/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var h1=["require","exports","vs/base/common/errors","vs/base/common/platform","vs/base/common/charCode","vs/base/common/functional","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/strings","vs/nls.messages","vs/base/common/path","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/arrays","vs/base/common/iterator","vs/base/common/lazy","vs/base/common/linkedList","vs/base/common/map","vs/base/common/marshallingIds","vs/base/common/stopwatch","vs/base/common/cancellation","vs/base/common/cache","vs/base/common/uint","vs/nls","vs/base/common/process","vs/base/common/uri","vs/base/common/network","vs/base/common/worker/simpleWorker"],d1=function(e1){for(var t=[],m=0,e=e1.length;m<e;m++)t[m]=h1[e1[m]];return t};define(h1[11],d1([0,1]),function(e1,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.MonotonousArray=void 0,t.findLast=m,t.findLastIdx=e,t.findLastMonotonous=W,t.findLastIdxMonotonous=U,t.findFirstMonotonous=t1,t.findFirstIdxMonotonousOrArrLen=$,t.findFirstIdxMonotonous=S,t.findFirstMax=N,t.findLastMax=j,t.findFirstMin=y,t.findMaxIdx=Y,t.mapFindFirst=p;function m(v,w){const F=e(v,w);if(F!==-1)return v[F]}function e(v,w,F=v.length-1){for(let q=F;q>=0;q--){const H=v[q];if(w(H))return q}return-1}function W(v,w){const F=U(v,w);return F===-1?void 0:v[F]}function U(v,w,F=0,q=v.length){let H=F,C=q;for(;H<C;){const G=Math.floor((H+C)/2);w(v[G])?H=G+1:C=G}return H-1}function t1(v,w){const F=$(v,w);return F===v.length?void 0:v[F]}function $(v,w,F=0,q=v.length){let H=F,C=q;for(;H<C;){const G=Math.floor((H+C)/2);w(v[G])?C=G:H=G+1}return H}function S(v,w,F=0,q=v.length){const H=$(v,w,F,q);return H===v.length?-1:H}class I{static{this.assertInvariants=!1}constructor(w){this._array=w,this._findLastMonotonousLastIdx=0}findLastMonotonous(w){if(I.assertInvariants){if(this._prevFindLastPredicate){for(const q of this._array)if(this._prevFindLastPredicate(q)&&!w(q))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this._prevFindLastPredicate=w}const F=U(this._array,w,this._findLastMonotonousLastIdx);return this._findLastMonotonousLastIdx=F+1,F===-1?void 0:this._array[F]}}t.MonotonousArray=I;function N(v,w){if(v.length===0)return;let F=v[0];for(let q=1;q<v.length;q++){const H=v[q];w(H,F)>0&&(F=H)}return F}function j(v,w){if(v.length===0)return;let F=v[0];for(let q=1;q<v.length;q++){const H=v[q];w(H,F)>=0&&(F=H)}return F}function y(v,w){return N(v,(F,q)=>-w(F,q))}function Y(v,w){if(v.length===0)return-1;let F=0;for(let q=1;q<v.length;q++){const H=v[q];w(H,v[F])>0&&(F=q)}return F}function p(v,w){for(const F of v){const q=w(F);if(q!==void 0)return q}}}),define(h1[4],d1([0,1]),function(e1,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CharCode=void 0;var m;(function(e){e[e.Null=0]="Null",e[e.Backspace=8]="Backspace",e[e.Tab=9]="Tab",e[e.LineFeed=10]="LineFeed",e[e.CarriageReturn=13]="CarriageReturn",e[e.Space=32]="Space",e[e.ExclamationMark=33]="ExclamationMark",e[e.DoubleQuote=34]="DoubleQuote",e[e.Hash=35]="Hash",e[e.DollarSign=36]="DollarSign",e[e.PercentSign=37]="PercentSign",e[e.Ampersand=38]="Ampersand",e[e.SingleQuote=39]="SingleQuote",e[e.OpenParen=40]="OpenParen",e[e.CloseParen=41]="CloseParen",e[e.Asterisk=42]="Asterisk",e[e.Plus=43]="Plus",e[e.Comma=44]="Comma",e[e.Dash=45]="Dash",e[e.Period=46]="Period",e[e.Slash=47]="Slash",e[e.Digit0=48]="Digit0",e[e.Digit1=49]="Digit1",e[e.Digit2=50]="Digit2",e[e.Digit3=51]="Digit3",e[e.Digit4=52]="Digit4",e[e.Digit5=53]="Digit5",e[e.Digit6=54]="Digit6",e[e.Digit7=55]="Digit7",e[e.Digit8=56]="Digit8",e[e.Digit9=57]="Digit9",e[e.Colon=58]="Colon",e[e.Semicolon=59]="Semicolon",e[e.LessThan=60]="LessThan",e[e.Equals=61]="Equals",e[e.GreaterThan=62]="GreaterThan",e[e.QuestionMark=63]="QuestionMark",e[e.AtSign=64]="AtSign",e[e.A=65]="A",e[e.B=66]="B",e[e.C=67]="C",e[e.D=68]="D",e[e.E=69]="E",e[e.F=70]="F",e[e.G=71]="G",e[e.H=72]="H",e[e.I=73]="I",e[e.J=74]="J",e[e.K=75]="K",e[e.L=76]="L",e[e.M=77]="M",e[e.N=78]="N",e[e.O=79]="O",e[e.P=80]="P",e[e.Q=81]="Q",e[e.R=82]="R",e[e.S=83]="S",e[e.T=84]="T",e[e.U=85]="U",e[e.V=86]="V",e[e.W=87]="W",e[e.X=88]="X",e[e.Y=89]="Y",e[e.Z=90]="Z",e[e.OpenSquareBracket=91]="OpenSquareBracket",e[e.Backslash=92]="Backslash",e[e.CloseSquareBracket=93]="CloseSquareBracket",e[e.Caret=94]="Caret",e[e.Underline=95]="Underline",e[e.BackTick=96]="BackTick",e[e.a=97]="a",e[e.b=98]="b",e[e.c=99]="c",e[e.d=100]="d",e[e.e=101]="e",e[e.f=102]="f",e[e.g=103]="g",e[e.h=104]="h",e[e.i=105]="i",e[e.j=106]="j",e[e.k=107]="k",e[e.l=108]="l",e[e.m=109]="m",e[e.n=110]="n",e[e.o=111]="o",e[e.p=112]="p",e[e.q=113]="q",e[e.r=114]="r",e[e.s=115]="s",e[e.t=116]="t",e[e.u=117]="u",e[e.v=118]="v",e[e.w=119]="w",e[e.x=120]="x",e[e.y=121]="y",e[e.z=122]="z",e[e.OpenCurlyBrace=123]="OpenCurlyBrace",e[e.Pipe=124]="Pipe",e[e.CloseCurlyBrace=125]="CloseCurlyBrace",e[e.Tilde=126]="Tilde",e[e.NoBreakSpace=160]="NoBreakSpace",e[e.U_Combining_Grave_Accent=768]="U_Combining_Grave_Accent",e[e.U_Combining_Acute_Accent=769]="U_Combining_Acute_Accent",e[e.U_Combining_Circumflex_Accent=770]="U_Combining_Circumflex_Accent",e[e.U_Combining_Tilde=771]="U_Combining_Tilde",e[e.U_Combining_Macron=772]="U_Combining_Macron",e[e.U_Combining_Overline=773]="U_Combining_Overline",e[e.U_Combining_Breve=774]="U_Combining_Breve",e[e.U_Combining_Dot_Above=775]="U_Combining_Dot_Above",e[e.U_Combining_Diaeresis=776]="U_Combining_Diaeresis",e[e.U_Combining_Hook_Above=777]="U_Combining_Hook_Above",e[e.U_Combining_Ring_Above=778]="U_Combining_Ring_Above",e[e.U_Combining_Double_Acute_Accent=779]="U_Combining_Double_Acute_Accent",e[e.U_Combining_Caron=780]="U_Combining_Caron",e[e.U_Combining_Vertical_Line_Above=781]="U_Combining_Vertical_Line_Above",e[e.U_Combining_Double_Vertical_Line_Above=782]="U_Combining_Double_Vertical_Line_Above",e[e.U_Combining_Double_Grave_Accent=783]="U_Combining_Double_Grave_Accent",e[e.U_Combining_Candrabindu=784]="U_Combining_Candrabindu",e[e.U_Combining_Inverted_Breve=785]="U_Combining_Inverted_Breve",e[e.U_Combining_Turned_Comma_Above=786]="U_Combining_Turned_Comma_Above",e[e.U_Combining_Comma_Above=787]="U_Combining_Comma_Above",e[e.U_Combining_Reversed_Comma_Above=788]="U_Combining_Reversed_Comma_Above",e[e.U_Combining_Comma_Above_Right=789]="U_Combining_Comma_Above_Right",e[e.U_Combining_Grave_Accent_Below=790]="U_Combining_Grave_Accent_Below",e[e.U_Combining_Acute_Accent_Below=791]="U_Combining_Acute_Accent_Below",e[e.U_Combining_Left_Tack_Below=792]="U_Combining_Left_Tack_Below",e[e.U_Combining_Right_Tack_Below=793]="U_Combining_Right_Tack_Below",e[e.U_Combining_Left_Angle_Above=794]="U_Combining_Left_Angle_Above",e[e.U_Combining_Horn=795]="U_Combining_Horn",e[e.U_Combining_Left_Half_Ring_Below=796]="U_Combining_Left_Half_Ring_Below",e[e.U_Combining_Up_Tack_Below=797]="U_Combining_Up_Tack_Below",e[e.U_Combining_Down_Tack_Below=798]="U_Combining_Down_Tack_Below",e[e.U_Combining_Plus_Sign_Below=799]="U_Combining_Plus_Sign_Below",e[e.U_Combining_Minus_Sign_Below=800]="U_Combining_Minus_Sign_Below",e[e.U_Combining_Palatalized_Hook_Below=801]="U_Combining_Palatalized_Hook_Below",e[e.U_Combining_Retroflex_Hook_Below=802]="U_Combining_Retroflex_Hook_Below",e[e.U_Combining_Dot_Below=803]="U_Combining_Dot_Below",e[e.U_Combining_Diaeresis_Below=804]="U_Combining_Diaeresis_Below",e[e.U_Combining_Ring_Below=805]="U_Combining_Ring_Below",e[e.U_Combining_Comma_Below=806]="U_Combining_Comma_Below",e[e.U_Combining_Cedilla=807]="U_Combining_Cedilla",e[e.U_Combining_Ogonek=808]="U_Combining_Ogonek",e[e.U_Combining_Vertical_Line_Below=809]="U_Combining_Vertical_Line_Below",e[e.U_Combining_Bridge_Below=810]="U_Combining_Bridge_Below",e[e.U_Combining_Inverted_Double_Arch_Below=811]="U_Combining_Inverted_Double_Arch_Below",e[e.U_Combining_Caron_Below=812]="U_Combining_Caron_Below",e[e.U_Combining_Circumflex_Accent_Below=813]="U_Combining_Circumflex_Accent_Below",e[e.U_Combining_Breve_Below=814]="U_Combining_Breve_Below",e[e.U_Combining_Inverted_Breve_Below=815]="U_Combining_Inverted_Breve_Below",e[e.U_Combining_Tilde_Below=816]="U_Combining_Tilde_Below",e[e.U_Combining_Macron_Below=817]="U_Combining_Macron_Below",e[e.U_Combining_Low_Line=818]="U_Combining_Low_Line",e[e.U_Combining_Double_Low_Line=819]="U_Combining_Double_Low_Line",e[e.U_Combining_Tilde_Overlay=820]="U_Combining_Tilde_Overlay",e[e.U_Combining_Short_Stroke_Overlay=821]="U_Combining_Short_Stroke_Overlay",e[e.U_Combining_Long_Stroke_Overlay=822]="U_Combining_Long_Stroke_Overlay",e[e.U_Combining_Short_Solidus_Overlay=823]="U_Combining_Short_Solidus_Overlay",e[e.U_Combining_Long_Solidus_Overlay=824]="U_Combining_Long_Solidus_Overlay",e[e.U_Combining_Right_Half_Ring_Below=825]="U_Combining_Right_Half_Ring_Below",e[e.U_Combining_Inverted_Bridge_Below=826]="U_Combining_Inverted_Bridge_Below",e[e.U_Combining_Square_Below=827]="U_Combining_Square_Below",e[e.U_Combining_Seagull_Below=828]="U_Combining_Seagull_Below",e[e.U_Combining_X_Above=829]="U_Combining_X_Above",e[e.U_Combining_Vertical_Tilde=830]="U_Combining_Vertical_Tilde",e[e.U_Combining_Double_Overline=831]="U_Combining_Double_Overline",e[e.U_Combining_Grave_Tone_Mark=832]="U_Combining_Grave_Tone_Mark",e[e.U_Combining_Acute_Tone_Mark=833]="U_Combining_Acute_Tone_Mark",e[e.U_Combining_Greek_Perispomeni=834]="U_Combining_Greek_Perispomeni",e[e.U_Combining_Greek_Koronis=835]="U_Combining_Greek_Koronis",e[e.U_Combining_Greek_Dialytika_Tonos=836]="U_Combining_Greek_Dialytika_Tonos",e[e.U_Combining_Greek_Ypogegrammeni=837]="U_Combining_Greek_Ypogegrammeni",e[e.U_Combining_Bridge_Above=838]="U_Combining_Bridge_Above",e[e.U_Combining_Equals_Sign_Below=839]="U_Combining_Equals_Sign_Below",e[e.U_Combining_Double_Vertical_Line_Below=840]="U_Combining_Double_Vertical_Line_Below",e[e.U_Combining_Left_Angle_Below=841]="U_Combining_Left_Angle_Below",e[e.U_Combining_Not_Tilde_Above=842]="U_Combining_Not_Tilde_Above",e[e.U_Combining_Homothetic_Above=843]="U_Combining_Homothetic_Above",e[e.U_Combining_Almost_Equal_To_Above=844]="U_Combining_Almost_Equal_To_Above",e[e.U_Combining_Left_Right_Arrow_Below=845]="U_Combining_Left_Right_Arrow_Below",e[e.U_Combining_Upwards_Arrow_Below=846]="U_Combining_Upwards_Arrow_Below",e[e.U_Combining_Grapheme_Joiner=847]="U_Combining_Grapheme_Joiner",e[e.U_Combining_Right_Arrowhead_Above=848]="U_Combining_Right_Arrowhead_Above",e[e.U_Combining_Left_Half_Ring_Above=849]="U_Combining_Left_Half_Ring_Above",e[e.U_Combining_Fermata=850]="U_Combining_Fermata",e[e.U_Combining_X_Below=851]="U_Combining_X_Below",e[e.U_Combining_Left_Arrowhead_Below=852]="U_Combining_Left_Arrowhead_Below",e[e.U_Combining_Right_Arrowhead_Below=853]="U_Combining_Right_Arrowhead_Below",e[e.U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below=854]="U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below",e[e.U_Combining_Right_Half_Ring_Above=855]="U_Combining_Right_Half_Ring_Above",e[e.U_Combining_Dot_Above_Right=856]="U_Combining_Dot_Above_Right",e[e.U_Combining_Asterisk_Below=857]="U_Combining_Asterisk_Below",e[e.U_Combining_Double_Ring_Below=858]="U_Combining_Double_Ring_Below",e[e.U_Combining_Zigzag_Above=859]="U_Combining_Zigzag_Above",e[e.U_Combining_Double_Breve_Below=860]="U_Combining_Double_Breve_Below",e[e.U_Combining_Double_Breve=861]="U_Combining_Double_Breve",e[e.U_Combining_Double_Macron=862]="U_Combining_Double_Macron",e[e.U_Combining_Double_Macron_Below=863]="U_Combining_Double_Macron_Below",e[e.U_Combining_Double_Tilde=864]="U_Combining_Double_Tilde",e[e.U_Combining_Double_Inverted_Breve=865]="U_Combining_Double_Inverted_Breve",e[e.U_Combining_Double_Rightwards_Arrow_Below=866]="U_Combining_Double_Rightwards_Arrow_Below",e[e.U_Combining_Latin_Small_Letter_A=867]="U_Combining_Latin_Small_Letter_A",e[e.U_Combining_Latin_Small_Letter_E=868]="U_Combining_Latin_Small_Letter_E",e[e.U_Combining_Latin_Small_Letter_I=869]="U_Combining_Latin_Small_Letter_I",e[e.U_Combining_Latin_Small_Letter_O=870]="U_Combining_Latin_Small_Letter_O",e[e.U_Combining_Latin_Small_Letter_U=871]="U_Combining_Latin_Small_Letter_U",e[e.U_Combining_Latin_Small_Letter_C=872]="U_Combining_Latin_Small_Letter_C",e[e.U_Combining_Latin_Small_Letter_D=873]="U_Combining_Latin_Small_Letter_D",e[e.U_Combining_Latin_Small_Letter_H=874]="U_Combining_Latin_Small_Letter_H",e[e.U_Combining_Latin_Small_Letter_M=875]="U_Combining_Latin_Small_Letter_M",e[e.U_Combining_Latin_Small_Letter_R=876]="U_Combining_Latin_Small_Letter_R",e[e.U_Combining_Latin_Small_Letter_T=877]="U_Combining_Latin_Small_Letter_T",e[e.U_Combining_Latin_Small_Letter_V=878]="U_Combining_Latin_Small_Letter_V",e[e.U_Combining_Latin_Small_Letter_X=879]="U_Combining_Latin_Small_Letter_X",e[e.LINE_SEPARATOR=8232]="LINE_SEPARATOR",e[e.PARAGRAPH_SEPARATOR=8233]="PARAGRAPH_SEPARATOR",e[e.NEXT_LINE=133]="NEXT_LINE",e[e.U_CIRCUMFLEX=94]="U_CIRCUMFLEX",e[e.U_GRAVE_ACCENT=96]="U_GRAVE_ACCENT",e[e.U_DIAERESIS=168]="U_DIAERESIS",e[e.U_MACRON=175]="U_MACRON",e[e.U_ACUTE_ACCENT=180]="U_ACUTE_ACCENT",e[e.U_CEDILLA=184]="U_CEDILLA",e[e.U_MODIFIER_LETTER_LEFT_ARROWHEAD=706]="U_MODIFIER_LETTER_LEFT_ARROWHEAD",e[e.U_MODIFIER_LETTER_RIGHT_ARROWHEAD=707]="U_MODIFIER_LETTER_RIGHT_ARROWHEAD",e[e.U_MODIFIER_LETTER_UP_ARROWHEAD=708]="U_MODIFIER_LETTER_UP_ARROWHEAD",e[e.U_MODIFIER_LETTER_DOWN_ARROWHEAD=709]="U_MODIFIER_LETTER_DOWN_ARROWHEAD",e[e.U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING=722]="U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING",e[e.U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING=723]="U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING",e[e.U_MODIFIER_LETTER_UP_TACK=724]="U_MODIFIER_LETTER_UP_TACK",e[e.U_MODIFIER_LETTER_DOWN_TACK=725]="U_MODIFIER_LETTER_DOWN_TACK",e[e.U_MODIFIER_LETTER_PLUS_SIGN=726]="U_MODIFIER_LETTER_PLUS_SIGN",e[e.U_MODIFIER_LETTER_MINUS_SIGN=727]="U_MODIFIER_LETTER_MINUS_SIGN",e[e.U_BREVE=728]="U_BREVE",e[e.U_DOT_ABOVE=729]="U_DOT_ABOVE",e[e.U_RING_ABOVE=730]="U_RING_ABOVE",e[e.U_OGONEK=731]="U_OGONEK",e[e.U_SMALL_TILDE=732]="U_SMALL_TILDE",e[e.U_DOUBLE_ACUTE_ACCENT=733]="U_DOUBLE_ACUTE_ACCENT",e[e.U_MODIFIER_LETTER_RHOTIC_HOOK=734]="U_MODIFIER_LETTER_RHOTIC_HOOK",e[e.U_MODIFIER_LETTER_CROSS_ACCENT=735]="U_MODIFIER_LETTER_CROSS_ACCENT",e[e.U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR=741]="U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR",e[e.U_MODIFIER_LETTER_HIGH_TONE_BAR=742]="U_MODIFIER_LETTER_HIGH_TONE_BAR",e[e.U_MODIFIER_LETTER_MID_TONE_BAR=743]="U_MODIFIER_LETTER_MID_TONE_BAR",e[e.U_MODIFIER_LETTER_LOW_TONE_BAR=744]="U_MODIFIER_LETTER_LOW_TONE_BAR",e[e.U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR=745]="U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR",e[e.U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK=746]="U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK",e[e.U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK=747]="U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK",e[e.U_MODIFIER_LETTER_UNASPIRATED=749]="U_MODIFIER_LETTER_UNASPIRATED",e[e.U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD=751]="U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD",e[e.U_MODIFIER_LETTER_LOW_UP_ARROWHEAD=752]="U_MODIFIER_LETTER_LOW_UP_ARROWHEAD",e[e.U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD=753]="U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD",e[e.U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD=754]="U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD",e[e.U_MODIFIER_LETTER_LOW_RING=755]="U_MODIFIER_LETTER_LOW_RING",e[e.U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT=756]="U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT",e[e.U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT=757]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT",e[e.U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT=758]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT",e[e.U_MODIFIER_LETTER_LOW_TILDE=759]="U_MODIFIER_LETTER_LOW_TILDE",e[e.U_MODIFIER_LETTER_RAISED_COLON=760]="U_MODIFIER_LETTER_RAISED_COLON",e[e.U_MODIFIER_LETTER_BEGIN_HIGH_TONE=761]="U_MODIFIER_LETTER_BEGIN_HIGH_TONE",e[e.U_MODIFIER_LETTER_END_HIGH_TONE=762]="U_MODIFIER_LETTER_END_HIGH_TONE",e[e.U_MODIFIER_LETTER_BEGIN_LOW_TONE=763]="U_MODIFIER_LETTER_BEGIN_LOW_TONE",e[e.U_MODIFIER_LETTER_END_LOW_TONE=764]="U_MODIFIER_LETTER_END_LOW_TONE",e[e.U_MODIFIER_LETTER_SHELF=765]="U_MODIFIER_LETTER_SHELF",e[e.U_MODIFIER_LETTER_OPEN_SHELF=766]="U_MODIFIER_LETTER_OPEN_SHELF",e[e.U_MODIFIER_LETTER_LOW_LEFT_ARROW=767]="U_MODIFIER_LETTER_LOW_LEFT_ARROW",e[e.U_GREEK_LOWER_NUMERAL_SIGN=885]="U_GREEK_LOWER_NUMERAL_SIGN",e[e.U_GREEK_TONOS=900]="U_GREEK_TONOS",e[e.U_GREEK_DIALYTIKA_TONOS=901]="U_GREEK_DIALYTIKA_TONOS",e[e.U_GREEK_KORONIS=8125]="U_GREEK_KORONIS",e[e.U_GREEK_PSILI=8127]="U_GREEK_PSILI",e[e.U_GREEK_PERISPOMENI=8128]="U_GREEK_PERISPOMENI",e[e.U_GREEK_DIALYTIKA_AND_PERISPOMENI=8129]="U_GREEK_DIALYTIKA_AND_PERISPOMENI",e[e.U_GREEK_PSILI_AND_VARIA=8141]="U_GREEK_PSILI_AND_VARIA",e[e.U_GREEK_PSILI_AND_OXIA=8142]="U_GREEK_PSILI_AND_OXIA",e[e.U_GREEK_PSILI_AND_PERISPOMENI=8143]="U_GREEK_PSILI_AND_PERISPOMENI",e[e.U_GREEK_DASIA_AND_VARIA=8157]="U_GREEK_DASIA_AND_VARIA",e[e.U_GREEK_DASIA_AND_OXIA=8158]="U_GREEK_DASIA_AND_OXIA",e[e.U_GREEK_DASIA_AND_PERISPOMENI=8159]="U_GREEK_DASIA_AND_PERISPOMENI",e[e.U_GREEK_DIALYTIKA_AND_VARIA=8173]="U_GREEK_DIALYTIKA_AND_VARIA",e[e.U_GREEK_DIALYTIKA_AND_OXIA=8174]="U_GREEK_DIALYTIKA_AND_OXIA",e[e.U_GREEK_VARIA=8175]="U_GREEK_VARIA",e[e.U_GREEK_OXIA=8189]="U_GREEK_OXIA",e[e.U_GREEK_DASIA=8190]="U_GREEK_DASIA",e[e.U_IDEOGRAPHIC_FULL_STOP=12290]="U_IDEOGRAPHIC_FULL_STOP",e[e.U_LEFT_CORNER_BRACKET=12300]="U_LEFT_CORNER_BRACKET",e[e.U_RIGHT_CORNER_BRACKET=12301]="U_RIGHT_CORNER_BRACKET",e[e.U_LEFT_BLACK_LENTICULAR_BRACKET=12304]="U_LEFT_BLACK_LENTICULAR_BRACKET",e[e.U_RIGHT_BLACK_LENTICULAR_BRACKET=12305]="U_RIGHT_BLACK_LENTICULAR_BRACKET",e[e.U_OVERLINE=8254]="U_OVERLINE",e[e.UTF8_BOM=65279]="UTF8_BOM",e[e.U_FULLWIDTH_SEMICOLON=65307]="U_FULLWIDTH_SEMICOLON",e[e.U_FULLWIDTH_COMMA=65292]="U_FULLWIDTH_COMMA"})(m||(t.CharCode=m={}))}),define(h1[12],d1([0,1]),function(e1,t){"use strict";var m;Object.defineProperty(t,"__esModule",{value:!0}),t.SetWithKey=void 0,t.groupBy=e,t.diffSets=W,t.diffMaps=U,t.intersection=t1;function e(S,I){const N=Object.create(null);for(const j of S){const y=I(j);let Y=N[y];Y||(Y=N[y]=[]),Y.push(j)}return N}function W(S,I){const N=[],j=[];for(const y of S)I.has(y)||N.push(y);for(const y of I)S.has(y)||j.push(y);return{removed:N,added:j}}function U(S,I){const N=[],j=[];for(const[y,Y]of S)I.has(y)||N.push(Y);for(const[y,Y]of I)S.has(y)||j.push(Y);return{removed:N,added:j}}function t1(S,I){const N=new Set;for(const j of I)S.has(j)&&N.add(j);return N}class ${static{m=Symbol.toStringTag}constructor(I,N){this.toKey=N,this._map=new Map,this[m]="SetWithKey";for(const j of I)this.add(j)}get size(){return this._map.size}add(I){const N=this.toKey(I);return this._map.set(N,I),this}delete(I){return this._map.delete(this.toKey(I))}has(I){return this._map.has(this.toKey(I))}*entries(){for(const I of this._map.values())yield[I,I]}keys(){return this.values()}*values(){for(const I of this._map.values())yield I}clear(){this._map.clear()}forEach(I,N){this._map.forEach(j=>I.call(N,j,j,this))}[Symbol.iterator](){return this.values()}}t.SetWithKey=$}),define(h1[2],d1([0,1]),function(e1,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.BugIndicatingError=t.ErrorNoTelemetry=t.ExpectedError=t.NotSupportedError=t.NotImplementedError=t.ReadonlyError=t.CancellationError=t.errorHandler=t.ErrorHandler=void 0,t.setUnexpectedErrorHandler=e,t.isSigPipeError=W,t.onUnexpectedError=U,t.onUnexpectedExternalError=t1,t.transformErrorForSerialization=$,t.transformErrorFromSerialization=S,t.isCancellationError=N,t.canceled=y,t.illegalArgument=Y,t.illegalState=p,t.getErrorMessage=w;class m{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(n){setTimeout(()=>{throw n.stack?C.isErrorNoTelemetry(n)?new C(n.message+`

`+n.stack):new Error(n.message+`

`+n.stack):n},0)}}addListener(n){return this.listeners.push(n),()=>{this._removeListener(n)}}emit(n){this.listeners.forEach(i=>{i(n)})}_removeListener(n){this.listeners.splice(this.listeners.indexOf(n),1)}setUnexpectedErrorHandler(n){this.unexpectedErrorHandler=n}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(n){this.unexpectedErrorHandler(n),this.emit(n)}onUnexpectedExternalError(n){this.unexpectedErrorHandler(n)}}t.ErrorHandler=m,t.errorHandler=new m;function e(o){t.errorHandler.setUnexpectedErrorHandler(o)}function W(o){if(!o||typeof o!="object")return!1;const n=o;return n.code==="EPIPE"&&n.syscall?.toUpperCase()==="WRITE"}function U(o){N(o)||t.errorHandler.onUnexpectedError(o)}function t1(o){N(o)||t.errorHandler.onUnexpectedExternalError(o)}function $(o){if(o instanceof Error){const{name:n,message:i}=o,a=o.stacktrace||o.stack;return{$isError:!0,name:n,message:i,stack:a,noTelemetry:C.isErrorNoTelemetry(o)}}return o}function S(o){let n;return o.noTelemetry?n=new C:(n=new Error,n.name=o.name),n.message=o.message,n.stack=o.stack,n}const I="Canceled";function N(o){return o instanceof j?!0:o instanceof Error&&o.name===I&&o.message===I}class j extends Error{constructor(){super(I),this.name=this.message}}t.CancellationError=j;function y(){const o=new Error(I);return o.name=o.message,o}function Y(o){return o?new Error(`Illegal argument: ${o}`):new Error("Illegal argument")}function p(o){return o?new Error(`Illegal state: ${o}`):new Error("Illegal state")}class v extends TypeError{constructor(n){super(n?`${n} is read-only and cannot be changed`:"Cannot change read-only property")}}t.ReadonlyError=v;function w(o){return o?o.message?o.message:o.stack?o.stack.split(`
`)[0]:String(o):"Error"}class F extends Error{constructor(n){super("NotImplemented"),n&&(this.message=n)}}t.NotImplementedError=F;class q extends Error{constructor(n){super("NotSupported"),n&&(this.message=n)}}t.NotSupportedError=q;class H extends Error{constructor(){super(...arguments),this.isExpected=!0}}t.ExpectedError=H;class C extends Error{constructor(n){super(n),this.name="CodeExpectedError"}static fromError(n){if(n instanceof C)return n;const i=new C;return i.message=n.message,i.stack=n.stack,i}static isErrorNoTelemetry(n){return n.name==="CodeExpectedError"}}t.ErrorNoTelemetry=C;class G extends Error{constructor(n){super(n||"An unexpected bug occurred."),Object.setPrototypeOf(this,G.prototype)}}t.BugIndicatingError=G}),define(h1[13],d1([0,1,2,11]),function(e1,t,m,e){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Permutation=t.CallbackIterable=t.ArrayQueue=t.booleanComparator=t.numberComparator=t.CompareResult=void 0,t.tail=W,t.tail2=U,t.equals=t1,t.removeFastWithoutKeepingOrder=$,t.binarySearch=S,t.binarySearch2=I,t.quickSelect=N,t.groupBy=j,t.groupAdjacentBy=y,t.forEachAdjacent=Y,t.forEachWithNeighbors=p,t.sortedDiff=v,t.delta=w,t.top=F,t.topAsync=q,t.coalesce=C,t.coalesceInPlace=G,t.move=o,t.isFalsyOrEmpty=n,t.isNonEmptyArray=i,t.distinct=a,t.uniqueFilter=g,t.firstOrDefault=s,t.lastOrDefault=r,t.commonPrefixLength=f,t.range=u,t.index=h,t.insert=E,t.remove=c,t.arrayInsert=D,t.shuffle=P,t.pushToStart=M,t.pushToEnd=R,t.pushMany=K,t.mapArrayOrNot=i1,t.asArray=x,t.getRandomElement=s1,t.insertInto=u1,t.splice=J,t.compareBy=p1,t.tieBreakComparators=R1,t.reverseOrder=G1,t.findAsync=j1;function W(d,A=0){return d[d.length-(1+A)]}function U(d){if(d.length===0)throw new Error("Invalid tail call");return[d.slice(0,d.length-1),d[d.length-1]]}function t1(d,A,b=(T,k)=>T===k){if(d===A)return!0;if(!d||!A||d.length!==A.length)return!1;for(let T=0,k=d.length;T<k;T++)if(!b(d[T],A[T]))return!1;return!0}function $(d,A){const b=d.length-1;A<b&&(d[A]=d[b]),d.pop()}function S(d,A,b){return I(d.length,T=>b(d[T],A))}function I(d,A){let b=0,T=d-1;for(;b<=T;){const k=(b+T)/2|0,n1=A(k);if(n1<0)b=k+1;else if(n1>0)T=k-1;else return k}return-(b+1)}function N(d,A,b){if(d=d|0,d>=A.length)throw new TypeError("invalid index");const T=A[Math.floor(A.length*Math.random())],k=[],n1=[],a1=[];for(const m1 of A){const E1=b(m1,T);E1<0?k.push(m1):E1>0?n1.push(m1):a1.push(m1)}return d<k.length?N(d,k,b):d<k.length+a1.length?a1[0]:N(d-(k.length+a1.length),n1,b)}function j(d,A){const b=[];let T;for(const k of d.slice(0).sort(A))!T||A(T[0],k)!==0?(T=[k],b.push(T)):T.push(k);return b}function*y(d,A){let b,T;for(const k of d)T!==void 0&&A(T,k)?b.push(k):(b&&(yield b),b=[k]),T=k;b&&(yield b)}function Y(d,A){for(let b=0;b<=d.length;b++)A(b===0?void 0:d[b-1],b===d.length?void 0:d[b])}function p(d,A){for(let b=0;b<d.length;b++)A(b===0?void 0:d[b-1],d[b],b+1===d.length?void 0:d[b+1])}function v(d,A,b){const T=[];function k(m1,E1,v1){if(E1===0&&v1.length===0)return;const U1=T[T.length-1];U1&&U1.start+U1.deleteCount===m1?(U1.deleteCount+=E1,U1.toInsert.push(...v1)):T.push({start:m1,deleteCount:E1,toInsert:v1})}let n1=0,a1=0;for(;;){if(n1===d.length){k(n1,0,A.slice(a1));break}if(a1===A.length){k(n1,d.length-n1,[]);break}const m1=d[n1],E1=A[a1],v1=b(m1,E1);v1===0?(n1+=1,a1+=1):v1<0?(k(n1,1,[]),n1+=1):v1>0&&(k(n1,0,[E1]),a1+=1)}return T}function w(d,A,b){const T=v(d,A,b),k=[],n1=[];for(const a1 of T)k.push(...d.slice(a1.start,a1.start+a1.deleteCount)),n1.push(...a1.toInsert);return{removed:k,added:n1}}function F(d,A,b){if(b===0)return[];const T=d.slice(0,b).sort(A);return H(d,A,T,b,d.length),T}function q(d,A,b,T,k){return b===0?Promise.resolve([]):new Promise((n1,a1)=>{(async()=>{const m1=d.length,E1=d.slice(0,b).sort(A);for(let v1=b,U1=Math.min(b+T,m1);v1<m1;v1=U1,U1=Math.min(U1+T,m1)){if(v1>b&&await new Promise(V=>setTimeout(V)),k&&k.isCancellationRequested)throw new m.CancellationError;H(d,A,E1,v1,U1)}return E1})().then(n1,a1)})}function H(d,A,b,T,k){for(const n1=b.length;T<k;T++){const a1=d[T];if(A(a1,b[n1-1])<0){b.pop();const m1=(0,e.findFirstIdxMonotonousOrArrLen)(b,E1=>A(a1,E1)<0);b.splice(m1,0,a1)}}}function C(d){return d.filter(A=>!!A)}function G(d){let A=0;for(let b=0;b<d.length;b++)d[b]&&(d[A]=d[b],A+=1);d.length=A}function o(d,A,b){d.splice(b,0,d.splice(A,1)[0])}function n(d){return!Array.isArray(d)||d.length===0}function i(d){return Array.isArray(d)&&d.length>0}function a(d,A=b=>b){const b=new Set;return d.filter(T=>{const k=A(T);return b.has(k)?!1:(b.add(k),!0)})}function g(d){const A=new Set;return b=>{const T=d(b);return A.has(T)?!1:(A.add(T),!0)}}function s(d,A){return d.length>0?d[0]:A}function r(d,A){return d.length>0?d[d.length-1]:A}function f(d,A,b=(T,k)=>T===k){let T=0;for(let k=0,n1=Math.min(d.length,A.length);k<n1&&b(d[k],A[k]);k++)T++;return T}function u(d,A){let b=typeof A=="number"?d:0;typeof A=="number"?b=d:(b=0,A=d);const T=[];if(b<=A)for(let k=b;k<A;k++)T.push(k);else for(let k=b;k>A;k--)T.push(k);return T}function h(d,A,b){return d.reduce((T,k)=>(T[A(k)]=b?b(k):k,T),Object.create(null))}function E(d,A){return d.push(A),()=>c(d,A)}function c(d,A){const b=d.indexOf(A);if(b>-1)return d.splice(b,1),A}function D(d,A,b){const T=d.slice(0,A),k=d.slice(A);return T.concat(b,k)}function P(d,A){let b;if(typeof A=="number"){let T=A;b=()=>{const k=Math.sin(T++)*179426549;return k-Math.floor(k)}}else b=Math.random;for(let T=d.length-1;T>0;T-=1){const k=Math.floor(b()*(T+1)),n1=d[T];d[T]=d[k],d[k]=n1}}function M(d,A){const b=d.indexOf(A);b>-1&&(d.splice(b,1),d.unshift(A))}function R(d,A){const b=d.indexOf(A);b>-1&&(d.splice(b,1),d.push(A))}function K(d,A){for(const b of A)d.push(b)}function i1(d,A){return Array.isArray(d)?d.map(A):A(d)}function x(d){return Array.isArray(d)?d:[d]}function s1(d){return d[Math.floor(Math.random()*d.length)]}function u1(d,A,b){const T=o1(d,A),k=d.length,n1=b.length;d.length=k+n1;for(let a1=k-1;a1>=T;a1--)d[a1+n1]=d[a1];for(let a1=0;a1<n1;a1++)d[a1+T]=b[a1]}function J(d,A,b,T){const k=o1(d,A);let n1=d.splice(k,b);return n1===void 0&&(n1=[]),u1(d,k,T),n1}function o1(d,A){return A<0?Math.max(A+d.length,0):Math.min(A,d.length)}var _1;(function(d){function A(n1){return n1<0}d.isLessThan=A;function b(n1){return n1<=0}d.isLessThanOrEqual=b;function T(n1){return n1>0}d.isGreaterThan=T;function k(n1){return n1===0}d.isNeitherLessOrGreaterThan=k,d.greaterThan=1,d.lessThan=-1,d.neitherLessOrGreaterThan=0})(_1||(t.CompareResult=_1={}));function p1(d,A){return(b,T)=>A(d(b),d(T))}function R1(...d){return(A,b)=>{for(const T of d){const k=T(A,b);if(!_1.isNeitherLessOrGreaterThan(k))return k}return _1.neitherLessOrGreaterThan}}const I1=(d,A)=>d-A;t.numberComparator=I1;const y1=(d,A)=>(0,t.numberComparator)(d?1:0,A?1:0);t.booleanComparator=y1;function G1(d){return(A,b)=>-d(A,b)}class $1{constructor(A){this.items=A,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(A){let b=this.firstIdx;for(;b<this.items.length&&A(this.items[b]);)b++;const T=b===this.firstIdx?null:this.items.slice(this.firstIdx,b);return this.firstIdx=b,T}takeFromEndWhile(A){let b=this.lastIdx;for(;b>=0&&A(this.items[b]);)b--;const T=b===this.lastIdx?null:this.items.slice(b+1,this.lastIdx+1);return this.lastIdx=b,T}peek(){if(this.length!==0)return this.items[this.firstIdx]}peekLast(){if(this.length!==0)return this.items[this.lastIdx]}dequeue(){const A=this.items[this.firstIdx];return this.firstIdx++,A}removeLast(){const A=this.items[this.lastIdx];return this.lastIdx--,A}takeCount(A){const b=this.items.slice(this.firstIdx,this.firstIdx+A);return this.firstIdx+=A,b}}t.ArrayQueue=$1;class D1{static{this.empty=new D1(A=>{})}constructor(A){this.iterate=A}forEach(A){this.iterate(b=>(A(b),!0))}toArray(){const A=[];return this.iterate(b=>(A.push(b),!0)),A}filter(A){return new D1(b=>this.iterate(T=>A(T)?b(T):!0))}map(A){return new D1(b=>this.iterate(T=>b(A(T))))}some(A){let b=!1;return this.iterate(T=>(b=A(T),!b)),b}findFirst(A){let b;return this.iterate(T=>A(T)?(b=T,!1):!0),b}findLast(A){let b;return this.iterate(T=>(A(T)&&(b=T),!0)),b}findLastMaxBy(A){let b,T=!0;return this.iterate(k=>((T||_1.isGreaterThan(A(k,b)))&&(T=!1,b=k),!0)),b}}t.CallbackIterable=D1;class F1{constructor(A){this._indexMap=A}static createSortPermutation(A,b){const T=Array.from(A.keys()).sort((k,n1)=>b(A[k],A[n1]));return new F1(T)}apply(A){return A.map((b,T)=>A[this._indexMap[T]])}inverse(){const A=this._indexMap.slice();for(let b=0;b<this._indexMap.length;b++)A[this._indexMap[b]]=b;return new F1(A)}}t.Permutation=F1;async function j1(d,A){return(await Promise.all(d.map(async(T,k)=>({element:T,ok:await A(T,k)})))).find(T=>T.ok)?.element}}),define(h1[5],d1([0,1]),function(e1,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.createSingleCallFunction=m;function m(e,W){const U=this;let t1=!1,$;return function(){if(t1)return $;if(t1=!0,W)try{$=e.apply(U,arguments)}finally{W()}else $=e.apply(U,arguments);return $}}}),define(h1[14],d1([0,1]),function(e1,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Iterable=void 0;var m;(function(e){function W(n){return n&&typeof n=="object"&&typeof n[Symbol.iterator]=="function"}e.is=W;const U=Object.freeze([]);function t1(){return U}e.empty=t1;function*$(n){yield n}e.single=$;function S(n){return W(n)?n:$(n)}e.wrap=S;function I(n){return n||U}e.from=I;function*N(n){for(let i=n.length-1;i>=0;i--)yield n[i]}e.reverse=N;function j(n){return!n||n[Symbol.iterator]().next().done===!0}e.isEmpty=j;function y(n){return n[Symbol.iterator]().next().value}e.first=y;function Y(n,i){let a=0;for(const g of n)if(i(g,a++))return!0;return!1}e.some=Y;function p(n,i){for(const a of n)if(i(a))return a}e.find=p;function*v(n,i){for(const a of n)i(a)&&(yield a)}e.filter=v;function*w(n,i){let a=0;for(const g of n)yield i(g,a++)}e.map=w;function*F(n,i){let a=0;for(const g of n)yield*i(g,a++)}e.flatMap=F;function*q(...n){for(const i of n)yield*i}e.concat=q;function H(n,i,a){let g=a;for(const s of n)g=i(g,s);return g}e.reduce=H;function*C(n,i,a=n.length){for(i<0&&(i+=n.length),a<0?a+=n.length:a>n.length&&(a=n.length);i<a;i++)yield n[i]}e.slice=C;function G(n,i=Number.POSITIVE_INFINITY){const a=[];if(i===0)return[a,n];const g=n[Symbol.iterator]();for(let s=0;s<i;s++){const r=g.next();if(r.done)return[a,e.empty()];a.push(r.value)}return[a,{[Symbol.iterator](){return g}}]}e.consume=G;async function o(n){const i=[];for await(const a of n)i.push(a);return Promise.resolve(i)}e.asyncToArray=o})(m||(t.Iterable=m={}))}),define(h1[15],d1([0,1]),function(e1,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Lazy=void 0;class m{constructor(W){this.executor=W,this._didRun=!1}get hasValue(){return this._didRun}get value(){if(!this._didRun)try{this._value=this.executor()}catch(W){this._error=W}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}}t.Lazy=m}),define(h1[16],d1([0,1]),function(e1,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LinkedList=void 0;class m{static{this.Undefined=new m(void 0)}constructor(U){this.element=U,this.next=m.Undefined,this.prev=m.Undefined}}class e{constructor(){this._first=m.Undefined,this._last=m.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===m.Undefined}clear(){let U=this._first;for(;U!==m.Undefined;){const t1=U.next;U.prev=m.Undefined,U.next=m.Undefined,U=t1}this._first=m.Undefined,this._last=m.Undefined,this._size=0}unshift(U){return this._insert(U,!1)}push(U){return this._insert(U,!0)}_insert(U,t1){const $=new m(U);if(this._first===m.Undefined)this._first=$,this._last=$;else if(t1){const I=this._last;this._last=$,$.prev=I,I.next=$}else{const I=this._first;this._first=$,$.next=I,I.prev=$}this._size+=1;let S=!1;return()=>{S||(S=!0,this._remove($))}}shift(){if(this._first!==m.Undefined){const U=this._first.element;return this._remove(this._first),U}}pop(){if(this._last!==m.Undefined){const U=this._last.element;return this._remove(this._last),U}}_remove(U){if(U.prev!==m.Undefined&&U.next!==m.Undefined){const t1=U.prev;t1.next=U.next,U.next.prev=t1}else U.prev===m.Undefined&&U.next===m.Undefined?(this._first=m.Undefined,this._last=m.Undefined):U.next===m.Undefined?(this._last=this._last.prev,this._last.next=m.Undefined):U.prev===m.Undefined&&(this._first=this._first.next,this._first.prev=m.Undefined);this._size-=1}*[Symbol.iterator](){let U=this._first;for(;U!==m.Undefined;)yield U.element,U=U.next}}t.LinkedList=e}),define(h1[17],d1([0,1]),function(e1,t){"use strict";var m,e,W;Object.defineProperty(t,"__esModule",{value:!0}),t.SetMap=t.BidirectionalMap=t.CounterSet=t.MRUCache=t.LRUCache=t.LinkedMap=t.Touch=t.ResourceSet=t.ResourceMap=void 0,t.getOrSet=U,t.mapToString=t1,t.setToString=$,t.mapsStrictEqualIgnoreOrder=C;function U(G,o,n){let i=G.get(o);return i===void 0&&(i=n,G.set(o,i)),i}function t1(G){const o=[];return G.forEach((n,i)=>{o.push(`${i} => ${n}`)}),`Map(${G.size}) {${o.join(", ")}}`}function $(G){const o=[];return G.forEach(n=>{o.push(n)}),`Set(${G.size}) {${o.join(", ")}}`}class S{constructor(o,n){this.uri=o,this.value=n}}function I(G){return Array.isArray(G)}class N{static{this.defaultToKey=o=>o.toString()}constructor(o,n){if(this[m]="ResourceMap",o instanceof N)this.map=new Map(o.map),this.toKey=n??N.defaultToKey;else if(I(o)){this.map=new Map,this.toKey=n??N.defaultToKey;for(const[i,a]of o)this.set(i,a)}else this.map=new Map,this.toKey=o??N.defaultToKey}set(o,n){return this.map.set(this.toKey(o),new S(o,n)),this}get(o){return this.map.get(this.toKey(o))?.value}has(o){return this.map.has(this.toKey(o))}get size(){return this.map.size}clear(){this.map.clear()}delete(o){return this.map.delete(this.toKey(o))}forEach(o,n){typeof n<"u"&&(o=o.bind(n));for(const[i,a]of this.map)o(a.value,a.uri,this)}*values(){for(const o of this.map.values())yield o.value}*keys(){for(const o of this.map.values())yield o.uri}*entries(){for(const o of this.map.values())yield[o.uri,o.value]}*[(m=Symbol.toStringTag,Symbol.iterator)](){for(const[,o]of this.map)yield[o.uri,o.value]}}t.ResourceMap=N;class j{constructor(o,n){this[e]="ResourceSet",!o||typeof o=="function"?this._map=new N(o):(this._map=new N(n),o.forEach(this.add,this))}get size(){return this._map.size}add(o){return this._map.set(o,o),this}clear(){this._map.clear()}delete(o){return this._map.delete(o)}forEach(o,n){this._map.forEach((i,a)=>o.call(n,a,a,this))}has(o){return this._map.has(o)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(e=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}t.ResourceSet=j;var y;(function(G){G[G.None=0]="None",G[G.AsOld=1]="AsOld",G[G.AsNew=2]="AsNew"})(y||(t.Touch=y={}));class Y{constructor(){this[W]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(o){return this._map.has(o)}get(o,n=y.None){const i=this._map.get(o);if(i)return n!==y.None&&this.touch(i,n),i.value}set(o,n,i=y.None){let a=this._map.get(o);if(a)a.value=n,i!==y.None&&this.touch(a,i);else{switch(a={key:o,value:n,next:void 0,previous:void 0},i){case y.None:this.addItemLast(a);break;case y.AsOld:this.addItemFirst(a);break;case y.AsNew:this.addItemLast(a);break;default:this.addItemLast(a);break}this._map.set(o,a),this._size++}return this}delete(o){return!!this.remove(o)}remove(o){const n=this._map.get(o);if(n)return this._map.delete(o),this.removeItem(n),this._size--,n.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const o=this._head;return this._map.delete(o.key),this.removeItem(o),this._size--,o.value}forEach(o,n){const i=this._state;let a=this._head;for(;a;){if(n?o.bind(n)(a.value,a.key,this):o(a.value,a.key,this),this._state!==i)throw new Error("LinkedMap got modified during iteration.");a=a.next}}keys(){const o=this,n=this._state;let i=this._head;const a={[Symbol.iterator](){return a},next(){if(o._state!==n)throw new Error("LinkedMap got modified during iteration.");if(i){const g={value:i.key,done:!1};return i=i.next,g}else return{value:void 0,done:!0}}};return a}values(){const o=this,n=this._state;let i=this._head;const a={[Symbol.iterator](){return a},next(){if(o._state!==n)throw new Error("LinkedMap got modified during iteration.");if(i){const g={value:i.value,done:!1};return i=i.next,g}else return{value:void 0,done:!0}}};return a}entries(){const o=this,n=this._state;let i=this._head;const a={[Symbol.iterator](){return a},next(){if(o._state!==n)throw new Error("LinkedMap got modified during iteration.");if(i){const g={value:[i.key,i.value],done:!1};return i=i.next,g}else return{value:void 0,done:!0}}};return a}[(W=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(o){if(o>=this.size)return;if(o===0){this.clear();return}let n=this._head,i=this.size;for(;n&&i>o;)this._map.delete(n.key),n=n.next,i--;this._head=n,this._size=i,n&&(n.previous=void 0),this._state++}trimNew(o){if(o>=this.size)return;if(o===0){this.clear();return}let n=this._tail,i=this.size;for(;n&&i>o;)this._map.delete(n.key),n=n.previous,i--;this._tail=n,this._size=i,n&&(n.next=void 0),this._state++}addItemFirst(o){if(!this._head&&!this._tail)this._tail=o;else if(this._head)o.next=this._head,this._head.previous=o;else throw new Error("Invalid list");this._head=o,this._state++}addItemLast(o){if(!this._head&&!this._tail)this._head=o;else if(this._tail)o.previous=this._tail,this._tail.next=o;else throw new Error("Invalid list");this._tail=o,this._state++}removeItem(o){if(o===this._head&&o===this._tail)this._head=void 0,this._tail=void 0;else if(o===this._head){if(!o.next)throw new Error("Invalid list");o.next.previous=void 0,this._head=o.next}else if(o===this._tail){if(!o.previous)throw new Error("Invalid list");o.previous.next=void 0,this._tail=o.previous}else{const n=o.next,i=o.previous;if(!n||!i)throw new Error("Invalid list");n.previous=i,i.next=n}o.next=void 0,o.previous=void 0,this._state++}touch(o,n){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(n!==y.AsOld&&n!==y.AsNew)){if(n===y.AsOld){if(o===this._head)return;const i=o.next,a=o.previous;o===this._tail?(a.next=void 0,this._tail=a):(i.previous=a,a.next=i),o.previous=void 0,o.next=this._head,this._head.previous=o,this._head=o,this._state++}else if(n===y.AsNew){if(o===this._tail)return;const i=o.next,a=o.previous;o===this._head?(i.previous=void 0,this._head=i):(i.previous=a,a.next=i),o.next=void 0,o.previous=this._tail,this._tail.next=o,this._tail=o,this._state++}}}toJSON(){const o=[];return this.forEach((n,i)=>{o.push([i,n])}),o}fromJSON(o){this.clear();for(const[n,i]of o)this.set(n,i)}}t.LinkedMap=Y;class p extends Y{constructor(o,n=1){super(),this._limit=o,this._ratio=Math.min(Math.max(0,n),1)}get limit(){return this._limit}set limit(o){this._limit=o,this.checkTrim()}get ratio(){return this._ratio}set ratio(o){this._ratio=Math.min(Math.max(0,o),1),this.checkTrim()}get(o,n=y.AsNew){return super.get(o,n)}peek(o){return super.get(o,y.None)}set(o,n){return super.set(o,n,y.AsNew),this}checkTrim(){this.size>this._limit&&this.trim(Math.round(this._limit*this._ratio))}}class v extends p{constructor(o,n=1){super(o,n)}trim(o){this.trimOld(o)}set(o,n){return super.set(o,n),this.checkTrim(),this}}t.LRUCache=v;class w extends p{constructor(o,n=1){super(o,n)}trim(o){this.trimNew(o)}set(o,n){return this._limit<=this.size&&!this.has(o)&&this.trim(Math.round(this._limit*this._ratio)-1),super.set(o,n),this}}t.MRUCache=w;class F{constructor(){this.map=new Map}add(o){return this.map.set(o,(this.map.get(o)||0)+1),this}delete(o){let n=this.map.get(o)||0;return n===0?!1:(n--,n===0?this.map.delete(o):this.map.set(o,n),!0)}has(o){return this.map.has(o)}}t.CounterSet=F;class q{constructor(o){if(this._m1=new Map,this._m2=new Map,o)for(const[n,i]of o)this.set(n,i)}clear(){this._m1.clear(),this._m2.clear()}set(o,n){this._m1.set(o,n),this._m2.set(n,o)}get(o){return this._m1.get(o)}getKey(o){return this._m2.get(o)}delete(o){const n=this._m1.get(o);return n===void 0?!1:(this._m1.delete(o),this._m2.delete(n),!0)}forEach(o,n){this._m1.forEach((i,a)=>{o.call(n,i,a,this)})}keys(){return this._m1.keys()}values(){return this._m1.values()}}t.BidirectionalMap=q;class H{constructor(){this.map=new Map}add(o,n){let i=this.map.get(o);i||(i=new Set,this.map.set(o,i)),i.add(n)}delete(o,n){const i=this.map.get(o);i&&(i.delete(n),i.size===0&&this.map.delete(o))}forEach(o,n){const i=this.map.get(o);i&&i.forEach(n)}get(o){const n=this.map.get(o);return n||new Set}}t.SetMap=H;function C(G,o){if(G===o)return!0;if(G.size!==o.size)return!1;for(const[n,i]of G)if(!o.has(n)||o.get(n)!==i)return!1;for(const[n]of o)if(!G.has(n))return!1;return!0}}),define(h1[6],d1([0,1,13,12,17,5,14]),function(e1,t,m,e,W,U,t1){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DisposableMap=t.ImmortalReference=t.AsyncReferenceCollection=t.ReferenceCollection=t.SafeDisposable=t.RefCountedDisposable=t.MandatoryMutableDisposable=t.MutableDisposable=t.Disposable=t.DisposableStore=t.DisposableTracker=void 0,t.setDisposableTracker=N,t.trackDisposable=j,t.markAsDisposed=y,t.markAsSingleton=v,t.isDisposable=w,t.dispose=F,t.disposeIfDisposable=q,t.combinedDisposable=H,t.toDisposable=C,t.disposeOnReturn=u;const $=!1;let S=null;class I{constructor(){this.livingDisposables=new Map}static{this.idx=0}getDisposableData(c){let D=this.livingDisposables.get(c);return D||(D={parent:null,source:null,isSingleton:!1,value:c,idx:I.idx++},this.livingDisposables.set(c,D)),D}trackDisposable(c){const D=this.getDisposableData(c);D.source||(D.source=new Error().stack)}setParent(c,D){const P=this.getDisposableData(c);P.parent=D}markAsDisposed(c){this.livingDisposables.delete(c)}markAsSingleton(c){this.getDisposableData(c).isSingleton=!0}getRootParent(c,D){const P=D.get(c);if(P)return P;const M=c.parent?this.getRootParent(this.getDisposableData(c.parent),D):c;return D.set(c,M),M}getTrackedDisposables(){const c=new Map;return[...this.livingDisposables.entries()].filter(([,P])=>P.source!==null&&!this.getRootParent(P,c).isSingleton).flatMap(([P])=>P)}computeLeakingDisposables(c=10,D){let P;if(D)P=D;else{const x=new Map,s1=[...this.livingDisposables.values()].filter(J=>J.source!==null&&!this.getRootParent(J,x).isSingleton);if(s1.length===0)return;const u1=new Set(s1.map(J=>J.value));if(P=s1.filter(J=>!(J.parent&&u1.has(J.parent))),P.length===0)throw new Error("There are cyclic diposable chains!")}if(!P)return;function M(x){function s1(J,o1){for(;J.length>0&&o1.some(_1=>typeof _1=="string"?_1===J[0]:J[0].match(_1));)J.shift()}const u1=x.source.split(`
`).map(J=>J.trim().replace("at ","")).filter(J=>J!=="");return s1(u1,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),u1.reverse()}const R=new W.SetMap;for(const x of P){const s1=M(x);for(let u1=0;u1<=s1.length;u1++)R.add(s1.slice(0,u1).join(`
`),x)}P.sort((0,m.compareBy)(x=>x.idx,m.numberComparator));let K="",i1=0;for(const x of P.slice(0,c)){i1++;const s1=M(x),u1=[];for(let J=0;J<s1.length;J++){let o1=s1[J];o1=`(shared with ${R.get(s1.slice(0,J+1).join(`
`)).size}/${P.length} leaks) at ${o1}`;const p1=R.get(s1.slice(0,J).join(`
`)),R1=(0,e.groupBy)([...p1].map(I1=>M(I1)[J]),I1=>I1);delete R1[s1[J]];for(const[I1,y1]of Object.entries(R1))u1.unshift(`    - stacktraces of ${y1.length} other leaks continue with ${I1}`);u1.unshift(o1)}K+=`


==================== Leaking disposable ${i1}/${P.length}: ${x.value.constructor.name} ====================
${u1.join(`
`)}
============================================================

`}return P.length>c&&(K+=`


... and ${P.length-c} more leaking disposables

`),{leaks:P,details:K}}}t.DisposableTracker=I;function N(E){S=E}if($){const E="__is_disposable_tracked__";N(new class{trackDisposable(c){const D=new Error("Potentially leaked disposable").stack;setTimeout(()=>{c[E]||console.log(D)},3e3)}setParent(c,D){if(c&&c!==o.None)try{c[E]=!0}catch{}}markAsDisposed(c){if(c&&c!==o.None)try{c[E]=!0}catch{}}markAsSingleton(c){}})}function j(E){return S?.trackDisposable(E),E}function y(E){S?.markAsDisposed(E)}function Y(E,c){S?.setParent(E,c)}function p(E,c){if(S)for(const D of E)S.setParent(D,c)}function v(E){return S?.markAsSingleton(E),E}function w(E){return typeof E=="object"&&E!==null&&typeof E.dispose=="function"&&E.dispose.length===0}function F(E){if(t1.Iterable.is(E)){const c=[];for(const D of E)if(D)try{D.dispose()}catch(P){c.push(P)}if(c.length===1)throw c[0];if(c.length>1)throw new AggregateError(c,"Encountered errors while disposing of store");return Array.isArray(E)?[]:E}else if(E)return E.dispose(),E}function q(E){for(const c of E)w(c)&&c.dispose();return[]}function H(...E){const c=C(()=>F(E));return p(E,c),c}function C(E){const c=j({dispose:(0,U.createSingleCallFunction)(()=>{y(c),E()})});return c}class G{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this._toDispose=new Set,this._isDisposed=!1,j(this)}dispose(){this._isDisposed||(y(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){if(this._toDispose.size!==0)try{F(this._toDispose)}finally{this._toDispose.clear()}}add(c){if(!c)return c;if(c===this)throw new Error("Cannot register a disposable on itself!");return Y(c,this),this._isDisposed?G.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(c),c}delete(c){if(c){if(c===this)throw new Error("Cannot dispose a disposable on itself!");this._toDispose.delete(c),c.dispose()}}deleteAndLeak(c){c&&this._toDispose.has(c)&&(this._toDispose.delete(c),Y(c,null))}}t.DisposableStore=G;class o{static{this.None=Object.freeze({dispose(){}})}constructor(){this._store=new G,j(this),Y(this._store,this)}dispose(){y(this),this._store.dispose()}_register(c){if(c===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(c)}}t.Disposable=o;class n{constructor(){this._isDisposed=!1,j(this)}get value(){return this._isDisposed?void 0:this._value}set value(c){this._isDisposed||c===this._value||(this._value?.dispose(),c&&Y(c,this),this._value=c)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,y(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const c=this._value;return this._value=void 0,c&&Y(c,null),c}}t.MutableDisposable=n;class i{constructor(c){this._disposable=new n,this._isDisposed=!1,this._disposable.value=c}get value(){return this._disposable.value}set value(c){this._isDisposed||c===this._disposable.value||(this._disposable.value=c)}dispose(){this._isDisposed=!0,this._disposable.dispose()}}t.MandatoryMutableDisposable=i;class a{constructor(c){this._disposable=c,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter===0&&this._disposable.dispose(),this}}t.RefCountedDisposable=a;class g{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,j(this)}set(c){let D=c;return this.unset=()=>D=void 0,this.isset=()=>D!==void 0,this.dispose=()=>{D&&(D(),D=void 0,y(this))},this}}t.SafeDisposable=g;class s{constructor(){this.references=new Map}acquire(c,...D){let P=this.references.get(c);P||(P={counter:0,object:this.createReferencedObject(c,...D)},this.references.set(c,P));const{object:M}=P,R=(0,U.createSingleCallFunction)(()=>{--P.counter===0&&(this.destroyReferencedObject(c,P.object),this.references.delete(c))});return P.counter++,{object:M,dispose:R}}}t.ReferenceCollection=s;class r{constructor(c){this.referenceCollection=c}async acquire(c,...D){const P=this.referenceCollection.acquire(c,...D);try{return{object:await P.object,dispose:()=>P.dispose()}}catch(M){throw P.dispose(),M}}}t.AsyncReferenceCollection=r;class f{constructor(c){this.object=c}dispose(){}}t.ImmortalReference=f;function u(E){const c=new G;try{E(c)}finally{c.dispose()}}class h{constructor(){this._store=new Map,this._isDisposed=!1,j(this)}dispose(){y(this),this._isDisposed=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this._store.size)try{F(this._store.values())}finally{this._store.clear()}}has(c){return this._store.has(c)}get size(){return this._store.size}get(c){return this._store.get(c)}set(c,D,P=!1){this._isDisposed&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),P||this._store.get(c)?.dispose(),this._store.set(c,D)}deleteAndDispose(c){this._store.get(c)?.dispose(),this._store.delete(c)}deleteAndLeak(c){const D=this._store.get(c);return this._store.delete(c),D}keys(){return this._store.keys()}values(){return this._store.values()}[Symbol.iterator](){return this._store[Symbol.iterator]()}}t.DisposableMap=h}),define(h1[18],d1([0,1]),function(e1,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.MarshalledId=void 0;var m;(function(e){e[e.Uri=1]="Uri",e[e.Regexp=2]="Regexp",e[e.ScmResource=3]="ScmResource",e[e.ScmResourceGroup=4]="ScmResourceGroup",e[e.ScmProvider=5]="ScmProvider",e[e.CommentController=6]="CommentController",e[e.CommentThread=7]="CommentThread",e[e.CommentThreadInstance=8]="CommentThreadInstance",e[e.CommentThreadReply=9]="CommentThreadReply",e[e.CommentNode=10]="CommentNode",e[e.CommentThreadNode=11]="CommentThreadNode",e[e.TimelineActionContext=12]="TimelineActionContext",e[e.NotebookCellActionContext=13]="NotebookCellActionContext",e[e.NotebookActionContext=14]="NotebookActionContext",e[e.TerminalContext=15]="TerminalContext",e[e.TestItemContext=16]="TestItemContext",e[e.Date=17]="Date",e[e.TestMessageMenuArgs=18]="TestMessageMenuArgs"})(m||(t.MarshalledId=m={}))}),define(h1[19],d1([0,1]),function(e1,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StopWatch=void 0;const m=globalThis.performance&&typeof globalThis.performance.now=="function";class e{static create(U){return new e(U)}constructor(U){this._now=m&&U===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this._startTime=this._now(),this._stopTime=-1}stop(){this._stopTime=this._now()}reset(){this._startTime=this._now(),this._stopTime=-1}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}}t.StopWatch=e}),define(h1[7],d1([0,1,2,5,6,16,19]),function(e1,t,m,e,W,U,t1){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ValueWithChangeEvent=t.Relay=t.EventBufferer=t.DynamicListEventMultiplexer=t.EventMultiplexer=t.MicrotaskEmitter=t.DebounceEmitter=t.PauseableEmitter=t.AsyncEmitter=t.createEventDeliveryQueue=t.Emitter=t.ListenerRefusalError=t.ListenerLeakError=t.EventProfiling=t.Event=void 0,t.setGlobalLeakWarningThreshold=Y;const $=!1,S=!1,I=!1;var N;(function(M){M.None=()=>W.Disposable.None;function R(V){if(I){const{onDidAddListener:B}=V,Q=v.create();let z=0;V.onDidAddListener=()=>{++z===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),Q.print()),B?.()}}}function K(V,B){return y1(V,()=>{},0,void 0,!0,void 0,B)}M.defer=K;function i1(V){return(B,Q=null,z)=>{let Z=!1,l1;return l1=V(f1=>{if(!Z)return l1?l1.dispose():Z=!0,B.call(Q,f1)},null,z),Z&&l1.dispose(),l1}}M.once=i1;function x(V,B){return M.once(M.filter(V,B))}M.onceIf=x;function s1(V,B,Q){return R1((z,Z=null,l1)=>V(f1=>z.call(Z,B(f1)),null,l1),Q)}M.map=s1;function u1(V,B,Q){return R1((z,Z=null,l1)=>V(f1=>{B(f1),z.call(Z,f1)},null,l1),Q)}M.forEach=u1;function J(V,B,Q){return R1((z,Z=null,l1)=>V(f1=>B(f1)&&z.call(Z,f1),null,l1),Q)}M.filter=J;function o1(V){return V}M.signal=o1;function _1(...V){return(B,Q=null,z)=>{const Z=(0,W.combinedDisposable)(...V.map(l1=>l1(f1=>B.call(Q,f1))));return I1(Z,z)}}M.any=_1;function p1(V,B,Q,z){let Z=Q;return s1(V,l1=>(Z=B(Z,l1),Z),z)}M.reduce=p1;function R1(V,B){let Q;const z={onWillAddFirstListener(){Q=V(Z.fire,Z)},onDidRemoveLastListener(){Q?.dispose()}};B||R(z);const Z=new n(z);return B?.add(Z),Z.event}function I1(V,B){return B instanceof Array?B.push(V):B&&B.add(V),V}function y1(V,B,Q=100,z=!1,Z=!1,l1,f1){let g1,b1,r1,w1=0,P1;const K1={leakWarningThreshold:l1,onWillAddFirstListener(){g1=V(V1=>{w1++,b1=B(b1,V1),z&&!r1&&(W1.fire(b1),b1=void 0),P1=()=>{const B1=b1;b1=void 0,r1=void 0,(!z||w1>1)&&W1.fire(B1),w1=0},typeof Q=="number"?(clearTimeout(r1),r1=setTimeout(P1,Q)):r1===void 0&&(r1=0,queueMicrotask(P1))})},onWillRemoveListener(){Z&&w1>0&&P1?.()},onDidRemoveLastListener(){P1=void 0,g1.dispose()}};f1||R(K1);const W1=new n(K1);return f1?.add(W1),W1.event}M.debounce=y1;function G1(V,B=0,Q){return M.debounce(V,(z,Z)=>z?(z.push(Z),z):[Z],B,void 0,!0,void 0,Q)}M.accumulate=G1;function $1(V,B=(z,Z)=>z===Z,Q){let z=!0,Z;return J(V,l1=>{const f1=z||!B(l1,Z);return z=!1,Z=l1,f1},Q)}M.latch=$1;function D1(V,B,Q){return[M.filter(V,B,Q),M.filter(V,z=>!B(z),Q)]}M.split=D1;function F1(V,B=!1,Q=[],z){let Z=Q.slice(),l1=V(b1=>{Z?Z.push(b1):g1.fire(b1)});z&&z.add(l1);const f1=()=>{Z?.forEach(b1=>g1.fire(b1)),Z=null},g1=new n({onWillAddFirstListener(){l1||(l1=V(b1=>g1.fire(b1)),z&&z.add(l1))},onDidAddFirstListener(){Z&&(B?setTimeout(f1):f1())},onDidRemoveLastListener(){l1&&l1.dispose(),l1=null}});return z&&z.add(g1),g1.event}M.buffer=F1;function j1(V,B){return(z,Z,l1)=>{const f1=B(new A);return V(function(g1){const b1=f1.evaluate(g1);b1!==d&&z.call(Z,b1)},void 0,l1)}}M.chain=j1;const d=Symbol("HaltChainable");class A{constructor(){this.steps=[]}map(B){return this.steps.push(B),this}forEach(B){return this.steps.push(Q=>(B(Q),Q)),this}filter(B){return this.steps.push(Q=>B(Q)?Q:d),this}reduce(B,Q){let z=Q;return this.steps.push(Z=>(z=B(z,Z),z)),this}latch(B=(Q,z)=>Q===z){let Q=!0,z;return this.steps.push(Z=>{const l1=Q||!B(Z,z);return Q=!1,z=Z,l1?Z:d}),this}evaluate(B){for(const Q of this.steps)if(B=Q(B),B===d)break;return B}}function b(V,B,Q=z=>z){const z=(...g1)=>f1.fire(Q(...g1)),Z=()=>V.on(B,z),l1=()=>V.removeListener(B,z),f1=new n({onWillAddFirstListener:Z,onDidRemoveLastListener:l1});return f1.event}M.fromNodeEventEmitter=b;function T(V,B,Q=z=>z){const z=(...g1)=>f1.fire(Q(...g1)),Z=()=>V.addEventListener(B,z),l1=()=>V.removeEventListener(B,z),f1=new n({onWillAddFirstListener:Z,onDidRemoveLastListener:l1});return f1.event}M.fromDOMEventEmitter=T;function k(V){return new Promise(B=>i1(V)(B))}M.toPromise=k;function n1(V){const B=new n;return V.then(Q=>{B.fire(Q)},()=>{B.fire(void 0)}).finally(()=>{B.dispose()}),B.event}M.fromPromise=n1;function a1(V,B){return V(Q=>B.fire(Q))}M.forward=a1;function m1(V,B,Q){return B(Q),V(z=>B(z))}M.runAndSubscribe=m1;class E1{constructor(B,Q){this._observable=B,this._counter=0,this._hasChanged=!1;const z={onWillAddFirstListener:()=>{B.addObserver(this),this._observable.reportChanges()},onDidRemoveLastListener:()=>{B.removeObserver(this)}};Q||R(z),this.emitter=new n(z),Q&&Q.add(this.emitter)}beginUpdate(B){this._counter++}handlePossibleChange(B){}handleChange(B,Q){this._hasChanged=!0}endUpdate(B){this._counter--,this._counter===0&&(this._observable.reportChanges(),this._hasChanged&&(this._hasChanged=!1,this.emitter.fire(this._observable.get())))}}function v1(V,B){return new E1(V,B).emitter.event}M.fromObservable=v1;function U1(V){return(B,Q,z)=>{let Z=0,l1=!1;const f1={beginUpdate(){Z++},endUpdate(){Z--,Z===0&&(V.reportChanges(),l1&&(l1=!1,B.call(Q)))},handlePossibleChange(){},handleChange(){l1=!0}};V.addObserver(f1),V.reportChanges();const g1={dispose(){V.removeObserver(f1)}};return z instanceof W.DisposableStore?z.add(g1):Array.isArray(z)&&z.push(g1),g1}}M.fromObservableLight=U1})(N||(t.Event=N={}));class j{static{this.all=new Set}static{this._idPool=0}constructor(R){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${R}_${j._idPool++}`,j.all.add(this)}start(R){this._stopWatch=new t1.StopWatch,this.listenerCount=R}stop(){if(this._stopWatch){const R=this._stopWatch.elapsed();this.durations.push(R),this.elapsedOverall+=R,this.invocationCount+=1,this._stopWatch=void 0}}}t.EventProfiling=j;let y=-1;function Y(M){const R=y;return y=M,{dispose(){y=R}}}class p{static{this._idPool=1}constructor(R,K,i1=(p._idPool++).toString(16).padStart(3,"0")){this._errorHandler=R,this.threshold=K,this.name=i1,this._warnCountdown=0}dispose(){this._stacks?.clear()}check(R,K){const i1=this.threshold;if(i1<=0||K<i1)return;this._stacks||(this._stacks=new Map);const x=this._stacks.get(R.value)||0;if(this._stacks.set(R.value,x+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=i1*.5;const[s1,u1]=this.getMostFrequentStack(),J=`[${this.name}] potential listener LEAK detected, having ${K} listeners already. MOST frequent listener (${u1}):`;console.warn(J),console.warn(s1);const o1=new w(J,s1);this._errorHandler(o1)}return()=>{const s1=this._stacks.get(R.value)||0;this._stacks.set(R.value,s1-1)}}getMostFrequentStack(){if(!this._stacks)return;let R,K=0;for(const[i1,x]of this._stacks)(!R||K<x)&&(R=[i1,x],K=x);return R}}class v{static create(){const R=new Error;return new v(R.stack??"")}constructor(R){this.value=R}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class w extends Error{constructor(R,K){super(R),this.name="ListenerLeakError",this.stack=K}}t.ListenerLeakError=w;class F extends Error{constructor(R,K){super(R),this.name="ListenerRefusalError",this.stack=K}}t.ListenerRefusalError=F;let q=0;class H{constructor(R){this.value=R,this.id=q++}}const C=2,G=(M,R)=>{if(M instanceof H)R(M);else for(let K=0;K<M.length;K++){const i1=M[K];i1&&R(i1)}};let o;if($){const M=[];setInterval(()=>{M.length!==0&&(console.warn("[LEAKING LISTENERS] GC'ed these listeners that were NOT yet disposed:"),console.warn(M.join(`
`)),M.length=0)},3e3),o=new FinalizationRegistry(R=>{typeof R=="string"&&M.push(R)})}class n{constructor(R){this._size=0,this._options=R,this._leakageMon=y>0||this._options?.leakWarningThreshold?new p(R?.onListenerError??m.onUnexpectedError,this._options?.leakWarningThreshold??y):void 0,this._perfMon=this._options?._profName?new j(this._options._profName):void 0,this._deliveryQueue=this._options?.deliveryQueue}dispose(){if(!this._disposed){if(this._disposed=!0,this._deliveryQueue?.current===this&&this._deliveryQueue.reset(),this._listeners){if(S){const R=this._listeners;queueMicrotask(()=>{G(R,K=>K.stack?.print())})}this._listeners=void 0,this._size=0}this._options?.onDidRemoveLastListener?.(),this._leakageMon?.dispose()}}get event(){return this._event??=(R,K,i1)=>{if(this._leakageMon&&this._size>this._leakageMon.threshold**2){const o1=`[${this._leakageMon.name}] REFUSES to accept new listeners because it exceeded its threshold by far (${this._size} vs ${this._leakageMon.threshold})`;console.warn(o1);const _1=this._leakageMon.getMostFrequentStack()??["UNKNOWN stack",-1],p1=new F(`${o1}. HINT: Stack shows most frequent listener (${_1[1]}-times)`,_1[0]);return(this._options?.onListenerError||m.onUnexpectedError)(p1),W.Disposable.None}if(this._disposed)return W.Disposable.None;K&&(R=R.bind(K));const x=new H(R);let s1,u1;this._leakageMon&&this._size>=Math.ceil(this._leakageMon.threshold*.2)&&(x.stack=v.create(),s1=this._leakageMon.check(x.stack,this._size+1)),S&&(x.stack=u1??v.create()),this._listeners?this._listeners instanceof H?(this._deliveryQueue??=new a,this._listeners=[this._listeners,x]):this._listeners.push(x):(this._options?.onWillAddFirstListener?.(this),this._listeners=x,this._options?.onDidAddFirstListener?.(this)),this._size++;const J=(0,W.toDisposable)(()=>{o?.unregister(J),s1?.(),this._removeListener(x)});if(i1 instanceof W.DisposableStore?i1.add(J):Array.isArray(i1)&&i1.push(J),o){const o1=new Error().stack.split(`
`).slice(2,3).join(`
`).trim(),_1=/(file:|vscode-file:\/\/vscode-app)?(\/[^:]*:\d+:\d+)/.exec(o1);o.register(J,_1?.[2]??o1,J)}return J},this._event}_removeListener(R){if(this._options?.onWillRemoveListener?.(this),!this._listeners)return;if(this._size===1){this._listeners=void 0,this._options?.onDidRemoveLastListener?.(this),this._size=0;return}const K=this._listeners,i1=K.indexOf(R);if(i1===-1)throw console.log("disposed?",this._disposed),console.log("size?",this._size),console.log("arr?",JSON.stringify(this._listeners)),new Error("Attempted to dispose unknown listener");this._size--,K[i1]=void 0;const x=this._deliveryQueue.current===this;if(this._size*C<=K.length){let s1=0;for(let u1=0;u1<K.length;u1++)K[u1]?K[s1++]=K[u1]:x&&(this._deliveryQueue.end--,s1<this._deliveryQueue.i&&this._deliveryQueue.i--);K.length=s1}}_deliver(R,K){if(!R)return;const i1=this._options?.onListenerError||m.onUnexpectedError;if(!i1){R.value(K);return}try{R.value(K)}catch(x){i1(x)}}_deliverQueue(R){const K=R.current._listeners;for(;R.i<R.end;)this._deliver(K[R.i++],R.value);R.reset()}fire(R){if(this._deliveryQueue?.current&&(this._deliverQueue(this._deliveryQueue),this._perfMon?.stop()),this._perfMon?.start(this._size),this._listeners)if(this._listeners instanceof H)this._deliver(this._listeners,R);else{const K=this._deliveryQueue;K.enqueue(this,R,this._listeners.length),this._deliverQueue(K)}this._perfMon?.stop()}hasListeners(){return this._size>0}}t.Emitter=n;const i=()=>new a;t.createEventDeliveryQueue=i;class a{constructor(){this.i=-1,this.end=0}enqueue(R,K,i1){this.i=0,this.end=i1,this.current=R,this.value=K}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class g extends n{async fireAsync(R,K,i1){if(this._listeners)for(this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new U.LinkedList),G(this._listeners,x=>this._asyncDeliveryQueue.push([x.value,R]));this._asyncDeliveryQueue.size>0&&!K.isCancellationRequested;){const[x,s1]=this._asyncDeliveryQueue.shift(),u1=[],J={...s1,token:K,waitUntil:o1=>{if(Object.isFrozen(u1))throw new Error("waitUntil can NOT be called asynchronous");i1&&(o1=i1(o1,x)),u1.push(o1)}};try{x(J)}catch(o1){(0,m.onUnexpectedError)(o1);continue}Object.freeze(u1),await Promise.allSettled(u1).then(o1=>{for(const _1 of o1)_1.status==="rejected"&&(0,m.onUnexpectedError)(_1.reason)})}}}t.AsyncEmitter=g;class s extends n{get isPaused(){return this._isPaused!==0}constructor(R){super(R),this._isPaused=0,this._eventQueue=new U.LinkedList,this._mergeFn=R?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused===0)if(this._mergeFn){if(this._eventQueue.size>0){const R=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(R))}}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(R){this._size&&(this._isPaused!==0?this._eventQueue.push(R):super.fire(R))}}t.PauseableEmitter=s;class r extends s{constructor(R){super(R),this._delay=R.delay??100}fire(R){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(R)}}t.DebounceEmitter=r;class f extends n{constructor(R){super(R),this._queuedEvents=[],this._mergeFn=R?.merge}fire(R){this.hasListeners()&&(this._queuedEvents.push(R),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(K=>super.fire(K)),this._queuedEvents=[]}))}}t.MicrotaskEmitter=f;class u{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new n({onWillAddFirstListener:()=>this.onFirstListenerAdd(),onDidRemoveLastListener:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(R){const K={event:R,listener:null};this.events.push(K),this.hasListeners&&this.hook(K);const i1=()=>{this.hasListeners&&this.unhook(K);const x=this.events.indexOf(K);this.events.splice(x,1)};return(0,W.toDisposable)((0,e.createSingleCallFunction)(i1))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(R=>this.hook(R))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(R=>this.unhook(R))}hook(R){R.listener=R.event(K=>this.emitter.fire(K))}unhook(R){R.listener?.dispose(),R.listener=null}dispose(){this.emitter.dispose();for(const R of this.events)R.listener?.dispose();this.events=[]}}t.EventMultiplexer=u;class h{constructor(R,K,i1,x){this._store=new W.DisposableStore;const s1=this._store.add(new u),u1=this._store.add(new W.DisposableMap);function J(o1){u1.set(o1,s1.add(x(o1)))}for(const o1 of R)J(o1);this._store.add(K(o1=>{J(o1)})),this._store.add(i1(o1=>{u1.deleteAndDispose(o1)})),this.event=s1.event}dispose(){this._store.dispose()}}t.DynamicListEventMultiplexer=h;class E{constructor(){this.data=[]}wrapEvent(R,K,i1){return(x,s1,u1)=>R(J=>{const o1=this.data[this.data.length-1];if(!K){o1?o1.buffers.push(()=>x.call(s1,J)):x.call(s1,J);return}const _1=o1;if(!_1){x.call(s1,K(i1,J));return}_1.items??=[],_1.items.push(J),_1.buffers.length===0&&o1.buffers.push(()=>{_1.reducedResult??=i1?_1.items.reduce(K,i1):_1.items.reduce(K),x.call(s1,_1.reducedResult)})},void 0,u1)}bufferEvents(R){const K={buffers:new Array};this.data.push(K);const i1=R();return this.data.pop(),K.buffers.forEach(x=>x()),i1}}t.EventBufferer=E;class c{constructor(){this.listening=!1,this.inputEvent=N.None,this.inputEventListener=W.Disposable.None,this.emitter=new n({onDidAddFirstListener:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onDidRemoveLastListener:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(R){this.inputEvent=R,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=R(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}t.Relay=c;class D{static const(R){return new P(R)}constructor(R){this._value=R,this._onDidChange=new n,this.onDidChange=this._onDidChange.event}get value(){return this._value}set value(R){R!==this._value&&(this._value=R,this._onDidChange.fire(void 0))}}t.ValueWithChangeEvent=D;class P{constructor(R){this.value=R,this.onDidChange=N.None}}}),define(h1[20],d1([0,1,7]),function(e1,t,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CancellationTokenSource=t.CancellationToken=void 0,t.cancelOnDispose=$;const e=Object.freeze(function(S,I){const N=setTimeout(S.bind(I),0);return{dispose(){clearTimeout(N)}}});var W;(function(S){function I(N){return N===S.None||N===S.Cancelled||N instanceof U?!0:!N||typeof N!="object"?!1:typeof N.isCancellationRequested=="boolean"&&typeof N.onCancellationRequested=="function"}S.isCancellationToken=I,S.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:m.Event.None}),S.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:e})})(W||(t.CancellationToken=W={}));class U{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?e:(this._emitter||(this._emitter=new m.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class t1{constructor(I){this._token=void 0,this._parentListener=void 0,this._parentListener=I&&I.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new U),this._token}cancel(){this._token?this._token instanceof U&&this._token.cancel():this._token=W.Cancelled}dispose(I=!1){I&&this.cancel(),this._parentListener?.dispose(),this._token?this._token instanceof U&&this._token.dispose():this._token=W.None}}t.CancellationTokenSource=t1;function $(S){const I=new t1;return S.add({dispose(){I.cancel()}}),I.token}}),define(h1[21],d1([0,1,20]),function(e1,t,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CachedFunction=t.LRUCachedFunction=t.Cache=void 0,t.identity=W;class e{constructor(S){this.task=S,this.result=null}get(){if(this.result)return this.result;const S=new m.CancellationTokenSource,I=this.task(S.token);return this.result={promise:I,dispose:()=>{this.result=null,S.cancel(),S.dispose()}},this.result}}t.Cache=e;function W($){return $}class U{constructor(S,I){this.lastCache=void 0,this.lastArgKey=void 0,typeof S=="function"?(this._fn=S,this._computeKey=W):(this._fn=I,this._computeKey=S.getCacheKey)}get(S){const I=this._computeKey(S);return this.lastArgKey!==I&&(this.lastArgKey=I,this.lastCache=this._fn(S)),this.lastCache}}t.LRUCachedFunction=U;class t1{get cachedValues(){return this._map}constructor(S,I){this._map=new Map,this._map2=new Map,typeof S=="function"?(this._fn=S,this._computeKey=W):(this._fn=I,this._computeKey=S.getCacheKey)}get(S){const I=this._computeKey(S);if(this._map2.has(I))return this._map2.get(I);const N=this._fn(S);return this._map.set(S,N),this._map2.set(I,N),N}}t.CachedFunction=t1}),define(h1[22],d1([0,1]),function(e1,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Constants=void 0,t.toUint8=e,t.toUint32=W;var m;(function(U){U[U.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",U[U.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",U[U.MAX_UINT_8=255]="MAX_UINT_8",U[U.MAX_UINT_16=65535]="MAX_UINT_16",U[U.MAX_UINT_32=4294967295]="MAX_UINT_32",U[U.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(m||(t.Constants=m={}));function e(U){return U<0?0:U>m.MAX_UINT_8?m.MAX_UINT_8:U|0}function W(U){return U<0?0:U>m.MAX_UINT_32?m.MAX_UINT_32:U|0}}),define(h1[8],d1([0,1,21,4,15,22]),function(e1,t,m,e,W,U){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.InvisibleCharacters=t.AmbiguousCharacters=t.noBreakWhitespace=t.GraphemeBreakType=t.UTF8_BOM_CHARACTER=t.UNUSUAL_LINE_TERMINATORS=t.GraphemeIterator=t.CodePointIterator=void 0,t.isFalsyOrWhitespace=t1,t.format=S,t.format2=N,t.htmlAttributeEncodeValue=j,t.escape=y,t.escapeRegExpCharacters=Y,t.count=p,t.truncate=v,t.truncateMiddle=w,t.trim=F,t.ltrim=q,t.rtrim=H,t.convertSimple2RegExpPattern=C,t.stripWildcards=G,t.createRegExp=o,t.regExpLeadsToEndlessLoop=n,t.splitLines=i,t.splitLinesIncludeSeparators=a,t.firstNonWhitespaceIndex=g,t.getLeadingWhitespace=s,t.lastNonWhitespaceIndex=r,t.replaceAsync=f,t.compare=u,t.compareSubstring=h,t.compareIgnoreCase=E,t.compareSubstringIgnoreCase=c,t.isAsciiDigit=D,t.isLowerAsciiLetter=P,t.isUpperAsciiLetter=M,t.equalsIgnoreCase=R,t.startsWithIgnoreCase=K,t.commonPrefixLength=i1,t.commonSuffixLength=x,t.isHighSurrogate=s1,t.isLowSurrogate=u1,t.computeCodePoint=J,t.getNextCodePoint=o1,t.nextCharLength=I1,t.prevCharLength=y1,t.getCharContainingOffset=G1,t.charCount=$1,t.containsRTL=j1,t.isBasicASCII=A,t.containsUnusualLineTerminators=b,t.isFullWidthCharacter=T,t.isEmojiImprecise=k,t.lcut=n1,t.forAnsiStringParts=m1,t.removeAnsiEscapeCodes=E1,t.removeAnsiEscapeCodesFromPrompt=U1,t.startsWithUTF8BOM=V,t.stripUTF8BOM=B,t.fuzzyContains=Q,t.containsUppercaseCharacter=z,t.uppercaseFirstLetter=Z,t.getNLines=l1,t.singleLetterHash=f1,t.getGraphemeBreakType=g1,t.getLeftDeleteOffset=K1;function t1(l){return!l||typeof l!="string"?!0:l.trim().length===0}const $=/{(\d+)}/g;function S(l,..._){return _.length===0?l:l.replace($,function(L,O){const X=parseInt(O,10);return isNaN(X)||X<0||X>=_.length?L:_[X]})}const I=/{([^}]+)}/g;function N(l,_){return Object.keys(_).length===0?l:l.replace(I,(L,O)=>_[O]??L)}function j(l){return l.replace(/[<>"'&]/g,_=>{switch(_){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return _})}function y(l){return l.replace(/[<>&]/g,function(_){switch(_){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return _}})}function Y(l){return l.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function p(l,_){let L=0,O=l.indexOf(_);for(;O!==-1;)L++,O=l.indexOf(_,O+_.length);return L}function v(l,_,L="\u2026"){return l.length<=_?l:`${l.substr(0,_)}${L}`}function w(l,_,L="\u2026"){if(l.length<=_)return l;const O=Math.ceil(_/2)-L.length/2,X=Math.floor(_/2)-L.length/2;return`${l.substr(0,O)}${L}${l.substr(l.length-X)}`}function F(l,_=" "){const L=q(l,_);return H(L,_)}function q(l,_){if(!l||!_)return l;const L=_.length;if(L===0||l.length===0)return l;let O=0;for(;l.indexOf(_,O)===O;)O=O+L;return l.substring(O)}function H(l,_){if(!l||!_)return l;const L=_.length,O=l.length;if(L===0||O===0)return l;let X=O,c1=-1;for(;c1=l.lastIndexOf(_,X-1),!(c1===-1||c1+L!==X);){if(c1===0)return"";X=c1}return l.substring(0,X)}function C(l){return l.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function G(l){return l.replace(/\*/g,"")}function o(l,_,L={}){if(!l)throw new Error("Cannot create regex from empty string");_||(l=Y(l)),L.wholeWord&&(/\B/.test(l.charAt(0))||(l="\\b"+l),/\B/.test(l.charAt(l.length-1))||(l=l+"\\b"));let O="";return L.global&&(O+="g"),L.matchCase||(O+="i"),L.multiline&&(O+="m"),L.unicode&&(O+="u"),new RegExp(l,O)}function n(l){return l.source==="^"||l.source==="^$"||l.source==="$"||l.source==="^\\s*$"?!1:!!(l.exec("")&&l.lastIndex===0)}function i(l){return l.split(/\r\n|\r|\n/)}function a(l){const _=[],L=l.split(/(\r\n|\r|\n)/);for(let O=0;O<Math.ceil(L.length/2);O++)_.push(L[2*O]+(L[2*O+1]??""));return _}function g(l){for(let _=0,L=l.length;_<L;_++){const O=l.charCodeAt(_);if(O!==e.CharCode.Space&&O!==e.CharCode.Tab)return _}return-1}function s(l,_=0,L=l.length){for(let O=_;O<L;O++){const X=l.charCodeAt(O);if(X!==e.CharCode.Space&&X!==e.CharCode.Tab)return l.substring(_,O)}return l.substring(_,L)}function r(l,_=l.length-1){for(let L=_;L>=0;L--){const O=l.charCodeAt(L);if(O!==e.CharCode.Space&&O!==e.CharCode.Tab)return L}return-1}function f(l,_,L){const O=[];let X=0;for(const c1 of l.matchAll(_)){if(O.push(l.slice(X,c1.index)),c1.index===void 0)throw new Error("match.index should be defined");X=c1.index+c1[0].length,O.push(L(c1[0],...c1.slice(1),c1.index,l,c1.groups))}return O.push(l.slice(X)),Promise.all(O).then(c1=>c1.join(""))}function u(l,_){return l<_?-1:l>_?1:0}function h(l,_,L=0,O=l.length,X=0,c1=_.length){for(;L<O&&X<c1;L++,X++){const T1=l.charCodeAt(L),O1=_.charCodeAt(X);if(T1<O1)return-1;if(T1>O1)return 1}const A1=O-L,M1=c1-X;return A1<M1?-1:A1>M1?1:0}function E(l,_){return c(l,_,0,l.length,0,_.length)}function c(l,_,L=0,O=l.length,X=0,c1=_.length){for(;L<O&&X<c1;L++,X++){let T1=l.charCodeAt(L),O1=_.charCodeAt(X);if(T1===O1)continue;if(T1>=128||O1>=128)return h(l.toLowerCase(),_.toLowerCase(),L,O,X,c1);P(T1)&&(T1-=32),P(O1)&&(O1-=32);const L1=T1-O1;if(L1!==0)return L1}const A1=O-L,M1=c1-X;return A1<M1?-1:A1>M1?1:0}function D(l){return l>=e.CharCode.Digit0&&l<=e.CharCode.Digit9}function P(l){return l>=e.CharCode.a&&l<=e.CharCode.z}function M(l){return l>=e.CharCode.A&&l<=e.CharCode.Z}function R(l,_){return l.length===_.length&&c(l,_)===0}function K(l,_){const L=_.length;return _.length>l.length?!1:c(l,_,0,L)===0}function i1(l,_){const L=Math.min(l.length,_.length);let O;for(O=0;O<L;O++)if(l.charCodeAt(O)!==_.charCodeAt(O))return O;return L}function x(l,_){const L=Math.min(l.length,_.length);let O;const X=l.length-1,c1=_.length-1;for(O=0;O<L;O++)if(l.charCodeAt(X-O)!==_.charCodeAt(c1-O))return O;return L}function s1(l){return 55296<=l&&l<=56319}function u1(l){return 56320<=l&&l<=57343}function J(l,_){return(l-55296<<10)+(_-56320)+65536}function o1(l,_,L){const O=l.charCodeAt(L);if(s1(O)&&L+1<_){const X=l.charCodeAt(L+1);if(u1(X))return J(O,X)}return O}function _1(l,_){const L=l.charCodeAt(_-1);if(u1(L)&&_>1){const O=l.charCodeAt(_-2);if(s1(O))return J(O,L)}return L}class p1{get offset(){return this._offset}constructor(_,L=0){this._str=_,this._len=_.length,this._offset=L}setOffset(_){this._offset=_}prevCodePoint(){const _=_1(this._str,this._offset);return this._offset-=_>=U.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,_}nextCodePoint(){const _=o1(this._str,this._len,this._offset);return this._offset+=_>=U.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,_}eol(){return this._offset>=this._len}}t.CodePointIterator=p1;class R1{get offset(){return this._iterator.offset}constructor(_,L=0){this._iterator=new p1(_,L)}nextGraphemeLength(){const _=w1.getInstance(),L=this._iterator,O=L.offset;let X=_.getGraphemeBreakType(L.nextCodePoint());for(;!L.eol();){const c1=L.offset,A1=_.getGraphemeBreakType(L.nextCodePoint());if(b1(X,A1)){L.setOffset(c1);break}X=A1}return L.offset-O}prevGraphemeLength(){const _=w1.getInstance(),L=this._iterator,O=L.offset;let X=_.getGraphemeBreakType(L.prevCodePoint());for(;L.offset>0;){const c1=L.offset,A1=_.getGraphemeBreakType(L.prevCodePoint());if(b1(A1,X)){L.setOffset(c1);break}X=A1}return O-L.offset}eol(){return this._iterator.eol()}}t.GraphemeIterator=R1;function I1(l,_){return new R1(l,_).nextGraphemeLength()}function y1(l,_){return new R1(l,_).prevGraphemeLength()}function G1(l,_){_>0&&u1(l.charCodeAt(_))&&_--;const L=_+I1(l,_);return[L-y1(l,L),L]}function $1(l){const _=new R1(l);let L=0;for(;!_.eol();)L++,_.nextGraphemeLength();return L}let D1;function F1(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function j1(l){return D1||(D1=F1()),D1.test(l)}const d=/^[\t\n\r\x20-\x7E]*$/;function A(l){return d.test(l)}t.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function b(l){return t.UNUSUAL_LINE_TERMINATORS.test(l)}function T(l){return l>=11904&&l<=55215||l>=63744&&l<=64255||l>=65281&&l<=65374}function k(l){return l>=127462&&l<=127487||l===8986||l===8987||l===9200||l===9203||l>=9728&&l<=10175||l===11088||l===11093||l>=127744&&l<=128591||l>=128640&&l<=128764||l>=128992&&l<=129008||l>=129280&&l<=129535||l>=129648&&l<=129782}function n1(l,_,L=""){const O=l.trimStart();if(O.length<_)return O;const X=/\b/g;let c1=0;for(;X.test(O)&&!(O.length-X.lastIndex<_);)c1=X.lastIndex,X.lastIndex+=1;return c1===0?O:L+O.substring(c1).trimStart()}const a1=/(?:(?:\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~])|(:?\x1b\].*?\x07)/g;function*m1(l){let _=0;for(const L of l.matchAll(a1))_!==L.index&&(yield{isCode:!1,str:l.substring(_,L.index)}),yield{isCode:!0,str:L[0]},_=L.index+L[0].length;_!==l.length&&(yield{isCode:!1,str:l.substring(_)})}function E1(l){return l&&(l=l.replace(a1,"")),l}const v1=/\\\[.*?\\\]/g;function U1(l){return E1(l).replace(v1,"")}t.UTF8_BOM_CHARACTER=String.fromCharCode(e.CharCode.UTF8_BOM);function V(l){return!!(l&&l.length>0&&l.charCodeAt(0)===e.CharCode.UTF8_BOM)}function B(l){return V(l)?l.substr(1):l}function Q(l,_){if(!l||!_||l.length<_.length)return!1;const L=_.length,O=l.toLowerCase();let X=0,c1=-1;for(;X<L;){const A1=O.indexOf(_[X],c1+1);if(A1<0)return!1;c1=A1,X++}return!0}function z(l,_=!1){return l?(_&&(l=l.replace(/\\./g,"")),l.toLowerCase()!==l):!1}function Z(l){return l.charAt(0).toUpperCase()+l.slice(1)}function l1(l,_=1){if(_===0)return"";let L=-1;do L=l.indexOf(`
`,L+1),_--;while(_>0&&L>=0);return L===-1?l:(l[L-1]==="\r"&&L--,l.substr(0,L))}function f1(l){const _=e.CharCode.Z-e.CharCode.A+1;return l=l%(2*_),l<_?String.fromCharCode(e.CharCode.a+l):String.fromCharCode(e.CharCode.A+l-_)}function g1(l){return w1.getInstance().getGraphemeBreakType(l)}function b1(l,_){return l===r1.Other?_!==r1.Extend&&_!==r1.SpacingMark:l===r1.CR&&_===r1.LF?!1:l===r1.Control||l===r1.CR||l===r1.LF||_===r1.Control||_===r1.CR||_===r1.LF?!0:!(l===r1.L&&(_===r1.L||_===r1.V||_===r1.LV||_===r1.LVT)||(l===r1.LV||l===r1.V)&&(_===r1.V||_===r1.T)||(l===r1.LVT||l===r1.T)&&_===r1.T||_===r1.Extend||_===r1.ZWJ||_===r1.SpacingMark||l===r1.Prepend||l===r1.ZWJ&&_===r1.Extended_Pictographic||l===r1.Regional_Indicator&&_===r1.Regional_Indicator)}var r1;(function(l){l[l.Other=0]="Other",l[l.Prepend=1]="Prepend",l[l.CR=2]="CR",l[l.LF=3]="LF",l[l.Control=4]="Control",l[l.Extend=5]="Extend",l[l.Regional_Indicator=6]="Regional_Indicator",l[l.SpacingMark=7]="SpacingMark",l[l.L=8]="L",l[l.V=9]="V",l[l.T=10]="T",l[l.LV=11]="LV",l[l.LVT=12]="LVT",l[l.ZWJ=13]="ZWJ",l[l.Extended_Pictographic=14]="Extended_Pictographic"})(r1||(t.GraphemeBreakType=r1={}));class w1{static{this._INSTANCE=null}static getInstance(){return w1._INSTANCE||(w1._INSTANCE=new w1),w1._INSTANCE}constructor(){this._data=P1()}getGraphemeBreakType(_){if(_<32)return _===e.CharCode.LineFeed?r1.LF:_===e.CharCode.CarriageReturn?r1.CR:r1.Control;if(_<127)return r1.Other;const L=this._data,O=L.length/3;let X=1;for(;X<=O;)if(_<L[3*X])X=2*X;else if(_>L[3*X+1])X=2*X+1;else return L[3*X+2];return r1.Other}}function P1(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function K1(l,_){if(l===0)return 0;const L=W1(l,_);if(L!==void 0)return L;const O=new p1(_,l);return O.prevCodePoint(),O.offset}function W1(l,_){const L=new p1(_,l);let O=L.prevCodePoint();for(;V1(O)||O===B1.emojiVariantSelector||O===B1.enclosingKeyCap;){if(L.offset===0)return;O=L.prevCodePoint()}if(!k(O))return;let X=L.offset;return X>0&&L.prevCodePoint()===B1.zwj&&(X=L.offset),X}function V1(l){return 127995<=l&&l<=127999}var B1;(function(l){l[l.zwj=8205]="zwj",l[l.emojiVariantSelector=65039]="emojiVariantSelector",l[l.enclosingKeyCap=8419]="enclosingKeyCap"})(B1||(B1={})),t.noBreakWhitespace="\xA0";class q1{static{this.ambiguousCharacterData=new W.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.cache=new m.LRUCachedFunction({getCacheKey:JSON.stringify},_=>{function L(L1){const N1=new Map;for(let S1=0;S1<L1.length;S1+=2)N1.set(L1[S1],L1[S1+1]);return N1}function O(L1,N1){const S1=new Map(L1);for(const[z1,Q1]of N1)S1.set(z1,Q1);return S1}function X(L1,N1){if(!L1)return N1;const S1=new Map;for(const[z1,Q1]of L1)N1.has(z1)&&S1.set(z1,Q1);return S1}const c1=this.ambiguousCharacterData.value;let A1=_.filter(L1=>!L1.startsWith("_")&&L1 in c1);A1.length===0&&(A1=["_default"]);let M1;for(const L1 of A1){const N1=L(c1[L1]);M1=X(M1,N1)}const T1=L(c1._common),O1=O(T1,M1);return new q1(O1)})}static getInstance(_){return q1.cache.get(Array.from(_))}static{this._locales=new W.Lazy(()=>Object.keys(q1.ambiguousCharacterData.value).filter(_=>!_.startsWith("_")))}static getLocales(){return q1._locales.value}constructor(_){this.confusableDictionary=_}isAmbiguous(_){return this.confusableDictionary.has(_)}containsAmbiguousCharacter(_){for(let L=0;L<_.length;L++){const O=_.codePointAt(L);if(typeof O=="number"&&this.isAmbiguous(O))return!0}return!1}getPrimaryConfusable(_){return this.confusableDictionary.get(_)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}t.AmbiguousCharacters=q1;class H1{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this._data=void 0}static getData(){return this._data||(this._data=new Set(H1.getRawData())),this._data}static isInvisibleCharacter(_){return H1.getData().has(_)}static containsInvisibleCharacter(_){for(let L=0;L<_.length;L++){const O=_.codePointAt(L);if(typeof O=="number"&&H1.isInvisibleCharacter(O))return!0}return!1}static get codePoints(){return H1.getData()}}t.InvisibleCharacters=H1}),define(h1[9],d1([0,1]),function(e1,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getNLSMessages=m,t.getNLSLanguage=e;function m(){return globalThis._VSCODE_NLS_MESSAGES}function e(){return globalThis._VSCODE_NLS_LANGUAGE}}),define(h1[23],d1([0,1,9,9]),function(e1,t,m,e){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getNLSMessages=t.getNLSLanguage=void 0,t.localize=t1,t.localize2=S,Object.defineProperty(t,"getNLSLanguage",{enumerable:!0,get:function(){return e.getNLSLanguage}}),Object.defineProperty(t,"getNLSMessages",{enumerable:!0,get:function(){return e.getNLSMessages}});const W=(0,m.getNLSLanguage)()==="pseudo"||typeof document<"u"&&document.location&&document.location.hash.indexOf("pseudo=true")>=0;function U(I,N){let j;return N.length===0?j=I:j=I.replace(/\{(\d+)\}/g,(y,Y)=>{const p=Y[0],v=N[p];let w=y;return typeof v=="string"?w=v:(typeof v=="number"||typeof v=="boolean"||v===void 0||v===null)&&(w=String(v)),w}),W&&(j="\uFF3B"+j.replace(/[aouei]/g,"$&$&")+"\uFF3D"),j}function t1(I,N,...j){return U(typeof I=="number"?$(I,N):N,j)}function $(I,N){const j=(0,m.getNLSMessages)()?.[I];if(typeof j!="string"){if(typeof N=="string")return N;throw new Error(`!!! NLS MISSING: ${I} !!!`)}return j}function S(I,N,...j){let y;typeof I=="number"?y=$(I,N):y=N;const Y=U(y,j);return{value:Y,original:N===y?Y:U(N,j)}}});var X1=this&&this.__createBinding||(Object.create?function(e1,t,m,e){e===void 0&&(e=m);var W=Object.getOwnPropertyDescriptor(t,m);(!W||("get"in W?!t.__esModule:W.writable||W.configurable))&&(W={enumerable:!0,get:function(){return t[m]}}),Object.defineProperty(e1,e,W)}:function(e1,t,m,e){e===void 0&&(e=m),e1[e]=t[m]}),Y1=this&&this.__setModuleDefault||(Object.create?function(e1,t){Object.defineProperty(e1,"default",{enumerable:!0,value:t})}:function(e1,t){e1.default=t}),k1=this&&this.__importStar||function(e1){if(e1&&e1.__esModule)return e1;var t={};if(e1!=null)for(var m in e1)m!=="default"&&Object.prototype.hasOwnProperty.call(e1,m)&&X1(t,e1,m);return Y1(t,e1),t};define(h1[3],d1([0,1,23]),function(e1,t,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isAndroid=t.isEdge=t.isSafari=t.isFirefox=t.isChrome=t.OS=t.OperatingSystem=t.setTimeout0=t.setTimeout0IsFaster=t.translationsConfigFile=t.platformLocale=t.locale=t.Language=t.language=t.userAgent=t.platform=t.isCI=t.isMobile=t.isIOS=t.webWorkerOrigin=t.isWebWorker=t.isWeb=t.isElectron=t.isNative=t.isLinuxSnap=t.isLinux=t.isMacintosh=t.isWindows=t.Platform=t.LANGUAGE_DEFAULT=void 0,t.PlatformToString=n,t.isLittleEndian=f,t.isBigSurOrNewer=u,m=k1(m),t.LANGUAGE_DEFAULT="en";let e=!1,W=!1,U=!1,t1=!1,$=!1,S=!1,I=!1,N=!1,j=!1,y=!1,Y,p=t.LANGUAGE_DEFAULT,v=t.LANGUAGE_DEFAULT,w,F;const q=globalThis;let H;typeof q.vscode<"u"&&typeof q.vscode.process<"u"?H=q.vscode.process:typeof process<"u"&&typeof process?.versions?.node=="string"&&(H=process);const C=typeof H?.versions?.electron=="string",G=C&&H?.type==="renderer";if(typeof H=="object"){e=H.platform==="win32",W=H.platform==="darwin",U=H.platform==="linux",t1=U&&!!H.env.SNAP&&!!H.env.SNAP_REVISION,I=C,j=!!H.env.CI||!!H.env.BUILD_ARTIFACTSTAGINGDIRECTORY,Y=t.LANGUAGE_DEFAULT,p=t.LANGUAGE_DEFAULT;const h=H.env.VSCODE_NLS_CONFIG;if(h)try{const E=JSON.parse(h);Y=E.userLocale,v=E.osLocale,p=E.resolvedLanguage||t.LANGUAGE_DEFAULT,w=E.languagePack?.translationsConfigFile}catch{}$=!0}else typeof navigator=="object"&&!G?(F=navigator.userAgent,e=F.indexOf("Windows")>=0,W=F.indexOf("Macintosh")>=0,N=(F.indexOf("Macintosh")>=0||F.indexOf("iPad")>=0||F.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,U=F.indexOf("Linux")>=0,y=F?.indexOf("Mobi")>=0,S=!0,p=m.getNLSLanguage()||t.LANGUAGE_DEFAULT,Y=navigator.language.toLowerCase(),v=Y):console.error("Unable to resolve platform.");var o;(function(h){h[h.Web=0]="Web",h[h.Mac=1]="Mac",h[h.Linux=2]="Linux",h[h.Windows=3]="Windows"})(o||(t.Platform=o={}));function n(h){switch(h){case o.Web:return"Web";case o.Mac:return"Mac";case o.Linux:return"Linux";case o.Windows:return"Windows"}}let i=o.Web;W?i=o.Mac:e?i=o.Windows:U&&(i=o.Linux),t.isWindows=e,t.isMacintosh=W,t.isLinux=U,t.isLinuxSnap=t1,t.isNative=$,t.isElectron=I,t.isWeb=S,t.isWebWorker=S&&typeof q.importScripts=="function",t.webWorkerOrigin=t.isWebWorker?q.origin:void 0,t.isIOS=N,t.isMobile=y,t.isCI=j,t.platform=i,t.userAgent=F,t.language=p;var a;(function(h){function E(){return t.language}h.value=E;function c(){return t.language.length===2?t.language==="en":t.language.length>=3?t.language[0]==="e"&&t.language[1]==="n"&&t.language[2]==="-":!1}h.isDefaultVariant=c;function D(){return t.language==="en"}h.isDefault=D})(a||(t.Language=a={})),t.locale=Y,t.platformLocale=v,t.translationsConfigFile=w,t.setTimeout0IsFaster=typeof q.postMessage=="function"&&!q.importScripts,t.setTimeout0=(()=>{if(t.setTimeout0IsFaster){const h=[];q.addEventListener("message",c=>{if(c.data&&c.data.vscodeScheduleAsyncWork)for(let D=0,P=h.length;D<P;D++){const M=h[D];if(M.id===c.data.vscodeScheduleAsyncWork){h.splice(D,1),M.callback();return}}});let E=0;return c=>{const D=++E;h.push({id:D,callback:c}),q.postMessage({vscodeScheduleAsyncWork:D},"*")}}return h=>setTimeout(h)})();var g;(function(h){h[h.Windows=1]="Windows",h[h.Macintosh=2]="Macintosh",h[h.Linux=3]="Linux"})(g||(t.OperatingSystem=g={})),t.OS=W||N?g.Macintosh:e?g.Windows:g.Linux;let s=!0,r=!1;function f(){if(!r){r=!0;const h=new Uint8Array(2);h[0]=1,h[1]=2,s=new Uint16Array(h.buffer)[0]===513}return s}t.isChrome=!!(t.userAgent&&t.userAgent.indexOf("Chrome")>=0),t.isFirefox=!!(t.userAgent&&t.userAgent.indexOf("Firefox")>=0),t.isSafari=!!(!t.isChrome&&t.userAgent&&t.userAgent.indexOf("Safari")>=0),t.isEdge=!!(t.userAgent&&t.userAgent.indexOf("Edg/")>=0),t.isAndroid=!!(t.userAgent&&t.userAgent.indexOf("Android")>=0);function u(h){return parseFloat(h)>=20}}),define(h1[24],d1([0,1,3]),function(e1,t,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.arch=t.platform=t.env=t.cwd=void 0;let e;const W=globalThis.vscode;if(typeof W<"u"&&typeof W.process<"u"){const U=W.process;e={get platform(){return U.platform},get arch(){return U.arch},get env(){return U.env},cwd(){return U.cwd()}}}else typeof process<"u"&&typeof process?.versions?.node=="string"?e={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:e={get platform(){return m.isWindows?"win32":m.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};t.cwd=e.cwd,t.env=e.env,t.platform=e.platform,t.arch=e.arch}),define(h1[10],d1([0,1,24]),function(e1,t,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.delimiter=t.sep=t.toNamespacedPath=t.parse=t.format=t.extname=t.basename=t.dirname=t.relative=t.resolve=t.join=t.isAbsolute=t.normalize=t.posix=t.win32=void 0,m=k1(m);const e=65,W=97,U=90,t1=122,$=46,S=47,I=92,N=58,j=63;class y extends Error{constructor(i,a,g){let s;typeof a=="string"&&a.indexOf("not ")===0?(s="must not be",a=a.replace(/^not /,"")):s="must be";const r=i.indexOf(".")!==-1?"property":"argument";let f=`The "${i}" ${r} ${s} of type ${a}`;f+=`. Received type ${typeof g}`,super(f),this.code="ERR_INVALID_ARG_TYPE"}}function Y(n,i){if(n===null||typeof n!="object")throw new y(i,"Object",n)}function p(n,i){if(typeof n!="string")throw new y(i,"string",n)}const v=m.platform==="win32";function w(n){return n===S||n===I}function F(n){return n===S}function q(n){return n>=e&&n<=U||n>=W&&n<=t1}function H(n,i,a,g){let s="",r=0,f=-1,u=0,h=0;for(let E=0;E<=n.length;++E){if(E<n.length)h=n.charCodeAt(E);else{if(g(h))break;h=S}if(g(h)){if(!(f===E-1||u===1))if(u===2){if(s.length<2||r!==2||s.charCodeAt(s.length-1)!==$||s.charCodeAt(s.length-2)!==$){if(s.length>2){const c=s.lastIndexOf(a);c===-1?(s="",r=0):(s=s.slice(0,c),r=s.length-1-s.lastIndexOf(a)),f=E,u=0;continue}else if(s.length!==0){s="",r=0,f=E,u=0;continue}}i&&(s+=s.length>0?`${a}..`:"..",r=2)}else s.length>0?s+=`${a}${n.slice(f+1,E)}`:s=n.slice(f+1,E),r=E-f-1;f=E,u=0}else h===$&&u!==-1?++u:u=-1}return s}function C(n){return n?`${n[0]==="."?"":"."}${n}`:""}function G(n,i){Y(i,"pathObject");const a=i.dir||i.root,g=i.base||`${i.name||""}${C(i.ext)}`;return a?a===i.root?`${a}${g}`:`${a}${n}${g}`:g}t.win32={resolve(...n){let i="",a="",g=!1;for(let s=n.length-1;s>=-1;s--){let r;if(s>=0){if(r=n[s],p(r,`paths[${s}]`),r.length===0)continue}else i.length===0?r=m.cwd():(r=m.env[`=${i}`]||m.cwd(),(r===void 0||r.slice(0,2).toLowerCase()!==i.toLowerCase()&&r.charCodeAt(2)===I)&&(r=`${i}\\`));const f=r.length;let u=0,h="",E=!1;const c=r.charCodeAt(0);if(f===1)w(c)&&(u=1,E=!0);else if(w(c))if(E=!0,w(r.charCodeAt(1))){let D=2,P=D;for(;D<f&&!w(r.charCodeAt(D));)D++;if(D<f&&D!==P){const M=r.slice(P,D);for(P=D;D<f&&w(r.charCodeAt(D));)D++;if(D<f&&D!==P){for(P=D;D<f&&!w(r.charCodeAt(D));)D++;(D===f||D!==P)&&(h=`\\\\${M}\\${r.slice(P,D)}`,u=D)}}}else u=1;else q(c)&&r.charCodeAt(1)===N&&(h=r.slice(0,2),u=2,f>2&&w(r.charCodeAt(2))&&(E=!0,u=3));if(h.length>0)if(i.length>0){if(h.toLowerCase()!==i.toLowerCase())continue}else i=h;if(g){if(i.length>0)break}else if(a=`${r.slice(u)}\\${a}`,g=E,E&&i.length>0)break}return a=H(a,!g,"\\",w),g?`${i}\\${a}`:`${i}${a}`||"."},normalize(n){p(n,"path");const i=n.length;if(i===0)return".";let a=0,g,s=!1;const r=n.charCodeAt(0);if(i===1)return F(r)?"\\":n;if(w(r))if(s=!0,w(n.charCodeAt(1))){let u=2,h=u;for(;u<i&&!w(n.charCodeAt(u));)u++;if(u<i&&u!==h){const E=n.slice(h,u);for(h=u;u<i&&w(n.charCodeAt(u));)u++;if(u<i&&u!==h){for(h=u;u<i&&!w(n.charCodeAt(u));)u++;if(u===i)return`\\\\${E}\\${n.slice(h)}\\`;u!==h&&(g=`\\\\${E}\\${n.slice(h,u)}`,a=u)}}}else a=1;else q(r)&&n.charCodeAt(1)===N&&(g=n.slice(0,2),a=2,i>2&&w(n.charCodeAt(2))&&(s=!0,a=3));let f=a<i?H(n.slice(a),!s,"\\",w):"";return f.length===0&&!s&&(f="."),f.length>0&&w(n.charCodeAt(i-1))&&(f+="\\"),g===void 0?s?`\\${f}`:f:s?`${g}\\${f}`:`${g}${f}`},isAbsolute(n){p(n,"path");const i=n.length;if(i===0)return!1;const a=n.charCodeAt(0);return w(a)||i>2&&q(a)&&n.charCodeAt(1)===N&&w(n.charCodeAt(2))},join(...n){if(n.length===0)return".";let i,a;for(let r=0;r<n.length;++r){const f=n[r];p(f,"path"),f.length>0&&(i===void 0?i=a=f:i+=`\\${f}`)}if(i===void 0)return".";let g=!0,s=0;if(typeof a=="string"&&w(a.charCodeAt(0))){++s;const r=a.length;r>1&&w(a.charCodeAt(1))&&(++s,r>2&&(w(a.charCodeAt(2))?++s:g=!1))}if(g){for(;s<i.length&&w(i.charCodeAt(s));)s++;s>=2&&(i=`\\${i.slice(s)}`)}return t.win32.normalize(i)},relative(n,i){if(p(n,"from"),p(i,"to"),n===i)return"";const a=t.win32.resolve(n),g=t.win32.resolve(i);if(a===g||(n=a.toLowerCase(),i=g.toLowerCase(),n===i))return"";let s=0;for(;s<n.length&&n.charCodeAt(s)===I;)s++;let r=n.length;for(;r-1>s&&n.charCodeAt(r-1)===I;)r--;const f=r-s;let u=0;for(;u<i.length&&i.charCodeAt(u)===I;)u++;let h=i.length;for(;h-1>u&&i.charCodeAt(h-1)===I;)h--;const E=h-u,c=f<E?f:E;let D=-1,P=0;for(;P<c;P++){const R=n.charCodeAt(s+P);if(R!==i.charCodeAt(u+P))break;R===I&&(D=P)}if(P!==c){if(D===-1)return g}else{if(E>c){if(i.charCodeAt(u+P)===I)return g.slice(u+P+1);if(P===2)return g.slice(u+P)}f>c&&(n.charCodeAt(s+P)===I?D=P:P===2&&(D=3)),D===-1&&(D=0)}let M="";for(P=s+D+1;P<=r;++P)(P===r||n.charCodeAt(P)===I)&&(M+=M.length===0?"..":"\\..");return u+=D,M.length>0?`${M}${g.slice(u,h)}`:(g.charCodeAt(u)===I&&++u,g.slice(u,h))},toNamespacedPath(n){if(typeof n!="string"||n.length===0)return n;const i=t.win32.resolve(n);if(i.length<=2)return n;if(i.charCodeAt(0)===I){if(i.charCodeAt(1)===I){const a=i.charCodeAt(2);if(a!==j&&a!==$)return`\\\\?\\UNC\\${i.slice(2)}`}}else if(q(i.charCodeAt(0))&&i.charCodeAt(1)===N&&i.charCodeAt(2)===I)return`\\\\?\\${i}`;return n},dirname(n){p(n,"path");const i=n.length;if(i===0)return".";let a=-1,g=0;const s=n.charCodeAt(0);if(i===1)return w(s)?n:".";if(w(s)){if(a=g=1,w(n.charCodeAt(1))){let u=2,h=u;for(;u<i&&!w(n.charCodeAt(u));)u++;if(u<i&&u!==h){for(h=u;u<i&&w(n.charCodeAt(u));)u++;if(u<i&&u!==h){for(h=u;u<i&&!w(n.charCodeAt(u));)u++;if(u===i)return n;u!==h&&(a=g=u+1)}}}}else q(s)&&n.charCodeAt(1)===N&&(a=i>2&&w(n.charCodeAt(2))?3:2,g=a);let r=-1,f=!0;for(let u=i-1;u>=g;--u)if(w(n.charCodeAt(u))){if(!f){r=u;break}}else f=!1;if(r===-1){if(a===-1)return".";r=a}return n.slice(0,r)},basename(n,i){i!==void 0&&p(i,"suffix"),p(n,"path");let a=0,g=-1,s=!0,r;if(n.length>=2&&q(n.charCodeAt(0))&&n.charCodeAt(1)===N&&(a=2),i!==void 0&&i.length>0&&i.length<=n.length){if(i===n)return"";let f=i.length-1,u=-1;for(r=n.length-1;r>=a;--r){const h=n.charCodeAt(r);if(w(h)){if(!s){a=r+1;break}}else u===-1&&(s=!1,u=r+1),f>=0&&(h===i.charCodeAt(f)?--f===-1&&(g=r):(f=-1,g=u))}return a===g?g=u:g===-1&&(g=n.length),n.slice(a,g)}for(r=n.length-1;r>=a;--r)if(w(n.charCodeAt(r))){if(!s){a=r+1;break}}else g===-1&&(s=!1,g=r+1);return g===-1?"":n.slice(a,g)},extname(n){p(n,"path");let i=0,a=-1,g=0,s=-1,r=!0,f=0;n.length>=2&&n.charCodeAt(1)===N&&q(n.charCodeAt(0))&&(i=g=2);for(let u=n.length-1;u>=i;--u){const h=n.charCodeAt(u);if(w(h)){if(!r){g=u+1;break}continue}s===-1&&(r=!1,s=u+1),h===$?a===-1?a=u:f!==1&&(f=1):a!==-1&&(f=-1)}return a===-1||s===-1||f===0||f===1&&a===s-1&&a===g+1?"":n.slice(a,s)},format:G.bind(null,"\\"),parse(n){p(n,"path");const i={root:"",dir:"",base:"",ext:"",name:""};if(n.length===0)return i;const a=n.length;let g=0,s=n.charCodeAt(0);if(a===1)return w(s)?(i.root=i.dir=n,i):(i.base=i.name=n,i);if(w(s)){if(g=1,w(n.charCodeAt(1))){let D=2,P=D;for(;D<a&&!w(n.charCodeAt(D));)D++;if(D<a&&D!==P){for(P=D;D<a&&w(n.charCodeAt(D));)D++;if(D<a&&D!==P){for(P=D;D<a&&!w(n.charCodeAt(D));)D++;D===a?g=D:D!==P&&(g=D+1)}}}}else if(q(s)&&n.charCodeAt(1)===N){if(a<=2)return i.root=i.dir=n,i;if(g=2,w(n.charCodeAt(2))){if(a===3)return i.root=i.dir=n,i;g=3}}g>0&&(i.root=n.slice(0,g));let r=-1,f=g,u=-1,h=!0,E=n.length-1,c=0;for(;E>=g;--E){if(s=n.charCodeAt(E),w(s)){if(!h){f=E+1;break}continue}u===-1&&(h=!1,u=E+1),s===$?r===-1?r=E:c!==1&&(c=1):r!==-1&&(c=-1)}return u!==-1&&(r===-1||c===0||c===1&&r===u-1&&r===f+1?i.base=i.name=n.slice(f,u):(i.name=n.slice(f,r),i.base=n.slice(f,u),i.ext=n.slice(r,u))),f>0&&f!==g?i.dir=n.slice(0,f-1):i.dir=i.root,i},sep:"\\",delimiter:";",win32:null,posix:null};const o=(()=>{if(v){const n=/\\/g;return()=>{const i=m.cwd().replace(n,"/");return i.slice(i.indexOf("/"))}}return()=>m.cwd()})();t.posix={resolve(...n){let i="",a=!1;for(let g=n.length-1;g>=-1&&!a;g--){const s=g>=0?n[g]:o();p(s,`paths[${g}]`),s.length!==0&&(i=`${s}/${i}`,a=s.charCodeAt(0)===S)}return i=H(i,!a,"/",F),a?`/${i}`:i.length>0?i:"."},normalize(n){if(p(n,"path"),n.length===0)return".";const i=n.charCodeAt(0)===S,a=n.charCodeAt(n.length-1)===S;return n=H(n,!i,"/",F),n.length===0?i?"/":a?"./":".":(a&&(n+="/"),i?`/${n}`:n)},isAbsolute(n){return p(n,"path"),n.length>0&&n.charCodeAt(0)===S},join(...n){if(n.length===0)return".";let i;for(let a=0;a<n.length;++a){const g=n[a];p(g,"path"),g.length>0&&(i===void 0?i=g:i+=`/${g}`)}return i===void 0?".":t.posix.normalize(i)},relative(n,i){if(p(n,"from"),p(i,"to"),n===i||(n=t.posix.resolve(n),i=t.posix.resolve(i),n===i))return"";const a=1,g=n.length,s=g-a,r=1,f=i.length-r,u=s<f?s:f;let h=-1,E=0;for(;E<u;E++){const D=n.charCodeAt(a+E);if(D!==i.charCodeAt(r+E))break;D===S&&(h=E)}if(E===u)if(f>u){if(i.charCodeAt(r+E)===S)return i.slice(r+E+1);if(E===0)return i.slice(r+E)}else s>u&&(n.charCodeAt(a+E)===S?h=E:E===0&&(h=0));let c="";for(E=a+h+1;E<=g;++E)(E===g||n.charCodeAt(E)===S)&&(c+=c.length===0?"..":"/..");return`${c}${i.slice(r+h)}`},toNamespacedPath(n){return n},dirname(n){if(p(n,"path"),n.length===0)return".";const i=n.charCodeAt(0)===S;let a=-1,g=!0;for(let s=n.length-1;s>=1;--s)if(n.charCodeAt(s)===S){if(!g){a=s;break}}else g=!1;return a===-1?i?"/":".":i&&a===1?"//":n.slice(0,a)},basename(n,i){i!==void 0&&p(i,"ext"),p(n,"path");let a=0,g=-1,s=!0,r;if(i!==void 0&&i.length>0&&i.length<=n.length){if(i===n)return"";let f=i.length-1,u=-1;for(r=n.length-1;r>=0;--r){const h=n.charCodeAt(r);if(h===S){if(!s){a=r+1;break}}else u===-1&&(s=!1,u=r+1),f>=0&&(h===i.charCodeAt(f)?--f===-1&&(g=r):(f=-1,g=u))}return a===g?g=u:g===-1&&(g=n.length),n.slice(a,g)}for(r=n.length-1;r>=0;--r)if(n.charCodeAt(r)===S){if(!s){a=r+1;break}}else g===-1&&(s=!1,g=r+1);return g===-1?"":n.slice(a,g)},extname(n){p(n,"path");let i=-1,a=0,g=-1,s=!0,r=0;for(let f=n.length-1;f>=0;--f){const u=n.charCodeAt(f);if(u===S){if(!s){a=f+1;break}continue}g===-1&&(s=!1,g=f+1),u===$?i===-1?i=f:r!==1&&(r=1):i!==-1&&(r=-1)}return i===-1||g===-1||r===0||r===1&&i===g-1&&i===a+1?"":n.slice(i,g)},format:G.bind(null,"/"),parse(n){p(n,"path");const i={root:"",dir:"",base:"",ext:"",name:""};if(n.length===0)return i;const a=n.charCodeAt(0)===S;let g;a?(i.root="/",g=1):g=0;let s=-1,r=0,f=-1,u=!0,h=n.length-1,E=0;for(;h>=g;--h){const c=n.charCodeAt(h);if(c===S){if(!u){r=h+1;break}continue}f===-1&&(u=!1,f=h+1),c===$?s===-1?s=h:E!==1&&(E=1):s!==-1&&(E=-1)}if(f!==-1){const c=r===0&&a?1:r;s===-1||E===0||E===1&&s===f-1&&s===r+1?i.base=i.name=n.slice(c,f):(i.name=n.slice(c,s),i.base=n.slice(c,f),i.ext=n.slice(s,f))}return r>0?i.dir=n.slice(0,r-1):a&&(i.dir="/"),i},sep:"/",delimiter:":",win32:null,posix:null},t.posix.win32=t.win32.win32=t.win32,t.posix.posix=t.win32.posix=t.posix,t.normalize=v?t.win32.normalize:t.posix.normalize,t.isAbsolute=v?t.win32.isAbsolute:t.posix.isAbsolute,t.join=v?t.win32.join:t.posix.join,t.resolve=v?t.win32.resolve:t.posix.resolve,t.relative=v?t.win32.relative:t.posix.relative,t.dirname=v?t.win32.dirname:t.posix.dirname,t.basename=v?t.win32.basename:t.posix.basename,t.extname=v?t.win32.extname:t.posix.extname,t.format=v?t.win32.format:t.posix.format,t.parse=v?t.win32.parse:t.posix.parse,t.toNamespacedPath=v?t.win32.toNamespacedPath:t.posix.toNamespacedPath,t.sep=v?t.win32.sep:t.posix.sep,t.delimiter=v?t.win32.delimiter:t.posix.delimiter}),define(h1[25],d1([0,1,4,18,10,3]),function(e1,t,m,e,W,U){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.URI=void 0,t.isUriComponents=w,t.uriToFsPath=o,W=k1(W);const t1=/^\w[\w\d+.-]*$/,$=/^\//,S=/^\/\//;function I(s,r){if(!s.scheme&&r)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${s.authority}", path: "${s.path}", query: "${s.query}", fragment: "${s.fragment}"}`);if(s.scheme&&!t1.test(s.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(s.path){if(s.authority){if(!$.test(s.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(S.test(s.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function N(s,r){return!s&&!r?"file":s}function j(s,r){switch(s){case"https":case"http":case"file":r?r[0]!==Y&&(r=Y+r):r=Y;break}return r}const y="",Y="/",p=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class v{static isUri(r){return r instanceof v?!0:r?typeof r.authority=="string"&&typeof r.fragment=="string"&&typeof r.path=="string"&&typeof r.query=="string"&&typeof r.scheme=="string"&&typeof r.fsPath=="string"&&typeof r.with=="function"&&typeof r.toString=="function":!1}constructor(r,f,u,h,E,c=!1){typeof r=="object"?(this.scheme=r.scheme||y,this.authority=r.authority||y,this.path=r.path||y,this.query=r.query||y,this.fragment=r.fragment||y):(this.scheme=N(r,c),this.authority=f||y,this.path=j(this.scheme,u||y),this.query=h||y,this.fragment=E||y,I(this,c))}get fsPath(){return o(this,!1)}with(r){if(!r)return this;let{scheme:f,authority:u,path:h,query:E,fragment:c}=r;return f===void 0?f=this.scheme:f===null&&(f=y),u===void 0?u=this.authority:u===null&&(u=y),h===void 0?h=this.path:h===null&&(h=y),E===void 0?E=this.query:E===null&&(E=y),c===void 0?c=this.fragment:c===null&&(c=y),f===this.scheme&&u===this.authority&&h===this.path&&E===this.query&&c===this.fragment?this:new q(f,u,h,E,c)}static parse(r,f=!1){const u=p.exec(r);return u?new q(u[2]||y,g(u[4]||y),g(u[5]||y),g(u[7]||y),g(u[9]||y),f):new q(y,y,y,y,y)}static file(r){let f=y;if(U.isWindows&&(r=r.replace(/\\/g,Y)),r[0]===Y&&r[1]===Y){const u=r.indexOf(Y,2);u===-1?(f=r.substring(2),r=Y):(f=r.substring(2,u),r=r.substring(u)||Y)}return new q("file",f,r,y,y)}static from(r,f){return new q(r.scheme,r.authority,r.path,r.query,r.fragment,f)}static joinPath(r,...f){if(!r.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let u;return U.isWindows&&r.scheme==="file"?u=v.file(W.win32.join(o(r,!0),...f)).path:u=W.posix.join(r.path,...f),r.with({path:u})}toString(r=!1){return n(this,r)}toJSON(){return this}static revive(r){if(r){if(r instanceof v)return r;{const f=new q(r);return f._formatted=r.external??null,f._fsPath=r._sep===F?r.fsPath??null:null,f}}else return r}[Symbol.for("debug.description")](){return`URI(${this.toString()})`}}t.URI=v;function w(s){return!s||typeof s!="object"?!1:typeof s.scheme=="string"&&(typeof s.authority=="string"||typeof s.authority>"u")&&(typeof s.path=="string"||typeof s.path>"u")&&(typeof s.query=="string"||typeof s.query>"u")&&(typeof s.fragment=="string"||typeof s.fragment>"u")}const F=U.isWindows?1:void 0;class q extends v{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=o(this,!1)),this._fsPath}toString(r=!1){return r?n(this,!0):(this._formatted||(this._formatted=n(this,!1)),this._formatted)}toJSON(){const r={$mid:e.MarshalledId.Uri};return this._fsPath&&(r.fsPath=this._fsPath,r._sep=F),this._formatted&&(r.external=this._formatted),this.path&&(r.path=this.path),this.scheme&&(r.scheme=this.scheme),this.authority&&(r.authority=this.authority),this.query&&(r.query=this.query),this.fragment&&(r.fragment=this.fragment),r}}const H={[m.CharCode.Colon]:"%3A",[m.CharCode.Slash]:"%2F",[m.CharCode.QuestionMark]:"%3F",[m.CharCode.Hash]:"%23",[m.CharCode.OpenSquareBracket]:"%5B",[m.CharCode.CloseSquareBracket]:"%5D",[m.CharCode.AtSign]:"%40",[m.CharCode.ExclamationMark]:"%21",[m.CharCode.DollarSign]:"%24",[m.CharCode.Ampersand]:"%26",[m.CharCode.SingleQuote]:"%27",[m.CharCode.OpenParen]:"%28",[m.CharCode.CloseParen]:"%29",[m.CharCode.Asterisk]:"%2A",[m.CharCode.Plus]:"%2B",[m.CharCode.Comma]:"%2C",[m.CharCode.Semicolon]:"%3B",[m.CharCode.Equals]:"%3D",[m.CharCode.Space]:"%20"};function C(s,r,f){let u,h=-1;for(let E=0;E<s.length;E++){const c=s.charCodeAt(E);if(c>=m.CharCode.a&&c<=m.CharCode.z||c>=m.CharCode.A&&c<=m.CharCode.Z||c>=m.CharCode.Digit0&&c<=m.CharCode.Digit9||c===m.CharCode.Dash||c===m.CharCode.Period||c===m.CharCode.Underline||c===m.CharCode.Tilde||r&&c===m.CharCode.Slash||f&&c===m.CharCode.OpenSquareBracket||f&&c===m.CharCode.CloseSquareBracket||f&&c===m.CharCode.Colon)h!==-1&&(u+=encodeURIComponent(s.substring(h,E)),h=-1),u!==void 0&&(u+=s.charAt(E));else{u===void 0&&(u=s.substr(0,E));const D=H[c];D!==void 0?(h!==-1&&(u+=encodeURIComponent(s.substring(h,E)),h=-1),u+=D):h===-1&&(h=E)}}return h!==-1&&(u+=encodeURIComponent(s.substring(h))),u!==void 0?u:s}function G(s){let r;for(let f=0;f<s.length;f++){const u=s.charCodeAt(f);u===m.CharCode.Hash||u===m.CharCode.QuestionMark?(r===void 0&&(r=s.substr(0,f)),r+=H[u]):r!==void 0&&(r+=s[f])}return r!==void 0?r:s}function o(s,r){let f;return s.authority&&s.path.length>1&&s.scheme==="file"?f=`//${s.authority}${s.path}`:s.path.charCodeAt(0)===m.CharCode.Slash&&(s.path.charCodeAt(1)>=m.CharCode.A&&s.path.charCodeAt(1)<=m.CharCode.Z||s.path.charCodeAt(1)>=m.CharCode.a&&s.path.charCodeAt(1)<=m.CharCode.z)&&s.path.charCodeAt(2)===m.CharCode.Colon?r?f=s.path.substr(1):f=s.path[1].toLowerCase()+s.path.substr(2):f=s.path,U.isWindows&&(f=f.replace(/\//g,"\\")),f}function n(s,r){const f=r?G:C;let u="",{scheme:h,authority:E,path:c,query:D,fragment:P}=s;if(h&&(u+=h,u+=":"),(E||h==="file")&&(u+=Y,u+=Y),E){let M=E.indexOf("@");if(M!==-1){const R=E.substr(0,M);E=E.substr(M+1),M=R.lastIndexOf(":"),M===-1?u+=f(R,!1,!1):(u+=f(R.substr(0,M),!1,!1),u+=":",u+=f(R.substr(M+1),!1,!0)),u+="@"}E=E.toLowerCase(),M=E.lastIndexOf(":"),M===-1?u+=f(E,!1,!0):(u+=f(E.substr(0,M),!1,!0),u+=E.substr(M))}if(c){if(c.length>=3&&c.charCodeAt(0)===m.CharCode.Slash&&c.charCodeAt(2)===m.CharCode.Colon){const M=c.charCodeAt(1);M>=m.CharCode.A&&M<=m.CharCode.Z&&(c=`/${String.fromCharCode(M+32)}:${c.substr(3)}`)}else if(c.length>=2&&c.charCodeAt(1)===m.CharCode.Colon){const M=c.charCodeAt(0);M>=m.CharCode.A&&M<=m.CharCode.Z&&(c=`${String.fromCharCode(M+32)}:${c.substr(2)}`)}u+=f(c,!0,!1)}return D&&(u+="?",u+=f(D,!1,!1)),P&&(u+="#",u+=r?P:C(P,!1,!1)),u}function i(s){try{return decodeURIComponent(s)}catch{return s.length>3?s.substr(0,3)+i(s.substr(3)):s}}const a=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function g(s){return s.match(a)?s.replace(a,r=>i(r)):s}}),define(h1[26],d1([0,1,2,3,8,25,10]),function(e1,t,m,e,W,U,t1){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.COI=t.FileAccess=t.VSCODE_AUTHORITY=t.nodeModulesAsarUnpackedPath=t.nodeModulesAsarPath=t.nodeModulesPath=t.builtinExtensionsPath=t.RemoteAuthorities=t.connectionTokenQueryName=t.connectionTokenCookieName=t.Schemas=void 0,t.matchesScheme=S,t.matchesSomeScheme=I,t.getServerRootPath=j,m=k1(m),e=k1(e),t1=k1(t1);var $;(function(p){p.inMemory="inmemory",p.vscode="vscode",p.internal="private",p.walkThrough="walkThrough",p.walkThroughSnippet="walkThroughSnippet",p.http="http",p.https="https",p.file="file",p.mailto="mailto",p.untitled="untitled",p.data="data",p.command="command",p.vscodeRemote="vscode-remote",p.vscodeRemoteResource="vscode-remote-resource",p.vscodeManagedRemoteResource="vscode-managed-remote-resource",p.vscodeUserData="vscode-userdata",p.vscodeCustomEditor="vscode-custom-editor",p.vscodeNotebookCell="vscode-notebook-cell",p.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",p.vscodeNotebookCellMetadataDiff="vscode-notebook-cell-metadata-diff",p.vscodeNotebookCellOutput="vscode-notebook-cell-output",p.vscodeNotebookCellOutputDiff="vscode-notebook-cell-output-diff",p.vscodeNotebookMetadata="vscode-notebook-metadata",p.vscodeInteractiveInput="vscode-interactive-input",p.vscodeSettings="vscode-settings",p.vscodeWorkspaceTrust="vscode-workspace-trust",p.vscodeTerminal="vscode-terminal",p.vscodeChatCodeBlock="vscode-chat-code-block",p.vscodeChatCodeCompareBlock="vscode-chat-code-compare-block",p.vscodeChatSesssion="vscode-chat-editor",p.webviewPanel="webview-panel",p.vscodeWebview="vscode-webview",p.extension="extension",p.vscodeFileResource="vscode-file",p.tmp="tmp",p.vsls="vsls",p.vscodeSourceControl="vscode-scm",p.commentsInput="comment",p.codeSetting="code-setting",p.outputChannel="output"})($||(t.Schemas=$={}));function S(p,v){return U.URI.isUri(p)?(0,W.equalsIgnoreCase)(p.scheme,v):(0,W.startsWithIgnoreCase)(p,v+":")}function I(p,...v){return v.some(w=>S(p,w))}t.connectionTokenCookieName="vscode-tkn",t.connectionTokenQueryName="tkn";class N{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._serverRootPath="/"}setPreferredWebSchema(v){this._preferredWebSchema=v}setDelegate(v){this._delegate=v}setServerRootPath(v,w){this._serverRootPath=j(v,w)}getServerRootPath(){return this._serverRootPath}get _remoteResourcesPath(){return t1.posix.join(this._serverRootPath,$.vscodeRemoteResource)}set(v,w,F){this._hosts[v]=w,this._ports[v]=F}setConnectionToken(v,w){this._connectionTokens[v]=w}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(v){if(this._delegate)try{return this._delegate(v)}catch(G){return m.onUnexpectedError(G),v}const w=v.authority;let F=this._hosts[w];F&&F.indexOf(":")!==-1&&F.indexOf("[")===-1&&(F=`[${F}]`);const q=this._ports[w],H=this._connectionTokens[w];let C=`path=${encodeURIComponent(v.path)}`;return typeof H=="string"&&(C+=`&${t.connectionTokenQueryName}=${encodeURIComponent(H)}`),U.URI.from({scheme:e.isWeb?this._preferredWebSchema:$.vscodeRemoteResource,authority:`${F}:${q}`,path:this._remoteResourcesPath,query:C})}}t.RemoteAuthorities=new N;function j(p,v){return t1.posix.join(v??"/",`${p.quality??"oss"}-${p.commit??"dev"}`)}t.builtinExtensionsPath="vs/../../extensions",t.nodeModulesPath="vs/../../node_modules",t.nodeModulesAsarPath="vs/../../node_modules.asar",t.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked",t.VSCODE_AUTHORITY="vscode-app";class y{static{this.FALLBACK_AUTHORITY=t.VSCODE_AUTHORITY}asBrowserUri(v){const w=this.toUri(v,e1);return this.uriToBrowserUri(w)}uriToBrowserUri(v){return v.scheme===$.vscodeRemote?t.RemoteAuthorities.rewrite(v):v.scheme===$.file&&(e.isNative||e.webWorkerOrigin===`${$.vscodeFileResource}://${y.FALLBACK_AUTHORITY}`)?v.with({scheme:$.vscodeFileResource,authority:v.authority||y.FALLBACK_AUTHORITY,query:null,fragment:null}):v}asFileUri(v){const w=this.toUri(v,e1);return this.uriToFileUri(w)}uriToFileUri(v){return v.scheme===$.vscodeFileResource?v.with({scheme:$.file,authority:v.authority!==y.FALLBACK_AUTHORITY?v.authority:null,query:null,fragment:null}):v}toUri(v,w){if(U.URI.isUri(v))return v;if(globalThis._VSCODE_FILE_ROOT){const F=globalThis._VSCODE_FILE_ROOT;if(/^\w[\w\d+.-]*:\/\//.test(F))return U.URI.joinPath(U.URI.parse(F,!0),v);const q=t1.join(F,v);return U.URI.file(q)}return U.URI.parse(w.toUrl(v))}}t.FileAccess=new y;var Y;(function(p){const v=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);p.CoopAndCoep=Object.freeze(v.get("3"));const w="vscode-coi";function F(H){let C;typeof H=="string"?C=new URL(H).searchParams:H instanceof URL?C=H.searchParams:U.URI.isUri(H)&&(C=new URL(H.toString(!0)).searchParams);const G=C?.get(w);if(G)return v.get(G)}p.getHeadersFromQuery=F;function q(H,C,G){if(!globalThis.crossOriginIsolated)return;const o=C&&G?"3":G?"2":"1";H instanceof URLSearchParams?H.set(w,o):H[w]=o}p.addSearchParam=q})(Y||(t.COI=Y={}))}),define(h1[27],d1([0,1,4,2,7,6,26,3,8]),function(e1,t,m,e,W,U,t1,$,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SimpleWorkerServer=t.SimpleWorkerClient=void 0,t.logOnceWebWorkerWarning=Y,t.create=a,S=k1(S);const I=!1,N="default",j="$initialize";let y=!1;function Y(g){$.isWeb&&(y||(y=!0,console.warn("Could not create web worker(s). Falling back to loading web worker code in main thread, which might cause UI freezes. Please see https://github.com/microsoft/monaco-editor#faq")),console.warn(g.message))}var p;(function(g){g[g.Request=0]="Request",g[g.Reply=1]="Reply",g[g.SubscribeEvent=2]="SubscribeEvent",g[g.Event=3]="Event",g[g.UnsubscribeEvent=4]="UnsubscribeEvent"})(p||(p={}));class v{constructor(s,r,f,u,h){this.vsWorker=s,this.req=r,this.channel=f,this.method=u,this.args=h,this.type=p.Request}}class w{constructor(s,r,f,u){this.vsWorker=s,this.seq=r,this.res=f,this.err=u,this.type=p.Reply}}class F{constructor(s,r,f,u,h){this.vsWorker=s,this.req=r,this.channel=f,this.eventName=u,this.arg=h,this.type=p.SubscribeEvent}}class q{constructor(s,r,f){this.vsWorker=s,this.req=r,this.event=f,this.type=p.Event}}class H{constructor(s,r){this.vsWorker=s,this.req=r,this.type=p.UnsubscribeEvent}}class C{constructor(s){this._workerId=-1,this._handler=s,this._lastSentReq=0,this._pendingReplies=Object.create(null),this._pendingEmitters=new Map,this._pendingEvents=new Map}setWorkerId(s){this._workerId=s}sendMessage(s,r,f){const u=String(++this._lastSentReq);return new Promise((h,E)=>{this._pendingReplies[u]={resolve:h,reject:E},this._send(new v(this._workerId,u,s,r,f))})}listen(s,r,f){let u=null;const h=new W.Emitter({onWillAddFirstListener:()=>{u=String(++this._lastSentReq),this._pendingEmitters.set(u,h),this._send(new F(this._workerId,u,s,r,f))},onDidRemoveLastListener:()=>{this._pendingEmitters.delete(u),this._send(new H(this._workerId,u)),u=null}});return h.event}handleMessage(s){!s||!s.vsWorker||this._workerId!==-1&&s.vsWorker!==this._workerId||this._handleMessage(s)}createProxyToRemoteChannel(s,r){const f={get:(u,h)=>(typeof h=="string"&&!u[h]&&(n(h)?u[h]=E=>this.listen(s,h,E):o(h)?u[h]=this.listen(s,h,void 0):h.charCodeAt(0)===m.CharCode.DollarSign&&(u[h]=async(...E)=>(await r?.(),this.sendMessage(s,h,E)))),u[h])};return new Proxy(Object.create(null),f)}_handleMessage(s){switch(s.type){case p.Reply:return this._handleReplyMessage(s);case p.Request:return this._handleRequestMessage(s);case p.SubscribeEvent:return this._handleSubscribeEventMessage(s);case p.Event:return this._handleEventMessage(s);case p.UnsubscribeEvent:return this._handleUnsubscribeEventMessage(s)}}_handleReplyMessage(s){if(!this._pendingReplies[s.seq]){console.warn("Got reply to unknown seq");return}const r=this._pendingReplies[s.seq];if(delete this._pendingReplies[s.seq],s.err){let f=s.err;s.err.$isError&&(f=new Error,f.name=s.err.name,f.message=s.err.message,f.stack=s.err.stack),r.reject(f);return}r.resolve(s.res)}_handleRequestMessage(s){const r=s.req;this._handler.handleMessage(s.channel,s.method,s.args).then(u=>{this._send(new w(this._workerId,r,u,void 0))},u=>{u.detail instanceof Error&&(u.detail=(0,e.transformErrorForSerialization)(u.detail)),this._send(new w(this._workerId,r,void 0,(0,e.transformErrorForSerialization)(u)))})}_handleSubscribeEventMessage(s){const r=s.req,f=this._handler.handleEvent(s.channel,s.eventName,s.arg)(u=>{this._send(new q(this._workerId,r,u))});this._pendingEvents.set(r,f)}_handleEventMessage(s){if(!this._pendingEmitters.has(s.req)){console.warn("Got event for unknown req");return}this._pendingEmitters.get(s.req).fire(s.event)}_handleUnsubscribeEventMessage(s){if(!this._pendingEvents.has(s.req)){console.warn("Got unsubscribe for unknown req");return}this._pendingEvents.get(s.req).dispose(),this._pendingEvents.delete(s.req)}_send(s){const r=[];if(s.type===p.Request)for(let f=0;f<s.args.length;f++)s.args[f]instanceof ArrayBuffer&&r.push(s.args[f]);else s.type===p.Reply&&s.res instanceof ArrayBuffer&&r.push(s.res);this._handler.sendMessage(s,r)}}class G extends U.Disposable{constructor(s,r){super(),this._localChannels=new Map,this._remoteChannels=new Map,this._worker=this._register(s.create({amdModuleId:"vs/base/common/worker/simpleWorker",esmModuleLocation:r.esmModuleLocation,label:r.label},h=>{this._protocol.handleMessage(h)},h=>{(0,e.onUnexpectedError)(h)})),this._protocol=new C({sendMessage:(h,E)=>{this._worker.postMessage(h,E)},handleMessage:(h,E,c)=>this._handleMessage(h,E,c),handleEvent:(h,E,c)=>this._handleEvent(h,E,c)}),this._protocol.setWorkerId(this._worker.getId());let f=null;const u=globalThis.require;typeof u<"u"&&typeof u.getConfig=="function"?f=u.getConfig():typeof globalThis.requirejs<"u"&&(f=globalThis.requirejs.s.contexts._.config),this._onModuleLoaded=this._protocol.sendMessage(N,j,[this._worker.getId(),JSON.parse(JSON.stringify(f)),r.amdModuleId]),this.proxy=this._protocol.createProxyToRemoteChannel(N,async()=>{await this._onModuleLoaded}),this._onModuleLoaded.catch(h=>{this._onError("Worker failed to load "+r.amdModuleId,h)})}_handleMessage(s,r,f){const u=this._localChannels.get(s);if(!u)return Promise.reject(new Error(`Missing channel ${s} on main thread`));if(typeof u[r]!="function")return Promise.reject(new Error(`Missing method ${r} on main thread channel ${s}`));try{return Promise.resolve(u[r].apply(u,f))}catch(h){return Promise.reject(h)}}_handleEvent(s,r,f){const u=this._localChannels.get(s);if(!u)throw new Error(`Missing channel ${s} on main thread`);if(n(r)){const h=u[r].call(u,f);if(typeof h!="function")throw new Error(`Missing dynamic event ${r} on main thread channel ${s}.`);return h}if(o(r)){const h=u[r];if(typeof h!="function")throw new Error(`Missing event ${r} on main thread channel ${s}.`);return h}throw new Error(`Malformed event name ${r}`)}setChannel(s,r){this._localChannels.set(s,r)}getChannel(s){if(!this._remoteChannels.has(s)){const r=this._protocol.createProxyToRemoteChannel(s,async()=>{await this._onModuleLoaded});this._remoteChannels.set(s,r)}return this._remoteChannels.get(s)}_onError(s,r){console.error(s),console.info(r)}}t.SimpleWorkerClient=G;function o(g){return g[0]==="o"&&g[1]==="n"&&S.isUpperAsciiLetter(g.charCodeAt(2))}function n(g){return/^onDynamic/.test(g)&&S.isUpperAsciiLetter(g.charCodeAt(9))}class i{constructor(s,r){this._localChannels=new Map,this._remoteChannels=new Map,this._requestHandlerFactory=r,this._requestHandler=null,this._protocol=new C({sendMessage:(f,u)=>{s(f,u)},handleMessage:(f,u,h)=>this._handleMessage(f,u,h),handleEvent:(f,u,h)=>this._handleEvent(f,u,h)})}onmessage(s){this._protocol.handleMessage(s)}_handleMessage(s,r,f){if(s===N&&r===j)return this.initialize(f[0],f[1],f[2]);const u=s===N?this._requestHandler:this._localChannels.get(s);if(!u)return Promise.reject(new Error(`Missing channel ${s} on worker thread`));if(typeof u[r]!="function")return Promise.reject(new Error(`Missing method ${r} on worker thread channel ${s}`));try{return Promise.resolve(u[r].apply(u,f))}catch(h){return Promise.reject(h)}}_handleEvent(s,r,f){const u=s===N?this._requestHandler:this._localChannels.get(s);if(!u)throw new Error(`Missing channel ${s} on worker thread`);if(n(r)){const h=u[r].call(u,f);if(typeof h!="function")throw new Error(`Missing dynamic event ${r} on request handler.`);return h}if(o(r)){const h=u[r];if(typeof h!="function")throw new Error(`Missing event ${r} on request handler.`);return h}throw new Error(`Malformed event name ${r}`)}setChannel(s,r){this._localChannels.set(s,r)}getChannel(s){if(!this._remoteChannels.has(s)){const r=this._protocol.createProxyToRemoteChannel(s);this._remoteChannels.set(s,r)}return this._remoteChannels.get(s)}async initialize(s,r,f){if(this._protocol.setWorkerId(s),this._requestHandlerFactory){this._requestHandler=this._requestHandlerFactory(this);return}if(r&&(typeof r.baseUrl<"u"&&delete r.baseUrl,typeof r.paths<"u"&&typeof r.paths.vs<"u"&&delete r.paths.vs,typeof r.trustedTypesPolicy<"u"&&delete r.trustedTypesPolicy,r.catchError=!0,globalThis.require.config(r)),I){const u=t1.FileAccess.asBrowserUri(`${f}.js`).toString(!0);return new Promise((h,E)=>{e1([`${u}`],h,E)}).then(k1).then(h=>{if(this._requestHandler=h.create(this),!this._requestHandler)throw new Error("No RequestHandler!")})}return new Promise((u,h)=>{(globalThis.require||e1)([f],c=>{if(this._requestHandler=c.create(this),!this._requestHandler){h(new Error("No RequestHandler!"));return}u()},h)})}}t.SimpleWorkerServer=i;function a(g){return new i(g,null)}})}).call(this);

//# sourceMappingURL=https://main.vscode-cdn.net/sourcemaps/532bdf24071d0a26ceea0844dcdf5ee8cfabd562/core/vs/base/common/worker/simpleWorker.js.map
