/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var re=["require","exports","vs/editor/common/core/range","vs/base/common/charCode","vs/base/common/errors","vs/editor/common/core/position","vs/base/common/strings","vs/editor/common/core/offsetRange","vs/base/common/platform","vs/base/common/arrays","vs/base/common/lifecycle","vs/base/common/arraysFind","vs/base/common/event","vs/editor/common/diff/defaultLinesDiffComputer/algorithms/diffAlgorithm","vs/base/common/uri","vs/base/common/assert","vs/base/common/uint","vs/editor/common/core/lineRange","vs/base/common/path","vs/base/common/map","vs/base/common/cancellation","vs/base/common/types","vs/editor/common/diff/defaultLinesDiffComputer/utils","vs/editor/common/diff/rangeMapping","vs/base/common/network","vs/base/common/functional","vs/base/common/iterator","vs/base/common/lazy","vs/base/common/linkedList","vs/base/common/stopwatch","vs/base/common/codiconsUtil","vs/base/common/objects","vs/base/common/diff/diff","vs/editor/common/core/characterClassifier","vs/editor/common/core/textLength","vs/editor/common/core/wordHelper","vs/editor/common/diff/defaultLinesDiffComputer/algorithms/myersDiffAlgorithm","vs/editor/common/diff/defaultLinesDiffComputer/linesSliceCharSequence","vs/editor/common/diff/linesDiffComputer","vs/editor/common/diff/legacyLinesDiffComputer","vs/nls.messages","vs/nls","vs/base/common/collections","vs/base/common/color","vs/base/common/diff/diffChange","vs/base/common/keyCodes","vs/base/common/marshallingIds","vs/base/common/cache","vs/base/common/symbols","vs/base/common/codiconsLibrary","vs/base/common/codicons","vs/base/common/hash","vs/editor/common/core/editOperation","vs/editor/common/core/selection","vs/editor/common/core/positionToOffset","vs/editor/common/core/textEdit","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/diff/defaultLinesDiffComputer/heuristicSequenceOptimizations","vs/editor/common/diff/defaultLinesDiffComputer/lineSequence","vs/editor/common/diff/defaultLinesDiffComputer/algorithms/dynamicProgrammingDiffing","vs/editor/common/diff/defaultLinesDiffComputer/computeMovedLines","vs/editor/common/diff/defaultLinesDiffComputer/defaultLinesDiffComputer","vs/editor/common/diff/linesDiffComputers","vs/editor/common/encodedTokenAttributes","vs/editor/common/languages/defaultDocumentColorsComputer","vs/editor/common/languages/linkComputer","vs/editor/common/languages/supports/inplaceReplaceSupport","vs/editor/common/model","vs/editor/common/model/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/editor/common/model/textModelSearch","vs/editor/common/services/editorWorkerHost","vs/editor/common/services/findSectionHeaders","vs/editor/common/services/unicodeTextModelHighlighter","vs/editor/common/standalone/standaloneEnums","vs/editor/common/tokenizationRegistry","vs/base/common/process","vs/base/common/extpath","vs/base/common/resources","vs/base/common/async","vs/editor/common/languages","vs/editor/common/services/editorBaseApi","vs/editor/common/services/textModelSync/textModelSync.impl","vs/css","vs/base/common/worker/simpleWorker","vs/editor/common/services/editorSimpleWorker"],ae=function(C){for(var t=[],n=0,i=C.length;n<i;n++)t[n]=re[C[n]];return t};const Qe=this,Ze=typeof global=="object"?global:{};var Ae;(function(C){C.global=Qe;class t{get isWindows(){return this._detect(),this._isWindows}get isNode(){return this._detect(),this._isNode}get isElectronRenderer(){return this._detect(),this._isElectronRenderer}get isWebWorker(){return this._detect(),this._isWebWorker}get isElectronNodeIntegrationWebWorker(){return this._detect(),this._isElectronNodeIntegrationWebWorker}constructor(){this._detected=!1,this._isWindows=!1,this._isNode=!1,this._isElectronRenderer=!1,this._isWebWorker=!1,this._isElectronNodeIntegrationWebWorker=!1}_detect(){this._detected||(this._detected=!0,this._isWindows=t._isWindows(),this._isNode=typeof module<"u"&&!!module.exports,this._isElectronRenderer=typeof process<"u"&&typeof process.versions<"u"&&typeof process.versions.electron<"u"&&process.type==="renderer",this._isWebWorker=typeof C.global.importScripts=="function",this._isElectronNodeIntegrationWebWorker=this._isWebWorker&&typeof process<"u"&&typeof process.versions<"u"&&typeof process.versions.electron<"u"&&process.type==="worker")}static _isWindows(){return typeof navigator<"u"&&navigator.userAgent&&navigator.userAgent.indexOf("Windows")>=0?!0:typeof process<"u"?process.platform==="win32":!1}}C.Environment=t})(Ae||(Ae={}));var Ae;(function(C){class t{constructor(m,R,b){this.type=m,this.detail=R,this.timestamp=b}}C.LoaderEvent=t;class n{constructor(m){this._events=[new t(1,"",m)]}record(m,R){this._events.push(new t(m,R,C.Utilities.getHighPerformanceTimestamp()))}getEvents(){return this._events}}C.LoaderEventRecorder=n;class i{record(m,R){}getEvents(){return[]}}i.INSTANCE=new i,C.NullLoaderEventRecorder=i})(Ae||(Ae={}));var Ae;(function(C){class t{static fileUriToFilePath(i,M){if(M=decodeURI(M).replace(/%23/g,"#"),i){if(/^file:\/\/\//.test(M))return M.substr(8);if(/^file:\/\//.test(M))return M.substr(5)}else if(/^file:\/\//.test(M))return M.substr(7);return M}static startsWith(i,M){return i.length>=M.length&&i.substr(0,M.length)===M}static endsWith(i,M){return i.length>=M.length&&i.substr(i.length-M.length)===M}static containsQueryString(i){return/^[^\#]*\?/gi.test(i)}static isAbsolutePath(i){return/^((http:\/\/)|(https:\/\/)|(file:\/\/)|(\/))/.test(i)}static forEachProperty(i,M){if(i){let m;for(m in i)i.hasOwnProperty(m)&&M(m,i[m])}}static isEmpty(i){let M=!0;return t.forEachProperty(i,()=>{M=!1}),M}static recursiveClone(i){if(!i||typeof i!="object"||i instanceof RegExp||!Array.isArray(i)&&Object.getPrototypeOf(i)!==Object.prototype)return i;let M=Array.isArray(i)?[]:{};return t.forEachProperty(i,(m,R)=>{R&&typeof R=="object"?M[m]=t.recursiveClone(R):M[m]=R}),M}static generateAnonymousModule(){return"===anonymous"+t.NEXT_ANONYMOUS_ID+++"==="}static isAnonymousModule(i){return t.startsWith(i,"===anonymous")}static getHighPerformanceTimestamp(){return this.PERFORMANCE_NOW_PROBED||(this.PERFORMANCE_NOW_PROBED=!0,this.HAS_PERFORMANCE_NOW=C.global.performance&&typeof C.global.performance.now=="function"),this.HAS_PERFORMANCE_NOW?C.global.performance.now():Date.now()}}t.NEXT_ANONYMOUS_ID=1,t.PERFORMANCE_NOW_PROBED=!1,t.HAS_PERFORMANCE_NOW=!1,C.Utilities=t})(Ae||(Ae={}));var Ae;(function(C){function t(M){if(M instanceof Error)return M;const m=new Error(M.message||String(M)||"Unknown Error");return M.stack&&(m.stack=M.stack),m}C.ensureError=t;class n{static validateConfigurationOptions(m){function R(b){if(b.phase==="loading"){console.error('Loading "'+b.moduleId+'" failed'),console.error(b),console.error("Here are the modules that depend on it:"),console.error(b.neededBy);return}if(b.phase==="factory"){console.error('The factory function of "'+b.moduleId+'" has thrown an exception'),console.error(b),console.error("Here are the modules that depend on it:"),console.error(b.neededBy);return}}if(m=m||{},typeof m.baseUrl!="string"&&(m.baseUrl=""),typeof m.isBuild!="boolean"&&(m.isBuild=!1),typeof m.paths!="object"&&(m.paths={}),typeof m.config!="object"&&(m.config={}),typeof m.catchError>"u"&&(m.catchError=!1),typeof m.recordStats>"u"&&(m.recordStats=!1),typeof m.urlArgs!="string"&&(m.urlArgs=""),typeof m.onError!="function"&&(m.onError=R),Array.isArray(m.ignoreDuplicateModules)||(m.ignoreDuplicateModules=[]),m.baseUrl.length>0&&(C.Utilities.endsWith(m.baseUrl,"/")||(m.baseUrl+="/")),typeof m.cspNonce!="string"&&(m.cspNonce=""),typeof m.preferScriptTags>"u"&&(m.preferScriptTags=!1),m.nodeCachedData&&typeof m.nodeCachedData=="object"&&(typeof m.nodeCachedData.seed!="string"&&(m.nodeCachedData.seed="seed"),(typeof m.nodeCachedData.writeDelay!="number"||m.nodeCachedData.writeDelay<0)&&(m.nodeCachedData.writeDelay=1e3*7),!m.nodeCachedData.path||typeof m.nodeCachedData.path!="string")){const b=t(new Error("INVALID cached data configuration, 'path' MUST be set"));b.phase="configuration",m.onError(b),m.nodeCachedData=void 0}return m}static mergeConfigurationOptions(m=null,R=null){let b=C.Utilities.recursiveClone(R||{});return C.Utilities.forEachProperty(m,(o,a)=>{o==="ignoreDuplicateModules"&&typeof b.ignoreDuplicateModules<"u"?b.ignoreDuplicateModules=b.ignoreDuplicateModules.concat(a):o==="paths"&&typeof b.paths<"u"?C.Utilities.forEachProperty(a,(h,_)=>b.paths[h]=_):o==="config"&&typeof b.config<"u"?C.Utilities.forEachProperty(a,(h,_)=>b.config[h]=_):b[o]=C.Utilities.recursiveClone(a)}),n.validateConfigurationOptions(b)}}C.ConfigurationOptionsUtil=n;class i{constructor(m,R){if(this._env=m,this.options=n.mergeConfigurationOptions(R),this._createIgnoreDuplicateModulesMap(),this._createSortedPathsRules(),this.options.baseUrl===""&&this.options.nodeRequire&&this.options.nodeRequire.main&&this.options.nodeRequire.main.filename&&this._env.isNode){let b=this.options.nodeRequire.main.filename,o=Math.max(b.lastIndexOf("/"),b.lastIndexOf("\\"));this.options.baseUrl=b.substring(0,o+1)}}_createIgnoreDuplicateModulesMap(){this.ignoreDuplicateModulesMap={};for(let m=0;m<this.options.ignoreDuplicateModules.length;m++)this.ignoreDuplicateModulesMap[this.options.ignoreDuplicateModules[m]]=!0}_createSortedPathsRules(){this.sortedPathsRules=[],C.Utilities.forEachProperty(this.options.paths,(m,R)=>{Array.isArray(R)?this.sortedPathsRules.push({from:m,to:R}):this.sortedPathsRules.push({from:m,to:[R]})}),this.sortedPathsRules.sort((m,R)=>R.from.length-m.from.length)}cloneAndMerge(m){return new i(this._env,n.mergeConfigurationOptions(m,this.options))}getOptionsLiteral(){return this.options}_applyPaths(m){let R;for(let b=0,o=this.sortedPathsRules.length;b<o;b++)if(R=this.sortedPathsRules[b],C.Utilities.startsWith(m,R.from)){let a=[];for(let h=0,_=R.to.length;h<_;h++)a.push(R.to[h]+m.substr(R.from.length));return a}return[m]}_addUrlArgsToUrl(m){return C.Utilities.containsQueryString(m)?m+"&"+this.options.urlArgs:m+"?"+this.options.urlArgs}_addUrlArgsIfNecessaryToUrl(m){return this.options.urlArgs?this._addUrlArgsToUrl(m):m}_addUrlArgsIfNecessaryToUrls(m){if(this.options.urlArgs)for(let R=0,b=m.length;R<b;R++)m[R]=this._addUrlArgsToUrl(m[R]);return m}moduleIdToPaths(m){if(this._env.isNode&&this.options.amdModulesPattern instanceof RegExp&&!this.options.amdModulesPattern.test(m))return this.isBuild()?["empty:"]:["node|"+m];let R=m,b;if(!C.Utilities.endsWith(R,".js")&&!C.Utilities.isAbsolutePath(R)){b=this._applyPaths(R);for(let o=0,a=b.length;o<a;o++)this.isBuild()&&b[o]==="empty:"||(C.Utilities.isAbsolutePath(b[o])||(b[o]=this.options.baseUrl+b[o]),!C.Utilities.endsWith(b[o],".js")&&!C.Utilities.containsQueryString(b[o])&&(b[o]=b[o]+".js"))}else!C.Utilities.endsWith(R,".js")&&!C.Utilities.containsQueryString(R)&&(R=R+".js"),b=[R];return this._addUrlArgsIfNecessaryToUrls(b)}requireToUrl(m){let R=m;return C.Utilities.isAbsolutePath(R)||(R=this._applyPaths(R)[0],C.Utilities.isAbsolutePath(R)||(R=this.options.baseUrl+R)),this._addUrlArgsIfNecessaryToUrl(R)}isBuild(){return this.options.isBuild}shouldInvokeFactory(m){return!!(!this.options.isBuild||C.Utilities.isAnonymousModule(m)||this.options.buildForceInvokeFactory&&this.options.buildForceInvokeFactory[m])}isDuplicateMessageIgnoredFor(m){return this.ignoreDuplicateModulesMap.hasOwnProperty(m)}getConfigForModule(m){if(this.options.config)return this.options.config[m]}shouldCatchError(){return this.options.catchError}shouldRecordStats(){return this.options.recordStats}onError(m){this.options.onError(m)}}C.Configuration=i})(Ae||(Ae={}));var Ae;(function(C){class t{constructor(a){this._env=a,this._scriptLoader=null,this._callbackMap={}}load(a,h,_,d){if(!this._scriptLoader)if(this._env.isWebWorker)this._scriptLoader=new M;else if(this._env.isElectronRenderer){const{preferScriptTags:e}=a.getConfig().getOptionsLiteral();e?this._scriptLoader=new n:this._scriptLoader=new m(this._env)}else this._env.isNode?this._scriptLoader=new m(this._env):this._scriptLoader=new n;let c={callback:_,errorback:d};if(this._callbackMap.hasOwnProperty(h)){this._callbackMap[h].push(c);return}this._callbackMap[h]=[c],this._scriptLoader.load(a,h,()=>this.triggerCallback(h),e=>this.triggerErrorback(h,e))}triggerCallback(a){let h=this._callbackMap[a];delete this._callbackMap[a];for(let _=0;_<h.length;_++)h[_].callback()}triggerErrorback(a,h){let _=this._callbackMap[a];delete this._callbackMap[a];for(let d=0;d<_.length;d++)_[d].errorback(h)}}class n{attachListeners(a,h,_){let d=()=>{a.removeEventListener("load",c),a.removeEventListener("error",e)},c=u=>{d(),h()},e=u=>{d(),_(u)};a.addEventListener("load",c),a.addEventListener("error",e)}load(a,h,_,d){if(/^node\|/.test(h)){let c=a.getConfig().getOptionsLiteral(),e=R(a.getRecorder(),c.nodeRequire||C.global.nodeRequire),u=h.split("|"),g=null;try{g=e(u[1])}catch(E){d(E);return}a.enqueueDefineAnonymousModule([],()=>g),_()}else{let c=document.createElement("script");c.setAttribute("async","async"),c.setAttribute("type","text/javascript"),this.attachListeners(c,_,d);const{trustedTypesPolicy:e}=a.getConfig().getOptionsLiteral();e&&(h=e.createScriptURL(h)),c.setAttribute("src",h);const{cspNonce:u}=a.getConfig().getOptionsLiteral();u&&c.setAttribute("nonce",u),document.getElementsByTagName("head")[0].appendChild(c)}}}function i(o){const{trustedTypesPolicy:a}=o.getConfig().getOptionsLiteral();try{return(a?self.eval(a.createScript("","true")):new Function("true")).call(self),!0}catch{return!1}}class M{constructor(){this._cachedCanUseEval=null}_canUseEval(a){return this._cachedCanUseEval===null&&(this._cachedCanUseEval=i(a)),this._cachedCanUseEval}load(a,h,_,d){if(/^node\|/.test(h)){const c=a.getConfig().getOptionsLiteral(),e=R(a.getRecorder(),c.nodeRequire||C.global.nodeRequire),u=h.split("|");let g=null;try{g=e(u[1])}catch(E){d(E);return}a.enqueueDefineAnonymousModule([],function(){return g}),_()}else{const{trustedTypesPolicy:c}=a.getConfig().getOptionsLiteral();if(!(/^((http:)|(https:)|(file:))/.test(h)&&h.substring(0,self.origin.length)!==self.origin)&&this._canUseEval(a)){fetch(h).then(u=>{if(u.status!==200)throw new Error(u.statusText);return u.text()}).then(u=>{u=`${u}
//# sourceURL=${h}`,(c?self.eval(c.createScript("",u)):new Function(u)).call(self),_()}).then(void 0,d);return}try{c&&(h=c.createScriptURL(h)),importScripts(h),_()}catch(u){d(u)}}}}class m{constructor(a){this._env=a,this._didInitialize=!1,this._didPatchNodeRequire=!1}_init(a){this._didInitialize||(this._didInitialize=!0,this._fs=a("fs"),this._vm=a("vm"),this._path=a("path"),this._crypto=a("crypto"))}_initNodeRequire(a,h){const{nodeCachedData:_}=h.getConfig().getOptionsLiteral();if(!_||this._didPatchNodeRequire)return;this._didPatchNodeRequire=!0;const d=this,c=a("module");function e(u){const g=u.constructor;let E=function(v){try{return u.require(v)}finally{}};return E.resolve=function(v,A){return g._resolveFilename(v,u,!1,A)},E.resolve.paths=function(v){return g._resolveLookupPaths(v,u)},E.main=process.mainModule,E.extensions=g._extensions,E.cache=g._cache,E}c.prototype._compile=function(u,g){const E=c.wrap(u.replace(/^#!.*/,"")),w=h.getRecorder(),v=d._getCachedDataPath(_,g),A={filename:g};let L;try{const S=d._fs.readFileSync(v);L=S.slice(0,16),A.cachedData=S.slice(16),w.record(60,v)}catch{w.record(61,v)}const l=new d._vm.Script(E,A),s=l.runInThisContext(A),f=d._path.dirname(g),p=e(this),I=[this.exports,p,this,g,f,process,Ze,Buffer],N=s.apply(this.exports,I);return d._handleCachedData(l,E,v,!A.cachedData,h),d._verifyCachedData(l,E,v,L,h),N}}load(a,h,_,d){const c=a.getConfig().getOptionsLiteral(),e=R(a.getRecorder(),c.nodeRequire||C.global.nodeRequire),u=c.nodeInstrumenter||function(E){return E};this._init(e),this._initNodeRequire(e,a);let g=a.getRecorder();if(/^node\|/.test(h)){let E=h.split("|"),w=null;try{w=e(E[1])}catch(v){d(v);return}a.enqueueDefineAnonymousModule([],()=>w),_()}else{h=C.Utilities.fileUriToFilePath(this._env.isWindows,h);const E=this._path.normalize(h),w=this._getElectronRendererScriptPathOrUri(E),v=!!c.nodeCachedData,A=v?this._getCachedDataPath(c.nodeCachedData,h):void 0;this._readSourceAndCachedData(E,A,g,(L,l,s,f)=>{if(L){d(L);return}let p;l.charCodeAt(0)===m._BOM?p=m._PREFIX+l.substring(1)+m._SUFFIX:p=m._PREFIX+l+m._SUFFIX,p=u(p,E);const I={filename:w,cachedData:s},N=this._createAndEvalScript(a,p,I,_,d);this._handleCachedData(N,p,A,v&&!s,a),this._verifyCachedData(N,p,A,f,a)})}}_createAndEvalScript(a,h,_,d,c){const e=a.getRecorder();e.record(31,_.filename);const u=new this._vm.Script(h,_),g=u.runInThisContext(_),E=a.getGlobalAMDDefineFunc();let w=!1;const v=function(){return w=!0,E.apply(null,arguments)};return v.amd=E.amd,g.call(C.global,a.getGlobalAMDRequireFunc(),v,_.filename,this._path.dirname(_.filename)),e.record(32,_.filename),w?d():c(new Error(`Didn't receive define call in ${_.filename}!`)),u}_getElectronRendererScriptPathOrUri(a){if(!this._env.isElectronRenderer)return a;let h=a.match(/^([a-z])\:(.*)/i);return h?`file:///${(h[1].toUpperCase()+":"+h[2]).replace(/\\/g,"/")}`:`file://${a}`}_getCachedDataPath(a,h){const _=this._crypto.createHash("md5").update(h,"utf8").update(a.seed,"utf8").update(process.arch,"").digest("hex"),d=this._path.basename(h).replace(/\.js$/,"");return this._path.join(a.path,`${d}-${_}.code`)}_handleCachedData(a,h,_,d,c){a.cachedDataRejected?this._fs.unlink(_,e=>{c.getRecorder().record(62,_),this._createAndWriteCachedData(a,h,_,c),e&&c.getConfig().onError(e)}):d&&this._createAndWriteCachedData(a,h,_,c)}_createAndWriteCachedData(a,h,_,d){let c=Math.ceil(d.getConfig().getOptionsLiteral().nodeCachedData.writeDelay*(1+Math.random())),e=-1,u=0,g;const E=()=>{setTimeout(()=>{g||(g=this._crypto.createHash("md5").update(h,"utf8").digest());const w=a.createCachedData();if(!(w.length===0||w.length===e||u>=5)){if(w.length<e){E();return}e=w.length,this._fs.writeFile(_,Buffer.concat([g,w]),v=>{v&&d.getConfig().onError(v),d.getRecorder().record(63,_),E()})}},c*Math.pow(4,u++))};E()}_readSourceAndCachedData(a,h,_,d){if(!h)this._fs.readFile(a,{encoding:"utf8"},d);else{let c,e,u,g=2;const E=w=>{w?d(w):--g===0&&d(void 0,c,e,u)};this._fs.readFile(a,{encoding:"utf8"},(w,v)=>{c=v,E(w)}),this._fs.readFile(h,(w,v)=>{!w&&v&&v.length>0?(u=v.slice(0,16),e=v.slice(16),_.record(60,h)):_.record(61,h),E()})}}_verifyCachedData(a,h,_,d,c){d&&(a.cachedDataRejected||setTimeout(()=>{const e=this._crypto.createHash("md5").update(h,"utf8").digest();d.equals(e)||(c.getConfig().onError(new Error(`FAILED TO VERIFY CACHED DATA, deleting stale '${_}' now, but a RESTART IS REQUIRED`)),this._fs.unlink(_,u=>{u&&c.getConfig().onError(u)}))},Math.ceil(5e3*(1+Math.random()))))}}m._BOM=65279,m._PREFIX="(function (require, define, __filename, __dirname) { ",m._SUFFIX=`
});`;function R(o,a){if(a.__$__isRecorded)return a;const h=function(d){o.record(33,d);try{return a(d)}finally{o.record(34,d)}};return h.__$__isRecorded=!0,h}C.ensureRecordedNodeRequire=R;function b(o){return new t(o)}C.createScriptLoader=b})(Ae||(Ae={}));var Ae;(function(C){class t{constructor(o){let a=o.lastIndexOf("/");a!==-1?this.fromModulePath=o.substr(0,a+1):this.fromModulePath=""}static _normalizeModuleId(o){let a=o,h;for(h=/\/\.\//;h.test(a);)a=a.replace(h,"/");for(a=a.replace(/^\.\//g,""),h=/\/(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//;h.test(a);)a=a.replace(h,"/");return a=a.replace(/^(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//,""),a}resolveModule(o){let a=o;return C.Utilities.isAbsolutePath(a)||(C.Utilities.startsWith(a,"./")||C.Utilities.startsWith(a,"../"))&&(a=t._normalizeModuleId(this.fromModulePath+a)),a}}t.ROOT=new t(""),C.ModuleIdResolver=t;class n{constructor(o,a,h,_,d,c){this.id=o,this.strId=a,this.dependencies=h,this._callback=_,this._errorback=d,this.moduleIdResolver=c,this.exports={},this.error=null,this.exportsPassedIn=!1,this.unresolvedDependenciesCount=this.dependencies.length,this._isComplete=!1}static _safeInvokeFunction(o,a){try{return{returnedValue:o.apply(C.global,a),producedError:null}}catch(h){return{returnedValue:null,producedError:h}}}static _invokeFactory(o,a,h,_){return o.shouldInvokeFactory(a)?o.shouldCatchError()?this._safeInvokeFunction(h,_):{returnedValue:h.apply(C.global,_),producedError:null}:{returnedValue:null,producedError:null}}complete(o,a,h,_){this._isComplete=!0;let d=null;if(this._callback)if(typeof this._callback=="function"){o.record(21,this.strId);let c=n._invokeFactory(a,this.strId,this._callback,h);d=c.producedError,o.record(22,this.strId),!d&&typeof c.returnedValue<"u"&&(!this.exportsPassedIn||C.Utilities.isEmpty(this.exports))&&(this.exports=c.returnedValue)}else this.exports=this._callback;if(d){let c=C.ensureError(d);c.phase="factory",c.moduleId=this.strId,c.neededBy=_(this.id),this.error=c,a.onError(c)}this.dependencies=null,this._callback=null,this._errorback=null,this.moduleIdResolver=null}onDependencyError(o){return this._isComplete=!0,this.error=o,this._errorback?(this._errorback(o),!0):!1}isComplete(){return this._isComplete}}C.Module=n;class i{constructor(){this._nextId=0,this._strModuleIdToIntModuleId=new Map,this._intModuleIdToStrModuleId=[],this.getModuleId("exports"),this.getModuleId("module"),this.getModuleId("require")}getMaxModuleId(){return this._nextId}getModuleId(o){let a=this._strModuleIdToIntModuleId.get(o);return typeof a>"u"&&(a=this._nextId++,this._strModuleIdToIntModuleId.set(o,a),this._intModuleIdToStrModuleId[a]=o),a}getStrModuleId(o){return this._intModuleIdToStrModuleId[o]}}class M{constructor(o){this.id=o}}M.EXPORTS=new M(0),M.MODULE=new M(1),M.REQUIRE=new M(2),C.RegularDependency=M;class m{constructor(o,a,h){this.id=o,this.pluginId=a,this.pluginParam=h}}C.PluginDependency=m;class R{constructor(o,a,h,_,d=0){this._env=o,this._scriptLoader=a,this._loaderAvailableTimestamp=d,this._defineFunc=h,this._requireFunc=_,this._moduleIdProvider=new i,this._config=new C.Configuration(this._env),this._hasDependencyCycle=!1,this._modules2=[],this._knownModules2=[],this._inverseDependencies2=[],this._inversePluginDependencies2=new Map,this._currentAnonymousDefineCall=null,this._recorder=null,this._buildInfoPath=[],this._buildInfoDefineStack=[],this._buildInfoDependencies=[],this._requireFunc.moduleManager=this}reset(){return new R(this._env,this._scriptLoader,this._defineFunc,this._requireFunc,this._loaderAvailableTimestamp)}getGlobalAMDDefineFunc(){return this._defineFunc}getGlobalAMDRequireFunc(){return this._requireFunc}static _findRelevantLocationInStack(o,a){let h=c=>c.replace(/\\/g,"/"),_=h(o),d=a.split(/\n/);for(let c=0;c<d.length;c++){let e=d[c].match(/(.*):(\d+):(\d+)\)?$/);if(e){let u=e[1],g=e[2],E=e[3],w=Math.max(u.lastIndexOf(" ")+1,u.lastIndexOf("(")+1);if(u=u.substr(w),u=h(u),u===_){let v={line:parseInt(g,10),col:parseInt(E,10)};return v.line===1&&(v.col-=53),v}}}throw new Error("Could not correlate define call site for needle "+o)}getBuildInfo(){if(!this._config.isBuild())return null;let o=[],a=0;for(let h=0,_=this._modules2.length;h<_;h++){let d=this._modules2[h];if(!d)continue;let c=this._buildInfoPath[d.id]||null,e=this._buildInfoDefineStack[d.id]||null,u=this._buildInfoDependencies[d.id];o[a++]={id:d.strId,path:c,defineLocation:c&&e?R._findRelevantLocationInStack(c,e):null,dependencies:u,shim:null,exports:d.exports}}return o}getRecorder(){return this._recorder||(this._config.shouldRecordStats()?this._recorder=new C.LoaderEventRecorder(this._loaderAvailableTimestamp):this._recorder=C.NullLoaderEventRecorder.INSTANCE),this._recorder}getLoaderEvents(){return this.getRecorder().getEvents()}enqueueDefineAnonymousModule(o,a){if(this._currentAnonymousDefineCall!==null)throw new Error("Can only have one anonymous define call per script file");let h=null;this._config.isBuild()&&(h=new Error("StackLocation").stack||null),this._currentAnonymousDefineCall={stack:h,dependencies:o,callback:a}}defineModule(o,a,h,_,d,c=new t(o)){let e=this._moduleIdProvider.getModuleId(o);if(this._modules2[e]){this._config.isDuplicateMessageIgnoredFor(o)||console.warn("Duplicate definition of module '"+o+"'");return}let u=new n(e,o,this._normalizeDependencies(a,c),h,_,c);this._modules2[e]=u,this._config.isBuild()&&(this._buildInfoDefineStack[e]=d,this._buildInfoDependencies[e]=(u.dependencies||[]).map(g=>this._moduleIdProvider.getStrModuleId(g.id))),this._resolve(u)}_normalizeDependency(o,a){if(o==="exports")return M.EXPORTS;if(o==="module")return M.MODULE;if(o==="require")return M.REQUIRE;let h=o.indexOf("!");if(h>=0){let _=a.resolveModule(o.substr(0,h)),d=a.resolveModule(o.substr(h+1)),c=this._moduleIdProvider.getModuleId(_+"!"+d),e=this._moduleIdProvider.getModuleId(_);return new m(c,e,d)}return new M(this._moduleIdProvider.getModuleId(a.resolveModule(o)))}_normalizeDependencies(o,a){let h=[],_=0;for(let d=0,c=o.length;d<c;d++)h[_++]=this._normalizeDependency(o[d],a);return h}_relativeRequire(o,a,h,_){if(typeof a=="string")return this.synchronousRequire(a,o);this.defineModule(C.Utilities.generateAnonymousModule(),a,h,_,null,o)}synchronousRequire(o,a=new t(o)){let h=this._normalizeDependency(o,a),_=this._modules2[h.id];if(!_)throw new Error("Check dependency list! Synchronous require cannot resolve module '"+o+"'. This is the first mention of this module!");if(!_.isComplete())throw new Error("Check dependency list! Synchronous require cannot resolve module '"+o+"'. This module has not been resolved completely yet.");if(_.error)throw _.error;return _.exports}configure(o,a){let h=this._config.shouldRecordStats();a?this._config=new C.Configuration(this._env,o):this._config=this._config.cloneAndMerge(o),this._config.shouldRecordStats()&&!h&&(this._recorder=null)}getConfig(){return this._config}_onLoad(o){if(this._currentAnonymousDefineCall!==null){let a=this._currentAnonymousDefineCall;this._currentAnonymousDefineCall=null,this.defineModule(this._moduleIdProvider.getStrModuleId(o),a.dependencies,a.callback,null,a.stack)}}_createLoadError(o,a){let h=this._moduleIdProvider.getStrModuleId(o),_=(this._inverseDependencies2[o]||[]).map(c=>this._moduleIdProvider.getStrModuleId(c));const d=C.ensureError(a);return d.phase="loading",d.moduleId=h,d.neededBy=_,d}_onLoadError(o,a){const h=this._createLoadError(o,a);this._modules2[o]||(this._modules2[o]=new n(o,this._moduleIdProvider.getStrModuleId(o),[],()=>{},null,null));let _=[];for(let e=0,u=this._moduleIdProvider.getMaxModuleId();e<u;e++)_[e]=!1;let d=!1,c=[];for(c.push(o),_[o]=!0;c.length>0;){let e=c.shift(),u=this._modules2[e];u&&(d=u.onDependencyError(h)||d);let g=this._inverseDependencies2[e];if(g)for(let E=0,w=g.length;E<w;E++){let v=g[E];_[v]||(c.push(v),_[v]=!0)}}d||this._config.onError(h)}_hasDependencyPath(o,a){let h=this._modules2[o];if(!h)return!1;let _=[];for(let c=0,e=this._moduleIdProvider.getMaxModuleId();c<e;c++)_[c]=!1;let d=[];for(d.push(h),_[o]=!0;d.length>0;){let e=d.shift().dependencies;if(e)for(let u=0,g=e.length;u<g;u++){let E=e[u];if(E.id===a)return!0;let w=this._modules2[E.id];w&&!_[E.id]&&(_[E.id]=!0,d.push(w))}}return!1}_findCyclePath(o,a,h){if(o===a||h===50)return[o];let _=this._modules2[o];if(!_)return null;let d=_.dependencies;if(d)for(let c=0,e=d.length;c<e;c++){let u=this._findCyclePath(d[c].id,a,h+1);if(u!==null)return u.push(o),u}return null}_createRequire(o){let a=(h,_,d)=>this._relativeRequire(o,h,_,d);return a.toUrl=h=>this._config.requireToUrl(o.resolveModule(h)),a.getStats=()=>this.getLoaderEvents(),a.hasDependencyCycle=()=>this._hasDependencyCycle,a.config=(h,_=!1)=>{this.configure(h,_)},a.__$__nodeRequire=C.global.nodeRequire,a}_loadModule(o){if(this._modules2[o]||this._knownModules2[o])return;this._knownModules2[o]=!0;let a=this._moduleIdProvider.getStrModuleId(o),h=this._config.moduleIdToPaths(a),_=/^@[^\/]+\/[^\/]+$/;this._env.isNode&&(a.indexOf("/")===-1||_.test(a))&&h.push("node|"+a);let d=-1,c=e=>{if(d++,d>=h.length)this._onLoadError(o,e);else{let u=h[d],g=this.getRecorder();if(this._config.isBuild()&&u==="empty:"){this._buildInfoPath[o]=u,this.defineModule(this._moduleIdProvider.getStrModuleId(o),[],null,null,null),this._onLoad(o);return}g.record(10,u),this._scriptLoader.load(this,u,()=>{this._config.isBuild()&&(this._buildInfoPath[o]=u),g.record(11,u),this._onLoad(o)},E=>{g.record(12,u),c(E)})}};c(null)}_loadPluginDependency(o,a){if(this._modules2[a.id]||this._knownModules2[a.id])return;this._knownModules2[a.id]=!0;let h=_=>{this.defineModule(this._moduleIdProvider.getStrModuleId(a.id),[],_,null,null)};h.error=_=>{this._config.onError(this._createLoadError(a.id,_))},o.load(a.pluginParam,this._createRequire(t.ROOT),h,this._config.getOptionsLiteral())}_resolve(o){let a=o.dependencies;if(a)for(let h=0,_=a.length;h<_;h++){let d=a[h];if(d===M.EXPORTS){o.exportsPassedIn=!0,o.unresolvedDependenciesCount--;continue}if(d===M.MODULE){o.unresolvedDependenciesCount--;continue}if(d===M.REQUIRE){o.unresolvedDependenciesCount--;continue}let c=this._modules2[d.id];if(c&&c.isComplete()){if(c.error){o.onDependencyError(c.error);return}o.unresolvedDependenciesCount--;continue}if(this._hasDependencyPath(d.id,o.id)){this._hasDependencyCycle=!0,console.warn("There is a dependency cycle between '"+this._moduleIdProvider.getStrModuleId(d.id)+"' and '"+this._moduleIdProvider.getStrModuleId(o.id)+"'. The cyclic path follows:");let e=this._findCyclePath(d.id,o.id,0)||[];e.reverse(),e.push(d.id),console.warn(e.map(u=>this._moduleIdProvider.getStrModuleId(u)).join(` => 
`)),o.unresolvedDependenciesCount--;continue}if(this._inverseDependencies2[d.id]=this._inverseDependencies2[d.id]||[],this._inverseDependencies2[d.id].push(o.id),d instanceof m){let e=this._modules2[d.pluginId];if(e&&e.isComplete()){this._loadPluginDependency(e.exports,d);continue}let u=this._inversePluginDependencies2.get(d.pluginId);u||(u=[],this._inversePluginDependencies2.set(d.pluginId,u)),u.push(d),this._loadModule(d.pluginId);continue}this._loadModule(d.id)}o.unresolvedDependenciesCount===0&&this._onModuleComplete(o)}_onModuleComplete(o){let a=this.getRecorder();if(o.isComplete())return;let h=o.dependencies,_=[];if(h)for(let u=0,g=h.length;u<g;u++){let E=h[u];if(E===M.EXPORTS){_[u]=o.exports;continue}if(E===M.MODULE){_[u]={id:o.strId,config:()=>this._config.getConfigForModule(o.strId)};continue}if(E===M.REQUIRE){_[u]=this._createRequire(o.moduleIdResolver);continue}let w=this._modules2[E.id];if(w){_[u]=w.exports;continue}_[u]=null}const d=u=>(this._inverseDependencies2[u]||[]).map(g=>this._moduleIdProvider.getStrModuleId(g));o.complete(a,this._config,_,d);let c=this._inverseDependencies2[o.id];if(this._inverseDependencies2[o.id]=null,c)for(let u=0,g=c.length;u<g;u++){let E=c[u],w=this._modules2[E];w.unresolvedDependenciesCount--,w.unresolvedDependenciesCount===0&&this._onModuleComplete(w)}let e=this._inversePluginDependencies2.get(o.id);if(e){this._inversePluginDependencies2.delete(o.id);for(let u=0,g=e.length;u<g;u++)this._loadPluginDependency(o.exports,e[u])}}}C.ModuleManager=R})(Ae||(Ae={}));var ie,Ae;(function(C){const t=new C.Environment;let n=null;const i=function(b,o,a){typeof b!="string"&&(a=o,o=b,b=null),(typeof o!="object"||!Array.isArray(o))&&(a=o,o=null),o||(o=["require","exports","module"]),b?n.defineModule(b,o,a,null,null):n.enqueueDefineAnonymousModule(o,a)};i.amd={jQuery:!0};const M=function(b,o=!1){n.configure(b,o)},m=function(){if(arguments.length===1){if(arguments[0]instanceof Object&&!Array.isArray(arguments[0])){M(arguments[0]);return}if(typeof arguments[0]=="string")return n.synchronousRequire(arguments[0])}if((arguments.length===2||arguments.length===3)&&Array.isArray(arguments[0])){n.defineModule(C.Utilities.generateAnonymousModule(),arguments[0],arguments[1],arguments[2],null);return}throw new Error("Unrecognized require call")};m.config=M,m.getConfig=function(){return n.getConfig().getOptionsLiteral()},m.reset=function(){n=n.reset()},m.getBuildInfo=function(){return n.getBuildInfo()},m.getStats=function(){return n.getLoaderEvents()},m.define=i;function R(){if(typeof C.global.require<"u"||typeof require<"u"){const b=C.global.require||require;if(typeof b=="function"&&typeof b.resolve=="function"){const o=C.ensureRecordedNodeRequire(n.getRecorder(),b);C.global.nodeRequire=o,m.nodeRequire=o,m.__$__nodeRequire=o}}t.isNode&&!t.isElectronRenderer&&!t.isElectronNodeIntegrationWebWorker?module.exports=m:(t.isElectronRenderer||(C.global.define=i),C.global.require=m)}C.init=R,(typeof C.global.define!="function"||!C.global.define.amd)&&(n=new C.ModuleManager(t,C.createScriptLoader(t),i,m,C.Utilities.getHighPerformanceTimestamp()),typeof C.global.require<"u"&&typeof C.global.require!="function"&&m.config(C.global.require),ie=function(){return i.apply(null,arguments)},ie.amd=i.amd,typeof doNotInitLoader>"u"&&R())})(Ae||(Ae={})),ie(re[83],ae([0,1]),function(C,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.load=n;function n(b,o,a,h){if(h=h||{},(h["vs/css"]||{}).disabled){a({});return}const d=o.toUrl(b+".css");i(b,d,()=>{a({})},c=>{typeof a.error=="function"&&a.error("Could not find "+d+".")})}function i(b,o,a,h){if(M(b,o)){a();return}m(b,o,a,h)}function M(b,o){const a=window.document.getElementsByTagName("link");for(let h=0,_=a.length;h<_;h++){const d=a[h].getAttribute("data-name"),c=a[h].getAttribute("href");if(d===b||c===o)return!0}return!1}function m(b,o,a,h){const _=document.createElement("link");_.setAttribute("rel","stylesheet"),_.setAttribute("type","text/css"),_.setAttribute("data-name",b),R(b,_,a,h),_.setAttribute("href",o),(window.document.head||window.document.getElementsByTagName("head")[0]).appendChild(_)}function R(b,o,a,h){const _=()=>{o.removeEventListener("load",d),o.removeEventListener("error",c)},d=e=>{_(),a()},c=e=>{_(),h(e)};o.addEventListener("load",d),o.addEventListener("error",c)}}),function(){const C=globalThis.MonacoEnvironment,t=C&&C.baseUrl?C.baseUrl:"../../../";function n(_,d){if(C?.createTrustedTypesPolicy)try{return C.createTrustedTypesPolicy(_,d)}catch(c){console.warn(c);return}try{return self.trustedTypes?.createPolicy(_,d)}catch(c){console.warn(c);return}}const i=n("amdLoader",{createScriptURL:_=>_,createScript:(_,...d)=>{const c=d.slice(0,-1).join(","),e=d.pop().toString();return`(function anonymous(${c}) { ${e}
})`}});function M(){try{return(i?globalThis.eval(i.createScript("","true")):new Function("true")).call(globalThis),!0}catch{return!1}}function m(){return new Promise((_,d)=>{if(typeof globalThis.define=="function"&&globalThis.define.amd)return _();const c=t+"vs/loader.js";if(!(/^((http:)|(https:)|(file:))/.test(c)&&c.substring(0,globalThis.origin.length)!==globalThis.origin)&&M()){fetch(c).then(u=>{if(u.status!==200)throw new Error(u.statusText);return u.text()}).then(u=>{u=`${u}
//# sourceURL=${c}`,(i?globalThis.eval(i.createScript("",u)):new Function(u)).call(globalThis),_()}).then(void 0,d);return}i?importScripts(i.createScriptURL(c)):importScripts(c),_()})}function R(){require.config({baseUrl:t,catchError:!0,trustedTypesPolicy:i,amdModulesPattern:/^vs\//})}function b(_){return m().then(()=>(R(),new Promise((d,c)=>{require([_],d,c)})))}function o(_){setTimeout(function(){const d=_.create((c,e)=>{globalThis.postMessage(c,e)});for(self.onmessage=c=>d.onmessage(c.data,c.ports);h.length>0;)self.onmessage(h.shift())},0)}typeof globalThis.define=="function"&&globalThis.define.amd&&R();let a=!0;const h=[];globalThis.onmessage=_=>{if(!a){h.push(_);return}a=!1,b(_.data).then(d=>{o(d)},d=>{console.error(d)})}}(),ie(re[11],ae([0,1]),function(C,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.MonotonousArray=void 0,t.findLast=n,t.findLastIdx=i,t.findLastMonotonous=M,t.findLastIdxMonotonous=m,t.findFirstMonotonous=R,t.findFirstIdxMonotonousOrArrLen=b,t.findFirstIdxMonotonous=o,t.findFirstMax=h,t.findLastMax=_,t.findFirstMin=d,t.findMaxIdx=c,t.mapFindFirst=e;function n(u,g){const E=i(u,g);if(E!==-1)return u[E]}function i(u,g,E=u.length-1){for(let w=E;w>=0;w--){const v=u[w];if(g(v))return w}return-1}function M(u,g){const E=m(u,g);return E===-1?void 0:u[E]}function m(u,g,E=0,w=u.length){let v=E,A=w;for(;v<A;){const L=Math.floor((v+A)/2);g(u[L])?v=L+1:A=L}return v-1}function R(u,g){const E=b(u,g);return E===u.length?void 0:u[E]}function b(u,g,E=0,w=u.length){let v=E,A=w;for(;v<A;){const L=Math.floor((v+A)/2);g(u[L])?A=L:v=L+1}return v}function o(u,g,E=0,w=u.length){const v=b(u,g,E,w);return v===u.length?-1:v}class a{static{this.assertInvariants=!1}constructor(g){this._array=g,this._findLastMonotonousLastIdx=0}findLastMonotonous(g){if(a.assertInvariants){if(this._prevFindLastPredicate){for(const w of this._array)if(this._prevFindLastPredicate(w)&&!g(w))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this._prevFindLastPredicate=g}const E=m(this._array,g,this._findLastMonotonousLastIdx);return this._findLastMonotonousLastIdx=E+1,E===-1?void 0:this._array[E]}}t.MonotonousArray=a;function h(u,g){if(u.length===0)return;let E=u[0];for(let w=1;w<u.length;w++){const v=u[w];g(v,E)>0&&(E=v)}return E}function _(u,g){if(u.length===0)return;let E=u[0];for(let w=1;w<u.length;w++){const v=u[w];g(v,E)>=0&&(E=v)}return E}function d(u,g){return h(u,(E,w)=>-g(E,w))}function c(u,g){if(u.length===0)return-1;let E=0;for(let w=1;w<u.length;w++){const v=u[w];g(v,u[E])>0&&(E=w)}return E}function e(u,g){for(const E of u){const w=g(E);if(w!==void 0)return w}}}),ie(re[3],ae([0,1]),function(C,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CharCode=void 0;var n;(function(i){i[i.Null=0]="Null",i[i.Backspace=8]="Backspace",i[i.Tab=9]="Tab",i[i.LineFeed=10]="LineFeed",i[i.CarriageReturn=13]="CarriageReturn",i[i.Space=32]="Space",i[i.ExclamationMark=33]="ExclamationMark",i[i.DoubleQuote=34]="DoubleQuote",i[i.Hash=35]="Hash",i[i.DollarSign=36]="DollarSign",i[i.PercentSign=37]="PercentSign",i[i.Ampersand=38]="Ampersand",i[i.SingleQuote=39]="SingleQuote",i[i.OpenParen=40]="OpenParen",i[i.CloseParen=41]="CloseParen",i[i.Asterisk=42]="Asterisk",i[i.Plus=43]="Plus",i[i.Comma=44]="Comma",i[i.Dash=45]="Dash",i[i.Period=46]="Period",i[i.Slash=47]="Slash",i[i.Digit0=48]="Digit0",i[i.Digit1=49]="Digit1",i[i.Digit2=50]="Digit2",i[i.Digit3=51]="Digit3",i[i.Digit4=52]="Digit4",i[i.Digit5=53]="Digit5",i[i.Digit6=54]="Digit6",i[i.Digit7=55]="Digit7",i[i.Digit8=56]="Digit8",i[i.Digit9=57]="Digit9",i[i.Colon=58]="Colon",i[i.Semicolon=59]="Semicolon",i[i.LessThan=60]="LessThan",i[i.Equals=61]="Equals",i[i.GreaterThan=62]="GreaterThan",i[i.QuestionMark=63]="QuestionMark",i[i.AtSign=64]="AtSign",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.OpenSquareBracket=91]="OpenSquareBracket",i[i.Backslash=92]="Backslash",i[i.CloseSquareBracket=93]="CloseSquareBracket",i[i.Caret=94]="Caret",i[i.Underline=95]="Underline",i[i.BackTick=96]="BackTick",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.OpenCurlyBrace=123]="OpenCurlyBrace",i[i.Pipe=124]="Pipe",i[i.CloseCurlyBrace=125]="CloseCurlyBrace",i[i.Tilde=126]="Tilde",i[i.NoBreakSpace=160]="NoBreakSpace",i[i.U_Combining_Grave_Accent=768]="U_Combining_Grave_Accent",i[i.U_Combining_Acute_Accent=769]="U_Combining_Acute_Accent",i[i.U_Combining_Circumflex_Accent=770]="U_Combining_Circumflex_Accent",i[i.U_Combining_Tilde=771]="U_Combining_Tilde",i[i.U_Combining_Macron=772]="U_Combining_Macron",i[i.U_Combining_Overline=773]="U_Combining_Overline",i[i.U_Combining_Breve=774]="U_Combining_Breve",i[i.U_Combining_Dot_Above=775]="U_Combining_Dot_Above",i[i.U_Combining_Diaeresis=776]="U_Combining_Diaeresis",i[i.U_Combining_Hook_Above=777]="U_Combining_Hook_Above",i[i.U_Combining_Ring_Above=778]="U_Combining_Ring_Above",i[i.U_Combining_Double_Acute_Accent=779]="U_Combining_Double_Acute_Accent",i[i.U_Combining_Caron=780]="U_Combining_Caron",i[i.U_Combining_Vertical_Line_Above=781]="U_Combining_Vertical_Line_Above",i[i.U_Combining_Double_Vertical_Line_Above=782]="U_Combining_Double_Vertical_Line_Above",i[i.U_Combining_Double_Grave_Accent=783]="U_Combining_Double_Grave_Accent",i[i.U_Combining_Candrabindu=784]="U_Combining_Candrabindu",i[i.U_Combining_Inverted_Breve=785]="U_Combining_Inverted_Breve",i[i.U_Combining_Turned_Comma_Above=786]="U_Combining_Turned_Comma_Above",i[i.U_Combining_Comma_Above=787]="U_Combining_Comma_Above",i[i.U_Combining_Reversed_Comma_Above=788]="U_Combining_Reversed_Comma_Above",i[i.U_Combining_Comma_Above_Right=789]="U_Combining_Comma_Above_Right",i[i.U_Combining_Grave_Accent_Below=790]="U_Combining_Grave_Accent_Below",i[i.U_Combining_Acute_Accent_Below=791]="U_Combining_Acute_Accent_Below",i[i.U_Combining_Left_Tack_Below=792]="U_Combining_Left_Tack_Below",i[i.U_Combining_Right_Tack_Below=793]="U_Combining_Right_Tack_Below",i[i.U_Combining_Left_Angle_Above=794]="U_Combining_Left_Angle_Above",i[i.U_Combining_Horn=795]="U_Combining_Horn",i[i.U_Combining_Left_Half_Ring_Below=796]="U_Combining_Left_Half_Ring_Below",i[i.U_Combining_Up_Tack_Below=797]="U_Combining_Up_Tack_Below",i[i.U_Combining_Down_Tack_Below=798]="U_Combining_Down_Tack_Below",i[i.U_Combining_Plus_Sign_Below=799]="U_Combining_Plus_Sign_Below",i[i.U_Combining_Minus_Sign_Below=800]="U_Combining_Minus_Sign_Below",i[i.U_Combining_Palatalized_Hook_Below=801]="U_Combining_Palatalized_Hook_Below",i[i.U_Combining_Retroflex_Hook_Below=802]="U_Combining_Retroflex_Hook_Below",i[i.U_Combining_Dot_Below=803]="U_Combining_Dot_Below",i[i.U_Combining_Diaeresis_Below=804]="U_Combining_Diaeresis_Below",i[i.U_Combining_Ring_Below=805]="U_Combining_Ring_Below",i[i.U_Combining_Comma_Below=806]="U_Combining_Comma_Below",i[i.U_Combining_Cedilla=807]="U_Combining_Cedilla",i[i.U_Combining_Ogonek=808]="U_Combining_Ogonek",i[i.U_Combining_Vertical_Line_Below=809]="U_Combining_Vertical_Line_Below",i[i.U_Combining_Bridge_Below=810]="U_Combining_Bridge_Below",i[i.U_Combining_Inverted_Double_Arch_Below=811]="U_Combining_Inverted_Double_Arch_Below",i[i.U_Combining_Caron_Below=812]="U_Combining_Caron_Below",i[i.U_Combining_Circumflex_Accent_Below=813]="U_Combining_Circumflex_Accent_Below",i[i.U_Combining_Breve_Below=814]="U_Combining_Breve_Below",i[i.U_Combining_Inverted_Breve_Below=815]="U_Combining_Inverted_Breve_Below",i[i.U_Combining_Tilde_Below=816]="U_Combining_Tilde_Below",i[i.U_Combining_Macron_Below=817]="U_Combining_Macron_Below",i[i.U_Combining_Low_Line=818]="U_Combining_Low_Line",i[i.U_Combining_Double_Low_Line=819]="U_Combining_Double_Low_Line",i[i.U_Combining_Tilde_Overlay=820]="U_Combining_Tilde_Overlay",i[i.U_Combining_Short_Stroke_Overlay=821]="U_Combining_Short_Stroke_Overlay",i[i.U_Combining_Long_Stroke_Overlay=822]="U_Combining_Long_Stroke_Overlay",i[i.U_Combining_Short_Solidus_Overlay=823]="U_Combining_Short_Solidus_Overlay",i[i.U_Combining_Long_Solidus_Overlay=824]="U_Combining_Long_Solidus_Overlay",i[i.U_Combining_Right_Half_Ring_Below=825]="U_Combining_Right_Half_Ring_Below",i[i.U_Combining_Inverted_Bridge_Below=826]="U_Combining_Inverted_Bridge_Below",i[i.U_Combining_Square_Below=827]="U_Combining_Square_Below",i[i.U_Combining_Seagull_Below=828]="U_Combining_Seagull_Below",i[i.U_Combining_X_Above=829]="U_Combining_X_Above",i[i.U_Combining_Vertical_Tilde=830]="U_Combining_Vertical_Tilde",i[i.U_Combining_Double_Overline=831]="U_Combining_Double_Overline",i[i.U_Combining_Grave_Tone_Mark=832]="U_Combining_Grave_Tone_Mark",i[i.U_Combining_Acute_Tone_Mark=833]="U_Combining_Acute_Tone_Mark",i[i.U_Combining_Greek_Perispomeni=834]="U_Combining_Greek_Perispomeni",i[i.U_Combining_Greek_Koronis=835]="U_Combining_Greek_Koronis",i[i.U_Combining_Greek_Dialytika_Tonos=836]="U_Combining_Greek_Dialytika_Tonos",i[i.U_Combining_Greek_Ypogegrammeni=837]="U_Combining_Greek_Ypogegrammeni",i[i.U_Combining_Bridge_Above=838]="U_Combining_Bridge_Above",i[i.U_Combining_Equals_Sign_Below=839]="U_Combining_Equals_Sign_Below",i[i.U_Combining_Double_Vertical_Line_Below=840]="U_Combining_Double_Vertical_Line_Below",i[i.U_Combining_Left_Angle_Below=841]="U_Combining_Left_Angle_Below",i[i.U_Combining_Not_Tilde_Above=842]="U_Combining_Not_Tilde_Above",i[i.U_Combining_Homothetic_Above=843]="U_Combining_Homothetic_Above",i[i.U_Combining_Almost_Equal_To_Above=844]="U_Combining_Almost_Equal_To_Above",i[i.U_Combining_Left_Right_Arrow_Below=845]="U_Combining_Left_Right_Arrow_Below",i[i.U_Combining_Upwards_Arrow_Below=846]="U_Combining_Upwards_Arrow_Below",i[i.U_Combining_Grapheme_Joiner=847]="U_Combining_Grapheme_Joiner",i[i.U_Combining_Right_Arrowhead_Above=848]="U_Combining_Right_Arrowhead_Above",i[i.U_Combining_Left_Half_Ring_Above=849]="U_Combining_Left_Half_Ring_Above",i[i.U_Combining_Fermata=850]="U_Combining_Fermata",i[i.U_Combining_X_Below=851]="U_Combining_X_Below",i[i.U_Combining_Left_Arrowhead_Below=852]="U_Combining_Left_Arrowhead_Below",i[i.U_Combining_Right_Arrowhead_Below=853]="U_Combining_Right_Arrowhead_Below",i[i.U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below=854]="U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below",i[i.U_Combining_Right_Half_Ring_Above=855]="U_Combining_Right_Half_Ring_Above",i[i.U_Combining_Dot_Above_Right=856]="U_Combining_Dot_Above_Right",i[i.U_Combining_Asterisk_Below=857]="U_Combining_Asterisk_Below",i[i.U_Combining_Double_Ring_Below=858]="U_Combining_Double_Ring_Below",i[i.U_Combining_Zigzag_Above=859]="U_Combining_Zigzag_Above",i[i.U_Combining_Double_Breve_Below=860]="U_Combining_Double_Breve_Below",i[i.U_Combining_Double_Breve=861]="U_Combining_Double_Breve",i[i.U_Combining_Double_Macron=862]="U_Combining_Double_Macron",i[i.U_Combining_Double_Macron_Below=863]="U_Combining_Double_Macron_Below",i[i.U_Combining_Double_Tilde=864]="U_Combining_Double_Tilde",i[i.U_Combining_Double_Inverted_Breve=865]="U_Combining_Double_Inverted_Breve",i[i.U_Combining_Double_Rightwards_Arrow_Below=866]="U_Combining_Double_Rightwards_Arrow_Below",i[i.U_Combining_Latin_Small_Letter_A=867]="U_Combining_Latin_Small_Letter_A",i[i.U_Combining_Latin_Small_Letter_E=868]="U_Combining_Latin_Small_Letter_E",i[i.U_Combining_Latin_Small_Letter_I=869]="U_Combining_Latin_Small_Letter_I",i[i.U_Combining_Latin_Small_Letter_O=870]="U_Combining_Latin_Small_Letter_O",i[i.U_Combining_Latin_Small_Letter_U=871]="U_Combining_Latin_Small_Letter_U",i[i.U_Combining_Latin_Small_Letter_C=872]="U_Combining_Latin_Small_Letter_C",i[i.U_Combining_Latin_Small_Letter_D=873]="U_Combining_Latin_Small_Letter_D",i[i.U_Combining_Latin_Small_Letter_H=874]="U_Combining_Latin_Small_Letter_H",i[i.U_Combining_Latin_Small_Letter_M=875]="U_Combining_Latin_Small_Letter_M",i[i.U_Combining_Latin_Small_Letter_R=876]="U_Combining_Latin_Small_Letter_R",i[i.U_Combining_Latin_Small_Letter_T=877]="U_Combining_Latin_Small_Letter_T",i[i.U_Combining_Latin_Small_Letter_V=878]="U_Combining_Latin_Small_Letter_V",i[i.U_Combining_Latin_Small_Letter_X=879]="U_Combining_Latin_Small_Letter_X",i[i.LINE_SEPARATOR=8232]="LINE_SEPARATOR",i[i.PARAGRAPH_SEPARATOR=8233]="PARAGRAPH_SEPARATOR",i[i.NEXT_LINE=133]="NEXT_LINE",i[i.U_CIRCUMFLEX=94]="U_CIRCUMFLEX",i[i.U_GRAVE_ACCENT=96]="U_GRAVE_ACCENT",i[i.U_DIAERESIS=168]="U_DIAERESIS",i[i.U_MACRON=175]="U_MACRON",i[i.U_ACUTE_ACCENT=180]="U_ACUTE_ACCENT",i[i.U_CEDILLA=184]="U_CEDILLA",i[i.U_MODIFIER_LETTER_LEFT_ARROWHEAD=706]="U_MODIFIER_LETTER_LEFT_ARROWHEAD",i[i.U_MODIFIER_LETTER_RIGHT_ARROWHEAD=707]="U_MODIFIER_LETTER_RIGHT_ARROWHEAD",i[i.U_MODIFIER_LETTER_UP_ARROWHEAD=708]="U_MODIFIER_LETTER_UP_ARROWHEAD",i[i.U_MODIFIER_LETTER_DOWN_ARROWHEAD=709]="U_MODIFIER_LETTER_DOWN_ARROWHEAD",i[i.U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING=722]="U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING",i[i.U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING=723]="U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING",i[i.U_MODIFIER_LETTER_UP_TACK=724]="U_MODIFIER_LETTER_UP_TACK",i[i.U_MODIFIER_LETTER_DOWN_TACK=725]="U_MODIFIER_LETTER_DOWN_TACK",i[i.U_MODIFIER_LETTER_PLUS_SIGN=726]="U_MODIFIER_LETTER_PLUS_SIGN",i[i.U_MODIFIER_LETTER_MINUS_SIGN=727]="U_MODIFIER_LETTER_MINUS_SIGN",i[i.U_BREVE=728]="U_BREVE",i[i.U_DOT_ABOVE=729]="U_DOT_ABOVE",i[i.U_RING_ABOVE=730]="U_RING_ABOVE",i[i.U_OGONEK=731]="U_OGONEK",i[i.U_SMALL_TILDE=732]="U_SMALL_TILDE",i[i.U_DOUBLE_ACUTE_ACCENT=733]="U_DOUBLE_ACUTE_ACCENT",i[i.U_MODIFIER_LETTER_RHOTIC_HOOK=734]="U_MODIFIER_LETTER_RHOTIC_HOOK",i[i.U_MODIFIER_LETTER_CROSS_ACCENT=735]="U_MODIFIER_LETTER_CROSS_ACCENT",i[i.U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR=741]="U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR",i[i.U_MODIFIER_LETTER_HIGH_TONE_BAR=742]="U_MODIFIER_LETTER_HIGH_TONE_BAR",i[i.U_MODIFIER_LETTER_MID_TONE_BAR=743]="U_MODIFIER_LETTER_MID_TONE_BAR",i[i.U_MODIFIER_LETTER_LOW_TONE_BAR=744]="U_MODIFIER_LETTER_LOW_TONE_BAR",i[i.U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR=745]="U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR",i[i.U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK=746]="U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK",i[i.U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK=747]="U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK",i[i.U_MODIFIER_LETTER_UNASPIRATED=749]="U_MODIFIER_LETTER_UNASPIRATED",i[i.U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD=751]="U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD",i[i.U_MODIFIER_LETTER_LOW_UP_ARROWHEAD=752]="U_MODIFIER_LETTER_LOW_UP_ARROWHEAD",i[i.U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD=753]="U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD",i[i.U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD=754]="U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD",i[i.U_MODIFIER_LETTER_LOW_RING=755]="U_MODIFIER_LETTER_LOW_RING",i[i.U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT=756]="U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT",i[i.U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT=757]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT",i[i.U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT=758]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT",i[i.U_MODIFIER_LETTER_LOW_TILDE=759]="U_MODIFIER_LETTER_LOW_TILDE",i[i.U_MODIFIER_LETTER_RAISED_COLON=760]="U_MODIFIER_LETTER_RAISED_COLON",i[i.U_MODIFIER_LETTER_BEGIN_HIGH_TONE=761]="U_MODIFIER_LETTER_BEGIN_HIGH_TONE",i[i.U_MODIFIER_LETTER_END_HIGH_TONE=762]="U_MODIFIER_LETTER_END_HIGH_TONE",i[i.U_MODIFIER_LETTER_BEGIN_LOW_TONE=763]="U_MODIFIER_LETTER_BEGIN_LOW_TONE",i[i.U_MODIFIER_LETTER_END_LOW_TONE=764]="U_MODIFIER_LETTER_END_LOW_TONE",i[i.U_MODIFIER_LETTER_SHELF=765]="U_MODIFIER_LETTER_SHELF",i[i.U_MODIFIER_LETTER_OPEN_SHELF=766]="U_MODIFIER_LETTER_OPEN_SHELF",i[i.U_MODIFIER_LETTER_LOW_LEFT_ARROW=767]="U_MODIFIER_LETTER_LOW_LEFT_ARROW",i[i.U_GREEK_LOWER_NUMERAL_SIGN=885]="U_GREEK_LOWER_NUMERAL_SIGN",i[i.U_GREEK_TONOS=900]="U_GREEK_TONOS",i[i.U_GREEK_DIALYTIKA_TONOS=901]="U_GREEK_DIALYTIKA_TONOS",i[i.U_GREEK_KORONIS=8125]="U_GREEK_KORONIS",i[i.U_GREEK_PSILI=8127]="U_GREEK_PSILI",i[i.U_GREEK_PERISPOMENI=8128]="U_GREEK_PERISPOMENI",i[i.U_GREEK_DIALYTIKA_AND_PERISPOMENI=8129]="U_GREEK_DIALYTIKA_AND_PERISPOMENI",i[i.U_GREEK_PSILI_AND_VARIA=8141]="U_GREEK_PSILI_AND_VARIA",i[i.U_GREEK_PSILI_AND_OXIA=8142]="U_GREEK_PSILI_AND_OXIA",i[i.U_GREEK_PSILI_AND_PERISPOMENI=8143]="U_GREEK_PSILI_AND_PERISPOMENI",i[i.U_GREEK_DASIA_AND_VARIA=8157]="U_GREEK_DASIA_AND_VARIA",i[i.U_GREEK_DASIA_AND_OXIA=8158]="U_GREEK_DASIA_AND_OXIA",i[i.U_GREEK_DASIA_AND_PERISPOMENI=8159]="U_GREEK_DASIA_AND_PERISPOMENI",i[i.U_GREEK_DIALYTIKA_AND_VARIA=8173]="U_GREEK_DIALYTIKA_AND_VARIA",i[i.U_GREEK_DIALYTIKA_AND_OXIA=8174]="U_GREEK_DIALYTIKA_AND_OXIA",i[i.U_GREEK_VARIA=8175]="U_GREEK_VARIA",i[i.U_GREEK_OXIA=8189]="U_GREEK_OXIA",i[i.U_GREEK_DASIA=8190]="U_GREEK_DASIA",i[i.U_IDEOGRAPHIC_FULL_STOP=12290]="U_IDEOGRAPHIC_FULL_STOP",i[i.U_LEFT_CORNER_BRACKET=12300]="U_LEFT_CORNER_BRACKET",i[i.U_RIGHT_CORNER_BRACKET=12301]="U_RIGHT_CORNER_BRACKET",i[i.U_LEFT_BLACK_LENTICULAR_BRACKET=12304]="U_LEFT_BLACK_LENTICULAR_BRACKET",i[i.U_RIGHT_BLACK_LENTICULAR_BRACKET=12305]="U_RIGHT_BLACK_LENTICULAR_BRACKET",i[i.U_OVERLINE=8254]="U_OVERLINE",i[i.UTF8_BOM=65279]="UTF8_BOM",i[i.U_FULLWIDTH_SEMICOLON=65307]="U_FULLWIDTH_SEMICOLON",i[i.U_FULLWIDTH_COMMA=65292]="U_FULLWIDTH_COMMA"})(n||(t.CharCode=n={}))}),ie(re[42],ae([0,1]),function(C,t){"use strict";var n;Object.defineProperty(t,"__esModule",{value:!0}),t.SetWithKey=void 0,t.groupBy=i,t.diffSets=M,t.diffMaps=m,t.intersection=R;function i(o,a){const h=Object.create(null);for(const _ of o){const d=a(_);let c=h[d];c||(c=h[d]=[]),c.push(_)}return h}function M(o,a){const h=[],_=[];for(const d of o)a.has(d)||h.push(d);for(const d of a)o.has(d)||_.push(d);return{removed:h,added:_}}function m(o,a){const h=[],_=[];for(const[d,c]of o)a.has(d)||h.push(c);for(const[d,c]of a)o.has(d)||_.push(c);return{removed:h,added:_}}function R(o,a){const h=new Set;for(const _ of a)o.has(_)&&h.add(_);return h}class b{static{n=Symbol.toStringTag}constructor(a,h){this.toKey=h,this._map=new Map,this[n]="SetWithKey";for(const _ of a)this.add(_)}get size(){return this._map.size}add(a){const h=this.toKey(a);return this._map.set(h,a),this}delete(a){return this._map.delete(this.toKey(a))}has(a){return this._map.has(this.toKey(a))}*entries(){for(const a of this._map.values())yield[a,a]}keys(){return this.values()}*values(){for(const a of this._map.values())yield a}clear(){this._map.clear()}forEach(a,h){this._map.forEach(_=>a.call(h,_,_,this))}[Symbol.iterator](){return this.values()}}t.SetWithKey=b}),ie(re[43],ae([0,1,3]),function(C,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Color=t.HSVA=t.HSLA=t.RGBA=void 0;function i(o,a){const h=Math.pow(10,a);return Math.round(o*h)/h}class M{constructor(a,h,_,d=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,a))|0,this.g=Math.min(255,Math.max(0,h))|0,this.b=Math.min(255,Math.max(0,_))|0,this.a=i(Math.max(Math.min(1,d),0),3)}static equals(a,h){return a.r===h.r&&a.g===h.g&&a.b===h.b&&a.a===h.a}}t.RGBA=M;class m{constructor(a,h,_,d){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,a),0)|0,this.s=i(Math.max(Math.min(1,h),0),3),this.l=i(Math.max(Math.min(1,_),0),3),this.a=i(Math.max(Math.min(1,d),0),3)}static equals(a,h){return a.h===h.h&&a.s===h.s&&a.l===h.l&&a.a===h.a}static fromRGBA(a){const h=a.r/255,_=a.g/255,d=a.b/255,c=a.a,e=Math.max(h,_,d),u=Math.min(h,_,d);let g=0,E=0;const w=(u+e)/2,v=e-u;if(v>0){switch(E=Math.min(w<=.5?v/(2*w):v/(2-2*w),1),e){case h:g=(_-d)/v+(_<d?6:0);break;case _:g=(d-h)/v+2;break;case d:g=(h-_)/v+4;break}g*=60,g=Math.round(g)}return new m(g,E,w,c)}static _hue2rgb(a,h,_){return _<0&&(_+=1),_>1&&(_-=1),_<1/6?a+(h-a)*6*_:_<1/2?h:_<2/3?a+(h-a)*(2/3-_)*6:a}static toRGBA(a){const h=a.h/360,{s:_,l:d,a:c}=a;let e,u,g;if(_===0)e=u=g=d;else{const E=d<.5?d*(1+_):d+_-d*_,w=2*d-E;e=m._hue2rgb(w,E,h+1/3),u=m._hue2rgb(w,E,h),g=m._hue2rgb(w,E,h-1/3)}return new M(Math.round(e*255),Math.round(u*255),Math.round(g*255),c)}}t.HSLA=m;class R{constructor(a,h,_,d){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,a),0)|0,this.s=i(Math.max(Math.min(1,h),0),3),this.v=i(Math.max(Math.min(1,_),0),3),this.a=i(Math.max(Math.min(1,d),0),3)}static equals(a,h){return a.h===h.h&&a.s===h.s&&a.v===h.v&&a.a===h.a}static fromRGBA(a){const h=a.r/255,_=a.g/255,d=a.b/255,c=Math.max(h,_,d),e=Math.min(h,_,d),u=c-e,g=c===0?0:u/c;let E;return u===0?E=0:c===h?E=((_-d)/u%6+6)%6:c===_?E=(d-h)/u+2:E=(h-_)/u+4,new R(Math.round(E*60),g,c,a.a)}static toRGBA(a){const{h,s:_,v:d,a:c}=a,e=d*_,u=e*(1-Math.abs(h/60%2-1)),g=d-e;let[E,w,v]=[0,0,0];return h<60?(E=e,w=u):h<120?(E=u,w=e):h<180?(w=e,v=u):h<240?(w=u,v=e):h<300?(E=u,v=e):h<=360&&(E=e,v=u),E=Math.round((E+g)*255),w=Math.round((w+g)*255),v=Math.round((v+g)*255),new M(E,w,v,c)}}t.HSVA=R;class b{static fromHex(a){return b.Format.CSS.parseHex(a)||b.red}static equals(a,h){return!a&&!h?!0:!a||!h?!1:a.equals(h)}get hsla(){return this._hsla?this._hsla:m.fromRGBA(this.rgba)}get hsva(){return this._hsva?this._hsva:R.fromRGBA(this.rgba)}constructor(a){if(a)if(a instanceof M)this.rgba=a;else if(a instanceof m)this._hsla=a,this.rgba=m.toRGBA(a);else if(a instanceof R)this._hsva=a,this.rgba=R.toRGBA(a);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(a){return!!a&&M.equals(this.rgba,a.rgba)&&m.equals(this.hsla,a.hsla)&&R.equals(this.hsva,a.hsva)}getRelativeLuminance(){const a=b._relativeLuminanceForComponent(this.rgba.r),h=b._relativeLuminanceForComponent(this.rgba.g),_=b._relativeLuminanceForComponent(this.rgba.b),d=.2126*a+.7152*h+.0722*_;return i(d,4)}static _relativeLuminanceForComponent(a){const h=a/255;return h<=.03928?h/12.92:Math.pow((h+.055)/1.055,2.4)}getContrastRatio(a){const h=this.getRelativeLuminance(),_=a.getRelativeLuminance();return h>_?(h+.05)/(_+.05):(_+.05)/(h+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(a){const h=this.getRelativeLuminance(),_=a.getRelativeLuminance();return h>_}isDarkerThan(a){const h=this.getRelativeLuminance(),_=a.getRelativeLuminance();return h<_}lighten(a){return new b(new m(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*a,this.hsla.a))}darken(a){return new b(new m(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*a,this.hsla.a))}transparent(a){const{r:h,g:_,b:d,a:c}=this.rgba;return new b(new M(h,_,d,c*a))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new b(new M(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(a){const h=a.rgba,_=this.rgba.a,d=h.a,c=_+d*(1-_);if(c<1e-6)return b.transparent;const e=this.rgba.r*_/c+h.r*d*(1-_)/c,u=this.rgba.g*_/c+h.g*d*(1-_)/c,g=this.rgba.b*_/c+h.b*d*(1-_)/c;return new b(new M(e,u,g,c))}makeOpaque(a){if(this.isOpaque()||a.rgba.a!==1)return this;const{r:h,g:_,b:d,a:c}=this.rgba;return new b(new M(a.rgba.r-c*(a.rgba.r-h),a.rgba.g-c*(a.rgba.g-_),a.rgba.b-c*(a.rgba.b-d),1))}flatten(...a){const h=a.reduceRight((_,d)=>b._flatten(d,_));return b._flatten(this,h)}static _flatten(a,h){const _=1-a.rgba.a;return new b(new M(_*h.rgba.r+a.rgba.a*a.rgba.r,_*h.rgba.g+a.rgba.a*a.rgba.g,_*h.rgba.b+a.rgba.a*a.rgba.b))}toString(){return this._toString||(this._toString=b.Format.CSS.format(this)),this._toString}static getLighterColor(a,h,_){if(a.isLighterThan(h))return a;_=_||.5;const d=a.getRelativeLuminance(),c=h.getRelativeLuminance();return _=_*(c-d)/c,a.lighten(_)}static getDarkerColor(a,h,_){if(a.isDarkerThan(h))return a;_=_||.5;const d=a.getRelativeLuminance(),c=h.getRelativeLuminance();return _=_*(d-c)/d,a.darken(_)}static{this.white=new b(new M(255,255,255,1))}static{this.black=new b(new M(0,0,0,1))}static{this.red=new b(new M(255,0,0,1))}static{this.blue=new b(new M(0,0,255,1))}static{this.green=new b(new M(0,255,0,1))}static{this.cyan=new b(new M(0,255,255,1))}static{this.lightgrey=new b(new M(211,211,211,1))}static{this.transparent=new b(new M(0,0,0,0))}}t.Color=b,function(o){let a;(function(h){let _;(function(d){function c(s){return s.rgba.a===1?`rgb(${s.rgba.r}, ${s.rgba.g}, ${s.rgba.b})`:o.Format.CSS.formatRGBA(s)}d.formatRGB=c;function e(s){return`rgba(${s.rgba.r}, ${s.rgba.g}, ${s.rgba.b}, ${+s.rgba.a.toFixed(2)})`}d.formatRGBA=e;function u(s){return s.hsla.a===1?`hsl(${s.hsla.h}, ${(s.hsla.s*100).toFixed(2)}%, ${(s.hsla.l*100).toFixed(2)}%)`:o.Format.CSS.formatHSLA(s)}d.formatHSL=u;function g(s){return`hsla(${s.hsla.h}, ${(s.hsla.s*100).toFixed(2)}%, ${(s.hsla.l*100).toFixed(2)}%, ${s.hsla.a.toFixed(2)})`}d.formatHSLA=g;function E(s){const f=s.toString(16);return f.length!==2?"0"+f:f}function w(s){return`#${E(s.rgba.r)}${E(s.rgba.g)}${E(s.rgba.b)}`}d.formatHex=w;function v(s,f=!1){return f&&s.rgba.a===1?o.Format.CSS.formatHex(s):`#${E(s.rgba.r)}${E(s.rgba.g)}${E(s.rgba.b)}${E(Math.round(s.rgba.a*255))}`}d.formatHexA=v;function A(s){return s.isOpaque()?o.Format.CSS.formatHex(s):o.Format.CSS.formatRGBA(s)}d.format=A;function L(s){const f=s.length;if(f===0||s.charCodeAt(0)!==n.CharCode.Hash)return null;if(f===7){const p=16*l(s.charCodeAt(1))+l(s.charCodeAt(2)),I=16*l(s.charCodeAt(3))+l(s.charCodeAt(4)),N=16*l(s.charCodeAt(5))+l(s.charCodeAt(6));return new o(new M(p,I,N,1))}if(f===9){const p=16*l(s.charCodeAt(1))+l(s.charCodeAt(2)),I=16*l(s.charCodeAt(3))+l(s.charCodeAt(4)),N=16*l(s.charCodeAt(5))+l(s.charCodeAt(6)),S=16*l(s.charCodeAt(7))+l(s.charCodeAt(8));return new o(new M(p,I,N,S/255))}if(f===4){const p=l(s.charCodeAt(1)),I=l(s.charCodeAt(2)),N=l(s.charCodeAt(3));return new o(new M(16*p+p,16*I+I,16*N+N))}if(f===5){const p=l(s.charCodeAt(1)),I=l(s.charCodeAt(2)),N=l(s.charCodeAt(3)),S=l(s.charCodeAt(4));return new o(new M(16*p+p,16*I+I,16*N+N,(16*S+S)/255))}return null}d.parseHex=L;function l(s){switch(s){case n.CharCode.Digit0:return 0;case n.CharCode.Digit1:return 1;case n.CharCode.Digit2:return 2;case n.CharCode.Digit3:return 3;case n.CharCode.Digit4:return 4;case n.CharCode.Digit5:return 5;case n.CharCode.Digit6:return 6;case n.CharCode.Digit7:return 7;case n.CharCode.Digit8:return 8;case n.CharCode.Digit9:return 9;case n.CharCode.a:return 10;case n.CharCode.A:return 10;case n.CharCode.b:return 11;case n.CharCode.B:return 11;case n.CharCode.c:return 12;case n.CharCode.C:return 12;case n.CharCode.d:return 13;case n.CharCode.D:return 13;case n.CharCode.e:return 14;case n.CharCode.E:return 14;case n.CharCode.f:return 15;case n.CharCode.F:return 15}return 0}})(_=h.CSS||(h.CSS={}))})(a=o.Format||(o.Format={}))}(b||(t.Color=b={}))}),ie(re[44],ae([0,1]),function(C,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DiffChange=void 0;class n{constructor(M,m,R,b){this.originalStart=M,this.originalLength=m,this.modifiedStart=R,this.modifiedLength=b}getOriginalEnd(){return this.originalStart+this.originalLength}getModifiedEnd(){return this.modifiedStart+this.modifiedLength}}t.DiffChange=n}),ie(re[4],ae([0,1]),function(C,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.BugIndicatingError=t.ErrorNoTelemetry=t.ExpectedError=t.NotSupportedError=t.NotImplementedError=t.ReadonlyError=t.CancellationError=t.errorHandler=t.ErrorHandler=void 0,t.setUnexpectedErrorHandler=i,t.isSigPipeError=M,t.onUnexpectedError=m,t.onUnexpectedExternalError=R,t.transformErrorForSerialization=b,t.transformErrorFromSerialization=o,t.isCancellationError=h,t.canceled=d,t.illegalArgument=c,t.illegalState=e,t.getErrorMessage=g;class n{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(s){setTimeout(()=>{throw s.stack?A.isErrorNoTelemetry(s)?new A(s.message+`

`+s.stack):new Error(s.message+`

`+s.stack):s},0)}}addListener(s){return this.listeners.push(s),()=>{this._removeListener(s)}}emit(s){this.listeners.forEach(f=>{f(s)})}_removeListener(s){this.listeners.splice(this.listeners.indexOf(s),1)}setUnexpectedErrorHandler(s){this.unexpectedErrorHandler=s}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(s){this.unexpectedErrorHandler(s),this.emit(s)}onUnexpectedExternalError(s){this.unexpectedErrorHandler(s)}}t.ErrorHandler=n,t.errorHandler=new n;function i(l){t.errorHandler.setUnexpectedErrorHandler(l)}function M(l){if(!l||typeof l!="object")return!1;const s=l;return s.code==="EPIPE"&&s.syscall?.toUpperCase()==="WRITE"}function m(l){h(l)||t.errorHandler.onUnexpectedError(l)}function R(l){h(l)||t.errorHandler.onUnexpectedExternalError(l)}function b(l){if(l instanceof Error){const{name:s,message:f}=l,p=l.stacktrace||l.stack;return{$isError:!0,name:s,message:f,stack:p,noTelemetry:A.isErrorNoTelemetry(l)}}return l}function o(l){let s;return l.noTelemetry?s=new A:(s=new Error,s.name=l.name),s.message=l.message,s.stack=l.stack,s}const a="Canceled";function h(l){return l instanceof _?!0:l instanceof Error&&l.name===a&&l.message===a}class _ extends Error{constructor(){super(a),this.name=this.message}}t.CancellationError=_;function d(){const l=new Error(a);return l.name=l.message,l}function c(l){return l?new Error(`Illegal argument: ${l}`):new Error("Illegal argument")}function e(l){return l?new Error(`Illegal state: ${l}`):new Error("Illegal state")}class u extends TypeError{constructor(s){super(s?`${s} is read-only and cannot be changed`:"Cannot change read-only property")}}t.ReadonlyError=u;function g(l){return l?l.message?l.message:l.stack?l.stack.split(`
`)[0]:String(l):"Error"}class E extends Error{constructor(s){super("NotImplemented"),s&&(this.message=s)}}t.NotImplementedError=E;class w extends Error{constructor(s){super("NotSupported"),s&&(this.message=s)}}t.NotSupportedError=w;class v extends Error{constructor(){super(...arguments),this.isExpected=!0}}t.ExpectedError=v;class A extends Error{constructor(s){super(s),this.name="CodeExpectedError"}static fromError(s){if(s instanceof A)return s;const f=new A;return f.message=s.message,f.stack=s.stack,f}static isErrorNoTelemetry(s){return s.name==="CodeExpectedError"}}t.ErrorNoTelemetry=A;class L extends Error{constructor(s){super(s||"An unexpected bug occurred."),Object.setPrototypeOf(this,L.prototype)}}t.BugIndicatingError=L}),ie(re[9],ae([0,1,4,11]),function(C,t,n,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Permutation=t.CallbackIterable=t.ArrayQueue=t.booleanComparator=t.numberComparator=t.CompareResult=void 0,t.tail=M,t.tail2=m,t.equals=R,t.removeFastWithoutKeepingOrder=b,t.binarySearch=o,t.binarySearch2=a,t.quickSelect=h,t.groupBy=_,t.groupAdjacentBy=d,t.forEachAdjacent=c,t.forEachWithNeighbors=e,t.sortedDiff=u,t.delta=g,t.top=E,t.topAsync=w,t.coalesce=A,t.coalesceInPlace=L,t.move=l,t.isFalsyOrEmpty=s,t.isNonEmptyArray=f,t.distinct=p,t.uniqueFilter=I,t.firstOrDefault=N,t.lastOrDefault=S,t.commonPrefixLength=D,t.range=T,t.index=y,t.insert=k,t.remove=P,t.arrayInsert=q,t.shuffle=j,t.pushToStart=H,t.pushToEnd=W,t.pushMany=J,t.mapArrayOrNot=ee,t.asArray=Z,t.getRandomElement=K,t.insertInto=ne,t.splice=F,t.compareBy=ge,t.tieBreakComparators=Ee,t.reverseOrder=ke,t.findAsync=Ue;function M(z,G=0){return z[z.length-(1+G)]}function m(z){if(z.length===0)throw new Error("Invalid tail call");return[z.slice(0,z.length-1),z[z.length-1]]}function R(z,G,x=(O,U)=>O===U){if(z===G)return!0;if(!z||!G||z.length!==G.length)return!1;for(let O=0,U=z.length;O<U;O++)if(!x(z[O],G[O]))return!1;return!0}function b(z,G){const x=z.length-1;G<x&&(z[G]=z[x]),z.pop()}function o(z,G,x){return a(z.length,O=>x(z[O],G))}function a(z,G){let x=0,O=z-1;for(;x<=O;){const U=(x+O)/2|0,X=G(U);if(X<0)x=U+1;else if(X>0)O=U-1;else return U}return-(x+1)}function h(z,G,x){if(z=z|0,z>=G.length)throw new TypeError("invalid index");const O=G[Math.floor(G.length*Math.random())],U=[],X=[],Q=[];for(const le of G){const Le=x(le,O);Le<0?U.push(le):Le>0?X.push(le):Q.push(le)}return z<U.length?h(z,U,x):z<U.length+Q.length?Q[0]:h(z-(U.length+Q.length),X,x)}function _(z,G){const x=[];let O;for(const U of z.slice(0).sort(G))!O||G(O[0],U)!==0?(O=[U],x.push(O)):O.push(U);return x}function*d(z,G){let x,O;for(const U of z)O!==void 0&&G(O,U)?x.push(U):(x&&(yield x),x=[U]),O=U;x&&(yield x)}function c(z,G){for(let x=0;x<=z.length;x++)G(x===0?void 0:z[x-1],x===z.length?void 0:z[x])}function e(z,G){for(let x=0;x<z.length;x++)G(x===0?void 0:z[x-1],z[x],x+1===z.length?void 0:z[x+1])}function u(z,G,x){const O=[];function U(le,Le,ve){if(Le===0&&ve.length===0)return;const Ne=O[O.length-1];Ne&&Ne.start+Ne.deleteCount===le?(Ne.deleteCount+=Le,Ne.toInsert.push(...ve)):O.push({start:le,deleteCount:Le,toInsert:ve})}let X=0,Q=0;for(;;){if(X===z.length){U(X,0,G.slice(Q));break}if(Q===G.length){U(X,z.length-X,[]);break}const le=z[X],Le=G[Q],ve=x(le,Le);ve===0?(X+=1,Q+=1):ve<0?(U(X,1,[]),X+=1):ve>0&&(U(X,0,[Le]),Q+=1)}return O}function g(z,G,x){const O=u(z,G,x),U=[],X=[];for(const Q of O)U.push(...z.slice(Q.start,Q.start+Q.deleteCount)),X.push(...Q.toInsert);return{removed:U,added:X}}function E(z,G,x){if(x===0)return[];const O=z.slice(0,x).sort(G);return v(z,G,O,x,z.length),O}function w(z,G,x,O,U){return x===0?Promise.resolve([]):new Promise((X,Q)=>{(async()=>{const le=z.length,Le=z.slice(0,x).sort(G);for(let ve=x,Ne=Math.min(x+O,le);ve<le;ve=Ne,Ne=Math.min(Ne+O,le)){if(ve>x&&await new Promise(oe=>setTimeout(oe)),U&&U.isCancellationRequested)throw new n.CancellationError;v(z,G,Le,ve,Ne)}return Le})().then(X,Q)})}function v(z,G,x,O,U){for(const X=x.length;O<U;O++){const Q=z[O];if(G(Q,x[X-1])<0){x.pop();const le=(0,i.findFirstIdxMonotonousOrArrLen)(x,Le=>G(Q,Le)<0);x.splice(le,0,Q)}}}function A(z){return z.filter(G=>!!G)}function L(z){let G=0;for(let x=0;x<z.length;x++)z[x]&&(z[G]=z[x],G+=1);z.length=G}function l(z,G,x){z.splice(x,0,z.splice(G,1)[0])}function s(z){return!Array.isArray(z)||z.length===0}function f(z){return Array.isArray(z)&&z.length>0}function p(z,G=x=>x){const x=new Set;return z.filter(O=>{const U=G(O);return x.has(U)?!1:(x.add(U),!0)})}function I(z){const G=new Set;return x=>{const O=z(x);return G.has(O)?!1:(G.add(O),!0)}}function N(z,G){return z.length>0?z[0]:G}function S(z,G){return z.length>0?z[z.length-1]:G}function D(z,G,x=(O,U)=>O===U){let O=0;for(let U=0,X=Math.min(z.length,G.length);U<X&&x(z[U],G[U]);U++)O++;return O}function T(z,G){let x=typeof G=="number"?z:0;typeof G=="number"?x=z:(x=0,G=z);const O=[];if(x<=G)for(let U=x;U<G;U++)O.push(U);else for(let U=x;U>G;U--)O.push(U);return O}function y(z,G,x){return z.reduce((O,U)=>(O[G(U)]=x?x(U):U,O),Object.create(null))}function k(z,G){return z.push(G),()=>P(z,G)}function P(z,G){const x=z.indexOf(G);if(x>-1)return z.splice(x,1),G}function q(z,G,x){const O=z.slice(0,G),U=z.slice(G);return O.concat(x,U)}function j(z,G){let x;if(typeof G=="number"){let O=G;x=()=>{const U=Math.sin(O++)*179426549;return U-Math.floor(U)}}else x=Math.random;for(let O=z.length-1;O>0;O-=1){const U=Math.floor(x()*(O+1)),X=z[O];z[O]=z[U],z[U]=X}}function H(z,G){const x=z.indexOf(G);x>-1&&(z.splice(x,1),z.unshift(G))}function W(z,G){const x=z.indexOf(G);x>-1&&(z.splice(x,1),z.push(G))}function J(z,G){for(const x of G)z.push(x)}function ee(z,G){return Array.isArray(z)?z.map(G):G(z)}function Z(z){return Array.isArray(z)?z:[z]}function K(z){return z[Math.floor(Math.random()*z.length)]}function ne(z,G,x){const O=$(z,G),U=z.length,X=x.length;z.length=U+X;for(let Q=U-1;Q>=O;Q--)z[Q+X]=z[Q];for(let Q=0;Q<X;Q++)z[Q+O]=x[Q]}function F(z,G,x,O){const U=$(z,G);let X=z.splice(U,x);return X===void 0&&(X=[]),ne(z,U,O),X}function $(z,G){return G<0?Math.max(G+z.length,0):Math.min(G,z.length)}var he;(function(z){function G(X){return X<0}z.isLessThan=G;function x(X){return X<=0}z.isLessThanOrEqual=x;function O(X){return X>0}z.isGreaterThan=O;function U(X){return X===0}z.isNeitherLessOrGreaterThan=U,z.greaterThan=1,z.lessThan=-1,z.neitherLessOrGreaterThan=0})(he||(t.CompareResult=he={}));function ge(z,G){return(x,O)=>G(z(x),z(O))}function Ee(...z){return(G,x)=>{for(const O of z){const U=O(G,x);if(!he.isNeitherLessOrGreaterThan(U))return U}return he.neitherLessOrGreaterThan}}const r=(z,G)=>z-G;t.numberComparator=r;const Te=(z,G)=>(0,t.numberComparator)(z?1:0,G?1:0);t.booleanComparator=Te;function ke(z){return(G,x)=>-z(G,x)}class We{constructor(G){this.items=G,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(G){let x=this.firstIdx;for(;x<this.items.length&&G(this.items[x]);)x++;const O=x===this.firstIdx?null:this.items.slice(this.firstIdx,x);return this.firstIdx=x,O}takeFromEndWhile(G){let x=this.lastIdx;for(;x>=0&&G(this.items[x]);)x--;const O=x===this.lastIdx?null:this.items.slice(x+1,this.lastIdx+1);return this.lastIdx=x,O}peek(){if(this.length!==0)return this.items[this.firstIdx]}peekLast(){if(this.length!==0)return this.items[this.lastIdx]}dequeue(){const G=this.items[this.firstIdx];return this.firstIdx++,G}removeLast(){const G=this.items[this.lastIdx];return this.lastIdx--,G}takeCount(G){const x=this.items.slice(this.firstIdx,this.firstIdx+G);return this.firstIdx+=G,x}}t.ArrayQueue=We;class Re{static{this.empty=new Re(G=>{})}constructor(G){this.iterate=G}forEach(G){this.iterate(x=>(G(x),!0))}toArray(){const G=[];return this.iterate(x=>(G.push(x),!0)),G}filter(G){return new Re(x=>this.iterate(O=>G(O)?x(O):!0))}map(G){return new Re(x=>this.iterate(O=>x(G(O))))}some(G){let x=!1;return this.iterate(O=>(x=G(O),!x)),x}findFirst(G){let x;return this.iterate(O=>G(O)?(x=O,!1):!0),x}findLast(G){let x;return this.iterate(O=>(G(O)&&(x=O),!0)),x}findLastMaxBy(G){let x,O=!0;return this.iterate(U=>((O||he.isGreaterThan(G(U,x)))&&(O=!1,x=U),!0)),x}}t.CallbackIterable=Re;class we{constructor(G){this._indexMap=G}static createSortPermutation(G,x){const O=Array.from(G.keys()).sort((U,X)=>x(G[U],G[X]));return new we(O)}apply(G){return G.map((x,O)=>G[this._indexMap[O]])}inverse(){const G=this._indexMap.slice();for(let x=0;x<this._indexMap.length;x++)G[this._indexMap[x]]=x;return new we(G)}}t.Permutation=we;async function Ue(z,G){return(await Promise.all(z.map(async(O,U)=>({element:O,ok:await G(O,U)})))).find(O=>O.ok)?.element}}),ie(re[15],ae([0,1,4]),function(C,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ok=i,t.assertNever=M,t.assert=m,t.softAssert=R,t.assertFn=b,t.checkAdjacentItems=o;function i(a,h){if(!a)throw new Error(h?`Assertion failed (${h})`:"Assertion Failed")}function M(a,h="Unreachable"){throw new Error(h)}function m(a,h="unexpected state"){if(!a)throw new n.BugIndicatingError(`Assertion Failed: ${h}`)}function R(a){a||(0,n.onUnexpectedError)(new n.BugIndicatingError("Soft Assertion Failed"))}function b(a){if(!a()){debugger;a(),(0,n.onUnexpectedError)(new n.BugIndicatingError("Assertion Failed"))}}function o(a,h){let _=0;for(;_<a.length-1;){const d=a[_],c=a[_+1];if(!h(d,c))return!1;_++}return!0}}),ie(re[25],ae([0,1]),function(C,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.createSingleCallFunction=n;function n(i,M){const m=this;let R=!1,b;return function(){if(R)return b;if(R=!0,M)try{b=i.apply(m,arguments)}finally{M()}else b=i.apply(m,arguments);return b}}}),ie(re[26],ae([0,1]),function(C,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Iterable=void 0;var n;(function(i){function M(s){return s&&typeof s=="object"&&typeof s[Symbol.iterator]=="function"}i.is=M;const m=Object.freeze([]);function R(){return m}i.empty=R;function*b(s){yield s}i.single=b;function o(s){return M(s)?s:b(s)}i.wrap=o;function a(s){return s||m}i.from=a;function*h(s){for(let f=s.length-1;f>=0;f--)yield s[f]}i.reverse=h;function _(s){return!s||s[Symbol.iterator]().next().done===!0}i.isEmpty=_;function d(s){return s[Symbol.iterator]().next().value}i.first=d;function c(s,f){let p=0;for(const I of s)if(f(I,p++))return!0;return!1}i.some=c;function e(s,f){for(const p of s)if(f(p))return p}i.find=e;function*u(s,f){for(const p of s)f(p)&&(yield p)}i.filter=u;function*g(s,f){let p=0;for(const I of s)yield f(I,p++)}i.map=g;function*E(s,f){let p=0;for(const I of s)yield*f(I,p++)}i.flatMap=E;function*w(...s){for(const f of s)yield*f}i.concat=w;function v(s,f,p){let I=p;for(const N of s)I=f(I,N);return I}i.reduce=v;function*A(s,f,p=s.length){for(f<0&&(f+=s.length),p<0?p+=s.length:p>s.length&&(p=s.length);f<p;f++)yield s[f]}i.slice=A;function L(s,f=Number.POSITIVE_INFINITY){const p=[];if(f===0)return[p,s];const I=s[Symbol.iterator]();for(let N=0;N<f;N++){const S=I.next();if(S.done)return[p,i.empty()];p.push(S.value)}return[p,{[Symbol.iterator](){return I}}]}i.consume=L;async function l(s){const f=[];for await(const p of s)f.push(p);return Promise.resolve(f)}i.asyncToArray=l})(n||(t.Iterable=n={}))}),ie(re[45],ae([0,1]),function(C,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.KeyMod=t.KeyCodeUtils=t.IMMUTABLE_KEY_CODE_TO_CODE=t.IMMUTABLE_CODE_TO_KEY_CODE=t.ScanCodeUtils=t.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE=t.EVENT_KEY_CODE_MAP=t.ScanCode=t.KeyCode=void 0,t.KeyChord=c;var n;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.Unknown=0]="Unknown",e[e.Backspace=1]="Backspace",e[e.Tab=2]="Tab",e[e.Enter=3]="Enter",e[e.Shift=4]="Shift",e[e.Ctrl=5]="Ctrl",e[e.Alt=6]="Alt",e[e.PauseBreak=7]="PauseBreak",e[e.CapsLock=8]="CapsLock",e[e.Escape=9]="Escape",e[e.Space=10]="Space",e[e.PageUp=11]="PageUp",e[e.PageDown=12]="PageDown",e[e.End=13]="End",e[e.Home=14]="Home",e[e.LeftArrow=15]="LeftArrow",e[e.UpArrow=16]="UpArrow",e[e.RightArrow=17]="RightArrow",e[e.DownArrow=18]="DownArrow",e[e.Insert=19]="Insert",e[e.Delete=20]="Delete",e[e.Digit0=21]="Digit0",e[e.Digit1=22]="Digit1",e[e.Digit2=23]="Digit2",e[e.Digit3=24]="Digit3",e[e.Digit4=25]="Digit4",e[e.Digit5=26]="Digit5",e[e.Digit6=27]="Digit6",e[e.Digit7=28]="Digit7",e[e.Digit8=29]="Digit8",e[e.Digit9=30]="Digit9",e[e.KeyA=31]="KeyA",e[e.KeyB=32]="KeyB",e[e.KeyC=33]="KeyC",e[e.KeyD=34]="KeyD",e[e.KeyE=35]="KeyE",e[e.KeyF=36]="KeyF",e[e.KeyG=37]="KeyG",e[e.KeyH=38]="KeyH",e[e.KeyI=39]="KeyI",e[e.KeyJ=40]="KeyJ",e[e.KeyK=41]="KeyK",e[e.KeyL=42]="KeyL",e[e.KeyM=43]="KeyM",e[e.KeyN=44]="KeyN",e[e.KeyO=45]="KeyO",e[e.KeyP=46]="KeyP",e[e.KeyQ=47]="KeyQ",e[e.KeyR=48]="KeyR",e[e.KeyS=49]="KeyS",e[e.KeyT=50]="KeyT",e[e.KeyU=51]="KeyU",e[e.KeyV=52]="KeyV",e[e.KeyW=53]="KeyW",e[e.KeyX=54]="KeyX",e[e.KeyY=55]="KeyY",e[e.KeyZ=56]="KeyZ",e[e.Meta=57]="Meta",e[e.ContextMenu=58]="ContextMenu",e[e.F1=59]="F1",e[e.F2=60]="F2",e[e.F3=61]="F3",e[e.F4=62]="F4",e[e.F5=63]="F5",e[e.F6=64]="F6",e[e.F7=65]="F7",e[e.F8=66]="F8",e[e.F9=67]="F9",e[e.F10=68]="F10",e[e.F11=69]="F11",e[e.F12=70]="F12",e[e.F13=71]="F13",e[e.F14=72]="F14",e[e.F15=73]="F15",e[e.F16=74]="F16",e[e.F17=75]="F17",e[e.F18=76]="F18",e[e.F19=77]="F19",e[e.F20=78]="F20",e[e.F21=79]="F21",e[e.F22=80]="F22",e[e.F23=81]="F23",e[e.F24=82]="F24",e[e.NumLock=83]="NumLock",e[e.ScrollLock=84]="ScrollLock",e[e.Semicolon=85]="Semicolon",e[e.Equal=86]="Equal",e[e.Comma=87]="Comma",e[e.Minus=88]="Minus",e[e.Period=89]="Period",e[e.Slash=90]="Slash",e[e.Backquote=91]="Backquote",e[e.BracketLeft=92]="BracketLeft",e[e.Backslash=93]="Backslash",e[e.BracketRight=94]="BracketRight",e[e.Quote=95]="Quote",e[e.OEM_8=96]="OEM_8",e[e.IntlBackslash=97]="IntlBackslash",e[e.Numpad0=98]="Numpad0",e[e.Numpad1=99]="Numpad1",e[e.Numpad2=100]="Numpad2",e[e.Numpad3=101]="Numpad3",e[e.Numpad4=102]="Numpad4",e[e.Numpad5=103]="Numpad5",e[e.Numpad6=104]="Numpad6",e[e.Numpad7=105]="Numpad7",e[e.Numpad8=106]="Numpad8",e[e.Numpad9=107]="Numpad9",e[e.NumpadMultiply=108]="NumpadMultiply",e[e.NumpadAdd=109]="NumpadAdd",e[e.NUMPAD_SEPARATOR=110]="NUMPAD_SEPARATOR",e[e.NumpadSubtract=111]="NumpadSubtract",e[e.NumpadDecimal=112]="NumpadDecimal",e[e.NumpadDivide=113]="NumpadDivide",e[e.KEY_IN_COMPOSITION=114]="KEY_IN_COMPOSITION",e[e.ABNT_C1=115]="ABNT_C1",e[e.ABNT_C2=116]="ABNT_C2",e[e.AudioVolumeMute=117]="AudioVolumeMute",e[e.AudioVolumeUp=118]="AudioVolumeUp",e[e.AudioVolumeDown=119]="AudioVolumeDown",e[e.BrowserSearch=120]="BrowserSearch",e[e.BrowserHome=121]="BrowserHome",e[e.BrowserBack=122]="BrowserBack",e[e.BrowserForward=123]="BrowserForward",e[e.MediaTrackNext=124]="MediaTrackNext",e[e.MediaTrackPrevious=125]="MediaTrackPrevious",e[e.MediaStop=126]="MediaStop",e[e.MediaPlayPause=127]="MediaPlayPause",e[e.LaunchMediaPlayer=128]="LaunchMediaPlayer",e[e.LaunchMail=129]="LaunchMail",e[e.LaunchApp2=130]="LaunchApp2",e[e.Clear=131]="Clear",e[e.MAX_VALUE=132]="MAX_VALUE"})(n||(t.KeyCode=n={}));var i;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.None=0]="None",e[e.Hyper=1]="Hyper",e[e.Super=2]="Super",e[e.Fn=3]="Fn",e[e.FnLock=4]="FnLock",e[e.Suspend=5]="Suspend",e[e.Resume=6]="Resume",e[e.Turbo=7]="Turbo",e[e.Sleep=8]="Sleep",e[e.WakeUp=9]="WakeUp",e[e.KeyA=10]="KeyA",e[e.KeyB=11]="KeyB",e[e.KeyC=12]="KeyC",e[e.KeyD=13]="KeyD",e[e.KeyE=14]="KeyE",e[e.KeyF=15]="KeyF",e[e.KeyG=16]="KeyG",e[e.KeyH=17]="KeyH",e[e.KeyI=18]="KeyI",e[e.KeyJ=19]="KeyJ",e[e.KeyK=20]="KeyK",e[e.KeyL=21]="KeyL",e[e.KeyM=22]="KeyM",e[e.KeyN=23]="KeyN",e[e.KeyO=24]="KeyO",e[e.KeyP=25]="KeyP",e[e.KeyQ=26]="KeyQ",e[e.KeyR=27]="KeyR",e[e.KeyS=28]="KeyS",e[e.KeyT=29]="KeyT",e[e.KeyU=30]="KeyU",e[e.KeyV=31]="KeyV",e[e.KeyW=32]="KeyW",e[e.KeyX=33]="KeyX",e[e.KeyY=34]="KeyY",e[e.KeyZ=35]="KeyZ",e[e.Digit1=36]="Digit1",e[e.Digit2=37]="Digit2",e[e.Digit3=38]="Digit3",e[e.Digit4=39]="Digit4",e[e.Digit5=40]="Digit5",e[e.Digit6=41]="Digit6",e[e.Digit7=42]="Digit7",e[e.Digit8=43]="Digit8",e[e.Digit9=44]="Digit9",e[e.Digit0=45]="Digit0",e[e.Enter=46]="Enter",e[e.Escape=47]="Escape",e[e.Backspace=48]="Backspace",e[e.Tab=49]="Tab",e[e.Space=50]="Space",e[e.Minus=51]="Minus",e[e.Equal=52]="Equal",e[e.BracketLeft=53]="BracketLeft",e[e.BracketRight=54]="BracketRight",e[e.Backslash=55]="Backslash",e[e.IntlHash=56]="IntlHash",e[e.Semicolon=57]="Semicolon",e[e.Quote=58]="Quote",e[e.Backquote=59]="Backquote",e[e.Comma=60]="Comma",e[e.Period=61]="Period",e[e.Slash=62]="Slash",e[e.CapsLock=63]="CapsLock",e[e.F1=64]="F1",e[e.F2=65]="F2",e[e.F3=66]="F3",e[e.F4=67]="F4",e[e.F5=68]="F5",e[e.F6=69]="F6",e[e.F7=70]="F7",e[e.F8=71]="F8",e[e.F9=72]="F9",e[e.F10=73]="F10",e[e.F11=74]="F11",e[e.F12=75]="F12",e[e.PrintScreen=76]="PrintScreen",e[e.ScrollLock=77]="ScrollLock",e[e.Pause=78]="Pause",e[e.Insert=79]="Insert",e[e.Home=80]="Home",e[e.PageUp=81]="PageUp",e[e.Delete=82]="Delete",e[e.End=83]="End",e[e.PageDown=84]="PageDown",e[e.ArrowRight=85]="ArrowRight",e[e.ArrowLeft=86]="ArrowLeft",e[e.ArrowDown=87]="ArrowDown",e[e.ArrowUp=88]="ArrowUp",e[e.NumLock=89]="NumLock",e[e.NumpadDivide=90]="NumpadDivide",e[e.NumpadMultiply=91]="NumpadMultiply",e[e.NumpadSubtract=92]="NumpadSubtract",e[e.NumpadAdd=93]="NumpadAdd",e[e.NumpadEnter=94]="NumpadEnter",e[e.Numpad1=95]="Numpad1",e[e.Numpad2=96]="Numpad2",e[e.Numpad3=97]="Numpad3",e[e.Numpad4=98]="Numpad4",e[e.Numpad5=99]="Numpad5",e[e.Numpad6=100]="Numpad6",e[e.Numpad7=101]="Numpad7",e[e.Numpad8=102]="Numpad8",e[e.Numpad9=103]="Numpad9",e[e.Numpad0=104]="Numpad0",e[e.NumpadDecimal=105]="NumpadDecimal",e[e.IntlBackslash=106]="IntlBackslash",e[e.ContextMenu=107]="ContextMenu",e[e.Power=108]="Power",e[e.NumpadEqual=109]="NumpadEqual",e[e.F13=110]="F13",e[e.F14=111]="F14",e[e.F15=112]="F15",e[e.F16=113]="F16",e[e.F17=114]="F17",e[e.F18=115]="F18",e[e.F19=116]="F19",e[e.F20=117]="F20",e[e.F21=118]="F21",e[e.F22=119]="F22",e[e.F23=120]="F23",e[e.F24=121]="F24",e[e.Open=122]="Open",e[e.Help=123]="Help",e[e.Select=124]="Select",e[e.Again=125]="Again",e[e.Undo=126]="Undo",e[e.Cut=127]="Cut",e[e.Copy=128]="Copy",e[e.Paste=129]="Paste",e[e.Find=130]="Find",e[e.AudioVolumeMute=131]="AudioVolumeMute",e[e.AudioVolumeUp=132]="AudioVolumeUp",e[e.AudioVolumeDown=133]="AudioVolumeDown",e[e.NumpadComma=134]="NumpadComma",e[e.IntlRo=135]="IntlRo",e[e.KanaMode=136]="KanaMode",e[e.IntlYen=137]="IntlYen",e[e.Convert=138]="Convert",e[e.NonConvert=139]="NonConvert",e[e.Lang1=140]="Lang1",e[e.Lang2=141]="Lang2",e[e.Lang3=142]="Lang3",e[e.Lang4=143]="Lang4",e[e.Lang5=144]="Lang5",e[e.Abort=145]="Abort",e[e.Props=146]="Props",e[e.NumpadParenLeft=147]="NumpadParenLeft",e[e.NumpadParenRight=148]="NumpadParenRight",e[e.NumpadBackspace=149]="NumpadBackspace",e[e.NumpadMemoryStore=150]="NumpadMemoryStore",e[e.NumpadMemoryRecall=151]="NumpadMemoryRecall",e[e.NumpadMemoryClear=152]="NumpadMemoryClear",e[e.NumpadMemoryAdd=153]="NumpadMemoryAdd",e[e.NumpadMemorySubtract=154]="NumpadMemorySubtract",e[e.NumpadClear=155]="NumpadClear",e[e.NumpadClearEntry=156]="NumpadClearEntry",e[e.ControlLeft=157]="ControlLeft",e[e.ShiftLeft=158]="ShiftLeft",e[e.AltLeft=159]="AltLeft",e[e.MetaLeft=160]="MetaLeft",e[e.ControlRight=161]="ControlRight",e[e.ShiftRight=162]="ShiftRight",e[e.AltRight=163]="AltRight",e[e.MetaRight=164]="MetaRight",e[e.BrightnessUp=165]="BrightnessUp",e[e.BrightnessDown=166]="BrightnessDown",e[e.MediaPlay=167]="MediaPlay",e[e.MediaRecord=168]="MediaRecord",e[e.MediaFastForward=169]="MediaFastForward",e[e.MediaRewind=170]="MediaRewind",e[e.MediaTrackNext=171]="MediaTrackNext",e[e.MediaTrackPrevious=172]="MediaTrackPrevious",e[e.MediaStop=173]="MediaStop",e[e.Eject=174]="Eject",e[e.MediaPlayPause=175]="MediaPlayPause",e[e.MediaSelect=176]="MediaSelect",e[e.LaunchMail=177]="LaunchMail",e[e.LaunchApp2=178]="LaunchApp2",e[e.LaunchApp1=179]="LaunchApp1",e[e.SelectTask=180]="SelectTask",e[e.LaunchScreenSaver=181]="LaunchScreenSaver",e[e.BrowserSearch=182]="BrowserSearch",e[e.BrowserHome=183]="BrowserHome",e[e.BrowserBack=184]="BrowserBack",e[e.BrowserForward=185]="BrowserForward",e[e.BrowserStop=186]="BrowserStop",e[e.BrowserRefresh=187]="BrowserRefresh",e[e.BrowserFavorites=188]="BrowserFavorites",e[e.ZoomToggle=189]="ZoomToggle",e[e.MailReply=190]="MailReply",e[e.MailForward=191]="MailForward",e[e.MailSend=192]="MailSend",e[e.MAX_VALUE=193]="MAX_VALUE"})(i||(t.ScanCode=i={}));class M{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(u,g){this._keyCodeToStr[u]=g,this._strToKeyCode[g.toLowerCase()]=u}keyCodeToStr(u){return this._keyCodeToStr[u]}strToKeyCode(u){return this._strToKeyCode[u.toLowerCase()]||n.Unknown}}const m=new M,R=new M,b=new M;t.EVENT_KEY_CODE_MAP=new Array(230),t.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE={};const o=[],a=Object.create(null),h=Object.create(null);t.ScanCodeUtils={lowerCaseToEnum:e=>h[e]||i.None,toEnum:e=>a[e]||i.None,toString:e=>o[e]||"None"},t.IMMUTABLE_CODE_TO_KEY_CODE=[],t.IMMUTABLE_KEY_CODE_TO_CODE=[];for(let e=0;e<=i.MAX_VALUE;e++)t.IMMUTABLE_CODE_TO_KEY_CODE[e]=n.DependsOnKbLayout;for(let e=0;e<=n.MAX_VALUE;e++)t.IMMUTABLE_KEY_CODE_TO_CODE[e]=i.DependsOnKbLayout;(function(){const e="",u=[[1,i.None,"None",n.Unknown,"unknown",0,"VK_UNKNOWN",e,e],[1,i.Hyper,"Hyper",n.Unknown,e,0,e,e,e],[1,i.Super,"Super",n.Unknown,e,0,e,e,e],[1,i.Fn,"Fn",n.Unknown,e,0,e,e,e],[1,i.FnLock,"FnLock",n.Unknown,e,0,e,e,e],[1,i.Suspend,"Suspend",n.Unknown,e,0,e,e,e],[1,i.Resume,"Resume",n.Unknown,e,0,e,e,e],[1,i.Turbo,"Turbo",n.Unknown,e,0,e,e,e],[1,i.Sleep,"Sleep",n.Unknown,e,0,"VK_SLEEP",e,e],[1,i.WakeUp,"WakeUp",n.Unknown,e,0,e,e,e],[0,i.KeyA,"KeyA",n.KeyA,"A",65,"VK_A",e,e],[0,i.KeyB,"KeyB",n.KeyB,"B",66,"VK_B",e,e],[0,i.KeyC,"KeyC",n.KeyC,"C",67,"VK_C",e,e],[0,i.KeyD,"KeyD",n.KeyD,"D",68,"VK_D",e,e],[0,i.KeyE,"KeyE",n.KeyE,"E",69,"VK_E",e,e],[0,i.KeyF,"KeyF",n.KeyF,"F",70,"VK_F",e,e],[0,i.KeyG,"KeyG",n.KeyG,"G",71,"VK_G",e,e],[0,i.KeyH,"KeyH",n.KeyH,"H",72,"VK_H",e,e],[0,i.KeyI,"KeyI",n.KeyI,"I",73,"VK_I",e,e],[0,i.KeyJ,"KeyJ",n.KeyJ,"J",74,"VK_J",e,e],[0,i.KeyK,"KeyK",n.KeyK,"K",75,"VK_K",e,e],[0,i.KeyL,"KeyL",n.KeyL,"L",76,"VK_L",e,e],[0,i.KeyM,"KeyM",n.KeyM,"M",77,"VK_M",e,e],[0,i.KeyN,"KeyN",n.KeyN,"N",78,"VK_N",e,e],[0,i.KeyO,"KeyO",n.KeyO,"O",79,"VK_O",e,e],[0,i.KeyP,"KeyP",n.KeyP,"P",80,"VK_P",e,e],[0,i.KeyQ,"KeyQ",n.KeyQ,"Q",81,"VK_Q",e,e],[0,i.KeyR,"KeyR",n.KeyR,"R",82,"VK_R",e,e],[0,i.KeyS,"KeyS",n.KeyS,"S",83,"VK_S",e,e],[0,i.KeyT,"KeyT",n.KeyT,"T",84,"VK_T",e,e],[0,i.KeyU,"KeyU",n.KeyU,"U",85,"VK_U",e,e],[0,i.KeyV,"KeyV",n.KeyV,"V",86,"VK_V",e,e],[0,i.KeyW,"KeyW",n.KeyW,"W",87,"VK_W",e,e],[0,i.KeyX,"KeyX",n.KeyX,"X",88,"VK_X",e,e],[0,i.KeyY,"KeyY",n.KeyY,"Y",89,"VK_Y",e,e],[0,i.KeyZ,"KeyZ",n.KeyZ,"Z",90,"VK_Z",e,e],[0,i.Digit1,"Digit1",n.Digit1,"1",49,"VK_1",e,e],[0,i.Digit2,"Digit2",n.Digit2,"2",50,"VK_2",e,e],[0,i.Digit3,"Digit3",n.Digit3,"3",51,"VK_3",e,e],[0,i.Digit4,"Digit4",n.Digit4,"4",52,"VK_4",e,e],[0,i.Digit5,"Digit5",n.Digit5,"5",53,"VK_5",e,e],[0,i.Digit6,"Digit6",n.Digit6,"6",54,"VK_6",e,e],[0,i.Digit7,"Digit7",n.Digit7,"7",55,"VK_7",e,e],[0,i.Digit8,"Digit8",n.Digit8,"8",56,"VK_8",e,e],[0,i.Digit9,"Digit9",n.Digit9,"9",57,"VK_9",e,e],[0,i.Digit0,"Digit0",n.Digit0,"0",48,"VK_0",e,e],[1,i.Enter,"Enter",n.Enter,"Enter",13,"VK_RETURN",e,e],[1,i.Escape,"Escape",n.Escape,"Escape",27,"VK_ESCAPE",e,e],[1,i.Backspace,"Backspace",n.Backspace,"Backspace",8,"VK_BACK",e,e],[1,i.Tab,"Tab",n.Tab,"Tab",9,"VK_TAB",e,e],[1,i.Space,"Space",n.Space,"Space",32,"VK_SPACE",e,e],[0,i.Minus,"Minus",n.Minus,"-",189,"VK_OEM_MINUS","-","OEM_MINUS"],[0,i.Equal,"Equal",n.Equal,"=",187,"VK_OEM_PLUS","=","OEM_PLUS"],[0,i.BracketLeft,"BracketLeft",n.BracketLeft,"[",219,"VK_OEM_4","[","OEM_4"],[0,i.BracketRight,"BracketRight",n.BracketRight,"]",221,"VK_OEM_6","]","OEM_6"],[0,i.Backslash,"Backslash",n.Backslash,"\\",220,"VK_OEM_5","\\","OEM_5"],[0,i.IntlHash,"IntlHash",n.Unknown,e,0,e,e,e],[0,i.Semicolon,"Semicolon",n.Semicolon,";",186,"VK_OEM_1",";","OEM_1"],[0,i.Quote,"Quote",n.Quote,"'",222,"VK_OEM_7","'","OEM_7"],[0,i.Backquote,"Backquote",n.Backquote,"`",192,"VK_OEM_3","`","OEM_3"],[0,i.Comma,"Comma",n.Comma,",",188,"VK_OEM_COMMA",",","OEM_COMMA"],[0,i.Period,"Period",n.Period,".",190,"VK_OEM_PERIOD",".","OEM_PERIOD"],[0,i.Slash,"Slash",n.Slash,"/",191,"VK_OEM_2","/","OEM_2"],[1,i.CapsLock,"CapsLock",n.CapsLock,"CapsLock",20,"VK_CAPITAL",e,e],[1,i.F1,"F1",n.F1,"F1",112,"VK_F1",e,e],[1,i.F2,"F2",n.F2,"F2",113,"VK_F2",e,e],[1,i.F3,"F3",n.F3,"F3",114,"VK_F3",e,e],[1,i.F4,"F4",n.F4,"F4",115,"VK_F4",e,e],[1,i.F5,"F5",n.F5,"F5",116,"VK_F5",e,e],[1,i.F6,"F6",n.F6,"F6",117,"VK_F6",e,e],[1,i.F7,"F7",n.F7,"F7",118,"VK_F7",e,e],[1,i.F8,"F8",n.F8,"F8",119,"VK_F8",e,e],[1,i.F9,"F9",n.F9,"F9",120,"VK_F9",e,e],[1,i.F10,"F10",n.F10,"F10",121,"VK_F10",e,e],[1,i.F11,"F11",n.F11,"F11",122,"VK_F11",e,e],[1,i.F12,"F12",n.F12,"F12",123,"VK_F12",e,e],[1,i.PrintScreen,"PrintScreen",n.Unknown,e,0,e,e,e],[1,i.ScrollLock,"ScrollLock",n.ScrollLock,"ScrollLock",145,"VK_SCROLL",e,e],[1,i.Pause,"Pause",n.PauseBreak,"PauseBreak",19,"VK_PAUSE",e,e],[1,i.Insert,"Insert",n.Insert,"Insert",45,"VK_INSERT",e,e],[1,i.Home,"Home",n.Home,"Home",36,"VK_HOME",e,e],[1,i.PageUp,"PageUp",n.PageUp,"PageUp",33,"VK_PRIOR",e,e],[1,i.Delete,"Delete",n.Delete,"Delete",46,"VK_DELETE",e,e],[1,i.End,"End",n.End,"End",35,"VK_END",e,e],[1,i.PageDown,"PageDown",n.PageDown,"PageDown",34,"VK_NEXT",e,e],[1,i.ArrowRight,"ArrowRight",n.RightArrow,"RightArrow",39,"VK_RIGHT","Right",e],[1,i.ArrowLeft,"ArrowLeft",n.LeftArrow,"LeftArrow",37,"VK_LEFT","Left",e],[1,i.ArrowDown,"ArrowDown",n.DownArrow,"DownArrow",40,"VK_DOWN","Down",e],[1,i.ArrowUp,"ArrowUp",n.UpArrow,"UpArrow",38,"VK_UP","Up",e],[1,i.NumLock,"NumLock",n.NumLock,"NumLock",144,"VK_NUMLOCK",e,e],[1,i.NumpadDivide,"NumpadDivide",n.NumpadDivide,"NumPad_Divide",111,"VK_DIVIDE",e,e],[1,i.NumpadMultiply,"NumpadMultiply",n.NumpadMultiply,"NumPad_Multiply",106,"VK_MULTIPLY",e,e],[1,i.NumpadSubtract,"NumpadSubtract",n.NumpadSubtract,"NumPad_Subtract",109,"VK_SUBTRACT",e,e],[1,i.NumpadAdd,"NumpadAdd",n.NumpadAdd,"NumPad_Add",107,"VK_ADD",e,e],[1,i.NumpadEnter,"NumpadEnter",n.Enter,e,0,e,e,e],[1,i.Numpad1,"Numpad1",n.Numpad1,"NumPad1",97,"VK_NUMPAD1",e,e],[1,i.Numpad2,"Numpad2",n.Numpad2,"NumPad2",98,"VK_NUMPAD2",e,e],[1,i.Numpad3,"Numpad3",n.Numpad3,"NumPad3",99,"VK_NUMPAD3",e,e],[1,i.Numpad4,"Numpad4",n.Numpad4,"NumPad4",100,"VK_NUMPAD4",e,e],[1,i.Numpad5,"Numpad5",n.Numpad5,"NumPad5",101,"VK_NUMPAD5",e,e],[1,i.Numpad6,"Numpad6",n.Numpad6,"NumPad6",102,"VK_NUMPAD6",e,e],[1,i.Numpad7,"Numpad7",n.Numpad7,"NumPad7",103,"VK_NUMPAD7",e,e],[1,i.Numpad8,"Numpad8",n.Numpad8,"NumPad8",104,"VK_NUMPAD8",e,e],[1,i.Numpad9,"Numpad9",n.Numpad9,"NumPad9",105,"VK_NUMPAD9",e,e],[1,i.Numpad0,"Numpad0",n.Numpad0,"NumPad0",96,"VK_NUMPAD0",e,e],[1,i.NumpadDecimal,"NumpadDecimal",n.NumpadDecimal,"NumPad_Decimal",110,"VK_DECIMAL",e,e],[0,i.IntlBackslash,"IntlBackslash",n.IntlBackslash,"OEM_102",226,"VK_OEM_102",e,e],[1,i.ContextMenu,"ContextMenu",n.ContextMenu,"ContextMenu",93,e,e,e],[1,i.Power,"Power",n.Unknown,e,0,e,e,e],[1,i.NumpadEqual,"NumpadEqual",n.Unknown,e,0,e,e,e],[1,i.F13,"F13",n.F13,"F13",124,"VK_F13",e,e],[1,i.F14,"F14",n.F14,"F14",125,"VK_F14",e,e],[1,i.F15,"F15",n.F15,"F15",126,"VK_F15",e,e],[1,i.F16,"F16",n.F16,"F16",127,"VK_F16",e,e],[1,i.F17,"F17",n.F17,"F17",128,"VK_F17",e,e],[1,i.F18,"F18",n.F18,"F18",129,"VK_F18",e,e],[1,i.F19,"F19",n.F19,"F19",130,"VK_F19",e,e],[1,i.F20,"F20",n.F20,"F20",131,"VK_F20",e,e],[1,i.F21,"F21",n.F21,"F21",132,"VK_F21",e,e],[1,i.F22,"F22",n.F22,"F22",133,"VK_F22",e,e],[1,i.F23,"F23",n.F23,"F23",134,"VK_F23",e,e],[1,i.F24,"F24",n.F24,"F24",135,"VK_F24",e,e],[1,i.Open,"Open",n.Unknown,e,0,e,e,e],[1,i.Help,"Help",n.Unknown,e,0,e,e,e],[1,i.Select,"Select",n.Unknown,e,0,e,e,e],[1,i.Again,"Again",n.Unknown,e,0,e,e,e],[1,i.Undo,"Undo",n.Unknown,e,0,e,e,e],[1,i.Cut,"Cut",n.Unknown,e,0,e,e,e],[1,i.Copy,"Copy",n.Unknown,e,0,e,e,e],[1,i.Paste,"Paste",n.Unknown,e,0,e,e,e],[1,i.Find,"Find",n.Unknown,e,0,e,e,e],[1,i.AudioVolumeMute,"AudioVolumeMute",n.AudioVolumeMute,"AudioVolumeMute",173,"VK_VOLUME_MUTE",e,e],[1,i.AudioVolumeUp,"AudioVolumeUp",n.AudioVolumeUp,"AudioVolumeUp",175,"VK_VOLUME_UP",e,e],[1,i.AudioVolumeDown,"AudioVolumeDown",n.AudioVolumeDown,"AudioVolumeDown",174,"VK_VOLUME_DOWN",e,e],[1,i.NumpadComma,"NumpadComma",n.NUMPAD_SEPARATOR,"NumPad_Separator",108,"VK_SEPARATOR",e,e],[0,i.IntlRo,"IntlRo",n.ABNT_C1,"ABNT_C1",193,"VK_ABNT_C1",e,e],[1,i.KanaMode,"KanaMode",n.Unknown,e,0,e,e,e],[0,i.IntlYen,"IntlYen",n.Unknown,e,0,e,e,e],[1,i.Convert,"Convert",n.Unknown,e,0,e,e,e],[1,i.NonConvert,"NonConvert",n.Unknown,e,0,e,e,e],[1,i.Lang1,"Lang1",n.Unknown,e,0,e,e,e],[1,i.Lang2,"Lang2",n.Unknown,e,0,e,e,e],[1,i.Lang3,"Lang3",n.Unknown,e,0,e,e,e],[1,i.Lang4,"Lang4",n.Unknown,e,0,e,e,e],[1,i.Lang5,"Lang5",n.Unknown,e,0,e,e,e],[1,i.Abort,"Abort",n.Unknown,e,0,e,e,e],[1,i.Props,"Props",n.Unknown,e,0,e,e,e],[1,i.NumpadParenLeft,"NumpadParenLeft",n.Unknown,e,0,e,e,e],[1,i.NumpadParenRight,"NumpadParenRight",n.Unknown,e,0,e,e,e],[1,i.NumpadBackspace,"NumpadBackspace",n.Unknown,e,0,e,e,e],[1,i.NumpadMemoryStore,"NumpadMemoryStore",n.Unknown,e,0,e,e,e],[1,i.NumpadMemoryRecall,"NumpadMemoryRecall",n.Unknown,e,0,e,e,e],[1,i.NumpadMemoryClear,"NumpadMemoryClear",n.Unknown,e,0,e,e,e],[1,i.NumpadMemoryAdd,"NumpadMemoryAdd",n.Unknown,e,0,e,e,e],[1,i.NumpadMemorySubtract,"NumpadMemorySubtract",n.Unknown,e,0,e,e,e],[1,i.NumpadClear,"NumpadClear",n.Clear,"Clear",12,"VK_CLEAR",e,e],[1,i.NumpadClearEntry,"NumpadClearEntry",n.Unknown,e,0,e,e,e],[1,i.None,e,n.Ctrl,"Ctrl",17,"VK_CONTROL",e,e],[1,i.None,e,n.Shift,"Shift",16,"VK_SHIFT",e,e],[1,i.None,e,n.Alt,"Alt",18,"VK_MENU",e,e],[1,i.None,e,n.Meta,"Meta",91,"VK_COMMAND",e,e],[1,i.ControlLeft,"ControlLeft",n.Ctrl,e,0,"VK_LCONTROL",e,e],[1,i.ShiftLeft,"ShiftLeft",n.Shift,e,0,"VK_LSHIFT",e,e],[1,i.AltLeft,"AltLeft",n.Alt,e,0,"VK_LMENU",e,e],[1,i.MetaLeft,"MetaLeft",n.Meta,e,0,"VK_LWIN",e,e],[1,i.ControlRight,"ControlRight",n.Ctrl,e,0,"VK_RCONTROL",e,e],[1,i.ShiftRight,"ShiftRight",n.Shift,e,0,"VK_RSHIFT",e,e],[1,i.AltRight,"AltRight",n.Alt,e,0,"VK_RMENU",e,e],[1,i.MetaRight,"MetaRight",n.Meta,e,0,"VK_RWIN",e,e],[1,i.BrightnessUp,"BrightnessUp",n.Unknown,e,0,e,e,e],[1,i.BrightnessDown,"BrightnessDown",n.Unknown,e,0,e,e,e],[1,i.MediaPlay,"MediaPlay",n.Unknown,e,0,e,e,e],[1,i.MediaRecord,"MediaRecord",n.Unknown,e,0,e,e,e],[1,i.MediaFastForward,"MediaFastForward",n.Unknown,e,0,e,e,e],[1,i.MediaRewind,"MediaRewind",n.Unknown,e,0,e,e,e],[1,i.MediaTrackNext,"MediaTrackNext",n.MediaTrackNext,"MediaTrackNext",176,"VK_MEDIA_NEXT_TRACK",e,e],[1,i.MediaTrackPrevious,"MediaTrackPrevious",n.MediaTrackPrevious,"MediaTrackPrevious",177,"VK_MEDIA_PREV_TRACK",e,e],[1,i.MediaStop,"MediaStop",n.MediaStop,"MediaStop",178,"VK_MEDIA_STOP",e,e],[1,i.Eject,"Eject",n.Unknown,e,0,e,e,e],[1,i.MediaPlayPause,"MediaPlayPause",n.MediaPlayPause,"MediaPlayPause",179,"VK_MEDIA_PLAY_PAUSE",e,e],[1,i.MediaSelect,"MediaSelect",n.LaunchMediaPlayer,"LaunchMediaPlayer",181,"VK_MEDIA_LAUNCH_MEDIA_SELECT",e,e],[1,i.LaunchMail,"LaunchMail",n.LaunchMail,"LaunchMail",180,"VK_MEDIA_LAUNCH_MAIL",e,e],[1,i.LaunchApp2,"LaunchApp2",n.LaunchApp2,"LaunchApp2",183,"VK_MEDIA_LAUNCH_APP2",e,e],[1,i.LaunchApp1,"LaunchApp1",n.Unknown,e,0,"VK_MEDIA_LAUNCH_APP1",e,e],[1,i.SelectTask,"SelectTask",n.Unknown,e,0,e,e,e],[1,i.LaunchScreenSaver,"LaunchScreenSaver",n.Unknown,e,0,e,e,e],[1,i.BrowserSearch,"BrowserSearch",n.BrowserSearch,"BrowserSearch",170,"VK_BROWSER_SEARCH",e,e],[1,i.BrowserHome,"BrowserHome",n.BrowserHome,"BrowserHome",172,"VK_BROWSER_HOME",e,e],[1,i.BrowserBack,"BrowserBack",n.BrowserBack,"BrowserBack",166,"VK_BROWSER_BACK",e,e],[1,i.BrowserForward,"BrowserForward",n.BrowserForward,"BrowserForward",167,"VK_BROWSER_FORWARD",e,e],[1,i.BrowserStop,"BrowserStop",n.Unknown,e,0,"VK_BROWSER_STOP",e,e],[1,i.BrowserRefresh,"BrowserRefresh",n.Unknown,e,0,"VK_BROWSER_REFRESH",e,e],[1,i.BrowserFavorites,"BrowserFavorites",n.Unknown,e,0,"VK_BROWSER_FAVORITES",e,e],[1,i.ZoomToggle,"ZoomToggle",n.Unknown,e,0,e,e,e],[1,i.MailReply,"MailReply",n.Unknown,e,0,e,e,e],[1,i.MailForward,"MailForward",n.Unknown,e,0,e,e,e],[1,i.MailSend,"MailSend",n.Unknown,e,0,e,e,e],[1,i.None,e,n.KEY_IN_COMPOSITION,"KeyInComposition",229,e,e,e],[1,i.None,e,n.ABNT_C2,"ABNT_C2",194,"VK_ABNT_C2",e,e],[1,i.None,e,n.OEM_8,"OEM_8",223,"VK_OEM_8",e,e],[1,i.None,e,n.Unknown,e,0,"VK_KANA",e,e],[1,i.None,e,n.Unknown,e,0,"VK_HANGUL",e,e],[1,i.None,e,n.Unknown,e,0,"VK_JUNJA",e,e],[1,i.None,e,n.Unknown,e,0,"VK_FINAL",e,e],[1,i.None,e,n.Unknown,e,0,"VK_HANJA",e,e],[1,i.None,e,n.Unknown,e,0,"VK_KANJI",e,e],[1,i.None,e,n.Unknown,e,0,"VK_CONVERT",e,e],[1,i.None,e,n.Unknown,e,0,"VK_NONCONVERT",e,e],[1,i.None,e,n.Unknown,e,0,"VK_ACCEPT",e,e],[1,i.None,e,n.Unknown,e,0,"VK_MODECHANGE",e,e],[1,i.None,e,n.Unknown,e,0,"VK_SELECT",e,e],[1,i.None,e,n.Unknown,e,0,"VK_PRINT",e,e],[1,i.None,e,n.Unknown,e,0,"VK_EXECUTE",e,e],[1,i.None,e,n.Unknown,e,0,"VK_SNAPSHOT",e,e],[1,i.None,e,n.Unknown,e,0,"VK_HELP",e,e],[1,i.None,e,n.Unknown,e,0,"VK_APPS",e,e],[1,i.None,e,n.Unknown,e,0,"VK_PROCESSKEY",e,e],[1,i.None,e,n.Unknown,e,0,"VK_PACKET",e,e],[1,i.None,e,n.Unknown,e,0,"VK_DBE_SBCSCHAR",e,e],[1,i.None,e,n.Unknown,e,0,"VK_DBE_DBCSCHAR",e,e],[1,i.None,e,n.Unknown,e,0,"VK_ATTN",e,e],[1,i.None,e,n.Unknown,e,0,"VK_CRSEL",e,e],[1,i.None,e,n.Unknown,e,0,"VK_EXSEL",e,e],[1,i.None,e,n.Unknown,e,0,"VK_EREOF",e,e],[1,i.None,e,n.Unknown,e,0,"VK_PLAY",e,e],[1,i.None,e,n.Unknown,e,0,"VK_ZOOM",e,e],[1,i.None,e,n.Unknown,e,0,"VK_NONAME",e,e],[1,i.None,e,n.Unknown,e,0,"VK_PA1",e,e],[1,i.None,e,n.Unknown,e,0,"VK_OEM_CLEAR",e,e]],g=[],E=[];for(const w of u){const[v,A,L,l,s,f,p,I,N]=w;if(E[A]||(E[A]=!0,o[A]=L,a[L]=A,h[L.toLowerCase()]=A,v&&(t.IMMUTABLE_CODE_TO_KEY_CODE[A]=l,l!==n.Unknown&&l!==n.Enter&&l!==n.Ctrl&&l!==n.Shift&&l!==n.Alt&&l!==n.Meta&&(t.IMMUTABLE_KEY_CODE_TO_CODE[l]=A))),!g[l]){if(g[l]=!0,!s)throw new Error(`String representation missing for key code ${l} around scan code ${L}`);m.define(l,s),R.define(l,I||s),b.define(l,N||I||s)}f&&(t.EVENT_KEY_CODE_MAP[f]=l),p&&(t.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE[p]=l)}t.IMMUTABLE_KEY_CODE_TO_CODE[n.Enter]=i.Enter})();var _;(function(e){function u(L){return m.keyCodeToStr(L)}e.toString=u;function g(L){return m.strToKeyCode(L)}e.fromString=g;function E(L){return R.keyCodeToStr(L)}e.toUserSettingsUS=E;function w(L){return b.keyCodeToStr(L)}e.toUserSettingsGeneral=w;function v(L){return R.strToKeyCode(L)||b.strToKeyCode(L)}e.fromUserSettings=v;function A(L){if(L>=n.Numpad0&&L<=n.NumpadDivide)return null;switch(L){case n.UpArrow:return"Up";case n.DownArrow:return"Down";case n.LeftArrow:return"Left";case n.RightArrow:return"Right"}return m.keyCodeToStr(L)}e.toElectronAccelerator=A})(_||(t.KeyCodeUtils=_={}));var d;(function(e){e[e.CtrlCmd=2048]="CtrlCmd",e[e.Shift=1024]="Shift",e[e.Alt=512]="Alt",e[e.WinCtrl=256]="WinCtrl"})(d||(t.KeyMod=d={}));function c(e,u){const g=(u&65535)<<16>>>0;return(e|g)>>>0}}),ie(re[27],ae([0,1]),function(C,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Lazy=void 0;class n{constructor(M){this.executor=M,this._didRun=!1}get hasValue(){return this._didRun}get value(){if(!this._didRun)try{this._value=this.executor()}catch(M){this._error=M}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}}t.Lazy=n}),ie(re[28],ae([0,1]),function(C,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LinkedList=void 0;class n{static{this.Undefined=new n(void 0)}constructor(m){this.element=m,this.next=n.Undefined,this.prev=n.Undefined}}class i{constructor(){this._first=n.Undefined,this._last=n.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===n.Undefined}clear(){let m=this._first;for(;m!==n.Undefined;){const R=m.next;m.prev=n.Undefined,m.next=n.Undefined,m=R}this._first=n.Undefined,this._last=n.Undefined,this._size=0}unshift(m){return this._insert(m,!1)}push(m){return this._insert(m,!0)}_insert(m,R){const b=new n(m);if(this._first===n.Undefined)this._first=b,this._last=b;else if(R){const a=this._last;this._last=b,b.prev=a,a.next=b}else{const a=this._first;this._first=b,b.next=a,a.prev=b}this._size+=1;let o=!1;return()=>{o||(o=!0,this._remove(b))}}shift(){if(this._first!==n.Undefined){const m=this._first.element;return this._remove(this._first),m}}pop(){if(this._last!==n.Undefined){const m=this._last.element;return this._remove(this._last),m}}_remove(m){if(m.prev!==n.Undefined&&m.next!==n.Undefined){const R=m.prev;R.next=m.next,m.next.prev=R}else m.prev===n.Undefined&&m.next===n.Undefined?(this._first=n.Undefined,this._last=n.Undefined):m.next===n.Undefined?(this._last=this._last.prev,this._last.next=n.Undefined):m.prev===n.Undefined&&(this._first=this._first.next,this._first.prev=n.Undefined);this._size-=1}*[Symbol.iterator](){let m=this._first;for(;m!==n.Undefined;)yield m.element,m=m.next}}t.LinkedList=i}),ie(re[19],ae([0,1]),function(C,t){"use strict";var n,i,M;Object.defineProperty(t,"__esModule",{value:!0}),t.SetMap=t.BidirectionalMap=t.CounterSet=t.MRUCache=t.LRUCache=t.LinkedMap=t.Touch=t.ResourceSet=t.ResourceMap=void 0,t.getOrSet=m,t.mapToString=R,t.setToString=b,t.mapsStrictEqualIgnoreOrder=A;function m(L,l,s){let f=L.get(l);return f===void 0&&(f=s,L.set(l,f)),f}function R(L){const l=[];return L.forEach((s,f)=>{l.push(`${f} => ${s}`)}),`Map(${L.size}) {${l.join(", ")}}`}function b(L){const l=[];return L.forEach(s=>{l.push(s)}),`Set(${L.size}) {${l.join(", ")}}`}class o{constructor(l,s){this.uri=l,this.value=s}}function a(L){return Array.isArray(L)}class h{static{this.defaultToKey=l=>l.toString()}constructor(l,s){if(this[n]="ResourceMap",l instanceof h)this.map=new Map(l.map),this.toKey=s??h.defaultToKey;else if(a(l)){this.map=new Map,this.toKey=s??h.defaultToKey;for(const[f,p]of l)this.set(f,p)}else this.map=new Map,this.toKey=l??h.defaultToKey}set(l,s){return this.map.set(this.toKey(l),new o(l,s)),this}get(l){return this.map.get(this.toKey(l))?.value}has(l){return this.map.has(this.toKey(l))}get size(){return this.map.size}clear(){this.map.clear()}delete(l){return this.map.delete(this.toKey(l))}forEach(l,s){typeof s<"u"&&(l=l.bind(s));for(const[f,p]of this.map)l(p.value,p.uri,this)}*values(){for(const l of this.map.values())yield l.value}*keys(){for(const l of this.map.values())yield l.uri}*entries(){for(const l of this.map.values())yield[l.uri,l.value]}*[(n=Symbol.toStringTag,Symbol.iterator)](){for(const[,l]of this.map)yield[l.uri,l.value]}}t.ResourceMap=h;class _{constructor(l,s){this[i]="ResourceSet",!l||typeof l=="function"?this._map=new h(l):(this._map=new h(s),l.forEach(this.add,this))}get size(){return this._map.size}add(l){return this._map.set(l,l),this}clear(){this._map.clear()}delete(l){return this._map.delete(l)}forEach(l,s){this._map.forEach((f,p)=>l.call(s,p,p,this))}has(l){return this._map.has(l)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(i=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}t.ResourceSet=_;var d;(function(L){L[L.None=0]="None",L[L.AsOld=1]="AsOld",L[L.AsNew=2]="AsNew"})(d||(t.Touch=d={}));class c{constructor(){this[M]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(l){return this._map.has(l)}get(l,s=d.None){const f=this._map.get(l);if(f)return s!==d.None&&this.touch(f,s),f.value}set(l,s,f=d.None){let p=this._map.get(l);if(p)p.value=s,f!==d.None&&this.touch(p,f);else{switch(p={key:l,value:s,next:void 0,previous:void 0},f){case d.None:this.addItemLast(p);break;case d.AsOld:this.addItemFirst(p);break;case d.AsNew:this.addItemLast(p);break;default:this.addItemLast(p);break}this._map.set(l,p),this._size++}return this}delete(l){return!!this.remove(l)}remove(l){const s=this._map.get(l);if(s)return this._map.delete(l),this.removeItem(s),this._size--,s.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const l=this._head;return this._map.delete(l.key),this.removeItem(l),this._size--,l.value}forEach(l,s){const f=this._state;let p=this._head;for(;p;){if(s?l.bind(s)(p.value,p.key,this):l(p.value,p.key,this),this._state!==f)throw new Error("LinkedMap got modified during iteration.");p=p.next}}keys(){const l=this,s=this._state;let f=this._head;const p={[Symbol.iterator](){return p},next(){if(l._state!==s)throw new Error("LinkedMap got modified during iteration.");if(f){const I={value:f.key,done:!1};return f=f.next,I}else return{value:void 0,done:!0}}};return p}values(){const l=this,s=this._state;let f=this._head;const p={[Symbol.iterator](){return p},next(){if(l._state!==s)throw new Error("LinkedMap got modified during iteration.");if(f){const I={value:f.value,done:!1};return f=f.next,I}else return{value:void 0,done:!0}}};return p}entries(){const l=this,s=this._state;let f=this._head;const p={[Symbol.iterator](){return p},next(){if(l._state!==s)throw new Error("LinkedMap got modified during iteration.");if(f){const I={value:[f.key,f.value],done:!1};return f=f.next,I}else return{value:void 0,done:!0}}};return p}[(M=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(l){if(l>=this.size)return;if(l===0){this.clear();return}let s=this._head,f=this.size;for(;s&&f>l;)this._map.delete(s.key),s=s.next,f--;this._head=s,this._size=f,s&&(s.previous=void 0),this._state++}trimNew(l){if(l>=this.size)return;if(l===0){this.clear();return}let s=this._tail,f=this.size;for(;s&&f>l;)this._map.delete(s.key),s=s.previous,f--;this._tail=s,this._size=f,s&&(s.next=void 0),this._state++}addItemFirst(l){if(!this._head&&!this._tail)this._tail=l;else if(this._head)l.next=this._head,this._head.previous=l;else throw new Error("Invalid list");this._head=l,this._state++}addItemLast(l){if(!this._head&&!this._tail)this._head=l;else if(this._tail)l.previous=this._tail,this._tail.next=l;else throw new Error("Invalid list");this._tail=l,this._state++}removeItem(l){if(l===this._head&&l===this._tail)this._head=void 0,this._tail=void 0;else if(l===this._head){if(!l.next)throw new Error("Invalid list");l.next.previous=void 0,this._head=l.next}else if(l===this._tail){if(!l.previous)throw new Error("Invalid list");l.previous.next=void 0,this._tail=l.previous}else{const s=l.next,f=l.previous;if(!s||!f)throw new Error("Invalid list");s.previous=f,f.next=s}l.next=void 0,l.previous=void 0,this._state++}touch(l,s){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(s!==d.AsOld&&s!==d.AsNew)){if(s===d.AsOld){if(l===this._head)return;const f=l.next,p=l.previous;l===this._tail?(p.next=void 0,this._tail=p):(f.previous=p,p.next=f),l.previous=void 0,l.next=this._head,this._head.previous=l,this._head=l,this._state++}else if(s===d.AsNew){if(l===this._tail)return;const f=l.next,p=l.previous;l===this._head?(f.previous=void 0,this._head=f):(f.previous=p,p.next=f),l.next=void 0,l.previous=this._tail,this._tail.next=l,this._tail=l,this._state++}}}toJSON(){const l=[];return this.forEach((s,f)=>{l.push([f,s])}),l}fromJSON(l){this.clear();for(const[s,f]of l)this.set(s,f)}}t.LinkedMap=c;class e extends c{constructor(l,s=1){super(),this._limit=l,this._ratio=Math.min(Math.max(0,s),1)}get limit(){return this._limit}set limit(l){this._limit=l,this.checkTrim()}get ratio(){return this._ratio}set ratio(l){this._ratio=Math.min(Math.max(0,l),1),this.checkTrim()}get(l,s=d.AsNew){return super.get(l,s)}peek(l){return super.get(l,d.None)}set(l,s){return super.set(l,s,d.AsNew),this}checkTrim(){this.size>this._limit&&this.trim(Math.round(this._limit*this._ratio))}}class u extends e{constructor(l,s=1){super(l,s)}trim(l){this.trimOld(l)}set(l,s){return super.set(l,s),this.checkTrim(),this}}t.LRUCache=u;class g extends e{constructor(l,s=1){super(l,s)}trim(l){this.trimNew(l)}set(l,s){return this._limit<=this.size&&!this.has(l)&&this.trim(Math.round(this._limit*this._ratio)-1),super.set(l,s),this}}t.MRUCache=g;class E{constructor(){this.map=new Map}add(l){return this.map.set(l,(this.map.get(l)||0)+1),this}delete(l){let s=this.map.get(l)||0;return s===0?!1:(s--,s===0?this.map.delete(l):this.map.set(l,s),!0)}has(l){return this.map.has(l)}}t.CounterSet=E;class w{constructor(l){if(this._m1=new Map,this._m2=new Map,l)for(const[s,f]of l)this.set(s,f)}clear(){this._m1.clear(),this._m2.clear()}set(l,s){this._m1.set(l,s),this._m2.set(s,l)}get(l){return this._m1.get(l)}getKey(l){return this._m2.get(l)}delete(l){const s=this._m1.get(l);return s===void 0?!1:(this._m1.delete(l),this._m2.delete(s),!0)}forEach(l,s){this._m1.forEach((f,p)=>{l.call(s,f,p,this)})}keys(){return this._m1.keys()}values(){return this._m1.values()}}t.BidirectionalMap=w;class v{constructor(){this.map=new Map}add(l,s){let f=this.map.get(l);f||(f=new Set,this.map.set(l,f)),f.add(s)}delete(l,s){const f=this.map.get(l);f&&(f.delete(s),f.size===0&&this.map.delete(l))}forEach(l,s){const f=this.map.get(l);f&&f.forEach(s)}get(l){const s=this.map.get(l);return s||new Set}}t.SetMap=v;function A(L,l){if(L===l)return!0;if(L.size!==l.size)return!1;for(const[s,f]of L)if(!l.has(s)||l.get(s)!==f)return!1;for(const[s]of l)if(!L.has(s))return!1;return!0}}),ie(re[10],ae([0,1,9,42,19,25,26]),function(C,t,n,i,M,m,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DisposableMap=t.ImmortalReference=t.AsyncReferenceCollection=t.ReferenceCollection=t.SafeDisposable=t.RefCountedDisposable=t.MandatoryMutableDisposable=t.MutableDisposable=t.Disposable=t.DisposableStore=t.DisposableTracker=void 0,t.setDisposableTracker=h,t.trackDisposable=_,t.markAsDisposed=d,t.markAsSingleton=u,t.isDisposable=g,t.dispose=E,t.disposeIfDisposable=w,t.combinedDisposable=v,t.toDisposable=A,t.disposeOnReturn=T;const b=!1;let o=null;class a{constructor(){this.livingDisposables=new Map}static{this.idx=0}getDisposableData(P){let q=this.livingDisposables.get(P);return q||(q={parent:null,source:null,isSingleton:!1,value:P,idx:a.idx++},this.livingDisposables.set(P,q)),q}trackDisposable(P){const q=this.getDisposableData(P);q.source||(q.source=new Error().stack)}setParent(P,q){const j=this.getDisposableData(P);j.parent=q}markAsDisposed(P){this.livingDisposables.delete(P)}markAsSingleton(P){this.getDisposableData(P).isSingleton=!0}getRootParent(P,q){const j=q.get(P);if(j)return j;const H=P.parent?this.getRootParent(this.getDisposableData(P.parent),q):P;return q.set(P,H),H}getTrackedDisposables(){const P=new Map;return[...this.livingDisposables.entries()].filter(([,j])=>j.source!==null&&!this.getRootParent(j,P).isSingleton).flatMap(([j])=>j)}computeLeakingDisposables(P=10,q){let j;if(q)j=q;else{const Z=new Map,K=[...this.livingDisposables.values()].filter(F=>F.source!==null&&!this.getRootParent(F,Z).isSingleton);if(K.length===0)return;const ne=new Set(K.map(F=>F.value));if(j=K.filter(F=>!(F.parent&&ne.has(F.parent))),j.length===0)throw new Error("There are cyclic diposable chains!")}if(!j)return;function H(Z){function K(F,$){for(;F.length>0&&$.some(he=>typeof he=="string"?he===F[0]:F[0].match(he));)F.shift()}const ne=Z.source.split(`
`).map(F=>F.trim().replace("at ","")).filter(F=>F!=="");return K(ne,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),ne.reverse()}const W=new M.SetMap;for(const Z of j){const K=H(Z);for(let ne=0;ne<=K.length;ne++)W.add(K.slice(0,ne).join(`
`),Z)}j.sort((0,n.compareBy)(Z=>Z.idx,n.numberComparator));let J="",ee=0;for(const Z of j.slice(0,P)){ee++;const K=H(Z),ne=[];for(let F=0;F<K.length;F++){let $=K[F];$=`(shared with ${W.get(K.slice(0,F+1).join(`
`)).size}/${j.length} leaks) at ${$}`;const ge=W.get(K.slice(0,F).join(`
`)),Ee=(0,i.groupBy)([...ge].map(r=>H(r)[F]),r=>r);delete Ee[K[F]];for(const[r,Te]of Object.entries(Ee))ne.unshift(`    - stacktraces of ${Te.length} other leaks continue with ${r}`);ne.unshift($)}J+=`


==================== Leaking disposable ${ee}/${j.length}: ${Z.value.constructor.name} ====================
${ne.join(`
`)}
============================================================

`}return j.length>P&&(J+=`


... and ${j.length-P} more leaking disposables

`),{leaks:j,details:J}}}t.DisposableTracker=a;function h(k){o=k}if(b){const k="__is_disposable_tracked__";h(new class{trackDisposable(P){const q=new Error("Potentially leaked disposable").stack;setTimeout(()=>{P[k]||console.log(q)},3e3)}setParent(P,q){if(P&&P!==l.None)try{P[k]=!0}catch{}}markAsDisposed(P){if(P&&P!==l.None)try{P[k]=!0}catch{}}markAsSingleton(P){}})}function _(k){return o?.trackDisposable(k),k}function d(k){o?.markAsDisposed(k)}function c(k,P){o?.setParent(k,P)}function e(k,P){if(o)for(const q of k)o.setParent(q,P)}function u(k){return o?.markAsSingleton(k),k}function g(k){return typeof k=="object"&&k!==null&&typeof k.dispose=="function"&&k.dispose.length===0}function E(k){if(R.Iterable.is(k)){const P=[];for(const q of k)if(q)try{q.dispose()}catch(j){P.push(j)}if(P.length===1)throw P[0];if(P.length>1)throw new AggregateError(P,"Encountered errors while disposing of store");return Array.isArray(k)?[]:k}else if(k)return k.dispose(),k}function w(k){for(const P of k)g(P)&&P.dispose();return[]}function v(...k){const P=A(()=>E(k));return e(k,P),P}function A(k){const P=_({dispose:(0,m.createSingleCallFunction)(()=>{d(P),k()})});return P}class L{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this._toDispose=new Set,this._isDisposed=!1,_(this)}dispose(){this._isDisposed||(d(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){if(this._toDispose.size!==0)try{E(this._toDispose)}finally{this._toDispose.clear()}}add(P){if(!P)return P;if(P===this)throw new Error("Cannot register a disposable on itself!");return c(P,this),this._isDisposed?L.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(P),P}delete(P){if(P){if(P===this)throw new Error("Cannot dispose a disposable on itself!");this._toDispose.delete(P),P.dispose()}}deleteAndLeak(P){P&&this._toDispose.has(P)&&(this._toDispose.delete(P),c(P,null))}}t.DisposableStore=L;class l{static{this.None=Object.freeze({dispose(){}})}constructor(){this._store=new L,_(this),c(this._store,this)}dispose(){d(this),this._store.dispose()}_register(P){if(P===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(P)}}t.Disposable=l;class s{constructor(){this._isDisposed=!1,_(this)}get value(){return this._isDisposed?void 0:this._value}set value(P){this._isDisposed||P===this._value||(this._value?.dispose(),P&&c(P,this),this._value=P)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,d(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const P=this._value;return this._value=void 0,P&&c(P,null),P}}t.MutableDisposable=s;class f{constructor(P){this._disposable=new s,this._isDisposed=!1,this._disposable.value=P}get value(){return this._disposable.value}set value(P){this._isDisposed||P===this._disposable.value||(this._disposable.value=P)}dispose(){this._isDisposed=!0,this._disposable.dispose()}}t.MandatoryMutableDisposable=f;class p{constructor(P){this._disposable=P,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter===0&&this._disposable.dispose(),this}}t.RefCountedDisposable=p;class I{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,_(this)}set(P){let q=P;return this.unset=()=>q=void 0,this.isset=()=>q!==void 0,this.dispose=()=>{q&&(q(),q=void 0,d(this))},this}}t.SafeDisposable=I;class N{constructor(){this.references=new Map}acquire(P,...q){let j=this.references.get(P);j||(j={counter:0,object:this.createReferencedObject(P,...q)},this.references.set(P,j));const{object:H}=j,W=(0,m.createSingleCallFunction)(()=>{--j.counter===0&&(this.destroyReferencedObject(P,j.object),this.references.delete(P))});return j.counter++,{object:H,dispose:W}}}t.ReferenceCollection=N;class S{constructor(P){this.referenceCollection=P}async acquire(P,...q){const j=this.referenceCollection.acquire(P,...q);try{return{object:await j.object,dispose:()=>j.dispose()}}catch(H){throw j.dispose(),H}}}t.AsyncReferenceCollection=S;class D{constructor(P){this.object=P}dispose(){}}t.ImmortalReference=D;function T(k){const P=new L;try{k(P)}finally{P.dispose()}}class y{constructor(){this._store=new Map,this._isDisposed=!1,_(this)}dispose(){d(this),this._isDisposed=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this._store.size)try{E(this._store.values())}finally{this._store.clear()}}has(P){return this._store.has(P)}get size(){return this._store.size}get(P){return this._store.get(P)}set(P,q,j=!1){this._isDisposed&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),j||this._store.get(P)?.dispose(),this._store.set(P,q)}deleteAndDispose(P){this._store.get(P)?.dispose(),this._store.delete(P)}deleteAndLeak(P){const q=this._store.get(P);return this._store.delete(P),q}keys(){return this._store.keys()}values(){return this._store.values()}[Symbol.iterator](){return this._store[Symbol.iterator]()}}t.DisposableMap=y}),ie(re[46],ae([0,1]),function(C,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.MarshalledId=void 0;var n;(function(i){i[i.Uri=1]="Uri",i[i.Regexp=2]="Regexp",i[i.ScmResource=3]="ScmResource",i[i.ScmResourceGroup=4]="ScmResourceGroup",i[i.ScmProvider=5]="ScmProvider",i[i.CommentController=6]="CommentController",i[i.CommentThread=7]="CommentThread",i[i.CommentThreadInstance=8]="CommentThreadInstance",i[i.CommentThreadReply=9]="CommentThreadReply",i[i.CommentNode=10]="CommentNode",i[i.CommentThreadNode=11]="CommentThreadNode",i[i.TimelineActionContext=12]="TimelineActionContext",i[i.NotebookCellActionContext=13]="NotebookCellActionContext",i[i.NotebookActionContext=14]="NotebookActionContext",i[i.TerminalContext=15]="TerminalContext",i[i.TestItemContext=16]="TestItemContext",i[i.Date=17]="Date",i[i.TestMessageMenuArgs=18]="TestMessageMenuArgs"})(n||(t.MarshalledId=n={}))}),ie(re[29],ae([0,1]),function(C,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StopWatch=void 0;const n=globalThis.performance&&typeof globalThis.performance.now=="function";class i{static create(m){return new i(m)}constructor(m){this._now=n&&m===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this._startTime=this._now(),this._stopTime=-1}stop(){this._stopTime=this._now()}reset(){this._startTime=this._now(),this._stopTime=-1}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}}t.StopWatch=i}),ie(re[12],ae([0,1,4,25,10,28,29]),function(C,t,n,i,M,m,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ValueWithChangeEvent=t.Relay=t.EventBufferer=t.DynamicListEventMultiplexer=t.EventMultiplexer=t.MicrotaskEmitter=t.DebounceEmitter=t.PauseableEmitter=t.AsyncEmitter=t.createEventDeliveryQueue=t.Emitter=t.ListenerRefusalError=t.ListenerLeakError=t.EventProfiling=t.Event=void 0,t.setGlobalLeakWarningThreshold=c;const b=!1,o=!1,a=!1;var h;(function(H){H.None=()=>M.Disposable.None;function W(oe){if(a){const{onDidAddListener:se}=oe,ce=u.create();let ue=0;oe.onDidAddListener=()=>{++ue===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),ce.print()),se?.()}}}function J(oe,se){return Te(oe,()=>{},0,void 0,!0,void 0,se)}H.defer=J;function ee(oe){return(se,ce=null,ue)=>{let me=!1,be;return be=oe(pe=>{if(!me)return be?be.dispose():me=!0,se.call(ce,pe)},null,ue),me&&be.dispose(),be}}H.once=ee;function Z(oe,se){return H.once(H.filter(oe,se))}H.onceIf=Z;function K(oe,se,ce){return Ee((ue,me=null,be)=>oe(pe=>ue.call(me,se(pe)),null,be),ce)}H.map=K;function ne(oe,se,ce){return Ee((ue,me=null,be)=>oe(pe=>{se(pe),ue.call(me,pe)},null,be),ce)}H.forEach=ne;function F(oe,se,ce){return Ee((ue,me=null,be)=>oe(pe=>se(pe)&&ue.call(me,pe),null,be),ce)}H.filter=F;function $(oe){return oe}H.signal=$;function he(...oe){return(se,ce=null,ue)=>{const me=(0,M.combinedDisposable)(...oe.map(be=>be(pe=>se.call(ce,pe))));return r(me,ue)}}H.any=he;function ge(oe,se,ce,ue){let me=ce;return K(oe,be=>(me=se(me,be),me),ue)}H.reduce=ge;function Ee(oe,se){let ce;const ue={onWillAddFirstListener(){ce=oe(me.fire,me)},onDidRemoveLastListener(){ce?.dispose()}};se||W(ue);const me=new s(ue);return se?.add(me),me.event}function r(oe,se){return se instanceof Array?se.push(oe):se&&se.add(oe),oe}function Te(oe,se,ce=100,ue=!1,me=!1,be,pe){let Me,Se,de,Pe=0,Ce;const je={leakWarningThreshold:be,onWillAddFirstListener(){Me=oe(Xe=>{Pe++,Se=se(Se,Xe),ue&&!de&&(He.fire(Se),Se=void 0),Ce=()=>{const Ve=Se;Se=void 0,de=void 0,(!ue||Pe>1)&&He.fire(Ve),Pe=0},typeof ce=="number"?(clearTimeout(de),de=setTimeout(Ce,ce)):de===void 0&&(de=0,queueMicrotask(Ce))})},onWillRemoveListener(){me&&Pe>0&&Ce?.()},onDidRemoveLastListener(){Ce=void 0,Me.dispose()}};pe||W(je);const He=new s(je);return pe?.add(He),He.event}H.debounce=Te;function ke(oe,se=0,ce){return H.debounce(oe,(ue,me)=>ue?(ue.push(me),ue):[me],se,void 0,!0,void 0,ce)}H.accumulate=ke;function We(oe,se=(ue,me)=>ue===me,ce){let ue=!0,me;return F(oe,be=>{const pe=ue||!se(be,me);return ue=!1,me=be,pe},ce)}H.latch=We;function Re(oe,se,ce){return[H.filter(oe,se,ce),H.filter(oe,ue=>!se(ue),ce)]}H.split=Re;function we(oe,se=!1,ce=[],ue){let me=ce.slice(),be=oe(Se=>{me?me.push(Se):Me.fire(Se)});ue&&ue.add(be);const pe=()=>{me?.forEach(Se=>Me.fire(Se)),me=null},Me=new s({onWillAddFirstListener(){be||(be=oe(Se=>Me.fire(Se)),ue&&ue.add(be))},onDidAddFirstListener(){me&&(se?setTimeout(pe):pe())},onDidRemoveLastListener(){be&&be.dispose(),be=null}});return ue&&ue.add(Me),Me.event}H.buffer=we;function Ue(oe,se){return(ue,me,be)=>{const pe=se(new G);return oe(function(Me){const Se=pe.evaluate(Me);Se!==z&&ue.call(me,Se)},void 0,be)}}H.chain=Ue;const z=Symbol("HaltChainable");class G{constructor(){this.steps=[]}map(se){return this.steps.push(se),this}forEach(se){return this.steps.push(ce=>(se(ce),ce)),this}filter(se){return this.steps.push(ce=>se(ce)?ce:z),this}reduce(se,ce){let ue=ce;return this.steps.push(me=>(ue=se(ue,me),ue)),this}latch(se=(ce,ue)=>ce===ue){let ce=!0,ue;return this.steps.push(me=>{const be=ce||!se(me,ue);return ce=!1,ue=me,be?me:z}),this}evaluate(se){for(const ce of this.steps)if(se=ce(se),se===z)break;return se}}function x(oe,se,ce=ue=>ue){const ue=(...Me)=>pe.fire(ce(...Me)),me=()=>oe.on(se,ue),be=()=>oe.removeListener(se,ue),pe=new s({onWillAddFirstListener:me,onDidRemoveLastListener:be});return pe.event}H.fromNodeEventEmitter=x;function O(oe,se,ce=ue=>ue){const ue=(...Me)=>pe.fire(ce(...Me)),me=()=>oe.addEventListener(se,ue),be=()=>oe.removeEventListener(se,ue),pe=new s({onWillAddFirstListener:me,onDidRemoveLastListener:be});return pe.event}H.fromDOMEventEmitter=O;function U(oe){return new Promise(se=>ee(oe)(se))}H.toPromise=U;function X(oe){const se=new s;return oe.then(ce=>{se.fire(ce)},()=>{se.fire(void 0)}).finally(()=>{se.dispose()}),se.event}H.fromPromise=X;function Q(oe,se){return oe(ce=>se.fire(ce))}H.forward=Q;function le(oe,se,ce){return se(ce),oe(ue=>se(ue))}H.runAndSubscribe=le;class Le{constructor(se,ce){this._observable=se,this._counter=0,this._hasChanged=!1;const ue={onWillAddFirstListener:()=>{se.addObserver(this),this._observable.reportChanges()},onDidRemoveLastListener:()=>{se.removeObserver(this)}};ce||W(ue),this.emitter=new s(ue),ce&&ce.add(this.emitter)}beginUpdate(se){this._counter++}handlePossibleChange(se){}handleChange(se,ce){this._hasChanged=!0}endUpdate(se){this._counter--,this._counter===0&&(this._observable.reportChanges(),this._hasChanged&&(this._hasChanged=!1,this.emitter.fire(this._observable.get())))}}function ve(oe,se){return new Le(oe,se).emitter.event}H.fromObservable=ve;function Ne(oe){return(se,ce,ue)=>{let me=0,be=!1;const pe={beginUpdate(){me++},endUpdate(){me--,me===0&&(oe.reportChanges(),be&&(be=!1,se.call(ce)))},handlePossibleChange(){},handleChange(){be=!0}};oe.addObserver(pe),oe.reportChanges();const Me={dispose(){oe.removeObserver(pe)}};return ue instanceof M.DisposableStore?ue.add(Me):Array.isArray(ue)&&ue.push(Me),Me}}H.fromObservableLight=Ne})(h||(t.Event=h={}));class _{static{this.all=new Set}static{this._idPool=0}constructor(W){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${W}_${_._idPool++}`,_.all.add(this)}start(W){this._stopWatch=new R.StopWatch,this.listenerCount=W}stop(){if(this._stopWatch){const W=this._stopWatch.elapsed();this.durations.push(W),this.elapsedOverall+=W,this.invocationCount+=1,this._stopWatch=void 0}}}t.EventProfiling=_;let d=-1;function c(H){const W=d;return d=H,{dispose(){d=W}}}class e{static{this._idPool=1}constructor(W,J,ee=(e._idPool++).toString(16).padStart(3,"0")){this._errorHandler=W,this.threshold=J,this.name=ee,this._warnCountdown=0}dispose(){this._stacks?.clear()}check(W,J){const ee=this.threshold;if(ee<=0||J<ee)return;this._stacks||(this._stacks=new Map);const Z=this._stacks.get(W.value)||0;if(this._stacks.set(W.value,Z+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=ee*.5;const[K,ne]=this.getMostFrequentStack(),F=`[${this.name}] potential listener LEAK detected, having ${J} listeners already. MOST frequent listener (${ne}):`;console.warn(F),console.warn(K);const $=new g(F,K);this._errorHandler($)}return()=>{const K=this._stacks.get(W.value)||0;this._stacks.set(W.value,K-1)}}getMostFrequentStack(){if(!this._stacks)return;let W,J=0;for(const[ee,Z]of this._stacks)(!W||J<Z)&&(W=[ee,Z],J=Z);return W}}class u{static create(){const W=new Error;return new u(W.stack??"")}constructor(W){this.value=W}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class g extends Error{constructor(W,J){super(W),this.name="ListenerLeakError",this.stack=J}}t.ListenerLeakError=g;class E extends Error{constructor(W,J){super(W),this.name="ListenerRefusalError",this.stack=J}}t.ListenerRefusalError=E;let w=0;class v{constructor(W){this.value=W,this.id=w++}}const A=2,L=(H,W)=>{if(H instanceof v)W(H);else for(let J=0;J<H.length;J++){const ee=H[J];ee&&W(ee)}};let l;if(b){const H=[];setInterval(()=>{H.length!==0&&(console.warn("[LEAKING LISTENERS] GC'ed these listeners that were NOT yet disposed:"),console.warn(H.join(`
`)),H.length=0)},3e3),l=new FinalizationRegistry(W=>{typeof W=="string"&&H.push(W)})}class s{constructor(W){this._size=0,this._options=W,this._leakageMon=d>0||this._options?.leakWarningThreshold?new e(W?.onListenerError??n.onUnexpectedError,this._options?.leakWarningThreshold??d):void 0,this._perfMon=this._options?._profName?new _(this._options._profName):void 0,this._deliveryQueue=this._options?.deliveryQueue}dispose(){if(!this._disposed){if(this._disposed=!0,this._deliveryQueue?.current===this&&this._deliveryQueue.reset(),this._listeners){if(o){const W=this._listeners;queueMicrotask(()=>{L(W,J=>J.stack?.print())})}this._listeners=void 0,this._size=0}this._options?.onDidRemoveLastListener?.(),this._leakageMon?.dispose()}}get event(){return this._event??=(W,J,ee)=>{if(this._leakageMon&&this._size>this._leakageMon.threshold**2){const $=`[${this._leakageMon.name}] REFUSES to accept new listeners because it exceeded its threshold by far (${this._size} vs ${this._leakageMon.threshold})`;console.warn($);const he=this._leakageMon.getMostFrequentStack()??["UNKNOWN stack",-1],ge=new E(`${$}. HINT: Stack shows most frequent listener (${he[1]}-times)`,he[0]);return(this._options?.onListenerError||n.onUnexpectedError)(ge),M.Disposable.None}if(this._disposed)return M.Disposable.None;J&&(W=W.bind(J));const Z=new v(W);let K,ne;this._leakageMon&&this._size>=Math.ceil(this._leakageMon.threshold*.2)&&(Z.stack=u.create(),K=this._leakageMon.check(Z.stack,this._size+1)),o&&(Z.stack=ne??u.create()),this._listeners?this._listeners instanceof v?(this._deliveryQueue??=new p,this._listeners=[this._listeners,Z]):this._listeners.push(Z):(this._options?.onWillAddFirstListener?.(this),this._listeners=Z,this._options?.onDidAddFirstListener?.(this)),this._size++;const F=(0,M.toDisposable)(()=>{l?.unregister(F),K?.(),this._removeListener(Z)});if(ee instanceof M.DisposableStore?ee.add(F):Array.isArray(ee)&&ee.push(F),l){const $=new Error().stack.split(`
`).slice(2,3).join(`
`).trim(),he=/(file:|vscode-file:\/\/vscode-app)?(\/[^:]*:\d+:\d+)/.exec($);l.register(F,he?.[2]??$,F)}return F},this._event}_removeListener(W){if(this._options?.onWillRemoveListener?.(this),!this._listeners)return;if(this._size===1){this._listeners=void 0,this._options?.onDidRemoveLastListener?.(this),this._size=0;return}const J=this._listeners,ee=J.indexOf(W);if(ee===-1)throw console.log("disposed?",this._disposed),console.log("size?",this._size),console.log("arr?",JSON.stringify(this._listeners)),new Error("Attempted to dispose unknown listener");this._size--,J[ee]=void 0;const Z=this._deliveryQueue.current===this;if(this._size*A<=J.length){let K=0;for(let ne=0;ne<J.length;ne++)J[ne]?J[K++]=J[ne]:Z&&(this._deliveryQueue.end--,K<this._deliveryQueue.i&&this._deliveryQueue.i--);J.length=K}}_deliver(W,J){if(!W)return;const ee=this._options?.onListenerError||n.onUnexpectedError;if(!ee){W.value(J);return}try{W.value(J)}catch(Z){ee(Z)}}_deliverQueue(W){const J=W.current._listeners;for(;W.i<W.end;)this._deliver(J[W.i++],W.value);W.reset()}fire(W){if(this._deliveryQueue?.current&&(this._deliverQueue(this._deliveryQueue),this._perfMon?.stop()),this._perfMon?.start(this._size),this._listeners)if(this._listeners instanceof v)this._deliver(this._listeners,W);else{const J=this._deliveryQueue;J.enqueue(this,W,this._listeners.length),this._deliverQueue(J)}this._perfMon?.stop()}hasListeners(){return this._size>0}}t.Emitter=s;const f=()=>new p;t.createEventDeliveryQueue=f;class p{constructor(){this.i=-1,this.end=0}enqueue(W,J,ee){this.i=0,this.end=ee,this.current=W,this.value=J}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class I extends s{async fireAsync(W,J,ee){if(this._listeners)for(this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new m.LinkedList),L(this._listeners,Z=>this._asyncDeliveryQueue.push([Z.value,W]));this._asyncDeliveryQueue.size>0&&!J.isCancellationRequested;){const[Z,K]=this._asyncDeliveryQueue.shift(),ne=[],F={...K,token:J,waitUntil:$=>{if(Object.isFrozen(ne))throw new Error("waitUntil can NOT be called asynchronous");ee&&($=ee($,Z)),ne.push($)}};try{Z(F)}catch($){(0,n.onUnexpectedError)($);continue}Object.freeze(ne),await Promise.allSettled(ne).then($=>{for(const he of $)he.status==="rejected"&&(0,n.onUnexpectedError)(he.reason)})}}}t.AsyncEmitter=I;class N extends s{get isPaused(){return this._isPaused!==0}constructor(W){super(W),this._isPaused=0,this._eventQueue=new m.LinkedList,this._mergeFn=W?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused===0)if(this._mergeFn){if(this._eventQueue.size>0){const W=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(W))}}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(W){this._size&&(this._isPaused!==0?this._eventQueue.push(W):super.fire(W))}}t.PauseableEmitter=N;class S extends N{constructor(W){super(W),this._delay=W.delay??100}fire(W){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(W)}}t.DebounceEmitter=S;class D extends s{constructor(W){super(W),this._queuedEvents=[],this._mergeFn=W?.merge}fire(W){this.hasListeners()&&(this._queuedEvents.push(W),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(J=>super.fire(J)),this._queuedEvents=[]}))}}t.MicrotaskEmitter=D;class T{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new s({onWillAddFirstListener:()=>this.onFirstListenerAdd(),onDidRemoveLastListener:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(W){const J={event:W,listener:null};this.events.push(J),this.hasListeners&&this.hook(J);const ee=()=>{this.hasListeners&&this.unhook(J);const Z=this.events.indexOf(J);this.events.splice(Z,1)};return(0,M.toDisposable)((0,i.createSingleCallFunction)(ee))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(W=>this.hook(W))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(W=>this.unhook(W))}hook(W){W.listener=W.event(J=>this.emitter.fire(J))}unhook(W){W.listener?.dispose(),W.listener=null}dispose(){this.emitter.dispose();for(const W of this.events)W.listener?.dispose();this.events=[]}}t.EventMultiplexer=T;class y{constructor(W,J,ee,Z){this._store=new M.DisposableStore;const K=this._store.add(new T),ne=this._store.add(new M.DisposableMap);function F($){ne.set($,K.add(Z($)))}for(const $ of W)F($);this._store.add(J($=>{F($)})),this._store.add(ee($=>{ne.deleteAndDispose($)})),this.event=K.event}dispose(){this._store.dispose()}}t.DynamicListEventMultiplexer=y;class k{constructor(){this.data=[]}wrapEvent(W,J,ee){return(Z,K,ne)=>W(F=>{const $=this.data[this.data.length-1];if(!J){$?$.buffers.push(()=>Z.call(K,F)):Z.call(K,F);return}const he=$;if(!he){Z.call(K,J(ee,F));return}he.items??=[],he.items.push(F),he.buffers.length===0&&$.buffers.push(()=>{he.reducedResult??=ee?he.items.reduce(J,ee):he.items.reduce(J),Z.call(K,he.reducedResult)})},void 0,ne)}bufferEvents(W){const J={buffers:new Array};this.data.push(J);const ee=W();return this.data.pop(),J.buffers.forEach(Z=>Z()),ee}}t.EventBufferer=k;class P{constructor(){this.listening=!1,this.inputEvent=h.None,this.inputEventListener=M.Disposable.None,this.emitter=new s({onDidAddFirstListener:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onDidRemoveLastListener:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(W){this.inputEvent=W,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=W(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}t.Relay=P;class q{static const(W){return new j(W)}constructor(W){this._value=W,this._onDidChange=new s,this.onDidChange=this._onDidChange.event}get value(){return this._value}set value(W){W!==this._value&&(this._value=W,this._onDidChange.fire(void 0))}}t.ValueWithChangeEvent=q;class j{constructor(W){this.value=W,this.onDidChange=h.None}}}),ie(re[20],ae([0,1,12]),function(C,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CancellationTokenSource=t.CancellationToken=void 0,t.cancelOnDispose=b;const i=Object.freeze(function(o,a){const h=setTimeout(o.bind(a),0);return{dispose(){clearTimeout(h)}}});var M;(function(o){function a(h){return h===o.None||h===o.Cancelled||h instanceof m?!0:!h||typeof h!="object"?!1:typeof h.isCancellationRequested=="boolean"&&typeof h.onCancellationRequested=="function"}o.isCancellationToken=a,o.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:n.Event.None}),o.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:i})})(M||(t.CancellationToken=M={}));class m{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?i:(this._emitter||(this._emitter=new n.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class R{constructor(a){this._token=void 0,this._parentListener=void 0,this._parentListener=a&&a.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new m),this._token}cancel(){this._token?this._token instanceof m&&this._token.cancel():this._token=M.Cancelled}dispose(a=!1){a&&this.cancel(),this._parentListener?.dispose(),this._token?this._token instanceof m&&this._token.dispose():this._token=M.None}}t.CancellationTokenSource=R;function b(o){const a=new R;return o.add({dispose(){a.cancel()}}),a.token}}),ie(re[47],ae([0,1,20]),function(C,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CachedFunction=t.LRUCachedFunction=t.Cache=void 0,t.identity=M;class i{constructor(o){this.task=o,this.result=null}get(){if(this.result)return this.result;const o=new n.CancellationTokenSource,a=this.task(o.token);return this.result={promise:a,dispose:()=>{this.result=null,o.cancel(),o.dispose()}},this.result}}t.Cache=i;function M(b){return b}class m{constructor(o,a){this.lastCache=void 0,this.lastArgKey=void 0,typeof o=="function"?(this._fn=o,this._computeKey=M):(this._fn=a,this._computeKey=o.getCacheKey)}get(o){const a=this._computeKey(o);return this.lastArgKey!==a&&(this.lastArgKey=a,this.lastCache=this._fn(o)),this.lastCache}}t.LRUCachedFunction=m;class R{get cachedValues(){return this._map}constructor(o,a){this._map=new Map,this._map2=new Map,typeof o=="function"?(this._fn=o,this._computeKey=M):(this._fn=a,this._computeKey=o.getCacheKey)}get(o){const a=this._computeKey(o);if(this._map2.has(a))return this._map2.get(a);const h=this._fn(o);return this._map.set(o,h),this._map2.set(a,h),h}}t.CachedFunction=R}),ie(re[48],ae([0,1]),function(C,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.MicrotaskDelay=void 0,t.MicrotaskDelay=Symbol("MicrotaskDelay")}),ie(re[21],ae([0,1]),function(C,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isString=n,t.isStringArray=i,t.isObject=M,t.isTypedArray=m,t.isNumber=R,t.isIterable=b,t.isBoolean=o,t.isUndefined=a,t.isDefined=h,t.isUndefinedOrNull=_,t.assertType=d,t.assertIsDefined=c,t.assertAllDefined=e,t.isEmptyObject=g,t.isFunction=E,t.areFunctions=w,t.validateConstraints=v,t.validateConstraint=A,t.upcast=L;function n(l){return typeof l=="string"}function i(l){return Array.isArray(l)&&l.every(s=>n(s))}function M(l){return typeof l=="object"&&l!==null&&!Array.isArray(l)&&!(l instanceof RegExp)&&!(l instanceof Date)}function m(l){const s=Object.getPrototypeOf(Uint8Array);return typeof l=="object"&&l instanceof s}function R(l){return typeof l=="number"&&!isNaN(l)}function b(l){return!!l&&typeof l[Symbol.iterator]=="function"}function o(l){return l===!0||l===!1}function a(l){return typeof l>"u"}function h(l){return!_(l)}function _(l){return a(l)||l===null}function d(l,s){if(!l)throw new Error(s?`Unexpected type, expected '${s}'`:"Unexpected type")}function c(l){if(_(l))throw new Error("Assertion Failed: argument is undefined or null");return l}function e(...l){const s=[];for(let f=0;f<l.length;f++){const p=l[f];if(_(p))throw new Error(`Assertion Failed: argument at index ${f} is undefined or null`);s.push(p)}return s}const u=Object.prototype.hasOwnProperty;function g(l){if(!M(l))return!1;for(const s in l)if(u.call(l,s))return!1;return!0}function E(l){return typeof l=="function"}function w(...l){return l.length>0&&l.every(E)}function v(l,s){const f=Math.min(l.length,s.length);for(let p=0;p<f;p++)A(l[p],s[p])}function A(l,s){if(n(s)){if(typeof l!==s)throw new Error(`argument does not match constraint: typeof ${s}`)}else if(E(s)){try{if(l instanceof s)return}catch{}if(!_(l)&&l.constructor===s||s.length===1&&s.call(void 0,l)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}function L(l){return l}}),ie(re[30],ae([0,1,21]),function(C,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.register=M,t.getCodiconFontCharacters=m;const i=Object.create(null);function M(R,b){if((0,n.isString)(b)){const o=i[b];if(o===void 0)throw new Error(`${R} references an unknown codicon: ${b}`);b=o}return i[R]=b,{id:R}}function m(){return i}}),ie(re[49],ae([0,1,30]),function(C,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.codiconsLibrary=void 0,t.codiconsLibrary={add:(0,n.register)("add",6e4),plus:(0,n.register)("plus",6e4),gistNew:(0,n.register)("gist-new",6e4),repoCreate:(0,n.register)("repo-create",6e4),lightbulb:(0,n.register)("lightbulb",60001),lightBulb:(0,n.register)("light-bulb",60001),repo:(0,n.register)("repo",60002),repoDelete:(0,n.register)("repo-delete",60002),gistFork:(0,n.register)("gist-fork",60003),repoForked:(0,n.register)("repo-forked",60003),gitPullRequest:(0,n.register)("git-pull-request",60004),gitPullRequestAbandoned:(0,n.register)("git-pull-request-abandoned",60004),recordKeys:(0,n.register)("record-keys",60005),keyboard:(0,n.register)("keyboard",60005),tag:(0,n.register)("tag",60006),gitPullRequestLabel:(0,n.register)("git-pull-request-label",60006),tagAdd:(0,n.register)("tag-add",60006),tagRemove:(0,n.register)("tag-remove",60006),person:(0,n.register)("person",60007),personFollow:(0,n.register)("person-follow",60007),personOutline:(0,n.register)("person-outline",60007),personFilled:(0,n.register)("person-filled",60007),gitBranch:(0,n.register)("git-branch",60008),gitBranchCreate:(0,n.register)("git-branch-create",60008),gitBranchDelete:(0,n.register)("git-branch-delete",60008),sourceControl:(0,n.register)("source-control",60008),mirror:(0,n.register)("mirror",60009),mirrorPublic:(0,n.register)("mirror-public",60009),star:(0,n.register)("star",60010),starAdd:(0,n.register)("star-add",60010),starDelete:(0,n.register)("star-delete",60010),starEmpty:(0,n.register)("star-empty",60010),comment:(0,n.register)("comment",60011),commentAdd:(0,n.register)("comment-add",60011),alert:(0,n.register)("alert",60012),warning:(0,n.register)("warning",60012),search:(0,n.register)("search",60013),searchSave:(0,n.register)("search-save",60013),logOut:(0,n.register)("log-out",60014),signOut:(0,n.register)("sign-out",60014),logIn:(0,n.register)("log-in",60015),signIn:(0,n.register)("sign-in",60015),eye:(0,n.register)("eye",60016),eyeUnwatch:(0,n.register)("eye-unwatch",60016),eyeWatch:(0,n.register)("eye-watch",60016),circleFilled:(0,n.register)("circle-filled",60017),primitiveDot:(0,n.register)("primitive-dot",60017),closeDirty:(0,n.register)("close-dirty",60017),debugBreakpoint:(0,n.register)("debug-breakpoint",60017),debugBreakpointDisabled:(0,n.register)("debug-breakpoint-disabled",60017),debugHint:(0,n.register)("debug-hint",60017),terminalDecorationSuccess:(0,n.register)("terminal-decoration-success",60017),primitiveSquare:(0,n.register)("primitive-square",60018),edit:(0,n.register)("edit",60019),pencil:(0,n.register)("pencil",60019),info:(0,n.register)("info",60020),issueOpened:(0,n.register)("issue-opened",60020),gistPrivate:(0,n.register)("gist-private",60021),gitForkPrivate:(0,n.register)("git-fork-private",60021),lock:(0,n.register)("lock",60021),mirrorPrivate:(0,n.register)("mirror-private",60021),close:(0,n.register)("close",60022),removeClose:(0,n.register)("remove-close",60022),x:(0,n.register)("x",60022),repoSync:(0,n.register)("repo-sync",60023),sync:(0,n.register)("sync",60023),clone:(0,n.register)("clone",60024),desktopDownload:(0,n.register)("desktop-download",60024),beaker:(0,n.register)("beaker",60025),microscope:(0,n.register)("microscope",60025),vm:(0,n.register)("vm",60026),deviceDesktop:(0,n.register)("device-desktop",60026),file:(0,n.register)("file",60027),fileText:(0,n.register)("file-text",60027),more:(0,n.register)("more",60028),ellipsis:(0,n.register)("ellipsis",60028),kebabHorizontal:(0,n.register)("kebab-horizontal",60028),mailReply:(0,n.register)("mail-reply",60029),reply:(0,n.register)("reply",60029),organization:(0,n.register)("organization",60030),organizationFilled:(0,n.register)("organization-filled",60030),organizationOutline:(0,n.register)("organization-outline",60030),newFile:(0,n.register)("new-file",60031),fileAdd:(0,n.register)("file-add",60031),newFolder:(0,n.register)("new-folder",60032),fileDirectoryCreate:(0,n.register)("file-directory-create",60032),trash:(0,n.register)("trash",60033),trashcan:(0,n.register)("trashcan",60033),history:(0,n.register)("history",60034),clock:(0,n.register)("clock",60034),folder:(0,n.register)("folder",60035),fileDirectory:(0,n.register)("file-directory",60035),symbolFolder:(0,n.register)("symbol-folder",60035),logoGithub:(0,n.register)("logo-github",60036),markGithub:(0,n.register)("mark-github",60036),github:(0,n.register)("github",60036),terminal:(0,n.register)("terminal",60037),console:(0,n.register)("console",60037),repl:(0,n.register)("repl",60037),zap:(0,n.register)("zap",60038),symbolEvent:(0,n.register)("symbol-event",60038),error:(0,n.register)("error",60039),stop:(0,n.register)("stop",60039),variable:(0,n.register)("variable",60040),symbolVariable:(0,n.register)("symbol-variable",60040),array:(0,n.register)("array",60042),symbolArray:(0,n.register)("symbol-array",60042),symbolModule:(0,n.register)("symbol-module",60043),symbolPackage:(0,n.register)("symbol-package",60043),symbolNamespace:(0,n.register)("symbol-namespace",60043),symbolObject:(0,n.register)("symbol-object",60043),symbolMethod:(0,n.register)("symbol-method",60044),symbolFunction:(0,n.register)("symbol-function",60044),symbolConstructor:(0,n.register)("symbol-constructor",60044),symbolBoolean:(0,n.register)("symbol-boolean",60047),symbolNull:(0,n.register)("symbol-null",60047),symbolNumeric:(0,n.register)("symbol-numeric",60048),symbolNumber:(0,n.register)("symbol-number",60048),symbolStructure:(0,n.register)("symbol-structure",60049),symbolStruct:(0,n.register)("symbol-struct",60049),symbolParameter:(0,n.register)("symbol-parameter",60050),symbolTypeParameter:(0,n.register)("symbol-type-parameter",60050),symbolKey:(0,n.register)("symbol-key",60051),symbolText:(0,n.register)("symbol-text",60051),symbolReference:(0,n.register)("symbol-reference",60052),goToFile:(0,n.register)("go-to-file",60052),symbolEnum:(0,n.register)("symbol-enum",60053),symbolValue:(0,n.register)("symbol-value",60053),symbolRuler:(0,n.register)("symbol-ruler",60054),symbolUnit:(0,n.register)("symbol-unit",60054),activateBreakpoints:(0,n.register)("activate-breakpoints",60055),archive:(0,n.register)("archive",60056),arrowBoth:(0,n.register)("arrow-both",60057),arrowDown:(0,n.register)("arrow-down",60058),arrowLeft:(0,n.register)("arrow-left",60059),arrowRight:(0,n.register)("arrow-right",60060),arrowSmallDown:(0,n.register)("arrow-small-down",60061),arrowSmallLeft:(0,n.register)("arrow-small-left",60062),arrowSmallRight:(0,n.register)("arrow-small-right",60063),arrowSmallUp:(0,n.register)("arrow-small-up",60064),arrowUp:(0,n.register)("arrow-up",60065),bell:(0,n.register)("bell",60066),bold:(0,n.register)("bold",60067),book:(0,n.register)("book",60068),bookmark:(0,n.register)("bookmark",60069),debugBreakpointConditionalUnverified:(0,n.register)("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:(0,n.register)("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:(0,n.register)("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:(0,n.register)("debug-breakpoint-data-unverified",60072),debugBreakpointData:(0,n.register)("debug-breakpoint-data",60073),debugBreakpointDataDisabled:(0,n.register)("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:(0,n.register)("debug-breakpoint-log-unverified",60074),debugBreakpointLog:(0,n.register)("debug-breakpoint-log",60075),debugBreakpointLogDisabled:(0,n.register)("debug-breakpoint-log-disabled",60075),briefcase:(0,n.register)("briefcase",60076),broadcast:(0,n.register)("broadcast",60077),browser:(0,n.register)("browser",60078),bug:(0,n.register)("bug",60079),calendar:(0,n.register)("calendar",60080),caseSensitive:(0,n.register)("case-sensitive",60081),check:(0,n.register)("check",60082),checklist:(0,n.register)("checklist",60083),chevronDown:(0,n.register)("chevron-down",60084),chevronLeft:(0,n.register)("chevron-left",60085),chevronRight:(0,n.register)("chevron-right",60086),chevronUp:(0,n.register)("chevron-up",60087),chromeClose:(0,n.register)("chrome-close",60088),chromeMaximize:(0,n.register)("chrome-maximize",60089),chromeMinimize:(0,n.register)("chrome-minimize",60090),chromeRestore:(0,n.register)("chrome-restore",60091),circleOutline:(0,n.register)("circle-outline",60092),circle:(0,n.register)("circle",60092),debugBreakpointUnverified:(0,n.register)("debug-breakpoint-unverified",60092),terminalDecorationIncomplete:(0,n.register)("terminal-decoration-incomplete",60092),circleSlash:(0,n.register)("circle-slash",60093),circuitBoard:(0,n.register)("circuit-board",60094),clearAll:(0,n.register)("clear-all",60095),clippy:(0,n.register)("clippy",60096),closeAll:(0,n.register)("close-all",60097),cloudDownload:(0,n.register)("cloud-download",60098),cloudUpload:(0,n.register)("cloud-upload",60099),code:(0,n.register)("code",60100),collapseAll:(0,n.register)("collapse-all",60101),colorMode:(0,n.register)("color-mode",60102),commentDiscussion:(0,n.register)("comment-discussion",60103),creditCard:(0,n.register)("credit-card",60105),dash:(0,n.register)("dash",60108),dashboard:(0,n.register)("dashboard",60109),database:(0,n.register)("database",60110),debugContinue:(0,n.register)("debug-continue",60111),debugDisconnect:(0,n.register)("debug-disconnect",60112),debugPause:(0,n.register)("debug-pause",60113),debugRestart:(0,n.register)("debug-restart",60114),debugStart:(0,n.register)("debug-start",60115),debugStepInto:(0,n.register)("debug-step-into",60116),debugStepOut:(0,n.register)("debug-step-out",60117),debugStepOver:(0,n.register)("debug-step-over",60118),debugStop:(0,n.register)("debug-stop",60119),debug:(0,n.register)("debug",60120),deviceCameraVideo:(0,n.register)("device-camera-video",60121),deviceCamera:(0,n.register)("device-camera",60122),deviceMobile:(0,n.register)("device-mobile",60123),diffAdded:(0,n.register)("diff-added",60124),diffIgnored:(0,n.register)("diff-ignored",60125),diffModified:(0,n.register)("diff-modified",60126),diffRemoved:(0,n.register)("diff-removed",60127),diffRenamed:(0,n.register)("diff-renamed",60128),diff:(0,n.register)("diff",60129),diffSidebyside:(0,n.register)("diff-sidebyside",60129),discard:(0,n.register)("discard",60130),editorLayout:(0,n.register)("editor-layout",60131),emptyWindow:(0,n.register)("empty-window",60132),exclude:(0,n.register)("exclude",60133),extensions:(0,n.register)("extensions",60134),eyeClosed:(0,n.register)("eye-closed",60135),fileBinary:(0,n.register)("file-binary",60136),fileCode:(0,n.register)("file-code",60137),fileMedia:(0,n.register)("file-media",60138),filePdf:(0,n.register)("file-pdf",60139),fileSubmodule:(0,n.register)("file-submodule",60140),fileSymlinkDirectory:(0,n.register)("file-symlink-directory",60141),fileSymlinkFile:(0,n.register)("file-symlink-file",60142),fileZip:(0,n.register)("file-zip",60143),files:(0,n.register)("files",60144),filter:(0,n.register)("filter",60145),flame:(0,n.register)("flame",60146),foldDown:(0,n.register)("fold-down",60147),foldUp:(0,n.register)("fold-up",60148),fold:(0,n.register)("fold",60149),folderActive:(0,n.register)("folder-active",60150),folderOpened:(0,n.register)("folder-opened",60151),gear:(0,n.register)("gear",60152),gift:(0,n.register)("gift",60153),gistSecret:(0,n.register)("gist-secret",60154),gist:(0,n.register)("gist",60155),gitCommit:(0,n.register)("git-commit",60156),gitCompare:(0,n.register)("git-compare",60157),compareChanges:(0,n.register)("compare-changes",60157),gitMerge:(0,n.register)("git-merge",60158),githubAction:(0,n.register)("github-action",60159),githubAlt:(0,n.register)("github-alt",60160),globe:(0,n.register)("globe",60161),grabber:(0,n.register)("grabber",60162),graph:(0,n.register)("graph",60163),gripper:(0,n.register)("gripper",60164),heart:(0,n.register)("heart",60165),home:(0,n.register)("home",60166),horizontalRule:(0,n.register)("horizontal-rule",60167),hubot:(0,n.register)("hubot",60168),inbox:(0,n.register)("inbox",60169),issueReopened:(0,n.register)("issue-reopened",60171),issues:(0,n.register)("issues",60172),italic:(0,n.register)("italic",60173),jersey:(0,n.register)("jersey",60174),json:(0,n.register)("json",60175),kebabVertical:(0,n.register)("kebab-vertical",60176),key:(0,n.register)("key",60177),law:(0,n.register)("law",60178),lightbulbAutofix:(0,n.register)("lightbulb-autofix",60179),linkExternal:(0,n.register)("link-external",60180),link:(0,n.register)("link",60181),listOrdered:(0,n.register)("list-ordered",60182),listUnordered:(0,n.register)("list-unordered",60183),liveShare:(0,n.register)("live-share",60184),loading:(0,n.register)("loading",60185),location:(0,n.register)("location",60186),mailRead:(0,n.register)("mail-read",60187),mail:(0,n.register)("mail",60188),markdown:(0,n.register)("markdown",60189),megaphone:(0,n.register)("megaphone",60190),mention:(0,n.register)("mention",60191),milestone:(0,n.register)("milestone",60192),gitPullRequestMilestone:(0,n.register)("git-pull-request-milestone",60192),mortarBoard:(0,n.register)("mortar-board",60193),move:(0,n.register)("move",60194),multipleWindows:(0,n.register)("multiple-windows",60195),mute:(0,n.register)("mute",60196),noNewline:(0,n.register)("no-newline",60197),note:(0,n.register)("note",60198),octoface:(0,n.register)("octoface",60199),openPreview:(0,n.register)("open-preview",60200),package:(0,n.register)("package",60201),paintcan:(0,n.register)("paintcan",60202),pin:(0,n.register)("pin",60203),play:(0,n.register)("play",60204),run:(0,n.register)("run",60204),plug:(0,n.register)("plug",60205),preserveCase:(0,n.register)("preserve-case",60206),preview:(0,n.register)("preview",60207),project:(0,n.register)("project",60208),pulse:(0,n.register)("pulse",60209),question:(0,n.register)("question",60210),quote:(0,n.register)("quote",60211),radioTower:(0,n.register)("radio-tower",60212),reactions:(0,n.register)("reactions",60213),references:(0,n.register)("references",60214),refresh:(0,n.register)("refresh",60215),regex:(0,n.register)("regex",60216),remoteExplorer:(0,n.register)("remote-explorer",60217),remote:(0,n.register)("remote",60218),remove:(0,n.register)("remove",60219),replaceAll:(0,n.register)("replace-all",60220),replace:(0,n.register)("replace",60221),repoClone:(0,n.register)("repo-clone",60222),repoForcePush:(0,n.register)("repo-force-push",60223),repoPull:(0,n.register)("repo-pull",60224),repoPush:(0,n.register)("repo-push",60225),report:(0,n.register)("report",60226),requestChanges:(0,n.register)("request-changes",60227),rocket:(0,n.register)("rocket",60228),rootFolderOpened:(0,n.register)("root-folder-opened",60229),rootFolder:(0,n.register)("root-folder",60230),rss:(0,n.register)("rss",60231),ruby:(0,n.register)("ruby",60232),saveAll:(0,n.register)("save-all",60233),saveAs:(0,n.register)("save-as",60234),save:(0,n.register)("save",60235),screenFull:(0,n.register)("screen-full",60236),screenNormal:(0,n.register)("screen-normal",60237),searchStop:(0,n.register)("search-stop",60238),server:(0,n.register)("server",60240),settingsGear:(0,n.register)("settings-gear",60241),settings:(0,n.register)("settings",60242),shield:(0,n.register)("shield",60243),smiley:(0,n.register)("smiley",60244),sortPrecedence:(0,n.register)("sort-precedence",60245),splitHorizontal:(0,n.register)("split-horizontal",60246),splitVertical:(0,n.register)("split-vertical",60247),squirrel:(0,n.register)("squirrel",60248),starFull:(0,n.register)("star-full",60249),starHalf:(0,n.register)("star-half",60250),symbolClass:(0,n.register)("symbol-class",60251),symbolColor:(0,n.register)("symbol-color",60252),symbolConstant:(0,n.register)("symbol-constant",60253),symbolEnumMember:(0,n.register)("symbol-enum-member",60254),symbolField:(0,n.register)("symbol-field",60255),symbolFile:(0,n.register)("symbol-file",60256),symbolInterface:(0,n.register)("symbol-interface",60257),symbolKeyword:(0,n.register)("symbol-keyword",60258),symbolMisc:(0,n.register)("symbol-misc",60259),symbolOperator:(0,n.register)("symbol-operator",60260),symbolProperty:(0,n.register)("symbol-property",60261),wrench:(0,n.register)("wrench",60261),wrenchSubaction:(0,n.register)("wrench-subaction",60261),symbolSnippet:(0,n.register)("symbol-snippet",60262),tasklist:(0,n.register)("tasklist",60263),telescope:(0,n.register)("telescope",60264),textSize:(0,n.register)("text-size",60265),threeBars:(0,n.register)("three-bars",60266),thumbsdown:(0,n.register)("thumbsdown",60267),thumbsup:(0,n.register)("thumbsup",60268),tools:(0,n.register)("tools",60269),triangleDown:(0,n.register)("triangle-down",60270),triangleLeft:(0,n.register)("triangle-left",60271),triangleRight:(0,n.register)("triangle-right",60272),triangleUp:(0,n.register)("triangle-up",60273),twitter:(0,n.register)("twitter",60274),unfold:(0,n.register)("unfold",60275),unlock:(0,n.register)("unlock",60276),unmute:(0,n.register)("unmute",60277),unverified:(0,n.register)("unverified",60278),verified:(0,n.register)("verified",60279),versions:(0,n.register)("versions",60280),vmActive:(0,n.register)("vm-active",60281),vmOutline:(0,n.register)("vm-outline",60282),vmRunning:(0,n.register)("vm-running",60283),watch:(0,n.register)("watch",60284),whitespace:(0,n.register)("whitespace",60285),wholeWord:(0,n.register)("whole-word",60286),window:(0,n.register)("window",60287),wordWrap:(0,n.register)("word-wrap",60288),zoomIn:(0,n.register)("zoom-in",60289),zoomOut:(0,n.register)("zoom-out",60290),listFilter:(0,n.register)("list-filter",60291),listFlat:(0,n.register)("list-flat",60292),listSelection:(0,n.register)("list-selection",60293),selection:(0,n.register)("selection",60293),listTree:(0,n.register)("list-tree",60294),debugBreakpointFunctionUnverified:(0,n.register)("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:(0,n.register)("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:(0,n.register)("debug-breakpoint-function-disabled",60296),debugStackframeActive:(0,n.register)("debug-stackframe-active",60297),circleSmallFilled:(0,n.register)("circle-small-filled",60298),debugStackframeDot:(0,n.register)("debug-stackframe-dot",60298),terminalDecorationMark:(0,n.register)("terminal-decoration-mark",60298),debugStackframe:(0,n.register)("debug-stackframe",60299),debugStackframeFocused:(0,n.register)("debug-stackframe-focused",60299),debugBreakpointUnsupported:(0,n.register)("debug-breakpoint-unsupported",60300),symbolString:(0,n.register)("symbol-string",60301),debugReverseContinue:(0,n.register)("debug-reverse-continue",60302),debugStepBack:(0,n.register)("debug-step-back",60303),debugRestartFrame:(0,n.register)("debug-restart-frame",60304),debugAlt:(0,n.register)("debug-alt",60305),callIncoming:(0,n.register)("call-incoming",60306),callOutgoing:(0,n.register)("call-outgoing",60307),menu:(0,n.register)("menu",60308),expandAll:(0,n.register)("expand-all",60309),feedback:(0,n.register)("feedback",60310),gitPullRequestReviewer:(0,n.register)("git-pull-request-reviewer",60310),groupByRefType:(0,n.register)("group-by-ref-type",60311),ungroupByRefType:(0,n.register)("ungroup-by-ref-type",60312),account:(0,n.register)("account",60313),gitPullRequestAssignee:(0,n.register)("git-pull-request-assignee",60313),bellDot:(0,n.register)("bell-dot",60314),debugConsole:(0,n.register)("debug-console",60315),library:(0,n.register)("library",60316),output:(0,n.register)("output",60317),runAll:(0,n.register)("run-all",60318),syncIgnored:(0,n.register)("sync-ignored",60319),pinned:(0,n.register)("pinned",60320),githubInverted:(0,n.register)("github-inverted",60321),serverProcess:(0,n.register)("server-process",60322),serverEnvironment:(0,n.register)("server-environment",60323),pass:(0,n.register)("pass",60324),issueClosed:(0,n.register)("issue-closed",60324),stopCircle:(0,n.register)("stop-circle",60325),playCircle:(0,n.register)("play-circle",60326),record:(0,n.register)("record",60327),debugAltSmall:(0,n.register)("debug-alt-small",60328),vmConnect:(0,n.register)("vm-connect",60329),cloud:(0,n.register)("cloud",60330),merge:(0,n.register)("merge",60331),export:(0,n.register)("export",60332),graphLeft:(0,n.register)("graph-left",60333),magnet:(0,n.register)("magnet",60334),notebook:(0,n.register)("notebook",60335),redo:(0,n.register)("redo",60336),checkAll:(0,n.register)("check-all",60337),pinnedDirty:(0,n.register)("pinned-dirty",60338),passFilled:(0,n.register)("pass-filled",60339),circleLargeFilled:(0,n.register)("circle-large-filled",60340),circleLarge:(0,n.register)("circle-large",60341),circleLargeOutline:(0,n.register)("circle-large-outline",60341),combine:(0,n.register)("combine",60342),gather:(0,n.register)("gather",60342),table:(0,n.register)("table",60343),variableGroup:(0,n.register)("variable-group",60344),typeHierarchy:(0,n.register)("type-hierarchy",60345),typeHierarchySub:(0,n.register)("type-hierarchy-sub",60346),typeHierarchySuper:(0,n.register)("type-hierarchy-super",60347),gitPullRequestCreate:(0,n.register)("git-pull-request-create",60348),runAbove:(0,n.register)("run-above",60349),runBelow:(0,n.register)("run-below",60350),notebookTemplate:(0,n.register)("notebook-template",60351),debugRerun:(0,n.register)("debug-rerun",60352),workspaceTrusted:(0,n.register)("workspace-trusted",60353),workspaceUntrusted:(0,n.register)("workspace-untrusted",60354),workspaceUnknown:(0,n.register)("workspace-unknown",60355),terminalCmd:(0,n.register)("terminal-cmd",60356),terminalDebian:(0,n.register)("terminal-debian",60357),terminalLinux:(0,n.register)("terminal-linux",60358),terminalPowershell:(0,n.register)("terminal-powershell",60359),terminalTmux:(0,n.register)("terminal-tmux",60360),terminalUbuntu:(0,n.register)("terminal-ubuntu",60361),terminalBash:(0,n.register)("terminal-bash",60362),arrowSwap:(0,n.register)("arrow-swap",60363),copy:(0,n.register)("copy",60364),personAdd:(0,n.register)("person-add",60365),filterFilled:(0,n.register)("filter-filled",60366),wand:(0,n.register)("wand",60367),debugLineByLine:(0,n.register)("debug-line-by-line",60368),inspect:(0,n.register)("inspect",60369),layers:(0,n.register)("layers",60370),layersDot:(0,n.register)("layers-dot",60371),layersActive:(0,n.register)("layers-active",60372),compass:(0,n.register)("compass",60373),compassDot:(0,n.register)("compass-dot",60374),compassActive:(0,n.register)("compass-active",60375),azure:(0,n.register)("azure",60376),issueDraft:(0,n.register)("issue-draft",60377),gitPullRequestClosed:(0,n.register)("git-pull-request-closed",60378),gitPullRequestDraft:(0,n.register)("git-pull-request-draft",60379),debugAll:(0,n.register)("debug-all",60380),debugCoverage:(0,n.register)("debug-coverage",60381),runErrors:(0,n.register)("run-errors",60382),folderLibrary:(0,n.register)("folder-library",60383),debugContinueSmall:(0,n.register)("debug-continue-small",60384),beakerStop:(0,n.register)("beaker-stop",60385),graphLine:(0,n.register)("graph-line",60386),graphScatter:(0,n.register)("graph-scatter",60387),pieChart:(0,n.register)("pie-chart",60388),bracket:(0,n.register)("bracket",60175),bracketDot:(0,n.register)("bracket-dot",60389),bracketError:(0,n.register)("bracket-error",60390),lockSmall:(0,n.register)("lock-small",60391),azureDevops:(0,n.register)("azure-devops",60392),verifiedFilled:(0,n.register)("verified-filled",60393),newline:(0,n.register)("newline",60394),layout:(0,n.register)("layout",60395),layoutActivitybarLeft:(0,n.register)("layout-activitybar-left",60396),layoutActivitybarRight:(0,n.register)("layout-activitybar-right",60397),layoutPanelLeft:(0,n.register)("layout-panel-left",60398),layoutPanelCenter:(0,n.register)("layout-panel-center",60399),layoutPanelJustify:(0,n.register)("layout-panel-justify",60400),layoutPanelRight:(0,n.register)("layout-panel-right",60401),layoutPanel:(0,n.register)("layout-panel",60402),layoutSidebarLeft:(0,n.register)("layout-sidebar-left",60403),layoutSidebarRight:(0,n.register)("layout-sidebar-right",60404),layoutStatusbar:(0,n.register)("layout-statusbar",60405),layoutMenubar:(0,n.register)("layout-menubar",60406),layoutCentered:(0,n.register)("layout-centered",60407),target:(0,n.register)("target",60408),indent:(0,n.register)("indent",60409),recordSmall:(0,n.register)("record-small",60410),errorSmall:(0,n.register)("error-small",60411),terminalDecorationError:(0,n.register)("terminal-decoration-error",60411),arrowCircleDown:(0,n.register)("arrow-circle-down",60412),arrowCircleLeft:(0,n.register)("arrow-circle-left",60413),arrowCircleRight:(0,n.register)("arrow-circle-right",60414),arrowCircleUp:(0,n.register)("arrow-circle-up",60415),layoutSidebarRightOff:(0,n.register)("layout-sidebar-right-off",60416),layoutPanelOff:(0,n.register)("layout-panel-off",60417),layoutSidebarLeftOff:(0,n.register)("layout-sidebar-left-off",60418),blank:(0,n.register)("blank",60419),heartFilled:(0,n.register)("heart-filled",60420),map:(0,n.register)("map",60421),mapHorizontal:(0,n.register)("map-horizontal",60421),foldHorizontal:(0,n.register)("fold-horizontal",60421),mapFilled:(0,n.register)("map-filled",60422),mapHorizontalFilled:(0,n.register)("map-horizontal-filled",60422),foldHorizontalFilled:(0,n.register)("fold-horizontal-filled",60422),circleSmall:(0,n.register)("circle-small",60423),bellSlash:(0,n.register)("bell-slash",60424),bellSlashDot:(0,n.register)("bell-slash-dot",60425),commentUnresolved:(0,n.register)("comment-unresolved",60426),gitPullRequestGoToChanges:(0,n.register)("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:(0,n.register)("git-pull-request-new-changes",60428),searchFuzzy:(0,n.register)("search-fuzzy",60429),commentDraft:(0,n.register)("comment-draft",60430),send:(0,n.register)("send",60431),sparkle:(0,n.register)("sparkle",60432),insert:(0,n.register)("insert",60433),mic:(0,n.register)("mic",60434),thumbsdownFilled:(0,n.register)("thumbsdown-filled",60435),thumbsupFilled:(0,n.register)("thumbsup-filled",60436),coffee:(0,n.register)("coffee",60437),snake:(0,n.register)("snake",60438),game:(0,n.register)("game",60439),vr:(0,n.register)("vr",60440),chip:(0,n.register)("chip",60441),piano:(0,n.register)("piano",60442),music:(0,n.register)("music",60443),micFilled:(0,n.register)("mic-filled",60444),repoFetch:(0,n.register)("repo-fetch",60445),copilot:(0,n.register)("copilot",60446),lightbulbSparkle:(0,n.register)("lightbulb-sparkle",60447),robot:(0,n.register)("robot",60448),sparkleFilled:(0,n.register)("sparkle-filled",60449),diffSingle:(0,n.register)("diff-single",60450),diffMultiple:(0,n.register)("diff-multiple",60451),surroundWith:(0,n.register)("surround-with",60452),share:(0,n.register)("share",60453),gitStash:(0,n.register)("git-stash",60454),gitStashApply:(0,n.register)("git-stash-apply",60455),gitStashPop:(0,n.register)("git-stash-pop",60456),vscode:(0,n.register)("vscode",60457),vscodeInsiders:(0,n.register)("vscode-insiders",60458),codeOss:(0,n.register)("code-oss",60459),runCoverage:(0,n.register)("run-coverage",60460),runAllCoverage:(0,n.register)("run-all-coverage",60461),coverage:(0,n.register)("coverage",60462),githubProject:(0,n.register)("github-project",60463),mapVertical:(0,n.register)("map-vertical",60464),foldVertical:(0,n.register)("fold-vertical",60464),mapVerticalFilled:(0,n.register)("map-vertical-filled",60465),foldVerticalFilled:(0,n.register)("fold-vertical-filled",60465),goToSearch:(0,n.register)("go-to-search",60466),percentage:(0,n.register)("percentage",60467),sortPercentage:(0,n.register)("sort-percentage",60467),attach:(0,n.register)("attach",60468)}}),ie(re[50],ae([0,1,30,49]),function(C,t,n,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Codicon=t.codiconsDerived=void 0,t.getAllCodicons=M;function M(){return Object.values(t.Codicon)}t.codiconsDerived={dialogError:(0,n.register)("dialog-error","error"),dialogWarning:(0,n.register)("dialog-warning","warning"),dialogInfo:(0,n.register)("dialog-info","info"),dialogClose:(0,n.register)("dialog-close","close"),treeItemExpanded:(0,n.register)("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:(0,n.register)("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:(0,n.register)("tree-filter-on-type-off","list-selection"),treeFilterClear:(0,n.register)("tree-filter-clear","close"),treeItemLoading:(0,n.register)("tree-item-loading","loading"),menuSelection:(0,n.register)("menu-selection","check"),menuSubmenu:(0,n.register)("menu-submenu","chevron-right"),menuBarMore:(0,n.register)("menubar-more","more"),scrollbarButtonLeft:(0,n.register)("scrollbar-button-left","triangle-left"),scrollbarButtonRight:(0,n.register)("scrollbar-button-right","triangle-right"),scrollbarButtonUp:(0,n.register)("scrollbar-button-up","triangle-up"),scrollbarButtonDown:(0,n.register)("scrollbar-button-down","triangle-down"),toolBarMore:(0,n.register)("toolbar-more","more"),quickInputBack:(0,n.register)("quick-input-back","arrow-left"),dropDownButton:(0,n.register)("drop-down-button",60084),symbolCustomColor:(0,n.register)("symbol-customcolor",60252),exportIcon:(0,n.register)("export",60332),workspaceUnspecified:(0,n.register)("workspace-unspecified",60355),newLine:(0,n.register)("newline",60394),thumbsDownFilled:(0,n.register)("thumbsdown-filled",60435),thumbsUpFilled:(0,n.register)("thumbsup-filled",60436),gitFetch:(0,n.register)("git-fetch",60445),lightbulbSparkleAutofix:(0,n.register)("lightbulb-sparkle-autofix",60447),debugBreakpointPending:(0,n.register)("debug-breakpoint-pending",60377)},t.Codicon={...i.codiconsLibrary,...t.codiconsDerived}}),ie(re[31],ae([0,1,21]),function(C,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.deepClone=i,t.deepFreeze=M,t.cloneAndChange=R,t.mixin=o,t.equals=a,t.safeStringify=h,t.distinct=_,t.getCaseInsensitive=d,t.filter=c,t.getAllPropertyNames=e,t.getAllMethodNames=u,t.createProxyObject=g,t.mapValues=E;function i(w){if(!w||typeof w!="object"||w instanceof RegExp)return w;const v=Array.isArray(w)?[]:{};return Object.entries(w).forEach(([A,L])=>{v[A]=L&&typeof L=="object"?i(L):L}),v}function M(w){if(!w||typeof w!="object")return w;const v=[w];for(;v.length>0;){const A=v.shift();Object.freeze(A);for(const L in A)if(m.call(A,L)){const l=A[L];typeof l=="object"&&!Object.isFrozen(l)&&!(0,n.isTypedArray)(l)&&v.push(l)}}return w}const m=Object.prototype.hasOwnProperty;function R(w,v){return b(w,v,new Set)}function b(w,v,A){if((0,n.isUndefinedOrNull)(w))return w;const L=v(w);if(typeof L<"u")return L;if(Array.isArray(w)){const l=[];for(const s of w)l.push(b(s,v,A));return l}if((0,n.isObject)(w)){if(A.has(w))throw new Error("Cannot clone recursive data-structure");A.add(w);const l={};for(const s in w)m.call(w,s)&&(l[s]=b(w[s],v,A));return A.delete(w),l}return w}function o(w,v,A=!0){return(0,n.isObject)(w)?((0,n.isObject)(v)&&Object.keys(v).forEach(L=>{L in w?A&&((0,n.isObject)(w[L])&&(0,n.isObject)(v[L])?o(w[L],v[L],A):w[L]=v[L]):w[L]=v[L]}),w):v}function a(w,v){if(w===v)return!0;if(w==null||v===null||v===void 0||typeof w!=typeof v||typeof w!="object"||Array.isArray(w)!==Array.isArray(v))return!1;let A,L;if(Array.isArray(w)){if(w.length!==v.length)return!1;for(A=0;A<w.length;A++)if(!a(w[A],v[A]))return!1}else{const l=[];for(L in w)l.push(L);l.sort();const s=[];for(L in v)s.push(L);if(s.sort(),!a(l,s))return!1;for(A=0;A<l.length;A++)if(!a(w[l[A]],v[l[A]]))return!1}return!0}function h(w){const v=new Set;return JSON.stringify(w,(A,L)=>{if((0,n.isObject)(L)||Array.isArray(L)){if(v.has(L))return"[Circular]";v.add(L)}return typeof L=="bigint"?`[BigInt ${L.toString()}]`:L})}function _(w,v){const A=Object.create(null);return!w||!v||Object.keys(v).forEach(l=>{const s=w[l],f=v[l];a(s,f)||(A[l]=f)}),A}function d(w,v){const A=v.toLowerCase(),L=Object.keys(w).find(l=>l.toLowerCase()===A);return L?w[L]:w[v]}function c(w,v){const A=Object.create(null);for(const[L,l]of Object.entries(w))v(L,l)&&(A[L]=l);return A}function e(w){let v=[];for(;Object.prototype!==w;)v=v.concat(Object.getOwnPropertyNames(w)),w=Object.getPrototypeOf(w);return v}function u(w){const v=[];for(const A of e(w))typeof w[A]=="function"&&v.push(A);return v}function g(w,v){const A=l=>function(){const s=Array.prototype.slice.call(arguments,0);return v(l,s)},L={};for(const l of w)L[l]=A(l);return L}function E(w,v){const A={};for(const[L,l]of Object.entries(w))A[L]=v(l,L);return A}}),ie(re[16],ae([0,1]),function(C,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Constants=void 0,t.toUint8=i,t.toUint32=M;var n;(function(m){m[m.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",m[m.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",m[m.MAX_UINT_8=255]="MAX_UINT_8",m[m.MAX_UINT_16=65535]="MAX_UINT_16",m[m.MAX_UINT_32=4294967295]="MAX_UINT_32",m[m.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(n||(t.Constants=n={}));function i(m){return m<0?0:m>n.MAX_UINT_8?n.MAX_UINT_8:m|0}function M(m){return m<0?0:m>n.MAX_UINT_32?n.MAX_UINT_32:m|0}}),ie(re[6],ae([0,1,47,3,27,16]),function(C,t,n,i,M,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.InvisibleCharacters=t.AmbiguousCharacters=t.noBreakWhitespace=t.GraphemeBreakType=t.UTF8_BOM_CHARACTER=t.UNUSUAL_LINE_TERMINATORS=t.GraphemeIterator=t.CodePointIterator=void 0,t.isFalsyOrWhitespace=R,t.format=o,t.format2=h,t.htmlAttributeEncodeValue=_,t.escape=d,t.escapeRegExpCharacters=c,t.count=e,t.truncate=u,t.truncateMiddle=g,t.trim=E,t.ltrim=w,t.rtrim=v,t.convertSimple2RegExpPattern=A,t.stripWildcards=L,t.createRegExp=l,t.regExpLeadsToEndlessLoop=s,t.splitLines=f,t.splitLinesIncludeSeparators=p,t.firstNonWhitespaceIndex=I,t.getLeadingWhitespace=N,t.lastNonWhitespaceIndex=S,t.replaceAsync=D,t.compare=T,t.compareSubstring=y,t.compareIgnoreCase=k,t.compareSubstringIgnoreCase=P,t.isAsciiDigit=q,t.isLowerAsciiLetter=j,t.isUpperAsciiLetter=H,t.equalsIgnoreCase=W,t.startsWithIgnoreCase=J,t.commonPrefixLength=ee,t.commonSuffixLength=Z,t.isHighSurrogate=K,t.isLowSurrogate=ne,t.computeCodePoint=F,t.getNextCodePoint=$,t.nextCharLength=r,t.prevCharLength=Te,t.getCharContainingOffset=ke,t.charCount=We,t.containsRTL=Ue,t.isBasicASCII=G,t.containsUnusualLineTerminators=x,t.isFullWidthCharacter=O,t.isEmojiImprecise=U,t.lcut=X,t.forAnsiStringParts=le,t.removeAnsiEscapeCodes=Le,t.removeAnsiEscapeCodesFromPrompt=Ne,t.startsWithUTF8BOM=oe,t.stripUTF8BOM=se,t.fuzzyContains=ce,t.containsUppercaseCharacter=ue,t.uppercaseFirstLetter=me,t.getNLines=be,t.singleLetterHash=pe,t.getGraphemeBreakType=Me,t.getLeftDeleteOffset=je;function R(B){return!B||typeof B!="string"?!0:B.trim().length===0}const b=/{(\d+)}/g;function o(B,...V){return V.length===0?B:B.replace(b,function(Y,te){const fe=parseInt(te,10);return isNaN(fe)||fe<0||fe>=V.length?Y:V[fe]})}const a=/{([^}]+)}/g;function h(B,V){return Object.keys(V).length===0?B:B.replace(a,(Y,te)=>V[te]??Y)}function _(B){return B.replace(/[<>"'&]/g,V=>{switch(V){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return V})}function d(B){return B.replace(/[<>&]/g,function(V){switch(V){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return V}})}function c(B){return B.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function e(B,V){let Y=0,te=B.indexOf(V);for(;te!==-1;)Y++,te=B.indexOf(V,te+V.length);return Y}function u(B,V,Y="\u2026"){return B.length<=V?B:`${B.substr(0,V)}${Y}`}function g(B,V,Y="\u2026"){if(B.length<=V)return B;const te=Math.ceil(V/2)-Y.length/2,fe=Math.floor(V/2)-Y.length/2;return`${B.substr(0,te)}${Y}${B.substr(B.length-fe)}`}function E(B,V=" "){const Y=w(B,V);return v(Y,V)}function w(B,V){if(!B||!V)return B;const Y=V.length;if(Y===0||B.length===0)return B;let te=0;for(;B.indexOf(V,te)===te;)te=te+Y;return B.substring(te)}function v(B,V){if(!B||!V)return B;const Y=V.length,te=B.length;if(Y===0||te===0)return B;let fe=te,_e=-1;for(;_e=B.lastIndexOf(V,fe-1),!(_e===-1||_e+Y!==fe);){if(_e===0)return"";fe=_e}return B.substring(0,fe)}function A(B){return B.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function L(B){return B.replace(/\*/g,"")}function l(B,V,Y={}){if(!B)throw new Error("Cannot create regex from empty string");V||(B=c(B)),Y.wholeWord&&(/\B/.test(B.charAt(0))||(B="\\b"+B),/\B/.test(B.charAt(B.length-1))||(B=B+"\\b"));let te="";return Y.global&&(te+="g"),Y.matchCase||(te+="i"),Y.multiline&&(te+="m"),Y.unicode&&(te+="u"),new RegExp(B,te)}function s(B){return B.source==="^"||B.source==="^$"||B.source==="$"||B.source==="^\\s*$"?!1:!!(B.exec("")&&B.lastIndex===0)}function f(B){return B.split(/\r\n|\r|\n/)}function p(B){const V=[],Y=B.split(/(\r\n|\r|\n)/);for(let te=0;te<Math.ceil(Y.length/2);te++)V.push(Y[2*te]+(Y[2*te+1]??""));return V}function I(B){for(let V=0,Y=B.length;V<Y;V++){const te=B.charCodeAt(V);if(te!==i.CharCode.Space&&te!==i.CharCode.Tab)return V}return-1}function N(B,V=0,Y=B.length){for(let te=V;te<Y;te++){const fe=B.charCodeAt(te);if(fe!==i.CharCode.Space&&fe!==i.CharCode.Tab)return B.substring(V,te)}return B.substring(V,Y)}function S(B,V=B.length-1){for(let Y=V;Y>=0;Y--){const te=B.charCodeAt(Y);if(te!==i.CharCode.Space&&te!==i.CharCode.Tab)return Y}return-1}function D(B,V,Y){const te=[];let fe=0;for(const _e of B.matchAll(V)){if(te.push(B.slice(fe,_e.index)),_e.index===void 0)throw new Error("match.index should be defined");fe=_e.index+_e[0].length,te.push(Y(_e[0],..._e.slice(1),_e.index,B,_e.groups))}return te.push(B.slice(fe)),Promise.all(te).then(_e=>_e.join(""))}function T(B,V){return B<V?-1:B>V?1:0}function y(B,V,Y=0,te=B.length,fe=0,_e=V.length){for(;Y<te&&fe<_e;Y++,fe++){const Fe=B.charCodeAt(Y),Oe=V.charCodeAt(fe);if(Fe<Oe)return-1;if(Fe>Oe)return 1}const De=te-Y,xe=_e-fe;return De<xe?-1:De>xe?1:0}function k(B,V){return P(B,V,0,B.length,0,V.length)}function P(B,V,Y=0,te=B.length,fe=0,_e=V.length){for(;Y<te&&fe<_e;Y++,fe++){let Fe=B.charCodeAt(Y),Oe=V.charCodeAt(fe);if(Fe===Oe)continue;if(Fe>=128||Oe>=128)return y(B.toLowerCase(),V.toLowerCase(),Y,te,fe,_e);j(Fe)&&(Fe-=32),j(Oe)&&(Oe-=32);const Ie=Fe-Oe;if(Ie!==0)return Ie}const De=te-Y,xe=_e-fe;return De<xe?-1:De>xe?1:0}function q(B){return B>=i.CharCode.Digit0&&B<=i.CharCode.Digit9}function j(B){return B>=i.CharCode.a&&B<=i.CharCode.z}function H(B){return B>=i.CharCode.A&&B<=i.CharCode.Z}function W(B,V){return B.length===V.length&&P(B,V)===0}function J(B,V){const Y=V.length;return V.length>B.length?!1:P(B,V,0,Y)===0}function ee(B,V){const Y=Math.min(B.length,V.length);let te;for(te=0;te<Y;te++)if(B.charCodeAt(te)!==V.charCodeAt(te))return te;return Y}function Z(B,V){const Y=Math.min(B.length,V.length);let te;const fe=B.length-1,_e=V.length-1;for(te=0;te<Y;te++)if(B.charCodeAt(fe-te)!==V.charCodeAt(_e-te))return te;return Y}function K(B){return 55296<=B&&B<=56319}function ne(B){return 56320<=B&&B<=57343}function F(B,V){return(B-55296<<10)+(V-56320)+65536}function $(B,V,Y){const te=B.charCodeAt(Y);if(K(te)&&Y+1<V){const fe=B.charCodeAt(Y+1);if(ne(fe))return F(te,fe)}return te}function he(B,V){const Y=B.charCodeAt(V-1);if(ne(Y)&&V>1){const te=B.charCodeAt(V-2);if(K(te))return F(te,Y)}return Y}class ge{get offset(){return this._offset}constructor(V,Y=0){this._str=V,this._len=V.length,this._offset=Y}setOffset(V){this._offset=V}prevCodePoint(){const V=he(this._str,this._offset);return this._offset-=V>=m.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,V}nextCodePoint(){const V=$(this._str,this._len,this._offset);return this._offset+=V>=m.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,V}eol(){return this._offset>=this._len}}t.CodePointIterator=ge;class Ee{get offset(){return this._iterator.offset}constructor(V,Y=0){this._iterator=new ge(V,Y)}nextGraphemeLength(){const V=Pe.getInstance(),Y=this._iterator,te=Y.offset;let fe=V.getGraphemeBreakType(Y.nextCodePoint());for(;!Y.eol();){const _e=Y.offset,De=V.getGraphemeBreakType(Y.nextCodePoint());if(Se(fe,De)){Y.setOffset(_e);break}fe=De}return Y.offset-te}prevGraphemeLength(){const V=Pe.getInstance(),Y=this._iterator,te=Y.offset;let fe=V.getGraphemeBreakType(Y.prevCodePoint());for(;Y.offset>0;){const _e=Y.offset,De=V.getGraphemeBreakType(Y.prevCodePoint());if(Se(De,fe)){Y.setOffset(_e);break}fe=De}return te-Y.offset}eol(){return this._iterator.eol()}}t.GraphemeIterator=Ee;function r(B,V){return new Ee(B,V).nextGraphemeLength()}function Te(B,V){return new Ee(B,V).prevGraphemeLength()}function ke(B,V){V>0&&ne(B.charCodeAt(V))&&V--;const Y=V+r(B,V);return[Y-Te(B,Y),Y]}function We(B){const V=new Ee(B);let Y=0;for(;!V.eol();)Y++,V.nextGraphemeLength();return Y}let Re;function we(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function Ue(B){return Re||(Re=we()),Re.test(B)}const z=/^[\t\n\r\x20-\x7E]*$/;function G(B){return z.test(B)}t.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function x(B){return t.UNUSUAL_LINE_TERMINATORS.test(B)}function O(B){return B>=11904&&B<=55215||B>=63744&&B<=64255||B>=65281&&B<=65374}function U(B){return B>=127462&&B<=127487||B===8986||B===8987||B===9200||B===9203||B>=9728&&B<=10175||B===11088||B===11093||B>=127744&&B<=128591||B>=128640&&B<=128764||B>=128992&&B<=129008||B>=129280&&B<=129535||B>=129648&&B<=129782}function X(B,V,Y=""){const te=B.trimStart();if(te.length<V)return te;const fe=/\b/g;let _e=0;for(;fe.test(te)&&!(te.length-fe.lastIndex<V);)_e=fe.lastIndex,fe.lastIndex+=1;return _e===0?te:Y+te.substring(_e).trimStart()}const Q=/(?:(?:\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~])|(:?\x1b\].*?\x07)/g;function*le(B){let V=0;for(const Y of B.matchAll(Q))V!==Y.index&&(yield{isCode:!1,str:B.substring(V,Y.index)}),yield{isCode:!0,str:Y[0]},V=Y.index+Y[0].length;V!==B.length&&(yield{isCode:!1,str:B.substring(V)})}function Le(B){return B&&(B=B.replace(Q,"")),B}const ve=/\\\[.*?\\\]/g;function Ne(B){return Le(B).replace(ve,"")}t.UTF8_BOM_CHARACTER=String.fromCharCode(i.CharCode.UTF8_BOM);function oe(B){return!!(B&&B.length>0&&B.charCodeAt(0)===i.CharCode.UTF8_BOM)}function se(B){return oe(B)?B.substr(1):B}function ce(B,V){if(!B||!V||B.length<V.length)return!1;const Y=V.length,te=B.toLowerCase();let fe=0,_e=-1;for(;fe<Y;){const De=te.indexOf(V[fe],_e+1);if(De<0)return!1;_e=De,fe++}return!0}function ue(B,V=!1){return B?(V&&(B=B.replace(/\\./g,"")),B.toLowerCase()!==B):!1}function me(B){return B.charAt(0).toUpperCase()+B.slice(1)}function be(B,V=1){if(V===0)return"";let Y=-1;do Y=B.indexOf(`
`,Y+1),V--;while(V>0&&Y>=0);return Y===-1?B:(B[Y-1]==="\r"&&Y--,B.substr(0,Y))}function pe(B){const V=i.CharCode.Z-i.CharCode.A+1;return B=B%(2*V),B<V?String.fromCharCode(i.CharCode.a+B):String.fromCharCode(i.CharCode.A+B-V)}function Me(B){return Pe.getInstance().getGraphemeBreakType(B)}function Se(B,V){return B===de.Other?V!==de.Extend&&V!==de.SpacingMark:B===de.CR&&V===de.LF?!1:B===de.Control||B===de.CR||B===de.LF||V===de.Control||V===de.CR||V===de.LF?!0:!(B===de.L&&(V===de.L||V===de.V||V===de.LV||V===de.LVT)||(B===de.LV||B===de.V)&&(V===de.V||V===de.T)||(B===de.LVT||B===de.T)&&V===de.T||V===de.Extend||V===de.ZWJ||V===de.SpacingMark||B===de.Prepend||B===de.ZWJ&&V===de.Extended_Pictographic||B===de.Regional_Indicator&&V===de.Regional_Indicator)}var de;(function(B){B[B.Other=0]="Other",B[B.Prepend=1]="Prepend",B[B.CR=2]="CR",B[B.LF=3]="LF",B[B.Control=4]="Control",B[B.Extend=5]="Extend",B[B.Regional_Indicator=6]="Regional_Indicator",B[B.SpacingMark=7]="SpacingMark",B[B.L=8]="L",B[B.V=9]="V",B[B.T=10]="T",B[B.LV=11]="LV",B[B.LVT=12]="LVT",B[B.ZWJ=13]="ZWJ",B[B.Extended_Pictographic=14]="Extended_Pictographic"})(de||(t.GraphemeBreakType=de={}));class Pe{static{this._INSTANCE=null}static getInstance(){return Pe._INSTANCE||(Pe._INSTANCE=new Pe),Pe._INSTANCE}constructor(){this._data=Ce()}getGraphemeBreakType(V){if(V<32)return V===i.CharCode.LineFeed?de.LF:V===i.CharCode.CarriageReturn?de.CR:de.Control;if(V<127)return de.Other;const Y=this._data,te=Y.length/3;let fe=1;for(;fe<=te;)if(V<Y[3*fe])fe=2*fe;else if(V>Y[3*fe+1])fe=2*fe+1;else return Y[3*fe+2];return de.Other}}function Ce(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function je(B,V){if(B===0)return 0;const Y=He(B,V);if(Y!==void 0)return Y;const te=new ge(V,B);return te.prevCodePoint(),te.offset}function He(B,V){const Y=new ge(V,B);let te=Y.prevCodePoint();for(;Xe(te)||te===Ve.emojiVariantSelector||te===Ve.enclosingKeyCap;){if(Y.offset===0)return;te=Y.prevCodePoint()}if(!U(te))return;let fe=Y.offset;return fe>0&&Y.prevCodePoint()===Ve.zwj&&(fe=Y.offset),fe}function Xe(B){return 127995<=B&&B<=127999}var Ve;(function(B){B[B.zwj=8205]="zwj",B[B.emojiVariantSelector=65039]="emojiVariantSelector",B[B.enclosingKeyCap=8419]="enclosingKeyCap"})(Ve||(Ve={})),t.noBreakWhitespace="\xA0";class ze{static{this.ambiguousCharacterData=new M.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.cache=new n.LRUCachedFunction({getCacheKey:JSON.stringify},V=>{function Y(Ie){const qe=new Map;for(let Be=0;Be<Ie.length;Be+=2)qe.set(Ie[Be],Ie[Be+1]);return qe}function te(Ie,qe){const Be=new Map(Ie);for(const[$e,Ye]of qe)Be.set($e,Ye);return Be}function fe(Ie,qe){if(!Ie)return qe;const Be=new Map;for(const[$e,Ye]of Ie)qe.has($e)&&Be.set($e,Ye);return Be}const _e=this.ambiguousCharacterData.value;let De=V.filter(Ie=>!Ie.startsWith("_")&&Ie in _e);De.length===0&&(De=["_default"]);let xe;for(const Ie of De){const qe=Y(_e[Ie]);xe=fe(xe,qe)}const Fe=Y(_e._common),Oe=te(Fe,xe);return new ze(Oe)})}static getInstance(V){return ze.cache.get(Array.from(V))}static{this._locales=new M.Lazy(()=>Object.keys(ze.ambiguousCharacterData.value).filter(V=>!V.startsWith("_")))}static getLocales(){return ze._locales.value}constructor(V){this.confusableDictionary=V}isAmbiguous(V){return this.confusableDictionary.has(V)}containsAmbiguousCharacter(V){for(let Y=0;Y<V.length;Y++){const te=V.codePointAt(Y);if(typeof te=="number"&&this.isAmbiguous(te))return!0}return!1}getPrimaryConfusable(V){return this.confusableDictionary.get(V)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}t.AmbiguousCharacters=ze;class Ge{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this._data=void 0}static getData(){return this._data||(this._data=new Set(Ge.getRawData())),this._data}static isInvisibleCharacter(V){return Ge.getData().has(V)}static containsInvisibleCharacter(V){for(let Y=0;Y<V.length;Y++){const te=V.codePointAt(Y);if(typeof te=="number"&&Ge.isInvisibleCharacter(te))return!0}return!1}static get codePoints(){return Ge.getData()}}t.InvisibleCharacters=Ge});var Je=this&&this.__createBinding||(Object.create?function(C,t,n,i){i===void 0&&(i=n);var M=Object.getOwnPropertyDescriptor(t,n);(!M||("get"in M?!t.__esModule:M.writable||M.configurable))&&(M={enumerable:!0,get:function(){return t[n]}}),Object.defineProperty(C,i,M)}:function(C,t,n,i){i===void 0&&(i=n),C[i]=t[n]}),Ke=this&&this.__setModuleDefault||(Object.create?function(C,t){Object.defineProperty(C,"default",{enumerable:!0,value:t})}:function(C,t){C.default=t}),ye=this&&this.__importStar||function(C){if(C&&C.__esModule)return C;var t={};if(C!=null)for(var n in C)n!=="default"&&Object.prototype.hasOwnProperty.call(C,n)&&Je(t,C,n);return Ke(t,C),t};ie(re[51],ae([0,1,6]),function(C,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StringSHA1=t.Hasher=void 0,t.hash=i,t.doHash=M,t.numberHash=m,t.stringHash=b,t.toHexString=u,n=ye(n);function i(E){return M(E,0)}function M(E,w){switch(typeof E){case"object":return E===null?m(349,w):Array.isArray(E)?o(E,w):a(E,w);case"string":return b(E,w);case"boolean":return R(E,w);case"number":return m(E,w);case"undefined":return m(937,w);default:return m(617,w)}}function m(E,w){return(w<<5)-w+E|0}function R(E,w){return m(E?433:863,w)}function b(E,w){w=m(149417,w);for(let v=0,A=E.length;v<A;v++)w=m(E.charCodeAt(v),w);return w}function o(E,w){return w=m(104579,w),E.reduce((v,A)=>M(A,v),w)}function a(E,w){return w=m(181387,w),Object.keys(E).sort().reduce((v,A)=>(v=b(A,v),M(E[A],v)),w)}class h{constructor(){this._value=0}get value(){return this._value}hash(w){return this._value=M(w,this._value),this._value}}t.Hasher=h;var _;(function(E){E[E.BLOCK_SIZE=64]="BLOCK_SIZE",E[E.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(_||(_={}));function d(E,w,v=32){const A=v-w,L=~((1<<A)-1);return(E<<w|(L&E)>>>A)>>>0}function c(E,w=0,v=E.byteLength,A=0){for(let L=0;L<v;L++)E[w+L]=A}function e(E,w,v="0"){for(;E.length<w;)E=v+E;return E}function u(E,w=32){return E instanceof ArrayBuffer?Array.from(new Uint8Array(E)).map(v=>v.toString(16).padStart(2,"0")).join(""):e((E>>>0).toString(16),w/4)}class g{static{this._bigBlock32=new DataView(new ArrayBuffer(320))}constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(_.BLOCK_SIZE+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(w){const v=w.length;if(v===0)return;const A=this._buff;let L=this._buffLen,l=this._leftoverHighSurrogate,s,f;for(l!==0?(s=l,f=-1,l=0):(s=w.charCodeAt(0),f=0);;){let p=s;if(n.isHighSurrogate(s))if(f+1<v){const I=w.charCodeAt(f+1);n.isLowSurrogate(I)?(f++,p=n.computeCodePoint(s,I)):p=_.UNICODE_REPLACEMENT}else{l=s;break}else n.isLowSurrogate(s)&&(p=_.UNICODE_REPLACEMENT);if(L=this._push(A,L,p),f++,f<v)s=w.charCodeAt(f);else break}this._buffLen=L,this._leftoverHighSurrogate=l}_push(w,v,A){return A<128?w[v++]=A:A<2048?(w[v++]=192|(A&1984)>>>6,w[v++]=128|(A&63)>>>0):A<65536?(w[v++]=224|(A&61440)>>>12,w[v++]=128|(A&4032)>>>6,w[v++]=128|(A&63)>>>0):(w[v++]=240|(A&1835008)>>>18,w[v++]=128|(A&258048)>>>12,w[v++]=128|(A&4032)>>>6,w[v++]=128|(A&63)>>>0),v>=_.BLOCK_SIZE&&(this._step(),v-=_.BLOCK_SIZE,this._totalLen+=_.BLOCK_SIZE,w[0]=w[_.BLOCK_SIZE+0],w[1]=w[_.BLOCK_SIZE+1],w[2]=w[_.BLOCK_SIZE+2]),v}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,_.UNICODE_REPLACEMENT)),this._totalLen+=this._buffLen,this._wrapUp()),u(this._h0)+u(this._h1)+u(this._h2)+u(this._h3)+u(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,c(this._buff,this._buffLen),this._buffLen>56&&(this._step(),c(this._buff));const w=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(w/4294967296),!1),this._buffDV.setUint32(60,w%4294967296,!1),this._step()}_step(){const w=g._bigBlock32,v=this._buffDV;for(let S=0;S<64;S+=4)w.setUint32(S,v.getUint32(S,!1),!1);for(let S=64;S<320;S+=4)w.setUint32(S,d(w.getUint32(S-12,!1)^w.getUint32(S-32,!1)^w.getUint32(S-56,!1)^w.getUint32(S-64,!1),1),!1);let A=this._h0,L=this._h1,l=this._h2,s=this._h3,f=this._h4,p,I,N;for(let S=0;S<80;S++)S<20?(p=L&l|~L&s,I=1518500249):S<40?(p=L^l^s,I=1859775393):S<60?(p=L&l|L&s|l&s,I=2400959708):(p=L^l^s,I=3395469782),N=d(A,5)+p+f+I+w.getUint32(S*4,!1)&4294967295,f=s,s=l,l=d(L,30),L=A,A=N;this._h0=this._h0+A&4294967295,this._h1=this._h1+L&4294967295,this._h2=this._h2+l&4294967295,this._h3=this._h3+s&4294967295,this._h4=this._h4+f&4294967295}}t.StringSHA1=g}),ie(re[32],ae([0,1,44,51,16]),function(C,t,n,i,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LcsDiff=t.StringDiffSequence=void 0,t.stringDiff=R;class m{constructor(c){this.source=c}getElements(){const c=this.source,e=new Int32Array(c.length);for(let u=0,g=c.length;u<g;u++)e[u]=c.charCodeAt(u);return e}}t.StringDiffSequence=m;function R(d,c,e){return new _(new m(d),new m(c)).ComputeDiff(e).changes}class b{static Assert(c,e){if(!c)throw new Error(e)}}class o{static Copy(c,e,u,g,E){for(let w=0;w<E;w++)u[g+w]=c[e+w]}static Copy2(c,e,u,g,E){for(let w=0;w<E;w++)u[g+w]=c[e+w]}}var a;(function(d){d[d.MaxDifferencesHistory=1447]="MaxDifferencesHistory"})(a||(a={}));class h{constructor(){this.m_changes=[],this.m_originalStart=M.Constants.MAX_SAFE_SMALL_INTEGER,this.m_modifiedStart=M.Constants.MAX_SAFE_SMALL_INTEGER,this.m_originalCount=0,this.m_modifiedCount=0}MarkNextChange(){(this.m_originalCount>0||this.m_modifiedCount>0)&&this.m_changes.push(new n.DiffChange(this.m_originalStart,this.m_originalCount,this.m_modifiedStart,this.m_modifiedCount)),this.m_originalCount=0,this.m_modifiedCount=0,this.m_originalStart=M.Constants.MAX_SAFE_SMALL_INTEGER,this.m_modifiedStart=M.Constants.MAX_SAFE_SMALL_INTEGER}AddOriginalElement(c,e){this.m_originalStart=Math.min(this.m_originalStart,c),this.m_modifiedStart=Math.min(this.m_modifiedStart,e),this.m_originalCount++}AddModifiedElement(c,e){this.m_originalStart=Math.min(this.m_originalStart,c),this.m_modifiedStart=Math.min(this.m_modifiedStart,e),this.m_modifiedCount++}getChanges(){return(this.m_originalCount>0||this.m_modifiedCount>0)&&this.MarkNextChange(),this.m_changes}getReverseChanges(){return(this.m_originalCount>0||this.m_modifiedCount>0)&&this.MarkNextChange(),this.m_changes.reverse(),this.m_changes}}class _{constructor(c,e,u=null){this.ContinueProcessingPredicate=u,this._originalSequence=c,this._modifiedSequence=e;const[g,E,w]=_._getElements(c),[v,A,L]=_._getElements(e);this._hasStrings=w&&L,this._originalStringElements=g,this._originalElementsOrHash=E,this._modifiedStringElements=v,this._modifiedElementsOrHash=A,this.m_forwardHistory=[],this.m_reverseHistory=[]}static _isStringArray(c){return c.length>0&&typeof c[0]=="string"}static _getElements(c){const e=c.getElements();if(_._isStringArray(e)){const u=new Int32Array(e.length);for(let g=0,E=e.length;g<E;g++)u[g]=(0,i.stringHash)(e[g],0);return[e,u,!0]}return e instanceof Int32Array?[[],e,!1]:[[],new Int32Array(e),!1]}ElementsAreEqual(c,e){return this._originalElementsOrHash[c]!==this._modifiedElementsOrHash[e]?!1:this._hasStrings?this._originalStringElements[c]===this._modifiedStringElements[e]:!0}ElementsAreStrictEqual(c,e){if(!this.ElementsAreEqual(c,e))return!1;const u=_._getStrictElement(this._originalSequence,c),g=_._getStrictElement(this._modifiedSequence,e);return u===g}static _getStrictElement(c,e){return typeof c.getStrictElement=="function"?c.getStrictElement(e):null}OriginalElementsAreEqual(c,e){return this._originalElementsOrHash[c]!==this._originalElementsOrHash[e]?!1:this._hasStrings?this._originalStringElements[c]===this._originalStringElements[e]:!0}ModifiedElementsAreEqual(c,e){return this._modifiedElementsOrHash[c]!==this._modifiedElementsOrHash[e]?!1:this._hasStrings?this._modifiedStringElements[c]===this._modifiedStringElements[e]:!0}ComputeDiff(c){return this._ComputeDiff(0,this._originalElementsOrHash.length-1,0,this._modifiedElementsOrHash.length-1,c)}_ComputeDiff(c,e,u,g,E){const w=[!1];let v=this.ComputeDiffRecursive(c,e,u,g,w);return E&&(v=this.PrettifyChanges(v)),{quitEarly:w[0],changes:v}}ComputeDiffRecursive(c,e,u,g,E){for(E[0]=!1;c<=e&&u<=g&&this.ElementsAreEqual(c,u);)c++,u++;for(;e>=c&&g>=u&&this.ElementsAreEqual(e,g);)e--,g--;if(c>e||u>g){let s;return u<=g?(b.Assert(c===e+1,"originalStart should only be one more than originalEnd"),s=[new n.DiffChange(c,0,u,g-u+1)]):c<=e?(b.Assert(u===g+1,"modifiedStart should only be one more than modifiedEnd"),s=[new n.DiffChange(c,e-c+1,u,0)]):(b.Assert(c===e+1,"originalStart should only be one more than originalEnd"),b.Assert(u===g+1,"modifiedStart should only be one more than modifiedEnd"),s=[]),s}const w=[0],v=[0],A=this.ComputeRecursionPoint(c,e,u,g,w,v,E),L=w[0],l=v[0];if(A!==null)return A;if(!E[0]){const s=this.ComputeDiffRecursive(c,L,u,l,E);let f=[];return E[0]?f=[new n.DiffChange(L+1,e-(L+1)+1,l+1,g-(l+1)+1)]:f=this.ComputeDiffRecursive(L+1,e,l+1,g,E),this.ConcatenateChanges(s,f)}return[new n.DiffChange(c,e-c+1,u,g-u+1)]}WALKTRACE(c,e,u,g,E,w,v,A,L,l,s,f,p,I,N,S,D,T){let y=null,k=null,P=new h,q=e,j=u,H=p[0]-S[0]-g,W=M.Constants.MIN_SAFE_SMALL_INTEGER,J=this.m_forwardHistory.length-1;do{const ee=H+c;ee===q||ee<j&&L[ee-1]<L[ee+1]?(s=L[ee+1],I=s-H-g,s<W&&P.MarkNextChange(),W=s,P.AddModifiedElement(s+1,I),H=ee+1-c):(s=L[ee-1]+1,I=s-H-g,s<W&&P.MarkNextChange(),W=s-1,P.AddOriginalElement(s,I+1),H=ee-1-c),J>=0&&(L=this.m_forwardHistory[J],c=L[0],q=1,j=L.length-1)}while(--J>=-1);if(y=P.getReverseChanges(),T[0]){let ee=p[0]+1,Z=S[0]+1;if(y!==null&&y.length>0){const K=y[y.length-1];ee=Math.max(ee,K.getOriginalEnd()),Z=Math.max(Z,K.getModifiedEnd())}k=[new n.DiffChange(ee,f-ee+1,Z,N-Z+1)]}else{P=new h,q=w,j=v,H=p[0]-S[0]-A,W=M.Constants.MAX_SAFE_SMALL_INTEGER,J=D?this.m_reverseHistory.length-1:this.m_reverseHistory.length-2;do{const ee=H+E;ee===q||ee<j&&l[ee-1]>=l[ee+1]?(s=l[ee+1]-1,I=s-H-A,s>W&&P.MarkNextChange(),W=s+1,P.AddOriginalElement(s+1,I+1),H=ee+1-E):(s=l[ee-1],I=s-H-A,s>W&&P.MarkNextChange(),W=s,P.AddModifiedElement(s+1,I+1),H=ee-1-E),J>=0&&(l=this.m_reverseHistory[J],E=l[0],q=1,j=l.length-1)}while(--J>=-1);k=P.getChanges()}return this.ConcatenateChanges(y,k)}ComputeRecursionPoint(c,e,u,g,E,w,v){let A=0,L=0,l=0,s=0,f=0,p=0;c--,u--,E[0]=0,w[0]=0,this.m_forwardHistory=[],this.m_reverseHistory=[];const I=e-c+(g-u),N=I+1,S=new Int32Array(N),D=new Int32Array(N),T=g-u,y=e-c,k=c-u,P=e-g,j=(y-T)%2===0;S[T]=c,D[y]=e,v[0]=!1;for(let H=1;H<=I/2+1;H++){let W=0,J=0;l=this.ClipDiagonalBound(T-H,H,T,N),s=this.ClipDiagonalBound(T+H,H,T,N);for(let Z=l;Z<=s;Z+=2){Z===l||Z<s&&S[Z-1]<S[Z+1]?A=S[Z+1]:A=S[Z-1]+1,L=A-(Z-T)-k;const K=A;for(;A<e&&L<g&&this.ElementsAreEqual(A+1,L+1);)A++,L++;if(S[Z]=A,A+L>W+J&&(W=A,J=L),!j&&Math.abs(Z-y)<=H-1&&A>=D[Z])return E[0]=A,w[0]=L,K<=D[Z]&&a.MaxDifferencesHistory>0&&H<=a.MaxDifferencesHistory+1?this.WALKTRACE(T,l,s,k,y,f,p,P,S,D,A,e,E,L,g,w,j,v):null}const ee=(W-c+(J-u)-H)/2;if(this.ContinueProcessingPredicate!==null&&!this.ContinueProcessingPredicate(W,ee))return v[0]=!0,E[0]=W,w[0]=J,ee>0&&a.MaxDifferencesHistory>0&&H<=a.MaxDifferencesHistory+1?this.WALKTRACE(T,l,s,k,y,f,p,P,S,D,A,e,E,L,g,w,j,v):(c++,u++,[new n.DiffChange(c,e-c+1,u,g-u+1)]);f=this.ClipDiagonalBound(y-H,H,y,N),p=this.ClipDiagonalBound(y+H,H,y,N);for(let Z=f;Z<=p;Z+=2){Z===f||Z<p&&D[Z-1]>=D[Z+1]?A=D[Z+1]-1:A=D[Z-1],L=A-(Z-y)-P;const K=A;for(;A>c&&L>u&&this.ElementsAreEqual(A,L);)A--,L--;if(D[Z]=A,j&&Math.abs(Z-T)<=H&&A<=S[Z])return E[0]=A,w[0]=L,K>=S[Z]&&a.MaxDifferencesHistory>0&&H<=a.MaxDifferencesHistory+1?this.WALKTRACE(T,l,s,k,y,f,p,P,S,D,A,e,E,L,g,w,j,v):null}if(H<=a.MaxDifferencesHistory){let Z=new Int32Array(s-l+2);Z[0]=T-l+1,o.Copy2(S,l,Z,1,s-l+1),this.m_forwardHistory.push(Z),Z=new Int32Array(p-f+2),Z[0]=y-f+1,o.Copy2(D,f,Z,1,p-f+1),this.m_reverseHistory.push(Z)}}return this.WALKTRACE(T,l,s,k,y,f,p,P,S,D,A,e,E,L,g,w,j,v)}PrettifyChanges(c){for(let e=0;e<c.length;e++){const u=c[e],g=e<c.length-1?c[e+1].originalStart:this._originalElementsOrHash.length,E=e<c.length-1?c[e+1].modifiedStart:this._modifiedElementsOrHash.length,w=u.originalLength>0,v=u.modifiedLength>0;for(;u.originalStart+u.originalLength<g&&u.modifiedStart+u.modifiedLength<E&&(!w||this.OriginalElementsAreEqual(u.originalStart,u.originalStart+u.originalLength))&&(!v||this.ModifiedElementsAreEqual(u.modifiedStart,u.modifiedStart+u.modifiedLength));){const L=this.ElementsAreStrictEqual(u.originalStart,u.modifiedStart);if(this.ElementsAreStrictEqual(u.originalStart+u.originalLength,u.modifiedStart+u.modifiedLength)&&!L)break;u.originalStart++,u.modifiedStart++}const A=[null];if(e<c.length-1&&this.ChangesOverlap(c[e],c[e+1],A)){c[e]=A[0],c.splice(e+1,1),e--;continue}}for(let e=c.length-1;e>=0;e--){const u=c[e];let g=0,E=0;if(e>0){const s=c[e-1];g=s.originalStart+s.originalLength,E=s.modifiedStart+s.modifiedLength}const w=u.originalLength>0,v=u.modifiedLength>0;let A=0,L=this._boundaryScore(u.originalStart,u.originalLength,u.modifiedStart,u.modifiedLength);for(let s=1;;s++){const f=u.originalStart-s,p=u.modifiedStart-s;if(f<g||p<E||w&&!this.OriginalElementsAreEqual(f,f+u.originalLength)||v&&!this.ModifiedElementsAreEqual(p,p+u.modifiedLength))break;const N=(f===g&&p===E?5:0)+this._boundaryScore(f,u.originalLength,p,u.modifiedLength);N>L&&(L=N,A=s)}u.originalStart-=A,u.modifiedStart-=A;const l=[null];if(e>0&&this.ChangesOverlap(c[e-1],c[e],l)){c[e-1]=l[0],c.splice(e,1),e++;continue}}if(this._hasStrings)for(let e=1,u=c.length;e<u;e++){const g=c[e-1],E=c[e],w=E.originalStart-g.originalStart-g.originalLength,v=g.originalStart,A=E.originalStart+E.originalLength,L=A-v,l=g.modifiedStart,s=E.modifiedStart+E.modifiedLength,f=s-l;if(w<5&&L<20&&f<20){const p=this._findBetterContiguousSequence(v,L,l,f,w);if(p){const[I,N]=p;(I!==g.originalStart+g.originalLength||N!==g.modifiedStart+g.modifiedLength)&&(g.originalLength=I-g.originalStart,g.modifiedLength=N-g.modifiedStart,E.originalStart=I+w,E.modifiedStart=N+w,E.originalLength=A-E.originalStart,E.modifiedLength=s-E.modifiedStart)}}}return c}_findBetterContiguousSequence(c,e,u,g,E){if(e<E||g<E)return null;const w=c+e-E+1,v=u+g-E+1;let A=0,L=0,l=0;for(let s=c;s<w;s++)for(let f=u;f<v;f++){const p=this._contiguousSequenceScore(s,f,E);p>0&&p>A&&(A=p,L=s,l=f)}return A>0?[L,l]:null}_contiguousSequenceScore(c,e,u){let g=0;for(let E=0;E<u;E++){if(!this.ElementsAreEqual(c+E,e+E))return 0;g+=this._originalStringElements[c+E].length}return g}_OriginalIsBoundary(c){return c<=0||c>=this._originalElementsOrHash.length-1?!0:this._hasStrings&&/^\s*$/.test(this._originalStringElements[c])}_OriginalRegionIsBoundary(c,e){if(this._OriginalIsBoundary(c)||this._OriginalIsBoundary(c-1))return!0;if(e>0){const u=c+e;if(this._OriginalIsBoundary(u-1)||this._OriginalIsBoundary(u))return!0}return!1}_ModifiedIsBoundary(c){return c<=0||c>=this._modifiedElementsOrHash.length-1?!0:this._hasStrings&&/^\s*$/.test(this._modifiedStringElements[c])}_ModifiedRegionIsBoundary(c,e){if(this._ModifiedIsBoundary(c)||this._ModifiedIsBoundary(c-1))return!0;if(e>0){const u=c+e;if(this._ModifiedIsBoundary(u-1)||this._ModifiedIsBoundary(u))return!0}return!1}_boundaryScore(c,e,u,g){const E=this._OriginalRegionIsBoundary(c,e)?1:0,w=this._ModifiedRegionIsBoundary(u,g)?1:0;return E+w}ConcatenateChanges(c,e){const u=[];if(c.length===0||e.length===0)return e.length>0?e:c;if(this.ChangesOverlap(c[c.length-1],e[0],u)){const g=new Array(c.length+e.length-1);return o.Copy(c,0,g,0,c.length-1),g[c.length-1]=u[0],o.Copy(e,1,g,c.length,e.length-1),g}else{const g=new Array(c.length+e.length);return o.Copy(c,0,g,0,c.length),o.Copy(e,0,g,c.length,e.length),g}}ChangesOverlap(c,e,u){if(b.Assert(c.originalStart<=e.originalStart,"Left change is not less than or equal to right change"),b.Assert(c.modifiedStart<=e.modifiedStart,"Left change is not less than or equal to right change"),c.originalStart+c.originalLength>=e.originalStart||c.modifiedStart+c.modifiedLength>=e.modifiedStart){const g=c.originalStart;let E=c.originalLength;const w=c.modifiedStart;let v=c.modifiedLength;return c.originalStart+c.originalLength>=e.originalStart&&(E=e.originalStart+e.originalLength-c.originalStart),c.modifiedStart+c.modifiedLength>=e.modifiedStart&&(v=e.modifiedStart+e.modifiedLength-c.modifiedStart),u[0]=new n.DiffChange(g,E,w,v),!0}else return u[0]=null,!1}ClipDiagonalBound(c,e,u,g){if(c>=0&&c<g)return c;const E=u,w=g-u-1,v=e%2===0;if(c<0){const A=E%2===0;return v===A?0:1}else{const A=w%2===0;return v===A?g-1:g-2}}}t.LcsDiff=_}),ie(re[33],ae([0,1,16]),function(C,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CharacterSet=t.CharacterClassifier=void 0;class i{constructor(b){const o=(0,n.toUint8)(b);this._defaultValue=o,this._asciiMap=i._createAsciiMap(o),this._map=new Map}static _createAsciiMap(b){const o=new Uint8Array(256);return o.fill(b),o}set(b,o){const a=(0,n.toUint8)(o);b>=0&&b<256?this._asciiMap[b]=a:this._map.set(b,a)}get(b){return b>=0&&b<256?this._asciiMap[b]:this._map.get(b)||this._defaultValue}clear(){this._asciiMap.fill(this._defaultValue),this._map.clear()}}t.CharacterClassifier=i;var M;(function(R){R[R.False=0]="False",R[R.True=1]="True"})(M||(M={}));class m{constructor(){this._actual=new i(M.False)}add(b){this._actual.set(b,M.True)}has(b){return this._actual.get(b)===M.True}clear(){return this._actual.clear()}}t.CharacterSet=m}),ie(re[7],ae([0,1,4]),function(C,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.OffsetRangeSet=t.OffsetRange=void 0;class i{static addRange(R,b){let o=0;for(;o<b.length&&b[o].endExclusive<R.start;)o++;let a=o;for(;a<b.length&&b[a].start<=R.endExclusive;)a++;if(o===a)b.splice(o,0,R);else{const h=Math.min(R.start,b[o].start),_=Math.max(R.endExclusive,b[a-1].endExclusive);b.splice(o,a-o,new i(h,_))}}static tryCreate(R,b){if(!(R>b))return new i(R,b)}static ofLength(R){return new i(0,R)}static ofStartAndLength(R,b){return new i(R,R+b)}constructor(R,b){if(this.start=R,this.endExclusive=b,R>b)throw new n.BugIndicatingError(`Invalid range: ${this.toString()}`)}get isEmpty(){return this.start===this.endExclusive}delta(R){return new i(this.start+R,this.endExclusive+R)}deltaStart(R){return new i(this.start+R,this.endExclusive)}deltaEnd(R){return new i(this.start,this.endExclusive+R)}get length(){return this.endExclusive-this.start}toString(){return`[${this.start}, ${this.endExclusive})`}equals(R){return this.start===R.start&&this.endExclusive===R.endExclusive}containsRange(R){return this.start<=R.start&&R.endExclusive<=this.endExclusive}contains(R){return this.start<=R&&R<this.endExclusive}join(R){return new i(Math.min(this.start,R.start),Math.max(this.endExclusive,R.endExclusive))}intersect(R){const b=Math.max(this.start,R.start),o=Math.min(this.endExclusive,R.endExclusive);if(b<=o)return new i(b,o)}intersects(R){const b=Math.max(this.start,R.start),o=Math.min(this.endExclusive,R.endExclusive);return b<o}intersectsOrTouches(R){const b=Math.max(this.start,R.start),o=Math.min(this.endExclusive,R.endExclusive);return b<=o}isBefore(R){return this.endExclusive<=R.start}isAfter(R){return this.start>=R.endExclusive}slice(R){return R.slice(this.start,this.endExclusive)}substring(R){return R.substring(this.start,this.endExclusive)}clip(R){if(this.isEmpty)throw new n.BugIndicatingError(`Invalid clipping range: ${this.toString()}`);return Math.max(this.start,Math.min(this.endExclusive-1,R))}clipCyclic(R){if(this.isEmpty)throw new n.BugIndicatingError(`Invalid clipping range: ${this.toString()}`);return R<this.start?this.endExclusive-(this.start-R)%this.length:R>=this.endExclusive?this.start+(R-this.start)%this.length:R}map(R){const b=[];for(let o=this.start;o<this.endExclusive;o++)b.push(R(o));return b}forEach(R){for(let b=this.start;b<this.endExclusive;b++)R(b)}}t.OffsetRange=i;class M{constructor(){this._sortedRanges=[]}addRange(R){let b=0;for(;b<this._sortedRanges.length&&this._sortedRanges[b].endExclusive<R.start;)b++;let o=b;for(;o<this._sortedRanges.length&&this._sortedRanges[o].start<=R.endExclusive;)o++;if(b===o)this._sortedRanges.splice(b,0,R);else{const a=Math.min(R.start,this._sortedRanges[b].start),h=Math.max(R.endExclusive,this._sortedRanges[o-1].endExclusive);this._sortedRanges.splice(b,o-b,new i(a,h))}}toString(){return this._sortedRanges.map(R=>R.toString()).join(", ")}intersectsStrict(R){let b=0;for(;b<this._sortedRanges.length&&this._sortedRanges[b].endExclusive<=R.start;)b++;return b<this._sortedRanges.length&&this._sortedRanges[b].start<R.endExclusive}intersectWithRange(R){const b=new M;for(const o of this._sortedRanges){const a=o.intersect(R);a&&b.addRange(a)}return b}intersectWithRangeLength(R){return this.intersectWithRange(R).length}get length(){return this._sortedRanges.reduce((R,b)=>R+b.length,0)}}t.OffsetRangeSet=M}),ie(re[5],ae([0,1]),function(C,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Position=void 0;class n{constructor(M,m){this.lineNumber=M,this.column=m}with(M=this.lineNumber,m=this.column){return M===this.lineNumber&&m===this.column?this:new n(M,m)}delta(M=0,m=0){return this.with(this.lineNumber+M,this.column+m)}equals(M){return n.equals(this,M)}static equals(M,m){return!M&&!m?!0:!!M&&!!m&&M.lineNumber===m.lineNumber&&M.column===m.column}isBefore(M){return n.isBefore(this,M)}static isBefore(M,m){return M.lineNumber<m.lineNumber?!0:m.lineNumber<M.lineNumber?!1:M.column<m.column}isBeforeOrEqual(M){return n.isBeforeOrEqual(this,M)}static isBeforeOrEqual(M,m){return M.lineNumber<m.lineNumber?!0:m.lineNumber<M.lineNumber?!1:M.column<=m.column}static compare(M,m){const R=M.lineNumber|0,b=m.lineNumber|0;if(R===b){const o=M.column|0,a=m.column|0;return o-a}return R-b}clone(){return new n(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(M){return new n(M.lineNumber,M.column)}static isIPosition(M){return M&&typeof M.lineNumber=="number"&&typeof M.column=="number"}toJSON(){return{lineNumber:this.lineNumber,column:this.column}}}t.Position=n}),ie(re[2],ae([0,1,5]),function(C,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Range=void 0;class i{constructor(m,R,b,o){m>b||m===b&&R>o?(this.startLineNumber=b,this.startColumn=o,this.endLineNumber=m,this.endColumn=R):(this.startLineNumber=m,this.startColumn=R,this.endLineNumber=b,this.endColumn=o)}isEmpty(){return i.isEmpty(this)}static isEmpty(m){return m.startLineNumber===m.endLineNumber&&m.startColumn===m.endColumn}containsPosition(m){return i.containsPosition(this,m)}static containsPosition(m,R){return!(R.lineNumber<m.startLineNumber||R.lineNumber>m.endLineNumber||R.lineNumber===m.startLineNumber&&R.column<m.startColumn||R.lineNumber===m.endLineNumber&&R.column>m.endColumn)}static strictContainsPosition(m,R){return!(R.lineNumber<m.startLineNumber||R.lineNumber>m.endLineNumber||R.lineNumber===m.startLineNumber&&R.column<=m.startColumn||R.lineNumber===m.endLineNumber&&R.column>=m.endColumn)}containsRange(m){return i.containsRange(this,m)}static containsRange(m,R){return!(R.startLineNumber<m.startLineNumber||R.endLineNumber<m.startLineNumber||R.startLineNumber>m.endLineNumber||R.endLineNumber>m.endLineNumber||R.startLineNumber===m.startLineNumber&&R.startColumn<m.startColumn||R.endLineNumber===m.endLineNumber&&R.endColumn>m.endColumn)}strictContainsRange(m){return i.strictContainsRange(this,m)}static strictContainsRange(m,R){return!(R.startLineNumber<m.startLineNumber||R.endLineNumber<m.startLineNumber||R.startLineNumber>m.endLineNumber||R.endLineNumber>m.endLineNumber||R.startLineNumber===m.startLineNumber&&R.startColumn<=m.startColumn||R.endLineNumber===m.endLineNumber&&R.endColumn>=m.endColumn)}plusRange(m){return i.plusRange(this,m)}static plusRange(m,R){let b,o,a,h;return R.startLineNumber<m.startLineNumber?(b=R.startLineNumber,o=R.startColumn):R.startLineNumber===m.startLineNumber?(b=R.startLineNumber,o=Math.min(R.startColumn,m.startColumn)):(b=m.startLineNumber,o=m.startColumn),R.endLineNumber>m.endLineNumber?(a=R.endLineNumber,h=R.endColumn):R.endLineNumber===m.endLineNumber?(a=R.endLineNumber,h=Math.max(R.endColumn,m.endColumn)):(a=m.endLineNumber,h=m.endColumn),new i(b,o,a,h)}intersectRanges(m){return i.intersectRanges(this,m)}static intersectRanges(m,R){let b=m.startLineNumber,o=m.startColumn,a=m.endLineNumber,h=m.endColumn;const _=R.startLineNumber,d=R.startColumn,c=R.endLineNumber,e=R.endColumn;return b<_?(b=_,o=d):b===_&&(o=Math.max(o,d)),a>c?(a=c,h=e):a===c&&(h=Math.min(h,e)),b>a||b===a&&o>h?null:new i(b,o,a,h)}equalsRange(m){return i.equalsRange(this,m)}static equalsRange(m,R){return!m&&!R?!0:!!m&&!!R&&m.startLineNumber===R.startLineNumber&&m.startColumn===R.startColumn&&m.endLineNumber===R.endLineNumber&&m.endColumn===R.endColumn}getEndPosition(){return i.getEndPosition(this)}static getEndPosition(m){return new n.Position(m.endLineNumber,m.endColumn)}getStartPosition(){return i.getStartPosition(this)}static getStartPosition(m){return new n.Position(m.startLineNumber,m.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(m,R){return new i(this.startLineNumber,this.startColumn,m,R)}setStartPosition(m,R){return new i(m,R,this.endLineNumber,this.endColumn)}collapseToStart(){return i.collapseToStart(this)}static collapseToStart(m){return new i(m.startLineNumber,m.startColumn,m.startLineNumber,m.startColumn)}collapseToEnd(){return i.collapseToEnd(this)}static collapseToEnd(m){return new i(m.endLineNumber,m.endColumn,m.endLineNumber,m.endColumn)}delta(m){return new i(this.startLineNumber+m,this.startColumn,this.endLineNumber+m,this.endColumn)}static fromPositions(m,R=m){return new i(m.lineNumber,m.column,R.lineNumber,R.column)}static lift(m){return m?new i(m.startLineNumber,m.startColumn,m.endLineNumber,m.endColumn):null}static isIRange(m){return m&&typeof m.startLineNumber=="number"&&typeof m.startColumn=="number"&&typeof m.endLineNumber=="number"&&typeof m.endColumn=="number"}static areIntersectingOrTouching(m,R){return!(m.endLineNumber<R.startLineNumber||m.endLineNumber===R.startLineNumber&&m.endColumn<R.startColumn||R.endLineNumber<m.startLineNumber||R.endLineNumber===m.startLineNumber&&R.endColumn<m.startColumn)}static areIntersecting(m,R){return!(m.endLineNumber<R.startLineNumber||m.endLineNumber===R.startLineNumber&&m.endColumn<=R.startColumn||R.endLineNumber<m.startLineNumber||R.endLineNumber===m.startLineNumber&&R.endColumn<=m.startColumn)}static compareRangesUsingStarts(m,R){if(m&&R){const a=m.startLineNumber|0,h=R.startLineNumber|0;if(a===h){const _=m.startColumn|0,d=R.startColumn|0;if(_===d){const c=m.endLineNumber|0,e=R.endLineNumber|0;if(c===e){const u=m.endColumn|0,g=R.endColumn|0;return u-g}return c-e}return _-d}return a-h}return(m?1:0)-(R?1:0)}static compareRangesUsingEnds(m,R){return m.endLineNumber===R.endLineNumber?m.endColumn===R.endColumn?m.startLineNumber===R.startLineNumber?m.startColumn-R.startColumn:m.startLineNumber-R.startLineNumber:m.endColumn-R.endColumn:m.endLineNumber-R.endLineNumber}static spansMultipleLines(m){return m.endLineNumber>m.startLineNumber}toJSON(){return this}}t.Range=i}),ie(re[52],ae([0,1,2]),function(C,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.EditOperation=void 0;class i{static insert(m,R){return{range:new n.Range(m.lineNumber,m.column,m.lineNumber,m.column),text:R,forceMoveMarkers:!0}}static delete(m){return{range:m,text:null}}static replace(m,R){return{range:m,text:R}}static replaceMove(m,R){return{range:m,text:R,forceMoveMarkers:!0}}}t.EditOperation=i}),ie(re[17],ae([0,1,4,7,2,11]),function(C,t,n,i,M,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LineRangeSet=t.LineRange=void 0;class R{static fromRange(a){return new R(a.startLineNumber,a.endLineNumber)}static fromRangeInclusive(a){return new R(a.startLineNumber,a.endLineNumber+1)}static subtract(a,h){return h?a.startLineNumber<h.startLineNumber&&h.endLineNumberExclusive<a.endLineNumberExclusive?[new R(a.startLineNumber,h.startLineNumber),new R(h.endLineNumberExclusive,a.endLineNumberExclusive)]:h.startLineNumber<=a.startLineNumber&&a.endLineNumberExclusive<=h.endLineNumberExclusive?[]:h.endLineNumberExclusive<a.endLineNumberExclusive?[new R(Math.max(h.endLineNumberExclusive,a.startLineNumber),a.endLineNumberExclusive)]:[new R(a.startLineNumber,Math.min(h.startLineNumber,a.endLineNumberExclusive))]:[a]}static joinMany(a){if(a.length===0)return[];let h=new b(a[0].slice());for(let _=1;_<a.length;_++)h=h.getUnion(new b(a[_].slice()));return h.ranges}static join(a){if(a.length===0)throw new n.BugIndicatingError("lineRanges cannot be empty");let h=a[0].startLineNumber,_=a[0].endLineNumberExclusive;for(let d=1;d<a.length;d++)h=Math.min(h,a[d].startLineNumber),_=Math.max(_,a[d].endLineNumberExclusive);return new R(h,_)}static ofLength(a,h){return new R(a,a+h)}static deserialize(a){return new R(a[0],a[1])}constructor(a,h){if(a>h)throw new n.BugIndicatingError(`startLineNumber ${a} cannot be after endLineNumberExclusive ${h}`);this.startLineNumber=a,this.endLineNumberExclusive=h}contains(a){return this.startLineNumber<=a&&a<this.endLineNumberExclusive}get isEmpty(){return this.startLineNumber===this.endLineNumberExclusive}delta(a){return new R(this.startLineNumber+a,this.endLineNumberExclusive+a)}deltaLength(a){return new R(this.startLineNumber,this.endLineNumberExclusive+a)}get length(){return this.endLineNumberExclusive-this.startLineNumber}join(a){return new R(Math.min(this.startLineNumber,a.startLineNumber),Math.max(this.endLineNumberExclusive,a.endLineNumberExclusive))}toString(){return`[${this.startLineNumber},${this.endLineNumberExclusive})`}intersect(a){const h=Math.max(this.startLineNumber,a.startLineNumber),_=Math.min(this.endLineNumberExclusive,a.endLineNumberExclusive);if(h<=_)return new R(h,_)}intersectsStrict(a){return this.startLineNumber<a.endLineNumberExclusive&&a.startLineNumber<this.endLineNumberExclusive}overlapOrTouch(a){return this.startLineNumber<=a.endLineNumberExclusive&&a.startLineNumber<=this.endLineNumberExclusive}equals(a){return this.startLineNumber===a.startLineNumber&&this.endLineNumberExclusive===a.endLineNumberExclusive}toInclusiveRange(){return this.isEmpty?null:new M.Range(this.startLineNumber,1,this.endLineNumberExclusive-1,Number.MAX_SAFE_INTEGER)}toExclusiveRange(){return new M.Range(this.startLineNumber,1,this.endLineNumberExclusive,1)}mapToLineArray(a){const h=[];for(let _=this.startLineNumber;_<this.endLineNumberExclusive;_++)h.push(a(_));return h}forEach(a){for(let h=this.startLineNumber;h<this.endLineNumberExclusive;h++)a(h)}serialize(){return[this.startLineNumber,this.endLineNumberExclusive]}includes(a){return this.startLineNumber<=a&&a<this.endLineNumberExclusive}toOffsetRange(){return new i.OffsetRange(this.startLineNumber-1,this.endLineNumberExclusive-1)}}t.LineRange=R;class b{constructor(a=[]){this._normalizedRanges=a}get ranges(){return this._normalizedRanges}addRange(a){if(a.length===0)return;const h=(0,m.findFirstIdxMonotonousOrArrLen)(this._normalizedRanges,d=>d.endLineNumberExclusive>=a.startLineNumber),_=(0,m.findLastIdxMonotonous)(this._normalizedRanges,d=>d.startLineNumber<=a.endLineNumberExclusive)+1;if(h===_)this._normalizedRanges.splice(h,0,a);else if(h===_-1){const d=this._normalizedRanges[h];this._normalizedRanges[h]=d.join(a)}else{const d=this._normalizedRanges[h].join(this._normalizedRanges[_-1]).join(a);this._normalizedRanges.splice(h,_-h,d)}}contains(a){const h=(0,m.findLastMonotonous)(this._normalizedRanges,_=>_.startLineNumber<=a);return!!h&&h.endLineNumberExclusive>a}intersects(a){const h=(0,m.findLastMonotonous)(this._normalizedRanges,_=>_.startLineNumber<a.endLineNumberExclusive);return!!h&&h.endLineNumberExclusive>a.startLineNumber}getUnion(a){if(this._normalizedRanges.length===0)return a;if(a._normalizedRanges.length===0)return this;const h=[];let _=0,d=0,c=null;for(;_<this._normalizedRanges.length||d<a._normalizedRanges.length;){let e=null;if(_<this._normalizedRanges.length&&d<a._normalizedRanges.length){const u=this._normalizedRanges[_],g=a._normalizedRanges[d];u.startLineNumber<g.startLineNumber?(e=u,_++):(e=g,d++)}else _<this._normalizedRanges.length?(e=this._normalizedRanges[_],_++):(e=a._normalizedRanges[d],d++);c===null?c=e:c.endLineNumberExclusive>=e.startLineNumber?c=new R(c.startLineNumber,Math.max(c.endLineNumberExclusive,e.endLineNumberExclusive)):(h.push(c),c=e)}return c!==null&&h.push(c),new b(h)}subtractFrom(a){const h=(0,m.findFirstIdxMonotonousOrArrLen)(this._normalizedRanges,e=>e.endLineNumberExclusive>=a.startLineNumber),_=(0,m.findLastIdxMonotonous)(this._normalizedRanges,e=>e.startLineNumber<=a.endLineNumberExclusive)+1;if(h===_)return new b([a]);const d=[];let c=a.startLineNumber;for(let e=h;e<_;e++){const u=this._normalizedRanges[e];u.startLineNumber>c&&d.push(new R(c,u.startLineNumber)),c=u.endLineNumberExclusive}return c<a.endLineNumberExclusive&&d.push(new R(c,a.endLineNumberExclusive)),new b(d)}toString(){return this._normalizedRanges.map(a=>a.toString()).join(", ")}getIntersection(a){const h=[];let _=0,d=0;for(;_<this._normalizedRanges.length&&d<a._normalizedRanges.length;){const c=this._normalizedRanges[_],e=a._normalizedRanges[d],u=c.intersect(e);u&&!u.isEmpty&&h.push(u),c.endLineNumberExclusive<e.endLineNumberExclusive?_++:d++}return new b(h)}getWithDelta(a){return new b(this._normalizedRanges.map(h=>h.delta(a)))}}t.LineRangeSet=b}),ie(re[53],ae([0,1,5,2]),function(C,t,n,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Selection=t.SelectionDirection=void 0;var M;(function(R){R[R.LTR=0]="LTR",R[R.RTL=1]="RTL"})(M||(t.SelectionDirection=M={}));class m extends i.Range{constructor(b,o,a,h){super(b,o,a,h),this.selectionStartLineNumber=b,this.selectionStartColumn=o,this.positionLineNumber=a,this.positionColumn=h}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(b){return m.selectionsEqual(this,b)}static selectionsEqual(b,o){return b.selectionStartLineNumber===o.selectionStartLineNumber&&b.selectionStartColumn===o.selectionStartColumn&&b.positionLineNumber===o.positionLineNumber&&b.positionColumn===o.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?M.LTR:M.RTL}setEndPosition(b,o){return this.getDirection()===M.LTR?new m(this.startLineNumber,this.startColumn,b,o):new m(b,o,this.startLineNumber,this.startColumn)}getPosition(){return new n.Position(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new n.Position(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(b,o){return this.getDirection()===M.LTR?new m(b,o,this.endLineNumber,this.endColumn):new m(this.endLineNumber,this.endColumn,b,o)}static fromPositions(b,o=b){return new m(b.lineNumber,b.column,o.lineNumber,o.column)}static fromRange(b,o){return o===M.LTR?new m(b.startLineNumber,b.startColumn,b.endLineNumber,b.endColumn):new m(b.endLineNumber,b.endColumn,b.startLineNumber,b.startColumn)}static liftSelection(b){return new m(b.selectionStartLineNumber,b.selectionStartColumn,b.positionLineNumber,b.positionColumn)}static selectionsArrEqual(b,o){if(b&&!o||!b&&o)return!1;if(!b&&!o)return!0;if(b.length!==o.length)return!1;for(let a=0,h=b.length;a<h;a++)if(!this.selectionsEqual(b[a],o[a]))return!1;return!0}static isISelection(b){return b&&typeof b.selectionStartLineNumber=="number"&&typeof b.selectionStartColumn=="number"&&typeof b.positionLineNumber=="number"&&typeof b.positionColumn=="number"}static createWithDirection(b,o,a,h,_){return _===M.LTR?new m(b,o,a,h):new m(a,h,b,o)}}t.Selection=m}),ie(re[34],ae([0,1,5,2]),function(C,t,n,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.TextLength=void 0;class M{static{this.zero=new M(0,0)}static lengthDiffNonNegative(R,b){return b.isLessThan(R)?M.zero:R.lineCount===b.lineCount?new M(0,b.columnCount-R.columnCount):new M(b.lineCount-R.lineCount,b.columnCount)}static betweenPositions(R,b){return R.lineNumber===b.lineNumber?new M(0,b.column-R.column):new M(b.lineNumber-R.lineNumber,b.column-1)}static ofRange(R){return M.betweenPositions(R.getStartPosition(),R.getEndPosition())}static ofText(R){let b=0,o=0;for(const a of R)a===`
`?(b++,o=0):o++;return new M(b,o)}constructor(R,b){this.lineCount=R,this.columnCount=b}isZero(){return this.lineCount===0&&this.columnCount===0}isLessThan(R){return this.lineCount!==R.lineCount?this.lineCount<R.lineCount:this.columnCount<R.columnCount}isGreaterThan(R){return this.lineCount!==R.lineCount?this.lineCount>R.lineCount:this.columnCount>R.columnCount}isGreaterThanOrEqualTo(R){return this.lineCount!==R.lineCount?this.lineCount>R.lineCount:this.columnCount>=R.columnCount}equals(R){return this.lineCount===R.lineCount&&this.columnCount===R.columnCount}compare(R){return this.lineCount!==R.lineCount?this.lineCount-R.lineCount:this.columnCount-R.columnCount}add(R){return R.lineCount===0?new M(this.lineCount,this.columnCount+R.columnCount):new M(this.lineCount+R.lineCount,R.columnCount)}createRange(R){return this.lineCount===0?new i.Range(R.lineNumber,R.column,R.lineNumber,R.column+this.columnCount):new i.Range(R.lineNumber,R.column,R.lineNumber+this.lineCount,this.columnCount+1)}toRange(){return new i.Range(1,1,this.lineCount+1,this.columnCount+1)}addToPosition(R){return this.lineCount===0?new n.Position(R.lineNumber,R.column+this.columnCount):new n.Position(R.lineNumber+this.lineCount,this.columnCount+1)}toString(){return`${this.lineCount},${this.columnCount}`}}t.TextLength=M}),ie(re[54],ae([0,1,11,7,5,2,34]),function(C,t,n,i,M,m,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.PositionOffsetTransformer=void 0;class b{constructor(a){this.text=a,this.lineStartOffsetByLineIdx=[],this.lineStartOffsetByLineIdx.push(0);for(let h=0;h<a.length;h++)a.charAt(h)===`
`&&this.lineStartOffsetByLineIdx.push(h+1)}getOffset(a){return this.lineStartOffsetByLineIdx[a.lineNumber-1]+a.column-1}getOffsetRange(a){return new i.OffsetRange(this.getOffset(a.getStartPosition()),this.getOffset(a.getEndPosition()))}getPosition(a){const h=(0,n.findLastIdxMonotonous)(this.lineStartOffsetByLineIdx,c=>c<=a),_=h+1,d=a-this.lineStartOffsetByLineIdx[h]+1;return new M.Position(_,d)}getRange(a){return m.Range.fromPositions(this.getPosition(a.start),this.getPosition(a.endExclusive))}getTextLength(a){return R.TextLength.ofRange(this.getRange(a))}get textLength(){const a=this.lineStartOffsetByLineIdx.length-1;return new R.TextLength(a,this.text.length-this.lineStartOffsetByLineIdx[a])}}t.PositionOffsetTransformer=b}),ie(re[55],ae([0,1,15,4,5,54,2,34]),function(C,t,n,i,M,m,R,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StringText=t.ArrayText=t.LineBasedText=t.AbstractText=t.SingleTextEdit=t.TextEdit=void 0;class o{static single(g,E){return new o([new a(g,E)])}constructor(g){this.edits=g,(0,n.assertFn)(()=>(0,n.checkAdjacentItems)(g,(E,w)=>E.range.getEndPosition().isBeforeOrEqual(w.range.getStartPosition())))}normalize(){const g=[];for(const E of this.edits)if(g.length>0&&g[g.length-1].range.getEndPosition().equals(E.range.getStartPosition())){const w=g[g.length-1];g[g.length-1]=new a(w.range.plusRange(E.range),w.text+E.text)}else E.isEmpty||g.push(E);return new o(g)}mapPosition(g){let E=0,w=0,v=0;for(const A of this.edits){const L=A.range.getStartPosition(),l=A.range.getEndPosition();if(g.isBeforeOrEqual(L))break;const s=b.TextLength.ofText(A.text);if(g.isBefore(l)){const f=new M.Position(L.lineNumber+E,L.column+(L.lineNumber+E===w?v:0)),p=s.addToPosition(f);return h(f,p)}E+=s.lineCount-(A.range.endLineNumber-A.range.startLineNumber),s.lineCount===0?l.lineNumber!==L.lineNumber?v+=s.columnCount-(l.column-1):v+=s.columnCount-(l.column-L.column):v=s.columnCount,w=l.lineNumber+E}return new M.Position(g.lineNumber+E,g.column+(g.lineNumber+E===w?v:0))}mapRange(g){function E(L){return L instanceof M.Position?L:L.getStartPosition()}function w(L){return L instanceof M.Position?L:L.getEndPosition()}const v=E(this.mapPosition(g.getStartPosition())),A=w(this.mapPosition(g.getEndPosition()));return h(v,A)}inverseMapPosition(g,E){return this.inverse(E).mapPosition(g)}inverseMapRange(g,E){return this.inverse(E).mapRange(g)}apply(g){let E="",w=new M.Position(1,1);for(const A of this.edits){const L=A.range,l=L.getStartPosition(),s=L.getEndPosition(),f=h(w,l);f.isEmpty()||(E+=g.getValueOfRange(f)),E+=A.text,w=s}const v=h(w,g.endPositionExclusive);return v.isEmpty()||(E+=g.getValueOfRange(v)),E}applyToString(g){const E=new e(g);return this.apply(E)}inverse(g){const E=this.getNewRanges();return new o(this.edits.map((w,v)=>new a(E[v],g.getValueOfRange(w.range))))}getNewRanges(){const g=[];let E=0,w=0,v=0;for(const A of this.edits){const L=b.TextLength.ofText(A.text),l=M.Position.lift({lineNumber:A.range.startLineNumber+w,column:A.range.startColumn+(A.range.startLineNumber===E?v:0)}),s=L.createRange(l);g.push(s),w=s.endLineNumber-A.range.endLineNumber,v=s.endColumn-A.range.endColumn,E=A.range.endLineNumber}return g}}t.TextEdit=o;class a{constructor(g,E){this.range=g,this.text=E}get isEmpty(){return this.range.isEmpty()&&this.text.length===0}static equals(g,E){return g.range.equalsRange(E.range)&&g.text===E.text}toSingleEditOperation(){return{range:this.range,text:this.text}}}t.SingleTextEdit=a;function h(u,g){if(u.lineNumber===g.lineNumber&&u.column===Number.MAX_SAFE_INTEGER)return R.Range.fromPositions(g,g);if(!u.isBeforeOrEqual(g))throw new i.BugIndicatingError("start must be before end");return new R.Range(u.lineNumber,u.column,g.lineNumber,g.column)}class _{get endPositionExclusive(){return this.length.addToPosition(new M.Position(1,1))}getValue(){return this.getValueOfRange(this.length.toRange())}}t.AbstractText=_;class d extends _{constructor(g,E){(0,n.assert)(E>=1),super(),this._getLineContent=g,this._lineCount=E}getValueOfRange(g){if(g.startLineNumber===g.endLineNumber)return this._getLineContent(g.startLineNumber).substring(g.startColumn-1,g.endColumn-1);let E=this._getLineContent(g.startLineNumber).substring(g.startColumn-1);for(let w=g.startLineNumber+1;w<g.endLineNumber;w++)E+=`
`+this._getLineContent(w);return E+=`
`+this._getLineContent(g.endLineNumber).substring(0,g.endColumn-1),E}get length(){const g=this._getLineContent(this._lineCount);return new b.TextLength(this._lineCount-1,g.length)}}t.LineBasedText=d;class c extends d{constructor(g){super(E=>g[E-1],g.length)}}t.ArrayText=c;class e extends _{constructor(g){super(),this.value=g,this._t=new m.PositionOffsetTransformer(this.value)}getValueOfRange(g){return this._t.getOffsetRange(g).substring(this.value)}get length(){return this._t.textLength}}t.StringText=e}),ie(re[56],ae([0,1,3,19,33]),function(C,t,n,i,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.WordCharacterClassifier=t.WordCharacterClass=void 0,t.getMapForWordSeparators=o;var m;(function(a){a[a.Regular=0]="Regular",a[a.Whitespace=1]="Whitespace",a[a.WordSeparator=2]="WordSeparator"})(m||(t.WordCharacterClass=m={}));class R extends M.CharacterClassifier{constructor(h,_){super(m.Regular),this._segmenter=null,this._cachedLine=null,this._cachedSegments=[],this.intlSegmenterLocales=_,this.intlSegmenterLocales.length>0?this._segmenter=new Intl.Segmenter(this.intlSegmenterLocales,{granularity:"word"}):this._segmenter=null;for(let d=0,c=h.length;d<c;d++)this.set(h.charCodeAt(d),m.WordSeparator);this.set(n.CharCode.Space,m.Whitespace),this.set(n.CharCode.Tab,m.Whitespace)}findPrevIntlWordBeforeOrAtOffset(h,_){let d=null;for(const c of this._getIntlSegmenterWordsOnLine(h)){if(c.index>_)break;d=c}return d}findNextIntlWordAtOrAfterOffset(h,_){for(const d of this._getIntlSegmenterWordsOnLine(h))if(!(d.index<_))return d;return null}_getIntlSegmenterWordsOnLine(h){return this._segmenter?this._cachedLine===h?this._cachedSegments:(this._cachedLine=h,this._cachedSegments=this._filterWordSegments(this._segmenter.segment(h)),this._cachedSegments):[]}_filterWordSegments(h){const _=[];for(const d of h)this._isWordLike(d)&&_.push(d);return _}_isWordLike(h){return!!h.isWordLike}}t.WordCharacterClassifier=R;const b=new i.LRUCache(10);function o(a,h){const _=`${a}/${h.join(",")}`;let d=b.get(_);return d||(d=new R(a,h),b.set(_,d)),d}}),ie(re[35],ae([0,1,26,10,28]),function(C,t,n,i,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DEFAULT_WORD_REGEXP=t.USUAL_WORD_SEPARATORS=void 0,t.ensureValidWordDefinition=R,t.setDefaultGetWordAtTextConfig=o,t.getWordAtText=a,t.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function m(_=""){let d="(-?\\d*\\.\\d\\w*)|([^";for(const c of t.USUAL_WORD_SEPARATORS)_.indexOf(c)>=0||(d+="\\"+c);return d+="\\s]+)",new RegExp(d,"g")}t.DEFAULT_WORD_REGEXP=m();function R(_){let d=t.DEFAULT_WORD_REGEXP;if(_&&_ instanceof RegExp)if(_.global)d=_;else{let c="g";_.ignoreCase&&(c+="i"),_.multiline&&(c+="m"),_.unicode&&(c+="u"),d=new RegExp(_.source,c)}return d.lastIndex=0,d}const b=new M.LinkedList;b.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function o(_){const d=b.unshift(_);return(0,i.toDisposable)(d)}function a(_,d,c,e,u){if(d=R(d),u||(u=n.Iterable.first(b)),c.length>u.maxLen){let A=_-u.maxLen/2;return A<0?A=0:e+=A,c=c.substring(A,_+u.maxLen/2),a(_,d,c,e,u)}const g=Date.now(),E=_-1-e;let w=-1,v=null;for(let A=1;!(Date.now()-g>=u.timeBudget);A++){const L=E-u.windowSize*A;d.lastIndex=Math.max(0,L);const l=h(d,c,E,w);if(!l&&v||(v=l,L<=0))break;w=L}if(v){const A={word:v[0],startColumn:e+1+v.index,endColumn:e+1+v.index+v[0].length};return d.lastIndex=0,A}return null}function h(_,d,c,e){let u;for(;u=_.exec(d);){const g=u.index||0;if(g<=c&&_.lastIndex>=c)return u;if(e>0&&g>e)return null}return null}}),ie(re[13],ae([0,1,9,4,7]),function(C,t,n,i,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DateTimeout=t.InfiniteTimeout=t.OffsetPair=t.SequenceDiff=t.DiffAlgorithmResult=void 0;class m{static trivial(_,d){return new m([new R(M.OffsetRange.ofLength(_.length),M.OffsetRange.ofLength(d.length))],!1)}static trivialTimedOut(_,d){return new m([new R(M.OffsetRange.ofLength(_.length),M.OffsetRange.ofLength(d.length))],!0)}constructor(_,d){this.diffs=_,this.hitTimeout=d}}t.DiffAlgorithmResult=m;class R{static invert(_,d){const c=[];return(0,n.forEachAdjacent)(_,(e,u)=>{c.push(R.fromOffsetPairs(e?e.getEndExclusives():b.zero,u?u.getStarts():new b(d,(e?e.seq2Range.endExclusive-e.seq1Range.endExclusive:0)+d)))}),c}static fromOffsetPairs(_,d){return new R(new M.OffsetRange(_.offset1,d.offset1),new M.OffsetRange(_.offset2,d.offset2))}static assertSorted(_){let d;for(const c of _){if(d&&!(d.seq1Range.endExclusive<=c.seq1Range.start&&d.seq2Range.endExclusive<=c.seq2Range.start))throw new i.BugIndicatingError("Sequence diffs must be sorted");d=c}}constructor(_,d){this.seq1Range=_,this.seq2Range=d}swap(){return new R(this.seq2Range,this.seq1Range)}toString(){return`${this.seq1Range} <-> ${this.seq2Range}`}join(_){return new R(this.seq1Range.join(_.seq1Range),this.seq2Range.join(_.seq2Range))}delta(_){return _===0?this:new R(this.seq1Range.delta(_),this.seq2Range.delta(_))}deltaStart(_){return _===0?this:new R(this.seq1Range.deltaStart(_),this.seq2Range.deltaStart(_))}deltaEnd(_){return _===0?this:new R(this.seq1Range.deltaEnd(_),this.seq2Range.deltaEnd(_))}intersectsOrTouches(_){return this.seq1Range.intersectsOrTouches(_.seq1Range)||this.seq2Range.intersectsOrTouches(_.seq2Range)}intersect(_){const d=this.seq1Range.intersect(_.seq1Range),c=this.seq2Range.intersect(_.seq2Range);if(!(!d||!c))return new R(d,c)}getStarts(){return new b(this.seq1Range.start,this.seq2Range.start)}getEndExclusives(){return new b(this.seq1Range.endExclusive,this.seq2Range.endExclusive)}}t.SequenceDiff=R;class b{static{this.zero=new b(0,0)}static{this.max=new b(Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER)}constructor(_,d){this.offset1=_,this.offset2=d}toString(){return`${this.offset1} <-> ${this.offset2}`}delta(_){return _===0?this:new b(this.offset1+_,this.offset2+_)}equals(_){return this.offset1===_.offset1&&this.offset2===_.offset2}}t.OffsetPair=b;class o{static{this.instance=new o}isValid(){return!0}}t.InfiniteTimeout=o;class a{constructor(_){if(this.timeout=_,this.startTime=Date.now(),this.valid=!0,_<=0)throw new i.BugIndicatingError("timeout must be positive")}isValid(){if(!(Date.now()-this.startTime<this.timeout)&&this.valid){this.valid=!1;debugger}return this.valid}disable(){this.timeout=Number.MAX_SAFE_INTEGER,this.isValid=()=>!0,this.valid=!0}}t.DateTimeout=a}),ie(re[36],ae([0,1,7,13]),function(C,t,n,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.MyersDiffAlgorithm=void 0;class M{compute(a,h,_=i.InfiniteTimeout.instance){if(a.length===0||h.length===0)return i.DiffAlgorithmResult.trivial(a,h);const d=a,c=h;function e(s,f){for(;s<d.length&&f<c.length&&d.getElement(s)===c.getElement(f);)s++,f++;return s}let u=0;const g=new R;g.set(0,e(0,0));const E=new b;E.set(0,g.get(0)===0?null:new m(null,0,0,g.get(0)));let w=0;e:for(;;){if(u++,!_.isValid())return i.DiffAlgorithmResult.trivialTimedOut(d,c);const s=-Math.min(u,c.length+u%2),f=Math.min(u,d.length+u%2);for(w=s;w<=f;w+=2){let p=0;const I=w===f?-1:g.get(w+1),N=w===s?-1:g.get(w-1)+1;p++;const S=Math.min(Math.max(I,N),d.length),D=S-w;if(p++,S>d.length||D>c.length)continue;const T=e(S,D);g.set(w,T);const y=S===I?E.get(w+1):E.get(w-1);if(E.set(w,T!==S?new m(y,S,D,T-S):y),g.get(w)===d.length&&g.get(w)-w===c.length)break e}}let v=E.get(w);const A=[];let L=d.length,l=c.length;for(;;){const s=v?v.x+v.length:0,f=v?v.y+v.length:0;if((s!==L||f!==l)&&A.push(new i.SequenceDiff(new n.OffsetRange(s,L),new n.OffsetRange(f,l))),!v)break;L=v.x,l=v.y,v=v.prev}return A.reverse(),new i.DiffAlgorithmResult(A,!1)}}t.MyersDiffAlgorithm=M;class m{constructor(a,h,_,d){this.prev=a,this.x=h,this.y=_,this.length=d}}class R{constructor(){this.positiveArr=new Int32Array(10),this.negativeArr=new Int32Array(10)}get(a){return a<0?(a=-a-1,this.negativeArr[a]):this.positiveArr[a]}set(a,h){if(a<0){if(a=-a-1,a>=this.negativeArr.length){const _=this.negativeArr;this.negativeArr=new Int32Array(_.length*2),this.negativeArr.set(_)}this.negativeArr[a]=h}else{if(a>=this.positiveArr.length){const _=this.positiveArr;this.positiveArr=new Int32Array(_.length*2),this.positiveArr.set(_)}this.positiveArr[a]=h}}}class b{constructor(){this.positiveArr=[],this.negativeArr=[]}get(a){return a<0?(a=-a-1,this.negativeArr[a]):this.positiveArr[a]}set(a,h){a<0?(a=-a-1,this.negativeArr[a]=h):this.positiveArr[a]=h}}}),ie(re[57],ae([0,1,9,7,13]),function(C,t,n,i,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.optimizeSequenceDiffs=m,t.removeShortMatches=a,t.extendDiffsToEntireWordIfAppropriate=h,t.removeVeryShortMatchingLinesBetweenDiffs=d,t.removeVeryShortMatchingTextBetweenLongDiffs=c;function m(e,u,g){let E=g;return E=R(e,u,E),E=R(e,u,E),E=b(e,u,E),E}function R(e,u,g){if(g.length===0)return g;const E=[];E.push(g[0]);for(let v=1;v<g.length;v++){const A=E[E.length-1];let L=g[v];if(L.seq1Range.isEmpty||L.seq2Range.isEmpty){const l=L.seq1Range.start-A.seq1Range.endExclusive;let s;for(s=1;s<=l&&!(e.getElement(L.seq1Range.start-s)!==e.getElement(L.seq1Range.endExclusive-s)||u.getElement(L.seq2Range.start-s)!==u.getElement(L.seq2Range.endExclusive-s));s++);if(s--,s===l){E[E.length-1]=new M.SequenceDiff(new i.OffsetRange(A.seq1Range.start,L.seq1Range.endExclusive-l),new i.OffsetRange(A.seq2Range.start,L.seq2Range.endExclusive-l));continue}L=L.delta(-s)}E.push(L)}const w=[];for(let v=0;v<E.length-1;v++){const A=E[v+1];let L=E[v];if(L.seq1Range.isEmpty||L.seq2Range.isEmpty){const l=A.seq1Range.start-L.seq1Range.endExclusive;let s;for(s=0;s<l&&!(!e.isStronglyEqual(L.seq1Range.start+s,L.seq1Range.endExclusive+s)||!u.isStronglyEqual(L.seq2Range.start+s,L.seq2Range.endExclusive+s));s++);if(s===l){E[v+1]=new M.SequenceDiff(new i.OffsetRange(L.seq1Range.start+l,A.seq1Range.endExclusive),new i.OffsetRange(L.seq2Range.start+l,A.seq2Range.endExclusive));continue}s>0&&(L=L.delta(s))}w.push(L)}return E.length>0&&w.push(E[E.length-1]),w}function b(e,u,g){if(!e.getBoundaryScore||!u.getBoundaryScore)return g;for(let E=0;E<g.length;E++){const w=E>0?g[E-1]:void 0,v=g[E],A=E+1<g.length?g[E+1]:void 0,L=new i.OffsetRange(w?w.seq1Range.endExclusive+1:0,A?A.seq1Range.start-1:e.length),l=new i.OffsetRange(w?w.seq2Range.endExclusive+1:0,A?A.seq2Range.start-1:u.length);v.seq1Range.isEmpty?g[E]=o(v,e,u,L,l):v.seq2Range.isEmpty&&(g[E]=o(v.swap(),u,e,l,L).swap())}return g}function o(e,u,g,E,w){let A=1;for(;e.seq1Range.start-A>=E.start&&e.seq2Range.start-A>=w.start&&g.isStronglyEqual(e.seq2Range.start-A,e.seq2Range.endExclusive-A)&&A<100;)A++;A--;let L=0;for(;e.seq1Range.start+L<E.endExclusive&&e.seq2Range.endExclusive+L<w.endExclusive&&g.isStronglyEqual(e.seq2Range.start+L,e.seq2Range.endExclusive+L)&&L<100;)L++;if(A===0&&L===0)return e;let l=0,s=-1;for(let f=-A;f<=L;f++){const p=e.seq2Range.start+f,I=e.seq2Range.endExclusive+f,N=e.seq1Range.start+f,S=u.getBoundaryScore(N)+g.getBoundaryScore(p)+g.getBoundaryScore(I);S>s&&(s=S,l=f)}return e.delta(l)}function a(e,u,g){const E=[];for(const w of g){const v=E[E.length-1];if(!v){E.push(w);continue}w.seq1Range.start-v.seq1Range.endExclusive<=2||w.seq2Range.start-v.seq2Range.endExclusive<=2?E[E.length-1]=new M.SequenceDiff(v.seq1Range.join(w.seq1Range),v.seq2Range.join(w.seq2Range)):E.push(w)}return E}function h(e,u,g){const E=M.SequenceDiff.invert(g,e.length),w=[];let v=new M.OffsetPair(0,0);function A(l,s){if(l.offset1<v.offset1||l.offset2<v.offset2)return;const f=e.findWordContaining(l.offset1),p=u.findWordContaining(l.offset2);if(!f||!p)return;let I=new M.SequenceDiff(f,p);const N=I.intersect(s);let S=N.seq1Range.length,D=N.seq2Range.length;for(;E.length>0;){const T=E[0];if(!(T.seq1Range.intersects(I.seq1Range)||T.seq2Range.intersects(I.seq2Range)))break;const k=e.findWordContaining(T.seq1Range.start),P=u.findWordContaining(T.seq2Range.start),q=new M.SequenceDiff(k,P),j=q.intersect(T);if(S+=j.seq1Range.length,D+=j.seq2Range.length,I=I.join(q),I.seq1Range.endExclusive>=T.seq1Range.endExclusive)E.shift();else break}S+D<(I.seq1Range.length+I.seq2Range.length)*2/3&&w.push(I),v=I.getEndExclusives()}for(;E.length>0;){const l=E.shift();l.seq1Range.isEmpty||(A(l.getStarts(),l),A(l.getEndExclusives().delta(-1),l))}return _(g,w)}function _(e,u){const g=[];for(;e.length>0||u.length>0;){const E=e[0],w=u[0];let v;E&&(!w||E.seq1Range.start<w.seq1Range.start)?v=e.shift():v=u.shift(),g.length>0&&g[g.length-1].seq1Range.endExclusive>=v.seq1Range.start?g[g.length-1]=g[g.length-1].join(v):g.push(v)}return g}function d(e,u,g){let E=g;if(E.length===0)return E;let w=0,v;do{v=!1;const A=[E[0]];for(let L=1;L<E.length;L++){let f=function(I,N){const S=new i.OffsetRange(s.seq1Range.endExclusive,l.seq1Range.start);return e.getText(S).replace(/\s/g,"").length<=4&&(I.seq1Range.length+I.seq2Range.length>5||N.seq1Range.length+N.seq2Range.length>5)};const l=E[L],s=A[A.length-1];f(s,l)?(v=!0,A[A.length-1]=A[A.length-1].join(l)):A.push(l)}E=A}while(w++<10&&v);return E}function c(e,u,g){let E=g;if(E.length===0)return E;let w=0,v;do{v=!1;const L=[E[0]];for(let l=1;l<E.length;l++){let p=function(N,S){const D=new i.OffsetRange(f.seq1Range.endExclusive,s.seq1Range.start);if(e.countLinesIn(D)>5||D.length>500)return!1;const y=e.getText(D).trim();if(y.length>20||y.split(/\r\n|\r|\n/).length>1)return!1;const k=e.countLinesIn(N.seq1Range),P=N.seq1Range.length,q=u.countLinesIn(N.seq2Range),j=N.seq2Range.length,H=e.countLinesIn(S.seq1Range),W=S.seq1Range.length,J=u.countLinesIn(S.seq2Range),ee=S.seq2Range.length,Z=2*40+50;function K(ne){return Math.min(ne,Z)}return Math.pow(Math.pow(K(k*40+P),1.5)+Math.pow(K(q*40+j),1.5),1.5)+Math.pow(Math.pow(K(H*40+W),1.5)+Math.pow(K(J*40+ee),1.5),1.5)>(Z**1.5)**1.5*1.3};const s=E[l],f=L[L.length-1];p(f,s)?(v=!0,L[L.length-1]=L[L.length-1].join(s)):L.push(s)}E=L}while(w++<10&&v);const A=[];return(0,n.forEachWithNeighbors)(E,(L,l,s)=>{let f=l;function p(y){return y.length>0&&y.trim().length<=3&&l.seq1Range.length+l.seq2Range.length>100}const I=e.extendToFullLines(l.seq1Range),N=e.getText(new i.OffsetRange(I.start,l.seq1Range.start));p(N)&&(f=f.deltaStart(-N.length));const S=e.getText(new i.OffsetRange(l.seq1Range.endExclusive,I.endExclusive));p(S)&&(f=f.deltaEnd(S.length));const D=M.SequenceDiff.fromOffsetPairs(L?L.getEndExclusives():M.OffsetPair.zero,s?s.getStarts():M.OffsetPair.max),T=f.intersect(D);A.length>0&&T.getStarts().equals(A[A.length-1].getEndExclusives())?A[A.length-1]=A[A.length-1].join(T):A.push(T)}),A}}),ie(re[58],ae([0,1,3]),function(C,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LineSequence=void 0;class i{constructor(R,b){this.trimmedHash=R,this.lines=b}getElement(R){return this.trimmedHash[R]}get length(){return this.trimmedHash.length}getBoundaryScore(R){const b=R===0?0:M(this.lines[R-1]),o=R===this.lines.length?0:M(this.lines[R]);return 1e3-(b+o)}getText(R){return this.lines.slice(R.start,R.endExclusive).join(`
`)}isStronglyEqual(R,b){return this.lines[R]===this.lines[b]}}t.LineSequence=i;function M(m){let R=0;for(;R<m.length&&(m.charCodeAt(R)===n.CharCode.Space||m.charCodeAt(R)===n.CharCode.Tab);)R++;return R}}),ie(re[22],ae([0,1,3]),function(C,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LineRangeFragment=t.Array2D=void 0,t.isSpace=M;class i{constructor(b,o){this.width=b,this.height=o,this.array=[],this.array=new Array(b*o)}get(b,o){return this.array[b+o*this.width]}set(b,o,a){this.array[b+o*this.width]=a}}t.Array2D=i;function M(R){return R===n.CharCode.Space||R===n.CharCode.Tab}class m{static{this.chrKeys=new Map}static getKey(b){let o=this.chrKeys.get(b);return o===void 0&&(o=this.chrKeys.size,this.chrKeys.set(b,o)),o}constructor(b,o,a){this.range=b,this.lines=o,this.source=a,this.histogram=[];let h=0;for(let _=b.startLineNumber-1;_<b.endLineNumberExclusive-1;_++){const d=o[_];for(let e=0;e<d.length;e++){h++;const u=d[e],g=m.getKey(u);this.histogram[g]=(this.histogram[g]||0)+1}h++;const c=m.getKey(`
`);this.histogram[c]=(this.histogram[c]||0)+1}this.totalCount=h}computeSimilarity(b){let o=0;const a=Math.max(this.histogram.length,b.histogram.length);for(let h=0;h<a;h++)o+=Math.abs((this.histogram[h]??0)-(b.histogram[h]??0));return 1-o/(this.totalCount+b.totalCount)}}t.LineRangeFragment=m}),ie(re[59],ae([0,1,7,13,22]),function(C,t,n,i,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DynamicProgrammingDiffing=void 0;class m{compute(b,o,a=i.InfiniteTimeout.instance,h){if(b.length===0||o.length===0)return i.DiffAlgorithmResult.trivial(b,o);const _=new M.Array2D(b.length,o.length),d=new M.Array2D(b.length,o.length),c=new M.Array2D(b.length,o.length);for(let A=0;A<b.length;A++)for(let L=0;L<o.length;L++){if(!a.isValid())return i.DiffAlgorithmResult.trivialTimedOut(b,o);const l=A===0?0:_.get(A-1,L),s=L===0?0:_.get(A,L-1);let f;b.getElement(A)===o.getElement(L)?(A===0||L===0?f=0:f=_.get(A-1,L-1),A>0&&L>0&&d.get(A-1,L-1)===3&&(f+=c.get(A-1,L-1)),f+=h?h(A,L):1):f=-1;const p=Math.max(l,s,f);if(p===f){const I=A>0&&L>0?c.get(A-1,L-1):0;c.set(A,L,I+1),d.set(A,L,3)}else p===l?(c.set(A,L,0),d.set(A,L,1)):p===s&&(c.set(A,L,0),d.set(A,L,2));_.set(A,L,p)}const e=[];let u=b.length,g=o.length;function E(A,L){(A+1!==u||L+1!==g)&&e.push(new i.SequenceDiff(new n.OffsetRange(A+1,u),new n.OffsetRange(L+1,g))),u=A,g=L}let w=b.length-1,v=o.length-1;for(;w>=0&&v>=0;)d.get(w,v)===3?(E(w,v),w--,v--):d.get(w,v)===1?w--:v--;return E(-1,-1),e.reverse(),new i.DiffAlgorithmResult(e,!1)}}t.DynamicProgrammingDiffing=m}),ie(re[37],ae([0,1,11,3,7,5,2,22]),function(C,t,n,i,M,m,R,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LinesSliceCharSequence=void 0;class o{constructor(u,g,E){this.lines=u,this.range=g,this.considerWhitespaceChanges=E,this.elements=[],this.firstElementOffsetByLineIdx=[],this.lineStartOffsets=[],this.trimmedWsLengthsByLineIdx=[],this.firstElementOffsetByLineIdx.push(0);for(let w=this.range.startLineNumber;w<=this.range.endLineNumber;w++){let v=u[w-1],A=0;w===this.range.startLineNumber&&this.range.startColumn>1&&(A=this.range.startColumn-1,v=v.substring(A)),this.lineStartOffsets.push(A);let L=0;if(!E){const s=v.trimStart();L=v.length-s.length,v=s.trimEnd()}this.trimmedWsLengthsByLineIdx.push(L);const l=w===this.range.endLineNumber?Math.min(this.range.endColumn-1-A-L,v.length):v.length;for(let s=0;s<l;s++)this.elements.push(v.charCodeAt(s));w<this.range.endLineNumber&&(this.elements.push(10),this.firstElementOffsetByLineIdx.push(this.elements.length))}}toString(){return`Slice: "${this.text}"`}get text(){return this.getText(new M.OffsetRange(0,this.length))}getText(u){return this.elements.slice(u.start,u.endExclusive).map(g=>String.fromCharCode(g)).join("")}getElement(u){return this.elements[u]}get length(){return this.elements.length}getBoundaryScore(u){const g=c(u>0?this.elements[u-1]:-1),E=c(u<this.elements.length?this.elements[u]:-1);if(g===h.LineBreakCR&&E===h.LineBreakLF)return 0;if(g===h.LineBreakLF)return 150;let w=0;return g!==E&&(w+=10,g===h.WordLower&&E===h.WordUpper&&(w+=1)),w+=d(g),w+=d(E),w}translateOffset(u,g="right"){const E=(0,n.findLastIdxMonotonous)(this.firstElementOffsetByLineIdx,v=>v<=u),w=u-this.firstElementOffsetByLineIdx[E];return new m.Position(this.range.startLineNumber+E,1+this.lineStartOffsets[E]+w+(w===0&&g==="left"?0:this.trimmedWsLengthsByLineIdx[E]))}translateRange(u){const g=this.translateOffset(u.start,"right"),E=this.translateOffset(u.endExclusive,"left");return E.isBefore(g)?R.Range.fromPositions(E,E):R.Range.fromPositions(g,E)}findWordContaining(u){if(u<0||u>=this.elements.length||!a(this.elements[u]))return;let g=u;for(;g>0&&a(this.elements[g-1]);)g--;let E=u;for(;E<this.elements.length&&a(this.elements[E]);)E++;return new M.OffsetRange(g,E)}countLinesIn(u){return this.translateOffset(u.endExclusive).lineNumber-this.translateOffset(u.start).lineNumber}isStronglyEqual(u,g){return this.elements[u]===this.elements[g]}extendToFullLines(u){const g=(0,n.findLastMonotonous)(this.firstElementOffsetByLineIdx,w=>w<=u.start)??0,E=(0,n.findFirstMonotonous)(this.firstElementOffsetByLineIdx,w=>u.endExclusive<=w)??this.elements.length;return new M.OffsetRange(g,E)}}t.LinesSliceCharSequence=o;function a(e){return e>=i.CharCode.a&&e<=i.CharCode.z||e>=i.CharCode.A&&e<=i.CharCode.Z||e>=i.CharCode.Digit0&&e<=i.CharCode.Digit9}var h;(function(e){e[e.WordLower=0]="WordLower",e[e.WordUpper=1]="WordUpper",e[e.WordNumber=2]="WordNumber",e[e.End=3]="End",e[e.Other=4]="Other",e[e.Separator=5]="Separator",e[e.Space=6]="Space",e[e.LineBreakCR=7]="LineBreakCR",e[e.LineBreakLF=8]="LineBreakLF"})(h||(h={}));const _={[h.WordLower]:0,[h.WordUpper]:0,[h.WordNumber]:0,[h.End]:10,[h.Other]:2,[h.Separator]:30,[h.Space]:3,[h.LineBreakCR]:10,[h.LineBreakLF]:10};function d(e){return _[e]}function c(e){return e===i.CharCode.LineFeed?h.LineBreakLF:e===i.CharCode.CarriageReturn?h.LineBreakCR:(0,b.isSpace)(e)?h.Space:e>=i.CharCode.a&&e<=i.CharCode.z?h.WordLower:e>=i.CharCode.A&&e<=i.CharCode.Z?h.WordUpper:e>=i.CharCode.Digit0&&e<=i.CharCode.Digit9?h.WordNumber:e===-1?h.End:e===i.CharCode.Comma||e===i.CharCode.Semicolon?h.Separator:h.Other}}),ie(re[38],ae([0,1]),function(C,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.MovedText=t.LinesDiff=void 0;class n{constructor(m,R,b){this.changes=m,this.moves=R,this.hitTimeout=b}}t.LinesDiff=n;class i{constructor(m,R){this.lineRangeMapping=m,this.changes=R}flip(){return new i(this.lineRangeMapping.flip(),this.changes.map(m=>m.flip()))}}t.MovedText=i}),ie(re[23],ae([0,1,4,17,5,2,55]),function(C,t,n,i,M,m,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.RangeMapping=t.DetailedLineRangeMapping=t.LineRangeMapping=void 0;class b{static inverse(c,e,u){const g=[];let E=1,w=1;for(const A of c){const L=new b(new i.LineRange(E,A.original.startLineNumber),new i.LineRange(w,A.modified.startLineNumber));L.modified.isEmpty||g.push(L),E=A.original.endLineNumberExclusive,w=A.modified.endLineNumberExclusive}const v=new b(new i.LineRange(E,e+1),new i.LineRange(w,u+1));return v.modified.isEmpty||g.push(v),g}static clip(c,e,u){const g=[];for(const E of c){const w=E.original.intersect(e),v=E.modified.intersect(u);w&&!w.isEmpty&&v&&!v.isEmpty&&g.push(new b(w,v))}return g}constructor(c,e){this.original=c,this.modified=e}toString(){return`{${this.original.toString()}->${this.modified.toString()}}`}flip(){return new b(this.modified,this.original)}join(c){return new b(this.original.join(c.original),this.modified.join(c.modified))}get changedLineCount(){return Math.max(this.original.length,this.modified.length)}toRangeMapping(){const c=this.original.toInclusiveRange(),e=this.modified.toInclusiveRange();if(c&&e)return new _(c,e);if(this.original.startLineNumber===1||this.modified.startLineNumber===1){if(!(this.modified.startLineNumber===1&&this.original.startLineNumber===1))throw new n.BugIndicatingError("not a valid diff");return new _(new m.Range(this.original.startLineNumber,1,this.original.endLineNumberExclusive,1),new m.Range(this.modified.startLineNumber,1,this.modified.endLineNumberExclusive,1))}else return new _(new m.Range(this.original.startLineNumber-1,Number.MAX_SAFE_INTEGER,this.original.endLineNumberExclusive-1,Number.MAX_SAFE_INTEGER),new m.Range(this.modified.startLineNumber-1,Number.MAX_SAFE_INTEGER,this.modified.endLineNumberExclusive-1,Number.MAX_SAFE_INTEGER))}toRangeMapping2(c,e){if(a(this.original.endLineNumberExclusive,c)&&a(this.modified.endLineNumberExclusive,e))return new _(new m.Range(this.original.startLineNumber,1,this.original.endLineNumberExclusive,1),new m.Range(this.modified.startLineNumber,1,this.modified.endLineNumberExclusive,1));if(!this.original.isEmpty&&!this.modified.isEmpty)return new _(m.Range.fromPositions(new M.Position(this.original.startLineNumber,1),o(new M.Position(this.original.endLineNumberExclusive-1,Number.MAX_SAFE_INTEGER),c)),m.Range.fromPositions(new M.Position(this.modified.startLineNumber,1),o(new M.Position(this.modified.endLineNumberExclusive-1,Number.MAX_SAFE_INTEGER),e)));if(this.original.startLineNumber>1&&this.modified.startLineNumber>1)return new _(m.Range.fromPositions(o(new M.Position(this.original.startLineNumber-1,Number.MAX_SAFE_INTEGER),c),o(new M.Position(this.original.endLineNumberExclusive-1,Number.MAX_SAFE_INTEGER),c)),m.Range.fromPositions(o(new M.Position(this.modified.startLineNumber-1,Number.MAX_SAFE_INTEGER),e),o(new M.Position(this.modified.endLineNumberExclusive-1,Number.MAX_SAFE_INTEGER),e)));throw new n.BugIndicatingError}}t.LineRangeMapping=b;function o(d,c){if(d.lineNumber<1)return new M.Position(1,1);if(d.lineNumber>c.length)return new M.Position(c.length,c[c.length-1].length+1);const e=c[d.lineNumber-1];return d.column>e.length+1?new M.Position(d.lineNumber,e.length+1):d}function a(d,c){return d>=1&&d<=c.length}class h extends b{static fromRangeMappings(c){const e=i.LineRange.join(c.map(g=>i.LineRange.fromRangeInclusive(g.originalRange))),u=i.LineRange.join(c.map(g=>i.LineRange.fromRangeInclusive(g.modifiedRange)));return new h(e,u,c)}constructor(c,e,u){super(c,e),this.innerChanges=u}flip(){return new h(this.modified,this.original,this.innerChanges?.map(c=>c.flip()))}withInnerChangesFromLineRanges(){return new h(this.original,this.modified,[this.toRangeMapping()])}}t.DetailedLineRangeMapping=h;class _{static assertSorted(c){for(let e=1;e<c.length;e++){const u=c[e-1],g=c[e];if(!(u.originalRange.getEndPosition().isBeforeOrEqual(g.originalRange.getStartPosition())&&u.modifiedRange.getEndPosition().isBeforeOrEqual(g.modifiedRange.getStartPosition())))throw new n.BugIndicatingError("Range mappings must be sorted")}}constructor(c,e){this.originalRange=c,this.modifiedRange=e}toString(){return`{${this.originalRange.toString()}->${this.modifiedRange.toString()}}`}flip(){return new _(this.modifiedRange,this.originalRange)}toTextEdit(c){const e=c.getValueOfRange(this.modifiedRange);return new R.SingleTextEdit(this.originalRange,e)}}t.RangeMapping=_}),ie(re[60],ae([0,1,13,23,9,11,19,17,37,22,36,2]),function(C,t,n,i,M,m,R,b,o,a,h,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.computeMovedLines=d;function d(v,A,L,l,s,f){let{moves:p,excludedChanges:I}=e(v,A,L,f);if(!f.isValid())return[];const N=v.filter(D=>!I.has(D)),S=u(N,l,s,A,L,f);return(0,M.pushMany)(p,S),p=E(p),p=p.filter(D=>{const T=D.original.toOffsetRange().slice(A).map(k=>k.trim());return T.join(`
`).length>=15&&c(T,k=>k.length>=2)>=2}),p=w(v,p),p}function c(v,A){let L=0;for(const l of v)A(l)&&L++;return L}function e(v,A,L,l){const s=[],f=v.filter(N=>N.modified.isEmpty&&N.original.length>=3).map(N=>new a.LineRangeFragment(N.original,A,N)),p=new Set(v.filter(N=>N.original.isEmpty&&N.modified.length>=3).map(N=>new a.LineRangeFragment(N.modified,L,N))),I=new Set;for(const N of f){let S=-1,D;for(const T of p){const y=N.computeSimilarity(T);y>S&&(S=y,D=T)}if(S>.9&&D&&(p.delete(D),s.push(new i.LineRangeMapping(N.range,D.range)),I.add(N.source),I.add(D.source)),!l.isValid())return{moves:s,excludedChanges:I}}return{moves:s,excludedChanges:I}}function u(v,A,L,l,s,f){const p=[],I=new R.SetMap;for(const y of v)for(let k=y.original.startLineNumber;k<y.original.endLineNumberExclusive-2;k++){const P=`${A[k-1]}:${A[k+1-1]}:${A[k+2-1]}`;I.add(P,{range:new b.LineRange(k,k+3)})}const N=[];v.sort((0,M.compareBy)(y=>y.modified.startLineNumber,M.numberComparator));for(const y of v){let k=[];for(let P=y.modified.startLineNumber;P<y.modified.endLineNumberExclusive-2;P++){const q=`${L[P-1]}:${L[P+1-1]}:${L[P+2-1]}`,j=new b.LineRange(P,P+3),H=[];I.forEach(q,({range:W})=>{for(const ee of k)if(ee.originalLineRange.endLineNumberExclusive+1===W.endLineNumberExclusive&&ee.modifiedLineRange.endLineNumberExclusive+1===j.endLineNumberExclusive){ee.originalLineRange=new b.LineRange(ee.originalLineRange.startLineNumber,W.endLineNumberExclusive),ee.modifiedLineRange=new b.LineRange(ee.modifiedLineRange.startLineNumber,j.endLineNumberExclusive),H.push(ee);return}const J={modifiedLineRange:j,originalLineRange:W};N.push(J),H.push(J)}),k=H}if(!f.isValid())return[]}N.sort((0,M.reverseOrder)((0,M.compareBy)(y=>y.modifiedLineRange.length,M.numberComparator)));const S=new b.LineRangeSet,D=new b.LineRangeSet;for(const y of N){const k=y.modifiedLineRange.startLineNumber-y.originalLineRange.startLineNumber,P=S.subtractFrom(y.modifiedLineRange),q=D.subtractFrom(y.originalLineRange).getWithDelta(k),j=P.getIntersection(q);for(const H of j.ranges){if(H.length<3)continue;const W=H,J=H.delta(-k);p.push(new i.LineRangeMapping(J,W)),S.addRange(W),D.addRange(J)}}p.sort((0,M.compareBy)(y=>y.original.startLineNumber,M.numberComparator));const T=new m.MonotonousArray(v);for(let y=0;y<p.length;y++){const k=p[y],P=T.findLastMonotonous(K=>K.original.startLineNumber<=k.original.startLineNumber),q=(0,m.findLastMonotonous)(v,K=>K.modified.startLineNumber<=k.modified.startLineNumber),j=Math.max(k.original.startLineNumber-P.original.startLineNumber,k.modified.startLineNumber-q.modified.startLineNumber),H=T.findLastMonotonous(K=>K.original.startLineNumber<k.original.endLineNumberExclusive),W=(0,m.findLastMonotonous)(v,K=>K.modified.startLineNumber<k.modified.endLineNumberExclusive),J=Math.max(H.original.endLineNumberExclusive-k.original.endLineNumberExclusive,W.modified.endLineNumberExclusive-k.modified.endLineNumberExclusive);let ee;for(ee=0;ee<j;ee++){const K=k.original.startLineNumber-ee-1,ne=k.modified.startLineNumber-ee-1;if(K>l.length||ne>s.length||S.contains(ne)||D.contains(K)||!g(l[K-1],s[ne-1],f))break}ee>0&&(D.addRange(new b.LineRange(k.original.startLineNumber-ee,k.original.startLineNumber)),S.addRange(new b.LineRange(k.modified.startLineNumber-ee,k.modified.startLineNumber)));let Z;for(Z=0;Z<J;Z++){const K=k.original.endLineNumberExclusive+Z,ne=k.modified.endLineNumberExclusive+Z;if(K>l.length||ne>s.length||S.contains(ne)||D.contains(K)||!g(l[K-1],s[ne-1],f))break}Z>0&&(D.addRange(new b.LineRange(k.original.endLineNumberExclusive,k.original.endLineNumberExclusive+Z)),S.addRange(new b.LineRange(k.modified.endLineNumberExclusive,k.modified.endLineNumberExclusive+Z))),(ee>0||Z>0)&&(p[y]=new i.LineRangeMapping(new b.LineRange(k.original.startLineNumber-ee,k.original.endLineNumberExclusive+Z),new b.LineRange(k.modified.startLineNumber-ee,k.modified.endLineNumberExclusive+Z)))}return p}function g(v,A,L){if(v.trim()===A.trim())return!0;if(v.length>300&&A.length>300)return!1;const s=new h.MyersDiffAlgorithm().compute(new o.LinesSliceCharSequence([v],new _.Range(1,1,1,v.length),!1),new o.LinesSliceCharSequence([A],new _.Range(1,1,1,A.length),!1),L);let f=0;const p=n.SequenceDiff.invert(s.diffs,v.length);for(const D of p)D.seq1Range.forEach(T=>{(0,a.isSpace)(v.charCodeAt(T))||f++});function I(D){let T=0;for(let y=0;y<v.length;y++)(0,a.isSpace)(D.charCodeAt(y))||T++;return T}const N=I(v.length>A.length?v:A);return f/N>.6&&N>10}function E(v){if(v.length===0)return v;v.sort((0,M.compareBy)(L=>L.original.startLineNumber,M.numberComparator));const A=[v[0]];for(let L=1;L<v.length;L++){const l=A[A.length-1],s=v[L],f=s.original.startLineNumber-l.original.endLineNumberExclusive,p=s.modified.startLineNumber-l.modified.endLineNumberExclusive;if(f>=0&&p>=0&&f+p<=2){A[A.length-1]=l.join(s);continue}A.push(s)}return A}function w(v,A){const L=new m.MonotonousArray(v);return A=A.filter(l=>{const s=L.findLastMonotonous(I=>I.original.startLineNumber<l.original.endLineNumberExclusive)||new i.LineRangeMapping(new b.LineRange(1,1),new b.LineRange(1,1)),f=(0,m.findLastMonotonous)(v,I=>I.modified.startLineNumber<l.modified.endLineNumberExclusive);return s!==f}),A}}),ie(re[61],ae([0,1,9,15,17,7,2,13,59,36,60,57,58,37,38,23]),function(C,t,n,i,M,m,R,b,o,a,h,_,d,c,e,u){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DefaultLinesDiffComputer=void 0,t.lineRangeMappingFromRangeMappings=E,t.getLineRangeMapping=w;class g{constructor(){this.dynamicProgrammingDiffing=new o.DynamicProgrammingDiffing,this.myersDiffingAlgorithm=new a.MyersDiffAlgorithm}computeDiff(L,l,s){if(L.length<=1&&(0,n.equals)(L,l,(K,ne)=>K===ne))return new e.LinesDiff([],[],!1);if(L.length===1&&L[0].length===0||l.length===1&&l[0].length===0)return new e.LinesDiff([new u.DetailedLineRangeMapping(new M.LineRange(1,L.length+1),new M.LineRange(1,l.length+1),[new u.RangeMapping(new R.Range(1,1,L.length,L[L.length-1].length+1),new R.Range(1,1,l.length,l[l.length-1].length+1))])],[],!1);const f=s.maxComputationTimeMs===0?b.InfiniteTimeout.instance:new b.DateTimeout(s.maxComputationTimeMs),p=!s.ignoreTrimWhitespace,I=new Map;function N(K){let ne=I.get(K);return ne===void 0&&(ne=I.size,I.set(K,ne)),ne}const S=L.map(K=>N(K.trim())),D=l.map(K=>N(K.trim())),T=new d.LineSequence(S,L),y=new d.LineSequence(D,l),k=T.length+y.length<1700?this.dynamicProgrammingDiffing.compute(T,y,f,(K,ne)=>L[K]===l[ne]?l[ne].length===0?.1:1+Math.log(1+l[ne].length):.99):this.myersDiffingAlgorithm.compute(T,y,f);let P=k.diffs,q=k.hitTimeout;P=(0,_.optimizeSequenceDiffs)(T,y,P),P=(0,_.removeVeryShortMatchingLinesBetweenDiffs)(T,y,P);const j=[],H=K=>{if(p)for(let ne=0;ne<K;ne++){const F=W+ne,$=J+ne;if(L[F]!==l[$]){const he=this.refineDiff(L,l,new b.SequenceDiff(new m.OffsetRange(F,F+1),new m.OffsetRange($,$+1)),f,p);for(const ge of he.mappings)j.push(ge);he.hitTimeout&&(q=!0)}}};let W=0,J=0;for(const K of P){(0,i.assertFn)(()=>K.seq1Range.start-W===K.seq2Range.start-J);const ne=K.seq1Range.start-W;H(ne),W=K.seq1Range.endExclusive,J=K.seq2Range.endExclusive;const F=this.refineDiff(L,l,K,f,p);F.hitTimeout&&(q=!0);for(const $ of F.mappings)j.push($)}H(L.length-W);const ee=E(j,L,l);let Z=[];return s.computeMoves&&(Z=this.computeMoves(ee,L,l,S,D,f,p)),(0,i.assertFn)(()=>{function K(F,$){if(F.lineNumber<1||F.lineNumber>$.length)return!1;const he=$[F.lineNumber-1];return!(F.column<1||F.column>he.length+1)}function ne(F,$){return!(F.startLineNumber<1||F.startLineNumber>$.length+1||F.endLineNumberExclusive<1||F.endLineNumberExclusive>$.length+1)}for(const F of ee){if(!F.innerChanges)return!1;for(const $ of F.innerChanges)if(!(K($.modifiedRange.getStartPosition(),l)&&K($.modifiedRange.getEndPosition(),l)&&K($.originalRange.getStartPosition(),L)&&K($.originalRange.getEndPosition(),L)))return!1;if(!ne(F.modified,l)||!ne(F.original,L))return!1}return!0}),new e.LinesDiff(ee,Z,q)}computeMoves(L,l,s,f,p,I,N){return(0,h.computeMovedLines)(L,l,s,f,p,I).map(T=>{const y=this.refineDiff(l,s,new b.SequenceDiff(T.original.toOffsetRange(),T.modified.toOffsetRange()),I,N),k=E(y.mappings,l,s,!0);return new e.MovedText(T,k)})}refineDiff(L,l,s,f,p){const N=v(s).toRangeMapping2(L,l),S=new c.LinesSliceCharSequence(L,N.originalRange,p),D=new c.LinesSliceCharSequence(l,N.modifiedRange,p),T=S.length+D.length<500?this.dynamicProgrammingDiffing.compute(S,D,f):this.myersDiffingAlgorithm.compute(S,D,f),y=!1;let k=T.diffs;y&&b.SequenceDiff.assertSorted(k),k=(0,_.optimizeSequenceDiffs)(S,D,k),y&&b.SequenceDiff.assertSorted(k),k=(0,_.extendDiffsToEntireWordIfAppropriate)(S,D,k),y&&b.SequenceDiff.assertSorted(k),k=(0,_.removeShortMatches)(S,D,k),y&&b.SequenceDiff.assertSorted(k),k=(0,_.removeVeryShortMatchingTextBetweenLongDiffs)(S,D,k),y&&b.SequenceDiff.assertSorted(k);const P=k.map(q=>new u.RangeMapping(S.translateRange(q.seq1Range),D.translateRange(q.seq2Range)));return y&&u.RangeMapping.assertSorted(P),{mappings:P,hitTimeout:T.hitTimeout}}}t.DefaultLinesDiffComputer=g;function E(A,L,l,s=!1){const f=[];for(const p of(0,n.groupAdjacentBy)(A.map(I=>w(I,L,l)),(I,N)=>I.original.overlapOrTouch(N.original)||I.modified.overlapOrTouch(N.modified))){const I=p[0],N=p[p.length-1];f.push(new u.DetailedLineRangeMapping(I.original.join(N.original),I.modified.join(N.modified),p.map(S=>S.innerChanges[0])))}return(0,i.assertFn)(()=>!s&&f.length>0&&(f[0].modified.startLineNumber!==f[0].original.startLineNumber||l.length-f[f.length-1].modified.endLineNumberExclusive!==L.length-f[f.length-1].original.endLineNumberExclusive)?!1:(0,i.checkAdjacentItems)(f,(p,I)=>I.original.startLineNumber-p.original.endLineNumberExclusive===I.modified.startLineNumber-p.modified.endLineNumberExclusive&&p.original.endLineNumberExclusive<I.original.startLineNumber&&p.modified.endLineNumberExclusive<I.modified.startLineNumber)),f}function w(A,L,l){let s=0,f=0;A.modifiedRange.endColumn===1&&A.originalRange.endColumn===1&&A.originalRange.startLineNumber+s<=A.originalRange.endLineNumber&&A.modifiedRange.startLineNumber+s<=A.modifiedRange.endLineNumber&&(f=-1),A.modifiedRange.startColumn-1>=l[A.modifiedRange.startLineNumber-1].length&&A.originalRange.startColumn-1>=L[A.originalRange.startLineNumber-1].length&&A.originalRange.startLineNumber<=A.originalRange.endLineNumber+f&&A.modifiedRange.startLineNumber<=A.modifiedRange.endLineNumber+f&&(s=1);const p=new M.LineRange(A.originalRange.startLineNumber+s,A.originalRange.endLineNumber+1+f),I=new M.LineRange(A.modifiedRange.startLineNumber+s,A.modifiedRange.endLineNumber+1+f);return new u.DetailedLineRangeMapping(p,I,[A])}function v(A){return new u.LineRangeMapping(new M.LineRange(A.seq1Range.start+1,A.seq1Range.endExclusive+1),new M.LineRange(A.seq2Range.start+1,A.seq2Range.endExclusive+1))}}),ie(re[39],ae([0,1,3,32,38,23,6,2,15,17]),function(C,t,n,i,M,m,R,b,o,a){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DiffComputer=t.LegacyLinesDiffComputer=void 0,R=ye(R);const h=3;class _{computeDiff(s,f,p){const N=new w(s,f,{maxComputationTime:p.maxComputationTimeMs,shouldIgnoreTrimWhitespace:p.ignoreTrimWhitespace,shouldComputeCharChanges:!0,shouldMakePrettyDiff:!0,shouldPostProcessCharChanges:!0}).computeDiff(),S=[];let D=null;for(const T of N.changes){let y;T.originalEndLineNumber===0?y=new a.LineRange(T.originalStartLineNumber+1,T.originalStartLineNumber+1):y=new a.LineRange(T.originalStartLineNumber,T.originalEndLineNumber+1);let k;T.modifiedEndLineNumber===0?k=new a.LineRange(T.modifiedStartLineNumber+1,T.modifiedStartLineNumber+1):k=new a.LineRange(T.modifiedStartLineNumber,T.modifiedEndLineNumber+1);let P=new m.DetailedLineRangeMapping(y,k,T.charChanges?.map(q=>new m.RangeMapping(new b.Range(q.originalStartLineNumber,q.originalStartColumn,q.originalEndLineNumber,q.originalEndColumn),new b.Range(q.modifiedStartLineNumber,q.modifiedStartColumn,q.modifiedEndLineNumber,q.modifiedEndColumn))));D&&(D.modified.endLineNumberExclusive===P.modified.startLineNumber||D.original.endLineNumberExclusive===P.original.startLineNumber)&&(P=new m.DetailedLineRangeMapping(D.original.join(P.original),D.modified.join(P.modified),D.innerChanges&&P.innerChanges?D.innerChanges.concat(P.innerChanges):void 0),S.pop()),S.push(P),D=P}return(0,o.assertFn)(()=>(0,o.checkAdjacentItems)(S,(T,y)=>y.original.startLineNumber-T.original.endLineNumberExclusive===y.modified.startLineNumber-T.modified.endLineNumberExclusive&&T.original.endLineNumberExclusive<y.original.startLineNumber&&T.modified.endLineNumberExclusive<y.modified.startLineNumber)),new M.LinesDiff(S,[],N.quitEarly)}}t.LegacyLinesDiffComputer=_;function d(l,s,f,p){return new i.LcsDiff(l,s,f).ComputeDiff(p)}class c{constructor(s){const f=[],p=[];for(let I=0,N=s.length;I<N;I++)f[I]=v(s[I],1),p[I]=A(s[I],1);this.lines=s,this._startColumns=f,this._endColumns=p}getElements(){const s=[];for(let f=0,p=this.lines.length;f<p;f++)s[f]=this.lines[f].substring(this._startColumns[f]-1,this._endColumns[f]-1);return s}getStrictElement(s){return this.lines[s]}getStartLineNumber(s){return s+1}getEndLineNumber(s){return s+1}createCharSequence(s,f,p){const I=[],N=[],S=[];let D=0;for(let T=f;T<=p;T++){const y=this.lines[T],k=s?this._startColumns[T]:1,P=s?this._endColumns[T]:y.length+1;for(let q=k;q<P;q++)I[D]=y.charCodeAt(q-1),N[D]=T+1,S[D]=q,D++;!s&&T<p&&(I[D]=n.CharCode.LineFeed,N[D]=T+1,S[D]=y.length+1,D++)}return new e(I,N,S)}}class e{constructor(s,f,p){this._charCodes=s,this._lineNumbers=f,this._columns=p}toString(){return"["+this._charCodes.map((s,f)=>(s===n.CharCode.LineFeed?"\\n":String.fromCharCode(s))+`-(${this._lineNumbers[f]},${this._columns[f]})`).join(", ")+"]"}_assertIndex(s,f){if(s<0||s>=f.length)throw new Error("Illegal index")}getElements(){return this._charCodes}getStartLineNumber(s){return s>0&&s===this._lineNumbers.length?this.getEndLineNumber(s-1):(this._assertIndex(s,this._lineNumbers),this._lineNumbers[s])}getEndLineNumber(s){return s===-1?this.getStartLineNumber(s+1):(this._assertIndex(s,this._lineNumbers),this._charCodes[s]===n.CharCode.LineFeed?this._lineNumbers[s]+1:this._lineNumbers[s])}getStartColumn(s){return s>0&&s===this._columns.length?this.getEndColumn(s-1):(this._assertIndex(s,this._columns),this._columns[s])}getEndColumn(s){return s===-1?this.getStartColumn(s+1):(this._assertIndex(s,this._columns),this._charCodes[s]===n.CharCode.LineFeed?1:this._columns[s]+1)}}class u{constructor(s,f,p,I,N,S,D,T){this.originalStartLineNumber=s,this.originalStartColumn=f,this.originalEndLineNumber=p,this.originalEndColumn=I,this.modifiedStartLineNumber=N,this.modifiedStartColumn=S,this.modifiedEndLineNumber=D,this.modifiedEndColumn=T}static createFromDiffChange(s,f,p){const I=f.getStartLineNumber(s.originalStart),N=f.getStartColumn(s.originalStart),S=f.getEndLineNumber(s.originalStart+s.originalLength-1),D=f.getEndColumn(s.originalStart+s.originalLength-1),T=p.getStartLineNumber(s.modifiedStart),y=p.getStartColumn(s.modifiedStart),k=p.getEndLineNumber(s.modifiedStart+s.modifiedLength-1),P=p.getEndColumn(s.modifiedStart+s.modifiedLength-1);return new u(I,N,S,D,T,y,k,P)}}function g(l){if(l.length<=1)return l;const s=[l[0]];let f=s[0];for(let p=1,I=l.length;p<I;p++){const N=l[p],S=N.originalStart-(f.originalStart+f.originalLength),D=N.modifiedStart-(f.modifiedStart+f.modifiedLength);Math.min(S,D)<h?(f.originalLength=N.originalStart+N.originalLength-f.originalStart,f.modifiedLength=N.modifiedStart+N.modifiedLength-f.modifiedStart):(s.push(N),f=N)}return s}class E{constructor(s,f,p,I,N){this.originalStartLineNumber=s,this.originalEndLineNumber=f,this.modifiedStartLineNumber=p,this.modifiedEndLineNumber=I,this.charChanges=N}static createFromDiffResult(s,f,p,I,N,S,D){let T,y,k,P,q;if(f.originalLength===0?(T=p.getStartLineNumber(f.originalStart)-1,y=0):(T=p.getStartLineNumber(f.originalStart),y=p.getEndLineNumber(f.originalStart+f.originalLength-1)),f.modifiedLength===0?(k=I.getStartLineNumber(f.modifiedStart)-1,P=0):(k=I.getStartLineNumber(f.modifiedStart),P=I.getEndLineNumber(f.modifiedStart+f.modifiedLength-1)),S&&f.originalLength>0&&f.originalLength<20&&f.modifiedLength>0&&f.modifiedLength<20&&N()){const j=p.createCharSequence(s,f.originalStart,f.originalStart+f.originalLength-1),H=I.createCharSequence(s,f.modifiedStart,f.modifiedStart+f.modifiedLength-1);if(j.getElements().length>0&&H.getElements().length>0){let W=d(j,H,N,!0).changes;D&&(W=g(W)),q=[];for(let J=0,ee=W.length;J<ee;J++)q.push(u.createFromDiffChange(W[J],j,H))}}return new E(T,y,k,P,q)}}class w{constructor(s,f,p){this.shouldComputeCharChanges=p.shouldComputeCharChanges,this.shouldPostProcessCharChanges=p.shouldPostProcessCharChanges,this.shouldIgnoreTrimWhitespace=p.shouldIgnoreTrimWhitespace,this.shouldMakePrettyDiff=p.shouldMakePrettyDiff,this.originalLines=s,this.modifiedLines=f,this.original=new c(s),this.modified=new c(f),this.continueLineDiff=L(p.maxComputationTime),this.continueCharDiff=L(p.maxComputationTime===0?0:Math.min(p.maxComputationTime,5e3))}computeDiff(){if(this.original.lines.length===1&&this.original.lines[0].length===0)return this.modified.lines.length===1&&this.modified.lines[0].length===0?{quitEarly:!1,changes:[]}:{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:1,modifiedStartLineNumber:1,modifiedEndLineNumber:this.modified.lines.length,charChanges:void 0}]};if(this.modified.lines.length===1&&this.modified.lines[0].length===0)return{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:this.original.lines.length,modifiedStartLineNumber:1,modifiedEndLineNumber:1,charChanges:void 0}]};const s=d(this.original,this.modified,this.continueLineDiff,this.shouldMakePrettyDiff),f=s.changes,p=s.quitEarly;if(this.shouldIgnoreTrimWhitespace){const D=[];for(let T=0,y=f.length;T<y;T++)D.push(E.createFromDiffResult(this.shouldIgnoreTrimWhitespace,f[T],this.original,this.modified,this.continueCharDiff,this.shouldComputeCharChanges,this.shouldPostProcessCharChanges));return{quitEarly:p,changes:D}}const I=[];let N=0,S=0;for(let D=-1,T=f.length;D<T;D++){const y=D+1<T?f[D+1]:null,k=y?y.originalStart:this.originalLines.length,P=y?y.modifiedStart:this.modifiedLines.length;for(;N<k&&S<P;){const q=this.originalLines[N],j=this.modifiedLines[S];if(q!==j){{let H=v(q,1),W=v(j,1);for(;H>1&&W>1;){const J=q.charCodeAt(H-2),ee=j.charCodeAt(W-2);if(J!==ee)break;H--,W--}(H>1||W>1)&&this._pushTrimWhitespaceCharChange(I,N+1,1,H,S+1,1,W)}{let H=A(q,1),W=A(j,1);const J=q.length+1,ee=j.length+1;for(;H<J&&W<ee;){const Z=q.charCodeAt(H-1),K=q.charCodeAt(W-1);if(Z!==K)break;H++,W++}(H<J||W<ee)&&this._pushTrimWhitespaceCharChange(I,N+1,H,J,S+1,W,ee)}}N++,S++}y&&(I.push(E.createFromDiffResult(this.shouldIgnoreTrimWhitespace,y,this.original,this.modified,this.continueCharDiff,this.shouldComputeCharChanges,this.shouldPostProcessCharChanges)),N+=y.originalLength,S+=y.modifiedLength)}return{quitEarly:p,changes:I}}_pushTrimWhitespaceCharChange(s,f,p,I,N,S,D){if(this._mergeTrimWhitespaceCharChange(s,f,p,I,N,S,D))return;let T;this.shouldComputeCharChanges&&(T=[new u(f,p,f,I,N,S,N,D)]),s.push(new E(f,f,N,N,T))}_mergeTrimWhitespaceCharChange(s,f,p,I,N,S,D){const T=s.length;if(T===0)return!1;const y=s[T-1];return y.originalEndLineNumber===0||y.modifiedEndLineNumber===0?!1:y.originalEndLineNumber===f&&y.modifiedEndLineNumber===N?(this.shouldComputeCharChanges&&y.charChanges&&y.charChanges.push(new u(f,p,f,I,N,S,N,D)),!0):y.originalEndLineNumber+1===f&&y.modifiedEndLineNumber+1===N?(y.originalEndLineNumber=f,y.modifiedEndLineNumber=N,this.shouldComputeCharChanges&&y.charChanges&&y.charChanges.push(new u(f,p,f,I,N,S,N,D)),!0):!1}}t.DiffComputer=w;function v(l,s){const f=R.firstNonWhitespaceIndex(l);return f===-1?s:f+1}function A(l,s){const f=R.lastNonWhitespaceIndex(l);return f===-1?s:f+2}function L(l){if(l===0)return()=>!0;const s=Date.now();return()=>Date.now()-s<l}}),ie(re[62],ae([0,1,39,61]),function(C,t,n,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.linesDiffComputers=void 0,t.linesDiffComputers={getLegacy:()=>new n.LegacyLinesDiffComputer,getDefault:()=>new i.DefaultLinesDiffComputer}}),ie(re[63],ae([0,1]),function(C,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.TokenMetadata=t.MetadataConsts=t.StandardTokenType=t.ColorId=t.FontStyle=t.LanguageId=void 0;var n;(function(o){o[o.Null=0]="Null",o[o.PlainText=1]="PlainText"})(n||(t.LanguageId=n={}));var i;(function(o){o[o.NotSet=-1]="NotSet",o[o.None=0]="None",o[o.Italic=1]="Italic",o[o.Bold=2]="Bold",o[o.Underline=4]="Underline",o[o.Strikethrough=8]="Strikethrough"})(i||(t.FontStyle=i={}));var M;(function(o){o[o.None=0]="None",o[o.DefaultForeground=1]="DefaultForeground",o[o.DefaultBackground=2]="DefaultBackground"})(M||(t.ColorId=M={}));var m;(function(o){o[o.Other=0]="Other",o[o.Comment=1]="Comment",o[o.String=2]="String",o[o.RegEx=3]="RegEx"})(m||(t.StandardTokenType=m={}));var R;(function(o){o[o.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",o[o.TOKEN_TYPE_MASK=768]="TOKEN_TYPE_MASK",o[o.BALANCED_BRACKETS_MASK=1024]="BALANCED_BRACKETS_MASK",o[o.FONT_STYLE_MASK=30720]="FONT_STYLE_MASK",o[o.FOREGROUND_MASK=16744448]="FOREGROUND_MASK",o[o.BACKGROUND_MASK=4278190080]="BACKGROUND_MASK",o[o.ITALIC_MASK=2048]="ITALIC_MASK",o[o.BOLD_MASK=4096]="BOLD_MASK",o[o.UNDERLINE_MASK=8192]="UNDERLINE_MASK",o[o.STRIKETHROUGH_MASK=16384]="STRIKETHROUGH_MASK",o[o.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",o[o.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",o[o.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",o[o.SEMANTIC_USE_STRIKETHROUGH=8]="SEMANTIC_USE_STRIKETHROUGH",o[o.SEMANTIC_USE_FOREGROUND=16]="SEMANTIC_USE_FOREGROUND",o[o.SEMANTIC_USE_BACKGROUND=32]="SEMANTIC_USE_BACKGROUND",o[o.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",o[o.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",o[o.BALANCED_BRACKETS_OFFSET=10]="BALANCED_BRACKETS_OFFSET",o[o.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",o[o.FOREGROUND_OFFSET=15]="FOREGROUND_OFFSET",o[o.BACKGROUND_OFFSET=24]="BACKGROUND_OFFSET"})(R||(t.MetadataConsts=R={}));class b{static getLanguageId(a){return(a&R.LANGUAGEID_MASK)>>>R.LANGUAGEID_OFFSET}static getTokenType(a){return(a&R.TOKEN_TYPE_MASK)>>>R.TOKEN_TYPE_OFFSET}static containsBalancedBrackets(a){return(a&R.BALANCED_BRACKETS_MASK)!==0}static getFontStyle(a){return(a&R.FONT_STYLE_MASK)>>>R.FONT_STYLE_OFFSET}static getForeground(a){return(a&R.FOREGROUND_MASK)>>>R.FOREGROUND_OFFSET}static getBackground(a){return(a&R.BACKGROUND_MASK)>>>R.BACKGROUND_OFFSET}static getClassNameFromMetadata(a){let _="mtk"+this.getForeground(a);const d=this.getFontStyle(a);return d&i.Italic&&(_+=" mtki"),d&i.Bold&&(_+=" mtkb"),d&i.Underline&&(_+=" mtku"),d&i.Strikethrough&&(_+=" mtks"),_}static getInlineStyleFromMetadata(a,h){const _=this.getForeground(a),d=this.getFontStyle(a);let c=`color: ${h[_]};`;d&i.Italic&&(c+="font-style: italic;"),d&i.Bold&&(c+="font-weight: bold;");let e="";return d&i.Underline&&(e+=" underline"),d&i.Strikethrough&&(e+=" line-through"),e&&(c+=`text-decoration:${e};`),c}static getPresentationFromMetadata(a){const h=this.getForeground(a),_=this.getFontStyle(a);return{foreground:h,italic:!!(_&i.Italic),bold:!!(_&i.Bold),underline:!!(_&i.Underline),strikethrough:!!(_&i.Strikethrough)}}}t.TokenMetadata=b}),ie(re[64],ae([0,1,43]),function(C,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.computeDefaultDocumentColors=_;function i(d){const c=[];for(const e of d){const u=Number(e);(u||u===0&&e.replace(/\s/g,"")!=="")&&c.push(u)}return c}function M(d,c,e,u){return{red:d/255,blue:e/255,green:c/255,alpha:u}}function m(d,c){const e=c.index,u=c[0].length;if(!e)return;const g=d.positionAt(e);return{startLineNumber:g.lineNumber,startColumn:g.column,endLineNumber:g.lineNumber,endColumn:g.column+u}}function R(d,c){if(!d)return;const e=n.Color.Format.CSS.parseHex(c);if(e)return{range:d,color:M(e.rgba.r,e.rgba.g,e.rgba.b,e.rgba.a)}}function b(d,c,e){if(!d||c.length!==1)return;const g=c[0].values(),E=i(g);return{range:d,color:M(E[0],E[1],E[2],e?E[3]:1)}}function o(d,c,e){if(!d||c.length!==1)return;const g=c[0].values(),E=i(g),w=new n.Color(new n.HSLA(E[0],E[1]/100,E[2]/100,e?E[3]:1));return{range:d,color:M(w.rgba.r,w.rgba.g,w.rgba.b,w.rgba.a)}}function a(d,c){return typeof d=="string"?[...d.matchAll(c)]:d.findMatches(c)}function h(d){const c=[],u=a(d,/\b(rgb|rgba|hsl|hsla)(\([0-9\s,.\%]*\))|(#)([A-Fa-f0-9]{3})\b|(#)([A-Fa-f0-9]{4})\b|(#)([A-Fa-f0-9]{6})\b|(#)([A-Fa-f0-9]{8})\b/gm);if(u.length>0)for(const g of u){const E=g.filter(L=>L!==void 0),w=E[1],v=E[2];if(!v)continue;let A;if(w==="rgb"){const L=/^\(\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*\)$/gm;A=b(m(d,g),a(v,L),!1)}else if(w==="rgba"){const L=/^\(\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(0[.][0-9]+|[.][0-9]+|[01][.]|[01])\s*\)$/gm;A=b(m(d,g),a(v,L),!0)}else if(w==="hsl"){const L=/^\(\s*(36[0]|3[0-5][0-9]|[12][0-9][0-9]|[1-9]?[0-9])\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*\)$/gm;A=o(m(d,g),a(v,L),!1)}else if(w==="hsla"){const L=/^\(\s*(36[0]|3[0-5][0-9]|[12][0-9][0-9]|[1-9]?[0-9])\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*,\s*(0[.][0-9]+|[.][0-9]+|[01][.]|[01])\s*\)$/gm;A=o(m(d,g),a(v,L),!0)}else w==="#"&&(A=R(m(d,g),w+v));A&&c.push(A)}return c}function _(d){return!d||typeof d.getValue!="function"||typeof d.positionAt!="function"?[]:h(d)}}),ie(re[65],ae([0,1,3,33]),function(C,t,n,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LinkComputer=t.StateMachine=t.State=void 0,t.computeLinks=c;var M;(function(e){e[e.Invalid=0]="Invalid",e[e.Start=1]="Start",e[e.H=2]="H",e[e.HT=3]="HT",e[e.HTT=4]="HTT",e[e.HTTP=5]="HTTP",e[e.F=6]="F",e[e.FI=7]="FI",e[e.FIL=8]="FIL",e[e.BeforeColon=9]="BeforeColon",e[e.AfterColon=10]="AfterColon",e[e.AlmostThere=11]="AlmostThere",e[e.End=12]="End",e[e.Accept=13]="Accept",e[e.LastKnownState=14]="LastKnownState"})(M||(t.State=M={}));class m{constructor(u,g,E){const w=new Uint8Array(u*g);for(let v=0,A=u*g;v<A;v++)w[v]=E;this._data=w,this.rows=u,this.cols=g}get(u,g){return this._data[u*this.cols+g]}set(u,g,E){this._data[u*this.cols+g]=E}}class R{constructor(u){let g=0,E=M.Invalid;for(let v=0,A=u.length;v<A;v++){const[L,l,s]=u[v];l>g&&(g=l),L>E&&(E=L),s>E&&(E=s)}g++,E++;const w=new m(E,g,M.Invalid);for(let v=0,A=u.length;v<A;v++){const[L,l,s]=u[v];w.set(L,l,s)}this._states=w,this._maxCharCode=g}nextState(u,g){return g<0||g>=this._maxCharCode?M.Invalid:this._states.get(u,g)}}t.StateMachine=R;let b=null;function o(){return b===null&&(b=new R([[M.Start,n.CharCode.h,M.H],[M.Start,n.CharCode.H,M.H],[M.Start,n.CharCode.f,M.F],[M.Start,n.CharCode.F,M.F],[M.H,n.CharCode.t,M.HT],[M.H,n.CharCode.T,M.HT],[M.HT,n.CharCode.t,M.HTT],[M.HT,n.CharCode.T,M.HTT],[M.HTT,n.CharCode.p,M.HTTP],[M.HTT,n.CharCode.P,M.HTTP],[M.HTTP,n.CharCode.s,M.BeforeColon],[M.HTTP,n.CharCode.S,M.BeforeColon],[M.HTTP,n.CharCode.Colon,M.AfterColon],[M.F,n.CharCode.i,M.FI],[M.F,n.CharCode.I,M.FI],[M.FI,n.CharCode.l,M.FIL],[M.FI,n.CharCode.L,M.FIL],[M.FIL,n.CharCode.e,M.BeforeColon],[M.FIL,n.CharCode.E,M.BeforeColon],[M.BeforeColon,n.CharCode.Colon,M.AfterColon],[M.AfterColon,n.CharCode.Slash,M.AlmostThere],[M.AlmostThere,n.CharCode.Slash,M.End]])),b}var a;(function(e){e[e.None=0]="None",e[e.ForceTermination=1]="ForceTermination",e[e.CannotEndIn=2]="CannotEndIn"})(a||(a={}));let h=null;function _(){if(h===null){h=new i.CharacterClassifier(a.None);const e=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let g=0;g<e.length;g++)h.set(e.charCodeAt(g),a.ForceTermination);const u=".,;:";for(let g=0;g<u.length;g++)h.set(u.charCodeAt(g),a.CannotEndIn)}return h}class d{static _createLink(u,g,E,w,v){let A=v-1;do{const L=g.charCodeAt(A);if(u.get(L)!==a.CannotEndIn)break;A--}while(A>w);if(w>0){const L=g.charCodeAt(w-1),l=g.charCodeAt(A);(L===n.CharCode.OpenParen&&l===n.CharCode.CloseParen||L===n.CharCode.OpenSquareBracket&&l===n.CharCode.CloseSquareBracket||L===n.CharCode.OpenCurlyBrace&&l===n.CharCode.CloseCurlyBrace)&&A--}return{range:{startLineNumber:E,startColumn:w+1,endLineNumber:E,endColumn:A+2},url:g.substring(w,A+1)}}static computeLinks(u,g=o()){const E=_(),w=[];for(let v=1,A=u.getLineCount();v<=A;v++){const L=u.getLineContent(v),l=L.length;let s=0,f=0,p=0,I=M.Start,N=!1,S=!1,D=!1,T=!1;for(;s<l;){let y=!1;const k=L.charCodeAt(s);if(I===M.Accept){let P;switch(k){case n.CharCode.OpenParen:N=!0,P=a.None;break;case n.CharCode.CloseParen:P=N?a.None:a.ForceTermination;break;case n.CharCode.OpenSquareBracket:D=!0,S=!0,P=a.None;break;case n.CharCode.CloseSquareBracket:D=!1,P=S?a.None:a.ForceTermination;break;case n.CharCode.OpenCurlyBrace:T=!0,P=a.None;break;case n.CharCode.CloseCurlyBrace:P=T?a.None:a.ForceTermination;break;case n.CharCode.SingleQuote:case n.CharCode.DoubleQuote:case n.CharCode.BackTick:p===k?P=a.ForceTermination:p===n.CharCode.SingleQuote||p===n.CharCode.DoubleQuote||p===n.CharCode.BackTick?P=a.None:P=a.ForceTermination;break;case n.CharCode.Asterisk:P=p===n.CharCode.Asterisk?a.ForceTermination:a.None;break;case n.CharCode.Pipe:P=p===n.CharCode.Pipe?a.ForceTermination:a.None;break;case n.CharCode.Space:P=D?a.None:a.ForceTermination;break;default:P=E.get(k)}P===a.ForceTermination&&(w.push(d._createLink(E,L,v,f,s)),y=!0)}else if(I===M.End){let P;k===n.CharCode.OpenSquareBracket?(S=!0,P=a.None):P=E.get(k),P===a.ForceTermination?y=!0:I=M.Accept}else I=g.nextState(I,k),I===M.Invalid&&(y=!0);y&&(I=M.Start,N=!1,S=!1,T=!1,f=s+1,p=k),s++}I===M.Accept&&w.push(d._createLink(E,L,v,f,l))}return w}}t.LinkComputer=d;function c(e){return!e||typeof e.getLineCount!="function"||typeof e.getLineContent!="function"?[]:d.computeLinks(e)}}),ie(re[66],ae([0,1]),function(C,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.BasicInplaceReplace=void 0;class n{constructor(){this._defaultValueSet=[["true","false"],["True","False"],["Private","Public","Friend","ReadOnly","Partial","Protected","WriteOnly"],["public","protected","private"]]}static{this.INSTANCE=new n}navigateValueSet(M,m,R,b,o){if(M&&m){const a=this.doNavigateValueSet(m,o);if(a)return{range:M,value:a}}if(R&&b){const a=this.doNavigateValueSet(b,o);if(a)return{range:R,value:a}}return null}doNavigateValueSet(M,m){const R=this.numberReplace(M,m);return R!==null?R:this.textReplace(M,m)}numberReplace(M,m){const R=Math.pow(10,M.length-(M.lastIndexOf(".")+1));let b=Number(M);const o=parseFloat(M);return!isNaN(b)&&!isNaN(o)&&b===o?b===0&&!m?null:(b=Math.floor(b*R),b+=m?R:-R,String(b/R)):null}textReplace(M,m){return this.valueSetsReplace(this._defaultValueSet,M,m)}valueSetsReplace(M,m,R){let b=null;for(let o=0,a=M.length;b===null&&o<a;o++)b=this.valueSetReplace(M[o],m,R);return b}valueSetReplace(M,m,R){let b=M.indexOf(m);return b>=0?(b+=R?1:-1,b<0?b=M.length-1:b%=M.length,M[b]):null}}t.BasicInplaceReplace=n}),ie(re[67],ae([0,1,31]),function(C,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ApplyEditsResult=t.SearchData=t.ValidAnnotatedEditOperation=t.ModelConstants=t.PositionAffinity=t.TrackedRangeStickiness=t.FindMatch=t.TextModelResolvedOptions=t.EndOfLineSequence=t.DefaultEndOfLine=t.EndOfLinePreference=t.InjectedTextCursorStops=t.MinimapSectionHeaderStyle=t.MinimapPosition=t.GlyphMarginLane=t.OverviewRulerLane=void 0,t.isITextSnapshot=e,t.shouldSynchronizeModel=A;var i;(function(L){L[L.Left=1]="Left",L[L.Center=2]="Center",L[L.Right=4]="Right",L[L.Full=7]="Full"})(i||(t.OverviewRulerLane=i={}));var M;(function(L){L[L.Left=1]="Left",L[L.Center=2]="Center",L[L.Right=3]="Right"})(M||(t.GlyphMarginLane=M={}));var m;(function(L){L[L.Inline=1]="Inline",L[L.Gutter=2]="Gutter"})(m||(t.MinimapPosition=m={}));var R;(function(L){L[L.Normal=1]="Normal",L[L.Underlined=2]="Underlined"})(R||(t.MinimapSectionHeaderStyle=R={}));var b;(function(L){L[L.Both=0]="Both",L[L.Right=1]="Right",L[L.Left=2]="Left",L[L.None=3]="None"})(b||(t.InjectedTextCursorStops=b={}));var o;(function(L){L[L.TextDefined=0]="TextDefined",L[L.LF=1]="LF",L[L.CRLF=2]="CRLF"})(o||(t.EndOfLinePreference=o={}));var a;(function(L){L[L.LF=1]="LF",L[L.CRLF=2]="CRLF"})(a||(t.DefaultEndOfLine=a={}));var h;(function(L){L[L.LF=0]="LF",L[L.CRLF=1]="CRLF"})(h||(t.EndOfLineSequence=h={}));class _{get originalIndentSize(){return this._indentSizeIsTabSize?"tabSize":this.indentSize}constructor(l){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,l.tabSize|0),l.indentSize==="tabSize"?(this.indentSize=this.tabSize,this._indentSizeIsTabSize=!0):(this.indentSize=Math.max(1,l.indentSize|0),this._indentSizeIsTabSize=!1),this.insertSpaces=!!l.insertSpaces,this.defaultEOL=l.defaultEOL|0,this.trimAutoWhitespace=!!l.trimAutoWhitespace,this.bracketPairColorizationOptions=l.bracketPairColorizationOptions}equals(l){return this.tabSize===l.tabSize&&this._indentSizeIsTabSize===l._indentSizeIsTabSize&&this.indentSize===l.indentSize&&this.insertSpaces===l.insertSpaces&&this.defaultEOL===l.defaultEOL&&this.trimAutoWhitespace===l.trimAutoWhitespace&&(0,n.equals)(this.bracketPairColorizationOptions,l.bracketPairColorizationOptions)}createChangeEvent(l){return{tabSize:this.tabSize!==l.tabSize,indentSize:this.indentSize!==l.indentSize,insertSpaces:this.insertSpaces!==l.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==l.trimAutoWhitespace}}}t.TextModelResolvedOptions=_;class d{constructor(l,s){this._findMatchBrand=void 0,this.range=l,this.matches=s}}t.FindMatch=d;var c;(function(L){L[L.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",L[L.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",L[L.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",L[L.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(c||(t.TrackedRangeStickiness=c={}));function e(L){return L&&typeof L.read=="function"}var u;(function(L){L[L.Left=0]="Left",L[L.Right=1]="Right",L[L.None=2]="None",L[L.LeftOfInjectedText=3]="LeftOfInjectedText",L[L.RightOfInjectedText=4]="RightOfInjectedText"})(u||(t.PositionAffinity=u={}));var g;(function(L){L[L.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(g||(t.ModelConstants=g={}));class E{constructor(l,s,f,p,I,N){this.identifier=l,this.range=s,this.text=f,this.forceMoveMarkers=p,this.isAutoWhitespaceEdit=I,this._isTracked=N}}t.ValidAnnotatedEditOperation=E;class w{constructor(l,s,f){this.regex=l,this.wordSeparators=s,this.simpleSearch=f}}t.SearchData=w;class v{constructor(l,s,f){this.reverseEdits=l,this.changes=s,this.trimAutoWhitespaceLineNumbers=f}}t.ApplyEditsResult=v;function A(L){return!L.isTooLargeForSyncing()&&!L.isForSimpleWidget}}),ie(re[68],ae([0,1,9,16]),function(C,t,n,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.PrefixSumIndexOfResult=t.ConstantTimePrefixSumComputer=t.PrefixSumComputer=void 0;class M{constructor(o){this.values=o,this.prefixSum=new Uint32Array(o.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}getCount(){return this.values.length}insertValues(o,a){o=(0,i.toUint32)(o);const h=this.values,_=this.prefixSum,d=a.length;return d===0?!1:(this.values=new Uint32Array(h.length+d),this.values.set(h.subarray(0,o),0),this.values.set(h.subarray(o),o+d),this.values.set(a,o),o-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=o-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(_.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}setValue(o,a){return o=(0,i.toUint32)(o),a=(0,i.toUint32)(a),this.values[o]===a?!1:(this.values[o]=a,o-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=o-1),!0)}removeValues(o,a){o=(0,i.toUint32)(o),a=(0,i.toUint32)(a);const h=this.values,_=this.prefixSum;if(o>=h.length)return!1;const d=h.length-o;return a>=d&&(a=d),a===0?!1:(this.values=new Uint32Array(h.length-a),this.values.set(h.subarray(0,o),0),this.values.set(h.subarray(o+a),o),this.prefixSum=new Uint32Array(this.values.length),o-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=o-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(_.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalSum(){return this.values.length===0?0:this._getPrefixSum(this.values.length-1)}getPrefixSum(o){return o<0?0:(o=(0,i.toUint32)(o),this._getPrefixSum(o))}_getPrefixSum(o){if(o<=this.prefixSumValidIndex[0])return this.prefixSum[o];let a=this.prefixSumValidIndex[0]+1;a===0&&(this.prefixSum[0]=this.values[0],a++),o>=this.values.length&&(o=this.values.length-1);for(let h=a;h<=o;h++)this.prefixSum[h]=this.prefixSum[h-1]+this.values[h];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],o),this.prefixSum[o]}getIndexOf(o){o=Math.floor(o),this.getTotalSum();let a=0,h=this.values.length-1,_=0,d=0,c=0;for(;a<=h;)if(_=a+(h-a)/2|0,d=this.prefixSum[_],c=d-this.values[_],o<c)h=_-1;else if(o>=d)a=_+1;else break;return new R(_,o-c)}}t.PrefixSumComputer=M;class m{constructor(o){this._values=o,this._isValid=!1,this._validEndIndex=-1,this._prefixSum=[],this._indexBySum=[]}getTotalSum(){return this._ensureValid(),this._indexBySum.length}getPrefixSum(o){return this._ensureValid(),o===0?0:this._prefixSum[o-1]}getIndexOf(o){this._ensureValid();const a=this._indexBySum[o],h=a>0?this._prefixSum[a-1]:0;return new R(a,o-h)}removeValues(o,a){this._values.splice(o,a),this._invalidate(o)}insertValues(o,a){this._values=(0,n.arrayInsert)(this._values,o,a),this._invalidate(o)}_invalidate(o){this._isValid=!1,this._validEndIndex=Math.min(this._validEndIndex,o-1)}_ensureValid(){if(!this._isValid){for(let o=this._validEndIndex+1,a=this._values.length;o<a;o++){const h=this._values[o],_=o>0?this._prefixSum[o-1]:0;this._prefixSum[o]=_+h;for(let d=0;d<h;d++)this._indexBySum[_+d]=o}this._prefixSum.length=this._values.length,this._indexBySum.length=this._prefixSum[this._prefixSum.length-1],this._isValid=!0,this._validEndIndex=this._values.length-1}}setValue(o,a){this._values[o]!==a&&(this._values[o]=a,this._invalidate(o))}}t.ConstantTimePrefixSumComputer=m;class R{constructor(o,a){this.index=o,this.remainder=a,this._prefixSumIndexOfResultBrand=void 0,this.index=o,this.remainder=a}}t.PrefixSumIndexOfResult=R}),ie(re[69],ae([0,1,6,5,68]),function(C,t,n,i,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.MirrorTextModel=void 0;class m{constructor(b,o,a,h){this._uri=b,this._lines=o,this._eol=a,this._versionId=h,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(b){b.eol&&b.eol!==this._eol&&(this._eol=b.eol,this._lineStarts=null);const o=b.changes;for(const a of o)this._acceptDeleteRange(a.range),this._acceptInsertText(new i.Position(a.range.startLineNumber,a.range.startColumn),a.text);this._versionId=b.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const b=this._eol.length,o=this._lines.length,a=new Uint32Array(o);for(let h=0;h<o;h++)a[h]=this._lines[h].length+b;this._lineStarts=new M.PrefixSumComputer(a)}}_setLineText(b,o){this._lines[b]=o,this._lineStarts&&this._lineStarts.setValue(b,this._lines[b].length+this._eol.length)}_acceptDeleteRange(b){if(b.startLineNumber===b.endLineNumber){if(b.startColumn===b.endColumn)return;this._setLineText(b.startLineNumber-1,this._lines[b.startLineNumber-1].substring(0,b.startColumn-1)+this._lines[b.startLineNumber-1].substring(b.endColumn-1));return}this._setLineText(b.startLineNumber-1,this._lines[b.startLineNumber-1].substring(0,b.startColumn-1)+this._lines[b.endLineNumber-1].substring(b.endColumn-1)),this._lines.splice(b.startLineNumber,b.endLineNumber-b.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(b.startLineNumber,b.endLineNumber-b.startLineNumber)}_acceptInsertText(b,o){if(o.length===0)return;const a=(0,n.splitLines)(o);if(a.length===1){this._setLineText(b.lineNumber-1,this._lines[b.lineNumber-1].substring(0,b.column-1)+a[0]+this._lines[b.lineNumber-1].substring(b.column-1));return}a[a.length-1]+=this._lines[b.lineNumber-1].substring(b.column-1),this._setLineText(b.lineNumber-1,this._lines[b.lineNumber-1].substring(0,b.column-1)+a[0]);const h=new Uint32Array(a.length-1);for(let _=1;_<a.length;_++)this._lines.splice(b.lineNumber+_-1,0,a[_]),h[_-1]=a[_].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(b.lineNumber,h)}}t.MirrorTextModel=m}),ie(re[70],ae([0,1,3,6,56,5,2,67]),function(C,t,n,i,M,m,R,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Searcher=t.TextModelSearch=t.SearchParams=void 0,t.isMultilineRegexSource=h,t.createFindMatch=_,t.isValidMatch=g,i=ye(i);const o=999;class a{constructor(v,A,L,l){this.searchString=v,this.isRegex=A,this.matchCase=L,this.wordSeparators=l}parseSearchRequest(){if(this.searchString==="")return null;let v;this.isRegex?v=h(this.searchString):v=this.searchString.indexOf(`
`)>=0;let A=null;try{A=i.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:v,global:!0,unicode:!0})}catch{return null}if(!A)return null;let L=!this.isRegex&&!v;return L&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(L=this.matchCase),new b.SearchData(A,this.wordSeparators?(0,M.getMapForWordSeparators)(this.wordSeparators,[]):null,L?this.searchString:null)}}t.SearchParams=a;function h(w){if(!w||w.length===0)return!1;for(let v=0,A=w.length;v<A;v++){const L=w.charCodeAt(v);if(L===n.CharCode.LineFeed)return!0;if(L===n.CharCode.Backslash){if(v++,v>=A)break;const l=w.charCodeAt(v);if(l===n.CharCode.n||l===n.CharCode.r||l===n.CharCode.W)return!0}}return!1}function _(w,v,A){if(!A)return new b.FindMatch(w,null);const L=[];for(let l=0,s=v.length;l<s;l++)L[l]=v[l];return new b.FindMatch(w,L)}class d{constructor(v){const A=[];let L=0;for(let l=0,s=v.length;l<s;l++)v.charCodeAt(l)===n.CharCode.LineFeed&&(A[L++]=l);this._lineFeedsOffsets=A}findLineFeedCountBeforeOffset(v){const A=this._lineFeedsOffsets;let L=0,l=A.length-1;if(l===-1||v<=A[0])return 0;for(;L<l;){const s=L+((l-L)/2>>0);A[s]>=v?l=s-1:A[s+1]>=v?(L=s,l=s):L=s+1}return L+1}}class c{static findMatches(v,A,L,l,s){const f=A.parseSearchRequest();return f?f.regex.multiline?this._doFindMatchesMultiline(v,L,new E(f.wordSeparators,f.regex),l,s):this._doFindMatchesLineByLine(v,L,f,l,s):[]}static _getMultilineMatchRange(v,A,L,l,s,f){let p,I=0;l?(I=l.findLineFeedCountBeforeOffset(s),p=A+s+I):p=A+s;let N;if(l){const y=l.findLineFeedCountBeforeOffset(s+f.length)-I;N=p+f.length+y}else N=p+f.length;const S=v.getPositionAt(p),D=v.getPositionAt(N);return new R.Range(S.lineNumber,S.column,D.lineNumber,D.column)}static _doFindMatchesMultiline(v,A,L,l,s){const f=v.getOffsetAt(A.getStartPosition()),p=v.getValueInRange(A,b.EndOfLinePreference.LF),I=v.getEOL()===`\r
`?new d(p):null,N=[];let S=0,D;for(L.reset(0);D=L.next(p);)if(N[S++]=_(this._getMultilineMatchRange(v,f,p,I,D.index,D[0]),D,l),S>=s)return N;return N}static _doFindMatchesLineByLine(v,A,L,l,s){const f=[];let p=0;if(A.startLineNumber===A.endLineNumber){const N=v.getLineContent(A.startLineNumber).substring(A.startColumn-1,A.endColumn-1);return p=this._findMatchesInLine(L,N,A.startLineNumber,A.startColumn-1,p,f,l,s),f}const I=v.getLineContent(A.startLineNumber).substring(A.startColumn-1);p=this._findMatchesInLine(L,I,A.startLineNumber,A.startColumn-1,p,f,l,s);for(let N=A.startLineNumber+1;N<A.endLineNumber&&p<s;N++)p=this._findMatchesInLine(L,v.getLineContent(N),N,0,p,f,l,s);if(p<s){const N=v.getLineContent(A.endLineNumber).substring(0,A.endColumn-1);p=this._findMatchesInLine(L,N,A.endLineNumber,0,p,f,l,s)}return f}static _findMatchesInLine(v,A,L,l,s,f,p,I){const N=v.wordSeparators;if(!p&&v.simpleSearch){const T=v.simpleSearch,y=T.length,k=A.length;let P=-y;for(;(P=A.indexOf(T,P+y))!==-1;)if((!N||g(N,A,k,P,y))&&(f[s++]=new b.FindMatch(new R.Range(L,P+1+l,L,P+1+y+l),null),s>=I))return s;return s}const S=new E(v.wordSeparators,v.regex);let D;S.reset(0);do if(D=S.next(A),D&&(f[s++]=_(new R.Range(L,D.index+1+l,L,D.index+1+D[0].length+l),D,p),s>=I))return s;while(D);return s}static findNextMatch(v,A,L,l){const s=A.parseSearchRequest();if(!s)return null;const f=new E(s.wordSeparators,s.regex);return s.regex.multiline?this._doFindNextMatchMultiline(v,L,f,l):this._doFindNextMatchLineByLine(v,L,f,l)}static _doFindNextMatchMultiline(v,A,L,l){const s=new m.Position(A.lineNumber,1),f=v.getOffsetAt(s),p=v.getLineCount(),I=v.getValueInRange(new R.Range(s.lineNumber,s.column,p,v.getLineMaxColumn(p)),b.EndOfLinePreference.LF),N=v.getEOL()===`\r
`?new d(I):null;L.reset(A.column-1);const S=L.next(I);return S?_(this._getMultilineMatchRange(v,f,I,N,S.index,S[0]),S,l):A.lineNumber!==1||A.column!==1?this._doFindNextMatchMultiline(v,new m.Position(1,1),L,l):null}static _doFindNextMatchLineByLine(v,A,L,l){const s=v.getLineCount(),f=A.lineNumber,p=v.getLineContent(f),I=this._findFirstMatchInLine(L,p,f,A.column,l);if(I)return I;for(let N=1;N<=s;N++){const S=(f+N-1)%s,D=v.getLineContent(S+1),T=this._findFirstMatchInLine(L,D,S+1,1,l);if(T)return T}return null}static _findFirstMatchInLine(v,A,L,l,s){v.reset(l-1);const f=v.next(A);return f?_(new R.Range(L,f.index+1,L,f.index+1+f[0].length),f,s):null}static findPreviousMatch(v,A,L,l){const s=A.parseSearchRequest();if(!s)return null;const f=new E(s.wordSeparators,s.regex);return s.regex.multiline?this._doFindPreviousMatchMultiline(v,L,f,l):this._doFindPreviousMatchLineByLine(v,L,f,l)}static _doFindPreviousMatchMultiline(v,A,L,l){const s=this._doFindMatchesMultiline(v,new R.Range(1,1,A.lineNumber,A.column),L,l,10*o);if(s.length>0)return s[s.length-1];const f=v.getLineCount();return A.lineNumber!==f||A.column!==v.getLineMaxColumn(f)?this._doFindPreviousMatchMultiline(v,new m.Position(f,v.getLineMaxColumn(f)),L,l):null}static _doFindPreviousMatchLineByLine(v,A,L,l){const s=v.getLineCount(),f=A.lineNumber,p=v.getLineContent(f).substring(0,A.column-1),I=this._findLastMatchInLine(L,p,f,l);if(I)return I;for(let N=1;N<=s;N++){const S=(s+f-N-1)%s,D=v.getLineContent(S+1),T=this._findLastMatchInLine(L,D,S+1,l);if(T)return T}return null}static _findLastMatchInLine(v,A,L,l){let s=null,f;for(v.reset(0);f=v.next(A);)s=_(new R.Range(L,f.index+1,L,f.index+1+f[0].length),f,l);return s}}t.TextModelSearch=c;function e(w,v,A,L,l){if(L===0)return!0;const s=v.charCodeAt(L-1);if(w.get(s)!==M.WordCharacterClass.Regular||s===n.CharCode.CarriageReturn||s===n.CharCode.LineFeed)return!0;if(l>0){const f=v.charCodeAt(L);if(w.get(f)!==M.WordCharacterClass.Regular)return!0}return!1}function u(w,v,A,L,l){if(L+l===A)return!0;const s=v.charCodeAt(L+l);if(w.get(s)!==M.WordCharacterClass.Regular||s===n.CharCode.CarriageReturn||s===n.CharCode.LineFeed)return!0;if(l>0){const f=v.charCodeAt(L+l-1);if(w.get(f)!==M.WordCharacterClass.Regular)return!0}return!1}function g(w,v,A,L,l){return e(w,v,A,L,l)&&u(w,v,A,L,l)}class E{constructor(v,A){this._wordSeparators=v,this._searchRegex=A,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(v){this._searchRegex.lastIndex=v,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(v){const A=v.length;let L;do{if(this._prevMatchStartIndex+this._prevMatchLength===A||(L=this._searchRegex.exec(v),!L))return null;const l=L.index,s=L[0].length;if(l===this._prevMatchStartIndex&&s===this._prevMatchLength){if(s===0){i.getNextCodePoint(v,A,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=l,this._prevMatchLength=s,!this._wordSeparators||g(this._wordSeparators,v,A,l,s))return L}while(L);return null}}t.Searcher=E}),ie(re[71],ae([0,1]),function(C,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.EditorWorkerHost=void 0;class n{static{this.CHANNEL_NAME="editorWorkerHost"}static getChannel(M){return M.getChannel(n.CHANNEL_NAME)}static setChannel(M,m){M.setChannel(n.CHANNEL_NAME,m)}}t.EditorWorkerHost=n}),ie(re[72],ae([0,1]),function(C,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.findSectionHeaders=M;const n=new RegExp("\\bMARK:\\s*(.*)$","d"),i=/^-+|-+$/g;function M(a,h){let _=[];if(h.findRegionSectionHeaders&&h.foldingRules?.markers){const d=m(a,h);_=_.concat(d)}if(h.findMarkSectionHeaders){const d=R(a);_=_.concat(d)}return _}function m(a,h){const _=[],d=a.getLineCount();for(let c=1;c<=d;c++){const e=a.getLineContent(c),u=e.match(h.foldingRules.markers.start);if(u){const g={startLineNumber:c,startColumn:u[0].length+1,endLineNumber:c,endColumn:e.length+1};if(g.endColumn>g.startColumn){const E={range:g,...o(e.substring(u[0].length)),shouldBeInComments:!1};(E.text||E.hasSeparatorLine)&&_.push(E)}}}return _}function R(a){const h=[],_=a.getLineCount();for(let d=1;d<=_;d++){const c=a.getLineContent(d);b(c,d,h)}return h}function b(a,h,_){n.lastIndex=0;const d=n.exec(a);if(d){const c=d.indices[1][0]+1,e=d.indices[1][1]+1,u={startLineNumber:h,startColumn:c,endLineNumber:h,endColumn:e};if(u.endColumn>u.startColumn){const g={range:u,...o(d[1]),shouldBeInComments:!0};(g.text||g.hasSeparatorLine)&&_.push(g)}}}function o(a){a=a.trim();const h=a.startsWith("-");return a=a.replace(i,""),{text:a,hasSeparatorLine:h}}}),ie(re[73],ae([0,1,2,70,6,15,35]),function(C,t,n,i,M,m,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.UnicodeHighlighterReasonKind=t.UnicodeTextModelHighlighter=void 0,M=ye(M);class b{static computeUnicodeHighlights(e,u,g){const E=g?g.startLineNumber:1,w=g?g.endLineNumber:e.getLineCount(),v=new h(u),A=v.getCandidateCodePoints();let L;A==="allNonBasicAscii"?L=new RegExp("[^\\t\\n\\r\\x20-\\x7E]","g"):L=new RegExp(`${o(Array.from(A))}`,"g");const l=new i.Searcher(null,L),s=[];let f=!1,p,I=0,N=0,S=0;e:for(let D=E,T=w;D<=T;D++){const y=e.getLineContent(D),k=y.length;l.reset(0);do if(p=l.next(y),p){let P=p.index,q=p.index+p[0].length;if(P>0){const J=y.charCodeAt(P-1);M.isHighSurrogate(J)&&P--}if(q+1<k){const J=y.charCodeAt(q-1);M.isHighSurrogate(J)&&q++}const j=y.substring(P,q);let H=(0,R.getWordAtText)(P+1,R.DEFAULT_WORD_REGEXP,y,0);H&&H.endColumn<=P+1&&(H=null);const W=v.shouldHighlightNonBasicASCII(j,H?H.word:null);if(W!==d.None){if(W===d.Ambiguous?I++:W===d.Invisible?N++:W===d.NonBasicASCII?S++:(0,m.assertNever)(W),s.length>=1e3){f=!0;break e}s.push(new n.Range(D,P+1,D,q+1))}}while(p)}return{ranges:s,hasMore:f,ambiguousCharacterCount:I,invisibleCharacterCount:N,nonBasicAsciiCharacterCount:S}}static computeUnicodeHighlightReason(e,u){const g=new h(u);switch(g.shouldHighlightNonBasicASCII(e,null)){case d.None:return null;case d.Invisible:return{kind:a.Invisible};case d.Ambiguous:{const w=e.codePointAt(0),v=g.ambiguousCharacters.getPrimaryConfusable(w),A=M.AmbiguousCharacters.getLocales().filter(L=>!M.AmbiguousCharacters.getInstance(new Set([...u.allowedLocales,L])).isAmbiguous(w));return{kind:a.Ambiguous,confusableWith:String.fromCodePoint(v),notAmbiguousInLocales:A}}case d.NonBasicASCII:return{kind:a.NonBasicAscii}}}}t.UnicodeTextModelHighlighter=b;function o(c,e){return`[${M.escapeRegExpCharacters(c.map(g=>String.fromCodePoint(g)).join(""))}]`}var a;(function(c){c[c.Ambiguous=0]="Ambiguous",c[c.Invisible=1]="Invisible",c[c.NonBasicAscii=2]="NonBasicAscii"})(a||(t.UnicodeHighlighterReasonKind=a={}));class h{constructor(e){this.options=e,this.allowedCodePoints=new Set(e.allowedCodePoints),this.ambiguousCharacters=M.AmbiguousCharacters.getInstance(new Set(e.allowedLocales))}getCandidateCodePoints(){if(this.options.nonBasicASCII)return"allNonBasicAscii";const e=new Set;if(this.options.invisibleCharacters)for(const u of M.InvisibleCharacters.codePoints)_(String.fromCodePoint(u))||e.add(u);if(this.options.ambiguousCharacters)for(const u of this.ambiguousCharacters.getConfusableCodePoints())e.add(u);for(const u of this.allowedCodePoints)e.delete(u);return e}shouldHighlightNonBasicASCII(e,u){const g=e.codePointAt(0);if(this.allowedCodePoints.has(g))return d.None;if(this.options.nonBasicASCII)return d.NonBasicASCII;let E=!1,w=!1;if(u)for(const v of u){const A=v.codePointAt(0),L=M.isBasicASCII(v);E=E||L,!L&&!this.ambiguousCharacters.isAmbiguous(A)&&!M.InvisibleCharacters.isInvisibleCharacter(A)&&(w=!0)}return!E&&w?d.None:this.options.invisibleCharacters&&!_(e)&&M.InvisibleCharacters.isInvisibleCharacter(g)?d.Invisible:this.options.ambiguousCharacters&&this.ambiguousCharacters.isAmbiguous(g)?d.Ambiguous:d.None}}function _(c){return c===" "||c===`
`||c==="	"}var d;(function(c){c[c.None=0]="None",c[c.NonBasicASCII=1]="NonBasicASCII",c[c.Invisible=2]="Invisible",c[c.Ambiguous=3]="Ambiguous"})(d||(d={}))}),ie(re[74],ae([0,1]),function(C,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.WrappingIndent=t.TrackedRangeStickiness=t.TextEditorCursorStyle=t.TextEditorCursorBlinkingStyle=t.SymbolTag=t.SymbolKind=t.SignatureHelpTriggerKind=t.ShowLightbulbIconMode=t.SelectionDirection=t.ScrollbarVisibility=t.ScrollType=t.RenderMinimap=t.RenderLineNumbersType=t.PositionAffinity=t.PartialAcceptTriggerKind=t.OverviewRulerLane=t.OverlayWidgetPositionPreference=t.NewSymbolNameTriggerKind=t.NewSymbolNameTag=t.MouseTargetType=t.MinimapSectionHeaderStyle=t.MinimapPosition=t.MarkerTag=t.MarkerSeverity=t.KeyCode=t.InlineEditTriggerKind=t.InlineCompletionTriggerKind=t.InlayHintKind=t.InjectedTextCursorStops=t.IndentAction=t.HoverVerbosityAction=t.GlyphMarginLane=t.EndOfLineSequence=t.EndOfLinePreference=t.EditorOption=t.EditorAutoIndentStrategy=t.DocumentHighlightKind=t.DefaultEndOfLine=t.CursorChangeReason=t.ContentWidgetPositionPreference=t.CompletionTriggerKind=t.CompletionItemTag=t.CompletionItemKind=t.CompletionItemInsertTextRule=t.CodeActionTriggerType=t.AccessibilitySupport=void 0;var n;(function(r){r[r.Unknown=0]="Unknown",r[r.Disabled=1]="Disabled",r[r.Enabled=2]="Enabled"})(n||(t.AccessibilitySupport=n={}));var i;(function(r){r[r.Invoke=1]="Invoke",r[r.Auto=2]="Auto"})(i||(t.CodeActionTriggerType=i={}));var M;(function(r){r[r.None=0]="None",r[r.KeepWhitespace=1]="KeepWhitespace",r[r.InsertAsSnippet=4]="InsertAsSnippet"})(M||(t.CompletionItemInsertTextRule=M={}));var m;(function(r){r[r.Method=0]="Method",r[r.Function=1]="Function",r[r.Constructor=2]="Constructor",r[r.Field=3]="Field",r[r.Variable=4]="Variable",r[r.Class=5]="Class",r[r.Struct=6]="Struct",r[r.Interface=7]="Interface",r[r.Module=8]="Module",r[r.Property=9]="Property",r[r.Event=10]="Event",r[r.Operator=11]="Operator",r[r.Unit=12]="Unit",r[r.Value=13]="Value",r[r.Constant=14]="Constant",r[r.Enum=15]="Enum",r[r.EnumMember=16]="EnumMember",r[r.Keyword=17]="Keyword",r[r.Text=18]="Text",r[r.Color=19]="Color",r[r.File=20]="File",r[r.Reference=21]="Reference",r[r.Customcolor=22]="Customcolor",r[r.Folder=23]="Folder",r[r.TypeParameter=24]="TypeParameter",r[r.User=25]="User",r[r.Issue=26]="Issue",r[r.Snippet=27]="Snippet"})(m||(t.CompletionItemKind=m={}));var R;(function(r){r[r.Deprecated=1]="Deprecated"})(R||(t.CompletionItemTag=R={}));var b;(function(r){r[r.Invoke=0]="Invoke",r[r.TriggerCharacter=1]="TriggerCharacter",r[r.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(b||(t.CompletionTriggerKind=b={}));var o;(function(r){r[r.EXACT=0]="EXACT",r[r.ABOVE=1]="ABOVE",r[r.BELOW=2]="BELOW"})(o||(t.ContentWidgetPositionPreference=o={}));var a;(function(r){r[r.NotSet=0]="NotSet",r[r.ContentFlush=1]="ContentFlush",r[r.RecoverFromMarkers=2]="RecoverFromMarkers",r[r.Explicit=3]="Explicit",r[r.Paste=4]="Paste",r[r.Undo=5]="Undo",r[r.Redo=6]="Redo"})(a||(t.CursorChangeReason=a={}));var h;(function(r){r[r.LF=1]="LF",r[r.CRLF=2]="CRLF"})(h||(t.DefaultEndOfLine=h={}));var _;(function(r){r[r.Text=0]="Text",r[r.Read=1]="Read",r[r.Write=2]="Write"})(_||(t.DocumentHighlightKind=_={}));var d;(function(r){r[r.None=0]="None",r[r.Keep=1]="Keep",r[r.Brackets=2]="Brackets",r[r.Advanced=3]="Advanced",r[r.Full=4]="Full"})(d||(t.EditorAutoIndentStrategy=d={}));var c;(function(r){r[r.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",r[r.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",r[r.accessibilitySupport=2]="accessibilitySupport",r[r.accessibilityPageSize=3]="accessibilityPageSize",r[r.ariaLabel=4]="ariaLabel",r[r.ariaRequired=5]="ariaRequired",r[r.autoClosingBrackets=6]="autoClosingBrackets",r[r.autoClosingComments=7]="autoClosingComments",r[r.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",r[r.autoClosingDelete=9]="autoClosingDelete",r[r.autoClosingOvertype=10]="autoClosingOvertype",r[r.autoClosingQuotes=11]="autoClosingQuotes",r[r.autoIndent=12]="autoIndent",r[r.automaticLayout=13]="automaticLayout",r[r.autoSurround=14]="autoSurround",r[r.bracketPairColorization=15]="bracketPairColorization",r[r.guides=16]="guides",r[r.codeLens=17]="codeLens",r[r.codeLensFontFamily=18]="codeLensFontFamily",r[r.codeLensFontSize=19]="codeLensFontSize",r[r.colorDecorators=20]="colorDecorators",r[r.colorDecoratorsLimit=21]="colorDecoratorsLimit",r[r.columnSelection=22]="columnSelection",r[r.comments=23]="comments",r[r.contextmenu=24]="contextmenu",r[r.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",r[r.cursorBlinking=26]="cursorBlinking",r[r.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",r[r.cursorStyle=28]="cursorStyle",r[r.cursorSurroundingLines=29]="cursorSurroundingLines",r[r.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",r[r.cursorWidth=31]="cursorWidth",r[r.disableLayerHinting=32]="disableLayerHinting",r[r.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",r[r.domReadOnly=34]="domReadOnly",r[r.dragAndDrop=35]="dragAndDrop",r[r.dropIntoEditor=36]="dropIntoEditor",r[r.emptySelectionClipboard=37]="emptySelectionClipboard",r[r.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",r[r.extraEditorClassName=39]="extraEditorClassName",r[r.fastScrollSensitivity=40]="fastScrollSensitivity",r[r.find=41]="find",r[r.fixedOverflowWidgets=42]="fixedOverflowWidgets",r[r.folding=43]="folding",r[r.foldingStrategy=44]="foldingStrategy",r[r.foldingHighlight=45]="foldingHighlight",r[r.foldingImportsByDefault=46]="foldingImportsByDefault",r[r.foldingMaximumRegions=47]="foldingMaximumRegions",r[r.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",r[r.fontFamily=49]="fontFamily",r[r.fontInfo=50]="fontInfo",r[r.fontLigatures=51]="fontLigatures",r[r.fontSize=52]="fontSize",r[r.fontWeight=53]="fontWeight",r[r.fontVariations=54]="fontVariations",r[r.formatOnPaste=55]="formatOnPaste",r[r.formatOnType=56]="formatOnType",r[r.glyphMargin=57]="glyphMargin",r[r.gotoLocation=58]="gotoLocation",r[r.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",r[r.hover=60]="hover",r[r.inDiffEditor=61]="inDiffEditor",r[r.inlineSuggest=62]="inlineSuggest",r[r.inlineEdit=63]="inlineEdit",r[r.letterSpacing=64]="letterSpacing",r[r.lightbulb=65]="lightbulb",r[r.lineDecorationsWidth=66]="lineDecorationsWidth",r[r.lineHeight=67]="lineHeight",r[r.lineNumbers=68]="lineNumbers",r[r.lineNumbersMinChars=69]="lineNumbersMinChars",r[r.linkedEditing=70]="linkedEditing",r[r.links=71]="links",r[r.matchBrackets=72]="matchBrackets",r[r.minimap=73]="minimap",r[r.mouseStyle=74]="mouseStyle",r[r.mouseWheelScrollSensitivity=75]="mouseWheelScrollSensitivity",r[r.mouseWheelZoom=76]="mouseWheelZoom",r[r.multiCursorMergeOverlapping=77]="multiCursorMergeOverlapping",r[r.multiCursorModifier=78]="multiCursorModifier",r[r.multiCursorPaste=79]="multiCursorPaste",r[r.multiCursorLimit=80]="multiCursorLimit",r[r.occurrencesHighlight=81]="occurrencesHighlight",r[r.overviewRulerBorder=82]="overviewRulerBorder",r[r.overviewRulerLanes=83]="overviewRulerLanes",r[r.padding=84]="padding",r[r.pasteAs=85]="pasteAs",r[r.parameterHints=86]="parameterHints",r[r.peekWidgetDefaultFocus=87]="peekWidgetDefaultFocus",r[r.placeholder=88]="placeholder",r[r.definitionLinkOpensInPeek=89]="definitionLinkOpensInPeek",r[r.quickSuggestions=90]="quickSuggestions",r[r.quickSuggestionsDelay=91]="quickSuggestionsDelay",r[r.readOnly=92]="readOnly",r[r.readOnlyMessage=93]="readOnlyMessage",r[r.renameOnType=94]="renameOnType",r[r.renderControlCharacters=95]="renderControlCharacters",r[r.renderFinalNewline=96]="renderFinalNewline",r[r.renderLineHighlight=97]="renderLineHighlight",r[r.renderLineHighlightOnlyWhenFocus=98]="renderLineHighlightOnlyWhenFocus",r[r.renderValidationDecorations=99]="renderValidationDecorations",r[r.renderWhitespace=100]="renderWhitespace",r[r.revealHorizontalRightPadding=101]="revealHorizontalRightPadding",r[r.roundedSelection=102]="roundedSelection",r[r.rulers=103]="rulers",r[r.scrollbar=104]="scrollbar",r[r.scrollBeyondLastColumn=105]="scrollBeyondLastColumn",r[r.scrollBeyondLastLine=106]="scrollBeyondLastLine",r[r.scrollPredominantAxis=107]="scrollPredominantAxis",r[r.selectionClipboard=108]="selectionClipboard",r[r.selectionHighlight=109]="selectionHighlight",r[r.selectOnLineNumbers=110]="selectOnLineNumbers",r[r.showFoldingControls=111]="showFoldingControls",r[r.showUnused=112]="showUnused",r[r.snippetSuggestions=113]="snippetSuggestions",r[r.smartSelect=114]="smartSelect",r[r.smoothScrolling=115]="smoothScrolling",r[r.stickyScroll=116]="stickyScroll",r[r.stickyTabStops=117]="stickyTabStops",r[r.stopRenderingLineAfter=118]="stopRenderingLineAfter",r[r.suggest=119]="suggest",r[r.suggestFontSize=120]="suggestFontSize",r[r.suggestLineHeight=121]="suggestLineHeight",r[r.suggestOnTriggerCharacters=122]="suggestOnTriggerCharacters",r[r.suggestSelection=123]="suggestSelection",r[r.tabCompletion=124]="tabCompletion",r[r.tabIndex=125]="tabIndex",r[r.unicodeHighlighting=126]="unicodeHighlighting",r[r.unusualLineTerminators=127]="unusualLineTerminators",r[r.useShadowDOM=128]="useShadowDOM",r[r.useTabStops=129]="useTabStops",r[r.wordBreak=130]="wordBreak",r[r.wordSegmenterLocales=131]="wordSegmenterLocales",r[r.wordSeparators=132]="wordSeparators",r[r.wordWrap=133]="wordWrap",r[r.wordWrapBreakAfterCharacters=134]="wordWrapBreakAfterCharacters",r[r.wordWrapBreakBeforeCharacters=135]="wordWrapBreakBeforeCharacters",r[r.wordWrapColumn=136]="wordWrapColumn",r[r.wordWrapOverride1=137]="wordWrapOverride1",r[r.wordWrapOverride2=138]="wordWrapOverride2",r[r.wrappingIndent=139]="wrappingIndent",r[r.wrappingStrategy=140]="wrappingStrategy",r[r.showDeprecated=141]="showDeprecated",r[r.inlayHints=142]="inlayHints",r[r.editorClassName=143]="editorClassName",r[r.pixelRatio=144]="pixelRatio",r[r.tabFocusMode=145]="tabFocusMode",r[r.layoutInfo=146]="layoutInfo",r[r.wrappingInfo=147]="wrappingInfo",r[r.defaultColorDecorators=148]="defaultColorDecorators",r[r.colorDecoratorsActivatedOn=149]="colorDecoratorsActivatedOn",r[r.inlineCompletionsAccessibilityVerbose=150]="inlineCompletionsAccessibilityVerbose"})(c||(t.EditorOption=c={}));var e;(function(r){r[r.TextDefined=0]="TextDefined",r[r.LF=1]="LF",r[r.CRLF=2]="CRLF"})(e||(t.EndOfLinePreference=e={}));var u;(function(r){r[r.LF=0]="LF",r[r.CRLF=1]="CRLF"})(u||(t.EndOfLineSequence=u={}));var g;(function(r){r[r.Left=1]="Left",r[r.Center=2]="Center",r[r.Right=3]="Right"})(g||(t.GlyphMarginLane=g={}));var E;(function(r){r[r.Increase=0]="Increase",r[r.Decrease=1]="Decrease"})(E||(t.HoverVerbosityAction=E={}));var w;(function(r){r[r.None=0]="None",r[r.Indent=1]="Indent",r[r.IndentOutdent=2]="IndentOutdent",r[r.Outdent=3]="Outdent"})(w||(t.IndentAction=w={}));var v;(function(r){r[r.Both=0]="Both",r[r.Right=1]="Right",r[r.Left=2]="Left",r[r.None=3]="None"})(v||(t.InjectedTextCursorStops=v={}));var A;(function(r){r[r.Type=1]="Type",r[r.Parameter=2]="Parameter"})(A||(t.InlayHintKind=A={}));var L;(function(r){r[r.Automatic=0]="Automatic",r[r.Explicit=1]="Explicit"})(L||(t.InlineCompletionTriggerKind=L={}));var l;(function(r){r[r.Invoke=0]="Invoke",r[r.Automatic=1]="Automatic"})(l||(t.InlineEditTriggerKind=l={}));var s;(function(r){r[r.DependsOnKbLayout=-1]="DependsOnKbLayout",r[r.Unknown=0]="Unknown",r[r.Backspace=1]="Backspace",r[r.Tab=2]="Tab",r[r.Enter=3]="Enter",r[r.Shift=4]="Shift",r[r.Ctrl=5]="Ctrl",r[r.Alt=6]="Alt",r[r.PauseBreak=7]="PauseBreak",r[r.CapsLock=8]="CapsLock",r[r.Escape=9]="Escape",r[r.Space=10]="Space",r[r.PageUp=11]="PageUp",r[r.PageDown=12]="PageDown",r[r.End=13]="End",r[r.Home=14]="Home",r[r.LeftArrow=15]="LeftArrow",r[r.UpArrow=16]="UpArrow",r[r.RightArrow=17]="RightArrow",r[r.DownArrow=18]="DownArrow",r[r.Insert=19]="Insert",r[r.Delete=20]="Delete",r[r.Digit0=21]="Digit0",r[r.Digit1=22]="Digit1",r[r.Digit2=23]="Digit2",r[r.Digit3=24]="Digit3",r[r.Digit4=25]="Digit4",r[r.Digit5=26]="Digit5",r[r.Digit6=27]="Digit6",r[r.Digit7=28]="Digit7",r[r.Digit8=29]="Digit8",r[r.Digit9=30]="Digit9",r[r.KeyA=31]="KeyA",r[r.KeyB=32]="KeyB",r[r.KeyC=33]="KeyC",r[r.KeyD=34]="KeyD",r[r.KeyE=35]="KeyE",r[r.KeyF=36]="KeyF",r[r.KeyG=37]="KeyG",r[r.KeyH=38]="KeyH",r[r.KeyI=39]="KeyI",r[r.KeyJ=40]="KeyJ",r[r.KeyK=41]="KeyK",r[r.KeyL=42]="KeyL",r[r.KeyM=43]="KeyM",r[r.KeyN=44]="KeyN",r[r.KeyO=45]="KeyO",r[r.KeyP=46]="KeyP",r[r.KeyQ=47]="KeyQ",r[r.KeyR=48]="KeyR",r[r.KeyS=49]="KeyS",r[r.KeyT=50]="KeyT",r[r.KeyU=51]="KeyU",r[r.KeyV=52]="KeyV",r[r.KeyW=53]="KeyW",r[r.KeyX=54]="KeyX",r[r.KeyY=55]="KeyY",r[r.KeyZ=56]="KeyZ",r[r.Meta=57]="Meta",r[r.ContextMenu=58]="ContextMenu",r[r.F1=59]="F1",r[r.F2=60]="F2",r[r.F3=61]="F3",r[r.F4=62]="F4",r[r.F5=63]="F5",r[r.F6=64]="F6",r[r.F7=65]="F7",r[r.F8=66]="F8",r[r.F9=67]="F9",r[r.F10=68]="F10",r[r.F11=69]="F11",r[r.F12=70]="F12",r[r.F13=71]="F13",r[r.F14=72]="F14",r[r.F15=73]="F15",r[r.F16=74]="F16",r[r.F17=75]="F17",r[r.F18=76]="F18",r[r.F19=77]="F19",r[r.F20=78]="F20",r[r.F21=79]="F21",r[r.F22=80]="F22",r[r.F23=81]="F23",r[r.F24=82]="F24",r[r.NumLock=83]="NumLock",r[r.ScrollLock=84]="ScrollLock",r[r.Semicolon=85]="Semicolon",r[r.Equal=86]="Equal",r[r.Comma=87]="Comma",r[r.Minus=88]="Minus",r[r.Period=89]="Period",r[r.Slash=90]="Slash",r[r.Backquote=91]="Backquote",r[r.BracketLeft=92]="BracketLeft",r[r.Backslash=93]="Backslash",r[r.BracketRight=94]="BracketRight",r[r.Quote=95]="Quote",r[r.OEM_8=96]="OEM_8",r[r.IntlBackslash=97]="IntlBackslash",r[r.Numpad0=98]="Numpad0",r[r.Numpad1=99]="Numpad1",r[r.Numpad2=100]="Numpad2",r[r.Numpad3=101]="Numpad3",r[r.Numpad4=102]="Numpad4",r[r.Numpad5=103]="Numpad5",r[r.Numpad6=104]="Numpad6",r[r.Numpad7=105]="Numpad7",r[r.Numpad8=106]="Numpad8",r[r.Numpad9=107]="Numpad9",r[r.NumpadMultiply=108]="NumpadMultiply",r[r.NumpadAdd=109]="NumpadAdd",r[r.NUMPAD_SEPARATOR=110]="NUMPAD_SEPARATOR",r[r.NumpadSubtract=111]="NumpadSubtract",r[r.NumpadDecimal=112]="NumpadDecimal",r[r.NumpadDivide=113]="NumpadDivide",r[r.KEY_IN_COMPOSITION=114]="KEY_IN_COMPOSITION",r[r.ABNT_C1=115]="ABNT_C1",r[r.ABNT_C2=116]="ABNT_C2",r[r.AudioVolumeMute=117]="AudioVolumeMute",r[r.AudioVolumeUp=118]="AudioVolumeUp",r[r.AudioVolumeDown=119]="AudioVolumeDown",r[r.BrowserSearch=120]="BrowserSearch",r[r.BrowserHome=121]="BrowserHome",r[r.BrowserBack=122]="BrowserBack",r[r.BrowserForward=123]="BrowserForward",r[r.MediaTrackNext=124]="MediaTrackNext",r[r.MediaTrackPrevious=125]="MediaTrackPrevious",r[r.MediaStop=126]="MediaStop",r[r.MediaPlayPause=127]="MediaPlayPause",r[r.LaunchMediaPlayer=128]="LaunchMediaPlayer",r[r.LaunchMail=129]="LaunchMail",r[r.LaunchApp2=130]="LaunchApp2",r[r.Clear=131]="Clear",r[r.MAX_VALUE=132]="MAX_VALUE"})(s||(t.KeyCode=s={}));var f;(function(r){r[r.Hint=1]="Hint",r[r.Info=2]="Info",r[r.Warning=4]="Warning",r[r.Error=8]="Error"})(f||(t.MarkerSeverity=f={}));var p;(function(r){r[r.Unnecessary=1]="Unnecessary",r[r.Deprecated=2]="Deprecated"})(p||(t.MarkerTag=p={}));var I;(function(r){r[r.Inline=1]="Inline",r[r.Gutter=2]="Gutter"})(I||(t.MinimapPosition=I={}));var N;(function(r){r[r.Normal=1]="Normal",r[r.Underlined=2]="Underlined"})(N||(t.MinimapSectionHeaderStyle=N={}));var S;(function(r){r[r.UNKNOWN=0]="UNKNOWN",r[r.TEXTAREA=1]="TEXTAREA",r[r.GUTTER_GLYPH_MARGIN=2]="GUTTER_GLYPH_MARGIN",r[r.GUTTER_LINE_NUMBERS=3]="GUTTER_LINE_NUMBERS",r[r.GUTTER_LINE_DECORATIONS=4]="GUTTER_LINE_DECORATIONS",r[r.GUTTER_VIEW_ZONE=5]="GUTTER_VIEW_ZONE",r[r.CONTENT_TEXT=6]="CONTENT_TEXT",r[r.CONTENT_EMPTY=7]="CONTENT_EMPTY",r[r.CONTENT_VIEW_ZONE=8]="CONTENT_VIEW_ZONE",r[r.CONTENT_WIDGET=9]="CONTENT_WIDGET",r[r.OVERVIEW_RULER=10]="OVERVIEW_RULER",r[r.SCROLLBAR=11]="SCROLLBAR",r[r.OVERLAY_WIDGET=12]="OVERLAY_WIDGET",r[r.OUTSIDE_EDITOR=13]="OUTSIDE_EDITOR"})(S||(t.MouseTargetType=S={}));var D;(function(r){r[r.AIGenerated=1]="AIGenerated"})(D||(t.NewSymbolNameTag=D={}));var T;(function(r){r[r.Invoke=0]="Invoke",r[r.Automatic=1]="Automatic"})(T||(t.NewSymbolNameTriggerKind=T={}));var y;(function(r){r[r.TOP_RIGHT_CORNER=0]="TOP_RIGHT_CORNER",r[r.BOTTOM_RIGHT_CORNER=1]="BOTTOM_RIGHT_CORNER",r[r.TOP_CENTER=2]="TOP_CENTER"})(y||(t.OverlayWidgetPositionPreference=y={}));var k;(function(r){r[r.Left=1]="Left",r[r.Center=2]="Center",r[r.Right=4]="Right",r[r.Full=7]="Full"})(k||(t.OverviewRulerLane=k={}));var P;(function(r){r[r.Word=0]="Word",r[r.Line=1]="Line",r[r.Suggest=2]="Suggest"})(P||(t.PartialAcceptTriggerKind=P={}));var q;(function(r){r[r.Left=0]="Left",r[r.Right=1]="Right",r[r.None=2]="None",r[r.LeftOfInjectedText=3]="LeftOfInjectedText",r[r.RightOfInjectedText=4]="RightOfInjectedText"})(q||(t.PositionAffinity=q={}));var j;(function(r){r[r.Off=0]="Off",r[r.On=1]="On",r[r.Relative=2]="Relative",r[r.Interval=3]="Interval",r[r.Custom=4]="Custom"})(j||(t.RenderLineNumbersType=j={}));var H;(function(r){r[r.None=0]="None",r[r.Text=1]="Text",r[r.Blocks=2]="Blocks"})(H||(t.RenderMinimap=H={}));var W;(function(r){r[r.Smooth=0]="Smooth",r[r.Immediate=1]="Immediate"})(W||(t.ScrollType=W={}));var J;(function(r){r[r.Auto=1]="Auto",r[r.Hidden=2]="Hidden",r[r.Visible=3]="Visible"})(J||(t.ScrollbarVisibility=J={}));var ee;(function(r){r[r.LTR=0]="LTR",r[r.RTL=1]="RTL"})(ee||(t.SelectionDirection=ee={}));var Z;(function(r){r.Off="off",r.OnCode="onCode",r.On="on"})(Z||(t.ShowLightbulbIconMode=Z={}));var K;(function(r){r[r.Invoke=1]="Invoke",r[r.TriggerCharacter=2]="TriggerCharacter",r[r.ContentChange=3]="ContentChange"})(K||(t.SignatureHelpTriggerKind=K={}));var ne;(function(r){r[r.File=0]="File",r[r.Module=1]="Module",r[r.Namespace=2]="Namespace",r[r.Package=3]="Package",r[r.Class=4]="Class",r[r.Method=5]="Method",r[r.Property=6]="Property",r[r.Field=7]="Field",r[r.Constructor=8]="Constructor",r[r.Enum=9]="Enum",r[r.Interface=10]="Interface",r[r.Function=11]="Function",r[r.Variable=12]="Variable",r[r.Constant=13]="Constant",r[r.String=14]="String",r[r.Number=15]="Number",r[r.Boolean=16]="Boolean",r[r.Array=17]="Array",r[r.Object=18]="Object",r[r.Key=19]="Key",r[r.Null=20]="Null",r[r.EnumMember=21]="EnumMember",r[r.Struct=22]="Struct",r[r.Event=23]="Event",r[r.Operator=24]="Operator",r[r.TypeParameter=25]="TypeParameter"})(ne||(t.SymbolKind=ne={}));var F;(function(r){r[r.Deprecated=1]="Deprecated"})(F||(t.SymbolTag=F={}));var $;(function(r){r[r.Hidden=0]="Hidden",r[r.Blink=1]="Blink",r[r.Smooth=2]="Smooth",r[r.Phase=3]="Phase",r[r.Expand=4]="Expand",r[r.Solid=5]="Solid"})($||(t.TextEditorCursorBlinkingStyle=$={}));var he;(function(r){r[r.Line=1]="Line",r[r.Block=2]="Block",r[r.Underline=3]="Underline",r[r.LineThin=4]="LineThin",r[r.BlockOutline=5]="BlockOutline",r[r.UnderlineThin=6]="UnderlineThin"})(he||(t.TextEditorCursorStyle=he={}));var ge;(function(r){r[r.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",r[r.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",r[r.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",r[r.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(ge||(t.TrackedRangeStickiness=ge={}));var Ee;(function(r){r[r.None=0]="None",r[r.Same=1]="Same",r[r.Indent=2]="Indent",r[r.DeepIndent=3]="DeepIndent"})(Ee||(t.WrappingIndent=Ee={}))}),ie(re[75],ae([0,1,12,10,63]),function(C,t,n,i,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.TokenizationRegistry=void 0;class m{constructor(){this._tokenizationSupports=new Map,this._factories=new Map,this._onDidChange=new n.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}handleChange(o){this._onDidChange.fire({changedLanguages:o,changedColorMap:!1})}register(o,a){return this._tokenizationSupports.set(o,a),this.handleChange([o]),(0,i.toDisposable)(()=>{this._tokenizationSupports.get(o)===a&&(this._tokenizationSupports.delete(o),this.handleChange([o]))})}get(o){return this._tokenizationSupports.get(o)||null}registerFactory(o,a){this._factories.get(o)?.dispose();const h=new R(this,o,a);return this._factories.set(o,h),(0,i.toDisposable)(()=>{const _=this._factories.get(o);!_||_!==h||(this._factories.delete(o),_.dispose())})}async getOrCreate(o){const a=this.get(o);if(a)return a;const h=this._factories.get(o);return!h||h.isResolved?null:(await h.resolve(),this.get(o))}isResolved(o){if(this.get(o))return!0;const h=this._factories.get(o);return!!(!h||h.isResolved)}setColorMap(o){this._colorMap=o,this._onDidChange.fire({changedLanguages:Array.from(this._tokenizationSupports.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>M.ColorId.DefaultBackground?this._colorMap[M.ColorId.DefaultBackground]:null}}t.TokenizationRegistry=m;class R extends i.Disposable{get isResolved(){return this._isResolved}constructor(o,a,h){super(),this._registry=o,this._languageId=a,this._factory=h,this._isDisposed=!1,this._resolvePromise=null,this._isResolved=!1}dispose(){this._isDisposed=!0,super.dispose()}async resolve(){return this._resolvePromise||(this._resolvePromise=this._create()),this._resolvePromise}async _create(){const o=await this._factory.tokenizationSupport;this._isResolved=!0,o&&!this._isDisposed&&this._register(this._registry.register(this._languageId,o))}}}),ie(re[40],ae([0,1]),function(C,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getNLSMessages=n,t.getNLSLanguage=i;function n(){return globalThis._VSCODE_NLS_MESSAGES}function i(){return globalThis._VSCODE_NLS_LANGUAGE}}),ie(re[41],ae([0,1,40,40]),function(C,t,n,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getNLSMessages=t.getNLSLanguage=void 0,t.localize=R,t.localize2=o,Object.defineProperty(t,"getNLSLanguage",{enumerable:!0,get:function(){return i.getNLSLanguage}}),Object.defineProperty(t,"getNLSMessages",{enumerable:!0,get:function(){return i.getNLSMessages}});const M=(0,n.getNLSLanguage)()==="pseudo"||typeof document<"u"&&document.location&&document.location.hash.indexOf("pseudo=true")>=0;function m(a,h){let _;return h.length===0?_=a:_=a.replace(/\{(\d+)\}/g,(d,c)=>{const e=c[0],u=h[e];let g=d;return typeof u=="string"?g=u:(typeof u=="number"||typeof u=="boolean"||u===void 0||u===null)&&(g=String(u)),g}),M&&(_="\uFF3B"+_.replace(/[aouei]/g,"$&$&")+"\uFF3D"),_}function R(a,h,..._){return m(typeof a=="number"?b(a,h):h,_)}function b(a,h){const _=(0,n.getNLSMessages)()?.[a];if(typeof _!="string"){if(typeof h=="string")return h;throw new Error(`!!! NLS MISSING: ${a} !!!`)}return _}function o(a,h,..._){let d;typeof a=="number"?d=b(a,h):d=h;const c=m(d,_);return{value:c,original:h===d?c:m(h,_)}}}),ie(re[8],ae([0,1,41]),function(C,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isAndroid=t.isEdge=t.isSafari=t.isFirefox=t.isChrome=t.OS=t.OperatingSystem=t.setTimeout0=t.setTimeout0IsFaster=t.translationsConfigFile=t.platformLocale=t.locale=t.Language=t.language=t.userAgent=t.platform=t.isCI=t.isMobile=t.isIOS=t.webWorkerOrigin=t.isWebWorker=t.isWeb=t.isElectron=t.isNative=t.isLinuxSnap=t.isLinux=t.isMacintosh=t.isWindows=t.Platform=t.LANGUAGE_DEFAULT=void 0,t.PlatformToString=s,t.isLittleEndian=D,t.isBigSurOrNewer=T,n=ye(n),t.LANGUAGE_DEFAULT="en";let i=!1,M=!1,m=!1,R=!1,b=!1,o=!1,a=!1,h=!1,_=!1,d=!1,c,e=t.LANGUAGE_DEFAULT,u=t.LANGUAGE_DEFAULT,g,E;const w=globalThis;let v;typeof w.vscode<"u"&&typeof w.vscode.process<"u"?v=w.vscode.process:typeof process<"u"&&typeof process?.versions?.node=="string"&&(v=process);const A=typeof v?.versions?.electron=="string",L=A&&v?.type==="renderer";if(typeof v=="object"){i=v.platform==="win32",M=v.platform==="darwin",m=v.platform==="linux",R=m&&!!v.env.SNAP&&!!v.env.SNAP_REVISION,a=A,_=!!v.env.CI||!!v.env.BUILD_ARTIFACTSTAGINGDIRECTORY,c=t.LANGUAGE_DEFAULT,e=t.LANGUAGE_DEFAULT;const y=v.env.VSCODE_NLS_CONFIG;if(y)try{const k=JSON.parse(y);c=k.userLocale,u=k.osLocale,e=k.resolvedLanguage||t.LANGUAGE_DEFAULT,g=k.languagePack?.translationsConfigFile}catch{}b=!0}else typeof navigator=="object"&&!L?(E=navigator.userAgent,i=E.indexOf("Windows")>=0,M=E.indexOf("Macintosh")>=0,h=(E.indexOf("Macintosh")>=0||E.indexOf("iPad")>=0||E.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,m=E.indexOf("Linux")>=0,d=E?.indexOf("Mobi")>=0,o=!0,e=n.getNLSLanguage()||t.LANGUAGE_DEFAULT,c=navigator.language.toLowerCase(),u=c):console.error("Unable to resolve platform.");var l;(function(y){y[y.Web=0]="Web",y[y.Mac=1]="Mac",y[y.Linux=2]="Linux",y[y.Windows=3]="Windows"})(l||(t.Platform=l={}));function s(y){switch(y){case l.Web:return"Web";case l.Mac:return"Mac";case l.Linux:return"Linux";case l.Windows:return"Windows"}}let f=l.Web;M?f=l.Mac:i?f=l.Windows:m&&(f=l.Linux),t.isWindows=i,t.isMacintosh=M,t.isLinux=m,t.isLinuxSnap=R,t.isNative=b,t.isElectron=a,t.isWeb=o,t.isWebWorker=o&&typeof w.importScripts=="function",t.webWorkerOrigin=t.isWebWorker?w.origin:void 0,t.isIOS=h,t.isMobile=d,t.isCI=_,t.platform=f,t.userAgent=E,t.language=e;var p;(function(y){function k(){return t.language}y.value=k;function P(){return t.language.length===2?t.language==="en":t.language.length>=3?t.language[0]==="e"&&t.language[1]==="n"&&t.language[2]==="-":!1}y.isDefaultVariant=P;function q(){return t.language==="en"}y.isDefault=q})(p||(t.Language=p={})),t.locale=c,t.platformLocale=u,t.translationsConfigFile=g,t.setTimeout0IsFaster=typeof w.postMessage=="function"&&!w.importScripts,t.setTimeout0=(()=>{if(t.setTimeout0IsFaster){const y=[];w.addEventListener("message",P=>{if(P.data&&P.data.vscodeScheduleAsyncWork)for(let q=0,j=y.length;q<j;q++){const H=y[q];if(H.id===P.data.vscodeScheduleAsyncWork){y.splice(q,1),H.callback();return}}});let k=0;return P=>{const q=++k;y.push({id:q,callback:P}),w.postMessage({vscodeScheduleAsyncWork:q},"*")}}return y=>setTimeout(y)})();var I;(function(y){y[y.Windows=1]="Windows",y[y.Macintosh=2]="Macintosh",y[y.Linux=3]="Linux"})(I||(t.OperatingSystem=I={})),t.OS=M||h?I.Macintosh:i?I.Windows:I.Linux;let N=!0,S=!1;function D(){if(!S){S=!0;const y=new Uint8Array(2);y[0]=1,y[1]=2,N=new Uint16Array(y.buffer)[0]===513}return N}t.isChrome=!!(t.userAgent&&t.userAgent.indexOf("Chrome")>=0),t.isFirefox=!!(t.userAgent&&t.userAgent.indexOf("Firefox")>=0),t.isSafari=!!(!t.isChrome&&t.userAgent&&t.userAgent.indexOf("Safari")>=0),t.isEdge=!!(t.userAgent&&t.userAgent.indexOf("Edg/")>=0),t.isAndroid=!!(t.userAgent&&t.userAgent.indexOf("Android")>=0);function T(y){return parseFloat(y)>=20}}),ie(re[76],ae([0,1,8]),function(C,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.arch=t.platform=t.env=t.cwd=void 0;let i;const M=globalThis.vscode;if(typeof M<"u"&&typeof M.process<"u"){const m=M.process;i={get platform(){return m.platform},get arch(){return m.arch},get env(){return m.env},cwd(){return m.cwd()}}}else typeof process<"u"&&typeof process?.versions?.node=="string"?i={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:i={get platform(){return n.isWindows?"win32":n.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};t.cwd=i.cwd,t.env=i.env,t.platform=i.platform,t.arch=i.arch}),ie(re[18],ae([0,1,76]),function(C,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.delimiter=t.sep=t.toNamespacedPath=t.parse=t.format=t.extname=t.basename=t.dirname=t.relative=t.resolve=t.join=t.isAbsolute=t.normalize=t.posix=t.win32=void 0,n=ye(n);const i=65,M=97,m=90,R=122,b=46,o=47,a=92,h=58,_=63;class d extends Error{constructor(f,p,I){let N;typeof p=="string"&&p.indexOf("not ")===0?(N="must not be",p=p.replace(/^not /,"")):N="must be";const S=f.indexOf(".")!==-1?"property":"argument";let D=`The "${f}" ${S} ${N} of type ${p}`;D+=`. Received type ${typeof I}`,super(D),this.code="ERR_INVALID_ARG_TYPE"}}function c(s,f){if(s===null||typeof s!="object")throw new d(f,"Object",s)}function e(s,f){if(typeof s!="string")throw new d(f,"string",s)}const u=n.platform==="win32";function g(s){return s===o||s===a}function E(s){return s===o}function w(s){return s>=i&&s<=m||s>=M&&s<=R}function v(s,f,p,I){let N="",S=0,D=-1,T=0,y=0;for(let k=0;k<=s.length;++k){if(k<s.length)y=s.charCodeAt(k);else{if(I(y))break;y=o}if(I(y)){if(!(D===k-1||T===1))if(T===2){if(N.length<2||S!==2||N.charCodeAt(N.length-1)!==b||N.charCodeAt(N.length-2)!==b){if(N.length>2){const P=N.lastIndexOf(p);P===-1?(N="",S=0):(N=N.slice(0,P),S=N.length-1-N.lastIndexOf(p)),D=k,T=0;continue}else if(N.length!==0){N="",S=0,D=k,T=0;continue}}f&&(N+=N.length>0?`${p}..`:"..",S=2)}else N.length>0?N+=`${p}${s.slice(D+1,k)}`:N=s.slice(D+1,k),S=k-D-1;D=k,T=0}else y===b&&T!==-1?++T:T=-1}return N}function A(s){return s?`${s[0]==="."?"":"."}${s}`:""}function L(s,f){c(f,"pathObject");const p=f.dir||f.root,I=f.base||`${f.name||""}${A(f.ext)}`;return p?p===f.root?`${p}${I}`:`${p}${s}${I}`:I}t.win32={resolve(...s){let f="",p="",I=!1;for(let N=s.length-1;N>=-1;N--){let S;if(N>=0){if(S=s[N],e(S,`paths[${N}]`),S.length===0)continue}else f.length===0?S=n.cwd():(S=n.env[`=${f}`]||n.cwd(),(S===void 0||S.slice(0,2).toLowerCase()!==f.toLowerCase()&&S.charCodeAt(2)===a)&&(S=`${f}\\`));const D=S.length;let T=0,y="",k=!1;const P=S.charCodeAt(0);if(D===1)g(P)&&(T=1,k=!0);else if(g(P))if(k=!0,g(S.charCodeAt(1))){let q=2,j=q;for(;q<D&&!g(S.charCodeAt(q));)q++;if(q<D&&q!==j){const H=S.slice(j,q);for(j=q;q<D&&g(S.charCodeAt(q));)q++;if(q<D&&q!==j){for(j=q;q<D&&!g(S.charCodeAt(q));)q++;(q===D||q!==j)&&(y=`\\\\${H}\\${S.slice(j,q)}`,T=q)}}}else T=1;else w(P)&&S.charCodeAt(1)===h&&(y=S.slice(0,2),T=2,D>2&&g(S.charCodeAt(2))&&(k=!0,T=3));if(y.length>0)if(f.length>0){if(y.toLowerCase()!==f.toLowerCase())continue}else f=y;if(I){if(f.length>0)break}else if(p=`${S.slice(T)}\\${p}`,I=k,k&&f.length>0)break}return p=v(p,!I,"\\",g),I?`${f}\\${p}`:`${f}${p}`||"."},normalize(s){e(s,"path");const f=s.length;if(f===0)return".";let p=0,I,N=!1;const S=s.charCodeAt(0);if(f===1)return E(S)?"\\":s;if(g(S))if(N=!0,g(s.charCodeAt(1))){let T=2,y=T;for(;T<f&&!g(s.charCodeAt(T));)T++;if(T<f&&T!==y){const k=s.slice(y,T);for(y=T;T<f&&g(s.charCodeAt(T));)T++;if(T<f&&T!==y){for(y=T;T<f&&!g(s.charCodeAt(T));)T++;if(T===f)return`\\\\${k}\\${s.slice(y)}\\`;T!==y&&(I=`\\\\${k}\\${s.slice(y,T)}`,p=T)}}}else p=1;else w(S)&&s.charCodeAt(1)===h&&(I=s.slice(0,2),p=2,f>2&&g(s.charCodeAt(2))&&(N=!0,p=3));let D=p<f?v(s.slice(p),!N,"\\",g):"";return D.length===0&&!N&&(D="."),D.length>0&&g(s.charCodeAt(f-1))&&(D+="\\"),I===void 0?N?`\\${D}`:D:N?`${I}\\${D}`:`${I}${D}`},isAbsolute(s){e(s,"path");const f=s.length;if(f===0)return!1;const p=s.charCodeAt(0);return g(p)||f>2&&w(p)&&s.charCodeAt(1)===h&&g(s.charCodeAt(2))},join(...s){if(s.length===0)return".";let f,p;for(let S=0;S<s.length;++S){const D=s[S];e(D,"path"),D.length>0&&(f===void 0?f=p=D:f+=`\\${D}`)}if(f===void 0)return".";let I=!0,N=0;if(typeof p=="string"&&g(p.charCodeAt(0))){++N;const S=p.length;S>1&&g(p.charCodeAt(1))&&(++N,S>2&&(g(p.charCodeAt(2))?++N:I=!1))}if(I){for(;N<f.length&&g(f.charCodeAt(N));)N++;N>=2&&(f=`\\${f.slice(N)}`)}return t.win32.normalize(f)},relative(s,f){if(e(s,"from"),e(f,"to"),s===f)return"";const p=t.win32.resolve(s),I=t.win32.resolve(f);if(p===I||(s=p.toLowerCase(),f=I.toLowerCase(),s===f))return"";let N=0;for(;N<s.length&&s.charCodeAt(N)===a;)N++;let S=s.length;for(;S-1>N&&s.charCodeAt(S-1)===a;)S--;const D=S-N;let T=0;for(;T<f.length&&f.charCodeAt(T)===a;)T++;let y=f.length;for(;y-1>T&&f.charCodeAt(y-1)===a;)y--;const k=y-T,P=D<k?D:k;let q=-1,j=0;for(;j<P;j++){const W=s.charCodeAt(N+j);if(W!==f.charCodeAt(T+j))break;W===a&&(q=j)}if(j!==P){if(q===-1)return I}else{if(k>P){if(f.charCodeAt(T+j)===a)return I.slice(T+j+1);if(j===2)return I.slice(T+j)}D>P&&(s.charCodeAt(N+j)===a?q=j:j===2&&(q=3)),q===-1&&(q=0)}let H="";for(j=N+q+1;j<=S;++j)(j===S||s.charCodeAt(j)===a)&&(H+=H.length===0?"..":"\\..");return T+=q,H.length>0?`${H}${I.slice(T,y)}`:(I.charCodeAt(T)===a&&++T,I.slice(T,y))},toNamespacedPath(s){if(typeof s!="string"||s.length===0)return s;const f=t.win32.resolve(s);if(f.length<=2)return s;if(f.charCodeAt(0)===a){if(f.charCodeAt(1)===a){const p=f.charCodeAt(2);if(p!==_&&p!==b)return`\\\\?\\UNC\\${f.slice(2)}`}}else if(w(f.charCodeAt(0))&&f.charCodeAt(1)===h&&f.charCodeAt(2)===a)return`\\\\?\\${f}`;return s},dirname(s){e(s,"path");const f=s.length;if(f===0)return".";let p=-1,I=0;const N=s.charCodeAt(0);if(f===1)return g(N)?s:".";if(g(N)){if(p=I=1,g(s.charCodeAt(1))){let T=2,y=T;for(;T<f&&!g(s.charCodeAt(T));)T++;if(T<f&&T!==y){for(y=T;T<f&&g(s.charCodeAt(T));)T++;if(T<f&&T!==y){for(y=T;T<f&&!g(s.charCodeAt(T));)T++;if(T===f)return s;T!==y&&(p=I=T+1)}}}}else w(N)&&s.charCodeAt(1)===h&&(p=f>2&&g(s.charCodeAt(2))?3:2,I=p);let S=-1,D=!0;for(let T=f-1;T>=I;--T)if(g(s.charCodeAt(T))){if(!D){S=T;break}}else D=!1;if(S===-1){if(p===-1)return".";S=p}return s.slice(0,S)},basename(s,f){f!==void 0&&e(f,"suffix"),e(s,"path");let p=0,I=-1,N=!0,S;if(s.length>=2&&w(s.charCodeAt(0))&&s.charCodeAt(1)===h&&(p=2),f!==void 0&&f.length>0&&f.length<=s.length){if(f===s)return"";let D=f.length-1,T=-1;for(S=s.length-1;S>=p;--S){const y=s.charCodeAt(S);if(g(y)){if(!N){p=S+1;break}}else T===-1&&(N=!1,T=S+1),D>=0&&(y===f.charCodeAt(D)?--D===-1&&(I=S):(D=-1,I=T))}return p===I?I=T:I===-1&&(I=s.length),s.slice(p,I)}for(S=s.length-1;S>=p;--S)if(g(s.charCodeAt(S))){if(!N){p=S+1;break}}else I===-1&&(N=!1,I=S+1);return I===-1?"":s.slice(p,I)},extname(s){e(s,"path");let f=0,p=-1,I=0,N=-1,S=!0,D=0;s.length>=2&&s.charCodeAt(1)===h&&w(s.charCodeAt(0))&&(f=I=2);for(let T=s.length-1;T>=f;--T){const y=s.charCodeAt(T);if(g(y)){if(!S){I=T+1;break}continue}N===-1&&(S=!1,N=T+1),y===b?p===-1?p=T:D!==1&&(D=1):p!==-1&&(D=-1)}return p===-1||N===-1||D===0||D===1&&p===N-1&&p===I+1?"":s.slice(p,N)},format:L.bind(null,"\\"),parse(s){e(s,"path");const f={root:"",dir:"",base:"",ext:"",name:""};if(s.length===0)return f;const p=s.length;let I=0,N=s.charCodeAt(0);if(p===1)return g(N)?(f.root=f.dir=s,f):(f.base=f.name=s,f);if(g(N)){if(I=1,g(s.charCodeAt(1))){let q=2,j=q;for(;q<p&&!g(s.charCodeAt(q));)q++;if(q<p&&q!==j){for(j=q;q<p&&g(s.charCodeAt(q));)q++;if(q<p&&q!==j){for(j=q;q<p&&!g(s.charCodeAt(q));)q++;q===p?I=q:q!==j&&(I=q+1)}}}}else if(w(N)&&s.charCodeAt(1)===h){if(p<=2)return f.root=f.dir=s,f;if(I=2,g(s.charCodeAt(2))){if(p===3)return f.root=f.dir=s,f;I=3}}I>0&&(f.root=s.slice(0,I));let S=-1,D=I,T=-1,y=!0,k=s.length-1,P=0;for(;k>=I;--k){if(N=s.charCodeAt(k),g(N)){if(!y){D=k+1;break}continue}T===-1&&(y=!1,T=k+1),N===b?S===-1?S=k:P!==1&&(P=1):S!==-1&&(P=-1)}return T!==-1&&(S===-1||P===0||P===1&&S===T-1&&S===D+1?f.base=f.name=s.slice(D,T):(f.name=s.slice(D,S),f.base=s.slice(D,T),f.ext=s.slice(S,T))),D>0&&D!==I?f.dir=s.slice(0,D-1):f.dir=f.root,f},sep:"\\",delimiter:";",win32:null,posix:null};const l=(()=>{if(u){const s=/\\/g;return()=>{const f=n.cwd().replace(s,"/");return f.slice(f.indexOf("/"))}}return()=>n.cwd()})();t.posix={resolve(...s){let f="",p=!1;for(let I=s.length-1;I>=-1&&!p;I--){const N=I>=0?s[I]:l();e(N,`paths[${I}]`),N.length!==0&&(f=`${N}/${f}`,p=N.charCodeAt(0)===o)}return f=v(f,!p,"/",E),p?`/${f}`:f.length>0?f:"."},normalize(s){if(e(s,"path"),s.length===0)return".";const f=s.charCodeAt(0)===o,p=s.charCodeAt(s.length-1)===o;return s=v(s,!f,"/",E),s.length===0?f?"/":p?"./":".":(p&&(s+="/"),f?`/${s}`:s)},isAbsolute(s){return e(s,"path"),s.length>0&&s.charCodeAt(0)===o},join(...s){if(s.length===0)return".";let f;for(let p=0;p<s.length;++p){const I=s[p];e(I,"path"),I.length>0&&(f===void 0?f=I:f+=`/${I}`)}return f===void 0?".":t.posix.normalize(f)},relative(s,f){if(e(s,"from"),e(f,"to"),s===f||(s=t.posix.resolve(s),f=t.posix.resolve(f),s===f))return"";const p=1,I=s.length,N=I-p,S=1,D=f.length-S,T=N<D?N:D;let y=-1,k=0;for(;k<T;k++){const q=s.charCodeAt(p+k);if(q!==f.charCodeAt(S+k))break;q===o&&(y=k)}if(k===T)if(D>T){if(f.charCodeAt(S+k)===o)return f.slice(S+k+1);if(k===0)return f.slice(S+k)}else N>T&&(s.charCodeAt(p+k)===o?y=k:k===0&&(y=0));let P="";for(k=p+y+1;k<=I;++k)(k===I||s.charCodeAt(k)===o)&&(P+=P.length===0?"..":"/..");return`${P}${f.slice(S+y)}`},toNamespacedPath(s){return s},dirname(s){if(e(s,"path"),s.length===0)return".";const f=s.charCodeAt(0)===o;let p=-1,I=!0;for(let N=s.length-1;N>=1;--N)if(s.charCodeAt(N)===o){if(!I){p=N;break}}else I=!1;return p===-1?f?"/":".":f&&p===1?"//":s.slice(0,p)},basename(s,f){f!==void 0&&e(f,"ext"),e(s,"path");let p=0,I=-1,N=!0,S;if(f!==void 0&&f.length>0&&f.length<=s.length){if(f===s)return"";let D=f.length-1,T=-1;for(S=s.length-1;S>=0;--S){const y=s.charCodeAt(S);if(y===o){if(!N){p=S+1;break}}else T===-1&&(N=!1,T=S+1),D>=0&&(y===f.charCodeAt(D)?--D===-1&&(I=S):(D=-1,I=T))}return p===I?I=T:I===-1&&(I=s.length),s.slice(p,I)}for(S=s.length-1;S>=0;--S)if(s.charCodeAt(S)===o){if(!N){p=S+1;break}}else I===-1&&(N=!1,I=S+1);return I===-1?"":s.slice(p,I)},extname(s){e(s,"path");let f=-1,p=0,I=-1,N=!0,S=0;for(let D=s.length-1;D>=0;--D){const T=s.charCodeAt(D);if(T===o){if(!N){p=D+1;break}continue}I===-1&&(N=!1,I=D+1),T===b?f===-1?f=D:S!==1&&(S=1):f!==-1&&(S=-1)}return f===-1||I===-1||S===0||S===1&&f===I-1&&f===p+1?"":s.slice(f,I)},format:L.bind(null,"/"),parse(s){e(s,"path");const f={root:"",dir:"",base:"",ext:"",name:""};if(s.length===0)return f;const p=s.charCodeAt(0)===o;let I;p?(f.root="/",I=1):I=0;let N=-1,S=0,D=-1,T=!0,y=s.length-1,k=0;for(;y>=I;--y){const P=s.charCodeAt(y);if(P===o){if(!T){S=y+1;break}continue}D===-1&&(T=!1,D=y+1),P===b?N===-1?N=y:k!==1&&(k=1):N!==-1&&(k=-1)}if(D!==-1){const P=S===0&&p?1:S;N===-1||k===0||k===1&&N===D-1&&N===S+1?f.base=f.name=s.slice(P,D):(f.name=s.slice(P,N),f.base=s.slice(P,D),f.ext=s.slice(N,D))}return S>0?f.dir=s.slice(0,S-1):p&&(f.dir="/"),f},sep:"/",delimiter:":",win32:null,posix:null},t.posix.win32=t.win32.win32=t.win32,t.posix.posix=t.win32.posix=t.posix,t.normalize=u?t.win32.normalize:t.posix.normalize,t.isAbsolute=u?t.win32.isAbsolute:t.posix.isAbsolute,t.join=u?t.win32.join:t.posix.join,t.resolve=u?t.win32.resolve:t.posix.resolve,t.relative=u?t.win32.relative:t.posix.relative,t.dirname=u?t.win32.dirname:t.posix.dirname,t.basename=u?t.win32.basename:t.posix.basename,t.extname=u?t.win32.extname:t.posix.extname,t.format=u?t.win32.format:t.posix.format,t.parse=u?t.win32.parse:t.posix.parse,t.toNamespacedPath=u?t.win32.toNamespacedPath:t.posix.toNamespacedPath,t.sep=u?t.win32.sep:t.posix.sep,t.delimiter=u?t.win32.delimiter:t.posix.delimiter}),ie(re[77],ae([0,1,3,18,8,6,21]),function(C,t,n,i,M,m,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isPathSeparator=b,t.toSlashes=o,t.toPosixPath=a,t.getRoot=h,t.isUNC=_,t.isValidBasename=u,t.isEqual=g,t.isEqualOrParent=E,t.isWindowsDriveLetter=w,t.sanitizeFilePath=v,t.removeTrailingPathSeparator=A,t.isRootOrDriveLetter=L,t.hasDriveLetter=l,t.getDriveLetter=s,t.indexOfPath=f,t.parseLineAndColumnAware=p,t.randomPath=S;function b(D){return D===n.CharCode.Slash||D===n.CharCode.Backslash}function o(D){return D.replace(/[\\/]/g,i.posix.sep)}function a(D){return D.indexOf("/")===-1&&(D=o(D)),/^[a-zA-Z]:(\/|$)/.test(D)&&(D="/"+D),D}function h(D,T=i.posix.sep){if(!D)return"";const y=D.length,k=D.charCodeAt(0);if(b(k)){if(b(D.charCodeAt(1))&&!b(D.charCodeAt(2))){let q=3;const j=q;for(;q<y&&!b(D.charCodeAt(q));q++);if(j!==q&&!b(D.charCodeAt(q+1))){for(q+=1;q<y;q++)if(b(D.charCodeAt(q)))return D.slice(0,q+1).replace(/[\\/]/g,T)}}return T}else if(w(k)&&D.charCodeAt(1)===n.CharCode.Colon)return b(D.charCodeAt(2))?D.slice(0,2)+T:D.slice(0,2);let P=D.indexOf("://");if(P!==-1){for(P+=3;P<y;P++)if(b(D.charCodeAt(P)))return D.slice(0,P+1)}return""}function _(D){if(!M.isWindows||!D||D.length<5)return!1;let T=D.charCodeAt(0);if(T!==n.CharCode.Backslash||(T=D.charCodeAt(1),T!==n.CharCode.Backslash))return!1;let y=2;const k=y;for(;y<D.length&&(T=D.charCodeAt(y),T!==n.CharCode.Backslash);y++);return!(k===y||(T=D.charCodeAt(y+1),isNaN(T)||T===n.CharCode.Backslash))}const d=/[\\/:\*\?"<>\|]/g,c=/[/]/g,e=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function u(D,T=M.isWindows){const y=T?d:c;return!(!D||D.length===0||/^\s+$/.test(D)||(y.lastIndex=0,y.test(D))||T&&e.test(D)||D==="."||D===".."||T&&D[D.length-1]==="."||T&&D.length!==D.trim().length||D.length>255)}function g(D,T,y){const k=D===T;return!y||k?k:!D||!T?!1:(0,m.equalsIgnoreCase)(D,T)}function E(D,T,y,k=i.sep){if(D===T)return!0;if(!D||!T||T.length>D.length)return!1;if(y){if(!(0,m.startsWithIgnoreCase)(D,T))return!1;if(T.length===D.length)return!0;let q=T.length;return T.charAt(T.length-1)===k&&q--,D.charAt(q)===k}return T.charAt(T.length-1)!==k&&(T+=k),D.indexOf(T)===0}function w(D){return D>=n.CharCode.A&&D<=n.CharCode.Z||D>=n.CharCode.a&&D<=n.CharCode.z}function v(D,T){return M.isWindows&&D.endsWith(":")&&(D+=i.sep),(0,i.isAbsolute)(D)||(D=(0,i.join)(T,D)),D=(0,i.normalize)(D),A(D)}function A(D){return M.isWindows?(D=(0,m.rtrim)(D,i.sep),D.endsWith(":")&&(D+=i.sep)):(D=(0,m.rtrim)(D,i.sep),D||(D=i.sep)),D}function L(D){const T=(0,i.normalize)(D);return M.isWindows?D.length>3?!1:l(T)&&(D.length===2||T.charCodeAt(2)===n.CharCode.Backslash):T===i.posix.sep}function l(D,T=M.isWindows){return T?w(D.charCodeAt(0))&&D.charCodeAt(1)===n.CharCode.Colon:!1}function s(D,T=M.isWindows){return l(D,T)?D[0]:void 0}function f(D,T,y){return T.length>D.length?-1:D===T?0:(y&&(D=D.toLowerCase(),T=T.toLowerCase()),D.indexOf(T))}function p(D){const T=D.split(":");let y,k,P;for(const q of T){const j=Number(q);(0,R.isNumber)(j)?k===void 0?k=j:P===void 0&&(P=j):y=y?[y,q].join(":"):q}if(!y)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:y,line:k!==void 0?k:void 0,column:P!==void 0?P:k!==void 0?1:void 0}}const I="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",N="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function S(D,T,y=8){let k="";for(let q=0;q<y;q++){let j;q===0&&M.isWindows&&!T&&(y===3||y===4)?j=N:j=I,k+=j.charAt(Math.floor(Math.random()*j.length))}let P;return T?P=`${T}-${k}`:P=k,D?(0,i.join)(D,P):P}}),ie(re[14],ae([0,1,3,46,18,8]),function(C,t,n,i,M,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.URI=void 0,t.isUriComponents=g,t.uriToFsPath=l,M=ye(M);const R=/^\w[\w\d+.-]*$/,b=/^\//,o=/^\/\//;function a(N,S){if(!N.scheme&&S)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${N.authority}", path: "${N.path}", query: "${N.query}", fragment: "${N.fragment}"}`);if(N.scheme&&!R.test(N.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(N.path){if(N.authority){if(!b.test(N.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(o.test(N.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function h(N,S){return!N&&!S?"file":N}function _(N,S){switch(N){case"https":case"http":case"file":S?S[0]!==c&&(S=c+S):S=c;break}return S}const d="",c="/",e=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class u{static isUri(S){return S instanceof u?!0:S?typeof S.authority=="string"&&typeof S.fragment=="string"&&typeof S.path=="string"&&typeof S.query=="string"&&typeof S.scheme=="string"&&typeof S.fsPath=="string"&&typeof S.with=="function"&&typeof S.toString=="function":!1}constructor(S,D,T,y,k,P=!1){typeof S=="object"?(this.scheme=S.scheme||d,this.authority=S.authority||d,this.path=S.path||d,this.query=S.query||d,this.fragment=S.fragment||d):(this.scheme=h(S,P),this.authority=D||d,this.path=_(this.scheme,T||d),this.query=y||d,this.fragment=k||d,a(this,P))}get fsPath(){return l(this,!1)}with(S){if(!S)return this;let{scheme:D,authority:T,path:y,query:k,fragment:P}=S;return D===void 0?D=this.scheme:D===null&&(D=d),T===void 0?T=this.authority:T===null&&(T=d),y===void 0?y=this.path:y===null&&(y=d),k===void 0?k=this.query:k===null&&(k=d),P===void 0?P=this.fragment:P===null&&(P=d),D===this.scheme&&T===this.authority&&y===this.path&&k===this.query&&P===this.fragment?this:new w(D,T,y,k,P)}static parse(S,D=!1){const T=e.exec(S);return T?new w(T[2]||d,I(T[4]||d),I(T[5]||d),I(T[7]||d),I(T[9]||d),D):new w(d,d,d,d,d)}static file(S){let D=d;if(m.isWindows&&(S=S.replace(/\\/g,c)),S[0]===c&&S[1]===c){const T=S.indexOf(c,2);T===-1?(D=S.substring(2),S=c):(D=S.substring(2,T),S=S.substring(T)||c)}return new w("file",D,S,d,d)}static from(S,D){return new w(S.scheme,S.authority,S.path,S.query,S.fragment,D)}static joinPath(S,...D){if(!S.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let T;return m.isWindows&&S.scheme==="file"?T=u.file(M.win32.join(l(S,!0),...D)).path:T=M.posix.join(S.path,...D),S.with({path:T})}toString(S=!1){return s(this,S)}toJSON(){return this}static revive(S){if(S){if(S instanceof u)return S;{const D=new w(S);return D._formatted=S.external??null,D._fsPath=S._sep===E?S.fsPath??null:null,D}}else return S}[Symbol.for("debug.description")](){return`URI(${this.toString()})`}}t.URI=u;function g(N){return!N||typeof N!="object"?!1:typeof N.scheme=="string"&&(typeof N.authority=="string"||typeof N.authority>"u")&&(typeof N.path=="string"||typeof N.path>"u")&&(typeof N.query=="string"||typeof N.query>"u")&&(typeof N.fragment=="string"||typeof N.fragment>"u")}const E=m.isWindows?1:void 0;class w extends u{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=l(this,!1)),this._fsPath}toString(S=!1){return S?s(this,!0):(this._formatted||(this._formatted=s(this,!1)),this._formatted)}toJSON(){const S={$mid:i.MarshalledId.Uri};return this._fsPath&&(S.fsPath=this._fsPath,S._sep=E),this._formatted&&(S.external=this._formatted),this.path&&(S.path=this.path),this.scheme&&(S.scheme=this.scheme),this.authority&&(S.authority=this.authority),this.query&&(S.query=this.query),this.fragment&&(S.fragment=this.fragment),S}}const v={[n.CharCode.Colon]:"%3A",[n.CharCode.Slash]:"%2F",[n.CharCode.QuestionMark]:"%3F",[n.CharCode.Hash]:"%23",[n.CharCode.OpenSquareBracket]:"%5B",[n.CharCode.CloseSquareBracket]:"%5D",[n.CharCode.AtSign]:"%40",[n.CharCode.ExclamationMark]:"%21",[n.CharCode.DollarSign]:"%24",[n.CharCode.Ampersand]:"%26",[n.CharCode.SingleQuote]:"%27",[n.CharCode.OpenParen]:"%28",[n.CharCode.CloseParen]:"%29",[n.CharCode.Asterisk]:"%2A",[n.CharCode.Plus]:"%2B",[n.CharCode.Comma]:"%2C",[n.CharCode.Semicolon]:"%3B",[n.CharCode.Equals]:"%3D",[n.CharCode.Space]:"%20"};function A(N,S,D){let T,y=-1;for(let k=0;k<N.length;k++){const P=N.charCodeAt(k);if(P>=n.CharCode.a&&P<=n.CharCode.z||P>=n.CharCode.A&&P<=n.CharCode.Z||P>=n.CharCode.Digit0&&P<=n.CharCode.Digit9||P===n.CharCode.Dash||P===n.CharCode.Period||P===n.CharCode.Underline||P===n.CharCode.Tilde||S&&P===n.CharCode.Slash||D&&P===n.CharCode.OpenSquareBracket||D&&P===n.CharCode.CloseSquareBracket||D&&P===n.CharCode.Colon)y!==-1&&(T+=encodeURIComponent(N.substring(y,k)),y=-1),T!==void 0&&(T+=N.charAt(k));else{T===void 0&&(T=N.substr(0,k));const q=v[P];q!==void 0?(y!==-1&&(T+=encodeURIComponent(N.substring(y,k)),y=-1),T+=q):y===-1&&(y=k)}}return y!==-1&&(T+=encodeURIComponent(N.substring(y))),T!==void 0?T:N}function L(N){let S;for(let D=0;D<N.length;D++){const T=N.charCodeAt(D);T===n.CharCode.Hash||T===n.CharCode.QuestionMark?(S===void 0&&(S=N.substr(0,D)),S+=v[T]):S!==void 0&&(S+=N[D])}return S!==void 0?S:N}function l(N,S){let D;return N.authority&&N.path.length>1&&N.scheme==="file"?D=`//${N.authority}${N.path}`:N.path.charCodeAt(0)===n.CharCode.Slash&&(N.path.charCodeAt(1)>=n.CharCode.A&&N.path.charCodeAt(1)<=n.CharCode.Z||N.path.charCodeAt(1)>=n.CharCode.a&&N.path.charCodeAt(1)<=n.CharCode.z)&&N.path.charCodeAt(2)===n.CharCode.Colon?S?D=N.path.substr(1):D=N.path[1].toLowerCase()+N.path.substr(2):D=N.path,m.isWindows&&(D=D.replace(/\//g,"\\")),D}function s(N,S){const D=S?L:A;let T="",{scheme:y,authority:k,path:P,query:q,fragment:j}=N;if(y&&(T+=y,T+=":"),(k||y==="file")&&(T+=c,T+=c),k){let H=k.indexOf("@");if(H!==-1){const W=k.substr(0,H);k=k.substr(H+1),H=W.lastIndexOf(":"),H===-1?T+=D(W,!1,!1):(T+=D(W.substr(0,H),!1,!1),T+=":",T+=D(W.substr(H+1),!1,!0)),T+="@"}k=k.toLowerCase(),H=k.lastIndexOf(":"),H===-1?T+=D(k,!1,!0):(T+=D(k.substr(0,H),!1,!0),T+=k.substr(H))}if(P){if(P.length>=3&&P.charCodeAt(0)===n.CharCode.Slash&&P.charCodeAt(2)===n.CharCode.Colon){const H=P.charCodeAt(1);H>=n.CharCode.A&&H<=n.CharCode.Z&&(P=`/${String.fromCharCode(H+32)}:${P.substr(3)}`)}else if(P.length>=2&&P.charCodeAt(1)===n.CharCode.Colon){const H=P.charCodeAt(0);H>=n.CharCode.A&&H<=n.CharCode.Z&&(P=`${String.fromCharCode(H+32)}:${P.substr(2)}`)}T+=D(P,!0,!1)}return q&&(T+="?",T+=D(q,!1,!1)),j&&(T+="#",T+=S?j:A(j,!1,!1)),T}function f(N){try{return decodeURIComponent(N)}catch{return N.length>3?N.substr(0,3)+f(N.substr(3)):N}}const p=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function I(N){return N.match(p)?N.replace(p,S=>f(S)):N}}),ie(re[24],ae([0,1,4,8,6,14,18]),function(C,t,n,i,M,m,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.COI=t.FileAccess=t.VSCODE_AUTHORITY=t.nodeModulesAsarUnpackedPath=t.nodeModulesAsarPath=t.nodeModulesPath=t.builtinExtensionsPath=t.RemoteAuthorities=t.connectionTokenQueryName=t.connectionTokenCookieName=t.Schemas=void 0,t.matchesScheme=o,t.matchesSomeScheme=a,t.getServerRootPath=_,n=ye(n),i=ye(i),R=ye(R);var b;(function(e){e.inMemory="inmemory",e.vscode="vscode",e.internal="private",e.walkThrough="walkThrough",e.walkThroughSnippet="walkThroughSnippet",e.http="http",e.https="https",e.file="file",e.mailto="mailto",e.untitled="untitled",e.data="data",e.command="command",e.vscodeRemote="vscode-remote",e.vscodeRemoteResource="vscode-remote-resource",e.vscodeManagedRemoteResource="vscode-managed-remote-resource",e.vscodeUserData="vscode-userdata",e.vscodeCustomEditor="vscode-custom-editor",e.vscodeNotebookCell="vscode-notebook-cell",e.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",e.vscodeNotebookCellMetadataDiff="vscode-notebook-cell-metadata-diff",e.vscodeNotebookCellOutput="vscode-notebook-cell-output",e.vscodeNotebookCellOutputDiff="vscode-notebook-cell-output-diff",e.vscodeNotebookMetadata="vscode-notebook-metadata",e.vscodeInteractiveInput="vscode-interactive-input",e.vscodeSettings="vscode-settings",e.vscodeWorkspaceTrust="vscode-workspace-trust",e.vscodeTerminal="vscode-terminal",e.vscodeChatCodeBlock="vscode-chat-code-block",e.vscodeChatCodeCompareBlock="vscode-chat-code-compare-block",e.vscodeChatSesssion="vscode-chat-editor",e.webviewPanel="webview-panel",e.vscodeWebview="vscode-webview",e.extension="extension",e.vscodeFileResource="vscode-file",e.tmp="tmp",e.vsls="vsls",e.vscodeSourceControl="vscode-scm",e.commentsInput="comment",e.codeSetting="code-setting",e.outputChannel="output"})(b||(t.Schemas=b={}));function o(e,u){return m.URI.isUri(e)?(0,M.equalsIgnoreCase)(e.scheme,u):(0,M.startsWithIgnoreCase)(e,u+":")}function a(e,...u){return u.some(g=>o(e,g))}t.connectionTokenCookieName="vscode-tkn",t.connectionTokenQueryName="tkn";class h{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._serverRootPath="/"}setPreferredWebSchema(u){this._preferredWebSchema=u}setDelegate(u){this._delegate=u}setServerRootPath(u,g){this._serverRootPath=_(u,g)}getServerRootPath(){return this._serverRootPath}get _remoteResourcesPath(){return R.posix.join(this._serverRootPath,b.vscodeRemoteResource)}set(u,g,E){this._hosts[u]=g,this._ports[u]=E}setConnectionToken(u,g){this._connectionTokens[u]=g}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(u){if(this._delegate)try{return this._delegate(u)}catch(L){return n.onUnexpectedError(L),u}const g=u.authority;let E=this._hosts[g];E&&E.indexOf(":")!==-1&&E.indexOf("[")===-1&&(E=`[${E}]`);const w=this._ports[g],v=this._connectionTokens[g];let A=`path=${encodeURIComponent(u.path)}`;return typeof v=="string"&&(A+=`&${t.connectionTokenQueryName}=${encodeURIComponent(v)}`),m.URI.from({scheme:i.isWeb?this._preferredWebSchema:b.vscodeRemoteResource,authority:`${E}:${w}`,path:this._remoteResourcesPath,query:A})}}t.RemoteAuthorities=new h;function _(e,u){return R.posix.join(u??"/",`${e.quality??"oss"}-${e.commit??"dev"}`)}t.builtinExtensionsPath="vs/../../extensions",t.nodeModulesPath="vs/../../node_modules",t.nodeModulesAsarPath="vs/../../node_modules.asar",t.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked",t.VSCODE_AUTHORITY="vscode-app";class d{static{this.FALLBACK_AUTHORITY=t.VSCODE_AUTHORITY}asBrowserUri(u){const g=this.toUri(u,C);return this.uriToBrowserUri(g)}uriToBrowserUri(u){return u.scheme===b.vscodeRemote?t.RemoteAuthorities.rewrite(u):u.scheme===b.file&&(i.isNative||i.webWorkerOrigin===`${b.vscodeFileResource}://${d.FALLBACK_AUTHORITY}`)?u.with({scheme:b.vscodeFileResource,authority:u.authority||d.FALLBACK_AUTHORITY,query:null,fragment:null}):u}asFileUri(u){const g=this.toUri(u,C);return this.uriToFileUri(g)}uriToFileUri(u){return u.scheme===b.vscodeFileResource?u.with({scheme:b.file,authority:u.authority!==d.FALLBACK_AUTHORITY?u.authority:null,query:null,fragment:null}):u}toUri(u,g){if(m.URI.isUri(u))return u;if(globalThis._VSCODE_FILE_ROOT){const E=globalThis._VSCODE_FILE_ROOT;if(/^\w[\w\d+.-]*:\/\//.test(E))return m.URI.joinPath(m.URI.parse(E,!0),u);const w=R.join(E,u);return m.URI.file(w)}return m.URI.parse(g.toUrl(u))}}t.FileAccess=new d;var c;(function(e){const u=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);e.CoopAndCoep=Object.freeze(u.get("3"));const g="vscode-coi";function E(v){let A;typeof v=="string"?A=new URL(v).searchParams:v instanceof URL?A=v.searchParams:m.URI.isUri(v)&&(A=new URL(v.toString(!0)).searchParams);const L=A?.get(g);if(L)return u.get(L)}e.getHeadersFromQuery=E;function w(v,A,L){if(!globalThis.crossOriginIsolated)return;const l=A&&L?"3":L?"2":"1";v instanceof URLSearchParams?v.set(g,l):v[g]=l}e.addSearchParam=w})(c||(t.COI=c={}))}),ie(re[78],ae([0,1,3,77,24,18,8,6,14]),function(C,t,n,i,M,m,R,b,o){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DataUri=t.addTrailingPathSeparator=t.removeTrailingPathSeparator=t.hasTrailingPathSeparator=t.isEqualAuthority=t.isAbsolutePath=t.resolvePath=t.relativePath=t.normalizePath=t.joinPath=t.dirname=t.extname=t.basename=t.basenameOrAuthority=t.getComparisonKey=t.isEqualOrParent=t.isEqual=t.extUriIgnorePathCase=t.extUriBiasedIgnorePathCase=t.extUri=t.ExtUri=void 0,t.originalFSPath=a,t.distinctParents=_,t.toLocalResource=c,i=ye(i),m=ye(m);function a(e){return(0,o.uriToFsPath)(e,!0)}class h{constructor(u){this._ignorePathCasing=u}compare(u,g,E=!1){return u===g?0:(0,b.compare)(this.getComparisonKey(u,E),this.getComparisonKey(g,E))}isEqual(u,g,E=!1){return u===g?!0:!u||!g?!1:this.getComparisonKey(u,E)===this.getComparisonKey(g,E)}getComparisonKey(u,g=!1){return u.with({path:this._ignorePathCasing(u)?u.path.toLowerCase():void 0,fragment:g?null:void 0}).toString()}ignorePathCasing(u){return this._ignorePathCasing(u)}isEqualOrParent(u,g,E=!1){if(u.scheme===g.scheme){if(u.scheme===M.Schemas.file)return i.isEqualOrParent(a(u),a(g),this._ignorePathCasing(u))&&u.query===g.query&&(E||u.fragment===g.fragment);if((0,t.isEqualAuthority)(u.authority,g.authority))return i.isEqualOrParent(u.path,g.path,this._ignorePathCasing(u),"/")&&u.query===g.query&&(E||u.fragment===g.fragment)}return!1}joinPath(u,...g){return o.URI.joinPath(u,...g)}basenameOrAuthority(u){return(0,t.basename)(u)||u.authority}basename(u){return m.posix.basename(u.path)}extname(u){return m.posix.extname(u.path)}dirname(u){if(u.path.length===0)return u;let g;return u.scheme===M.Schemas.file?g=o.URI.file(m.dirname(a(u))).path:(g=m.posix.dirname(u.path),u.authority&&g.length&&g.charCodeAt(0)!==n.CharCode.Slash&&(console.error(`dirname("${u.toString})) resulted in a relative path`),g="/")),u.with({path:g})}normalizePath(u){if(!u.path.length)return u;let g;return u.scheme===M.Schemas.file?g=o.URI.file(m.normalize(a(u))).path:g=m.posix.normalize(u.path),u.with({path:g})}relativePath(u,g){if(u.scheme!==g.scheme||!(0,t.isEqualAuthority)(u.authority,g.authority))return;if(u.scheme===M.Schemas.file){const v=m.relative(a(u),a(g));return R.isWindows?i.toSlashes(v):v}let E=u.path||"/";const w=g.path||"/";if(this._ignorePathCasing(u)){let v=0;for(const A=Math.min(E.length,w.length);v<A&&!(E.charCodeAt(v)!==w.charCodeAt(v)&&E.charAt(v).toLowerCase()!==w.charAt(v).toLowerCase());v++);E=w.substr(0,v)+E.substr(v)}return m.posix.relative(E,w)}resolvePath(u,g){if(u.scheme===M.Schemas.file){const E=o.URI.file(m.resolve(a(u),g));return u.with({authority:E.authority,path:E.path})}return g=i.toPosixPath(g),u.with({path:m.posix.resolve(u.path,g)})}isAbsolutePath(u){return!!u.path&&u.path[0]==="/"}isEqualAuthority(u,g){return u===g||u!==void 0&&g!==void 0&&(0,b.equalsIgnoreCase)(u,g)}hasTrailingPathSeparator(u,g=m.sep){if(u.scheme===M.Schemas.file){const E=a(u);return E.length>i.getRoot(E).length&&E[E.length-1]===g}else{const E=u.path;return E.length>1&&E.charCodeAt(E.length-1)===n.CharCode.Slash&&!/^[a-zA-Z]:(\/$|\\$)/.test(u.fsPath)}}removeTrailingPathSeparator(u,g=m.sep){return(0,t.hasTrailingPathSeparator)(u,g)?u.with({path:u.path.substr(0,u.path.length-1)}):u}addTrailingPathSeparator(u,g=m.sep){let E=!1;if(u.scheme===M.Schemas.file){const w=a(u);E=w!==void 0&&w.length===i.getRoot(w).length&&w[w.length-1]===g}else{g="/";const w=u.path;E=w.length===1&&w.charCodeAt(w.length-1)===n.CharCode.Slash}return!E&&!(0,t.hasTrailingPathSeparator)(u,g)?u.with({path:u.path+"/"}):u}}t.ExtUri=h,t.extUri=new h(()=>!1),t.extUriBiasedIgnorePathCase=new h(e=>e.scheme===M.Schemas.file?!R.isLinux:!0),t.extUriIgnorePathCase=new h(e=>!0),t.isEqual=t.extUri.isEqual.bind(t.extUri),t.isEqualOrParent=t.extUri.isEqualOrParent.bind(t.extUri),t.getComparisonKey=t.extUri.getComparisonKey.bind(t.extUri),t.basenameOrAuthority=t.extUri.basenameOrAuthority.bind(t.extUri),t.basename=t.extUri.basename.bind(t.extUri),t.extname=t.extUri.extname.bind(t.extUri),t.dirname=t.extUri.dirname.bind(t.extUri),t.joinPath=t.extUri.joinPath.bind(t.extUri),t.normalizePath=t.extUri.normalizePath.bind(t.extUri),t.relativePath=t.extUri.relativePath.bind(t.extUri),t.resolvePath=t.extUri.resolvePath.bind(t.extUri),t.isAbsolutePath=t.extUri.isAbsolutePath.bind(t.extUri),t.isEqualAuthority=t.extUri.isEqualAuthority.bind(t.extUri),t.hasTrailingPathSeparator=t.extUri.hasTrailingPathSeparator.bind(t.extUri),t.removeTrailingPathSeparator=t.extUri.removeTrailingPathSeparator.bind(t.extUri),t.addTrailingPathSeparator=t.extUri.addTrailingPathSeparator.bind(t.extUri);function _(e,u){const g=[];for(let E=0;E<e.length;E++){const w=u(e[E]);e.some((v,A)=>A===E?!1:(0,t.isEqualOrParent)(w,u(v)))||g.push(e[E])}return g}var d;(function(e){e.META_DATA_LABEL="label",e.META_DATA_DESCRIPTION="description",e.META_DATA_SIZE="size",e.META_DATA_MIME="mime";function u(g){const E=new Map;g.path.substring(g.path.indexOf(";")+1,g.path.lastIndexOf(";")).split(";").forEach(A=>{const[L,l]=A.split(":");L&&l&&E.set(L,l)});const v=g.path.substring(0,g.path.indexOf(";"));return v&&E.set(e.META_DATA_MIME,v),E}e.parseMetaData=u})(d||(t.DataUri=d={}));function c(e,u,g){if(u){let E=e.path;return E&&E[0]!==m.posix.sep&&(E=m.posix.sep+E),e.with({scheme:g,authority:u,path:E})}return e.with({scheme:g})}}),ie(re[79],ae([0,1,20,4,12,10,78,8,48,27]),function(C,t,n,i,M,m,R,b,o,a){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AsyncIterableSource=t.CancelableAsyncIterableObject=t.AsyncIterableObject=t.LazyStatefulPromise=t.StatefulPromise=t.Promises=t.DeferredPromise=t.IntervalCounter=t.TaskSequentializer=t.GlobalIdleValue=t.AbstractIdleValue=t._runWhenIdle=t.runWhenGlobalIdle=t.ThrottledWorker=t.RunOnceWorker=t.ProcessTimeRunOnceScheduler=t.RunOnceScheduler=t.IntervalTimer=t.TimeoutTimer=t.ResourceQueue=t.LimitedQueue=t.Queue=t.Limiter=t.AutoOpenBarrier=t.Barrier=t.ThrottledDelayer=t.Delayer=t.SequencerByKey=t.Sequencer=t.Throttler=void 0,t.isThenable=h,t.createCancelablePromise=_,t.raceCancellation=d,t.raceCancellationError=c,t.raceCancellablePromises=e,t.raceTimeout=u,t.asPromise=g,t.promiseWithResolvers=E,t.timeout=N,t.disposableTimeout=S,t.sequence=D,t.first=T,t.firstParallel=y,t.retry=$,t.createCancelableAsyncIterable=z;function h(x){return!!x&&typeof x.then=="function"}function _(x){const O=new n.CancellationTokenSource,U=x(O.token),X=new Promise((Q,le)=>{const Le=O.token.onCancellationRequested(()=>{Le.dispose(),le(new i.CancellationError)});Promise.resolve(U).then(ve=>{Le.dispose(),O.dispose(),Q(ve)},ve=>{Le.dispose(),O.dispose(),le(ve)})});return new class{cancel(){O.cancel(),O.dispose()}then(Q,le){return X.then(Q,le)}catch(Q){return this.then(void 0,Q)}finally(Q){return X.finally(Q)}}}function d(x,O,U){return new Promise((X,Q)=>{const le=O.onCancellationRequested(()=>{le.dispose(),X(U)});x.then(X,Q).finally(()=>le.dispose())})}function c(x,O){return new Promise((U,X)=>{const Q=O.onCancellationRequested(()=>{Q.dispose(),X(new i.CancellationError)});x.then(U,X).finally(()=>Q.dispose())})}async function e(x){let O=-1;const U=x.map((X,Q)=>X.then(le=>(O=Q,le)));try{return await Promise.race(U)}finally{x.forEach((X,Q)=>{Q!==O&&X.cancel()})}}function u(x,O,U){let X;const Q=setTimeout(()=>{X?.(void 0),U?.()},O);return Promise.race([x.finally(()=>clearTimeout(Q)),new Promise(le=>X=le)])}function g(x){return new Promise((O,U)=>{const X=x();h(X)?X.then(O,U):O(X)})}function E(){let x,O;return{promise:new Promise((X,Q)=>{x=X,O=Q}),resolve:x,reject:O}}class w{constructor(){this.isDisposed=!1,this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(O){if(this.isDisposed)return Promise.reject(new Error("Throttler is disposed"));if(this.activePromise){if(this.queuedPromiseFactory=O,!this.queuedPromise){const U=()=>{if(this.queuedPromise=null,this.isDisposed)return;const X=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,X};this.queuedPromise=new Promise(X=>{this.activePromise.then(U,U).then(X)})}return new Promise((U,X)=>{this.queuedPromise.then(U,X)})}return this.activePromise=O(),new Promise((U,X)=>{this.activePromise.then(Q=>{this.activePromise=null,U(Q)},Q=>{this.activePromise=null,X(Q)})})}dispose(){this.isDisposed=!0}}t.Throttler=w;class v{constructor(){this.current=Promise.resolve(null)}queue(O){return this.current=this.current.then(()=>O(),()=>O())}}t.Sequencer=v;class A{constructor(){this.promiseMap=new Map}queue(O,U){const Q=(this.promiseMap.get(O)??Promise.resolve()).catch(()=>{}).then(U).finally(()=>{this.promiseMap.get(O)===Q&&this.promiseMap.delete(O)});return this.promiseMap.set(O,Q),Q}}t.SequencerByKey=A;const L=(x,O)=>{let U=!0;const X=setTimeout(()=>{U=!1,O()},x);return{isTriggered:()=>U,dispose:()=>{clearTimeout(X),U=!1}}},l=x=>{let O=!0;return queueMicrotask(()=>{O&&(O=!1,x())}),{isTriggered:()=>O,dispose:()=>{O=!1}}};class s{constructor(O){this.defaultDelay=O,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(O,U=this.defaultDelay){this.task=O,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((Q,le)=>{this.doResolve=Q,this.doReject=le}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const Q=this.task;return this.task=null,Q()}}));const X=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=U===o.MicrotaskDelay?l(X):L(U,X),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new i.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}t.Delayer=s;class f{constructor(O){this.delayer=new s(O),this.throttler=new w}trigger(O,U){return this.delayer.trigger(()=>this.throttler.queue(O),U)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose(),this.throttler.dispose()}}t.ThrottledDelayer=f;class p{constructor(){this._isOpen=!1,this._promise=new Promise((O,U)=>{this._completePromise=O})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}t.Barrier=p;class I extends p{constructor(O){super(),this._timeout=setTimeout(()=>this.open(),O)}open(){clearTimeout(this._timeout),super.open()}}t.AutoOpenBarrier=I;function N(x,O){return O?new Promise((U,X)=>{const Q=setTimeout(()=>{le.dispose(),U()},x),le=O.onCancellationRequested(()=>{clearTimeout(Q),le.dispose(),X(new i.CancellationError)})}):_(U=>N(x,U))}function S(x,O=0,U){const X=setTimeout(()=>{x(),U&&Q.dispose()},O),Q=(0,m.toDisposable)(()=>{clearTimeout(X),U?.deleteAndLeak(Q)});return U?.add(Q),Q}function D(x){const O=[];let U=0;const X=x.length;function Q(){return U<X?x[U++]():null}function le(Le){Le!=null&&O.push(Le);const ve=Q();return ve?ve.then(le):Promise.resolve(O)}return Promise.resolve(null).then(le)}function T(x,O=X=>!!X,U=null){let X=0;const Q=x.length,le=()=>{if(X>=Q)return Promise.resolve(U);const Le=x[X++];return Promise.resolve(Le()).then(Ne=>O(Ne)?Promise.resolve(Ne):le())};return le()}function y(x,O=X=>!!X,U=null){if(x.length===0)return Promise.resolve(U);let X=x.length;const Q=()=>{X=-1;for(const le of x)le.cancel?.()};return new Promise((le,Le)=>{for(const ve of x)ve.then(Ne=>{--X>=0&&O(Ne)?(Q(),le(Ne)):X===0&&le(U)}).catch(Ne=>{--X>=0&&(Q(),Le(Ne))})})}class k{constructor(O){this._size=0,this._isDisposed=!1,this.maxDegreeOfParalellism=O,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new M.Emitter}whenIdle(){return this.size>0?M.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(O){if(this._isDisposed)throw new Error("Object has been disposed");return this._size++,new Promise((U,X)=>{this.outstandingPromises.push({factory:O,c:U,e:X}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const O=this.outstandingPromises.shift();this.runningPromises++;const U=O.factory();U.then(O.c,O.e),U.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._isDisposed||(this.runningPromises--,--this._size===0&&this._onDrained.fire(),this.outstandingPromises.length>0&&this.consume())}clear(){if(this._isDisposed)throw new Error("Object has been disposed");this.outstandingPromises.length=0,this._size=this.runningPromises}dispose(){this._isDisposed=!0,this.outstandingPromises.length=0,this._size=0,this._onDrained.dispose()}}t.Limiter=k;class P extends k{constructor(){super(1)}}t.Queue=P;class q{constructor(){this.sequentializer=new he,this.tasks=0}queue(O){return this.sequentializer.isRunning()?this.sequentializer.queue(()=>this.sequentializer.run(this.tasks++,O())):this.sequentializer.run(this.tasks++,O())}}t.LimitedQueue=q;class j{constructor(){this.queues=new Map,this.drainers=new Set,this.drainListeners=void 0,this.drainListenerCount=0}async whenDrained(){if(this.isDrained())return;const O=new r;return this.drainers.add(O),O.p}isDrained(){for(const[,O]of this.queues)if(O.size>0)return!1;return!0}queueSize(O,U=R.extUri){const X=U.getComparisonKey(O);return this.queues.get(X)?.size??0}queueFor(O,U,X=R.extUri){const Q=X.getComparisonKey(O);let le=this.queues.get(Q);if(!le){le=new P;const Le=this.drainListenerCount++,ve=M.Event.once(le.onDrained)(()=>{le?.dispose(),this.queues.delete(Q),this.onDidQueueDrain(),this.drainListeners?.deleteAndDispose(Le),this.drainListeners?.size===0&&(this.drainListeners.dispose(),this.drainListeners=void 0)});this.drainListeners||(this.drainListeners=new m.DisposableMap),this.drainListeners.set(Le,ve),this.queues.set(Q,le)}return le.queue(U)}onDidQueueDrain(){this.isDrained()&&this.releaseDrainers()}releaseDrainers(){for(const O of this.drainers)O.complete();this.drainers.clear()}dispose(){for(const[,O]of this.queues)O.dispose();this.queues.clear(),this.releaseDrainers(),this.drainListeners?.dispose()}}t.ResourceQueue=j;class H{constructor(O,U){this._isDisposed=!1,this._token=-1,typeof O=="function"&&typeof U=="number"&&this.setIfNotSet(O,U)}dispose(){this.cancel(),this._isDisposed=!0}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(O,U){if(this._isDisposed)throw new i.BugIndicatingError("Calling 'cancelAndSet' on a disposed TimeoutTimer");this.cancel(),this._token=setTimeout(()=>{this._token=-1,O()},U)}setIfNotSet(O,U){if(this._isDisposed)throw new i.BugIndicatingError("Calling 'setIfNotSet' on a disposed TimeoutTimer");this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,O()},U))}}t.TimeoutTimer=H;class W{constructor(){this.disposable=void 0,this.isDisposed=!1}cancel(){this.disposable?.dispose(),this.disposable=void 0}cancelAndSet(O,U,X=globalThis){if(this.isDisposed)throw new i.BugIndicatingError("Calling 'cancelAndSet' on a disposed IntervalTimer");this.cancel();const Q=X.setInterval(()=>{O()},U);this.disposable=(0,m.toDisposable)(()=>{X.clearInterval(Q),this.disposable=void 0})}dispose(){this.cancel(),this.isDisposed=!0}}t.IntervalTimer=W;class J{constructor(O,U){this.timeoutToken=-1,this.runner=O,this.timeout=U,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(O=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,O)}get delay(){return this.timeout}set delay(O){this.timeout=O}isScheduled(){return this.timeoutToken!==-1}flush(){this.isScheduled()&&(this.cancel(),this.doRun())}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}t.RunOnceScheduler=J;class ee{constructor(O,U){U%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${U}ms is not a multiple of 1000ms.`),this.runner=O,this.timeout=U,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(O=this.timeout){O%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${O}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(O/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}t.ProcessTimeRunOnceScheduler=ee;class Z extends J{constructor(O,U){super(O,U),this.units=[]}work(O){this.units.push(O),this.isScheduled()||this.schedule()}doRun(){const O=this.units;this.units=[],this.runner?.(O)}dispose(){this.units=[],super.dispose()}}t.RunOnceWorker=Z;class K extends m.Disposable{constructor(O,U){super(),this.options=O,this.handler=U,this.pendingWork=[],this.throttler=this._register(new m.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(O){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+O.length>this.options.maxBufferedWork)return!1}else if(this.pending+O.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}for(const U of O)this.pendingWork.push(U);return this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new J(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}t.ThrottledWorker=K,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?t._runWhenIdle=(x,O)=>{(0,b.setTimeout0)(()=>{if(U)return;const X=Date.now()+15;O(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,X-Date.now())}}))});let U=!1;return{dispose(){U||(U=!0)}}}:t._runWhenIdle=(x,O,U)=>{const X=x.requestIdleCallback(O,typeof U=="number"?{timeout:U}:void 0);let Q=!1;return{dispose(){Q||(Q=!0,x.cancelIdleCallback(X))}}},t.runWhenGlobalIdle=x=>(0,t._runWhenIdle)(globalThis,x)}();class ne{constructor(O,U){this._didRun=!1,this._executor=()=>{try{this._value=U()}catch(X){this._error=X}finally{this._didRun=!0}},this._handle=(0,t._runWhenIdle)(O,()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}t.AbstractIdleValue=ne;class F extends ne{constructor(O){super(globalThis,O)}}t.GlobalIdleValue=F;async function $(x,O,U){let X;for(let Q=0;Q<U;Q++)try{return await x()}catch(le){X=le,await N(O)}throw X}class he{isRunning(O){return typeof O=="number"?this._running?.taskId===O:!!this._running}get running(){return this._running?.promise}cancelRunning(){this._running?.cancel()}run(O,U,X){return this._running={taskId:O,cancel:()=>X?.(),promise:U},U.then(()=>this.doneRunning(O),()=>this.doneRunning(O)),U}doneRunning(O){this._running&&O===this._running.taskId&&(this._running=void 0,this.runQueued())}runQueued(){if(this._queued){const O=this._queued;this._queued=void 0,O.run().then(O.promiseResolve,O.promiseReject)}}queue(O){if(this._queued)this._queued.run=O;else{const{promise:U,resolve:X,reject:Q}=E();this._queued={run:O,promise:U,promiseResolve:X,promiseReject:Q}}return this._queued.promise}hasQueued(){return!!this._queued}async join(){return this._queued?.promise??this._running?.promise}}t.TaskSequentializer=he;class ge{constructor(O,U=()=>Date.now()){this.interval=O,this.nowFn=U,this.lastIncrementTime=0,this.value=0}increment(){const O=this.nowFn();return O-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=O,this.value=0),this.value++,this.value}}t.IntervalCounter=ge;var Ee;(function(x){x[x.Resolved=0]="Resolved",x[x.Rejected=1]="Rejected"})(Ee||(Ee={}));class r{get isRejected(){return this.outcome?.outcome===Ee.Rejected}get isResolved(){return this.outcome?.outcome===Ee.Resolved}get isSettled(){return!!this.outcome}get value(){return this.outcome?.outcome===Ee.Resolved?this.outcome?.value:void 0}constructor(){this.p=new Promise((O,U)=>{this.completeCallback=O,this.errorCallback=U})}complete(O){return new Promise(U=>{this.completeCallback(O),this.outcome={outcome:Ee.Resolved,value:O},U()})}error(O){return new Promise(U=>{this.errorCallback(O),this.outcome={outcome:Ee.Rejected,value:O},U()})}cancel(){return this.error(new i.CancellationError)}}t.DeferredPromise=r;var Te;(function(x){async function O(X){let Q;const le=await Promise.all(X.map(Le=>Le.then(ve=>ve,ve=>{Q||(Q=ve)})));if(typeof Q<"u")throw Q;return le}x.settled=O;function U(X){return new Promise(async(Q,le)=>{try{await X(Q,le)}catch(Le){le(Le)}})}x.withAsyncBody=U})(Te||(t.Promises=Te={}));class ke{get value(){return this._value}get error(){return this._error}get isResolved(){return this._isResolved}constructor(O){this._value=void 0,this._error=void 0,this._isResolved=!1,this.promise=O.then(U=>(this._value=U,this._isResolved=!0,U),U=>{throw this._error=U,this._isResolved=!0,U})}requireValue(){if(!this._isResolved)throw new i.BugIndicatingError("Promise is not resolved yet");if(this._error)throw this._error;return this._value}}t.StatefulPromise=ke;class We{constructor(O){this._compute=O,this._promise=new a.Lazy(()=>new ke(this._compute()))}requireValue(){return this._promise.value.requireValue()}getPromise(){return this._promise.value.promise}get currentValue(){return this._promise.rawValue?.value}}t.LazyStatefulPromise=We;var Re;(function(x){x[x.Initial=0]="Initial",x[x.DoneOK=1]="DoneOK",x[x.DoneError=2]="DoneError"})(Re||(Re={}));class we{static fromArray(O){return new we(U=>{U.emitMany(O)})}static fromPromise(O){return new we(async U=>{U.emitMany(await O)})}static fromPromises(O){return new we(async U=>{await Promise.all(O.map(async X=>U.emitOne(await X)))})}static merge(O){return new we(async U=>{await Promise.all(O.map(async X=>{for await(const Q of X)U.emitOne(Q)}))})}static{this.EMPTY=we.fromArray([])}constructor(O,U){this._state=Re.Initial,this._results=[],this._error=null,this._onReturn=U,this._onStateChanged=new M.Emitter,queueMicrotask(async()=>{const X={emitOne:Q=>this.emitOne(Q),emitMany:Q=>this.emitMany(Q),reject:Q=>this.reject(Q)};try{await Promise.resolve(O(X)),this.resolve()}catch(Q){this.reject(Q)}finally{X.emitOne=void 0,X.emitMany=void 0,X.reject=void 0}})}[Symbol.asyncIterator](){let O=0;return{next:async()=>{do{if(this._state===Re.DoneError)throw this._error;if(O<this._results.length)return{done:!1,value:this._results[O++]};if(this._state===Re.DoneOK)return{done:!0,value:void 0};await M.Event.toPromise(this._onStateChanged.event)}while(!0)},return:async()=>(this._onReturn?.(),{done:!0,value:void 0})}}static map(O,U){return new we(async X=>{for await(const Q of O)X.emitOne(U(Q))})}map(O){return we.map(this,O)}static filter(O,U){return new we(async X=>{for await(const Q of O)U(Q)&&X.emitOne(Q)})}filter(O){return we.filter(this,O)}static coalesce(O){return we.filter(O,U=>!!U)}coalesce(){return we.coalesce(this)}static async toPromise(O){const U=[];for await(const X of O)U.push(X);return U}toPromise(){return we.toPromise(this)}emitOne(O){this._state===Re.Initial&&(this._results.push(O),this._onStateChanged.fire())}emitMany(O){this._state===Re.Initial&&(this._results=this._results.concat(O),this._onStateChanged.fire())}resolve(){this._state===Re.Initial&&(this._state=Re.DoneOK,this._onStateChanged.fire())}reject(O){this._state===Re.Initial&&(this._state=Re.DoneError,this._error=O,this._onStateChanged.fire())}}t.AsyncIterableObject=we;class Ue extends we{constructor(O,U){super(U),this._source=O}cancel(){this._source.cancel()}}t.CancelableAsyncIterableObject=Ue;function z(x){const O=new n.CancellationTokenSource,U=x(O.token);return new Ue(O,async X=>{const Q=O.token.onCancellationRequested(()=>{Q.dispose(),O.dispose(),X.reject(new i.CancellationError)});try{for await(const le of U){if(O.token.isCancellationRequested)return;X.emitOne(le)}Q.dispose(),O.dispose()}catch(le){Q.dispose(),O.dispose(),X.reject(le)}})}class G{constructor(O){this._deferred=new r,this._asyncIterable=new we(Q=>{if(U){Q.reject(U);return}return X&&Q.emitMany(X),this._errorFn=le=>Q.reject(le),this._emitFn=le=>Q.emitOne(le),this._deferred.p},O);let U,X;this._emitFn=Q=>{X||(X=[]),X.push(Q)},this._errorFn=Q=>{U||(U=Q)}}get asyncIterable(){return this._asyncIterable}resolve(){this._deferred.complete()}reject(O){this._errorFn(O),this._deferred.complete()}emitOne(O){this._emitFn(O)}}t.AsyncIterableSource=G}),ie(re[84],ae([0,1,3,4,12,10,24,8,6]),function(C,t,n,i,M,m,R,b,o){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SimpleWorkerServer=t.SimpleWorkerClient=void 0,t.logOnceWebWorkerWarning=c,t.create=p,o=ye(o);const a=!1,h="default",_="$initialize";let d=!1;function c(I){b.isWeb&&(d||(d=!0,console.warn("Could not create web worker(s). Falling back to loading web worker code in main thread, which might cause UI freezes. Please see https://github.com/microsoft/monaco-editor#faq")),console.warn(I.message))}var e;(function(I){I[I.Request=0]="Request",I[I.Reply=1]="Reply",I[I.SubscribeEvent=2]="SubscribeEvent",I[I.Event=3]="Event",I[I.UnsubscribeEvent=4]="UnsubscribeEvent"})(e||(e={}));class u{constructor(N,S,D,T,y){this.vsWorker=N,this.req=S,this.channel=D,this.method=T,this.args=y,this.type=e.Request}}class g{constructor(N,S,D,T){this.vsWorker=N,this.seq=S,this.res=D,this.err=T,this.type=e.Reply}}class E{constructor(N,S,D,T,y){this.vsWorker=N,this.req=S,this.channel=D,this.eventName=T,this.arg=y,this.type=e.SubscribeEvent}}class w{constructor(N,S,D){this.vsWorker=N,this.req=S,this.event=D,this.type=e.Event}}class v{constructor(N,S){this.vsWorker=N,this.req=S,this.type=e.UnsubscribeEvent}}class A{constructor(N){this._workerId=-1,this._handler=N,this._lastSentReq=0,this._pendingReplies=Object.create(null),this._pendingEmitters=new Map,this._pendingEvents=new Map}setWorkerId(N){this._workerId=N}sendMessage(N,S,D){const T=String(++this._lastSentReq);return new Promise((y,k)=>{this._pendingReplies[T]={resolve:y,reject:k},this._send(new u(this._workerId,T,N,S,D))})}listen(N,S,D){let T=null;const y=new M.Emitter({onWillAddFirstListener:()=>{T=String(++this._lastSentReq),this._pendingEmitters.set(T,y),this._send(new E(this._workerId,T,N,S,D))},onDidRemoveLastListener:()=>{this._pendingEmitters.delete(T),this._send(new v(this._workerId,T)),T=null}});return y.event}handleMessage(N){!N||!N.vsWorker||this._workerId!==-1&&N.vsWorker!==this._workerId||this._handleMessage(N)}createProxyToRemoteChannel(N,S){const D={get:(T,y)=>(typeof y=="string"&&!T[y]&&(s(y)?T[y]=k=>this.listen(N,y,k):l(y)?T[y]=this.listen(N,y,void 0):y.charCodeAt(0)===n.CharCode.DollarSign&&(T[y]=async(...k)=>(await S?.(),this.sendMessage(N,y,k)))),T[y])};return new Proxy(Object.create(null),D)}_handleMessage(N){switch(N.type){case e.Reply:return this._handleReplyMessage(N);case e.Request:return this._handleRequestMessage(N);case e.SubscribeEvent:return this._handleSubscribeEventMessage(N);case e.Event:return this._handleEventMessage(N);case e.UnsubscribeEvent:return this._handleUnsubscribeEventMessage(N)}}_handleReplyMessage(N){if(!this._pendingReplies[N.seq]){console.warn("Got reply to unknown seq");return}const S=this._pendingReplies[N.seq];if(delete this._pendingReplies[N.seq],N.err){let D=N.err;N.err.$isError&&(D=new Error,D.name=N.err.name,D.message=N.err.message,D.stack=N.err.stack),S.reject(D);return}S.resolve(N.res)}_handleRequestMessage(N){const S=N.req;this._handler.handleMessage(N.channel,N.method,N.args).then(T=>{this._send(new g(this._workerId,S,T,void 0))},T=>{T.detail instanceof Error&&(T.detail=(0,i.transformErrorForSerialization)(T.detail)),this._send(new g(this._workerId,S,void 0,(0,i.transformErrorForSerialization)(T)))})}_handleSubscribeEventMessage(N){const S=N.req,D=this._handler.handleEvent(N.channel,N.eventName,N.arg)(T=>{this._send(new w(this._workerId,S,T))});this._pendingEvents.set(S,D)}_handleEventMessage(N){if(!this._pendingEmitters.has(N.req)){console.warn("Got event for unknown req");return}this._pendingEmitters.get(N.req).fire(N.event)}_handleUnsubscribeEventMessage(N){if(!this._pendingEvents.has(N.req)){console.warn("Got unsubscribe for unknown req");return}this._pendingEvents.get(N.req).dispose(),this._pendingEvents.delete(N.req)}_send(N){const S=[];if(N.type===e.Request)for(let D=0;D<N.args.length;D++)N.args[D]instanceof ArrayBuffer&&S.push(N.args[D]);else N.type===e.Reply&&N.res instanceof ArrayBuffer&&S.push(N.res);this._handler.sendMessage(N,S)}}class L extends m.Disposable{constructor(N,S){super(),this._localChannels=new Map,this._remoteChannels=new Map,this._worker=this._register(N.create({amdModuleId:"vs/base/common/worker/simpleWorker",esmModuleLocation:S.esmModuleLocation,label:S.label},y=>{this._protocol.handleMessage(y)},y=>{(0,i.onUnexpectedError)(y)})),this._protocol=new A({sendMessage:(y,k)=>{this._worker.postMessage(y,k)},handleMessage:(y,k,P)=>this._handleMessage(y,k,P),handleEvent:(y,k,P)=>this._handleEvent(y,k,P)}),this._protocol.setWorkerId(this._worker.getId());let D=null;const T=globalThis.require;typeof T<"u"&&typeof T.getConfig=="function"?D=T.getConfig():typeof globalThis.requirejs<"u"&&(D=globalThis.requirejs.s.contexts._.config),this._onModuleLoaded=this._protocol.sendMessage(h,_,[this._worker.getId(),JSON.parse(JSON.stringify(D)),S.amdModuleId]),this.proxy=this._protocol.createProxyToRemoteChannel(h,async()=>{await this._onModuleLoaded}),this._onModuleLoaded.catch(y=>{this._onError("Worker failed to load "+S.amdModuleId,y)})}_handleMessage(N,S,D){const T=this._localChannels.get(N);if(!T)return Promise.reject(new Error(`Missing channel ${N} on main thread`));if(typeof T[S]!="function")return Promise.reject(new Error(`Missing method ${S} on main thread channel ${N}`));try{return Promise.resolve(T[S].apply(T,D))}catch(y){return Promise.reject(y)}}_handleEvent(N,S,D){const T=this._localChannels.get(N);if(!T)throw new Error(`Missing channel ${N} on main thread`);if(s(S)){const y=T[S].call(T,D);if(typeof y!="function")throw new Error(`Missing dynamic event ${S} on main thread channel ${N}.`);return y}if(l(S)){const y=T[S];if(typeof y!="function")throw new Error(`Missing event ${S} on main thread channel ${N}.`);return y}throw new Error(`Malformed event name ${S}`)}setChannel(N,S){this._localChannels.set(N,S)}getChannel(N){if(!this._remoteChannels.has(N)){const S=this._protocol.createProxyToRemoteChannel(N,async()=>{await this._onModuleLoaded});this._remoteChannels.set(N,S)}return this._remoteChannels.get(N)}_onError(N,S){console.error(N),console.info(S)}}t.SimpleWorkerClient=L;function l(I){return I[0]==="o"&&I[1]==="n"&&o.isUpperAsciiLetter(I.charCodeAt(2))}function s(I){return/^onDynamic/.test(I)&&o.isUpperAsciiLetter(I.charCodeAt(9))}class f{constructor(N,S){this._localChannels=new Map,this._remoteChannels=new Map,this._requestHandlerFactory=S,this._requestHandler=null,this._protocol=new A({sendMessage:(D,T)=>{N(D,T)},handleMessage:(D,T,y)=>this._handleMessage(D,T,y),handleEvent:(D,T,y)=>this._handleEvent(D,T,y)})}onmessage(N){this._protocol.handleMessage(N)}_handleMessage(N,S,D){if(N===h&&S===_)return this.initialize(D[0],D[1],D[2]);const T=N===h?this._requestHandler:this._localChannels.get(N);if(!T)return Promise.reject(new Error(`Missing channel ${N} on worker thread`));if(typeof T[S]!="function")return Promise.reject(new Error(`Missing method ${S} on worker thread channel ${N}`));try{return Promise.resolve(T[S].apply(T,D))}catch(y){return Promise.reject(y)}}_handleEvent(N,S,D){const T=N===h?this._requestHandler:this._localChannels.get(N);if(!T)throw new Error(`Missing channel ${N} on worker thread`);if(s(S)){const y=T[S].call(T,D);if(typeof y!="function")throw new Error(`Missing dynamic event ${S} on request handler.`);return y}if(l(S)){const y=T[S];if(typeof y!="function")throw new Error(`Missing event ${S} on request handler.`);return y}throw new Error(`Malformed event name ${S}`)}setChannel(N,S){this._localChannels.set(N,S)}getChannel(N){if(!this._remoteChannels.has(N)){const S=this._protocol.createProxyToRemoteChannel(N);this._remoteChannels.set(N,S)}return this._remoteChannels.get(N)}async initialize(N,S,D){if(this._protocol.setWorkerId(N),this._requestHandlerFactory){this._requestHandler=this._requestHandlerFactory(this);return}if(S&&(typeof S.baseUrl<"u"&&delete S.baseUrl,typeof S.paths<"u"&&typeof S.paths.vs<"u"&&delete S.paths.vs,typeof S.trustedTypesPolicy<"u"&&delete S.trustedTypesPolicy,S.catchError=!0,globalThis.require.config(S)),a){const T=R.FileAccess.asBrowserUri(`${D}.js`).toString(!0);return new Promise((y,k)=>{C([`${T}`],y,k)}).then(ye).then(y=>{if(this._requestHandler=y.create(this),!this._requestHandler)throw new Error("No RequestHandler!")})}return new Promise((T,y)=>{(globalThis.require||C)([D],P=>{if(this._requestHandler=P.create(this),!this._requestHandler){y(new Error("No RequestHandler!"));return}T()},y)})}}t.SimpleWorkerServer=f;function p(I){return new f(I,null)}}),ie(re[80],ae([0,1,50,14,52,2,75,41]),function(C,t,n,i,M,m,R,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.InlineEditTriggerKind=t.ExternalUriOpenerPriority=t.TreeSitterTokenizationRegistry=t.TokenizationRegistry=t.LazyTokenizationSupport=t.InlayHintKind=t.CommentState=t.CommentMode=t.CommentThreadApplicability=t.CommentThreadState=t.CommentThreadCollapsibleState=t.Command=t.NewSymbolNameTriggerKind=t.NewSymbolNameTag=t.FoldingRangeKind=t.TextEdit=t.SymbolKinds=t.SymbolTag=t.symbolKindNames=t.SymbolKind=t.DocumentHighlightKind=t.SignatureHelpTriggerKind=t.DocumentPasteTriggerKind=t.CodeActionTriggerType=t.SelectedSuggestionInfo=t.InlineCompletionTriggerKind=t.CompletionTriggerKind=t.PartialAcceptTriggerKind=t.CompletionItemInsertTextRule=t.CompletionItemTag=t.CompletionItemKinds=t.CompletionItemKind=t.HoverVerbosityAction=t.EncodedTokenizationResult=t.TokenizationResult=t.Token=void 0,t.isLocationLink=f,t.getAriaLabelForSymbol=I;class o{constructor($,he,ge){this.offset=$,this.type=he,this.language=ge,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}t.Token=o;class a{constructor($,he){this.tokens=$,this.endState=he,this._tokenizationResultBrand=void 0}}t.TokenizationResult=a;class h{constructor($,he){this.tokens=$,this.endState=he,this._encodedTokenizationResultBrand=void 0}}t.EncodedTokenizationResult=h;var _;(function(F){F[F.Increase=0]="Increase",F[F.Decrease=1]="Decrease"})(_||(t.HoverVerbosityAction=_={}));var d;(function(F){F[F.Method=0]="Method",F[F.Function=1]="Function",F[F.Constructor=2]="Constructor",F[F.Field=3]="Field",F[F.Variable=4]="Variable",F[F.Class=5]="Class",F[F.Struct=6]="Struct",F[F.Interface=7]="Interface",F[F.Module=8]="Module",F[F.Property=9]="Property",F[F.Event=10]="Event",F[F.Operator=11]="Operator",F[F.Unit=12]="Unit",F[F.Value=13]="Value",F[F.Constant=14]="Constant",F[F.Enum=15]="Enum",F[F.EnumMember=16]="EnumMember",F[F.Keyword=17]="Keyword",F[F.Text=18]="Text",F[F.Color=19]="Color",F[F.File=20]="File",F[F.Reference=21]="Reference",F[F.Customcolor=22]="Customcolor",F[F.Folder=23]="Folder",F[F.TypeParameter=24]="TypeParameter",F[F.User=25]="User",F[F.Issue=26]="Issue",F[F.Snippet=27]="Snippet"})(d||(t.CompletionItemKind=d={}));var c;(function(F){const $=new Map;$.set(d.Method,n.Codicon.symbolMethod),$.set(d.Function,n.Codicon.symbolFunction),$.set(d.Constructor,n.Codicon.symbolConstructor),$.set(d.Field,n.Codicon.symbolField),$.set(d.Variable,n.Codicon.symbolVariable),$.set(d.Class,n.Codicon.symbolClass),$.set(d.Struct,n.Codicon.symbolStruct),$.set(d.Interface,n.Codicon.symbolInterface),$.set(d.Module,n.Codicon.symbolModule),$.set(d.Property,n.Codicon.symbolProperty),$.set(d.Event,n.Codicon.symbolEvent),$.set(d.Operator,n.Codicon.symbolOperator),$.set(d.Unit,n.Codicon.symbolUnit),$.set(d.Value,n.Codicon.symbolValue),$.set(d.Enum,n.Codicon.symbolEnum),$.set(d.Constant,n.Codicon.symbolConstant),$.set(d.Enum,n.Codicon.symbolEnum),$.set(d.EnumMember,n.Codicon.symbolEnumMember),$.set(d.Keyword,n.Codicon.symbolKeyword),$.set(d.Snippet,n.Codicon.symbolSnippet),$.set(d.Text,n.Codicon.symbolText),$.set(d.Color,n.Codicon.symbolColor),$.set(d.File,n.Codicon.symbolFile),$.set(d.Reference,n.Codicon.symbolReference),$.set(d.Customcolor,n.Codicon.symbolCustomColor),$.set(d.Folder,n.Codicon.symbolFolder),$.set(d.TypeParameter,n.Codicon.symbolTypeParameter),$.set(d.User,n.Codicon.account),$.set(d.Issue,n.Codicon.issues);function he(r){let Te=$.get(r);return Te||(console.info("No codicon found for CompletionItemKind "+r),Te=n.Codicon.symbolProperty),Te}F.toIcon=he;const ge=new Map;ge.set("method",d.Method),ge.set("function",d.Function),ge.set("constructor",d.Constructor),ge.set("field",d.Field),ge.set("variable",d.Variable),ge.set("class",d.Class),ge.set("struct",d.Struct),ge.set("interface",d.Interface),ge.set("module",d.Module),ge.set("property",d.Property),ge.set("event",d.Event),ge.set("operator",d.Operator),ge.set("unit",d.Unit),ge.set("value",d.Value),ge.set("constant",d.Constant),ge.set("enum",d.Enum),ge.set("enum-member",d.EnumMember),ge.set("enumMember",d.EnumMember),ge.set("keyword",d.Keyword),ge.set("snippet",d.Snippet),ge.set("text",d.Text),ge.set("color",d.Color),ge.set("file",d.File),ge.set("reference",d.Reference),ge.set("customcolor",d.Customcolor),ge.set("folder",d.Folder),ge.set("type-parameter",d.TypeParameter),ge.set("typeParameter",d.TypeParameter),ge.set("account",d.User),ge.set("issue",d.Issue);function Ee(r,Te){let ke=ge.get(r);return typeof ke>"u"&&!Te&&(ke=d.Property),ke}F.fromString=Ee})(c||(t.CompletionItemKinds=c={}));var e;(function(F){F[F.Deprecated=1]="Deprecated"})(e||(t.CompletionItemTag=e={}));var u;(function(F){F[F.None=0]="None",F[F.KeepWhitespace=1]="KeepWhitespace",F[F.InsertAsSnippet=4]="InsertAsSnippet"})(u||(t.CompletionItemInsertTextRule=u={}));var g;(function(F){F[F.Word=0]="Word",F[F.Line=1]="Line",F[F.Suggest=2]="Suggest"})(g||(t.PartialAcceptTriggerKind=g={}));var E;(function(F){F[F.Invoke=0]="Invoke",F[F.TriggerCharacter=1]="TriggerCharacter",F[F.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(E||(t.CompletionTriggerKind=E={}));var w;(function(F){F[F.Automatic=0]="Automatic",F[F.Explicit=1]="Explicit"})(w||(t.InlineCompletionTriggerKind=w={}));class v{constructor($,he,ge,Ee){this.range=$,this.text=he,this.completionKind=ge,this.isSnippetText=Ee}equals($){return m.Range.lift(this.range).equalsRange($.range)&&this.text===$.text&&this.completionKind===$.completionKind&&this.isSnippetText===$.isSnippetText}}t.SelectedSuggestionInfo=v;var A;(function(F){F[F.Invoke=1]="Invoke",F[F.Auto=2]="Auto"})(A||(t.CodeActionTriggerType=A={}));var L;(function(F){F[F.Automatic=0]="Automatic",F[F.PasteAs=1]="PasteAs"})(L||(t.DocumentPasteTriggerKind=L={}));var l;(function(F){F[F.Invoke=1]="Invoke",F[F.TriggerCharacter=2]="TriggerCharacter",F[F.ContentChange=3]="ContentChange"})(l||(t.SignatureHelpTriggerKind=l={}));var s;(function(F){F[F.Text=0]="Text",F[F.Read=1]="Read",F[F.Write=2]="Write"})(s||(t.DocumentHighlightKind=s={}));function f(F){return F&&i.URI.isUri(F.uri)&&m.Range.isIRange(F.range)&&(m.Range.isIRange(F.originSelectionRange)||m.Range.isIRange(F.targetSelectionRange))}var p;(function(F){F[F.File=0]="File",F[F.Module=1]="Module",F[F.Namespace=2]="Namespace",F[F.Package=3]="Package",F[F.Class=4]="Class",F[F.Method=5]="Method",F[F.Property=6]="Property",F[F.Field=7]="Field",F[F.Constructor=8]="Constructor",F[F.Enum=9]="Enum",F[F.Interface=10]="Interface",F[F.Function=11]="Function",F[F.Variable=12]="Variable",F[F.Constant=13]="Constant",F[F.String=14]="String",F[F.Number=15]="Number",F[F.Boolean=16]="Boolean",F[F.Array=17]="Array",F[F.Object=18]="Object",F[F.Key=19]="Key",F[F.Null=20]="Null",F[F.EnumMember=21]="EnumMember",F[F.Struct=22]="Struct",F[F.Event=23]="Event",F[F.Operator=24]="Operator",F[F.TypeParameter=25]="TypeParameter"})(p||(t.SymbolKind=p={})),t.symbolKindNames={[p.Array]:(0,b.localize)(788,null),[p.Boolean]:(0,b.localize)(789,null),[p.Class]:(0,b.localize)(790,null),[p.Constant]:(0,b.localize)(791,null),[p.Constructor]:(0,b.localize)(792,null),[p.Enum]:(0,b.localize)(793,null),[p.EnumMember]:(0,b.localize)(794,null),[p.Event]:(0,b.localize)(795,null),[p.Field]:(0,b.localize)(796,null),[p.File]:(0,b.localize)(797,null),[p.Function]:(0,b.localize)(798,null),[p.Interface]:(0,b.localize)(799,null),[p.Key]:(0,b.localize)(800,null),[p.Method]:(0,b.localize)(801,null),[p.Module]:(0,b.localize)(802,null),[p.Namespace]:(0,b.localize)(803,null),[p.Null]:(0,b.localize)(804,null),[p.Number]:(0,b.localize)(805,null),[p.Object]:(0,b.localize)(806,null),[p.Operator]:(0,b.localize)(807,null),[p.Package]:(0,b.localize)(808,null),[p.Property]:(0,b.localize)(809,null),[p.String]:(0,b.localize)(810,null),[p.Struct]:(0,b.localize)(811,null),[p.TypeParameter]:(0,b.localize)(812,null),[p.Variable]:(0,b.localize)(813,null)};function I(F,$){return(0,b.localize)(814,null,F,t.symbolKindNames[$])}var N;(function(F){F[F.Deprecated=1]="Deprecated"})(N||(t.SymbolTag=N={}));var S;(function(F){const $=new Map;$.set(p.File,n.Codicon.symbolFile),$.set(p.Module,n.Codicon.symbolModule),$.set(p.Namespace,n.Codicon.symbolNamespace),$.set(p.Package,n.Codicon.symbolPackage),$.set(p.Class,n.Codicon.symbolClass),$.set(p.Method,n.Codicon.symbolMethod),$.set(p.Property,n.Codicon.symbolProperty),$.set(p.Field,n.Codicon.symbolField),$.set(p.Constructor,n.Codicon.symbolConstructor),$.set(p.Enum,n.Codicon.symbolEnum),$.set(p.Interface,n.Codicon.symbolInterface),$.set(p.Function,n.Codicon.symbolFunction),$.set(p.Variable,n.Codicon.symbolVariable),$.set(p.Constant,n.Codicon.symbolConstant),$.set(p.String,n.Codicon.symbolString),$.set(p.Number,n.Codicon.symbolNumber),$.set(p.Boolean,n.Codicon.symbolBoolean),$.set(p.Array,n.Codicon.symbolArray),$.set(p.Object,n.Codicon.symbolObject),$.set(p.Key,n.Codicon.symbolKey),$.set(p.Null,n.Codicon.symbolNull),$.set(p.EnumMember,n.Codicon.symbolEnumMember),$.set(p.Struct,n.Codicon.symbolStruct),$.set(p.Event,n.Codicon.symbolEvent),$.set(p.Operator,n.Codicon.symbolOperator),$.set(p.TypeParameter,n.Codicon.symbolTypeParameter);function he(ge){let Ee=$.get(ge);return Ee||(console.info("No codicon found for SymbolKind "+ge),Ee=n.Codicon.symbolProperty),Ee}F.toIcon=he})(S||(t.SymbolKinds=S={}));class D{static asEditOperation($){return M.EditOperation.replace(m.Range.lift($.range),$.text)}}t.TextEdit=D;class T{static{this.Comment=new T("comment")}static{this.Imports=new T("imports")}static{this.Region=new T("region")}static fromValue($){switch($){case"comment":return T.Comment;case"imports":return T.Imports;case"region":return T.Region}return new T($)}constructor($){this.value=$}}t.FoldingRangeKind=T;var y;(function(F){F[F.AIGenerated=1]="AIGenerated"})(y||(t.NewSymbolNameTag=y={}));var k;(function(F){F[F.Invoke=0]="Invoke",F[F.Automatic=1]="Automatic"})(k||(t.NewSymbolNameTriggerKind=k={}));var P;(function(F){function $(he){return!he||typeof he!="object"?!1:typeof he.id=="string"&&typeof he.title=="string"}F.is=$})(P||(t.Command=P={}));var q;(function(F){F[F.Collapsed=0]="Collapsed",F[F.Expanded=1]="Expanded"})(q||(t.CommentThreadCollapsibleState=q={}));var j;(function(F){F[F.Unresolved=0]="Unresolved",F[F.Resolved=1]="Resolved"})(j||(t.CommentThreadState=j={}));var H;(function(F){F[F.Current=0]="Current",F[F.Outdated=1]="Outdated"})(H||(t.CommentThreadApplicability=H={}));var W;(function(F){F[F.Editing=0]="Editing",F[F.Preview=1]="Preview"})(W||(t.CommentMode=W={}));var J;(function(F){F[F.Published=0]="Published",F[F.Draft=1]="Draft"})(J||(t.CommentState=J={}));var ee;(function(F){F[F.Type=1]="Type",F[F.Parameter=2]="Parameter"})(ee||(t.InlayHintKind=ee={}));class Z{constructor($){this.createSupport=$,this._tokenizationSupport=null}dispose(){this._tokenizationSupport&&this._tokenizationSupport.then($=>{$&&$.dispose()})}get tokenizationSupport(){return this._tokenizationSupport||(this._tokenizationSupport=this.createSupport()),this._tokenizationSupport}}t.LazyTokenizationSupport=Z,t.TokenizationRegistry=new R.TokenizationRegistry,t.TreeSitterTokenizationRegistry=new R.TokenizationRegistry;var K;(function(F){F[F.None=0]="None",F[F.Option=1]="Option",F[F.Default=2]="Default",F[F.Preferred=3]="Preferred"})(K||(t.ExternalUriOpenerPriority=K={}));var ne;(function(F){F[F.Invoke=0]="Invoke",F[F.Automatic=1]="Automatic"})(ne||(t.InlineEditTriggerKind=ne={}))}),ie(re[81],ae([0,1,20,12,45,14,5,2,53,80,74]),function(C,t,n,i,M,m,R,b,o,a,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.KeyMod=void 0,t.createMonacoBaseAPI=d,h=ye(h);class _{static{this.CtrlCmd=M.KeyMod.CtrlCmd}static{this.Shift=M.KeyMod.Shift}static{this.Alt=M.KeyMod.Alt}static{this.WinCtrl=M.KeyMod.WinCtrl}static chord(e,u){return(0,M.KeyChord)(e,u)}}t.KeyMod=_;function d(){return{editor:void 0,languages:void 0,CancellationTokenSource:n.CancellationTokenSource,Emitter:i.Emitter,KeyCode:h.KeyCode,KeyMod:_,Position:R.Position,Range:b.Range,Selection:o.Selection,SelectionDirection:h.SelectionDirection,MarkerSeverity:h.MarkerSeverity,MarkerTag:h.MarkerTag,Uri:m.URI,Token:a.Token}}}),ie(re[82],ae([0,1,79,10,14,5,2,35,69]),function(C,t,n,i,M,m,R,b,o){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.MirrorModel=t.WorkerTextModelSyncServer=t.WorkerTextModelSyncClient=t.WORKER_TEXT_MODEL_SYNC_CHANNEL=t.STOP_SYNC_MODEL_DELTA_TIME_MS=void 0,t.STOP_SYNC_MODEL_DELTA_TIME_MS=60*1e3,t.WORKER_TEXT_MODEL_SYNC_CHANNEL="workerTextModelSync";class a extends i.Disposable{static create(c,e){return new a(c.getChannel(t.WORKER_TEXT_MODEL_SYNC_CHANNEL),e)}constructor(c,e,u=!1){if(super(),this._syncedModels=Object.create(null),this._syncedModelsLastUsedTime=Object.create(null),this._proxy=c,this._modelService=e,!u){const g=new n.IntervalTimer;g.cancelAndSet(()=>this._checkStopModelSync(),Math.round(t.STOP_SYNC_MODEL_DELTA_TIME_MS/2)),this._register(g)}}dispose(){for(const c in this._syncedModels)(0,i.dispose)(this._syncedModels[c]);this._syncedModels=Object.create(null),this._syncedModelsLastUsedTime=Object.create(null),super.dispose()}ensureSyncedResources(c,e=!1){for(const u of c){const g=u.toString();this._syncedModels[g]||this._beginModelSync(u,e),this._syncedModels[g]&&(this._syncedModelsLastUsedTime[g]=new Date().getTime())}}_checkStopModelSync(){const c=new Date().getTime(),e=[];for(const u in this._syncedModelsLastUsedTime)c-this._syncedModelsLastUsedTime[u]>t.STOP_SYNC_MODEL_DELTA_TIME_MS&&e.push(u);for(const u of e)this._stopModelSync(u)}_beginModelSync(c,e){const u=this._modelService.getModel(c);if(!u||!e&&u.isTooLargeForSyncing())return;const g=c.toString();this._proxy.$acceptNewModel({url:u.uri.toString(),lines:u.getLinesContent(),EOL:u.getEOL(),versionId:u.getVersionId()});const E=new i.DisposableStore;E.add(u.onDidChangeContent(w=>{this._proxy.$acceptModelChanged(g.toString(),w)})),E.add(u.onWillDispose(()=>{this._stopModelSync(g)})),E.add((0,i.toDisposable)(()=>{this._proxy.$acceptRemovedModel(g)})),this._syncedModels[g]=E}_stopModelSync(c){const e=this._syncedModels[c];delete this._syncedModels[c],delete this._syncedModelsLastUsedTime[c],(0,i.dispose)(e)}}t.WorkerTextModelSyncClient=a;class h{constructor(){this._models=Object.create(null)}bindToServer(c){c.setChannel(t.WORKER_TEXT_MODEL_SYNC_CHANNEL,this)}getModel(c){return this._models[c]}getModels(){const c=[];return Object.keys(this._models).forEach(e=>c.push(this._models[e])),c}$acceptNewModel(c){this._models[c.url]=new _(M.URI.parse(c.url),c.lines,c.EOL,c.versionId)}$acceptModelChanged(c,e){if(!this._models[c])return;this._models[c].onEvents(e)}$acceptRemovedModel(c){this._models[c]&&delete this._models[c]}}t.WorkerTextModelSyncServer=h;class _ extends o.MirrorTextModel{get uri(){return this._uri}get eol(){return this._eol}getValue(){return this.getText()}findMatches(c){const e=[];for(let u=0;u<this._lines.length;u++){const g=this._lines[u],E=this.offsetAt(new m.Position(u+1,1)),w=g.matchAll(c);for(const v of w)(v.index||v.index===0)&&(v.index=v.index+E),e.push(v)}return e}getLinesContent(){return this._lines.slice(0)}getLineCount(){return this._lines.length}getLineContent(c){return this._lines[c-1]}getWordAtPosition(c,e){const u=(0,b.getWordAtText)(c.column,(0,b.ensureValidWordDefinition)(e),this._lines[c.lineNumber-1],0);return u?new R.Range(c.lineNumber,u.startColumn,c.lineNumber,u.endColumn):null}getWordUntilPosition(c,e){const u=this.getWordAtPosition(c,e);return u?{word:this._lines[c.lineNumber-1].substring(u.startColumn-1,c.column-1),startColumn:u.startColumn,endColumn:c.column}:{word:"",startColumn:c.column,endColumn:c.column}}words(c){const e=this._lines,u=this._wordenize.bind(this);let g=0,E="",w=0,v=[];return{*[Symbol.iterator](){for(;;)if(w<v.length){const A=E.substring(v[w].start,v[w].end);w+=1,yield A}else if(g<e.length)E=e[g],v=u(E,c),w=0,g+=1;else break}}}getLineWords(c,e){const u=this._lines[c-1],g=this._wordenize(u,e),E=[];for(const w of g)E.push({word:u.substring(w.start,w.end),startColumn:w.start+1,endColumn:w.end+1});return E}_wordenize(c,e){const u=[];let g;for(e.lastIndex=0;(g=e.exec(c))&&g[0].length!==0;)u.push({start:g.index,end:g.index+g[0].length});return u}getValueInRange(c){if(c=this._validateRange(c),c.startLineNumber===c.endLineNumber)return this._lines[c.startLineNumber-1].substring(c.startColumn-1,c.endColumn-1);const e=this._eol,u=c.startLineNumber-1,g=c.endLineNumber-1,E=[];E.push(this._lines[u].substring(c.startColumn-1));for(let w=u+1;w<g;w++)E.push(this._lines[w]);return E.push(this._lines[g].substring(0,c.endColumn-1)),E.join(e)}offsetAt(c){return c=this._validatePosition(c),this._ensureLineStarts(),this._lineStarts.getPrefixSum(c.lineNumber-2)+(c.column-1)}positionAt(c){c=Math.floor(c),c=Math.max(0,c),this._ensureLineStarts();const e=this._lineStarts.getIndexOf(c),u=this._lines[e.index].length;return{lineNumber:1+e.index,column:1+Math.min(e.remainder,u)}}_validateRange(c){const e=this._validatePosition({lineNumber:c.startLineNumber,column:c.startColumn}),u=this._validatePosition({lineNumber:c.endLineNumber,column:c.endColumn});return e.lineNumber!==c.startLineNumber||e.column!==c.startColumn||u.lineNumber!==c.endLineNumber||u.column!==c.endColumn?{startLineNumber:e.lineNumber,startColumn:e.column,endLineNumber:u.lineNumber,endColumn:u.column}:c}_validatePosition(c){if(!m.Position.isIPosition(c))throw new Error("bad position");let{lineNumber:e,column:u}=c,g=!1;if(e<1)e=1,u=1,g=!0;else if(e>this._lines.length)e=this._lines.length,u=this._lines[e-1].length+1,g=!0;else{const E=this._lines[e-1].length+1;u<1?(u=1,g=!0):u>E&&(u=E,g=!0)}return g?{lineNumber:e,column:u}:c}}t.MirrorModel=_}),ie(re[85],ae([0,1,32,5,2,65,66,81,71,29,73,39,62,31,24,4,64,72,82]),function(C,t,n,i,M,m,R,b,o,a,h,_,d,c,e,u,g,E,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.EditorSimpleWorker=t.BaseEditorSimpleWorker=void 0,t.create=l;const v=!1;class A{constructor(){this._workerTextModelSyncServer=new w.WorkerTextModelSyncServer}dispose(){}_getModel(f){return this._workerTextModelSyncServer.getModel(f)}_getModels(){return this._workerTextModelSyncServer.getModels()}$acceptNewModel(f){this._workerTextModelSyncServer.$acceptNewModel(f)}$acceptModelChanged(f,p){this._workerTextModelSyncServer.$acceptModelChanged(f,p)}$acceptRemovedModel(f){this._workerTextModelSyncServer.$acceptRemovedModel(f)}async $computeUnicodeHighlights(f,p,I){const N=this._getModel(f);return N?h.UnicodeTextModelHighlighter.computeUnicodeHighlights(N,p,I):{ranges:[],hasMore:!1,ambiguousCharacterCount:0,invisibleCharacterCount:0,nonBasicAsciiCharacterCount:0}}async $findSectionHeaders(f,p){const I=this._getModel(f);return I?(0,E.findSectionHeaders)(I,p):[]}async $computeDiff(f,p,I,N){const S=this._getModel(f),D=this._getModel(p);return!S||!D?null:L.computeDiff(S,D,I,N)}static computeDiff(f,p,I,N){const S=N==="advanced"?d.linesDiffComputers.getDefault():d.linesDiffComputers.getLegacy(),D=f.getLinesContent(),T=p.getLinesContent(),y=S.computeDiff(D,T,I),k=y.changes.length>0?!1:this._modelsAreIdentical(f,p);function P(q){return q.map(j=>[j.original.startLineNumber,j.original.endLineNumberExclusive,j.modified.startLineNumber,j.modified.endLineNumberExclusive,j.innerChanges?.map(H=>[H.originalRange.startLineNumber,H.originalRange.startColumn,H.originalRange.endLineNumber,H.originalRange.endColumn,H.modifiedRange.startLineNumber,H.modifiedRange.startColumn,H.modifiedRange.endLineNumber,H.modifiedRange.endColumn])])}return{identical:k,quitEarly:y.hitTimeout,changes:P(y.changes),moves:y.moves.map(q=>[q.lineRangeMapping.original.startLineNumber,q.lineRangeMapping.original.endLineNumberExclusive,q.lineRangeMapping.modified.startLineNumber,q.lineRangeMapping.modified.endLineNumberExclusive,P(q.changes)])}}static _modelsAreIdentical(f,p){const I=f.getLineCount(),N=p.getLineCount();if(I!==N)return!1;for(let S=1;S<=I;S++){const D=f.getLineContent(S),T=p.getLineContent(S);if(D!==T)return!1}return!0}async $computeDirtyDiff(f,p,I){const N=this._getModel(f),S=this._getModel(p);if(!N||!S)return null;const D=N.getLinesContent(),T=S.getLinesContent();return new _.DiffComputer(D,T,{shouldComputeCharChanges:!1,shouldPostProcessCharChanges:!1,shouldIgnoreTrimWhitespace:I,shouldMakePrettyDiff:!0,maxComputationTime:1e3}).computeDiff().changes}static{this._diffLimit=1e5}async $computeMoreMinimalEdits(f,p,I){const N=this._getModel(f);if(!N)return p;const S=[];let D;p=p.slice(0).sort((y,k)=>{if(y.range&&k.range)return M.Range.compareRangesUsingStarts(y.range,k.range);const P=y.range?0:1,q=k.range?0:1;return P-q});let T=0;for(let y=1;y<p.length;y++)M.Range.getEndPosition(p[T].range).equals(M.Range.getStartPosition(p[y].range))?(p[T].range=M.Range.fromPositions(M.Range.getStartPosition(p[T].range),M.Range.getEndPosition(p[y].range)),p[T].text+=p[y].text):(T++,p[T]=p[y]);p.length=T+1;for(let{range:y,text:k,eol:P}of p){if(typeof P=="number"&&(D=P),M.Range.isEmpty(y)&&!k)continue;const q=N.getValueInRange(y);if(k=k.replace(/\r\n|\n|\r/g,N.eol),q===k)continue;if(Math.max(k.length,q.length)>L._diffLimit){S.push({range:y,text:k});continue}const j=(0,n.stringDiff)(q,k,I),H=N.offsetAt(M.Range.lift(y).getStartPosition());for(const W of j){const J=N.positionAt(H+W.originalStart),ee=N.positionAt(H+W.originalStart+W.originalLength),Z={text:k.substr(W.modifiedStart,W.modifiedLength),range:{startLineNumber:J.lineNumber,startColumn:J.column,endLineNumber:ee.lineNumber,endColumn:ee.column}};N.getValueInRange(Z.range)!==Z.text&&S.push(Z)}}return typeof D=="number"&&S.push({eol:D,text:"",range:{startLineNumber:0,startColumn:0,endLineNumber:0,endColumn:0}}),S}$computeHumanReadableDiff(f,p,I){const N=this._getModel(f);if(!N)return p;const S=[];let D;p=p.slice(0).sort((T,y)=>{if(T.range&&y.range)return M.Range.compareRangesUsingStarts(T.range,y.range);const k=T.range?0:1,P=y.range?0:1;return k-P});for(let{range:T,text:y,eol:k}of p){let J=function(Z,K){return new i.Position(Z.lineNumber+K.lineNumber-1,K.lineNumber===1?Z.column+K.column-1:K.column)},ee=function(Z,K){const ne=[];for(let F=K.startLineNumber;F<=K.endLineNumber;F++){const $=Z[F-1];F===K.startLineNumber&&F===K.endLineNumber?ne.push($.substring(K.startColumn-1,K.endColumn-1)):F===K.startLineNumber?ne.push($.substring(K.startColumn-1)):F===K.endLineNumber?ne.push($.substring(0,K.endColumn-1)):ne.push($)}return ne};if(typeof k=="number"&&(D=k),M.Range.isEmpty(T)&&!y)continue;const P=N.getValueInRange(T);if(y=y.replace(/\r\n|\n|\r/g,N.eol),P===y)continue;if(Math.max(y.length,P.length)>L._diffLimit){S.push({range:T,text:y});continue}const q=P.split(/\r\n|\n|\r/),j=y.split(/\r\n|\n|\r/),H=d.linesDiffComputers.getDefault().computeDiff(q,j,I),W=M.Range.lift(T).getStartPosition();for(const Z of H.changes)if(Z.innerChanges)for(const K of Z.innerChanges)S.push({range:M.Range.fromPositions(J(W,K.originalRange.getStartPosition()),J(W,K.originalRange.getEndPosition())),text:ee(j,K.modifiedRange).join(N.eol)});else throw new u.BugIndicatingError("The experimental diff algorithm always produces inner changes")}return typeof D=="number"&&S.push({eol:D,text:"",range:{startLineNumber:0,startColumn:0,endLineNumber:0,endColumn:0}}),S}async $computeLinks(f){const p=this._getModel(f);return p?(0,m.computeLinks)(p):null}async $computeDefaultDocumentColors(f){const p=this._getModel(f);return p?(0,g.computeDefaultDocumentColors)(p):null}static{this._suggestionsLimit=1e4}async $textualSuggest(f,p,I,N){const S=new a.StopWatch,D=new RegExp(I,N),T=new Set;e:for(const y of f){const k=this._getModel(y);if(k){for(const P of k.words(D))if(!(P===p||!isNaN(Number(P)))&&(T.add(P),T.size>L._suggestionsLimit))break e}}return{words:Array.from(T),duration:S.elapsed()}}async $computeWordRanges(f,p,I,N){const S=this._getModel(f);if(!S)return Object.create(null);const D=new RegExp(I,N),T=Object.create(null);for(let y=p.startLineNumber;y<p.endLineNumber;y++){const k=S.getLineWords(y,D);for(const P of k){if(!isNaN(Number(P.word)))continue;let q=T[P.word];q||(q=[],T[P.word]=q),q.push({startLineNumber:y,startColumn:P.startColumn,endLineNumber:y,endColumn:P.endColumn})}}return T}async $navigateValueSet(f,p,I,N,S){const D=this._getModel(f);if(!D)return null;const T=new RegExp(N,S);p.startColumn===p.endColumn&&(p={startLineNumber:p.startLineNumber,startColumn:p.startColumn,endLineNumber:p.endLineNumber,endColumn:p.endColumn+1});const y=D.getValueInRange(p),k=D.getWordAtPosition({lineNumber:p.startLineNumber,column:p.startColumn},T);if(!k)return null;const P=D.getValueInRange(k);return R.BasicInplaceReplace.INSTANCE.navigateValueSet(p,y,k,P,I)}}t.BaseEditorSimpleWorker=A;class L extends A{constructor(f,p){super(),this._host=f,this._foreignModuleFactory=p,this._foreignModule=null}async $ping(){return"pong"}$loadForeignModule(f,p,I){const N=(T,y)=>this._host.$fhr(T,y),D={host:(0,c.createProxyObject)(I,N),getMirrorModels:()=>this._getModels()};return this._foreignModuleFactory?(this._foreignModule=this._foreignModuleFactory(D,p),Promise.resolve((0,c.getAllMethodNames)(this._foreignModule))):new Promise((T,y)=>{const k=P=>{this._foreignModule=P.create(D,p),T((0,c.getAllMethodNames)(this._foreignModule))};if(!v)C([`${f}`],k,y);else{const P=e.FileAccess.asBrowserUri(`${f}.js`).toString(!0);new Promise((q,j)=>{C([`${P}`],q,j)}).then(ye).then(k).catch(y)}})}$fmr(f,p){if(!this._foreignModule||typeof this._foreignModule[f]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+f));try{return Promise.resolve(this._foreignModule[f].apply(this._foreignModule,p))}catch(I){return Promise.reject(I)}}}t.EditorSimpleWorker=L;function l(s){return new L(o.EditorWorkerHost.getChannel(s),null)}typeof importScripts=="function"&&(globalThis.monaco=(0,b.createMonacoBaseAPI)())})}).call(this);

//# sourceMappingURL=https://main.vscode-cdn.net/sourcemaps/532bdf24071d0a26ceea0844dcdf5ee8cfabd562/core/vs/base/worker/workerMain.js.map
