/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var le=["require","exports","vs/base/common/lifecycle","vs/base/common/platform","vs/base/common/event","vs/platform/log/common/log","vs/platform/instantiation/common/instantiation","vs/base/common/uri","vs/base/common/async","vs/nls","vs/base/common/path","vs/base/common/network","vs/base/common/types","electron","vs/platform/files/common/files","vs/base/common/errors","vs/platform/configuration/common/configuration","vs/base/common/buffer","vs/base/common/resources","vs/platform/lifecycle/electron-main/lifecycleMainService","vs/platform/environment/electron-main/environmentMainService","vs/base/common/arrays","vs/base/common/cancellation","vs/base/node/pfs","vs/platform/telemetry/common/telemetry","vs/base/common/strings","fs","os","vs/platform/product/common/productService","vs/platform/windows/electron-main/windows","vs/platform/workspace/common/workspace","vs/base/common/map","vs/base/common/extpath","vs/base/common/uuid","vs/platform/state/node/state","vs/base/parts/ipc/electron-main/ipcMain","vs/platform/environment/common/environment","vs/base/common/objects","vs/base/common/process","vs/base/common/charCode","vs/platform/policy/common/policy","vs/platform/uriIdentity/common/uriIdentity","vs/platform/userDataProfile/common/userDataProfile","vs/base/common/json","child_process","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/platform/window/common/window","vs/base/common/hash","vs/base/common/labels","vs/platform/request/common/request","vs/platform/update/common/update","vs/platform/window/electron-main/window","vs/platform/dialogs/electron-main/dialogMainService","vs/base/common/decorators","vs/base/common/errorMessage","vs/platform/configuration/common/configurationRegistry","vs/platform/telemetry/common/telemetryUtils","vs/platform/userDataProfile/electron-main/userDataProfile","vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/base/common/stopwatch","vs/base/common/ternarySearchTree","vs/platform/files/common/watcher","vs/platform/storage/common/storage","vs/platform/utilityProcess/electron-main/utilityProcess","vs/platform/native/electron-main/nativeHostMainService","vs/base/common/amd","vs/base/common/lazy","vs/base/common/stream","vs/platform/environment/node/argvHelper","vs/platform/backup/electron-main/backup","vs/base/common/performance","vs/platform/log/electron-main/loggerService","vs/platform/product/common/product","vs/platform/protocol/electron-main/protocol","vs/platform/remote/common/remoteHosts","vs/platform/terminal/common/terminal","vs/platform/theme/electron-main/themeMainService","vs/base/common/iterator","vs/base/common/normalization","vs/base/common/codicons","vs/base/common/severity","vs/base/common/processes","vs/base/common/marshalling","vs/platform/instantiation/common/descriptors","vs/platform/auxiliaryWindow/electron-main/auxiliaryWindows","vs/platform/cssDev/node/cssDevService","vs/platform/extensions/common/extensions","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/platform/storage/electron-main/storageMainService","vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/base/common/functional","vs/base/common/marshallingIds","crypto","net","vs/base/node/id","vs/base/node/processes","path","vs/platform/environment/node/environmentService","vs/platform/diagnostics/common/diagnostics","vs/platform/encryption/common/encryptionService","vs/platform/instantiation/common/serviceCollection","vs/platform/files/node/diskFileSystemProvider","vs/platform/shell/node/shellEnv","vs/platform/sign/common/sign","vs/platform/workspaces/common/workspaces","vs/platform/workspaces/node/workspaces","vs/base/parts/ipc/node/ipc.net","vs/platform/update/electron-main/abstractUpdateService","vs/base/node/unc","vs/base/common/jsonEdit","vs/base/common/linkedList","vs/base/common/codiconsUtil","vs/base/common/themables","vs/base/node/ports","vs/nls.messages","vs/base/common/glob","vs/base/node/extpath","vs/base/node/powershell","vs/base/node/ps","vs/base/node/shell","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/electron-main/ipc.mp","vs/base/parts/storage/common/storage","vs/platform/environment/node/argv","vs/platform/contextkey/common/contextkey","vs/platform/dialogs/common/dialogs","vs/platform/files/common/io","vs/platform/configuration/common/configurationModels","vs/platform/extensionManagement/common/extensionManagement","vs/platform/state/node/stateService","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariable","vs/platform/tunnel/common/tunnel","vs/platform/url/common/url","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/windows/electron-main/windowsFinder","vs/platform/native/electron-main/auth","vs/platform/diagnostics/electron-main/diagnosticsMainService","vs/platform/windows/electron-main/windowImpl","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/color","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/jsonSchema","vs/base/common/numbers","vs/base/common/skipList","vs/base/common/cache","vs/base/common/symbols","vs/base/common/codiconsLibrary","vs/base/common/uint","vs/base/node/crypto","vs/base/node/macAddress","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/base/common/date","vs/base/common/jsonErrorMessages","vs/base/common/console","vs/amdX","vs/base/common/uriIpc","util","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/contextmenu/electron-main/contextmenu","vs/base/parts/ipc/electron-main/ipc.electron","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/node/storage","vs/platform/backup/common/backup","vs/platform/backup/node/backup","vs/platform/contextkey/common/scanner","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/wait","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensions/common/extensionsApiProposals","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/extensions/common/extensionHostStarter","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/electron-main/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/baseWatcher","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/issue/common/issue","vs/platform/encryption/electron-main/encryptionMainService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProviderServer","vs/platform/files/electron-main/diskFileSystemProviderServer","vs/platform/log/common/bufferLog","vs/platform/log/common/logIpc","vs/platform/log/common/logService","vs/platform/log/electron-main/logIpc","vs/platform/log/node/spdlogLog","vs/platform/log/node/loggerService","vs/platform/menubar/common/menubar","vs/platform/policy/common/filePolicyService","vs/platform/policy/common/policyIpc","vs/platform/policy/node/nativePolicyService","vs/platform/profiling/electron-main/windowProfiling","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/electronRemoteResources","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/extensions/common/extensionValidator","vs/base/common/semver/semver","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/remote/node/wsl","vs/platform/request/common/requestIpc","vs/platform/request/node/proxy","url","vs/platform/sharedProcess/common/sharedProcess","vs/platform/sign/common/abstractSignService","vs/platform/sign/node/signService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/node/telemetryUtils","vs/platform/telemetry/electron-main/telemetryUtils","vs/platform/terminal/common/environmentVariableCollection","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/requestStore","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/terminalEnvironment","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/update/common/update.config.contribution","vs/platform/update/common/updateIpc","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/url/common/urlIpc","vs/platform/url/common/urlService","vs/platform/url/electron-main/electronUrlListener","vs/platform/userData/common/fileUserDataProvider","vs/platform/utilityProcess/common/utilityProcessWorkerService","vs/platform/webview/common/webviewManagerService","vs/platform/webview/electron-main/webviewProtocolProvider","vs/platform/windows/node/windowTracker","vs/platform/storage/electron-main/storageIpc","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/protocol/electron-main/protocolMainService","vs/platform/externalServices/common/serviceMachineId","vs/platform/externalServices/common/marketplace","vs/platform/storage/electron-main/storageMain","vs/platform/userDataProfile/electron-main/userDataProfileStorageIpc","vs/platform/userDataProfile/node/userDataProfile","zlib","vs/platform/backup/electron-main/backupMainService","vs/platform/keyboardLayout/electron-main/keyboardLayoutMainService","vs/platform/request/node/requestService","vs/platform/request/electron-main/requestMainService","vs/platform/tunnel/node/tunnelService","vs/platform/update/electron-main/updateService.darwin","vs/platform/update/electron-main/updateService.snap","vs/platform/debug/electron-main/extensionHostDebugIpc","vs/platform/launch/electron-main/launchMainService","vs/platform/userDataProfile/electron-main/userDataProfilesHandler","vs/platform/extensions/electron-main/extensionHostStarter","vs/platform/sharedProcess/electron-main/sharedProcess","vs/platform/terminal/electron-main/electronPtyHostStarter","vs/platform/utilityProcess/electron-main/utilityProcessWorkerMainService","vs/platform/webview/electron-main/webviewMainService","vs/platform/windows/electron-main/windowsStateHandler","vs/platform/issue/electron-main/issueMainService","vs/platform/issue/electron-main/processMainService","vs/platform/update/electron-main/updateService.linux","vs/platform/update/electron-main/updateService.win32","vs/platform/auxiliaryWindow/electron-main/auxiliaryWindow","vs/platform/auxiliaryWindow/electron-main/auxiliaryWindowsMainService","vs/platform/menubar/electron-main/menubar","vs/platform/menubar/electron-main/menubarMainService","vs/platform/windows/electron-main/windowsMainService","vs/platform/workspaces/electron-main/workspacesMainService","vs/code/electron-main/app","minimist","assert","string_decoder","vs/base/common/jsonc","vs/code/electron-main/main"],ue=function(j){for(var e=[],i=0,s=j.length;i<s;i++)e[i]=le[j[i]];return e};define(le[66],ue([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoaderStats=e.LoaderEventType=e.canASAR=e.isESM=void 0,e.isESM=!1,e.canASAR=!0;var i;(function(y){y[y.LoaderAvailable=1]="LoaderAvailable",y[y.BeginLoadingScript=10]="BeginLoadingScript",y[y.EndLoadingScriptOK=11]="EndLoadingScriptOK",y[y.EndLoadingScriptError=12]="EndLoadingScriptError",y[y.BeginInvokeFactory=21]="BeginInvokeFactory",y[y.EndInvokeFactory=22]="EndInvokeFactory",y[y.NodeBeginEvaluatingScript=31]="NodeBeginEvaluatingScript",y[y.NodeEndEvaluatingScript=32]="NodeEndEvaluatingScript",y[y.NodeBeginNativeRequire=33]="NodeBeginNativeRequire",y[y.NodeEndNativeRequire=34]="NodeEndNativeRequire",y[y.CachedDataFound=60]="CachedDataFound",y[y.CachedDataMissed=61]="CachedDataMissed",y[y.CachedDataRejected=62]="CachedDataRejected",y[y.CachedDataCreated=63]="CachedDataCreated"})(i||(e.LoaderEventType=i={}));class s{static get(){const k=new Map,A=new Map,R=new Map,S=new Map;function c(f,h){f.has(h.detail)||f.set(h.detail,-h.timestamp)}function m(f,h){const E=f.get(h.detail);E&&(E>=0||f.set(h.detail,E+h.timestamp))}let u=[];typeof j=="function"&&typeof j.getStats=="function"&&(u=j.getStats().slice(0).sort((f,h)=>f.timestamp-h.timestamp));for(const f of u)switch(f.type){case i.BeginLoadingScript:c(k,f);break;case i.EndLoadingScriptOK:case i.EndLoadingScriptError:m(k,f);break;case i.BeginInvokeFactory:c(A,f);break;case i.EndInvokeFactory:m(A,f);break;case i.NodeBeginNativeRequire:c(R,f);break;case i.NodeEndNativeRequire:m(R,f);break;case i.NodeBeginEvaluatingScript:c(S,f);break;case i.NodeEndEvaluatingScript:m(S,f);break}let p=0;R.forEach(f=>p+=f);function v(f){const h=[];return f.forEach((E,b)=>h.push([b,E])),h}return{amdLoad:v(k),amdInvoke:v(A),nodeRequire:v(R),nodeEval:v(S),nodeRequireTotal:p}}static toMarkdownTable(k,A){let R="";const S=[];return k.forEach((c,m)=>{S[m]=c.length}),A.forEach(c=>{c.forEach((m,u)=>{typeof m>"u"&&(m=c[u]="-");const p=m.toString().length;S[u]=Math.max(p,S[u])})}),k.forEach((c,m)=>{R+=`| ${c+" ".repeat(S[m]-c.toString().length)} `}),R+=`|
`,k.forEach((c,m)=>{R+=`| ${"-".repeat(S[m])} `}),R+=`|
`,A.forEach(c=>{c.forEach((m,u)=>{typeof m<"u"&&(R+=`| ${m+" ".repeat(S[u]-m.toString().length)} `)}),R+=`|
`}),R}}e.LoaderStats=s}),define(le[141],ue([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MonotonousArray=void 0,e.findLast=i,e.findLastIdx=s,e.findLastMonotonous=y,e.findLastIdxMonotonous=k,e.findFirstMonotonous=A,e.findFirstIdxMonotonousOrArrLen=R,e.findFirstIdxMonotonous=S,e.findFirstMax=m,e.findLastMax=u,e.findFirstMin=p,e.findMaxIdx=v,e.mapFindFirst=f;function i(h,E){const b=s(h,E);if(b!==-1)return h[b]}function s(h,E,b=h.length-1){for(let g=b;g>=0;g--){const I=h[g];if(E(I))return g}return-1}function y(h,E){const b=k(h,E);return b===-1?void 0:h[b]}function k(h,E,b=0,g=h.length){let I=b,P=g;for(;I<P;){const r=Math.floor((I+P)/2);E(h[r])?I=r+1:P=r}return I-1}function A(h,E){const b=R(h,E);return b===h.length?void 0:h[b]}function R(h,E,b=0,g=h.length){let I=b,P=g;for(;I<P;){const r=Math.floor((I+P)/2);E(h[r])?P=r:I=r+1}return I}function S(h,E,b=0,g=h.length){const I=R(h,E,b,g);return I===h.length?-1:I}class c{static{this.assertInvariants=!1}constructor(E){this._array=E,this._findLastMonotonousLastIdx=0}findLastMonotonous(E){if(c.assertInvariants){if(this._prevFindLastPredicate){for(const g of this._array)if(this._prevFindLastPredicate(g)&&!E(g))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this._prevFindLastPredicate=E}const b=k(this._array,E,this._findLastMonotonousLastIdx);return this._findLastMonotonousLastIdx=b+1,b===-1?void 0:this._array[b]}}e.MonotonousArray=c;function m(h,E){if(h.length===0)return;let b=h[0];for(let g=1;g<h.length;g++){const I=h[g];E(I,b)>0&&(b=I)}return b}function u(h,E){if(h.length===0)return;let b=h[0];for(let g=1;g<h.length;g++){const I=h[g];E(I,b)>=0&&(b=I)}return b}function p(h,E){return m(h,(b,g)=>-E(b,g))}function v(h,E){if(h.length===0)return-1;let b=0;for(let g=1;g<h.length;g++){const I=h[g];E(I,h[b])>0&&(b=g)}return b}function f(h,E){for(const b of h){const g=E(b);if(g!==void 0)return g}}}),define(le[39],ue([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharCode=void 0;var i;(function(s){s[s.Null=0]="Null",s[s.Backspace=8]="Backspace",s[s.Tab=9]="Tab",s[s.LineFeed=10]="LineFeed",s[s.CarriageReturn=13]="CarriageReturn",s[s.Space=32]="Space",s[s.ExclamationMark=33]="ExclamationMark",s[s.DoubleQuote=34]="DoubleQuote",s[s.Hash=35]="Hash",s[s.DollarSign=36]="DollarSign",s[s.PercentSign=37]="PercentSign",s[s.Ampersand=38]="Ampersand",s[s.SingleQuote=39]="SingleQuote",s[s.OpenParen=40]="OpenParen",s[s.CloseParen=41]="CloseParen",s[s.Asterisk=42]="Asterisk",s[s.Plus=43]="Plus",s[s.Comma=44]="Comma",s[s.Dash=45]="Dash",s[s.Period=46]="Period",s[s.Slash=47]="Slash",s[s.Digit0=48]="Digit0",s[s.Digit1=49]="Digit1",s[s.Digit2=50]="Digit2",s[s.Digit3=51]="Digit3",s[s.Digit4=52]="Digit4",s[s.Digit5=53]="Digit5",s[s.Digit6=54]="Digit6",s[s.Digit7=55]="Digit7",s[s.Digit8=56]="Digit8",s[s.Digit9=57]="Digit9",s[s.Colon=58]="Colon",s[s.Semicolon=59]="Semicolon",s[s.LessThan=60]="LessThan",s[s.Equals=61]="Equals",s[s.GreaterThan=62]="GreaterThan",s[s.QuestionMark=63]="QuestionMark",s[s.AtSign=64]="AtSign",s[s.A=65]="A",s[s.B=66]="B",s[s.C=67]="C",s[s.D=68]="D",s[s.E=69]="E",s[s.F=70]="F",s[s.G=71]="G",s[s.H=72]="H",s[s.I=73]="I",s[s.J=74]="J",s[s.K=75]="K",s[s.L=76]="L",s[s.M=77]="M",s[s.N=78]="N",s[s.O=79]="O",s[s.P=80]="P",s[s.Q=81]="Q",s[s.R=82]="R",s[s.S=83]="S",s[s.T=84]="T",s[s.U=85]="U",s[s.V=86]="V",s[s.W=87]="W",s[s.X=88]="X",s[s.Y=89]="Y",s[s.Z=90]="Z",s[s.OpenSquareBracket=91]="OpenSquareBracket",s[s.Backslash=92]="Backslash",s[s.CloseSquareBracket=93]="CloseSquareBracket",s[s.Caret=94]="Caret",s[s.Underline=95]="Underline",s[s.BackTick=96]="BackTick",s[s.a=97]="a",s[s.b=98]="b",s[s.c=99]="c",s[s.d=100]="d",s[s.e=101]="e",s[s.f=102]="f",s[s.g=103]="g",s[s.h=104]="h",s[s.i=105]="i",s[s.j=106]="j",s[s.k=107]="k",s[s.l=108]="l",s[s.m=109]="m",s[s.n=110]="n",s[s.o=111]="o",s[s.p=112]="p",s[s.q=113]="q",s[s.r=114]="r",s[s.s=115]="s",s[s.t=116]="t",s[s.u=117]="u",s[s.v=118]="v",s[s.w=119]="w",s[s.x=120]="x",s[s.y=121]="y",s[s.z=122]="z",s[s.OpenCurlyBrace=123]="OpenCurlyBrace",s[s.Pipe=124]="Pipe",s[s.CloseCurlyBrace=125]="CloseCurlyBrace",s[s.Tilde=126]="Tilde",s[s.NoBreakSpace=160]="NoBreakSpace",s[s.U_Combining_Grave_Accent=768]="U_Combining_Grave_Accent",s[s.U_Combining_Acute_Accent=769]="U_Combining_Acute_Accent",s[s.U_Combining_Circumflex_Accent=770]="U_Combining_Circumflex_Accent",s[s.U_Combining_Tilde=771]="U_Combining_Tilde",s[s.U_Combining_Macron=772]="U_Combining_Macron",s[s.U_Combining_Overline=773]="U_Combining_Overline",s[s.U_Combining_Breve=774]="U_Combining_Breve",s[s.U_Combining_Dot_Above=775]="U_Combining_Dot_Above",s[s.U_Combining_Diaeresis=776]="U_Combining_Diaeresis",s[s.U_Combining_Hook_Above=777]="U_Combining_Hook_Above",s[s.U_Combining_Ring_Above=778]="U_Combining_Ring_Above",s[s.U_Combining_Double_Acute_Accent=779]="U_Combining_Double_Acute_Accent",s[s.U_Combining_Caron=780]="U_Combining_Caron",s[s.U_Combining_Vertical_Line_Above=781]="U_Combining_Vertical_Line_Above",s[s.U_Combining_Double_Vertical_Line_Above=782]="U_Combining_Double_Vertical_Line_Above",s[s.U_Combining_Double_Grave_Accent=783]="U_Combining_Double_Grave_Accent",s[s.U_Combining_Candrabindu=784]="U_Combining_Candrabindu",s[s.U_Combining_Inverted_Breve=785]="U_Combining_Inverted_Breve",s[s.U_Combining_Turned_Comma_Above=786]="U_Combining_Turned_Comma_Above",s[s.U_Combining_Comma_Above=787]="U_Combining_Comma_Above",s[s.U_Combining_Reversed_Comma_Above=788]="U_Combining_Reversed_Comma_Above",s[s.U_Combining_Comma_Above_Right=789]="U_Combining_Comma_Above_Right",s[s.U_Combining_Grave_Accent_Below=790]="U_Combining_Grave_Accent_Below",s[s.U_Combining_Acute_Accent_Below=791]="U_Combining_Acute_Accent_Below",s[s.U_Combining_Left_Tack_Below=792]="U_Combining_Left_Tack_Below",s[s.U_Combining_Right_Tack_Below=793]="U_Combining_Right_Tack_Below",s[s.U_Combining_Left_Angle_Above=794]="U_Combining_Left_Angle_Above",s[s.U_Combining_Horn=795]="U_Combining_Horn",s[s.U_Combining_Left_Half_Ring_Below=796]="U_Combining_Left_Half_Ring_Below",s[s.U_Combining_Up_Tack_Below=797]="U_Combining_Up_Tack_Below",s[s.U_Combining_Down_Tack_Below=798]="U_Combining_Down_Tack_Below",s[s.U_Combining_Plus_Sign_Below=799]="U_Combining_Plus_Sign_Below",s[s.U_Combining_Minus_Sign_Below=800]="U_Combining_Minus_Sign_Below",s[s.U_Combining_Palatalized_Hook_Below=801]="U_Combining_Palatalized_Hook_Below",s[s.U_Combining_Retroflex_Hook_Below=802]="U_Combining_Retroflex_Hook_Below",s[s.U_Combining_Dot_Below=803]="U_Combining_Dot_Below",s[s.U_Combining_Diaeresis_Below=804]="U_Combining_Diaeresis_Below",s[s.U_Combining_Ring_Below=805]="U_Combining_Ring_Below",s[s.U_Combining_Comma_Below=806]="U_Combining_Comma_Below",s[s.U_Combining_Cedilla=807]="U_Combining_Cedilla",s[s.U_Combining_Ogonek=808]="U_Combining_Ogonek",s[s.U_Combining_Vertical_Line_Below=809]="U_Combining_Vertical_Line_Below",s[s.U_Combining_Bridge_Below=810]="U_Combining_Bridge_Below",s[s.U_Combining_Inverted_Double_Arch_Below=811]="U_Combining_Inverted_Double_Arch_Below",s[s.U_Combining_Caron_Below=812]="U_Combining_Caron_Below",s[s.U_Combining_Circumflex_Accent_Below=813]="U_Combining_Circumflex_Accent_Below",s[s.U_Combining_Breve_Below=814]="U_Combining_Breve_Below",s[s.U_Combining_Inverted_Breve_Below=815]="U_Combining_Inverted_Breve_Below",s[s.U_Combining_Tilde_Below=816]="U_Combining_Tilde_Below",s[s.U_Combining_Macron_Below=817]="U_Combining_Macron_Below",s[s.U_Combining_Low_Line=818]="U_Combining_Low_Line",s[s.U_Combining_Double_Low_Line=819]="U_Combining_Double_Low_Line",s[s.U_Combining_Tilde_Overlay=820]="U_Combining_Tilde_Overlay",s[s.U_Combining_Short_Stroke_Overlay=821]="U_Combining_Short_Stroke_Overlay",s[s.U_Combining_Long_Stroke_Overlay=822]="U_Combining_Long_Stroke_Overlay",s[s.U_Combining_Short_Solidus_Overlay=823]="U_Combining_Short_Solidus_Overlay",s[s.U_Combining_Long_Solidus_Overlay=824]="U_Combining_Long_Solidus_Overlay",s[s.U_Combining_Right_Half_Ring_Below=825]="U_Combining_Right_Half_Ring_Below",s[s.U_Combining_Inverted_Bridge_Below=826]="U_Combining_Inverted_Bridge_Below",s[s.U_Combining_Square_Below=827]="U_Combining_Square_Below",s[s.U_Combining_Seagull_Below=828]="U_Combining_Seagull_Below",s[s.U_Combining_X_Above=829]="U_Combining_X_Above",s[s.U_Combining_Vertical_Tilde=830]="U_Combining_Vertical_Tilde",s[s.U_Combining_Double_Overline=831]="U_Combining_Double_Overline",s[s.U_Combining_Grave_Tone_Mark=832]="U_Combining_Grave_Tone_Mark",s[s.U_Combining_Acute_Tone_Mark=833]="U_Combining_Acute_Tone_Mark",s[s.U_Combining_Greek_Perispomeni=834]="U_Combining_Greek_Perispomeni",s[s.U_Combining_Greek_Koronis=835]="U_Combining_Greek_Koronis",s[s.U_Combining_Greek_Dialytika_Tonos=836]="U_Combining_Greek_Dialytika_Tonos",s[s.U_Combining_Greek_Ypogegrammeni=837]="U_Combining_Greek_Ypogegrammeni",s[s.U_Combining_Bridge_Above=838]="U_Combining_Bridge_Above",s[s.U_Combining_Equals_Sign_Below=839]="U_Combining_Equals_Sign_Below",s[s.U_Combining_Double_Vertical_Line_Below=840]="U_Combining_Double_Vertical_Line_Below",s[s.U_Combining_Left_Angle_Below=841]="U_Combining_Left_Angle_Below",s[s.U_Combining_Not_Tilde_Above=842]="U_Combining_Not_Tilde_Above",s[s.U_Combining_Homothetic_Above=843]="U_Combining_Homothetic_Above",s[s.U_Combining_Almost_Equal_To_Above=844]="U_Combining_Almost_Equal_To_Above",s[s.U_Combining_Left_Right_Arrow_Below=845]="U_Combining_Left_Right_Arrow_Below",s[s.U_Combining_Upwards_Arrow_Below=846]="U_Combining_Upwards_Arrow_Below",s[s.U_Combining_Grapheme_Joiner=847]="U_Combining_Grapheme_Joiner",s[s.U_Combining_Right_Arrowhead_Above=848]="U_Combining_Right_Arrowhead_Above",s[s.U_Combining_Left_Half_Ring_Above=849]="U_Combining_Left_Half_Ring_Above",s[s.U_Combining_Fermata=850]="U_Combining_Fermata",s[s.U_Combining_X_Below=851]="U_Combining_X_Below",s[s.U_Combining_Left_Arrowhead_Below=852]="U_Combining_Left_Arrowhead_Below",s[s.U_Combining_Right_Arrowhead_Below=853]="U_Combining_Right_Arrowhead_Below",s[s.U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below=854]="U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below",s[s.U_Combining_Right_Half_Ring_Above=855]="U_Combining_Right_Half_Ring_Above",s[s.U_Combining_Dot_Above_Right=856]="U_Combining_Dot_Above_Right",s[s.U_Combining_Asterisk_Below=857]="U_Combining_Asterisk_Below",s[s.U_Combining_Double_Ring_Below=858]="U_Combining_Double_Ring_Below",s[s.U_Combining_Zigzag_Above=859]="U_Combining_Zigzag_Above",s[s.U_Combining_Double_Breve_Below=860]="U_Combining_Double_Breve_Below",s[s.U_Combining_Double_Breve=861]="U_Combining_Double_Breve",s[s.U_Combining_Double_Macron=862]="U_Combining_Double_Macron",s[s.U_Combining_Double_Macron_Below=863]="U_Combining_Double_Macron_Below",s[s.U_Combining_Double_Tilde=864]="U_Combining_Double_Tilde",s[s.U_Combining_Double_Inverted_Breve=865]="U_Combining_Double_Inverted_Breve",s[s.U_Combining_Double_Rightwards_Arrow_Below=866]="U_Combining_Double_Rightwards_Arrow_Below",s[s.U_Combining_Latin_Small_Letter_A=867]="U_Combining_Latin_Small_Letter_A",s[s.U_Combining_Latin_Small_Letter_E=868]="U_Combining_Latin_Small_Letter_E",s[s.U_Combining_Latin_Small_Letter_I=869]="U_Combining_Latin_Small_Letter_I",s[s.U_Combining_Latin_Small_Letter_O=870]="U_Combining_Latin_Small_Letter_O",s[s.U_Combining_Latin_Small_Letter_U=871]="U_Combining_Latin_Small_Letter_U",s[s.U_Combining_Latin_Small_Letter_C=872]="U_Combining_Latin_Small_Letter_C",s[s.U_Combining_Latin_Small_Letter_D=873]="U_Combining_Latin_Small_Letter_D",s[s.U_Combining_Latin_Small_Letter_H=874]="U_Combining_Latin_Small_Letter_H",s[s.U_Combining_Latin_Small_Letter_M=875]="U_Combining_Latin_Small_Letter_M",s[s.U_Combining_Latin_Small_Letter_R=876]="U_Combining_Latin_Small_Letter_R",s[s.U_Combining_Latin_Small_Letter_T=877]="U_Combining_Latin_Small_Letter_T",s[s.U_Combining_Latin_Small_Letter_V=878]="U_Combining_Latin_Small_Letter_V",s[s.U_Combining_Latin_Small_Letter_X=879]="U_Combining_Latin_Small_Letter_X",s[s.LINE_SEPARATOR=8232]="LINE_SEPARATOR",s[s.PARAGRAPH_SEPARATOR=8233]="PARAGRAPH_SEPARATOR",s[s.NEXT_LINE=133]="NEXT_LINE",s[s.U_CIRCUMFLEX=94]="U_CIRCUMFLEX",s[s.U_GRAVE_ACCENT=96]="U_GRAVE_ACCENT",s[s.U_DIAERESIS=168]="U_DIAERESIS",s[s.U_MACRON=175]="U_MACRON",s[s.U_ACUTE_ACCENT=180]="U_ACUTE_ACCENT",s[s.U_CEDILLA=184]="U_CEDILLA",s[s.U_MODIFIER_LETTER_LEFT_ARROWHEAD=706]="U_MODIFIER_LETTER_LEFT_ARROWHEAD",s[s.U_MODIFIER_LETTER_RIGHT_ARROWHEAD=707]="U_MODIFIER_LETTER_RIGHT_ARROWHEAD",s[s.U_MODIFIER_LETTER_UP_ARROWHEAD=708]="U_MODIFIER_LETTER_UP_ARROWHEAD",s[s.U_MODIFIER_LETTER_DOWN_ARROWHEAD=709]="U_MODIFIER_LETTER_DOWN_ARROWHEAD",s[s.U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING=722]="U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING",s[s.U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING=723]="U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING",s[s.U_MODIFIER_LETTER_UP_TACK=724]="U_MODIFIER_LETTER_UP_TACK",s[s.U_MODIFIER_LETTER_DOWN_TACK=725]="U_MODIFIER_LETTER_DOWN_TACK",s[s.U_MODIFIER_LETTER_PLUS_SIGN=726]="U_MODIFIER_LETTER_PLUS_SIGN",s[s.U_MODIFIER_LETTER_MINUS_SIGN=727]="U_MODIFIER_LETTER_MINUS_SIGN",s[s.U_BREVE=728]="U_BREVE",s[s.U_DOT_ABOVE=729]="U_DOT_ABOVE",s[s.U_RING_ABOVE=730]="U_RING_ABOVE",s[s.U_OGONEK=731]="U_OGONEK",s[s.U_SMALL_TILDE=732]="U_SMALL_TILDE",s[s.U_DOUBLE_ACUTE_ACCENT=733]="U_DOUBLE_ACUTE_ACCENT",s[s.U_MODIFIER_LETTER_RHOTIC_HOOK=734]="U_MODIFIER_LETTER_RHOTIC_HOOK",s[s.U_MODIFIER_LETTER_CROSS_ACCENT=735]="U_MODIFIER_LETTER_CROSS_ACCENT",s[s.U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR=741]="U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR",s[s.U_MODIFIER_LETTER_HIGH_TONE_BAR=742]="U_MODIFIER_LETTER_HIGH_TONE_BAR",s[s.U_MODIFIER_LETTER_MID_TONE_BAR=743]="U_MODIFIER_LETTER_MID_TONE_BAR",s[s.U_MODIFIER_LETTER_LOW_TONE_BAR=744]="U_MODIFIER_LETTER_LOW_TONE_BAR",s[s.U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR=745]="U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR",s[s.U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK=746]="U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK",s[s.U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK=747]="U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK",s[s.U_MODIFIER_LETTER_UNASPIRATED=749]="U_MODIFIER_LETTER_UNASPIRATED",s[s.U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD=751]="U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD",s[s.U_MODIFIER_LETTER_LOW_UP_ARROWHEAD=752]="U_MODIFIER_LETTER_LOW_UP_ARROWHEAD",s[s.U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD=753]="U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD",s[s.U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD=754]="U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD",s[s.U_MODIFIER_LETTER_LOW_RING=755]="U_MODIFIER_LETTER_LOW_RING",s[s.U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT=756]="U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT",s[s.U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT=757]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT",s[s.U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT=758]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT",s[s.U_MODIFIER_LETTER_LOW_TILDE=759]="U_MODIFIER_LETTER_LOW_TILDE",s[s.U_MODIFIER_LETTER_RAISED_COLON=760]="U_MODIFIER_LETTER_RAISED_COLON",s[s.U_MODIFIER_LETTER_BEGIN_HIGH_TONE=761]="U_MODIFIER_LETTER_BEGIN_HIGH_TONE",s[s.U_MODIFIER_LETTER_END_HIGH_TONE=762]="U_MODIFIER_LETTER_END_HIGH_TONE",s[s.U_MODIFIER_LETTER_BEGIN_LOW_TONE=763]="U_MODIFIER_LETTER_BEGIN_LOW_TONE",s[s.U_MODIFIER_LETTER_END_LOW_TONE=764]="U_MODIFIER_LETTER_END_LOW_TONE",s[s.U_MODIFIER_LETTER_SHELF=765]="U_MODIFIER_LETTER_SHELF",s[s.U_MODIFIER_LETTER_OPEN_SHELF=766]="U_MODIFIER_LETTER_OPEN_SHELF",s[s.U_MODIFIER_LETTER_LOW_LEFT_ARROW=767]="U_MODIFIER_LETTER_LOW_LEFT_ARROW",s[s.U_GREEK_LOWER_NUMERAL_SIGN=885]="U_GREEK_LOWER_NUMERAL_SIGN",s[s.U_GREEK_TONOS=900]="U_GREEK_TONOS",s[s.U_GREEK_DIALYTIKA_TONOS=901]="U_GREEK_DIALYTIKA_TONOS",s[s.U_GREEK_KORONIS=8125]="U_GREEK_KORONIS",s[s.U_GREEK_PSILI=8127]="U_GREEK_PSILI",s[s.U_GREEK_PERISPOMENI=8128]="U_GREEK_PERISPOMENI",s[s.U_GREEK_DIALYTIKA_AND_PERISPOMENI=8129]="U_GREEK_DIALYTIKA_AND_PERISPOMENI",s[s.U_GREEK_PSILI_AND_VARIA=8141]="U_GREEK_PSILI_AND_VARIA",s[s.U_GREEK_PSILI_AND_OXIA=8142]="U_GREEK_PSILI_AND_OXIA",s[s.U_GREEK_PSILI_AND_PERISPOMENI=8143]="U_GREEK_PSILI_AND_PERISPOMENI",s[s.U_GREEK_DASIA_AND_VARIA=8157]="U_GREEK_DASIA_AND_VARIA",s[s.U_GREEK_DASIA_AND_OXIA=8158]="U_GREEK_DASIA_AND_OXIA",s[s.U_GREEK_DASIA_AND_PERISPOMENI=8159]="U_GREEK_DASIA_AND_PERISPOMENI",s[s.U_GREEK_DIALYTIKA_AND_VARIA=8173]="U_GREEK_DIALYTIKA_AND_VARIA",s[s.U_GREEK_DIALYTIKA_AND_OXIA=8174]="U_GREEK_DIALYTIKA_AND_OXIA",s[s.U_GREEK_VARIA=8175]="U_GREEK_VARIA",s[s.U_GREEK_OXIA=8189]="U_GREEK_OXIA",s[s.U_GREEK_DASIA=8190]="U_GREEK_DASIA",s[s.U_IDEOGRAPHIC_FULL_STOP=12290]="U_IDEOGRAPHIC_FULL_STOP",s[s.U_LEFT_CORNER_BRACKET=12300]="U_LEFT_CORNER_BRACKET",s[s.U_RIGHT_CORNER_BRACKET=12301]="U_RIGHT_CORNER_BRACKET",s[s.U_LEFT_BLACK_LENTICULAR_BRACKET=12304]="U_LEFT_BLACK_LENTICULAR_BRACKET",s[s.U_RIGHT_BLACK_LENTICULAR_BRACKET=12305]="U_RIGHT_BLACK_LENTICULAR_BRACKET",s[s.U_OVERLINE=8254]="U_OVERLINE",s[s.UTF8_BOM=65279]="UTF8_BOM",s[s.U_FULLWIDTH_SEMICOLON=65307]="U_FULLWIDTH_SEMICOLON",s[s.U_FULLWIDTH_COMMA=65292]="U_FULLWIDTH_COMMA"})(i||(e.CharCode=i={}))}),define(le[142],ue([0,1]),function(j,e){"use strict";var i;Object.defineProperty(e,"__esModule",{value:!0}),e.SetWithKey=void 0,e.groupBy=s,e.diffSets=y,e.diffMaps=k,e.intersection=A;function s(S,c){const m=Object.create(null);for(const u of S){const p=c(u);let v=m[p];v||(v=m[p]=[]),v.push(u)}return m}function y(S,c){const m=[],u=[];for(const p of S)c.has(p)||m.push(p);for(const p of c)S.has(p)||u.push(p);return{removed:m,added:u}}function k(S,c){const m=[],u=[];for(const[p,v]of S)c.has(p)||m.push(v);for(const[p,v]of c)S.has(p)||u.push(v);return{removed:m,added:u}}function A(S,c){const m=new Set;for(const u of c)S.has(u)&&m.add(u);return m}class R{static{i=Symbol.toStringTag}constructor(c,m){this.toKey=m,this._map=new Map,this[i]="SetWithKey";for(const u of c)this.add(u)}get size(){return this._map.size}add(c){const m=this.toKey(c);return this._map.set(m,c),this}delete(c){return this._map.delete(this.toKey(c))}has(c){return this._map.has(this.toKey(c))}*entries(){for(const c of this._map.values())yield[c,c]}keys(){return this.values()}*values(){for(const c of this._map.values())yield c}clear(){this._map.clear()}forEach(c,m){this._map.forEach(u=>c.call(m,u,u,this))}[Symbol.iterator](){return this.values()}}e.SetWithKey=R}),define(le[143],ue([0,1,39]),function(j,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Color=e.HSVA=e.HSLA=e.RGBA=void 0;function s(S,c){const m=Math.pow(10,c);return Math.round(S*m)/m}class y{constructor(c,m,u,p=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,c))|0,this.g=Math.min(255,Math.max(0,m))|0,this.b=Math.min(255,Math.max(0,u))|0,this.a=s(Math.max(Math.min(1,p),0),3)}static equals(c,m){return c.r===m.r&&c.g===m.g&&c.b===m.b&&c.a===m.a}}e.RGBA=y;class k{constructor(c,m,u,p){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,c),0)|0,this.s=s(Math.max(Math.min(1,m),0),3),this.l=s(Math.max(Math.min(1,u),0),3),this.a=s(Math.max(Math.min(1,p),0),3)}static equals(c,m){return c.h===m.h&&c.s===m.s&&c.l===m.l&&c.a===m.a}static fromRGBA(c){const m=c.r/255,u=c.g/255,p=c.b/255,v=c.a,f=Math.max(m,u,p),h=Math.min(m,u,p);let E=0,b=0;const g=(h+f)/2,I=f-h;if(I>0){switch(b=Math.min(g<=.5?I/(2*g):I/(2-2*g),1),f){case m:E=(u-p)/I+(u<p?6:0);break;case u:E=(p-m)/I+2;break;case p:E=(m-u)/I+4;break}E*=60,E=Math.round(E)}return new k(E,b,g,v)}static _hue2rgb(c,m,u){return u<0&&(u+=1),u>1&&(u-=1),u<1/6?c+(m-c)*6*u:u<1/2?m:u<2/3?c+(m-c)*(2/3-u)*6:c}static toRGBA(c){const m=c.h/360,{s:u,l:p,a:v}=c;let f,h,E;if(u===0)f=h=E=p;else{const b=p<.5?p*(1+u):p+u-p*u,g=2*p-b;f=k._hue2rgb(g,b,m+1/3),h=k._hue2rgb(g,b,m),E=k._hue2rgb(g,b,m-1/3)}return new y(Math.round(f*255),Math.round(h*255),Math.round(E*255),v)}}e.HSLA=k;class A{constructor(c,m,u,p){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,c),0)|0,this.s=s(Math.max(Math.min(1,m),0),3),this.v=s(Math.max(Math.min(1,u),0),3),this.a=s(Math.max(Math.min(1,p),0),3)}static equals(c,m){return c.h===m.h&&c.s===m.s&&c.v===m.v&&c.a===m.a}static fromRGBA(c){const m=c.r/255,u=c.g/255,p=c.b/255,v=Math.max(m,u,p),f=Math.min(m,u,p),h=v-f,E=v===0?0:h/v;let b;return h===0?b=0:v===m?b=((u-p)/h%6+6)%6:v===u?b=(p-m)/h+2:b=(m-u)/h+4,new A(Math.round(b*60),E,v,c.a)}static toRGBA(c){const{h:m,s:u,v:p,a:v}=c,f=p*u,h=f*(1-Math.abs(m/60%2-1)),E=p-f;let[b,g,I]=[0,0,0];return m<60?(b=f,g=h):m<120?(b=h,g=f):m<180?(g=f,I=h):m<240?(g=h,I=f):m<300?(b=h,I=f):m<=360&&(b=f,I=h),b=Math.round((b+E)*255),g=Math.round((g+E)*255),I=Math.round((I+E)*255),new y(b,g,I,v)}}e.HSVA=A;class R{static fromHex(c){return R.Format.CSS.parseHex(c)||R.red}static equals(c,m){return!c&&!m?!0:!c||!m?!1:c.equals(m)}get hsla(){return this._hsla?this._hsla:k.fromRGBA(this.rgba)}get hsva(){return this._hsva?this._hsva:A.fromRGBA(this.rgba)}constructor(c){if(c)if(c instanceof y)this.rgba=c;else if(c instanceof k)this._hsla=c,this.rgba=k.toRGBA(c);else if(c instanceof A)this._hsva=c,this.rgba=A.toRGBA(c);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(c){return!!c&&y.equals(this.rgba,c.rgba)&&k.equals(this.hsla,c.hsla)&&A.equals(this.hsva,c.hsva)}getRelativeLuminance(){const c=R._relativeLuminanceForComponent(this.rgba.r),m=R._relativeLuminanceForComponent(this.rgba.g),u=R._relativeLuminanceForComponent(this.rgba.b),p=.2126*c+.7152*m+.0722*u;return s(p,4)}static _relativeLuminanceForComponent(c){const m=c/255;return m<=.03928?m/12.92:Math.pow((m+.055)/1.055,2.4)}getContrastRatio(c){const m=this.getRelativeLuminance(),u=c.getRelativeLuminance();return m>u?(m+.05)/(u+.05):(u+.05)/(m+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(c){const m=this.getRelativeLuminance(),u=c.getRelativeLuminance();return m>u}isDarkerThan(c){const m=this.getRelativeLuminance(),u=c.getRelativeLuminance();return m<u}lighten(c){return new R(new k(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*c,this.hsla.a))}darken(c){return new R(new k(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*c,this.hsla.a))}transparent(c){const{r:m,g:u,b:p,a:v}=this.rgba;return new R(new y(m,u,p,v*c))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new R(new y(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(c){const m=c.rgba,u=this.rgba.a,p=m.a,v=u+p*(1-u);if(v<1e-6)return R.transparent;const f=this.rgba.r*u/v+m.r*p*(1-u)/v,h=this.rgba.g*u/v+m.g*p*(1-u)/v,E=this.rgba.b*u/v+m.b*p*(1-u)/v;return new R(new y(f,h,E,v))}makeOpaque(c){if(this.isOpaque()||c.rgba.a!==1)return this;const{r:m,g:u,b:p,a:v}=this.rgba;return new R(new y(c.rgba.r-v*(c.rgba.r-m),c.rgba.g-v*(c.rgba.g-u),c.rgba.b-v*(c.rgba.b-p),1))}flatten(...c){const m=c.reduceRight((u,p)=>R._flatten(p,u));return R._flatten(this,m)}static _flatten(c,m){const u=1-c.rgba.a;return new R(new y(u*m.rgba.r+c.rgba.a*c.rgba.r,u*m.rgba.g+c.rgba.a*c.rgba.g,u*m.rgba.b+c.rgba.a*c.rgba.b))}toString(){return this._toString||(this._toString=R.Format.CSS.format(this)),this._toString}static getLighterColor(c,m,u){if(c.isLighterThan(m))return c;u=u||.5;const p=c.getRelativeLuminance(),v=m.getRelativeLuminance();return u=u*(v-p)/v,c.lighten(u)}static getDarkerColor(c,m,u){if(c.isDarkerThan(m))return c;u=u||.5;const p=c.getRelativeLuminance(),v=m.getRelativeLuminance();return u=u*(p-v)/p,c.darken(u)}static{this.white=new R(new y(255,255,255,1))}static{this.black=new R(new y(0,0,0,1))}static{this.red=new R(new y(255,0,0,1))}static{this.blue=new R(new y(0,0,255,1))}static{this.green=new R(new y(0,255,0,1))}static{this.cyan=new R(new y(0,255,255,1))}static{this.lightgrey=new R(new y(211,211,211,1))}static{this.transparent=new R(new y(0,0,0,0))}}e.Color=R,function(S){let c;(function(m){let u;(function(p){function v(t){return t.rgba.a===1?`rgb(${t.rgba.r}, ${t.rgba.g}, ${t.rgba.b})`:S.Format.CSS.formatRGBA(t)}p.formatRGB=v;function f(t){return`rgba(${t.rgba.r}, ${t.rgba.g}, ${t.rgba.b}, ${+t.rgba.a.toFixed(2)})`}p.formatRGBA=f;function h(t){return t.hsla.a===1?`hsl(${t.hsla.h}, ${(t.hsla.s*100).toFixed(2)}%, ${(t.hsla.l*100).toFixed(2)}%)`:S.Format.CSS.formatHSLA(t)}p.formatHSL=h;function E(t){return`hsla(${t.hsla.h}, ${(t.hsla.s*100).toFixed(2)}%, ${(t.hsla.l*100).toFixed(2)}%, ${t.hsla.a.toFixed(2)})`}p.formatHSLA=E;function b(t){const o=t.toString(16);return o.length!==2?"0"+o:o}function g(t){return`#${b(t.rgba.r)}${b(t.rgba.g)}${b(t.rgba.b)}`}p.formatHex=g;function I(t,o=!1){return o&&t.rgba.a===1?S.Format.CSS.formatHex(t):`#${b(t.rgba.r)}${b(t.rgba.g)}${b(t.rgba.b)}${b(Math.round(t.rgba.a*255))}`}p.formatHexA=I;function P(t){return t.isOpaque()?S.Format.CSS.formatHex(t):S.Format.CSS.formatRGBA(t)}p.format=P;function r(t){const o=t.length;if(o===0||t.charCodeAt(0)!==i.CharCode.Hash)return null;if(o===7){const n=16*a(t.charCodeAt(1))+a(t.charCodeAt(2)),l=16*a(t.charCodeAt(3))+a(t.charCodeAt(4)),d=16*a(t.charCodeAt(5))+a(t.charCodeAt(6));return new S(new y(n,l,d,1))}if(o===9){const n=16*a(t.charCodeAt(1))+a(t.charCodeAt(2)),l=16*a(t.charCodeAt(3))+a(t.charCodeAt(4)),d=16*a(t.charCodeAt(5))+a(t.charCodeAt(6)),D=16*a(t.charCodeAt(7))+a(t.charCodeAt(8));return new S(new y(n,l,d,D/255))}if(o===4){const n=a(t.charCodeAt(1)),l=a(t.charCodeAt(2)),d=a(t.charCodeAt(3));return new S(new y(16*n+n,16*l+l,16*d+d))}if(o===5){const n=a(t.charCodeAt(1)),l=a(t.charCodeAt(2)),d=a(t.charCodeAt(3)),D=a(t.charCodeAt(4));return new S(new y(16*n+n,16*l+l,16*d+d,(16*D+D)/255))}return null}p.parseHex=r;function a(t){switch(t){case i.CharCode.Digit0:return 0;case i.CharCode.Digit1:return 1;case i.CharCode.Digit2:return 2;case i.CharCode.Digit3:return 3;case i.CharCode.Digit4:return 4;case i.CharCode.Digit5:return 5;case i.CharCode.Digit6:return 6;case i.CharCode.Digit7:return 7;case i.CharCode.Digit8:return 8;case i.CharCode.Digit9:return 9;case i.CharCode.a:return 10;case i.CharCode.A:return 10;case i.CharCode.b:return 11;case i.CharCode.B:return 11;case i.CharCode.c:return 12;case i.CharCode.C:return 12;case i.CharCode.d:return 13;case i.CharCode.D:return 13;case i.CharCode.e:return 14;case i.CharCode.E:return 14;case i.CharCode.f:return 15;case i.CharCode.F:return 15}return 0}})(u=m.CSS||(m.CSS={}))})(c=S.Format||(S.Format={}))}(R||(e.Color=R={}))}),define(le[54],ue([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.memoize=s,e.debounce=y,e.throttle=k;function i(A){return(R,S,c)=>{let m=null,u=null;if(typeof c.value=="function"?(m="value",u=c.value):typeof c.get=="function"&&(m="get",u=c.get),!u)throw new Error("not supported");c[m]=A(u,S)}}function s(A,R,S){let c=null,m=null;if(typeof S.value=="function"?(c="value",m=S.value,m.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof S.get=="function"&&(c="get",m=S.get),!m)throw new Error("not supported");const u=`$memoize$${R}`;S[c]=function(...p){return this.hasOwnProperty(u)||Object.defineProperty(this,u,{configurable:!1,enumerable:!1,writable:!1,value:m.apply(this,p)}),this[u]}}function y(A,R,S){return i((c,m)=>{const u=`$debounce$${m}`,p=`$debounce$result$${m}`;return function(...v){this[p]||(this[p]=S?S():void 0),clearTimeout(this[u]),R&&(this[p]=R(this[p],...v),v=[this[p]]),this[u]=setTimeout(()=>{c.apply(this,v),this[p]=S?S():void 0},A)}})}function k(A,R,S){return i((c,m)=>{const u=`$throttle$timer$${m}`,p=`$throttle$result$${m}`,v=`$throttle$lastRun$${m}`,f=`$throttle$pending$${m}`;return function(...h){if(this[p]||(this[p]=S?S():void 0),(this[v]===null||this[v]===void 0)&&(this[v]=-Number.MAX_VALUE),R&&(this[p]=R(this[p],...h)),this[f])return;const E=this[v]+A;E<=Date.now()?(this[v]=Date.now(),c.apply(this,[this[p]]),this[p]=S?S():void 0):(this[f]=!0,this[u]=setTimeout(()=>{this[f]=!1,this[v]=Date.now(),c.apply(this,[this[p]]),this[p]=S?S():void 0},E-Date.now()))}})}}),define(le[15],ue([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.ReadonlyError=e.CancellationError=e.errorHandler=e.ErrorHandler=void 0,e.setUnexpectedErrorHandler=s,e.isSigPipeError=y,e.onUnexpectedError=k,e.onUnexpectedExternalError=A,e.transformErrorForSerialization=R,e.transformErrorFromSerialization=S,e.isCancellationError=m,e.canceled=p,e.illegalArgument=v,e.illegalState=f,e.getErrorMessage=E;class i{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(t){setTimeout(()=>{throw t.stack?P.isErrorNoTelemetry(t)?new P(t.message+`

`+t.stack):new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.listeners.push(t),()=>{this._removeListener(t)}}emit(t){this.listeners.forEach(o=>{o(t)})}_removeListener(t){this.listeners.splice(this.listeners.indexOf(t),1)}setUnexpectedErrorHandler(t){this.unexpectedErrorHandler=t}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(t){this.unexpectedErrorHandler(t),this.emit(t)}onUnexpectedExternalError(t){this.unexpectedErrorHandler(t)}}e.ErrorHandler=i,e.errorHandler=new i;function s(a){e.errorHandler.setUnexpectedErrorHandler(a)}function y(a){if(!a||typeof a!="object")return!1;const t=a;return t.code==="EPIPE"&&t.syscall?.toUpperCase()==="WRITE"}function k(a){m(a)||e.errorHandler.onUnexpectedError(a)}function A(a){m(a)||e.errorHandler.onUnexpectedExternalError(a)}function R(a){if(a instanceof Error){const{name:t,message:o}=a,n=a.stacktrace||a.stack;return{$isError:!0,name:t,message:o,stack:n,noTelemetry:P.isErrorNoTelemetry(a)}}return a}function S(a){let t;return a.noTelemetry?t=new P:(t=new Error,t.name=a.name),t.message=a.message,t.stack=a.stack,t}const c="Canceled";function m(a){return a instanceof u?!0:a instanceof Error&&a.name===c&&a.message===c}class u extends Error{constructor(){super(c),this.name=this.message}}e.CancellationError=u;function p(){const a=new Error(c);return a.name=a.message,a}function v(a){return a?new Error(`Illegal argument: ${a}`):new Error("Illegal argument")}function f(a){return a?new Error(`Illegal state: ${a}`):new Error("Illegal state")}class h extends TypeError{constructor(t){super(t?`${t} is read-only and cannot be changed`:"Cannot change read-only property")}}e.ReadonlyError=h;function E(a){return a?a.message?a.message:a.stack?a.stack.split(`
`)[0]:String(a):"Error"}class b extends Error{constructor(t){super("NotImplemented"),t&&(this.message=t)}}e.NotImplementedError=b;class g extends Error{constructor(t){super("NotSupported"),t&&(this.message=t)}}e.NotSupportedError=g;class I extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.ExpectedError=I;class P extends Error{constructor(t){super(t),this.name="CodeExpectedError"}static fromError(t){if(t instanceof P)return t;const o=new P;return o.message=t.message,o.stack=t.stack,o}static isErrorNoTelemetry(t){return t.name==="CodeExpectedError"}}e.ErrorNoTelemetry=P;class r extends Error{constructor(t){super(t||"An unexpected bug occurred."),Object.setPrototypeOf(this,r.prototype)}}e.BugIndicatingError=r}),define(le[21],ue([0,1,15,141]),function(j,e,i,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Permutation=e.CallbackIterable=e.ArrayQueue=e.booleanComparator=e.numberComparator=e.CompareResult=void 0,e.tail=y,e.tail2=k,e.equals=A,e.removeFastWithoutKeepingOrder=R,e.binarySearch=S,e.binarySearch2=c,e.quickSelect=m,e.groupBy=u,e.groupAdjacentBy=p,e.forEachAdjacent=v,e.forEachWithNeighbors=f,e.sortedDiff=h,e.delta=E,e.top=b,e.topAsync=g,e.coalesce=P,e.coalesceInPlace=r,e.move=a,e.isFalsyOrEmpty=t,e.isNonEmptyArray=o,e.distinct=n,e.uniqueFilter=l,e.firstOrDefault=d,e.lastOrDefault=D,e.commonPrefixLength=w,e.range=M,e.index=T,e.insert=C,e.remove=L,e.arrayInsert=_,e.shuffle=V,e.pushToStart=z,e.pushToEnd=Q,e.pushMany=fe,e.mapArrayOrNot=se,e.asArray=ee,e.getRandomElement=U,e.insertInto=K,e.splice=N,e.compareBy=q,e.tieBreakComparators=ie,e.reverseOrder=oe,e.findAsync=B;function y(F,J=0){return F[F.length-(1+J)]}function k(F){if(F.length===0)throw new Error("Invalid tail call");return[F.slice(0,F.length-1),F[F.length-1]]}function A(F,J,G=($,Z)=>$===Z){if(F===J)return!0;if(!F||!J||F.length!==J.length)return!1;for(let $=0,Z=F.length;$<Z;$++)if(!G(F[$],J[$]))return!1;return!0}function R(F,J){const G=F.length-1;J<G&&(F[J]=F[G]),F.pop()}function S(F,J,G){return c(F.length,$=>G(F[$],J))}function c(F,J){let G=0,$=F-1;for(;G<=$;){const Z=(G+$)/2|0,ae=J(Z);if(ae<0)G=Z+1;else if(ae>0)$=Z-1;else return Z}return-(G+1)}function m(F,J,G){if(F=F|0,F>=J.length)throw new TypeError("invalid index");const $=J[Math.floor(J.length*Math.random())],Z=[],ae=[],pe=[];for(const Se of J){const ye=G(Se,$);ye<0?Z.push(Se):ye>0?ae.push(Se):pe.push(Se)}return F<Z.length?m(F,Z,G):F<Z.length+pe.length?pe[0]:m(F-(Z.length+pe.length),ae,G)}function u(F,J){const G=[];let $;for(const Z of F.slice(0).sort(J))!$||J($[0],Z)!==0?($=[Z],G.push($)):$.push(Z);return G}function*p(F,J){let G,$;for(const Z of F)$!==void 0&&J($,Z)?G.push(Z):(G&&(yield G),G=[Z]),$=Z;G&&(yield G)}function v(F,J){for(let G=0;G<=F.length;G++)J(G===0?void 0:F[G-1],G===F.length?void 0:F[G])}function f(F,J){for(let G=0;G<F.length;G++)J(G===0?void 0:F[G-1],F[G],G+1===F.length?void 0:F[G+1])}function h(F,J,G){const $=[];function Z(Se,ye,We){if(ye===0&&We.length===0)return;const He=$[$.length-1];He&&He.start+He.deleteCount===Se?(He.deleteCount+=ye,He.toInsert.push(...We)):$.push({start:Se,deleteCount:ye,toInsert:We})}let ae=0,pe=0;for(;;){if(ae===F.length){Z(ae,0,J.slice(pe));break}if(pe===J.length){Z(ae,F.length-ae,[]);break}const Se=F[ae],ye=J[pe],We=G(Se,ye);We===0?(ae+=1,pe+=1):We<0?(Z(ae,1,[]),ae+=1):We>0&&(Z(ae,0,[ye]),pe+=1)}return $}function E(F,J,G){const $=h(F,J,G),Z=[],ae=[];for(const pe of $)Z.push(...F.slice(pe.start,pe.start+pe.deleteCount)),ae.push(...pe.toInsert);return{removed:Z,added:ae}}function b(F,J,G){if(G===0)return[];const $=F.slice(0,G).sort(J);return I(F,J,$,G,F.length),$}function g(F,J,G,$,Z){return G===0?Promise.resolve([]):new Promise((ae,pe)=>{(async()=>{const Se=F.length,ye=F.slice(0,G).sort(J);for(let We=G,He=Math.min(G+$,Se);We<Se;We=He,He=Math.min(He+$,Se)){if(We>G&&await new Promise(Ce=>setTimeout(Ce)),Z&&Z.isCancellationRequested)throw new i.CancellationError;I(F,J,ye,We,He)}return ye})().then(ae,pe)})}function I(F,J,G,$,Z){for(const ae=G.length;$<Z;$++){const pe=F[$];if(J(pe,G[ae-1])<0){G.pop();const Se=(0,s.findFirstIdxMonotonousOrArrLen)(G,ye=>J(pe,ye)<0);G.splice(Se,0,pe)}}}function P(F){return F.filter(J=>!!J)}function r(F){let J=0;for(let G=0;G<F.length;G++)F[G]&&(F[J]=F[G],J+=1);F.length=J}function a(F,J,G){F.splice(G,0,F.splice(J,1)[0])}function t(F){return!Array.isArray(F)||F.length===0}function o(F){return Array.isArray(F)&&F.length>0}function n(F,J=G=>G){const G=new Set;return F.filter($=>{const Z=J($);return G.has(Z)?!1:(G.add(Z),!0)})}function l(F){const J=new Set;return G=>{const $=F(G);return J.has($)?!1:(J.add($),!0)}}function d(F,J){return F.length>0?F[0]:J}function D(F,J){return F.length>0?F[F.length-1]:J}function w(F,J,G=($,Z)=>$===Z){let $=0;for(let Z=0,ae=Math.min(F.length,J.length);Z<ae&&G(F[Z],J[Z]);Z++)$++;return $}function M(F,J){let G=typeof J=="number"?F:0;typeof J=="number"?G=F:(G=0,J=F);const $=[];if(G<=J)for(let Z=G;Z<J;Z++)$.push(Z);else for(let Z=G;Z>J;Z--)$.push(Z);return $}function T(F,J,G){return F.reduce(($,Z)=>($[J(Z)]=G?G(Z):Z,$),Object.create(null))}function C(F,J){return F.push(J),()=>L(F,J)}function L(F,J){const G=F.indexOf(J);if(G>-1)return F.splice(G,1),J}function _(F,J,G){const $=F.slice(0,J),Z=F.slice(J);return $.concat(G,Z)}function V(F,J){let G;if(typeof J=="number"){let $=J;G=()=>{const Z=Math.sin($++)*179426549;return Z-Math.floor(Z)}}else G=Math.random;for(let $=F.length-1;$>0;$-=1){const Z=Math.floor(G()*($+1)),ae=F[$];F[$]=F[Z],F[Z]=ae}}function z(F,J){const G=F.indexOf(J);G>-1&&(F.splice(G,1),F.unshift(J))}function Q(F,J){const G=F.indexOf(J);G>-1&&(F.splice(G,1),F.push(J))}function fe(F,J){for(const G of J)F.push(G)}function se(F,J){return Array.isArray(F)?F.map(J):J(F)}function ee(F){return Array.isArray(F)?F:[F]}function U(F){return F[Math.floor(Math.random()*F.length)]}function K(F,J,G){const $=x(F,J),Z=F.length,ae=G.length;F.length=Z+ae;for(let pe=Z-1;pe>=$;pe--)F[pe+ae]=F[pe];for(let pe=0;pe<ae;pe++)F[pe+$]=G[pe]}function N(F,J,G,$){const Z=x(F,J);let ae=F.splice(Z,G);return ae===void 0&&(ae=[]),K(F,Z,$),ae}function x(F,J){return J<0?Math.max(J+F.length,0):Math.min(J,F.length)}var W;(function(F){function J(ae){return ae<0}F.isLessThan=J;function G(ae){return ae<=0}F.isLessThanOrEqual=G;function $(ae){return ae>0}F.isGreaterThan=$;function Z(ae){return ae===0}F.isNeitherLessOrGreaterThan=Z,F.greaterThan=1,F.lessThan=-1,F.neitherLessOrGreaterThan=0})(W||(e.CompareResult=W={}));function q(F,J){return(G,$)=>J(F(G),F($))}function ie(...F){return(J,G)=>{for(const $ of F){const Z=$(J,G);if(!W.isNeitherLessOrGreaterThan(Z))return Z}return W.neitherLessOrGreaterThan}}const H=(F,J)=>F-J;e.numberComparator=H;const ce=(F,J)=>(0,e.numberComparator)(F?1:0,J?1:0);e.booleanComparator=ce;function oe(F){return(J,G)=>-F(J,G)}class te{constructor(J){this.items=J,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(J){let G=this.firstIdx;for(;G<this.items.length&&J(this.items[G]);)G++;const $=G===this.firstIdx?null:this.items.slice(this.firstIdx,G);return this.firstIdx=G,$}takeFromEndWhile(J){let G=this.lastIdx;for(;G>=0&&J(this.items[G]);)G--;const $=G===this.lastIdx?null:this.items.slice(G+1,this.lastIdx+1);return this.lastIdx=G,$}peek(){if(this.length!==0)return this.items[this.firstIdx]}peekLast(){if(this.length!==0)return this.items[this.lastIdx]}dequeue(){const J=this.items[this.firstIdx];return this.firstIdx++,J}removeLast(){const J=this.items[this.lastIdx];return this.lastIdx--,J}takeCount(J){const G=this.items.slice(this.firstIdx,this.firstIdx+J);return this.firstIdx+=J,G}}e.ArrayQueue=te;class O{static{this.empty=new O(J=>{})}constructor(J){this.iterate=J}forEach(J){this.iterate(G=>(J(G),!0))}toArray(){const J=[];return this.iterate(G=>(J.push(G),!0)),J}filter(J){return new O(G=>this.iterate($=>J($)?G($):!0))}map(J){return new O(G=>this.iterate($=>G(J($))))}some(J){let G=!1;return this.iterate($=>(G=J($),!G)),G}findFirst(J){let G;return this.iterate($=>J($)?(G=$,!1):!0),G}findLast(J){let G;return this.iterate($=>(J($)&&(G=$),!0)),G}findLastMaxBy(J){let G,$=!0;return this.iterate(Z=>(($||W.isGreaterThan(J(Z,G)))&&($=!1,G=Z),!0)),G}}e.CallbackIterable=O;class X{constructor(J){this._indexMap=J}static createSortPermutation(J,G){const $=Array.from(J.keys()).sort((Z,ae)=>G(J[Z],J[ae]));return new X($)}apply(J){return J.map((G,$)=>J[this._indexMap[$]])}inverse(){const J=this._indexMap.slice();for(let G=0;G<this._indexMap.length;G++)J[this._indexMap[G]]=G;return new X(J)}}e.Permutation=X;async function B(F,J){return(await Promise.all(F.map(async($,Z)=>({element:$,ok:await J($,Z)})))).find($=>$.ok)?.element}}),define(le[144],ue([0,1,15]),function(j,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=s,e.assertNever=y,e.assert=k,e.softAssert=A,e.assertFn=R,e.checkAdjacentItems=S;function s(c,m){if(!c)throw new Error(m?`Assertion failed (${m})`:"Assertion Failed")}function y(c,m="Unreachable"){throw new Error(m)}function k(c,m="unexpected state"){if(!c)throw new i.BugIndicatingError(`Assertion Failed: ${m}`)}function A(c){c||(0,i.onUnexpectedError)(new i.BugIndicatingError("Soft Assertion Failed"))}function R(c){if(!c()){debugger;c(),(0,i.onUnexpectedError)(new i.BugIndicatingError("Assertion Failed"))}}function S(c,m){let u=0;for(;u<c.length-1;){const p=c[u],v=c[u+1];if(!m(p,v))return!1;u++}return!0}}),define(le[91],ue([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createSingleCallFunction=i;function i(s,y){const k=this;let A=!1,R;return function(){if(A)return R;if(A=!0,y)try{R=s.apply(k,arguments)}finally{y()}else R=s.apply(k,arguments);return R}}}),define(le[78],ue([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var i;(function(s){function y(t){return t&&typeof t=="object"&&typeof t[Symbol.iterator]=="function"}s.is=y;const k=Object.freeze([]);function A(){return k}s.empty=A;function*R(t){yield t}s.single=R;function S(t){return y(t)?t:R(t)}s.wrap=S;function c(t){return t||k}s.from=c;function*m(t){for(let o=t.length-1;o>=0;o--)yield t[o]}s.reverse=m;function u(t){return!t||t[Symbol.iterator]().next().done===!0}s.isEmpty=u;function p(t){return t[Symbol.iterator]().next().value}s.first=p;function v(t,o){let n=0;for(const l of t)if(o(l,n++))return!0;return!1}s.some=v;function f(t,o){for(const n of t)if(o(n))return n}s.find=f;function*h(t,o){for(const n of t)o(n)&&(yield n)}s.filter=h;function*E(t,o){let n=0;for(const l of t)yield o(l,n++)}s.map=E;function*b(t,o){let n=0;for(const l of t)yield*o(l,n++)}s.flatMap=b;function*g(...t){for(const o of t)yield*o}s.concat=g;function I(t,o,n){let l=n;for(const d of t)l=o(l,d);return l}s.reduce=I;function*P(t,o,n=t.length){for(o<0&&(o+=t.length),n<0?n+=t.length:n>t.length&&(n=t.length);o<n;o++)yield t[o]}s.slice=P;function r(t,o=Number.POSITIVE_INFINITY){const n=[];if(o===0)return[n,t];const l=t[Symbol.iterator]();for(let d=0;d<o;d++){const D=l.next();if(D.done)return[n,s.empty()];n.push(D.value)}return[n,{[Symbol.iterator](){return l}}]}s.consume=r;async function a(t){const o=[];for await(const n of t)o.push(n);return Promise.resolve(o)}s.asyncToArray=a})(i||(e.Iterable=i={}))}),define(le[43],ue([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.createScanner=A,e.getLocation=u,e.parse=p,e.parseTree=v,e.findNodeAtLocation=f,e.getNodePath=h,e.getNodeValue=E,e.contains=b,e.findNodeAtOffset=g,e.visit=I,e.getNodeType=P;var i;(function(r){r[r.None=0]="None",r[r.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",r[r.UnexpectedEndOfString=2]="UnexpectedEndOfString",r[r.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",r[r.InvalidUnicode=4]="InvalidUnicode",r[r.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",r[r.InvalidCharacter=6]="InvalidCharacter"})(i||(e.ScanError=i={}));var s;(function(r){r[r.OpenBraceToken=1]="OpenBraceToken",r[r.CloseBraceToken=2]="CloseBraceToken",r[r.OpenBracketToken=3]="OpenBracketToken",r[r.CloseBracketToken=4]="CloseBracketToken",r[r.CommaToken=5]="CommaToken",r[r.ColonToken=6]="ColonToken",r[r.NullKeyword=7]="NullKeyword",r[r.TrueKeyword=8]="TrueKeyword",r[r.FalseKeyword=9]="FalseKeyword",r[r.StringLiteral=10]="StringLiteral",r[r.NumericLiteral=11]="NumericLiteral",r[r.LineCommentTrivia=12]="LineCommentTrivia",r[r.BlockCommentTrivia=13]="BlockCommentTrivia",r[r.LineBreakTrivia=14]="LineBreakTrivia",r[r.Trivia=15]="Trivia",r[r.Unknown=16]="Unknown",r[r.EOF=17]="EOF"})(s||(e.SyntaxKind=s={}));var y;(function(r){r[r.InvalidSymbol=1]="InvalidSymbol",r[r.InvalidNumberFormat=2]="InvalidNumberFormat",r[r.PropertyNameExpected=3]="PropertyNameExpected",r[r.ValueExpected=4]="ValueExpected",r[r.ColonExpected=5]="ColonExpected",r[r.CommaExpected=6]="CommaExpected",r[r.CloseBraceExpected=7]="CloseBraceExpected",r[r.CloseBracketExpected=8]="CloseBracketExpected",r[r.EndOfFileExpected=9]="EndOfFileExpected",r[r.InvalidCommentToken=10]="InvalidCommentToken",r[r.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",r[r.UnexpectedEndOfString=12]="UnexpectedEndOfString",r[r.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",r[r.InvalidUnicode=14]="InvalidUnicode",r[r.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",r[r.InvalidCharacter=16]="InvalidCharacter"})(y||(e.ParseErrorCode=y={}));var k;(function(r){r.DEFAULT={allowTrailingComma:!0}})(k||(e.ParseOptions=k={}));function A(r,a=!1){let t=0;const o=r.length;let n="",l=0,d=s.Unknown,D=i.None;function w(z){let Q=0,fe=0;for(;Q<z;){const se=r.charCodeAt(t);if(se>=m._0&&se<=m._9)fe=fe*16+se-m._0;else if(se>=m.A&&se<=m.F)fe=fe*16+se-m.A+10;else if(se>=m.a&&se<=m.f)fe=fe*16+se-m.a+10;else break;t++,Q++}return Q<z&&(fe=-1),fe}function M(z){t=z,n="",l=0,d=s.Unknown,D=i.None}function T(){const z=t;if(r.charCodeAt(t)===m._0)t++;else for(t++;t<r.length&&c(r.charCodeAt(t));)t++;if(t<r.length&&r.charCodeAt(t)===m.dot)if(t++,t<r.length&&c(r.charCodeAt(t)))for(t++;t<r.length&&c(r.charCodeAt(t));)t++;else return D=i.UnexpectedEndOfNumber,r.substring(z,t);let Q=t;if(t<r.length&&(r.charCodeAt(t)===m.E||r.charCodeAt(t)===m.e))if(t++,(t<r.length&&r.charCodeAt(t)===m.plus||r.charCodeAt(t)===m.minus)&&t++,t<r.length&&c(r.charCodeAt(t))){for(t++;t<r.length&&c(r.charCodeAt(t));)t++;Q=t}else D=i.UnexpectedEndOfNumber;return r.substring(z,Q)}function C(){let z="",Q=t;for(;;){if(t>=o){z+=r.substring(Q,t),D=i.UnexpectedEndOfString;break}const fe=r.charCodeAt(t);if(fe===m.doubleQuote){z+=r.substring(Q,t),t++;break}if(fe===m.backslash){if(z+=r.substring(Q,t),t++,t>=o){D=i.UnexpectedEndOfString;break}switch(r.charCodeAt(t++)){case m.doubleQuote:z+='"';break;case m.backslash:z+="\\";break;case m.slash:z+="/";break;case m.b:z+="\b";break;case m.f:z+="\f";break;case m.n:z+=`
`;break;case m.r:z+="\r";break;case m.t:z+="	";break;case m.u:{const ee=w(4);ee>=0?z+=String.fromCharCode(ee):D=i.InvalidUnicode;break}default:D=i.InvalidEscapeCharacter}Q=t;continue}if(fe>=0&&fe<=31)if(S(fe)){z+=r.substring(Q,t),D=i.UnexpectedEndOfString;break}else D=i.InvalidCharacter;t++}return z}function L(){if(n="",D=i.None,l=t,t>=o)return l=o,d=s.EOF;let z=r.charCodeAt(t);if(R(z)){do t++,n+=String.fromCharCode(z),z=r.charCodeAt(t);while(R(z));return d=s.Trivia}if(S(z))return t++,n+=String.fromCharCode(z),z===m.carriageReturn&&r.charCodeAt(t)===m.lineFeed&&(t++,n+=`
`),d=s.LineBreakTrivia;switch(z){case m.openBrace:return t++,d=s.OpenBraceToken;case m.closeBrace:return t++,d=s.CloseBraceToken;case m.openBracket:return t++,d=s.OpenBracketToken;case m.closeBracket:return t++,d=s.CloseBracketToken;case m.colon:return t++,d=s.ColonToken;case m.comma:return t++,d=s.CommaToken;case m.doubleQuote:return t++,n=C(),d=s.StringLiteral;case m.slash:{const Q=t-1;if(r.charCodeAt(t+1)===m.slash){for(t+=2;t<o&&!S(r.charCodeAt(t));)t++;return n=r.substring(Q,t),d=s.LineCommentTrivia}if(r.charCodeAt(t+1)===m.asterisk){t+=2;const fe=o-1;let se=!1;for(;t<fe;){if(r.charCodeAt(t)===m.asterisk&&r.charCodeAt(t+1)===m.slash){t+=2,se=!0;break}t++}return se||(t++,D=i.UnexpectedEndOfComment),n=r.substring(Q,t),d=s.BlockCommentTrivia}return n+=String.fromCharCode(z),t++,d=s.Unknown}case m.minus:if(n+=String.fromCharCode(z),t++,t===o||!c(r.charCodeAt(t)))return d=s.Unknown;case m._0:case m._1:case m._2:case m._3:case m._4:case m._5:case m._6:case m._7:case m._8:case m._9:return n+=T(),d=s.NumericLiteral;default:for(;t<o&&_(z);)t++,z=r.charCodeAt(t);if(l!==t){switch(n=r.substring(l,t),n){case"true":return d=s.TrueKeyword;case"false":return d=s.FalseKeyword;case"null":return d=s.NullKeyword}return d=s.Unknown}return n+=String.fromCharCode(z),t++,d=s.Unknown}}function _(z){if(R(z)||S(z))return!1;switch(z){case m.closeBrace:case m.closeBracket:case m.openBrace:case m.openBracket:case m.doubleQuote:case m.colon:case m.comma:case m.slash:return!1}return!0}function V(){let z;do z=L();while(z>=s.LineCommentTrivia&&z<=s.Trivia);return z}return{setPosition:M,getPosition:()=>t,scan:a?V:L,getToken:()=>d,getTokenValue:()=>n,getTokenOffset:()=>l,getTokenLength:()=>t-l,getTokenError:()=>D}}function R(r){return r===m.space||r===m.tab||r===m.verticalTab||r===m.formFeed||r===m.nonBreakingSpace||r===m.ogham||r>=m.enQuad&&r<=m.zeroWidthSpace||r===m.narrowNoBreakSpace||r===m.mathematicalSpace||r===m.ideographicSpace||r===m.byteOrderMark}function S(r){return r===m.lineFeed||r===m.carriageReturn||r===m.lineSeparator||r===m.paragraphSeparator}function c(r){return r>=m._0&&r<=m._9}var m;(function(r){r[r.nullCharacter=0]="nullCharacter",r[r.maxAsciiCharacter=127]="maxAsciiCharacter",r[r.lineFeed=10]="lineFeed",r[r.carriageReturn=13]="carriageReturn",r[r.lineSeparator=8232]="lineSeparator",r[r.paragraphSeparator=8233]="paragraphSeparator",r[r.nextLine=133]="nextLine",r[r.space=32]="space",r[r.nonBreakingSpace=160]="nonBreakingSpace",r[r.enQuad=8192]="enQuad",r[r.emQuad=8193]="emQuad",r[r.enSpace=8194]="enSpace",r[r.emSpace=8195]="emSpace",r[r.threePerEmSpace=8196]="threePerEmSpace",r[r.fourPerEmSpace=8197]="fourPerEmSpace",r[r.sixPerEmSpace=8198]="sixPerEmSpace",r[r.figureSpace=8199]="figureSpace",r[r.punctuationSpace=8200]="punctuationSpace",r[r.thinSpace=8201]="thinSpace",r[r.hairSpace=8202]="hairSpace",r[r.zeroWidthSpace=8203]="zeroWidthSpace",r[r.narrowNoBreakSpace=8239]="narrowNoBreakSpace",r[r.ideographicSpace=12288]="ideographicSpace",r[r.mathematicalSpace=8287]="mathematicalSpace",r[r.ogham=5760]="ogham",r[r._=95]="_",r[r.$=36]="$",r[r._0=48]="_0",r[r._1=49]="_1",r[r._2=50]="_2",r[r._3=51]="_3",r[r._4=52]="_4",r[r._5=53]="_5",r[r._6=54]="_6",r[r._7=55]="_7",r[r._8=56]="_8",r[r._9=57]="_9",r[r.a=97]="a",r[r.b=98]="b",r[r.c=99]="c",r[r.d=100]="d",r[r.e=101]="e",r[r.f=102]="f",r[r.g=103]="g",r[r.h=104]="h",r[r.i=105]="i",r[r.j=106]="j",r[r.k=107]="k",r[r.l=108]="l",r[r.m=109]="m",r[r.n=110]="n",r[r.o=111]="o",r[r.p=112]="p",r[r.q=113]="q",r[r.r=114]="r",r[r.s=115]="s",r[r.t=116]="t",r[r.u=117]="u",r[r.v=118]="v",r[r.w=119]="w",r[r.x=120]="x",r[r.y=121]="y",r[r.z=122]="z",r[r.A=65]="A",r[r.B=66]="B",r[r.C=67]="C",r[r.D=68]="D",r[r.E=69]="E",r[r.F=70]="F",r[r.G=71]="G",r[r.H=72]="H",r[r.I=73]="I",r[r.J=74]="J",r[r.K=75]="K",r[r.L=76]="L",r[r.M=77]="M",r[r.N=78]="N",r[r.O=79]="O",r[r.P=80]="P",r[r.Q=81]="Q",r[r.R=82]="R",r[r.S=83]="S",r[r.T=84]="T",r[r.U=85]="U",r[r.V=86]="V",r[r.W=87]="W",r[r.X=88]="X",r[r.Y=89]="Y",r[r.Z=90]="Z",r[r.ampersand=38]="ampersand",r[r.asterisk=42]="asterisk",r[r.at=64]="at",r[r.backslash=92]="backslash",r[r.bar=124]="bar",r[r.caret=94]="caret",r[r.closeBrace=125]="closeBrace",r[r.closeBracket=93]="closeBracket",r[r.closeParen=41]="closeParen",r[r.colon=58]="colon",r[r.comma=44]="comma",r[r.dot=46]="dot",r[r.doubleQuote=34]="doubleQuote",r[r.equals=61]="equals",r[r.exclamation=33]="exclamation",r[r.greaterThan=62]="greaterThan",r[r.lessThan=60]="lessThan",r[r.minus=45]="minus",r[r.openBrace=123]="openBrace",r[r.openBracket=91]="openBracket",r[r.openParen=40]="openParen",r[r.percent=37]="percent",r[r.plus=43]="plus",r[r.question=63]="question",r[r.semicolon=59]="semicolon",r[r.singleQuote=39]="singleQuote",r[r.slash=47]="slash",r[r.tilde=126]="tilde",r[r.backspace=8]="backspace",r[r.formFeed=12]="formFeed",r[r.byteOrderMark=65279]="byteOrderMark",r[r.tab=9]="tab",r[r.verticalTab=11]="verticalTab"})(m||(m={}));function u(r,a){const t=[],o=new Object;let n;const l={value:{},offset:0,length:0,type:"object",parent:void 0};let d=!1;function D(w,M,T,C){l.value=w,l.offset=M,l.length=T,l.type=C,l.colonOffset=void 0,n=l}try{I(r,{onObjectBegin:(w,M)=>{if(a<=w)throw o;n=void 0,d=a>w,t.push("")},onObjectProperty:(w,M,T)=>{if(a<M||(D(w,M,T,"property"),t[t.length-1]=w,a<=M+T))throw o},onObjectEnd:(w,M)=>{if(a<=w)throw o;n=void 0,t.pop()},onArrayBegin:(w,M)=>{if(a<=w)throw o;n=void 0,t.push(0)},onArrayEnd:(w,M)=>{if(a<=w)throw o;n=void 0,t.pop()},onLiteralValue:(w,M,T)=>{if(a<M||(D(w,M,T,P(w)),a<=M+T))throw o},onSeparator:(w,M,T)=>{if(a<=M)throw o;if(w===":"&&n&&n.type==="property")n.colonOffset=M,d=!1,n=void 0;else if(w===","){const C=t[t.length-1];typeof C=="number"?t[t.length-1]=C+1:(d=!0,t[t.length-1]=""),n=void 0}}})}catch(w){if(w!==o)throw w}return{path:t,previousNode:n,isAtPropertyKey:d,matches:w=>{let M=0;for(let T=0;M<w.length&&T<t.length;T++)if(w[M]===t[T]||w[M]==="*")M++;else if(w[M]!=="**")return!1;return M===w.length}}}function p(r,a=[],t=k.DEFAULT){let o=null,n=[];const l=[];function d(w){Array.isArray(n)?n.push(w):o!==null&&(n[o]=w)}return I(r,{onObjectBegin:()=>{const w={};d(w),l.push(n),n=w,o=null},onObjectProperty:w=>{o=w},onObjectEnd:()=>{n=l.pop()},onArrayBegin:()=>{const w=[];d(w),l.push(n),n=w,o=null},onArrayEnd:()=>{n=l.pop()},onLiteralValue:d,onError:(w,M,T)=>{a.push({error:w,offset:M,length:T})}},t),n[0]}function v(r,a=[],t=k.DEFAULT){let o={type:"array",offset:-1,length:-1,children:[],parent:void 0};function n(w){o.type==="property"&&(o.length=w-o.offset,o=o.parent)}function l(w){return o.children.push(w),w}I(r,{onObjectBegin:w=>{o=l({type:"object",offset:w,length:-1,parent:o,children:[]})},onObjectProperty:(w,M,T)=>{o=l({type:"property",offset:M,length:-1,parent:o,children:[]}),o.children.push({type:"string",value:w,offset:M,length:T,parent:o})},onObjectEnd:(w,M)=>{o.length=w+M-o.offset,o=o.parent,n(w+M)},onArrayBegin:(w,M)=>{o=l({type:"array",offset:w,length:-1,parent:o,children:[]})},onArrayEnd:(w,M)=>{o.length=w+M-o.offset,o=o.parent,n(w+M)},onLiteralValue:(w,M,T)=>{l({type:P(w),offset:M,length:T,parent:o,value:w}),n(M+T)},onSeparator:(w,M,T)=>{o.type==="property"&&(w===":"?o.colonOffset=M:w===","&&n(M))},onError:(w,M,T)=>{a.push({error:w,offset:M,length:T})}},t);const D=o.children[0];return D&&delete D.parent,D}function f(r,a){if(!r)return;let t=r;for(const o of a)if(typeof o=="string"){if(t.type!=="object"||!Array.isArray(t.children))return;let n=!1;for(const l of t.children)if(Array.isArray(l.children)&&l.children[0].value===o){t=l.children[1],n=!0;break}if(!n)return}else{const n=o;if(t.type!=="array"||n<0||!Array.isArray(t.children)||n>=t.children.length)return;t=t.children[n]}return t}function h(r){if(!r.parent||!r.parent.children)return[];const a=h(r.parent);if(r.parent.type==="property"){const t=r.parent.children[0].value;a.push(t)}else if(r.parent.type==="array"){const t=r.parent.children.indexOf(r);t!==-1&&a.push(t)}return a}function E(r){switch(r.type){case"array":return r.children.map(E);case"object":{const a=Object.create(null);for(const t of r.children){const o=t.children[1];o&&(a[t.children[0].value]=E(o))}return a}case"null":case"string":case"number":case"boolean":return r.value;default:return}}function b(r,a,t=!1){return a>=r.offset&&a<r.offset+r.length||t&&a===r.offset+r.length}function g(r,a,t=!1){if(b(r,a,t)){const o=r.children;if(Array.isArray(o))for(let n=0;n<o.length&&o[n].offset<=a;n++){const l=g(o[n],a,t);if(l)return l}return r}}function I(r,a,t=k.DEFAULT){const o=A(r,!1);function n(q){return q?()=>q(o.getTokenOffset(),o.getTokenLength()):()=>!0}function l(q){return q?ie=>q(ie,o.getTokenOffset(),o.getTokenLength()):()=>!0}const d=n(a.onObjectBegin),D=l(a.onObjectProperty),w=n(a.onObjectEnd),M=n(a.onArrayBegin),T=n(a.onArrayEnd),C=l(a.onLiteralValue),L=l(a.onSeparator),_=n(a.onComment),V=l(a.onError),z=t&&t.disallowComments,Q=t&&t.allowTrailingComma;function fe(){for(;;){const q=o.scan();switch(o.getTokenError()){case i.InvalidUnicode:se(y.InvalidUnicode);break;case i.InvalidEscapeCharacter:se(y.InvalidEscapeCharacter);break;case i.UnexpectedEndOfNumber:se(y.UnexpectedEndOfNumber);break;case i.UnexpectedEndOfComment:z||se(y.UnexpectedEndOfComment);break;case i.UnexpectedEndOfString:se(y.UnexpectedEndOfString);break;case i.InvalidCharacter:se(y.InvalidCharacter);break}switch(q){case s.LineCommentTrivia:case s.BlockCommentTrivia:z?se(y.InvalidCommentToken):_();break;case s.Unknown:se(y.InvalidSymbol);break;case s.Trivia:case s.LineBreakTrivia:break;default:return q}}}function se(q,ie=[],H=[]){if(V(q),ie.length+H.length>0){let ce=o.getToken();for(;ce!==s.EOF;){if(ie.indexOf(ce)!==-1){fe();break}else if(H.indexOf(ce)!==-1)break;ce=fe()}}}function ee(q){const ie=o.getTokenValue();return q?C(ie):D(ie),fe(),!0}function U(){switch(o.getToken()){case s.NumericLiteral:{let q=0;try{q=JSON.parse(o.getTokenValue()),typeof q!="number"&&(se(y.InvalidNumberFormat),q=0)}catch{se(y.InvalidNumberFormat)}C(q);break}case s.NullKeyword:C(null);break;case s.TrueKeyword:C(!0);break;case s.FalseKeyword:C(!1);break;default:return!1}return fe(),!0}function K(){return o.getToken()!==s.StringLiteral?(se(y.PropertyNameExpected,[],[s.CloseBraceToken,s.CommaToken]),!1):(ee(!1),o.getToken()===s.ColonToken?(L(":"),fe(),W()||se(y.ValueExpected,[],[s.CloseBraceToken,s.CommaToken])):se(y.ColonExpected,[],[s.CloseBraceToken,s.CommaToken]),!0)}function N(){d(),fe();let q=!1;for(;o.getToken()!==s.CloseBraceToken&&o.getToken()!==s.EOF;){if(o.getToken()===s.CommaToken){if(q||se(y.ValueExpected,[],[]),L(","),fe(),o.getToken()===s.CloseBraceToken&&Q)break}else q&&se(y.CommaExpected,[],[]);K()||se(y.ValueExpected,[],[s.CloseBraceToken,s.CommaToken]),q=!0}return w(),o.getToken()!==s.CloseBraceToken?se(y.CloseBraceExpected,[s.CloseBraceToken],[]):fe(),!0}function x(){M(),fe();let q=!1;for(;o.getToken()!==s.CloseBracketToken&&o.getToken()!==s.EOF;){if(o.getToken()===s.CommaToken){if(q||se(y.ValueExpected,[],[]),L(","),fe(),o.getToken()===s.CloseBracketToken&&Q)break}else q&&se(y.CommaExpected,[],[]);W()||se(y.ValueExpected,[],[s.CloseBracketToken,s.CommaToken]),q=!0}return T(),o.getToken()!==s.CloseBracketToken?se(y.CloseBracketExpected,[s.CloseBracketToken],[]):fe(),!0}function W(){switch(o.getToken()){case s.OpenBracketToken:return x();case s.OpenBraceToken:return N();case s.StringLiteral:return ee(!0);default:return U()}}return fe(),o.getToken()===s.EOF?t.allowEmptyContent?!0:(se(y.ValueExpected,[],[]),!1):W()?(o.getToken()!==s.EOF&&se(y.EndOfFileExpected,[],[]),!0):(se(y.ValueExpected,[],[]),!1)}function P(r){switch(typeof r){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(r){if(Array.isArray(r))return"array"}else return"null";return"object"}default:return"null"}}}),define(le[145],ue([0,1,43]),function(j,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.format=s,e.toFormattedString=y,e.getEOL=R,e.isEOL=S;function s(c,m,u){let p,v,f,h,E;if(m){for(h=m.offset,E=h+m.length,f=h;f>0&&!S(c,f-1);)f--;let D=E;for(;D<c.length&&!S(c,D);)D++;v=c.substring(f,D),p=A(v,u)}else v=c,p=0,f=0,h=0,E=c.length;const b=R(u,c);let g=!1,I=0,P;u.insertSpaces?P=k(" ",u.tabSize||4):P="	";const r=(0,i.createScanner)(v,!1);let a=!1;function t(){return b+k(P,p+I)}function o(){let D=r.scan();for(g=!1;D===i.SyntaxKind.Trivia||D===i.SyntaxKind.LineBreakTrivia;)g=g||D===i.SyntaxKind.LineBreakTrivia,D=r.scan();return a=D===i.SyntaxKind.Unknown||r.getTokenError()!==i.ScanError.None,D}const n=[];function l(D,w,M){!a&&w<E&&M>h&&c.substring(w,M)!==D&&n.push({offset:w,length:M-w,content:D})}let d=o();if(d!==i.SyntaxKind.EOF){const D=r.getTokenOffset()+f,w=k(P,p);l(w,f,D)}for(;d!==i.SyntaxKind.EOF;){let D=r.getTokenOffset()+r.getTokenLength()+f,w=o(),M="";for(;!g&&(w===i.SyntaxKind.LineCommentTrivia||w===i.SyntaxKind.BlockCommentTrivia);){const C=r.getTokenOffset()+f;l(" ",D,C),D=r.getTokenOffset()+r.getTokenLength()+f,M=w===i.SyntaxKind.LineCommentTrivia?t():"",w=o()}if(w===i.SyntaxKind.CloseBraceToken)d!==i.SyntaxKind.OpenBraceToken&&(I--,M=t());else if(w===i.SyntaxKind.CloseBracketToken)d!==i.SyntaxKind.OpenBracketToken&&(I--,M=t());else{switch(d){case i.SyntaxKind.OpenBracketToken:case i.SyntaxKind.OpenBraceToken:I++,M=t();break;case i.SyntaxKind.CommaToken:case i.SyntaxKind.LineCommentTrivia:M=t();break;case i.SyntaxKind.BlockCommentTrivia:g?M=t():M=" ";break;case i.SyntaxKind.ColonToken:M=" ";break;case i.SyntaxKind.StringLiteral:if(w===i.SyntaxKind.ColonToken){M="";break}case i.SyntaxKind.NullKeyword:case i.SyntaxKind.TrueKeyword:case i.SyntaxKind.FalseKeyword:case i.SyntaxKind.NumericLiteral:case i.SyntaxKind.CloseBraceToken:case i.SyntaxKind.CloseBracketToken:w===i.SyntaxKind.LineCommentTrivia||w===i.SyntaxKind.BlockCommentTrivia?M=" ":w!==i.SyntaxKind.CommaToken&&w!==i.SyntaxKind.EOF&&(a=!0);break;case i.SyntaxKind.Unknown:a=!0;break}g&&(w===i.SyntaxKind.LineCommentTrivia||w===i.SyntaxKind.BlockCommentTrivia)&&(M=t())}const T=r.getTokenOffset()+f;l(M,D,T),d=w}return n}function y(c,m){const u=JSON.stringify(c,void 0,m.insertSpaces?m.tabSize||4:"	");return m.eol!==void 0?u.replace(/\r\n|\r|\n/g,m.eol):u}function k(c,m){let u="";for(let p=0;p<m;p++)u+=c;return u}function A(c,m){let u=0,p=0;const v=m.tabSize||4;for(;u<c.length;){const f=c.charAt(u);if(f===" ")p++;else if(f==="	")p+=v;else break;u++}return Math.floor(p/v)}function R(c,m){for(let u=0;u<m.length;u++){const p=m.charAt(u);if(p==="\r")return u+1<m.length&&m.charAt(u+1)===`
`?`\r
`:"\r";if(p===`
`)return`
`}return c&&c.eol||`
`}function S(c,m){return`\r
`.indexOf(c.charAt(m))!==-1}}),define(le[110],ue([0,1,43,145]),function(j,e,i,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeProperty=y,e.setProperty=k,e.withFormatting=A,e.applyEdit=R,e.applyEdits=S;function y(c,m,u){return k(c,m,void 0,u)}function k(c,m,u,p,v){const f=m.slice(),h=[],E=(0,i.parseTree)(c,h);let b,g;for(;f.length>0&&(g=f.pop(),b=(0,i.findNodeAtLocation)(E,f),b===void 0&&u!==void 0);)typeof g=="string"?u={[g]:u}:u=[u];if(b)if(b.type==="object"&&typeof g=="string"&&Array.isArray(b.children)){const I=(0,i.findNodeAtLocation)(b,[g]);if(I!==void 0)if(u===void 0){if(!I.parent)throw new Error("Malformed AST");const P=b.children.indexOf(I.parent);let r,a=I.parent.offset+I.parent.length;if(P>0){const t=b.children[P-1];r=t.offset+t.length}else r=b.offset+1,b.children.length>1&&(a=b.children[1].offset);return A(c,{offset:r,length:a-r,content:""},p)}else return A(c,{offset:I.offset,length:I.length,content:JSON.stringify(u)},p);else{if(u===void 0)return[];const P=`${JSON.stringify(g)}: ${JSON.stringify(u)}`,r=v?v(b.children.map(t=>t.children[0].value)):b.children.length;let a;if(r>0){const t=b.children[r-1];a={offset:t.offset+t.length,length:0,content:","+P}}else b.children.length===0?a={offset:b.offset+1,length:0,content:P}:a={offset:b.offset+1,length:0,content:P+","};return A(c,a,p)}}else if(b.type==="array"&&typeof g=="number"&&Array.isArray(b.children))if(u!==void 0){const I=`${JSON.stringify(u)}`;let P;if(b.children.length===0||g===0)P={offset:b.offset+1,length:0,content:b.children.length===0?I:I+","};else{const r=g===-1||g>b.children.length?b.children.length:g,a=b.children[r-1];P={offset:a.offset+a.length,length:0,content:","+I}}return A(c,P,p)}else{const I=g,P=b.children[I];let r;if(b.children.length===1)r={offset:b.offset+1,length:b.length-2,content:""};else if(b.children.length-1===I){const a=b.children[I-1],t=a.offset+a.length,o=b.offset+b.length;r={offset:t,length:o-2-t,content:""}}else r={offset:P.offset,length:b.children[I+1].offset-P.offset,content:""};return A(c,r,p)}else throw new Error(`Can not add ${typeof g!="number"?"index":"property"} to parent of type ${b.type}`);else return u===void 0?[]:A(c,{offset:E?E.offset:0,length:E?E.length:0,content:JSON.stringify(u)},p)}function A(c,m,u){let p=R(c,m),v=m.offset,f=m.offset+m.content.length;if(m.length===0||m.content.length===0){for(;v>0&&!(0,s.isEOL)(p,v-1);)v--;for(;f<p.length&&!(0,s.isEOL)(p,f);)f++}const h=(0,s.format)(p,{offset:v,length:f-v},u);for(let b=h.length-1;b>=0;b--){const g=h[b];p=R(p,g),v=Math.min(v,g.offset),f=Math.max(f,g.offset+g.length),f+=g.content.length-g.length}const E=c.length-(p.length-f)-v;return[{offset:v,length:E,content:p.substring(v,f)}]}function R(c,m){return c.substring(0,m.offset)+m.content+c.substring(m.offset+m.length)}function S(c,m){const u=m.slice(0).sort((v,f)=>{const h=v.offset-f.offset;return h===0?v.length-f.length:h});let p=c.length;for(let v=u.length-1;v>=0;v--){const f=u[v];if(f.offset+f.length<=p)c=R(c,f);else throw new Error("Overlapping edit");p=f.offset}return c}}),define(le[146],ue([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getCompressedContent=i;function i(k){let A=!1;const R=new Map,S=new Map;if(y(k,h=>{if(k===h)return!0;const E=JSON.stringify(h);if(E.length<30)return!0;const b=R.get(E);if(!b){const g={schemas:[h]};return R.set(E,g),S.set(h,g),!0}return b.schemas.push(h),S.set(h,b),A=!0,!1}),R.clear(),!A)return JSON.stringify(k);let m="$defs";for(;k.hasOwnProperty(m);)m+="_";const u=[];function p(h){return JSON.stringify(h,(E,b)=>{if(b!==h){const g=S.get(b);if(g&&g.schemas.length>1)return g.id||(g.id=`_${u.length}`,u.push(g.schemas[0])),{$ref:`#/${m}/${g.id}`}}return b})}const v=p(k),f=[];for(let h=0;h<u.length;h++)f.push(`"_${h}":${p(u[h])}`);return f.length?`${v.substring(0,v.length-1)},"${m}":{${f.join(",")}}}`:v}function s(k){return typeof k=="object"&&k!==null}function y(k,A){if(!k||typeof k!="object")return;const R=(...v)=>{for(const f of v)s(f)&&u.push(f)},S=(...v)=>{for(const f of v)if(s(f))for(const h in f){const E=f[h];s(E)&&u.push(E)}},c=(...v)=>{for(const f of v)if(Array.isArray(f))for(const h of f)s(h)&&u.push(h)},m=v=>{if(Array.isArray(v))for(const f of v)s(f)&&u.push(f);else s(v)&&u.push(v)},u=[k];let p=u.pop();for(;p;)A(p)&&(R(p.additionalItems,p.additionalProperties,p.not,p.contains,p.propertyNames,p.if,p.then,p.else,p.unevaluatedItems,p.unevaluatedProperties),S(p.definitions,p.$defs,p.properties,p.patternProperties,p.dependencies,p.dependentSchemas),c(p.anyOf,p.allOf,p.oneOf,p.prefixItems),m(p.items)),p=u.pop()}}),function(){function j(){const e=/("[^"\\]*(?:\\.[^"\\]*)*")|('[^'\\]*(?:\\.[^'\\]*)*')|(\/\*[^\/\*]*(?:(?:\*|\/)[^\/\*]*)*?\*\/)|(\/{2,}.*?(?:(?:\r?\n)|$))|(,\s*[}\]])/g;function i(y){return y.replace(e,function(k,A,R,S,c,m){if(S)return"";if(c){const u=c.length;return c[u-1]===`
`?c[u-2]==="\r"?`\r
`:`
`:""}else return m?k.substring(1):k})}function s(y){const k=i(y);try{return JSON.parse(k)}catch{const R=k.replace(/,\s*([}\]])/g,"$1");return JSON.parse(R)}}return{stripComments:i,parse:s}}typeof define=="function"?define("vs/base/common/jsonc",[],function(){return j()}):typeof module=="object"&&typeof module.exports=="object"?module.exports=j():console.trace("jsonc defined in UNKNOWN context (neither requirejs or commonjs)")}(),define(le[67],ue([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class i{constructor(y){this.executor=y,this._didRun=!1}get hasValue(){return this._didRun}get value(){if(!this._didRun)try{this._value=this.executor()}catch(y){this._error=y}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}}e.Lazy=i}),define(le[111],ue([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class i{static{this.Undefined=new i(void 0)}constructor(k){this.element=k,this.next=i.Undefined,this.prev=i.Undefined}}class s{constructor(){this._first=i.Undefined,this._last=i.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===i.Undefined}clear(){let k=this._first;for(;k!==i.Undefined;){const A=k.next;k.prev=i.Undefined,k.next=i.Undefined,k=A}this._first=i.Undefined,this._last=i.Undefined,this._size=0}unshift(k){return this._insert(k,!1)}push(k){return this._insert(k,!0)}_insert(k,A){const R=new i(k);if(this._first===i.Undefined)this._first=R,this._last=R;else if(A){const c=this._last;this._last=R,R.prev=c,c.next=R}else{const c=this._first;this._first=R,R.next=c,c.prev=R}this._size+=1;let S=!1;return()=>{S||(S=!0,this._remove(R))}}shift(){if(this._first!==i.Undefined){const k=this._first.element;return this._remove(this._first),k}}pop(){if(this._last!==i.Undefined){const k=this._last.element;return this._remove(this._last),k}}_remove(k){if(k.prev!==i.Undefined&&k.next!==i.Undefined){const A=k.prev;A.next=k.next,k.next.prev=A}else k.prev===i.Undefined&&k.next===i.Undefined?(this._first=i.Undefined,this._last=i.Undefined):k.next===i.Undefined?(this._last=this._last.prev,this._last.next=i.Undefined):k.prev===i.Undefined&&(this._first=this._first.next,this._first.prev=i.Undefined);this._size-=1}*[Symbol.iterator](){let k=this._first;for(;k!==i.Undefined;)yield k.element,k=k.next}}e.LinkedList=s}),define(le[31],ue([0,1]),function(j,e){"use strict";var i,s,y;Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.BidirectionalMap=e.CounterSet=e.MRUCache=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=void 0,e.getOrSet=k,e.mapToString=A,e.setToString=R,e.mapsStrictEqualIgnoreOrder=P;function k(r,a,t){let o=r.get(a);return o===void 0&&(o=t,r.set(a,o)),o}function A(r){const a=[];return r.forEach((t,o)=>{a.push(`${o} => ${t}`)}),`Map(${r.size}) {${a.join(", ")}}`}function R(r){const a=[];return r.forEach(t=>{a.push(t)}),`Set(${r.size}) {${a.join(", ")}}`}class S{constructor(a,t){this.uri=a,this.value=t}}function c(r){return Array.isArray(r)}class m{static{this.defaultToKey=a=>a.toString()}constructor(a,t){if(this[i]="ResourceMap",a instanceof m)this.map=new Map(a.map),this.toKey=t??m.defaultToKey;else if(c(a)){this.map=new Map,this.toKey=t??m.defaultToKey;for(const[o,n]of a)this.set(o,n)}else this.map=new Map,this.toKey=a??m.defaultToKey}set(a,t){return this.map.set(this.toKey(a),new S(a,t)),this}get(a){return this.map.get(this.toKey(a))?.value}has(a){return this.map.has(this.toKey(a))}get size(){return this.map.size}clear(){this.map.clear()}delete(a){return this.map.delete(this.toKey(a))}forEach(a,t){typeof t<"u"&&(a=a.bind(t));for(const[o,n]of this.map)a(n.value,n.uri,this)}*values(){for(const a of this.map.values())yield a.value}*keys(){for(const a of this.map.values())yield a.uri}*entries(){for(const a of this.map.values())yield[a.uri,a.value]}*[(i=Symbol.toStringTag,Symbol.iterator)](){for(const[,a]of this.map)yield[a.uri,a.value]}}e.ResourceMap=m;class u{constructor(a,t){this[s]="ResourceSet",!a||typeof a=="function"?this._map=new m(a):(this._map=new m(t),a.forEach(this.add,this))}get size(){return this._map.size}add(a){return this._map.set(a,a),this}clear(){this._map.clear()}delete(a){return this._map.delete(a)}forEach(a,t){this._map.forEach((o,n)=>a.call(t,n,n,this))}has(a){return this._map.has(a)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(s=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=u;var p;(function(r){r[r.None=0]="None",r[r.AsOld=1]="AsOld",r[r.AsNew=2]="AsNew"})(p||(e.Touch=p={}));class v{constructor(){this[y]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(a){return this._map.has(a)}get(a,t=p.None){const o=this._map.get(a);if(o)return t!==p.None&&this.touch(o,t),o.value}set(a,t,o=p.None){let n=this._map.get(a);if(n)n.value=t,o!==p.None&&this.touch(n,o);else{switch(n={key:a,value:t,next:void 0,previous:void 0},o){case p.None:this.addItemLast(n);break;case p.AsOld:this.addItemFirst(n);break;case p.AsNew:this.addItemLast(n);break;default:this.addItemLast(n);break}this._map.set(a,n),this._size++}return this}delete(a){return!!this.remove(a)}remove(a){const t=this._map.get(a);if(t)return this._map.delete(a),this.removeItem(t),this._size--,t.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const a=this._head;return this._map.delete(a.key),this.removeItem(a),this._size--,a.value}forEach(a,t){const o=this._state;let n=this._head;for(;n;){if(t?a.bind(t)(n.value,n.key,this):a(n.value,n.key,this),this._state!==o)throw new Error("LinkedMap got modified during iteration.");n=n.next}}keys(){const a=this,t=this._state;let o=this._head;const n={[Symbol.iterator](){return n},next(){if(a._state!==t)throw new Error("LinkedMap got modified during iteration.");if(o){const l={value:o.key,done:!1};return o=o.next,l}else return{value:void 0,done:!0}}};return n}values(){const a=this,t=this._state;let o=this._head;const n={[Symbol.iterator](){return n},next(){if(a._state!==t)throw new Error("LinkedMap got modified during iteration.");if(o){const l={value:o.value,done:!1};return o=o.next,l}else return{value:void 0,done:!0}}};return n}entries(){const a=this,t=this._state;let o=this._head;const n={[Symbol.iterator](){return n},next(){if(a._state!==t)throw new Error("LinkedMap got modified during iteration.");if(o){const l={value:[o.key,o.value],done:!1};return o=o.next,l}else return{value:void 0,done:!0}}};return n}[(y=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(a){if(a>=this.size)return;if(a===0){this.clear();return}let t=this._head,o=this.size;for(;t&&o>a;)this._map.delete(t.key),t=t.next,o--;this._head=t,this._size=o,t&&(t.previous=void 0),this._state++}trimNew(a){if(a>=this.size)return;if(a===0){this.clear();return}let t=this._tail,o=this.size;for(;t&&o>a;)this._map.delete(t.key),t=t.previous,o--;this._tail=t,this._size=o,t&&(t.next=void 0),this._state++}addItemFirst(a){if(!this._head&&!this._tail)this._tail=a;else if(this._head)a.next=this._head,this._head.previous=a;else throw new Error("Invalid list");this._head=a,this._state++}addItemLast(a){if(!this._head&&!this._tail)this._head=a;else if(this._tail)a.previous=this._tail,this._tail.next=a;else throw new Error("Invalid list");this._tail=a,this._state++}removeItem(a){if(a===this._head&&a===this._tail)this._head=void 0,this._tail=void 0;else if(a===this._head){if(!a.next)throw new Error("Invalid list");a.next.previous=void 0,this._head=a.next}else if(a===this._tail){if(!a.previous)throw new Error("Invalid list");a.previous.next=void 0,this._tail=a.previous}else{const t=a.next,o=a.previous;if(!t||!o)throw new Error("Invalid list");t.previous=o,o.next=t}a.next=void 0,a.previous=void 0,this._state++}touch(a,t){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(t!==p.AsOld&&t!==p.AsNew)){if(t===p.AsOld){if(a===this._head)return;const o=a.next,n=a.previous;a===this._tail?(n.next=void 0,this._tail=n):(o.previous=n,n.next=o),a.previous=void 0,a.next=this._head,this._head.previous=a,this._head=a,this._state++}else if(t===p.AsNew){if(a===this._tail)return;const o=a.next,n=a.previous;a===this._head?(o.previous=void 0,this._head=o):(o.previous=n,n.next=o),a.next=void 0,a.previous=this._tail,this._tail.next=a,this._tail=a,this._state++}}}toJSON(){const a=[];return this.forEach((t,o)=>{a.push([o,t])}),a}fromJSON(a){this.clear();for(const[t,o]of a)this.set(t,o)}}e.LinkedMap=v;class f extends v{constructor(a,t=1){super(),this._limit=a,this._ratio=Math.min(Math.max(0,t),1)}get limit(){return this._limit}set limit(a){this._limit=a,this.checkTrim()}get ratio(){return this._ratio}set ratio(a){this._ratio=Math.min(Math.max(0,a),1),this.checkTrim()}get(a,t=p.AsNew){return super.get(a,t)}peek(a){return super.get(a,p.None)}set(a,t){return super.set(a,t,p.AsNew),this}checkTrim(){this.size>this._limit&&this.trim(Math.round(this._limit*this._ratio))}}class h extends f{constructor(a,t=1){super(a,t)}trim(a){this.trimOld(a)}set(a,t){return super.set(a,t),this.checkTrim(),this}}e.LRUCache=h;class E extends f{constructor(a,t=1){super(a,t)}trim(a){this.trimNew(a)}set(a,t){return this._limit<=this.size&&!this.has(a)&&this.trim(Math.round(this._limit*this._ratio)-1),super.set(a,t),this}}e.MRUCache=E;class b{constructor(){this.map=new Map}add(a){return this.map.set(a,(this.map.get(a)||0)+1),this}delete(a){let t=this.map.get(a)||0;return t===0?!1:(t--,t===0?this.map.delete(a):this.map.set(a,t),!0)}has(a){return this.map.has(a)}}e.CounterSet=b;class g{constructor(a){if(this._m1=new Map,this._m2=new Map,a)for(const[t,o]of a)this.set(t,o)}clear(){this._m1.clear(),this._m2.clear()}set(a,t){this._m1.set(a,t),this._m2.set(t,a)}get(a){return this._m1.get(a)}getKey(a){return this._m2.get(a)}delete(a){const t=this._m1.get(a);return t===void 0?!1:(this._m1.delete(a),this._m2.delete(t),!0)}forEach(a,t){this._m1.forEach((o,n)=>{a.call(t,o,n,this)})}keys(){return this._m1.keys()}values(){return this._m1.values()}}e.BidirectionalMap=g;class I{constructor(){this.map=new Map}add(a,t){let o=this.map.get(a);o||(o=new Set,this.map.set(a,o)),o.add(t)}delete(a,t){const o=this.map.get(a);o&&(o.delete(t),o.size===0&&this.map.delete(a))}forEach(a,t){const o=this.map.get(a);o&&o.forEach(t)}get(a){const t=this.map.get(a);return t||new Set}}e.SetMap=I;function P(r,a){if(r===a)return!0;if(r.size!==a.size)return!1;for(const[t,o]of r)if(!a.has(t)||a.get(t)!==o)return!1;for(const[t]of a)if(!r.has(t))return!1;return!0}}),define(le[2],ue([0,1,21,142,31,91,78]),function(j,e,i,s,y,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DisposableMap=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MandatoryMutableDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.DisposableTracker=void 0,e.setDisposableTracker=m,e.trackDisposable=u,e.markAsDisposed=p,e.markAsSingleton=h,e.isDisposable=E,e.dispose=b,e.disposeIfDisposable=g,e.combinedDisposable=I,e.toDisposable=P,e.disposeOnReturn=M;const R=!1;let S=null;class c{constructor(){this.livingDisposables=new Map}static{this.idx=0}getDisposableData(L){let _=this.livingDisposables.get(L);return _||(_={parent:null,source:null,isSingleton:!1,value:L,idx:c.idx++},this.livingDisposables.set(L,_)),_}trackDisposable(L){const _=this.getDisposableData(L);_.source||(_.source=new Error().stack)}setParent(L,_){const V=this.getDisposableData(L);V.parent=_}markAsDisposed(L){this.livingDisposables.delete(L)}markAsSingleton(L){this.getDisposableData(L).isSingleton=!0}getRootParent(L,_){const V=_.get(L);if(V)return V;const z=L.parent?this.getRootParent(this.getDisposableData(L.parent),_):L;return _.set(L,z),z}getTrackedDisposables(){const L=new Map;return[...this.livingDisposables.entries()].filter(([,V])=>V.source!==null&&!this.getRootParent(V,L).isSingleton).flatMap(([V])=>V)}computeLeakingDisposables(L=10,_){let V;if(_)V=_;else{const ee=new Map,U=[...this.livingDisposables.values()].filter(N=>N.source!==null&&!this.getRootParent(N,ee).isSingleton);if(U.length===0)return;const K=new Set(U.map(N=>N.value));if(V=U.filter(N=>!(N.parent&&K.has(N.parent))),V.length===0)throw new Error("There are cyclic diposable chains!")}if(!V)return;function z(ee){function U(N,x){for(;N.length>0&&x.some(W=>typeof W=="string"?W===N[0]:N[0].match(W));)N.shift()}const K=ee.source.split(`
`).map(N=>N.trim().replace("at ","")).filter(N=>N!=="");return U(K,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),K.reverse()}const Q=new y.SetMap;for(const ee of V){const U=z(ee);for(let K=0;K<=U.length;K++)Q.add(U.slice(0,K).join(`
`),ee)}V.sort((0,i.compareBy)(ee=>ee.idx,i.numberComparator));let fe="",se=0;for(const ee of V.slice(0,L)){se++;const U=z(ee),K=[];for(let N=0;N<U.length;N++){let x=U[N];x=`(shared with ${Q.get(U.slice(0,N+1).join(`
`)).size}/${V.length} leaks) at ${x}`;const q=Q.get(U.slice(0,N).join(`
`)),ie=(0,s.groupBy)([...q].map(H=>z(H)[N]),H=>H);delete ie[U[N]];for(const[H,ce]of Object.entries(ie))K.unshift(`    - stacktraces of ${ce.length} other leaks continue with ${H}`);K.unshift(x)}fe+=`


==================== Leaking disposable ${se}/${V.length}: ${ee.value.constructor.name} ====================
${K.join(`
`)}
============================================================

`}return V.length>L&&(fe+=`


... and ${V.length-L} more leaking disposables

`),{leaks:V,details:fe}}}e.DisposableTracker=c;function m(C){S=C}if(R){const C="__is_disposable_tracked__";m(new class{trackDisposable(L){const _=new Error("Potentially leaked disposable").stack;setTimeout(()=>{L[C]||console.log(_)},3e3)}setParent(L,_){if(L&&L!==a.None)try{L[C]=!0}catch{}}markAsDisposed(L){if(L&&L!==a.None)try{L[C]=!0}catch{}}markAsSingleton(L){}})}function u(C){return S?.trackDisposable(C),C}function p(C){S?.markAsDisposed(C)}function v(C,L){S?.setParent(C,L)}function f(C,L){if(S)for(const _ of C)S.setParent(_,L)}function h(C){return S?.markAsSingleton(C),C}function E(C){return typeof C=="object"&&C!==null&&typeof C.dispose=="function"&&C.dispose.length===0}function b(C){if(A.Iterable.is(C)){const L=[];for(const _ of C)if(_)try{_.dispose()}catch(V){L.push(V)}if(L.length===1)throw L[0];if(L.length>1)throw new AggregateError(L,"Encountered errors while disposing of store");return Array.isArray(C)?[]:C}else if(C)return C.dispose(),C}function g(C){for(const L of C)E(L)&&L.dispose();return[]}function I(...C){const L=P(()=>b(C));return f(C,L),L}function P(C){const L=u({dispose:(0,k.createSingleCallFunction)(()=>{p(L),C()})});return L}class r{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this._toDispose=new Set,this._isDisposed=!1,u(this)}dispose(){this._isDisposed||(p(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){if(this._toDispose.size!==0)try{b(this._toDispose)}finally{this._toDispose.clear()}}add(L){if(!L)return L;if(L===this)throw new Error("Cannot register a disposable on itself!");return v(L,this),this._isDisposed?r.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(L),L}delete(L){if(L){if(L===this)throw new Error("Cannot dispose a disposable on itself!");this._toDispose.delete(L),L.dispose()}}deleteAndLeak(L){L&&this._toDispose.has(L)&&(this._toDispose.delete(L),v(L,null))}}e.DisposableStore=r;class a{static{this.None=Object.freeze({dispose(){}})}constructor(){this._store=new r,u(this),v(this._store,this)}dispose(){p(this),this._store.dispose()}_register(L){if(L===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(L)}}e.Disposable=a;class t{constructor(){this._isDisposed=!1,u(this)}get value(){return this._isDisposed?void 0:this._value}set value(L){this._isDisposed||L===this._value||(this._value?.dispose(),L&&v(L,this),this._value=L)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,p(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const L=this._value;return this._value=void 0,L&&v(L,null),L}}e.MutableDisposable=t;class o{constructor(L){this._disposable=new t,this._isDisposed=!1,this._disposable.value=L}get value(){return this._disposable.value}set value(L){this._isDisposed||L===this._disposable.value||(this._disposable.value=L)}dispose(){this._isDisposed=!0,this._disposable.dispose()}}e.MandatoryMutableDisposable=o;class n{constructor(L){this._disposable=L,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter===0&&this._disposable.dispose(),this}}e.RefCountedDisposable=n;class l{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,u(this)}set(L){let _=L;return this.unset=()=>_=void 0,this.isset=()=>_!==void 0,this.dispose=()=>{_&&(_(),_=void 0,p(this))},this}}e.SafeDisposable=l;class d{constructor(){this.references=new Map}acquire(L,..._){let V=this.references.get(L);V||(V={counter:0,object:this.createReferencedObject(L,..._)},this.references.set(L,V));const{object:z}=V,Q=(0,k.createSingleCallFunction)(()=>{--V.counter===0&&(this.destroyReferencedObject(L,V.object),this.references.delete(L))});return V.counter++,{object:z,dispose:Q}}}e.ReferenceCollection=d;class D{constructor(L){this.referenceCollection=L}async acquire(L,..._){const V=this.referenceCollection.acquire(L,..._);try{return{object:await V.object,dispose:()=>V.dispose()}}catch(z){throw V.dispose(),z}}}e.AsyncReferenceCollection=D;class w{constructor(L){this.object=L}dispose(){}}e.ImmortalReference=w;function M(C){const L=new r;try{C(L)}finally{L.dispose()}}class T{constructor(){this._store=new Map,this._isDisposed=!1,u(this)}dispose(){p(this),this._isDisposed=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this._store.size)try{b(this._store.values())}finally{this._store.clear()}}has(L){return this._store.has(L)}get size(){return this._store.size}get(L){return this._store.get(L)}set(L,_,V=!1){this._isDisposed&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),V||this._store.get(L)?.dispose(),this._store.set(L,_)}deleteAndDispose(L){this._store.get(L)?.dispose(),this._store.delete(L)}deleteAndLeak(L){const _=this._store.get(L);return this._store.delete(L),_}keys(){return this._store.keys()}values(){return this._store.values()}[Symbol.iterator](){return this._store[Symbol.iterator]()}}e.DisposableMap=T}),define(le[92],ue([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MarshalledId=void 0;var i;(function(s){s[s.Uri=1]="Uri",s[s.Regexp=2]="Regexp",s[s.ScmResource=3]="ScmResource",s[s.ScmResourceGroup=4]="ScmResourceGroup",s[s.ScmProvider=5]="ScmProvider",s[s.CommentController=6]="CommentController",s[s.CommentThread=7]="CommentThread",s[s.CommentThreadInstance=8]="CommentThreadInstance",s[s.CommentThreadReply=9]="CommentThreadReply",s[s.CommentNode=10]="CommentNode",s[s.CommentThreadNode=11]="CommentThreadNode",s[s.TimelineActionContext=12]="TimelineActionContext",s[s.NotebookCellActionContext=13]="NotebookCellActionContext",s[s.NotebookActionContext=14]="NotebookActionContext",s[s.TerminalContext=15]="TerminalContext",s[s.TestItemContext=16]="TestItemContext",s[s.Date=17]="Date",s[s.TestMessageMenuArgs=18]="TestMessageMenuArgs"})(i||(e.MarshalledId=i={}))}),define(le[79],ue([0,1,31]),function(j,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=void 0,e.normalizeNFC=y,e.normalizeNFD=A;const s=new i.LRUCache(1e4);function y(c){return S(c,"NFC",s)}const k=new i.LRUCache(1e4);function A(c){return S(c,"NFD",k)}const R=/[^\u0000-\u0080]/;function S(c,m,u){if(!c)return c;const p=u.get(c);if(p)return p;let v;return R.test(c)?v=c.normalize(m):v=c,u.set(c,v),v}e.removeAccents=function(){const c=/[\u0300-\u036f]/g;return function(m){return A(m).replace(c,"")}}()}),define(le[147],ue([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=void 0,e.clamp=i,e.rot=s,e.isPointWithinTriangle=R;function i(S,c,m){return Math.min(Math.max(S,c),m)}function s(S,c){return(c+S%c)%c}class y{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=y;class k{constructor(){this._n=1,this._val=0}update(c){return this._val=this._val+(c-this._val)/this._n,this._n+=1,this._val}get value(){return this._val}}e.MovingAverage=k;class A{constructor(c){this._n=0,this._val=0,this._values=[],this._index=0,this._sum=0,this._values=new Array(c),this._values.fill(0,0,c)}update(c){const m=this._values[this._index];return this._values[this._index]=c,this._index=(this._index+1)%this._values.length,this._sum-=m,this._sum+=c,this._n<this._values.length&&(this._n+=1),this._val=this._sum/this._n,this._val}get value(){return this._val}}e.SlidingWindowAverage=A;function R(S,c,m,u,p,v,f,h){const E=f-m,b=h-u,g=p-m,I=v-u,P=S-m,r=c-u,a=E*E+b*b,t=E*g+b*I,o=E*P+b*r,n=g*g+I*I,l=g*P+I*r,d=1/(a*n-t*t),D=(n*o-t*l)*d,w=(a*l-t*o)*d;return D>=0&&w>=0&&D+w<1}}),function(){function j(y){const k=[];typeof y=="number"&&k.push("code/timeOrigin",y);function A(S){k.push(S,Date.now())}function R(){const S=[];for(let c=0;c<k.length;c+=2)S.push({name:k[c],startTime:k[c+1]});return S}return{mark:A,getMarks:R}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?j():{mark(y){performance.mark(y)},getMarks(){let y=performance.timeOrigin;typeof y!="number"&&(y=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const k=[{name:"code/timeOrigin",startTime:Math.round(y)}];for(const A of performance.getEntriesByType("mark"))k.push({name:A.name,startTime:Math.round(y+A.startTime)});return k}};if(typeof process=="object"){const y=performance?.timeOrigin;return j(y)}else return console.trace("perf-util loaded in UNKNOWN environment"),j()}function i(y){return y.MonacoPerformanceMarks||(y.MonacoPerformanceMarks=e()),y.MonacoPerformanceMarks}var s;typeof global=="object"?s=global:typeof self=="object"?s=self:s={},typeof define=="function"?define("vs/base/common/performance",[],function(){return i(s)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=i(s):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),s.perf=i(s))}(),function(j,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var i=e();for(var s in i)(typeof exports=="object"?exports:j)[s]=i[s]}}(typeof self<"u"?self:this,function(){return function(j){var e={};function i(s){if(e[s])return e[s].exports;var y=e[s]={i:s,l:!1,exports:{}};return j[s].call(y.exports,y,y.exports,i),y.l=!0,y.exports}return i.m=j,i.c=e,i.d=function(s,y,k){i.o(s,y)||Object.defineProperty(s,y,{enumerable:!0,get:k})},i.r=function(s){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(s,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(s,"__esModule",{value:!0})},i.t=function(s,y){if(1&y&&(s=i(s)),8&y||4&y&&typeof s=="object"&&s&&s.__esModule)return s;var k=Object.create(null);if(i.r(k),Object.defineProperty(k,"default",{enumerable:!0,value:s}),2&y&&typeof s!="string")for(var A in s)i.d(k,A,function(R){return s[R]}.bind(null,A));return k},i.n=function(s){var y=s&&s.__esModule?function(){return s.default}:function(){return s};return i.d(y,"a",y),y},i.o=function(s,y){return Object.prototype.hasOwnProperty.call(s,y)},i.p="",i(i.s=0)}([function(j,e,i){(function(s){var y;e=j.exports=ce,y=typeof s=="object"&&s.env&&s.env.NODE_DEBUG&&/\bsemver\b/i.test(s.env.NODE_DEBUG)?function(){var Y=Array.prototype.slice.call(arguments,0);Y.unshift("SEMVER"),console.log.apply(console,Y)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var k=256,A=Number.MAX_SAFE_INTEGER||9007199254740991,R=e.re=[],S=e.src=[],c=0,m=c++;S[m]="0|[1-9]\\d*";var u=c++;S[u]="[0-9]+";var p=c++;S[p]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var v=c++;S[v]="("+S[m]+")\\.("+S[m]+")\\.("+S[m]+")";var f=c++;S[f]="("+S[u]+")\\.("+S[u]+")\\.("+S[u]+")";var h=c++;S[h]="(?:"+S[m]+"|"+S[p]+")";var E=c++;S[E]="(?:"+S[u]+"|"+S[p]+")";var b=c++;S[b]="(?:-("+S[h]+"(?:\\."+S[h]+")*))";var g=c++;S[g]="(?:-?("+S[E]+"(?:\\."+S[E]+")*))";var I=c++;S[I]="[0-9A-Za-z-]+";var P=c++;S[P]="(?:\\+("+S[I]+"(?:\\."+S[I]+")*))";var r=c++,a="v?"+S[v]+S[b]+"?"+S[P]+"?";S[r]="^"+a+"$";var t="[v=\\s]*"+S[f]+S[g]+"?"+S[P]+"?",o=c++;S[o]="^"+t+"$";var n=c++;S[n]="((?:<|>)?=?)";var l=c++;S[l]=S[u]+"|x|X|\\*";var d=c++;S[d]=S[m]+"|x|X|\\*";var D=c++;S[D]="[v=\\s]*("+S[d]+")(?:\\.("+S[d]+")(?:\\.("+S[d]+")(?:"+S[b]+")?"+S[P]+"?)?)?";var w=c++;S[w]="[v=\\s]*("+S[l]+")(?:\\.("+S[l]+")(?:\\.("+S[l]+")(?:"+S[g]+")?"+S[P]+"?)?)?";var M=c++;S[M]="^"+S[n]+"\\s*"+S[D]+"$";var T=c++;S[T]="^"+S[n]+"\\s*"+S[w]+"$";var C=c++;S[C]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var L=c++;S[L]="(?:~>?)";var _=c++;S[_]="(\\s*)"+S[L]+"\\s+",R[_]=new RegExp(S[_],"g");var V=c++;S[V]="^"+S[L]+S[D]+"$";var z=c++;S[z]="^"+S[L]+S[w]+"$";var Q=c++;S[Q]="(?:\\^)";var fe=c++;S[fe]="(\\s*)"+S[Q]+"\\s+",R[fe]=new RegExp(S[fe],"g");var se=c++;S[se]="^"+S[Q]+S[D]+"$";var ee=c++;S[ee]="^"+S[Q]+S[w]+"$";var U=c++;S[U]="^"+S[n]+"\\s*("+t+")$|^$";var K=c++;S[K]="^"+S[n]+"\\s*("+a+")$|^$";var N=c++;S[N]="(\\s*)"+S[n]+"\\s*("+t+"|"+S[D]+")",R[N]=new RegExp(S[N],"g");var x=c++;S[x]="^\\s*("+S[D]+")\\s+-\\s+("+S[D]+")\\s*$";var W=c++;S[W]="^\\s*("+S[w]+")\\s+-\\s+("+S[w]+")\\s*$";var q=c++;S[q]="(<|>)?=?\\s*\\*";for(var ie=0;ie<35;ie++)y(ie,S[ie]),R[ie]||(R[ie]=new RegExp(S[ie]));function H(Y,de){if(Y instanceof ce)return Y;if(typeof Y!="string"||Y.length>k||!(de?R[o]:R[r]).test(Y))return null;try{return new ce(Y,de)}catch{return null}}function ce(Y,de){if(Y instanceof ce){if(Y.loose===de)return Y;Y=Y.version}else if(typeof Y!="string")throw new TypeError("Invalid Version: "+Y);if(Y.length>k)throw new TypeError("version is longer than "+k+" characters");if(!(this instanceof ce))return new ce(Y,de);y("SemVer",Y,de),this.loose=de;var he=Y.trim().match(de?R[o]:R[r]);if(!he)throw new TypeError("Invalid Version: "+Y);if(this.raw=Y,this.major=+he[1],this.minor=+he[2],this.patch=+he[3],this.major>A||this.major<0)throw new TypeError("Invalid major version");if(this.minor>A||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>A||this.patch<0)throw new TypeError("Invalid patch version");he[4]?this.prerelease=he[4].split(".").map(function(ve){if(/^[0-9]+$/.test(ve)){var Ee=+ve;if(Ee>=0&&Ee<A)return Ee}return ve}):this.prerelease=[],this.build=he[5]?he[5].split("."):[],this.format()}e.parse=H,e.valid=function(Y,de){var he=H(Y,de);return he?he.version:null},e.clean=function(Y,de){var he=H(Y.trim().replace(/^[=v]+/,""),de);return he?he.version:null},e.SemVer=ce,ce.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},ce.prototype.toString=function(){return this.version},ce.prototype.compare=function(Y){return y("SemVer.compare",this.version,this.loose,Y),Y instanceof ce||(Y=new ce(Y,this.loose)),this.compareMain(Y)||this.comparePre(Y)},ce.prototype.compareMain=function(Y){return Y instanceof ce||(Y=new ce(Y,this.loose)),te(this.major,Y.major)||te(this.minor,Y.minor)||te(this.patch,Y.patch)},ce.prototype.comparePre=function(Y){if(Y instanceof ce||(Y=new ce(Y,this.loose)),this.prerelease.length&&!Y.prerelease.length)return-1;if(!this.prerelease.length&&Y.prerelease.length)return 1;if(!this.prerelease.length&&!Y.prerelease.length)return 0;var de=0;do{var he=this.prerelease[de],ve=Y.prerelease[de];if(y("prerelease compare",de,he,ve),he===void 0&&ve===void 0)return 0;if(ve===void 0)return 1;if(he===void 0)return-1;if(he!==ve)return te(he,ve)}while(++de)},ce.prototype.inc=function(Y,de){switch(Y){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",de);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",de);break;case"prepatch":this.prerelease.length=0,this.inc("patch",de),this.inc("pre",de);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",de),this.inc("pre",de);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var he=this.prerelease.length;--he>=0;)typeof this.prerelease[he]=="number"&&(this.prerelease[he]++,he=-2);he===-1&&this.prerelease.push(0)}de&&(this.prerelease[0]===de?isNaN(this.prerelease[1])&&(this.prerelease=[de,0]):this.prerelease=[de,0]);break;default:throw new Error("invalid increment argument: "+Y)}return this.format(),this.raw=this.version,this},e.inc=function(Y,de,he,ve){typeof he=="string"&&(ve=he,he=void 0);try{return new ce(Y,he).inc(de,ve).version}catch{return null}},e.diff=function(Y,de){if(F(Y,de))return null;var he=H(Y),ve=H(de);if(he.prerelease.length||ve.prerelease.length){for(var Ee in he)if((Ee==="major"||Ee==="minor"||Ee==="patch")&&he[Ee]!==ve[Ee])return"pre"+Ee;return"prerelease"}for(var Ee in he)if((Ee==="major"||Ee==="minor"||Ee==="patch")&&he[Ee]!==ve[Ee])return Ee},e.compareIdentifiers=te;var oe=/^[0-9]+$/;function te(Y,de){var he=oe.test(Y),ve=oe.test(de);return he&&ve&&(Y=+Y,de=+de),he&&!ve?-1:ve&&!he?1:Y<de?-1:Y>de?1:0}function O(Y,de,he){return new ce(Y,he).compare(new ce(de,he))}function X(Y,de,he){return O(Y,de,he)>0}function B(Y,de,he){return O(Y,de,he)<0}function F(Y,de,he){return O(Y,de,he)===0}function J(Y,de,he){return O(Y,de,he)!==0}function G(Y,de,he){return O(Y,de,he)>=0}function $(Y,de,he){return O(Y,de,he)<=0}function Z(Y,de,he,ve){var Ee;switch(de){case"===":typeof Y=="object"&&(Y=Y.version),typeof he=="object"&&(he=he.version),Ee=Y===he;break;case"!==":typeof Y=="object"&&(Y=Y.version),typeof he=="object"&&(he=he.version),Ee=Y!==he;break;case"":case"=":case"==":Ee=F(Y,he,ve);break;case"!=":Ee=J(Y,he,ve);break;case">":Ee=X(Y,he,ve);break;case">=":Ee=G(Y,he,ve);break;case"<":Ee=B(Y,he,ve);break;case"<=":Ee=$(Y,he,ve);break;default:throw new TypeError("Invalid operator: "+de)}return Ee}function ae(Y,de){if(Y instanceof ae){if(Y.loose===de)return Y;Y=Y.value}if(!(this instanceof ae))return new ae(Y,de);y("comparator",Y,de),this.loose=de,this.parse(Y),this.semver===pe?this.value="":this.value=this.operator+this.semver.version,y("comp",this)}e.rcompareIdentifiers=function(Y,de){return te(de,Y)},e.major=function(Y,de){return new ce(Y,de).major},e.minor=function(Y,de){return new ce(Y,de).minor},e.patch=function(Y,de){return new ce(Y,de).patch},e.compare=O,e.compareLoose=function(Y,de){return O(Y,de,!0)},e.rcompare=function(Y,de,he){return O(de,Y,he)},e.sort=function(Y,de){return Y.sort(function(he,ve){return e.compare(he,ve,de)})},e.rsort=function(Y,de){return Y.sort(function(he,ve){return e.rcompare(he,ve,de)})},e.gt=X,e.lt=B,e.eq=F,e.neq=J,e.gte=G,e.lte=$,e.cmp=Z,e.Comparator=ae;var pe={};function Se(Y,de){if(Y instanceof Se)return Y.loose===de?Y:new Se(Y.raw,de);if(Y instanceof ae)return new Se(Y.value,de);if(!(this instanceof Se))return new Se(Y,de);if(this.loose=de,this.raw=Y,this.set=Y.split(/\s*\|\|\s*/).map(function(he){return this.parseRange(he.trim())},this).filter(function(he){return he.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+Y);this.format()}function ye(Y){return!Y||Y.toLowerCase()==="x"||Y==="*"}function We(Y,de,he,ve,Ee,Oe,Ae,Me,Ue,Ge,Je,ze,Xe){return((de=ye(he)?"":ye(ve)?">="+he+".0.0":ye(Ee)?">="+he+"."+ve+".0":">="+de)+" "+(Me=ye(Ue)?"":ye(Ge)?"<"+(+Ue+1)+".0.0":ye(Je)?"<"+Ue+"."+(+Ge+1)+".0":ze?"<="+Ue+"."+Ge+"."+Je+"-"+ze:"<="+Me)).trim()}function He(Y,de){for(var he=0;he<Y.length;he++)if(!Y[he].test(de))return!1;if(de.prerelease.length){for(he=0;he<Y.length;he++)if(y(Y[he].semver),Y[he].semver!==pe&&Y[he].semver.prerelease.length>0){var ve=Y[he].semver;if(ve.major===de.major&&ve.minor===de.minor&&ve.patch===de.patch)return!0}return!1}return!0}function Ce(Y,de,he){try{de=new Se(de,he)}catch{return!1}return de.test(Y)}function me(Y,de,he,ve){var Ee,Oe,Ae,Me,Ue;switch(Y=new ce(Y,ve),de=new Se(de,ve),he){case">":Ee=X,Oe=$,Ae=B,Me=">",Ue=">=";break;case"<":Ee=B,Oe=G,Ae=X,Me="<",Ue="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Ce(Y,de,ve))return!1;for(var Ge=0;Ge<de.set.length;++Ge){var Je=de.set[Ge],ze=null,Xe=null;if(Je.forEach(function(Qe){Qe.semver===pe&&(Qe=new ae(">=0.0.0")),ze=ze||Qe,Xe=Xe||Qe,Ee(Qe.semver,ze.semver,ve)?ze=Qe:Ae(Qe.semver,Xe.semver,ve)&&(Xe=Qe)}),ze.operator===Me||ze.operator===Ue||(!Xe.operator||Xe.operator===Me)&&Oe(Y,Xe.semver)||Xe.operator===Ue&&Ae(Y,Xe.semver))return!1}return!0}ae.prototype.parse=function(Y){var de=this.loose?R[U]:R[K],he=Y.match(de);if(!he)throw new TypeError("Invalid comparator: "+Y);this.operator=he[1],this.operator==="="&&(this.operator=""),he[2]?this.semver=new ce(he[2],this.loose):this.semver=pe},ae.prototype.toString=function(){return this.value},ae.prototype.test=function(Y){return y("Comparator.test",Y,this.loose),this.semver===pe||(typeof Y=="string"&&(Y=new ce(Y,this.loose)),Z(Y,this.operator,this.semver,this.loose))},ae.prototype.intersects=function(Y,de){if(!(Y instanceof ae))throw new TypeError("a Comparator is required");var he;if(this.operator==="")return he=new Se(Y.value,de),Ce(this.value,he,de);if(Y.operator==="")return he=new Se(this.value,de),Ce(Y.semver,he,de);var ve=!(this.operator!==">="&&this.operator!==">"||Y.operator!==">="&&Y.operator!==">"),Ee=!(this.operator!=="<="&&this.operator!=="<"||Y.operator!=="<="&&Y.operator!=="<"),Oe=this.semver.version===Y.semver.version,Ae=!(this.operator!==">="&&this.operator!=="<="||Y.operator!==">="&&Y.operator!=="<="),Me=Z(this.semver,"<",Y.semver,de)&&(this.operator===">="||this.operator===">")&&(Y.operator==="<="||Y.operator==="<"),Ue=Z(this.semver,">",Y.semver,de)&&(this.operator==="<="||this.operator==="<")&&(Y.operator===">="||Y.operator===">");return ve||Ee||Oe&&Ae||Me||Ue},e.Range=Se,Se.prototype.format=function(){return this.range=this.set.map(function(Y){return Y.join(" ").trim()}).join("||").trim(),this.range},Se.prototype.toString=function(){return this.range},Se.prototype.parseRange=function(Y){var de=this.loose;Y=Y.trim(),y("range",Y,de);var he=de?R[W]:R[x];Y=Y.replace(he,We),y("hyphen replace",Y),Y=Y.replace(R[N],"$1$2$3"),y("comparator trim",Y,R[N]),Y=(Y=(Y=Y.replace(R[_],"$1~")).replace(R[fe],"$1^")).split(/\s+/).join(" ");var ve=de?R[U]:R[K],Ee=Y.split(" ").map(function(Oe){return function(Ae,Me){return y("comp",Ae),Ae=function(Ue,Ge){return Ue.trim().split(/\s+/).map(function(Je){return function(ze,Xe){y("caret",ze,Xe);var Qe=Xe?R[ee]:R[se];return ze.replace(Qe,function(Ye,Ne,ne,ge,we){var be;return y("caret",ze,Ye,Ne,ne,ge,we),ye(Ne)?be="":ye(ne)?be=">="+Ne+".0.0 <"+(+Ne+1)+".0.0":ye(ge)?be=Ne==="0"?">="+Ne+"."+ne+".0 <"+Ne+"."+(+ne+1)+".0":">="+Ne+"."+ne+".0 <"+(+Ne+1)+".0.0":we?(y("replaceCaret pr",we),we.charAt(0)!=="-"&&(we="-"+we),be=Ne==="0"?ne==="0"?">="+Ne+"."+ne+"."+ge+we+" <"+Ne+"."+ne+"."+(+ge+1):">="+Ne+"."+ne+"."+ge+we+" <"+Ne+"."+(+ne+1)+".0":">="+Ne+"."+ne+"."+ge+we+" <"+(+Ne+1)+".0.0"):(y("no pr"),be=Ne==="0"?ne==="0"?">="+Ne+"."+ne+"."+ge+" <"+Ne+"."+ne+"."+(+ge+1):">="+Ne+"."+ne+"."+ge+" <"+Ne+"."+(+ne+1)+".0":">="+Ne+"."+ne+"."+ge+" <"+(+Ne+1)+".0.0"),y("caret return",be),be})}(Je,Ge)}).join(" ")}(Ae,Me),y("caret",Ae),Ae=function(Ue,Ge){return Ue.trim().split(/\s+/).map(function(Je){return function(ze,Xe){var Qe=Xe?R[z]:R[V];return ze.replace(Qe,function(Ye,Ne,ne,ge,we){var be;return y("tilde",ze,Ye,Ne,ne,ge,we),ye(Ne)?be="":ye(ne)?be=">="+Ne+".0.0 <"+(+Ne+1)+".0.0":ye(ge)?be=">="+Ne+"."+ne+".0 <"+Ne+"."+(+ne+1)+".0":we?(y("replaceTilde pr",we),we.charAt(0)!=="-"&&(we="-"+we),be=">="+Ne+"."+ne+"."+ge+we+" <"+Ne+"."+(+ne+1)+".0"):be=">="+Ne+"."+ne+"."+ge+" <"+Ne+"."+(+ne+1)+".0",y("tilde return",be),be})}(Je,Ge)}).join(" ")}(Ae,Me),y("tildes",Ae),Ae=function(Ue,Ge){return y("replaceXRanges",Ue,Ge),Ue.split(/\s+/).map(function(Je){return function(ze,Xe){ze=ze.trim();var Qe=Xe?R[T]:R[M];return ze.replace(Qe,function(Ye,Ne,ne,ge,we,be){y("xRange",ze,Ye,Ne,ne,ge,we,be);var _e=ye(ne),xe=_e||ye(ge),Ze=xe||ye(we);return Ne==="="&&Ze&&(Ne=""),_e?Ye=Ne===">"||Ne==="<"?"<0.0.0":"*":Ne&&Ze?(xe&&(ge=0),Ze&&(we=0),Ne===">"?(Ne=">=",xe?(ne=+ne+1,ge=0,we=0):Ze&&(ge=+ge+1,we=0)):Ne==="<="&&(Ne="<",xe?ne=+ne+1:ge=+ge+1),Ye=Ne+ne+"."+ge+"."+we):xe?Ye=">="+ne+".0.0 <"+(+ne+1)+".0.0":Ze&&(Ye=">="+ne+"."+ge+".0 <"+ne+"."+(+ge+1)+".0"),y("xRange return",Ye),Ye})}(Je,Ge)}).join(" ")}(Ae,Me),y("xrange",Ae),Ae=function(Ue,Ge){return y("replaceStars",Ue,Ge),Ue.trim().replace(R[q],"")}(Ae,Me),y("stars",Ae),Ae}(Oe,de)}).join(" ").split(/\s+/);return this.loose&&(Ee=Ee.filter(function(Oe){return!!Oe.match(ve)})),Ee=Ee.map(function(Oe){return new ae(Oe,de)})},Se.prototype.intersects=function(Y,de){if(!(Y instanceof Se))throw new TypeError("a Range is required");return this.set.some(function(he){return he.every(function(ve){return Y.set.some(function(Ee){return Ee.every(function(Oe){return ve.intersects(Oe,de)})})})})},e.toComparators=function(Y,de){return new Se(Y,de).set.map(function(he){return he.map(function(ve){return ve.value}).join(" ").trim().split(" ")})},Se.prototype.test=function(Y){if(!Y)return!1;typeof Y=="string"&&(Y=new ce(Y,this.loose));for(var de=0;de<this.set.length;de++)if(He(this.set[de],Y))return!0;return!1},e.satisfies=Ce,e.maxSatisfying=function(Y,de,he){var ve=null,Ee=null;try{var Oe=new Se(de,he)}catch{return null}return Y.forEach(function(Ae){Oe.test(Ae)&&(ve&&Ee.compare(Ae)!==-1||(Ee=new ce(ve=Ae,he)))}),ve},e.minSatisfying=function(Y,de,he){var ve=null,Ee=null;try{var Oe=new Se(de,he)}catch{return null}return Y.forEach(function(Ae){Oe.test(Ae)&&(ve&&Ee.compare(Ae)!==1||(Ee=new ce(ve=Ae,he)))}),ve},e.validRange=function(Y,de){try{return new Se(Y,de).range||"*"}catch{return null}},e.ltr=function(Y,de,he){return me(Y,de,"<",he)},e.gtr=function(Y,de,he){return me(Y,de,">",he)},e.outside=me,e.prerelease=function(Y,de){var he=H(Y,de);return he&&he.prerelease.length?he.prerelease:null},e.intersects=function(Y,de,he){return Y=new Se(Y,he),de=new Se(de,he),Y.intersects(de)},e.coerce=function(Y){if(Y instanceof ce)return Y;if(typeof Y!="string")return null;var de=Y.match(R[C]);return de==null?null:H((de[1]||"0")+"."+(de[2]||"0")+"."+(de[3]||"0"))}}).call(this,i(1))},function(j,e){var i,s,y=j.exports={};function k(){throw new Error("setTimeout has not been defined")}function A(){throw new Error("clearTimeout has not been defined")}function R(E){if(i===setTimeout)return setTimeout(E,0);if((i===k||!i)&&setTimeout)return i=setTimeout,setTimeout(E,0);try{return i(E,0)}catch{try{return i.call(null,E,0)}catch{return i.call(this,E,0)}}}(function(){try{i=typeof setTimeout=="function"?setTimeout:k}catch{i=k}try{s=typeof clearTimeout=="function"?clearTimeout:A}catch{s=A}})();var S,c=[],m=!1,u=-1;function p(){m&&S&&(m=!1,S.length?c=S.concat(c):u=-1,c.length&&v())}function v(){if(!m){var E=R(p);m=!0;for(var b=c.length;b;){for(S=c,c=[];++u<b;)S&&S[u].run();u=-1,b=c.length}S=null,m=!1,function(g){if(s===clearTimeout)return clearTimeout(g);if((s===A||!s)&&clearTimeout)return s=clearTimeout,clearTimeout(g);try{s(g)}catch{try{return s.call(null,g)}catch{return s.call(this,g)}}}(E)}}function f(E,b){this.fun=E,this.array=b}function h(){}y.nextTick=function(E){var b=new Array(arguments.length-1);if(arguments.length>1)for(var g=1;g<arguments.length;g++)b[g-1]=arguments[g];c.push(new f(E,b)),c.length!==1||m||R(v)},f.prototype.run=function(){this.fun.apply(null,this.array)},y.title="browser",y.browser=!0,y.env={},y.argv=[],y.version="",y.versions={},y.on=h,y.addListener=h,y.once=h,y.off=h,y.removeListener=h,y.removeAllListeners=h,y.emit=h,y.prependListener=h,y.prependOnceListener=h,y.listeners=function(E){return[]},y.binding=function(E){throw new Error("process.binding is not supported")},y.cwd=function(){return"/"},y.chdir=function(E){throw new Error("process.chdir is not supported")},y.umask=function(){return 0}}])}),define(le[148],ue([0,1]),function(j,e){"use strict";var i;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class s{constructor(R,S,c){this.level=R,this.key=S,this.value=c,this.forward=[]}}const y=void 0;class k{constructor(R,S=2**16){this.comparator=R,this[i]="SkipList",this._level=0,this._size=0,this._maxLevel=Math.max(1,Math.log2(S)|0),this._header=new s(this._maxLevel,y,y)}get size(){return this._size}clear(){this._header=new s(this._maxLevel,y,y),this._size=0}has(R){return!!k._search(this,R,this.comparator)}get(R){return k._search(this,R,this.comparator)?.value}set(R,S){return k._insert(this,R,S,this.comparator)&&(this._size+=1),this}delete(R){const S=k._delete(this,R,this.comparator);return S&&(this._size-=1),S}forEach(R,S){let c=this._header.forward[0];for(;c;)R.call(S,c.value,c.key,this),c=c.forward[0]}[(i=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let R=this._header.forward[0];for(;R;)yield[R.key,R.value],R=R.forward[0]}*keys(){let R=this._header.forward[0];for(;R;)yield R.key,R=R.forward[0]}*values(){let R=this._header.forward[0];for(;R;)yield R.value,R=R.forward[0]}toString(){let R="[SkipList]:",S=this._header.forward[0];for(;S;)R+=`node(${S.key}, ${S.value}, lvl:${S.level})`,S=S.forward[0];return R}static _search(R,S,c){let m=R._header;for(let u=R._level-1;u>=0;u--)for(;m.forward[u]&&c(m.forward[u].key,S)<0;)m=m.forward[u];if(m=m.forward[0],m&&c(m.key,S)===0)return m}static _insert(R,S,c,m){const u=[];let p=R._header;for(let v=R._level-1;v>=0;v--){for(;p.forward[v]&&m(p.forward[v].key,S)<0;)p=p.forward[v];u[v]=p}if(p=p.forward[0],p&&m(p.key,S)===0)return p.value=c,!1;{const v=k._randomLevel(R);if(v>R._level){for(let f=R._level;f<v;f++)u[f]=R._header;R._level=v}p=new s(v,S,c);for(let f=0;f<v;f++)p.forward[f]=u[f].forward[f],u[f].forward[f]=p;return!0}}static _randomLevel(R,S=.5){let c=1;for(;Math.random()<S&&c<R._maxLevel;)c+=1;return c}static _delete(R,S,c){const m=[];let u=R._header;for(let p=R._level-1;p>=0;p--){for(;u.forward[p]&&c(u.forward[p].key,S)<0;)u=u.forward[p];m[p]=u}if(u=u.forward[0],!u||c(u.key,S)!==0)return!1;for(let p=0;p<R._level&&m[p].forward[p]===u;p++)m[p].forward[p]=u.forward[p];for(;R._level>0&&R._header.forward[R._level-1]===y;)R._level-=1;return!0}}e.SkipList=k}),define(le[60],ue([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const i=globalThis.performance&&typeof globalThis.performance.now=="function";class s{static create(k){return new s(k)}constructor(k){this._now=i&&k===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this._startTime=this._now(),this._stopTime=-1}stop(){this._stopTime=this._now()}reset(){this._startTime=this._now(),this._stopTime=-1}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}}e.StopWatch=s}),define(le[4],ue([0,1,15,91,2,111,60]),function(j,e,i,s,y,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ValueWithChangeEvent=e.Relay=e.EventBufferer=e.DynamicListEventMultiplexer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.createEventDeliveryQueue=e.Emitter=e.ListenerRefusalError=e.ListenerLeakError=e.EventProfiling=e.Event=void 0,e.setGlobalLeakWarningThreshold=v;const R=!1,S=!1,c=!1;var m;(function(z){z.None=()=>y.Disposable.None;function Q(Ce){if(c){const{onDidAddListener:me}=Ce,Y=h.create();let de=0;Ce.onDidAddListener=()=>{++de===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),Y.print()),me?.()}}}function fe(Ce,me){return ce(Ce,()=>{},0,void 0,!0,void 0,me)}z.defer=fe;function se(Ce){return(me,Y=null,de)=>{let he=!1,ve;return ve=Ce(Ee=>{if(!he)return ve?ve.dispose():he=!0,me.call(Y,Ee)},null,de),he&&ve.dispose(),ve}}z.once=se;function ee(Ce,me){return z.once(z.filter(Ce,me))}z.onceIf=ee;function U(Ce,me,Y){return ie((de,he=null,ve)=>Ce(Ee=>de.call(he,me(Ee)),null,ve),Y)}z.map=U;function K(Ce,me,Y){return ie((de,he=null,ve)=>Ce(Ee=>{me(Ee),de.call(he,Ee)},null,ve),Y)}z.forEach=K;function N(Ce,me,Y){return ie((de,he=null,ve)=>Ce(Ee=>me(Ee)&&de.call(he,Ee),null,ve),Y)}z.filter=N;function x(Ce){return Ce}z.signal=x;function W(...Ce){return(me,Y=null,de)=>{const he=(0,y.combinedDisposable)(...Ce.map(ve=>ve(Ee=>me.call(Y,Ee))));return H(he,de)}}z.any=W;function q(Ce,me,Y,de){let he=Y;return U(Ce,ve=>(he=me(he,ve),he),de)}z.reduce=q;function ie(Ce,me){let Y;const de={onWillAddFirstListener(){Y=Ce(he.fire,he)},onDidRemoveLastListener(){Y?.dispose()}};me||Q(de);const he=new t(de);return me?.add(he),he.event}function H(Ce,me){return me instanceof Array?me.push(Ce):me&&me.add(Ce),Ce}function ce(Ce,me,Y=100,de=!1,he=!1,ve,Ee){let Oe,Ae,Me,Ue=0,Ge;const Je={leakWarningThreshold:ve,onWillAddFirstListener(){Oe=Ce(Xe=>{Ue++,Ae=me(Ae,Xe),de&&!Me&&(ze.fire(Ae),Ae=void 0),Ge=()=>{const Qe=Ae;Ae=void 0,Me=void 0,(!de||Ue>1)&&ze.fire(Qe),Ue=0},typeof Y=="number"?(clearTimeout(Me),Me=setTimeout(Ge,Y)):Me===void 0&&(Me=0,queueMicrotask(Ge))})},onWillRemoveListener(){he&&Ue>0&&Ge?.()},onDidRemoveLastListener(){Ge=void 0,Oe.dispose()}};Ee||Q(Je);const ze=new t(Je);return Ee?.add(ze),ze.event}z.debounce=ce;function oe(Ce,me=0,Y){return z.debounce(Ce,(de,he)=>de?(de.push(he),de):[he],me,void 0,!0,void 0,Y)}z.accumulate=oe;function te(Ce,me=(de,he)=>de===he,Y){let de=!0,he;return N(Ce,ve=>{const Ee=de||!me(ve,he);return de=!1,he=ve,Ee},Y)}z.latch=te;function O(Ce,me,Y){return[z.filter(Ce,me,Y),z.filter(Ce,de=>!me(de),Y)]}z.split=O;function X(Ce,me=!1,Y=[],de){let he=Y.slice(),ve=Ce(Ae=>{he?he.push(Ae):Oe.fire(Ae)});de&&de.add(ve);const Ee=()=>{he?.forEach(Ae=>Oe.fire(Ae)),he=null},Oe=new t({onWillAddFirstListener(){ve||(ve=Ce(Ae=>Oe.fire(Ae)),de&&de.add(ve))},onDidAddFirstListener(){he&&(me?setTimeout(Ee):Ee())},onDidRemoveLastListener(){ve&&ve.dispose(),ve=null}});return de&&de.add(Oe),Oe.event}z.buffer=X;function B(Ce,me){return(de,he,ve)=>{const Ee=me(new J);return Ce(function(Oe){const Ae=Ee.evaluate(Oe);Ae!==F&&de.call(he,Ae)},void 0,ve)}}z.chain=B;const F=Symbol("HaltChainable");class J{constructor(){this.steps=[]}map(me){return this.steps.push(me),this}forEach(me){return this.steps.push(Y=>(me(Y),Y)),this}filter(me){return this.steps.push(Y=>me(Y)?Y:F),this}reduce(me,Y){let de=Y;return this.steps.push(he=>(de=me(de,he),de)),this}latch(me=(Y,de)=>Y===de){let Y=!0,de;return this.steps.push(he=>{const ve=Y||!me(he,de);return Y=!1,de=he,ve?he:F}),this}evaluate(me){for(const Y of this.steps)if(me=Y(me),me===F)break;return me}}function G(Ce,me,Y=de=>de){const de=(...Oe)=>Ee.fire(Y(...Oe)),he=()=>Ce.on(me,de),ve=()=>Ce.removeListener(me,de),Ee=new t({onWillAddFirstListener:he,onDidRemoveLastListener:ve});return Ee.event}z.fromNodeEventEmitter=G;function $(Ce,me,Y=de=>de){const de=(...Oe)=>Ee.fire(Y(...Oe)),he=()=>Ce.addEventListener(me,de),ve=()=>Ce.removeEventListener(me,de),Ee=new t({onWillAddFirstListener:he,onDidRemoveLastListener:ve});return Ee.event}z.fromDOMEventEmitter=$;function Z(Ce){return new Promise(me=>se(Ce)(me))}z.toPromise=Z;function ae(Ce){const me=new t;return Ce.then(Y=>{me.fire(Y)},()=>{me.fire(void 0)}).finally(()=>{me.dispose()}),me.event}z.fromPromise=ae;function pe(Ce,me){return Ce(Y=>me.fire(Y))}z.forward=pe;function Se(Ce,me,Y){return me(Y),Ce(de=>me(de))}z.runAndSubscribe=Se;class ye{constructor(me,Y){this._observable=me,this._counter=0,this._hasChanged=!1;const de={onWillAddFirstListener:()=>{me.addObserver(this),this._observable.reportChanges()},onDidRemoveLastListener:()=>{me.removeObserver(this)}};Y||Q(de),this.emitter=new t(de),Y&&Y.add(this.emitter)}beginUpdate(me){this._counter++}handlePossibleChange(me){}handleChange(me,Y){this._hasChanged=!0}endUpdate(me){this._counter--,this._counter===0&&(this._observable.reportChanges(),this._hasChanged&&(this._hasChanged=!1,this.emitter.fire(this._observable.get())))}}function We(Ce,me){return new ye(Ce,me).emitter.event}z.fromObservable=We;function He(Ce){return(me,Y,de)=>{let he=0,ve=!1;const Ee={beginUpdate(){he++},endUpdate(){he--,he===0&&(Ce.reportChanges(),ve&&(ve=!1,me.call(Y)))},handlePossibleChange(){},handleChange(){ve=!0}};Ce.addObserver(Ee),Ce.reportChanges();const Oe={dispose(){Ce.removeObserver(Ee)}};return de instanceof y.DisposableStore?de.add(Oe):Array.isArray(de)&&de.push(Oe),Oe}}z.fromObservableLight=He})(m||(e.Event=m={}));class u{static{this.all=new Set}static{this._idPool=0}constructor(Q){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${Q}_${u._idPool++}`,u.all.add(this)}start(Q){this._stopWatch=new A.StopWatch,this.listenerCount=Q}stop(){if(this._stopWatch){const Q=this._stopWatch.elapsed();this.durations.push(Q),this.elapsedOverall+=Q,this.invocationCount+=1,this._stopWatch=void 0}}}e.EventProfiling=u;let p=-1;function v(z){const Q=p;return p=z,{dispose(){p=Q}}}class f{static{this._idPool=1}constructor(Q,fe,se=(f._idPool++).toString(16).padStart(3,"0")){this._errorHandler=Q,this.threshold=fe,this.name=se,this._warnCountdown=0}dispose(){this._stacks?.clear()}check(Q,fe){const se=this.threshold;if(se<=0||fe<se)return;this._stacks||(this._stacks=new Map);const ee=this._stacks.get(Q.value)||0;if(this._stacks.set(Q.value,ee+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=se*.5;const[U,K]=this.getMostFrequentStack(),N=`[${this.name}] potential listener LEAK detected, having ${fe} listeners already. MOST frequent listener (${K}):`;console.warn(N),console.warn(U);const x=new E(N,U);this._errorHandler(x)}return()=>{const U=this._stacks.get(Q.value)||0;this._stacks.set(Q.value,U-1)}}getMostFrequentStack(){if(!this._stacks)return;let Q,fe=0;for(const[se,ee]of this._stacks)(!Q||fe<ee)&&(Q=[se,ee],fe=ee);return Q}}class h{static create(){const Q=new Error;return new h(Q.stack??"")}constructor(Q){this.value=Q}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class E extends Error{constructor(Q,fe){super(Q),this.name="ListenerLeakError",this.stack=fe}}e.ListenerLeakError=E;class b extends Error{constructor(Q,fe){super(Q),this.name="ListenerRefusalError",this.stack=fe}}e.ListenerRefusalError=b;let g=0;class I{constructor(Q){this.value=Q,this.id=g++}}const P=2,r=(z,Q)=>{if(z instanceof I)Q(z);else for(let fe=0;fe<z.length;fe++){const se=z[fe];se&&Q(se)}};let a;if(R){const z=[];setInterval(()=>{z.length!==0&&(console.warn("[LEAKING LISTENERS] GC'ed these listeners that were NOT yet disposed:"),console.warn(z.join(`
`)),z.length=0)},3e3),a=new FinalizationRegistry(Q=>{typeof Q=="string"&&z.push(Q)})}class t{constructor(Q){this._size=0,this._options=Q,this._leakageMon=p>0||this._options?.leakWarningThreshold?new f(Q?.onListenerError??i.onUnexpectedError,this._options?.leakWarningThreshold??p):void 0,this._perfMon=this._options?._profName?new u(this._options._profName):void 0,this._deliveryQueue=this._options?.deliveryQueue}dispose(){if(!this._disposed){if(this._disposed=!0,this._deliveryQueue?.current===this&&this._deliveryQueue.reset(),this._listeners){if(S){const Q=this._listeners;queueMicrotask(()=>{r(Q,fe=>fe.stack?.print())})}this._listeners=void 0,this._size=0}this._options?.onDidRemoveLastListener?.(),this._leakageMon?.dispose()}}get event(){return this._event??=(Q,fe,se)=>{if(this._leakageMon&&this._size>this._leakageMon.threshold**2){const x=`[${this._leakageMon.name}] REFUSES to accept new listeners because it exceeded its threshold by far (${this._size} vs ${this._leakageMon.threshold})`;console.warn(x);const W=this._leakageMon.getMostFrequentStack()??["UNKNOWN stack",-1],q=new b(`${x}. HINT: Stack shows most frequent listener (${W[1]}-times)`,W[0]);return(this._options?.onListenerError||i.onUnexpectedError)(q),y.Disposable.None}if(this._disposed)return y.Disposable.None;fe&&(Q=Q.bind(fe));const ee=new I(Q);let U,K;this._leakageMon&&this._size>=Math.ceil(this._leakageMon.threshold*.2)&&(ee.stack=h.create(),U=this._leakageMon.check(ee.stack,this._size+1)),S&&(ee.stack=K??h.create()),this._listeners?this._listeners instanceof I?(this._deliveryQueue??=new n,this._listeners=[this._listeners,ee]):this._listeners.push(ee):(this._options?.onWillAddFirstListener?.(this),this._listeners=ee,this._options?.onDidAddFirstListener?.(this)),this._size++;const N=(0,y.toDisposable)(()=>{a?.unregister(N),U?.(),this._removeListener(ee)});if(se instanceof y.DisposableStore?se.add(N):Array.isArray(se)&&se.push(N),a){const x=new Error().stack.split(`
`).slice(2,3).join(`
`).trim(),W=/(file:|vscode-file:\/\/vscode-app)?(\/[^:]*:\d+:\d+)/.exec(x);a.register(N,W?.[2]??x,N)}return N},this._event}_removeListener(Q){if(this._options?.onWillRemoveListener?.(this),!this._listeners)return;if(this._size===1){this._listeners=void 0,this._options?.onDidRemoveLastListener?.(this),this._size=0;return}const fe=this._listeners,se=fe.indexOf(Q);if(se===-1)throw console.log("disposed?",this._disposed),console.log("size?",this._size),console.log("arr?",JSON.stringify(this._listeners)),new Error("Attempted to dispose unknown listener");this._size--,fe[se]=void 0;const ee=this._deliveryQueue.current===this;if(this._size*P<=fe.length){let U=0;for(let K=0;K<fe.length;K++)fe[K]?fe[U++]=fe[K]:ee&&(this._deliveryQueue.end--,U<this._deliveryQueue.i&&this._deliveryQueue.i--);fe.length=U}}_deliver(Q,fe){if(!Q)return;const se=this._options?.onListenerError||i.onUnexpectedError;if(!se){Q.value(fe);return}try{Q.value(fe)}catch(ee){se(ee)}}_deliverQueue(Q){const fe=Q.current._listeners;for(;Q.i<Q.end;)this._deliver(fe[Q.i++],Q.value);Q.reset()}fire(Q){if(this._deliveryQueue?.current&&(this._deliverQueue(this._deliveryQueue),this._perfMon?.stop()),this._perfMon?.start(this._size),this._listeners)if(this._listeners instanceof I)this._deliver(this._listeners,Q);else{const fe=this._deliveryQueue;fe.enqueue(this,Q,this._listeners.length),this._deliverQueue(fe)}this._perfMon?.stop()}hasListeners(){return this._size>0}}e.Emitter=t;const o=()=>new n;e.createEventDeliveryQueue=o;class n{constructor(){this.i=-1,this.end=0}enqueue(Q,fe,se){this.i=0,this.end=se,this.current=Q,this.value=fe}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class l extends t{async fireAsync(Q,fe,se){if(this._listeners)for(this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new k.LinkedList),r(this._listeners,ee=>this._asyncDeliveryQueue.push([ee.value,Q]));this._asyncDeliveryQueue.size>0&&!fe.isCancellationRequested;){const[ee,U]=this._asyncDeliveryQueue.shift(),K=[],N={...U,token:fe,waitUntil:x=>{if(Object.isFrozen(K))throw new Error("waitUntil can NOT be called asynchronous");se&&(x=se(x,ee)),K.push(x)}};try{ee(N)}catch(x){(0,i.onUnexpectedError)(x);continue}Object.freeze(K),await Promise.allSettled(K).then(x=>{for(const W of x)W.status==="rejected"&&(0,i.onUnexpectedError)(W.reason)})}}}e.AsyncEmitter=l;class d extends t{get isPaused(){return this._isPaused!==0}constructor(Q){super(Q),this._isPaused=0,this._eventQueue=new k.LinkedList,this._mergeFn=Q?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused===0)if(this._mergeFn){if(this._eventQueue.size>0){const Q=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(Q))}}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(Q){this._size&&(this._isPaused!==0?this._eventQueue.push(Q):super.fire(Q))}}e.PauseableEmitter=d;class D extends d{constructor(Q){super(Q),this._delay=Q.delay??100}fire(Q){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(Q)}}e.DebounceEmitter=D;class w extends t{constructor(Q){super(Q),this._queuedEvents=[],this._mergeFn=Q?.merge}fire(Q){this.hasListeners()&&(this._queuedEvents.push(Q),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(fe=>super.fire(fe)),this._queuedEvents=[]}))}}e.MicrotaskEmitter=w;class M{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new t({onWillAddFirstListener:()=>this.onFirstListenerAdd(),onDidRemoveLastListener:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(Q){const fe={event:Q,listener:null};this.events.push(fe),this.hasListeners&&this.hook(fe);const se=()=>{this.hasListeners&&this.unhook(fe);const ee=this.events.indexOf(fe);this.events.splice(ee,1)};return(0,y.toDisposable)((0,s.createSingleCallFunction)(se))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(Q=>this.hook(Q))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(Q=>this.unhook(Q))}hook(Q){Q.listener=Q.event(fe=>this.emitter.fire(fe))}unhook(Q){Q.listener?.dispose(),Q.listener=null}dispose(){this.emitter.dispose();for(const Q of this.events)Q.listener?.dispose();this.events=[]}}e.EventMultiplexer=M;class T{constructor(Q,fe,se,ee){this._store=new y.DisposableStore;const U=this._store.add(new M),K=this._store.add(new y.DisposableMap);function N(x){K.set(x,U.add(ee(x)))}for(const x of Q)N(x);this._store.add(fe(x=>{N(x)})),this._store.add(se(x=>{K.deleteAndDispose(x)})),this.event=U.event}dispose(){this._store.dispose()}}e.DynamicListEventMultiplexer=T;class C{constructor(){this.data=[]}wrapEvent(Q,fe,se){return(ee,U,K)=>Q(N=>{const x=this.data[this.data.length-1];if(!fe){x?x.buffers.push(()=>ee.call(U,N)):ee.call(U,N);return}const W=x;if(!W){ee.call(U,fe(se,N));return}W.items??=[],W.items.push(N),W.buffers.length===0&&x.buffers.push(()=>{W.reducedResult??=se?W.items.reduce(fe,se):W.items.reduce(fe),ee.call(U,W.reducedResult)})},void 0,K)}bufferEvents(Q){const fe={buffers:new Array};this.data.push(fe);const se=Q();return this.data.pop(),fe.buffers.forEach(ee=>ee()),se}}e.EventBufferer=C;class L{constructor(){this.listening=!1,this.inputEvent=m.None,this.inputEventListener=y.Disposable.None,this.emitter=new t({onDidAddFirstListener:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onDidRemoveLastListener:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(Q){this.inputEvent=Q,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=Q(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=L;class _{static const(Q){return new V(Q)}constructor(Q){this._value=Q,this._onDidChange=new t,this.onDidChange=this._onDidChange.event}get value(){return this._value}set value(Q){Q!==this._value&&(this._value=Q,this._onDidChange.fire(void 0))}}e.ValueWithChangeEvent=_;class V{constructor(Q){this.value=Q,this.onDidChange=m.None}}}),define(le[22],ue([0,1,4]),function(j,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0,e.cancelOnDispose=R;const s=Object.freeze(function(S,c){const m=setTimeout(S.bind(c),0);return{dispose(){clearTimeout(m)}}});var y;(function(S){function c(m){return m===S.None||m===S.Cancelled||m instanceof k?!0:!m||typeof m!="object"?!1:typeof m.isCancellationRequested=="boolean"&&typeof m.onCancellationRequested=="function"}S.isCancellationToken=c,S.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:i.Event.None}),S.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:s})})(y||(e.CancellationToken=y={}));class k{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?s:(this._emitter||(this._emitter=new i.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class A{constructor(c){this._token=void 0,this._parentListener=void 0,this._parentListener=c&&c.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new k),this._token}cancel(){this._token?this._token instanceof k&&this._token.cancel():this._token=y.Cancelled}dispose(c=!1){c&&this.cancel(),this._parentListener?.dispose(),this._token?this._token instanceof k&&this._token.dispose():this._token=y.None}}e.CancellationTokenSource=A;function R(S){const c=new A;return S.add({dispose(){c.cancel()}}),c.token}}),define(le[149],ue([0,1,22]),function(j,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0,e.identity=y;class s{constructor(S){this.task=S,this.result=null}get(){if(this.result)return this.result;const S=new i.CancellationTokenSource,c=this.task(S.token);return this.result={promise:c,dispose:()=>{this.result=null,S.cancel(),S.dispose()}},this.result}}e.Cache=s;function y(R){return R}class k{constructor(S,c){this.lastCache=void 0,this.lastArgKey=void 0,typeof S=="function"?(this._fn=S,this._computeKey=y):(this._fn=c,this._computeKey=S.getCacheKey)}get(S){const c=this._computeKey(S);return this.lastArgKey!==c&&(this.lastArgKey=c,this.lastCache=this._fn(S)),this.lastCache}}e.LRUCachedFunction=k;class A{get cachedValues(){return this._map}constructor(S,c){this._map=new Map,this._map2=new Map,typeof S=="function"?(this._fn=S,this._computeKey=y):(this._fn=c,this._computeKey=S.getCacheKey)}get(S){const c=this._computeKey(S);if(this._map2.has(c))return this._map2.get(c);const m=this._fn(S);return this._map.set(S,m),this._map2.set(c,m),m}}e.CachedFunction=A}),define(le[68],ue([0,1,15,2]),function(j,e,i,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isReadable=y,e.isReadableStream=k,e.isReadableBufferedStream=A,e.newWriteableStream=R,e.consumeReadable=c,e.peekReadable=m,e.consumeStream=u,e.listenStream=p,e.peekStream=v,e.toStream=f,e.emptyStream=h,e.toReadable=E,e.transform=b,e.prefixedReadable=g,e.prefixedStream=I;function y(P){const r=P;return r?typeof r.read=="function":!1}function k(P){const r=P;return r?[r.on,r.pause,r.resume,r.destroy].every(a=>typeof a=="function"):!1}function A(P){const r=P;return r?k(r.stream)&&Array.isArray(r.buffer)&&typeof r.ended=="boolean":!1}function R(P,r){return new S(P,r)}class S{constructor(r,a){this.reducer=r,this.options=a,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(r){if(!this.state.destroyed){if(this.state.flowing)this.emitData(r);else if(this.buffer.data.push(r),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(a=>this.pendingWritePromises.push(a))}}error(r){this.state.destroyed||(this.state.flowing?this.emitError(r):this.buffer.error.push(r))}end(r){this.state.destroyed||(typeof r<"u"&&this.write(r),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(r){this.listeners.data.slice(0).forEach(a=>a(r))}emitError(r){this.listeners.error.length===0?(0,i.onUnexpectedError)(r):this.listeners.error.slice(0).forEach(a=>a(r))}emitEnd(){this.listeners.end.slice(0).forEach(r=>r())}on(r,a){if(!this.state.destroyed)switch(r){case"data":this.listeners.data.push(a),this.resume();break;case"end":this.listeners.end.push(a),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(a),this.state.flowing&&this.flowErrors();break}}removeListener(r,a){if(this.state.destroyed)return;let t;switch(r){case"data":t=this.listeners.data;break;case"end":t=this.listeners.end;break;case"error":t=this.listeners.error;break}if(t){const o=t.indexOf(a);o>=0&&t.splice(o,1)}}flowData(){if(this.buffer.data.length>0){const r=this.reducer(this.buffer.data);this.emitData(r),this.buffer.data.length=0;const a=[...this.pendingWritePromises];this.pendingWritePromises.length=0,a.forEach(t=>t())}}flowErrors(){if(this.listeners.error.length>0){for(const r of this.buffer.error)this.emitError(r);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function c(P,r){const a=[];let t;for(;(t=P.read())!==null;)a.push(t);return r(a)}function m(P,r,a){const t=[];let o;for(;(o=P.read())!==null&&t.length<a;)t.push(o);return o===null&&t.length>0?r(t):{read:()=>{if(t.length>0)return t.shift();if(typeof o<"u"){const n=o;return o=void 0,n}return P.read()}}}function u(P,r){return new Promise((a,t)=>{const o=[];p(P,{onData:n=>{r&&o.push(n)},onError:n=>{r?t(n):a(void 0)},onEnd:()=>{a(r?r(o):void 0)}})})}function p(P,r,a){P.on("error",t=>{a?.isCancellationRequested||r.onError(t)}),P.on("end",()=>{a?.isCancellationRequested||r.onEnd()}),P.on("data",t=>{a?.isCancellationRequested||r.onData(t)})}function v(P,r){return new Promise((a,t)=>{const o=new s.DisposableStore,n=[],l=w=>{if(n.push(w),n.length>r)return o.dispose(),P.pause(),a({stream:P,buffer:n,ended:!1})},d=w=>(o.dispose(),t(w)),D=()=>(o.dispose(),a({stream:P,buffer:n,ended:!0}));o.add((0,s.toDisposable)(()=>P.removeListener("error",d))),P.on("error",d),o.add((0,s.toDisposable)(()=>P.removeListener("end",D))),P.on("end",D),o.add((0,s.toDisposable)(()=>P.removeListener("data",l))),P.on("data",l)})}function f(P,r){const a=R(r);return a.end(P),a}function h(){const P=R(()=>{throw new Error("not supported")});return P.end(),P}function E(P){let r=!1;return{read:()=>r?null:(r=!0,P)}}function b(P,r,a){const t=R(a);return p(P,{onData:o=>t.write(r.data(o)),onError:o=>t.error(r.error?r.error(o):o),onEnd:()=>t.end()}),t}function g(P,r,a){let t=!1;return{read:()=>{const o=r.read();return t?o:(t=!0,o!==null?a([P,o]):P)}}}function I(P,r,a){let t=!1;const o=R(a);return p(r,{onData:n=>t?o.write(n):(t=!0,o.write(a([P,n]))),onError:n=>o.error(n),onEnd:()=>{t||(t=!0,o.write(P)),o.end()}}),o}});var Ct=this&&this.__createBinding||(Object.create?function(j,e,i,s){s===void 0&&(s=i);var y=Object.getOwnPropertyDescriptor(e,i);(!y||("get"in y?!e.__esModule:y.writable||y.configurable))&&(y={enumerable:!0,get:function(){return e[i]}}),Object.defineProperty(j,s,y)}:function(j,e,i,s){s===void 0&&(s=i),j[s]=e[i]}),At=this&&this.__setModuleDefault||(Object.create?function(j,e){Object.defineProperty(j,"default",{enumerable:!0,value:e})}:function(j,e){j.default=e}),Re=this&&this.__importStar||function(j){if(j&&j.__esModule)return j;var e={};if(j!=null)for(var i in j)i!=="default"&&Object.prototype.hasOwnProperty.call(j,i)&&Ct(e,j,i);return At(e,j),e};define(le[17],ue([0,1,67,68]),function(j,e,i,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.VSBuffer=void 0,e.binaryIndexOf=c,e.readUInt16LE=m,e.writeUInt16LE=u,e.readUInt32BE=p,e.writeUInt32BE=v,e.readUInt32LE=f,e.writeUInt32LE=h,e.readUInt8=E,e.writeUInt8=b,e.readableToBuffer=g,e.bufferToReadable=I,e.streamToBuffer=P,e.bufferedStreamToBuffer=r,e.bufferToStream=a,e.streamToBufferReadableStream=t,e.newWriteableBufferStream=o,e.prefixedBufferReadable=n,e.prefixedBufferStream=l,e.decodeBase64=d,e.encodeBase64=M,s=Re(s);const y=typeof Buffer<"u",k=new i.Lazy(()=>new Uint8Array(256));let A,R;class S{static alloc(C){return y?new S(Buffer.allocUnsafe(C)):new S(new Uint8Array(C))}static wrap(C){return y&&!Buffer.isBuffer(C)&&(C=Buffer.from(C.buffer,C.byteOffset,C.byteLength)),new S(C)}static fromString(C,L){return!(L?.dontUseNodeBuffer||!1)&&y?new S(Buffer.from(C)):(A||(A=new TextEncoder),new S(A.encode(C)))}static fromByteArray(C){const L=S.alloc(C.length);for(let _=0,V=C.length;_<V;_++)L.buffer[_]=C[_];return L}static concat(C,L){if(typeof L>"u"){L=0;for(let z=0,Q=C.length;z<Q;z++)L+=C[z].byteLength}const _=S.alloc(L);let V=0;for(let z=0,Q=C.length;z<Q;z++){const fe=C[z];_.set(fe,V),V+=fe.byteLength}return _}constructor(C){this.buffer=C,this.byteLength=this.buffer.byteLength}clone(){const C=S.alloc(this.byteLength);return C.set(this),C}toString(){return y?this.buffer.toString():(R||(R=new TextDecoder),R.decode(this.buffer))}slice(C,L){return new S(this.buffer.subarray(C,L))}set(C,L){if(C instanceof S)this.buffer.set(C.buffer,L);else if(C instanceof Uint8Array)this.buffer.set(C,L);else if(C instanceof ArrayBuffer)this.buffer.set(new Uint8Array(C),L);else if(ArrayBuffer.isView(C))this.buffer.set(new Uint8Array(C.buffer,C.byteOffset,C.byteLength),L);else throw new Error("Unknown argument 'array'")}readUInt32BE(C){return p(this.buffer,C)}writeUInt32BE(C,L){v(this.buffer,C,L)}readUInt32LE(C){return f(this.buffer,C)}writeUInt32LE(C,L){h(this.buffer,C,L)}readUInt8(C){return E(this.buffer,C)}writeUInt8(C,L){b(this.buffer,C,L)}indexOf(C,L=0){return c(this.buffer,C instanceof S?C.buffer:C,L)}}e.VSBuffer=S;function c(T,C,L=0){const _=C.byteLength,V=T.byteLength;if(_===0)return 0;if(_===1)return T.indexOf(C[0]);if(_>V-L)return-1;const z=k.value;z.fill(C.length);for(let ee=0;ee<C.length;ee++)z[C[ee]]=C.length-ee-1;let Q=L+C.length-1,fe=Q,se=-1;for(;Q<V;)if(T[Q]===C[fe]){if(fe===0){se=Q;break}Q--,fe--}else Q+=Math.max(C.length-fe,z[T[Q]]),fe=C.length-1;return se}function m(T,C){return T[C+0]<<0>>>0|T[C+1]<<8>>>0}function u(T,C,L){T[L+0]=C&255,C=C>>>8,T[L+1]=C&255}function p(T,C){return T[C]*2**24+T[C+1]*2**16+T[C+2]*2**8+T[C+3]}function v(T,C,L){T[L+3]=C,C=C>>>8,T[L+2]=C,C=C>>>8,T[L+1]=C,C=C>>>8,T[L]=C}function f(T,C){return T[C+0]<<0>>>0|T[C+1]<<8>>>0|T[C+2]<<16>>>0|T[C+3]<<24>>>0}function h(T,C,L){T[L+0]=C&255,C=C>>>8,T[L+1]=C&255,C=C>>>8,T[L+2]=C&255,C=C>>>8,T[L+3]=C&255}function E(T,C){return T[C]}function b(T,C,L){T[L]=C}function g(T){return s.consumeReadable(T,C=>S.concat(C))}function I(T){return s.toReadable(T)}function P(T){return s.consumeStream(T,C=>S.concat(C))}async function r(T){return T.ended?S.concat(T.buffer):S.concat([...T.buffer,await P(T.stream)])}function a(T){return s.toStream(T,C=>S.concat(C))}function t(T){return s.transform(T,{data:C=>typeof C=="string"?S.fromString(C):S.wrap(C)},C=>S.concat(C))}function o(T){return s.newWriteableStream(C=>S.concat(C),T)}function n(T,C){return s.prefixedReadable(T,C,L=>S.concat(L))}function l(T,C){return s.prefixedStream(T,C,L=>S.concat(L))}function d(T){let C=0,L=0,_=0;const V=new Uint8Array(Math.floor(T.length/4*3)),z=fe=>{switch(L){case 3:V[_++]=C|fe,L=0;break;case 2:V[_++]=C|fe>>>2,C=fe<<6,L=3;break;case 1:V[_++]=C|fe>>>4,C=fe<<4,L=2;break;default:C=fe<<2,L=1}};for(let fe=0;fe<T.length;fe++){const se=T.charCodeAt(fe);if(se>=65&&se<=90)z(se-65);else if(se>=97&&se<=122)z(se-97+26);else if(se>=48&&se<=57)z(se-48+52);else if(se===43||se===45)z(62);else if(se===47||se===95)z(63);else{if(se===61)break;throw new SyntaxError(`Unexpected base64 character ${T[fe]}`)}}const Q=_;for(;L>0;)z(0);return S.wrap(V).slice(0,Q)}const D="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",w="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function M({buffer:T},C=!0,L=!1){const _=L?w:D;let V="";const z=T.byteLength%3;let Q=0;for(;Q<T.byteLength-z;Q+=3){const fe=T[Q+0],se=T[Q+1],ee=T[Q+2];V+=_[fe>>>2],V+=_[(fe<<4|se>>>4)&63],V+=_[(se<<2|ee>>>6)&63],V+=_[ee&63]}if(z===1){const fe=T[Q+0];V+=_[fe>>>2],V+=_[fe<<4&63],C&&(V+="==")}else if(z===2){const fe=T[Q+0],se=T[Q+1];V+=_[fe>>>2],V+=_[(fe<<4|se>>>4)&63],V+=_[se<<2&63],C&&(V+="=")}return V}}),define(le[150],ue([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MicrotaskDelay=void 0,e.MicrotaskDelay=Symbol("MicrotaskDelay")}),define(le[12],ue([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isString=i,e.isStringArray=s,e.isObject=y,e.isTypedArray=k,e.isNumber=A,e.isIterable=R,e.isBoolean=S,e.isUndefined=c,e.isDefined=m,e.isUndefinedOrNull=u,e.assertType=p,e.assertIsDefined=v,e.assertAllDefined=f,e.isEmptyObject=E,e.isFunction=b,e.areFunctions=g,e.validateConstraints=I,e.validateConstraint=P,e.upcast=r;function i(a){return typeof a=="string"}function s(a){return Array.isArray(a)&&a.every(t=>i(t))}function y(a){return typeof a=="object"&&a!==null&&!Array.isArray(a)&&!(a instanceof RegExp)&&!(a instanceof Date)}function k(a){const t=Object.getPrototypeOf(Uint8Array);return typeof a=="object"&&a instanceof t}function A(a){return typeof a=="number"&&!isNaN(a)}function R(a){return!!a&&typeof a[Symbol.iterator]=="function"}function S(a){return a===!0||a===!1}function c(a){return typeof a>"u"}function m(a){return!u(a)}function u(a){return c(a)||a===null}function p(a,t){if(!a)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")}function v(a){if(u(a))throw new Error("Assertion Failed: argument is undefined or null");return a}function f(...a){const t=[];for(let o=0;o<a.length;o++){const n=a[o];if(u(n))throw new Error(`Assertion Failed: argument at index ${o} is undefined or null`);t.push(n)}return t}const h=Object.prototype.hasOwnProperty;function E(a){if(!y(a))return!1;for(const t in a)if(h.call(a,t))return!1;return!0}function b(a){return typeof a=="function"}function g(...a){return a.length>0&&a.every(b)}function I(a,t){const o=Math.min(a.length,t.length);for(let n=0;n<o;n++)P(a[n],t[n])}function P(a,t){if(i(t)){if(typeof a!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if(b(t)){try{if(a instanceof t)return}catch{}if(!u(a)&&a.constructor===t||t.length===1&&t.call(void 0,a)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}function r(a){return a}}),define(le[112],ue([0,1,12]),function(j,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.register=y,e.getCodiconFontCharacters=k;const s=Object.create(null);function y(A,R){if((0,i.isString)(R)){const S=s[R];if(S===void 0)throw new Error(`${A} references an unknown codicon: ${R}`);R=S}return s[A]=R,{id:A}}function k(){return s}}),define(le[151],ue([0,1,112]),function(j,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.codiconsLibrary=void 0,e.codiconsLibrary={add:(0,i.register)("add",6e4),plus:(0,i.register)("plus",6e4),gistNew:(0,i.register)("gist-new",6e4),repoCreate:(0,i.register)("repo-create",6e4),lightbulb:(0,i.register)("lightbulb",60001),lightBulb:(0,i.register)("light-bulb",60001),repo:(0,i.register)("repo",60002),repoDelete:(0,i.register)("repo-delete",60002),gistFork:(0,i.register)("gist-fork",60003),repoForked:(0,i.register)("repo-forked",60003),gitPullRequest:(0,i.register)("git-pull-request",60004),gitPullRequestAbandoned:(0,i.register)("git-pull-request-abandoned",60004),recordKeys:(0,i.register)("record-keys",60005),keyboard:(0,i.register)("keyboard",60005),tag:(0,i.register)("tag",60006),gitPullRequestLabel:(0,i.register)("git-pull-request-label",60006),tagAdd:(0,i.register)("tag-add",60006),tagRemove:(0,i.register)("tag-remove",60006),person:(0,i.register)("person",60007),personFollow:(0,i.register)("person-follow",60007),personOutline:(0,i.register)("person-outline",60007),personFilled:(0,i.register)("person-filled",60007),gitBranch:(0,i.register)("git-branch",60008),gitBranchCreate:(0,i.register)("git-branch-create",60008),gitBranchDelete:(0,i.register)("git-branch-delete",60008),sourceControl:(0,i.register)("source-control",60008),mirror:(0,i.register)("mirror",60009),mirrorPublic:(0,i.register)("mirror-public",60009),star:(0,i.register)("star",60010),starAdd:(0,i.register)("star-add",60010),starDelete:(0,i.register)("star-delete",60010),starEmpty:(0,i.register)("star-empty",60010),comment:(0,i.register)("comment",60011),commentAdd:(0,i.register)("comment-add",60011),alert:(0,i.register)("alert",60012),warning:(0,i.register)("warning",60012),search:(0,i.register)("search",60013),searchSave:(0,i.register)("search-save",60013),logOut:(0,i.register)("log-out",60014),signOut:(0,i.register)("sign-out",60014),logIn:(0,i.register)("log-in",60015),signIn:(0,i.register)("sign-in",60015),eye:(0,i.register)("eye",60016),eyeUnwatch:(0,i.register)("eye-unwatch",60016),eyeWatch:(0,i.register)("eye-watch",60016),circleFilled:(0,i.register)("circle-filled",60017),primitiveDot:(0,i.register)("primitive-dot",60017),closeDirty:(0,i.register)("close-dirty",60017),debugBreakpoint:(0,i.register)("debug-breakpoint",60017),debugBreakpointDisabled:(0,i.register)("debug-breakpoint-disabled",60017),debugHint:(0,i.register)("debug-hint",60017),terminalDecorationSuccess:(0,i.register)("terminal-decoration-success",60017),primitiveSquare:(0,i.register)("primitive-square",60018),edit:(0,i.register)("edit",60019),pencil:(0,i.register)("pencil",60019),info:(0,i.register)("info",60020),issueOpened:(0,i.register)("issue-opened",60020),gistPrivate:(0,i.register)("gist-private",60021),gitForkPrivate:(0,i.register)("git-fork-private",60021),lock:(0,i.register)("lock",60021),mirrorPrivate:(0,i.register)("mirror-private",60021),close:(0,i.register)("close",60022),removeClose:(0,i.register)("remove-close",60022),x:(0,i.register)("x",60022),repoSync:(0,i.register)("repo-sync",60023),sync:(0,i.register)("sync",60023),clone:(0,i.register)("clone",60024),desktopDownload:(0,i.register)("desktop-download",60024),beaker:(0,i.register)("beaker",60025),microscope:(0,i.register)("microscope",60025),vm:(0,i.register)("vm",60026),deviceDesktop:(0,i.register)("device-desktop",60026),file:(0,i.register)("file",60027),fileText:(0,i.register)("file-text",60027),more:(0,i.register)("more",60028),ellipsis:(0,i.register)("ellipsis",60028),kebabHorizontal:(0,i.register)("kebab-horizontal",60028),mailReply:(0,i.register)("mail-reply",60029),reply:(0,i.register)("reply",60029),organization:(0,i.register)("organization",60030),organizationFilled:(0,i.register)("organization-filled",60030),organizationOutline:(0,i.register)("organization-outline",60030),newFile:(0,i.register)("new-file",60031),fileAdd:(0,i.register)("file-add",60031),newFolder:(0,i.register)("new-folder",60032),fileDirectoryCreate:(0,i.register)("file-directory-create",60032),trash:(0,i.register)("trash",60033),trashcan:(0,i.register)("trashcan",60033),history:(0,i.register)("history",60034),clock:(0,i.register)("clock",60034),folder:(0,i.register)("folder",60035),fileDirectory:(0,i.register)("file-directory",60035),symbolFolder:(0,i.register)("symbol-folder",60035),logoGithub:(0,i.register)("logo-github",60036),markGithub:(0,i.register)("mark-github",60036),github:(0,i.register)("github",60036),terminal:(0,i.register)("terminal",60037),console:(0,i.register)("console",60037),repl:(0,i.register)("repl",60037),zap:(0,i.register)("zap",60038),symbolEvent:(0,i.register)("symbol-event",60038),error:(0,i.register)("error",60039),stop:(0,i.register)("stop",60039),variable:(0,i.register)("variable",60040),symbolVariable:(0,i.register)("symbol-variable",60040),array:(0,i.register)("array",60042),symbolArray:(0,i.register)("symbol-array",60042),symbolModule:(0,i.register)("symbol-module",60043),symbolPackage:(0,i.register)("symbol-package",60043),symbolNamespace:(0,i.register)("symbol-namespace",60043),symbolObject:(0,i.register)("symbol-object",60043),symbolMethod:(0,i.register)("symbol-method",60044),symbolFunction:(0,i.register)("symbol-function",60044),symbolConstructor:(0,i.register)("symbol-constructor",60044),symbolBoolean:(0,i.register)("symbol-boolean",60047),symbolNull:(0,i.register)("symbol-null",60047),symbolNumeric:(0,i.register)("symbol-numeric",60048),symbolNumber:(0,i.register)("symbol-number",60048),symbolStructure:(0,i.register)("symbol-structure",60049),symbolStruct:(0,i.register)("symbol-struct",60049),symbolParameter:(0,i.register)("symbol-parameter",60050),symbolTypeParameter:(0,i.register)("symbol-type-parameter",60050),symbolKey:(0,i.register)("symbol-key",60051),symbolText:(0,i.register)("symbol-text",60051),symbolReference:(0,i.register)("symbol-reference",60052),goToFile:(0,i.register)("go-to-file",60052),symbolEnum:(0,i.register)("symbol-enum",60053),symbolValue:(0,i.register)("symbol-value",60053),symbolRuler:(0,i.register)("symbol-ruler",60054),symbolUnit:(0,i.register)("symbol-unit",60054),activateBreakpoints:(0,i.register)("activate-breakpoints",60055),archive:(0,i.register)("archive",60056),arrowBoth:(0,i.register)("arrow-both",60057),arrowDown:(0,i.register)("arrow-down",60058),arrowLeft:(0,i.register)("arrow-left",60059),arrowRight:(0,i.register)("arrow-right",60060),arrowSmallDown:(0,i.register)("arrow-small-down",60061),arrowSmallLeft:(0,i.register)("arrow-small-left",60062),arrowSmallRight:(0,i.register)("arrow-small-right",60063),arrowSmallUp:(0,i.register)("arrow-small-up",60064),arrowUp:(0,i.register)("arrow-up",60065),bell:(0,i.register)("bell",60066),bold:(0,i.register)("bold",60067),book:(0,i.register)("book",60068),bookmark:(0,i.register)("bookmark",60069),debugBreakpointConditionalUnverified:(0,i.register)("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:(0,i.register)("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:(0,i.register)("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:(0,i.register)("debug-breakpoint-data-unverified",60072),debugBreakpointData:(0,i.register)("debug-breakpoint-data",60073),debugBreakpointDataDisabled:(0,i.register)("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:(0,i.register)("debug-breakpoint-log-unverified",60074),debugBreakpointLog:(0,i.register)("debug-breakpoint-log",60075),debugBreakpointLogDisabled:(0,i.register)("debug-breakpoint-log-disabled",60075),briefcase:(0,i.register)("briefcase",60076),broadcast:(0,i.register)("broadcast",60077),browser:(0,i.register)("browser",60078),bug:(0,i.register)("bug",60079),calendar:(0,i.register)("calendar",60080),caseSensitive:(0,i.register)("case-sensitive",60081),check:(0,i.register)("check",60082),checklist:(0,i.register)("checklist",60083),chevronDown:(0,i.register)("chevron-down",60084),chevronLeft:(0,i.register)("chevron-left",60085),chevronRight:(0,i.register)("chevron-right",60086),chevronUp:(0,i.register)("chevron-up",60087),chromeClose:(0,i.register)("chrome-close",60088),chromeMaximize:(0,i.register)("chrome-maximize",60089),chromeMinimize:(0,i.register)("chrome-minimize",60090),chromeRestore:(0,i.register)("chrome-restore",60091),circleOutline:(0,i.register)("circle-outline",60092),circle:(0,i.register)("circle",60092),debugBreakpointUnverified:(0,i.register)("debug-breakpoint-unverified",60092),terminalDecorationIncomplete:(0,i.register)("terminal-decoration-incomplete",60092),circleSlash:(0,i.register)("circle-slash",60093),circuitBoard:(0,i.register)("circuit-board",60094),clearAll:(0,i.register)("clear-all",60095),clippy:(0,i.register)("clippy",60096),closeAll:(0,i.register)("close-all",60097),cloudDownload:(0,i.register)("cloud-download",60098),cloudUpload:(0,i.register)("cloud-upload",60099),code:(0,i.register)("code",60100),collapseAll:(0,i.register)("collapse-all",60101),colorMode:(0,i.register)("color-mode",60102),commentDiscussion:(0,i.register)("comment-discussion",60103),creditCard:(0,i.register)("credit-card",60105),dash:(0,i.register)("dash",60108),dashboard:(0,i.register)("dashboard",60109),database:(0,i.register)("database",60110),debugContinue:(0,i.register)("debug-continue",60111),debugDisconnect:(0,i.register)("debug-disconnect",60112),debugPause:(0,i.register)("debug-pause",60113),debugRestart:(0,i.register)("debug-restart",60114),debugStart:(0,i.register)("debug-start",60115),debugStepInto:(0,i.register)("debug-step-into",60116),debugStepOut:(0,i.register)("debug-step-out",60117),debugStepOver:(0,i.register)("debug-step-over",60118),debugStop:(0,i.register)("debug-stop",60119),debug:(0,i.register)("debug",60120),deviceCameraVideo:(0,i.register)("device-camera-video",60121),deviceCamera:(0,i.register)("device-camera",60122),deviceMobile:(0,i.register)("device-mobile",60123),diffAdded:(0,i.register)("diff-added",60124),diffIgnored:(0,i.register)("diff-ignored",60125),diffModified:(0,i.register)("diff-modified",60126),diffRemoved:(0,i.register)("diff-removed",60127),diffRenamed:(0,i.register)("diff-renamed",60128),diff:(0,i.register)("diff",60129),diffSidebyside:(0,i.register)("diff-sidebyside",60129),discard:(0,i.register)("discard",60130),editorLayout:(0,i.register)("editor-layout",60131),emptyWindow:(0,i.register)("empty-window",60132),exclude:(0,i.register)("exclude",60133),extensions:(0,i.register)("extensions",60134),eyeClosed:(0,i.register)("eye-closed",60135),fileBinary:(0,i.register)("file-binary",60136),fileCode:(0,i.register)("file-code",60137),fileMedia:(0,i.register)("file-media",60138),filePdf:(0,i.register)("file-pdf",60139),fileSubmodule:(0,i.register)("file-submodule",60140),fileSymlinkDirectory:(0,i.register)("file-symlink-directory",60141),fileSymlinkFile:(0,i.register)("file-symlink-file",60142),fileZip:(0,i.register)("file-zip",60143),files:(0,i.register)("files",60144),filter:(0,i.register)("filter",60145),flame:(0,i.register)("flame",60146),foldDown:(0,i.register)("fold-down",60147),foldUp:(0,i.register)("fold-up",60148),fold:(0,i.register)("fold",60149),folderActive:(0,i.register)("folder-active",60150),folderOpened:(0,i.register)("folder-opened",60151),gear:(0,i.register)("gear",60152),gift:(0,i.register)("gift",60153),gistSecret:(0,i.register)("gist-secret",60154),gist:(0,i.register)("gist",60155),gitCommit:(0,i.register)("git-commit",60156),gitCompare:(0,i.register)("git-compare",60157),compareChanges:(0,i.register)("compare-changes",60157),gitMerge:(0,i.register)("git-merge",60158),githubAction:(0,i.register)("github-action",60159),githubAlt:(0,i.register)("github-alt",60160),globe:(0,i.register)("globe",60161),grabber:(0,i.register)("grabber",60162),graph:(0,i.register)("graph",60163),gripper:(0,i.register)("gripper",60164),heart:(0,i.register)("heart",60165),home:(0,i.register)("home",60166),horizontalRule:(0,i.register)("horizontal-rule",60167),hubot:(0,i.register)("hubot",60168),inbox:(0,i.register)("inbox",60169),issueReopened:(0,i.register)("issue-reopened",60171),issues:(0,i.register)("issues",60172),italic:(0,i.register)("italic",60173),jersey:(0,i.register)("jersey",60174),json:(0,i.register)("json",60175),kebabVertical:(0,i.register)("kebab-vertical",60176),key:(0,i.register)("key",60177),law:(0,i.register)("law",60178),lightbulbAutofix:(0,i.register)("lightbulb-autofix",60179),linkExternal:(0,i.register)("link-external",60180),link:(0,i.register)("link",60181),listOrdered:(0,i.register)("list-ordered",60182),listUnordered:(0,i.register)("list-unordered",60183),liveShare:(0,i.register)("live-share",60184),loading:(0,i.register)("loading",60185),location:(0,i.register)("location",60186),mailRead:(0,i.register)("mail-read",60187),mail:(0,i.register)("mail",60188),markdown:(0,i.register)("markdown",60189),megaphone:(0,i.register)("megaphone",60190),mention:(0,i.register)("mention",60191),milestone:(0,i.register)("milestone",60192),gitPullRequestMilestone:(0,i.register)("git-pull-request-milestone",60192),mortarBoard:(0,i.register)("mortar-board",60193),move:(0,i.register)("move",60194),multipleWindows:(0,i.register)("multiple-windows",60195),mute:(0,i.register)("mute",60196),noNewline:(0,i.register)("no-newline",60197),note:(0,i.register)("note",60198),octoface:(0,i.register)("octoface",60199),openPreview:(0,i.register)("open-preview",60200),package:(0,i.register)("package",60201),paintcan:(0,i.register)("paintcan",60202),pin:(0,i.register)("pin",60203),play:(0,i.register)("play",60204),run:(0,i.register)("run",60204),plug:(0,i.register)("plug",60205),preserveCase:(0,i.register)("preserve-case",60206),preview:(0,i.register)("preview",60207),project:(0,i.register)("project",60208),pulse:(0,i.register)("pulse",60209),question:(0,i.register)("question",60210),quote:(0,i.register)("quote",60211),radioTower:(0,i.register)("radio-tower",60212),reactions:(0,i.register)("reactions",60213),references:(0,i.register)("references",60214),refresh:(0,i.register)("refresh",60215),regex:(0,i.register)("regex",60216),remoteExplorer:(0,i.register)("remote-explorer",60217),remote:(0,i.register)("remote",60218),remove:(0,i.register)("remove",60219),replaceAll:(0,i.register)("replace-all",60220),replace:(0,i.register)("replace",60221),repoClone:(0,i.register)("repo-clone",60222),repoForcePush:(0,i.register)("repo-force-push",60223),repoPull:(0,i.register)("repo-pull",60224),repoPush:(0,i.register)("repo-push",60225),report:(0,i.register)("report",60226),requestChanges:(0,i.register)("request-changes",60227),rocket:(0,i.register)("rocket",60228),rootFolderOpened:(0,i.register)("root-folder-opened",60229),rootFolder:(0,i.register)("root-folder",60230),rss:(0,i.register)("rss",60231),ruby:(0,i.register)("ruby",60232),saveAll:(0,i.register)("save-all",60233),saveAs:(0,i.register)("save-as",60234),save:(0,i.register)("save",60235),screenFull:(0,i.register)("screen-full",60236),screenNormal:(0,i.register)("screen-normal",60237),searchStop:(0,i.register)("search-stop",60238),server:(0,i.register)("server",60240),settingsGear:(0,i.register)("settings-gear",60241),settings:(0,i.register)("settings",60242),shield:(0,i.register)("shield",60243),smiley:(0,i.register)("smiley",60244),sortPrecedence:(0,i.register)("sort-precedence",60245),splitHorizontal:(0,i.register)("split-horizontal",60246),splitVertical:(0,i.register)("split-vertical",60247),squirrel:(0,i.register)("squirrel",60248),starFull:(0,i.register)("star-full",60249),starHalf:(0,i.register)("star-half",60250),symbolClass:(0,i.register)("symbol-class",60251),symbolColor:(0,i.register)("symbol-color",60252),symbolConstant:(0,i.register)("symbol-constant",60253),symbolEnumMember:(0,i.register)("symbol-enum-member",60254),symbolField:(0,i.register)("symbol-field",60255),symbolFile:(0,i.register)("symbol-file",60256),symbolInterface:(0,i.register)("symbol-interface",60257),symbolKeyword:(0,i.register)("symbol-keyword",60258),symbolMisc:(0,i.register)("symbol-misc",60259),symbolOperator:(0,i.register)("symbol-operator",60260),symbolProperty:(0,i.register)("symbol-property",60261),wrench:(0,i.register)("wrench",60261),wrenchSubaction:(0,i.register)("wrench-subaction",60261),symbolSnippet:(0,i.register)("symbol-snippet",60262),tasklist:(0,i.register)("tasklist",60263),telescope:(0,i.register)("telescope",60264),textSize:(0,i.register)("text-size",60265),threeBars:(0,i.register)("three-bars",60266),thumbsdown:(0,i.register)("thumbsdown",60267),thumbsup:(0,i.register)("thumbsup",60268),tools:(0,i.register)("tools",60269),triangleDown:(0,i.register)("triangle-down",60270),triangleLeft:(0,i.register)("triangle-left",60271),triangleRight:(0,i.register)("triangle-right",60272),triangleUp:(0,i.register)("triangle-up",60273),twitter:(0,i.register)("twitter",60274),unfold:(0,i.register)("unfold",60275),unlock:(0,i.register)("unlock",60276),unmute:(0,i.register)("unmute",60277),unverified:(0,i.register)("unverified",60278),verified:(0,i.register)("verified",60279),versions:(0,i.register)("versions",60280),vmActive:(0,i.register)("vm-active",60281),vmOutline:(0,i.register)("vm-outline",60282),vmRunning:(0,i.register)("vm-running",60283),watch:(0,i.register)("watch",60284),whitespace:(0,i.register)("whitespace",60285),wholeWord:(0,i.register)("whole-word",60286),window:(0,i.register)("window",60287),wordWrap:(0,i.register)("word-wrap",60288),zoomIn:(0,i.register)("zoom-in",60289),zoomOut:(0,i.register)("zoom-out",60290),listFilter:(0,i.register)("list-filter",60291),listFlat:(0,i.register)("list-flat",60292),listSelection:(0,i.register)("list-selection",60293),selection:(0,i.register)("selection",60293),listTree:(0,i.register)("list-tree",60294),debugBreakpointFunctionUnverified:(0,i.register)("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:(0,i.register)("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:(0,i.register)("debug-breakpoint-function-disabled",60296),debugStackframeActive:(0,i.register)("debug-stackframe-active",60297),circleSmallFilled:(0,i.register)("circle-small-filled",60298),debugStackframeDot:(0,i.register)("debug-stackframe-dot",60298),terminalDecorationMark:(0,i.register)("terminal-decoration-mark",60298),debugStackframe:(0,i.register)("debug-stackframe",60299),debugStackframeFocused:(0,i.register)("debug-stackframe-focused",60299),debugBreakpointUnsupported:(0,i.register)("debug-breakpoint-unsupported",60300),symbolString:(0,i.register)("symbol-string",60301),debugReverseContinue:(0,i.register)("debug-reverse-continue",60302),debugStepBack:(0,i.register)("debug-step-back",60303),debugRestartFrame:(0,i.register)("debug-restart-frame",60304),debugAlt:(0,i.register)("debug-alt",60305),callIncoming:(0,i.register)("call-incoming",60306),callOutgoing:(0,i.register)("call-outgoing",60307),menu:(0,i.register)("menu",60308),expandAll:(0,i.register)("expand-all",60309),feedback:(0,i.register)("feedback",60310),gitPullRequestReviewer:(0,i.register)("git-pull-request-reviewer",60310),groupByRefType:(0,i.register)("group-by-ref-type",60311),ungroupByRefType:(0,i.register)("ungroup-by-ref-type",60312),account:(0,i.register)("account",60313),gitPullRequestAssignee:(0,i.register)("git-pull-request-assignee",60313),bellDot:(0,i.register)("bell-dot",60314),debugConsole:(0,i.register)("debug-console",60315),library:(0,i.register)("library",60316),output:(0,i.register)("output",60317),runAll:(0,i.register)("run-all",60318),syncIgnored:(0,i.register)("sync-ignored",60319),pinned:(0,i.register)("pinned",60320),githubInverted:(0,i.register)("github-inverted",60321),serverProcess:(0,i.register)("server-process",60322),serverEnvironment:(0,i.register)("server-environment",60323),pass:(0,i.register)("pass",60324),issueClosed:(0,i.register)("issue-closed",60324),stopCircle:(0,i.register)("stop-circle",60325),playCircle:(0,i.register)("play-circle",60326),record:(0,i.register)("record",60327),debugAltSmall:(0,i.register)("debug-alt-small",60328),vmConnect:(0,i.register)("vm-connect",60329),cloud:(0,i.register)("cloud",60330),merge:(0,i.register)("merge",60331),export:(0,i.register)("export",60332),graphLeft:(0,i.register)("graph-left",60333),magnet:(0,i.register)("magnet",60334),notebook:(0,i.register)("notebook",60335),redo:(0,i.register)("redo",60336),checkAll:(0,i.register)("check-all",60337),pinnedDirty:(0,i.register)("pinned-dirty",60338),passFilled:(0,i.register)("pass-filled",60339),circleLargeFilled:(0,i.register)("circle-large-filled",60340),circleLarge:(0,i.register)("circle-large",60341),circleLargeOutline:(0,i.register)("circle-large-outline",60341),combine:(0,i.register)("combine",60342),gather:(0,i.register)("gather",60342),table:(0,i.register)("table",60343),variableGroup:(0,i.register)("variable-group",60344),typeHierarchy:(0,i.register)("type-hierarchy",60345),typeHierarchySub:(0,i.register)("type-hierarchy-sub",60346),typeHierarchySuper:(0,i.register)("type-hierarchy-super",60347),gitPullRequestCreate:(0,i.register)("git-pull-request-create",60348),runAbove:(0,i.register)("run-above",60349),runBelow:(0,i.register)("run-below",60350),notebookTemplate:(0,i.register)("notebook-template",60351),debugRerun:(0,i.register)("debug-rerun",60352),workspaceTrusted:(0,i.register)("workspace-trusted",60353),workspaceUntrusted:(0,i.register)("workspace-untrusted",60354),workspaceUnknown:(0,i.register)("workspace-unknown",60355),terminalCmd:(0,i.register)("terminal-cmd",60356),terminalDebian:(0,i.register)("terminal-debian",60357),terminalLinux:(0,i.register)("terminal-linux",60358),terminalPowershell:(0,i.register)("terminal-powershell",60359),terminalTmux:(0,i.register)("terminal-tmux",60360),terminalUbuntu:(0,i.register)("terminal-ubuntu",60361),terminalBash:(0,i.register)("terminal-bash",60362),arrowSwap:(0,i.register)("arrow-swap",60363),copy:(0,i.register)("copy",60364),personAdd:(0,i.register)("person-add",60365),filterFilled:(0,i.register)("filter-filled",60366),wand:(0,i.register)("wand",60367),debugLineByLine:(0,i.register)("debug-line-by-line",60368),inspect:(0,i.register)("inspect",60369),layers:(0,i.register)("layers",60370),layersDot:(0,i.register)("layers-dot",60371),layersActive:(0,i.register)("layers-active",60372),compass:(0,i.register)("compass",60373),compassDot:(0,i.register)("compass-dot",60374),compassActive:(0,i.register)("compass-active",60375),azure:(0,i.register)("azure",60376),issueDraft:(0,i.register)("issue-draft",60377),gitPullRequestClosed:(0,i.register)("git-pull-request-closed",60378),gitPullRequestDraft:(0,i.register)("git-pull-request-draft",60379),debugAll:(0,i.register)("debug-all",60380),debugCoverage:(0,i.register)("debug-coverage",60381),runErrors:(0,i.register)("run-errors",60382),folderLibrary:(0,i.register)("folder-library",60383),debugContinueSmall:(0,i.register)("debug-continue-small",60384),beakerStop:(0,i.register)("beaker-stop",60385),graphLine:(0,i.register)("graph-line",60386),graphScatter:(0,i.register)("graph-scatter",60387),pieChart:(0,i.register)("pie-chart",60388),bracket:(0,i.register)("bracket",60175),bracketDot:(0,i.register)("bracket-dot",60389),bracketError:(0,i.register)("bracket-error",60390),lockSmall:(0,i.register)("lock-small",60391),azureDevops:(0,i.register)("azure-devops",60392),verifiedFilled:(0,i.register)("verified-filled",60393),newline:(0,i.register)("newline",60394),layout:(0,i.register)("layout",60395),layoutActivitybarLeft:(0,i.register)("layout-activitybar-left",60396),layoutActivitybarRight:(0,i.register)("layout-activitybar-right",60397),layoutPanelLeft:(0,i.register)("layout-panel-left",60398),layoutPanelCenter:(0,i.register)("layout-panel-center",60399),layoutPanelJustify:(0,i.register)("layout-panel-justify",60400),layoutPanelRight:(0,i.register)("layout-panel-right",60401),layoutPanel:(0,i.register)("layout-panel",60402),layoutSidebarLeft:(0,i.register)("layout-sidebar-left",60403),layoutSidebarRight:(0,i.register)("layout-sidebar-right",60404),layoutStatusbar:(0,i.register)("layout-statusbar",60405),layoutMenubar:(0,i.register)("layout-menubar",60406),layoutCentered:(0,i.register)("layout-centered",60407),target:(0,i.register)("target",60408),indent:(0,i.register)("indent",60409),recordSmall:(0,i.register)("record-small",60410),errorSmall:(0,i.register)("error-small",60411),terminalDecorationError:(0,i.register)("terminal-decoration-error",60411),arrowCircleDown:(0,i.register)("arrow-circle-down",60412),arrowCircleLeft:(0,i.register)("arrow-circle-left",60413),arrowCircleRight:(0,i.register)("arrow-circle-right",60414),arrowCircleUp:(0,i.register)("arrow-circle-up",60415),layoutSidebarRightOff:(0,i.register)("layout-sidebar-right-off",60416),layoutPanelOff:(0,i.register)("layout-panel-off",60417),layoutSidebarLeftOff:(0,i.register)("layout-sidebar-left-off",60418),blank:(0,i.register)("blank",60419),heartFilled:(0,i.register)("heart-filled",60420),map:(0,i.register)("map",60421),mapHorizontal:(0,i.register)("map-horizontal",60421),foldHorizontal:(0,i.register)("fold-horizontal",60421),mapFilled:(0,i.register)("map-filled",60422),mapHorizontalFilled:(0,i.register)("map-horizontal-filled",60422),foldHorizontalFilled:(0,i.register)("fold-horizontal-filled",60422),circleSmall:(0,i.register)("circle-small",60423),bellSlash:(0,i.register)("bell-slash",60424),bellSlashDot:(0,i.register)("bell-slash-dot",60425),commentUnresolved:(0,i.register)("comment-unresolved",60426),gitPullRequestGoToChanges:(0,i.register)("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:(0,i.register)("git-pull-request-new-changes",60428),searchFuzzy:(0,i.register)("search-fuzzy",60429),commentDraft:(0,i.register)("comment-draft",60430),send:(0,i.register)("send",60431),sparkle:(0,i.register)("sparkle",60432),insert:(0,i.register)("insert",60433),mic:(0,i.register)("mic",60434),thumbsdownFilled:(0,i.register)("thumbsdown-filled",60435),thumbsupFilled:(0,i.register)("thumbsup-filled",60436),coffee:(0,i.register)("coffee",60437),snake:(0,i.register)("snake",60438),game:(0,i.register)("game",60439),vr:(0,i.register)("vr",60440),chip:(0,i.register)("chip",60441),piano:(0,i.register)("piano",60442),music:(0,i.register)("music",60443),micFilled:(0,i.register)("mic-filled",60444),repoFetch:(0,i.register)("repo-fetch",60445),copilot:(0,i.register)("copilot",60446),lightbulbSparkle:(0,i.register)("lightbulb-sparkle",60447),robot:(0,i.register)("robot",60448),sparkleFilled:(0,i.register)("sparkle-filled",60449),diffSingle:(0,i.register)("diff-single",60450),diffMultiple:(0,i.register)("diff-multiple",60451),surroundWith:(0,i.register)("surround-with",60452),share:(0,i.register)("share",60453),gitStash:(0,i.register)("git-stash",60454),gitStashApply:(0,i.register)("git-stash-apply",60455),gitStashPop:(0,i.register)("git-stash-pop",60456),vscode:(0,i.register)("vscode",60457),vscodeInsiders:(0,i.register)("vscode-insiders",60458),codeOss:(0,i.register)("code-oss",60459),runCoverage:(0,i.register)("run-coverage",60460),runAllCoverage:(0,i.register)("run-all-coverage",60461),coverage:(0,i.register)("coverage",60462),githubProject:(0,i.register)("github-project",60463),mapVertical:(0,i.register)("map-vertical",60464),foldVertical:(0,i.register)("fold-vertical",60464),mapVerticalFilled:(0,i.register)("map-vertical-filled",60465),foldVerticalFilled:(0,i.register)("fold-vertical-filled",60465),goToSearch:(0,i.register)("go-to-search",60466),percentage:(0,i.register)("percentage",60467),sortPercentage:(0,i.register)("sort-percentage",60467),attach:(0,i.register)("attach",60468)}}),define(le[80],ue([0,1,112,151]),function(j,e,i,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Codicon=e.codiconsDerived=void 0,e.getAllCodicons=y;function y(){return Object.values(e.Codicon)}e.codiconsDerived={dialogError:(0,i.register)("dialog-error","error"),dialogWarning:(0,i.register)("dialog-warning","warning"),dialogInfo:(0,i.register)("dialog-info","info"),dialogClose:(0,i.register)("dialog-close","close"),treeItemExpanded:(0,i.register)("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:(0,i.register)("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:(0,i.register)("tree-filter-on-type-off","list-selection"),treeFilterClear:(0,i.register)("tree-filter-clear","close"),treeItemLoading:(0,i.register)("tree-item-loading","loading"),menuSelection:(0,i.register)("menu-selection","check"),menuSubmenu:(0,i.register)("menu-submenu","chevron-right"),menuBarMore:(0,i.register)("menubar-more","more"),scrollbarButtonLeft:(0,i.register)("scrollbar-button-left","triangle-left"),scrollbarButtonRight:(0,i.register)("scrollbar-button-right","triangle-right"),scrollbarButtonUp:(0,i.register)("scrollbar-button-up","triangle-up"),scrollbarButtonDown:(0,i.register)("scrollbar-button-down","triangle-down"),toolBarMore:(0,i.register)("toolbar-more","more"),quickInputBack:(0,i.register)("quick-input-back","arrow-left"),dropDownButton:(0,i.register)("drop-down-button",60084),symbolCustomColor:(0,i.register)("symbol-customcolor",60252),exportIcon:(0,i.register)("export",60332),workspaceUnspecified:(0,i.register)("workspace-unspecified",60355),newLine:(0,i.register)("newline",60394),thumbsDownFilled:(0,i.register)("thumbsdown-filled",60435),thumbsUpFilled:(0,i.register)("thumbsup-filled",60436),gitFetch:(0,i.register)("git-fetch",60445),lightbulbSparkleAutofix:(0,i.register)("lightbulb-sparkle-autofix",60447),debugBreakpointPending:(0,i.register)("debug-breakpoint-pending",60377)},e.Codicon={...s.codiconsLibrary,...e.codiconsDerived}}),define(le[37],ue([0,1,12]),function(j,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deepClone=s,e.deepFreeze=y,e.cloneAndChange=A,e.mixin=S,e.equals=c,e.safeStringify=m,e.distinct=u,e.getCaseInsensitive=p,e.filter=v,e.getAllPropertyNames=f,e.getAllMethodNames=h,e.createProxyObject=E,e.mapValues=b;function s(g){if(!g||typeof g!="object"||g instanceof RegExp)return g;const I=Array.isArray(g)?[]:{};return Object.entries(g).forEach(([P,r])=>{I[P]=r&&typeof r=="object"?s(r):r}),I}function y(g){if(!g||typeof g!="object")return g;const I=[g];for(;I.length>0;){const P=I.shift();Object.freeze(P);for(const r in P)if(k.call(P,r)){const a=P[r];typeof a=="object"&&!Object.isFrozen(a)&&!(0,i.isTypedArray)(a)&&I.push(a)}}return g}const k=Object.prototype.hasOwnProperty;function A(g,I){return R(g,I,new Set)}function R(g,I,P){if((0,i.isUndefinedOrNull)(g))return g;const r=I(g);if(typeof r<"u")return r;if(Array.isArray(g)){const a=[];for(const t of g)a.push(R(t,I,P));return a}if((0,i.isObject)(g)){if(P.has(g))throw new Error("Cannot clone recursive data-structure");P.add(g);const a={};for(const t in g)k.call(g,t)&&(a[t]=R(g[t],I,P));return P.delete(g),a}return g}function S(g,I,P=!0){return(0,i.isObject)(g)?((0,i.isObject)(I)&&Object.keys(I).forEach(r=>{r in g?P&&((0,i.isObject)(g[r])&&(0,i.isObject)(I[r])?S(g[r],I[r],P):g[r]=I[r]):g[r]=I[r]}),g):I}function c(g,I){if(g===I)return!0;if(g==null||I===null||I===void 0||typeof g!=typeof I||typeof g!="object"||Array.isArray(g)!==Array.isArray(I))return!1;let P,r;if(Array.isArray(g)){if(g.length!==I.length)return!1;for(P=0;P<g.length;P++)if(!c(g[P],I[P]))return!1}else{const a=[];for(r in g)a.push(r);a.sort();const t=[];for(r in I)t.push(r);if(t.sort(),!c(a,t))return!1;for(P=0;P<a.length;P++)if(!c(g[a[P]],I[a[P]]))return!1}return!0}function m(g){const I=new Set;return JSON.stringify(g,(P,r)=>{if((0,i.isObject)(r)||Array.isArray(r)){if(I.has(r))return"[Circular]";I.add(r)}return typeof r=="bigint"?`[BigInt ${r.toString()}]`:r})}function u(g,I){const P=Object.create(null);return!g||!I||Object.keys(I).forEach(a=>{const t=g[a],o=I[a];c(t,o)||(P[a]=o)}),P}function p(g,I){const P=I.toLowerCase(),r=Object.keys(g).find(a=>a.toLowerCase()===P);return r?g[r]:g[I]}function v(g,I){const P=Object.create(null);for(const[r,a]of Object.entries(g))I(r,a)&&(P[r]=a);return P}function f(g){let I=[];for(;Object.prototype!==g;)I=I.concat(Object.getOwnPropertyNames(g)),g=Object.getPrototypeOf(g);return I}function h(g){const I=[];for(const P of f(g))typeof g[P]=="function"&&I.push(P);return I}function E(g,I){const P=a=>function(){const t=Array.prototype.slice.call(arguments,0);return I(a,t)},r={};for(const a of g)r[a]=P(a);return r}function b(g,I){const P={};for(const[r,a]of Object.entries(g))P[r]=I(a,r);return P}}),define(le[113],ue([0,1,80]),function(j,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.ThemeColor=void 0,e.themeColorFromId=y;var s;(function(A){function R(S){return S&&typeof S=="object"&&typeof S.id=="string"}A.isThemeColor=R})(s||(e.ThemeColor=s={}));function y(A){return{id:A}}var k;(function(A){A.iconNameSegment="[A-Za-z0-9]+",A.iconNameExpression="[A-Za-z0-9-]+",A.iconModifierExpression="~[A-Za-z]+",A.iconNameCharacter="[A-Za-z0-9~-]";const R=new RegExp(`^(${A.iconNameExpression})(${A.iconModifierExpression})?$`);function S(g){const I=R.exec(g.id);if(!I)return S(i.Codicon.error);const[,P,r]=I,a=["codicon","codicon-"+P];return r&&a.push("codicon-modifier-"+r.substring(1)),a}A.asClassNameArray=S;function c(g){return S(g).join(" ")}A.asClassName=c;function m(g){return"."+S(g).join(".")}A.asCSSSelector=m;function u(g){return g&&typeof g=="object"&&typeof g.id=="string"&&(typeof g.color>"u"||s.isThemeColor(g.color))}A.isThemeIcon=u;const p=new RegExp(`^\\$\\((${A.iconNameExpression}(?:${A.iconModifierExpression})?)\\)$`);function v(g){const I=p.exec(g);if(!I)return;const[,P]=I;return{id:P}}A.fromString=v;function f(g){return{id:g}}A.fromId=f;function h(g,I){let P=g.id;const r=P.lastIndexOf("~");return r!==-1&&(P=P.substring(0,r)),I&&(P=`${P}~${I}`),{id:P}}A.modify=h;function E(g){const I=g.id.lastIndexOf("~");if(I!==-1)return g.id.substring(I+1)}A.getModifier=E;function b(g,I){return g.id===I.id&&g.color?.id===I.color?.id}A.isEqual=b})(k||(e.ThemeIcon=k={}))}),define(le[152],ue([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Constants=void 0,e.toUint8=s,e.toUint32=y;var i;(function(k){k[k.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",k[k.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",k[k.MAX_UINT_8=255]="MAX_UINT_8",k[k.MAX_UINT_16=65535]="MAX_UINT_16",k[k.MAX_UINT_32=4294967295]="MAX_UINT_32",k[k.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(i||(e.Constants=i={}));function s(k){return k<0?0:k>i.MAX_UINT_8?i.MAX_UINT_8:k|0}function y(k){return k<0?0:k>i.MAX_UINT_32?i.MAX_UINT_32:k|0}}),define(le[25],ue([0,1,149,39,67,152]),function(j,e,i,s,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.GraphemeBreakType=e.UTF8_BOM_CHARACTER=e.UNUSUAL_LINE_TERMINATORS=e.GraphemeIterator=e.CodePointIterator=void 0,e.isFalsyOrWhitespace=A,e.format=S,e.format2=m,e.htmlAttributeEncodeValue=u,e.escape=p,e.escapeRegExpCharacters=v,e.count=f,e.truncate=h,e.truncateMiddle=E,e.trim=b,e.ltrim=g,e.rtrim=I,e.convertSimple2RegExpPattern=P,e.stripWildcards=r,e.createRegExp=a,e.regExpLeadsToEndlessLoop=t,e.splitLines=o,e.splitLinesIncludeSeparators=n,e.firstNonWhitespaceIndex=l,e.getLeadingWhitespace=d,e.lastNonWhitespaceIndex=D,e.replaceAsync=w,e.compare=M,e.compareSubstring=T,e.compareIgnoreCase=C,e.compareSubstringIgnoreCase=L,e.isAsciiDigit=_,e.isLowerAsciiLetter=V,e.isUpperAsciiLetter=z,e.equalsIgnoreCase=Q,e.startsWithIgnoreCase=fe,e.commonPrefixLength=se,e.commonSuffixLength=ee,e.isHighSurrogate=U,e.isLowSurrogate=K,e.computeCodePoint=N,e.getNextCodePoint=x,e.nextCharLength=H,e.prevCharLength=ce,e.getCharContainingOffset=oe,e.charCount=te,e.containsRTL=B,e.isBasicASCII=J,e.containsUnusualLineTerminators=G,e.isFullWidthCharacter=$,e.isEmojiImprecise=Z,e.lcut=ae,e.forAnsiStringParts=Se,e.removeAnsiEscapeCodes=ye,e.removeAnsiEscapeCodesFromPrompt=He,e.startsWithUTF8BOM=Ce,e.stripUTF8BOM=me,e.fuzzyContains=Y,e.containsUppercaseCharacter=de,e.uppercaseFirstLetter=he,e.getNLines=ve,e.singleLetterHash=Ee,e.getGraphemeBreakType=Oe,e.getLeftDeleteOffset=Je;function A(ne){return!ne||typeof ne!="string"?!0:ne.trim().length===0}const R=/{(\d+)}/g;function S(ne,...ge){return ge.length===0?ne:ne.replace(R,function(we,be){const _e=parseInt(be,10);return isNaN(_e)||_e<0||_e>=ge.length?we:ge[_e]})}const c=/{([^}]+)}/g;function m(ne,ge){return Object.keys(ge).length===0?ne:ne.replace(c,(we,be)=>ge[be]??we)}function u(ne){return ne.replace(/[<>"'&]/g,ge=>{switch(ge){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return ge})}function p(ne){return ne.replace(/[<>&]/g,function(ge){switch(ge){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ge}})}function v(ne){return ne.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function f(ne,ge){let we=0,be=ne.indexOf(ge);for(;be!==-1;)we++,be=ne.indexOf(ge,be+ge.length);return we}function h(ne,ge,we="\u2026"){return ne.length<=ge?ne:`${ne.substr(0,ge)}${we}`}function E(ne,ge,we="\u2026"){if(ne.length<=ge)return ne;const be=Math.ceil(ge/2)-we.length/2,_e=Math.floor(ge/2)-we.length/2;return`${ne.substr(0,be)}${we}${ne.substr(ne.length-_e)}`}function b(ne,ge=" "){const we=g(ne,ge);return I(we,ge)}function g(ne,ge){if(!ne||!ge)return ne;const we=ge.length;if(we===0||ne.length===0)return ne;let be=0;for(;ne.indexOf(ge,be)===be;)be=be+we;return ne.substring(be)}function I(ne,ge){if(!ne||!ge)return ne;const we=ge.length,be=ne.length;if(we===0||be===0)return ne;let _e=be,xe=-1;for(;xe=ne.lastIndexOf(ge,_e-1),!(xe===-1||xe+we!==_e);){if(xe===0)return"";_e=xe}return ne.substring(0,_e)}function P(ne){return ne.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function r(ne){return ne.replace(/\*/g,"")}function a(ne,ge,we={}){if(!ne)throw new Error("Cannot create regex from empty string");ge||(ne=v(ne)),we.wholeWord&&(/\B/.test(ne.charAt(0))||(ne="\\b"+ne),/\B/.test(ne.charAt(ne.length-1))||(ne=ne+"\\b"));let be="";return we.global&&(be+="g"),we.matchCase||(be+="i"),we.multiline&&(be+="m"),we.unicode&&(be+="u"),new RegExp(ne,be)}function t(ne){return ne.source==="^"||ne.source==="^$"||ne.source==="$"||ne.source==="^\\s*$"?!1:!!(ne.exec("")&&ne.lastIndex===0)}function o(ne){return ne.split(/\r\n|\r|\n/)}function n(ne){const ge=[],we=ne.split(/(\r\n|\r|\n)/);for(let be=0;be<Math.ceil(we.length/2);be++)ge.push(we[2*be]+(we[2*be+1]??""));return ge}function l(ne){for(let ge=0,we=ne.length;ge<we;ge++){const be=ne.charCodeAt(ge);if(be!==s.CharCode.Space&&be!==s.CharCode.Tab)return ge}return-1}function d(ne,ge=0,we=ne.length){for(let be=ge;be<we;be++){const _e=ne.charCodeAt(be);if(_e!==s.CharCode.Space&&_e!==s.CharCode.Tab)return ne.substring(ge,be)}return ne.substring(ge,we)}function D(ne,ge=ne.length-1){for(let we=ge;we>=0;we--){const be=ne.charCodeAt(we);if(be!==s.CharCode.Space&&be!==s.CharCode.Tab)return we}return-1}function w(ne,ge,we){const be=[];let _e=0;for(const xe of ne.matchAll(ge)){if(be.push(ne.slice(_e,xe.index)),xe.index===void 0)throw new Error("match.index should be defined");_e=xe.index+xe[0].length,be.push(we(xe[0],...xe.slice(1),xe.index,ne,xe.groups))}return be.push(ne.slice(_e)),Promise.all(be).then(xe=>xe.join(""))}function M(ne,ge){return ne<ge?-1:ne>ge?1:0}function T(ne,ge,we=0,be=ne.length,_e=0,xe=ge.length){for(;we<be&&_e<xe;we++,_e++){const st=ne.charCodeAt(we),at=ge.charCodeAt(_e);if(st<at)return-1;if(st>at)return 1}const Ze=be-we,lt=xe-_e;return Ze<lt?-1:Ze>lt?1:0}function C(ne,ge){return L(ne,ge,0,ne.length,0,ge.length)}function L(ne,ge,we=0,be=ne.length,_e=0,xe=ge.length){for(;we<be&&_e<xe;we++,_e++){let st=ne.charCodeAt(we),at=ge.charCodeAt(_e);if(st===at)continue;if(st>=128||at>=128)return T(ne.toLowerCase(),ge.toLowerCase(),we,be,_e,xe);V(st)&&(st-=32),V(at)&&(at-=32);const tt=st-at;if(tt!==0)return tt}const Ze=be-we,lt=xe-_e;return Ze<lt?-1:Ze>lt?1:0}function _(ne){return ne>=s.CharCode.Digit0&&ne<=s.CharCode.Digit9}function V(ne){return ne>=s.CharCode.a&&ne<=s.CharCode.z}function z(ne){return ne>=s.CharCode.A&&ne<=s.CharCode.Z}function Q(ne,ge){return ne.length===ge.length&&L(ne,ge)===0}function fe(ne,ge){const we=ge.length;return ge.length>ne.length?!1:L(ne,ge,0,we)===0}function se(ne,ge){const we=Math.min(ne.length,ge.length);let be;for(be=0;be<we;be++)if(ne.charCodeAt(be)!==ge.charCodeAt(be))return be;return we}function ee(ne,ge){const we=Math.min(ne.length,ge.length);let be;const _e=ne.length-1,xe=ge.length-1;for(be=0;be<we;be++)if(ne.charCodeAt(_e-be)!==ge.charCodeAt(xe-be))return be;return we}function U(ne){return 55296<=ne&&ne<=56319}function K(ne){return 56320<=ne&&ne<=57343}function N(ne,ge){return(ne-55296<<10)+(ge-56320)+65536}function x(ne,ge,we){const be=ne.charCodeAt(we);if(U(be)&&we+1<ge){const _e=ne.charCodeAt(we+1);if(K(_e))return N(be,_e)}return be}function W(ne,ge){const we=ne.charCodeAt(ge-1);if(K(we)&&ge>1){const be=ne.charCodeAt(ge-2);if(U(be))return N(be,we)}return we}class q{get offset(){return this._offset}constructor(ge,we=0){this._str=ge,this._len=ge.length,this._offset=we}setOffset(ge){this._offset=ge}prevCodePoint(){const ge=W(this._str,this._offset);return this._offset-=ge>=k.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,ge}nextCodePoint(){const ge=x(this._str,this._len,this._offset);return this._offset+=ge>=k.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,ge}eol(){return this._offset>=this._len}}e.CodePointIterator=q;class ie{get offset(){return this._iterator.offset}constructor(ge,we=0){this._iterator=new q(ge,we)}nextGraphemeLength(){const ge=Ue.getInstance(),we=this._iterator,be=we.offset;let _e=ge.getGraphemeBreakType(we.nextCodePoint());for(;!we.eol();){const xe=we.offset,Ze=ge.getGraphemeBreakType(we.nextCodePoint());if(Ae(_e,Ze)){we.setOffset(xe);break}_e=Ze}return we.offset-be}prevGraphemeLength(){const ge=Ue.getInstance(),we=this._iterator,be=we.offset;let _e=ge.getGraphemeBreakType(we.prevCodePoint());for(;we.offset>0;){const xe=we.offset,Ze=ge.getGraphemeBreakType(we.prevCodePoint());if(Ae(Ze,_e)){we.setOffset(xe);break}_e=Ze}return be-we.offset}eol(){return this._iterator.eol()}}e.GraphemeIterator=ie;function H(ne,ge){return new ie(ne,ge).nextGraphemeLength()}function ce(ne,ge){return new ie(ne,ge).prevGraphemeLength()}function oe(ne,ge){ge>0&&K(ne.charCodeAt(ge))&&ge--;const we=ge+H(ne,ge);return[we-ce(ne,we),we]}function te(ne){const ge=new ie(ne);let we=0;for(;!ge.eol();)we++,ge.nextGraphemeLength();return we}let O;function X(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function B(ne){return O||(O=X()),O.test(ne)}const F=/^[\t\n\r\x20-\x7E]*$/;function J(ne){return F.test(ne)}e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function G(ne){return e.UNUSUAL_LINE_TERMINATORS.test(ne)}function $(ne){return ne>=11904&&ne<=55215||ne>=63744&&ne<=64255||ne>=65281&&ne<=65374}function Z(ne){return ne>=127462&&ne<=127487||ne===8986||ne===8987||ne===9200||ne===9203||ne>=9728&&ne<=10175||ne===11088||ne===11093||ne>=127744&&ne<=128591||ne>=128640&&ne<=128764||ne>=128992&&ne<=129008||ne>=129280&&ne<=129535||ne>=129648&&ne<=129782}function ae(ne,ge,we=""){const be=ne.trimStart();if(be.length<ge)return be;const _e=/\b/g;let xe=0;for(;_e.test(be)&&!(be.length-_e.lastIndex<ge);)xe=_e.lastIndex,_e.lastIndex+=1;return xe===0?be:we+be.substring(xe).trimStart()}const pe=/(?:(?:\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~])|(:?\x1b\].*?\x07)/g;function*Se(ne){let ge=0;for(const we of ne.matchAll(pe))ge!==we.index&&(yield{isCode:!1,str:ne.substring(ge,we.index)}),yield{isCode:!0,str:we[0]},ge=we.index+we[0].length;ge!==ne.length&&(yield{isCode:!1,str:ne.substring(ge)})}function ye(ne){return ne&&(ne=ne.replace(pe,"")),ne}const We=/\\\[.*?\\\]/g;function He(ne){return ye(ne).replace(We,"")}e.UTF8_BOM_CHARACTER=String.fromCharCode(s.CharCode.UTF8_BOM);function Ce(ne){return!!(ne&&ne.length>0&&ne.charCodeAt(0)===s.CharCode.UTF8_BOM)}function me(ne){return Ce(ne)?ne.substr(1):ne}function Y(ne,ge){if(!ne||!ge||ne.length<ge.length)return!1;const we=ge.length,be=ne.toLowerCase();let _e=0,xe=-1;for(;_e<we;){const Ze=be.indexOf(ge[_e],xe+1);if(Ze<0)return!1;xe=Ze,_e++}return!0}function de(ne,ge=!1){return ne?(ge&&(ne=ne.replace(/\\./g,"")),ne.toLowerCase()!==ne):!1}function he(ne){return ne.charAt(0).toUpperCase()+ne.slice(1)}function ve(ne,ge=1){if(ge===0)return"";let we=-1;do we=ne.indexOf(`
`,we+1),ge--;while(ge>0&&we>=0);return we===-1?ne:(ne[we-1]==="\r"&&we--,ne.substr(0,we))}function Ee(ne){const ge=s.CharCode.Z-s.CharCode.A+1;return ne=ne%(2*ge),ne<ge?String.fromCharCode(s.CharCode.a+ne):String.fromCharCode(s.CharCode.A+ne-ge)}function Oe(ne){return Ue.getInstance().getGraphemeBreakType(ne)}function Ae(ne,ge){return ne===Me.Other?ge!==Me.Extend&&ge!==Me.SpacingMark:ne===Me.CR&&ge===Me.LF?!1:ne===Me.Control||ne===Me.CR||ne===Me.LF||ge===Me.Control||ge===Me.CR||ge===Me.LF?!0:!(ne===Me.L&&(ge===Me.L||ge===Me.V||ge===Me.LV||ge===Me.LVT)||(ne===Me.LV||ne===Me.V)&&(ge===Me.V||ge===Me.T)||(ne===Me.LVT||ne===Me.T)&&ge===Me.T||ge===Me.Extend||ge===Me.ZWJ||ge===Me.SpacingMark||ne===Me.Prepend||ne===Me.ZWJ&&ge===Me.Extended_Pictographic||ne===Me.Regional_Indicator&&ge===Me.Regional_Indicator)}var Me;(function(ne){ne[ne.Other=0]="Other",ne[ne.Prepend=1]="Prepend",ne[ne.CR=2]="CR",ne[ne.LF=3]="LF",ne[ne.Control=4]="Control",ne[ne.Extend=5]="Extend",ne[ne.Regional_Indicator=6]="Regional_Indicator",ne[ne.SpacingMark=7]="SpacingMark",ne[ne.L=8]="L",ne[ne.V=9]="V",ne[ne.T=10]="T",ne[ne.LV=11]="LV",ne[ne.LVT=12]="LVT",ne[ne.ZWJ=13]="ZWJ",ne[ne.Extended_Pictographic=14]="Extended_Pictographic"})(Me||(e.GraphemeBreakType=Me={}));class Ue{static{this._INSTANCE=null}static getInstance(){return Ue._INSTANCE||(Ue._INSTANCE=new Ue),Ue._INSTANCE}constructor(){this._data=Ge()}getGraphemeBreakType(ge){if(ge<32)return ge===s.CharCode.LineFeed?Me.LF:ge===s.CharCode.CarriageReturn?Me.CR:Me.Control;if(ge<127)return Me.Other;const we=this._data,be=we.length/3;let _e=1;for(;_e<=be;)if(ge<we[3*_e])_e=2*_e;else if(ge>we[3*_e+1])_e=2*_e+1;else return we[3*_e+2];return Me.Other}}function Ge(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Je(ne,ge){if(ne===0)return 0;const we=ze(ne,ge);if(we!==void 0)return we;const be=new q(ge,ne);return be.prevCodePoint(),be.offset}function ze(ne,ge){const we=new q(ge,ne);let be=we.prevCodePoint();for(;Xe(be)||be===Qe.emojiVariantSelector||be===Qe.enclosingKeyCap;){if(we.offset===0)return;be=we.prevCodePoint()}if(!Z(be))return;let _e=we.offset;return _e>0&&we.prevCodePoint()===Qe.zwj&&(_e=we.offset),_e}function Xe(ne){return 127995<=ne&&ne<=127999}var Qe;(function(ne){ne[ne.zwj=8205]="zwj",ne[ne.emojiVariantSelector=65039]="emojiVariantSelector",ne[ne.enclosingKeyCap=8419]="enclosingKeyCap"})(Qe||(Qe={})),e.noBreakWhitespace="\xA0";class Ye{static{this.ambiguousCharacterData=new y.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.cache=new i.LRUCachedFunction({getCacheKey:JSON.stringify},ge=>{function we(tt){const ut=new Map;for(let ct=0;ct<tt.length;ct+=2)ut.set(tt[ct],tt[ct+1]);return ut}function be(tt,ut){const ct=new Map(tt);for(const[ht,gt]of ut)ct.set(ht,gt);return ct}function _e(tt,ut){if(!tt)return ut;const ct=new Map;for(const[ht,gt]of tt)ut.has(ht)&&ct.set(ht,gt);return ct}const xe=this.ambiguousCharacterData.value;let Ze=ge.filter(tt=>!tt.startsWith("_")&&tt in xe);Ze.length===0&&(Ze=["_default"]);let lt;for(const tt of Ze){const ut=we(xe[tt]);lt=_e(lt,ut)}const st=we(xe._common),at=be(st,lt);return new Ye(at)})}static getInstance(ge){return Ye.cache.get(Array.from(ge))}static{this._locales=new y.Lazy(()=>Object.keys(Ye.ambiguousCharacterData.value).filter(ge=>!ge.startsWith("_")))}static getLocales(){return Ye._locales.value}constructor(ge){this.confusableDictionary=ge}isAmbiguous(ge){return this.confusableDictionary.has(ge)}containsAmbiguousCharacter(ge){for(let we=0;we<ge.length;we++){const be=ge.codePointAt(we);if(typeof be=="number"&&this.isAmbiguous(be))return!0}return!1}getPrimaryConfusable(ge){return this.confusableDictionary.get(ge)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}e.AmbiguousCharacters=Ye;class Ne{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this._data=void 0}static getData(){return this._data||(this._data=new Set(Ne.getRawData())),this._data}static isInvisibleCharacter(ge){return Ne.getData().has(ge)}static containsInvisibleCharacter(ge){for(let we=0;we<ge.length;we++){const be=ge.codePointAt(we);if(typeof be=="number"&&Ne.isInvisibleCharacter(be))return!0}return!1}static get codePoints(){return Ne.getData()}}e.InvisibleCharacters=Ne}),define(le[48],ue([0,1,25]),function(j,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.Hasher=void 0,e.hash=s,e.doHash=y,e.numberHash=k,e.stringHash=R,e.toHexString=h,i=Re(i);function s(b){return y(b,0)}function y(b,g){switch(typeof b){case"object":return b===null?k(349,g):Array.isArray(b)?S(b,g):c(b,g);case"string":return R(b,g);case"boolean":return A(b,g);case"number":return k(b,g);case"undefined":return k(937,g);default:return k(617,g)}}function k(b,g){return(g<<5)-g+b|0}function A(b,g){return k(b?433:863,g)}function R(b,g){g=k(149417,g);for(let I=0,P=b.length;I<P;I++)g=k(b.charCodeAt(I),g);return g}function S(b,g){return g=k(104579,g),b.reduce((I,P)=>y(P,I),g)}function c(b,g){return g=k(181387,g),Object.keys(b).sort().reduce((I,P)=>(I=R(P,I),y(b[P],I)),g)}class m{constructor(){this._value=0}get value(){return this._value}hash(g){return this._value=y(g,this._value),this._value}}e.Hasher=m;var u;(function(b){b[b.BLOCK_SIZE=64]="BLOCK_SIZE",b[b.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(u||(u={}));function p(b,g,I=32){const P=I-g,r=~((1<<P)-1);return(b<<g|(r&b)>>>P)>>>0}function v(b,g=0,I=b.byteLength,P=0){for(let r=0;r<I;r++)b[g+r]=P}function f(b,g,I="0"){for(;b.length<g;)b=I+b;return b}function h(b,g=32){return b instanceof ArrayBuffer?Array.from(new Uint8Array(b)).map(I=>I.toString(16).padStart(2,"0")).join(""):f((b>>>0).toString(16),g/4)}class E{static{this._bigBlock32=new DataView(new ArrayBuffer(320))}constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(u.BLOCK_SIZE+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(g){const I=g.length;if(I===0)return;const P=this._buff;let r=this._buffLen,a=this._leftoverHighSurrogate,t,o;for(a!==0?(t=a,o=-1,a=0):(t=g.charCodeAt(0),o=0);;){let n=t;if(i.isHighSurrogate(t))if(o+1<I){const l=g.charCodeAt(o+1);i.isLowSurrogate(l)?(o++,n=i.computeCodePoint(t,l)):n=u.UNICODE_REPLACEMENT}else{a=t;break}else i.isLowSurrogate(t)&&(n=u.UNICODE_REPLACEMENT);if(r=this._push(P,r,n),o++,o<I)t=g.charCodeAt(o);else break}this._buffLen=r,this._leftoverHighSurrogate=a}_push(g,I,P){return P<128?g[I++]=P:P<2048?(g[I++]=192|(P&1984)>>>6,g[I++]=128|(P&63)>>>0):P<65536?(g[I++]=224|(P&61440)>>>12,g[I++]=128|(P&4032)>>>6,g[I++]=128|(P&63)>>>0):(g[I++]=240|(P&1835008)>>>18,g[I++]=128|(P&258048)>>>12,g[I++]=128|(P&4032)>>>6,g[I++]=128|(P&63)>>>0),I>=u.BLOCK_SIZE&&(this._step(),I-=u.BLOCK_SIZE,this._totalLen+=u.BLOCK_SIZE,g[0]=g[u.BLOCK_SIZE+0],g[1]=g[u.BLOCK_SIZE+1],g[2]=g[u.BLOCK_SIZE+2]),I}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,u.UNICODE_REPLACEMENT)),this._totalLen+=this._buffLen,this._wrapUp()),h(this._h0)+h(this._h1)+h(this._h2)+h(this._h3)+h(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,v(this._buff,this._buffLen),this._buffLen>56&&(this._step(),v(this._buff));const g=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(g/4294967296),!1),this._buffDV.setUint32(60,g%4294967296,!1),this._step()}_step(){const g=E._bigBlock32,I=this._buffDV;for(let D=0;D<64;D+=4)g.setUint32(D,I.getUint32(D,!1),!1);for(let D=64;D<320;D+=4)g.setUint32(D,p(g.getUint32(D-12,!1)^g.getUint32(D-32,!1)^g.getUint32(D-56,!1)^g.getUint32(D-64,!1),1),!1);let P=this._h0,r=this._h1,a=this._h2,t=this._h3,o=this._h4,n,l,d;for(let D=0;D<80;D++)D<20?(n=r&a|~r&t,l=1518500249):D<40?(n=r^a^t,l=1859775393):D<60?(n=r&a|r&t|a&t,l=2400959708):(n=r^a^t,l=3395469782),d=p(P,5)+n+o+l+g.getUint32(D*4,!1)&4294967295,o=t,t=a,a=p(r,30),r=P,P=d;this._h0=this._h0+P&4294967295,this._h1=this._h1+r&4294967295,this._h2=this._h2+a&4294967295,this._h3=this._h3+t&4294967295,this._h4=this._h4+o&4294967295}}e.StringSHA1=E}),define(le[81],ue([0,1,25]),function(j,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),i=Re(i);var s;(function(y){y[y.Ignore=0]="Ignore",y[y.Info=1]="Info",y[y.Warning=2]="Warning",y[y.Error=3]="Error"})(s||(s={})),function(y){const k="error",A="warning",R="warn",S="info",c="ignore";function m(p){return p?i.equalsIgnoreCase(k,p)?y.Error:i.equalsIgnoreCase(A,p)||i.equalsIgnoreCase(R,p)?y.Warning:i.equalsIgnoreCase(S,p)?y.Info:y.Ignore:y.Ignore}y.fromValue=m;function u(p){switch(p){case y.Error:return k;case y.Warning:return A;case y.Info:return S;default:return c}}y.toString=u}(s||(s={})),e.default=s}),define(le[61],ue([0,1,21,39,25]),function(j,e,i,s,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class k{constructor(){this._value="",this._pos=0}reset(f){return this._value=f,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(f){const h=f.charCodeAt(0),E=this._value.charCodeAt(this._pos);return h-E}value(){return this._value[this._pos]}}e.StringIterator=k;class A{constructor(f=!0){this._caseSensitive=f}reset(f){return this._value=f,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let f=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===s.CharCode.Period)if(f)this._from++;else break;else f=!1;return this}cmp(f){return this._caseSensitive?(0,y.compareSubstring)(f,this._value,0,f.length,this._from,this._to):(0,y.compareSubstringIgnoreCase)(f,this._value,0,f.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=A;class R{constructor(f=!0,h=!0){this._splitOnBackslash=f,this._caseSensitive=h}reset(f){this._from=0,this._to=0,this._value=f,this._valueLen=f.length;for(let h=f.length-1;h>=0;h--,this._valueLen--){const E=this._value.charCodeAt(h);if(!(E===s.CharCode.Slash||this._splitOnBackslash&&E===s.CharCode.Backslash))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let f=!0;for(;this._to<this._valueLen;this._to++){const h=this._value.charCodeAt(this._to);if(h===s.CharCode.Slash||this._splitOnBackslash&&h===s.CharCode.Backslash)if(f)this._from++;else break;else f=!1}return this}cmp(f){return this._caseSensitive?(0,y.compareSubstring)(f,this._value,0,f.length,this._from,this._to):(0,y.compareSubstringIgnoreCase)(f,this._value,0,f.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=R;var S;(function(v){v[v.Scheme=1]="Scheme",v[v.Authority=2]="Authority",v[v.Path=3]="Path",v[v.Query=4]="Query",v[v.Fragment=5]="Fragment"})(S||(S={}));class c{constructor(f,h){this._ignorePathCasing=f,this._ignoreQueryAndFragment=h,this._states=[],this._stateIdx=0}reset(f){return this._value=f,this._states=[],this._value.scheme&&this._states.push(S.Scheme),this._value.authority&&this._states.push(S.Authority),this._value.path&&(this._pathIterator=new R(!1,!this._ignorePathCasing(f)),this._pathIterator.reset(f.path),this._pathIterator.value()&&this._states.push(S.Path)),this._ignoreQueryAndFragment(f)||(this._value.query&&this._states.push(S.Query),this._value.fragment&&this._states.push(S.Fragment)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===S.Path&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===S.Path&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(f){if(this._states[this._stateIdx]===S.Scheme)return(0,y.compareIgnoreCase)(f,this._value.scheme);if(this._states[this._stateIdx]===S.Authority)return(0,y.compareIgnoreCase)(f,this._value.authority);if(this._states[this._stateIdx]===S.Path)return this._pathIterator.cmp(f);if(this._states[this._stateIdx]===S.Query)return(0,y.compare)(f,this._value.query);if(this._states[this._stateIdx]===S.Fragment)return(0,y.compare)(f,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===S.Scheme)return this._value.scheme;if(this._states[this._stateIdx]===S.Authority)return this._value.authority;if(this._states[this._stateIdx]===S.Path)return this._pathIterator.value();if(this._states[this._stateIdx]===S.Query)return this._value.query;if(this._states[this._stateIdx]===S.Fragment)return this._value.fragment;throw new Error}}e.UriIterator=c;class m{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const f=this.right;return this.right=f.left,f.left=this,this.updateHeight(),f.updateHeight(),f}rotateRight(){const f=this.left;return this.left=f.right,f.right=this,this.updateHeight(),f.updateHeight(),f}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var u;(function(v){v[v.Left=-1]="Left",v[v.Mid=0]="Mid",v[v.Right=1]="Right"})(u||(u={}));class p{static forUris(f=()=>!1,h=()=>!1){return new p(new c(f,h))}static forPaths(f=!1){return new p(new R(void 0,!f))}static forStrings(){return new p(new k)}static forConfigKeys(){return new p(new A)}constructor(f){this._iter=f}clear(){this._root=void 0}fill(f,h){if(h){const E=h.slice(0);(0,i.shuffle)(E);for(const b of E)this.set(b,f)}else{const E=f.slice(0);(0,i.shuffle)(E);for(const b of E)this.set(b[0],b[1])}}set(f,h){const E=this._iter.reset(f);let b;this._root||(this._root=new m,this._root.segment=E.value());const g=[];for(b=this._root;;){const P=E.cmp(b.segment);if(P>0)b.left||(b.left=new m,b.left.segment=E.value()),g.push([u.Left,b]),b=b.left;else if(P<0)b.right||(b.right=new m,b.right.segment=E.value()),g.push([u.Right,b]),b=b.right;else if(E.hasNext())E.next(),b.mid||(b.mid=new m,b.mid.segment=E.value()),g.push([u.Mid,b]),b=b.mid;else break}const I=b.value;b.value=h,b.key=f;for(let P=g.length-1;P>=0;P--){const r=g[P][1];r.updateHeight();const a=r.balanceFactor();if(a<-1||a>1){const t=g[P][0],o=g[P+1][0];if(t===u.Right&&o===u.Right)g[P][1]=r.rotateLeft();else if(t===u.Left&&o===u.Left)g[P][1]=r.rotateRight();else if(t===u.Right&&o===u.Left)r.right=g[P+1][1]=g[P+1][1].rotateRight(),g[P][1]=r.rotateLeft();else if(t===u.Left&&o===u.Right)r.left=g[P+1][1]=g[P+1][1].rotateLeft(),g[P][1]=r.rotateRight();else throw new Error;if(P>0)switch(g[P-1][0]){case u.Left:g[P-1][1].left=g[P][1];break;case u.Right:g[P-1][1].right=g[P][1];break;case u.Mid:g[P-1][1].mid=g[P][1];break}else this._root=g[0][1]}}return I}get(f){return this._getNode(f)?.value}_getNode(f){const h=this._iter.reset(f);let E=this._root;for(;E;){const b=h.cmp(E.segment);if(b>0)E=E.left;else if(b<0)E=E.right;else if(h.hasNext())h.next(),E=E.mid;else break}return E}has(f){const h=this._getNode(f);return!(h?.value===void 0&&h?.mid===void 0)}delete(f){return this._delete(f,!1)}deleteSuperstr(f){return this._delete(f,!0)}_delete(f,h){const E=this._iter.reset(f),b=[];let g=this._root;for(;g;){const I=E.cmp(g.segment);if(I>0)b.push([u.Left,g]),g=g.left;else if(I<0)b.push([u.Right,g]),g=g.right;else if(E.hasNext())E.next(),b.push([u.Mid,g]),g=g.mid;else break}if(g){if(h?(g.left=void 0,g.mid=void 0,g.right=void 0,g.height=1):(g.key=void 0,g.value=void 0),!g.mid&&!g.value)if(g.left&&g.right){const I=this._min(g.right);if(I.key){const{key:P,value:r,segment:a}=I;this._delete(I.key,!1),g.key=P,g.value=r,g.segment=a}}else{const I=g.left??g.right;if(b.length>0){const[P,r]=b[b.length-1];switch(P){case u.Left:r.left=I;break;case u.Mid:r.mid=I;break;case u.Right:r.right=I;break}}else this._root=I}for(let I=b.length-1;I>=0;I--){const P=b[I][1];P.updateHeight();const r=P.balanceFactor();if(r>1?(P.right.balanceFactor()>=0||(P.right=P.right.rotateRight()),b[I][1]=P.rotateLeft()):r<-1&&(P.left.balanceFactor()<=0||(P.left=P.left.rotateLeft()),b[I][1]=P.rotateRight()),I>0)switch(b[I-1][0]){case u.Left:b[I-1][1].left=b[I][1];break;case u.Right:b[I-1][1].right=b[I][1];break;case u.Mid:b[I-1][1].mid=b[I][1];break}else this._root=b[0][1]}}}_min(f){for(;f.left;)f=f.left;return f}findSubstr(f){const h=this._iter.reset(f);let E=this._root,b;for(;E;){const g=h.cmp(E.segment);if(g>0)E=E.left;else if(g<0)E=E.right;else if(h.hasNext())h.next(),b=E.value||b,E=E.mid;else break}return E&&E.value||b}findSuperstr(f){return this._findSuperstrOrElement(f,!1)}_findSuperstrOrElement(f,h){const E=this._iter.reset(f);let b=this._root;for(;b;){const g=E.cmp(b.segment);if(g>0)b=b.left;else if(g<0)b=b.right;else if(E.hasNext())E.next(),b=b.mid;else return b.mid?this._entries(b.mid):h?b.value:void 0}}hasElementOrSubtree(f){return this._findSuperstrOrElement(f,!0)!==void 0}forEach(f){for(const[h,E]of this)f(E,h)}*[Symbol.iterator](){yield*this._entries(this._root)}_entries(f){const h=[];return this._dfsEntries(f,h),h[Symbol.iterator]()}_dfsEntries(f,h){f&&(f.left&&this._dfsEntries(f.left,h),f.value&&h.push([f.key,f.value]),f.mid&&this._dfsEntries(f.mid,h),f.right&&this._dfsEntries(f.right,h))}_isBalanced(){const f=h=>{if(!h)return!0;const E=h.balanceFactor();return E<-1||E>1?!1:f(h.left)&&f(h.right)};return f(this._root)}}e.TernarySearchTree=p}),define(le[33],ue([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=void 0,e.isUUID=s;const i=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function s(y){return i.test(y)}e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let y;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?y=crypto.getRandomValues.bind(crypto):y=function(R){for(let S=0;S<R.length;S++)R[S]=Math.floor(Math.random()*256);return R};const k=new Uint8Array(16),A=[];for(let R=0;R<256;R++)A.push(R.toString(16).padStart(2,"0"));return function(){y(k),k[6]=k[6]&15|64,k[8]=k[8]&63|128;let S=0,c="";return c+=A[k[S++]],c+=A[k[S++]],c+=A[k[S++]],c+=A[k[S++]],c+="-",c+=A[k[S++]],c+=A[k[S++]],c+="-",c+=A[k[S++]],c+=A[k[S++]],c+="-",c+=A[k[S++]],c+=A[k[S++]],c+="-",c+=A[k[S++]],c+=A[k[S++]],c+=A[k[S++]],c+=A[k[S++]],c+=A[k[S++]],c+=A[k[S++]],c}}()}),define(le[153],ue([0,1,93,26,91]),function(j,e,i,s,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checksum=k,i=Re(i),s=Re(s);async function k(A,R){if(await new Promise((m,u)=>{const p=s.createReadStream(A),v=i.createHash("sha256");p.pipe(v);const f=(0,y.createSingleCallFunction)((h,E)=>{p.removeAllListeners(),v.removeAllListeners(),h?u(h):m(E)});p.once("error",f),p.once("end",f),v.once("error",f),v.once("data",h=>f(void 0,h.toString("hex")))})!==R)throw new Error("Hash mismatch")}}),define(le[154],ue([0,1,27]),function(j,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=k;const s=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function y(A){const R=A.replace(/\-/g,":").toLowerCase();return!s.has(R)}function k(){const A=(0,i.networkInterfaces)();for(const R in A){const S=A[R];if(S){for(const{mac:c}of S)if(y(c))return c}}throw new Error("Unable to retrieve mac address (unexpected format)")}}),define(le[114],ue([0,1,94]),function(j,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BROWSER_RESTRICTED_PORTS=void 0,e.findFreePort=s,e.findFreePortFaster=k,i=Re(i);function s(R,S,c,m=1){let u=!1;return new Promise(p=>{const v=setTimeout(()=>{if(!u)return u=!0,p(0)},c);y(R,S,m,f=>{if(!u)return u=!0,clearTimeout(v),p(f)})})}function y(R,S,c,m){if(S===0)return m(0);const u=new i.Socket;u.once("connect",()=>(A(u),y(R+c,S-1,c,m))),u.once("data",()=>{}),u.once("error",p=>(A(u),p.code!=="ECONNREFUSED"?y(R+c,S-1,c,m):m(R))),u.connect(R,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function k(R,S,c,m="127.0.0.1"){let u=!1,p,v=1;const f=i.createServer({pauseOnConnect:!0});function h(E,b){u||(u=!0,f.removeAllListeners(),f.close(),p&&clearTimeout(p),b(E))}return new Promise(E=>{p=setTimeout(()=>{h(0,E)},c),f.on("listening",()=>{h(R,E)}),f.on("error",b=>{b&&(b.code==="EADDRINUSE"||b.code==="EACCES")&&v<S?(R++,v++,f.listen(R,m)):h(0,E)}),f.on("close",()=>{h(0,E)}),f.listen(R,m)})}function A(R){try{R.removeAllListeners("connect"),R.removeAllListeners("error"),R.end(),R.destroy(),R.unref()}catch(S){console.error(S)}}}),function(){function j(){function e(){return process.uncHostAllowlist}function i(S){const c=new Set;if(Array.isArray(S))for(const m of S)typeof m=="string"&&c.add(m);return Array.from(c)}function s(){const S=e();return S?Array.from(S):[]}function y(S){if(process.platform!=="win32")return;const c=e();if(c)if(typeof S=="string")c.add(S.toLowerCase());else for(const m of i(S))y(m)}function k(S){if(typeof S!="string")return;const c=["\\\\.\\UNC\\","\\\\?\\UNC\\","\\\\"];let m;for(const u of c){if(S.indexOf(u)!==0)continue;const v=S.indexOf("\\",u.length);if(v===-1)continue;const f=S.substring(u.length,v);if(f){m=f;break}}return m}function A(){process.platform==="win32"&&(process.restrictUNCAccess=!1)}function R(){return process.platform!=="win32"?!0:process.restrictUNCAccess===!1}return{getUNCHostAllowlist:s,addUNCHostToAllowlist:y,getUNCHost:k,disableUNCAccessRestrictions:A,isUNCAccessRestrictionsDisabled:R}}typeof define=="function"?define("vs/base/node/unc",[],function(){return j()}):typeof module=="object"&&typeof module.exports=="object"?module.exports=j():console.trace("vs/base/node/unc defined in UNKNOWN context (neither requirejs or commonjs)")}(),define(le[155],ue([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_MENU_CLOSE_CHANNEL=e.CONTEXT_MENU_CHANNEL=void 0,e.CONTEXT_MENU_CHANNEL="vscode:contextmenu",e.CONTEXT_MENU_CLOSE_CHANNEL="vscode:onCloseContextMenu"}),define(le[156],ue([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Protocol=void 0;class i{constructor(y,k){this.sender=y,this.onMessage=k}send(y){try{this.sender.send("vscode:message",y.buffer)}catch{}}disconnect(){this.sender.send("vscode:disconnect",null)}}e.Protocol=i}),define(le[115],ue([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNLSMessages=i,e.getNLSLanguage=s;function i(){return globalThis._VSCODE_NLS_MESSAGES}function s(){return globalThis._VSCODE_NLS_LANGUAGE}}),define(le[9],ue([0,1,115,115]),function(j,e,i,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNLSMessages=e.getNLSLanguage=void 0,e.localize=A,e.localize2=S,Object.defineProperty(e,"getNLSLanguage",{enumerable:!0,get:function(){return s.getNLSLanguage}}),Object.defineProperty(e,"getNLSMessages",{enumerable:!0,get:function(){return s.getNLSMessages}});const y=(0,i.getNLSLanguage)()==="pseudo"||typeof document<"u"&&document.location&&document.location.hash.indexOf("pseudo=true")>=0;function k(c,m){let u;return m.length===0?u=c:u=c.replace(/\{(\d+)\}/g,(p,v)=>{const f=v[0],h=m[f];let E=p;return typeof h=="string"?E=h:(typeof h=="number"||typeof h=="boolean"||h===void 0||h===null)&&(E=String(h)),E}),y&&(u="\uFF3B"+u.replace(/[aouei]/g,"$&$&")+"\uFF3D"),u}function A(c,m,...u){return k(typeof c=="number"?R(c,m):m,u)}function R(c,m){const u=(0,i.getNLSMessages)()?.[c];if(typeof u!="string"){if(typeof m=="string")return m;throw new Error(`!!! NLS MISSING: ${c} !!!`)}return u}function S(c,m,...u){let p;typeof c=="number"?p=R(c,m):p=m;const v=k(p,u);return{value:v,original:m===p?v:k(m,u)}}}),define(le[157],ue([0,1,9]),function(j,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fromNow=c,e.fromNowByDay=m,e.getDurationString=u,e.toLocalISOString=p;const s=60,y=s*60,k=y*24,A=k*7,R=k*30,S=k*365;function c(v,f,h,E){typeof v!="number"&&(v=v.getTime());const b=Math.round((new Date().getTime()-v)/1e3);if(b<-30)return(0,i.localize)(42,null,c(new Date().getTime()+b*1e3,!1));if(!E&&b<30)return(0,i.localize)(43,null);let g;return b<s?(g=b,f?g===1?h?(0,i.localize)(44,null,g):(0,i.localize)(45,null,g):h?(0,i.localize)(46,null,g):(0,i.localize)(47,null,g):g===1?h?(0,i.localize)(48,null,g):(0,i.localize)(49,null,g):h?(0,i.localize)(50,null,g):(0,i.localize)(51,null,g)):b<y?(g=Math.floor(b/s),f?g===1?h?(0,i.localize)(52,null,g):(0,i.localize)(53,null,g):h?(0,i.localize)(54,null,g):(0,i.localize)(55,null,g):g===1?h?(0,i.localize)(56,null,g):(0,i.localize)(57,null,g):h?(0,i.localize)(58,null,g):(0,i.localize)(59,null,g)):b<k?(g=Math.floor(b/y),f?g===1?h?(0,i.localize)(60,null,g):(0,i.localize)(61,null,g):h?(0,i.localize)(62,null,g):(0,i.localize)(63,null,g):g===1?h?(0,i.localize)(64,null,g):(0,i.localize)(65,null,g):h?(0,i.localize)(66,null,g):(0,i.localize)(67,null,g)):b<A?(g=Math.floor(b/k),f?g===1?(0,i.localize)(68,null,g):(0,i.localize)(69,null,g):g===1?(0,i.localize)(70,null,g):(0,i.localize)(71,null,g)):b<R?(g=Math.floor(b/A),f?g===1?h?(0,i.localize)(72,null,g):(0,i.localize)(73,null,g):h?(0,i.localize)(74,null,g):(0,i.localize)(75,null,g):g===1?h?(0,i.localize)(76,null,g):(0,i.localize)(77,null,g):h?(0,i.localize)(78,null,g):(0,i.localize)(79,null,g)):b<S?(g=Math.floor(b/R),f?g===1?h?(0,i.localize)(80,null,g):(0,i.localize)(81,null,g):h?(0,i.localize)(82,null,g):(0,i.localize)(83,null,g):g===1?h?(0,i.localize)(84,null,g):(0,i.localize)(85,null,g):h?(0,i.localize)(86,null,g):(0,i.localize)(87,null,g)):(g=Math.floor(b/S),f?g===1?h?(0,i.localize)(88,null,g):(0,i.localize)(89,null,g):h?(0,i.localize)(90,null,g):(0,i.localize)(91,null,g):g===1?h?(0,i.localize)(92,null,g):(0,i.localize)(93,null,g):h?(0,i.localize)(94,null,g):(0,i.localize)(95,null,g))}function m(v,f,h){typeof v!="number"&&(v=v.getTime());const E=new Date;E.setHours(0,0,0,0);const b=new Date(E.getTime());return b.setDate(b.getDate()-1),v>E.getTime()?(0,i.localize)(96,null):v>b.getTime()?(0,i.localize)(97,null):c(v,f,h)}function u(v,f){const h=Math.abs(v/1e3);return h<1?f?(0,i.localize)(98,null,v):(0,i.localize)(99,null,v):h<s?f?(0,i.localize)(100,null,Math.round(v)/1e3):(0,i.localize)(101,null,Math.round(v)/1e3):h<y?f?(0,i.localize)(102,null,Math.round(v/(1e3*s))):(0,i.localize)(103,null,Math.round(v/(1e3*s))):h<k?f?(0,i.localize)(104,null,Math.round(v/(1e3*y))):(0,i.localize)(105,null,Math.round(v/(1e3*y))):(0,i.localize)(106,null,Math.round(v/(1e3*k)))}function p(v){return v.getFullYear()+"-"+String(v.getMonth()+1).padStart(2,"0")+"-"+String(v.getDate()).padStart(2,"0")+"T"+String(v.getHours()).padStart(2,"0")+":"+String(v.getMinutes()).padStart(2,"0")+":"+String(v.getSeconds()).padStart(2,"0")+"."+(v.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(le[55],ue([0,1,21,12,9]),function(j,e,i,s,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=S,e.isErrorWithActions=c,e.createErrorWithActions=m,i=Re(i),s=Re(s),y=Re(y);function k(u,p){return p&&(u.stack||u.stacktrace)?y.localize(107,null,R(u),A(u.stack)||A(u.stacktrace)):R(u)}function A(u){return Array.isArray(u)?u.join(`
`):u}function R(u){return u.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${u.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof u.code=="string"&&typeof u.errno=="number"&&typeof u.syscall=="string"?y.localize(108,null,u.message):u.message||y.localize(109,null)}function S(u=null,p=!1){if(!u)return y.localize(110,null);if(Array.isArray(u)){const v=i.coalesce(u),f=S(v[0],p);return v.length>1?y.localize(111,null,f,v.length):f}if(s.isString(u))return u;if(u.detail){const v=u.detail;if(v.error)return k(v.error,p);if(v.exception)return k(v.exception,p)}return u.stack?k(u,p):u.message?u.message:y.localize(112,null)}function c(u){const p=u;return p instanceof Error&&Array.isArray(p.actions)}function m(u,p){let v;return typeof u=="string"?v=new Error(u):v=u,v.actions=p,v}}),define(le[158],ue([0,1,9,43]),function(j,e,i,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getParseErrorMessage=y;function y(k){switch(k){case s.ParseErrorCode.InvalidSymbol:return(0,i.localize)(113,null);case s.ParseErrorCode.InvalidNumberFormat:return(0,i.localize)(114,null);case s.ParseErrorCode.PropertyNameExpected:return(0,i.localize)(115,null);case s.ParseErrorCode.ValueExpected:return(0,i.localize)(116,null);case s.ParseErrorCode.ColonExpected:return(0,i.localize)(117,null);case s.ParseErrorCode.CommaExpected:return(0,i.localize)(118,null);case s.ParseErrorCode.CloseBraceExpected:return(0,i.localize)(119,null);case s.ParseErrorCode.CloseBracketExpected:return(0,i.localize)(120,null);case s.ParseErrorCode.EndOfFileExpected:return(0,i.localize)(121,null);default:return""}}}),define(le[3],ue([0,1,9]),function(j,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.platformLocale=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isMobile=e.isIOS=e.webWorkerOrigin=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.Platform=e.LANGUAGE_DEFAULT=void 0,e.PlatformToString=t,e.isLittleEndian=w,e.isBigSurOrNewer=M,i=Re(i),e.LANGUAGE_DEFAULT="en";let s=!1,y=!1,k=!1,A=!1,R=!1,S=!1,c=!1,m=!1,u=!1,p=!1,v,f=e.LANGUAGE_DEFAULT,h=e.LANGUAGE_DEFAULT,E,b;const g=globalThis;let I;typeof g.vscode<"u"&&typeof g.vscode.process<"u"?I=g.vscode.process:typeof process<"u"&&typeof process?.versions?.node=="string"&&(I=process);const P=typeof I?.versions?.electron=="string",r=P&&I?.type==="renderer";if(typeof I=="object"){s=I.platform==="win32",y=I.platform==="darwin",k=I.platform==="linux",A=k&&!!I.env.SNAP&&!!I.env.SNAP_REVISION,c=P,u=!!I.env.CI||!!I.env.BUILD_ARTIFACTSTAGINGDIRECTORY,v=e.LANGUAGE_DEFAULT,f=e.LANGUAGE_DEFAULT;const T=I.env.VSCODE_NLS_CONFIG;if(T)try{const C=JSON.parse(T);v=C.userLocale,h=C.osLocale,f=C.resolvedLanguage||e.LANGUAGE_DEFAULT,E=C.languagePack?.translationsConfigFile}catch{}R=!0}else typeof navigator=="object"&&!r?(b=navigator.userAgent,s=b.indexOf("Windows")>=0,y=b.indexOf("Macintosh")>=0,m=(b.indexOf("Macintosh")>=0||b.indexOf("iPad")>=0||b.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,k=b.indexOf("Linux")>=0,p=b?.indexOf("Mobi")>=0,S=!0,f=i.getNLSLanguage()||e.LANGUAGE_DEFAULT,v=navigator.language.toLowerCase(),h=v):console.error("Unable to resolve platform.");var a;(function(T){T[T.Web=0]="Web",T[T.Mac=1]="Mac",T[T.Linux=2]="Linux",T[T.Windows=3]="Windows"})(a||(e.Platform=a={}));function t(T){switch(T){case a.Web:return"Web";case a.Mac:return"Mac";case a.Linux:return"Linux";case a.Windows:return"Windows"}}let o=a.Web;y?o=a.Mac:s?o=a.Windows:k&&(o=a.Linux),e.isWindows=s,e.isMacintosh=y,e.isLinux=k,e.isLinuxSnap=A,e.isNative=R,e.isElectron=c,e.isWeb=S,e.isWebWorker=S&&typeof g.importScripts=="function",e.webWorkerOrigin=e.isWebWorker?g.origin:void 0,e.isIOS=m,e.isMobile=p,e.isCI=u,e.platform=o,e.userAgent=b,e.language=f;var n;(function(T){function C(){return e.language}T.value=C;function L(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}T.isDefaultVariant=L;function _(){return e.language==="en"}T.isDefault=_})(n||(e.Language=n={})),e.locale=v,e.platformLocale=h,e.translationsConfigFile=E,e.setTimeout0IsFaster=typeof g.postMessage=="function"&&!g.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const T=[];g.addEventListener("message",L=>{if(L.data&&L.data.vscodeScheduleAsyncWork)for(let _=0,V=T.length;_<V;_++){const z=T[_];if(z.id===L.data.vscodeScheduleAsyncWork){T.splice(_,1),z.callback();return}}});let C=0;return L=>{const _=++C;T.push({id:_,callback:L}),g.postMessage({vscodeScheduleAsyncWork:_},"*")}}return T=>setTimeout(T)})();var l;(function(T){T[T.Windows=1]="Windows",T[T.Macintosh=2]="Macintosh",T[T.Linux=3]="Linux"})(l||(e.OperatingSystem=l={})),e.OS=y||m?l.Macintosh:s?l.Windows:l.Linux;let d=!0,D=!1;function w(){if(!D){D=!0;const T=new Uint8Array(2);T[0]=1,T[1]=2,d=new Uint16Array(T.buffer)[0]===513}return d}e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0);function M(T){return parseFloat(T)>=20}}),define(le[38],ue([0,1,3]),function(j,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let s;const y=globalThis.vscode;if(typeof y<"u"&&typeof y.process<"u"){const k=y.process;s={get platform(){return k.platform},get arch(){return k.arch},get env(){return k.env},cwd(){return k.cwd()}}}else typeof process<"u"&&typeof process?.versions?.node=="string"?s={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:s={get platform(){return i.isWindows?"win32":i.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=s.cwd,e.env=s.env,e.platform=s.platform,e.arch=s.arch}),define(le[10],ue([0,1,38]),function(j,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0,i=Re(i);const s=65,y=97,k=90,A=122,R=46,S=47,c=92,m=58,u=63;class p extends Error{constructor(o,n,l){let d;typeof n=="string"&&n.indexOf("not ")===0?(d="must not be",n=n.replace(/^not /,"")):d="must be";const D=o.indexOf(".")!==-1?"property":"argument";let w=`The "${o}" ${D} ${d} of type ${n}`;w+=`. Received type ${typeof l}`,super(w),this.code="ERR_INVALID_ARG_TYPE"}}function v(t,o){if(t===null||typeof t!="object")throw new p(o,"Object",t)}function f(t,o){if(typeof t!="string")throw new p(o,"string",t)}const h=i.platform==="win32";function E(t){return t===S||t===c}function b(t){return t===S}function g(t){return t>=s&&t<=k||t>=y&&t<=A}function I(t,o,n,l){let d="",D=0,w=-1,M=0,T=0;for(let C=0;C<=t.length;++C){if(C<t.length)T=t.charCodeAt(C);else{if(l(T))break;T=S}if(l(T)){if(!(w===C-1||M===1))if(M===2){if(d.length<2||D!==2||d.charCodeAt(d.length-1)!==R||d.charCodeAt(d.length-2)!==R){if(d.length>2){const L=d.lastIndexOf(n);L===-1?(d="",D=0):(d=d.slice(0,L),D=d.length-1-d.lastIndexOf(n)),w=C,M=0;continue}else if(d.length!==0){d="",D=0,w=C,M=0;continue}}o&&(d+=d.length>0?`${n}..`:"..",D=2)}else d.length>0?d+=`${n}${t.slice(w+1,C)}`:d=t.slice(w+1,C),D=C-w-1;w=C,M=0}else T===R&&M!==-1?++M:M=-1}return d}function P(t){return t?`${t[0]==="."?"":"."}${t}`:""}function r(t,o){v(o,"pathObject");const n=o.dir||o.root,l=o.base||`${o.name||""}${P(o.ext)}`;return n?n===o.root?`${n}${l}`:`${n}${t}${l}`:l}e.win32={resolve(...t){let o="",n="",l=!1;for(let d=t.length-1;d>=-1;d--){let D;if(d>=0){if(D=t[d],f(D,`paths[${d}]`),D.length===0)continue}else o.length===0?D=i.cwd():(D=i.env[`=${o}`]||i.cwd(),(D===void 0||D.slice(0,2).toLowerCase()!==o.toLowerCase()&&D.charCodeAt(2)===c)&&(D=`${o}\\`));const w=D.length;let M=0,T="",C=!1;const L=D.charCodeAt(0);if(w===1)E(L)&&(M=1,C=!0);else if(E(L))if(C=!0,E(D.charCodeAt(1))){let _=2,V=_;for(;_<w&&!E(D.charCodeAt(_));)_++;if(_<w&&_!==V){const z=D.slice(V,_);for(V=_;_<w&&E(D.charCodeAt(_));)_++;if(_<w&&_!==V){for(V=_;_<w&&!E(D.charCodeAt(_));)_++;(_===w||_!==V)&&(T=`\\\\${z}\\${D.slice(V,_)}`,M=_)}}}else M=1;else g(L)&&D.charCodeAt(1)===m&&(T=D.slice(0,2),M=2,w>2&&E(D.charCodeAt(2))&&(C=!0,M=3));if(T.length>0)if(o.length>0){if(T.toLowerCase()!==o.toLowerCase())continue}else o=T;if(l){if(o.length>0)break}else if(n=`${D.slice(M)}\\${n}`,l=C,C&&o.length>0)break}return n=I(n,!l,"\\",E),l?`${o}\\${n}`:`${o}${n}`||"."},normalize(t){f(t,"path");const o=t.length;if(o===0)return".";let n=0,l,d=!1;const D=t.charCodeAt(0);if(o===1)return b(D)?"\\":t;if(E(D))if(d=!0,E(t.charCodeAt(1))){let M=2,T=M;for(;M<o&&!E(t.charCodeAt(M));)M++;if(M<o&&M!==T){const C=t.slice(T,M);for(T=M;M<o&&E(t.charCodeAt(M));)M++;if(M<o&&M!==T){for(T=M;M<o&&!E(t.charCodeAt(M));)M++;if(M===o)return`\\\\${C}\\${t.slice(T)}\\`;M!==T&&(l=`\\\\${C}\\${t.slice(T,M)}`,n=M)}}}else n=1;else g(D)&&t.charCodeAt(1)===m&&(l=t.slice(0,2),n=2,o>2&&E(t.charCodeAt(2))&&(d=!0,n=3));let w=n<o?I(t.slice(n),!d,"\\",E):"";return w.length===0&&!d&&(w="."),w.length>0&&E(t.charCodeAt(o-1))&&(w+="\\"),l===void 0?d?`\\${w}`:w:d?`${l}\\${w}`:`${l}${w}`},isAbsolute(t){f(t,"path");const o=t.length;if(o===0)return!1;const n=t.charCodeAt(0);return E(n)||o>2&&g(n)&&t.charCodeAt(1)===m&&E(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let o,n;for(let D=0;D<t.length;++D){const w=t[D];f(w,"path"),w.length>0&&(o===void 0?o=n=w:o+=`\\${w}`)}if(o===void 0)return".";let l=!0,d=0;if(typeof n=="string"&&E(n.charCodeAt(0))){++d;const D=n.length;D>1&&E(n.charCodeAt(1))&&(++d,D>2&&(E(n.charCodeAt(2))?++d:l=!1))}if(l){for(;d<o.length&&E(o.charCodeAt(d));)d++;d>=2&&(o=`\\${o.slice(d)}`)}return e.win32.normalize(o)},relative(t,o){if(f(t,"from"),f(o,"to"),t===o)return"";const n=e.win32.resolve(t),l=e.win32.resolve(o);if(n===l||(t=n.toLowerCase(),o=l.toLowerCase(),t===o))return"";let d=0;for(;d<t.length&&t.charCodeAt(d)===c;)d++;let D=t.length;for(;D-1>d&&t.charCodeAt(D-1)===c;)D--;const w=D-d;let M=0;for(;M<o.length&&o.charCodeAt(M)===c;)M++;let T=o.length;for(;T-1>M&&o.charCodeAt(T-1)===c;)T--;const C=T-M,L=w<C?w:C;let _=-1,V=0;for(;V<L;V++){const Q=t.charCodeAt(d+V);if(Q!==o.charCodeAt(M+V))break;Q===c&&(_=V)}if(V!==L){if(_===-1)return l}else{if(C>L){if(o.charCodeAt(M+V)===c)return l.slice(M+V+1);if(V===2)return l.slice(M+V)}w>L&&(t.charCodeAt(d+V)===c?_=V:V===2&&(_=3)),_===-1&&(_=0)}let z="";for(V=d+_+1;V<=D;++V)(V===D||t.charCodeAt(V)===c)&&(z+=z.length===0?"..":"\\..");return M+=_,z.length>0?`${z}${l.slice(M,T)}`:(l.charCodeAt(M)===c&&++M,l.slice(M,T))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const o=e.win32.resolve(t);if(o.length<=2)return t;if(o.charCodeAt(0)===c){if(o.charCodeAt(1)===c){const n=o.charCodeAt(2);if(n!==u&&n!==R)return`\\\\?\\UNC\\${o.slice(2)}`}}else if(g(o.charCodeAt(0))&&o.charCodeAt(1)===m&&o.charCodeAt(2)===c)return`\\\\?\\${o}`;return t},dirname(t){f(t,"path");const o=t.length;if(o===0)return".";let n=-1,l=0;const d=t.charCodeAt(0);if(o===1)return E(d)?t:".";if(E(d)){if(n=l=1,E(t.charCodeAt(1))){let M=2,T=M;for(;M<o&&!E(t.charCodeAt(M));)M++;if(M<o&&M!==T){for(T=M;M<o&&E(t.charCodeAt(M));)M++;if(M<o&&M!==T){for(T=M;M<o&&!E(t.charCodeAt(M));)M++;if(M===o)return t;M!==T&&(n=l=M+1)}}}}else g(d)&&t.charCodeAt(1)===m&&(n=o>2&&E(t.charCodeAt(2))?3:2,l=n);let D=-1,w=!0;for(let M=o-1;M>=l;--M)if(E(t.charCodeAt(M))){if(!w){D=M;break}}else w=!1;if(D===-1){if(n===-1)return".";D=n}return t.slice(0,D)},basename(t,o){o!==void 0&&f(o,"suffix"),f(t,"path");let n=0,l=-1,d=!0,D;if(t.length>=2&&g(t.charCodeAt(0))&&t.charCodeAt(1)===m&&(n=2),o!==void 0&&o.length>0&&o.length<=t.length){if(o===t)return"";let w=o.length-1,M=-1;for(D=t.length-1;D>=n;--D){const T=t.charCodeAt(D);if(E(T)){if(!d){n=D+1;break}}else M===-1&&(d=!1,M=D+1),w>=0&&(T===o.charCodeAt(w)?--w===-1&&(l=D):(w=-1,l=M))}return n===l?l=M:l===-1&&(l=t.length),t.slice(n,l)}for(D=t.length-1;D>=n;--D)if(E(t.charCodeAt(D))){if(!d){n=D+1;break}}else l===-1&&(d=!1,l=D+1);return l===-1?"":t.slice(n,l)},extname(t){f(t,"path");let o=0,n=-1,l=0,d=-1,D=!0,w=0;t.length>=2&&t.charCodeAt(1)===m&&g(t.charCodeAt(0))&&(o=l=2);for(let M=t.length-1;M>=o;--M){const T=t.charCodeAt(M);if(E(T)){if(!D){l=M+1;break}continue}d===-1&&(D=!1,d=M+1),T===R?n===-1?n=M:w!==1&&(w=1):n!==-1&&(w=-1)}return n===-1||d===-1||w===0||w===1&&n===d-1&&n===l+1?"":t.slice(n,d)},format:r.bind(null,"\\"),parse(t){f(t,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return o;const n=t.length;let l=0,d=t.charCodeAt(0);if(n===1)return E(d)?(o.root=o.dir=t,o):(o.base=o.name=t,o);if(E(d)){if(l=1,E(t.charCodeAt(1))){let _=2,V=_;for(;_<n&&!E(t.charCodeAt(_));)_++;if(_<n&&_!==V){for(V=_;_<n&&E(t.charCodeAt(_));)_++;if(_<n&&_!==V){for(V=_;_<n&&!E(t.charCodeAt(_));)_++;_===n?l=_:_!==V&&(l=_+1)}}}}else if(g(d)&&t.charCodeAt(1)===m){if(n<=2)return o.root=o.dir=t,o;if(l=2,E(t.charCodeAt(2))){if(n===3)return o.root=o.dir=t,o;l=3}}l>0&&(o.root=t.slice(0,l));let D=-1,w=l,M=-1,T=!0,C=t.length-1,L=0;for(;C>=l;--C){if(d=t.charCodeAt(C),E(d)){if(!T){w=C+1;break}continue}M===-1&&(T=!1,M=C+1),d===R?D===-1?D=C:L!==1&&(L=1):D!==-1&&(L=-1)}return M!==-1&&(D===-1||L===0||L===1&&D===M-1&&D===w+1?o.base=o.name=t.slice(w,M):(o.name=t.slice(w,D),o.base=t.slice(w,M),o.ext=t.slice(D,M))),w>0&&w!==l?o.dir=t.slice(0,w-1):o.dir=o.root,o},sep:"\\",delimiter:";",win32:null,posix:null};const a=(()=>{if(h){const t=/\\/g;return()=>{const o=i.cwd().replace(t,"/");return o.slice(o.indexOf("/"))}}return()=>i.cwd()})();e.posix={resolve(...t){let o="",n=!1;for(let l=t.length-1;l>=-1&&!n;l--){const d=l>=0?t[l]:a();f(d,`paths[${l}]`),d.length!==0&&(o=`${d}/${o}`,n=d.charCodeAt(0)===S)}return o=I(o,!n,"/",b),n?`/${o}`:o.length>0?o:"."},normalize(t){if(f(t,"path"),t.length===0)return".";const o=t.charCodeAt(0)===S,n=t.charCodeAt(t.length-1)===S;return t=I(t,!o,"/",b),t.length===0?o?"/":n?"./":".":(n&&(t+="/"),o?`/${t}`:t)},isAbsolute(t){return f(t,"path"),t.length>0&&t.charCodeAt(0)===S},join(...t){if(t.length===0)return".";let o;for(let n=0;n<t.length;++n){const l=t[n];f(l,"path"),l.length>0&&(o===void 0?o=l:o+=`/${l}`)}return o===void 0?".":e.posix.normalize(o)},relative(t,o){if(f(t,"from"),f(o,"to"),t===o||(t=e.posix.resolve(t),o=e.posix.resolve(o),t===o))return"";const n=1,l=t.length,d=l-n,D=1,w=o.length-D,M=d<w?d:w;let T=-1,C=0;for(;C<M;C++){const _=t.charCodeAt(n+C);if(_!==o.charCodeAt(D+C))break;_===S&&(T=C)}if(C===M)if(w>M){if(o.charCodeAt(D+C)===S)return o.slice(D+C+1);if(C===0)return o.slice(D+C)}else d>M&&(t.charCodeAt(n+C)===S?T=C:C===0&&(T=0));let L="";for(C=n+T+1;C<=l;++C)(C===l||t.charCodeAt(C)===S)&&(L+=L.length===0?"..":"/..");return`${L}${o.slice(D+T)}`},toNamespacedPath(t){return t},dirname(t){if(f(t,"path"),t.length===0)return".";const o=t.charCodeAt(0)===S;let n=-1,l=!0;for(let d=t.length-1;d>=1;--d)if(t.charCodeAt(d)===S){if(!l){n=d;break}}else l=!1;return n===-1?o?"/":".":o&&n===1?"//":t.slice(0,n)},basename(t,o){o!==void 0&&f(o,"ext"),f(t,"path");let n=0,l=-1,d=!0,D;if(o!==void 0&&o.length>0&&o.length<=t.length){if(o===t)return"";let w=o.length-1,M=-1;for(D=t.length-1;D>=0;--D){const T=t.charCodeAt(D);if(T===S){if(!d){n=D+1;break}}else M===-1&&(d=!1,M=D+1),w>=0&&(T===o.charCodeAt(w)?--w===-1&&(l=D):(w=-1,l=M))}return n===l?l=M:l===-1&&(l=t.length),t.slice(n,l)}for(D=t.length-1;D>=0;--D)if(t.charCodeAt(D)===S){if(!d){n=D+1;break}}else l===-1&&(d=!1,l=D+1);return l===-1?"":t.slice(n,l)},extname(t){f(t,"path");let o=-1,n=0,l=-1,d=!0,D=0;for(let w=t.length-1;w>=0;--w){const M=t.charCodeAt(w);if(M===S){if(!d){n=w+1;break}continue}l===-1&&(d=!1,l=w+1),M===R?o===-1?o=w:D!==1&&(D=1):o!==-1&&(D=-1)}return o===-1||l===-1||D===0||D===1&&o===l-1&&o===n+1?"":t.slice(o,l)},format:r.bind(null,"/"),parse(t){f(t,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return o;const n=t.charCodeAt(0)===S;let l;n?(o.root="/",l=1):l=0;let d=-1,D=0,w=-1,M=!0,T=t.length-1,C=0;for(;T>=l;--T){const L=t.charCodeAt(T);if(L===S){if(!M){D=T+1;break}continue}w===-1&&(M=!1,w=T+1),L===R?d===-1?d=T:C!==1&&(C=1):d!==-1&&(C=-1)}if(w!==-1){const L=D===0&&n?1:D;d===-1||C===0||C===1&&d===w-1&&d===D+1?o.base=o.name=t.slice(L,w):(o.name=t.slice(L,d),o.base=t.slice(L,w),o.ext=t.slice(d,w))}return D>0?o.dir=t.slice(0,D-1):n&&(o.dir="/"),o},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=h?e.win32.normalize:e.posix.normalize,e.isAbsolute=h?e.win32.isAbsolute:e.posix.isAbsolute,e.join=h?e.win32.join:e.posix.join,e.resolve=h?e.win32.resolve:e.posix.resolve,e.relative=h?e.win32.relative:e.posix.relative,e.dirname=h?e.win32.dirname:e.posix.dirname,e.basename=h?e.win32.basename:e.posix.basename,e.extname=h?e.win32.extname:e.posix.extname,e.format=h?e.win32.format:e.posix.format,e.parse=h?e.win32.parse:e.posix.parse,e.toNamespacedPath=h?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=h?e.win32.sep:e.posix.sep,e.delimiter=h?e.win32.delimiter:e.posix.delimiter}),define(le[32],ue([0,1,39,10,3,25,12]),function(j,e,i,s,y,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPathSeparator=R,e.toSlashes=S,e.toPosixPath=c,e.getRoot=m,e.isUNC=u,e.isValidBasename=h,e.isEqual=E,e.isEqualOrParent=b,e.isWindowsDriveLetter=g,e.sanitizeFilePath=I,e.removeTrailingPathSeparator=P,e.isRootOrDriveLetter=r,e.hasDriveLetter=a,e.getDriveLetter=t,e.indexOfPath=o,e.parseLineAndColumnAware=n,e.randomPath=D;function R(w){return w===i.CharCode.Slash||w===i.CharCode.Backslash}function S(w){return w.replace(/[\\/]/g,s.posix.sep)}function c(w){return w.indexOf("/")===-1&&(w=S(w)),/^[a-zA-Z]:(\/|$)/.test(w)&&(w="/"+w),w}function m(w,M=s.posix.sep){if(!w)return"";const T=w.length,C=w.charCodeAt(0);if(R(C)){if(R(w.charCodeAt(1))&&!R(w.charCodeAt(2))){let _=3;const V=_;for(;_<T&&!R(w.charCodeAt(_));_++);if(V!==_&&!R(w.charCodeAt(_+1))){for(_+=1;_<T;_++)if(R(w.charCodeAt(_)))return w.slice(0,_+1).replace(/[\\/]/g,M)}}return M}else if(g(C)&&w.charCodeAt(1)===i.CharCode.Colon)return R(w.charCodeAt(2))?w.slice(0,2)+M:w.slice(0,2);let L=w.indexOf("://");if(L!==-1){for(L+=3;L<T;L++)if(R(w.charCodeAt(L)))return w.slice(0,L+1)}return""}function u(w){if(!y.isWindows||!w||w.length<5)return!1;let M=w.charCodeAt(0);if(M!==i.CharCode.Backslash||(M=w.charCodeAt(1),M!==i.CharCode.Backslash))return!1;let T=2;const C=T;for(;T<w.length&&(M=w.charCodeAt(T),M!==i.CharCode.Backslash);T++);return!(C===T||(M=w.charCodeAt(T+1),isNaN(M)||M===i.CharCode.Backslash))}const p=/[\\/:\*\?"<>\|]/g,v=/[/]/g,f=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function h(w,M=y.isWindows){const T=M?p:v;return!(!w||w.length===0||/^\s+$/.test(w)||(T.lastIndex=0,T.test(w))||M&&f.test(w)||w==="."||w===".."||M&&w[w.length-1]==="."||M&&w.length!==w.trim().length||w.length>255)}function E(w,M,T){const C=w===M;return!T||C?C:!w||!M?!1:(0,k.equalsIgnoreCase)(w,M)}function b(w,M,T,C=s.sep){if(w===M)return!0;if(!w||!M||M.length>w.length)return!1;if(T){if(!(0,k.startsWithIgnoreCase)(w,M))return!1;if(M.length===w.length)return!0;let _=M.length;return M.charAt(M.length-1)===C&&_--,w.charAt(_)===C}return M.charAt(M.length-1)!==C&&(M+=C),w.indexOf(M)===0}function g(w){return w>=i.CharCode.A&&w<=i.CharCode.Z||w>=i.CharCode.a&&w<=i.CharCode.z}function I(w,M){return y.isWindows&&w.endsWith(":")&&(w+=s.sep),(0,s.isAbsolute)(w)||(w=(0,s.join)(M,w)),w=(0,s.normalize)(w),P(w)}function P(w){return y.isWindows?(w=(0,k.rtrim)(w,s.sep),w.endsWith(":")&&(w+=s.sep)):(w=(0,k.rtrim)(w,s.sep),w||(w=s.sep)),w}function r(w){const M=(0,s.normalize)(w);return y.isWindows?w.length>3?!1:a(M)&&(w.length===2||M.charCodeAt(2)===i.CharCode.Backslash):M===s.posix.sep}function a(w,M=y.isWindows){return M?g(w.charCodeAt(0))&&w.charCodeAt(1)===i.CharCode.Colon:!1}function t(w,M=y.isWindows){return a(w,M)?w[0]:void 0}function o(w,M,T){return M.length>w.length?-1:w===M?0:(T&&(w=w.toLowerCase(),M=M.toLowerCase()),w.indexOf(M))}function n(w){const M=w.split(":");let T,C,L;for(const _ of M){const V=Number(_);(0,A.isNumber)(V)?C===void 0?C=V:L===void 0&&(L=V):T=T?[T,_].join(":"):_}if(!T)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:T,line:C!==void 0?C:void 0,column:L!==void 0?L:C!==void 0?1:void 0}}const l="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",d="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function D(w,M,T=8){let C="";for(let _=0;_<T;_++){let V;_===0&&y.isWindows&&!M&&(T===3||T===4)?V=d:V=l,C+=V.charAt(Math.floor(Math.random()*V.length))}let L;return M?L=`${M}-${C}`:L=C,w?(0,s.join)(w,L):L}}),define(le[82],ue([0,1,3]),function(j,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminateResponseCode=e.Source=void 0,e.sanitizeProcessEnvironment=k,e.removeDangerousEnvVariables=A;var s;(function(R){R[R.stdout=0]="stdout",R[R.stderr=1]="stderr"})(s||(e.Source=s={}));var y;(function(R){R[R.Success=0]="Success",R[R.Unknown=1]="Unknown",R[R.AccessDenied=2]="AccessDenied",R[R.ProcessNotFound=3]="ProcessNotFound"})(y||(e.TerminateResponseCode=y={}));function k(R,...S){const c=S.reduce((p,v)=>(p[v]=!0,p),{}),m=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(R).filter(p=>!c[p]).forEach(p=>{for(let v=0;v<m.length;v++)if(p.search(m[v])!==-1){delete R[p];break}})}function A(R){R&&(delete R.DEBUG,i.isLinux&&delete R.LD_PRELOAD)}}),define(le[7],ue([0,1,39,92,10,3]),function(j,e,i,s,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URI=void 0,e.isUriComponents=E,e.uriToFsPath=a,y=Re(y);const A=/^\w[\w\d+.-]*$/,R=/^\//,S=/^\/\//;function c(d,D){if(!d.scheme&&D)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${d.authority}", path: "${d.path}", query: "${d.query}", fragment: "${d.fragment}"}`);if(d.scheme&&!A.test(d.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(d.path){if(d.authority){if(!R.test(d.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(S.test(d.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function m(d,D){return!d&&!D?"file":d}function u(d,D){switch(d){case"https":case"http":case"file":D?D[0]!==v&&(D=v+D):D=v;break}return D}const p="",v="/",f=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class h{static isUri(D){return D instanceof h?!0:D?typeof D.authority=="string"&&typeof D.fragment=="string"&&typeof D.path=="string"&&typeof D.query=="string"&&typeof D.scheme=="string"&&typeof D.fsPath=="string"&&typeof D.with=="function"&&typeof D.toString=="function":!1}constructor(D,w,M,T,C,L=!1){typeof D=="object"?(this.scheme=D.scheme||p,this.authority=D.authority||p,this.path=D.path||p,this.query=D.query||p,this.fragment=D.fragment||p):(this.scheme=m(D,L),this.authority=w||p,this.path=u(this.scheme,M||p),this.query=T||p,this.fragment=C||p,c(this,L))}get fsPath(){return a(this,!1)}with(D){if(!D)return this;let{scheme:w,authority:M,path:T,query:C,fragment:L}=D;return w===void 0?w=this.scheme:w===null&&(w=p),M===void 0?M=this.authority:M===null&&(M=p),T===void 0?T=this.path:T===null&&(T=p),C===void 0?C=this.query:C===null&&(C=p),L===void 0?L=this.fragment:L===null&&(L=p),w===this.scheme&&M===this.authority&&T===this.path&&C===this.query&&L===this.fragment?this:new g(w,M,T,C,L)}static parse(D,w=!1){const M=f.exec(D);return M?new g(M[2]||p,l(M[4]||p),l(M[5]||p),l(M[7]||p),l(M[9]||p),w):new g(p,p,p,p,p)}static file(D){let w=p;if(k.isWindows&&(D=D.replace(/\\/g,v)),D[0]===v&&D[1]===v){const M=D.indexOf(v,2);M===-1?(w=D.substring(2),D=v):(w=D.substring(2,M),D=D.substring(M)||v)}return new g("file",w,D,p,p)}static from(D,w){return new g(D.scheme,D.authority,D.path,D.query,D.fragment,w)}static joinPath(D,...w){if(!D.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let M;return k.isWindows&&D.scheme==="file"?M=h.file(y.win32.join(a(D,!0),...w)).path:M=y.posix.join(D.path,...w),D.with({path:M})}toString(D=!1){return t(this,D)}toJSON(){return this}static revive(D){if(D){if(D instanceof h)return D;{const w=new g(D);return w._formatted=D.external??null,w._fsPath=D._sep===b?D.fsPath??null:null,w}}else return D}[Symbol.for("debug.description")](){return`URI(${this.toString()})`}}e.URI=h;function E(d){return!d||typeof d!="object"?!1:typeof d.scheme=="string"&&(typeof d.authority=="string"||typeof d.authority>"u")&&(typeof d.path=="string"||typeof d.path>"u")&&(typeof d.query=="string"||typeof d.query>"u")&&(typeof d.fragment=="string"||typeof d.fragment>"u")}const b=k.isWindows?1:void 0;class g extends h{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=a(this,!1)),this._fsPath}toString(D=!1){return D?t(this,!0):(this._formatted||(this._formatted=t(this,!1)),this._formatted)}toJSON(){const D={$mid:s.MarshalledId.Uri};return this._fsPath&&(D.fsPath=this._fsPath,D._sep=b),this._formatted&&(D.external=this._formatted),this.path&&(D.path=this.path),this.scheme&&(D.scheme=this.scheme),this.authority&&(D.authority=this.authority),this.query&&(D.query=this.query),this.fragment&&(D.fragment=this.fragment),D}}const I={[i.CharCode.Colon]:"%3A",[i.CharCode.Slash]:"%2F",[i.CharCode.QuestionMark]:"%3F",[i.CharCode.Hash]:"%23",[i.CharCode.OpenSquareBracket]:"%5B",[i.CharCode.CloseSquareBracket]:"%5D",[i.CharCode.AtSign]:"%40",[i.CharCode.ExclamationMark]:"%21",[i.CharCode.DollarSign]:"%24",[i.CharCode.Ampersand]:"%26",[i.CharCode.SingleQuote]:"%27",[i.CharCode.OpenParen]:"%28",[i.CharCode.CloseParen]:"%29",[i.CharCode.Asterisk]:"%2A",[i.CharCode.Plus]:"%2B",[i.CharCode.Comma]:"%2C",[i.CharCode.Semicolon]:"%3B",[i.CharCode.Equals]:"%3D",[i.CharCode.Space]:"%20"};function P(d,D,w){let M,T=-1;for(let C=0;C<d.length;C++){const L=d.charCodeAt(C);if(L>=i.CharCode.a&&L<=i.CharCode.z||L>=i.CharCode.A&&L<=i.CharCode.Z||L>=i.CharCode.Digit0&&L<=i.CharCode.Digit9||L===i.CharCode.Dash||L===i.CharCode.Period||L===i.CharCode.Underline||L===i.CharCode.Tilde||D&&L===i.CharCode.Slash||w&&L===i.CharCode.OpenSquareBracket||w&&L===i.CharCode.CloseSquareBracket||w&&L===i.CharCode.Colon)T!==-1&&(M+=encodeURIComponent(d.substring(T,C)),T=-1),M!==void 0&&(M+=d.charAt(C));else{M===void 0&&(M=d.substr(0,C));const _=I[L];_!==void 0?(T!==-1&&(M+=encodeURIComponent(d.substring(T,C)),T=-1),M+=_):T===-1&&(T=C)}}return T!==-1&&(M+=encodeURIComponent(d.substring(T))),M!==void 0?M:d}function r(d){let D;for(let w=0;w<d.length;w++){const M=d.charCodeAt(w);M===i.CharCode.Hash||M===i.CharCode.QuestionMark?(D===void 0&&(D=d.substr(0,w)),D+=I[M]):D!==void 0&&(D+=d[w])}return D!==void 0?D:d}function a(d,D){let w;return d.authority&&d.path.length>1&&d.scheme==="file"?w=`//${d.authority}${d.path}`:d.path.charCodeAt(0)===i.CharCode.Slash&&(d.path.charCodeAt(1)>=i.CharCode.A&&d.path.charCodeAt(1)<=i.CharCode.Z||d.path.charCodeAt(1)>=i.CharCode.a&&d.path.charCodeAt(1)<=i.CharCode.z)&&d.path.charCodeAt(2)===i.CharCode.Colon?D?w=d.path.substr(1):w=d.path[1].toLowerCase()+d.path.substr(2):w=d.path,k.isWindows&&(w=w.replace(/\//g,"\\")),w}function t(d,D){const w=D?r:P;let M="",{scheme:T,authority:C,path:L,query:_,fragment:V}=d;if(T&&(M+=T,M+=":"),(C||T==="file")&&(M+=v,M+=v),C){let z=C.indexOf("@");if(z!==-1){const Q=C.substr(0,z);C=C.substr(z+1),z=Q.lastIndexOf(":"),z===-1?M+=w(Q,!1,!1):(M+=w(Q.substr(0,z),!1,!1),M+=":",M+=w(Q.substr(z+1),!1,!0)),M+="@"}C=C.toLowerCase(),z=C.lastIndexOf(":"),z===-1?M+=w(C,!1,!0):(M+=w(C.substr(0,z),!1,!0),M+=C.substr(z))}if(L){if(L.length>=3&&L.charCodeAt(0)===i.CharCode.Slash&&L.charCodeAt(2)===i.CharCode.Colon){const z=L.charCodeAt(1);z>=i.CharCode.A&&z<=i.CharCode.Z&&(L=`/${String.fromCharCode(z+32)}:${L.substr(3)}`)}else if(L.length>=2&&L.charCodeAt(1)===i.CharCode.Colon){const z=L.charCodeAt(0);z>=i.CharCode.A&&z<=i.CharCode.Z&&(L=`${String.fromCharCode(z+32)}:${L.substr(2)}`)}M+=w(L,!0,!1)}return _&&(M+="?",M+=w(_,!1,!1)),V&&(M+="#",M+=D?V:P(V,!1,!1)),M}function o(d){try{return decodeURIComponent(d)}catch{return d.length>3?d.substr(0,3)+o(d.substr(3)):d}}const n=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function l(d){return d.match(n)?d.replace(n,D=>o(D)):d}}),define(le[159],ue([0,1,7]),function(j,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isRemoteConsoleLog=s,e.parse=y,e.getFirstFrame=k,e.log=R;function s(c){const m=c;return m&&typeof m.type=="string"&&typeof m.severity=="string"}function y(c){const m=[];let u;try{const p=JSON.parse(c.arguments),v=p[p.length-1];v&&v.__$stack&&(p.pop(),u=v.__$stack),m.push(...p)}catch{m.push("Unable to log remote console arguments",c.arguments)}return{args:m,stack:u}}function k(c){if(typeof c!="string")return k(y(c).stack);const m=c;if(m){const u=A(m),p=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(u||"");if(p&&p.length===4)return{uri:i.URI.file(p[1]),line:Number(p[2]),column:Number(p[3])}}}function A(c){if(!c)return c;const m=c.indexOf(`
`);return m===-1?c:c.substring(0,m)}function R(c,m){const{args:u,stack:p}=y(c),v=typeof u[0]=="string"&&u.length===1;let f=A(p);f&&(f=`(${f.trim()})`);let h=[];if(typeof u[0]=="string"?f&&v?h=[`%c[${m}] %c${u[0]} %c${f}`,S("blue"),S(""),S("grey")]:h=[`%c[${m}] %c${u[0]}`,S("blue"),S(""),...u.slice(1)]:h=[`%c[${m}]%`,S("blue"),...u],f&&!v&&h.push(f),typeof console[c.severity]!="function")throw new Error("Unknown console method");console[c.severity].apply(console,h)}function S(c){return`color: ${c}`}}),define(le[83],ue([0,1,17,7,92]),function(j,e,i,s,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.stringify=k,e.parse=A,e.revive=S;function k(c){return JSON.stringify(c,R)}function A(c){let m=JSON.parse(c);return m=S(m),m}function R(c,m){return m instanceof RegExp?{$mid:y.MarshalledId.Regexp,source:m.source,flags:m.flags}:m}function S(c,m=0){if(!c||m>200)return c;if(typeof c=="object"){switch(c.$mid){case y.MarshalledId.Uri:return s.URI.revive(c);case y.MarshalledId.Regexp:return new RegExp(c.source,c.flags);case y.MarshalledId.Date:return new Date(c.source)}if(c instanceof i.VSBuffer||c instanceof Uint8Array)return c;if(Array.isArray(c))for(let u=0;u<c.length;++u)c[u]=S(c[u],m+1);else for(const u in c)Object.hasOwnProperty.call(c,u)&&(c[u]=S(c[u],m+1))}return c}}),define(le[11],ue([0,1,15,3,25,7,10]),function(j,e,i,s,y,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.VSCODE_AUTHORITY=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0,e.matchesScheme=S,e.matchesSomeScheme=c,e.getServerRootPath=u,i=Re(i),s=Re(s),A=Re(A);var R;(function(f){f.inMemory="inmemory",f.vscode="vscode",f.internal="private",f.walkThrough="walkThrough",f.walkThroughSnippet="walkThroughSnippet",f.http="http",f.https="https",f.file="file",f.mailto="mailto",f.untitled="untitled",f.data="data",f.command="command",f.vscodeRemote="vscode-remote",f.vscodeRemoteResource="vscode-remote-resource",f.vscodeManagedRemoteResource="vscode-managed-remote-resource",f.vscodeUserData="vscode-userdata",f.vscodeCustomEditor="vscode-custom-editor",f.vscodeNotebookCell="vscode-notebook-cell",f.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",f.vscodeNotebookCellMetadataDiff="vscode-notebook-cell-metadata-diff",f.vscodeNotebookCellOutput="vscode-notebook-cell-output",f.vscodeNotebookCellOutputDiff="vscode-notebook-cell-output-diff",f.vscodeNotebookMetadata="vscode-notebook-metadata",f.vscodeInteractiveInput="vscode-interactive-input",f.vscodeSettings="vscode-settings",f.vscodeWorkspaceTrust="vscode-workspace-trust",f.vscodeTerminal="vscode-terminal",f.vscodeChatCodeBlock="vscode-chat-code-block",f.vscodeChatCodeCompareBlock="vscode-chat-code-compare-block",f.vscodeChatSesssion="vscode-chat-editor",f.webviewPanel="webview-panel",f.vscodeWebview="vscode-webview",f.extension="extension",f.vscodeFileResource="vscode-file",f.tmp="tmp",f.vsls="vsls",f.vscodeSourceControl="vscode-scm",f.commentsInput="comment",f.codeSetting="code-setting",f.outputChannel="output"})(R||(e.Schemas=R={}));function S(f,h){return k.URI.isUri(f)?(0,y.equalsIgnoreCase)(f.scheme,h):(0,y.startsWithIgnoreCase)(f,h+":")}function c(f,...h){return h.some(E=>S(f,E))}e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class m{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._serverRootPath="/"}setPreferredWebSchema(h){this._preferredWebSchema=h}setDelegate(h){this._delegate=h}setServerRootPath(h,E){this._serverRootPath=u(h,E)}getServerRootPath(){return this._serverRootPath}get _remoteResourcesPath(){return A.posix.join(this._serverRootPath,R.vscodeRemoteResource)}set(h,E,b){this._hosts[h]=E,this._ports[h]=b}setConnectionToken(h,E){this._connectionTokens[h]=E}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(h){if(this._delegate)try{return this._delegate(h)}catch(r){return i.onUnexpectedError(r),h}const E=h.authority;let b=this._hosts[E];b&&b.indexOf(":")!==-1&&b.indexOf("[")===-1&&(b=`[${b}]`);const g=this._ports[E],I=this._connectionTokens[E];let P=`path=${encodeURIComponent(h.path)}`;return typeof I=="string"&&(P+=`&${e.connectionTokenQueryName}=${encodeURIComponent(I)}`),k.URI.from({scheme:s.isWeb?this._preferredWebSchema:R.vscodeRemoteResource,authority:`${b}:${g}`,path:this._remoteResourcesPath,query:P})}}e.RemoteAuthorities=new m;function u(f,h){return A.posix.join(h??"/",`${f.quality??"oss"}-${f.commit??"dev"}`)}e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked",e.VSCODE_AUTHORITY="vscode-app";class p{static{this.FALLBACK_AUTHORITY=e.VSCODE_AUTHORITY}asBrowserUri(h){const E=this.toUri(h,j);return this.uriToBrowserUri(E)}uriToBrowserUri(h){return h.scheme===R.vscodeRemote?e.RemoteAuthorities.rewrite(h):h.scheme===R.file&&(s.isNative||s.webWorkerOrigin===`${R.vscodeFileResource}://${p.FALLBACK_AUTHORITY}`)?h.with({scheme:R.vscodeFileResource,authority:h.authority||p.FALLBACK_AUTHORITY,query:null,fragment:null}):h}asFileUri(h){const E=this.toUri(h,j);return this.uriToFileUri(E)}uriToFileUri(h){return h.scheme===R.vscodeFileResource?h.with({scheme:R.file,authority:h.authority!==p.FALLBACK_AUTHORITY?h.authority:null,query:null,fragment:null}):h}toUri(h,E){if(k.URI.isUri(h))return h;if(globalThis._VSCODE_FILE_ROOT){const b=globalThis._VSCODE_FILE_ROOT;if(/^\w[\w\d+.-]*:\/\//.test(b))return k.URI.joinPath(k.URI.parse(b,!0),h);const g=A.join(b,h);return k.URI.file(g)}return k.URI.parse(E.toUrl(h))}}e.FileAccess=new p;var v;(function(f){const h=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);f.CoopAndCoep=Object.freeze(h.get("3"));const E="vscode-coi";function b(I){let P;typeof I=="string"?P=new URL(I).searchParams:I instanceof URL?P=I.searchParams:k.URI.isUri(I)&&(P=new URL(I.toString(!0)).searchParams);const r=P?.get(E);if(r)return h.get(r)}f.getHeadersFromQuery=b;function g(I,P,r){if(!globalThis.crossOriginIsolated)return;const a=P&&r?"3":r?"2":"1";I instanceof URLSearchParams?I.set(E,a):I[E]=a}f.addSearchParam=g})(v||(e.COI=v={}))}),define(le[160],ue([0,1,66,11,3,12,7]),function(j,e,i,s,y,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.importAMDNodeModule=m,e.resolveAmdNodeModulePath=u,y=Re(y);class R{constructor(v,f,h){this.id=v,this.dependencies=f,this.callback=h}}class S{static{this.INSTANCE=new S}constructor(){this._isWebWorker=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this._isRenderer=typeof document=="object",this._defineCalls=[],this._initialized=!1}_initialize(){this._initialized||(this._initialized=!0,globalThis.define=(v,f,h)=>{typeof v!="string"&&(h=f,f=v,v=null),(typeof f!="object"||!Array.isArray(f))&&(h=f,f=null),this._defineCalls.push(new R(v,f,h))},globalThis.define.amd=!0,this._isRenderer?this._amdPolicy=globalThis._VSCODE_WEB_PACKAGE_TTP??window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(v){if(v.startsWith(window.location.origin)||v.startsWith(`${s.Schemas.vscodeFileResource}://${s.VSCODE_AUTHORITY}`))return v;throw new Error(`[trusted_script_src] Invalid script url: ${v}`)}}):this._isWebWorker&&(this._amdPolicy=globalThis._VSCODE_WEB_PACKAGE_TTP??globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(v){return v}})))}async load(v){this._initialize();const f=await(this._isWebWorker?this._workerLoadScript(v):this._isRenderer?this._rendererLoadScript(v):this._nodeJSLoadScript(v));if(!f){console.warn(`Did not receive a define call from script ${v}`);return}const h={},E=[],b=[];if(Array.isArray(f.dependencies))for(const g of f.dependencies)g==="exports"?E.push(h):b.push(g);if(b.length>0)throw new Error(`Cannot resolve dependencies for script ${v}. The dependencies are: ${b.join(", ")}`);return typeof f.callback=="function"?f.callback(...E)??h:f.callback}_rendererLoadScript(v){return new Promise((f,h)=>{const E=document.createElement("script");E.setAttribute("async","async"),E.setAttribute("type","text/javascript");const b=()=>{E.removeEventListener("load",g),E.removeEventListener("error",I)},g=P=>{b(),f(this._defineCalls.pop())},I=P=>{b(),h(P)};E.addEventListener("load",g),E.addEventListener("error",I),this._amdPolicy&&(v=this._amdPolicy.createScriptURL(v)),E.setAttribute("src",v),window.document.getElementsByTagName("head")[0].appendChild(E)})}async _workerLoadScript(v){return this._amdPolicy&&(v=this._amdPolicy.createScriptURL(v)),i.isESM?await new Promise((f,h)=>{j([v],f,h)}).then(Re):importScripts(v),this._defineCalls.pop()}async _nodeJSLoadScript(v){try{const f=globalThis._VSCODE_NODE_MODULES.fs,h=globalThis._VSCODE_NODE_MODULES.vm,E=globalThis._VSCODE_NODE_MODULES.module,b=A.URI.parse(v).fsPath,g=f.readFileSync(b).toString(),I=E.wrap(g.replace(/^#!.*/,""));return new h.Script(I).runInThisContext().apply(),this._defineCalls.pop()}catch(f){throw f}}}const c=new Map;async function m(p,v,f){if(i.isESM){f===void 0&&(f=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit);const h=v?`${p}/${v}`:p;if(c.has(h))return c.get(h);let E;if(/^\w[\w\d+.-]*:\/\//.test(h))E=h;else{const P=`${i.canASAR&&f&&!y.isWeb?s.nodeModulesAsarPath:s.nodeModulesPath}/${h}`;E=s.FileAccess.asBrowserUri(P).toString(!0)}const b=S.INSTANCE.load(E);return c.set(h,b),b}else return await new Promise((h,E)=>{j([p],h,E)}).then(Re)}function u(p,v){(0,k.assertType)(i.isESM);const h=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit,E=i.canASAR&&h&&!y.isWeb,b=`${p}/${v}`,I=`${E?s.nodeModulesAsarPath:s.nodeModulesPath}/${b}`;return s.FileAccess.asBrowserUri(I).toString(!0)}}),define(le[18],ue([0,1,39,32,11,10,3,25,7]),function(j,e,i,s,y,k,A,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=void 0,e.originalFSPath=c,e.distinctParents=u,e.toLocalResource=v,s=Re(s),k=Re(k);function c(f){return(0,S.uriToFsPath)(f,!0)}class m{constructor(h){this._ignorePathCasing=h}compare(h,E,b=!1){return h===E?0:(0,R.compare)(this.getComparisonKey(h,b),this.getComparisonKey(E,b))}isEqual(h,E,b=!1){return h===E?!0:!h||!E?!1:this.getComparisonKey(h,b)===this.getComparisonKey(E,b)}getComparisonKey(h,E=!1){return h.with({path:this._ignorePathCasing(h)?h.path.toLowerCase():void 0,fragment:E?null:void 0}).toString()}ignorePathCasing(h){return this._ignorePathCasing(h)}isEqualOrParent(h,E,b=!1){if(h.scheme===E.scheme){if(h.scheme===y.Schemas.file)return s.isEqualOrParent(c(h),c(E),this._ignorePathCasing(h))&&h.query===E.query&&(b||h.fragment===E.fragment);if((0,e.isEqualAuthority)(h.authority,E.authority))return s.isEqualOrParent(h.path,E.path,this._ignorePathCasing(h),"/")&&h.query===E.query&&(b||h.fragment===E.fragment)}return!1}joinPath(h,...E){return S.URI.joinPath(h,...E)}basenameOrAuthority(h){return(0,e.basename)(h)||h.authority}basename(h){return k.posix.basename(h.path)}extname(h){return k.posix.extname(h.path)}dirname(h){if(h.path.length===0)return h;let E;return h.scheme===y.Schemas.file?E=S.URI.file(k.dirname(c(h))).path:(E=k.posix.dirname(h.path),h.authority&&E.length&&E.charCodeAt(0)!==i.CharCode.Slash&&(console.error(`dirname("${h.toString})) resulted in a relative path`),E="/")),h.with({path:E})}normalizePath(h){if(!h.path.length)return h;let E;return h.scheme===y.Schemas.file?E=S.URI.file(k.normalize(c(h))).path:E=k.posix.normalize(h.path),h.with({path:E})}relativePath(h,E){if(h.scheme!==E.scheme||!(0,e.isEqualAuthority)(h.authority,E.authority))return;if(h.scheme===y.Schemas.file){const I=k.relative(c(h),c(E));return A.isWindows?s.toSlashes(I):I}let b=h.path||"/";const g=E.path||"/";if(this._ignorePathCasing(h)){let I=0;for(const P=Math.min(b.length,g.length);I<P&&!(b.charCodeAt(I)!==g.charCodeAt(I)&&b.charAt(I).toLowerCase()!==g.charAt(I).toLowerCase());I++);b=g.substr(0,I)+b.substr(I)}return k.posix.relative(b,g)}resolvePath(h,E){if(h.scheme===y.Schemas.file){const b=S.URI.file(k.resolve(c(h),E));return h.with({authority:b.authority,path:b.path})}return E=s.toPosixPath(E),h.with({path:k.posix.resolve(h.path,E)})}isAbsolutePath(h){return!!h.path&&h.path[0]==="/"}isEqualAuthority(h,E){return h===E||h!==void 0&&E!==void 0&&(0,R.equalsIgnoreCase)(h,E)}hasTrailingPathSeparator(h,E=k.sep){if(h.scheme===y.Schemas.file){const b=c(h);return b.length>s.getRoot(b).length&&b[b.length-1]===E}else{const b=h.path;return b.length>1&&b.charCodeAt(b.length-1)===i.CharCode.Slash&&!/^[a-zA-Z]:(\/$|\\$)/.test(h.fsPath)}}removeTrailingPathSeparator(h,E=k.sep){return(0,e.hasTrailingPathSeparator)(h,E)?h.with({path:h.path.substr(0,h.path.length-1)}):h}addTrailingPathSeparator(h,E=k.sep){let b=!1;if(h.scheme===y.Schemas.file){const g=c(h);b=g!==void 0&&g.length===s.getRoot(g).length&&g[g.length-1]===E}else{E="/";const g=h.path;b=g.length===1&&g.charCodeAt(g.length-1)===i.CharCode.Slash}return!b&&!(0,e.hasTrailingPathSeparator)(h,E)?h.with({path:h.path+"/"}):h}}e.ExtUri=m,e.extUri=new m(()=>!1),e.extUriBiasedIgnorePathCase=new m(f=>f.scheme===y.Schemas.file?!A.isLinux:!0),e.extUriIgnorePathCase=new m(f=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function u(f,h){const E=[];for(let b=0;b<f.length;b++){const g=h(f[b]);f.some((I,P)=>P===b?!1:(0,e.isEqualOrParent)(g,h(I)))||E.push(f[b])}return E}var p;(function(f){f.META_DATA_LABEL="label",f.META_DATA_DESCRIPTION="description",f.META_DATA_SIZE="size",f.META_DATA_MIME="mime";function h(E){const b=new Map;E.path.substring(E.path.indexOf(";")+1,E.path.lastIndexOf(";")).split(";").forEach(P=>{const[r,a]=P.split(":");r&&a&&b.set(r,a)});const I=E.path.substring(0,E.path.indexOf(";"));return I&&b.set(f.META_DATA_MIME,I),b}f.parseMetaData=h})(p||(e.DataUri=p={}));function v(f,h,E){if(h){let b=f.path;return b&&b[0]!==k.posix.sep&&(b=k.posix.sep+b),f.with({scheme:E,authority:h,path:b})}return f.with({scheme:E})}}),define(le[8],ue([0,1,22,15,4,2,18,3,150,67]),function(j,e,i,s,y,k,A,R,S,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AsyncIterableSource=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.LazyStatefulPromise=e.StatefulPromise=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.GlobalIdleValue=e.AbstractIdleValue=e._runWhenIdle=e.runWhenGlobalIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.LimitedQueue=e.Queue=e.Limiter=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=void 0,e.isThenable=m,e.createCancelablePromise=u,e.raceCancellation=p,e.raceCancellationError=v,e.raceCancellablePromises=f,e.raceTimeout=h,e.asPromise=E,e.promiseWithResolvers=b,e.timeout=d,e.disposableTimeout=D,e.sequence=w,e.first=M,e.firstParallel=T,e.retry=x,e.createCancelableAsyncIterable=F;function m(G){return!!G&&typeof G.then=="function"}function u(G){const $=new i.CancellationTokenSource,Z=G($.token),ae=new Promise((pe,Se)=>{const ye=$.token.onCancellationRequested(()=>{ye.dispose(),Se(new s.CancellationError)});Promise.resolve(Z).then(We=>{ye.dispose(),$.dispose(),pe(We)},We=>{ye.dispose(),$.dispose(),Se(We)})});return new class{cancel(){$.cancel(),$.dispose()}then(pe,Se){return ae.then(pe,Se)}catch(pe){return this.then(void 0,pe)}finally(pe){return ae.finally(pe)}}}function p(G,$,Z){return new Promise((ae,pe)=>{const Se=$.onCancellationRequested(()=>{Se.dispose(),ae(Z)});G.then(ae,pe).finally(()=>Se.dispose())})}function v(G,$){return new Promise((Z,ae)=>{const pe=$.onCancellationRequested(()=>{pe.dispose(),ae(new s.CancellationError)});G.then(Z,ae).finally(()=>pe.dispose())})}async function f(G){let $=-1;const Z=G.map((ae,pe)=>ae.then(Se=>($=pe,Se)));try{return await Promise.race(Z)}finally{G.forEach((ae,pe)=>{pe!==$&&ae.cancel()})}}function h(G,$,Z){let ae;const pe=setTimeout(()=>{ae?.(void 0),Z?.()},$);return Promise.race([G.finally(()=>clearTimeout(pe)),new Promise(Se=>ae=Se)])}function E(G){return new Promise(($,Z)=>{const ae=G();m(ae)?ae.then($,Z):$(ae)})}function b(){let G,$;return{promise:new Promise((ae,pe)=>{G=ae,$=pe}),resolve:G,reject:$}}class g{constructor(){this.isDisposed=!1,this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue($){if(this.isDisposed)return Promise.reject(new Error("Throttler is disposed"));if(this.activePromise){if(this.queuedPromiseFactory=$,!this.queuedPromise){const Z=()=>{if(this.queuedPromise=null,this.isDisposed)return;const ae=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,ae};this.queuedPromise=new Promise(ae=>{this.activePromise.then(Z,Z).then(ae)})}return new Promise((Z,ae)=>{this.queuedPromise.then(Z,ae)})}return this.activePromise=$(),new Promise((Z,ae)=>{this.activePromise.then(pe=>{this.activePromise=null,Z(pe)},pe=>{this.activePromise=null,ae(pe)})})}dispose(){this.isDisposed=!0}}e.Throttler=g;class I{constructor(){this.current=Promise.resolve(null)}queue($){return this.current=this.current.then(()=>$(),()=>$())}}e.Sequencer=I;class P{constructor(){this.promiseMap=new Map}queue($,Z){const pe=(this.promiseMap.get($)??Promise.resolve()).catch(()=>{}).then(Z).finally(()=>{this.promiseMap.get($)===pe&&this.promiseMap.delete($)});return this.promiseMap.set($,pe),pe}}e.SequencerByKey=P;const r=(G,$)=>{let Z=!0;const ae=setTimeout(()=>{Z=!1,$()},G);return{isTriggered:()=>Z,dispose:()=>{clearTimeout(ae),Z=!1}}},a=G=>{let $=!0;return queueMicrotask(()=>{$&&($=!1,G())}),{isTriggered:()=>$,dispose:()=>{$=!1}}};class t{constructor($){this.defaultDelay=$,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger($,Z=this.defaultDelay){this.task=$,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((pe,Se)=>{this.doResolve=pe,this.doReject=Se}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const pe=this.task;return this.task=null,pe()}}));const ae=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=Z===S.MicrotaskDelay?a(ae):r(Z,ae),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new s.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=t;class o{constructor($){this.delayer=new t($),this.throttler=new g}trigger($,Z){return this.delayer.trigger(()=>this.throttler.queue($),Z)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose(),this.throttler.dispose()}}e.ThrottledDelayer=o;class n{constructor(){this._isOpen=!1,this._promise=new Promise(($,Z)=>{this._completePromise=$})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=n;class l extends n{constructor($){super(),this._timeout=setTimeout(()=>this.open(),$)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=l;function d(G,$){return $?new Promise((Z,ae)=>{const pe=setTimeout(()=>{Se.dispose(),Z()},G),Se=$.onCancellationRequested(()=>{clearTimeout(pe),Se.dispose(),ae(new s.CancellationError)})}):u(Z=>d(G,Z))}function D(G,$=0,Z){const ae=setTimeout(()=>{G(),Z&&pe.dispose()},$),pe=(0,k.toDisposable)(()=>{clearTimeout(ae),Z?.deleteAndLeak(pe)});return Z?.add(pe),pe}function w(G){const $=[];let Z=0;const ae=G.length;function pe(){return Z<ae?G[Z++]():null}function Se(ye){ye!=null&&$.push(ye);const We=pe();return We?We.then(Se):Promise.resolve($)}return Promise.resolve(null).then(Se)}function M(G,$=ae=>!!ae,Z=null){let ae=0;const pe=G.length,Se=()=>{if(ae>=pe)return Promise.resolve(Z);const ye=G[ae++];return Promise.resolve(ye()).then(He=>$(He)?Promise.resolve(He):Se())};return Se()}function T(G,$=ae=>!!ae,Z=null){if(G.length===0)return Promise.resolve(Z);let ae=G.length;const pe=()=>{ae=-1;for(const Se of G)Se.cancel?.()};return new Promise((Se,ye)=>{for(const We of G)We.then(He=>{--ae>=0&&$(He)?(pe(),Se(He)):ae===0&&Se(Z)}).catch(He=>{--ae>=0&&(pe(),ye(He))})})}class C{constructor($){this._size=0,this._isDisposed=!1,this.maxDegreeOfParalellism=$,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new y.Emitter}whenIdle(){return this.size>0?y.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this._onDrained.event}get size(){return this._size}queue($){if(this._isDisposed)throw new Error("Object has been disposed");return this._size++,new Promise((Z,ae)=>{this.outstandingPromises.push({factory:$,c:Z,e:ae}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const $=this.outstandingPromises.shift();this.runningPromises++;const Z=$.factory();Z.then($.c,$.e),Z.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._isDisposed||(this.runningPromises--,--this._size===0&&this._onDrained.fire(),this.outstandingPromises.length>0&&this.consume())}clear(){if(this._isDisposed)throw new Error("Object has been disposed");this.outstandingPromises.length=0,this._size=this.runningPromises}dispose(){this._isDisposed=!0,this.outstandingPromises.length=0,this._size=0,this._onDrained.dispose()}}e.Limiter=C;class L extends C{constructor(){super(1)}}e.Queue=L;class _{constructor(){this.sequentializer=new W,this.tasks=0}queue($){return this.sequentializer.isRunning()?this.sequentializer.queue(()=>this.sequentializer.run(this.tasks++,$())):this.sequentializer.run(this.tasks++,$())}}e.LimitedQueue=_;class V{constructor(){this.queues=new Map,this.drainers=new Set,this.drainListeners=void 0,this.drainListenerCount=0}async whenDrained(){if(this.isDrained())return;const $=new H;return this.drainers.add($),$.p}isDrained(){for(const[,$]of this.queues)if($.size>0)return!1;return!0}queueSize($,Z=A.extUri){const ae=Z.getComparisonKey($);return this.queues.get(ae)?.size??0}queueFor($,Z,ae=A.extUri){const pe=ae.getComparisonKey($);let Se=this.queues.get(pe);if(!Se){Se=new L;const ye=this.drainListenerCount++,We=y.Event.once(Se.onDrained)(()=>{Se?.dispose(),this.queues.delete(pe),this.onDidQueueDrain(),this.drainListeners?.deleteAndDispose(ye),this.drainListeners?.size===0&&(this.drainListeners.dispose(),this.drainListeners=void 0)});this.drainListeners||(this.drainListeners=new k.DisposableMap),this.drainListeners.set(ye,We),this.queues.set(pe,Se)}return Se.queue(Z)}onDidQueueDrain(){this.isDrained()&&this.releaseDrainers()}releaseDrainers(){for(const $ of this.drainers)$.complete();this.drainers.clear()}dispose(){for(const[,$]of this.queues)$.dispose();this.queues.clear(),this.releaseDrainers(),this.drainListeners?.dispose()}}e.ResourceQueue=V;class z{constructor($,Z){this._isDisposed=!1,this._token=-1,typeof $=="function"&&typeof Z=="number"&&this.setIfNotSet($,Z)}dispose(){this.cancel(),this._isDisposed=!0}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet($,Z){if(this._isDisposed)throw new s.BugIndicatingError("Calling 'cancelAndSet' on a disposed TimeoutTimer");this.cancel(),this._token=setTimeout(()=>{this._token=-1,$()},Z)}setIfNotSet($,Z){if(this._isDisposed)throw new s.BugIndicatingError("Calling 'setIfNotSet' on a disposed TimeoutTimer");this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,$()},Z))}}e.TimeoutTimer=z;class Q{constructor(){this.disposable=void 0,this.isDisposed=!1}cancel(){this.disposable?.dispose(),this.disposable=void 0}cancelAndSet($,Z,ae=globalThis){if(this.isDisposed)throw new s.BugIndicatingError("Calling 'cancelAndSet' on a disposed IntervalTimer");this.cancel();const pe=ae.setInterval(()=>{$()},Z);this.disposable=(0,k.toDisposable)(()=>{ae.clearInterval(pe),this.disposable=void 0})}dispose(){this.cancel(),this.isDisposed=!0}}e.IntervalTimer=Q;class fe{constructor($,Z){this.timeoutToken=-1,this.runner=$,this.timeout=Z,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule($=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,$)}get delay(){return this.timeout}set delay($){this.timeout=$}isScheduled(){return this.timeoutToken!==-1}flush(){this.isScheduled()&&(this.cancel(),this.doRun())}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}e.RunOnceScheduler=fe;class se{constructor($,Z){Z%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${Z}ms is not a multiple of 1000ms.`),this.runner=$,this.timeout=Z,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule($=this.timeout){$%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${$}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil($/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}e.ProcessTimeRunOnceScheduler=se;class ee extends fe{constructor($,Z){super($,Z),this.units=[]}work($){this.units.push($),this.isScheduled()||this.schedule()}doRun(){const $=this.units;this.units=[],this.runner?.($)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=ee;class U extends k.Disposable{constructor($,Z){super(),this.options=$,this.handler=Z,this.pendingWork=[],this.throttler=this._register(new k.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work($){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+$.length>this.options.maxBufferedWork)return!1}else if(this.pending+$.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}for(const Z of $)this.pendingWork.push(Z);return this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new fe(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=U,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e._runWhenIdle=(G,$)=>{(0,R.setTimeout0)(()=>{if(Z)return;const ae=Date.now()+15;$(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,ae-Date.now())}}))});let Z=!1;return{dispose(){Z||(Z=!0)}}}:e._runWhenIdle=(G,$,Z)=>{const ae=G.requestIdleCallback($,typeof Z=="number"?{timeout:Z}:void 0);let pe=!1;return{dispose(){pe||(pe=!0,G.cancelIdleCallback(ae))}}},e.runWhenGlobalIdle=G=>(0,e._runWhenIdle)(globalThis,G)}();class K{constructor($,Z){this._didRun=!1,this._executor=()=>{try{this._value=Z()}catch(ae){this._error=ae}finally{this._didRun=!0}},this._handle=(0,e._runWhenIdle)($,()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.AbstractIdleValue=K;class N extends K{constructor($){super(globalThis,$)}}e.GlobalIdleValue=N;async function x(G,$,Z){let ae;for(let pe=0;pe<Z;pe++)try{return await G()}catch(Se){ae=Se,await d($)}throw ae}class W{isRunning($){return typeof $=="number"?this._running?.taskId===$:!!this._running}get running(){return this._running?.promise}cancelRunning(){this._running?.cancel()}run($,Z,ae){return this._running={taskId:$,cancel:()=>ae?.(),promise:Z},Z.then(()=>this.doneRunning($),()=>this.doneRunning($)),Z}doneRunning($){this._running&&$===this._running.taskId&&(this._running=void 0,this.runQueued())}runQueued(){if(this._queued){const $=this._queued;this._queued=void 0,$.run().then($.promiseResolve,$.promiseReject)}}queue($){if(this._queued)this._queued.run=$;else{const{promise:Z,resolve:ae,reject:pe}=b();this._queued={run:$,promise:Z,promiseResolve:ae,promiseReject:pe}}return this._queued.promise}hasQueued(){return!!this._queued}async join(){return this._queued?.promise??this._running?.promise}}e.TaskSequentializer=W;class q{constructor($,Z=()=>Date.now()){this.interval=$,this.nowFn=Z,this.lastIncrementTime=0,this.value=0}increment(){const $=this.nowFn();return $-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=$,this.value=0),this.value++,this.value}}e.IntervalCounter=q;var ie;(function(G){G[G.Resolved=0]="Resolved",G[G.Rejected=1]="Rejected"})(ie||(ie={}));class H{get isRejected(){return this.outcome?.outcome===ie.Rejected}get isResolved(){return this.outcome?.outcome===ie.Resolved}get isSettled(){return!!this.outcome}get value(){return this.outcome?.outcome===ie.Resolved?this.outcome?.value:void 0}constructor(){this.p=new Promise(($,Z)=>{this.completeCallback=$,this.errorCallback=Z})}complete($){return new Promise(Z=>{this.completeCallback($),this.outcome={outcome:ie.Resolved,value:$},Z()})}error($){return new Promise(Z=>{this.errorCallback($),this.outcome={outcome:ie.Rejected,value:$},Z()})}cancel(){return this.error(new s.CancellationError)}}e.DeferredPromise=H;var ce;(function(G){async function $(ae){let pe;const Se=await Promise.all(ae.map(ye=>ye.then(We=>We,We=>{pe||(pe=We)})));if(typeof pe<"u")throw pe;return Se}G.settled=$;function Z(ae){return new Promise(async(pe,Se)=>{try{await ae(pe,Se)}catch(ye){Se(ye)}})}G.withAsyncBody=Z})(ce||(e.Promises=ce={}));class oe{get value(){return this._value}get error(){return this._error}get isResolved(){return this._isResolved}constructor($){this._value=void 0,this._error=void 0,this._isResolved=!1,this.promise=$.then(Z=>(this._value=Z,this._isResolved=!0,Z),Z=>{throw this._error=Z,this._isResolved=!0,Z})}requireValue(){if(!this._isResolved)throw new s.BugIndicatingError("Promise is not resolved yet");if(this._error)throw this._error;return this._value}}e.StatefulPromise=oe;class te{constructor($){this._compute=$,this._promise=new c.Lazy(()=>new oe(this._compute()))}requireValue(){return this._promise.value.requireValue()}getPromise(){return this._promise.value.promise}get currentValue(){return this._promise.rawValue?.value}}e.LazyStatefulPromise=te;var O;(function(G){G[G.Initial=0]="Initial",G[G.DoneOK=1]="DoneOK",G[G.DoneError=2]="DoneError"})(O||(O={}));class X{static fromArray($){return new X(Z=>{Z.emitMany($)})}static fromPromise($){return new X(async Z=>{Z.emitMany(await $)})}static fromPromises($){return new X(async Z=>{await Promise.all($.map(async ae=>Z.emitOne(await ae)))})}static merge($){return new X(async Z=>{await Promise.all($.map(async ae=>{for await(const pe of ae)Z.emitOne(pe)}))})}static{this.EMPTY=X.fromArray([])}constructor($,Z){this._state=O.Initial,this._results=[],this._error=null,this._onReturn=Z,this._onStateChanged=new y.Emitter,queueMicrotask(async()=>{const ae={emitOne:pe=>this.emitOne(pe),emitMany:pe=>this.emitMany(pe),reject:pe=>this.reject(pe)};try{await Promise.resolve($(ae)),this.resolve()}catch(pe){this.reject(pe)}finally{ae.emitOne=void 0,ae.emitMany=void 0,ae.reject=void 0}})}[Symbol.asyncIterator](){let $=0;return{next:async()=>{do{if(this._state===O.DoneError)throw this._error;if($<this._results.length)return{done:!1,value:this._results[$++]};if(this._state===O.DoneOK)return{done:!0,value:void 0};await y.Event.toPromise(this._onStateChanged.event)}while(!0)},return:async()=>(this._onReturn?.(),{done:!0,value:void 0})}}static map($,Z){return new X(async ae=>{for await(const pe of $)ae.emitOne(Z(pe))})}map($){return X.map(this,$)}static filter($,Z){return new X(async ae=>{for await(const pe of $)Z(pe)&&ae.emitOne(pe)})}filter($){return X.filter(this,$)}static coalesce($){return X.filter($,Z=>!!Z)}coalesce(){return X.coalesce(this)}static async toPromise($){const Z=[];for await(const ae of $)Z.push(ae);return Z}toPromise(){return X.toPromise(this)}emitOne($){this._state===O.Initial&&(this._results.push($),this._onStateChanged.fire())}emitMany($){this._state===O.Initial&&(this._results=this._results.concat($),this._onStateChanged.fire())}resolve(){this._state===O.Initial&&(this._state=O.DoneOK,this._onStateChanged.fire())}reject($){this._state===O.Initial&&(this._state=O.DoneError,this._error=$,this._onStateChanged.fire())}}e.AsyncIterableObject=X;class B extends X{constructor($,Z){super(Z),this._source=$}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=B;function F(G){const $=new i.CancellationTokenSource,Z=G($.token);return new B($,async ae=>{const pe=$.token.onCancellationRequested(()=>{pe.dispose(),$.dispose(),ae.reject(new s.CancellationError)});try{for await(const Se of Z){if($.token.isCancellationRequested)return;ae.emitOne(Se)}pe.dispose(),$.dispose()}catch(Se){pe.dispose(),$.dispose(),ae.reject(Se)}})}class J{constructor($){this._deferred=new H,this._asyncIterable=new X(pe=>{if(Z){pe.reject(Z);return}return ae&&pe.emitMany(ae),this._errorFn=Se=>pe.reject(Se),this._emitFn=Se=>pe.emitOne(Se),this._deferred.p},$);let Z,ae;this._emitFn=pe=>{ae||(ae=[]),ae.push(pe)},this._errorFn=pe=>{Z||(Z=pe)}}get asyncIterable(){return this._asyncIterable}resolve(){this._deferred.complete()}reject($){this._errorFn($),this._deferred.complete()}emitOne($){this._emitFn($)}}e.AsyncIterableSource=J}),define(le[116],ue([0,1,21,8,39,32,31,10,3,25]),function(j,e,i,s,y,k,A,R,S,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.GLOB_SPLIT=e.GLOBSTAR=void 0,e.getEmptyExpression=m,e.splitGlobAware=h,e.match=_,e.parse=V,e.isRelativePattern=z,e.getBasenameTerms=Q,e.getPathTerms=fe,e.patternsEquals=K;function m(){return Object.create(null)}e.GLOBSTAR="**",e.GLOB_SPLIT="/";const u="[/\\\\]",p="[^/\\\\]",v=/\//g;function f(N,x){switch(N){case 0:return"";case 1:return`${p}*?`;default:return`(?:${u}|${p}+${u}${x?`|${u}${p}+`:""})*?`}}function h(N,x){if(!N)return[];const W=[];let q=!1,ie=!1,H="";for(const ce of N){switch(ce){case x:if(!q&&!ie){W.push(H),H="";continue}break;case"{":q=!0;break;case"}":q=!1;break;case"[":ie=!0;break;case"]":ie=!1;break}H+=ce}return H&&W.push(H),W}function E(N){if(!N)return"";let x="";const W=h(N,e.GLOB_SPLIT);if(W.every(q=>q===e.GLOBSTAR))x=".*";else{let q=!1;W.forEach((ie,H)=>{if(ie===e.GLOBSTAR){if(q)return;x+=f(2,H===W.length-1)}else{let ce=!1,oe="",te=!1,O="";for(const X of ie){if(X!=="}"&&ce){oe+=X;continue}if(te&&(X!=="]"||!O)){let B;X==="-"?B=X:(X==="^"||X==="!")&&!O?B="^":X===e.GLOB_SPLIT?B="":B=(0,c.escapeRegExpCharacters)(X),O+=B;continue}switch(X){case"{":ce=!0;continue;case"[":te=!0;continue;case"}":{const F=`(?:${h(oe,",").map(J=>E(J)).join("|")})`;x+=F,ce=!1,oe="";break}case"]":{x+="["+O+"]",te=!1,O="";break}case"?":x+=p;continue;case"*":x+=f(1);continue;default:x+=(0,c.escapeRegExpCharacters)(X)}}H<W.length-1&&(W[H+1]!==e.GLOBSTAR||H+2<W.length)&&(x+=u)}q=ie===e.GLOBSTAR})}return x}const b=/^\*\*\/\*\.[\w\.-]+$/,g=/^\*\*\/([\w\.-]+)\/?$/,I=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,P=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,r=/^\*\*((\/[\w\.-]+)+)\/?$/,a=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new A.LRUCache(1e4),o=function(){return!1},n=function(){return null};function l(N,x){if(!N)return n;let W;typeof N!="string"?W=N.pattern:W=N,W=W.trim();const q=`${W}_${!!x.trimForExclusions}`;let ie=t.get(q);if(ie)return d(ie,N);let H;return b.test(W)?ie=w(W.substr(4),W):(H=g.exec(D(W,x)))?ie=M(H[1],W):(x.trimForExclusions?P:I).test(W)?ie=T(W,x):(H=r.exec(D(W,x)))?ie=C(H[1].substr(1),W,!0):(H=a.exec(D(W,x)))?ie=C(H[1],W,!1):ie=L(W),t.set(q,ie),d(ie,N)}function d(N,x){if(typeof x=="string")return N;const W=function(q,ie){return(0,k.isEqualOrParent)(q,x.base,!S.isLinux)?N((0,c.ltrim)(q.substr(x.base.length),R.sep),ie):null};return W.allBasenames=N.allBasenames,W.allPaths=N.allPaths,W.basenames=N.basenames,W.patterns=N.patterns,W}function D(N,x){return x.trimForExclusions&&N.endsWith("/**")?N.substr(0,N.length-2):N}function w(N,x){return function(W,q){return typeof W=="string"&&W.endsWith(N)?x:null}}function M(N,x){const W=`/${N}`,q=`\\${N}`,ie=function(ce,oe){return typeof ce!="string"?null:oe?oe===N?x:null:ce===N||ce.endsWith(W)||ce.endsWith(q)?x:null},H=[N];return ie.basenames=H,ie.patterns=[x],ie.allBasenames=H,ie}function T(N,x){const W=U(N.slice(1,-1).split(",").map(oe=>l(oe,x)).filter(oe=>oe!==n),N),q=W.length;if(!q)return n;if(q===1)return W[0];const ie=function(oe,te){for(let O=0,X=W.length;O<X;O++)if(W[O](oe,te))return N;return null},H=W.find(oe=>!!oe.allBasenames);H&&(ie.allBasenames=H.allBasenames);const ce=W.reduce((oe,te)=>te.allPaths?oe.concat(te.allPaths):oe,[]);return ce.length&&(ie.allPaths=ce),ie}function C(N,x,W){const q=R.sep===R.posix.sep,ie=q?N:N.replace(v,R.sep),H=R.sep+ie,ce=R.posix.sep+N;let oe;return W?oe=function(te,O){return typeof te=="string"&&(te===ie||te.endsWith(H)||!q&&(te===N||te.endsWith(ce)))?x:null}:oe=function(te,O){return typeof te=="string"&&(te===ie||!q&&te===N)?x:null},oe.allPaths=[(W?"*/":"./")+N],oe}function L(N){try{const x=new RegExp(`^${E(N)}$`);return function(W){return x.lastIndex=0,typeof W=="string"&&x.test(W)?N:null}}catch{return n}}function _(N,x,W){return!N||typeof x!="string"?!1:V(N)(x,void 0,W)}function V(N,x={}){if(!N)return o;if(typeof N=="string"||z(N)){const W=l(N,x);if(W===n)return o;const q=function(ie,H){return!!W(ie,H)};return W.allBasenames&&(q.allBasenames=W.allBasenames),W.allPaths&&(q.allPaths=W.allPaths),q}return se(N,x)}function z(N){const x=N;return x?typeof x.base=="string"&&typeof x.pattern=="string":!1}function Q(N){return N.allBasenames||[]}function fe(N){return N.allPaths||[]}function se(N,x){const W=U(Object.getOwnPropertyNames(N).map(oe=>ee(oe,N[oe],x)).filter(oe=>oe!==n)),q=W.length;if(!q)return n;if(!W.some(oe=>!!oe.requiresSiblings)){if(q===1)return W[0];const oe=function(X,B){let F;for(let J=0,G=W.length;J<G;J++){const $=W[J](X,B);if(typeof $=="string")return $;(0,s.isThenable)($)&&(F||(F=[]),F.push($))}return F?(async()=>{for(const J of F){const G=await J;if(typeof G=="string")return G}return null})():null},te=W.find(X=>!!X.allBasenames);te&&(oe.allBasenames=te.allBasenames);const O=W.reduce((X,B)=>B.allPaths?X.concat(B.allPaths):X,[]);return O.length&&(oe.allPaths=O),oe}const ie=function(oe,te,O){let X,B;for(let F=0,J=W.length;F<J;F++){const G=W[F];G.requiresSiblings&&O&&(te||(te=(0,R.basename)(oe)),X||(X=te.substr(0,te.length-(0,R.extname)(oe).length)));const $=G(oe,te,X,O);if(typeof $=="string")return $;(0,s.isThenable)($)&&(B||(B=[]),B.push($))}return B?(async()=>{for(const F of B){const J=await F;if(typeof J=="string")return J}return null})():null},H=W.find(oe=>!!oe.allBasenames);H&&(ie.allBasenames=H.allBasenames);const ce=W.reduce((oe,te)=>te.allPaths?oe.concat(te.allPaths):oe,[]);return ce.length&&(ie.allPaths=ce),ie}function ee(N,x,W){if(x===!1)return n;const q=l(N,W);if(q===n)return n;if(typeof x=="boolean")return q;if(x){const ie=x.when;if(typeof ie=="string"){const H=(ce,oe,te,O)=>{if(!O||!q(ce,oe))return null;const X=ie.replace("$(basename)",()=>te),B=O(X);return(0,s.isThenable)(B)?B.then(F=>F?N:null):B?N:null};return H.requiresSiblings=!0,H}}return q}function U(N,x){const W=N.filter(oe=>!!oe.basenames);if(W.length<2)return N;const q=W.reduce((oe,te)=>{const O=te.basenames;return O?oe.concat(O):oe},[]);let ie;if(x){ie=[];for(let oe=0,te=q.length;oe<te;oe++)ie.push(x)}else ie=W.reduce((oe,te)=>{const O=te.patterns;return O?oe.concat(O):oe},[]);const H=function(oe,te){if(typeof oe!="string")return null;if(!te){let X;for(X=oe.length;X>0;X--){const B=oe.charCodeAt(X-1);if(B===y.CharCode.Slash||B===y.CharCode.Backslash)break}te=oe.substr(X)}const O=q.indexOf(te);return O!==-1?ie[O]:null};H.basenames=q,H.patterns=ie,H.allBasenames=q;const ce=N.filter(oe=>!oe.basenames);return ce.push(H),ce}function K(N,x){return(0,i.equals)(N,x,(W,q)=>typeof W=="string"&&typeof q=="string"?W===q:typeof W!="string"&&typeof q!="string"?W.base===q.base&&W.pattern===q.pattern:!1)}}),define(le[49],ue([0,1,21,32,10,3,18,25]),function(j,e,i,s,y,k,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathLabel=S,e.normalizeDriveLetter=m,e.tildify=p,e.untildify=v,e.shorten=b,e.template=I,e.mnemonicMenuLabel=P,e.mnemonicButtonLabel=r,e.unmnemonicLabel=a,e.splitRecentLabel=t;function S(n,l){const{os:d,tildify:D,relative:w}=l;if(w){const C=c(n,w,d);if(typeof C=="string")return C}let M=n.fsPath;if(d===k.OperatingSystem.Windows&&!k.isWindows?M=M.replace(/\//g,"\\"):d!==k.OperatingSystem.Windows&&k.isWindows&&(M=M.replace(/\\/g,"/")),d!==k.OperatingSystem.Windows&&D?.userHome){const C=D.userHome.fsPath;let L;n.scheme!==D.userHome.scheme&&n.path[0]===y.posix.sep&&n.path[1]!==y.posix.sep?L=D.userHome.with({path:n.path}).fsPath:L=M,M=p(L,C,d)}return(d===k.OperatingSystem.Windows?y.win32:y.posix).normalize(m(M,d===k.OperatingSystem.Windows))}function c(n,l,d){const D=d===k.OperatingSystem.Windows?y.win32:y.posix,w=d===k.OperatingSystem.Linux?A.extUri:A.extUriIgnorePathCase,M=l.getWorkspace(),T=(0,i.firstOrDefault)(M.folders);if(!T)return;n.scheme!==T.uri.scheme&&n.path[0]===y.posix.sep&&n.path[1]!==y.posix.sep&&(n=T.uri.with({path:n.path}));const C=l.getWorkspaceFolder(n);if(!C)return;let L;if(w.isEqual(C.uri,n)?L="":L=w.relativePath(C.uri,n)??"",L&&(L=D.normalize(L)),M.folders.length>1&&!l.noPrefix){const _=C.name?C.name:w.basenameOrAuthority(C.uri);L=L?`${_} \u2022 ${L}`:_}return L}function m(n,l=k.isWindows){return(0,s.hasDriveLetter)(n,l)?n.charAt(0).toUpperCase()+n.slice(1):n}let u=Object.create(null);function p(n,l,d=k.OS){if(d===k.OperatingSystem.Windows||!n||!l)return n;let D=u.original===l?u.normalized:void 0;D||(D=l,k.isWindows&&(D=(0,s.toSlashes)(D)),D=`${(0,R.rtrim)(D,y.posix.sep)}${y.posix.sep}`,u={original:l,normalized:D});let w=n;return k.isWindows&&(w=(0,s.toSlashes)(w)),(d===k.OperatingSystem.Linux?w.startsWith(D):(0,R.startsWithIgnoreCase)(w,D))?`~/${w.substr(D.length)}`:n}function v(n,l){return n.replace(/^~($|\/|\\)/,`${l}$1`)}const f="\u2026",h="\\\\",E="~";function b(n,l=y.sep){const d=new Array(n.length);let D=!1;for(let w=0;w<n.length;w++){const M=n[w];if(M===""){d[w]=`.${l}`;continue}if(!M){d[w]=M;continue}D=!0;let T="",C=M;C.indexOf(h)===0?(T=C.substr(0,C.indexOf(h)+h.length),C=C.substr(C.indexOf(h)+h.length)):C.indexOf(l)===0?(T=C.substr(0,C.indexOf(l)+l.length),C=C.substr(C.indexOf(l)+l.length)):C.indexOf(E)===0&&(T=C.substr(0,C.indexOf(E)+E.length),C=C.substr(C.indexOf(E)+E.length));const L=C.split(l);for(let _=1;D&&_<=L.length;_++)for(let V=L.length-_;D&&V>=0;V--){D=!1;let z=L.slice(V,V+_).join(l);for(let Q=0;!D&&Q<n.length;Q++)if(Q!==w&&n[Q]&&n[Q].indexOf(z)>-1){const fe=V+_===L.length,se=V>0&&n[Q].indexOf(l)>-1?l+z:z,ee=n[Q].endsWith(se);D=!fe||ee}if(!D){let Q="";(L[0].endsWith(":")||T!=="")&&(V===1&&(V=0,_++,z=L[0]+l+z),V>0&&(Q=L[0]+l),Q=T+Q),V>0&&(Q=Q+f+l),Q=Q+z,V+_<L.length&&(Q=Q+l+f),d[w]=Q}}D&&(d[w]=M)}return d}var g;(function(n){n[n.TEXT=0]="TEXT",n[n.VARIABLE=1]="VARIABLE",n[n.SEPARATOR=2]="SEPARATOR"})(g||(g={}));function I(n,l=Object.create(null)){const d=[];let D=!1,w="";for(const M of n)if(M==="$"||D&&M==="{")w&&d.push({value:w,type:g.TEXT}),w="",D=!0;else if(M==="}"&&D){const T=l[w];if(typeof T=="string")T.length&&d.push({value:T,type:g.VARIABLE});else if(T){const C=d[d.length-1];(!C||C.type!==g.SEPARATOR)&&d.push({value:T.label,type:g.SEPARATOR})}w="",D=!1}else w+=M;return w&&!D&&d.push({value:w,type:g.TEXT}),d.filter((M,T)=>{if(M.type===g.SEPARATOR){const C=d[T-1],L=d[T+1];return[C,L].every(_=>_&&(_.type===g.VARIABLE||_.type===g.TEXT)&&_.value.length>0)}return!0}).map(M=>M.value).join("")}function P(n,l){return k.isMacintosh||l?n.replace(/\(&&\w\)|&&/g,"").replace(/&/g,k.isMacintosh?"&":"&&"):n.replace(/&&|&/g,d=>d==="&"?"&&":"&")}function r(n,l){return k.isMacintosh||l?n.replace(/\(&&\w\)|&&/g,""):k.isWindows?n.replace(/&&|&/g,d=>d==="&"?"&&":"&"):n.replace(/&&/g,"_")}function a(n){return n.replace(/&/g,"&&")}function t(n){if(n.endsWith("]")){const l=n.lastIndexOf(" [",n.length-2);if(l!==-1){const d=o(n.substring(0,l)),D=n.substring(l);return{name:d.name+D,parentPath:d.parentPath}}}return o(n)}function o(n){const l=n.indexOf("/")!==-1?y.posix:y.win32,d=l.basename(n),D=l.dirname(n);return d.length?{name:d,parentPath:D}:{name:D,parentPath:""}}}),define(le[161],ue([0,1,17,92,7]),function(j,e,i,s,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DefaultURITransformer=e.URITransformer=void 0,e.transformOutgoingURIs=S,e.transformIncomingURIs=m,e.transformAndReviveIncomingURIs=u;function k(p){return p.toJSON()}class A{constructor(v){this._uriTransformer=v}transformIncoming(v){const f=this._uriTransformer.transformIncoming(v);return f===v?v:k(y.URI.from(f))}transformOutgoing(v){const f=this._uriTransformer.transformOutgoing(v);return f===v?v:k(y.URI.from(f))}transformOutgoingURI(v){const f=this._uriTransformer.transformOutgoing(v);return f===v?v:y.URI.from(f)}transformOutgoingScheme(v){return this._uriTransformer.transformOutgoingScheme(v)}}e.URITransformer=A,e.DefaultURITransformer=new class{transformIncoming(p){return p}transformOutgoing(p){return p}transformOutgoingURI(p){return p}transformOutgoingScheme(p){return p}};function R(p,v,f){if(!p||f>200)return null;if(typeof p=="object"){if(p instanceof y.URI)return v.transformOutgoing(p);for(const h in p)if(Object.hasOwnProperty.call(p,h)){const E=R(p[h],v,f+1);E!==null&&(p[h]=E)}}return null}function S(p,v){const f=R(p,v,0);return f===null?p:f}function c(p,v,f,h){if(!p||h>200)return null;if(typeof p=="object"){if(p.$mid===s.MarshalledId.Uri)return f?y.URI.revive(v.transformIncoming(p)):v.transformIncoming(p);if(p instanceof i.VSBuffer)return null;for(const E in p)if(Object.hasOwnProperty.call(p,E)){const b=c(p[E],v,f,h+1);b!==null&&(p[E]=b)}}return null}function m(p,v){const f=c(p,v,!1,0);return f===null?p:f}function u(p,v){const f=c(p,v,!0,0);return f===null?p:f}}),define(le[95],ue([0,1,27,61,33,154,3]),function(j,e,i,s,y,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.virtualMachineHint=void 0,e.getMachineId=S,e.getSqmMachineId=u,e.getdevDeviceId=p,y=Re(y),e.virtualMachineHint=new class{_isVirtualMachineMacAddress(v){return this._virtualMachineOUIs||(this._virtualMachineOUIs=s.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(v)}value(){if(this._value===void 0){let v=0,f=0;const h=(0,i.networkInterfaces)();for(const E in h){const b=h[E];if(b)for(const{mac:g,internal:I}of b)I||(f+=1,this._isVirtualMachineMacAddress(g.toUpperCase())&&(v+=1))}this._value=f>0?v/f:0}return this._value}};let R;async function S(v){return R||(R=(async()=>await c(v)||y.generateUuid())()),R}async function c(v){try{const f=await new Promise((E,b)=>{j(["crypto"],E,b)}).then(Re),h=(0,k.getMac)();return f.createHash("sha256").update(h,"utf8").digest("hex")}catch(f){v(f);return}}const m="Software\\Microsoft\\SQMClient";async function u(v){if(A.isWindows){const f=await new Promise((h,E)=>{j(["@vscode/windows-registry"],h,E)}).then(Re);try{return f.GetStringRegKey("HKEY_LOCAL_MACHINE",m,"MachineId")||""}catch(h){return v(h),""}}return""}async function p(v){try{return await(await new Promise((E,b)=>{j(["@vscode/deviceid"],E,b)}).then(Re)).getDeviceId()}catch(f){return v(f),""}}}),define(le[23],ue([0,1,26,27,162,8,32,79,10,3,18,7]),function(j,e,i,s,y,k,A,R,S,c,m,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.SymlinkSupport=e.RimRafMode=void 0,e.rimrafSync=E,e.readdirSync=I,e.whenDeleted=a,e.configureFlushOnWrite=d,e.writeFileSync=w,i=Re(i);var p;(function(se){se[se.UNLINK=0]="UNLINK",se[se.MOVE=1]="MOVE"})(p||(e.RimRafMode=p={}));async function v(se,ee=p.UNLINK,U){if((0,A.isRootOrDriveLetter)(se))throw new Error("rimraf - will refuse to recursively delete root");return ee===p.UNLINK?h(se):f(se,U)}async function f(se,ee=(0,A.randomPath)((0,s.tmpdir)())){try{try{await i.promises.rename(se,ee)}catch(U){return U.code==="ENOENT"?void 0:h(se)}h(ee).catch(U=>{})}catch(U){if(U.code!=="ENOENT")throw U}}async function h(se){return i.promises.rm(se,{recursive:!0,force:!0,maxRetries:3})}function E(se){if((0,A.isRootOrDriveLetter)(se))throw new Error("rimraf - will refuse to recursively delete root");i.rmSync(se,{recursive:!0,force:!0,maxRetries:3})}async function b(se,ee){return P(await(ee?g(se):i.promises.readdir(se)))}async function g(se){try{return await i.promises.readdir(se,{withFileTypes:!0})}catch(K){console.warn("[node.js fs] readdir with filetypes failed with error: ",K)}const ee=[],U=await b(se);for(const K of U){let N=!1,x=!1,W=!1;try{const q=await i.promises.lstat((0,S.join)(se,K));N=q.isFile(),x=q.isDirectory(),W=q.isSymbolicLink()}catch(q){console.warn("[node.js fs] unexpected error from lstat after readdir: ",q)}ee.push({name:K,isFile:()=>N,isDirectory:()=>x,isSymbolicLink:()=>W})}return ee}function I(se){return P(i.readdirSync(se))}function P(se){return se.map(ee=>typeof ee=="string"?c.isMacintosh?(0,R.normalizeNFC)(ee):ee:(ee.name=c.isMacintosh?(0,R.normalizeNFC)(ee.name):ee.name,ee))}async function r(se){const ee=await b(se),U=[];for(const K of ee)await t.existsDirectory((0,S.join)(se,K))&&U.push(K);return U}function a(se,ee=1e3){return new Promise(U=>{let K=!1;const N=setInterval(()=>{K||(K=!0,i.access(se,x=>{K=!1,x&&(clearInterval(N),U(void 0))}))},ee)})}var t;(function(se){async function ee(N){let x;try{if(x=await i.promises.lstat(N),!x.isSymbolicLink())return{stat:x}}catch{}try{return{stat:await i.promises.stat(N),symbolicLink:x?.isSymbolicLink()?{dangling:!1}:void 0}}catch(W){if(W.code==="ENOENT"&&x)return{stat:x,symbolicLink:{dangling:!0}};if(c.isWindows&&W.code==="EACCES")try{return{stat:await i.promises.stat(await i.promises.readlink(N)),symbolicLink:{dangling:!1}}}catch(q){if(q.code==="ENOENT"&&x)return{stat:x,symbolicLink:{dangling:!0}};throw q}throw W}}se.stat=ee;async function U(N){try{const{stat:x,symbolicLink:W}=await se.stat(N);return x.isFile()&&W?.dangling!==!0}catch{}return!1}se.existsFile=U;async function K(N){try{const{stat:x,symbolicLink:W}=await se.stat(N);return x.isDirectory()&&W?.dangling!==!0}catch{}return!1}se.existsDirectory=K})(t||(e.SymlinkSupport=t={}));const o=new k.ResourceQueue;function n(se,ee,U){return o.queueFor(u.URI.file(se),()=>{const K=M(U);return new Promise((N,x)=>D(se,ee,K,W=>W?x(W):N()))},m.extUriBiasedIgnorePathCase)}let l=!0;function d(se){l=se}function D(se,ee,U,K){if(!l)return i.writeFile(se,ee,{mode:U.mode,flag:U.flag},K);i.open(se,U.flag,U.mode,(N,x)=>{if(N)return K(N);i.writeFile(x,ee,W=>{if(W)return i.close(x,()=>K(W));i.fdatasync(x,q=>(q&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",q),d(!1)),i.close(x,ie=>K(ie))))})})}function w(se,ee,U){const K=M(U);if(!l)return i.writeFileSync(se,ee,{mode:K.mode,flag:K.flag});const N=i.openSync(se,K.flag,K.mode);try{i.writeFileSync(N,ee);try{i.fdatasyncSync(N)}catch(x){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",x),d(!1)}}finally{i.closeSync(N)}}function M(se){return se?{mode:typeof se.mode=="number"?se.mode:438,flag:typeof se.flag=="string"?se.flag:"w"}:{mode:438,flag:"w"}}async function T(se,ee,U=6e4){if(se!==ee)try{c.isWindows&&typeof U=="number"?await C(se,ee,Date.now(),U):await i.promises.rename(se,ee)}catch(K){if(se.toLowerCase()!==ee.toLowerCase()&&K.code==="EXDEV"||se.endsWith("."))await L(se,ee,{preserveSymlinks:!1}),await v(se,p.MOVE);else throw K}}async function C(se,ee,U,K,N=0){try{return await i.promises.rename(se,ee)}catch(x){if(x.code!=="EACCES"&&x.code!=="EPERM"&&x.code!=="EBUSY")throw x;if(Date.now()-U>=K)throw console.error(`[node.js fs] rename failed after ${N} retries with error: ${x}`),x;if(N===0){let W=!1;try{const{stat:q}=await t.stat(ee);q.isFile()||(W=!0)}catch{}if(W)throw x}return await(0,k.timeout)(Math.min(100,N*10)),C(se,ee,U,K,N+1)}}async function L(se,ee,U){return V(se,ee,{root:{source:se,target:ee},options:U,handledSourcePaths:new Set})}const _=511;async function V(se,ee,U){if(U.handledSourcePaths.has(se))return;U.handledSourcePaths.add(se);const{stat:K,symbolicLink:N}=await t.stat(se);if(N){if(U.options.preserveSymlinks)try{return await fe(se,ee,U)}catch{}if(N.dangling)return}return K.isDirectory()?z(se,ee,K.mode&_,U):Q(se,ee,K.mode&_)}async function z(se,ee,U,K){await i.promises.mkdir(ee,{recursive:!0,mode:U});const N=await b(se);for(const x of N)await V((0,S.join)(se,x),(0,S.join)(ee,x),K)}async function Q(se,ee,U){await i.promises.copyFile(se,ee),await i.promises.chmod(ee,U)}async function fe(se,ee,U){let K=await i.promises.readlink(se);(0,A.isEqualOrParent)(K,U.root.source,!c.isLinux)&&(K=(0,S.join)(U.root.target,K.substr(U.root.source.length+1))),await i.promises.symlink(K,ee)}e.Promises=new class{get read(){return(se,ee,U,K,N)=>new Promise((x,W)=>{i.read(se,ee,U,K,N,(q,ie,H)=>q?W(q):x({bytesRead:ie,buffer:H}))})}get write(){return(se,ee,U,K,N)=>new Promise((x,W)=>{i.write(se,ee,U,K,N,(q,ie,H)=>q?W(q):x({bytesWritten:ie,buffer:H}))})}get fdatasync(){return(0,y.promisify)(i.fdatasync)}get open(){return(0,y.promisify)(i.open)}get close(){return(0,y.promisify)(i.close)}get realpath(){return(0,y.promisify)(i.realpath)}async exists(se){try{return await i.promises.access(se),!0}catch{return!1}}get readdir(){return b}get readDirsInDir(){return r}get writeFile(){return n}get rm(){return v}get rename(){return T}get copy(){return L}}}),define(le[117],ue([0,1,26,10,3,25,23]),function(j,e,i,s,y,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realcaseSync=R,e.realcase=S,e.realpath=c,e.realpathSync=m,i=Re(i);function R(p){if(y.isLinux)return p;const v=(0,s.dirname)(p);if(p===v)return p;const f=((0,s.basename)(p)||p).toLowerCase();try{const E=(0,A.readdirSync)(v).filter(b=>b.toLowerCase()===f);if(E.length===1){const b=R(v);if(b)return(0,s.join)(b,E[0])}else if(E.length>1){const b=E.indexOf(f);if(b>=0){const g=R(v);if(g)return(0,s.join)(g,E[b])}}}catch{}return null}async function S(p,v){if(y.isLinux)return p;const f=(0,s.dirname)(p);if(p===f)return p;const h=((0,s.basename)(p)||p).toLowerCase();try{if(v?.isCancellationRequested)return null;const b=(await A.Promises.readdir(f)).filter(g=>g.toLowerCase()===h);if(b.length===1){const g=await S(f,v);if(g)return(0,s.join)(g,b[0])}else if(b.length>1){const g=b.indexOf(h);if(g>=0){const I=await S(f,v);if(I)return(0,s.join)(I,b[g])}}}catch{}return null}async function c(p){try{return await A.Promises.realpath(p)}catch{const f=u(p);return await i.promises.access(f,i.constants.R_OK),f}}function m(p){try{return i.realpathSync(p)}catch{const f=u(p);return i.accessSync(f,i.constants.R_OK),f}}function u(p){return(0,k.rtrim)((0,s.normalize)(p),s.sep)}}),define(le[118],ue([0,1,27,10,23]),function(j,e,i,s,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.enumeratePowerShellInstallations=g,e.getFirstAvailablePowerShellInstallation=I,i=Re(i),s=Re(s),y=Re(y);const k=/^\d+$/,A=/^Microsoft.PowerShell_.*/,R=/^Microsoft.PowerShellPreview_.*/;var S;(function(P){P[P.x64=0]="x64",P[P.x86=1]="x86",P[P.ARM=2]="ARM"})(S||(S={}));let c;switch(process.arch){case"ia32":c=S.x86;break;case"arm":case"arm64":c=S.ARM;break;default:c=S.x64;break}let m;process.env.PROCESSOR_ARCHITEW6432?m=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?S.ARM:S.x64:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?m=S.ARM:process.env.PROCESSOR_ARCHITECTURE==="X86"?m=S.x86:m=S.x64;class u{constructor(r,a,t){this.exePath=r,this.displayName=a,this.knownToExist=t}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await y.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function p({useAlternateBitness:P=!1}={}){return P?c===S.x64?process.env["ProgramFiles(x86)"]||null:m===S.x64&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function v({useAlternateBitness:P=!1,findPreview:r=!1}={}){const a=p({useAlternateBitness:P});if(!a)return null;const t=s.join(a,"PowerShell");if(!await y.SymlinkSupport.existsDirectory(t))return null;let o=-1,n=null;for(const D of await y.Promises.readdir(t)){let w=-1;if(r){const T=D.indexOf("-");if(T<0)continue;const C=D.substring(0,T);if(!k.test(C)||D.substring(T+1)!=="preview")continue;w=parseInt(C,10)}else{if(!k.test(D))continue;w=parseInt(D,10)}if(w<=o)continue;const M=s.join(t,D,"pwsh.exe");await y.SymlinkSupport.existsFile(M)&&(n=M,o=w)}if(!n)return null;const l=a.includes("x86")?" (x86)":"",d=r?" Preview":"";return new u(n,`PowerShell${d}${l}`,!0)}async function f({findPreview:P}={}){if(!process.env.LOCALAPPDATA)return null;const r=s.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await y.SymlinkSupport.existsDirectory(r))return null;const{pwshMsixDirRegex:a,pwshMsixName:t}=P?{pwshMsixDirRegex:R,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:A,pwshMsixName:"PowerShell (Store)"};for(const o of await y.Promises.readdir(r))if(a.test(o)){const n=s.join(r,o,"pwsh.exe");return new u(n,t)}return null}function h(){const P=s.join(i.homedir(),".dotnet","tools","pwsh.exe");return new u(P,".NET Core PowerShell Global Tool")}function E(){const P=s.join(process.env.windir,c===S.x86&&m!==S.x86?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new u(P,"Windows PowerShell",!0)}async function*b(){let P=await v();P&&(yield P),P=await v({useAlternateBitness:!0}),P&&(yield P),P=await f(),P&&(yield P),P=h(),P&&(yield P),P=await v({findPreview:!0}),P&&(yield P),P=await f({findPreview:!0}),P&&(yield P),P=await v({useAlternateBitness:!0,findPreview:!0}),P&&(yield P),P=E(),P&&(yield P)}async function*g(){for await(const P of b())await P.exists()&&(yield P)}async function I(){for await(const P of g())return P;return null}}),define(le[96],ue([0,1,26,10,3,38,82,12,23]),function(j,e,i,s,y,k,A,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.TerminateResponseCode=e.Source=void 0,e.getWindowsShell=c,e.createQueuedSender=m,s=Re(s),y=Re(y),k=Re(k),R=Re(R),S=Re(S),Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return A.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return A.TerminateResponseCode}});function c(p=k.env){return p.comspec||"cmd.exe"}function m(p){let v=[],f=!1;const h=function(E){if(f){v.push(E);return}(!p.send(E,g=>{if(g&&console.error(g),f=!1,v.length>0){const I=v.slice(0);v=[],I.forEach(P=>h(P))}})||y.isWindows)&&(f=!0)};return{send:h}}var u;(function(p){async function v(f,h,E){if(s.isAbsolute(f))return f;if(h===void 0&&(h=k.cwd()),s.dirname(f)!=="."||(E===void 0&&R.isString(k.env.PATH)&&(E=k.env.PATH.split(s.delimiter)),E===void 0||E.length===0))return s.join(h,f);async function g(I){if(await S.Promises.exists(I)){let P;try{P=await i.promises.stat(I)}catch(r){r.message.startsWith("EACCES")&&(P=await i.promises.lstat(I))}return P?!P.isDirectory():!1}return!1}for(const I of E){let P;if(s.isAbsolute(I)?P=s.join(I,f):P=s.join(h,I,f),await g(P))return P;let r=P+".com";if(await g(r)||(r=P+".exe",await g(r)))return r}return s.join(h,f)}p.findExecutable=v})(u||(e.win32=u={}))}),define(le[119],ue([0,1,44,11]),function(j,e,i,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=y;function y(A){return new Promise((R,S)=>{let c;const m=new Map;function u(v,f,h,E,b){const g=m.get(f);if(v===A||g){const I={name:p(h),cmd:h,pid:v,ppid:f,load:E,mem:b};m.set(v,I),v===A&&(c=I),g&&(g.children||(g.children=[]),g.children.push(I),g.children.length>1&&(g.children=g.children.sort((P,r)=>P.pid-r.pid)))}}function p(v){const f=/--utility-sub-type=network/i,h=/--crashes-directory/i,E=/\\pipe\\winpty-control/i,b=/conhost\.exe.+--headless/i,g=/--type=([a-zA-Z-]+)/;if(h.exec(v))return"electron-crash-reporter";if(E.exec(v))return"winpty-agent";if(b.exec(v))return"conpty-agent";let I=g.exec(v);if(I&&I.length===2)return I[1]==="renderer"?"window":I[1]==="utility"?f.exec(v)?"utility-network-service":"utility-process":I[1]==="extensionHost"?"extension-host":I[1];const P=/[a-zA-Z-]+\.js/g;let r="";do I=P.exec(v),I&&(r+=I+" ");while(I);return r&&v.indexOf("node ")<0&&v.indexOf("node.exe")<0?`electron-nodejs (${r})`:v}if(process.platform==="win32"){const v=f=>f.indexOf("\\\\?\\")===0||f.indexOf("\\??\\")===0?f.substring(4):f.indexOf('"\\\\?\\')===0||f.indexOf('"\\??\\')===0?'"'+f.substring(5):f;new Promise((f,h)=>{j(["@vscode/windows-process-tree"],f,h)}).then(Re).then(f=>{f.getProcessList(A,h=>{if(!h){S(new Error(`Root process ${A} not found`));return}f.getProcessCpuUsage(h,E=>{const b=new Map;E.forEach(g=>{const I=v(g.commandLine||"");b.set(g.pid,{name:p(I),cmd:I,pid:g.pid,ppid:g.ppid,load:g.cpu||0,mem:g.memory||0})}),c=b.get(A),c?(b.forEach(g=>{const I=b.get(g.ppid);I&&(I.children||(I.children=[]),I.children.push(g))}),b.forEach(g=>{g.children&&(g.children=g.children.sort((I,P)=>I.pid-P.pid))}),R(c)):S(new Error(`Root process ${A} not found`))})},f.ProcessDataFlag.CommandLine|f.ProcessDataFlag.Memory)})}else{let v=function(){let f=[c];const h=[];for(;f.length;){const b=f.shift();b&&(h.push(b.pid),b.children&&(f=f.concat(b.children)))}let E=JSON.stringify(s.FileAccess.asFileUri("vs/base/node/cpuUsage.sh").fsPath);E+=" "+h.join(" "),(0,i.exec)(E,{},(b,g,I)=>{if(b||I)S(b||new Error(I.toString()));else{const P=g.toString().split(`
`);for(let r=0;r<h.length;r++){const a=m.get(h[r]);a.load=parseFloat(P[r])}if(!c){S(new Error(`Root process ${A} not found`));return}R(c)}})};(0,i.exec)("which ps",{},(f,h,E)=>{if(f||E)if(process.platform!=="linux")S(f||new Error(E.toString()));else{const b=JSON.stringify(s.FileAccess.asFileUri("vs/base/node/ps.sh").fsPath);(0,i.exec)(b,{},(g,I,P)=>{g||P?S(g||new Error(P.toString())):(k(I,u),v())})}else{const b=h.toString().trim();(0,i.exec)(`${b} -ax -o pid=,ppid=,pcpu=,pmem=,command=`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(I,P,r)=>{I||r&&!r.includes("screen size is bogus")?S(I||new Error(r.toString())):(k(P,u),process.platform==="linux"?v():c?R(c):S(new Error(`Root process ${A} not found`)))})}})}})}function k(A,R){const S=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,c=A.toString().split(`
`);for(const m of c){const u=S.exec(m.trim());u&&u.length===6&&R(parseInt(u[1]),parseInt(u[2]),u[5],parseFloat(u[3]),parseFloat(u[4]))}}}),define(le[120],ue([0,1,27,3,118,96]),function(j,e,i,s,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShell=A,s=Re(s),k=Re(k);async function A(u,p){return u===s.OperatingSystem.Windows?s.isWindows?m():k.getWindowsShell(p):S(u,p)}let R=null;function S(u,p){if(s.isLinux&&u===s.OperatingSystem.Macintosh||s.isMacintosh&&u===s.OperatingSystem.Linux)return"/bin/bash";if(!R){let v;if(s.isWindows)v="/bin/bash";else{if(v=p.SHELL,!v)try{v=(0,i.userInfo)().shell}catch{}v||(v="sh"),v==="/bin/false"&&(v="/bin/bash")}R=v}return R}let c=null;async function m(){return c||(c=(await(0,y.getFirstAvailablePowerShellInstallation)()).exePath),c}});var Pe=this&&this.__decorate||function(j,e,i,s){var y=arguments.length,k=y<3?e:s===null?s=Object.getOwnPropertyDescriptor(e,i):s,A;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")k=Reflect.decorate(j,e,i,s);else for(var R=j.length-1;R>=0;R--)(A=j[R])&&(k=(y<3?A(k):y>3?A(e,i,k):A(e,i))||k);return y>3&&k&&Object.defineProperty(e,i,k),k};define(le[45],ue([0,1,21,8,17,22,54,15,4,2,83,25,12]),function(j,e,i,s,y,k,A,R,S,c,m,u,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.ProxyChannel=e.StaticRouter=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.BufferWriter=e.BufferReader=void 0,e.serialize=d,e.deserialize=D,e.getDelayedChannel=_,e.getNextTickChannel=V,u=Re(u);var v;(function(N){N[N.Promise=100]="Promise",N[N.PromiseCancel=101]="PromiseCancel",N[N.EventListen=102]="EventListen",N[N.EventDispose=103]="EventDispose"})(v||(v={}));function f(N){switch(N){case v.Promise:return"req";case v.PromiseCancel:return"cancel";case v.EventListen:return"subscribe";case v.EventDispose:return"unsubscribe"}}var h;(function(N){N[N.Initialize=200]="Initialize",N[N.PromiseSuccess=201]="PromiseSuccess",N[N.PromiseError=202]="PromiseError",N[N.PromiseErrorObj=203]="PromiseErrorObj",N[N.EventFire=204]="EventFire"})(h||(h={}));function E(N){switch(N){case h.Initialize:return"init";case h.PromiseSuccess:return"reply:";case h.PromiseError:case h.PromiseErrorObj:return"replyErr:";case h.EventFire:return"event:"}}var b;(function(N){N[N.Uninitialized=0]="Uninitialized",N[N.Idle=1]="Idle"})(b||(b={}));function g(N){let x=0;for(let W=0;;W+=7){const q=N.read(1);if(x|=(q.buffer[0]&127)<<W,!(q.buffer[0]&128))return x}}const I=o(0);function P(N,x){if(x===0){N.write(I);return}let W=0;for(let ie=x;ie!==0;ie=ie>>>7)W++;const q=y.VSBuffer.alloc(W);for(let ie=0;x!==0;ie++)q.buffer[ie]=x&127,x=x>>>7,x>0&&(q.buffer[ie]|=128);N.write(q)}class r{constructor(x){this.buffer=x,this.pos=0}read(x){const W=this.buffer.slice(this.pos,this.pos+x);return this.pos+=W.byteLength,W}}e.BufferReader=r;class a{constructor(){this.buffers=[]}get buffer(){return y.VSBuffer.concat(this.buffers)}write(x){this.buffers.push(x)}}e.BufferWriter=a;var t;(function(N){N[N.Undefined=0]="Undefined",N[N.String=1]="String",N[N.Buffer=2]="Buffer",N[N.VSBuffer=3]="VSBuffer",N[N.Array=4]="Array",N[N.Object=5]="Object",N[N.Int=6]="Int"})(t||(t={}));function o(N){const x=y.VSBuffer.alloc(1);return x.writeUInt8(N,0),x}const n={Undefined:o(t.Undefined),String:o(t.String),Buffer:o(t.Buffer),VSBuffer:o(t.VSBuffer),Array:o(t.Array),Object:o(t.Object),Uint:o(t.Int)},l=typeof Buffer<"u";function d(N,x){if(typeof x>"u")N.write(n.Undefined);else if(typeof x=="string"){const W=y.VSBuffer.fromString(x);N.write(n.String),P(N,W.byteLength),N.write(W)}else if(l&&Buffer.isBuffer(x)){const W=y.VSBuffer.wrap(x);N.write(n.Buffer),P(N,W.byteLength),N.write(W)}else if(x instanceof y.VSBuffer)N.write(n.VSBuffer),P(N,x.byteLength),N.write(x);else if(Array.isArray(x)){N.write(n.Array),P(N,x.length);for(const W of x)d(N,W)}else if(typeof x=="number"&&(x|0)===x)N.write(n.Uint),P(N,x);else{const W=y.VSBuffer.fromString(JSON.stringify(x));N.write(n.Object),P(N,W.byteLength),N.write(W)}}function D(N){switch(N.read(1).readUInt8(0)){case t.Undefined:return;case t.String:return N.read(g(N)).toString();case t.Buffer:return N.read(g(N)).buffer;case t.VSBuffer:return N.read(g(N));case t.Array:{const W=g(N),q=[];for(let ie=0;ie<W;ie++)q.push(D(N));return q}case t.Object:return JSON.parse(N.read(g(N)).toString());case t.Int:return g(N)}}class w{constructor(x,W,q=null,ie=1e3){this.protocol=x,this.ctx=W,this.logger=q,this.timeoutDelay=ie,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(H=>this.onRawMessage(H)),this.sendResponse({type:h.Initialize})}registerChannel(x,W){this.channels.set(x,W),setTimeout(()=>this.flushPendingRequests(x),0)}sendResponse(x){switch(x.type){case h.Initialize:{const W=this.send([x.type]);this.logger?.logOutgoing(W,0,M.OtherSide,E(x.type));return}case h.PromiseSuccess:case h.PromiseError:case h.EventFire:case h.PromiseErrorObj:{const W=this.send([x.type,x.id],x.data);this.logger?.logOutgoing(W,x.id,M.OtherSide,E(x.type),x.data);return}}}send(x,W=void 0){const q=new a;return d(q,x),d(q,W),this.sendBuffer(q.buffer)}sendBuffer(x){try{return this.protocol.send(x),x.byteLength}catch{return 0}}onRawMessage(x){const W=new r(x),q=D(W),ie=D(W),H=q[0];switch(H){case v.Promise:return this.logger?.logIncoming(x.byteLength,q[1],M.OtherSide,`${f(H)}: ${q[2]}.${q[3]}`,ie),this.onPromise({type:H,id:q[1],channelName:q[2],name:q[3],arg:ie});case v.EventListen:return this.logger?.logIncoming(x.byteLength,q[1],M.OtherSide,`${f(H)}: ${q[2]}.${q[3]}`,ie),this.onEventListen({type:H,id:q[1],channelName:q[2],name:q[3],arg:ie});case v.PromiseCancel:return this.logger?.logIncoming(x.byteLength,q[1],M.OtherSide,`${f(H)}`),this.disposeActiveRequest({type:H,id:q[1]});case v.EventDispose:return this.logger?.logIncoming(x.byteLength,q[1],M.OtherSide,`${f(H)}`),this.disposeActiveRequest({type:H,id:q[1]})}}onPromise(x){const W=this.channels.get(x.channelName);if(!W){this.collectPendingRequest(x);return}const q=new k.CancellationTokenSource;let ie;try{ie=W.call(this.ctx,x.name,x.arg,q.token)}catch(oe){ie=Promise.reject(oe)}const H=x.id;ie.then(oe=>{this.sendResponse({id:H,data:oe,type:h.PromiseSuccess})},oe=>{oe instanceof Error?this.sendResponse({id:H,data:{message:oe.message,name:oe.name,stack:oe.stack?oe.stack.split(`
`):void 0},type:h.PromiseError}):this.sendResponse({id:H,data:oe,type:h.PromiseErrorObj})}).finally(()=>{ce.dispose(),this.activeRequests.delete(x.id)});const ce=(0,c.toDisposable)(()=>q.cancel());this.activeRequests.set(x.id,ce)}onEventListen(x){const W=this.channels.get(x.channelName);if(!W){this.collectPendingRequest(x);return}const q=x.id,H=W.listen(this.ctx,x.name,x.arg)(ce=>this.sendResponse({id:q,data:ce,type:h.EventFire}));this.activeRequests.set(x.id,H)}disposeActiveRequest(x){const W=this.activeRequests.get(x.id);W&&(W.dispose(),this.activeRequests.delete(x.id))}collectPendingRequest(x){let W=this.pendingRequests.get(x.channelName);W||(W=[],this.pendingRequests.set(x.channelName,W));const q=setTimeout(()=>{console.error(`Unknown channel: ${x.channelName}`),x.type===v.Promise&&this.sendResponse({id:x.id,data:{name:"Unknown channel",message:`Channel name '${x.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:h.PromiseError})},this.timeoutDelay);W.push({request:x,timeoutTimer:q})}flushPendingRequests(x){const W=this.pendingRequests.get(x);if(W){for(const q of W)switch(clearTimeout(q.timeoutTimer),q.request.type){case v.Promise:this.onPromise(q.request);break;case v.EventListen:this.onEventListen(q.request);break}this.pendingRequests.delete(x)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,c.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelServer=w;var M;(function(N){N[N.LocalSide=0]="LocalSide",N[N.OtherSide=1]="OtherSide"})(M||(e.RequestInitiator=M={}));class T{constructor(x,W=null){this.protocol=x,this.isDisposed=!1,this.state=b.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new S.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(q=>this.onBuffer(q)),this.logger=W}getChannel(x){const W=this;return{call(q,ie,H){return W.isDisposed?Promise.reject(new R.CancellationError):W.requestPromise(x,q,ie,H)},listen(q,ie){return W.isDisposed?S.Event.None:W.requestEvent(x,q,ie)}}}requestPromise(x,W,q,ie=k.CancellationToken.None){const H=this.lastRequestId++,ce=v.Promise,oe={id:H,type:ce,channelName:x,name:W,arg:q};if(ie.isCancellationRequested)return Promise.reject(new R.CancellationError);let te;return new Promise((X,B)=>{if(ie.isCancellationRequested)return B(new R.CancellationError);const F=()=>{const Z=ae=>{switch(ae.type){case h.PromiseSuccess:this.handlers.delete(H),X(ae.data);break;case h.PromiseError:{this.handlers.delete(H);const pe=new Error(ae.data.message);pe.stack=Array.isArray(ae.data.stack)?ae.data.stack.join(`
`):ae.data.stack,pe.name=ae.data.name,B(pe);break}case h.PromiseErrorObj:this.handlers.delete(H),B(ae.data);break}};this.handlers.set(H,Z),this.sendRequest(oe)};let J=null;this.state===b.Idle?F():(J=(0,s.createCancelablePromise)(Z=>this.whenInitialized()),J.then(()=>{J=null,F()}));const G=()=>{J?(J.cancel(),J=null):this.sendRequest({id:H,type:v.PromiseCancel}),B(new R.CancellationError)},$=ie.onCancellationRequested(G);te=(0,c.combinedDisposable)((0,c.toDisposable)(G),$),this.activeRequests.add(te)}).finally(()=>{te.dispose(),this.activeRequests.delete(te)})}requestEvent(x,W,q){const ie=this.lastRequestId++,H=v.EventListen,ce={id:ie,type:H,channelName:x,name:W,arg:q};let oe=null;const te=new S.Emitter({onWillAddFirstListener:()=>{oe=(0,s.createCancelablePromise)(X=>this.whenInitialized()),oe.then(()=>{oe=null,this.activeRequests.add(te),this.sendRequest(ce)})},onDidRemoveLastListener:()=>{oe?(oe.cancel(),oe=null):(this.activeRequests.delete(te),this.sendRequest({id:ie,type:v.EventDispose}))}}),O=X=>te.fire(X.data);return this.handlers.set(ie,O),te.event}sendRequest(x){switch(x.type){case v.Promise:case v.EventListen:{const W=this.send([x.type,x.id,x.channelName,x.name],x.arg);this.logger?.logOutgoing(W,x.id,M.LocalSide,`${f(x.type)}: ${x.channelName}.${x.name}`,x.arg);return}case v.PromiseCancel:case v.EventDispose:{const W=this.send([x.type,x.id]);this.logger?.logOutgoing(W,x.id,M.LocalSide,f(x.type));return}}}send(x,W=void 0){const q=new a;return d(q,x),d(q,W),this.sendBuffer(q.buffer)}sendBuffer(x){try{return this.protocol.send(x),x.byteLength}catch{return 0}}onBuffer(x){const W=new r(x),q=D(W),ie=D(W),H=q[0];switch(H){case h.Initialize:return this.logger?.logIncoming(x.byteLength,0,M.LocalSide,E(H)),this.onResponse({type:q[0]});case h.PromiseSuccess:case h.PromiseError:case h.EventFire:case h.PromiseErrorObj:return this.logger?.logIncoming(x.byteLength,q[1],M.LocalSide,E(H),ie),this.onResponse({type:q[0],id:q[1],data:ie})}}onResponse(x){if(x.type===h.Initialize){this.state=b.Idle,this._onDidInitialize.fire();return}this.handlers.get(x.id)?.(x)}get onDidInitializePromise(){return S.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===b.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,c.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelClient=T,Pe([A.memoize],T.prototype,"onDidInitializePromise",null);class C{get connections(){const x=[];return this._connections.forEach(W=>x.push(W)),x}constructor(x,W,q){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new S.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new S.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,this.disposables=new c.DisposableStore,this.disposables.add(x(({protocol:ie,onDidClientDisconnect:H})=>{const ce=S.Event.once(ie.onMessage);this.disposables.add(ce(oe=>{const te=new r(oe),O=D(te),X=new w(ie,O,W,q),B=new T(ie,W);this.channels.forEach((J,G)=>X.registerChannel(G,J));const F={channelServer:X,channelClient:B,ctx:O};this._connections.add(F),this._onDidAddConnection.fire(F),this.disposables.add(H(()=>{X.dispose(),B.dispose(),this._connections.delete(F),this._onDidRemoveConnection.fire(F)}))}))}))}getChannel(x,W){const q=this;return{call(ie,H,ce){let oe;if((0,p.isFunction)(W)){const O=(0,i.getRandomElement)(q.connections.filter(W));oe=O?Promise.resolve(O):S.Event.toPromise(S.Event.filter(q.onDidAddConnection,W))}else oe=W.routeCall(q,ie,H);const te=oe.then(O=>O.channelClient.getChannel(x));return _(te).call(ie,H,ce)},listen(ie,H){if((0,p.isFunction)(W))return q.getMulticastEvent(x,W,ie,H);const ce=W.routeEvent(q,ie,H).then(oe=>oe.channelClient.getChannel(x));return _(ce).listen(ie,H)}}}getMulticastEvent(x,W,q,ie){const H=this;let ce;const oe=new S.Emitter({onWillAddFirstListener:()=>{ce=new c.DisposableStore;const te=new S.EventMultiplexer,O=new Map,X=F=>{const G=F.channelClient.getChannel(x).listen(q,ie),$=te.add(G);O.set(F,$)},B=F=>{const J=O.get(F);J&&(J.dispose(),O.delete(F))};H.connections.filter(W).forEach(X),S.Event.filter(H.onDidAddConnection,W)(X,void 0,ce),H.onDidRemoveConnection(B,void 0,ce),te.event(oe.fire,oe,ce),ce.add(te)},onDidRemoveLastListener:()=>{ce?.dispose(),ce=void 0}});return oe.event}registerChannel(x,W){this.channels.set(x,W);for(const q of this._connections)q.channelServer.registerChannel(x,W)}dispose(){this.disposables.dispose();for(const x of this._connections)x.channelClient.dispose(),x.channelServer.dispose();this._connections.clear(),this.channels.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=C;class L{constructor(x,W,q=null){const ie=new a;d(ie,W),x.send(ie.buffer),this.channelClient=new T(x,q),this.channelServer=new w(x,W,q)}getChannel(x){return this.channelClient.getChannel(x)}registerChannel(x,W){this.channelServer.registerChannel(x,W)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=L;function _(N){return{call(x,W,q){return N.then(ie=>ie.call(x,W,q))},listen(x,W){const q=new S.Relay;return N.then(ie=>q.input=ie.listen(x,W)),q.event}}}function V(N){let x=!1;return{call(W,q,ie){return x?N.call(W,q,ie):(0,s.timeout)(0).then(()=>x=!0).then(()=>N.call(W,q,ie))},listen(W,q){if(x)return N.listen(W,q);const ie=new S.Relay;return(0,s.timeout)(0).then(()=>x=!0).then(()=>ie.input=N.listen(W,q)),ie.event}}}class z{constructor(x){this.fn=x}routeCall(x){return this.route(x)}routeEvent(x){return this.route(x)}async route(x){for(const W of x.connections)if(await Promise.resolve(this.fn(W.ctx)))return Promise.resolve(W);return await S.Event.toPromise(x.onDidAddConnection),await this.route(x)}}e.StaticRouter=z;var Q;(function(N){function x(H,ce,oe){const te=H,O=oe&&oe.disableMarshalling,X=new Map;for(const B in te)q(B)&&X.set(B,S.Event.buffer(te[B],!0,void 0,ce));return new class{listen(B,F,J){const G=X.get(F);if(G)return G;const $=te[F];if(typeof $=="function"){if(ie(F))return $.call(te,J);if(q(F))return X.set(F,S.Event.buffer(te[F],!0,void 0,ce)),X.get(F)}throw new R.ErrorNoTelemetry(`Event not found: ${F}`)}call(B,F,J){const G=te[F];if(typeof G=="function"){if(!O&&Array.isArray(J))for(let Z=0;Z<J.length;Z++)J[Z]=(0,m.revive)(J[Z]);let $=G.apply(te,J);return $ instanceof Promise||($=Promise.resolve($)),$}throw new R.ErrorNoTelemetry(`Method not found: ${F}`)}}}N.fromService=x;function W(H,ce){const oe=ce&&ce.disableMarshalling;return new Proxy({},{get(te,O){if(typeof O=="string")return ce?.properties?.has(O)?ce.properties.get(O):ie(O)?function(X){return H.listen(O,X)}:q(O)?H.listen(O):async function(...X){let B;ce&&!(0,p.isUndefinedOrNull)(ce.context)?B=[ce.context,...X]:B=X;const F=await H.call(O,B);return oe?F:(0,m.revive)(F)};throw new R.ErrorNoTelemetry(`Property not found: ${String(O)}`)}})}N.toService=W;function q(H){return H[0]==="o"&&H[1]==="n"&&u.isUpperAsciiLetter(H.charCodeAt(2))}function ie(H){return/^onDynamic/.test(H)&&u.isUpperAsciiLetter(H.charCodeAt(9))}})(Q||(e.ProxyChannel=Q={}));const fe=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function se(N){if(Array.isArray(N))return N;if(N&&typeof N=="object"&&typeof N.toString=="function"){const x=N.toString();if(x!=="[object Object]")return x}return N}function ee(N){return Array.isArray(N)?N.map(se):se(N)}function U(N,x,W,q,ie,H,ce){ce=ee(ce);const oe=fe[ie],te=oe[q%oe.length];let O=[`%c[${N}]%c[${String(x).padStart(7," ")}]%c[len: ${String(W).padStart(5," ")}]%c${String(q).padStart(5," ")} - ${H}`,"color: darkgreen","color: grey","color: grey",`color: ${te}`];/\($/.test(H)?(O=O.concat(ce),O.push(")")):O.push(ce),console.log.apply(console,O)}class K{constructor(x,W){this._outgoingPrefix=x,this._incomingPrefix=W,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(x,W,q,ie,H){this._totalOutgoing+=x,U(this._outgoingPrefix,this._totalOutgoing,x,W,q,ie,H)}logIncoming(x,W,q,ie,H){this._totalIncoming+=x,U(this._incomingPrefix,this._totalIncoming,x,W,q,ie,H)}}e.IPCLogger=K}),define(le[163],ue([0,1,17,4,45]),function(j,e,i,s,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class k{constructor(S){this.port=S,this.onMessage=s.Event.fromDOMEventEmitter(this.port,"message",c=>c.data?i.VSBuffer.wrap(c.data):i.VSBuffer.alloc(0)),S.start()}send(S){this.port.postMessage(S.buffer)}disconnect(){this.port.close()}}e.Protocol=k;class A extends y.IPCClient{constructor(S,c){const m=new k(S);super(m,c),this.protocol=m}dispose(){this.protocol.disconnect(),super.dispose()}}e.Client=A}),define(le[121],ue([0,1,17,4,2,45]),function(j,e,i,s,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var A;(function(n){n.Created="created",n.Read="read",n.Write="write",n.Open="open",n.Error="error",n.Close="close",n.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",n.NodeEndReceived="nodeEndReceived",n.NodeEndSent="nodeEndSent",n.NodeDrainBegin="nodeDrainBegin",n.NodeDrainEnd="nodeDrainEnd",n.zlibInflateError="zlibInflateError",n.zlibInflateData="zlibInflateData",n.zlibInflateInitialWrite="zlibInflateInitialWrite",n.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",n.zlibInflateWrite="zlibInflateWrite",n.zlibInflateFlushFired="zlibInflateFlushFired",n.zlibDeflateError="zlibDeflateError",n.zlibDeflateData="zlibDeflateData",n.zlibDeflateWrite="zlibDeflateWrite",n.zlibDeflateFlushFired="zlibDeflateFlushFired",n.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",n.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",n.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",n.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",n.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",n.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",n.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",n.ProtocolHeaderRead="protocolHeaderRead",n.ProtocolMessageRead="protocolMessageRead",n.ProtocolHeaderWrite="protocolHeaderWrite",n.ProtocolMessageWrite="protocolMessageWrite",n.ProtocolWrite="protocolWrite"})(A||(e.SocketDiagnosticsEventType=A={}));var R;(function(n){n.enableDiagnostics=!1,n.records=[];const l=new WeakMap;let d=0;function D(M,T){if(!l.has(M)){const C=String(++d);l.set(M,C)}return l.get(M)}function w(M,T,C,L){if(!n.enableDiagnostics)return;const _=D(M,T);if(L instanceof i.VSBuffer||L instanceof Uint8Array||L instanceof ArrayBuffer||ArrayBuffer.isView(L)){const V=i.VSBuffer.alloc(L.byteLength);V.set(L),n.records.push({timestamp:Date.now(),id:_,label:T,type:C,buff:V})}else n.records.push({timestamp:Date.now(),id:_,label:T,type:C,data:L})}n.traceSocketEvent=w})(R||(e.SocketDiagnostics=R={}));var S;(function(n){n[n.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",n[n.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(S||(e.SocketCloseEventType=S={}));let c=null;function m(){return c||(c=i.VSBuffer.alloc(0)),c}class u{get byteLength(){return this._totalLength}constructor(){this._chunks=[],this._totalLength=0}acceptChunk(l){this._chunks.push(l),this._totalLength+=l.byteLength}read(l){return this._read(l,!0)}peek(l){return this._read(l,!1)}_read(l,d){if(l===0)return m();if(l>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===l){const T=this._chunks[0];return d&&(this._chunks.shift(),this._totalLength-=l),T}if(this._chunks[0].byteLength>l){const T=this._chunks[0].slice(0,l);return d&&(this._chunks[0]=this._chunks[0].slice(l),this._totalLength-=l),T}const D=i.VSBuffer.alloc(l);let w=0,M=0;for(;l>0;){const T=this._chunks[M];if(T.byteLength>l){const C=T.slice(0,l);D.set(C,w),w+=l,d&&(this._chunks[M]=T.slice(l),this._totalLength-=l),l-=l}else D.set(T,w),w+=T.byteLength,d?(this._chunks.shift(),this._totalLength-=T.byteLength):M++,l-=T.byteLength}return D}}e.ChunkStream=u;var p;(function(n){n[n.None=0]="None",n[n.Regular=1]="Regular",n[n.Control=2]="Control",n[n.Ack=3]="Ack",n[n.Disconnect=5]="Disconnect",n[n.ReplayRequest=6]="ReplayRequest",n[n.Pause=7]="Pause",n[n.Resume=8]="Resume",n[n.KeepAlive=9]="KeepAlive"})(p||(p={}));function v(n){switch(n){case p.None:return"None";case p.Regular:return"Regular";case p.Control:return"Control";case p.Ack:return"Ack";case p.Disconnect:return"Disconnect";case p.ReplayRequest:return"ReplayRequest";case p.Pause:return"PauseWriting";case p.Resume:return"ResumeWriting";case p.KeepAlive:return"KeepAlive"}}var f;(function(n){n[n.HeaderLength=13]="HeaderLength",n[n.AcknowledgeTime=2e3]="AcknowledgeTime",n[n.TimeoutTime=2e4]="TimeoutTime",n[n.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",n[n.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",n[n.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(f||(e.ProtocolConstants=f={}));class h{constructor(l,d,D,w){this.type=l,this.id=d,this.ack=D,this.data=w,this.writtenTime=0}get size(){return this.data.byteLength}}class E extends y.Disposable{constructor(l){super(),this._onMessage=this._register(new s.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:f.HeaderLength,messageType:p.None,id:0,ack:0},this._socket=l,this._isDisposed=!1,this._incomingData=new u,this._register(this._socket.onData(d=>this.acceptChunk(d))),this.lastReadTime=Date.now()}acceptChunk(l){if(!(!l||l.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(l);this._incomingData.byteLength>=this._state.readLen;){const d=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=d.readUInt32BE(9),this._state.messageType=d.readUInt8(0),this._state.id=d.readUInt32BE(1),this._state.ack=d.readUInt32BE(5),this._socket.traceSocketEvent(A.ProtocolHeaderRead,{messageType:v(this._state.messageType),id:this._state.id,ack:this._state.ack,messageSize:this._state.readLen});else{const D=this._state.messageType,w=this._state.id,M=this._state.ack;if(this._state.readHead=!0,this._state.readLen=f.HeaderLength,this._state.messageType=p.None,this._state.id=0,this._state.ack=0,this._socket.traceSocketEvent(A.ProtocolMessageRead,d),this._onMessage.fire(new h(D,w,M,d)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class b{constructor(l){this._writeNowTimeout=null,this._isDisposed=!1,this._isPaused=!1,this._socket=l,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}pause(){this._isPaused=!0}resume(){this._isPaused=!1,this._scheduleWriting()}write(l){if(this._isDisposed)return;l.writtenTime=Date.now(),this.lastWriteTime=Date.now();const d=i.VSBuffer.alloc(f.HeaderLength);d.writeUInt8(l.type,0),d.writeUInt32BE(l.id,1),d.writeUInt32BE(l.ack,5),d.writeUInt32BE(l.data.byteLength,9),this._socket.traceSocketEvent(A.ProtocolHeaderWrite,{messageType:v(l.type),id:l.id,ack:l.ack,messageSize:l.data.byteLength}),this._socket.traceSocketEvent(A.ProtocolMessageWrite,l.data),this._writeSoon(d,l.data)}_bufferAdd(l,d){const D=this._totalLength===0;return this._data.push(l,d),this._totalLength+=l.byteLength+d.byteLength,D}_bufferTake(){const l=i.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,l}_writeSoon(l,d){this._bufferAdd(l,d)&&this._scheduleWriting()}_scheduleWriting(){this._writeNowTimeout||(this._writeNowTimeout=setTimeout(()=>{this._writeNowTimeout=null,this._writeNow()}))}_writeNow(){if(this._totalLength===0||this._isPaused)return;const l=this._bufferTake();this._socket.traceSocketEvent(A.ProtocolWrite,{byteLength:l.byteLength}),this._socket.write(l)}}class g extends y.Disposable{constructor(l){super(),this._onMessage=new s.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new s.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=l,this._socketWriter=this._register(new b(this._socket)),this._socketReader=this._register(new E(this._socket)),this._register(this._socketReader.onMessage(d=>{d.type===p.Regular&&this._onMessage.fire(d.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(l){this._socketWriter.write(new h(p.Regular,0,0,l))}}e.Protocol=g;class I extends k.IPCClient{static fromSocket(l,d){return new I(new g(l),d)}get onDidDispose(){return this.protocol.onDidDispose}constructor(l,d,D=null){super(l,d,D),this.protocol=l}dispose(){super.dispose();const l=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),l.end()}}e.Client=I;class P{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new s.Emitter({onWillAddFirstListener:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onDidRemoveLastListener:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(l){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(l):this._emitter.fire(l):this._bufferedMessages.push(l)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=P;class r{constructor(l){this.data=l,this.next=null}}class a{constructor(){this._first=null,this._last=null}length(){let l=0,d=this._first;for(;d;)d=d.next,l++;return l}peek(){return this._first?this._first.data:null}toArray(){const l=[];let d=0,D=this._first;for(;D;)l[d++]=D.data,D=D.next;return l}pop(){if(this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(l){const d=new r(l);if(!this._first){this._first=d,this._last=d;return}this._last.next=d,this._last=d}}class t{static{this._HISTORY_LENGTH=10}static{this._INSTANCE=null}static getInstance(){return t._INSTANCE||(t._INSTANCE=new t),t._INSTANCE}constructor(){this.lastRuns=[];const l=Date.now();for(let d=0;d<t._HISTORY_LENGTH;d++)this.lastRuns[d]=l-1e3*d;setInterval(()=>{for(let d=t._HISTORY_LENGTH;d>=1;d--)this.lastRuns[d]=this.lastRuns[d-1];this.lastRuns[0]=Date.now()},1e3)}load(){const l=Date.now(),d=(1+t._HISTORY_LENGTH)*1e3;let D=0;for(let w=0;w<t._HISTORY_LENGTH;w++)l-this.lastRuns[w]<=d&&D++;return 1-D/t._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}class o{get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}constructor(l){this._onControlMessage=new P,this.onControlMessage=this._onControlMessage.event,this._onMessage=new P,this.onMessage=this._onMessage.event,this._onDidDispose=new P,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new P,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new P,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=l.loadEstimator??t.getInstance(),this._shouldSendKeepAlive=l.sendKeepAlive??!0,this._isReconnecting=!1,this._outgoingUnackMsg=new a,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socketDisposables=new y.DisposableStore,this._socket=l.socket,this._socketWriter=this._socketDisposables.add(new b(this._socket)),this._socketReader=this._socketDisposables.add(new E(this._socket)),this._socketDisposables.add(this._socketReader.onMessage(d=>this._receiveMessage(d))),this._socketDisposables.add(this._socket.onClose(d=>this._onSocketClose.fire(d))),l.initialChunk&&this._socketReader.acceptChunk(l.initialChunk),this._shouldSendKeepAlive?this._keepAliveInterval=setInterval(()=>{this._sendKeepAlive()},f.KeepAliveSendTime):this._keepAliveInterval=null}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._keepAliveInterval&&(clearInterval(this._keepAliveInterval),this._keepAliveInterval=null),this._socketDisposables.dispose()}drain(){return this._socketWriter.drain()}sendDisconnect(){if(!this._didSendDisconnect){this._didSendDisconnect=!0;const l=new h(p.Disconnect,0,0,m());this._socketWriter.write(l),this._socketWriter.flush()}}sendPause(){const l=new h(p.Pause,0,0,m());this._socketWriter.write(l)}sendResume(){const l=new h(p.Resume,0,0,m());this._socketWriter.write(l)}pauseSocketWriting(){this._socketWriter.pause()}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(l,d){this._isReconnecting=!0,this._socketDisposables.dispose(),this._socketDisposables=new y.DisposableStore,this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socket=l,this._socketWriter=this._socketDisposables.add(new b(this._socket)),this._socketReader=this._socketDisposables.add(new E(this._socket)),this._socketDisposables.add(this._socketReader.onMessage(D=>this._receiveMessage(D))),this._socketDisposables.add(this._socket.onClose(D=>this._onSocketClose.fire(D))),this._socketReader.acceptChunk(d)}endAcceptReconnection(){this._isReconnecting=!1,this._incomingAckId=this._incomingMsgId;const l=new h(p.Ack,0,this._incomingAckId,m());this._socketWriter.write(l);const d=this._outgoingUnackMsg.toArray();for(let D=0,w=d.length;D<w;D++)this._socketWriter.write(d[D]);this._recvAckCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(l){if(l.ack>this._outgoingAckId){this._outgoingAckId=l.ack;do{const d=this._outgoingUnackMsg.peek();if(d&&d.id<=l.ack)this._outgoingUnackMsg.pop();else break}while(!0)}switch(l.type){case p.None:break;case p.Regular:{if(l.id>this._incomingMsgId)if(l.id!==this._incomingMsgId+1){const d=Date.now();d-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=d,this._socketWriter.write(new h(p.ReplayRequest,0,0,m())))}else this._incomingMsgId=l.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(l.data);break}case p.Control:{this._onControlMessage.fire(l.data);break}case p.Ack:break;case p.Disconnect:{this._onDidDispose.fire();break}case p.ReplayRequest:{const d=this._outgoingUnackMsg.toArray();for(let D=0,w=d.length;D<w;D++)this._socketWriter.write(d[D]);this._recvAckCheck();break}case p.Pause:{this._socketWriter.pause();break}case p.Resume:{this._socketWriter.resume();break}case p.KeepAlive:break}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(l){const d=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const D=new h(p.Regular,d,this._incomingAckId,l);this._outgoingUnackMsg.push(D),this._isReconnecting||(this._socketWriter.write(D),this._recvAckCheck())}sendControl(l){const d=new h(p.Control,0,0,l);this._socketWriter.write(d)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const l=Date.now()-this._incomingMsgLastTime;if(l>=f.AcknowledgeTime){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},f.AcknowledgeTime-l+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const l=this._outgoingUnackMsg.peek(),d=Date.now()-l.writtenTime,D=Date.now()-this._socketReader.lastReadTime,w=Date.now()-this._lastSocketTimeoutTime;if(d>=f.TimeoutTime&&D>=f.TimeoutTime&&w>=f.TimeoutTime&&!this._loadEstimator.hasHighLoad()){this._lastSocketTimeoutTime=Date.now(),this._onSocketTimeout.fire({unacknowledgedMsgCount:this._outgoingUnackMsg.length(),timeSinceOldestUnacknowledgedMsg:d,timeSinceLastReceivedSomeData:D});return}const M=Math.max(f.TimeoutTime-d,f.TimeoutTime-D,f.TimeoutTime-w,500);this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},M)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const l=new h(p.Ack,0,this._incomingAckId,m());this._socketWriter.write(l)}_sendKeepAlive(){this._incomingAckId=this._incomingMsgId;const l=new h(p.KeepAlive,0,this._incomingAckId,m());this._socketWriter.write(l)}}e.PersistentProtocol=o});var je=this&&this.__importDefault||function(j){return j&&j.__esModule?j:{default:j}};define(le[35],ue([0,1,13,15,11]),function(j,e,i,s,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.validatedIpcMain=void 0,i=je(i);class k{constructor(){this.mapListenerToWrapper=new WeakMap}on(R,S){const c=(m,...u)=>{this.validateEvent(R,m)&&S(m,...u)};return this.mapListenerToWrapper.set(S,c),i.default.ipcMain.on(R,c),this}once(R,S){return i.default.ipcMain.once(R,(c,...m)=>{this.validateEvent(R,c)&&S(c,...m)}),this}handle(R,S){return i.default.ipcMain.handle(R,(c,...m)=>this.validateEvent(R,c)?S(c,...m):Promise.reject(`Invalid channel '${R}' or sender for ipcMain.handle() usage.`)),this}removeHandler(R){return i.default.ipcMain.removeHandler(R),this}removeListener(R,S){const c=this.mapListenerToWrapper.get(S);return c&&(i.default.ipcMain.removeListener(R,c),this.mapListenerToWrapper.delete(S)),this}validateEvent(R,S){if(!R||!R.startsWith("vscode:"))return(0,s.onUnexpectedError)(`Refused to handle ipcMain event for channel '${R}' because the channel is unknown.`),!1;const c=S.senderFrame,m=c.url;if(!m||m==="about:blank")return!0;let u="unknown";try{u=new URL(m).host}catch{return(0,s.onUnexpectedError)(`Refused to handle ipcMain event for channel '${R}' because of a malformed URL '${m}'.`),!1}return u!==y.VSCODE_AUTHORITY?((0,s.onUnexpectedError)(`Refused to handle ipcMain event for channel '${R}' because of a bad origin of '${u}'.`),!1):c.parent!==null?((0,s.onUnexpectedError)(`Refused to handle ipcMain event for channel '${R}' because sender of origin '${u}' is not a main frame.`),!1):!0}}e.validatedIpcMain=new k}),define(le[164],ue([0,1,13,35,155]),function(j,e,i,s,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerContextMenuListener=k;function k(){s.validatedIpcMain.on(y.CONTEXT_MENU_CHANNEL,(R,S,c,m,u)=>{const p=A(R,m,c);p.popup({x:u?u.x:void 0,y:u?u.y:void 0,positioningItem:u?u.positioningItem:void 0,callback:()=>{p&&R.sender.send(y.CONTEXT_MENU_CLOSE_CHANNEL,S)}})})}function A(R,S,c){const m=new i.Menu;return c.forEach(u=>{let p;u.type==="separator"?p=new i.MenuItem({type:u.type}):Array.isArray(u.submenu)?p=new i.MenuItem({submenu:A(R,S,u.submenu),label:u.label}):p=new i.MenuItem({label:u.label,type:u.type,accelerator:u.accelerator,checked:u.checked,enabled:u.enabled,visible:u.visible,click:(v,f,h)=>R.sender.send(S,u.id,h)}),m.append(p)}),m}}),define(le[165],ue([0,1,35,17,4,2,45,156]),function(j,e,i,s,y,k,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;function S(m,u){const p=y.Event.fromNodeEventEmitter(i.validatedIpcMain,u,(f,h)=>({event:f,message:h})),v=y.Event.filter(p,({event:f})=>f.sender.id===m);return y.Event.map(v,({message:f})=>f&&s.VSBuffer.wrap(f))}class c extends A.IPCServer{static{this.Clients=new Map}static getOnDidClientConnect(){const u=y.Event.fromNodeEventEmitter(i.validatedIpcMain,"vscode:hello",({sender:p})=>p);return y.Event.map(u,p=>{const v=p.id;c.Clients.get(v)?.dispose();const h=new y.Emitter;c.Clients.set(v,(0,k.toDisposable)(()=>h.fire()));const E=S(v,"vscode:message"),b=y.Event.any(y.Event.signal(S(v,"vscode:disconnect")),h.event);return{protocol:new R.Protocol(p,E),onDidClientDisconnect:b}})}constructor(){super(c.getOnDidClientConnect())}}e.Server=c}),define(le[122],ue([0,1,35,4,33,163]),function(j,e,i,s,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=void 0,e.connect=R;class A extends k.Client{constructor(c,m){super({addEventListener:(u,p)=>c.addListener(u,p),removeEventListener:(u,p)=>c.removeListener(u,p),postMessage:u=>c.postMessage(u),start:()=>c.start(),close:()=>c.close()},m)}}e.Client=A;async function R(S){if(S.isDestroyed()||S.webContents.isDestroyed())throw new Error("ipc.mp#connect: Cannot talk to window because it is closed or destroyed");const c=(0,y.generateUuid)();S.webContents.send("vscode:createMessageChannel",c);const m=s.Event.fromNodeEventEmitter(i.validatedIpcMain,"vscode:createMessageChannelResult",(p,v)=>({nonce:v,port:p.ports[0]})),{port:u}=await s.Event.toPromise(s.Event.once(s.Event.filter(m,p=>p.nonce===c)));return u}}),define(le[166],ue([0,1,44,8,17,22,159,15,4,2,37,96,82,45]),function(j,e,i,s,y,k,A,R,S,c,m,u,p,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0,R=Re(R);class f extends v.ChannelServer{constructor(b){super({send:g=>{try{process.send?.(g.buffer.toString("base64"))}catch{}},onMessage:S.Event.fromNodeEventEmitter(process,"message",g=>y.VSBuffer.wrap(Buffer.from(g,"base64")))},b),process.once("disconnect",()=>this.dispose())}}e.Server=f;class h{constructor(b,g){this.modulePath=b,this.options=g,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new S.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const I=g&&g.timeout?g.timeout:6e4;this.disposeDelayer=new s.Delayer(I),this.child=null,this._client=null}getChannel(b){const g=this;return{call(I,P,r){return g.requestPromise(b,I,P,r)},listen(I,P){return g.requestEvent(b,I,P)}}}requestPromise(b,g,I,P=k.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(P.isCancellationRequested)return Promise.reject(R.canceled());this.disposeDelayer.cancel();const r=this.getCachedChannel(b),a=(0,s.createCancelablePromise)(n=>r.call(g,I,n)),t=P.onCancellationRequested(()=>a.cancel()),o=(0,c.toDisposable)(()=>a.cancel());return this.activeRequests.add(o),a.finally(()=>{t.dispose(),this.activeRequests.delete(o),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),a}requestEvent(b,g,I){if(!this.disposeDelayer)return S.Event.None;this.disposeDelayer.cancel();let P;const r=new S.Emitter({onWillAddFirstListener:()=>{P=this.getCachedChannel(b).listen(g,I)(r.fire,r),this.activeRequests.add(P)},onDidRemoveLastListener:()=>{this.activeRequests.delete(P),P.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return r.event}get client(){if(!this._client){const b=this.options&&this.options.args?this.options.args:[],g=Object.create(null);g.env={...(0,m.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(g.env={...g.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(g.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(g.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(g.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),g.execArgv===void 0&&(g.execArgv=process.execArgv.filter(d=>!/^--inspect(-brk)?=/.test(d)).filter(d=>!d.startsWith("--vscode-"))),(0,p.removeDangerousEnvVariables)(g.env),this.child=(0,i.fork)(this.modulePath,b,g);const I=new S.Emitter,r=S.Event.fromNodeEventEmitter(this.child,"message",d=>d)(d=>{if((0,A.isRemoteConsoleLog)(d)){(0,A.log)(d,`IPC Library: ${this.options.serverName}`);return}I.fire(y.VSBuffer.wrap(Buffer.from(d,"base64")))}),a=this.options.useQueue?(0,u.createQueuedSender)(this.child):this.child,t=d=>this.child&&this.child.connected&&a.send(d.buffer.toString("base64")),o=I.event,n={send:t,onMessage:o};this._client=new v.ChannelClient(n);const l=()=>this.disposeClient();process.once("exit",l),this.child.on("error",d=>console.warn('IPC "'+this.options.serverName+'" errored with '+d)),this.child.on("exit",(d,D)=>{process.removeListener("exit",l),r.dispose(),this.activeRequests.forEach(w=>(0,c.dispose)(w)),this.activeRequests.clear(),d!==0&&D!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+d+" and signal "+D),this.disposeDelayer?.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:d,signal:D})})}return this._client}getCachedChannel(b){let g=this.channels.get(b);return g||(g=this.client.getChannel(b),this.channels.set(b,g)),g}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer?.cancel(),this.disposeDelayer=void 0,this.disposeClient(),this.activeRequests.clear()}}e.Client=h}),define(le[123],ue([0,1,8,4,2,83,12]),function(j,e,i,s,y,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.StorageHint=void 0,e.isStorageItemsChangeEvent=S;var R;(function(p){p[p.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",p[p.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(R||(e.StorageHint=R={}));function S(p){const v=p;return v?.changed instanceof Map||v?.deleted instanceof Set}var c;(function(p){p[p.None=0]="None",p[p.Initialized=1]="Initialized",p[p.Closed=2]="Closed"})(c||(e.StorageState=c={}));class m extends y.Disposable{static{this.DEFAULT_FLUSH_DELAY=100}constructor(v,f=Object.create(null)){super(),this.database=v,this.options=f,this._onDidChangeStorage=this._register(new s.PauseableEmitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=c.None,this.cache=new Map,this.flushDelayer=this._register(new i.ThrottledDelayer(m.DEFAULT_FLUSH_DELAY)),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(v=>this.onDidChangeItemsExternal(v)))}onDidChangeItemsExternal(v){this._onDidChangeStorage.pause();try{v.changed?.forEach((f,h)=>this.acceptExternal(h,f)),v.deleted?.forEach(f=>this.acceptExternal(f,void 0))}finally{this._onDidChangeStorage.resume()}}acceptExternal(v,f){if(this.state===c.Closed)return;let h=!1;(0,A.isUndefinedOrNull)(f)?h=this.cache.delete(v):this.cache.get(v)!==f&&(this.cache.set(v,f),h=!0),h&&this._onDidChangeStorage.fire({key:v,external:!0})}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===c.None&&(this.state=c.Initialized,this.options.hint!==R.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(v,f){const h=this.cache.get(v);return(0,A.isUndefinedOrNull)(h)?f:h}getBoolean(v,f){const h=this.get(v);return(0,A.isUndefinedOrNull)(h)?f:h==="true"}getNumber(v,f){const h=this.get(v);return(0,A.isUndefinedOrNull)(h)?f:parseInt(h,10)}getObject(v,f){const h=this.get(v);return(0,A.isUndefinedOrNull)(h)?f:(0,k.parse)(h)}async set(v,f,h=!1){if(this.state===c.Closed)return;if((0,A.isUndefinedOrNull)(f))return this.delete(v,h);const E=(0,A.isObject)(f)||Array.isArray(f)?(0,k.stringify)(f):String(f);if(this.cache.get(v)!==E)return this.cache.set(v,E),this.pendingInserts.set(v,E),this.pendingDeletes.delete(v),this._onDidChangeStorage.fire({key:v,external:h}),this.doFlush()}async delete(v,f=!1){if(!(this.state===c.Closed||!this.cache.delete(v)))return this.pendingDeletes.has(v)||this.pendingDeletes.add(v),this.pendingInserts.delete(v),this._onDidChangeStorage.fire({key:v,external:f}),this.doFlush()}async optimize(){if(this.state!==c.Closed)return await this.flush(0),this.database.optimize()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=c.Closed;try{await this.doFlush(0)}catch{}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const v={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(v).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(v){if(!(this.state===c.Closed||this.pendingClose))return this.doFlush(v)}async doFlush(v){return this.options.hint===R.STORAGE_IN_MEMORY?this.flushPending():this.flushDelayer.trigger(()=>this.flushPending(),v)}async whenFlushed(){if(this.hasPending)return new Promise(v=>this.whenFlushedCallbacks.push(v))}isInMemory(){return this.options.hint===R.STORAGE_IN_MEMORY}}e.Storage=m;class u{constructor(){this.onDidChangeItemsExternal=s.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(v){v.insert?.forEach((f,h)=>this.items.set(h,f)),v.delete?.forEach(f=>this.items.delete(f))}async optimize(){}async close(){}}e.InMemoryStorageDatabase=u}),define(le[167],ue([0,1,26,8,4,31,10,23]),function(j,e,i,s,y,k,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SQLiteStorageDatabase=void 0,i=Re(i);class S{static{this.IN_MEMORY_PATH=":memory:"}get onDidChangeItemsExternal(){return y.Event.None}static{this.BUSY_OPEN_TIMEOUT=2e3}static{this.MAX_HOST_PARAMETERS=256}constructor(u,p=Object.create(null)){this.path=u,this.options=p,this.name=(0,A.basename)(this.path),this.logger=new c(this.options.logging),this.whenConnected=this.connect(this.path)}async getItems(){const u=await this.whenConnected,p=new Map;return(await this.all(u,"SELECT * FROM ItemTable")).forEach(f=>p.set(f.key,f.value)),this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] getItems(): ${p.size} rows`),p}async updateItems(u){const p=await this.whenConnected;return this.doUpdateItems(p,u)}doUpdateItems(u,p){return this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] updateItems(): insert(${p.insert?(0,k.mapToString)(p.insert):"0"}), delete(${p.delete?(0,k.setToString)(p.delete):"0"})`),this.transaction(u,()=>{const v=p.insert,f=p.delete;if(v&&v.size>0){const h=[];h.push([]);let E=0;v.forEach((b,g)=>{let I=h[E];I.length>S.MAX_HOST_PARAMETERS&&(E++,I=[],h.push(I)),I.push(g,b)}),h.forEach(b=>{this.prepare(u,`INSERT INTO ItemTable VALUES ${new Array(b.length/2).fill("(?,?)").join(",")}`,g=>g.run(b),()=>{const g=[];let I=0;return v.forEach((P,r)=>{g.push(r),I+=P.length}),`Keys: ${g.join(", ")} Length: ${I}`})})}if(f&&f.size){const h=[];h.push([]);let E=0;f.forEach(b=>{let g=h[E];g.length>S.MAX_HOST_PARAMETERS&&(E++,g=[],h.push(g)),g.push(b)}),h.forEach(b=>{this.prepare(u,`DELETE FROM ItemTable WHERE key IN (${new Array(b.length).fill("?").join(",")})`,g=>g.run(b),()=>{const g=[];return f.forEach(I=>{g.push(I)}),`Keys: ${g.join(", ")}`})})}})}async optimize(){this.logger.trace(`[storage ${this.name}] vacuum()`);const u=await this.whenConnected;return this.exec(u,"VACUUM")}async close(u){this.logger.trace(`[storage ${this.name}] close()`);const p=await this.whenConnected;return this.doClose(p,u)}doClose(u,p){return new Promise((v,f)=>{u.db.close(h=>(h&&this.handleSQLiteError(u,`[storage ${this.name}] close(): ${h}`),this.path===S.IN_MEMORY_PATH?v():!u.isErroneous&&!u.isInMemory?this.backup().then(v,E=>(this.logger.error(`[storage ${this.name}] backup(): ${E}`),v())):typeof p=="function"?i.promises.unlink(this.path).then(()=>this.doConnect(this.path).then(E=>{const b=()=>this.doClose(E,void 0);return this.doUpdateItems(E,{insert:p()}).then(()=>b(),g=>(b(),Promise.reject(g)))})).then(v,f):f(h||new Error("Database has errors or is in-memory without recovery option"))))})}backup(){const u=this.toBackupPath(this.path);return R.Promises.copy(this.path,u,{preserveSymlinks:!1})}toBackupPath(u){return`${u}.backup`}async checkIntegrity(u){this.logger.trace(`[storage ${this.name}] checkIntegrity(full: ${u})`);const p=await this.whenConnected,v=await this.get(p,u?"PRAGMA integrity_check":"PRAGMA quick_check"),f=u?v.integrity_check:v.quick_check;return p.isErroneous?`${f} (last error: ${p.lastError})`:p.isInMemory?`${f} (in-memory!)`:f}async connect(u,p=!0){this.logger.trace(`[storage ${this.name}] open(${u}, retryOnBusy: ${p})`);try{return await this.doConnect(u)}catch(v){if(this.logger.error(`[storage ${this.name}] open(): Unable to open DB due to ${v}`),v.code==="SQLITE_BUSY"&&p)return await(0,s.timeout)(S.BUSY_OPEN_TIMEOUT),this.connect(u,!1);try{await i.promises.unlink(u);try{await R.Promises.rename(this.toBackupPath(u),u,!1)}catch{}return await this.doConnect(u)}catch(f){return this.logger.error(`[storage ${this.name}] open(): Unable to use backup due to ${f}`),this.doConnect(S.IN_MEMORY_PATH)}}}handleSQLiteError(u,p){u.isErroneous=!0,u.lastError=p,this.logger.error(p)}doConnect(u){return new Promise((p,v)=>{new Promise((f,h)=>{j(["@vscode/sqlite3"],f,h)}).then(Re).then(f=>{const h=this.logger.isTracing?f.verbose().Database:f.Database,E={db:new h(u,b=>b?E.db&&b.code!=="SQLITE_CANTOPEN"?E.db.close(()=>v(b)):v(b):this.exec(E,["PRAGMA user_version = 1;","CREATE TABLE IF NOT EXISTS ItemTable (key TEXT UNIQUE ON CONFLICT REPLACE, value BLOB)"].join("")).then(()=>p(E),g=>E.db.close(()=>v(g)))),isInMemory:u===S.IN_MEMORY_PATH};E.db.on("error",b=>this.handleSQLiteError(E,`[storage ${this.name}] Error (event): ${b}`)),this.logger.isTracing&&E.db.on("trace",b=>this.logger.trace(`[storage ${this.name}] Trace (event): ${b}`))},v)})}exec(u,p){return new Promise((v,f)=>{u.db.exec(p,h=>h?(this.handleSQLiteError(u,`[storage ${this.name}] exec(): ${h}`),f(h)):v())})}get(u,p){return new Promise((v,f)=>{u.db.get(p,(h,E)=>h?(this.handleSQLiteError(u,`[storage ${this.name}] get(): ${h}`),f(h)):v(E))})}all(u,p){return new Promise((v,f)=>{u.db.all(p,(h,E)=>h?(this.handleSQLiteError(u,`[storage ${this.name}] all(): ${h}`),f(h)):v(E))})}transaction(u,p){return new Promise((v,f)=>{u.db.serialize(()=>{u.db.run("BEGIN TRANSACTION"),p(),u.db.run("END TRANSACTION",h=>h?(this.handleSQLiteError(u,`[storage ${this.name}] transaction(): ${h}`),f(h)):v())})})}prepare(u,p,v,f){const h=u.db.prepare(p),E=b=>{this.handleSQLiteError(u,`[storage ${this.name}] prepare(): ${b} (${p}). Details: ${f()}`)};h.on("error",E),v(h),h.finalize(b=>{b&&E(b),h.removeListener("error",E)})}}e.SQLiteStorageDatabase=S;class c{static{this.VSCODE_TRACE_STORAGE="VSCODE_TRACE_STORAGE"}constructor(u){u&&typeof u.logTrace=="function"&&process.env[c.VSCODE_TRACE_STORAGE]&&(this.logTrace=u.logTrace),u&&typeof u.logError=="function"&&(this.logError=u.logError)}get isTracing(){return!!this.logTrace}trace(u){this.logTrace?.(u)}error(u){this.logError?.(u)}}}),define(le[168],ue([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isFolderBackupInfo=i,e.isWorkspaceBackupInfo=s;function i(y){return y&&y.hasOwnProperty("folderUri")}function s(y){return y&&y.hasOwnProperty("workspace")}}),define(le[169],ue([0,1,7]),function(j,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEmptyWindowBackupInfo=s,e.deserializeWorkspaceInfos=y,e.deserializeFolderInfos=k;function s(A){return typeof A?.backupFolder=="string"}function y(A){let R=[];try{Array.isArray(A.workspaces)&&(R=A.workspaces.map(S=>({workspace:{id:S.id,configPath:i.URI.parse(S.configURIPath)},remoteAuthority:S.remoteAuthority})))}catch{}return R}function k(A){let R=[];try{Array.isArray(A.folders)&&(R=A.folders.map(S=>({folderUri:i.URI.parse(S.folderUri),remoteAuthority:S.remoteAuthority})))}catch{}return R}}),define(le[170],ue([0,1,39,15,9]),function(j,e,i,s,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Scanner=e.TokenType=void 0;var k;(function(m){m[m.LParen=0]="LParen",m[m.RParen=1]="RParen",m[m.Neg=2]="Neg",m[m.Eq=3]="Eq",m[m.NotEq=4]="NotEq",m[m.Lt=5]="Lt",m[m.LtEq=6]="LtEq",m[m.Gt=7]="Gt",m[m.GtEq=8]="GtEq",m[m.RegexOp=9]="RegexOp",m[m.RegexStr=10]="RegexStr",m[m.True=11]="True",m[m.False=12]="False",m[m.In=13]="In",m[m.Not=14]="Not",m[m.And=15]="And",m[m.Or=16]="Or",m[m.Str=17]="Str",m[m.QuotedStr=18]="QuotedStr",m[m.Error=19]="Error",m[m.EOF=20]="EOF"})(k||(e.TokenType=k={}));function A(...m){switch(m.length){case 1:return(0,y.localize)(1693,null,m[0]);case 2:return(0,y.localize)(1694,null,m[0],m[1]);case 3:return(0,y.localize)(1695,null,m[0],m[1],m[2]);default:return}}const R=(0,y.localize)(1696,null),S=(0,y.localize)(1697,null);class c{constructor(){this._input="",this._start=0,this._current=0,this._tokens=[],this._errors=[],this.stringRe=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(u){switch(u.type){case k.LParen:return"(";case k.RParen:return")";case k.Neg:return"!";case k.Eq:return u.isTripleEq?"===":"==";case k.NotEq:return u.isTripleEq?"!==":"!=";case k.Lt:return"<";case k.LtEq:return"<=";case k.Gt:return">=";case k.GtEq:return">=";case k.RegexOp:return"=~";case k.RegexStr:return u.lexeme;case k.True:return"true";case k.False:return"false";case k.In:return"in";case k.Not:return"not";case k.And:return"&&";case k.Or:return"||";case k.Str:return u.lexeme;case k.QuotedStr:return u.lexeme;case k.Error:return u.lexeme;case k.EOF:return"EOF";default:throw(0,s.illegalState)(`unhandled token type: ${JSON.stringify(u)}; have you forgotten to add a case?`)}}static{this._regexFlags=new Set(["i","g","s","m","y","u"].map(u=>u.charCodeAt(0)))}static{this._keywords=new Map([["not",k.Not],["in",k.In],["false",k.False],["true",k.True]])}get errors(){return this._errors}reset(u){return this._input=u,this._start=0,this._current=0,this._tokens=[],this._errors=[],this}scan(){for(;!this._isAtEnd();)switch(this._start=this._current,this._advance()){case i.CharCode.OpenParen:this._addToken(k.LParen);break;case i.CharCode.CloseParen:this._addToken(k.RParen);break;case i.CharCode.ExclamationMark:if(this._match(i.CharCode.Equals)){const p=this._match(i.CharCode.Equals);this._tokens.push({type:k.NotEq,offset:this._start,isTripleEq:p})}else this._addToken(k.Neg);break;case i.CharCode.SingleQuote:this._quotedString();break;case i.CharCode.Slash:this._regex();break;case i.CharCode.Equals:if(this._match(i.CharCode.Equals)){const p=this._match(i.CharCode.Equals);this._tokens.push({type:k.Eq,offset:this._start,isTripleEq:p})}else this._match(i.CharCode.Tilde)?this._addToken(k.RegexOp):this._error(A("==","=~"));break;case i.CharCode.LessThan:this._addToken(this._match(i.CharCode.Equals)?k.LtEq:k.Lt);break;case i.CharCode.GreaterThan:this._addToken(this._match(i.CharCode.Equals)?k.GtEq:k.Gt);break;case i.CharCode.Ampersand:this._match(i.CharCode.Ampersand)?this._addToken(k.And):this._error(A("&&"));break;case i.CharCode.Pipe:this._match(i.CharCode.Pipe)?this._addToken(k.Or):this._error(A("||"));break;case i.CharCode.Space:case i.CharCode.CarriageReturn:case i.CharCode.Tab:case i.CharCode.LineFeed:case i.CharCode.NoBreakSpace:break;default:this._string()}return this._start=this._current,this._addToken(k.EOF),Array.from(this._tokens)}_match(u){return this._isAtEnd()||this._input.charCodeAt(this._current)!==u?!1:(this._current++,!0)}_advance(){return this._input.charCodeAt(this._current++)}_peek(){return this._isAtEnd()?i.CharCode.Null:this._input.charCodeAt(this._current)}_addToken(u){this._tokens.push({type:u,offset:this._start})}_error(u){const p=this._start,v=this._input.substring(this._start,this._current),f={type:k.Error,offset:this._start,lexeme:v};this._errors.push({offset:p,lexeme:v,additionalInfo:u}),this._tokens.push(f)}_string(){this.stringRe.lastIndex=this._start;const u=this.stringRe.exec(this._input);if(u){this._current=this._start+u[0].length;const p=this._input.substring(this._start,this._current),v=c._keywords.get(p);v?this._addToken(v):this._tokens.push({type:k.Str,lexeme:p,offset:this._start})}}_quotedString(){for(;this._peek()!==i.CharCode.SingleQuote&&!this._isAtEnd();)this._advance();if(this._isAtEnd()){this._error(R);return}this._advance(),this._tokens.push({type:k.QuotedStr,lexeme:this._input.substring(this._start+1,this._current-1),offset:this._start+1})}_regex(){let u=this._current,p=!1,v=!1;for(;;){if(u>=this._input.length){this._current=u,this._error(S);return}const h=this._input.charCodeAt(u);if(p)p=!1;else if(h===i.CharCode.Slash&&!v){u++;break}else h===i.CharCode.OpenSquareBracket?v=!0:h===i.CharCode.Backslash?p=!0:h===i.CharCode.CloseSquareBracket&&(v=!1);u++}for(;u<this._input.length&&c._regexFlags.has(this._input.charCodeAt(u));)u++;this._current=u;const f=this._input.substring(this._start,this._current);this._tokens.push({type:k.RegexStr,lexeme:f,offset:this._start})}_isAtEnd(){return this._current>=this._input.length}}e.Scanner=c}),define(le[171],ue([0,1,4,2]),function(j,e,i,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostDebugChannelClient=e.ExtensionHostDebugBroadcastChannel=void 0;class y{constructor(){this._onCloseEmitter=new i.Emitter,this._onReloadEmitter=new i.Emitter,this._onTerminateEmitter=new i.Emitter,this._onAttachEmitter=new i.Emitter}static{this.ChannelName="extensionhostdebugservice"}call(R,S,c){switch(S){case"close":return Promise.resolve(this._onCloseEmitter.fire({sessionId:c[0]}));case"reload":return Promise.resolve(this._onReloadEmitter.fire({sessionId:c[0]}));case"terminate":return Promise.resolve(this._onTerminateEmitter.fire({sessionId:c[0]}));case"attach":return Promise.resolve(this._onAttachEmitter.fire({sessionId:c[0],port:c[1],subId:c[2]}))}throw new Error("Method not implemented.")}listen(R,S,c){switch(S){case"close":return this._onCloseEmitter.event;case"reload":return this._onReloadEmitter.event;case"terminate":return this._onTerminateEmitter.event;case"attach":return this._onAttachEmitter.event}throw new Error("Method not implemented.")}}e.ExtensionHostDebugBroadcastChannel=y;class k extends s.Disposable{constructor(R){super(),this.channel=R}reload(R){this.channel.call("reload",[R])}get onReload(){return this.channel.listen("reload")}close(R){this.channel.call("close",[R])}get onClose(){return this.channel.listen("close")}attachSession(R,S,c){this.channel.call("attach",[R,S,c])}get onAttachSession(){return this.channel.listen("attach")}terminateSession(R,S){this.channel.call("terminate",[R,S])}get onTerminateSession(){return this.channel.listen("terminate")}openExtensionDevelopmentHostWindow(R,S){return this.channel.call("openExtensionDevelopmentHostWindow",[R,S])}}e.ExtensionHostDebugChannelClient=k}),define(le[172],ue([0,1,157,54,11,10,38,18,7]),function(j,e,i,s,y,k,A,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractNativeEnvironmentService=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=void 0,e.parseExtensionHostDebugPort=m,e.parseDebugParams=u,e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=/^([^.]+\..+)[:=](.+)$/;class c{get appRoot(){return(0,k.dirname)(y.FileAccess.asFileUri("").fsPath)}get userHome(){return S.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return S.URI.file((0,k.join)(this.userDataPath,"User"))}get tmpDir(){return S.URI.file(this.paths.tmpDir)}get cacheHome(){return S.URI.file(this.userDataPath)}get stateResource(){return(0,R.joinPath)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:y.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,R.joinPath)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const v=(0,i.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,k.join)(this.userDataPath,"logs",v)}return S.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,R.joinPath)(S.URI.file((0,k.join)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,R.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,R.joinPath)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,R.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const v=A.env.VSCODE_PORTABLE;return v?S.URI.file((0,k.join)(v,"argv.json")):(0,R.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return S.URI.file((0,k.join)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const v=this.args["builtin-extensions-dir"];return v?(0,k.resolve)(v):(0,k.normalize)((0,k.join)(y.FileAccess.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const v=this.args["extensions-download-dir"];return v?S.URI.file((0,k.resolve)(v)):S.URI.file((0,k.join)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const v=this.args["extensions-dir"];if(v)return(0,k.resolve)(v);const f=A.env.VSCODE_EXTENSIONS;if(f)return f;const h=A.env.VSCODE_PORTABLE;return h?(0,k.join)(h,"extensions"):(0,R.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const v=this.args.extensionDevelopmentPath;if(Array.isArray(v))return v.map(f=>/^[^:/?#]+?:\/\//.test(f)?S.URI.parse(f):S.URI.file((0,k.normalize)(f)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(v=>v==="ui"||v==="workspace"||v==="web"?v:"workspace")}get extensionTestsLocationURI(){const v=this.args.extensionTestsPath;if(v)return/^[^:/?#]+?:\/\//.test(v)?S.URI.parse(v):S.URI.file((0,k.normalize)(v))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const v=this.args["disable-extension"];if(v){if(typeof v=="string")return[v];if(Array.isArray(v)&&v.length>0)return v}return!1}get debugExtensionHost(){return m(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!A.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(v=>!e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.test(v))}get extensionLogLevel(){const v=[];for(const f of this.args.log||[]){const h=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.exec(f);h&&h[1]&&h[2]&&v.push([h[1],h[2]])}return v.length?v:void 0}get serviceMachineIdResource(){return(0,R.joinPath)(S.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const v=A.env.VSCODE_PORTABLE;return v?S.URI.file((0,k.join)(v,"policy.json")):(0,R.joinPath)(this.userHome,this.productService.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(v){this.args.continueOn=v}get args(){return this._args}constructor(v,f,h){this._args=v,this.paths=f,this.productService=h,this.editSessionId=this.args.editSessionId}}e.AbstractNativeEnvironmentService=c,Pe([s.memoize],c.prototype,"appRoot",null),Pe([s.memoize],c.prototype,"userHome",null),Pe([s.memoize],c.prototype,"userDataPath",null),Pe([s.memoize],c.prototype,"appSettingsHome",null),Pe([s.memoize],c.prototype,"tmpDir",null),Pe([s.memoize],c.prototype,"cacheHome",null),Pe([s.memoize],c.prototype,"stateResource",null),Pe([s.memoize],c.prototype,"userRoamingDataHome",null),Pe([s.memoize],c.prototype,"userDataSyncHome",null),Pe([s.memoize],c.prototype,"sync",null),Pe([s.memoize],c.prototype,"machineSettingsResource",null),Pe([s.memoize],c.prototype,"workspaceStorageHome",null),Pe([s.memoize],c.prototype,"localHistoryHome",null),Pe([s.memoize],c.prototype,"keyboardLayoutResource",null),Pe([s.memoize],c.prototype,"argvResource",null),Pe([s.memoize],c.prototype,"isExtensionDevelopment",null),Pe([s.memoize],c.prototype,"untitledWorkspacesHome",null),Pe([s.memoize],c.prototype,"builtinExtensionsPath",null),Pe([s.memoize],c.prototype,"extensionsPath",null),Pe([s.memoize],c.prototype,"extensionDevelopmentLocationURI",null),Pe([s.memoize],c.prototype,"extensionDevelopmentKind",null),Pe([s.memoize],c.prototype,"extensionTestsLocationURI",null),Pe([s.memoize],c.prototype,"debugExtensionHost",null),Pe([s.memoize],c.prototype,"logLevel",null),Pe([s.memoize],c.prototype,"extensionLogLevel",null),Pe([s.memoize],c.prototype,"serviceMachineIdResource",null),Pe([s.memoize],c.prototype,"disableTelemetry",null),Pe([s.memoize],c.prototype,"disableWorkspaceTrust",null),Pe([s.memoize],c.prototype,"useInMemorySecretStorage",null),Pe([s.memoize],c.prototype,"policyFile",null);function m(p,v){return u(p["inspect-extensions"],p["inspect-brk-extensions"],5870,v,p.debugId,p.extensionEnvironment)}function u(p,v,f,h,E,b){const I=Number(v||p)||(h?null:f),P=I?!!v:!1;let r;if(b)try{r=JSON.parse(b)}catch{}return{port:I,break:P,debugId:E,env:r}}});var je=this&&this.__importDefault||function(j){return j&&j.__esModule?j:{default:j}};define(le[124],ue([0,1,284,3,9]),function(j,e,i,s,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OPTIONS=e.NATIVE_CLI_COMMANDS=void 0,e.parseArgs=R,e.formatOptions=c,e.buildHelpMessage=v,e.buildVersionMessage=f,i=je(i);const k={o:(0,y.localize)(1713,null),e:(0,y.localize)(1714,null),t:(0,y.localize)(1715,null)};e.NATIVE_CLI_COMMANDS=["tunnel","serve-web"],e.OPTIONS={tunnel:{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,y.localize)(1716,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"},user:{type:"subcommand",options:{login:{type:"subcommand",options:{provider:{type:"string"},"access-token":{type:"string"}}}}}}},"serve-web":{type:"subcommand",description:"Run a server that displays the editor UI in browsers.",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,y.localize)(1717,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"}}},diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,y.localize)(1718,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,y.localize)(1719,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,y.localize)(1720,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,y.localize)(1721,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,y.localize)(1722,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,y.localize)(1723,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,y.localize)(1724,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,y.localize)(1725,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,y.localize)(1726,null)},profile:{type:"string",cat:"o",args:"profileName",description:(0,y.localize)(1727,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,y.localize)(1728,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,y.localize)(1729,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,y.localize)(1730,null)},"show-versions":{type:"boolean",cat:"e",description:(0,y.localize)(1731,null)},category:{type:"string",allowEmptyValue:!0,cat:"e",description:(0,y.localize)(1732,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,y.localize)(1733,null)},"pre-release":{type:"boolean",cat:"e",description:(0,y.localize)(1734,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,y.localize)(1735,null)},"update-extensions":{type:"boolean",cat:"e",description:(0,y.localize)(1736,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,y.localize)(1737,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,y.localize)(1738,null)},verbose:{type:"boolean",cat:"t",global:!0,description:(0,y.localize)(1739,null)},log:{type:"string[]",cat:"t",args:"level",global:!0,description:(0,y.localize)(1740,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,y.localize)(1741,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,y.localize)(1742,null)},"prof-append-timers":{type:"string"},"prof-duration-markers":{type:"string[]"},"prof-duration-markers-file":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,y.localize)(1743,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,y.localize)(1744,null)},sync:{type:"string",cat:"t",description:(0,y.localize)(1745,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,y.localize)(1746,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,y.localize)(1747,null)},"disable-lcd-text":{type:"boolean",cat:"t",description:(0,y.localize)(1748,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,y.localize)(1749,null)},"disable-chromium-sandbox":{type:"boolean",cat:"t",description:(0,y.localize)(1750,null)},sandbox:{type:"boolean"},telemetry:{type:"boolean",cat:"t",description:(0,y.localize)(1751,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"inspect-sharedprocess":{type:"string",allowEmptyValue:!0},"inspect-brk-sharedprocess":{type:"string",allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"use-inmemory-secretstorage":{type:"boolean",deprecates:["disable-keytar"]},"password-store":{type:"string"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"preserve-env":{type:"boolean"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},"disable-gpu-sandbox":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},"ozone-platform":{type:"string"},"enable-tracing":{type:"string"},"trace-startup-format":{type:"string"},"trace-startup-file":{type:"string"},"trace-startup-duration":{type:"string"},_:{type:"string[]"}};const A={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function R(h,E,b=A){const g=h.find(d=>d.length>0&&d[0]!=="-"),I={},P=["_"],r=[],a={};let t;for(const d in E){const D=E[d];D.type==="subcommand"?d===g&&(t=D):(D.alias&&(I[d]=D.alias),D.type==="string"||D.type==="string[]"?(P.push(d),D.deprecates&&P.push(...D.deprecates)):D.type==="boolean"&&(r.push(d),D.deprecates&&r.push(...D.deprecates)),D.global&&(a[d]=D))}if(t&&g){const d=a;for(const T in t.options)d[T]=t.options[T];const D=h.filter(T=>T!==g),w=b.getSubcommandReporter?b.getSubcommandReporter(g):void 0,M=R(D,d,w);return{[g]:M,_:[]}}const o=(0,i.default)(h,{string:P,boolean:r,alias:I}),n={},l=o;n._=o._.map(d=>String(d)).filter(d=>d.length>0),delete l._;for(const d in E){const D=E[d];if(D.type==="subcommand")continue;D.alias&&delete l[D.alias];let w=l[d];if(D.deprecates)for(const M of D.deprecates)l.hasOwnProperty(M)&&(w||(w=l[M],w&&b.onDeprecatedOption(M,D.deprecationMessage||(0,y.localize)(1752,null,d))),delete l[M]);if(typeof w<"u"){if(D.type==="string[]"){if(Array.isArray(w)||(w=[w]),!D.allowEmptyValue){const M=w.filter(T=>T.length>0);M.length!==w.length&&(b.onEmptyValue(d),w=M.length>0?M:void 0)}}else D.type==="string"&&(Array.isArray(w)?(w=w.pop(),b.onMultipleValues(d,w)):!w&&!D.allowEmptyValue&&(b.onEmptyValue(d),w=void 0));n[d]=w,D.deprecationMessage&&b.onDeprecatedOption(d,D.deprecationMessage)}delete l[d]}for(const d in l)b.onUnknownOption(d);return n}function S(h,E){let b="";return E.args&&(Array.isArray(E.args)?b=` <${E.args.join("> <")}>`:b=` <${E.args}>`),E.alias?`-${E.alias} --${h}${b}`:`--${h}${b}`}function c(h,E){const b=[];for(const g in h){const I=h[g],P=S(g,I);b.push([P,I.description])}return m(b,E)}function m(h,E){const g=h.reduce((r,a)=>Math.max(r,a[0].length),12)+2+1;if(E-g<25)return h.reduce((r,a)=>r.concat([`  ${a[0]}`,`      ${a[1]}`]),[]);const I=E-g-1,P=[];for(const r of h){const a=r[0],t=p(r[1],I),o=u(g-a.length-2);P.push("  "+a+o+t[0]);for(let n=1;n<t.length;n++)P.push(u(g)+t[n])}return P}function u(h){return" ".repeat(h)}function p(h,E){const b=[];for(;h.length;){const g=h.length<E?h.length:h.lastIndexOf(" ",E),I=h.slice(0,g).trim();h=h.slice(g),b.push(I)}return b}function v(h,E,b,g,I){const P=process.stdout.isTTY&&process.stdout.columns||80,r=I?.noInputFiles!==!0?`[${(0,y.localize)(1753,null)}...]`:"",a=[`${h} ${b}`];a.push(""),a.push(`${(0,y.localize)(1754,null)}: ${E} [${(0,y.localize)(1755,null)}]${r}`),a.push(""),I?.noPipe!==!0&&(s.isWindows?a.push((0,y.localize)(1756,null,E)):a.push((0,y.localize)(1757,null,E)),a.push(""));const t={},o=[];for(const n in g){const l=g[n];if(l.type==="subcommand")l.description&&o.push({command:n,description:l.description});else if(l.description&&l.cat){let d=t[l.cat];d||(t[l.cat]=d={}),d[n]=l}}for(const n in t){const l=n,d=t[l];d&&(a.push(k[l]),a.push(...c(d,P)),a.push(""))}return o.length&&(a.push((0,y.localize)(1758,null)),a.push(...m(o.map(n=>[n.command,n.description]),P)),a.push("")),a.join(`
`)}function f(h,E){return`${h||(0,y.localize)(1759,null)}
${E||(0,y.localize)(1760,null)}
${process.arch}`}});var je=this&&this.__importDefault||function(j){return j&&j.__esModule?j:{default:j}};define(le[69],ue([0,1,285,9,124]),function(j,e,i,s,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseMainProcessArgv=R,e.parseCLIProcessArgv=S,e.addArg=c,e.isLaunchedFromCli=m,i=je(i);function k(u,p){const v=(I,P)=>{console.warn((0,s.localize)(1761,null,I,P))},f=I=>{console.warn((0,s.localize)(1762,null,I))},h=(I,P)=>{console.warn((0,s.localize)(1763,null,I,P))},E=I=>({onUnknownOption:P=>{y.NATIVE_CLI_COMMANDS.includes(I)||console.warn((0,s.localize)(1764,null,P,I))},onMultipleValues:v,onEmptyValue:f,onDeprecatedOption:h,getSubcommandReporter:y.NATIVE_CLI_COMMANDS.includes(I)?E:void 0}),b={onUnknownOption:I=>{console.warn((0,s.localize)(1765,null,I))},onMultipleValues:v,onEmptyValue:f,onDeprecatedOption:h,getSubcommandReporter:E},g=(0,y.parseArgs)(u,y.OPTIONS,p?b:void 0);return g.goto&&g._.forEach(I=>(0,i.default)(/^(\w:)?[^:]+(:\d*){0,2}:?$/.test(I),(0,s.localize)(1766,null))),g}function A(u){const p=u.findIndex(v=>!/^-/.test(v));if(p>-1)return[...u.slice(0,p),...u.slice(p+1)]}function R(u){let[,...p]=u;process.env.VSCODE_DEV&&(p=A(p)||[]);const v=!m(process.env);return k(p,v)}function S(u){let[,,...p]=u;return process.env.VSCODE_DEV&&(p=A(p)||[]),k(p,!0)}function c(u,...p){const v=u.indexOf("--");return v===-1?u.push(...p):u.splice(v,0,...p),u}function m(u){return u.VSCODE_CLI==="1"}}),function(){function j(e,i,s){function y(A,R){const S=k(A,R),c=[S];return e.isAbsolute(S)||c.unshift(s),e.resolve(...c)}function k(A,R){process.env.VSCODE_DEV&&(R="code-oss-dev");const S=process.env.VSCODE_PORTABLE;if(S)return e.join(S,"user-data");let c=process.env.VSCODE_APPDATA;if(c)return e.join(c,R);const m=A["user-data-dir"];if(m)return m;switch(process.platform){case"win32":if(c=process.env.APPDATA,!c){const u=process.env.USERPROFILE;if(typeof u!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");c=e.join(u,"AppData","Roaming")}break;case"darwin":c=e.join(i.homedir(),"Library","Application Support");break;case"linux":c=process.env.XDG_CONFIG_HOME||e.join(i.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(c,R)}return{getUserDataPath:y}}if(typeof define=="function")define(le[173],ue([97,27,38]),function(e,i,s){return j(e,i,s.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),i=require("os");module.exports=j(e,i,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(le[98],ue([0,1,27,172,173]),function(j,e,i,s,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0,e.parsePtyHostDebugPort=A,e.parseSharedProcessDebugPort=R;class k extends s.AbstractNativeEnvironmentService{constructor(c,m){super(c,{homeDir:(0,i.homedir)(),tmpDir:(0,i.tmpdir)(),userDataDir:(0,y.getUserDataPath)(c,m.nameShort)},m)}}e.NativeEnvironmentService=k;function A(S,c){return(0,s.parseDebugParams)(S["inspect-ptyhost"],S["inspect-brk-ptyhost"],5877,c,S.extensionEnvironment)}function R(S,c){return(0,s.parseDebugParams)(S["inspect-sharedprocess"],S["inspect-brk-sharedprocess"],5879,c,S.extensionEnvironment)}}),define(le[174],ue([0,1,26,27,32]),function(j,e,i,s,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createWaitMarkerFileSync=k;function k(A){const R=(0,y.randomPath)((0,s.tmpdir)());try{return(0,i.writeFileSync)(R,""),A&&console.log(`Marker file for --wait created: ${R}`),R}catch(S){A&&console.error(`Failed to create marker file for --wait: ${S}`);return}}}),define(le[175],ue([0,1,12,9]),function(j,e,i,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=y;function y(A,R,S,c){try{k(A,R,S,c)}catch(m){A.error(m?.message??m)}return R}function k(A,R,S,c){const m=(u,p,v)=>{const f=u[p];if((0,i.isString)(f)){const h=f,E=h.length;if(E>1&&h[0]==="%"&&h[E-1]==="%"){const b=h.substr(1,E-2);let g=S[b];g===void 0&&c&&(g=c[b]);const I=typeof g=="string"?g:g?.message,P=c?.[b],r=typeof P=="string"?P:P?.message;if(!I){r||A.warn(`[${R.name}]: ${(0,s.localize)(1814,null,b)}`);return}if(v&&(p==="title"||p==="category")&&r&&r!==I){const a={value:I,original:r};u[p]=a}else u[p]=I}}else if((0,i.isObject)(f))for(const h in f)f.hasOwnProperty(h)&&(h==="commands"?m(f,h,!0):m(f,h,v));else if(Array.isArray(f))for(let h=0;h<f.length;h++)m(f,h,v)};for(const u in R)R.hasOwnProperty(u)&&m(R,u)}}),define(le[176],ue([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0;const i={activeComment:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.activeComment.d.ts"},aiRelatedInformation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts"},aiTextSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiTextSearchProvider.d.ts"},aiTextSearchProviderNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiTextSearchProviderNew.d.ts"},attributableCoverage:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.attributableCoverage.d.ts"},authLearnMore:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authLearnMore.d.ts"},authSession:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts"},canonicalUriProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts"},chatParticipantAdditions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantAdditions.d.ts"},chatParticipantPrivate:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantPrivate.d.ts",version:2},chatProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts"},chatTab:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts"},chatVariableResolver:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariableResolver.d.ts"},codeActionAI:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts"},codeActionRanges:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionRanges.d.ts"},codiconDecoration:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts"},commentReactor:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReactor.d.ts"},commentReveal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReveal.d.ts"},commentThreadApplicability:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentThreadApplicability.d.ts"},commentingRangeHint:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentingRangeHint.d.ts"},commentsDraftState:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts"},contribAccessibilityHelpContent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribAccessibilityHelpContent.d.ts"},contribCommentEditorActionsMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts"},contribCommentPeekContext:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts"},contribCommentThreadAdditionalMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts"},contribCommentsViewThreadMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentsViewThreadMenus.d.ts"},contribDebugCreateConfiguration:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribDebugCreateConfiguration.d.ts"},contribDiffEditorGutterToolBarMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribDiffEditorGutterToolBarMenus.d.ts"},contribEditSessions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts"},contribEditorContentMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts"},contribIssueReporter:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribIssueReporter.d.ts"},contribLabelFormatterWorkspaceTooltip:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts"},contribMenuBarHome:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts"},contribMergeEditorMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts"},contribMultiDiffEditorMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMultiDiffEditorMenus.d.ts"},contribNotebookStaticPreloads:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts"},contribRemoteHelp:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts"},contribShareMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts"},contribSourceControlHistoryItemChangesMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemChangesMenu.d.ts"},contribSourceControlHistoryItemGroupMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemGroupMenu.d.ts"},contribSourceControlHistoryItemMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemMenu.d.ts"},contribSourceControlHistoryTitleMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryTitleMenu.d.ts"},contribSourceControlInputBoxMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts"},contribSourceControlTitleMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlTitleMenu.d.ts"},contribStatusBarItems:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts"},contribViewContainerTitle:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewContainerTitle.d.ts"},contribViewsRemote:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts"},contribViewsWelcome:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts"},createFileSystemWatcher:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts"},customEditorMove:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts"},debugVisualization:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugVisualization.d.ts"},defaultChatParticipant:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatParticipant.d.ts"},diffCommand:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts"},diffContentOptions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts"},documentFiltersExclusive:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts"},documentPaste:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts"},editSessionIdentityProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts"},editorHoverVerbosityLevel:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorHoverVerbosityLevel.d.ts"},editorInsets:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts"},embeddings:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.embeddings.d.ts"},extensionRuntime:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts"},extensionsAny:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts"},externalUriOpener:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts"},fileComments:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts"},fileSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts"},fileSearchProviderNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProviderNew.d.ts"},findFiles2:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2.d.ts"},findFiles2New:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2New.d.ts"},findTextInFiles:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts"},findTextInFilesNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFilesNew.d.ts"},fsChunks:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts"},idToken:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts"},inlineCompletionsAdditions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts"},inlineEdit:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineEdit.d.ts"},interactive:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts"},interactiveWindow:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts"},ipc:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts"},languageModelSystem:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageModelSystem.d.ts"},languageStatusText:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts"},lmTools:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.lmTools.d.ts",version:6},mappedEditsProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts"},multiDocumentHighlightProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.multiDocumentHighlightProvider.d.ts"},newSymbolNamesProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.newSymbolNamesProvider.d.ts"},notebookCellExecution:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecution.d.ts"},notebookCellExecutionState:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts"},notebookControllerAffinityHidden:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts"},notebookDeprecated:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts"},notebookExecution:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts"},notebookKernelSource:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts"},notebookLiveShare:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts"},notebookMessaging:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts"},notebookMime:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts"},notebookReplDocument:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookReplDocument.d.ts"},notebookVariableProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts"},portsAttributes:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts"},profileContentHandlers:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts"},quickDiffProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts"},quickInputButtonLocation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickInputButtonLocation.d.ts"},quickPickItemTooltip:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts"},quickPickSortByLabel:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts"},resolvers:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts"},scmActionButton:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts"},scmHistoryProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts"},scmMultiDiffEditor:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmMultiDiffEditor.d.ts"},scmSelectedProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts"},scmTextDocument:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts"},scmValidation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts"},shareProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts"},showLocal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts"},speech:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts"},tabInputMultiDiff:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputMultiDiff.d.ts"},tabInputTextMerge:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts"},taskPresentationGroup:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts"},telemetry:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts"},terminalDataWriteEvent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts"},terminalDimensions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts"},terminalExecuteCommandEvent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts"},terminalQuickFixProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts"},terminalSelection:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts"},testObserver:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts"},testRelatedCode:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testRelatedCode.d.ts"},textSearchCompleteNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchCompleteNew.d.ts"},textSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts"},textSearchProviderNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProviderNew.d.ts"},timeline:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts"},tokenInformation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts"},treeViewActiveItem:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts"},treeViewMarkdownMessage:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts"},treeViewReveal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts"},tunnelFactory:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts"},tunnels:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts"},workspaceTrust:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"}};e.allApiProposals=Object.freeze(i)}),define(le[84],ue([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class i{constructor(y,k=[],A=!1){this.ctor=y,this.staticArguments=k,this.supportsDelayedInstantiation=A}}e.SyncDescriptor=i}),define(le[177],ue([0,1,84]),function(j,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.registerSingleton=k,e.getSingletonServiceDescriptors=A;const s=[];var y;(function(R){R[R.Eager=0]="Eager",R[R.Delayed=1]="Delayed"})(y||(e.InstantiationType=y={}));function k(R,S,c){S instanceof i.SyncDescriptor||(S=new i.SyncDescriptor(S,[],!!c)),s.push([R,S])}function A(){return s}}),define(le[178],ue([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class i{constructor(k,A){this.key=k,this.data=A,this.incoming=new Map,this.outgoing=new Map}}e.Node=i;class s{constructor(k){this._hashFn=k,this._nodes=new Map}roots(){const k=[];for(const A of this._nodes.values())A.outgoing.size===0&&k.push(A);return k}insertEdge(k,A){const R=this.lookupOrInsertNode(k),S=this.lookupOrInsertNode(A);R.outgoing.set(S.key,S),S.incoming.set(R.key,R)}removeNode(k){const A=this._hashFn(k);this._nodes.delete(A);for(const R of this._nodes.values())R.outgoing.delete(A),R.incoming.delete(A)}lookupOrInsertNode(k){const A=this._hashFn(k);let R=this._nodes.get(A);return R||(R=new i(A,k),this._nodes.set(A,R)),R}lookup(k){return this._nodes.get(this._hashFn(k))}isEmpty(){return this._nodes.size===0}toString(){const k=[];for(const[A,R]of this._nodes)k.push(`${A}
	(-> incoming)[${[...R.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...R.outgoing.keys()].join(",")}]
`);return k.join(`
`)}findCycleSlow(){for(const[k,A]of this._nodes){const R=new Set([k]),S=this._findCycle(A,R);if(S)return S}}_findCycle(k,A){for(const[R,S]of k.outgoing){if(A.has(R))return[...A,R].join(" -> ");A.add(R);const c=this._findCycle(S,A);if(c)return c;A.delete(R)}}}e.Graph=s}),define(le[6],ue([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IInstantiationService=e._util=void 0,e.createDecorator=y,e.refineServiceDecorator=k;var i;(function(A){A.serviceIds=new Map,A.DI_TARGET="$di$target",A.DI_DEPENDENCIES="$di$dependencies";function R(S){return S[A.DI_DEPENDENCIES]||[]}A.getServiceDependencies=R})(i||(e._util=i={})),e.IInstantiationService=y("instantiationService");function s(A,R,S){R[i.DI_TARGET]===R?R[i.DI_DEPENDENCIES].push({id:A,index:S}):(R[i.DI_DEPENDENCIES]=[{id:A,index:S}],R[i.DI_TARGET]=R)}function y(A){if(i.serviceIds.has(A))return i.serviceIds.get(A);const R=function(S,c,m){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");s(R,S,m)};return R.toString=()=>A,i.serviceIds.set(A,R),R}function k(A){return A}}),define(le[85],ue([0,1,6]),function(j,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IAuxiliaryWindowsMainService=void 0,e.IAuxiliaryWindowsMainService=(0,i.createDecorator)("auxiliaryWindowsMainService")}),define(le[70],ue([0,1,6]),function(j,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBackupMainService=void 0,e.IBackupMainService=(0,i.createDecorator)("backupMainService")}),define(le[16],ue([0,1,12,7,6]),function(j,e,i,s,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.IConfigurationService=void 0,e.isConfigurationOverrides=k,e.isConfigurationUpdateOverrides=A,e.ConfigurationTargetToString=S,e.isConfigured=c,e.toValuesTree=m,e.addToValueTree=u,e.removeFromValueTree=p,e.getConfigurationValue=f,e.merge=h,e.getLanguageTagSettingPlainKey=E,i=Re(i),e.IConfigurationService=(0,y.createDecorator)("configurationService");function k(b){return b&&typeof b=="object"&&(!b.overrideIdentifier||typeof b.overrideIdentifier=="string")&&(!b.resource||b.resource instanceof s.URI)}function A(b){return b&&typeof b=="object"&&(!b.overrideIdentifiers||Array.isArray(b.overrideIdentifiers))&&!b.overrideIdentifier&&(!b.resource||b.resource instanceof s.URI)}var R;(function(b){b[b.APPLICATION=1]="APPLICATION",b[b.USER=2]="USER",b[b.USER_LOCAL=3]="USER_LOCAL",b[b.USER_REMOTE=4]="USER_REMOTE",b[b.WORKSPACE=5]="WORKSPACE",b[b.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",b[b.DEFAULT=7]="DEFAULT",b[b.MEMORY=8]="MEMORY"})(R||(e.ConfigurationTarget=R={}));function S(b){switch(b){case R.APPLICATION:return"APPLICATION";case R.USER:return"USER";case R.USER_LOCAL:return"USER_LOCAL";case R.USER_REMOTE:return"USER_REMOTE";case R.WORKSPACE:return"WORKSPACE";case R.WORKSPACE_FOLDER:return"WORKSPACE_FOLDER";case R.DEFAULT:return"DEFAULT";case R.MEMORY:return"MEMORY"}}function c(b){return b.applicationValue!==void 0||b.userValue!==void 0||b.userLocalValue!==void 0||b.userRemoteValue!==void 0||b.workspaceValue!==void 0||b.workspaceFolderValue!==void 0}function m(b,g){const I=Object.create(null);for(const P in b)u(I,P,b[P],g);return I}function u(b,g,I,P){const r=g.split("."),a=r.pop();let t=b;for(let o=0;o<r.length;o++){const n=r[o];let l=t[n];switch(typeof l){case"undefined":l=t[n]=Object.create(null);break;case"object":if(l===null){P(`Ignoring ${g} as ${r.slice(0,o+1).join(".")} is null`);return}break;default:P(`Ignoring ${g} as ${r.slice(0,o+1).join(".")} is ${JSON.stringify(l)}`);return}t=l}if(typeof t=="object"&&t!==null)try{t[a]=I}catch{P(`Ignoring ${g} as ${r.join(".")} is ${JSON.stringify(t)}`)}else P(`Ignoring ${g} as ${r.join(".")} is ${JSON.stringify(t)}`)}function p(b,g){const I=g.split(".");v(b,I)}function v(b,g){const I=g.shift();if(g.length===0){delete b[I];return}if(Object.keys(b).indexOf(I)!==-1){const P=b[I];typeof P=="object"&&!Array.isArray(P)&&(v(P,g),Object.keys(P).length===0&&delete b[I])}}function f(b,g,I){function P(t,o){let n=t;for(const l of o){if(typeof n!="object"||n===null)return;n=n[l]}return n}const r=g.split("."),a=P(b,r);return typeof a>"u"?I:a}function h(b,g,I){Object.keys(g).forEach(P=>{P!=="__proto__"&&(P in b?i.isObject(b[P])&&i.isObject(g[P])?h(b[P],g[P],I):I&&(b[P]=g[P]):b[P]=g[P])})}function E(b){return b.replace(/[\[\]]/g,"")}}),define(le[125],ue([0,1,39,3,25,170,6,9,15]),function(j,e,i,s,y,k,A,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.ContextKeyExpr=e.Parser=e.ContextKeyExprType=void 0,e.setConstant=m,e.validateWhenClauses=o,e.expressionsAreEqualWithConstantSubstitution=n,e.implies=H;const c=new Map;c.set("false",!1),c.set("true",!0),c.set("isMac",s.isMacintosh),c.set("isLinux",s.isLinux),c.set("isWindows",s.isWindows),c.set("isWeb",s.isWeb),c.set("isMacNative",s.isMacintosh&&!s.isWeb),c.set("isEdge",s.isEdge),c.set("isFirefox",s.isFirefox),c.set("isChrome",s.isChrome),c.set("isSafari",s.isSafari);function m(te,O){if(c.get(te)!==void 0)throw(0,S.illegalArgument)("contextkey.setConstant(k, v) invoked with already set constant `k`");c.set(te,O)}const u=Object.prototype.hasOwnProperty;var p;(function(te){te[te.False=0]="False",te[te.True=1]="True",te[te.Defined=2]="Defined",te[te.Not=3]="Not",te[te.Equals=4]="Equals",te[te.NotEquals=5]="NotEquals",te[te.And=6]="And",te[te.Regex=7]="Regex",te[te.NotRegex=8]="NotRegex",te[te.Or=9]="Or",te[te.In=10]="In",te[te.NotIn=11]="NotIn",te[te.Greater=12]="Greater",te[te.GreaterEquals=13]="GreaterEquals",te[te.Smaller=14]="Smaller",te[te.SmallerEquals=15]="SmallerEquals"})(p||(e.ContextKeyExprType=p={}));const v={regexParsingWithErrorRecovery:!0},f=(0,R.localize)(1673,null),h=(0,R.localize)(1674,null),E=(0,R.localize)(1675,null),b=(0,R.localize)(1676,null),g=(0,R.localize)(1677,null),I=(0,R.localize)(1678,null),P=(0,R.localize)(1679,null),r=(0,R.localize)(1680,null);class a{static{this._parseError=new Error}get lexingErrors(){return this._scanner.errors}get parsingErrors(){return this._parsingErrors}constructor(O=v){this._config=O,this._scanner=new k.Scanner,this._tokens=[],this._current=0,this._parsingErrors=[],this._flagsGYRe=/g|y/g}parse(O){if(O===""){this._parsingErrors.push({message:f,offset:0,lexeme:"",additionalInfo:h});return}this._tokens=this._scanner.reset(O).scan(),this._current=0,this._parsingErrors=[];try{const X=this._expr();if(!this._isAtEnd()){const B=this._peek(),F=B.type===k.TokenType.Str?I:void 0;throw this._parsingErrors.push({message:g,offset:B.offset,lexeme:k.Scanner.getLexeme(B),additionalInfo:F}),a._parseError}return X}catch(X){if(X!==a._parseError)throw X;return}}_expr(){return this._or()}_or(){const O=[this._and()];for(;this._matchOne(k.TokenType.Or);){const X=this._and();O.push(X)}return O.length===1?O[0]:t.or(...O)}_and(){const O=[this._term()];for(;this._matchOne(k.TokenType.And);){const X=this._term();O.push(X)}return O.length===1?O[0]:t.and(...O)}_term(){if(this._matchOne(k.TokenType.Neg)){const O=this._peek();switch(O.type){case k.TokenType.True:return this._advance(),d.INSTANCE;case k.TokenType.False:return this._advance(),D.INSTANCE;case k.TokenType.LParen:{this._advance();const X=this._expr();return this._consume(k.TokenType.RParen,b),X?.negate()}case k.TokenType.Str:return this._advance(),_.create(O.lexeme);default:throw this._errExpectedButGot("KEY | true | false | '(' expression ')'",O)}}return this._primary()}_primary(){const O=this._peek();switch(O.type){case k.TokenType.True:return this._advance(),t.true();case k.TokenType.False:return this._advance(),t.false();case k.TokenType.LParen:{this._advance();const X=this._expr();return this._consume(k.TokenType.RParen,b),X}case k.TokenType.Str:{const X=O.lexeme;if(this._advance(),this._matchOne(k.TokenType.RegexOp)){const F=this._peek();if(!this._config.regexParsingWithErrorRecovery){if(this._advance(),F.type!==k.TokenType.RegexStr)throw this._errExpectedButGot("REGEX",F);const J=F.lexeme,G=J.lastIndexOf("/"),$=G===J.length-1?void 0:this._removeFlagsGY(J.substring(G+1));let Z;try{Z=new RegExp(J.substring(1,G),$)}catch{throw this._errExpectedButGot("REGEX",F)}return ee.create(X,Z)}switch(F.type){case k.TokenType.RegexStr:case k.TokenType.Error:{const J=[F.lexeme];this._advance();let G=this._peek(),$=0;for(let ye=0;ye<F.lexeme.length;ye++)F.lexeme.charCodeAt(ye)===i.CharCode.OpenParen?$++:F.lexeme.charCodeAt(ye)===i.CharCode.CloseParen&&$--;for(;!this._isAtEnd()&&G.type!==k.TokenType.And&&G.type!==k.TokenType.Or;){switch(G.type){case k.TokenType.LParen:$++;break;case k.TokenType.RParen:$--;break;case k.TokenType.RegexStr:case k.TokenType.QuotedStr:for(let ye=0;ye<G.lexeme.length;ye++)G.lexeme.charCodeAt(ye)===i.CharCode.OpenParen?$++:F.lexeme.charCodeAt(ye)===i.CharCode.CloseParen&&$--}if($<0)break;J.push(k.Scanner.getLexeme(G)),this._advance(),G=this._peek()}const Z=J.join(""),ae=Z.lastIndexOf("/"),pe=ae===Z.length-1?void 0:this._removeFlagsGY(Z.substring(ae+1));let Se;try{Se=new RegExp(Z.substring(1,ae),pe)}catch{throw this._errExpectedButGot("REGEX",F)}return t.regex(X,Se)}case k.TokenType.QuotedStr:{const J=F.lexeme;this._advance();let G=null;if(!(0,y.isFalsyOrWhitespace)(J)){const $=J.indexOf("/"),Z=J.lastIndexOf("/");if($!==Z&&$>=0){const ae=J.slice($+1,Z),pe=J[Z+1]==="i"?"i":"";try{G=new RegExp(ae,pe)}catch{throw this._errExpectedButGot("REGEX",F)}}}if(G===null)throw this._errExpectedButGot("REGEX",F);return ee.create(X,G)}default:throw this._errExpectedButGot("REGEX",this._peek())}}if(this._matchOne(k.TokenType.Not)){this._consume(k.TokenType.In,E);const F=this._value();return t.notIn(X,F)}switch(this._peek().type){case k.TokenType.Eq:{this._advance();const F=this._value();if(this._previous().type===k.TokenType.QuotedStr)return t.equals(X,F);switch(F){case"true":return t.has(X);case"false":return t.not(X);default:return t.equals(X,F)}}case k.TokenType.NotEq:{this._advance();const F=this._value();if(this._previous().type===k.TokenType.QuotedStr)return t.notEquals(X,F);switch(F){case"true":return t.not(X);case"false":return t.has(X);default:return t.notEquals(X,F)}}case k.TokenType.Lt:return this._advance(),fe.create(X,this._value());case k.TokenType.LtEq:return this._advance(),se.create(X,this._value());case k.TokenType.Gt:return this._advance(),z.create(X,this._value());case k.TokenType.GtEq:return this._advance(),Q.create(X,this._value());case k.TokenType.In:return this._advance(),t.in(X,this._value());default:return t.has(X)}}case k.TokenType.EOF:throw this._parsingErrors.push({message:P,offset:O.offset,lexeme:"",additionalInfo:r}),a._parseError;default:throw this._errExpectedButGot(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this._peek())}}_value(){const O=this._peek();switch(O.type){case k.TokenType.Str:case k.TokenType.QuotedStr:return this._advance(),O.lexeme;case k.TokenType.True:return this._advance(),"true";case k.TokenType.False:return this._advance(),"false";case k.TokenType.In:return this._advance(),"in";default:return""}}_removeFlagsGY(O){return O.replaceAll(this._flagsGYRe,"")}_previous(){return this._tokens[this._current-1]}_matchOne(O){return this._check(O)?(this._advance(),!0):!1}_advance(){return this._isAtEnd()||this._current++,this._previous()}_consume(O,X){if(this._check(O))return this._advance();throw this._errExpectedButGot(X,this._peek())}_errExpectedButGot(O,X,B){const F=(0,R.localize)(1681,null,O,k.Scanner.getLexeme(X)),J=X.offset,G=k.Scanner.getLexeme(X);return this._parsingErrors.push({message:F,offset:J,lexeme:G,additionalInfo:B}),a._parseError}_check(O){return this._peek().type===O}_peek(){return this._tokens[this._current]}_isAtEnd(){return this._peek().type===k.TokenType.EOF}}e.Parser=a;class t{static false(){return d.INSTANCE}static true(){return D.INSTANCE}static has(O){return w.create(O)}static equals(O,X){return M.create(O,X)}static notEquals(O,X){return L.create(O,X)}static regex(O,X){return ee.create(O,X)}static in(O,X){return T.create(O,X)}static notIn(O,X){return C.create(O,X)}static not(O){return _.create(O)}static and(...O){return N.create(O,null,!0)}static or(...O){return x.create(O,null,!0)}static greater(O,X){return z.create(O,X)}static greaterEquals(O,X){return Q.create(O,X)}static smaller(O,X){return fe.create(O,X)}static smallerEquals(O,X){return se.create(O,X)}static{this._parser=new a({regexParsingWithErrorRecovery:!1})}static deserialize(O){return O==null?void 0:this._parser.parse(O)}}e.ContextKeyExpr=t;function o(te){const O=new a({regexParsingWithErrorRecovery:!1});return te.map(X=>(O.parse(X),O.lexingErrors.length>0?O.lexingErrors.map(B=>({errorMessage:B.additionalInfo?(0,R.localize)(1682,null,B.additionalInfo):(0,R.localize)(1683,null),offset:B.offset,length:B.lexeme.length})):O.parsingErrors.length>0?O.parsingErrors.map(B=>({errorMessage:B.additionalInfo?`${B.message}. ${B.additionalInfo}`:B.message,offset:B.offset,length:B.lexeme.length})):[]))}function n(te,O){const X=te?te.substituteConstants():void 0,B=O?O.substituteConstants():void 0;return!X&&!B?!0:!X||!B?!1:X.equals(B)}function l(te,O){return te.cmp(O)}class d{static{this.INSTANCE=new d}constructor(){this.type=p.False}cmp(O){return this.type-O.type}equals(O){return O.type===this.type}substituteConstants(){return this}evaluate(O){return!1}serialize(){return"false"}keys(){return[]}map(O){return this}negate(){return D.INSTANCE}}e.ContextKeyFalseExpr=d;class D{static{this.INSTANCE=new D}constructor(){this.type=p.True}cmp(O){return this.type-O.type}equals(O){return O.type===this.type}substituteConstants(){return this}evaluate(O){return!0}serialize(){return"true"}keys(){return[]}map(O){return this}negate(){return d.INSTANCE}}e.ContextKeyTrueExpr=D;class w{static create(O,X=null){const B=c.get(O);return typeof B=="boolean"?B?D.INSTANCE:d.INSTANCE:new w(O,X)}constructor(O,X){this.key=O,this.negated=X,this.type=p.Defined}cmp(O){return O.type!==this.type?this.type-O.type:q(this.key,O.key)}equals(O){return O.type===this.type?this.key===O.key:!1}substituteConstants(){const O=c.get(this.key);return typeof O=="boolean"?O?D.INSTANCE:d.INSTANCE:this}evaluate(O){return!!O.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(O){return O.mapDefined(this.key)}negate(){return this.negated||(this.negated=_.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=w;class M{static create(O,X,B=null){if(typeof X=="boolean")return X?w.create(O,B):_.create(O,B);const F=c.get(O);return typeof F=="boolean"?X===(F?"true":"false")?D.INSTANCE:d.INSTANCE:new M(O,X,B)}constructor(O,X,B){this.key=O,this.value=X,this.negated=B,this.type=p.Equals}cmp(O){return O.type!==this.type?this.type-O.type:ie(this.key,this.value,O.key,O.value)}equals(O){return O.type===this.type?this.key===O.key&&this.value===O.value:!1}substituteConstants(){const O=c.get(this.key);if(typeof O=="boolean"){const X=O?"true":"false";return this.value===X?D.INSTANCE:d.INSTANCE}return this}evaluate(O){return O.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(O){return O.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=L.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=M;class T{static create(O,X){return new T(O,X)}constructor(O,X){this.key=O,this.valueKey=X,this.type=p.In,this.negated=null}cmp(O){return O.type!==this.type?this.type-O.type:ie(this.key,this.valueKey,O.key,O.valueKey)}equals(O){return O.type===this.type?this.key===O.key&&this.valueKey===O.valueKey:!1}substituteConstants(){return this}evaluate(O){const X=O.getValue(this.valueKey),B=O.getValue(this.key);return Array.isArray(X)?X.includes(B):typeof B=="string"&&typeof X=="object"&&X!==null?u.call(X,B):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(O){return O.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=C.create(this.key,this.valueKey)),this.negated}}e.ContextKeyInExpr=T;class C{static create(O,X){return new C(O,X)}constructor(O,X){this.key=O,this.valueKey=X,this.type=p.NotIn,this._negated=T.create(O,X)}cmp(O){return O.type!==this.type?this.type-O.type:this._negated.cmp(O._negated)}equals(O){return O.type===this.type?this._negated.equals(O._negated):!1}substituteConstants(){return this}evaluate(O){return!this._negated.evaluate(O)}serialize(){return`${this.key} not in '${this.valueKey}'`}keys(){return this._negated.keys()}map(O){return O.mapNotIn(this.key,this.valueKey)}negate(){return this._negated}}e.ContextKeyNotInExpr=C;class L{static create(O,X,B=null){if(typeof X=="boolean")return X?_.create(O,B):w.create(O,B);const F=c.get(O);return typeof F=="boolean"?X===(F?"true":"false")?d.INSTANCE:D.INSTANCE:new L(O,X,B)}constructor(O,X,B){this.key=O,this.value=X,this.negated=B,this.type=p.NotEquals}cmp(O){return O.type!==this.type?this.type-O.type:ie(this.key,this.value,O.key,O.value)}equals(O){return O.type===this.type?this.key===O.key&&this.value===O.value:!1}substituteConstants(){const O=c.get(this.key);if(typeof O=="boolean"){const X=O?"true":"false";return this.value===X?d.INSTANCE:D.INSTANCE}return this}evaluate(O){return O.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(O){return O.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=M.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=L;class _{static create(O,X=null){const B=c.get(O);return typeof B=="boolean"?B?d.INSTANCE:D.INSTANCE:new _(O,X)}constructor(O,X){this.key=O,this.negated=X,this.type=p.Not}cmp(O){return O.type!==this.type?this.type-O.type:q(this.key,O.key)}equals(O){return O.type===this.type?this.key===O.key:!1}substituteConstants(){const O=c.get(this.key);return typeof O=="boolean"?O?d.INSTANCE:D.INSTANCE:this}evaluate(O){return!O.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(O){return O.mapNot(this.key)}negate(){return this.negated||(this.negated=w.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=_;function V(te,O){if(typeof te=="string"){const X=parseFloat(te);isNaN(X)||(te=X)}return typeof te=="string"||typeof te=="number"?O(te):d.INSTANCE}class z{static create(O,X,B=null){return V(X,F=>new z(O,F,B))}constructor(O,X,B){this.key=O,this.value=X,this.negated=B,this.type=p.Greater}cmp(O){return O.type!==this.type?this.type-O.type:ie(this.key,this.value,O.key,O.value)}equals(O){return O.type===this.type?this.key===O.key&&this.value===O.value:!1}substituteConstants(){return this}evaluate(O){return typeof this.value=="string"?!1:parseFloat(O.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(O){return O.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=se.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=z;class Q{static create(O,X,B=null){return V(X,F=>new Q(O,F,B))}constructor(O,X,B){this.key=O,this.value=X,this.negated=B,this.type=p.GreaterEquals}cmp(O){return O.type!==this.type?this.type-O.type:ie(this.key,this.value,O.key,O.value)}equals(O){return O.type===this.type?this.key===O.key&&this.value===O.value:!1}substituteConstants(){return this}evaluate(O){return typeof this.value=="string"?!1:parseFloat(O.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(O){return O.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=fe.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=Q;class fe{static create(O,X,B=null){return V(X,F=>new fe(O,F,B))}constructor(O,X,B){this.key=O,this.value=X,this.negated=B,this.type=p.Smaller}cmp(O){return O.type!==this.type?this.type-O.type:ie(this.key,this.value,O.key,O.value)}equals(O){return O.type===this.type?this.key===O.key&&this.value===O.value:!1}substituteConstants(){return this}evaluate(O){return typeof this.value=="string"?!1:parseFloat(O.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(O){return O.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=Q.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=fe;class se{static create(O,X,B=null){return V(X,F=>new se(O,F,B))}constructor(O,X,B){this.key=O,this.value=X,this.negated=B,this.type=p.SmallerEquals}cmp(O){return O.type!==this.type?this.type-O.type:ie(this.key,this.value,O.key,O.value)}equals(O){return O.type===this.type?this.key===O.key&&this.value===O.value:!1}substituteConstants(){return this}evaluate(O){return typeof this.value=="string"?!1:parseFloat(O.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(O){return O.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=z.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=se;class ee{static create(O,X){return new ee(O,X)}constructor(O,X){this.key=O,this.regexp=X,this.type=p.Regex,this.negated=null}cmp(O){if(O.type!==this.type)return this.type-O.type;if(this.key<O.key)return-1;if(this.key>O.key)return 1;const X=this.regexp?this.regexp.source:"",B=O.regexp?O.regexp.source:"";return X<B?-1:X>B?1:0}equals(O){if(O.type===this.type){const X=this.regexp?this.regexp.source:"",B=O.regexp?O.regexp.source:"";return this.key===O.key&&X===B}return!1}substituteConstants(){return this}evaluate(O){const X=O.getValue(this.key);return this.regexp?this.regexp.test(X):!1}serialize(){const O=this.regexp?`/${this.regexp.source}/${this.regexp.flags}`:"/invalid/";return`${this.key} =~ ${O}`}keys(){return[this.key]}map(O){return O.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=U.create(this)),this.negated}}e.ContextKeyRegexExpr=ee;class U{static create(O){return new U(O)}constructor(O){this._actual=O,this.type=p.NotRegex}cmp(O){return O.type!==this.type?this.type-O.type:this._actual.cmp(O._actual)}equals(O){return O.type===this.type?this._actual.equals(O._actual):!1}substituteConstants(){return this}evaluate(O){return!this._actual.evaluate(O)}serialize(){return`!(${this._actual.serialize()})`}keys(){return this._actual.keys()}map(O){return new U(this._actual.map(O))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=U;function K(te){let O=null;for(let X=0,B=te.length;X<B;X++){const F=te[X].substituteConstants();if(te[X]!==F&&O===null){O=[];for(let J=0;J<X;J++)O[J]=te[J]}O!==null&&(O[X]=F)}return O===null?te:O}class N{static create(O,X,B){return N._normalizeArr(O,X,B)}constructor(O,X){this.expr=O,this.negated=X,this.type=p.And}cmp(O){if(O.type!==this.type)return this.type-O.type;if(this.expr.length<O.expr.length)return-1;if(this.expr.length>O.expr.length)return 1;for(let X=0,B=this.expr.length;X<B;X++){const F=l(this.expr[X],O.expr[X]);if(F!==0)return F}return 0}equals(O){if(O.type===this.type){if(this.expr.length!==O.expr.length)return!1;for(let X=0,B=this.expr.length;X<B;X++)if(!this.expr[X].equals(O.expr[X]))return!1;return!0}return!1}substituteConstants(){const O=K(this.expr);return O===this.expr?this:N.create(O,this.negated,!1)}evaluate(O){for(let X=0,B=this.expr.length;X<B;X++)if(!this.expr[X].evaluate(O))return!1;return!0}static _normalizeArr(O,X,B){const F=[];let J=!1;for(const G of O)if(G){if(G.type===p.True){J=!0;continue}if(G.type===p.False)return d.INSTANCE;if(G.type===p.And){F.push(...G.expr);continue}F.push(G)}if(F.length===0&&J)return D.INSTANCE;if(F.length!==0){if(F.length===1)return F[0];F.sort(l);for(let G=1;G<F.length;G++)F[G-1].equals(F[G])&&(F.splice(G,1),G--);if(F.length===1)return F[0];for(;F.length>1;){const G=F[F.length-1];if(G.type!==p.Or)break;F.pop();const $=F.pop(),Z=F.length===0,ae=x.create(G.expr.map(pe=>N.create([pe,$],null,B)),null,Z);ae&&(F.push(ae),F.sort(l))}if(F.length===1)return F[0];if(B){for(let G=0;G<F.length;G++)for(let $=G+1;$<F.length;$++)if(F[G].negate().equals(F[$]))return d.INSTANCE;if(F.length===1)return F[0]}return new N(F,X)}}serialize(){return this.expr.map(O=>O.serialize()).join(" && ")}keys(){const O=[];for(const X of this.expr)O.push(...X.keys());return O}map(O){return new N(this.expr.map(X=>X.map(O)),null)}negate(){if(!this.negated){const O=[];for(const X of this.expr)O.push(X.negate());this.negated=x.create(O,this,!0)}return this.negated}}e.ContextKeyAndExpr=N;class x{static create(O,X,B){return x._normalizeArr(O,X,B)}constructor(O,X){this.expr=O,this.negated=X,this.type=p.Or}cmp(O){if(O.type!==this.type)return this.type-O.type;if(this.expr.length<O.expr.length)return-1;if(this.expr.length>O.expr.length)return 1;for(let X=0,B=this.expr.length;X<B;X++){const F=l(this.expr[X],O.expr[X]);if(F!==0)return F}return 0}equals(O){if(O.type===this.type){if(this.expr.length!==O.expr.length)return!1;for(let X=0,B=this.expr.length;X<B;X++)if(!this.expr[X].equals(O.expr[X]))return!1;return!0}return!1}substituteConstants(){const O=K(this.expr);return O===this.expr?this:x.create(O,this.negated,!1)}evaluate(O){for(let X=0,B=this.expr.length;X<B;X++)if(this.expr[X].evaluate(O))return!0;return!1}static _normalizeArr(O,X,B){let F=[],J=!1;if(O){for(let G=0,$=O.length;G<$;G++){const Z=O[G];if(Z){if(Z.type===p.False){J=!0;continue}if(Z.type===p.True)return D.INSTANCE;if(Z.type===p.Or){F=F.concat(Z.expr);continue}F.push(Z)}}if(F.length===0&&J)return d.INSTANCE;F.sort(l)}if(F.length!==0){if(F.length===1)return F[0];for(let G=1;G<F.length;G++)F[G-1].equals(F[G])&&(F.splice(G,1),G--);if(F.length===1)return F[0];if(B){for(let G=0;G<F.length;G++)for(let $=G+1;$<F.length;$++)if(F[G].negate().equals(F[$]))return D.INSTANCE;if(F.length===1)return F[0]}return new x(F,X)}}serialize(){return this.expr.map(O=>O.serialize()).join(" || ")}keys(){const O=[];for(const X of this.expr)O.push(...X.keys());return O}map(O){return new x(this.expr.map(X=>X.map(O)),null)}negate(){if(!this.negated){const O=[];for(const X of this.expr)O.push(X.negate());for(;O.length>1;){const X=O.shift(),B=O.shift(),F=[];for(const J of oe(X))for(const G of oe(B))F.push(N.create([J,G],null,!1));O.unshift(x.create(F,null,!1))}this.negated=x.create(O,this,!0)}return this.negated}}e.ContextKeyOrExpr=x;class W extends w{static{this._info=[]}static all(){return W._info.values()}constructor(O,X,B){super(O,null),this._defaultValue=X,typeof B=="object"?W._info.push({...B,key:O}):B!==!0&&W._info.push({key:O,description:B,type:X!=null?typeof X:void 0})}bindTo(O){return O.createKey(this.key,this._defaultValue)}getValue(O){return O.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(O){return M.create(this.key,O)}notEqualsTo(O){return L.create(this.key,O)}}e.RawContextKey=W,e.IContextKeyService=(0,A.createDecorator)("contextKeyService");function q(te,O){return te<O?-1:te>O?1:0}function ie(te,O,X,B){return te<X?-1:te>X?1:O<B?-1:O>B?1:0}function H(te,O){if(te.type===p.False||O.type===p.True)return!0;if(te.type===p.Or)return O.type===p.Or?ce(te.expr,O.expr):!1;if(O.type===p.Or){for(const X of O.expr)if(H(te,X))return!0;return!1}if(te.type===p.And){if(O.type===p.And)return ce(O.expr,te.expr);for(const X of te.expr)if(H(X,O))return!0;return!1}return te.equals(O)}function ce(te,O){let X=0,B=0;for(;X<te.length&&B<O.length;){const F=te[X].cmp(O[B]);if(F<0)return!1;F===0&&X++,B++}return X===te.length}function oe(te){return te.type===p.Or?te.expr:[te]}}),define(le[99],ue([0,1,6]),function(j,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullDiagnosticsService=e.IDiagnosticsService=e.ID=void 0,e.isRemoteDiagnosticError=s,e.ID="diagnosticsService",e.IDiagnosticsService=(0,i.createDecorator)(e.ID);function s(k){return!!k.hostName&&!!k.errorMessage}class y{async getPerformanceInfo(A,R){return{}}async getSystemInfo(A,R){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(A,R){return""}async getWorkspaceFileExtensions(A){return{extensions:[]}}async reportWorkspaceStats(A){}}e.NullDiagnosticsService=y});var je=this&&this.__importDefault||function(j){return j&&j.__esModule?j:{default:j}};define(le[126],ue([0,1,18,81,9,6,49,3,37]),function(j,e,i,s,y,k,A,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfirmResult=e.IFileDialogService=e.AbstractDialogHandler=e.IDialogService=void 0,e.getFileNamesMessage=v,e.massageMessageBoxOptions=f,s=je(s),e.IDialogService=(0,k.createDecorator)("dialogService");var c;(function(h){h[h.Confirmation=1]="Confirmation",h[h.Prompt=2]="Prompt",h[h.Input=3]="Input"})(c||(c={}));class m{getConfirmationButtons(E){return this.getButtons(E,c.Confirmation)}getPromptButtons(E){return this.getButtons(E,c.Prompt)}getInputButtons(E){return this.getButtons(E,c.Input)}getButtons(E,b){const g=[];switch(b){case c.Confirmation:{const I=E;I.primaryButton?g.push(I.primaryButton):g.push((0,y.localize)(1698,null)),I.cancelButton?g.push(I.cancelButton):g.push((0,y.localize)(1699,null));break}case c.Prompt:{const I=E;Array.isArray(I.buttons)&&I.buttons.length>0&&g.push(...I.buttons.map(P=>P.label)),I.cancelButton&&(I.cancelButton===!0?g.push((0,y.localize)(1700,null)):typeof I.cancelButton=="string"?g.push(I.cancelButton):I.cancelButton.label?g.push(I.cancelButton.label):g.push((0,y.localize)(1701,null))),g.length===0&&g.push((0,y.localize)(1702,null));break}case c.Input:{const I=E;I.primaryButton?g.push(I.primaryButton):g.push((0,y.localize)(1703,null)),I.cancelButton?g.push(I.cancelButton):g.push((0,y.localize)(1704,null));break}}return g}getDialogType(E){if(typeof E=="string")return E;if(typeof E=="number")return E===s.default.Info?"info":E===s.default.Error?"error":E===s.default.Warning?"warning":"none"}getPromptResult(E,b,g){const I=[...E.buttons??[]];E.cancelButton&&typeof E.cancelButton!="string"&&typeof E.cancelButton!="boolean"&&I.push(E.cancelButton);let P=I[b]?.run({checkboxChecked:g});return P instanceof Promise||(P=Promise.resolve(P)),{result:P,checkboxChecked:g}}}e.AbstractDialogHandler=m,e.IFileDialogService=(0,k.createDecorator)("fileDialogService");var u;(function(h){h[h.SAVE=0]="SAVE",h[h.DONT_SAVE=1]="DONT_SAVE",h[h.CANCEL=2]="CANCEL"})(u||(e.ConfirmResult=u={}));const p=10;function v(h){const E=[];return E.push(...h.slice(0,p).map(b=>typeof b=="string"?b:(0,i.basename)(b))),h.length>p&&(h.length-p===1?E.push((0,y.localize)(1705,null)):E.push((0,y.localize)(1706,null,h.length-p))),E.push(""),E.join(`
`)}function f(h,E){const b=(0,S.deepClone)(h);let g=(b.buttons??[]).map(a=>(0,A.mnemonicButtonLabel)(a)),I=(h.buttons||[]).map((a,t)=>t),P=0,r=b.cancelId??g.length-1;if(g.length>1){const a=typeof r=="number"?g[r]:void 0;if(R.isLinux||R.isMacintosh){if(typeof a=="string"&&g.length>1&&r!==1){g.splice(r,1),g.splice(1,0,a);const t=I[r];I.splice(r,1),I.splice(1,0,t),r=1}R.isLinux&&g.length>1&&(g=g.reverse(),I=I.reverse(),P=g.length-1,typeof a=="string"&&(r=P-1))}else if(R.isWindows&&typeof a=="string"&&g.length>1&&r!==g.length-1){g.splice(r,1),g.push(a);const t=I[r];I.splice(r,1),I.push(t),r=g.length-1}}return b.buttons=g,b.defaultId=P,b.cancelId=r,b.noLink=!0,b.title=b.title||E.nameLong,{options:b,buttonIndeces:I}}}),define(le[100],ue([0,1,6]),function(j,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KnownStorageProvider=e.PasswordStoreCLIOption=e.IEncryptionMainService=e.IEncryptionService=void 0,e.isKwallet=k,e.isGnome=A,e.IEncryptionService=(0,i.createDecorator)("encryptionService"),e.IEncryptionMainService=(0,i.createDecorator)("encryptionMainService");var s;(function(R){R.kwallet="kwallet",R.kwallet5="kwallet5",R.gnomeLibsecret="gnome-libsecret",R.basic="basic"})(s||(e.PasswordStoreCLIOption=s={}));var y;(function(R){R.unknown="unknown",R.basicText="basic_text",R.gnomeAny="gnome_any",R.gnomeLibsecret="gnome_libsecret",R.gnomeKeyring="gnome_keyring",R.kwallet="kwallet",R.kwallet5="kwallet5",R.kwallet6="kwallet6",R.dplib="dpapi",R.keychainAccess="keychain_access"})(y||(e.KnownStorageProvider=y={}));function k(R){return R===y.kwallet||R===y.kwallet5||R===y.kwallet6}function A(R){return R===y.gnomeAny||R===y.gnomeLibsecret||R===y.gnomeKeyring}}),define(le[36],ue([0,1,6]),function(j,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,i.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,i.refineServiceDecorator)(e.IEnvironmentService)}),define(le[179],ue([0,1,6]),function(j,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcExtensionHostStarterChannelName=e.IExtensionHostStarter=void 0,e.IExtensionHostStarter=(0,i.createDecorator)("extensionHostStarter"),e.ipcExtensionHostStarterChannelName="extensionHostStarter"}),define(le[180],ue([0,1,6]),function(j,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,i.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app"}),define(le[181],ue([0,1,6]),function(j,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=void 0,e.IExternalTerminalMainService=(0,i.createDecorator)("externalTerminal")}),define(le[182],ue([0,1,44,54,11,10,3,82,23,96,9,180]),function(j,e,i,s,y,k,A,R,S,c,m,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0,i=Re(i),k=Re(k),A=Re(A),S=Re(S),c=Re(c),m=Re(m);const p=m.localize(1851,null);class v{async getDefaultTerminalForPlatforms(){return{windows:f.getDefaultTerminalWindows(),linux:await E.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class f extends v{static{this.CMD="cmd.exe"}openTerminal(r,a){return this.spawnTerminal(i,r,c.getWindowsShell(),a)}spawnTerminal(r,a,t,o){const n=a.windowsExec||f.getDefaultTerminalWindows();o&&o[1]===":"&&(o=o[0].toUpperCase()+o.substr(1));const l=k.basename(n,".exe").toLowerCase();if(l==="cmder")return r.spawn(n,o?[o]:void 0),Promise.resolve(void 0);const d=["/c","start","/wait"];return n.indexOf(" ")>=0&&d.push(n),d.push(n),l==="wt"&&d.push("-d ."),new Promise((D,w)=>{const M=b(process),T=r.spawn(t,d,{cwd:o,env:M,detached:!0});T.on("error",w),T.on("exit",()=>D())})}async runInTerminal(r,a,t,o,n){const l="windowsExec"in n&&n.windowsExec?n.windowsExec:f.getDefaultTerminalWindows(),d=await f.getWtExePath();return new Promise((D,w)=>{const M=`"${a} - ${p}"`,T=`"${t.join('" "')}" & pause`,C=Object.assign({},b(process),o);Object.keys(C).filter(Q=>C[Q]===null).forEach(Q=>delete C[Q]);const L={cwd:a,env:C,windowsVerbatimArguments:!0};let _,V;k.basename(l,".exe")==="wt"?(_=l,V=["-d",".",f.CMD,"/c",T]):d?(_=d,V=["-d",".",l,"/c",T]):(_=f.CMD,V=["/c","start",M,"/wait",l,"/c",`"${T}"`]),i.spawn(_,V,L).on("error",Q=>{w(g(Q))}),D(void 0)})}static getDefaultTerminalWindows(){if(!f._DEFAULT_TERMINAL_WINDOWS){const r=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");f._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${r?"Sysnative":"System32"}\\cmd.exe`}return f._DEFAULT_TERMINAL_WINDOWS}static async getWtExePath(){try{const r=await c.win32.findExecutable("wt");return await S.Promises.exists(r)?r:void 0}catch{return}}}e.WindowsExternalTerminalService=f,Pe([s.memoize],f,"getWtExePath",null);class h extends v{static{this.OSASCRIPT="/usr/bin/osascript"}openTerminal(r,a){return this.spawnTerminal(i,r,a)}runInTerminal(r,a,t,o,n){const l=n.osxExec||u.DEFAULT_TERMINAL_OSX;return new Promise((d,D)=>{if(l===u.DEFAULT_TERMINAL_OSX||l==="iTerm.app"){const w=l===u.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",T=[y.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${w}.scpt`).fsPath,"-t",r||p,"-w",a];for(const _ of t)T.push("-a"),T.push(_);if(o){const _=Object.assign({},b(process),o);for(const V in _){const z=_[V];z===null?(T.push("-u"),T.push(V)):(T.push("-e"),T.push(`${V}=${z}`))}}let C="";const L=i.spawn(h.OSASCRIPT,T);L.on("error",_=>{D(g(_))}),L.stderr.on("data",_=>{C+=_.toString()}),L.on("exit",_=>{if(_===0)d(void 0);else if(C){const V=C.split(`
`,1);D(new Error(V[0]))}else D(new Error(m.localize(1852,null,w,_)))})}else D(new Error(m.localize(1853,null,l)))})}spawnTerminal(r,a,t){const o=a.osxExec||u.DEFAULT_TERMINAL_OSX;return new Promise((n,l)=>{const d=["-a",o];t&&d.push(t);const D=b(process),w=r.spawn("/usr/bin/open",d,{cwd:t,env:D});w.on("error",l),w.on("exit",()=>n())})}}e.MacExternalTerminalService=h;class E extends v{static{this.WAIT_MESSAGE=m.localize(1854,null)}openTerminal(r,a){return this.spawnTerminal(i,r,a)}runInTerminal(r,a,t,o,n){const l=n.linuxExec?Promise.resolve(n.linuxExec):E.getDefaultTerminalLinuxReady();return new Promise((d,D)=>{const w=[];l.then(M=>{M.indexOf("gnome-terminal")>=0?w.push("-x"):w.push("-e"),w.push("bash"),w.push("-c");const T=`${I(t)}; echo; read -p "${E.WAIT_MESSAGE}" -n1;`;w.push(`''${T}''`);const C=Object.assign({},b(process),o);Object.keys(C).filter(z=>C[z]===null).forEach(z=>delete C[z]);const L={cwd:a,env:C};let _="";const V=i.spawn(M,w,L);V.on("error",z=>{D(g(z))}),V.stderr.on("data",z=>{_+=z.toString()}),V.on("exit",z=>{if(z===0)d(void 0);else if(_){const Q=_.split(`
`,1);D(new Error(Q[0]))}else D(new Error(m.localize(1855,null,M,z)))})})})}static async getDefaultTerminalLinuxReady(){if(!E._DEFAULT_TERMINAL_LINUX_READY)if(!A.isLinux)E._DEFAULT_TERMINAL_LINUX_READY=Promise.resolve("xterm");else{const r=await S.Promises.exists("/etc/debian_version");E._DEFAULT_TERMINAL_LINUX_READY=new Promise(a=>{r?a("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?a("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?a("konsole"):process.env.COLORTERM?a(process.env.COLORTERM):process.env.TERM?a(process.env.TERM):a("xterm")})}return E._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(r,a,t){const o=a.linuxExec?Promise.resolve(a.linuxExec):E.getDefaultTerminalLinuxReady();return new Promise((n,l)=>{o.then(d=>{const D=b(process),w=r.spawn(d,[],{cwd:t,env:D});w.on("error",l),w.on("exit",()=>n())})})}}e.LinuxExternalTerminalService=E;function b(P){const r={...P.env};return(0,R.sanitizeProcessEnvironment)(r),r}function g(P){return"errno"in P&&P.errno==="ENOENT"&&"path"in P&&typeof P.path=="string"?new Error(m.localize(1856,null,P.path)):P}function I(P){let r="";for(const a of P)a.indexOf(" ")>=0?r+='"'+a+'"':r+=a,r+=" ";return r}}),define(le[14],ue([0,1,61,10,25,12,7,9,6,3,11,67]),function(j,e,i,s,y,k,A,R,S,c,m,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ByteSize=e.ETAG_DISABLED=e.FileKind=e.FILES_READONLY_FROM_PERMISSIONS_CONFIG=e.FILES_READONLY_EXCLUDE_CONFIG=e.FILES_READONLY_INCLUDE_CONFIG=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.TooLargeFileOperationError=e.FileOperationError=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FileChangeFilter=e.FilePermission=e.FileType=e.IFileService=void 0,e.isFileOpenForWriteOptions=p,e.isFileSystemWatcher=E,e.hasReadWriteCapability=g,e.hasFileFolderCopyCapability=I,e.hasFileCloneCapability=P,e.hasOpenReadWriteCloseCapability=r,e.hasFileReadStreamCapability=a,e.hasFileAtomicReadCapability=t,e.hasFileAtomicWriteCapability=o,e.hasFileAtomicDeleteCapability=n,e.hasReadonlyCapability=l,e.createFileSystemProviderError=w,e.ensureFileSystemProviderError=M,e.markAsFileSystemProviderError=T,e.toFileSystemProviderErrorCode=C,e.toFileOperationResult=L,e.isParent=fe,e.etag=x,e.whenProviderRegistered=W,e.getLargeFileConfirmationLimit=ie,e.IFileService=(0,S.createDecorator)("fileService");function p(H){return H.create===!0}var v;(function(H){H[H.Unknown=0]="Unknown",H[H.File=1]="File",H[H.Directory=2]="Directory",H[H.SymbolicLink=64]="SymbolicLink"})(v||(e.FileType=v={}));var f;(function(H){H[H.Readonly=1]="Readonly",H[H.Locked=2]="Locked"})(f||(e.FilePermission=f={}));var h;(function(H){H[H.UPDATED=2]="UPDATED",H[H.ADDED=4]="ADDED",H[H.DELETED=8]="DELETED"})(h||(e.FileChangeFilter=h={}));function E(H){const ce=H;return!!ce&&typeof ce.onDidChange=="function"}var b;(function(H){H[H.None=0]="None",H[H.FileReadWrite=2]="FileReadWrite",H[H.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",H[H.FileReadStream=16]="FileReadStream",H[H.FileFolderCopy=8]="FileFolderCopy",H[H.PathCaseSensitive=1024]="PathCaseSensitive",H[H.Readonly=2048]="Readonly",H[H.Trash=4096]="Trash",H[H.FileWriteUnlock=8192]="FileWriteUnlock",H[H.FileAtomicRead=16384]="FileAtomicRead",H[H.FileAtomicWrite=32768]="FileAtomicWrite",H[H.FileAtomicDelete=65536]="FileAtomicDelete",H[H.FileClone=131072]="FileClone"})(b||(e.FileSystemProviderCapabilities=b={}));function g(H){return!!(H.capabilities&b.FileReadWrite)}function I(H){return!!(H.capabilities&b.FileFolderCopy)}function P(H){return!!(H.capabilities&b.FileClone)}function r(H){return!!(H.capabilities&b.FileOpenReadWriteClose)}function a(H){return!!(H.capabilities&b.FileReadStream)}function t(H){return g(H)?!!(H.capabilities&b.FileAtomicRead):!1}function o(H){return g(H)?!!(H.capabilities&b.FileAtomicWrite):!1}function n(H){return!!(H.capabilities&b.FileAtomicDelete)}function l(H){return!!(H.capabilities&b.Readonly)}var d;(function(H){H.FileExists="EntryExists",H.FileNotFound="EntryNotFound",H.FileNotADirectory="EntryNotADirectory",H.FileIsADirectory="EntryIsADirectory",H.FileExceedsStorageQuota="EntryExceedsStorageQuota",H.FileTooLarge="EntryTooLarge",H.FileWriteLocked="EntryWriteLocked",H.NoPermissions="NoPermissions",H.Unavailable="Unavailable",H.Unknown="Unknown"})(d||(e.FileSystemProviderErrorCode=d={}));class D extends Error{static create(ce,oe){const te=new D(ce.toString(),oe);return T(te,oe),te}constructor(ce,oe){super(ce),this.code=oe}}e.FileSystemProviderError=D;function w(H,ce){return D.create(H,ce)}function M(H){return H||w((0,R.localize)(1865,null),d.Unknown)}function T(H,ce){return H.name=ce?`${ce} (FileSystemError)`:"FileSystemError",H}function C(H){if(!H)return d.Unknown;if(H instanceof D)return H.code;const ce=/^(.+) \(FileSystemError\)$/.exec(H.name);if(!ce)return d.Unknown;switch(ce[1]){case d.FileExists:return d.FileExists;case d.FileIsADirectory:return d.FileIsADirectory;case d.FileNotADirectory:return d.FileNotADirectory;case d.FileNotFound:return d.FileNotFound;case d.FileTooLarge:return d.FileTooLarge;case d.FileWriteLocked:return d.FileWriteLocked;case d.NoPermissions:return d.NoPermissions;case d.Unavailable:return d.Unavailable}return d.Unknown}function L(H){if(H instanceof se)return H.fileOperationResult;switch(C(H)){case d.FileNotFound:return K.FILE_NOT_FOUND;case d.FileIsADirectory:return K.FILE_IS_DIRECTORY;case d.FileNotADirectory:return K.FILE_NOT_DIRECTORY;case d.FileWriteLocked:return K.FILE_WRITE_LOCKED;case d.NoPermissions:return K.FILE_PERMISSION_DENIED;case d.FileExists:return K.FILE_MOVE_CONFLICT;case d.FileTooLarge:return K.FILE_TOO_LARGE;default:return K.FILE_OTHER_ERROR}}var _;(function(H){H[H.CREATE=0]="CREATE",H[H.DELETE=1]="DELETE",H[H.MOVE=2]="MOVE",H[H.COPY=3]="COPY",H[H.WRITE=4]="WRITE"})(_||(e.FileOperation=_={}));class V{constructor(ce,oe,te){this.resource=ce,this.operation=oe,this.target=te}isOperation(ce){return this.operation===ce}}e.FileOperationEvent=V;var z;(function(H){H[H.UPDATED=0]="UPDATED",H[H.ADDED=1]="ADDED",H[H.DELETED=2]="DELETED"})(z||(e.FileChangeType=z={}));class Q{static{this.MIXED_CORRELATION=null}constructor(ce,oe){this.ignorePathCasing=oe,this.correlationId=void 0,this.added=new u.Lazy(()=>{const te=i.TernarySearchTree.forUris(()=>this.ignorePathCasing);return te.fill(this.rawAdded.map(O=>[O,!0])),te}),this.updated=new u.Lazy(()=>{const te=i.TernarySearchTree.forUris(()=>this.ignorePathCasing);return te.fill(this.rawUpdated.map(O=>[O,!0])),te}),this.deleted=new u.Lazy(()=>{const te=i.TernarySearchTree.forUris(()=>this.ignorePathCasing);return te.fill(this.rawDeleted.map(O=>[O,!0])),te}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const te of ce){switch(te.type){case z.ADDED:this.rawAdded.push(te.resource);break;case z.UPDATED:this.rawUpdated.push(te.resource);break;case z.DELETED:this.rawDeleted.push(te.resource);break}this.correlationId!==Q.MIXED_CORRELATION&&(typeof te.cId=="number"?this.correlationId===void 0?this.correlationId=te.cId:this.correlationId!==te.cId&&(this.correlationId=Q.MIXED_CORRELATION):this.correlationId!==void 0&&(this.correlationId=Q.MIXED_CORRELATION))}}contains(ce,...oe){return this.doContains(ce,{includeChildren:!1},...oe)}affects(ce,...oe){return this.doContains(ce,{includeChildren:!0},...oe)}doContains(ce,oe,...te){if(!ce)return!1;const O=te.length>0;return!!((!O||te.includes(z.ADDED))&&(this.added.value.get(ce)||oe.includeChildren&&this.added.value.findSuperstr(ce))||(!O||te.includes(z.UPDATED))&&(this.updated.value.get(ce)||oe.includeChildren&&this.updated.value.findSuperstr(ce))||(!O||te.includes(z.DELETED))&&(this.deleted.value.findSubstr(ce)||oe.includeChildren&&this.deleted.value.findSuperstr(ce)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(ce){return this.correlationId===ce}hasCorrelation(){return typeof this.correlationId=="number"}}e.FileChangesEvent=Q;function fe(H,ce,oe){return!H||!ce||H===ce||ce.length>H.length?!1:(ce.charAt(ce.length-1)!==s.sep&&(ce+=s.sep),oe?(0,y.startsWithIgnoreCase)(H,ce):H.indexOf(ce)===0)}class se extends Error{constructor(ce,oe,te){super(ce),this.fileOperationResult=oe,this.options=te}}e.FileOperationError=se;class ee extends se{constructor(ce,oe,te,O){super(ce,oe,O),this.fileOperationResult=oe,this.size=te}}e.TooLargeFileOperationError=ee;class U extends se{constructor(ce,oe,te){super(ce,K.FILE_NOT_MODIFIED_SINCE,te),this.stat=oe}}e.NotModifiedSinceFileOperationError=U;var K;(function(H){H[H.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",H[H.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",H[H.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",H[H.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",H[H.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",H[H.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",H[H.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",H[H.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",H[H.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",H[H.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",H[H.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(K||(e.FileOperationResult=K={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude",e.FILES_READONLY_INCLUDE_CONFIG="files.readonlyInclude",e.FILES_READONLY_EXCLUDE_CONFIG="files.readonlyExclude",e.FILES_READONLY_FROM_PERMISSIONS_CONFIG="files.readonlyFromPermissions";var N;(function(H){H[H.FILE=0]="FILE",H[H.FOLDER=1]="FOLDER",H[H.ROOT_FOLDER=2]="ROOT_FOLDER"})(N||(e.FileKind=N={})),e.ETAG_DISABLED="";function x(H){if(!(typeof H.size!="number"||typeof H.mtime!="number"))return H.mtime.toString(29)+H.size.toString(31)}async function W(H,ce){if(!ce.hasProvider(A.URI.from({scheme:H.scheme})))return new Promise(oe=>{const te=ce.onDidChangeFileSystemProviderRegistrations(O=>{O.scheme===H.scheme&&O.added&&(te.dispose(),oe())})})}class q{static{this.KB=1024}static{this.MB=q.KB*q.KB}static{this.GB=q.MB*q.KB}static{this.TB=q.GB*q.KB}static formatSize(ce){return(0,k.isNumber)(ce)||(ce=0),ce<q.KB?(0,R.localize)(1866,null,ce.toFixed(0)):ce<q.MB?(0,R.localize)(1867,null,(ce/q.KB).toFixed(2)):ce<q.GB?(0,R.localize)(1868,null,(ce/q.MB).toFixed(2)):ce<q.TB?(0,R.localize)(1869,null,(ce/q.GB).toFixed(2)):(0,R.localize)(1870,null,(ce/q.TB).toFixed(2))}}e.ByteSize=q;function ie(H){const ce=typeof H=="string"||H?.scheme===m.Schemas.vscodeRemote;return typeof H!="string"&&H?.scheme===m.Schemas.file?1024*q.MB:ce?10*q.MB:c.isWeb?50*q.MB:1024*q.MB}}),define(le[127],ue([0,1,17,15,9,14]),function(j,e,i,s,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=A;async function A(m,u,p,v,f,h){let E;try{await R(m,u,p,v,f,h)}catch(b){E=b}finally{E&&f.errorTransformer&&(E=f.errorTransformer(E)),typeof E<"u"&&p.error(E),p.end()}}async function R(m,u,p,v,f,h){S(h);const E=await m.open(u,{create:!1});try{S(h);let b=0,g=0,I=f&&typeof f.length=="number"?f.length:void 0,P=i.VSBuffer.alloc(Math.min(f.bufferSize,typeof I=="number"?I:f.bufferSize)),r=f&&typeof f.position=="number"?f.position:0,a=0;do g=await m.read(E,r,P.buffer,a,P.byteLength-a),r+=g,a+=g,b+=g,typeof I=="number"&&(I-=g),a===P.byteLength&&(await p.write(v(P)),P=i.VSBuffer.alloc(Math.min(f.bufferSize,typeof I=="number"?I:f.bufferSize)),a=0);while(g>0&&(typeof I!="number"||I>0)&&S(h)&&c(b,f));if(a>0){let t=a;typeof I=="number"&&(t=Math.min(a,I)),p.write(v(P.slice(0,t)))}}catch(b){throw(0,k.ensureFileSystemProviderError)(b)}finally{await m.close(E)}}function S(m){if(m.isCancellationRequested)throw(0,s.canceled)();return!0}function c(m,u){if(typeof u?.limits?.size=="number"&&m>u.limits.size)throw(0,k.createFileSystemProviderError)((0,y.localize)(1898,null),k.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(le[62],ue([0,1,116,2,10,3,7,14]),function(j,e,i,s,y,k,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractUniversalWatcherClient=e.AbstractNonRecursiveWatcherClient=e.AbstractWatcherClient=void 0,e.isWatchRequestWithCorrelation=S,e.isRecursiveWatchRequest=c,e.reviveFileChanges=v,e.coalesceEvents=f,e.normalizeWatcherPattern=h,e.parseWatcherPatterns=E,e.isFiltered=g,e.requestFilterToString=I;function S(P){return typeof P.correlationId=="number"}function c(P){return P.recursive===!0}class m extends s.Disposable{static{this.MAX_RESTARTS=5}constructor(r,a,t,o){super(),this.onFileChanges=r,this.onLogMessage=a,this.verboseLogging=t,this.options=o,this.watcherDisposables=this._register(new s.MutableDisposable),this.requests=void 0,this.restartCounter=0}init(){const r=new s.DisposableStore;this.watcherDisposables.value=r,this.watcher=this.createWatcher(r),this.watcher.setVerboseLogging(this.verboseLogging),r.add(this.watcher.onDidChangeFile(a=>this.onFileChanges(a))),r.add(this.watcher.onDidLogMessage(a=>this.onLogMessage(a))),r.add(this.watcher.onDidError(a=>this.onError(a.error,a.request)))}onError(r,a){this.canRestart(r,a)?this.restartCounter<m.MAX_RESTARTS&&this.requests?(this.error(`restarting watcher after unexpected error: ${r}`),this.restart(this.requests)):this.error(`gave up attempting to restart watcher after unexpected error: ${r}`):this.error(r)}canRestart(r,a){return!(!this.options.restartOnError||a||r.indexOf("No space left on device")!==-1||r.indexOf("EMFILE")!==-1)}restart(r){this.restartCounter++,this.init(),this.watch(r)}async watch(r){this.requests=r,await this.watcher?.watch(r)}async setVerboseLogging(r){this.verboseLogging=r,await this.watcher?.setVerboseLogging(r)}error(r){this.onLogMessage({type:"error",message:`[File Watcher (${this.options.type})] ${r}`})}trace(r){this.onLogMessage({type:"trace",message:`[File Watcher (${this.options.type})] ${r}`})}dispose(){return this.watcher=void 0,super.dispose()}}e.AbstractWatcherClient=m;class u extends m{constructor(r,a,t){super(r,a,t,{type:"node.js",restartOnError:!1})}}e.AbstractNonRecursiveWatcherClient=u;class p extends m{constructor(r,a,t){super(r,a,t,{type:"universal",restartOnError:!0})}}e.AbstractUniversalWatcherClient=p;function v(P){return P.map(r=>({type:r.type,resource:A.URI.revive(r.resource),cId:r.cId}))}function f(P){const r=new b;for(const a of P)r.processEvent(a);return r.coalesce()}function h(P,r){return typeof r=="string"&&!r.startsWith(i.GLOBSTAR)&&!(0,y.isAbsolute)(r)?{base:P,pattern:r}:r}function E(P,r){const a=[];for(const t of r)a.push((0,i.parse)(h(P,t)));return a}class b{constructor(){this.coalesced=new Set,this.mapPathToChange=new Map}toKey(r){return k.isLinux?r.resource.fsPath:r.resource.fsPath.toLowerCase()}processEvent(r){const a=this.mapPathToChange.get(this.toKey(r));let t=!1;if(a){const o=a.type,n=r.type;a.resource.fsPath!==r.resource.fsPath&&(r.type===R.FileChangeType.DELETED||r.type===R.FileChangeType.ADDED)?t=!0:o===R.FileChangeType.ADDED&&n===R.FileChangeType.DELETED?(this.mapPathToChange.delete(this.toKey(r)),this.coalesced.delete(a)):o===R.FileChangeType.DELETED&&n===R.FileChangeType.ADDED?a.type=R.FileChangeType.UPDATED:o===R.FileChangeType.ADDED&&n===R.FileChangeType.UPDATED||(a.type=n)}else t=!0;t&&(this.coalesced.add(r),this.mapPathToChange.set(this.toKey(r),r))}coalesce(){const r=[],a=[];return Array.from(this.coalesced).filter(t=>t.type!==R.FileChangeType.DELETED?(r.push(t),!1):!0).sort((t,o)=>t.resource.fsPath.length-o.resource.fsPath.length).filter(t=>a.some(o=>(0,R.isParent)(t.resource.fsPath,o,!k.isLinux))?!1:(a.push(t.resource.fsPath),!0)).concat(r)}}function g(P,r){if(typeof r=="number")switch(P.type){case R.FileChangeType.ADDED:return(r&R.FileChangeFilter.ADDED)===0;case R.FileChangeType.DELETED:return(r&R.FileChangeFilter.DELETED)===0;case R.FileChangeType.UPDATED:return(r&R.FileChangeFilter.UPDATED)===0}return!1}function I(P){if(typeof P=="number"){const r=[];return P&R.FileChangeFilter.ADDED&&r.push("Added"),P&R.FileChangeFilter.DELETED&&r.push("Deleted"),P&R.FileChangeFilter.UPDATED&&r.push("Updated"),r.length===0?"<all>":`[${r.join(", ")}]`}return"<none>"}}),define(le[183],ue([0,1,17,55,15,4,2,68,33,14,62]),function(j,e,i,s,y,k,A,R,S,c,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderClient=e.LOCAL_FILE_SYSTEM_CHANNEL_NAME=void 0,e.LOCAL_FILE_SYSTEM_CHANNEL_NAME="localFilesystem";class u extends A.Disposable{constructor(v,f){super(),this.channel=v,this.extraCapabilities=f,this.onDidChangeCapabilities=k.Event.None,this._onDidChange=this._register(new k.Emitter),this.onDidChangeFile=this._onDidChange.event,this._onDidWatchError=this._register(new k.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.sessionId=(0,S.generateUuid)(),this.registerFileChangeListeners()}get capabilities(){return this._capabilities||(this._capabilities=c.FileSystemProviderCapabilities.FileReadWrite|c.FileSystemProviderCapabilities.FileOpenReadWriteClose|c.FileSystemProviderCapabilities.FileReadStream|c.FileSystemProviderCapabilities.FileFolderCopy|c.FileSystemProviderCapabilities.FileWriteUnlock|c.FileSystemProviderCapabilities.FileAtomicRead|c.FileSystemProviderCapabilities.FileAtomicWrite|c.FileSystemProviderCapabilities.FileAtomicDelete|c.FileSystemProviderCapabilities.FileClone,this.extraCapabilities.pathCaseSensitive&&(this._capabilities|=c.FileSystemProviderCapabilities.PathCaseSensitive),this.extraCapabilities.trash&&(this._capabilities|=c.FileSystemProviderCapabilities.Trash)),this._capabilities}stat(v){return this.channel.call("stat",[v])}readdir(v){return this.channel.call("readdir",[v])}async readFile(v,f){const{buffer:h}=await this.channel.call("readFile",[v,f]);return h}readFileStream(v,f,h){const E=(0,R.newWriteableStream)(g=>i.VSBuffer.concat(g.map(I=>i.VSBuffer.wrap(I))).buffer),b=new A.DisposableStore;return b.add(this.channel.listen("readFileStream",[v,f])(g=>{if(g instanceof i.VSBuffer)E.write(g.buffer);else{if(g==="end")E.end();else{let I;if(g instanceof Error)I=g;else{const P=g;I=(0,c.createFileSystemProviderError)(P.message??(0,s.toErrorMessage)(P),P.code??c.FileSystemProviderErrorCode.Unknown)}E.error(I),E.end()}b.dispose()}})),b.add(h.onCancellationRequested(()=>{E.error((0,y.canceled)()),E.end(),b.dispose()})),E}writeFile(v,f,h){return this.channel.call("writeFile",[v,i.VSBuffer.wrap(f),h])}open(v,f){return this.channel.call("open",[v,f])}close(v){return this.channel.call("close",[v])}async read(v,f,h,E,b){const[g,I]=await this.channel.call("read",[v,f,b]);return h.set(g.buffer.slice(0,I),E),I}write(v,f,h,E,b){return this.channel.call("write",[v,f,i.VSBuffer.wrap(h),E,b])}mkdir(v){return this.channel.call("mkdir",[v])}delete(v,f){return this.channel.call("delete",[v,f])}rename(v,f,h){return this.channel.call("rename",[v,f,h])}copy(v,f,h){return this.channel.call("copy",[v,f,h])}cloneFile(v,f){return this.channel.call("cloneFile",[v,f])}registerFileChangeListeners(){this._register(this.channel.listen("fileChange",[this.sessionId])(v=>{if(Array.isArray(v)){const f=v;this._onDidChange.fire((0,m.reviveFileChanges)(f))}else{const f=v;this._onDidWatchError.fire(f)}}))}watch(v,f){const h=(0,S.generateUuid)();return this.channel.call("watch",[this.sessionId,h,v,f]),(0,A.toDisposable)(()=>this.channel.call("unwatch",[this.sessionId,h]))}}e.DiskFileSystemProviderClient=u}),define(le[184],ue([0,1,26,2,62,4,14,7,8]),function(j,e,i,s,y,k,A,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BaseWatcher=void 0;class c extends s.Disposable{constructor(){super(),this._onDidChangeFile=this._register(new k.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidLogMessage=this._register(new k.Emitter),this.onDidLogMessage=this._onDidLogMessage.event,this._onDidWatchFail=this._register(new k.Emitter),this.onDidWatchFail=this._onDidWatchFail.event,this.allNonCorrelatedWatchRequests=new Set,this.allCorrelatedWatchRequests=new Map,this.suspendedWatchRequests=this._register(new s.DisposableMap),this.suspendedWatchRequestsWithPolling=new Set,this.updateWatchersDelayer=this._register(new S.ThrottledDelayer(this.getUpdateWatchersDelay())),this.suspendedWatchRequestPollingInterval=5007,this.joinWatch=new S.DeferredPromise,this.verboseLogging=!1,this._register(this.onDidWatchFail(u=>this.handleDidWatchFail(u)))}handleDidWatchFail(u){this.isCorrelated(u)&&this.suspendWatchRequest(u)}isCorrelated(u){return(0,y.isWatchRequestWithCorrelation)(u)}async watch(u){this.joinWatch.isSettled||this.joinWatch.complete(),this.joinWatch=new S.DeferredPromise;try{this.allCorrelatedWatchRequests.clear(),this.allNonCorrelatedWatchRequests.clear();for(const p of u)this.isCorrelated(p)?this.allCorrelatedWatchRequests.set(p.correlationId,p):this.allNonCorrelatedWatchRequests.add(p);for(const[p]of this.suspendedWatchRequests)this.allCorrelatedWatchRequests.has(p)||(this.suspendedWatchRequests.deleteAndDispose(p),this.suspendedWatchRequestsWithPolling.delete(p));return await this.updateWatchers(!1)}finally{this.joinWatch.complete()}}updateWatchers(u){return this.updateWatchersDelayer.trigger(()=>this.doWatch([...this.allNonCorrelatedWatchRequests,...Array.from(this.allCorrelatedWatchRequests.values()).filter(p=>!this.suspendedWatchRequests.has(p.correlationId))]),u?this.getUpdateWatchersDelay():0)}getUpdateWatchersDelay(){return 800}isSuspended(u){return typeof u.correlationId!="number"?!1:this.suspendedWatchRequestsWithPolling.has(u.correlationId)?"polling":this.suspendedWatchRequests.has(u.correlationId)}async suspendWatchRequest(u){if(this.suspendedWatchRequests.has(u.correlationId))return;const p=new s.DisposableStore;this.suspendedWatchRequests.set(u.correlationId,p),await this.joinWatch.p,!p.isDisposed&&(this.monitorSuspendedWatchRequest(u,p),this.updateWatchers(!0))}resumeWatchRequest(u){this.suspendedWatchRequests.deleteAndDispose(u.correlationId),this.suspendedWatchRequestsWithPolling.delete(u.correlationId),this.updateWatchers(!1)}monitorSuspendedWatchRequest(u,p){this.doMonitorWithExistingWatcher(u,p)?(this.trace(`reusing an existing recursive watcher to monitor ${u.path}`),this.suspendedWatchRequestsWithPolling.delete(u.correlationId)):(this.doMonitorWithNodeJS(u,p),this.suspendedWatchRequestsWithPolling.add(u.correlationId))}doMonitorWithExistingWatcher(u,p){const v=this.recursiveWatcher?.subscribe(u.path,(f,h)=>{p.isDisposed||(f?this.monitorSuspendedWatchRequest(u,p):h?.type===A.FileChangeType.ADDED&&this.onMonitoredPathAdded(u))});return v?(p.add(v),!0):!1}doMonitorWithNodeJS(u,p){let v=!1;const f=(h,E)=>{if(p.isDisposed)return;const b=this.isPathNotFound(h),g=this.isPathNotFound(E),I=v;v=b,!b&&(g||I)&&this.onMonitoredPathAdded(u)};this.trace(`starting fs.watchFile() on ${u.path} (correlationId: ${u.correlationId})`);try{(0,i.watchFile)(u.path,{persistent:!1,interval:this.suspendedWatchRequestPollingInterval},f)}catch(h){this.warn(`fs.watchFile() failed with error ${h} on path ${u.path} (correlationId: ${u.correlationId})`)}p.add((0,s.toDisposable)(()=>{this.trace(`stopping fs.watchFile() on ${u.path} (correlationId: ${u.correlationId})`);try{(0,i.unwatchFile)(u.path,f)}catch(h){this.warn(`fs.unwatchFile() failed with error ${h} on path ${u.path} (correlationId: ${u.correlationId})`)}}))}onMonitoredPathAdded(u){this.trace(`detected ${u.path} exists again, resuming watcher (correlationId: ${u.correlationId})`);const p={resource:R.URI.file(u.path),type:A.FileChangeType.ADDED,cId:u.correlationId};this._onDidChangeFile.fire([p]),this.traceEvent(p,u),this.resumeWatchRequest(u)}isPathNotFound(u){return u.ctimeMs===0&&u.ino===0}async stop(){this.suspendedWatchRequests.clearAndDisposeAll(),this.suspendedWatchRequestsWithPolling.clear()}traceEvent(u,p){if(this.verboseLogging){const v=` >> normalized ${u.type===A.FileChangeType.ADDED?"[ADDED]":u.type===A.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${u.resource.fsPath}`;this.traceWithCorrelation(v,p)}}traceWithCorrelation(u,p){this.verboseLogging&&this.trace(`${u}${typeof p.correlationId=="number"?` <${p.correlationId}> `:""}`)}requestToString(u){return`${u.path} (excludes: ${u.excludes.length>0?u.excludes:"<none>"}, includes: ${u.includes&&u.includes.length>0?JSON.stringify(u.includes):"<all>"}, filter: ${(0,y.requestFilterToString)(u.filter)}, correlationId: ${typeof u.correlationId=="number"?u.correlationId:"<none>"})`}async setVerboseLogging(u){this.verboseLogging=u}}e.BaseWatcher=c}),define(le[185],ue([0,1,26,8,22,32,2,79,10,3,18,7,117,23,14,62]),function(j,e,i,s,y,k,A,R,S,c,m,u,p,v,f,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSFileWatcherLibrary=void 0,e.watchFileContents=b;class E extends A.Disposable{static{this.FILE_DELETE_HANDLER_DELAY=100}static{this.FILE_CHANGES_HANDLER_DELAY=75}get isReusingRecursiveWatcher(){return this._isReusingRecursiveWatcher}get failed(){return this.didFail}constructor(I,P,r,a,t,o){super(),this.request=I,this.recursiveWatcher=P,this.onDidFilesChange=r,this.onDidWatchFail=a,this.onLogMessage=t,this.verboseLogging=o,this.throttledFileChangesEmitter=this._register(new s.ThrottledWorker({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},n=>this.onDidFilesChange(n))),this.fileChangesAggregator=this._register(new s.RunOnceWorker(n=>this.handleFileChanges(n),E.FILE_CHANGES_HANDLER_DELAY)),this.excludes=(0,h.parseWatcherPatterns)(this.request.path,this.request.excludes),this.includes=this.request.includes?(0,h.parseWatcherPatterns)(this.request.path,this.request.includes):void 0,this.filter=(0,h.isWatchRequestWithCorrelation)(this.request)?this.request.filter:void 0,this.cts=new y.CancellationTokenSource,this.ready=this.watch(),this._isReusingRecursiveWatcher=!1,this.didFail=!1}async watch(){try{const I=await this.normalizePath(this.request);if(this.cts.token.isCancellationRequested)return;const P=await i.promises.stat(I);if(this.cts.token.isCancellationRequested)return;this._register(await this.doWatch(I,P.isDirectory()))}catch(I){I.code!=="ENOENT"?this.error(I):this.trace(`ignoring a path for watching who's stat info failed to resolve: ${this.request.path} (error: ${I})`),this.notifyWatchFailed()}}notifyWatchFailed(){this.didFail=!0,this.onDidWatchFail?.()}async normalizePath(I){let P=I.path;try{P=await v.Promises.realpath(I.path),I.path===P&&(P=await(0,p.realcase)(I.path,this.cts.token)??I.path),I.path!==P&&this.trace(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${I.path}, real: ${P})`)}catch{}return P}async doWatch(I,P){const r=new A.DisposableStore;return this.doWatchWithExistingWatcher(I,P,r)?(this.trace(`reusing an existing recursive watcher for ${this.request.path}`),this._isReusingRecursiveWatcher=!0):(this._isReusingRecursiveWatcher=!1,await this.doWatchWithNodeJS(I,P,r)),r}doWatchWithExistingWatcher(I,P,r){if(P)return!1;const a=u.URI.file(this.request.path),t=this.recursiveWatcher?.subscribe(this.request.path,async(o,n)=>{if(!r.isDisposed)if(o){const l=await this.doWatch(I,P);r.isDisposed?l.dispose():r.add(l)}else n&&(typeof n.cId=="number"||typeof this.request.correlationId=="number")&&this.onFileChange({resource:a,type:n.type,cId:this.request.correlationId},!0)});return t?(r.add(t),!0):!1}async doWatchWithNodeJS(I,P,r){if(c.isMacintosh&&(0,k.isEqualOrParent)(I,"/Volumes/",!0)){this.error(`Refusing to watch ${I} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`);return}const a=new y.CancellationTokenSource(this.cts.token);r.add((0,A.toDisposable)(()=>a.dispose(!0)));const t=new A.DisposableStore;r.add(t);try{const o=u.URI.file(this.request.path),n=(0,S.basename)(I),l=(0,i.watch)(I);t.add((0,A.toDisposable)(()=>{l.removeAllListeners(),l.close()})),this.trace(`Started watching: '${I}'`);const d=new Set;if(P)try{for(const w of await v.Promises.readdir(I))d.add(w)}catch(w){this.error(w)}if(a.token.isCancellationRequested)return;const D=new Map;t.add((0,A.toDisposable)(()=>{for(const[,w]of D)w.dispose();D.clear()})),l.on("error",(w,M)=>{a.token.isCancellationRequested||(this.error(`Failed to watch ${I} for changes using fs.watch() (${w}, ${M})`),this.notifyWatchFailed())}),l.on("change",(w,M)=>{if(a.token.isCancellationRequested)return;this.verboseLogging&&this.traceWithCorrelation(`[raw] ["${w}"] ${M}`);let T="";if(M&&(T=M.toString(),c.isMacintosh&&(T=(0,R.normalizeNFC)(T))),!(!T||w!=="change"&&w!=="rename"))if(P)if(w==="rename"){D.get(T)?.dispose();const C=setTimeout(async()=>{if(D.delete(T),T===n&&!await v.Promises.exists(I)){this.onWatchedPathDeleted(o);return}if(a.token.isCancellationRequested)return;const L=await this.existsChildStrictCase((0,S.join)(I,T));if(a.token.isCancellationRequested)return;let _;L?d.has(T)?_=f.FileChangeType.UPDATED:(_=f.FileChangeType.ADDED,d.add(T)):(d.delete(T),_=f.FileChangeType.DELETED),this.onFileChange({resource:(0,m.joinPath)(o,T),type:_,cId:this.request.correlationId})},E.FILE_DELETE_HANDLER_DELAY);D.set(T,(0,A.toDisposable)(()=>clearTimeout(C)))}else{let C;d.has(T)?C=f.FileChangeType.UPDATED:(C=f.FileChangeType.ADDED,d.add(T)),this.onFileChange({resource:(0,m.joinPath)(o,T),type:C,cId:this.request.correlationId})}else if(w==="rename"||T!==n){const C=setTimeout(async()=>{const L=await v.Promises.exists(I);a.token.isCancellationRequested||(L?(this.onFileChange({resource:o,type:f.FileChangeType.UPDATED,cId:this.request.correlationId},!0),t.add(await this.doWatch(I,!1))):this.onWatchedPathDeleted(o))},E.FILE_DELETE_HANDLER_DELAY);t.clear(),t.add((0,A.toDisposable)(()=>clearTimeout(C)))}else this.onFileChange({resource:o,type:f.FileChangeType.UPDATED,cId:this.request.correlationId},!0)})}catch(o){a.token.isCancellationRequested||this.error(`Failed to watch ${I} for changes using fs.watch() (${o.toString()})`),this.notifyWatchFailed()}}onWatchedPathDeleted(I){this.warn("Watcher shutdown because watched path got deleted"),this.onFileChange({resource:I,type:f.FileChangeType.DELETED,cId:this.request.correlationId},!0),this.fileChangesAggregator.flush(),this.notifyWatchFailed()}onFileChange(I,P=!1){this.cts.token.isCancellationRequested||(this.verboseLogging&&this.traceWithCorrelation(`${I.type===f.FileChangeType.ADDED?"[ADDED]":I.type===f.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${I.resource.fsPath}`),!P&&this.excludes.some(r=>r(I.resource.fsPath))?this.verboseLogging&&this.traceWithCorrelation(` >> ignored (excluded) ${I.resource.fsPath}`):!P&&this.includes&&this.includes.length>0&&!this.includes.some(r=>r(I.resource.fsPath))?this.verboseLogging&&this.traceWithCorrelation(` >> ignored (not included) ${I.resource.fsPath}`):this.fileChangesAggregator.work(I))}handleFileChanges(I){const P=(0,h.coalesceEvents)(I),r=[];for(const t of P){if((0,h.isFiltered)(t,this.filter)){this.verboseLogging&&this.traceWithCorrelation(` >> ignored (filtered) ${t.resource.fsPath}`);continue}r.push(t)}if(r.length===0)return;if(this.verboseLogging)for(const t of r)this.traceWithCorrelation(` >> normalized ${t.type===f.FileChangeType.ADDED?"[ADDED]":t.type===f.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${t.resource.fsPath}`);this.throttledFileChangesEmitter.work(r)?this.throttledFileChangesEmitter.pending>0&&this.trace(`started throttling events due to large amount of file change events at once (pending: ${this.throttledFileChangesEmitter.pending}, most recent change: ${r[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.warn(`started ignoring events due to too many file change events at once (incoming: ${r.length}, most recent change: ${r[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}async existsChildStrictCase(I){if(c.isLinux)return v.Promises.exists(I);try{const P=(0,S.basename)(I);return(await v.Promises.readdir((0,S.dirname)(I))).some(a=>a===P)}catch(P){return this.trace(P),!1}}setVerboseLogging(I){this.verboseLogging=I}error(I){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"error",message:`[File Watcher (node.js)] ${I}`})}warn(I){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"warn",message:`[File Watcher (node.js)] ${I}`})}trace(I){!this.cts.token.isCancellationRequested&&this.verboseLogging&&this.onLogMessage?.({type:"trace",message:`[File Watcher (node.js)] ${I}`})}traceWithCorrelation(I){!this.cts.token.isCancellationRequested&&this.verboseLogging&&this.trace(`${I}${typeof this.request.correlationId=="number"?` <${this.request.correlationId}> `:""}`)}dispose(){this.cts.dispose(!0),super.dispose()}}e.NodeJSFileWatcherLibrary=E;async function b(g,I,P,r,a=512){const t=await v.Promises.open(g,"r"),o=Buffer.allocUnsafe(a),n=new y.CancellationTokenSource(r);let l,d=!1;const D={path:g,excludes:[],recursive:!1},w=new E(D,void 0,M=>{(async()=>{for(const{type:T}of M)if(T===f.FileChangeType.UPDATED){if(d)return;d=!0;try{for(;!n.token.isCancellationRequested;){const{bytesRead:C}=await v.Promises.read(t,o,0,a,null);if(!C||n.token.isCancellationRequested)break;I(o.slice(0,C))}}catch(C){l=new Error(C),n.dispose(!0)}finally{d=!1}}})()});return await w.ready,P(),new Promise((M,T)=>{n.token.onCancellationRequested(async()=>{w.dispose();try{await v.Promises.close(t)}catch(C){l=new Error(C)}l?T(l):M()})})}}),define(le[186],ue([0,1,4,116,184,3,185,32]),function(j,e,i,s,y,k,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class S extends y.BaseWatcher{constructor(m){super(),this.recursiveWatcher=m,this.onDidError=i.Event.None,this.watchers=new Set}async doWatch(m){m=this.removeDuplicateRequests(m);const u=[],p=new Set(Array.from(this.watchers));for(const v of m){const f=this.findWatcher(v);f&&(0,s.patternsEquals)(f.request.excludes,v.excludes)&&(0,s.patternsEquals)(f.request.includes,v.includes)?p.delete(f):u.push(v)}u.length&&this.trace(`Request to start watching: ${u.map(v=>this.requestToString(v)).join(",")}`),p.size&&this.trace(`Request to stop watching: ${Array.from(p).map(v=>this.requestToString(v.request)).join(",")}`);for(const v of p)this.stopWatching(v);for(const v of u)this.startWatching(v)}findWatcher(m){for(const u of this.watchers)if(typeof m.correlationId=="number"||typeof u.request.correlationId=="number"){if(u.request.correlationId===m.correlationId)return u}else if((0,R.isEqual)(u.request.path,m.path,!k.isLinux))return u}startWatching(m){const u=new A.NodeJSFileWatcherLibrary(m,this.recursiveWatcher,v=>this._onDidChangeFile.fire(v),()=>this._onDidWatchFail.fire(m),v=>this._onDidLogMessage.fire(v),this.verboseLogging),p={request:m,instance:u};this.watchers.add(p)}async stop(){await super.stop();for(const m of this.watchers)this.stopWatching(m)}stopWatching(m){this.trace("stopping file watcher",m),this.watchers.delete(m),m.instance.dispose()}removeDuplicateRequests(m){const u=new Map;for(const p of m){const v=k.isLinux?p.path:p.path.toLowerCase();let f=u.get(p.correlationId);f||(f=new Map,u.set(p.correlationId,f)),f.has(v)&&this.trace(`ignoring a request for watching who's path is already watched: ${this.requestToString(p)}`),f.set(v,p)}return Array.from(u.values()).map(p=>Array.from(p.values())).flat()}async setVerboseLogging(m){super.setVerboseLogging(m);for(const u of this.watchers)u.instance.setVerboseLogging(m)}trace(m,u){this.verboseLogging&&this._onDidLogMessage.fire({type:"trace",message:this.toMessage(m,u)})}warn(m){this._onDidLogMessage.fire({type:"warn",message:this.toMessage(m)})}toMessage(m,u){return u?`[File Watcher (node.js)] ${m} (${this.requestToString(u.request)})`:`[File Watcher (node.js)] ${m}`}}e.NodeJSWatcher=S}),define(le[187],ue([0,1,62,186]),function(j,e,i,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class y extends i.AbstractNonRecursiveWatcherClient{constructor(A,R,S){super(A,R,S),this.init()}createWatcher(A){return A.add(new s.NodeJSWatcher(void 0))}}e.NodeJSWatcherClient=y}),define(le[188],ue([0,1,11,45,166,62]),function(j,e,i,s,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class A extends k.AbstractUniversalWatcherClient{constructor(S,c,m){super(S,c,m),this.init()}createWatcher(S){const c=S.add(new y.Client(i.FileAccess.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return S.add(c.onDidProcessExit(({code:m,signal:u})=>this.onError(`terminated by itself with code ${m}, signal: ${u} (ETERM)`))),s.ProxyChannel.toService((0,s.getNextTickChannel)(c.getChannel("watcher")))}}e.UniversalWatcherClient=A}),define(le[101],ue([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class i{constructor(...y){this._entries=new Map;for(const[k,A]of y)this.set(k,A)}set(y,k){const A=this._entries.get(y);return this._entries.set(y,k),A}has(y){return this._entries.has(y)}get(y){return this._entries.get(y)}}e.ServiceCollection=i}),define(le[189],ue([0,1,8,15,2,84,178,6,101,111]),function(j,e,i,s,y,k,A,R,S,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const m=!1;class u extends Error{constructor(E){super("cyclic dependency between services"),this.message=E.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${E.toString()}`}}class p{constructor(E=new S.ServiceCollection,b=!1,g,I=m){this._services=E,this._strict=b,this._parent=g,this._enableTracing=I,this._isDisposed=!1,this._servicesToMaybeDispose=new Set,this._children=new Set,this._activeInstantiations=new Set,this._services.set(R.IInstantiationService,this),this._globalGraph=I?g?._globalGraph??new A.Graph(P=>P):void 0}dispose(){if(!this._isDisposed){this._isDisposed=!0,(0,y.dispose)(this._children),this._children.clear();for(const E of this._servicesToMaybeDispose)(0,y.isDisposable)(E)&&E.dispose();this._servicesToMaybeDispose.clear()}}_throwIfDisposed(){if(this._isDisposed)throw new Error("InstantiationService has been disposed")}createChild(E,b){this._throwIfDisposed();const g=this,I=new class extends p{dispose(){g._children.delete(I),super.dispose()}}(E,this._strict,this,this._enableTracing);return this._children.add(I),b?.add(I),I}invokeFunction(E,...b){this._throwIfDisposed();const g=f.traceInvocation(this._enableTracing,E);let I=!1;try{return E({get:r=>{if(I)throw(0,s.illegalState)("service accessor is only valid during the invocation of its target method");const a=this._getOrCreateServiceInstance(r,g);if(!a)throw new Error(`[invokeFunction] unknown service '${r}'`);return a}},...b)}finally{I=!0,g.stop()}}createInstance(E,...b){this._throwIfDisposed();let g,I;return E instanceof k.SyncDescriptor?(g=f.traceCreation(this._enableTracing,E.ctor),I=this._createInstance(E.ctor,E.staticArguments.concat(b),g)):(g=f.traceCreation(this._enableTracing,E),I=this._createInstance(E,b,g)),g.stop(),I}_createInstance(E,b=[],g){const I=R._util.getServiceDependencies(E).sort((a,t)=>a.index-t.index),P=[];for(const a of I){const t=this._getOrCreateServiceInstance(a.id,g);t||this._throwIfStrict(`[createInstance] ${E.name} depends on UNKNOWN service ${a.id}.`,!1),P.push(t)}const r=I.length>0?I[0].index:b.length;if(b.length!==r){console.trace(`[createInstance] First service dependency of ${E.name} at position ${r+1} conflicts with ${b.length} static arguments`);const a=r-b.length;a>0?b=b.concat(new Array(a)):b=b.slice(0,r)}return Reflect.construct(E,b.concat(P))}_setCreatedServiceInstance(E,b){if(this._services.get(E)instanceof k.SyncDescriptor)this._services.set(E,b);else if(this._parent)this._parent._setCreatedServiceInstance(E,b);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(E){const b=this._services.get(E);return!b&&this._parent?this._parent._getServiceInstanceOrDescriptor(E):b}_getOrCreateServiceInstance(E,b){this._globalGraph&&this._globalGraphImplicitDependency&&this._globalGraph.insertEdge(this._globalGraphImplicitDependency,String(E));const g=this._getServiceInstanceOrDescriptor(E);return g instanceof k.SyncDescriptor?this._safeCreateAndCacheServiceInstance(E,g,b.branch(E,!0)):(b.branch(E,!1),g)}_safeCreateAndCacheServiceInstance(E,b,g){if(this._activeInstantiations.has(E))throw new Error(`illegal state - RECURSIVELY instantiating service '${E}'`);this._activeInstantiations.add(E);try{return this._createAndCacheServiceInstance(E,b,g)}finally{this._activeInstantiations.delete(E)}}_createAndCacheServiceInstance(E,b,g){const I=new A.Graph(t=>t.id.toString());let P=0;const r=[{id:E,desc:b,_trace:g}],a=new Set;for(;r.length;){const t=r.pop();if(!a.has(String(t.id))){if(a.add(String(t.id)),I.lookupOrInsertNode(t),P++>1e3)throw new u(I);for(const o of R._util.getServiceDependencies(t.desc.ctor)){const n=this._getServiceInstanceOrDescriptor(o.id);if(n||this._throwIfStrict(`[createInstance] ${E} depends on ${o.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(o.id)),n instanceof k.SyncDescriptor){const l={id:o.id,desc:n,_trace:t._trace.branch(o.id,!0)};I.insertEdge(t,l),r.push(l)}}}}for(;;){const t=I.roots();if(t.length===0){if(!I.isEmpty())throw new u(I);break}for(const{data:o}of t){if(this._getServiceInstanceOrDescriptor(o.id)instanceof k.SyncDescriptor){const l=this._createServiceInstanceWithOwner(o.id,o.desc.ctor,o.desc.staticArguments,o.desc.supportsDelayedInstantiation,o._trace);this._setCreatedServiceInstance(o.id,l)}I.removeNode(o)}}return this._getServiceInstanceOrDescriptor(E)}_createServiceInstanceWithOwner(E,b,g=[],I,P){if(this._services.get(E)instanceof k.SyncDescriptor)return this._createServiceInstance(E,b,g,I,P,this._servicesToMaybeDispose);if(this._parent)return this._parent._createServiceInstanceWithOwner(E,b,g,I,P);throw new Error(`illegalState - creating UNKNOWN service instance ${b.name}`)}_createServiceInstance(E,b,g=[],I,P,r){if(I){const a=new p(void 0,this._strict,this,this._enableTracing);a._globalGraphImplicitDependency=String(E);const t=new Map,o=new i.GlobalIdleValue(()=>{const n=a._createInstance(b,g,P);for(const[l,d]of t){const D=n[l];if(typeof D=="function")for(const w of d)w.disposable=D.apply(n,w.listener)}return t.clear(),r.add(n),n});return new Proxy(Object.create(null),{get(n,l){if(!o.isInitialized&&typeof l=="string"&&(l.startsWith("onDid")||l.startsWith("onWill"))){let w=t.get(l);return w||(w=new c.LinkedList,t.set(l,w)),(T,C,L)=>{if(o.isInitialized)return o.value[l](T,C,L);{const _={listener:[T,C,L],disposable:void 0},V=w.push(_);return(0,y.toDisposable)(()=>{V(),_.disposable?.dispose()})}}}if(l in n)return n[l];const d=o.value;let D=d[l];return typeof D!="function"||(D=D.bind(d),n[l]=D),D},set(n,l,d){return o.value[l]=d,!0},getPrototypeOf(n){return b.prototype}})}else{const a=this._createInstance(b,g,P);return r.add(a),a}}_throwIfStrict(E,b){if(b&&console.warn(E),this._strict)throw new Error(E)}}e.InstantiationService=p;var v;(function(h){h[h.None=0]="None",h[h.Creation=1]="Creation",h[h.Invocation=2]="Invocation",h[h.Branch=3]="Branch"})(v||(v={}));class f{static{this.all=new Set}static{this._None=new class extends f{constructor(){super(v.None,null)}stop(){}branch(){return this}}}static traceInvocation(E,b){return E?new f(v.Invocation,b.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):f._None}static traceCreation(E,b){return E?new f(v.Creation,b.name):f._None}static{this._totals=0}constructor(E,b){this.type=E,this.name=b,this._start=Date.now(),this._dep=[]}branch(E,b){const g=new f(v.Branch,E.toString());return this._dep.push([E,b,g]),g}stop(){const E=Date.now()-this._start;f._totals+=E;let b=!1;function g(P,r){const a=[],t=new Array(P+1).join("	");for(const[o,n,l]of r._dep)if(n&&l){b=!0,a.push(`${t}CREATES -> ${o}`);const d=g(P+1,l);d&&a.push(d)}else a.push(`${t}uses -> ${o}`);return a.join(`
`)}const I=[`${this.type===v.Creation?"CREATE":"CALL"} ${this.name}`,`${g(1,this)}`,`DONE, took ${E.toFixed(2)}ms (grand total ${f._totals.toFixed(2)}ms)`];(E>2||b)&&f.all.add(I.join(`
`))}}e.Trace=f}),define(le[190],ue([0,1,6]),function(j,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProcessMainService=e.IIssueMainService=e.IssueSource=e.OldIssueType=void 0;var s;(function(k){k[k.Bug=0]="Bug",k[k.PerformanceIssue=1]="PerformanceIssue",k[k.FeatureRequest=2]="FeatureRequest"})(s||(e.OldIssueType=s={}));var y;(function(k){k.VSCode="vscode",k.Extension="extension",k.Marketplace="marketplace"})(y||(e.IssueSource=y={})),e.IIssueMainService=(0,i.createDecorator)("issueService"),e.IProcessMainService=(0,i.createDecorator)("processService")}),define(le[5],ue([0,1,9,55,4,48,2,31,3,18,12,7,125,6]),function(j,e,i,s,y,k,A,R,S,c,m,u,p,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_LOG_LEVEL=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.MultiplexLogger=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.isLogLevel=h,e.log=b,e.getLogLevel=D,e.LogLevelToString=w,e.LogLevelToLocalizedString=M,e.parseLogLevel=T,i=Re(i),e.ILogService=(0,v.createDecorator)("logService"),e.ILoggerService=(0,v.createDecorator)("loggerService");function f(){return new Date().toISOString()}function h(C){return(0,m.isNumber)(C)}var E;(function(C){C[C.Off=0]="Off",C[C.Trace=1]="Trace",C[C.Debug=2]="Debug",C[C.Info=3]="Info",C[C.Warning=4]="Warning",C[C.Error=5]="Error"})(E||(e.LogLevel=E={})),e.DEFAULT_LOG_LEVEL=E.Info;function b(C,L,_){switch(L){case E.Trace:C.trace(_);break;case E.Debug:C.debug(_);break;case E.Info:C.info(_);break;case E.Warning:C.warn(_);break;case E.Error:C.error(_);break;case E.Off:break;default:throw new Error(`Invalid log level ${L}`)}}function g(C,L=!1){let _="";for(let V=0;V<C.length;V++){let z=C[V];if(z instanceof Error&&(z=(0,s.toErrorMessage)(z,L)),typeof z=="object")try{z=JSON.stringify(z)}catch{}_+=(V>0?" ":"")+z}return _}class I extends A.Disposable{constructor(){super(...arguments),this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new y.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(L){this.level!==L&&(this.level=L,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}checkLogLevel(L){return this.level!==E.Off&&this.level<=L}}e.AbstractLogger=I;class P extends I{constructor(L){super(),this.logAlways=L}checkLogLevel(L){return this.logAlways||super.checkLogLevel(L)}trace(L,..._){this.checkLogLevel(E.Trace)&&this.log(E.Trace,g([L,..._],!0))}debug(L,..._){this.checkLogLevel(E.Debug)&&this.log(E.Debug,g([L,..._]))}info(L,..._){this.checkLogLevel(E.Info)&&this.log(E.Info,g([L,..._]))}warn(L,..._){this.checkLogLevel(E.Warning)&&this.log(E.Warning,g([L,..._]))}error(L,..._){if(this.checkLogLevel(E.Error))if(L instanceof Error){const V=Array.prototype.slice.call(arguments);V[0]=L.stack,this.log(E.Error,g(V))}else this.log(E.Error,g([L,..._]))}flush(){}}e.AbstractMessageLogger=P;class r extends I{constructor(L=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(L),this.useColors=!S.isWindows}trace(L,..._){this.checkLogLevel(E.Trace)&&(this.useColors?console.log(`\x1B[90m[main ${f()}]\x1B[0m`,L,..._):console.log(`[main ${f()}]`,L,..._))}debug(L,..._){this.checkLogLevel(E.Debug)&&(this.useColors?console.log(`\x1B[90m[main ${f()}]\x1B[0m`,L,..._):console.log(`[main ${f()}]`,L,..._))}info(L,..._){this.checkLogLevel(E.Info)&&(this.useColors?console.log(`\x1B[90m[main ${f()}]\x1B[0m`,L,..._):console.log(`[main ${f()}]`,L,..._))}warn(L,..._){this.checkLogLevel(E.Warning)&&(this.useColors?console.warn(`\x1B[93m[main ${f()}]\x1B[0m`,L,..._):console.warn(`[main ${f()}]`,L,..._))}error(L,..._){this.checkLogLevel(E.Error)&&(this.useColors?console.error(`\x1B[91m[main ${f()}]\x1B[0m`,L,..._):console.error(`[main ${f()}]`,L,..._))}flush(){}}e.ConsoleMainLogger=r;class a extends I{constructor(L=e.DEFAULT_LOG_LEVEL,_=!0){super(),this.useColors=_,this.setLevel(L)}trace(L,..._){this.checkLogLevel(E.Trace)&&(this.useColors?console.log("%cTRACE","color: #888",L,..._):console.log(L,..._))}debug(L,..._){this.checkLogLevel(E.Debug)&&(this.useColors?console.log("%cDEBUG","background: #eee; color: #888",L,..._):console.log(L,..._))}info(L,..._){this.checkLogLevel(E.Info)&&(this.useColors?console.log("%c INFO","color: #33f",L,..._):console.log(L,..._))}warn(L,..._){this.checkLogLevel(E.Warning)&&(this.useColors?console.log("%c WARN","color: #993",L,..._):console.log(L,..._))}error(L,..._){this.checkLogLevel(E.Error)&&(this.useColors?console.log("%c  ERR","color: #f33",L,..._):console.error(L,..._))}flush(){}}e.ConsoleLogger=a;class t extends I{constructor(L,_=e.DEFAULT_LOG_LEVEL){super(),this.adapter=L,this.setLevel(_)}trace(L,..._){this.checkLogLevel(E.Trace)&&this.adapter.log(E.Trace,[this.extractMessage(L),..._])}debug(L,..._){this.checkLogLevel(E.Debug)&&this.adapter.log(E.Debug,[this.extractMessage(L),..._])}info(L,..._){this.checkLogLevel(E.Info)&&this.adapter.log(E.Info,[this.extractMessage(L),..._])}warn(L,..._){this.checkLogLevel(E.Warning)&&this.adapter.log(E.Warning,[this.extractMessage(L),..._])}error(L,..._){this.checkLogLevel(E.Error)&&this.adapter.log(E.Error,[this.extractMessage(L),..._])}extractMessage(L){return typeof L=="string"?L:(0,s.toErrorMessage)(L,this.checkLogLevel(E.Trace))}flush(){}}e.AdapterLogger=t;class o extends I{constructor(L){super(),this.loggers=L,L.length&&this.setLevel(L[0].getLevel())}setLevel(L){for(const _ of this.loggers)_.setLevel(L);super.setLevel(L)}trace(L,..._){for(const V of this.loggers)V.trace(L,..._)}debug(L,..._){for(const V of this.loggers)V.debug(L,..._)}info(L,..._){for(const V of this.loggers)V.info(L,..._)}warn(L,..._){for(const V of this.loggers)V.warn(L,..._)}error(L,..._){for(const V of this.loggers)V.error(L,..._)}flush(){for(const L of this.loggers)L.flush()}dispose(){for(const L of this.loggers)L.dispose();super.dispose()}}e.MultiplexLogger=o;class n extends A.Disposable{constructor(L,_,V){if(super(),this.logLevel=L,this.logsHome=_,this._loggers=new R.ResourceMap,this._onDidChangeLoggers=this._register(new y.Emitter),this.onDidChangeLoggers=this._onDidChangeLoggers.event,this._onDidChangeLogLevel=this._register(new y.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event,this._onDidChangeVisibility=this._register(new y.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,V)for(const z of V)this._loggers.set(z.resource,{logger:void 0,info:z})}getLoggerEntry(L){return(0,m.isString)(L)?[...this._loggers.values()].find(_=>_.info.id===L):this._loggers.get(L)}getLogger(L){return this.getLoggerEntry(L)?.logger}createLogger(L,_){const V=this.toResource(L),z=(0,m.isString)(L)?L:_?.id??(0,k.hash)(V.toString()).toString(16);let Q=this._loggers.get(V)?.logger;const fe=_?.logLevel==="always"?E.Trace:_?.logLevel;Q||(Q=this.doCreateLogger(V,fe??this.getLogLevel(V)??this.logLevel,{..._,id:z}));const se={logger:Q,info:{resource:V,id:z,logLevel:fe,name:_?.name,hidden:_?.hidden,extensionId:_?.extensionId,when:_?.when}};return this.registerLogger(se.info),this._loggers.set(V,se),Q}toResource(L){return(0,m.isString)(L)?(0,c.joinPath)(this.logsHome,`${L}.log`):L}setLogLevel(L,_){if(u.URI.isUri(L)){const V=L,z=_,Q=this._loggers.get(V);Q&&z!==Q.info.logLevel&&(Q.info.logLevel=z===this.logLevel?void 0:z,Q.logger?.setLevel(z),this._loggers.set(Q.info.resource,Q),this._onDidChangeLogLevel.fire([V,z]))}else{this.logLevel=L;for(const[V,z]of this._loggers.entries())this._loggers.get(V)?.info.logLevel===void 0&&z.logger?.setLevel(this.logLevel);this._onDidChangeLogLevel.fire(this.logLevel)}}setVisibility(L,_){const V=this.getLoggerEntry(L);V&&_!==!V.info.hidden&&(V.info.hidden=!_,this._loggers.set(V.info.resource,V),this._onDidChangeVisibility.fire([V.info.resource,_]))}getLogLevel(L){let _;return L&&(_=this._loggers.get(L)?.info.logLevel),_??this.logLevel}registerLogger(L){const _=this._loggers.get(L.resource);_?_.info.hidden!==L.hidden&&this.setVisibility(L.resource,!L.hidden):(this._loggers.set(L.resource,{info:L,logger:void 0}),this._onDidChangeLoggers.fire({added:[L],removed:[]}))}deregisterLogger(L){const _=this._loggers.get(L);_&&(_.logger&&_.logger.dispose(),this._loggers.delete(L),this._onDidChangeLoggers.fire({added:[],removed:[_.info]}))}*getRegisteredLoggers(){for(const L of this._loggers.values())yield L.info}getRegisteredLogger(L){return this._loggers.get(L)?.info}dispose(){this._loggers.forEach(L=>L.logger?.dispose()),this._loggers.clear(),super.dispose()}}e.AbstractLoggerService=n;class l{constructor(){this.onDidChangeLogLevel=new y.Emitter().event}setLevel(L){}getLevel(){return E.Info}trace(L,..._){}debug(L,..._){}info(L,..._){}warn(L,..._){}error(L,..._){}critical(L,..._){}dispose(){}flush(){}}e.NullLogger=l;class d extends l{}e.NullLogService=d;function D(C){if(C.verbose)return E.Trace;if(typeof C.logLevel=="string"){const L=T(C.logLevel.toLowerCase());if(L!==void 0)return L}return e.DEFAULT_LOG_LEVEL}function w(C){switch(C){case E.Trace:return"trace";case E.Debug:return"debug";case E.Info:return"info";case E.Warning:return"warn";case E.Error:return"error";case E.Off:return"off"}}function M(C){switch(C){case E.Trace:return{original:"Trace",value:i.localize(1959,null)};case E.Debug:return{original:"Debug",value:i.localize(1960,null)};case E.Info:return{original:"Info",value:i.localize(1961,null)};case E.Warning:return{original:"Warning",value:i.localize(1962,null)};case E.Error:return{original:"Error",value:i.localize(1963,null)};case E.Off:return{original:"Off",value:i.localize(1964,null)}}}function T(C){switch(C){case"trace":return E.Trace;case"debug":return E.Debug;case"info":return E.Info;case"warn":return E.Warning;case"error":return E.Error;case"critical":return E.Error;case"off":return E.Off}}e.CONTEXT_LOG_LEVEL=new p.RawContextKey("logLevel",w(E.Info))});var re=this&&this.__param||function(j,e){return function(i,s){e(i,s,j)}};define(le[86],ue([0,1,44,97,66,11,60,36,6,5]),function(j,e,i,s,y,k,A,R,S,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSDevelopmentService=e.ICSSDevelopmentService=void 0,e.ICSSDevelopmentService=(0,S.createDecorator)("ICSSDevelopmentService");let m=class{constructor(p,v){this.envService=p,this.logService=v}get isEnabled(){return!this.envService.isBuilt&&y.isESM}getCssModules(){return this._cssModules??=this.computeCssModules(),this._cssModules}async computeCssModules(){if(!this.isEnabled)return[];const p=await new Promise((v,f)=>{j(["@vscode/ripgrep"],v,f)}).then(Re);return await new Promise(v=>{const f=A.StopWatch.create(),h=[],E=new TextDecoder,b=k.FileAccess.asFileUri("").fsPath,g=(0,i.spawn)(p.rgPath,["-g","**/*.css","--files","--no-ignore",b],{});g.stdout.on("data",I=>{const P=E.decode(I,{stream:!0});h.push(P.split(`
`).filter(Boolean))}),g.on("error",I=>{this.logService.error("[CSS_DEV] FAILED to compute CSS data",I),v([])}),g.on("close",()=>{const I=h.flat().map(P=>(0,s.relative)(b,P).replace(/\\/g,"/")).filter(Boolean).sort();v(I),this.logService.info(`[CSS_DEV] DONE, ${I.length} css modules (${Math.round(f.elapsed())}ms)`)})})}};e.CSSDevelopmentService=m,e.CSSDevelopmentService=m=Pe([re(0,R.IEnvironmentService),re(1,c.ILogService)],m)}),define(le[191],ue([0,1,13,3,100,5]),function(j,e,i,s,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EncryptionMainService=void 0;const A=i.safeStorage;let R=class{constructor(c){this.logService=c,i.app.commandLine.getSwitchValue("password-store")===y.PasswordStoreCLIOption.basic&&(this.logService.trace("[EncryptionMainService] setting usePlainTextEncryption to true..."),A.setUsePlainTextEncryption?.(!0),this.logService.trace("[EncryptionMainService] set usePlainTextEncryption to true"))}async encrypt(c){this.logService.trace("[EncryptionMainService] Encrypting value...");try{const m=JSON.stringify(A.encryptString(c));return this.logService.trace("[EncryptionMainService] Encrypted value."),m}catch(m){throw this.logService.error(m),m}}async decrypt(c){let m;try{if(m=JSON.parse(c),!m.data)throw new Error(`[EncryptionMainService] Invalid encrypted value: ${c}`);const u=Buffer.from(m.data);this.logService.trace("[EncryptionMainService] Decrypting value...");const p=A.decryptString(u);return this.logService.trace("[EncryptionMainService] Decrypted value."),p}catch(u){throw this.logService.error(u),u}}isEncryptionAvailable(){this.logService.trace("[EncryptionMainService] Checking if encryption is available...");const c=A.isEncryptionAvailable();return this.logService.trace("[EncryptionMainService] Encryption is available: ",c),Promise.resolve(c)}getKeyStorageProvider(){if(s.isWindows)return Promise.resolve(y.KnownStorageProvider.dplib);if(s.isMacintosh)return Promise.resolve(y.KnownStorageProvider.keychainAccess);if(A.getSelectedStorageBackend)try{this.logService.trace("[EncryptionMainService] Getting selected storage backend...");const c=A.getSelectedStorageBackend();return this.logService.trace("[EncryptionMainService] Selected storage backend: ",c),Promise.resolve(c)}catch(c){this.logService.error(c)}return Promise.resolve(y.KnownStorageProvider.unknown)}async setUsePlainTextEncryption(){if(s.isWindows)throw new Error("Setting plain text encryption is not supported on Windows.");if(s.isMacintosh)throw new Error("Setting plain text encryption is not supported on macOS.");if(!A.setUsePlainTextEncryption)throw new Error("Setting plain text encryption is not supported.");this.logService.trace("[EncryptionMainService] Setting usePlainTextEncryption to true..."),A.setUsePlainTextEncryption(!0),this.logService.trace("[EncryptionMainService] Set usePlainTextEncryption to true")}};e.EncryptionMainService=R,e.EncryptionMainService=R=Pe([re(0,k.ILogService)],R)}),define(le[192],ue([0,1,21,8,15,4,32,2,10,62,5]),function(j,e,i,s,y,k,A,R,S,c,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class u extends R.Disposable{constructor(v,f){super(),this.logService=v,this.options=f,this._onDidChangeFile=this._register(new k.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidWatchError=this._register(new k.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.universalWatchRequests=[],this.universalWatchRequestDelayer=this._register(new s.ThrottledDelayer(0)),this.nonRecursiveWatchRequests=[],this.nonRecursiveWatchRequestDelayer=this._register(new s.ThrottledDelayer(0))}watch(v,f){return f.recursive||this.options?.watcher?.forceUniversal?this.watchUniversal(v,f):this.watchNonRecursive(v,f)}watchUniversal(v,f){const h={path:this.toWatchPath(v),excludes:f.excludes,includes:f.includes,recursive:f.recursive,filter:f.filter,correlationId:f.correlationId},E=(0,i.insert)(this.universalWatchRequests,h);return this.refreshUniversalWatchers(),(0,R.toDisposable)(()=>{E(),this.refreshUniversalWatchers()})}refreshUniversalWatchers(){this.universalWatchRequestDelayer.trigger(()=>this.doRefreshUniversalWatchers()).catch(v=>(0,y.onUnexpectedError)(v))}doRefreshUniversalWatchers(){this.universalWatcher||(this.universalWatcher=this._register(this.createUniversalWatcher(f=>this._onDidChangeFile.fire((0,c.reviveFileChanges)(f)),f=>this.onWatcherLogMessage(f),this.logService.getLevel()===m.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.universalWatcher?.setVerboseLogging(this.logService.getLevel()===m.LogLevel.Trace)})));const v=this.options?.watcher?.recursive?.usePolling;if(v===!0)for(const f of this.universalWatchRequests)(0,c.isRecursiveWatchRequest)(f)&&(f.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(v))for(const f of this.universalWatchRequests)(0,c.isRecursiveWatchRequest)(f)&&v.includes(f.path)&&(f.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);return this.universalWatcher.watch(this.universalWatchRequests)}watchNonRecursive(v,f){const h={path:this.toWatchPath(v),excludes:f.excludes,includes:f.includes,recursive:!1,filter:f.filter,correlationId:f.correlationId},E=(0,i.insert)(this.nonRecursiveWatchRequests,h);return this.refreshNonRecursiveWatchers(),(0,R.toDisposable)(()=>{E(),this.refreshNonRecursiveWatchers()})}refreshNonRecursiveWatchers(){this.nonRecursiveWatchRequestDelayer.trigger(()=>this.doRefreshNonRecursiveWatchers()).catch(v=>(0,y.onUnexpectedError)(v))}doRefreshNonRecursiveWatchers(){return this.nonRecursiveWatcher||(this.nonRecursiveWatcher=this._register(this.createNonRecursiveWatcher(v=>this._onDidChangeFile.fire((0,c.reviveFileChanges)(v)),v=>this.onWatcherLogMessage(v),this.logService.getLevel()===m.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.nonRecursiveWatcher?.setVerboseLogging(this.logService.getLevel()===m.LogLevel.Trace)}))),this.nonRecursiveWatcher.watch(this.nonRecursiveWatchRequests)}onWatcherLogMessage(v){v.type==="error"&&this._onDidWatchError.fire(v.message),this.logWatcherMessage(v)}logWatcherMessage(v){this.logService[v.type](v.message)}toFilePath(v){return(0,S.normalize)(v.fsPath)}toWatchPath(v){const f=this.toFilePath(v);return(0,A.removeTrailingPathSeparator)(f)}}e.AbstractDiskFileSystemProvider=u}),define(le[193],ue([0,1,21,8,17,22,4,48,78,2,61,11,71,18,68,9,14,127,5,15]),function(j,e,i,s,y,k,A,R,S,c,m,u,p,v,f,h,E,b,g,I){"use strict";var P;Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let r=class extends c.Disposable{static{P=this}constructor(t){super(),this.logService=t,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new A.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new A.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new A.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new A.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this.internalOnDidFilesChange=this._register(new A.Emitter),this._onDidUncorrelatedFilesChange=this._register(new A.Emitter),this.onDidFilesChange=this._onDidUncorrelatedFilesChange.event,this._onDidWatchError=this._register(new A.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.activeWatchers=new Map,this.writeQueue=this._register(new s.ResourceQueue)}registerProvider(t,o){if(this.provider.has(t))throw new Error(`A filesystem provider for the scheme '${t}' is already registered.`);(0,p.mark)(`code/registerFilesystem/${t}`);const n=new c.DisposableStore;return this.provider.set(t,o),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:t,provider:o}),n.add(o.onDidChangeFile(l=>{const d=new E.FileChangesEvent(l,!this.isPathCaseSensitive(o));this.internalOnDidFilesChange.fire(d),d.hasCorrelation()||this._onDidUncorrelatedFilesChange.fire(d)})),typeof o.onDidWatchError=="function"&&n.add(o.onDidWatchError(l=>this._onDidWatchError.fire(new Error(l)))),n.add(o.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:o,scheme:t}))),(0,c.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:t,provider:o}),this.provider.delete(t),(0,c.dispose)(n)})}getProvider(t){return this.provider.get(t)}async activateProvider(t){const o=[];this._onWillActivateFileSystemProvider.fire({scheme:t,join(n){o.push(n)}}),!this.provider.has(t)&&await s.Promises.settled(o)}async canHandleResource(t){return await this.activateProvider(t.scheme),this.hasProvider(t)}hasProvider(t){return this.provider.has(t.scheme)}hasCapability(t,o){const n=this.provider.get(t.scheme);return!!(n&&n.capabilities&o)}listCapabilities(){return S.Iterable.map(this.provider,([t,o])=>({scheme:t,capabilities:o.capabilities}))}async withProvider(t){if(!(0,v.isAbsolutePath)(t))throw new E.FileOperationError((0,h.localize)(1871,null,this.resourceForError(t)),E.FileOperationResult.FILE_INVALID_PATH);await this.activateProvider(t.scheme);const o=this.provider.get(t.scheme);if(!o){const n=new I.ErrorNoTelemetry;throw n.message=(0,h.localize)(1872,null,t.toString()),n}return o}async withReadProvider(t){const o=await this.withProvider(t);if((0,E.hasOpenReadWriteCloseCapability)(o)||(0,E.hasReadWriteCapability)(o)||(0,E.hasFileReadStreamCapability)(o))return o;throw new Error(`Filesystem provider for scheme '${t.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(t){const o=await this.withProvider(t);if((0,E.hasOpenReadWriteCloseCapability)(o)||(0,E.hasReadWriteCapability)(o))return o;throw new Error(`Filesystem provider for scheme '${t.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(t,o){try{return await this.doResolveFile(t,o)}catch(n){throw(0,E.toFileSystemProviderErrorCode)(n)===E.FileSystemProviderErrorCode.FileNotFound?new E.FileOperationError((0,h.localize)(1873,null,this.resourceForError(t)),E.FileOperationResult.FILE_NOT_FOUND):(0,E.ensureFileSystemProviderError)(n)}}async doResolveFile(t,o){const n=await this.withProvider(t),l=this.isPathCaseSensitive(n),d=o?.resolveTo,D=o?.resolveSingleChildDescendants,w=o?.resolveMetadata,M=await n.stat(t);let T;return this.toFileStat(n,t,M,void 0,!!w,(C,L)=>(T||(T=m.TernarySearchTree.forUris(()=>!l),T.set(t,!0),d&&T.fill(!0,d)),T.get(C.resource)||T.findSuperstr(C.resource.with({query:null,fragment:null}))?!0:C.isDirectory&&D?L===1:!1))}async toFileStat(t,o,n,l,d,D){const{providerExtUri:w}=this.getExtUri(t),M={resource:o,name:w.basename(o),isFile:(n.type&E.FileType.File)!==0,isDirectory:(n.type&E.FileType.Directory)!==0,isSymbolicLink:(n.type&E.FileType.SymbolicLink)!==0,mtime:n.mtime,ctime:n.ctime,size:n.size,readonly:!!((n.permissions??0)&E.FilePermission.Readonly)||!!(t.capabilities&E.FileSystemProviderCapabilities.Readonly),locked:!!((n.permissions??0)&E.FilePermission.Locked),etag:(0,E.etag)({mtime:n.mtime,size:n.size}),children:void 0};if(M.isDirectory&&D(M,l)){try{const T=await t.readdir(o),C=await s.Promises.settled(T.map(async([L,_])=>{try{const V=w.joinPath(o,L),z=d?await t.stat(V):{type:_};return await this.toFileStat(t,V,z,T.length,d,D)}catch(V){return this.logService.trace(V),null}}));M.children=(0,i.coalesce)(C)}catch(T){this.logService.trace(T),M.children=[]}return M}return M}async resolveAll(t){return s.Promises.settled(t.map(async o=>{try{return{stat:await this.doResolveFile(o.resource,o.options),success:!0}}catch(n){return this.logService.trace(n),{stat:void 0,success:!1}}}))}async stat(t){const o=await this.withProvider(t),n=await o.stat(t);return this.toFileStat(o,t,n,void 0,!0,()=>!1)}async exists(t){const o=await this.withProvider(t);try{return!!await o.stat(t)}catch{return!1}}async canCreateFile(t,o){try{await this.doValidateCreateFile(t,o)}catch(n){return n}return!0}async doValidateCreateFile(t,o){if(!o?.overwrite&&await this.exists(t))throw new E.FileOperationError((0,h.localize)(1874,null,this.resourceForError(t)),E.FileOperationResult.FILE_MODIFIED_SINCE,o)}async createFile(t,o=y.VSBuffer.fromString(""),n){await this.doValidateCreateFile(t,n);const l=await this.writeFile(t,o);return this._onDidRunOperation.fire(new E.FileOperationEvent(t,E.FileOperation.CREATE,l)),l}async writeFile(t,o,n){const l=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(t),t),{providerExtUri:d}=this.getExtUri(l);let D=n;if((0,E.hasFileAtomicWriteCapability)(l)&&!D?.atomic){const w=l.enforceAtomicWriteFile?.(t);w&&(D={...n,atomic:w})}try{await this.validateWriteFile(l,t,D)||await this.mkdirp(l,d.dirname(t));let M;if((0,E.hasReadWriteCapability)(l)&&!(o instanceof y.VSBuffer))if((0,f.isReadableStream)(o)){const T=await(0,f.peekStream)(o,3);T.ended?M=y.VSBuffer.concat(T.buffer):M=T}else M=(0,f.peekReadable)(o,T=>y.VSBuffer.concat(T),3);else M=o;!(0,E.hasOpenReadWriteCloseCapability)(l)||(0,E.hasReadWriteCapability)(l)&&M instanceof y.VSBuffer||(0,E.hasReadWriteCapability)(l)&&(0,E.hasFileAtomicWriteCapability)(l)&&D?.atomic?await this.doWriteUnbuffered(l,t,D,M):await this.doWriteBuffered(l,t,D,M instanceof y.VSBuffer?(0,y.bufferToReadable)(M):M),this._onDidRunOperation.fire(new E.FileOperationEvent(t,E.FileOperation.WRITE))}catch(w){throw new E.FileOperationError((0,h.localize)(1875,null,this.resourceForError(t),(0,E.ensureFileSystemProviderError)(w).toString()),(0,E.toFileOperationResult)(w),D)}return this.resolve(t,{resolveMetadata:!0})}async validateWriteFile(t,o,n){const l=!!n?.unlock;if(l&&!(t.capabilities&E.FileSystemProviderCapabilities.FileWriteUnlock))throw new Error((0,h.localize)(1876,null,this.resourceForError(o)));if(!!n?.atomic){if(!(t.capabilities&E.FileSystemProviderCapabilities.FileAtomicWrite))throw new Error((0,h.localize)(1877,null,this.resourceForError(o)));if(!(t.capabilities&E.FileSystemProviderCapabilities.FileReadWrite))throw new Error((0,h.localize)(1878,null,this.resourceForError(o)));if(l)throw new Error((0,h.localize)(1879,null,this.resourceForError(o)))}let D;try{D=await t.stat(o)}catch{return}if(D.type&E.FileType.Directory)throw new E.FileOperationError((0,h.localize)(1880,null,this.resourceForError(o)),E.FileOperationResult.FILE_IS_DIRECTORY,n);if(this.throwIfFileIsReadonly(o,D),typeof n?.mtime=="number"&&typeof n.etag=="string"&&n.etag!==E.ETAG_DISABLED&&typeof D.mtime=="number"&&typeof D.size=="number"&&n.mtime<D.mtime&&n.etag!==(0,E.etag)({mtime:n.mtime,size:D.size}))throw new E.FileOperationError((0,h.localize)(1881,null),E.FileOperationResult.FILE_MODIFIED_SINCE,n);return D}async readFile(t,o,n){const l=await this.withReadProvider(t);return o?.atomic?this.doReadFileAtomic(l,t,o,n):this.doReadFile(l,t,o,n)}async doReadFileAtomic(t,o,n,l){return new Promise((d,D)=>{this.writeQueue.queueFor(o,async()=>{try{const w=await this.doReadFile(t,o,n,l);d(w)}catch(w){D(w)}},this.getExtUri(t).providerExtUri)})}async doReadFile(t,o,n,l){const d=await this.doReadFileStream(t,o,{...n,preferUnbuffered:!0},l);return{...d,value:await(0,y.streamToBuffer)(d.value)}}async readFileStream(t,o,n){const l=await this.withReadProvider(t);return this.doReadFileStream(l,t,o,n)}async doReadFileStream(t,o,n,l){const d=new k.CancellationTokenSource(l);let D=n;(0,E.hasFileAtomicReadCapability)(t)&&t.enforceAtomicReadFile?.(o)&&(D={...n,atomic:!0});const w=this.validateReadFile(o,D).then(T=>T,T=>{throw d.dispose(!0),T});let M;try{return typeof D?.etag=="string"&&D.etag!==E.ETAG_DISABLED&&await w,D?.atomic&&(0,E.hasFileAtomicReadCapability)(t)||!((0,E.hasOpenReadWriteCloseCapability)(t)||(0,E.hasFileReadStreamCapability)(t))||(0,E.hasReadWriteCapability)(t)&&D?.preferUnbuffered?M=this.readFileUnbuffered(t,o,D):(0,E.hasFileReadStreamCapability)(t)?M=this.readFileStreamed(t,o,d.token,D):M=this.readFileBuffered(t,o,d.token,D),M.on("end",()=>d.dispose()),M.on("error",()=>d.dispose()),{...await w,value:M}}catch(T){throw M&&await(0,f.consumeStream)(M),this.restoreReadError(T,o,D)}}restoreReadError(t,o,n){const l=(0,h.localize)(1882,null,this.resourceForError(o),(0,E.ensureFileSystemProviderError)(t).toString());return t instanceof E.NotModifiedSinceFileOperationError?new E.NotModifiedSinceFileOperationError(l,t.stat,n):t instanceof E.TooLargeFileOperationError?new E.TooLargeFileOperationError(l,t.fileOperationResult,t.size,t.options):new E.FileOperationError(l,(0,E.toFileOperationResult)(t),n)}readFileStreamed(t,o,n,l=Object.create(null)){const d=t.readFileStream(o,l,n);return(0,f.transform)(d,{data:D=>D instanceof y.VSBuffer?D:y.VSBuffer.wrap(D),error:D=>this.restoreReadError(D,o,l)},D=>y.VSBuffer.concat(D))}readFileBuffered(t,o,n,l=Object.create(null)){const d=(0,y.newWriteableBufferStream)();return(0,b.readFileIntoStream)(t,o,d,D=>D,{...l,bufferSize:this.BUFFER_SIZE,errorTransformer:D=>this.restoreReadError(D,o,l)},n),d}readFileUnbuffered(t,o,n){const l=(0,f.newWriteableStream)(d=>y.VSBuffer.concat(d));return(async()=>{try{let d;n?.atomic&&(0,E.hasFileAtomicReadCapability)(t)?d=await t.readFile(o,{atomic:!0}):d=await t.readFile(o),typeof n?.position=="number"&&(d=d.slice(n.position)),typeof n?.length=="number"&&(d=d.slice(0,n.length)),this.validateReadFileLimits(o,d.byteLength,n),l.end(y.VSBuffer.wrap(d))}catch(d){l.error(d),l.end()}})(),l}async validateReadFile(t,o){const n=await this.resolve(t,{resolveMetadata:!0});if(n.isDirectory)throw new E.FileOperationError((0,h.localize)(1883,null,this.resourceForError(t)),E.FileOperationResult.FILE_IS_DIRECTORY,o);if(typeof o?.etag=="string"&&o.etag!==E.ETAG_DISABLED&&o.etag===n.etag)throw new E.NotModifiedSinceFileOperationError((0,h.localize)(1884,null),n,o);return this.validateReadFileLimits(t,n.size,o),n}validateReadFileLimits(t,o,n){if(typeof n?.limits?.size=="number"&&o>n.limits.size)throw new E.TooLargeFileOperationError((0,h.localize)(1885,null,this.resourceForError(t)),E.FileOperationResult.FILE_TOO_LARGE,o,n)}async canMove(t,o,n){return this.doCanMoveCopy(t,o,"move",n)}async canCopy(t,o,n){return this.doCanMoveCopy(t,o,"copy",n)}async doCanMoveCopy(t,o,n,l){if(t.toString()!==o.toString())try{const d=n==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(t),t):await this.withReadProvider(t),D=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o);await this.doValidateMoveCopy(d,t,D,o,n,l)}catch(d){return d}return!0}async move(t,o,n){const l=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(t),t),d=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),D=await this.doMoveCopy(l,t,d,o,"move",!!n),w=await this.resolve(o,{resolveMetadata:!0});return this._onDidRunOperation.fire(new E.FileOperationEvent(t,D==="move"?E.FileOperation.MOVE:E.FileOperation.COPY,w)),w}async copy(t,o,n){const l=await this.withReadProvider(t),d=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),D=await this.doMoveCopy(l,t,d,o,"copy",!!n),w=await this.resolve(o,{resolveMetadata:!0});return this._onDidRunOperation.fire(new E.FileOperationEvent(t,D==="copy"?E.FileOperation.COPY:E.FileOperation.MOVE,w)),w}async doMoveCopy(t,o,n,l,d,D){if(o.toString()===l.toString())return d;const{exists:w,isSameResourceWithDifferentPathCase:M}=await this.doValidateMoveCopy(t,o,n,l,d,D);if(w&&!M&&D&&await this.del(l,{recursive:!0}),await this.mkdirp(n,this.getExtUri(n).providerExtUri.dirname(l)),d==="copy"){if(t===n&&(0,E.hasFileFolderCopyCapability)(t))await t.copy(o,l,{overwrite:D});else{const T=await this.resolve(o);T.isDirectory?await this.doCopyFolder(t,T,n,l):await this.doCopyFile(t,o,n,l)}return d}else return t===n?(await t.rename(o,l,{overwrite:D}),d):(await this.doMoveCopy(t,o,n,l,"copy",D),await this.del(o,{recursive:!0}),"copy")}async doCopyFile(t,o,n,l){if((0,E.hasOpenReadWriteCloseCapability)(t)&&(0,E.hasOpenReadWriteCloseCapability)(n))return this.doPipeBuffered(t,o,n,l);if((0,E.hasOpenReadWriteCloseCapability)(t)&&(0,E.hasReadWriteCapability)(n))return this.doPipeBufferedToUnbuffered(t,o,n,l);if((0,E.hasReadWriteCapability)(t)&&(0,E.hasOpenReadWriteCloseCapability)(n))return this.doPipeUnbufferedToBuffered(t,o,n,l);if((0,E.hasReadWriteCapability)(t)&&(0,E.hasReadWriteCapability)(n))return this.doPipeUnbuffered(t,o,n,l)}async doCopyFolder(t,o,n,l){await n.mkdir(l),Array.isArray(o.children)&&await s.Promises.settled(o.children.map(async d=>{const D=this.getExtUri(n).providerExtUri.joinPath(l,d.name);return d.isDirectory?this.doCopyFolder(t,await this.resolve(d.resource),n,D):this.doCopyFile(t,d.resource,n,D)}))}async doValidateMoveCopy(t,o,n,l,d,D){let w=!1;if(t===n){const{providerExtUri:T,isPathCaseSensitive:C}=this.getExtUri(t);if(C||(w=T.isEqual(o,l)),w&&d==="copy")throw new Error((0,h.localize)(1886,null,this.resourceForError(o),this.resourceForError(l)));if(!w&&T.isEqualOrParent(l,o))throw new Error((0,h.localize)(1887,null,this.resourceForError(o),this.resourceForError(l)))}const M=await this.exists(l);if(M&&!w){if(!D)throw new E.FileOperationError((0,h.localize)(1888,null,this.resourceForError(o),this.resourceForError(l)),E.FileOperationResult.FILE_MOVE_CONFLICT);if(t===n){const{providerExtUri:T}=this.getExtUri(t);if(T.isEqualOrParent(o,l))throw new Error((0,h.localize)(1889,null,this.resourceForError(o),this.resourceForError(l)))}}return{exists:M,isSameResourceWithDifferentPathCase:w}}getExtUri(t){const o=this.isPathCaseSensitive(t);return{providerExtUri:o?v.extUri:v.extUriIgnorePathCase,isPathCaseSensitive:o}}isPathCaseSensitive(t){return!!(t.capabilities&E.FileSystemProviderCapabilities.PathCaseSensitive)}async createFolder(t){const o=this.throwIfFileSystemIsReadonly(await this.withProvider(t),t);await this.mkdirp(o,t);const n=await this.resolve(t,{resolveMetadata:!0});return this._onDidRunOperation.fire(new E.FileOperationEvent(t,E.FileOperation.CREATE,n)),n}async mkdirp(t,o){const n=[],{providerExtUri:l}=this.getExtUri(t);for(;!l.isEqual(o,l.dirname(o));)try{if(!((await t.stat(o)).type&E.FileType.Directory))throw new Error((0,h.localize)(1890,null,this.resourceForError(o)));break}catch(d){if((0,E.toFileSystemProviderErrorCode)(d)!==E.FileSystemProviderErrorCode.FileNotFound)throw d;n.push(l.basename(o)),o=l.dirname(o)}for(let d=n.length-1;d>=0;d--){o=l.joinPath(o,n[d]);try{await t.mkdir(o)}catch(D){if((0,E.toFileSystemProviderErrorCode)(D)!==E.FileSystemProviderErrorCode.FileExists)throw D}}}async canDelete(t,o){try{await this.doValidateDelete(t,o)}catch(n){return n}return!0}async doValidateDelete(t,o){const n=this.throwIfFileSystemIsReadonly(await this.withProvider(t),t),l=!!o?.useTrash;if(l&&!(n.capabilities&E.FileSystemProviderCapabilities.Trash))throw new Error((0,h.localize)(1891,null,this.resourceForError(t)));const d=o?.atomic;if(d&&!(n.capabilities&E.FileSystemProviderCapabilities.FileAtomicDelete))throw new Error((0,h.localize)(1892,null,this.resourceForError(t)));if(l&&d)throw new Error((0,h.localize)(1893,null,this.resourceForError(t)));let D;try{D=await n.stat(t)}catch{}if(D)this.throwIfFileIsReadonly(t,D);else throw new E.FileOperationError((0,h.localize)(1894,null,this.resourceForError(t)),E.FileOperationResult.FILE_NOT_FOUND);if(!!!o?.recursive){const M=await this.resolve(t);if(M.isDirectory&&Array.isArray(M.children)&&M.children.length>0)throw new Error((0,h.localize)(1895,null,this.resourceForError(t)))}return n}async del(t,o){const n=await this.doValidateDelete(t,o);let l=o;if((0,E.hasFileAtomicDeleteCapability)(n)&&!l?.atomic){const M=n.enforceAtomicDelete?.(t);M&&(l={...o,atomic:M})}const d=!!l?.useTrash,D=!!l?.recursive,w=l?.atomic??!1;await n.delete(t,{recursive:D,useTrash:d,atomic:w}),this._onDidRunOperation.fire(new E.FileOperationEvent(t,E.FileOperation.DELETE))}async cloneFile(t,o){const n=await this.withProvider(t),l=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o);if(!(n===l&&this.getExtUri(n).providerExtUri.isEqual(t,o)))return n===l&&(0,E.hasFileCloneCapability)(n)?n.cloneFile(t,o):(await this.mkdirp(l,this.getExtUri(l).providerExtUri.dirname(o)),n===l&&(0,E.hasFileFolderCopyCapability)(n)?this.writeQueue.queueFor(t,()=>n.copy(t,o,{overwrite:!0}),this.getExtUri(n).providerExtUri):this.writeQueue.queueFor(t,()=>this.doCopyFile(n,t,l,o),this.getExtUri(n).providerExtUri))}static{this.WATCHER_CORRELATION_IDS=0}createWatcher(t,o){return this.watch(t,{...o,correlationId:P.WATCHER_CORRELATION_IDS++})}watch(t,o={recursive:!1,excludes:[]}){const n=new c.DisposableStore;let l=!1,d=()=>{l=!0};n.add((0,c.toDisposable)(()=>d())),(async()=>{try{const w=await this.doWatch(t,o);l?(0,c.dispose)(w):d=()=>(0,c.dispose)(w)}catch(w){this.logService.error(w)}})();const D=o.correlationId;if(typeof D=="number"){const w=n.add(new A.Emitter);return n.add(this.internalOnDidFilesChange.event(T=>{T.correlates(D)&&w.fire(T)})),{onDidChange:w.event,dispose:()=>n.dispose()}}return n}async doWatch(t,o){const n=await this.withProvider(t),l=(0,R.hash)([this.getExtUri(n).providerExtUri.getComparisonKey(t),o]);let d=this.activeWatchers.get(l);return d||(d={count:0,disposable:n.watch(t,o)},this.activeWatchers.set(l,d)),d.count+=1,(0,c.toDisposable)(()=>{d&&(d.count--,d.count===0&&((0,c.dispose)(d.disposable),this.activeWatchers.delete(l)))})}dispose(){super.dispose();for(const[,t]of this.activeWatchers)(0,c.dispose)(t.disposable);this.activeWatchers.clear()}async doWriteBuffered(t,o,n,l){return this.writeQueue.queueFor(o,async()=>{const d=await t.open(o,{create:!0,unlock:n?.unlock??!1});try{(0,f.isReadableStream)(l)||(0,f.isReadableBufferedStream)(l)?await this.doWriteStreamBufferedQueued(t,d,l):await this.doWriteReadableBufferedQueued(t,d,l)}catch(D){throw(0,E.ensureFileSystemProviderError)(D)}finally{await t.close(d)}},this.getExtUri(t).providerExtUri)}async doWriteStreamBufferedQueued(t,o,n){let l=0,d;if((0,f.isReadableBufferedStream)(n)){if(n.buffer.length>0){const D=y.VSBuffer.concat(n.buffer);await this.doWriteBuffer(t,o,D,D.byteLength,l,0),l+=D.byteLength}if(n.ended)return;d=n.stream}else d=n;return new Promise((D,w)=>{(0,f.listenStream)(d,{onData:async M=>{d.pause();try{await this.doWriteBuffer(t,o,M,M.byteLength,l,0)}catch(T){return w(T)}l+=M.byteLength,setTimeout(()=>d.resume())},onError:M=>w(M),onEnd:()=>D()})})}async doWriteReadableBufferedQueued(t,o,n){let l=0,d;for(;(d=n.read())!==null;)await this.doWriteBuffer(t,o,d,d.byteLength,l,0),l+=d.byteLength}async doWriteBuffer(t,o,n,l,d,D){let w=0;for(;w<l;){const M=await t.write(o,d+w,n.buffer,D+w,l-w);w+=M}}async doWriteUnbuffered(t,o,n,l){return this.writeQueue.queueFor(o,()=>this.doWriteUnbufferedQueued(t,o,n,l),this.getExtUri(t).providerExtUri)}async doWriteUnbufferedQueued(t,o,n,l){let d;l instanceof y.VSBuffer?d=l:(0,f.isReadableStream)(l)?d=await(0,y.streamToBuffer)(l):(0,f.isReadableBufferedStream)(l)?d=await(0,y.bufferedStreamToBuffer)(l):d=(0,y.readableToBuffer)(l),await t.writeFile(o,d.buffer,{create:!0,overwrite:!0,unlock:n?.unlock??!1,atomic:n?.atomic??!1})}async doPipeBuffered(t,o,n,l){return this.writeQueue.queueFor(l,()=>this.doPipeBufferedQueued(t,o,n,l),this.getExtUri(n).providerExtUri)}async doPipeBufferedQueued(t,o,n,l){let d,D;try{d=await t.open(o,{create:!1}),D=await n.open(l,{create:!0,unlock:!1});const w=y.VSBuffer.alloc(this.BUFFER_SIZE);let M=0,T=0,C=0;do C=await t.read(d,M,w.buffer,T,w.byteLength-T),await this.doWriteBuffer(n,D,w,C,M,T),M+=C,T+=C,T===w.byteLength&&(T=0);while(C>0)}catch(w){throw(0,E.ensureFileSystemProviderError)(w)}finally{await s.Promises.settled([typeof d=="number"?t.close(d):Promise.resolve(),typeof D=="number"?n.close(D):Promise.resolve()])}}async doPipeUnbuffered(t,o,n,l){return this.writeQueue.queueFor(l,()=>this.doPipeUnbufferedQueued(t,o,n,l),this.getExtUri(n).providerExtUri)}async doPipeUnbufferedQueued(t,o,n,l){return n.writeFile(l,await t.readFile(o),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async doPipeUnbufferedToBuffered(t,o,n,l){return this.writeQueue.queueFor(l,()=>this.doPipeUnbufferedToBufferedQueued(t,o,n,l),this.getExtUri(n).providerExtUri)}async doPipeUnbufferedToBufferedQueued(t,o,n,l){const d=await n.open(l,{create:!0,unlock:!1});try{const D=await t.readFile(o);await this.doWriteBuffer(n,d,y.VSBuffer.wrap(D),D.byteLength,0,0)}catch(D){throw(0,E.ensureFileSystemProviderError)(D)}finally{await n.close(d)}}async doPipeBufferedToUnbuffered(t,o,n,l){const d=await(0,y.streamToBuffer)(this.readFileBuffered(t,o,k.CancellationToken.None));await this.doWriteUnbuffered(n,l,void 0,d)}throwIfFileSystemIsReadonly(t,o){if(t.capabilities&E.FileSystemProviderCapabilities.Readonly)throw new E.FileOperationError((0,h.localize)(1896,null,this.resourceForError(o)),E.FileOperationResult.FILE_PERMISSION_DENIED);return t}throwIfFileIsReadonly(t,o){if((o.permissions??0)&E.FilePermission.Readonly)throw new E.FileOperationError((0,h.localize)(1897,null,this.resourceForError(t)),E.FileOperationResult.FILE_PERMISSION_DENIED)}resourceForError(t){return t.scheme===u.Schemas.file?t.fsPath:t.toString(!0)}};e.FileService=r,e.FileService=r=P=Pe([re(0,g.ILogService)],r)}),define(le[102],ue([0,1,26,8,31,17,4,32,2,10,3,18,68,23,9,14,127,192,188,187]),function(j,e,i,s,y,k,A,R,S,c,m,u,p,v,f,h,E,b,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0;class P extends b.AbstractDiskFileSystemProvider{static{this.TRACE_LOG_RESOURCE_LOCKS=!1}constructor(a,t){super(a,t),this.onDidChangeCapabilities=A.Event.None,this.resourceLocks=new y.ResourceMap(o=>u.extUriBiasedIgnorePathCase.getComparisonKey(o)),this.mapHandleToPos=new Map,this.mapHandleToLock=new Map,this.writeHandles=new Map}get capabilities(){return this._capabilities||(this._capabilities=h.FileSystemProviderCapabilities.FileReadWrite|h.FileSystemProviderCapabilities.FileOpenReadWriteClose|h.FileSystemProviderCapabilities.FileReadStream|h.FileSystemProviderCapabilities.FileFolderCopy|h.FileSystemProviderCapabilities.FileWriteUnlock|h.FileSystemProviderCapabilities.FileAtomicRead|h.FileSystemProviderCapabilities.FileAtomicWrite|h.FileSystemProviderCapabilities.FileAtomicDelete|h.FileSystemProviderCapabilities.FileClone,m.isLinux&&(this._capabilities|=h.FileSystemProviderCapabilities.PathCaseSensitive)),this._capabilities}async stat(a){try{const{stat:t,symbolicLink:o}=await v.SymlinkSupport.stat(this.toFilePath(a));return{type:this.toType(t,o),ctime:t.birthtime.getTime(),mtime:t.mtime.getTime(),size:t.size,permissions:t.mode&128?void 0:h.FilePermission.Locked}}catch(t){throw this.toFileSystemProviderError(t)}}async statIgnoreError(a){try{return await this.stat(a)}catch{return}}async readdir(a){try{const t=await v.Promises.readdir(this.toFilePath(a),{withFileTypes:!0}),o=[];return await Promise.all(t.map(async n=>{try{let l;n.isSymbolicLink()?l=(await this.stat((0,u.joinPath)(a,n.name))).type:l=this.toType(n),o.push([n.name,l])}catch(l){this.logService.trace(l)}})),o}catch(t){throw this.toFileSystemProviderError(t)}}toType(a,t){let o;return t?.dangling?o=h.FileType.Unknown:a.isFile()?o=h.FileType.File:a.isDirectory()?o=h.FileType.Directory:o=h.FileType.Unknown,t&&(o|=h.FileType.SymbolicLink),o}async createResourceLock(a){const t=this.toFilePath(a);this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${t})`);let o;for(;o=this.resourceLocks.get(a);)this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${t})`),await o.wait();const n=new s.Barrier;return this.resourceLocks.set(a,n),this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${t})`),(0,S.toDisposable)(()=>{this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${t})`),this.resourceLocks.get(a)===n&&(this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${t})`),this.resourceLocks.delete(a)),this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${t})`),n.open()})}async readFile(a,t){let o;try{t?.atomic&&(this.traceLock(`[Disk FileSystemProvider]: atomic read operation started (${this.toFilePath(a)})`),o=await this.createResourceLock(a));const n=this.toFilePath(a);return await i.promises.readFile(n)}catch(n){throw this.toFileSystemProviderError(n)}finally{o?.dispose()}}traceLock(a){P.TRACE_LOG_RESOURCE_LOCKS&&this.logService.trace(a)}readFileStream(a,t,o){const n=(0,p.newWriteableStream)(l=>k.VSBuffer.concat(l.map(d=>k.VSBuffer.wrap(d))).buffer);return(0,E.readFileIntoStream)(this,a,n,l=>l.buffer,{...t,bufferSize:256*1024},o),n}async writeFile(a,t,o){return o?.atomic!==!1&&o?.atomic?.postfix&&await this.canWriteFileAtomic(a)?this.doWriteFileAtomic(a,(0,u.joinPath)((0,u.dirname)(a),`${(0,u.basename)(a)}${o.atomic.postfix}`),t,o):this.doWriteFile(a,t,o)}async canWriteFileAtomic(a){try{const t=this.toFilePath(a),{symbolicLink:o}=await v.SymlinkSupport.stat(t);if(o)return!1}catch{}return!0}async doWriteFileAtomic(a,t,o,n){const l=new S.DisposableStore;try{l.add(await this.createResourceLock(a)),l.add(await this.createResourceLock(t)),await this.doWriteFile(t,o,n,!0);try{await this.rename(t,a,{overwrite:!0})}catch(d){try{await this.delete(t,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw d}}finally{l.dispose()}}async doWriteFile(a,t,o,n){let l;try{const d=this.toFilePath(a);if(!o.create||!o.overwrite){if(await v.Promises.exists(d)){if(!o.overwrite)throw(0,h.createFileSystemProviderError)((0,f.localize)(1901,null),h.FileSystemProviderErrorCode.FileExists)}else if(!o.create)throw(0,h.createFileSystemProviderError)((0,f.localize)(1902,null),h.FileSystemProviderErrorCode.FileNotFound)}l=await this.open(a,{create:!0,unlock:o.unlock},n),await this.write(l,0,t,0,t.byteLength)}catch(d){throw await this.toFileSystemProviderWriteError(a,d)}finally{typeof l=="number"&&await this.close(l)}}static{this.canFlush=!0}static configureFlushOnWrite(a){P.canFlush=a}async open(a,t,o){const n=this.toFilePath(a);let l;(0,h.isFileOpenForWriteOptions)(t)&&!o&&(l=await this.createResourceLock(a));let d;try{if((0,h.isFileOpenForWriteOptions)(t)&&t.unlock)try{const{stat:w}=await v.SymlinkSupport.stat(n);w.mode&128||await i.promises.chmod(n,w.mode|128)}catch(w){w.code!=="ENOENT"&&this.logService.trace(w)}let D;if((0,h.isFileOpenForWriteOptions)(t)){if(m.isWindows)try{await i.promises.truncate(n,0),D="r+"}catch(w){w.code!=="ENOENT"&&this.logService.trace(w)}D||(D="w")}else D="r";d=await v.Promises.open(n,D)}catch(D){throw l?.dispose(),(0,h.isFileOpenForWriteOptions)(t)?await this.toFileSystemProviderWriteError(a,D):this.toFileSystemProviderError(D)}if(this.mapHandleToPos.set(d,0),(0,h.isFileOpenForWriteOptions)(t)&&this.writeHandles.set(d,a),l){const D=this.mapHandleToLock.get(d);this.traceLock(`[Disk FileSystemProvider]: open() - storing lock for handle ${d} (${n})`),this.mapHandleToLock.set(d,l),D&&(this.traceLock(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${d} (${n})`),D.dispose())}return d}async close(a){const t=this.mapHandleToLock.get(a);try{if(this.mapHandleToPos.delete(a),this.writeHandles.delete(a)&&P.canFlush)try{await v.Promises.fdatasync(a)}catch(o){P.configureFlushOnWrite(!1),this.logService.error(o)}return await v.Promises.close(a)}catch(o){throw this.toFileSystemProviderError(o)}finally{t&&(this.mapHandleToLock.get(a)===t&&(this.traceLock(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${a}`),this.mapHandleToLock.delete(a)),this.traceLock(`[Disk FileSystemProvider]: close() - disposing lock for handle ${a}`),t.dispose())}}async read(a,t,o,n,l){const d=this.normalizePos(a,t);let D=null;try{D=(await v.Promises.read(a,o,n,l,d)).bytesRead}catch(w){throw this.toFileSystemProviderError(w)}finally{this.updatePos(a,d,D)}return D}normalizePos(a,t){return t===this.mapHandleToPos.get(a)?null:t}updatePos(a,t,o){const n=this.mapHandleToPos.get(a);typeof n=="number"&&(typeof t=="number"||(typeof o=="number"?this.mapHandleToPos.set(a,n+o):this.mapHandleToPos.delete(a)))}async write(a,t,o,n,l){return(0,s.retry)(()=>this.doWrite(a,t,o,n,l),100,3)}async doWrite(a,t,o,n,l){const d=this.normalizePos(a,t);let D=null;try{D=(await v.Promises.write(a,o,n,l,d)).bytesWritten}catch(w){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(a),w)}finally{this.updatePos(a,d,D)}return D}async mkdir(a){try{await i.promises.mkdir(this.toFilePath(a))}catch(t){throw this.toFileSystemProviderError(t)}}async delete(a,t){try{const o=this.toFilePath(a);if(t.recursive){let n;t?.atomic!==!1&&t.atomic.postfix&&(n=(0,c.join)((0,c.dirname)(o),`${(0,c.basename)(o)}${t.atomic.postfix}`)),await v.Promises.rm(o,v.RimRafMode.MOVE,n)}else try{await i.promises.unlink(o)}catch(n){if(n.code==="EPERM"||n.code==="EISDIR"){let l=!1;try{const{stat:d,symbolicLink:D}=await v.SymlinkSupport.stat(o);l=d.isDirectory()&&!D}catch{}if(l)await i.promises.rmdir(o);else throw n}else throw n}}catch(o){throw this.toFileSystemProviderError(o)}}async rename(a,t,o){const n=this.toFilePath(a),l=this.toFilePath(t);if(n!==l)try{await this.validateMoveCopy(a,t,"move",o.overwrite),await v.Promises.rename(n,l)}catch(d){throw(d.code==="EINVAL"||d.code==="EBUSY"||d.code==="ENAMETOOLONG")&&(d=new Error((0,f.localize)(1903,null,(0,c.basename)(n),(0,c.basename)((0,c.dirname)(l)),d.toString()))),this.toFileSystemProviderError(d)}}async copy(a,t,o){const n=this.toFilePath(a),l=this.toFilePath(t);if(n!==l)try{await this.validateMoveCopy(a,t,"copy",o.overwrite),await v.Promises.copy(n,l,{preserveSymlinks:!0})}catch(d){throw(d.code==="EINVAL"||d.code==="EBUSY"||d.code==="ENAMETOOLONG")&&(d=new Error((0,f.localize)(1904,null,(0,c.basename)(n),(0,c.basename)((0,c.dirname)(l)),d.toString()))),this.toFileSystemProviderError(d)}}async validateMoveCopy(a,t,o,n){const l=this.toFilePath(a),d=this.toFilePath(t);let D=!1;if(!!(this.capabilities&h.FileSystemProviderCapabilities.PathCaseSensitive)||(D=(0,R.isEqual)(l,d,!0)),D){if(o==="copy")throw(0,h.createFileSystemProviderError)((0,f.localize)(1905,null),h.FileSystemProviderErrorCode.FileExists);if(o==="move")return}const M=await this.statIgnoreError(a);if(!M)throw(0,h.createFileSystemProviderError)((0,f.localize)(1906,null),h.FileSystemProviderErrorCode.FileNotFound);const T=await this.statIgnoreError(t);if(T){if(!n)throw(0,h.createFileSystemProviderError)((0,f.localize)(1907,null),h.FileSystemProviderErrorCode.FileExists);M.type&h.FileType.File&&T.type&h.FileType.File||await this.delete(t,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(a,t){return this.doCloneFile(a,t,!1)}async doCloneFile(a,t,o){const n=this.toFilePath(a),l=this.toFilePath(t),d=!!(this.capabilities&h.FileSystemProviderCapabilities.PathCaseSensitive);if((0,R.isEqual)(n,l,!d))return;const D=new S.DisposableStore;try{D.add(await this.createResourceLock(a)),D.add(await this.createResourceLock(t)),o&&await i.promises.mkdir((0,c.dirname)(l),{recursive:!0}),await i.promises.copyFile(n,l)}catch(w){if(w.code==="ENOENT"&&!o)return this.doCloneFile(a,t,!0);throw this.toFileSystemProviderError(w)}finally{D.dispose()}}createUniversalWatcher(a,t,o){return new g.UniversalWatcherClient(n=>a(n),n=>t(n),o)}createNonRecursiveWatcher(a,t,o){return new I.NodeJSWatcherClient(n=>a(n),n=>t(n),o)}toFileSystemProviderError(a){if(a instanceof h.FileSystemProviderError)return a;let t=a,o;switch(a.code){case"ENOENT":o=h.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":o=h.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":o=h.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":o=h.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":o=h.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":t=`${a.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,o=h.FileSystemProviderErrorCode.Unknown;break;default:o=h.FileSystemProviderErrorCode.Unknown}return(0,h.createFileSystemProviderError)(t,o)}async toFileSystemProviderWriteError(a,t){let o=this.toFileSystemProviderError(t);if(a&&o.code===h.FileSystemProviderErrorCode.NoPermissions)try{const{stat:n}=await v.SymlinkSupport.stat(this.toFilePath(a));n.mode&128||(o=(0,h.createFileSystemProviderError)(t,h.FileSystemProviderErrorCode.FileWriteLocked))}catch(n){this.logService.trace(n)}return o}}e.DiskFileSystemProvider=P}),define(le[194],ue([0,1,4,102,2,17,68,22]),function(j,e,i,s,y,k,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractSessionFileWatcher=e.AbstractDiskFileSystemProviderChannel=void 0;class S extends y.Disposable{constructor(u,p){super(),this.provider=u,this.logService=p,this.sessionToWatcher=new Map,this.watchRequests=new Map}call(u,p,v){const f=this.getUriTransformer(u);switch(p){case"stat":return this.stat(f,v[0]);case"readdir":return this.readdir(f,v[0]);case"open":return this.open(f,v[0],v[1]);case"close":return this.close(v[0]);case"read":return this.read(v[0],v[1],v[2]);case"readFile":return this.readFile(f,v[0],v[1]);case"write":return this.write(v[0],v[1],v[2],v[3],v[4]);case"writeFile":return this.writeFile(f,v[0],v[1],v[2]);case"rename":return this.rename(f,v[0],v[1],v[2]);case"copy":return this.copy(f,v[0],v[1],v[2]);case"cloneFile":return this.cloneFile(f,v[0],v[1]);case"mkdir":return this.mkdir(f,v[0]);case"delete":return this.delete(f,v[0],v[1]);case"watch":return this.watch(f,v[0],v[1],v[2],v[3]);case"unwatch":return this.unwatch(v[0],v[1])}throw new Error(`IPC Command ${p} not found`)}listen(u,p,v){const f=this.getUriTransformer(u);switch(p){case"fileChange":return this.onFileChange(f,v[0]);case"readFileStream":return this.onReadFileStream(f,v[0],v[1])}throw new Error(`Unknown event ${p}`)}stat(u,p){const v=this.transformIncoming(u,p,!0);return this.provider.stat(v)}readdir(u,p){const v=this.transformIncoming(u,p);return this.provider.readdir(v)}async readFile(u,p,v){const f=this.transformIncoming(u,p,!0),h=await this.provider.readFile(f,v);return k.VSBuffer.wrap(h)}onReadFileStream(u,p,v){const f=this.transformIncoming(u,p,!0),h=new R.CancellationTokenSource,E=new i.Emitter({onDidRemoveLastListener:()=>{h.cancel()}}),b=this.provider.readFileStream(f,v,h.token);return(0,A.listenStream)(b,{onData:g=>E.fire(k.VSBuffer.wrap(g)),onError:g=>E.fire(g),onEnd:()=>{E.fire("end"),E.dispose(),h.dispose()}}),E.event}writeFile(u,p,v,f){const h=this.transformIncoming(u,p);return this.provider.writeFile(h,v.buffer,f)}open(u,p,v){const f=this.transformIncoming(u,p,!0);return this.provider.open(f,v)}close(u){return this.provider.close(u)}async read(u,p,v){const f=k.VSBuffer.alloc(v),E=await this.provider.read(u,p,f.buffer,0,v);return[f,E]}write(u,p,v,f,h){return this.provider.write(u,p,v.buffer,f,h)}mkdir(u,p){const v=this.transformIncoming(u,p);return this.provider.mkdir(v)}delete(u,p,v){const f=this.transformIncoming(u,p);return this.provider.delete(f,v)}rename(u,p,v,f){const h=this.transformIncoming(u,p),E=this.transformIncoming(u,v);return this.provider.rename(h,E,f)}copy(u,p,v,f){const h=this.transformIncoming(u,p),E=this.transformIncoming(u,v);return this.provider.copy(h,E,f)}cloneFile(u,p,v){const f=this.transformIncoming(u,p),h=this.transformIncoming(u,v);return this.provider.cloneFile(f,h)}onFileChange(u,p){const v=new i.Emitter({onWillAddFirstListener:()=>{this.sessionToWatcher.set(p,this.createSessionFileWatcher(u,v))},onDidRemoveLastListener:()=>{(0,y.dispose)(this.sessionToWatcher.get(p)),this.sessionToWatcher.delete(p)}});return v.event}async watch(u,p,v,f,h){const E=this.sessionToWatcher.get(p);if(E){const b=this.transformIncoming(u,f),g=E.watch(v,b,h);this.watchRequests.set(p+v,g)}}async unwatch(u,p){const v=u+p,f=this.watchRequests.get(v);f&&((0,y.dispose)(f),this.watchRequests.delete(v))}dispose(){super.dispose();for(const[,u]of this.watchRequests)u.dispose();this.watchRequests.clear();for(const[,u]of this.sessionToWatcher)u.dispose();this.sessionToWatcher.clear()}}e.AbstractDiskFileSystemProviderChannel=S;class c extends y.Disposable{constructor(u,p,v,f){super(),this.uriTransformer=u,this.logService=v,this.environmentService=f,this.watcherRequests=new Map,this.fileWatcher=this._register(new s.DiskFileSystemProvider(this.logService,{watcher:{recursive:this.getRecursiveWatcherOptions(this.environmentService)}})),this.registerListeners(p)}registerListeners(u){const p=this._register(new i.Emitter);this._register(p.event(v=>{u.fire(v.map(f=>({resource:this.uriTransformer.transformOutgoingURI(f.resource),type:f.type,cId:f.cId})))})),this._register(this.fileWatcher.onDidChangeFile(v=>p.fire(v))),this._register(this.fileWatcher.onDidWatchError(v=>u.fire(v)))}getRecursiveWatcherOptions(u){}getExtraExcludes(u){}watch(u,p,v){const f=this.getExtraExcludes(this.environmentService);return Array.isArray(f)&&(v.excludes=[...v.excludes,...f]),this.watcherRequests.set(u,this.fileWatcher.watch(p,v)),(0,y.toDisposable)(()=>{(0,y.dispose)(this.watcherRequests.get(u)),this.watcherRequests.delete(u)})}dispose(){for(const[,u]of this.watcherRequests)u.dispose();this.watcherRequests.clear(),super.dispose()}}e.AbstractSessionFileWatcher=c}),define(le[195],ue([0,1,13,9,3,7,14,10,194,161,55]),function(j,e,i,s,y,k,A,R,S,c,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderChannel=void 0;class u extends S.AbstractDiskFileSystemProviderChannel{constructor(f,h,E){super(f,h),this.environmentService=E}getUriTransformer(f){return c.DefaultURITransformer}transformIncoming(f,h){return k.URI.revive(h)}async delete(f,h,E){if(!E.useTrash)return super.delete(f,h,E);const b=this.transformIncoming(f,h),g=(0,R.normalize)(b.fsPath);try{await i.shell.trashItem(g)}catch(I){throw(0,A.createFileSystemProviderError)(y.isWindows?(0,s.localize)(1899,null,(0,R.basename)(g),(0,m.toErrorMessage)(I)):(0,s.localize)(1900,null,(0,R.basename)(g),(0,m.toErrorMessage)(I)),A.FileSystemProviderErrorCode.Unknown)}}createSessionFileWatcher(f,h){return new p(f,h,this.logService,this.environmentService)}}e.DiskFileSystemProviderChannel=u;class p extends S.AbstractSessionFileWatcher{watch(f,h,E){if(E.recursive)throw(0,A.createFileSystemProviderError)("Recursive file watching is not supported from main process for performance reasons.",A.FileSystemProviderErrorCode.Unavailable);return super.watch(f,h,E)}}}),define(le[196],ue([0,1,5]),function(j,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BufferLogger=void 0;class s extends i.AbstractMessageLogger{constructor(k=i.DEFAULT_LOG_LEVEL){super(),this.buffer=[],this._logger=void 0,this.setLevel(k),this._register(this.onDidChangeLogLevel(A=>{this._logger?.setLevel(A)}))}set logger(k){this._logger=k;for(const{level:A,message:R}of this.buffer)(0,i.log)(k,A,R);this.buffer=[]}log(k,A){this._logger?(0,i.log)(this._logger,k,A):this.getLevel()<=k&&this.buffer.push({level:k,message:A})}dispose(){this._logger?.dispose(),super.dispose()}flush(){this._logger?.flush()}}e.BufferLogger=s}),define(le[197],ue([0,1,7,4,5,2]),function(j,e,i,s,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteLoggerChannelClient=e.LoggerChannel=e.LoggerChannelClient=void 0;class A extends y.AbstractLoggerService{constructor(u,p,v,f,h){super(p,v,f),this.windowId=u,this.channel=h,this._register(h.listen("onDidChangeLogLevel",u)(E=>{(0,y.isLogLevel)(E)?super.setLogLevel(E):super.setLogLevel(i.URI.revive(E[0]),E[1])})),this._register(h.listen("onDidChangeVisibility",u)(([E,b])=>super.setVisibility(i.URI.revive(E),b))),this._register(h.listen("onDidChangeLoggers",u)(({added:E,removed:b})=>{for(const g of E)super.registerLogger({...g,resource:i.URI.revive(g.resource)});for(const g of b)super.deregisterLogger(g.resource)}))}createConsoleMainLogger(){return new y.AdapterLogger({log:(u,p)=>{this.channel.call("consoleLog",[u,p])}})}registerLogger(u){super.registerLogger(u),this.channel.call("registerLogger",[u,this.windowId])}deregisterLogger(u){super.deregisterLogger(u),this.channel.call("deregisterLogger",[u,this.windowId])}setLogLevel(u,p){super.setLogLevel(u,p),this.channel.call("setLogLevel",[u,p])}setVisibility(u,p){super.setVisibility(u,p),this.channel.call("setVisibility",[this.toResource(u),p])}doCreateLogger(u,p,v){return new R(this.channel,u,p,v,this.windowId)}static setLogLevel(u,p,v){return u.call("setLogLevel",[p,v])}}e.LoggerChannelClient=A;class R extends y.AbstractMessageLogger{constructor(u,p,v,f,h){super(f?.logLevel==="always"),this.channel=u,this.file=p,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(v),this.channel.call("createLogger",[p,f,h]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(u,p){const v=[[u,p]];this.isLoggerCreated?this.doLog(v):this.buffer.push(...v)}doLog(u){this.channel.call("log",[this.file,u])}}class S{constructor(u,p){this.loggerService=u,this.getUriTransformer=p}listen(u,p){const v=this.getUriTransformer(u);switch(p){case"onDidChangeLoggers":return s.Event.map(this.loggerService.onDidChangeLoggers,f=>({added:[...f.added].map(h=>this.transformLogger(h,v)),removed:[...f.removed].map(h=>this.transformLogger(h,v))}));case"onDidChangeVisibility":return s.Event.map(this.loggerService.onDidChangeVisibility,f=>[v.transformOutgoingURI(f[0]),f[1]]);case"onDidChangeLogLevel":return s.Event.map(this.loggerService.onDidChangeLogLevel,f=>(0,y.isLogLevel)(f)?f:[v.transformOutgoingURI(f[0]),f[1]])}throw new Error(`Event not found: ${p}`)}async call(u,p,v){const f=this.getUriTransformer(u);switch(p){case"setLogLevel":return(0,y.isLogLevel)(v[0])?this.loggerService.setLogLevel(v[0]):this.loggerService.setLogLevel(i.URI.revive(f.transformIncoming(v[0][0])),v[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.loggerService.getRegisteredLoggers()].map(h=>this.transformLogger(h,f)))}throw new Error(`Call not found: ${p}`)}transformLogger(u,p){return{...u,resource:p.transformOutgoingURI(u.resource)}}}e.LoggerChannel=S;class c extends k.Disposable{constructor(u,p){super(),p.call("setLogLevel",[u.getLogLevel()]),this._register(u.onDidChangeLogLevel(v=>p.call("setLogLevel",[v]))),p.call("getRegisteredLoggers").then(v=>{for(const f of v)u.registerLogger({...f,resource:i.URI.revive(f.resource)})}),this._register(p.listen("onDidChangeVisibility")(([v,f])=>u.setVisibility(i.URI.revive(v),f))),this._register(p.listen("onDidChangeLoggers")(({added:v,removed:f})=>{for(const h of v)u.registerLogger({...h,resource:i.URI.revive(h.resource)});for(const h of f)u.deregisterLogger(h.resource)}))}}e.RemoteLoggerChannelClient=c}),define(le[198],ue([0,1,2,5]),function(j,e,i,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogService=void 0;class y extends i.Disposable{constructor(A,R=[]){super(),this.logger=new s.MultiplexLogger([A,...R]),this._register(A.onDidChangeLogLevel(S=>this.setLevel(S)))}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(A){this.logger.setLevel(A)}getLevel(){return this.logger.getLevel()}trace(A,...R){this.logger.trace(A,...R)}debug(A,...R){this.logger.debug(A,...R)}info(A,...R){this.logger.info(A,...R)}warn(A,...R){this.logger.warn(A,...R)}error(A,...R){this.logger.error(A,...R)}flush(){this.logger.flush()}}e.LogService=y}),define(le[199],ue([0,1,31,7,5]),function(j,e,i,s,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerChannel=void 0;class k{constructor(R){this.loggerService=R,this.loggers=new i.ResourceMap}listen(R,S,c){switch(S){case"onDidChangeLoggers":return c?this.loggerService.getOnDidChangeLoggersEvent(c):this.loggerService.onDidChangeLoggers;case"onDidChangeLogLevel":return c?this.loggerService.getOnDidChangeLogLevelEvent(c):this.loggerService.onDidChangeLogLevel;case"onDidChangeVisibility":return c?this.loggerService.getOnDidChangeVisibilityEvent(c):this.loggerService.onDidChangeVisibility}throw new Error(`Event not found: ${S}`)}async call(R,S,c){switch(S){case"createLogger":this.createLogger(s.URI.revive(c[0]),c[1],c[2]);return;case"log":return this.log(s.URI.revive(c[0]),c[1]);case"consoleLog":return this.consoleLog(c[0],c[1]);case"setLogLevel":return(0,y.isLogLevel)(c[0])?this.loggerService.setLogLevel(c[0]):this.loggerService.setLogLevel(s.URI.revive(c[0]),c[1]);case"setVisibility":return this.loggerService.setVisibility(s.URI.revive(c[0]),c[1]);case"registerLogger":return this.loggerService.registerLogger({...c[0],resource:s.URI.revive(c[0].resource)},c[1]);case"deregisterLogger":return this.loggerService.deregisterLogger(s.URI.revive(c[0]))}throw new Error(`Call not found: ${S}`)}createLogger(R,S,c){this.loggers.set(R,this.loggerService.createLogger(R,S,c))}consoleLog(R,S){let c=console.log;switch(R){case y.LogLevel.Error:c=console.error;break;case y.LogLevel.Warning:c=console.warn;break;case y.LogLevel.Info:c=console.info;break}c.call(console,...S)}log(R,S){const c=this.loggers.get(R);if(!c)throw new Error("Create the logger before logging");for(const[m,u]of S)(0,y.log)(c,m,u)}}e.LoggerChannel=k}),define(le[200],ue([0,1,14,5]),function(j,e,i,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;var y;(function(c){c[c.Trace=0]="Trace",c[c.Debug=1]="Debug",c[c.Info=2]="Info",c[c.Warning=3]="Warning",c[c.Error=4]="Error",c[c.Critical=5]="Critical",c[c.Off=6]="Off"})(y||(y={}));async function k(c,m,u,p,v){try{const f=await new Promise((E,b)=>{j(["@vscode/spdlog"],E,b)}).then(Re);f.setFlushOn(y.Trace);const h=await f.createAsyncRotatingLogger(c,m,u,p);return v?h.clearFormatters():h.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),h}catch(f){console.error(f)}return null}function A(c,m,u){switch(m){case s.LogLevel.Trace:c.trace(u);break;case s.LogLevel.Debug:c.debug(u);break;case s.LogLevel.Info:c.info(u);break;case s.LogLevel.Warning:c.warn(u);break;case s.LogLevel.Error:c.error(u);break;case s.LogLevel.Off:break;default:throw new Error(`Invalid log level ${m}`)}}function R(c,m){switch(m){case s.LogLevel.Trace:c.setLevel(y.Trace);break;case s.LogLevel.Debug:c.setLevel(y.Debug);break;case s.LogLevel.Info:c.setLevel(y.Info);break;case s.LogLevel.Warning:c.setLevel(y.Warning);break;case s.LogLevel.Error:c.setLevel(y.Error);break;case s.LogLevel.Off:c.setLevel(y.Off);break;default:throw new Error(`Invalid log level ${m}`)}}class S extends s.AbstractMessageLogger{constructor(m,u,p,v,f){super(),this.buffer=[],this.setLevel(f),this._loggerCreationPromise=this._createSpdLogLogger(m,u,p,v),this._register(this.onDidChangeLogLevel(h=>{this._logger&&R(this._logger,h)}))}async _createSpdLogLogger(m,u,p,v){const f=p?6:1,h=30/f*i.ByteSize.MB,E=await k(m,u,h,f,v);if(E){this._logger=E,R(this._logger,this.getLevel());for(const{level:b,message:g}of this.buffer)A(this._logger,b,g);this.buffer=[]}}log(m,u){this._logger?A(this._logger,m,u):this.getLevel()<=m&&this.buffer.push({level:m,message:u})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger()),super.dispose()}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=S}),define(le[201],ue([0,1,33,5,200]),function(j,e,i,s,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerService=void 0;class k extends s.AbstractLoggerService{doCreateLogger(R,S,c){return new y.SpdLogLogger((0,i.generateUuid)(),R.fsPath,!c?.donotRotate,!!c?.donotUseFormatters,S)}}e.LoggerService=k}),define(le[72],ue([0,1,31,4,6,5,201]),function(j,e,i,s,y,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerMainService=e.ILoggerMainService=void 0,e.ILoggerMainService=(0,y.refineServiceDecorator)(k.ILoggerService);class R extends A.LoggerService{constructor(){super(...arguments),this.loggerResourcesByWindow=new i.ResourceMap}createLogger(c,m,u){u!==void 0&&this.loggerResourcesByWindow.set(this.toResource(c),u);try{return super.createLogger(c,m)}catch(p){throw this.loggerResourcesByWindow.delete(this.toResource(c)),p}}registerLogger(c,m){m!==void 0&&this.loggerResourcesByWindow.set(c.resource,m),super.registerLogger(c)}deregisterLogger(c){this.loggerResourcesByWindow.delete(c),super.deregisterLogger(c)}getRegisteredLoggers(c){const m=[];for(const u of super.getRegisteredLoggers())c===this.loggerResourcesByWindow.get(u.resource)&&m.push(u);return m}getOnDidChangeLogLevelEvent(c){return s.Event.filter(this.onDidChangeLogLevel,m=>(0,k.isLogLevel)(m)||this.isInterestedLoggerResource(m[0],c))}getOnDidChangeVisibilityEvent(c){return s.Event.filter(this.onDidChangeVisibility,([m])=>this.isInterestedLoggerResource(m,c))}getOnDidChangeLoggersEvent(c){return s.Event.filter(s.Event.map(this.onDidChangeLoggers,m=>({added:[...m.added].filter(p=>this.isInterestedLoggerResource(p.resource,c)),removed:[...m.removed].filter(p=>this.isInterestedLoggerResource(p.resource,c))})),m=>m.added.length>0||m.removed.length>0)}deregisterLoggers(c){for(const[m,u]of this.loggerResourcesByWindow)u===c&&this.deregisterLogger(m)}isInterestedLoggerResource(c,m){const u=this.loggerResourcesByWindow.get(c);return u===void 0||u===m}dispose(){super.dispose(),this.loggerResourcesByWindow.clear()}}e.LoggerMainService=R}),define(le[202],ue([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMenubarMenuItemSubmenu=i,e.isMenubarMenuItemSeparator=s,e.isMenubarMenuItemRecentAction=y,e.isMenubarMenuItemAction=k;function i(A){return A.submenu!==void 0}function s(A){return A.id==="vscode.menubar.separator"}function y(A){return A.uri!==void 0}function k(A){return!i(A)&&!s(A)&&!y(A)}}),define(le[40],ue([0,1,4,78,2,6]),function(j,e,i,s,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullPolicyService=e.AbstractPolicyService=e.IPolicyService=void 0,e.IPolicyService=(0,k.createDecorator)("policy");class A extends y.Disposable{constructor(){super(...arguments),this.policyDefinitions={},this.policies=new Map,this._onDidChange=this._register(new i.Emitter),this.onDidChange=this._onDidChange.event}async updatePolicyDefinitions(c){const m=Object.keys(this.policyDefinitions).length;return this.policyDefinitions={...c,...this.policyDefinitions},m!==Object.keys(this.policyDefinitions).length&&await this._updatePolicyDefinitions(c),s.Iterable.reduce(this.policies.entries(),(u,[p,v])=>({...u,[p]:v}),{})}getPolicyValue(c){return this.policies.get(c)}serialize(){return s.Iterable.reduce(Object.entries(this.policyDefinitions),(c,[m,u])=>({...c,[m]:{definition:u,value:this.policies.get(m)}}),{})}}e.AbstractPolicyService=A;class R{constructor(){this.onDidChange=i.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.NullPolicyService=R}),define(le[203],ue([0,1,8,4,78,12,14,5,40]),function(j,e,i,s,y,k,A,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FilePolicyService=void 0;function c(u,p){const v=[];for(const f of new Set(y.Iterable.concat(u.keys(),p.keys())))u.get(f)!==p.get(f)&&v.push(f);return v}let m=class extends S.AbstractPolicyService{constructor(p,v,f){super(),this.file=p,this.fileService=v,this.logService=f,this.throttledDelayer=this._register(new i.ThrottledDelayer(500));const h=s.Event.filter(v.onDidFilesChange,E=>E.affects(p));this._register(v.watch(p)),this._register(h(()=>this.throttledDelayer.trigger(()=>this.refresh())))}async _updatePolicyDefinitions(){await this.refresh()}async read(){const p=new Map;try{const v=await this.fileService.readFile(this.file),f=JSON.parse(v.value.toString());if(!(0,k.isObject)(f))throw new Error("Policy file isn't a JSON object");for(const h of Object.keys(f))this.policyDefinitions[h]&&p.set(h,f[h])}catch(v){v.fileOperationResult!==A.FileOperationResult.FILE_NOT_FOUND&&this.logService.error("[FilePolicyService] Failed to read policies",v)}return p}async refresh(){const p=await this.read(),v=c(this.policies,p);this.policies=p,v.length>0&&this._onDidChange.fire(v)}};e.FilePolicyService=m,e.FilePolicyService=m=Pe([re(1,A.IFileService),re(2,R.ILogService)],m)}),define(le[204],ue([0,1,4,2,40]),function(j,e,i,s,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyChannelClient=e.PolicyChannel=void 0;class k{constructor(S){this.service=S,this.disposables=new s.DisposableStore}listen(S,c){switch(c){case"onDidChange":return i.Event.map(this.service.onDidChange,m=>m.reduce((u,p)=>({...u,[p]:this.service.getPolicyValue(p)??null}),{}),this.disposables)}throw new Error(`Event not found: ${c}`)}call(S,c,m){switch(c){case"updatePolicyDefinitions":return this.service.updatePolicyDefinitions(m)}throw new Error(`Call not found: ${c}`)}dispose(){this.disposables.dispose()}}e.PolicyChannel=k;class A extends y.AbstractPolicyService{constructor(S,c){super(),this.channel=c;for(const m in S){const{definition:u,value:p}=S[m];this.policyDefinitions[m]=u,p!==void 0&&this.policies.set(m,p)}this.channel.listen("onDidChange")(m=>{for(const u in m){const p=m[u];p===null?this.policies.delete(u):this.policies.set(u,p)}this._onDidChange.fire(Object.keys(m))})}async _updatePolicyDefinitions(S){const c=await this.channel.call("updatePolicyDefinitions",S);for(const m in c)this.policies.set(m,c[m])}}e.PolicyChannelClient=A}),define(le[205],ue([0,1,40,8,2,5]),function(j,e,i,s,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativePolicyService=void 0;let A=class extends i.AbstractPolicyService{constructor(S,c){super(),this.logService=S,this.productName=c,this.throttler=new s.Throttler,this.watcher=this._register(new y.MutableDisposable)}async _updatePolicyDefinitions(S){this.logService.trace(`NativePolicyService#_updatePolicyDefinitions - Found ${Object.keys(S).length} policy definitions`);const{createWatcher:c}=await new Promise((m,u)=>{j(["@vscode/policy-watcher"],m,u)}).then(Re);await this.throttler.queue(()=>new Promise((m,u)=>{try{this.watcher.value=c(this.productName,S,p=>{this._onDidPolicyChange(p),m()})}catch(p){this.logService.error("NativePolicyService#_updatePolicyDefinitions - Error creating watcher:",p),u(p)}}))}_onDidPolicyChange(S){this.logService.trace(`NativePolicyService#_onDidPolicyChange - Updated policy values: ${JSON.stringify(S)}`);for(const c in S){const m=S[c];m===void 0?this.policies.delete(c):this.policies.set(c,m)}this._onDidChange.fire(Object.keys(S))}};e.NativePolicyService=A,e.NativePolicyService=A=Pe([re(0,k.ILogService)],A)}),define(le[73],ue([0,1,38]),function(j,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let s;const y=globalThis.vscode;if(typeof y<"u"&&typeof y.context<"u"){const k=y.context.configuration();if(k)s=k.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){s=globalThis._VSCODE_PRODUCT_JSON;const{serviceUrl:k,searchUrl:A,itemUrl:R,controlUrl:S}=s.extensionsGallery||{};Object.assign(s,{extensionsGallery:{serviceUrl:i.env.VSCODE_GALLERY_SERVICE_URL||k,searchUrl:i.env.VSCODE_GALLERY_SEARCH_URL||A,itemUrl:i.env.VSCODE_GALLERY_ITEM_URL||R,controlUrl:i.env.VSCODE_GALLERY_CONTROL_URL||S}});try{const c=(...u)=>u.reduce((p,v)=>(Object.keys(v).forEach(f=>{Array.isArray(p[f])&&Array.isArray(v[f])?p[f]=v[f]:typeof p[f]=="object"&&typeof v[f]=="object"?p[f]=c(p[f],v[f]):p[f]=v[f]}),p),{}),m=globalThis._VSCODE_USER_PRODUCT_JSON||{};s=c(s,m)}catch{}if(i.env.VSCODE_DEV&&Object.assign(s,{nameShort:`${s.nameShort} Dev`,nameLong:`${s.nameLong} Dev`,dataFolderName:`${s.dataFolderName}-dev`,serverDataFolderName:s.serverDataFolderName?`${s.serverDataFolderName}-dev`:void 0}),!s.version){const c=globalThis._VSCODE_PACKAGE_JSON;Object.assign(s,{version:c.version,release:c.release})}}else s={},Object.keys(s).length===0&&Object.assign(s,{version:"1.91.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=s}),define(le[28],ue([0,1,6]),function(j,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,i.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(le[206],ue([0,1,8,5]),function(j,e,i,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowProfiler=void 0;let y=class{constructor(A,R,S){this._window=A,this._sessionId=R,this._logService=S}async inspect(A){await this._connect();const R=this._window.webContents.debugger;await R.sendCommand("Profiler.start"),this._logService.warn("[perf] profiling STARTED",this._sessionId),await(0,i.timeout)(A);const S=await R.sendCommand("Profiler.stop");return this._logService.warn("[perf] profiling DONE",this._sessionId),await this._disconnect(),S.profile}async _connect(){const A=this._window.webContents.debugger;A.attach(),await A.sendCommand("Profiler.enable")}async _disconnect(){const A=this._window.webContents.debugger;await A.sendCommand("Profiler.disable"),A.detach()}};e.WindowProfiler=y,e.WindowProfiler=y=Pe([re(2,s.ILogService)],y)}),define(le[74],ue([0,1,6]),function(j,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProtocolMainService=void 0,e.IProtocolMainService=(0,i.createDecorator)("protocolMainService")}),define(le[46],ue([0,1,144,12]),function(j,e,i,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0,i=Re(i),s=Re(s);class y{constructor(){this.data=new Map}add(A,R){i.ok(s.isString(A)),i.ok(s.isObject(R)),i.ok(!this.data.has(A),"There is already an extension with this id"),this.data.set(A,R)}knows(A){return this.data.has(A)}as(A){return this.data.get(A)||null}}e.Registry=new y}),define(le[207],ue([0,1,4,146,46]),function(j,e,i,s,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,y=Re(y),e.Extensions={JSONContribution:"base.contributions.json"};function k(S){return S.length>0&&S.charAt(S.length-1)==="#"?S.substring(0,S.length-1):S}class A{constructor(){this._onDidChangeSchema=new i.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(c,m){this.schemasById[k(c)]=m,this._onDidChangeSchema.fire(c)}notifySchemaChanged(c){this._onDidChangeSchema.fire(c)}getSchemaContributions(){return{schemas:this.schemasById}}getSchemaContent(c){const m=this.schemasById[c];return m?(0,s.getCompressedContent)(m):void 0}hasSchemaContent(c){return!!this.schemasById[c]}}const R=new A;y.Registry.add(e.Extensions.JSONContribution,R)}),define(le[56],ue([0,1,21,4,12,9,16,207,46]),function(j,e,i,s,y,k,A,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0,e.overrideIdentifiersFromKey=h,e.keyFromOverrideIdentifiers=E,e.getDefaultValue=b,e.validateProperty=I,e.getScopes=P,e.getAllConfigurationProperties=r,e.parseScope=a,y=Re(y),k=Re(k);var c;(function(t){t.Multiline="multilineText",t.Singleline="singlelineText"})(c||(e.EditPresentationTypes=c={})),e.Extensions={Configuration:"base.contributions.configuration"};var m;(function(t){t[t.APPLICATION=1]="APPLICATION",t[t.MACHINE=2]="MACHINE",t[t.WINDOW=3]="WINDOW",t[t.RESOURCE=4]="RESOURCE",t[t.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",t[t.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(m||(e.ConfigurationScope=m={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const u=S.Registry.as(R.Extensions.JSONContribution);class p{constructor(){this.registeredConfigurationDefaults=[],this.overrideIdentifiers=new Set,this._onDidSchemaChange=new s.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new s.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:k.localize(1662,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.policyConfigurations=new Map,this.excludedConfigurationProperties={},u.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(o,n=!0){this.registerConfigurations([o],n)}registerConfigurations(o,n=!0){const l=new Set;this.doRegisterConfigurations(o,n,l),u.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:l})}deregisterConfigurations(o){const n=new Set;this.doDeregisterConfigurations(o,n),u.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:n})}updateConfigurations({add:o,remove:n}){const l=new Set;this.doDeregisterConfigurations(n,l),this.doRegisterConfigurations(o,!1,l),u.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:l})}registerDefaultConfigurations(o){const n=new Set;this.doRegisterDefaultConfigurations(o,n),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:n,defaultsOverrides:!0})}doRegisterDefaultConfigurations(o,n){this.registeredConfigurationDefaults.push(...o);const l=[];for(const{overrides:d,source:D}of o)for(const w in d){n.add(w);const M=this.configurationDefaultsOverrides.get(w)??this.configurationDefaultsOverrides.set(w,{configurationDefaultOverrides:[]}).get(w),T=d[w];if(M.configurationDefaultOverrides.push({value:T,source:D}),e.OVERRIDE_PROPERTY_REGEX.test(w)){const C=this.mergeDefaultConfigurationsForOverrideIdentifier(w,T,D,M.configurationDefaultOverrideValue);if(!C)continue;M.configurationDefaultOverrideValue=C,this.updateDefaultOverrideProperty(w,C,D),l.push(...h(w))}else{const C=this.mergeDefaultConfigurationsForConfigurationProperty(w,T,D,M.configurationDefaultOverrideValue);if(!C)continue;M.configurationDefaultOverrideValue=C;const L=this.configurationProperties[w];L&&(this.updatePropertyDefaultValue(w,L),this.updateSchema(w,L))}}this.doRegisterOverrideIdentifiers(l)}deregisterDefaultConfigurations(o){const n=new Set;this.doDeregisterDefaultConfigurations(o,n),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:n,defaultsOverrides:!0})}doDeregisterDefaultConfigurations(o,n){for(const l of o){const d=this.registeredConfigurationDefaults.indexOf(l);d!==-1&&this.registeredConfigurationDefaults.splice(d,1)}for(const{overrides:l,source:d}of o)for(const D in l){const w=this.configurationDefaultsOverrides.get(D);if(!w)continue;const M=w.configurationDefaultOverrides.findIndex(T=>d?T.source?.id===d.id:T.value===l[D]);if(M!==-1){if(w.configurationDefaultOverrides.splice(M,1),w.configurationDefaultOverrides.length===0&&this.configurationDefaultsOverrides.delete(D),e.OVERRIDE_PROPERTY_REGEX.test(D)){let T;for(const C of w.configurationDefaultOverrides)T=this.mergeDefaultConfigurationsForOverrideIdentifier(D,C.value,C.source,T);T&&!y.isEmptyObject(T.value)?(w.configurationDefaultOverrideValue=T,this.updateDefaultOverrideProperty(D,T,d)):(this.configurationDefaultsOverrides.delete(D),delete this.configurationProperties[D],delete this.defaultLanguageConfigurationOverridesNode.properties[D])}else{let T;for(const L of w.configurationDefaultOverrides)T=this.mergeDefaultConfigurationsForConfigurationProperty(D,L.value,L.source,T);w.configurationDefaultOverrideValue=T;const C=this.configurationProperties[D];C&&(this.updatePropertyDefaultValue(D,C),this.updateSchema(D,C))}n.add(D)}}this.updateOverridePropertyPatternKey()}updateDefaultOverrideProperty(o,n,l){const d={type:"object",default:n.value,description:k.localize(1663,null,(0,A.getLanguageTagSettingPlainKey)(o)),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:n.value,source:l,defaultValueSource:l};this.configurationProperties[o]=d,this.defaultLanguageConfigurationOverridesNode.properties[o]=d}mergeDefaultConfigurationsForOverrideIdentifier(o,n,l,d){const D=d?.value||{},w=d?.source??new Map;if(!(w instanceof Map)){console.error("objectConfigurationSources is not a Map");return}for(const M of Object.keys(n)){const T=n[M];if(y.isObject(T)&&(y.isUndefined(D[M])||y.isObject(D[M]))){if(D[M]={...D[M]??{},...T},l)for(const L in T)w.set(`${M}.${L}`,l)}else D[M]=T,l?w.set(M,l):w.delete(M)}return{value:D,source:w}}mergeDefaultConfigurationsForConfigurationProperty(o,n,l,d){const D=this.configurationProperties[o],w=d?.value??D?.defaultDefaultValue;let M=l;if(y.isObject(n)&&(D!==void 0&&D.type==="object"||D===void 0&&(y.isUndefined(w)||y.isObject(w)))){if(M=d?.source??new Map,!(M instanceof Map)){console.error("defaultValueSource is not a Map");return}for(const C in n)l&&M.set(`${o}.${C}`,l);n={...y.isObject(w)?w:{},...n}}return{value:n,source:M}}deltaConfiguration(o){let n=!1;const l=new Set;o.removedDefaults&&(this.doDeregisterDefaultConfigurations(o.removedDefaults,l),n=!0),o.addedDefaults&&(this.doRegisterDefaultConfigurations(o.addedDefaults,l),n=!0),o.removedConfigurations&&this.doDeregisterConfigurations(o.removedConfigurations,l),o.addedConfigurations&&this.doRegisterConfigurations(o.addedConfigurations,!1,l),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:l,defaultsOverrides:n})}notifyConfigurationSchemaUpdated(...o){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(o){this.doRegisterOverrideIdentifiers(o),this._onDidSchemaChange.fire()}doRegisterOverrideIdentifiers(o){for(const n of o)this.overrideIdentifiers.add(n);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(o,n,l){o.forEach(d=>{this.validateAndRegisterProperties(d,n,d.extensionInfo,d.restrictedProperties,void 0,l),this.configurationContributors.push(d),this.registerJSONConfiguration(d)})}doDeregisterConfigurations(o,n){const l=d=>{if(d.properties)for(const D in d.properties){n.add(D);const w=this.configurationProperties[D];w?.policy?.name&&this.policyConfigurations.delete(w.policy.name),delete this.configurationProperties[D],this.removeFromSchema(D,d.properties[D])}d.allOf?.forEach(D=>l(D))};for(const d of o){l(d);const D=this.configurationContributors.indexOf(d);D!==-1&&this.configurationContributors.splice(D,1)}}validateAndRegisterProperties(o,n=!0,l,d,D=m.WINDOW,w){D=y.isUndefinedOrNull(o.scope)?D:o.scope;const M=o.properties;if(M)for(const C in M){const L=M[C];if(n&&I(C,L)){delete M[C];continue}if(L.source=l,L.defaultDefaultValue=M[C].default,this.updatePropertyDefaultValue(C,L),e.OVERRIDE_PROPERTY_REGEX.test(C)?L.scope=void 0:(L.scope=y.isUndefinedOrNull(L.scope)?D:L.scope,L.restricted=y.isUndefinedOrNull(L.restricted)?!!d?.includes(C):L.restricted),M[C].hasOwnProperty("included")&&!M[C].included){this.excludedConfigurationProperties[C]=M[C],delete M[C];continue}else this.configurationProperties[C]=M[C],M[C].policy?.name&&this.policyConfigurations.set(M[C].policy.name,C);!M[C].deprecationMessage&&M[C].markdownDeprecationMessage&&(M[C].deprecationMessage=M[C].markdownDeprecationMessage),w.add(C)}const T=o.allOf;if(T)for(const C of T)this.validateAndRegisterProperties(C,n,l,d,D,w)}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getPolicyConfigurations(){return this.policyConfigurations}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getRegisteredDefaultConfigurations(){return[...this.registeredConfigurationDefaults]}getConfigurationDefaultsOverrides(){const o=new Map;for(const[n,l]of this.configurationDefaultsOverrides)l.configurationDefaultOverrideValue&&o.set(n,l.configurationDefaultOverrideValue);return o}registerJSONConfiguration(o){const n=l=>{const d=l.properties;if(d)for(const w in d)this.updateSchema(w,d[w]);l.allOf?.forEach(n)};n(o)}updateSchema(o,n){switch(e.allSettings.properties[o]=n,n.scope){case m.APPLICATION:e.applicationSettings.properties[o]=n;break;case m.MACHINE:e.machineSettings.properties[o]=n;break;case m.MACHINE_OVERRIDABLE:e.machineOverridableSettings.properties[o]=n;break;case m.WINDOW:e.windowSettings.properties[o]=n;break;case m.RESOURCE:e.resourceSettings.properties[o]=n;break;case m.LANGUAGE_OVERRIDABLE:e.resourceSettings.properties[o]=n,this.resourceLanguageSettingsSchema.properties[o]=n;break}}removeFromSchema(o,n){switch(delete e.allSettings.properties[o],n.scope){case m.APPLICATION:delete e.applicationSettings.properties[o];break;case m.MACHINE:delete e.machineSettings.properties[o];break;case m.MACHINE_OVERRIDABLE:delete e.machineOverridableSettings.properties[o];break;case m.WINDOW:delete e.windowSettings.properties[o];break;case m.RESOURCE:case m.LANGUAGE_OVERRIDABLE:delete e.resourceSettings.properties[o],delete this.resourceLanguageSettingsSchema.properties[o];break}}updateOverridePropertyPatternKey(){for(const o of this.overrideIdentifiers.values()){const n=`[${o}]`,l={type:"object",description:k.localize(1664,null),errorMessage:k.localize(1665,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(n,l),e.allSettings.properties[n]=l,e.applicationSettings.properties[n]=l,e.machineSettings.properties[n]=l,e.machineOverridableSettings.properties[n]=l,e.windowSettings.properties[n]=l,e.resourceSettings.properties[n]=l}}registerOverridePropertyPatternKey(){const o={type:"object",description:k.localize(1666,null),errorMessage:k.localize(1667,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=o,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=o,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=o,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=o,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=o,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=o,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(o,n){const l=this.configurationDefaultsOverrides.get(o)?.configurationDefaultOverrideValue;let d,D;l&&(!n.disallowConfigurationDefault||!l.source)&&(d=l.value,D=l.source),y.isUndefined(d)&&(d=n.defaultDefaultValue,D=void 0),y.isUndefined(d)&&(d=b(n.type)),n.default=d,n.defaultValueSource=D}}const v="\\[([^\\]]+)\\]",f=new RegExp(v,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${v})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function h(t){const o=[];if(e.OVERRIDE_PROPERTY_REGEX.test(t)){let n=f.exec(t);for(;n?.length;){const l=n[1].trim();l&&o.push(l),n=f.exec(t)}}return(0,i.distinct)(o)}function E(t){return t.reduce((o,n)=>`${o}[${n}]`,"")}function b(t){switch(Array.isArray(t)?t[0]:t){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const g=new p;S.Registry.add(e.Extensions.Configuration,g);function I(t,o){return t.trim()?e.OVERRIDE_PROPERTY_REGEX.test(t)?k.localize(1669,null,t):g.getConfigurationProperties()[t]!==void 0?k.localize(1670,null,t):o.policy?.name&&g.getPolicyConfigurations().get(o.policy?.name)!==void 0?k.localize(1671,null,t,o.policy?.name,g.getPolicyConfigurations().get(o.policy?.name)):null:k.localize(1668,null)}function P(){const t=[],o=g.getConfigurationProperties();for(const n of Object.keys(o))t.push([n,o[n].scope]);return t.push(["launch",m.RESOURCE]),t.push(["task",m.RESOURCE]),t}function r(t){const o={};for(const n of t){const l=n.properties;if(y.isObject(l))for(const d in l)o[d]=l[d];n.allOf&&Object.assign(o,r(n.allOf))}return o}function a(t){switch(t){case"application":return m.APPLICATION;case"machine":return m.MACHINE;case"resource":return m.RESOURCE;case"machine-overridable":return m.MACHINE_OVERRIDABLE;case"language-overridable":return m.LANGUAGE_OVERRIDABLE;default:return m.WINDOW}}}),define(le[128],ue([0,1,21,4,43,2,31,37,12,7,16,56,14,46]),function(j,e,i,s,y,k,A,R,S,c,m,u,p,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0,e.mergeChanges=P,i=Re(i),y=Re(y),R=Re(R),S=Re(S);function f(o){return Object.isFrozen(o)?o:R.deepFreeze(o)}class h{static createEmptyModel(n){return new h({},[],[],void 0,n)}constructor(n,l,d,D,w){this._contents=n,this._keys=l,this._overrides=d,this.raw=D,this.logService=w,this.overrideConfigurations=new Map}get rawConfiguration(){if(!this._rawConfiguration)if(this.raw?.length){const n=this.raw.map(l=>{if(l instanceof h)return l;const d=new E("",this.logService);return d.parseRaw(l),d.configurationModel});this._rawConfiguration=n.reduce((l,d)=>d===l?d:l.merge(d),n[0])}else this._rawConfiguration=this;return this._rawConfiguration}get contents(){return this._contents}get overrides(){return this._overrides}get keys(){return this._keys}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(n){return n?(0,m.getConfigurationValue)(this.contents,n):this.contents}inspect(n,l){const d=this;return{get value(){return f(d.rawConfiguration.getValue(n))},get override(){return l?f(d.rawConfiguration.getOverrideValue(n,l)):void 0},get merged(){return f(l?d.rawConfiguration.override(l).getValue(n):d.rawConfiguration.getValue(n))},get overrides(){const D=[];for(const{contents:w,identifiers:M,keys:T}of d.rawConfiguration.overrides){const C=new h(w,T,[],void 0,d.logService).getValue(n);C!==void 0&&D.push({identifiers:M,value:C})}return D.length?f(D):void 0}}}getOverrideValue(n,l){const d=this.getContentsForOverrideIdentifer(l);return d?n?(0,m.getConfigurationValue)(d,n):d:void 0}getKeysForOverrideIdentifier(n){const l=[];for(const d of this.overrides)d.identifiers.includes(n)&&l.push(...d.keys);return i.distinct(l)}getAllOverrideIdentifiers(){const n=[];for(const l of this.overrides)n.push(...l.identifiers);return i.distinct(n)}override(n){let l=this.overrideConfigurations.get(n);return l||(l=this.createOverrideConfigurationModel(n),this.overrideConfigurations.set(n,l)),l}merge(...n){const l=R.deepClone(this.contents),d=R.deepClone(this.overrides),D=[...this.keys],w=this.raw?.length?[...this.raw]:[this];for(const M of n)if(w.push(...M.raw?.length?M.raw:[M]),!M.isEmpty()){this.mergeContents(l,M.contents);for(const T of M.overrides){const[C]=d.filter(L=>i.equals(L.identifiers,T.identifiers));C?(this.mergeContents(C.contents,T.contents),C.keys.push(...T.keys),C.keys=i.distinct(C.keys)):d.push(R.deepClone(T))}for(const T of M.keys)D.indexOf(T)===-1&&D.push(T)}return new h(l,D,d,w.every(M=>M instanceof h)?void 0:w,this.logService)}createOverrideConfigurationModel(n){const l=this.getContentsForOverrideIdentifer(n);if(!l||typeof l!="object"||!Object.keys(l).length)return this;const d={};for(const D of i.distinct([...Object.keys(this.contents),...Object.keys(l)])){let w=this.contents[D];const M=l[D];M&&(typeof w=="object"&&typeof M=="object"?(w=R.deepClone(w),this.mergeContents(w,M)):w=M),d[D]=w}return new h(d,this.keys,this.overrides,void 0,this.logService)}mergeContents(n,l){for(const d of Object.keys(l)){if(d in n&&S.isObject(n[d])&&S.isObject(l[d])){this.mergeContents(n[d],l[d]);continue}n[d]=R.deepClone(l[d])}}getContentsForOverrideIdentifer(n){let l=null,d=null;const D=w=>{w&&(d?this.mergeContents(d,w):d=R.deepClone(w))};for(const w of this.overrides)w.identifiers.length===1&&w.identifiers[0]===n?l=w.contents:w.identifiers.includes(n)&&D(w.contents);return D(l),d}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(n,l){this.updateValue(n,l,!0)}setValue(n,l){this.updateValue(n,l,!1)}removeValue(n){const l=this.keys.indexOf(n);l!==-1&&(this.keys.splice(l,1),(0,m.removeFromValueTree)(this.contents,n),u.OVERRIDE_PROPERTY_REGEX.test(n)&&this.overrides.splice(this.overrides.findIndex(d=>i.equals(d.identifiers,(0,u.overrideIdentifiersFromKey)(n))),1))}updateValue(n,l,d){if((0,m.addToValueTree)(this.contents,n,l,D=>this.logService.error(D)),d=d||this.keys.indexOf(n)===-1,d&&this.keys.push(n),u.OVERRIDE_PROPERTY_REGEX.test(n)){const D=(0,u.overrideIdentifiersFromKey)(n),w={identifiers:D,keys:Object.keys(this.contents[n]),contents:(0,m.toValuesTree)(this.contents[n],T=>this.logService.error(T))},M=this.overrides.findIndex(T=>i.equals(T.identifiers,D));M!==-1?this.overrides[M]=w:this.overrides.push(w)}}}e.ConfigurationModel=h;class E{constructor(n,l){this._name=n,this.logService=l,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||h.createEmptyModel(this.logService)}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(n,l){if(!S.isUndefinedOrNull(n)){const d=this.doParseContent(n);this.parseRaw(d,l)}}reparse(n){this._raw&&this.parseRaw(this._raw,n)}parseRaw(n,l){this._raw=n;const{contents:d,keys:D,overrides:w,restricted:M,hasExcludedProperties:T}=this.doParseRaw(n,l);this._configurationModel=new h(d,D,w,T?[n]:void 0,this.logService),this._restrictedConfigurations=M||[]}doParseContent(n){let l={},d=null,D=[];const w=[],M=[];function T(L){Array.isArray(D)?D.push(L):d!==null&&(D[d]=L)}const C={onObjectBegin:()=>{const L={};T(L),w.push(D),D=L,d=null},onObjectProperty:L=>{d=L},onObjectEnd:()=>{D=w.pop()},onArrayBegin:()=>{const L=[];T(L),w.push(D),D=L,d=null},onArrayEnd:()=>{D=w.pop()},onLiteralValue:T,onError:(L,_,V)=>{M.push({error:L,offset:_,length:V})}};if(n)try{y.visit(n,C),l=D[0]||{}}catch(L){this.logService.error(`Error while parsing settings file ${this._name}: ${L}`),this._parseErrors=[L]}return l}doParseRaw(n,l){const d=v.Registry.as(u.Extensions.Configuration).getConfigurationProperties(),D=this.filter(n,d,!0,l);n=D.raw;const w=(0,m.toValuesTree)(n,C=>this.logService.error(`Conflict in settings file ${this._name}: ${C}`)),M=Object.keys(n),T=this.toOverrides(n,C=>this.logService.error(`Conflict in settings file ${this._name}: ${C}`));return{contents:w,keys:M,overrides:T,restricted:D.restricted,hasExcludedProperties:D.hasExcludedProperties}}filter(n,l,d,D){let w=!1;if(!D?.scopes&&!D?.skipRestricted&&!D?.exclude?.length)return{raw:n,restricted:[],hasExcludedProperties:w};const M={},T=[];for(const C in n)if(u.OVERRIDE_PROPERTY_REGEX.test(C)&&d){const L=this.filter(n[C],l,!1,D);M[C]=L.raw,w=w||L.hasExcludedProperties,T.push(...L.restricted)}else{const L=l[C],_=L?typeof L.scope<"u"?L.scope:u.ConfigurationScope.WINDOW:void 0;L?.restricted&&T.push(C),!D.exclude?.includes(C)&&(D.include?.includes(C)||(_===void 0||D.scopes===void 0||D.scopes.includes(_))&&!(D.skipRestricted&&L?.restricted))?M[C]=n[C]:w=!0}return{raw:M,restricted:T,hasExcludedProperties:w}}toOverrides(n,l){const d=[];for(const D of Object.keys(n))if(u.OVERRIDE_PROPERTY_REGEX.test(D)){const w={};for(const M in n[D])w[M]=n[D][M];d.push({identifiers:(0,u.overrideIdentifiersFromKey)(D),keys:Object.keys(w),contents:(0,m.toValuesTree)(w,l)})}return d}}e.ConfigurationModelParser=E;class b extends k.Disposable{constructor(n,l,d,D,w){super(),this.userSettingsResource=n,this.parseOptions=l,this.fileService=D,this.logService=w,this._onDidChange=this._register(new s.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new E(this.userSettingsResource.toString(),w),this._register(this.fileService.watch(d.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(s.Event.any(s.Event.filter(this.fileService.onDidFilesChange,M=>M.contains(this.userSettingsResource)),s.Event.filter(this.fileService.onDidRunOperation,M=>(M.isOperation(p.FileOperation.CREATE)||M.isOperation(p.FileOperation.COPY)||M.isOperation(p.FileOperation.DELETE)||M.isOperation(p.FileOperation.WRITE))&&d.isEqual(M.resource,n)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const n=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(n.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return h.createEmptyModel(this.logService)}}reparse(n){return n&&(this.parseOptions=n),this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=b;class g{constructor(n,l,d,D,w,M,T,C,L,_,V,z,Q){this.key=n,this.overrides=l,this._value=d,this.overrideIdentifiers=D,this.defaultConfiguration=w,this.policyConfiguration=M,this.applicationConfiguration=T,this.userConfiguration=C,this.localUserConfiguration=L,this.remoteUserConfiguration=_,this.workspaceConfiguration=V,this.folderConfigurationModel=z,this.memoryConfigurationModel=Q}get value(){return f(this._value)}toInspectValue(n){return n?.value!==void 0||n?.override!==void 0||n?.overrides!==void 0?n:void 0}get defaultInspectValue(){return this._defaultInspectValue||(this._defaultInspectValue=this.defaultConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._defaultInspectValue}get defaultValue(){return this.defaultInspectValue.merged}get default(){return this.toInspectValue(this.defaultInspectValue)}get policyInspectValue(){return this._policyInspectValue===void 0&&(this._policyInspectValue=this.policyConfiguration?this.policyConfiguration.inspect(this.key):null),this._policyInspectValue}get policyValue(){return this.policyInspectValue?.merged}get policy(){return this.policyInspectValue?.value!==void 0?{value:this.policyInspectValue.value}:void 0}get applicationInspectValue(){return this._applicationInspectValue===void 0&&(this._applicationInspectValue=this.applicationConfiguration?this.applicationConfiguration.inspect(this.key):null),this._applicationInspectValue}get applicationValue(){return this.applicationInspectValue?.merged}get application(){return this.toInspectValue(this.applicationInspectValue)}get userInspectValue(){return this._userInspectValue||(this._userInspectValue=this.userConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._userInspectValue}get userValue(){return this.userInspectValue.merged}get user(){return this.toInspectValue(this.userInspectValue)}get userLocalInspectValue(){return this._userLocalInspectValue||(this._userLocalInspectValue=this.localUserConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._userLocalInspectValue}get userLocalValue(){return this.userLocalInspectValue.merged}get userLocal(){return this.toInspectValue(this.userLocalInspectValue)}get userRemoteInspectValue(){return this._userRemoteInspectValue||(this._userRemoteInspectValue=this.remoteUserConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._userRemoteInspectValue}get userRemoteValue(){return this.userRemoteInspectValue.merged}get userRemote(){return this.toInspectValue(this.userRemoteInspectValue)}get workspaceInspectValue(){return this._workspaceInspectValue===void 0&&(this._workspaceInspectValue=this.workspaceConfiguration?this.workspaceConfiguration.inspect(this.key,this.overrides.overrideIdentifier):null),this._workspaceInspectValue}get workspaceValue(){return this.workspaceInspectValue?.merged}get workspace(){return this.toInspectValue(this.workspaceInspectValue)}get workspaceFolderInspectValue(){return this._workspaceFolderInspectValue===void 0&&(this._workspaceFolderInspectValue=this.folderConfigurationModel?this.folderConfigurationModel.inspect(this.key,this.overrides.overrideIdentifier):null),this._workspaceFolderInspectValue}get workspaceFolderValue(){return this.workspaceFolderInspectValue?.merged}get workspaceFolder(){return this.toInspectValue(this.workspaceFolderInspectValue)}get memoryInspectValue(){return this._memoryInspectValue===void 0&&(this._memoryInspectValue=this.memoryConfigurationModel.inspect(this.key,this.overrides.overrideIdentifier)),this._memoryInspectValue}get memoryValue(){return this.memoryInspectValue.merged}get memory(){return this.toInspectValue(this.memoryInspectValue)}}class I{constructor(n,l,d,D,w,M,T,C,L,_){this._defaultConfiguration=n,this._policyConfiguration=l,this._applicationConfiguration=d,this._localUserConfiguration=D,this._remoteUserConfiguration=w,this._workspaceConfiguration=M,this._folderConfigurations=T,this._memoryConfiguration=C,this._memoryConfigurationByResource=L,this.logService=_,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new A.ResourceMap,this._userConfiguration=null}getValue(n,l,d){return this.getConsolidatedConfigurationModel(n,l,d).getValue(n)}updateValue(n,l,d={}){let D;d.resource?(D=this._memoryConfigurationByResource.get(d.resource),D||(D=h.createEmptyModel(this.logService),this._memoryConfigurationByResource.set(d.resource,D))):D=this._memoryConfiguration,l===void 0?D.removeValue(n):D.setValue(n,l),d.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(n,l,d){const D=this.getConsolidatedConfigurationModel(n,l,d),w=this.getFolderConfigurationModelForResource(l.resource,d),M=l.resource?this._memoryConfigurationByResource.get(l.resource)||this._memoryConfiguration:this._memoryConfiguration,T=new Set;for(const C of D.overrides)for(const L of C.identifiers)D.getOverrideValue(n,L)!==void 0&&T.add(L);return new g(n,l,D.getValue(n),T.size?[...T]:void 0,this._defaultConfiguration,this._policyConfiguration.isEmpty()?void 0:this._policyConfiguration,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,d?this._workspaceConfiguration:void 0,w||void 0,M)}keys(n){const l=this.getFolderConfigurationModelForResource(void 0,n);return{default:this._defaultConfiguration.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this._workspaceConfiguration.keys.slice(0),workspaceFolder:l?l.keys.slice(0):[]}}updateDefaultConfiguration(n){this._defaultConfiguration=n,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updatePolicyConfiguration(n){this._policyConfiguration=n}updateApplicationConfiguration(n){this._applicationConfiguration=n,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(n){this._localUserConfiguration=n,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(n){this._remoteUserConfiguration=n,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(n){this._workspaceConfiguration=n,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(n,l){this._folderConfigurations.set(n,l),this._foldersConsolidatedConfigurations.delete(n)}deleteFolderConfiguration(n){this.folderConfigurations.delete(n),this._foldersConsolidatedConfigurations.delete(n)}compareAndUpdateDefaultConfiguration(n,l){const d=[];if(!l){const{added:D,updated:w,removed:M}=a(this._defaultConfiguration,n);l=[...D,...w,...M]}for(const D of l)for(const w of(0,u.overrideIdentifiersFromKey)(D)){const M=this._defaultConfiguration.getKeysForOverrideIdentifier(w),T=n.getKeysForOverrideIdentifier(w),C=[...T.filter(L=>M.indexOf(L)===-1),...M.filter(L=>T.indexOf(L)===-1),...M.filter(L=>!R.equals(this._defaultConfiguration.override(w).getValue(L),n.override(w).getValue(L)))];d.push([w,C])}return this.updateDefaultConfiguration(n),{keys:l,overrides:d}}compareAndUpdatePolicyConfiguration(n){const{added:l,updated:d,removed:D}=a(this._policyConfiguration,n),w=[...l,...d,...D];return w.length&&this.updatePolicyConfiguration(n),{keys:w,overrides:[]}}compareAndUpdateApplicationConfiguration(n){const{added:l,updated:d,removed:D,overrides:w}=a(this.applicationConfiguration,n),M=[...l,...d,...D];return M.length&&this.updateApplicationConfiguration(n),{keys:M,overrides:w}}compareAndUpdateLocalUserConfiguration(n){const{added:l,updated:d,removed:D,overrides:w}=a(this.localUserConfiguration,n),M=[...l,...d,...D];return M.length&&this.updateLocalUserConfiguration(n),{keys:M,overrides:w}}compareAndUpdateRemoteUserConfiguration(n){const{added:l,updated:d,removed:D,overrides:w}=a(this.remoteUserConfiguration,n),M=[...l,...d,...D];return M.length&&this.updateRemoteUserConfiguration(n),{keys:M,overrides:w}}compareAndUpdateWorkspaceConfiguration(n){const{added:l,updated:d,removed:D,overrides:w}=a(this.workspaceConfiguration,n),M=[...l,...d,...D];return M.length&&this.updateWorkspaceConfiguration(n),{keys:M,overrides:w}}compareAndUpdateFolderConfiguration(n,l){const d=this.folderConfigurations.get(n),{added:D,updated:w,removed:M,overrides:T}=a(d,l),C=[...D,...w,...M];return(C.length||!d)&&this.updateFolderConfiguration(n,l),{keys:C,overrides:T}}compareAndDeleteFolderConfiguration(n){const l=this.folderConfigurations.get(n);if(!l)throw new Error("Unknown folder");this.deleteFolderConfiguration(n);const{added:d,updated:D,removed:w,overrides:M}=a(l,void 0);return{keys:[...d,...D,...w],overrides:M}}get defaults(){return this._defaultConfiguration}get applicationConfiguration(){return this._applicationConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration)),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidatedConfigurationModel(n,l,d){let D=this.getConsolidatedConfigurationModelForResource(l,d);return l.overrideIdentifier&&(D=D.override(l.overrideIdentifier)),!this._policyConfiguration.isEmpty()&&this._policyConfiguration.getValue(n)!==void 0&&(D=D.merge(this._policyConfiguration)),D}getConsolidatedConfigurationModelForResource({resource:n},l){let d=this.getWorkspaceConsolidatedConfiguration();if(l&&n){const D=l.getFolder(n);D&&(d=this.getFolderConsolidatedConfiguration(D.uri)||d);const w=this._memoryConfigurationByResource.get(n);w&&(d=d.merge(w))}return d}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.applicationConfiguration,this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration)),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(n){let l=this._foldersConsolidatedConfigurations.get(n);if(!l){const d=this.getWorkspaceConsolidatedConfiguration(),D=this._folderConfigurations.get(n);D?(l=d.merge(D),this._foldersConsolidatedConfigurations.set(n,l)):l=d}return l}getFolderConfigurationModelForResource(n,l){if(l&&n){const d=l.getFolder(n);if(d)return this._folderConfigurations.get(d.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},policy:{contents:this._policyConfiguration.contents,overrides:this._policyConfiguration.overrides,keys:this._policyConfiguration.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((n,l)=>{const{contents:d,overrides:D,keys:w}=this._folderConfigurations.get(l);return n.push([l,{contents:d,overrides:D,keys:w}]),n},[])}}allKeys(){const n=new Set;return this._defaultConfiguration.keys.forEach(l=>n.add(l)),this.userConfiguration.keys.forEach(l=>n.add(l)),this._workspaceConfiguration.keys.forEach(l=>n.add(l)),this._folderConfigurations.forEach(l=>l.keys.forEach(d=>n.add(d))),[...n.values()]}allOverrideIdentifiers(){const n=new Set;return this._defaultConfiguration.getAllOverrideIdentifiers().forEach(l=>n.add(l)),this.userConfiguration.getAllOverrideIdentifiers().forEach(l=>n.add(l)),this._workspaceConfiguration.getAllOverrideIdentifiers().forEach(l=>n.add(l)),this._folderConfigurations.forEach(l=>l.getAllOverrideIdentifiers().forEach(d=>n.add(d))),[...n.values()]}getAllKeysForOverrideIdentifier(n){const l=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(n).forEach(d=>l.add(d)),this.userConfiguration.getKeysForOverrideIdentifier(n).forEach(d=>l.add(d)),this._workspaceConfiguration.getKeysForOverrideIdentifier(n).forEach(d=>l.add(d)),this._folderConfigurations.forEach(d=>d.getKeysForOverrideIdentifier(n).forEach(D=>l.add(D))),[...l.values()]}static parse(n,l){const d=this.parseConfigurationModel(n.defaults,l),D=this.parseConfigurationModel(n.policy,l),w=this.parseConfigurationModel(n.application,l),M=this.parseConfigurationModel(n.user,l),T=this.parseConfigurationModel(n.workspace,l),C=n.folders.reduce((L,_)=>(L.set(c.URI.revive(_[0]),this.parseConfigurationModel(_[1],l)),L),new A.ResourceMap);return new I(d,D,w,M,h.createEmptyModel(l),T,C,h.createEmptyModel(l),new A.ResourceMap,l)}static parseConfigurationModel(n,l){return new h(n.contents,n.keys,n.overrides,void 0,l)}}e.Configuration=I;function P(...o){if(o.length===0)return{keys:[],overrides:[]};if(o.length===1)return o[0];const n=new Set,l=new Map;for(const D of o)D.keys.forEach(w=>n.add(w)),D.overrides.forEach(([w,M])=>{const T=(0,A.getOrSet)(l,w,new Set);M.forEach(C=>T.add(C))});const d=[];return l.forEach((D,w)=>d.push([w,[...D.values()]])),{keys:[...n.values()],overrides:d}}class r{constructor(n,l,d,D,w){this.change=n,this.previous=l,this.currentConfiguraiton=d,this.currentWorkspace=D,this.logService=w,this._marker=`
`,this._markerCode1=this._marker.charCodeAt(0),this._markerCode2=46,this.affectedKeys=new Set,this._previousConfiguration=void 0;for(const M of n.keys)this.affectedKeys.add(M);for(const[,M]of n.overrides)for(const T of M)this.affectedKeys.add(T);this._affectsConfigStr=this._marker;for(const M of this.affectedKeys)this._affectsConfigStr+=M+this._marker}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=I.parse(this.previous.data,this.logService)),this._previousConfiguration}affectsConfiguration(n,l){const d=this._marker+n,D=this._affectsConfigStr.indexOf(d);if(D<0)return!1;const w=D+d.length;if(w>=this._affectsConfigStr.length)return!1;const M=this._affectsConfigStr.charCodeAt(w);if(M!==this._markerCode1&&M!==this._markerCode2)return!1;if(l){const T=this.previousConfiguration?this.previousConfiguration.getValue(n,l,this.previous?.workspace):void 0,C=this.currentConfiguraiton.getValue(n,l,this.currentWorkspace);return!R.equals(T,C)}return!0}}e.ConfigurationChangeEvent=r;function a(o,n){const{added:l,removed:d,updated:D}=t(n?.rawConfiguration,o?.rawConfiguration),w=[],M=o?.getAllOverrideIdentifiers()||[],T=n?.getAllOverrideIdentifiers()||[];if(n){const C=T.filter(L=>!M.includes(L));for(const L of C)w.push([L,n.getKeysForOverrideIdentifier(L)])}if(o){const C=M.filter(L=>!T.includes(L));for(const L of C)w.push([L,o.getKeysForOverrideIdentifier(L)])}if(n&&o){for(const C of M)if(T.includes(C)){const L=t({contents:o.getOverrideValue(void 0,C)||{},keys:o.getKeysForOverrideIdentifier(C)},{contents:n.getOverrideValue(void 0,C)||{},keys:n.getKeysForOverrideIdentifier(C)});w.push([C,[...L.added,...L.removed,...L.updated]])}}return{added:l,removed:d,updated:D,overrides:w}}function t(o,n){const l=o?n?o.keys.filter(w=>n.keys.indexOf(w)===-1):[...o.keys]:[],d=n?o?n.keys.filter(w=>o.keys.indexOf(w)===-1):[...n.keys]:[],D=[];if(o&&n){for(const w of n.keys)if(o.keys.indexOf(w)!==-1){const M=(0,m.getConfigurationValue)(n.contents,w),T=(0,m.getConfigurationValue)(o.contents,w);R.equals(M,T)||D.push(w)}}return{added:l,removed:d,updated:D}}}),define(le[208],ue([0,1,21,4,2,37,12,128,56,5,40,46]),function(j,e,i,s,y,k,A,R,S,c,m,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyConfiguration=e.NullPolicyConfiguration=e.DefaultConfiguration=void 0;class p extends y.Disposable{get configurationModel(){return this._configurationModel}constructor(E){super(),this.logService=E,this._onDidChangeConfiguration=this._register(new s.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this._configurationModel=R.ConfigurationModel.createEmptyModel(this.logService)}async initialize(){return this.resetConfigurationModel(),this._register(u.Registry.as(S.Extensions.Configuration).onDidUpdateConfiguration(({properties:E,defaultsOverrides:b})=>this.onDidUpdateConfiguration(Array.from(E),b))),this.configurationModel}reload(){return this.resetConfigurationModel(),this.configurationModel}onDidUpdateConfiguration(E,b){this.updateConfigurationModel(E,u.Registry.as(S.Extensions.Configuration).getConfigurationProperties()),this._onDidChangeConfiguration.fire({defaults:this.configurationModel,properties:E})}getConfigurationDefaultOverrides(){return{}}resetConfigurationModel(){this._configurationModel=R.ConfigurationModel.createEmptyModel(this.logService);const E=u.Registry.as(S.Extensions.Configuration).getConfigurationProperties();this.updateConfigurationModel(Object.keys(E),E)}updateConfigurationModel(E,b){const g=this.getConfigurationDefaultOverrides();for(const I of E){const P=g[I],r=b[I];P!==void 0?this._configurationModel.setValue(I,P):r?this._configurationModel.setValue(I,r.default):this._configurationModel.removeValue(I)}}}e.DefaultConfiguration=p;class v{constructor(){this.onDidChangeConfiguration=s.Event.None,this.configurationModel=R.ConfigurationModel.createEmptyModel(new c.NullLogService)}async initialize(){return this.configurationModel}}e.NullPolicyConfiguration=v;let f=class extends y.Disposable{get configurationModel(){return this._configurationModel}constructor(E,b,g){super(),this.defaultConfiguration=E,this.policyService=b,this.logService=g,this._onDidChangeConfiguration=this._register(new s.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this._configurationModel=R.ConfigurationModel.createEmptyModel(this.logService)}async initialize(){return this.logService.trace("PolicyConfiguration#initialize"),this.update(await this.updatePolicyDefinitions(this.defaultConfiguration.configurationModel.keys),!1),this._register(this.policyService.onDidChange(E=>this.onDidChangePolicies(E))),this._register(this.defaultConfiguration.onDidChangeConfiguration(async({properties:E})=>this.update(await this.updatePolicyDefinitions(E),!0))),this._configurationModel}async updatePolicyDefinitions(E){this.logService.trace("PolicyConfiguration#updatePolicyDefinitions",E);const b={},g=[],I=u.Registry.as(S.Extensions.Configuration).getConfigurationProperties();for(const P of E){const r=I[P];if(!r){g.push(P);continue}if(r.policy){if(r.type!=="string"&&r.type!=="number"){this.logService.warn(`Policy ${r.policy.name} has unsupported type ${r.type}`);continue}g.push(P),b[r.policy.name]={type:r.type}}}return(0,A.isEmptyObject)(b)||await this.policyService.updatePolicyDefinitions(b),g}onDidChangePolicies(E){this.logService.trace("PolicyConfiguration#onDidChangePolicies",E);const b=u.Registry.as(S.Extensions.Configuration).getPolicyConfigurations(),g=(0,i.coalesce)(E.map(I=>b.get(I)));this.update(g,!0)}update(E,b){this.logService.trace("PolicyConfiguration#update",E);const g=u.Registry.as(S.Extensions.Configuration).getConfigurationProperties(),I=[],P=this._configurationModel.isEmpty();for(const r of E){const a=g[r]?.policy?.name;if(a){const t=this.policyService.getPolicyValue(a);(P?t!==void 0:!(0,k.equals)(this._configurationModel.getValue(r),t))&&I.push([r,t])}else this._configurationModel.getValue(r)!==void 0&&I.push([r,void 0])}if(I.length){this.logService.trace("PolicyConfiguration#changed",I);const r=this._configurationModel;this._configurationModel=R.ConfigurationModel.createEmptyModel(this.logService);for(const a of r.keys)this._configurationModel.setValue(a,r.getValue(a));for(const[a,t]of I)t===void 0?this._configurationModel.removeValue(a):this._configurationModel.setValue(a,t);b&&this._onDidChangeConfiguration.fire(this._configurationModel)}}};e.PolicyConfiguration=f,e.PolicyConfiguration=f=Pe([re(1,m.IPolicyService),re(2,c.ILogService)],f)}),define(le[209],ue([0,1,21,8,17,4,43,110,2,31,37,3,18,16,128,56,208,14,40]),function(j,e,i,s,y,k,A,R,S,c,m,u,p,v,f,h,E,b,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class I extends S.Disposable{constructor(a,t,o,n){super(),this.settingsResource=a,this.logService=n,this._onDidChangeConfiguration=this._register(new k.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.defaultConfiguration=this._register(new E.DefaultConfiguration(n)),this.policyConfiguration=o instanceof g.NullPolicyService?new E.NullPolicyConfiguration:this._register(new E.PolicyConfiguration(this.defaultConfiguration,o,n)),this.userConfiguration=this._register(new f.UserSettings(this.settingsResource,{},p.extUriBiasedIgnorePathCase,t,n)),this.configuration=new f.Configuration(this.defaultConfiguration.configurationModel,this.policyConfiguration.configurationModel,f.ConfigurationModel.createEmptyModel(n),f.ConfigurationModel.createEmptyModel(n),f.ConfigurationModel.createEmptyModel(n),f.ConfigurationModel.createEmptyModel(n),new c.ResourceMap,f.ConfigurationModel.createEmptyModel(n),new c.ResourceMap,n),this.configurationEditing=new P(a,t,this),this.reloadConfigurationScheduler=this._register(new s.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(this.defaultConfiguration.onDidChangeConfiguration(({defaults:l,properties:d})=>this.onDidDefaultConfigurationChange(l,d))),this._register(this.policyConfiguration.onDidChangeConfiguration(l=>this.onDidPolicyConfigurationChange(l))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const[a,t,o]=await Promise.all([this.defaultConfiguration.initialize(),this.policyConfiguration.initialize(),this.userConfiguration.loadConfiguration()]);this.configuration=new f.Configuration(a,t,f.ConfigurationModel.createEmptyModel(this.logService),o,f.ConfigurationModel.createEmptyModel(this.logService),f.ConfigurationModel.createEmptyModel(this.logService),new c.ResourceMap,f.ConfigurationModel.createEmptyModel(this.logService),new c.ResourceMap,this.logService)}getConfigurationData(){return this.configuration.toData()}getValue(a,t){const o=typeof a=="string"?a:void 0,n=(0,v.isConfigurationOverrides)(a)?a:(0,v.isConfigurationOverrides)(t)?t:{};return this.configuration.getValue(o,n,void 0)}async updateValue(a,t,o,n,l){const d=(0,v.isConfigurationUpdateOverrides)(o)?o:(0,v.isConfigurationOverrides)(o)?{resource:o.resource,overrideIdentifiers:o.overrideIdentifier?[o.overrideIdentifier]:void 0}:void 0,D=d?n:o;if(D!==void 0&&D!==v.ConfigurationTarget.USER_LOCAL&&D!==v.ConfigurationTarget.USER)throw new Error(`Unable to write ${a} to target ${D}.`);d?.overrideIdentifiers&&(d.overrideIdentifiers=(0,i.distinct)(d.overrideIdentifiers),d.overrideIdentifiers=d.overrideIdentifiers.length?d.overrideIdentifiers:void 0);const w=this.inspect(a,{resource:d?.resource,overrideIdentifier:d?.overrideIdentifiers?d.overrideIdentifiers[0]:void 0});if(w.policyValue!==void 0)throw new Error(`Unable to write ${a} because it is configured in system policy.`);if((0,m.equals)(t,w.defaultValue)&&(t=void 0),d?.overrideIdentifiers?.length&&d.overrideIdentifiers.length>1){const T=d.overrideIdentifiers.sort(),C=this.configuration.localUserConfiguration.overrides.find(L=>(0,i.equals)([...L.identifiers].sort(),T));C&&(d.overrideIdentifiers=C.identifiers)}const M=d?.overrideIdentifiers?.length?[(0,h.keyFromOverrideIdentifiers)(d.overrideIdentifiers),a]:[a];await this.configurationEditing.write(M,t),await this.reloadConfiguration()}inspect(a,t={}){return this.configuration.inspect(a,t,void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const a=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(a)}onDidChangeUserConfiguration(a){const t=this.configuration.toData(),o=this.configuration.compareAndUpdateLocalUserConfiguration(a);this.trigger(o,t,v.ConfigurationTarget.USER)}onDidDefaultConfigurationChange(a,t){const o=this.configuration.toData(),n=this.configuration.compareAndUpdateDefaultConfiguration(a,t);this.trigger(n,o,v.ConfigurationTarget.DEFAULT)}onDidPolicyConfigurationChange(a){const t=this.configuration.toData(),o=this.configuration.compareAndUpdatePolicyConfiguration(a);this.trigger(o,t,v.ConfigurationTarget.DEFAULT)}trigger(a,t,o){const n=new f.ConfigurationChangeEvent(a,{data:t},this.configuration,void 0,this.logService);n.source=o,this._onDidChangeConfiguration.fire(n)}}e.ConfigurationService=I;class P{constructor(a,t,o){this.settingsResource=a,this.fileService=t,this.configurationService=o,this.queue=new s.Queue}write(a,t){return this.queue.queue(()=>this.doWriteConfiguration(a,t))}async doWriteConfiguration(a,t){let o;try{o=(await this.fileService.readFile(this.settingsResource)).value.toString()}catch(d){if(d.fileOperationResult===b.FileOperationResult.FILE_NOT_FOUND)o="{}";else throw d}const n=[];if((0,A.parse)(o,n,{allowTrailingComma:!0,allowEmptyContent:!0}),n.length>0)throw new Error("Unable to write into the settings file. Please open the file to correct errors/warnings in the file and try again.");const l=this.getEdits(o,a,t);o=(0,R.applyEdits)(o,l),await this.fileService.writeFile(this.settingsResource,y.VSBuffer.fromString(o))}getEdits(a,t,o){const{tabSize:n,insertSpaces:l,eol:d}=this.formattingOptions;if(!t.length){const D=JSON.stringify(o,null,l?" ".repeat(n):"	");return[{content:D,length:D.length,offset:0}]}return(0,R.setProperty)(a,t,o,{tabSize:n,insertSpaces:l,eol:d})}get formattingOptions(){if(!this._formattingOptions){let a=u.OS===u.OperatingSystem.Linux||u.OS===u.OperatingSystem.Macintosh?`
`:`\r
`;const t=this.configurationService.getValue("files.eol",{overrideIdentifier:"jsonc"});t&&typeof t=="string"&&t!=="auto"&&(a=t),this._formattingOptions={eol:a,insertSpaces:!!this.configurationService.getValue("editor.insertSpaces",{overrideIdentifier:"jsonc"}),tabSize:this.configurationService.getValue("editor.tabSize",{overrideIdentifier:"jsonc"})}}return this._formattingOptions}}}),define(le[210],ue([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeRemoteResourceRouter=e.NODE_REMOTE_RESOURCE_CHANNEL_NAME=e.NODE_REMOTE_RESOURCE_IPC_METHOD_NAME=void 0,e.NODE_REMOTE_RESOURCE_IPC_METHOD_NAME="request",e.NODE_REMOTE_RESOURCE_CHANNEL_NAME="remoteResourceHandler";class i{async routeCall(y,k,A){if(k!==e.NODE_REMOTE_RESOURCE_IPC_METHOD_NAME)throw new Error(`Call not found: ${k}`);const R=A[0];if(R?.authority){const S=y.connections.find(c=>c.ctx===R.authority);if(S)return S}throw new Error("Caller not found")}routeEvent(y,k){throw new Error(`Event not found: ${k}`)}}e.NodeRemoteResourceRouter=i}),define(le[211],ue([0,1,15,6]),function(j,e,i,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.WebSocketRemoteConnection=e.ManagedRemoteConnection=e.RemoteConnectionType=e.IRemoteAuthorityResolverService=void 0,e.getRemoteAuthorityPrefix=c,e.IRemoteAuthorityResolverService=(0,s.createDecorator)("remoteAuthorityResolverService");var y;(function(m){m[m.WebSocket=0]="WebSocket",m[m.Managed=1]="Managed"})(y||(e.RemoteConnectionType=y={}));class k{constructor(u){this.id=u,this.type=y.Managed}toString(){return`Managed(${this.id})`}}e.ManagedRemoteConnection=k;class A{constructor(u,p){this.host=u,this.port=p,this.type=y.WebSocket}toString(){return`WebSocket(${this.host}:${this.port})`}}e.WebSocketRemoteConnection=A;var R;(function(m){m.Unknown="Unknown",m.NotAvailable="NotAvailable",m.TemporarilyNotAvailable="TemporarilyNotAvailable",m.NoResolverFound="NoResolverFound",m.InvalidAuthority="InvalidAuthority"})(R||(e.RemoteAuthorityResolverErrorCode=R={}));class S extends i.ErrorNoTelemetry{static isNotAvailable(u){return u instanceof S&&u._code===R.NotAvailable}static isTemporarilyNotAvailable(u){return u instanceof S&&u._code===R.TemporarilyNotAvailable}static isNoResolverFound(u){return u instanceof S&&u._code===R.NoResolverFound}static isInvalidAuthority(u){return u instanceof S&&u._code===R.InvalidAuthority}static isHandled(u){return u instanceof S&&u.isHandled}constructor(u,p=R.Unknown,v){super(u),this._message=u,this._code=p,this._detail=v,this.isHandled=p===R.NotAvailable&&v===!0,Object.setPrototypeOf(this,S.prototype)}}e.RemoteAuthorityResolverError=S;function c(m){const u=m.indexOf("+");return u===-1?m:m.substring(0,u)}}),define(le[212],ue([0,1,8,17,22,15,4,2,11,71,60,33,121,211]),function(j,e,i,s,y,k,A,R,S,c,m,u,p,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.PersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.ConnectionType=void 0,e.connectRemoteAgentManagement=w,e.connectRemoteAgentExtensionHost=M,e.connectRemoteAgentTunnel=C,c=Re(c);const f=30*1e3;var h;(function(oe){oe[oe.Management=1]="Management",oe[oe.ExtensionHost=2]="ExtensionHost",oe[oe.Tunnel=3]="Tunnel"})(h||(e.ConnectionType=h={}));function E(oe){switch(oe){case h.Management:return"Management";case h.ExtensionHost:return"ExtensionHost";case h.Tunnel:return"Tunnel"}}function b(oe){const te=new y.CancellationTokenSource;return setTimeout(()=>te.cancel(),oe),te.token}function g(oe,te){if(oe.isCancellationRequested||te.isCancellationRequested)return y.CancellationToken.Cancelled;const O=new y.CancellationTokenSource;return oe.onCancellationRequested(()=>O.cancel()),te.onCancellationRequested(()=>O.cancel()),O.token}class I{get didTimeout(){return this._state==="timedout"}constructor(te){this._state="pending",this._disposables=new R.DisposableStore,{promise:this.promise,resolve:this._resolvePromise,reject:this._rejectPromise}=(0,i.promiseWithResolvers)(),te.isCancellationRequested?this._timeout():this._disposables.add(te.onCancellationRequested(()=>this._timeout()))}registerDisposable(te){this._state==="pending"?this._disposables.add(te):te.dispose()}_timeout(){this._state==="pending"&&(this._disposables.dispose(),this._state="timedout",this._rejectPromise(this._createTimeoutError()))}_createTimeoutError(){const te=new Error("Time limit reached");return te.code="ETIMEDOUT",te.syscall="connect",te}resolve(te){this._state==="pending"&&(this._disposables.dispose(),this._state="resolved",this._resolvePromise(te))}reject(te){this._state==="pending"&&(this._disposables.dispose(),this._state="rejected",this._rejectPromise(te))}}function P(oe,te){const O=new I(te);return O.registerDisposable(oe.onControlMessage(X=>{const B=JSON.parse(X.toString()),F=x(B);F?O.reject(F):O.resolve(B)})),O.promise}function r(oe,te,O,X,B,F,J,G){const $=new I(G),Z=m.StopWatch.create(!1);return oe.info(`Creating a socket (${J})...`),c.mark(`code/willCreateSocket/${F}`),te.connect(O,X,B,J).then(ae=>{$.didTimeout?(c.mark(`code/didCreateSocketError/${F}`),oe.info(`Creating a socket (${J}) finished after ${Z.elapsed()} ms, but this is too late and has timed out already.`),ae?.dispose()):(c.mark(`code/didCreateSocketOK/${F}`),oe.info(`Creating a socket (${J}) was successful after ${Z.elapsed()} ms.`),$.resolve(ae))},ae=>{c.mark(`code/didCreateSocketError/${F}`),oe.info(`Creating a socket (${J}) returned an error after ${Z.elapsed()} ms.`),oe.error(ae),$.reject(ae)}),$.promise}function a(oe,te){const O=new I(te);return oe.then(X=>{O.didTimeout||O.resolve(X)},X=>{O.didTimeout||O.reject(X)}),O.promise}async function t(oe,te,O,X){const B=H(oe,te);oe.logService.trace(`${B} 1/6. invoking socketFactory.connect().`);let F;try{F=await r(oe.logService,oe.remoteSocketFactoryService,oe.connectTo,S.RemoteAuthorities.getServerRootPath(),`reconnectionToken=${oe.reconnectionToken}&reconnection=${oe.reconnectionProtocol?"true":"false"}`,E(te),`renderer-${E(te)}-${oe.reconnectionToken}`,X)}catch(ae){throw oe.logService.error(`${B} socketFactory.connect() failed or timed out. Error:`),oe.logService.error(ae),ae}oe.logService.trace(`${B} 2/6. socketFactory.connect() was successful.`);let J,G;oe.reconnectionProtocol?(oe.reconnectionProtocol.beginAcceptReconnection(F,null),J=oe.reconnectionProtocol,G=!1):(J=new p.PersistentProtocol({socket:F}),G=!0),oe.logService.trace(`${B} 3/6. sending AuthRequest control message.`);const $=await a(oe.signService.createNewMessage((0,u.generateUuid)()),X),Z={type:"auth",auth:oe.connectionToken||"00000000000000000000",data:$.data};J.sendControl(s.VSBuffer.fromString(JSON.stringify(Z)));try{const ae=await P(J,g(X,b(1e4)));if(ae.type!=="sign"||typeof ae.data!="string"){const We=new Error("Unexpected handshake message");throw We.code="VSCODE_CONNECTION_ERROR",We}if(oe.logService.trace(`${B} 4/6. received SignRequest control message.`),!await a(oe.signService.validate($,ae.signedData),X)){const We=new Error("Refused to connect to unsupported server");throw We.code="VSCODE_CONNECTION_ERROR",We}const Se=await a(oe.signService.sign(ae.data),X),ye={type:"connectionType",commit:oe.commit,signedData:Se,desiredConnectionType:te};return O&&(ye.args=O),oe.logService.trace(`${B} 5/6. sending ConnectionTypeRequest control message.`),J.sendControl(s.VSBuffer.fromString(JSON.stringify(ye))),{protocol:J,ownsProtocol:G}}catch(ae){throw ae&&ae.code==="ETIMEDOUT"&&(oe.logService.error(`${B} the handshake timed out. Error:`),oe.logService.error(ae)),ae&&ae.code==="VSCODE_CONNECTION_ERROR"&&(oe.logService.error(`${B} received error control message when negotiating connection. Error:`),oe.logService.error(ae)),G&&N(J),ae}}async function o(oe,te,O,X){const B=Date.now(),F=H(oe,te),{protocol:J,ownsProtocol:G}=await t(oe,te,O,X),$=new I(X);return $.registerDisposable(J.onControlMessage(Z=>{const ae=JSON.parse(Z.toString()),pe=x(ae);pe?(oe.logService.error(`${F} received error control message when negotiating connection. Error:`),oe.logService.error(pe),G&&N(J),$.reject(pe)):(oe.reconnectionProtocol?.endAcceptReconnection(),oe.logService.trace(`${F} 6/6. handshake finished, connection is up and running after ${ce(B)}!`),$.resolve({protocol:J,firstMessage:ae}))})),$.promise}async function n(oe,te){const{protocol:O}=await o(oe,h.Management,void 0,te);return{protocol:O}}async function l(oe,te,O){const{protocol:X,firstMessage:B}=await o(oe,h.ExtensionHost,te,O),F=B&&B.debugPort;return{protocol:X,debugPort:F}}async function d(oe,te,O){const X=Date.now(),B=H(oe,h.Tunnel),{protocol:F}=await t(oe,h.Tunnel,te,O);return oe.logService.trace(`${B} 6/6. handshake finished, connection is up and running after ${ce(X)}!`),F}async function D(oe,te,O){const{connectTo:X,connectionToken:B}=await oe.addressProvider.getAddress();return{commit:oe.commit,quality:oe.quality,connectTo:X,connectionToken:B,reconnectionToken:te,reconnectionProtocol:O,remoteSocketFactoryService:oe.remoteSocketFactoryService,signService:oe.signService,logService:oe.logService}}async function w(oe,te,O){return T(oe,async X=>{const{protocol:B}=await n(X,y.CancellationToken.None);return new U(oe,te,O,X.reconnectionToken,B)})}async function M(oe,te){return T(oe,async O=>{const{protocol:X,debugPort:B}=await l(O,te,y.CancellationToken.None);return new K(oe,te,O.reconnectionToken,X,B)})}async function T(oe,te){for(let X=1;;X++)try{const B=(0,u.generateUuid)(),F=await D(oe,B,null);return await te(F)}catch(B){if(X<5)oe.logService.error(`[remote-connection][attempt ${X}] An error occurred in initial connection! Will retry... Error:`),oe.logService.error(B);else throw oe.logService.error(`[remote-connection][attempt ${X}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),oe.logService.error(B),ee.triggerPermanentFailure(0,0,v.RemoteAuthorityResolverError.isHandled(B)),B}}async function C(oe,te,O){const X=await D(oe,(0,u.generateUuid)(),null);return await d(X,{host:te,port:O},y.CancellationToken.None)}function L(oe){return(0,i.createCancelablePromise)(te=>new Promise((O,X)=>{const B=setTimeout(O,oe*1e3);te.onCancellationRequested(()=>{clearTimeout(B),O()})}))}var _;(function(oe){oe[oe.ConnectionLost=0]="ConnectionLost",oe[oe.ReconnectionWait=1]="ReconnectionWait",oe[oe.ReconnectionRunning=2]="ReconnectionRunning",oe[oe.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",oe[oe.ConnectionGain=4]="ConnectionGain"})(_||(e.PersistentConnectionEventType=_={}));class V{constructor(te,O){this.reconnectionToken=te,this.millisSinceLastIncomingData=O,this.type=_.ConnectionLost}}e.ConnectionLostEvent=V;class z{constructor(te,O,X,B){this.reconnectionToken=te,this.millisSinceLastIncomingData=O,this.durationSeconds=X,this.cancellableTimer=B,this.type=_.ReconnectionWait}skipWait(){this.cancellableTimer.cancel()}}e.ReconnectionWaitEvent=z;class Q{constructor(te,O,X){this.reconnectionToken=te,this.millisSinceLastIncomingData=O,this.attempt=X,this.type=_.ReconnectionRunning}}e.ReconnectionRunningEvent=Q;class fe{constructor(te,O,X){this.reconnectionToken=te,this.millisSinceLastIncomingData=O,this.attempt=X,this.type=_.ConnectionGain}}e.ConnectionGainEvent=fe;class se{constructor(te,O,X,B){this.reconnectionToken=te,this.millisSinceLastIncomingData=O,this.attempt=X,this.handled=B,this.type=_.ReconnectionPermanentFailure}}e.ReconnectionPermanentFailureEvent=se;class ee extends R.Disposable{static triggerPermanentFailure(te,O,X){this._permanentFailure=!0,this._permanentFailureMillisSinceLastIncomingData=te,this._permanentFailureAttempt=O,this._permanentFailureHandled=X,this._instances.forEach(B=>B._gotoPermanentFailure(this._permanentFailureMillisSinceLastIncomingData,this._permanentFailureAttempt,this._permanentFailureHandled))}static debugTriggerReconnection(){this._instances.forEach(te=>te._beginReconnecting())}static debugPauseSocketWriting(){this._instances.forEach(te=>te._pauseSocketWriting())}static{this._permanentFailure=!1}static{this._permanentFailureMillisSinceLastIncomingData=0}static{this._permanentFailureAttempt=0}static{this._permanentFailureHandled=!1}static{this._instances=[]}get _isPermanentFailure(){return this._permanentFailure||ee._permanentFailure}constructor(te,O,X,B,F){super(),this._connectionType=te,this._options=O,this.reconnectionToken=X,this.protocol=B,this._reconnectionFailureIsFatal=F,this._onDidStateChange=this._register(new A.Emitter),this.onDidStateChange=this._onDidStateChange.event,this._permanentFailure=!1,this._isReconnecting=!1,this._isDisposed=!1,this._onDidStateChange.fire(new fe(this.reconnectionToken,0,0)),this._register(B.onSocketClose(J=>{const G=ie(this._connectionType,this.reconnectionToken,!0);J?J.type===p.SocketCloseEventType.NodeSocketCloseEvent?(this._options.logService.info(`${G} received socket close event (hadError: ${J.hadError}).`),J.error&&this._options.logService.error(J.error)):(this._options.logService.info(`${G} received socket close event (wasClean: ${J.wasClean}, code: ${J.code}, reason: ${J.reason}).`),J.event&&this._options.logService.error(J.event)):this._options.logService.info(`${G} received socket close event.`),this._beginReconnecting()})),this._register(B.onSocketTimeout(J=>{const G=ie(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${G} received socket timeout event (unacknowledgedMsgCount: ${J.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${J.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${J.timeSinceLastReceivedSomeData}).`),this._beginReconnecting()})),ee._instances.push(this),this._register((0,R.toDisposable)(()=>{const J=ee._instances.indexOf(this);J>=0&&ee._instances.splice(J,1)})),this._isPermanentFailure&&this._gotoPermanentFailure(ee._permanentFailureMillisSinceLastIncomingData,ee._permanentFailureAttempt,ee._permanentFailureHandled)}dispose(){super.dispose(),this._isDisposed=!0}async _beginReconnecting(){if(!this._isReconnecting)try{this._isReconnecting=!0,await this._runReconnectingLoop()}finally{this._isReconnecting=!1}}async _runReconnectingLoop(){if(this._isPermanentFailure||this._isDisposed)return;const te=ie(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${te} starting reconnecting loop. You can get more information with the trace log level.`),this._onDidStateChange.fire(new V(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const O=[0,5,5,10,10,10,10,10,30];let X=-1;do{X++;const B=X<O.length?O[X]:O[O.length-1];try{if(B>0){const J=L(B);this._onDidStateChange.fire(new z(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),B,J)),this._options.logService.info(`${te} waiting for ${B} seconds before reconnecting...`);try{await J}catch{}}if(this._isPermanentFailure){this._options.logService.error(`${te} permanent failure occurred while running the reconnecting loop.`);break}this._onDidStateChange.fire(new Q(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),X+1)),this._options.logService.info(`${te} resolving connection...`);const F=await D(this._options,this.reconnectionToken,this.protocol);this._options.logService.info(`${te} connecting to ${F.connectTo}...`),await this._reconnect(F,b(f)),this._options.logService.info(`${te} reconnected!`),this._onDidStateChange.fire(new fe(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),X+1));break}catch(F){if(F.code==="VSCODE_CONNECTION_ERROR"){this._options.logService.error(`${te} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this._options.logService.error(F),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),X+1,!1);break}if(X>360){this._options.logService.error(`${te} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this._options.logService.error(F),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),X+1,!1);break}if(v.RemoteAuthorityResolverError.isTemporarilyNotAvailable(F)){this._options.logService.info(`${te} A temporarily not available error occurred while trying to reconnect, will try again...`),this._options.logService.trace(F);continue}if((F.code==="ETIMEDOUT"||F.code==="ENETUNREACH"||F.code==="ECONNREFUSED"||F.code==="ECONNRESET")&&F.syscall==="connect"){this._options.logService.info(`${te} A network error occurred while trying to reconnect, will try again...`),this._options.logService.trace(F);continue}if((0,k.isCancellationError)(F)){this._options.logService.info(`${te} A promise cancelation error occurred while trying to reconnect, will try again...`),this._options.logService.trace(F);continue}if(F instanceof v.RemoteAuthorityResolverError){this._options.logService.error(`${te} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this._options.logService.error(F),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),X+1,v.RemoteAuthorityResolverError.isHandled(F));break}this._options.logService.error(`${te} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this._options.logService.error(F),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),X+1,!1);break}}while(!this._isPermanentFailure&&!this._isDisposed)}_onReconnectionPermanentFailure(te,O,X){this._reconnectionFailureIsFatal?ee.triggerPermanentFailure(te,O,X):this._gotoPermanentFailure(te,O,X)}_gotoPermanentFailure(te,O,X){this._onDidStateChange.fire(new se(this.reconnectionToken,te,O,X)),N(this.protocol)}_pauseSocketWriting(){this.protocol.pauseSocketWriting()}}e.PersistentConnection=ee;class U extends ee{constructor(te,O,X,B,F){super(h.Management,te,B,F,!0),this.client=this._register(new p.Client(F,{remoteAuthority:O,clientId:X},te.ipcLogger))}async _reconnect(te,O){await n(te,O)}}e.ManagementPersistentConnection=U;class K extends ee{constructor(te,O,X,B,F){super(h.ExtensionHost,te,X,B,!1),this._startArguments=O,this.debugPort=F}async _reconnect(te,O){await l(te,this._startArguments,O)}}e.ExtensionHostPersistentConnection=K;function N(oe){try{oe.acceptDisconnect();const te=oe.getSocket();oe.dispose(),te.dispose()}catch(te){(0,k.onUnexpectedError)(te)}}function x(oe){if(oe&&oe.type==="error"){const te=new Error(`Connection error: ${oe.reason}`);return te.code="VSCODE_CONNECTION_ERROR",te}return null}function W(oe,te){for(;oe.length<te;)oe+=" ";return oe}function q(oe,te){return`[remote-connection][${W(E(oe),13)}][${te.substr(0,5)}\u2026]`}function ie(oe,te,O){return`${q(oe,te)}[${O?"reconnect":"initial"}]`}function H(oe,te){return`${ie(te,oe.reconnectionToken,!!oe.reconnectionProtocol)}[${oe.connectTo}]`}function ce(oe){return`${Date.now()-oe} ms`}}),define(le[75],ue([0,1,11]),function(j,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteAuthority=s,e.getRemoteName=y,e.parseAuthorityWithPort=k,e.parseAuthorityWithOptionalPort=A;function s(S){return S.scheme===i.Schemas.vscodeRemote?S.authority:void 0}function y(S){if(!S)return;const c=S.indexOf("+");return c<0?S:S.substr(0,c)}function k(S){const{host:c,port:m}=R(S);if(typeof m>"u")throw new Error(`Invalid remote authority: ${S}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:c,port:m}}function A(S,c){let{host:m,port:u}=R(S);return typeof u>"u"&&(u=c),{host:m,port:u}}function R(S){const c=S.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(c)return{host:c[1],port:parseInt(c[2],10)};const m=S.match(/^(\[[0-9a-z:]+\])$/);if(m)return{host:m[1],port:void 0};const u=S.match(/(.*):(\d+)$/);return u?{host:u[1],port:parseInt(u[2],10)}:{host:S,port:void 0}}}),define(le[87],ue([0,1,25,6,75]),function(j,e,i,s,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.ExtensionIdentifierMap=e.ExtensionIdentifierSet=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=void 0,e.getWorkspaceSupportTypeMessage=k,e.isApplicationScopedExtension=u,e.isLanguagePackExtension=p,e.isAuthenticationProviderExtension=v,e.isResolverExtension=f,e.parseApiProposals=h,e.parseEnabledApiProposalNames=E,i=Re(i),e.USER_MANIFEST_CACHE_FILE="extensions.user.cache",e.BUILTIN_MANIFEST_CACHE_FILE="extensions.builtin.cache",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function k(b){if(typeof b=="object"&&b!==null&&b.supported!==!0)return b.description}e.EXTENSION_CATEGORIES=["AI","Azure","Chat","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var A;(function(b){b[b.System=0]="System",b[b.User=1]="User"})(A||(e.ExtensionType=A={}));var R;(function(b){b.WIN32_X64="win32-x64",b.WIN32_ARM64="win32-arm64",b.LINUX_X64="linux-x64",b.LINUX_ARM64="linux-arm64",b.LINUX_ARMHF="linux-armhf",b.LINUX_PPC64LE="linux-ppc64le",b.LINUX_RISCV64="linux-riscv64",b.ALPINE_X64="alpine-x64",b.ALPINE_ARM64="alpine-arm64",b.DARWIN_X64="darwin-x64",b.DARWIN_ARM64="darwin-arm64",b.WEB="web",b.UNIVERSAL="universal",b.UNKNOWN="unknown",b.UNDEFINED="undefined"})(R||(e.TargetPlatform=R={}));class S{constructor(g){this.value=g,this._lower=g.toLowerCase()}static equals(g,I){if(typeof g>"u"||g===null)return typeof I>"u"||I===null;if(typeof I>"u"||I===null)return!1;if(typeof g=="string"||typeof I=="string"){const P=typeof g=="string"?g:g.value,r=typeof I=="string"?I:I.value;return i.equalsIgnoreCase(P,r)}return g._lower===I._lower}static toKey(g){return typeof g=="string"?g.toLowerCase():g._lower}}e.ExtensionIdentifier=S;class c{get size(){return this._set.size}constructor(g){if(this._set=new Set,g)for(const I of g)this.add(I)}add(g){this._set.add(S.toKey(g))}delete(g){return this._set.delete(S.toKey(g))}has(g){return this._set.has(S.toKey(g))}}e.ExtensionIdentifierSet=c;class m{constructor(){this._map=new Map}clear(){this._map.clear()}delete(g){this._map.delete(S.toKey(g))}get(g){return this._map.get(S.toKey(g))}has(g){return this._map.has(S.toKey(g))}set(g,I){this._map.set(S.toKey(g),I)}values(){return this._map.values()}forEach(g){this._map.forEach(g)}[Symbol.iterator](){return this._map[Symbol.iterator]()}}e.ExtensionIdentifierMap=m;function u(b){return p(b)}function p(b){return b.contributes&&b.contributes.localizations?b.contributes.localizations.length>0:!1}function v(b){return b.contributes&&b.contributes.authentication?b.contributes.authentication.length>0:!1}function f(b,g){if(g){const I=`onResolveRemoteAuthority:${(0,y.getRemoteName)(g)}`;return!!b.activationEvents?.includes(I)}return!1}function h(b){return b.map(g=>{const[I,P]=g.split("@");return{proposalName:I,version:P?parseInt(P):void 0}})}function E(b){return b.map(g=>g.split("@")[0])}e.IBuiltinExtensionsScannerService=(0,s.createDecorator)("IBuiltinExtensionsScannerService")}),define(le[129],ue([0,1,3,9,87,6]),function(j,e,i,s,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.ExtensionsLocalizedLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.ExtensionGalleryError=e.ExtensionGalleryErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.ExtensionInstallSource=e.EXTENSION_INSTALL_CLIENT_TARGET_PLATFORM_CONTEXT=e.EXTENSION_INSTALL_DEP_PACK_CONTEXT=e.EXTENSION_INSTALL_SOURCE_CONTEXT=e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.TargetPlatformToString=R,e.toTargetPlatform=S,e.getTargetPlatform=c,e.isNotWebExtensionInWebTargetPlatform=m,e.isTargetPlatformCompatible=u,e.isIExtensionIdentifier=p,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension",e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT="skipWalkthrough",e.EXTENSION_INSTALL_SOURCE_CONTEXT="extensionInstallSource",e.EXTENSION_INSTALL_DEP_PACK_CONTEXT="dependecyOrPackExtensionInstall",e.EXTENSION_INSTALL_CLIENT_TARGET_PLATFORM_CONTEXT="clientTargetPlatform";var A;(function(r){r.COMMAND="command",r.SETTINGS_SYNC="settingsSync"})(A||(e.ExtensionInstallSource=A={}));function R(r){switch(r){case y.TargetPlatform.WIN32_X64:return"Windows 64 bit";case y.TargetPlatform.WIN32_ARM64:return"Windows ARM";case y.TargetPlatform.LINUX_X64:return"Linux 64 bit";case y.TargetPlatform.LINUX_ARM64:return"Linux ARM 64";case y.TargetPlatform.LINUX_ARMHF:return"Linux ARM";case y.TargetPlatform.LINUX_PPC64LE:return"Linux PowerPC64";case y.TargetPlatform.LINUX_RISCV64:return"Linux RISC-V 64";case y.TargetPlatform.ALPINE_X64:return"Alpine Linux 64 bit";case y.TargetPlatform.ALPINE_ARM64:return"Alpine ARM 64";case y.TargetPlatform.DARWIN_X64:return"Mac";case y.TargetPlatform.DARWIN_ARM64:return"Mac Silicon";case y.TargetPlatform.WEB:return"Web";case y.TargetPlatform.UNIVERSAL:return y.TargetPlatform.UNIVERSAL;case y.TargetPlatform.UNKNOWN:return y.TargetPlatform.UNKNOWN;case y.TargetPlatform.UNDEFINED:return y.TargetPlatform.UNDEFINED}}function S(r){switch(r){case y.TargetPlatform.WIN32_X64:return y.TargetPlatform.WIN32_X64;case y.TargetPlatform.WIN32_ARM64:return y.TargetPlatform.WIN32_ARM64;case y.TargetPlatform.LINUX_X64:return y.TargetPlatform.LINUX_X64;case y.TargetPlatform.LINUX_ARM64:return y.TargetPlatform.LINUX_ARM64;case y.TargetPlatform.LINUX_ARMHF:return y.TargetPlatform.LINUX_ARMHF;case y.TargetPlatform.LINUX_PPC64LE:return y.TargetPlatform.LINUX_PPC64LE;case y.TargetPlatform.LINUX_RISCV64:return y.TargetPlatform.LINUX_RISCV64;case y.TargetPlatform.ALPINE_X64:return y.TargetPlatform.ALPINE_X64;case y.TargetPlatform.ALPINE_ARM64:return y.TargetPlatform.ALPINE_ARM64;case y.TargetPlatform.DARWIN_X64:return y.TargetPlatform.DARWIN_X64;case y.TargetPlatform.DARWIN_ARM64:return y.TargetPlatform.DARWIN_ARM64;case y.TargetPlatform.WEB:return y.TargetPlatform.WEB;case y.TargetPlatform.UNIVERSAL:return y.TargetPlatform.UNIVERSAL;default:return y.TargetPlatform.UNKNOWN}}function c(r,a){switch(r){case i.Platform.Windows:return a==="x64"?y.TargetPlatform.WIN32_X64:a==="arm64"?y.TargetPlatform.WIN32_ARM64:y.TargetPlatform.UNKNOWN;case i.Platform.Linux:return a==="x64"?y.TargetPlatform.LINUX_X64:a==="arm64"?y.TargetPlatform.LINUX_ARM64:a==="arm"?y.TargetPlatform.LINUX_ARMHF:a==="ppc64le"?y.TargetPlatform.LINUX_PPC64LE:a==="riscv64"?y.TargetPlatform.LINUX_RISCV64:y.TargetPlatform.UNKNOWN;case"alpine":return a==="x64"?y.TargetPlatform.ALPINE_X64:a==="arm64"?y.TargetPlatform.ALPINE_ARM64:y.TargetPlatform.UNKNOWN;case i.Platform.Mac:return a==="x64"?y.TargetPlatform.DARWIN_X64:a==="arm64"?y.TargetPlatform.DARWIN_ARM64:y.TargetPlatform.UNKNOWN;case i.Platform.Web:return y.TargetPlatform.WEB}}function m(r,a){return a===y.TargetPlatform.WEB&&!r.includes(y.TargetPlatform.WEB)}function u(r,a,t){return m(a,t)?!1:r===y.TargetPlatform.UNDEFINED||r===y.TargetPlatform.UNIVERSAL?!0:r===y.TargetPlatform.UNKNOWN?!1:r===t}function p(r){return r&&typeof r=="object"&&typeof r.id=="string"&&(!r.uuid||typeof r.uuid=="string")}var v;(function(r){r[r.NoneOrRelevance=0]="NoneOrRelevance",r[r.LastUpdatedDate=1]="LastUpdatedDate",r[r.Title=2]="Title",r[r.PublisherName=3]="PublisherName",r[r.InstallCount=4]="InstallCount",r[r.PublishedDate=10]="PublishedDate",r[r.AverageRating=6]="AverageRating",r[r.WeightedRating=12]="WeightedRating"})(v||(e.SortBy=v={}));var f;(function(r){r[r.Default=0]="Default",r[r.Ascending=1]="Ascending",r[r.Descending=2]="Descending"})(f||(e.SortOrder=f={}));var h;(function(r){r.Install="install",r.Uninstall="uninstall"})(h||(e.StatisticType=h={}));var E;(function(r){r[r.None=1]="None",r[r.Install=2]="Install",r[r.Update=3]="Update",r[r.Migrate=4]="Migrate"})(E||(e.InstallOperation=E={})),e.IExtensionGalleryService=(0,k.createDecorator)("extensionGalleryService");var b;(function(r){r.Timeout="Timeout",r.Cancelled="Cancelled",r.Failed="Failed",r.DownloadFailedWriting="DownloadFailedWriting",r.Offline="Offline"})(b||(e.ExtensionGalleryErrorCode=b={}));class g extends Error{constructor(a,t){super(a),this.code=t,this.name=t}}e.ExtensionGalleryError=g;var I;(function(r){r.Unsupported="Unsupported",r.Deprecated="Deprecated",r.Malicious="Malicious",r.Incompatible="Incompatible",r.IncompatibleApi="IncompatibleApi",r.IncompatibleTargetPlatform="IncompatibleTargetPlatform",r.ReleaseVersionNotFound="ReleaseVersionNotFound",r.Invalid="Invalid",r.Download="Download",r.DownloadSignature="DownloadSignature",r.DownloadFailedWriting="DownloadFailedWriting",r.UpdateMetadata="UpdateMetadata",r.Extract="Extract",r.Scanning="Scanning",r.ScanningExtension="ScanningExtension",r.ReadUninstalled="ReadUninstalled",r.UnsetUninstalled="UnsetUninstalled",r.Delete="Delete",r.Rename="Rename",r.IntializeDefaultProfile="IntializeDefaultProfile",r.AddToProfile="AddToProfile",r.InstalledExtensionNotFound="InstalledExtensionNotFound",r.PostInstall="PostInstall",r.CorruptZip="CorruptZip",r.IncompleteZip="IncompleteZip",r.Signature="Signature",r.NotAllowed="NotAllowed",r.Gallery="Gallery",r.Cancelled="Cancelled",r.Unknown="Unknown",r.Internal="Internal"})(I||(e.ExtensionManagementErrorCode=I={}));class P extends Error{constructor(a,t){super(a),this.code=t,this.name=t}}e.ExtensionManagementError=P,e.IExtensionManagementService=(0,k.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,k.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,k.createDecorator)("IExtensionTipsService"),e.ExtensionsLocalizedLabel=(0,s.localize2)(1780,"Extensions"),e.PreferencesLocalizedLabel=(0,s.localize2)(1781,"Preferences")});var je=this&&this.__importDefault||function(j){return j&&j.__esModule?j:{default:j}};define(le[213],ue([0,1,18,81,9,214,87,176]),function(j,e,i,s,y,k,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isValidVersionStr=m,e.parseVersion=u,e.normalizeVersion=p,e.isValidVersion=v,e.validateExtensionManifest=f,e.isValidExtensionVersion=h,e.isEngineValid=E,e.areApiProposalsCompatible=b,s=je(s),y=Re(y),k=Re(k);const S=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,c=/^-(\d{4})(\d{2})(\d{2})$/;function m(P){return P=P.trim(),P==="*"||S.test(P)}function u(P){if(!m(P))return null;if(P=P.trim(),P==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const r=P.match(S);return r?{hasCaret:r[1]==="^",hasGreaterEquals:r[1]===">=",majorBase:r[2]==="x"?0:parseInt(r[2],10),majorMustEqual:r[2]!=="x",minorBase:r[4]==="x"?0:parseInt(r[4],10),minorMustEqual:r[4]!=="x",patchBase:r[6]==="x"?0:parseInt(r[6],10),patchMustEqual:r[6]!=="x",preRelease:r[8]||null}:null}function p(P){if(!P)return null;const r=P.majorBase,a=P.majorMustEqual,t=P.minorBase;let o=P.minorMustEqual;const n=P.patchBase;let l=P.patchMustEqual;P.hasCaret&&(r===0||(o=!1),l=!1);let d=0;if(P.preRelease){const D=c.exec(P.preRelease);if(D){const[,w,M,T]=D;d=Date.UTC(Number(w),Number(M)-1,Number(T))}}return{majorBase:r,majorMustEqual:a,minorBase:t,minorMustEqual:o,patchBase:n,patchMustEqual:l,isMinimum:P.hasGreaterEquals,notBefore:d}}function v(P,r,a){let t;typeof P=="string"?t=p(u(P)):t=P;let o;r instanceof Date?o=r.getTime():typeof r=="string"&&(o=new Date(r).getTime());let n;if(typeof a=="string"?n=p(u(a)):n=a,!t||!n)return!1;const l=t.majorBase,d=t.minorBase,D=t.patchBase;let w=n.majorBase,M=n.minorBase,T=n.patchBase;const C=n.notBefore;let L=n.majorMustEqual,_=n.minorMustEqual,V=n.patchMustEqual;return n.isMinimum?l>w?!0:l<w?!1:d>M?!0:d<M||o&&o<C?!1:D>=T:(l===1&&w===0&&(!L||!_||!V)&&(w=1,M=0,T=0,L=!0,_=!1,V=!1),l<w?!1:l>w?!L:d<M?!1:d>M?!_:D<T?!1:D>T?!V:!(o&&o<C))}function f(P,r,a,t,o,n){const l=[];if(typeof t.publisher<"u"&&typeof t.publisher!="string")return l.push([s.default.Error,y.localize(1832,null)]),l;if(typeof t.name!="string")return l.push([s.default.Error,y.localize(1833,null,"name")]),l;if(typeof t.version!="string")return l.push([s.default.Error,y.localize(1834,null,"version")]),l;if(!t.engines)return l.push([s.default.Error,y.localize(1835,null,"engines")]),l;if(typeof t.engines.vscode!="string")return l.push([s.default.Error,y.localize(1836,null,"engines.vscode")]),l;if(typeof t.extensionDependencies<"u"&&!I(t.extensionDependencies))return l.push([s.default.Error,y.localize(1837,null,"extensionDependencies")]),l;if(typeof t.activationEvents<"u"){if(!I(t.activationEvents))return l.push([s.default.Error,y.localize(1838,null,"activationEvents")]),l;if(typeof t.main>"u"&&typeof t.browser>"u")return l.push([s.default.Error,y.localize(1839,null,"activationEvents","main","browser")]),l}if(typeof t.extensionKind<"u"&&typeof t.main>"u"&&l.push([s.default.Warning,y.localize(1840,null,"extensionKind")]),typeof t.main<"u"){if(typeof t.main!="string")return l.push([s.default.Error,y.localize(1841,null,"main")]),l;{const w=(0,i.joinPath)(a,t.main);(0,i.isEqualOrParent)(w,a)||l.push([s.default.Warning,y.localize(1842,null,w.path,a.path)])}}if(typeof t.browser<"u"){if(typeof t.browser!="string")return l.push([s.default.Error,y.localize(1843,null,"browser")]),l;{const w=(0,i.joinPath)(a,t.browser);(0,i.isEqualOrParent)(w,a)||l.push([s.default.Warning,y.localize(1844,null,w.path,a.path)])}}if(!k.valid(t.version))return l.push([s.default.Error,y.localize(1845,null)]),l;const d=[];if(!h(P,r,t,o,d))for(const w of d)l.push([s.default.Error,w]);if(n&&t.enabledApiProposals?.length){const w=[];if(!b([...t.enabledApiProposals],w))for(const M of w)l.push([s.default.Error,M])}return l}function h(P,r,a,t,o){return t||typeof a.main>"u"&&typeof a.browser>"u"?!0:g(P,r,a.engines.vscode,o)}function E(P,r,a){return P==="*"||g(r,a,P)}function b(P,r){if(P.length===0)return!0;const a=Array.isArray(r)?r:void 0,t=(a?void 0:r)??R.allApiProposals,o=[],n=(0,A.parseApiProposals)(P);for(const{proposalName:l,version:d}of n){const D=t[l];D&&d&&D.version!==d&&o.push(y.localize(1846,null,l))}return a?.push(...o),o.length===0}function g(P,r,a,t=[]){const o=p(u(a));if(!o)return t.push(y.localize(1847,null,a)),!1;if(o.majorBase===0){if(!o.majorMustEqual||!o.minorMustEqual)return t.push(y.localize(1848,null,a)),!1}else if(!o.majorMustEqual)return t.push(y.localize(1849,null,a)),!1;return v(P,r,o)?!0:(t.push(y.localize(1850,null,P,a)),!1)}function I(P){if(!Array.isArray(P))return!1;for(let r=0,a=P.length;r<a;r++)if(typeof P[r]!="string")return!1;return!0}}),define(le[215],ue([0,1,2,6]),function(j,e,i,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteSocketFactoryService=e.IRemoteSocketFactoryService=void 0,e.IRemoteSocketFactoryService=(0,s.createDecorator)("remoteSocketFactoryService");class y{constructor(){this.factories={}}register(A,R){return this.factories[A]??=[],this.factories[A].push(R),(0,i.toDisposable)(()=>{const S=this.factories[A]?.indexOf(R);typeof S=="number"&&S>=0&&this.factories[A]?.splice(S,1)})}getSocketFactory(A){return(this.factories[A.type]||[]).find(S=>S.supports(A))}connect(A,R,S,c){const m=this.getSocketFactory(A);if(!m)throw new Error(`No socket factory found for ${A}`);return m.connect(A,R,S,c)}}e.RemoteSocketFactoryService=y}),define(le[216],ue([0,1,26,27,44,97]),function(j,e,i,s,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWSLFeatureInstalled=R,i=Re(i),s=Re(s),y=Re(y),k=Re(k);let A;async function R(v=!1){return(A===void 0||v)&&(A=S()),A}async function S(){const v=c();if(v===void 0)return!1;if(v>=22e3){const f=u();if(f)return new Promise(h=>{try{y.execFile(f,["--status"],E=>h(!E))}catch{h(!1)}})}else{const f=p();if(f)try{if((await i.promises.stat(f)).isFile())return!0}catch{}}return!1}function c(){const v=/(\d+)\.(\d+)\.(\d+)/g.exec(s.release());if(v)return parseInt(v[3])}function m(v){const f=process.env.SystemRoot;if(f){const h=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");return k.join(f,h?"Sysnative":"System32",v)}}function u(){return m("wsl.exe")}function p(){return m("lxss\\LxssManager.dll")}}),define(le[50],ue([0,1,17,15,2,9,56,6,5,46]),function(j,e,i,s,y,k,A,R,S,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractRequestService=e.IRequestService=void 0,e.isSuccess=p,e.hasNoContent=v,e.asText=f,e.asTextOrError=h,e.asJson=E,e.updateProxyConfigurationsScope=b,e.IRequestService=(0,R.createDecorator)("requestService");class m{constructor(r){this.original=r}toJSON(){if(!this.headers){const r=Object.create(null);for(const a in this.original)a.toLowerCase()==="authorization"||a.toLowerCase()==="proxy-authorization"?r[a]="*****":r[a]=this.original[a];this.headers=r}return this.headers}}class u extends y.Disposable{constructor(r){super(),this.counter=0,this.logger=r.createLogger("network",{name:(0,k.localize)(2050,null),when:S.CONTEXT_LOG_LEVEL.isEqualTo((0,S.LogLevelToString)(S.LogLevel.Trace)).serialize()})}async logAndRequest(r,a,t){const o=`${r} #${++this.counter}: ${a.url}`;this.logger.trace(`${o} - begin`,a.type,new m(a.headers??{}));try{const n=await t();return this.logger.trace(`${o} - end`,a.type,n.res.statusCode,n.res.headers),n}catch(n){throw this.logger.error(`${o} - error`,a.type,(0,s.getErrorMessage)(n)),n}}}e.AbstractRequestService=u;function p(P){return P.res.statusCode&&P.res.statusCode>=200&&P.res.statusCode<300||P.res.statusCode===1223}function v(P){return P.res.statusCode===204}async function f(P){return v(P)?null:(await(0,i.streamToBuffer)(P.stream)).toString()}async function h(P){if(!p(P))throw new Error("Server returned "+P.res.statusCode);return f(P)}async function E(P){if(!p(P))throw new Error("Server returned "+P.res.statusCode);if(v(P))return null;const a=(await(0,i.streamToBuffer)(P.stream)).toString();try{return JSON.parse(a)}catch(t){throw t.message+=`:
`+a,t}}function b(P){I(P)}let g;function I(P){const r=c.Registry.as(A.Extensions.Configuration),a=g;g={id:"http",order:15,title:(0,k.localize)(2051,null),type:"object",scope:P,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,k.localize)(2052,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,k.localize)(2053,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,k.localize)(2054,null),restricted:!0},"http.noProxy":{type:"array",items:{type:"string"},markdownDescription:(0,k.localize)(2055,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,k.localize)(2056,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,k.localize)(2057,null),(0,k.localize)(2058,null),(0,k.localize)(2059,null),(0,k.localize)(2060,null)],default:"override",description:(0,k.localize)(2061,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,k.localize)(2062,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,k.localize)(2063,null),restricted:!0}}},r.updateConfigurations({add:[g],remove:a?[a]:[]})}I(A.ConfigurationScope.APPLICATION)}),define(le[217],ue([0,1,17,22]),function(j,e,i,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestChannelClient=e.RequestChannel=void 0;class y{constructor(R){this.service=R}listen(R,S){throw new Error("Invalid listen")}call(R,S,c,m=s.CancellationToken.None){switch(S){case"request":return this.service.request(c[0],m).then(async({res:u,stream:p})=>{const v=await(0,i.streamToBuffer)(p);return[{statusCode:u.statusCode,headers:u.headers},v]});case"resolveProxy":return this.service.resolveProxy(c[0]);case"lookupAuthorization":return this.service.lookupAuthorization(c[0]);case"lookupKerberosAuthorization":return this.service.lookupKerberosAuthorization(c[0]);case"loadCertificates":return this.service.loadCertificates()}throw new Error("Invalid call")}}e.RequestChannel=y;class k{constructor(R){this.channel=R}async request(R,S){const[c,m]=await this.channel.call("request",[R],S);return{res:c,stream:(0,i.bufferToStream)(m)}}async resolveProxy(R){return this.channel.call("resolveProxy",[R])}async lookupAuthorization(R){return this.channel.call("lookupAuthorization",[R])}async lookupKerberosAuthorization(R){return this.channel.call("lookupKerberosAuthorization",[R])}async loadCertificates(){return this.channel.call("loadCertificates")}}e.RequestChannelClient=k}),define(le[218],ue([0,1,219,12]),function(j,e,i,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=k;function y(A,R){return A.protocol==="http:"?R.HTTP_PROXY||R.http_proxy||null:A.protocol==="https:"&&(R.HTTPS_PROXY||R.https_proxy||R.HTTP_PROXY||R.http_proxy)||null}async function k(A,R,S={}){const c=(0,i.parse)(A),m=S.proxyUrl||y(c,R);if(!m)return null;const u=(0,i.parse)(m);if(!/^https?:$/.test(u.protocol||""))return null;const p={host:u.hostname||"",port:(u.port?+u.port:0)||(u.protocol==="https"?443:80),auth:u.auth,rejectUnauthorized:(0,s.isBoolean)(S.strictSSL)?S.strictSSL:!0};if(c.protocol==="http:"){const v=await new Promise((f,h)=>{j(["http-proxy-agent"],f,h)}).then(Re);return new v.HttpProxyAgent(m,p)}else{const v=await new Promise((f,h)=>{j(["https-proxy-agent"],f,h)}).then(Re);return new v.HttpsProxyAgent(m,p)}}}),define(le[220],ue([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessRawConnection=e.SharedProcessChannelConnection=e.SharedProcessLifecycle=void 0,e.SharedProcessLifecycle={exit:"vscode:electron-main->shared-process=exit",ipcReady:"vscode:shared-process->electron-main=ipc-ready",initDone:"vscode:shared-process->electron-main=init-done"},e.SharedProcessChannelConnection={request:"vscode:createSharedProcessChannelConnection",response:"vscode:createSharedProcessChannelConnectionResult"},e.SharedProcessRawConnection={request:"vscode:createSharedProcessRawConnection",response:"vscode:createSharedProcessRawConnectionResult"}}),define(le[103],ue([0,1,44,10,9,22,55,15,3,33,120,69,8,147]),function(j,e,i,s,y,k,A,R,S,c,m,u,p,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=h;let f;async function h(b,g,I,P){return I["force-disable-user-env"]?(g.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):S.isWindows?(g.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,u.isLaunchedFromCli)(P)&&!I["force-user-env"]?(g.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,u.isLaunchedFromCli)(P)?g.trace("resolveShellEnv(): running (--force-user-env)"):g.trace("resolveShellEnv(): running (macOS/Linux)"),f||(f=p.Promises.withAsyncBody(async(r,a)=>{const t=new k.CancellationTokenSource;let o=1e4;const n=b.getValue("application.shellEnvironmentResolutionTimeout");typeof n=="number"&&(o=(0,v.clamp)(n,1,120)*1e3);const l=setTimeout(()=>{t.dispose(!0),a(new Error((0,y.localize)(2064,null)))},o);try{r(await E(g,t.token))}catch(d){!(0,R.isCancellationError)(d)&&!t.token.isCancellationRequested?a(new Error((0,y.localize)(2065,null,(0,A.toErrorMessage)(d)))):r({})}finally{clearTimeout(l),t.dispose()}})),f)}async function E(b,g){const I=process.env.ELECTRON_RUN_AS_NODE;b.trace("getUnixShellEnvironment#runAsNode",I);const P=process.env.ELECTRON_NO_ATTACH_CONSOLE;b.trace("getUnixShellEnvironment#noAttach",P);const r=(0,c.generateUuid)().replace(/-/g,"").substr(0,12),a=new RegExp(r+"({.*})"+r),t={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};b.trace("getUnixShellEnvironment#env",t);const o=await(0,m.getSystemShell)(S.OS,t);return b.trace("getUnixShellEnvironment#shell",o),new Promise((n,l)=>{if(g.isCancellationRequested)return l(new R.CancellationError);const d=(0,s.basename)(o);let D,w;const M="";/^pwsh(-preview)?$/.test(d)?(D=`& '${process.execPath}' ${M} -p '''${r}'' + JSON.stringify(process.env) + ''${r}'''`,w=["-Login","-Command"]):d==="nu"?(D=`^'${process.execPath}' ${M} -p '"${r}" + JSON.stringify(process.env) + "${r}"'`,w=["-i","-l","-c"]):d==="xonsh"?(D=`import os, json; print("${r}", json.dumps(dict(os.environ)), "${r}")`,w=["-i","-l","-c"]):(D=`'${process.execPath}' ${M} -p '"${r}" + JSON.stringify(process.env) + "${r}"'`,d==="tcsh"||d==="csh"?w=["-ic"]:w=["-i","-l","-c"]),b.trace("getUnixShellEnvironment#spawn",JSON.stringify(w),D);const T=(0,i.spawn)(o,[...w,D],{detached:!0,stdio:["ignore","pipe","pipe"],env:t});g.onCancellationRequested(()=>(T.kill(),l(new R.CancellationError))),T.on("error",_=>{b.error("getUnixShellEnvironment#errorChildProcess",(0,A.toErrorMessage)(_)),l(_)});const C=[];T.stdout.on("data",_=>C.push(_));const L=[];T.stderr.on("data",_=>L.push(_)),T.on("close",(_,V)=>{const z=Buffer.concat(C).toString("utf8");b.trace("getUnixShellEnvironment#raw",z);const Q=Buffer.concat(L).toString("utf8");if(Q.trim()&&b.trace("getUnixShellEnvironment#stderr",Q),_||V)return l(new Error((0,y.localize)(2066,null,_,V)));const fe=a.exec(z),se=fe?fe[1]:"{}";try{const ee=JSON.parse(se);I?ee.ELECTRON_RUN_AS_NODE=I:delete ee.ELECTRON_RUN_AS_NODE,P?ee.ELECTRON_NO_ATTACH_CONSOLE=P:delete ee.ELECTRON_NO_ATTACH_CONSOLE,delete ee.VSCODE_RESOLVING_ENVIRONMENT,delete ee.XDG_RUNTIME_DIR,b.trace("getUnixShellEnvironment#result",ee),n(ee)}catch(ee){b.error("getUnixShellEnvironment#errorCaught",(0,A.toErrorMessage)(ee)),l(ee)}})})}}),define(le[221],ue([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractSignService=void 0;class i{constructor(){this.validators=new Map}static{this._nextId=1}async createNewMessage(y){try{const k=await this.getValidator();if(k){const A=String(i._nextId++);return this.validators.set(A,k),{id:A,data:k.createNewMessage(y)}}}catch{}return{id:"",data:y}}async validate(y,k){if(!y.id)return!0;const A=this.validators.get(y.id);if(!A)return!1;this.validators.delete(y.id);try{return A.validate(k)==="ok"}catch{return!1}finally{A.dispose?.()}}async sign(y){try{return await this.signValue(y)}catch{}return y}}e.AbstractSignService=i}),define(le[104],ue([0,1,6]),function(j,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,i.createDecorator)(e.SIGN_SERVICE_ID)}),define(le[222],ue([0,1,160,221]),function(j,e,i,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class y extends s.AbstractSignService{getValidator(){return this.vsda().then(A=>new A.validator)}signValue(A){return this.vsda().then(R=>new R.signer().sign(A))}async vsda(){return(0,i.importAMDNodeModule)("vsda","index.js")}}e.SignService=y}),define(le[34],ue([0,1,6]),function(j,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateService=e.IStateReadService=void 0,e.IStateReadService=(0,i.createDecorator)("stateReadService"),e.IStateService=(0,i.createDecorator)("stateService")}),define(le[130],ue([0,1,8,17,2,12,36,14,5]),function(j,e,i,s,y,k,A,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateService=e.StateReadonlyService=e.FileStorage=e.SaveStrategy=void 0;var c;(function(v){v[v.IMMEDIATE=0]="IMMEDIATE",v[v.DELAYED=1]="DELAYED"})(c||(e.SaveStrategy=c={}));class m extends y.Disposable{constructor(f,h,E,b){super(),this.storagePath=f,this.saveStrategy=h,this.logService=E,this.fileService=b,this.storage=Object.create(null),this.lastSavedStorageContents="",this.flushDelayer=this._register(new i.ThrottledDelayer(this.saveStrategy===c.IMMEDIATE?0:100)),this.initializing=void 0,this.closing=void 0}init(){return this.initializing||(this.initializing=this.doInit()),this.initializing}async doInit(){try{this.lastSavedStorageContents=(await this.fileService.readFile(this.storagePath)).value.toString(),this.storage=JSON.parse(this.lastSavedStorageContents)}catch(f){f.fileOperationResult!==R.FileOperationResult.FILE_NOT_FOUND&&this.logService.error(f)}}getItem(f,h){const E=this.storage[f];return(0,k.isUndefinedOrNull)(E)?h:E}setItem(f,h){this.setItems([{key:f,data:h}])}setItems(f){let h=!1;for(const{key:E,data:b}of f)this.storage[E]!==b&&((0,k.isUndefinedOrNull)(b)?(0,k.isUndefined)(this.storage[E])||(this.storage[E]=void 0,h=!0):(this.storage[E]=b,h=!0));h&&this.save()}removeItem(f){(0,k.isUndefined)(this.storage[f])||(this.storage[f]=void 0,this.save())}async save(){if(!this.closing)return this.flushDelayer.trigger(()=>this.doSave())}async doSave(){if(!this.initializing)return;await this.initializing;const f=JSON.stringify(this.storage,null,4);if(f!==this.lastSavedStorageContents)try{await this.fileService.writeFile(this.storagePath,s.VSBuffer.fromString(f),{atomic:{postfix:".vsctmp"}}),this.lastSavedStorageContents=f}catch(h){this.logService.error(h)}}async close(){return this.closing||(this.closing=this.flushDelayer.trigger(()=>this.doSave(),0)),this.closing}}e.FileStorage=m;let u=class extends y.Disposable{constructor(f,h,E,b){super(),this.fileStorage=this._register(new m(h.stateResource,f,E,b))}async init(){await this.fileStorage.init()}getItem(f,h){return this.fileStorage.getItem(f,h)}};e.StateReadonlyService=u,e.StateReadonlyService=u=Pe([re(1,A.IEnvironmentService),re(2,S.ILogService),re(3,R.IFileService)],u);class p extends u{setItem(f,h){this.fileStorage.setItem(f,h)}setItems(f){this.fileStorage.setItems(f)}removeItem(f){this.fileStorage.removeItem(f)}close(){return this.fileStorage.close()}}e.StateService=p}),define(le[131],ue([0,1,3,38,33]),function(j,e,i,s,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveCommonProperties=A,e.verifyMicrosoftInternalDomain=R;function k(S){if(i.platform===i.Platform.Linux&&/^penguin(\.|$)/i.test(S))return"chromebook"}function A(S,c,m,u,p,v,f,h,E,b){const g=Object.create(null);g["common.machineId"]=v,g["common.sqmId"]=f,g["common.devDeviceId"]=h,g.sessionID=(0,y.generateUuid)()+Date.now(),g.commitHash=u,g.version=p,g["common.platformVersion"]=(S||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),g["common.platform"]=(0,i.PlatformToString)(i.platform),g["common.nodePlatform"]=s.platform,g["common.nodeArch"]=m,g["common.product"]=b||"desktop",E&&(g["common.msftInternal"]=E);let I=0;const P=Date.now();Object.defineProperties(g,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-P,enumerable:!0},"common.sequence":{get:()=>I++,enumerable:!0}}),i.isLinuxSnap&&(g["common.snap"]="true");const r=k(c);return r&&(g["common.platformDetail"]=r),g}function R(S){const c=s.env.USERDNSDOMAIN;if(!c)return!1;const m=c.toLowerCase();return S.some(u=>m===u)}}),define(le[24],ue([0,1,6]),function(j,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_CRASH_REPORTER_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.devDeviceIdKey=e.sqmIdKey=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,i.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,i.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.sqmIdKey="telemetry.sqmId",e.devDeviceIdKey="telemetry.devDeviceId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_CRASH_REPORTER_SETTING_ID="telemetry.enableCrashReporter",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var s;(function(k){k[k.NONE=0]="NONE",k[k.CRASH=1]="CRASH",k[k.ERROR=2]="ERROR",k[k.USAGE=3]="USAGE"})(s||(e.TelemetryLevel=s={}));var y;(function(k){k.OFF="off",k.CRASH="crash",k.ERROR="error",k.ON="all"})(y||(e.TelemetryConfiguration=y={}))}),define(le[223],ue([0,1,26,27,8,43,11,10,3,60,7,95,23,119,99,14,28,24]),function(j,e,i,s,y,k,A,R,S,c,m,u,p,v,f,h,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=void 0,e.collectWorkspaceStats=I,e.getMachineInfo=r,e.collectLaunchConfigs=a,i=Re(i),s=Re(s);const g=new Map;async function I(o,n){const l=`${o}::${n.join(":")}`,d=g.get(l);if(d)return d;const D=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i},{tag:"cursorrules",filePattern:/^\.cursorrules$/i}],w=new Map,M=new Map,T=2e4;function C(_,V,z,Q){const fe=V.substring(_.length+1);return y.Promises.withAsyncBody(async se=>{let ee;Q.readdirCount++;try{ee=await p.Promises.readdir(V,{withFileTypes:!0})}catch{se();return}if(Q.count>=T){Q.count+=ee.length,Q.maxReached=!0,se();return}let U=ee.length;if(U===0){se();return}let K=ee;Q.count+ee.length>T&&(Q.maxReached=!0,U=T-Q.count,K=ee.slice(0,U)),Q.count+=ee.length;for(const N of K)if(N.isDirectory()){if(z.includes(N.name)||await C(_,(0,R.join)(V,N.name),z,Q),--U===0){se();return}}else{const x=N.name.lastIndexOf(".");if(x>=0){const W=N.name.substring(x+1);W&&w.set(W,(w.get(W)??0)+1)}for(const W of D)W.relativePathPattern?.test(fe)!==!1&&W.filePattern.test(N.name)&&M.set(W.tag,(M.get(W.tag)??0)+1);if(--U===0){se();return}}})}const L=y.Promises.withAsyncBody(async _=>{const V={count:0,maxReached:!1,readdirCount:0},z=new c.StopWatch(!0);await C(o,o,n,V);const Q=await a(o);_({configFiles:P(M),fileTypes:P(w),fileCount:V.count,maxFilesReached:V.maxReached,launchConfigFiles:Q,totalScanTime:z.elapsed(),totalReaddirCount:V.readdirCount})});return g.set(l,L),L}function P(o){return Array.from(o.entries(),([n,l])=>({name:n,count:l})).sort((n,l)=>l.count-n.count)}function r(){const o={os:`${s.type()} ${s.arch()} ${s.release()}`,memory:`${(s.totalmem()/h.ByteSize.GB).toFixed(2)}GB (${(s.freemem()/h.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(u.virtualMachineHint.value()*100)}%`},n=s.cpus();return n&&n.length>0&&(o.cpus=`${n[0].model} (${n.length} x ${n[0].speed})`),o}async function a(o){try{const n=new Map,l=(0,R.join)(o,".vscode","launch.json"),d=await i.promises.readFile(l),D=[],w=(0,k.parse)(d.toString(),D);if(D.length)return console.log(`Unable to parse ${l}`),[];if((0,k.getNodeType)(w)==="object"&&w.configurations)for(const M of w.configurations){const T=M.type;T&&(n.has(T)?n.set(T,n.get(T)+1):n.set(T,1))}return P(n)}catch{return[]}}let t=class{constructor(n,l){this.telemetryService=n,this.productService=l}formatMachineInfo(n){const l=[];return l.push(`OS Version:       ${n.os}`),l.push(`CPUs:             ${n.cpus}`),l.push(`Memory (System):  ${n.memory}`),l.push(`VM:               ${n.vmHint}`),l.join(`
`)}formatEnvironment(n){const l=[];l.push(`Version:          ${this.productService.nameShort} ${this.productService.version} ${this.productService.release||"Release unknown"} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),l.push(`OS Version:       ${s.type()} ${s.arch()} ${s.release()}`);const d=s.cpus();return d&&d.length>0&&l.push(`CPUs:             ${d[0].model} (${d.length} x ${d[0].speed})`),l.push(`Memory (System):  ${(s.totalmem()/h.ByteSize.GB).toFixed(2)}GB (${(s.freemem()/h.ByteSize.GB).toFixed(2)}GB free)`),S.isWindows||l.push(`Load (avg):       ${s.loadavg().map(D=>Math.round(D)).join(", ")}`),l.push(`VM:               ${Math.round(u.virtualMachineHint.value()*100)}%`),l.push(`Screen Reader:    ${n.screenReader?"yes":"no"}`),l.push(`Process Argv:     ${n.mainArguments.join(" ")}`),l.push(`GPU Status:       ${this.expandGPUFeatures(n.gpuFeatureStatus)}`),l.join(`
`)}async getPerformanceInfo(n,l){return Promise.all([(0,v.listProcesses)(n.mainPID),this.formatWorkspaceMetadata(n)]).then(async d=>{let[D,w]=d,M=this.formatProcessList(n,D);return l.forEach(T=>{if((0,f.isRemoteDiagnosticError)(T))M+=`
${T.errorMessage}`,w+=`
${T.errorMessage}`;else if(M+=`

Remote: ${T.hostName}`,T.processes&&(M+=`
${this.formatProcessList(n,T.processes)}`),T.workspaceMetadata){w+=`
|  Remote: ${T.hostName}`;for(const C of Object.keys(T.workspaceMetadata)){const L=T.workspaceMetadata[C];let _=`${L.fileCount} files`;L.maxFilesReached&&(_=`more than ${_}`),w+=`|    Folder (${C}): ${_}`,w+=this.formatWorkspaceStats(L)}}}),{processInfo:M,workspaceInfo:w}})}async getSystemInfo(n,l){const{memory:d,vmHint:D,os:w,cpus:M}=r(),T={os:w,memory:d,cpus:M,vmHint:D,processArgs:`${n.mainArguments.join(" ")}`,gpuStatus:n.gpuFeatureStatus,screenReader:`${n.screenReader?"yes":"no"}`,remoteData:l};return S.isWindows||(T.load=`${s.loadavg().map(C=>Math.round(C)).join(", ")}`),S.isLinux&&(T.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(T)}async getDiagnostics(n,l){const d=[];return(0,v.listProcesses)(n.mainPID).then(async D=>(d.push(""),d.push(this.formatEnvironment(n)),d.push(""),d.push(this.formatProcessList(n,D)),n.windows.some(w=>w.folderURIs&&w.folderURIs.length>0&&!w.remoteAuthority)&&(d.push(""),d.push("Workspace Stats: "),d.push(await this.formatWorkspaceMetadata(n))),l.forEach(w=>{if((0,f.isRemoteDiagnosticError)(w))d.push(`
${w.errorMessage}`);else if(d.push(`

`),d.push(`Remote:           ${w.hostName}`),d.push(this.formatMachineInfo(w.machineInfo)),w.processes&&d.push(this.formatProcessList(n,w.processes)),w.workspaceMetadata)for(const M of Object.keys(w.workspaceMetadata)){const T=w.workspaceMetadata[M];let C=`${T.fileCount} files`;T.maxFilesReached&&(C=`more than ${C}`),d.push(`Folder (${M}): ${C}`),d.push(this.formatWorkspaceStats(T))}}),d.push(""),d.push(""),d.join(`
`)))}formatWorkspaceStats(n){const l=[];let D=0;const w=(L,_)=>{const V=` ${L}(${_})`;D+V.length>60?(l.push(M),M="|                 ",D=M.length):D+=V.length,M+=V};let M="|      File types:";const T=10,C=n.fileTypes.length>T?T:n.fileTypes.length;for(let L=0;L<C;L++){const _=n.fileTypes[L];w(_.name,_.count)}if(l.push(M),n.configFiles.length>=0&&(M="|      Conf files:",D=0,n.configFiles.forEach(L=>{w(L.name,L.count)}),l.push(M)),n.launchConfigFiles.length>0){let L="|      Launch Configs:";n.launchConfigFiles.forEach(_=>{const V=_.count>1?` ${_.name}(${_.count})`:` ${_.name}`;L+=V}),l.push(L)}return l.join(`
`)}expandGPUFeatures(n){const l=Math.max(...Object.keys(n).map(d=>d.length));return Object.keys(n).map(d=>`${d}:  ${" ".repeat(l-d.length)}  ${n[d]}`).join(`
                  `)}formatWorkspaceMetadata(n){const l=[],d=[];return n.windows.forEach(D=>{D.folderURIs.length===0||D.remoteAuthority||(l.push(`|  Window (${D.title})`),D.folderURIs.forEach(w=>{const M=m.URI.revive(w);if(M.scheme===A.Schemas.file){const T=M.fsPath;d.push(I(T,["node_modules",".git"]).then(C=>{let L=`${C.fileCount} files`;C.maxFilesReached&&(L=`more than ${L}`),l.push(`|    Folder (${(0,R.basename)(T)}): ${L}`),l.push(this.formatWorkspaceStats(C))}).catch(C=>{l.push(`|      Error: Unable to collect workspace stats for folder ${T} (${C.toString()})`)}))}else l.push(`|    Folder (${M.toString()}): Workspace stats not available.`)}))}),Promise.all(d).then(D=>l.join(`
`)).catch(D=>`Unable to collect workspace stats: ${D}`)}formatProcessList(n,l){const d=new Map;n.windows.forEach(w=>d.set(w.pid,`window [${w.id}] (${w.title})`)),n.pidToNames.forEach(({pid:w,name:M})=>d.set(w,M));const D=[];return D.push("CPU %	Mem MB	   PID	Process"),l&&this.formatProcessItem(n.mainPID,d,D,l,0),D.join(`
`)}formatProcessItem(n,l,d,D,w){const M=w===0;let T;M?T=D.pid===n?`${this.productService.applicationName} main`:"remote agent":l.has(D.pid)?T=l.get(D.pid):T=`${"  ".repeat(w)} ${D.name}`;const C=process.platform==="win32"?D.mem:s.totalmem()*(D.mem/100);d.push(`${D.load.toFixed(0).padStart(5," ")}	${(C/h.ByteSize.MB).toFixed(0).padStart(6," ")}	${D.pid.toFixed(0).padStart(6," ")}	${T}`),Array.isArray(D.children)&&D.children.forEach(L=>this.formatProcessItem(n,l,d,L,w+1))}async getWorkspaceFileExtensions(n){const l=new Set;for(const{uri:d}of n.folders){const D=m.URI.revive(d);if(D.scheme!==A.Schemas.file)continue;const w=D.fsPath;try{(await I(w,["node_modules",".git"])).fileTypes.forEach(T=>l.add(T.name))}catch{}}return{extensions:[...l]}}async reportWorkspaceStats(n){for(const{uri:l}of n.folders){const d=m.URI.revive(l);if(d.scheme!==A.Schemas.file)continue;const D=d.fsPath;try{const w=await I(D,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":n.telemetryId,rendererSessionId:n.rendererSessionId}),w.fileTypes.forEach(M=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:n.rendererSessionId,type:M.name,count:M.count})}),w.launchConfigFiles.forEach(M=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:n.rendererSessionId,type:M.name,count:M.count})}),w.configFiles.forEach(M=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:n.rendererSessionId,type:M.name,count:M.count})}),this.telemetryService.publicLog2("workspace.stats.metadata",{duration:w.totalScanTime,reachedLimit:w.maxFilesReached,fileCount:w.fileCount,readdirCount:w.totalReaddirCount})}catch{}}}};e.DiagnosticsService=t,e.DiagnosticsService=t=Pe([re(0,b.ITelemetryService),re(1,E.IProductService)],t)}),define(le[224],ue([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class i{constructor(k){this.appenders=k}listen(k,A){throw new Error(`Event not found: ${A}`)}call(k,A,{eventName:R,data:S}){return this.appenders.forEach(c=>c.log(R,S)),Promise.resolve(null)}}e.TelemetryAppenderChannel=i;class s{constructor(k){this.channel=k}log(k,A){return this.channel.call("log",{eventName:k,data:A}).then(void 0,R=>`Failed to log telemetry: ${console.warn(R)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=s}),define(le[57],ue([0,1,37,12,75,131,24]),function(j,e,i,s,y,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullAppender=e.extensionTelemetryLogChannelId=e.telemetryLogId=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TelemetryTrustedValue=void 0,e.supportsTelemetry=m,e.isLoggingOnly=u,e.getTelemetryLevel=p,e.validateTelemetryData=v,e.cleanRemoteAuthority=h,e.isInternalTelemetry=b,e.getPiiPathsFromEnvironment=g,e.cleanData=r;class R{constructor(t){this.value=t,this.isTrustedTelemetryValue=!0}}e.TelemetryTrustedValue=R;class S{constructor(){this.telemetryLevel=A.TelemetryLevel.NONE,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.devDeviceId="someValue.devDeviceId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.NullTelemetryServiceShape=S,e.NullTelemetryService=new S;class c{async publicLog(t,o,n){}async publicLogError(t,o,n){}}e.NullEndpointTelemetryService=c,e.telemetryLogId="telemetry",e.extensionTelemetryLogChannelId="extensionTelemetryLog",e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function m(a,t){return!t.isBuilt&&!t.disableTelemetry?!0:!(t.disableTelemetry||!a.enableTelemetry)}function u(a,t){return t.extensionTestsLocationURI?!0:!(t.isBuilt||t.disableTelemetry||a.enableTelemetry&&a.aiConfig?.ariaKey)}function p(a){const t=a.getValue(A.TELEMETRY_SETTING_ID),o=a.getValue(A.TELEMETRY_CRASH_REPORTER_SETTING_ID);if(a.getValue(A.TELEMETRY_OLD_SETTING_ID)===!1||o===!1)return A.TelemetryLevel.NONE;switch(t??A.TelemetryConfiguration.ON){case A.TelemetryConfiguration.ON:return A.TelemetryLevel.USAGE;case A.TelemetryConfiguration.ERROR:return A.TelemetryLevel.ERROR;case A.TelemetryConfiguration.CRASH:return A.TelemetryLevel.CRASH;case A.TelemetryConfiguration.OFF:return A.TelemetryLevel.NONE}}function v(a){const t={},o={},n={};E(a,n);for(let l in n){l=l.length>150?l.substr(l.length-149):l;const d=n[l];typeof d=="number"?o[l]=d:typeof d=="boolean"?o[l]=d?1:0:typeof d=="string"?(d.length>8192&&console.warn(`Telemetry property: ${l} has been trimmed to 8192, the original length is ${d.length}`),t[l]=d.substring(0,8191)):typeof d<"u"&&d!==null&&(t[l]=d)}return{properties:t,measurements:o}}const f=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function h(a){if(!a)return"none";const t=(0,y.getRemoteName)(a);return f.has(t)?t:"other"}function E(a,t,o=0,n){if(a)for(const l of Object.getOwnPropertyNames(a)){const d=a[l],D=n?n+l:l;Array.isArray(d)?t[D]=(0,i.safeStringify)(d):d instanceof Date?t[D]=d.toISOString():(0,s.isObject)(d)?o<2?E(d,t,o+1,D+"."):t[D]=(0,i.safeStringify)(d):t[D]=d}}function b(a,t){const o=a.msftInternalDomains||[],n=t.getValue("telemetry.internalTesting");return(0,k.verifyMicrosoftInternalDomain)(o)||n}function g(a){return[a.appRoot,a.extensionsPath,a.userHome.fsPath,a.tmpDir.fsPath,a.userDataPath]}function I(a,t){if(!a||!a.includes("/")&&!a.includes("\\"))return a;let o=a;const n=[];for(const w of t)for(;;){const M=w.exec(a);if(!M)break;n.push([M.index,w.lastIndex])}const l=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,d=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let D=0;for(o="";;){const w=d.exec(a);if(!w)break;const M=n.some(([T,C])=>w.index<C&&T<d.lastIndex);!l.test(w[0])&&!M&&(o+=a.substring(D,w.index)+"<REDACTED: user-file-path>",D=d.lastIndex)}return D<a.length&&(o+=a.substr(D)),o}function P(a){if(!a)return a;const t=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"CLI Credentials",regex:/((login|psexec|(certutil|psexec)\.exe).{1,50}(\s-u(ser(name)?)?\s+.{3,100})?\s-(admin|user|vm|root)?p(ass(word)?)?\s+["']?[^$\-\/\s]|(^|[\s\r\n\\])net(\.exe)?.{1,5}(user\s+|share\s+\/user:| user -? secrets ? set) \s + [^ $\s \/])/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const o of t)if(o.regex.test(a))return`<REDACTED: ${o.label}>`;return a}function r(a,t){return(0,i.cloneAndChange)(a,o=>{if(o instanceof R||Object.hasOwnProperty.call(o,"isTrustedTelemetryValue"))return o.value;if(typeof o=="string"){let n=o.replaceAll("%20"," ");n=I(n,t);for(const l of t)n=n.replace(l,"");return n=P(n),n}})}}),define(le[132],ue([0,1,25,129,87,3,7,15,38,57]),function(j,e,i,s,y,k,A,R,S,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BetterMergeId=e.ExtensionKey=void 0,e.areSameExtensions=m,e.getIdAndVersion=f,e.getExtensionId=h,e.adoptToGalleryExtensionId=E,e.getGalleryExtensionId=b,e.groupByExtension=g,e.getLocalExtensionTelemetryData=I,e.getGalleryExtensionTelemetryData=P,e.getExtensionDependencies=r,e.computeTargetPlatform=t;function m(o,n){return o.uuid&&n.uuid?o.uuid===n.uuid:o.id===n.id?!0:(0,i.compareIgnoreCase)(o.id,n.id)===0}const u=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class p{static create(n){const l=n.manifest?n.manifest.version:n.version,d=n.manifest?n.targetPlatform:n.properties.targetPlatform;return new p(n.identifier,l,d)}static parse(n){const l=u.exec(n);return l&&l[1]&&l[2]?new p({id:l[1]},l[2],l[4]||void 0):null}constructor(n,l,d=y.TargetPlatform.UNDEFINED){this.identifier=n,this.version=l,this.targetPlatform=d,this.id=n.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!==y.TargetPlatform.UNDEFINED?`-${this.targetPlatform}`:""}`}equals(n){return n instanceof p?m(this,n)&&this.version===n.version&&this.targetPlatform===n.targetPlatform:!1}}e.ExtensionKey=p;const v=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function f(o){const n=v.exec(o);return n&&n[1]?[E(n[1]),n[2]]:[E(o),void 0]}function h(o,n){return`${o}.${n}`}function E(o){return o.toLowerCase()}function b(o,n){return E(h(o??y.UNDEFINED_PUBLISHER,n))}function g(o,n){const l=[],d=D=>{for(const w of l)if(w.some(M=>m(n(M),n(D))))return w;return null};for(const D of o){const w=d(D);w?w.push(D):l.push([D])}return l}function I(o){return{id:o.identifier.id,name:o.manifest.name,galleryId:null,publisherId:o.publisherId,publisherName:o.manifest.publisher,publisherDisplayName:o.publisherDisplayName,dependencies:o.manifest.extensionDependencies&&o.manifest.extensionDependencies.length>0}}function P(o){return{id:new c.TelemetryTrustedValue(o.identifier.id),name:new c.TelemetryTrustedValue(o.name),version:o.version,galleryId:o.identifier.uuid,publisherId:o.publisherId,publisherName:o.publisher,publisherDisplayName:o.publisherDisplayName,isPreReleaseVersion:o.properties.isPreReleaseVersion,dependencies:!!(o.properties.dependencies&&o.properties.dependencies.length>0),isSigned:o.isSigned,...o.telemetryData}}e.BetterMergeId=new y.ExtensionIdentifier("pprice.better-merge");function r(o,n){const l=[],d=n.manifest.extensionDependencies?.slice(0)??[];for(;d.length;){const D=d.shift();if(D&&l.every(w=>!m(w.identifier,{id:D}))){const w=o.filter(M=>m(M.identifier,{id:D}));w.length===1&&(l.push(w[0]),d.push(...w[0].manifest.extensionDependencies?.slice(0)??[]))}}return l}async function a(o,n){if(!k.isLinux)return!1;let l;try{l=(await o.readFile(A.URI.file("/etc/os-release"))).value.toString()}catch{try{l=(await o.readFile(A.URI.file("/usr/lib/os-release"))).value.toString()}catch(D){n.debug("Error while getting the os-release file.",(0,R.getErrorMessage)(D))}}return!!l&&(l.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function t(o,n){const l=await a(o,n),d=(0,s.getTargetPlatform)(l?"alpine":k.platform,S.arch);return n.debug("ComputeTargetPlatform:",d),d}});var je=this&&this.__importDefault||function(j){return j&&j.__esModule?j:{default:j}};define(le[225],ue([0,1,2,37,3,25,9,16,56,73,28,46,24,57]),function(j,e,i,s,y,k,A,R,S,c,m,u,p,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0,c=je(c);let f=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor(b,g,I){this._configurationService=g,this._productService=I,this._experimentProperties={},this._disposables=new i.DisposableStore,this._cleanupPatterns=[],this._appenders=b.appenders,this._commonProperties=b.commonProperties??Object.create(null),this.sessionId=this._commonProperties.sessionID,this.machineId=this._commonProperties["common.machineId"],this.sqmId=this._commonProperties["common.sqmId"],this.devDeviceId=this._commonProperties["common.devDeviceId"],this.firstSessionDate=this._commonProperties["common.firstSessionDate"],this.msftInternal=this._commonProperties["common.msftInternal"],this._piiPaths=b.piiPaths||[],this._telemetryLevel=p.TelemetryLevel.USAGE,this._sendErrorTelemetry=!!b.sendErrorTelemetry,this._cleanupPatterns=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const P of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,k.escapeRegExpCharacters)(P),"gi")),P.indexOf("\\")>=0&&this._cleanupPatterns.push(new RegExp((0,k.escapeRegExpCharacters)(P.replace(/\\/g,"/")),"gi"));this._updateTelemetryLevel(),this._disposables.add(this._configurationService.onDidChangeConfiguration(P=>{(P.affectsConfiguration(p.TELEMETRY_SETTING_ID)||P.affectsConfiguration(p.TELEMETRY_OLD_SETTING_ID)||P.affectsConfiguration(p.TELEMETRY_CRASH_REPORTER_SETTING_ID))&&this._updateTelemetryLevel()}))}setExperimentProperty(b,g){this._experimentProperties[b]=g}_updateTelemetryLevel(){let b=(0,v.getTelemetryLevel)(this._configurationService);const g=this._productService.enabledTelemetryLevels;if(g){this._sendErrorTelemetry=this.sendErrorTelemetry?g.error:!1;const I=g.usage?p.TelemetryLevel.USAGE:g.error?p.TelemetryLevel.ERROR:p.TelemetryLevel.NONE;b=Math.min(b,I)}this._telemetryLevel=b}get sendErrorTelemetry(){return this._sendErrorTelemetry}get telemetryLevel(){return this._telemetryLevel}dispose(){this._disposables.dispose()}_log(b,g,I){this._telemetryLevel<g||(I=(0,s.mixin)(I,this._experimentProperties),I=(0,v.cleanData)(I,this._cleanupPatterns),I=(0,s.mixin)(I,this._commonProperties),this._appenders.forEach(P=>P.log(b,I)))}publicLog(b,g){this._log(b,p.TelemetryLevel.USAGE,g)}publicLog2(b,g){this.publicLog(b,g)}publicLogError(b,g){this._sendErrorTelemetry&&this._log(b,p.TelemetryLevel.ERROR,g)}publicLogError2(b,g){this.publicLogError(b,g)}};e.TelemetryService=f,e.TelemetryService=f=Pe([re(1,R.IConfigurationService),re(2,m.IProductService)],f);function h(){const E=(0,A.localize)(2068,null,c.default.nameLong),b=c.default.privacyStatementUrl?(0,A.localize)(2070,null,"https://aka.ms/vscode-telemetry",c.default.privacyStatementUrl):(0,A.localize)(2069,null,"https://aka.ms/vscode-telemetry"),g=y.isWeb?"":(0,A.localize)(2071,null),I=(0,A.localize)(2072,null),P=(0,A.localize)(2073,null),r=(0,A.localize)(2074,null),a=(0,A.localize)(2075,null),t=`
|       | ${I} | ${P} | ${r} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,o=(0,A.localize)(2076,null);return`
${E} ${b} ${g}

&nbsp;

${a}
${t}

&nbsp;

${o}
`}u.Registry.as(S.Extensions.Configuration).registerConfiguration({id:p.TELEMETRY_SECTION_ID,order:1,type:"object",title:(0,A.localize)(2077,null),properties:{[p.TELEMETRY_SETTING_ID]:{type:"string",enum:[p.TelemetryConfiguration.ON,p.TelemetryConfiguration.ERROR,p.TelemetryConfiguration.CRASH,p.TelemetryConfiguration.OFF],enumDescriptions:[(0,A.localize)(2078,null),(0,A.localize)(2079,null),(0,A.localize)(2080,null),(0,A.localize)(2081,null)],markdownDescription:h(),default:p.TelemetryConfiguration.OFF,restricted:!0,scope:S.ConfigurationScope.APPLICATION,tags:["usesOnlineServices","telemetry"]}}}),u.Registry.as(S.Extensions.Configuration).registerConfiguration({id:p.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,A.localize)(2082,null),properties:{[p.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:c.default.privacyStatementUrl?(0,A.localize)(2084,null,c.default.nameLong,c.default.privacyStatementUrl):(0,A.localize)(2083,null,c.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,A.localize)(2085,null,`\`#${p.TELEMETRY_SETTING_ID}#\``),scope:S.ConfigurationScope.APPLICATION,tags:["usesOnlineServices","telemetry"]}}})}),define(le[226],ue([0,1,3,95,24]),function(j,e,i,s,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMachineId=k,e.resolveSqmId=A,e.resolvedevDeviceId=R;async function k(S,c){let m=S.getItem(y.machineIdKey);return(typeof m!="string"||i.isMacintosh&&m==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(m=await(0,s.getMachineId)(c.error.bind(c))),m}async function A(S,c){let m=S.getItem(y.sqmIdKey);return typeof m!="string"&&(m=await(0,s.getSqmMachineId)(c.error.bind(c))),m}async function R(S,c){let m=S.getItem(y.devDeviceIdKey);return typeof m!="string"&&(m=await(0,s.getdevDeviceId)(c.error.bind(c))),m}}),define(le[227],ue([0,1,24,226]),function(j,e,i,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMachineId=y,e.resolveSqmId=k,e.resolvedevDeviceId=A;async function y(R,S){const c=await(0,s.resolveMachineId)(R,S);return R.setItem(i.machineIdKey,c),c}async function k(R,S){const c=await(0,s.resolveSqmId)(R,S);return R.setItem(i.sqmIdKey,c),c}async function A(R,S){const c=await(0,s.resolvedevDeviceId)(R,S);return R.setItem(i.devDeviceIdKey,c),c}}),define(le[133],ue([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentVariableMutatorType=void 0;var i;(function(s){s[s.Replace=1]="Replace",s[s.Append=2]="Append",s[s.Prepend=3]="Prepend"})(i||(e.EnvironmentVariableMutatorType=i={}))}),define(le[228],ue([0,1,3,133]),function(j,e,i,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MergedEnvironmentVariableCollection=void 0;const y=new Map([[s.EnvironmentVariableMutatorType.Append,"APPEND"],[s.EnvironmentVariableMutatorType.Prepend,"PREPEND"],[s.EnvironmentVariableMutatorType.Replace,"REPLACE"]]);class k{constructor(m){this.collections=m,this.map=new Map,this.descriptionMap=new Map,m.forEach((u,p)=>{this.populateDescriptionMap(u,p);const v=u.map.entries();let f=v.next();for(;!f.done;){const h=f.value[1],E=f.value[0];let b=this.map.get(E);if(b||(b=[],this.map.set(E,b)),b.length>0&&b[0].type===s.EnvironmentVariableMutatorType.Replace){f=v.next();continue}const g={extensionIdentifier:p,value:h.value,type:h.type,scope:h.scope,variable:h.variable,options:h.options};g.scope||delete g.scope,b.unshift(g),f=v.next()}})}async applyToProcessEnvironment(m,u,p){let v;i.isWindows&&(v={},Object.keys(m).forEach(f=>v[f.toLowerCase()]=f));for(const[f,h]of this.getVariableMap(u)){const E=i.isWindows&&v[f.toLowerCase()]||f;for(const b of h){const g=p?await p(b.value):b.value;if(b.options?.applyAtProcessCreation??!0)switch(b.type){case s.EnvironmentVariableMutatorType.Append:m[E]=(m[E]||"")+g;break;case s.EnvironmentVariableMutatorType.Prepend:m[E]=g+(m[E]||"");break;case s.EnvironmentVariableMutatorType.Replace:m[E]=g;break}if(b.options?.applyAtShellIntegration??!1){const I=`VSCODE_ENV_${y.get(b.type)}`;m[I]=(m[I]?m[I]+":":"")+f+"="+this._encodeColons(g)}}}}_encodeColons(m){return m.replaceAll(":","\\x3a")}diff(m,u){const p=new Map,v=new Map,f=new Map;if(m.getVariableMap(u).forEach((h,E)=>{const b=this.getVariableMap(u).get(E),g=R(h,b);g&&p.set(E,g)}),this.getVariableMap(u).forEach((h,E)=>{const b=m.getVariableMap(u).get(E),g=R(h,b);g&&f.set(E,g)}),this.getVariableMap(u).forEach((h,E)=>{const b=m.getVariableMap(u).get(E),g=S(h,b);g&&v.set(E,g)}),!(p.size===0&&v.size===0&&f.size===0))return{added:p,changed:v,removed:f}}getVariableMap(m){const u=new Map;for(const p of this.map.values()){const v=p.filter(f=>A(f,m));v.length>0&&u.set(v[0].variable,v)}return u}getDescriptionMap(m){const u=new Map;for(const p of this.descriptionMap.values()){const v=p.filter(f=>A(f,m,!0));for(const f of v)u.set(f.extensionIdentifier,f.description)}return u}populateDescriptionMap(m,u){if(!m.descriptionMap)return;const p=m.descriptionMap.entries();let v=p.next();for(;!v.done;){const f=v.value[1],h=v.value[0];let E=this.descriptionMap.get(h);E||(E=[],this.descriptionMap.set(h,E));const b={extensionIdentifier:u,scope:f.scope,description:f.description};b.scope||delete b.scope,E.push(b),v=p.next()}}}e.MergedEnvironmentVariableCollection=k;function A(c,m,u=!1){return c.scope?!!(c.scope.workspaceFolder&&m?.workspaceFolder&&c.scope.workspaceFolder.index===m.workspaceFolder.index):u?m===c.scope:!0}function R(c,m){if(!m)return c;const u=new Set;m.forEach(v=>u.add(v.extensionIdentifier));const p=[];return c.forEach(v=>{u.has(v.extensionIdentifier)||p.push(v)}),p.length===0?void 0:p}function S(c,m){if(!m)return;const u=new Map;m.forEach(v=>u.set(v.extensionIdentifier,v));const p=[];return c.forEach(v=>{const f=u.get(v.extensionIdentifier);f&&(v.type!==f.type||v.value!==f.value||v.scope?.workspaceFolder?.index!==f.scope?.workspaceFolder?.index)&&p.push(f)}),p.length===0?void 0:p}}),define(le[229],ue([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.serializeEnvironmentVariableCollection=i,e.serializeEnvironmentDescriptionMap=s,e.deserializeEnvironmentVariableCollection=y,e.deserializeEnvironmentDescriptionMap=k,e.serializeEnvironmentVariableCollections=A,e.deserializeEnvironmentVariableCollections=R;function i(S){return[...S.entries()]}function s(S){return S?[...S.entries()]:[]}function y(S){return new Map(S)}function k(S){return new Map(S??[])}function A(S){return Array.from(S.entries()).map(c=>[c[0],i(c[1].map),s(c[1].descriptionMap)])}function R(S){return new Map(S.map(c=>[c[0],{map:y(c[1]),descriptionMap:k(c[2])}]))}}),define(le[230],ue([0,1,8,22,4,2,5]),function(j,e,i,s,y,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestStore=void 0;let R=class extends k.Disposable{constructor(c,m){super(),this._logService=m,this._lastRequestId=0,this._pendingRequests=new Map,this._pendingRequestDisposables=new Map,this._onCreateRequest=this._register(new y.Emitter),this.onCreateRequest=this._onCreateRequest.event,this._timeout=c===void 0?15e3:c,this._register((0,k.toDisposable)(()=>{for(const u of this._pendingRequestDisposables.values())(0,k.dispose)(u)}))}createRequest(c){return new Promise((m,u)=>{const p=++this._lastRequestId;this._pendingRequests.set(p,m),this._onCreateRequest.fire({requestId:p,...c});const v=new s.CancellationTokenSource;(0,i.timeout)(this._timeout,v.token).then(()=>u(`Request ${p} timed out (${this._timeout}ms)`)),this._pendingRequestDisposables.set(p,[(0,k.toDisposable)(()=>v.cancel())])})}acceptReply(c,m){const u=this._pendingRequests.get(c);u?(this._pendingRequests.delete(c),(0,k.dispose)(this._pendingRequestDisposables.get(c)||[]),this._pendingRequestDisposables.delete(c),u(m)):this._logService.warn(`RequestStore#acceptReply was called without receiving a matching request ${c}`)}};e.RequestStore=R,e.RequestStore=R=Pe([re(1,A.ILogService)],R)}),define(le[76],ue([0,1,6,125,46]),function(j,e,i,s,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ITerminalLogService=e.ILocalPtyService=e.TerminalExtensions=e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.IPtyService=e.ProcessPropertyType=e.TerminalIpcChannels=e.TitleEventSource=e.GeneralShellType=e.WindowsShellType=e.PosixShellType=e.TerminalSettingId=e.TerminalSettingPrefix=e.terminalTabFocusModeContextKey=void 0,e.terminalTabFocusModeContextKey=new s.RawContextKey("terminalTabFocusMode",!1,!0);var k;(function(a){a.AutomationProfile="terminal.integrated.automationProfile.",a.DefaultProfile="terminal.integrated.defaultProfile.",a.Profiles="terminal.integrated.profiles."})(k||(e.TerminalSettingPrefix=k={}));var A;(function(a){a.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",a.AutomationProfileLinux="terminal.integrated.automationProfile.linux",a.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",a.AutomationProfileWindows="terminal.integrated.automationProfile.windows",a.ProfilesWindows="terminal.integrated.profiles.windows",a.ProfilesMacOs="terminal.integrated.profiles.osx",a.ProfilesLinux="terminal.integrated.profiles.linux",a.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",a.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",a.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",a.UseWslProfiles="terminal.integrated.useWslProfiles",a.TabsDefaultColor="terminal.integrated.tabs.defaultColor",a.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",a.TabsEnabled="terminal.integrated.tabs.enabled",a.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",a.TabsHideCondition="terminal.integrated.tabs.hideCondition",a.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",a.TabsShowActions="terminal.integrated.tabs.showActions",a.TabsLocation="terminal.integrated.tabs.location",a.TabsFocusMode="terminal.integrated.tabs.focusMode",a.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",a.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",a.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",a.CopyOnSelection="terminal.integrated.copyOnSelection",a.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",a.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",a.FontFamily="terminal.integrated.fontFamily",a.FontSize="terminal.integrated.fontSize",a.LetterSpacing="terminal.integrated.letterSpacing",a.LineHeight="terminal.integrated.lineHeight",a.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",a.TabStopWidth="terminal.integrated.tabStopWidth",a.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",a.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",a.BellDuration="terminal.integrated.bellDuration",a.FontWeight="terminal.integrated.fontWeight",a.FontWeightBold="terminal.integrated.fontWeightBold",a.CursorBlinking="terminal.integrated.cursorBlinking",a.CursorStyle="terminal.integrated.cursorStyle",a.CursorStyleInactive="terminal.integrated.cursorStyleInactive",a.CursorWidth="terminal.integrated.cursorWidth",a.Scrollback="terminal.integrated.scrollback",a.DetectLocale="terminal.integrated.detectLocale",a.DefaultLocation="terminal.integrated.defaultLocation",a.GpuAcceleration="terminal.integrated.gpuAcceleration",a.TerminalTitleSeparator="terminal.integrated.tabs.separator",a.TerminalTitle="terminal.integrated.tabs.title",a.TerminalDescription="terminal.integrated.tabs.description",a.RightClickBehavior="terminal.integrated.rightClickBehavior",a.MiddleClickBehavior="terminal.integrated.middleClickBehavior",a.Cwd="terminal.integrated.cwd",a.ConfirmOnExit="terminal.integrated.confirmOnExit",a.ConfirmOnKill="terminal.integrated.confirmOnKill",a.EnableBell="terminal.integrated.enableBell",a.EnableVisualBell="terminal.integrated.enableVisualBell",a.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",a.AllowChords="terminal.integrated.allowChords",a.AllowMnemonics="terminal.integrated.allowMnemonics",a.TabFocusMode="terminal.integrated.tabFocusMode",a.EnvMacOs="terminal.integrated.env.osx",a.EnvLinux="terminal.integrated.env.linux",a.EnvWindows="terminal.integrated.env.windows",a.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",a.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",a.ExperimentalWindowsUseConptyDll="terminal.integrated.experimental.windowsUseConptyDll",a.ShowExitAlert="terminal.integrated.showExitAlert",a.SplitCwd="terminal.integrated.splitCwd",a.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",a.WordSeparators="terminal.integrated.wordSeparators",a.EnableFileLinks="terminal.integrated.enableFileLinks",a.AllowedLinkSchemes="terminal.integrated.allowedLinkSchemes",a.UnicodeVersion="terminal.integrated.unicodeVersion",a.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",a.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",a.HideOnStartup="terminal.integrated.hideOnStartup",a.CustomGlyphs="terminal.integrated.customGlyphs",a.RescaleOverlappingGlyphs="terminal.integrated.rescaleOverlappingGlyphs",a.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",a.InheritEnv="terminal.integrated.inheritEnv",a.ShowLinkHover="terminal.integrated.showLinkHover",a.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",a.AutoReplies="terminal.integrated.autoReplies",a.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",a.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",a.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",a.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",a.EnableImages="terminal.integrated.enableImages",a.SmoothScrolling="terminal.integrated.smoothScrolling",a.IgnoreBracketedPasteMode="terminal.integrated.ignoreBracketedPasteMode",a.FocusAfterRun="terminal.integrated.focusAfterRun",a.DeveloperPtyHostLatency="terminal.integrated.developer.ptyHost.latency",a.DeveloperPtyHostStartupDelay="terminal.integrated.developer.ptyHost.startupDelay",a.DevMode="terminal.integrated.developer.devMode"})(A||(e.TerminalSettingId=A={}));var R;(function(a){a.Bash="bash",a.Fish="fish",a.Sh="sh",a.Csh="csh",a.Ksh="ksh",a.Zsh="zsh"})(R||(e.PosixShellType=R={}));var S;(function(a){a.CommandPrompt="cmd",a.Wsl="wsl",a.GitBash="gitbash"})(S||(e.WindowsShellType=S={}));var c;(function(a){a.PowerShell="pwsh",a.Python="python",a.Julia="julia",a.NuShell="nu"})(c||(e.GeneralShellType=c={}));var m;(function(a){a[a.Api=0]="Api",a[a.Process=1]="Process",a[a.Sequence=2]="Sequence",a[a.Config=3]="Config"})(m||(e.TitleEventSource=m={}));var u;(function(a){a.LocalPty="localPty",a.PtyHost="ptyHost",a.PtyHostWindow="ptyHostWindow",a.Logger="logger",a.Heartbeat="heartbeat"})(u||(e.TerminalIpcChannels=u={}));var p;(function(a){a.Cwd="cwd",a.InitialCwd="initialCwd",a.FixedDimensions="fixedDimensions",a.Title="title",a.ShellType="shellType",a.HasChildProcesses="hasChildProcesses",a.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",a.OverrideDimensions="overrideDimensions",a.FailedShellIntegrationActivation="failedShellIntegrationActivation",a.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(p||(e.ProcessPropertyType=p={})),e.IPtyService=(0,i.createDecorator)("ptyService");var v;(function(a){a[a.BeatInterval=5e3]="BeatInterval",a[a.ConnectingBeatInterval=2e4]="ConnectingBeatInterval",a[a.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",a[a.SecondWaitMultiplier=1]="SecondWaitMultiplier",a[a.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(v||(e.HeartbeatConstants=v={}));var f;(function(a){a[a.Panel=1]="Panel",a[a.Editor=2]="Editor"})(f||(e.TerminalLocation=f={}));var h;(function(a){a.TerminalView="view",a.Editor="editor"})(h||(e.TerminalLocationString=h={}));var E;(function(a){a[a.GraceTime=6e4]="GraceTime",a[a.ShortGraceTime=6e3]="ShortGraceTime"})(E||(e.LocalReconnectConstants=E={}));var b;(function(a){a[a.HighWatermarkChars=1e5]="HighWatermarkChars",a[a.LowWatermarkChars=5e3]="LowWatermarkChars",a[a.CharCountAckSize=5e3]="CharCountAckSize"})(b||(e.FlowControlConstants=b={}));var g;(function(a){a.GitBash="Git Bash",a.Pwsh="PowerShell"})(g||(e.ProfileSource=g={}));var I;(function(a){a[a.Off=0]="Off",a[a.FinalTerm=1]="FinalTerm",a[a.VSCode=2]="VSCode"})(I||(e.ShellIntegrationStatus=I={}));var P;(function(a){a[a.Unknown=0]="Unknown",a[a.Shutdown=1]="Shutdown",a[a.Process=2]="Process",a[a.User=3]="User",a[a.Extension=4]="Extension"})(P||(e.TerminalExitReason=P={})),e.TerminalExtensions={Backend:"workbench.contributions.terminal.processBackend"};class r{constructor(){this._backends=new Map}get backends(){return this._backends}registerTerminalBackend(t){const o=this._sanitizeRemoteAuthority(t.remoteAuthority);if(this._backends.has(o))throw new Error(`A terminal backend with remote authority '${o}' was already registered.`);this._backends.set(o,t)}getTerminalBackend(t){return this._backends.get(this._sanitizeRemoteAuthority(t))}_sanitizeRemoteAuthority(t){return t?.toLowerCase()??""}}y.Registry.add(e.TerminalExtensions.Backend,new r),e.ILocalPtyService=(0,i.createDecorator)("localPtyService"),e.ITerminalLogService=(0,i.createDecorator)("terminalLogService")}),define(le[231],ue([0,1,80,7,9,113]),function(j,e,i,s,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProfileSchemaEnums=A,e.terminalProfileArgsMatch=c,e.terminalIconsEqual=m,e.isUriComponents=u;function A(p,v){const f=[{name:null,description:(0,y.localize)(2118,null)}];return f.push(...p.map(h=>({name:h.profileName,description:R(h)}))),v&&f.push(...v.map(h=>({name:h.title,description:S(h)}))),{values:f.map(h=>h.name),markdownDescriptions:f.map(h=>h.description)}}function R(p){let v=`$(${k.ThemeIcon.isThemeIcon(p.icon)?p.icon.id:p.icon?p.icon:i.Codicon.terminal.id}) ${p.profileName}
- path: ${p.path}`;return p.args&&(typeof p.args=="string"?v+=`
- args: "${p.args}"`:v+=`
- args: [${p.args.length===0?"":`'${p.args.join("','")}'`}]`),p.overrideName!==void 0&&(v+=`
- overrideName: ${p.overrideName}`),p.color&&(v+=`
- color: ${p.color}`),p.env&&(v+=`
- env: ${JSON.stringify(p.env)}`),v}function S(p){return`$(${k.ThemeIcon.isThemeIcon(p.icon)?p.icon.id:p.icon?p.icon:i.Codicon.terminal.id}) ${p.title}
- extensionIdentifier: ${p.extensionIdentifier}`}function c(p,v){if(!p&&!v)return!0;if(typeof p=="string"&&typeof v=="string")return p===v;if(Array.isArray(p)&&Array.isArray(v)){if(p.length!==v.length)return!1;for(let f=0;f<p.length;f++)if(p[f]!==v[f])return!1;return!0}return!1}function m(p,v){if(!p&&!v)return!0;if(!p||!v)return!1;if(k.ThemeIcon.isThemeIcon(p)&&k.ThemeIcon.isThemeIcon(v))return p.id===v.id&&p.color===v.color;if(typeof p=="object"&&"light"in p&&"dark"in p&&typeof v=="object"&&"light"in v&&"dark"in v){const f=p,h=v;if((s.URI.isUri(f.light)||u(f.light))&&(s.URI.isUri(f.dark)||u(f.dark))&&(s.URI.isUri(h.light)||u(h.light))&&(s.URI.isUri(h.dark)||u(h.dark)))return f.light.path===h.light.path&&f.dark.path===h.dark.path}if(s.URI.isUri(p)&&s.URI.isUri(v)||u(p)||u(v)){const f=p,h=v;return f.path===h.path&&f.scheme===h.scheme}return!1}function u(p){return p?typeof p.path=="string"&&typeof p.scheme=="string":!1}}),define(le[232],ue([0,1,80,3,9,56,46,76,231]),function(j,e,i,s,y,k,A,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.terminalIconSchema=e.terminalColorSchema=void 0,e.registerTerminalPlatformConfiguration=f,e.registerTerminalDefaultProfileConfiguration=E,e.terminalColorSchema={type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},e.terminalIconSchema={type:"string",enum:Array.from((0,i.getAllCodicons)(),b=>b.id),markdownEnumDescriptions:Array.from((0,i.getAllCodicons)(),b=>`$(${b.id})`)};const c={args:{description:(0,y.localize)(2087,null),type:"array",items:{type:"string"}},overrideName:{description:(0,y.localize)(2088,null),type:"boolean"},icon:{description:(0,y.localize)(2089,null),...e.terminalIconSchema},color:{description:(0,y.localize)(2090,null),...e.terminalColorSchema},env:{markdownDescription:(0,y.localize)(2091,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},m={type:"object",required:["path"],properties:{path:{description:(0,y.localize)(2092,null),type:["string","array"],items:{type:"string"}},...c}},u={type:"object",required:["path"],properties:{path:{description:(0,y.localize)(2093,null),type:["string"],items:{type:"string"}},...c}};function p(b){const g=b===s.Platform.Linux?"linux":b===s.Platform.Mac?"osx":"windows";return(0,y.localize)(2094,null,(0,s.PlatformToString)(b),'```json\n"terminal.integrated.profile.'+g+'": {\n  "bash": null\n}\n```',"[","](https://code.visualstudio.com/docs/terminal/profiles)")}const v={id:"terminal",order:100,title:(0,y.localize)(2095,null),type:"object",properties:{[R.TerminalSettingId.AutomationProfileLinux]:{restricted:!0,markdownDescription:(0,y.localize)(2096,null),type:["object","null"],default:null,anyOf:[{type:"null"},u],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},[R.TerminalSettingId.AutomationProfileMacOs]:{restricted:!0,markdownDescription:(0,y.localize)(2097,null),type:["object","null"],default:null,anyOf:[{type:"null"},u],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},[R.TerminalSettingId.AutomationProfileWindows]:{restricted:!0,markdownDescription:(0,y.localize)(2098,null,"`terminal.integrated.automationShell.windows`"),type:["object","null"],default:null,anyOf:[{type:"null"},u],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},[R.TerminalSettingId.ProfilesWindows]:{restricted:!0,markdownDescription:p(s.Platform.Windows),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,y.localize)(2099,null),enum:["PowerShell","Git Bash"]},...c}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,y.localize)(2100,null),type:"string"},id:{description:(0,y.localize)(2101,null),type:"string"},title:{description:(0,y.localize)(2102,null),type:"string"},...c}},{type:"null"},m]}},[R.TerminalSettingId.ProfilesMacOs]:{restricted:!0,markdownDescription:p(s.Platform.Mac),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,y.localize)(2103,null),type:"string"},id:{description:(0,y.localize)(2104,null),type:"string"},title:{description:(0,y.localize)(2105,null),type:"string"},...c}},{type:"null"},m]}},[R.TerminalSettingId.ProfilesLinux]:{restricted:!0,markdownDescription:p(s.Platform.Linux),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,y.localize)(2106,null),type:"string"},id:{description:(0,y.localize)(2107,null),type:"string"},title:{description:(0,y.localize)(2108,null),type:"string"},...c}},{type:"null"},m]}},[R.TerminalSettingId.UseWslProfiles]:{description:(0,y.localize)(2109,null),type:"boolean",default:!0},[R.TerminalSettingId.InheritEnv]:{scope:k.ConfigurationScope.APPLICATION,description:(0,y.localize)(2110,null),type:"boolean",default:!0},[R.TerminalSettingId.PersistentSessionScrollback]:{scope:k.ConfigurationScope.APPLICATION,markdownDescription:(0,y.localize)(2111,null),type:"number",default:100},[R.TerminalSettingId.ShowLinkHover]:{scope:k.ConfigurationScope.APPLICATION,description:(0,y.localize)(2112,null),type:"boolean",default:!0},[R.TerminalSettingId.IgnoreProcessNames]:{markdownDescription:(0,y.localize)(2113,null,"`#terminal.integrated.confirmOnKill#`"),type:"array",items:{type:"string",uniqueItems:!0},default:["starship","oh-my-posh","bash","zsh"]}}};function f(){A.Registry.as(k.Extensions.Configuration).registerConfiguration(v),E()}let h;function E(b,g){const I=A.Registry.as(k.Extensions.Configuration);let P;b&&(P=(0,S.createProfileSchemaEnums)(b?.profiles,g));const r=h;h={id:"terminal",order:100,title:(0,y.localize)(2114,null),type:"object",properties:{[R.TerminalSettingId.DefaultProfileLinux]:{restricted:!0,markdownDescription:(0,y.localize)(2115,null),type:["string","null"],default:null,enum:b?.os===s.OperatingSystem.Linux?P?.values:void 0,markdownEnumDescriptions:b?.os===s.OperatingSystem.Linux?P?.markdownDescriptions:void 0},[R.TerminalSettingId.DefaultProfileMacOs]:{restricted:!0,markdownDescription:(0,y.localize)(2116,null),type:["string","null"],default:null,enum:b?.os===s.OperatingSystem.Macintosh?P?.values:void 0,markdownEnumDescriptions:b?.os===s.OperatingSystem.Macintosh?P?.markdownDescriptions:void 0},[R.TerminalSettingId.DefaultProfileWindows]:{restricted:!0,markdownDescription:(0,y.localize)(2117,null),type:["string","null"],default:null,enum:b?.os===s.OperatingSystem.Windows?P?.values:void 0,markdownEnumDescriptions:b?.os===s.OperatingSystem.Windows?P?.markdownDescriptions:void 0}}},I.updateConfigurations({add:[h],remove:r?[r]:[]})}}),define(le[233],ue([0,1,27,11,37,10,3,38,25,12,23,133,229,228]),function(j,e,i,s,y,k,A,R,S,c,m,u,p,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWindowsBuildNumber=f,e.findExecutable=h,e.getShellIntegrationInjection=E,i=Re(i),k=Re(k),R=Re(R),m=Re(m);function f(){const d=/(\d+)\.(\d+)\.(\d+)/g.exec(i.release());let D=0;return d&&d.length===4&&(D=parseInt(d[3])),D}async function h(d,D,w,M=R.env,T=m.Promises.exists){if(k.isAbsolute(d))return await T(d)?d:void 0;if(D===void 0&&(D=R.cwd()),k.dirname(d)!=="."){const V=k.join(D,d);return await T(V)?V:void 0}const L=(0,y.getCaseInsensitive)(M,"PATH");if(w===void 0&&(0,c.isString)(L)&&(w=L.split(k.delimiter)),w===void 0||w.length===0){const V=k.join(D,d);return await T(V)?V:void 0}for(const V of w){let z;if(k.isAbsolute(V)?z=k.join(V,d):z=k.join(D,V,d),await T(z))return z;if(A.isWindows){let Q=z+".com";if(await T(Q)||(Q=z+".exe",await T(Q)))return Q}}const _=k.join(D,d);return await T(_)?_:void 0}function E(d,D,w,M,T){const C=A.isWindows&&(!D.windowsEnableConpty||f()<18309);if(!D.shellIntegration.enabled||!d.executable||d.isFeatureTerminal&&!d.forceShellIntegration||d.ignoreShellIntegration||C)return;const L=d.args,_=R.platform==="win32"?k.basename(d.executable).toLowerCase():k.basename(d.executable),V=k.dirname(s.FileAccess.asFileUri("").fsPath);let z;const Q={VSCODE_INJECTION:"1"};if(D.shellIntegration.nonce&&(Q.VSCODE_NONCE=D.shellIntegration.nonce),A.isWindows){if(_==="pwsh.exe"||_==="powershell.exe")return!L||n(L)?z=I.get(g.WindowsPwsh):o(L)&&(z=I.get(g.WindowsPwshLogin)),z?(z=[...z],z[z.length-1]=(0,S.format)(z[z.length-1],V,""),Q.VSCODE_STABLE=T.quality==="stable"?"1":"0",D.shellIntegration.suggestEnabled&&(Q.VSCODE_SUGGEST="1"),{newArgs:z,envMixin:Q}):void 0;if(_==="bash.exe")return!L||L.length===0?z=I.get(g.Bash):l(L)&&(Q.VSCODE_SHELL_LOGIN="1",b(D,Q),z=I.get(g.Bash)),z?(z=[...z],z[z.length-1]=(0,S.format)(z[z.length-1],V),Q.VSCODE_STABLE=T.quality==="stable"?"1":"0",{newArgs:z,envMixin:Q}):void 0;M.warn(`Shell integration cannot be enabled for executable "${d.executable}" and args`,d.args);return}switch(_){case"bash":return!L||L.length===0?z=I.get(g.Bash):l(L)&&(Q.VSCODE_SHELL_LOGIN="1",b(D,Q),z=I.get(g.Bash)),z?(z=[...z],z[z.length-1]=(0,S.format)(z[z.length-1],V),Q.VSCODE_STABLE=T.quality==="stable"?"1":"0",{newArgs:z,envMixin:Q}):void 0;case"fish":{const fe=w?.XDG_DATA_DIRS??"/usr/local/share:/usr/share",se=k.join(V,"out/vs/workbench/contrib/terminal/browser/media/fish_xdg_data");return Q.XDG_DATA_DIRS=`${fe}:${se}`,b(D,Q),{newArgs:void 0,envMixin:Q}}case"pwsh":return!L||n(L)?z=I.get(g.Pwsh):o(L)&&(z=I.get(g.PwshLogin)),z?(D.shellIntegration.suggestEnabled&&(Q.VSCODE_SUGGEST="1"),z=[...z],z[z.length-1]=(0,S.format)(z[z.length-1],V,""),Q.VSCODE_STABLE=T.quality==="stable"?"1":"0",{newArgs:z,envMixin:Q}):void 0;case"zsh":{if(!L||L.length===0?z=I.get(g.Zsh):l(L)?(z=I.get(g.ZshLogin),b(D,Q)):(L===I.get(g.Zsh)||L===I.get(g.ZshLogin))&&(z=L),!z)return;z=[...z],z[z.length-1]=(0,S.format)(z[z.length-1],V);let fe;try{fe=i.userInfo().username}catch{fe="unknown"}const se=k.join(i.tmpdir(),`${fe}-${T.applicationName}-zsh`);Q.ZDOTDIR=se;const ee=w?.ZDOTDIR??i.homedir()??"~";Q.USER_ZDOTDIR=ee;const U=[];return U.push({source:k.join(V,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-rc.zsh"),dest:k.join(se,".zshrc")}),U.push({source:k.join(V,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-profile.zsh"),dest:k.join(se,".zprofile")}),U.push({source:k.join(V,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-env.zsh"),dest:k.join(se,".zshenv")}),U.push({source:k.join(V,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-login.zsh"),dest:k.join(se,".zlogin")}),{newArgs:z,envMixin:Q,filesToCopy:U}}}M.warn(`Shell integration cannot be enabled for executable "${d.executable}" and args`,d.args)}function b(d,D){if(A.isMacintosh&&d.environmentVariableCollections){const w=(0,p.deserializeEnvironmentVariableCollections)(d.environmentVariableCollections),T=new v.MergedEnvironmentVariableCollection(w).getVariableMap({workspaceFolder:d.workspaceFolder}).get("PATH"),C=[];if(T)for(const L of T)L.type===u.EnvironmentVariableMutatorType.Prepend&&C.push(L.value);C.length>0&&(D.VSCODE_PATH_PREFIX=C.join(""))}}var g;(function(d){d.WindowsPwsh="windows-pwsh",d.WindowsPwshLogin="windows-pwsh-login",d.Pwsh="pwsh",d.PwshLogin="pwsh-login",d.Zsh="zsh",d.ZshLogin="zsh-login",d.Bash="bash"})(g||(g={}));const I=new Map;I.set(g.WindowsPwsh,["-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),I.set(g.WindowsPwshLogin,["-l","-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),I.set(g.Pwsh,["-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"{1}']),I.set(g.PwshLogin,["-l","-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"']),I.set(g.Zsh,["-i"]),I.set(g.ZshLogin,["-il"]),I.set(g.Bash,["--init-file","{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration-bash.sh"]);const P=["-login","-l"],r=["--login","-l"],a=["-i","--interactive"],t=["-nol","-nologo"];function o(d){return typeof d=="string"?P.includes(d.toLowerCase()):d.length===1&&P.includes(d[0].toLowerCase())||d.length===2&&(P.includes(d[0].toLowerCase())||P.includes(d[1].toLowerCase()))&&(t.includes(d[0].toLowerCase())||t.includes(d[1].toLowerCase()))}function n(d){return typeof d=="string"?t.includes(d.toLowerCase()):d.length===0||d?.length===1&&t.includes(d[0].toLowerCase())}function l(d){return typeof d!="string"&&(d=d.filter(D=>!a.includes(D.toLowerCase()))),d==="string"&&r.includes(d.toLowerCase())||typeof d!="string"&&d.length===1&&r.includes(d[0].toLowerCase())}}),define(le[234],ue([0,1,26,44,80,10,3,12,23,118,76,233,97]),function(j,e,i,s,y,k,A,R,S,c,m,u,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.detectAvailableProfiles=E,i=Re(i),s=Re(s),S=Re(S);var v;(function(w){w.UnixShellsPath="/etc/shells"})(v||(v={}));let f,h=!0;function E(w,M,T,C,L=process.env,_,V,z,Q){return _=_||{existsFile:S.SymlinkSupport.existsFile,readFile:i.promises.readFile},A.isWindows?b(T,_,L,V,C.getValue(m.TerminalSettingId.UseWslProfiles)!==!1,w&&typeof w=="object"?{...w}:C.getValue(m.TerminalSettingId.ProfilesWindows),typeof M=="string"?M:C.getValue(m.TerminalSettingId.DefaultProfileWindows),Q,z):l(_,V,T,w&&typeof w=="object"?{...w}:C.getValue(A.isLinux?m.TerminalSettingId.ProfilesLinux:m.TerminalSettingId.ProfilesMacOs),typeof M=="string"?M:C.getValue(A.isLinux?m.TerminalSettingId.DefaultProfileLinux:m.TerminalSettingId.DefaultProfileMacOs),Q,z,L)}async function b(w,M,T,C,L,_,V,z,Q){const fe=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),se=`${process.env.windir}\\${fe?"Sysnative":"System32"}`;let ee=!1;(0,u.getWindowsBuildNumber)()>=16299&&(ee=!0),await r(z);const U=new Map;if(w){U.set("PowerShell",{source:m.ProfileSource.Pwsh,icon:y.Codicon.terminalPowershell,isAutoDetected:!0}),U.set("Windows PowerShell",{path:`${se}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:y.Codicon.terminalPowershell,isAutoDetected:!0}),U.set("Git Bash",{source:m.ProfileSource.GitBash,isAutoDetected:!0}),U.set("Command Prompt",{path:`${se}\\cmd.exe`,icon:y.Codicon.terminalCmd,isAutoDetected:!0}),U.set("Cygwin",{path:[{path:`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,isUnsafe:!0},{path:`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`,isUnsafe:!0}],args:["--login"],isAutoDetected:!0}),U.set("bash (MSYS2)",{path:[{path:`${process.env.HOMEDRIVE}\\msys64\\usr\\bin\\bash.exe`,isUnsafe:!0}],args:["--login","-i"],env:{CHERE_INVOKING:"1"},icon:y.Codicon.terminalBash,isAutoDetected:!0});const N=`${process.env.CMDER_ROOT||`${process.env.HOMEDRIVE}\\cmder`}\\vendor\\bin\\vscode_init.cmd`;U.set("Cmder",{path:`${se}\\cmd.exe`,args:["/K",N],requiresPath:process.env.CMDER_ROOT?N:{path:N,isUnsafe:!0},isAutoDetected:!0})}d(_,U);const K=await g(U.entries(),V,M,T,C,Q);if(w&&L)try{const N=await o(`${se}\\${ee?"wsl":"bash"}.exe`,V);for(const x of N)(!_||!(x.profileName in _))&&K.push(x)}catch{h&&(C?.trace("WSL is not installed, so could not detect WSL profiles"),h=!1)}return K}async function g(w,M,T,C=process.env,L,_){const V=[];for(const[z,Q]of w)V.push(I(z,Q,M,T,C,L,_));return(await Promise.all(V)).filter(z=>!!z)}async function I(w,M,T,C,L=process.env,_,V){if(M===null)return;let z,Q,fe;if("source"in M&&!("path"in M)){const K=f?.get(M.source);if(!K)return;z=K.paths,Q=M.args||K.args,M.icon?fe=P(M.icon):K.icon&&(fe=K.icon)}else z=Array.isArray(M.path)?M.path:[M.path],Q=A.isWindows||Array.isArray(M.args)?M.args:void 0,fe=P(M.icon);let se;if(V){const K=z.map(x=>typeof x=="string"?x:x.path),N=await V(K);se=new Array(z.length);for(let x=0;x<z.length;x++)typeof z[x]=="string"?se[x]=N[x]:se[x]={path:N[x],isUnsafe:!0}}else se=z.slice();let ee;if(M.requiresPath){let K;if((0,R.isString)(M.requiresPath)?K=M.requiresPath:(K=M.requiresPath.path,M.requiresPath.isUnsafe&&(ee=K)),!await C.existsFile(K))return}const U=await D(w,T,se,C,L,Q,M.env,M.overrideName,M.isAutoDetected,ee);if(!U){_?.debug("Terminal profile not validated",w,z);return}return U.isAutoDetected=M.isAutoDetected,U.icon=fe,U.color=M.color,U}function P(w){return typeof w=="string"?{id:w}:w}async function r(w){if(f&&!w)return;const[M,T]=await Promise.all([a(),w||t()]);f=new Map,f.set(m.ProfileSource.GitBash,{profileName:"Git Bash",paths:M,args:["--login","-i"]}),f.set(m.ProfileSource.Pwsh,{profileName:"PowerShell",paths:T,icon:y.Codicon.terminalPowershell})}async function a(){const w=new Set,M=await(0,u.findExecutable)("git.exe");if(M){const L=(0,p.dirname)(M);w.add((0,p.resolve)(L,"../.."))}function T(L,_){_&&L.add(_)}T(w,process.env.ProgramW6432),T(w,process.env.ProgramFiles),T(w,process.env["ProgramFiles(X86)"]),T(w,`${process.env.LocalAppData}\\Program`);const C=[];for(const L of w)C.push(`${L}\\Git\\bin\\bash.exe`,`${L}\\Git\\usr\\bin\\bash.exe`,`${L}\\usr\\bin\\bash.exe`);return C.push(`${process.env.UserProfile}\\scoop\\apps\\git\\current\\bin\\bash.exe`),C.push(`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`),C}async function t(){const w=[];for await(const M of(0,c.enumeratePowerShellInstallations)())w.push(M.exePath);return w}async function o(w,M){const T=[],C=await new Promise((V,z)=>{s.exec("wsl.exe -l -q",{encoding:"utf16le",timeout:1e3},(Q,fe)=>{if(Q)return z("Problem occurred when getting wsl distros");V(fe)})});if(!C)return[];const L=new RegExp(/[\r?\n]/),_=C.split(L).filter(V=>V.trim().length>0&&V!=="");for(const V of _){if(V===""||V.startsWith("docker-desktop"))continue;const z=`${V} (WSL)`,Q={profileName:z,path:w,args:["-d",`${V}`],isDefault:z===M,icon:n(V),isAutoDetected:!1};T.push(Q)}return T}function n(w){return w.includes("Ubuntu")?y.Codicon.terminalUbuntu:w.includes("Debian")?y.Codicon.terminalDebian:y.Codicon.terminalLinux}async function l(w,M,T,C,L,_,V,z){const Q=new Map;if(T&&await w.existsFile(v.UnixShellsPath)){const fe=(await w.readFile(v.UnixShellsPath)).toString(),se=(_||fe.split(`
`)).map(U=>{const K=U.indexOf("#");return K===-1?U:U.substring(0,K)}).filter(U=>U.trim().length>0),ee=new Map;for(const U of se){let K=(0,k.basename)(U),N=ee.get(K)||0;N++,N>1&&(K=`${K} (${N})`),ee.set(K,N),Q.set(K,{path:U,isAutoDetected:!0})}}return d(C,Q),await g(Q.entries(),L,w,z,M,V)}function d(w,M){if(w)for(const[T,C]of Object.entries(w))C===null||typeof C!="object"||!("path"in C)&&!("source"in C)?M.delete(T):(C.icon=C.icon||M.get(T)?.icon,M.set(T,C))}async function D(w,M,T,C,L,_,V,z,Q,fe){if(T.length===0)return Promise.resolve(void 0);const se=T.shift();if(se==="")return D(w,M,T,C,L,_,V,z,Q);const ee=typeof se!="string"&&se.isUnsafe,U=typeof se=="string"?se:se.path,K={profileName:w,path:U,args:_,env:V,overrideName:z,isAutoDetected:Q,isDefault:w===M,isUnsafePath:ee,requiresUnsafePath:fe};if((0,k.basename)(U)===U){const x=L.PATH?L.PATH.split(k.delimiter):void 0,W=await(0,u.findExecutable)(U,void 0,x,void 0,C.existsFile);return W?(K.path=W,K.isFromPath=!0,K):D(w,M,T,C,L,_)}return await C.existsFile((0,k.normalize)(U))?K:D(w,M,T,C,L,_,V,z,Q)}}),define(le[235],ue([0,1,4,2,3,45,16,5,197,103,230,76,232,234,120,60]),function(j,e,i,s,y,k,A,R,S,c,m,u,p,v,f,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PtyHostService=void 0;var E;(function(g){g[g.MaxRestarts=5]="MaxRestarts"})(E||(E={}));let b=class extends s.Disposable{get _connection(){return this._ensurePtyHost(),this.__connection}get _proxy(){return this._ensurePtyHost(),this.__proxy}get _optionalProxy(){return this.__proxy}_ensurePtyHost(){this.__connection||this._startPtyHost()}constructor(I,P,r,a){super(),this._ptyHostStarter=I,this._configurationService=P,this._logService=r,this._loggerService=a,this._wasQuitRequested=!1,this._restartCount=0,this._isResponsive=!0,this._onPtyHostExit=this._register(new i.Emitter),this.onPtyHostExit=this._onPtyHostExit.event,this._onPtyHostStart=this._register(new i.Emitter),this.onPtyHostStart=this._onPtyHostStart.event,this._onPtyHostUnresponsive=this._register(new i.Emitter),this.onPtyHostUnresponsive=this._onPtyHostUnresponsive.event,this._onPtyHostResponsive=this._register(new i.Emitter),this.onPtyHostResponsive=this._onPtyHostResponsive.event,this._onPtyHostRequestResolveVariables=this._register(new i.Emitter),this.onPtyHostRequestResolveVariables=this._onPtyHostRequestResolveVariables.event,this._onProcessData=this._register(new i.Emitter),this.onProcessData=this._onProcessData.event,this._onProcessReady=this._register(new i.Emitter),this.onProcessReady=this._onProcessReady.event,this._onProcessReplay=this._register(new i.Emitter),this.onProcessReplay=this._onProcessReplay.event,this._onProcessOrphanQuestion=this._register(new i.Emitter),this.onProcessOrphanQuestion=this._onProcessOrphanQuestion.event,this._onDidRequestDetach=this._register(new i.Emitter),this.onDidRequestDetach=this._onDidRequestDetach.event,this._onDidChangeProperty=this._register(new i.Emitter),this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=this._register(new i.Emitter),this.onProcessExit=this._onProcessExit.event,(0,p.registerTerminalPlatformConfiguration)(),this._register(this._ptyHostStarter),this._register((0,s.toDisposable)(()=>this._disposePtyHost())),this._resolveVariablesRequestStore=this._register(new m.RequestStore(void 0,this._logService)),this._register(this._resolveVariablesRequestStore.onCreateRequest(this._onPtyHostRequestResolveVariables.fire,this._onPtyHostRequestResolveVariables)),this._ptyHostStarter.onRequestConnection&&this._register(i.Event.once(this._ptyHostStarter.onRequestConnection)(()=>this._ensurePtyHost())),this._ptyHostStarter.onWillShutdown&&this._register(this._ptyHostStarter.onWillShutdown(()=>this._wasQuitRequested=!0))}get _ignoreProcessNames(){return this._configurationService.getValue(u.TerminalSettingId.IgnoreProcessNames)}async _refreshIgnoreProcessNames(){return this._optionalProxy?.refreshIgnoreProcessNames?.(this._ignoreProcessNames)}async _resolveShellEnv(){if(y.isWindows)return process.env;try{return await(0,c.getResolvedShellEnv)(this._configurationService,this._logService,{_:[]},process.env)}catch(I){return this._logService.error("ptyHost was unable to resolve shell environment",I),{}}}_startPtyHost(){const I=this._ptyHostStarter.start(),P=I.client;this._logService.getLevel()===R.LogLevel.Trace&&this._logService.trace("PtyHostService#_startPtyHost",new Error().stack?.replace(/^Error/,"")),k.ProxyChannel.toService(P.getChannel(u.TerminalIpcChannels.Heartbeat)).onBeat(()=>this._handleHeartbeat()),this._handleHeartbeat(!0),this._register(I.onDidProcessExit(t=>{this._onPtyHostExit.fire(t.code),!this._wasQuitRequested&&!this._store.isDisposed&&(this._restartCount<=E.MaxRestarts?(this._logService.error(`ptyHost terminated unexpectedly with code ${t.code}`),this._restartCount++,this.restartPtyHost()):this._logService.error(`ptyHost terminated unexpectedly with code ${t.code}, giving up`))}));const a=k.ProxyChannel.toService(P.getChannel(u.TerminalIpcChannels.PtyHost));return this._register(a.onProcessData(t=>this._onProcessData.fire(t))),this._register(a.onProcessReady(t=>this._onProcessReady.fire(t))),this._register(a.onProcessExit(t=>this._onProcessExit.fire(t))),this._register(a.onDidChangeProperty(t=>this._onDidChangeProperty.fire(t))),this._register(a.onProcessReplay(t=>this._onProcessReplay.fire(t))),this._register(a.onProcessOrphanQuestion(t=>this._onProcessOrphanQuestion.fire(t))),this._register(a.onDidRequestDetach(t=>this._onDidRequestDetach.fire(t))),this._register(new S.RemoteLoggerChannelClient(this._loggerService,P.getChannel(u.TerminalIpcChannels.Logger))),this.__connection=I,this.__proxy=a,this._onPtyHostStart.fire(),this._register(this._configurationService.onDidChangeConfiguration(async t=>{t.affectsConfiguration(u.TerminalSettingId.IgnoreProcessNames)&&await this._refreshIgnoreProcessNames()})),this._refreshIgnoreProcessNames(),[I,a]}async createProcess(I,P,r,a,t,o,n,l,d,D,w){const M=setTimeout(()=>this._handleUnresponsiveCreateProcess(),u.HeartbeatConstants.CreateProcessTimeout),T=await this._proxy.createProcess(I,P,r,a,t,o,n,l,d,D,w);return clearTimeout(M),T}updateTitle(I,P,r){return this._proxy.updateTitle(I,P,r)}updateIcon(I,P,r,a){return this._proxy.updateIcon(I,P,r,a)}attachToProcess(I){return this._proxy.attachToProcess(I)}detachFromProcess(I,P){return this._proxy.detachFromProcess(I,P)}shutdownAll(){return this._proxy.shutdownAll()}listProcesses(){return this._proxy.listProcesses()}async getPerformanceMarks(){return this._optionalProxy?.getPerformanceMarks()??[]}async reduceConnectionGraceTime(){return this._optionalProxy?.reduceConnectionGraceTime()}start(I){return this._proxy.start(I)}shutdown(I,P){return this._proxy.shutdown(I,P)}input(I,P){return this._proxy.input(I,P)}processBinary(I,P){return this._proxy.processBinary(I,P)}resize(I,P,r){return this._proxy.resize(I,P,r)}clearBuffer(I){return this._proxy.clearBuffer(I)}acknowledgeDataEvent(I,P){return this._proxy.acknowledgeDataEvent(I,P)}setUnicodeVersion(I,P){return this._proxy.setUnicodeVersion(I,P)}getInitialCwd(I){return this._proxy.getInitialCwd(I)}getCwd(I){return this._proxy.getCwd(I)}async getLatency(){const I=new h.StopWatch,P=await this._proxy.getLatency();return I.stop(),[{label:"ptyhostservice<->ptyhost",latency:I.elapsed()},...P]}orphanQuestionReply(I){return this._proxy.orphanQuestionReply(I)}installAutoReply(I,P){return this._proxy.installAutoReply(I,P)}uninstallAllAutoReplies(){return this._proxy.uninstallAllAutoReplies()}uninstallAutoReply(I){return this._proxy.uninstallAutoReply(I)}getDefaultSystemShell(I){return this._optionalProxy?.getDefaultSystemShell(I)??(0,f.getSystemShell)(I??y.OS,process.env)}async getProfiles(I,P,r,a=!1){const t=await this._resolveShellEnv();return(0,v.detectAvailableProfiles)(P,r,a,this._configurationService,t,void 0,this._logService,this._resolveVariables.bind(this,I))}async getEnvironment(){return this.__proxy?this._proxy.getEnvironment():{...process.env}}getWslPath(I,P){return this._proxy.getWslPath(I,P)}getRevivedPtyNewId(I,P){return this._proxy.getRevivedPtyNewId(I,P)}setTerminalLayoutInfo(I){return this._proxy.setTerminalLayoutInfo(I)}async getTerminalLayoutInfo(I){return this._optionalProxy?.getTerminalLayoutInfo(I)}async requestDetachInstance(I,P){return this._proxy.requestDetachInstance(I,P)}async acceptDetachInstanceReply(I,P){return this._proxy.acceptDetachInstanceReply(I,P)}async freePortKillProcess(I){if(!this._proxy.freePortKillProcess)throw new Error("freePortKillProcess does not exist on the pty proxy");return this._proxy.freePortKillProcess(I)}async serializeTerminalState(I){return this._proxy.serializeTerminalState(I)}async reviveTerminalProcesses(I,P,r){return this._proxy.reviveTerminalProcesses(I,P,r)}async refreshProperty(I,P){return this._proxy.refreshProperty(I,P)}async updateProperty(I,P,r){return this._proxy.updateProperty(I,P,r)}async restartPtyHost(){this._disposePtyHost(),this._isResponsive=!0,this._startPtyHost()}_disposePtyHost(){this._proxy.shutdownAll(),this._connection.store.dispose()}_handleHeartbeat(I){this._clearHeartbeatTimeouts(),this._heartbeatFirstTimeout=setTimeout(()=>this._handleHeartbeatFirstTimeout(),I?u.HeartbeatConstants.ConnectingBeatInterval:u.HeartbeatConstants.BeatInterval*u.HeartbeatConstants.FirstWaitMultiplier),this._isResponsive||(this._isResponsive=!0,this._onPtyHostResponsive.fire())}_handleHeartbeatFirstTimeout(){this._logService.warn(`No ptyHost heartbeat after ${u.HeartbeatConstants.BeatInterval*u.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this._heartbeatFirstTimeout=void 0,this._heartbeatSecondTimeout=setTimeout(()=>this._handleHeartbeatSecondTimeout(),u.HeartbeatConstants.BeatInterval*u.HeartbeatConstants.SecondWaitMultiplier)}_handleHeartbeatSecondTimeout(){this._logService.error(`No ptyHost heartbeat after ${(u.HeartbeatConstants.BeatInterval*u.HeartbeatConstants.FirstWaitMultiplier+u.HeartbeatConstants.BeatInterval*u.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this._heartbeatSecondTimeout=void 0,this._isResponsive&&(this._isResponsive=!1,this._onPtyHostUnresponsive.fire())}_handleUnresponsiveCreateProcess(){this._clearHeartbeatTimeouts(),this._logService.error(`No ptyHost response to createProcess after ${u.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this._isResponsive&&(this._isResponsive=!1,this._onPtyHostUnresponsive.fire())}_clearHeartbeatTimeouts(){this._heartbeatFirstTimeout&&(clearTimeout(this._heartbeatFirstTimeout),this._heartbeatFirstTimeout=void 0),this._heartbeatSecondTimeout&&(clearTimeout(this._heartbeatSecondTimeout),this._heartbeatSecondTimeout=void 0)}_resolveVariables(I,P){return this._resolveVariablesRequestStore.createRequest({workspaceId:I,originalText:P})}async acceptPtyHostResolvedVariables(I,P){this._resolveVariablesRequestStore.acceptReply(I,P)}};e.PtyHostService=b,e.PtyHostService=b=Pe([re(1,A.IConfigurationService),re(2,R.ILogService),re(3,R.ILoggerService)],b)});var je=this&&this.__importDefault||function(j){return j&&j.__esModule?j:{default:j}};define(le[77],ue([0,1,13,4,2,3,16,6,34]),function(j,e,i,s,y,k,A,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeMainService=e.IThemeMainService=void 0,i=je(i);const c="#FFFFFF",m="#1E1E1E",u="#000000",p="#FFFFFF",v="theme",f="themeBackground",h="windowSplash";var E;(function(g){g.DETECT_COLOR_SCHEME="window.autoDetectColorScheme",g.SYSTEM_COLOR_THEME="window.systemColorTheme"})(E||(E={})),e.IThemeMainService=(0,R.createDecorator)("themeMainService");let b=class extends y.Disposable{constructor(I,P){super(),this.stateService=I,this.configurationService=P,this._onDidChangeColorScheme=this._register(new s.Emitter),this.onDidChangeColorScheme=this._onDidChangeColorScheme.event,k.isLinux||this._register(this.configurationService.onDidChangeConfiguration(r=>{(r.affectsConfiguration(E.SYSTEM_COLOR_THEME)||r.affectsConfiguration(E.DETECT_COLOR_SCHEME))&&this.updateSystemColorTheme()})),this.updateSystemColorTheme(),this._register(s.Event.fromNodeEventEmitter(i.default.nativeTheme,"updated")(()=>this._onDidChangeColorScheme.fire(this.getColorScheme())))}updateSystemColorTheme(){if(k.isLinux||this.configurationService.getValue(E.DETECT_COLOR_SCHEME))i.default.nativeTheme.themeSource="system";else switch(this.configurationService.getValue(E.SYSTEM_COLOR_THEME)){case"dark":i.default.nativeTheme.themeSource="dark";break;case"light":i.default.nativeTheme.themeSource="light";break;case"auto":switch(this.getBaseTheme()){case"vs":i.default.nativeTheme.themeSource="light";break;case"vs-dark":i.default.nativeTheme.themeSource="dark";break;default:i.default.nativeTheme.themeSource="system"}break;default:i.default.nativeTheme.themeSource="system";break}}getColorScheme(){if(k.isWindows){if(i.default.nativeTheme.shouldUseHighContrastColors)return{dark:i.default.nativeTheme.shouldUseInvertedColorScheme,highContrast:!0}}else if(k.isMacintosh){if(i.default.nativeTheme.shouldUseInvertedColorScheme||i.default.nativeTheme.shouldUseHighContrastColors)return{dark:i.default.nativeTheme.shouldUseDarkColors,highContrast:!0}}else if(k.isLinux&&i.default.nativeTheme.shouldUseHighContrastColors)return{dark:!0,highContrast:!0};return{dark:i.default.nativeTheme.shouldUseDarkColors,highContrast:!1}}getBackgroundColor(){const I=this.getColorScheme();if(I.highContrast&&this.configurationService.getValue("window.autoDetectHighContrast"))return I.dark?u:p;let P=this.stateService.getItem(f,null);if(!P)switch(this.getBaseTheme()){case"vs":P=c;break;case"hc-black":P=u;break;case"hc-light":P=p;break;default:P=m}return k.isMacintosh&&P.toUpperCase()===m&&(P="#171717"),P}getBaseTheme(){switch(this.stateService.getItem(v,"vs-dark").split(" ")[0]){case"vs":return"vs";case"hc-black":return"hc-black";case"hc-light":return"hc-light";default:return"vs-dark"}}saveWindowSplash(I,P){this.stateService.setItems([{key:v,data:P.baseTheme},{key:f,data:P.colorInfo.background},{key:h,data:P}]),typeof I=="number"&&this.updateBackgroundColor(I,P),this.updateSystemColorTheme()}updateBackgroundColor(I,P){for(const r of i.default.BrowserWindow.getAllWindows())if(r.id===I){r.setBackgroundColor(P.colorInfo.background);break}}getWindowSplash(){return this.stateService.getItem(h)}};e.ThemeMainService=b,e.ThemeMainService=b=Pe([re(0,S.IStateService),re(1,A.IConfigurationService)],b)}),define(le[134],ue([0,1,4,2,3,7,16,6,5]),function(j,e,i,s,y,k,A,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.ALL_INTERFACES_ADDRESSES=e.LOCALHOST_ADDRESSES=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.isTunnelProvider=u,e.extractLocalHostUriMetaDataForPortMapping=v,e.extractQueryLocalHostUriMetaDataForPortMapping=f,e.isLocalhost=h,e.isAllInterfaces=E,e.isPortPrivileged=b,e.ITunnelService=(0,R.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,R.createDecorator)("sharedTunnelsService");var c;(function(P){P.Http="http",P.Https="https"})(c||(e.TunnelProtocol=c={}));var m;(function(P){P.ConstantPrivate="constantPrivate",P.Private="private",P.Public="public"})(m||(e.TunnelPrivacyId=m={}));function u(P){return!!P.forwardPort}var p;(function(P){P[P.Notify=1]="Notify",P[P.OpenBrowser=2]="OpenBrowser",P[P.OpenPreview=3]="OpenPreview",P[P.Silent=4]="Silent",P[P.Ignore=5]="Ignore",P[P.OpenBrowserOnce=6]="OpenBrowserOnce"})(p||(e.ProvidedOnAutoForward=p={}));function v(P){if(P.scheme!=="http"&&P.scheme!=="https")return;const r=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(P.authority);if(r)return{address:r[1],port:+r[2]}}function f(P){if(P.scheme!=="http"&&P.scheme!=="https"||!P.query)return;const r=P.query.split("&");for(const a of r){const t=a.split("=")[1];if(/^https?:/.exec(t)){const o=v(k.URI.parse(t));if(o)return o}}}e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function h(P){return e.LOCALHOST_ADDRESSES.indexOf(P)>=0}e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function E(P){return e.ALL_INTERFACES_ADDRESSES.indexOf(P)>=0}function b(P,r,a,t){if(a===y.OperatingSystem.Windows)return!1;if(a===y.OperatingSystem.Macintosh&&E(r)){const o=/(\d+)\.(\d+)\.(\d+)/g.exec(t);if(o?.length===4&&parseInt(o[1])>=18)return!1}return P<1024}class g{constructor(r,a,t){this.remoteAddress=r,this.localAddress=a,this._dispose=t,this._onDispose=new i.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}e.DisposableTunnel=g;let I=class extends s.Disposable{constructor(r,a){super(),this.logService=r,this.configurationService=a,this._onTunnelOpened=new i.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new i.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new i.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._canChangeProtocol=!0,this._privacyOptions=[],this._factoryInProgress=new Set}get hasTunnelProvider(){return!!this._tunnelProvider}get defaultTunnelHost(){const r=this.configurationService.getValue("remote.localPortHost");return!r||r==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(r){return this._tunnelProvider=r,r?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(r){this._canElevate=r.elevation,this._privacyOptions=r.privacyOptions,this._canChangeProtocol=r.protocol}get canChangeProtocol(){return this._canChangeProtocol}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const r=[],a=Array.from(this._tunnels.values());for(const t of a){const o=Array.from(t.values());for(const n of o){const l=await n.value;l&&typeof l!="string"&&r.push(l)}}return r}async dispose(){super.dispose();for(const r of this._tunnels.values()){for(const{value:a}of r.values())await a.then(t=>typeof t!="string"?t?.dispose():void 0);r.clear()}this._tunnels.clear()}setEnvironmentTunnel(r,a,t,o,n){this.addTunnelToMap(r,a,Promise.resolve({tunnelRemoteHost:r,tunnelRemotePort:a,localAddress:t,privacy:o,protocol:n,dispose:()=>Promise.resolve()}))}async getExistingTunnel(r,a){(E(r)||h(r))&&(r=e.LOCALHOST_ADDRESSES[0]);const t=this.getTunnelFromMap(r,a);if(t)return++t.refcount,t.value}openTunnel(r,a,t,o,n,l=!1,d,D){this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${a}:${t} on local port ${n}.`);const w=this._tunnelProvider??r;if(!w)return;if(a||(a="localhost"),o||(o=this.defaultTunnelHost),this._tunnelProvider&&this._factoryInProgress.has(t)){this.logService.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const M=this.retainOrCreateTunnel(w,a,t,o,n,l,d,D);return M?M.then(T=>{if(T){if(typeof T=="string")return this.logService.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.removeEmptyOrErrorTunnelFromMap(a,t),T}else{this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyOrErrorTunnelFromMap(a,t);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const C=this.makeTunnel(T);return(T.tunnelRemoteHost!==a||T.tunnelRemotePort!==t)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),d&&T.privacy!==d&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this._onTunnelOpened.fire(C),C}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),M)}makeTunnel(r){return{tunnelRemotePort:r.tunnelRemotePort,tunnelRemoteHost:r.tunnelRemoteHost,tunnelLocalPort:r.tunnelLocalPort,localAddress:r.localAddress,privacy:r.privacy,protocol:r.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${r.tunnelRemoteHost}:${r.tunnelRemotePort} `);const a=this._tunnels.get(r.tunnelRemoteHost);if(a){const t=a.get(r.tunnelRemotePort);t&&(t.refcount--,await this.tryDisposeTunnel(r.tunnelRemoteHost,r.tunnelRemotePort,t))}}}}async tryDisposeTunnel(r,a,t){if(t.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${r}:${a}.`);const o=t.value.then(async n=>{n&&typeof n!="string"&&(await n.dispose(!0),this._onTunnelClosed.fire({host:n.tunnelRemoteHost,port:n.tunnelRemotePort}))});return this._tunnels.has(r)&&this._tunnels.get(r).delete(a),o}}async closeTunnel(r,a){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${r}:${a} `);const t=this._tunnels.get(r);if(t&&t.has(a)){const o=t.get(a);o.refcount=0,await this.tryDisposeTunnel(r,a,o)}}addTunnelToMap(r,a,t){this._tunnels.has(r)||this._tunnels.set(r,new Map),this._tunnels.get(r).set(a,{refcount:1,value:t})}async removeEmptyOrErrorTunnelFromMap(r,a){const t=this._tunnels.get(r);if(t){const o=t.get(a),n=o?await o.value:void 0;(!n||typeof n=="string")&&t.delete(a),t.size===0&&this._tunnels.delete(r)}}getTunnelFromMap(r,a){const t=[r];h(r)?(t.push(...e.LOCALHOST_ADDRESSES),t.push(...e.ALL_INTERFACES_ADDRESSES)):E(r)&&t.push(...e.ALL_INTERFACES_ADDRESSES);const o=t.map(n=>this._tunnels.get(n));for(const n of o){const l=n?.get(a);if(l)return l}}canTunnel(r){return!!v(r)}createWithProvider(r,a,t,o,n,l,d){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${a}:${t} on local port ${o}.`);const D=t;this._factoryInProgress.add(D);const w=o===void 0?t:o,M={elevationRequired:n?this.isPortPrivileged(w):!1},T={remoteAddress:{host:a,port:t},localAddressPort:o,privacy:l,public:l?l!==m.Private:void 0,protocol:d},C=r.forwardPort(T,M);return C?(this.addTunnelToMap(a,t,C),C.finally(()=>{this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this._factoryInProgress.delete(D)})):this._factoryInProgress.delete(D),C}};e.AbstractTunnelService=I,e.AbstractTunnelService=I=Pe([re(0,S.ILogService),re(1,A.IConfigurationService)],I)}),define(le[51],ue([0,1,6]),function(j,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUpdateService=e.State=e.DisablementReason=e.UpdateType=e.StateType=void 0;var s;(function(A){A.Uninitialized="uninitialized",A.Idle="idle",A.Disabled="disabled",A.CheckingForUpdates="checking for updates",A.AvailableForDownload="available for download",A.Downloading="downloading",A.Downloaded="downloaded",A.Updating="updating",A.Ready="ready"})(s||(e.StateType=s={}));var y;(function(A){A[A.Setup=0]="Setup",A[A.Archive=1]="Archive",A[A.Snap=2]="Snap"})(y||(e.UpdateType=y={}));var k;(function(A){A[A.NotBuilt=0]="NotBuilt",A[A.DisabledByEnvironment=1]="DisabledByEnvironment",A[A.ManuallyDisabled=2]="ManuallyDisabled",A[A.MissingConfiguration=3]="MissingConfiguration",A[A.InvalidConfiguration=4]="InvalidConfiguration",A[A.RunningAsAdmin=5]="RunningAsAdmin"})(k||(e.DisablementReason=k={})),e.State={Uninitialized:{type:s.Uninitialized},Disabled:A=>({type:s.Disabled,reason:A}),Idle:(A,R)=>({type:s.Idle,updateType:A,error:R}),CheckingForUpdates:A=>({type:s.CheckingForUpdates,explicit:A}),AvailableForDownload:A=>({type:s.AvailableForDownload,update:A}),Downloading:{type:s.Downloading},Downloaded:A=>({type:s.Downloaded,update:A}),Updating:A=>({type:s.Updating,update:A}),Ready:A=>({type:s.Ready,update:A})},e.IUpdateService=(0,i.createDecorator)("updateService")}),define(le[236],ue([0,1,3,9,56,46]),function(j,e,i,s,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),k.Registry.as(y.Extensions.Configuration).registerConfiguration({id:"update",order:15,title:(0,s.localize)(2431,null),type:"object",properties:{"update.mode":{type:"string",enum:["none","manual","start","default"],default:"default",scope:y.ConfigurationScope.APPLICATION,description:(0,s.localize)(2432,null),tags:["usesOnlineServices"],enumDescriptions:[(0,s.localize)(2433,null),(0,s.localize)(2434,null),(0,s.localize)(2435,null),(0,s.localize)(2436,null)],policy:{name:"UpdateMode",minimumVersion:"1.67"}},"update.channel":{type:"string",default:"default",scope:y.ConfigurationScope.APPLICATION,description:(0,s.localize)(2437,null),deprecationMessage:(0,s.localize)(2438,null,"update.mode")},"update.enableWindowsBackgroundUpdates":{type:"boolean",default:!0,scope:y.ConfigurationScope.APPLICATION,title:(0,s.localize)(2439,null),description:(0,s.localize)(2440,null),included:i.isWindows&&!i.isWeb},"update.showReleaseNotes":{type:"boolean",default:!0,scope:y.ConfigurationScope.APPLICATION,description:(0,s.localize)(2441,null),tags:["usesOnlineServices"]}}})}),define(le[237],ue([0,1,4,51]),function(j,e,i,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UpdateChannelClient=e.UpdateChannel=void 0;class y{constructor(R){this.service=R}listen(R,S){switch(S){case"onStateChange":return this.service.onStateChange}throw new Error(`Event not found: ${S}`)}call(R,S,c){switch(S){case"checkForUpdates":return this.service.checkForUpdates(c);case"downloadUpdate":return this.service.downloadUpdate();case"applyUpdate":return this.service.applyUpdate();case"quitAndInstall":return this.service.quitAndInstall();case"_getInitialState":return Promise.resolve(this.service.state);case"isLatestVersion":return this.service.isLatestVersion();case"_applySpecificUpdate":return this.service._applySpecificUpdate(c)}throw new Error(`Call not found: ${S}`)}}e.UpdateChannel=y;class k{get state(){return this._state}set state(R){this._state=R,this._onStateChange.fire(R)}constructor(R){this.channel=R,this._onStateChange=new i.Emitter,this.onStateChange=this._onStateChange.event,this._state=s.State.Uninitialized,this.channel.listen("onStateChange")(S=>this.state=S),this.channel.call("_getInitialState").then(S=>this.state=S)}checkForUpdates(R){return this.channel.call("checkForUpdates",R)}downloadUpdate(){return this.channel.call("downloadUpdate")}applyUpdate(){return this.channel.call("applyUpdate")}quitAndInstall(){return this.channel.call("quitAndInstall")}isLatestVersion(){return this.channel.call("isLatestVersion")}_applySpecificUpdate(R){return this.channel.call("_applySpecificUpdate",R)}}e.UpdateChannelClient=k}),define(le[41],ue([0,1,6]),function(j,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,i.createDecorator)("IUriIdentityService")}),define(le[238],ue([0,1,41,177,14,18,148,4,2]),function(j,e,i,s,y,k,A,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class c{static{this._clock=0}constructor(p){this.uri=p,this.time=c._clock++}touch(){return this.time=c._clock++,this}}let m=class{constructor(p){this._fileService=p,this._dispooables=new S.DisposableStore,this._limit=2**16;const v=new Map,f=h=>{let E=v.get(h.scheme);return E===void 0&&(E=p.hasProvider(h)&&!this._fileService.hasCapability(h,y.FileSystemProviderCapabilities.PathCaseSensitive),v.set(h.scheme,E)),E};this._dispooables.add(R.Event.any(p.onDidChangeFileSystemProviderRegistrations,p.onDidChangeFileSystemProviderCapabilities)(h=>{v.delete(h.scheme)})),this.extUri=new k.ExtUri(f),this._canonicalUris=new A.SkipList((h,E)=>this.extUri.compare(h,E,!0),this._limit)}dispose(){this._dispooables.dispose(),this._canonicalUris.clear()}asCanonicalUri(p){this._fileService.hasProvider(p)&&(p=(0,k.normalizePath)(p));const v=this._canonicalUris.get(p);return v?v.touch().uri.with({fragment:p.fragment}):(this._canonicalUris.set(p,new c(p)),this._checkTrim(),p)}_checkTrim(){if(this._canonicalUris.size<this._limit)return;const p=[...this._canonicalUris.entries()].sort((f,h)=>f[1].time<h[1].time?1:f[1].time>h[1].time?-1:0);c._clock=0,this._canonicalUris.clear();const v=this._limit*.5;for(let f=0;f<v;f++)this._canonicalUris.set(p[f][0],p[f][1].touch())}};e.UriIdentityService=m,e.UriIdentityService=m=Pe([re(0,y.IFileService)],m),(0,s.registerSingleton)(i.IUriIdentityService,m,s.InstantiationType.Delayed)}),define(le[135],ue([0,1,6]),function(j,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IURLService=void 0,e.IURLService=(0,i.createDecorator)("urlService")}),define(le[239],ue([0,1,7]),function(j,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URLHandlerRouter=e.URLHandlerChannelClient=e.URLHandlerChannel=void 0;class s{constructor(R){this.handler=R}listen(R,S){throw new Error(`Event not found: ${S}`)}call(R,S,c){switch(S){case"handleURL":return this.handler.handleURL(i.URI.revive(c[0]),c[1])}throw new Error(`Call not found: ${S}`)}}e.URLHandlerChannel=s;class y{constructor(R){this.channel=R}handleURL(R,S){return this.channel.call("handleURL",[R.toJSON(),S])}}e.URLHandlerChannelClient=y;class k{constructor(R,S){this.next=R,this.logService=S}async routeCall(R,S,c,m){if(S!=="handleURL")throw new Error(`Call not found: ${S}`);if(Array.isArray(c)&&c.length>0){const u=i.URI.revive(c[0]);if(this.logService.trace("URLHandlerRouter#routeCall() with URI argument",u.toString(!0)),u.query){const p=/\bwindowId=(\d+)/.exec(u.query);if(p){const v=p[1];this.logService.trace(`URLHandlerRouter#routeCall(): found windowId query parameter with value "${v}"`,u.toString(!0));const f=new RegExp(`window:${v}`),h=R.connections.find(E=>(this.logService.trace("URLHandlerRouter#routeCall(): testing connection",E.ctx),f.test(E.ctx)));if(h)return this.logService.trace("URLHandlerRouter#routeCall(): found a connection to route",u.toString(!0)),h;this.logService.trace("URLHandlerRouter#routeCall(): did not find a connection to route",u.toString(!0))}else this.logService.trace("URLHandlerRouter#routeCall(): did not find windowId query parameter",u.toString(!0))}}else this.logService.trace("URLHandlerRouter#routeCall() without URI argument");return this.next.routeCall(R,S,c,m)}routeEvent(R,S){throw new Error(`Event not found: ${S}`)}}e.URLHandlerRouter=k}),define(le[240],ue([0,1,8,2,7,28]),function(j,e,i,s,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeURLService=e.AbstractURLService=void 0;class A extends s.Disposable{constructor(){super(...arguments),this.handlers=new Set}open(c,m){const u=[...this.handlers.values()];return(0,i.first)(u.map(p=>()=>p.handleURL(c,m)),void 0,!1).then(p=>p||!1)}registerHandler(c){return this.handlers.add(c),(0,s.toDisposable)(()=>this.handlers.delete(c))}}e.AbstractURLService=A;let R=class extends A{constructor(c){super(),this.productService=c}create(c){let{authority:m,path:u,query:p,fragment:v}=c||{authority:void 0,path:void 0,query:void 0,fragment:void 0};return m&&u&&u.indexOf("/")!==0&&(u=`/${u}`),y.URI.from({scheme:this.productService.urlProtocol,authority:m,path:u,query:p,fragment:v})}};e.NativeURLService=R,e.NativeURLService=R=Pe([re(0,k.IProductService)],R)}),define(le[241],ue([0,1,13,8,4,2,3,7]),function(j,e,i,s,y,k,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronURLListener=void 0;class S extends k.Disposable{constructor(m,u,p,v,f,h){if(super(),this.urlService=u,this.logService=h,this.uris=[],this.retryCount=0,m&&(h.trace("ElectronURLListener initialUrisToHandle:",m.map(g=>g.originalUrl)),this.uris=m),A.isWindows){const g=v.isBuilt?[]:[`"${v.appRoot}"`];g.push("--open-url","--"),i.app.setAsDefaultProtocolClient(f.urlProtocol,process.execPath,g)}const E=y.Event.map(y.Event.fromNodeEventEmitter(i.app,"open-url",(g,I)=>({event:g,url:I})),({event:g,url:I})=>(g.preventDefault(),I));this._register(E(g=>{const I=this.uriFromRawUrl(g);I&&this.urlService.open(I,{originalUrl:g})})),p.getWindows().filter(g=>g.isReady).length>0?(h.trace("ElectronURLListener: window is ready to handle URLs"),this.flush()):(h.trace("ElectronURLListener: waiting for window to be ready to handle URLs..."),this._register(y.Event.once(p.onDidSignalReadyWindow)(()=>this.flush())))}uriFromRawUrl(m){try{return R.URI.parse(m)}catch{return}}async flush(){if(this.retryCount++>10){this.logService.trace("ElectronURLListener#flush(): giving up after 10 retries");return}this.logService.trace("ElectronURLListener#flush(): flushing URLs");const m=[];for(const u of this.uris)await this.urlService.open(u.uri,{originalUrl:u.originalUrl})?this.logService.trace("ElectronURLListener#flush(): URL was handled",u.originalUrl):(this.logService.trace("ElectronURLListener#flush(): URL was not yet handled",u.originalUrl),m.push(u));m.length!==0&&(this.uris=m,(0,s.disposableTimeout)(()=>this.flush(),500,this._store))}}e.ElectronURLListener=S}),define(le[242],ue([0,1,4,2,14,61,31]),function(j,e,i,s,y,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileUserDataProvider=void 0;class R extends s.Disposable{constructor(c,m,u,p,v,f){super(),this.fileSystemScheme=c,this.fileSystemProvider=m,this.userDataScheme=u,this.userDataProfilesService=p,this.uriIdentityService=v,this.logService=f,this.capabilities=this.fileSystemProvider.capabilities,this.onDidChangeCapabilities=this.fileSystemProvider.onDidChangeCapabilities,this._onDidChangeFile=this._register(new i.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.watchResources=k.TernarySearchTree.forUris(()=>!(this.capabilities&y.FileSystemProviderCapabilities.PathCaseSensitive)),this.atomicReadWriteResources=new A.ResourceSet(h=>this.uriIdentityService.extUri.getComparisonKey(this.toFileSystemResource(h))),this.updateAtomicReadWritesResources(),this._register(p.onDidChangeProfiles(()=>this.updateAtomicReadWritesResources())),this._register(this.fileSystemProvider.onDidChangeFile(h=>this.handleFileChanges(h)))}updateAtomicReadWritesResources(){this.atomicReadWriteResources.clear();for(const c of this.userDataProfilesService.profiles)this.atomicReadWriteResources.add(c.settingsResource),this.atomicReadWriteResources.add(c.keybindingsResource),this.atomicReadWriteResources.add(c.tasksResource),this.atomicReadWriteResources.add(c.extensionsResource)}open(c,m){return this.fileSystemProvider.open(this.toFileSystemResource(c),m)}close(c){return this.fileSystemProvider.close(c)}read(c,m,u,p,v){return this.fileSystemProvider.read(c,m,u,p,v)}write(c,m,u,p,v){return this.fileSystemProvider.write(c,m,u,p,v)}watch(c,m){this.watchResources.set(c,c);const u=this.fileSystemProvider.watch(this.toFileSystemResource(c),m);return(0,s.toDisposable)(()=>{this.watchResources.delete(c),u.dispose()})}stat(c){return this.fileSystemProvider.stat(this.toFileSystemResource(c))}mkdir(c){return this.fileSystemProvider.mkdir(this.toFileSystemResource(c))}rename(c,m,u){return this.fileSystemProvider.rename(this.toFileSystemResource(c),this.toFileSystemResource(m),u)}readFile(c,m){return this.fileSystemProvider.readFile(this.toFileSystemResource(c),m)}readFileStream(c,m,u){return this.fileSystemProvider.readFileStream(this.toFileSystemResource(c),m,u)}readdir(c){return this.fileSystemProvider.readdir(this.toFileSystemResource(c))}enforceAtomicReadFile(c){return this.atomicReadWriteResources.has(c)}writeFile(c,m,u){return this.fileSystemProvider.writeFile(this.toFileSystemResource(c),m,u)}enforceAtomicWriteFile(c){return this.atomicReadWriteResources.has(c)?{postfix:".vsctmp"}:!1}delete(c,m){return this.fileSystemProvider.delete(this.toFileSystemResource(c),m)}copy(c,m,u){if((0,y.hasFileFolderCopyCapability)(this.fileSystemProvider))return this.fileSystemProvider.copy(this.toFileSystemResource(c),this.toFileSystemResource(m),u);throw new Error("copy not supported")}cloneFile(c,m){if((0,y.hasFileCloneCapability)(this.fileSystemProvider))return this.fileSystemProvider.cloneFile(this.toFileSystemResource(c),this.toFileSystemResource(m));throw new Error("clone not supported")}handleFileChanges(c){const m=[];for(const u of c){if(u.resource.scheme!==this.fileSystemScheme)continue;const p=this.toUserDataResource(u.resource);this.watchResources.findSubstr(p)&&m.push({resource:p,type:u.type,cId:u.cId})}m.length&&(this.logService.debug("User data changed"),this._onDidChangeFile.fire(m))}toFileSystemResource(c){return c.with({scheme:this.fileSystemScheme})}toUserDataResource(c){return c.with({scheme:this.userDataScheme})}}e.FileUserDataProvider=R}),define(le[243],ue([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcUtilityProcessWorkerChannelName=void 0,e.ipcUtilityProcessWorkerChannelName="utilityProcessWorker"}),define(le[244],ue([0,1,6]),function(j,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWebviewManagerService=void 0,e.IWebviewManagerService=(0,i.createDecorator)("webviewManagerService")}),define(le[245],ue([0,1,13,2,11,7]),function(j,e,i,s,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewProtocolProvider=void 0;class A extends s.Disposable{static{this.validWebviewFilePaths=new Map([["/index.html","index.html"],["/fake.html","fake.html"],["/service-worker.js","service-worker.js"]])}constructor(){super();const S=this.handleWebviewRequest.bind(this);i.protocol.registerFileProtocol(y.Schemas.vscodeWebview,S)}handleWebviewRequest(S,c){try{const m=k.URI.parse(S.url),u=A.validWebviewFilePaths.get(m.path);if(typeof u=="string"){const p=`vs/workbench/contrib/webview/browser/pre/${u}`,v=y.FileAccess.asFileUri(p);return c({path:v.fsPath,headers:{...y.COI.getHeadersFromQuery(S.url),"Cross-Origin-Resource-Policy":"cross-origin"}})}else return c({error:-10})}catch{}return c({error:-2})}}e.WebviewProtocolProvider=A}),define(le[47],ue([0,1,3]),function(j,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DEFAULT_CUSTOM_TITLEBAR_HEIGHT=e.CustomTitleBarVisibility=e.TitlebarStyle=e.TitleBarSetting=e.WindowMinimumSize=void 0,e.isOpenedAuxiliaryWindow=s,e.isWorkspaceToOpen=y,e.isFolderToOpen=k,e.isFileToOpen=A,e.getMenuBarVisibility=R,e.hasCustomTitlebar=u,e.hasNativeTitlebar=p,e.getTitleBarStyle=v,e.useWindowControlsOverlay=f,e.useNativeFullScreen=h,e.zoomLevelToZoomFactor=E,e.WindowMinimumSize={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function s(b){return typeof b.parentId=="number"}function y(b){return!!b.workspaceUri}function k(b){return!!b.folderUri}function A(b){return!!b.fileUri}function R(b){const g=p(b),I=b.getValue("window.menuBarVisibility");return I==="default"||g&&I==="compact"||i.isMacintosh&&i.isNative?"classic":I}var S;(function(b){b.TITLE_BAR_STYLE="window.titleBarStyle",b.CUSTOM_TITLE_BAR_VISIBILITY="window.customTitleBarVisibility"})(S||(e.TitleBarSetting=S={}));var c;(function(b){b.NATIVE="native",b.CUSTOM="custom"})(c||(e.TitlebarStyle=c={}));var m;(function(b){b.AUTO="auto",b.WINDOWED="windowed",b.NEVER="never"})(m||(e.CustomTitleBarVisibility=m={}));function u(b,g){return!0}function p(b,g){return g||(g=v(b)),g===c.NATIVE}function v(b){if(i.isWeb)return c.CUSTOM;const g=b.getValue("window");if(g){if(i.isMacintosh&&g.nativeTabs===!0||i.isMacintosh&&g.nativeFullScreen===!1)return c.NATIVE;const r=g.titleBarStyle;if(r===c.NATIVE||r===c.CUSTOM)return r}return i.isLinux?c.NATIVE:c.CUSTOM}e.DEFAULT_CUSTOM_TITLEBAR_HEIGHT=35;function f(b){if(i.isMacintosh||i.isWeb||p(b))return!1;if(i.isLinux){const g=b.getValue("window.experimentalControlOverlay");if(typeof g=="boolean")return g}return!0}function h(b){const g=b.getValue("window");return!g||typeof g.nativeFullScreen!="boolean"||g.nativeTabs?!0:g.nativeFullScreen!==!1}function E(b=0){return Math.pow(1.2,b)}});var je=this&&this.__importDefault||function(j){return j&&j.__esModule?j:{default:j}};define(le[52],ue([0,1,13]),function(j,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowError=e.WindowMode=e.defaultAuxWindowState=e.defaultWindowState=e.UnloadReason=e.LoadReason=void 0,i=je(i);var s;(function(c){c[c.INITIAL=1]="INITIAL",c[c.LOAD=2]="LOAD",c[c.RELOAD=3]="RELOAD"})(s||(e.LoadReason=s={}));var y;(function(c){c[c.CLOSE=1]="CLOSE",c[c.QUIT=2]="QUIT",c[c.RELOAD=3]="RELOAD",c[c.LOAD=4]="LOAD"})(y||(e.UnloadReason=y={}));const k=function(c=R.Normal){return{width:1024,height:768,mode:c}};e.defaultWindowState=k;const A=function(){const u=i.default.screen.getPrimaryDisplay().workArea,p=Math.max(u.x+u.width/2-800/2,0),v=Math.max(u.y+u.height/2-600/2,0);return{x:p,y:v,width:800,height:600,mode:R.Normal}};e.defaultAuxWindowState=A;var R;(function(c){c[c.Maximized=0]="Maximized",c[c.Normal=1]="Normal",c[c.Minimized=2]="Minimized",c[c.Fullscreen=3]="Fullscreen"})(R||(e.WindowMode=R={}));var S;(function(c){c[c.UNRESPONSIVE=1]="UNRESPONSIVE",c[c.PROCESS_GONE=2]="PROCESS_GONE",c[c.LOAD=3]="LOAD"})(S||(e.WindowError=S={}))}),define(le[246],ue([0,1,8,4,2]),function(j,e,i,s,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class k extends y.Disposable{constructor({onDidOpenMainWindow:R,onDidFocusMainWindow:S,getActiveWindowId:c}){super(),this.disposables=this._register(new y.DisposableStore),s.Event.latch(s.Event.any(R,S))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=(0,i.createCancelablePromise)(()=>c()),(async()=>{try{const u=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:u}catch{}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(R){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=R}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=k}),define(le[30],ue([0,1,9,10,61,18,7,6,11]),function(j,e,i,s,y,k,A,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.STANDALONE_EDITOR_WORKSPACE_ID=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.WorkspaceFolder=e.Workspace=e.WorkbenchState=e.UNKNOWN_EMPTY_WINDOW_WORKSPACE=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.IWorkspaceContextService=void 0,e.isSingleFolderWorkspaceIdentifier=c,e.isEmptyWorkspaceIdentifier=m,e.toWorkspaceIdentifier=u,e.isWorkspaceIdentifier=p,e.reviveIdentifier=v,e.isWorkspace=h,e.isWorkspaceFolder=E,e.toWorkspaceFolder=I,e.isUntitledWorkspace=P,e.isTemporaryWorkspace=r,e.isStandaloneEditorWorkspace=a,e.isSavedWorkspace=t,e.hasWorkspaceFileExtension=o,e.IWorkspaceContextService=(0,R.createDecorator)("contextService");function c(n){const l=n;return typeof l?.id=="string"&&A.URI.isUri(l.uri)}function m(n){return typeof n?.id=="string"&&!c(n)&&!p(n)}e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"},e.UNKNOWN_EMPTY_WINDOW_WORKSPACE={id:"empty-window"};function u(n,l){if(typeof n=="string"||typeof n>"u")return typeof n=="string"?{id:(0,s.basename)(n)}:l?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:e.UNKNOWN_EMPTY_WINDOW_WORKSPACE;const d=n;return d.configuration?{id:d.id,configPath:d.configuration}:d.folders.length===1?{id:d.id,uri:d.folders[0].uri}:{id:d.id}}function p(n){const l=n;return typeof l?.id=="string"&&A.URI.isUri(l.configPath)}function v(n){const l=n;if(l?.uri)return{id:l.id,uri:A.URI.revive(l.uri)};const d=n;if(d?.configPath)return{id:d.id,configPath:A.URI.revive(d.configPath)};if(n?.id)return{id:n.id}}var f;(function(n){n[n.EMPTY=1]="EMPTY",n[n.FOLDER=2]="FOLDER",n[n.WORKSPACE=3]="WORKSPACE"})(f||(e.WorkbenchState=f={}));function h(n){const l=n;return!!(l&&typeof l=="object"&&typeof l.id=="string"&&Array.isArray(l.folders))}function E(n){const l=n;return!!(l&&typeof l=="object"&&A.URI.isUri(l.uri)&&typeof l.name=="string"&&typeof l.toResource=="function")}class b{constructor(l,d,D,w,M){this._id=l,this._transient=D,this._configuration=w,this._ignorePathCasing=M,this._foldersMap=y.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0),this.folders=d}update(l){this._id=l.id,this._configuration=l.configuration,this._transient=l.transient,this._ignorePathCasing=l._ignorePathCasing,this.folders=l.folders}get folders(){return this._folders}set folders(l){this._folders=l,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(l){this._configuration=l}getFolder(l){return l&&this._foldersMap.findSubstr(l)||null}updateFoldersMap(){this._foldersMap=y.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0);for(const l of this.folders)this._foldersMap.set(l.uri,l)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=b;class g{constructor(l,d){this.raw=d,this.uri=l.uri,this.index=l.index,this.name=l.name}toResource(l){return(0,k.joinPath)(this.uri,l)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=g;function I(n){return new g({uri:n,index:0,name:(0,k.basenameOrAuthority)(n)},{uri:n.toString()})}e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,i.localize)(2489,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function P(n,l){return k.extUriBiasedIgnorePathCase.isEqualOrParent(n,l.untitledWorkspacesHome)}function r(n){let l;return A.URI.isUri(n)?l=n:l=n.configuration,l?.scheme===S.Schemas.tmp}e.STANDALONE_EDITOR_WORKSPACE_ID="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function a(n){return n.id===e.STANDALONE_EDITOR_WORKSPACE_ID}function t(n,l){return!P(n,l)&&!r(n)}function o(n){return(typeof n=="string"?(0,s.extname)(n):(0,k.extname)(n))===e.WORKSPACE_SUFFIX}});var je=this&&this.__importDefault||function(j){return j&&j.__esModule?j:{default:j}};define(le[53],ue([0,1,13,8,48,49,2,79,3,23,9,126,6,5,28,30]),function(j,e,i,s,y,k,A,R,S,c,m,u,p,v,f,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DialogMainService=e.IDialogMainService=void 0,i=je(i),e.IDialogMainService=(0,p.createDecorator)("dialogMainService");let E=class{constructor(g,I){this.logService=g,this.productService=I,this.windowFileDialogLocks=new Map,this.windowDialogQueues=new Map,this.noWindowDialogueQueue=new s.Queue}pickFileFolder(g,I){return this.doPick({...g,pickFolders:!0,pickFiles:!0,title:(0,m.localize)(1707,null)},I)}pickFolder(g,I){return this.doPick({...g,pickFolders:!0,title:(0,m.localize)(1708,null)},I)}pickFile(g,I){return this.doPick({...g,pickFiles:!0,title:(0,m.localize)(1709,null)},I)}pickWorkspace(g,I){const P=(0,m.localize)(1710,null),r=(0,k.mnemonicButtonLabel)((0,m.localize)(1711,null)),a=h.WORKSPACE_FILTER;return this.doPick({...g,pickFiles:!0,title:P,filters:a,buttonLabel:r},I)}async doPick(g,I){const P={title:g.title,buttonLabel:g.buttonLabel,filters:g.filters,defaultPath:g.defaultPath};(typeof g.pickFiles=="boolean"||typeof g.pickFolders=="boolean")&&(P.properties=void 0,g.pickFiles&&g.pickFolders&&(P.properties=["multiSelections","openDirectory","openFile","createDirectory"])),P.properties||(P.properties=["multiSelections",g.pickFolders?"openDirectory":"openFile","createDirectory"]),S.isMacintosh&&P.properties.push("treatPackageAsDirectory");const r=await this.showOpenDialog(P,(I||i.default.BrowserWindow.getFocusedWindow())??void 0);if(r&&r.filePaths&&r.filePaths.length>0)return r.filePaths}getWindowDialogQueue(g){if(g){let I=this.windowDialogQueues.get(g.id);return I||(I=new s.Queue,this.windowDialogQueues.set(g.id,I)),I}else return this.noWindowDialogueQueue}showMessageBox(g,I){return this.getWindowDialogQueue(I).queue(async()=>{const{options:P,buttonIndeces:r}=(0,u.massageMessageBoxOptions)(g,this.productService);let a;return I?a=await i.default.dialog.showMessageBox(I,P):a=await i.default.dialog.showMessageBox(P),{response:r[a.response],checkboxChecked:a.checkboxChecked}})}async showSaveDialog(g,I){const P=this.acquireFileDialogLock(g,I);if(!P)return this.logService.error("[DialogMainService]: file save dialog is already or will be showing for the window with the same configuration"),{canceled:!0,filePath:""};try{return await this.getWindowDialogQueue(I).queue(async()=>{let r;return I?r=await i.default.dialog.showSaveDialog(I,g):r=await i.default.dialog.showSaveDialog(g),r.filePath=this.normalizePath(r.filePath),r})}finally{(0,A.dispose)(P)}}normalizePath(g){return g&&S.isMacintosh&&(g=(0,R.normalizeNFC)(g)),g}normalizePaths(g){return g.map(I=>this.normalizePath(I))}async showOpenDialog(g,I){g.defaultPath&&(await c.Promises.exists(g.defaultPath)||(g.defaultPath=void 0));const P=this.acquireFileDialogLock(g,I);if(!P)return this.logService.error("[DialogMainService]: file open dialog is already or will be showing for the window with the same configuration"),{canceled:!0,filePaths:[]};try{return await this.getWindowDialogQueue(I).queue(async()=>{let r;return I?r=await i.default.dialog.showOpenDialog(I,g):r=await i.default.dialog.showOpenDialog(g),r.filePaths=this.normalizePaths(r.filePaths),r})}finally{(0,A.dispose)(P)}}acquireFileDialogLock(g,I){if(!I)return A.Disposable.None;this.logService.trace("[DialogMainService]: request to acquire file dialog lock",g);let P=this.windowFileDialogLocks.get(I.id);P||(P=new Set,this.windowFileDialogLocks.set(I.id,P));const r=(0,y.hash)(g);if(!P.has(r))return this.logService.trace("[DialogMainService]: new file dialog lock created",g),P.add(r),(0,A.toDisposable)(()=>{this.logService.trace("[DialogMainService]: file dialog lock disposed",g),P?.delete(r),P?.size===0&&this.windowFileDialogLocks.delete(I.id)})}};e.DialogMainService=E,e.DialogMainService=E=Pe([re(0,v.ILogService),re(1,f.IProductService)],E)}),define(le[247],ue([0,1,4,2,83,30]),function(j,e,i,s,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDatabaseChannel=void 0;class A extends s.Disposable{static{this.STORAGE_CHANGE_DEBOUNCE_TIME=100}constructor(S,c){super(),this.logService=S,this.storageMainService=c,this.onDidChangeApplicationStorageEmitter=this._register(new i.Emitter),this.mapProfileToOnDidChangeProfileStorageEmitter=new Map,this.registerStorageChangeListeners(c.applicationStorage,this.onDidChangeApplicationStorageEmitter)}registerStorageChangeListeners(S,c){this._register(i.Event.debounce(S.onDidChangeStorage,(m,u)=>(m?m.push(u):m=[u],m),A.STORAGE_CHANGE_DEBOUNCE_TIME)(m=>{m.length&&c.fire(this.serializeStorageChangeEvents(m,S))}))}serializeStorageChangeEvents(S,c){const m=new Map,u=new Set;return S.forEach(p=>{const v=c.get(p.key);typeof v=="string"?m.set(p.key,v):u.add(p.key)}),{changed:Array.from(m.entries()),deleted:Array.from(u.values())}}listen(S,c,m){switch(c){case"onDidChangeStorage":{const u=m.profile?(0,y.revive)(m.profile):void 0;if(!u)return this.onDidChangeApplicationStorageEmitter.event;let p=this.mapProfileToOnDidChangeProfileStorageEmitter.get(u.id);return p||(p=this._register(new i.Emitter),this.registerStorageChangeListeners(this.storageMainService.profileStorage(u),p),this.mapProfileToOnDidChangeProfileStorageEmitter.set(u.id,p)),p.event}}throw new Error(`Event not found: ${c}`)}async call(S,c,m){const u=m.profile?(0,y.revive)(m.profile):void 0,p=(0,k.reviveIdentifier)(m.workspace),v=await this.withStorageInitialized(u,p);switch(c){case"getItems":return Array.from(v.items.entries());case"updateItems":{const f=m;if(f.insert)for(const[h,E]of f.insert)v.set(h,E);f.delete?.forEach(h=>v.delete(h));break}case"optimize":return v.optimize();case"isUsed":{const f=m.payload;if(typeof f=="string")return this.storageMainService.isUsed(f)}default:throw new Error(`Call not found: ${c}`)}}async withStorageInitialized(S,c){let m;c?m=this.storageMainService.workspaceStorage(c):S?m=this.storageMainService.profileStorage(S):m=this.storageMainService.applicationStorage;try{await m.init()}catch(u){this.logService.error(`StorageIPC#init: Unable to init ${c?"workspace":S?"profile":"application"} storage due to ${u}`)}return m}}e.StorageDatabaseChannel=A}),define(le[42],ue([0,1,48,4,2,18,7,9,36,14,6,5,30,31,41,8,33,25,12]),function(j,e,i,s,y,k,A,R,S,c,m,u,p,v,f,h,E,b,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryUserDataProfilesService=e.UserDataProfilesService=e.IUserDataProfilesService=e.ProfileResourceType=void 0,e.isUserDataProfile=P,e.reviveProfile=r,e.toUserDataProfile=a;var I;(function(n){n.Settings="settings",n.Keybindings="keybindings",n.Snippets="snippets",n.Tasks="tasks",n.Extensions="extensions",n.GlobalState="globalState"})(I||(e.ProfileResourceType=I={}));function P(n){const l=n;return!!(l&&typeof l=="object"&&typeof l.id=="string"&&typeof l.isDefault=="boolean"&&typeof l.name=="string"&&A.URI.isUri(l.location)&&A.URI.isUri(l.globalStorageHome)&&A.URI.isUri(l.settingsResource)&&A.URI.isUri(l.keybindingsResource)&&A.URI.isUri(l.tasksResource)&&A.URI.isUri(l.snippetsHome)&&A.URI.isUri(l.extensionsResource))}e.IUserDataProfilesService=(0,m.createDecorator)("IUserDataProfilesService");function r(n,l){return{id:n.id,isDefault:n.isDefault,name:n.name,shortName:n.shortName,icon:n.icon,location:A.URI.revive(n.location).with({scheme:l}),globalStorageHome:A.URI.revive(n.globalStorageHome).with({scheme:l}),settingsResource:A.URI.revive(n.settingsResource).with({scheme:l}),keybindingsResource:A.URI.revive(n.keybindingsResource).with({scheme:l}),tasksResource:A.URI.revive(n.tasksResource).with({scheme:l}),snippetsHome:A.URI.revive(n.snippetsHome).with({scheme:l}),extensionsResource:A.URI.revive(n.extensionsResource).with({scheme:l}),cacheHome:A.URI.revive(n.cacheHome).with({scheme:l}),useDefaultFlags:n.useDefaultFlags,isTransient:n.isTransient}}function a(n,l,d,D,w,M){return{id:n,name:l,location:d,isDefault:!1,shortName:w?.shortName,icon:w?.icon,globalStorageHome:M&&w?.useDefaultFlags?.globalState?M.globalStorageHome:(0,k.joinPath)(d,"globalStorage"),settingsResource:M&&w?.useDefaultFlags?.settings?M.settingsResource:(0,k.joinPath)(d,"settings.json"),keybindingsResource:M&&w?.useDefaultFlags?.keybindings?M.keybindingsResource:(0,k.joinPath)(d,"keybindings.json"),tasksResource:M&&w?.useDefaultFlags?.tasks?M.tasksResource:(0,k.joinPath)(d,"tasks.json"),snippetsHome:M&&w?.useDefaultFlags?.snippets?M.snippetsHome:(0,k.joinPath)(d,"snippets"),extensionsResource:M&&w?.useDefaultFlags?.extensions?M.extensionsResource:(0,k.joinPath)(d,"extensions.json"),cacheHome:(0,k.joinPath)(D,n),useDefaultFlags:w?.useDefaultFlags,isTransient:w?.transient}}let t=class extends y.Disposable{static{this.PROFILES_KEY="userDataProfiles"}static{this.PROFILE_ASSOCIATIONS_KEY="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.profilesObject.profiles,...this.transientProfilesObject.profiles]}constructor(l,d,D,w){super(),this.environmentService=l,this.fileService=d,this.uriIdentityService=D,this.logService=w,this.enabled=!0,this._onDidChangeProfiles=this._register(new s.Emitter),this.onDidChangeProfiles=this._onDidChangeProfiles.event,this._onWillCreateProfile=this._register(new s.Emitter),this.onWillCreateProfile=this._onWillCreateProfile.event,this._onWillRemoveProfile=this._register(new s.Emitter),this.onWillRemoveProfile=this._onWillRemoveProfile.event,this._onDidResetWorkspaces=this._register(new s.Emitter),this.onDidResetWorkspaces=this._onDidResetWorkspaces.event,this.profileCreationPromises=new Map,this.transientProfilesObject={profiles:[],folders:new v.ResourceMap,workspaces:new v.ResourceMap,emptyWindows:new Map},this.profilesHome=(0,k.joinPath)(this.environmentService.userRoamingDataHome,"profiles"),this.profilesCacheHome=(0,k.joinPath)(this.environmentService.cacheHome,"CachedProfilesData")}init(){this._profilesObject=void 0}setEnablement(l){this.enabled!==l&&(this._profilesObject=void 0,this.enabled=l)}isEnabled(){return this.enabled}get profilesObject(){if(!this._profilesObject){const l=this.createDefaultProfile(),d=[l];if(this.enabled)try{for(const M of this.getStoredProfiles()){if(!M.name||!(0,g.isString)(M.name)||!M.location){this.logService.warn("Skipping the invalid stored profile",M.location||M.name);continue}d.push(a((0,k.basename)(M.location),M.name,M.location,this.profilesCacheHome,{shortName:M.shortName,icon:M.icon,useDefaultFlags:M.useDefaultFlags},l))}}catch(M){this.logService.error(M)}const D=new v.ResourceMap,w=new Map;if(d.length)try{const M=this.getStoredProfileAssociations();if(M.workspaces)for(const[T,C]of Object.entries(M.workspaces)){const L=A.URI.parse(T),_=d.find(V=>V.id===C);_&&D.set(L,_)}if(M.emptyWindows)for(const[T,C]of Object.entries(M.emptyWindows)){const L=d.find(_=>_.id===C);L&&w.set(T,L)}}catch(M){this.logService.error(M)}this._profilesObject={profiles:d,workspaces:D,emptyWindows:w}}return this._profilesObject}createDefaultProfile(){const l=a("__default__profile__",(0,R.localize)(2442,null),this.environmentService.userRoamingDataHome,this.profilesCacheHome);return{...l,extensionsResource:this.getDefaultProfileExtensionsLocation()??l.extensionsResource,isDefault:!0}}async createTransientProfile(l){const d="Temp",D=new RegExp(`${(0,b.escapeRegExpCharacters)(d)}\\s(\\d+)`);let w=0;for(const T of this.profiles){const C=D.exec(T.name),L=C?parseInt(C[1]):0;w=L>w?L:w}const M=`${d} ${w+1}`;return this.createProfile((0,i.hash)((0,E.generateUuid)()).toString(16),M,{transient:!0},l)}async createNamedProfile(l,d,D){return this.createProfile((0,i.hash)((0,E.generateUuid)()).toString(16),l,d,D)}async createProfile(l,d,D,w){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");const M=await this.doCreateProfile(l,d,D);return w&&await this.setProfileForWorkspace(w,M),M}async doCreateProfile(l,d,D){if(!(0,g.isString)(d)||!d)throw new Error("Name of the profile is mandatory and must be of type `string`");let w=this.profileCreationPromises.get(d);return w||(w=(async()=>{try{if(this.profiles.find(L=>L.name===d||L.id===l))throw new Error(`Profile with ${d} name already exists`);const T=a(l,d,(0,k.joinPath)(this.profilesHome,l),this.profilesCacheHome,D,this.defaultProfile);await this.fileService.createFolder(T.location);const C=[];return this._onWillCreateProfile.fire({profile:T,join(L){C.push(L)}}),await h.Promises.settled(C),this.updateProfiles([T],[],[]),T}finally{this.profileCreationPromises.delete(d)}})(),this.profileCreationPromises.set(d,w)),w}async updateProfile(l,d){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");let D=this.profiles.find(w=>w.id===l.id);if(!D)throw new Error(`Profile '${l.name}' does not exist`);return D=a(D.id,d.name??D.name,D.location,this.profilesCacheHome,{shortName:d.shortName??D.shortName,icon:d.icon===null?void 0:d.icon??D.icon,transient:d.transient??D.isTransient,useDefaultFlags:d.useDefaultFlags??D.useDefaultFlags},this.defaultProfile),this.updateProfiles([],[],[D]),D}async removeProfile(l){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");if(l.isDefault)throw new Error("Cannot remove default profile");const d=this.profiles.find(w=>w.id===l.id);if(!d)throw new Error(`Profile '${l.name}' does not exist`);const D=[];this._onWillRemoveProfile.fire({profile:d,join(w){D.push(w)}});try{await Promise.allSettled(D)}catch(w){this.logService.error(w)}for(const w of[...this.profilesObject.emptyWindows.keys()])d.id===this.profilesObject.emptyWindows.get(w)?.id&&this.profilesObject.emptyWindows.delete(w);for(const w of[...this.profilesObject.workspaces.keys()])d.id===this.profilesObject.workspaces.get(w)?.id&&this.profilesObject.workspaces.delete(w);this.updateStoredProfileAssociations(),this.updateProfiles([],[d],[]);try{await this.fileService.del(d.cacheHome,{recursive:!0})}catch(w){(0,c.toFileOperationResult)(w)!==c.FileOperationResult.FILE_NOT_FOUND&&this.logService.error(w)}}async setProfileForWorkspace(l,d){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");const D=this.profiles.find(w=>w.id===d.id);if(!D)throw new Error(`Profile '${d.name}' does not exist`);this.updateWorkspaceAssociation(l,D)}unsetWorkspace(l,d){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");this.updateWorkspaceAssociation(l,void 0,d)}async resetWorkspaces(){this.transientProfilesObject.folders.clear(),this.transientProfilesObject.workspaces.clear(),this.transientProfilesObject.emptyWindows.clear(),this.profilesObject.workspaces.clear(),this.profilesObject.emptyWindows.clear(),this.updateStoredProfileAssociations(),this._onDidResetWorkspaces.fire()}async cleanUp(){if(this.enabled&&await this.fileService.exists(this.profilesHome)){const l=await this.fileService.resolve(this.profilesHome);await Promise.all((l.children||[]).filter(d=>d.isDirectory&&this.profiles.every(D=>!this.uriIdentityService.extUri.isEqual(D.location,d.resource))).map(d=>this.fileService.del(d.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.enabled)return;const l=this.transientProfilesObject.profiles.filter(d=>!this.isProfileAssociatedToWorkspace(d));await Promise.allSettled(l.map(d=>this.removeProfile(d)))}getProfileForWorkspace(l){const d=this.getWorkspace(l),D=A.URI.isUri(d)?this.profilesObject.workspaces.get(d):this.profilesObject.emptyWindows.get(d);return D||((0,p.isSingleFolderWorkspaceIdentifier)(l)?this.transientProfilesObject.folders.get(l.uri):(0,p.isWorkspaceIdentifier)(l)?this.transientProfilesObject.workspaces.get(l.configPath):this.transientProfilesObject.emptyWindows.get(l.id))}getWorkspace(l){return(0,p.isSingleFolderWorkspaceIdentifier)(l)?l.uri:(0,p.isWorkspaceIdentifier)(l)?l.configPath:l.id}isProfileAssociatedToWorkspace(l){return!!([...this.profilesObject.emptyWindows.values()].some(d=>this.uriIdentityService.extUri.isEqual(d.location,l.location))||[...this.profilesObject.workspaces.values()].some(d=>this.uriIdentityService.extUri.isEqual(d.location,l.location))||[...this.transientProfilesObject.emptyWindows.values()].some(d=>this.uriIdentityService.extUri.isEqual(d.location,l.location))||[...this.transientProfilesObject.workspaces.values()].some(d=>this.uriIdentityService.extUri.isEqual(d.location,l.location))||[...this.transientProfilesObject.folders.values()].some(d=>this.uriIdentityService.extUri.isEqual(d.location,l.location)))}updateProfiles(l,d,D){const w=[...this.profiles,...l],M=[],T=this.transientProfilesObject.profiles;this.transientProfilesObject.profiles=[];for(let C of w){if(C.isDefault||d.some(_=>C.id===_.id))continue;C=D.find(_=>C.id===_.id)??C;const L=T.find(_=>C.id===_.id);if(C.isTransient)this.transientProfilesObject.profiles.push(C);else{if(L){for(const[_,V]of this.transientProfilesObject.emptyWindows.entries())if(C.id===V.id){this.updateWorkspaceAssociation({id:_},C);break}for(const[_,V]of this.transientProfilesObject.workspaces.entries())if(C.id===V.id){this.updateWorkspaceAssociation({id:"",configPath:_},C);break}for(const[_,V]of this.transientProfilesObject.folders.entries())if(C.id===V.id){this.updateWorkspaceAssociation({id:"",uri:_},C);break}}M.push({location:C.location,name:C.name,shortName:C.shortName,icon:C.icon,useDefaultFlags:C.useDefaultFlags})}}this.saveStoredProfiles(M),this._profilesObject=void 0,this.triggerProfilesChanges(l,d,D)}triggerProfilesChanges(l,d,D){this._onDidChangeProfiles.fire({added:l,removed:d,updated:D,all:this.profiles})}updateWorkspaceAssociation(l,d,D){if(D=d?.isTransient?!0:D,D)(0,p.isSingleFolderWorkspaceIdentifier)(l)?(this.transientProfilesObject.folders.delete(l.uri),d&&this.transientProfilesObject.folders.set(l.uri,d)):(0,p.isWorkspaceIdentifier)(l)?(this.transientProfilesObject.workspaces.delete(l.configPath),d&&this.transientProfilesObject.workspaces.set(l.configPath,d)):(this.transientProfilesObject.emptyWindows.delete(l.id),d&&this.transientProfilesObject.emptyWindows.set(l.id,d));else{this.updateWorkspaceAssociation(l,void 0,!0);const w=this.getWorkspace(l);A.URI.isUri(w)?(this.profilesObject.workspaces.delete(w),d&&this.profilesObject.workspaces.set(w,d)):(this.profilesObject.emptyWindows.delete(w),d&&this.profilesObject.emptyWindows.set(w,d)),this.updateStoredProfileAssociations()}}updateStoredProfileAssociations(){const l={};for(const[D,w]of this.profilesObject.workspaces.entries())l[D.toString()]=w.id;const d={};for(const[D,w]of this.profilesObject.emptyWindows.entries())d[D.toString()]=w.id;this.saveStoredProfileAssociations({workspaces:l,emptyWindows:d}),this._profilesObject=void 0}migrateStoredProfileAssociations(l){const d={},D=this.createDefaultProfile();if(l.workspaces)for(const[M,T]of Object.entries(l.workspaces)){const C=A.URI.parse(T);d[M]=this.uriIdentityService.extUri.isEqual(C,D.location)?D.id:this.uriIdentityService.extUri.basename(C)}const w={};if(l.emptyWindows)for(const[M,T]of Object.entries(l.emptyWindows)){const C=A.URI.parse(T);w[M]=this.uriIdentityService.extUri.isEqual(C,D.location)?D.id:this.uriIdentityService.extUri.basename(C)}return{workspaces:d,emptyWindows:w}}getStoredProfiles(){return[]}saveStoredProfiles(l){throw new Error("not implemented")}getStoredProfileAssociations(){return{}}saveStoredProfileAssociations(l){throw new Error("not implemented")}getDefaultProfileExtensionsLocation(){}};e.UserDataProfilesService=t,e.UserDataProfilesService=t=Pe([re(0,S.IEnvironmentService),re(1,c.IFileService),re(2,f.IUriIdentityService),re(3,u.ILogService)],t);class o extends t{constructor(){super(...arguments),this.storedProfiles=[],this.storedProfileAssociations={}}getStoredProfiles(){return this.storedProfiles}saveStoredProfiles(l){this.storedProfiles=l}getStoredProfileAssociations(){return this.storedProfileAssociations}saveStoredProfileAssociations(l){this.storedProfileAssociations=l}}e.InMemoryUserDataProfilesService=o}),define(le[88],ue([0,1,8,17,2,4,31,7,129,132,14,6,5,42,41,12,15,24]),function(j,e,i,s,y,k,A,R,S,c,m,u,p,v,f,h,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsProfileScannerService=e.IExtensionsProfileScannerService=e.ExtensionsProfileScanningError=e.ExtensionsProfileScanningErrorCode=void 0;var g;(function(t){t.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",t.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(g||(e.ExtensionsProfileScanningErrorCode=g={}));class I extends Error{constructor(o,n){super(o),this.code=n}}e.ExtensionsProfileScanningError=I,e.IExtensionsProfileScannerService=(0,u.createDecorator)("IExtensionsProfileScannerService");let P=class extends y.Disposable{constructor(o,n,l,d,D,w){super(),this.extensionsLocation=o,this.fileService=n,this.userDataProfilesService=l,this.uriIdentityService=d,this.telemetryService=D,this.logService=w,this._onAddExtensions=this._register(new k.Emitter),this.onAddExtensions=this._onAddExtensions.event,this._onDidAddExtensions=this._register(new k.Emitter),this.onDidAddExtensions=this._onDidAddExtensions.event,this._onRemoveExtensions=this._register(new k.Emitter),this.onRemoveExtensions=this._onRemoveExtensions.event,this._onDidRemoveExtensions=this._register(new k.Emitter),this.onDidRemoveExtensions=this._onDidRemoveExtensions.event,this.resourcesAccessQueueMap=new A.ResourceMap}scanProfileExtensions(o,n){return this.withProfileExtensions(o,void 0,n)}async addExtensionsToProfile(o,n,l){const d=[],D=[];try{return await this.withProfileExtensions(n,w=>{const M=[];if(l)M.push(...w);else for(const T of w)o.some(([C])=>(0,c.areSameExtensions)(C.identifier,T.identifier)&&C.manifest.version!==T.version)?d.push(T):M.push(T);for(const[T,C]of o){const L=M.findIndex(V=>(0,c.areSameExtensions)(V.identifier,T.identifier)&&V.version===T.manifest.version),_={identifier:T.identifier,version:T.manifest.version,location:T.location,metadata:C};L===-1?(D.push(_),M.push(_)):M.splice(L,1,_)}return D.length&&this._onAddExtensions.fire({extensions:D,profileLocation:n}),d.length&&this._onRemoveExtensions.fire({extensions:d,profileLocation:n}),M}),D.length&&this._onDidAddExtensions.fire({extensions:D,profileLocation:n}),d.length&&this._onDidRemoveExtensions.fire({extensions:d,profileLocation:n}),D}catch(w){throw D.length&&this._onDidAddExtensions.fire({extensions:D,error:w,profileLocation:n}),d.length&&this._onDidRemoveExtensions.fire({extensions:d,error:w,profileLocation:n}),w}}async updateMetadata(o,n){const l=[];return await this.withProfileExtensions(n,d=>{const D=[];for(const w of d){const M=o.find(([T])=>(0,c.areSameExtensions)(T.identifier,w.identifier)&&T.manifest.version===w.version);M&&(w.metadata={...w.metadata,...M[1]},l.push(w)),D.push(w)}return D}),l}async removeExtensionFromProfile(o,n){const l=[];try{await this.withProfileExtensions(n,d=>{const D=[];for(const w of d)(0,c.areSameExtensions)(w.identifier,o.identifier)?l.push(w):D.push(w);return l.length&&this._onRemoveExtensions.fire({extensions:l,profileLocation:n}),D}),l.length&&this._onDidRemoveExtensions.fire({extensions:l,profileLocation:n})}catch(d){throw l.length&&this._onDidRemoveExtensions.fire({extensions:l,error:d,profileLocation:n}),d}}async withProfileExtensions(o,n,l){return this.getResourceAccessQueue(o).queue(async()=>{let d=[],D;try{const w=await this.fileService.readFile(o);D=JSON.parse(w.value.toString().trim()||"[]")}catch(w){if((0,m.toFileOperationResult)(w)!==m.FileOperationResult.FILE_NOT_FOUND)throw w;if(this.uriIdentityService.extUri.isEqual(o,this.userDataProfilesService.defaultProfile.extensionsResource)&&(D=await this.migrateFromOldDefaultProfileExtensionsLocation()),!D&&l?.bailOutWhenFileNotFound)throw new I((0,E.getErrorMessage)(w),g.ERROR_PROFILE_NOT_FOUND)}if(D){Array.isArray(D)||this.reportAndThrowInvalidConentError(o);let w=!1;for(const M of D){r(M)||this.reportAndThrowInvalidConentError(o);let T;if((0,h.isString)(M.relativeLocation)&&M.relativeLocation)T=this.resolveExtensionLocation(M.relativeLocation);else if((0,h.isString)(M.location)){this.logService.warn(`Extensions profile: Ignoring extension with invalid location: ${M.location}`);continue}else{T=R.URI.revive(M.location);const C=this.toRelativePath(T);C&&(w=!0,M.relativeLocation=C)}(0,h.isUndefined)(M.metadata?.hasPreReleaseVersion)&&M.metadata?.preRelease&&(w=!0,M.metadata.hasPreReleaseVersion=!0),d.push({identifier:M.identifier,location:T,version:M.version,metadata:M.metadata})}w&&await this.fileService.writeFile(o,s.VSBuffer.fromString(JSON.stringify(D)))}if(n){d=n(d);const w=d.map(M=>({identifier:M.identifier,version:M.version,location:M.location.toJSON(),relativeLocation:this.toRelativePath(M.location),metadata:M.metadata}));await this.fileService.writeFile(o,s.VSBuffer.fromString(JSON.stringify(w)))}return d})}reportAndThrowInvalidConentError(o){const n=new I(`Invalid extensions content in ${o.toString()}`,g.ERROR_INVALID_CONTENT);throw this.telemetryService.publicLogError2("extensionsProfileScanningError",{code:n.code}),n}toRelativePath(o){return this.uriIdentityService.extUri.isEqual(this.uriIdentityService.extUri.dirname(o),this.extensionsLocation)?this.uriIdentityService.extUri.basename(o):void 0}resolveExtensionLocation(o){return this.uriIdentityService.extUri.joinPath(this.extensionsLocation,o)}async migrateFromOldDefaultProfileExtensionsLocation(){return this._migrationPromise||(this._migrationPromise=(async()=>{const o=this.uriIdentityService.extUri.joinPath(this.userDataProfilesService.defaultProfile.location,"extensions.json"),n=this.uriIdentityService.extUri.joinPath(this.extensionsLocation,".init-default-profile-extensions");let l;try{l=(await this.fileService.readFile(o)).value.toString()}catch(D){if((0,m.toFileOperationResult)(D)===m.FileOperationResult.FILE_NOT_FOUND)return;throw D}this.logService.info("Migrating extensions from old default profile location",o.toString());let d;try{const D=JSON.parse(l);Array.isArray(D)&&D.every(w=>r(w))?d=D:this.logService.warn("Skipping migrating from old default profile locaiton: Found invalid data",D)}catch(D){this.logService.error(D)}if(d)try{await this.fileService.createFile(this.userDataProfilesService.defaultProfile.extensionsResource,s.VSBuffer.fromString(JSON.stringify(d)),{overwrite:!1}),this.logService.info("Migrated extensions from old default profile location to new location",o.toString(),this.userDataProfilesService.defaultProfile.extensionsResource.toString())}catch(D){if((0,m.toFileOperationResult)(D)===m.FileOperationResult.FILE_MODIFIED_SINCE)this.logService.info("Migration from old default profile location to new location is done by another window",o.toString(),this.userDataProfilesService.defaultProfile.extensionsResource.toString());else throw D}try{await this.fileService.del(o)}catch(D){(0,m.toFileOperationResult)(D)!==m.FileOperationResult.FILE_NOT_FOUND&&this.logService.error(D)}try{await this.fileService.del(n)}catch(D){(0,m.toFileOperationResult)(D)!==m.FileOperationResult.FILE_NOT_FOUND&&this.logService.error(D)}return d})()),this._migrationPromise}getResourceAccessQueue(o){let n=this.resourcesAccessQueueMap.get(o);return n||(n=new i.Queue,this.resourcesAccessQueueMap.set(o,n)),n}};e.AbstractExtensionsProfileScannerService=P,e.AbstractExtensionsProfileScannerService=P=Pe([re(1,m.IFileService),re(2,v.IUserDataProfilesService),re(3,f.IUriIdentityService),re(4,b.ITelemetryService),re(5,p.ILogService)],P);function r(t){return(0,h.isObject)(t)&&(0,S.isIExtensionIdentifier)(t.identifier)&&(a(t.location)||(0,h.isString)(t.location)&&t.location)&&((0,h.isUndefined)(t.relativeLocation)||(0,h.isString)(t.relativeLocation))&&t.version&&(0,h.isString)(t.version)}function a(t){return t?(0,h.isString)(t.path)&&(0,h.isString)(t.scheme):!1}});var je=this&&this.__importDefault||function(j){return j&&j.__esModule?j:{default:j}};define(le[136],ue([0,1,21,8,37,17,15,43,158,2,11,10,3,18,214,81,12,7,9,36,132,87,213,14,6,5,28,4,83,88,42,41,175]),function(j,e,i,s,y,k,A,R,S,c,m,u,p,v,f,h,E,b,g,I,P,r,a,t,o,n,l,d,D,w,M,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtensionsScannerService=e.ExtensionScannerInput=e.AbstractExtensionsScannerService=e.IExtensionsScannerService=e.Translations=void 0,e.toExtensionDescription=fe,y=Re(y),u=Re(u),p=Re(p),f=Re(f),h=je(h);var L;(function(ee){function U(K,N){if(K===N)return!0;const x=Object.keys(K),W=new Set;for(const q of Object.keys(N))W.add(q);if(x.length!==W.size)return!1;for(const q of x){if(K[q]!==N[q])return!1;W.delete(q)}return W.size===0}ee.equals=U})(L||(e.Translations=L={})),e.IExtensionsScannerService=(0,o.createDecorator)("IExtensionsScannerService");let _=class extends c.Disposable{constructor(U,K,N,x,W,q,ie,H,ce,oe,te,O){super(),this.systemExtensionsLocation=U,this.userExtensionsLocation=K,this.extensionsControlLocation=N,this.currentProfile=x,this.userDataProfilesService=W,this.extensionsProfileScannerService=q,this.fileService=ie,this.logService=H,this.environmentService=ce,this.productService=oe,this.uriIdentityService=te,this.instantiationService=O,this._onDidChangeCache=this._register(new d.Emitter),this.onDidChangeCache=this._onDidChangeCache.event,this.obsoleteFile=(0,v.joinPath)(this.userExtensionsLocation,".obsolete"),this.systemExtensionsCachedScanner=this._register(this.instantiationService.createInstance(Q,this.currentProfile,this.obsoleteFile)),this.userExtensionsCachedScanner=this._register(this.instantiationService.createInstance(Q,this.currentProfile,this.obsoleteFile)),this.extensionsScanner=this._register(this.instantiationService.createInstance(z,this.obsoleteFile)),this.initializeDefaultProfileExtensionsPromise=void 0,this._register(this.systemExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(r.ExtensionType.System))),this._register(this.userExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(r.ExtensionType.User)))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,P.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async scanAllExtensions(U,K,N){const[x,W]=await Promise.all([this.scanSystemExtensions(U),this.scanUserExtensions(K)]),q=N?await this.scanExtensionsUnderDevelopment(U,[...x,...W]):[];return this.dedupExtensions(x,W,q,await this.getTargetPlatform(),!0)}async scanSystemExtensions(U){const K=[];K.push(this.scanDefaultSystemExtensions(!!U.useCache,U.language)),K.push(this.scanDevSystemExtensions(U.language,!!U.checkControlFile));const[N,x]=await Promise.all(K);return this.applyScanOptions([...N,...x],r.ExtensionType.System,U,!1)}async scanUserExtensions(U){const K=U.profileLocation??this.userExtensionsLocation;this.logService.trace("Started scanning user extensions",K);const N=this.uriIdentityService.extUri.isEqual(U.profileLocation,this.userDataProfilesService.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,x=await this.createExtensionScannerInput(K,!!U.profileLocation,r.ExtensionType.User,!U.includeUninstalled,U.language,!0,N,U.productVersion??this.getProductVersion()),W=U.useCache&&!x.devMode&&x.excludeObsolete?this.userExtensionsCachedScanner:this.extensionsScanner;let q;try{q=await W.scanExtensions(x)}catch(ie){if(ie instanceof w.ExtensionsProfileScanningError&&ie.code===w.ExtensionsProfileScanningErrorCode.ERROR_PROFILE_NOT_FOUND)await this.doInitializeDefaultProfileExtensions(),q=await W.scanExtensions(x);else throw ie}return q=await this.applyScanOptions(q,r.ExtensionType.User,U,!0),this.logService.trace("Scanned user extensions:",q.length),q}async scanExtensionsUnderDevelopment(U,K){if(this.environmentService.isExtensionDevelopment&&this.environmentService.extensionDevelopmentLocationURI){const N=(await Promise.all(this.environmentService.extensionDevelopmentLocationURI.filter(x=>x.scheme===m.Schemas.file).map(async x=>{const W=await this.createExtensionScannerInput(x,!1,r.ExtensionType.User,!0,U.language,!1,void 0,U.productVersion??this.getProductVersion());return(await this.extensionsScanner.scanOneOrMultipleExtensions(W)).map(ie=>(ie.type=K.find(H=>(0,P.areSameExtensions)(H.identifier,ie.identifier))?.type??ie.type,this.extensionsScanner.validate(ie,W)))}))).flat();return this.applyScanOptions(N,"development",U,!0)}return[]}async scanExistingExtension(U,K,N){const x=await this.createExtensionScannerInput(U,!1,K,!0,N.language,!0,void 0,N.productVersion??this.getProductVersion()),W=await this.extensionsScanner.scanExtension(x);return!W||!N.includeInvalid&&!W.isValid?null:W}async scanOneOrMultipleExtensions(U,K,N){const x=await this.createExtensionScannerInput(U,!1,K,!0,N.language,!0,void 0,N.productVersion??this.getProductVersion()),W=await this.extensionsScanner.scanOneOrMultipleExtensions(x);return this.applyScanOptions(W,K,N,!0)}async scanMultipleExtensions(U,K,N){const x=[];return await Promise.all(U.map(async W=>{const q=await this.scanOneOrMultipleExtensions(W,K,N);x.push(...q)})),this.applyScanOptions(x,K,N,!0)}async scanMetadata(U){const K=(0,v.joinPath)(U,"package.json"),N=(await this.fileService.readFile(K)).value.toString();return JSON.parse(N).__metadata}async updateMetadata(U,K){const N=(0,v.joinPath)(U,"package.json"),x=(await this.fileService.readFile(N)).value.toString(),W=JSON.parse(x);K.isMachineScoped===!1&&delete K.isMachineScoped,K.isBuiltin===!1&&delete K.isBuiltin,W.__metadata={...W.__metadata,...K},await this.fileService.writeFile((0,v.joinPath)(U,"package.json"),k.VSBuffer.fromString(JSON.stringify(W,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.extensionsProfileScannerService.scanProfileExtensions(this.userDataProfilesService.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(U){if(U instanceof w.ExtensionsProfileScanningError&&U.code===w.ExtensionsProfileScanningErrorCode.ERROR_PROFILE_NOT_FOUND)await this.doInitializeDefaultProfileExtensions();else throw U}}async doInitializeDefaultProfileExtensions(){return this.initializeDefaultProfileExtensionsPromise||(this.initializeDefaultProfileExtensionsPromise=(async()=>{try{this.logService.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const U=await this.scanUserExtensions({includeInvalid:!0});if(U.length)await this.extensionsProfileScannerService.addExtensionsToProfile(U.map(K=>[K,K.metadata]),this.userDataProfilesService.defaultProfile.extensionsResource);else try{await this.fileService.createFile(this.userDataProfilesService.defaultProfile.extensionsResource,k.VSBuffer.fromString(JSON.stringify([])))}catch(K){(0,t.toFileOperationResult)(K)!==t.FileOperationResult.FILE_NOT_FOUND&&this.logService.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,A.getErrorMessage)(K))}this.logService.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(U){this.logService.error(U)}finally{this.initializeDefaultProfileExtensionsPromise=void 0}})()),this.initializeDefaultProfileExtensionsPromise}async applyScanOptions(U,K,N,x){return N.includeAllVersions||(U=this.dedupExtensions(K===r.ExtensionType.System?U:void 0,K===r.ExtensionType.User?U:void 0,K==="development"?U:void 0,await this.getTargetPlatform(),x)),N.includeInvalid||(U=U.filter(W=>W.isValid)),U.sort((W,q)=>{const ie=u.basename(W.location.fsPath),H=u.basename(q.location.fsPath);return ie<H?-1:ie>H?1:0})}dedupExtensions(U,K,N,x,W){const q=(H,ce,oe)=>{if(H.isValid&&!ce.isValid)return!1;if(H.isValid===ce.isValid){if(W&&f.gt(H.manifest.version,ce.manifest.version))return this.logService.debug(`Skipping extension ${ce.location.path} with lower version ${ce.manifest.version} in favour of ${H.location.path} with version ${H.manifest.version}`),!1;if(f.eq(H.manifest.version,ce.manifest.version)){if(H.type===r.ExtensionType.System)return this.logService.debug(`Skipping extension ${ce.location.path} in favour of system extension ${H.location.path} with same version`),!1;if(H.targetPlatform===x)return this.logService.debug(`Skipping extension ${ce.location.path} from different target platform ${ce.targetPlatform}`),!1}}return oe?this.logService.warn(`Overwriting user extension ${H.location.path} with ${ce.location.path}.`):this.logService.debug(`Overwriting user extension ${H.location.path} with ${ce.location.path}.`),!0},ie=new r.ExtensionIdentifierMap;return U?.forEach(H=>{const ce=ie.get(H.identifier.id);(!ce||q(ce,H,!1))&&ie.set(H.identifier.id,H)}),K?.forEach(H=>{const ce=ie.get(H.identifier.id);if(!ce&&U&&H.type===r.ExtensionType.System){this.logService.debug(`Skipping obsolete system extension ${H.location.path}.`);return}(!ce||q(ce,H,!1))&&ie.set(H.identifier.id,H)}),N?.forEach(H=>{const ce=ie.get(H.identifier.id);(!ce||q(ce,H,!0))&&ie.set(H.identifier.id,H),ie.set(H.identifier.id,H)}),[...ie.values()]}async scanDefaultSystemExtensions(U,K){this.logService.trace("Started scanning system extensions");const N=await this.createExtensionScannerInput(this.systemExtensionsLocation,!1,r.ExtensionType.System,!0,K,!0,void 0,this.getProductVersion()),W=await(U&&!N.devMode?this.systemExtensionsCachedScanner:this.extensionsScanner).scanExtensions(N);return this.logService.trace("Scanned system extensions:",W.length),W}async scanDevSystemExtensions(U,K){const N=this.environmentService.isBuilt?[]:this.productService.builtInExtensions;if(!N?.length)return[];this.logService.trace("Started scanning dev system extensions");const x=K?await this.getBuiltInExtensionControl():{},W=[],q=b.URI.file(u.normalize(u.join(m.FileAccess.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const H of N){const ce=x[H.name]||"marketplace";switch(ce){case"disabled":break;case"marketplace":W.push((0,v.joinPath)(q,H.name));break;default:W.push(b.URI.file(ce));break}}const ie=await Promise.all(W.map(async H=>this.extensionsScanner.scanExtension(await this.createExtensionScannerInput(H,!1,r.ExtensionType.System,!0,U,!0,void 0,this.getProductVersion()))));return this.logService.trace("Scanned dev system extensions:",ie.length),(0,i.coalesce)(ie)}async getBuiltInExtensionControl(){try{const U=await this.fileService.readFile(this.extensionsControlLocation);return JSON.parse(U.value.toString())}catch{return{}}}async createExtensionScannerInput(U,K,N,x,W,q,ie,H){const ce=await this.getTranslations(W??p.language),oe=await this.getMtime(U),te=K&&!this.uriIdentityService.extUri.isEqual(U,this.userDataProfilesService.defaultProfile.extensionsResource)?this.userDataProfilesService.defaultProfile.extensionsResource:void 0,O=te?await this.getMtime(te):void 0;return new V(U,oe,te,O,K,ie,N,x,q,H.version,H.date,this.productService.commit,!this.environmentService.isBuilt,W,ce)}async getMtime(U){try{const K=await this.fileService.stat(U);if(typeof K.mtime=="number")return K.mtime}catch{}}getProductVersion(){return{version:this.productService.version,date:this.productService.date}}};e.AbstractExtensionsScannerService=_,e.AbstractExtensionsScannerService=_=Pe([re(4,M.IUserDataProfilesService),re(5,w.IExtensionsProfileScannerService),re(6,t.IFileService),re(7,n.ILogService),re(8,I.IEnvironmentService),re(9,l.IProductService),re(10,T.IUriIdentityService),re(11,o.IInstantiationService)],_);class V{constructor(U,K,N,x,W,q,ie,H,ce,oe,te,O,X,B,F){this.location=U,this.mtime=K,this.applicationExtensionslocation=N,this.applicationExtensionslocationMtime=x,this.profile=W,this.profileScanOptions=q,this.type=ie,this.excludeObsolete=H,this.validate=ce,this.productVersion=oe,this.productDate=te,this.productCommit=O,this.devMode=X,this.language=B,this.translations=F}static createNlsConfiguration(U){return{language:U.language,pseudo:U.language==="pseudo",devMode:U.devMode,translations:U.translations}}static equals(U,K){return(0,v.isEqual)(U.location,K.location)&&U.mtime===K.mtime&&(0,v.isEqual)(U.applicationExtensionslocation,K.applicationExtensionslocation)&&U.applicationExtensionslocationMtime===K.applicationExtensionslocationMtime&&U.profile===K.profile&&y.equals(U.profileScanOptions,K.profileScanOptions)&&U.type===K.type&&U.excludeObsolete===K.excludeObsolete&&U.validate===K.validate&&U.productVersion===K.productVersion&&U.productDate===K.productDate&&U.productCommit===K.productCommit&&U.devMode===K.devMode&&U.language===K.language&&L.equals(U.translations,K.translations)}}e.ExtensionScannerInput=V;let z=class extends c.Disposable{constructor(U,K,N,x,W,q,ie){super(),this.obsoleteFile=U,this.extensionsProfileScannerService=K,this.uriIdentityService=N,this.fileService=x,this.environmentService=q,this.logService=ie,this.extensionsEnabledWithApiProposalVersion=W.extensionsEnabledWithApiProposalVersion?.map(H=>H.toLowerCase())??[]}async scanExtensions(U){const K=U.profile?await this.scanExtensionsFromProfile(U):await this.scanExtensionsFromLocation(U);let N={};if(U.excludeObsolete&&U.type===r.ExtensionType.User)try{const x=(await this.fileService.readFile(this.obsoleteFile)).value.toString();N=JSON.parse(x)}catch{}return(0,E.isEmptyObject)(N)?K:K.filter(x=>!N[P.ExtensionKey.create(x).toString()])}async scanExtensionsFromLocation(U){const K=await this.fileService.resolve(U.location);if(!K.children?.length)return[];const N=await Promise.all(K.children.map(async x=>{if(!x.isDirectory||U.type===r.ExtensionType.User&&(0,v.basename)(x.resource).indexOf(".")===0)return null;const W=new V(x.resource,U.mtime,U.applicationExtensionslocation,U.applicationExtensionslocationMtime,U.profile,U.profileScanOptions,U.type,U.excludeObsolete,U.validate,U.productVersion,U.productDate,U.productCommit,U.devMode,U.language,U.translations);return this.scanExtension(W)}));return(0,i.coalesce)(N).sort((x,W)=>x.location.path<W.location.path?-1:1)}async scanExtensionsFromProfile(U){let K=await this.scanExtensionsFromProfileResource(U.location,()=>!0,U);if(U.applicationExtensionslocation&&!this.uriIdentityService.extUri.isEqual(U.location,U.applicationExtensionslocation)){K=K.filter(x=>!x.metadata?.isApplicationScoped);const N=await this.scanExtensionsFromProfileResource(U.applicationExtensionslocation,x=>!!x.metadata?.isBuiltin||!!x.metadata?.isApplicationScoped,U);K.push(...N)}return K}async scanExtensionsFromProfileResource(U,K,N){const x=await this.extensionsProfileScannerService.scanProfileExtensions(U,N.profileScanOptions);if(!x.length)return[];const W=await Promise.all(x.map(async q=>{if(K(q)){const ie=new V(q.location,N.mtime,N.applicationExtensionslocation,N.applicationExtensionslocationMtime,N.profile,N.profileScanOptions,N.type,N.excludeObsolete,N.validate,N.productVersion,N.productDate,N.productCommit,N.devMode,N.language,N.translations);return this.scanExtension(ie,q.metadata)}return null}));return(0,i.coalesce)(W)}async scanOneOrMultipleExtensions(U){try{if(await this.fileService.exists((0,v.joinPath)(U.location,"package.json"))){const K=await this.scanExtension(U);return K?[K]:[]}else return await this.scanExtensions(U)}catch(K){return this.logService.error(`Error scanning extensions at ${U.location.path}:`,(0,A.getErrorMessage)(K)),[]}}async scanExtension(U,K){try{let N=await this.scanExtensionManifest(U.location);if(N){N.publisher||(N.publisher=r.UNDEFINED_PUBLISHER),K=K??N.__metadata,delete N.__metadata;const x=(0,P.getGalleryExtensionId)(N.publisher,N.name),W=K?.id?{id:x,uuid:K.id}:{id:x},q=K?.isSystem?r.ExtensionType.System:U.type,ie=q===r.ExtensionType.System||!!K?.isBuiltin;N=await this.translateManifest(U.location,N,V.createNlsConfiguration(U));let H={type:q,identifier:W,manifest:N,location:U.location,isBuiltin:ie,targetPlatform:K?.targetPlatform??r.TargetPlatform.UNDEFINED,publisherDisplayName:K?.publisherDisplayName,metadata:K,isValid:!0,validations:[]};return U.validate&&(H=this.validate(H,U)),N.enabledApiProposals&&(!this.environmentService.isBuilt||this.extensionsEnabledWithApiProposalVersion.includes(x.toLowerCase()))&&(N.originalEnabledApiProposals=N.enabledApiProposals,N.enabledApiProposals=(0,r.parseEnabledApiProposalNames)([...N.enabledApiProposals])),H}}catch(N){U.type!==r.ExtensionType.System&&this.logService.error(N)}return null}validate(U,K){let N=!0;const x=this.environmentService.isBuilt&&this.extensionsEnabledWithApiProposalVersion.includes(U.identifier.id.toLowerCase()),W=(0,a.validateExtensionManifest)(K.productVersion,K.productDate,K.location,U.manifest,U.isBuiltin,x);for(const[q,ie]of W)q===h.default.Error&&(N=!1,this.logService.error(this.formatMessage(K.location,ie)));return U.isValid=N,U.validations=W,U}async scanExtensionManifest(U){const K=(0,v.joinPath)(U,"package.json");let N;try{N=(await this.fileService.readFile(K)).value.toString()}catch(W){return(0,t.toFileOperationResult)(W)!==t.FileOperationResult.FILE_NOT_FOUND&&this.logService.error(this.formatMessage(U,(0,g.localize)(1815,null,K.path,W.message))),null}let x;try{x=JSON.parse(N)}catch{const q=[];(0,R.parse)(N,q);for(const ie of q)this.logService.error(this.formatMessage(U,(0,g.localize)(1816,null,K.path,ie.offset,ie.length,(0,S.getParseErrorMessage)(ie.error))));return null}return(0,R.getNodeType)(x)!=="object"?(this.logService.error(this.formatMessage(U,(0,g.localize)(1817,null,K.path))),null):x}async translateManifest(U,K,N){const x=await this.getLocalizedMessages(U,K,N);if(x)try{const W=[],q=await this.resolveOriginalMessageBundle(x.default,W);if(W.length>0)return W.forEach(H=>{this.logService.error(this.formatMessage(U,(0,g.localize)(1818,null,x.default?.path,(0,S.getParseErrorMessage)(H.error))))}),K;if((0,R.getNodeType)(x)!=="object")return this.logService.error(this.formatMessage(U,(0,g.localize)(1819,null,x.default?.path))),K;const ie=x.values||Object.create(null);return(0,C.localizeManifest)(this.logService,K,ie,q)}catch{}return K}async getLocalizedMessages(U,K,N){const x=(0,v.joinPath)(U,"package.nls.json"),W=(ce,oe)=>{oe.forEach(te=>{this.logService.error(this.formatMessage(U,(0,g.localize)(1820,null,ce?.path,(0,S.getParseErrorMessage)(te.error))))})},q=ce=>{this.logService.error(this.formatMessage(U,(0,g.localize)(1821,null,ce?.path)))},ie=`${K.publisher}.${K.name}`,H=N.translations[ie];if(H)try{const ce=b.URI.file(H),oe=(await this.fileService.readFile(ce)).value.toString(),te=[],O=(0,R.parse)(oe,te);return te.length>0?(W(ce,te),{values:void 0,default:x}):(0,R.getNodeType)(O)!=="object"?(q(ce),{values:void 0,default:x}):{values:O.contents?O.contents.package:void 0,default:x}}catch{return{values:void 0,default:x}}else{if(!await this.fileService.exists(x))return;let oe;try{oe=await this.findMessageBundles(U,N)}catch{return}if(!oe.localized)return{values:void 0,default:oe.original};try{const te=(await this.fileService.readFile(oe.localized)).value.toString(),O=[],X=(0,R.parse)(te,O);return O.length>0?(W(oe.localized,O),{values:void 0,default:oe.original}):(0,R.getNodeType)(X)!=="object"?(q(oe.localized),{values:void 0,default:oe.original}):{values:X,default:oe.original}}catch{return{values:void 0,default:oe.original}}}}async resolveOriginalMessageBundle(U,K){if(U)try{const N=(await this.fileService.readFile(U)).value.toString();return(0,R.parse)(N,K)}catch{}}findMessageBundles(U,K){return new Promise((N,x)=>{const W=q=>{const ie=(0,v.joinPath)(U,`package.nls.${q}.json`);this.fileService.exists(ie).then(H=>{H&&N({localized:ie,original:(0,v.joinPath)(U,"package.nls.json")});const ce=q.lastIndexOf("-");ce===-1?N({localized:(0,v.joinPath)(U,"package.nls.json"),original:null}):(q=q.substring(0,ce),W(q))})};if(K.devMode||K.pseudo||!K.language)return N({localized:(0,v.joinPath)(U,"package.nls.json"),original:null});W(K.language)})}formatMessage(U,K){return`[${U.path}]: ${K}`}};z=Pe([re(1,w.IExtensionsProfileScannerService),re(2,T.IUriIdentityService),re(3,t.IFileService),re(4,l.IProductService),re(5,I.IEnvironmentService),re(6,n.ILogService)],z);let Q=class extends z{constructor(U,K,N,x,W,q,ie,H,ce){super(K,x,W,q,ie,H,ce),this.currentProfile=U,this.userDataProfilesService=N,this.cacheValidatorThrottler=this._register(new s.ThrottledDelayer(3e3)),this._onDidChangeCache=this._register(new d.Emitter),this.onDidChangeCache=this._onDidChangeCache.event}async scanExtensions(U){const K=this.getCacheFile(U),N=await this.readExtensionCache(K);if(this.input=U,N&&N.input&&V.equals(N.input,this.input))return this.logService.debug("Using cached extensions scan result",U.type===r.ExtensionType.System?"system":"user",U.location.toString()),this.cacheValidatorThrottler.trigger(()=>this.validateCache()),N.result.map(W=>(W.location=b.URI.revive(W.location),W));const x=await super.scanExtensions(U);return await this.writeExtensionCache(K,{input:U,result:x}),x}async readExtensionCache(U){try{const K=await this.fileService.readFile(U),N=JSON.parse(K.value.toString());return{result:N.result,input:(0,D.revive)(N.input)}}catch(K){this.logService.debug("Error while reading the extension cache file:",U.path,(0,A.getErrorMessage)(K))}return null}async writeExtensionCache(U,K){try{await this.fileService.writeFile(U,k.VSBuffer.fromString(JSON.stringify(K)))}catch(N){this.logService.debug("Error while writing the extension cache file:",U.path,(0,A.getErrorMessage)(N))}}async validateCache(){if(!this.input)return;const U=this.getCacheFile(this.input),K=await this.readExtensionCache(U);if(!K)return;const N=K.result,x=JSON.parse(JSON.stringify(await super.scanExtensions(this.input)));if(!y.equals(x,N))try{this.logService.info("Invalidating Cache",N,x),await this.fileService.del(U),this._onDidChangeCache.fire()}catch(W){this.logService.error(W)}}getCacheFile(U){const K=this.getProfile(U);return this.uriIdentityService.extUri.joinPath(K.cacheHome,U.type===r.ExtensionType.System?r.BUILTIN_MANIFEST_CACHE_FILE:r.USER_MANIFEST_CACHE_FILE)}getProfile(U){return U.type===r.ExtensionType.System?this.userDataProfilesService.defaultProfile:U.profile?this.uriIdentityService.extUri.isEqual(U.location,this.currentProfile.extensionsResource)?this.currentProfile:this.userDataProfilesService.profiles.find(K=>this.uriIdentityService.extUri.isEqual(U.location,K.extensionsResource))??this.currentProfile:this.userDataProfilesService.defaultProfile}};Q=Pe([re(2,M.IUserDataProfilesService),re(3,w.IExtensionsProfileScannerService),re(4,T.IUriIdentityService),re(5,t.IFileService),re(6,l.IProductService),re(7,I.IEnvironmentService),re(8,n.ILogService)],Q);function fe(ee,U){const K=(0,P.getExtensionId)(ee.manifest.publisher,ee.manifest.name);return{id:K,identifier:new r.ExtensionIdentifier(K),isBuiltin:ee.type===r.ExtensionType.System,isUserBuiltin:ee.type===r.ExtensionType.User&&ee.isBuiltin,isUnderDevelopment:U,extensionLocation:ee.location,uuid:ee.identifier.uuid,targetPlatform:ee.targetPlatform,publisherDisplayName:ee.publisherDisplayName,...ee.manifest}}class se extends _{constructor(U,K,N,x,W,q,ie,H,ce,oe,te,O){super(U,K,(0,v.joinPath)(N,".vscode-oss-dev","extensions","control.json"),x,W,q,ie,H,ce,oe,te,O),this.translationsPromise=(async()=>{if(p.translationsConfigFile)try{const X=await this.fileService.readFile(b.URI.file(p.translationsConfigFile));return JSON.parse(X.value.toString())}catch{}return Object.create(null)})()}getTranslations(U){return this.translationsPromise}}e.NativeExtensionsScannerService=se}),define(le[248],ue([0,1,5,42,41,24,88,14,36,7]),function(j,e,i,s,y,k,A,R,S,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsProfileScannerService=void 0;let m=class extends A.AbstractExtensionsProfileScannerService{constructor(p,v,f,h,E,b){super(c.URI.file(p.extensionsPath),v,f,h,E,b)}};e.ExtensionsProfileScannerService=m,e.ExtensionsProfileScannerService=m=Pe([re(0,S.INativeEnvironmentService),re(1,R.IFileService),re(2,s.IUserDataProfilesService),re(3,y.IUriIdentityService),re(4,k.ITelemetryService),re(5,i.ILogService)],m)}),define(le[249],ue([0,1,7,36,88,136,14,6,5,28,41,42]),function(j,e,i,s,y,k,A,R,S,c,m,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScannerService=void 0;let p=class extends k.NativeExtensionsScannerService{constructor(f,h,E,b,g,I,P,r){super(i.URI.file(g.builtinExtensionsPath),i.URI.file(g.extensionsPath),g.userHome,f.defaultProfile,f,h,E,b,g,I,P,r)}};e.ExtensionsScannerService=p,e.ExtensionsScannerService=p=Pe([re(0,u.IUserDataProfilesService),re(1,y.IExtensionsProfileScannerService),re(2,A.IFileService),re(3,S.ILogService),re(4,s.INativeEnvironmentService),re(5,c.IProductService),re(6,m.IUriIdentityService),re(7,R.IInstantiationService)],p)}),define(le[250],ue([0,1,13,2,11,10,3,61,7,33,35,36,5,42]),function(j,e,i,s,y,k,A,R,S,c,m,u,p,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProtocolMainService=void 0;let f=class extends s.Disposable{constructor(E,b,g){super(),this.environmentService=E,this.logService=g,this.validRoots=R.TernarySearchTree.forPaths(!A.isLinux),this.validExtensions=new Set([".svg",".png",".jpg",".jpeg",".gif",".bmp",".webp",".mp4"]),this.addValidFileRoot(E.appRoot),this.addValidFileRoot(E.extensionsPath),this.addValidFileRoot(b.defaultProfile.globalStorageHome.with({scheme:y.Schemas.file}).fsPath),this.addValidFileRoot(E.workspaceStorageHome.with({scheme:y.Schemas.file}).fsPath),this.handleProtocols()}handleProtocols(){const{defaultSession:E}=i.session;E.protocol.registerFileProtocol(y.Schemas.vscodeFileResource,(b,g)=>this.handleResourceRequest(b,g)),E.protocol.interceptFileProtocol(y.Schemas.file,(b,g)=>this.handleFileRequest(b,g)),this._register((0,s.toDisposable)(()=>{E.protocol.unregisterProtocol(y.Schemas.vscodeFileResource),E.protocol.uninterceptProtocol(y.Schemas.file)}))}addValidFileRoot(E){const b=(0,k.normalize)(E);return this.validRoots.get(b)?s.Disposable.None:(this.validRoots.set(b,!0),(0,s.toDisposable)(()=>this.validRoots.delete(b)))}handleFileRequest(E,b){const g=S.URI.parse(E.url);return this.logService.error(`Refused to load resource ${g.fsPath} from ${y.Schemas.file}: protocol (original URL: ${E.url})`),b({error:-3})}handleResourceRequest(E,b){const g=this.requestToNormalizedFilePath(E);let I;if(this.environmentService.crossOriginIsolated){const P=(0,k.basename)(g);P==="workbench.html"||P==="workbench-dev.html"||P==="workbench.esm.html"||P==="workbench-dev.esm.html"?I=y.COI.CoopAndCoep:I=y.COI.getHeadersFromQuery(E.url)}return this.validRoots.findSubstr(g)?b({path:g,headers:I}):this.validExtensions.has((0,k.extname)(g).toLowerCase())?b({path:g}):(this.logService.error(`${y.Schemas.vscodeFileResource}: Refused to load resource ${g} from ${y.Schemas.vscodeFileResource}: protocol (original URL: ${E.url})`),b({error:-3}))}requestToNormalizedFilePath(E){const b=S.URI.parse(E.url),g=y.FileAccess.uriToFileUri(b);return(0,k.normalize)(g.fsPath)}createIPCObjectUrl(){let E;const b=S.URI.from({scheme:"vscode",path:(0,c.generateUuid)()}),g=b.toString(),I=async()=>E;return m.validatedIpcMain.handle(g,I),this.logService.trace(`IPC Object URL: Registered new channel ${g}.`),{resource:b,update:P=>E=P,dispose:()=>{this.logService.trace(`IPC Object URL: Removed channel ${g}.`),m.validatedIpcMain.removeHandler(g)}}}};e.ProtocolMainService=f,e.ProtocolMainService=f=Pe([re(0,u.INativeEnvironmentService),re(1,v.IUserDataProfilesService),re(2,p.ILogService)],f)}),define(le[63],ue([0,1,8,4,2,71,12,123,6,42]),function(j,e,i,s,y,k,A,R,S,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageService=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.TARGET_KEY=e.IS_NEW_KEY=void 0,e.loadKeyTargets=v,e.isProfileUsingDefaultStorage=h,e.logStorage=b,e.IS_NEW_KEY="__$__isNewStorageMarker",e.TARGET_KEY="__$__targetStorageMarker",e.IStorageService=(0,S.createDecorator)("storageService");var m;(function(g){g[g.NONE=0]="NONE",g[g.SHUTDOWN=1]="SHUTDOWN"})(m||(e.WillSaveStateReason=m={}));var u;(function(g){g[g.APPLICATION=-1]="APPLICATION",g[g.PROFILE=0]="PROFILE",g[g.WORKSPACE=1]="WORKSPACE"})(u||(e.StorageScope=u={}));var p;(function(g){g[g.USER=0]="USER",g[g.MACHINE=1]="MACHINE"})(p||(e.StorageTarget=p={}));function v(g){const I=g.get(e.TARGET_KEY);if(I)try{return JSON.parse(I)}catch{}return Object.create(null)}class f extends y.Disposable{static{this.DEFAULT_FLUSH_INTERVAL=60*1e3}constructor(I={flushInterval:f.DEFAULT_FLUSH_INTERVAL}){super(),this.options=I,this._onDidChangeValue=this._register(new s.PauseableEmitter),this._onDidChangeTarget=this._register(new s.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new s.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new i.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new y.MutableDisposable),this._workspaceKeyTargets=void 0,this._profileKeyTargets=void 0,this._applicationKeyTargets=void 0}onDidChangeValue(I,P,r){return s.Event.filter(this._onDidChangeValue.event,a=>a.scope===I&&(P===void 0||a.key===P),r)}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,i.runWhenGlobalIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,y.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,k.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,k.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(I,P){const{key:r,external:a}=P;if(r===e.TARGET_KEY){switch(I){case u.APPLICATION:this._applicationKeyTargets=void 0;break;case u.PROFILE:this._profileKeyTargets=void 0;break;case u.WORKSPACE:this._workspaceKeyTargets=void 0;break}this._onDidChangeTarget.fire({scope:I})}else this._onDidChangeValue.fire({scope:I,key:r,target:this.getKeyTargets(I)[r],external:a})}emitWillSaveState(I){this._onWillSaveState.fire({reason:I})}get(I,P,r){return this.getStorage(P)?.get(I,r)}getBoolean(I,P,r){return this.getStorage(P)?.getBoolean(I,r)}getNumber(I,P,r){return this.getStorage(P)?.getNumber(I,r)}getObject(I,P,r){return this.getStorage(P)?.getObject(I,r)}storeAll(I,P){this.withPausedEmitters(()=>{for(const r of I)this.store(r.key,r.value,r.scope,r.target,P)})}store(I,P,r,a,t=!1){if((0,A.isUndefinedOrNull)(P)){this.remove(I,r,t);return}this.withPausedEmitters(()=>{this.updateKeyTarget(I,r,a),this.getStorage(r)?.set(I,P,t)})}remove(I,P,r=!1){this.withPausedEmitters(()=>{this.updateKeyTarget(I,P,void 0),this.getStorage(P)?.delete(I,r)})}withPausedEmitters(I){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{I()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(I,P){const r=[],a=this.getKeyTargets(I);for(const t of Object.keys(a))a[t]===P&&r.push(t);return r}updateKeyTarget(I,P,r,a=!1){const t=this.getKeyTargets(P);typeof r=="number"?t[I]!==r&&(t[I]=r,this.getStorage(P)?.set(e.TARGET_KEY,JSON.stringify(t),a)):typeof t[I]=="number"&&(delete t[I],this.getStorage(P)?.set(e.TARGET_KEY,JSON.stringify(t),a))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(u.WORKSPACE)),this._workspaceKeyTargets}get profileKeyTargets(){return this._profileKeyTargets||(this._profileKeyTargets=this.loadKeyTargets(u.PROFILE)),this._profileKeyTargets}get applicationKeyTargets(){return this._applicationKeyTargets||(this._applicationKeyTargets=this.loadKeyTargets(u.APPLICATION)),this._applicationKeyTargets}getKeyTargets(I){switch(I){case u.APPLICATION:return this.applicationKeyTargets;case u.PROFILE:return this.profileKeyTargets;default:return this.workspaceKeyTargets}}loadKeyTargets(I){const P=this.getStorage(I);return P?v(P):Object.create(null)}isNew(I){return this.getBoolean(e.IS_NEW_KEY,I)===!0}async flush(I=m.NONE){this._onWillSaveState.fire({reason:I});const P=this.getStorage(u.APPLICATION),r=this.getStorage(u.PROFILE),a=this.getStorage(u.WORKSPACE);switch(I){case m.NONE:await i.Promises.settled([P?.whenFlushed()??Promise.resolve(),r?.whenFlushed()??Promise.resolve(),a?.whenFlushed()??Promise.resolve()]);break;case m.SHUTDOWN:await i.Promises.settled([P?.flush(0)??Promise.resolve(),r?.flush(0)??Promise.resolve(),a?.flush(0)??Promise.resolve()]);break}}async log(){const I=this.getStorage(u.APPLICATION)?.items??new Map,P=this.getStorage(u.PROFILE)?.items??new Map,r=this.getStorage(u.WORKSPACE)?.items??new Map;return b(I,P,r,this.getLogDetails(u.APPLICATION)??"",this.getLogDetails(u.PROFILE)??"",this.getLogDetails(u.WORKSPACE)??"")}async optimize(I){return await this.flush(),this.getStorage(I)?.optimize()}async switch(I,P){return this.emitWillSaveState(m.NONE),(0,c.isUserDataProfile)(I)?this.switchToProfile(I,P):this.switchToWorkspace(I,P)}canSwitchProfile(I,P){return!(I.id===P.id||h(P)&&h(I))}switchData(I,P,r){this.withPausedEmitters(()=>{const a=new Set;for(const[t,o]of I)a.add(t),P.get(t)!==o&&this.emitDidChangeValue(r,{key:t,external:!0});for(const[t]of P.items)a.has(t)||this.emitDidChangeValue(r,{key:t,external:!0})})}}e.AbstractStorageService=f;function h(g){return g.isDefault||!!g.useDefaultFlags?.globalState}class E extends f{constructor(){super(),this.applicationStorage=this._register(new R.Storage(new R.InMemoryStorageDatabase,{hint:R.StorageHint.STORAGE_IN_MEMORY})),this.profileStorage=this._register(new R.Storage(new R.InMemoryStorageDatabase,{hint:R.StorageHint.STORAGE_IN_MEMORY})),this.workspaceStorage=this._register(new R.Storage(new R.InMemoryStorageDatabase,{hint:R.StorageHint.STORAGE_IN_MEMORY})),this._register(this.workspaceStorage.onDidChangeStorage(I=>this.emitDidChangeValue(u.WORKSPACE,I))),this._register(this.profileStorage.onDidChangeStorage(I=>this.emitDidChangeValue(u.PROFILE,I))),this._register(this.applicationStorage.onDidChangeStorage(I=>this.emitDidChangeValue(u.APPLICATION,I)))}getStorage(I){switch(I){case u.APPLICATION:return this.applicationStorage;case u.PROFILE:return this.profileStorage;default:return this.workspaceStorage}}getLogDetails(I){switch(I){case u.APPLICATION:return"inMemory (application)";case u.PROFILE:return"inMemory (profile)";default:return"inMemory (workspace)"}}async doInitialize(){}async switchToProfile(){}async switchToWorkspace(){}shouldFlushWhenIdle(){return!1}hasScope(I){return!1}}e.InMemoryStorageService=E;async function b(g,I,P,r,a,t){const o=L=>{try{return JSON.parse(L)}catch{return L}},n=new Map,l=new Map;g.forEach((L,_)=>{n.set(_,L),l.set(_,o(L))});const d=new Map,D=new Map;I.forEach((L,_)=>{d.set(_,L),D.set(_,o(L))});const w=new Map,M=new Map;P.forEach((L,_)=>{w.set(_,L),M.set(_,o(L))}),console.group(r!==a?`Storage: Application (path: ${r})`:`Storage: Application & Profile (path: ${r}, default profile)`);const T=[];if(n.forEach((L,_)=>{T.push({key:_,value:L})}),console.table(T),console.groupEnd(),console.log(l),r!==a){console.group(`Storage: Profile (path: ${a}, profile specific)`);const L=[];d.forEach((_,V)=>{L.push({key:V,value:_})}),console.table(L),console.groupEnd(),console.log(D)}console.group(`Storage: Workspace (path: ${t})`);const C=[];w.forEach((L,_)=>{C.push({key:_,value:L})}),console.table(C),console.groupEnd(),console.log(M)}}),define(le[251],ue([0,1,17,33,63]),function(j,e,i,s,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=k;async function k(A,R,S){let c=S&&S.get("storage.serviceMachineId",y.StorageScope.APPLICATION)||null;if(c)return c;try{const u=(await R.readFile(A.serviceMachineIdResource)).value.toString();c=(0,s.isUUID)(u)?u:null}catch{c=null}if(!c){c=(0,s.generateUuid)();try{await R.writeFile(A.serviceMachineIdResource,i.VSBuffer.fromString(c))}catch{}}return S?.store("storage.serviceMachineId",c,y.StorageScope.APPLICATION,y.StorageTarget.MACHINE),c}}),define(le[252],ue([0,1,251,24,57]),function(j,e,i,s,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=k;async function k(A,R,S,c,m,u,p){const v={"X-Market-Client-Id":`VSCode ${A}`,"User-Agent":`VSCode ${A} (${R.nameShort})`};if((0,y.supportsTelemetry)(R,S)&&(0,y.getTelemetryLevel)(c)===s.TelemetryLevel.USAGE){const f=await(0,i.getServiceMachineId)(S,m,u);v["X-Market-User-Id"]=f,v["VSCode-SessionId"]=p.machineId||f}return v}}),define(le[253],ue([0,1,26,21,8,4,2,10,60,7,23,123,167,5,63,24,30,11]),function(j,e,i,s,y,k,A,R,S,c,m,u,p,v,f,h,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageMain=e.WorkspaceStorageMain=e.ApplicationStorageMain=e.ProfileStorageMain=void 0,i=Re(i);class g extends A.Disposable{static{this.LOG_SLOW_CLOSE_THRESHOLD=2e3}get storage(){return this._storage}constructor(n,l){super(),this.logService=n,this.fileService=l,this._onDidChangeStorage=this._register(new k.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this._onDidCloseStorage=this._register(new k.Emitter),this.onDidCloseStorage=this._onDidCloseStorage.event,this._storage=this._register(new u.Storage(new u.InMemoryStorageDatabase,{hint:u.StorageHint.STORAGE_IN_MEMORY})),this.initializePromise=void 0,this.whenInitPromise=new y.DeferredPromise,this.whenInit=this.whenInitPromise.p,this.state=u.StorageState.None}isInMemory(){return this._storage.isInMemory()}init(){return this.initializePromise||(this.initializePromise=(async()=>{if(this.state===u.StorageState.None)try{const n=this._register(await this.doCreate());this._storage.dispose(),this._storage=n,this._register(n.onDidChangeStorage(d=>this._onDidChangeStorage.fire(d))),await this.doInit(n);const l=n.getBoolean(f.IS_NEW_KEY);l===void 0?n.set(f.IS_NEW_KEY,!0):l&&n.set(f.IS_NEW_KEY,!1)}catch(n){this.logService.error(`[storage main] initialize(): Unable to init storage due to ${n}`)}finally{this.state=u.StorageState.Initialized,this.whenInitPromise.complete()}})()),this.initializePromise}createLoggingOptions(){return{logTrace:this.logService.getLevel()===v.LogLevel.Trace?n=>this.logService.trace(n):void 0,logError:n=>this.logService.error(n)}}doInit(n){return n.init()}get items(){return this._storage.items}get(n,l){return this._storage.get(n,l)}set(n,l){return this._storage.set(n,l)}delete(n){return this._storage.delete(n)}optimize(){return this._storage.optimize()}async close(){const n=new S.StopWatch(!1);await this.doClose(),n.stop(),n.elapsed()>g.LOG_SLOW_CLOSE_THRESHOLD&&await this.logSlowClose(n),this._onDidCloseStorage.fire()}async logSlowClose(n){if(this.path)try{const l=(0,s.top)(Array.from(this._storage.items.entries()).map(([D,w])=>({key:D,length:w.length})),(D,w)=>w.length-D.length,5).map(D=>`${D.key}:${D.length}`).join(", "),d=(await this.fileService.stat(c.URI.file(this.path))).size;this.logService.warn(`[storage main] detected slow close() operation: Time: ${n.elapsed()}ms, DB size: ${d}b, Large Keys: ${l}`)}catch(l){this.logService.error("[storage main] figuring out stats for slow DB on close() resulted in an error",l)}}async doClose(){this.initializePromise&&await this.initializePromise,this.state=u.StorageState.Closed,await this._storage.close()}}class I extends g{static{this.STORAGE_NAME="state.vscdb"}get path(){if(!this.options.useInMemoryStorage)return(0,R.join)(this.profile.globalStorageHome.with({scheme:b.Schemas.file}).fsPath,I.STORAGE_NAME)}constructor(n,l,d,D){super(d,D),this.profile=n,this.options=l}async doCreate(){return new u.Storage(new p.SQLiteStorageDatabase(this.path??p.SQLiteStorageDatabase.IN_MEMORY_PATH,{logging:this.createLoggingOptions()}),this.path?void 0:{hint:u.StorageHint.STORAGE_IN_MEMORY})}}class P extends I{constructor(n,l,d,D){super(n,l,d,D)}}e.ProfileStorageMain=P;class r extends I{constructor(n,l,d,D){super(l.defaultProfile,n,d,D)}async doInit(n){await super.doInit(n),this.updateTelemetryState(n)}updateTelemetryState(n){n.get(h.firstSessionDateStorageKey,void 0)===void 0&&n.set(h.firstSessionDateStorageKey,new Date().toUTCString());const d=n.get(h.currentSessionDateStorageKey,void 0),D=new Date().toUTCString();n.set(h.lastSessionDateStorageKey,typeof d>"u"?null:d),n.set(h.currentSessionDateStorageKey,D)}}e.ApplicationStorageMain=r;class a extends g{static{this.WORKSPACE_STORAGE_NAME="state.vscdb"}static{this.WORKSPACE_META_NAME="workspace.json"}get path(){if(!this.options.useInMemoryStorage)return(0,R.join)(this.environmentService.workspaceStorageHome.with({scheme:b.Schemas.file}).fsPath,this.workspace.id,a.WORKSPACE_STORAGE_NAME)}constructor(n,l,d,D,w){super(d,w),this.workspace=n,this.options=l,this.environmentService=D}async doCreate(){const{storageFilePath:n,wasCreated:l}=await this.prepareWorkspaceStorageFolder();return new u.Storage(new p.SQLiteStorageDatabase(n,{logging:this.createLoggingOptions()}),{hint:this.options.useInMemoryStorage?u.StorageHint.STORAGE_IN_MEMORY:l?u.StorageHint.STORAGE_DOES_NOT_EXIST:void 0})}async prepareWorkspaceStorageFolder(){if(this.options.useInMemoryStorage)return{storageFilePath:p.SQLiteStorageDatabase.IN_MEMORY_PATH,wasCreated:!0};const n=(0,R.join)(this.environmentService.workspaceStorageHome.with({scheme:b.Schemas.file}).fsPath,this.workspace.id),l=(0,R.join)(n,a.WORKSPACE_STORAGE_NAME);return await m.Promises.exists(n)?{storageFilePath:l,wasCreated:!1}:(await i.promises.mkdir(n,{recursive:!0}),this.ensureWorkspaceStorageFolderMeta(n),{storageFilePath:l,wasCreated:!0})}async ensureWorkspaceStorageFolderMeta(n){let l;if((0,E.isSingleFolderWorkspaceIdentifier)(this.workspace)?l={folder:this.workspace.uri.toString()}:(0,E.isWorkspaceIdentifier)(this.workspace)&&(l={workspace:this.workspace.configPath.toString()}),l)try{const d=(0,R.join)(n,a.WORKSPACE_META_NAME);await m.Promises.exists(d)||await m.Promises.writeFile(d,JSON.stringify(l,void 0,2))}catch(d){this.logService.error(`[storage main] ensureWorkspaceStorageFolderMeta(): Unable to create workspace storage metadata due to ${d}`)}}}e.WorkspaceStorageMain=a;class t extends g{get path(){}async doCreate(){return new u.Storage(new u.InMemoryStorageDatabase,{hint:u.StorageHint.STORAGE_IN_MEMORY})}}e.InMemoryStorageMain=t}),define(le[254],ue([0,1,4,2,63]),function(j,e,i,s,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProfileStorageChangesListenerChannel=void 0;class k extends s.Disposable{constructor(R,S,c){super(),this.storageMainService=R,this.userDataProfilesService=S,this.logService=c;const m=this._register(new s.MutableDisposable);this._onDidChange=this._register(new i.Emitter({onWillAddFirstListener:()=>m.value=this.registerStorageChangeListeners(),onDidRemoveLastListener:()=>m.value=void 0}))}registerStorageChangeListeners(){this.logService.debug("ProfileStorageChangesListenerChannel#registerStorageChangeListeners");const R=new s.DisposableStore;return R.add(i.Event.debounce(this.storageMainService.applicationStorage.onDidChangeStorage,(S,c)=>(S?S.push(c.key):S=[c.key],S),100)(S=>this.onDidChangeApplicationStorage(S))),R.add(i.Event.debounce(this.storageMainService.onDidChangeProfileStorage,(S,c)=>{S||(S=new Map);let m=S.get(c.profile.id);return m||S.set(c.profile.id,m={profile:c.profile,keys:[],storage:c.storage}),m.keys.push(c.key),S},100)(S=>this.onDidChangeProfileStorage(S))),R}onDidChangeApplicationStorage(R){const S=R.includes(y.TARGET_KEY)?[this.userDataProfilesService.defaultProfile]:[],c=[];if(R=R.filter(m=>m!==y.TARGET_KEY),R.length){const m=(0,y.loadKeyTargets)(this.storageMainService.applicationStorage.storage);c.push({profile:this.userDataProfilesService.defaultProfile,changes:R.map(u=>({key:u,scope:y.StorageScope.PROFILE,target:m[u]}))})}this.triggerEvents(S,c)}onDidChangeProfileStorage(R){const S=[],c=new Map;for(const[m,u]of R.entries()){u.keys.includes(y.TARGET_KEY)&&S.push(u.profile);const p=u.keys.filter(v=>v!==y.TARGET_KEY);if(p.length){const v=(0,y.loadKeyTargets)(u.storage.storage);c.set(m,{profile:u.profile,changes:p.map(f=>({key:f,scope:y.StorageScope.PROFILE,target:v[f]}))})}}this.triggerEvents(S,[...c.values()])}triggerEvents(R,S){(R.length||S.length)&&this._onDidChange.fire({valueChanges:S,targetChanges:R})}listen(R,S,c){switch(S){case"onDidChange":return this._onDidChange.event}throw new Error(`[ProfileStorageChangesListenerChannel] Event not found: ${S}`)}async call(R,S){throw new Error(`Call not found: ${S}`)}}e.ProfileStorageChangesListenerChannel=k}),define(le[255],ue([0,1,7,36,14,5,34,41,42,12,130]),function(j,e,i,s,y,k,A,R,S,c,m){"use strict";var u,p;Object.defineProperty(e,"__esModule",{value:!0}),e.ServerUserDataProfilesService=e.UserDataProfilesService=e.UserDataProfilesReadonlyService=void 0;let v=class extends S.UserDataProfilesService{static{u=this}static{this.PROFILE_ASSOCIATIONS_MIGRATION_KEY="profileAssociationsMigration"}constructor(b,g,I,P,r){super(I,P,g,r),this.stateReadonlyService=b,this.nativeEnvironmentService=I}getStoredProfiles(){return this.stateReadonlyService.getItem(u.PROFILES_KEY,[]).map(g=>({...g,location:(0,c.isString)(g.location)?this.uriIdentityService.extUri.joinPath(this.profilesHome,g.location):i.URI.revive(g.location)}))}getStoredProfileAssociations(){const b=this.stateReadonlyService.getItem(u.PROFILE_ASSOCIATIONS_KEY,{});return this.stateReadonlyService.getItem(u.PROFILE_ASSOCIATIONS_MIGRATION_KEY,!1)?b:this.migrateStoredProfileAssociations(b)}getDefaultProfileExtensionsLocation(){return this.uriIdentityService.extUri.joinPath(i.URI.file(this.nativeEnvironmentService.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};e.UserDataProfilesReadonlyService=v,e.UserDataProfilesReadonlyService=v=u=Pe([re(0,A.IStateReadService),re(1,R.IUriIdentityService),re(2,s.INativeEnvironmentService),re(3,y.IFileService),re(4,k.ILogService)],v);let f=p=class extends v{constructor(b,g,I,P,r){super(b,g,I,P,r),this.stateService=b}saveStoredProfiles(b){b.length?this.stateService.setItem(p.PROFILES_KEY,b.map(g=>({...g,location:this.uriIdentityService.extUri.basename(g.location)}))):this.stateService.removeItem(p.PROFILES_KEY)}getStoredProfiles(){const b=super.getStoredProfiles();return this.stateService.getItem("userDataProfilesMigration",!1)||(this.saveStoredProfiles(b),this.stateService.setItem("userDataProfilesMigration",!0)),b}saveStoredProfileAssociations(b){b.emptyWindows||b.workspaces?this.stateService.setItem(p.PROFILE_ASSOCIATIONS_KEY,b):this.stateService.removeItem(p.PROFILE_ASSOCIATIONS_KEY)}getStoredProfileAssociations(){const b="workspaceAndProfileInfo",g=this.stateService.getItem(b,void 0);if(g){this.stateService.removeItem(b);const P=g.reduce((r,{workspace:a,profile:t})=>(r[i.URI.revive(a).toString()]=i.URI.revive(t).toString(),r),{});this.stateService.setItem(p.PROFILE_ASSOCIATIONS_KEY,{workspaces:P})}const I=super.getStoredProfileAssociations();return this.stateService.getItem(p.PROFILE_ASSOCIATIONS_MIGRATION_KEY,!1)||(this.saveStoredProfileAssociations(I),this.stateService.setItem(p.PROFILE_ASSOCIATIONS_MIGRATION_KEY,!0)),I}};e.UserDataProfilesService=f,e.UserDataProfilesService=f=p=Pe([re(0,A.IStateService),re(1,R.IUriIdentityService),re(2,s.INativeEnvironmentService),re(3,y.IFileService),re(4,k.ILogService)],f);let h=class extends f{constructor(b,g,I,P){super(new m.StateService(m.SaveStrategy.IMMEDIATE,g,P,I),b,g,I,P)}async init(){return await this.stateService.init(),super.init()}};e.ServerUserDataProfilesService=h,e.ServerUserDataProfilesService=h=Pe([re(0,R.IUriIdentityService),re(1,s.INativeEnvironmentService),re(2,y.IFileService),re(3,k.ILogService)],h)}),define(le[58],ue([0,1,36,14,6,5,41,42,255,34]),function(j,e,i,s,y,k,A,R,S,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesMainService=e.IUserDataProfilesMainService=void 0,e.IUserDataProfilesMainService=(0,y.refineServiceDecorator)(R.IUserDataProfilesService);let m=class extends S.UserDataProfilesService{constructor(p,v,f,h,E){super(p,v,f,h,E)}getAssociatedEmptyWindows(){const p=[];for(const v of this.profilesObject.emptyWindows.keys())p.push({id:v});return p}};e.UserDataProfilesMainService=m,e.UserDataProfilesMainService=m=Pe([re(0,c.IStateService),re(1,A.IUriIdentityService),re(2,i.INativeEnvironmentService),re(3,s.IFileService),re(4,k.ILogService)],m)}),define(le[137],ue([0,1,18,7,30]),function(j,e,i,s,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findWindowOnFile=k,e.findWindowOnWorkspaceOrFolder=A,e.findWindowOnExtensionDevelopmentPath=R;async function k(S,c,m){for(const p of S){const v=p.openedWorkspace;if((0,y.isWorkspaceIdentifier)(v)){const f=await m(v);if(f){if(f.folders.some(h=>i.extUriBiasedIgnorePathCase.isEqualOrParent(c,h.uri)))return p}else if(i.extUriBiasedIgnorePathCase.isEqualOrParent(c,v.configPath))return p}}const u=S.filter(p=>(0,y.isSingleFolderWorkspaceIdentifier)(p.openedWorkspace)&&i.extUriBiasedIgnorePathCase.isEqualOrParent(c,p.openedWorkspace.uri));if(u.length)return u.sort((p,v)=>-(p.openedWorkspace.uri.path.length-v.openedWorkspace.uri.path.length))[0]}function A(S,c){for(const m of S)if((0,y.isWorkspaceIdentifier)(m.openedWorkspace)&&i.extUriBiasedIgnorePathCase.isEqual(m.openedWorkspace.configPath,c)||(0,y.isSingleFolderWorkspaceIdentifier)(m.openedWorkspace)&&i.extUriBiasedIgnorePathCase.isEqual(m.openedWorkspace.uri,c))return m}function R(S,c){const m=u=>c.some(p=>i.extUriBiasedIgnorePathCase.isEqual(s.URI.file(p),s.URI.file(u)));for(const u of S)if(u.config?.extensionDevelopmentPath?.some(p=>m(p)))return u}}),define(le[105],ue([0,1,32,43,110,49,11,10,3,18,7,6,75,30]),function(j,e,i,s,y,k,A,R,S,c,m,u,p,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkspacesService=void 0,e.isRecentWorkspace=f,e.isRecentFolder=h,e.isRecentFile=E,e.isStoredWorkspaceFolder=b,e.getStoredWorkspaceFolder=P,e.toWorkspaceFolders=a,e.rewriteWorkspaceFileForNewLocation=t,e.restoreRecentlyOpened=D,e.toStoreData=w,s=Re(s),y=Re(y),e.IWorkspacesService=(0,u.createDecorator)("workspacesService");function f(M){return M.hasOwnProperty("workspace")}function h(M){return M.hasOwnProperty("folderUri")}function E(M){return M.hasOwnProperty("fileUri")}function b(M){return g(M)||I(M)}function g(M){const T=M;return typeof T?.path=="string"&&(!T.name||typeof T.name=="string")}function I(M){const T=M;return typeof T?.uri=="string"&&(!T.name||typeof T.name=="string")}function P(M,T,C,L,_){if(M.scheme!==L.scheme)return{name:C,uri:M.toString(!0)};let V=T?void 0:_.relativePath(L,M);if(V!==void 0)V.length===0?V=".":S.isWindows&&(V=r(V));else if(M.scheme===A.Schemas.file)V=M.fsPath,S.isWindows&&(V=r(V));else if(_.isEqualAuthority(M.authority,L.authority))V=M.path;else return{name:C,uri:M.toString(!0)};return{name:C,path:V}}function r(M){return M=(0,k.normalizeDriveLetter)(M),(0,i.isUNC)(M)||(M=(0,i.toSlashes)(M)),M}function a(M,T,C){const L=[],_=new Set,V=C.dirname(T);for(const z of M){let Q;if(g(z))z.path&&(Q=C.resolvePath(V,z.path));else if(I(z))try{Q=m.URI.parse(z.uri),Q.path[0]!==R.posix.sep&&(Q=Q.with({path:R.posix.sep+Q.path}))}catch(fe){console.warn(fe)}if(Q){const fe=C.getComparisonKey(Q);if(!_.has(fe)){_.add(fe);const se=z.name||C.basenameOrAuthority(Q);L.push(new v.WorkspaceFolder({uri:Q,name:se,index:L.length},z))}}}return L}function t(M,T,C,L,_){const V=o(T,M),z=_.dirname(T),Q=_.dirname(L),fe=[];for(const K of V.folders){const N=g(K)?_.resolvePath(z,K.path):m.URI.parse(K.uri);let x;C?x=!1:x=!g(K)||(0,R.isAbsolute)(K.path),fe.push(P(N,x,K.name,Q,_))}const se={insertSpaces:!1,tabSize:4,eol:S.isLinux||S.isMacintosh?`
`:`\r
`},ee=y.setProperty(M,["folders"],fe,se);let U=y.applyEdits(M,ee);return(0,c.isEqualAuthority)(V.remoteAuthority,(0,p.getRemoteAuthority)(L))&&(U=y.applyEdits(U,y.removeProperty(U,["remoteAuthority"],se))),U}function o(M,T){const C=s.parse(T);if(C&&Array.isArray(C.folders))C.folders=C.folders.filter(L=>b(L));else throw new Error(`${M} looks like an invalid workspace file.`);return C}function n(M){return M.workspace&&typeof M.workspace=="object"&&typeof M.workspace.id=="string"&&typeof M.workspace.configPath=="string"}function l(M){return typeof M.folderUri=="string"}function d(M){return typeof M.fileUri=="string"}function D(M,T){const C={workspaces:[],files:[]};if(M){const L=function(V,z){for(let Q=0;Q<V.length;Q++)try{z(V[Q],Q)}catch(fe){T.warn(`Error restoring recent entry ${JSON.stringify(V[Q])}: ${fe.toString()}. Skip entry.`)}},_=M;Array.isArray(_.entries)&&L(_.entries,V=>{const z=V.label,Q=V.remoteAuthority;n(V)?C.workspaces.push({label:z,remoteAuthority:Q,workspace:{id:V.workspace.id,configPath:m.URI.parse(V.workspace.configPath)}}):l(V)?C.workspaces.push({label:z,remoteAuthority:Q,folderUri:m.URI.parse(V.folderUri)}):d(V)&&C.files.push({label:z,remoteAuthority:Q,fileUri:m.URI.parse(V.fileUri)})})}return C}function w(M){const T={entries:[]};for(const C of M.workspaces)h(C)?T.entries.push({folderUri:C.folderUri.toString(),label:C.label,remoteAuthority:C.remoteAuthority}):T.entries.push({workspace:{id:C.workspace.id,configPath:C.workspace.configPath.toString()},label:C.label,remoteAuthority:C.remoteAuthority});for(const C of M.files)T.entries.push({fileUri:C.fileUri.toString(),label:C.label,remoteAuthority:C.remoteAuthority});return T}}),define(le[106],ue([0,1,93,11,3,18]),function(j,e,i,s,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NON_EMPTY_WORKSPACE_ID_LENGTH=void 0,e.getWorkspaceIdentifier=A,e.getSingleFolderWorkspaceIdentifier=R,e.createEmptyWorkspaceIdentifier=S,e.NON_EMPTY_WORKSPACE_ID_LENGTH=128/4;function A(c){function m(){let u=c.scheme===s.Schemas.file?(0,k.originalFSPath)(c):c.toString();return y.isLinux||(u=u.toLowerCase()),(0,i.createHash)("md5").update(u).digest("hex")}return{id:m(),configPath:c}}function R(c,m){function u(){if(c.scheme!==s.Schemas.file)return(0,i.createHash)("md5").update(c.toString()).digest("hex");if(!m)return;let v;return y.isLinux?v=m.ino:y.isMacintosh?v=m.birthtime.getTime():y.isWindows&&(typeof m.birthtimeMs=="number"?v=Math.floor(m.birthtimeMs):v=m.birthtime.getTime()),(0,i.createHash)("md5").update(c.fsPath).update(v?String(v):"").digest("hex")}const p=u();if(typeof p=="string")return{id:p,uri:c}}function S(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}}),define(le[107],ue([0,1,93,94,27,256,17,15,4,2,10,3,33,45,121]),function(j,e,i,s,y,k,A,R,S,c,m,u,p,v,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0,e.createRandomIPCHandle=n,e.createStaticIPCHandle=l,e.serve=w,e.connect=M;const h=3e4;class E{traceSocketEvent(C,L){f.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,C,L)}constructor(C,L=""){this._canWrite=!0,this.debugLabel=L,this.socket=C,this.traceSocketEvent(f.SocketDiagnosticsEventType.Created,{type:"NodeSocket"}),this._errorListener=V=>{if(this.traceSocketEvent(f.SocketDiagnosticsEventType.Error,{code:V?.code,message:V?.message}),V){if(V.code==="EPIPE")return;(0,R.onUnexpectedError)(V)}},this.socket.on("error",this._errorListener);let _;this._closeListener=V=>{this.traceSocketEvent(f.SocketDiagnosticsEventType.Close,{hadError:V}),this._canWrite=!1,_&&clearTimeout(_)},this.socket.on("close",this._closeListener),this._endListener=()=>{this.traceSocketEvent(f.SocketDiagnosticsEventType.NodeEndReceived),this._canWrite=!1,_=setTimeout(()=>C.destroy(),h)},this.socket.on("end",this._endListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.off("close",this._closeListener),this.socket.off("end",this._endListener),this.socket.destroy()}onData(C){const L=_=>{this.traceSocketEvent(f.SocketDiagnosticsEventType.Read,_),C(A.VSBuffer.wrap(_))};return this.socket.on("data",L),{dispose:()=>this.socket.off("data",L)}}onClose(C){const L=_=>{C({type:f.SocketCloseEventType.NodeSocketCloseEvent,hadError:_,error:void 0})};return this.socket.on("close",L),{dispose:()=>this.socket.off("close",L)}}onEnd(C){const L=()=>{C()};return this.socket.on("end",L),{dispose:()=>this.socket.off("end",L)}}write(C){if(!(this.socket.destroyed||!this._canWrite))try{this.traceSocketEvent(f.SocketDiagnosticsEventType.Write,C),this.socket.write(C.buffer,L=>{if(L){if(L.code==="EPIPE")return;(0,R.onUnexpectedError)(L)}})}catch(L){if(L.code==="EPIPE")return;(0,R.onUnexpectedError)(L)}}end(){this.traceSocketEvent(f.SocketDiagnosticsEventType.NodeEndSent),this.socket.end()}drain(){return this.traceSocketEvent(f.SocketDiagnosticsEventType.NodeDrainBegin),new Promise((C,L)=>{if(this.socket.bufferSize===0){this.traceSocketEvent(f.SocketDiagnosticsEventType.NodeDrainEnd),C();return}const _=()=>{this.socket.off("close",_),this.socket.off("end",_),this.socket.off("error",_),this.socket.off("timeout",_),this.socket.off("drain",_),this.traceSocketEvent(f.SocketDiagnosticsEventType.NodeDrainEnd),C()};this.socket.on("close",_),this.socket.on("end",_),this.socket.on("error",_),this.socket.on("timeout",_),this.socket.on("drain",_)})}}e.NodeSocket=E;var b;(function(T){T[T.MinHeaderByteSize=2]="MinHeaderByteSize",T[T.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(b||(b={}));var g;(function(T){T[T.PeekHeader=1]="PeekHeader",T[T.ReadHeader=2]="ReadHeader",T[T.ReadBody=3]="ReadBody",T[T.Fin=4]="Fin"})(g||(g={}));class I extends c.Disposable{get permessageDeflate(){return this._flowManager.permessageDeflate}get recordedInflateBytes(){return this._flowManager.recordedInflateBytes}traceSocketEvent(C,L){this.socket.traceSocketEvent(C,L)}constructor(C,L,_,V){super(),this._onData=this._register(new S.Emitter),this._onClose=this._register(new S.Emitter),this._isEnded=!1,this._state={state:g.PeekHeader,readLen:b.MinHeaderByteSize,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=C,this.traceSocketEvent(f.SocketDiagnosticsEventType.Created,{type:"WebSocketNodeSocket",permessageDeflate:L,inflateBytesLength:_?.byteLength||0,recordInflateBytes:V}),this._flowManager=this._register(new P(this,L,_,V,this._onData,(z,Q)=>this._write(z,Q))),this._register(this._flowManager.onError(z=>{console.error(z),(0,R.onUnexpectedError)(z),this._onClose.fire({type:f.SocketCloseEventType.NodeSocketCloseEvent,hadError:!0,error:z})})),this._incomingData=new f.ChunkStream,this._register(this.socket.onData(z=>this._acceptChunk(z))),this._register(this.socket.onClose(async z=>{this._flowManager.isProcessingReadQueue()&&await S.Event.toPromise(this._flowManager.onDidFinishProcessingReadQueue),this._onClose.fire(z)}))}dispose(){this._flowManager.isProcessingWriteQueue()?this._register(this._flowManager.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(C){return this._onData.event(C)}onClose(C){return this._onClose.event(C)}onEnd(C){return this.socket.onEnd(C)}write(C){let L=0;for(;L<C.byteLength;)this._flowManager.writeMessage(C.slice(L,Math.min(L+b.MaxWebSocketMessageLength,C.byteLength)),{compressed:!0,opcode:2}),L+=b.MaxWebSocketMessageLength}_write(C,{compressed:L,opcode:_}){if(this._isEnded)return;this.traceSocketEvent(f.SocketDiagnosticsEventType.WebSocketNodeSocketWrite,C);let V=b.MinHeaderByteSize;C.byteLength<126?V+=0:C.byteLength<2**16?V+=2:V+=8;const z=A.VSBuffer.alloc(V),Q=L?64:0,fe=_&15;if(z.writeUInt8(128|Q|fe,0),C.byteLength<126)z.writeUInt8(C.byteLength,1);else if(C.byteLength<2**16){z.writeUInt8(126,1);let se=1;z.writeUInt8(C.byteLength>>>8&255,++se),z.writeUInt8(C.byteLength>>>0&255,++se)}else{z.writeUInt8(127,1);let se=1;z.writeUInt8(0,++se),z.writeUInt8(0,++se),z.writeUInt8(0,++se),z.writeUInt8(0,++se),z.writeUInt8(C.byteLength>>>24&255,++se),z.writeUInt8(C.byteLength>>>16&255,++se),z.writeUInt8(C.byteLength>>>8&255,++se),z.writeUInt8(C.byteLength>>>0&255,++se)}this.socket.write(A.VSBuffer.concat([z,C]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(C){if(C.byteLength!==0){for(this._incomingData.acceptChunk(C);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===g.PeekHeader){const L=this._incomingData.peek(this._state.readLen),_=L.readUInt8(0),V=(_&128)>>>7,z=(_&64)>>>6,Q=_&15,fe=L.readUInt8(1),se=(fe&128)>>>7,ee=fe&127;this._state.state=g.ReadHeader,this._state.readLen=b.MinHeaderByteSize+(se?4:0)+(ee===126?2:0)+(ee===127?8:0),this._state.fin=V,this._state.firstFrameOfMessage&&(this._state.compressed=!!z),this._state.firstFrameOfMessage=!!V,this._state.mask=0,this._state.opcode=Q,this.traceSocketEvent(f.SocketDiagnosticsEventType.WebSocketNodeSocketPeekedHeader,{headerSize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,opcode:this._state.opcode})}else if(this._state.state===g.ReadHeader){const L=this._incomingData.read(this._state.readLen),_=L.readUInt8(1),V=(_&128)>>>7;let z=_&127,Q=1;z===126?z=L.readUInt8(++Q)*2**8+L.readUInt8(++Q):z===127&&(z=L.readUInt8(++Q)*0+L.readUInt8(++Q)*0+L.readUInt8(++Q)*0+L.readUInt8(++Q)*0+L.readUInt8(++Q)*2**24+L.readUInt8(++Q)*2**16+L.readUInt8(++Q)*2**8+L.readUInt8(++Q));let fe=0;V&&(fe=L.readUInt8(++Q)*2**24+L.readUInt8(++Q)*2**16+L.readUInt8(++Q)*2**8+L.readUInt8(++Q)),this._state.state=g.ReadBody,this._state.readLen=z,this._state.mask=fe,this.traceSocketEvent(f.SocketDiagnosticsEventType.WebSocketNodeSocketPeekedHeader,{bodySize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,mask:this._state.mask,opcode:this._state.opcode})}else if(this._state.state===g.ReadBody){const L=this._incomingData.read(this._state.readLen);this.traceSocketEvent(f.SocketDiagnosticsEventType.WebSocketNodeSocketReadData,L),t(L,this._state.mask),this.traceSocketEvent(f.SocketDiagnosticsEventType.WebSocketNodeSocketUnmaskedData,L),this._state.state=g.PeekHeader,this._state.readLen=b.MinHeaderByteSize,this._state.mask=0,this._state.opcode<=2?this._flowManager.acceptFrame(L,this._state.compressed,!!this._state.fin):this._state.opcode===9&&this._flowManager.writeMessage(L,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent(f.SocketDiagnosticsEventType.WebSocketNodeSocketDrainBegin),this._flowManager.isProcessingWriteQueue()&&await S.Event.toPromise(this._flowManager.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent(f.SocketDiagnosticsEventType.WebSocketNodeSocketDrainEnd)}}e.WebSocketNodeSocket=I;class P extends c.Disposable{get permessageDeflate(){return!!(this._zlibInflateStream&&this._zlibDeflateStream)}get recordedInflateBytes(){return this._zlibInflateStream?this._zlibInflateStream.recordedInflateBytes:A.VSBuffer.alloc(0)}constructor(C,L,_,V,z,Q){super(),this._tracer=C,this._onData=z,this._writeFn=Q,this._onError=this._register(new S.Emitter),this.onError=this._onError.event,this._writeQueue=[],this._readQueue=[],this._onDidFinishProcessingReadQueue=this._register(new S.Emitter),this.onDidFinishProcessingReadQueue=this._onDidFinishProcessingReadQueue.event,this._onDidFinishProcessingWriteQueue=this._register(new S.Emitter),this.onDidFinishProcessingWriteQueue=this._onDidFinishProcessingWriteQueue.event,this._isProcessingWriteQueue=!1,this._isProcessingReadQueue=!1,L?(this._zlibInflateStream=this._register(new r(this._tracer,V,_,{windowBits:15})),this._zlibDeflateStream=this._register(new a(this._tracer,{windowBits:15})),this._register(this._zlibInflateStream.onError(fe=>this._onError.fire(fe))),this._register(this._zlibDeflateStream.onError(fe=>this._onError.fire(fe)))):(this._zlibInflateStream=null,this._zlibDeflateStream=null)}writeMessage(C,L){this._writeQueue.push({data:C,options:L}),this._processWriteQueue()}async _processWriteQueue(){if(!this._isProcessingWriteQueue){for(this._isProcessingWriteQueue=!0;this._writeQueue.length>0;){const{data:C,options:L}=this._writeQueue.shift();if(this._zlibDeflateStream&&L.compressed){const _=await this._deflateMessage(this._zlibDeflateStream,C);this._writeFn(_,L)}else this._writeFn(C,{...L,compressed:!1})}this._isProcessingWriteQueue=!1,this._onDidFinishProcessingWriteQueue.fire()}}isProcessingWriteQueue(){return this._isProcessingWriteQueue}_deflateMessage(C,L){return new Promise((_,V)=>{C.write(L),C.flush(z=>_(z))})}acceptFrame(C,L,_){this._readQueue.push({data:C,isCompressed:L,isLastFrameOfMessage:_}),this._processReadQueue()}async _processReadQueue(){if(!this._isProcessingReadQueue){for(this._isProcessingReadQueue=!0;this._readQueue.length>0;){const C=this._readQueue.shift();if(this._zlibInflateStream&&C.isCompressed){const L=await this._inflateFrame(this._zlibInflateStream,C.data,C.isLastFrameOfMessage);this._onData.fire(L)}else this._onData.fire(C.data)}this._isProcessingReadQueue=!1,this._onDidFinishProcessingReadQueue.fire()}}isProcessingReadQueue(){return this._isProcessingReadQueue}_inflateFrame(C,L,_){return new Promise((V,z)=>{C.write(L),_&&C.write(A.VSBuffer.fromByteArray([0,0,255,255])),C.flush(Q=>V(Q))})}}class r extends c.Disposable{get recordedInflateBytes(){return this._recordInflateBytes?A.VSBuffer.concat(this._recordedInflateBytes):A.VSBuffer.alloc(0)}constructor(C,L,_,V){super(),this._tracer=C,this._recordInflateBytes=L,this._onError=this._register(new S.Emitter),this.onError=this._onError.event,this._recordedInflateBytes=[],this._pendingInflateData=[],this._zlibInflate=(0,k.createInflateRaw)(V),this._zlibInflate.on("error",z=>{this._tracer.traceSocketEvent(f.SocketDiagnosticsEventType.zlibInflateError,{message:z?.message,code:z?.code}),this._onError.fire(z)}),this._zlibInflate.on("data",z=>{this._tracer.traceSocketEvent(f.SocketDiagnosticsEventType.zlibInflateData,z),this._pendingInflateData.push(A.VSBuffer.wrap(z))}),_&&(this._tracer.traceSocketEvent(f.SocketDiagnosticsEventType.zlibInflateInitialWrite,_.buffer),this._zlibInflate.write(_.buffer),this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent(f.SocketDiagnosticsEventType.zlibInflateInitialFlushFired),this._pendingInflateData.length=0}))}write(C){this._recordInflateBytes&&this._recordedInflateBytes.push(C.clone()),this._tracer.traceSocketEvent(f.SocketDiagnosticsEventType.zlibInflateWrite,C),this._zlibInflate.write(C.buffer)}flush(C){this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent(f.SocketDiagnosticsEventType.zlibInflateFlushFired);const L=A.VSBuffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,C(L)})}}class a extends c.Disposable{constructor(C,L){super(),this._tracer=C,this._onError=this._register(new S.Emitter),this.onError=this._onError.event,this._pendingDeflateData=[],this._zlibDeflate=(0,k.createDeflateRaw)({windowBits:15}),this._zlibDeflate.on("error",_=>{this._tracer.traceSocketEvent(f.SocketDiagnosticsEventType.zlibDeflateError,{message:_?.message,code:_?.code}),this._onError.fire(_)}),this._zlibDeflate.on("data",_=>{this._tracer.traceSocketEvent(f.SocketDiagnosticsEventType.zlibDeflateData,_),this._pendingDeflateData.push(A.VSBuffer.wrap(_))})}write(C){this._tracer.traceSocketEvent(f.SocketDiagnosticsEventType.zlibDeflateWrite,C.buffer),this._zlibDeflate.write(C.buffer)}flush(C){this._zlibDeflate.flush(2,()=>{this._tracer.traceSocketEvent(f.SocketDiagnosticsEventType.zlibDeflateFlushFired);let L=A.VSBuffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,L=L.slice(0,L.byteLength-4),C(L)})}}function t(T,C){if(C===0)return;const L=T.byteLength>>>2;for(let se=0;se<L;se++){const ee=T.readUInt32BE(se*4);T.writeUInt32BE(ee^C,se*4)}const _=L*4,V=T.byteLength-_,z=C>>>24&255,Q=C>>>16&255,fe=C>>>8&255;V>=1&&T.writeUInt8(T.readUInt8(_)^z,_),V>=2&&T.writeUInt8(T.readUInt8(_+1)^Q,_+1),V>=3&&T.writeUInt8(T.readUInt8(_+2)^fe,_+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const o={[u.Platform.Linux]:107,[u.Platform.Mac]:103};function n(){const T=(0,p.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${T}-sock`;const C=process.platform!=="darwin"&&e.XDG_RUNTIME_DIR?e.XDG_RUNTIME_DIR:(0,y.tmpdir)(),L=(0,m.join)(C,`vscode-ipc-${T}.sock`);return d(L),L}function l(T,C,L){const V=(0,i.createHash)("sha256").update(T).digest("hex").substr(0,8);if(process.platform==="win32")return`\\\\.\\pipe\\${V}-${L}-${C}-sock`;const z=L.substr(0,4),Q=C.substr(0,6);let fe;return process.platform!=="darwin"&&e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?fe=(0,m.join)(e.XDG_RUNTIME_DIR,`vscode-${V}-${z}-${Q}.sock`):fe=(0,m.join)(T,`${z}-${Q}.sock`),d(fe),fe}function d(T){const C=o[u.platform];typeof C=="number"&&T.length>=C&&console.warn(`WARNING: IPC handle "${T}" is longer than ${C} chars, try a shorter --user-data-dir`)}class D extends v.IPCServer{static toClientConnectionEvent(C){const L=S.Event.fromNodeEventEmitter(C,"connection");return S.Event.map(L,_=>({protocol:new f.Protocol(new E(_,"ipc-server-connection")),onDidClientDisconnect:S.Event.once(S.Event.fromNodeEventEmitter(_,"close"))}))}constructor(C){super(D.toClientConnectionEvent(C)),this.server=C}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=D;function w(T){return new Promise((C,L)=>{const _=(0,s.createServer)();_.on("error",L),_.listen(T,()=>{_.removeListener("error",L),C(new D(_))})})}function M(T,C){return new Promise((L,_)=>{const V=(0,s.createConnection)(T,()=>{V.removeListener("error",_),L(f.Client.fromSocket(new E(V,`ipc-client${C}`),C))});V.once("error",_)})}}),define(le[20],ue([0,1,54,10,3,107,36,98,6]),function(j,e,i,s,y,k,A,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentMainService=e.IEnvironmentMainService=void 0,e.IEnvironmentMainService=(0,S.refineServiceDecorator)(A.IEnvironmentService);class c extends R.NativeEnvironmentService{constructor(){super(...arguments),this._snapEnv={}}get backupHome(){return(0,s.join)(this.userDataPath,"Backups")}get mainIPCHandle(){return(0,k.createStaticIPCHandle)(this.userDataPath,"main",this.productService.version)}get mainLockfile(){return(0,s.join)(this.userDataPath,"code.lock")}get disableUpdates(){return!!this.args["disable-updates"]}get crossOriginIsolated(){return!!this.args["enable-coi"]}get codeCachePath(){return process.env.VSCODE_CODE_CACHE_PATH||void 0}get useCodeCache(){return!!this.codeCachePath}unsetSnapExportedVariables(){if(y.isLinux){for(const u in process.env)if(u.endsWith("_VSCODE_SNAP_ORIG")){const p=u.slice(0,-17);if(this._snapEnv[p])continue;process.env[p]&&(this._snapEnv[p]=process.env[p]),process.env[u]?process.env[p]=process.env[u]:delete process.env[p]}}}restoreSnapExportedVariables(){if(y.isLinux)for(const u in this._snapEnv)process.env[u]=this._snapEnv[u],delete this._snapEnv[u]}}e.EnvironmentMainService=c,Pe([i.memoize],c.prototype,"backupHome",null),Pe([i.memoize],c.prototype,"mainIPCHandle",null),Pe([i.memoize],c.prototype,"mainLockfile",null),Pe([i.memoize],c.prototype,"disableUpdates",null),Pe([i.memoize],c.prototype,"crossOriginIsolated",null),Pe([i.memoize],c.prototype,"codeCachePath",null),Pe([i.memoize],c.prototype,"useCodeCache",null)}),define(le[257],ue([0,1,93,32,11,10,3,18,23,169,16,20,34,14,5,168,30,106]),function(j,e,i,s,y,k,A,R,S,c,m,u,p,v,f,h,E,b){"use strict";var g;Object.defineProperty(e,"__esModule",{value:!0}),e.BackupMainService=void 0;let I=class{static{g=this}static{this.backupWorkspacesMetadataStorageKey="backupWorkspaces"}constructor(r,a,t,o){this.environmentMainService=r,this.configurationService=a,this.logService=t,this.stateService=o,this.backupHome=this.environmentMainService.backupHome,this.workspaces=[],this.folders=[],this.emptyWindows=[],this.backupUriComparer=R.extUriBiasedIgnorePathCase,this.backupPathComparer={isEqual:(n,l)=>(0,s.isEqual)(n,l,!A.isLinux)}}async initialize(){const r=this.stateService.getItem(g.backupWorkspacesMetadataStorageKey)??{workspaces:[],folders:[],emptyWindows:[]};this.emptyWindows=await this.validateEmptyWorkspaces(r.emptyWindows),this.workspaces=await this.validateWorkspaces((0,c.deserializeWorkspaceInfos)(r)),this.folders=await this.validateFolders((0,c.deserializeFolderInfos)(r)),this.storeWorkspacesMetadata()}getWorkspaceBackups(){return this.isHotExitOnExitAndWindowClose()?[]:this.workspaces.slice(0)}getFolderBackups(){return this.isHotExitOnExitAndWindowClose()?[]:this.folders.slice(0)}isHotExitEnabled(){return this.getHotExitConfig()!==v.HotExitConfiguration.OFF}isHotExitOnExitAndWindowClose(){return this.getHotExitConfig()===v.HotExitConfiguration.ON_EXIT_AND_WINDOW_CLOSE}getHotExitConfig(){return this.configurationService.getValue()?.files?.hotExit||v.HotExitConfiguration.ON_EXIT}getEmptyWindowBackups(){return this.emptyWindows.slice(0)}registerWorkspaceBackup(r,a){this.workspaces.some(o=>r.workspace.id===o.workspace.id)||(this.workspaces.push(r),this.storeWorkspacesMetadata());const t=(0,k.join)(this.backupHome,r.workspace.id);return a?this.moveBackupFolder(t,a).then(()=>t):t}async moveBackupFolder(r,a){if(await S.Promises.exists(r)&&await this.convertToEmptyWindowBackup(r),await S.Promises.exists(a))try{await S.Promises.rename(a,r,!1)}catch(t){this.logService.error(`Backup: Could not move backup folder to new location: ${t.toString()}`)}}registerFolderBackup(r){return this.folders.some(a=>this.backupUriComparer.isEqual(r.folderUri,a.folderUri))||(this.folders.push(r),this.storeWorkspacesMetadata()),(0,k.join)(this.backupHome,this.getFolderHash(r))}registerEmptyWindowBackup(r){return this.emptyWindows.some(a=>!!a.backupFolder&&this.backupPathComparer.isEqual(a.backupFolder,r.backupFolder))||(this.emptyWindows.push(r),this.storeWorkspacesMetadata()),(0,k.join)(this.backupHome,r.backupFolder)}async validateWorkspaces(r){if(!Array.isArray(r))return[];const a=new Set,t=[];for(const o of r){const n=o.workspace;if(!(0,E.isWorkspaceIdentifier)(n))return[];if(!a.has(n.id)){a.add(n.id);const l=(0,k.join)(this.backupHome,n.id);await this.doHasBackups(l)?n.configPath.scheme!==y.Schemas.file||await S.Promises.exists(n.configPath.fsPath)?t.push(o):await this.convertToEmptyWindowBackup(l):await this.deleteStaleBackup(l)}}return t}async validateFolders(r){if(!Array.isArray(r))return[];const a=[],t=new Set;for(const o of r){const n=o.folderUri,l=this.backupUriComparer.getComparisonKey(n);if(!t.has(l)){t.add(l);const d=(0,k.join)(this.backupHome,this.getFolderHash(o));await this.doHasBackups(d)?n.scheme!==y.Schemas.file||await S.Promises.exists(n.fsPath)?a.push(o):await this.convertToEmptyWindowBackup(d):await this.deleteStaleBackup(d)}}return a}async validateEmptyWorkspaces(r){if(!Array.isArray(r))return[];const a=[],t=new Set;for(const o of r){const n=o.backupFolder;if(typeof n!="string")return[];if(!t.has(n)){t.add(n);const l=(0,k.join)(this.backupHome,n);await this.doHasBackups(l)?a.push(o):await this.deleteStaleBackup(l)}}return a}async deleteStaleBackup(r){try{await S.Promises.rm(r,S.RimRafMode.MOVE)}catch(a){this.logService.error(`Backup: Could not delete stale backup: ${a.toString()}`)}}prepareNewEmptyWindowBackup(){let r=(0,b.createEmptyWorkspaceIdentifier)();for(;this.emptyWindows.some(a=>!!a.backupFolder&&this.backupPathComparer.isEqual(a.backupFolder,r.id));)r=(0,b.createEmptyWorkspaceIdentifier)();return{backupFolder:r.id}}async convertToEmptyWindowBackup(r){const a=this.prepareNewEmptyWindowBackup(),t=(0,k.join)(this.backupHome,a.backupFolder);try{await S.Promises.rename(r,t,!1)}catch(o){return this.logService.error(`Backup: Could not rename backup folder: ${o.toString()}`),!1}return this.emptyWindows.push(a),!0}async getDirtyWorkspaces(){const r=[];for(const a of this.workspaces)await this.hasBackups(a)&&r.push(a);for(const a of this.folders)await this.hasBackups(a)&&r.push(a);return r}hasBackups(r){let a;return(0,c.isEmptyWindowBackupInfo)(r)?a=(0,k.join)(this.backupHome,r.backupFolder):(0,h.isFolderBackupInfo)(r)?a=(0,k.join)(this.backupHome,this.getFolderHash(r)):a=(0,k.join)(this.backupHome,r.workspace.id),this.doHasBackups(a)}async doHasBackups(r){try{const a=await S.Promises.readdir(r);for(const t of a)try{if((await S.Promises.readdir((0,k.join)(r,t))).length>0)return!0}catch{}}catch{}return!1}storeWorkspacesMetadata(){const r={workspaces:this.workspaces.map(({workspace:a,remoteAuthority:t})=>{const o={id:a.id,configURIPath:a.configPath.toString()};return t&&(o.remoteAuthority=t),o}),folders:this.folders.map(({folderUri:a,remoteAuthority:t})=>{const o={folderUri:a.toString()};return t&&(o.remoteAuthority=t),o}),emptyWindows:this.emptyWindows.map(({backupFolder:a,remoteAuthority:t})=>{const o={backupFolder:a};return t&&(o.remoteAuthority=t),o})};this.stateService.setItem(g.backupWorkspacesMetadataStorageKey,r)}getFolderHash(r){const a=r.folderUri;let t;return a.scheme===y.Schemas.file?t=A.isLinux?a.fsPath:a.fsPath.toLowerCase():t=a.toString().toLowerCase(),(0,i.createHash)("md5").update(t).digest("hex")}};e.BackupMainService=I,e.BackupMainService=I=g=Pe([re(0,u.IEnvironmentMainService),re(1,m.IConfigurationService),re(2,f.ILogService),re(3,p.IStateService)],I)});var je=this&&this.__importDefault||function(j){return j&&j.__esModule?j:{default:j}};define(le[19],ue([0,1,13,35,8,4,2,3,38,12,6,5,34,52,20]),function(j,e,i,s,y,k,A,R,S,c,m,u,p,v,f){"use strict";var h;Object.defineProperty(e,"__esModule",{value:!0}),e.LifecycleMainService=e.LifecycleMainPhase=e.ShutdownReason=e.ILifecycleMainService=void 0,i=je(i),e.ILifecycleMainService=(0,m.createDecorator)("lifecycleMainService");var E;(function(I){I[I.QUIT=1]="QUIT",I[I.KILL=2]="KILL"})(E||(e.ShutdownReason=E={}));var b;(function(I){I[I.Starting=1]="Starting",I[I.Ready=2]="Ready",I[I.AfterWindowOpen=3]="AfterWindowOpen",I[I.Eventually=4]="Eventually"})(b||(e.LifecycleMainPhase=b={}));let g=class extends A.Disposable{static{h=this}static{this.QUIT_AND_RESTART_KEY="lifecycle.quitAndRestart"}get quitRequested(){return this._quitRequested}get wasRestarted(){return this._wasRestarted}get phase(){return this._phase}constructor(P,r,a){super(),this.logService=P,this.stateService=r,this.environmentMainService=a,this._onBeforeShutdown=this._register(new k.Emitter),this.onBeforeShutdown=this._onBeforeShutdown.event,this._onWillShutdown=this._register(new k.Emitter),this.onWillShutdown=this._onWillShutdown.event,this._onWillLoadWindow=this._register(new k.Emitter),this.onWillLoadWindow=this._onWillLoadWindow.event,this._onBeforeCloseWindow=this._register(new k.Emitter),this.onBeforeCloseWindow=this._onBeforeCloseWindow.event,this._quitRequested=!1,this._wasRestarted=!1,this._phase=b.Starting,this.windowToCloseRequest=new Set,this.oneTimeListenerTokenGenerator=0,this.windowCounter=0,this.pendingQuitPromise=void 0,this.pendingQuitPromiseResolve=void 0,this.pendingWillShutdownPromise=void 0,this.mapWindowIdToPendingUnload=new Map,this.phaseWhen=new Map,this.relaunchHandler=void 0,this.resolveRestarted(),this.when(b.Ready).then(()=>this.registerListeners())}resolveRestarted(){this._wasRestarted=!!this.stateService.getItem(h.QUIT_AND_RESTART_KEY),this._wasRestarted&&this.stateService.removeItem(h.QUIT_AND_RESTART_KEY)}registerListeners(){const P=()=>{this._quitRequested||(this.trace("Lifecycle#app.on(before-quit)"),this._quitRequested=!0,this.trace("Lifecycle#onBeforeShutdown.fire()"),this._onBeforeShutdown.fire(),R.isMacintosh&&this.windowCounter===0&&this.fireOnWillShutdown(E.QUIT))};i.default.app.addListener("before-quit",P);const r=()=>{this.trace("Lifecycle#app.on(window-all-closed)"),(this._quitRequested||!R.isMacintosh)&&i.default.app.quit()};i.default.app.addListener("window-all-closed",r),i.default.app.once("will-quit",a=>{this.trace("Lifecycle#app.on(will-quit) - begin"),a.preventDefault(),this.fireOnWillShutdown(E.QUIT).finally(()=>{this.trace("Lifecycle#app.on(will-quit) - after fireOnWillShutdown"),this.resolvePendingQuitPromise(!1),i.default.app.removeListener("before-quit",P),i.default.app.removeListener("window-all-closed",r),this.trace("Lifecycle#app.on(will-quit) - calling app.quit()"),i.default.app.quit()})})}fireOnWillShutdown(P){if(this.pendingWillShutdownPromise)return this.pendingWillShutdownPromise;const r=this.logService;this.trace("Lifecycle#onWillShutdown.fire()");const a=[];return this._onWillShutdown.fire({reason:P,join(t,o){r.trace(`Lifecycle#onWillShutdown - begin '${t}'`),a.push(o.finally(()=>{r.trace(`Lifecycle#onWillShutdown - end '${t}'`)}))}}),this.pendingWillShutdownPromise=(async()=>{try{await y.Promises.settled(a)}catch(t){this.logService.error(t)}try{await this.stateService.close()}catch(t){this.logService.error(t)}})(),this.pendingWillShutdownPromise}set phase(P){if(P<this.phase)throw new Error("Lifecycle cannot go backwards");if(this._phase===P)return;this.trace(`lifecycle (main): phase changed (value: ${P})`),this._phase=P;const r=this.phaseWhen.get(this._phase);r&&(r.open(),this.phaseWhen.delete(this._phase))}async when(P){if(P<=this._phase)return;let r=this.phaseWhen.get(P);r||(r=new y.Barrier,this.phaseWhen.set(P,r)),await r.wait()}registerWindow(P){const r=new A.DisposableStore;this.windowCounter++,r.add(P.onWillLoad(t=>this._onWillLoadWindow.fire({window:P,workspace:t.workspace,reason:t.reason})));const a=(0,c.assertIsDefined)(P.win);r.add(k.Event.fromNodeEventEmitter(a,"close")(t=>{const o=P.id;if(this.windowToCloseRequest.has(o)){this.windowToCloseRequest.delete(o);return}this.trace(`Lifecycle#window.on('close') - window ID ${P.id}`),t.preventDefault(),this.unload(P,v.UnloadReason.CLOSE).then(n=>{if(n){this.windowToCloseRequest.delete(o);return}this.windowToCloseRequest.add(o),this.trace(`Lifecycle#onBeforeCloseWindow.fire() - window ID ${o}`),this._onBeforeCloseWindow.fire(P),P.close()})})),r.add(k.Event.fromNodeEventEmitter(a,"closed")(()=>{this.trace(`Lifecycle#window.on('closed') - window ID ${P.id}`),this.windowCounter--,r.dispose(),this.windowCounter===0&&(!R.isMacintosh||this._quitRequested)&&this.fireOnWillShutdown(E.QUIT)}))}registerAuxWindow(P){const r=(0,c.assertIsDefined)(P.win),a=new A.DisposableStore;a.add(k.Event.fromNodeEventEmitter(r,"close")(t=>{this.trace(`Lifecycle#auxWindow.on('close') - window ID ${P.id}`),this._quitRequested&&(this.trace("Lifecycle#auxWindow.on('close') - preventDefault() because quit requested"),t.preventDefault())})),a.add(k.Event.fromNodeEventEmitter(r,"closed")(()=>{this.trace(`Lifecycle#auxWindow.on('closed') - window ID ${P.id}`),a.dispose()}))}async reload(P,r){await this.unload(P,v.UnloadReason.RELOAD)||P.reload(r)}unload(P,r){const a=this.mapWindowIdToPendingUnload.get(P.id);if(a)return a;const t=this.doUnload(P,r).finally(()=>{this.mapWindowIdToPendingUnload.delete(P.id)});return this.mapWindowIdToPendingUnload.set(P.id,t),t}async doUnload(P,r){if(!P.isReady)return!1;this.trace(`Lifecycle#unload() - window ID ${P.id}`);const a=this._quitRequested?v.UnloadReason.QUIT:r,t=await this.onBeforeUnloadWindowInRenderer(P,a);return t?(this.trace(`Lifecycle#unload() - veto in renderer (window ID ${P.id})`),this.handleWindowUnloadVeto(t)):(await this.onWillUnloadWindowInRenderer(P,a),!1)}handleWindowUnloadVeto(P){return P?(this.resolvePendingQuitPromise(!0),this._quitRequested=!1,!0):!1}resolvePendingQuitPromise(P){this.pendingQuitPromiseResolve&&(this.pendingQuitPromiseResolve(P),this.pendingQuitPromiseResolve=void 0,this.pendingQuitPromise=void 0)}onBeforeUnloadWindowInRenderer(P,r){return new Promise(a=>{const t=this.oneTimeListenerTokenGenerator++,o=`vscode:ok${t}`,n=`vscode:cancel${t}`;s.validatedIpcMain.once(o,()=>{a(!1)}),s.validatedIpcMain.once(n,()=>{a(!0)}),P.send("vscode:onBeforeUnload",{okChannel:o,cancelChannel:n,reason:r})})}onWillUnloadWindowInRenderer(P,r){return new Promise(a=>{const o=`vscode:reply${this.oneTimeListenerTokenGenerator++}`;s.validatedIpcMain.once(o,()=>a()),P.send("vscode:onWillUnload",{replyChannel:o,reason:r})})}quit(P){return this.doQuit(P).then(r=>{if(!r&&P)try{if(R.isWindows){const a=(0,S.cwd)();a!==process.cwd()&&process.chdir(a)}}catch(a){this.logService.error(a)}return r})}doQuit(P){return this.trace(`Lifecycle#quit() - begin (willRestart: ${P})`),this.pendingQuitPromise?(this.trace("Lifecycle#quit() - returning pending quit promise"),this.pendingQuitPromise):(P&&this.stateService.setItem(h.QUIT_AND_RESTART_KEY,!0),this.pendingQuitPromise=new Promise(r=>{this.pendingQuitPromiseResolve=r,this.trace("Lifecycle#quit() - calling app.quit()"),i.default.app.quit()}),this.pendingQuitPromise)}trace(P){this.environmentMainService.args["enable-smoke-test-driver"]?this.logService.info(P):this.logService.trace(P)}setRelaunchHandler(P){this.relaunchHandler=P}async relaunch(P){this.trace("Lifecycle#relaunch()");const r=process.argv.slice(1);if(P?.addArgs&&r.push(...P.addArgs),P?.removeArgs)for(const o of P.removeArgs){const n=r.indexOf(o);n>=0&&r.splice(n,1)}const a=()=>{this.relaunchHandler?.handleRelaunch(P)||(this.trace("Lifecycle#relaunch() - calling app.relaunch()"),i.default.app.relaunch({args:r}))};i.default.app.once("quit",a),await this.quit(!0)&&i.default.app.removeListener("quit",a)}async kill(P){this.trace("Lifecycle#kill()"),await this.fireOnWillShutdown(E.KILL),await Promise.race([(0,y.timeout)(1e3),(async()=>{for(const r of i.default.BrowserWindow.getAllWindows())if(r&&!r.isDestroyed()){let a;r.webContents&&!r.webContents.isDestroyed()?a=new Promise(t=>r.once("closed",t)):a=Promise.resolve(),r.destroy(),await a}})()]),i.default.app.exit(P)}};e.LifecycleMainService=g,e.LifecycleMainService=g=h=Pe([re(0,u.ILogService),re(1,p.IStateService),re(2,f.IEnvironmentMainService)],g)}),define(le[258],ue([0,1,3,4,2,6,19]),function(j,e,i,s,y,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeyboardLayoutMainService=e.IKeyboardLayoutMainService=void 0,i=Re(i),e.IKeyboardLayoutMainService=(0,k.createDecorator)("keyboardLayoutMainService");let R=class extends y.Disposable{constructor(m){super(),this._onDidChangeKeyboardLayout=this._register(new s.Emitter),this.onDidChangeKeyboardLayout=this._onDidChangeKeyboardLayout.event,this._initPromise=null,this._keyboardLayoutData=null,m.when(A.LifecycleMainPhase.AfterWindowOpen).then(()=>this._initialize())}_initialize(){return this._initPromise||(this._initPromise=this._doInitialize()),this._initPromise}async _doInitialize(){const m=await new Promise((u,p)=>{j(["native-keymap"],u,p)}).then(Re);this._keyboardLayoutData=S(m),i.isCI||m.onDidChangeKeyboardLayout(()=>{this._keyboardLayoutData=S(m),this._onDidChangeKeyboardLayout.fire(this._keyboardLayoutData)})}async getKeyboardLayoutData(){return await this._initialize(),this._keyboardLayoutData}};e.KeyboardLayoutMainService=R,e.KeyboardLayoutMainService=R=Pe([re(0,A.ILifecycleMainService)],R);function S(c){const m=c.getKeyMap(),u=c.getCurrentKeyboardLayout();return{keyboardMapping:m,keyboardLayoutInfo:u}}}),define(le[259],ue([0,1,219,8,17,15,12,16,36,103,5,50,218,256]),function(j,e,i,s,y,k,A,R,S,c,m,u,p,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0,e.nodeRequest=E;let f=class extends u.AbstractRequestService{constructor(g,I,P,r){super(r),this.configurationService=g,this.environmentService=I,this.logService=P,this.configure(),this._register(g.onDidChangeConfiguration(a=>{a.affectsConfiguration("http")&&this.configure()}))}configure(){const g=this.configurationService.getValue("http");this.proxyUrl=g?.proxy,this.strictSSL=!!g?.proxyStrictSSL,this.authorization=g?.proxyAuthorization}async request(g,I){const{proxyUrl:P,strictSSL:r}=this;let a;try{a=await(0,c.getResolvedShellEnv)(this.configurationService,this.logService,this.environmentService.args,process.env)}catch(n){this.shellEnvErrorLogged||(this.shellEnvErrorLogged=!0,this.logService.error("resolving shell environment failed",(0,k.getErrorMessage)(n)))}const t={...process.env,...a},o=g.agent?g.agent:await(0,p.getProxyAgent)(g.url||"",t,{proxyUrl:P,strictSSL:r});return g.agent=o,g.strictSSL=r,this.authorization&&(g.headers={...g.headers||{},"Proxy-Authorization":this.authorization}),this.logAndRequest(g.isChromiumNetwork?"electron":"node",g,()=>E(g,I))}async resolveProxy(g){}async lookupAuthorization(g){}async lookupKerberosAuthorization(g){try{const I=await new Promise((o,n)=>{j(["kerberos"],o,n)}).then(Re),P=new URL(g),r=this.configurationService.getValue("http.proxyKerberosServicePrincipal")||(process.platform==="win32"?`HTTP/${P.hostname}`:`HTTP@${P.hostname}`);return this.logService.debug("RequestService#lookupKerberosAuthorization Kerberos authentication lookup",`proxyURL:${P}`,`spn:${r}`),"Negotiate "+await(await I.initializeClient(r)).step("")}catch(I){this.logService.debug("RequestService#lookupKerberosAuthorization Kerberos authentication failed",I);return}}async loadCertificates(){return(await new Promise((I,P)=>{j(["@vscode/proxy-agent"],I,P)}).then(Re)).loadSystemCertificates({log:this.logService})}};e.RequestService=f,e.RequestService=f=Pe([re(0,R.IConfigurationService),re(1,S.INativeEnvironmentService),re(2,m.ILogService),re(3,m.ILoggerService)],f);async function h(b){return((0,i.parse)(b.url).protocol==="https:"?await new Promise((P,r)=>{j(["https"],P,r)}).then(Re):await new Promise((P,r)=>{j(["http"],P,r)}).then(Re)).request}async function E(b,g){return s.Promises.withAsyncBody(async(I,P)=>{const r=(0,i.parse)(b.url),a=b.getRawRequest?b.getRawRequest(b):await h(b),t={hostname:r.hostname,port:r.port?parseInt(r.port):r.protocol==="https:"?443:80,protocol:r.protocol,path:r.path,method:b.type||"GET",headers:b.headers,agent:b.agent,rejectUnauthorized:(0,A.isBoolean)(b.strictSSL)?b.strictSSL:!0};b.user&&b.password&&(t.auth=b.user+":"+b.password);const o=a(t,n=>{const l=(0,A.isNumber)(b.followRedirects)?b.followRedirects:3;if(n.statusCode&&n.statusCode>=300&&n.statusCode<400&&l>0&&n.headers.location)E({...b,url:n.headers.location,followRedirects:l-1},g).then(I,P);else{let d=n;!b.isChromiumNetwork&&n.headers["content-encoding"]==="gzip"&&(d=n.pipe((0,v.createGunzip)())),I({res:n,stream:(0,y.streamToBufferReadableStream)(d)})}});o.on("error",P),b.timeout&&o.setTimeout(b.timeout),b.isChromiumNetwork&&o.removeHeader("Content-Length"),b.data&&typeof b.data=="string"&&o.write(b.data),o.end(),g.onCancellationRequested(()=>{o.abort(),P(new k.CancellationError)})})}}),define(le[260],ue([0,1,13,259]),function(j,e,i,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestMainService=void 0;function y(A){return i.net.request}class k extends s.RequestService{request(R,S){return super.request({...R||{},getRawRequest:y,isChromiumNetwork:!0},S)}}e.RequestMainService=k}),define(le[89],ue([0,1,7,4,2,36,14,6,19,5,63,253,42,58,41,11]),function(j,e,i,s,y,k,A,R,S,c,m,u,p,v,f,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplicationStorageMainService=e.IApplicationStorageMainService=e.StorageMainService=e.IStorageMainService=void 0,e.IStorageMainService=(0,R.createDecorator)("storageMainService");let E=class extends y.Disposable{constructor(I,P,r,a,t,o){super(),this.logService=I,this.environmentService=P,this.userDataProfilesService=r,this.lifecycleMainService=a,this.fileService=t,this.uriIdentityService=o,this.shutdownReason=void 0,this._onDidChangeProfileStorage=this._register(new s.Emitter),this.onDidChangeProfileStorage=this._onDidChangeProfileStorage.event,this.applicationStorage=this._register(this.createApplicationStorage()),this.mapProfileToStorage=new Map,this.mapWorkspaceToStorage=new Map,this.registerListeners()}getStorageOptions(){return{useInMemoryStorage:!!this.environmentService.extensionTestsLocationURI}}registerListeners(){(async()=>(await this.lifecycleMainService.when(S.LifecycleMainPhase.AfterWindowOpen),this.applicationStorage.init()))(),this._register(this.lifecycleMainService.onWillLoadWindow(I=>{I.window.profile&&this.profileStorage(I.window.profile).init(),I.workspace&&this.workspaceStorage(I.workspace).init()})),this._register(this.lifecycleMainService.onWillShutdown(I=>{this.logService.trace("storageMainService#onWillShutdown()"),this.shutdownReason=I.reason,I.join("applicationStorage",this.applicationStorage.close());for(const[,P]of this.mapProfileToStorage)I.join("profileStorage",P.close());for(const[,P]of this.mapWorkspaceToStorage)I.join("workspaceStorage",P.close())})),this._register(this.userDataProfilesService.onWillCreateProfile(I=>{I.join((async()=>{await this.fileService.exists(I.profile.globalStorageHome)||await this.fileService.createFolder(I.profile.globalStorageHome)})())})),this._register(this.userDataProfilesService.onWillRemoveProfile(I=>{const P=this.mapProfileToStorage.get(I.profile.id);P&&I.join(P.close())}))}createApplicationStorage(){this.logService.trace("StorageMainService: creating application storage");const I=new u.ApplicationStorageMain(this.getStorageOptions(),this.userDataProfilesService,this.logService,this.fileService);return this._register(s.Event.once(I.onDidCloseStorage)(()=>{this.logService.trace("StorageMainService: closed application storage")})),I}profileStorage(I){if((0,m.isProfileUsingDefaultStorage)(I))return this.applicationStorage;let P=this.mapProfileToStorage.get(I.id);if(!P){this.logService.trace(`StorageMainService: creating profile storage (${I.name})`),P=this._register(this.createProfileStorage(I)),this.mapProfileToStorage.set(I.id,P);const r=this._register(P.onDidChangeStorage(a=>this._onDidChangeProfileStorage.fire({...a,storage:P,profile:I})));this._register(s.Event.once(P.onDidCloseStorage)(()=>{this.logService.trace(`StorageMainService: closed profile storage (${I.name})`),this.mapProfileToStorage.delete(I.id),r.dispose()}))}return P}createProfileStorage(I){return this.shutdownReason===S.ShutdownReason.KILL?new u.InMemoryStorageMain(this.logService,this.fileService):new u.ProfileStorageMain(I,this.getStorageOptions(),this.logService,this.fileService)}workspaceStorage(I){let P=this.mapWorkspaceToStorage.get(I.id);return P||(this.logService.trace(`StorageMainService: creating workspace storage (${I.id})`),P=this._register(this.createWorkspaceStorage(I)),this.mapWorkspaceToStorage.set(I.id,P),this._register(s.Event.once(P.onDidCloseStorage)(()=>{this.logService.trace(`StorageMainService: closed workspace storage (${I.id})`),this.mapWorkspaceToStorage.delete(I.id)}))),P}createWorkspaceStorage(I){return this.shutdownReason===S.ShutdownReason.KILL?new u.InMemoryStorageMain(this.logService,this.fileService):new u.WorkspaceStorageMain(I,this.getStorageOptions(),this.logService,this.environmentService,this.fileService)}isUsed(I){const P=i.URI.file(I);for(const r of[this.applicationStorage,...this.mapProfileToStorage.values(),...this.mapWorkspaceToStorage.values()])if(r.path&&this.uriIdentityService.extUri.isEqualOrParent(i.URI.file(r.path),P))return!0;return!1}};e.StorageMainService=E,e.StorageMainService=E=Pe([re(0,c.ILogService),re(1,k.IEnvironmentService),re(2,v.IUserDataProfilesMainService),re(3,S.ILifecycleMainService),re(4,A.IFileService),re(5,f.IUriIdentityService)],E),e.IApplicationStorageMainService=(0,R.createDecorator)("applicationStorageMainService");let b=class extends m.AbstractStorageService{constructor(I,P){super(),this.userDataProfilesService=I,this.storageMainService=P,this.whenReady=this.storageMainService.applicationStorage.whenInit}doInitialize(){return this.storageMainService.applicationStorage.whenInit}getStorage(I){if(I===m.StorageScope.APPLICATION)return this.storageMainService.applicationStorage.storage}getLogDetails(I){if(I===m.StorageScope.APPLICATION)return this.userDataProfilesService.defaultProfile.globalStorageHome.with({scheme:h.Schemas.file}).fsPath}shouldFlushWhenIdle(){return!1}switch(){throw new Error("Migrating storage is unsupported from main process")}switchToProfile(){throw new Error("Switching storage profile is unsupported from main process")}switchToWorkspace(){throw new Error("Switching storage workspace is unsupported from main process")}hasScope(){throw new Error("Main process is never profile or workspace scoped")}};e.ApplicationStorageMainService=b,e.ApplicationStorageMainService=b=Pe([re(0,p.IUserDataProfilesService),re(1,e.IStorageMainService)],b)}),define(le[261],ue([0,1,94,27,114,107,8,2,3,16,5,28,212,215,104,134,17]),function(j,e,i,s,y,k,A,R,S,c,m,u,p,v,f,h,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedTunnelsService=e.TunnelService=e.BaseTunnelService=e.NodeRemoteTunnel=void 0,i=Re(i),s=Re(s);async function b(a,t,o,n,l){let d;for(let D=3;D&&(d?.dispose(),d=await new g(a,t,o,n,l).waitForReady(),!(l&&y.BROWSER_RESTRICTED_PORTS[l]||!y.BROWSER_RESTRICTED_PORTS[d.tunnelLocalPort]));D--);return d}class g extends R.Disposable{constructor(t,o,n,l,d){super(),this.defaultTunnelHost=o,this.suggestedLocalPort=d,this.privacy=h.TunnelPrivacyId.Private,this._socketsDispose=new Map,this._options=t,this._server=i.createServer(),this._barrier=new A.Barrier,this._listeningListener=()=>this._barrier.open(),this._server.on("listening",this._listeningListener),this._connectionListener=D=>this._onConnection(D),this._server.on("connection",this._connectionListener),this._errorListener=()=>{},this._server.on("error",this._errorListener),this.tunnelRemotePort=l,this.tunnelRemoteHost=n}async dispose(){super.dispose(),this._server.removeListener("listening",this._listeningListener),this._server.removeListener("connection",this._connectionListener),this._server.removeListener("error",this._errorListener),this._server.close(),Array.from(this._socketsDispose.values()).forEach(o=>{o()})}async waitForReady(){const t=this.suggestedLocalPort??this.tunnelRemotePort,o=(0,h.isAllInterfaces)(this.defaultTunnelHost)?"0.0.0.0":"127.0.0.1";let n=await(0,y.findFreePortFaster)(t,2,1e3,o),l=null;return this._server.listen(n,this.defaultTunnelHost),await this._barrier.wait(),l=this._server.address(),l||(n=0,this._server.listen(n,this.defaultTunnelHost),await this._barrier.wait(),l=this._server.address()),this.tunnelLocalPort=l.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${l.port}`,this}async _onConnection(t){t.pause();const o=(0,h.isLocalhost)(this.tunnelRemoteHost)||(0,h.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,n=await(0,p.connectRemoteAgentTunnel)(this._options,o,this.tunnelRemotePort),l=n.getSocket(),d=n.readEntireBuffer();n.dispose(),d.byteLength>0&&t.write(d.buffer),t.on("end",()=>{t.localAddress&&this._socketsDispose.delete(t.localAddress),l.end()}),t.on("close",()=>l.end()),t.on("error",()=>{t.localAddress&&this._socketsDispose.delete(t.localAddress),l instanceof k.NodeSocket?l.socket.destroy():l.end()}),l instanceof k.NodeSocket?this._mirrorNodeSocket(t,l):this._mirrorGenericSocket(t,l),t.localAddress&&this._socketsDispose.set(t.localAddress,()=>{t.end(),l.end()})}_mirrorGenericSocket(t,o){o.onClose(()=>t.destroy()),o.onEnd(()=>t.end()),o.onData(n=>t.write(n.buffer)),t.on("data",n=>o.write(E.VSBuffer.wrap(n))),t.resume()}_mirrorNodeSocket(t,o){const n=o.socket;n.on("end",()=>t.end()),n.on("close",()=>t.end()),n.on("error",()=>{t.destroy()}),n.pipe(t),t.pipe(n)}}e.NodeRemoteTunnel=g;let I=class extends h.AbstractTunnelService{constructor(t,o,n,l,d){super(o,d),this.remoteSocketFactoryService=t,this.signService=n,this.productService=l}isPortPrivileged(t){return(0,h.isPortPrivileged)(t,this.defaultTunnelHost,S.OS,s.release())}retainOrCreateTunnel(t,o,n,l,d,D,w,M){const T=this.getTunnelFromMap(o,n);if(T)return++T.refcount,T.value;if((0,h.isTunnelProvider)(t))return this.createWithProvider(t,o,n,d,D,w,M);{this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${o}:${n} on local port ${d}.`);const C={commit:this.productService.commit,quality:this.productService.quality,addressProvider:t,remoteSocketFactoryService:this.remoteSocketFactoryService,signService:this.signService,logService:this.logService,ipcLogger:null},L=b(C,l,o,n,d);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.addTunnelToMap(o,n,L),L}}};e.BaseTunnelService=I,e.BaseTunnelService=I=Pe([re(0,v.IRemoteSocketFactoryService),re(1,m.ILogService),re(2,f.ISignService),re(3,u.IProductService),re(4,c.IConfigurationService)],I);let P=class extends I{constructor(t,o,n,l,d){super(t,o,n,l,d)}};e.TunnelService=P,e.TunnelService=P=Pe([re(0,v.IRemoteSocketFactoryService),re(1,m.ILogService),re(2,f.ISignService),re(3,u.IProductService),re(4,c.IConfigurationService)],P);let r=class extends R.Disposable{constructor(t,o,n,l,d){super(),this.remoteSocketFactoryService=t,this.logService=o,this.productService=n,this.signService=l,this.configurationService=d,this._tunnelServices=new Map}async openTunnel(t,o,n,l,d,D,w,M,T){if(this.logService.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${n}:${l} on local port ${D}.`),!this._tunnelServices.has(t)){const C=new P(this.remoteSocketFactoryService,this.logService,this.signService,this.productService,this.configurationService);this._register(C),this._tunnelServices.set(t,C),C.onTunnelClosed(async()=>{(await C.tunnels).length===0&&(C.dispose(),this._tunnelServices.delete(t))})}return this._tunnelServices.get(t).openTunnel(o,n,l,d,D,w,M,T)}};e.SharedTunnelsService=r,e.SharedTunnelsService=r=Pe([re(0,v.IRemoteSocketFactoryService),re(1,m.ILogService),re(2,u.IProductService),re(3,f.ISignService),re(4,c.IConfigurationService)],r)}),define(le[108],ue([0,1,8,22,4,16,20,19,5,28,50,51]),function(j,e,i,s,y,k,A,R,S,c,m,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractUpdateService=void 0,e.createUpdateURL=p;function p(f,h,E){return`${E.updateUrl}/api/update/${f}/${h}/${E.commit}`}let v=class{get state(){return this._state}setState(h){this.logService.info("update#setState",h.type),this._state=h,this._onStateChange.fire(h)}constructor(h,E,b,g,I,P){this.lifecycleMainService=h,this.configurationService=E,this.environmentMainService=b,this.requestService=g,this.logService=I,this.productService=P,this._state=u.State.Uninitialized,this._onStateChange=new y.Emitter,this.onStateChange=this._onStateChange.event,h.when(R.LifecycleMainPhase.AfterWindowOpen).finally(()=>this.initialize())}async initialize(){if(!this.environmentMainService.isBuilt){this.setState(u.State.Disabled(u.DisablementReason.NotBuilt));return}if(this.environmentMainService.disableUpdates){this.setState(u.State.Disabled(u.DisablementReason.DisabledByEnvironment)),this.logService.info("update#ctor - updates are disabled by the environment");return}if(!this.productService.updateUrl||!this.productService.commit){this.setState(u.State.Disabled(u.DisablementReason.MissingConfiguration)),this.logService.info("update#ctor - updates are disabled as there is no update URL");return}const h=this.configurationService.getValue("update.mode"),E=this.getProductQuality(h);if(!E){this.setState(u.State.Disabled(u.DisablementReason.ManuallyDisabled)),this.logService.info("update#ctor - updates are disabled by user preference");return}if(this.url=this.buildUpdateFeedUrl(E),!this.url){this.setState(u.State.Disabled(u.DisablementReason.InvalidConfiguration)),this.logService.info("update#ctor - updates are disabled as the update URL is badly formed");return}if(this.configurationService.getValue("_update.prss")){const b=new URL(this.url);b.searchParams.set("prss","true"),this.url=b.toString()}if(this.setState(u.State.Idle(this.getUpdateType())),h==="manual"){this.logService.info("update#ctor - manual checks only; automatic updates are disabled by user preference");return}h==="start"?(this.logService.info("update#ctor - startup checks only; automatic updates are disabled by user preference"),setTimeout(()=>this.checkForUpdates(!1),30*1e3)):this.scheduleCheckForUpdates(30*1e3).then(void 0,b=>this.logService.error(b))}getProductQuality(h){return h==="none"?void 0:this.productService.quality}scheduleCheckForUpdates(h=60*60*1e3){return(0,i.timeout)(h).then(()=>this.checkForUpdates(!1)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(h){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type===u.StateType.Idle&&this.doCheckForUpdates(h)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type===u.StateType.AvailableForDownload&&await this.doDownloadUpdate(this.state)}async doDownloadUpdate(h){}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type===u.StateType.Downloaded&&await this.doApplyUpdate()}async doApplyUpdate(){}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!==u.StateType.Ready||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(h=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${h}`),!h&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}async isLatestVersion(){if(!this.url)return;if(this.configurationService.getValue("update.mode")==="none")return!1;try{return(await this.requestService.request({url:this.url},s.CancellationToken.None)).res.statusCode===204}catch(E){this.logService.error("update#isLatestVersion(): failed to check for updates"),this.logService.error(E);return}}async _applySpecificUpdate(h){}getUpdateType(){return u.UpdateType.Archive}doQuitAndInstall(){}};e.AbstractUpdateService=v,e.AbstractUpdateService=v=Pe([re(0,R.ILifecycleMainService),re(1,k.IConfigurationService),re(2,A.IEnvironmentMainService),re(3,m.IRequestService),re(4,S.ILogService),re(5,c.IProductService)],v)}),define(le[262],ue([0,1,13,54,4,48,2,16,20,19,5,28,50,24,51,108]),function(j,e,i,s,y,k,A,R,S,c,m,u,p,v,f,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DarwinUpdateService=void 0,i=Re(i);let E=class extends h.AbstractUpdateService{get onRawError(){return y.Event.fromNodeEventEmitter(i.autoUpdater,"error",(g,I)=>I)}get onRawUpdateNotAvailable(){return y.Event.fromNodeEventEmitter(i.autoUpdater,"update-not-available")}get onRawUpdateAvailable(){return y.Event.fromNodeEventEmitter(i.autoUpdater,"update-available")}get onRawUpdateDownloaded(){return y.Event.fromNodeEventEmitter(i.autoUpdater,"update-downloaded",(g,I,P,r)=>({version:P,productVersion:P,timestamp:r}))}constructor(g,I,P,r,a,t,o){super(g,I,r,a,t,o),this.telemetryService=P,this.disposables=new A.DisposableStore,g.setRelaunchHandler(this)}handleRelaunch(g){return g?.addArgs||g?.removeArgs||this.state.type!==f.StateType.Ready?!1:(this.logService.trace("update#handleRelaunch(): running raw#quitAndInstall()"),this.doQuitAndInstall(),!0)}async initialize(){await super.initialize(),this.onRawError(this.onError,this,this.disposables),this.onRawUpdateAvailable(this.onUpdateAvailable,this,this.disposables),this.onRawUpdateDownloaded(this.onUpdateDownloaded,this,this.disposables),this.onRawUpdateNotAvailable(this.onUpdateNotAvailable,this,this.disposables)}onError(g){this.telemetryService.publicLog2("update:error",{messageHash:String((0,k.hash)(String(g)))}),this.logService.error("UpdateService error:",g);const I=this.state.type===f.StateType.CheckingForUpdates&&this.state.explicit?g:void 0;this.setState(f.State.Idle(f.UpdateType.Archive,I))}buildUpdateFeedUrl(g){let I;this.productService.darwinUniversalAssetId?I=this.productService.darwinUniversalAssetId:I=process.arch==="x64"?"darwin":"darwin-arm64";const P=(0,h.createUpdateURL)(I,g,this.productService);try{i.autoUpdater.setFeedURL({url:P})}catch(r){this.logService.error("Failed to set update feed URL",r);return}return P}doCheckForUpdates(g){this.setState(f.State.CheckingForUpdates(g)),i.autoUpdater.checkForUpdates()}onUpdateAvailable(){this.state.type===f.StateType.CheckingForUpdates&&this.setState(f.State.Downloading)}onUpdateDownloaded(g){this.state.type===f.StateType.Downloading&&(this.setState(f.State.Downloaded(g)),this.telemetryService.publicLog2("update:downloaded",{version:g.version}),this.setState(f.State.Ready(g)))}onUpdateNotAvailable(){this.state.type===f.StateType.CheckingForUpdates&&(this.telemetryService.publicLog2("update:notAvailable",{explicit:this.state.explicit}),this.setState(f.State.Idle(f.UpdateType.Archive)))}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),i.autoUpdater.quitAndInstall()}dispose(){this.disposables.dispose()}};e.DarwinUpdateService=E,Pe([s.memoize],E.prototype,"onRawError",null),Pe([s.memoize],E.prototype,"onRawUpdateNotAvailable",null),Pe([s.memoize],E.prototype,"onRawUpdateAvailable",null),Pe([s.memoize],E.prototype,"onRawUpdateDownloaded",null),e.DarwinUpdateService=E=Pe([re(0,c.ILifecycleMainService),re(1,R.IConfigurationService),re(2,v.ITelemetryService),re(3,S.IEnvironmentMainService),re(4,p.IRequestService),re(5,m.ILogService),re(6,u.IProductService)],E)}),define(le[263],ue([0,1,44,26,8,4,10,20,19,5,24,51]),function(j,e,i,s,y,k,A,R,S,c,m,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnapUpdateService=void 0,A=Re(A);let p=class{get state(){return this._state}setState(h){this.logService.info("update#setState",h.type),this._state=h,this._onStateChange.fire(h)}constructor(h,E,b){if(this.lifecycleMainService=h,this.logService=b,this._state=u.State.Uninitialized,this._onStateChange=new k.Emitter,this.onStateChange=this._onStateChange.event,E.disableUpdates){this.logService.info("update#ctor - updates are disabled");return}this.setState(u.State.Idle(this.getUpdateType())),this.scheduleCheckForUpdates(30*1e3).then(void 0,g=>this.logService.error(g))}scheduleCheckForUpdates(h=60*60*1e3){return(0,y.timeout)(h).then(()=>this.checkForUpdates(!1)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(h){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type===u.StateType.Idle&&this.doCheckForUpdates(h)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type===u.StateType.AvailableForDownload&&await this.doDownloadUpdate(this.state)}doDownloadUpdate(h){return Promise.resolve(void 0)}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type===u.StateType.Downloaded&&await this.doApplyUpdate()}doApplyUpdate(){return Promise.resolve(void 0)}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!==u.StateType.Ready||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(h=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${h}`),!h&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}getUpdateType(){return u.UpdateType.Snap}doQuitAndInstall(){}async _applySpecificUpdate(h){}};p=Pe([re(0,S.ILifecycleMainService),re(1,R.IEnvironmentMainService),re(2,c.ILogService)],p);let v=class extends p{constructor(h,E,b,g,I,P){super(b,g,I),this.snap=h,this.snapRevision=E,this.telemetryService=P;const r=(0,s.watch)(A.dirname(this.snap)),a=k.Event.fromNodeEventEmitter(r,"change",(l,d)=>d),t=k.Event.filter(a,l=>l==="current"),n=k.Event.debounce(t,(l,d)=>d,2e3)(()=>this.checkForUpdates(!1));b.onWillShutdown(()=>{n.dispose(),r.close()})}doCheckForUpdates(){this.setState(u.State.CheckingForUpdates(!1)),this.isUpdateAvailable().then(h=>{h?this.setState(u.State.Ready({version:"something"})):(this.telemetryService.publicLog2("update:notAvailable",{explicit:!1}),this.setState(u.State.Idle(u.UpdateType.Snap)))},h=>{this.logService.error(h),this.telemetryService.publicLog2("update:notAvailable",{explicit:!1}),this.setState(u.State.Idle(u.UpdateType.Snap,h.message||h))})}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),(0,i.spawn)("sleep 3 && "+A.basename(process.argv[0]),{shell:!0,detached:!0,stdio:"ignore"})}async isUpdateAvailable(){const h=await new Promise((b,g)=>(0,s.realpath)(`${A.dirname(this.snap)}/current`,(I,P)=>I?g(I):b(P))),E=A.basename(h);return this.snapRevision!==E}isLatestVersion(){return this.isUpdateAvailable().then(void 0,h=>{this.logService.error("update#checkForSnapUpdate(): Could not get realpath of application.")})}};e.SnapUpdateService=v,e.SnapUpdateService=v=Pe([re(2,S.ILifecycleMainService),re(3,R.IEnvironmentMainService),re(4,c.ILogService),re(5,m.ITelemetryService)],v)});var je=this&&this.__importDefault||function(j){return j&&j.__esModule?j:{default:j}};define(le[29],ue([0,1,13,143,10,3,16,20,6,28,77,47,52]),function(j,e,i,s,y,k,A,R,S,c,m,u,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowStateValidator=e.OpenContext=e.IWindowsMainService=void 0,e.defaultBrowserWindowOptions=f,e.getLastFocused=h,i=je(i),e.IWindowsMainService=(0,S.createDecorator)("windowsMainService");var v;(function(b){b[b.CLI=0]="CLI",b[b.DOCK=1]="DOCK",b[b.MENU=2]="MENU",b[b.DIALOG=3]="DIALOG",b[b.DESKTOP=4]="DESKTOP",b[b.API=5]="API",b[b.LINK=6]="LINK"})(v||(e.OpenContext=v={}));function f(b,g,I,P){const r=b.get(m.IThemeMainService),a=b.get(c.IProductService),t=b.get(A.IConfigurationService),o=b.get(R.IEnvironmentMainService),n=t.getValue("window"),l={backgroundColor:r.getBackgroundColor(),minWidth:u.WindowMinimumSize.WIDTH,minHeight:u.WindowMinimumSize.HEIGHT,title:a.nameLong,show:g.mode!==p.WindowMode.Maximized&&g.mode!==p.WindowMode.Fullscreen,x:g.x,y:g.y,width:g.width,height:g.height,webPreferences:{...P,enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,u.zoomLevelToZoomFactor)(g.zoomLevel??n?.zoomLevel),autoplayPolicy:"user-gesture-required",enableBlinkFeatures:"HighlightAPI",sandbox:!0},experimentalDarkMode:!0};if(k.isLinux?l.icon=(0,y.join)(o.appRoot,"resources/linux/code.png"):k.isWindows&&!o.isBuilt&&(l.icon=(0,y.join)(o.appRoot,"resources/win32/code_150x150.png")),k.isMacintosh&&(l.acceptFirstMouse=!0,n?.clickThroughInactive===!1&&(l.acceptFirstMouse=!1)),I?.disableFullscreen?l.fullscreen=!1:k.isMacintosh&&!(0,u.useNativeFullScreen)(t)&&(l.fullscreenable=!1),k.isMacintosh&&n?.nativeTabs===!0&&(l.tabbingIdentifier=a.nameShort),!(0,u.hasNativeTitlebar)(t,I?.forceNativeTitlebar?u.TitlebarStyle.NATIVE:void 0)&&(l.titleBarStyle="hidden",k.isMacintosh||(l.frame=!1),(0,u.useWindowControlsOverlay)(t))){const w=r.getWindowSplash()?.colorInfo.titleBarBackground??r.getBackgroundColor(),M=s.Color.fromHex(w).isDarker()?"#FFFFFF":"#000000";l.titleBarOverlay={height:29,color:w,symbolColor:M}}return l}function h(b){let g,I=Number.MIN_VALUE;for(const P of b)P.lastFocusTime>I&&(I=P.lastFocusTime,g=P);return g}var E;(function(b){function g(P,r,a=i.default.screen.getAllDisplays()){if(P.trace(`window#validateWindowState: validating window state on ${a.length} display(s)`,r),typeof r.x!="number"||typeof r.y!="number"||typeof r.width!="number"||typeof r.height!="number"){P.trace("window#validateWindowState: unexpected type of state values");return}if(r.width<=0||r.height<=0){P.trace("window#validateWindowState: unexpected negative values");return}if(a.length===1){const n=I(a[0]);if(P.trace("window#validateWindowState: single monitor working area",n),n){let l=function(){!r||typeof r.x!="number"||typeof r.y!="number"||!n||(r.x<n.x&&(r.x=n.x),r.y<n.y&&(r.y=n.y))};l(),r.width>n.width&&(r.width=n.width),r.height>n.height&&(r.height=n.height),r.x>n.x+n.width-128&&(r.x=n.x+n.width-r.width),r.y>n.y+n.height-128&&(r.y=n.y+n.height-r.height),l()}return r}if(r.display&&r.mode===p.WindowMode.Fullscreen){const n=a.find(l=>l.id===r.display);if(n&&typeof n.bounds?.x=="number"&&typeof n.bounds?.y=="number"){P.trace("window#validateWindowState: restoring fullscreen to previous display");const l=(0,p.defaultWindowState)(p.WindowMode.Fullscreen);return l.x=n.bounds.x,l.y=n.bounds.y,l}}let t,o;try{t=i.default.screen.getDisplayMatching({x:r.x,y:r.y,width:r.width,height:r.height}),o=I(t),P.trace("window#validateWindowState: multi-monitor working area",o)}catch(n){P.error("window#validateWindowState: error finding display for window state",n)}if(t&&o&&r.x+r.width>o.x&&r.y+r.height>o.y&&r.x<o.x+o.width&&r.y<o.y+o.height)return r;P.trace("window#validateWindowState: state is outside of the multi-monitor working area")}b.validateWindowState=g;function I(P){if(P.workArea.width>0&&P.workArea.height>0)return P.workArea;if(P.bounds.width>0&&P.bounds.height>0)return P.bounds}})(E||(e.WindowStateValidator=E={}))}),define(le[264],ue([0,1,94,171,124,29]),function(j,e,i,s,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronExtensionHostDebugBroadcastChannel=void 0;class A extends s.ExtensionHostDebugBroadcastChannel{constructor(S){super(),this.windowsMainService=S}call(S,c,m){return c==="openExtensionDevelopmentHostWindow"?this.openExtensionDevelopmentHostWindow(m[0],m[1]):super.call(S,c,m)}async openExtensionDevelopmentHostWindow(S,c){const m=(0,y.parseArgs)(S,y.OPTIONS);m.debugRenderer=c;const u=m.extensionDevelopmentPath;if(!u)return{success:!1};const[p]=await this.windowsMainService.openExtensionDevelopmentHostWindow(u,{context:k.OpenContext.API,cli:m,forceProfile:m.profile,forceTempProfile:m["profile-temp"]});if(!c)return{success:!0};const v=p.win;if(!v)return{success:!0};const f=v.webContents.debugger;let h=f.isAttached()?1/0:0;const E=(0,i.createServer)(b=>{h++===0&&f.attach();let g=!1;const I=a=>{g||b.write(JSON.stringify(a)+"\0")},P=(a,t,o,n)=>I({method:t,params:o,sessionId:n});v.on("close",()=>{f.removeListener("message",P),b.end(),g=!0}),f.addListener("message",P);let r=Buffer.alloc(0);b.on("data",a=>{r=Buffer.concat([r,a]);for(let t=r.indexOf(0);t!==-1;t=r.indexOf(0)){let o;try{const n=r.slice(0,t).toString("utf8");r=r.slice(t+1),o=JSON.parse(n)}catch(n){console.error("error reading cdp line",n)}f.sendCommand(o.method,o.params,o.sessionId).then(n=>I({id:o.id,sessionId:o.sessionId,result:n})).catch(n=>I({id:o.id,sessionId:o.sessionId,error:{code:0,message:n.message}}))}}),b.on("error",a=>{console.error("error on cdp pipe:",a)}),b.on("close",()=>{g=!0,--h===0&&f.detach()})});return await new Promise(b=>E.listen(0,b)),v.on("close",()=>E.close()),{rendererDebugPort:E.address().port,success:!0}}}e.ElectronExtensionHostDebugBroadcastChannel=A}),define(le[265],ue([0,1,13,21,3,7,23,16,69,6,5,135,29]),function(j,e,i,s,y,k,A,R,S,c,m,u,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LaunchMainService=e.ILaunchMainService=e.ID=void 0,e.ID="launchMainService",e.ILaunchMainService=(0,c.createDecorator)(e.ID);let v=class{constructor(h,E,b,g){this.logService=h,this.windowsMainService=E,this.urlService=b,this.configurationService=g}async start(h,E){this.logService.trace("Received data from other instance: ",h,E),y.isMacintosh&&i.app.focus({steal:!0});const b=this.parseOpenUrl(h);if(b.length){let g=Promise.resolve();if(this.windowsMainService.getWindowCount()===0){const I=(0,s.firstOrDefault)(await this.windowsMainService.openEmptyWindow({context:p.OpenContext.DESKTOP}));I&&(g=I.ready())}g.then(()=>{for(const{uri:I,originalUrl:P}of b)this.urlService.open(I,{originalUrl:P})})}else return this.startOpenWindow(h,E)}parseOpenUrl(h){return h["open-url"]&&h._urls&&h._urls.length>0?(0,s.coalesce)(h._urls.map(E=>{try{return{uri:k.URI.parse(E),originalUrl:E}}catch{return null}})):[]}async startOpenWindow(h,E){const b=(0,S.isLaunchedFromCli)(E)?p.OpenContext.CLI:p.OpenContext.DESKTOP;let g=[];const I=h.wait&&h.waitMarkerFilePath?k.URI.file(h.waitMarkerFilePath):void 0,P=h.remote||void 0,r={context:b,cli:h,userEnv:h["preserve-env"]||b===p.OpenContext.CLI?E:void 0,waitMarkerFileURI:I,remoteAuthority:P,forceProfile:h.profile,forceTempProfile:h["profile-temp"]};if(h.extensionDevelopmentPath)await this.windowsMainService.openExtensionDevelopmentHostWindow(h.extensionDevelopmentPath,r);else if(!h._.length&&!h["folder-uri"]&&!h["file-uri"]){let a=!1;if(h["new-window"]||r.forceProfile||r.forceTempProfile)a=!0;else if(h["reuse-window"])a=!1;else switch(this.configurationService.getValue("window")?.openWithoutArgumentsInNewWindow||"default"){case"on":a=!0;break;case"off":a=!1;break;default:a=!y.isMacintosh}if(a)g=await this.windowsMainService.open({...r,forceNewWindow:!0,forceEmpty:!0});else{const t=this.windowsMainService.getLastActiveWindow();t?(this.windowsMainService.openExistingWindow(t,r),g=[t]):g=await this.windowsMainService.open({...r,forceEmpty:!0})}}else g=await this.windowsMainService.open({...r,forceNewWindow:h["new-window"],preferNewWindow:!h["reuse-window"]&&!h.wait,forceReuseWindow:h["reuse-window"],diffMode:h.diff,mergeMode:h.merge,addMode:h.add,noRecentEntry:!!h["skip-add-to-recently-opened"],gotoLineMode:h.goto});if(I&&g.length===1&&g[0])return Promise.race([g[0].whenClosedOrLoaded,(0,A.whenDeleted)(I.fsPath)]).then(()=>{},()=>{})}async getMainProcessId(){return this.logService.trace("Received request for process ID from other instance."),process.pid}};e.LaunchMainService=v,e.LaunchMainService=v=Pe([re(0,m.ILogService),re(1,p.IWindowsMainService),re(2,u.IURLService),re(3,R.IConfigurationService)],v)}),define(le[138],ue([0,1,13,22,4,48,2,7,33,16,100,20,6,5,63,89,29]),function(j,e,i,s,y,k,A,R,S,c,m,u,p,v,f,h,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProxyAuthService=e.IProxyAuthService=void 0,e.IProxyAuthService=(0,p.createDecorator)("proxyAuthService");let b=class extends A.Disposable{constructor(I,P,r,a,t,o){super(),this.logService=I,this.windowsMainService=P,this.encryptionMainService=r,this.applicationStorageMainService=a,this.configurationService=t,this.environmentMainService=o,this.PROXY_CREDENTIALS_SERVICE_KEY="proxy-credentials://",this.pendingProxyResolves=new Map,this.currentDialog=void 0,this.cancelledAuthInfoHashes=new Set,this.sessionCredentials=new Map,this.registerListeners()}registerListeners(){const I=y.Event.fromNodeEventEmitter(i.app,"login",(P,r,a,t,o)=>({event:P,authInfo:{...t,attempt:a.firstAuthAttempt?1:2},callback:o}));this._register(I(this.onLogin,this))}async lookupAuthorization(I){return this.onLogin({authInfo:I})}async onLogin({event:I,authInfo:P,callback:r}){if(!P.isProxy)return;I?.preventDefault();const a=String((0,k.hash)({scheme:P.scheme,host:P.host,port:P.port}));let t,o=this.pendingProxyResolves.get(a);if(o)this.logService.trace("auth#onLogin (proxy) - pending proxy handling found"),t=await o;else{this.logService.trace("auth#onLogin (proxy) - no pending proxy handling found, starting new"),o=this.resolveProxyCredentials(P,a),this.pendingProxyResolves.set(a,o);try{t=await o}finally{this.pendingProxyResolves.delete(a)}}return r?.(t?.username,t?.password),t}async resolveProxyCredentials(I,P){this.logService.trace("auth#resolveProxyCredentials (proxy) - enter");try{const r=await this.doResolveProxyCredentials(I,P);if(r)return this.logService.trace("auth#resolveProxyCredentials (proxy) - got credentials"),r;this.logService.trace("auth#resolveProxyCredentials (proxy) - did not get credentials")}finally{this.logService.trace("auth#resolveProxyCredentials (proxy) - exit")}}async doResolveProxyCredentials(I,P){if(this.logService.trace("auth#doResolveProxyCredentials - enter",I),this.environmentMainService.extensionTestsLocationURI){const d=this.configurationService.getValue("integration-test.http.proxyAuth");if(d){const D=d.indexOf(":");return D!==-1?{username:d.substring(0,D),password:d.substring(D+1)}:{username:d,password:""}}return}const r=(this.configurationService.getValue("http.proxy")||"").trim()||(process.env.https_proxy||process.env.HTTPS_PROXY||process.env.http_proxy||process.env.HTTP_PROXY||"").trim()||void 0;if(r?.indexOf("@")!==-1){const d=R.URI.parse(r),D=d.authority.indexOf("@");if(D!==-1){if(I.attempt>1){this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - ignoring previously used config/envvar credentials");return}this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - found config/envvar credentials to use");const w=d.authority.substring(0,D),M=w.indexOf(":");return M!==-1?{username:w.substring(0,M),password:w.substring(M+1)}:{username:w,password:""}}}const a=I.attempt===1&&this.sessionCredentials.get(P);if(a){this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - found session credentials to use");const{username:d,password:D}=a;return{username:d,password:D}}let t,o;try{const d=this.applicationStorageMainService.get(this.PROXY_CREDENTIALS_SERVICE_KEY+P,f.StorageScope.APPLICATION);if(d){const D=JSON.parse(await this.encryptionMainService.decrypt(d));t=D.username,o=D.password}}catch(d){this.logService.error(d)}if(I.attempt===1&&typeof t=="string"&&typeof o=="string")return this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - found stored credentials to use"),this.sessionCredentials.set(P,{username:t,password:o}),{username:t,password:o};const n=this.currentDialog,l=this.currentDialog=(async()=>{await n;const d=await this.showProxyCredentialsDialog(I,P,t,o);return this.currentDialog===l&&(this.currentDialog=void 0),d})();return l}async showProxyCredentialsDialog(I,P,r,a){if(this.cancelledAuthInfoHashes.has(P)){this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - login dialog was cancelled before, not showing again");return}const t=this.windowsMainService.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(!t){this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - no opened window found to show dialog in");return}this.logService.trace(`auth#doResolveProxyCredentials (proxy) - asking window ${t.id} to handle proxy login`);const o=this.sessionCredentials.get(P),n={authInfo:I,username:o?.username??r,password:o?.password??a,replyChannel:`vscode:proxyAuthResponse:${(0,S.generateUuid)()}`};t.sendWhenReady("vscode:openProxyAuthenticationDialog",s.CancellationToken.None,n);const l=await new Promise(d=>{const D=async(w,M,T)=>{if(M===n.replyChannel)if(this.logService.trace(`auth#doResolveProxyCredentials - exit - received credentials from window ${t.id}`),t.win?.webContents.off("ipc-message",D),T){const C={username:T.username,password:T.password};try{if(T.remember){const L=await this.encryptionMainService.encrypt(JSON.stringify(C));this.applicationStorageMainService.store(this.PROXY_CREDENTIALS_SERVICE_KEY+P,L,f.StorageScope.APPLICATION,f.StorageTarget.MACHINE)}else this.applicationStorageMainService.remove(this.PROXY_CREDENTIALS_SERVICE_KEY+P,f.StorageScope.APPLICATION)}catch(L){this.logService.error(L)}d({username:C.username,password:C.password})}else this.cancelledAuthInfoHashes.add(P),d(void 0)};t.win?.webContents.on("ipc-message",D)});return this.sessionCredentials.set(P,l),l}};e.ProxyAuthService=b,e.ProxyAuthService=b=Pe([re(0,v.ILogService),re(1,E.IWindowsMainService),re(2,m.IEncryptionMainService),re(3,h.IApplicationStorageMainService),re(4,c.IConfigurationService),re(5,u.IEnvironmentMainService)],b)}),define(le[266],ue([0,1,2,19,52,58,30,8,29]),function(j,e,i,s,y,k,A,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesHandler=void 0;let c=class extends i.Disposable{constructor(u,p,v){super(),this.userDataProfilesService=p,this.windowsMainService=v,this._register(u.onWillLoadWindow(f=>{f.reason===y.LoadReason.LOAD&&this.unsetProfileForWorkspace(f.window)})),this._register(u.onBeforeCloseWindow(f=>this.unsetProfileForWorkspace(f))),this._register(new R.RunOnceScheduler(()=>this.cleanUpEmptyWindowAssociations(),30*1e3)).schedule()}async unsetProfileForWorkspace(u){const p=this.getWorkspace(u),v=this.userDataProfilesService.getProfileForWorkspace(p);v?.isTransient&&(this.userDataProfilesService.unsetWorkspace(p,v.isTransient),v.isTransient&&await this.userDataProfilesService.cleanUpTransientProfiles())}getWorkspace(u){return u.openedWorkspace??(0,A.toWorkspaceIdentifier)(u.backupPath,u.isExtensionDevelopmentHost)}cleanUpEmptyWindowAssociations(){const u=this.userDataProfilesService.getAssociatedEmptyWindows();if(u.length===0)return;const p=this.windowsMainService.getWindows().map(v=>this.getWorkspace(v));for(const v of u)p.some(f=>f.id===v.id)||this.userDataProfilesService.unsetWorkspace(v,!1)}};e.UserDataProfilesHandler=c,e.UserDataProfilesHandler=c=Pe([re(0,s.ILifecycleMainService),re(1,k.IUserDataProfilesMainService),re(2,S.IWindowsMainService)],c)});var je=this&&this.__importDefault||function(j){return j&&j.__esModule?j:{default:j}};define(le[64],ue([0,1,13,2,4,5,286,8,11,29,81,24,19,82,37,3,109,12]),function(j,e,i,s,y,k,A,R,S,c,m,u,p,v,f,h,E,b){"use strict";var g;Object.defineProperty(e,"__esModule",{value:!0}),e.WindowUtilityProcess=e.UtilityProcess=void 0,m=je(m);function I(a){return typeof a.responseWindowId=="number"}let P=class extends s.Disposable{static{g=this}static{this.ID_COUNTER=0}static{this.all=new Map}static getAll(){return Array.from(g.all.values())}constructor(t,o,n){super(),this.logService=t,this.telemetryService=o,this.lifecycleMainService=n,this.id=String(++g.ID_COUNTER),this._onStdout=this._register(new y.Emitter),this.onStdout=this._onStdout.event,this._onStderr=this._register(new y.Emitter),this.onStderr=this._onStderr.event,this._onMessage=this._register(new y.Emitter),this.onMessage=this._onMessage.event,this._onSpawn=this._register(new y.Emitter),this.onSpawn=this._onSpawn.event,this._onExit=this._register(new y.Emitter),this.onExit=this._onExit.event,this._onCrash=this._register(new y.Emitter),this.onCrash=this._onCrash.event,this.process=void 0,this.processPid=void 0,this.configuration=void 0,this.killed=!1}log(t,o){let n;switch(this.configuration?.correlationId?n=`[UtilityProcess id: ${this.configuration?.correlationId}, type: ${this.configuration?.type}, pid: ${this.processPid??"<none>"}]: ${t}`:n=`[UtilityProcess type: ${this.configuration?.type}, pid: ${this.processPid??"<none>"}]: ${t}`,o){case m.default.Error:this.logService.error(n);break;case m.default.Warning:this.logService.warn(n);break;case m.default.Info:this.logService.trace(n);break}}validateCanStart(){return this.process?(this.log("Cannot start utility process because it is already running...",m.default.Error),!1):!0}start(t){const o=this.doStart(t);return o&&t.payload&&this.postMessage(t.payload)&&this.log("payload sent via postMessage()",m.default.Info),o}doStart(t){if(!this.validateCanStart())return!1;this.configuration=t;const o=`${this.configuration.type}-${this.id}`,n=S.FileAccess.asFileUri("bootstrap-fork.js").fsPath,l=this.configuration.args??[],d=this.configuration.execArgv??[],D=this.configuration.allowLoadingUnsignedLibraries,w=this.configuration.forceAllocationsToV8Sandbox,M=this.configuration.respondToAuthRequestsFromMainProcess,T="pipe",C=this.createEnv(t);return this.log("creating new...",m.default.Info),this.process=i.utilityProcess.fork(n,l,(0,b.upcast)({serviceName:o,env:C,execArgv:d,allowLoadingUnsignedLibraries:D,forceAllocationsToV8Sandbox:w,respondToAuthRequestsFromMainProcess:M,stdio:T})),this.registerListeners(this.process,this.configuration,o),!0}createEnv(t){const o=t.env?{...t.env}:{...(0,f.deepClone)(process.env)};o.VSCODE_AMD_ENTRYPOINT=t.entryPoint,typeof t.parentLifecycleBound=="number"&&(o.VSCODE_PARENT_PID=String(t.parentLifecycleBound)),o.VSCODE_CRASH_REPORTER_PROCESS_TYPE=t.type,h.isWindows&&((0,E.isUNCAccessRestrictionsDisabled)()?o.NODE_DISABLE_UNC_ACCESS_CHECKS="1":o.NODE_UNC_HOST_ALLOWLIST=(0,E.getUNCHostAllowlist)().join("\\")),(0,v.removeDangerousEnvVariables)(o);for(const n of Object.keys(o))o[n]=String(o[n]);return o}registerListeners(t,o,n){if(t.stdout){const l=new A.StringDecoder("utf-8");this._register(y.Event.fromNodeEventEmitter(t.stdout,"data")(d=>this._onStdout.fire(typeof d=="string"?d:l.write(d))))}if(t.stderr){const l=new A.StringDecoder("utf-8");this._register(y.Event.fromNodeEventEmitter(t.stderr,"data")(d=>this._onStderr.fire(typeof d=="string"?d:l.write(d))))}this._register(y.Event.fromNodeEventEmitter(t,"message")(l=>this._onMessage.fire(l))),this._register(y.Event.fromNodeEventEmitter(t,"spawn")(()=>{this.processPid=t.pid,typeof t.pid=="number"&&g.all.set(t.pid,{pid:t.pid,name:I(o)?`${o.type} [${o.responseWindowId}]`:o.type}),this.log("successfully created",m.default.Info),this._onSpawn.fire(t.pid)})),this._register(y.Event.fromNodeEventEmitter(t,"exit")(l=>{const d=this.isNormalExit(l)?0:l;this.log(`received exit event with code ${d}`,m.default.Info),this._onExit.fire({pid:this.processPid,code:d,signal:"unknown"}),this.onDidExitOrCrashOrKill()})),this._register(y.Event.fromNodeEventEmitter(i.app,"child-process-gone",(l,d)=>({event:l,details:d}))(({details:l})=>{l.type==="Utility"&&l.name===n&&!this.isNormalExit(l.exitCode)&&(this.log(`crashed with code ${l.exitCode} and reason '${l.reason}'`,m.default.Error),this.telemetryService.publicLog2("utilityprocesscrash",{type:o.type,reason:l.reason,code:l.exitCode}),this._onCrash.fire({pid:this.processPid,code:l.exitCode,reason:l.reason}),this.onDidExitOrCrashOrKill())}))}once(t,o){const n=this._register(this._onMessage.event(l=>{l===t&&(n.dispose(),o())}))}postMessage(t,o){return this.process?(this.process.postMessage(t,o),!0):!1}connect(t){const{port1:o,port2:n}=new i.MessageChannelMain;return this.postMessage(t,[n]),o}enableInspectPort(){if(!this.process||typeof this.processPid!="number")return!1;this.log("enabling inspect port",m.default.Info);const t=process;return typeof t._debugProcess=="function"?(t._debugProcess(this.processPid),!0):!1}kill(){if(!this.process)return;this.log("attempting to kill the process...",m.default.Info),this.process.kill()?(this.log("successfully killed the process",m.default.Info),this.killed=!0,this.onDidExitOrCrashOrKill()):this.log("unable to kill the process",m.default.Warning)}isNormalExit(t){return t===0?!0:this.killed&&t===15}onDidExitOrCrashOrKill(){typeof this.processPid=="number"&&g.all.delete(this.processPid),this.process=void 0}async waitForExit(t){this.process&&(this.log("waiting to exit...",m.default.Info),await Promise.race([y.Event.toPromise(this.onExit),(0,R.timeout)(t)]),this.process&&(this.log(`did not exit within ${t}ms, will kill it now...`,m.default.Info),this.kill()))}};e.UtilityProcess=P,e.UtilityProcess=P=g=Pe([re(0,k.ILogService),re(1,u.ITelemetryService),re(2,p.ILifecycleMainService)],P);let r=class extends P{constructor(t,o,n,l){super(t,n,l),this.windowsMainService=o}start(t){const o=this.windowsMainService.getWindowById(t.responseWindowId);if(!o?.win||o.win.isDestroyed()||o.win.webContents.isDestroyed())return this.log("Refusing to start utility process because requesting window cannot be found or is destroyed...",m.default.Error),!0;if(!super.doStart(t))return!1;this.registerWindowListeners(o.win,t);const l=this.connect(t.payload);return o.win.webContents.postMessage(t.responseChannel,t.responseNonce,[l]),!0}registerWindowListeners(t,o){o.windowLifecycleBound&&(this._register(y.Event.filter(this.lifecycleMainService.onWillLoadWindow,n=>n.window.win===t)(()=>this.kill())),this._register(y.Event.fromNodeEventEmitter(t,"closed")(()=>this.kill())))}};e.WindowUtilityProcess=r,e.WindowUtilityProcess=r=Pe([re(0,k.ILogService),re(1,c.IWindowsMainService),re(2,u.ITelemetryService),re(3,p.ILifecycleMainService)],r)}),define(le[267],ue([0,1,8,15,4,2,19,5,24,64,29]),function(j,e,i,s,y,k,A,R,S,c,m){"use strict";var u;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostStarter=void 0;let p=class extends k.Disposable{static{u=this}static{this._lastId=0}constructor(f,h,E,b){super(),this._logService=f,this._lifecycleMainService=h,this._windowsMainService=E,this._telemetryService=b,this._extHosts=new Map,this._shutdown=!1,this._register(this._lifecycleMainService.onWillShutdown(g=>{this._shutdown=!0,g.join("extHostStarter",this._waitForAllExit(6e3))}))}dispose(){super.dispose()}_getExtHost(f){const h=this._extHosts.get(f);if(!h)throw new Error("Unknown extension host!");return h}onDynamicStdout(f){return this._getExtHost(f).onStdout}onDynamicStderr(f){return this._getExtHost(f).onStderr}onDynamicMessage(f){return this._getExtHost(f).onMessage}onDynamicExit(f){return this._getExtHost(f).onExit}async createExtensionHost(){if(this._shutdown)throw(0,s.canceled)();const f=String(++u._lastId),h=new c.WindowUtilityProcess(this._logService,this._windowsMainService,this._telemetryService,this._lifecycleMainService);this._extHosts.set(f,h);const E=h.onExit(({pid:b,code:g,signal:I})=>{E.dispose(),this._logService.info(`Extension host with pid ${b} exited with code: ${g}, signal: ${I}.`),setTimeout(()=>{h.dispose(),this._extHosts.delete(f)}),setTimeout(()=>{try{process.kill(b,0),this._logService.error(`Extension host with pid ${b} still exists, forcefully killing it...`),process.kill(b)}catch{}},1e3)});return{id:f}}async start(f,h){if(this._shutdown)throw(0,s.canceled)();const E=this._getExtHost(f);return E.start({...h,type:"extensionHost",entryPoint:"vs/workbench/api/node/extensionHostProcess",args:["--skipWorkspaceStorageLock"],execArgv:h.execArgv,allowLoadingUnsignedLibraries:!0,forceAllocationsToV8Sandbox:!0,respondToAuthRequestsFromMainProcess:!0,correlationId:f}),{pid:await y.Event.toPromise(E.onSpawn)}}async enableInspectPort(f){if(this._shutdown)throw(0,s.canceled)();const h=this._extHosts.get(f);return h?h.enableInspectPort():!1}async kill(f){if(this._shutdown)throw(0,s.canceled)();const h=this._extHosts.get(f);h&&h.kill()}async _killAllNow(){for(const[,f]of this._extHosts)f.kill()}async _waitForAllExit(f){const h=[];for(const[,E]of this._extHosts)h.push(E.waitForExit(f));return i.Promises.settled(h).then(()=>{})}};e.ExtensionHostStarter=p,e.ExtensionHostStarter=p=u=Pe([re(0,R.ILogService),re(1,A.ILifecycleMainService),re(2,m.IWindowsMainService),re(3,S.ITelemetryService)],p)}),define(le[268],ue([0,1,35,8,2,20,19,5,42,40,72,64,57,98,12,220,4]),function(j,e,i,s,y,k,A,R,S,c,m,u,p,v,f,h,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcess=void 0;let b=class extends y.Disposable{constructor(I,P,r,a,t,o,n,l,d){super(),this.machineId=I,this.sqmId=P,this.devDeviceId=r,this.environmentMainService=a,this.userDataProfilesService=t,this.lifecycleMainService=o,this.logService=n,this.loggerMainService=l,this.policyService=d,this.firstWindowConnectionBarrier=new s.Barrier,this.utilityProcess=void 0,this.utilityProcessLogListener=void 0,this._onDidCrash=this._register(new E.Emitter),this.onDidCrash=this._onDidCrash.event,this._whenReady=void 0,this._whenIpcReady=void 0,this.registerListeners()}registerListeners(){i.validatedIpcMain.on(h.SharedProcessChannelConnection.request,(I,P)=>this.onWindowConnection(I,P,h.SharedProcessChannelConnection.response)),i.validatedIpcMain.on(h.SharedProcessRawConnection.request,(I,P)=>this.onWindowConnection(I,P,h.SharedProcessRawConnection.response)),this._register(this.lifecycleMainService.onWillShutdown(()=>this.onWillShutdown()))}async onWindowConnection(I,P,r){this.logService.trace(`[SharedProcess] onWindowConnection for: ${r}`),this.firstWindowConnectionBarrier.isOpen()||this.firstWindowConnectionBarrier.open(),await this.whenReady();const a=await this.connect(r);if(I.sender.isDestroyed())return a.close();I.sender.postMessage(r,P,[a])}onWillShutdown(){this.logService.trace("[SharedProcess] onWillShutdown"),this.utilityProcess?.postMessage(h.SharedProcessLifecycle.exit),this.utilityProcess=void 0}whenReady(){return this._whenReady||(this._whenReady=(async()=>{await this.whenIpcReady;const I=new s.DeferredPromise;this.utilityProcess?.once(h.SharedProcessLifecycle.initDone,()=>I.complete()),await I.p,this.utilityProcessLogListener?.dispose(),this.logService.trace("[SharedProcess] Overall ready")})()),this._whenReady}get whenIpcReady(){return this._whenIpcReady||(this._whenIpcReady=(async()=>{await this.firstWindowConnectionBarrier.wait(),this.createUtilityProcess();const I=new s.DeferredPromise;this.utilityProcess?.once(h.SharedProcessLifecycle.ipcReady,()=>I.complete()),await I.p,this.logService.trace("[SharedProcess] IPC ready")})()),this._whenIpcReady}createUtilityProcess(){this.utilityProcess=this._register(new u.UtilityProcess(this.logService,p.NullTelemetryService,this.lifecycleMainService)),this.utilityProcessLogListener=this.utilityProcess.onMessage(r=>{typeof r.warning=="string"?this.logService.warn(r.warning):typeof r.error=="string"&&this.logService.error(r.error)});const I=(0,v.parseSharedProcessDebugPort)(this.environmentMainService.args,this.environmentMainService.isBuilt);let P;I.port&&(P=["--nolazy"],I.break?P.push(`--inspect-brk=${I.port}`):P.push(`--inspect=${I.port}`)),this.utilityProcess.start({type:"shared-process",entryPoint:"vs/code/node/sharedProcess/sharedProcessMain",payload:this.createSharedProcessConfiguration(),execArgv:P}),this._register(this.utilityProcess.onCrash(()=>this._onDidCrash.fire()))}createSharedProcessConfiguration(){return{machineId:this.machineId,sqmId:this.sqmId,devDeviceId:this.devDeviceId,codeCachePath:this.environmentMainService.codeCachePath,profiles:{home:this.userDataProfilesService.profilesHome,all:this.userDataProfilesService.profiles},args:this.environmentMainService.args,logLevel:this.loggerMainService.getLogLevel(),loggers:this.loggerMainService.getRegisteredLoggers(),policiesData:this.policyService.serialize()}}async connect(I){return await this.whenIpcReady,(0,f.assertIsDefined)(this.utilityProcess).connect(I)}};e.SharedProcess=b,e.SharedProcess=b=Pe([re(3,k.IEnvironmentMainService),re(4,S.IUserDataProfilesService),re(5,A.ILifecycleMainService),re(6,R.ILogService),re(7,m.ILoggerMainService),re(8,c.IPolicyService)],b)}),define(le[269],ue([0,1,20,98,19,5,57,76,64,122,35,2,4,37,16,11]),function(j,e,i,s,y,k,A,R,S,c,m,u,p,v,f,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronPtyHostStarter=void 0;let E=class extends u.Disposable{constructor(g,I,P,r,a){super(),this._reconnectConstants=g,this._configurationService=I,this._environmentMainService=P,this._lifecycleMainService=r,this._logService=a,this.utilityProcess=void 0,this._onRequestConnection=new p.Emitter,this.onRequestConnection=this._onRequestConnection.event,this._onWillShutdown=new p.Emitter,this.onWillShutdown=this._onWillShutdown.event,this._register(this._lifecycleMainService.onWillShutdown(()=>this._onWillShutdown.fire())),m.validatedIpcMain.on("vscode:createPtyHostMessageChannel",(t,o)=>this._onWindowConnection(t,o)),this._register((0,u.toDisposable)(()=>{m.validatedIpcMain.removeHandler("vscode:createPtyHostMessageChannel")}))}start(){this.utilityProcess=new S.UtilityProcess(this._logService,A.NullTelemetryService,this._lifecycleMainService);const g=(0,s.parsePtyHostDebugPort)(this._environmentMainService.args,this._environmentMainService.isBuilt),I=g.port?["--nolazy",`--inspect${g.break?"-brk":""}=${g.port}`]:void 0;this.utilityProcess.start({type:"ptyHost",entryPoint:"vs/platform/terminal/node/ptyHostMain",execArgv:I,args:["--logsPath",this._environmentMainService.logsHome.with({scheme:h.Schemas.file}).fsPath],env:this._createPtyHostConfiguration()});const P=this.utilityProcess.connect(),r=new c.Client(P,"ptyHost"),a=new u.DisposableStore;return a.add(r),a.add((0,u.toDisposable)(()=>{this.utilityProcess?.kill(),this.utilityProcess?.dispose(),this.utilityProcess=void 0})),{client:r,store:a,onDidProcessExit:this.utilityProcess.onExit}}_createPtyHostConfiguration(){this._environmentMainService.unsetSnapExportedVariables();const g={...(0,v.deepClone)(process.env),VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:String(this._reconnectConstants.graceTime),VSCODE_RECONNECT_SHORT_GRACE_TIME:String(this._reconnectConstants.shortGraceTime),VSCODE_RECONNECT_SCROLLBACK:String(this._reconnectConstants.scrollback)},I=this._configurationService.getValue(R.TerminalSettingId.DeveloperPtyHostLatency);I&&typeof I=="number"&&(g.VSCODE_LATENCY=String(I));const P=this._configurationService.getValue(R.TerminalSettingId.DeveloperPtyHostStartupDelay);return P&&typeof P=="number"&&(g.VSCODE_STARTUP_DELAY=String(P)),this._environmentMainService.restoreSnapExportedVariables(),g}_onWindowConnection(g,I){this._onRequestConnection.fire();const P=this.utilityProcess.connect();if(g.sender.isDestroyed()){P.close();return}g.sender.postMessage("vscode:createPtyHostMessageChannelResult",I,[P])}};e.ElectronPtyHostStarter=E,e.ElectronPtyHostStarter=E=Pe([re(1,f.IConfigurationService),re(2,i.IEnvironmentMainService),re(3,y.ILifecycleMainService),re(4,k.ILogService)],E)}),define(le[270],ue([0,1,2,6,5,29,64,24,48,4,8,19]),function(j,e,i,s,y,k,A,R,S,c,m,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UtilityProcessWorkerMainService=e.IUtilityProcessWorkerMainService=void 0,e.IUtilityProcessWorkerMainService=(0,s.createDecorator)("utilityProcessWorker");let p=class extends i.Disposable{constructor(h,E,b,g){super(),this.logService=h,this.windowsMainService=E,this.telemetryService=b,this.lifecycleMainService=g,this.workers=new Map}async createWorker(h){const E=`window: ${h.reply.windowId}, moduleId: ${h.process.moduleId}`;this.logService.trace(`[UtilityProcessWorker]: createWorker(${E})`);const b=this.hash(h);this.workers.has(b)&&(this.logService.warn(`[UtilityProcessWorker]: createWorker() found an existing worker that will be terminated (${E})`),this.disposeWorker(h));const g=new v(this.logService,this.windowsMainService,this.telemetryService,this.lifecycleMainService,h);if(!g.spawn())return{reason:{code:1,signal:"EINVALID"}};this.workers.set(b,g);const I=new m.DeferredPromise;return c.Event.once(g.onDidTerminate)(P=>{P.code===0?this.logService.trace(`[UtilityProcessWorker]: terminated normally with code ${P.code}, signal: ${P.signal}`):this.logService.error(`[UtilityProcessWorker]: terminated unexpectedly with code ${P.code}, signal: ${P.signal}`),this.workers.delete(b),I.complete({reason:P})}),I.p}hash(h){return(0,S.hash)({moduleId:h.process.moduleId,windowId:h.reply.windowId})}async disposeWorker(h){const E=this.hash(h),b=this.workers.get(E);b&&(this.logService.trace(`[UtilityProcessWorker]: disposeWorker(window: ${h.reply.windowId}, moduleId: ${h.process.moduleId})`),b.kill(),b.dispose(),this.workers.delete(E))}};e.UtilityProcessWorkerMainService=p,e.UtilityProcessWorkerMainService=p=Pe([re(0,y.ILogService),re(1,k.IWindowsMainService),re(2,R.ITelemetryService),re(3,u.ILifecycleMainService)],p);let v=class extends i.Disposable{constructor(h,E,b,g,I){super(),this.logService=h,this.windowsMainService=E,this.telemetryService=b,this.lifecycleMainService=g,this.configuration=I,this._onDidTerminate=this._register(new c.Emitter),this.onDidTerminate=this._onDidTerminate.event,this.utilityProcess=this._register(new A.WindowUtilityProcess(this.logService,this.windowsMainService,this.telemetryService,this.lifecycleMainService)),this.registerListeners()}registerListeners(){this._register(this.utilityProcess.onExit(h=>this._onDidTerminate.fire({code:h.code,signal:h.signal}))),this._register(this.utilityProcess.onCrash(h=>this._onDidTerminate.fire({code:h.code,signal:"ECRASH"})))}spawn(){const E=this.windowsMainService.getWindowById(this.configuration.reply.windowId)?.win?.webContents.getOSProcessId();return this.utilityProcess.start({type:this.configuration.process.type,entryPoint:this.configuration.process.moduleId,parentLifecycleBound:E,windowLifecycleBound:!0,correlationId:`${this.configuration.reply.windowId}`,responseWindowId:this.configuration.reply.windowId,responseChannel:this.configuration.reply.channel,responseNonce:this.configuration.reply.nonce})}kill(){this.utilityProcess.kill()}};v=Pe([re(0,y.ILogService),re(1,k.IWindowsMainService),re(2,R.ITelemetryService),re(3,u.ILifecycleMainService)],v)}),define(le[271],ue([0,1,13,4,2,245,29]),function(j,e,i,s,y,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewMainService=void 0;let R=class extends y.Disposable{constructor(c){super(),this.windowsMainService=c,this._onFoundInFrame=this._register(new s.Emitter),this.onFoundInFrame=this._onFoundInFrame.event,this._register(new k.WebviewProtocolProvider)}async setIgnoreMenuShortcuts(c,m){let u;if(typeof c.windowId=="number"){const{windowId:p}=c,v=this.windowsMainService.getWindowById(p);if(!v?.win)throw new Error(`Invalid windowId: ${p}`);u=v.win.webContents}else{const{webContentsId:p}=c;if(u=i.webContents.fromId(p),!u)throw new Error(`Invalid webContentsId: ${p}`)}u.isDestroyed()||u.setIgnoreMenuShortcuts(m)}async findInFrame(c,m,u,p){const f=this.getFrameByName(c,m);if(typeof f.findInFrame=="function"){f.findInFrame(u,{findNext:p.findNext,forward:p.forward});const h=(E,b)=>{b.finalUpdate&&(this._onFoundInFrame.fire(b),f.removeListener("found-in-frame",h))};f.on("found-in-frame",h)}}async stopFindInFrame(c,m,u){const v=this.getFrameByName(c,m);typeof v.stopFindInFrame=="function"&&v.stopFindInFrame(u.keepSelection?"keepSelection":"clearSelection")}getFrameByName(c,m){const u=this.windowsMainService.getWindowById(c.windowId);if(!u?.win)throw new Error(`Invalid windowId: ${c}`);const p=u.win.webContents.mainFrame.framesInSubtree.find(v=>v.name===m);if(!p)throw new Error(`Unknown frame: ${m}`);return p}};e.WebviewMainService=R,e.WebviewMainService=R=Pe([re(0,A.IWindowsMainService)],R)});var je=this&&this.__importDefault||function(j){return j&&j.__esModule?j:{default:j}};define(le[272],ue([0,1,13,2,3,18,7,16,19,5,34,29,52,30]),function(j,e,i,s,y,k,A,R,S,c,m,u,p,v){"use strict";var f;Object.defineProperty(e,"__esModule",{value:!0}),e.WindowsStateHandler=void 0,e.restoreWindowsState=E,e.getWindowsStateStoreData=g,i=je(i);let h=class extends s.Disposable{static{f=this}static{this.windowsStateStorageKey="windowsState"}get state(){return this._state}constructor(r,a,t,o,n){super(),this.windowsMainService=r,this.stateService=a,this.lifecycleMainService=t,this.logService=o,this.configurationService=n,this._state=E(this.stateService.getItem(f.windowsStateStorageKey)),this.lastClosedState=void 0,this.shuttingDown=!1,this.registerListeners()}registerListeners(){i.default.app.on("browser-window-blur",()=>{this.shuttingDown||this.saveWindowsState()}),this._register(this.lifecycleMainService.onBeforeCloseWindow(r=>this.onBeforeCloseWindow(r))),this._register(this.lifecycleMainService.onBeforeShutdown(()=>this.onBeforeShutdown())),this._register(this.windowsMainService.onDidChangeWindowsCount(r=>{r.newCount-r.oldCount>0&&(this.lastClosedState=void 0)})),this._register(this.windowsMainService.onDidDestroyWindow(r=>this.onBeforeCloseWindow(r)))}onBeforeShutdown(){this.shuttingDown=!0,this.saveWindowsState()}saveWindowsState(){const r=new Set,a={openedWindows:[],lastPluginDevelopmentHostWindow:this._state.lastPluginDevelopmentHostWindow,lastActiveWindow:this.lastClosedState};if(!a.lastActiveWindow){let n=this.windowsMainService.getLastActiveWindow();(!n||n.isExtensionDevelopmentHost)&&(n=this.windowsMainService.getWindows().find(l=>!l.isExtensionDevelopmentHost)),n&&(a.lastActiveWindow=this.toWindowState(n),a.lastActiveWindow.uiState.mode===p.WindowMode.Fullscreen&&r.add(a.lastActiveWindow.uiState.display))}const t=this.windowsMainService.getWindows().find(n=>n.isExtensionDevelopmentHost&&!n.isExtensionTestHost);t&&(a.lastPluginDevelopmentHostWindow=this.toWindowState(t),a.lastPluginDevelopmentHostWindow.uiState.mode===p.WindowMode.Fullscreen&&(r.has(a.lastPluginDevelopmentHostWindow.uiState.display)?y.isMacintosh&&!t.win?.isSimpleFullScreen()&&(a.lastPluginDevelopmentHostWindow.uiState.mode=p.WindowMode.Normal):r.add(a.lastPluginDevelopmentHostWindow.uiState.display))),this.windowsMainService.getWindowCount()>1&&(a.openedWindows=this.windowsMainService.getWindows().filter(n=>!n.isExtensionDevelopmentHost).map(n=>{const l=this.toWindowState(n);return l.uiState.mode===p.WindowMode.Fullscreen&&(r.has(l.uiState.display)?y.isMacintosh&&l.windowId!==a.lastActiveWindow?.windowId&&!n.win?.isSimpleFullScreen()&&(l.uiState.mode=p.WindowMode.Normal):r.add(l.uiState.display)),l}));const o=g(a);this.stateService.setItem(f.windowsStateStorageKey,o),this.shuttingDown&&this.logService.trace("[WindowsStateHandler] onBeforeShutdown",o)}onBeforeCloseWindow(r){if(this.lifecycleMainService.quitRequested)return;const a=this.toWindowState(r);r.isExtensionDevelopmentHost&&!r.isExtensionTestHost?this._state.lastPluginDevelopmentHostWindow=a:!r.isExtensionDevelopmentHost&&r.openedWorkspace&&this._state.openedWindows.forEach(t=>{const o=(0,v.isWorkspaceIdentifier)(r.openedWorkspace)&&t.workspace?.id===r.openedWorkspace.id,n=(0,v.isSingleFolderWorkspaceIdentifier)(r.openedWorkspace)&&t.folderUri&&k.extUriBiasedIgnorePathCase.isEqual(t.folderUri,r.openedWorkspace.uri);(o||n)&&(t.uiState=a.uiState)}),this.windowsMainService.getWindowCount()===1&&(this.lastClosedState=a)}toWindowState(r){return{windowId:r.id,workspace:(0,v.isWorkspaceIdentifier)(r.openedWorkspace)?r.openedWorkspace:void 0,folderUri:(0,v.isSingleFolderWorkspaceIdentifier)(r.openedWorkspace)?r.openedWorkspace.uri:void 0,backupPath:r.backupPath,remoteAuthority:r.remoteAuthority,uiState:r.serializeWindowState()}}getNewWindowState(r){const a=this.doGetNewWindowState(r),t=this.configurationService.getValue("window");if(a.mode===p.WindowMode.Fullscreen){let o;a.hasDefaultState?o=!!(t?.newWindowDimensions&&["fullscreen","inherit","offset"].indexOf(t.newWindowDimensions)>=0):o=!!(this.lifecycleMainService.wasRestarted||t?.restoreFullscreen),o||(a.mode=p.WindowMode.Normal)}return a}doGetNewWindowState(r){const a=this.windowsMainService.getLastActiveWindow();if(!r.extensionTestsPath){if(r.extensionDevelopmentPath&&this.state.lastPluginDevelopmentHostWindow)return this.state.lastPluginDevelopmentHostWindow.uiState;const D=r.workspace;if((0,v.isWorkspaceIdentifier)(D)){const M=this.state.openedWindows.filter(T=>T.workspace&&T.workspace.id===D.id).map(T=>T.uiState);if(M.length)return M[0]}if((0,v.isSingleFolderWorkspaceIdentifier)(D)){const M=this.state.openedWindows.filter(T=>T.folderUri&&k.extUriBiasedIgnorePathCase.isEqual(T.folderUri,D.uri)).map(T=>T.uiState);if(M.length)return M[0]}else if(r.backupPath){const M=this.state.openedWindows.filter(T=>T.backupPath===r.backupPath).map(T=>T.uiState);if(M.length)return M[0]}const w=this.lastClosedState||this.state.lastActiveWindow;if(!a&&w)return w.uiState}let t;const o=i.default.screen.getAllDisplays();if(o.length===1)t=o[0];else{if(y.isMacintosh){const D=i.default.screen.getCursorScreenPoint();t=i.default.screen.getDisplayNearestPoint(D)}!t&&a&&(t=i.default.screen.getDisplayMatching(a.getBounds())),t||(t=i.default.screen.getPrimaryDisplay()||o[0])}let n=(0,p.defaultWindowState)();n.x=Math.round(t.bounds.x+t.bounds.width/2-n.width/2),n.y=Math.round(t.bounds.y+t.bounds.height/2-n.height/2);const l=this.configurationService.getValue("window");let d=!0;if(l?.newWindowDimensions){if(l.newWindowDimensions==="maximized")n.mode=p.WindowMode.Maximized,d=!1;else if(l.newWindowDimensions==="fullscreen")n.mode=p.WindowMode.Fullscreen,d=!1;else if((l.newWindowDimensions==="inherit"||l.newWindowDimensions==="offset")&&a){const D=a.serializeWindowState();D.mode===p.WindowMode.Fullscreen?n.mode=p.WindowMode.Fullscreen:n={...D,zoomLevel:void 0},d=n.mode!==p.WindowMode.Fullscreen&&l.newWindowDimensions==="offset"}}return d&&(n=this.ensureNoOverlap(n)),n.hasDefaultState=!0,n}ensureNoOverlap(r){if(this.windowsMainService.getWindows().length===0)return r;r.x=typeof r.x=="number"?r.x:0,r.y=typeof r.y=="number"?r.y:0;const a=this.windowsMainService.getWindows().map(t=>t.getBounds());for(;a.some(t=>t.x===r.x||t.y===r.y);)r.x+=30,r.y+=30;return r}};e.WindowsStateHandler=h,e.WindowsStateHandler=h=f=Pe([re(0,u.IWindowsMainService),re(1,m.IStateService),re(2,S.ILifecycleMainService),re(3,c.ILogService),re(4,R.IConfigurationService)],h);function E(P){const r={openedWindows:[]},a=P||{openedWindows:[]};return a.lastActiveWindow&&(r.lastActiveWindow=b(a.lastActiveWindow)),a.lastPluginDevelopmentHostWindow&&(r.lastPluginDevelopmentHostWindow=b(a.lastPluginDevelopmentHostWindow)),Array.isArray(a.openedWindows)&&(r.openedWindows=a.openedWindows.map(t=>b(t))),r}function b(P){const r={uiState:P.uiState};return P.backupPath&&(r.backupPath=P.backupPath),P.remoteAuthority&&(r.remoteAuthority=P.remoteAuthority),P.folder&&(r.folderUri=A.URI.parse(P.folder)),P.workspaceIdentifier&&(r.workspace={id:P.workspaceIdentifier.id,configPath:A.URI.parse(P.workspaceIdentifier.configURIPath)}),r}function g(P){return{lastActiveWindow:P.lastActiveWindow&&I(P.lastActiveWindow),lastPluginDevelopmentHostWindow:P.lastPluginDevelopmentHostWindow&&I(P.lastPluginDevelopmentHostWindow),openedWindows:P.openedWindows.map(r=>I(r))}}function I(P){return{workspaceIdentifier:P.workspace&&{id:P.workspace.id,configURIPath:P.workspace.configPath.toString()},folder:P.folderUri&&P.folderUri.toString(),backupPath:P.backupPath,remoteAuthority:P.remoteAuthority,uiState:P.uiState}}});var je=this&&this.__importDefault||function(j){return j&&j.__esModule?j:{default:j}};define(le[59],ue([0,1,26,13,4,43,2,11,10,18,23,9,70,53,20,6,5,58,137,30,105,106]),function(j,e,i,s,y,k,A,R,S,c,m,u,p,v,f,h,E,b,g,I,P,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesManagementMainService=e.IWorkspacesManagementMainService=void 0,i=Re(i),s=je(s),e.IWorkspacesManagementMainService=(0,h.createDecorator)("workspacesManagementMainService");let a=class extends A.Disposable{constructor(o,n,l,d,D){super(),this.environmentMainService=o,this.logService=n,this.userDataProfilesMainService=l,this.backupMainService=d,this.dialogMainService=D,this._onDidDeleteUntitledWorkspace=this._register(new y.Emitter),this.onDidDeleteUntitledWorkspace=this._onDidDeleteUntitledWorkspace.event,this._onDidEnterWorkspace=this._register(new y.Emitter),this.onDidEnterWorkspace=this._onDidEnterWorkspace.event,this.untitledWorkspacesHome=this.environmentMainService.untitledWorkspacesHome,this.untitledWorkspaces=[]}async initialize(){this.untitledWorkspaces=[];try{const o=(await m.Promises.readdir(this.untitledWorkspacesHome.with({scheme:R.Schemas.file}).fsPath)).map(n=>(0,c.joinPath)(this.untitledWorkspacesHome,n,I.UNTITLED_WORKSPACE_NAME));for(const n of o){const l=(0,r.getWorkspaceIdentifier)(n),d=await this.resolveLocalWorkspace(n);d?this.untitledWorkspaces.push({workspace:l,remoteAuthority:d.remoteAuthority}):await this.deleteUntitledWorkspace(l)}}catch(o){o.code!=="ENOENT"&&this.logService.warn(`Unable to read folders in ${this.untitledWorkspacesHome} (${o}).`)}}resolveLocalWorkspace(o){return this.doResolveLocalWorkspace(o,n=>i.promises.readFile(n,"utf8"))}doResolveLocalWorkspace(o,n){if(this.isWorkspacePath(o)&&o.scheme===R.Schemas.file)try{const l=n(o.fsPath);return l instanceof Promise?l.then(d=>this.doResolveWorkspace(o,d),d=>{}):this.doResolveWorkspace(o,l)}catch{return}}isWorkspacePath(o){return(0,I.isUntitledWorkspace)(o,this.environmentMainService)||(0,I.hasWorkspaceFileExtension)(o)}doResolveWorkspace(o,n){try{const l=this.doParseStoredWorkspace(o,n),d=(0,r.getWorkspaceIdentifier)(o);return{id:d.id,configPath:d.configPath,folders:(0,P.toWorkspaceFolders)(l.folders,d.configPath,c.extUriBiasedIgnorePathCase),remoteAuthority:l.remoteAuthority,transient:l.transient}}catch(l){this.logService.warn(l.toString())}}doParseStoredWorkspace(o,n){const l=(0,k.parse)(n);if(l&&Array.isArray(l.folders))l.folders=l.folders.filter(d=>(0,P.isStoredWorkspaceFolder)(d));else throw new Error(`${o.toString(!0)} looks like an invalid workspace file.`);return l}async createUntitledWorkspace(o,n){const{workspace:l,storedWorkspace:d}=this.newUntitledWorkspace(o,n),D=l.configPath.fsPath;return await i.promises.mkdir((0,S.dirname)(D),{recursive:!0}),await m.Promises.writeFile(D,JSON.stringify(d,null,"	")),this.untitledWorkspaces.push({workspace:l,remoteAuthority:n}),l}newUntitledWorkspace(o=[],n){const l=(Date.now()+Math.round(Math.random()*1e3)).toString(),d=(0,c.joinPath)(this.untitledWorkspacesHome,l),D=(0,c.joinPath)(d,I.UNTITLED_WORKSPACE_NAME),w=[];for(const M of o)w.push((0,P.getStoredWorkspaceFolder)(M.uri,!0,M.name,d,c.extUriBiasedIgnorePathCase));return{workspace:(0,r.getWorkspaceIdentifier)(D),storedWorkspace:{folders:w,remoteAuthority:n}}}async getWorkspaceIdentifier(o){return(0,r.getWorkspaceIdentifier)(o)}isUntitledWorkspace(o){return(0,I.isUntitledWorkspace)(o.configPath,this.environmentMainService)}async deleteUntitledWorkspace(o){this.isUntitledWorkspace(o)&&(await this.doDeleteUntitledWorkspace(o),this.userDataProfilesMainService.isEnabled()&&this.userDataProfilesMainService.unsetWorkspace(o),this._onDidDeleteUntitledWorkspace.fire(o))}async doDeleteUntitledWorkspace(o){const n=(0,c.originalFSPath)(o.configPath);try{await m.Promises.rm((0,S.dirname)(n));const l=(0,S.join)(this.environmentMainService.workspaceStorageHome.with({scheme:R.Schemas.file}).fsPath,o.id);await m.Promises.exists(l)&&await m.Promises.writeFile((0,S.join)(l,"obsolete"),""),this.untitledWorkspaces=this.untitledWorkspaces.filter(d=>d.workspace.id!==o.id)}catch(l){this.logService.warn(`Unable to delete untitled workspace ${n} (${l}).`)}}getUntitledWorkspaces(){return this.untitledWorkspaces}async enterWorkspace(o,n,l){if(!o||!o.win||!o.isReady||!await this.isValidTargetWorkspacePath(o,n,l))return;const D=await this.doEnterWorkspace(o,(0,r.getWorkspaceIdentifier)(l));if(D)return this._onDidEnterWorkspace.fire({window:o,workspace:D.workspace}),D}async isValidTargetWorkspacePath(o,n,l){return l?(0,I.isWorkspaceIdentifier)(o.openedWorkspace)&&c.extUriBiasedIgnorePathCase.isEqual(o.openedWorkspace.configPath,l)?!1:(0,g.findWindowOnWorkspaceOrFolder)(n,l)?(await this.dialogMainService.showMessageBox({type:"info",buttons:[(0,u.localize)(2500,null)],message:(0,u.localize)(2501,null,(0,c.basename)(l)),detail:(0,u.localize)(2502,null)},s.default.BrowserWindow.getFocusedWindow()??void 0),!1):!0:!0}async doEnterWorkspace(o,n){if(!o.config)return;o.focus();let l;return o.config.extensionDevelopmentPath||(o.config.backupPath?l=await this.backupMainService.registerWorkspaceBackup({workspace:n,remoteAuthority:o.remoteAuthority},o.config.backupPath):l=this.backupMainService.registerWorkspaceBackup({workspace:n,remoteAuthority:o.remoteAuthority})),(0,I.isWorkspaceIdentifier)(o.openedWorkspace)&&this.isUntitledWorkspace(o.openedWorkspace)&&await this.deleteUntitledWorkspace(o.openedWorkspace),o.config.workspace=n,o.config.backupPath=l,{workspace:n,backupPath:l}}};e.WorkspacesManagementMainService=a,e.WorkspacesManagementMainService=a=Pe([re(0,f.IEnvironmentMainService),re(1,E.ILogService),re(2,b.IUserDataProfilesMainService),re(3,p.IBackupMainService),re(4,v.IDialogMainService)],a)}),define(le[139],ue([0,1,13,35,22,6,29,30,59,12,5,64]),function(j,e,i,s,y,k,A,R,S,c,m,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsMainService=e.IDiagnosticsMainService=e.ID=void 0,e.ID="diagnosticsMainService",e.IDiagnosticsMainService=(0,k.createDecorator)(e.ID);let p=class{constructor(f,h,E){this.windowsMainService=f,this.workspacesManagementMainService=h,this.logService=E}async getRemoteDiagnostics(f){const h=this.windowsMainService.getWindows();return(await Promise.all(h.map(async b=>{const g=b.remoteAuthority;if(!g)return;const I=`vscode:getDiagnosticInfoResponse${b.id}`,P={includeProcesses:f.includeProcesses,folders:f.includeWorkspaceMetadata?await this.getFolderURIs(b):void 0};return new Promise(r=>{b.sendWhenReady("vscode:getDiagnosticInfo",y.CancellationToken.None,{replyChannel:I,args:P}),s.validatedIpcMain.once(I,(a,t)=>{t||r({hostName:g,errorMessage:`Unable to resolve connection to '${g}'.`}),r(t)}),setTimeout(()=>{r({hostName:g,errorMessage:`Connection to '${g}' could not be established`})},5e3)})}))).filter(b=>!!b)}async getMainDiagnostics(){this.logService.trace("Received request for main process info from other instance.");const f=[];for(const E of i.BrowserWindow.getAllWindows()){const b=this.windowsMainService.getWindowById(E.id);b?f.push(await this.codeWindowToInfo(b)):f.push(this.browserWindowToInfo(E))}const h=[];for(const{pid:E,name:b}of u.UtilityProcess.getAll())h.push({pid:E,name:b});return{mainPID:process.pid,mainArguments:process.argv.slice(1),windows:f,pidToNames:h,screenReader:!!i.app.accessibilitySupportEnabled,gpuFeatureStatus:i.app.getGPUFeatureStatus()}}async codeWindowToInfo(f){const h=await this.getFolderURIs(f),E=(0,c.assertIsDefined)(f.win);return this.browserWindowToInfo(E,h,f.remoteAuthority)}browserWindowToInfo(f,h=[],E){return{id:f.id,pid:f.webContents.getOSProcessId(),title:f.getTitle(),folderURIs:h,remoteAuthority:E}}async getFolderURIs(f){const h=[],E=f.openedWorkspace;if((0,R.isSingleFolderWorkspaceIdentifier)(E))h.push(E.uri);else if((0,R.isWorkspaceIdentifier)(E)){const b=await this.workspacesManagementMainService.resolveLocalWorkspace(E.configPath);b&&b.folders.forEach(I=>{h.push(I.uri)})}return h}};e.DiagnosticsMainService=p,e.DiagnosticsMainService=p=Pe([re(0,A.IWindowsMainService),re(1,S.IWorkspacesManagementMainService),re(2,m.ILogService)],p)}),define(le[65],ue([0,1,26,44,13,27,162,54,4,2,11,10,3,7,117,95,23,114,9,53,20,6,19,5,28,77,47,29,30,59,17,216,206,85,15,16,138,50]),function(j,e,i,s,y,k,A,R,S,c,m,u,p,v,f,h,E,b,g,I,P,r,a,t,o,n,l,d,D,w,M,T,C,L,_,V,z,Q){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeHostMainService=e.INativeHostMainService=void 0,i=Re(i),e.INativeHostMainService=(0,r.createDecorator)("nativeHostMainService");let fe=class extends c.Disposable{constructor(ee,U,K,N,x,W,q,ie,H,ce,oe,te){super(),this.windowsMainService=ee,this.auxiliaryWindowsMainService=U,this.dialogMainService=K,this.lifecycleMainService=N,this.environmentMainService=x,this.logService=W,this.productService=q,this.themeMainService=ie,this.workspacesManagementMainService=H,this.configurationService=ce,this.requestService=oe,this.proxyAuthService=te,this.onDidOpenMainWindow=S.Event.map(this.windowsMainService.onDidOpenWindow,O=>O.id),this.onDidTriggerWindowSystemContextMenu=S.Event.any(S.Event.map(this.windowsMainService.onDidTriggerSystemContextMenu,({window:O,x:X,y:B})=>({windowId:O.id,x:X,y:B})),S.Event.map(this.auxiliaryWindowsMainService.onDidTriggerSystemContextMenu,({window:O,x:X,y:B})=>({windowId:O.id,x:X,y:B}))),this.onDidMaximizeWindow=S.Event.any(S.Event.map(this.windowsMainService.onDidMaximizeWindow,O=>O.id),S.Event.map(this.auxiliaryWindowsMainService.onDidMaximizeWindow,O=>O.id)),this.onDidUnmaximizeWindow=S.Event.any(S.Event.map(this.windowsMainService.onDidUnmaximizeWindow,O=>O.id),S.Event.map(this.auxiliaryWindowsMainService.onDidUnmaximizeWindow,O=>O.id)),this.onDidChangeWindowFullScreen=S.Event.any(S.Event.map(this.windowsMainService.onDidChangeFullScreen,O=>({windowId:O.window.id,fullscreen:O.fullscreen})),S.Event.map(this.auxiliaryWindowsMainService.onDidChangeFullScreen,O=>({windowId:O.window.id,fullscreen:O.fullscreen}))),this.onDidBlurMainWindow=S.Event.filter(S.Event.fromNodeEventEmitter(y.app,"browser-window-blur",(O,X)=>X.id),O=>!!this.windowsMainService.getWindowById(O)),this.onDidFocusMainWindow=S.Event.any(S.Event.map(S.Event.filter(S.Event.map(this.windowsMainService.onDidChangeWindowsCount,()=>this.windowsMainService.getLastActiveWindow()),O=>!!O),O=>O.id),S.Event.filter(S.Event.fromNodeEventEmitter(y.app,"browser-window-focus",(O,X)=>X.id),O=>!!this.windowsMainService.getWindowById(O))),this.onDidBlurMainOrAuxiliaryWindow=S.Event.any(this.onDidBlurMainWindow,S.Event.map(S.Event.filter(S.Event.fromNodeEventEmitter(y.app,"browser-window-blur",(O,X)=>this.auxiliaryWindowsMainService.getWindowByWebContents(X.webContents)),O=>!!O),O=>O.id)),this.onDidFocusMainOrAuxiliaryWindow=S.Event.any(this.onDidFocusMainWindow,S.Event.map(S.Event.filter(S.Event.fromNodeEventEmitter(y.app,"browser-window-focus",(O,X)=>this.auxiliaryWindowsMainService.getWindowByWebContents(X.webContents)),O=>!!O),O=>O.id)),this.onDidResumeOS=S.Event.fromNodeEventEmitter(y.powerMonitor,"resume"),this.onDidChangeColorScheme=this.themeMainService.onDidChangeColorScheme,this._onDidChangePassword=this._register(new S.Emitter),this.onDidChangePassword=this._onDidChangePassword.event,this.onDidChangeDisplay=S.Event.debounce(S.Event.any(S.Event.filter(S.Event.fromNodeEventEmitter(y.screen,"display-metrics-changed",(O,X,B)=>B),O=>!(Array.isArray(O)&&O.length===1&&O[0]==="workArea")),S.Event.fromNodeEventEmitter(y.screen,"display-added"),S.Event.fromNodeEventEmitter(y.screen,"display-removed")),()=>{},100)}get windowId(){throw new Error("Not implemented in electron-main")}async getWindows(ee,U){const K=this.windowsMainService.getWindows().map(x=>({id:x.id,workspace:x.openedWorkspace??(0,D.toWorkspaceIdentifier)(x.backupPath,x.isExtensionDevelopmentHost),title:x.win?.getTitle()??"",filename:x.getRepresentedFilename(),dirty:x.isDocumentEdited()})),N=[];return U.includeAuxiliaryWindows&&N.push(...this.auxiliaryWindowsMainService.getWindows().map(x=>({id:x.id,parentId:x.parentId,title:x.win?.getTitle()??"",filename:x.getRepresentedFilename()}))),[...K,...N]}async getWindowCount(ee){return this.windowsMainService.getWindowCount()}async getActiveWindowId(ee){const U=this.windowsMainService.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(U)return U.id}async getActiveWindowPosition(){const ee=this.windowsMainService.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(ee)return ee.getBounds()}openWindow(ee,U,K){return Array.isArray(U)?this.doOpenWindow(ee,U,K):this.doOpenEmptyWindow(ee,U)}async doOpenWindow(ee,U,K=Object.create(null)){U.length>0&&await this.windowsMainService.open({context:d.OpenContext.API,contextWindowId:ee,urisToOpen:U,cli:this.environmentMainService.args,forceNewWindow:K.forceNewWindow,forceReuseWindow:K.forceReuseWindow,preferNewWindow:K.preferNewWindow,diffMode:K.diffMode,mergeMode:K.mergeMode,addMode:K.addMode,gotoLineMode:K.gotoLineMode,noRecentEntry:K.noRecentEntry,waitMarkerFileURI:K.waitMarkerFileURI,remoteAuthority:K.remoteAuthority||void 0,forceProfile:K.forceProfile,forceTempProfile:K.forceTempProfile})}async doOpenEmptyWindow(ee,U){await this.windowsMainService.openEmptyWindow({context:d.OpenContext.API,contextWindowId:ee},U)}async isFullScreen(ee,U){return this.windowById(U?.targetWindowId,ee)?.isFullScreen??!1}async toggleFullScreen(ee,U){this.windowById(U?.targetWindowId,ee)?.toggleFullScreen()}async handleTitleDoubleClick(ee,U){this.windowById(U?.targetWindowId,ee)?.handleTitleDoubleClick()}async getCursorScreenPoint(ee){const U=y.screen.getCursorScreenPoint(),K=y.screen.getDisplayNearestPoint(U);return{point:U,display:K.bounds}}async isMaximized(ee,U){return this.windowById(U?.targetWindowId,ee)?.win?.isMaximized()??!1}async maximizeWindow(ee,U){this.windowById(U?.targetWindowId,ee)?.win?.maximize()}async unmaximizeWindow(ee,U){this.windowById(U?.targetWindowId,ee)?.win?.unmaximize()}async minimizeWindow(ee,U){this.windowById(U?.targetWindowId,ee)?.win?.minimize()}async moveWindowTop(ee,U){this.windowById(U?.targetWindowId,ee)?.win?.moveTop()}async positionWindow(ee,U,K){const N=this.windowById(K?.targetWindowId,ee);if(N?.win){if(N.win.isFullScreen()){const x=S.Event.toPromise(S.Event.once(S.Event.fromNodeEventEmitter(N.win,"leave-full-screen")));N.win.setFullScreen(!1),await x}N.win.setBounds(U)}}async updateWindowControls(ee,U){this.windowById(U?.targetWindowId,ee)?.updateWindowControls(U)}async focusWindow(ee,U){this.windowById(U?.targetWindowId,ee)?.focus({force:U?.force??!1})}async setMinimumSize(ee,U,K){const N=this.codeWindowById(ee);if(N?.win){const[x,W]=N.win.getSize(),[q,ie]=N.win.getMinimumSize(),[H,ce]=[U??q,K??ie],[oe,te]=[Math.max(x,H),Math.max(W,ce)];(q!==H||ie!==ce)&&N.win.setMinimumSize(H,ce),(x!==oe||W!==te)&&N.win.setSize(oe,te)}}async saveWindowSplash(ee,U){this.themeMainService.saveWindowSplash(ee,U)}async installShellCommand(ee){const{source:U,target:K}=await this.getShellCommandLink();try{const{symbolicLink:N}=await E.SymlinkSupport.stat(U);if(N&&!N.dangling){const x=await(0,f.realpath)(U);if(K===x)return}await i.promises.unlink(U)}catch(N){if(N.code!=="ENOENT")throw N}try{await i.promises.symlink(K,U)}catch(N){if(N.code!=="EACCES"&&N.code!=="ENOENT")throw N;const{response:x}=await this.showMessageBox(ee,{type:"info",message:(0,g.localize)(2004,null,this.productService.nameShort),buttons:[(0,g.localize)(2005,null),(0,g.localize)(2006,null)]});if(x===1)throw new _.CancellationError;try{const W=`osascript -e "do shell script \\"mkdir -p /usr/local/bin && ln -sf '${K}' '${U}'\\" with administrator privileges"`;await(0,A.promisify)(s.exec)(W)}catch{throw new Error((0,g.localize)(2007,null,U))}}}async uninstallShellCommand(ee){const{source:U}=await this.getShellCommandLink();try{await i.promises.unlink(U)}catch(K){switch(K.code){case"EACCES":{const{response:N}=await this.showMessageBox(ee,{type:"info",message:(0,g.localize)(2008,null,this.productService.nameShort),buttons:[(0,g.localize)(2009,null),(0,g.localize)(2010,null)]});if(N===1)throw new _.CancellationError;try{const x=`osascript -e "do shell script \\"rm '${U}'\\" with administrator privileges"`;await(0,A.promisify)(s.exec)(x)}catch{throw new Error((0,g.localize)(2011,null,U))}break}case"ENOENT":break;default:throw K}}}async getShellCommandLink(){const ee=(0,u.resolve)(this.environmentMainService.appRoot,"bin",this.productService.applicationName),U=`/usr/local/bin/${this.productService.applicationName}`;if(!await E.Promises.exists(ee))throw new Error((0,g.localize)(2012,null,ee));return{source:U,target:ee}}async showMessageBox(ee,U){const K=this.windowById(U?.targetWindowId,ee);return this.dialogMainService.showMessageBox(U,K?.win??void 0)}async showSaveDialog(ee,U){const K=this.windowById(U?.targetWindowId,ee);return this.dialogMainService.showSaveDialog(U,K?.win??void 0)}async showOpenDialog(ee,U){const K=this.windowById(U?.targetWindowId,ee);return this.dialogMainService.showOpenDialog(U,K?.win??void 0)}async pickFileFolderAndOpen(ee,U){const K=await this.dialogMainService.pickFileFolder(U);K&&await this.doOpenPicked(await Promise.all(K.map(async N=>await E.SymlinkSupport.existsDirectory(N)?{folderUri:v.URI.file(N)}:{fileUri:v.URI.file(N)})),U,ee)}async pickFolderAndOpen(ee,U){const K=await this.dialogMainService.pickFolder(U);K&&await this.doOpenPicked(K.map(N=>({folderUri:v.URI.file(N)})),U,ee)}async pickFileAndOpen(ee,U){const K=await this.dialogMainService.pickFile(U);K&&await this.doOpenPicked(K.map(N=>({fileUri:v.URI.file(N)})),U,ee)}async pickWorkspaceAndOpen(ee,U){const K=await this.dialogMainService.pickWorkspace(U);K&&await this.doOpenPicked(K.map(N=>({workspaceUri:v.URI.file(N)})),U,ee)}async doOpenPicked(ee,U,K){await this.windowsMainService.open({context:d.OpenContext.DIALOG,contextWindowId:K,cli:this.environmentMainService.args,urisToOpen:ee,forceNewWindow:U.forceNewWindow})}async showItemInFolder(ee,U){y.shell.showItemInFolder(U)}async setRepresentedFilename(ee,U,K){this.windowById(K?.targetWindowId,ee)?.setRepresentedFilename(U)}async setDocumentEdited(ee,U,K){this.windowById(K?.targetWindowId,ee)?.setDocumentEdited(U)}async openExternal(ee,U,K){this.environmentMainService.unsetSnapExportedVariables();try{(0,m.matchesSomeScheme)(U,m.Schemas.http,m.Schemas.https)?this.openExternalBrowser(U,K):y.shell.openExternal(U)}finally{this.environmentMainService.restoreSnapExportedVariables()}return!0}async openExternalBrowser(ee,U){const K=U??this.configurationService.getValue("workbench.externalBrowser");if(!K)return y.shell.openExternal(ee);if((K.includes(u.posix.sep)||K.includes(u.win32.sep))&&!await E.Promises.exists(K))return this.logService.error(`Configured external browser path does not exist: ${K}`),y.shell.openExternal(ee);try{const{default:N}=await new Promise((W,q)=>{j(["open"],W,q)}).then(Re);(await N(ee,{app:{name:Object.hasOwn(N.apps,K)?N.apps[K]:K}})).stderr?.once("data",W=>(this.logService.error(`Error openening external URL '${ee}' using browser '${K}': ${W.toString()}`),y.shell.openExternal(ee)))}catch(N){return this.logService.error(`Unable to open external URL '${ee}' using browser '${K}' due to ${N}.`),y.shell.openExternal(ee)}}moveItemToTrash(ee,U){return y.shell.trashItem(U)}async isAdmin(){let ee;return p.isWindows?ee=(await new Promise((U,K)=>{j(["native-is-elevated"],U,K)}).then(Re)).default():ee=process.getuid?.()===0,ee}async writeElevated(ee,U,K,N){const x=await new Promise((W,q)=>{j(["@vscode/sudo-prompt"],W,q)}).then(Re);return new Promise((W,q)=>{const ie=[`"${this.cliPath}"`];N?.unlock&&ie.push("--file-chmod"),ie.push("--file-write",`"${U.fsPath}"`,`"${K.fsPath}"`);const H={name:this.productService.nameLong.replace("-",""),icns:p.isMacintosh&&this.environmentMainService.isBuilt?(0,u.join)((0,u.dirname)(this.environmentMainService.appRoot),`${this.productService.nameShort}.icns`):void 0};x.exec(ie.join(" "),H,(ce,oe,te)=>{oe&&this.logService.trace(`[sudo-prompt] received stdout: ${oe}`),te&&this.logService.trace(`[sudo-prompt] received stderr: ${te}`),ce?q(ce):W(void 0)})})}async isRunningUnderARM64Translation(){return p.isLinux||p.isWindows?!1:y.app.runningUnderARM64Translation}get cliPath(){return p.isWindows?this.environmentMainService.isBuilt?(0,u.join)((0,u.dirname)(process.execPath),"bin",`${this.productService.applicationName}.cmd`):(0,u.join)(this.environmentMainService.appRoot,"scripts","code-cli.bat"):p.isLinux?this.environmentMainService.isBuilt?(0,u.join)((0,u.dirname)(process.execPath),"bin",`${this.productService.applicationName}`):(0,u.join)(this.environmentMainService.appRoot,"scripts","code-cli.sh"):this.environmentMainService.isBuilt?(0,u.join)(this.environmentMainService.appRoot,"bin",`${this.productService.applicationName}`):(0,u.join)(this.environmentMainService.appRoot,"scripts","code-cli.sh")}async getOSStatistics(){return{totalmem:(0,k.totalmem)(),freemem:(0,k.freemem)(),loadavg:(0,k.loadavg)()}}async getOSProperties(){return{arch:(0,k.arch)(),platform:(0,k.platform)(),release:(0,k.release)(),type:(0,k.type)(),cpus:(0,k.cpus)()}}async getOSVirtualMachineHint(){return h.virtualMachineHint.value()}async getOSColorScheme(){return this.themeMainService.getColorScheme()}async hasWSLFeatureInstalled(){return p.isWindows&&(0,T.hasWSLFeatureInstalled)()}async getProcessId(ee){return this.windowById(void 0,ee)?.win?.webContents.getOSProcessId()}async killProcess(ee,U,K){process.kill(U,K)}async readClipboardText(ee,U){return y.clipboard.readText(U)}async writeClipboardText(ee,U,K){return y.clipboard.writeText(U,K)}async readClipboardFindText(ee){return y.clipboard.readFindText()}async writeClipboardFindText(ee,U){return y.clipboard.writeFindText(U)}async writeClipboardBuffer(ee,U,K,N){return y.clipboard.writeBuffer(U,Buffer.from(K.buffer),N)}async readClipboardBuffer(ee,U){return M.VSBuffer.wrap(y.clipboard.readBuffer(U))}async hasClipboard(ee,U,K){return y.clipboard.has(U,K)}async newWindowTab(){await this.windowsMainService.open({context:d.OpenContext.API,cli:this.environmentMainService.args,forceNewTabbedWindow:!0,forceEmpty:!0,remoteAuthority:this.environmentMainService.args.remote||void 0})}async showPreviousWindowTab(){y.Menu.sendActionToFirstResponder("selectPreviousTab:")}async showNextWindowTab(){y.Menu.sendActionToFirstResponder("selectNextTab:")}async moveWindowTabToNewWindow(){y.Menu.sendActionToFirstResponder("moveTabToNewWindow:")}async mergeAllWindowTabs(){y.Menu.sendActionToFirstResponder("mergeAllWindows:")}async toggleWindowTabsBar(){y.Menu.sendActionToFirstResponder("toggleTabBar:")}async updateTouchBar(ee,U){this.codeWindowById(ee)?.updateTouchBar(U)}async notifyReady(ee){this.codeWindowById(ee)?.setReady()}async relaunch(ee,U){return this.lifecycleMainService.relaunch(U)}async reload(ee,U){const K=this.codeWindowById(ee);if(K){if((0,D.isWorkspaceIdentifier)(K.openedWorkspace)){const N=K.openedWorkspace.configPath;if(N.scheme===m.Schemas.file&&(await this.workspacesManagementMainService.resolveLocalWorkspace(N))?.transient)return this.openWindow(K.id,{forceReuseWindow:!0})}return this.lifecycleMainService.reload(K,U?.disableExtensions!==void 0?{_:[],"disable-extensions":U.disableExtensions}:void 0)}}async closeWindow(ee,U){return this.windowById(U?.targetWindowId,ee)?.win?.close()}async quit(ee){const U=this.windowsMainService.getLastActiveWindow();U?.isExtensionDevelopmentHost&&this.windowsMainService.getWindowCount()>1&&U.win?U.win.close():this.lifecycleMainService.quit()}async exit(ee,U){await this.lifecycleMainService.kill(U)}async resolveProxy(ee,U){if(this.environmentMainService.extensionTestsLocationURI){const x=this.configurationService.getValue("integration-test.http.proxy");if(x)return x}return this.codeWindowById(ee)?.win?.webContents?.session?.resolveProxy(U)}async lookupAuthorization(ee,U){return this.proxyAuthService.lookupAuthorization(U)}async lookupKerberosAuthorization(ee,U){return this.requestService.lookupKerberosAuthorization(U)}async loadCertificates(ee){return this.requestService.loadCertificates()}findFreePort(ee,U,K,N,x=1){return(0,b.findFreePort)(U,K,N,x)}async openDevTools(ee,U){const K=this.windowById(U?.targetWindowId,ee);let N;p.isLinux&&(0,l.useWindowControlsOverlay)(this.configurationService)&&(N="bottom"),K?.win?.webContents.openDevTools(N?{mode:N}:void 0)}async toggleDevTools(ee,U){const N=this.windowById(U?.targetWindowId,ee)?.win?.webContents;N&&(p.isLinux&&(0,l.useWindowControlsOverlay)(this.configurationService)&&!N.isDevToolsOpened()?N.openDevTools({mode:"bottom"}):N.toggleDevTools())}async profileRenderer(ee,U,K){const N=this.codeWindowById(ee);if(!N||!N.win)throw new Error;return await new C.WindowProfiler(N.win,U,this.logService).inspect(K)}async windowsGetStringRegKey(ee,U,K,N){if(!p.isWindows)return;const x=await new Promise((W,q)=>{j(["@vscode/windows-registry"],W,q)}).then(Re);try{return x.GetStringRegKey(U,K,N)}catch{return}}windowById(ee,U){return this.codeWindowById(ee)??this.auxiliaryWindowById(ee)??this.codeWindowById(U)}codeWindowById(ee){if(typeof ee=="number")return this.windowsMainService.getWindowById(ee)}auxiliaryWindowById(ee){if(typeof ee!="number")return;const U=y.webContents.fromId(ee);if(U)return this.auxiliaryWindowsMainService.getWindowByWebContents(U)}};e.NativeHostMainService=fe,Pe([R.memoize],fe.prototype,"cliPath",null),e.NativeHostMainService=fe=Pe([re(0,d.IWindowsMainService),re(1,L.IAuxiliaryWindowsMainService),re(2,I.IDialogMainService),re(3,a.ILifecycleMainService),re(4,P.IEnvironmentMainService),re(5,t.ILogService),re(6,o.IProductService),re(7,n.IThemeMainService),re(8,w.IWorkspacesManagementMainService),re(9,V.IConfigurationService),re(10,Q.IRequestService),re(11,z.IProxyAuthService)],fe)});var je=this&&this.__importDefault||function(j){return j&&j.__esModule?j:{default:j}};define(le[273],ue([0,1,13,27,8,22,2,11,3,35,9,53,20,5,65,73,74,47,29,66,86]),function(j,e,i,s,y,k,A,R,S,c,m,u,p,v,f,h,E,b,g,I,P){"use strict";var r;Object.defineProperty(e,"__esModule",{value:!0}),e.IssueMainService=void 0,h=je(h);let a=class{static{r=this}static{this.DEFAULT_BACKGROUND_COLOR="#1E1E1E"}constructor(o,n,l,d,D,w,M,T){this.userEnv=o,this.environmentMainService=n,this.logService=l,this.dialogMainService=d,this.nativeHostMainService=D,this.protocolMainService=w,this.windowsMainService=M,this.cssDevelopmentService=T,this.issueReporterWindow=null,this.issueReporterParentWindow=null}async openReporter(o){if(this.issueReporterWindow)this.issueReporterWindow&&this.focusWindow(this.issueReporterWindow);else if(this.issueReporterParentWindow=i.BrowserWindow.getFocusedWindow(),this.issueReporterParentWindow){const n=new A.DisposableStore,l=n.add(this.protocolMainService.createIPCObjectUrl()),d=this.getWindowPosition(this.issueReporterParentWindow,700,800);this.issueReporterWindow=this.createBrowserWindow(d,l,{backgroundColor:o.styles.backgroundColor,title:(0,m.localize)(1909,null),zoomLevel:o.zoomLevel,alwaysOnTop:!1},"issue-reporter"),l.update({appRoot:this.environmentMainService.appRoot,windowId:this.issueReporterWindow.id,userEnv:this.userEnv,data:o,disableExtensions:!!this.environmentMainService.disableExtensions,os:{type:(0,s.type)(),arch:(0,s.arch)(),release:(0,s.release)()},product:h.default,nls:{messages:(0,m.getNLSMessages)(),language:(0,m.getNLSLanguage)()},cssModules:this.cssDevelopmentService.isEnabled?await this.cssDevelopmentService.getCssModules():void 0}),this.issueReporterWindow.loadURL(R.FileAccess.asBrowserUri(`vs/workbench/contrib/issue/electron-sandbox/issueReporter${this.environmentMainService.isBuilt?"":"-dev"}.${I.isESM?"esm.":""}html`).toString(!0)),this.issueReporterWindow.on("close",()=>{this.issueReporterWindow=null,n.dispose()}),this.issueReporterParentWindow.on("closed",()=>{this.issueReporterWindow&&(this.issueReporterWindow.close(),this.issueReporterWindow=null,n.dispose())})}}async $reloadWithExtensionsDisabled(){if(this.issueReporterParentWindow)try{await this.nativeHostMainService.reload(this.issueReporterParentWindow.id,{disableExtensions:!0})}catch(o){this.logService.error(o)}}async $showConfirmCloseDialog(){if(this.issueReporterWindow){const{response:o}=await this.dialogMainService.showMessageBox({type:"warning",message:(0,m.localize)(1910,null),buttons:[(0,m.localize)(1911,null),(0,m.localize)(1912,null)]},this.issueReporterWindow);o===0&&this.issueReporterWindow&&(this.issueReporterWindow.destroy(),this.issueReporterWindow=null)}}async $showClipboardDialog(){if(this.issueReporterWindow){const{response:o}=await this.dialogMainService.showMessageBox({type:"warning",message:(0,m.localize)(1913,null),buttons:[(0,m.localize)(1914,null),(0,m.localize)(1915,null)]},this.issueReporterWindow);return o===0}return!1}issueReporterWindowCheck(){if(!this.issueReporterParentWindow)throw new Error("Issue reporter window not available");const o=this.windowsMainService.getWindowById(this.issueReporterParentWindow.id);if(!o)throw new Error("Window not found");return o}async $sendReporterMenu(o,n){const l=this.issueReporterWindowCheck(),d="vscode:triggerReporterMenu",D=new k.CancellationTokenSource;return l.sendWhenReady(d,D.token,{replyChannel:d,extensionId:o,extensionName:n}),await(0,y.raceTimeout)(new Promise(M=>c.validatedIpcMain.once(`vscode:triggerReporterMenuResponse:${o}`,(T,C)=>M(C))),5e3,()=>{this.logService.error(`Error: Extension ${o} timed out waiting for menu response`),D.cancel()})}async $closeReporter(){this.issueReporterWindow?.close()}focusWindow(o){o.isMinimized()&&o.restore(),o.focus()}createBrowserWindow(o,n,l,d){const D=new i.BrowserWindow({fullscreen:!1,skipTaskbar:!1,resizable:!0,width:o.width,height:o.height,minWidth:300,minHeight:200,x:o.x,y:o.y,title:l.title,backgroundColor:l.backgroundColor||r.DEFAULT_BACKGROUND_COLOR,webPreferences:{preload:R.FileAccess.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${n.resource.toString()}`],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,b.zoomLevelToZoomFactor)(l.zoomLevel),sandbox:!0},alwaysOnTop:l.alwaysOnTop,experimentalDarkMode:!0});return D.setMenuBarVisibility(!1),D}getWindowPosition(o,n,l){let d;const D=i.screen.getAllDisplays();if(D.length===1)d=D[0];else{if(S.isMacintosh){const T=i.screen.getCursorScreenPoint();d=i.screen.getDisplayNearestPoint(T)}!d&&o&&(d=i.screen.getDisplayMatching(o.getBounds())),d||(d=i.screen.getPrimaryDisplay()||D[0])}const w=d.bounds,M={width:n,height:l,x:w.x+w.width/2-n/2,y:w.y+w.height/2-l/2};return w.width>0&&w.height>0&&(M.x<w.x&&(M.x=w.x),M.y<w.y&&(M.y=w.y),M.x>w.x+w.width&&(M.x=w.x),M.y>w.y+w.height&&(M.y=w.y),M.width>w.width&&(M.width=w.width),M.height>w.height&&(M.height=w.height)),M}};e.IssueMainService=a,e.IssueMainService=a=r=Pe([re(1,p.IEnvironmentMainService),re(2,v.ILogService),re(3,u.IDialogMainService),re(4,f.INativeHostMainService),re(5,E.IProtocolMainService),re(6,g.IWindowsMainService),re(7,P.ICSSDevelopmentService)],a)});var je=this&&this.__importDefault||function(j){return j&&j.__esModule?j:{default:j}};define(le[274],ue([0,1,13,32,2,11,3,119,35,9,99,139,53,20,86,5,65,73,28,74,34,64,47,66]),function(j,e,i,s,y,k,A,R,S,c,m,u,p,v,f,h,E,b,g,I,P,r,a,t){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.ProcessMainService=void 0,b=je(b);const n="issue.processExplorerWindowState";let l=class{static{o=this}static{this.DEFAULT_BACKGROUND_COLOR="#1E1E1E"}constructor(w,M,T,C,L,_,V,z,Q,fe,se){this.userEnv=w,this.environmentMainService=M,this.logService=T,this.diagnosticsService=C,this.diagnosticsMainService=L,this.dialogMainService=_,this.nativeHostMainService=V,this.protocolMainService=z,this.productService=Q,this.stateService=fe,this.cssDevelopmentService=se,this.processExplorerWindow=null,this.processExplorerParentWindow=null,this.registerListeners()}registerListeners(){S.validatedIpcMain.on("vscode:listProcesses",async w=>{const M=[];try{M.push({name:(0,c.localize)(1916,null),rootProcess:await(0,R.listProcesses)(process.pid)}),(await this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!0})).forEach(C=>{(0,m.isRemoteDiagnosticError)(C)?M.push({name:C.hostName,rootProcess:C}):C.processes&&M.push({name:C.hostName,rootProcess:C.processes})})}catch(T){this.logService.error(`Listing processes failed: ${T}`)}this.safeSend(w,"vscode:listProcessesResponse",M)}),S.validatedIpcMain.on("vscode:workbenchCommand",(w,M)=>{const{id:T,from:C,args:L}=M;let _;switch(C){case"processExplorer":_=this.processExplorerParentWindow;break;default:throw new Error(`Unexpected command source: ${C}`)}_?.webContents.send("vscode:runAction",{id:T,from:C,args:L})}),S.validatedIpcMain.on("vscode:closeProcessExplorer",w=>{this.processExplorerWindow?.close()}),S.validatedIpcMain.on("vscode:pidToNameRequest",async w=>{const M=await this.diagnosticsMainService.getMainDiagnostics(),T=[];for(const C of M.windows)T.push([C.pid,`window [${C.id}] (${C.title})`]);for(const{pid:C,name:L}of r.UtilityProcess.getAll())T.push([C,L]);this.safeSend(w,"vscode:pidToNameResponse",T)})}async openProcessExplorer(w){if(!this.processExplorerWindow&&(this.processExplorerParentWindow=i.BrowserWindow.getFocusedWindow(),this.processExplorerParentWindow)){const M=new y.DisposableStore,T=M.add(this.protocolMainService.createIPCObjectUrl()),C=this.stateService.getItem(n,void 0),L=d(C)?C:this.getWindowPosition(this.processExplorerParentWindow,800,500);this.processExplorerWindow=this.createBrowserWindow(L,T,{backgroundColor:w.styles.backgroundColor,title:(0,c.localize)(1917,null),zoomLevel:w.zoomLevel,alwaysOnTop:!0},"process-explorer"),T.update({appRoot:this.environmentMainService.appRoot,windowId:this.processExplorerWindow.id,userEnv:this.userEnv,data:w,product:b.default,nls:{messages:(0,c.getNLSMessages)(),language:(0,c.getNLSLanguage)()},cssModules:this.cssDevelopmentService.isEnabled?await this.cssDevelopmentService.getCssModules():void 0}),this.processExplorerWindow.loadURL(k.FileAccess.asBrowserUri(`vs/code/electron-sandbox/processExplorer/processExplorer${this.environmentMainService.isBuilt?"":"-dev"}.${t.isESM?"esm.":""}html`).toString(!0)),this.processExplorerWindow.on("close",()=>{this.processExplorerWindow=null,M.dispose()}),this.processExplorerParentWindow.on("close",()=>{this.processExplorerWindow&&(this.processExplorerWindow.close(),this.processExplorerWindow=null,M.dispose())});const _=()=>{if(!this.processExplorerWindow)return;const V=this.processExplorerWindow.getSize(),z=this.processExplorerWindow.getPosition();if(!V||!z)return;const Q={width:V[0],height:V[1],x:z[0],y:z[1]};this.stateService.setItem(n,Q)};this.processExplorerWindow.on("moved",_),this.processExplorerWindow.on("resized",_)}this.processExplorerWindow&&this.focusWindow(this.processExplorerWindow)}focusWindow(w){w.isMinimized()&&w.restore(),w.focus()}getWindowPosition(w,M,T){let C;const L=i.screen.getAllDisplays();if(L.length===1)C=L[0];else{if(A.isMacintosh){const z=i.screen.getCursorScreenPoint();C=i.screen.getDisplayNearestPoint(z)}!C&&w&&(C=i.screen.getDisplayMatching(w.getBounds())),C||(C=i.screen.getPrimaryDisplay()||L[0])}const _=C.bounds,V={width:M,height:T,x:_.x+_.width/2-M/2,y:_.y+_.height/2-T/2};return _.width>0&&_.height>0&&(V.x<_.x&&(V.x=_.x),V.y<_.y&&(V.y=_.y),V.x>_.x+_.width&&(V.x=_.x),V.y>_.y+_.height&&(V.y=_.y),V.width>_.width&&(V.width=_.width),V.height>_.height&&(V.height=_.height)),V}async stopTracing(){if(!this.environmentMainService.args.trace)return;const w=await i.contentTracing.stopRecording(`${(0,s.randomPath)(this.environmentMainService.userHome.fsPath,this.productService.applicationName)}.trace.txt`);await this.dialogMainService.showMessageBox({type:"info",message:(0,c.localize)(1918,null),detail:(0,c.localize)(1919,null,w),buttons:[(0,c.localize)(1920,null)]},i.BrowserWindow.getFocusedWindow()??void 0),this.nativeHostMainService.showItemInFolder(void 0,w)}async getSystemStatus(){const[w,M]=await Promise.all([this.diagnosticsMainService.getMainDiagnostics(),this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return this.diagnosticsService.getDiagnostics(w,M)}async $getSystemInfo(){const[w,M]=await Promise.all([this.diagnosticsMainService.getMainDiagnostics(),this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return await this.diagnosticsService.getSystemInfo(w,M)}async $getPerformanceInfo(){try{const[w,M]=await Promise.all([this.diagnosticsMainService.getMainDiagnostics(),this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0})]);return await this.diagnosticsService.getPerformanceInfo(w,M)}catch(w){throw this.logService.warn("issueService#getPerformanceInfo ",w.message),w}}createBrowserWindow(w,M,T,C){const L=new i.BrowserWindow({fullscreen:!1,skipTaskbar:!1,resizable:!0,width:w.width,height:w.height,minWidth:300,minHeight:200,x:w.x,y:w.y,title:T.title,backgroundColor:T.backgroundColor||o.DEFAULT_BACKGROUND_COLOR,webPreferences:{preload:k.FileAccess.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${M.resource.toString()}`],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,a.zoomLevelToZoomFactor)(T.zoomLevel),sandbox:!0},alwaysOnTop:T.alwaysOnTop,experimentalDarkMode:!0});return L.setMenuBarVisibility(!1),L}safeSend(w,M,...T){w.sender.isDestroyed()||w.sender.send(M,...T)}async closeProcessExplorer(){this.processExplorerWindow?.close()}};e.ProcessMainService=l,e.ProcessMainService=l=o=Pe([re(1,v.IEnvironmentMainService),re(2,h.ILogService),re(3,m.IDiagnosticsService),re(4,u.IDiagnosticsMainService),re(5,p.IDialogMainService),re(6,E.INativeHostMainService),re(7,I.IProtocolMainService),re(8,g.IProductService),re(9,P.IStateService),re(10,f.ICSSDevelopmentService)],l);function d(D){return typeof D!="object"||D===null?!1:"x"in D&&"y"in D&&"width"in D&&"height"in D}}),define(le[275],ue([0,1,22,16,20,19,5,65,28,50,24,51,108]),function(j,e,i,s,y,k,A,R,S,c,m,u,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxUpdateService=void 0;let v=class extends p.AbstractUpdateService{constructor(h,E,b,g,I,P,r,a){super(h,E,g,I,P,a),this.telemetryService=b,this.nativeHostMainService=r}buildUpdateFeedUrl(h){return(0,p.createUpdateURL)(`linux-${process.arch}`,h,this.productService)}doCheckForUpdates(h){this.url&&(this.setState(u.State.CheckingForUpdates(h)),this.requestService.request({url:this.url},i.CancellationToken.None).then(c.asJson).then(E=>{!E||!E.url||!E.version||!E.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!h}),this.setState(u.State.Idle(u.UpdateType.Archive))):this.setState(u.State.AvailableForDownload(E))}).then(void 0,E=>{this.logService.error(E);const b=h?E.message||E:void 0;this.setState(u.State.Idle(u.UpdateType.Archive,b))}))}async doDownloadUpdate(h){this.productService.downloadUrl&&this.productService.downloadUrl.length>0?this.nativeHostMainService.openExternal(void 0,this.productService.downloadUrl):h.update.url&&this.nativeHostMainService.openExternal(void 0,h.update.url),this.setState(u.State.Idle(u.UpdateType.Archive))}};e.LinuxUpdateService=v,e.LinuxUpdateService=v=Pe([re(0,k.ILifecycleMainService),re(1,s.IConfigurationService),re(2,m.ITelemetryService),re(3,y.IEnvironmentMainService),re(4,c.IRequestService),re(5,A.ILogService),re(6,R.INativeHostMainService),re(7,S.IProductService)],v)}),define(le[276],ue([0,1,44,26,27,8,22,54,48,10,7,153,23,16,20,14,19,5,65,28,50,24,51,108]),function(j,e,i,s,y,k,A,R,S,c,m,u,p,v,f,h,E,b,g,I,P,r,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Win32UpdateService=void 0,s=Re(s),c=Re(c),p=Re(p);async function o(D,w=1e3){for(;!D();)await(0,k.timeout)(w)}let n;function l(){return typeof n>"u"&&(n=s.existsSync(c.join(c.dirname(process.execPath),"unins000.exe"))?a.UpdateType.Setup:a.UpdateType.Archive),n}let d=class extends t.AbstractUpdateService{get cachePath(){const w=c.join((0,y.tmpdir)(),`${this.productService.applicationName}-${this.productService.quality}-${this.productService.target}-${process.arch}`);return s.promises.mkdir(w,{recursive:!0}).then(()=>w)}constructor(w,M,T,C,L,_,V,z,Q){super(w,M,C,L,_,Q),this.telemetryService=T,this.fileService=V,this.nativeHostMainService=z,w.setRelaunchHandler(this)}handleRelaunch(w){return w?.addArgs||w?.removeArgs||this.state.type!==a.StateType.Ready||!this.availableUpdate?!1:(this.logService.trace("update#handleRelaunch(): running raw#quitAndInstall()"),this.doQuitAndInstall(),!0)}async initialize(){if(this.productService.target==="user"&&await this.nativeHostMainService.isAdmin(void 0)){this.setState(a.State.Disabled(a.DisablementReason.RunningAsAdmin)),this.logService.info("update#ctor - updates are disabled due to running as Admin in user setup");return}await super.initialize()}buildUpdateFeedUrl(w){let M=`win32-${process.arch}`;return l()===a.UpdateType.Archive?M+="-archive":this.productService.target==="user"&&(M+="-user"),(0,t.createUpdateURL)(M,w,this.productService)}doCheckForUpdates(w){this.url&&(this.setState(a.State.CheckingForUpdates(w)),this.requestService.request({url:this.url},A.CancellationToken.None).then(P.asJson).then(M=>{const T=l();return!M||!M.url||!M.version||!M.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!w}),this.setState(a.State.Idle(T)),Promise.resolve(null)):T===a.UpdateType.Archive?(this.setState(a.State.AvailableForDownload(M)),Promise.resolve(null)):(this.setState(a.State.Downloading),this.cleanup(M.version).then(()=>this.getUpdatePackagePath(M.version).then(C=>p.Promises.exists(C).then(L=>{if(L)return Promise.resolve(C);const _=`${C}.tmp`;return this.requestService.request({url:M.url},A.CancellationToken.None).then(V=>this.fileService.writeFile(m.URI.file(_),V.stream)).then(M.sha256hash?()=>(0,u.checksum)(_,M.sha256hash):()=>{}).then(()=>p.Promises.rename(_,C,!1)).then(()=>C)})).then(C=>{this.availableUpdate={packagePath:C},this.setState(a.State.Downloaded(M)),this.configurationService.getValue("update.enableWindowsBackgroundUpdates")?this.productService.target==="user"&&this.doApplyUpdate():this.setState(a.State.Ready(M))})))}).then(void 0,M=>{this.telemetryService.publicLog2("update:error",{messageHash:String((0,S.hash)(String(M)))}),this.logService.error(M);const T=w?M.message||M:void 0;this.setState(a.State.Idle(l(),T))}))}async doDownloadUpdate(w){w.update.url&&this.nativeHostMainService.openExternal(void 0,w.update.url),this.setState(a.State.Idle(l()))}async getUpdatePackagePath(w){const M=await this.cachePath;return c.join(M,`CodeSetup-${this.productService.quality}-${w}.exe`)}async cleanup(w=null){const M=w?_=>!new RegExp(`${this.productService.quality}-${w}\\.exe$`).test(_):()=>!0,T=await this.cachePath,L=(await p.Promises.readdir(T)).filter(M).map(async _=>{try{await s.promises.unlink(c.join(T,_))}catch{}});await Promise.all(L)}async doApplyUpdate(){if(this.state.type!==a.StateType.Downloaded||!this.availableUpdate)return Promise.resolve(void 0);const w=this.state.update;this.setState(a.State.Updating(w));const M=await this.cachePath;this.availableUpdate.updateFilePath=c.join(M,`CodeSetup-${this.productService.quality}-${w.version}.flag`),await p.Promises.writeFile(this.availableUpdate.updateFilePath,"flag"),(0,i.spawn)(this.availableUpdate.packagePath,["/verysilent","/log",`/update="${this.availableUpdate.updateFilePath}"`,"/nocloseapplications","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"],windowsVerbatimArguments:!0}).once("exit",()=>{this.availableUpdate=void 0,this.setState(a.State.Idle(l()))});const C=`${this.productService.win32MutexName}-ready`,L=await new Promise((_,V)=>{j(["@vscode/windows-mutex"],_,V)}).then(Re);o(()=>L.isActive(C)).then(()=>this.setState(a.State.Ready(w)))}doQuitAndInstall(){this.state.type!==a.StateType.Ready||!this.availableUpdate||(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.availableUpdate.updateFilePath?s.unlinkSync(this.availableUpdate.updateFilePath):(0,i.spawn)(this.availableUpdate.packagePath,["/silent","/log","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"]}))}getUpdateType(){return l()}async _applySpecificUpdate(w){if(this.state.type!==a.StateType.Idle)return;const M=this.configurationService.getValue("update.enableWindowsBackgroundUpdates"),T={version:"unknown",productVersion:"unknown"};this.setState(a.State.Downloading),this.availableUpdate={packagePath:w},this.setState(a.State.Downloaded(T)),M?this.productService.target==="user"&&this.doApplyUpdate():this.setState(a.State.Ready(T))}};e.Win32UpdateService=d,Pe([R.memoize],d.prototype,"cachePath",null),e.Win32UpdateService=d=Pe([re(0,E.ILifecycleMainService),re(1,v.IConfigurationService),re(2,r.ITelemetryService),re(3,f.IEnvironmentMainService),re(4,P.IRequestService),re(5,b.ILogService),re(6,h.IFileService),re(7,g.INativeHostMainService),re(8,I.IProductService)],d)});var je=this&&this.__importDefault||function(j){return j&&j.__esModule?j:{default:j}};define(le[140],ue([0,1,13,8,22,55,4,2,11,71,3,7,9,27,70,16,53,20,69,14,19,5,28,74,252,89,24,113,77,47,29,30,59,52,40,34,58,72,21,6,66]),function(j,e,i,s,y,k,A,R,S,c,m,u,p,v,f,h,E,b,g,I,P,r,a,t,o,n,l,d,D,w,M,T,C,L,_,V,z,Q,fe,se,ee){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeWindow=e.BaseWindow=void 0,i=je(i);var U;(function(x){x[x.NONE=0]="NONE",x[x.NAVIGATING=1]="NAVIGATING",x[x.READY=2]="READY"})(U||(U={}));class K extends R.Disposable{get lastFocusTime(){return this._lastFocusTime}get win(){return this._win}setWin(W,q){this._win=W,this._register(A.Event.fromNodeEventEmitter(W,"maximize")(()=>this._onDidMaximize.fire())),this._register(A.Event.fromNodeEventEmitter(W,"unmaximize")(()=>this._onDidUnmaximize.fire())),this._register(A.Event.fromNodeEventEmitter(W,"closed")(()=>{this._onDidClose.fire(),this.dispose()})),this._register(A.Event.fromNodeEventEmitter(W,"focus")(()=>{this._lastFocusTime=Date.now()})),this._register(A.Event.fromNodeEventEmitter(this._win,"enter-full-screen")(()=>this._onDidEnterFullScreen.fire())),this._register(A.Event.fromNodeEventEmitter(this._win,"leave-full-screen")(()=>this._onDidLeaveFullScreen.fire()));const ie=!(0,w.hasNativeTitlebar)(this.configurationService,q?.titleBarStyle==="hidden"?w.TitlebarStyle.CUSTOM:void 0);if(m.isMacintosh&&ie&&W.setSheetOffset((0,m.isBigSurOrNewer)((0,v.release)())?28:22),ie&&((0,w.useWindowControlsOverlay)(this.configurationService)||m.isMacintosh)){const H=this.stateService.getItem(K.windowControlHeightStateStorageKey);H?this.updateWindowControls({height:H}):this.updateWindowControls({height:w.DEFAULT_CUSTOM_TITLEBAR_HEIGHT})}m.isWindows&&ie&&W.hookWindowMessage(278,()=>{const[ce,oe]=W.getPosition(),te=i.default.screen.getCursorScreenPoint(),O=te.x-ce,X=te.y-oe;return!(O>30&&X>=0&&X<=Math.max(W.getBounds().height*.15,35))||(W.setEnabled(!1),W.setEnabled(!0),this._onDidTriggerSystemContextMenu.fire({x:O,y:X})),0}),this.environmentMainService.args["open-devtools"]===!0&&W.webContents.openDevTools(),m.isMacintosh&&(this._register(this.onDidEnterFullScreen(()=>{this.joinNativeFullScreenTransition?.complete(!0)})),this._register(this.onDidLeaveFullScreen(()=>{this.joinNativeFullScreenTransition?.complete(!0)})))}constructor(W,q,ie,H){super(),this.configurationService=W,this.stateService=q,this.environmentMainService=ie,this.logService=H,this._onDidClose=this._register(new A.Emitter),this.onDidClose=this._onDidClose.event,this._onDidMaximize=this._register(new A.Emitter),this.onDidMaximize=this._onDidMaximize.event,this._onDidUnmaximize=this._register(new A.Emitter),this.onDidUnmaximize=this._onDidUnmaximize.event,this._onDidTriggerSystemContextMenu=this._register(new A.Emitter),this.onDidTriggerSystemContextMenu=this._onDidTriggerSystemContextMenu.event,this._onDidEnterFullScreen=this._register(new A.Emitter),this.onDidEnterFullScreen=this._onDidEnterFullScreen.event,this._onDidLeaveFullScreen=this._register(new A.Emitter),this.onDidLeaveFullScreen=this._onDidLeaveFullScreen.event,this._lastFocusTime=Date.now(),this._win=null,this.hasWindowControlOverlay=(0,w.useWindowControlsOverlay)(this.configurationService),this.transientIsNativeFullScreen=void 0,this.joinNativeFullScreenTransition=void 0}applyState(W,q=i.default.screen.getAllDisplays().length>0){const ie=this.configurationService.getValue("window"),H=m.isMacintosh&&ie?.nativeTabs===!0;(m.isMacintosh||m.isWindows)&&q&&(!H||i.default.BrowserWindow.getAllWindows().length===1)&&[W.width,W.height,W.x,W.y].every(ce=>typeof ce=="number")&&this._win?.setBounds({width:W.width,height:W.height,x:W.x,y:W.y}),(W.mode===L.WindowMode.Maximized||W.mode===L.WindowMode.Fullscreen)&&(this._win?.maximize(),W.mode===L.WindowMode.Fullscreen&&this.setFullScreen(!0,!0),this._win?.show())}setRepresentedFilename(W){m.isMacintosh?this.win?.setRepresentedFilename(W):this.representedFilename=W}getRepresentedFilename(){return m.isMacintosh?this.win?.getRepresentedFilename():this.representedFilename}setDocumentEdited(W){m.isMacintosh&&this.win?.setDocumentEdited(W),this.documentEdited=W}isDocumentEdited(){return m.isMacintosh?!!this.win?.isDocumentEdited():!!this.documentEdited}focus(W){m.isMacintosh&&W?.force&&i.default.app.focus({steal:!0});const q=this.win;q&&(q.isMinimized()&&q.restore(),q.focus())}handleTitleDoubleClick(){const W=this.win;if(W)if(m.isMacintosh)switch(i.default.systemPreferences.getUserDefault("AppleActionOnDoubleClick","string")){case"Minimize":W.minimize();break;case"None":break;case"Maximize":default:W.isMaximized()?W.unmaximize():W.maximize()}else W.isMaximized()?W.unmaximize():W.maximize()}static{this.windowControlHeightStateStorageKey="windowControlHeight"}updateWindowControls(W){const q=this.win;if(q){if(W.height&&this.stateService.setItem(N.windowControlHeightStateStorageKey,W.height),this.hasWindowControlOverlay)q.setTitleBarOverlay({color:W.backgroundColor?.trim()===""?void 0:W.backgroundColor,symbolColor:W.foregroundColor?.trim()===""?void 0:W.foregroundColor,height:W.height?W.height-1:void 0});else if(m.isMacintosh&&W.height!==void 0){const ie=(W.height-15)/2;ie?q.setWindowButtonPosition({x:ie,y:ie}):q.setWindowButtonPosition(null)}}}toggleFullScreen(){this.setFullScreen(!this.isFullScreen,!1)}setFullScreen(W,q){(0,w.useNativeFullScreen)(this.configurationService)?this.setNativeFullScreen(W,q):this.setSimpleFullScreen(W)}get isFullScreen(){if(m.isMacintosh&&typeof this.transientIsNativeFullScreen=="boolean")return this.transientIsNativeFullScreen;const W=this.win,q=W?.isFullScreen(),ie=W?.isSimpleFullScreen();return!!(q||ie)}setNativeFullScreen(W,q){const ie=this.win;ie?.isSimpleFullScreen()&&ie?.setSimpleFullScreen(!1),this.doSetNativeFullScreen(W,q)}doSetNativeFullScreen(W,q){if(m.isMacintosh){this.transientIsNativeFullScreen=W;const H=this.joinNativeFullScreenTransition=new s.DeferredPromise;(async()=>{const ce=await Promise.race([H.p,(0,s.timeout)(1e4).then(()=>!1)]);this.joinNativeFullScreenTransition===H&&(this.transientIsNativeFullScreen=void 0,this.joinNativeFullScreenTransition=void 0,!ce&&W&&q&&this.win&&!this.win.isFullScreen()&&(this.logService.warn("window: native macOS fullscreen transition did not happen within 10s from restoring"),this._onDidLeaveFullScreen.fire()))})()}this.win?.setFullScreen(W)}setSimpleFullScreen(W){const q=this.win;q?.isFullScreen()&&this.doSetNativeFullScreen(!1,!1),q?.setSimpleFullScreen(W),q?.webContents.focus()}dispose(){super.dispose(),this._win=null}}e.BaseWindow=K;let N=class extends K{get id(){return this._id}get backupPath(){return this._config?.backupPath}get openedWorkspace(){return this._config?.workspace}get profile(){if(!this.config)return;const W=this.userDataProfilesService.profiles.find(q=>q.id===this.config?.profiles.profile.id);return this.isExtensionDevelopmentHost&&W?W:this.userDataProfilesService.getProfileForWorkspace(this.config.workspace??(0,T.toWorkspaceIdentifier)(this.backupPath,this.isExtensionDevelopmentHost))??this.userDataProfilesService.defaultProfile}get remoteAuthority(){return this._config?.remoteAuthority}get config(){return this._config}get isExtensionDevelopmentHost(){return!!this._config?.extensionDevelopmentPath}get isExtensionTestHost(){return!!this._config?.extensionTestsPath}get isExtensionDevelopmentTestFromCli(){return this.isExtensionDevelopmentHost&&this.isExtensionTestHost&&!this._config?.debugId}constructor(W,q,ie,H,ce,oe,te,O,X,B,F,J,G,$,Z,ae,pe,Se,ye,We,He){super(B,We,H,q),this.loggerMainService=ie,this.policyService=ce,this.userDataProfilesService=oe,this.fileService=te,this.applicationStorageMainService=O,this.storageMainService=X,this.themeMainService=F,this.workspacesManagementMainService=J,this.backupMainService=G,this.telemetryService=$,this.dialogMainService=Z,this.lifecycleMainService=ae,this.productService=pe,this.protocolMainService=Se,this.windowsMainService=ye,this._onWillLoad=this._register(new A.Emitter),this.onWillLoad=this._onWillLoad.event,this._onDidSignalReady=this._register(new A.Emitter),this.onDidSignalReady=this._onDidSignalReady.event,this._onDidDestroy=this._register(new A.Emitter),this.onDidDestroy=this._onDidDestroy.event,this.whenReadyCallbacks=[],this.touchBarGroups=[],this.currentHttpProxy=void 0,this.currentNoProxy=void 0,this.customZoomLevel=void 0,this.configObjectUrl=this._register(this.protocolMainService.createIPCObjectUrl()),this.wasLoaded=!1,this.readyState=U.NONE;{const[Ce,me]=this.restoreWindowState(W.state);this.windowState=Ce,this.logService.trace("window#ctor: using window state",Ce);const Y=He.invokeFunction(M.defaultBrowserWindowOptions,this.windowState,void 0,{preload:S.FileAccess.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${this.configObjectUrl.resource.toString()}`],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none"});(0,c.mark)("code/willCreateCodeBrowserWindow"),this._win=new i.default.BrowserWindow(Y),(0,c.mark)("code/didCreateCodeBrowserWindow"),this._id=this._win.id,this.setWin(this._win,Y),this.applyState(this.windowState,me),this._lastFocusTime=Date.now()}this.onConfigurationUpdated(),this.createTouchBar(),this.registerListeners()}setReady(){for(this.logService.trace(`window#load: window reported ready (id: ${this._id})`),this.readyState=U.READY;this.whenReadyCallbacks.length;)this.whenReadyCallbacks.pop()(this);this._onDidSignalReady.fire()}ready(){return new Promise(W=>{if(this.isReady)return W(this);this.whenReadyCallbacks.push(W)})}get isReady(){return this.readyState===U.READY}get whenClosedOrLoaded(){return new Promise(W=>{function q(){ie.dispose(),H.dispose(),W()}const ie=this.onDidClose(()=>q()),H=this.onWillLoad(()=>q())})}registerListeners(){this._register(A.Event.fromNodeEventEmitter(this._win,"unresponsive")(()=>this.onWindowError(L.WindowError.UNRESPONSIVE))),this._register(A.Event.fromNodeEventEmitter(this._win.webContents,"render-process-gone",(q,ie)=>ie)(q=>this.onWindowError(L.WindowError.PROCESS_GONE,{...q}))),this._register(A.Event.fromNodeEventEmitter(this._win.webContents,"did-fail-load",(q,ie,H)=>({exitCode:ie,reason:H}))(({exitCode:q,reason:ie})=>this.onWindowError(L.WindowError.LOAD,{reason:ie,exitCode:q}))),this._register(A.Event.fromNodeEventEmitter(this._win.webContents,"will-prevent-unload")(q=>q.preventDefault())),this._register(A.Event.fromNodeEventEmitter(this._win.webContents,"did-finish-load")(()=>{this.pendingLoadConfig&&(this._config=this.pendingLoadConfig,this.pendingLoadConfig=void 0)})),this._register(this.onDidMaximize(()=>{this._config&&(this._config.maximized=!0)})),this._register(this.onDidUnmaximize(()=>{this._config&&(this._config.maximized=!1)})),this._register(this.onDidEnterFullScreen(()=>{this.sendWhenReady("vscode:enterFullScreen",y.CancellationToken.None)})),this._register(this.onDidLeaveFullScreen(()=>{this.sendWhenReady("vscode:leaveFullScreen",y.CancellationToken.None)})),this._register(this.configurationService.onDidChangeConfiguration(q=>this.onConfigurationUpdated(q))),this._register(this.workspacesManagementMainService.onDidDeleteUntitledWorkspace(q=>this.onDidDeleteUntitledWorkspace(q)));const W=["https://marketplace.visualstudio.com/*","https://*.vsassets.io/*"];this._win.webContents.session.webRequest.onBeforeSendHeaders({urls:W},async(q,ie)=>{const H=await this.getMarketplaceHeaders();ie({cancel:!1,requestHeaders:Object.assign(q.requestHeaders,H)})})}getMarketplaceHeaders(){return this.marketplaceHeadersPromise||(this.marketplaceHeadersPromise=(0,o.resolveMarketplaceHeaders)(this.productService.version,this.productService,this.environmentMainService,this.configurationService,this.fileService,this.applicationStorageMainService,this.telemetryService)),this.marketplaceHeadersPromise}async onWindowError(W,q){switch(W){case L.WindowError.PROCESS_GONE:this.logService.error(`CodeWindow: renderer process gone (reason: ${q?.reason||"<unknown>"}, code: ${q?.exitCode||"<unknown>"})`);break;case L.WindowError.UNRESPONSIVE:this.logService.error("CodeWindow: detected unresponsive");break;case L.WindowError.LOAD:this.logService.error(`CodeWindow: failed to load (reason: ${q?.reason||"<unknown>"}, code: ${q?.exitCode||"<unknown>"})`);break}switch(this.telemetryService.publicLog2("windowerror",{type:W,reason:q?.reason,code:q?.exitCode}),W){case L.WindowError.UNRESPONSIVE:case L.WindowError.PROCESS_GONE:if(this.isExtensionDevelopmentTestFromCli){this.lifecycleMainService.kill(1);return}if(this.environmentMainService.args["enable-smoke-test-driver"]){await this.destroyWindow(!1,!1),this.lifecycleMainService.quit();return}if(W===L.WindowError.UNRESPONSIVE){if(this.isExtensionDevelopmentHost||this.isExtensionTestHost||this._win&&this._win.webContents&&this._win.webContents.isDevToolsOpened())return;const{response:ie,checkboxChecked:H}=await this.dialogMainService.showMessageBox({type:"warning",buttons:[(0,p.localize)(2463,null),(0,p.localize)(2464,null),(0,p.localize)(2465,null)],message:(0,p.localize)(2466,null),detail:(0,p.localize)(2467,null),checkboxLabel:this._config?.workspace?(0,p.localize)(2468,null):void 0},this._win);if(ie!==2){const ce=ie===0;await this.destroyWindow(ce,H)}}else if(W===L.WindowError.PROCESS_GONE){let ie;q?ie=(0,p.localize)(2470,null,q.reason,q.exitCode??"<unknown>"):ie=(0,p.localize)(2469,null);const{response:H,checkboxChecked:ce}=await this.dialogMainService.showMessageBox({type:"warning",buttons:[this._config?.workspace?(0,p.localize)(2471,null):(0,p.localize)(2472,null),(0,p.localize)(2473,null)],message:ie,detail:this._config?.workspace?(0,p.localize)(2474,null):(0,p.localize)(2475,null),checkboxLabel:this._config?.workspace?(0,p.localize)(2476,null):void 0},this._win),oe=H===0;await this.destroyWindow(oe,ce)}break}}async destroyWindow(W,q){const ie=this._config?.workspace;if(q&&ie)try{const H=this.storageMainService.workspaceStorage(ie);await H.init(),H.delete("memento/workbench.parts.editor"),await H.close()}catch(H){this.logService.error(H)}this._onDidDestroy.fire();try{if(W&&this._config){let H,ce;(0,T.isSingleFolderWorkspaceIdentifier)(ie)?H={folderUri:ie.uri}:(0,T.isWorkspaceIdentifier)(ie)?H={workspaceUri:ie.configPath}:ce=!0,(0,fe.firstOrDefault)(await this.windowsMainService.open({context:M.OpenContext.API,userEnv:this._config.userEnv,cli:{...this.environmentMainService.args,_:[]},urisToOpen:H?[H]:void 0,forceEmpty:ce,forceNewWindow:!0,remoteAuthority:this.remoteAuthority}))?.focus()}}finally{this._win?.destroy()}}onDidDeleteUntitledWorkspace(W){this._config?.workspace?.id===W.id&&(this._config.workspace=void 0)}onConfigurationUpdated(W){if(!W||W.affectsConfiguration("window.menuBarVisibility")){const q=this.getMenuBarVisibility();q!==this.currentMenuBarVisibility&&(this.currentMenuBarVisibility=q,this.setMenuBarVisibility(q))}if(!W||W.affectsConfiguration("http.proxy")||W.affectsConfiguration("http.noProxy")){let q=(this.configurationService.getValue("http.proxy")||"").trim()||(process.env.https_proxy||process.env.HTTPS_PROXY||process.env.http_proxy||process.env.HTTP_PROXY||"").trim()||void 0;if(q?.indexOf("@")!==-1){const H=u.URI.parse(q),ce=H.authority.indexOf("@");ce!==-1&&(q=H.with({authority:H.authority.substring(ce+1)}).toString())}q?.endsWith("/")&&(q=q.substr(0,q.length-1));const ie=(this.configurationService.getValue("http.noProxy")||[]).map(H=>H.trim()).join(",")||(process.env.no_proxy||process.env.NO_PROXY||"").trim()||void 0;if((q||"").indexOf("@")===-1&&(q!==this.currentHttpProxy||ie!==this.currentNoProxy)){this.currentHttpProxy=q,this.currentNoProxy=ie;const H=q||"",ce=ie?`${ie},<local>`:"<local>";this.logService.trace(`Setting proxy to '${H}', bypassing '${ce}'`),this._win.webContents.session.setProxy({proxyRules:H,proxyBypassRules:ce,pacScript:""}),i.default.app.setProxy({proxyRules:H,proxyBypassRules:ce,pacScript:""})}}}addTabbedWindow(W){m.isMacintosh&&W.win&&this._win.addTabbedWindow(W.win)}load(W,q=Object.create(null)){this.logService.trace(`window#load: attempt to load window (id: ${this._id})`),this.isDocumentEdited()&&(!q.isReload||!this.backupMainService.isHotExitEnabled())&&this.setDocumentEdited(!1),q.isReload||(this.getRepresentedFilename()&&this.setRepresentedFilename(""),this._win.setTitle(this.productService.nameLong)),this.updateConfiguration(W,q),this.readyState===U.NONE?this._config=W:this.pendingLoadConfig=W,this.readyState=U.NAVIGATING,this._win.loadURL(S.FileAccess.asBrowserUri(`vs/code/electron-sandbox/workbench/workbench${this.environmentMainService.isBuilt?"":"-dev"}.${ee.isESM?"esm.":""}html`).toString(!0));const ie=this.wasLoaded;this.wasLoaded=!0,!this.environmentMainService.isBuilt&&!this.environmentMainService.extensionTestsLocationURI&&this._register(new s.RunOnceScheduler(()=>{this._win&&!this._win.isVisible()&&!this._win.isMinimized()&&(this._win.show(),this.focus({force:!0}),this._win.webContents.openDevTools())},1e4)).schedule(),this._onWillLoad.fire({workspace:W.workspace,reason:q.isReload?L.LoadReason.RELOAD:ie?L.LoadReason.LOAD:L.LoadReason.INITIAL})}updateConfiguration(W,q){const ie=(this._config??this.pendingLoadConfig)?.userEnv;if(ie){const H=(0,g.isLaunchedFromCli)(ie)&&!(0,g.isLaunchedFromCli)(W.userEnv),ce=this.isExtensionDevelopmentHost;(H||ce)&&(W.userEnv={...ie,...W.userEnv})}process.env.CHROME_CRASHPAD_PIPE_NAME&&Object.assign(W.userEnv,{CHROME_CRASHPAD_PIPE_NAME:process.env.CHROME_CRASHPAD_PIPE_NAME}),q.disableExtensions!==void 0&&(W["disable-extensions"]=q.disableExtensions),W.fullscreen=this.isFullScreen,W.maximized=this._win.isMaximized(),W.partsSplash=this.themeMainService.getWindowSplash(),W.zoomLevel=this.getZoomLevel(),W.isCustomZoomLevel=typeof this.customZoomLevel=="number",W.isCustomZoomLevel&&W.partsSplash&&(W.partsSplash.zoomLevel=W.zoomLevel),(0,c.mark)("code/willOpenNewWindow"),W.perfMarks=(0,c.getMarks)(),this.configObjectUrl.update(W)}async reload(W){const q=Object.assign({},this._config);q.workspace=await this.validateWorkspaceBeforeReload(q),delete q.filesToOpenOrCreate,delete q.filesToDiff,delete q.filesToMerge,delete q.filesToWait,this.isExtensionDevelopmentHost&&W&&(q.verbose=W.verbose,q.debugId=W.debugId,q.extensionEnvironment=W.extensionEnvironment,q["inspect-extensions"]=W["inspect-extensions"],q["inspect-brk-extensions"]=W["inspect-brk-extensions"],q["extensions-dir"]=W["extensions-dir"]),q.accessibilitySupport=i.default.app.isAccessibilitySupportEnabled(),q.isInitialStartup=!1,q.policiesData=this.policyService.serialize(),q.continueOn=this.environmentMainService.continueOn,q.profiles={all:this.userDataProfilesService.profiles,profile:this.profile||this.userDataProfilesService.defaultProfile,home:this.userDataProfilesService.profilesHome},q.logLevel=this.loggerMainService.getLogLevel(),q.loggers={window:this.loggerMainService.getRegisteredLoggers(this.id),global:this.loggerMainService.getRegisteredLoggers()},this.load(q,{isReload:!0,disableExtensions:W?.["disable-extensions"]})}async validateWorkspaceBeforeReload(W){if((0,T.isWorkspaceIdentifier)(W.workspace)){const q=W.workspace.configPath;if(q.scheme===S.Schemas.file&&!await this.fileService.exists(q))return}else if((0,T.isSingleFolderWorkspaceIdentifier)(W.workspace)){const q=W.workspace.uri;if(q.scheme===S.Schemas.file&&!await this.fileService.exists(q))return}return W.workspace}serializeWindowState(){if(!this._win)return(0,L.defaultWindowState)();if(this.isFullScreen){let ie;try{ie=i.default.screen.getDisplayMatching(this.getBounds())}catch{}const H=(0,L.defaultWindowState)();return{mode:L.WindowMode.Fullscreen,display:ie?ie.id:void 0,width:this.windowState.width||H.width,height:this.windowState.height||H.height,x:this.windowState.x||0,y:this.windowState.y||0,zoomLevel:this.customZoomLevel}}const W=Object.create(null);let q;if(!m.isMacintosh&&this._win.isMaximized()?q=L.WindowMode.Maximized:q=L.WindowMode.Normal,q===L.WindowMode.Maximized?W.mode=L.WindowMode.Maximized:W.mode=L.WindowMode.Normal,q===L.WindowMode.Normal||q===L.WindowMode.Maximized){let ie;q===L.WindowMode.Normal?ie=this.getBounds():ie=this._win.getNormalBounds(),W.x=ie.x,W.y=ie.y,W.width=ie.width,W.height=ie.height}return W.zoomLevel=this.customZoomLevel,W}restoreWindowState(W){(0,c.mark)("code/willRestoreCodeWindowState");let q=!1;if(W){this.customZoomLevel=W.zoomLevel;try{const ie=i.default.screen.getAllDisplays();q=ie.length>1,W=M.WindowStateValidator.validateWindowState(this.logService,W,ie)}catch(ie){this.logService.warn(`Unexpected error validating window state: ${ie}
${ie.stack}`)}}return(0,c.mark)("code/didRestoreCodeWindowState"),[W||(0,L.defaultWindowState)(),q]}getBounds(){const[W,q]=this._win.getPosition(),[ie,H]=this._win.getSize();return{x:W,y:q,width:ie,height:H}}setFullScreen(W,q){super.setFullScreen(W,q),this.sendWhenReady(W?"vscode:enterFullScreen":"vscode:leaveFullScreen",y.CancellationToken.None),this.currentMenuBarVisibility&&this.setMenuBarVisibility(this.currentMenuBarVisibility,!1)}getMenuBarVisibility(){let W=(0,w.getMenuBarVisibility)(this.configurationService);return["visible","toggle","hidden"].indexOf(W)<0&&(W="classic"),W}setMenuBarVisibility(W,q=!0){m.isMacintosh||(W==="toggle"&&q&&this.send("vscode:showInfoMessage",(0,p.localize)(2477,null)),W==="hidden"?setTimeout(()=>{this.doSetMenuBarVisibility(W)}):this.doSetMenuBarVisibility(W))}doSetMenuBarVisibility(W){const q=this.isFullScreen;switch(W){case"classic":this._win.setMenuBarVisibility(!q),this._win.autoHideMenuBar=q;break;case"visible":this._win.setMenuBarVisibility(!0),this._win.autoHideMenuBar=!1;break;case"toggle":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!0;break;case"hidden":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!1;break}}notifyZoomLevel(W){this.customZoomLevel=W}getZoomLevel(){return typeof this.customZoomLevel=="number"?this.customZoomLevel:this.configurationService.getValue("window")?.zoomLevel}close(){this._win?.close()}sendWhenReady(W,q,...ie){this.isReady?this.send(W,...ie):this.ready().then(()=>{q.isCancellationRequested||this.send(W,...ie)})}send(W,...q){if(this._win){if(this._win.isDestroyed()||this._win.webContents.isDestroyed()){this.logService.warn(`Sending IPC message to channel '${W}' for window that is destroyed`);return}try{this._win.webContents.send(W,...q)}catch(ie){this.logService.warn(`Error sending IPC message to channel '${W}' of window ${this._id}: ${(0,k.toErrorMessage)(ie)}`)}}}updateTouchBar(W){m.isMacintosh&&this.touchBarGroups.forEach((q,ie)=>{const H=W[ie];q.segments=this.createTouchBarGroupSegments(H)})}createTouchBar(){if(m.isMacintosh){for(let W=0;W<10;W++){const q=this.createTouchBarGroup();this.touchBarGroups.push(q)}this._win.setTouchBar(new i.default.TouchBar({items:this.touchBarGroups}))}}createTouchBarGroup(W=[]){const q=this.createTouchBarGroupSegments(W),ie=new i.default.TouchBar.TouchBarSegmentedControl({segments:q,mode:"buttons",segmentStyle:"automatic",change:H=>{this.sendWhenReady("vscode:runAction",y.CancellationToken.None,{id:ie.segments[H].id,from:"touchbar"})}});return ie}createTouchBarGroupSegments(W=[]){return W.map(ie=>{let H;ie.icon&&!d.ThemeIcon.isThemeIcon(ie.icon)&&ie.icon?.dark?.scheme===S.Schemas.file&&(H=i.default.nativeImage.createFromPath(u.URI.revive(ie.icon.dark).fsPath),H.isEmpty()&&(H=void 0));let ce;return typeof ie.title=="string"?ce=ie.title:ce=ie.title.value,{id:ie.id,label:H?void 0:ce,icon:H}})}matches(W){return this._win?.webContents.id===W.id}dispose(){super.dispose(),this.loggerMainService.deregisterLoggers(this.id)}};e.CodeWindow=N,e.CodeWindow=N=Pe([re(1,r.ILogService),re(2,Q.ILoggerMainService),re(3,b.IEnvironmentMainService),re(4,_.IPolicyService),re(5,z.IUserDataProfilesMainService),re(6,I.IFileService),re(7,n.IApplicationStorageMainService),re(8,n.IStorageMainService),re(9,h.IConfigurationService),re(10,D.IThemeMainService),re(11,C.IWorkspacesManagementMainService),re(12,f.IBackupMainService),re(13,l.ITelemetryService),re(14,E.IDialogMainService),re(15,P.ILifecycleMainService),re(16,a.IProductService),re(17,t.IProtocolMainService),re(18,M.IWindowsMainService),re(19,V.IStateService),re(20,se.IInstantiationService)],N)}),define(le[277],ue([0,1,13,3,16,20,19,5,34,47,52,140]),function(j,e,i,s,y,k,A,R,S,c,m,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AuxiliaryWindow=void 0;let p=class extends u.BaseWindow{get win(){return super.win||this.tryClaimWindow(),super.win}constructor(f,h,E,b,g,I){super(b,g,h,E),this.webContents=f,this.lifecycleMainService=I,this.id=this.webContents.id,this.parentId=-1,this.stateApplied=!1,this.tryClaimWindow()}tryClaimWindow(f){this._store.isDisposed||this.webContents.isDestroyed()||(this.doTryClaimWindow(f),f&&!this.stateApplied&&(this.stateApplied=!0,this.applyState({x:f.x,y:f.y,width:f.width,height:f.height,mode:f.show===!1?m.WindowMode.Maximized:m.WindowMode.Normal})))}doTryClaimWindow(f){if(this._win)return;const h=i.BrowserWindow.fromWebContents(this.webContents);h&&(this.logService.trace("[aux window] Claimed browser window instance"),this.setWin(h,f),h.setMenu(null),(s.isWindows||s.isLinux)&&(0,c.hasNativeTitlebar)(this.configurationService,f?.titleBarStyle==="hidden"?c.TitlebarStyle.CUSTOM:void 0)&&h.setAutoHideMenuBar(!0),this.lifecycleMainService.registerAuxWindow(this))}matches(f){return this.webContents.id===f.id}};e.AuxiliaryWindow=p,e.AuxiliaryWindow=p=Pe([re(1,k.IEnvironmentMainService),re(2,R.ILogService),re(3,y.IConfigurationService),re(4,S.IStateService),re(5,A.ILifecycleMainService)],p)}),define(le[278],ue([0,1,13,4,2,11,35,277,6,5,52,29]),function(j,e,i,s,y,k,A,R,S,c,m,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AuxiliaryWindowsMainService=void 0;let p=class extends y.Disposable{constructor(f,h){super(),this.instantiationService=f,this.logService=h,this._onDidMaximizeWindow=this._register(new s.Emitter),this.onDidMaximizeWindow=this._onDidMaximizeWindow.event,this._onDidUnmaximizeWindow=this._register(new s.Emitter),this.onDidUnmaximizeWindow=this._onDidUnmaximizeWindow.event,this._onDidChangeFullScreen=this._register(new s.Emitter),this.onDidChangeFullScreen=this._onDidChangeFullScreen.event,this._onDidTriggerSystemContextMenu=this._register(new s.Emitter),this.onDidTriggerSystemContextMenu=this._onDidTriggerSystemContextMenu.event,this.windows=new Map,this.registerListeners()}registerListeners(){i.app.on("browser-window-created",(f,h)=>{const E=this.getWindowByWebContents(h.webContents);if(E)this.logService.trace('[aux window] app.on("browser-window-created"): Trying to claim auxiliary window'),E.tryClaimWindow();else{const b=new y.DisposableStore;b.add(s.Event.fromNodeEventEmitter(h.webContents,"did-create-window",(g,I)=>({browserWindow:g,details:I}))(({browserWindow:g,details:I})=>{const P=this.getWindowByWebContents(g.webContents);P&&(this.logService.trace('[aux window] window.on("did-create-window"): Trying to claim auxiliary window'),P.tryClaimWindow(I.options))})),b.add(s.Event.fromNodeEventEmitter(h,"closed")(()=>b.dispose()))}}),A.validatedIpcMain.handle("vscode:registerAuxiliaryWindow",async(f,h)=>{const E=this.getWindowByWebContents(f.sender);return E&&(this.logService.trace("[aux window] vscode:registerAuxiliaryWindow: Registering auxiliary window to main window"),E.parentId=h),f.sender.id})}createWindow(f){const{state:h,overrides:E}=this.computeWindowStateAndOverrides(f);return this.instantiationService.invokeFunction(u.defaultBrowserWindowOptions,h,E,{preload:k.FileAccess.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload-aux.js").fsPath})}computeWindowStateAndOverrides(f){const h={},E={},b=f.features.split(",");for(const I of b){const[P,r]=I.split("=");switch(P){case"width":h.width=parseInt(r,10);break;case"height":h.height=parseInt(r,10);break;case"left":h.x=parseInt(r,10);break;case"top":h.y=parseInt(r,10);break;case"window-maximized":h.mode=m.WindowMode.Maximized;break;case"window-fullscreen":h.mode=m.WindowMode.Fullscreen;break;case"window-disable-fullscreen":E.disableFullscreen=!0;break;case"window-native-titlebar":E.forceNativeTitlebar=!0;break}}const g=u.WindowStateValidator.validateWindowState(this.logService,h)??(0,m.defaultAuxWindowState)();return this.logService.trace("[aux window] using window state",g),{state:g,overrides:E}}registerWindow(f){const h=new y.DisposableStore,E=this.instantiationService.createInstance(R.AuxiliaryWindow,f);this.windows.set(E.id,E),h.add((0,y.toDisposable)(()=>this.windows.delete(E.id))),h.add(E.onDidMaximize(()=>this._onDidMaximizeWindow.fire(E))),h.add(E.onDidUnmaximize(()=>this._onDidUnmaximizeWindow.fire(E))),h.add(E.onDidEnterFullScreen(()=>this._onDidChangeFullScreen.fire({window:E,fullscreen:!0}))),h.add(E.onDidLeaveFullScreen(()=>this._onDidChangeFullScreen.fire({window:E,fullscreen:!1}))),h.add(E.onDidTriggerSystemContextMenu(({x:b,y:g})=>this._onDidTriggerSystemContextMenu.fire({window:E,x:b,y:g}))),s.Event.once(E.onDidClose)(()=>h.dispose())}getWindowByWebContents(f){const h=this.windows.get(f.id);return h?.matches(f)?h:void 0}getFocusedWindow(){const f=i.BrowserWindow.getFocusedWindow();if(f)return this.getWindowByWebContents(f.webContents)}getLastActiveWindow(){return(0,u.getLastFocused)(Array.from(this.windows.values()))}getWindows(){return Array.from(this.windows.values())}};e.AuxiliaryWindowsMainService=p,e.AuxiliaryWindowsMainService=p=Pe([re(0,S.IInstantiationService),re(1,c.ILogService)],p)}),define(le[90],ue([0,1,13,21,8,4,49,2,11,3,18,7,23,9,6,19,5,63,89,105,30,59,31,53]),function(j,e,i,s,y,k,A,R,S,c,m,u,p,v,f,h,E,b,g,I,P,r,a,t){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesHistoryMainService=e.IWorkspacesHistoryMainService=void 0,e.IWorkspacesHistoryMainService=(0,f.createDecorator)("workspacesHistoryMainService");let n=class extends R.Disposable{static{o=this}static{this.MAX_TOTAL_RECENT_ENTRIES=500}static{this.RECENTLY_OPENED_STORAGE_KEY="history.recentlyOpenedPathsList"}constructor(d,D,w,M,T){super(),this.logService=d,this.workspacesManagementMainService=D,this.lifecycleMainService=w,this.applicationStorageMainService=M,this.dialogMainService=T,this._onDidChangeRecentlyOpened=this._register(new k.Emitter),this.onDidChangeRecentlyOpened=this._onDidChangeRecentlyOpened.event,this.macOSRecentDocumentsUpdater=this._register(new y.ThrottledDelayer(800)),this.registerListeners()}registerListeners(){this.lifecycleMainService.when(h.LifecycleMainPhase.Eventually).then(()=>this.handleWindowsJumpList()),this._register(this.workspacesManagementMainService.onDidEnterWorkspace(d=>this.addRecentlyOpened([{workspace:d.workspace,remoteAuthority:d.window.remoteAuthority}])))}async addRecentlyOpened(d){let D=[],w=[];for(const T of d)if((0,I.isRecentWorkspace)(T))!this.workspacesManagementMainService.isUntitledWorkspace(T.workspace)&&!this.containsWorkspace(D,T.workspace)&&D.push(T);else if((0,I.isRecentFolder)(T))this.containsFolder(D,T.folderUri)||D.push(T);else{const C=this.containsFile(w,T.fileUri),L=T.fileUri.scheme===S.Schemas.file&&o.COMMON_FILES_FILTER.indexOf((0,m.basename)(T.fileUri))>=0;!C&&!L&&(w.push(T),c.isWindows&&T.fileUri.scheme===S.Schemas.file&&i.app.addRecentDocument(T.fileUri.fsPath))}const M=await this.mergeEntriesFromStorage({workspaces:D,files:w});D=M.workspaces,w=M.files,D.length>o.MAX_TOTAL_RECENT_ENTRIES&&(D.length=o.MAX_TOTAL_RECENT_ENTRIES),w.length>o.MAX_TOTAL_RECENT_ENTRIES&&(w.length=o.MAX_TOTAL_RECENT_ENTRIES),await this.saveRecentlyOpened({workspaces:D,files:w}),this._onDidChangeRecentlyOpened.fire(),c.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments())}async removeRecentlyOpened(d){const D=C=>{const L=this.location(C);for(const _ of d)if(m.extUriBiasedIgnorePathCase.isEqual(_,L))return!1;return!0},w=await this.getRecentlyOpened(),M=w.workspaces.filter(D),T=w.files.filter(D);(M.length!==w.workspaces.length||T.length!==w.files.length)&&(await this.saveRecentlyOpened({files:T,workspaces:M}),this._onDidChangeRecentlyOpened.fire(),c.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments()))}async clearRecentlyOpened(d){if(d?.confirm){const{response:D}=await this.dialogMainService.showMessageBox({type:"warning",buttons:[(0,v.localize)(2490,null),(0,v.localize)(2491,null)],message:(0,v.localize)(2492,null),detail:(0,v.localize)(2493,null),cancelId:1});if(D!==0)return}await this.saveRecentlyOpened({workspaces:[],files:[]}),i.app.clearRecentDocuments(),this._onDidChangeRecentlyOpened.fire()}async getRecentlyOpened(){return this.mergeEntriesFromStorage()}async mergeEntriesFromStorage(d){const D=new a.ResourceMap(T=>m.extUriBiasedIgnorePathCase.getComparisonKey(T));if(d?.workspaces)for(const T of d.workspaces)D.set(this.location(T),T);const w=new a.ResourceMap(T=>m.extUriBiasedIgnorePathCase.getComparisonKey(T));if(d?.files)for(const T of d.files)w.set(this.location(T),T);const M=await this.getRecentlyOpenedFromStorage();for(const T of M.workspaces){const C=D.get(this.location(T));C?C.label=C.label??T.label:D.set(this.location(T),T)}for(const T of M.files){const C=w.get(this.location(T));C?C.label=C.label??T.label:w.set(this.location(T),T)}return{workspaces:[...D.values()],files:[...w.values()]}}async getRecentlyOpenedFromStorage(){await this.applicationStorageMainService.whenReady;let d;const D=this.applicationStorageMainService.get(o.RECENTLY_OPENED_STORAGE_KEY,b.StorageScope.APPLICATION);if(typeof D=="string")try{d=JSON.parse(D)}catch(w){this.logService.error("Unexpected error parsing opened paths list",w)}return(0,I.restoreRecentlyOpened)(d,this.logService)}async saveRecentlyOpened(d){await this.applicationStorageMainService.whenReady,this.applicationStorageMainService.store(o.RECENTLY_OPENED_STORAGE_KEY,JSON.stringify((0,I.toStoreData)(d)),b.StorageScope.APPLICATION,b.StorageTarget.MACHINE)}location(d){return(0,I.isRecentFolder)(d)?d.folderUri:(0,I.isRecentFile)(d)?d.fileUri:d.workspace.configPath}containsWorkspace(d,D){return!!d.find(w=>(0,I.isRecentWorkspace)(w)&&w.workspace.id===D.id)}containsFolder(d,D){return!!d.find(w=>(0,I.isRecentFolder)(w)&&m.extUriBiasedIgnorePathCase.isEqual(w.folderUri,D))}containsFile(d,D){return!!d.find(w=>m.extUriBiasedIgnorePathCase.isEqual(w.fileUri,D))}static{this.MAX_MACOS_DOCK_RECENT_WORKSPACES=7}static{this.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL=10}static{this.MAX_WINDOWS_JUMP_LIST_ENTRIES=7}static{this.COMMON_FILES_FILTER=["COMMIT_EDITMSG","MERGE_MSG","git-rebase-todo"]}async handleWindowsJumpList(){c.isWindows&&(await this.updateWindowsJumpList(),this._register(this.onDidChangeRecentlyOpened(()=>this.updateWindowsJumpList())))}async updateWindowsJumpList(){if(!c.isWindows)return;const d=[];if(d.push({type:"tasks",items:[{type:"task",title:(0,v.localize)(2494,null),description:(0,v.localize)(2495,null),program:process.execPath,args:"-n",iconPath:process.execPath,iconIndex:0}]}),(await this.getRecentlyOpened()).workspaces.length>0){const D=[];for(const T of i.app.getJumpListSettings().removedItems){const C=T.args;if(C){const L=/^--(folder|file)-uri\s+"([^"]+)"$/.exec(C);L&&D.push(u.URI.parse(L[2]))}}await this.removeRecentlyOpened(D);let w=!1;const M=(0,s.coalesce)((await this.getRecentlyOpened()).workspaces.slice(0,o.MAX_WINDOWS_JUMP_LIST_ENTRIES).map(T=>{const C=(0,I.isRecentWorkspace)(T)?T.workspace:T.folderUri,{title:L,description:_}=this.getWindowsJumpListLabel(C,T.label);let V;return u.URI.isUri(C)?V=`--folder-uri "${C.toString()}"`:(w=!0,V=`--file-uri "${C.configPath.toString()}"`),{type:"task",title:L.substr(0,255),description:_.substr(0,255),program:process.execPath,args:V,iconPath:"explorer.exe",iconIndex:0}}));M.length>0&&d.push({type:"custom",name:w?(0,v.localize)(2496,null):(0,v.localize)(2497,null),items:M})}d.push({type:"recent"});try{const D=i.app.setJumpList(d);D&&D!=="ok"&&this.logService.warn(`updateWindowsJumpList#setJumpList unexpected result: ${D}`)}catch(D){this.logService.warn("updateWindowsJumpList#setJumpList",D)}}getWindowsJumpListLabel(d,D){if(D)return{title:(0,A.splitRecentLabel)(D).name,description:D};if(u.URI.isUri(d))return{title:(0,m.basename)(d),description:this.renderJumpListPathDescription(d)};if(this.workspacesManagementMainService.isUntitledWorkspace(d))return{title:(0,v.localize)(2498,null),description:""};let w=(0,m.basename)(d.configPath);return w.endsWith(P.WORKSPACE_EXTENSION)&&(w=w.substr(0,w.length-P.WORKSPACE_EXTENSION.length-1)),{title:(0,v.localize)(2499,null,w),description:this.renderJumpListPathDescription(d.configPath)}}renderJumpListPathDescription(d){return d.scheme==="file"?(0,A.normalizeDriveLetter)(d.fsPath):d.toString()}async updateMacOSRecentDocuments(){if(!c.isMacintosh)return;i.app.clearRecentDocuments();const d=await this.getRecentlyOpened(),D=[];let w=0;for(let T=0;T<d.workspaces.length&&w<o.MAX_MACOS_DOCK_RECENT_WORKSPACES;T++){const C=this.location(d.workspaces[T]);if(C.scheme===S.Schemas.file){const L=(0,m.originalFSPath)(C);await p.Promises.exists(L)&&(D.push(L),w++)}}const M=[];for(let T=0;T<d.files.length&&w<o.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL;T++){const C=this.location(d.files[T]);if(C.scheme===S.Schemas.file){const L=(0,m.originalFSPath)(C);if(o.COMMON_FILES_FILTER.includes((0,m.basename)(C))||D.includes(L))continue;await p.Promises.exists(L)&&(M.push(L),w++)}}M.reverse().forEach(T=>i.app.addRecentDocument(T)),D.reverse().forEach(T=>i.app.addRecentDocument(T))}};e.WorkspacesHistoryMainService=n,e.WorkspacesHistoryMainService=n=o=Pe([re(0,E.ILogService),re(1,r.IWorkspacesManagementMainService),re(2,h.ILifecycleMainService),re(3,g.IApplicationStorageMainService),re(4,t.IDialogMainService)],n)}),define(le[279],ue([0,1,13,8,22,49,3,7,9,85,16,20,19,5,202,65,28,34,24,51,47,29,90,2]),function(j,e,i,s,y,k,A,R,S,c,m,u,p,v,f,h,E,b,g,I,P,r,a,t){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.Menubar=void 0,S=Re(S);const n="menu";let l=class extends t.Disposable{static{o=this}static{this.lastKnownMenubarStorageKey="lastKnownMenubarData"}constructor(w,M,T,C,L,_,V,z,Q,fe,se,ee){super(),this.updateService=w,this.configurationService=M,this.windowsMainService=T,this.environmentMainService=C,this.telemetryService=L,this.workspacesHistoryMainService=_,this.stateService=V,this.lifecycleMainService=z,this.logService=Q,this.nativeHostMainService=fe,this.productService=se,this.auxiliaryWindowsMainService=ee,this.fallbackMenuHandlers=Object.create(null),this.menuUpdater=new s.RunOnceScheduler(()=>this.doUpdateMenu(),0),this.menuGC=new s.RunOnceScheduler(()=>{this.oldMenus=[]},1e4),this.menubarMenus=Object.create(null),this.keybindings=Object.create(null),(A.isMacintosh||(0,P.hasNativeTitlebar)(M))&&this.restoreCachedMenubarData(),this.addFallbackHandlers(),this.closedLastWindow=!1,this.noActiveMainWindow=!1,this.oldMenus=[],this.install(),this.registerListeners()}restoreCachedMenubarData(){const w=this.stateService.getItem(o.lastKnownMenubarStorageKey);w&&(w.menus&&(this.menubarMenus=w.menus),w.keybindings&&(this.keybindings=w.keybindings))}addFallbackHandlers(){this.fallbackMenuHandlers["workbench.action.files.newUntitledFile"]=(_,V,z)=>{this.runActionInRenderer({type:"commandId",commandId:"workbench.action.files.newUntitledFile"})||this.windowsMainService.openEmptyWindow({context:r.OpenContext.MENU,contextWindowId:V?.id})},this.fallbackMenuHandlers["workbench.action.newWindow"]=(_,V,z)=>this.windowsMainService.openEmptyWindow({context:r.OpenContext.MENU,contextWindowId:V?.id}),this.fallbackMenuHandlers["workbench.action.files.openFileFolder"]=(_,V,z)=>this.nativeHostMainService.pickFileFolderAndOpen(void 0,{forceNewWindow:this.isOptionClick(z),telemetryExtraData:{from:n}}),this.fallbackMenuHandlers["workbench.action.files.openFolder"]=(_,V,z)=>this.nativeHostMainService.pickFolderAndOpen(void 0,{forceNewWindow:this.isOptionClick(z),telemetryExtraData:{from:n}}),this.fallbackMenuHandlers["workbench.action.openWorkspace"]=(_,V,z)=>this.nativeHostMainService.pickWorkspaceAndOpen(void 0,{forceNewWindow:this.isOptionClick(z),telemetryExtraData:{from:n}}),this.fallbackMenuHandlers["workbench.action.clearRecentFiles"]=()=>this.workspacesHistoryMainService.clearRecentlyOpened({confirm:!0});const w=this.productService.youTubeUrl;w&&(this.fallbackMenuHandlers["workbench.action.openYouTubeUrl"]=()=>this.openUrl(w,"openYouTubeUrl"));const M=this.productService.requestFeatureUrl;M&&(this.fallbackMenuHandlers["workbench.action.openRequestFeatureUrl"]=()=>this.openUrl(M,"openUserVoiceUrl"));const T=this.productService.reportIssueUrl;T&&(this.fallbackMenuHandlers["workbench.action.openIssueReporter"]=()=>this.openUrl(T,"openReportIssues"));const C=this.productService.licenseUrl;C&&(this.fallbackMenuHandlers["workbench.action.openLicenseUrl"]=()=>{if(A.language){const _=C.indexOf("?")>0?"&":"?";this.openUrl(`${C}${_}lang=${A.language}`,"openLicenseUrl")}else this.openUrl(C,"openLicenseUrl")});const L=this.productService.privacyStatementUrl;L&&C&&(this.fallbackMenuHandlers["workbench.action.openPrivacyStatementUrl"]=()=>{this.openUrl(L,"openPrivacyStatement")})}registerListeners(){this._register(this.lifecycleMainService.onWillShutdown(()=>this.willShutdown=!0)),this._register(this.windowsMainService.onDidChangeWindowsCount(w=>this.onDidChangeWindowsCount(w))),this._register(this.nativeHostMainService.onDidBlurMainWindow(()=>this.onDidChangeWindowFocus())),this._register(this.nativeHostMainService.onDidFocusMainWindow(()=>this.onDidChangeWindowFocus()))}get currentEnableMenuBarMnemonics(){const w=this.configurationService.getValue("window.enableMenuBarMnemonics");return typeof w!="boolean"?!0:w}get currentEnableNativeTabs(){if(!A.isMacintosh)return!1;const w=this.configurationService.getValue("window.nativeTabs");return typeof w!="boolean"?!1:w}updateMenu(w,M){this.menubarMenus=w.menus,this.keybindings=w.keybindings,this.stateService.setItem(o.lastKnownMenubarStorageKey,w),this.scheduleUpdateMenu()}scheduleUpdateMenu(){this.menuUpdater.schedule()}doUpdateMenu(){this.willShutdown||setTimeout(()=>{this.willShutdown||this.install()},10)}onDidChangeWindowsCount(w){A.isMacintosh&&(w.oldCount===0&&w.newCount>0||w.oldCount>0&&w.newCount===0)&&(this.closedLastWindow=w.newCount===0,this.scheduleUpdateMenu())}onDidChangeWindowFocus(){if(!A.isMacintosh)return;const w=i.BrowserWindow.getFocusedWindow();this.noActiveMainWindow=!w||!!this.auxiliaryWindowsMainService.getWindowByWebContents(w.webContents),this.scheduleUpdateMenu()}install(){const w=i.Menu.getApplicationMenu();if(w&&this.oldMenus.push(w),Object.keys(this.menubarMenus).length===0){this.doSetApplicationMenu(A.isMacintosh?new i.Menu:null);return}const M=new i.Menu;let T;if(A.isMacintosh){const L=new i.Menu;T=new i.MenuItem({label:this.productService.nameShort,submenu:L}),this.setMacApplicationMenu(L),M.append(T)}if(A.isMacintosh&&!this.appMenuInstalled){this.appMenuInstalled=!0;const L=new i.Menu;L.append(new i.MenuItem({label:this.mnemonicLabel(S.localize(1968,null)),click:()=>this.windowsMainService.openEmptyWindow({context:r.OpenContext.DOCK})})),i.app.dock.setMenu(L)}if(this.shouldDrawMenu("File")){const L=new i.Menu,_=new i.MenuItem({label:this.mnemonicLabel(S.localize(1969,null)),submenu:L});this.setMenuById(L,"File"),M.append(_)}if(this.shouldDrawMenu("Edit")){const L=new i.Menu,_=new i.MenuItem({label:this.mnemonicLabel(S.localize(1970,null)),submenu:L});this.setMenuById(L,"Edit"),M.append(_)}if(this.shouldDrawMenu("Selection")){const L=new i.Menu,_=new i.MenuItem({label:this.mnemonicLabel(S.localize(1971,null)),submenu:L});this.setMenuById(L,"Selection"),M.append(_)}if(this.shouldDrawMenu("View")){const L=new i.Menu,_=new i.MenuItem({label:this.mnemonicLabel(S.localize(1972,null)),submenu:L});this.setMenuById(L,"View"),M.append(_)}if(this.shouldDrawMenu("Go")){const L=new i.Menu,_=new i.MenuItem({label:this.mnemonicLabel(S.localize(1973,null)),submenu:L});this.setMenuById(L,"Go"),M.append(_)}if(this.shouldDrawMenu("Run")){const L=new i.Menu,_=new i.MenuItem({label:this.mnemonicLabel(S.localize(1974,null)),submenu:L});this.setMenuById(L,"Run"),M.append(_)}if(this.shouldDrawMenu("Terminal")){const L=new i.Menu,_=new i.MenuItem({label:this.mnemonicLabel(S.localize(1975,null)),submenu:L});this.setMenuById(L,"Terminal"),M.append(_)}let C;if(this.shouldDrawMenu("Window")){const L=new i.Menu;C=new i.MenuItem({label:this.mnemonicLabel(S.localize(1976,null)),submenu:L,role:"window"}),this.setMacWindowMenu(L)}if(C&&M.append(C),this.shouldDrawMenu("Help")){const L=new i.Menu,_=new i.MenuItem({label:this.mnemonicLabel(S.localize(1977,null)),submenu:L,role:"help"});this.setMenuById(L,"Help"),M.append(_)}M.items&&M.items.length>0?this.doSetApplicationMenu(M):this.doSetApplicationMenu(null),this.menuGC.schedule()}doSetApplicationMenu(w){if(i.Menu.setApplicationMenu(w),w)for(const M of this.auxiliaryWindowsMainService.getWindows())M.win?.setMenu(null)}setMacApplicationMenu(w){const M=this.createMenuItem(S.localize(1978,null,this.productService.nameLong),"workbench.action.showAboutDialog"),T=this.getUpdateMenuItems();let C;if(this.shouldDrawMenu("Preferences")){const ee=new i.Menu;this.setMenuById(ee,"Preferences"),C=new i.MenuItem({label:this.mnemonicLabel(S.localize(1979,null)),submenu:ee})}const L=new i.Menu,_=new i.MenuItem({label:S.localize(1980,null),role:"services",submenu:L}),V=new i.MenuItem({label:S.localize(1981,null,this.productService.nameLong),role:"hide",accelerator:"Command+H"}),z=new i.MenuItem({label:S.localize(1982,null),role:"hideOthers",accelerator:"Command+Alt+H"}),Q=new i.MenuItem({label:S.localize(1983,null),role:"unhide"}),fe=new i.MenuItem(this.likeAction("workbench.action.quit",{label:S.localize(1984,null,this.productService.nameLong),click:async(ee,U,K)=>{const N=this.windowsMainService.getLastActiveWindow();(this.windowsMainService.getWindowCount()===0||i.BrowserWindow.getFocusedWindow()||N?.win?.isMinimized())&&await this.confirmBeforeQuit(K)&&this.nativeHostMainService.quit(void 0)}})),se=[M];se.push(...T),C&&se.push(d(),C),se.push(d(),_,d(),V,z,Q,d(),fe),se.forEach(ee=>w.append(ee))}async confirmBeforeQuit(w){if(this.windowsMainService.getWindowCount()===0)return!0;const M=this.configurationService.getValue("window.confirmBeforeClose");if(M==="always"||M==="keyboardOnly"&&this.isKeyboardEvent(w)){const{response:T}=await this.nativeHostMainService.showMessageBox(this.windowsMainService.getFocusedWindow()?.id,{type:"question",buttons:[S.localize(1985,null),S.localize(1986,null)],message:S.localize(1987,null)});return T===0}return!0}shouldDrawMenu(w){if(!A.isMacintosh&&!(0,P.hasNativeTitlebar)(this.configurationService))return!1;switch(w){case"File":case"Help":if(A.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveMainWindow||!!this.menubarMenus&&!!this.menubarMenus[w];case"Window":if(A.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveMainWindow||!!this.menubarMenus;default:return this.windowsMainService.getWindowCount()>0&&!!this.menubarMenus&&!!this.menubarMenus[w]}}setMenu(w,M){M.forEach(T=>{if((0,f.isMenubarMenuItemSeparator)(T))w.append(d());else if((0,f.isMenubarMenuItemSubmenu)(T)){const C=new i.Menu,L=new i.MenuItem({label:this.mnemonicLabel(T.label),submenu:C});this.setMenu(C,T.submenu.items),w.append(L)}else(0,f.isMenubarMenuItemRecentAction)(T)?w.append(this.createOpenRecentMenuItem(T)):(0,f.isMenubarMenuItemAction)(T)&&(T.id==="workbench.action.showAboutDialog"&&this.insertCheckForUpdatesItems(w),A.isMacintosh?this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveMainWindow?this.fallbackMenuHandlers[T.id]?w.append(new i.MenuItem(this.likeAction(T.id,{label:this.mnemonicLabel(T.label),click:this.fallbackMenuHandlers[T.id]}))):w.append(this.createMenuItem(T.label,T.id,!1,T.checked)):w.append(this.createMenuItem(T.label,T.id,T.enabled!==!1,!!T.checked)):w.append(this.createMenuItem(T.label,T.id,T.enabled!==!1,!!T.checked)))})}setMenuById(w,M){this.menubarMenus&&this.menubarMenus[M]&&this.setMenu(w,this.menubarMenus[M].items)}insertCheckForUpdatesItems(w){const M=this.getUpdateMenuItems();M.length&&(M.forEach(T=>w.append(T)),w.append(d()))}createOpenRecentMenuItem(w){const M=R.URI.revive(w.uri),T=w.id,C=T==="openRecentFile"?{fileUri:M}:T==="openRecentWorkspace"?{workspaceUri:M}:{folderUri:M};return new i.MenuItem(this.likeAction(T,{label:w.label,click:async(L,_,V)=>{const z=this.isOptionClick(V);(await this.windowsMainService.open({context:r.OpenContext.MENU,cli:this.environmentMainService.args,urisToOpen:[C],forceNewWindow:z,gotoLineMode:!1,remoteAuthority:w.remoteAuthority})).length>0||await this.workspacesHistoryMainService.removeRecentlyOpened([M])}},!1))}isOptionClick(w){return!!(w&&(!A.isMacintosh&&(w.ctrlKey||w.shiftKey)||A.isMacintosh&&(w.metaKey||w.altKey)))}isKeyboardEvent(w){return!!(w.triggeredByAccelerator||w.altKey||w.ctrlKey||w.metaKey||w.shiftKey)}createRoleMenuItem(w,M,T){const C={label:this.mnemonicLabel(w),role:T,enabled:!0};return new i.MenuItem(this.withKeybinding(M,C))}setMacWindowMenu(w){const M=new i.MenuItem({label:S.localize(1988,null),role:"minimize",accelerator:"Command+M",enabled:this.windowsMainService.getWindowCount()>0}),T=new i.MenuItem({label:S.localize(1989,null),role:"zoom",enabled:this.windowsMainService.getWindowCount()>0}),C=new i.MenuItem({label:S.localize(1990,null),role:"front",enabled:this.windowsMainService.getWindowCount()>0}),L=this.createMenuItem(S.localize(1991,null),"workbench.action.switchWindow"),_=[];this.currentEnableNativeTabs&&(_.push(d()),_.push(this.createMenuItem(S.localize(1992,null),"workbench.action.newWindowTab")),_.push(this.createRoleMenuItem(S.localize(1993,null),"workbench.action.showPreviousWindowTab","selectPreviousTab")),_.push(this.createRoleMenuItem(S.localize(1994,null),"workbench.action.showNextWindowTab","selectNextTab")),_.push(this.createRoleMenuItem(S.localize(1995,null),"workbench.action.moveWindowTabToNewWindow","moveTabToNewWindow")),_.push(this.createRoleMenuItem(S.localize(1996,null),"workbench.action.mergeAllWindowTabs","mergeAllWindows"))),[M,T,d(),L,..._,d(),C].forEach(V=>w.append(V))}getUpdateMenuItems(){switch(this.updateService.state.type){case I.StateType.Idle:return[new i.MenuItem({label:this.mnemonicLabel(S.localize(1997,null)),click:()=>setTimeout(()=>{this.reportMenuActionTelemetry("CheckForUpdate"),this.updateService.checkForUpdates(!0)},0)})];case I.StateType.CheckingForUpdates:return[new i.MenuItem({label:S.localize(1998,null),enabled:!1})];case I.StateType.AvailableForDownload:return[new i.MenuItem({label:this.mnemonicLabel(S.localize(1999,null)),click:()=>{this.updateService.downloadUpdate()}})];case I.StateType.Downloading:return[new i.MenuItem({label:S.localize(2e3,null),enabled:!1})];case I.StateType.Downloaded:return A.isMacintosh?[]:[new i.MenuItem({label:this.mnemonicLabel(S.localize(2001,null)),click:()=>{this.reportMenuActionTelemetry("InstallUpdate"),this.updateService.applyUpdate()}})];case I.StateType.Updating:return[new i.MenuItem({label:S.localize(2002,null),enabled:!1})];case I.StateType.Ready:return[new i.MenuItem({label:this.mnemonicLabel(S.localize(2003,null)),click:()=>{this.reportMenuActionTelemetry("RestartToUpdate"),this.updateService.quitAndInstall()}})];default:return[]}}createMenuItem(w,M,T,C){const L=this.mnemonicLabel(w),_=typeof M=="function"?M:(se,ee,U)=>{const K=se?se.userSettingsLabel:null;let N=M;Array.isArray(M)&&(N=this.isOptionClick(U)?M[1]:M[0]),K&&U.triggeredByAccelerator?this.runActionInRenderer({type:"keybinding",userSettingsLabel:K}):this.runActionInRenderer({type:"commandId",commandId:N})},V=typeof T=="boolean"?T:this.windowsMainService.getWindowCount()>0,z=typeof C=="boolean"?C:!1,Q={label:L,click:_,enabled:V};z&&(Q.type="checkbox",Q.checked=z);let fe;return typeof M=="string"?fe=M:Array.isArray(M)&&(fe=M[0]),A.isMacintosh&&(fe==="editor.action.clipboardCutAction"?Q.role="cut":fe==="editor.action.clipboardCopyAction"?Q.role="copy":fe==="editor.action.clipboardPasteAction"&&(Q.role="paste"),fe==="undo"?Q.click=this.makeContextAwareClickHandler(_,{inDevTools:se=>se.undo(),inNoWindow:()=>i.Menu.sendActionToFirstResponder("undo:")}):fe==="redo"?Q.click=this.makeContextAwareClickHandler(_,{inDevTools:se=>se.redo(),inNoWindow:()=>i.Menu.sendActionToFirstResponder("redo:")}):fe==="editor.action.selectAll"&&(Q.click=this.makeContextAwareClickHandler(_,{inDevTools:se=>se.selectAll(),inNoWindow:()=>i.Menu.sendActionToFirstResponder("selectAll:")}))),new i.MenuItem(this.withKeybinding(fe,Q))}makeContextAwareClickHandler(w,M){return(T,C,L)=>{const _=i.BrowserWindow.getFocusedWindow();if(!_)return M.inNoWindow();if(_.webContents.isDevToolsFocused()&&_.webContents.devToolsWebContents)return M.inDevTools(_.webContents.devToolsWebContents);w(T,C||_,L)}}runActionInRenderer(w){let M=i.BrowserWindow.getFocusedWindow();if(M){const C=this.auxiliaryWindowsMainService.getWindowByWebContents(M.webContents);C&&(M=this.windowsMainService.getWindowById(C.parentId)?.win??null)}if(!M){const C=this.windowsMainService.getLastActiveWindow();C?.win?.isMinimized()&&(M=C.win)}const T=M?this.windowsMainService.getWindowById(M.id):void 0;if(T){if(this.logService.trace("menubar#runActionInRenderer",w),A.isMacintosh&&!this.environmentMainService.isBuilt&&!T.isReady&&(w.type==="commandId"&&w.commandId==="workbench.action.toggleDevTools"||w.type!=="commandId"&&w.userSettingsLabel==="alt+cmd+i"))return!1;if(w.type==="commandId"){const C={id:w.commandId,from:"menu"};T.sendWhenReady("vscode:runAction",y.CancellationToken.None,C)}else{const C={userSettingsLabel:w.userSettingsLabel};T.sendWhenReady("vscode:runKeybinding",y.CancellationToken.None,C)}return!0}else return this.logService.trace("menubar#runActionInRenderer: no active window found",w),!1}withKeybinding(w,M){const T=typeof w=="string"?this.keybindings[w]:void 0;if(T?.label){if(T.isNative!==!1)M.accelerator=T.label,M.userSettingsLabel=T.userSettingsLabel;else if(typeof M.label=="string"){const C=M.label.indexOf("[");C>=0?M.label=`${M.label.substr(0,C)} [${T.label}]`:M.label=`${M.label} [${T.label}]`}}else M.accelerator=void 0;return M}likeAction(w,M,T=!M.accelerator){T&&(M=this.withKeybinding(w,M));const C=M.click;return M.click=(L,_,V)=>{this.reportMenuActionTelemetry(w),C?.(L,_,V)},M}openUrl(w,M){this.nativeHostMainService.openExternal(void 0,w),this.reportMenuActionTelemetry(M)}reportMenuActionTelemetry(w){this.telemetryService.publicLog2("workbenchActionExecuted",{id:w,from:n})}mnemonicLabel(w){return(0,k.mnemonicMenuLabel)(w,!this.currentEnableMenuBarMnemonics)}};e.Menubar=l,e.Menubar=l=o=Pe([re(0,I.IUpdateService),re(1,m.IConfigurationService),re(2,r.IWindowsMainService),re(3,u.IEnvironmentMainService),re(4,g.ITelemetryService),re(5,a.IWorkspacesHistoryMainService),re(6,b.IStateService),re(7,p.ILifecycleMainService),re(8,v.ILogService),re(9,h.INativeHostMainService),re(10,E.IProductService),re(11,c.IAuxiliaryWindowsMainService)],l);function d(){return new i.MenuItem({type:"separator"})}}),define(le[280],ue([0,1,6,19,5,279,2]),function(j,e,i,s,y,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MenubarMainService=e.IMenubarMainService=void 0,e.IMenubarMainService=(0,i.createDecorator)("menubarMainService");let R=class extends A.Disposable{constructor(c,m,u){super(),this.instantiationService=c,this.lifecycleMainService=m,this.logService=u,this.menubar=this.installMenuBarAfterWindowOpen()}async installMenuBarAfterWindowOpen(){return await this.lifecycleMainService.when(s.LifecycleMainPhase.AfterWindowOpen),this._register(this.instantiationService.createInstance(k.Menubar))}async updateMenubar(c,m){this.logService.trace("menubarService#updateMenubar",c),(await this.menubar).updateMenu(m,c)}};e.MenubarMainService=R,e.MenubarMainService=R=Pe([re(0,i.IInstantiationService),re(1,s.ILifecycleMainService),re(2,y.ILogService)],R)});var je=this&&this.__importDefault||function(j){return j&&j.__esModule?j:{default:j}};define(le[281],ue([0,1,26,13,109,27,21,22,39,4,32,49,2,11,10,71,3,38,18,12,7,9,70,16,53,20,14,6,19,5,73,74,75,34,47,140,29,137,272,30,106,90,59,52,77,40,58,72,85,86]),function(j,e,i,s,y,k,A,R,S,c,m,u,p,v,f,h,E,b,g,I,P,r,a,t,o,n,l,d,D,w,M,T,C,L,_,V,z,Q,fe,se,ee,U,K,N,x,W,q,ie,H,ce){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowsMainService=void 0,i=Re(i),M=je(M);function oe(X){return(0,se.isWorkspaceIdentifier)(X?.workspace)}function te(X){return(0,se.isSingleFolderWorkspaceIdentifier)(X?.workspace)}let O=class extends p.Disposable{constructor(B,F,J,G,$,Z,ae,pe,Se,ye,We,He,Ce,me,Y,de,he,ve,Ee,Oe,Ae,Me){super(),this.machineId=B,this.sqmId=F,this.devDeviceId=J,this.initialUserEnv=G,this.logService=$,this.loggerService=Z,this.stateService=ae,this.policyService=pe,this.environmentMainService=Se,this.userDataProfilesMainService=ye,this.lifecycleMainService=We,this.backupMainService=He,this.configurationService=Ce,this.workspacesHistoryMainService=me,this.workspacesManagementMainService=Y,this.instantiationService=de,this.dialogMainService=he,this.fileService=ve,this.protocolMainService=Ee,this.themeMainService=Oe,this.auxiliaryWindowsMainService=Ae,this.cssDevelopmentService=Me,this._onDidOpenWindow=this._register(new c.Emitter),this.onDidOpenWindow=this._onDidOpenWindow.event,this._onDidSignalReadyWindow=this._register(new c.Emitter),this.onDidSignalReadyWindow=this._onDidSignalReadyWindow.event,this._onDidDestroyWindow=this._register(new c.Emitter),this.onDidDestroyWindow=this._onDidDestroyWindow.event,this._onDidChangeWindowsCount=this._register(new c.Emitter),this.onDidChangeWindowsCount=this._onDidChangeWindowsCount.event,this._onDidMaximizeWindow=this._register(new c.Emitter),this.onDidMaximizeWindow=this._onDidMaximizeWindow.event,this._onDidUnmaximizeWindow=this._register(new c.Emitter),this.onDidUnmaximizeWindow=this._onDidUnmaximizeWindow.event,this._onDidChangeFullScreen=this._register(new c.Emitter),this.onDidChangeFullScreen=this._onDidChangeFullScreen.event,this._onDidTriggerSystemContextMenu=this._register(new c.Emitter),this.onDidTriggerSystemContextMenu=this._onDidTriggerSystemContextMenu.event,this.windows=new Map,this.windowsStateHandler=this._register(new fe.WindowsStateHandler(this,this.stateService,this.lifecycleMainService,this.logService,this.configurationService)),this.registerListeners()}registerListeners(){this._register(this.workspacesManagementMainService.onDidEnterWorkspace(B=>this._onDidSignalReadyWindow.fire(B.window))),this._register(this.onDidSignalReadyWindow(B=>{if(B.config?.extensionDevelopmentPath||B.config?.extensionTestsPath){const F=new p.DisposableStore;if(F.add(c.Event.any(B.onDidClose,B.onDidDestroy)(()=>F.dispose())),B.config.extensionDevelopmentPath)for(const J of B.config.extensionDevelopmentPath)F.add(this.protocolMainService.addValidFileRoot(J));B.config.extensionTestsPath&&F.add(this.protocolMainService.addValidFileRoot(B.config.extensionTestsPath))}}))}openEmptyWindow(B,F){const J=this.environmentMainService.args,G=F?.remoteAuthority||void 0,$=!0,Z=F?.forceReuseWindow,ae=!Z;return this.open({...B,cli:J,forceEmpty:$,forceNewWindow:ae,forceReuseWindow:Z,remoteAuthority:G,forceTempProfile:F?.forceTempProfile,forceProfile:F?.forceProfile})}openExistingWindow(B,F){B.focus(),this.handleWaitMarkerFile(F,[B])}async open(B){this.logService.trace("windowsManager#open"),B.addMode&&(B.initialStartup||!this.getLastActiveWindow())&&(B.addMode=!1);const F=[],J=[],G=[],$=[],Z=[];let ae,pe=!1;const Se=await this.getPathsToOpen(B);this.logService.trace("windowsManager#open pathsToOpen",Se);for(const me of Se)te(me)?B.addMode?F.push(me):J.push(me):oe(me)?G.push(me):me.fileUri?(ae||(ae={filesToOpenOrCreate:[],filesToDiff:[],filesToMerge:[],remoteAuthority:me.remoteAuthority}),ae.filesToOpenOrCreate.push(me)):me.backupPath?Z.push({backupFolder:(0,f.basename)(me.backupPath),remoteAuthority:me.remoteAuthority}):pe=!0;B.diffMode&&ae&&ae.filesToOpenOrCreate.length>=2&&(ae.filesToDiff=ae.filesToOpenOrCreate.slice(0,2),ae.filesToOpenOrCreate=[]),B.mergeMode&&ae&&ae.filesToOpenOrCreate.length===4&&(ae.filesToMerge=ae.filesToOpenOrCreate.slice(0,4),ae.filesToOpenOrCreate=[],ae.filesToDiff=[]),ae&&B.waitMarkerFileURI&&(ae.filesToWait={paths:(0,A.coalesce)([...ae.filesToDiff,ae.filesToMerge[3],...ae.filesToOpenOrCreate]),waitMarkerFileUri:B.waitMarkerFileURI}),B.initialStartup?($.push(...this.workspacesManagementMainService.getUntitledWorkspaces()),G.push(...$),Z.push(...this.backupMainService.getEmptyWindowBackups())):Z.length=0;const{windows:ye,filesOpenedInWindow:We}=await this.doOpen(B,G,J,Z,pe,ae,F);if(this.logService.trace(`windowsManager#open used window count ${ye.length} (workspacesToOpen: ${G.length}, foldersToOpen: ${J.length}, emptyToRestore: ${Z.length}, openOneEmptyWindow: ${pe})`),ye.length>1)if(We)We.focus();else{const me=this.windowsStateHandler.state.lastActiveWindow&&!B.forceEmpty&&!B.cli._.length&&!B.cli["file-uri"]&&!B.cli["folder-uri"]&&!(B.urisToOpen&&B.urisToOpen.length);let Y=!0,de=!0;if(me){const he=ye.filter(ve=>this.windowsStateHandler.state.lastActiveWindow&&ve.backupPath===this.windowsStateHandler.state.lastActiveWindow.backupPath);he.length&&(he[0].focus(),Y=!1,de=!1)}if(Y)for(let he=ye.length-1;he>=0;he--){const ve=ye[he];if(!(ve.openedWorkspace&&$.some(Ee=>ve.openedWorkspace&&Ee.workspace.id===ve.openedWorkspace.id)||ve.backupPath&&Z.some(Ee=>ve.backupPath&&Ee.backupFolder===(0,f.basename)(ve.backupPath)))){ve.focus(),de=!1;break}}de&&ye[ye.length-1].focus()}const He=ae&&ae.filesToDiff.length>0,Ce=ae&&ae.filesToMerge.length>0;if(!ye.some(me=>me.isExtensionDevelopmentHost)&&!He&&!Ce&&!B.noRecentEntry){const me=[];for(const Y of Se)oe(Y)&&!Y.transient?me.push({label:Y.label,workspace:Y.workspace,remoteAuthority:Y.remoteAuthority}):te(Y)?me.push({label:Y.label,folderUri:Y.workspace.uri,remoteAuthority:Y.remoteAuthority}):Y.fileUri&&me.push({label:Y.label,fileUri:Y.fileUri,remoteAuthority:Y.remoteAuthority});this.workspacesHistoryMainService.addRecentlyOpened(me)}return this.handleWaitMarkerFile(B,ye),ye}handleWaitMarkerFile(B,F){const J=B.waitMarkerFileURI;B.context===z.OpenContext.CLI&&J&&F.length===1&&F[0]&&(async()=>{await F[0].whenClosedOrLoaded;try{await this.fileService.del(J)}catch{}})()}async doOpen(B,F,J,G,$,Z,ae){const pe=[];let Se;function ye(he,ve){pe.push(he),ve&&(Se=he,Z=void 0)}let{openFolderInNewWindow:We,openFilesInNewWindow:He}=this.shouldOpenNewWindow(B);if(!B.initialStartup&&ae.length>0){const he=ae[0].remoteAuthority,ve=this.getLastActiveWindowForAuthority(he);ve&&ye(this.doAddFoldersToExistingWindow(ve,ae.map(Ee=>Ee.workspace.uri)))}const Ce=J.length+F.length+G.length;if(Z&&Ce===0){const he=Z.filesToOpenOrCreate[0]||Z.filesToDiff[0]||Z.filesToMerge[3],ve=this.getWindows().filter(Oe=>Z&&(0,g.isEqualAuthority)(Oe.remoteAuthority,Z.remoteAuthority));let Ee;he?.fileUri&&!He&&((B.context===z.OpenContext.DESKTOP||B.context===z.OpenContext.CLI||B.context===z.OpenContext.DOCK||B.context===z.OpenContext.LINK)&&(Ee=await(0,Q.findWindowOnFile)(ve,he.fileUri,async Oe=>Oe.configPath.scheme===v.Schemas.file?this.workspacesManagementMainService.resolveLocalWorkspace(Oe.configPath):void 0)),Ee||(Ee=this.doGetLastActiveWindow(ve))),Ee?(0,se.isWorkspaceIdentifier)(Ee.openedWorkspace)?F.push({workspace:Ee.openedWorkspace,remoteAuthority:Ee.remoteAuthority}):(0,se.isSingleFolderWorkspaceIdentifier)(Ee.openedWorkspace)?J.push({workspace:Ee.openedWorkspace,remoteAuthority:Ee.remoteAuthority}):ye(this.doOpenFilesInExistingWindow(B,Ee,Z),!0):ye(await this.openInBrowserWindow({userEnv:B.userEnv,cli:B.cli,initialStartup:B.initialStartup,filesToOpen:Z,forceNewWindow:!0,remoteAuthority:Z.remoteAuthority,forceNewTabbedWindow:B.forceNewTabbedWindow,forceProfile:B.forceProfile,forceTempProfile:B.forceTempProfile}),!0)}const me=(0,A.distinct)(F,he=>he.workspace.id);if(me.length>0){const he=(0,A.coalesce)(me.map(ve=>(0,Q.findWindowOnWorkspaceOrFolder)(this.getWindows(),ve.workspace.configPath)));if(he.length>0){const ve=he[0],Ee=(0,g.isEqualAuthority)(Z?.remoteAuthority,ve.remoteAuthority)?Z:void 0;ye(this.doOpenFilesInExistingWindow(B,ve,Ee),!!Ee),We=!0}for(const ve of me){if(he.some(Ae=>Ae.openedWorkspace&&Ae.openedWorkspace.id===ve.workspace.id))continue;const Ee=ve.remoteAuthority,Oe=(0,g.isEqualAuthority)(Z?.remoteAuthority,Ee)?Z:void 0;ye(await this.doOpenFolderOrWorkspace(B,ve,We,Oe),!!Oe),We=!0}}const Y=(0,A.distinct)(J,he=>g.extUriBiasedIgnorePathCase.getComparisonKey(he.workspace.uri));if(Y.length>0){const he=(0,A.coalesce)(Y.map(ve=>(0,Q.findWindowOnWorkspaceOrFolder)(this.getWindows(),ve.workspace.uri)));if(he.length>0){const ve=he[0],Ee=(0,g.isEqualAuthority)(Z?.remoteAuthority,ve.remoteAuthority)?Z:void 0;ye(this.doOpenFilesInExistingWindow(B,ve,Ee),!!Ee),We=!0}for(const ve of Y){if(he.some(Ae=>(0,se.isSingleFolderWorkspaceIdentifier)(Ae.openedWorkspace)&&g.extUriBiasedIgnorePathCase.isEqual(Ae.openedWorkspace.uri,ve.workspace.uri)))continue;const Ee=ve.remoteAuthority,Oe=(0,g.isEqualAuthority)(Z?.remoteAuthority,Ee)?Z:void 0;ye(await this.doOpenFolderOrWorkspace(B,ve,We,Oe),!!Oe),We=!0}}const de=(0,A.distinct)(G,he=>he.backupFolder);if(de.length>0)for(const he of de){const ve=he.remoteAuthority,Ee=(0,g.isEqualAuthority)(Z?.remoteAuthority,ve)?Z:void 0;ye(await this.doOpenEmpty(B,!0,ve,Ee,he),!!Ee),We=!0}if(Z||$){const he=Z?Z.remoteAuthority:B.remoteAuthority;ye(await this.doOpenEmpty(B,We,he,Z),!!Z)}return{windows:(0,A.distinct)(pe),filesOpenedInWindow:Se}}doOpenFilesInExistingWindow(B,F,J){this.logService.trace("windowsManager#doOpenFilesInExistingWindow",{filesToOpen:J}),this.focusMainOrChildWindow(F);const G={filesToOpenOrCreate:J?.filesToOpenOrCreate,filesToDiff:J?.filesToDiff,filesToMerge:J?.filesToMerge,filesToWait:J?.filesToWait,termProgram:B?.userEnv?.TERM_PROGRAM};return F.sendWhenReady("vscode:openFiles",R.CancellationToken.None,G),F}focusMainOrChildWindow(B){let F=B;const J=s.BrowserWindow.getFocusedWindow();if(J&&J.id!==B.id){const G=this.auxiliaryWindowsMainService.getWindowByWebContents(J.webContents);G&&G.parentId===B.id&&(F=G)}F.focus()}doAddFoldersToExistingWindow(B,F){this.logService.trace("windowsManager#doAddFoldersToExistingWindow",{foldersToAdd:F}),B.focus();const J={foldersToAdd:F};return B.sendWhenReady("vscode:addFolders",R.CancellationToken.None,J),B}doOpenEmpty(B,F,J,G,$){this.logService.trace("windowsManager#doOpenEmpty",{restore:!!$,remoteAuthority:J,filesToOpen:G,forceNewWindow:F});let Z;return!F&&typeof B.contextWindowId=="number"&&(Z=this.getWindowById(B.contextWindowId)),this.openInBrowserWindow({userEnv:B.userEnv,cli:B.cli,initialStartup:B.initialStartup,remoteAuthority:J,forceNewWindow:F,forceNewTabbedWindow:B.forceNewTabbedWindow,filesToOpen:G,windowToUse:Z,emptyWindowBackupInfo:$,forceProfile:B.forceProfile,forceTempProfile:B.forceTempProfile})}doOpenFolderOrWorkspace(B,F,J,G,$){return this.logService.trace("windowsManager#doOpenFolderOrWorkspace",{folderOrWorkspace:F,filesToOpen:G}),!J&&!$&&typeof B.contextWindowId=="number"&&($=this.getWindowById(B.contextWindowId)),this.openInBrowserWindow({workspace:F.workspace,userEnv:B.userEnv,cli:B.cli,initialStartup:B.initialStartup,remoteAuthority:F.remoteAuthority,forceNewWindow:J,forceNewTabbedWindow:B.forceNewTabbedWindow,filesToOpen:G,windowToUse:$,forceProfile:B.forceProfile,forceTempProfile:B.forceTempProfile})}async getPathsToOpen(B){let F,J=!1,G=!1;if(B.urisToOpen&&B.urisToOpen.length>0?(F=await this.doExtractPathsFromAPI(B),J=!0):B.forceEmpty?F=[Object.create(null)]:B.cli._.length||B.cli["folder-uri"]||B.cli["file-uri"]?(F=await this.doExtractPathsFromCLI(B.cli),F.length===0&&F.push(Object.create(null)),J=!0):(F=await this.doGetPathsFromLastSession(),F.length===0&&F.push(Object.create(null)),G=!0),!B.addMode&&J){const $=F.filter(Z=>te(Z));if($.length>1){const Z=$[0].remoteAuthority;if($.every(ae=>(0,g.isEqualAuthority)(ae.remoteAuthority,Z))){const ae=await this.workspacesManagementMainService.createUntitledWorkspace($.map(pe=>({uri:pe.workspace.uri})));F.push({workspace:ae,remoteAuthority:Z}),F=F.filter(pe=>!te(pe))}}}if(B.initialStartup&&!G&&this.configurationService.getValue("window")?.restoreWindows==="preserve"){const $=await this.doGetPathsFromLastSession();F.unshift(...$.filter(Z=>oe(Z)||te(Z)||Z.backupPath))}return F}async doExtractPathsFromAPI(B){const F={gotoLineMode:B.gotoLineMode,remoteAuthority:B.remoteAuthority},J=await Promise.all((0,A.coalesce)(B.urisToOpen||[]).map(async G=>{const $=await this.resolveOpenable(G,F);if($)return $.label=G.label,$;const Z=this.resourceFromOpenable(G);this.dialogMainService.showMessageBox({type:"info",buttons:[(0,r.localize)(2478,null)],message:Z.scheme===v.Schemas.file?(0,r.localize)(2479,null):(0,r.localize)(2480,null),detail:Z.scheme===v.Schemas.file?(0,r.localize)(2481,null,(0,u.getPathLabel)(Z,{os:E.OS,tildify:this.environmentMainService})):(0,r.localize)(2482,null,Z.toString(!0))},s.BrowserWindow.getFocusedWindow()??void 0)}));return(0,A.coalesce)(J)}async doExtractPathsFromCLI(B){const F=[],J={ignoreFileNotFound:!0,gotoLineMode:B.goto,remoteAuthority:B.remote||void 0,forceOpenWorkspaceAsFile:B.diff&&B._.length===2||B.merge&&B._.length===4},G=B["folder-uri"];if(G){const ae=await Promise.all(G.map(pe=>{const Se=this.cliArgToUri(pe);if(Se)return this.resolveOpenable({folderUri:Se},J)}));F.push(...(0,A.coalesce)(ae))}const $=B["file-uri"];if($){const ae=await Promise.all($.map(pe=>{const Se=this.cliArgToUri(pe);if(Se)return this.resolveOpenable((0,se.hasWorkspaceFileExtension)(pe)?{workspaceUri:Se}:{fileUri:Se},J)}));F.push(...(0,A.coalesce)(ae))}const Z=await Promise.all(B._.map(ae=>J.remoteAuthority?this.doResolveRemotePath(ae,J):this.doResolveFilePath(ae,J)));return F.push(...(0,A.coalesce)(Z)),F}cliArgToUri(B){try{const F=P.URI.parse(B);if(!F.scheme){this.logService.error(`Invalid URI input string, scheme missing: ${B}`);return}return F.path?F:F.with({path:"/"})}catch(F){this.logService.error(`Invalid URI input string: ${B}, ${F.message}`)}}async doGetPathsFromLastSession(){const B=this.getRestoreWindowsSetting();switch(B){case"none":return[];case"one":case"all":case"preserve":case"folders":{const F=[];B!=="one"&&F.push(...this.windowsStateHandler.state.openedWindows),this.windowsStateHandler.state.lastActiveWindow&&F.push(this.windowsStateHandler.state.lastActiveWindow);const J=await Promise.all(F.map(async G=>{if(G.workspace){const $=await this.resolveOpenable({workspaceUri:G.workspace.configPath},{remoteAuthority:G.remoteAuthority,rejectTransientWorkspaces:!0});if(oe($))return $}else if(G.folderUri){const $=await this.resolveOpenable({folderUri:G.folderUri},{remoteAuthority:G.remoteAuthority});if(te($))return $}else if(B!=="folders"&&G.backupPath)return{backupPath:G.backupPath,remoteAuthority:G.remoteAuthority}}));return(0,A.coalesce)(J)}}}getRestoreWindowsSetting(){let B;return this.lifecycleMainService.wasRestarted?B="all":(B=this.configurationService.getValue("window")?.restoreWindows||"all",["preserve","all","folders","one","none"].includes(B)||(B="all")),B}async resolveOpenable(B,F=Object.create(null)){const J=this.resourceFromOpenable(B);return J.scheme===v.Schemas.file?((0,_.isFileToOpen)(B)&&(F={...F,forceOpenWorkspaceAsFile:!0}),this.doResolveFilePath(J.fsPath,F)):this.doResolveRemoteOpenable(B,F)}doResolveRemoteOpenable(B,F){let J=this.resourceFromOpenable(B);const G=(0,C.getRemoteAuthority)(J)||F.remoteAuthority;if(J=(0,g.removeTrailingPathSeparator)((0,g.normalizePath)(J)),(0,_.isFileToOpen)(B)){if(F.gotoLineMode){const{path:$,line:Z,column:ae}=(0,m.parseLineAndColumnAware)(J.path);return{fileUri:J.with({path:$}),options:{selection:Z?{startLineNumber:Z,startColumn:ae||1}:void 0},remoteAuthority:G}}return{fileUri:J,remoteAuthority:G}}else if((0,_.isWorkspaceToOpen)(B))return{workspace:(0,ee.getWorkspaceIdentifier)(J),remoteAuthority:G};return{workspace:(0,ee.getSingleFolderWorkspaceIdentifier)(J),remoteAuthority:G}}resourceFromOpenable(B){return(0,_.isWorkspaceToOpen)(B)?B.workspaceUri:(0,_.isFolderToOpen)(B)?B.folderUri:B.fileUri}async doResolveFilePath(B,F,J){let G,$;F.gotoLineMode&&({path:B,line:G,column:$}=(0,m.parseLineAndColumnAware)(B)),B=(0,m.sanitizeFilePath)((0,f.normalize)(B),(0,b.cwd)());try{const Z=await i.promises.stat(B);if(Z.isFile()){if(!F.forceOpenWorkspaceAsFile){const ae=await this.workspacesManagementMainService.resolveLocalWorkspace(P.URI.file(B));if(ae)return ae.transient&&F.rejectTransientWorkspaces?void 0:{workspace:{id:ae.id,configPath:ae.configPath},type:l.FileType.File,exists:!0,remoteAuthority:ae.remoteAuthority,transient:ae.transient}}return{fileUri:P.URI.file(B),type:l.FileType.File,exists:!0,options:{selection:G?{startLineNumber:G,startColumn:$||1}:void 0}}}else{if(Z.isDirectory())return{workspace:(0,ee.getSingleFolderWorkspaceIdentifier)(P.URI.file(B),Z),type:l.FileType.Directory,exists:!0};if(!E.isWindows&&B==="/dev/null")return{fileUri:P.URI.file(B),type:l.FileType.File,exists:!0}}}catch(Z){if(Z.code==="ERR_UNC_HOST_NOT_ALLOWED"&&!J)return this.onUNCHostNotAllowed(B,F);const ae=P.URI.file(B);if(this.workspacesHistoryMainService.removeRecentlyOpened([ae]),F.ignoreFileNotFound)return{fileUri:ae,type:l.FileType.File,exists:!1}}}async onUNCHostNotAllowed(B,F){const J=P.URI.file(B),{response:G,checkboxChecked:$}=await this.dialogMainService.showMessageBox({type:"warning",buttons:[(0,r.localize)(2483,null),(0,r.localize)(2484,null),(0,r.localize)(2485,null)],message:(0,r.localize)(2486,null,J.authority),detail:(0,r.localize)(2487,null,(0,u.getPathLabel)(J,{os:E.OS,tildify:this.environmentMainService})),checkboxLabel:(0,r.localize)(2488,null,J.authority),cancelId:1});if(G===0){if((0,y.addUNCHostToAllowlist)(J.authority),$){const Z={channel:"vscode:configureAllowedUNCHost",args:J.authority};this.sendToFocused(Z.channel,Z.args),this.sendToOpeningWindow(Z.channel,Z.args)}return this.doResolveFilePath(B,F,!0)}if(G===2)return s.shell.openExternal("https://aka.ms/vscode-windows-unc"),this.onUNCHostNotAllowed(B,F)}doResolveRemotePath(B,F){const J=B.charCodeAt(0),G=F.remoteAuthority;let $,Z;F.gotoLineMode&&({path:B,line:$,column:Z}=(0,m.parseLineAndColumnAware)(B)),J!==S.CharCode.Slash&&((0,m.isWindowsDriveLetter)(J)&&B.charCodeAt(B.charCodeAt(1))===S.CharCode.Colon&&(B=(0,m.toSlashes)(B)),B=`/${B}`);const ae=P.URI.from({scheme:v.Schemas.vscodeRemote,authority:G,path:B});if(B.charCodeAt(B.length-1)!==S.CharCode.Slash){if((0,se.hasWorkspaceFileExtension)(B))return F.forceOpenWorkspaceAsFile?{fileUri:ae,options:{selection:$?{startLineNumber:$,startColumn:Z||1}:void 0},remoteAuthority:F.remoteAuthority}:{workspace:(0,ee.getWorkspaceIdentifier)(ae),remoteAuthority:G};if(F.gotoLineMode||f.posix.basename(B).indexOf(".")!==-1)return{fileUri:ae,options:{selection:$?{startLineNumber:$,startColumn:Z||1}:void 0},remoteAuthority:G}}return{workspace:(0,ee.getSingleFolderWorkspaceIdentifier)(ae),remoteAuthority:G}}shouldOpenNewWindow(B){const F=this.configurationService.getValue("window"),J=F?.openFoldersInNewWindow||"default",G=F?.openFilesInNewWindow||"off";let $=(B.preferNewWindow||B.forceNewWindow)&&!B.forceReuseWindow;!B.forceNewWindow&&!B.forceReuseWindow&&(J==="on"||J==="off")&&($=J==="on");let Z=!1;return B.forceNewWindow||B.forceReuseWindow?Z=!!B.forceNewWindow&&!B.forceReuseWindow:(E.isMacintosh?B.context===z.OpenContext.DOCK&&(Z=!0):B.context!==z.OpenContext.DIALOG&&B.context!==z.OpenContext.MENU&&!(B.userEnv&&B.userEnv.TERM_PROGRAM==="vscode")&&(Z=!0),!B.cli.extensionDevelopmentPath&&(G==="on"||G==="off")&&(Z=G==="on")),{openFolderInNewWindow:!!$,openFilesInNewWindow:Z}}async openExtensionDevelopmentHostWindow(B,F){const J=(0,Q.findWindowOnExtensionDevelopmentPath)(this.getWindows(),B);if(J)return this.lifecycleMainService.reload(J,F.cli),J.focus(),[J];let G=F.cli["folder-uri"]||[],$=F.cli["file-uri"]||[],Z=F.cli._;if(!Z.length&&!G.length&&!$.length&&!F.cli.extensionTestsPath){const Se=this.windowsStateHandler.state.lastPluginDevelopmentHostWindow,ye=Se?.workspace??Se?.folderUri;ye&&(P.URI.isUri(ye)?ye.scheme===v.Schemas.file?Z=[ye.fsPath]:G=[ye.toString()]:ye.configPath.scheme===v.Schemas.file?Z=[(0,g.originalFSPath)(ye.configPath)]:$=[ye.configPath.toString()])}let ae=F.remoteAuthority;for(const Se of B)if(Se.match(/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/)){const ye=P.URI.parse(Se),We=(0,C.getRemoteAuthority)(ye);We&&(ae?(0,g.isEqualAuthority)(We,ae)||this.logService.error("more than one extension development path authority"):ae=We)}Z=Z.filter(Se=>{const ye=P.URI.file(Se);return(0,Q.findWindowOnWorkspaceOrFolder)(this.getWindows(),ye)?!1:(0,g.isEqualAuthority)((0,C.getRemoteAuthority)(ye),ae)}),G=G.filter(Se=>{const ye=this.cliArgToUri(Se);return ye&&(0,Q.findWindowOnWorkspaceOrFolder)(this.getWindows(),ye)?!1:ye?(0,g.isEqualAuthority)((0,C.getRemoteAuthority)(ye),ae):!1}),$=$.filter(Se=>{const ye=this.cliArgToUri(Se);return ye&&(0,Q.findWindowOnWorkspaceOrFolder)(this.getWindows(),ye)?!1:ye?(0,g.isEqualAuthority)((0,C.getRemoteAuthority)(ye),ae):!1}),F.cli._=Z,F.cli["folder-uri"]=G,F.cli["file-uri"]=$;const pe={context:F.context,cli:F.cli,forceNewWindow:!0,forceEmpty:!Z.length&&!G.length&&!$.length,userEnv:F.userEnv,noRecentEntry:!0,waitMarkerFileURI:F.waitMarkerFileURI,remoteAuthority:ae,forceProfile:F.forceProfile,forceTempProfile:F.forceTempProfile};return this.open(pe)}async openInBrowserWindow(B){const F=this.configurationService.getValue("window"),J=this.getLastActiveWindow(),$=(F?.newWindowProfile?this.userDataProfilesMainService.profiles.find(pe=>pe.name===F.newWindowProfile):void 0)??J?.profile??this.userDataProfilesMainService.defaultProfile;let Z;!B.forceNewWindow&&!B.forceNewTabbedWindow&&(Z=B.windowToUse||J,Z&&Z.focus());const ae={...this.environmentMainService.args,...B.cli,machineId:this.machineId,sqmId:this.sqmId,devDeviceId:this.devDeviceId,windowId:-1,mainPid:process.pid,appRoot:this.environmentMainService.appRoot,execPath:process.execPath,codeCachePath:this.environmentMainService.codeCachePath,backupPath:B.emptyWindowBackupInfo?(0,f.join)(this.environmentMainService.backupHome,B.emptyWindowBackupInfo.backupFolder):void 0,profiles:{home:this.userDataProfilesMainService.profilesHome,all:this.userDataProfilesMainService.profiles,profile:$},homeDir:this.environmentMainService.userHome.with({scheme:v.Schemas.file}).fsPath,tmpDir:this.environmentMainService.tmpDir.with({scheme:v.Schemas.file}).fsPath,userDataDir:this.environmentMainService.userDataPath,remoteAuthority:B.remoteAuthority,workspace:B.workspace,userEnv:{...this.initialUserEnv,...B.userEnv},nls:{messages:(0,r.getNLSMessages)(),language:(0,r.getNLSLanguage)()},filesToOpenOrCreate:B.filesToOpen?.filesToOpenOrCreate,filesToDiff:B.filesToOpen?.filesToDiff,filesToMerge:B.filesToOpen?.filesToMerge,filesToWait:B.filesToOpen?.filesToWait,logLevel:this.loggerService.getLogLevel(),loggers:{window:[],global:this.loggerService.getRegisteredLoggers()},logsPath:this.environmentMainService.logsHome.with({scheme:v.Schemas.file}).fsPath,product:M.default,isInitialStartup:B.initialStartup,perfMarks:(0,h.getMarks)(),os:{release:(0,k.release)(),hostname:(0,k.hostname)(),arch:(0,k.arch)()},autoDetectHighContrast:F?.autoDetectHighContrast??!0,autoDetectColorScheme:F?.autoDetectColorScheme??!1,accessibilitySupport:s.app.accessibilitySupportEnabled,colorScheme:this.themeMainService.getColorScheme(),policiesData:this.policyService.serialize(),continueOn:this.environmentMainService.continueOn,cssModules:this.cssDevelopmentService.isEnabled?await this.cssDevelopmentService.getCssModules():void 0};if(Z){const pe=Z.config;!ae.extensionDevelopmentPath&&pe?.extensionDevelopmentPath&&(ae.extensionDevelopmentPath=pe.extensionDevelopmentPath,ae.extensionDevelopmentKind=pe.extensionDevelopmentKind,ae["enable-proposed-api"]=pe["enable-proposed-api"],ae.verbose=pe.verbose,ae["inspect-extensions"]=pe["inspect-extensions"],ae["inspect-brk-extensions"]=pe["inspect-brk-extensions"],ae.debugId=pe.debugId,ae.extensionEnvironment=pe.extensionEnvironment,ae["extensions-dir"]=pe["extensions-dir"],ae["disable-extensions"]=pe["disable-extensions"]),ae.loggers={global:ae.loggers.global,window:pe?.loggers.window??ae.loggers.window}}else{const pe=this.windowsStateHandler.getNewWindowState(ae);(0,h.mark)("code/willCreateCodeWindow");const Se=Z=this.instantiationService.createInstance(V.CodeWindow,{state:pe,extensionDevelopmentPath:ae.extensionDevelopmentPath,isExtensionTestHost:!!ae.extensionTestsPath});(0,h.mark)("code/didCreateCodeWindow"),B.forceNewTabbedWindow&&this.getLastActiveWindow()?.addTabbedWindow(Se),this.windows.set(Se.id,Se),this._onDidOpenWindow.fire(Se),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()-1,newCount:this.getWindowCount()});const ye=new p.DisposableStore;ye.add(Se.onDidSignalReady(()=>this._onDidSignalReadyWindow.fire(Se))),ye.add(c.Event.once(Se.onDidClose)(()=>this.onWindowClosed(Se,ye))),ye.add(c.Event.once(Se.onDidDestroy)(()=>this.onWindowDestroyed(Se))),ye.add(Se.onDidMaximize(()=>this._onDidMaximizeWindow.fire(Se))),ye.add(Se.onDidUnmaximize(()=>this._onDidUnmaximizeWindow.fire(Se))),ye.add(Se.onDidEnterFullScreen(()=>this._onDidChangeFullScreen.fire({window:Se,fullscreen:!0}))),ye.add(Se.onDidLeaveFullScreen(()=>this._onDidChangeFullScreen.fire({window:Se,fullscreen:!1}))),ye.add(Se.onDidTriggerSystemContextMenu(({x:He,y:Ce})=>this._onDidTriggerSystemContextMenu.fire({window:Se,x:He,y:Ce})));const We=(0,I.assertIsDefined)(Se.win?.webContents);We.removeAllListeners("devtools-reload-page"),ye.add(c.Event.fromNodeEventEmitter(We,"devtools-reload-page")(()=>this.lifecycleMainService.reload(Se))),this.lifecycleMainService.registerWindow(Se)}return ae.windowId=Z.id,Z.isReady?this.lifecycleMainService.unload(Z,N.UnloadReason.LOAD).then(async pe=>{pe||await this.doOpenInBrowserWindow(Z,ae,B,$)}):await this.doOpenInBrowserWindow(Z,ae,B,$),Z}async doOpenInBrowserWindow(B,F,J,G){if(F.extensionDevelopmentPath||((0,se.isWorkspaceIdentifier)(F.workspace)?F.backupPath=this.backupMainService.registerWorkspaceBackup({workspace:F.workspace,remoteAuthority:F.remoteAuthority}):(0,se.isSingleFolderWorkspaceIdentifier)(F.workspace)?F.backupPath=this.backupMainService.registerFolderBackup({folderUri:F.workspace.uri,remoteAuthority:F.remoteAuthority}):F.backupPath=this.backupMainService.registerEmptyWindowBackup({backupFolder:J.emptyWindowBackupInfo?.backupFolder??(0,ee.createEmptyWorkspaceIdentifier)().id,remoteAuthority:F.remoteAuthority})),this.userDataProfilesMainService.isEnabled()){const $=F.workspace??(0,se.toWorkspaceIdentifier)(F.backupPath,!1),Z=this.resolveProfileForBrowserWindow(J,$,G),ae=Z instanceof Promise?await Z:Z;F.profiles.profile=ae,F.extensionDevelopmentPath||await this.userDataProfilesMainService.setProfileForWorkspace($,ae)}B.load(F)}resolveProfileForBrowserWindow(B,F,J){return B.forceProfile?this.userDataProfilesMainService.profiles.find(G=>G.name===B.forceProfile)??this.userDataProfilesMainService.createNamedProfile(B.forceProfile):B.forceTempProfile?this.userDataProfilesMainService.createTransientProfile():this.userDataProfilesMainService.getProfileForWorkspace(F)??J}onWindowClosed(B,F){this.windows.delete(B.id),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()+1,newCount:this.getWindowCount()}),F.dispose()}onWindowDestroyed(B){this.windows.delete(B.id),this._onDidDestroyWindow.fire(B)}getFocusedWindow(){const B=s.BrowserWindow.getFocusedWindow();if(B)return this.getWindowById(B.id)}getLastActiveWindow(){return this.doGetLastActiveWindow(this.getWindows())}getLastActiveWindowForAuthority(B){return this.doGetLastActiveWindow(this.getWindows().filter(F=>(0,g.isEqualAuthority)(F.remoteAuthority,B)))}doGetLastActiveWindow(B){return(0,z.getLastFocused)(B)}sendToFocused(B,...F){(this.getFocusedWindow()||this.getLastActiveWindow())?.sendWhenReady(B,R.CancellationToken.None,...F)}sendToOpeningWindow(B,...F){this._register(c.Event.once(this.onDidSignalReadyWindow)(J=>{J.sendWhenReady(B,R.CancellationToken.None,...F)}))}sendToAll(B,F,J){for(const G of this.getWindows())J&&J.indexOf(G.id)>=0||G.sendWhenReady(B,R.CancellationToken.None,F)}getWindows(){return Array.from(this.windows.values())}getWindowCount(){return this.windows.size}getWindowById(B){return this.windows.get(B)}getWindowByWebContents(B){const F=s.BrowserWindow.fromWebContents(B);if(!F)return;const J=this.getWindowById(F.id);return J?.matches(B)?J:void 0}};e.WindowsMainService=O,e.WindowsMainService=O=Pe([re(4,w.ILogService),re(5,ie.ILoggerMainService),re(6,L.IStateService),re(7,W.IPolicyService),re(8,n.IEnvironmentMainService),re(9,q.IUserDataProfilesMainService),re(10,D.ILifecycleMainService),re(11,a.IBackupMainService),re(12,t.IConfigurationService),re(13,U.IWorkspacesHistoryMainService),re(14,K.IWorkspacesManagementMainService),re(15,d.IInstantiationService),re(16,o.IDialogMainService),re(17,l.IFileService),re(18,T.IProtocolMainService),re(19,x.IThemeMainService),re(20,H.IAuxiliaryWindowsMainService),re(21,ce.ICSSDevelopmentService)],O)}),define(le[282],ue([0,1,70,29,90,59]),function(j,e,i,s,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesMainService=void 0;let A=class{constructor(S,c,m,u){this.workspacesManagementMainService=S,this.windowsMainService=c,this.workspacesHistoryMainService=m,this.backupMainService=u,this.onDidChangeRecentlyOpened=this.workspacesHistoryMainService.onDidChangeRecentlyOpened}async enterWorkspace(S,c){const m=this.windowsMainService.getWindowById(S);if(m)return this.workspacesManagementMainService.enterWorkspace(m,this.windowsMainService.getWindows(),c)}createUntitledWorkspace(S,c,m){return this.workspacesManagementMainService.createUntitledWorkspace(c,m)}deleteUntitledWorkspace(S,c){return this.workspacesManagementMainService.deleteUntitledWorkspace(c)}getWorkspaceIdentifier(S,c){return this.workspacesManagementMainService.getWorkspaceIdentifier(c)}getRecentlyOpened(S){return this.workspacesHistoryMainService.getRecentlyOpened()}addRecentlyOpened(S,c){return this.workspacesHistoryMainService.addRecentlyOpened(c)}removeRecentlyOpened(S,c){return this.workspacesHistoryMainService.removeRecentlyOpened(c)}clearRecentlyOpened(S){return this.workspacesHistoryMainService.clearRecentlyOpened()}async getDirtyWorkspaces(){return this.backupMainService.getDirtyWorkspaces()}};e.WorkspacesMainService=A,e.WorkspacesMainService=A=Pe([re(0,k.IWorkspacesManagementMainService),re(1,s.IWindowsMainService),re(2,y.IWorkspacesHistoryMainService),re(3,i.IBackupMainService)],A)}),define(le[283],ue([0,1,13,109,35,27,17,55,15,4,287,49,2,11,10,3,12,7,33,164,45,165,122,138,9,70,257,16,264,99,139,53,100,191,20,69,103,179,267,181,182,183,14,195,102,84,6,101,190,273,274,258,265,19,5,280,65,28,75,268,104,34,247,89,131,24,224,225,57,51,237,262,275,263,276,135,239,240,241,244,271,47,29,281,246,30,105,90,282,59,40,204,58,217,50,88,136,249,266,254,8,227,248,199,72,270,243,21,76,269,235,210,67,85,278,79,86]),function(j,e,i,s,y,k,A,R,S,c,m,u,p,v,f,h,E,b,g,I,P,r,a,t,o,n,l,d,D,w,M,T,C,L,_,V,z,Q,fe,se,ee,U,K,N,x,W,q,ie,H,ce,oe,te,O,X,B,F,J,G,$,Z,ae,pe,Se,ye,We,He,Ce,me,Y,de,he,ve,Ee,Oe,Ae,Me,Ue,Ge,Je,ze,Xe,Qe,Ye,Ne,ne,ge,we,be,_e,xe,Ze,lt,st,at,tt,ut,ct,ht,gt,Lt,mt,pt,Tt,Ot,_t,vt,Wt,bt,ft,Ft,Nt,wt,Ut,It,xt,Pt,Dt){"use strict";var St;Object.defineProperty(e,"__esModule",{value:!0}),e.CodeApplication=void 0;let yt=class extends p.Disposable{static{St=this}static{this.SECURITY_PROTOCOL_HANDLING_CONFIRMATION_SETTING_KEY={[v.Schemas.file]:"security.promptForLocalFileProtocolHandling",[v.Schemas.vscodeRemote]:"security.promptForRemoteFileProtocolHandling"}}constructor(ke,Le,Te,Ie,De,qe,Ve,Ke,Fe,$e,Be,et){super(),this.mainProcessNodeIpcServer=ke,this.userEnv=Le,this.mainInstantiationService=Te,this.logService=Ie,this.loggerService=De,this.environmentMainService=qe,this.lifecycleMainService=Ve,this.configurationService=Ke,this.stateService=Fe,this.fileService=$e,this.productService=Be,this.userDataProfilesMainService=et,this.configureSession(),this.registerListeners()}configureSession(){const ke=Fe=>Fe?.startsWith(`${v.Schemas.vscodeWebview}://`),Le=new Set(["clipboard-read","clipboard-sanitized-write"]);i.session.defaultSession.setPermissionRequestHandler((Fe,$e,Be,et)=>ke(et.requestingUrl)?Be(Le.has($e)):Be(!1)),i.session.defaultSession.setPermissionCheckHandler((Fe,$e,Be,et)=>ke(et.requestingUrl)?Le.has($e):!1);const Te=new Set([v.Schemas.file,v.Schemas.vscodeFileResource,v.Schemas.vscodeRemoteResource,v.Schemas.vscodeManagedRemoteResource,"devtools"]),Ie=Fe=>{for(let $e=Fe;$e;$e=$e.parent)if($e.url.startsWith(`${v.Schemas.vscodeWebview}://`))return!0;return!1},De=Fe=>Fe.resourceType==="xhr"||Ie(Fe.frame),qe=Fe=>{const $e=Fe.frame;if(!$e||!this.windowsMainService)return!1;const Be=i.BrowserWindow.getAllWindows();for(const et of Be)if($e.processId===et.webContents.mainFrame.processId)return!0;return!1},Ve=(Fe,$e)=>{if(Fe.path!=="/index.html")return!0;const Be=$e.frame;if(!Be||!this.windowsMainService)return!1;for(const et of this.windowsMainService.getWindows())if(et.win&&Be.processId===et.win.webContents.mainFrame.processId)return!0;return!1};i.session.defaultSession.webRequest.onBeforeRequest((Fe,$e)=>{const Be=b.URI.parse(Fe.url);return Be.scheme===v.Schemas.vscodeWebview&&!Ve(Be,Fe)?(this.logService.error("Blocked vscode-webview request",Fe.url),$e({cancel:!0})):Be.scheme===v.Schemas.vscodeFileResource&&!qe(Fe)?(this.logService.error("Blocked vscode-file request",Fe.url),$e({cancel:!0})):Be.path.endsWith(".svg")&&!Te.has(Be.scheme)?$e({cancel:!De(Fe)}):$e({cancel:!1})}),i.session.defaultSession.webRequest.onHeadersReceived((Fe,$e)=>{const Be=Fe.responseHeaders,et=Be["content-type"]||Be["Content-Type"];if(et&&Array.isArray(et)){const it=b.URI.parse(Fe.url);if(it.path.endsWith(".svg")&&Te.has(it.scheme))return Be["Content-Type"]=["image/svg+xml"],$e({cancel:!1,responseHeaders:Be});if(!it.path.endsWith(v.Schemas.vscodeRemoteResource)&&et.some(ot=>ot.toLowerCase().includes("image/svg")))return $e({cancel:!De(Fe)})}return $e({cancel:!1})}),i.session.defaultSession.webRequest.onHeadersReceived((Fe,$e)=>{if(Fe.url.startsWith("https://vscode.download.prss.microsoft.com/")){const Be=Fe.responseHeaders??Object.create(null);if(Be["Access-Control-Allow-Origin"]===void 0)return Be["Access-Control-Allow-Origin"]=["*"],$e({cancel:!1,responseHeaders:Be})}return $e({cancel:!1})});const Ke=i.session.defaultSession;typeof Ke.setCodeCachePath=="function"&&this.environmentMainService.codeCachePath&&Ke.setCodeCachePath((0,f.join)(this.environmentMainService.codeCachePath,"chrome")),h.isWindows&&(this.configurationService.getValue("security.restrictUNCAccess")===!1?(0,s.disableUNCAccessRestrictions)():(0,s.addUNCHostToAllowlist)(this.configurationService.getValue("security.allowedUNCHosts")))}registerListeners(){(0,S.setUnexpectedErrorHandler)(Te=>this.onUnexpectedError(Te)),process.on("uncaughtException",Te=>{(0,S.isSigPipeError)(Te)||(0,S.onUnexpectedError)(Te)}),process.on("unhandledRejection",Te=>(0,S.onUnexpectedError)(Te)),c.Event.once(this.lifecycleMainService.onWillShutdown)(()=>this.dispose()),(0,I.registerContextMenuListener)(),i.app.on("accessibility-support-changed",(Te,Ie)=>{this.windowsMainService?.sendToAll("vscode:accessibilitySupportChanged",Ie)}),i.app.on("activate",async(Te,Ie)=>{this.logService.trace("app#activate"),Ie||await this.windowsMainService?.openEmptyWindow({context:Ye.OpenContext.DOCK})}),i.app.on("web-contents-created",(Te,Ie)=>{Ie?.opener?.url.startsWith(`${v.Schemas.vscodeFileResource}://${v.VSCODE_AUTHORITY}/`)&&(this.logService.trace('[aux window]  app.on("web-contents-created"): Registering auxiliary window'),this.auxiliaryWindowsMainService?.registerWindow(Ie)),Ie.on("will-navigate",De=>{this.logService.error("webContents#will-navigate: Prevented webcontent navigation"),De.preventDefault()}),Ie.setWindowOpenHandler(De=>De.url==="about:blank"?(this.logService.trace("[aux window] webContents#setWindowOpenHandler: Allowing auxiliary window to open on about:blank"),{action:"allow",overrideBrowserWindowOptions:this.auxiliaryWindowsMainService?.createWindow(De)}):(this.logService.trace(`webContents#setWindowOpenHandler: Prevented opening window with URL ${De.url}}`),this.nativeHostMainService?.openExternal(void 0,De.url),{action:"deny"}))});let ke=[],Le;i.app.on("open-file",(Te,Ie)=>{Ie=(0,Pt.normalizeNFC)(Ie),this.logService.trace("app#open-file: ",Ie),Te.preventDefault(),ke.push((0,ge.hasWorkspaceFileExtension)(Ie)?{workspaceUri:b.URI.file(Ie)}:{fileUri:b.URI.file(Ie)}),Le!==void 0&&(clearTimeout(Le),Le=void 0),Le=setTimeout(async()=>{await this.windowsMainService?.open({context:Ye.OpenContext.DOCK,cli:this.environmentMainService.args,urisToOpen:ke,gotoLineMode:!1,preferNewWindow:!0}),ke=[],Le=void 0},100)}),i.app.on("new-window-for-tab",async()=>{await this.windowsMainService?.openEmptyWindow({context:Ye.OpenContext.DESKTOP})}),y.validatedIpcMain.handle("vscode:fetchShellEnv",Te=>{const Ie=this.windowsMainService?.getWindowByWebContents(Te.sender);let De,qe;return Ie?.config?(De=Ie.config,qe={...process.env,...Ie.config.userEnv}):(De=this.environmentMainService.args,qe=process.env),this.resolveShellEnvironment(De,qe,!1)}),y.validatedIpcMain.on("vscode:toggleDevTools",Te=>Te.sender.toggleDevTools()),y.validatedIpcMain.on("vscode:openDevTools",Te=>Te.sender.openDevTools()),y.validatedIpcMain.on("vscode:reloadWindow",Te=>Te.sender.reload()),y.validatedIpcMain.handle("vscode:notifyZoomLevel",async(Te,Ie)=>{const De=this.windowsMainService?.getWindowByWebContents(Te.sender);De&&De.notifyZoomLevel(Ie)})}onUnexpectedError(ke){if(ke){const Le={message:`[uncaught exception in main]: ${ke.message}`,stack:ke.stack};this.windowsMainService?.sendToFocused("vscode:reportError",JSON.stringify(Le))}this.logService.error(`[uncaught exception in main]: ${ke}`),ke.stack&&this.logService.error(ke.stack)}async startup(){this.logService.debug("Starting VSCodium"),this.logService.debug(`from: ${this.environmentMainService.appRoot}`),this.logService.debug("args:",this.environmentMainService.args);const ke=this.productService.win32AppUserModelId;h.isWindows&&ke&&i.app.setAppUserModelId(ke);try{h.isMacintosh&&this.configurationService.getValue("window.nativeTabs")===!0&&!i.systemPreferences.getUserDefault("NSUseImprovedLayoutPass","boolean")&&i.systemPreferences.setUserDefault("NSUseImprovedLayoutPass","boolean",!0)}catch(Be){this.logService.error(Be)}const Le=new r.Server;c.Event.once(this.lifecycleMainService.onWillShutdown)(Be=>{Be.reason===X.ShutdownReason.KILL&&Le.dispose()}),this.logService.trace("Resolving machine identifier...");const[Te,Ie,De]=await Promise.all([(0,pt.resolveMachineId)(this.stateService,this.logService),(0,pt.resolveSqmId)(this.stateService,this.logService),(0,pt.resolvedevDeviceId)(this.stateService,this.logService)]);this.logService.trace(`Resolved machine identifier: ${Te}`);const{sharedProcessReady:qe,sharedProcessClient:Ve}=this.setupSharedProcess(Te,Ie,De),Ke=await this.initServices(Te,Ie,De,qe);Ke.invokeFunction(Be=>Be.get(t.IProxyAuthService)),this._register(Ke.createInstance(gt.UserDataProfilesHandler)),Ke.invokeFunction(Be=>this.initChannels(Be,Le,Ve));const Fe=await Ke.invokeFunction(Be=>this.setupProtocolUrlHandlers(Be,Le));this.setupManagedRemoteResourceUrlHandler(Le),this.lifecycleMainService.phase=X.LifecycleMainPhase.Ready,await Ke.invokeFunction(Be=>this.openFirstWindow(Be,Fe)),this.lifecycleMainService.phase=X.LifecycleMainPhase.AfterWindowOpen,this.afterWindowOpen(),this._register(new mt.RunOnceScheduler(()=>{this._register((0,mt.runWhenGlobalIdle)(()=>this.lifecycleMainService.phase=X.LifecycleMainPhase.Eventually,2500))},2500)).schedule()}async setupProtocolUrlHandlers(ke,Le){const Te=this.windowsMainService=ke.get(Ye.IWindowsMainService),Ie=ke.get(Me.IURLService),De=this.nativeHostMainService=ke.get(J.INativeHostMainService),qe=ke.get(T.IDialogMainService),Ve=this;Ie.registerHandler({async handleURL(it,ot){return Ve.handleProtocolUrl(Te,qe,Ie,it,ot)}});const Ke=this._register(new ne.ActiveWindowManager({onDidOpenMainWindow:De.onDidOpenMainWindow,onDidFocusMainWindow:De.onDidFocusMainWindow,getActiveWindowId:()=>De.getActiveWindowId(-1)})),Fe=new P.StaticRouter(it=>Ke.getActiveClientId().then(ot=>it===ot)),$e=new Ue.URLHandlerRouter(Fe,this.logService),Be=Le.getChannel("urlHandler",$e);Ie.registerHandler(new Ue.URLHandlerChannelClient(Be));const et=await this.resolveInitialProtocolUrls(Te,qe);return this._register(new Je.ElectronURLListener(et?.urls,Ie,Te,this.environmentMainService,this.productService,this.logService)),et}setupManagedRemoteResourceUrlHandler(ke){const Le=()=>({statusCode:404,data:"Not found"}),Te=new Ut.Lazy(()=>ke.getChannel(wt.NODE_REMOTE_RESOURCE_CHANNEL_NAME,new wt.NodeRemoteResourceRouter));i.protocol.registerBufferProtocol(v.Schemas.vscodeManagedRemoteResource,(Ie,De)=>{const qe=b.URI.parse(Ie.url);if(!qe.authority.startsWith("window:"))return De(Le());Te.value.call(wt.NODE_REMOTE_RESOURCE_IPC_METHOD_NAME,[qe]).then(Ve=>De({...Ve,data:Buffer.from(Ve.body,"base64")}),Ve=>{this.logService.warn("error dispatching remote resource call",Ve),De({statusCode:500,data:String(Ve)})})})}async resolveInitialProtocolUrls(ke,Le){const Te=this.environmentMainService.args["open-url"]?this.environmentMainService.args._urls||[]:[];Te.length>0&&this.logService.trace("app#resolveInitialProtocolUrls() protocol urls from command line:",Te);const Ie=global.getOpenUrls()||[];if(Ie.length>0&&this.logService.trace("app#resolveInitialProtocolUrls() protocol urls from macOS 'open-url' event:",Ie),Te.length+Ie.length===0)return;const De=[...Te,...Ie].map(Ke=>{try{return{uri:b.URI.parse(Ke),originalUrl:Ke}}catch{this.logService.trace("app#resolveInitialProtocolUrls() protocol url failed to parse:",Ke);return}}),qe=[],Ve=[];for(const Ke of De){if(!Ke)continue;const Fe=this.getWindowOpenableFromProtocolUrl(Ke.uri);if(Fe)if(await this.shouldBlockOpenable(Fe,ke,Le)){this.logService.trace("app#resolveInitialProtocolUrls() protocol url was blocked:",Ke.uri.toString(!0));continue}else this.logService.trace("app#resolveInitialProtocolUrls() protocol url will be handled as window to open:",Ke.uri.toString(!0),Fe),qe.push(Fe);else this.logService.trace("app#resolveInitialProtocolUrls() protocol url will be passed to active window for handling:",Ke.uri.toString(!0)),Ve.push(Ke)}return{urls:Ve,openables:qe}}async shouldBlockOpenable(ke,Le,Te){let Ie,De;if((0,Qe.isWorkspaceToOpen)(ke)?(Ie=ke.workspaceUri,De=(0,o.localize)(145,null,Ie.scheme===v.Schemas.file?(0,u.getPathLabel)(Ie,{os:h.OS,tildify:this.environmentMainService}):Ie.toString(!0),this.productService.nameShort)):(0,Qe.isFolderToOpen)(ke)?(Ie=ke.folderUri,De=(0,o.localize)(146,null,Ie.scheme===v.Schemas.file?(0,u.getPathLabel)(Ie,{os:h.OS,tildify:this.environmentMainService}):Ie.toString(!0),this.productService.nameShort)):(Ie=ke.fileUri,De=(0,o.localize)(147,null,Ie.scheme===v.Schemas.file?(0,u.getPathLabel)(Ie,{os:h.OS,tildify:this.environmentMainService}):Ie.toString(!0),this.productService.nameShort)),Ie.scheme!==v.Schemas.file&&Ie.scheme!==v.Schemas.vscodeRemote||this.configurationService.getValue(St.SECURITY_PROTOCOL_HANDLING_CONFIRMATION_SETTING_KEY[Ie.scheme])===!1)return!1;const{response:Ve,checkboxChecked:Ke}=await Te.showMessageBox({type:"warning",buttons:[(0,o.localize)(148,null),(0,o.localize)(149,null)],message:De,detail:(0,o.localize)(150,null),checkboxLabel:Ie.scheme===v.Schemas.file?(0,o.localize)(151,null):(0,o.localize)(152,null),cancelId:1});if(Ve!==0)return!0;if(Ke){const Fe={channel:"vscode:disablePromptForProtocolHandling",args:Ie.scheme===v.Schemas.file?"local":"remote"};Le.sendToFocused(Fe.channel,Fe.args),Le.sendToOpeningWindow(Fe.channel,Fe.args)}return!1}getWindowOpenableFromProtocolUrl(ke){if(ke.path){if(ke.authority===v.Schemas.file){const Le=b.URI.file(ke.fsPath);return(0,ge.hasWorkspaceFileExtension)(Le)?{workspaceUri:Le}:{fileUri:Le}}else if(ke.authority===v.Schemas.vscodeRemote){const Le=ke.path.indexOf(f.posix.sep,1);let Te,Ie;Le!==-1?(Te=ke.path.substring(1,Le),Ie=ke.path.substring(Le)):(Te=ke.path.substring(1),Ie="/");let De=ke.query;const qe=new URLSearchParams(ke.query);qe.get("windowId")==="_blank"&&(qe.delete("windowId"),De=qe.toString());const Ve=b.URI.from({scheme:v.Schemas.vscodeRemote,authority:Te,path:Ie,query:De,fragment:ke.fragment});return(0,ge.hasWorkspaceFileExtension)(Ie)?{workspaceUri:Ve}:/:[\d]+$/.test(Ie)?{fileUri:Ve}:{folderUri:Ve}}}}async handleProtocolUrl(ke,Le,Te,Ie,De){this.logService.trace("app#handleProtocolUrl():",Ie.toString(!0),De),Ie.scheme===this.productService.urlProtocol&&Ie.path==="workspace"&&(Ie=Ie.with({authority:"file",path:b.URI.parse(Ie.query).path,query:""}));let qe=!1;const Ve=new URLSearchParams(Ie.query);Ve.get("windowId")==="_blank"?(this.logService.trace("app#handleProtocolUrl() found 'windowId=_blank' as parameter, setting shouldOpenInNewWindow=true:",Ie.toString(!0)),Ve.delete("windowId"),Ie=Ie.with({query:Ve.toString()}),qe=!0):h.isMacintosh&&ke.getWindowCount()===0&&(this.logService.trace("app#handleProtocolUrl() running on macOS with no window open, setting shouldOpenInNewWindow=true:",Ie.toString(!0)),qe=!0);const Ke=Ve.get("continueOn");Ke!==null&&(this.logService.trace("app#handleProtocolUrl() found 'continueOn' as parameter:",Ie.toString(!0)),Ve.delete("continueOn"),Ie=Ie.with({query:Ve.toString()}),this.environmentMainService.continueOn=Ke??void 0);const Fe=this.getWindowOpenableFromProtocolUrl(Ie);return Fe?await this.shouldBlockOpenable(Fe,ke,Le)?(this.logService.trace("app#handleProtocolUrl() protocol url was blocked:",Ie.toString(!0)),!0):(this.logService.trace("app#handleProtocolUrl() opening protocol url as window:",Fe,Ie.toString(!0)),(0,bt.firstOrDefault)(await ke.open({context:Ye.OpenContext.LINK,cli:{...this.environmentMainService.args},urisToOpen:[Fe],forceNewWindow:qe,gotoLineMode:!0}))?.focus(),!0):qe?(this.logService.trace("app#handleProtocolUrl() opening empty window and passing in protocol url:",Ie.toString(!0)),await(0,bt.firstOrDefault)(await ke.open({context:Ye.OpenContext.LINK,cli:{...this.environmentMainService.args},forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,remoteAuthority:(0,$.getRemoteAuthority)(Ie)}))?.ready(),Te.open(Ie,De)):(this.logService.trace("app#handleProtocolUrl(): not handled",Ie.toString(!0),De),!1)}setupSharedProcess(ke,Le,Te){const Ie=this._register(this.mainInstantiationService.createInstance(Z.SharedProcess,ke,Le,Te));this._register(Ie.onDidCrash(()=>this.windowsMainService?.sendToFocused("vscode:reportSharedProcessCrash")));const De=(async()=>{this.logService.trace("Main->SharedProcess#connect");const Ve=await Ie.connect();return this.logService.trace("Main->SharedProcess#connect: connection established"),new a.Client(Ve,"main")})();return{sharedProcessReady:(async()=>(await Ie.whenReady(),De))(),sharedProcessClient:De}}async initServices(ke,Le,Te,Ie){const De=new ie.ServiceCollection;switch(process.platform){case"win32":De.set(de.IUpdateService,new W.SyncDescriptor(Ae.Win32UpdateService));break;case"linux":h.isLinuxSnap?De.set(de.IUpdateService,new W.SyncDescriptor(Oe.SnapUpdateService,[process.env.SNAP,process.env.SNAP_REVISION])):De.set(de.IUpdateService,new W.SyncDescriptor(Ee.LinuxUpdateService));break;case"darwin":De.set(de.IUpdateService,new W.SyncDescriptor(ve.DarwinUpdateService));break}De.set(Ye.IWindowsMainService,new W.SyncDescriptor(Ne.WindowsMainService,[ke,Le,Te,this.userEnv],!1)),De.set(It.IAuxiliaryWindowsMainService,new W.SyncDescriptor(xt.AuxiliaryWindowsMainService,void 0,!1));const qe=new T.DialogMainService(this.logService,this.productService);De.set(T.IDialogMainService,qe),De.set(O.ILaunchMainService,new W.SyncDescriptor(O.LaunchMainService,void 0,!1)),De.set(M.IDiagnosticsMainService,new W.SyncDescriptor(M.DiagnosticsMainService,void 0,!1)),De.set(w.IDiagnosticsService,P.ProxyChannel.toService((0,P.getDelayedChannel)(Ie.then(Be=>Be.getChannel("diagnostics"))))),De.set(H.IIssueMainService,new W.SyncDescriptor(ce.IssueMainService,[this.userEnv])),De.set(H.IProcessMainService,new W.SyncDescriptor(oe.ProcessMainService,[this.userEnv])),De.set(C.IEncryptionMainService,new W.SyncDescriptor(L.EncryptionMainService)),De.set(te.IKeyboardLayoutMainService,new W.SyncDescriptor(te.KeyboardLayoutMainService)),De.set(J.INativeHostMainService,new W.SyncDescriptor(J.NativeHostMainService,void 0,!1)),De.set(ze.IWebviewManagerService,new W.SyncDescriptor(Xe.WebviewMainService)),De.set(F.IMenubarMainService,new W.SyncDescriptor(F.MenubarMainService)),De.set(Q.IExtensionHostStarter,new W.SyncDescriptor(fe.ExtensionHostStarter)),De.set(ye.IStorageMainService,new W.SyncDescriptor(ye.StorageMainService)),De.set(ye.IApplicationStorageMainService,new W.SyncDescriptor(ye.ApplicationStorageMainService));const Ve=new Ft.ElectronPtyHostStarter({graceTime:ft.LocalReconnectConstants.GraceTime,shortGraceTime:ft.LocalReconnectConstants.ShortGraceTime,scrollback:this.configurationService.getValue(ft.TerminalSettingId.PersistentSessionScrollback)??100},this.configurationService,this.environmentMainService,this.lifecycleMainService,this.logService),Ke=new Nt.PtyHostService(Ve,this.configurationService,this.logService,this.loggerService);De.set(ft.ILocalPtyService,Ke),h.isWindows?De.set(se.IExternalTerminalMainService,new W.SyncDescriptor(ee.WindowsExternalTerminalService)):h.isMacintosh?De.set(se.IExternalTerminalMainService,new W.SyncDescriptor(ee.MacExternalTerminalService)):h.isLinux&&De.set(se.IExternalTerminalMainService,new W.SyncDescriptor(ee.LinuxExternalTerminalService));const Fe=new l.BackupMainService(this.environmentMainService,this.configurationService,this.logService,this.stateService);De.set(n.IBackupMainService,Fe);const $e=new xe.WorkspacesManagementMainService(this.environmentMainService,this.logService,this.userDataProfilesMainService,Fe,qe);if(De.set(xe.IWorkspacesManagementMainService,$e),De.set(we.IWorkspacesService,new W.SyncDescriptor(_e.WorkspacesMainService,void 0,!1)),De.set(be.IWorkspacesHistoryMainService,new W.SyncDescriptor(be.WorkspacesHistoryMainService,void 0,!1)),De.set(Me.IURLService,new W.SyncDescriptor(Ge.NativeURLService,void 0,!1)),(0,Y.supportsTelemetry)(this.productService,this.environmentMainService)){const Be=(0,Y.isInternalTelemetry)(this.productService,this.configurationService),et=(0,P.getDelayedChannel)(Ie.then(Et=>Et.getChannel("telemetryAppender"))),it=new Ce.TelemetryAppenderClient(et),ot=(0,We.resolveCommonProperties)((0,k.release)(),(0,k.hostname)(),process.arch,this.productService.commit,this.productService.version,ke,Le,Te,Be),nt=(0,Y.getPiiPathsFromEnvironment)(this.environmentMainService),dt={appenders:[it],commonProperties:ot,piiPaths:nt,sendErrorTelemetry:!0};De.set(He.ITelemetryService,new W.SyncDescriptor(me.TelemetryService,[dt],!1))}else De.set(He.ITelemetryService,Y.NullTelemetryService);return De.set(ut.IExtensionsProfileScannerService,new W.SyncDescriptor(Tt.ExtensionsProfileScannerService,void 0,!0)),De.set(ct.IExtensionsScannerService,new W.SyncDescriptor(ht.ExtensionsScannerService,void 0,!0)),De.set(vt.IUtilityProcessWorkerMainService,new W.SyncDescriptor(vt.UtilityProcessWorkerMainService,void 0,!0)),De.set(t.IProxyAuthService,new W.SyncDescriptor(t.ProxyAuthService)),De.set(Dt.ICSSDevelopmentService,new W.SyncDescriptor(Dt.CSSDevelopmentService,void 0,!0)),await mt.Promises.settled([Fe.initialize(),$e.initialize()]),this.mainInstantiationService.createChild(De)}initChannels(ke,Le,Te){const Ie=this._register(new p.DisposableStore),De=P.ProxyChannel.fromService(ke.get(O.ILaunchMainService),Ie,{disableMarshalling:!0});this.mainProcessNodeIpcServer.registerChannel("launch",De);const qe=P.ProxyChannel.fromService(ke.get(M.IDiagnosticsMainService),Ie,{disableMarshalling:!0});this.mainProcessNodeIpcServer.registerChannel("diagnostics",qe);const Ve=Ie.add(new lt.PolicyChannel(ke.get(Ze.IPolicyService)));Le.registerChannel("policy",Ve),Te.then(rt=>rt.registerChannel("policy",Ve));const Ke=this.fileService.getProvider(v.Schemas.file);(0,E.assertType)(Ke instanceof x.DiskFileSystemProvider);const Fe=Ie.add(new N.DiskFileSystemProviderChannel(Ke,this.logService,this.environmentMainService));Le.registerChannel(U.LOCAL_FILE_SYSTEM_CHANNEL_NAME,Fe),Te.then(rt=>rt.registerChannel(U.LOCAL_FILE_SYSTEM_CHANNEL_NAME,Fe));const $e=P.ProxyChannel.fromService(ke.get(st.IUserDataProfilesMainService),Ie);Le.registerChannel("userDataProfiles",$e),Te.then(rt=>rt.registerChannel("userDataProfiles",$e));const Be=new at.RequestChannel(ke.get(tt.IRequestService));Te.then(rt=>rt.registerChannel("request",Be));const et=new he.UpdateChannel(ke.get(de.IUpdateService));Le.registerChannel("update",et);const it=P.ProxyChannel.fromService(ke.get(H.IIssueMainService),Ie);Le.registerChannel("issue",it);const ot=P.ProxyChannel.fromService(ke.get(H.IProcessMainService),Ie);Le.registerChannel("process",ot);const nt=P.ProxyChannel.fromService(ke.get(C.IEncryptionMainService),Ie);Le.registerChannel("encryption",nt);const dt=P.ProxyChannel.fromService(ke.get(ae.ISignService),Ie);Le.registerChannel("sign",dt);const Et=P.ProxyChannel.fromService(ke.get(te.IKeyboardLayoutMainService),Ie);Le.registerChannel("keyboardLayout",Et),this.nativeHostMainService=ke.get(J.INativeHostMainService);const Rt=P.ProxyChannel.fromService(this.nativeHostMainService,Ie);Le.registerChannel("nativeHost",Rt),Te.then(rt=>rt.registerChannel("nativeHost",Rt));const Bt=P.ProxyChannel.fromService(ke.get(we.IWorkspacesService),Ie);Le.registerChannel("workspaces",Bt);const zt=P.ProxyChannel.fromService(ke.get(F.IMenubarMainService),Ie);Le.registerChannel("menubar",zt);const qt=P.ProxyChannel.fromService(ke.get(Me.IURLService),Ie);Le.registerChannel("url",qt);const $t=P.ProxyChannel.fromService(ke.get(ze.IWebviewManagerService),Ie);Le.registerChannel("webview",$t);const Mt=Ie.add(new Se.StorageDatabaseChannel(this.logService,ke.get(ye.IStorageMainService)));Le.registerChannel("storage",Mt),Te.then(rt=>rt.registerChannel("storage",Mt));const Ht=Ie.add(new Lt.ProfileStorageChangesListenerChannel(ke.get(ye.IStorageMainService),ke.get(st.IUserDataProfilesMainService),this.logService));Te.then(rt=>rt.registerChannel("profileStorageListener",Ht));const Vt=P.ProxyChannel.fromService(ke.get(ft.ILocalPtyService),Ie);Le.registerChannel(ft.TerminalIpcChannels.LocalPty,Vt);const jt=P.ProxyChannel.fromService(ke.get(se.IExternalTerminalMainService),Ie);Le.registerChannel("externalTerminal",jt);const kt=new Ot.LoggerChannel(ke.get(_t.ILoggerMainService));Le.registerChannel("logger",kt),Te.then(rt=>rt.registerChannel("logger",kt));const Gt=new D.ElectronExtensionHostDebugBroadcastChannel(ke.get(Ye.IWindowsMainService));Le.registerChannel("extensionhostdebugservice",Gt);const Kt=P.ProxyChannel.fromService(ke.get(Q.IExtensionHostStarter),Ie);Le.registerChannel(Q.ipcExtensionHostStarterChannelName,Kt);const Qt=P.ProxyChannel.fromService(ke.get(vt.IUtilityProcessWorkerMainService),Ie);Le.registerChannel(Wt.ipcUtilityProcessWorkerChannelName,Qt)}async openFirstWindow(ke,Le){const Te=this.windowsMainService=ke.get(Ye.IWindowsMainService);this.auxiliaryWindowsMainService=ke.get(It.IAuxiliaryWindowsMainService);const Ie=(0,V.isLaunchedFromCli)(process.env)?Ye.OpenContext.CLI:Ye.OpenContext.DESKTOP,De=this.environmentMainService.args;if(Le){if(Le.openables.length>0)return Te.open({context:Ie,cli:De,urisToOpen:Le.openables,gotoLineMode:!0,initialStartup:!0});if(Le.urls.length>0)for(const nt of Le.urls){const dt=new URLSearchParams(nt.uri.query);if(dt.get("windowId")==="_blank")return dt.delete("windowId"),nt.originalUrl=nt.uri.toString(!0),nt.uri=nt.uri.with({query:dt.toString()}),Te.open({context:Ie,cli:De,forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,initialStartup:!0})}}const qe=global.macOpenFiles,Ve=De._.length,Ke=!!De["folder-uri"],Fe=!!De["file-uri"],$e=De["skip-add-to-recently-opened"]===!0,Be=De.wait&&De.waitMarkerFilePath?b.URI.file(De.waitMarkerFilePath):void 0,et=De.remote||void 0,it=De.profile,ot=De["profile-temp"];if(!Ve&&!Ke&&!Fe){if(De["new-window"]||it||ot)return Te.open({context:Ie,cli:De,forceNewWindow:!0,forceEmpty:!0,noRecentEntry:$e,waitMarkerFileURI:Be,initialStartup:!0,remoteAuthority:et,forceProfile:it,forceTempProfile:ot});if(qe.length)return Te.open({context:Ye.OpenContext.DOCK,cli:De,urisToOpen:qe.map(nt=>(nt=(0,Pt.normalizeNFC)(nt),(0,ge.hasWorkspaceFileExtension)(nt)?{workspaceUri:b.URI.file(nt)}:{fileUri:b.URI.file(nt)})),noRecentEntry:$e,waitMarkerFileURI:Be,initialStartup:!0})}return Te.open({context:Ie,cli:De,forceNewWindow:De["new-window"],diffMode:De.diff,mergeMode:De.merge,noRecentEntry:$e,waitMarkerFileURI:Be,gotoLineMode:De.goto,initialStartup:!0,remoteAuthority:et,forceProfile:it,forceTempProfile:ot})}afterWindowOpen(){this.installMutex(),i.protocol.registerHttpProtocol(v.Schemas.vscodeRemoteResource,(ke,Le)=>{Le({url:ke.url.replace(/^vscode-remote-resource:/,"http:"),method:ke.method})}),this.resolveShellEnvironment(this.environmentMainService.args,process.env,!0),this.updateCrashReporterEnablement(),h.isMacintosh&&i.app.runningUnderARM64Translation&&this.windowsMainService?.sendToFocused("vscode:showTranslatedBuildWarning")}async installMutex(){const ke=this.productService.win32MutexName;if(h.isWindows&&ke)try{const Le=await new Promise((Ie,De)=>{j(["@vscode/windows-mutex"],Ie,De)}).then(Re),Te=new Le.Mutex(ke);c.Event.once(this.lifecycleMainService.onWillShutdown)(()=>Te.release())}catch(Le){this.logService.error(Le)}}async resolveShellEnvironment(ke,Le,Te){try{return await(0,z.getResolvedShellEnv)(this.configurationService,this.logService,ke,Le)}catch(Ie){const De=(0,R.toErrorMessage)(Ie);Te?this.windowsMainService?.sendToFocused("vscode:showResolveShellEnvError",De):this.logService.error(De)}return{}}async updateCrashReporterEnablement(){try{const Le=(await this.fileService.readFile(this.environmentMainService.argvResource)).value.toString(),Te=(0,m.parse)(Le),De=(0,Y.getTelemetryLevel)(this.configurationService)>=He.TelemetryLevel.CRASH;if(Te["enable-crash-reporter"]===void 0){const qe=["","	// Allows to disable crash reporting.","	// Should restart the app if the value is changed.",`	"enable-crash-reporter": ${De},`,"","	// Unique id used for correlating crash reports sent from this instance.","	// Do not edit this value.",`	"crash-reporter-id": "${(0,g.generateUuid)()}"`,"}"],Ve=Le.substring(0,Le.length-2).concat(`,
`,qe.join(`
`));await this.fileService.writeFile(this.environmentMainService.argvResource,A.VSBuffer.fromString(Ve))}else{const qe=Le.replace(/"enable-crash-reporter": .*,/,`"enable-crash-reporter": ${De},`);qe!==Le&&await this.fileService.writeFile(this.environmentMainService.argvResource,A.VSBuffer.fromString(qe))}}catch(ke){this.logService.error(ke),this.windowsMainService?.sendToFocused("vscode:showArgvParseWarning")}}};e.CodeApplication=yt,e.CodeApplication=yt=St=Pe([re(2,q.IInstantiationService),re(3,B.ILogService),re(4,B.ILoggerService),re(5,_.IEnvironmentMainService),re(6,X.ILifecycleMainService),re(7,d.IConfigurationService),re(8,pe.IStateService),re(9,K.IFileService),re(10,G.IProductService),re(11,st.IUserDataProfilesMainService)],yt)});var je=this&&this.__importDefault||function(j){return j&&j.__esModule?j:{default:j}};define(le[288],ue([0,1,13,26,7,21,8,55,15,32,4,49,11,10,71,3,38,25,23,45,107,283,9,16,209,223,20,69,174,14,193,102,84,189,101,19,196,5,73,28,74,250,134,261,50,260,104,222,34,57,77,58,40,205,203,2,41,238,72,198,126,130,242,109,236]),function(j,e,i,s,y,k,A,R,S,c,m,u,p,v,f,h,E,b,g,I,P,r,a,t,o,n,l,d,D,w,M,T,C,L,_,V,z,Q,fe,se,ee,U,K,N,x,W,q,ie,H,ce,oe,te,O,X,B,F,J,G,$,Z,ae,pe,Se,ye){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),fe=je(fe);class We{main(){try{this.startup()}catch(me){console.error(me.message),i.app.exit(1)}}async startup(){(0,S.setUnexpectedErrorHandler)(Me=>console.error(Me));const[me,Y,de,he,ve,Ee,Oe,Ae]=this.createServices();try{try{await this.initServices(de,Ae,he,ve,Oe)}catch(Me){throw this.handleStartupDataDirError(de,Oe,Me),Me}await me.invokeFunction(async Me=>{const Ue=Me.get(Q.ILogService),Ge=Me.get(V.ILifecycleMainService),Je=Me.get(w.IFileService),ze=Me.get(Q.ILoggerService),Xe=await this.claimInstance(Ue,de,Ge,me,Oe,!0);return g.Promises.writeFile(de.mainLockfile,String(process.pid)).catch(Qe=>{Ue.warn(`app#startup(): Error writing main lockfile: ${Qe.stack}`)}),Ee.logger=ze.createLogger("main",{name:(0,a.localize)(153,null)}),m.Event.once(Ge.onWillShutdown)(Qe=>{Je.dispose(),he.dispose(),Qe.join("instanceLockfile",s.promises.unlink(de.mainLockfile).catch(()=>{}))}),me.createInstance(r.CodeApplication,Xe,Y).startup()})}catch(Me){me.invokeFunction(this.quit,Me)}}createServices(){const me=new _.ServiceCollection,Y=new F.DisposableStore;process.once("exit",()=>Y.dispose());const de={_serviceBrand:void 0,...fe.default};me.set(se.IProductService,de);const he=new l.EnvironmentMainService(this.resolveArgs(),de),ve=this.patchEnvironment(he);me.set(l.IEnvironmentMainService,he);const Ee=new $.LoggerMainService((0,Q.getLogLevel)(he),he.logsHome);me.set($.ILoggerMainService,Ee);const Oe=new z.BufferLogger(Ee.getLogLevel()),Ae=Y.add(new Z.LogService(Oe,[new Q.ConsoleMainLogger(Ee.getLogLevel())]));me.set(Q.ILogService,Ae);const Me=new M.FileService(Ae);me.set(w.IFileService,Me);const Ue=new T.DiskFileSystemProvider(Ae);Me.registerProvider(p.Schemas.file,Ue);const Ge=new G.UriIdentityService(Me);me.set(J.IUriIdentityService,Ge);const Je=new pe.StateService(pe.SaveStrategy.DELAYED,he,Ae,Me);me.set(H.IStateReadService,Je),me.set(H.IStateService,Je);const ze=new te.UserDataProfilesMainService(Je,Ge,he,Me,Ae);me.set(te.IUserDataProfilesMainService,ze),Me.registerProvider(p.Schemas.vscodeUserData,new Se.FileUserDataProvider(p.Schemas.file,Ue,p.Schemas.vscodeUserData,ze,Ge,Ae));const Xe=h.isWindows&&de.win32RegValueName?Y.add(new X.NativePolicyService(Ae,de.win32RegValueName)):he.policyFile?Y.add(new B.FilePolicyService(he.policyFile,Me,Ae)):new O.NullPolicyService;me.set(O.IPolicyService,Xe);const Qe=new o.ConfigurationService(ze.defaultProfile.settingsResource,Me,Xe,Ae);return me.set(t.IConfigurationService,Qe),me.set(V.ILifecycleMainService,new C.SyncDescriptor(V.LifecycleMainService,void 0,!1)),me.set(x.IRequestService,new C.SyncDescriptor(W.RequestMainService,void 0,!0)),me.set(oe.IThemeMainService,new C.SyncDescriptor(oe.ThemeMainService)),me.set(q.ISignService,new C.SyncDescriptor(ie.SignService,void 0,!1)),me.set(K.ITunnelService,new C.SyncDescriptor(N.TunnelService)),me.set(ee.IProtocolMainService,new U.ProtocolMainService(he,ze,Ae)),[new L.InstantiationService(me,!0),ve,he,Qe,Je,Oe,de,ze]}patchEnvironment(me){const Y={VSCODE_IPC_HOOK:me.mainIPCHandle};return["VSCODE_NLS_CONFIG","VSCODE_PORTABLE"].forEach(de=>{const he=process.env[de];typeof he=="string"&&(Y[de]=he)}),Object.assign(process.env,Y),Y}async initServices(me,Y,de,he,ve){await A.Promises.settled([Promise.all([this.allowWindowsUNCPath(me.extensionsPath),me.codeCachePath,me.logsHome.with({scheme:p.Schemas.file}).fsPath,Y.defaultProfile.globalStorageHome.with({scheme:p.Schemas.file}).fsPath,me.workspaceStorageHome.with({scheme:p.Schemas.file}).fsPath,me.localHistoryHome.with({scheme:p.Schemas.file}).fsPath,me.backupHome].map(Ee=>Ee?s.promises.mkdir(Ee,{recursive:!0}):void 0)),he.init(),de.initialize()]),Y.init()}allowWindowsUNCPath(me){if(h.isWindows){const Y=(0,ye.getUNCHost)(me);Y&&(0,ye.addUNCHostToAllowlist)(Y)}return me}async claimInstance(me,Y,de,he,ve,Ee){let Oe;try{(0,f.mark)("code/willStartMainServer"),Oe=await(0,P.serve)(Y.mainIPCHandle),(0,f.mark)("code/didStartMainServer"),m.Event.once(de.onWillShutdown)(()=>Oe.dispose())}catch(Ae){if(Ae.code!=="EADDRINUSE")throw this.handleStartupDataDirError(Y,ve,Ae),Ae;let Me;try{Me=await(0,P.connect)(Y.mainIPCHandle,"main")}catch(ze){if(!Ee||h.isWindows||ze.code!=="ECONNREFUSED")throw ze.code==="EPERM"&&this.showStartupWarningDialog((0,a.localize)(154,null,ve.nameShort),(0,a.localize)(155,null),ve),ze;try{(0,s.unlinkSync)(Y.mainIPCHandle)}catch(Xe){throw me.warn("Could not delete obsolete instance handle",Xe),Xe}return this.claimInstance(me,Y,de,he,ve,!1)}if(Y.extensionTestsLocationURI&&!Y.debugExtensionHost.break){const ze=`Running extension tests from the command line is currently only supported if no other instance of ${ve.nameShort} is running.`;throw me.error(ze),Me.dispose(),new Error(ze)}let Ue;!Y.args.wait&&!Y.args.status&&(Ue=setTimeout(()=>{this.showStartupWarningDialog((0,a.localize)(156,null,ve.nameShort),(0,a.localize)(157,null),ve)},1e4));const Ge=I.ProxyChannel.toService(Me.getChannel("launch"),{disableMarshalling:!0}),Je=I.ProxyChannel.toService(Me.getChannel("diagnostics"),{disableMarshalling:!0});if(Y.args.status)return he.invokeFunction(async()=>{const ze=new n.DiagnosticsService(ce.NullTelemetryService,ve),Xe=await Je.getMainDiagnostics(),Qe=await Je.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0}),Ye=await ze.getDiagnostics(Xe,Qe);throw console.log(Ye),new S.ExpectedError});throw h.isWindows&&await this.windowsAllowSetForegroundWindow(Ge,me),me.trace("Sending env to running instance..."),await Ge.start(Y.args,process.env),Me.dispose(),Ue&&clearTimeout(Ue),new S.ExpectedError("Sent env to running instance. Terminating...")}if(Y.args.status)throw console.log((0,a.localize)(158,null,ve.nameShort)),new S.ExpectedError("Terminating...");return process.env.VSCODE_PID=String(process.pid),Oe}handleStartupDataDirError(me,Y,de){if(de.code==="EACCES"||de.code==="EPERM"){const he=(0,k.coalesce)([me.userDataPath,me.extensionsPath,P.XDG_RUNTIME_DIR]).map(ve=>(0,u.getPathLabel)(y.URI.file(ve),{os:h.OS,tildify:me}));this.showStartupWarningDialog((0,a.localize)(159,null),(0,a.localize)(160,null,(0,R.toErrorMessage)(de),he.join(`
`)),Y)}}showStartupWarningDialog(me,Y,de){i.dialog.showMessageBoxSync((0,ae.massageMessageBoxOptions)({type:"warning",buttons:[(0,a.localize)(161,null)],message:me,detail:Y},de).options)}async windowsAllowSetForegroundWindow(me,Y){if(h.isWindows){const de=await me.getMainProcessId();Y.trace("Sending some foreground love to the running instance:",de);try{(await new Promise((he,ve)=>{j(["windows-foreground-love"],he,ve)}).then(Re)).allowSetForegroundWindow(de)}catch(he){Y.error(he)}}}quit(me,Y){const de=me.get(Q.ILogService),he=me.get(V.ILifecycleMainService);let ve=0;Y&&(Y.isExpected?Y.message&&de.trace(Y.message):(ve=1,Y.stack?de.error(Y.stack):de.error(`Startup error: ${Y.toString()}`))),he.kill(ve)}resolveArgs(){const me=this.validatePaths((0,d.parseMainProcessArgv)(process.argv));if(me.wait&&!me.waitMarkerFilePath){const Y=(0,D.createWaitMarkerFileSync)(me.verbose);Y&&((0,d.addArg)(process.argv,"--waitMarkerFilePath",Y),me.waitMarkerFilePath=Y)}return me}validatePaths(me){if(me["open-url"]&&(me._urls=me._,me._=[]),!me.remote){const Y=this.doValidatePaths(me._,me.goto);me._=Y}return me}doValidatePaths(me,Y){const de=(0,E.cwd)(),he=me.map(Oe=>{let Ae=String(Oe),Me;Y&&(Me=(0,c.parseLineAndColumnAware)(Ae),Ae=Me.path),Ae&&(Ae=this.preparePath(de,Ae));const Ue=(0,c.sanitizeFilePath)(Ae,de),Ge=(0,v.basename)(Ue);return Ge&&!(0,c.isValidBasename)(Ge)?null:Y&&Me?(Me.path=Ue,this.toPath(Me)):Ue}),ve=h.isWindows||h.isMacintosh,Ee=(0,k.distinct)(he,Oe=>Oe&&ve?Oe.toLowerCase():Oe||"");return(0,k.coalesce)(Ee)}preparePath(me,Y){return h.isWindows&&(Y=(0,b.rtrim)(Y,'"')),Y=(0,b.trim)((0,b.trim)(Y," "),"	"),h.isWindows&&(Y=(0,v.resolve)(me,Y),Y=(0,b.rtrim)(Y,".")),Y}toPath(me){const Y=[me.path];return typeof me.line=="number"&&Y.push(String(me.line)),typeof me.column=="number"&&Y.push(String(me.column)),Y.join(":")}}new We().main()})}).call(this);

//# sourceMappingURL=https://main.vscode-cdn.net/sourcemaps/532bdf24071d0a26ceea0844dcdf5ee8cfabd562/core/vs/code/electron-main/main.js.map
