/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var _e=["exports","require","vs/base/common/lifecycle","vs/base/common/event","vs/base/browser/dom","vs/base/common/platform","vs/base/common/errors","vs/css!vs/code/electron-sandbox/processExplorer/processExplorerMain","vs/base/common/keyCodes","vs/base/common/arrays","vs/base/common/types","vs/base/common/strings","vs/nls","vs/base/common/async","vs/base/browser/ui/hover/hoverDelegateFactory","vs/base/browser/keyboardEvent","vs/base/common/uri","vs/base/common/charCode","vs/base/browser/browser","vs/base/common/scrollable","vs/base/common/codicons","vs/base/common/themables","vs/base/browser/mouseEvent","vs/base/browser/ui/widget","vs/base/browser/window","vs/base/common/lazy","vs/base/common/observableInternal/debugName","vs/base/common/observableInternal/base","vs/base/browser/event","vs/base/common/path","vs/base/common/equals","vs/base/common/observableInternal/logging","vs/base/browser/touch","vs/base/browser/ui/hover/hoverDelegate2","vs/base/browser/ui/tree/tree","vs/base/common/decorators","vs/base/common/iterator","vs/base/common/numbers","vs/base/common/cancellation","vs/base/parts/sandbox/electron-sandbox/globals","vs/base/common/network","vs/base/browser/ui/list/list","vs/base/common/assert","vs/base/common/map","vs/base/common/observableInternal/autorun","vs/base/common/observableInternal/derived","vs/base/common/range","vs/base/common/buffer","vs/base/common/codiconsUtil","vs/base/common/filters","vs/base/common/actions","vs/base/common/resources","vs/base/browser/ui/aria/aria","vs/base/browser/ui/scrollbar/scrollbarArrow","vs/base/browser/ui/list/listWidget","vs/platform/instantiation/common/instantiation","vs/base/browser/fastDomNode","vs/base/browser/ui/scrollbar/scrollbarState","vs/base/common/collections","vs/base/common/functional","vs/base/common/linkedList","vs/base/common/marshallingIds","vs/base/common/observable","vs/base/common/symbols","vs/base/common/objects","vs/base/common/uint","vs/base/common/hash","vs/base/common/iconLabels","vs/css!vs/base/browser/ui/actionbar/actionbar","vs/nls.messages","vs/base/browser/canIUse","vs/base/common/marshalling","vs/base/browser/dnd","vs/base/browser/formattedTextRenderer","vs/base/browser/globalPointerMoveMonitor","vs/base/browser/ui/contextview/contextview","vs/base/browser/ui/tree/indexTreeModel","vs/base/browser/ui/scrollbar/abstractScrollbar","vs/base/browser/ui/scrollbar/scrollableElement","vs/base/browser/ui/list/listView","vs/base/browser/ui/actionbar/actionViewItems","vs/base/browser/ui/actionbar/actionbar","vs/base/browser/ui/inputbox/inputBox","vs/base/browser/ui/toggle/toggle","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/base/browser/iframe","vs/base/browser/ui/list/splice","vs/base/common/arraysFind","vs/base/common/color","vs/base/common/diff/diffChange","vs/base/common/idGenerator","vs/base/common/jsonSchema","vs/base/common/marked/marked","vs/base/common/naturalLanguage/korean","vs/base/common/navigator","vs/base/common/history","vs/base/common/observableInternal/lazyObservableValue","vs/base/common/observableInternal/api","vs/base/browser/ui/list/rangeMap","vs/base/common/stopwatch","vs/base/common/cache","vs/base/common/observableInternal/promise","vs/base/common/observableInternal/utils","vs/base/common/stream","vs/base/common/codiconsLibrary","vs/base/common/diff/diff","vs/base/common/ternarySearchTree","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/base/parts/contextmenu/electron-sandbox/contextmenu","vs/css!vs/base/browser/ui/aria/aria","vs/css!vs/base/browser/ui/codicons/codicon/codicon","vs/css!vs/base/browser/ui/codicons/codicon/codicon-modifiers","vs/base/browser/ui/codicons/codiconStyles","vs/css!vs/base/browser/ui/contextview/contextview","vs/css!vs/base/browser/ui/findinput/findInput","vs/css!vs/base/browser/ui/inputbox/inputBox","vs/css!vs/base/browser/ui/list/list","vs/css!vs/base/browser/ui/scrollbar/media/scrollbars","vs/css!vs/base/browser/ui/selectBox/selectBox","vs/css!vs/base/browser/ui/selectBox/selectBoxCustom","vs/css!vs/base/browser/ui/toggle/toggle","vs/css!vs/base/browser/ui/tree/media/tree","vs/css!vs/code/electron-sandbox/processExplorer/media/processExplorer","vs/base/common/keybindings","vs/base/common/process","vs/base/common/extpath","vs/base/common/mime","vs/base/browser/dompurify/dompurify","vs/base/browser/ui/iconLabel/iconLabels","vs/base/browser/ui/list/rowCache","vs/base/browser/ui/scrollbar/scrollbarVisibilityController","vs/base/browser/ui/selectBox/selectBoxNative","vs/base/browser/ui/tree/objectTreeModel","vs/base/browser/ui/scrollbar/horizontalScrollbar","vs/base/browser/ui/scrollbar/verticalScrollbar","vs/base/common/htmlContent","vs/base/browser/markdownRenderer","vs/base/browser/ui/selectBox/selectBoxCustom","vs/base/browser/ui/selectBox/selectBox","vs/base/browser/ui/findinput/findInputToggles","vs/base/browser/ui/findinput/findInput","vs/base/browser/ui/tree/abstractTree","vs/base/browser/ui/tree/dataTree","vs/base/parts/ipc/electron-sandbox/ipc.electron","vs/platform/diagnostics/common/diagnostics","vs/platform/files/common/files","vs/platform/ipc/common/mainProcessService","vs/platform/ipc/electron-sandbox/mainProcessService","vs/platform/native/common/nativeHostService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/theme/common/iconRegistry","vs/platform/theme/browser/iconsStyleSheet","vs/platform/window/common/window","vs/platform/window/electron-sandbox/window","vs/code/electron-sandbox/processExplorer/processExplorerMain"],Se=function(ue){for(var t=[],i=0,n=ue.length;i<n;i++)t[i]=_e[ue[i]];return t};/*! @license DOMPurify 3.0.5 | (c) Cure53 and other contributors | Released under the Apache license 2.0 and Mozilla Public License 2.0 | github.com/cure53/DOMPurify/blob/3.0.5/LICENSE */const{entries:zt,setPrototypeOf:Ut,isFrozen:ui,getPrototypeOf:ci,getOwnPropertyDescriptor:hi}=Object;let{freeze:gt,seal:vt,create:di}=Object,{apply:Pt,construct:Ct}=typeof Reflect<"u"&&Reflect;Pt||(Pt=function(t,i,n){return t.apply(i,n)}),gt||(gt=function(t){return t}),vt||(vt=function(t){return t}),Ct||(Ct=function(t,i){return new t(...i)});const fi=pt(Array.prototype.forEach),Vt=pt(Array.prototype.pop),Tt=pt(Array.prototype.push),Nt=pt(String.prototype.toLowerCase),Ft=pt(String.prototype.toString),gi=pt(String.prototype.match),wt=pt(String.prototype.replace),mi=pt(String.prototype.indexOf),pi=pt(String.prototype.trim),mt=pt(RegExp.prototype.test),At=bi(TypeError);function pt(ue){return function(t){for(var i=arguments.length,n=new Array(i>1?i-1:0),O=1;O<i;O++)n[O-1]=arguments[O];return Pt(ue,t,n)}}function bi(ue){return function(){for(var t=arguments.length,i=new Array(t),n=0;n<t;n++)i[n]=arguments[n];return Ct(ue,i)}}function tt(ue,t,i){var n;i=(n=i)!==null&&n!==void 0?n:Nt,Ut&&Ut(ue,null);let O=t.length;for(;O--;){let I=t[O];if(typeof I=="string"){const N=i(I);N!==I&&(ui(t)||(t[O]=N),I=N)}ue[I]=!0}return ue}function Et(ue){const t=di(null);for(const[i,n]of zt(ue))t[i]=n;return t}function Rt(ue,t){for(;ue!==null;){const n=hi(ue,t);if(n){if(n.get)return pt(n.get);if(typeof n.value=="function")return pt(n.value)}ue=ci(ue)}function i(n){return console.warn("fallback value for",n),null}return i}const Kt=gt(["a","abbr","acronym","address","area","article","aside","audio","b","bdi","bdo","big","blink","blockquote","body","br","button","canvas","caption","center","cite","code","col","colgroup","content","data","datalist","dd","decorator","del","details","dfn","dialog","dir","div","dl","dt","element","em","fieldset","figcaption","figure","font","footer","form","h1","h2","h3","h4","h5","h6","head","header","hgroup","hr","html","i","img","input","ins","kbd","label","legend","li","main","map","mark","marquee","menu","menuitem","meter","nav","nobr","ol","optgroup","option","output","p","picture","pre","progress","q","rp","rt","ruby","s","samp","section","select","shadow","small","source","spacer","span","strike","strong","style","sub","summary","sup","table","tbody","td","template","textarea","tfoot","th","thead","time","tr","track","tt","u","ul","var","video","wbr"]),Bt=gt(["svg","a","altglyph","altglyphdef","altglyphitem","animatecolor","animatemotion","animatetransform","circle","clippath","defs","desc","ellipse","filter","font","g","glyph","glyphref","hkern","image","line","lineargradient","marker","mask","metadata","mpath","path","pattern","polygon","polyline","radialgradient","rect","stop","style","switch","symbol","text","textpath","title","tref","tspan","view","vkern"]),xt=gt(["feBlend","feColorMatrix","feComponentTransfer","feComposite","feConvolveMatrix","feDiffuseLighting","feDisplacementMap","feDistantLight","feDropShadow","feFlood","feFuncA","feFuncB","feFuncG","feFuncR","feGaussianBlur","feImage","feMerge","feMergeNode","feMorphology","feOffset","fePointLight","feSpecularLighting","feSpotLight","feTile","feTurbulence"]),vi=gt(["animate","color-profile","cursor","discard","font-face","font-face-format","font-face-name","font-face-src","font-face-uri","foreignobject","hatch","hatchpath","mesh","meshgradient","meshpatch","meshrow","missing-glyph","script","set","solidcolor","unknown","use"]),Wt=gt(["math","menclose","merror","mfenced","mfrac","mglyph","mi","mlabeledtr","mmultiscripts","mn","mo","mover","mpadded","mphantom","mroot","mrow","ms","mspace","msqrt","mstyle","msub","msup","msubsup","mtable","mtd","mtext","mtr","munder","munderover","mprescripts"]),wi=gt(["maction","maligngroup","malignmark","mlongdiv","mscarries","mscarry","msgroup","mstack","msline","msrow","semantics","annotation","annotation-xml","mprescripts","none"]),$t=gt(["#text"]),qt=gt(["accept","action","align","alt","autocapitalize","autocomplete","autopictureinpicture","autoplay","background","bgcolor","border","capture","cellpadding","cellspacing","checked","cite","class","clear","color","cols","colspan","controls","controlslist","coords","crossorigin","datetime","decoding","default","dir","disabled","disablepictureinpicture","disableremoteplayback","download","draggable","enctype","enterkeyhint","face","for","headers","height","hidden","high","href","hreflang","id","inputmode","integrity","ismap","kind","label","lang","list","loading","loop","low","max","maxlength","media","method","min","minlength","multiple","muted","name","nonce","noshade","novalidate","nowrap","open","optimum","pattern","placeholder","playsinline","poster","preload","pubdate","radiogroup","readonly","rel","required","rev","reversed","role","rows","rowspan","spellcheck","scope","selected","shape","size","sizes","span","srclang","start","src","srcset","step","style","summary","tabindex","title","translate","type","usemap","valign","value","width","xmlns","slot"]),Ht=gt(["accent-height","accumulate","additive","alignment-baseline","ascent","attributename","attributetype","azimuth","basefrequency","baseline-shift","begin","bias","by","class","clip","clippathunits","clip-path","clip-rule","color","color-interpolation","color-interpolation-filters","color-profile","color-rendering","cx","cy","d","dx","dy","diffuseconstant","direction","display","divisor","dur","edgemode","elevation","end","fill","fill-opacity","fill-rule","filter","filterunits","flood-color","flood-opacity","font-family","font-size","font-size-adjust","font-stretch","font-style","font-variant","font-weight","fx","fy","g1","g2","glyph-name","glyphref","gradientunits","gradienttransform","height","href","id","image-rendering","in","in2","k","k1","k2","k3","k4","kerning","keypoints","keysplines","keytimes","lang","lengthadjust","letter-spacing","kernelmatrix","kernelunitlength","lighting-color","local","marker-end","marker-mid","marker-start","markerheight","markerunits","markerwidth","maskcontentunits","maskunits","max","mask","media","method","mode","min","name","numoctaves","offset","operator","opacity","order","orient","orientation","origin","overflow","paint-order","path","pathlength","patterncontentunits","patterntransform","patternunits","points","preservealpha","preserveaspectratio","primitiveunits","r","rx","ry","radius","refx","refy","repeatcount","repeatdur","restart","result","rotate","scale","seed","shape-rendering","specularconstant","specularexponent","spreadmethod","startoffset","stddeviation","stitchtiles","stop-color","stop-opacity","stroke-dasharray","stroke-dashoffset","stroke-linecap","stroke-linejoin","stroke-miterlimit","stroke-opacity","stroke","stroke-width","style","surfacescale","systemlanguage","tabindex","targetx","targety","transform","transform-origin","text-anchor","text-decoration","text-rendering","textlength","type","u1","u2","unicode","values","viewbox","visibility","version","vert-adv-y","vert-origin-x","vert-origin-y","width","word-spacing","wrap","writing-mode","xchannelselector","ychannelselector","x","x1","x2","xmlns","y","y1","y2","z","zoomandpan"]),jt=gt(["accent","accentunder","align","bevelled","close","columnsalign","columnlines","columnspan","denomalign","depth","dir","display","displaystyle","encoding","fence","frame","height","href","id","largeop","length","linethickness","lspace","lquote","mathbackground","mathcolor","mathsize","mathvariant","maxsize","minsize","movablelimits","notation","numalign","open","rowalign","rowlines","rowspacing","rowspan","rspace","rquote","scriptlevel","scriptminsize","scriptsizemultiplier","selection","separator","separators","stretchy","subscriptshift","supscriptshift","symmetric","voffset","width","xmlns"]),Ot=gt(["xlink:href","xml:id","xlink:title","xml:space","xmlns:xlink"]),yi=vt(/\{\{[\w\W]*|[\w\W]*\}\}/gm),Ei=vt(/<%[\w\W]*|[\w\W]*%>/gm),_i=vt(/\${[\w\W]*}/gm),Si=vt(/^data-[\-\w.\u00B7-\uFFFF]/),Di=vt(/^aria-[\-\w]+$/),Gt=vt(/^(?:(?:(?:f|ht)tps?|mailto|tel|callto|sms|cid|xmpp):|[^a-z]|[a-z+.\-]+(?:[^a-z+.\-:]|$))/i),Ti=vt(/^(?:\w+script|data):/i),Ai=vt(/[\u0000-\u0020\u00A0\u1680\u180E\u2000-\u2029\u205F\u3000]/g),Yt=vt(/^html$/i);var Xt=Object.freeze({__proto__:null,MUSTACHE_EXPR:yi,ERB_EXPR:Ei,TMPLIT_EXPR:_i,DATA_ATTR:Si,ARIA_ATTR:Di,IS_ALLOWED_URI:Gt,IS_SCRIPT_OR_DATA:Ti,ATTR_WHITESPACE:Ai,DOCTYPE_NAME:Yt});const Li=()=>typeof window>"u"?null:window,Ii=function(t,i){if(typeof t!="object"||typeof t.createPolicy!="function")return null;let n=null;const O="data-tt-policy-suffix";i&&i.hasAttribute(O)&&(n=i.getAttribute(O));const I="dompurify"+(n?"#"+n:"");try{return t.createPolicy(I,{createHTML(N){return N},createScriptURL(N){return N}})}catch{return console.warn("TrustedTypes policy "+I+" could not be created."),null}};function Zt(){let ue=arguments.length>0&&arguments[0]!==void 0?arguments[0]:Li();const t=Ve=>Zt(Ve);if(t.version="3.0.5",t.removed=[],!ue||!ue.document||ue.document.nodeType!==9)return t.isSupported=!1,t;const i=ue.document,n=i.currentScript;let{document:O}=ue;const{DocumentFragment:I,HTMLTemplateElement:N,Node:b,Element:w,NodeFilter:u,NamedNodeMap:m=ue.NamedNodeMap||ue.MozNamedAttrMap,HTMLFormElement:v,DOMParser:g,trustedTypes:d}=ue,e=w.prototype,s=Rt(e,"cloneNode"),r=Rt(e,"nextSibling"),l=Rt(e,"childNodes"),o=Rt(e,"parentNode");if(typeof N=="function"){const Ve=O.createElement("template");Ve.content&&Ve.content.ownerDocument&&(O=Ve.content.ownerDocument)}let p,A="";const{implementation:L,createNodeIterator:c,createDocumentFragment:a,getElementsByTagName:f}=O,{importNode:_}=i;let H={};t.isSupported=typeof zt=="function"&&typeof o=="function"&&L&&L.createHTMLDocument!==void 0;const{MUSTACHE_EXPR:B,ERB_EXPR:F,TMPLIT_EXPR:E,DATA_ATTR:k,ARIA_ATTR:W,IS_SCRIPT_OR_DATA:R,ATTR_WHITESPACE:C}=Xt;let{IS_ALLOWED_URI:$}=Xt,ee=null;const Y=tt({},[...Kt,...Bt,...xt,...Wt,...$t]);let Z=null;const ce=tt({},[...qt,...Ht,...jt,...Ot]);let he=Object.seal(Object.create(null,{tagNameCheck:{writable:!0,configurable:!1,enumerable:!0,value:null},attributeNameCheck:{writable:!0,configurable:!1,enumerable:!0,value:null},allowCustomizedBuiltInElements:{writable:!0,configurable:!1,enumerable:!0,value:!1}})),ye=null,Re=null,Pe=!0,re=!0,ie=!1,fe=!0,ve=!1,Ne=!1,ne=!1,Ee=!1,Le=!1,Ce=!1,Fe=!1,ze=!0,Xe=!1;const oe="user-content-";let x=!0,h=!1,S={},P=null;const G=tt({},["annotation-xml","audio","colgroup","desc","foreignobject","head","iframe","math","mi","mn","mo","ms","mtext","noembed","noframes","noscript","plaintext","script","style","svg","template","thead","title","video","xmp"]);let J=null;const te=tt({},["audio","video","img","source","image","track"]);let y=null;const D=tt({},["alt","class","for","id","label","name","pattern","placeholder","role","summary","title","value","style","xmlns"]),z="http://www.w3.org/1998/Math/MathML",V="http://www.w3.org/2000/svg",q="http://www.w3.org/1999/xhtml";let se=q,ae=!1,ge=null;const we=tt({},[z,V,q],Ft);let De;const Te=["application/xhtml+xml","text/html"],Oe="text/html";let Ae,ke=null;const Ge=O.createElement("form"),it=function(me){return me instanceof RegExp||me instanceof Function},rt=function(me){if(!(ke&&ke===me)){if((!me||typeof me!="object")&&(me={}),me=Et(me),De=Te.indexOf(me.PARSER_MEDIA_TYPE)===-1?De=Oe:De=me.PARSER_MEDIA_TYPE,Ae=De==="application/xhtml+xml"?Ft:Nt,ee="ALLOWED_TAGS"in me?tt({},me.ALLOWED_TAGS,Ae):Y,Z="ALLOWED_ATTR"in me?tt({},me.ALLOWED_ATTR,Ae):ce,ge="ALLOWED_NAMESPACES"in me?tt({},me.ALLOWED_NAMESPACES,Ft):we,y="ADD_URI_SAFE_ATTR"in me?tt(Et(D),me.ADD_URI_SAFE_ATTR,Ae):D,J="ADD_DATA_URI_TAGS"in me?tt(Et(te),me.ADD_DATA_URI_TAGS,Ae):te,P="FORBID_CONTENTS"in me?tt({},me.FORBID_CONTENTS,Ae):G,ye="FORBID_TAGS"in me?tt({},me.FORBID_TAGS,Ae):{},Re="FORBID_ATTR"in me?tt({},me.FORBID_ATTR,Ae):{},S="USE_PROFILES"in me?me.USE_PROFILES:!1,Pe=me.ALLOW_ARIA_ATTR!==!1,re=me.ALLOW_DATA_ATTR!==!1,ie=me.ALLOW_UNKNOWN_PROTOCOLS||!1,fe=me.ALLOW_SELF_CLOSE_IN_ATTR!==!1,ve=me.SAFE_FOR_TEMPLATES||!1,Ne=me.WHOLE_DOCUMENT||!1,Le=me.RETURN_DOM||!1,Ce=me.RETURN_DOM_FRAGMENT||!1,Fe=me.RETURN_TRUSTED_TYPE||!1,Ee=me.FORCE_BODY||!1,ze=me.SANITIZE_DOM!==!1,Xe=me.SANITIZE_NAMED_PROPS||!1,x=me.KEEP_CONTENT!==!1,h=me.IN_PLACE||!1,$=me.ALLOWED_URI_REGEXP||Gt,se=me.NAMESPACE||q,he=me.CUSTOM_ELEMENT_HANDLING||{},me.CUSTOM_ELEMENT_HANDLING&&it(me.CUSTOM_ELEMENT_HANDLING.tagNameCheck)&&(he.tagNameCheck=me.CUSTOM_ELEMENT_HANDLING.tagNameCheck),me.CUSTOM_ELEMENT_HANDLING&&it(me.CUSTOM_ELEMENT_HANDLING.attributeNameCheck)&&(he.attributeNameCheck=me.CUSTOM_ELEMENT_HANDLING.attributeNameCheck),me.CUSTOM_ELEMENT_HANDLING&&typeof me.CUSTOM_ELEMENT_HANDLING.allowCustomizedBuiltInElements=="boolean"&&(he.allowCustomizedBuiltInElements=me.CUSTOM_ELEMENT_HANDLING.allowCustomizedBuiltInElements),ve&&(re=!1),Ce&&(Le=!0),S&&(ee=tt({},[...$t]),Z=[],S.html===!0&&(tt(ee,Kt),tt(Z,qt)),S.svg===!0&&(tt(ee,Bt),tt(Z,Ht),tt(Z,Ot)),S.svgFilters===!0&&(tt(ee,xt),tt(Z,Ht),tt(Z,Ot)),S.mathMl===!0&&(tt(ee,Wt),tt(Z,jt),tt(Z,Ot))),me.ADD_TAGS&&(ee===Y&&(ee=Et(ee)),tt(ee,me.ADD_TAGS,Ae)),me.ADD_ATTR&&(Z===ce&&(Z=Et(Z)),tt(Z,me.ADD_ATTR,Ae)),me.ADD_URI_SAFE_ATTR&&tt(y,me.ADD_URI_SAFE_ATTR,Ae),me.FORBID_CONTENTS&&(P===G&&(P=Et(P)),tt(P,me.FORBID_CONTENTS,Ae)),x&&(ee["#text"]=!0),Ne&&tt(ee,["html","head","body"]),ee.table&&(tt(ee,["tbody"]),delete ye.tbody),me.TRUSTED_TYPES_POLICY){if(typeof me.TRUSTED_TYPES_POLICY.createHTML!="function")throw At('TRUSTED_TYPES_POLICY configuration option must provide a "createHTML" hook.');if(typeof me.TRUSTED_TYPES_POLICY.createScriptURL!="function")throw At('TRUSTED_TYPES_POLICY configuration option must provide a "createScriptURL" hook.');p=me.TRUSTED_TYPES_POLICY,A=p.createHTML("")}else p===void 0&&(p=Ii(d,n)),p!==null&&typeof A=="string"&&(A=p.createHTML(""));gt&&gt(me),ke=me}},ft=tt({},["mi","mo","mn","ms","mtext"]),ht=tt({},["foreignobject","desc","title","annotation-xml"]),He=tt({},["title","style","font","a","script"]),j=tt({},Bt);tt(j,xt),tt(j,vi);const T=tt({},Wt);tt(T,wi);const M=function(me){let Be=o(me);(!Be||!Be.tagName)&&(Be={namespaceURI:se,tagName:"template"});const Ue=Nt(me.tagName),st=Nt(Be.tagName);return ge[me.namespaceURI]?me.namespaceURI===V?Be.namespaceURI===q?Ue==="svg":Be.namespaceURI===z?Ue==="svg"&&(st==="annotation-xml"||ft[st]):!!j[Ue]:me.namespaceURI===z?Be.namespaceURI===q?Ue==="math":Be.namespaceURI===V?Ue==="math"&&ht[st]:!!T[Ue]:me.namespaceURI===q?Be.namespaceURI===V&&!ht[st]||Be.namespaceURI===z&&!ft[st]?!1:!T[Ue]&&(He[Ue]||!j[Ue]):!!(De==="application/xhtml+xml"&&ge[me.namespaceURI]):!1},K=function(me){Tt(t.removed,{element:me});try{me.parentNode.removeChild(me)}catch{me.remove()}},Q=function(me,Be){try{Tt(t.removed,{attribute:Be.getAttributeNode(me),from:Be})}catch{Tt(t.removed,{attribute:null,from:Be})}if(Be.removeAttribute(me),me==="is"&&!Z[me])if(Le||Ce)try{K(Be)}catch{}else try{Be.setAttribute(me,"")}catch{}},de=function(me){let Be,Ue;if(Ee)me="<remove></remove>"+me;else{const dt=gi(me,/^[\r\n\t ]+/);Ue=dt&&dt[0]}De==="application/xhtml+xml"&&se===q&&(me='<html xmlns="http://www.w3.org/1999/xhtml"><head></head><body>'+me+"</body></html>");const st=p?p.createHTML(me):me;if(se===q)try{Be=new g().parseFromString(st,De)}catch{}if(!Be||!Be.documentElement){Be=L.createDocument(se,"template",null);try{Be.documentElement.innerHTML=ae?A:st}catch{}}const at=Be.body||Be.documentElement;return me&&Ue&&at.insertBefore(O.createTextNode(Ue),at.childNodes[0]||null),se===q?f.call(Be,Ne?"html":"body")[0]:Ne?Be.documentElement:at},pe=function(me){return c.call(me.ownerDocument||me,me,u.SHOW_ELEMENT|u.SHOW_COMMENT|u.SHOW_TEXT,null,!1)},Me=function(me){return me instanceof v&&(typeof me.nodeName!="string"||typeof me.textContent!="string"||typeof me.removeChild!="function"||!(me.attributes instanceof m)||typeof me.removeAttribute!="function"||typeof me.setAttribute!="function"||typeof me.namespaceURI!="string"||typeof me.insertBefore!="function"||typeof me.hasChildNodes!="function")},xe=function(me){return typeof b=="object"?me instanceof b:me&&typeof me=="object"&&typeof me.nodeType=="number"&&typeof me.nodeName=="string"},Ke=function(me,Be,Ue){H[me]&&fi(H[me],st=>{st.call(t,Be,Ue,ke)})},Ye=function(me){let Be;if(Ke("beforeSanitizeElements",me,null),Me(me))return K(me),!0;const Ue=Ae(me.nodeName);if(Ke("uponSanitizeElement",me,{tagName:Ue,allowedTags:ee}),me.hasChildNodes()&&!xe(me.firstElementChild)&&(!xe(me.content)||!xe(me.content.firstElementChild))&&mt(/<[/\w]/g,me.innerHTML)&&mt(/<[/\w]/g,me.textContent))return K(me),!0;if(!ee[Ue]||ye[Ue]){if(!ye[Ue]&&nt(Ue)&&(he.tagNameCheck instanceof RegExp&&mt(he.tagNameCheck,Ue)||he.tagNameCheck instanceof Function&&he.tagNameCheck(Ue)))return!1;if(x&&!P[Ue]){const st=o(me)||me.parentNode,at=l(me)||me.childNodes;if(at&&st){const dt=at.length;for(let ot=dt-1;ot>=0;--ot)st.insertBefore(s(at[ot],!0),r(me))}}return K(me),!0}return me instanceof w&&!M(me)||(Ue==="noscript"||Ue==="noembed"||Ue==="noframes")&&mt(/<\/no(script|embed|frames)/i,me.innerHTML)?(K(me),!0):(ve&&me.nodeType===3&&(Be=me.textContent,Be=wt(Be,B," "),Be=wt(Be,F," "),Be=wt(Be,E," "),me.textContent!==Be&&(Tt(t.removed,{element:me.cloneNode()}),me.textContent=Be)),Ke("afterSanitizeElements",me,null),!1)},Qe=function(me,Be,Ue){if(ze&&(Be==="id"||Be==="name")&&(Ue in O||Ue in Ge))return!1;if(!(re&&!Re[Be]&&mt(k,Be))){if(!(Pe&&mt(W,Be))){if(!Z[Be]||Re[Be]){if(!(nt(me)&&(he.tagNameCheck instanceof RegExp&&mt(he.tagNameCheck,me)||he.tagNameCheck instanceof Function&&he.tagNameCheck(me))&&(he.attributeNameCheck instanceof RegExp&&mt(he.attributeNameCheck,Be)||he.attributeNameCheck instanceof Function&&he.attributeNameCheck(Be))||Be==="is"&&he.allowCustomizedBuiltInElements&&(he.tagNameCheck instanceof RegExp&&mt(he.tagNameCheck,Ue)||he.tagNameCheck instanceof Function&&he.tagNameCheck(Ue))))return!1}else if(!y[Be]){if(!mt($,wt(Ue,C,""))){if(!((Be==="src"||Be==="xlink:href"||Be==="href")&&me!=="script"&&mi(Ue,"data:")===0&&J[me])){if(!(ie&&!mt(R,wt(Ue,C,"")))){if(Ue)return!1}}}}}}return!0},nt=function(me){return me.indexOf("-")>0},et=function(me){let Be,Ue,st,at;Ke("beforeSanitizeAttributes",me,null);const{attributes:dt}=me;if(!dt)return;const ot={attrName:"",attrValue:"",keepAttr:!0,allowedAttributes:Z};for(at=dt.length;at--;){Be=dt[at];const{name:bt,namespaceURI:_t}=Be;if(Ue=bt==="value"?Be.value:pi(Be.value),st=Ae(bt),ot.attrName=st,ot.attrValue=Ue,ot.keepAttr=!0,ot.forceKeepAttr=void 0,Ke("uponSanitizeAttribute",me,ot),Ue=ot.attrValue,ot.forceKeepAttr||(Q(bt,me),!ot.keepAttr))continue;if(!fe&&mt(/\/>/i,Ue)){Q(bt,me);continue}ve&&(Ue=wt(Ue,B," "),Ue=wt(Ue,F," "),Ue=wt(Ue,E," "));const kt=Ae(me.nodeName);if(Qe(kt,st,Ue)){if(Xe&&(st==="id"||st==="name")&&(Q(bt,me),Ue=oe+Ue),p&&typeof d=="object"&&typeof d.getAttributeType=="function"&&!_t)switch(d.getAttributeType(kt,st)){case"TrustedHTML":{Ue=p.createHTML(Ue);break}case"TrustedScriptURL":{Ue=p.createScriptURL(Ue);break}}try{_t?me.setAttributeNS(_t,bt,Ue):me.setAttribute(bt,Ue),Vt(t.removed)}catch{}}}Ke("afterSanitizeAttributes",me,null)},ut=function Ve(me){let Be;const Ue=pe(me);for(Ke("beforeSanitizeShadowDOM",me,null);Be=Ue.nextNode();)Ke("uponSanitizeShadowNode",Be,null),!Ye(Be)&&(Be.content instanceof I&&Ve(Be.content),et(Be));Ke("afterSanitizeShadowDOM",me,null)};return t.sanitize=function(Ve){let me=arguments.length>1&&arguments[1]!==void 0?arguments[1]:{},Be,Ue,st,at;if(ae=!Ve,ae&&(Ve="<!-->"),typeof Ve!="string"&&!xe(Ve))if(typeof Ve.toString=="function"){if(Ve=Ve.toString(),typeof Ve!="string")throw At("dirty is not a string, aborting")}else throw At("toString is not a function");if(!t.isSupported)return Ve;if(ne||rt(me),t.removed=[],typeof Ve=="string"&&(h=!1),h){if(Ve.nodeName){const bt=Ae(Ve.nodeName);if(!ee[bt]||ye[bt])throw At("root node is forbidden and cannot be sanitized in-place")}}else if(Ve instanceof b)Be=de("<!---->"),Ue=Be.ownerDocument.importNode(Ve,!0),Ue.nodeType===1&&Ue.nodeName==="BODY"||Ue.nodeName==="HTML"?Be=Ue:Be.appendChild(Ue);else{if(!Le&&!ve&&!Ne&&Ve.indexOf("<")===-1)return p&&Fe?p.createHTML(Ve):Ve;if(Be=de(Ve),!Be)return Le?null:Fe?A:""}Be&&Ee&&K(Be.firstChild);const dt=pe(h?Ve:Be);for(;st=dt.nextNode();)Ye(st)||(st.content instanceof I&&ut(st.content),et(st));if(h)return Ve;if(Le){if(Ce)for(at=a.call(Be.ownerDocument);Be.firstChild;)at.appendChild(Be.firstChild);else at=Be;return(Z.shadowroot||Z.shadowrootmode)&&(at=_.call(i,at,!0)),at}let ot=Ne?Be.outerHTML:Be.innerHTML;return Ne&&ee["!doctype"]&&Be.ownerDocument&&Be.ownerDocument.doctype&&Be.ownerDocument.doctype.name&&mt(Yt,Be.ownerDocument.doctype.name)&&(ot="<!DOCTYPE "+Be.ownerDocument.doctype.name+`>
`+ot),ve&&(ot=wt(ot,B," "),ot=wt(ot,F," "),ot=wt(ot,E," ")),p&&Fe?p.createHTML(ot):ot},t.setConfig=function(Ve){rt(Ve),ne=!0},t.clearConfig=function(){ke=null,ne=!1},t.isValidAttribute=function(Ve,me,Be){ke||rt({});const Ue=Ae(Ve),st=Ae(me);return Qe(Ue,st,Be)},t.addHook=function(Ve,me){typeof me=="function"&&(H[Ve]=H[Ve]||[],Tt(H[Ve],me))},t.removeHook=function(Ve){if(H[Ve])return Vt(H[Ve])},t.removeHooks=function(Ve){H[Ve]&&(H[Ve]=[])},t.removeAllHooks=function(){H={}},t}var Ni=Zt();define("vs/base/browser/dompurify/dompurify",function(){return Ni}),define(_e[56],Se([1,0]),function(ue,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FastDomNode=void 0,t.createFastDomNode=O;class i{constructor(N){this.domNode=N,this._maxWidth="",this._width="",this._height="",this._top="",this._left="",this._bottom="",this._right="",this._paddingTop="",this._paddingLeft="",this._paddingBottom="",this._paddingRight="",this._fontFamily="",this._fontWeight="",this._fontSize="",this._fontStyle="",this._fontFeatureSettings="",this._fontVariationSettings="",this._textDecoration="",this._lineHeight="",this._letterSpacing="",this._className="",this._display="",this._position="",this._visibility="",this._color="",this._backgroundColor="",this._layerHint=!1,this._contain="none",this._boxShadow=""}setMaxWidth(N){const b=n(N);this._maxWidth!==b&&(this._maxWidth=b,this.domNode.style.maxWidth=this._maxWidth)}setWidth(N){const b=n(N);this._width!==b&&(this._width=b,this.domNode.style.width=this._width)}setHeight(N){const b=n(N);this._height!==b&&(this._height=b,this.domNode.style.height=this._height)}setTop(N){const b=n(N);this._top!==b&&(this._top=b,this.domNode.style.top=this._top)}setLeft(N){const b=n(N);this._left!==b&&(this._left=b,this.domNode.style.left=this._left)}setBottom(N){const b=n(N);this._bottom!==b&&(this._bottom=b,this.domNode.style.bottom=this._bottom)}setRight(N){const b=n(N);this._right!==b&&(this._right=b,this.domNode.style.right=this._right)}setPaddingTop(N){const b=n(N);this._paddingTop!==b&&(this._paddingTop=b,this.domNode.style.paddingTop=this._paddingTop)}setPaddingLeft(N){const b=n(N);this._paddingLeft!==b&&(this._paddingLeft=b,this.domNode.style.paddingLeft=this._paddingLeft)}setPaddingBottom(N){const b=n(N);this._paddingBottom!==b&&(this._paddingBottom=b,this.domNode.style.paddingBottom=this._paddingBottom)}setPaddingRight(N){const b=n(N);this._paddingRight!==b&&(this._paddingRight=b,this.domNode.style.paddingRight=this._paddingRight)}setFontFamily(N){this._fontFamily!==N&&(this._fontFamily=N,this.domNode.style.fontFamily=this._fontFamily)}setFontWeight(N){this._fontWeight!==N&&(this._fontWeight=N,this.domNode.style.fontWeight=this._fontWeight)}setFontSize(N){const b=n(N);this._fontSize!==b&&(this._fontSize=b,this.domNode.style.fontSize=this._fontSize)}setFontStyle(N){this._fontStyle!==N&&(this._fontStyle=N,this.domNode.style.fontStyle=this._fontStyle)}setFontFeatureSettings(N){this._fontFeatureSettings!==N&&(this._fontFeatureSettings=N,this.domNode.style.fontFeatureSettings=this._fontFeatureSettings)}setFontVariationSettings(N){this._fontVariationSettings!==N&&(this._fontVariationSettings=N,this.domNode.style.fontVariationSettings=this._fontVariationSettings)}setTextDecoration(N){this._textDecoration!==N&&(this._textDecoration=N,this.domNode.style.textDecoration=this._textDecoration)}setLineHeight(N){const b=n(N);this._lineHeight!==b&&(this._lineHeight=b,this.domNode.style.lineHeight=this._lineHeight)}setLetterSpacing(N){const b=n(N);this._letterSpacing!==b&&(this._letterSpacing=b,this.domNode.style.letterSpacing=this._letterSpacing)}setClassName(N){this._className!==N&&(this._className=N,this.domNode.className=this._className)}toggleClassName(N,b){this.domNode.classList.toggle(N,b),this._className=this.domNode.className}setDisplay(N){this._display!==N&&(this._display=N,this.domNode.style.display=this._display)}setPosition(N){this._position!==N&&(this._position=N,this.domNode.style.position=this._position)}setVisibility(N){this._visibility!==N&&(this._visibility=N,this.domNode.style.visibility=this._visibility)}setColor(N){this._color!==N&&(this._color=N,this.domNode.style.color=this._color)}setBackgroundColor(N){this._backgroundColor!==N&&(this._backgroundColor=N,this.domNode.style.backgroundColor=this._backgroundColor)}setLayerHinting(N){this._layerHint!==N&&(this._layerHint=N,this.domNode.style.transform=this._layerHint?"translate3d(0px, 0px, 0px)":"")}setBoxShadow(N){this._boxShadow!==N&&(this._boxShadow=N,this.domNode.style.boxShadow=N)}setContain(N){this._contain!==N&&(this._contain=N,this.domNode.style.contain=this._contain)}setAttribute(N,b){this.domNode.setAttribute(N,b)}removeAttribute(N){this.domNode.removeAttribute(N)}appendChild(N){this.domNode.appendChild(N.domNode)}removeChild(N){this.domNode.removeChild(N.domNode)}}t.FastDomNode=i;function n(I){return typeof I=="number"?`${I}px`:I}function O(I){return new i(I)}}),define(_e[86],Se([1,0]),function(ue,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IframeUtils=void 0,t.parentOriginHash=I;const i=new WeakMap;function n(b){if(!b.parent||b.parent===b)return null;try{const w=b.location,u=b.parent.location;if(w.origin!=="null"&&u.origin!=="null"&&w.origin!==u.origin)return null}catch{return null}return b.parent}class O{static getSameOriginWindowChain(w){let u=i.get(w);if(!u){u=[],i.set(w,u);let m=w,v;do v=n(m),v?u.push({window:new WeakRef(m),iframeElement:m.frameElement||null}):u.push({window:new WeakRef(m),iframeElement:null}),m=v;while(m)}return u.slice(0)}static getPositionOfChildWindowRelativeToAncestorWindow(w,u){if(!u||w===u)return{top:0,left:0};let m=0,v=0;const g=this.getSameOriginWindowChain(w);for(const d of g){const e=d.window.deref();if(m+=e?.scrollY??0,v+=e?.scrollX??0,e===u||!d.iframeElement)break;const s=d.iframeElement.getBoundingClientRect();m+=s.top,v+=s.left}return{top:m,left:v}}}t.IframeUtils=O;async function I(b,w){if(!crypto.subtle)throw new Error("'crypto.subtle' is not available so webviews will not work. This is likely because the editor is not running in a secure context (https://developer.mozilla.org/en-US/docs/Web/Security/Secure_Contexts).");const u=JSON.stringify({parentOrigin:b,salt:w}),v=new TextEncoder().encode(u),g=await crypto.subtle.digest("sha-256",v);return N(g)}function N(b){const u=Array.from(new Uint8Array(b)).map(m=>m.toString(16).padStart(2,"0")).join("");return BigInt(`0x${u}`).toString(32).padStart(52,"0")}}),define(_e[33],Se([1,0]),function(ue,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.setBaseLayerHoverDelegate=n,t.getBaseLayerHoverDelegate=O;let i={showHover:()=>{},hideHover:()=>{},showAndFocusLastHover:()=>{},setupManagedHover:()=>null,showManagedHover:()=>{}};function n(I){i=I}function O(){return i}}),define(_e[41],Se([1,0]),function(ue,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CachedListVirtualDelegate=t.ListError=t.ListDragOverReactions=t.ListDragOverEffectPosition=t.ListDragOverEffectType=void 0;var i;(function(N){N[N.Copy=0]="Copy",N[N.Move=1]="Move"})(i||(t.ListDragOverEffectType=i={}));var n;(function(N){N.Over="drop-target",N.Before="drop-target-before",N.After="drop-target-after"})(n||(t.ListDragOverEffectPosition=n={})),t.ListDragOverReactions={reject(){return{accept:!1}},accept(){return{accept:!0}}};class O extends Error{constructor(b,w){super(`ListError [${b}] ${w}`)}}t.ListError=O;class I{constructor(){this.cache=new WeakMap}getHeight(b){return this.cache.get(b)??this.estimateHeight(b)}setDynamicHeight(b,w){w>0&&this.cache.set(b,w)}}t.CachedListVirtualDelegate=I}),define(_e[87],Se([1,0]),function(ue,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CombinedSpliceable=void 0;class i{constructor(O){this.spliceables=O}splice(O,I,N){this.spliceables.forEach(b=>b.splice(O,I,N))}}t.CombinedSpliceable=i}),define(_e[57],Se([1,0]),function(ue,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ScrollbarState=void 0;const i=20;class n{constructor(I,N,b,w,u,m){this._scrollbarSize=Math.round(N),this._oppositeScrollbarSize=Math.round(b),this._arrowSize=Math.round(I),this._visibleSize=w,this._scrollSize=u,this._scrollPosition=m,this._computedAvailableSize=0,this._computedIsNeeded=!1,this._computedSliderSize=0,this._computedSliderRatio=0,this._computedSliderPosition=0,this._refreshComputedValues()}clone(){return new n(this._arrowSize,this._scrollbarSize,this._oppositeScrollbarSize,this._visibleSize,this._scrollSize,this._scrollPosition)}setVisibleSize(I){const N=Math.round(I);return this._visibleSize!==N?(this._visibleSize=N,this._refreshComputedValues(),!0):!1}setScrollSize(I){const N=Math.round(I);return this._scrollSize!==N?(this._scrollSize=N,this._refreshComputedValues(),!0):!1}setScrollPosition(I){const N=Math.round(I);return this._scrollPosition!==N?(this._scrollPosition=N,this._refreshComputedValues(),!0):!1}setScrollbarSize(I){this._scrollbarSize=Math.round(I)}setOppositeScrollbarSize(I){this._oppositeScrollbarSize=Math.round(I)}static _computeValues(I,N,b,w,u){const m=Math.max(0,b-I),v=Math.max(0,m-2*N),g=w>0&&w>b;if(!g)return{computedAvailableSize:Math.round(m),computedIsNeeded:g,computedSliderSize:Math.round(v),computedSliderRatio:0,computedSliderPosition:0};const d=Math.round(Math.max(i,Math.floor(b*v/w))),e=(v-d)/(w-b),s=u*e;return{computedAvailableSize:Math.round(m),computedIsNeeded:g,computedSliderSize:Math.round(d),computedSliderRatio:e,computedSliderPosition:Math.round(s)}}_refreshComputedValues(){const I=n._computeValues(this._oppositeScrollbarSize,this._arrowSize,this._visibleSize,this._scrollSize,this._scrollPosition);this._computedAvailableSize=I.computedAvailableSize,this._computedIsNeeded=I.computedIsNeeded,this._computedSliderSize=I.computedSliderSize,this._computedSliderRatio=I.computedSliderRatio,this._computedSliderPosition=I.computedSliderPosition}getArrowSize(){return this._arrowSize}getScrollPosition(){return this._scrollPosition}getRectangleLargeSize(){return this._computedAvailableSize}getRectangleSmallSize(){return this._scrollbarSize}isNeeded(){return this._computedIsNeeded}getSliderSize(){return this._computedSliderSize}getSliderPosition(){return this._computedSliderPosition}getDesiredScrollPositionFromOffset(I){if(!this._computedIsNeeded)return 0;const N=I-this._arrowSize-this._computedSliderSize/2;return Math.round(N/this._computedSliderRatio)}getDesiredScrollPositionFromOffsetPaged(I){if(!this._computedIsNeeded)return 0;const N=I-this._arrowSize;let b=this._scrollPosition;return N<this._computedSliderPosition?b-=this._visibleSize:b+=this._visibleSize,b}getDesiredScrollPositionFromDelta(I){if(!this._computedIsNeeded)return 0;const N=this._computedSliderPosition+I;return Math.round(N/this._computedSliderRatio)}}t.ScrollbarState=n}),define(_e[34],Se([1,0,41]),function(ue,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.WeakMapper=t.TreeError=t.TreeDragOverReactions=t.TreeDragOverBubble=t.TreeMouseEventTarget=t.ObjectTreeElementCollapseState=t.TreeVisibility=void 0;var n;(function(u){u[u.Hidden=0]="Hidden",u[u.Visible=1]="Visible",u[u.Recurse=2]="Recurse"})(n||(t.TreeVisibility=n={}));var O;(function(u){u[u.Expanded=0]="Expanded",u[u.Collapsed=1]="Collapsed",u[u.PreserveOrExpanded=2]="PreserveOrExpanded",u[u.PreserveOrCollapsed=3]="PreserveOrCollapsed"})(O||(t.ObjectTreeElementCollapseState=O={}));var I;(function(u){u[u.Unknown=0]="Unknown",u[u.Twistie=1]="Twistie",u[u.Element=2]="Element",u[u.Filter=3]="Filter"})(I||(t.TreeMouseEventTarget=I={}));var N;(function(u){u[u.Down=0]="Down",u[u.Up=1]="Up"})(N||(t.TreeDragOverBubble=N={})),t.TreeDragOverReactions={acceptBubbleUp(){return{accept:!0,bubble:N.Up}},acceptBubbleDown(u=!1){return{accept:!0,bubble:N.Down,autoExpand:u}},acceptCopyBubbleUp(){return{accept:!0,bubble:N.Up,effect:{type:i.ListDragOverEffectType.Copy,position:i.ListDragOverEffectPosition.Over}}},acceptCopyBubbleDown(u=!1){return{accept:!0,bubble:N.Down,effect:{type:i.ListDragOverEffectType.Copy,position:i.ListDragOverEffectPosition.Over},autoExpand:u}}};class b extends Error{constructor(m,v){super(`TreeError [${m}] ${v}`)}}t.TreeError=b;class w{constructor(m){this.fn=m,this._map=new WeakMap}map(m){let v=this._map.get(m);return v||(v=this.fn(m),this._map.set(m,v)),v}}t.WeakMapper=w}),define(_e[24],Se([1,0]),function(ue,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.mainWindow=void 0,t.ensureCodeWindow=i,t.isAuxiliaryWindow=n;function i(O,I){const N=O;typeof N.vscodeWindowId!="number"&&Object.defineProperty(N,"vscodeWindowId",{get:()=>I})}t.mainWindow=window;function n(O){return O===t.mainWindow?!1:typeof O?.vscodeWindowId=="number"}}),define(_e[88],Se([1,0]),function(ue,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.MonotonousArray=void 0,t.findLast=i,t.findLastIdx=n,t.findLastMonotonous=O,t.findLastIdxMonotonous=I,t.findFirstMonotonous=N,t.findFirstIdxMonotonousOrArrLen=b,t.findFirstIdxMonotonous=w,t.findFirstMax=m,t.findLastMax=v,t.findFirstMin=g,t.findMaxIdx=d,t.mapFindFirst=e;function i(s,r){const l=n(s,r);if(l!==-1)return s[l]}function n(s,r,l=s.length-1){for(let o=l;o>=0;o--){const p=s[o];if(r(p))return o}return-1}function O(s,r){const l=I(s,r);return l===-1?void 0:s[l]}function I(s,r,l=0,o=s.length){let p=l,A=o;for(;p<A;){const L=Math.floor((p+A)/2);r(s[L])?p=L+1:A=L}return p-1}function N(s,r){const l=b(s,r);return l===s.length?void 0:s[l]}function b(s,r,l=0,o=s.length){let p=l,A=o;for(;p<A;){const L=Math.floor((p+A)/2);r(s[L])?A=L:p=L+1}return p}function w(s,r,l=0,o=s.length){const p=b(s,r,l,o);return p===s.length?-1:p}class u{static{this.assertInvariants=!1}constructor(r){this._array=r,this._findLastMonotonousLastIdx=0}findLastMonotonous(r){if(u.assertInvariants){if(this._prevFindLastPredicate){for(const o of this._array)if(this._prevFindLastPredicate(o)&&!r(o))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this._prevFindLastPredicate=r}const l=I(this._array,r,this._findLastMonotonousLastIdx);return this._findLastMonotonousLastIdx=l+1,l===-1?void 0:this._array[l]}}t.MonotonousArray=u;function m(s,r){if(s.length===0)return;let l=s[0];for(let o=1;o<s.length;o++){const p=s[o];r(p,l)>0&&(l=p)}return l}function v(s,r){if(s.length===0)return;let l=s[0];for(let o=1;o<s.length;o++){const p=s[o];r(p,l)>=0&&(l=p)}return l}function g(s,r){return m(s,(l,o)=>-r(l,o))}function d(s,r){if(s.length===0)return-1;let l=0;for(let o=1;o<s.length;o++){const p=s[o];r(p,s[l])>0&&(l=o)}return l}function e(s,r){for(const l of s){const o=r(l);if(o!==void 0)return o}}}),define(_e[17],Se([1,0]),function(ue,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CharCode=void 0;var i;(function(n){n[n.Null=0]="Null",n[n.Backspace=8]="Backspace",n[n.Tab=9]="Tab",n[n.LineFeed=10]="LineFeed",n[n.CarriageReturn=13]="CarriageReturn",n[n.Space=32]="Space",n[n.ExclamationMark=33]="ExclamationMark",n[n.DoubleQuote=34]="DoubleQuote",n[n.Hash=35]="Hash",n[n.DollarSign=36]="DollarSign",n[n.PercentSign=37]="PercentSign",n[n.Ampersand=38]="Ampersand",n[n.SingleQuote=39]="SingleQuote",n[n.OpenParen=40]="OpenParen",n[n.CloseParen=41]="CloseParen",n[n.Asterisk=42]="Asterisk",n[n.Plus=43]="Plus",n[n.Comma=44]="Comma",n[n.Dash=45]="Dash",n[n.Period=46]="Period",n[n.Slash=47]="Slash",n[n.Digit0=48]="Digit0",n[n.Digit1=49]="Digit1",n[n.Digit2=50]="Digit2",n[n.Digit3=51]="Digit3",n[n.Digit4=52]="Digit4",n[n.Digit5=53]="Digit5",n[n.Digit6=54]="Digit6",n[n.Digit7=55]="Digit7",n[n.Digit8=56]="Digit8",n[n.Digit9=57]="Digit9",n[n.Colon=58]="Colon",n[n.Semicolon=59]="Semicolon",n[n.LessThan=60]="LessThan",n[n.Equals=61]="Equals",n[n.GreaterThan=62]="GreaterThan",n[n.QuestionMark=63]="QuestionMark",n[n.AtSign=64]="AtSign",n[n.A=65]="A",n[n.B=66]="B",n[n.C=67]="C",n[n.D=68]="D",n[n.E=69]="E",n[n.F=70]="F",n[n.G=71]="G",n[n.H=72]="H",n[n.I=73]="I",n[n.J=74]="J",n[n.K=75]="K",n[n.L=76]="L",n[n.M=77]="M",n[n.N=78]="N",n[n.O=79]="O",n[n.P=80]="P",n[n.Q=81]="Q",n[n.R=82]="R",n[n.S=83]="S",n[n.T=84]="T",n[n.U=85]="U",n[n.V=86]="V",n[n.W=87]="W",n[n.X=88]="X",n[n.Y=89]="Y",n[n.Z=90]="Z",n[n.OpenSquareBracket=91]="OpenSquareBracket",n[n.Backslash=92]="Backslash",n[n.CloseSquareBracket=93]="CloseSquareBracket",n[n.Caret=94]="Caret",n[n.Underline=95]="Underline",n[n.BackTick=96]="BackTick",n[n.a=97]="a",n[n.b=98]="b",n[n.c=99]="c",n[n.d=100]="d",n[n.e=101]="e",n[n.f=102]="f",n[n.g=103]="g",n[n.h=104]="h",n[n.i=105]="i",n[n.j=106]="j",n[n.k=107]="k",n[n.l=108]="l",n[n.m=109]="m",n[n.n=110]="n",n[n.o=111]="o",n[n.p=112]="p",n[n.q=113]="q",n[n.r=114]="r",n[n.s=115]="s",n[n.t=116]="t",n[n.u=117]="u",n[n.v=118]="v",n[n.w=119]="w",n[n.x=120]="x",n[n.y=121]="y",n[n.z=122]="z",n[n.OpenCurlyBrace=123]="OpenCurlyBrace",n[n.Pipe=124]="Pipe",n[n.CloseCurlyBrace=125]="CloseCurlyBrace",n[n.Tilde=126]="Tilde",n[n.NoBreakSpace=160]="NoBreakSpace",n[n.U_Combining_Grave_Accent=768]="U_Combining_Grave_Accent",n[n.U_Combining_Acute_Accent=769]="U_Combining_Acute_Accent",n[n.U_Combining_Circumflex_Accent=770]="U_Combining_Circumflex_Accent",n[n.U_Combining_Tilde=771]="U_Combining_Tilde",n[n.U_Combining_Macron=772]="U_Combining_Macron",n[n.U_Combining_Overline=773]="U_Combining_Overline",n[n.U_Combining_Breve=774]="U_Combining_Breve",n[n.U_Combining_Dot_Above=775]="U_Combining_Dot_Above",n[n.U_Combining_Diaeresis=776]="U_Combining_Diaeresis",n[n.U_Combining_Hook_Above=777]="U_Combining_Hook_Above",n[n.U_Combining_Ring_Above=778]="U_Combining_Ring_Above",n[n.U_Combining_Double_Acute_Accent=779]="U_Combining_Double_Acute_Accent",n[n.U_Combining_Caron=780]="U_Combining_Caron",n[n.U_Combining_Vertical_Line_Above=781]="U_Combining_Vertical_Line_Above",n[n.U_Combining_Double_Vertical_Line_Above=782]="U_Combining_Double_Vertical_Line_Above",n[n.U_Combining_Double_Grave_Accent=783]="U_Combining_Double_Grave_Accent",n[n.U_Combining_Candrabindu=784]="U_Combining_Candrabindu",n[n.U_Combining_Inverted_Breve=785]="U_Combining_Inverted_Breve",n[n.U_Combining_Turned_Comma_Above=786]="U_Combining_Turned_Comma_Above",n[n.U_Combining_Comma_Above=787]="U_Combining_Comma_Above",n[n.U_Combining_Reversed_Comma_Above=788]="U_Combining_Reversed_Comma_Above",n[n.U_Combining_Comma_Above_Right=789]="U_Combining_Comma_Above_Right",n[n.U_Combining_Grave_Accent_Below=790]="U_Combining_Grave_Accent_Below",n[n.U_Combining_Acute_Accent_Below=791]="U_Combining_Acute_Accent_Below",n[n.U_Combining_Left_Tack_Below=792]="U_Combining_Left_Tack_Below",n[n.U_Combining_Right_Tack_Below=793]="U_Combining_Right_Tack_Below",n[n.U_Combining_Left_Angle_Above=794]="U_Combining_Left_Angle_Above",n[n.U_Combining_Horn=795]="U_Combining_Horn",n[n.U_Combining_Left_Half_Ring_Below=796]="U_Combining_Left_Half_Ring_Below",n[n.U_Combining_Up_Tack_Below=797]="U_Combining_Up_Tack_Below",n[n.U_Combining_Down_Tack_Below=798]="U_Combining_Down_Tack_Below",n[n.U_Combining_Plus_Sign_Below=799]="U_Combining_Plus_Sign_Below",n[n.U_Combining_Minus_Sign_Below=800]="U_Combining_Minus_Sign_Below",n[n.U_Combining_Palatalized_Hook_Below=801]="U_Combining_Palatalized_Hook_Below",n[n.U_Combining_Retroflex_Hook_Below=802]="U_Combining_Retroflex_Hook_Below",n[n.U_Combining_Dot_Below=803]="U_Combining_Dot_Below",n[n.U_Combining_Diaeresis_Below=804]="U_Combining_Diaeresis_Below",n[n.U_Combining_Ring_Below=805]="U_Combining_Ring_Below",n[n.U_Combining_Comma_Below=806]="U_Combining_Comma_Below",n[n.U_Combining_Cedilla=807]="U_Combining_Cedilla",n[n.U_Combining_Ogonek=808]="U_Combining_Ogonek",n[n.U_Combining_Vertical_Line_Below=809]="U_Combining_Vertical_Line_Below",n[n.U_Combining_Bridge_Below=810]="U_Combining_Bridge_Below",n[n.U_Combining_Inverted_Double_Arch_Below=811]="U_Combining_Inverted_Double_Arch_Below",n[n.U_Combining_Caron_Below=812]="U_Combining_Caron_Below",n[n.U_Combining_Circumflex_Accent_Below=813]="U_Combining_Circumflex_Accent_Below",n[n.U_Combining_Breve_Below=814]="U_Combining_Breve_Below",n[n.U_Combining_Inverted_Breve_Below=815]="U_Combining_Inverted_Breve_Below",n[n.U_Combining_Tilde_Below=816]="U_Combining_Tilde_Below",n[n.U_Combining_Macron_Below=817]="U_Combining_Macron_Below",n[n.U_Combining_Low_Line=818]="U_Combining_Low_Line",n[n.U_Combining_Double_Low_Line=819]="U_Combining_Double_Low_Line",n[n.U_Combining_Tilde_Overlay=820]="U_Combining_Tilde_Overlay",n[n.U_Combining_Short_Stroke_Overlay=821]="U_Combining_Short_Stroke_Overlay",n[n.U_Combining_Long_Stroke_Overlay=822]="U_Combining_Long_Stroke_Overlay",n[n.U_Combining_Short_Solidus_Overlay=823]="U_Combining_Short_Solidus_Overlay",n[n.U_Combining_Long_Solidus_Overlay=824]="U_Combining_Long_Solidus_Overlay",n[n.U_Combining_Right_Half_Ring_Below=825]="U_Combining_Right_Half_Ring_Below",n[n.U_Combining_Inverted_Bridge_Below=826]="U_Combining_Inverted_Bridge_Below",n[n.U_Combining_Square_Below=827]="U_Combining_Square_Below",n[n.U_Combining_Seagull_Below=828]="U_Combining_Seagull_Below",n[n.U_Combining_X_Above=829]="U_Combining_X_Above",n[n.U_Combining_Vertical_Tilde=830]="U_Combining_Vertical_Tilde",n[n.U_Combining_Double_Overline=831]="U_Combining_Double_Overline",n[n.U_Combining_Grave_Tone_Mark=832]="U_Combining_Grave_Tone_Mark",n[n.U_Combining_Acute_Tone_Mark=833]="U_Combining_Acute_Tone_Mark",n[n.U_Combining_Greek_Perispomeni=834]="U_Combining_Greek_Perispomeni",n[n.U_Combining_Greek_Koronis=835]="U_Combining_Greek_Koronis",n[n.U_Combining_Greek_Dialytika_Tonos=836]="U_Combining_Greek_Dialytika_Tonos",n[n.U_Combining_Greek_Ypogegrammeni=837]="U_Combining_Greek_Ypogegrammeni",n[n.U_Combining_Bridge_Above=838]="U_Combining_Bridge_Above",n[n.U_Combining_Equals_Sign_Below=839]="U_Combining_Equals_Sign_Below",n[n.U_Combining_Double_Vertical_Line_Below=840]="U_Combining_Double_Vertical_Line_Below",n[n.U_Combining_Left_Angle_Below=841]="U_Combining_Left_Angle_Below",n[n.U_Combining_Not_Tilde_Above=842]="U_Combining_Not_Tilde_Above",n[n.U_Combining_Homothetic_Above=843]="U_Combining_Homothetic_Above",n[n.U_Combining_Almost_Equal_To_Above=844]="U_Combining_Almost_Equal_To_Above",n[n.U_Combining_Left_Right_Arrow_Below=845]="U_Combining_Left_Right_Arrow_Below",n[n.U_Combining_Upwards_Arrow_Below=846]="U_Combining_Upwards_Arrow_Below",n[n.U_Combining_Grapheme_Joiner=847]="U_Combining_Grapheme_Joiner",n[n.U_Combining_Right_Arrowhead_Above=848]="U_Combining_Right_Arrowhead_Above",n[n.U_Combining_Left_Half_Ring_Above=849]="U_Combining_Left_Half_Ring_Above",n[n.U_Combining_Fermata=850]="U_Combining_Fermata",n[n.U_Combining_X_Below=851]="U_Combining_X_Below",n[n.U_Combining_Left_Arrowhead_Below=852]="U_Combining_Left_Arrowhead_Below",n[n.U_Combining_Right_Arrowhead_Below=853]="U_Combining_Right_Arrowhead_Below",n[n.U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below=854]="U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below",n[n.U_Combining_Right_Half_Ring_Above=855]="U_Combining_Right_Half_Ring_Above",n[n.U_Combining_Dot_Above_Right=856]="U_Combining_Dot_Above_Right",n[n.U_Combining_Asterisk_Below=857]="U_Combining_Asterisk_Below",n[n.U_Combining_Double_Ring_Below=858]="U_Combining_Double_Ring_Below",n[n.U_Combining_Zigzag_Above=859]="U_Combining_Zigzag_Above",n[n.U_Combining_Double_Breve_Below=860]="U_Combining_Double_Breve_Below",n[n.U_Combining_Double_Breve=861]="U_Combining_Double_Breve",n[n.U_Combining_Double_Macron=862]="U_Combining_Double_Macron",n[n.U_Combining_Double_Macron_Below=863]="U_Combining_Double_Macron_Below",n[n.U_Combining_Double_Tilde=864]="U_Combining_Double_Tilde",n[n.U_Combining_Double_Inverted_Breve=865]="U_Combining_Double_Inverted_Breve",n[n.U_Combining_Double_Rightwards_Arrow_Below=866]="U_Combining_Double_Rightwards_Arrow_Below",n[n.U_Combining_Latin_Small_Letter_A=867]="U_Combining_Latin_Small_Letter_A",n[n.U_Combining_Latin_Small_Letter_E=868]="U_Combining_Latin_Small_Letter_E",n[n.U_Combining_Latin_Small_Letter_I=869]="U_Combining_Latin_Small_Letter_I",n[n.U_Combining_Latin_Small_Letter_O=870]="U_Combining_Latin_Small_Letter_O",n[n.U_Combining_Latin_Small_Letter_U=871]="U_Combining_Latin_Small_Letter_U",n[n.U_Combining_Latin_Small_Letter_C=872]="U_Combining_Latin_Small_Letter_C",n[n.U_Combining_Latin_Small_Letter_D=873]="U_Combining_Latin_Small_Letter_D",n[n.U_Combining_Latin_Small_Letter_H=874]="U_Combining_Latin_Small_Letter_H",n[n.U_Combining_Latin_Small_Letter_M=875]="U_Combining_Latin_Small_Letter_M",n[n.U_Combining_Latin_Small_Letter_R=876]="U_Combining_Latin_Small_Letter_R",n[n.U_Combining_Latin_Small_Letter_T=877]="U_Combining_Latin_Small_Letter_T",n[n.U_Combining_Latin_Small_Letter_V=878]="U_Combining_Latin_Small_Letter_V",n[n.U_Combining_Latin_Small_Letter_X=879]="U_Combining_Latin_Small_Letter_X",n[n.LINE_SEPARATOR=8232]="LINE_SEPARATOR",n[n.PARAGRAPH_SEPARATOR=8233]="PARAGRAPH_SEPARATOR",n[n.NEXT_LINE=133]="NEXT_LINE",n[n.U_CIRCUMFLEX=94]="U_CIRCUMFLEX",n[n.U_GRAVE_ACCENT=96]="U_GRAVE_ACCENT",n[n.U_DIAERESIS=168]="U_DIAERESIS",n[n.U_MACRON=175]="U_MACRON",n[n.U_ACUTE_ACCENT=180]="U_ACUTE_ACCENT",n[n.U_CEDILLA=184]="U_CEDILLA",n[n.U_MODIFIER_LETTER_LEFT_ARROWHEAD=706]="U_MODIFIER_LETTER_LEFT_ARROWHEAD",n[n.U_MODIFIER_LETTER_RIGHT_ARROWHEAD=707]="U_MODIFIER_LETTER_RIGHT_ARROWHEAD",n[n.U_MODIFIER_LETTER_UP_ARROWHEAD=708]="U_MODIFIER_LETTER_UP_ARROWHEAD",n[n.U_MODIFIER_LETTER_DOWN_ARROWHEAD=709]="U_MODIFIER_LETTER_DOWN_ARROWHEAD",n[n.U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING=722]="U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING",n[n.U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING=723]="U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING",n[n.U_MODIFIER_LETTER_UP_TACK=724]="U_MODIFIER_LETTER_UP_TACK",n[n.U_MODIFIER_LETTER_DOWN_TACK=725]="U_MODIFIER_LETTER_DOWN_TACK",n[n.U_MODIFIER_LETTER_PLUS_SIGN=726]="U_MODIFIER_LETTER_PLUS_SIGN",n[n.U_MODIFIER_LETTER_MINUS_SIGN=727]="U_MODIFIER_LETTER_MINUS_SIGN",n[n.U_BREVE=728]="U_BREVE",n[n.U_DOT_ABOVE=729]="U_DOT_ABOVE",n[n.U_RING_ABOVE=730]="U_RING_ABOVE",n[n.U_OGONEK=731]="U_OGONEK",n[n.U_SMALL_TILDE=732]="U_SMALL_TILDE",n[n.U_DOUBLE_ACUTE_ACCENT=733]="U_DOUBLE_ACUTE_ACCENT",n[n.U_MODIFIER_LETTER_RHOTIC_HOOK=734]="U_MODIFIER_LETTER_RHOTIC_HOOK",n[n.U_MODIFIER_LETTER_CROSS_ACCENT=735]="U_MODIFIER_LETTER_CROSS_ACCENT",n[n.U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR=741]="U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR",n[n.U_MODIFIER_LETTER_HIGH_TONE_BAR=742]="U_MODIFIER_LETTER_HIGH_TONE_BAR",n[n.U_MODIFIER_LETTER_MID_TONE_BAR=743]="U_MODIFIER_LETTER_MID_TONE_BAR",n[n.U_MODIFIER_LETTER_LOW_TONE_BAR=744]="U_MODIFIER_LETTER_LOW_TONE_BAR",n[n.U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR=745]="U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR",n[n.U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK=746]="U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK",n[n.U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK=747]="U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK",n[n.U_MODIFIER_LETTER_UNASPIRATED=749]="U_MODIFIER_LETTER_UNASPIRATED",n[n.U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD=751]="U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD",n[n.U_MODIFIER_LETTER_LOW_UP_ARROWHEAD=752]="U_MODIFIER_LETTER_LOW_UP_ARROWHEAD",n[n.U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD=753]="U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD",n[n.U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD=754]="U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD",n[n.U_MODIFIER_LETTER_LOW_RING=755]="U_MODIFIER_LETTER_LOW_RING",n[n.U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT=756]="U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT",n[n.U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT=757]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT",n[n.U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT=758]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT",n[n.U_MODIFIER_LETTER_LOW_TILDE=759]="U_MODIFIER_LETTER_LOW_TILDE",n[n.U_MODIFIER_LETTER_RAISED_COLON=760]="U_MODIFIER_LETTER_RAISED_COLON",n[n.U_MODIFIER_LETTER_BEGIN_HIGH_TONE=761]="U_MODIFIER_LETTER_BEGIN_HIGH_TONE",n[n.U_MODIFIER_LETTER_END_HIGH_TONE=762]="U_MODIFIER_LETTER_END_HIGH_TONE",n[n.U_MODIFIER_LETTER_BEGIN_LOW_TONE=763]="U_MODIFIER_LETTER_BEGIN_LOW_TONE",n[n.U_MODIFIER_LETTER_END_LOW_TONE=764]="U_MODIFIER_LETTER_END_LOW_TONE",n[n.U_MODIFIER_LETTER_SHELF=765]="U_MODIFIER_LETTER_SHELF",n[n.U_MODIFIER_LETTER_OPEN_SHELF=766]="U_MODIFIER_LETTER_OPEN_SHELF",n[n.U_MODIFIER_LETTER_LOW_LEFT_ARROW=767]="U_MODIFIER_LETTER_LOW_LEFT_ARROW",n[n.U_GREEK_LOWER_NUMERAL_SIGN=885]="U_GREEK_LOWER_NUMERAL_SIGN",n[n.U_GREEK_TONOS=900]="U_GREEK_TONOS",n[n.U_GREEK_DIALYTIKA_TONOS=901]="U_GREEK_DIALYTIKA_TONOS",n[n.U_GREEK_KORONIS=8125]="U_GREEK_KORONIS",n[n.U_GREEK_PSILI=8127]="U_GREEK_PSILI",n[n.U_GREEK_PERISPOMENI=8128]="U_GREEK_PERISPOMENI",n[n.U_GREEK_DIALYTIKA_AND_PERISPOMENI=8129]="U_GREEK_DIALYTIKA_AND_PERISPOMENI",n[n.U_GREEK_PSILI_AND_VARIA=8141]="U_GREEK_PSILI_AND_VARIA",n[n.U_GREEK_PSILI_AND_OXIA=8142]="U_GREEK_PSILI_AND_OXIA",n[n.U_GREEK_PSILI_AND_PERISPOMENI=8143]="U_GREEK_PSILI_AND_PERISPOMENI",n[n.U_GREEK_DASIA_AND_VARIA=8157]="U_GREEK_DASIA_AND_VARIA",n[n.U_GREEK_DASIA_AND_OXIA=8158]="U_GREEK_DASIA_AND_OXIA",n[n.U_GREEK_DASIA_AND_PERISPOMENI=8159]="U_GREEK_DASIA_AND_PERISPOMENI",n[n.U_GREEK_DIALYTIKA_AND_VARIA=8173]="U_GREEK_DIALYTIKA_AND_VARIA",n[n.U_GREEK_DIALYTIKA_AND_OXIA=8174]="U_GREEK_DIALYTIKA_AND_OXIA",n[n.U_GREEK_VARIA=8175]="U_GREEK_VARIA",n[n.U_GREEK_OXIA=8189]="U_GREEK_OXIA",n[n.U_GREEK_DASIA=8190]="U_GREEK_DASIA",n[n.U_IDEOGRAPHIC_FULL_STOP=12290]="U_IDEOGRAPHIC_FULL_STOP",n[n.U_LEFT_CORNER_BRACKET=12300]="U_LEFT_CORNER_BRACKET",n[n.U_RIGHT_CORNER_BRACKET=12301]="U_RIGHT_CORNER_BRACKET",n[n.U_LEFT_BLACK_LENTICULAR_BRACKET=12304]="U_LEFT_BLACK_LENTICULAR_BRACKET",n[n.U_RIGHT_BLACK_LENTICULAR_BRACKET=12305]="U_RIGHT_BLACK_LENTICULAR_BRACKET",n[n.U_OVERLINE=8254]="U_OVERLINE",n[n.UTF8_BOM=65279]="UTF8_BOM",n[n.U_FULLWIDTH_SEMICOLON=65307]="U_FULLWIDTH_SEMICOLON",n[n.U_FULLWIDTH_COMMA=65292]="U_FULLWIDTH_COMMA"})(i||(t.CharCode=i={}))}),define(_e[58],Se([1,0]),function(ue,t){"use strict";var i;Object.defineProperty(t,"__esModule",{value:!0}),t.SetWithKey=void 0,t.groupBy=n,t.diffSets=O,t.diffMaps=I,t.intersection=N;function n(w,u){const m=Object.create(null);for(const v of w){const g=u(v);let d=m[g];d||(d=m[g]=[]),d.push(v)}return m}function O(w,u){const m=[],v=[];for(const g of w)u.has(g)||m.push(g);for(const g of u)w.has(g)||v.push(g);return{removed:m,added:v}}function I(w,u){const m=[],v=[];for(const[g,d]of w)u.has(g)||m.push(d);for(const[g,d]of u)w.has(g)||v.push(d);return{removed:m,added:v}}function N(w,u){const m=new Set;for(const v of u)w.has(v)&&m.add(v);return m}class b{static{i=Symbol.toStringTag}constructor(u,m){this.toKey=m,this._map=new Map,this[i]="SetWithKey";for(const v of u)this.add(v)}get size(){return this._map.size}add(u){const m=this.toKey(u);return this._map.set(m,u),this}delete(u){return this._map.delete(this.toKey(u))}has(u){return this._map.has(this.toKey(u))}*entries(){for(const u of this._map.values())yield[u,u]}keys(){return this.values()}*values(){for(const u of this._map.values())yield u}clear(){this._map.clear()}forEach(u,m){this._map.forEach(v=>u.call(m,v,v,this))}[Symbol.iterator](){return this.values()}}t.SetWithKey=b}),define(_e[89],Se([1,0,17]),function(ue,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Color=t.HSVA=t.HSLA=t.RGBA=void 0;function n(w,u){const m=Math.pow(10,u);return Math.round(w*m)/m}class O{constructor(u,m,v,g=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,u))|0,this.g=Math.min(255,Math.max(0,m))|0,this.b=Math.min(255,Math.max(0,v))|0,this.a=n(Math.max(Math.min(1,g),0),3)}static equals(u,m){return u.r===m.r&&u.g===m.g&&u.b===m.b&&u.a===m.a}}t.RGBA=O;class I{constructor(u,m,v,g){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,u),0)|0,this.s=n(Math.max(Math.min(1,m),0),3),this.l=n(Math.max(Math.min(1,v),0),3),this.a=n(Math.max(Math.min(1,g),0),3)}static equals(u,m){return u.h===m.h&&u.s===m.s&&u.l===m.l&&u.a===m.a}static fromRGBA(u){const m=u.r/255,v=u.g/255,g=u.b/255,d=u.a,e=Math.max(m,v,g),s=Math.min(m,v,g);let r=0,l=0;const o=(s+e)/2,p=e-s;if(p>0){switch(l=Math.min(o<=.5?p/(2*o):p/(2-2*o),1),e){case m:r=(v-g)/p+(v<g?6:0);break;case v:r=(g-m)/p+2;break;case g:r=(m-v)/p+4;break}r*=60,r=Math.round(r)}return new I(r,l,o,d)}static _hue2rgb(u,m,v){return v<0&&(v+=1),v>1&&(v-=1),v<1/6?u+(m-u)*6*v:v<1/2?m:v<2/3?u+(m-u)*(2/3-v)*6:u}static toRGBA(u){const m=u.h/360,{s:v,l:g,a:d}=u;let e,s,r;if(v===0)e=s=r=g;else{const l=g<.5?g*(1+v):g+v-g*v,o=2*g-l;e=I._hue2rgb(o,l,m+1/3),s=I._hue2rgb(o,l,m),r=I._hue2rgb(o,l,m-1/3)}return new O(Math.round(e*255),Math.round(s*255),Math.round(r*255),d)}}t.HSLA=I;class N{constructor(u,m,v,g){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,u),0)|0,this.s=n(Math.max(Math.min(1,m),0),3),this.v=n(Math.max(Math.min(1,v),0),3),this.a=n(Math.max(Math.min(1,g),0),3)}static equals(u,m){return u.h===m.h&&u.s===m.s&&u.v===m.v&&u.a===m.a}static fromRGBA(u){const m=u.r/255,v=u.g/255,g=u.b/255,d=Math.max(m,v,g),e=Math.min(m,v,g),s=d-e,r=d===0?0:s/d;let l;return s===0?l=0:d===m?l=((v-g)/s%6+6)%6:d===v?l=(g-m)/s+2:l=(m-v)/s+4,new N(Math.round(l*60),r,d,u.a)}static toRGBA(u){const{h:m,s:v,v:g,a:d}=u,e=g*v,s=e*(1-Math.abs(m/60%2-1)),r=g-e;let[l,o,p]=[0,0,0];return m<60?(l=e,o=s):m<120?(l=s,o=e):m<180?(o=e,p=s):m<240?(o=s,p=e):m<300?(l=s,p=e):m<=360&&(l=e,p=s),l=Math.round((l+r)*255),o=Math.round((o+r)*255),p=Math.round((p+r)*255),new O(l,o,p,d)}}t.HSVA=N;class b{static fromHex(u){return b.Format.CSS.parseHex(u)||b.red}static equals(u,m){return!u&&!m?!0:!u||!m?!1:u.equals(m)}get hsla(){return this._hsla?this._hsla:I.fromRGBA(this.rgba)}get hsva(){return this._hsva?this._hsva:N.fromRGBA(this.rgba)}constructor(u){if(u)if(u instanceof O)this.rgba=u;else if(u instanceof I)this._hsla=u,this.rgba=I.toRGBA(u);else if(u instanceof N)this._hsva=u,this.rgba=N.toRGBA(u);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(u){return!!u&&O.equals(this.rgba,u.rgba)&&I.equals(this.hsla,u.hsla)&&N.equals(this.hsva,u.hsva)}getRelativeLuminance(){const u=b._relativeLuminanceForComponent(this.rgba.r),m=b._relativeLuminanceForComponent(this.rgba.g),v=b._relativeLuminanceForComponent(this.rgba.b),g=.2126*u+.7152*m+.0722*v;return n(g,4)}static _relativeLuminanceForComponent(u){const m=u/255;return m<=.03928?m/12.92:Math.pow((m+.055)/1.055,2.4)}getContrastRatio(u){const m=this.getRelativeLuminance(),v=u.getRelativeLuminance();return m>v?(m+.05)/(v+.05):(v+.05)/(m+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(u){const m=this.getRelativeLuminance(),v=u.getRelativeLuminance();return m>v}isDarkerThan(u){const m=this.getRelativeLuminance(),v=u.getRelativeLuminance();return m<v}lighten(u){return new b(new I(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*u,this.hsla.a))}darken(u){return new b(new I(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*u,this.hsla.a))}transparent(u){const{r:m,g:v,b:g,a:d}=this.rgba;return new b(new O(m,v,g,d*u))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new b(new O(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(u){const m=u.rgba,v=this.rgba.a,g=m.a,d=v+g*(1-v);if(d<1e-6)return b.transparent;const e=this.rgba.r*v/d+m.r*g*(1-v)/d,s=this.rgba.g*v/d+m.g*g*(1-v)/d,r=this.rgba.b*v/d+m.b*g*(1-v)/d;return new b(new O(e,s,r,d))}makeOpaque(u){if(this.isOpaque()||u.rgba.a!==1)return this;const{r:m,g:v,b:g,a:d}=this.rgba;return new b(new O(u.rgba.r-d*(u.rgba.r-m),u.rgba.g-d*(u.rgba.g-v),u.rgba.b-d*(u.rgba.b-g),1))}flatten(...u){const m=u.reduceRight((v,g)=>b._flatten(g,v));return b._flatten(this,m)}static _flatten(u,m){const v=1-u.rgba.a;return new b(new O(v*m.rgba.r+u.rgba.a*u.rgba.r,v*m.rgba.g+u.rgba.a*u.rgba.g,v*m.rgba.b+u.rgba.a*u.rgba.b))}toString(){return this._toString||(this._toString=b.Format.CSS.format(this)),this._toString}static getLighterColor(u,m,v){if(u.isLighterThan(m))return u;v=v||.5;const g=u.getRelativeLuminance(),d=m.getRelativeLuminance();return v=v*(d-g)/d,u.lighten(v)}static getDarkerColor(u,m,v){if(u.isDarkerThan(m))return u;v=v||.5;const g=u.getRelativeLuminance(),d=m.getRelativeLuminance();return v=v*(g-d)/g,u.darken(v)}static{this.white=new b(new O(255,255,255,1))}static{this.black=new b(new O(0,0,0,1))}static{this.red=new b(new O(255,0,0,1))}static{this.blue=new b(new O(0,0,255,1))}static{this.green=new b(new O(0,255,0,1))}static{this.cyan=new b(new O(0,255,255,1))}static{this.lightgrey=new b(new O(211,211,211,1))}static{this.transparent=new b(new O(0,0,0,0))}}t.Color=b,function(w){let u;(function(m){let v;(function(g){function d(a){return a.rgba.a===1?`rgb(${a.rgba.r}, ${a.rgba.g}, ${a.rgba.b})`:w.Format.CSS.formatRGBA(a)}g.formatRGB=d;function e(a){return`rgba(${a.rgba.r}, ${a.rgba.g}, ${a.rgba.b}, ${+a.rgba.a.toFixed(2)})`}g.formatRGBA=e;function s(a){return a.hsla.a===1?`hsl(${a.hsla.h}, ${(a.hsla.s*100).toFixed(2)}%, ${(a.hsla.l*100).toFixed(2)}%)`:w.Format.CSS.formatHSLA(a)}g.formatHSL=s;function r(a){return`hsla(${a.hsla.h}, ${(a.hsla.s*100).toFixed(2)}%, ${(a.hsla.l*100).toFixed(2)}%, ${a.hsla.a.toFixed(2)})`}g.formatHSLA=r;function l(a){const f=a.toString(16);return f.length!==2?"0"+f:f}function o(a){return`#${l(a.rgba.r)}${l(a.rgba.g)}${l(a.rgba.b)}`}g.formatHex=o;function p(a,f=!1){return f&&a.rgba.a===1?w.Format.CSS.formatHex(a):`#${l(a.rgba.r)}${l(a.rgba.g)}${l(a.rgba.b)}${l(Math.round(a.rgba.a*255))}`}g.formatHexA=p;function A(a){return a.isOpaque()?w.Format.CSS.formatHex(a):w.Format.CSS.formatRGBA(a)}g.format=A;function L(a){const f=a.length;if(f===0||a.charCodeAt(0)!==i.CharCode.Hash)return null;if(f===7){const _=16*c(a.charCodeAt(1))+c(a.charCodeAt(2)),H=16*c(a.charCodeAt(3))+c(a.charCodeAt(4)),B=16*c(a.charCodeAt(5))+c(a.charCodeAt(6));return new w(new O(_,H,B,1))}if(f===9){const _=16*c(a.charCodeAt(1))+c(a.charCodeAt(2)),H=16*c(a.charCodeAt(3))+c(a.charCodeAt(4)),B=16*c(a.charCodeAt(5))+c(a.charCodeAt(6)),F=16*c(a.charCodeAt(7))+c(a.charCodeAt(8));return new w(new O(_,H,B,F/255))}if(f===4){const _=c(a.charCodeAt(1)),H=c(a.charCodeAt(2)),B=c(a.charCodeAt(3));return new w(new O(16*_+_,16*H+H,16*B+B))}if(f===5){const _=c(a.charCodeAt(1)),H=c(a.charCodeAt(2)),B=c(a.charCodeAt(3)),F=c(a.charCodeAt(4));return new w(new O(16*_+_,16*H+H,16*B+B,(16*F+F)/255))}return null}g.parseHex=L;function c(a){switch(a){case i.CharCode.Digit0:return 0;case i.CharCode.Digit1:return 1;case i.CharCode.Digit2:return 2;case i.CharCode.Digit3:return 3;case i.CharCode.Digit4:return 4;case i.CharCode.Digit5:return 5;case i.CharCode.Digit6:return 6;case i.CharCode.Digit7:return 7;case i.CharCode.Digit8:return 8;case i.CharCode.Digit9:return 9;case i.CharCode.a:return 10;case i.CharCode.A:return 10;case i.CharCode.b:return 11;case i.CharCode.B:return 11;case i.CharCode.c:return 12;case i.CharCode.C:return 12;case i.CharCode.d:return 13;case i.CharCode.D:return 13;case i.CharCode.e:return 14;case i.CharCode.E:return 14;case i.CharCode.f:return 15;case i.CharCode.F:return 15}return 0}})(v=m.CSS||(m.CSS={}))})(u=w.Format||(w.Format={}))}(b||(t.Color=b={}))}),define(_e[35],Se([1,0]),function(ue,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.memoize=n,t.debounce=O,t.throttle=I;function i(N){return(b,w,u)=>{let m=null,v=null;if(typeof u.value=="function"?(m="value",v=u.value):typeof u.get=="function"&&(m="get",v=u.get),!v)throw new Error("not supported");u[m]=N(v,w)}}function n(N,b,w){let u=null,m=null;if(typeof w.value=="function"?(u="value",m=w.value,m.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof w.get=="function"&&(u="get",m=w.get),!m)throw new Error("not supported");const v=`$memoize$${b}`;w[u]=function(...g){return this.hasOwnProperty(v)||Object.defineProperty(this,v,{configurable:!1,enumerable:!1,writable:!1,value:m.apply(this,g)}),this[v]}}function O(N,b,w){return i((u,m)=>{const v=`$debounce$${m}`,g=`$debounce$result$${m}`;return function(...d){this[g]||(this[g]=w?w():void 0),clearTimeout(this[v]),b&&(this[g]=b(this[g],...d),d=[this[g]]),this[v]=setTimeout(()=>{u.apply(this,d),this[g]=w?w():void 0},N)}})}function I(N,b,w){return i((u,m)=>{const v=`$throttle$timer$${m}`,g=`$throttle$result$${m}`,d=`$throttle$lastRun$${m}`,e=`$throttle$pending$${m}`;return function(...s){if(this[g]||(this[g]=w?w():void 0),(this[d]===null||this[d]===void 0)&&(this[d]=-Number.MAX_VALUE),b&&(this[g]=b(this[g],...s)),this[e])return;const r=this[d]+N;r<=Date.now()?(this[d]=Date.now(),u.apply(this,[this[g]]),this[g]=w?w():void 0):(this[e]=!0,this[v]=setTimeout(()=>{this[e]=!1,this[d]=Date.now(),u.apply(this,[this[g]]),this[g]=w?w():void 0},r-Date.now()))}})}}),define(_e[90],Se([1,0]),function(ue,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DiffChange=void 0;class i{constructor(O,I,N,b){this.originalStart=O,this.originalLength=I,this.modifiedStart=N,this.modifiedLength=b}getOriginalEnd(){return this.originalStart+this.originalLength}getModifiedEnd(){return this.modifiedStart+this.modifiedLength}}t.DiffChange=i}),define(_e[6],Se([1,0]),function(ue,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.BugIndicatingError=t.ErrorNoTelemetry=t.ExpectedError=t.NotSupportedError=t.NotImplementedError=t.ReadonlyError=t.CancellationError=t.errorHandler=t.ErrorHandler=void 0,t.setUnexpectedErrorHandler=n,t.isSigPipeError=O,t.onUnexpectedError=I,t.onUnexpectedExternalError=N,t.transformErrorForSerialization=b,t.transformErrorFromSerialization=w,t.isCancellationError=m,t.canceled=g,t.illegalArgument=d,t.illegalState=e,t.getErrorMessage=r;class i{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(a){setTimeout(()=>{throw a.stack?A.isErrorNoTelemetry(a)?new A(a.message+`

`+a.stack):new Error(a.message+`

`+a.stack):a},0)}}addListener(a){return this.listeners.push(a),()=>{this._removeListener(a)}}emit(a){this.listeners.forEach(f=>{f(a)})}_removeListener(a){this.listeners.splice(this.listeners.indexOf(a),1)}setUnexpectedErrorHandler(a){this.unexpectedErrorHandler=a}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(a){this.unexpectedErrorHandler(a),this.emit(a)}onUnexpectedExternalError(a){this.unexpectedErrorHandler(a)}}t.ErrorHandler=i,t.errorHandler=new i;function n(c){t.errorHandler.setUnexpectedErrorHandler(c)}function O(c){if(!c||typeof c!="object")return!1;const a=c;return a.code==="EPIPE"&&a.syscall?.toUpperCase()==="WRITE"}function I(c){m(c)||t.errorHandler.onUnexpectedError(c)}function N(c){m(c)||t.errorHandler.onUnexpectedExternalError(c)}function b(c){if(c instanceof Error){const{name:a,message:f}=c,_=c.stacktrace||c.stack;return{$isError:!0,name:a,message:f,stack:_,noTelemetry:A.isErrorNoTelemetry(c)}}return c}function w(c){let a;return c.noTelemetry?a=new A:(a=new Error,a.name=c.name),a.message=c.message,a.stack=c.stack,a}const u="Canceled";function m(c){return c instanceof v?!0:c instanceof Error&&c.name===u&&c.message===u}class v extends Error{constructor(){super(u),this.name=this.message}}t.CancellationError=v;function g(){const c=new Error(u);return c.name=c.message,c}function d(c){return c?new Error(`Illegal argument: ${c}`):new Error("Illegal argument")}function e(c){return c?new Error(`Illegal state: ${c}`):new Error("Illegal state")}class s extends TypeError{constructor(a){super(a?`${a} is read-only and cannot be changed`:"Cannot change read-only property")}}t.ReadonlyError=s;function r(c){return c?c.message?c.message:c.stack?c.stack.split(`
`)[0]:String(c):"Error"}class l extends Error{constructor(a){super("NotImplemented"),a&&(this.message=a)}}t.NotImplementedError=l;class o extends Error{constructor(a){super("NotSupported"),a&&(this.message=a)}}t.NotSupportedError=o;class p extends Error{constructor(){super(...arguments),this.isExpected=!0}}t.ExpectedError=p;class A extends Error{constructor(a){super(a),this.name="CodeExpectedError"}static fromError(a){if(a instanceof A)return a;const f=new A;return f.message=a.message,f.stack=a.stack,f}static isErrorNoTelemetry(a){return a.name==="CodeExpectedError"}}t.ErrorNoTelemetry=A;class L extends Error{constructor(a){super(a||"An unexpected bug occurred."),Object.setPrototypeOf(this,L.prototype)}}t.BugIndicatingError=L}),define(_e[9],Se([1,0,6,88]),function(ue,t,i,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Permutation=t.CallbackIterable=t.ArrayQueue=t.booleanComparator=t.numberComparator=t.CompareResult=void 0,t.tail=O,t.tail2=I,t.equals=N,t.removeFastWithoutKeepingOrder=b,t.binarySearch=w,t.binarySearch2=u,t.quickSelect=m,t.groupBy=v,t.groupAdjacentBy=g,t.forEachAdjacent=d,t.forEachWithNeighbors=e,t.sortedDiff=s,t.delta=r,t.top=l,t.topAsync=o,t.coalesce=A,t.coalesceInPlace=L,t.move=c,t.isFalsyOrEmpty=a,t.isNonEmptyArray=f,t.distinct=_,t.uniqueFilter=H,t.firstOrDefault=B,t.lastOrDefault=F,t.commonPrefixLength=E,t.range=k,t.index=W,t.insert=R,t.remove=C,t.arrayInsert=$,t.shuffle=ee,t.pushToStart=Y,t.pushToEnd=Z,t.pushMany=ce,t.mapArrayOrNot=he,t.asArray=ye,t.getRandomElement=Re,t.insertInto=Pe,t.splice=re,t.compareBy=ve,t.tieBreakComparators=Ne,t.reverseOrder=Le,t.findAsync=Xe;function O(oe,x=0){return oe[oe.length-(1+x)]}function I(oe){if(oe.length===0)throw new Error("Invalid tail call");return[oe.slice(0,oe.length-1),oe[oe.length-1]]}function N(oe,x,h=(S,P)=>S===P){if(oe===x)return!0;if(!oe||!x||oe.length!==x.length)return!1;for(let S=0,P=oe.length;S<P;S++)if(!h(oe[S],x[S]))return!1;return!0}function b(oe,x){const h=oe.length-1;x<h&&(oe[x]=oe[h]),oe.pop()}function w(oe,x,h){return u(oe.length,S=>h(oe[S],x))}function u(oe,x){let h=0,S=oe-1;for(;h<=S;){const P=(h+S)/2|0,G=x(P);if(G<0)h=P+1;else if(G>0)S=P-1;else return P}return-(h+1)}function m(oe,x,h){if(oe=oe|0,oe>=x.length)throw new TypeError("invalid index");const S=x[Math.floor(x.length*Math.random())],P=[],G=[],J=[];for(const te of x){const y=h(te,S);y<0?P.push(te):y>0?G.push(te):J.push(te)}return oe<P.length?m(oe,P,h):oe<P.length+J.length?J[0]:m(oe-(P.length+J.length),G,h)}function v(oe,x){const h=[];let S;for(const P of oe.slice(0).sort(x))!S||x(S[0],P)!==0?(S=[P],h.push(S)):S.push(P);return h}function*g(oe,x){let h,S;for(const P of oe)S!==void 0&&x(S,P)?h.push(P):(h&&(yield h),h=[P]),S=P;h&&(yield h)}function d(oe,x){for(let h=0;h<=oe.length;h++)x(h===0?void 0:oe[h-1],h===oe.length?void 0:oe[h])}function e(oe,x){for(let h=0;h<oe.length;h++)x(h===0?void 0:oe[h-1],oe[h],h+1===oe.length?void 0:oe[h+1])}function s(oe,x,h){const S=[];function P(te,y,D){if(y===0&&D.length===0)return;const z=S[S.length-1];z&&z.start+z.deleteCount===te?(z.deleteCount+=y,z.toInsert.push(...D)):S.push({start:te,deleteCount:y,toInsert:D})}let G=0,J=0;for(;;){if(G===oe.length){P(G,0,x.slice(J));break}if(J===x.length){P(G,oe.length-G,[]);break}const te=oe[G],y=x[J],D=h(te,y);D===0?(G+=1,J+=1):D<0?(P(G,1,[]),G+=1):D>0&&(P(G,0,[y]),J+=1)}return S}function r(oe,x,h){const S=s(oe,x,h),P=[],G=[];for(const J of S)P.push(...oe.slice(J.start,J.start+J.deleteCount)),G.push(...J.toInsert);return{removed:P,added:G}}function l(oe,x,h){if(h===0)return[];const S=oe.slice(0,h).sort(x);return p(oe,x,S,h,oe.length),S}function o(oe,x,h,S,P){return h===0?Promise.resolve([]):new Promise((G,J)=>{(async()=>{const te=oe.length,y=oe.slice(0,h).sort(x);for(let D=h,z=Math.min(h+S,te);D<te;D=z,z=Math.min(z+S,te)){if(D>h&&await new Promise(V=>setTimeout(V)),P&&P.isCancellationRequested)throw new i.CancellationError;p(oe,x,y,D,z)}return y})().then(G,J)})}function p(oe,x,h,S,P){for(const G=h.length;S<P;S++){const J=oe[S];if(x(J,h[G-1])<0){h.pop();const te=(0,n.findFirstIdxMonotonousOrArrLen)(h,y=>x(J,y)<0);h.splice(te,0,J)}}}function A(oe){return oe.filter(x=>!!x)}function L(oe){let x=0;for(let h=0;h<oe.length;h++)oe[h]&&(oe[x]=oe[h],x+=1);oe.length=x}function c(oe,x,h){oe.splice(h,0,oe.splice(x,1)[0])}function a(oe){return!Array.isArray(oe)||oe.length===0}function f(oe){return Array.isArray(oe)&&oe.length>0}function _(oe,x=h=>h){const h=new Set;return oe.filter(S=>{const P=x(S);return h.has(P)?!1:(h.add(P),!0)})}function H(oe){const x=new Set;return h=>{const S=oe(h);return x.has(S)?!1:(x.add(S),!0)}}function B(oe,x){return oe.length>0?oe[0]:x}function F(oe,x){return oe.length>0?oe[oe.length-1]:x}function E(oe,x,h=(S,P)=>S===P){let S=0;for(let P=0,G=Math.min(oe.length,x.length);P<G&&h(oe[P],x[P]);P++)S++;return S}function k(oe,x){let h=typeof x=="number"?oe:0;typeof x=="number"?h=oe:(h=0,x=oe);const S=[];if(h<=x)for(let P=h;P<x;P++)S.push(P);else for(let P=h;P>x;P--)S.push(P);return S}function W(oe,x,h){return oe.reduce((S,P)=>(S[x(P)]=h?h(P):P,S),Object.create(null))}function R(oe,x){return oe.push(x),()=>C(oe,x)}function C(oe,x){const h=oe.indexOf(x);if(h>-1)return oe.splice(h,1),x}function $(oe,x,h){const S=oe.slice(0,x),P=oe.slice(x);return S.concat(h,P)}function ee(oe,x){let h;if(typeof x=="number"){let S=x;h=()=>{const P=Math.sin(S++)*179426549;return P-Math.floor(P)}}else h=Math.random;for(let S=oe.length-1;S>0;S-=1){const P=Math.floor(h()*(S+1)),G=oe[S];oe[S]=oe[P],oe[P]=G}}function Y(oe,x){const h=oe.indexOf(x);h>-1&&(oe.splice(h,1),oe.unshift(x))}function Z(oe,x){const h=oe.indexOf(x);h>-1&&(oe.splice(h,1),oe.push(x))}function ce(oe,x){for(const h of x)oe.push(h)}function he(oe,x){return Array.isArray(oe)?oe.map(x):x(oe)}function ye(oe){return Array.isArray(oe)?oe:[oe]}function Re(oe){return oe[Math.floor(Math.random()*oe.length)]}function Pe(oe,x,h){const S=ie(oe,x),P=oe.length,G=h.length;oe.length=P+G;for(let J=P-1;J>=S;J--)oe[J+G]=oe[J];for(let J=0;J<G;J++)oe[J+S]=h[J]}function re(oe,x,h,S){const P=ie(oe,x);let G=oe.splice(P,h);return G===void 0&&(G=[]),Pe(oe,P,S),G}function ie(oe,x){return x<0?Math.max(x+oe.length,0):Math.min(x,oe.length)}var fe;(function(oe){function x(G){return G<0}oe.isLessThan=x;function h(G){return G<=0}oe.isLessThanOrEqual=h;function S(G){return G>0}oe.isGreaterThan=S;function P(G){return G===0}oe.isNeitherLessOrGreaterThan=P,oe.greaterThan=1,oe.lessThan=-1,oe.neitherLessOrGreaterThan=0})(fe||(t.CompareResult=fe={}));function ve(oe,x){return(h,S)=>x(oe(h),oe(S))}function Ne(...oe){return(x,h)=>{for(const S of oe){const P=S(x,h);if(!fe.isNeitherLessOrGreaterThan(P))return P}return fe.neitherLessOrGreaterThan}}const ne=(oe,x)=>oe-x;t.numberComparator=ne;const Ee=(oe,x)=>(0,t.numberComparator)(oe?1:0,x?1:0);t.booleanComparator=Ee;function Le(oe){return(x,h)=>-oe(x,h)}class Ce{constructor(x){this.items=x,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(x){let h=this.firstIdx;for(;h<this.items.length&&x(this.items[h]);)h++;const S=h===this.firstIdx?null:this.items.slice(this.firstIdx,h);return this.firstIdx=h,S}takeFromEndWhile(x){let h=this.lastIdx;for(;h>=0&&x(this.items[h]);)h--;const S=h===this.lastIdx?null:this.items.slice(h+1,this.lastIdx+1);return this.lastIdx=h,S}peek(){if(this.length!==0)return this.items[this.firstIdx]}peekLast(){if(this.length!==0)return this.items[this.lastIdx]}dequeue(){const x=this.items[this.firstIdx];return this.firstIdx++,x}removeLast(){const x=this.items[this.lastIdx];return this.lastIdx--,x}takeCount(x){const h=this.items.slice(this.firstIdx,this.firstIdx+x);return this.firstIdx+=x,h}}t.ArrayQueue=Ce;class Fe{static{this.empty=new Fe(x=>{})}constructor(x){this.iterate=x}forEach(x){this.iterate(h=>(x(h),!0))}toArray(){const x=[];return this.iterate(h=>(x.push(h),!0)),x}filter(x){return new Fe(h=>this.iterate(S=>x(S)?h(S):!0))}map(x){return new Fe(h=>this.iterate(S=>h(x(S))))}some(x){let h=!1;return this.iterate(S=>(h=x(S),!h)),h}findFirst(x){let h;return this.iterate(S=>x(S)?(h=S,!1):!0),h}findLast(x){let h;return this.iterate(S=>(x(S)&&(h=S),!0)),h}findLastMaxBy(x){let h,S=!0;return this.iterate(P=>((S||fe.isGreaterThan(x(P,h)))&&(S=!1,h=P),!0)),h}}t.CallbackIterable=Fe;class ze{constructor(x){this._indexMap=x}static createSortPermutation(x,h){const S=Array.from(x.keys()).sort((P,G)=>h(x[P],x[G]));return new ze(S)}apply(x){return x.map((h,S)=>x[this._indexMap[S]])}inverse(){const x=this._indexMap.slice();for(let h=0;h<this._indexMap.length;h++)x[this._indexMap[h]]=h;return new ze(x)}}t.Permutation=ze;async function Xe(oe,x){return(await Promise.all(oe.map(async(S,P)=>({element:S,ok:await x(S,P)})))).find(S=>S.ok)?.element}}),define(_e[42],Se([1,0,6]),function(ue,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ok=n,t.assertNever=O,t.assert=I,t.softAssert=N,t.assertFn=b,t.checkAdjacentItems=w;function n(u,m){if(!u)throw new Error(m?`Assertion failed (${m})`:"Assertion Failed")}function O(u,m="Unreachable"){throw new Error(m)}function I(u,m="unexpected state"){if(!u)throw new i.BugIndicatingError(`Assertion Failed: ${m}`)}function N(u){u||(0,i.onUnexpectedError)(new i.BugIndicatingError("Soft Assertion Failed"))}function b(u){if(!u()){debugger;u(),(0,i.onUnexpectedError)(new i.BugIndicatingError("Assertion Failed"))}}function w(u,m){let v=0;for(;v<u.length-1;){const g=u[v],d=u[v+1];if(!m(g,d))return!1;v++}return!0}});var Ri=this&&this.__createBinding||(Object.create?function(ue,t,i,n){n===void 0&&(n=i);var O=Object.getOwnPropertyDescriptor(t,i);(!O||("get"in O?!t.__esModule:O.writable||O.configurable))&&(O={enumerable:!0,get:function(){return t[i]}}),Object.defineProperty(ue,n,O)}:function(ue,t,i,n){n===void 0&&(n=i),ue[n]=t[i]}),Oi=this&&this.__setModuleDefault||(Object.create?function(ue,t){Object.defineProperty(ue,"default",{enumerable:!0,value:t})}:function(ue,t){ue.default=t}),qe=this&&this.__importStar||function(ue){if(ue&&ue.__esModule)return ue;var t={};if(ue!=null)for(var i in ue)i!=="default"&&Object.prototype.hasOwnProperty.call(ue,i)&&Ri(t,ue,i);return Oi(t,ue),t};define(_e[30],Se([1,0,9]),function(ue,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.strictEquals=void 0,t.itemsEquals=O,t.jsonStringifyEquals=I,t.itemEquals=N,t.equalsIfDefined=b,t.structuralEquals=w,t.getStructuralKey=u,i=qe(i);const n=(d,e)=>d===e;t.strictEquals=n;function O(d=t.strictEquals){return(e,s)=>i.equals(e,s,d)}function I(){return(d,e)=>JSON.stringify(d)===JSON.stringify(e)}function N(){return(d,e)=>d.equals(e)}function b(d,e,s){if(s!==void 0){const r=d;return r==null||e===void 0||e===null?e===r:s(r,e)}else{const r=d;return(l,o)=>l==null||o===void 0||o===null?o===l:r(l,o)}}function w(d,e){if(d===e)return!0;if(Array.isArray(d)&&Array.isArray(e)){if(d.length!==e.length)return!1;for(let s=0;s<d.length;s++)if(!w(d[s],e[s]))return!1;return!0}if(d&&typeof d=="object"&&e&&typeof e=="object"&&Object.getPrototypeOf(d)===Object.prototype&&Object.getPrototypeOf(e)===Object.prototype){const s=d,r=e,l=Object.keys(s),o=Object.keys(r),p=new Set(o);if(l.length!==o.length)return!1;for(const A of l)if(!p.has(A)||!w(s[A],r[A]))return!1;return!0}return!1}function u(d){return JSON.stringify(g(d))}let m=0;const v=new WeakMap;function g(d){if(Array.isArray(d))return d.map(g);if(d&&typeof d=="object")if(Object.getPrototypeOf(d)===Object.prototype){const e=d,s=Object.create(null);for(const r of Object.keys(e).sort())s[r]=g(e[r]);return s}else{let e=v.get(d);return e===void 0&&(e=m++,v.set(d,e)),e+"----2b76a038c20c4bcc"}return d}}),define(_e[59],Se([1,0]),function(ue,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.createSingleCallFunction=i;function i(n,O){const I=this;let N=!1,b;return function(){if(N)return b;if(N=!0,O)try{b=n.apply(I,arguments)}finally{O()}else b=n.apply(I,arguments);return b}}}),define(_e[91],Se([1,0]),function(ue,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.defaultGenerator=t.IdGenerator=void 0;class i{constructor(O){this._prefix=O,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}t.IdGenerator=i,t.defaultGenerator=new i("id#")}),define(_e[36],Se([1,0]),function(ue,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Iterable=void 0;var i;(function(n){function O(a){return a&&typeof a=="object"&&typeof a[Symbol.iterator]=="function"}n.is=O;const I=Object.freeze([]);function N(){return I}n.empty=N;function*b(a){yield a}n.single=b;function w(a){return O(a)?a:b(a)}n.wrap=w;function u(a){return a||I}n.from=u;function*m(a){for(let f=a.length-1;f>=0;f--)yield a[f]}n.reverse=m;function v(a){return!a||a[Symbol.iterator]().next().done===!0}n.isEmpty=v;function g(a){return a[Symbol.iterator]().next().value}n.first=g;function d(a,f){let _=0;for(const H of a)if(f(H,_++))return!0;return!1}n.some=d;function e(a,f){for(const _ of a)if(f(_))return _}n.find=e;function*s(a,f){for(const _ of a)f(_)&&(yield _)}n.filter=s;function*r(a,f){let _=0;for(const H of a)yield f(H,_++)}n.map=r;function*l(a,f){let _=0;for(const H of a)yield*f(H,_++)}n.flatMap=l;function*o(...a){for(const f of a)yield*f}n.concat=o;function p(a,f,_){let H=_;for(const B of a)H=f(H,B);return H}n.reduce=p;function*A(a,f,_=a.length){for(f<0&&(f+=a.length),_<0?_+=a.length:_>a.length&&(_=a.length);f<_;f++)yield a[f]}n.slice=A;function L(a,f=Number.POSITIVE_INFINITY){const _=[];if(f===0)return[_,a];const H=a[Symbol.iterator]();for(let B=0;B<f;B++){const F=H.next();if(F.done)return[_,n.empty()];_.push(F.value)}return[_,{[Symbol.iterator](){return H}}]}n.consume=L;async function c(a){const f=[];for await(const _ of a)f.push(_);return Promise.resolve(f)}n.asyncToArray=c})(i||(t.Iterable=i={}))}),define(_e[92],Se([1,0]),function(ue,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getCompressedContent=i;function i(I){let N=!1;const b=new Map,w=new Map;if(O(I,s=>{if(I===s)return!0;const r=JSON.stringify(s);if(r.length<30)return!0;const l=b.get(r);if(!l){const o={schemas:[s]};return b.set(r,o),w.set(s,o),!0}return l.schemas.push(s),w.set(s,l),N=!0,!1}),b.clear(),!N)return JSON.stringify(I);let m="$defs";for(;I.hasOwnProperty(m);)m+="_";const v=[];function g(s){return JSON.stringify(s,(r,l)=>{if(l!==s){const o=w.get(l);if(o&&o.schemas.length>1)return o.id||(o.id=`_${v.length}`,v.push(o.schemas[0])),{$ref:`#/${m}/${o.id}`}}return l})}const d=g(I),e=[];for(let s=0;s<v.length;s++)e.push(`"_${s}":${g(v[s])}`);return e.length?`${d.substring(0,d.length-1)},"${m}":{${e.join(",")}}}`:d}function n(I){return typeof I=="object"&&I!==null}function O(I,N){if(!I||typeof I!="object")return;const b=(...d)=>{for(const e of d)n(e)&&v.push(e)},w=(...d)=>{for(const e of d)if(n(e))for(const s in e){const r=e[s];n(r)&&v.push(r)}},u=(...d)=>{for(const e of d)if(Array.isArray(e))for(const s of e)n(s)&&v.push(s)},m=d=>{if(Array.isArray(d))for(const e of d)n(e)&&v.push(e);else n(d)&&v.push(d)},v=[I];let g=v.pop();for(;g;)N(g)&&(b(g.additionalItems,g.additionalProperties,g.not,g.contains,g.propertyNames,g.if,g.then,g.else,g.unevaluatedItems,g.unevaluatedProperties),w(g.definitions,g.$defs,g.properties,g.patternProperties,g.dependencies,g.dependentSchemas),u(g.anyOf,g.allOf,g.oneOf,g.prefixItems),m(g.items)),g=v.pop()}}),define(_e[8],Se([1,0]),function(ue,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.KeyMod=t.KeyCodeUtils=t.IMMUTABLE_KEY_CODE_TO_CODE=t.IMMUTABLE_CODE_TO_KEY_CODE=t.ScanCodeUtils=t.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE=t.EVENT_KEY_CODE_MAP=t.ScanCode=t.KeyCode=void 0,t.KeyChord=d;var i;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.Unknown=0]="Unknown",e[e.Backspace=1]="Backspace",e[e.Tab=2]="Tab",e[e.Enter=3]="Enter",e[e.Shift=4]="Shift",e[e.Ctrl=5]="Ctrl",e[e.Alt=6]="Alt",e[e.PauseBreak=7]="PauseBreak",e[e.CapsLock=8]="CapsLock",e[e.Escape=9]="Escape",e[e.Space=10]="Space",e[e.PageUp=11]="PageUp",e[e.PageDown=12]="PageDown",e[e.End=13]="End",e[e.Home=14]="Home",e[e.LeftArrow=15]="LeftArrow",e[e.UpArrow=16]="UpArrow",e[e.RightArrow=17]="RightArrow",e[e.DownArrow=18]="DownArrow",e[e.Insert=19]="Insert",e[e.Delete=20]="Delete",e[e.Digit0=21]="Digit0",e[e.Digit1=22]="Digit1",e[e.Digit2=23]="Digit2",e[e.Digit3=24]="Digit3",e[e.Digit4=25]="Digit4",e[e.Digit5=26]="Digit5",e[e.Digit6=27]="Digit6",e[e.Digit7=28]="Digit7",e[e.Digit8=29]="Digit8",e[e.Digit9=30]="Digit9",e[e.KeyA=31]="KeyA",e[e.KeyB=32]="KeyB",e[e.KeyC=33]="KeyC",e[e.KeyD=34]="KeyD",e[e.KeyE=35]="KeyE",e[e.KeyF=36]="KeyF",e[e.KeyG=37]="KeyG",e[e.KeyH=38]="KeyH",e[e.KeyI=39]="KeyI",e[e.KeyJ=40]="KeyJ",e[e.KeyK=41]="KeyK",e[e.KeyL=42]="KeyL",e[e.KeyM=43]="KeyM",e[e.KeyN=44]="KeyN",e[e.KeyO=45]="KeyO",e[e.KeyP=46]="KeyP",e[e.KeyQ=47]="KeyQ",e[e.KeyR=48]="KeyR",e[e.KeyS=49]="KeyS",e[e.KeyT=50]="KeyT",e[e.KeyU=51]="KeyU",e[e.KeyV=52]="KeyV",e[e.KeyW=53]="KeyW",e[e.KeyX=54]="KeyX",e[e.KeyY=55]="KeyY",e[e.KeyZ=56]="KeyZ",e[e.Meta=57]="Meta",e[e.ContextMenu=58]="ContextMenu",e[e.F1=59]="F1",e[e.F2=60]="F2",e[e.F3=61]="F3",e[e.F4=62]="F4",e[e.F5=63]="F5",e[e.F6=64]="F6",e[e.F7=65]="F7",e[e.F8=66]="F8",e[e.F9=67]="F9",e[e.F10=68]="F10",e[e.F11=69]="F11",e[e.F12=70]="F12",e[e.F13=71]="F13",e[e.F14=72]="F14",e[e.F15=73]="F15",e[e.F16=74]="F16",e[e.F17=75]="F17",e[e.F18=76]="F18",e[e.F19=77]="F19",e[e.F20=78]="F20",e[e.F21=79]="F21",e[e.F22=80]="F22",e[e.F23=81]="F23",e[e.F24=82]="F24",e[e.NumLock=83]="NumLock",e[e.ScrollLock=84]="ScrollLock",e[e.Semicolon=85]="Semicolon",e[e.Equal=86]="Equal",e[e.Comma=87]="Comma",e[e.Minus=88]="Minus",e[e.Period=89]="Period",e[e.Slash=90]="Slash",e[e.Backquote=91]="Backquote",e[e.BracketLeft=92]="BracketLeft",e[e.Backslash=93]="Backslash",e[e.BracketRight=94]="BracketRight",e[e.Quote=95]="Quote",e[e.OEM_8=96]="OEM_8",e[e.IntlBackslash=97]="IntlBackslash",e[e.Numpad0=98]="Numpad0",e[e.Numpad1=99]="Numpad1",e[e.Numpad2=100]="Numpad2",e[e.Numpad3=101]="Numpad3",e[e.Numpad4=102]="Numpad4",e[e.Numpad5=103]="Numpad5",e[e.Numpad6=104]="Numpad6",e[e.Numpad7=105]="Numpad7",e[e.Numpad8=106]="Numpad8",e[e.Numpad9=107]="Numpad9",e[e.NumpadMultiply=108]="NumpadMultiply",e[e.NumpadAdd=109]="NumpadAdd",e[e.NUMPAD_SEPARATOR=110]="NUMPAD_SEPARATOR",e[e.NumpadSubtract=111]="NumpadSubtract",e[e.NumpadDecimal=112]="NumpadDecimal",e[e.NumpadDivide=113]="NumpadDivide",e[e.KEY_IN_COMPOSITION=114]="KEY_IN_COMPOSITION",e[e.ABNT_C1=115]="ABNT_C1",e[e.ABNT_C2=116]="ABNT_C2",e[e.AudioVolumeMute=117]="AudioVolumeMute",e[e.AudioVolumeUp=118]="AudioVolumeUp",e[e.AudioVolumeDown=119]="AudioVolumeDown",e[e.BrowserSearch=120]="BrowserSearch",e[e.BrowserHome=121]="BrowserHome",e[e.BrowserBack=122]="BrowserBack",e[e.BrowserForward=123]="BrowserForward",e[e.MediaTrackNext=124]="MediaTrackNext",e[e.MediaTrackPrevious=125]="MediaTrackPrevious",e[e.MediaStop=126]="MediaStop",e[e.MediaPlayPause=127]="MediaPlayPause",e[e.LaunchMediaPlayer=128]="LaunchMediaPlayer",e[e.LaunchMail=129]="LaunchMail",e[e.LaunchApp2=130]="LaunchApp2",e[e.Clear=131]="Clear",e[e.MAX_VALUE=132]="MAX_VALUE"})(i||(t.KeyCode=i={}));var n;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.None=0]="None",e[e.Hyper=1]="Hyper",e[e.Super=2]="Super",e[e.Fn=3]="Fn",e[e.FnLock=4]="FnLock",e[e.Suspend=5]="Suspend",e[e.Resume=6]="Resume",e[e.Turbo=7]="Turbo",e[e.Sleep=8]="Sleep",e[e.WakeUp=9]="WakeUp",e[e.KeyA=10]="KeyA",e[e.KeyB=11]="KeyB",e[e.KeyC=12]="KeyC",e[e.KeyD=13]="KeyD",e[e.KeyE=14]="KeyE",e[e.KeyF=15]="KeyF",e[e.KeyG=16]="KeyG",e[e.KeyH=17]="KeyH",e[e.KeyI=18]="KeyI",e[e.KeyJ=19]="KeyJ",e[e.KeyK=20]="KeyK",e[e.KeyL=21]="KeyL",e[e.KeyM=22]="KeyM",e[e.KeyN=23]="KeyN",e[e.KeyO=24]="KeyO",e[e.KeyP=25]="KeyP",e[e.KeyQ=26]="KeyQ",e[e.KeyR=27]="KeyR",e[e.KeyS=28]="KeyS",e[e.KeyT=29]="KeyT",e[e.KeyU=30]="KeyU",e[e.KeyV=31]="KeyV",e[e.KeyW=32]="KeyW",e[e.KeyX=33]="KeyX",e[e.KeyY=34]="KeyY",e[e.KeyZ=35]="KeyZ",e[e.Digit1=36]="Digit1",e[e.Digit2=37]="Digit2",e[e.Digit3=38]="Digit3",e[e.Digit4=39]="Digit4",e[e.Digit5=40]="Digit5",e[e.Digit6=41]="Digit6",e[e.Digit7=42]="Digit7",e[e.Digit8=43]="Digit8",e[e.Digit9=44]="Digit9",e[e.Digit0=45]="Digit0",e[e.Enter=46]="Enter",e[e.Escape=47]="Escape",e[e.Backspace=48]="Backspace",e[e.Tab=49]="Tab",e[e.Space=50]="Space",e[e.Minus=51]="Minus",e[e.Equal=52]="Equal",e[e.BracketLeft=53]="BracketLeft",e[e.BracketRight=54]="BracketRight",e[e.Backslash=55]="Backslash",e[e.IntlHash=56]="IntlHash",e[e.Semicolon=57]="Semicolon",e[e.Quote=58]="Quote",e[e.Backquote=59]="Backquote",e[e.Comma=60]="Comma",e[e.Period=61]="Period",e[e.Slash=62]="Slash",e[e.CapsLock=63]="CapsLock",e[e.F1=64]="F1",e[e.F2=65]="F2",e[e.F3=66]="F3",e[e.F4=67]="F4",e[e.F5=68]="F5",e[e.F6=69]="F6",e[e.F7=70]="F7",e[e.F8=71]="F8",e[e.F9=72]="F9",e[e.F10=73]="F10",e[e.F11=74]="F11",e[e.F12=75]="F12",e[e.PrintScreen=76]="PrintScreen",e[e.ScrollLock=77]="ScrollLock",e[e.Pause=78]="Pause",e[e.Insert=79]="Insert",e[e.Home=80]="Home",e[e.PageUp=81]="PageUp",e[e.Delete=82]="Delete",e[e.End=83]="End",e[e.PageDown=84]="PageDown",e[e.ArrowRight=85]="ArrowRight",e[e.ArrowLeft=86]="ArrowLeft",e[e.ArrowDown=87]="ArrowDown",e[e.ArrowUp=88]="ArrowUp",e[e.NumLock=89]="NumLock",e[e.NumpadDivide=90]="NumpadDivide",e[e.NumpadMultiply=91]="NumpadMultiply",e[e.NumpadSubtract=92]="NumpadSubtract",e[e.NumpadAdd=93]="NumpadAdd",e[e.NumpadEnter=94]="NumpadEnter",e[e.Numpad1=95]="Numpad1",e[e.Numpad2=96]="Numpad2",e[e.Numpad3=97]="Numpad3",e[e.Numpad4=98]="Numpad4",e[e.Numpad5=99]="Numpad5",e[e.Numpad6=100]="Numpad6",e[e.Numpad7=101]="Numpad7",e[e.Numpad8=102]="Numpad8",e[e.Numpad9=103]="Numpad9",e[e.Numpad0=104]="Numpad0",e[e.NumpadDecimal=105]="NumpadDecimal",e[e.IntlBackslash=106]="IntlBackslash",e[e.ContextMenu=107]="ContextMenu",e[e.Power=108]="Power",e[e.NumpadEqual=109]="NumpadEqual",e[e.F13=110]="F13",e[e.F14=111]="F14",e[e.F15=112]="F15",e[e.F16=113]="F16",e[e.F17=114]="F17",e[e.F18=115]="F18",e[e.F19=116]="F19",e[e.F20=117]="F20",e[e.F21=118]="F21",e[e.F22=119]="F22",e[e.F23=120]="F23",e[e.F24=121]="F24",e[e.Open=122]="Open",e[e.Help=123]="Help",e[e.Select=124]="Select",e[e.Again=125]="Again",e[e.Undo=126]="Undo",e[e.Cut=127]="Cut",e[e.Copy=128]="Copy",e[e.Paste=129]="Paste",e[e.Find=130]="Find",e[e.AudioVolumeMute=131]="AudioVolumeMute",e[e.AudioVolumeUp=132]="AudioVolumeUp",e[e.AudioVolumeDown=133]="AudioVolumeDown",e[e.NumpadComma=134]="NumpadComma",e[e.IntlRo=135]="IntlRo",e[e.KanaMode=136]="KanaMode",e[e.IntlYen=137]="IntlYen",e[e.Convert=138]="Convert",e[e.NonConvert=139]="NonConvert",e[e.Lang1=140]="Lang1",e[e.Lang2=141]="Lang2",e[e.Lang3=142]="Lang3",e[e.Lang4=143]="Lang4",e[e.Lang5=144]="Lang5",e[e.Abort=145]="Abort",e[e.Props=146]="Props",e[e.NumpadParenLeft=147]="NumpadParenLeft",e[e.NumpadParenRight=148]="NumpadParenRight",e[e.NumpadBackspace=149]="NumpadBackspace",e[e.NumpadMemoryStore=150]="NumpadMemoryStore",e[e.NumpadMemoryRecall=151]="NumpadMemoryRecall",e[e.NumpadMemoryClear=152]="NumpadMemoryClear",e[e.NumpadMemoryAdd=153]="NumpadMemoryAdd",e[e.NumpadMemorySubtract=154]="NumpadMemorySubtract",e[e.NumpadClear=155]="NumpadClear",e[e.NumpadClearEntry=156]="NumpadClearEntry",e[e.ControlLeft=157]="ControlLeft",e[e.ShiftLeft=158]="ShiftLeft",e[e.AltLeft=159]="AltLeft",e[e.MetaLeft=160]="MetaLeft",e[e.ControlRight=161]="ControlRight",e[e.ShiftRight=162]="ShiftRight",e[e.AltRight=163]="AltRight",e[e.MetaRight=164]="MetaRight",e[e.BrightnessUp=165]="BrightnessUp",e[e.BrightnessDown=166]="BrightnessDown",e[e.MediaPlay=167]="MediaPlay",e[e.MediaRecord=168]="MediaRecord",e[e.MediaFastForward=169]="MediaFastForward",e[e.MediaRewind=170]="MediaRewind",e[e.MediaTrackNext=171]="MediaTrackNext",e[e.MediaTrackPrevious=172]="MediaTrackPrevious",e[e.MediaStop=173]="MediaStop",e[e.Eject=174]="Eject",e[e.MediaPlayPause=175]="MediaPlayPause",e[e.MediaSelect=176]="MediaSelect",e[e.LaunchMail=177]="LaunchMail",e[e.LaunchApp2=178]="LaunchApp2",e[e.LaunchApp1=179]="LaunchApp1",e[e.SelectTask=180]="SelectTask",e[e.LaunchScreenSaver=181]="LaunchScreenSaver",e[e.BrowserSearch=182]="BrowserSearch",e[e.BrowserHome=183]="BrowserHome",e[e.BrowserBack=184]="BrowserBack",e[e.BrowserForward=185]="BrowserForward",e[e.BrowserStop=186]="BrowserStop",e[e.BrowserRefresh=187]="BrowserRefresh",e[e.BrowserFavorites=188]="BrowserFavorites",e[e.ZoomToggle=189]="ZoomToggle",e[e.MailReply=190]="MailReply",e[e.MailForward=191]="MailForward",e[e.MailSend=192]="MailSend",e[e.MAX_VALUE=193]="MAX_VALUE"})(n||(t.ScanCode=n={}));class O{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(s,r){this._keyCodeToStr[s]=r,this._strToKeyCode[r.toLowerCase()]=s}keyCodeToStr(s){return this._keyCodeToStr[s]}strToKeyCode(s){return this._strToKeyCode[s.toLowerCase()]||i.Unknown}}const I=new O,N=new O,b=new O;t.EVENT_KEY_CODE_MAP=new Array(230),t.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE={};const w=[],u=Object.create(null),m=Object.create(null);t.ScanCodeUtils={lowerCaseToEnum:e=>m[e]||n.None,toEnum:e=>u[e]||n.None,toString:e=>w[e]||"None"},t.IMMUTABLE_CODE_TO_KEY_CODE=[],t.IMMUTABLE_KEY_CODE_TO_CODE=[];for(let e=0;e<=n.MAX_VALUE;e++)t.IMMUTABLE_CODE_TO_KEY_CODE[e]=i.DependsOnKbLayout;for(let e=0;e<=i.MAX_VALUE;e++)t.IMMUTABLE_KEY_CODE_TO_CODE[e]=n.DependsOnKbLayout;(function(){const e="",s=[[1,n.None,"None",i.Unknown,"unknown",0,"VK_UNKNOWN",e,e],[1,n.Hyper,"Hyper",i.Unknown,e,0,e,e,e],[1,n.Super,"Super",i.Unknown,e,0,e,e,e],[1,n.Fn,"Fn",i.Unknown,e,0,e,e,e],[1,n.FnLock,"FnLock",i.Unknown,e,0,e,e,e],[1,n.Suspend,"Suspend",i.Unknown,e,0,e,e,e],[1,n.Resume,"Resume",i.Unknown,e,0,e,e,e],[1,n.Turbo,"Turbo",i.Unknown,e,0,e,e,e],[1,n.Sleep,"Sleep",i.Unknown,e,0,"VK_SLEEP",e,e],[1,n.WakeUp,"WakeUp",i.Unknown,e,0,e,e,e],[0,n.KeyA,"KeyA",i.KeyA,"A",65,"VK_A",e,e],[0,n.KeyB,"KeyB",i.KeyB,"B",66,"VK_B",e,e],[0,n.KeyC,"KeyC",i.KeyC,"C",67,"VK_C",e,e],[0,n.KeyD,"KeyD",i.KeyD,"D",68,"VK_D",e,e],[0,n.KeyE,"KeyE",i.KeyE,"E",69,"VK_E",e,e],[0,n.KeyF,"KeyF",i.KeyF,"F",70,"VK_F",e,e],[0,n.KeyG,"KeyG",i.KeyG,"G",71,"VK_G",e,e],[0,n.KeyH,"KeyH",i.KeyH,"H",72,"VK_H",e,e],[0,n.KeyI,"KeyI",i.KeyI,"I",73,"VK_I",e,e],[0,n.KeyJ,"KeyJ",i.KeyJ,"J",74,"VK_J",e,e],[0,n.KeyK,"KeyK",i.KeyK,"K",75,"VK_K",e,e],[0,n.KeyL,"KeyL",i.KeyL,"L",76,"VK_L",e,e],[0,n.KeyM,"KeyM",i.KeyM,"M",77,"VK_M",e,e],[0,n.KeyN,"KeyN",i.KeyN,"N",78,"VK_N",e,e],[0,n.KeyO,"KeyO",i.KeyO,"O",79,"VK_O",e,e],[0,n.KeyP,"KeyP",i.KeyP,"P",80,"VK_P",e,e],[0,n.KeyQ,"KeyQ",i.KeyQ,"Q",81,"VK_Q",e,e],[0,n.KeyR,"KeyR",i.KeyR,"R",82,"VK_R",e,e],[0,n.KeyS,"KeyS",i.KeyS,"S",83,"VK_S",e,e],[0,n.KeyT,"KeyT",i.KeyT,"T",84,"VK_T",e,e],[0,n.KeyU,"KeyU",i.KeyU,"U",85,"VK_U",e,e],[0,n.KeyV,"KeyV",i.KeyV,"V",86,"VK_V",e,e],[0,n.KeyW,"KeyW",i.KeyW,"W",87,"VK_W",e,e],[0,n.KeyX,"KeyX",i.KeyX,"X",88,"VK_X",e,e],[0,n.KeyY,"KeyY",i.KeyY,"Y",89,"VK_Y",e,e],[0,n.KeyZ,"KeyZ",i.KeyZ,"Z",90,"VK_Z",e,e],[0,n.Digit1,"Digit1",i.Digit1,"1",49,"VK_1",e,e],[0,n.Digit2,"Digit2",i.Digit2,"2",50,"VK_2",e,e],[0,n.Digit3,"Digit3",i.Digit3,"3",51,"VK_3",e,e],[0,n.Digit4,"Digit4",i.Digit4,"4",52,"VK_4",e,e],[0,n.Digit5,"Digit5",i.Digit5,"5",53,"VK_5",e,e],[0,n.Digit6,"Digit6",i.Digit6,"6",54,"VK_6",e,e],[0,n.Digit7,"Digit7",i.Digit7,"7",55,"VK_7",e,e],[0,n.Digit8,"Digit8",i.Digit8,"8",56,"VK_8",e,e],[0,n.Digit9,"Digit9",i.Digit9,"9",57,"VK_9",e,e],[0,n.Digit0,"Digit0",i.Digit0,"0",48,"VK_0",e,e],[1,n.Enter,"Enter",i.Enter,"Enter",13,"VK_RETURN",e,e],[1,n.Escape,"Escape",i.Escape,"Escape",27,"VK_ESCAPE",e,e],[1,n.Backspace,"Backspace",i.Backspace,"Backspace",8,"VK_BACK",e,e],[1,n.Tab,"Tab",i.Tab,"Tab",9,"VK_TAB",e,e],[1,n.Space,"Space",i.Space,"Space",32,"VK_SPACE",e,e],[0,n.Minus,"Minus",i.Minus,"-",189,"VK_OEM_MINUS","-","OEM_MINUS"],[0,n.Equal,"Equal",i.Equal,"=",187,"VK_OEM_PLUS","=","OEM_PLUS"],[0,n.BracketLeft,"BracketLeft",i.BracketLeft,"[",219,"VK_OEM_4","[","OEM_4"],[0,n.BracketRight,"BracketRight",i.BracketRight,"]",221,"VK_OEM_6","]","OEM_6"],[0,n.Backslash,"Backslash",i.Backslash,"\\",220,"VK_OEM_5","\\","OEM_5"],[0,n.IntlHash,"IntlHash",i.Unknown,e,0,e,e,e],[0,n.Semicolon,"Semicolon",i.Semicolon,";",186,"VK_OEM_1",";","OEM_1"],[0,n.Quote,"Quote",i.Quote,"'",222,"VK_OEM_7","'","OEM_7"],[0,n.Backquote,"Backquote",i.Backquote,"`",192,"VK_OEM_3","`","OEM_3"],[0,n.Comma,"Comma",i.Comma,",",188,"VK_OEM_COMMA",",","OEM_COMMA"],[0,n.Period,"Period",i.Period,".",190,"VK_OEM_PERIOD",".","OEM_PERIOD"],[0,n.Slash,"Slash",i.Slash,"/",191,"VK_OEM_2","/","OEM_2"],[1,n.CapsLock,"CapsLock",i.CapsLock,"CapsLock",20,"VK_CAPITAL",e,e],[1,n.F1,"F1",i.F1,"F1",112,"VK_F1",e,e],[1,n.F2,"F2",i.F2,"F2",113,"VK_F2",e,e],[1,n.F3,"F3",i.F3,"F3",114,"VK_F3",e,e],[1,n.F4,"F4",i.F4,"F4",115,"VK_F4",e,e],[1,n.F5,"F5",i.F5,"F5",116,"VK_F5",e,e],[1,n.F6,"F6",i.F6,"F6",117,"VK_F6",e,e],[1,n.F7,"F7",i.F7,"F7",118,"VK_F7",e,e],[1,n.F8,"F8",i.F8,"F8",119,"VK_F8",e,e],[1,n.F9,"F9",i.F9,"F9",120,"VK_F9",e,e],[1,n.F10,"F10",i.F10,"F10",121,"VK_F10",e,e],[1,n.F11,"F11",i.F11,"F11",122,"VK_F11",e,e],[1,n.F12,"F12",i.F12,"F12",123,"VK_F12",e,e],[1,n.PrintScreen,"PrintScreen",i.Unknown,e,0,e,e,e],[1,n.ScrollLock,"ScrollLock",i.ScrollLock,"ScrollLock",145,"VK_SCROLL",e,e],[1,n.Pause,"Pause",i.PauseBreak,"PauseBreak",19,"VK_PAUSE",e,e],[1,n.Insert,"Insert",i.Insert,"Insert",45,"VK_INSERT",e,e],[1,n.Home,"Home",i.Home,"Home",36,"VK_HOME",e,e],[1,n.PageUp,"PageUp",i.PageUp,"PageUp",33,"VK_PRIOR",e,e],[1,n.Delete,"Delete",i.Delete,"Delete",46,"VK_DELETE",e,e],[1,n.End,"End",i.End,"End",35,"VK_END",e,e],[1,n.PageDown,"PageDown",i.PageDown,"PageDown",34,"VK_NEXT",e,e],[1,n.ArrowRight,"ArrowRight",i.RightArrow,"RightArrow",39,"VK_RIGHT","Right",e],[1,n.ArrowLeft,"ArrowLeft",i.LeftArrow,"LeftArrow",37,"VK_LEFT","Left",e],[1,n.ArrowDown,"ArrowDown",i.DownArrow,"DownArrow",40,"VK_DOWN","Down",e],[1,n.ArrowUp,"ArrowUp",i.UpArrow,"UpArrow",38,"VK_UP","Up",e],[1,n.NumLock,"NumLock",i.NumLock,"NumLock",144,"VK_NUMLOCK",e,e],[1,n.NumpadDivide,"NumpadDivide",i.NumpadDivide,"NumPad_Divide",111,"VK_DIVIDE",e,e],[1,n.NumpadMultiply,"NumpadMultiply",i.NumpadMultiply,"NumPad_Multiply",106,"VK_MULTIPLY",e,e],[1,n.NumpadSubtract,"NumpadSubtract",i.NumpadSubtract,"NumPad_Subtract",109,"VK_SUBTRACT",e,e],[1,n.NumpadAdd,"NumpadAdd",i.NumpadAdd,"NumPad_Add",107,"VK_ADD",e,e],[1,n.NumpadEnter,"NumpadEnter",i.Enter,e,0,e,e,e],[1,n.Numpad1,"Numpad1",i.Numpad1,"NumPad1",97,"VK_NUMPAD1",e,e],[1,n.Numpad2,"Numpad2",i.Numpad2,"NumPad2",98,"VK_NUMPAD2",e,e],[1,n.Numpad3,"Numpad3",i.Numpad3,"NumPad3",99,"VK_NUMPAD3",e,e],[1,n.Numpad4,"Numpad4",i.Numpad4,"NumPad4",100,"VK_NUMPAD4",e,e],[1,n.Numpad5,"Numpad5",i.Numpad5,"NumPad5",101,"VK_NUMPAD5",e,e],[1,n.Numpad6,"Numpad6",i.Numpad6,"NumPad6",102,"VK_NUMPAD6",e,e],[1,n.Numpad7,"Numpad7",i.Numpad7,"NumPad7",103,"VK_NUMPAD7",e,e],[1,n.Numpad8,"Numpad8",i.Numpad8,"NumPad8",104,"VK_NUMPAD8",e,e],[1,n.Numpad9,"Numpad9",i.Numpad9,"NumPad9",105,"VK_NUMPAD9",e,e],[1,n.Numpad0,"Numpad0",i.Numpad0,"NumPad0",96,"VK_NUMPAD0",e,e],[1,n.NumpadDecimal,"NumpadDecimal",i.NumpadDecimal,"NumPad_Decimal",110,"VK_DECIMAL",e,e],[0,n.IntlBackslash,"IntlBackslash",i.IntlBackslash,"OEM_102",226,"VK_OEM_102",e,e],[1,n.ContextMenu,"ContextMenu",i.ContextMenu,"ContextMenu",93,e,e,e],[1,n.Power,"Power",i.Unknown,e,0,e,e,e],[1,n.NumpadEqual,"NumpadEqual",i.Unknown,e,0,e,e,e],[1,n.F13,"F13",i.F13,"F13",124,"VK_F13",e,e],[1,n.F14,"F14",i.F14,"F14",125,"VK_F14",e,e],[1,n.F15,"F15",i.F15,"F15",126,"VK_F15",e,e],[1,n.F16,"F16",i.F16,"F16",127,"VK_F16",e,e],[1,n.F17,"F17",i.F17,"F17",128,"VK_F17",e,e],[1,n.F18,"F18",i.F18,"F18",129,"VK_F18",e,e],[1,n.F19,"F19",i.F19,"F19",130,"VK_F19",e,e],[1,n.F20,"F20",i.F20,"F20",131,"VK_F20",e,e],[1,n.F21,"F21",i.F21,"F21",132,"VK_F21",e,e],[1,n.F22,"F22",i.F22,"F22",133,"VK_F22",e,e],[1,n.F23,"F23",i.F23,"F23",134,"VK_F23",e,e],[1,n.F24,"F24",i.F24,"F24",135,"VK_F24",e,e],[1,n.Open,"Open",i.Unknown,e,0,e,e,e],[1,n.Help,"Help",i.Unknown,e,0,e,e,e],[1,n.Select,"Select",i.Unknown,e,0,e,e,e],[1,n.Again,"Again",i.Unknown,e,0,e,e,e],[1,n.Undo,"Undo",i.Unknown,e,0,e,e,e],[1,n.Cut,"Cut",i.Unknown,e,0,e,e,e],[1,n.Copy,"Copy",i.Unknown,e,0,e,e,e],[1,n.Paste,"Paste",i.Unknown,e,0,e,e,e],[1,n.Find,"Find",i.Unknown,e,0,e,e,e],[1,n.AudioVolumeMute,"AudioVolumeMute",i.AudioVolumeMute,"AudioVolumeMute",173,"VK_VOLUME_MUTE",e,e],[1,n.AudioVolumeUp,"AudioVolumeUp",i.AudioVolumeUp,"AudioVolumeUp",175,"VK_VOLUME_UP",e,e],[1,n.AudioVolumeDown,"AudioVolumeDown",i.AudioVolumeDown,"AudioVolumeDown",174,"VK_VOLUME_DOWN",e,e],[1,n.NumpadComma,"NumpadComma",i.NUMPAD_SEPARATOR,"NumPad_Separator",108,"VK_SEPARATOR",e,e],[0,n.IntlRo,"IntlRo",i.ABNT_C1,"ABNT_C1",193,"VK_ABNT_C1",e,e],[1,n.KanaMode,"KanaMode",i.Unknown,e,0,e,e,e],[0,n.IntlYen,"IntlYen",i.Unknown,e,0,e,e,e],[1,n.Convert,"Convert",i.Unknown,e,0,e,e,e],[1,n.NonConvert,"NonConvert",i.Unknown,e,0,e,e,e],[1,n.Lang1,"Lang1",i.Unknown,e,0,e,e,e],[1,n.Lang2,"Lang2",i.Unknown,e,0,e,e,e],[1,n.Lang3,"Lang3",i.Unknown,e,0,e,e,e],[1,n.Lang4,"Lang4",i.Unknown,e,0,e,e,e],[1,n.Lang5,"Lang5",i.Unknown,e,0,e,e,e],[1,n.Abort,"Abort",i.Unknown,e,0,e,e,e],[1,n.Props,"Props",i.Unknown,e,0,e,e,e],[1,n.NumpadParenLeft,"NumpadParenLeft",i.Unknown,e,0,e,e,e],[1,n.NumpadParenRight,"NumpadParenRight",i.Unknown,e,0,e,e,e],[1,n.NumpadBackspace,"NumpadBackspace",i.Unknown,e,0,e,e,e],[1,n.NumpadMemoryStore,"NumpadMemoryStore",i.Unknown,e,0,e,e,e],[1,n.NumpadMemoryRecall,"NumpadMemoryRecall",i.Unknown,e,0,e,e,e],[1,n.NumpadMemoryClear,"NumpadMemoryClear",i.Unknown,e,0,e,e,e],[1,n.NumpadMemoryAdd,"NumpadMemoryAdd",i.Unknown,e,0,e,e,e],[1,n.NumpadMemorySubtract,"NumpadMemorySubtract",i.Unknown,e,0,e,e,e],[1,n.NumpadClear,"NumpadClear",i.Clear,"Clear",12,"VK_CLEAR",e,e],[1,n.NumpadClearEntry,"NumpadClearEntry",i.Unknown,e,0,e,e,e],[1,n.None,e,i.Ctrl,"Ctrl",17,"VK_CONTROL",e,e],[1,n.None,e,i.Shift,"Shift",16,"VK_SHIFT",e,e],[1,n.None,e,i.Alt,"Alt",18,"VK_MENU",e,e],[1,n.None,e,i.Meta,"Meta",91,"VK_COMMAND",e,e],[1,n.ControlLeft,"ControlLeft",i.Ctrl,e,0,"VK_LCONTROL",e,e],[1,n.ShiftLeft,"ShiftLeft",i.Shift,e,0,"VK_LSHIFT",e,e],[1,n.AltLeft,"AltLeft",i.Alt,e,0,"VK_LMENU",e,e],[1,n.MetaLeft,"MetaLeft",i.Meta,e,0,"VK_LWIN",e,e],[1,n.ControlRight,"ControlRight",i.Ctrl,e,0,"VK_RCONTROL",e,e],[1,n.ShiftRight,"ShiftRight",i.Shift,e,0,"VK_RSHIFT",e,e],[1,n.AltRight,"AltRight",i.Alt,e,0,"VK_RMENU",e,e],[1,n.MetaRight,"MetaRight",i.Meta,e,0,"VK_RWIN",e,e],[1,n.BrightnessUp,"BrightnessUp",i.Unknown,e,0,e,e,e],[1,n.BrightnessDown,"BrightnessDown",i.Unknown,e,0,e,e,e],[1,n.MediaPlay,"MediaPlay",i.Unknown,e,0,e,e,e],[1,n.MediaRecord,"MediaRecord",i.Unknown,e,0,e,e,e],[1,n.MediaFastForward,"MediaFastForward",i.Unknown,e,0,e,e,e],[1,n.MediaRewind,"MediaRewind",i.Unknown,e,0,e,e,e],[1,n.MediaTrackNext,"MediaTrackNext",i.MediaTrackNext,"MediaTrackNext",176,"VK_MEDIA_NEXT_TRACK",e,e],[1,n.MediaTrackPrevious,"MediaTrackPrevious",i.MediaTrackPrevious,"MediaTrackPrevious",177,"VK_MEDIA_PREV_TRACK",e,e],[1,n.MediaStop,"MediaStop",i.MediaStop,"MediaStop",178,"VK_MEDIA_STOP",e,e],[1,n.Eject,"Eject",i.Unknown,e,0,e,e,e],[1,n.MediaPlayPause,"MediaPlayPause",i.MediaPlayPause,"MediaPlayPause",179,"VK_MEDIA_PLAY_PAUSE",e,e],[1,n.MediaSelect,"MediaSelect",i.LaunchMediaPlayer,"LaunchMediaPlayer",181,"VK_MEDIA_LAUNCH_MEDIA_SELECT",e,e],[1,n.LaunchMail,"LaunchMail",i.LaunchMail,"LaunchMail",180,"VK_MEDIA_LAUNCH_MAIL",e,e],[1,n.LaunchApp2,"LaunchApp2",i.LaunchApp2,"LaunchApp2",183,"VK_MEDIA_LAUNCH_APP2",e,e],[1,n.LaunchApp1,"LaunchApp1",i.Unknown,e,0,"VK_MEDIA_LAUNCH_APP1",e,e],[1,n.SelectTask,"SelectTask",i.Unknown,e,0,e,e,e],[1,n.LaunchScreenSaver,"LaunchScreenSaver",i.Unknown,e,0,e,e,e],[1,n.BrowserSearch,"BrowserSearch",i.BrowserSearch,"BrowserSearch",170,"VK_BROWSER_SEARCH",e,e],[1,n.BrowserHome,"BrowserHome",i.BrowserHome,"BrowserHome",172,"VK_BROWSER_HOME",e,e],[1,n.BrowserBack,"BrowserBack",i.BrowserBack,"BrowserBack",166,"VK_BROWSER_BACK",e,e],[1,n.BrowserForward,"BrowserForward",i.BrowserForward,"BrowserForward",167,"VK_BROWSER_FORWARD",e,e],[1,n.BrowserStop,"BrowserStop",i.Unknown,e,0,"VK_BROWSER_STOP",e,e],[1,n.BrowserRefresh,"BrowserRefresh",i.Unknown,e,0,"VK_BROWSER_REFRESH",e,e],[1,n.BrowserFavorites,"BrowserFavorites",i.Unknown,e,0,"VK_BROWSER_FAVORITES",e,e],[1,n.ZoomToggle,"ZoomToggle",i.Unknown,e,0,e,e,e],[1,n.MailReply,"MailReply",i.Unknown,e,0,e,e,e],[1,n.MailForward,"MailForward",i.Unknown,e,0,e,e,e],[1,n.MailSend,"MailSend",i.Unknown,e,0,e,e,e],[1,n.None,e,i.KEY_IN_COMPOSITION,"KeyInComposition",229,e,e,e],[1,n.None,e,i.ABNT_C2,"ABNT_C2",194,"VK_ABNT_C2",e,e],[1,n.None,e,i.OEM_8,"OEM_8",223,"VK_OEM_8",e,e],[1,n.None,e,i.Unknown,e,0,"VK_KANA",e,e],[1,n.None,e,i.Unknown,e,0,"VK_HANGUL",e,e],[1,n.None,e,i.Unknown,e,0,"VK_JUNJA",e,e],[1,n.None,e,i.Unknown,e,0,"VK_FINAL",e,e],[1,n.None,e,i.Unknown,e,0,"VK_HANJA",e,e],[1,n.None,e,i.Unknown,e,0,"VK_KANJI",e,e],[1,n.None,e,i.Unknown,e,0,"VK_CONVERT",e,e],[1,n.None,e,i.Unknown,e,0,"VK_NONCONVERT",e,e],[1,n.None,e,i.Unknown,e,0,"VK_ACCEPT",e,e],[1,n.None,e,i.Unknown,e,0,"VK_MODECHANGE",e,e],[1,n.None,e,i.Unknown,e,0,"VK_SELECT",e,e],[1,n.None,e,i.Unknown,e,0,"VK_PRINT",e,e],[1,n.None,e,i.Unknown,e,0,"VK_EXECUTE",e,e],[1,n.None,e,i.Unknown,e,0,"VK_SNAPSHOT",e,e],[1,n.None,e,i.Unknown,e,0,"VK_HELP",e,e],[1,n.None,e,i.Unknown,e,0,"VK_APPS",e,e],[1,n.None,e,i.Unknown,e,0,"VK_PROCESSKEY",e,e],[1,n.None,e,i.Unknown,e,0,"VK_PACKET",e,e],[1,n.None,e,i.Unknown,e,0,"VK_DBE_SBCSCHAR",e,e],[1,n.None,e,i.Unknown,e,0,"VK_DBE_DBCSCHAR",e,e],[1,n.None,e,i.Unknown,e,0,"VK_ATTN",e,e],[1,n.None,e,i.Unknown,e,0,"VK_CRSEL",e,e],[1,n.None,e,i.Unknown,e,0,"VK_EXSEL",e,e],[1,n.None,e,i.Unknown,e,0,"VK_EREOF",e,e],[1,n.None,e,i.Unknown,e,0,"VK_PLAY",e,e],[1,n.None,e,i.Unknown,e,0,"VK_ZOOM",e,e],[1,n.None,e,i.Unknown,e,0,"VK_NONAME",e,e],[1,n.None,e,i.Unknown,e,0,"VK_PA1",e,e],[1,n.None,e,i.Unknown,e,0,"VK_OEM_CLEAR",e,e]],r=[],l=[];for(const o of s){const[p,A,L,c,a,f,_,H,B]=o;if(l[A]||(l[A]=!0,w[A]=L,u[L]=A,m[L.toLowerCase()]=A,p&&(t.IMMUTABLE_CODE_TO_KEY_CODE[A]=c,c!==i.Unknown&&c!==i.Enter&&c!==i.Ctrl&&c!==i.Shift&&c!==i.Alt&&c!==i.Meta&&(t.IMMUTABLE_KEY_CODE_TO_CODE[c]=A))),!r[c]){if(r[c]=!0,!a)throw new Error(`String representation missing for key code ${c} around scan code ${L}`);I.define(c,a),N.define(c,H||a),b.define(c,B||H||a)}f&&(t.EVENT_KEY_CODE_MAP[f]=c),_&&(t.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE[_]=c)}t.IMMUTABLE_KEY_CODE_TO_CODE[i.Enter]=n.Enter})();var v;(function(e){function s(L){return I.keyCodeToStr(L)}e.toString=s;function r(L){return I.strToKeyCode(L)}e.fromString=r;function l(L){return N.keyCodeToStr(L)}e.toUserSettingsUS=l;function o(L){return b.keyCodeToStr(L)}e.toUserSettingsGeneral=o;function p(L){return N.strToKeyCode(L)||b.strToKeyCode(L)}e.fromUserSettings=p;function A(L){if(L>=i.Numpad0&&L<=i.NumpadDivide)return null;switch(L){case i.UpArrow:return"Up";case i.DownArrow:return"Down";case i.LeftArrow:return"Left";case i.RightArrow:return"Right"}return I.keyCodeToStr(L)}e.toElectronAccelerator=A})(v||(t.KeyCodeUtils=v={}));var g;(function(e){e[e.CtrlCmd=2048]="CtrlCmd",e[e.Shift=1024]="Shift",e[e.Alt=512]="Alt",e[e.WinCtrl=256]="WinCtrl"})(g||(t.KeyMod=g={}));function d(e,s){const r=(s&65535)<<16>>>0;return(e|r)>>>0}}),define(_e[25],Se([1,0]),function(ue,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Lazy=void 0;class i{constructor(O){this.executor=O,this._didRun=!1}get hasValue(){return this._didRun}get value(){if(!this._didRun)try{this._value=this.executor()}catch(O){this._error=O}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}}t.Lazy=i}),define(_e[14],Se([1,0,25]),function(ue,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.setHoverDelegateFactory=b,t.getDefaultHoverDelegate=w,t.createInstantHoverDelegate=u;let O=()=>({get delay(){return-1},dispose:()=>{},showHover:()=>{}});const I=new i.Lazy(()=>O("mouse",!1)),N=new i.Lazy(()=>O("element",!1));function b(m){O=m}function w(m){return m==="element"?N.value:I.value}function u(){return O("element",!0)}}),define(_e[60],Se([1,0]),function(ue,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LinkedList=void 0;class i{static{this.Undefined=new i(void 0)}constructor(I){this.element=I,this.next=i.Undefined,this.prev=i.Undefined}}class n{constructor(){this._first=i.Undefined,this._last=i.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===i.Undefined}clear(){let I=this._first;for(;I!==i.Undefined;){const N=I.next;I.prev=i.Undefined,I.next=i.Undefined,I=N}this._first=i.Undefined,this._last=i.Undefined,this._size=0}unshift(I){return this._insert(I,!1)}push(I){return this._insert(I,!0)}_insert(I,N){const b=new i(I);if(this._first===i.Undefined)this._first=b,this._last=b;else if(N){const u=this._last;this._last=b,b.prev=u,u.next=b}else{const u=this._first;this._first=b,b.next=u,u.prev=b}this._size+=1;let w=!1;return()=>{w||(w=!0,this._remove(b))}}shift(){if(this._first!==i.Undefined){const I=this._first.element;return this._remove(this._first),I}}pop(){if(this._last!==i.Undefined){const I=this._last.element;return this._remove(this._last),I}}_remove(I){if(I.prev!==i.Undefined&&I.next!==i.Undefined){const N=I.prev;N.next=I.next,I.next.prev=N}else I.prev===i.Undefined&&I.next===i.Undefined?(this._first=i.Undefined,this._last=i.Undefined):I.next===i.Undefined?(this._last=this._last.prev,this._last.next=i.Undefined):I.prev===i.Undefined&&(this._first=this._first.next,this._first.prev=i.Undefined);this._size-=1}*[Symbol.iterator](){let I=this._first;for(;I!==i.Undefined;)yield I.element,I=I.next}}t.LinkedList=n}),define(_e[43],Se([1,0]),function(ue,t){"use strict";var i,n,O;Object.defineProperty(t,"__esModule",{value:!0}),t.SetMap=t.BidirectionalMap=t.CounterSet=t.MRUCache=t.LRUCache=t.LinkedMap=t.Touch=t.ResourceSet=t.ResourceMap=void 0,t.getOrSet=I,t.mapToString=N,t.setToString=b,t.mapsStrictEqualIgnoreOrder=A;function I(L,c,a){let f=L.get(c);return f===void 0&&(f=a,L.set(c,f)),f}function N(L){const c=[];return L.forEach((a,f)=>{c.push(`${f} => ${a}`)}),`Map(${L.size}) {${c.join(", ")}}`}function b(L){const c=[];return L.forEach(a=>{c.push(a)}),`Set(${L.size}) {${c.join(", ")}}`}class w{constructor(c,a){this.uri=c,this.value=a}}function u(L){return Array.isArray(L)}class m{static{this.defaultToKey=c=>c.toString()}constructor(c,a){if(this[i]="ResourceMap",c instanceof m)this.map=new Map(c.map),this.toKey=a??m.defaultToKey;else if(u(c)){this.map=new Map,this.toKey=a??m.defaultToKey;for(const[f,_]of c)this.set(f,_)}else this.map=new Map,this.toKey=c??m.defaultToKey}set(c,a){return this.map.set(this.toKey(c),new w(c,a)),this}get(c){return this.map.get(this.toKey(c))?.value}has(c){return this.map.has(this.toKey(c))}get size(){return this.map.size}clear(){this.map.clear()}delete(c){return this.map.delete(this.toKey(c))}forEach(c,a){typeof a<"u"&&(c=c.bind(a));for(const[f,_]of this.map)c(_.value,_.uri,this)}*values(){for(const c of this.map.values())yield c.value}*keys(){for(const c of this.map.values())yield c.uri}*entries(){for(const c of this.map.values())yield[c.uri,c.value]}*[(i=Symbol.toStringTag,Symbol.iterator)](){for(const[,c]of this.map)yield[c.uri,c.value]}}t.ResourceMap=m;class v{constructor(c,a){this[n]="ResourceSet",!c||typeof c=="function"?this._map=new m(c):(this._map=new m(a),c.forEach(this.add,this))}get size(){return this._map.size}add(c){return this._map.set(c,c),this}clear(){this._map.clear()}delete(c){return this._map.delete(c)}forEach(c,a){this._map.forEach((f,_)=>c.call(a,_,_,this))}has(c){return this._map.has(c)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(n=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}t.ResourceSet=v;var g;(function(L){L[L.None=0]="None",L[L.AsOld=1]="AsOld",L[L.AsNew=2]="AsNew"})(g||(t.Touch=g={}));class d{constructor(){this[O]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(c){return this._map.has(c)}get(c,a=g.None){const f=this._map.get(c);if(f)return a!==g.None&&this.touch(f,a),f.value}set(c,a,f=g.None){let _=this._map.get(c);if(_)_.value=a,f!==g.None&&this.touch(_,f);else{switch(_={key:c,value:a,next:void 0,previous:void 0},f){case g.None:this.addItemLast(_);break;case g.AsOld:this.addItemFirst(_);break;case g.AsNew:this.addItemLast(_);break;default:this.addItemLast(_);break}this._map.set(c,_),this._size++}return this}delete(c){return!!this.remove(c)}remove(c){const a=this._map.get(c);if(a)return this._map.delete(c),this.removeItem(a),this._size--,a.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const c=this._head;return this._map.delete(c.key),this.removeItem(c),this._size--,c.value}forEach(c,a){const f=this._state;let _=this._head;for(;_;){if(a?c.bind(a)(_.value,_.key,this):c(_.value,_.key,this),this._state!==f)throw new Error("LinkedMap got modified during iteration.");_=_.next}}keys(){const c=this,a=this._state;let f=this._head;const _={[Symbol.iterator](){return _},next(){if(c._state!==a)throw new Error("LinkedMap got modified during iteration.");if(f){const H={value:f.key,done:!1};return f=f.next,H}else return{value:void 0,done:!0}}};return _}values(){const c=this,a=this._state;let f=this._head;const _={[Symbol.iterator](){return _},next(){if(c._state!==a)throw new Error("LinkedMap got modified during iteration.");if(f){const H={value:f.value,done:!1};return f=f.next,H}else return{value:void 0,done:!0}}};return _}entries(){const c=this,a=this._state;let f=this._head;const _={[Symbol.iterator](){return _},next(){if(c._state!==a)throw new Error("LinkedMap got modified during iteration.");if(f){const H={value:[f.key,f.value],done:!1};return f=f.next,H}else return{value:void 0,done:!0}}};return _}[(O=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(c){if(c>=this.size)return;if(c===0){this.clear();return}let a=this._head,f=this.size;for(;a&&f>c;)this._map.delete(a.key),a=a.next,f--;this._head=a,this._size=f,a&&(a.previous=void 0),this._state++}trimNew(c){if(c>=this.size)return;if(c===0){this.clear();return}let a=this._tail,f=this.size;for(;a&&f>c;)this._map.delete(a.key),a=a.previous,f--;this._tail=a,this._size=f,a&&(a.next=void 0),this._state++}addItemFirst(c){if(!this._head&&!this._tail)this._tail=c;else if(this._head)c.next=this._head,this._head.previous=c;else throw new Error("Invalid list");this._head=c,this._state++}addItemLast(c){if(!this._head&&!this._tail)this._head=c;else if(this._tail)c.previous=this._tail,this._tail.next=c;else throw new Error("Invalid list");this._tail=c,this._state++}removeItem(c){if(c===this._head&&c===this._tail)this._head=void 0,this._tail=void 0;else if(c===this._head){if(!c.next)throw new Error("Invalid list");c.next.previous=void 0,this._head=c.next}else if(c===this._tail){if(!c.previous)throw new Error("Invalid list");c.previous.next=void 0,this._tail=c.previous}else{const a=c.next,f=c.previous;if(!a||!f)throw new Error("Invalid list");a.previous=f,f.next=a}c.next=void 0,c.previous=void 0,this._state++}touch(c,a){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(a!==g.AsOld&&a!==g.AsNew)){if(a===g.AsOld){if(c===this._head)return;const f=c.next,_=c.previous;c===this._tail?(_.next=void 0,this._tail=_):(f.previous=_,_.next=f),c.previous=void 0,c.next=this._head,this._head.previous=c,this._head=c,this._state++}else if(a===g.AsNew){if(c===this._tail)return;const f=c.next,_=c.previous;c===this._head?(f.previous=void 0,this._head=f):(f.previous=_,_.next=f),c.next=void 0,c.previous=this._tail,this._tail.next=c,this._tail=c,this._state++}}}toJSON(){const c=[];return this.forEach((a,f)=>{c.push([f,a])}),c}fromJSON(c){this.clear();for(const[a,f]of c)this.set(a,f)}}t.LinkedMap=d;class e extends d{constructor(c,a=1){super(),this._limit=c,this._ratio=Math.min(Math.max(0,a),1)}get limit(){return this._limit}set limit(c){this._limit=c,this.checkTrim()}get ratio(){return this._ratio}set ratio(c){this._ratio=Math.min(Math.max(0,c),1),this.checkTrim()}get(c,a=g.AsNew){return super.get(c,a)}peek(c){return super.get(c,g.None)}set(c,a){return super.set(c,a,g.AsNew),this}checkTrim(){this.size>this._limit&&this.trim(Math.round(this._limit*this._ratio))}}class s extends e{constructor(c,a=1){super(c,a)}trim(c){this.trimOld(c)}set(c,a){return super.set(c,a),this.checkTrim(),this}}t.LRUCache=s;class r extends e{constructor(c,a=1){super(c,a)}trim(c){this.trimNew(c)}set(c,a){return this._limit<=this.size&&!this.has(c)&&this.trim(Math.round(this._limit*this._ratio)-1),super.set(c,a),this}}t.MRUCache=r;class l{constructor(){this.map=new Map}add(c){return this.map.set(c,(this.map.get(c)||0)+1),this}delete(c){let a=this.map.get(c)||0;return a===0?!1:(a--,a===0?this.map.delete(c):this.map.set(c,a),!0)}has(c){return this.map.has(c)}}t.CounterSet=l;class o{constructor(c){if(this._m1=new Map,this._m2=new Map,c)for(const[a,f]of c)this.set(a,f)}clear(){this._m1.clear(),this._m2.clear()}set(c,a){this._m1.set(c,a),this._m2.set(a,c)}get(c){return this._m1.get(c)}getKey(c){return this._m2.get(c)}delete(c){const a=this._m1.get(c);return a===void 0?!1:(this._m1.delete(c),this._m2.delete(a),!0)}forEach(c,a){this._m1.forEach((f,_)=>{c.call(a,f,_,this)})}keys(){return this._m1.keys()}values(){return this._m1.values()}}t.BidirectionalMap=o;class p{constructor(){this.map=new Map}add(c,a){let f=this.map.get(c);f||(f=new Set,this.map.set(c,f)),f.add(a)}delete(c,a){const f=this.map.get(c);f&&(f.delete(a),f.size===0&&this.map.delete(c))}forEach(c,a){const f=this.map.get(c);f&&f.forEach(a)}get(c){const a=this.map.get(c);return a||new Set}}t.SetMap=p;function A(L,c){if(L===c)return!0;if(L.size!==c.size)return!1;for(const[a,f]of L)if(!c.has(a)||c.get(a)!==f)return!1;for(const[a]of c)if(!L.has(a))return!1;return!0}}),define(_e[2],Se([1,0,9,58,43,59,36]),function(ue,t,i,n,O,I,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DisposableMap=t.ImmortalReference=t.AsyncReferenceCollection=t.ReferenceCollection=t.SafeDisposable=t.RefCountedDisposable=t.MandatoryMutableDisposable=t.MutableDisposable=t.Disposable=t.DisposableStore=t.DisposableTracker=void 0,t.setDisposableTracker=m,t.trackDisposable=v,t.markAsDisposed=g,t.markAsSingleton=s,t.isDisposable=r,t.dispose=l,t.disposeIfDisposable=o,t.combinedDisposable=p,t.toDisposable=A,t.disposeOnReturn=k;const b=!1;let w=null;class u{constructor(){this.livingDisposables=new Map}static{this.idx=0}getDisposableData(C){let $=this.livingDisposables.get(C);return $||($={parent:null,source:null,isSingleton:!1,value:C,idx:u.idx++},this.livingDisposables.set(C,$)),$}trackDisposable(C){const $=this.getDisposableData(C);$.source||($.source=new Error().stack)}setParent(C,$){const ee=this.getDisposableData(C);ee.parent=$}markAsDisposed(C){this.livingDisposables.delete(C)}markAsSingleton(C){this.getDisposableData(C).isSingleton=!0}getRootParent(C,$){const ee=$.get(C);if(ee)return ee;const Y=C.parent?this.getRootParent(this.getDisposableData(C.parent),$):C;return $.set(C,Y),Y}getTrackedDisposables(){const C=new Map;return[...this.livingDisposables.entries()].filter(([,ee])=>ee.source!==null&&!this.getRootParent(ee,C).isSingleton).flatMap(([ee])=>ee)}computeLeakingDisposables(C=10,$){let ee;if($)ee=$;else{const ye=new Map,Re=[...this.livingDisposables.values()].filter(re=>re.source!==null&&!this.getRootParent(re,ye).isSingleton);if(Re.length===0)return;const Pe=new Set(Re.map(re=>re.value));if(ee=Re.filter(re=>!(re.parent&&Pe.has(re.parent))),ee.length===0)throw new Error("There are cyclic diposable chains!")}if(!ee)return;function Y(ye){function Re(re,ie){for(;re.length>0&&ie.some(fe=>typeof fe=="string"?fe===re[0]:re[0].match(fe));)re.shift()}const Pe=ye.source.split(`
`).map(re=>re.trim().replace("at ","")).filter(re=>re!=="");return Re(Pe,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),Pe.reverse()}const Z=new O.SetMap;for(const ye of ee){const Re=Y(ye);for(let Pe=0;Pe<=Re.length;Pe++)Z.add(Re.slice(0,Pe).join(`
`),ye)}ee.sort((0,i.compareBy)(ye=>ye.idx,i.numberComparator));let ce="",he=0;for(const ye of ee.slice(0,C)){he++;const Re=Y(ye),Pe=[];for(let re=0;re<Re.length;re++){let ie=Re[re];ie=`(shared with ${Z.get(Re.slice(0,re+1).join(`
`)).size}/${ee.length} leaks) at ${ie}`;const ve=Z.get(Re.slice(0,re).join(`
`)),Ne=(0,n.groupBy)([...ve].map(ne=>Y(ne)[re]),ne=>ne);delete Ne[Re[re]];for(const[ne,Ee]of Object.entries(Ne))Pe.unshift(`    - stacktraces of ${Ee.length} other leaks continue with ${ne}`);Pe.unshift(ie)}ce+=`


==================== Leaking disposable ${he}/${ee.length}: ${ye.value.constructor.name} ====================
${Pe.join(`
`)}
============================================================

`}return ee.length>C&&(ce+=`


... and ${ee.length-C} more leaking disposables

`),{leaks:ee,details:ce}}}t.DisposableTracker=u;function m(R){w=R}if(b){const R="__is_disposable_tracked__";m(new class{trackDisposable(C){const $=new Error("Potentially leaked disposable").stack;setTimeout(()=>{C[R]||console.log($)},3e3)}setParent(C,$){if(C&&C!==c.None)try{C[R]=!0}catch{}}markAsDisposed(C){if(C&&C!==c.None)try{C[R]=!0}catch{}}markAsSingleton(C){}})}function v(R){return w?.trackDisposable(R),R}function g(R){w?.markAsDisposed(R)}function d(R,C){w?.setParent(R,C)}function e(R,C){if(w)for(const $ of R)w.setParent($,C)}function s(R){return w?.markAsSingleton(R),R}function r(R){return typeof R=="object"&&R!==null&&typeof R.dispose=="function"&&R.dispose.length===0}function l(R){if(N.Iterable.is(R)){const C=[];for(const $ of R)if($)try{$.dispose()}catch(ee){C.push(ee)}if(C.length===1)throw C[0];if(C.length>1)throw new AggregateError(C,"Encountered errors while disposing of store");return Array.isArray(R)?[]:R}else if(R)return R.dispose(),R}function o(R){for(const C of R)r(C)&&C.dispose();return[]}function p(...R){const C=A(()=>l(R));return e(R,C),C}function A(R){const C=v({dispose:(0,I.createSingleCallFunction)(()=>{g(C),R()})});return C}class L{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this._toDispose=new Set,this._isDisposed=!1,v(this)}dispose(){this._isDisposed||(g(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){if(this._toDispose.size!==0)try{l(this._toDispose)}finally{this._toDispose.clear()}}add(C){if(!C)return C;if(C===this)throw new Error("Cannot register a disposable on itself!");return d(C,this),this._isDisposed?L.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(C),C}delete(C){if(C){if(C===this)throw new Error("Cannot dispose a disposable on itself!");this._toDispose.delete(C),C.dispose()}}deleteAndLeak(C){C&&this._toDispose.has(C)&&(this._toDispose.delete(C),d(C,null))}}t.DisposableStore=L;class c{static{this.None=Object.freeze({dispose(){}})}constructor(){this._store=new L,v(this),d(this._store,this)}dispose(){g(this),this._store.dispose()}_register(C){if(C===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(C)}}t.Disposable=c;class a{constructor(){this._isDisposed=!1,v(this)}get value(){return this._isDisposed?void 0:this._value}set value(C){this._isDisposed||C===this._value||(this._value?.dispose(),C&&d(C,this),this._value=C)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,g(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const C=this._value;return this._value=void 0,C&&d(C,null),C}}t.MutableDisposable=a;class f{constructor(C){this._disposable=new a,this._isDisposed=!1,this._disposable.value=C}get value(){return this._disposable.value}set value(C){this._isDisposed||C===this._disposable.value||(this._disposable.value=C)}dispose(){this._isDisposed=!0,this._disposable.dispose()}}t.MandatoryMutableDisposable=f;class _{constructor(C){this._disposable=C,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter===0&&this._disposable.dispose(),this}}t.RefCountedDisposable=_;class H{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,v(this)}set(C){let $=C;return this.unset=()=>$=void 0,this.isset=()=>$!==void 0,this.dispose=()=>{$&&($(),$=void 0,g(this))},this}}t.SafeDisposable=H;class B{constructor(){this.references=new Map}acquire(C,...$){let ee=this.references.get(C);ee||(ee={counter:0,object:this.createReferencedObject(C,...$)},this.references.set(C,ee));const{object:Y}=ee,Z=(0,I.createSingleCallFunction)(()=>{--ee.counter===0&&(this.destroyReferencedObject(C,ee.object),this.references.delete(C))});return ee.counter++,{object:Y,dispose:Z}}}t.ReferenceCollection=B;class F{constructor(C){this.referenceCollection=C}async acquire(C,...$){const ee=this.referenceCollection.acquire(C,...$);try{return{object:await ee.object,dispose:()=>ee.dispose()}}catch(Y){throw ee.dispose(),Y}}}t.AsyncReferenceCollection=F;class E{constructor(C){this.object=C}dispose(){}}t.ImmortalReference=E;function k(R){const C=new L;try{R(C)}finally{C.dispose()}}class W{constructor(){this._store=new Map,this._isDisposed=!1,v(this)}dispose(){g(this),this._isDisposed=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this._store.size)try{l(this._store.values())}finally{this._store.clear()}}has(C){return this._store.has(C)}get size(){return this._store.size}get(C){return this._store.get(C)}set(C,$,ee=!1){this._isDisposed&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),ee||this._store.get(C)?.dispose(),this._store.set(C,$)}deleteAndDispose(C){this._store.get(C)?.dispose(),this._store.delete(C)}deleteAndLeak(C){const $=this._store.get(C);return this._store.delete(C),$}keys(){return this._store.keys()}values(){return this._store.values()}[Symbol.iterator](){return this._store[Symbol.iterator]()}}t.DisposableMap=W}),function(ue,t){typeof define=="function"&&define.amd?define(_e[93],Se([0]),t):typeof exports=="object"&&typeof module<"u"?t(exports):(ue=typeof globalThis<"u"?globalThis:ue||self,t(ue.marked={}))}(this,function(ue){"use strict";function t(){return{async:!1,breaks:!1,extensions:null,gfm:!0,hooks:null,pedantic:!1,renderer:null,silent:!1,tokenizer:null,walkTokens:null}}ue.defaults=t();function i(He){ue.defaults=He}const n=/[&<>"']/,O=new RegExp(n.source,"g"),I=/[<>"']|&(?!(#\d{1,7}|#[Xx][a-fA-F0-9]{1,6}|\w+);)/,N=new RegExp(I.source,"g"),b={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},w=He=>b[He];function u(He,j){if(j){if(n.test(He))return He.replace(O,w)}else if(I.test(He))return He.replace(N,w);return He}const m=/(^|[^\[])\^/g;function v(He,j){let T=typeof He=="string"?He:He.source;j=j||"";const M={replace:(K,Q)=>{let de=typeof Q=="string"?Q:Q.source;return de=de.replace(m,"$1"),T=T.replace(K,de),M},getRegex:()=>new RegExp(T,j)};return M}function g(He){try{He=encodeURI(He).replace(/%25/g,"%")}catch{return null}return He}const d={exec:()=>null};function e(He,j){const T=He.replace(/\|/g,(Q,de,pe)=>{let Me=!1,xe=de;for(;--xe>=0&&pe[xe]==="\\";)Me=!Me;return Me?"|":" |"}),M=T.split(/ \|/);let K=0;if(M[0].trim()||M.shift(),M.length>0&&!M[M.length-1].trim()&&M.pop(),j)if(M.length>j)M.splice(j);else for(;M.length<j;)M.push("");for(;K<M.length;K++)M[K]=M[K].trim().replace(/\\\|/g,"|");return M}function s(He,j,T){const M=He.length;if(M===0)return"";let K=0;for(;K<M;){const Q=He.charAt(M-K-1);if(Q===j&&!T)K++;else if(Q!==j&&T)K++;else break}return He.slice(0,M-K)}function r(He,j){if(He.indexOf(j[1])===-1)return-1;let T=0;for(let M=0;M<He.length;M++)if(He[M]==="\\")M++;else if(He[M]===j[0])T++;else if(He[M]===j[1]&&(T--,T<0))return M;return-1}function l(He,j,T,M){const K=j.href,Q=j.title?u(j.title):null,de=He[1].replace(/\\([\[\]])/g,"$1");if(He[0].charAt(0)!=="!"){M.state.inLink=!0;const pe={type:"link",raw:T,href:K,title:Q,text:de,tokens:M.inlineTokens(de)};return M.state.inLink=!1,pe}return{type:"image",raw:T,href:K,title:Q,text:u(de)}}function o(He,j){const T=He.match(/^(\s+)(?:```)/);if(T===null)return j;const M=T[1];return j.split(`
`).map(K=>{const Q=K.match(/^\s+/);if(Q===null)return K;const[de]=Q;return de.length>=M.length?K.slice(M.length):K}).join(`
`)}class p{options;rules;lexer;constructor(j){this.options=j||ue.defaults}space(j){const T=this.rules.block.newline.exec(j);if(T&&T[0].length>0)return{type:"space",raw:T[0]}}code(j){const T=this.rules.block.code.exec(j);if(T){const M=T[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:T[0],codeBlockStyle:"indented",text:this.options.pedantic?M:s(M,`
`)}}}fences(j){const T=this.rules.block.fences.exec(j);if(T){const M=T[0],K=o(M,T[3]||"");return{type:"code",raw:M,lang:T[2]?T[2].trim().replace(this.rules.inline.anyPunctuation,"$1"):T[2],text:K}}}heading(j){const T=this.rules.block.heading.exec(j);if(T){let M=T[2].trim();if(/#$/.test(M)){const K=s(M,"#");(this.options.pedantic||!K||/ $/.test(K))&&(M=K.trim())}return{type:"heading",raw:T[0],depth:T[1].length,text:M,tokens:this.lexer.inline(M)}}}hr(j){const T=this.rules.block.hr.exec(j);if(T)return{type:"hr",raw:s(T[0],`
`)}}blockquote(j){const T=this.rules.block.blockquote.exec(j);if(T){let M=s(T[0],`
`).split(`
`),K="",Q="";const de=[];for(;M.length>0;){let pe=!1;const Me=[];let xe;for(xe=0;xe<M.length;xe++)if(/^ {0,3}>/.test(M[xe]))Me.push(M[xe]),pe=!0;else if(!pe)Me.push(M[xe]);else break;M=M.slice(xe);const Ke=Me.join(`
`),Ye=Ke.replace(/\n {0,3}((?:=+|-+) *)(?=\n|$)/g,`
    $1`).replace(/^ {0,3}>[ \t]?/gm,"");K=K?`${K}
${Ke}`:Ke,Q=Q?`${Q}
${Ye}`:Ye;const Qe=this.lexer.state.top;if(this.lexer.state.top=!0,this.lexer.blockTokens(Ye,de,!0),this.lexer.state.top=Qe,M.length===0)break;const nt=de[de.length-1];if(nt?.type==="code")break;if(nt?.type==="blockquote"){const et=nt,ut=et.raw+`
`+M.join(`
`),Ve=this.blockquote(ut);de[de.length-1]=Ve,K=K.substring(0,K.length-et.raw.length)+Ve.raw,Q=Q.substring(0,Q.length-et.text.length)+Ve.text;break}else if(nt?.type==="list"){const et=nt,ut=et.raw+`
`+M.join(`
`),Ve=this.list(ut);de[de.length-1]=Ve,K=K.substring(0,K.length-nt.raw.length)+Ve.raw,Q=Q.substring(0,Q.length-et.raw.length)+Ve.raw,M=ut.substring(de[de.length-1].raw.length).split(`
`);continue}}return{type:"blockquote",raw:K,tokens:de,text:Q}}}list(j){let T=this.rules.block.list.exec(j);if(T){let M=T[1].trim();const K=M.length>1,Q={type:"list",raw:"",ordered:K,start:K?+M.slice(0,-1):"",loose:!1,items:[]};M=K?`\\d{1,9}\\${M.slice(-1)}`:`\\${M}`,this.options.pedantic&&(M=K?M:"[*+-]");const de=new RegExp(`^( {0,3}${M})((?:[	 ][^\\n]*)?(?:\\n|$))`);let pe=!1;for(;j;){let Me=!1,xe="",Ke="";if(!(T=de.exec(j))||this.rules.block.hr.test(j))break;xe=T[0],j=j.substring(xe.length);let Ye=T[2].split(`
`,1)[0].replace(/^\t+/,me=>" ".repeat(3*me.length)),Qe=j.split(`
`,1)[0],nt=!Ye.trim(),et=0;if(this.options.pedantic?(et=2,Ke=Ye.trimStart()):nt?et=T[1].length+1:(et=T[2].search(/[^ ]/),et=et>4?1:et,Ke=Ye.slice(et),et+=T[1].length),nt&&/^ *$/.test(Qe)&&(xe+=Qe+`
`,j=j.substring(Qe.length+1),Me=!0),!Me){const me=new RegExp(`^ {0,${Math.min(3,et-1)}}(?:[*+-]|\\d{1,9}[.)])((?:[ 	][^\\n]*)?(?:\\n|$))`),Be=new RegExp(`^ {0,${Math.min(3,et-1)}}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)`),Ue=new RegExp(`^ {0,${Math.min(3,et-1)}}(?:\`\`\`|~~~)`),st=new RegExp(`^ {0,${Math.min(3,et-1)}}#`);for(;j;){const at=j.split(`
`,1)[0];if(Qe=at,this.options.pedantic&&(Qe=Qe.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),Ue.test(Qe)||st.test(Qe)||me.test(Qe)||Be.test(j))break;if(Qe.search(/[^ ]/)>=et||!Qe.trim())Ke+=`
`+Qe.slice(et);else{if(nt||Ye.search(/[^ ]/)>=4||Ue.test(Ye)||st.test(Ye)||Be.test(Ye))break;Ke+=`
`+Qe}!nt&&!Qe.trim()&&(nt=!0),xe+=at+`
`,j=j.substring(at.length+1),Ye=Qe.slice(et)}}Q.loose||(pe?Q.loose=!0:/\n *\n *$/.test(xe)&&(pe=!0));let ut=null,Ve;this.options.gfm&&(ut=/^\[[ xX]\] /.exec(Ke),ut&&(Ve=ut[0]!=="[ ] ",Ke=Ke.replace(/^\[[ xX]\] +/,""))),Q.items.push({type:"list_item",raw:xe,task:!!ut,checked:Ve,loose:!1,text:Ke,tokens:[]}),Q.raw+=xe}Q.items[Q.items.length-1].raw=Q.items[Q.items.length-1].raw.trimEnd(),Q.items[Q.items.length-1].text=Q.items[Q.items.length-1].text.trimEnd(),Q.raw=Q.raw.trimEnd();for(let Me=0;Me<Q.items.length;Me++)if(this.lexer.state.top=!1,Q.items[Me].tokens=this.lexer.blockTokens(Q.items[Me].text,[]),!Q.loose){const xe=Q.items[Me].tokens.filter(Ye=>Ye.type==="space"),Ke=xe.length>0&&xe.some(Ye=>/\n.*\n/.test(Ye.raw));Q.loose=Ke}if(Q.loose)for(let Me=0;Me<Q.items.length;Me++)Q.items[Me].loose=!0;return Q}}html(j){const T=this.rules.block.html.exec(j);if(T)return{type:"html",block:!0,raw:T[0],pre:T[1]==="pre"||T[1]==="script"||T[1]==="style",text:T[0]}}def(j){const T=this.rules.block.def.exec(j);if(T){const M=T[1].toLowerCase().replace(/\s+/g," "),K=T[2]?T[2].replace(/^<(.*)>$/,"$1").replace(this.rules.inline.anyPunctuation,"$1"):"",Q=T[3]?T[3].substring(1,T[3].length-1).replace(this.rules.inline.anyPunctuation,"$1"):T[3];return{type:"def",tag:M,raw:T[0],href:K,title:Q}}}table(j){const T=this.rules.block.table.exec(j);if(!T||!/[:|]/.test(T[2]))return;const M=e(T[1]),K=T[2].replace(/^\||\| *$/g,"").split("|"),Q=T[3]&&T[3].trim()?T[3].replace(/\n[ \t]*$/,"").split(`
`):[],de={type:"table",raw:T[0],header:[],align:[],rows:[]};if(M.length===K.length){for(const pe of K)/^ *-+: *$/.test(pe)?de.align.push("right"):/^ *:-+: *$/.test(pe)?de.align.push("center"):/^ *:-+ *$/.test(pe)?de.align.push("left"):de.align.push(null);for(let pe=0;pe<M.length;pe++)de.header.push({text:M[pe],tokens:this.lexer.inline(M[pe]),header:!0,align:de.align[pe]});for(const pe of Q)de.rows.push(e(pe,de.header.length).map((Me,xe)=>({text:Me,tokens:this.lexer.inline(Me),header:!1,align:de.align[xe]})));return de}}lheading(j){const T=this.rules.block.lheading.exec(j);if(T)return{type:"heading",raw:T[0],depth:T[2].charAt(0)==="="?1:2,text:T[1],tokens:this.lexer.inline(T[1])}}paragraph(j){const T=this.rules.block.paragraph.exec(j);if(T){const M=T[1].charAt(T[1].length-1)===`
`?T[1].slice(0,-1):T[1];return{type:"paragraph",raw:T[0],text:M,tokens:this.lexer.inline(M)}}}text(j){const T=this.rules.block.text.exec(j);if(T)return{type:"text",raw:T[0],text:T[0],tokens:this.lexer.inline(T[0])}}escape(j){const T=this.rules.inline.escape.exec(j);if(T)return{type:"escape",raw:T[0],text:u(T[1])}}tag(j){const T=this.rules.inline.tag.exec(j);if(T)return!this.lexer.state.inLink&&/^<a /i.test(T[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(T[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(T[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(T[0])&&(this.lexer.state.inRawBlock=!1),{type:"html",raw:T[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,block:!1,text:T[0]}}link(j){const T=this.rules.inline.link.exec(j);if(T){const M=T[2].trim();if(!this.options.pedantic&&/^</.test(M)){if(!/>$/.test(M))return;const de=s(M.slice(0,-1),"\\");if((M.length-de.length)%2===0)return}else{const de=r(T[2],"()");if(de>-1){const Me=(T[0].indexOf("!")===0?5:4)+T[1].length+de;T[2]=T[2].substring(0,de),T[0]=T[0].substring(0,Me).trim(),T[3]=""}}let K=T[2],Q="";if(this.options.pedantic){const de=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(K);de&&(K=de[1],Q=de[3])}else Q=T[3]?T[3].slice(1,-1):"";return K=K.trim(),/^</.test(K)&&(this.options.pedantic&&!/>$/.test(M)?K=K.slice(1):K=K.slice(1,-1)),l(T,{href:K&&K.replace(this.rules.inline.anyPunctuation,"$1"),title:Q&&Q.replace(this.rules.inline.anyPunctuation,"$1")},T[0],this.lexer)}}reflink(j,T){let M;if((M=this.rules.inline.reflink.exec(j))||(M=this.rules.inline.nolink.exec(j))){const K=(M[2]||M[1]).replace(/\s+/g," "),Q=T[K.toLowerCase()];if(!Q){const de=M[0].charAt(0);return{type:"text",raw:de,text:de}}return l(M,Q,M[0],this.lexer)}}emStrong(j,T,M=""){let K=this.rules.inline.emStrongLDelim.exec(j);if(!K||K[3]&&M.match(/[\p{L}\p{N}]/u))return;if(!(K[1]||K[2]||"")||!M||this.rules.inline.punctuation.exec(M)){const de=[...K[0]].length-1;let pe,Me,xe=de,Ke=0;const Ye=K[0][0]==="*"?this.rules.inline.emStrongRDelimAst:this.rules.inline.emStrongRDelimUnd;for(Ye.lastIndex=0,T=T.slice(-1*j.length+de);(K=Ye.exec(T))!=null;){if(pe=K[1]||K[2]||K[3]||K[4]||K[5]||K[6],!pe)continue;if(Me=[...pe].length,K[3]||K[4]){xe+=Me;continue}else if((K[5]||K[6])&&de%3&&!((de+Me)%3)){Ke+=Me;continue}if(xe-=Me,xe>0)continue;Me=Math.min(Me,Me+xe+Ke);const Qe=[...K[0]][0].length,nt=j.slice(0,de+K.index+Qe+Me);if(Math.min(de,Me)%2){const ut=nt.slice(1,-1);return{type:"em",raw:nt,text:ut,tokens:this.lexer.inlineTokens(ut)}}const et=nt.slice(2,-2);return{type:"strong",raw:nt,text:et,tokens:this.lexer.inlineTokens(et)}}}}codespan(j){const T=this.rules.inline.code.exec(j);if(T){let M=T[2].replace(/\n/g," ");const K=/[^ ]/.test(M),Q=/^ /.test(M)&&/ $/.test(M);return K&&Q&&(M=M.substring(1,M.length-1)),M=u(M,!0),{type:"codespan",raw:T[0],text:M}}}br(j){const T=this.rules.inline.br.exec(j);if(T)return{type:"br",raw:T[0]}}del(j){const T=this.rules.inline.del.exec(j);if(T)return{type:"del",raw:T[0],text:T[2],tokens:this.lexer.inlineTokens(T[2])}}autolink(j){const T=this.rules.inline.autolink.exec(j);if(T){let M,K;return T[2]==="@"?(M=u(T[1]),K="mailto:"+M):(M=u(T[1]),K=M),{type:"link",raw:T[0],text:M,href:K,tokens:[{type:"text",raw:M,text:M}]}}}url(j){let T;if(T=this.rules.inline.url.exec(j)){let M,K;if(T[2]==="@")M=u(T[0]),K="mailto:"+M;else{let Q;do Q=T[0],T[0]=this.rules.inline._backpedal.exec(T[0])?.[0]??"";while(Q!==T[0]);M=u(T[0]),T[1]==="www."?K="http://"+T[0]:K=T[0]}return{type:"link",raw:T[0],text:M,href:K,tokens:[{type:"text",raw:M,text:M}]}}}inlineText(j){const T=this.rules.inline.text.exec(j);if(T){let M;return this.lexer.state.inRawBlock?M=T[0]:M=u(T[0]),{type:"text",raw:T[0],text:M}}}}const A=/^(?: *(?:\n|$))+/,L=/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,c=/^ {0,3}(`{3,}(?=[^`\n]*(?:\n|$))|~{3,})([^\n]*)(?:\n|$)(?:|([\s\S]*?)(?:\n|$))(?: {0,3}\1[~`]* *(?=\n|$)|$)/,a=/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,f=/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,_=/(?:[*+-]|\d{1,9}[.)])/,H=v(/^(?!bull |blockCode|fences|blockquote|heading|html)((?:.|\n(?!\s*?\n|bull |blockCode|fences|blockquote|heading|html))+?)\n {0,3}(=+|-+) *(?:\n+|$)/).replace(/bull/g,_).replace(/blockCode/g,/ {4}/).replace(/fences/g,/ {0,3}(?:`{3,}|~{3,})/).replace(/blockquote/g,/ {0,3}>/).replace(/heading/g,/ {0,3}#{1,6}/).replace(/html/g,/ {0,3}<[^\n>]+>\n/).getRegex(),B=/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,F=/^[^\n]+/,E=/(?!\s*\])(?:\\.|[^\[\]\\])+/,k=v(/^ {0,3}\[(label)\]: *(?:\n *)?([^<\s][^\s]*|<.*?>)(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/).replace("label",E).replace("title",/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/).getRegex(),W=v(/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/).replace(/bull/g,_).getRegex(),R="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|search|section|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",C=/<!--(?:-?>|[\s\S]*?(?:-->|$))/,$=v("^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))","i").replace("comment",C).replace("tag",R).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),ee=v(B).replace("hr",a).replace("heading"," {0,3}#{1,6}(?:\\s|$)").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",R).getRegex(),Z={blockquote:v(/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/).replace("paragraph",ee).getRegex(),code:L,def:k,fences:c,heading:f,hr:a,html:$,lheading:H,list:W,newline:A,paragraph:ee,table:d,text:F},ce=v("^ *([^\\n ].*)\\n {0,3}((?:\\| *)?:?-+:? *(?:\\| *:?-+:? *)*(?:\\| *)?)(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)").replace("hr",a).replace("heading"," {0,3}#{1,6}(?:\\s|$)").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",R).getRegex(),he={...Z,table:ce,paragraph:v(B).replace("hr",a).replace("heading"," {0,3}#{1,6}(?:\\s|$)").replace("|lheading","").replace("table",ce).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",R).getRegex()},ye={...Z,html:v(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",C).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:d,lheading:/^(.+?)\n {0,3}(=+|-+) *(?:\n+|$)/,paragraph:v(B).replace("hr",a).replace("heading",` *#{1,6} *[^
]`).replace("lheading",H).replace("|table","").replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").replace("|tag","").getRegex()},Re=/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,Pe=/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,re=/^( {2,}|\\)\n(?!\s*$)/,ie=/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,fe="\\p{P}\\p{S}",ve=v(/^((?![*_])[\spunctuation])/,"u").replace(/punctuation/g,fe).getRegex(),Ne=/\[[^[\]]*?\]\([^\(\)]*?\)|`[^`]*?`|<[^<>]*?>/g,ne=v(/^(?:\*+(?:((?!\*)[punct])|[^\s*]))|^_+(?:((?!_)[punct])|([^\s_]))/,"u").replace(/punct/g,fe).getRegex(),Ee=v("^[^_*]*?__[^_*]*?\\*[^_*]*?(?=__)|[^*]+(?=[^*])|(?!\\*)[punct](\\*+)(?=[\\s]|$)|[^punct\\s](\\*+)(?!\\*)(?=[punct\\s]|$)|(?!\\*)[punct\\s](\\*+)(?=[^punct\\s])|[\\s](\\*+)(?!\\*)(?=[punct])|(?!\\*)[punct](\\*+)(?!\\*)(?=[punct])|[^punct\\s](\\*+)(?=[^punct\\s])","gu").replace(/punct/g,fe).getRegex(),Le=v("^[^_*]*?\\*\\*[^_*]*?_[^_*]*?(?=\\*\\*)|[^_]+(?=[^_])|(?!_)[punct](_+)(?=[\\s]|$)|[^punct\\s](_+)(?!_)(?=[punct\\s]|$)|(?!_)[punct\\s](_+)(?=[^punct\\s])|[\\s](_+)(?!_)(?=[punct])|(?!_)[punct](_+)(?!_)(?=[punct])","gu").replace(/punct/g,fe).getRegex(),Ce=v(/\\([punct])/,"gu").replace(/punct/g,fe).getRegex(),Fe=v(/^<(scheme:[^\s\x00-\x1f<>]*|email)>/).replace("scheme",/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/).replace("email",/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/).getRegex(),ze=v(C).replace("(?:-->|$)","-->").getRegex(),Xe=v("^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>").replace("comment",ze).replace("attribute",/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/).getRegex(),oe=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,x=v(/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/).replace("label",oe).replace("href",/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/).replace("title",/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/).getRegex(),h=v(/^!?\[(label)\]\[(ref)\]/).replace("label",oe).replace("ref",E).getRegex(),S=v(/^!?\[(ref)\](?:\[\])?/).replace("ref",E).getRegex(),P=v("reflink|nolink(?!\\()","g").replace("reflink",h).replace("nolink",S).getRegex(),G={_backpedal:d,anyPunctuation:Ce,autolink:Fe,blockSkip:Ne,br:re,code:Pe,del:d,emStrongLDelim:ne,emStrongRDelimAst:Ee,emStrongRDelimUnd:Le,escape:Re,link:x,nolink:S,punctuation:ve,reflink:h,reflinkSearch:P,tag:Xe,text:ie,url:d},J={...G,link:v(/^!?\[(label)\]\((.*?)\)/).replace("label",oe).getRegex(),reflink:v(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",oe).getRegex()},te={...G,escape:v(Re).replace("])","~|])").getRegex(),url:v(/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,"i").replace("email",/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/).getRegex(),_backpedal:/(?:[^?!.,:;*_'"~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_'"~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/},y={...te,br:v(re).replace("{2,}","*").getRegex(),text:v(te.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()},D={normal:Z,gfm:he,pedantic:ye},z={normal:G,gfm:te,breaks:y,pedantic:J};class V{tokens;options;state;tokenizer;inlineQueue;constructor(j){this.tokens=[],this.tokens.links=Object.create(null),this.options=j||ue.defaults,this.options.tokenizer=this.options.tokenizer||new p,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};const T={block:D.normal,inline:z.normal};this.options.pedantic?(T.block=D.pedantic,T.inline=z.pedantic):this.options.gfm&&(T.block=D.gfm,this.options.breaks?T.inline=z.breaks:T.inline=z.gfm),this.tokenizer.rules=T}static get rules(){return{block:D,inline:z}}static lex(j,T){return new V(T).lex(j)}static lexInline(j,T){return new V(T).inlineTokens(j)}lex(j){j=j.replace(/\r\n|\r/g,`
`),this.blockTokens(j,this.tokens);for(let T=0;T<this.inlineQueue.length;T++){const M=this.inlineQueue[T];this.inlineTokens(M.src,M.tokens)}return this.inlineQueue=[],this.tokens}blockTokens(j,T=[],M=!1){this.options.pedantic?j=j.replace(/\t/g,"    ").replace(/^ +$/gm,""):j=j.replace(/^( *)(\t+)/gm,(pe,Me,xe)=>Me+"    ".repeat(xe.length));let K,Q,de;for(;j;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(pe=>(K=pe.call({lexer:this},j,T))?(j=j.substring(K.raw.length),T.push(K),!0):!1))){if(K=this.tokenizer.space(j)){j=j.substring(K.raw.length),K.raw.length===1&&T.length>0?T[T.length-1].raw+=`
`:T.push(K);continue}if(K=this.tokenizer.code(j)){j=j.substring(K.raw.length),Q=T[T.length-1],Q&&(Q.type==="paragraph"||Q.type==="text")?(Q.raw+=`
`+K.raw,Q.text+=`
`+K.text,this.inlineQueue[this.inlineQueue.length-1].src=Q.text):T.push(K);continue}if(K=this.tokenizer.fences(j)){j=j.substring(K.raw.length),T.push(K);continue}if(K=this.tokenizer.heading(j)){j=j.substring(K.raw.length),T.push(K);continue}if(K=this.tokenizer.hr(j)){j=j.substring(K.raw.length),T.push(K);continue}if(K=this.tokenizer.blockquote(j)){j=j.substring(K.raw.length),T.push(K);continue}if(K=this.tokenizer.list(j)){j=j.substring(K.raw.length),T.push(K);continue}if(K=this.tokenizer.html(j)){j=j.substring(K.raw.length),T.push(K);continue}if(K=this.tokenizer.def(j)){j=j.substring(K.raw.length),Q=T[T.length-1],Q&&(Q.type==="paragraph"||Q.type==="text")?(Q.raw+=`
`+K.raw,Q.text+=`
`+K.raw,this.inlineQueue[this.inlineQueue.length-1].src=Q.text):this.tokens.links[K.tag]||(this.tokens.links[K.tag]={href:K.href,title:K.title});continue}if(K=this.tokenizer.table(j)){j=j.substring(K.raw.length),T.push(K);continue}if(K=this.tokenizer.lheading(j)){j=j.substring(K.raw.length),T.push(K);continue}if(de=j,this.options.extensions&&this.options.extensions.startBlock){let pe=1/0;const Me=j.slice(1);let xe;this.options.extensions.startBlock.forEach(Ke=>{xe=Ke.call({lexer:this},Me),typeof xe=="number"&&xe>=0&&(pe=Math.min(pe,xe))}),pe<1/0&&pe>=0&&(de=j.substring(0,pe+1))}if(this.state.top&&(K=this.tokenizer.paragraph(de))){Q=T[T.length-1],M&&Q?.type==="paragraph"?(Q.raw+=`
`+K.raw,Q.text+=`
`+K.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Q.text):T.push(K),M=de.length!==j.length,j=j.substring(K.raw.length);continue}if(K=this.tokenizer.text(j)){j=j.substring(K.raw.length),Q=T[T.length-1],Q&&Q.type==="text"?(Q.raw+=`
`+K.raw,Q.text+=`
`+K.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Q.text):T.push(K);continue}if(j){const pe="Infinite loop on byte: "+j.charCodeAt(0);if(this.options.silent){console.error(pe);break}else throw new Error(pe)}}return this.state.top=!0,T}inline(j,T=[]){return this.inlineQueue.push({src:j,tokens:T}),T}inlineTokens(j,T=[]){let M,K,Q,de=j,pe,Me,xe;if(this.tokens.links){const Ke=Object.keys(this.tokens.links);if(Ke.length>0)for(;(pe=this.tokenizer.rules.inline.reflinkSearch.exec(de))!=null;)Ke.includes(pe[0].slice(pe[0].lastIndexOf("[")+1,-1))&&(de=de.slice(0,pe.index)+"["+"a".repeat(pe[0].length-2)+"]"+de.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(pe=this.tokenizer.rules.inline.blockSkip.exec(de))!=null;)de=de.slice(0,pe.index)+"["+"a".repeat(pe[0].length-2)+"]"+de.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(pe=this.tokenizer.rules.inline.anyPunctuation.exec(de))!=null;)de=de.slice(0,pe.index)+"++"+de.slice(this.tokenizer.rules.inline.anyPunctuation.lastIndex);for(;j;)if(Me||(xe=""),Me=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(Ke=>(M=Ke.call({lexer:this},j,T))?(j=j.substring(M.raw.length),T.push(M),!0):!1))){if(M=this.tokenizer.escape(j)){j=j.substring(M.raw.length),T.push(M);continue}if(M=this.tokenizer.tag(j)){j=j.substring(M.raw.length),K=T[T.length-1],K&&M.type==="text"&&K.type==="text"?(K.raw+=M.raw,K.text+=M.text):T.push(M);continue}if(M=this.tokenizer.link(j)){j=j.substring(M.raw.length),T.push(M);continue}if(M=this.tokenizer.reflink(j,this.tokens.links)){j=j.substring(M.raw.length),K=T[T.length-1],K&&M.type==="text"&&K.type==="text"?(K.raw+=M.raw,K.text+=M.text):T.push(M);continue}if(M=this.tokenizer.emStrong(j,de,xe)){j=j.substring(M.raw.length),T.push(M);continue}if(M=this.tokenizer.codespan(j)){j=j.substring(M.raw.length),T.push(M);continue}if(M=this.tokenizer.br(j)){j=j.substring(M.raw.length),T.push(M);continue}if(M=this.tokenizer.del(j)){j=j.substring(M.raw.length),T.push(M);continue}if(M=this.tokenizer.autolink(j)){j=j.substring(M.raw.length),T.push(M);continue}if(!this.state.inLink&&(M=this.tokenizer.url(j))){j=j.substring(M.raw.length),T.push(M);continue}if(Q=j,this.options.extensions&&this.options.extensions.startInline){let Ke=1/0;const Ye=j.slice(1);let Qe;this.options.extensions.startInline.forEach(nt=>{Qe=nt.call({lexer:this},Ye),typeof Qe=="number"&&Qe>=0&&(Ke=Math.min(Ke,Qe))}),Ke<1/0&&Ke>=0&&(Q=j.substring(0,Ke+1))}if(M=this.tokenizer.inlineText(Q)){j=j.substring(M.raw.length),M.raw.slice(-1)!=="_"&&(xe=M.raw.slice(-1)),Me=!0,K=T[T.length-1],K&&K.type==="text"?(K.raw+=M.raw,K.text+=M.text):T.push(M);continue}if(j){const Ke="Infinite loop on byte: "+j.charCodeAt(0);if(this.options.silent){console.error(Ke);break}else throw new Error(Ke)}}return T}}class q{options;parser;constructor(j){this.options=j||ue.defaults}space(j){return""}code({text:j,lang:T,escaped:M}){const K=(T||"").match(/^\S*/)?.[0],Q=j.replace(/\n$/,"")+`
`;return K?'<pre><code class="language-'+u(K)+'">'+(M?Q:u(Q,!0))+`</code></pre>
`:"<pre><code>"+(M?Q:u(Q,!0))+`</code></pre>
`}blockquote({tokens:j}){return`<blockquote>
${this.parser.parse(j)}</blockquote>
`}html({text:j}){return j}heading({tokens:j,depth:T}){return`<h${T}>${this.parser.parseInline(j)}</h${T}>
`}hr(j){return`<hr>
`}list(j){const T=j.ordered,M=j.start;let K="";for(let pe=0;pe<j.items.length;pe++){const Me=j.items[pe];K+=this.listitem(Me)}const Q=T?"ol":"ul",de=T&&M!==1?' start="'+M+'"':"";return"<"+Q+de+`>
`+K+"</"+Q+`>
`}listitem(j){let T="";if(j.task){const M=this.checkbox({checked:!!j.checked});j.loose?j.tokens.length>0&&j.tokens[0].type==="paragraph"?(j.tokens[0].text=M+" "+j.tokens[0].text,j.tokens[0].tokens&&j.tokens[0].tokens.length>0&&j.tokens[0].tokens[0].type==="text"&&(j.tokens[0].tokens[0].text=M+" "+j.tokens[0].tokens[0].text)):j.tokens.unshift({type:"text",raw:M+" ",text:M+" "}):T+=M+" "}return T+=this.parser.parse(j.tokens,!!j.loose),`<li>${T}</li>
`}checkbox({checked:j}){return"<input "+(j?'checked="" ':"")+'disabled="" type="checkbox">'}paragraph({tokens:j}){return`<p>${this.parser.parseInline(j)}</p>
`}table(j){let T="",M="";for(let Q=0;Q<j.header.length;Q++)M+=this.tablecell(j.header[Q]);T+=this.tablerow({text:M});let K="";for(let Q=0;Q<j.rows.length;Q++){const de=j.rows[Q];M="";for(let pe=0;pe<de.length;pe++)M+=this.tablecell(de[pe]);K+=this.tablerow({text:M})}return K&&(K=`<tbody>${K}</tbody>`),`<table>
<thead>
`+T+`</thead>
`+K+`</table>
`}tablerow({text:j}){return`<tr>
${j}</tr>
`}tablecell(j){const T=this.parser.parseInline(j.tokens),M=j.header?"th":"td";return(j.align?`<${M} align="${j.align}">`:`<${M}>`)+T+`</${M}>
`}strong({tokens:j}){return`<strong>${this.parser.parseInline(j)}</strong>`}em({tokens:j}){return`<em>${this.parser.parseInline(j)}</em>`}codespan({text:j}){return`<code>${j}</code>`}br(j){return"<br>"}del({tokens:j}){return`<del>${this.parser.parseInline(j)}</del>`}link({href:j,title:T,tokens:M}){const K=this.parser.parseInline(M),Q=g(j);if(Q===null)return K;j=Q;let de='<a href="'+j+'"';return T&&(de+=' title="'+T+'"'),de+=">"+K+"</a>",de}image({href:j,title:T,text:M}){const K=g(j);if(K===null)return M;j=K;let Q=`<img src="${j}" alt="${M}"`;return T&&(Q+=` title="${T}"`),Q+=">",Q}text(j){return"tokens"in j&&j.tokens?this.parser.parseInline(j.tokens):j.text}}class se{strong({text:j}){return j}em({text:j}){return j}codespan({text:j}){return j}del({text:j}){return j}html({text:j}){return j}text({text:j}){return j}link({text:j}){return""+j}image({text:j}){return""+j}br(){return""}}class ae{options;renderer;textRenderer;constructor(j){this.options=j||ue.defaults,this.options.renderer=this.options.renderer||new q,this.renderer=this.options.renderer,this.renderer.options=this.options,this.renderer.parser=this,this.textRenderer=new se}static parse(j,T){return new ae(T).parse(j)}static parseInline(j,T){return new ae(T).parseInline(j)}parse(j,T=!0){let M="";for(let K=0;K<j.length;K++){const Q=j[K];if(this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Q.type]){const pe=Q,Me=this.options.extensions.renderers[pe.type].call({parser:this},pe);if(Me!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(pe.type)){M+=Me||"";continue}}const de=Q;switch(de.type){case"space":{M+=this.renderer.space(de);continue}case"hr":{M+=this.renderer.hr(de);continue}case"heading":{M+=this.renderer.heading(de);continue}case"code":{M+=this.renderer.code(de);continue}case"table":{M+=this.renderer.table(de);continue}case"blockquote":{M+=this.renderer.blockquote(de);continue}case"list":{M+=this.renderer.list(de);continue}case"html":{M+=this.renderer.html(de);continue}case"paragraph":{M+=this.renderer.paragraph(de);continue}case"text":{let pe=de,Me=this.renderer.text(pe);for(;K+1<j.length&&j[K+1].type==="text";)pe=j[++K],Me+=`
`+this.renderer.text(pe);T?M+=this.renderer.paragraph({type:"paragraph",raw:Me,text:Me,tokens:[{type:"text",raw:Me,text:Me}]}):M+=Me;continue}default:{const pe='Token with "'+de.type+'" type was not found.';if(this.options.silent)return console.error(pe),"";throw new Error(pe)}}}return M}parseInline(j,T){T=T||this.renderer;let M="";for(let K=0;K<j.length;K++){const Q=j[K];if(this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Q.type]){const pe=this.options.extensions.renderers[Q.type].call({parser:this},Q);if(pe!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Q.type)){M+=pe||"";continue}}const de=Q;switch(de.type){case"escape":{M+=T.text(de);break}case"html":{M+=T.html(de);break}case"link":{M+=T.link(de);break}case"image":{M+=T.image(de);break}case"strong":{M+=T.strong(de);break}case"em":{M+=T.em(de);break}case"codespan":{M+=T.codespan(de);break}case"br":{M+=T.br(de);break}case"del":{M+=T.del(de);break}case"text":{M+=T.text(de);break}default:{const pe='Token with "'+de.type+'" type was not found.';if(this.options.silent)return console.error(pe),"";throw new Error(pe)}}}return M}}class ge{options;constructor(j){this.options=j||ue.defaults}static passThroughHooks=new Set(["preprocess","postprocess","processAllTokens"]);preprocess(j){return j}postprocess(j){return j}processAllTokens(j){return j}}class we{defaults=t();options=this.setOptions;parse=this.parseMarkdown(V.lex,ae.parse);parseInline=this.parseMarkdown(V.lexInline,ae.parseInline);Parser=ae;Renderer=q;TextRenderer=se;Lexer=V;Tokenizer=p;Hooks=ge;constructor(...j){this.use(...j)}walkTokens(j,T){let M=[];for(const K of j)switch(M=M.concat(T.call(this,K)),K.type){case"table":{const Q=K;for(const de of Q.header)M=M.concat(this.walkTokens(de.tokens,T));for(const de of Q.rows)for(const pe of de)M=M.concat(this.walkTokens(pe.tokens,T));break}case"list":{const Q=K;M=M.concat(this.walkTokens(Q.items,T));break}default:{const Q=K;this.defaults.extensions?.childTokens?.[Q.type]?this.defaults.extensions.childTokens[Q.type].forEach(de=>{const pe=Q[de].flat(1/0);M=M.concat(this.walkTokens(pe,T))}):Q.tokens&&(M=M.concat(this.walkTokens(Q.tokens,T)))}}return M}use(...j){const T=this.defaults.extensions||{renderers:{},childTokens:{}};return j.forEach(M=>{const K={...M};if(K.async=this.defaults.async||K.async||!1,M.extensions&&(M.extensions.forEach(Q=>{if(!Q.name)throw new Error("extension name required");if("renderer"in Q){const de=T.renderers[Q.name];de?T.renderers[Q.name]=function(...pe){let Me=Q.renderer.apply(this,pe);return Me===!1&&(Me=de.apply(this,pe)),Me}:T.renderers[Q.name]=Q.renderer}if("tokenizer"in Q){if(!Q.level||Q.level!=="block"&&Q.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");const de=T[Q.level];de?de.unshift(Q.tokenizer):T[Q.level]=[Q.tokenizer],Q.start&&(Q.level==="block"?T.startBlock?T.startBlock.push(Q.start):T.startBlock=[Q.start]:Q.level==="inline"&&(T.startInline?T.startInline.push(Q.start):T.startInline=[Q.start]))}"childTokens"in Q&&Q.childTokens&&(T.childTokens[Q.name]=Q.childTokens)}),K.extensions=T),M.renderer){const Q=this.defaults.renderer||new q(this.defaults);for(const de in M.renderer){if(!(de in Q))throw new Error(`renderer '${de}' does not exist`);if(["options","parser"].includes(de))continue;const pe=de,Me=M.renderer[pe],xe=Q[pe];Q[pe]=(...Ke)=>{let Ye=Me.apply(Q,Ke);return Ye===!1&&(Ye=xe.apply(Q,Ke)),Ye||""}}K.renderer=Q}if(M.tokenizer){const Q=this.defaults.tokenizer||new p(this.defaults);for(const de in M.tokenizer){if(!(de in Q))throw new Error(`tokenizer '${de}' does not exist`);if(["options","rules","lexer"].includes(de))continue;const pe=de,Me=M.tokenizer[pe],xe=Q[pe];Q[pe]=(...Ke)=>{let Ye=Me.apply(Q,Ke);return Ye===!1&&(Ye=xe.apply(Q,Ke)),Ye}}K.tokenizer=Q}if(M.hooks){const Q=this.defaults.hooks||new ge;for(const de in M.hooks){if(!(de in Q))throw new Error(`hook '${de}' does not exist`);if(de==="options")continue;const pe=de,Me=M.hooks[pe],xe=Q[pe];ge.passThroughHooks.has(de)?Q[pe]=Ke=>{if(this.defaults.async)return Promise.resolve(Me.call(Q,Ke)).then(Qe=>xe.call(Q,Qe));const Ye=Me.call(Q,Ke);return xe.call(Q,Ye)}:Q[pe]=(...Ke)=>{let Ye=Me.apply(Q,Ke);return Ye===!1&&(Ye=xe.apply(Q,Ke)),Ye}}K.hooks=Q}if(M.walkTokens){const Q=this.defaults.walkTokens,de=M.walkTokens;K.walkTokens=function(pe){let Me=[];return Me.push(de.call(this,pe)),Q&&(Me=Me.concat(Q.call(this,pe))),Me}}this.defaults={...this.defaults,...K}}),this}setOptions(j){return this.defaults={...this.defaults,...j},this}lexer(j,T){return V.lex(j,T??this.defaults)}parser(j,T){return ae.parse(j,T??this.defaults)}parseMarkdown(j,T){return(K,Q)=>{const de={...Q},pe={...this.defaults,...de},Me=this.onError(!!pe.silent,!!pe.async);if(this.defaults.async===!0&&de.async===!1)return Me(new Error("marked(): The async option was set to true by an extension. Remove async: false from the parse options object to return a Promise."));if(typeof K>"u"||K===null)return Me(new Error("marked(): input parameter is undefined or null"));if(typeof K!="string")return Me(new Error("marked(): input parameter is of type "+Object.prototype.toString.call(K)+", string expected"));if(pe.hooks&&(pe.hooks.options=pe),pe.async)return Promise.resolve(pe.hooks?pe.hooks.preprocess(K):K).then(xe=>j(xe,pe)).then(xe=>pe.hooks?pe.hooks.processAllTokens(xe):xe).then(xe=>pe.walkTokens?Promise.all(this.walkTokens(xe,pe.walkTokens)).then(()=>xe):xe).then(xe=>T(xe,pe)).then(xe=>pe.hooks?pe.hooks.postprocess(xe):xe).catch(Me);try{pe.hooks&&(K=pe.hooks.preprocess(K));let xe=j(K,pe);pe.hooks&&(xe=pe.hooks.processAllTokens(xe)),pe.walkTokens&&this.walkTokens(xe,pe.walkTokens);let Ke=T(xe,pe);return pe.hooks&&(Ke=pe.hooks.postprocess(Ke)),Ke}catch(xe){return Me(xe)}}}onError(j,T){return M=>{if(M.message+=`
Please report this to https://github.com/markedjs/marked.`,j){const K="<p>An error occurred:</p><pre>"+u(M.message+"",!0)+"</pre>";return T?Promise.resolve(K):K}if(T)return Promise.reject(M);throw M}}}const De=new we;function Te(He,j){return De.parse(He,j)}Te.options=Te.setOptions=function(He){return De.setOptions(He),Te.defaults=De.defaults,i(Te.defaults),Te},Te.getDefaults=t,Te.defaults=ue.defaults,Te.use=function(...He){return De.use(...He),Te.defaults=De.defaults,i(Te.defaults),Te},Te.walkTokens=function(He,j){return De.walkTokens(He,j)},Te.parseInline=De.parseInline,Te.Parser=ae,Te.parser=ae.parse,Te.Renderer=q,Te.TextRenderer=se,Te.Lexer=V,Te.lexer=V.lex,Te.Tokenizer=p,Te.Hooks=ge,Te.parse=Te;const Oe=Te.options,Ae=Te.setOptions,ke=Te.use,Ge=Te.walkTokens,it=Te.parseInline,rt=Te,ft=ae.parse,ht=V.lex;ue.Hooks=ge,ue.Lexer=V,ue.Marked=we,ue.Parser=ae,ue.Renderer=q,ue.TextRenderer=se,ue.Tokenizer=p,ue.getDefaults=t,ue.lexer=ht,ue.marked=Te,ue.options=Oe,ue.parse=rt,ue.parseInline=it,ue.parser=ft,ue.setOptions=Ae,ue.use=ke,ue.walkTokens=Ge}),define(_e[61],Se([1,0]),function(ue,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.MarshalledId=void 0;var i;(function(n){n[n.Uri=1]="Uri",n[n.Regexp=2]="Regexp",n[n.ScmResource=3]="ScmResource",n[n.ScmResourceGroup=4]="ScmResourceGroup",n[n.ScmProvider=5]="ScmProvider",n[n.CommentController=6]="CommentController",n[n.CommentThread=7]="CommentThread",n[n.CommentThreadInstance=8]="CommentThreadInstance",n[n.CommentThreadReply=9]="CommentThreadReply",n[n.CommentNode=10]="CommentNode",n[n.CommentThreadNode=11]="CommentThreadNode",n[n.TimelineActionContext=12]="TimelineActionContext",n[n.NotebookCellActionContext=13]="NotebookCellActionContext",n[n.NotebookActionContext=14]="NotebookActionContext",n[n.TerminalContext=15]="TerminalContext",n[n.TestItemContext=16]="TestItemContext",n[n.Date=17]="Date",n[n.TestMessageMenuArgs=18]="TestMessageMenuArgs"})(i||(t.MarshalledId=i={}))}),define(_e[94],Se([1,0]),function(ue,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getKoreanAltChars=i;function i(s){const r=I(s);if(r&&r.length>0)return new Uint32Array(r)}let n=0;const O=new Uint32Array(10);function I(s){if(n=0,N(s,v,w.InitialConsonant),n>0||(N(s,g,w.Vowel),n>0)||(N(s,d,w.FinalConsonant),n>0)||(N(s,e,w.CompatibilityJamo),n))return O.subarray(0,n);if(s>=44032&&s<=55203){const r=s-44032,l=r%588,o=Math.floor(r/588),p=Math.floor(l/28),A=l%28-1;if(o<v.length?N(o,v,0):w.InitialConsonant+o-w.CompatibilityJamo<e.length&&N(w.InitialConsonant+o,e,w.CompatibilityJamo),p<g.length?N(p,g,0):w.Vowel+p-w.CompatibilityJamo<e.length&&N(w.Vowel+p-w.CompatibilityJamo,e,w.CompatibilityJamo),A>=0&&(A<d.length?N(A,d,0):w.FinalConsonant+A-w.CompatibilityJamo<e.length&&N(w.FinalConsonant+A-w.CompatibilityJamo,e,w.CompatibilityJamo)),n>0)return O.subarray(0,n)}}function N(s,r,l){s>=l&&s<l+r.length&&b(r[s-l])}function b(s){s!==u.NUL&&(O[n++]=s&255,s>>8&&(O[n++]=s>>8&255),s>>16&&(O[n++]=s>>16&255))}var w;(function(s){s[s.InitialConsonant=4352]="InitialConsonant",s[s.Vowel=4449]="Vowel",s[s.FinalConsonant=4520]="FinalConsonant",s[s.CompatibilityJamo=12593]="CompatibilityJamo"})(w||(w={}));var u;(function(s){s[s.NUL=0]="NUL",s[s.A=65]="A",s[s.B=66]="B",s[s.C=67]="C",s[s.D=68]="D",s[s.E=69]="E",s[s.F=70]="F",s[s.G=71]="G",s[s.H=72]="H",s[s.I=73]="I",s[s.J=74]="J",s[s.K=75]="K",s[s.L=76]="L",s[s.M=77]="M",s[s.N=78]="N",s[s.O=79]="O",s[s.P=80]="P",s[s.Q=81]="Q",s[s.R=82]="R",s[s.S=83]="S",s[s.T=84]="T",s[s.U=85]="U",s[s.V=86]="V",s[s.W=87]="W",s[s.X=88]="X",s[s.Y=89]="Y",s[s.Z=90]="Z",s[s.a=97]="a",s[s.b=98]="b",s[s.c=99]="c",s[s.d=100]="d",s[s.e=101]="e",s[s.f=102]="f",s[s.g=103]="g",s[s.h=104]="h",s[s.i=105]="i",s[s.j=106]="j",s[s.k=107]="k",s[s.l=108]="l",s[s.m=109]="m",s[s.n=110]="n",s[s.o=111]="o",s[s.p=112]="p",s[s.q=113]="q",s[s.r=114]="r",s[s.s=115]="s",s[s.t=116]="t",s[s.u=117]="u",s[s.v=118]="v",s[s.w=119]="w",s[s.x=120]="x",s[s.y=121]="y",s[s.z=122]="z"})(u||(u={}));var m;(function(s){s[s.fa=24934]="fa",s[s.fg=26470]="fg",s[s.fq=29030]="fq",s[s.fr=29286]="fr",s[s.ft=29798]="ft",s[s.fv=30310]="fv",s[s.fx=30822]="fx",s[s.hk=27496]="hk",s[s.hl=27752]="hl",s[s.ho=28520]="ho",s[s.ml=27757]="ml",s[s.nj=27246]="nj",s[s.nl=27758]="nl",s[s.np=28782]="np",s[s.qt=29809]="qt",s[s.rt=29810]="rt",s[s.sg=26483]="sg",s[s.sw=30579]="sw"})(m||(m={}));const v=new Uint8Array([u.r,u.R,u.s,u.e,u.E,u.f,u.a,u.q,u.Q,u.t,u.T,u.d,u.w,u.W,u.c,u.z,u.x,u.v,u.g]),g=new Uint16Array([u.k,u.o,u.i,u.O,u.j,u.p,u.u,u.P,u.h,m.hk,m.ho,m.hl,u.y,u.n,m.nj,m.np,m.nl,u.b,u.m,m.ml,u.l]),d=new Uint16Array([u.r,u.R,m.rt,u.s,m.sw,m.sg,u.e,u.f,m.fr,m.fa,m.fq,m.ft,m.fx,m.fv,m.fg,u.a,u.q,m.qt,u.t,u.T,u.d,u.w,u.c,u.z,u.x,u.v,u.g]),e=new Uint16Array([u.r,u.R,m.rt,u.s,m.sw,m.sg,u.e,u.E,u.f,m.fr,m.fa,m.fq,m.ft,m.fx,m.fv,m.fg,u.a,u.q,u.Q,m.qt,u.t,u.T,u.d,u.w,u.W,u.c,u.z,u.x,u.v,u.g,u.k,u.o,u.i,u.O,u.j,u.p,u.u,u.P,u.h,m.hk,m.ho,m.hl,u.y,u.n,m.nj,m.np,m.nl,u.b,u.m,m.ml,u.l])}),define(_e[95],Se([1,0]),function(ue,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ArrayNavigator=void 0;class i{constructor(O,I=0,N=O.length,b=I-1){this.items=O,this.start=I,this.end=N,this.index=b}current(){return this.index===this.start-1||this.index===this.end?null:this.items[this.index]}next(){return this.index=Math.min(this.index+1,this.end),this.current()}previous(){return this.index=Math.max(this.index-1,this.start-1),this.current()}first(){return this.index=this.start,this.current()}last(){return this.index=this.end-1,this.current()}}t.ArrayNavigator=i}),define(_e[96],Se([1,0,58,95]),function(ue,t,i,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.HistoryNavigator2=t.HistoryNavigator=void 0;class O{constructor(b=[],w=10){this._initialize(b),this._limit=w,this._onChange()}getHistory(){return this._elements}add(b){this._history.delete(b),this._history.add(b),this._onChange()}next(){return this._navigator.next()}previous(){return this._currentPosition()!==0?this._navigator.previous():null}current(){return this._navigator.current()}first(){return this._navigator.first()}last(){return this._navigator.last()}isFirst(){return this._currentPosition()===0}isLast(){return this._currentPosition()>=this._elements.length-1}isNowhere(){return this._navigator.current()===null}has(b){return this._history.has(b)}clear(){this._initialize([]),this._onChange()}_onChange(){this._reduceToLimit();const b=this._elements;this._navigator=new n.ArrayNavigator(b,0,b.length,b.length)}_reduceToLimit(){const b=this._elements;b.length>this._limit&&this._initialize(b.slice(b.length-this._limit))}_currentPosition(){const b=this._navigator.current();return b?this._elements.indexOf(b):-1}_initialize(b){this._history=new Set;for(const w of b)this._history.add(w)}get _elements(){const b=[];return this._history.forEach(w=>b.push(w)),b}}t.HistoryNavigator=O;class I{get size(){return this._size}constructor(b,w=10,u=m=>m){if(this.capacity=w,this.identityFn=u,b.length<1)throw new Error("not supported");this._size=1,this.head=this.tail=this.cursor={value:b[0],previous:void 0,next:void 0},this.valueSet=new i.SetWithKey([b[0]],u);for(let m=1;m<b.length;m++)this.add(b[m])}add(b){const w={value:b,previous:this.tail,next:void 0};for(this.tail.next=w,this.tail=w,this.cursor=this.tail,this._size++,this.valueSet.has(b)?this._deleteFromList(b):this.valueSet.add(b);this._size>this.capacity;)this.valueSet.delete(this.head.value),this.head=this.head.next,this.head.previous=void 0,this._size--}replaceLast(b){if(this.identityFn(this.tail.value)===this.identityFn(b))return b;const w=this.tail.value;return this.valueSet.delete(w),this.tail.value=b,this.valueSet.has(b)?this._deleteFromList(b):this.valueSet.add(b),w}prepend(b){if(this._size===this.capacity||this.valueSet.has(b))return;const w={value:b,previous:void 0,next:this.head};this.head.previous=w,this.head=w,this._size++,this.valueSet.add(b)}isAtEnd(){return this.cursor===this.tail}current(){return this.cursor.value}previous(){return this.cursor.previous&&(this.cursor=this.cursor.previous),this.cursor.value}next(){return this.cursor.next&&(this.cursor=this.cursor.next),this.cursor.value}has(b){return this.valueSet.has(b)}resetCursor(){return this.cursor=this.tail,this.cursor.value}*[Symbol.iterator](){let b=this.head;for(;b;)yield b.value,b=b.next}_deleteFromList(b){let w=this.head;const u=this.identityFn(b);for(;w!==this.tail;)this.identityFn(w.value)===u&&(w===this.head?(this.head=this.head.next,this.head.previous=void 0):(w.previous.next=w.next,w.next.previous=w.previous),this._size--),w=w.next}}t.HistoryNavigator2=I}),define(_e[37],Se([1,0]),function(ue,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SlidingWindowAverage=t.MovingAverage=t.Counter=void 0,t.clamp=i,t.rot=n,t.isPointWithinTriangle=b;function i(w,u,m){return Math.min(Math.max(w,u),m)}function n(w,u){return(u+w%u)%u}class O{constructor(){this._next=0}getNext(){return this._next++}}t.Counter=O;class I{constructor(){this._n=1,this._val=0}update(u){return this._val=this._val+(u-this._val)/this._n,this._n+=1,this._val}get value(){return this._val}}t.MovingAverage=I;class N{constructor(u){this._n=0,this._val=0,this._values=[],this._index=0,this._sum=0,this._values=new Array(u),this._values.fill(0,0,u)}update(u){const m=this._values[this._index];return this._values[this._index]=u,this._index=(this._index+1)%this._values.length,this._sum-=m,this._sum+=u,this._n<this._values.length&&(this._n+=1),this._val=this._sum/this._n,this._val}get value(){return this._val}}t.SlidingWindowAverage=N;function b(w,u,m,v,g,d,e,s){const r=e-m,l=s-v,o=g-m,p=d-v,A=w-m,L=u-v,c=r*r+l*l,a=r*o+l*p,f=r*A+l*L,_=o*o+p*p,H=o*A+p*L,B=1/(c*_-a*a),F=(_*f-a*H)*B,E=(c*H-a*f)*B;return F>=0&&E>=0&&F+E<1}}),define(_e[26],Se([1,0]),function(ue,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DebugNameData=void 0,t.getDebugName=I,t.getFunctionName=g;class i{constructor(e,s,r){this.owner=e,this.debugNameSource=s,this.referenceFn=r}getDebugName(e){return I(e,this)}}t.DebugNameData=i;const n=new Map,O=new WeakMap;function I(d,e){const s=O.get(d);if(s)return s;const r=N(d,e);if(r){let l=n.get(r)??0;l++,n.set(r,l);const o=l===1?r:`${r}#${l}`;return O.set(d,o),o}}function N(d,e){const s=O.get(d);if(s)return s;const r=e.owner?m(e.owner)+".":"";let l;const o=e.debugNameSource;if(o!==void 0)if(typeof o=="function"){if(l=o(),l!==void 0)return r+l}else return r+o;const p=e.referenceFn;if(p!==void 0&&(l=g(p),l!==void 0))return r+l;if(e.owner!==void 0){const A=b(e.owner,d);if(A!==void 0)return r+A}}function b(d,e){for(const s in d)if(d[s]===e)return s}const w=new Map,u=new WeakMap;function m(d){const e=u.get(d);if(e)return e;const s=v(d);let r=w.get(s)??0;r++,w.set(s,r);const l=r===1?s:`${s}#${r}`;return u.set(d,l),l}function v(d){const e=d.constructor;return e?e.name:"Object"}function g(d){const e=d.toString(),r=/\/\*\*\s*@description\s*([^*]*)\*\//.exec(e);return(r?r[1]:void 0)?.trim()}}),define(_e[31],Se([1,0]),function(ue,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ConsoleObservableLogger=void 0,t.setLogger=n,t.getLogger=O;let i;function n(s){i=s}function O(){return i}class I{constructor(){this.indentation=0,this.changedObservablesSets=new WeakMap}textToConsoleArgs(r){return N([b(d("|  ",this.indentation)),r])}formatInfo(r){return r.hadValue?r.didChange?[b(" "),u(m(r.oldValue,70),{color:"red",strikeThrough:!0}),b(" "),u(m(r.newValue,60),{color:"green"})]:[b(" (unchanged)")]:[b(" "),u(m(r.newValue,60),{color:"green"}),b(" (initial)")]}handleObservableChanged(r,l){console.log(...this.textToConsoleArgs([w("observable value changed"),u(r.debugName,{color:"BlueViolet"}),...this.formatInfo(l)]))}formatChanges(r){if(r.size!==0)return u(" (changed deps: "+[...r].map(l=>l.debugName).join(", ")+")",{color:"gray"})}handleDerivedCreated(r){const l=r.handleChange;this.changedObservablesSets.set(r,new Set),r.handleChange=(o,p)=>(this.changedObservablesSets.get(r).add(o),l.apply(r,[o,p]))}handleDerivedRecomputed(r,l){const o=this.changedObservablesSets.get(r);console.log(...this.textToConsoleArgs([w("derived recomputed"),u(r.debugName,{color:"BlueViolet"}),...this.formatInfo(l),this.formatChanges(o),{data:[{fn:r._debugNameData.referenceFn??r._computeFn}]}])),o.clear()}handleFromEventObservableTriggered(r,l){console.log(...this.textToConsoleArgs([w("observable from event triggered"),u(r.debugName,{color:"BlueViolet"}),...this.formatInfo(l),{data:[{fn:r._getValue}]}]))}handleAutorunCreated(r){const l=r.handleChange;this.changedObservablesSets.set(r,new Set),r.handleChange=(o,p)=>(this.changedObservablesSets.get(r).add(o),l.apply(r,[o,p]))}handleAutorunTriggered(r){const l=this.changedObservablesSets.get(r);console.log(...this.textToConsoleArgs([w("autorun"),u(r.debugName,{color:"BlueViolet"}),this.formatChanges(l),{data:[{fn:r._debugNameData.referenceFn??r._runFn}]}])),l.clear(),this.indentation++}handleAutorunFinished(r){this.indentation--}handleBeginTransaction(r){let l=r.getDebugName();l===void 0&&(l=""),console.log(...this.textToConsoleArgs([w("transaction"),u(l,{color:"BlueViolet"}),{data:[{fn:r._fn}]}])),this.indentation++}handleEndTransaction(){this.indentation--}}t.ConsoleObservableLogger=I;function N(s){const r=new Array,l=[];let o="";function p(L){if("length"in L)for(const c of L)c&&p(c);else"text"in L?(o+=`%c${L.text}`,r.push(L.style),L.data&&l.push(...L.data)):"data"in L&&l.push(...L.data)}p(s);const A=[o,...r];return A.push(...l),A}function b(s){return u(s,{color:"black"})}function w(s){return u(e(`${s}: `,10),{color:"black",bold:!0})}function u(s,r={color:"black"}){function l(p){return Object.entries(p).reduce((A,[L,c])=>`${A}${L}:${c};`,"")}const o={color:r.color};return r.strikeThrough&&(o["text-decoration"]="line-through"),r.bold&&(o["font-weight"]="bold"),{text:s,style:l(o)}}function m(s,r){switch(typeof s){case"number":return""+s;case"string":return s.length+2<=r?`"${s}"`:`"${s.substr(0,r-7)}"+...`;case"boolean":return s?"true":"false";case"undefined":return"undefined";case"object":return s===null?"null":Array.isArray(s)?v(s,r):g(s,r);case"symbol":return s.toString();case"function":return`[[Function${s.name?" "+s.name:""}]]`;default:return""+s}}function v(s,r){let l="[ ",o=!0;for(const p of s){if(o||(l+=", "),l.length-5>r){l+="...";break}o=!1,l+=`${m(p,r-l.length)}`}return l+=" ]",l}function g(s,r){let l="{ ",o=!0;for(const[p,A]of Object.entries(s)){if(o||(l+=", "),l.length-5>r){l+="...";break}o=!1,l+=`${p}: ${m(A,r-l.length)}`}return l+=" }",l}function d(s,r){let l="";for(let o=1;o<=r;o++)l+=s;return l}function e(s,r){for(;s.length<r;)s+=" ";return s}}),define(_e[44],Se([1,0,42,2,26,31]),function(ue,t,i,n,O,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AutorunObserver=void 0,t.autorun=N,t.autorunOpts=b,t.autorunHandleChanges=w,t.autorunWithStoreHandleChanges=u,t.autorunWithStore=m,t.autorunDelta=v;function N(e){return new d(new O.DebugNameData(void 0,void 0,e),e,void 0,void 0)}function b(e,s){return new d(new O.DebugNameData(e.owner,e.debugName,e.debugReferenceFn??s),s,void 0,void 0)}function w(e,s){return new d(new O.DebugNameData(e.owner,e.debugName,e.debugReferenceFn??s),s,e.createEmptyChangeSummary,e.handleChange)}function u(e,s){const r=new n.DisposableStore,l=w({owner:e.owner,debugName:e.debugName,debugReferenceFn:e.debugReferenceFn??s,createEmptyChangeSummary:e.createEmptyChangeSummary,handleChange:e.handleChange},(o,p)=>{r.clear(),s(o,p,r)});return(0,n.toDisposable)(()=>{l.dispose(),r.dispose()})}function m(e){const s=new n.DisposableStore,r=b({owner:void 0,debugName:void 0,debugReferenceFn:e},l=>{s.clear(),e(l,s)});return(0,n.toDisposable)(()=>{r.dispose(),s.dispose()})}function v(e,s){let r;return b({debugReferenceFn:s},l=>{const o=e.read(l),p=r;r=o,s({lastValue:p,newValue:o})})}var g;(function(e){e[e.dependenciesMightHaveChanged=1]="dependenciesMightHaveChanged",e[e.stale=2]="stale",e[e.upToDate=3]="upToDate"})(g||(g={}));class d{get debugName(){return this._debugNameData.getDebugName(this)??"(anonymous)"}constructor(s,r,l,o){this._debugNameData=s,this._runFn=r,this.createChangeSummary=l,this._handleChange=o,this.state=g.stale,this.updateCount=0,this.disposed=!1,this.dependencies=new Set,this.dependenciesToBeRemoved=new Set,this.changeSummary=this.createChangeSummary?.(),(0,I.getLogger)()?.handleAutorunCreated(this),this._runIfNeeded(),(0,n.trackDisposable)(this)}dispose(){this.disposed=!0;for(const s of this.dependencies)s.removeObserver(this);this.dependencies.clear(),(0,n.markAsDisposed)(this)}_runIfNeeded(){if(this.state===g.upToDate)return;const s=this.dependenciesToBeRemoved;this.dependenciesToBeRemoved=this.dependencies,this.dependencies=s,this.state=g.upToDate;const r=this.disposed;try{if(!r){(0,I.getLogger)()?.handleAutorunTriggered(this);const l=this.changeSummary;this.changeSummary=this.createChangeSummary?.(),this._runFn(this,l)}}finally{r||(0,I.getLogger)()?.handleAutorunFinished(this);for(const l of this.dependenciesToBeRemoved)l.removeObserver(this);this.dependenciesToBeRemoved.clear()}}toString(){return`Autorun<${this.debugName}>`}beginUpdate(){this.state===g.upToDate&&(this.state=g.dependenciesMightHaveChanged),this.updateCount++}endUpdate(){if(this.updateCount===1)do{if(this.state===g.dependenciesMightHaveChanged){this.state=g.upToDate;for(const s of this.dependencies)if(s.reportChanges(),this.state===g.stale)break}this._runIfNeeded()}while(this.state!==g.upToDate);this.updateCount--,(0,i.assertFn)(()=>this.updateCount>=0)}handlePossibleChange(s){this.state===g.upToDate&&this.dependencies.has(s)&&!this.dependenciesToBeRemoved.has(s)&&(this.state=g.dependenciesMightHaveChanged)}handleChange(s,r){this.dependencies.has(s)&&!this.dependenciesToBeRemoved.has(s)&&(!this._handleChange||this._handleChange({changedObservable:s,change:r,didChange:o=>o===s},this.changeSummary))&&(this.state=g.stale)}readObservable(s){if(this.disposed)return s.get();s.addObserver(this);const r=s.get();return this.dependencies.add(s),this.dependenciesToBeRemoved.delete(s),r}}t.AutorunObserver=d,function(e){e.Observer=d}(N||(t.autorun=N={}))}),define(_e[27],Se([1,0,30,26,31]),function(ue,t,i,n,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DisposableObservableValue=t.ObservableValue=t.TransactionImpl=t.BaseObservable=t.ConvenientObservable=void 0,t._setRecomputeInitiallyAndOnChange=N,t._setKeepObserved=w,t._setDerivedOpts=m,t.transaction=d,t.globalTransaction=s,t.asyncTransaction=r,t.subtransaction=l,t.observableValue=p,t.disposableObservableValue=L;let I;function N(a){I=a}let b;function w(a){b=a}let u;function m(a){u=a}class v{get TChange(){return null}reportChanges(){this.get()}read(f){return f?f.readObservable(this):this.get()}map(f,_){const H=_===void 0?void 0:f,B=_===void 0?f:_;return u({owner:H,debugName:()=>{const F=(0,n.getFunctionName)(B);if(F!==void 0)return F;const k=/^\s*\(?\s*([a-zA-Z_$][a-zA-Z_$0-9]*)\s*\)?\s*=>\s*\1(?:\??)\.([a-zA-Z_$][a-zA-Z_$0-9]*)\s*$/.exec(B.toString());if(k)return`${this.debugName}.${k[2]}`;if(!H)return`${this.debugName} (mapped)`},debugReferenceFn:B},F=>B(this.read(F),F))}flatten(){return u({owner:void 0,debugName:()=>`${this.debugName} (flattened)`},f=>this.read(f).read(f))}recomputeInitiallyAndOnChange(f,_){return f.add(I(this,_)),this}keepObserved(f){return f.add(b(this)),this}get debugValue(){return this.get()}}t.ConvenientObservable=v;class g extends v{constructor(){super(...arguments),this.observers=new Set}addObserver(f){const _=this.observers.size;this.observers.add(f),_===0&&this.onFirstObserverAdded()}removeObserver(f){this.observers.delete(f)&&this.observers.size===0&&this.onLastObserverRemoved()}onFirstObserverAdded(){}onLastObserverRemoved(){}}t.BaseObservable=g;function d(a,f){const _=new o(a,f);try{a(_)}finally{_.finish()}}let e;function s(a){if(e)a(e);else{const f=new o(a,void 0);e=f;try{a(f)}finally{f.finish(),e=void 0}}}async function r(a,f){const _=new o(a,f);try{await a(_)}finally{_.finish()}}function l(a,f,_){a?f(a):d(f,_)}class o{constructor(f,_){this._fn=f,this._getDebugName=_,this.updatingObservers=[],(0,O.getLogger)()?.handleBeginTransaction(this)}getDebugName(){return this._getDebugName?this._getDebugName():(0,n.getFunctionName)(this._fn)}updateObserver(f,_){this.updatingObservers.push({observer:f,observable:_}),f.beginUpdate(_)}finish(){const f=this.updatingObservers;for(let _=0;_<f.length;_++){const{observer:H,observable:B}=f[_];H.endUpdate(B)}this.updatingObservers=null,(0,O.getLogger)()?.handleEndTransaction()}}t.TransactionImpl=o;function p(a,f){let _;return typeof a=="string"?_=new n.DebugNameData(void 0,a,void 0):_=new n.DebugNameData(a,void 0,void 0),new A(_,f,i.strictEquals)}class A extends g{get debugName(){return this._debugNameData.getDebugName(this)??"ObservableValue"}constructor(f,_,H){super(),this._debugNameData=f,this._equalityComparator=H,this._value=_}get(){return this._value}set(f,_,H){if(H===void 0&&this._equalityComparator(this._value,f))return;let B;_||(_=B=new o(()=>{},()=>`Setting ${this.debugName}`));try{const F=this._value;this._setValue(f),(0,O.getLogger)()?.handleObservableChanged(this,{oldValue:F,newValue:f,change:H,didChange:!0,hadValue:!0});for(const E of this.observers)_.updateObserver(E,this),E.handleChange(this,H)}finally{B&&B.finish()}}toString(){return`${this.debugName}: ${this._value}`}_setValue(f){this._value=f}}t.ObservableValue=A;function L(a,f){let _;return typeof a=="string"?_=new n.DebugNameData(void 0,a,void 0):_=new n.DebugNameData(a,void 0,void 0),new c(_,f,i.strictEquals)}class c extends A{_setValue(f){this._value!==f&&(this._value&&this._value.dispose(),this._value=f)}dispose(){this._value?.dispose()}}t.DisposableObservableValue=c}),define(_e[45],Se([1,0,42,30,2,27,26,31]),function(ue,t,i,n,O,I,N,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DerivedWithSetter=t.Derived=void 0,t.derived=w,t.derivedWithSetter=u,t.derivedOpts=m,t.derivedHandleChanges=v,t.derivedWithStore=g,t.derivedDisposable=d;function w(l,o){return o!==void 0?new s(new N.DebugNameData(l,void 0,o),o,void 0,void 0,void 0,n.strictEquals):new s(new N.DebugNameData(void 0,void 0,l),l,void 0,void 0,void 0,n.strictEquals)}function u(l,o,p){return new r(new N.DebugNameData(l,void 0,o),o,void 0,void 0,void 0,n.strictEquals,p)}function m(l,o){return new s(new N.DebugNameData(l.owner,l.debugName,l.debugReferenceFn),o,void 0,void 0,l.onLastObserverRemoved,l.equalsFn??n.strictEquals)}(0,I._setDerivedOpts)(m);function v(l,o){return new s(new N.DebugNameData(l.owner,l.debugName,void 0),o,l.createEmptyChangeSummary,l.handleChange,void 0,l.equalityComparer??n.strictEquals)}function g(l,o){let p,A;o===void 0?(p=l,A=void 0):(A=l,p=o);const L=new O.DisposableStore;return new s(new N.DebugNameData(A,void 0,p),c=>(L.clear(),p(c,L)),void 0,void 0,()=>L.dispose(),n.strictEquals)}function d(l,o){let p,A;o===void 0?(p=l,A=void 0):(A=l,p=o);let L;return new s(new N.DebugNameData(A,void 0,p),c=>{L?L.clear():L=new O.DisposableStore;const a=p(c);return a&&L.add(a),a},void 0,void 0,()=>{L&&(L.dispose(),L=void 0)},n.strictEquals)}var e;(function(l){l[l.initial=0]="initial",l[l.dependenciesMightHaveChanged=1]="dependenciesMightHaveChanged",l[l.stale=2]="stale",l[l.upToDate=3]="upToDate"})(e||(e={}));class s extends I.BaseObservable{get debugName(){return this._debugNameData.getDebugName(this)??"(anonymous)"}constructor(o,p,A,L,c=void 0,a){super(),this._debugNameData=o,this._computeFn=p,this.createChangeSummary=A,this._handleChange=L,this._handleLastObserverRemoved=c,this._equalityComparator=a,this.state=e.initial,this.value=void 0,this.updateCount=0,this.dependencies=new Set,this.dependenciesToBeRemoved=new Set,this.changeSummary=void 0,this.changeSummary=this.createChangeSummary?.(),(0,b.getLogger)()?.handleDerivedCreated(this)}onLastObserverRemoved(){this.state=e.initial,this.value=void 0;for(const o of this.dependencies)o.removeObserver(this);this.dependencies.clear(),this._handleLastObserverRemoved?.()}get(){if(this.observers.size===0){const o=this._computeFn(this,this.createChangeSummary?.());return this.onLastObserverRemoved(),o}else{do{if(this.state===e.dependenciesMightHaveChanged){for(const o of this.dependencies)if(o.reportChanges(),this.state===e.stale)break}this.state===e.dependenciesMightHaveChanged&&(this.state=e.upToDate),this._recomputeIfNeeded()}while(this.state!==e.upToDate);return this.value}}_recomputeIfNeeded(){if(this.state===e.upToDate)return;const o=this.dependenciesToBeRemoved;this.dependenciesToBeRemoved=this.dependencies,this.dependencies=o;const p=this.state!==e.initial,A=this.value;this.state=e.upToDate;const L=this.changeSummary;this.changeSummary=this.createChangeSummary?.();try{this.value=this._computeFn(this,L)}finally{for(const a of this.dependenciesToBeRemoved)a.removeObserver(this);this.dependenciesToBeRemoved.clear()}const c=p&&!this._equalityComparator(A,this.value);if((0,b.getLogger)()?.handleDerivedRecomputed(this,{oldValue:A,newValue:this.value,change:void 0,didChange:c,hadValue:p}),c)for(const a of this.observers)a.handleChange(this,void 0)}toString(){return`LazyDerived<${this.debugName}>`}beginUpdate(o){this.updateCount++;const p=this.updateCount===1;if(this.state===e.upToDate&&(this.state=e.dependenciesMightHaveChanged,!p))for(const A of this.observers)A.handlePossibleChange(this);if(p)for(const A of this.observers)A.beginUpdate(this)}endUpdate(o){if(this.updateCount--,this.updateCount===0){const p=[...this.observers];for(const A of p)A.endUpdate(this)}(0,i.assertFn)(()=>this.updateCount>=0)}handlePossibleChange(o){if(this.state===e.upToDate&&this.dependencies.has(o)&&!this.dependenciesToBeRemoved.has(o)){this.state=e.dependenciesMightHaveChanged;for(const p of this.observers)p.handlePossibleChange(this)}}handleChange(o,p){if(this.dependencies.has(o)&&!this.dependenciesToBeRemoved.has(o)){const A=this._handleChange?this._handleChange({changedObservable:o,change:p,didChange:c=>c===o},this.changeSummary):!0,L=this.state===e.upToDate;if(A&&(this.state===e.dependenciesMightHaveChanged||L)&&(this.state=e.stale,L))for(const c of this.observers)c.handlePossibleChange(this)}}readObservable(o){o.addObserver(this);const p=o.get();return this.dependencies.add(o),this.dependenciesToBeRemoved.delete(o),p}addObserver(o){const p=!this.observers.has(o)&&this.updateCount>0;super.addObserver(o),p&&o.beginUpdate(this)}removeObserver(o){const p=this.observers.has(o)&&this.updateCount>0;super.removeObserver(o),p&&o.endUpdate(this)}}t.Derived=s;class r extends s{constructor(o,p,A,L,c=void 0,a,f){super(o,p,A,L,c,a),this.set=f}}t.DerivedWithSetter=r}),define(_e[97],Se([1,0,27]),function(ue,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LazyObservableValue=void 0;class n extends i.BaseObservable{get debugName(){return this._debugNameData.getDebugName(this)??"LazyObservableValue"}constructor(I,N,b){super(),this._debugNameData=I,this._equalityComparator=b,this._isUpToDate=!0,this._deltas=[],this._updateCounter=0,this._value=N}get(){return this._update(),this._value}_update(){if(!this._isUpToDate)if(this._isUpToDate=!0,this._deltas.length>0){for(const I of this.observers)for(const N of this._deltas)I.handleChange(this,N);this._deltas.length=0}else for(const I of this.observers)I.handleChange(this,void 0)}_beginUpdate(){if(this._updateCounter++,this._updateCounter===1)for(const I of this.observers)I.beginUpdate(this)}_endUpdate(){if(this._updateCounter--,this._updateCounter===0){this._update();const I=[...this.observers];for(const N of I)N.endUpdate(this)}}addObserver(I){const N=!this.observers.has(I)&&this._updateCounter>0;super.addObserver(I),N&&I.beginUpdate(this)}removeObserver(I){const N=this.observers.has(I)&&this._updateCounter>0;super.removeObserver(I),N&&I.endUpdate(this)}set(I,N,b){if(b===void 0&&this._equalityComparator(this._value,I))return;let w;N||(N=w=new i.TransactionImpl(()=>{},()=>`Setting ${this.debugName}`));try{if(this._isUpToDate=!1,this._setValue(I),b!==void 0&&this._deltas.push(b),N.updateObserver({beginUpdate:()=>this._beginUpdate(),endUpdate:()=>this._endUpdate(),handleChange:(u,m)=>{},handlePossibleChange:u=>{}},this),this._updateCounter>1)for(const u of this.observers)u.handlePossibleChange(this)}finally{w&&w.finish()}}toString(){return`${this.debugName}: ${this._value}`}_setValue(I){this._value=I}}t.LazyObservableValue=n}),define(_e[98],Se([1,0,30,27,26,97]),function(ue,t,i,n,O,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.observableValueOpts=N;function N(b,w){return b.lazy?new I.LazyObservableValue(new O.DebugNameData(b.owner,b.debugName,void 0),w,b.equalsFn??i.strictEquals):new n.ObservableValue(new O.DebugNameData(b.owner,b.debugName,void 0),w,b.equalsFn??i.strictEquals)}}),define(_e[46],Se([1,0]),function(ue,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Range=void 0;var i;(function(n){function O(w,u){if(w.start>=u.end||u.start>=w.end)return{start:0,end:0};const m=Math.max(w.start,u.start),v=Math.min(w.end,u.end);return v-m<=0?{start:0,end:0}:{start:m,end:v}}n.intersect=O;function I(w){return w.end-w.start<=0}n.isEmpty=I;function N(w,u){return!I(O(w,u))}n.intersects=N;function b(w,u){const m=[],v={start:w.start,end:Math.min(u.start,w.end)},g={start:Math.max(u.end,w.start),end:w.end};return I(v)||m.push(v),I(g)||m.push(g),m}n.relativeComplement=b})(i||(t.Range=i={}))}),define(_e[99],Se([1,0,46]),function(ue,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.RangeMap=void 0,t.groupIntersect=n,t.shift=O,t.consolidate=I;function n(w,u){const m=[];for(const v of u){if(w.start>=v.range.end)continue;if(w.end<v.range.start)break;const g=i.Range.intersect(w,v.range);i.Range.isEmpty(g)||m.push({range:g,size:v.size})}return m}function O({start:w,end:u},m){return{start:w+m,end:u+m}}function I(w){const u=[];let m=null;for(const v of w){const g=v.range.start,d=v.range.end,e=v.size;if(m&&e===m.size){m.range.end=d;continue}m={range:{start:g,end:d},size:e},u.push(m)}return u}function N(...w){return I(w.reduce((u,m)=>u.concat(m),[]))}class b{get paddingTop(){return this._paddingTop}set paddingTop(u){this._size=this._size+u-this._paddingTop,this._paddingTop=u}constructor(u){this.groups=[],this._size=0,this._paddingTop=0,this._paddingTop=u??0,this._size=this._paddingTop}splice(u,m,v=[]){const g=v.length-m,d=n({start:0,end:u},this.groups),e=n({start:u+m,end:Number.POSITIVE_INFINITY},this.groups).map(r=>({range:O(r.range,g),size:r.size})),s=v.map((r,l)=>({range:{start:u+l,end:u+l+1},size:r.size}));this.groups=N(d,s,e),this._size=this._paddingTop+this.groups.reduce((r,l)=>r+l.size*(l.range.end-l.range.start),0)}get count(){const u=this.groups.length;return u?this.groups[u-1].range.end:0}get size(){return this._size}indexAt(u){if(u<0)return-1;if(u<this._paddingTop)return 0;let m=0,v=this._paddingTop;for(const g of this.groups){const d=g.range.end-g.range.start,e=v+d*g.size;if(u<e)return m+Math.floor((u-v)/g.size);m+=d,v=e}return m}indexAfter(u){return Math.min(this.indexAt(u)+1,this.count)}positionAt(u){if(u<0)return-1;let m=0,v=0;for(const g of this.groups){const d=g.range.end-g.range.start,e=v+d;if(u<e)return this._paddingTop+m+(u-v)*g.size;m+=d*g.size,v=e}return-1}}t.RangeMap=b}),define(_e[100],Se([1,0]),function(ue,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StopWatch=void 0;const i=globalThis.performance&&typeof globalThis.performance.now=="function";class n{static create(I){return new n(I)}constructor(I){this._now=i&&I===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this._startTime=this._now(),this._stopTime=-1}stop(){this._stopTime=this._now()}reset(){this._startTime=this._now(),this._stopTime=-1}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}}t.StopWatch=n}),define(_e[3],Se([1,0,6,59,2,60,100]),function(ue,t,i,n,O,I,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ValueWithChangeEvent=t.Relay=t.EventBufferer=t.DynamicListEventMultiplexer=t.EventMultiplexer=t.MicrotaskEmitter=t.DebounceEmitter=t.PauseableEmitter=t.AsyncEmitter=t.createEventDeliveryQueue=t.Emitter=t.ListenerRefusalError=t.ListenerLeakError=t.EventProfiling=t.Event=void 0,t.setGlobalLeakWarningThreshold=d;const b=!1,w=!1,u=!1;var m;(function(Y){Y.None=()=>O.Disposable.None;function Z(V){if(u){const{onDidAddListener:q}=V,se=s.create();let ae=0;V.onDidAddListener=()=>{++ae===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),se.print()),q?.()}}}function ce(V,q){return Ee(V,()=>{},0,void 0,!0,void 0,q)}Y.defer=ce;function he(V){return(q,se=null,ae)=>{let ge=!1,we;return we=V(De=>{if(!ge)return we?we.dispose():ge=!0,q.call(se,De)},null,ae),ge&&we.dispose(),we}}Y.once=he;function ye(V,q){return Y.once(Y.filter(V,q))}Y.onceIf=ye;function Re(V,q,se){return Ne((ae,ge=null,we)=>V(De=>ae.call(ge,q(De)),null,we),se)}Y.map=Re;function Pe(V,q,se){return Ne((ae,ge=null,we)=>V(De=>{q(De),ae.call(ge,De)},null,we),se)}Y.forEach=Pe;function re(V,q,se){return Ne((ae,ge=null,we)=>V(De=>q(De)&&ae.call(ge,De),null,we),se)}Y.filter=re;function ie(V){return V}Y.signal=ie;function fe(...V){return(q,se=null,ae)=>{const ge=(0,O.combinedDisposable)(...V.map(we=>we(De=>q.call(se,De))));return ne(ge,ae)}}Y.any=fe;function ve(V,q,se,ae){let ge=se;return Re(V,we=>(ge=q(ge,we),ge),ae)}Y.reduce=ve;function Ne(V,q){let se;const ae={onWillAddFirstListener(){se=V(ge.fire,ge)},onDidRemoveLastListener(){se?.dispose()}};q||Z(ae);const ge=new a(ae);return q?.add(ge),ge.event}function ne(V,q){return q instanceof Array?q.push(V):q&&q.add(V),V}function Ee(V,q,se=100,ae=!1,ge=!1,we,De){let Te,Oe,Ae,ke=0,Ge;const it={leakWarningThreshold:we,onWillAddFirstListener(){Te=V(ft=>{ke++,Oe=q(Oe,ft),ae&&!Ae&&(rt.fire(Oe),Oe=void 0),Ge=()=>{const ht=Oe;Oe=void 0,Ae=void 0,(!ae||ke>1)&&rt.fire(ht),ke=0},typeof se=="number"?(clearTimeout(Ae),Ae=setTimeout(Ge,se)):Ae===void 0&&(Ae=0,queueMicrotask(Ge))})},onWillRemoveListener(){ge&&ke>0&&Ge?.()},onDidRemoveLastListener(){Ge=void 0,Te.dispose()}};De||Z(it);const rt=new a(it);return De?.add(rt),rt.event}Y.debounce=Ee;function Le(V,q=0,se){return Y.debounce(V,(ae,ge)=>ae?(ae.push(ge),ae):[ge],q,void 0,!0,void 0,se)}Y.accumulate=Le;function Ce(V,q=(ae,ge)=>ae===ge,se){let ae=!0,ge;return re(V,we=>{const De=ae||!q(we,ge);return ae=!1,ge=we,De},se)}Y.latch=Ce;function Fe(V,q,se){return[Y.filter(V,q,se),Y.filter(V,ae=>!q(ae),se)]}Y.split=Fe;function ze(V,q=!1,se=[],ae){let ge=se.slice(),we=V(Oe=>{ge?ge.push(Oe):Te.fire(Oe)});ae&&ae.add(we);const De=()=>{ge?.forEach(Oe=>Te.fire(Oe)),ge=null},Te=new a({onWillAddFirstListener(){we||(we=V(Oe=>Te.fire(Oe)),ae&&ae.add(we))},onDidAddFirstListener(){ge&&(q?setTimeout(De):De())},onDidRemoveLastListener(){we&&we.dispose(),we=null}});return ae&&ae.add(Te),Te.event}Y.buffer=ze;function Xe(V,q){return(ae,ge,we)=>{const De=q(new x);return V(function(Te){const Oe=De.evaluate(Te);Oe!==oe&&ae.call(ge,Oe)},void 0,we)}}Y.chain=Xe;const oe=Symbol("HaltChainable");class x{constructor(){this.steps=[]}map(q){return this.steps.push(q),this}forEach(q){return this.steps.push(se=>(q(se),se)),this}filter(q){return this.steps.push(se=>q(se)?se:oe),this}reduce(q,se){let ae=se;return this.steps.push(ge=>(ae=q(ae,ge),ae)),this}latch(q=(se,ae)=>se===ae){let se=!0,ae;return this.steps.push(ge=>{const we=se||!q(ge,ae);return se=!1,ae=ge,we?ge:oe}),this}evaluate(q){for(const se of this.steps)if(q=se(q),q===oe)break;return q}}function h(V,q,se=ae=>ae){const ae=(...Te)=>De.fire(se(...Te)),ge=()=>V.on(q,ae),we=()=>V.removeListener(q,ae),De=new a({onWillAddFirstListener:ge,onDidRemoveLastListener:we});return De.event}Y.fromNodeEventEmitter=h;function S(V,q,se=ae=>ae){const ae=(...Te)=>De.fire(se(...Te)),ge=()=>V.addEventListener(q,ae),we=()=>V.removeEventListener(q,ae),De=new a({onWillAddFirstListener:ge,onDidRemoveLastListener:we});return De.event}Y.fromDOMEventEmitter=S;function P(V){return new Promise(q=>he(V)(q))}Y.toPromise=P;function G(V){const q=new a;return V.then(se=>{q.fire(se)},()=>{q.fire(void 0)}).finally(()=>{q.dispose()}),q.event}Y.fromPromise=G;function J(V,q){return V(se=>q.fire(se))}Y.forward=J;function te(V,q,se){return q(se),V(ae=>q(ae))}Y.runAndSubscribe=te;class y{constructor(q,se){this._observable=q,this._counter=0,this._hasChanged=!1;const ae={onWillAddFirstListener:()=>{q.addObserver(this),this._observable.reportChanges()},onDidRemoveLastListener:()=>{q.removeObserver(this)}};se||Z(ae),this.emitter=new a(ae),se&&se.add(this.emitter)}beginUpdate(q){this._counter++}handlePossibleChange(q){}handleChange(q,se){this._hasChanged=!0}endUpdate(q){this._counter--,this._counter===0&&(this._observable.reportChanges(),this._hasChanged&&(this._hasChanged=!1,this.emitter.fire(this._observable.get())))}}function D(V,q){return new y(V,q).emitter.event}Y.fromObservable=D;function z(V){return(q,se,ae)=>{let ge=0,we=!1;const De={beginUpdate(){ge++},endUpdate(){ge--,ge===0&&(V.reportChanges(),we&&(we=!1,q.call(se)))},handlePossibleChange(){},handleChange(){we=!0}};V.addObserver(De),V.reportChanges();const Te={dispose(){V.removeObserver(De)}};return ae instanceof O.DisposableStore?ae.add(Te):Array.isArray(ae)&&ae.push(Te),Te}}Y.fromObservableLight=z})(m||(t.Event=m={}));class v{static{this.all=new Set}static{this._idPool=0}constructor(Z){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${Z}_${v._idPool++}`,v.all.add(this)}start(Z){this._stopWatch=new N.StopWatch,this.listenerCount=Z}stop(){if(this._stopWatch){const Z=this._stopWatch.elapsed();this.durations.push(Z),this.elapsedOverall+=Z,this.invocationCount+=1,this._stopWatch=void 0}}}t.EventProfiling=v;let g=-1;function d(Y){const Z=g;return g=Y,{dispose(){g=Z}}}class e{static{this._idPool=1}constructor(Z,ce,he=(e._idPool++).toString(16).padStart(3,"0")){this._errorHandler=Z,this.threshold=ce,this.name=he,this._warnCountdown=0}dispose(){this._stacks?.clear()}check(Z,ce){const he=this.threshold;if(he<=0||ce<he)return;this._stacks||(this._stacks=new Map);const ye=this._stacks.get(Z.value)||0;if(this._stacks.set(Z.value,ye+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=he*.5;const[Re,Pe]=this.getMostFrequentStack(),re=`[${this.name}] potential listener LEAK detected, having ${ce} listeners already. MOST frequent listener (${Pe}):`;console.warn(re),console.warn(Re);const ie=new r(re,Re);this._errorHandler(ie)}return()=>{const Re=this._stacks.get(Z.value)||0;this._stacks.set(Z.value,Re-1)}}getMostFrequentStack(){if(!this._stacks)return;let Z,ce=0;for(const[he,ye]of this._stacks)(!Z||ce<ye)&&(Z=[he,ye],ce=ye);return Z}}class s{static create(){const Z=new Error;return new s(Z.stack??"")}constructor(Z){this.value=Z}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class r extends Error{constructor(Z,ce){super(Z),this.name="ListenerLeakError",this.stack=ce}}t.ListenerLeakError=r;class l extends Error{constructor(Z,ce){super(Z),this.name="ListenerRefusalError",this.stack=ce}}t.ListenerRefusalError=l;let o=0;class p{constructor(Z){this.value=Z,this.id=o++}}const A=2,L=(Y,Z)=>{if(Y instanceof p)Z(Y);else for(let ce=0;ce<Y.length;ce++){const he=Y[ce];he&&Z(he)}};let c;if(b){const Y=[];setInterval(()=>{Y.length!==0&&(console.warn("[LEAKING LISTENERS] GC'ed these listeners that were NOT yet disposed:"),console.warn(Y.join(`
`)),Y.length=0)},3e3),c=new FinalizationRegistry(Z=>{typeof Z=="string"&&Y.push(Z)})}class a{constructor(Z){this._size=0,this._options=Z,this._leakageMon=g>0||this._options?.leakWarningThreshold?new e(Z?.onListenerError??i.onUnexpectedError,this._options?.leakWarningThreshold??g):void 0,this._perfMon=this._options?._profName?new v(this._options._profName):void 0,this._deliveryQueue=this._options?.deliveryQueue}dispose(){if(!this._disposed){if(this._disposed=!0,this._deliveryQueue?.current===this&&this._deliveryQueue.reset(),this._listeners){if(w){const Z=this._listeners;queueMicrotask(()=>{L(Z,ce=>ce.stack?.print())})}this._listeners=void 0,this._size=0}this._options?.onDidRemoveLastListener?.(),this._leakageMon?.dispose()}}get event(){return this._event??=(Z,ce,he)=>{if(this._leakageMon&&this._size>this._leakageMon.threshold**2){const ie=`[${this._leakageMon.name}] REFUSES to accept new listeners because it exceeded its threshold by far (${this._size} vs ${this._leakageMon.threshold})`;console.warn(ie);const fe=this._leakageMon.getMostFrequentStack()??["UNKNOWN stack",-1],ve=new l(`${ie}. HINT: Stack shows most frequent listener (${fe[1]}-times)`,fe[0]);return(this._options?.onListenerError||i.onUnexpectedError)(ve),O.Disposable.None}if(this._disposed)return O.Disposable.None;ce&&(Z=Z.bind(ce));const ye=new p(Z);let Re,Pe;this._leakageMon&&this._size>=Math.ceil(this._leakageMon.threshold*.2)&&(ye.stack=s.create(),Re=this._leakageMon.check(ye.stack,this._size+1)),w&&(ye.stack=Pe??s.create()),this._listeners?this._listeners instanceof p?(this._deliveryQueue??=new _,this._listeners=[this._listeners,ye]):this._listeners.push(ye):(this._options?.onWillAddFirstListener?.(this),this._listeners=ye,this._options?.onDidAddFirstListener?.(this)),this._size++;const re=(0,O.toDisposable)(()=>{c?.unregister(re),Re?.(),this._removeListener(ye)});if(he instanceof O.DisposableStore?he.add(re):Array.isArray(he)&&he.push(re),c){const ie=new Error().stack.split(`
`).slice(2,3).join(`
`).trim(),fe=/(file:|vscode-file:\/\/vscode-app)?(\/[^:]*:\d+:\d+)/.exec(ie);c.register(re,fe?.[2]??ie,re)}return re},this._event}_removeListener(Z){if(this._options?.onWillRemoveListener?.(this),!this._listeners)return;if(this._size===1){this._listeners=void 0,this._options?.onDidRemoveLastListener?.(this),this._size=0;return}const ce=this._listeners,he=ce.indexOf(Z);if(he===-1)throw console.log("disposed?",this._disposed),console.log("size?",this._size),console.log("arr?",JSON.stringify(this._listeners)),new Error("Attempted to dispose unknown listener");this._size--,ce[he]=void 0;const ye=this._deliveryQueue.current===this;if(this._size*A<=ce.length){let Re=0;for(let Pe=0;Pe<ce.length;Pe++)ce[Pe]?ce[Re++]=ce[Pe]:ye&&(this._deliveryQueue.end--,Re<this._deliveryQueue.i&&this._deliveryQueue.i--);ce.length=Re}}_deliver(Z,ce){if(!Z)return;const he=this._options?.onListenerError||i.onUnexpectedError;if(!he){Z.value(ce);return}try{Z.value(ce)}catch(ye){he(ye)}}_deliverQueue(Z){const ce=Z.current._listeners;for(;Z.i<Z.end;)this._deliver(ce[Z.i++],Z.value);Z.reset()}fire(Z){if(this._deliveryQueue?.current&&(this._deliverQueue(this._deliveryQueue),this._perfMon?.stop()),this._perfMon?.start(this._size),this._listeners)if(this._listeners instanceof p)this._deliver(this._listeners,Z);else{const ce=this._deliveryQueue;ce.enqueue(this,Z,this._listeners.length),this._deliverQueue(ce)}this._perfMon?.stop()}hasListeners(){return this._size>0}}t.Emitter=a;const f=()=>new _;t.createEventDeliveryQueue=f;class _{constructor(){this.i=-1,this.end=0}enqueue(Z,ce,he){this.i=0,this.end=he,this.current=Z,this.value=ce}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class H extends a{async fireAsync(Z,ce,he){if(this._listeners)for(this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new I.LinkedList),L(this._listeners,ye=>this._asyncDeliveryQueue.push([ye.value,Z]));this._asyncDeliveryQueue.size>0&&!ce.isCancellationRequested;){const[ye,Re]=this._asyncDeliveryQueue.shift(),Pe=[],re={...Re,token:ce,waitUntil:ie=>{if(Object.isFrozen(Pe))throw new Error("waitUntil can NOT be called asynchronous");he&&(ie=he(ie,ye)),Pe.push(ie)}};try{ye(re)}catch(ie){(0,i.onUnexpectedError)(ie);continue}Object.freeze(Pe),await Promise.allSettled(Pe).then(ie=>{for(const fe of ie)fe.status==="rejected"&&(0,i.onUnexpectedError)(fe.reason)})}}}t.AsyncEmitter=H;class B extends a{get isPaused(){return this._isPaused!==0}constructor(Z){super(Z),this._isPaused=0,this._eventQueue=new I.LinkedList,this._mergeFn=Z?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused===0)if(this._mergeFn){if(this._eventQueue.size>0){const Z=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(Z))}}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(Z){this._size&&(this._isPaused!==0?this._eventQueue.push(Z):super.fire(Z))}}t.PauseableEmitter=B;class F extends B{constructor(Z){super(Z),this._delay=Z.delay??100}fire(Z){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(Z)}}t.DebounceEmitter=F;class E extends a{constructor(Z){super(Z),this._queuedEvents=[],this._mergeFn=Z?.merge}fire(Z){this.hasListeners()&&(this._queuedEvents.push(Z),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(ce=>super.fire(ce)),this._queuedEvents=[]}))}}t.MicrotaskEmitter=E;class k{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new a({onWillAddFirstListener:()=>this.onFirstListenerAdd(),onDidRemoveLastListener:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(Z){const ce={event:Z,listener:null};this.events.push(ce),this.hasListeners&&this.hook(ce);const he=()=>{this.hasListeners&&this.unhook(ce);const ye=this.events.indexOf(ce);this.events.splice(ye,1)};return(0,O.toDisposable)((0,n.createSingleCallFunction)(he))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(Z=>this.hook(Z))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(Z=>this.unhook(Z))}hook(Z){Z.listener=Z.event(ce=>this.emitter.fire(ce))}unhook(Z){Z.listener?.dispose(),Z.listener=null}dispose(){this.emitter.dispose();for(const Z of this.events)Z.listener?.dispose();this.events=[]}}t.EventMultiplexer=k;class W{constructor(Z,ce,he,ye){this._store=new O.DisposableStore;const Re=this._store.add(new k),Pe=this._store.add(new O.DisposableMap);function re(ie){Pe.set(ie,Re.add(ye(ie)))}for(const ie of Z)re(ie);this._store.add(ce(ie=>{re(ie)})),this._store.add(he(ie=>{Pe.deleteAndDispose(ie)})),this.event=Re.event}dispose(){this._store.dispose()}}t.DynamicListEventMultiplexer=W;class R{constructor(){this.data=[]}wrapEvent(Z,ce,he){return(ye,Re,Pe)=>Z(re=>{const ie=this.data[this.data.length-1];if(!ce){ie?ie.buffers.push(()=>ye.call(Re,re)):ye.call(Re,re);return}const fe=ie;if(!fe){ye.call(Re,ce(he,re));return}fe.items??=[],fe.items.push(re),fe.buffers.length===0&&ie.buffers.push(()=>{fe.reducedResult??=he?fe.items.reduce(ce,he):fe.items.reduce(ce),ye.call(Re,fe.reducedResult)})},void 0,Pe)}bufferEvents(Z){const ce={buffers:new Array};this.data.push(ce);const he=Z();return this.data.pop(),ce.buffers.forEach(ye=>ye()),he}}t.EventBufferer=R;class C{constructor(){this.listening=!1,this.inputEvent=m.None,this.inputEventListener=O.Disposable.None,this.emitter=new a({onDidAddFirstListener:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onDidRemoveLastListener:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(Z){this.inputEvent=Z,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=Z(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}t.Relay=C;class ${static const(Z){return new ee(Z)}constructor(Z){this._value=Z,this._onDidChange=new a,this.onDidChange=this._onDidChange.event}get value(){return this._value}set value(Z){Z!==this._value&&(this._value=Z,this._onDidChange.fire(void 0))}}t.ValueWithChangeEvent=$;class ee{constructor(Z){this.value=Z,this.onDidChange=m.None}}}),define(_e[18],Se([1,0,24,3]),function(ue,t,i,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isAndroid=t.isElectron=t.isWebkitWebView=t.isSafari=t.isChrome=t.isWebKit=t.isFirefox=t.onDidChangeFullscreen=t.onDidChangeZoomLevel=void 0,t.addMatchMediaChangeListener=I,t.setZoomLevel=N,t.getZoomLevel=b,t.getZoomFactor=w,t.setZoomFactor=u,t.setFullscreen=m,t.isFullscreen=v,t.isStandalone=e,t.isWCOEnabled=s,t.getWCOTitlebarAreaRect=r;class O{constructor(){this.mapWindowIdToZoomLevel=new Map,this._onDidChangeZoomLevel=new n.Emitter,this.onDidChangeZoomLevel=this._onDidChangeZoomLevel.event,this.mapWindowIdToZoomFactor=new Map,this._onDidChangeFullscreen=new n.Emitter,this.onDidChangeFullscreen=this._onDidChangeFullscreen.event,this.mapWindowIdToFullScreen=new Map}static{this.INSTANCE=new O}getZoomLevel(o){return this.mapWindowIdToZoomLevel.get(this.getWindowId(o))??0}setZoomLevel(o,p){if(this.getZoomLevel(p)===o)return;const A=this.getWindowId(p);this.mapWindowIdToZoomLevel.set(A,o),this._onDidChangeZoomLevel.fire(A)}getZoomFactor(o){return this.mapWindowIdToZoomFactor.get(this.getWindowId(o))??1}setZoomFactor(o,p){this.mapWindowIdToZoomFactor.set(this.getWindowId(p),o)}setFullscreen(o,p){if(this.isFullscreen(p)===o)return;const A=this.getWindowId(p);this.mapWindowIdToFullScreen.set(A,o),this._onDidChangeFullscreen.fire(A)}isFullscreen(o){return!!this.mapWindowIdToFullScreen.get(this.getWindowId(o))}getWindowId(o){return o.vscodeWindowId}}function I(l,o,p){typeof o=="string"&&(o=l.matchMedia(o)),o.addEventListener("change",p)}function N(l,o){O.INSTANCE.setZoomLevel(l,o)}function b(l){return O.INSTANCE.getZoomLevel(l)}t.onDidChangeZoomLevel=O.INSTANCE.onDidChangeZoomLevel;function w(l){return O.INSTANCE.getZoomFactor(l)}function u(l,o){O.INSTANCE.setZoomFactor(l,o)}function m(l,o){O.INSTANCE.setFullscreen(l,o)}function v(l){return O.INSTANCE.isFullscreen(l)}t.onDidChangeFullscreen=O.INSTANCE.onDidChangeFullscreen;const g=navigator.userAgent;t.isFirefox=g.indexOf("Firefox")>=0,t.isWebKit=g.indexOf("AppleWebKit")>=0,t.isChrome=g.indexOf("Chrome")>=0,t.isSafari=!t.isChrome&&g.indexOf("Safari")>=0,t.isWebkitWebView=!t.isChrome&&!t.isSafari&&t.isWebKit,t.isElectron=g.indexOf("Electron/")>=0,t.isAndroid=g.indexOf("Android")>=0;let d=!1;if(typeof i.mainWindow.matchMedia=="function"){const l=i.mainWindow.matchMedia("(display-mode: standalone) or (display-mode: window-controls-overlay)"),o=i.mainWindow.matchMedia("(display-mode: fullscreen)");d=l.matches,I(i.mainWindow,l,({matches:p})=>{d&&o.matches||(d=p)})}function e(){return d}function s(){return navigator?.windowControlsOverlay?.visible}function r(l){return l.navigator?.windowControlsOverlay?.getTitlebarAreaRect()}}),define(_e[28],Se([1,0,3]),function(ue,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DomEmitter=void 0;class n{get event(){return this.emitter.event}constructor(I,N,b){const w=u=>this.emitter.fire(u);this.emitter=new i.Emitter({onWillAddFirstListener:()=>I.addEventListener(N,w,b),onDidRemoveLastListener:()=>I.removeEventListener(N,w,b)})}dispose(){this.emitter.dispose()}}t.DomEmitter=n}),define(_e[38],Se([1,0,3]),function(ue,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CancellationTokenSource=t.CancellationToken=void 0,t.cancelOnDispose=b;const n=Object.freeze(function(w,u){const m=setTimeout(w.bind(u),0);return{dispose(){clearTimeout(m)}}});var O;(function(w){function u(m){return m===w.None||m===w.Cancelled||m instanceof I?!0:!m||typeof m!="object"?!1:typeof m.isCancellationRequested=="boolean"&&typeof m.onCancellationRequested=="function"}w.isCancellationToken=u,w.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:i.Event.None}),w.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:n})})(O||(t.CancellationToken=O={}));class I{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?n:(this._emitter||(this._emitter=new i.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class N{constructor(u){this._token=void 0,this._parentListener=void 0,this._parentListener=u&&u.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new I),this._token}cancel(){this._token?this._token instanceof I&&this._token.cancel():this._token=O.Cancelled}dispose(u=!1){u&&this.cancel(),this._parentListener?.dispose(),this._token?this._token instanceof I&&this._token.dispose():this._token=O.None}}t.CancellationTokenSource=N;function b(w){const u=new N;return w.add({dispose(){u.cancel()}}),u.token}}),define(_e[101],Se([1,0,38]),function(ue,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CachedFunction=t.LRUCachedFunction=t.Cache=void 0,t.identity=O;class n{constructor(w){this.task=w,this.result=null}get(){if(this.result)return this.result;const w=new i.CancellationTokenSource,u=this.task(w.token);return this.result={promise:u,dispose:()=>{this.result=null,w.cancel(),w.dispose()}},this.result}}t.Cache=n;function O(b){return b}class I{constructor(w,u){this.lastCache=void 0,this.lastArgKey=void 0,typeof w=="function"?(this._fn=w,this._computeKey=O):(this._fn=u,this._computeKey=w.getCacheKey)}get(w){const u=this._computeKey(w);return this.lastArgKey!==u&&(this.lastArgKey=u,this.lastCache=this._fn(w)),this.lastCache}}t.LRUCachedFunction=I;class N{get cachedValues(){return this._map}constructor(w,u){this._map=new Map,this._map2=new Map,typeof w=="function"?(this._fn=w,this._computeKey=O):(this._fn=u,this._computeKey=w.getCacheKey)}get(w){const u=this._computeKey(w);if(this._map2.has(u))return this._map2.get(u);const m=this._fn(w);return this._map.set(w,m),this._map2.set(u,m),m}}t.CachedFunction=N}),define(_e[102],Se([1,0,44,27,45,38,26,30,6]),function(ue,t,i,n,O,I,N,b,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ObservableLazyPromise=t.PromiseResult=t.ObservablePromise=t.ObservableLazy=void 0,t.waitForState=d,t.derivedWithCancellationToken=e;class u{get cachedValue(){return this._value}constructor(r){this._computeValue=r,this._value=(0,n.observableValue)(this,void 0)}getValue(){let r=this._value.get();return r||(r=this._computeValue(),this._value.set(r,void 0)),r}}t.ObservableLazy=u;class m{static fromFn(r){return new m(r())}constructor(r){this._value=(0,n.observableValue)(this,void 0),this.promiseResult=this._value,this.promise=r.then(l=>((0,n.transaction)(o=>{this._value.set(new v(l,void 0),o)}),l),l=>{throw(0,n.transaction)(o=>{this._value.set(new v(void 0,l),o)}),l})}}t.ObservablePromise=m;class v{constructor(r,l){this.data=r,this.error=l}getDataOrThrow(){if(this.error)throw this.error;return this.data}}t.PromiseResult=v;class g{constructor(r){this._computePromise=r,this._lazyValue=new u(()=>new m(this._computePromise())),this.cachedPromiseResult=(0,O.derived)(this,l=>this._lazyValue.cachedValue.read(l)?.promiseResult.read(l))}getPromise(){return this._lazyValue.getValue().promise}}t.ObservableLazyPromise=g;function d(s,r,l,o){return r||(r=p=>p!=null),new Promise((p,A)=>{let L=!0,c=!1;const a=s.map(_=>({isFinished:r(_),error:l?l(_):!1,state:_})),f=(0,i.autorun)(_=>{const{isFinished:H,error:B,state:F}=a.read(_);(H||B)&&(L?c=!0:f.dispose(),B?A(B===!0?F:B):p(F))});if(o){const _=o.onCancellationRequested(()=>{f.dispose(),_.dispose(),A(new w.CancellationError)});if(o.isCancellationRequested){f.dispose(),_.dispose(),A(new w.CancellationError);return}}L=!1,c&&f.dispose()})}function e(s,r){let l,o;r===void 0?(l=s,o=void 0):(o=s,l=r);let p;return new O.Derived(new N.DebugNameData(o,void 0,l),A=>(p&&p.dispose(!0),p=new I.CancellationTokenSource,l(A,p.token)),void 0,void 0,()=>p?.dispose(),b.strictEquals)}}),define(_e[103],Se([1,0,3,2,44,27,26,45,31,6,30]),function(ue,t,i,n,O,I,N,b,w,u,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ValueWithChangeEventFromObservable=t.KeepAliveObserver=t.FromEventObservable=void 0,t.constObservable=v,t.observableFromPromise=d,t.observableFromEvent=e,t.observableFromEventOpts=s,t.observableSignalFromEvent=l,t.observableSignal=p,t.debouncedObservable=L,t.debouncedObservable2=c,t.wasEventTriggeredRecently=a,t.keepObserved=f,t.recomputeInitiallyAndOnChange=_,t.derivedObservableWithCache=B,t.derivedObservableWithWritableCache=F,t.mapObservableArrayCached=E,t.observableFromValueWithChangeEvent=R,t.latestChangedValue=C,t.derivedConstOnceDefined=$;function v(ee){return new g(ee)}class g extends I.ConvenientObservable{constructor(Y){super(),this.value=Y}get debugName(){return this.toString()}get(){return this.value}addObserver(Y){}removeObserver(Y){}toString(){return`Const: ${this.value}`}}function d(ee){const Y=(0,I.observableValue)("promiseValue",{});return ee.then(Z=>{Y.set({value:Z},void 0)}),Y}function e(...ee){let Y,Z,ce;return ee.length===3?[Y,Z,ce]=ee:[Z,ce]=ee,new r(new N.DebugNameData(Y,void 0,ce),Z,ce,()=>r.globalTransaction,m.strictEquals)}function s(ee,Y,Z){return new r(new N.DebugNameData(ee.owner,ee.debugName,ee.debugReferenceFn??Z),Y,Z,()=>r.globalTransaction,ee.equalsFn??m.strictEquals)}class r extends I.BaseObservable{constructor(Y,Z,ce,he,ye){super(),this._debugNameData=Y,this.event=Z,this._getValue=ce,this._getTransaction=he,this._equalityComparator=ye,this.hasValue=!1,this.handleEvent=Re=>{const Pe=this._getValue(Re),re=this.value,ie=!this.hasValue||!this._equalityComparator(re,Pe);let fe=!1;ie&&(this.value=Pe,this.hasValue&&(fe=!0,(0,I.subtransaction)(this._getTransaction(),ve=>{(0,w.getLogger)()?.handleFromEventObservableTriggered(this,{oldValue:re,newValue:Pe,change:void 0,didChange:ie,hadValue:this.hasValue});for(const Ne of this.observers)ve.updateObserver(Ne,this),Ne.handleChange(this,void 0)},()=>{const ve=this.getDebugName();return"Event fired"+(ve?`: ${ve}`:"")})),this.hasValue=!0),fe||(0,w.getLogger)()?.handleFromEventObservableTriggered(this,{oldValue:re,newValue:Pe,change:void 0,didChange:ie,hadValue:this.hasValue})}}getDebugName(){return this._debugNameData.getDebugName(this)}get debugName(){const Y=this.getDebugName();return"From Event"+(Y?`: ${Y}`:"")}onFirstObserverAdded(){this.subscription=this.event(this.handleEvent)}onLastObserverRemoved(){this.subscription.dispose(),this.subscription=void 0,this.hasValue=!1,this.value=void 0}get(){return this.subscription?(this.hasValue||this.handleEvent(void 0),this.value):this._getValue(void 0)}}t.FromEventObservable=r,function(ee){ee.Observer=r;function Y(Z,ce){let he=!1;r.globalTransaction===void 0&&(r.globalTransaction=Z,he=!0);try{ce()}finally{he&&(r.globalTransaction=void 0)}}ee.batchEventsGlobally=Y}(e||(t.observableFromEvent=e={}));function l(ee,Y){return new o(ee,Y)}class o extends I.BaseObservable{constructor(Y,Z){super(),this.debugName=Y,this.event=Z,this.handleEvent=()=>{(0,I.transaction)(ce=>{for(const he of this.observers)ce.updateObserver(he,this),he.handleChange(this,void 0)},()=>this.debugName)}}onFirstObserverAdded(){this.subscription=this.event(this.handleEvent)}onLastObserverRemoved(){this.subscription.dispose(),this.subscription=void 0}get(){}}function p(ee){return typeof ee=="string"?new A(ee):new A(void 0,ee)}class A extends I.BaseObservable{get debugName(){return new N.DebugNameData(this._owner,this._debugName,void 0).getDebugName(this)??"Observable Signal"}toString(){return this.debugName}constructor(Y,Z){super(),this._debugName=Y,this._owner=Z}trigger(Y,Z){if(!Y){(0,I.transaction)(ce=>{this.trigger(ce,Z)},()=>`Trigger signal ${this.debugName}`);return}for(const ce of this.observers)Y.updateObserver(ce,this),ce.handleChange(this,Z)}get(){}}function L(ee,Y,Z){const ce=(0,I.observableValue)("debounced",void 0);let he;return Z.add((0,O.autorun)(ye=>{const Re=ee.read(ye);he&&clearTimeout(he),he=setTimeout(()=>{(0,I.transaction)(Pe=>{ce.set(Re,Pe)})},Y)})),ce}function c(ee,Y){let Z=!1,ce,he;return e(ye=>{const Re=(0,O.autorun)(Pe=>{const re=ee.read(Pe);Z?(he&&clearTimeout(he),he=setTimeout(()=>{ce=re,ye()},Y)):(Z=!0,ce=re)});return{dispose(){Re.dispose(),Z=!1,ce=void 0}}},()=>Z?ce:ee.get())}function a(ee,Y,Z){const ce=(0,I.observableValue)("triggeredRecently",!1);let he;return Z.add(ee(()=>{ce.set(!0,void 0),he&&clearTimeout(he),he=setTimeout(()=>{ce.set(!1,void 0)},Y)})),ce}function f(ee){const Y=new H(!1,void 0);return ee.addObserver(Y),(0,n.toDisposable)(()=>{ee.removeObserver(Y)})}(0,I._setKeepObserved)(f);function _(ee,Y){const Z=new H(!0,Y);return ee.addObserver(Z),Y?Y(ee.get()):ee.reportChanges(),(0,n.toDisposable)(()=>{ee.removeObserver(Z)})}(0,I._setRecomputeInitiallyAndOnChange)(_);class H{constructor(Y,Z){this._forceRecompute=Y,this._handleValue=Z,this._counter=0}beginUpdate(Y){this._counter++}endUpdate(Y){this._counter--,this._counter===0&&this._forceRecompute&&(this._handleValue?this._handleValue(Y.get()):Y.reportChanges())}handlePossibleChange(Y){}handleChange(Y,Z){}}t.KeepAliveObserver=H;function B(ee,Y){let Z;return(0,b.derivedOpts)({owner:ee,debugReferenceFn:Y},he=>(Z=Y(he,Z),Z))}function F(ee,Y){let Z;const ce=p("derivedObservableWithWritableCache"),he=(0,b.derived)(ee,ye=>(ce.read(ye),Z=Y(ye,Z),Z));return Object.assign(he,{clearCache:ye=>{Z=void 0,ce.trigger(ye)},setCache:(ye,Re)=>{Z=ye,ce.trigger(Re)}})}function E(ee,Y,Z,ce){let he=new k(Z,ce);return(0,b.derivedOpts)({debugReferenceFn:Z,owner:ee,onLastObserverRemoved:()=>{he.dispose(),he=new k(Z)}},Re=>(he.setItems(Y.read(Re)),he.getItems()))}class k{constructor(Y,Z){this._map=Y,this._keySelector=Z,this._cache=new Map,this._items=[]}dispose(){this._cache.forEach(Y=>Y.store.dispose()),this._cache.clear()}setItems(Y){const Z=[],ce=new Set(this._cache.keys());for(const he of Y){const ye=this._keySelector?this._keySelector(he):he;let Re=this._cache.get(ye);if(Re)ce.delete(ye);else{const Pe=new n.DisposableStore;Re={out:this._map(he,Pe),store:Pe},this._cache.set(ye,Re)}Z.push(Re.out)}for(const he of ce)this._cache.get(he).store.dispose(),this._cache.delete(he);this._items=Z}getItems(){return this._items}}class W{constructor(Y){this.observable=Y}get onDidChange(){return i.Event.fromObservableLight(this.observable)}get value(){return this.observable.get()}}t.ValueWithChangeEventFromObservable=W;function R(ee,Y){return Y instanceof W?Y.observable:e(ee,Y.onDidChange,()=>Y.value)}function C(ee,Y){if(Y.length===0)throw new u.BugIndicatingError;let Z=!1,ce;const he=e(ee,ye=>{const Re=new n.DisposableStore;for(const Pe of Y)Re.add((0,O.autorunOpts)({debugName:()=>(0,N.getDebugName)(he,new N.DebugNameData(ee,void 0,void 0))+".updateLastChangedValue"},re=>{Z=!0,ce=Pe.read(re),ye()}));return Re.add({dispose(){Z=!1,ce=void 0}}),Re},()=>Z?ce:Y[Y.length-1].get());return he}function $(ee,Y){return B(ee,(Z,ce)=>ce??Y(Z))}}),define(_e[62],Se([1,0,27,45,44,103,102,98,31]),function(ue,t,i,n,O,I,N,b,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.observableValueOpts=t.derivedWithCancellationToken=t.waitForState=t.PromiseResult=t.ObservablePromise=t.ObservableLazyPromise=t.ObservableLazy=t.wasEventTriggeredRecently=t.observableSignalFromEvent=t.observableSignal=t.observableFromPromise=t.observableFromEvent=t.recomputeInitiallyAndOnChange=t.keepObserved=t.derivedObservableWithWritableCache=t.derivedObservableWithCache=t.debouncedObservable=t.constObservable=t.autorunWithStoreHandleChanges=t.autorunOpts=t.autorunWithStore=t.autorunHandleChanges=t.autorunDelta=t.autorun=t.derivedWithStore=t.derivedHandleChanges=t.derivedOpts=t.derived=t.subtransaction=t.transaction=t.disposableObservableValue=t.observableValue=void 0,Object.defineProperty(t,"observableValue",{enumerable:!0,get:function(){return i.observableValue}}),Object.defineProperty(t,"disposableObservableValue",{enumerable:!0,get:function(){return i.disposableObservableValue}}),Object.defineProperty(t,"transaction",{enumerable:!0,get:function(){return i.transaction}}),Object.defineProperty(t,"subtransaction",{enumerable:!0,get:function(){return i.subtransaction}}),Object.defineProperty(t,"derived",{enumerable:!0,get:function(){return n.derived}}),Object.defineProperty(t,"derivedOpts",{enumerable:!0,get:function(){return n.derivedOpts}}),Object.defineProperty(t,"derivedHandleChanges",{enumerable:!0,get:function(){return n.derivedHandleChanges}}),Object.defineProperty(t,"derivedWithStore",{enumerable:!0,get:function(){return n.derivedWithStore}}),Object.defineProperty(t,"autorun",{enumerable:!0,get:function(){return O.autorun}}),Object.defineProperty(t,"autorunDelta",{enumerable:!0,get:function(){return O.autorunDelta}}),Object.defineProperty(t,"autorunHandleChanges",{enumerable:!0,get:function(){return O.autorunHandleChanges}}),Object.defineProperty(t,"autorunWithStore",{enumerable:!0,get:function(){return O.autorunWithStore}}),Object.defineProperty(t,"autorunOpts",{enumerable:!0,get:function(){return O.autorunOpts}}),Object.defineProperty(t,"autorunWithStoreHandleChanges",{enumerable:!0,get:function(){return O.autorunWithStoreHandleChanges}}),Object.defineProperty(t,"constObservable",{enumerable:!0,get:function(){return I.constObservable}}),Object.defineProperty(t,"debouncedObservable",{enumerable:!0,get:function(){return I.debouncedObservable}}),Object.defineProperty(t,"derivedObservableWithCache",{enumerable:!0,get:function(){return I.derivedObservableWithCache}}),Object.defineProperty(t,"derivedObservableWithWritableCache",{enumerable:!0,get:function(){return I.derivedObservableWithWritableCache}}),Object.defineProperty(t,"keepObserved",{enumerable:!0,get:function(){return I.keepObserved}}),Object.defineProperty(t,"recomputeInitiallyAndOnChange",{enumerable:!0,get:function(){return I.recomputeInitiallyAndOnChange}}),Object.defineProperty(t,"observableFromEvent",{enumerable:!0,get:function(){return I.observableFromEvent}}),Object.defineProperty(t,"observableFromPromise",{enumerable:!0,get:function(){return I.observableFromPromise}}),Object.defineProperty(t,"observableSignal",{enumerable:!0,get:function(){return I.observableSignal}}),Object.defineProperty(t,"observableSignalFromEvent",{enumerable:!0,get:function(){return I.observableSignalFromEvent}}),Object.defineProperty(t,"wasEventTriggeredRecently",{enumerable:!0,get:function(){return I.wasEventTriggeredRecently}}),Object.defineProperty(t,"ObservableLazy",{enumerable:!0,get:function(){return N.ObservableLazy}}),Object.defineProperty(t,"ObservableLazyPromise",{enumerable:!0,get:function(){return N.ObservableLazyPromise}}),Object.defineProperty(t,"ObservablePromise",{enumerable:!0,get:function(){return N.ObservablePromise}}),Object.defineProperty(t,"PromiseResult",{enumerable:!0,get:function(){return N.PromiseResult}}),Object.defineProperty(t,"waitForState",{enumerable:!0,get:function(){return N.waitForState}}),Object.defineProperty(t,"derivedWithCancellationToken",{enumerable:!0,get:function(){return N.derivedWithCancellationToken}}),Object.defineProperty(t,"observableValueOpts",{enumerable:!0,get:function(){return b.observableValueOpts}}),!1&&(0,w.setLogger)(new w.ConsoleObservableLogger)}),define(_e[19],Se([1,0,3,2]),function(ue,t,i,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SmoothScrollingOperation=t.SmoothScrollingUpdate=t.Scrollable=t.ScrollState=t.ScrollbarVisibility=void 0;var O;(function(d){d[d.Auto=1]="Auto",d[d.Hidden=2]="Hidden",d[d.Visible=3]="Visible"})(O||(t.ScrollbarVisibility=O={}));class I{constructor(e,s,r,l,o,p,A){this._forceIntegerValues=e,this._scrollStateBrand=void 0,this._forceIntegerValues&&(s=s|0,r=r|0,l=l|0,o=o|0,p=p|0,A=A|0),this.rawScrollLeft=l,this.rawScrollTop=A,s<0&&(s=0),l+s>r&&(l=r-s),l<0&&(l=0),o<0&&(o=0),A+o>p&&(A=p-o),A<0&&(A=0),this.width=s,this.scrollWidth=r,this.scrollLeft=l,this.height=o,this.scrollHeight=p,this.scrollTop=A}equals(e){return this.rawScrollLeft===e.rawScrollLeft&&this.rawScrollTop===e.rawScrollTop&&this.width===e.width&&this.scrollWidth===e.scrollWidth&&this.scrollLeft===e.scrollLeft&&this.height===e.height&&this.scrollHeight===e.scrollHeight&&this.scrollTop===e.scrollTop}withScrollDimensions(e,s){return new I(this._forceIntegerValues,typeof e.width<"u"?e.width:this.width,typeof e.scrollWidth<"u"?e.scrollWidth:this.scrollWidth,s?this.rawScrollLeft:this.scrollLeft,typeof e.height<"u"?e.height:this.height,typeof e.scrollHeight<"u"?e.scrollHeight:this.scrollHeight,s?this.rawScrollTop:this.scrollTop)}withScrollPosition(e){return new I(this._forceIntegerValues,this.width,this.scrollWidth,typeof e.scrollLeft<"u"?e.scrollLeft:this.rawScrollLeft,this.height,this.scrollHeight,typeof e.scrollTop<"u"?e.scrollTop:this.rawScrollTop)}createScrollEvent(e,s){const r=this.width!==e.width,l=this.scrollWidth!==e.scrollWidth,o=this.scrollLeft!==e.scrollLeft,p=this.height!==e.height,A=this.scrollHeight!==e.scrollHeight,L=this.scrollTop!==e.scrollTop;return{inSmoothScrolling:s,oldWidth:e.width,oldScrollWidth:e.scrollWidth,oldScrollLeft:e.scrollLeft,width:this.width,scrollWidth:this.scrollWidth,scrollLeft:this.scrollLeft,oldHeight:e.height,oldScrollHeight:e.scrollHeight,oldScrollTop:e.scrollTop,height:this.height,scrollHeight:this.scrollHeight,scrollTop:this.scrollTop,widthChanged:r,scrollWidthChanged:l,scrollLeftChanged:o,heightChanged:p,scrollHeightChanged:A,scrollTopChanged:L}}}t.ScrollState=I;class N extends n.Disposable{constructor(e){super(),this._scrollableBrand=void 0,this._onScroll=this._register(new i.Emitter),this.onScroll=this._onScroll.event,this._smoothScrollDuration=e.smoothScrollDuration,this._scheduleAtNextAnimationFrame=e.scheduleAtNextAnimationFrame,this._state=new I(e.forceIntegerValues,0,0,0,0,0,0),this._smoothScrolling=null}dispose(){this._smoothScrolling&&(this._smoothScrolling.dispose(),this._smoothScrolling=null),super.dispose()}setSmoothScrollDuration(e){this._smoothScrollDuration=e}validateScrollPosition(e){return this._state.withScrollPosition(e)}getScrollDimensions(){return this._state}setScrollDimensions(e,s){const r=this._state.withScrollDimensions(e,s);this._setState(r,!!this._smoothScrolling),this._smoothScrolling?.acceptScrollDimensions(this._state)}getFutureScrollPosition(){return this._smoothScrolling?this._smoothScrolling.to:this._state}getCurrentScrollPosition(){return this._state}setScrollPositionNow(e){const s=this._state.withScrollPosition(e);this._smoothScrolling&&(this._smoothScrolling.dispose(),this._smoothScrolling=null),this._setState(s,!1)}setScrollPositionSmooth(e,s){if(this._smoothScrollDuration===0)return this.setScrollPositionNow(e);if(this._smoothScrolling){e={scrollLeft:typeof e.scrollLeft>"u"?this._smoothScrolling.to.scrollLeft:e.scrollLeft,scrollTop:typeof e.scrollTop>"u"?this._smoothScrolling.to.scrollTop:e.scrollTop};const r=this._state.withScrollPosition(e);if(this._smoothScrolling.to.scrollLeft===r.scrollLeft&&this._smoothScrolling.to.scrollTop===r.scrollTop)return;let l;s?l=new m(this._smoothScrolling.from,r,this._smoothScrolling.startTime,this._smoothScrolling.duration):l=this._smoothScrolling.combine(this._state,r,this._smoothScrollDuration),this._smoothScrolling.dispose(),this._smoothScrolling=l}else{const r=this._state.withScrollPosition(e);this._smoothScrolling=m.start(this._state,r,this._smoothScrollDuration)}this._smoothScrolling.animationFrameDisposable=this._scheduleAtNextAnimationFrame(()=>{this._smoothScrolling&&(this._smoothScrolling.animationFrameDisposable=null,this._performSmoothScrolling())})}hasPendingScrollAnimation(){return!!this._smoothScrolling}_performSmoothScrolling(){if(!this._smoothScrolling)return;const e=this._smoothScrolling.tick(),s=this._state.withScrollPosition(e);if(this._setState(s,!0),!!this._smoothScrolling){if(e.isDone){this._smoothScrolling.dispose(),this._smoothScrolling=null;return}this._smoothScrolling.animationFrameDisposable=this._scheduleAtNextAnimationFrame(()=>{this._smoothScrolling&&(this._smoothScrolling.animationFrameDisposable=null,this._performSmoothScrolling())})}}_setState(e,s){const r=this._state;r.equals(e)||(this._state=e,this._onScroll.fire(this._state.createScrollEvent(r,s)))}}t.Scrollable=N;class b{constructor(e,s,r){this.scrollLeft=e,this.scrollTop=s,this.isDone=r}}t.SmoothScrollingUpdate=b;function w(d,e){const s=e-d;return function(r){return d+s*g(r)}}function u(d,e,s){return function(r){return r<s?d(r/s):e((r-s)/(1-s))}}class m{constructor(e,s,r,l){this.from=e,this.to=s,this.duration=l,this.startTime=r,this.animationFrameDisposable=null,this._initAnimations()}_initAnimations(){this.scrollLeft=this._initAnimation(this.from.scrollLeft,this.to.scrollLeft,this.to.width),this.scrollTop=this._initAnimation(this.from.scrollTop,this.to.scrollTop,this.to.height)}_initAnimation(e,s,r){if(Math.abs(e-s)>2.5*r){let o,p;return e<s?(o=e+.75*r,p=s-.75*r):(o=e-.75*r,p=s+.75*r),u(w(e,o),w(p,s),.33)}return w(e,s)}dispose(){this.animationFrameDisposable!==null&&(this.animationFrameDisposable.dispose(),this.animationFrameDisposable=null)}acceptScrollDimensions(e){this.to=e.withScrollPosition(this.to),this._initAnimations()}tick(){return this._tick(Date.now())}_tick(e){const s=(e-this.startTime)/this.duration;if(s<1){const r=this.scrollLeft(s),l=this.scrollTop(s);return new b(r,l,!1)}return new b(this.to.scrollLeft,this.to.scrollTop,!0)}combine(e,s,r){return m.start(e,s,r)}static start(e,s,r){r=r+10;const l=Date.now()-10;return new m(e,s,l,r)}}t.SmoothScrollingOperation=m;function v(d){return Math.pow(d,3)}function g(d){return 1-v(1-d)}}),define(_e[104],Se([1,0,6,2]),function(ue,t,i,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isReadable=O,t.isReadableStream=I,t.isReadableBufferedStream=N,t.newWriteableStream=b,t.consumeReadable=u,t.peekReadable=m,t.consumeStream=v,t.listenStream=g,t.peekStream=d,t.toStream=e,t.emptyStream=s,t.toReadable=r,t.transform=l,t.prefixedReadable=o,t.prefixedStream=p;function O(A){const L=A;return L?typeof L.read=="function":!1}function I(A){const L=A;return L?[L.on,L.pause,L.resume,L.destroy].every(c=>typeof c=="function"):!1}function N(A){const L=A;return L?I(L.stream)&&Array.isArray(L.buffer)&&typeof L.ended=="boolean":!1}function b(A,L){return new w(A,L)}class w{constructor(L,c){this.reducer=L,this.options=c,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(L){if(!this.state.destroyed){if(this.state.flowing)this.emitData(L);else if(this.buffer.data.push(L),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(c=>this.pendingWritePromises.push(c))}}error(L){this.state.destroyed||(this.state.flowing?this.emitError(L):this.buffer.error.push(L))}end(L){this.state.destroyed||(typeof L<"u"&&this.write(L),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(L){this.listeners.data.slice(0).forEach(c=>c(L))}emitError(L){this.listeners.error.length===0?(0,i.onUnexpectedError)(L):this.listeners.error.slice(0).forEach(c=>c(L))}emitEnd(){this.listeners.end.slice(0).forEach(L=>L())}on(L,c){if(!this.state.destroyed)switch(L){case"data":this.listeners.data.push(c),this.resume();break;case"end":this.listeners.end.push(c),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(c),this.state.flowing&&this.flowErrors();break}}removeListener(L,c){if(this.state.destroyed)return;let a;switch(L){case"data":a=this.listeners.data;break;case"end":a=this.listeners.end;break;case"error":a=this.listeners.error;break}if(a){const f=a.indexOf(c);f>=0&&a.splice(f,1)}}flowData(){if(this.buffer.data.length>0){const L=this.reducer(this.buffer.data);this.emitData(L),this.buffer.data.length=0;const c=[...this.pendingWritePromises];this.pendingWritePromises.length=0,c.forEach(a=>a())}}flowErrors(){if(this.listeners.error.length>0){for(const L of this.buffer.error)this.emitError(L);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function u(A,L){const c=[];let a;for(;(a=A.read())!==null;)c.push(a);return L(c)}function m(A,L,c){const a=[];let f;for(;(f=A.read())!==null&&a.length<c;)a.push(f);return f===null&&a.length>0?L(a):{read:()=>{if(a.length>0)return a.shift();if(typeof f<"u"){const _=f;return f=void 0,_}return A.read()}}}function v(A,L){return new Promise((c,a)=>{const f=[];g(A,{onData:_=>{L&&f.push(_)},onError:_=>{L?a(_):c(void 0)},onEnd:()=>{c(L?L(f):void 0)}})})}function g(A,L,c){A.on("error",a=>{c?.isCancellationRequested||L.onError(a)}),A.on("end",()=>{c?.isCancellationRequested||L.onEnd()}),A.on("data",a=>{c?.isCancellationRequested||L.onData(a)})}function d(A,L){return new Promise((c,a)=>{const f=new n.DisposableStore,_=[],H=E=>{if(_.push(E),_.length>L)return f.dispose(),A.pause(),c({stream:A,buffer:_,ended:!1})},B=E=>(f.dispose(),a(E)),F=()=>(f.dispose(),c({stream:A,buffer:_,ended:!0}));f.add((0,n.toDisposable)(()=>A.removeListener("error",B))),A.on("error",B),f.add((0,n.toDisposable)(()=>A.removeListener("end",F))),A.on("end",F),f.add((0,n.toDisposable)(()=>A.removeListener("data",H))),A.on("data",H)})}function e(A,L){const c=b(L);return c.end(A),c}function s(){const A=b(()=>{throw new Error("not supported")});return A.end(),A}function r(A){let L=!1;return{read:()=>L?null:(L=!0,A)}}function l(A,L,c){const a=b(c);return g(A,{onData:f=>a.write(L.data(f)),onError:f=>a.error(L.error?L.error(f):f),onEnd:()=>a.end()}),a}function o(A,L,c){let a=!1;return{read:()=>{const f=L.read();return a?f:(a=!0,f!==null?c([A,f]):A)}}}function p(A,L,c){let a=!1;const f=b(c);return g(L,{onData:_=>a?f.write(_):(a=!0,f.write(c([A,_]))),onError:_=>f.error(_),onEnd:()=>{a||(a=!0,f.write(A)),f.end()}}),f}}),define(_e[47],Se([1,0,25,104]),function(ue,t,i,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.VSBuffer=void 0,t.binaryIndexOf=u,t.readUInt16LE=m,t.writeUInt16LE=v,t.readUInt32BE=g,t.writeUInt32BE=d,t.readUInt32LE=e,t.writeUInt32LE=s,t.readUInt8=r,t.writeUInt8=l,t.readableToBuffer=o,t.bufferToReadable=p,t.streamToBuffer=A,t.bufferedStreamToBuffer=L,t.bufferToStream=c,t.streamToBufferReadableStream=a,t.newWriteableBufferStream=f,t.prefixedBufferReadable=_,t.prefixedBufferStream=H,t.decodeBase64=B,t.encodeBase64=k,n=qe(n);const O=typeof Buffer<"u",I=new i.Lazy(()=>new Uint8Array(256));let N,b;class w{static alloc(R){return O?new w(Buffer.allocUnsafe(R)):new w(new Uint8Array(R))}static wrap(R){return O&&!Buffer.isBuffer(R)&&(R=Buffer.from(R.buffer,R.byteOffset,R.byteLength)),new w(R)}static fromString(R,C){return!(C?.dontUseNodeBuffer||!1)&&O?new w(Buffer.from(R)):(N||(N=new TextEncoder),new w(N.encode(R)))}static fromByteArray(R){const C=w.alloc(R.length);for(let $=0,ee=R.length;$<ee;$++)C.buffer[$]=R[$];return C}static concat(R,C){if(typeof C>"u"){C=0;for(let Y=0,Z=R.length;Y<Z;Y++)C+=R[Y].byteLength}const $=w.alloc(C);let ee=0;for(let Y=0,Z=R.length;Y<Z;Y++){const ce=R[Y];$.set(ce,ee),ee+=ce.byteLength}return $}constructor(R){this.buffer=R,this.byteLength=this.buffer.byteLength}clone(){const R=w.alloc(this.byteLength);return R.set(this),R}toString(){return O?this.buffer.toString():(b||(b=new TextDecoder),b.decode(this.buffer))}slice(R,C){return new w(this.buffer.subarray(R,C))}set(R,C){if(R instanceof w)this.buffer.set(R.buffer,C);else if(R instanceof Uint8Array)this.buffer.set(R,C);else if(R instanceof ArrayBuffer)this.buffer.set(new Uint8Array(R),C);else if(ArrayBuffer.isView(R))this.buffer.set(new Uint8Array(R.buffer,R.byteOffset,R.byteLength),C);else throw new Error("Unknown argument 'array'")}readUInt32BE(R){return g(this.buffer,R)}writeUInt32BE(R,C){d(this.buffer,R,C)}readUInt32LE(R){return e(this.buffer,R)}writeUInt32LE(R,C){s(this.buffer,R,C)}readUInt8(R){return r(this.buffer,R)}writeUInt8(R,C){l(this.buffer,R,C)}indexOf(R,C=0){return u(this.buffer,R instanceof w?R.buffer:R,C)}}t.VSBuffer=w;function u(W,R,C=0){const $=R.byteLength,ee=W.byteLength;if($===0)return 0;if($===1)return W.indexOf(R[0]);if($>ee-C)return-1;const Y=I.value;Y.fill(R.length);for(let ye=0;ye<R.length;ye++)Y[R[ye]]=R.length-ye-1;let Z=C+R.length-1,ce=Z,he=-1;for(;Z<ee;)if(W[Z]===R[ce]){if(ce===0){he=Z;break}Z--,ce--}else Z+=Math.max(R.length-ce,Y[W[Z]]),ce=R.length-1;return he}function m(W,R){return W[R+0]<<0>>>0|W[R+1]<<8>>>0}function v(W,R,C){W[C+0]=R&255,R=R>>>8,W[C+1]=R&255}function g(W,R){return W[R]*2**24+W[R+1]*2**16+W[R+2]*2**8+W[R+3]}function d(W,R,C){W[C+3]=R,R=R>>>8,W[C+2]=R,R=R>>>8,W[C+1]=R,R=R>>>8,W[C]=R}function e(W,R){return W[R+0]<<0>>>0|W[R+1]<<8>>>0|W[R+2]<<16>>>0|W[R+3]<<24>>>0}function s(W,R,C){W[C+0]=R&255,R=R>>>8,W[C+1]=R&255,R=R>>>8,W[C+2]=R&255,R=R>>>8,W[C+3]=R&255}function r(W,R){return W[R]}function l(W,R,C){W[C]=R}function o(W){return n.consumeReadable(W,R=>w.concat(R))}function p(W){return n.toReadable(W)}function A(W){return n.consumeStream(W,R=>w.concat(R))}async function L(W){return W.ended?w.concat(W.buffer):w.concat([...W.buffer,await A(W.stream)])}function c(W){return n.toStream(W,R=>w.concat(R))}function a(W){return n.transform(W,{data:R=>typeof R=="string"?w.fromString(R):w.wrap(R)},R=>w.concat(R))}function f(W){return n.newWriteableStream(R=>w.concat(R),W)}function _(W,R){return n.prefixedReadable(W,R,C=>w.concat(C))}function H(W,R){return n.prefixedStream(W,R,C=>w.concat(C))}function B(W){let R=0,C=0,$=0;const ee=new Uint8Array(Math.floor(W.length/4*3)),Y=ce=>{switch(C){case 3:ee[$++]=R|ce,C=0;break;case 2:ee[$++]=R|ce>>>2,R=ce<<6,C=3;break;case 1:ee[$++]=R|ce>>>4,R=ce<<4,C=2;break;default:R=ce<<2,C=1}};for(let ce=0;ce<W.length;ce++){const he=W.charCodeAt(ce);if(he>=65&&he<=90)Y(he-65);else if(he>=97&&he<=122)Y(he-97+26);else if(he>=48&&he<=57)Y(he-48+52);else if(he===43||he===45)Y(62);else if(he===47||he===95)Y(63);else{if(he===61)break;throw new SyntaxError(`Unexpected base64 character ${W[ce]}`)}}const Z=$;for(;C>0;)Y(0);return w.wrap(ee).slice(0,Z)}const F="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",E="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function k({buffer:W},R=!0,C=!1){const $=C?E:F;let ee="";const Y=W.byteLength%3;let Z=0;for(;Z<W.byteLength-Y;Z+=3){const ce=W[Z+0],he=W[Z+1],ye=W[Z+2];ee+=$[ce>>>2],ee+=$[(ce<<4|he>>>4)&63],ee+=$[(he<<2|ye>>>6)&63],ee+=$[ye&63]}if(Y===1){const ce=W[Z+0];ee+=$[ce>>>2],ee+=$[ce<<4&63],R&&(ee+="==")}else if(Y===2){const ce=W[Z+0],he=W[Z+1];ee+=$[ce>>>2],ee+=$[(ce<<4|he>>>4)&63],ee+=$[he<<2&63],R&&(ee+="=")}return ee}}),define(_e[63],Se([1,0]),function(ue,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.MicrotaskDelay=void 0,t.MicrotaskDelay=Symbol("MicrotaskDelay")}),define(_e[10],Se([1,0]),function(ue,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isString=i,t.isStringArray=n,t.isObject=O,t.isTypedArray=I,t.isNumber=N,t.isIterable=b,t.isBoolean=w,t.isUndefined=u,t.isDefined=m,t.isUndefinedOrNull=v,t.assertType=g,t.assertIsDefined=d,t.assertAllDefined=e,t.isEmptyObject=r,t.isFunction=l,t.areFunctions=o,t.validateConstraints=p,t.validateConstraint=A,t.upcast=L;function i(c){return typeof c=="string"}function n(c){return Array.isArray(c)&&c.every(a=>i(a))}function O(c){return typeof c=="object"&&c!==null&&!Array.isArray(c)&&!(c instanceof RegExp)&&!(c instanceof Date)}function I(c){const a=Object.getPrototypeOf(Uint8Array);return typeof c=="object"&&c instanceof a}function N(c){return typeof c=="number"&&!isNaN(c)}function b(c){return!!c&&typeof c[Symbol.iterator]=="function"}function w(c){return c===!0||c===!1}function u(c){return typeof c>"u"}function m(c){return!v(c)}function v(c){return u(c)||c===null}function g(c,a){if(!c)throw new Error(a?`Unexpected type, expected '${a}'`:"Unexpected type")}function d(c){if(v(c))throw new Error("Assertion Failed: argument is undefined or null");return c}function e(...c){const a=[];for(let f=0;f<c.length;f++){const _=c[f];if(v(_))throw new Error(`Assertion Failed: argument at index ${f} is undefined or null`);a.push(_)}return a}const s=Object.prototype.hasOwnProperty;function r(c){if(!O(c))return!1;for(const a in c)if(s.call(c,a))return!1;return!0}function l(c){return typeof c=="function"}function o(...c){return c.length>0&&c.every(l)}function p(c,a){const f=Math.min(c.length,a.length);for(let _=0;_<f;_++)A(c[_],a[_])}function A(c,a){if(i(a)){if(typeof c!==a)throw new Error(`argument does not match constraint: typeof ${a}`)}else if(l(a)){try{if(c instanceof a)return}catch{}if(!v(c)&&c.constructor===a||a.length===1&&a.call(void 0,c)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}function L(c){return c}}),define(_e[48],Se([1,0,10]),function(ue,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.register=O,t.getCodiconFontCharacters=I;const n=Object.create(null);function O(N,b){if((0,i.isString)(b)){const w=n[b];if(w===void 0)throw new Error(`${N} references an unknown codicon: ${b}`);b=w}return n[N]=b,{id:N}}function I(){return n}}),define(_e[105],Se([1,0,48]),function(ue,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.codiconsLibrary=void 0,t.codiconsLibrary={add:(0,i.register)("add",6e4),plus:(0,i.register)("plus",6e4),gistNew:(0,i.register)("gist-new",6e4),repoCreate:(0,i.register)("repo-create",6e4),lightbulb:(0,i.register)("lightbulb",60001),lightBulb:(0,i.register)("light-bulb",60001),repo:(0,i.register)("repo",60002),repoDelete:(0,i.register)("repo-delete",60002),gistFork:(0,i.register)("gist-fork",60003),repoForked:(0,i.register)("repo-forked",60003),gitPullRequest:(0,i.register)("git-pull-request",60004),gitPullRequestAbandoned:(0,i.register)("git-pull-request-abandoned",60004),recordKeys:(0,i.register)("record-keys",60005),keyboard:(0,i.register)("keyboard",60005),tag:(0,i.register)("tag",60006),gitPullRequestLabel:(0,i.register)("git-pull-request-label",60006),tagAdd:(0,i.register)("tag-add",60006),tagRemove:(0,i.register)("tag-remove",60006),person:(0,i.register)("person",60007),personFollow:(0,i.register)("person-follow",60007),personOutline:(0,i.register)("person-outline",60007),personFilled:(0,i.register)("person-filled",60007),gitBranch:(0,i.register)("git-branch",60008),gitBranchCreate:(0,i.register)("git-branch-create",60008),gitBranchDelete:(0,i.register)("git-branch-delete",60008),sourceControl:(0,i.register)("source-control",60008),mirror:(0,i.register)("mirror",60009),mirrorPublic:(0,i.register)("mirror-public",60009),star:(0,i.register)("star",60010),starAdd:(0,i.register)("star-add",60010),starDelete:(0,i.register)("star-delete",60010),starEmpty:(0,i.register)("star-empty",60010),comment:(0,i.register)("comment",60011),commentAdd:(0,i.register)("comment-add",60011),alert:(0,i.register)("alert",60012),warning:(0,i.register)("warning",60012),search:(0,i.register)("search",60013),searchSave:(0,i.register)("search-save",60013),logOut:(0,i.register)("log-out",60014),signOut:(0,i.register)("sign-out",60014),logIn:(0,i.register)("log-in",60015),signIn:(0,i.register)("sign-in",60015),eye:(0,i.register)("eye",60016),eyeUnwatch:(0,i.register)("eye-unwatch",60016),eyeWatch:(0,i.register)("eye-watch",60016),circleFilled:(0,i.register)("circle-filled",60017),primitiveDot:(0,i.register)("primitive-dot",60017),closeDirty:(0,i.register)("close-dirty",60017),debugBreakpoint:(0,i.register)("debug-breakpoint",60017),debugBreakpointDisabled:(0,i.register)("debug-breakpoint-disabled",60017),debugHint:(0,i.register)("debug-hint",60017),terminalDecorationSuccess:(0,i.register)("terminal-decoration-success",60017),primitiveSquare:(0,i.register)("primitive-square",60018),edit:(0,i.register)("edit",60019),pencil:(0,i.register)("pencil",60019),info:(0,i.register)("info",60020),issueOpened:(0,i.register)("issue-opened",60020),gistPrivate:(0,i.register)("gist-private",60021),gitForkPrivate:(0,i.register)("git-fork-private",60021),lock:(0,i.register)("lock",60021),mirrorPrivate:(0,i.register)("mirror-private",60021),close:(0,i.register)("close",60022),removeClose:(0,i.register)("remove-close",60022),x:(0,i.register)("x",60022),repoSync:(0,i.register)("repo-sync",60023),sync:(0,i.register)("sync",60023),clone:(0,i.register)("clone",60024),desktopDownload:(0,i.register)("desktop-download",60024),beaker:(0,i.register)("beaker",60025),microscope:(0,i.register)("microscope",60025),vm:(0,i.register)("vm",60026),deviceDesktop:(0,i.register)("device-desktop",60026),file:(0,i.register)("file",60027),fileText:(0,i.register)("file-text",60027),more:(0,i.register)("more",60028),ellipsis:(0,i.register)("ellipsis",60028),kebabHorizontal:(0,i.register)("kebab-horizontal",60028),mailReply:(0,i.register)("mail-reply",60029),reply:(0,i.register)("reply",60029),organization:(0,i.register)("organization",60030),organizationFilled:(0,i.register)("organization-filled",60030),organizationOutline:(0,i.register)("organization-outline",60030),newFile:(0,i.register)("new-file",60031),fileAdd:(0,i.register)("file-add",60031),newFolder:(0,i.register)("new-folder",60032),fileDirectoryCreate:(0,i.register)("file-directory-create",60032),trash:(0,i.register)("trash",60033),trashcan:(0,i.register)("trashcan",60033),history:(0,i.register)("history",60034),clock:(0,i.register)("clock",60034),folder:(0,i.register)("folder",60035),fileDirectory:(0,i.register)("file-directory",60035),symbolFolder:(0,i.register)("symbol-folder",60035),logoGithub:(0,i.register)("logo-github",60036),markGithub:(0,i.register)("mark-github",60036),github:(0,i.register)("github",60036),terminal:(0,i.register)("terminal",60037),console:(0,i.register)("console",60037),repl:(0,i.register)("repl",60037),zap:(0,i.register)("zap",60038),symbolEvent:(0,i.register)("symbol-event",60038),error:(0,i.register)("error",60039),stop:(0,i.register)("stop",60039),variable:(0,i.register)("variable",60040),symbolVariable:(0,i.register)("symbol-variable",60040),array:(0,i.register)("array",60042),symbolArray:(0,i.register)("symbol-array",60042),symbolModule:(0,i.register)("symbol-module",60043),symbolPackage:(0,i.register)("symbol-package",60043),symbolNamespace:(0,i.register)("symbol-namespace",60043),symbolObject:(0,i.register)("symbol-object",60043),symbolMethod:(0,i.register)("symbol-method",60044),symbolFunction:(0,i.register)("symbol-function",60044),symbolConstructor:(0,i.register)("symbol-constructor",60044),symbolBoolean:(0,i.register)("symbol-boolean",60047),symbolNull:(0,i.register)("symbol-null",60047),symbolNumeric:(0,i.register)("symbol-numeric",60048),symbolNumber:(0,i.register)("symbol-number",60048),symbolStructure:(0,i.register)("symbol-structure",60049),symbolStruct:(0,i.register)("symbol-struct",60049),symbolParameter:(0,i.register)("symbol-parameter",60050),symbolTypeParameter:(0,i.register)("symbol-type-parameter",60050),symbolKey:(0,i.register)("symbol-key",60051),symbolText:(0,i.register)("symbol-text",60051),symbolReference:(0,i.register)("symbol-reference",60052),goToFile:(0,i.register)("go-to-file",60052),symbolEnum:(0,i.register)("symbol-enum",60053),symbolValue:(0,i.register)("symbol-value",60053),symbolRuler:(0,i.register)("symbol-ruler",60054),symbolUnit:(0,i.register)("symbol-unit",60054),activateBreakpoints:(0,i.register)("activate-breakpoints",60055),archive:(0,i.register)("archive",60056),arrowBoth:(0,i.register)("arrow-both",60057),arrowDown:(0,i.register)("arrow-down",60058),arrowLeft:(0,i.register)("arrow-left",60059),arrowRight:(0,i.register)("arrow-right",60060),arrowSmallDown:(0,i.register)("arrow-small-down",60061),arrowSmallLeft:(0,i.register)("arrow-small-left",60062),arrowSmallRight:(0,i.register)("arrow-small-right",60063),arrowSmallUp:(0,i.register)("arrow-small-up",60064),arrowUp:(0,i.register)("arrow-up",60065),bell:(0,i.register)("bell",60066),bold:(0,i.register)("bold",60067),book:(0,i.register)("book",60068),bookmark:(0,i.register)("bookmark",60069),debugBreakpointConditionalUnverified:(0,i.register)("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:(0,i.register)("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:(0,i.register)("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:(0,i.register)("debug-breakpoint-data-unverified",60072),debugBreakpointData:(0,i.register)("debug-breakpoint-data",60073),debugBreakpointDataDisabled:(0,i.register)("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:(0,i.register)("debug-breakpoint-log-unverified",60074),debugBreakpointLog:(0,i.register)("debug-breakpoint-log",60075),debugBreakpointLogDisabled:(0,i.register)("debug-breakpoint-log-disabled",60075),briefcase:(0,i.register)("briefcase",60076),broadcast:(0,i.register)("broadcast",60077),browser:(0,i.register)("browser",60078),bug:(0,i.register)("bug",60079),calendar:(0,i.register)("calendar",60080),caseSensitive:(0,i.register)("case-sensitive",60081),check:(0,i.register)("check",60082),checklist:(0,i.register)("checklist",60083),chevronDown:(0,i.register)("chevron-down",60084),chevronLeft:(0,i.register)("chevron-left",60085),chevronRight:(0,i.register)("chevron-right",60086),chevronUp:(0,i.register)("chevron-up",60087),chromeClose:(0,i.register)("chrome-close",60088),chromeMaximize:(0,i.register)("chrome-maximize",60089),chromeMinimize:(0,i.register)("chrome-minimize",60090),chromeRestore:(0,i.register)("chrome-restore",60091),circleOutline:(0,i.register)("circle-outline",60092),circle:(0,i.register)("circle",60092),debugBreakpointUnverified:(0,i.register)("debug-breakpoint-unverified",60092),terminalDecorationIncomplete:(0,i.register)("terminal-decoration-incomplete",60092),circleSlash:(0,i.register)("circle-slash",60093),circuitBoard:(0,i.register)("circuit-board",60094),clearAll:(0,i.register)("clear-all",60095),clippy:(0,i.register)("clippy",60096),closeAll:(0,i.register)("close-all",60097),cloudDownload:(0,i.register)("cloud-download",60098),cloudUpload:(0,i.register)("cloud-upload",60099),code:(0,i.register)("code",60100),collapseAll:(0,i.register)("collapse-all",60101),colorMode:(0,i.register)("color-mode",60102),commentDiscussion:(0,i.register)("comment-discussion",60103),creditCard:(0,i.register)("credit-card",60105),dash:(0,i.register)("dash",60108),dashboard:(0,i.register)("dashboard",60109),database:(0,i.register)("database",60110),debugContinue:(0,i.register)("debug-continue",60111),debugDisconnect:(0,i.register)("debug-disconnect",60112),debugPause:(0,i.register)("debug-pause",60113),debugRestart:(0,i.register)("debug-restart",60114),debugStart:(0,i.register)("debug-start",60115),debugStepInto:(0,i.register)("debug-step-into",60116),debugStepOut:(0,i.register)("debug-step-out",60117),debugStepOver:(0,i.register)("debug-step-over",60118),debugStop:(0,i.register)("debug-stop",60119),debug:(0,i.register)("debug",60120),deviceCameraVideo:(0,i.register)("device-camera-video",60121),deviceCamera:(0,i.register)("device-camera",60122),deviceMobile:(0,i.register)("device-mobile",60123),diffAdded:(0,i.register)("diff-added",60124),diffIgnored:(0,i.register)("diff-ignored",60125),diffModified:(0,i.register)("diff-modified",60126),diffRemoved:(0,i.register)("diff-removed",60127),diffRenamed:(0,i.register)("diff-renamed",60128),diff:(0,i.register)("diff",60129),diffSidebyside:(0,i.register)("diff-sidebyside",60129),discard:(0,i.register)("discard",60130),editorLayout:(0,i.register)("editor-layout",60131),emptyWindow:(0,i.register)("empty-window",60132),exclude:(0,i.register)("exclude",60133),extensions:(0,i.register)("extensions",60134),eyeClosed:(0,i.register)("eye-closed",60135),fileBinary:(0,i.register)("file-binary",60136),fileCode:(0,i.register)("file-code",60137),fileMedia:(0,i.register)("file-media",60138),filePdf:(0,i.register)("file-pdf",60139),fileSubmodule:(0,i.register)("file-submodule",60140),fileSymlinkDirectory:(0,i.register)("file-symlink-directory",60141),fileSymlinkFile:(0,i.register)("file-symlink-file",60142),fileZip:(0,i.register)("file-zip",60143),files:(0,i.register)("files",60144),filter:(0,i.register)("filter",60145),flame:(0,i.register)("flame",60146),foldDown:(0,i.register)("fold-down",60147),foldUp:(0,i.register)("fold-up",60148),fold:(0,i.register)("fold",60149),folderActive:(0,i.register)("folder-active",60150),folderOpened:(0,i.register)("folder-opened",60151),gear:(0,i.register)("gear",60152),gift:(0,i.register)("gift",60153),gistSecret:(0,i.register)("gist-secret",60154),gist:(0,i.register)("gist",60155),gitCommit:(0,i.register)("git-commit",60156),gitCompare:(0,i.register)("git-compare",60157),compareChanges:(0,i.register)("compare-changes",60157),gitMerge:(0,i.register)("git-merge",60158),githubAction:(0,i.register)("github-action",60159),githubAlt:(0,i.register)("github-alt",60160),globe:(0,i.register)("globe",60161),grabber:(0,i.register)("grabber",60162),graph:(0,i.register)("graph",60163),gripper:(0,i.register)("gripper",60164),heart:(0,i.register)("heart",60165),home:(0,i.register)("home",60166),horizontalRule:(0,i.register)("horizontal-rule",60167),hubot:(0,i.register)("hubot",60168),inbox:(0,i.register)("inbox",60169),issueReopened:(0,i.register)("issue-reopened",60171),issues:(0,i.register)("issues",60172),italic:(0,i.register)("italic",60173),jersey:(0,i.register)("jersey",60174),json:(0,i.register)("json",60175),kebabVertical:(0,i.register)("kebab-vertical",60176),key:(0,i.register)("key",60177),law:(0,i.register)("law",60178),lightbulbAutofix:(0,i.register)("lightbulb-autofix",60179),linkExternal:(0,i.register)("link-external",60180),link:(0,i.register)("link",60181),listOrdered:(0,i.register)("list-ordered",60182),listUnordered:(0,i.register)("list-unordered",60183),liveShare:(0,i.register)("live-share",60184),loading:(0,i.register)("loading",60185),location:(0,i.register)("location",60186),mailRead:(0,i.register)("mail-read",60187),mail:(0,i.register)("mail",60188),markdown:(0,i.register)("markdown",60189),megaphone:(0,i.register)("megaphone",60190),mention:(0,i.register)("mention",60191),milestone:(0,i.register)("milestone",60192),gitPullRequestMilestone:(0,i.register)("git-pull-request-milestone",60192),mortarBoard:(0,i.register)("mortar-board",60193),move:(0,i.register)("move",60194),multipleWindows:(0,i.register)("multiple-windows",60195),mute:(0,i.register)("mute",60196),noNewline:(0,i.register)("no-newline",60197),note:(0,i.register)("note",60198),octoface:(0,i.register)("octoface",60199),openPreview:(0,i.register)("open-preview",60200),package:(0,i.register)("package",60201),paintcan:(0,i.register)("paintcan",60202),pin:(0,i.register)("pin",60203),play:(0,i.register)("play",60204),run:(0,i.register)("run",60204),plug:(0,i.register)("plug",60205),preserveCase:(0,i.register)("preserve-case",60206),preview:(0,i.register)("preview",60207),project:(0,i.register)("project",60208),pulse:(0,i.register)("pulse",60209),question:(0,i.register)("question",60210),quote:(0,i.register)("quote",60211),radioTower:(0,i.register)("radio-tower",60212),reactions:(0,i.register)("reactions",60213),references:(0,i.register)("references",60214),refresh:(0,i.register)("refresh",60215),regex:(0,i.register)("regex",60216),remoteExplorer:(0,i.register)("remote-explorer",60217),remote:(0,i.register)("remote",60218),remove:(0,i.register)("remove",60219),replaceAll:(0,i.register)("replace-all",60220),replace:(0,i.register)("replace",60221),repoClone:(0,i.register)("repo-clone",60222),repoForcePush:(0,i.register)("repo-force-push",60223),repoPull:(0,i.register)("repo-pull",60224),repoPush:(0,i.register)("repo-push",60225),report:(0,i.register)("report",60226),requestChanges:(0,i.register)("request-changes",60227),rocket:(0,i.register)("rocket",60228),rootFolderOpened:(0,i.register)("root-folder-opened",60229),rootFolder:(0,i.register)("root-folder",60230),rss:(0,i.register)("rss",60231),ruby:(0,i.register)("ruby",60232),saveAll:(0,i.register)("save-all",60233),saveAs:(0,i.register)("save-as",60234),save:(0,i.register)("save",60235),screenFull:(0,i.register)("screen-full",60236),screenNormal:(0,i.register)("screen-normal",60237),searchStop:(0,i.register)("search-stop",60238),server:(0,i.register)("server",60240),settingsGear:(0,i.register)("settings-gear",60241),settings:(0,i.register)("settings",60242),shield:(0,i.register)("shield",60243),smiley:(0,i.register)("smiley",60244),sortPrecedence:(0,i.register)("sort-precedence",60245),splitHorizontal:(0,i.register)("split-horizontal",60246),splitVertical:(0,i.register)("split-vertical",60247),squirrel:(0,i.register)("squirrel",60248),starFull:(0,i.register)("star-full",60249),starHalf:(0,i.register)("star-half",60250),symbolClass:(0,i.register)("symbol-class",60251),symbolColor:(0,i.register)("symbol-color",60252),symbolConstant:(0,i.register)("symbol-constant",60253),symbolEnumMember:(0,i.register)("symbol-enum-member",60254),symbolField:(0,i.register)("symbol-field",60255),symbolFile:(0,i.register)("symbol-file",60256),symbolInterface:(0,i.register)("symbol-interface",60257),symbolKeyword:(0,i.register)("symbol-keyword",60258),symbolMisc:(0,i.register)("symbol-misc",60259),symbolOperator:(0,i.register)("symbol-operator",60260),symbolProperty:(0,i.register)("symbol-property",60261),wrench:(0,i.register)("wrench",60261),wrenchSubaction:(0,i.register)("wrench-subaction",60261),symbolSnippet:(0,i.register)("symbol-snippet",60262),tasklist:(0,i.register)("tasklist",60263),telescope:(0,i.register)("telescope",60264),textSize:(0,i.register)("text-size",60265),threeBars:(0,i.register)("three-bars",60266),thumbsdown:(0,i.register)("thumbsdown",60267),thumbsup:(0,i.register)("thumbsup",60268),tools:(0,i.register)("tools",60269),triangleDown:(0,i.register)("triangle-down",60270),triangleLeft:(0,i.register)("triangle-left",60271),triangleRight:(0,i.register)("triangle-right",60272),triangleUp:(0,i.register)("triangle-up",60273),twitter:(0,i.register)("twitter",60274),unfold:(0,i.register)("unfold",60275),unlock:(0,i.register)("unlock",60276),unmute:(0,i.register)("unmute",60277),unverified:(0,i.register)("unverified",60278),verified:(0,i.register)("verified",60279),versions:(0,i.register)("versions",60280),vmActive:(0,i.register)("vm-active",60281),vmOutline:(0,i.register)("vm-outline",60282),vmRunning:(0,i.register)("vm-running",60283),watch:(0,i.register)("watch",60284),whitespace:(0,i.register)("whitespace",60285),wholeWord:(0,i.register)("whole-word",60286),window:(0,i.register)("window",60287),wordWrap:(0,i.register)("word-wrap",60288),zoomIn:(0,i.register)("zoom-in",60289),zoomOut:(0,i.register)("zoom-out",60290),listFilter:(0,i.register)("list-filter",60291),listFlat:(0,i.register)("list-flat",60292),listSelection:(0,i.register)("list-selection",60293),selection:(0,i.register)("selection",60293),listTree:(0,i.register)("list-tree",60294),debugBreakpointFunctionUnverified:(0,i.register)("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:(0,i.register)("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:(0,i.register)("debug-breakpoint-function-disabled",60296),debugStackframeActive:(0,i.register)("debug-stackframe-active",60297),circleSmallFilled:(0,i.register)("circle-small-filled",60298),debugStackframeDot:(0,i.register)("debug-stackframe-dot",60298),terminalDecorationMark:(0,i.register)("terminal-decoration-mark",60298),debugStackframe:(0,i.register)("debug-stackframe",60299),debugStackframeFocused:(0,i.register)("debug-stackframe-focused",60299),debugBreakpointUnsupported:(0,i.register)("debug-breakpoint-unsupported",60300),symbolString:(0,i.register)("symbol-string",60301),debugReverseContinue:(0,i.register)("debug-reverse-continue",60302),debugStepBack:(0,i.register)("debug-step-back",60303),debugRestartFrame:(0,i.register)("debug-restart-frame",60304),debugAlt:(0,i.register)("debug-alt",60305),callIncoming:(0,i.register)("call-incoming",60306),callOutgoing:(0,i.register)("call-outgoing",60307),menu:(0,i.register)("menu",60308),expandAll:(0,i.register)("expand-all",60309),feedback:(0,i.register)("feedback",60310),gitPullRequestReviewer:(0,i.register)("git-pull-request-reviewer",60310),groupByRefType:(0,i.register)("group-by-ref-type",60311),ungroupByRefType:(0,i.register)("ungroup-by-ref-type",60312),account:(0,i.register)("account",60313),gitPullRequestAssignee:(0,i.register)("git-pull-request-assignee",60313),bellDot:(0,i.register)("bell-dot",60314),debugConsole:(0,i.register)("debug-console",60315),library:(0,i.register)("library",60316),output:(0,i.register)("output",60317),runAll:(0,i.register)("run-all",60318),syncIgnored:(0,i.register)("sync-ignored",60319),pinned:(0,i.register)("pinned",60320),githubInverted:(0,i.register)("github-inverted",60321),serverProcess:(0,i.register)("server-process",60322),serverEnvironment:(0,i.register)("server-environment",60323),pass:(0,i.register)("pass",60324),issueClosed:(0,i.register)("issue-closed",60324),stopCircle:(0,i.register)("stop-circle",60325),playCircle:(0,i.register)("play-circle",60326),record:(0,i.register)("record",60327),debugAltSmall:(0,i.register)("debug-alt-small",60328),vmConnect:(0,i.register)("vm-connect",60329),cloud:(0,i.register)("cloud",60330),merge:(0,i.register)("merge",60331),export:(0,i.register)("export",60332),graphLeft:(0,i.register)("graph-left",60333),magnet:(0,i.register)("magnet",60334),notebook:(0,i.register)("notebook",60335),redo:(0,i.register)("redo",60336),checkAll:(0,i.register)("check-all",60337),pinnedDirty:(0,i.register)("pinned-dirty",60338),passFilled:(0,i.register)("pass-filled",60339),circleLargeFilled:(0,i.register)("circle-large-filled",60340),circleLarge:(0,i.register)("circle-large",60341),circleLargeOutline:(0,i.register)("circle-large-outline",60341),combine:(0,i.register)("combine",60342),gather:(0,i.register)("gather",60342),table:(0,i.register)("table",60343),variableGroup:(0,i.register)("variable-group",60344),typeHierarchy:(0,i.register)("type-hierarchy",60345),typeHierarchySub:(0,i.register)("type-hierarchy-sub",60346),typeHierarchySuper:(0,i.register)("type-hierarchy-super",60347),gitPullRequestCreate:(0,i.register)("git-pull-request-create",60348),runAbove:(0,i.register)("run-above",60349),runBelow:(0,i.register)("run-below",60350),notebookTemplate:(0,i.register)("notebook-template",60351),debugRerun:(0,i.register)("debug-rerun",60352),workspaceTrusted:(0,i.register)("workspace-trusted",60353),workspaceUntrusted:(0,i.register)("workspace-untrusted",60354),workspaceUnknown:(0,i.register)("workspace-unknown",60355),terminalCmd:(0,i.register)("terminal-cmd",60356),terminalDebian:(0,i.register)("terminal-debian",60357),terminalLinux:(0,i.register)("terminal-linux",60358),terminalPowershell:(0,i.register)("terminal-powershell",60359),terminalTmux:(0,i.register)("terminal-tmux",60360),terminalUbuntu:(0,i.register)("terminal-ubuntu",60361),terminalBash:(0,i.register)("terminal-bash",60362),arrowSwap:(0,i.register)("arrow-swap",60363),copy:(0,i.register)("copy",60364),personAdd:(0,i.register)("person-add",60365),filterFilled:(0,i.register)("filter-filled",60366),wand:(0,i.register)("wand",60367),debugLineByLine:(0,i.register)("debug-line-by-line",60368),inspect:(0,i.register)("inspect",60369),layers:(0,i.register)("layers",60370),layersDot:(0,i.register)("layers-dot",60371),layersActive:(0,i.register)("layers-active",60372),compass:(0,i.register)("compass",60373),compassDot:(0,i.register)("compass-dot",60374),compassActive:(0,i.register)("compass-active",60375),azure:(0,i.register)("azure",60376),issueDraft:(0,i.register)("issue-draft",60377),gitPullRequestClosed:(0,i.register)("git-pull-request-closed",60378),gitPullRequestDraft:(0,i.register)("git-pull-request-draft",60379),debugAll:(0,i.register)("debug-all",60380),debugCoverage:(0,i.register)("debug-coverage",60381),runErrors:(0,i.register)("run-errors",60382),folderLibrary:(0,i.register)("folder-library",60383),debugContinueSmall:(0,i.register)("debug-continue-small",60384),beakerStop:(0,i.register)("beaker-stop",60385),graphLine:(0,i.register)("graph-line",60386),graphScatter:(0,i.register)("graph-scatter",60387),pieChart:(0,i.register)("pie-chart",60388),bracket:(0,i.register)("bracket",60175),bracketDot:(0,i.register)("bracket-dot",60389),bracketError:(0,i.register)("bracket-error",60390),lockSmall:(0,i.register)("lock-small",60391),azureDevops:(0,i.register)("azure-devops",60392),verifiedFilled:(0,i.register)("verified-filled",60393),newline:(0,i.register)("newline",60394),layout:(0,i.register)("layout",60395),layoutActivitybarLeft:(0,i.register)("layout-activitybar-left",60396),layoutActivitybarRight:(0,i.register)("layout-activitybar-right",60397),layoutPanelLeft:(0,i.register)("layout-panel-left",60398),layoutPanelCenter:(0,i.register)("layout-panel-center",60399),layoutPanelJustify:(0,i.register)("layout-panel-justify",60400),layoutPanelRight:(0,i.register)("layout-panel-right",60401),layoutPanel:(0,i.register)("layout-panel",60402),layoutSidebarLeft:(0,i.register)("layout-sidebar-left",60403),layoutSidebarRight:(0,i.register)("layout-sidebar-right",60404),layoutStatusbar:(0,i.register)("layout-statusbar",60405),layoutMenubar:(0,i.register)("layout-menubar",60406),layoutCentered:(0,i.register)("layout-centered",60407),target:(0,i.register)("target",60408),indent:(0,i.register)("indent",60409),recordSmall:(0,i.register)("record-small",60410),errorSmall:(0,i.register)("error-small",60411),terminalDecorationError:(0,i.register)("terminal-decoration-error",60411),arrowCircleDown:(0,i.register)("arrow-circle-down",60412),arrowCircleLeft:(0,i.register)("arrow-circle-left",60413),arrowCircleRight:(0,i.register)("arrow-circle-right",60414),arrowCircleUp:(0,i.register)("arrow-circle-up",60415),layoutSidebarRightOff:(0,i.register)("layout-sidebar-right-off",60416),layoutPanelOff:(0,i.register)("layout-panel-off",60417),layoutSidebarLeftOff:(0,i.register)("layout-sidebar-left-off",60418),blank:(0,i.register)("blank",60419),heartFilled:(0,i.register)("heart-filled",60420),map:(0,i.register)("map",60421),mapHorizontal:(0,i.register)("map-horizontal",60421),foldHorizontal:(0,i.register)("fold-horizontal",60421),mapFilled:(0,i.register)("map-filled",60422),mapHorizontalFilled:(0,i.register)("map-horizontal-filled",60422),foldHorizontalFilled:(0,i.register)("fold-horizontal-filled",60422),circleSmall:(0,i.register)("circle-small",60423),bellSlash:(0,i.register)("bell-slash",60424),bellSlashDot:(0,i.register)("bell-slash-dot",60425),commentUnresolved:(0,i.register)("comment-unresolved",60426),gitPullRequestGoToChanges:(0,i.register)("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:(0,i.register)("git-pull-request-new-changes",60428),searchFuzzy:(0,i.register)("search-fuzzy",60429),commentDraft:(0,i.register)("comment-draft",60430),send:(0,i.register)("send",60431),sparkle:(0,i.register)("sparkle",60432),insert:(0,i.register)("insert",60433),mic:(0,i.register)("mic",60434),thumbsdownFilled:(0,i.register)("thumbsdown-filled",60435),thumbsupFilled:(0,i.register)("thumbsup-filled",60436),coffee:(0,i.register)("coffee",60437),snake:(0,i.register)("snake",60438),game:(0,i.register)("game",60439),vr:(0,i.register)("vr",60440),chip:(0,i.register)("chip",60441),piano:(0,i.register)("piano",60442),music:(0,i.register)("music",60443),micFilled:(0,i.register)("mic-filled",60444),repoFetch:(0,i.register)("repo-fetch",60445),copilot:(0,i.register)("copilot",60446),lightbulbSparkle:(0,i.register)("lightbulb-sparkle",60447),robot:(0,i.register)("robot",60448),sparkleFilled:(0,i.register)("sparkle-filled",60449),diffSingle:(0,i.register)("diff-single",60450),diffMultiple:(0,i.register)("diff-multiple",60451),surroundWith:(0,i.register)("surround-with",60452),share:(0,i.register)("share",60453),gitStash:(0,i.register)("git-stash",60454),gitStashApply:(0,i.register)("git-stash-apply",60455),gitStashPop:(0,i.register)("git-stash-pop",60456),vscode:(0,i.register)("vscode",60457),vscodeInsiders:(0,i.register)("vscode-insiders",60458),codeOss:(0,i.register)("code-oss",60459),runCoverage:(0,i.register)("run-coverage",60460),runAllCoverage:(0,i.register)("run-all-coverage",60461),coverage:(0,i.register)("coverage",60462),githubProject:(0,i.register)("github-project",60463),mapVertical:(0,i.register)("map-vertical",60464),foldVertical:(0,i.register)("fold-vertical",60464),mapVerticalFilled:(0,i.register)("map-vertical-filled",60465),foldVerticalFilled:(0,i.register)("fold-vertical-filled",60465),goToSearch:(0,i.register)("go-to-search",60466),percentage:(0,i.register)("percentage",60467),sortPercentage:(0,i.register)("sort-percentage",60467),attach:(0,i.register)("attach",60468)}}),define(_e[20],Se([1,0,48,105]),function(ue,t,i,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Codicon=t.codiconsDerived=void 0,t.getAllCodicons=O;function O(){return Object.values(t.Codicon)}t.codiconsDerived={dialogError:(0,i.register)("dialog-error","error"),dialogWarning:(0,i.register)("dialog-warning","warning"),dialogInfo:(0,i.register)("dialog-info","info"),dialogClose:(0,i.register)("dialog-close","close"),treeItemExpanded:(0,i.register)("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:(0,i.register)("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:(0,i.register)("tree-filter-on-type-off","list-selection"),treeFilterClear:(0,i.register)("tree-filter-clear","close"),treeItemLoading:(0,i.register)("tree-item-loading","loading"),menuSelection:(0,i.register)("menu-selection","check"),menuSubmenu:(0,i.register)("menu-submenu","chevron-right"),menuBarMore:(0,i.register)("menubar-more","more"),scrollbarButtonLeft:(0,i.register)("scrollbar-button-left","triangle-left"),scrollbarButtonRight:(0,i.register)("scrollbar-button-right","triangle-right"),scrollbarButtonUp:(0,i.register)("scrollbar-button-up","triangle-up"),scrollbarButtonDown:(0,i.register)("scrollbar-button-down","triangle-down"),toolBarMore:(0,i.register)("toolbar-more","more"),quickInputBack:(0,i.register)("quick-input-back","arrow-left"),dropDownButton:(0,i.register)("drop-down-button",60084),symbolCustomColor:(0,i.register)("symbol-customcolor",60252),exportIcon:(0,i.register)("export",60332),workspaceUnspecified:(0,i.register)("workspace-unspecified",60355),newLine:(0,i.register)("newline",60394),thumbsDownFilled:(0,i.register)("thumbsdown-filled",60435),thumbsUpFilled:(0,i.register)("thumbsup-filled",60436),gitFetch:(0,i.register)("git-fetch",60445),lightbulbSparkleAutofix:(0,i.register)("lightbulb-sparkle-autofix",60447),debugBreakpointPending:(0,i.register)("debug-breakpoint-pending",60377)},t.Codicon={...n.codiconsLibrary,...t.codiconsDerived}}),define(_e[64],Se([1,0,10]),function(ue,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.deepClone=n,t.deepFreeze=O,t.cloneAndChange=N,t.mixin=w,t.equals=u,t.safeStringify=m,t.distinct=v,t.getCaseInsensitive=g,t.filter=d,t.getAllPropertyNames=e,t.getAllMethodNames=s,t.createProxyObject=r,t.mapValues=l;function n(o){if(!o||typeof o!="object"||o instanceof RegExp)return o;const p=Array.isArray(o)?[]:{};return Object.entries(o).forEach(([A,L])=>{p[A]=L&&typeof L=="object"?n(L):L}),p}function O(o){if(!o||typeof o!="object")return o;const p=[o];for(;p.length>0;){const A=p.shift();Object.freeze(A);for(const L in A)if(I.call(A,L)){const c=A[L];typeof c=="object"&&!Object.isFrozen(c)&&!(0,i.isTypedArray)(c)&&p.push(c)}}return o}const I=Object.prototype.hasOwnProperty;function N(o,p){return b(o,p,new Set)}function b(o,p,A){if((0,i.isUndefinedOrNull)(o))return o;const L=p(o);if(typeof L<"u")return L;if(Array.isArray(o)){const c=[];for(const a of o)c.push(b(a,p,A));return c}if((0,i.isObject)(o)){if(A.has(o))throw new Error("Cannot clone recursive data-structure");A.add(o);const c={};for(const a in o)I.call(o,a)&&(c[a]=b(o[a],p,A));return A.delete(o),c}return o}function w(o,p,A=!0){return(0,i.isObject)(o)?((0,i.isObject)(p)&&Object.keys(p).forEach(L=>{L in o?A&&((0,i.isObject)(o[L])&&(0,i.isObject)(p[L])?w(o[L],p[L],A):o[L]=p[L]):o[L]=p[L]}),o):p}function u(o,p){if(o===p)return!0;if(o==null||p===null||p===void 0||typeof o!=typeof p||typeof o!="object"||Array.isArray(o)!==Array.isArray(p))return!1;let A,L;if(Array.isArray(o)){if(o.length!==p.length)return!1;for(A=0;A<o.length;A++)if(!u(o[A],p[A]))return!1}else{const c=[];for(L in o)c.push(L);c.sort();const a=[];for(L in p)a.push(L);if(a.sort(),!u(c,a))return!1;for(A=0;A<c.length;A++)if(!u(o[c[A]],p[c[A]]))return!1}return!0}function m(o){const p=new Set;return JSON.stringify(o,(A,L)=>{if((0,i.isObject)(L)||Array.isArray(L)){if(p.has(L))return"[Circular]";p.add(L)}return typeof L=="bigint"?`[BigInt ${L.toString()}]`:L})}function v(o,p){const A=Object.create(null);return!o||!p||Object.keys(p).forEach(c=>{const a=o[c],f=p[c];u(a,f)||(A[c]=f)}),A}function g(o,p){const A=p.toLowerCase(),L=Object.keys(o).find(c=>c.toLowerCase()===A);return L?o[L]:o[p]}function d(o,p){const A=Object.create(null);for(const[L,c]of Object.entries(o))p(L,c)&&(A[L]=c);return A}function e(o){let p=[];for(;Object.prototype!==o;)p=p.concat(Object.getOwnPropertyNames(o)),o=Object.getPrototypeOf(o);return p}function s(o){const p=[];for(const A of e(o))typeof o[A]=="function"&&p.push(A);return p}function r(o,p){const A=c=>function(){const a=Array.prototype.slice.call(arguments,0);return p(c,a)},L={};for(const c of o)L[c]=A(c);return L}function l(o,p){const A={};for(const[L,c]of Object.entries(o))A[L]=p(c,L);return A}}),define(_e[21],Se([1,0,20]),function(ue,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ThemeIcon=t.ThemeColor=void 0,t.themeColorFromId=O;var n;(function(N){function b(w){return w&&typeof w=="object"&&typeof w.id=="string"}N.isThemeColor=b})(n||(t.ThemeColor=n={}));function O(N){return{id:N}}var I;(function(N){N.iconNameSegment="[A-Za-z0-9]+",N.iconNameExpression="[A-Za-z0-9-]+",N.iconModifierExpression="~[A-Za-z]+",N.iconNameCharacter="[A-Za-z0-9~-]";const b=new RegExp(`^(${N.iconNameExpression})(${N.iconModifierExpression})?$`);function w(o){const p=b.exec(o.id);if(!p)return w(i.Codicon.error);const[,A,L]=p,c=["codicon","codicon-"+A];return L&&c.push("codicon-modifier-"+L.substring(1)),c}N.asClassNameArray=w;function u(o){return w(o).join(" ")}N.asClassName=u;function m(o){return"."+w(o).join(".")}N.asCSSSelector=m;function v(o){return o&&typeof o=="object"&&typeof o.id=="string"&&(typeof o.color>"u"||n.isThemeColor(o.color))}N.isThemeIcon=v;const g=new RegExp(`^\\$\\((${N.iconNameExpression}(?:${N.iconModifierExpression})?)\\)$`);function d(o){const p=g.exec(o);if(!p)return;const[,A]=p;return{id:A}}N.fromString=d;function e(o){return{id:o}}N.fromId=e;function s(o,p){let A=o.id;const L=A.lastIndexOf("~");return L!==-1&&(A=A.substring(0,L)),p&&(A=`${A}~${p}`),{id:A}}N.modify=s;function r(o){const p=o.id.lastIndexOf("~");if(p!==-1)return o.id.substring(p+1)}N.getModifier=r;function l(o,p){return o.id===p.id&&o.color?.id===p.color?.id}N.isEqual=l})(I||(t.ThemeIcon=I={}))}),define(_e[65],Se([1,0]),function(ue,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Constants=void 0,t.toUint8=n,t.toUint32=O;var i;(function(I){I[I.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",I[I.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",I[I.MAX_UINT_8=255]="MAX_UINT_8",I[I.MAX_UINT_16=65535]="MAX_UINT_16",I[I.MAX_UINT_32=4294967295]="MAX_UINT_32",I[I.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(i||(t.Constants=i={}));function n(I){return I<0?0:I>i.MAX_UINT_8?i.MAX_UINT_8:I|0}function O(I){return I<0?0:I>i.MAX_UINT_32?i.MAX_UINT_32:I|0}}),define(_e[11],Se([1,0,101,17,25,65]),function(ue,t,i,n,O,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.InvisibleCharacters=t.AmbiguousCharacters=t.noBreakWhitespace=t.GraphemeBreakType=t.UTF8_BOM_CHARACTER=t.UNUSUAL_LINE_TERMINATORS=t.GraphemeIterator=t.CodePointIterator=void 0,t.isFalsyOrWhitespace=N,t.format=w,t.format2=m,t.htmlAttributeEncodeValue=v,t.escape=g,t.escapeRegExpCharacters=d,t.count=e,t.truncate=s,t.truncateMiddle=r,t.trim=l,t.ltrim=o,t.rtrim=p,t.convertSimple2RegExpPattern=A,t.stripWildcards=L,t.createRegExp=c,t.regExpLeadsToEndlessLoop=a,t.splitLines=f,t.splitLinesIncludeSeparators=_,t.firstNonWhitespaceIndex=H,t.getLeadingWhitespace=B,t.lastNonWhitespaceIndex=F,t.replaceAsync=E,t.compare=k,t.compareSubstring=W,t.compareIgnoreCase=R,t.compareSubstringIgnoreCase=C,t.isAsciiDigit=$,t.isLowerAsciiLetter=ee,t.isUpperAsciiLetter=Y,t.equalsIgnoreCase=Z,t.startsWithIgnoreCase=ce,t.commonPrefixLength=he,t.commonSuffixLength=ye,t.isHighSurrogate=Re,t.isLowSurrogate=Pe,t.computeCodePoint=re,t.getNextCodePoint=ie,t.nextCharLength=ne,t.prevCharLength=Ee,t.getCharContainingOffset=Le,t.charCount=Ce,t.containsRTL=Xe,t.isBasicASCII=x,t.containsUnusualLineTerminators=h,t.isFullWidthCharacter=S,t.isEmojiImprecise=P,t.lcut=G,t.forAnsiStringParts=te,t.removeAnsiEscapeCodes=y,t.removeAnsiEscapeCodesFromPrompt=z,t.startsWithUTF8BOM=V,t.stripUTF8BOM=q,t.fuzzyContains=se,t.containsUppercaseCharacter=ae,t.uppercaseFirstLetter=ge,t.getNLines=we,t.singleLetterHash=De,t.getGraphemeBreakType=Te,t.getLeftDeleteOffset=it;function N(T){return!T||typeof T!="string"?!0:T.trim().length===0}const b=/{(\d+)}/g;function w(T,...M){return M.length===0?T:T.replace(b,function(K,Q){const de=parseInt(Q,10);return isNaN(de)||de<0||de>=M.length?K:M[de]})}const u=/{([^}]+)}/g;function m(T,M){return Object.keys(M).length===0?T:T.replace(u,(K,Q)=>M[Q]??K)}function v(T){return T.replace(/[<>"'&]/g,M=>{switch(M){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return M})}function g(T){return T.replace(/[<>&]/g,function(M){switch(M){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return M}})}function d(T){return T.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function e(T,M){let K=0,Q=T.indexOf(M);for(;Q!==-1;)K++,Q=T.indexOf(M,Q+M.length);return K}function s(T,M,K="\u2026"){return T.length<=M?T:`${T.substr(0,M)}${K}`}function r(T,M,K="\u2026"){if(T.length<=M)return T;const Q=Math.ceil(M/2)-K.length/2,de=Math.floor(M/2)-K.length/2;return`${T.substr(0,Q)}${K}${T.substr(T.length-de)}`}function l(T,M=" "){const K=o(T,M);return p(K,M)}function o(T,M){if(!T||!M)return T;const K=M.length;if(K===0||T.length===0)return T;let Q=0;for(;T.indexOf(M,Q)===Q;)Q=Q+K;return T.substring(Q)}function p(T,M){if(!T||!M)return T;const K=M.length,Q=T.length;if(K===0||Q===0)return T;let de=Q,pe=-1;for(;pe=T.lastIndexOf(M,de-1),!(pe===-1||pe+K!==de);){if(pe===0)return"";de=pe}return T.substring(0,de)}function A(T){return T.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function L(T){return T.replace(/\*/g,"")}function c(T,M,K={}){if(!T)throw new Error("Cannot create regex from empty string");M||(T=d(T)),K.wholeWord&&(/\B/.test(T.charAt(0))||(T="\\b"+T),/\B/.test(T.charAt(T.length-1))||(T=T+"\\b"));let Q="";return K.global&&(Q+="g"),K.matchCase||(Q+="i"),K.multiline&&(Q+="m"),K.unicode&&(Q+="u"),new RegExp(T,Q)}function a(T){return T.source==="^"||T.source==="^$"||T.source==="$"||T.source==="^\\s*$"?!1:!!(T.exec("")&&T.lastIndex===0)}function f(T){return T.split(/\r\n|\r|\n/)}function _(T){const M=[],K=T.split(/(\r\n|\r|\n)/);for(let Q=0;Q<Math.ceil(K.length/2);Q++)M.push(K[2*Q]+(K[2*Q+1]??""));return M}function H(T){for(let M=0,K=T.length;M<K;M++){const Q=T.charCodeAt(M);if(Q!==n.CharCode.Space&&Q!==n.CharCode.Tab)return M}return-1}function B(T,M=0,K=T.length){for(let Q=M;Q<K;Q++){const de=T.charCodeAt(Q);if(de!==n.CharCode.Space&&de!==n.CharCode.Tab)return T.substring(M,Q)}return T.substring(M,K)}function F(T,M=T.length-1){for(let K=M;K>=0;K--){const Q=T.charCodeAt(K);if(Q!==n.CharCode.Space&&Q!==n.CharCode.Tab)return K}return-1}function E(T,M,K){const Q=[];let de=0;for(const pe of T.matchAll(M)){if(Q.push(T.slice(de,pe.index)),pe.index===void 0)throw new Error("match.index should be defined");de=pe.index+pe[0].length,Q.push(K(pe[0],...pe.slice(1),pe.index,T,pe.groups))}return Q.push(T.slice(de)),Promise.all(Q).then(pe=>pe.join(""))}function k(T,M){return T<M?-1:T>M?1:0}function W(T,M,K=0,Q=T.length,de=0,pe=M.length){for(;K<Q&&de<pe;K++,de++){const Ke=T.charCodeAt(K),Ye=M.charCodeAt(de);if(Ke<Ye)return-1;if(Ke>Ye)return 1}const Me=Q-K,xe=pe-de;return Me<xe?-1:Me>xe?1:0}function R(T,M){return C(T,M,0,T.length,0,M.length)}function C(T,M,K=0,Q=T.length,de=0,pe=M.length){for(;K<Q&&de<pe;K++,de++){let Ke=T.charCodeAt(K),Ye=M.charCodeAt(de);if(Ke===Ye)continue;if(Ke>=128||Ye>=128)return W(T.toLowerCase(),M.toLowerCase(),K,Q,de,pe);ee(Ke)&&(Ke-=32),ee(Ye)&&(Ye-=32);const Qe=Ke-Ye;if(Qe!==0)return Qe}const Me=Q-K,xe=pe-de;return Me<xe?-1:Me>xe?1:0}function $(T){return T>=n.CharCode.Digit0&&T<=n.CharCode.Digit9}function ee(T){return T>=n.CharCode.a&&T<=n.CharCode.z}function Y(T){return T>=n.CharCode.A&&T<=n.CharCode.Z}function Z(T,M){return T.length===M.length&&C(T,M)===0}function ce(T,M){const K=M.length;return M.length>T.length?!1:C(T,M,0,K)===0}function he(T,M){const K=Math.min(T.length,M.length);let Q;for(Q=0;Q<K;Q++)if(T.charCodeAt(Q)!==M.charCodeAt(Q))return Q;return K}function ye(T,M){const K=Math.min(T.length,M.length);let Q;const de=T.length-1,pe=M.length-1;for(Q=0;Q<K;Q++)if(T.charCodeAt(de-Q)!==M.charCodeAt(pe-Q))return Q;return K}function Re(T){return 55296<=T&&T<=56319}function Pe(T){return 56320<=T&&T<=57343}function re(T,M){return(T-55296<<10)+(M-56320)+65536}function ie(T,M,K){const Q=T.charCodeAt(K);if(Re(Q)&&K+1<M){const de=T.charCodeAt(K+1);if(Pe(de))return re(Q,de)}return Q}function fe(T,M){const K=T.charCodeAt(M-1);if(Pe(K)&&M>1){const Q=T.charCodeAt(M-2);if(Re(Q))return re(Q,K)}return K}class ve{get offset(){return this._offset}constructor(M,K=0){this._str=M,this._len=M.length,this._offset=K}setOffset(M){this._offset=M}prevCodePoint(){const M=fe(this._str,this._offset);return this._offset-=M>=I.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,M}nextCodePoint(){const M=ie(this._str,this._len,this._offset);return this._offset+=M>=I.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,M}eol(){return this._offset>=this._len}}t.CodePointIterator=ve;class Ne{get offset(){return this._iterator.offset}constructor(M,K=0){this._iterator=new ve(M,K)}nextGraphemeLength(){const M=ke.getInstance(),K=this._iterator,Q=K.offset;let de=M.getGraphemeBreakType(K.nextCodePoint());for(;!K.eol();){const pe=K.offset,Me=M.getGraphemeBreakType(K.nextCodePoint());if(Oe(de,Me)){K.setOffset(pe);break}de=Me}return K.offset-Q}prevGraphemeLength(){const M=ke.getInstance(),K=this._iterator,Q=K.offset;let de=M.getGraphemeBreakType(K.prevCodePoint());for(;K.offset>0;){const pe=K.offset,Me=M.getGraphemeBreakType(K.prevCodePoint());if(Oe(Me,de)){K.setOffset(pe);break}de=Me}return Q-K.offset}eol(){return this._iterator.eol()}}t.GraphemeIterator=Ne;function ne(T,M){return new Ne(T,M).nextGraphemeLength()}function Ee(T,M){return new Ne(T,M).prevGraphemeLength()}function Le(T,M){M>0&&Pe(T.charCodeAt(M))&&M--;const K=M+ne(T,M);return[K-Ee(T,K),K]}function Ce(T){const M=new Ne(T);let K=0;for(;!M.eol();)K++,M.nextGraphemeLength();return K}let Fe;function ze(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function Xe(T){return Fe||(Fe=ze()),Fe.test(T)}const oe=/^[\t\n\r\x20-\x7E]*$/;function x(T){return oe.test(T)}t.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function h(T){return t.UNUSUAL_LINE_TERMINATORS.test(T)}function S(T){return T>=11904&&T<=55215||T>=63744&&T<=64255||T>=65281&&T<=65374}function P(T){return T>=127462&&T<=127487||T===8986||T===8987||T===9200||T===9203||T>=9728&&T<=10175||T===11088||T===11093||T>=127744&&T<=128591||T>=128640&&T<=128764||T>=128992&&T<=129008||T>=129280&&T<=129535||T>=129648&&T<=129782}function G(T,M,K=""){const Q=T.trimStart();if(Q.length<M)return Q;const de=/\b/g;let pe=0;for(;de.test(Q)&&!(Q.length-de.lastIndex<M);)pe=de.lastIndex,de.lastIndex+=1;return pe===0?Q:K+Q.substring(pe).trimStart()}const J=/(?:(?:\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~])|(:?\x1b\].*?\x07)/g;function*te(T){let M=0;for(const K of T.matchAll(J))M!==K.index&&(yield{isCode:!1,str:T.substring(M,K.index)}),yield{isCode:!0,str:K[0]},M=K.index+K[0].length;M!==T.length&&(yield{isCode:!1,str:T.substring(M)})}function y(T){return T&&(T=T.replace(J,"")),T}const D=/\\\[.*?\\\]/g;function z(T){return y(T).replace(D,"")}t.UTF8_BOM_CHARACTER=String.fromCharCode(n.CharCode.UTF8_BOM);function V(T){return!!(T&&T.length>0&&T.charCodeAt(0)===n.CharCode.UTF8_BOM)}function q(T){return V(T)?T.substr(1):T}function se(T,M){if(!T||!M||T.length<M.length)return!1;const K=M.length,Q=T.toLowerCase();let de=0,pe=-1;for(;de<K;){const Me=Q.indexOf(M[de],pe+1);if(Me<0)return!1;pe=Me,de++}return!0}function ae(T,M=!1){return T?(M&&(T=T.replace(/\\./g,"")),T.toLowerCase()!==T):!1}function ge(T){return T.charAt(0).toUpperCase()+T.slice(1)}function we(T,M=1){if(M===0)return"";let K=-1;do K=T.indexOf(`
`,K+1),M--;while(M>0&&K>=0);return K===-1?T:(T[K-1]==="\r"&&K--,T.substr(0,K))}function De(T){const M=n.CharCode.Z-n.CharCode.A+1;return T=T%(2*M),T<M?String.fromCharCode(n.CharCode.a+T):String.fromCharCode(n.CharCode.A+T-M)}function Te(T){return ke.getInstance().getGraphemeBreakType(T)}function Oe(T,M){return T===Ae.Other?M!==Ae.Extend&&M!==Ae.SpacingMark:T===Ae.CR&&M===Ae.LF?!1:T===Ae.Control||T===Ae.CR||T===Ae.LF||M===Ae.Control||M===Ae.CR||M===Ae.LF?!0:!(T===Ae.L&&(M===Ae.L||M===Ae.V||M===Ae.LV||M===Ae.LVT)||(T===Ae.LV||T===Ae.V)&&(M===Ae.V||M===Ae.T)||(T===Ae.LVT||T===Ae.T)&&M===Ae.T||M===Ae.Extend||M===Ae.ZWJ||M===Ae.SpacingMark||T===Ae.Prepend||T===Ae.ZWJ&&M===Ae.Extended_Pictographic||T===Ae.Regional_Indicator&&M===Ae.Regional_Indicator)}var Ae;(function(T){T[T.Other=0]="Other",T[T.Prepend=1]="Prepend",T[T.CR=2]="CR",T[T.LF=3]="LF",T[T.Control=4]="Control",T[T.Extend=5]="Extend",T[T.Regional_Indicator=6]="Regional_Indicator",T[T.SpacingMark=7]="SpacingMark",T[T.L=8]="L",T[T.V=9]="V",T[T.T=10]="T",T[T.LV=11]="LV",T[T.LVT=12]="LVT",T[T.ZWJ=13]="ZWJ",T[T.Extended_Pictographic=14]="Extended_Pictographic"})(Ae||(t.GraphemeBreakType=Ae={}));class ke{static{this._INSTANCE=null}static getInstance(){return ke._INSTANCE||(ke._INSTANCE=new ke),ke._INSTANCE}constructor(){this._data=Ge()}getGraphemeBreakType(M){if(M<32)return M===n.CharCode.LineFeed?Ae.LF:M===n.CharCode.CarriageReturn?Ae.CR:Ae.Control;if(M<127)return Ae.Other;const K=this._data,Q=K.length/3;let de=1;for(;de<=Q;)if(M<K[3*de])de=2*de;else if(M>K[3*de+1])de=2*de+1;else return K[3*de+2];return Ae.Other}}function Ge(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function it(T,M){if(T===0)return 0;const K=rt(T,M);if(K!==void 0)return K;const Q=new ve(M,T);return Q.prevCodePoint(),Q.offset}function rt(T,M){const K=new ve(M,T);let Q=K.prevCodePoint();for(;ft(Q)||Q===ht.emojiVariantSelector||Q===ht.enclosingKeyCap;){if(K.offset===0)return;Q=K.prevCodePoint()}if(!P(Q))return;let de=K.offset;return de>0&&K.prevCodePoint()===ht.zwj&&(de=K.offset),de}function ft(T){return 127995<=T&&T<=127999}var ht;(function(T){T[T.zwj=8205]="zwj",T[T.emojiVariantSelector=65039]="emojiVariantSelector",T[T.enclosingKeyCap=8419]="enclosingKeyCap"})(ht||(ht={})),t.noBreakWhitespace="\xA0";class He{static{this.ambiguousCharacterData=new O.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.cache=new i.LRUCachedFunction({getCacheKey:JSON.stringify},M=>{function K(Qe){const nt=new Map;for(let et=0;et<Qe.length;et+=2)nt.set(Qe[et],Qe[et+1]);return nt}function Q(Qe,nt){const et=new Map(Qe);for(const[ut,Ve]of nt)et.set(ut,Ve);return et}function de(Qe,nt){if(!Qe)return nt;const et=new Map;for(const[ut,Ve]of Qe)nt.has(ut)&&et.set(ut,Ve);return et}const pe=this.ambiguousCharacterData.value;let Me=M.filter(Qe=>!Qe.startsWith("_")&&Qe in pe);Me.length===0&&(Me=["_default"]);let xe;for(const Qe of Me){const nt=K(pe[Qe]);xe=de(xe,nt)}const Ke=K(pe._common),Ye=Q(Ke,xe);return new He(Ye)})}static getInstance(M){return He.cache.get(Array.from(M))}static{this._locales=new O.Lazy(()=>Object.keys(He.ambiguousCharacterData.value).filter(M=>!M.startsWith("_")))}static getLocales(){return He._locales.value}constructor(M){this.confusableDictionary=M}isAmbiguous(M){return this.confusableDictionary.has(M)}containsAmbiguousCharacter(M){for(let K=0;K<M.length;K++){const Q=M.codePointAt(K);if(typeof Q=="number"&&this.isAmbiguous(Q))return!0}return!1}getPrimaryConfusable(M){return this.confusableDictionary.get(M)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}t.AmbiguousCharacters=He;class j{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this._data=void 0}static getData(){return this._data||(this._data=new Set(j.getRawData())),this._data}static isInvisibleCharacter(M){return j.getData().has(M)}static containsInvisibleCharacter(M){for(let K=0;K<M.length;K++){const Q=M.codePointAt(K);if(typeof Q=="number"&&j.isInvisibleCharacter(Q))return!0}return!1}static get codePoints(){return j.getData()}}t.InvisibleCharacters=j}),define(_e[49],Se([1,0,17,43,94,11]),function(ue,t,i,n,O,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FuzzyScoreOptions=t.FuzzyScore=t.matchesPrefix=t.matchesStrictPrefix=void 0,t.or=N,t.matchesContiguousSubString=w,t.matchesSubString=u,t.isUpper=g,t.matchesCamelCase=F,t.matchesWords=E,t.matchesFuzzy=ee,t.matchesFuzzy2=Y,t.anyScore=Z,t.createMatches=ce,t.isPatternInWord=ze,t.fuzzyScore=h,t.fuzzyScoreGracefulAggressive=G,t.fuzzyScoreGraceful=J,I=qe(I);function N(...D){return function(z,V){for(let q=0,se=D.length;q<se;q++){const ae=D[q](z,V);if(ae)return ae}return null}}t.matchesStrictPrefix=b.bind(void 0,!1),t.matchesPrefix=b.bind(void 0,!0);function b(D,z,V){if(!V||V.length<z.length)return null;let q;return D?q=I.startsWithIgnoreCase(V,z):q=V.indexOf(z)===0,q?z.length>0?[{start:0,end:z.length}]:[]:null}function w(D,z){const V=z.toLowerCase().indexOf(D.toLowerCase());return V===-1?null:[{start:V,end:V+D.length}]}function u(D,z){return m(D.toLowerCase(),z.toLowerCase(),0,0)}function m(D,z,V,q){if(V===D.length)return[];if(q===z.length)return null;if(D[V]===z[q]){let se=null;return(se=m(D,z,V+1,q+1))?L({start:q,end:q+1},se):null}return m(D,z,V,q+1)}function v(D){return i.CharCode.a<=D&&D<=i.CharCode.z}function g(D){return i.CharCode.A<=D&&D<=i.CharCode.Z}function d(D){return i.CharCode.Digit0<=D&&D<=i.CharCode.Digit9}function e(D){return D===i.CharCode.Space||D===i.CharCode.Tab||D===i.CharCode.LineFeed||D===i.CharCode.CarriageReturn}const s=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(D=>s.add(D.charCodeAt(0)));function r(D){return e(D)||s.has(D)}function l(D,z){return D===z||r(D)&&r(z)}const o=new Map;function p(D){if(o.has(D))return o.get(D);let z;const V=(0,O.getKoreanAltChars)(D);return V&&(z=V),o.set(D,z),z}function A(D){return v(D)||g(D)||d(D)}function L(D,z){return z.length===0?z=[D]:D.end===z[0].start?z[0].start=D.start:z.unshift(D),z}function c(D,z){for(let V=z;V<D.length;V++){const q=D.charCodeAt(V);if(g(q)||d(q)||V>0&&!A(D.charCodeAt(V-1)))return V}return D.length}function a(D,z,V,q){if(V===D.length)return[];if(q===z.length)return null;if(D[V]!==z[q].toLowerCase())return null;{let se=null,ae=q+1;for(se=a(D,z,V+1,q+1);!se&&(ae=c(z,ae))<z.length;)se=a(D,z,V+1,ae),ae++;return se===null?null:L({start:q,end:q+1},se)}}function f(D){let z=0,V=0,q=0,se=0,ae=0;for(let Oe=0;Oe<D.length;Oe++)ae=D.charCodeAt(Oe),g(ae)&&z++,v(ae)&&V++,A(ae)&&q++,d(ae)&&se++;const ge=z/D.length,we=V/D.length,De=q/D.length,Te=se/D.length;return{upperPercent:ge,lowerPercent:we,alphaPercent:De,numericPercent:Te}}function _(D){const{upperPercent:z,lowerPercent:V}=D;return V===0&&z>.6}function H(D){const{upperPercent:z,lowerPercent:V,alphaPercent:q,numericPercent:se}=D;return V>.2&&z<.8&&q>.6&&se<.2}function B(D){let z=0,V=0,q=0,se=0;for(let ae=0;ae<D.length;ae++)q=D.charCodeAt(ae),g(q)&&z++,v(q)&&V++,e(q)&&se++;return(z===0||V===0)&&se===0?D.length<=30:z<=5}function F(D,z){if(!z||(z=z.trim(),z.length===0)||!B(D))return null;z.length>60&&(z=z.substring(0,60));const V=f(z);if(!H(V)){if(!_(V))return null;z=z.toLowerCase()}let q=null,se=0;for(D=D.toLowerCase();se<z.length&&(q=a(D,z,0,se))===null;)se=c(z,se+1);return q}function E(D,z,V=!1){if(!z||z.length===0)return null;let q=null,se=0;for(D=D.toLowerCase(),z=z.toLowerCase();se<z.length&&(q=k(D,z,0,se,V),q===null);)se=W(z,se+1);return q}function k(D,z,V,q,se){let ae=0;if(V===D.length)return[];if(q===z.length)return null;if(!l(D.charCodeAt(V),z.charCodeAt(q))){const De=p(D.charCodeAt(V));if(!De)return null;for(let Te=0;Te<De.length;Te++)if(!l(De[Te],z.charCodeAt(q+Te)))return null;ae+=De.length-1}let ge=null,we=q+ae+1;if(ge=k(D,z,V+1,we,se),!se)for(;!ge&&(we=W(z,we))<z.length;)ge=k(D,z,V+1,we,se),we++;if(!ge)return null;if(D.charCodeAt(V)!==z.charCodeAt(q)){const De=p(D.charCodeAt(V));if(!De)return ge;for(let Te=0;Te<De.length;Te++)if(De[Te]!==z.charCodeAt(q+Te))return ge}return L({start:q,end:q+ae+1},ge)}function W(D,z){for(let V=z;V<D.length;V++)if(r(D.charCodeAt(V))||V>0&&r(D.charCodeAt(V-1)))return V;return D.length}const R=N(t.matchesPrefix,F,w),C=N(t.matchesPrefix,F,u),$=new n.LRUCache(1e4);function ee(D,z,V=!1){if(typeof D!="string"||typeof z!="string")return null;let q=$.get(D);q||(q=new RegExp(I.convertSimple2RegExpPattern(D),"i"),$.set(D,q));const se=q.exec(z);return se?[{start:se.index,end:se.index+se[0].length}]:V?C(D,z):R(D,z)}function Y(D,z){const V=h(D,D.toLowerCase(),0,z,z.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return V?ce(V):null}function Z(D,z,V,q,se,ae){const ge=Math.min(13,D.length);for(;V<ge;V++){const we=h(D,z,V,q,se,ae,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(we)return we}return[0,ae]}function ce(D){if(typeof D>"u")return[];const z=[],V=D[1];for(let q=D.length-1;q>1;q--){const se=D[q]+V,ae=z[z.length-1];ae&&ae.end===se?ae.end=se+1:z.push({start:se,end:se+1})}return z}const he=128;function ye(){const D=[],z=[];for(let V=0;V<=he;V++)z[V]=0;for(let V=0;V<=he;V++)D.push(z.slice(0));return D}function Re(D){const z=[];for(let V=0;V<=D;V++)z[V]=0;return z}const Pe=Re(2*he),re=Re(2*he),ie=ye(),fe=ye(),ve=ye(),Ne=!1;function ne(D,z,V,q,se){function ae(we,De,Te=" "){for(;we.length<De;)we=Te+we;return we}let ge=` |   |${q.split("").map(we=>ae(we,3)).join("|")}
`;for(let we=0;we<=V;we++)we===0?ge+=" |":ge+=`${z[we-1]}|`,ge+=D[we].slice(0,se+1).map(De=>ae(De.toString(),3)).join("|")+`
`;return ge}function Ee(D,z,V,q){D=D.substr(z),V=V.substr(q),console.log(ne(fe,D,D.length,V,V.length)),console.log(ne(ve,D,D.length,V,V.length)),console.log(ne(ie,D,D.length,V,V.length))}function Le(D,z){if(z<0||z>=D.length)return!1;const V=D.codePointAt(z);switch(V){case i.CharCode.Underline:case i.CharCode.Dash:case i.CharCode.Period:case i.CharCode.Space:case i.CharCode.Slash:case i.CharCode.Backslash:case i.CharCode.SingleQuote:case i.CharCode.DoubleQuote:case i.CharCode.Colon:case i.CharCode.DollarSign:case i.CharCode.LessThan:case i.CharCode.GreaterThan:case i.CharCode.OpenParen:case i.CharCode.CloseParen:case i.CharCode.OpenSquareBracket:case i.CharCode.CloseSquareBracket:case i.CharCode.OpenCurlyBrace:case i.CharCode.CloseCurlyBrace:return!0;case void 0:return!1;default:return!!I.isEmojiImprecise(V)}}function Ce(D,z){if(z<0||z>=D.length)return!1;switch(D.charCodeAt(z)){case i.CharCode.Space:case i.CharCode.Tab:return!0;default:return!1}}function Fe(D,z,V){return z[D]!==V[D]}function ze(D,z,V,q,se,ae,ge=!1){for(;z<V&&se<ae;)D[z]===q[se]&&(ge&&(Pe[z]=se),z+=1),se+=1;return z===V}var Xe;(function(D){D[D.Diag=1]="Diag",D[D.Left=2]="Left",D[D.LeftLeft=3]="LeftLeft"})(Xe||(Xe={}));var oe;(function(D){D.Default=[-100,0];function z(V){return!V||V.length===2&&V[0]===-100&&V[1]===0}D.isDefault=z})(oe||(t.FuzzyScore=oe={}));class x{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(z,V){this.firstMatchCanBeWeak=z,this.boostFullMatch=V}}t.FuzzyScoreOptions=x;function h(D,z,V,q,se,ae,ge=x.default){const we=D.length>he?he:D.length,De=q.length>he?he:q.length;if(V>=we||ae>=De||we-V>De-ae||!ze(z,V,we,se,ae,De,!0))return;S(we,De,V,ae,z,se);let Te=1,Oe=1,Ae=V,ke=ae;const Ge=[!1];for(Te=1,Ae=V;Ae<we;Te++,Ae++){const He=Pe[Ae],j=re[Ae],T=Ae+1<we?re[Ae+1]:De;for(Oe=He-ae+1,ke=He;ke<T;Oe++,ke++){let M=Number.MIN_SAFE_INTEGER,K=!1;ke<=j&&(M=P(D,z,Ae,V,q,se,ke,De,ae,ie[Te-1][Oe-1]===0,Ge));let Q=0;M!==Number.MAX_SAFE_INTEGER&&(K=!0,Q=M+fe[Te-1][Oe-1]);const de=ke>He,pe=de?fe[Te][Oe-1]+(ie[Te][Oe-1]>0?-5:0):0,Me=ke>He+1&&ie[Te][Oe-1]>0,xe=Me?fe[Te][Oe-2]+(ie[Te][Oe-2]>0?-5:0):0;if(Me&&(!de||xe>=pe)&&(!K||xe>=Q))fe[Te][Oe]=xe,ve[Te][Oe]=Xe.LeftLeft,ie[Te][Oe]=0;else if(de&&(!K||pe>=Q))fe[Te][Oe]=pe,ve[Te][Oe]=Xe.Left,ie[Te][Oe]=0;else if(K)fe[Te][Oe]=Q,ve[Te][Oe]=Xe.Diag,ie[Te][Oe]=ie[Te-1][Oe-1]+1;else throw new Error("not possible")}}if(Ne&&Ee(D,V,q,ae),!Ge[0]&&!ge.firstMatchCanBeWeak)return;Te--,Oe--;const it=[fe[Te][Oe],ae];let rt=0,ft=0;for(;Te>=1;){let He=Oe;do{const j=ve[Te][He];if(j===Xe.LeftLeft)He=He-2;else if(j===Xe.Left)He=He-1;else break}while(He>=1);rt>1&&z[V+Te-1]===se[ae+Oe-1]&&!Fe(He+ae-1,q,se)&&rt+1>ie[Te][He]&&(He=Oe),He===Oe?rt++:rt=1,ft||(ft=He),Te--,Oe=He-1,it.push(Oe)}De-ae===we&&ge.boostFullMatch&&(it[0]+=2);const ht=ft-we;return it[0]-=ht,it}function S(D,z,V,q,se,ae){let ge=D-1,we=z-1;for(;ge>=V&&we>=q;)se[ge]===ae[we]&&(re[ge]=we,ge--),we--}function P(D,z,V,q,se,ae,ge,we,De,Te,Oe){if(z[V]!==ae[ge])return Number.MIN_SAFE_INTEGER;let Ae=1,ke=!1;return ge===V-q?Ae=D[V]===se[ge]?7:5:Fe(ge,se,ae)&&(ge===0||!Fe(ge-1,se,ae))?(Ae=D[V]===se[ge]?7:5,ke=!0):Le(ae,ge)&&(ge===0||!Le(ae,ge-1))?Ae=5:(Le(ae,ge-1)||Ce(ae,ge-1))&&(Ae=5,ke=!0),Ae>1&&V===q&&(Oe[0]=!0),ke||(ke=Fe(ge,se,ae)||Le(ae,ge-1)||Ce(ae,ge-1)),V===q?ge>De&&(Ae-=ke?3:5):Te?Ae+=ke?2:0:Ae+=ke?0:1,ge+1===we&&(Ae-=ke?3:5),Ae}function G(D,z,V,q,se,ae,ge){return te(D,z,V,q,se,ae,!0,ge)}function J(D,z,V,q,se,ae,ge){return te(D,z,V,q,se,ae,!1,ge)}function te(D,z,V,q,se,ae,ge,we){let De=h(D,z,V,q,se,ae,we);if(De&&!ge)return De;if(D.length>=3){const Te=Math.min(7,D.length-1);for(let Oe=V+1;Oe<Te;Oe++){const Ae=y(D,Oe);if(Ae){const ke=h(Ae,Ae.toLowerCase(),V,q,se,ae,we);ke&&(ke[0]-=3,(!De||ke[0]>De[0])&&(De=ke))}}}return De}function y(D,z){if(z+1>=D.length)return;const V=D[z],q=D[z+1];if(V!==q)return D.slice(0,z)+q+V+D.slice(z+2)}}),define(_e[66],Se([1,0,11]),function(ue,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StringSHA1=t.Hasher=void 0,t.hash=n,t.doHash=O,t.numberHash=I,t.stringHash=b,t.toHexString=s,i=qe(i);function n(l){return O(l,0)}function O(l,o){switch(typeof l){case"object":return l===null?I(349,o):Array.isArray(l)?w(l,o):u(l,o);case"string":return b(l,o);case"boolean":return N(l,o);case"number":return I(l,o);case"undefined":return I(937,o);default:return I(617,o)}}function I(l,o){return(o<<5)-o+l|0}function N(l,o){return I(l?433:863,o)}function b(l,o){o=I(149417,o);for(let p=0,A=l.length;p<A;p++)o=I(l.charCodeAt(p),o);return o}function w(l,o){return o=I(104579,o),l.reduce((p,A)=>O(A,p),o)}function u(l,o){return o=I(181387,o),Object.keys(l).sort().reduce((p,A)=>(p=b(A,p),O(l[A],p)),o)}class m{constructor(){this._value=0}get value(){return this._value}hash(o){return this._value=O(o,this._value),this._value}}t.Hasher=m;var v;(function(l){l[l.BLOCK_SIZE=64]="BLOCK_SIZE",l[l.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(v||(v={}));function g(l,o,p=32){const A=p-o,L=~((1<<A)-1);return(l<<o|(L&l)>>>A)>>>0}function d(l,o=0,p=l.byteLength,A=0){for(let L=0;L<p;L++)l[o+L]=A}function e(l,o,p="0"){for(;l.length<o;)l=p+l;return l}function s(l,o=32){return l instanceof ArrayBuffer?Array.from(new Uint8Array(l)).map(p=>p.toString(16).padStart(2,"0")).join(""):e((l>>>0).toString(16),o/4)}class r{static{this._bigBlock32=new DataView(new ArrayBuffer(320))}constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(v.BLOCK_SIZE+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(o){const p=o.length;if(p===0)return;const A=this._buff;let L=this._buffLen,c=this._leftoverHighSurrogate,a,f;for(c!==0?(a=c,f=-1,c=0):(a=o.charCodeAt(0),f=0);;){let _=a;if(i.isHighSurrogate(a))if(f+1<p){const H=o.charCodeAt(f+1);i.isLowSurrogate(H)?(f++,_=i.computeCodePoint(a,H)):_=v.UNICODE_REPLACEMENT}else{c=a;break}else i.isLowSurrogate(a)&&(_=v.UNICODE_REPLACEMENT);if(L=this._push(A,L,_),f++,f<p)a=o.charCodeAt(f);else break}this._buffLen=L,this._leftoverHighSurrogate=c}_push(o,p,A){return A<128?o[p++]=A:A<2048?(o[p++]=192|(A&1984)>>>6,o[p++]=128|(A&63)>>>0):A<65536?(o[p++]=224|(A&61440)>>>12,o[p++]=128|(A&4032)>>>6,o[p++]=128|(A&63)>>>0):(o[p++]=240|(A&1835008)>>>18,o[p++]=128|(A&258048)>>>12,o[p++]=128|(A&4032)>>>6,o[p++]=128|(A&63)>>>0),p>=v.BLOCK_SIZE&&(this._step(),p-=v.BLOCK_SIZE,this._totalLen+=v.BLOCK_SIZE,o[0]=o[v.BLOCK_SIZE+0],o[1]=o[v.BLOCK_SIZE+1],o[2]=o[v.BLOCK_SIZE+2]),p}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,v.UNICODE_REPLACEMENT)),this._totalLen+=this._buffLen,this._wrapUp()),s(this._h0)+s(this._h1)+s(this._h2)+s(this._h3)+s(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,d(this._buff,this._buffLen),this._buffLen>56&&(this._step(),d(this._buff));const o=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(o/4294967296),!1),this._buffDV.setUint32(60,o%4294967296,!1),this._step()}_step(){const o=r._bigBlock32,p=this._buffDV;for(let F=0;F<64;F+=4)o.setUint32(F,p.getUint32(F,!1),!1);for(let F=64;F<320;F+=4)o.setUint32(F,g(o.getUint32(F-12,!1)^o.getUint32(F-32,!1)^o.getUint32(F-56,!1)^o.getUint32(F-64,!1),1),!1);let A=this._h0,L=this._h1,c=this._h2,a=this._h3,f=this._h4,_,H,B;for(let F=0;F<80;F++)F<20?(_=L&c|~L&a,H=1518500249):F<40?(_=L^c^a,H=1859775393):F<60?(_=L&c|L&a|c&a,H=2400959708):(_=L^c^a,H=3395469782),B=g(A,5)+_+f+H+o.getUint32(F*4,!1)&4294967295,f=a,a=c,c=g(L,30),L=A,A=B;this._h0=this._h0+A&4294967295,this._h1=this._h1+L&4294967295,this._h2=this._h2+c&4294967295,this._h3=this._h3+a&4294967295,this._h4=this._h4+f&4294967295}}t.StringSHA1=r}),define(_e[106],Se([1,0,90,66,65]),function(ue,t,i,n,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LcsDiff=t.StringDiffSequence=void 0,t.stringDiff=N;class I{constructor(d){this.source=d}getElements(){const d=this.source,e=new Int32Array(d.length);for(let s=0,r=d.length;s<r;s++)e[s]=d.charCodeAt(s);return e}}t.StringDiffSequence=I;function N(g,d,e){return new v(new I(g),new I(d)).ComputeDiff(e).changes}class b{static Assert(d,e){if(!d)throw new Error(e)}}class w{static Copy(d,e,s,r,l){for(let o=0;o<l;o++)s[r+o]=d[e+o]}static Copy2(d,e,s,r,l){for(let o=0;o<l;o++)s[r+o]=d[e+o]}}var u;(function(g){g[g.MaxDifferencesHistory=1447]="MaxDifferencesHistory"})(u||(u={}));class m{constructor(){this.m_changes=[],this.m_originalStart=O.Constants.MAX_SAFE_SMALL_INTEGER,this.m_modifiedStart=O.Constants.MAX_SAFE_SMALL_INTEGER,this.m_originalCount=0,this.m_modifiedCount=0}MarkNextChange(){(this.m_originalCount>0||this.m_modifiedCount>0)&&this.m_changes.push(new i.DiffChange(this.m_originalStart,this.m_originalCount,this.m_modifiedStart,this.m_modifiedCount)),this.m_originalCount=0,this.m_modifiedCount=0,this.m_originalStart=O.Constants.MAX_SAFE_SMALL_INTEGER,this.m_modifiedStart=O.Constants.MAX_SAFE_SMALL_INTEGER}AddOriginalElement(d,e){this.m_originalStart=Math.min(this.m_originalStart,d),this.m_modifiedStart=Math.min(this.m_modifiedStart,e),this.m_originalCount++}AddModifiedElement(d,e){this.m_originalStart=Math.min(this.m_originalStart,d),this.m_modifiedStart=Math.min(this.m_modifiedStart,e),this.m_modifiedCount++}getChanges(){return(this.m_originalCount>0||this.m_modifiedCount>0)&&this.MarkNextChange(),this.m_changes}getReverseChanges(){return(this.m_originalCount>0||this.m_modifiedCount>0)&&this.MarkNextChange(),this.m_changes.reverse(),this.m_changes}}class v{constructor(d,e,s=null){this.ContinueProcessingPredicate=s,this._originalSequence=d,this._modifiedSequence=e;const[r,l,o]=v._getElements(d),[p,A,L]=v._getElements(e);this._hasStrings=o&&L,this._originalStringElements=r,this._originalElementsOrHash=l,this._modifiedStringElements=p,this._modifiedElementsOrHash=A,this.m_forwardHistory=[],this.m_reverseHistory=[]}static _isStringArray(d){return d.length>0&&typeof d[0]=="string"}static _getElements(d){const e=d.getElements();if(v._isStringArray(e)){const s=new Int32Array(e.length);for(let r=0,l=e.length;r<l;r++)s[r]=(0,n.stringHash)(e[r],0);return[e,s,!0]}return e instanceof Int32Array?[[],e,!1]:[[],new Int32Array(e),!1]}ElementsAreEqual(d,e){return this._originalElementsOrHash[d]!==this._modifiedElementsOrHash[e]?!1:this._hasStrings?this._originalStringElements[d]===this._modifiedStringElements[e]:!0}ElementsAreStrictEqual(d,e){if(!this.ElementsAreEqual(d,e))return!1;const s=v._getStrictElement(this._originalSequence,d),r=v._getStrictElement(this._modifiedSequence,e);return s===r}static _getStrictElement(d,e){return typeof d.getStrictElement=="function"?d.getStrictElement(e):null}OriginalElementsAreEqual(d,e){return this._originalElementsOrHash[d]!==this._originalElementsOrHash[e]?!1:this._hasStrings?this._originalStringElements[d]===this._originalStringElements[e]:!0}ModifiedElementsAreEqual(d,e){return this._modifiedElementsOrHash[d]!==this._modifiedElementsOrHash[e]?!1:this._hasStrings?this._modifiedStringElements[d]===this._modifiedStringElements[e]:!0}ComputeDiff(d){return this._ComputeDiff(0,this._originalElementsOrHash.length-1,0,this._modifiedElementsOrHash.length-1,d)}_ComputeDiff(d,e,s,r,l){const o=[!1];let p=this.ComputeDiffRecursive(d,e,s,r,o);return l&&(p=this.PrettifyChanges(p)),{quitEarly:o[0],changes:p}}ComputeDiffRecursive(d,e,s,r,l){for(l[0]=!1;d<=e&&s<=r&&this.ElementsAreEqual(d,s);)d++,s++;for(;e>=d&&r>=s&&this.ElementsAreEqual(e,r);)e--,r--;if(d>e||s>r){let a;return s<=r?(b.Assert(d===e+1,"originalStart should only be one more than originalEnd"),a=[new i.DiffChange(d,0,s,r-s+1)]):d<=e?(b.Assert(s===r+1,"modifiedStart should only be one more than modifiedEnd"),a=[new i.DiffChange(d,e-d+1,s,0)]):(b.Assert(d===e+1,"originalStart should only be one more than originalEnd"),b.Assert(s===r+1,"modifiedStart should only be one more than modifiedEnd"),a=[]),a}const o=[0],p=[0],A=this.ComputeRecursionPoint(d,e,s,r,o,p,l),L=o[0],c=p[0];if(A!==null)return A;if(!l[0]){const a=this.ComputeDiffRecursive(d,L,s,c,l);let f=[];return l[0]?f=[new i.DiffChange(L+1,e-(L+1)+1,c+1,r-(c+1)+1)]:f=this.ComputeDiffRecursive(L+1,e,c+1,r,l),this.ConcatenateChanges(a,f)}return[new i.DiffChange(d,e-d+1,s,r-s+1)]}WALKTRACE(d,e,s,r,l,o,p,A,L,c,a,f,_,H,B,F,E,k){let W=null,R=null,C=new m,$=e,ee=s,Y=_[0]-F[0]-r,Z=O.Constants.MIN_SAFE_SMALL_INTEGER,ce=this.m_forwardHistory.length-1;do{const he=Y+d;he===$||he<ee&&L[he-1]<L[he+1]?(a=L[he+1],H=a-Y-r,a<Z&&C.MarkNextChange(),Z=a,C.AddModifiedElement(a+1,H),Y=he+1-d):(a=L[he-1]+1,H=a-Y-r,a<Z&&C.MarkNextChange(),Z=a-1,C.AddOriginalElement(a,H+1),Y=he-1-d),ce>=0&&(L=this.m_forwardHistory[ce],d=L[0],$=1,ee=L.length-1)}while(--ce>=-1);if(W=C.getReverseChanges(),k[0]){let he=_[0]+1,ye=F[0]+1;if(W!==null&&W.length>0){const Re=W[W.length-1];he=Math.max(he,Re.getOriginalEnd()),ye=Math.max(ye,Re.getModifiedEnd())}R=[new i.DiffChange(he,f-he+1,ye,B-ye+1)]}else{C=new m,$=o,ee=p,Y=_[0]-F[0]-A,Z=O.Constants.MAX_SAFE_SMALL_INTEGER,ce=E?this.m_reverseHistory.length-1:this.m_reverseHistory.length-2;do{const he=Y+l;he===$||he<ee&&c[he-1]>=c[he+1]?(a=c[he+1]-1,H=a-Y-A,a>Z&&C.MarkNextChange(),Z=a+1,C.AddOriginalElement(a+1,H+1),Y=he+1-l):(a=c[he-1],H=a-Y-A,a>Z&&C.MarkNextChange(),Z=a,C.AddModifiedElement(a+1,H+1),Y=he-1-l),ce>=0&&(c=this.m_reverseHistory[ce],l=c[0],$=1,ee=c.length-1)}while(--ce>=-1);R=C.getChanges()}return this.ConcatenateChanges(W,R)}ComputeRecursionPoint(d,e,s,r,l,o,p){let A=0,L=0,c=0,a=0,f=0,_=0;d--,s--,l[0]=0,o[0]=0,this.m_forwardHistory=[],this.m_reverseHistory=[];const H=e-d+(r-s),B=H+1,F=new Int32Array(B),E=new Int32Array(B),k=r-s,W=e-d,R=d-s,C=e-r,ee=(W-k)%2===0;F[k]=d,E[W]=e,p[0]=!1;for(let Y=1;Y<=H/2+1;Y++){let Z=0,ce=0;c=this.ClipDiagonalBound(k-Y,Y,k,B),a=this.ClipDiagonalBound(k+Y,Y,k,B);for(let ye=c;ye<=a;ye+=2){ye===c||ye<a&&F[ye-1]<F[ye+1]?A=F[ye+1]:A=F[ye-1]+1,L=A-(ye-k)-R;const Re=A;for(;A<e&&L<r&&this.ElementsAreEqual(A+1,L+1);)A++,L++;if(F[ye]=A,A+L>Z+ce&&(Z=A,ce=L),!ee&&Math.abs(ye-W)<=Y-1&&A>=E[ye])return l[0]=A,o[0]=L,Re<=E[ye]&&u.MaxDifferencesHistory>0&&Y<=u.MaxDifferencesHistory+1?this.WALKTRACE(k,c,a,R,W,f,_,C,F,E,A,e,l,L,r,o,ee,p):null}const he=(Z-d+(ce-s)-Y)/2;if(this.ContinueProcessingPredicate!==null&&!this.ContinueProcessingPredicate(Z,he))return p[0]=!0,l[0]=Z,o[0]=ce,he>0&&u.MaxDifferencesHistory>0&&Y<=u.MaxDifferencesHistory+1?this.WALKTRACE(k,c,a,R,W,f,_,C,F,E,A,e,l,L,r,o,ee,p):(d++,s++,[new i.DiffChange(d,e-d+1,s,r-s+1)]);f=this.ClipDiagonalBound(W-Y,Y,W,B),_=this.ClipDiagonalBound(W+Y,Y,W,B);for(let ye=f;ye<=_;ye+=2){ye===f||ye<_&&E[ye-1]>=E[ye+1]?A=E[ye+1]-1:A=E[ye-1],L=A-(ye-W)-C;const Re=A;for(;A>d&&L>s&&this.ElementsAreEqual(A,L);)A--,L--;if(E[ye]=A,ee&&Math.abs(ye-k)<=Y&&A<=F[ye])return l[0]=A,o[0]=L,Re>=F[ye]&&u.MaxDifferencesHistory>0&&Y<=u.MaxDifferencesHistory+1?this.WALKTRACE(k,c,a,R,W,f,_,C,F,E,A,e,l,L,r,o,ee,p):null}if(Y<=u.MaxDifferencesHistory){let ye=new Int32Array(a-c+2);ye[0]=k-c+1,w.Copy2(F,c,ye,1,a-c+1),this.m_forwardHistory.push(ye),ye=new Int32Array(_-f+2),ye[0]=W-f+1,w.Copy2(E,f,ye,1,_-f+1),this.m_reverseHistory.push(ye)}}return this.WALKTRACE(k,c,a,R,W,f,_,C,F,E,A,e,l,L,r,o,ee,p)}PrettifyChanges(d){for(let e=0;e<d.length;e++){const s=d[e],r=e<d.length-1?d[e+1].originalStart:this._originalElementsOrHash.length,l=e<d.length-1?d[e+1].modifiedStart:this._modifiedElementsOrHash.length,o=s.originalLength>0,p=s.modifiedLength>0;for(;s.originalStart+s.originalLength<r&&s.modifiedStart+s.modifiedLength<l&&(!o||this.OriginalElementsAreEqual(s.originalStart,s.originalStart+s.originalLength))&&(!p||this.ModifiedElementsAreEqual(s.modifiedStart,s.modifiedStart+s.modifiedLength));){const L=this.ElementsAreStrictEqual(s.originalStart,s.modifiedStart);if(this.ElementsAreStrictEqual(s.originalStart+s.originalLength,s.modifiedStart+s.modifiedLength)&&!L)break;s.originalStart++,s.modifiedStart++}const A=[null];if(e<d.length-1&&this.ChangesOverlap(d[e],d[e+1],A)){d[e]=A[0],d.splice(e+1,1),e--;continue}}for(let e=d.length-1;e>=0;e--){const s=d[e];let r=0,l=0;if(e>0){const a=d[e-1];r=a.originalStart+a.originalLength,l=a.modifiedStart+a.modifiedLength}const o=s.originalLength>0,p=s.modifiedLength>0;let A=0,L=this._boundaryScore(s.originalStart,s.originalLength,s.modifiedStart,s.modifiedLength);for(let a=1;;a++){const f=s.originalStart-a,_=s.modifiedStart-a;if(f<r||_<l||o&&!this.OriginalElementsAreEqual(f,f+s.originalLength)||p&&!this.ModifiedElementsAreEqual(_,_+s.modifiedLength))break;const B=(f===r&&_===l?5:0)+this._boundaryScore(f,s.originalLength,_,s.modifiedLength);B>L&&(L=B,A=a)}s.originalStart-=A,s.modifiedStart-=A;const c=[null];if(e>0&&this.ChangesOverlap(d[e-1],d[e],c)){d[e-1]=c[0],d.splice(e,1),e++;continue}}if(this._hasStrings)for(let e=1,s=d.length;e<s;e++){const r=d[e-1],l=d[e],o=l.originalStart-r.originalStart-r.originalLength,p=r.originalStart,A=l.originalStart+l.originalLength,L=A-p,c=r.modifiedStart,a=l.modifiedStart+l.modifiedLength,f=a-c;if(o<5&&L<20&&f<20){const _=this._findBetterContiguousSequence(p,L,c,f,o);if(_){const[H,B]=_;(H!==r.originalStart+r.originalLength||B!==r.modifiedStart+r.modifiedLength)&&(r.originalLength=H-r.originalStart,r.modifiedLength=B-r.modifiedStart,l.originalStart=H+o,l.modifiedStart=B+o,l.originalLength=A-l.originalStart,l.modifiedLength=a-l.modifiedStart)}}}return d}_findBetterContiguousSequence(d,e,s,r,l){if(e<l||r<l)return null;const o=d+e-l+1,p=s+r-l+1;let A=0,L=0,c=0;for(let a=d;a<o;a++)for(let f=s;f<p;f++){const _=this._contiguousSequenceScore(a,f,l);_>0&&_>A&&(A=_,L=a,c=f)}return A>0?[L,c]:null}_contiguousSequenceScore(d,e,s){let r=0;for(let l=0;l<s;l++){if(!this.ElementsAreEqual(d+l,e+l))return 0;r+=this._originalStringElements[d+l].length}return r}_OriginalIsBoundary(d){return d<=0||d>=this._originalElementsOrHash.length-1?!0:this._hasStrings&&/^\s*$/.test(this._originalStringElements[d])}_OriginalRegionIsBoundary(d,e){if(this._OriginalIsBoundary(d)||this._OriginalIsBoundary(d-1))return!0;if(e>0){const s=d+e;if(this._OriginalIsBoundary(s-1)||this._OriginalIsBoundary(s))return!0}return!1}_ModifiedIsBoundary(d){return d<=0||d>=this._modifiedElementsOrHash.length-1?!0:this._hasStrings&&/^\s*$/.test(this._modifiedStringElements[d])}_ModifiedRegionIsBoundary(d,e){if(this._ModifiedIsBoundary(d)||this._ModifiedIsBoundary(d-1))return!0;if(e>0){const s=d+e;if(this._ModifiedIsBoundary(s-1)||this._ModifiedIsBoundary(s))return!0}return!1}_boundaryScore(d,e,s,r){const l=this._OriginalRegionIsBoundary(d,e)?1:0,o=this._ModifiedRegionIsBoundary(s,r)?1:0;return l+o}ConcatenateChanges(d,e){const s=[];if(d.length===0||e.length===0)return e.length>0?e:d;if(this.ChangesOverlap(d[d.length-1],e[0],s)){const r=new Array(d.length+e.length-1);return w.Copy(d,0,r,0,d.length-1),r[d.length-1]=s[0],w.Copy(e,1,r,d.length,e.length-1),r}else{const r=new Array(d.length+e.length);return w.Copy(d,0,r,0,d.length),w.Copy(e,0,r,d.length,e.length),r}}ChangesOverlap(d,e,s){if(b.Assert(d.originalStart<=e.originalStart,"Left change is not less than or equal to right change"),b.Assert(d.modifiedStart<=e.modifiedStart,"Left change is not less than or equal to right change"),d.originalStart+d.originalLength>=e.originalStart||d.modifiedStart+d.modifiedLength>=e.modifiedStart){const r=d.originalStart;let l=d.originalLength;const o=d.modifiedStart;let p=d.modifiedLength;return d.originalStart+d.originalLength>=e.originalStart&&(l=e.originalStart+e.originalLength-d.originalStart),d.modifiedStart+d.modifiedLength>=e.modifiedStart&&(p=e.modifiedStart+e.modifiedLength-d.modifiedStart),s[0]=new i.DiffChange(r,l,o,p),!0}else return s[0]=null,!1}ClipDiagonalBound(d,e,s,r){if(d>=0&&d<r)return d;const l=s,o=r-s-1,p=e%2===0;if(d<0){const A=l%2===0;return p===A?0:1}else{const A=o%2===0;return p===A?r-1:r-2}}}t.LcsDiff=v}),define(_e[67],Se([1,0,49,11,21]),function(ue,t,i,n,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.escapeIcons=w,t.markdownEscapeEscapedIcons=m,t.stripIcons=g,t.getCodiconAriaLabel=d,t.parseLabelWithIcons=s,t.matchesFuzzyIconAware=r;const I="$(",N=new RegExp(`\\$\\(${O.ThemeIcon.iconNameExpression}(?:${O.ThemeIcon.iconModifierExpression})?\\)`,"g"),b=new RegExp(`(\\\\)?${N.source}`,"g");function w(l){return l.replace(b,(o,p)=>p?o:`\\${o}`)}const u=new RegExp(`\\\\${N.source}`,"g");function m(l){return l.replace(u,o=>`\\${o}`)}const v=new RegExp(`(\\s)?(\\\\)?${N.source}(\\s)?`,"g");function g(l){return l.indexOf(I)===-1?l:l.replace(v,(o,p,A,L)=>A?o:p||L||"")}function d(l){return l?l.replace(/\$\((.*?)\)/g,(o,p)=>` ${p} `).trim():""}const e=new RegExp(`\\$\\(${O.ThemeIcon.iconNameCharacter}+\\)`,"g");function s(l){e.lastIndex=0;let o="";const p=[];let A=0;for(;;){const L=e.lastIndex,c=e.exec(l),a=l.substring(L,c?.index);if(a.length>0){o+=a;for(let f=0;f<a.length;f++)p.push(A)}if(!c)break;A+=c[0].length}return{text:o,iconOffsets:p}}function r(l,o,p=!1){const{text:A,iconOffsets:L}=o;if(!L||L.length===0)return(0,i.matchesFuzzy)(l,A,p);const c=(0,n.ltrim)(A," "),a=A.length-c.length,f=(0,i.matchesFuzzy)(l,c,p);if(f)for(const _ of f){const H=L[_.start+a]+a;_.start+=H,_.end+=H}return f}}),define(_e[107],Se([1,0,9,17,11]),function(ue,t,i,n,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.TernarySearchTree=t.UriIterator=t.PathIterator=t.ConfigKeysIterator=t.StringIterator=void 0;class I{constructor(){this._value="",this._pos=0}reset(e){return this._value=e,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(e){const s=e.charCodeAt(0),r=this._value.charCodeAt(this._pos);return s-r}value(){return this._value[this._pos]}}t.StringIterator=I;class N{constructor(e=!0){this._caseSensitive=e}reset(e){return this._value=e,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let e=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===n.CharCode.Period)if(e)this._from++;else break;else e=!1;return this}cmp(e){return this._caseSensitive?(0,O.compareSubstring)(e,this._value,0,e.length,this._from,this._to):(0,O.compareSubstringIgnoreCase)(e,this._value,0,e.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}t.ConfigKeysIterator=N;class b{constructor(e=!0,s=!0){this._splitOnBackslash=e,this._caseSensitive=s}reset(e){this._from=0,this._to=0,this._value=e,this._valueLen=e.length;for(let s=e.length-1;s>=0;s--,this._valueLen--){const r=this._value.charCodeAt(s);if(!(r===n.CharCode.Slash||this._splitOnBackslash&&r===n.CharCode.Backslash))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let e=!0;for(;this._to<this._valueLen;this._to++){const s=this._value.charCodeAt(this._to);if(s===n.CharCode.Slash||this._splitOnBackslash&&s===n.CharCode.Backslash)if(e)this._from++;else break;else e=!1}return this}cmp(e){return this._caseSensitive?(0,O.compareSubstring)(e,this._value,0,e.length,this._from,this._to):(0,O.compareSubstringIgnoreCase)(e,this._value,0,e.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}t.PathIterator=b;var w;(function(d){d[d.Scheme=1]="Scheme",d[d.Authority=2]="Authority",d[d.Path=3]="Path",d[d.Query=4]="Query",d[d.Fragment=5]="Fragment"})(w||(w={}));class u{constructor(e,s){this._ignorePathCasing=e,this._ignoreQueryAndFragment=s,this._states=[],this._stateIdx=0}reset(e){return this._value=e,this._states=[],this._value.scheme&&this._states.push(w.Scheme),this._value.authority&&this._states.push(w.Authority),this._value.path&&(this._pathIterator=new b(!1,!this._ignorePathCasing(e)),this._pathIterator.reset(e.path),this._pathIterator.value()&&this._states.push(w.Path)),this._ignoreQueryAndFragment(e)||(this._value.query&&this._states.push(w.Query),this._value.fragment&&this._states.push(w.Fragment)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===w.Path&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===w.Path&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(e){if(this._states[this._stateIdx]===w.Scheme)return(0,O.compareIgnoreCase)(e,this._value.scheme);if(this._states[this._stateIdx]===w.Authority)return(0,O.compareIgnoreCase)(e,this._value.authority);if(this._states[this._stateIdx]===w.Path)return this._pathIterator.cmp(e);if(this._states[this._stateIdx]===w.Query)return(0,O.compare)(e,this._value.query);if(this._states[this._stateIdx]===w.Fragment)return(0,O.compare)(e,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===w.Scheme)return this._value.scheme;if(this._states[this._stateIdx]===w.Authority)return this._value.authority;if(this._states[this._stateIdx]===w.Path)return this._pathIterator.value();if(this._states[this._stateIdx]===w.Query)return this._value.query;if(this._states[this._stateIdx]===w.Fragment)return this._value.fragment;throw new Error}}t.UriIterator=u;class m{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const e=this.right;return this.right=e.left,e.left=this,this.updateHeight(),e.updateHeight(),e}rotateRight(){const e=this.left;return this.left=e.right,e.right=this,this.updateHeight(),e.updateHeight(),e}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var v;(function(d){d[d.Left=-1]="Left",d[d.Mid=0]="Mid",d[d.Right=1]="Right"})(v||(v={}));class g{static forUris(e=()=>!1,s=()=>!1){return new g(new u(e,s))}static forPaths(e=!1){return new g(new b(void 0,!e))}static forStrings(){return new g(new I)}static forConfigKeys(){return new g(new N)}constructor(e){this._iter=e}clear(){this._root=void 0}fill(e,s){if(s){const r=s.slice(0);(0,i.shuffle)(r);for(const l of r)this.set(l,e)}else{const r=e.slice(0);(0,i.shuffle)(r);for(const l of r)this.set(l[0],l[1])}}set(e,s){const r=this._iter.reset(e);let l;this._root||(this._root=new m,this._root.segment=r.value());const o=[];for(l=this._root;;){const A=r.cmp(l.segment);if(A>0)l.left||(l.left=new m,l.left.segment=r.value()),o.push([v.Left,l]),l=l.left;else if(A<0)l.right||(l.right=new m,l.right.segment=r.value()),o.push([v.Right,l]),l=l.right;else if(r.hasNext())r.next(),l.mid||(l.mid=new m,l.mid.segment=r.value()),o.push([v.Mid,l]),l=l.mid;else break}const p=l.value;l.value=s,l.key=e;for(let A=o.length-1;A>=0;A--){const L=o[A][1];L.updateHeight();const c=L.balanceFactor();if(c<-1||c>1){const a=o[A][0],f=o[A+1][0];if(a===v.Right&&f===v.Right)o[A][1]=L.rotateLeft();else if(a===v.Left&&f===v.Left)o[A][1]=L.rotateRight();else if(a===v.Right&&f===v.Left)L.right=o[A+1][1]=o[A+1][1].rotateRight(),o[A][1]=L.rotateLeft();else if(a===v.Left&&f===v.Right)L.left=o[A+1][1]=o[A+1][1].rotateLeft(),o[A][1]=L.rotateRight();else throw new Error;if(A>0)switch(o[A-1][0]){case v.Left:o[A-1][1].left=o[A][1];break;case v.Right:o[A-1][1].right=o[A][1];break;case v.Mid:o[A-1][1].mid=o[A][1];break}else this._root=o[0][1]}}return p}get(e){return this._getNode(e)?.value}_getNode(e){const s=this._iter.reset(e);let r=this._root;for(;r;){const l=s.cmp(r.segment);if(l>0)r=r.left;else if(l<0)r=r.right;else if(s.hasNext())s.next(),r=r.mid;else break}return r}has(e){const s=this._getNode(e);return!(s?.value===void 0&&s?.mid===void 0)}delete(e){return this._delete(e,!1)}deleteSuperstr(e){return this._delete(e,!0)}_delete(e,s){const r=this._iter.reset(e),l=[];let o=this._root;for(;o;){const p=r.cmp(o.segment);if(p>0)l.push([v.Left,o]),o=o.left;else if(p<0)l.push([v.Right,o]),o=o.right;else if(r.hasNext())r.next(),l.push([v.Mid,o]),o=o.mid;else break}if(o){if(s?(o.left=void 0,o.mid=void 0,o.right=void 0,o.height=1):(o.key=void 0,o.value=void 0),!o.mid&&!o.value)if(o.left&&o.right){const p=this._min(o.right);if(p.key){const{key:A,value:L,segment:c}=p;this._delete(p.key,!1),o.key=A,o.value=L,o.segment=c}}else{const p=o.left??o.right;if(l.length>0){const[A,L]=l[l.length-1];switch(A){case v.Left:L.left=p;break;case v.Mid:L.mid=p;break;case v.Right:L.right=p;break}}else this._root=p}for(let p=l.length-1;p>=0;p--){const A=l[p][1];A.updateHeight();const L=A.balanceFactor();if(L>1?(A.right.balanceFactor()>=0||(A.right=A.right.rotateRight()),l[p][1]=A.rotateLeft()):L<-1&&(A.left.balanceFactor()<=0||(A.left=A.left.rotateLeft()),l[p][1]=A.rotateRight()),p>0)switch(l[p-1][0]){case v.Left:l[p-1][1].left=l[p][1];break;case v.Right:l[p-1][1].right=l[p][1];break;case v.Mid:l[p-1][1].mid=l[p][1];break}else this._root=l[0][1]}}}_min(e){for(;e.left;)e=e.left;return e}findSubstr(e){const s=this._iter.reset(e);let r=this._root,l;for(;r;){const o=s.cmp(r.segment);if(o>0)r=r.left;else if(o<0)r=r.right;else if(s.hasNext())s.next(),l=r.value||l,r=r.mid;else break}return r&&r.value||l}findSuperstr(e){return this._findSuperstrOrElement(e,!1)}_findSuperstrOrElement(e,s){const r=this._iter.reset(e);let l=this._root;for(;l;){const o=r.cmp(l.segment);if(o>0)l=l.left;else if(o<0)l=l.right;else if(r.hasNext())r.next(),l=l.mid;else return l.mid?this._entries(l.mid):s?l.value:void 0}}hasElementOrSubtree(e){return this._findSuperstrOrElement(e,!0)!==void 0}forEach(e){for(const[s,r]of this)e(r,s)}*[Symbol.iterator](){yield*this._entries(this._root)}_entries(e){const s=[];return this._dfsEntries(e,s),s[Symbol.iterator]()}_dfsEntries(e,s){e&&(e.left&&this._dfsEntries(e.left,s),e.value&&s.push([e.key,e.value]),e.mid&&this._dfsEntries(e.mid,s),e.right&&this._dfsEntries(e.right,s))}_isBalanced(){const e=s=>{if(!s)return!0;const r=s.balanceFactor();return r<-1||r>1?!1:e(s.left)&&e(s.right)};return e(this._root)}}t.TernarySearchTree=g}),define(_e[108],Se([1,0]),function(ue,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CONTEXT_MENU_CLOSE_CHANNEL=t.CONTEXT_MENU_CHANNEL=void 0,t.CONTEXT_MENU_CHANNEL="vscode:contextmenu",t.CONTEXT_MENU_CLOSE_CHANNEL="vscode:onCloseContextMenu"}),define(_e[109],Se([1,0]),function(ue,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Protocol=void 0;class i{constructor(O,I){this.sender=O,this.onMessage=I}send(O){try{this.sender.send("vscode:message",O.buffer)}catch{}}disconnect(){this.sender.send("vscode:disconnect",null)}}t.Protocol=i}),define(_e[39],Se([1,0]),function(ue,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.webUtils=t.context=t.process=t.webFrame=t.ipcMessagePort=t.ipcRenderer=void 0;const i=globalThis.vscode;t.ipcRenderer=i.ipcRenderer,t.ipcMessagePort=i.ipcMessagePort,t.webFrame=i.webFrame,t.process=i.process,t.context=i.context,t.webUtils=i.webUtils}),define(_e[110],Se([1,0,108,39]),function(ue,t,i,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.popup=I;let O=0;function I(b,w,u){const m=[],v=O++,g=`vscode:onContextMenu${v}`,d=(e,s,r)=>{m[s].click?.(r)};n.ipcRenderer.once(g,d),n.ipcRenderer.once(i.CONTEXT_MENU_CLOSE_CHANNEL,(e,s)=>{s===v&&(n.ipcRenderer.removeListener(g,d),u?.())}),n.ipcRenderer.send(i.CONTEXT_MENU_CHANNEL,v,b.map(e=>N(e,m)),g,w)}function N(b,w){const u={id:w.length,label:b.label,type:b.type,accelerator:b.accelerator,checked:b.checked,enabled:typeof b.enabled=="boolean"?b.enabled:!0,visible:typeof b.visible=="boolean"?b.visible:!0};return w.push(b),Array.isArray(b.submenu)&&(u.submenu=b.submenu.map(m=>N(m,w))),u}}),define(_e[68],Se([7]),{}),define(_e[111],Se([7]),{}),define(_e[112],Se([7]),{}),define(_e[113],Se([7]),{}),define(_e[114],Se([1,0,112,113]),function(ue,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0})}),define(_e[115],Se([7]),{}),define(_e[116],Se([7]),{}),define(_e[117],Se([7]),{}),define(_e[118],Se([7]),{}),define(_e[119],Se([7]),{}),define(_e[120],Se([7]),{}),define(_e[121],Se([7]),{}),define(_e[122],Se([7]),{}),define(_e[123],Se([7]),{}),define(_e[124],Se([7]),{}),define(_e[69],Se([1,0]),function(ue,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getNLSMessages=i,t.getNLSLanguage=n;function i(){return globalThis._VSCODE_NLS_MESSAGES}function n(){return globalThis._VSCODE_NLS_LANGUAGE}}),define(_e[12],Se([1,0,69,69]),function(ue,t,i,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getNLSMessages=t.getNLSLanguage=void 0,t.localize=N,t.localize2=w,Object.defineProperty(t,"getNLSLanguage",{enumerable:!0,get:function(){return n.getNLSLanguage}}),Object.defineProperty(t,"getNLSMessages",{enumerable:!0,get:function(){return n.getNLSMessages}});const O=(0,i.getNLSLanguage)()==="pseudo"||typeof document<"u"&&document.location&&document.location.hash.indexOf("pseudo=true")>=0;function I(u,m){let v;return m.length===0?v=u:v=u.replace(/\{(\d+)\}/g,(g,d)=>{const e=d[0],s=m[e];let r=g;return typeof s=="string"?r=s:(typeof s=="number"||typeof s=="boolean"||s===void 0||s===null)&&(r=String(s)),r}),O&&(v="\uFF3B"+v.replace(/[aouei]/g,"$&$&")+"\uFF3D"),v}function N(u,m,...v){return I(typeof u=="number"?b(u,m):m,v)}function b(u,m){const v=(0,i.getNLSMessages)()?.[u];if(typeof v!="string"){if(typeof m=="string")return m;throw new Error(`!!! NLS MISSING: ${u} !!!`)}return v}function w(u,m,...v){let g;typeof u=="number"?g=b(u,m):g=m;const d=I(g,v);return{value:d,original:m===g?d:I(m,v)}}}),define(_e[50],Se([1,0,3,2,12]),function(ue,t,i,n,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.EmptySubmenuAction=t.SubmenuAction=t.Separator=t.ActionRunner=t.Action=void 0,t.toAction=m,O=qe(O);class I extends n.Disposable{constructor(g,d="",e="",s=!0,r){super(),this._onDidChange=this._register(new i.Emitter),this.onDidChange=this._onDidChange.event,this._enabled=!0,this._id=g,this._label=d,this._cssClass=e,this._enabled=s,this._actionCallback=r}get id(){return this._id}get label(){return this._label}set label(g){this._setLabel(g)}_setLabel(g){this._label!==g&&(this._label=g,this._onDidChange.fire({label:g}))}get tooltip(){return this._tooltip||""}set tooltip(g){this._setTooltip(g)}_setTooltip(g){this._tooltip!==g&&(this._tooltip=g,this._onDidChange.fire({tooltip:g}))}get class(){return this._cssClass}set class(g){this._setClass(g)}_setClass(g){this._cssClass!==g&&(this._cssClass=g,this._onDidChange.fire({class:g}))}get enabled(){return this._enabled}set enabled(g){this._setEnabled(g)}_setEnabled(g){this._enabled!==g&&(this._enabled=g,this._onDidChange.fire({enabled:g}))}get checked(){return this._checked}set checked(g){this._setChecked(g)}_setChecked(g){this._checked!==g&&(this._checked=g,this._onDidChange.fire({checked:g}))}async run(g,d){this._actionCallback&&await this._actionCallback(g)}}t.Action=I;class N extends n.Disposable{constructor(){super(...arguments),this._onWillRun=this._register(new i.Emitter),this.onWillRun=this._onWillRun.event,this._onDidRun=this._register(new i.Emitter),this.onDidRun=this._onDidRun.event}async run(g,d){if(!g.enabled)return;this._onWillRun.fire({action:g});let e;try{await this.runAction(g,d)}catch(s){e=s}this._onDidRun.fire({action:g,error:e})}async runAction(g,d){await g.run(d)}}t.ActionRunner=N;class b{constructor(){this.id=b.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...g){let d=[];for(const e of g)e.length&&(d.length?d=[...d,new b,...e]:d=e);return d}static{this.ID="vs.actions.separator"}async run(){}}t.Separator=b;class w{get actions(){return this._actions}constructor(g,d,e,s){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=g,this.label=d,this.class=s,this._actions=e}async run(){}}t.SubmenuAction=w;class u extends I{static{this.ID="vs.actions.empty"}constructor(){super(u.ID,O.localize(41,null),void 0,!1)}}t.EmptySubmenuAction=u;function m(v){return{id:v.id,label:v.label,tooltip:v.tooltip??v.label,class:v.class,enabled:v.enabled??!0,checked:v.checked,run:async(...g)=>v.run(...g)}}}),define(_e[5],Se([1,0,12]),function(ue,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isAndroid=t.isEdge=t.isSafari=t.isFirefox=t.isChrome=t.OS=t.OperatingSystem=t.setTimeout0=t.setTimeout0IsFaster=t.translationsConfigFile=t.platformLocale=t.locale=t.Language=t.language=t.userAgent=t.platform=t.isCI=t.isMobile=t.isIOS=t.webWorkerOrigin=t.isWebWorker=t.isWeb=t.isElectron=t.isNative=t.isLinuxSnap=t.isLinux=t.isMacintosh=t.isWindows=t.Platform=t.LANGUAGE_DEFAULT=void 0,t.PlatformToString=a,t.isLittleEndian=E,t.isBigSurOrNewer=k,i=qe(i),t.LANGUAGE_DEFAULT="en";let n=!1,O=!1,I=!1,N=!1,b=!1,w=!1,u=!1,m=!1,v=!1,g=!1,d,e=t.LANGUAGE_DEFAULT,s=t.LANGUAGE_DEFAULT,r,l;const o=globalThis;let p;typeof o.vscode<"u"&&typeof o.vscode.process<"u"?p=o.vscode.process:typeof process<"u"&&typeof process?.versions?.node=="string"&&(p=process);const A=typeof p?.versions?.electron=="string",L=A&&p?.type==="renderer";if(typeof p=="object"){n=p.platform==="win32",O=p.platform==="darwin",I=p.platform==="linux",N=I&&!!p.env.SNAP&&!!p.env.SNAP_REVISION,u=A,v=!!p.env.CI||!!p.env.BUILD_ARTIFACTSTAGINGDIRECTORY,d=t.LANGUAGE_DEFAULT,e=t.LANGUAGE_DEFAULT;const W=p.env.VSCODE_NLS_CONFIG;if(W)try{const R=JSON.parse(W);d=R.userLocale,s=R.osLocale,e=R.resolvedLanguage||t.LANGUAGE_DEFAULT,r=R.languagePack?.translationsConfigFile}catch{}b=!0}else typeof navigator=="object"&&!L?(l=navigator.userAgent,n=l.indexOf("Windows")>=0,O=l.indexOf("Macintosh")>=0,m=(l.indexOf("Macintosh")>=0||l.indexOf("iPad")>=0||l.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,I=l.indexOf("Linux")>=0,g=l?.indexOf("Mobi")>=0,w=!0,e=i.getNLSLanguage()||t.LANGUAGE_DEFAULT,d=navigator.language.toLowerCase(),s=d):console.error("Unable to resolve platform.");var c;(function(W){W[W.Web=0]="Web",W[W.Mac=1]="Mac",W[W.Linux=2]="Linux",W[W.Windows=3]="Windows"})(c||(t.Platform=c={}));function a(W){switch(W){case c.Web:return"Web";case c.Mac:return"Mac";case c.Linux:return"Linux";case c.Windows:return"Windows"}}let f=c.Web;O?f=c.Mac:n?f=c.Windows:I&&(f=c.Linux),t.isWindows=n,t.isMacintosh=O,t.isLinux=I,t.isLinuxSnap=N,t.isNative=b,t.isElectron=u,t.isWeb=w,t.isWebWorker=w&&typeof o.importScripts=="function",t.webWorkerOrigin=t.isWebWorker?o.origin:void 0,t.isIOS=m,t.isMobile=g,t.isCI=v,t.platform=f,t.userAgent=l,t.language=e;var _;(function(W){function R(){return t.language}W.value=R;function C(){return t.language.length===2?t.language==="en":t.language.length>=3?t.language[0]==="e"&&t.language[1]==="n"&&t.language[2]==="-":!1}W.isDefaultVariant=C;function $(){return t.language==="en"}W.isDefault=$})(_||(t.Language=_={})),t.locale=d,t.platformLocale=s,t.translationsConfigFile=r,t.setTimeout0IsFaster=typeof o.postMessage=="function"&&!o.importScripts,t.setTimeout0=(()=>{if(t.setTimeout0IsFaster){const W=[];o.addEventListener("message",C=>{if(C.data&&C.data.vscodeScheduleAsyncWork)for(let $=0,ee=W.length;$<ee;$++){const Y=W[$];if(Y.id===C.data.vscodeScheduleAsyncWork){W.splice($,1),Y.callback();return}}});let R=0;return C=>{const $=++R;W.push({id:$,callback:C}),o.postMessage({vscodeScheduleAsyncWork:$},"*")}}return W=>setTimeout(W)})();var H;(function(W){W[W.Windows=1]="Windows",W[W.Macintosh=2]="Macintosh",W[W.Linux=3]="Linux"})(H||(t.OperatingSystem=H={})),t.OS=O||m?H.Macintosh:n?H.Windows:H.Linux;let B=!0,F=!1;function E(){if(!F){F=!0;const W=new Uint8Array(2);W[0]=1,W[1]=2,B=new Uint16Array(W.buffer)[0]===513}return B}t.isChrome=!!(t.userAgent&&t.userAgent.indexOf("Chrome")>=0),t.isFirefox=!!(t.userAgent&&t.userAgent.indexOf("Firefox")>=0),t.isSafari=!!(!t.isChrome&&t.userAgent&&t.userAgent.indexOf("Safari")>=0),t.isEdge=!!(t.userAgent&&t.userAgent.indexOf("Edg/")>=0),t.isAndroid=!!(t.userAgent&&t.userAgent.indexOf("Android")>=0);function k(W){return parseFloat(W)>=20}}),define(_e[70],Se([1,0,18,24,5]),function(ue,t,i,n,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.BrowserFeatures=t.KeyboardSupport=void 0,i=qe(i),O=qe(O);var I;(function(N){N[N.Always=0]="Always",N[N.FullScreen=1]="FullScreen",N[N.None=2]="None"})(I||(t.KeyboardSupport=I={})),t.BrowserFeatures={clipboard:{writeText:O.isNative||document.queryCommandSupported&&document.queryCommandSupported("copy")||!!(navigator&&navigator.clipboard&&navigator.clipboard.writeText),readText:O.isNative||!!(navigator&&navigator.clipboard&&navigator.clipboard.readText)},keyboard:O.isNative||i.isStandalone()?I.Always:navigator.keyboard||i.isSafari?I.FullScreen:I.None,touch:"ontouchstart"in n.mainWindow||navigator.maxTouchPoints>0,pointerEvents:n.mainWindow.PointerEvent&&("ontouchstart"in n.mainWindow||navigator.maxTouchPoints>0)}}),define(_e[22],Se([1,0,18,86,5]),function(ue,t,i,n,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StandardWheelEvent=t.DragMouseEvent=t.StandardMouseEvent=void 0,i=qe(i),O=qe(O);class I{constructor(u,m){this.timestamp=Date.now(),this.browserEvent=m,this.leftButton=m.button===0,this.middleButton=m.button===1,this.rightButton=m.button===2,this.buttons=m.buttons,this.target=m.target,this.detail=m.detail||1,m.type==="dblclick"&&(this.detail=2),this.ctrlKey=m.ctrlKey,this.shiftKey=m.shiftKey,this.altKey=m.altKey,this.metaKey=m.metaKey,typeof m.pageX=="number"?(this.posx=m.pageX,this.posy=m.pageY):(this.posx=m.clientX+this.target.ownerDocument.body.scrollLeft+this.target.ownerDocument.documentElement.scrollLeft,this.posy=m.clientY+this.target.ownerDocument.body.scrollTop+this.target.ownerDocument.documentElement.scrollTop);const v=n.IframeUtils.getPositionOfChildWindowRelativeToAncestorWindow(u,m.view);this.posx-=v.left,this.posy-=v.top}preventDefault(){this.browserEvent.preventDefault()}stopPropagation(){this.browserEvent.stopPropagation()}}t.StandardMouseEvent=I;class N extends I{constructor(u,m){super(u,m),this.dataTransfer=m.dataTransfer}}t.DragMouseEvent=N;class b{constructor(u,m=0,v=0){this.browserEvent=u||null,this.target=u?u.target||u.targetNode||u.srcElement:null,this.deltaY=v,this.deltaX=m;let g=!1;if(i.isChrome){const d=navigator.userAgent.match(/Chrome\/(\d+)/);g=(d?parseInt(d[1]):123)<=122}if(u){const d=u,e=u,s=u.view?.devicePixelRatio||1;if(typeof d.wheelDeltaY<"u")g?this.deltaY=d.wheelDeltaY/(120*s):this.deltaY=d.wheelDeltaY/120;else if(typeof e.VERTICAL_AXIS<"u"&&e.axis===e.VERTICAL_AXIS)this.deltaY=-e.detail/3;else if(u.type==="wheel"){const r=u;r.deltaMode===r.DOM_DELTA_LINE?i.isFirefox&&!O.isMacintosh?this.deltaY=-u.deltaY/3:this.deltaY=-u.deltaY:this.deltaY=-u.deltaY/40}if(typeof d.wheelDeltaX<"u")i.isSafari&&O.isWindows?this.deltaX=-(d.wheelDeltaX/120):g?this.deltaX=d.wheelDeltaX/(120*s):this.deltaX=d.wheelDeltaX/120;else if(typeof e.HORIZONTAL_AXIS<"u"&&e.axis===e.HORIZONTAL_AXIS)this.deltaX=-u.detail/3;else if(u.type==="wheel"){const r=u;r.deltaMode===r.DOM_DELTA_LINE?i.isFirefox&&!O.isMacintosh?this.deltaX=-u.deltaX/3:this.deltaX=-u.deltaX:this.deltaX=-u.deltaX/40}this.deltaY===0&&this.deltaX===0&&u.wheelDelta&&(g?this.deltaY=u.wheelDelta/(120*s):this.deltaY=u.wheelDelta/120)}}preventDefault(){this.browserEvent?.preventDefault()}stopPropagation(){this.browserEvent?.stopPropagation()}}t.StandardWheelEvent=b}),define(_e[125],Se([1,0,6,8,5]),function(ue,t,i,n,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ResolvedKeybinding=t.ResolvedChord=t.Keybinding=t.ScanCodeChord=t.KeyCodeChord=void 0,t.decodeKeybinding=N,t.createSimpleKeybinding=b;var I;(function(d){d[d.CtrlCmd=2048]="CtrlCmd",d[d.Shift=1024]="Shift",d[d.Alt=512]="Alt",d[d.WinCtrl=256]="WinCtrl",d[d.KeyCode=255]="KeyCode"})(I||(I={}));function N(d,e){if(typeof d=="number"){if(d===0)return null;const s=(d&65535)>>>0,r=(d&4294901760)>>>16;return r!==0?new m([b(s,e),b(r,e)]):new m([b(s,e)])}else{const s=[];for(let r=0;r<d.length;r++)s.push(b(d[r],e));return new m(s)}}function b(d,e){const s=!!(d&I.CtrlCmd),r=!!(d&I.WinCtrl),l=e===O.OperatingSystem.Macintosh?r:s,o=!!(d&I.Shift),p=!!(d&I.Alt),A=e===O.OperatingSystem.Macintosh?s:r,L=d&I.KeyCode;return new w(l,o,p,A,L)}class w{constructor(e,s,r,l,o){this.ctrlKey=e,this.shiftKey=s,this.altKey=r,this.metaKey=l,this.keyCode=o}equals(e){return e instanceof w&&this.ctrlKey===e.ctrlKey&&this.shiftKey===e.shiftKey&&this.altKey===e.altKey&&this.metaKey===e.metaKey&&this.keyCode===e.keyCode}getHashCode(){const e=this.ctrlKey?"1":"0",s=this.shiftKey?"1":"0",r=this.altKey?"1":"0",l=this.metaKey?"1":"0";return`K${e}${s}${r}${l}${this.keyCode}`}isModifierKey(){return this.keyCode===n.KeyCode.Unknown||this.keyCode===n.KeyCode.Ctrl||this.keyCode===n.KeyCode.Meta||this.keyCode===n.KeyCode.Alt||this.keyCode===n.KeyCode.Shift}toKeybinding(){return new m([this])}isDuplicateModifierCase(){return this.ctrlKey&&this.keyCode===n.KeyCode.Ctrl||this.shiftKey&&this.keyCode===n.KeyCode.Shift||this.altKey&&this.keyCode===n.KeyCode.Alt||this.metaKey&&this.keyCode===n.KeyCode.Meta}}t.KeyCodeChord=w;class u{constructor(e,s,r,l,o){this.ctrlKey=e,this.shiftKey=s,this.altKey=r,this.metaKey=l,this.scanCode=o}equals(e){return e instanceof u&&this.ctrlKey===e.ctrlKey&&this.shiftKey===e.shiftKey&&this.altKey===e.altKey&&this.metaKey===e.metaKey&&this.scanCode===e.scanCode}getHashCode(){const e=this.ctrlKey?"1":"0",s=this.shiftKey?"1":"0",r=this.altKey?"1":"0",l=this.metaKey?"1":"0";return`S${e}${s}${r}${l}${this.scanCode}`}isDuplicateModifierCase(){return this.ctrlKey&&(this.scanCode===n.ScanCode.ControlLeft||this.scanCode===n.ScanCode.ControlRight)||this.shiftKey&&(this.scanCode===n.ScanCode.ShiftLeft||this.scanCode===n.ScanCode.ShiftRight)||this.altKey&&(this.scanCode===n.ScanCode.AltLeft||this.scanCode===n.ScanCode.AltRight)||this.metaKey&&(this.scanCode===n.ScanCode.MetaLeft||this.scanCode===n.ScanCode.MetaRight)}}t.ScanCodeChord=u;class m{constructor(e){if(e.length===0)throw(0,i.illegalArgument)("chords");this.chords=e}getHashCode(){let e="";for(let s=0,r=this.chords.length;s<r;s++)s!==0&&(e+=";"),e+=this.chords[s].getHashCode();return e}equals(e){if(e===null||this.chords.length!==e.chords.length)return!1;for(let s=0;s<this.chords.length;s++)if(!this.chords[s].equals(e.chords[s]))return!1;return!0}}t.Keybinding=m;class v{constructor(e,s,r,l,o,p){this.ctrlKey=e,this.shiftKey=s,this.altKey=r,this.metaKey=l,this.keyLabel=o,this.keyAriaLabel=p}}t.ResolvedChord=v;class g{}t.ResolvedKeybinding=g}),define(_e[15],Se([1,0,18,8,125,5]),function(ue,t,i,n,O,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StandardKeyboardEvent=void 0,t.printKeyboardEvent=v,t.printStandardKeyboardEvent=g,i=qe(i),I=qe(I);function N(e){if(e.charCode){const r=String.fromCharCode(e.charCode).toUpperCase();return n.KeyCodeUtils.fromString(r)}const s=e.keyCode;if(s===3)return n.KeyCode.PauseBreak;if(i.isFirefox)switch(s){case 59:return n.KeyCode.Semicolon;case 60:if(I.isLinux)return n.KeyCode.IntlBackslash;break;case 61:return n.KeyCode.Equal;case 107:return n.KeyCode.NumpadAdd;case 109:return n.KeyCode.NumpadSubtract;case 173:return n.KeyCode.Minus;case 224:if(I.isMacintosh)return n.KeyCode.Meta;break}else if(i.isWebKit){if(I.isMacintosh&&s===93)return n.KeyCode.Meta;if(!I.isMacintosh&&s===92)return n.KeyCode.Meta}return n.EVENT_KEY_CODE_MAP[s]||n.KeyCode.Unknown}const b=I.isMacintosh?n.KeyMod.WinCtrl:n.KeyMod.CtrlCmd,w=n.KeyMod.Alt,u=n.KeyMod.Shift,m=I.isMacintosh?n.KeyMod.CtrlCmd:n.KeyMod.WinCtrl;function v(e){const s=[];return e.ctrlKey&&s.push("ctrl"),e.shiftKey&&s.push("shift"),e.altKey&&s.push("alt"),e.metaKey&&s.push("meta"),`modifiers: [${s.join(",")}], code: ${e.code}, keyCode: ${e.keyCode}, key: ${e.key}`}function g(e){const s=[];return e.ctrlKey&&s.push("ctrl"),e.shiftKey&&s.push("shift"),e.altKey&&s.push("alt"),e.metaKey&&s.push("meta"),`modifiers: [${s.join(",")}], code: ${e.code}, keyCode: ${e.keyCode} ('${n.KeyCodeUtils.toString(e.keyCode)}')`}class d{constructor(s){this._standardKeyboardEventBrand=!0;const r=s;this.browserEvent=r,this.target=r.target,this.ctrlKey=r.ctrlKey,this.shiftKey=r.shiftKey,this.altKey=r.altKey,this.metaKey=r.metaKey,this.altGraphKey=r.getModifierState?.("AltGraph"),this.keyCode=N(r),this.code=r.code,this.ctrlKey=this.ctrlKey||this.keyCode===n.KeyCode.Ctrl,this.altKey=this.altKey||this.keyCode===n.KeyCode.Alt,this.shiftKey=this.shiftKey||this.keyCode===n.KeyCode.Shift,this.metaKey=this.metaKey||this.keyCode===n.KeyCode.Meta,this._asKeybinding=this._computeKeybinding(),this._asKeyCodeChord=this._computeKeyCodeChord()}preventDefault(){this.browserEvent&&this.browserEvent.preventDefault&&this.browserEvent.preventDefault()}stopPropagation(){this.browserEvent&&this.browserEvent.stopPropagation&&this.browserEvent.stopPropagation()}toKeyCodeChord(){return this._asKeyCodeChord}equals(s){return this._asKeybinding===s}_computeKeybinding(){let s=n.KeyCode.Unknown;this.keyCode!==n.KeyCode.Ctrl&&this.keyCode!==n.KeyCode.Shift&&this.keyCode!==n.KeyCode.Alt&&this.keyCode!==n.KeyCode.Meta&&(s=this.keyCode);let r=0;return this.ctrlKey&&(r|=b),this.altKey&&(r|=w),this.shiftKey&&(r|=u),this.metaKey&&(r|=m),r|=s,r}_computeKeyCodeChord(){let s=n.KeyCode.Unknown;return this.keyCode!==n.KeyCode.Ctrl&&this.keyCode!==n.KeyCode.Shift&&this.keyCode!==n.KeyCode.Alt&&this.keyCode!==n.KeyCode.Meta&&(s=this.keyCode),new O.KeyCodeChord(this.ctrlKey,this.shiftKey,this.altKey,this.metaKey,s)}}t.StandardKeyboardEvent=d}),define(_e[126],Se([1,0,5]),function(ue,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.arch=t.platform=t.env=t.cwd=void 0;let n;const O=globalThis.vscode;if(typeof O<"u"&&typeof O.process<"u"){const I=O.process;n={get platform(){return I.platform},get arch(){return I.arch},get env(){return I.env},cwd(){return I.cwd()}}}else typeof process<"u"&&typeof process?.versions?.node=="string"?n={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:n={get platform(){return i.isWindows?"win32":i.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};t.cwd=n.cwd,t.env=n.env,t.platform=n.platform,t.arch=n.arch}),define(_e[29],Se([1,0,126]),function(ue,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.delimiter=t.sep=t.toNamespacedPath=t.parse=t.format=t.extname=t.basename=t.dirname=t.relative=t.resolve=t.join=t.isAbsolute=t.normalize=t.posix=t.win32=void 0,i=qe(i);const n=65,O=97,I=90,N=122,b=46,w=47,u=92,m=58,v=63;class g extends Error{constructor(f,_,H){let B;typeof _=="string"&&_.indexOf("not ")===0?(B="must not be",_=_.replace(/^not /,"")):B="must be";const F=f.indexOf(".")!==-1?"property":"argument";let E=`The "${f}" ${F} ${B} of type ${_}`;E+=`. Received type ${typeof H}`,super(E),this.code="ERR_INVALID_ARG_TYPE"}}function d(a,f){if(a===null||typeof a!="object")throw new g(f,"Object",a)}function e(a,f){if(typeof a!="string")throw new g(f,"string",a)}const s=i.platform==="win32";function r(a){return a===w||a===u}function l(a){return a===w}function o(a){return a>=n&&a<=I||a>=O&&a<=N}function p(a,f,_,H){let B="",F=0,E=-1,k=0,W=0;for(let R=0;R<=a.length;++R){if(R<a.length)W=a.charCodeAt(R);else{if(H(W))break;W=w}if(H(W)){if(!(E===R-1||k===1))if(k===2){if(B.length<2||F!==2||B.charCodeAt(B.length-1)!==b||B.charCodeAt(B.length-2)!==b){if(B.length>2){const C=B.lastIndexOf(_);C===-1?(B="",F=0):(B=B.slice(0,C),F=B.length-1-B.lastIndexOf(_)),E=R,k=0;continue}else if(B.length!==0){B="",F=0,E=R,k=0;continue}}f&&(B+=B.length>0?`${_}..`:"..",F=2)}else B.length>0?B+=`${_}${a.slice(E+1,R)}`:B=a.slice(E+1,R),F=R-E-1;E=R,k=0}else W===b&&k!==-1?++k:k=-1}return B}function A(a){return a?`${a[0]==="."?"":"."}${a}`:""}function L(a,f){d(f,"pathObject");const _=f.dir||f.root,H=f.base||`${f.name||""}${A(f.ext)}`;return _?_===f.root?`${_}${H}`:`${_}${a}${H}`:H}t.win32={resolve(...a){let f="",_="",H=!1;for(let B=a.length-1;B>=-1;B--){let F;if(B>=0){if(F=a[B],e(F,`paths[${B}]`),F.length===0)continue}else f.length===0?F=i.cwd():(F=i.env[`=${f}`]||i.cwd(),(F===void 0||F.slice(0,2).toLowerCase()!==f.toLowerCase()&&F.charCodeAt(2)===u)&&(F=`${f}\\`));const E=F.length;let k=0,W="",R=!1;const C=F.charCodeAt(0);if(E===1)r(C)&&(k=1,R=!0);else if(r(C))if(R=!0,r(F.charCodeAt(1))){let $=2,ee=$;for(;$<E&&!r(F.charCodeAt($));)$++;if($<E&&$!==ee){const Y=F.slice(ee,$);for(ee=$;$<E&&r(F.charCodeAt($));)$++;if($<E&&$!==ee){for(ee=$;$<E&&!r(F.charCodeAt($));)$++;($===E||$!==ee)&&(W=`\\\\${Y}\\${F.slice(ee,$)}`,k=$)}}}else k=1;else o(C)&&F.charCodeAt(1)===m&&(W=F.slice(0,2),k=2,E>2&&r(F.charCodeAt(2))&&(R=!0,k=3));if(W.length>0)if(f.length>0){if(W.toLowerCase()!==f.toLowerCase())continue}else f=W;if(H){if(f.length>0)break}else if(_=`${F.slice(k)}\\${_}`,H=R,R&&f.length>0)break}return _=p(_,!H,"\\",r),H?`${f}\\${_}`:`${f}${_}`||"."},normalize(a){e(a,"path");const f=a.length;if(f===0)return".";let _=0,H,B=!1;const F=a.charCodeAt(0);if(f===1)return l(F)?"\\":a;if(r(F))if(B=!0,r(a.charCodeAt(1))){let k=2,W=k;for(;k<f&&!r(a.charCodeAt(k));)k++;if(k<f&&k!==W){const R=a.slice(W,k);for(W=k;k<f&&r(a.charCodeAt(k));)k++;if(k<f&&k!==W){for(W=k;k<f&&!r(a.charCodeAt(k));)k++;if(k===f)return`\\\\${R}\\${a.slice(W)}\\`;k!==W&&(H=`\\\\${R}\\${a.slice(W,k)}`,_=k)}}}else _=1;else o(F)&&a.charCodeAt(1)===m&&(H=a.slice(0,2),_=2,f>2&&r(a.charCodeAt(2))&&(B=!0,_=3));let E=_<f?p(a.slice(_),!B,"\\",r):"";return E.length===0&&!B&&(E="."),E.length>0&&r(a.charCodeAt(f-1))&&(E+="\\"),H===void 0?B?`\\${E}`:E:B?`${H}\\${E}`:`${H}${E}`},isAbsolute(a){e(a,"path");const f=a.length;if(f===0)return!1;const _=a.charCodeAt(0);return r(_)||f>2&&o(_)&&a.charCodeAt(1)===m&&r(a.charCodeAt(2))},join(...a){if(a.length===0)return".";let f,_;for(let F=0;F<a.length;++F){const E=a[F];e(E,"path"),E.length>0&&(f===void 0?f=_=E:f+=`\\${E}`)}if(f===void 0)return".";let H=!0,B=0;if(typeof _=="string"&&r(_.charCodeAt(0))){++B;const F=_.length;F>1&&r(_.charCodeAt(1))&&(++B,F>2&&(r(_.charCodeAt(2))?++B:H=!1))}if(H){for(;B<f.length&&r(f.charCodeAt(B));)B++;B>=2&&(f=`\\${f.slice(B)}`)}return t.win32.normalize(f)},relative(a,f){if(e(a,"from"),e(f,"to"),a===f)return"";const _=t.win32.resolve(a),H=t.win32.resolve(f);if(_===H||(a=_.toLowerCase(),f=H.toLowerCase(),a===f))return"";let B=0;for(;B<a.length&&a.charCodeAt(B)===u;)B++;let F=a.length;for(;F-1>B&&a.charCodeAt(F-1)===u;)F--;const E=F-B;let k=0;for(;k<f.length&&f.charCodeAt(k)===u;)k++;let W=f.length;for(;W-1>k&&f.charCodeAt(W-1)===u;)W--;const R=W-k,C=E<R?E:R;let $=-1,ee=0;for(;ee<C;ee++){const Z=a.charCodeAt(B+ee);if(Z!==f.charCodeAt(k+ee))break;Z===u&&($=ee)}if(ee!==C){if($===-1)return H}else{if(R>C){if(f.charCodeAt(k+ee)===u)return H.slice(k+ee+1);if(ee===2)return H.slice(k+ee)}E>C&&(a.charCodeAt(B+ee)===u?$=ee:ee===2&&($=3)),$===-1&&($=0)}let Y="";for(ee=B+$+1;ee<=F;++ee)(ee===F||a.charCodeAt(ee)===u)&&(Y+=Y.length===0?"..":"\\..");return k+=$,Y.length>0?`${Y}${H.slice(k,W)}`:(H.charCodeAt(k)===u&&++k,H.slice(k,W))},toNamespacedPath(a){if(typeof a!="string"||a.length===0)return a;const f=t.win32.resolve(a);if(f.length<=2)return a;if(f.charCodeAt(0)===u){if(f.charCodeAt(1)===u){const _=f.charCodeAt(2);if(_!==v&&_!==b)return`\\\\?\\UNC\\${f.slice(2)}`}}else if(o(f.charCodeAt(0))&&f.charCodeAt(1)===m&&f.charCodeAt(2)===u)return`\\\\?\\${f}`;return a},dirname(a){e(a,"path");const f=a.length;if(f===0)return".";let _=-1,H=0;const B=a.charCodeAt(0);if(f===1)return r(B)?a:".";if(r(B)){if(_=H=1,r(a.charCodeAt(1))){let k=2,W=k;for(;k<f&&!r(a.charCodeAt(k));)k++;if(k<f&&k!==W){for(W=k;k<f&&r(a.charCodeAt(k));)k++;if(k<f&&k!==W){for(W=k;k<f&&!r(a.charCodeAt(k));)k++;if(k===f)return a;k!==W&&(_=H=k+1)}}}}else o(B)&&a.charCodeAt(1)===m&&(_=f>2&&r(a.charCodeAt(2))?3:2,H=_);let F=-1,E=!0;for(let k=f-1;k>=H;--k)if(r(a.charCodeAt(k))){if(!E){F=k;break}}else E=!1;if(F===-1){if(_===-1)return".";F=_}return a.slice(0,F)},basename(a,f){f!==void 0&&e(f,"suffix"),e(a,"path");let _=0,H=-1,B=!0,F;if(a.length>=2&&o(a.charCodeAt(0))&&a.charCodeAt(1)===m&&(_=2),f!==void 0&&f.length>0&&f.length<=a.length){if(f===a)return"";let E=f.length-1,k=-1;for(F=a.length-1;F>=_;--F){const W=a.charCodeAt(F);if(r(W)){if(!B){_=F+1;break}}else k===-1&&(B=!1,k=F+1),E>=0&&(W===f.charCodeAt(E)?--E===-1&&(H=F):(E=-1,H=k))}return _===H?H=k:H===-1&&(H=a.length),a.slice(_,H)}for(F=a.length-1;F>=_;--F)if(r(a.charCodeAt(F))){if(!B){_=F+1;break}}else H===-1&&(B=!1,H=F+1);return H===-1?"":a.slice(_,H)},extname(a){e(a,"path");let f=0,_=-1,H=0,B=-1,F=!0,E=0;a.length>=2&&a.charCodeAt(1)===m&&o(a.charCodeAt(0))&&(f=H=2);for(let k=a.length-1;k>=f;--k){const W=a.charCodeAt(k);if(r(W)){if(!F){H=k+1;break}continue}B===-1&&(F=!1,B=k+1),W===b?_===-1?_=k:E!==1&&(E=1):_!==-1&&(E=-1)}return _===-1||B===-1||E===0||E===1&&_===B-1&&_===H+1?"":a.slice(_,B)},format:L.bind(null,"\\"),parse(a){e(a,"path");const f={root:"",dir:"",base:"",ext:"",name:""};if(a.length===0)return f;const _=a.length;let H=0,B=a.charCodeAt(0);if(_===1)return r(B)?(f.root=f.dir=a,f):(f.base=f.name=a,f);if(r(B)){if(H=1,r(a.charCodeAt(1))){let $=2,ee=$;for(;$<_&&!r(a.charCodeAt($));)$++;if($<_&&$!==ee){for(ee=$;$<_&&r(a.charCodeAt($));)$++;if($<_&&$!==ee){for(ee=$;$<_&&!r(a.charCodeAt($));)$++;$===_?H=$:$!==ee&&(H=$+1)}}}}else if(o(B)&&a.charCodeAt(1)===m){if(_<=2)return f.root=f.dir=a,f;if(H=2,r(a.charCodeAt(2))){if(_===3)return f.root=f.dir=a,f;H=3}}H>0&&(f.root=a.slice(0,H));let F=-1,E=H,k=-1,W=!0,R=a.length-1,C=0;for(;R>=H;--R){if(B=a.charCodeAt(R),r(B)){if(!W){E=R+1;break}continue}k===-1&&(W=!1,k=R+1),B===b?F===-1?F=R:C!==1&&(C=1):F!==-1&&(C=-1)}return k!==-1&&(F===-1||C===0||C===1&&F===k-1&&F===E+1?f.base=f.name=a.slice(E,k):(f.name=a.slice(E,F),f.base=a.slice(E,k),f.ext=a.slice(F,k))),E>0&&E!==H?f.dir=a.slice(0,E-1):f.dir=f.root,f},sep:"\\",delimiter:";",win32:null,posix:null};const c=(()=>{if(s){const a=/\\/g;return()=>{const f=i.cwd().replace(a,"/");return f.slice(f.indexOf("/"))}}return()=>i.cwd()})();t.posix={resolve(...a){let f="",_=!1;for(let H=a.length-1;H>=-1&&!_;H--){const B=H>=0?a[H]:c();e(B,`paths[${H}]`),B.length!==0&&(f=`${B}/${f}`,_=B.charCodeAt(0)===w)}return f=p(f,!_,"/",l),_?`/${f}`:f.length>0?f:"."},normalize(a){if(e(a,"path"),a.length===0)return".";const f=a.charCodeAt(0)===w,_=a.charCodeAt(a.length-1)===w;return a=p(a,!f,"/",l),a.length===0?f?"/":_?"./":".":(_&&(a+="/"),f?`/${a}`:a)},isAbsolute(a){return e(a,"path"),a.length>0&&a.charCodeAt(0)===w},join(...a){if(a.length===0)return".";let f;for(let _=0;_<a.length;++_){const H=a[_];e(H,"path"),H.length>0&&(f===void 0?f=H:f+=`/${H}`)}return f===void 0?".":t.posix.normalize(f)},relative(a,f){if(e(a,"from"),e(f,"to"),a===f||(a=t.posix.resolve(a),f=t.posix.resolve(f),a===f))return"";const _=1,H=a.length,B=H-_,F=1,E=f.length-F,k=B<E?B:E;let W=-1,R=0;for(;R<k;R++){const $=a.charCodeAt(_+R);if($!==f.charCodeAt(F+R))break;$===w&&(W=R)}if(R===k)if(E>k){if(f.charCodeAt(F+R)===w)return f.slice(F+R+1);if(R===0)return f.slice(F+R)}else B>k&&(a.charCodeAt(_+R)===w?W=R:R===0&&(W=0));let C="";for(R=_+W+1;R<=H;++R)(R===H||a.charCodeAt(R)===w)&&(C+=C.length===0?"..":"/..");return`${C}${f.slice(F+W)}`},toNamespacedPath(a){return a},dirname(a){if(e(a,"path"),a.length===0)return".";const f=a.charCodeAt(0)===w;let _=-1,H=!0;for(let B=a.length-1;B>=1;--B)if(a.charCodeAt(B)===w){if(!H){_=B;break}}else H=!1;return _===-1?f?"/":".":f&&_===1?"//":a.slice(0,_)},basename(a,f){f!==void 0&&e(f,"ext"),e(a,"path");let _=0,H=-1,B=!0,F;if(f!==void 0&&f.length>0&&f.length<=a.length){if(f===a)return"";let E=f.length-1,k=-1;for(F=a.length-1;F>=0;--F){const W=a.charCodeAt(F);if(W===w){if(!B){_=F+1;break}}else k===-1&&(B=!1,k=F+1),E>=0&&(W===f.charCodeAt(E)?--E===-1&&(H=F):(E=-1,H=k))}return _===H?H=k:H===-1&&(H=a.length),a.slice(_,H)}for(F=a.length-1;F>=0;--F)if(a.charCodeAt(F)===w){if(!B){_=F+1;break}}else H===-1&&(B=!1,H=F+1);return H===-1?"":a.slice(_,H)},extname(a){e(a,"path");let f=-1,_=0,H=-1,B=!0,F=0;for(let E=a.length-1;E>=0;--E){const k=a.charCodeAt(E);if(k===w){if(!B){_=E+1;break}continue}H===-1&&(B=!1,H=E+1),k===b?f===-1?f=E:F!==1&&(F=1):f!==-1&&(F=-1)}return f===-1||H===-1||F===0||F===1&&f===H-1&&f===_+1?"":a.slice(f,H)},format:L.bind(null,"/"),parse(a){e(a,"path");const f={root:"",dir:"",base:"",ext:"",name:""};if(a.length===0)return f;const _=a.charCodeAt(0)===w;let H;_?(f.root="/",H=1):H=0;let B=-1,F=0,E=-1,k=!0,W=a.length-1,R=0;for(;W>=H;--W){const C=a.charCodeAt(W);if(C===w){if(!k){F=W+1;break}continue}E===-1&&(k=!1,E=W+1),C===b?B===-1?B=W:R!==1&&(R=1):B!==-1&&(R=-1)}if(E!==-1){const C=F===0&&_?1:F;B===-1||R===0||R===1&&B===E-1&&B===F+1?f.base=f.name=a.slice(C,E):(f.name=a.slice(C,B),f.base=a.slice(C,E),f.ext=a.slice(B,E))}return F>0?f.dir=a.slice(0,F-1):_&&(f.dir="/"),f},sep:"/",delimiter:":",win32:null,posix:null},t.posix.win32=t.win32.win32=t.win32,t.posix.posix=t.win32.posix=t.posix,t.normalize=s?t.win32.normalize:t.posix.normalize,t.isAbsolute=s?t.win32.isAbsolute:t.posix.isAbsolute,t.join=s?t.win32.join:t.posix.join,t.resolve=s?t.win32.resolve:t.posix.resolve,t.relative=s?t.win32.relative:t.posix.relative,t.dirname=s?t.win32.dirname:t.posix.dirname,t.basename=s?t.win32.basename:t.posix.basename,t.extname=s?t.win32.extname:t.posix.extname,t.format=s?t.win32.format:t.posix.format,t.parse=s?t.win32.parse:t.posix.parse,t.toNamespacedPath=s?t.win32.toNamespacedPath:t.posix.toNamespacedPath,t.sep=s?t.win32.sep:t.posix.sep,t.delimiter=s?t.win32.delimiter:t.posix.delimiter}),define(_e[127],Se([1,0,17,29,5,11,10]),function(ue,t,i,n,O,I,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isPathSeparator=b,t.toSlashes=w,t.toPosixPath=u,t.getRoot=m,t.isUNC=v,t.isValidBasename=s,t.isEqual=r,t.isEqualOrParent=l,t.isWindowsDriveLetter=o,t.sanitizeFilePath=p,t.removeTrailingPathSeparator=A,t.isRootOrDriveLetter=L,t.hasDriveLetter=c,t.getDriveLetter=a,t.indexOfPath=f,t.parseLineAndColumnAware=_,t.randomPath=F;function b(E){return E===i.CharCode.Slash||E===i.CharCode.Backslash}function w(E){return E.replace(/[\\/]/g,n.posix.sep)}function u(E){return E.indexOf("/")===-1&&(E=w(E)),/^[a-zA-Z]:(\/|$)/.test(E)&&(E="/"+E),E}function m(E,k=n.posix.sep){if(!E)return"";const W=E.length,R=E.charCodeAt(0);if(b(R)){if(b(E.charCodeAt(1))&&!b(E.charCodeAt(2))){let $=3;const ee=$;for(;$<W&&!b(E.charCodeAt($));$++);if(ee!==$&&!b(E.charCodeAt($+1))){for($+=1;$<W;$++)if(b(E.charCodeAt($)))return E.slice(0,$+1).replace(/[\\/]/g,k)}}return k}else if(o(R)&&E.charCodeAt(1)===i.CharCode.Colon)return b(E.charCodeAt(2))?E.slice(0,2)+k:E.slice(0,2);let C=E.indexOf("://");if(C!==-1){for(C+=3;C<W;C++)if(b(E.charCodeAt(C)))return E.slice(0,C+1)}return""}function v(E){if(!O.isWindows||!E||E.length<5)return!1;let k=E.charCodeAt(0);if(k!==i.CharCode.Backslash||(k=E.charCodeAt(1),k!==i.CharCode.Backslash))return!1;let W=2;const R=W;for(;W<E.length&&(k=E.charCodeAt(W),k!==i.CharCode.Backslash);W++);return!(R===W||(k=E.charCodeAt(W+1),isNaN(k)||k===i.CharCode.Backslash))}const g=/[\\/:\*\?"<>\|]/g,d=/[/]/g,e=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function s(E,k=O.isWindows){const W=k?g:d;return!(!E||E.length===0||/^\s+$/.test(E)||(W.lastIndex=0,W.test(E))||k&&e.test(E)||E==="."||E===".."||k&&E[E.length-1]==="."||k&&E.length!==E.trim().length||E.length>255)}function r(E,k,W){const R=E===k;return!W||R?R:!E||!k?!1:(0,I.equalsIgnoreCase)(E,k)}function l(E,k,W,R=n.sep){if(E===k)return!0;if(!E||!k||k.length>E.length)return!1;if(W){if(!(0,I.startsWithIgnoreCase)(E,k))return!1;if(k.length===E.length)return!0;let $=k.length;return k.charAt(k.length-1)===R&&$--,E.charAt($)===R}return k.charAt(k.length-1)!==R&&(k+=R),E.indexOf(k)===0}function o(E){return E>=i.CharCode.A&&E<=i.CharCode.Z||E>=i.CharCode.a&&E<=i.CharCode.z}function p(E,k){return O.isWindows&&E.endsWith(":")&&(E+=n.sep),(0,n.isAbsolute)(E)||(E=(0,n.join)(k,E)),E=(0,n.normalize)(E),A(E)}function A(E){return O.isWindows?(E=(0,I.rtrim)(E,n.sep),E.endsWith(":")&&(E+=n.sep)):(E=(0,I.rtrim)(E,n.sep),E||(E=n.sep)),E}function L(E){const k=(0,n.normalize)(E);return O.isWindows?E.length>3?!1:c(k)&&(E.length===2||k.charCodeAt(2)===i.CharCode.Backslash):k===n.posix.sep}function c(E,k=O.isWindows){return k?o(E.charCodeAt(0))&&E.charCodeAt(1)===i.CharCode.Colon:!1}function a(E,k=O.isWindows){return c(E,k)?E[0]:void 0}function f(E,k,W){return k.length>E.length?-1:E===k?0:(W&&(E=E.toLowerCase(),k=k.toLowerCase()),E.indexOf(k))}function _(E){const k=E.split(":");let W,R,C;for(const $ of k){const ee=Number($);(0,N.isNumber)(ee)?R===void 0?R=ee:C===void 0&&(C=ee):W=W?[W,$].join(":"):$}if(!W)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:W,line:R!==void 0?R:void 0,column:C!==void 0?C:R!==void 0?1:void 0}}const H="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",B="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function F(E,k,W=8){let R="";for(let $=0;$<W;$++){let ee;$===0&&O.isWindows&&!k&&(W===3||W===4)?ee=B:ee=H,R+=ee.charAt(Math.floor(Math.random()*ee.length))}let C;return k?C=`${k}-${R}`:C=R,E?(0,n.join)(E,C):C}}),define(_e[128],Se([1,0,29]),function(ue,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Mimes=void 0,t.getMediaOrTextMime=I,t.getMediaMime=N,t.getExtensionForMimeType=b,t.normalizeMimeType=u,t.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const n={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},O={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function I(m){const v=(0,i.extname)(m),g=n[v.toLowerCase()];return g!==void 0?g:N(m)}function N(m){const v=(0,i.extname)(m);return O[v.toLowerCase()]}function b(m){for(const v in O)if(O[v]===m)return v}const w=/^(.+)\/(.+?)(;.+)?$/;function u(m,v){const g=w.exec(m);return g?`${g[1].toLowerCase()}/${g[2].toLowerCase()}${g[3]??""}`:v?void 0:m}}),define(_e[16],Se([1,0,17,61,29,5]),function(ue,t,i,n,O,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.URI=void 0,t.isUriComponents=r,t.uriToFsPath=c,O=qe(O);const N=/^\w[\w\d+.-]*$/,b=/^\//,w=/^\/\//;function u(B,F){if(!B.scheme&&F)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${B.authority}", path: "${B.path}", query: "${B.query}", fragment: "${B.fragment}"}`);if(B.scheme&&!N.test(B.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(B.path){if(B.authority){if(!b.test(B.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(w.test(B.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function m(B,F){return!B&&!F?"file":B}function v(B,F){switch(B){case"https":case"http":case"file":F?F[0]!==d&&(F=d+F):F=d;break}return F}const g="",d="/",e=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class s{static isUri(F){return F instanceof s?!0:F?typeof F.authority=="string"&&typeof F.fragment=="string"&&typeof F.path=="string"&&typeof F.query=="string"&&typeof F.scheme=="string"&&typeof F.fsPath=="string"&&typeof F.with=="function"&&typeof F.toString=="function":!1}constructor(F,E,k,W,R,C=!1){typeof F=="object"?(this.scheme=F.scheme||g,this.authority=F.authority||g,this.path=F.path||g,this.query=F.query||g,this.fragment=F.fragment||g):(this.scheme=m(F,C),this.authority=E||g,this.path=v(this.scheme,k||g),this.query=W||g,this.fragment=R||g,u(this,C))}get fsPath(){return c(this,!1)}with(F){if(!F)return this;let{scheme:E,authority:k,path:W,query:R,fragment:C}=F;return E===void 0?E=this.scheme:E===null&&(E=g),k===void 0?k=this.authority:k===null&&(k=g),W===void 0?W=this.path:W===null&&(W=g),R===void 0?R=this.query:R===null&&(R=g),C===void 0?C=this.fragment:C===null&&(C=g),E===this.scheme&&k===this.authority&&W===this.path&&R===this.query&&C===this.fragment?this:new o(E,k,W,R,C)}static parse(F,E=!1){const k=e.exec(F);return k?new o(k[2]||g,H(k[4]||g),H(k[5]||g),H(k[7]||g),H(k[9]||g),E):new o(g,g,g,g,g)}static file(F){let E=g;if(I.isWindows&&(F=F.replace(/\\/g,d)),F[0]===d&&F[1]===d){const k=F.indexOf(d,2);k===-1?(E=F.substring(2),F=d):(E=F.substring(2,k),F=F.substring(k)||d)}return new o("file",E,F,g,g)}static from(F,E){return new o(F.scheme,F.authority,F.path,F.query,F.fragment,E)}static joinPath(F,...E){if(!F.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let k;return I.isWindows&&F.scheme==="file"?k=s.file(O.win32.join(c(F,!0),...E)).path:k=O.posix.join(F.path,...E),F.with({path:k})}toString(F=!1){return a(this,F)}toJSON(){return this}static revive(F){if(F){if(F instanceof s)return F;{const E=new o(F);return E._formatted=F.external??null,E._fsPath=F._sep===l?F.fsPath??null:null,E}}else return F}[Symbol.for("debug.description")](){return`URI(${this.toString()})`}}t.URI=s;function r(B){return!B||typeof B!="object"?!1:typeof B.scheme=="string"&&(typeof B.authority=="string"||typeof B.authority>"u")&&(typeof B.path=="string"||typeof B.path>"u")&&(typeof B.query=="string"||typeof B.query>"u")&&(typeof B.fragment=="string"||typeof B.fragment>"u")}const l=I.isWindows?1:void 0;class o extends s{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=c(this,!1)),this._fsPath}toString(F=!1){return F?a(this,!0):(this._formatted||(this._formatted=a(this,!1)),this._formatted)}toJSON(){const F={$mid:n.MarshalledId.Uri};return this._fsPath&&(F.fsPath=this._fsPath,F._sep=l),this._formatted&&(F.external=this._formatted),this.path&&(F.path=this.path),this.scheme&&(F.scheme=this.scheme),this.authority&&(F.authority=this.authority),this.query&&(F.query=this.query),this.fragment&&(F.fragment=this.fragment),F}}const p={[i.CharCode.Colon]:"%3A",[i.CharCode.Slash]:"%2F",[i.CharCode.QuestionMark]:"%3F",[i.CharCode.Hash]:"%23",[i.CharCode.OpenSquareBracket]:"%5B",[i.CharCode.CloseSquareBracket]:"%5D",[i.CharCode.AtSign]:"%40",[i.CharCode.ExclamationMark]:"%21",[i.CharCode.DollarSign]:"%24",[i.CharCode.Ampersand]:"%26",[i.CharCode.SingleQuote]:"%27",[i.CharCode.OpenParen]:"%28",[i.CharCode.CloseParen]:"%29",[i.CharCode.Asterisk]:"%2A",[i.CharCode.Plus]:"%2B",[i.CharCode.Comma]:"%2C",[i.CharCode.Semicolon]:"%3B",[i.CharCode.Equals]:"%3D",[i.CharCode.Space]:"%20"};function A(B,F,E){let k,W=-1;for(let R=0;R<B.length;R++){const C=B.charCodeAt(R);if(C>=i.CharCode.a&&C<=i.CharCode.z||C>=i.CharCode.A&&C<=i.CharCode.Z||C>=i.CharCode.Digit0&&C<=i.CharCode.Digit9||C===i.CharCode.Dash||C===i.CharCode.Period||C===i.CharCode.Underline||C===i.CharCode.Tilde||F&&C===i.CharCode.Slash||E&&C===i.CharCode.OpenSquareBracket||E&&C===i.CharCode.CloseSquareBracket||E&&C===i.CharCode.Colon)W!==-1&&(k+=encodeURIComponent(B.substring(W,R)),W=-1),k!==void 0&&(k+=B.charAt(R));else{k===void 0&&(k=B.substr(0,R));const $=p[C];$!==void 0?(W!==-1&&(k+=encodeURIComponent(B.substring(W,R)),W=-1),k+=$):W===-1&&(W=R)}}return W!==-1&&(k+=encodeURIComponent(B.substring(W))),k!==void 0?k:B}function L(B){let F;for(let E=0;E<B.length;E++){const k=B.charCodeAt(E);k===i.CharCode.Hash||k===i.CharCode.QuestionMark?(F===void 0&&(F=B.substr(0,E)),F+=p[k]):F!==void 0&&(F+=B[E])}return F!==void 0?F:B}function c(B,F){let E;return B.authority&&B.path.length>1&&B.scheme==="file"?E=`//${B.authority}${B.path}`:B.path.charCodeAt(0)===i.CharCode.Slash&&(B.path.charCodeAt(1)>=i.CharCode.A&&B.path.charCodeAt(1)<=i.CharCode.Z||B.path.charCodeAt(1)>=i.CharCode.a&&B.path.charCodeAt(1)<=i.CharCode.z)&&B.path.charCodeAt(2)===i.CharCode.Colon?F?E=B.path.substr(1):E=B.path[1].toLowerCase()+B.path.substr(2):E=B.path,I.isWindows&&(E=E.replace(/\//g,"\\")),E}function a(B,F){const E=F?L:A;let k="",{scheme:W,authority:R,path:C,query:$,fragment:ee}=B;if(W&&(k+=W,k+=":"),(R||W==="file")&&(k+=d,k+=d),R){let Y=R.indexOf("@");if(Y!==-1){const Z=R.substr(0,Y);R=R.substr(Y+1),Y=Z.lastIndexOf(":"),Y===-1?k+=E(Z,!1,!1):(k+=E(Z.substr(0,Y),!1,!1),k+=":",k+=E(Z.substr(Y+1),!1,!0)),k+="@"}R=R.toLowerCase(),Y=R.lastIndexOf(":"),Y===-1?k+=E(R,!1,!0):(k+=E(R.substr(0,Y),!1,!0),k+=R.substr(Y))}if(C){if(C.length>=3&&C.charCodeAt(0)===i.CharCode.Slash&&C.charCodeAt(2)===i.CharCode.Colon){const Y=C.charCodeAt(1);Y>=i.CharCode.A&&Y<=i.CharCode.Z&&(C=`/${String.fromCharCode(Y+32)}:${C.substr(3)}`)}else if(C.length>=2&&C.charCodeAt(1)===i.CharCode.Colon){const Y=C.charCodeAt(0);Y>=i.CharCode.A&&Y<=i.CharCode.Z&&(C=`${String.fromCharCode(Y+32)}:${C.substr(2)}`)}k+=E(C,!0,!1)}return $&&(k+="?",k+=E($,!1,!1)),ee&&(k+="#",k+=F?ee:A(ee,!1,!1)),k}function f(B){try{return decodeURIComponent(B)}catch{return B.length>3?B.substr(0,3)+f(B.substr(3)):B}}const _=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function H(B){return B.match(_)?B.replace(_,F=>f(F)):B}}),define(_e[71],Se([1,0,47,16,61]),function(ue,t,i,n,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.stringify=I,t.parse=N,t.revive=w;function I(u){return JSON.stringify(u,b)}function N(u){let m=JSON.parse(u);return m=w(m),m}function b(u,m){return m instanceof RegExp?{$mid:O.MarshalledId.Regexp,source:m.source,flags:m.flags}:m}function w(u,m=0){if(!u||m>200)return u;if(typeof u=="object"){switch(u.$mid){case O.MarshalledId.Uri:return n.URI.revive(u);case O.MarshalledId.Regexp:return new RegExp(u.source,u.flags);case O.MarshalledId.Date:return new Date(u.source)}if(u instanceof i.VSBuffer||u instanceof Uint8Array)return u;if(Array.isArray(u))for(let v=0;v<u.length;++v)u[v]=w(u[v],m+1);else for(const v in u)Object.hasOwnProperty.call(u,v)&&(u[v]=w(u[v],m+1))}return u}}),define(_e[40],Se([1,0,6,5,11,16,29]),function(ue,t,i,n,O,I,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.COI=t.FileAccess=t.VSCODE_AUTHORITY=t.nodeModulesAsarUnpackedPath=t.nodeModulesAsarPath=t.nodeModulesPath=t.builtinExtensionsPath=t.RemoteAuthorities=t.connectionTokenQueryName=t.connectionTokenCookieName=t.Schemas=void 0,t.matchesScheme=w,t.matchesSomeScheme=u,t.getServerRootPath=v,i=qe(i),n=qe(n),N=qe(N);var b;(function(e){e.inMemory="inmemory",e.vscode="vscode",e.internal="private",e.walkThrough="walkThrough",e.walkThroughSnippet="walkThroughSnippet",e.http="http",e.https="https",e.file="file",e.mailto="mailto",e.untitled="untitled",e.data="data",e.command="command",e.vscodeRemote="vscode-remote",e.vscodeRemoteResource="vscode-remote-resource",e.vscodeManagedRemoteResource="vscode-managed-remote-resource",e.vscodeUserData="vscode-userdata",e.vscodeCustomEditor="vscode-custom-editor",e.vscodeNotebookCell="vscode-notebook-cell",e.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",e.vscodeNotebookCellMetadataDiff="vscode-notebook-cell-metadata-diff",e.vscodeNotebookCellOutput="vscode-notebook-cell-output",e.vscodeNotebookCellOutputDiff="vscode-notebook-cell-output-diff",e.vscodeNotebookMetadata="vscode-notebook-metadata",e.vscodeInteractiveInput="vscode-interactive-input",e.vscodeSettings="vscode-settings",e.vscodeWorkspaceTrust="vscode-workspace-trust",e.vscodeTerminal="vscode-terminal",e.vscodeChatCodeBlock="vscode-chat-code-block",e.vscodeChatCodeCompareBlock="vscode-chat-code-compare-block",e.vscodeChatSesssion="vscode-chat-editor",e.webviewPanel="webview-panel",e.vscodeWebview="vscode-webview",e.extension="extension",e.vscodeFileResource="vscode-file",e.tmp="tmp",e.vsls="vsls",e.vscodeSourceControl="vscode-scm",e.commentsInput="comment",e.codeSetting="code-setting",e.outputChannel="output"})(b||(t.Schemas=b={}));function w(e,s){return I.URI.isUri(e)?(0,O.equalsIgnoreCase)(e.scheme,s):(0,O.startsWithIgnoreCase)(e,s+":")}function u(e,...s){return s.some(r=>w(e,r))}t.connectionTokenCookieName="vscode-tkn",t.connectionTokenQueryName="tkn";class m{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._serverRootPath="/"}setPreferredWebSchema(s){this._preferredWebSchema=s}setDelegate(s){this._delegate=s}setServerRootPath(s,r){this._serverRootPath=v(s,r)}getServerRootPath(){return this._serverRootPath}get _remoteResourcesPath(){return N.posix.join(this._serverRootPath,b.vscodeRemoteResource)}set(s,r,l){this._hosts[s]=r,this._ports[s]=l}setConnectionToken(s,r){this._connectionTokens[s]=r}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(s){if(this._delegate)try{return this._delegate(s)}catch(L){return i.onUnexpectedError(L),s}const r=s.authority;let l=this._hosts[r];l&&l.indexOf(":")!==-1&&l.indexOf("[")===-1&&(l=`[${l}]`);const o=this._ports[r],p=this._connectionTokens[r];let A=`path=${encodeURIComponent(s.path)}`;return typeof p=="string"&&(A+=`&${t.connectionTokenQueryName}=${encodeURIComponent(p)}`),I.URI.from({scheme:n.isWeb?this._preferredWebSchema:b.vscodeRemoteResource,authority:`${l}:${o}`,path:this._remoteResourcesPath,query:A})}}t.RemoteAuthorities=new m;function v(e,s){return N.posix.join(s??"/",`${e.quality??"oss"}-${e.commit??"dev"}`)}t.builtinExtensionsPath="vs/../../extensions",t.nodeModulesPath="vs/../../node_modules",t.nodeModulesAsarPath="vs/../../node_modules.asar",t.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked",t.VSCODE_AUTHORITY="vscode-app";class g{static{this.FALLBACK_AUTHORITY=t.VSCODE_AUTHORITY}asBrowserUri(s){const r=this.toUri(s,ue);return this.uriToBrowserUri(r)}uriToBrowserUri(s){return s.scheme===b.vscodeRemote?t.RemoteAuthorities.rewrite(s):s.scheme===b.file&&(n.isNative||n.webWorkerOrigin===`${b.vscodeFileResource}://${g.FALLBACK_AUTHORITY}`)?s.with({scheme:b.vscodeFileResource,authority:s.authority||g.FALLBACK_AUTHORITY,query:null,fragment:null}):s}asFileUri(s){const r=this.toUri(s,ue);return this.uriToFileUri(r)}uriToFileUri(s){return s.scheme===b.vscodeFileResource?s.with({scheme:b.file,authority:s.authority!==g.FALLBACK_AUTHORITY?s.authority:null,query:null,fragment:null}):s}toUri(s,r){if(I.URI.isUri(s))return s;if(globalThis._VSCODE_FILE_ROOT){const l=globalThis._VSCODE_FILE_ROOT;if(/^\w[\w\d+.-]*:\/\//.test(l))return I.URI.joinPath(I.URI.parse(l,!0),s);const o=N.join(l,s);return I.URI.file(o)}return I.URI.parse(r.toUrl(s))}}t.FileAccess=new g;var d;(function(e){const s=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);e.CoopAndCoep=Object.freeze(s.get("3"));const r="vscode-coi";function l(p){let A;typeof p=="string"?A=new URL(p).searchParams:p instanceof URL?A=p.searchParams:I.URI.isUri(p)&&(A=new URL(p.toString(!0)).searchParams);const L=A?.get(r);if(L)return s.get(L)}e.getHeadersFromQuery=l;function o(p,A,L){if(!globalThis.crossOriginIsolated)return;const c=A&&L?"3":L?"2":"1";p instanceof URLSearchParams?p.set(r,c):p[r]=c}e.addSearchParam=o})(d||(t.COI=d={}))}),define(_e[51],Se([1,0,17,127,40,29,5,11,16]),function(ue,t,i,n,O,I,N,b,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DataUri=t.addTrailingPathSeparator=t.removeTrailingPathSeparator=t.hasTrailingPathSeparator=t.isEqualAuthority=t.isAbsolutePath=t.resolvePath=t.relativePath=t.normalizePath=t.joinPath=t.dirname=t.extname=t.basename=t.basenameOrAuthority=t.getComparisonKey=t.isEqualOrParent=t.isEqual=t.extUriIgnorePathCase=t.extUriBiasedIgnorePathCase=t.extUri=t.ExtUri=void 0,t.originalFSPath=u,t.distinctParents=v,t.toLocalResource=d,n=qe(n),I=qe(I);function u(e){return(0,w.uriToFsPath)(e,!0)}class m{constructor(s){this._ignorePathCasing=s}compare(s,r,l=!1){return s===r?0:(0,b.compare)(this.getComparisonKey(s,l),this.getComparisonKey(r,l))}isEqual(s,r,l=!1){return s===r?!0:!s||!r?!1:this.getComparisonKey(s,l)===this.getComparisonKey(r,l)}getComparisonKey(s,r=!1){return s.with({path:this._ignorePathCasing(s)?s.path.toLowerCase():void 0,fragment:r?null:void 0}).toString()}ignorePathCasing(s){return this._ignorePathCasing(s)}isEqualOrParent(s,r,l=!1){if(s.scheme===r.scheme){if(s.scheme===O.Schemas.file)return n.isEqualOrParent(u(s),u(r),this._ignorePathCasing(s))&&s.query===r.query&&(l||s.fragment===r.fragment);if((0,t.isEqualAuthority)(s.authority,r.authority))return n.isEqualOrParent(s.path,r.path,this._ignorePathCasing(s),"/")&&s.query===r.query&&(l||s.fragment===r.fragment)}return!1}joinPath(s,...r){return w.URI.joinPath(s,...r)}basenameOrAuthority(s){return(0,t.basename)(s)||s.authority}basename(s){return I.posix.basename(s.path)}extname(s){return I.posix.extname(s.path)}dirname(s){if(s.path.length===0)return s;let r;return s.scheme===O.Schemas.file?r=w.URI.file(I.dirname(u(s))).path:(r=I.posix.dirname(s.path),s.authority&&r.length&&r.charCodeAt(0)!==i.CharCode.Slash&&(console.error(`dirname("${s.toString})) resulted in a relative path`),r="/")),s.with({path:r})}normalizePath(s){if(!s.path.length)return s;let r;return s.scheme===O.Schemas.file?r=w.URI.file(I.normalize(u(s))).path:r=I.posix.normalize(s.path),s.with({path:r})}relativePath(s,r){if(s.scheme!==r.scheme||!(0,t.isEqualAuthority)(s.authority,r.authority))return;if(s.scheme===O.Schemas.file){const p=I.relative(u(s),u(r));return N.isWindows?n.toSlashes(p):p}let l=s.path||"/";const o=r.path||"/";if(this._ignorePathCasing(s)){let p=0;for(const A=Math.min(l.length,o.length);p<A&&!(l.charCodeAt(p)!==o.charCodeAt(p)&&l.charAt(p).toLowerCase()!==o.charAt(p).toLowerCase());p++);l=o.substr(0,p)+l.substr(p)}return I.posix.relative(l,o)}resolvePath(s,r){if(s.scheme===O.Schemas.file){const l=w.URI.file(I.resolve(u(s),r));return s.with({authority:l.authority,path:l.path})}return r=n.toPosixPath(r),s.with({path:I.posix.resolve(s.path,r)})}isAbsolutePath(s){return!!s.path&&s.path[0]==="/"}isEqualAuthority(s,r){return s===r||s!==void 0&&r!==void 0&&(0,b.equalsIgnoreCase)(s,r)}hasTrailingPathSeparator(s,r=I.sep){if(s.scheme===O.Schemas.file){const l=u(s);return l.length>n.getRoot(l).length&&l[l.length-1]===r}else{const l=s.path;return l.length>1&&l.charCodeAt(l.length-1)===i.CharCode.Slash&&!/^[a-zA-Z]:(\/$|\\$)/.test(s.fsPath)}}removeTrailingPathSeparator(s,r=I.sep){return(0,t.hasTrailingPathSeparator)(s,r)?s.with({path:s.path.substr(0,s.path.length-1)}):s}addTrailingPathSeparator(s,r=I.sep){let l=!1;if(s.scheme===O.Schemas.file){const o=u(s);l=o!==void 0&&o.length===n.getRoot(o).length&&o[o.length-1]===r}else{r="/";const o=s.path;l=o.length===1&&o.charCodeAt(o.length-1)===i.CharCode.Slash}return!l&&!(0,t.hasTrailingPathSeparator)(s,r)?s.with({path:s.path+"/"}):s}}t.ExtUri=m,t.extUri=new m(()=>!1),t.extUriBiasedIgnorePathCase=new m(e=>e.scheme===O.Schemas.file?!N.isLinux:!0),t.extUriIgnorePathCase=new m(e=>!0),t.isEqual=t.extUri.isEqual.bind(t.extUri),t.isEqualOrParent=t.extUri.isEqualOrParent.bind(t.extUri),t.getComparisonKey=t.extUri.getComparisonKey.bind(t.extUri),t.basenameOrAuthority=t.extUri.basenameOrAuthority.bind(t.extUri),t.basename=t.extUri.basename.bind(t.extUri),t.extname=t.extUri.extname.bind(t.extUri),t.dirname=t.extUri.dirname.bind(t.extUri),t.joinPath=t.extUri.joinPath.bind(t.extUri),t.normalizePath=t.extUri.normalizePath.bind(t.extUri),t.relativePath=t.extUri.relativePath.bind(t.extUri),t.resolvePath=t.extUri.resolvePath.bind(t.extUri),t.isAbsolutePath=t.extUri.isAbsolutePath.bind(t.extUri),t.isEqualAuthority=t.extUri.isEqualAuthority.bind(t.extUri),t.hasTrailingPathSeparator=t.extUri.hasTrailingPathSeparator.bind(t.extUri),t.removeTrailingPathSeparator=t.extUri.removeTrailingPathSeparator.bind(t.extUri),t.addTrailingPathSeparator=t.extUri.addTrailingPathSeparator.bind(t.extUri);function v(e,s){const r=[];for(let l=0;l<e.length;l++){const o=s(e[l]);e.some((p,A)=>A===l?!1:(0,t.isEqualOrParent)(o,s(p)))||r.push(e[l])}return r}var g;(function(e){e.META_DATA_LABEL="label",e.META_DATA_DESCRIPTION="description",e.META_DATA_SIZE="size",e.META_DATA_MIME="mime";function s(r){const l=new Map;r.path.substring(r.path.indexOf(";")+1,r.path.lastIndexOf(";")).split(";").forEach(A=>{const[L,c]=A.split(":");L&&c&&l.set(L,c)});const p=r.path.substring(0,r.path.indexOf(";"));return p&&l.set(e.META_DATA_MIME,p),l}e.parseMetaData=s})(g||(t.DataUri=g={}));function d(e,s,r){if(s){let l=e.path;return l&&l[0]!==I.posix.sep&&(l=I.posix.sep+l),e.with({scheme:r,authority:s,path:l})}return e.with({scheme:r})}}),define(_e[13],Se([1,0,38,6,3,2,51,5,63,25]),function(ue,t,i,n,O,I,N,b,w,u){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AsyncIterableSource=t.CancelableAsyncIterableObject=t.AsyncIterableObject=t.LazyStatefulPromise=t.StatefulPromise=t.Promises=t.DeferredPromise=t.IntervalCounter=t.TaskSequentializer=t.GlobalIdleValue=t.AbstractIdleValue=t._runWhenIdle=t.runWhenGlobalIdle=t.ThrottledWorker=t.RunOnceWorker=t.ProcessTimeRunOnceScheduler=t.RunOnceScheduler=t.IntervalTimer=t.TimeoutTimer=t.ResourceQueue=t.LimitedQueue=t.Queue=t.Limiter=t.AutoOpenBarrier=t.Barrier=t.ThrottledDelayer=t.Delayer=t.SequencerByKey=t.Sequencer=t.Throttler=void 0,t.isThenable=m,t.createCancelablePromise=v,t.raceCancellation=g,t.raceCancellationError=d,t.raceCancellablePromises=e,t.raceTimeout=s,t.asPromise=r,t.promiseWithResolvers=l,t.timeout=B,t.disposableTimeout=F,t.sequence=E,t.first=k,t.firstParallel=W,t.retry=ie,t.createCancelableAsyncIterable=oe;function m(h){return!!h&&typeof h.then=="function"}function v(h){const S=new i.CancellationTokenSource,P=h(S.token),G=new Promise((J,te)=>{const y=S.token.onCancellationRequested(()=>{y.dispose(),te(new n.CancellationError)});Promise.resolve(P).then(D=>{y.dispose(),S.dispose(),J(D)},D=>{y.dispose(),S.dispose(),te(D)})});return new class{cancel(){S.cancel(),S.dispose()}then(J,te){return G.then(J,te)}catch(J){return this.then(void 0,J)}finally(J){return G.finally(J)}}}function g(h,S,P){return new Promise((G,J)=>{const te=S.onCancellationRequested(()=>{te.dispose(),G(P)});h.then(G,J).finally(()=>te.dispose())})}function d(h,S){return new Promise((P,G)=>{const J=S.onCancellationRequested(()=>{J.dispose(),G(new n.CancellationError)});h.then(P,G).finally(()=>J.dispose())})}async function e(h){let S=-1;const P=h.map((G,J)=>G.then(te=>(S=J,te)));try{return await Promise.race(P)}finally{h.forEach((G,J)=>{J!==S&&G.cancel()})}}function s(h,S,P){let G;const J=setTimeout(()=>{G?.(void 0),P?.()},S);return Promise.race([h.finally(()=>clearTimeout(J)),new Promise(te=>G=te)])}function r(h){return new Promise((S,P)=>{const G=h();m(G)?G.then(S,P):S(G)})}function l(){let h,S;return{promise:new Promise((G,J)=>{h=G,S=J}),resolve:h,reject:S}}class o{constructor(){this.isDisposed=!1,this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(S){if(this.isDisposed)return Promise.reject(new Error("Throttler is disposed"));if(this.activePromise){if(this.queuedPromiseFactory=S,!this.queuedPromise){const P=()=>{if(this.queuedPromise=null,this.isDisposed)return;const G=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,G};this.queuedPromise=new Promise(G=>{this.activePromise.then(P,P).then(G)})}return new Promise((P,G)=>{this.queuedPromise.then(P,G)})}return this.activePromise=S(),new Promise((P,G)=>{this.activePromise.then(J=>{this.activePromise=null,P(J)},J=>{this.activePromise=null,G(J)})})}dispose(){this.isDisposed=!0}}t.Throttler=o;class p{constructor(){this.current=Promise.resolve(null)}queue(S){return this.current=this.current.then(()=>S(),()=>S())}}t.Sequencer=p;class A{constructor(){this.promiseMap=new Map}queue(S,P){const J=(this.promiseMap.get(S)??Promise.resolve()).catch(()=>{}).then(P).finally(()=>{this.promiseMap.get(S)===J&&this.promiseMap.delete(S)});return this.promiseMap.set(S,J),J}}t.SequencerByKey=A;const L=(h,S)=>{let P=!0;const G=setTimeout(()=>{P=!1,S()},h);return{isTriggered:()=>P,dispose:()=>{clearTimeout(G),P=!1}}},c=h=>{let S=!0;return queueMicrotask(()=>{S&&(S=!1,h())}),{isTriggered:()=>S,dispose:()=>{S=!1}}};class a{constructor(S){this.defaultDelay=S,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(S,P=this.defaultDelay){this.task=S,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((J,te)=>{this.doResolve=J,this.doReject=te}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const J=this.task;return this.task=null,J()}}));const G=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=P===w.MicrotaskDelay?c(G):L(P,G),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new n.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}t.Delayer=a;class f{constructor(S){this.delayer=new a(S),this.throttler=new o}trigger(S,P){return this.delayer.trigger(()=>this.throttler.queue(S),P)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose(),this.throttler.dispose()}}t.ThrottledDelayer=f;class _{constructor(){this._isOpen=!1,this._promise=new Promise((S,P)=>{this._completePromise=S})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}t.Barrier=_;class H extends _{constructor(S){super(),this._timeout=setTimeout(()=>this.open(),S)}open(){clearTimeout(this._timeout),super.open()}}t.AutoOpenBarrier=H;function B(h,S){return S?new Promise((P,G)=>{const J=setTimeout(()=>{te.dispose(),P()},h),te=S.onCancellationRequested(()=>{clearTimeout(J),te.dispose(),G(new n.CancellationError)})}):v(P=>B(h,P))}function F(h,S=0,P){const G=setTimeout(()=>{h(),P&&J.dispose()},S),J=(0,I.toDisposable)(()=>{clearTimeout(G),P?.deleteAndLeak(J)});return P?.add(J),J}function E(h){const S=[];let P=0;const G=h.length;function J(){return P<G?h[P++]():null}function te(y){y!=null&&S.push(y);const D=J();return D?D.then(te):Promise.resolve(S)}return Promise.resolve(null).then(te)}function k(h,S=G=>!!G,P=null){let G=0;const J=h.length,te=()=>{if(G>=J)return Promise.resolve(P);const y=h[G++];return Promise.resolve(y()).then(z=>S(z)?Promise.resolve(z):te())};return te()}function W(h,S=G=>!!G,P=null){if(h.length===0)return Promise.resolve(P);let G=h.length;const J=()=>{G=-1;for(const te of h)te.cancel?.()};return new Promise((te,y)=>{for(const D of h)D.then(z=>{--G>=0&&S(z)?(J(),te(z)):G===0&&te(P)}).catch(z=>{--G>=0&&(J(),y(z))})})}class R{constructor(S){this._size=0,this._isDisposed=!1,this.maxDegreeOfParalellism=S,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new O.Emitter}whenIdle(){return this.size>0?O.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(S){if(this._isDisposed)throw new Error("Object has been disposed");return this._size++,new Promise((P,G)=>{this.outstandingPromises.push({factory:S,c:P,e:G}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const S=this.outstandingPromises.shift();this.runningPromises++;const P=S.factory();P.then(S.c,S.e),P.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._isDisposed||(this.runningPromises--,--this._size===0&&this._onDrained.fire(),this.outstandingPromises.length>0&&this.consume())}clear(){if(this._isDisposed)throw new Error("Object has been disposed");this.outstandingPromises.length=0,this._size=this.runningPromises}dispose(){this._isDisposed=!0,this.outstandingPromises.length=0,this._size=0,this._onDrained.dispose()}}t.Limiter=R;class C extends R{constructor(){super(1)}}t.Queue=C;class ${constructor(){this.sequentializer=new fe,this.tasks=0}queue(S){return this.sequentializer.isRunning()?this.sequentializer.queue(()=>this.sequentializer.run(this.tasks++,S())):this.sequentializer.run(this.tasks++,S())}}t.LimitedQueue=$;class ee{constructor(){this.queues=new Map,this.drainers=new Set,this.drainListeners=void 0,this.drainListenerCount=0}async whenDrained(){if(this.isDrained())return;const S=new ne;return this.drainers.add(S),S.p}isDrained(){for(const[,S]of this.queues)if(S.size>0)return!1;return!0}queueSize(S,P=N.extUri){const G=P.getComparisonKey(S);return this.queues.get(G)?.size??0}queueFor(S,P,G=N.extUri){const J=G.getComparisonKey(S);let te=this.queues.get(J);if(!te){te=new C;const y=this.drainListenerCount++,D=O.Event.once(te.onDrained)(()=>{te?.dispose(),this.queues.delete(J),this.onDidQueueDrain(),this.drainListeners?.deleteAndDispose(y),this.drainListeners?.size===0&&(this.drainListeners.dispose(),this.drainListeners=void 0)});this.drainListeners||(this.drainListeners=new I.DisposableMap),this.drainListeners.set(y,D),this.queues.set(J,te)}return te.queue(P)}onDidQueueDrain(){this.isDrained()&&this.releaseDrainers()}releaseDrainers(){for(const S of this.drainers)S.complete();this.drainers.clear()}dispose(){for(const[,S]of this.queues)S.dispose();this.queues.clear(),this.releaseDrainers(),this.drainListeners?.dispose()}}t.ResourceQueue=ee;class Y{constructor(S,P){this._isDisposed=!1,this._token=-1,typeof S=="function"&&typeof P=="number"&&this.setIfNotSet(S,P)}dispose(){this.cancel(),this._isDisposed=!0}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(S,P){if(this._isDisposed)throw new n.BugIndicatingError("Calling 'cancelAndSet' on a disposed TimeoutTimer");this.cancel(),this._token=setTimeout(()=>{this._token=-1,S()},P)}setIfNotSet(S,P){if(this._isDisposed)throw new n.BugIndicatingError("Calling 'setIfNotSet' on a disposed TimeoutTimer");this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,S()},P))}}t.TimeoutTimer=Y;class Z{constructor(){this.disposable=void 0,this.isDisposed=!1}cancel(){this.disposable?.dispose(),this.disposable=void 0}cancelAndSet(S,P,G=globalThis){if(this.isDisposed)throw new n.BugIndicatingError("Calling 'cancelAndSet' on a disposed IntervalTimer");this.cancel();const J=G.setInterval(()=>{S()},P);this.disposable=(0,I.toDisposable)(()=>{G.clearInterval(J),this.disposable=void 0})}dispose(){this.cancel(),this.isDisposed=!0}}t.IntervalTimer=Z;class ce{constructor(S,P){this.timeoutToken=-1,this.runner=S,this.timeout=P,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(S=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,S)}get delay(){return this.timeout}set delay(S){this.timeout=S}isScheduled(){return this.timeoutToken!==-1}flush(){this.isScheduled()&&(this.cancel(),this.doRun())}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}t.RunOnceScheduler=ce;class he{constructor(S,P){P%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${P}ms is not a multiple of 1000ms.`),this.runner=S,this.timeout=P,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(S=this.timeout){S%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${S}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(S/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}t.ProcessTimeRunOnceScheduler=he;class ye extends ce{constructor(S,P){super(S,P),this.units=[]}work(S){this.units.push(S),this.isScheduled()||this.schedule()}doRun(){const S=this.units;this.units=[],this.runner?.(S)}dispose(){this.units=[],super.dispose()}}t.RunOnceWorker=ye;class Re extends I.Disposable{constructor(S,P){super(),this.options=S,this.handler=P,this.pendingWork=[],this.throttler=this._register(new I.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(S){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+S.length>this.options.maxBufferedWork)return!1}else if(this.pending+S.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}for(const P of S)this.pendingWork.push(P);return this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new ce(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}t.ThrottledWorker=Re,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?t._runWhenIdle=(h,S)=>{(0,b.setTimeout0)(()=>{if(P)return;const G=Date.now()+15;S(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,G-Date.now())}}))});let P=!1;return{dispose(){P||(P=!0)}}}:t._runWhenIdle=(h,S,P)=>{const G=h.requestIdleCallback(S,typeof P=="number"?{timeout:P}:void 0);let J=!1;return{dispose(){J||(J=!0,h.cancelIdleCallback(G))}}},t.runWhenGlobalIdle=h=>(0,t._runWhenIdle)(globalThis,h)}();class Pe{constructor(S,P){this._didRun=!1,this._executor=()=>{try{this._value=P()}catch(G){this._error=G}finally{this._didRun=!0}},this._handle=(0,t._runWhenIdle)(S,()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}t.AbstractIdleValue=Pe;class re extends Pe{constructor(S){super(globalThis,S)}}t.GlobalIdleValue=re;async function ie(h,S,P){let G;for(let J=0;J<P;J++)try{return await h()}catch(te){G=te,await B(S)}throw G}class fe{isRunning(S){return typeof S=="number"?this._running?.taskId===S:!!this._running}get running(){return this._running?.promise}cancelRunning(){this._running?.cancel()}run(S,P,G){return this._running={taskId:S,cancel:()=>G?.(),promise:P},P.then(()=>this.doneRunning(S),()=>this.doneRunning(S)),P}doneRunning(S){this._running&&S===this._running.taskId&&(this._running=void 0,this.runQueued())}runQueued(){if(this._queued){const S=this._queued;this._queued=void 0,S.run().then(S.promiseResolve,S.promiseReject)}}queue(S){if(this._queued)this._queued.run=S;else{const{promise:P,resolve:G,reject:J}=l();this._queued={run:S,promise:P,promiseResolve:G,promiseReject:J}}return this._queued.promise}hasQueued(){return!!this._queued}async join(){return this._queued?.promise??this._running?.promise}}t.TaskSequentializer=fe;class ve{constructor(S,P=()=>Date.now()){this.interval=S,this.nowFn=P,this.lastIncrementTime=0,this.value=0}increment(){const S=this.nowFn();return S-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=S,this.value=0),this.value++,this.value}}t.IntervalCounter=ve;var Ne;(function(h){h[h.Resolved=0]="Resolved",h[h.Rejected=1]="Rejected"})(Ne||(Ne={}));class ne{get isRejected(){return this.outcome?.outcome===Ne.Rejected}get isResolved(){return this.outcome?.outcome===Ne.Resolved}get isSettled(){return!!this.outcome}get value(){return this.outcome?.outcome===Ne.Resolved?this.outcome?.value:void 0}constructor(){this.p=new Promise((S,P)=>{this.completeCallback=S,this.errorCallback=P})}complete(S){return new Promise(P=>{this.completeCallback(S),this.outcome={outcome:Ne.Resolved,value:S},P()})}error(S){return new Promise(P=>{this.errorCallback(S),this.outcome={outcome:Ne.Rejected,value:S},P()})}cancel(){return this.error(new n.CancellationError)}}t.DeferredPromise=ne;var Ee;(function(h){async function S(G){let J;const te=await Promise.all(G.map(y=>y.then(D=>D,D=>{J||(J=D)})));if(typeof J<"u")throw J;return te}h.settled=S;function P(G){return new Promise(async(J,te)=>{try{await G(J,te)}catch(y){te(y)}})}h.withAsyncBody=P})(Ee||(t.Promises=Ee={}));class Le{get value(){return this._value}get error(){return this._error}get isResolved(){return this._isResolved}constructor(S){this._value=void 0,this._error=void 0,this._isResolved=!1,this.promise=S.then(P=>(this._value=P,this._isResolved=!0,P),P=>{throw this._error=P,this._isResolved=!0,P})}requireValue(){if(!this._isResolved)throw new n.BugIndicatingError("Promise is not resolved yet");if(this._error)throw this._error;return this._value}}t.StatefulPromise=Le;class Ce{constructor(S){this._compute=S,this._promise=new u.Lazy(()=>new Le(this._compute()))}requireValue(){return this._promise.value.requireValue()}getPromise(){return this._promise.value.promise}get currentValue(){return this._promise.rawValue?.value}}t.LazyStatefulPromise=Ce;var Fe;(function(h){h[h.Initial=0]="Initial",h[h.DoneOK=1]="DoneOK",h[h.DoneError=2]="DoneError"})(Fe||(Fe={}));class ze{static fromArray(S){return new ze(P=>{P.emitMany(S)})}static fromPromise(S){return new ze(async P=>{P.emitMany(await S)})}static fromPromises(S){return new ze(async P=>{await Promise.all(S.map(async G=>P.emitOne(await G)))})}static merge(S){return new ze(async P=>{await Promise.all(S.map(async G=>{for await(const J of G)P.emitOne(J)}))})}static{this.EMPTY=ze.fromArray([])}constructor(S,P){this._state=Fe.Initial,this._results=[],this._error=null,this._onReturn=P,this._onStateChanged=new O.Emitter,queueMicrotask(async()=>{const G={emitOne:J=>this.emitOne(J),emitMany:J=>this.emitMany(J),reject:J=>this.reject(J)};try{await Promise.resolve(S(G)),this.resolve()}catch(J){this.reject(J)}finally{G.emitOne=void 0,G.emitMany=void 0,G.reject=void 0}})}[Symbol.asyncIterator](){let S=0;return{next:async()=>{do{if(this._state===Fe.DoneError)throw this._error;if(S<this._results.length)return{done:!1,value:this._results[S++]};if(this._state===Fe.DoneOK)return{done:!0,value:void 0};await O.Event.toPromise(this._onStateChanged.event)}while(!0)},return:async()=>(this._onReturn?.(),{done:!0,value:void 0})}}static map(S,P){return new ze(async G=>{for await(const J of S)G.emitOne(P(J))})}map(S){return ze.map(this,S)}static filter(S,P){return new ze(async G=>{for await(const J of S)P(J)&&G.emitOne(J)})}filter(S){return ze.filter(this,S)}static coalesce(S){return ze.filter(S,P=>!!P)}coalesce(){return ze.coalesce(this)}static async toPromise(S){const P=[];for await(const G of S)P.push(G);return P}toPromise(){return ze.toPromise(this)}emitOne(S){this._state===Fe.Initial&&(this._results.push(S),this._onStateChanged.fire())}emitMany(S){this._state===Fe.Initial&&(this._results=this._results.concat(S),this._onStateChanged.fire())}resolve(){this._state===Fe.Initial&&(this._state=Fe.DoneOK,this._onStateChanged.fire())}reject(S){this._state===Fe.Initial&&(this._state=Fe.DoneError,this._error=S,this._onStateChanged.fire())}}t.AsyncIterableObject=ze;class Xe extends ze{constructor(S,P){super(P),this._source=S}cancel(){this._source.cancel()}}t.CancelableAsyncIterableObject=Xe;function oe(h){const S=new i.CancellationTokenSource,P=h(S.token);return new Xe(S,async G=>{const J=S.token.onCancellationRequested(()=>{J.dispose(),S.dispose(),G.reject(new n.CancellationError)});try{for await(const te of P){if(S.token.isCancellationRequested)return;G.emitOne(te)}J.dispose(),S.dispose()}catch(te){J.dispose(),S.dispose(),G.reject(te)}})}class x{constructor(S){this._deferred=new ne,this._asyncIterable=new ze(J=>{if(P){J.reject(P);return}return G&&J.emitMany(G),this._errorFn=te=>J.reject(te),this._emitFn=te=>J.emitOne(te),this._deferred.p},S);let P,G;this._emitFn=J=>{G||(G=[]),G.push(J)},this._errorFn=J=>{P||(P=J)}}get asyncIterable(){return this._asyncIterable}resolve(){this._deferred.complete()}reject(S){this._errorFn(S),this._deferred.complete()}emitOne(S){this._emitFn(S)}}t.AsyncIterableSource=x}),define(_e[4],Se([1,0,18,70,15,22,13,6,3,129,8,2,40,5,16,66,24,37]),function(ue,t,i,n,O,I,N,b,w,u,m,v,g,d,e,s,r,l){"use strict";var o;Object.defineProperty(t,"__esModule",{value:!0}),t.SafeTriangle=t.DragAndDropObserver=t.ModifierKeyEmitter=t.basicMarkupHtmlTags=t.DetectedFullscreenMode=t.Namespace=t.EventHelper=t.EventType=t.sharedMutationObserver=t.Dimension=t.WindowIntervalTimer=t.scheduleAtNextAnimationFrame=t.runAtThisOrScheduleAtNextAnimationFrame=t.WindowIdleValue=t.addStandardDisposableGenericMouseUpListener=t.addStandardDisposableGenericMouseDownListener=t.addStandardDisposableListener=t.onDidUnregisterWindow=t.onWillUnregisterWindow=t.onDidRegisterWindow=t.hasWindow=t.getWindowById=t.getWindowId=t.getWindowsCount=t.getWindows=t.getDocument=t.getWindow=t.registerWindow=void 0,t.clearNode=p,t.addDisposableListener=L,t.addDisposableGenericMouseDownListener=B,t.addDisposableGenericMouseMoveListener=F,t.addDisposableGenericMouseUpListener=E,t.runWhenWindowIdle=k,t.disposableWindowInterval=R,t.measure=ee,t.modify=Y,t.addDisposableThrottledListener=ye,t.getComputedStyle=Re,t.getClientArea=Pe,t.getTopLeftOffset=fe,t.size=ve,t.position=Ne,t.getDomNodePagePosition=ne,t.getDomNodeZoomLevel=Ee,t.getTotalWidth=Le,t.getContentWidth=Ce,t.getTotalScrollWidth=Fe,t.getContentHeight=ze,t.getTotalHeight=Xe,t.getLargestChildWidth=x,t.isAncestor=h,t.setParentFlowTo=P,t.isAncestorUsingFlowTo=J,t.findParentWithClass=te,t.hasParentWithClass=y,t.isShadowRoot=D,t.isInShadowDOM=z,t.getShadowRoot=V,t.getActiveElement=q,t.isActiveElement=se,t.isAncestorOfActiveElement=ae,t.isActiveDocument=ge,t.getActiveDocument=we,t.getActiveWindow=De,t.isGlobalStylesheet=Oe,t.createStyleSheet2=Ae,t.createStyleSheet=Ge,t.cloneGlobalStylesheets=it,t.createMetaElement=ft,t.createLinkElement=ht,t.createCSSRule=K,t.removeCSSRulesContainingSelector=Q,t.isHTMLElement=pe,t.isHTMLAnchorElement=Me,t.isHTMLSpanElement=xe,t.isHTMLTextAreaElement=Ke,t.isHTMLInputElement=Ye,t.isHTMLButtonElement=Qe,t.isHTMLDivElement=nt,t.isSVGElement=et,t.isMouseEvent=ut,t.isKeyboardEvent=Ve,t.isPointerEvent=me,t.isDragEvent=Be,t.isEventLike=Ue,t.saveParentsScrollTop=st,t.restoreParentsScrollTop=at,t.trackFocus=ot,t.after=bt,t.append=_t,t.prepend=kt,t.reset=Qt,t.$=ei,t.join=Pi,t.setVisibility=Ci,t.show=ti,t.hide=ii,t.removeTabIndexAndUpdateFocus=Bi,t.finalHandler=xi,t.domContentLoaded=Wi,t.computeScreenAwareSize=Hi,t.windowOpenNoOpener=zi,t.windowOpenPopup=Ui,t.windowOpenWithSuccess=Vi,t.animate=Ki,t.asCSSUrl=$i,t.asCSSPropertyValue=qi,t.asCssValueWithDefault=ri,t.triggerDownload=ji,t.triggerUpload=Gi,t.detectFullscreen=Yi,t.hookDomPurifyHrefAndSrcSanitizer=oi,t.safeInnerHtml=Qi,t.multibyteAwareBtoa=en,t.getCookieValue=tn,t.h=sn,t.svgElem=rn,t.copyAttributes=ai,t.trackAttributes=ln,i=qe(i),w=qe(w),u=qe(u),d=qe(d),o=function(){const U=new Map;(0,r.ensureCodeWindow)(r.mainWindow,1);const X={window:r.mainWindow,disposables:new v.DisposableStore};U.set(r.mainWindow.vscodeWindowId,X);const le=new w.Emitter,be=new w.Emitter,Ie=new w.Emitter;function $e(We,Je){return(typeof We=="number"?U.get(We):void 0)??(Je?X:void 0)}return{onDidRegisterWindow:le.event,onWillUnregisterWindow:Ie.event,onDidUnregisterWindow:be.event,registerWindow(We){if(U.has(We.vscodeWindowId))return v.Disposable.None;const Je=new v.DisposableStore,Ze={window:We,disposables:Je.add(new v.DisposableStore)};return U.set(We.vscodeWindowId,Ze),Je.add((0,v.toDisposable)(()=>{U.delete(We.vscodeWindowId),be.fire(We)})),Je.add(L(We,t.EventType.BEFORE_UNLOAD,()=>{Ie.fire(We)})),le.fire(Ze),Je},getWindows(){return U.values()},getWindowsCount(){return U.size},getWindowId(We){return We.vscodeWindowId},hasWindow(We){return U.has(We)},getWindowById:$e,getWindow(We){const Je=We;if(Je?.ownerDocument?.defaultView)return Je.ownerDocument.defaultView.window;const Ze=We;return Ze?.view?Ze.view.window:r.mainWindow},getDocument(We){const Je=We;return(0,t.getWindow)(Je).document}}}(),t.registerWindow=o.registerWindow,t.getWindow=o.getWindow,t.getDocument=o.getDocument,t.getWindows=o.getWindows,t.getWindowsCount=o.getWindowsCount,t.getWindowId=o.getWindowId,t.getWindowById=o.getWindowById,t.hasWindow=o.hasWindow,t.onDidRegisterWindow=o.onDidRegisterWindow,t.onWillUnregisterWindow=o.onWillUnregisterWindow,t.onDidUnregisterWindow=o.onDidUnregisterWindow;function p(U){for(;U.firstChild;)U.firstChild.remove()}class A{constructor(X,le,be,Ie){this._node=X,this._type=le,this._handler=be,this._options=Ie||!1,this._node.addEventListener(this._type,this._handler,this._options)}dispose(){this._handler&&(this._node.removeEventListener(this._type,this._handler,this._options),this._node=null,this._handler=null)}}function L(U,X,le,be){return new A(U,X,le,be)}function c(U,X){return function(le){return X(new I.StandardMouseEvent(U,le))}}function a(U){return function(X){return U(new O.StandardKeyboardEvent(X))}}const f=function(X,le,be,Ie){let $e=be;return le==="click"||le==="mousedown"||le==="contextmenu"?$e=c((0,t.getWindow)(X),be):(le==="keydown"||le==="keypress"||le==="keyup")&&($e=a(be)),L(X,le,$e,Ie)};t.addStandardDisposableListener=f;const _=function(X,le,be){const Ie=c((0,t.getWindow)(X),le);return B(X,Ie,be)};t.addStandardDisposableGenericMouseDownListener=_;const H=function(X,le,be){const Ie=c((0,t.getWindow)(X),le);return E(X,Ie,be)};t.addStandardDisposableGenericMouseUpListener=H;function B(U,X,le){return L(U,d.isIOS&&n.BrowserFeatures.pointerEvents?t.EventType.POINTER_DOWN:t.EventType.MOUSE_DOWN,X,le)}function F(U,X,le){return L(U,d.isIOS&&n.BrowserFeatures.pointerEvents?t.EventType.POINTER_MOVE:t.EventType.MOUSE_MOVE,X,le)}function E(U,X,le){return L(U,d.isIOS&&n.BrowserFeatures.pointerEvents?t.EventType.POINTER_UP:t.EventType.MOUSE_UP,X,le)}function k(U,X,le){return(0,N._runWhenIdle)(U,X,le)}class W extends N.AbstractIdleValue{constructor(X,le){super(X,le)}}t.WindowIdleValue=W;function R(U,X,le,be){let Ie=0;const $e=U.setInterval(()=>{Ie++,(typeof be=="number"&&Ie>=be||X()===!0)&&We.dispose()},le),We=(0,v.toDisposable)(()=>{U.clearInterval($e)});return We}class C extends N.IntervalTimer{constructor(X){super(),this.defaultTarget=X&&(0,t.getWindow)(X)}cancelAndSet(X,le,be){return super.cancelAndSet(X,le,be??this.defaultTarget)}}t.WindowIntervalTimer=C;class ${constructor(X,le=0){this._runner=X,this.priority=le,this._canceled=!1}dispose(){this._canceled=!0}execute(){if(!this._canceled)try{this._runner()}catch(X){(0,b.onUnexpectedError)(X)}}static sort(X,le){return le.priority-X.priority}}(function(){const U=new Map,X=new Map,le=new Map,be=new Map,Ie=$e=>{le.set($e,!1);const We=U.get($e)??[];for(X.set($e,We),U.set($e,[]),be.set($e,!0);We.length>0;)We.sort($.sort),We.shift().execute();be.set($e,!1)};t.scheduleAtNextAnimationFrame=($e,We,Je=0)=>{const Ze=(0,t.getWindowId)($e),je=new $(We,Je);let ct=U.get(Ze);return ct||(ct=[],U.set(Ze,ct)),ct.push(je),le.get(Ze)||(le.set(Ze,!0),$e.requestAnimationFrame(()=>Ie(Ze))),je},t.runAtThisOrScheduleAtNextAnimationFrame=($e,We,Je)=>{const Ze=(0,t.getWindowId)($e);if(be.get(Ze)){const je=new $(We,Je);let ct=X.get(Ze);return ct||(ct=[],X.set(Ze,ct)),ct.push(je),je}else return(0,t.scheduleAtNextAnimationFrame)($e,We,Je)}})();function ee(U,X){return(0,t.scheduleAtNextAnimationFrame)(U,X,1e4)}function Y(U,X){return(0,t.scheduleAtNextAnimationFrame)(U,X,-1e4)}const Z=8,ce=function(U,X){return X};class he extends v.Disposable{constructor(X,le,be,Ie=ce,$e=Z){super();let We=null,Je=0;const Ze=this._register(new N.TimeoutTimer),je=()=>{Je=new Date().getTime(),be(We),We=null};this._register(L(X,le,ct=>{We=Ie(We,ct);const Dt=new Date().getTime()-Je;Dt>=$e?(Ze.cancel(),je()):Ze.setIfNotSet(je,$e-Dt)}))}}function ye(U,X,le,be,Ie){return new he(U,X,le,be,Ie)}function Re(U){return(0,t.getWindow)(U).getComputedStyle(U,null)}function Pe(U,X){const le=(0,t.getWindow)(U),be=le.document;if(U!==be.body)return new ie(U.clientWidth,U.clientHeight);if(d.isIOS&&le?.visualViewport)return new ie(le.visualViewport.width,le.visualViewport.height);if(le?.innerWidth&&le.innerHeight)return new ie(le.innerWidth,le.innerHeight);if(be.body&&be.body.clientWidth&&be.body.clientHeight)return new ie(be.body.clientWidth,be.body.clientHeight);if(be.documentElement&&be.documentElement.clientWidth&&be.documentElement.clientHeight)return new ie(be.documentElement.clientWidth,be.documentElement.clientHeight);if(X)return Pe(X);throw new Error("Unable to figure out browser width and height")}class re{static convertToPixels(X,le){return parseFloat(le)||0}static getDimension(X,le,be){const Ie=Re(X),$e=Ie?Ie.getPropertyValue(le):"0";return re.convertToPixels(X,$e)}static getBorderLeftWidth(X){return re.getDimension(X,"border-left-width","borderLeftWidth")}static getBorderRightWidth(X){return re.getDimension(X,"border-right-width","borderRightWidth")}static getBorderTopWidth(X){return re.getDimension(X,"border-top-width","borderTopWidth")}static getBorderBottomWidth(X){return re.getDimension(X,"border-bottom-width","borderBottomWidth")}static getPaddingLeft(X){return re.getDimension(X,"padding-left","paddingLeft")}static getPaddingRight(X){return re.getDimension(X,"padding-right","paddingRight")}static getPaddingTop(X){return re.getDimension(X,"padding-top","paddingTop")}static getPaddingBottom(X){return re.getDimension(X,"padding-bottom","paddingBottom")}static getMarginLeft(X){return re.getDimension(X,"margin-left","marginLeft")}static getMarginTop(X){return re.getDimension(X,"margin-top","marginTop")}static getMarginRight(X){return re.getDimension(X,"margin-right","marginRight")}static getMarginBottom(X){return re.getDimension(X,"margin-bottom","marginBottom")}}class ie{static{this.None=new ie(0,0)}constructor(X,le){this.width=X,this.height=le}with(X=this.width,le=this.height){return X!==this.width||le!==this.height?new ie(X,le):this}static is(X){return typeof X=="object"&&typeof X.height=="number"&&typeof X.width=="number"}static lift(X){return X instanceof ie?X:new ie(X.width,X.height)}static equals(X,le){return X===le?!0:!X||!le?!1:X.width===le.width&&X.height===le.height}}t.Dimension=ie;function fe(U){let X=U.offsetParent,le=U.offsetTop,be=U.offsetLeft;for(;(U=U.parentNode)!==null&&U!==U.ownerDocument.body&&U!==U.ownerDocument.documentElement;){le-=U.scrollTop;const Ie=D(U)?null:Re(U);Ie&&(be-=Ie.direction!=="rtl"?U.scrollLeft:-U.scrollLeft),U===X&&(be+=re.getBorderLeftWidth(U),le+=re.getBorderTopWidth(U),le+=U.offsetTop,be+=U.offsetLeft,X=U.offsetParent)}return{left:be,top:le}}function ve(U,X,le){typeof X=="number"&&(U.style.width=`${X}px`),typeof le=="number"&&(U.style.height=`${le}px`)}function Ne(U,X,le,be,Ie,$e="absolute"){typeof X=="number"&&(U.style.top=`${X}px`),typeof le=="number"&&(U.style.right=`${le}px`),typeof be=="number"&&(U.style.bottom=`${be}px`),typeof Ie=="number"&&(U.style.left=`${Ie}px`),U.style.position=$e}function ne(U){const X=U.getBoundingClientRect(),le=(0,t.getWindow)(U);return{left:X.left+le.scrollX,top:X.top+le.scrollY,width:X.width,height:X.height}}function Ee(U){let X=U,le=1;do{const be=Re(X).zoom;be!=null&&be!=="1"&&(le*=be),X=X.parentElement}while(X!==null&&X!==X.ownerDocument.documentElement);return le}function Le(U){const X=re.getMarginLeft(U)+re.getMarginRight(U);return U.offsetWidth+X}function Ce(U){const X=re.getBorderLeftWidth(U)+re.getBorderRightWidth(U),le=re.getPaddingLeft(U)+re.getPaddingRight(U);return U.offsetWidth-X-le}function Fe(U){const X=re.getMarginLeft(U)+re.getMarginRight(U);return U.scrollWidth+X}function ze(U){const X=re.getBorderTopWidth(U)+re.getBorderBottomWidth(U),le=re.getPaddingTop(U)+re.getPaddingBottom(U);return U.offsetHeight-X-le}function Xe(U){const X=re.getMarginTop(U)+re.getMarginBottom(U);return U.offsetHeight+X}function oe(U,X){if(U===null)return 0;const le=fe(U),be=fe(X);return le.left-be.left}function x(U,X){const le=X.map(Ie=>Math.max(Fe(Ie),Le(Ie))+oe(Ie,U)||0);return Math.max(...le)}function h(U,X){return!!X?.contains(U)}const S="parentFlowToElementId";function P(U,X){U.dataset[S]=X.id}function G(U){const X=U.dataset[S];return typeof X=="string"?U.ownerDocument.getElementById(X):null}function J(U,X){let le=U;for(;le;){if(le===X)return!0;if(pe(le)){const be=G(le);if(be){le=be;continue}}le=le.parentNode}return!1}function te(U,X,le){for(;U&&U.nodeType===U.ELEMENT_NODE;){if(U.classList.contains(X))return U;if(le){if(typeof le=="string"){if(U.classList.contains(le))return null}else if(U===le)return null}U=U.parentNode}return null}function y(U,X,le){return!!te(U,X,le)}function D(U){return U&&!!U.host&&!!U.mode}function z(U){return!!V(U)}function V(U){for(;U.parentNode;){if(U===U.ownerDocument?.body)return null;U=U.parentNode}return D(U)?U:null}function q(){let U=we().activeElement;for(;U?.shadowRoot;)U=U.shadowRoot.activeElement;return U}function se(U){return q()===U}function ae(U){return h(q(),U)}function ge(U){return U.ownerDocument===we()}function we(){return(0,t.getWindowsCount)()<=1?r.mainWindow.document:Array.from((0,t.getWindows)()).map(({window:X})=>X.document).find(X=>X.hasFocus())??r.mainWindow.document}function De(){return we().defaultView?.window??r.mainWindow}const Te=new Map;function Oe(U){return Te.has(U)}function Ae(){return new ke}class ke{constructor(){this._currentCssStyle="",this._styleSheet=void 0}setStyle(X){X!==this._currentCssStyle&&(this._currentCssStyle=X,this._styleSheet?this._styleSheet.innerText=X:this._styleSheet=Ge(r.mainWindow.document.head,le=>le.innerText=X))}dispose(){this._styleSheet&&(this._styleSheet.remove(),this._styleSheet=void 0)}}function Ge(U=r.mainWindow.document.head,X,le){const be=document.createElement("style");if(be.type="text/css",be.media="screen",X?.(be),U.appendChild(be),le&&le.add((0,v.toDisposable)(()=>be.remove())),U===r.mainWindow.document.head){const Ie=new Set;Te.set(be,Ie);for(const{window:$e,disposables:We}of(0,t.getWindows)()){if($e===r.mainWindow)continue;const Je=We.add(rt(be,Ie,$e));le?.add(Je)}}return be}function it(U){const X=new v.DisposableStore;for(const[le,be]of Te)X.add(rt(le,be,U));return X}function rt(U,X,le){const be=new v.DisposableStore,Ie=U.cloneNode(!0);le.document.head.appendChild(Ie),be.add((0,v.toDisposable)(()=>Ie.remove()));for(const $e of M(U))Ie.sheet?.insertRule($e.cssText,Ie.sheet?.cssRules.length);return be.add(t.sharedMutationObserver.observe(U,be,{childList:!0})(()=>{Ie.textContent=U.textContent})),X.add(Ie),be.add((0,v.toDisposable)(()=>X.delete(Ie))),be}t.sharedMutationObserver=new class{constructor(){this.mutationObservers=new Map}observe(U,X,le){let be=this.mutationObservers.get(U);be||(be=new Map,this.mutationObservers.set(U,be));const Ie=(0,s.hash)(le);let $e=be.get(Ie);if($e)$e.users+=1;else{const We=new w.Emitter,Je=new MutationObserver(je=>We.fire(je));Je.observe(U,le);const Ze=$e={users:1,observer:Je,onDidMutate:We.event};X.add((0,v.toDisposable)(()=>{Ze.users-=1,Ze.users===0&&(We.dispose(),Je.disconnect(),be?.delete(Ie),be?.size===0&&this.mutationObservers.delete(U))})),be.set(Ie,$e)}return $e.onDidMutate}};function ft(U=r.mainWindow.document.head){return He("meta",U)}function ht(U=r.mainWindow.document.head){return He("link",U)}function He(U,X=r.mainWindow.document.head){const le=document.createElement(U);return X.appendChild(le),le}let j=null;function T(){return j||(j=Ge()),j}function M(U){return U?.sheet?.rules?U.sheet.rules:U?.sheet?.cssRules?U.sheet.cssRules:[]}function K(U,X,le=T()){if(!(!le||!X)){le.sheet?.insertRule(`${U} {${X}}`,0);for(const be of Te.get(le)??[])K(U,X,be)}}function Q(U,X=T()){if(!X)return;const le=M(X),be=[];for(let Ie=0;Ie<le.length;Ie++){const $e=le[Ie];de($e)&&$e.selectorText.indexOf(U)!==-1&&be.push(Ie)}for(let Ie=be.length-1;Ie>=0;Ie--)X.sheet?.deleteRule(be[Ie]);for(const Ie of Te.get(X)??[])Q(U,Ie)}function de(U){return typeof U.selectorText=="string"}function pe(U){return U instanceof HTMLElement||U instanceof(0,t.getWindow)(U).HTMLElement}function Me(U){return U instanceof HTMLAnchorElement||U instanceof(0,t.getWindow)(U).HTMLAnchorElement}function xe(U){return U instanceof HTMLSpanElement||U instanceof(0,t.getWindow)(U).HTMLSpanElement}function Ke(U){return U instanceof HTMLTextAreaElement||U instanceof(0,t.getWindow)(U).HTMLTextAreaElement}function Ye(U){return U instanceof HTMLInputElement||U instanceof(0,t.getWindow)(U).HTMLInputElement}function Qe(U){return U instanceof HTMLButtonElement||U instanceof(0,t.getWindow)(U).HTMLButtonElement}function nt(U){return U instanceof HTMLDivElement||U instanceof(0,t.getWindow)(U).HTMLDivElement}function et(U){return U instanceof SVGElement||U instanceof(0,t.getWindow)(U).SVGElement}function ut(U){return U instanceof MouseEvent||U instanceof(0,t.getWindow)(U).MouseEvent}function Ve(U){return U instanceof KeyboardEvent||U instanceof(0,t.getWindow)(U).KeyboardEvent}function me(U){return U instanceof PointerEvent||U instanceof(0,t.getWindow)(U).PointerEvent}function Be(U){return U instanceof DragEvent||U instanceof(0,t.getWindow)(U).DragEvent}t.EventType={CLICK:"click",AUXCLICK:"auxclick",DBLCLICK:"dblclick",MOUSE_UP:"mouseup",MOUSE_DOWN:"mousedown",MOUSE_OVER:"mouseover",MOUSE_MOVE:"mousemove",MOUSE_OUT:"mouseout",MOUSE_ENTER:"mouseenter",MOUSE_LEAVE:"mouseleave",MOUSE_WHEEL:"wheel",POINTER_UP:"pointerup",POINTER_DOWN:"pointerdown",POINTER_MOVE:"pointermove",POINTER_LEAVE:"pointerleave",CONTEXT_MENU:"contextmenu",WHEEL:"wheel",KEY_DOWN:"keydown",KEY_PRESS:"keypress",KEY_UP:"keyup",LOAD:"load",BEFORE_UNLOAD:"beforeunload",UNLOAD:"unload",PAGE_SHOW:"pageshow",PAGE_HIDE:"pagehide",PASTE:"paste",ABORT:"abort",ERROR:"error",RESIZE:"resize",SCROLL:"scroll",FULLSCREEN_CHANGE:"fullscreenchange",WK_FULLSCREEN_CHANGE:"webkitfullscreenchange",SELECT:"select",CHANGE:"change",SUBMIT:"submit",RESET:"reset",FOCUS:"focus",FOCUS_IN:"focusin",FOCUS_OUT:"focusout",BLUR:"blur",INPUT:"input",STORAGE:"storage",DRAG_START:"dragstart",DRAG:"drag",DRAG_ENTER:"dragenter",DRAG_LEAVE:"dragleave",DRAG_OVER:"dragover",DROP:"drop",DRAG_END:"dragend",ANIMATION_START:i.isWebKit?"webkitAnimationStart":"animationstart",ANIMATION_END:i.isWebKit?"webkitAnimationEnd":"animationend",ANIMATION_ITERATION:i.isWebKit?"webkitAnimationIteration":"animationiteration"};function Ue(U){const X=U;return!!(X&&typeof X.preventDefault=="function"&&typeof X.stopPropagation=="function")}t.EventHelper={stop:(U,X)=>(U.preventDefault(),X&&U.stopPropagation(),U)};function st(U){const X=[];for(let le=0;U&&U.nodeType===U.ELEMENT_NODE;le++)X[le]=U.scrollTop,U=U.parentNode;return X}function at(U,X){for(let le=0;U&&U.nodeType===U.ELEMENT_NODE;le++)U.scrollTop!==X[le]&&(U.scrollTop=X[le]),U=U.parentNode}class dt extends v.Disposable{static hasFocusWithin(X){if(pe(X)){const le=V(X),be=le?le.activeElement:X.ownerDocument.activeElement;return h(be,X)}else{const le=X;return h(le.document.activeElement,le.document)}}constructor(X){super(),this._onDidFocus=this._register(new w.Emitter),this.onDidFocus=this._onDidFocus.event,this._onDidBlur=this._register(new w.Emitter),this.onDidBlur=this._onDidBlur.event;let le=dt.hasFocusWithin(X),be=!1;const Ie=()=>{be=!1,le||(le=!0,this._onDidFocus.fire())},$e=()=>{le&&(be=!0,(pe(X)?(0,t.getWindow)(X):X).setTimeout(()=>{be&&(be=!1,le=!1,this._onDidBlur.fire())},0))};this._refreshStateHandler=()=>{dt.hasFocusWithin(X)!==le&&(le?$e():Ie())},this._register(L(X,t.EventType.FOCUS,Ie,!0)),this._register(L(X,t.EventType.BLUR,$e,!0)),pe(X)&&(this._register(L(X,t.EventType.FOCUS_IN,()=>this._refreshStateHandler())),this._register(L(X,t.EventType.FOCUS_OUT,()=>this._refreshStateHandler())))}refreshState(){this._refreshStateHandler()}}function ot(U){return new dt(U)}function bt(U,X){return U.after(X),X}function _t(U,...X){if(U.append(...X),X.length===1&&typeof X[0]!="string")return X[0]}function kt(U,X){return U.insertBefore(X,U.firstChild),X}function Qt(U,...X){U.innerText="",_t(U,...X)}const Mi=/([\w\-]+)?(#([\w\-]+))?((\.([\w\-]+))*)/;var Lt;(function(U){U.HTML="http://www.w3.org/1999/xhtml",U.SVG="http://www.w3.org/2000/svg"})(Lt||(t.Namespace=Lt={}));function Jt(U,X,le,...be){const Ie=Mi.exec(X);if(!Ie)throw new Error("Bad use of emmet");const $e=Ie[1]||"div";let We;return U!==Lt.HTML?We=document.createElementNS(U,$e):We=document.createElement($e),Ie[3]&&(We.id=Ie[3]),Ie[4]&&(We.className=Ie[4].replace(/\./g," ").trim()),le&&Object.entries(le).forEach(([Je,Ze])=>{typeof Ze>"u"||(/^on\w+$/.test(Je)?We[Je]=Ze:Je==="selected"?Ze&&We.setAttribute(Je,"true"):We.setAttribute(Je,Ze))}),We.append(...be),We}function ei(U,X,...le){return Jt(Lt.HTML,U,X,...le)}ei.SVG=function(U,X,...le){return Jt(Lt.SVG,U,X,...le)};function Pi(U,X){const le=[];return U.forEach((be,Ie)=>{Ie>0&&(X instanceof Node?le.push(X.cloneNode()):le.push(document.createTextNode(X))),le.push(be)}),le}function Ci(U,...X){U?ti(...X):ii(...X)}function ti(...U){for(const X of U)X.style.display="",X.removeAttribute("aria-hidden")}function ii(...U){for(const X of U)X.style.display="none",X.setAttribute("aria-hidden","true")}function Fi(U,X){for(;U&&U.nodeType===U.ELEMENT_NODE;){if(pe(U)&&U.hasAttribute(X))return U;U=U.parentNode}return null}function Bi(U){!U||!U.hasAttribute("tabIndex")||(U.ownerDocument.activeElement===U&&Fi(U.parentElement,"tabIndex")?.focus(),U.removeAttribute("tabindex"))}function xi(U){return X=>{X.preventDefault(),X.stopPropagation(),U(X)}}function Wi(U){return new Promise(X=>{if(U.document.readyState==="complete"||U.document&&U.document.body!==null)X(void 0);else{const be=()=>{U.window.removeEventListener("DOMContentLoaded",be,!1),X()};U.window.addEventListener("DOMContentLoaded",be,!1)}})}function Hi(U,X){const le=U.devicePixelRatio*X;return Math.max(1,Math.floor(le))/U.devicePixelRatio}function zi(U){r.mainWindow.open(U,"_blank","noopener")}const ni=780,si=640;function Ui(U){const X=Math.floor(r.mainWindow.screenLeft+r.mainWindow.innerWidth/2-ni/2),le=Math.floor(r.mainWindow.screenTop+r.mainWindow.innerHeight/2-si/2);r.mainWindow.open(U,"_blank",`width=${ni},height=${si},top=${le},left=${X}`)}function Vi(U,X=!0){const le=r.mainWindow.open();return le?(X&&(le.opener=null),le.location.href=U,!0):!1}function Ki(U,X){const le=()=>{X(),be=(0,t.scheduleAtNextAnimationFrame)(U,le)};let be=(0,t.scheduleAtNextAnimationFrame)(U,le);return(0,v.toDisposable)(()=>be.dispose())}g.RemoteAuthorities.setPreferredWebSchema(/^https:/.test(r.mainWindow.location.href)?"https":"http");function $i(U){return U?`url('${g.FileAccess.uriToBrowserUri(U).toString(!0).replace(/'/g,"%27")}')`:"url('')"}function qi(U){return`'${U.replace(/'/g,"%27")}'`}function ri(U,X){if(U!==void 0){const le=U.match(/^\s*var\((.+)\)$/);if(le){const be=le[1].split(",",2);return be.length===2&&(X=ri(be[1].trim(),X)),`var(${be[0]}, ${X})`}return U}return X}function ji(U,X){let le;if(e.URI.isUri(U))le=U.toString(!0);else{const $e=new Blob([U]);le=URL.createObjectURL($e),setTimeout(()=>URL.revokeObjectURL(le))}const be=De(),Ie=document.createElement("a");be.document.body.appendChild(Ie),Ie.download=X,Ie.href=le,Ie.click(),setTimeout(()=>Ie.remove())}function Gi(){return new Promise(U=>{const X=De(),le=document.createElement("input");X.document.body.appendChild(le),le.type="file",le.multiple=!0,w.Event.once(w.Event.fromDOMEventEmitter(le,"input"))(()=>{U(le.files??void 0)}),le.click(),setTimeout(()=>le.remove())})}var It;(function(U){U[U.DOCUMENT=1]="DOCUMENT",U[U.BROWSER=2]="BROWSER"})(It||(t.DetectedFullscreenMode=It={}));function Yi(U){return U.document.fullscreenElement||U.document.webkitFullscreenElement||U.document.webkitIsFullScreen?{mode:It.DOCUMENT,guess:!1}:U.innerHeight===U.screen.height?{mode:It.BROWSER,guess:!1}:(d.isMacintosh||d.isLinux)&&U.outerHeight===U.screen.height&&U.outerWidth===U.screen.width?{mode:It.BROWSER,guess:!0}:null}function oi(U,X=!1){const le=document.createElement("a");return u.addHook("afterSanitizeAttributes",be=>{for(const Ie of["href","src"])if(be.hasAttribute(Ie)){const $e=be.getAttribute(Ie);if(Ie==="href"&&$e.startsWith("#"))continue;if(le.href=$e,!U.includes(le.protocol.replace(/:$/,""))){if(X&&Ie==="src"&&le.href.startsWith("data:"))continue;be.removeAttribute(Ie)}}}),(0,v.toDisposable)(()=>{u.removeHook("afterSanitizeAttributes")})}const Xi=[g.Schemas.http,g.Schemas.https,g.Schemas.command];t.basicMarkupHtmlTags=Object.freeze(["a","abbr","b","bdo","blockquote","br","caption","cite","code","col","colgroup","dd","del","details","dfn","div","dl","dt","em","figcaption","figure","h1","h2","h3","h4","h5","h6","hr","i","img","input","ins","kbd","label","li","mark","ol","p","pre","q","rp","rt","ruby","samp","small","small","source","span","strike","strong","sub","summary","sup","table","tbody","td","tfoot","th","thead","time","tr","tt","u","ul","var","video","wbr"]);const Zi=Object.freeze({ALLOWED_TAGS:["a","button","blockquote","code","div","h1","h2","h3","h4","h5","h6","hr","input","label","li","p","pre","select","small","span","strong","textarea","ul","ol"],ALLOWED_ATTR:["href","data-href","data-command","target","title","name","src","alt","class","id","role","tabindex","style","data-code","width","height","align","x-dispatch","required","checked","placeholder","type","start"],RETURN_DOM:!1,RETURN_DOM_FRAGMENT:!1,RETURN_TRUSTED_TYPE:!0});function Qi(U,X){const le=oi(Xi);try{const be=u.sanitize(X,Zi);U.innerHTML=be}finally{le.dispose()}}function Ji(U){const X=new Uint16Array(U.length);for(let Ie=0;Ie<X.length;Ie++)X[Ie]=U.charCodeAt(Ie);let le="";const be=new Uint8Array(X.buffer);for(let Ie=0;Ie<be.length;Ie++)le+=String.fromCharCode(be[Ie]);return le}function en(U){return btoa(Ji(U))}class St extends w.Emitter{constructor(){super(),this._subscriptions=new v.DisposableStore,this._keyStatus={altKey:!1,shiftKey:!1,ctrlKey:!1,metaKey:!1},this._subscriptions.add(w.Event.runAndSubscribe(t.onDidRegisterWindow,({window:X,disposables:le})=>this.registerListeners(X,le),{window:r.mainWindow,disposables:this._subscriptions}))}registerListeners(X,le){le.add(L(X,"keydown",be=>{if(be.defaultPrevented)return;const Ie=new O.StandardKeyboardEvent(be);if(!(Ie.keyCode===m.KeyCode.Alt&&be.repeat)){if(be.altKey&&!this._keyStatus.altKey)this._keyStatus.lastKeyPressed="alt";else if(be.ctrlKey&&!this._keyStatus.ctrlKey)this._keyStatus.lastKeyPressed="ctrl";else if(be.metaKey&&!this._keyStatus.metaKey)this._keyStatus.lastKeyPressed="meta";else if(be.shiftKey&&!this._keyStatus.shiftKey)this._keyStatus.lastKeyPressed="shift";else if(Ie.keyCode!==m.KeyCode.Alt)this._keyStatus.lastKeyPressed=void 0;else return;this._keyStatus.altKey=be.altKey,this._keyStatus.ctrlKey=be.ctrlKey,this._keyStatus.metaKey=be.metaKey,this._keyStatus.shiftKey=be.shiftKey,this._keyStatus.lastKeyPressed&&(this._keyStatus.event=be,this.fire(this._keyStatus))}},!0)),le.add(L(X,"keyup",be=>{be.defaultPrevented||(!be.altKey&&this._keyStatus.altKey?this._keyStatus.lastKeyReleased="alt":!be.ctrlKey&&this._keyStatus.ctrlKey?this._keyStatus.lastKeyReleased="ctrl":!be.metaKey&&this._keyStatus.metaKey?this._keyStatus.lastKeyReleased="meta":!be.shiftKey&&this._keyStatus.shiftKey?this._keyStatus.lastKeyReleased="shift":this._keyStatus.lastKeyReleased=void 0,this._keyStatus.lastKeyPressed!==this._keyStatus.lastKeyReleased&&(this._keyStatus.lastKeyPressed=void 0),this._keyStatus.altKey=be.altKey,this._keyStatus.ctrlKey=be.ctrlKey,this._keyStatus.metaKey=be.metaKey,this._keyStatus.shiftKey=be.shiftKey,this._keyStatus.lastKeyReleased&&(this._keyStatus.event=be,this.fire(this._keyStatus)))},!0)),le.add(L(X.document.body,"mousedown",()=>{this._keyStatus.lastKeyPressed=void 0},!0)),le.add(L(X.document.body,"mouseup",()=>{this._keyStatus.lastKeyPressed=void 0},!0)),le.add(L(X.document.body,"mousemove",be=>{be.buttons&&(this._keyStatus.lastKeyPressed=void 0)},!0)),le.add(L(X,"blur",()=>{this.resetKeyStatus()}))}get keyStatus(){return this._keyStatus}get isModifierPressed(){return this._keyStatus.altKey||this._keyStatus.ctrlKey||this._keyStatus.metaKey||this._keyStatus.shiftKey}resetKeyStatus(){this.doResetKeyStatus(),this.fire(this._keyStatus)}doResetKeyStatus(){this._keyStatus={altKey:!1,shiftKey:!1,ctrlKey:!1,metaKey:!1}}static getInstance(){return St.instance||(St.instance=new St),St.instance}dispose(){super.dispose(),this._subscriptions.dispose()}}t.ModifierKeyEmitter=St;function tn(U){const X=document.cookie.match("(^|[^;]+)\\s*"+U+"\\s*=\\s*([^;]+)");return X?X.pop():void 0}class nn extends v.Disposable{constructor(X,le){super(),this.element=X,this.callbacks=le,this.counter=0,this.dragStartTime=0,this.registerListeners()}registerListeners(){this.callbacks.onDragStart&&this._register(L(this.element,t.EventType.DRAG_START,X=>{this.callbacks.onDragStart?.(X)})),this.callbacks.onDrag&&this._register(L(this.element,t.EventType.DRAG,X=>{this.callbacks.onDrag?.(X)})),this._register(L(this.element,t.EventType.DRAG_ENTER,X=>{this.counter++,this.dragStartTime=X.timeStamp,this.callbacks.onDragEnter?.(X)})),this._register(L(this.element,t.EventType.DRAG_OVER,X=>{X.preventDefault(),this.callbacks.onDragOver?.(X,X.timeStamp-this.dragStartTime)})),this._register(L(this.element,t.EventType.DRAG_LEAVE,X=>{this.counter--,this.counter===0&&(this.dragStartTime=0,this.callbacks.onDragLeave?.(X))})),this._register(L(this.element,t.EventType.DRAG_END,X=>{this.counter=0,this.dragStartTime=0,this.callbacks.onDragEnd?.(X)})),this._register(L(this.element,t.EventType.DROP,X=>{this.counter=0,this.dragStartTime=0,this.callbacks.onDrop?.(X)}))}}t.DragAndDropObserver=nn;const li=/(?<tag>[\w\-]+)?(?:#(?<id>[\w\-]+))?(?<class>(?:\.(?:[\w\-]+))*)(?:@(?<name>(?:[\w\_])+))?/;function sn(U,...X){let le,be;Array.isArray(X[0])?(le={},be=X[0]):(le=X[0]||{},be=X[1]);const Ie=li.exec(U);if(!Ie||!Ie.groups)throw new Error("Bad use of h");const $e=Ie.groups.tag||"div",We=document.createElement($e);Ie.groups.id&&(We.id=Ie.groups.id);const Je=[];if(Ie.groups.class)for(const je of Ie.groups.class.split("."))je!==""&&Je.push(je);if(le.className!==void 0)for(const je of le.className.split("."))je!==""&&Je.push(je);Je.length>0&&(We.className=Je.join(" "));const Ze={};if(Ie.groups.name&&(Ze[Ie.groups.name]=We),be)for(const je of be)pe(je)?We.appendChild(je):typeof je=="string"?We.append(je):"root"in je&&(Object.assign(Ze,je),We.appendChild(je.root));for(const[je,ct]of Object.entries(le))if(je!=="className")if(je==="style")for(const[Dt,yt]of Object.entries(ct))We.style.setProperty(Mt(Dt),typeof yt=="number"?yt+"px":""+yt);else je==="tabIndex"?We.tabIndex=ct:We.setAttribute(Mt(je),ct.toString());return Ze.root=We,Ze}function rn(U,...X){let le,be;Array.isArray(X[0])?(le={},be=X[0]):(le=X[0]||{},be=X[1]);const Ie=li.exec(U);if(!Ie||!Ie.groups)throw new Error("Bad use of h");const $e=Ie.groups.tag||"div",We=document.createElementNS("http://www.w3.org/2000/svg",$e);Ie.groups.id&&(We.id=Ie.groups.id);const Je=[];if(Ie.groups.class)for(const je of Ie.groups.class.split("."))je!==""&&Je.push(je);if(le.className!==void 0)for(const je of le.className.split("."))je!==""&&Je.push(je);Je.length>0&&(We.className=Je.join(" "));const Ze={};if(Ie.groups.name&&(Ze[Ie.groups.name]=We),be)for(const je of be)pe(je)?We.appendChild(je):typeof je=="string"?We.append(je):"root"in je&&(Object.assign(Ze,je),We.appendChild(je.root));for(const[je,ct]of Object.entries(le))if(je!=="className")if(je==="style")for(const[Dt,yt]of Object.entries(ct))We.style.setProperty(Mt(Dt),typeof yt=="number"?yt+"px":""+yt);else je==="tabIndex"?We.tabIndex=ct:We.setAttribute(Mt(je),ct.toString());return Ze.root=We,Ze}function Mt(U){return U.replace(/([a-z])([A-Z])/g,"$1-$2").toLowerCase()}function ai(U,X,le){for(const{name:be,value:Ie}of U.attributes)(!le||le.includes(be))&&X.setAttribute(be,Ie)}function on(U,X,le){const be=U.getAttribute(le);be?X.setAttribute(le,be):X.removeAttribute(le)}function ln(U,X,le){ai(U,X,le);const be=new v.DisposableStore;return be.add(t.sharedMutationObserver.observe(U,be,{attributes:!0,attributeFilter:le})(Ie=>{for(const $e of Ie)$e.type==="attributes"&&$e.attributeName&&on(U,X,$e.attributeName)})),be}class an{constructor(X,le,be){this.originX=X,this.originY=le,this.points=new Int16Array(8);const{top:Ie,left:$e,right:We,bottom:Je}=be.getBoundingClientRect(),Ze=this.points;let je=0;Ze[je++]=$e,Ze[je++]=Ie,Ze[je++]=We,Ze[je++]=Ie,Ze[je++]=$e,Ze[je++]=Je,Ze[je++]=We,Ze[je++]=Je}contains(X,le){const{points:be,originX:Ie,originY:$e}=this;for(let We=0;We<4;We++){const Je=2*We,Ze=2*((We+1)%4);if((0,l.isPointWithinTriangle)(X,le,Ie,$e,be[Je],be[Je+1],be[Ze],be[Ze+1]))return!0}return!1}}t.SafeTriangle=an}),define(_e[72],Se([1,0,4,2,128]),function(ue,t,i,n,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DataTransfers=t.DelayedDragHandler=void 0,t.applyDragImage=N;class I extends n.Disposable{constructor(w,u){super(),this._register((0,i.addDisposableListener)(w,"dragover",m=>{m.preventDefault(),this.timeout||(this.timeout=setTimeout(()=>{u(),this.timeout=null},800))})),["dragleave","drop","dragend"].forEach(m=>{this._register((0,i.addDisposableListener)(w,m,()=>{this.clearDragTimeout()}))})}clearDragTimeout(){this.timeout&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){super.dispose(),this.clearDragTimeout()}}t.DelayedDragHandler=I,t.DataTransfers={RESOURCES:"ResourceURLs",DOWNLOAD_URL:"DownloadURL",FILES:"Files",TEXT:O.Mimes.text,INTERNAL_URI_LIST:"application/vnd.code.uri-list"};function N(b,w,u,m,v){const g=document.createElement("div");g.className=u,g.textContent=w,v&&(g.style.color=v),m&&(g.style.background=m),b.dataTransfer&&((0,i.getWindow)(b).document.body.appendChild(g),b.dataTransfer.setDragImage(g,-10,-10),setTimeout(()=>g.remove(),0))}}),define(_e[73],Se([1,0,4]),function(ue,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.renderText=n,t.renderFormattedText=O,t.createElement=I,i=qe(i);function n(g,d={}){const e=I(d);return e.textContent=g,e}function O(g,d={}){const e=I(d);return w(e,u(g,!!d.renderCodeSegments),d.actionHandler,d.renderCodeSegments),e}function I(g){const d=g.inline?"span":"div",e=document.createElement(d);return g.className&&(e.className=g.className),e}class N{constructor(d){this.source=d,this.index=0}eos(){return this.index>=this.source.length}next(){const d=this.peek();return this.advance(),d}peek(){return this.source[this.index]}advance(){this.index++}}var b;(function(g){g[g.Invalid=0]="Invalid",g[g.Root=1]="Root",g[g.Text=2]="Text",g[g.Bold=3]="Bold",g[g.Italics=4]="Italics",g[g.Action=5]="Action",g[g.ActionClose=6]="ActionClose",g[g.Code=7]="Code",g[g.NewLine=8]="NewLine"})(b||(b={}));function w(g,d,e,s){let r;if(d.type===b.Text)r=document.createTextNode(d.content||"");else if(d.type===b.Bold)r=document.createElement("b");else if(d.type===b.Italics)r=document.createElement("i");else if(d.type===b.Code&&s)r=document.createElement("code");else if(d.type===b.Action&&e){const l=document.createElement("a");e.disposables.add(i.addStandardDisposableListener(l,"click",o=>{e.callback(String(d.index),o)})),r=l}else d.type===b.NewLine?r=document.createElement("br"):d.type===b.Root&&(r=g);r&&g!==r&&g.appendChild(r),r&&Array.isArray(d.children)&&d.children.forEach(l=>{w(r,l,e,s)})}function u(g,d){const e={type:b.Root,children:[]};let s=0,r=e;const l=[],o=new N(g);for(;!o.eos();){let p=o.next();const A=p==="\\"&&v(o.peek(),d)!==b.Invalid;if(A&&(p=o.next()),!A&&m(p,d)&&p===o.peek()){o.advance(),r.type===b.Text&&(r=l.pop());const L=v(p,d);if(r.type===L||r.type===b.Action&&L===b.ActionClose)r=l.pop();else{const c={type:L,children:[]};L===b.Action&&(c.index=s,s++),r.children.push(c),l.push(r),r=c}}else if(p===`
`)r.type===b.Text&&(r=l.pop()),r.children.push({type:b.NewLine});else if(r.type!==b.Text){const L={type:b.Text,content:p};r.children.push(L),l.push(r),r=L}else r.content+=p}return r.type===b.Text&&(r=l.pop()),l.length,e}function m(g,d){return v(g,d)!==b.Invalid}function v(g,d){switch(g){case"*":return b.Bold;case"_":return b.Italics;case"[":return b.Action;case"]":return b.ActionClose;case"`":return d?b.Code:b.Invalid;default:return b.Invalid}}}),define(_e[74],Se([1,0,4,2]),function(ue,t,i,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.GlobalPointerMoveMonitor=void 0,i=qe(i);class O{constructor(){this._hooks=new n.DisposableStore,this._pointerMoveCallback=null,this._onStopCallback=null}dispose(){this.stopMonitoring(!1),this._hooks.dispose()}stopMonitoring(N,b){if(!this.isMonitoring())return;this._hooks.clear(),this._pointerMoveCallback=null;const w=this._onStopCallback;this._onStopCallback=null,N&&w&&w(b)}isMonitoring(){return!!this._pointerMoveCallback}startMonitoring(N,b,w,u,m){this.isMonitoring()&&this.stopMonitoring(!1),this._pointerMoveCallback=u,this._onStopCallback=m;let v=N;try{N.setPointerCapture(b),this._hooks.add((0,n.toDisposable)(()=>{try{N.releasePointerCapture(b)}catch{}}))}catch{v=i.getWindow(N)}this._hooks.add(i.addDisposableListener(v,i.EventType.POINTER_MOVE,g=>{if(g.buttons!==w){this.stopMonitoring(!0);return}g.preventDefault(),this._pointerMoveCallback(g)})),this._hooks.add(i.addDisposableListener(v,i.EventType.POINTER_UP,g=>this.stopMonitoring(!0)))}}t.GlobalPointerMoveMonitor=O});var lt=this&&this.__decorate||function(ue,t,i,n){var O=arguments.length,I=O<3?t:n===null?n=Object.getOwnPropertyDescriptor(t,i):n,N;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")I=Reflect.decorate(ue,t,i,n);else for(var b=ue.length-1;b>=0;b--)(N=ue[b])&&(I=(O<3?N(I):O>3?N(t,i,I):N(t,i))||I);return O>3&&I&&Object.defineProperty(t,i,I),I};define(_e[32],Se([1,0,4,24,9,35,3,2,60]),function(ue,t,i,n,O,I,N,b,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Gesture=t.EventType=void 0,i=qe(i),O=qe(O);var u;(function(v){v.Tap="-monaco-gesturetap",v.Change="-monaco-gesturechange",v.Start="-monaco-gesturestart",v.End="-monaco-gesturesend",v.Contextmenu="-monaco-gesturecontextmenu"})(u||(t.EventType=u={}));class m extends b.Disposable{static{this.SCROLL_FRICTION=-.005}static{this.HOLD_DELAY=700}static{this.CLEAR_TAP_COUNT_TIME=400}constructor(){super(),this.dispatched=!1,this.targets=new w.LinkedList,this.ignoreTargets=new w.LinkedList,this.activeTouches={},this.handle=null,this._lastSetTapCountTime=0,this._register(N.Event.runAndSubscribe(i.onDidRegisterWindow,({window:g,disposables:d})=>{d.add(i.addDisposableListener(g.document,"touchstart",e=>this.onTouchStart(e),{passive:!1})),d.add(i.addDisposableListener(g.document,"touchend",e=>this.onTouchEnd(g,e))),d.add(i.addDisposableListener(g.document,"touchmove",e=>this.onTouchMove(e),{passive:!1}))},{window:n.mainWindow,disposables:this._store}))}static addTarget(g){if(!m.isTouchDevice())return b.Disposable.None;m.INSTANCE||(m.INSTANCE=(0,b.markAsSingleton)(new m));const d=m.INSTANCE.targets.push(g);return(0,b.toDisposable)(d)}static ignoreTarget(g){if(!m.isTouchDevice())return b.Disposable.None;m.INSTANCE||(m.INSTANCE=(0,b.markAsSingleton)(new m));const d=m.INSTANCE.ignoreTargets.push(g);return(0,b.toDisposable)(d)}static isTouchDevice(){return"ontouchstart"in n.mainWindow||navigator.maxTouchPoints>0}dispose(){this.handle&&(this.handle.dispose(),this.handle=null),super.dispose()}onTouchStart(g){const d=Date.now();this.handle&&(this.handle.dispose(),this.handle=null);for(let e=0,s=g.targetTouches.length;e<s;e++){const r=g.targetTouches.item(e);this.activeTouches[r.identifier]={id:r.identifier,initialTarget:r.target,initialTimeStamp:d,initialPageX:r.pageX,initialPageY:r.pageY,rollingTimestamps:[d],rollingPageX:[r.pageX],rollingPageY:[r.pageY]};const l=this.newGestureEvent(u.Start,r.target);l.pageX=r.pageX,l.pageY=r.pageY,this.dispatchEvent(l)}this.dispatched&&(g.preventDefault(),g.stopPropagation(),this.dispatched=!1)}onTouchEnd(g,d){const e=Date.now(),s=Object.keys(this.activeTouches).length;for(let r=0,l=d.changedTouches.length;r<l;r++){const o=d.changedTouches.item(r);if(!this.activeTouches.hasOwnProperty(String(o.identifier))){console.warn("move of an UNKNOWN touch",o);continue}const p=this.activeTouches[o.identifier],A=Date.now()-p.initialTimeStamp;if(A<m.HOLD_DELAY&&Math.abs(p.initialPageX-O.tail(p.rollingPageX))<30&&Math.abs(p.initialPageY-O.tail(p.rollingPageY))<30){const L=this.newGestureEvent(u.Tap,p.initialTarget);L.pageX=O.tail(p.rollingPageX),L.pageY=O.tail(p.rollingPageY),this.dispatchEvent(L)}else if(A>=m.HOLD_DELAY&&Math.abs(p.initialPageX-O.tail(p.rollingPageX))<30&&Math.abs(p.initialPageY-O.tail(p.rollingPageY))<30){const L=this.newGestureEvent(u.Contextmenu,p.initialTarget);L.pageX=O.tail(p.rollingPageX),L.pageY=O.tail(p.rollingPageY),this.dispatchEvent(L)}else if(s===1){const L=O.tail(p.rollingPageX),c=O.tail(p.rollingPageY),a=O.tail(p.rollingTimestamps)-p.rollingTimestamps[0],f=L-p.rollingPageX[0],_=c-p.rollingPageY[0],H=[...this.targets].filter(B=>p.initialTarget instanceof Node&&B.contains(p.initialTarget));this.inertia(g,H,e,Math.abs(f)/a,f>0?1:-1,L,Math.abs(_)/a,_>0?1:-1,c)}this.dispatchEvent(this.newGestureEvent(u.End,p.initialTarget)),delete this.activeTouches[o.identifier]}this.dispatched&&(d.preventDefault(),d.stopPropagation(),this.dispatched=!1)}newGestureEvent(g,d){const e=document.createEvent("CustomEvent");return e.initEvent(g,!1,!0),e.initialTarget=d,e.tapCount=0,e}dispatchEvent(g){if(g.type===u.Tap){const d=new Date().getTime();let e=0;d-this._lastSetTapCountTime>m.CLEAR_TAP_COUNT_TIME?e=1:e=2,this._lastSetTapCountTime=d,g.tapCount=e}else(g.type===u.Change||g.type===u.Contextmenu)&&(this._lastSetTapCountTime=0);if(g.initialTarget instanceof Node){for(const e of this.ignoreTargets)if(e.contains(g.initialTarget))return;const d=[];for(const e of this.targets)if(e.contains(g.initialTarget)){let s=0,r=g.initialTarget;for(;r&&r!==e;)s++,r=r.parentElement;d.push([s,e])}d.sort((e,s)=>e[0]-s[0]);for(const[e,s]of d)s.dispatchEvent(g),this.dispatched=!0}}inertia(g,d,e,s,r,l,o,p,A){this.handle=i.scheduleAtNextAnimationFrame(g,()=>{const L=Date.now(),c=L-e;let a=0,f=0,_=!0;s+=m.SCROLL_FRICTION*c,o+=m.SCROLL_FRICTION*c,s>0&&(_=!1,a=r*s*c),o>0&&(_=!1,f=p*o*c);const H=this.newGestureEvent(u.Change);H.translationX=a,H.translationY=f,d.forEach(B=>B.dispatchEvent(H)),_||this.inertia(g,d,L,s,r,l+a,o,p,A+f)})}onTouchMove(g){const d=Date.now();for(let e=0,s=g.changedTouches.length;e<s;e++){const r=g.changedTouches.item(e);if(!this.activeTouches.hasOwnProperty(String(r.identifier))){console.warn("end of an UNKNOWN touch",r);continue}const l=this.activeTouches[r.identifier],o=this.newGestureEvent(u.Change,l.initialTarget);o.translationX=r.pageX-O.tail(l.rollingPageX),o.translationY=r.pageY-O.tail(l.rollingPageY),o.pageX=r.pageX,o.pageY=r.pageY,this.dispatchEvent(o),l.rollingPageX.length>3&&(l.rollingPageX.shift(),l.rollingPageY.shift(),l.rollingTimestamps.shift()),l.rollingPageX.push(r.pageX),l.rollingPageY.push(r.pageY),l.rollingTimestamps.push(d)}this.dispatched&&(g.preventDefault(),g.stopPropagation(),this.dispatched=!1)}}t.Gesture=m,lt([I.memoize],m,"isTouchDevice",null)}),define(_e[52],Se([1,0,4,111]),function(ue,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.setARIAContainer=u,t.alert=m,t.status=v,i=qe(i);const n=2e4;let O,I,N,b,w;function u(d){O=document.createElement("div"),O.className="monaco-aria-container";const e=()=>{const r=document.createElement("div");return r.className="monaco-alert",r.setAttribute("role","alert"),r.setAttribute("aria-atomic","true"),O.appendChild(r),r};I=e(),N=e();const s=()=>{const r=document.createElement("div");return r.className="monaco-status",r.setAttribute("aria-live","polite"),r.setAttribute("aria-atomic","true"),O.appendChild(r),r};b=s(),w=s(),d.appendChild(O)}function m(d){O&&(I.textContent!==d?(i.clearNode(N),g(I,d)):(i.clearNode(I),g(N,d)))}function v(d){O&&(b.textContent!==d?(i.clearNode(w),g(b,d)):(i.clearNode(b),g(w,d)))}function g(d,e){i.clearNode(d),e.length>n&&(e=e.substr(0,n)),d.textContent=e,d.style.visibility="hidden",d.style.visibility="visible"}}),define(_e[75],Se([1,0,70,4,2,5,46,115]),function(ue,t,i,n,O,I,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ContextView=t.LayoutAnchorMode=t.LayoutAnchorPosition=t.AnchorAxisAlignment=t.AnchorPosition=t.AnchorAlignment=t.ContextViewDOMPosition=void 0,t.isAnchor=w,t.layout=e,n=qe(n),I=qe(I);var b;(function(l){l[l.ABSOLUTE=1]="ABSOLUTE",l[l.FIXED=2]="FIXED",l[l.FIXED_SHADOW=3]="FIXED_SHADOW"})(b||(t.ContextViewDOMPosition=b={}));function w(l){const o=l;return!!o&&typeof o.x=="number"&&typeof o.y=="number"}var u;(function(l){l[l.LEFT=0]="LEFT",l[l.RIGHT=1]="RIGHT"})(u||(t.AnchorAlignment=u={}));var m;(function(l){l[l.BELOW=0]="BELOW",l[l.ABOVE=1]="ABOVE"})(m||(t.AnchorPosition=m={}));var v;(function(l){l[l.VERTICAL=0]="VERTICAL",l[l.HORIZONTAL=1]="HORIZONTAL"})(v||(t.AnchorAxisAlignment=v={}));var g;(function(l){l[l.Before=0]="Before",l[l.After=1]="After"})(g||(t.LayoutAnchorPosition=g={}));var d;(function(l){l[l.AVOID=0]="AVOID",l[l.ALIGN=1]="ALIGN"})(d||(t.LayoutAnchorMode=d={}));function e(l,o,p){const A=p.mode===d.ALIGN?p.offset:p.offset+p.size,L=p.mode===d.ALIGN?p.offset+p.size:p.offset;return p.position===g.Before?o<=l-A?A:o<=L?L-o:Math.max(l-o,0):o<=L?L-o:o<=l-A?A:0}class s extends O.Disposable{static{this.BUBBLE_UP_EVENTS=["click","keydown","focus","blur"]}static{this.BUBBLE_DOWN_EVENTS=["click"]}constructor(o,p){super(),this.container=null,this.useFixedPosition=!1,this.useShadowDOM=!1,this.delegate=null,this.toDisposeOnClean=O.Disposable.None,this.toDisposeOnSetContainer=O.Disposable.None,this.shadowRoot=null,this.shadowRootHostElement=null,this.view=n.$(".context-view"),n.hide(this.view),this.setContainer(o,p),this._register((0,O.toDisposable)(()=>this.setContainer(null,b.ABSOLUTE)))}setContainer(o,p){this.useFixedPosition=p!==b.ABSOLUTE;const A=this.useShadowDOM;if(this.useShadowDOM=p===b.FIXED_SHADOW,!(o===this.container&&A===this.useShadowDOM)&&(this.container&&(this.toDisposeOnSetContainer.dispose(),this.view.remove(),this.shadowRoot&&(this.shadowRoot=null,this.shadowRootHostElement?.remove(),this.shadowRootHostElement=null),this.container=null),o)){if(this.container=o,this.useShadowDOM){this.shadowRootHostElement=n.$(".shadow-root-host"),this.container.appendChild(this.shadowRootHostElement),this.shadowRoot=this.shadowRootHostElement.attachShadow({mode:"open"});const c=document.createElement("style");c.textContent=r,this.shadowRoot.appendChild(c),this.shadowRoot.appendChild(this.view),this.shadowRoot.appendChild(n.$("slot"))}else this.container.appendChild(this.view);const L=new O.DisposableStore;s.BUBBLE_UP_EVENTS.forEach(c=>{L.add(n.addStandardDisposableListener(this.container,c,a=>{this.onDOMEvent(a,!1)}))}),s.BUBBLE_DOWN_EVENTS.forEach(c=>{L.add(n.addStandardDisposableListener(this.container,c,a=>{this.onDOMEvent(a,!0)},!0))}),this.toDisposeOnSetContainer=L}}show(o){this.isVisible()&&this.hide(),n.clearNode(this.view),this.view.className="context-view monaco-component",this.view.style.top="0px",this.view.style.left="0px",this.view.style.zIndex=`${2575+(o.layer??0)}`,this.view.style.position=this.useFixedPosition?"fixed":"absolute",n.show(this.view),this.toDisposeOnClean=o.render(this.view)||O.Disposable.None,this.delegate=o,this.doLayout(),this.delegate.focus?.()}getViewElement(){return this.view}layout(){if(this.isVisible()){if(this.delegate.canRelayout===!1&&!(I.isIOS&&i.BrowserFeatures.pointerEvents)){this.hide();return}this.delegate?.layout?.(),this.doLayout()}}doLayout(){if(!this.isVisible())return;const o=this.delegate.getAnchor();let p;if(n.isHTMLElement(o)){const E=n.getDomNodePagePosition(o),k=n.getDomNodeZoomLevel(o);p={top:E.top*k,left:E.left*k,width:E.width*k,height:E.height*k}}else w(o)?p={top:o.y,left:o.x,width:o.width||1,height:o.height||2}:p={top:o.posy,left:o.posx,width:2,height:2};const A=n.getTotalWidth(this.view),L=n.getTotalHeight(this.view),c=this.delegate.anchorPosition||m.BELOW,a=this.delegate.anchorAlignment||u.LEFT,f=this.delegate.anchorAxisAlignment||v.VERTICAL;let _,H;const B=n.getActiveWindow();if(f===v.VERTICAL){const E={offset:p.top-B.pageYOffset,size:p.height,position:c===m.BELOW?g.Before:g.After},k={offset:p.left,size:p.width,position:a===u.LEFT?g.Before:g.After,mode:d.ALIGN};_=e(B.innerHeight,L,E)+B.pageYOffset,N.Range.intersects({start:_,end:_+L},{start:E.offset,end:E.offset+E.size})&&(k.mode=d.AVOID),H=e(B.innerWidth,A,k)}else{const E={offset:p.left,size:p.width,position:a===u.LEFT?g.Before:g.After},k={offset:p.top,size:p.height,position:c===m.BELOW?g.Before:g.After,mode:d.ALIGN};H=e(B.innerWidth,A,E),N.Range.intersects({start:H,end:H+A},{start:E.offset,end:E.offset+E.size})&&(k.mode=d.AVOID),_=e(B.innerHeight,L,k)+B.pageYOffset}this.view.classList.remove("top","bottom","left","right"),this.view.classList.add(c===m.BELOW?"bottom":"top"),this.view.classList.add(a===u.LEFT?"left":"right"),this.view.classList.toggle("fixed",this.useFixedPosition);const F=n.getDomNodePagePosition(this.container);this.view.style.top=`${_-(this.useFixedPosition?n.getDomNodePagePosition(this.view).top:F.top)}px`,this.view.style.left=`${H-(this.useFixedPosition?n.getDomNodePagePosition(this.view).left:F.left)}px`,this.view.style.width="initial"}hide(o){const p=this.delegate;this.delegate=null,p?.onHide&&p.onHide(o),this.toDisposeOnClean.dispose(),n.hide(this.view)}isVisible(){return!!this.delegate}onDOMEvent(o,p){this.delegate&&(this.delegate.onDOMEvent?this.delegate.onDOMEvent(o,n.getWindow(o).document.activeElement):p&&!n.isAncestor(o.target,this.container)&&this.hide())}dispose(){this.hide(),super.dispose()}}t.ContextView=s;const r=`
	:host {
		all: initial; /* 1st rule so subsequent properties are reset. */
	}

	.codicon[class*='codicon-'] {
		font: normal normal normal 16px/1 codicon;
		display: inline-block;
		text-decoration: none;
		text-rendering: auto;
		text-align: center;
		-webkit-font-smoothing: antialiased;
		-moz-osx-font-smoothing: grayscale;
		user-select: none;
		-webkit-user-select: none;
		-ms-user-select: none;
	}

	:host {
		font-family: -apple-system, BlinkMacSystemFont, "Segoe WPC", "Segoe UI", "HelveticaNeue-Light", system-ui, "Ubuntu", "Droid Sans", sans-serif;
	}

	:host-context(.mac) { font-family: -apple-system, BlinkMacSystemFont, sans-serif; }
	:host-context(.mac:lang(zh-Hans)) { font-family: -apple-system, BlinkMacSystemFont, "PingFang SC", "Hiragino Sans GB", sans-serif; }
	:host-context(.mac:lang(zh-Hant)) { font-family: -apple-system, BlinkMacSystemFont, "PingFang TC", sans-serif; }
	:host-context(.mac:lang(ja)) { font-family: -apple-system, BlinkMacSystemFont, "Hiragino Kaku Gothic Pro", sans-serif; }
	:host-context(.mac:lang(ko)) { font-family: -apple-system, BlinkMacSystemFont, "Nanum Gothic", "Apple SD Gothic Neo", "AppleGothic", sans-serif; }

	:host-context(.windows) { font-family: "Segoe WPC", "Segoe UI", sans-serif; }
	:host-context(.windows:lang(zh-Hans)) { font-family: "Segoe WPC", "Segoe UI", "Microsoft YaHei", sans-serif; }
	:host-context(.windows:lang(zh-Hant)) { font-family: "Segoe WPC", "Segoe UI", "Microsoft Jhenghei", sans-serif; }
	:host-context(.windows:lang(ja)) { font-family: "Segoe WPC", "Segoe UI", "Yu Gothic UI", "Meiryo UI", sans-serif; }
	:host-context(.windows:lang(ko)) { font-family: "Segoe WPC", "Segoe UI", "Malgun Gothic", "Dotom", sans-serif; }

	:host-context(.linux) { font-family: system-ui, "Ubuntu", "Droid Sans", sans-serif; }
	:host-context(.linux:lang(zh-Hans)) { font-family: system-ui, "Ubuntu", "Droid Sans", "Source Han Sans SC", "Source Han Sans CN", "Source Han Sans", sans-serif; }
	:host-context(.linux:lang(zh-Hant)) { font-family: system-ui, "Ubuntu", "Droid Sans", "Source Han Sans TC", "Source Han Sans TW", "Source Han Sans", sans-serif; }
	:host-context(.linux:lang(ja)) { font-family: system-ui, "Ubuntu", "Droid Sans", "Source Han Sans J", "Source Han Sans JP", "Source Han Sans", sans-serif; }
	:host-context(.linux:lang(ko)) { font-family: system-ui, "Ubuntu", "Droid Sans", "Source Han Sans K", "Source Han Sans JR", "Source Han Sans", "UnDotum", "FBaekmuk Gulim", sans-serif; }
`}),define(_e[130],Se([1,0,4,21]),function(ue,t,i,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.renderLabelWithIcons=I,t.renderIcon=N,i=qe(i);const O=new RegExp(`(\\\\)?\\$\\((${n.ThemeIcon.iconNameExpression}(?:${n.ThemeIcon.iconModifierExpression})?)\\)`,"g");function I(b){const w=new Array;let u,m=0,v=0;for(;(u=O.exec(b))!==null;){v=u.index||0,m<v&&w.push(b.substring(m,v)),m=(u.index||0)+u[0].length;const[,g,d]=u;w.push(g?`$(${d})`:N({id:d}))}return m<b.length&&w.push(b.substring(m)),w}function N(b){const w=i.$("span");return w.classList.add(...n.ThemeIcon.asClassNameArray(b)),w}}),define(_e[131],Se([1,0,4]),function(ue,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.RowCache=void 0;class n{constructor(I){this.renderers=I,this.cache=new Map,this.transactionNodesPendingRemoval=new Set,this.inTransaction=!1}alloc(I){let N=this.getTemplateCache(I).pop(),b=!1;if(N)b=this.transactionNodesPendingRemoval.has(N.domNode),b&&this.transactionNodesPendingRemoval.delete(N.domNode);else{const w=(0,i.$)(".monaco-list-row"),m=this.getRenderer(I).renderTemplate(w);N={domNode:w,templateId:I,templateData:m}}return{row:N,isReusingConnectedDomNode:b}}release(I){I&&this.releaseRow(I)}transact(I){if(this.inTransaction)throw new Error("Already in transaction");this.inTransaction=!0;try{I()}finally{for(const N of this.transactionNodesPendingRemoval)this.doRemoveNode(N);this.transactionNodesPendingRemoval.clear(),this.inTransaction=!1}}releaseRow(I){const{domNode:N,templateId:b}=I;N&&(this.inTransaction?this.transactionNodesPendingRemoval.add(N):this.doRemoveNode(N)),this.getTemplateCache(b).push(I)}doRemoveNode(I){I.classList.remove("scrolling"),I.remove()}getTemplateCache(I){let N=this.cache.get(I);return N||(N=[],this.cache.set(I,N)),N}dispose(){this.cache.forEach((I,N)=>{for(const b of I)this.getRenderer(N).disposeTemplate(b.templateData),b.templateData=null}),this.cache.clear(),this.transactionNodesPendingRemoval.clear()}getRenderer(I){const N=this.renderers.get(I);if(!N)throw new Error(`No renderer found for ${I}`);return N}}t.RowCache=n}),define(_e[132],Se([1,0,13,2,19]),function(ue,t,i,n,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ScrollbarVisibilityController=void 0;class I extends n.Disposable{constructor(b,w,u){super(),this._visibility=b,this._visibleClassName=w,this._invisibleClassName=u,this._domNode=null,this._isVisible=!1,this._isNeeded=!1,this._rawShouldBeVisible=!1,this._shouldBeVisible=!1,this._revealTimer=this._register(new i.TimeoutTimer)}setVisibility(b){this._visibility!==b&&(this._visibility=b,this._updateShouldBeVisible())}setShouldBeVisible(b){this._rawShouldBeVisible=b,this._updateShouldBeVisible()}_applyVisibilitySetting(){return this._visibility===O.ScrollbarVisibility.Hidden?!1:this._visibility===O.ScrollbarVisibility.Visible?!0:this._rawShouldBeVisible}_updateShouldBeVisible(){const b=this._applyVisibilitySetting();this._shouldBeVisible!==b&&(this._shouldBeVisible=b,this.ensureVisibility())}setIsNeeded(b){this._isNeeded!==b&&(this._isNeeded=b,this.ensureVisibility())}setDomNode(b){this._domNode=b,this._domNode.setClassName(this._invisibleClassName),this.setShouldBeVisible(!1)}ensureVisibility(){if(!this._isNeeded){this._hide(!1);return}this._shouldBeVisible?this._reveal():this._hide(!0)}_reveal(){this._isVisible||(this._isVisible=!0,this._revealTimer.setIfNotSet(()=>{this._domNode?.setClassName(this._visibleClassName)},0))}_hide(b){this._revealTimer.cancel(),this._isVisible&&(this._isVisible=!1,this._domNode?.setClassName(this._invisibleClassName+(b?" fade":"")))}}t.ScrollbarVisibilityController=I}),define(_e[133],Se([1,0,4,32,9,3,8,2,5]),function(ue,t,i,n,O,I,N,b,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SelectBoxNative=void 0,i=qe(i),O=qe(O);class u extends b.Disposable{constructor(v,g,d,e){super(),this.selected=0,this.selectBoxOptions=e||Object.create(null),this.options=[],this.selectElement=document.createElement("select"),this.selectElement.className="monaco-select-box",typeof this.selectBoxOptions.ariaLabel=="string"&&this.selectElement.setAttribute("aria-label",this.selectBoxOptions.ariaLabel),typeof this.selectBoxOptions.ariaDescription=="string"&&this.selectElement.setAttribute("aria-description",this.selectBoxOptions.ariaDescription),this._onDidSelect=this._register(new I.Emitter),this.styles=d,this.registerListeners(),this.setOptions(v,g)}registerListeners(){this._register(n.Gesture.addTarget(this.selectElement)),[n.EventType.Tap].forEach(v=>{this._register(i.addDisposableListener(this.selectElement,v,g=>{this.selectElement.focus()}))}),this._register(i.addStandardDisposableListener(this.selectElement,"click",v=>{i.EventHelper.stop(v,!0)})),this._register(i.addStandardDisposableListener(this.selectElement,"change",v=>{this.selectElement.title=v.target.value,this._onDidSelect.fire({index:v.target.selectedIndex,selected:v.target.value})})),this._register(i.addStandardDisposableListener(this.selectElement,"keydown",v=>{let g=!1;w.isMacintosh?(v.keyCode===N.KeyCode.DownArrow||v.keyCode===N.KeyCode.UpArrow||v.keyCode===N.KeyCode.Space)&&(g=!0):(v.keyCode===N.KeyCode.DownArrow&&v.altKey||v.keyCode===N.KeyCode.Space||v.keyCode===N.KeyCode.Enter)&&(g=!0),g&&v.stopPropagation()}))}get onDidSelect(){return this._onDidSelect.event}setOptions(v,g){(!this.options||!O.equals(this.options,v))&&(this.options=v,this.selectElement.options.length=0,this.options.forEach((d,e)=>{this.selectElement.add(this.createOption(d.text,e,d.isDisabled))})),g!==void 0&&this.select(g)}select(v){this.options.length===0?this.selected=0:v>=0&&v<this.options.length?this.selected=v:v>this.options.length-1?this.select(this.options.length-1):this.selected<0&&(this.selected=0),this.selectElement.selectedIndex=this.selected,this.selected<this.options.length&&typeof this.options[this.selected].text=="string"?this.selectElement.title=this.options[this.selected].text:this.selectElement.title=""}setAriaLabel(v){this.selectBoxOptions.ariaLabel=v,this.selectElement.setAttribute("aria-label",v)}focus(){this.selectElement&&(this.selectElement.tabIndex=0,this.selectElement.focus())}blur(){this.selectElement&&(this.selectElement.tabIndex=-1,this.selectElement.blur())}setEnabled(v){this.selectElement.disabled=!v}setFocusable(v){this.selectElement.tabIndex=v?0:-1}render(v){v.classList.add("select-container"),v.appendChild(this.selectElement),this.setOptions(this.options,this.selected),this.applyStyles()}style(v){this.styles=v,this.applyStyles()}applyStyles(){this.selectElement&&(this.selectElement.style.backgroundColor=this.styles.selectBackground??"",this.selectElement.style.color=this.styles.selectForeground??"",this.selectElement.style.borderColor=this.styles.selectBorder??"")}createOption(v,g,d){const e=document.createElement("option");return e.value=v,e.text=v,e.disabled=!!d,e}}t.SelectBoxNative=u}),define(_e[76],Se([1,0,34,9,13,63,106,3,36]),function(ue,t,i,n,O,I,N,b,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IndexTreeModel=void 0,t.isFilterResult=u,t.getVisibleState=m;function u(d){return typeof d=="object"&&"visibility"in d&&"data"in d}function m(d){switch(d){case!0:return i.TreeVisibility.Visible;case!1:return i.TreeVisibility.Hidden;default:return d}}function v(d){return typeof d.collapsible=="boolean"}class g{constructor(e,s,r,l={}){this.user=e,this.list=s,this.rootRef=[],this.eventBufferer=new b.EventBufferer,this._onDidChangeCollapseState=new b.Emitter,this.onDidChangeCollapseState=this.eventBufferer.wrapEvent(this._onDidChangeCollapseState.event),this._onDidChangeRenderNodeCount=new b.Emitter,this.onDidChangeRenderNodeCount=this.eventBufferer.wrapEvent(this._onDidChangeRenderNodeCount.event),this._onDidSplice=new b.Emitter,this.onDidSplice=this._onDidSplice.event,this.refilterDelayer=new O.Delayer(I.MicrotaskDelay),this.collapseByDefault=typeof l.collapseByDefault>"u"?!1:l.collapseByDefault,this.allowNonCollapsibleParents=l.allowNonCollapsibleParents??!1,this.filter=l.filter,this.autoExpandSingleChildren=typeof l.autoExpandSingleChildren>"u"?!1:l.autoExpandSingleChildren,this.root={parent:void 0,element:r,children:[],depth:0,visibleChildrenCount:0,visibleChildIndex:-1,collapsible:!1,collapsed:!1,renderNodeCount:0,visibility:i.TreeVisibility.Visible,visible:!0,filterData:void 0}}splice(e,s,r=w.Iterable.empty(),l={}){if(e.length===0)throw new i.TreeError(this.user,"Invalid tree location");l.diffIdentityProvider?this.spliceSmart(l.diffIdentityProvider,e,s,r,l):this.spliceSimple(e,s,r,l)}spliceSmart(e,s,r,l=w.Iterable.empty(),o,p=o.diffDepth??0){const{parentNode:A}=this.getParentNodeWithListIndex(s);if(!A.lastDiffIds)return this.spliceSimple(s,r,l,o);const L=[...l],c=s[s.length-1],a=new N.LcsDiff({getElements:()=>A.lastDiffIds},{getElements:()=>[...A.children.slice(0,c),...L,...A.children.slice(c+r)].map(F=>e.getId(F.element).toString())}).ComputeDiff(!1);if(a.quitEarly)return A.lastDiffIds=void 0,this.spliceSimple(s,r,L,o);const f=s.slice(0,-1),_=(F,E,k)=>{if(p>0)for(let W=0;W<k;W++)F--,E--,this.spliceSmart(e,[...f,F,0],Number.MAX_SAFE_INTEGER,L[E].children,o,p-1)};let H=Math.min(A.children.length,c+r),B=L.length;for(const F of a.changes.sort((E,k)=>k.originalStart-E.originalStart))_(H,B,H-(F.originalStart+F.originalLength)),H=F.originalStart,B=F.modifiedStart-c,this.spliceSimple([...f,H],F.originalLength,w.Iterable.slice(L,B,B+F.modifiedLength),o);_(H,B,H)}spliceSimple(e,s,r=w.Iterable.empty(),{onDidCreateNode:l,onDidDeleteNode:o,diffIdentityProvider:p}){const{parentNode:A,listIndex:L,revealed:c,visible:a}=this.getParentNodeWithListIndex(e),f=[],_=w.Iterable.map(r,$=>this.createTreeNode($,A,A.visible?i.TreeVisibility.Visible:i.TreeVisibility.Hidden,c,f,l)),H=e[e.length-1];let B=0;for(let $=H;$>=0&&$<A.children.length;$--){const ee=A.children[$];if(ee.visible){B=ee.visibleChildIndex;break}}const F=[];let E=0,k=0;for(const $ of _)F.push($),k+=$.renderNodeCount,$.visible&&($.visibleChildIndex=B+E++);const W=(0,n.splice)(A.children,H,s,F);p?A.lastDiffIds?(0,n.splice)(A.lastDiffIds,H,s,F.map($=>p.getId($.element).toString())):A.lastDiffIds=A.children.map($=>p.getId($.element).toString()):A.lastDiffIds=void 0;let R=0;for(const $ of W)$.visible&&R++;if(R!==0)for(let $=H+F.length;$<A.children.length;$++){const ee=A.children[$];ee.visible&&(ee.visibleChildIndex-=R)}if(A.visibleChildrenCount+=E-R,c&&a){const $=W.reduce((ee,Y)=>ee+(Y.visible?Y.renderNodeCount:0),0);this._updateAncestorsRenderNodeCount(A,k-$),this.list.splice(L,$,f)}if(W.length>0&&o){const $=ee=>{o(ee),ee.children.forEach($)};W.forEach($)}this._onDidSplice.fire({insertedNodes:F,deletedNodes:W});let C=A;for(;C;){if(C.visibility===i.TreeVisibility.Recurse){this.refilterDelayer.trigger(()=>this.refilter());break}C=C.parent}}rerender(e){if(e.length===0)throw new i.TreeError(this.user,"Invalid tree location");const{node:s,listIndex:r,revealed:l}=this.getTreeNodeWithListIndex(e);s.visible&&l&&this.list.splice(r,1,[s])}updateElementHeight(e,s){if(e.length===0)throw new i.TreeError(this.user,"Invalid tree location");const{listIndex:r}=this.getTreeNodeWithListIndex(e);this.list.updateElementHeight(r,s)}has(e){return this.hasTreeNode(e)}getListIndex(e){const{listIndex:s,visible:r,revealed:l}=this.getTreeNodeWithListIndex(e);return r&&l?s:-1}getListRenderCount(e){return this.getTreeNode(e).renderNodeCount}isCollapsible(e){return this.getTreeNode(e).collapsible}setCollapsible(e,s){const r=this.getTreeNode(e);typeof s>"u"&&(s=!r.collapsible);const l={collapsible:s};return this.eventBufferer.bufferEvents(()=>this._setCollapseState(e,l))}isCollapsed(e){return this.getTreeNode(e).collapsed}setCollapsed(e,s,r){const l=this.getTreeNode(e);typeof s>"u"&&(s=!l.collapsed);const o={collapsed:s,recursive:r||!1};return this.eventBufferer.bufferEvents(()=>this._setCollapseState(e,o))}_setCollapseState(e,s){const{node:r,listIndex:l,revealed:o}=this.getTreeNodeWithListIndex(e),p=this._setListNodeCollapseState(r,l,o,s);if(r!==this.root&&this.autoExpandSingleChildren&&p&&!v(s)&&r.collapsible&&!r.collapsed&&!s.recursive){let A=-1;for(let L=0;L<r.children.length;L++)if(r.children[L].visible)if(A>-1){A=-1;break}else A=L;A>-1&&this._setCollapseState([...e,A],s)}return p}_setListNodeCollapseState(e,s,r,l){const o=this._setNodeCollapseState(e,l,!1);if(!r||!e.visible||!o)return o;const p=e.renderNodeCount,A=this.updateNodeAfterCollapseChange(e),L=p-(s===-1?0:1);return this.list.splice(s+1,L,A.slice(1)),o}_setNodeCollapseState(e,s,r){let l;if(e===this.root?l=!1:(v(s)?(l=e.collapsible!==s.collapsible,e.collapsible=s.collapsible):e.collapsible?(l=e.collapsed!==s.collapsed,e.collapsed=s.collapsed):l=!1,l&&this._onDidChangeCollapseState.fire({node:e,deep:r})),!v(s)&&s.recursive)for(const o of e.children)l=this._setNodeCollapseState(o,s,!0)||l;return l}expandTo(e){this.eventBufferer.bufferEvents(()=>{let s=this.getTreeNode(e);for(;s.parent;)s=s.parent,e=e.slice(0,e.length-1),s.collapsed&&this._setCollapseState(e,{collapsed:!1,recursive:!1})})}refilter(){const e=this.root.renderNodeCount,s=this.updateNodeAfterFilterChange(this.root);this.list.splice(0,e,s),this.refilterDelayer.cancel()}createTreeNode(e,s,r,l,o,p){const A={parent:s,element:e.element,children:[],depth:s.depth+1,visibleChildrenCount:0,visibleChildIndex:-1,collapsible:typeof e.collapsible=="boolean"?e.collapsible:typeof e.collapsed<"u",collapsed:typeof e.collapsed>"u"?this.collapseByDefault:e.collapsed,renderNodeCount:1,visibility:i.TreeVisibility.Visible,visible:!0,filterData:void 0},L=this._filterNode(A,r);A.visibility=L,l&&o.push(A);const c=e.children||w.Iterable.empty(),a=l&&L!==i.TreeVisibility.Hidden&&!A.collapsed;let f=0,_=1;for(const H of c){const B=this.createTreeNode(H,A,L,a,o,p);A.children.push(B),_+=B.renderNodeCount,B.visible&&(B.visibleChildIndex=f++)}return this.allowNonCollapsibleParents||(A.collapsible=A.collapsible||A.children.length>0),A.visibleChildrenCount=f,A.visible=L===i.TreeVisibility.Recurse?f>0:L===i.TreeVisibility.Visible,A.visible?A.collapsed||(A.renderNodeCount=_):(A.renderNodeCount=0,l&&o.pop()),p?.(A),A}updateNodeAfterCollapseChange(e){const s=e.renderNodeCount,r=[];return this._updateNodeAfterCollapseChange(e,r),this._updateAncestorsRenderNodeCount(e.parent,r.length-s),r}_updateNodeAfterCollapseChange(e,s){if(e.visible===!1)return 0;if(s.push(e),e.renderNodeCount=1,!e.collapsed)for(const r of e.children)e.renderNodeCount+=this._updateNodeAfterCollapseChange(r,s);return this._onDidChangeRenderNodeCount.fire(e),e.renderNodeCount}updateNodeAfterFilterChange(e){const s=e.renderNodeCount,r=[];return this._updateNodeAfterFilterChange(e,e.visible?i.TreeVisibility.Visible:i.TreeVisibility.Hidden,r),this._updateAncestorsRenderNodeCount(e.parent,r.length-s),r}_updateNodeAfterFilterChange(e,s,r,l=!0){let o;if(e!==this.root){if(o=this._filterNode(e,s),o===i.TreeVisibility.Hidden)return e.visible=!1,e.renderNodeCount=0,!1;l&&r.push(e)}const p=r.length;e.renderNodeCount=e===this.root?0:1;let A=!1;if(!e.collapsed||o!==i.TreeVisibility.Hidden){let L=0;for(const c of e.children)A=this._updateNodeAfterFilterChange(c,o,r,l&&!e.collapsed)||A,c.visible&&(c.visibleChildIndex=L++);e.visibleChildrenCount=L}else e.visibleChildrenCount=0;return e!==this.root&&(e.visible=o===i.TreeVisibility.Recurse?A:o===i.TreeVisibility.Visible,e.visibility=o),e.visible?e.collapsed||(e.renderNodeCount+=r.length-p):(e.renderNodeCount=0,l&&r.pop()),this._onDidChangeRenderNodeCount.fire(e),e.visible}_updateAncestorsRenderNodeCount(e,s){if(s!==0)for(;e;)e.renderNodeCount+=s,this._onDidChangeRenderNodeCount.fire(e),e=e.parent}_filterNode(e,s){const r=this.filter?this.filter.filter(e.element,s):i.TreeVisibility.Visible;return typeof r=="boolean"?(e.filterData=void 0,r?i.TreeVisibility.Visible:i.TreeVisibility.Hidden):u(r)?(e.filterData=r.data,m(r.visibility)):(e.filterData=void 0,m(r))}hasTreeNode(e,s=this.root){if(!e||e.length===0)return!0;const[r,...l]=e;return r<0||r>s.children.length?!1:this.hasTreeNode(l,s.children[r])}getTreeNode(e,s=this.root){if(!e||e.length===0)return s;const[r,...l]=e;if(r<0||r>s.children.length)throw new i.TreeError(this.user,"Invalid tree location");return this.getTreeNode(l,s.children[r])}getTreeNodeWithListIndex(e){if(e.length===0)return{node:this.root,listIndex:-1,revealed:!0,visible:!1};const{parentNode:s,listIndex:r,revealed:l,visible:o}=this.getParentNodeWithListIndex(e),p=e[e.length-1];if(p<0||p>s.children.length)throw new i.TreeError(this.user,"Invalid tree location");const A=s.children[p];return{node:A,listIndex:r,revealed:l,visible:o&&A.visible}}getParentNodeWithListIndex(e,s=this.root,r=0,l=!0,o=!0){const[p,...A]=e;if(p<0||p>s.children.length)throw new i.TreeError(this.user,"Invalid tree location");for(let L=0;L<p;L++)r+=s.children[L].renderNodeCount;return l=l&&!s.collapsed,o=o&&s.visible,A.length===0?{parentNode:s,listIndex:r,revealed:l,visible:o}:this.getParentNodeWithListIndex(A,s.children[p],r+1,l,o)}getNode(e=[]){return this.getTreeNode(e)}getNodeLocation(e){const s=[];let r=e;for(;r.parent;)s.push(r.parent.children.indexOf(r)),r=r.parent;return s.reverse()}getParentNodeLocation(e){if(e.length!==0)return e.length===1?[]:(0,n.tail2)(e)[0]}getFirstElementChild(e){const s=this.getTreeNode(e);if(s.children.length!==0)return s.children[0].element}getLastElementAncestor(e=[]){const s=this.getTreeNode(e);if(s.children.length!==0)return this._getLastElementAncestor(s)}_getLastElementAncestor(e){return e.children.length===0?e.element:this._getLastElementAncestor(e.children[e.children.length-1])}}t.IndexTreeModel=g}),define(_e[134],Se([1,0,76,34,36]),function(ue,t,i,n,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ObjectTreeModel=void 0;class I{get size(){return this.nodes.size}constructor(b,w,u={}){this.user=b,this.rootRef=null,this.nodes=new Map,this.nodesByIdentity=new Map,this.model=new i.IndexTreeModel(b,w,null,u),this.onDidSplice=this.model.onDidSplice,this.onDidChangeCollapseState=this.model.onDidChangeCollapseState,this.onDidChangeRenderNodeCount=this.model.onDidChangeRenderNodeCount,u.sorter&&(this.sorter={compare(m,v){return u.sorter.compare(m.element,v.element)}}),this.identityProvider=u.identityProvider}setChildren(b,w=O.Iterable.empty(),u={}){const m=this.getElementLocation(b);this._setChildren(m,this.preserveCollapseState(w),u)}_setChildren(b,w=O.Iterable.empty(),u){const m=new Set,v=new Set,g=e=>{if(e.element===null)return;const s=e;if(m.add(s.element),this.nodes.set(s.element,s),this.identityProvider){const r=this.identityProvider.getId(s.element).toString();v.add(r),this.nodesByIdentity.set(r,s)}u.onDidCreateNode?.(s)},d=e=>{if(e.element===null)return;const s=e;if(m.has(s.element)||this.nodes.delete(s.element),this.identityProvider){const r=this.identityProvider.getId(s.element).toString();v.has(r)||this.nodesByIdentity.delete(r)}u.onDidDeleteNode?.(s)};this.model.splice([...b,0],Number.MAX_VALUE,w,{...u,onDidCreateNode:g,onDidDeleteNode:d})}preserveCollapseState(b=O.Iterable.empty()){return this.sorter&&(b=[...b].sort(this.sorter.compare.bind(this.sorter))),O.Iterable.map(b,w=>{let u=this.nodes.get(w.element);if(!u&&this.identityProvider){const g=this.identityProvider.getId(w.element).toString();u=this.nodesByIdentity.get(g)}if(!u){let g;return typeof w.collapsed>"u"?g=void 0:w.collapsed===n.ObjectTreeElementCollapseState.Collapsed||w.collapsed===n.ObjectTreeElementCollapseState.PreserveOrCollapsed?g=!0:w.collapsed===n.ObjectTreeElementCollapseState.Expanded||w.collapsed===n.ObjectTreeElementCollapseState.PreserveOrExpanded?g=!1:g=!!w.collapsed,{...w,children:this.preserveCollapseState(w.children),collapsed:g}}const m=typeof w.collapsible=="boolean"?w.collapsible:u.collapsible;let v;return typeof w.collapsed>"u"||w.collapsed===n.ObjectTreeElementCollapseState.PreserveOrCollapsed||w.collapsed===n.ObjectTreeElementCollapseState.PreserveOrExpanded?v=u.collapsed:w.collapsed===n.ObjectTreeElementCollapseState.Collapsed?v=!0:w.collapsed===n.ObjectTreeElementCollapseState.Expanded?v=!1:v=!!w.collapsed,{...w,collapsible:m,collapsed:v,children:this.preserveCollapseState(w.children)}})}rerender(b){const w=this.getElementLocation(b);this.model.rerender(w)}updateElementHeight(b,w){const u=this.getElementLocation(b);this.model.updateElementHeight(u,w)}resort(b=null,w=!0){if(!this.sorter)return;const u=this.getElementLocation(b),m=this.model.getNode(u);this._setChildren(u,this.resortChildren(m,w),{})}resortChildren(b,w,u=!0){let m=[...b.children];return(w||u)&&(m=m.sort(this.sorter.compare.bind(this.sorter))),O.Iterable.map(m,v=>({element:v.element,collapsible:v.collapsible,collapsed:v.collapsed,children:this.resortChildren(v,w,!1)}))}getFirstElementChild(b=null){const w=this.getElementLocation(b);return this.model.getFirstElementChild(w)}getLastElementAncestor(b=null){const w=this.getElementLocation(b);return this.model.getLastElementAncestor(w)}has(b){return this.nodes.has(b)}getListIndex(b){const w=this.getElementLocation(b);return this.model.getListIndex(w)}getListRenderCount(b){const w=this.getElementLocation(b);return this.model.getListRenderCount(w)}isCollapsible(b){const w=this.getElementLocation(b);return this.model.isCollapsible(w)}setCollapsible(b,w){const u=this.getElementLocation(b);return this.model.setCollapsible(u,w)}isCollapsed(b){const w=this.getElementLocation(b);return this.model.isCollapsed(w)}setCollapsed(b,w,u){const m=this.getElementLocation(b);return this.model.setCollapsed(m,w,u)}expandTo(b){const w=this.getElementLocation(b);this.model.expandTo(w)}refilter(){this.model.refilter()}getNode(b=null){if(b===null)return this.model.getNode(this.model.rootRef);const w=this.nodes.get(b);if(!w)throw new n.TreeError(this.user,`Tree element not found: ${b}`);return w}getNodeLocation(b){return b.element}getParentNodeLocation(b){if(b===null)throw new n.TreeError(this.user,"Invalid getParentNodeLocation call");const w=this.nodes.get(b);if(!w)throw new n.TreeError(this.user,`Tree element not found: ${b}`);const u=this.model.getNodeLocation(w),m=this.model.getParentNodeLocation(u);return this.model.getNode(m).element}getElementLocation(b){if(b===null)return[];const w=this.nodes.get(b);if(!w)throw new n.TreeError(this.user,`Tree element not found: ${b}`);return this.model.getNodeLocation(w)}}t.ObjectTreeModel=I}),define(_e[23],Se([1,0,4,15,22,32,2]),function(ue,t,i,n,O,I,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Widget=void 0,i=qe(i);class b extends N.Disposable{onclick(u,m){this._register(i.addDisposableListener(u,i.EventType.CLICK,v=>m(new O.StandardMouseEvent(i.getWindow(u),v))))}onmousedown(u,m){this._register(i.addDisposableListener(u,i.EventType.MOUSE_DOWN,v=>m(new O.StandardMouseEvent(i.getWindow(u),v))))}onmouseover(u,m){this._register(i.addDisposableListener(u,i.EventType.MOUSE_OVER,v=>m(new O.StandardMouseEvent(i.getWindow(u),v))))}onmouseleave(u,m){this._register(i.addDisposableListener(u,i.EventType.MOUSE_LEAVE,v=>m(new O.StandardMouseEvent(i.getWindow(u),v))))}onkeydown(u,m){this._register(i.addDisposableListener(u,i.EventType.KEY_DOWN,v=>m(new n.StandardKeyboardEvent(v))))}onkeyup(u,m){this._register(i.addDisposableListener(u,i.EventType.KEY_UP,v=>m(new n.StandardKeyboardEvent(v))))}oninput(u,m){this._register(i.addDisposableListener(u,i.EventType.INPUT,m))}onblur(u,m){this._register(i.addDisposableListener(u,i.EventType.BLUR,m))}onfocus(u,m){this._register(i.addDisposableListener(u,i.EventType.FOCUS,m))}onchange(u,m){this._register(i.addDisposableListener(u,i.EventType.CHANGE,m))}ignoreGesture(u){return I.Gesture.ignoreTarget(u)}}t.Widget=b}),define(_e[53],Se([1,0,74,23,13,21,4]),function(ue,t,i,n,O,I,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ScrollbarArrow=t.ARROW_IMG_SIZE=void 0,N=qe(N),t.ARROW_IMG_SIZE=11;class b extends n.Widget{constructor(u){super(),this._onActivate=u.onActivate,this.bgDomNode=document.createElement("div"),this.bgDomNode.className="arrow-background",this.bgDomNode.style.position="absolute",this.bgDomNode.style.width=u.bgWidth+"px",this.bgDomNode.style.height=u.bgHeight+"px",typeof u.top<"u"&&(this.bgDomNode.style.top="0px"),typeof u.left<"u"&&(this.bgDomNode.style.left="0px"),typeof u.bottom<"u"&&(this.bgDomNode.style.bottom="0px"),typeof u.right<"u"&&(this.bgDomNode.style.right="0px"),this.domNode=document.createElement("div"),this.domNode.className=u.className,this.domNode.classList.add(...I.ThemeIcon.asClassNameArray(u.icon)),this.domNode.style.position="absolute",this.domNode.style.width=t.ARROW_IMG_SIZE+"px",this.domNode.style.height=t.ARROW_IMG_SIZE+"px",typeof u.top<"u"&&(this.domNode.style.top=u.top+"px"),typeof u.left<"u"&&(this.domNode.style.left=u.left+"px"),typeof u.bottom<"u"&&(this.domNode.style.bottom=u.bottom+"px"),typeof u.right<"u"&&(this.domNode.style.right=u.right+"px"),this._pointerMoveMonitor=this._register(new i.GlobalPointerMoveMonitor),this._register(N.addStandardDisposableListener(this.bgDomNode,N.EventType.POINTER_DOWN,m=>this._arrowPointerDown(m))),this._register(N.addStandardDisposableListener(this.domNode,N.EventType.POINTER_DOWN,m=>this._arrowPointerDown(m))),this._pointerdownRepeatTimer=this._register(new N.WindowIntervalTimer),this._pointerdownScheduleRepeatTimer=this._register(new O.TimeoutTimer)}_arrowPointerDown(u){if(!u.target||!(u.target instanceof Element))return;const m=()=>{this._pointerdownRepeatTimer.cancelAndSet(()=>this._onActivate(),1e3/24,N.getWindow(u))};this._onActivate(),this._pointerdownRepeatTimer.cancel(),this._pointerdownScheduleRepeatTimer.cancelAndSet(m,200),this._pointerMoveMonitor.startMonitoring(u.target,u.pointerId,u.buttons,v=>{},()=>{this._pointerdownRepeatTimer.cancel(),this._pointerdownScheduleRepeatTimer.cancel()}),u.preventDefault()}}t.ScrollbarArrow=b}),define(_e[77],Se([1,0,4,56,74,53,132,23,5]),function(ue,t,i,n,O,I,N,b,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AbstractScrollbar=void 0,i=qe(i),w=qe(w);const u=140;class m extends b.Widget{constructor(g){super(),this._lazyRender=g.lazyRender,this._host=g.host,this._scrollable=g.scrollable,this._scrollByPage=g.scrollByPage,this._scrollbarState=g.scrollbarState,this._visibilityController=this._register(new N.ScrollbarVisibilityController(g.visibility,"visible scrollbar "+g.extraScrollbarClassName,"invisible scrollbar "+g.extraScrollbarClassName)),this._visibilityController.setIsNeeded(this._scrollbarState.isNeeded()),this._pointerMoveMonitor=this._register(new O.GlobalPointerMoveMonitor),this._shouldRender=!0,this.domNode=(0,n.createFastDomNode)(document.createElement("div")),this.domNode.setAttribute("role","presentation"),this.domNode.setAttribute("aria-hidden","true"),this._visibilityController.setDomNode(this.domNode),this.domNode.setPosition("absolute"),this._register(i.addDisposableListener(this.domNode.domNode,i.EventType.POINTER_DOWN,d=>this._domNodePointerDown(d)))}_createArrow(g){const d=this._register(new I.ScrollbarArrow(g));this.domNode.domNode.appendChild(d.bgDomNode),this.domNode.domNode.appendChild(d.domNode)}_createSlider(g,d,e,s){this.slider=(0,n.createFastDomNode)(document.createElement("div")),this.slider.setClassName("slider"),this.slider.setPosition("absolute"),this.slider.setTop(g),this.slider.setLeft(d),typeof e=="number"&&this.slider.setWidth(e),typeof s=="number"&&this.slider.setHeight(s),this.slider.setLayerHinting(!0),this.slider.setContain("strict"),this.domNode.domNode.appendChild(this.slider.domNode),this._register(i.addDisposableListener(this.slider.domNode,i.EventType.POINTER_DOWN,r=>{r.button===0&&(r.preventDefault(),this._sliderPointerDown(r))})),this.onclick(this.slider.domNode,r=>{r.leftButton&&r.stopPropagation()})}_onElementSize(g){return this._scrollbarState.setVisibleSize(g)&&(this._visibilityController.setIsNeeded(this._scrollbarState.isNeeded()),this._shouldRender=!0,this._lazyRender||this.render()),this._shouldRender}_onElementScrollSize(g){return this._scrollbarState.setScrollSize(g)&&(this._visibilityController.setIsNeeded(this._scrollbarState.isNeeded()),this._shouldRender=!0,this._lazyRender||this.render()),this._shouldRender}_onElementScrollPosition(g){return this._scrollbarState.setScrollPosition(g)&&(this._visibilityController.setIsNeeded(this._scrollbarState.isNeeded()),this._shouldRender=!0,this._lazyRender||this.render()),this._shouldRender}beginReveal(){this._visibilityController.setShouldBeVisible(!0)}beginHide(){this._visibilityController.setShouldBeVisible(!1)}render(){this._shouldRender&&(this._shouldRender=!1,this._renderDomNode(this._scrollbarState.getRectangleLargeSize(),this._scrollbarState.getRectangleSmallSize()),this._updateSlider(this._scrollbarState.getSliderSize(),this._scrollbarState.getArrowSize()+this._scrollbarState.getSliderPosition()))}_domNodePointerDown(g){g.target===this.domNode.domNode&&this._onPointerDown(g)}delegatePointerDown(g){const d=this.domNode.domNode.getClientRects()[0].top,e=d+this._scrollbarState.getSliderPosition(),s=d+this._scrollbarState.getSliderPosition()+this._scrollbarState.getSliderSize(),r=this._sliderPointerPosition(g);e<=r&&r<=s?g.button===0&&(g.preventDefault(),this._sliderPointerDown(g)):this._onPointerDown(g)}_onPointerDown(g){let d,e;if(g.target===this.domNode.domNode&&typeof g.offsetX=="number"&&typeof g.offsetY=="number")d=g.offsetX,e=g.offsetY;else{const r=i.getDomNodePagePosition(this.domNode.domNode);d=g.pageX-r.left,e=g.pageY-r.top}const s=this._pointerDownRelativePosition(d,e);this._setDesiredScrollPositionNow(this._scrollByPage?this._scrollbarState.getDesiredScrollPositionFromOffsetPaged(s):this._scrollbarState.getDesiredScrollPositionFromOffset(s)),g.button===0&&(g.preventDefault(),this._sliderPointerDown(g))}_sliderPointerDown(g){if(!g.target||!(g.target instanceof Element))return;const d=this._sliderPointerPosition(g),e=this._sliderOrthogonalPointerPosition(g),s=this._scrollbarState.clone();this.slider.toggleClassName("active",!0),this._pointerMoveMonitor.startMonitoring(g.target,g.pointerId,g.buttons,r=>{const l=this._sliderOrthogonalPointerPosition(r),o=Math.abs(l-e);if(w.isWindows&&o>u){this._setDesiredScrollPositionNow(s.getScrollPosition());return}const A=this._sliderPointerPosition(r)-d;this._setDesiredScrollPositionNow(s.getDesiredScrollPositionFromDelta(A))},()=>{this.slider.toggleClassName("active",!1),this._host.onDragEnd()}),this._host.onDragStart()}_setDesiredScrollPositionNow(g){const d={};this.writeScrollPosition(d,g),this._scrollable.setScrollPositionNow(d)}updateScrollbarSize(g){this._updateScrollbarSize(g),this._scrollbarState.setScrollbarSize(g),this._shouldRender=!0,this._lazyRender||this.render()}isNeeded(){return this._scrollbarState.isNeeded()}}t.AbstractScrollbar=m}),define(_e[135],Se([1,0,22,77,53,57,20,19]),function(ue,t,i,n,O,I,N,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.HorizontalScrollbar=void 0;class w extends n.AbstractScrollbar{constructor(m,v,g){const d=m.getScrollDimensions(),e=m.getCurrentScrollPosition();if(super({lazyRender:v.lazyRender,host:g,scrollbarState:new I.ScrollbarState(v.horizontalHasArrows?v.arrowSize:0,v.horizontal===b.ScrollbarVisibility.Hidden?0:v.horizontalScrollbarSize,v.vertical===b.ScrollbarVisibility.Hidden?0:v.verticalScrollbarSize,d.width,d.scrollWidth,e.scrollLeft),visibility:v.horizontal,extraScrollbarClassName:"horizontal",scrollable:m,scrollByPage:v.scrollByPage}),v.horizontalHasArrows){const s=(v.arrowSize-O.ARROW_IMG_SIZE)/2,r=(v.horizontalScrollbarSize-O.ARROW_IMG_SIZE)/2;this._createArrow({className:"scra",icon:N.Codicon.scrollbarButtonLeft,top:r,left:s,bottom:void 0,right:void 0,bgWidth:v.arrowSize,bgHeight:v.horizontalScrollbarSize,onActivate:()=>this._host.onMouseWheel(new i.StandardWheelEvent(null,1,0))}),this._createArrow({className:"scra",icon:N.Codicon.scrollbarButtonRight,top:r,left:void 0,bottom:void 0,right:s,bgWidth:v.arrowSize,bgHeight:v.horizontalScrollbarSize,onActivate:()=>this._host.onMouseWheel(new i.StandardWheelEvent(null,-1,0))})}this._createSlider(Math.floor((v.horizontalScrollbarSize-v.horizontalSliderSize)/2),0,void 0,v.horizontalSliderSize)}_updateSlider(m,v){this.slider.setWidth(m),this.slider.setLeft(v)}_renderDomNode(m,v){this.domNode.setWidth(m),this.domNode.setHeight(v),this.domNode.setLeft(0),this.domNode.setBottom(0)}onDidScroll(m){return this._shouldRender=this._onElementScrollSize(m.scrollWidth)||this._shouldRender,this._shouldRender=this._onElementScrollPosition(m.scrollLeft)||this._shouldRender,this._shouldRender=this._onElementSize(m.width)||this._shouldRender,this._shouldRender}_pointerDownRelativePosition(m,v){return m}_sliderPointerPosition(m){return m.pageX}_sliderOrthogonalPointerPosition(m){return m.pageY}_updateScrollbarSize(m){this.slider.setHeight(m)}writeScrollPosition(m,v){m.scrollLeft=v}updateOptions(m){this.updateScrollbarSize(m.horizontal===b.ScrollbarVisibility.Hidden?0:m.horizontalScrollbarSize),this._scrollbarState.setOppositeScrollbarSize(m.vertical===b.ScrollbarVisibility.Hidden?0:m.verticalScrollbarSize),this._visibilityController.setVisibility(m.horizontal),this._scrollByPage=m.scrollByPage}}t.HorizontalScrollbar=w}),define(_e[136],Se([1,0,22,77,53,57,20,19]),function(ue,t,i,n,O,I,N,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.VerticalScrollbar=void 0;class w extends n.AbstractScrollbar{constructor(m,v,g){const d=m.getScrollDimensions(),e=m.getCurrentScrollPosition();if(super({lazyRender:v.lazyRender,host:g,scrollbarState:new I.ScrollbarState(v.verticalHasArrows?v.arrowSize:0,v.vertical===b.ScrollbarVisibility.Hidden?0:v.verticalScrollbarSize,0,d.height,d.scrollHeight,e.scrollTop),visibility:v.vertical,extraScrollbarClassName:"vertical",scrollable:m,scrollByPage:v.scrollByPage}),v.verticalHasArrows){const s=(v.arrowSize-O.ARROW_IMG_SIZE)/2,r=(v.verticalScrollbarSize-O.ARROW_IMG_SIZE)/2;this._createArrow({className:"scra",icon:N.Codicon.scrollbarButtonUp,top:s,left:r,bottom:void 0,right:void 0,bgWidth:v.verticalScrollbarSize,bgHeight:v.arrowSize,onActivate:()=>this._host.onMouseWheel(new i.StandardWheelEvent(null,0,1))}),this._createArrow({className:"scra",icon:N.Codicon.scrollbarButtonDown,top:void 0,left:r,bottom:s,right:void 0,bgWidth:v.verticalScrollbarSize,bgHeight:v.arrowSize,onActivate:()=>this._host.onMouseWheel(new i.StandardWheelEvent(null,0,-1))})}this._createSlider(0,Math.floor((v.verticalScrollbarSize-v.verticalSliderSize)/2),v.verticalSliderSize,void 0)}_updateSlider(m,v){this.slider.setHeight(m),this.slider.setTop(v)}_renderDomNode(m,v){this.domNode.setWidth(v),this.domNode.setHeight(m),this.domNode.setRight(0),this.domNode.setTop(0)}onDidScroll(m){return this._shouldRender=this._onElementScrollSize(m.scrollHeight)||this._shouldRender,this._shouldRender=this._onElementScrollPosition(m.scrollTop)||this._shouldRender,this._shouldRender=this._onElementSize(m.height)||this._shouldRender,this._shouldRender}_pointerDownRelativePosition(m,v){return v}_sliderPointerPosition(m){return m.pageY}_sliderOrthogonalPointerPosition(m){return m.pageX}_updateScrollbarSize(m){this.slider.setWidth(m)}writeScrollPosition(m,v){m.scrollTop=v}updateOptions(m){this.updateScrollbarSize(m.vertical===b.ScrollbarVisibility.Hidden?0:m.verticalScrollbarSize),this._scrollbarState.setOppositeScrollbarSize(0),this._visibilityController.setVisibility(m.vertical),this._scrollByPage=m.scrollByPage}}t.VerticalScrollbar=w}),define(_e[78],Se([1,0,18,4,56,22,135,136,23,13,3,2,5,19,119]),function(ue,t,i,n,O,I,N,b,w,u,m,v,g,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DomScrollableElement=t.SmoothScrollableElement=t.ScrollableElement=t.AbstractScrollableElement=t.MouseWheelClassifier=void 0,n=qe(n),g=qe(g);const e=500,s=50,r=!0;class l{constructor(_,H,B){this.timestamp=_,this.deltaX=H,this.deltaY=B,this.score=0}}class o{static{this.INSTANCE=new o}constructor(){this._capacity=5,this._memory=[],this._front=-1,this._rear=-1}isPhysicalMouseWheel(){if(this._front===-1&&this._rear===-1)return!1;let _=1,H=0,B=1,F=this._rear;do{const E=F===this._front?_:Math.pow(2,-B);if(_-=E,H+=this._memory[F].score*E,F===this._front)break;F=(this._capacity+F-1)%this._capacity,B++}while(!0);return H<=.5}acceptStandardWheelEvent(_){if(i.isChrome){const H=n.getWindow(_.browserEvent),B=(0,i.getZoomFactor)(H);this.accept(Date.now(),_.deltaX*B,_.deltaY*B)}else this.accept(Date.now(),_.deltaX,_.deltaY)}accept(_,H,B){let F=null;const E=new l(_,H,B);this._front===-1&&this._rear===-1?(this._memory[0]=E,this._front=0,this._rear=0):(F=this._memory[this._rear],this._rear=(this._rear+1)%this._capacity,this._rear===this._front&&(this._front=(this._front+1)%this._capacity),this._memory[this._rear]=E),E.score=this._computeScore(E,F)}_computeScore(_,H){if(Math.abs(_.deltaX)>0&&Math.abs(_.deltaY)>0)return 1;let B=.5;if((!this._isAlmostInt(_.deltaX)||!this._isAlmostInt(_.deltaY))&&(B+=.25),H){const F=Math.abs(_.deltaX),E=Math.abs(_.deltaY),k=Math.abs(H.deltaX),W=Math.abs(H.deltaY),R=Math.max(Math.min(F,k),1),C=Math.max(Math.min(E,W),1),$=Math.max(F,k),ee=Math.max(E,W);$%R===0&&ee%C===0&&(B-=.5)}return Math.min(Math.max(B,0),1)}_isAlmostInt(_){return Math.abs(Math.round(_)-_)<.01}}t.MouseWheelClassifier=o;class p extends w.Widget{get options(){return this._options}constructor(_,H,B){super(),this._onScroll=this._register(new m.Emitter),this.onScroll=this._onScroll.event,this._onWillScroll=this._register(new m.Emitter),this.onWillScroll=this._onWillScroll.event,_.style.overflow="hidden",this._options=a(H),this._scrollable=B,this._register(this._scrollable.onScroll(E=>{this._onWillScroll.fire(E),this._onDidScroll(E),this._onScroll.fire(E)}));const F={onMouseWheel:E=>this._onMouseWheel(E),onDragStart:()=>this._onDragStart(),onDragEnd:()=>this._onDragEnd()};this._verticalScrollbar=this._register(new b.VerticalScrollbar(this._scrollable,this._options,F)),this._horizontalScrollbar=this._register(new N.HorizontalScrollbar(this._scrollable,this._options,F)),this._domNode=document.createElement("div"),this._domNode.className="monaco-scrollable-element "+this._options.className,this._domNode.setAttribute("role","presentation"),this._domNode.style.position="relative",this._domNode.style.overflow="hidden",this._domNode.appendChild(_),this._domNode.appendChild(this._horizontalScrollbar.domNode.domNode),this._domNode.appendChild(this._verticalScrollbar.domNode.domNode),this._options.useShadows?(this._leftShadowDomNode=(0,O.createFastDomNode)(document.createElement("div")),this._leftShadowDomNode.setClassName("shadow"),this._domNode.appendChild(this._leftShadowDomNode.domNode),this._topShadowDomNode=(0,O.createFastDomNode)(document.createElement("div")),this._topShadowDomNode.setClassName("shadow"),this._domNode.appendChild(this._topShadowDomNode.domNode),this._topLeftShadowDomNode=(0,O.createFastDomNode)(document.createElement("div")),this._topLeftShadowDomNode.setClassName("shadow"),this._domNode.appendChild(this._topLeftShadowDomNode.domNode)):(this._leftShadowDomNode=null,this._topShadowDomNode=null,this._topLeftShadowDomNode=null),this._listenOnDomNode=this._options.listenOnDomNode||this._domNode,this._mouseWheelToDispose=[],this._setListeningToMouseWheel(this._options.handleMouseWheel),this.onmouseover(this._listenOnDomNode,E=>this._onMouseOver(E)),this.onmouseleave(this._listenOnDomNode,E=>this._onMouseLeave(E)),this._hideTimeout=this._register(new u.TimeoutTimer),this._isDragging=!1,this._mouseIsOver=!1,this._shouldRender=!0,this._revealOnScroll=!0}dispose(){this._mouseWheelToDispose=(0,v.dispose)(this._mouseWheelToDispose),super.dispose()}getDomNode(){return this._domNode}getOverviewRulerLayoutInfo(){return{parent:this._domNode,insertBefore:this._verticalScrollbar.domNode.domNode}}delegateVerticalScrollbarPointerDown(_){this._verticalScrollbar.delegatePointerDown(_)}getScrollDimensions(){return this._scrollable.getScrollDimensions()}setScrollDimensions(_){this._scrollable.setScrollDimensions(_,!1)}updateClassName(_){this._options.className=_,g.isMacintosh&&(this._options.className+=" mac"),this._domNode.className="monaco-scrollable-element "+this._options.className}updateOptions(_){typeof _.handleMouseWheel<"u"&&(this._options.handleMouseWheel=_.handleMouseWheel,this._setListeningToMouseWheel(this._options.handleMouseWheel)),typeof _.mouseWheelScrollSensitivity<"u"&&(this._options.mouseWheelScrollSensitivity=_.mouseWheelScrollSensitivity),typeof _.fastScrollSensitivity<"u"&&(this._options.fastScrollSensitivity=_.fastScrollSensitivity),typeof _.scrollPredominantAxis<"u"&&(this._options.scrollPredominantAxis=_.scrollPredominantAxis),typeof _.horizontal<"u"&&(this._options.horizontal=_.horizontal),typeof _.vertical<"u"&&(this._options.vertical=_.vertical),typeof _.horizontalScrollbarSize<"u"&&(this._options.horizontalScrollbarSize=_.horizontalScrollbarSize),typeof _.verticalScrollbarSize<"u"&&(this._options.verticalScrollbarSize=_.verticalScrollbarSize),typeof _.scrollByPage<"u"&&(this._options.scrollByPage=_.scrollByPage),this._horizontalScrollbar.updateOptions(this._options),this._verticalScrollbar.updateOptions(this._options),this._options.lazyRender||this._render()}setRevealOnScroll(_){this._revealOnScroll=_}delegateScrollFromMouseWheelEvent(_){this._onMouseWheel(new I.StandardWheelEvent(_))}_setListeningToMouseWheel(_){if(this._mouseWheelToDispose.length>0!==_&&(this._mouseWheelToDispose=(0,v.dispose)(this._mouseWheelToDispose),_)){const B=F=>{this._onMouseWheel(new I.StandardWheelEvent(F))};this._mouseWheelToDispose.push(n.addDisposableListener(this._listenOnDomNode,n.EventType.MOUSE_WHEEL,B,{passive:!1}))}}_onMouseWheel(_){if(_.browserEvent?.defaultPrevented)return;const H=o.INSTANCE;r&&H.acceptStandardWheelEvent(_);let B=!1;if(_.deltaY||_.deltaX){let E=_.deltaY*this._options.mouseWheelScrollSensitivity,k=_.deltaX*this._options.mouseWheelScrollSensitivity;this._options.scrollPredominantAxis&&(this._options.scrollYToX&&k+E===0?k=E=0:Math.abs(E)>=Math.abs(k)?k=0:E=0),this._options.flipAxes&&([E,k]=[k,E]);const W=!g.isMacintosh&&_.browserEvent&&_.browserEvent.shiftKey;(this._options.scrollYToX||W)&&!k&&(k=E,E=0),_.browserEvent&&_.browserEvent.altKey&&(k=k*this._options.fastScrollSensitivity,E=E*this._options.fastScrollSensitivity);const R=this._scrollable.getFutureScrollPosition();let C={};if(E){const $=s*E,ee=R.scrollTop-($<0?Math.floor($):Math.ceil($));this._verticalScrollbar.writeScrollPosition(C,ee)}if(k){const $=s*k,ee=R.scrollLeft-($<0?Math.floor($):Math.ceil($));this._horizontalScrollbar.writeScrollPosition(C,ee)}C=this._scrollable.validateScrollPosition(C),(R.scrollLeft!==C.scrollLeft||R.scrollTop!==C.scrollTop)&&(r&&this._options.mouseWheelSmoothScroll&&H.isPhysicalMouseWheel()?this._scrollable.setScrollPositionSmooth(C):this._scrollable.setScrollPositionNow(C),B=!0)}let F=B;!F&&this._options.alwaysConsumeMouseWheel&&(F=!0),!F&&this._options.consumeMouseWheelIfScrollbarIsNeeded&&(this._verticalScrollbar.isNeeded()||this._horizontalScrollbar.isNeeded())&&(F=!0),F&&(_.preventDefault(),_.stopPropagation())}_onDidScroll(_){this._shouldRender=this._horizontalScrollbar.onDidScroll(_)||this._shouldRender,this._shouldRender=this._verticalScrollbar.onDidScroll(_)||this._shouldRender,this._options.useShadows&&(this._shouldRender=!0),this._revealOnScroll&&this._reveal(),this._options.lazyRender||this._render()}renderNow(){if(!this._options.lazyRender)throw new Error("Please use `lazyRender` together with `renderNow`!");this._render()}_render(){if(this._shouldRender&&(this._shouldRender=!1,this._horizontalScrollbar.render(),this._verticalScrollbar.render(),this._options.useShadows)){const _=this._scrollable.getCurrentScrollPosition(),H=_.scrollTop>0,B=_.scrollLeft>0,F=B?" left":"",E=H?" top":"",k=B||H?" top-left-corner":"";this._leftShadowDomNode.setClassName(`shadow${F}`),this._topShadowDomNode.setClassName(`shadow${E}`),this._topLeftShadowDomNode.setClassName(`shadow${k}${E}${F}`)}}_onDragStart(){this._isDragging=!0,this._reveal()}_onDragEnd(){this._isDragging=!1,this._hide()}_onMouseLeave(_){this._mouseIsOver=!1,this._hide()}_onMouseOver(_){this._mouseIsOver=!0,this._reveal()}_reveal(){this._verticalScrollbar.beginReveal(),this._horizontalScrollbar.beginReveal(),this._scheduleHide()}_hide(){!this._mouseIsOver&&!this._isDragging&&(this._verticalScrollbar.beginHide(),this._horizontalScrollbar.beginHide())}_scheduleHide(){!this._mouseIsOver&&!this._isDragging&&this._hideTimeout.cancelAndSet(()=>this._hide(),e)}}t.AbstractScrollableElement=p;class A extends p{constructor(_,H){H=H||{},H.mouseWheelSmoothScroll=!1;const B=new d.Scrollable({forceIntegerValues:!0,smoothScrollDuration:0,scheduleAtNextAnimationFrame:F=>n.scheduleAtNextAnimationFrame(n.getWindow(_),F)});super(_,H,B),this._register(B)}setScrollPosition(_){this._scrollable.setScrollPositionNow(_)}getScrollPosition(){return this._scrollable.getCurrentScrollPosition()}}t.ScrollableElement=A;class L extends p{constructor(_,H,B){super(_,H,B)}setScrollPosition(_){_.reuseAnimation?this._scrollable.setScrollPositionSmooth(_,_.reuseAnimation):this._scrollable.setScrollPositionNow(_)}getScrollPosition(){return this._scrollable.getCurrentScrollPosition()}}t.SmoothScrollableElement=L;class c extends p{constructor(_,H){H=H||{},H.mouseWheelSmoothScroll=!1;const B=new d.Scrollable({forceIntegerValues:!1,smoothScrollDuration:0,scheduleAtNextAnimationFrame:F=>n.scheduleAtNextAnimationFrame(n.getWindow(_),F)});super(_,H,B),this._register(B),this._element=_,this._register(this.onScroll(F=>{F.scrollTopChanged&&(this._element.scrollTop=F.scrollTop),F.scrollLeftChanged&&(this._element.scrollLeft=F.scrollLeft)})),this.scanDomNode()}setScrollPosition(_){this._scrollable.setScrollPositionNow(_)}getScrollPosition(){return this._scrollable.getCurrentScrollPosition()}scanDomNode(){this.setScrollDimensions({width:this._element.clientWidth,scrollWidth:this._element.scrollWidth,height:this._element.clientHeight,scrollHeight:this._element.scrollHeight}),this.setScrollPosition({scrollLeft:this._element.scrollLeft,scrollTop:this._element.scrollTop})}}t.DomScrollableElement=c;function a(f){const _={lazyRender:typeof f.lazyRender<"u"?f.lazyRender:!1,className:typeof f.className<"u"?f.className:"",useShadows:typeof f.useShadows<"u"?f.useShadows:!0,handleMouseWheel:typeof f.handleMouseWheel<"u"?f.handleMouseWheel:!0,flipAxes:typeof f.flipAxes<"u"?f.flipAxes:!1,consumeMouseWheelIfScrollbarIsNeeded:typeof f.consumeMouseWheelIfScrollbarIsNeeded<"u"?f.consumeMouseWheelIfScrollbarIsNeeded:!1,alwaysConsumeMouseWheel:typeof f.alwaysConsumeMouseWheel<"u"?f.alwaysConsumeMouseWheel:!1,scrollYToX:typeof f.scrollYToX<"u"?f.scrollYToX:!1,mouseWheelScrollSensitivity:typeof f.mouseWheelScrollSensitivity<"u"?f.mouseWheelScrollSensitivity:1,fastScrollSensitivity:typeof f.fastScrollSensitivity<"u"?f.fastScrollSensitivity:5,scrollPredominantAxis:typeof f.scrollPredominantAxis<"u"?f.scrollPredominantAxis:!0,mouseWheelSmoothScroll:typeof f.mouseWheelSmoothScroll<"u"?f.mouseWheelSmoothScroll:!0,arrowSize:typeof f.arrowSize<"u"?f.arrowSize:11,listenOnDomNode:typeof f.listenOnDomNode<"u"?f.listenOnDomNode:null,horizontal:typeof f.horizontal<"u"?f.horizontal:d.ScrollbarVisibility.Auto,horizontalScrollbarSize:typeof f.horizontalScrollbarSize<"u"?f.horizontalScrollbarSize:10,horizontalSliderSize:typeof f.horizontalSliderSize<"u"?f.horizontalSliderSize:0,horizontalHasArrows:typeof f.horizontalHasArrows<"u"?f.horizontalHasArrows:!1,vertical:typeof f.vertical<"u"?f.vertical:d.ScrollbarVisibility.Auto,verticalScrollbarSize:typeof f.verticalScrollbarSize<"u"?f.verticalScrollbarSize:10,verticalHasArrows:typeof f.verticalHasArrows<"u"?f.verticalHasArrows:!1,verticalSliderSize:typeof f.verticalSliderSize<"u"?f.verticalSliderSize:0,scrollByPage:typeof f.scrollByPage<"u"?f.scrollByPage:!1};return _.horizontalSliderSize=typeof f.horizontalSliderSize<"u"?f.horizontalSliderSize:_.horizontalScrollbarSize,_.verticalSliderSize=typeof f.verticalSliderSize<"u"?f.verticalSliderSize:_.verticalScrollbarSize,g.isMacintosh&&(_.className+=" mac"),_}}),define(_e[79],Se([1,0,72,4,28,32,78,9,13,35,3,2,46,19,41,99,131,6,37]),function(ue,t,i,n,O,I,N,b,w,u,m,v,g,d,e,s,r,l,o){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ListView=t.NativeDragAndDropData=t.ExternalElementsDragAndDropData=t.ElementsDragAndDropData=t.ListViewTargetSector=void 0;const p={CurrentDragAndDropData:void 0};var A;(function(F){F[F.TOP=0]="TOP",F[F.CENTER_TOP=1]="CENTER_TOP",F[F.CENTER_BOTTOM=2]="CENTER_BOTTOM",F[F.BOTTOM=3]="BOTTOM"})(A||(t.ListViewTargetSector=A={}));const L={useShadows:!0,verticalScrollMode:d.ScrollbarVisibility.Auto,setRowLineHeight:!0,setRowHeight:!0,supportDynamicHeights:!1,dnd:{getDragElements(F){return[F]},getDragURI(){return null},onDragStart(){},onDragOver(){return!1},drop(){},dispose(){}},horizontalScrolling:!1,transformOptimization:!0,alwaysConsumeMouseWheel:!0};class c{get context(){return this._context}set context(E){this._context=E}constructor(E){this.elements=E}update(){}getData(){return this.elements}}t.ElementsDragAndDropData=c;class a{constructor(E){this.elements=E}update(){}getData(){return this.elements}}t.ExternalElementsDragAndDropData=a;class f{constructor(){this.types=[],this.files=[]}update(E){if(E.types&&this.types.splice(0,this.types.length,...E.types),E.files){this.files.splice(0,this.files.length);for(let k=0;k<E.files.length;k++){const W=E.files.item(k);W&&(W.size||W.type)&&this.files.push(W)}}}getData(){return{types:this.types,files:this.files}}}t.NativeDragAndDropData=f;function _(F,E){return Array.isArray(F)&&Array.isArray(E)?(0,b.equals)(F,E):F===E}class H{constructor(E){E?.getSetSize?this.getSetSize=E.getSetSize.bind(E):this.getSetSize=(k,W,R)=>R,E?.getPosInSet?this.getPosInSet=E.getPosInSet.bind(E):this.getPosInSet=(k,W)=>W+1,E?.getRole?this.getRole=E.getRole.bind(E):this.getRole=k=>"listitem",E?.isChecked?this.isChecked=E.isChecked.bind(E):this.isChecked=k=>{}}}class B{static{this.InstanceCount=0}get contentHeight(){return this.rangeMap.size}get contentWidth(){return this.scrollWidth??0}get onDidScroll(){return this.scrollableElement.onScroll}get onWillScroll(){return this.scrollableElement.onWillScroll}get containerDomNode(){return this.rowsContainer}get scrollableElementDomNode(){return this.scrollableElement.getDomNode()}get horizontalScrolling(){return this._horizontalScrolling}set horizontalScrolling(E){if(E!==this._horizontalScrolling){if(E&&this.supportDynamicHeights)throw new Error("Horizontal scrolling and dynamic heights not supported simultaneously");if(this._horizontalScrolling=E,this.domNode.classList.toggle("horizontal-scrolling",this._horizontalScrolling),this._horizontalScrolling){for(const k of this.items)this.measureItemWidth(k);this.updateScrollWidth(),this.scrollableElement.setScrollDimensions({width:(0,n.getContentWidth)(this.domNode)}),this.rowsContainer.style.width=`${Math.max(this.scrollWidth||0,this.renderWidth)}px`}else this.scrollableElementWidthDelayer.cancel(),this.scrollableElement.setScrollDimensions({width:this.renderWidth,scrollWidth:this.renderWidth}),this.rowsContainer.style.width=""}}constructor(E,k,W,R=L){if(this.virtualDelegate=k,this.domId=`list_id_${++B.InstanceCount}`,this.renderers=new Map,this.renderWidth=0,this._scrollHeight=0,this.scrollableElementUpdateDisposable=null,this.scrollableElementWidthDelayer=new w.Delayer(50),this.splicing=!1,this.dragOverAnimationStopDisposable=v.Disposable.None,this.dragOverMouseY=0,this.canDrop=!1,this.currentDragFeedbackDisposable=v.Disposable.None,this.onDragLeaveTimeout=v.Disposable.None,this.disposables=new v.DisposableStore,this._onDidChangeContentHeight=new m.Emitter,this._onDidChangeContentWidth=new m.Emitter,this.onDidChangeContentHeight=m.Event.latch(this._onDidChangeContentHeight.event,void 0,this.disposables),this.onDidChangeContentWidth=m.Event.latch(this._onDidChangeContentWidth.event,void 0,this.disposables),this._horizontalScrolling=!1,R.horizontalScrolling&&R.supportDynamicHeights)throw new Error("Horizontal scrolling and dynamic heights not supported simultaneously");this.items=[],this.itemId=0,this.rangeMap=this.createRangeMap(R.paddingTop??0);for(const $ of W)this.renderers.set($.templateId,$);this.cache=this.disposables.add(new r.RowCache(this.renderers)),this.lastRenderTop=0,this.lastRenderHeight=0,this.domNode=document.createElement("div"),this.domNode.className="monaco-list",this.domNode.classList.add(this.domId),this.domNode.tabIndex=0,this.domNode.classList.toggle("mouse-support",typeof R.mouseSupport=="boolean"?R.mouseSupport:!0),this._horizontalScrolling=R.horizontalScrolling??L.horizontalScrolling,this.domNode.classList.toggle("horizontal-scrolling",this._horizontalScrolling),this.paddingBottom=typeof R.paddingBottom>"u"?0:R.paddingBottom,this.accessibilityProvider=new H(R.accessibilityProvider),this.rowsContainer=document.createElement("div"),this.rowsContainer.className="monaco-list-rows",(R.transformOptimization??L.transformOptimization)&&(this.rowsContainer.style.transform="translate3d(0px, 0px, 0px)",this.rowsContainer.style.overflow="hidden",this.rowsContainer.style.contain="strict"),this.disposables.add(I.Gesture.addTarget(this.rowsContainer)),this.scrollable=this.disposables.add(new d.Scrollable({forceIntegerValues:!0,smoothScrollDuration:R.smoothScrolling??!1?125:0,scheduleAtNextAnimationFrame:$=>(0,n.scheduleAtNextAnimationFrame)((0,n.getWindow)(this.domNode),$)})),this.scrollableElement=this.disposables.add(new N.SmoothScrollableElement(this.rowsContainer,{alwaysConsumeMouseWheel:R.alwaysConsumeMouseWheel??L.alwaysConsumeMouseWheel,horizontal:d.ScrollbarVisibility.Auto,vertical:R.verticalScrollMode??L.verticalScrollMode,useShadows:R.useShadows??L.useShadows,mouseWheelScrollSensitivity:R.mouseWheelScrollSensitivity,fastScrollSensitivity:R.fastScrollSensitivity,scrollByPage:R.scrollByPage},this.scrollable)),this.domNode.appendChild(this.scrollableElement.getDomNode()),E.appendChild(this.domNode),this.scrollableElement.onScroll(this.onScroll,this,this.disposables),this.disposables.add((0,n.addDisposableListener)(this.rowsContainer,I.EventType.Change,$=>this.onTouchChange($))),this.disposables.add((0,n.addDisposableListener)(this.scrollableElement.getDomNode(),"scroll",$=>$.target.scrollTop=0)),this.disposables.add((0,n.addDisposableListener)(this.domNode,"dragover",$=>this.onDragOver(this.toDragEvent($)))),this.disposables.add((0,n.addDisposableListener)(this.domNode,"drop",$=>this.onDrop(this.toDragEvent($)))),this.disposables.add((0,n.addDisposableListener)(this.domNode,"dragleave",$=>this.onDragLeave(this.toDragEvent($)))),this.disposables.add((0,n.addDisposableListener)(this.domNode,"dragend",$=>this.onDragEnd($))),this.setRowLineHeight=R.setRowLineHeight??L.setRowLineHeight,this.setRowHeight=R.setRowHeight??L.setRowHeight,this.supportDynamicHeights=R.supportDynamicHeights??L.supportDynamicHeights,this.dnd=R.dnd??this.disposables.add(L.dnd),this.layout(R.initialSize?.height,R.initialSize?.width)}updateOptions(E){E.paddingBottom!==void 0&&(this.paddingBottom=E.paddingBottom,this.scrollableElement.setScrollDimensions({scrollHeight:this.scrollHeight})),E.smoothScrolling!==void 0&&this.scrollable.setSmoothScrollDuration(E.smoothScrolling?125:0),E.horizontalScrolling!==void 0&&(this.horizontalScrolling=E.horizontalScrolling);let k;if(E.scrollByPage!==void 0&&(k={...k??{},scrollByPage:E.scrollByPage}),E.mouseWheelScrollSensitivity!==void 0&&(k={...k??{},mouseWheelScrollSensitivity:E.mouseWheelScrollSensitivity}),E.fastScrollSensitivity!==void 0&&(k={...k??{},fastScrollSensitivity:E.fastScrollSensitivity}),k&&this.scrollableElement.updateOptions(k),E.paddingTop!==void 0&&E.paddingTop!==this.rangeMap.paddingTop){const W=this.getRenderRange(this.lastRenderTop,this.lastRenderHeight),R=E.paddingTop-this.rangeMap.paddingTop;this.rangeMap.paddingTop=E.paddingTop,this.render(W,Math.max(0,this.lastRenderTop+R),this.lastRenderHeight,void 0,void 0,!0),this.setScrollTop(this.lastRenderTop),this.eventuallyUpdateScrollDimensions(),this.supportDynamicHeights&&this._rerender(this.lastRenderTop,this.lastRenderHeight)}}delegateScrollFromMouseWheelEvent(E){this.scrollableElement.delegateScrollFromMouseWheelEvent(E)}delegateVerticalScrollbarPointerDown(E){this.scrollableElement.delegateVerticalScrollbarPointerDown(E)}updateElementHeight(E,k,W){if(E<0||E>=this.items.length)return;const R=this.items[E].size;if(typeof k>"u"){if(!this.supportDynamicHeights){console.warn("Dynamic heights not supported",new Error().stack);return}this.items[E].lastDynamicHeightWidth=void 0,k=R+this.probeDynamicHeight(E)}if(R===k)return;const C=this.getRenderRange(this.lastRenderTop,this.lastRenderHeight);let $=0;E<C.start||W!==null&&W>E&&W<C.end?$=k-R:$=0,this.rangeMap.splice(E,1,[{size:k}]),this.items[E].size=k,this.render(C,Math.max(0,this.lastRenderTop+$),this.lastRenderHeight,void 0,void 0,!0),this.setScrollTop(this.lastRenderTop),this.eventuallyUpdateScrollDimensions(),this.supportDynamicHeights&&this._rerender(this.lastRenderTop,this.lastRenderHeight)}createRangeMap(E){return new s.RangeMap(E)}splice(E,k,W=[]){if(this.splicing)throw new Error("Can't run recursive splices.");this.splicing=!0;try{return this._splice(E,k,W)}finally{this.splicing=!1,this._onDidChangeContentHeight.fire(this.contentHeight)}}_splice(E,k,W=[]){const R=this.getRenderRange(this.lastRenderTop,this.lastRenderHeight),C={start:E,end:E+k},$=g.Range.intersect(R,C),ee=new Map;for(let Ee=$.end-1;Ee>=$.start;Ee--){const Le=this.items[Ee];if(Le.dragStartDisposable.dispose(),Le.checkedDisposable.dispose(),Le.row){let Ce=ee.get(Le.templateId);Ce||(Ce=[],ee.set(Le.templateId,Ce));const Fe=this.renderers.get(Le.templateId);Fe&&Fe.disposeElement&&Fe.disposeElement(Le.element,Ee,Le.row.templateData,Le.size),Ce.unshift(Le.row)}Le.row=null,Le.stale=!0}const Y={start:E+k,end:this.items.length},Z=g.Range.intersect(Y,R),ce=g.Range.relativeComplement(Y,R),he=W.map(Ee=>({id:String(this.itemId++),element:Ee,templateId:this.virtualDelegate.getTemplateId(Ee),size:this.virtualDelegate.getHeight(Ee),width:void 0,hasDynamicHeight:!!this.virtualDelegate.hasDynamicHeight&&this.virtualDelegate.hasDynamicHeight(Ee),lastDynamicHeightWidth:void 0,row:null,uri:void 0,dropTarget:!1,dragStartDisposable:v.Disposable.None,checkedDisposable:v.Disposable.None,stale:!1}));let ye;E===0&&k>=this.items.length?(this.rangeMap=this.createRangeMap(this.rangeMap.paddingTop),this.rangeMap.splice(0,0,he),ye=this.items,this.items=he):(this.rangeMap.splice(E,k,he),ye=this.items.splice(E,k,...he));const Re=W.length-k,Pe=this.getRenderRange(this.lastRenderTop,this.lastRenderHeight),re=(0,s.shift)(Z,Re),ie=g.Range.intersect(Pe,re);for(let Ee=ie.start;Ee<ie.end;Ee++)this.updateItemInDOM(this.items[Ee],Ee);const fe=g.Range.relativeComplement(re,Pe);for(const Ee of fe)for(let Le=Ee.start;Le<Ee.end;Le++)this.removeItemFromDOM(Le);const ve=ce.map(Ee=>(0,s.shift)(Ee,Re)),ne=[{start:E,end:E+W.length},...ve].map(Ee=>g.Range.intersect(Pe,Ee)).reverse();for(const Ee of ne)for(let Le=Ee.end-1;Le>=Ee.start;Le--){const Ce=this.items[Le],ze=ee.get(Ce.templateId)?.pop();this.insertItemInDOM(Le,ze)}for(const Ee of ee.values())for(const Le of Ee)this.cache.release(Le);return this.eventuallyUpdateScrollDimensions(),this.supportDynamicHeights&&this._rerender(this.scrollTop,this.renderHeight),ye.map(Ee=>Ee.element)}eventuallyUpdateScrollDimensions(){this._scrollHeight=this.contentHeight,this.rowsContainer.style.height=`${this._scrollHeight}px`,this.scrollableElementUpdateDisposable||(this.scrollableElementUpdateDisposable=(0,n.scheduleAtNextAnimationFrame)((0,n.getWindow)(this.domNode),()=>{this.scrollableElement.setScrollDimensions({scrollHeight:this.scrollHeight}),this.updateScrollWidth(),this.scrollableElementUpdateDisposable=null}))}eventuallyUpdateScrollWidth(){if(!this.horizontalScrolling){this.scrollableElementWidthDelayer.cancel();return}this.scrollableElementWidthDelayer.trigger(()=>this.updateScrollWidth())}updateScrollWidth(){if(!this.horizontalScrolling)return;let E=0;for(const k of this.items)typeof k.width<"u"&&(E=Math.max(E,k.width));this.scrollWidth=E,this.scrollableElement.setScrollDimensions({scrollWidth:E===0?0:E+10}),this._onDidChangeContentWidth.fire(this.scrollWidth)}updateWidth(E){if(!this.horizontalScrolling||typeof this.scrollWidth>"u")return;const k=this.items[E];this.measureItemWidth(k),typeof k.width<"u"&&k.width>this.scrollWidth&&(this.scrollWidth=k.width,this.scrollableElement.setScrollDimensions({scrollWidth:this.scrollWidth+10}),this._onDidChangeContentWidth.fire(this.scrollWidth))}rerender(){if(this.supportDynamicHeights){for(const E of this.items)E.lastDynamicHeightWidth=void 0;this._rerender(this.lastRenderTop,this.lastRenderHeight)}}get length(){return this.items.length}get renderHeight(){return this.scrollableElement.getScrollDimensions().height}get firstVisibleIndex(){return this.getRenderRange(this.lastRenderTop,this.lastRenderHeight).start}get firstMostlyVisibleIndex(){const E=this.firstVisibleIndex,k=this.rangeMap.positionAt(E),W=this.rangeMap.positionAt(E+1);return W!==-1&&(W-k)/2+k<this.scrollTop?E+1:E}get lastVisibleIndex(){return this.getRenderRange(this.lastRenderTop,this.lastRenderHeight).end-1}element(E){return this.items[E].element}indexOf(E){return this.items.findIndex(k=>k.element===E)}domElement(E){const k=this.items[E].row;return k&&k.domNode}elementHeight(E){return this.items[E].size}elementTop(E){return this.rangeMap.positionAt(E)}indexAt(E){return this.rangeMap.indexAt(E)}indexAfter(E){return this.rangeMap.indexAfter(E)}layout(E,k){const W={height:typeof E=="number"?E:(0,n.getContentHeight)(this.domNode)};this.scrollableElementUpdateDisposable&&(this.scrollableElementUpdateDisposable.dispose(),this.scrollableElementUpdateDisposable=null,W.scrollHeight=this.scrollHeight),this.scrollableElement.setScrollDimensions(W),typeof k<"u"&&(this.renderWidth=k,this.supportDynamicHeights&&this._rerender(this.scrollTop,this.renderHeight)),this.horizontalScrolling&&this.scrollableElement.setScrollDimensions({width:typeof k=="number"?k:(0,n.getContentWidth)(this.domNode)})}render(E,k,W,R,C,$=!1){const ee=this.getRenderRange(k,W),Y=g.Range.relativeComplement(ee,E).reverse(),Z=g.Range.relativeComplement(E,ee);if($){const ce=g.Range.intersect(E,ee);for(let he=ce.start;he<ce.end;he++)this.updateItemInDOM(this.items[he],he)}this.cache.transact(()=>{for(const ce of Z)for(let he=ce.start;he<ce.end;he++)this.removeItemFromDOM(he);for(const ce of Y)for(let he=ce.end-1;he>=ce.start;he--)this.insertItemInDOM(he)}),R!==void 0&&(this.rowsContainer.style.left=`-${R}px`),this.rowsContainer.style.top=`-${k}px`,this.horizontalScrolling&&C!==void 0&&(this.rowsContainer.style.width=`${Math.max(C,this.renderWidth)}px`),this.lastRenderTop=k,this.lastRenderHeight=W}insertItemInDOM(E,k){const W=this.items[E];if(!W.row)if(k)W.row=k,W.stale=!0;else{const Y=this.cache.alloc(W.templateId);W.row=Y.row,W.stale||=Y.isReusingConnectedDomNode}const R=this.accessibilityProvider.getRole(W.element)||"listitem";W.row.domNode.setAttribute("role",R);const C=this.accessibilityProvider.isChecked(W.element);if(typeof C=="boolean")W.row.domNode.setAttribute("aria-checked",String(!!C));else if(C){const Y=Z=>W.row.domNode.setAttribute("aria-checked",String(!!Z));Y(C.value),W.checkedDisposable=C.onDidChange(()=>Y(C.value))}if(W.stale||!W.row.domNode.parentElement){const Y=this.items.at(E+1)?.row?.domNode??null;(W.row.domNode.parentElement!==this.rowsContainer||W.row.domNode.nextElementSibling!==Y)&&this.rowsContainer.insertBefore(W.row.domNode,Y),W.stale=!1}this.updateItemInDOM(W,E);const $=this.renderers.get(W.templateId);if(!$)throw new Error(`No renderer found for template id ${W.templateId}`);$?.renderElement(W.element,E,W.row.templateData,W.size);const ee=this.dnd.getDragURI(W.element);W.dragStartDisposable.dispose(),W.row.domNode.draggable=!!ee,ee&&(W.dragStartDisposable=(0,n.addDisposableListener)(W.row.domNode,"dragstart",Y=>this.onDragStart(W.element,ee,Y))),this.horizontalScrolling&&(this.measureItemWidth(W),this.eventuallyUpdateScrollWidth())}measureItemWidth(E){if(!E.row||!E.row.domNode)return;E.row.domNode.style.width="fit-content",E.width=(0,n.getContentWidth)(E.row.domNode);const k=(0,n.getWindow)(E.row.domNode).getComputedStyle(E.row.domNode);k.paddingLeft&&(E.width+=parseFloat(k.paddingLeft)),k.paddingRight&&(E.width+=parseFloat(k.paddingRight)),E.row.domNode.style.width=""}updateItemInDOM(E,k){E.row.domNode.style.top=`${this.elementTop(k)}px`,this.setRowHeight&&(E.row.domNode.style.height=`${E.size}px`),this.setRowLineHeight&&(E.row.domNode.style.lineHeight=`${E.size}px`),E.row.domNode.setAttribute("data-index",`${k}`),E.row.domNode.setAttribute("data-last-element",k===this.length-1?"true":"false"),E.row.domNode.setAttribute("data-parity",k%2===0?"even":"odd"),E.row.domNode.setAttribute("aria-setsize",String(this.accessibilityProvider.getSetSize(E.element,k,this.length))),E.row.domNode.setAttribute("aria-posinset",String(this.accessibilityProvider.getPosInSet(E.element,k))),E.row.domNode.setAttribute("id",this.getElementDomId(k)),E.row.domNode.classList.toggle("drop-target",E.dropTarget)}removeItemFromDOM(E){const k=this.items[E];if(k.dragStartDisposable.dispose(),k.checkedDisposable.dispose(),k.row){const W=this.renderers.get(k.templateId);W&&W.disposeElement&&W.disposeElement(k.element,E,k.row.templateData,k.size),this.cache.release(k.row),k.row=null}this.horizontalScrolling&&this.eventuallyUpdateScrollWidth()}getScrollTop(){return this.scrollableElement.getScrollPosition().scrollTop}setScrollTop(E,k){this.scrollableElementUpdateDisposable&&(this.scrollableElementUpdateDisposable.dispose(),this.scrollableElementUpdateDisposable=null,this.scrollableElement.setScrollDimensions({scrollHeight:this.scrollHeight})),this.scrollableElement.setScrollPosition({scrollTop:E,reuseAnimation:k})}getScrollLeft(){return this.scrollableElement.getScrollPosition().scrollLeft}setScrollLeft(E){this.scrollableElementUpdateDisposable&&(this.scrollableElementUpdateDisposable.dispose(),this.scrollableElementUpdateDisposable=null,this.scrollableElement.setScrollDimensions({scrollWidth:this.scrollWidth})),this.scrollableElement.setScrollPosition({scrollLeft:E})}get scrollTop(){return this.getScrollTop()}set scrollTop(E){this.setScrollTop(E)}get scrollHeight(){return this._scrollHeight+(this.horizontalScrolling?10:0)+this.paddingBottom}get onMouseClick(){return m.Event.map(this.disposables.add(new O.DomEmitter(this.domNode,"click")).event,E=>this.toMouseEvent(E),this.disposables)}get onMouseDblClick(){return m.Event.map(this.disposables.add(new O.DomEmitter(this.domNode,"dblclick")).event,E=>this.toMouseEvent(E),this.disposables)}get onMouseMiddleClick(){return m.Event.filter(m.Event.map(this.disposables.add(new O.DomEmitter(this.domNode,"auxclick")).event,E=>this.toMouseEvent(E),this.disposables),E=>E.browserEvent.button===1,this.disposables)}get onMouseUp(){return m.Event.map(this.disposables.add(new O.DomEmitter(this.domNode,"mouseup")).event,E=>this.toMouseEvent(E),this.disposables)}get onMouseDown(){return m.Event.map(this.disposables.add(new O.DomEmitter(this.domNode,"mousedown")).event,E=>this.toMouseEvent(E),this.disposables)}get onMouseOver(){return m.Event.map(this.disposables.add(new O.DomEmitter(this.domNode,"mouseover")).event,E=>this.toMouseEvent(E),this.disposables)}get onMouseMove(){return m.Event.map(this.disposables.add(new O.DomEmitter(this.domNode,"mousemove")).event,E=>this.toMouseEvent(E),this.disposables)}get onMouseOut(){return m.Event.map(this.disposables.add(new O.DomEmitter(this.domNode,"mouseout")).event,E=>this.toMouseEvent(E),this.disposables)}get onContextMenu(){return m.Event.any(m.Event.map(this.disposables.add(new O.DomEmitter(this.domNode,"contextmenu")).event,E=>this.toMouseEvent(E),this.disposables),m.Event.map(this.disposables.add(new O.DomEmitter(this.domNode,I.EventType.Contextmenu)).event,E=>this.toGestureEvent(E),this.disposables))}get onTouchStart(){return m.Event.map(this.disposables.add(new O.DomEmitter(this.domNode,"touchstart")).event,E=>this.toTouchEvent(E),this.disposables)}get onTap(){return m.Event.map(this.disposables.add(new O.DomEmitter(this.rowsContainer,I.EventType.Tap)).event,E=>this.toGestureEvent(E),this.disposables)}toMouseEvent(E){const k=this.getItemIndexFromEventTarget(E.target||null),W=typeof k>"u"?void 0:this.items[k],R=W&&W.element;return{browserEvent:E,index:k,element:R}}toTouchEvent(E){const k=this.getItemIndexFromEventTarget(E.target||null),W=typeof k>"u"?void 0:this.items[k],R=W&&W.element;return{browserEvent:E,index:k,element:R}}toGestureEvent(E){const k=this.getItemIndexFromEventTarget(E.initialTarget||null),W=typeof k>"u"?void 0:this.items[k],R=W&&W.element;return{browserEvent:E,index:k,element:R}}toDragEvent(E){const k=this.getItemIndexFromEventTarget(E.target||null),W=typeof k>"u"?void 0:this.items[k],R=W&&W.element,C=this.getTargetSector(E,k);return{browserEvent:E,index:k,element:R,sector:C}}onScroll(E){try{const k=this.getRenderRange(this.lastRenderTop,this.lastRenderHeight);this.render(k,E.scrollTop,E.height,E.scrollLeft,E.scrollWidth),this.supportDynamicHeights&&this._rerender(E.scrollTop,E.height,E.inSmoothScrolling)}catch(k){throw console.error("Got bad scroll event:",E),k}}onTouchChange(E){E.preventDefault(),E.stopPropagation(),this.scrollTop-=E.translationY}onDragStart(E,k,W){if(!W.dataTransfer)return;const R=this.dnd.getDragElements(E);if(W.dataTransfer.effectAllowed="copyMove",W.dataTransfer.setData(i.DataTransfers.TEXT,k),W.dataTransfer.setDragImage){let C;this.dnd.getDragLabel&&(C=this.dnd.getDragLabel(R,W)),typeof C>"u"&&(C=String(R.length));const $=(0,n.$)(".monaco-drag-image");$.textContent=C,(Z=>{for(;Z&&!Z.classList.contains("monaco-workbench");)Z=Z.parentElement;return Z||this.domNode.ownerDocument})(this.domNode).appendChild($),W.dataTransfer.setDragImage($,-10,-10),setTimeout(()=>$.remove(),0)}this.domNode.classList.add("dragging"),this.currentDragData=new c(R),p.CurrentDragAndDropData=new a(R),this.dnd.onDragStart?.(this.currentDragData,W)}onDragOver(E){if(E.browserEvent.preventDefault(),this.onDragLeaveTimeout.dispose(),p.CurrentDragAndDropData&&p.CurrentDragAndDropData.getData()==="vscode-ui"||(this.setupDragAndDropScrollTopAnimation(E.browserEvent),!E.browserEvent.dataTransfer))return!1;if(!this.currentDragData)if(p.CurrentDragAndDropData)this.currentDragData=p.CurrentDragAndDropData;else{if(!E.browserEvent.dataTransfer.types)return!1;this.currentDragData=new f}const k=this.dnd.onDragOver(this.currentDragData,E.element,E.index,E.sector,E.browserEvent);if(this.canDrop=typeof k=="boolean"?k:k.accept,!this.canDrop)return this.currentDragFeedback=void 0,this.currentDragFeedbackDisposable.dispose(),!1;E.browserEvent.dataTransfer.dropEffect=typeof k!="boolean"&&k.effect?.type===e.ListDragOverEffectType.Copy?"copy":"move";let W;typeof k!="boolean"&&k.feedback?W=k.feedback:typeof E.index>"u"?W=[-1]:W=[E.index],W=(0,b.distinct)(W).filter(C=>C>=-1&&C<this.length).sort((C,$)=>C-$),W=W[0]===-1?[-1]:W;let R=typeof k!="boolean"&&k.effect&&k.effect.position?k.effect.position:e.ListDragOverEffectPosition.Over;if(_(this.currentDragFeedback,W)&&this.currentDragFeedbackPosition===R)return!0;if(this.currentDragFeedback=W,this.currentDragFeedbackPosition=R,this.currentDragFeedbackDisposable.dispose(),W[0]===-1)this.domNode.classList.add(R),this.rowsContainer.classList.add(R),this.currentDragFeedbackDisposable=(0,v.toDisposable)(()=>{this.domNode.classList.remove(R),this.rowsContainer.classList.remove(R)});else{if(W.length>1&&R!==e.ListDragOverEffectPosition.Over)throw new Error("Can't use multiple feedbacks with position different than 'over'");R===e.ListDragOverEffectPosition.After&&W[0]<this.length-1&&(W[0]+=1,R=e.ListDragOverEffectPosition.Before);for(const C of W){const $=this.items[C];$.dropTarget=!0,$.row?.domNode.classList.add(R)}this.currentDragFeedbackDisposable=(0,v.toDisposable)(()=>{for(const C of W){const $=this.items[C];$.dropTarget=!1,$.row?.domNode.classList.remove(R)}})}return!0}onDragLeave(E){this.onDragLeaveTimeout.dispose(),this.onDragLeaveTimeout=(0,w.disposableTimeout)(()=>this.clearDragOverFeedback(),100,this.disposables),this.currentDragData&&this.dnd.onDragLeave?.(this.currentDragData,E.element,E.index,E.browserEvent)}onDrop(E){if(!this.canDrop)return;const k=this.currentDragData;this.teardownDragAndDropScrollTopAnimation(),this.clearDragOverFeedback(),this.domNode.classList.remove("dragging"),this.currentDragData=void 0,p.CurrentDragAndDropData=void 0,!(!k||!E.browserEvent.dataTransfer)&&(E.browserEvent.preventDefault(),k.update(E.browserEvent.dataTransfer),this.dnd.drop(k,E.element,E.index,E.sector,E.browserEvent))}onDragEnd(E){this.canDrop=!1,this.teardownDragAndDropScrollTopAnimation(),this.clearDragOverFeedback(),this.domNode.classList.remove("dragging"),this.currentDragData=void 0,p.CurrentDragAndDropData=void 0,this.dnd.onDragEnd?.(E)}clearDragOverFeedback(){this.currentDragFeedback=void 0,this.currentDragFeedbackPosition=void 0,this.currentDragFeedbackDisposable.dispose(),this.currentDragFeedbackDisposable=v.Disposable.None}setupDragAndDropScrollTopAnimation(E){if(!this.dragOverAnimationDisposable){const k=(0,n.getTopLeftOffset)(this.domNode).top;this.dragOverAnimationDisposable=(0,n.animate)((0,n.getWindow)(this.domNode),this.animateDragAndDropScrollTop.bind(this,k))}this.dragOverAnimationStopDisposable.dispose(),this.dragOverAnimationStopDisposable=(0,w.disposableTimeout)(()=>{this.dragOverAnimationDisposable&&(this.dragOverAnimationDisposable.dispose(),this.dragOverAnimationDisposable=void 0)},1e3,this.disposables),this.dragOverMouseY=E.pageY}animateDragAndDropScrollTop(E){if(this.dragOverMouseY===void 0)return;const k=this.dragOverMouseY-E,W=this.renderHeight-35;k<35?this.scrollTop+=Math.max(-14,Math.floor(.3*(k-35))):k>W&&(this.scrollTop+=Math.min(14,Math.floor(.3*(k-W))))}teardownDragAndDropScrollTopAnimation(){this.dragOverAnimationStopDisposable.dispose(),this.dragOverAnimationDisposable&&(this.dragOverAnimationDisposable.dispose(),this.dragOverAnimationDisposable=void 0)}getTargetSector(E,k){if(k===void 0)return;const W=E.offsetY/this.items[k].size,R=Math.floor(W/.25);return(0,o.clamp)(R,0,3)}getItemIndexFromEventTarget(E){const k=this.scrollableElement.getDomNode();let W=E;for(;((0,n.isHTMLElement)(W)||(0,n.isSVGElement)(W))&&W!==this.rowsContainer&&k.contains(W);){const R=W.getAttribute("data-index");if(R){const C=Number(R);if(!isNaN(C))return C}W=W.parentElement}}getRenderRange(E,k){return{start:this.rangeMap.indexAt(E),end:this.rangeMap.indexAfter(E+k-1)}}_rerender(E,k,W){const R=this.getRenderRange(E,k);let C,$;E===this.elementTop(R.start)?(C=R.start,$=0):R.end-R.start>1&&(C=R.start+1,$=this.elementTop(C)-E);let ee=0;for(;;){const Y=this.getRenderRange(E,k);let Z=!1;for(let ce=Y.start;ce<Y.end;ce++){const he=this.probeDynamicHeight(ce);he!==0&&this.rangeMap.splice(ce,1,[this.items[ce]]),ee+=he,Z=Z||he!==0}if(!Z){ee!==0&&this.eventuallyUpdateScrollDimensions();const ce=g.Range.relativeComplement(R,Y);for(const ye of ce)for(let Re=ye.start;Re<ye.end;Re++)this.items[Re].row&&this.removeItemFromDOM(Re);const he=g.Range.relativeComplement(Y,R).reverse();for(const ye of he)for(let Re=ye.end-1;Re>=ye.start;Re--)this.insertItemInDOM(Re);for(let ye=Y.start;ye<Y.end;ye++)this.items[ye].row&&this.updateItemInDOM(this.items[ye],ye);if(typeof C=="number"){const ye=this.scrollable.getFutureScrollPosition().scrollTop-E,Re=this.elementTop(C)-$+ye;this.setScrollTop(Re,W)}this._onDidChangeContentHeight.fire(this.contentHeight);return}}}probeDynamicHeight(E){const k=this.items[E];if(this.virtualDelegate.getDynamicHeight){const $=this.virtualDelegate.getDynamicHeight(k.element);if($!==null){const ee=k.size;return k.size=$,k.lastDynamicHeightWidth=this.renderWidth,$-ee}}if(!k.hasDynamicHeight||k.lastDynamicHeightWidth===this.renderWidth||this.virtualDelegate.hasDynamicHeight&&!this.virtualDelegate.hasDynamicHeight(k.element))return 0;const W=k.size;if(k.row)return k.row.domNode.style.height="",k.size=k.row.domNode.offsetHeight,k.size===0&&!(0,n.isAncestor)(k.row.domNode,(0,n.getWindow)(k.row.domNode).document.body)&&console.warn("Measuring item node that is not in DOM! Add ListView to the DOM before measuring row height!",new Error().stack),k.lastDynamicHeightWidth=this.renderWidth,k.size-W;const{row:R}=this.cache.alloc(k.templateId);R.domNode.style.height="",this.rowsContainer.appendChild(R.domNode);const C=this.renderers.get(k.templateId);if(!C)throw new l.BugIndicatingError("Missing renderer for templateId: "+k.templateId);return C.renderElement(k.element,E,R.templateData,void 0),k.size=R.domNode.offsetHeight,C.disposeElement?.(k.element,E,R.templateData,void 0),this.virtualDelegate.setDynamicHeight?.(k.element,k.size),k.lastDynamicHeightWidth=this.renderWidth,R.domNode.remove(),this.cache.release(R),k.size-W}getElementDomId(E){return`${this.domId}_${E}`}dispose(){for(const E of this.items)if(E.dragStartDisposable.dispose(),E.checkedDisposable.dispose(),E.row){const k=this.renderers.get(E.row.templateId);k&&(k.disposeElement?.(E.element,-1,E.row.templateData,void 0),k.disposeTemplate(E.row.templateData))}this.items=[],this.domNode?.remove(),this.dragOverAnimationDisposable?.dispose(),this.disposables.dispose()}}t.ListView=B,lt([u.memoize],B.prototype,"onMouseClick",null),lt([u.memoize],B.prototype,"onMouseDblClick",null),lt([u.memoize],B.prototype,"onMouseMiddleClick",null),lt([u.memoize],B.prototype,"onMouseUp",null),lt([u.memoize],B.prototype,"onMouseDown",null),lt([u.memoize],B.prototype,"onMouseOver",null),lt([u.memoize],B.prototype,"onMouseMove",null),lt([u.memoize],B.prototype,"onMouseOut",null),lt([u.memoize],B.prototype,"onContextMenu",null),lt([u.memoize],B.prototype,"onTouchStart",null),lt([u.memoize],B.prototype,"onTap",null)}),define(_e[54],Se([1,0,4,28,15,32,52,87,9,13,89,35,3,49,8,2,37,5,10,41,79,22,62,118]),function(ue,t,i,n,O,I,N,b,w,u,m,v,g,d,e,s,r,l,o,p,A,L,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.List=t.unthemedListStyles=t.DefaultStyleController=t.MouseController=t.DefaultKeyboardNavigationDelegate=t.TypeNavigationMode=void 0,t.isInputElement=B,t.isMonacoEditor=E,t.isMonacoCustomToggle=k,t.isActionItem=W,t.isMonacoTwistie=R,t.isStickyScrollElement=C,t.isStickyScrollContainer=$,t.isButton=ee,t.isSelectionSingleChangeEvent=Re,t.isSelectionRangeChangeEvent=Pe,l=qe(l);class a{constructor(h){this.trait=h,this.renderedElements=[]}get templateId(){return`template:${this.trait.name}`}renderTemplate(h){return h}renderElement(h,S,P){const G=this.renderedElements.findIndex(J=>J.templateData===P);if(G>=0){const J=this.renderedElements[G];this.trait.unrender(P),J.index=S}else{const J={index:S,templateData:P};this.renderedElements.push(J)}this.trait.renderIndex(S,P)}splice(h,S,P){const G=[];for(const J of this.renderedElements)J.index<h?G.push(J):J.index>=h+S&&G.push({index:J.index+P-S,templateData:J.templateData});this.renderedElements=G}renderIndexes(h){for(const{index:S,templateData:P}of this.renderedElements)h.indexOf(S)>-1&&this.trait.renderIndex(S,P)}disposeTemplate(h){const S=this.renderedElements.findIndex(P=>P.templateData===h);S<0||this.renderedElements.splice(S,1)}}class f{get name(){return this._trait}get renderer(){return new a(this)}constructor(h){this._trait=h,this.indexes=[],this.sortedIndexes=[],this._onChange=new g.Emitter,this.onChange=this._onChange.event}splice(h,S,P){const G=P.length-S,J=h+S,te=[];let y=0;for(;y<this.sortedIndexes.length&&this.sortedIndexes[y]<h;)te.push(this.sortedIndexes[y++]);for(let D=0;D<P.length;D++)P[D]&&te.push(D+h);for(;y<this.sortedIndexes.length&&this.sortedIndexes[y]>=J;)te.push(this.sortedIndexes[y++]+G);this.renderer.splice(h,S,P.length),this._set(te,te)}renderIndex(h,S){S.classList.toggle(this._trait,this.contains(h))}unrender(h){h.classList.remove(this._trait)}set(h,S){return this._set(h,[...h].sort(Ce),S)}_set(h,S,P){const G=this.indexes,J=this.sortedIndexes;this.indexes=h,this.sortedIndexes=S;const te=Ee(J,h);return this.renderer.renderIndexes(te),this._onChange.fire({indexes:h,browserEvent:P}),G}get(){return this.indexes}contains(h){return(0,w.binarySearch)(this.sortedIndexes,h,Ce)>=0}dispose(){(0,s.dispose)(this._onChange)}}lt([v.memoize],f.prototype,"renderer",null);class _ extends f{constructor(h){super("selected"),this.setAriaSelected=h}renderIndex(h,S){super.renderIndex(h,S),this.setAriaSelected&&(this.contains(h)?S.setAttribute("aria-selected","true"):S.setAttribute("aria-selected","false"))}}class H{constructor(h,S,P){this.trait=h,this.view=S,this.identityProvider=P}splice(h,S,P){if(!this.identityProvider)return this.trait.splice(h,S,new Array(P.length).fill(!1));const G=this.trait.get().map(y=>this.identityProvider.getId(this.view.element(y)).toString());if(G.length===0)return this.trait.splice(h,S,new Array(P.length).fill(!1));const J=new Set(G),te=P.map(y=>J.has(this.identityProvider.getId(y).toString()));this.trait.splice(h,S,te)}}function B(x){return x.tagName==="INPUT"||x.tagName==="TEXTAREA"}function F(x,h){return x.classList.contains(h)?!0:x.classList.contains("monaco-list")||!x.parentElement?!1:F(x.parentElement,h)}function E(x){return F(x,"monaco-editor")}function k(x){return F(x,"monaco-custom-toggle")}function W(x){return F(x,"action-item")}function R(x){return F(x,"monaco-tl-twistie")}function C(x){return F(x,"monaco-tree-sticky-row")}function $(x){return x.classList.contains("monaco-tree-sticky-container")}function ee(x){return x.tagName==="A"&&x.classList.contains("monaco-button")||x.tagName==="DIV"&&x.classList.contains("monaco-button-dropdown")?!0:x.classList.contains("monaco-list")||!x.parentElement?!1:ee(x.parentElement)}class Y{get onKeyDown(){return g.Event.chain(this.disposables.add(new n.DomEmitter(this.view.domNode,"keydown")).event,h=>h.filter(S=>!B(S.target)).map(S=>new O.StandardKeyboardEvent(S)))}constructor(h,S,P){this.list=h,this.view=S,this.disposables=new s.DisposableStore,this.multipleSelectionDisposables=new s.DisposableStore,this.multipleSelectionSupport=P.multipleSelectionSupport,this.disposables.add(this.onKeyDown(G=>{switch(G.keyCode){case e.KeyCode.Enter:return this.onEnter(G);case e.KeyCode.UpArrow:return this.onUpArrow(G);case e.KeyCode.DownArrow:return this.onDownArrow(G);case e.KeyCode.PageUp:return this.onPageUpArrow(G);case e.KeyCode.PageDown:return this.onPageDownArrow(G);case e.KeyCode.Escape:return this.onEscape(G);case e.KeyCode.KeyA:this.multipleSelectionSupport&&(l.isMacintosh?G.metaKey:G.ctrlKey)&&this.onCtrlA(G)}}))}updateOptions(h){h.multipleSelectionSupport!==void 0&&(this.multipleSelectionSupport=h.multipleSelectionSupport)}onEnter(h){h.preventDefault(),h.stopPropagation(),this.list.setSelection(this.list.getFocus(),h.browserEvent)}onUpArrow(h){h.preventDefault(),h.stopPropagation(),this.list.focusPrevious(1,!1,h.browserEvent);const S=this.list.getFocus()[0];this.list.setAnchor(S),this.list.reveal(S),this.view.domNode.focus()}onDownArrow(h){h.preventDefault(),h.stopPropagation(),this.list.focusNext(1,!1,h.browserEvent);const S=this.list.getFocus()[0];this.list.setAnchor(S),this.list.reveal(S),this.view.domNode.focus()}onPageUpArrow(h){h.preventDefault(),h.stopPropagation(),this.list.focusPreviousPage(h.browserEvent);const S=this.list.getFocus()[0];this.list.setAnchor(S),this.list.reveal(S),this.view.domNode.focus()}onPageDownArrow(h){h.preventDefault(),h.stopPropagation(),this.list.focusNextPage(h.browserEvent);const S=this.list.getFocus()[0];this.list.setAnchor(S),this.list.reveal(S),this.view.domNode.focus()}onCtrlA(h){h.preventDefault(),h.stopPropagation(),this.list.setSelection((0,w.range)(this.list.length),h.browserEvent),this.list.setAnchor(void 0),this.view.domNode.focus()}onEscape(h){this.list.getSelection().length&&(h.preventDefault(),h.stopPropagation(),this.list.setSelection([],h.browserEvent),this.list.setAnchor(void 0),this.view.domNode.focus())}dispose(){this.disposables.dispose(),this.multipleSelectionDisposables.dispose()}}lt([v.memoize],Y.prototype,"onKeyDown",null);var Z;(function(x){x[x.Automatic=0]="Automatic",x[x.Trigger=1]="Trigger"})(Z||(t.TypeNavigationMode=Z={}));var ce;(function(x){x[x.Idle=0]="Idle",x[x.Typing=1]="Typing"})(ce||(ce={})),t.DefaultKeyboardNavigationDelegate=new class{mightProducePrintableCharacter(x){return x.ctrlKey||x.metaKey||x.altKey?!1:x.keyCode>=e.KeyCode.KeyA&&x.keyCode<=e.KeyCode.KeyZ||x.keyCode>=e.KeyCode.Digit0&&x.keyCode<=e.KeyCode.Digit9||x.keyCode>=e.KeyCode.Numpad0&&x.keyCode<=e.KeyCode.Numpad9||x.keyCode>=e.KeyCode.Semicolon&&x.keyCode<=e.KeyCode.Quote}};class he{constructor(h,S,P,G,J){this.list=h,this.view=S,this.keyboardNavigationLabelProvider=P,this.keyboardNavigationEventFilter=G,this.delegate=J,this.enabled=!1,this.state=ce.Idle,this.mode=Z.Automatic,this.triggered=!1,this.previouslyFocused=-1,this.enabledDisposables=new s.DisposableStore,this.disposables=new s.DisposableStore,this.updateOptions(h.options)}updateOptions(h){h.typeNavigationEnabled??!0?this.enable():this.disable(),this.mode=h.typeNavigationMode??Z.Automatic}trigger(){this.triggered=!this.triggered}enable(){if(this.enabled)return;let h=!1;const S=g.Event.chain(this.enabledDisposables.add(new n.DomEmitter(this.view.domNode,"keydown")).event,J=>J.filter(te=>!B(te.target)).filter(()=>this.mode===Z.Automatic||this.triggered).map(te=>new O.StandardKeyboardEvent(te)).filter(te=>h||this.keyboardNavigationEventFilter(te)).filter(te=>this.delegate.mightProducePrintableCharacter(te)).forEach(te=>i.EventHelper.stop(te,!0)).map(te=>te.browserEvent.key)),P=g.Event.debounce(S,()=>null,800,void 0,void 0,void 0,this.enabledDisposables);g.Event.reduce(g.Event.any(S,P),(J,te)=>te===null?null:(J||"")+te,void 0,this.enabledDisposables)(this.onInput,this,this.enabledDisposables),P(this.onClear,this,this.enabledDisposables),S(()=>h=!0,void 0,this.enabledDisposables),P(()=>h=!1,void 0,this.enabledDisposables),this.enabled=!0,this.triggered=!1}disable(){this.enabled&&(this.enabledDisposables.clear(),this.enabled=!1,this.triggered=!1)}onClear(){const h=this.list.getFocus();if(h.length>0&&h[0]===this.previouslyFocused){const S=this.list.options.accessibilityProvider?.getAriaLabel(this.list.element(h[0]));typeof S=="string"?(0,N.alert)(S):S&&(0,N.alert)(S.get())}this.previouslyFocused=-1}onInput(h){if(!h){this.state=ce.Idle,this.triggered=!1;return}const S=this.list.getFocus(),P=S.length>0?S[0]:0,G=this.state===ce.Idle?1:0;this.state=ce.Typing;for(let J=0;J<this.list.length;J++){const te=(P+J+G)%this.list.length,y=this.keyboardNavigationLabelProvider.getKeyboardNavigationLabel(this.view.element(te)),D=y&&y.toString();if(this.list.options.typeNavigationEnabled){if(typeof D<"u"){if((0,d.matchesPrefix)(h,D)){this.previouslyFocused=P,this.list.setFocus([te]),this.list.reveal(te);return}const z=(0,d.matchesFuzzy2)(h,D);if(z&&z[0].end-z[0].start>1&&z.length===1){this.previouslyFocused=P,this.list.setFocus([te]),this.list.reveal(te);return}}}else if(typeof D>"u"||(0,d.matchesPrefix)(h,D)){this.previouslyFocused=P,this.list.setFocus([te]),this.list.reveal(te);return}}}dispose(){this.disable(),this.enabledDisposables.dispose(),this.disposables.dispose()}}class ye{constructor(h,S){this.list=h,this.view=S,this.disposables=new s.DisposableStore;const P=g.Event.chain(this.disposables.add(new n.DomEmitter(S.domNode,"keydown")).event,J=>J.filter(te=>!B(te.target)).map(te=>new O.StandardKeyboardEvent(te)));g.Event.chain(P,J=>J.filter(te=>te.keyCode===e.KeyCode.Tab&&!te.ctrlKey&&!te.metaKey&&!te.shiftKey&&!te.altKey))(this.onTab,this,this.disposables)}onTab(h){if(h.target!==this.view.domNode)return;const S=this.list.getFocus();if(S.length===0)return;const P=this.view.domElement(S[0]);if(!P)return;const G=P.querySelector("[tabIndex]");if(!G||!(0,i.isHTMLElement)(G)||G.tabIndex===-1)return;const J=(0,i.getWindow)(G).getComputedStyle(G);J.visibility==="hidden"||J.display==="none"||(h.preventDefault(),h.stopPropagation(),G.focus())}dispose(){this.disposables.dispose()}}function Re(x){return l.isMacintosh?x.browserEvent.metaKey:x.browserEvent.ctrlKey}function Pe(x){return x.browserEvent.shiftKey}function re(x){return(0,i.isMouseEvent)(x)&&x.button===2}const ie={isSelectionSingleChangeEvent:Re,isSelectionRangeChangeEvent:Pe};class fe{constructor(h){this.list=h,this.disposables=new s.DisposableStore,this._onPointer=new g.Emitter,this.onPointer=this._onPointer.event,h.options.multipleSelectionSupport!==!1&&(this.multipleSelectionController=this.list.options.multipleSelectionController||ie),this.mouseSupport=typeof h.options.mouseSupport>"u"||!!h.options.mouseSupport,this.mouseSupport&&(h.onMouseDown(this.onMouseDown,this,this.disposables),h.onContextMenu(this.onContextMenu,this,this.disposables),h.onMouseDblClick(this.onDoubleClick,this,this.disposables),h.onTouchStart(this.onMouseDown,this,this.disposables),this.disposables.add(I.Gesture.addTarget(h.getHTMLElement()))),g.Event.any(h.onMouseClick,h.onMouseMiddleClick,h.onTap)(this.onViewPointer,this,this.disposables)}updateOptions(h){h.multipleSelectionSupport!==void 0&&(this.multipleSelectionController=void 0,h.multipleSelectionSupport&&(this.multipleSelectionController=this.list.options.multipleSelectionController||ie))}isSelectionSingleChangeEvent(h){return this.multipleSelectionController?this.multipleSelectionController.isSelectionSingleChangeEvent(h):!1}isSelectionRangeChangeEvent(h){return this.multipleSelectionController?this.multipleSelectionController.isSelectionRangeChangeEvent(h):!1}isSelectionChangeEvent(h){return this.isSelectionSingleChangeEvent(h)||this.isSelectionRangeChangeEvent(h)}onMouseDown(h){E(h.browserEvent.target)||(0,i.getActiveElement)()!==h.browserEvent.target&&this.list.domFocus()}onContextMenu(h){if(B(h.browserEvent.target)||E(h.browserEvent.target))return;const S=typeof h.index>"u"?[]:[h.index];this.list.setFocus(S,h.browserEvent)}onViewPointer(h){if(!this.mouseSupport||B(h.browserEvent.target)||E(h.browserEvent.target)||h.browserEvent.isHandledByList)return;h.browserEvent.isHandledByList=!0;const S=h.index;if(typeof S>"u"){this.list.setFocus([],h.browserEvent),this.list.setSelection([],h.browserEvent),this.list.setAnchor(void 0);return}if(this.isSelectionChangeEvent(h))return this.changeSelection(h);this.list.setFocus([S],h.browserEvent),this.list.setAnchor(S),re(h.browserEvent)||this.list.setSelection([S],h.browserEvent),this._onPointer.fire(h)}onDoubleClick(h){if(B(h.browserEvent.target)||E(h.browserEvent.target)||this.isSelectionChangeEvent(h)||h.browserEvent.isHandledByList)return;h.browserEvent.isHandledByList=!0;const S=this.list.getFocus();this.list.setSelection(S,h.browserEvent)}changeSelection(h){const S=h.index;let P=this.list.getAnchor();if(this.isSelectionRangeChangeEvent(h)){typeof P>"u"&&(P=this.list.getFocus()[0]??S,this.list.setAnchor(P));const G=Math.min(P,S),J=Math.max(P,S),te=(0,w.range)(G,J+1),y=this.list.getSelection(),D=ne(Ee(y,[P]),P);if(D.length===0)return;const z=Ee(te,Le(y,D));this.list.setSelection(z,h.browserEvent),this.list.setFocus([S],h.browserEvent)}else if(this.isSelectionSingleChangeEvent(h)){const G=this.list.getSelection(),J=G.filter(te=>te!==S);this.list.setFocus([S]),this.list.setAnchor(S),G.length===J.length?this.list.setSelection([...J,S],h.browserEvent):this.list.setSelection(J,h.browserEvent)}}dispose(){this.disposables.dispose()}}t.MouseController=fe;class ve{constructor(h,S){this.styleElement=h,this.selectorSuffix=S}style(h){const S=this.selectorSuffix&&`.${this.selectorSuffix}`,P=[];h.listBackground&&P.push(`.monaco-list${S} .monaco-list-rows { background: ${h.listBackground}; }`),h.listFocusBackground&&(P.push(`.monaco-list${S}:focus .monaco-list-row.focused { background-color: ${h.listFocusBackground}; }`),P.push(`.monaco-list${S}:focus .monaco-list-row.focused:hover { background-color: ${h.listFocusBackground}; }`)),h.listFocusForeground&&P.push(`.monaco-list${S}:focus .monaco-list-row.focused { color: ${h.listFocusForeground}; }`),h.listActiveSelectionBackground&&(P.push(`.monaco-list${S}:focus .monaco-list-row.selected { background-color: ${h.listActiveSelectionBackground}; }`),P.push(`.monaco-list${S}:focus .monaco-list-row.selected:hover { background-color: ${h.listActiveSelectionBackground}; }`)),h.listActiveSelectionForeground&&P.push(`.monaco-list${S}:focus .monaco-list-row.selected { color: ${h.listActiveSelectionForeground}; }`),h.listActiveSelectionIconForeground&&P.push(`.monaco-list${S}:focus .monaco-list-row.selected .codicon { color: ${h.listActiveSelectionIconForeground}; }`),h.listFocusAndSelectionBackground&&P.push(`
				.monaco-drag-image,
				.monaco-list${S}:focus .monaco-list-row.selected.focused { background-color: ${h.listFocusAndSelectionBackground}; }
			`),h.listFocusAndSelectionForeground&&P.push(`
				.monaco-drag-image,
				.monaco-list${S}:focus .monaco-list-row.selected.focused { color: ${h.listFocusAndSelectionForeground}; }
			`),h.listInactiveFocusForeground&&(P.push(`.monaco-list${S} .monaco-list-row.focused { color:  ${h.listInactiveFocusForeground}; }`),P.push(`.monaco-list${S} .monaco-list-row.focused:hover { color:  ${h.listInactiveFocusForeground}; }`)),h.listInactiveSelectionIconForeground&&P.push(`.monaco-list${S} .monaco-list-row.focused .codicon { color:  ${h.listInactiveSelectionIconForeground}; }`),h.listInactiveFocusBackground&&(P.push(`.monaco-list${S} .monaco-list-row.focused { background-color:  ${h.listInactiveFocusBackground}; }`),P.push(`.monaco-list${S} .monaco-list-row.focused:hover { background-color:  ${h.listInactiveFocusBackground}; }`)),h.listInactiveSelectionBackground&&(P.push(`.monaco-list${S} .monaco-list-row.selected { background-color:  ${h.listInactiveSelectionBackground}; }`),P.push(`.monaco-list${S} .monaco-list-row.selected:hover { background-color:  ${h.listInactiveSelectionBackground}; }`)),h.listInactiveSelectionForeground&&P.push(`.monaco-list${S} .monaco-list-row.selected { color: ${h.listInactiveSelectionForeground}; }`),h.listHoverBackground&&P.push(`.monaco-list${S}:not(.drop-target):not(.dragging) .monaco-list-row:hover:not(.selected):not(.focused) { background-color: ${h.listHoverBackground}; }`),h.listHoverForeground&&P.push(`.monaco-list${S}:not(.drop-target):not(.dragging) .monaco-list-row:hover:not(.selected):not(.focused) { color:  ${h.listHoverForeground}; }`);const G=(0,i.asCssValueWithDefault)(h.listFocusAndSelectionOutline,(0,i.asCssValueWithDefault)(h.listSelectionOutline,h.listFocusOutline??""));G&&P.push(`.monaco-list${S}:focus .monaco-list-row.focused.selected { outline: 1px solid ${G}; outline-offset: -1px;}`),h.listFocusOutline&&P.push(`
				.monaco-drag-image,
				.monaco-list${S}:focus .monaco-list-row.focused { outline: 1px solid ${h.listFocusOutline}; outline-offset: -1px; }
				.monaco-workbench.context-menu-visible .monaco-list${S}.last-focused .monaco-list-row.focused { outline: 1px solid ${h.listFocusOutline}; outline-offset: -1px; }
			`);const J=(0,i.asCssValueWithDefault)(h.listSelectionOutline,h.listInactiveFocusOutline??"");J&&P.push(`.monaco-list${S} .monaco-list-row.focused.selected { outline: 1px dotted ${J}; outline-offset: -1px; }`),h.listSelectionOutline&&P.push(`.monaco-list${S} .monaco-list-row.selected { outline: 1px dotted ${h.listSelectionOutline}; outline-offset: -1px; }`),h.listInactiveFocusOutline&&P.push(`.monaco-list${S} .monaco-list-row.focused { outline: 1px dotted ${h.listInactiveFocusOutline}; outline-offset: -1px; }`),h.listHoverOutline&&P.push(`.monaco-list${S} .monaco-list-row:hover { outline: 1px dashed ${h.listHoverOutline}; outline-offset: -1px; }`),h.listDropOverBackground&&P.push(`
				.monaco-list${S}.drop-target,
				.monaco-list${S} .monaco-list-rows.drop-target,
				.monaco-list${S} .monaco-list-row.drop-target { background-color: ${h.listDropOverBackground} !important; color: inherit !important; }
			`),h.listDropBetweenBackground&&(P.push(`
			.monaco-list${S} .monaco-list-rows.drop-target-before .monaco-list-row:first-child::before,
			.monaco-list${S} .monaco-list-row.drop-target-before::before {
				content: ""; position: absolute; top: 0px; left: 0px; width: 100%; height: 1px;
				background-color: ${h.listDropBetweenBackground};
			}`),P.push(`
			.monaco-list${S} .monaco-list-rows.drop-target-after .monaco-list-row:last-child::after,
			.monaco-list${S} .monaco-list-row.drop-target-after::after {
				content: ""; position: absolute; bottom: 0px; left: 0px; width: 100%; height: 1px;
				background-color: ${h.listDropBetweenBackground};
			}`)),h.tableColumnsBorder&&P.push(`
				.monaco-table > .monaco-split-view2,
				.monaco-table > .monaco-split-view2 .monaco-sash.vertical::before,
				.monaco-workbench:not(.reduce-motion) .monaco-table:hover > .monaco-split-view2,
				.monaco-workbench:not(.reduce-motion) .monaco-table:hover > .monaco-split-view2 .monaco-sash.vertical::before {
					border-color: ${h.tableColumnsBorder};
				}

				.monaco-workbench:not(.reduce-motion) .monaco-table > .monaco-split-view2,
				.monaco-workbench:not(.reduce-motion) .monaco-table > .monaco-split-view2 .monaco-sash.vertical::before {
					border-color: transparent;
				}
			`),h.tableOddRowsBackgroundColor&&P.push(`
				.monaco-table .monaco-list-row[data-parity=odd]:not(.focused):not(.selected):not(:hover) .monaco-table-tr,
				.monaco-table .monaco-list:not(:focus) .monaco-list-row[data-parity=odd].focused:not(.selected):not(:hover) .monaco-table-tr,
				.monaco-table .monaco-list:not(.focused) .monaco-list-row[data-parity=odd].focused:not(.selected):not(:hover) .monaco-table-tr {
					background-color: ${h.tableOddRowsBackgroundColor};
				}
			`),this.styleElement.textContent=P.join(`
`)}}t.DefaultStyleController=ve,t.unthemedListStyles={listFocusBackground:"#7FB0D0",listActiveSelectionBackground:"#0E639C",listActiveSelectionForeground:"#FFFFFF",listActiveSelectionIconForeground:"#FFFFFF",listFocusAndSelectionOutline:"#90C2F9",listFocusAndSelectionBackground:"#094771",listFocusAndSelectionForeground:"#FFFFFF",listInactiveSelectionBackground:"#3F3F46",listInactiveSelectionIconForeground:"#FFFFFF",listHoverBackground:"#2A2D2E",listDropOverBackground:"#383B3D",listDropBetweenBackground:"#EEEEEE",treeIndentGuidesStroke:"#a9a9a9",treeInactiveIndentGuidesStroke:m.Color.fromHex("#a9a9a9").transparent(.4).toString(),tableColumnsBorder:m.Color.fromHex("#cccccc").transparent(.2).toString(),tableOddRowsBackgroundColor:m.Color.fromHex("#cccccc").transparent(.04).toString(),listBackground:void 0,listFocusForeground:void 0,listInactiveSelectionForeground:void 0,listInactiveFocusForeground:void 0,listInactiveFocusBackground:void 0,listHoverForeground:void 0,listFocusOutline:void 0,listInactiveFocusOutline:void 0,listSelectionOutline:void 0,listHoverOutline:void 0,treeStickyScrollBackground:void 0,treeStickyScrollBorder:void 0,treeStickyScrollShadow:void 0};const Ne={keyboardSupport:!0,mouseSupport:!0,multipleSelectionSupport:!0,dnd:{getDragURI(){return null},onDragStart(){},onDragOver(){return!1},drop(){},dispose(){}}};function ne(x,h){const S=x.indexOf(h);if(S===-1)return[];const P=[];let G=S-1;for(;G>=0&&x[G]===h-(S-G);)P.push(x[G--]);for(P.reverse(),G=S;G<x.length&&x[G]===h+(G-S);)P.push(x[G++]);return P}function Ee(x,h){const S=[];let P=0,G=0;for(;P<x.length||G<h.length;)if(P>=x.length)S.push(h[G++]);else if(G>=h.length)S.push(x[P++]);else if(x[P]===h[G]){S.push(x[P]),P++,G++;continue}else x[P]<h[G]?S.push(x[P++]):S.push(h[G++]);return S}function Le(x,h){const S=[];let P=0,G=0;for(;P<x.length||G<h.length;)if(P>=x.length)S.push(h[G++]);else if(G>=h.length)S.push(x[P++]);else if(x[P]===h[G]){P++,G++;continue}else x[P]<h[G]?S.push(x[P++]):G++;return S}const Ce=(x,h)=>x-h;class Fe{constructor(h,S){this._templateId=h,this.renderers=S}get templateId(){return this._templateId}renderTemplate(h){return this.renderers.map(S=>S.renderTemplate(h))}renderElement(h,S,P,G){let J=0;for(const te of this.renderers)te.renderElement(h,S,P[J++],G)}disposeElement(h,S,P,G){let J=0;for(const te of this.renderers)te.disposeElement?.(h,S,P[J],G),J+=1}disposeTemplate(h){let S=0;for(const P of this.renderers)P.disposeTemplate(h[S++])}}class ze{constructor(h){this.accessibilityProvider=h,this.templateId="a18n"}renderTemplate(h){return{container:h,disposables:new s.DisposableStore}}renderElement(h,S,P){const G=this.accessibilityProvider.getAriaLabel(h),J=G&&typeof G!="string"?G:(0,c.constObservable)(G);P.disposables.add((0,c.autorun)(y=>{this.setAriaLabel(y.readObservable(J),P.container)}));const te=this.accessibilityProvider.getAriaLevel&&this.accessibilityProvider.getAriaLevel(h);typeof te=="number"?P.container.setAttribute("aria-level",`${te}`):P.container.removeAttribute("aria-level")}setAriaLabel(h,S){h?S.setAttribute("aria-label",h):S.removeAttribute("aria-label")}disposeElement(h,S,P,G){P.disposables.clear()}disposeTemplate(h){h.disposables.dispose()}}class Xe{constructor(h,S){this.list=h,this.dnd=S}getDragElements(h){const S=this.list.getSelectedElements();return S.indexOf(h)>-1?S:[h]}getDragURI(h){return this.dnd.getDragURI(h)}getDragLabel(h,S){if(this.dnd.getDragLabel)return this.dnd.getDragLabel(h,S)}onDragStart(h,S){this.dnd.onDragStart?.(h,S)}onDragOver(h,S,P,G,J){return this.dnd.onDragOver(h,S,P,G,J)}onDragLeave(h,S,P,G){this.dnd.onDragLeave?.(h,S,P,G)}onDragEnd(h){this.dnd.onDragEnd?.(h)}drop(h,S,P,G,J){this.dnd.drop(h,S,P,G,J)}dispose(){this.dnd.dispose()}}class oe{get onDidChangeFocus(){return g.Event.map(this.eventBufferer.wrapEvent(this.focus.onChange),h=>this.toListEvent(h),this.disposables)}get onDidChangeSelection(){return g.Event.map(this.eventBufferer.wrapEvent(this.selection.onChange),h=>this.toListEvent(h),this.disposables)}get domId(){return this.view.domId}get onDidScroll(){return this.view.onDidScroll}get onMouseClick(){return this.view.onMouseClick}get onMouseDblClick(){return this.view.onMouseDblClick}get onMouseMiddleClick(){return this.view.onMouseMiddleClick}get onPointer(){return this.mouseController.onPointer}get onMouseUp(){return this.view.onMouseUp}get onMouseDown(){return this.view.onMouseDown}get onMouseOver(){return this.view.onMouseOver}get onMouseMove(){return this.view.onMouseMove}get onMouseOut(){return this.view.onMouseOut}get onTouchStart(){return this.view.onTouchStart}get onTap(){return this.view.onTap}get onContextMenu(){let h=!1;const S=g.Event.chain(this.disposables.add(new n.DomEmitter(this.view.domNode,"keydown")).event,J=>J.map(te=>new O.StandardKeyboardEvent(te)).filter(te=>h=te.keyCode===e.KeyCode.ContextMenu||te.shiftKey&&te.keyCode===e.KeyCode.F10).map(te=>i.EventHelper.stop(te,!0)).filter(()=>!1)),P=g.Event.chain(this.disposables.add(new n.DomEmitter(this.view.domNode,"keyup")).event,J=>J.forEach(()=>h=!1).map(te=>new O.StandardKeyboardEvent(te)).filter(te=>te.keyCode===e.KeyCode.ContextMenu||te.shiftKey&&te.keyCode===e.KeyCode.F10).map(te=>i.EventHelper.stop(te,!0)).map(({browserEvent:te})=>{const y=this.getFocus(),D=y.length?y[0]:void 0,z=typeof D<"u"?this.view.element(D):void 0,V=typeof D<"u"?this.view.domElement(D):this.view.domNode;return{index:D,element:z,anchor:V,browserEvent:te}})),G=g.Event.chain(this.view.onContextMenu,J=>J.filter(te=>!h).map(({element:te,index:y,browserEvent:D})=>({element:te,index:y,anchor:new L.StandardMouseEvent((0,i.getWindow)(this.view.domNode),D),browserEvent:D})));return g.Event.any(S,P,G)}get onKeyDown(){return this.disposables.add(new n.DomEmitter(this.view.domNode,"keydown")).event}get onKeyUp(){return this.disposables.add(new n.DomEmitter(this.view.domNode,"keyup")).event}get onKeyPress(){return this.disposables.add(new n.DomEmitter(this.view.domNode,"keypress")).event}get onDidFocus(){return g.Event.signal(this.disposables.add(new n.DomEmitter(this.view.domNode,"focus",!0)).event)}get onDidBlur(){return g.Event.signal(this.disposables.add(new n.DomEmitter(this.view.domNode,"blur",!0)).event)}constructor(h,S,P,G,J=Ne){this.user=h,this._options=J,this.focus=new f("focused"),this.anchor=new f("anchor"),this.eventBufferer=new g.EventBufferer,this._ariaLabel="",this.disposables=new s.DisposableStore,this._onDidDispose=new g.Emitter,this.onDidDispose=this._onDidDispose.event;const te=this._options.accessibilityProvider&&this._options.accessibilityProvider.getWidgetRole?this._options.accessibilityProvider?.getWidgetRole():"list";this.selection=new _(te!=="listbox");const y=[this.focus.renderer,this.selection.renderer];this.accessibilityProvider=J.accessibilityProvider,this.accessibilityProvider&&(y.push(new ze(this.accessibilityProvider)),this.accessibilityProvider.onDidChangeActiveDescendant?.(this.onDidChangeActiveDescendant,this,this.disposables)),G=G.map(z=>new Fe(z.templateId,[...y,z]));const D={...J,dnd:J.dnd&&new Xe(this,J.dnd)};if(this.view=this.createListView(S,P,G,D),this.view.domNode.setAttribute("role",te),J.styleController)this.styleController=J.styleController(this.view.domId);else{const z=(0,i.createStyleSheet)(this.view.domNode);this.styleController=new ve(z,this.view.domId)}if(this.spliceable=new b.CombinedSpliceable([new H(this.focus,this.view,J.identityProvider),new H(this.selection,this.view,J.identityProvider),new H(this.anchor,this.view,J.identityProvider),this.view]),this.disposables.add(this.focus),this.disposables.add(this.selection),this.disposables.add(this.anchor),this.disposables.add(this.view),this.disposables.add(this._onDidDispose),this.disposables.add(new ye(this,this.view)),(typeof J.keyboardSupport!="boolean"||J.keyboardSupport)&&(this.keyboardController=new Y(this,this.view,J),this.disposables.add(this.keyboardController)),J.keyboardNavigationLabelProvider){const z=J.keyboardNavigationDelegate||t.DefaultKeyboardNavigationDelegate;this.typeNavigationController=new he(this,this.view,J.keyboardNavigationLabelProvider,J.keyboardNavigationEventFilter??(()=>!0),z),this.disposables.add(this.typeNavigationController)}this.mouseController=this.createMouseController(J),this.disposables.add(this.mouseController),this.onDidChangeFocus(this._onFocusChange,this,this.disposables),this.onDidChangeSelection(this._onSelectionChange,this,this.disposables),this.accessibilityProvider&&(this.ariaLabel=this.accessibilityProvider.getWidgetAriaLabel()),this._options.multipleSelectionSupport!==!1&&this.view.domNode.setAttribute("aria-multiselectable","true")}createListView(h,S,P,G){return new A.ListView(h,S,P,G)}createMouseController(h){return new fe(this)}updateOptions(h={}){this._options={...this._options,...h},this.typeNavigationController?.updateOptions(this._options),this._options.multipleSelectionController!==void 0&&(this._options.multipleSelectionSupport?this.view.domNode.setAttribute("aria-multiselectable","true"):this.view.domNode.removeAttribute("aria-multiselectable")),this.mouseController.updateOptions(h),this.keyboardController?.updateOptions(h),this.view.updateOptions(h)}get options(){return this._options}splice(h,S,P=[]){if(h<0||h>this.view.length)throw new p.ListError(this.user,`Invalid start index: ${h}`);if(S<0)throw new p.ListError(this.user,`Invalid delete count: ${S}`);S===0&&P.length===0||this.eventBufferer.bufferEvents(()=>this.spliceable.splice(h,S,P))}updateWidth(h){this.view.updateWidth(h)}updateElementHeight(h,S){this.view.updateElementHeight(h,S,null)}rerender(){this.view.rerender()}element(h){return this.view.element(h)}indexOf(h){return this.view.indexOf(h)}indexAt(h){return this.view.indexAt(h)}get length(){return this.view.length}get contentHeight(){return this.view.contentHeight}get contentWidth(){return this.view.contentWidth}get onDidChangeContentHeight(){return this.view.onDidChangeContentHeight}get onDidChangeContentWidth(){return this.view.onDidChangeContentWidth}get scrollTop(){return this.view.getScrollTop()}set scrollTop(h){this.view.setScrollTop(h)}get scrollLeft(){return this.view.getScrollLeft()}set scrollLeft(h){this.view.setScrollLeft(h)}get scrollHeight(){return this.view.scrollHeight}get renderHeight(){return this.view.renderHeight}get firstVisibleIndex(){return this.view.firstVisibleIndex}get firstMostlyVisibleIndex(){return this.view.firstMostlyVisibleIndex}get lastVisibleIndex(){return this.view.lastVisibleIndex}get ariaLabel(){return this._ariaLabel}set ariaLabel(h){this._ariaLabel=h,this.view.domNode.setAttribute("aria-label",h)}domFocus(){this.view.domNode.focus({preventScroll:!0})}layout(h,S){this.view.layout(h,S)}triggerTypeNavigation(){this.typeNavigationController?.trigger()}setSelection(h,S){for(const P of h)if(P<0||P>=this.length)throw new p.ListError(this.user,`Invalid index ${P}`);this.selection.set(h,S)}getSelection(){return this.selection.get()}getSelectedElements(){return this.getSelection().map(h=>this.view.element(h))}setAnchor(h){if(typeof h>"u"){this.anchor.set([]);return}if(h<0||h>=this.length)throw new p.ListError(this.user,`Invalid index ${h}`);this.anchor.set([h])}getAnchor(){return(0,w.firstOrDefault)(this.anchor.get(),void 0)}getAnchorElement(){const h=this.getAnchor();return typeof h>"u"?void 0:this.element(h)}setFocus(h,S){for(const P of h)if(P<0||P>=this.length)throw new p.ListError(this.user,`Invalid index ${P}`);this.focus.set(h,S)}focusNext(h=1,S=!1,P,G){if(this.length===0)return;const J=this.focus.get(),te=this.findNextIndex(J.length>0?J[0]+h:0,S,G);te>-1&&this.setFocus([te],P)}focusPrevious(h=1,S=!1,P,G){if(this.length===0)return;const J=this.focus.get(),te=this.findPreviousIndex(J.length>0?J[0]-h:0,S,G);te>-1&&this.setFocus([te],P)}async focusNextPage(h,S){let P=this.view.indexAt(this.view.getScrollTop()+this.view.renderHeight);P=P===0?0:P-1;const G=this.getFocus()[0];if(G!==P&&(G===void 0||P>G)){const J=this.findPreviousIndex(P,!1,S);J>-1&&G!==J?this.setFocus([J],h):this.setFocus([P],h)}else{const J=this.view.getScrollTop();let te=J+this.view.renderHeight;P>G&&(te-=this.view.elementHeight(P)),this.view.setScrollTop(te),this.view.getScrollTop()!==J&&(this.setFocus([]),await(0,u.timeout)(0),await this.focusNextPage(h,S))}}async focusPreviousPage(h,S,P=()=>0){let G;const J=P(),te=this.view.getScrollTop()+J;te===0?G=this.view.indexAt(te):G=this.view.indexAfter(te-1);const y=this.getFocus()[0];if(y!==G&&(y===void 0||y>=G)){const D=this.findNextIndex(G,!1,S);D>-1&&y!==D?this.setFocus([D],h):this.setFocus([G],h)}else{const D=te;this.view.setScrollTop(te-this.view.renderHeight-J),this.view.getScrollTop()+P()!==D&&(this.setFocus([]),await(0,u.timeout)(0),await this.focusPreviousPage(h,S,P))}}focusLast(h,S){if(this.length===0)return;const P=this.findPreviousIndex(this.length-1,!1,S);P>-1&&this.setFocus([P],h)}focusFirst(h,S){this.focusNth(0,h,S)}focusNth(h,S,P){if(this.length===0)return;const G=this.findNextIndex(h,!1,P);G>-1&&this.setFocus([G],S)}findNextIndex(h,S=!1,P){for(let G=0;G<this.length;G++){if(h>=this.length&&!S)return-1;if(h=h%this.length,!P||P(this.element(h)))return h;h++}return-1}findPreviousIndex(h,S=!1,P){for(let G=0;G<this.length;G++){if(h<0&&!S)return-1;if(h=(this.length+h%this.length)%this.length,!P||P(this.element(h)))return h;h--}return-1}getFocus(){return this.focus.get()}getFocusedElements(){return this.getFocus().map(h=>this.view.element(h))}reveal(h,S,P=0){if(h<0||h>=this.length)throw new p.ListError(this.user,`Invalid index ${h}`);const G=this.view.getScrollTop(),J=this.view.elementTop(h),te=this.view.elementHeight(h);if((0,o.isNumber)(S)){const y=te-this.view.renderHeight+P;this.view.setScrollTop(y*(0,r.clamp)(S,0,1)+J-P)}else{const y=J+te,D=G+this.view.renderHeight;J<G+P&&y>=D||(J<G+P||y>=D&&te>=this.view.renderHeight?this.view.setScrollTop(J-P):y>=D&&this.view.setScrollTop(y-this.view.renderHeight))}}getRelativeTop(h,S=0){if(h<0||h>=this.length)throw new p.ListError(this.user,`Invalid index ${h}`);const P=this.view.getScrollTop(),G=this.view.elementTop(h),J=this.view.elementHeight(h);if(G<P+S||G+J>P+this.view.renderHeight)return null;const te=J-this.view.renderHeight+S;return Math.abs((P+S-G)/te)}isDOMFocused(){return(0,i.isActiveElement)(this.view.domNode)}getHTMLElement(){return this.view.domNode}getScrollableElement(){return this.view.scrollableElementDomNode}getElementID(h){return this.view.getElementDomId(h)}getElementTop(h){return this.view.elementTop(h)}style(h){this.styleController.style(h)}toListEvent({indexes:h,browserEvent:S}){return{indexes:h,elements:h.map(P=>this.view.element(P)),browserEvent:S}}_onFocusChange(){const h=this.focus.get();this.view.domNode.classList.toggle("element-focused",h.length>0),this.onDidChangeActiveDescendant()}onDidChangeActiveDescendant(){const h=this.focus.get();if(h.length>0){let S;this.accessibilityProvider?.getActiveDescendantId&&(S=this.accessibilityProvider.getActiveDescendantId(this.view.element(h[0]))),this.view.domNode.setAttribute("aria-activedescendant",S||this.view.getElementDomId(h[0]))}else this.view.domNode.removeAttribute("aria-activedescendant")}_onSelectionChange(){const h=this.selection.get();this.view.domNode.classList.toggle("selection-none",h.length===0),this.view.domNode.classList.toggle("selection-single",h.length===1),this.view.domNode.classList.toggle("selection-multiple",h.length>1)}dispose(){this._onDidDispose.fire(),this.disposables.dispose(),this._onDidDispose.dispose()}}t.List=oe,lt([v.memoize],oe.prototype,"onDidChangeFocus",null),lt([v.memoize],oe.prototype,"onDidChangeSelection",null),lt([v.memoize],oe.prototype,"onContextMenu",null),lt([v.memoize],oe.prototype,"onKeyDown",null),lt([v.memoize],oe.prototype,"onKeyUp",null),lt([v.memoize],oe.prototype,"onKeyPress",null),lt([v.memoize],oe.prototype,"onDidFocus",null),lt([v.memoize],oe.prototype,"onDidBlur",null)}),define(_e[137],Se([1,0,6,67,51,11,16]),function(ue,t,i,n,O,I,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.MarkdownString=t.MarkdownStringTextNewlineStyle=void 0,t.isEmptyMarkdownString=u,t.isMarkdownString=m,t.markdownStringEqual=v,t.escapeMarkdownSyntaxTokens=g,t.appendEscapedMarkdownCodeBlockFence=d,t.escapeDoubleQuotes=e,t.removeMarkdownEscapes=s,t.parseHrefAndDimensions=r;var b;(function(l){l[l.Paragraph=0]="Paragraph",l[l.Break=1]="Break"})(b||(t.MarkdownStringTextNewlineStyle=b={}));class w{constructor(o="",p=!1){if(this.value=o,typeof this.value!="string")throw(0,i.illegalArgument)("value");typeof p=="boolean"?(this.isTrusted=p,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=p.isTrusted??void 0,this.supportThemeIcons=p.supportThemeIcons??!1,this.supportHtml=p.supportHtml??!1)}appendText(o,p=b.Paragraph){return this.value+=g(this.supportThemeIcons?(0,n.escapeIcons)(o):o).replace(/([ \t]+)/g,(A,L)=>"&nbsp;".repeat(L.length)).replace(/\>/gm,"\\>").replace(/\n/g,p===b.Break?`\\
`:`

`),this}appendMarkdown(o){return this.value+=o,this}appendCodeblock(o,p){return this.value+=`
${d(p,o)}
`,this}appendLink(o,p,A){return this.value+="[",this.value+=this._escape(p,"]"),this.value+="](",this.value+=this._escape(String(o),")"),A&&(this.value+=` "${this._escape(this._escape(A,'"'),")")}"`),this.value+=")",this}_escape(o,p){const A=new RegExp((0,I.escapeRegExpCharacters)(p),"g");return o.replace(A,(L,c)=>o.charAt(c-1)!=="\\"?`\\${L}`:L)}}t.MarkdownString=w;function u(l){return m(l)?!l.value:Array.isArray(l)?l.every(u):!0}function m(l){return l instanceof w?!0:l&&typeof l=="object"?typeof l.value=="string"&&(typeof l.isTrusted=="boolean"||typeof l.isTrusted=="object"||l.isTrusted===void 0)&&(typeof l.supportThemeIcons=="boolean"||l.supportThemeIcons===void 0):!1}function v(l,o){return l===o?!0:!l||!o?!1:l.value===o.value&&l.isTrusted===o.isTrusted&&l.supportThemeIcons===o.supportThemeIcons&&l.supportHtml===o.supportHtml&&(l.baseUri===o.baseUri||!!l.baseUri&&!!o.baseUri&&(0,O.isEqual)(N.URI.from(l.baseUri),N.URI.from(o.baseUri)))}function g(l){return l.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}function d(l,o){const p=l.match(/^`+/gm)?.reduce((L,c)=>L.length>c.length?L:c).length??0,A=p>=3?p+1:3;return[`${"`".repeat(A)}${o}`,l,`${"`".repeat(A)}`].join(`
`)}function e(l){return l.replace(/"/g,"&quot;")}function s(l){return l&&l.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}function r(l){const o=[],p=l.split("|").map(L=>L.trim());l=p[0];const A=p[1];if(A){const L=/height=(\d+)/.exec(A),c=/width=(\d+)/.exec(A),a=L?L[1]:"",f=c?c[1]:"",_=isFinite(parseInt(f)),H=isFinite(parseInt(a));_&&o.push(`width="${f}"`),H&&o.push(`height="${a}"`)}return{href:l,dimensions:o}}}),define(_e[138],Se([1,0,4,129,28,73,15,22,130,6,3,137,67,91,8,25,2,93,71,40,64,51,11,16]),function(ue,t,i,n,O,I,N,b,w,u,m,v,g,d,e,s,r,l,o,p,A,L,c,a){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.allowedMarkdownAttr=void 0,t.renderMarkdown=_,t.renderStringAsPlaintext=W,t.renderMarkdownAsPlaintext=R,t.fillInIncompleteTokens=re,i=qe(i),n=qe(n),l=qe(l);const f=Object.freeze({image:({href:x,title:h,text:S})=>{let P=[],G=[];return x&&({href:x,dimensions:P}=(0,v.parseHrefAndDimensions)(x),G.push(`src="${(0,v.escapeDoubleQuotes)(x)}"`)),S&&G.push(`alt="${(0,v.escapeDoubleQuotes)(S)}"`),h&&G.push(`title="${(0,v.escapeDoubleQuotes)(h)}"`),P.length&&(G=G.concat(P)),"<img "+G.join(" ")+">"},paragraph({tokens:x}){return`<p>${this.parser.parseInline(x)}</p>`},link({href:x,title:h,tokens:S}){let P=this.parser.parseInline(S);return typeof x!="string"?"":(x===P&&(P=(0,v.removeMarkdownEscapes)(P)),h=typeof h=="string"?(0,v.escapeDoubleQuotes)((0,v.removeMarkdownEscapes)(h)):"",x=(0,v.removeMarkdownEscapes)(x),x=x.replace(/&/g,"&amp;").replace(/</g,"&lt;").replace(/>/g,"&gt;").replace(/"/g,"&quot;").replace(/'/g,"&#39;"),`<a href="${x}" title="${h||x}" draggable="false">${P}</a>`)}});function _(x,h={},S={}){const P=new r.DisposableStore;let G=!1;const J=(0,I.createElement)(h),te=function(we){let De;try{De=(0,o.parse)(decodeURIComponent(we))}catch{}return De?(De=(0,A.cloneAndChange)(De,Te=>{if(x.uris&&x.uris[Te])return a.URI.revive(x.uris[Te])}),encodeURIComponent(JSON.stringify(De))):we},y=function(we,De){const Te=x.uris&&x.uris[we];let Oe=a.URI.revive(Te);return De?we.startsWith(p.Schemas.data+":")?we:(Oe||(Oe=a.URI.parse(we)),p.FileAccess.uriToBrowserUri(Oe).toString(!0)):!Oe||a.URI.parse(we).toString()===Oe.toString()?we:(Oe.query&&(Oe=Oe.with({query:te(Oe.query)})),Oe.toString())},D=new l.Renderer;D.image=f.image,D.link=f.link,D.paragraph=f.paragraph;const z=[],V=[];if(h.codeBlockRendererSync?D.code=({text:we,lang:De})=>{const Te=d.defaultGenerator.nextId(),Oe=h.codeBlockRendererSync(H(De),we);return V.push([Te,Oe]),`<div class="code" data-code="${Te}">${(0,c.escape)(we)}</div>`}:h.codeBlockRenderer&&(D.code=({text:we,lang:De})=>{const Te=d.defaultGenerator.nextId(),Oe=h.codeBlockRenderer(H(De),we);return z.push(Oe.then(Ae=>[Te,Ae])),`<div class="code" data-code="${Te}">${(0,c.escape)(we)}</div>`}),h.actionHandler){const we=function(Oe){let Ae=Oe.target;if(!(Ae.tagName!=="A"&&(Ae=Ae.parentElement,!Ae||Ae.tagName!=="A")))try{let ke=Ae.dataset.href;ke&&(x.baseUri&&(ke=B(a.URI.from(x.baseUri),ke)),h.actionHandler.callback(ke,Oe))}catch(ke){(0,u.onUnexpectedError)(ke)}finally{Oe.preventDefault()}},De=h.actionHandler.disposables.add(new O.DomEmitter(J,"click")),Te=h.actionHandler.disposables.add(new O.DomEmitter(J,"auxclick"));h.actionHandler.disposables.add(m.Event.any(De.event,Te.event)(Oe=>{const Ae=new b.StandardMouseEvent(i.getWindow(J),Oe);!Ae.leftButton&&!Ae.middleButton||we(Ae)})),h.actionHandler.disposables.add(i.addDisposableListener(J,"keydown",Oe=>{const Ae=new N.StandardKeyboardEvent(Oe);!Ae.equals(e.KeyCode.Space)&&!Ae.equals(e.KeyCode.Enter)||we(Ae)}))}x.supportHtml||(D.html=({text:we})=>h.sanitizerOptions?.replaceWithPlaintext?(0,c.escape)(we):(x.isTrusted?we.match(/^(<span[^>]+>)|(<\/\s*span>)$/):void 0)?we:""),S.renderer=D;let q=x.value??"";q.length>1e5&&(q=`${q.substr(0,1e5)}\u2026`),x.supportThemeIcons&&(q=(0,g.markdownEscapeEscapedIcons)(q));let se;if(h.fillInIncompleteTokens){const we={...l.defaults,...S},De=l.lexer(q,we),Te=re(De);se=l.parser(Te,we)}else se=l.parse(q,{...S,async:!1});x.supportThemeIcons&&(se=(0,w.renderLabelWithIcons)(se).map(De=>typeof De=="string"?De:De.outerHTML).join(""));const ge=new DOMParser().parseFromString(E({isTrusted:x.isTrusted,...h.sanitizerOptions},se),"text/html");if(ge.body.querySelectorAll("img, audio, video, source").forEach(we=>{const De=we.getAttribute("src");if(De){let Te=De;try{x.baseUri&&(Te=B(a.URI.from(x.baseUri),Te))}catch{}if(we.setAttribute("src",y(Te,!0)),h.remoteImageIsAllowed){const Oe=a.URI.parse(Te);Oe.scheme!==p.Schemas.file&&Oe.scheme!==p.Schemas.data&&!h.remoteImageIsAllowed(Oe)&&we.replaceWith(i.$("",void 0,we.outerHTML))}}}),ge.body.querySelectorAll("a").forEach(we=>{const De=we.getAttribute("href");if(we.setAttribute("href",""),!De||/^data:|javascript:/i.test(De)||/^command:/i.test(De)&&!x.isTrusted||/^command:(\/\/\/)?_workbench\.downloadResource/i.test(De))we.replaceWith(...we.childNodes);else{let Te=y(De,!1);x.baseUri&&(Te=B(a.URI.from(x.baseUri),De)),we.dataset.href=Te}}),J.innerHTML=E({isTrusted:x.isTrusted,...h.sanitizerOptions},ge.body.innerHTML),z.length>0)Promise.all(z).then(we=>{if(G)return;const De=new Map(we),Te=J.querySelectorAll("div[data-code]");for(const Oe of Te){const Ae=De.get(Oe.dataset.code??"");Ae&&i.reset(Oe,Ae)}h.asyncRenderCallback?.()});else if(V.length>0){const we=new Map(V),De=J.querySelectorAll("div[data-code]");for(const Te of De){const Oe=we.get(Te.dataset.code??"");Oe&&i.reset(Te,Oe)}}if(h.asyncRenderCallback)for(const we of J.getElementsByTagName("img")){const De=P.add(i.addDisposableListener(we,"load",()=>{De.dispose(),h.asyncRenderCallback()}))}return{element:J,dispose:()=>{G=!0,P.dispose()}}}function H(x){if(!x)return"";const h=x.split(/[\s+|:|,|\{|\?]/,1);return h.length?h[0]:x}function B(x,h){return/^\w[\w\d+.-]*:/.test(h)?h:x.path.endsWith("/")?(0,L.resolvePath)(x,h).toString():(0,L.resolvePath)((0,L.dirname)(x),h).toString()}const F=["area","base","br","col","command","embed","hr","img","input","keygen","link","meta","param","source","track","wbr"];function E(x,h){const{config:S,allowedSchemes:P}=k(x),G=new r.DisposableStore;G.add(oe("uponSanitizeAttribute",(J,te)=>{if(te.attrName==="style"||te.attrName==="class"){if(J.tagName==="SPAN"){if(te.attrName==="style"){te.keepAttr=/^(color\:(#[0-9a-fA-F]+|var\(--vscode(-[a-zA-Z]+)+\));)?(background-color\:(#[0-9a-fA-F]+|var\(--vscode(-[a-zA-Z]+)+\));)?(border-radius:[0-9]+px;)?$/.test(te.attrValue);return}else if(te.attrName==="class"){te.keepAttr=/^codicon codicon-[a-z\-]+( codicon-modifier-[a-z\-]+)?$/.test(te.attrValue);return}}te.keepAttr=!1;return}else if(J.tagName==="INPUT"&&J.attributes.getNamedItem("type")?.value==="checkbox"){if(te.attrName==="type"&&te.attrValue==="checkbox"||te.attrName==="disabled"||te.attrName==="checked"){te.keepAttr=!0;return}te.keepAttr=!1}})),G.add(oe("uponSanitizeElement",(J,te)=>{if(te.tagName==="input"&&(J.attributes.getNamedItem("type")?.value==="checkbox"?J.setAttribute("disabled",""):x.replaceWithPlaintext||J.remove()),x.replaceWithPlaintext&&!te.allowedTags[te.tagName]&&te.tagName!=="body"&&J.parentElement){let y,D;if(te.tagName==="#comment")y=`<!--${J.textContent}-->`;else{const se=F.includes(te.tagName),ae=J.attributes.length?" "+Array.from(J.attributes).map(ge=>`${ge.name}="${ge.value}"`).join(" "):"";y=`<${te.tagName}${ae}>`,se||(D=`</${te.tagName}>`)}const z=document.createDocumentFragment(),V=J.parentElement.ownerDocument.createTextNode(y);z.appendChild(V);const q=D?J.parentElement.ownerDocument.createTextNode(D):void 0;for(;J.firstChild;)z.appendChild(J.firstChild);q&&z.appendChild(q),J.parentElement.replaceChild(z,J)}})),G.add(i.hookDomPurifyHrefAndSrcSanitizer(P));try{return n.sanitize(h,{...S,RETURN_TRUSTED_TYPE:!0})}finally{G.dispose()}}t.allowedMarkdownAttr=["align","autoplay","alt","checked","class","colspan","controls","data-code","data-href","disabled","draggable","height","href","loop","muted","playsinline","poster","rowspan","src","style","target","title","type","width","start"];function k(x){const h=[p.Schemas.http,p.Schemas.https,p.Schemas.mailto,p.Schemas.data,p.Schemas.file,p.Schemas.vscodeFileResource,p.Schemas.vscodeRemote,p.Schemas.vscodeRemoteResource];return x.isTrusted&&h.push(p.Schemas.command),{config:{ALLOWED_TAGS:x.allowedTags??[...i.basicMarkupHtmlTags],ALLOWED_ATTR:t.allowedMarkdownAttr,ALLOW_UNKNOWN_PROTOCOLS:!0},allowedSchemes:h}}function W(x){return typeof x=="string"?x:R(x)}function R(x,h){let S=x.value??"";S.length>1e5&&(S=`${S.substr(0,1e5)}\u2026`);const P=l.parse(S,{async:!1,renderer:h?Y.value:ee.value}).replace(/&(#\d+|[a-zA-Z]+);/g,G=>C.get(G)??G);return E({isTrusted:!1},P).toString()}const C=new Map([["&quot;",'"'],["&nbsp;"," "],["&amp;","&"],["&#39;","'"],["&lt;","<"],["&gt;",">"]]);function $(){const x=new l.Renderer;return x.code=({text:h})=>h,x.blockquote=({text:h})=>h+`
`,x.html=h=>"",x.heading=function({tokens:h}){return this.parser.parseInline(h)+`
`},x.hr=()=>"",x.list=function({items:h}){return h.map(S=>this.listitem(S)).join(`
`)+`
`},x.listitem=({text:h})=>h+`
`,x.paragraph=function({tokens:h}){return this.parser.parseInline(h)+`
`},x.table=function({header:h,rows:S}){return h.map(P=>this.tablecell(P)).join(" ")+`
`+S.map(P=>P.map(G=>this.tablecell(G)).join(" ")).join(`
`)+`
`},x.tablerow=({text:h})=>h,x.tablecell=function({tokens:h}){return this.parser.parseInline(h)},x.strong=({text:h})=>h,x.em=({text:h})=>h,x.codespan=({text:h})=>h,x.br=h=>`
`,x.del=({text:h})=>h,x.image=h=>"",x.text=({text:h})=>h,x.link=({text:h})=>h,x}const ee=new s.Lazy(x=>$()),Y=new s.Lazy(()=>{const x=$();return x.code=({text:h})=>`
\`\`\`
${h}
\`\`\`
`,x});function Z(x){let h="";return x.forEach(S=>{h+=S.raw}),h}function ce(x){if(x.tokens)for(let h=x.tokens.length-1;h>=0;h--){const S=x.tokens[h];if(S.type==="text"){const P=S.raw.split(`
`),G=P[P.length-1];if(G.includes("`"))return fe(x);if(G.includes("**"))return Ce(x);if(G.match(/\*\w/))return ve(x);if(G.match(/(^|\s)__\w/))return Fe(x);if(G.match(/(^|\s)_\w/))return Ne(x);if(he(G)||ye(G)&&x.tokens.slice(0,h).some(J=>J.type==="text"&&J.raw.match(/\[[^\]]*$/))){const J=x.tokens.slice(h+1);return J[0]?.type==="link"&&J[1]?.type==="text"&&J[1].raw.match(/^ *"[^"]*$/)||G.match(/^[^"]* +"[^"]*$/)?Ee(x):ne(x)}else if(G.match(/(^|\s)\[\w*/))return Le(x)}}}function he(x){return!!x.match(/(^|\s)\[.*\]\(\w*/)}function ye(x){return!!x.match(/^[^\[]*\]\([^\)]*$/)}function Re(x){const h=x.items[x.items.length-1],S=h.tokens?h.tokens[h.tokens.length-1]:void 0;let P;if(S?.type==="text"&&!("inRawBlock"in h)&&(P=ce(S)),!P||P.type!=="paragraph")return;const G=Z(x.items.slice(0,-1)),J=h.raw.match(/^(\s*(-|\d+\.|\*) +)/)?.[0];if(!J)return;const te=J+Z(h.tokens.slice(0,-1))+P.raw,y=l.lexer(G+te)[0];if(y.type==="list")return y}const Pe=3;function re(x){for(let h=0;h<Pe;h++){const S=ie(x);if(S)x=S;else break}return x}function ie(x){let h,S;for(h=0;h<x.length;h++){const P=x[h];if(P.type==="paragraph"&&P.raw.match(/(\n|^)\|/)){S=Xe(x.slice(h));break}if(h===x.length-1&&P.type==="list"){const G=Re(P);if(G){S=[G];break}}if(h===x.length-1&&P.type==="paragraph"){const G=ce(P);if(G){S=[G];break}}}if(S){const P=[...x.slice(0,h),...S];return P.links=x.links,P}return null}function fe(x){return ze(x,"`")}function ve(x){return ze(x,"*")}function Ne(x){return ze(x,"_")}function ne(x){return ze(x,")")}function Ee(x){return ze(x,'")')}function Le(x){return ze(x,"](https://microsoft.com)")}function Ce(x){return ze(x,"**")}function Fe(x){return ze(x,"__")}function ze(x,h){const S=Z(Array.isArray(x)?x:[x]);return l.lexer(S+h)[0]}function Xe(x){const h=Z(x),S=h.split(`
`);let P,G=!1;for(let J=0;J<S.length;J++){const te=S[J].trim();if(typeof P>"u"&&te.match(/^\s*\|/)){const y=te.match(/(\|[^\|]+)(?=\||$)/g);y&&(P=y.length)}else if(typeof P=="number")if(te.match(/^\s*\|/)){if(J!==S.length-1)return;G=!0}else return}if(typeof P=="number"&&P>0){const J=G?S.slice(0,-1).join(`
`):h,te=!!J.match(/\|\s*$/),y=J+(te?"":"|")+`
|${" --- |".repeat(P)}`;return l.lexer(y)}}function oe(x,h){return n.addHook(x,h),(0,r.toDisposable)(()=>n.removeHook(x))}}),define(_e[139],Se([1,0,4,28,15,138,75,33,14,54,9,3,8,2,5,19,12,121]),function(ue,t,i,n,O,I,N,b,w,u,m,v,g,d,e,s,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SelectBoxList=void 0,i=qe(i),m=qe(m);const l=i.$,o="selectOption.entry.template";class p{get templateId(){return o}renderTemplate(c){const a=Object.create(null);return a.root=c,a.text=i.append(c,l(".option-text")),a.detail=i.append(c,l(".option-detail")),a.decoratorRight=i.append(c,l(".option-decorator-right")),a}renderElement(c,a,f){const _=f,H=c.text,B=c.detail,F=c.decoratorRight,E=c.isDisabled;_.text.textContent=H,_.detail.textContent=B||"",_.decoratorRight.innerText=F||"",E?_.root.classList.add("option-disabled"):_.root.classList.remove("option-disabled")}disposeTemplate(c){}}class A extends d.Disposable{static{this.DEFAULT_DROPDOWN_MINIMUM_BOTTOM_MARGIN=32}static{this.DEFAULT_DROPDOWN_MINIMUM_TOP_MARGIN=2}static{this.DEFAULT_MINIMUM_VISIBLE_OPTIONS=3}constructor(c,a,f,_,H){super(),this.options=[],this._currentSelection=0,this._hasDetails=!1,this._skipLayout=!1,this._sticky=!1,this._isVisible=!1,this.styles=_,this.selectBoxOptions=H||Object.create(null),typeof this.selectBoxOptions.minBottomMargin!="number"?this.selectBoxOptions.minBottomMargin=A.DEFAULT_DROPDOWN_MINIMUM_BOTTOM_MARGIN:this.selectBoxOptions.minBottomMargin<0&&(this.selectBoxOptions.minBottomMargin=0),this.selectElement=document.createElement("select"),this.selectElement.className="monaco-select-box monaco-select-box-dropdown-padding",typeof this.selectBoxOptions.ariaLabel=="string"&&this.selectElement.setAttribute("aria-label",this.selectBoxOptions.ariaLabel),typeof this.selectBoxOptions.ariaDescription=="string"&&this.selectElement.setAttribute("aria-description",this.selectBoxOptions.ariaDescription),this._onDidSelect=new v.Emitter,this._register(this._onDidSelect),this.registerListeners(),this.constructSelectDropDown(f),this.selected=a||0,c&&this.setOptions(c,a),this.initStyleSheet()}setTitle(c){!this._hover&&c?this._hover=this._register((0,b.getBaseLayerHoverDelegate)().setupManagedHover((0,w.getDefaultHoverDelegate)("mouse"),this.selectElement,c)):this._hover&&this._hover.update(c)}getHeight(){return 22}getTemplateId(){return o}constructSelectDropDown(c){this.contextViewProvider=c,this.selectDropDownContainer=i.$(".monaco-select-box-dropdown-container"),this.selectDropDownContainer.classList.add("monaco-select-box-dropdown-padding"),this.selectionDetailsPane=i.append(this.selectDropDownContainer,l(".select-box-details-pane"));const a=i.append(this.selectDropDownContainer,l(".select-box-dropdown-container-width-control")),f=i.append(a,l(".width-control-div"));this.widthControlElement=document.createElement("span"),this.widthControlElement.className="option-text-width-control",i.append(f,this.widthControlElement),this._dropDownPosition=N.AnchorPosition.BELOW,this.styleElement=i.createStyleSheet(this.selectDropDownContainer),this.selectDropDownContainer.setAttribute("draggable","true"),this._register(i.addDisposableListener(this.selectDropDownContainer,i.EventType.DRAG_START,_=>{i.EventHelper.stop(_,!0)}))}registerListeners(){this._register(i.addStandardDisposableListener(this.selectElement,"change",a=>{this.selected=a.target.selectedIndex,this._onDidSelect.fire({index:a.target.selectedIndex,selected:a.target.value}),this.options[this.selected]&&this.options[this.selected].text&&this.setTitle(this.options[this.selected].text)})),this._register(i.addDisposableListener(this.selectElement,i.EventType.CLICK,a=>{i.EventHelper.stop(a),this._isVisible?this.hideSelectDropDown(!0):this.showSelectDropDown()})),this._register(i.addDisposableListener(this.selectElement,i.EventType.MOUSE_DOWN,a=>{i.EventHelper.stop(a)}));let c;this._register(i.addDisposableListener(this.selectElement,"touchstart",a=>{c=this._isVisible})),this._register(i.addDisposableListener(this.selectElement,"touchend",a=>{i.EventHelper.stop(a),c?this.hideSelectDropDown(!0):this.showSelectDropDown()})),this._register(i.addDisposableListener(this.selectElement,i.EventType.KEY_DOWN,a=>{const f=new O.StandardKeyboardEvent(a);let _=!1;e.isMacintosh?(f.keyCode===g.KeyCode.DownArrow||f.keyCode===g.KeyCode.UpArrow||f.keyCode===g.KeyCode.Space||f.keyCode===g.KeyCode.Enter)&&(_=!0):(f.keyCode===g.KeyCode.DownArrow&&f.altKey||f.keyCode===g.KeyCode.UpArrow&&f.altKey||f.keyCode===g.KeyCode.Space||f.keyCode===g.KeyCode.Enter)&&(_=!0),_&&(this.showSelectDropDown(),i.EventHelper.stop(a,!0))}))}get onDidSelect(){return this._onDidSelect.event}setOptions(c,a){m.equals(this.options,c)||(this.options=c,this.selectElement.options.length=0,this._hasDetails=!1,this._cachedMaxDetailsHeight=void 0,this.options.forEach((f,_)=>{this.selectElement.add(this.createOption(f.text,_,f.isDisabled)),typeof f.description=="string"&&(this._hasDetails=!0)})),a!==void 0&&(this.select(a),this._currentSelection=this.selected)}setEnabled(c){this.selectElement.disabled=!c}setOptionsList(){this.selectList?.splice(0,this.selectList.length,this.options)}select(c){c>=0&&c<this.options.length?this.selected=c:c>this.options.length-1?this.select(this.options.length-1):this.selected<0&&(this.selected=0),this.selectElement.selectedIndex=this.selected,this.options[this.selected]&&this.options[this.selected].text&&this.setTitle(this.options[this.selected].text)}setAriaLabel(c){this.selectBoxOptions.ariaLabel=c,this.selectElement.setAttribute("aria-label",this.selectBoxOptions.ariaLabel)}focus(){this.selectElement&&(this.selectElement.tabIndex=0,this.selectElement.focus())}blur(){this.selectElement&&(this.selectElement.tabIndex=-1,this.selectElement.blur())}setFocusable(c){this.selectElement.tabIndex=c?0:-1}render(c){this.container=c,c.classList.add("select-container"),c.appendChild(this.selectElement),this.styleSelectElement()}initStyleSheet(){const c=[];this.styles.listFocusBackground&&c.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { background-color: ${this.styles.listFocusBackground} !important; }`),this.styles.listFocusForeground&&c.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { color: ${this.styles.listFocusForeground} !important; }`),this.styles.decoratorRightForeground&&c.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.focused) .option-decorator-right { color: ${this.styles.decoratorRightForeground}; }`),this.styles.selectBackground&&this.styles.selectBorder&&this.styles.selectBorder!==this.styles.selectBackground?(c.push(`.monaco-select-box-dropdown-container { border: 1px solid ${this.styles.selectBorder} } `),c.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-top { border-top: 1px solid ${this.styles.selectBorder} } `),c.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-bottom { border-bottom: 1px solid ${this.styles.selectBorder} } `)):this.styles.selectListBorder&&(c.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-top { border-top: 1px solid ${this.styles.selectListBorder} } `),c.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-bottom { border-bottom: 1px solid ${this.styles.selectListBorder} } `)),this.styles.listHoverForeground&&c.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { color: ${this.styles.listHoverForeground} !important; }`),this.styles.listHoverBackground&&c.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { background-color: ${this.styles.listHoverBackground} !important; }`),this.styles.listFocusOutline&&c.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { outline: 1.6px dotted ${this.styles.listFocusOutline} !important; outline-offset: -1.6px !important; }`),this.styles.listHoverOutline&&c.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { outline: 1.6px dashed ${this.styles.listHoverOutline} !important; outline-offset: -1.6px !important; }`),c.push(".monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.option-disabled.focused { background-color: transparent !important; color: inherit !important; outline: none !important; }"),c.push(".monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.option-disabled:hover { background-color: transparent !important; color: inherit !important; outline: none !important; }"),this.styleElement.textContent=c.join(`
`)}styleSelectElement(){const c=this.styles.selectBackground??"",a=this.styles.selectForeground??"",f=this.styles.selectBorder??"";this.selectElement.style.backgroundColor=c,this.selectElement.style.color=a,this.selectElement.style.borderColor=f}styleList(){const c=this.styles.selectBackground??"",a=i.asCssValueWithDefault(this.styles.selectListBackground,c);this.selectDropDownListContainer.style.backgroundColor=a,this.selectionDetailsPane.style.backgroundColor=a;const f=this.styles.focusBorder??"";this.selectDropDownContainer.style.outlineColor=f,this.selectDropDownContainer.style.outlineOffset="-1px",this.selectList.style(this.styles)}createOption(c,a,f){const _=document.createElement("option");return _.value=c,_.text=c,_.disabled=!!f,_}showSelectDropDown(){this.selectionDetailsPane.innerText="",!(!this.contextViewProvider||this._isVisible)&&(this.createSelectList(this.selectDropDownContainer),this.setOptionsList(),this.contextViewProvider.showContextView({getAnchor:()=>this.selectElement,render:c=>this.renderSelectDropDown(c,!0),layout:()=>{this.layoutSelectDropDown()},onHide:()=>{this.selectDropDownContainer.classList.remove("visible"),this.selectElement.classList.remove("synthetic-focus")},anchorPosition:this._dropDownPosition},this.selectBoxOptions.optionsAsChildren?this.container:void 0),this._isVisible=!0,this.hideSelectDropDown(!1),this.contextViewProvider.showContextView({getAnchor:()=>this.selectElement,render:c=>this.renderSelectDropDown(c),layout:()=>this.layoutSelectDropDown(),onHide:()=>{this.selectDropDownContainer.classList.remove("visible"),this.selectElement.classList.remove("synthetic-focus")},anchorPosition:this._dropDownPosition},this.selectBoxOptions.optionsAsChildren?this.container:void 0),this._currentSelection=this.selected,this._isVisible=!0,this.selectElement.setAttribute("aria-expanded","true"))}hideSelectDropDown(c){!this.contextViewProvider||!this._isVisible||(this._isVisible=!1,this.selectElement.setAttribute("aria-expanded","false"),c&&this.selectElement.focus(),this.contextViewProvider.hideContextView())}renderSelectDropDown(c,a){return c.appendChild(this.selectDropDownContainer),this.layoutSelectDropDown(a),{dispose:()=>{this.selectDropDownContainer.remove()}}}measureMaxDetailsHeight(){let c=0;return this.options.forEach((a,f)=>{this.updateDetail(f),this.selectionDetailsPane.offsetHeight>c&&(c=this.selectionDetailsPane.offsetHeight)}),c}layoutSelectDropDown(c){if(this._skipLayout)return!1;if(this.selectList){this.selectDropDownContainer.classList.add("visible");const a=i.getWindow(this.selectElement),f=i.getDomNodePagePosition(this.selectElement),_=i.getWindow(this.selectElement).getComputedStyle(this.selectElement),H=parseFloat(_.getPropertyValue("--dropdown-padding-top"))+parseFloat(_.getPropertyValue("--dropdown-padding-bottom")),B=a.innerHeight-f.top-f.height-(this.selectBoxOptions.minBottomMargin||0),F=f.top-A.DEFAULT_DROPDOWN_MINIMUM_TOP_MARGIN,E=this.selectElement.offsetWidth,k=this.setWidthControlElement(this.widthControlElement),W=Math.max(k,Math.round(E)).toString()+"px";this.selectDropDownContainer.style.width=W,this.selectList.getHTMLElement().style.height="",this.selectList.layout();let R=this.selectList.contentHeight;this._hasDetails&&this._cachedMaxDetailsHeight===void 0&&(this._cachedMaxDetailsHeight=this.measureMaxDetailsHeight());const C=this._hasDetails?this._cachedMaxDetailsHeight:0,$=R+H+C,ee=Math.floor((B-H-C)/this.getHeight()),Y=Math.floor((F-H-C)/this.getHeight());if(c)return f.top+f.height>a.innerHeight-22||f.top<A.DEFAULT_DROPDOWN_MINIMUM_TOP_MARGIN||ee<1&&Y<1?!1:(ee<A.DEFAULT_MINIMUM_VISIBLE_OPTIONS&&Y>ee&&this.options.length>ee?(this._dropDownPosition=N.AnchorPosition.ABOVE,this.selectDropDownListContainer.remove(),this.selectionDetailsPane.remove(),this.selectDropDownContainer.appendChild(this.selectionDetailsPane),this.selectDropDownContainer.appendChild(this.selectDropDownListContainer),this.selectionDetailsPane.classList.remove("border-top"),this.selectionDetailsPane.classList.add("border-bottom")):(this._dropDownPosition=N.AnchorPosition.BELOW,this.selectDropDownListContainer.remove(),this.selectionDetailsPane.remove(),this.selectDropDownContainer.appendChild(this.selectDropDownListContainer),this.selectDropDownContainer.appendChild(this.selectionDetailsPane),this.selectionDetailsPane.classList.remove("border-bottom"),this.selectionDetailsPane.classList.add("border-top")),!0);if(f.top+f.height>a.innerHeight-22||f.top<A.DEFAULT_DROPDOWN_MINIMUM_TOP_MARGIN||this._dropDownPosition===N.AnchorPosition.BELOW&&ee<1||this._dropDownPosition===N.AnchorPosition.ABOVE&&Y<1)return this.hideSelectDropDown(!0),!1;if(this._dropDownPosition===N.AnchorPosition.BELOW){if(this._isVisible&&ee+Y<1)return this.hideSelectDropDown(!0),!1;$>B&&(R=ee*this.getHeight())}else $>F&&(R=Y*this.getHeight());return this.selectList.layout(R),this.selectList.domFocus(),this.selectList.length>0&&(this.selectList.setFocus([this.selected||0]),this.selectList.reveal(this.selectList.getFocus()[0]||0)),this._hasDetails?(this.selectList.getHTMLElement().style.height=R+H+"px",this.selectDropDownContainer.style.height=""):this.selectDropDownContainer.style.height=R+H+"px",this.updateDetail(this.selected),this.selectDropDownContainer.style.width=W,this.selectDropDownListContainer.setAttribute("tabindex","0"),this.selectElement.classList.add("synthetic-focus"),this.selectDropDownContainer.classList.add("synthetic-focus"),!0}else return!1}setWidthControlElement(c){let a=0;if(c){let f=0,_=0;this.options.forEach((H,B)=>{const F=H.detail?H.detail.length:0,E=H.decoratorRight?H.decoratorRight.length:0,k=H.text.length+F+E;k>_&&(f=B,_=k)}),c.textContent=this.options[f].text+(this.options[f].decoratorRight?this.options[f].decoratorRight+" ":""),a=i.getTotalWidth(c)}return a}createSelectList(c){if(this.selectList)return;this.selectDropDownListContainer=i.append(c,l(".select-box-dropdown-list-container")),this.listRenderer=new p,this.selectList=this._register(new u.List("SelectBoxCustom",this.selectDropDownListContainer,this,[this.listRenderer],{useShadows:!1,verticalScrollMode:s.ScrollbarVisibility.Visible,keyboardSupport:!1,mouseSupport:!1,accessibilityProvider:{getAriaLabel:_=>{let H=_.text;return _.detail&&(H+=`. ${_.detail}`),_.decoratorRight&&(H+=`. ${_.decoratorRight}`),_.description&&(H+=`. ${_.description}`),H},getWidgetAriaLabel:()=>(0,r.localize)(28,null),getRole:()=>e.isMacintosh?"":"option",getWidgetRole:()=>"listbox"}})),this.selectBoxOptions.ariaLabel&&(this.selectList.ariaLabel=this.selectBoxOptions.ariaLabel);const a=this._register(new n.DomEmitter(this.selectDropDownListContainer,"keydown")),f=v.Event.chain(a.event,_=>_.filter(()=>this.selectList.length>0).map(H=>new O.StandardKeyboardEvent(H)));this._register(v.Event.chain(f,_=>_.filter(H=>H.keyCode===g.KeyCode.Enter))(this.onEnter,this)),this._register(v.Event.chain(f,_=>_.filter(H=>H.keyCode===g.KeyCode.Tab))(this.onEnter,this)),this._register(v.Event.chain(f,_=>_.filter(H=>H.keyCode===g.KeyCode.Escape))(this.onEscape,this)),this._register(v.Event.chain(f,_=>_.filter(H=>H.keyCode===g.KeyCode.UpArrow))(this.onUpArrow,this)),this._register(v.Event.chain(f,_=>_.filter(H=>H.keyCode===g.KeyCode.DownArrow))(this.onDownArrow,this)),this._register(v.Event.chain(f,_=>_.filter(H=>H.keyCode===g.KeyCode.PageDown))(this.onPageDown,this)),this._register(v.Event.chain(f,_=>_.filter(H=>H.keyCode===g.KeyCode.PageUp))(this.onPageUp,this)),this._register(v.Event.chain(f,_=>_.filter(H=>H.keyCode===g.KeyCode.Home))(this.onHome,this)),this._register(v.Event.chain(f,_=>_.filter(H=>H.keyCode===g.KeyCode.End))(this.onEnd,this)),this._register(v.Event.chain(f,_=>_.filter(H=>H.keyCode>=g.KeyCode.Digit0&&H.keyCode<=g.KeyCode.KeyZ||H.keyCode>=g.KeyCode.Semicolon&&H.keyCode<=g.KeyCode.NumpadDivide))(this.onCharacter,this)),this._register(i.addDisposableListener(this.selectList.getHTMLElement(),i.EventType.POINTER_UP,_=>this.onPointerUp(_))),this._register(this.selectList.onMouseOver(_=>typeof _.index<"u"&&this.selectList.setFocus([_.index]))),this._register(this.selectList.onDidChangeFocus(_=>this.onListFocus(_))),this._register(i.addDisposableListener(this.selectDropDownContainer,i.EventType.FOCUS_OUT,_=>{!this._isVisible||i.isAncestor(_.relatedTarget,this.selectDropDownContainer)||this.onListBlur()})),this.selectList.getHTMLElement().setAttribute("aria-label",this.selectBoxOptions.ariaLabel||""),this.selectList.getHTMLElement().setAttribute("aria-expanded","true"),this.styleList()}onPointerUp(c){if(!this.selectList.length)return;i.EventHelper.stop(c);const a=c.target;if(!a||a.classList.contains("slider"))return;const f=a.closest(".monaco-list-row");if(!f)return;const _=Number(f.getAttribute("data-index")),H=f.classList.contains("option-disabled");_>=0&&_<this.options.length&&!H&&(this.selected=_,this.select(this.selected),this.selectList.setFocus([this.selected]),this.selectList.reveal(this.selectList.getFocus()[0]),this.selected!==this._currentSelection&&(this._currentSelection=this.selected,this._onDidSelect.fire({index:this.selectElement.selectedIndex,selected:this.options[this.selected].text}),this.options[this.selected]&&this.options[this.selected].text&&this.setTitle(this.options[this.selected].text)),this.hideSelectDropDown(!0))}onListBlur(){this._sticky||(this.selected!==this._currentSelection&&this.select(this._currentSelection),this.hideSelectDropDown(!1))}renderDescriptionMarkdown(c,a){const f=H=>{for(let B=0;B<H.childNodes.length;B++){const F=H.childNodes.item(B);(F.tagName&&F.tagName.toLowerCase())==="img"?F.remove():f(F)}},_=(0,I.renderMarkdown)({value:c,supportThemeIcons:!0},{actionHandler:a});return _.element.classList.add("select-box-description-markdown"),f(_.element),_.element}onListFocus(c){!this._isVisible||!this._hasDetails||this.updateDetail(c.indexes[0])}updateDetail(c){this.selectionDetailsPane.innerText="";const a=this.options[c],f=a?.description??"",_=a?.descriptionIsMarkdown??!1;if(f){if(_){const H=a.descriptionMarkdownActionHandler;this.selectionDetailsPane.appendChild(this.renderDescriptionMarkdown(f,H))}else this.selectionDetailsPane.innerText=f;this.selectionDetailsPane.style.display="block"}else this.selectionDetailsPane.style.display="none";this._skipLayout=!0,this.contextViewProvider.layout(),this._skipLayout=!1}onEscape(c){i.EventHelper.stop(c),this.select(this._currentSelection),this.hideSelectDropDown(!0)}onEnter(c){i.EventHelper.stop(c),this.selected!==this._currentSelection&&(this._currentSelection=this.selected,this._onDidSelect.fire({index:this.selectElement.selectedIndex,selected:this.options[this.selected].text}),this.options[this.selected]&&this.options[this.selected].text&&this.setTitle(this.options[this.selected].text)),this.hideSelectDropDown(!0)}onDownArrow(c){if(this.selected<this.options.length-1){i.EventHelper.stop(c,!0);const a=this.options[this.selected+1].isDisabled;if(a&&this.options.length>this.selected+2)this.selected+=2;else{if(a)return;this.selected++}this.select(this.selected),this.selectList.setFocus([this.selected]),this.selectList.reveal(this.selectList.getFocus()[0])}}onUpArrow(c){this.selected>0&&(i.EventHelper.stop(c,!0),this.options[this.selected-1].isDisabled&&this.selected>1?this.selected-=2:this.selected--,this.select(this.selected),this.selectList.setFocus([this.selected]),this.selectList.reveal(this.selectList.getFocus()[0]))}onPageUp(c){i.EventHelper.stop(c),this.selectList.focusPreviousPage(),setTimeout(()=>{this.selected=this.selectList.getFocus()[0],this.options[this.selected].isDisabled&&this.selected<this.options.length-1&&(this.selected++,this.selectList.setFocus([this.selected])),this.selectList.reveal(this.selected),this.select(this.selected)},1)}onPageDown(c){i.EventHelper.stop(c),this.selectList.focusNextPage(),setTimeout(()=>{this.selected=this.selectList.getFocus()[0],this.options[this.selected].isDisabled&&this.selected>0&&(this.selected--,this.selectList.setFocus([this.selected])),this.selectList.reveal(this.selected),this.select(this.selected)},1)}onHome(c){i.EventHelper.stop(c),!(this.options.length<2)&&(this.selected=0,this.options[this.selected].isDisabled&&this.selected>1&&this.selected++,this.selectList.setFocus([this.selected]),this.selectList.reveal(this.selected),this.select(this.selected))}onEnd(c){i.EventHelper.stop(c),!(this.options.length<2)&&(this.selected=this.options.length-1,this.options[this.selected].isDisabled&&this.selected>1&&this.selected--,this.selectList.setFocus([this.selected]),this.selectList.reveal(this.selected),this.select(this.selected))}onCharacter(c){const a=g.KeyCodeUtils.toString(c.keyCode);let f=-1;for(let _=0;_<this.options.length-1;_++)if(f=(_+this.selected+1)%this.options.length,this.options[f].text.charAt(0).toUpperCase()===a&&!this.options[f].isDisabled){this.select(f),this.selectList.setFocus([f]),this.selectList.reveal(this.selectList.getFocus()[0]),i.EventHelper.stop(c);break}}dispose(){this.hideSelectDropDown(!1),super.dispose()}}t.SelectBoxList=A}),define(_e[140],Se([1,0,54,139,133,23,5,120]),function(ue,t,i,n,O,I,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SelectBox=t.unthemedSelectBoxStyles=void 0,t.unthemedSelectBoxStyles={...i.unthemedListStyles,selectBackground:"#3C3C3C",selectForeground:"#F0F0F0",selectBorder:"#3C3C3C",decoratorRightForeground:void 0,selectListBackground:void 0,selectListBorder:void 0,focusBorder:void 0};class b extends I.Widget{constructor(u,m,v,g,d){super(),N.isMacintosh&&!d?.useCustomDrawn?this.selectBoxDelegate=new O.SelectBoxNative(u,m,g,d):this.selectBoxDelegate=new n.SelectBoxList(u,m,v,g,d),this._register(this.selectBoxDelegate)}get onDidSelect(){return this.selectBoxDelegate.onDidSelect}setOptions(u,m){this.selectBoxDelegate.setOptions(u,m)}select(u){this.selectBoxDelegate.select(u)}setAriaLabel(u){this.selectBoxDelegate.setAriaLabel(u)}focus(){this.selectBoxDelegate.focus()}blur(){this.selectBoxDelegate.blur()}setFocusable(u){this.selectBoxDelegate.setFocusable(u)}setEnabled(u){this.selectBoxDelegate.setEnabled(u)}render(u){this.selectBoxDelegate.render(u)}}t.SelectBox=b}),define(_e[80],Se([1,0,18,72,4,32,14,140,50,2,5,10,12,33,68]),function(ue,t,i,n,O,I,N,b,w,u,m,v,g,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SelectActionViewItem=t.ActionViewItem=t.BaseActionViewItem=void 0,m=qe(m),v=qe(v),g=qe(g);class e extends u.Disposable{get action(){return this._action}constructor(o,p,A={}){super(),this.options=A,this._context=o||this,this._action=p,p instanceof w.Action&&this._register(p.onDidChange(L=>{this.element&&this.handleActionChangeEvent(L)}))}handleActionChangeEvent(o){o.enabled!==void 0&&this.updateEnabled(),o.checked!==void 0&&this.updateChecked(),o.class!==void 0&&this.updateClass(),o.label!==void 0&&(this.updateLabel(),this.updateTooltip()),o.tooltip!==void 0&&this.updateTooltip()}get actionRunner(){return this._actionRunner||(this._actionRunner=this._register(new w.ActionRunner)),this._actionRunner}set actionRunner(o){this._actionRunner=o}isEnabled(){return this._action.enabled}setActionContext(o){this._context=o}render(o){const p=this.element=o;this._register(I.Gesture.addTarget(o));const A=this.options&&this.options.draggable;A&&(o.draggable=!0,i.isFirefox&&this._register((0,O.addDisposableListener)(o,O.EventType.DRAG_START,L=>L.dataTransfer?.setData(n.DataTransfers.TEXT,this._action.label)))),this._register((0,O.addDisposableListener)(p,I.EventType.Tap,L=>this.onClick(L,!0))),this._register((0,O.addDisposableListener)(p,O.EventType.MOUSE_DOWN,L=>{A||O.EventHelper.stop(L,!0),this._action.enabled&&L.button===0&&p.classList.add("active")})),m.isMacintosh&&this._register((0,O.addDisposableListener)(p,O.EventType.CONTEXT_MENU,L=>{L.button===0&&L.ctrlKey===!0&&this.onClick(L)})),this._register((0,O.addDisposableListener)(p,O.EventType.CLICK,L=>{O.EventHelper.stop(L,!0),this.options&&this.options.isMenu||this.onClick(L)})),this._register((0,O.addDisposableListener)(p,O.EventType.DBLCLICK,L=>{O.EventHelper.stop(L,!0)})),[O.EventType.MOUSE_UP,O.EventType.MOUSE_OUT].forEach(L=>{this._register((0,O.addDisposableListener)(p,L,c=>{O.EventHelper.stop(c),p.classList.remove("active")}))})}onClick(o,p=!1){O.EventHelper.stop(o,!0);const A=v.isUndefinedOrNull(this._context)?this.options?.useEventAsContext?o:{preserveFocus:p}:this._context;this.actionRunner.run(this._action,A)}focus(){this.element&&(this.element.tabIndex=0,this.element.focus(),this.element.classList.add("focused"))}isFocused(){return!!this.element?.classList.contains("focused")}blur(){this.element&&(this.element.blur(),this.element.tabIndex=-1,this.element.classList.remove("focused"))}setFocusable(o){this.element&&(this.element.tabIndex=o?0:-1)}get trapsArrowNavigation(){return!1}updateEnabled(){}updateLabel(){}getClass(){return this.action.class}getTooltip(){return this.action.tooltip}updateTooltip(){if(!this.element)return;const o=this.getTooltip()??"";if(this.updateAriaLabel(),this.options.hoverDelegate?.showNativeHover)this.element.title=o;else if(!this.customHover&&o!==""){const p=this.options.hoverDelegate??(0,N.getDefaultHoverDelegate)("element");this.customHover=this._store.add((0,d.getBaseLayerHoverDelegate)().setupManagedHover(p,this.element,o))}else this.customHover&&this.customHover.update(o)}updateAriaLabel(){if(this.element){const o=this.getTooltip()??"";this.element.setAttribute("aria-label",o)}}updateClass(){}updateChecked(){}dispose(){this.element&&(this.element.remove(),this.element=void 0),this._context=void 0,super.dispose()}}t.BaseActionViewItem=e;class s extends e{constructor(o,p,A){super(o,p,A),this.options=A,this.options.icon=A.icon!==void 0?A.icon:!1,this.options.label=A.label!==void 0?A.label:!0,this.cssClass=""}render(o){super.render(o),v.assertType(this.element);const p=document.createElement("a");if(p.classList.add("action-label"),p.setAttribute("role",this.getDefaultAriaRole()),this.label=p,this.element.appendChild(p),this.options.label&&this.options.keybinding){const A=document.createElement("span");A.classList.add("keybinding"),A.textContent=this.options.keybinding,this.element.appendChild(A)}this.updateClass(),this.updateLabel(),this.updateTooltip(),this.updateEnabled(),this.updateChecked()}getDefaultAriaRole(){return this._action.id===w.Separator.ID?"presentation":this.options.isMenu?"menuitem":this.options.isTabList?"tab":"button"}focus(){this.label&&(this.label.tabIndex=0,this.label.focus())}isFocused(){return!!this.label&&this.label?.tabIndex===0}blur(){this.label&&(this.label.tabIndex=-1)}setFocusable(o){this.label&&(this.label.tabIndex=o?0:-1)}updateLabel(){this.options.label&&this.label&&(this.label.textContent=this.action.label)}getTooltip(){let o=null;return this.action.tooltip?o=this.action.tooltip:!this.options.label&&this.action.label&&this.options.icon&&(o=this.action.label,this.options.keybinding&&(o=g.localize(0,null,o,this.options.keybinding))),o??void 0}updateClass(){this.cssClass&&this.label&&this.label.classList.remove(...this.cssClass.split(" ")),this.options.icon?(this.cssClass=this.getClass(),this.label&&(this.label.classList.add("codicon"),this.cssClass&&this.label.classList.add(...this.cssClass.split(" "))),this.updateEnabled()):this.label?.classList.remove("codicon")}updateEnabled(){this.action.enabled?(this.label&&(this.label.removeAttribute("aria-disabled"),this.label.classList.remove("disabled")),this.element?.classList.remove("disabled")):(this.label&&(this.label.setAttribute("aria-disabled","true"),this.label.classList.add("disabled")),this.element?.classList.add("disabled"))}updateAriaLabel(){if(this.label){const o=this.getTooltip()??"";this.label.setAttribute("aria-label",o)}}updateChecked(){this.label&&(this.action.checked!==void 0?(this.label.classList.toggle("checked",this.action.checked),this.options.isTabList?this.label.setAttribute("aria-selected",this.action.checked?"true":"false"):(this.label.setAttribute("aria-checked",this.action.checked?"true":"false"),this.label.setAttribute("role","checkbox"))):(this.label.classList.remove("checked"),this.label.removeAttribute(this.options.isTabList?"aria-selected":"aria-checked"),this.label.setAttribute("role",this.getDefaultAriaRole())))}}t.ActionViewItem=s;class r extends e{constructor(o,p,A,L,c,a,f){super(o,p),this.selectBox=new b.SelectBox(A,L,c,a,f),this.selectBox.setFocusable(!1),this._register(this.selectBox),this.registerListeners()}setOptions(o,p){this.selectBox.setOptions(o,p)}select(o){this.selectBox.select(o)}registerListeners(){this._register(this.selectBox.onDidSelect(o=>this.runAction(o.selected,o.index)))}runAction(o,p){this.actionRunner.run(this._action,this.getActionContext(o,p))}getActionContext(o,p){return o}setFocusable(o){this.selectBox.setFocusable(o)}focus(){this.selectBox?.focus()}blur(){this.selectBox?.blur()}render(o){this.selectBox.render(o)}}t.SelectActionViewItem=r}),define(_e[81],Se([1,0,4,15,80,14,50,3,8,2,10,68]),function(ue,t,i,n,O,I,N,b,w,u,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ActionBar=t.ActionsOrientation=void 0,t.prepareActions=d,i=qe(i),m=qe(m);var v;(function(e){e[e.HORIZONTAL=0]="HORIZONTAL",e[e.VERTICAL=1]="VERTICAL"})(v||(t.ActionsOrientation=v={}));class g extends u.Disposable{constructor(s,r={}){super(),this._actionRunnerDisposables=this._register(new u.DisposableStore),this.viewItemDisposables=this._register(new u.DisposableMap),this.triggerKeyDown=!1,this.focusable=!0,this._onDidBlur=this._register(new b.Emitter),this.onDidBlur=this._onDidBlur.event,this._onDidCancel=this._register(new b.Emitter({onWillAddFirstListener:()=>this.cancelHasListener=!0})),this.onDidCancel=this._onDidCancel.event,this.cancelHasListener=!1,this._onDidRun=this._register(new b.Emitter),this.onDidRun=this._onDidRun.event,this._onWillRun=this._register(new b.Emitter),this.onWillRun=this._onWillRun.event,this.options=r,this._context=r.context??null,this._orientation=this.options.orientation??v.HORIZONTAL,this._triggerKeys={keyDown:this.options.triggerKeys?.keyDown??!1,keys:this.options.triggerKeys?.keys??[w.KeyCode.Enter,w.KeyCode.Space]},this._hoverDelegate=r.hoverDelegate??this._register((0,I.createInstantHoverDelegate)()),this.options.actionRunner?this._actionRunner=this.options.actionRunner:(this._actionRunner=new N.ActionRunner,this._actionRunnerDisposables.add(this._actionRunner)),this._actionRunnerDisposables.add(this._actionRunner.onDidRun(p=>this._onDidRun.fire(p))),this._actionRunnerDisposables.add(this._actionRunner.onWillRun(p=>this._onWillRun.fire(p))),this.viewItems=[],this.focusedItem=void 0,this.domNode=document.createElement("div"),this.domNode.className="monaco-action-bar";let l,o;switch(this._orientation){case v.HORIZONTAL:l=[w.KeyCode.LeftArrow],o=[w.KeyCode.RightArrow];break;case v.VERTICAL:l=[w.KeyCode.UpArrow],o=[w.KeyCode.DownArrow],this.domNode.className+=" vertical";break}this._register(i.addDisposableListener(this.domNode,i.EventType.KEY_DOWN,p=>{const A=new n.StandardKeyboardEvent(p);let L=!0;const c=typeof this.focusedItem=="number"?this.viewItems[this.focusedItem]:void 0;l&&(A.equals(l[0])||A.equals(l[1]))?L=this.focusPrevious():o&&(A.equals(o[0])||A.equals(o[1]))?L=this.focusNext():A.equals(w.KeyCode.Escape)&&this.cancelHasListener?this._onDidCancel.fire():A.equals(w.KeyCode.Home)?L=this.focusFirst():A.equals(w.KeyCode.End)?L=this.focusLast():A.equals(w.KeyCode.Tab)&&c instanceof O.BaseActionViewItem&&c.trapsArrowNavigation?L=this.focusNext(void 0,!0):this.isTriggerKeyEvent(A)?this._triggerKeys.keyDown?this.doTrigger(A):this.triggerKeyDown=!0:L=!1,L&&(A.preventDefault(),A.stopPropagation())})),this._register(i.addDisposableListener(this.domNode,i.EventType.KEY_UP,p=>{const A=new n.StandardKeyboardEvent(p);this.isTriggerKeyEvent(A)?(!this._triggerKeys.keyDown&&this.triggerKeyDown&&(this.triggerKeyDown=!1,this.doTrigger(A)),A.preventDefault(),A.stopPropagation()):(A.equals(w.KeyCode.Tab)||A.equals(w.KeyMod.Shift|w.KeyCode.Tab)||A.equals(w.KeyCode.UpArrow)||A.equals(w.KeyCode.DownArrow)||A.equals(w.KeyCode.LeftArrow)||A.equals(w.KeyCode.RightArrow))&&this.updateFocusedItem()})),this.focusTracker=this._register(i.trackFocus(this.domNode)),this._register(this.focusTracker.onDidBlur(()=>{(i.getActiveElement()===this.domNode||!i.isAncestor(i.getActiveElement(),this.domNode))&&(this._onDidBlur.fire(),this.previouslyFocusedItem=this.focusedItem,this.focusedItem=void 0,this.triggerKeyDown=!1)})),this._register(this.focusTracker.onDidFocus(()=>this.updateFocusedItem())),this.actionsList=document.createElement("ul"),this.actionsList.className="actions-container",this.options.highlightToggledItems&&this.actionsList.classList.add("highlight-toggled"),this.actionsList.setAttribute("role",this.options.ariaRole||"toolbar"),this.options.ariaLabel&&this.actionsList.setAttribute("aria-label",this.options.ariaLabel),this.domNode.appendChild(this.actionsList),s.appendChild(this.domNode)}refreshRole(){this.length()>=1?this.actionsList.setAttribute("role",this.options.ariaRole||"toolbar"):this.actionsList.setAttribute("role","presentation")}setAriaLabel(s){s?this.actionsList.setAttribute("aria-label",s):this.actionsList.removeAttribute("aria-label")}setFocusable(s){if(this.focusable=s,this.focusable){const r=this.viewItems.find(l=>l instanceof O.BaseActionViewItem&&l.isEnabled());r instanceof O.BaseActionViewItem&&r.setFocusable(!0)}else this.viewItems.forEach(r=>{r instanceof O.BaseActionViewItem&&r.setFocusable(!1)})}isTriggerKeyEvent(s){let r=!1;return this._triggerKeys.keys.forEach(l=>{r=r||s.equals(l)}),r}updateFocusedItem(){for(let s=0;s<this.actionsList.children.length;s++){const r=this.actionsList.children[s];if(i.isAncestor(i.getActiveElement(),r)){this.focusedItem=s,this.viewItems[this.focusedItem]?.showHover?.();break}}}get context(){return this._context}set context(s){this._context=s,this.viewItems.forEach(r=>r.setActionContext(s))}get actionRunner(){return this._actionRunner}set actionRunner(s){this._actionRunner=s,this._actionRunnerDisposables.clear(),this._actionRunnerDisposables.add(this._actionRunner.onDidRun(r=>this._onDidRun.fire(r))),this._actionRunnerDisposables.add(this._actionRunner.onWillRun(r=>this._onWillRun.fire(r))),this.viewItems.forEach(r=>r.actionRunner=s)}getContainer(){return this.domNode}hasAction(s){return this.viewItems.findIndex(r=>r.action.id===s.id)!==-1}getAction(s){if(typeof s=="number")return this.viewItems[s]?.action;if(i.isHTMLElement(s)){for(;s.parentElement!==this.actionsList;){if(!s.parentElement)return;s=s.parentElement}for(let r=0;r<this.actionsList.childNodes.length;r++)if(this.actionsList.childNodes[r]===s)return this.viewItems[r].action}}push(s,r={}){const l=Array.isArray(s)?s:[s];let o=m.isNumber(r.index)?r.index:null;l.forEach(p=>{const A=document.createElement("li");A.className="action-item",A.setAttribute("role","presentation");let L;const c={hoverDelegate:this._hoverDelegate,...r,isTabList:this.options.ariaRole==="tablist"};this.options.actionViewItemProvider&&(L=this.options.actionViewItemProvider(p,c)),L||(L=new O.ActionViewItem(this.context,p,c)),this.options.allowContextMenu||this.viewItemDisposables.set(L,i.addDisposableListener(A,i.EventType.CONTEXT_MENU,a=>{i.EventHelper.stop(a,!0)})),L.actionRunner=this._actionRunner,L.setActionContext(this.context),L.render(A),this.focusable&&L instanceof O.BaseActionViewItem&&this.viewItems.length===0&&L.setFocusable(!0),o===null||o<0||o>=this.actionsList.children.length?(this.actionsList.appendChild(A),this.viewItems.push(L)):(this.actionsList.insertBefore(A,this.actionsList.children[o]),this.viewItems.splice(o,0,L),o++)}),typeof this.focusedItem=="number"&&this.focus(this.focusedItem),this.refreshRole()}getWidth(s){if(s>=0&&s<this.actionsList.children.length){const r=this.actionsList.children.item(s);if(r)return r.clientWidth}return 0}getHeight(s){if(s>=0&&s<this.actionsList.children.length){const r=this.actionsList.children.item(s);if(r)return r.clientHeight}return 0}pull(s){s>=0&&s<this.viewItems.length&&(this.actionsList.childNodes[s].remove(),this.viewItemDisposables.deleteAndDispose(this.viewItems[s]),(0,u.dispose)(this.viewItems.splice(s,1)),this.refreshRole())}clear(){this.isEmpty()||(this.viewItems=(0,u.dispose)(this.viewItems),this.viewItemDisposables.clearAndDisposeAll(),i.clearNode(this.actionsList),this.refreshRole())}length(){return this.viewItems.length}isEmpty(){return this.viewItems.length===0}focus(s){let r=!1,l;if(s===void 0?r=!0:typeof s=="number"?l=s:typeof s=="boolean"&&(r=s),r&&typeof this.focusedItem>"u"){const o=this.viewItems.findIndex(p=>p.isEnabled());this.focusedItem=o===-1?void 0:o,this.updateFocus(void 0,void 0,!0)}else l!==void 0&&(this.focusedItem=l),this.updateFocus(void 0,void 0,!0)}focusFirst(){return this.focusedItem=this.length()-1,this.focusNext(!0)}focusLast(){return this.focusedItem=0,this.focusPrevious(!0)}focusNext(s,r){if(typeof this.focusedItem>"u")this.focusedItem=this.viewItems.length-1;else if(this.viewItems.length<=1)return!1;const l=this.focusedItem;let o;do{if(!s&&this.options.preventLoopNavigation&&this.focusedItem+1>=this.viewItems.length)return this.focusedItem=l,!1;this.focusedItem=(this.focusedItem+1)%this.viewItems.length,o=this.viewItems[this.focusedItem]}while(this.focusedItem!==l&&(this.options.focusOnlyEnabledItems&&!o.isEnabled()||o.action.id===N.Separator.ID));return this.updateFocus(void 0,void 0,r),!0}focusPrevious(s){if(typeof this.focusedItem>"u")this.focusedItem=0;else if(this.viewItems.length<=1)return!1;const r=this.focusedItem;let l;do{if(this.focusedItem=this.focusedItem-1,this.focusedItem<0){if(!s&&this.options.preventLoopNavigation)return this.focusedItem=r,!1;this.focusedItem=this.viewItems.length-1}l=this.viewItems[this.focusedItem]}while(this.focusedItem!==r&&(this.options.focusOnlyEnabledItems&&!l.isEnabled()||l.action.id===N.Separator.ID));return this.updateFocus(!0),!0}updateFocus(s,r,l=!1){typeof this.focusedItem>"u"&&this.actionsList.focus({preventScroll:r}),this.previouslyFocusedItem!==void 0&&this.previouslyFocusedItem!==this.focusedItem&&this.viewItems[this.previouslyFocusedItem]?.blur();const o=this.focusedItem!==void 0?this.viewItems[this.focusedItem]:void 0;if(o){let p=!0;m.isFunction(o.focus)||(p=!1),this.options.focusOnlyEnabledItems&&m.isFunction(o.isEnabled)&&!o.isEnabled()&&(p=!1),o.action.id===N.Separator.ID&&(p=!1),p?(l||this.previouslyFocusedItem!==this.focusedItem)&&(o.focus(s),this.previouslyFocusedItem=this.focusedItem):(this.actionsList.focus({preventScroll:r}),this.previouslyFocusedItem=void 0),p&&o.showHover?.()}}doTrigger(s){if(typeof this.focusedItem>"u")return;const r=this.viewItems[this.focusedItem];if(r instanceof O.BaseActionViewItem){const l=r._context===null||r._context===void 0?s:r._context;this.run(r._action,l)}}async run(s,r){await this._actionRunner.run(s,r)}dispose(){this._context=void 0,this.viewItems=(0,u.dispose)(this.viewItems),this.getContainer().remove(),super.dispose()}}t.ActionBar=g;function d(e){if(!e.length)return e;let s=-1;for(let l=0;l<e.length;l++)if(e[l].id!==N.Separator.ID){s=l;break}if(s===-1)return[];e=e.slice(s);for(let l=e.length-1;l>=0&&e[l].id===N.Separator.ID;l--)e.splice(l,1);let r=!1;for(let l=e.length-1;l>=0;l--){const o=e[l].id===N.Separator.ID;o&&!r?e.splice(l,1):o?o&&(r=!1):r=!0}return e}}),define(_e[82],Se([1,0,4,28,73,81,52,75,33,14,78,23,3,96,64,19,12,117]),function(ue,t,i,n,O,I,N,b,w,u,m,v,g,d,e,s,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.HistoryInputBox=t.InputBox=t.unthemedInboxStyles=t.MessageType=void 0,i=qe(i),N=qe(N),r=qe(r);const l=i.$;var o;(function(L){L[L.INFO=1]="INFO",L[L.WARNING=2]="WARNING",L[L.ERROR=3]="ERROR"})(o||(t.MessageType=o={})),t.unthemedInboxStyles={inputBackground:"#3C3C3C",inputForeground:"#CCCCCC",inputValidationInfoBorder:"#55AAFF",inputValidationInfoBackground:"#063B49",inputValidationWarningBorder:"#B89500",inputValidationWarningBackground:"#352A05",inputValidationErrorBorder:"#BE1100",inputValidationErrorBackground:"#5A1D1D",inputBorder:void 0,inputValidationErrorForeground:void 0,inputValidationInfoForeground:void 0,inputValidationWarningForeground:void 0};class p extends v.Widget{constructor(c,a,f){super(),this.state="idle",this.maxHeight=Number.POSITIVE_INFINITY,this._onDidChange=this._register(new g.Emitter),this.onDidChange=this._onDidChange.event,this._onDidHeightChange=this._register(new g.Emitter),this.onDidHeightChange=this._onDidHeightChange.event,this.contextViewProvider=a,this.options=f,this.message=null,this.placeholder=this.options.placeholder||"",this.tooltip=this.options.tooltip??(this.placeholder||""),this.ariaLabel=this.options.ariaLabel||"",this.options.validationOptions&&(this.validation=this.options.validationOptions.validation),this.element=i.append(c,l(".monaco-inputbox.idle"));const _=this.options.flexibleHeight?"textarea":"input",H=i.append(this.element,l(".ibwrapper"));if(this.input=i.append(H,l(_+".input.empty")),this.input.setAttribute("autocorrect","off"),this.input.setAttribute("autocapitalize","off"),this.input.setAttribute("spellcheck","false"),this.onfocus(this.input,()=>this.element.classList.add("synthetic-focus")),this.onblur(this.input,()=>this.element.classList.remove("synthetic-focus")),this.options.flexibleHeight){this.maxHeight=typeof this.options.flexibleMaxHeight=="number"?this.options.flexibleMaxHeight:Number.POSITIVE_INFINITY,this.mirror=i.append(H,l("div.mirror")),this.mirror.innerText="\xA0",this.scrollableElement=new m.ScrollableElement(this.element,{vertical:s.ScrollbarVisibility.Auto}),this.options.flexibleWidth&&(this.input.setAttribute("wrap","off"),this.mirror.style.whiteSpace="pre",this.mirror.style.wordWrap="initial"),i.append(c,this.scrollableElement.getDomNode()),this._register(this.scrollableElement),this._register(this.scrollableElement.onScroll(E=>this.input.scrollTop=E.scrollTop));const B=this._register(new n.DomEmitter(c.ownerDocument,"selectionchange")),F=g.Event.filter(B.event,()=>c.ownerDocument.getSelection()?.anchorNode===H);this._register(F(this.updateScrollDimensions,this)),this._register(this.onDidHeightChange(this.updateScrollDimensions,this))}else this.input.type=this.options.type||"text",this.input.setAttribute("wrap","off");this.ariaLabel&&this.input.setAttribute("aria-label",this.ariaLabel),this.placeholder&&!this.options.showPlaceholderOnFocus&&this.setPlaceHolder(this.placeholder),this.tooltip&&this.setTooltip(this.tooltip),this.oninput(this.input,()=>this.onValueChange()),this.onblur(this.input,()=>this.onBlur()),this.onfocus(this.input,()=>this.onFocus()),this._register(this.ignoreGesture(this.input)),setTimeout(()=>this.updateMirror(),0),this.options.actions&&(this.actionbar=this._register(new I.ActionBar(this.element)),this.actionbar.push(this.options.actions,{icon:!0,label:!1})),this.applyStyles()}onBlur(){this._hideMessage(),this.options.showPlaceholderOnFocus&&this.input.setAttribute("placeholder","")}onFocus(){this._showMessage(),this.options.showPlaceholderOnFocus&&this.input.setAttribute("placeholder",this.placeholder||"")}setPlaceHolder(c){this.placeholder=c,this.input.setAttribute("placeholder",c)}setTooltip(c){this.tooltip=c,this.hover?this.hover.update(c):this.hover=this._register((0,w.getBaseLayerHoverDelegate)().setupManagedHover((0,u.getDefaultHoverDelegate)("mouse"),this.input,c))}setAriaLabel(c){this.ariaLabel=c,c?this.input.setAttribute("aria-label",this.ariaLabel):this.input.removeAttribute("aria-label")}getAriaLabel(){return this.ariaLabel}get mirrorElement(){return this.mirror}get inputElement(){return this.input}get value(){return this.input.value}set value(c){this.input.value!==c&&(this.input.value=c,this.onValueChange())}get step(){return this.input.step}set step(c){this.input.step=c}get height(){return typeof this.cachedHeight=="number"?this.cachedHeight:i.getTotalHeight(this.element)}focus(){this.input.focus()}blur(){this.input.blur()}hasFocus(){return i.isActiveElement(this.input)}select(c=null){this.input.select(),c&&(this.input.setSelectionRange(c.start,c.end),c.end===this.input.value.length&&(this.input.scrollLeft=this.input.scrollWidth))}isSelectionAtEnd(){return this.input.selectionEnd===this.input.value.length&&this.input.selectionStart===this.input.selectionEnd}getSelection(){const c=this.input.selectionStart;if(c===null)return null;const a=this.input.selectionEnd??c;return{start:c,end:a}}enable(){this.input.removeAttribute("disabled")}disable(){this.blur(),this.input.disabled=!0,this._hideMessage()}setEnabled(c){c?this.enable():this.disable()}get width(){return i.getTotalWidth(this.input)}set width(c){if(this.options.flexibleHeight&&this.options.flexibleWidth){let a=0;if(this.mirror){const f=parseFloat(this.mirror.style.paddingLeft||"")||0,_=parseFloat(this.mirror.style.paddingRight||"")||0;a=f+_}this.input.style.width=c-a+"px"}else this.input.style.width=c+"px";this.mirror&&(this.mirror.style.width=c+"px")}set paddingRight(c){this.input.style.width=`calc(100% - ${c}px)`,this.mirror&&(this.mirror.style.paddingRight=c+"px")}updateScrollDimensions(){if(typeof this.cachedContentHeight!="number"||typeof this.cachedHeight!="number"||!this.scrollableElement)return;const c=this.cachedContentHeight,a=this.cachedHeight,f=this.input.scrollTop;this.scrollableElement.setScrollDimensions({scrollHeight:c,height:a}),this.scrollableElement.setScrollPosition({scrollTop:f})}showMessage(c,a){if(this.state==="open"&&(0,e.equals)(this.message,c))return;this.message=c,this.element.classList.remove("idle"),this.element.classList.remove("info"),this.element.classList.remove("warning"),this.element.classList.remove("error"),this.element.classList.add(this.classForType(c.type));const f=this.stylesForType(this.message.type);this.element.style.border=`1px solid ${i.asCssValueWithDefault(f.border,"transparent")}`,this.message.content&&(this.hasFocus()||a)&&this._showMessage()}hideMessage(){this.message=null,this.element.classList.remove("info"),this.element.classList.remove("warning"),this.element.classList.remove("error"),this.element.classList.add("idle"),this._hideMessage(),this.applyStyles()}isInputValid(){return!!this.validation&&!this.validation(this.value)}validate(){let c=null;return this.validation&&(c=this.validation(this.value),c?(this.inputElement.setAttribute("aria-invalid","true"),this.showMessage(c)):this.inputElement.hasAttribute("aria-invalid")&&(this.inputElement.removeAttribute("aria-invalid"),this.hideMessage())),c?.type}stylesForType(c){const a=this.options.inputBoxStyles;switch(c){case o.INFO:return{border:a.inputValidationInfoBorder,background:a.inputValidationInfoBackground,foreground:a.inputValidationInfoForeground};case o.WARNING:return{border:a.inputValidationWarningBorder,background:a.inputValidationWarningBackground,foreground:a.inputValidationWarningForeground};default:return{border:a.inputValidationErrorBorder,background:a.inputValidationErrorBackground,foreground:a.inputValidationErrorForeground}}}classForType(c){switch(c){case o.INFO:return"info";case o.WARNING:return"warning";default:return"error"}}_showMessage(){if(!this.contextViewProvider||!this.message)return;let c;const a=()=>c.style.width=i.getTotalWidth(this.element)+"px";this.contextViewProvider.showContextView({getAnchor:()=>this.element,anchorAlignment:b.AnchorAlignment.RIGHT,render:_=>{if(!this.message)return null;c=i.append(_,l(".monaco-inputbox-container")),a();const H={inline:!0,className:"monaco-inputbox-message"},B=this.message.formatContent?(0,O.renderFormattedText)(this.message.content,H):(0,O.renderText)(this.message.content,H);B.classList.add(this.classForType(this.message.type));const F=this.stylesForType(this.message.type);return B.style.backgroundColor=F.background??"",B.style.color=F.foreground??"",B.style.border=F.border?`1px solid ${F.border}`:"",i.append(c,B),null},onHide:()=>{this.state="closed"},layout:a});let f;this.message.type===o.ERROR?f=r.localize(19,null,this.message.content):this.message.type===o.WARNING?f=r.localize(20,null,this.message.content):f=r.localize(21,null,this.message.content),N.alert(f),this.state="open"}_hideMessage(){this.contextViewProvider&&(this.state==="open"&&this.contextViewProvider.hideContextView(),this.state="idle")}onValueChange(){this._onDidChange.fire(this.value),this.validate(),this.updateMirror(),this.input.classList.toggle("empty",!this.value),this.state==="open"&&this.contextViewProvider&&this.contextViewProvider.layout()}updateMirror(){if(!this.mirror)return;const c=this.value,f=c.charCodeAt(c.length-1)===10?" ":"";(c+f).replace(/\u000c/g,"")?this.mirror.textContent=c+f:this.mirror.innerText="\xA0",this.layout()}applyStyles(){const c=this.options.inputBoxStyles,a=c.inputBackground??"",f=c.inputForeground??"",_=c.inputBorder??"";this.element.style.backgroundColor=a,this.element.style.color=f,this.input.style.backgroundColor="inherit",this.input.style.color=f,this.element.style.border=`1px solid ${i.asCssValueWithDefault(_,"transparent")}`}layout(){if(!this.mirror)return;const c=this.cachedContentHeight;this.cachedContentHeight=i.getTotalHeight(this.mirror),c!==this.cachedContentHeight&&(this.cachedHeight=Math.min(this.cachedContentHeight,this.maxHeight),this.input.style.height=this.cachedHeight+"px",this._onDidHeightChange.fire(this.cachedContentHeight))}insertAtCursor(c){const a=this.inputElement,f=a.selectionStart,_=a.selectionEnd,H=a.value;f!==null&&_!==null&&(this.value=H.substr(0,f)+c+H.substr(_),a.setSelectionRange(f+1,f+1),this.layout())}dispose(){this._hideMessage(),this.message=null,this.actionbar?.dispose(),super.dispose()}}t.InputBox=p;class A extends p{constructor(c,a,f){const _=r.localize(22,null,"\u21C5"),H=r.localize(23,null,"\u21C5");super(c,a,f),this._onDidFocus=this._register(new g.Emitter),this.onDidFocus=this._onDidFocus.event,this._onDidBlur=this._register(new g.Emitter),this.onDidBlur=this._onDidBlur.event,this.history=new d.HistoryNavigator(f.history,100);const B=()=>{if(f.showHistoryHint&&f.showHistoryHint()&&!this.placeholder.endsWith(_)&&!this.placeholder.endsWith(H)&&this.history.getHistory().length){const F=this.placeholder.endsWith(")")?_:H,E=this.placeholder+F;f.showPlaceholderOnFocus&&!i.isActiveElement(this.input)?this.placeholder=E:this.setPlaceHolder(E)}};this.observer=new MutationObserver((F,E)=>{F.forEach(k=>{k.target.textContent||B()})}),this.observer.observe(this.input,{attributeFilter:["class"]}),this.onfocus(this.input,()=>B()),this.onblur(this.input,()=>{const F=E=>{if(this.placeholder.endsWith(E)){const k=this.placeholder.slice(0,this.placeholder.length-E.length);return f.showPlaceholderOnFocus?this.placeholder=k:this.setPlaceHolder(k),!0}else return!1};F(H)||F(_)})}dispose(){super.dispose(),this.observer&&(this.observer.disconnect(),this.observer=void 0)}addToHistory(c){this.value&&(c||this.value!==this.getCurrentValue())&&this.history.add(this.value)}prependHistory(c){const a=this.getHistory();this.clearHistory(),c.forEach(f=>{this.history.add(f)}),a.forEach(f=>{this.history.add(f)})}getHistory(){return this.history.getHistory()}isAtFirstInHistory(){return this.history.isFirst()}isAtLastInHistory(){return this.history.isLast()}isNowhereInHistory(){return this.history.isNowhere()}showNextValue(){this.history.has(this.value)||this.addToHistory();let c=this.getNextValue();c&&(c=c===this.value?this.getNextValue():c),this.value=c??"",N.status(this.value?this.value:r.localize(24,null))}showPreviousValue(){this.history.has(this.value)||this.addToHistory();let c=this.getPreviousValue();c&&(c=c===this.value?this.getPreviousValue():c),c&&(this.value=c,N.status(this.value))}clearHistory(){this.history.clear()}setPlaceHolder(c){super.setPlaceHolder(c),this.setTooltip(c)}onBlur(){super.onBlur(),this._onDidBlur.fire()}onFocus(){super.onFocus(),this._onDidFocus.fire()}getCurrentValue(){let c=this.history.current();return c||(c=this.history.last(),this.history.next()),c}getPreviousValue(){return this.history.previous()||this.history.first()}getNextValue(){return this.history.next()}}t.HistoryInputBox=A}),define(_e[83],Se([1,0,80,23,20,21,3,8,4,14,33,122]),function(ue,t,i,n,O,I,N,b,w,u,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CheckboxActionViewItem=t.Checkbox=t.Toggle=t.ToggleActionViewItem=t.unthemedToggleStyles=void 0,t.unthemedToggleStyles={inputActiveOptionBorder:"#007ACC00",inputActiveOptionForeground:"#FFFFFF",inputActiveOptionBackground:"#0E639C50"};class v extends i.BaseActionViewItem{constructor(r,l,o){super(r,l,o),this.toggle=this._register(new g({actionClassName:this._action.class,isChecked:!!this._action.checked,title:this.options.keybinding?`${this._action.label} (${this.options.keybinding})`:this._action.label,notFocusable:!0,inputActiveOptionBackground:o.toggleStyles?.inputActiveOptionBackground,inputActiveOptionBorder:o.toggleStyles?.inputActiveOptionBorder,inputActiveOptionForeground:o.toggleStyles?.inputActiveOptionForeground,hoverDelegate:o.hoverDelegate})),this._register(this.toggle.onChange(()=>this._action.checked=!!this.toggle&&this.toggle.checked))}render(r){this.element=r,this.element.appendChild(this.toggle.domNode)}updateEnabled(){this.toggle&&(this.isEnabled()?this.toggle.enable():this.toggle.disable())}updateChecked(){this.toggle.checked=!!this._action.checked}focus(){this.toggle.domNode.tabIndex=0,this.toggle.focus()}blur(){this.toggle.domNode.tabIndex=-1,this.toggle.domNode.blur()}setFocusable(r){this.toggle.domNode.tabIndex=r?0:-1}}t.ToggleActionViewItem=v;class g extends n.Widget{constructor(r){super(),this._onChange=this._register(new N.Emitter),this.onChange=this._onChange.event,this._onKeyDown=this._register(new N.Emitter),this.onKeyDown=this._onKeyDown.event,this._opts=r,this._checked=this._opts.isChecked;const l=["monaco-custom-toggle"];this._opts.icon&&(this._icon=this._opts.icon,l.push(...I.ThemeIcon.asClassNameArray(this._icon))),this._opts.actionClassName&&l.push(...this._opts.actionClassName.split(" ")),this._checked&&l.push("checked"),this.domNode=document.createElement("div"),this._hover=this._register((0,m.getBaseLayerHoverDelegate)().setupManagedHover(r.hoverDelegate??(0,u.getDefaultHoverDelegate)("mouse"),this.domNode,this._opts.title)),this.domNode.classList.add(...l),this._opts.notFocusable||(this.domNode.tabIndex=0),this.domNode.setAttribute("role","checkbox"),this.domNode.setAttribute("aria-checked",String(this._checked)),this.domNode.setAttribute("aria-label",this._opts.title),this.applyStyles(),this.onclick(this.domNode,o=>{this.enabled&&(this.checked=!this._checked,this._onChange.fire(!1),o.preventDefault())}),this._register(this.ignoreGesture(this.domNode)),this.onkeydown(this.domNode,o=>{if(o.keyCode===b.KeyCode.Space||o.keyCode===b.KeyCode.Enter){this.checked=!this._checked,this._onChange.fire(!0),o.preventDefault(),o.stopPropagation();return}this._onKeyDown.fire(o)})}get enabled(){return this.domNode.getAttribute("aria-disabled")!=="true"}focus(){this.domNode.focus()}get checked(){return this._checked}set checked(r){this._checked=r,this.domNode.setAttribute("aria-checked",String(this._checked)),this.domNode.classList.toggle("checked",this._checked),this.applyStyles()}setIcon(r){this._icon&&this.domNode.classList.remove(...I.ThemeIcon.asClassNameArray(this._icon)),this._icon=r,this._icon&&this.domNode.classList.add(...I.ThemeIcon.asClassNameArray(this._icon))}width(){return 22}applyStyles(){this.domNode&&(this.domNode.style.borderColor=this._checked&&this._opts.inputActiveOptionBorder||"",this.domNode.style.color=this._checked&&this._opts.inputActiveOptionForeground||"inherit",this.domNode.style.backgroundColor=this._checked&&this._opts.inputActiveOptionBackground||"")}enable(){this.domNode.setAttribute("aria-disabled",String(!1))}disable(){this.domNode.setAttribute("aria-disabled",String(!0))}setTitle(r){this._hover.update(r),this.domNode.setAttribute("aria-label",r)}set visible(r){this.domNode.style.display=r?"":"none"}get visible(){return this.domNode.style.display!=="none"}}t.Toggle=g;class d extends n.Widget{static{this.CLASS_NAME="monaco-checkbox"}constructor(r,l,o){super(),this.title=r,this.isChecked=l,this._onChange=this._register(new N.Emitter),this.onChange=this._onChange.event,this.checkbox=this._register(new g({title:this.title,isChecked:this.isChecked,icon:O.Codicon.check,actionClassName:d.CLASS_NAME,...t.unthemedToggleStyles})),this.domNode=this.checkbox.domNode,this.styles=o,this.applyStyles(),this._register(this.checkbox.onChange(p=>{this.applyStyles(),this._onChange.fire(p)}))}get checked(){return this.checkbox.checked}set checked(r){this.checkbox.checked=r,this.applyStyles()}focus(){this.domNode.focus()}hasFocus(){return(0,w.isActiveElement)(this.domNode)}enable(){this.checkbox.enable()}disable(){this.checkbox.disable()}applyStyles(){this.domNode.style.color=this.styles.checkboxForeground||"",this.domNode.style.backgroundColor=this.styles.checkboxBackground||"",this.domNode.style.borderColor=this.styles.checkboxBorder||""}}t.Checkbox=d;class e extends i.BaseActionViewItem{constructor(r,l,o){super(r,l,o),this.toggle=this._register(new d(this._action.label,!!this._action.checked,o.checkboxStyles)),this._register(this.toggle.onChange(()=>this.onChange()))}render(r){if(this.element=r,this.element.classList.add("checkbox-action-item"),this.element.appendChild(this.toggle.domNode),this.options.label&&this._action.label){const l=this.element.appendChild((0,w.$)("span.checkbox-label",void 0,this._action.label));this._register((0,w.addDisposableListener)(l,w.EventType.CLICK,o=>{this.toggle.checked=!this.toggle.checked,o.stopPropagation(),o.preventDefault(),this.onChange()}))}this.updateEnabled(),this.updateClass(),this.updateChecked()}onChange(){this._action.checked=!!this.toggle&&this.toggle.checked,this.actionRunner.run(this._action,this._context)}updateEnabled(){this.isEnabled()?this.toggle.enable():this.toggle.disable(),this.action.enabled?this.element?.classList.remove("disabled"):this.element?.classList.add("disabled")}updateChecked(){this.toggle.checked=!!this._action.checked}updateClass(){this.cssClass&&this.toggle.domNode.classList.remove(...this.cssClass.split(" ")),this.cssClass=this.getClass(),this.cssClass&&this.toggle.domNode.classList.add(...this.cssClass.split(" "))}focus(){this.toggle.domNode.tabIndex=0,this.toggle.focus()}blur(){this.toggle.domNode.tabIndex=-1,this.toggle.domNode.blur()}setFocusable(r){this.toggle.domNode.tabIndex=r?0:-1}}t.CheckboxActionViewItem=e}),define(_e[141],Se([1,0,14,83,20,12]),function(ue,t,i,n,O,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.RegexToggle=t.WholeWordsToggle=t.CaseSensitiveToggle=void 0,I=qe(I);const N=I.localize(10,null),b=I.localize(11,null),w=I.localize(12,null);class u extends n.Toggle{constructor(d){super({icon:O.Codicon.caseSensitive,title:N+d.appendTitle,isChecked:d.isChecked,hoverDelegate:d.hoverDelegate??(0,i.getDefaultHoverDelegate)("element"),inputActiveOptionBorder:d.inputActiveOptionBorder,inputActiveOptionForeground:d.inputActiveOptionForeground,inputActiveOptionBackground:d.inputActiveOptionBackground})}}t.CaseSensitiveToggle=u;class m extends n.Toggle{constructor(d){super({icon:O.Codicon.wholeWord,title:b+d.appendTitle,isChecked:d.isChecked,hoverDelegate:d.hoverDelegate??(0,i.getDefaultHoverDelegate)("element"),inputActiveOptionBorder:d.inputActiveOptionBorder,inputActiveOptionForeground:d.inputActiveOptionForeground,inputActiveOptionBackground:d.inputActiveOptionBackground})}}t.WholeWordsToggle=m;class v extends n.Toggle{constructor(d){super({icon:O.Codicon.regex,title:w+d.appendTitle,isChecked:d.isChecked,hoverDelegate:d.hoverDelegate??(0,i.getDefaultHoverDelegate)("element"),inputActiveOptionBorder:d.inputActiveOptionBorder,inputActiveOptionForeground:d.inputActiveOptionForeground,inputActiveOptionBackground:d.inputActiveOptionBackground})}}t.RegexToggle=v}),define(_e[142],Se([1,0,4,141,82,23,3,8,12,2,14,116]),function(ue,t,i,n,O,I,N,b,w,u,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FindInput=void 0,i=qe(i),w=qe(w);const v=w.localize(9,null);class g extends I.Widget{static{this.OPTION_CHANGE="optionChange"}constructor(e,s,r){super(),this.fixFocusOnOptionClickEnabled=!0,this.imeSessionInProgress=!1,this.additionalTogglesDisposables=this._register(new u.MutableDisposable),this.additionalToggles=[],this._onDidOptionChange=this._register(new N.Emitter),this.onDidOptionChange=this._onDidOptionChange.event,this._onKeyDown=this._register(new N.Emitter),this.onKeyDown=this._onKeyDown.event,this._onMouseDown=this._register(new N.Emitter),this.onMouseDown=this._onMouseDown.event,this._onInput=this._register(new N.Emitter),this.onInput=this._onInput.event,this._onKeyUp=this._register(new N.Emitter),this.onKeyUp=this._onKeyUp.event,this._onCaseSensitiveKeyDown=this._register(new N.Emitter),this.onCaseSensitiveKeyDown=this._onCaseSensitiveKeyDown.event,this._onRegexKeyDown=this._register(new N.Emitter),this.onRegexKeyDown=this._onRegexKeyDown.event,this._lastHighlightFindOptions=0,this.placeholder=r.placeholder||"",this.validation=r.validation,this.label=r.label||v,this.showCommonFindToggles=!!r.showCommonFindToggles;const l=r.appendCaseSensitiveLabel||"",o=r.appendWholeWordsLabel||"",p=r.appendRegexLabel||"",A=r.history||[],L=!!r.flexibleHeight,c=!!r.flexibleWidth,a=r.flexibleMaxHeight;this.domNode=document.createElement("div"),this.domNode.classList.add("monaco-findInput"),this.inputBox=this._register(new O.HistoryInputBox(this.domNode,s,{placeholder:this.placeholder||"",ariaLabel:this.label||"",validationOptions:{validation:this.validation},history:A,showHistoryHint:r.showHistoryHint,flexibleHeight:L,flexibleWidth:c,flexibleMaxHeight:a,inputBoxStyles:r.inputBoxStyles}));const f=this._register((0,m.createInstantHoverDelegate)());if(this.showCommonFindToggles){this.regex=this._register(new n.RegexToggle({appendTitle:p,isChecked:!1,hoverDelegate:f,...r.toggleStyles})),this._register(this.regex.onChange(H=>{this._onDidOptionChange.fire(H),!H&&this.fixFocusOnOptionClickEnabled&&this.inputBox.focus(),this.validate()})),this._register(this.regex.onKeyDown(H=>{this._onRegexKeyDown.fire(H)})),this.wholeWords=this._register(new n.WholeWordsToggle({appendTitle:o,isChecked:!1,hoverDelegate:f,...r.toggleStyles})),this._register(this.wholeWords.onChange(H=>{this._onDidOptionChange.fire(H),!H&&this.fixFocusOnOptionClickEnabled&&this.inputBox.focus(),this.validate()})),this.caseSensitive=this._register(new n.CaseSensitiveToggle({appendTitle:l,isChecked:!1,hoverDelegate:f,...r.toggleStyles})),this._register(this.caseSensitive.onChange(H=>{this._onDidOptionChange.fire(H),!H&&this.fixFocusOnOptionClickEnabled&&this.inputBox.focus(),this.validate()})),this._register(this.caseSensitive.onKeyDown(H=>{this._onCaseSensitiveKeyDown.fire(H)}));const _=[this.caseSensitive.domNode,this.wholeWords.domNode,this.regex.domNode];this.onkeydown(this.domNode,H=>{if(H.equals(b.KeyCode.LeftArrow)||H.equals(b.KeyCode.RightArrow)||H.equals(b.KeyCode.Escape)){const B=_.indexOf(this.domNode.ownerDocument.activeElement);if(B>=0){let F=-1;H.equals(b.KeyCode.RightArrow)?F=(B+1)%_.length:H.equals(b.KeyCode.LeftArrow)&&(B===0?F=_.length-1:F=B-1),H.equals(b.KeyCode.Escape)?(_[B].blur(),this.inputBox.focus()):F>=0&&_[F].focus(),i.EventHelper.stop(H,!0)}}})}this.controls=document.createElement("div"),this.controls.className="controls",this.controls.style.display=this.showCommonFindToggles?"":"none",this.caseSensitive&&this.controls.append(this.caseSensitive.domNode),this.wholeWords&&this.controls.appendChild(this.wholeWords.domNode),this.regex&&this.controls.appendChild(this.regex.domNode),this.setAdditionalToggles(r?.additionalToggles),this.controls&&this.domNode.appendChild(this.controls),e?.appendChild(this.domNode),this._register(i.addDisposableListener(this.inputBox.inputElement,"compositionstart",_=>{this.imeSessionInProgress=!0})),this._register(i.addDisposableListener(this.inputBox.inputElement,"compositionend",_=>{this.imeSessionInProgress=!1,this._onInput.fire()})),this.onkeydown(this.inputBox.inputElement,_=>this._onKeyDown.fire(_)),this.onkeyup(this.inputBox.inputElement,_=>this._onKeyUp.fire(_)),this.oninput(this.inputBox.inputElement,_=>this._onInput.fire()),this.onmousedown(this.inputBox.inputElement,_=>this._onMouseDown.fire(_))}get isImeSessionInProgress(){return this.imeSessionInProgress}get onDidChange(){return this.inputBox.onDidChange}layout(e){this.inputBox.layout(),this.updateInputBoxPadding(e.collapsedFindWidget)}enable(){this.domNode.classList.remove("disabled"),this.inputBox.enable(),this.regex?.enable(),this.wholeWords?.enable(),this.caseSensitive?.enable();for(const e of this.additionalToggles)e.enable()}disable(){this.domNode.classList.add("disabled"),this.inputBox.disable(),this.regex?.disable(),this.wholeWords?.disable(),this.caseSensitive?.disable();for(const e of this.additionalToggles)e.disable()}setFocusInputOnOptionClick(e){this.fixFocusOnOptionClickEnabled=e}setEnabled(e){e?this.enable():this.disable()}setAdditionalToggles(e){for(const s of this.additionalToggles)s.domNode.remove();this.additionalToggles=[],this.additionalTogglesDisposables.value=new u.DisposableStore;for(const s of e??[])this.additionalTogglesDisposables.value.add(s),this.controls.appendChild(s.domNode),this.additionalTogglesDisposables.value.add(s.onChange(r=>{this._onDidOptionChange.fire(r),!r&&this.fixFocusOnOptionClickEnabled&&this.inputBox.focus()})),this.additionalToggles.push(s);this.additionalToggles.length>0&&(this.controls.style.display=""),this.updateInputBoxPadding()}updateInputBoxPadding(e=!1){e?this.inputBox.paddingRight=0:this.inputBox.paddingRight=(this.caseSensitive?.width()??0)+(this.wholeWords?.width()??0)+(this.regex?.width()??0)+this.additionalToggles.reduce((s,r)=>s+r.width(),0)}clear(){this.clearValidation(),this.setValue(""),this.focus()}getValue(){return this.inputBox.value}setValue(e){this.inputBox.value!==e&&(this.inputBox.value=e)}onSearchSubmit(){this.inputBox.addToHistory()}select(){this.inputBox.select()}focus(){this.inputBox.focus()}getCaseSensitive(){return this.caseSensitive?.checked??!1}setCaseSensitive(e){this.caseSensitive&&(this.caseSensitive.checked=e)}getWholeWords(){return this.wholeWords?.checked??!1}setWholeWords(e){this.wholeWords&&(this.wholeWords.checked=e)}getRegex(){return this.regex?.checked??!1}setRegex(e){this.regex&&(this.regex.checked=e,this.validate())}focusOnCaseSensitive(){this.caseSensitive?.focus()}focusOnRegex(){this.regex?.focus()}highlightFindOptions(){this.domNode.classList.remove("highlight-"+this._lastHighlightFindOptions),this._lastHighlightFindOptions=1-this._lastHighlightFindOptions,this.domNode.classList.add("highlight-"+this._lastHighlightFindOptions)}validate(){this.inputBox.validate()}showMessage(e){this.inputBox.showMessage(e)}clearMessage(){this.inputBox.hideMessage()}clearValidation(){this.inputBox.hideMessage()}}t.FindInput=g}),define(_e[143],Se([1,0,4,28,15,81,142,82,79,54,83,76,34,50,9,13,20,21,43,3,49,8,2,37,10,12,14,62,52,123]),function(ue,t,i,n,O,I,N,b,w,u,m,v,g,d,e,s,r,l,o,p,A,L,c,a,f,_,H,B,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AbstractTree=t.AbstractTreePart=t.TreeFindMatchType=t.TreeFindMode=t.FuzzyToggle=t.ModeToggle=t.TreeRenderer=t.RenderIndentGuides=t.AbstractTreeViewState=t.ComposedTreeDelegate=void 0;class E extends w.ElementsDragAndDropData{set context(y){this.data.context=y}get context(){return this.data.context}constructor(y){super(y.elements.map(D=>D.element)),this.data=y}}function k(te){return te instanceof w.ElementsDragAndDropData?new E(te):te}class W{constructor(y,D){this.modelProvider=y,this.dnd=D,this.autoExpandDisposable=c.Disposable.None,this.disposables=new c.DisposableStore}getDragURI(y){return this.dnd.getDragURI(y.element)}getDragLabel(y,D){if(this.dnd.getDragLabel)return this.dnd.getDragLabel(y.map(z=>z.element),D)}onDragStart(y,D){this.dnd.onDragStart?.(k(y),D)}onDragOver(y,D,z,V,q,se=!0){const ae=this.dnd.onDragOver(k(y),D&&D.element,z,V,q),ge=this.autoExpandNode!==D;if(ge&&(this.autoExpandDisposable.dispose(),this.autoExpandNode=D),typeof D>"u")return ae;if(ge&&typeof ae!="boolean"&&ae.autoExpand&&(this.autoExpandDisposable=(0,s.disposableTimeout)(()=>{const Ae=this.modelProvider(),ke=Ae.getNodeLocation(D);Ae.isCollapsed(ke)&&Ae.setCollapsed(ke,!1),this.autoExpandNode=void 0},500,this.disposables)),typeof ae=="boolean"||!ae.accept||typeof ae.bubble>"u"||ae.feedback){if(!se){const Ae=typeof ae=="boolean"?ae:ae.accept,ke=typeof ae=="boolean"?void 0:ae.effect;return{accept:Ae,effect:ke,feedback:[z]}}return ae}if(ae.bubble===g.TreeDragOverBubble.Up){const Ae=this.modelProvider(),ke=Ae.getNodeLocation(D),Ge=Ae.getParentNodeLocation(ke),it=Ae.getNode(Ge),rt=Ge&&Ae.getListIndex(Ge);return this.onDragOver(y,it,rt,V,q,!1)}const we=this.modelProvider(),De=we.getNodeLocation(D),Te=we.getListIndex(De),Oe=we.getListRenderCount(De);return{...ae,feedback:(0,e.range)(Te,Te+Oe)}}drop(y,D,z,V,q){this.autoExpandDisposable.dispose(),this.autoExpandNode=void 0,this.dnd.drop(k(y),D&&D.element,z,V,q)}onDragEnd(y){this.dnd.onDragEnd?.(y)}dispose(){this.disposables.dispose(),this.dnd.dispose()}}function R(te,y){return y&&{...y,identityProvider:y.identityProvider&&{getId(D){return y.identityProvider.getId(D.element)}},dnd:y.dnd&&new W(te,y.dnd),multipleSelectionController:y.multipleSelectionController&&{isSelectionSingleChangeEvent(D){return y.multipleSelectionController.isSelectionSingleChangeEvent({...D,element:D.element})},isSelectionRangeChangeEvent(D){return y.multipleSelectionController.isSelectionRangeChangeEvent({...D,element:D.element})}},accessibilityProvider:y.accessibilityProvider&&{...y.accessibilityProvider,getSetSize(D){const z=te(),V=z.getNodeLocation(D),q=z.getParentNodeLocation(V);return z.getNode(q).visibleChildrenCount},getPosInSet(D){return D.visibleChildIndex+1},isChecked:y.accessibilityProvider&&y.accessibilityProvider.isChecked?D=>y.accessibilityProvider.isChecked(D.element):void 0,getRole:y.accessibilityProvider&&y.accessibilityProvider.getRole?D=>y.accessibilityProvider.getRole(D.element):()=>"treeitem",getAriaLabel(D){return y.accessibilityProvider.getAriaLabel(D.element)},getWidgetAriaLabel(){return y.accessibilityProvider.getWidgetAriaLabel()},getWidgetRole:y.accessibilityProvider&&y.accessibilityProvider.getWidgetRole?()=>y.accessibilityProvider.getWidgetRole():()=>"tree",getAriaLevel:y.accessibilityProvider&&y.accessibilityProvider.getAriaLevel?D=>y.accessibilityProvider.getAriaLevel(D.element):D=>D.depth,getActiveDescendantId:y.accessibilityProvider.getActiveDescendantId&&(D=>y.accessibilityProvider.getActiveDescendantId(D.element))},keyboardNavigationLabelProvider:y.keyboardNavigationLabelProvider&&{...y.keyboardNavigationLabelProvider,getKeyboardNavigationLabel(D){return y.keyboardNavigationLabelProvider.getKeyboardNavigationLabel(D.element)}}}}class C{constructor(y){this.delegate=y}getHeight(y){return this.delegate.getHeight(y.element)}getTemplateId(y){return this.delegate.getTemplateId(y.element)}hasDynamicHeight(y){return!!this.delegate.hasDynamicHeight&&this.delegate.hasDynamicHeight(y.element)}setDynamicHeight(y,D){this.delegate.setDynamicHeight?.(y.element,D)}}t.ComposedTreeDelegate=C;class ${static lift(y){return y instanceof $?y:new $(y)}static empty(y=0){return new $({focus:[],selection:[],expanded:Object.create(null),scrollTop:y})}constructor(y){if(this.focus=new Set(y.focus),this.selection=new Set(y.selection),y.expanded instanceof Array){this.expanded=Object.create(null);for(const D of y.expanded)this.expanded[D]=1}else this.expanded=y.expanded;this.expanded=y.expanded,this.scrollTop=y.scrollTop}toJSON(){return{focus:Array.from(this.focus),selection:Array.from(this.selection),expanded:this.expanded,scrollTop:this.scrollTop}}}t.AbstractTreeViewState=$;var ee;(function(te){te.None="none",te.OnHover="onHover",te.Always="always"})(ee||(t.RenderIndentGuides=ee={}));class Y{get elements(){return this._elements}constructor(y,D=[]){this._elements=D,this.disposables=new c.DisposableStore,this.onDidChange=p.Event.forEach(y,z=>this._elements=z,this.disposables)}dispose(){this.disposables.dispose()}}class Z{static{this.DefaultIndent=8}constructor(y,D,z,V,q,se={}){this.renderer=y,this.modelProvider=D,this.activeNodes=V,this.renderedIndentGuides=q,this.renderedElements=new Map,this.renderedNodes=new Map,this.indent=Z.DefaultIndent,this.hideTwistiesOfChildlessElements=!1,this.shouldRenderIndentGuides=!1,this.activeIndentNodes=new Set,this.indentGuidesDisposable=c.Disposable.None,this.disposables=new c.DisposableStore,this.templateId=y.templateId,this.updateOptions(se),p.Event.map(z,ae=>ae.node)(this.onDidChangeNodeTwistieState,this,this.disposables),y.onDidChangeTwistieState?.(this.onDidChangeTwistieState,this,this.disposables)}updateOptions(y={}){if(typeof y.indent<"u"){const D=(0,a.clamp)(y.indent,0,40);if(D!==this.indent){this.indent=D;for(const[z,V]of this.renderedNodes)this.renderTreeElement(z,V)}}if(typeof y.renderIndentGuides<"u"){const D=y.renderIndentGuides!==ee.None;if(D!==this.shouldRenderIndentGuides){this.shouldRenderIndentGuides=D;for(const[z,V]of this.renderedNodes)this._renderIndentGuides(z,V);if(this.indentGuidesDisposable.dispose(),D){const z=new c.DisposableStore;this.activeNodes.onDidChange(this._onDidChangeActiveNodes,this,z),this.indentGuidesDisposable=z,this._onDidChangeActiveNodes(this.activeNodes.elements)}}}typeof y.hideTwistiesOfChildlessElements<"u"&&(this.hideTwistiesOfChildlessElements=y.hideTwistiesOfChildlessElements)}renderTemplate(y){const D=(0,i.append)(y,(0,i.$)(".monaco-tl-row")),z=(0,i.append)(D,(0,i.$)(".monaco-tl-indent")),V=(0,i.append)(D,(0,i.$)(".monaco-tl-twistie")),q=(0,i.append)(D,(0,i.$)(".monaco-tl-contents")),se=this.renderer.renderTemplate(q);return{container:y,indent:z,twistie:V,indentGuidesDisposable:c.Disposable.None,templateData:se}}renderElement(y,D,z,V){this.renderedNodes.set(y,z),this.renderedElements.set(y.element,y),this.renderTreeElement(y,z),this.renderer.renderElement(y,D,z.templateData,V)}disposeElement(y,D,z,V){z.indentGuidesDisposable.dispose(),this.renderer.disposeElement?.(y,D,z.templateData,V),typeof V=="number"&&(this.renderedNodes.delete(y),this.renderedElements.delete(y.element))}disposeTemplate(y){this.renderer.disposeTemplate(y.templateData)}onDidChangeTwistieState(y){const D=this.renderedElements.get(y);D&&this.onDidChangeNodeTwistieState(D)}onDidChangeNodeTwistieState(y){const D=this.renderedNodes.get(y);D&&(this._onDidChangeActiveNodes(this.activeNodes.elements),this.renderTreeElement(y,D))}renderTreeElement(y,D){const z=Z.DefaultIndent+(y.depth-1)*this.indent;D.twistie.style.paddingLeft=`${z}px`,D.indent.style.width=`${z+this.indent-16}px`,y.collapsible?D.container.setAttribute("aria-expanded",String(!y.collapsed)):D.container.removeAttribute("aria-expanded"),D.twistie.classList.remove(...l.ThemeIcon.asClassNameArray(r.Codicon.treeItemExpanded));let V=!1;this.renderer.renderTwistie&&(V=this.renderer.renderTwistie(y.element,D.twistie)),y.collapsible&&(!this.hideTwistiesOfChildlessElements||y.visibleChildrenCount>0)?(V||D.twistie.classList.add(...l.ThemeIcon.asClassNameArray(r.Codicon.treeItemExpanded)),D.twistie.classList.add("collapsible"),D.twistie.classList.toggle("collapsed",y.collapsed)):D.twistie.classList.remove("collapsible","collapsed"),this._renderIndentGuides(y,D)}_renderIndentGuides(y,D){if((0,i.clearNode)(D.indent),D.indentGuidesDisposable.dispose(),!this.shouldRenderIndentGuides)return;const z=new c.DisposableStore,V=this.modelProvider();for(;;){const q=V.getNodeLocation(y),se=V.getParentNodeLocation(q);if(!se)break;const ae=V.getNode(se),ge=(0,i.$)(".indent-guide",{style:`width: ${this.indent}px`});this.activeIndentNodes.has(ae)&&ge.classList.add("active"),D.indent.childElementCount===0?D.indent.appendChild(ge):D.indent.insertBefore(ge,D.indent.firstElementChild),this.renderedIndentGuides.add(ae,ge),z.add((0,c.toDisposable)(()=>this.renderedIndentGuides.delete(ae,ge))),y=ae}D.indentGuidesDisposable=z}_onDidChangeActiveNodes(y){if(!this.shouldRenderIndentGuides)return;const D=new Set,z=this.modelProvider();y.forEach(V=>{const q=z.getNodeLocation(V);try{const se=z.getParentNodeLocation(q);V.collapsible&&V.children.length>0&&!V.collapsed?D.add(V):se&&D.add(z.getNode(se))}catch{}}),this.activeIndentNodes.forEach(V=>{D.has(V)||this.renderedIndentGuides.forEach(V,q=>q.classList.remove("active"))}),D.forEach(V=>{this.activeIndentNodes.has(V)||this.renderedIndentGuides.forEach(V,q=>q.classList.add("active"))}),this.activeIndentNodes=D}dispose(){this.renderedNodes.clear(),this.renderedElements.clear(),this.indentGuidesDisposable.dispose(),(0,c.dispose)(this.disposables)}}t.TreeRenderer=Z;class ce{get totalCount(){return this._totalCount}get matchCount(){return this._matchCount}set pattern(y){this._pattern=y,this._lowercasePattern=y.toLowerCase()}constructor(y,D,z){this.tree=y,this.keyboardNavigationLabelProvider=D,this._filter=z,this._totalCount=0,this._matchCount=0,this._pattern="",this._lowercasePattern="",this.disposables=new c.DisposableStore,y.onWillRefilter(this.reset,this,this.disposables)}filter(y,D){let z=g.TreeVisibility.Visible;if(this._filter){const se=this._filter.filter(y,D);if(typeof se=="boolean"?z=se?g.TreeVisibility.Visible:g.TreeVisibility.Hidden:(0,v.isFilterResult)(se)?z=(0,v.getVisibleState)(se.visibility):z=se,z===g.TreeVisibility.Hidden)return!1}if(this._totalCount++,!this._pattern)return this._matchCount++,{data:A.FuzzyScore.Default,visibility:z};const V=this.keyboardNavigationLabelProvider.getKeyboardNavigationLabel(y),q=Array.isArray(V)?V:[V];for(const se of q){const ae=se&&se.toString();if(typeof ae>"u")return{data:A.FuzzyScore.Default,visibility:z};let ge;if(this.tree.findMatchType===re.Contiguous){const we=ae.toLowerCase().indexOf(this._lowercasePattern);if(we>-1){ge=[Number.MAX_SAFE_INTEGER,0];for(let De=this._lowercasePattern.length;De>0;De--)ge.push(we+De-1)}}else ge=(0,A.fuzzyScore)(this._pattern,this._lowercasePattern,0,ae,ae.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(ge)return this._matchCount++,q.length===1?{data:ge,visibility:z}:{data:{label:ae,score:ge},visibility:z}}return this.tree.findMode===Pe.Filter?typeof this.tree.options.defaultFindVisibility=="number"?this.tree.options.defaultFindVisibility:this.tree.options.defaultFindVisibility?this.tree.options.defaultFindVisibility(y):g.TreeVisibility.Recurse:{data:A.FuzzyScore.Default,visibility:z}}reset(){this._totalCount=0,this._matchCount=0}dispose(){(0,c.dispose)(this.disposables)}}class he extends m.Toggle{constructor(y){super({icon:r.Codicon.listFilter,title:(0,_.localize)(31,null),isChecked:y.isChecked??!1,hoverDelegate:y.hoverDelegate??(0,H.getDefaultHoverDelegate)("element"),inputActiveOptionBorder:y.inputActiveOptionBorder,inputActiveOptionForeground:y.inputActiveOptionForeground,inputActiveOptionBackground:y.inputActiveOptionBackground})}}t.ModeToggle=he;class ye extends m.Toggle{constructor(y){super({icon:r.Codicon.searchFuzzy,title:(0,_.localize)(32,null),isChecked:y.isChecked??!1,hoverDelegate:y.hoverDelegate??(0,H.getDefaultHoverDelegate)("element"),inputActiveOptionBorder:y.inputActiveOptionBorder,inputActiveOptionForeground:y.inputActiveOptionForeground,inputActiveOptionBackground:y.inputActiveOptionBackground})}}t.FuzzyToggle=ye;const Re={inputBoxStyles:b.unthemedInboxStyles,toggleStyles:m.unthemedToggleStyles,listFilterWidgetBackground:void 0,listFilterWidgetNoMatchesOutline:void 0,listFilterWidgetOutline:void 0,listFilterWidgetShadow:void 0};var Pe;(function(te){te[te.Highlight=0]="Highlight",te[te.Filter=1]="Filter"})(Pe||(t.TreeFindMode=Pe={}));var re;(function(te){te[te.Fuzzy=0]="Fuzzy",te[te.Contiguous=1]="Contiguous"})(re||(t.TreeFindMatchType=re={}));class ie extends c.Disposable{set mode(y){this.modeToggle.checked=y===Pe.Filter,this.findInput.inputBox.setPlaceHolder(y===Pe.Filter?(0,_.localize)(33,null):(0,_.localize)(34,null))}set matchType(y){this.matchTypeToggle.checked=y===re.Fuzzy}get value(){return this.findInput.inputBox.value}set value(y){this.findInput.inputBox.value=y}constructor(y,D,z,V,q,se){super(),this.tree=D,this.elements=(0,i.h)(".monaco-tree-type-filter",[(0,i.h)(".monaco-tree-type-filter-grab.codicon.codicon-debug-gripper@grab",{tabIndex:0}),(0,i.h)(".monaco-tree-type-filter-input@findInput"),(0,i.h)(".monaco-tree-type-filter-actionbar@actionbar")]),this.width=0,this.right=0,this.top=0,this._onDidDisable=new p.Emitter,this.onDidDisable=this._onDidDisable.event,y.appendChild(this.elements.root),this._register((0,c.toDisposable)(()=>this.elements.root.remove()));const ae=se?.styles??Re;ae.listFilterWidgetBackground&&(this.elements.root.style.backgroundColor=ae.listFilterWidgetBackground),ae.listFilterWidgetShadow&&(this.elements.root.style.boxShadow=`0 0 8px 2px ${ae.listFilterWidgetShadow}`);const ge=this._register((0,H.createInstantHoverDelegate)());this.modeToggle=this._register(new he({...ae.toggleStyles,isChecked:V===Pe.Filter,hoverDelegate:ge})),this.matchTypeToggle=this._register(new ye({...ae.toggleStyles,isChecked:q===re.Fuzzy,hoverDelegate:ge})),this.onDidChangeMode=p.Event.map(this.modeToggle.onChange,()=>this.modeToggle.checked?Pe.Filter:Pe.Highlight,this._store),this.onDidChangeMatchType=p.Event.map(this.matchTypeToggle.onChange,()=>this.matchTypeToggle.checked?re.Fuzzy:re.Contiguous,this._store),this.findInput=this._register(new N.FindInput(this.elements.findInput,z,{label:(0,_.localize)(35,null),additionalToggles:[this.modeToggle,this.matchTypeToggle],showCommonFindToggles:!1,inputBoxStyles:ae.inputBoxStyles,toggleStyles:ae.toggleStyles,history:se?.history})),this.actionbar=this._register(new I.ActionBar(this.elements.actionbar)),this.mode=V;const we=this._register(new n.DomEmitter(this.findInput.inputBox.inputElement,"keydown")),De=p.Event.chain(we.event,ke=>ke.map(Ge=>new O.StandardKeyboardEvent(Ge)));this._register(De(ke=>{if(ke.equals(L.KeyCode.Enter)){ke.preventDefault(),ke.stopPropagation(),this.findInput.inputBox.addToHistory(),this.tree.domFocus();return}if(ke.equals(L.KeyCode.DownArrow)){ke.preventDefault(),ke.stopPropagation(),this.findInput.inputBox.isAtLastInHistory()||this.findInput.inputBox.isNowhereInHistory()?(this.findInput.inputBox.addToHistory(),this.tree.domFocus()):this.findInput.inputBox.showNextValue();return}if(ke.equals(L.KeyCode.UpArrow)){ke.preventDefault(),ke.stopPropagation(),this.findInput.inputBox.showPreviousValue();return}}));const Te=this._register(new d.Action("close",(0,_.localize)(36,null),"codicon codicon-close",!0,()=>this.dispose()));this.actionbar.push(Te,{icon:!0,label:!1});const Oe=this._register(new n.DomEmitter(this.elements.grab,"mousedown"));this._register(Oe.event(ke=>{const Ge=new c.DisposableStore,it=Ge.add(new n.DomEmitter((0,i.getWindow)(ke),"mousemove")),rt=Ge.add(new n.DomEmitter((0,i.getWindow)(ke),"mouseup")),ft=this.right,ht=ke.pageX,He=this.top,j=ke.pageY;this.elements.grab.classList.add("grabbing");const T=this.elements.root.style.transition;this.elements.root.style.transition="unset";const M=K=>{const Q=K.pageX-ht;this.right=ft-Q;const de=K.pageY-j;this.top=He+de,this.layout()};Ge.add(it.event(M)),Ge.add(rt.event(K=>{M(K),this.elements.grab.classList.remove("grabbing"),this.elements.root.style.transition=T,Ge.dispose()}))}));const Ae=p.Event.chain(this._register(new n.DomEmitter(this.elements.grab,"keydown")).event,ke=>ke.map(Ge=>new O.StandardKeyboardEvent(Ge)));this._register(Ae(ke=>{let Ge,it;if(ke.keyCode===L.KeyCode.LeftArrow?Ge=Number.POSITIVE_INFINITY:ke.keyCode===L.KeyCode.RightArrow?Ge=0:ke.keyCode===L.KeyCode.Space&&(Ge=this.right===0?Number.POSITIVE_INFINITY:0),ke.keyCode===L.KeyCode.UpArrow?it=0:ke.keyCode===L.KeyCode.DownArrow&&(it=Number.POSITIVE_INFINITY),Ge!==void 0&&(ke.preventDefault(),ke.stopPropagation(),this.right=Ge,this.layout()),it!==void 0){ke.preventDefault(),ke.stopPropagation(),this.top=it;const rt=this.elements.root.style.transition;this.elements.root.style.transition="unset",this.layout(),setTimeout(()=>{this.elements.root.style.transition=rt},0)}})),this.onDidChangeValue=this.findInput.onDidChange}getHistory(){return this.findInput.inputBox.getHistory()}focus(){this.findInput.focus()}select(){this.findInput.select(),this.findInput.inputBox.addToHistory(!0)}layout(y=this.width){this.width=y,this.right=(0,a.clamp)(this.right,0,Math.max(0,y-212)),this.elements.root.style.right=`${this.right}px`,this.top=(0,a.clamp)(this.top,0,24),this.elements.root.style.top=`${this.top}px`}showMessage(y){this.findInput.showMessage(y)}clearMessage(){this.findInput.clearMessage()}async dispose(){this._onDidDisable.fire(),this.elements.root.classList.add("disabled"),await(0,s.timeout)(300),super.dispose()}}class fe{get pattern(){return this._pattern}get mode(){return this._mode}set mode(y){y!==this._mode&&(this._mode=y,this.widget&&(this.widget.mode=this._mode),this.tree.refilter(),this.render(),this._onDidChangeMode.fire(y))}get matchType(){return this._matchType}set matchType(y){y!==this._matchType&&(this._matchType=y,this.widget&&(this.widget.matchType=this._matchType),this.tree.refilter(),this.render(),this._onDidChangeMatchType.fire(y))}constructor(y,D,z,V,q,se={}){this.tree=y,this.view=z,this.filter=V,this.contextViewProvider=q,this.options=se,this._pattern="",this.previousPattern="",this.width=0,this._onDidChangeMode=new p.Emitter,this.onDidChangeMode=this._onDidChangeMode.event,this._onDidChangeMatchType=new p.Emitter,this.onDidChangeMatchType=this._onDidChangeMatchType.event,this._onDidChangePattern=new p.Emitter,this.onDidChangePattern=this._onDidChangePattern.event,this._onDidChangeOpenState=new p.Emitter,this.onDidChangeOpenState=this._onDidChangeOpenState.event,this.enabledDisposables=new c.DisposableStore,this.disposables=new c.DisposableStore,this._mode=y.options.defaultFindMode??Pe.Highlight,this._matchType=y.options.defaultFindMatchType??re.Fuzzy,D.onDidSplice(this.onDidSpliceModel,this,this.disposables)}updateOptions(y={}){y.defaultFindMode!==void 0&&(this.mode=y.defaultFindMode),y.defaultFindMatchType!==void 0&&(this.matchType=y.defaultFindMatchType)}open(){if(this.widget){this.widget.focus(),this.widget.select();return}this.widget=new ie(this.view.getHTMLElement(),this.tree,this.contextViewProvider,this.mode,this.matchType,{...this.options,history:this._history}),this.enabledDisposables.add(this.widget),this.widget.onDidChangeValue(this.onDidChangeValue,this,this.enabledDisposables),this.widget.onDidChangeMode(y=>this.mode=y,void 0,this.enabledDisposables),this.widget.onDidChangeMatchType(y=>this.matchType=y,void 0,this.enabledDisposables),this.widget.onDidDisable(this.close,this,this.enabledDisposables),this.widget.layout(this.width),this.widget.focus(),this.widget.value=this.previousPattern,this.widget.select(),this._onDidChangeOpenState.fire(!0)}close(){this.widget&&(this._history=this.widget.getHistory(),this.widget=void 0,this.enabledDisposables.clear(),this.previousPattern=this.pattern,this.onDidChangeValue(""),this.tree.domFocus(),this._onDidChangeOpenState.fire(!1))}onDidChangeValue(y){this._pattern=y,this._onDidChangePattern.fire(y),this.filter.pattern=y,this.tree.refilter(),y&&this.tree.focusNext(0,!0,void 0,z=>!A.FuzzyScore.isDefault(z.filterData));const D=this.tree.getFocus();if(D.length>0){const z=D[0];this.tree.getRelativeTop(z)===null&&this.tree.reveal(z,.5)}this.render()}onDidSpliceModel(){!this.widget||this.pattern.length===0||(this.tree.refilter(),this.render())}render(){const y=this.filter.totalCount>0&&this.filter.matchCount===0;this.pattern&&y?((0,F.alert)((0,_.localize)(37,null)),this.tree.options.showNotFoundMessage??!0?this.widget?.showMessage({type:b.MessageType.WARNING,content:(0,_.localize)(38,null)}):this.widget?.showMessage({type:b.MessageType.WARNING})):(this.widget?.clearMessage(),this.pattern&&(0,F.alert)((0,_.localize)(39,null,this.filter.matchCount)))}shouldAllowFocus(y){return!this.widget||!this.pattern||this.filter.totalCount>0&&this.filter.matchCount<=1?!0:!A.FuzzyScore.isDefault(y.filterData)}layout(y){this.width=y,this.widget?.layout(y)}dispose(){this._history=void 0,this._onDidChangePattern.dispose(),this.enabledDisposables.dispose(),this.disposables.dispose()}}function ve(te,y){return te.position===y.position&&Ne(te,y)}function Ne(te,y){return te.node.element===y.node.element&&te.startIndex===y.startIndex&&te.height===y.height&&te.endIndex===y.endIndex}class ne{constructor(y=[]){this.stickyNodes=y}get count(){return this.stickyNodes.length}equal(y){return(0,e.equals)(this.stickyNodes,y.stickyNodes,ve)}lastNodePartiallyVisible(){if(this.count===0)return!1;const y=this.stickyNodes[this.count-1];if(this.count===1)return y.position!==0;const D=this.stickyNodes[this.count-2];return D.position+D.height!==y.position}animationStateChanged(y){if(!(0,e.equals)(this.stickyNodes,y.stickyNodes,Ne)||this.count===0)return!1;const D=this.stickyNodes[this.count-1],z=y.stickyNodes[y.count-1];return D.position!==z.position}}class Ee{constrainStickyScrollNodes(y,D,z){for(let V=0;V<y.length;V++){const q=y[V];if(q.position+q.height>z||V>=D)return y.slice(0,V)}return y}}class Le extends c.Disposable{constructor(y,D,z,V,q,se={}){super(),this.tree=y,this.model=D,this.view=z,this.treeDelegate=q,this.maxWidgetViewRatio=.4;const ae=this.validateStickySettings(se);this.stickyScrollMaxItemCount=ae.stickyScrollMaxItemCount,this.stickyScrollDelegate=se.stickyScrollDelegate??new Ee,this._widget=this._register(new Ce(z.getScrollableElement(),z,y,V,q,se.accessibilityProvider)),this.onDidChangeHasFocus=this._widget.onDidChangeHasFocus,this.onContextMenu=this._widget.onContextMenu,this._register(z.onDidScroll(()=>this.update())),this._register(z.onDidChangeContentHeight(()=>this.update())),this._register(y.onDidChangeCollapseState(()=>this.update())),this.update()}get height(){return this._widget.height}get count(){return this._widget.count}getNode(y){return this._widget.getNode(y)}getNodeAtHeight(y){let D;if(y===0?D=this.view.firstVisibleIndex:D=this.view.indexAt(y+this.view.scrollTop),!(D<0||D>=this.view.length))return this.view.element(D)}update(){const y=this.getNodeAtHeight(0);if(!y||this.tree.scrollTop===0){this._widget.setState(void 0);return}const D=this.findStickyState(y);this._widget.setState(D)}findStickyState(y){const D=[];let z=y,V=0,q=this.getNextStickyNode(z,void 0,V);for(;q&&(D.push(q),V+=q.height,!(D.length<=this.stickyScrollMaxItemCount&&(z=this.getNextVisibleNode(q),!z)));)q=this.getNextStickyNode(z,q.node,V);const se=this.constrainStickyNodes(D);return se.length?new ne(se):void 0}getNextVisibleNode(y){return this.getNodeAtHeight(y.position+y.height)}getNextStickyNode(y,D,z){const V=this.getAncestorUnderPrevious(y,D);if(V&&!(V===y&&(!this.nodeIsUncollapsedParent(y)||this.nodeTopAlignsWithStickyNodesBottom(y,z))))return this.createStickyScrollNode(V,z)}nodeTopAlignsWithStickyNodesBottom(y,D){const z=this.getNodeIndex(y),V=this.view.getElementTop(z),q=D;return this.view.scrollTop===V-q}createStickyScrollNode(y,D){const z=this.treeDelegate.getHeight(y),{startIndex:V,endIndex:q}=this.getNodeRange(y),se=this.calculateStickyNodePosition(q,D,z);return{node:y,position:se,height:z,startIndex:V,endIndex:q}}getAncestorUnderPrevious(y,D=void 0){let z=y,V=this.getParentNode(z);for(;V;){if(V===D)return z;z=V,V=this.getParentNode(z)}if(D===void 0)return z}calculateStickyNodePosition(y,D,z){let V=this.view.getRelativeTop(y);if(V===null&&this.view.firstVisibleIndex===y&&y+1<this.view.length){const we=this.treeDelegate.getHeight(this.view.element(y)),De=this.view.getRelativeTop(y+1);V=De?De-we/this.view.renderHeight:null}if(V===null)return D;const q=this.view.element(y),se=this.treeDelegate.getHeight(q),ge=V*this.view.renderHeight+se;return D+z>ge&&D<=ge?ge-z:D}constrainStickyNodes(y){if(y.length===0)return[];const D=this.view.renderHeight*this.maxWidgetViewRatio,z=y[y.length-1];if(y.length<=this.stickyScrollMaxItemCount&&z.position+z.height<=D)return y;const V=this.stickyScrollDelegate.constrainStickyScrollNodes(y,this.stickyScrollMaxItemCount,D);if(!V.length)return[];const q=V[V.length-1];if(V.length>this.stickyScrollMaxItemCount||q.position+q.height>D)throw new Error("stickyScrollDelegate violates constraints");return V}getParentNode(y){const D=this.model.getNodeLocation(y),z=this.model.getParentNodeLocation(D);return z?this.model.getNode(z):void 0}nodeIsUncollapsedParent(y){const D=this.model.getNodeLocation(y);return this.model.getListRenderCount(D)>1}getNodeIndex(y){const D=this.model.getNodeLocation(y);return this.model.getListIndex(D)}getNodeRange(y){const D=this.model.getNodeLocation(y),z=this.model.getListIndex(D);if(z<0)throw new Error("Node not found in tree");const V=this.model.getListRenderCount(D),q=z+V-1;return{startIndex:z,endIndex:q}}nodePositionTopBelowWidget(y){const D=[];let z=this.getParentNode(y);for(;z;)D.push(z),z=this.getParentNode(z);let V=0;for(let q=0;q<D.length&&q<this.stickyScrollMaxItemCount;q++)V+=this.treeDelegate.getHeight(D[q]);return V}getFocus(){return this._widget.getFocus()}domFocus(){this._widget.domFocus()}focusedLast(){return this._widget.focusedLast()}updateOptions(y={}){if(!y.stickyScrollMaxItemCount)return;const D=this.validateStickySettings(y);this.stickyScrollMaxItemCount!==D.stickyScrollMaxItemCount&&(this.stickyScrollMaxItemCount=D.stickyScrollMaxItemCount,this.update())}validateStickySettings(y){let D=7;return typeof y.stickyScrollMaxItemCount=="number"&&(D=Math.max(y.stickyScrollMaxItemCount,1)),{stickyScrollMaxItemCount:D}}}class Ce{constructor(y,D,z,V,q,se){this.view=D,this.tree=z,this.treeRenderers=V,this.treeDelegate=q,this.accessibilityProvider=se,this._previousElements=[],this._previousStateDisposables=new c.DisposableStore,this._rootDomNode=(0,i.$)(".monaco-tree-sticky-container.empty"),y.appendChild(this._rootDomNode);const ae=(0,i.$)(".monaco-tree-sticky-container-shadow");this._rootDomNode.appendChild(ae),this.stickyScrollFocus=new Fe(this._rootDomNode,D),this.onDidChangeHasFocus=this.stickyScrollFocus.onDidChangeHasFocus,this.onContextMenu=this.stickyScrollFocus.onContextMenu}get height(){if(!this._previousState)return 0;const y=this._previousState.stickyNodes[this._previousState.count-1];return y.position+y.height}get count(){return this._previousState?.count??0}getNode(y){return this._previousState?.stickyNodes.find(D=>D.node===y)}setState(y){const D=!!this._previousState&&this._previousState.count>0,z=!!y&&y.count>0;if(!D&&!z||D&&z&&this._previousState.equal(y))return;if(D!==z&&this.setVisible(z),!z){this._previousState=void 0,this._previousElements=[],this._previousStateDisposables.clear();return}const V=y.stickyNodes[y.count-1];if(this._previousState&&y.animationStateChanged(this._previousState))this._previousElements[this._previousState.count-1].style.top=`${V.position}px`;else{this._previousStateDisposables.clear();const q=Array(y.count);for(let se=y.count-1;se>=0;se--){const ae=y.stickyNodes[se],{element:ge,disposable:we}=this.createElement(ae,se,y.count);q[se]=ge,this._rootDomNode.appendChild(ge),this._previousStateDisposables.add(we)}this.stickyScrollFocus.updateElements(q,y),this._previousElements=q}this._previousState=y,this._rootDomNode.style.height=`${V.position+V.height}px`}createElement(y,D,z){const V=y.startIndex,q=document.createElement("div");q.style.top=`${y.position}px`,this.tree.options.setRowHeight!==!1&&(q.style.height=`${y.height}px`),this.tree.options.setRowLineHeight!==!1&&(q.style.lineHeight=`${y.height}px`),q.classList.add("monaco-tree-sticky-row"),q.classList.add("monaco-list-row"),q.setAttribute("data-index",`${V}`),q.setAttribute("data-parity",V%2===0?"even":"odd"),q.setAttribute("id",this.view.getElementID(V));const se=this.setAccessibilityAttributes(q,y.node.element,D,z),ae=this.treeDelegate.getTemplateId(y.node),ge=this.treeRenderers.find(Oe=>Oe.templateId===ae);if(!ge)throw new Error(`No renderer found for template id ${ae}`);let we=y.node;we===this.tree.getNode(this.tree.getNodeLocation(y.node))&&(we=new Proxy(y.node,{}));const De=ge.renderTemplate(q);ge.renderElement(we,y.startIndex,De,y.height);const Te=(0,c.toDisposable)(()=>{se.dispose(),ge.disposeElement(we,y.startIndex,De,y.height),ge.disposeTemplate(De),q.remove()});return{element:q,disposable:Te}}setAccessibilityAttributes(y,D,z,V){if(!this.accessibilityProvider)return c.Disposable.None;this.accessibilityProvider.getSetSize&&y.setAttribute("aria-setsize",String(this.accessibilityProvider.getSetSize(D,z,V))),this.accessibilityProvider.getPosInSet&&y.setAttribute("aria-posinset",String(this.accessibilityProvider.getPosInSet(D,z))),this.accessibilityProvider.getRole&&y.setAttribute("role",this.accessibilityProvider.getRole(D)??"treeitem");const q=this.accessibilityProvider.getAriaLabel(D),se=q&&typeof q!="string"?q:(0,B.constObservable)(q),ae=(0,B.autorun)(we=>{const De=we.readObservable(se);De?y.setAttribute("aria-label",De):y.removeAttribute("aria-label")});typeof q=="string"||q&&y.setAttribute("aria-label",q.get());const ge=this.accessibilityProvider.getAriaLevel&&this.accessibilityProvider.getAriaLevel(D);return typeof ge=="number"&&y.setAttribute("aria-level",`${ge}`),y.setAttribute("aria-selected",String(!1)),ae}setVisible(y){this._rootDomNode.classList.toggle("empty",!y),y||this.stickyScrollFocus.updateElements([],void 0)}getFocus(){return this.stickyScrollFocus.getFocus()}domFocus(){this.stickyScrollFocus.domFocus()}focusedLast(){return this.stickyScrollFocus.focusedLast()}dispose(){this.stickyScrollFocus.dispose(),this._previousStateDisposables.dispose(),this._rootDomNode.remove()}}class Fe extends c.Disposable{get domHasFocus(){return this._domHasFocus}set domHasFocus(y){y!==this._domHasFocus&&(this._onDidChangeHasFocus.fire(y),this._domHasFocus=y)}constructor(y,D){super(),this.container=y,this.view=D,this.focusedIndex=-1,this.elements=[],this._onDidChangeHasFocus=new p.Emitter,this.onDidChangeHasFocus=this._onDidChangeHasFocus.event,this._onContextMenu=new p.Emitter,this.onContextMenu=this._onContextMenu.event,this._domHasFocus=!1,this._register((0,i.addDisposableListener)(this.container,"focus",()=>this.onFocus())),this._register((0,i.addDisposableListener)(this.container,"blur",()=>this.onBlur())),this._register(this.view.onDidFocus(()=>this.toggleStickyScrollFocused(!1))),this._register(this.view.onKeyDown(z=>this.onKeyDown(z))),this._register(this.view.onMouseDown(z=>this.onMouseDown(z))),this._register(this.view.onContextMenu(z=>this.handleContextMenu(z)))}handleContextMenu(y){const D=y.browserEvent.target;if(!(0,u.isStickyScrollContainer)(D)&&!(0,u.isStickyScrollElement)(D)){this.focusedLast()&&this.view.domFocus();return}if(!(0,i.isKeyboardEvent)(y.browserEvent)){if(!this.state)throw new Error("Context menu should not be triggered when state is undefined");const se=this.state.stickyNodes.findIndex(ae=>ae.node.element===y.element?.element);if(se===-1)throw new Error("Context menu should not be triggered when element is not in sticky scroll widget");this.container.focus(),this.setFocus(se);return}if(!this.state||this.focusedIndex<0)throw new Error("Context menu key should not be triggered when focus is not in sticky scroll widget");const V=this.state.stickyNodes[this.focusedIndex].node.element,q=this.elements[this.focusedIndex];this._onContextMenu.fire({element:V,anchor:q,browserEvent:y.browserEvent,isStickyScroll:!0})}onKeyDown(y){if(this.domHasFocus&&this.state){if(y.key==="ArrowUp")this.setFocusedElement(Math.max(0,this.focusedIndex-1)),y.preventDefault(),y.stopPropagation();else if(y.key==="ArrowDown"||y.key==="ArrowRight"){if(this.focusedIndex>=this.state.count-1){const D=this.state.stickyNodes[this.state.count-1].startIndex+1;this.view.domFocus(),this.view.setFocus([D]),this.scrollNodeUnderWidget(D,this.state)}else this.setFocusedElement(this.focusedIndex+1);y.preventDefault(),y.stopPropagation()}}}onMouseDown(y){const D=y.browserEvent.target;!(0,u.isStickyScrollContainer)(D)&&!(0,u.isStickyScrollElement)(D)||(y.browserEvent.preventDefault(),y.browserEvent.stopPropagation())}updateElements(y,D){if(D&&D.count===0)throw new Error("Sticky scroll state must be undefined when there are no sticky nodes");if(D&&D.count!==y.length)throw new Error("Sticky scroll focus received illigel state");const z=this.focusedIndex;if(this.removeFocus(),this.elements=y,this.state=D,D){const V=(0,a.clamp)(z,0,D.count-1);this.setFocus(V)}else this.domHasFocus&&this.view.domFocus();this.container.tabIndex=D?0:-1}setFocusedElement(y){const D=this.state;if(!D)throw new Error("Cannot set focus when state is undefined");if(this.setFocus(y),!(y<D.count-1)&&D.lastNodePartiallyVisible()){const z=D.stickyNodes[y];this.scrollNodeUnderWidget(z.endIndex+1,D)}}scrollNodeUnderWidget(y,D){const z=D.stickyNodes[D.count-1],V=D.count>1?D.stickyNodes[D.count-2]:void 0,q=this.view.getElementTop(y),se=V?V.position+V.height+z.height:z.height;this.view.scrollTop=q-se}getFocus(){if(!(!this.state||this.focusedIndex===-1))return this.state.stickyNodes[this.focusedIndex].node.element}domFocus(){if(!this.state)throw new Error("Cannot focus when state is undefined");this.container.focus()}focusedLast(){return this.state?this.view.getHTMLElement().classList.contains("sticky-scroll-focused"):!1}removeFocus(){this.focusedIndex!==-1&&(this.toggleElementFocus(this.elements[this.focusedIndex],!1),this.focusedIndex=-1)}setFocus(y){if(0>y)throw new Error("addFocus() can not remove focus");if(!this.state&&y>=0)throw new Error("Cannot set focus index when state is undefined");if(this.state&&y>=this.state.count)throw new Error("Cannot set focus index to an index that does not exist");const D=this.focusedIndex;D>=0&&this.toggleElementFocus(this.elements[D],!1),y>=0&&this.toggleElementFocus(this.elements[y],!0),this.focusedIndex=y}toggleElementFocus(y,D){this.toggleElementActiveFocus(y,D&&this.domHasFocus),this.toggleElementPassiveFocus(y,D)}toggleCurrentElementActiveFocus(y){this.focusedIndex!==-1&&this.toggleElementActiveFocus(this.elements[this.focusedIndex],y)}toggleElementActiveFocus(y,D){y.classList.toggle("focused",D)}toggleElementPassiveFocus(y,D){y.classList.toggle("passive-focused",D)}toggleStickyScrollFocused(y){this.view.getHTMLElement().classList.toggle("sticky-scroll-focused",y)}onFocus(){if(!this.state||this.elements.length===0)throw new Error("Cannot focus when state is undefined or elements are empty");this.domHasFocus=!0,this.toggleStickyScrollFocused(!0),this.toggleCurrentElementActiveFocus(!0),this.focusedIndex===-1&&this.setFocus(0)}onBlur(){this.domHasFocus=!1,this.toggleCurrentElementActiveFocus(!1)}dispose(){this.toggleStickyScrollFocused(!1),this._onDidChangeHasFocus.fire(!1),super.dispose()}}function ze(te){let y=g.TreeMouseEventTarget.Unknown;return(0,i.hasParentWithClass)(te.browserEvent.target,"monaco-tl-twistie","monaco-tl-row")?y=g.TreeMouseEventTarget.Twistie:(0,i.hasParentWithClass)(te.browserEvent.target,"monaco-tl-contents","monaco-tl-row")?y=g.TreeMouseEventTarget.Element:(0,i.hasParentWithClass)(te.browserEvent.target,"monaco-tree-type-filter","monaco-list")&&(y=g.TreeMouseEventTarget.Filter),{browserEvent:te.browserEvent,element:te.element?te.element.element:null,target:y}}function Xe(te){const y=(0,u.isStickyScrollContainer)(te.browserEvent.target);return{element:te.element?te.element.element:null,browserEvent:te.browserEvent,anchor:te.anchor,isStickyScroll:y}}function oe(te,y){y(te),te.children.forEach(D=>oe(D,y))}class x{get nodeSet(){return this._nodeSet||(this._nodeSet=this.createNodeSet()),this._nodeSet}constructor(y,D){this.getFirstViewElementWithTrait=y,this.identityProvider=D,this.nodes=[],this._onDidChange=new p.Emitter,this.onDidChange=this._onDidChange.event}set(y,D){!D?.__forceEvent&&(0,e.equals)(this.nodes,y)||this._set(y,!1,D)}_set(y,D,z){if(this.nodes=[...y],this.elements=void 0,this._nodeSet=void 0,!D){const V=this;this._onDidChange.fire({get elements(){return V.get()},browserEvent:z})}}get(){return this.elements||(this.elements=this.nodes.map(y=>y.element)),[...this.elements]}getNodes(){return this.nodes}has(y){return this.nodeSet.has(y)}onDidModelSplice({insertedNodes:y,deletedNodes:D}){if(!this.identityProvider){const ge=this.createNodeSet(),we=De=>ge.delete(De);D.forEach(De=>oe(De,we)),this.set([...ge.values()]);return}const z=new Set,V=ge=>z.add(this.identityProvider.getId(ge.element).toString());D.forEach(ge=>oe(ge,V));const q=new Map,se=ge=>q.set(this.identityProvider.getId(ge.element).toString(),ge);y.forEach(ge=>oe(ge,se));const ae=[];for(const ge of this.nodes){const we=this.identityProvider.getId(ge.element).toString();if(!z.has(we))ae.push(ge);else{const Te=q.get(we);Te&&Te.visible&&ae.push(Te)}}if(this.nodes.length>0&&ae.length===0){const ge=this.getFirstViewElementWithTrait();ge&&ae.push(ge)}this._set(ae,!0)}createNodeSet(){const y=new Set;for(const D of this.nodes)y.add(D);return y}}class h extends u.MouseController{constructor(y,D,z){super(y),this.tree=D,this.stickyScrollProvider=z}onViewPointer(y){if((0,u.isButton)(y.browserEvent.target)||(0,u.isInputElement)(y.browserEvent.target)||(0,u.isMonacoEditor)(y.browserEvent.target)||y.browserEvent.isHandledByList)return;const D=y.element;if(!D)return super.onViewPointer(y);if(this.isSelectionRangeChangeEvent(y)||this.isSelectionSingleChangeEvent(y))return super.onViewPointer(y);const z=y.browserEvent.target,V=z.classList.contains("monaco-tl-twistie")||z.classList.contains("monaco-icon-label")&&z.classList.contains("folder-icon")&&y.browserEvent.offsetX<16,q=(0,u.isStickyScrollElement)(y.browserEvent.target);let se=!1;if(q?se=!0:typeof this.tree.expandOnlyOnTwistieClick=="function"?se=this.tree.expandOnlyOnTwistieClick(D.element):se=!!this.tree.expandOnlyOnTwistieClick,q)this.handleStickyScrollMouseEvent(y,D);else{if(se&&!V&&y.browserEvent.detail!==2)return super.onViewPointer(y);if(!this.tree.expandOnDoubleClick&&y.browserEvent.detail===2)return super.onViewPointer(y)}if(D.collapsible&&(!q||V)){const ae=this.tree.getNodeLocation(D),ge=y.browserEvent.altKey;if(this.tree.setFocus([ae]),this.tree.toggleCollapsed(ae,ge),V){y.browserEvent.isHandledByList=!0;return}}q||super.onViewPointer(y)}handleStickyScrollMouseEvent(y,D){if((0,u.isMonacoCustomToggle)(y.browserEvent.target)||(0,u.isActionItem)(y.browserEvent.target))return;const z=this.stickyScrollProvider();if(!z)throw new Error("Sticky scroll controller not found");const V=this.list.indexOf(D),q=this.list.getElementTop(V),se=z.nodePositionTopBelowWidget(D);this.tree.scrollTop=q-se,this.list.domFocus(),this.list.setFocus([V]),this.list.setSelection([V])}onDoubleClick(y){y.browserEvent.target.classList.contains("monaco-tl-twistie")||!this.tree.expandOnDoubleClick||y.browserEvent.isHandledByList||super.onDoubleClick(y)}onMouseDown(y){const D=y.browserEvent.target;if(!(0,u.isStickyScrollContainer)(D)&&!(0,u.isStickyScrollElement)(D)){super.onMouseDown(y);return}}onContextMenu(y){const D=y.browserEvent.target;if(!(0,u.isStickyScrollContainer)(D)&&!(0,u.isStickyScrollElement)(D)){super.onContextMenu(y);return}}}class S extends u.List{constructor(y,D,z,V,q,se,ae,ge){super(y,D,z,V,ge),this.focusTrait=q,this.selectionTrait=se,this.anchorTrait=ae}createMouseController(y){return new h(this,y.tree,y.stickyScrollProvider)}splice(y,D,z=[]){if(super.splice(y,D,z),z.length===0)return;const V=[],q=[];let se;z.forEach((ae,ge)=>{this.focusTrait.has(ae)&&V.push(y+ge),this.selectionTrait.has(ae)&&q.push(y+ge),this.anchorTrait.has(ae)&&(se=y+ge)}),V.length>0&&super.setFocus((0,e.distinct)([...super.getFocus(),...V])),q.length>0&&super.setSelection((0,e.distinct)([...super.getSelection(),...q])),typeof se=="number"&&super.setAnchor(se)}setFocus(y,D,z=!1){super.setFocus(y,D),z||this.focusTrait.set(y.map(V=>this.element(V)),D)}setSelection(y,D,z=!1){super.setSelection(y,D),z||this.selectionTrait.set(y.map(V=>this.element(V)),D)}setAnchor(y,D=!1){super.setAnchor(y),D||(typeof y>"u"?this.anchorTrait.set([]):this.anchorTrait.set([this.element(y)]))}}var P;(function(te){te[te.Tree=0]="Tree",te[te.StickyScroll=1]="StickyScroll"})(P||(t.AbstractTreePart=P={}));class G{get onDidScroll(){return this.view.onDidScroll}get onDidChangeFocus(){return this.eventBufferer.wrapEvent(this.focus.onDidChange)}get onDidChangeSelection(){return this.eventBufferer.wrapEvent(this.selection.onDidChange)}get onMouseClick(){return p.Event.map(this.view.onMouseClick,ze)}get onMouseDblClick(){return p.Event.filter(p.Event.map(this.view.onMouseDblClick,ze),y=>y.target!==g.TreeMouseEventTarget.Filter)}get onMouseOver(){return p.Event.map(this.view.onMouseOver,ze)}get onMouseOut(){return p.Event.map(this.view.onMouseOut,ze)}get onContextMenu(){return p.Event.any(p.Event.filter(p.Event.map(this.view.onContextMenu,Xe),y=>!y.isStickyScroll),this.stickyScrollController?.onContextMenu??p.Event.None)}get onTap(){return p.Event.map(this.view.onTap,ze)}get onPointer(){return p.Event.map(this.view.onPointer,ze)}get onKeyDown(){return this.view.onKeyDown}get onKeyUp(){return this.view.onKeyUp}get onKeyPress(){return this.view.onKeyPress}get onDidFocus(){return this.view.onDidFocus}get onDidBlur(){return this.view.onDidBlur}get onDidChangeModel(){return p.Event.signal(this.model.onDidSplice)}get onDidChangeCollapseState(){return this.model.onDidChangeCollapseState}get onDidChangeRenderNodeCount(){return this.model.onDidChangeRenderNodeCount}get findMode(){return this.findController?.mode??Pe.Highlight}set findMode(y){this.findController&&(this.findController.mode=y)}get findMatchType(){return this.findController?.matchType??re.Fuzzy}set findMatchType(y){this.findController&&(this.findController.matchType=y)}get onDidChangeFindPattern(){return this.findController?this.findController.onDidChangePattern:p.Event.None}get expandOnDoubleClick(){return typeof this._options.expandOnDoubleClick>"u"?!0:this._options.expandOnDoubleClick}get expandOnlyOnTwistieClick(){return typeof this._options.expandOnlyOnTwistieClick>"u"?!0:this._options.expandOnlyOnTwistieClick}get onDidDispose(){return this.view.onDidDispose}constructor(y,D,z,V,q={}){this._user=y,this._options=q,this.eventBufferer=new p.EventBufferer,this.onDidChangeFindOpenState=p.Event.None,this.onDidChangeStickyScrollFocused=p.Event.None,this.disposables=new c.DisposableStore,this._onWillRefilter=new p.Emitter,this.onWillRefilter=this._onWillRefilter.event,this._onDidUpdateOptions=new p.Emitter,this.onDidUpdateOptions=this._onDidUpdateOptions.event,this.treeDelegate=new C(z);const se=new p.Relay,ae=new p.Relay,ge=this.disposables.add(new Y(ae.event)),we=new o.SetMap;this.renderers=V.map(ke=>new Z(ke,()=>this.model,se.event,ge,we,q));for(const ke of this.renderers)this.disposables.add(ke);let De;q.keyboardNavigationLabelProvider&&(De=new ce(this,q.keyboardNavigationLabelProvider,q.filter),q={...q,filter:De},this.disposables.add(De)),this.focus=new x(()=>this.view.getFocusedElements()[0],q.identityProvider),this.selection=new x(()=>this.view.getSelectedElements()[0],q.identityProvider),this.anchor=new x(()=>this.view.getAnchorElement(),q.identityProvider),this.view=new S(y,D,this.treeDelegate,this.renderers,this.focus,this.selection,this.anchor,{...R(()=>this.model,q),tree:this,stickyScrollProvider:()=>this.stickyScrollController}),this.model=this.createModel(y,this.view,q),se.input=this.model.onDidChangeCollapseState;const Te=p.Event.forEach(this.model.onDidSplice,ke=>{this.eventBufferer.bufferEvents(()=>{this.focus.onDidModelSplice(ke),this.selection.onDidModelSplice(ke)})},this.disposables);Te(()=>null,null,this.disposables);const Oe=this.disposables.add(new p.Emitter),Ae=this.disposables.add(new s.Delayer(0));if(this.disposables.add(p.Event.any(Te,this.focus.onDidChange,this.selection.onDidChange)(()=>{Ae.trigger(()=>{const ke=new Set;for(const Ge of this.focus.getNodes())ke.add(Ge);for(const Ge of this.selection.getNodes())ke.add(Ge);Oe.fire([...ke.values()])})})),ae.input=Oe.event,q.keyboardSupport!==!1){const ke=p.Event.chain(this.view.onKeyDown,Ge=>Ge.filter(it=>!(0,u.isInputElement)(it.target)).map(it=>new O.StandardKeyboardEvent(it)));p.Event.chain(ke,Ge=>Ge.filter(it=>it.keyCode===L.KeyCode.LeftArrow))(this.onLeftArrow,this,this.disposables),p.Event.chain(ke,Ge=>Ge.filter(it=>it.keyCode===L.KeyCode.RightArrow))(this.onRightArrow,this,this.disposables),p.Event.chain(ke,Ge=>Ge.filter(it=>it.keyCode===L.KeyCode.Space))(this.onSpace,this,this.disposables)}if((q.findWidgetEnabled??!0)&&q.keyboardNavigationLabelProvider&&q.contextViewProvider){const ke=this.options.findWidgetStyles?{styles:this.options.findWidgetStyles}:void 0;this.findController=new fe(this,this.model,this.view,De,q.contextViewProvider,ke),this.focusNavigationFilter=Ge=>this.findController.shouldAllowFocus(Ge),this.onDidChangeFindOpenState=this.findController.onDidChangeOpenState,this.disposables.add(this.findController),this.onDidChangeFindMode=this.findController.onDidChangeMode,this.onDidChangeFindMatchType=this.findController.onDidChangeMatchType}else this.onDidChangeFindMode=p.Event.None,this.onDidChangeFindMatchType=p.Event.None;q.enableStickyScroll&&(this.stickyScrollController=new Le(this,this.model,this.view,this.renderers,this.treeDelegate,q),this.onDidChangeStickyScrollFocused=this.stickyScrollController.onDidChangeHasFocus),this.styleElement=(0,i.createStyleSheet)(this.view.getHTMLElement()),this.getHTMLElement().classList.toggle("always",this._options.renderIndentGuides===ee.Always)}updateOptions(y={}){this._options={...this._options,...y};for(const D of this.renderers)D.updateOptions(y);this.view.updateOptions(this._options),this.findController?.updateOptions(y),this.updateStickyScroll(y),this._onDidUpdateOptions.fire(this._options),this.getHTMLElement().classList.toggle("always",this._options.renderIndentGuides===ee.Always)}get options(){return this._options}updateStickyScroll(y){!this.stickyScrollController&&this._options.enableStickyScroll?(this.stickyScrollController=new Le(this,this.model,this.view,this.renderers,this.treeDelegate,this._options),this.onDidChangeStickyScrollFocused=this.stickyScrollController.onDidChangeHasFocus):this.stickyScrollController&&!this._options.enableStickyScroll&&(this.onDidChangeStickyScrollFocused=p.Event.None,this.stickyScrollController.dispose(),this.stickyScrollController=void 0),this.stickyScrollController?.updateOptions(y)}updateWidth(y){const D=this.model.getListIndex(y);D!==-1&&this.view.updateWidth(D)}getHTMLElement(){return this.view.getHTMLElement()}get contentHeight(){return this.view.contentHeight}get contentWidth(){return this.view.contentWidth}get onDidChangeContentHeight(){return this.view.onDidChangeContentHeight}get onDidChangeContentWidth(){return this.view.onDidChangeContentWidth}get scrollTop(){return this.view.scrollTop}set scrollTop(y){this.view.scrollTop=y}get scrollLeft(){return this.view.scrollLeft}set scrollLeft(y){this.view.scrollLeft=y}get scrollHeight(){return this.view.scrollHeight}get renderHeight(){return this.view.renderHeight}get firstVisibleElement(){let y=this.view.firstVisibleIndex;return this.stickyScrollController&&(y+=this.stickyScrollController.count),y<0||y>=this.view.length?void 0:this.view.element(y).element}get lastVisibleElement(){const y=this.view.lastVisibleIndex;return this.view.element(y).element}get ariaLabel(){return this.view.ariaLabel}set ariaLabel(y){this.view.ariaLabel=y}get selectionSize(){return this.selection.getNodes().length}domFocus(){this.stickyScrollController?.focusedLast()?this.stickyScrollController.domFocus():this.view.domFocus()}isDOMFocused(){return(0,i.isActiveElement)(this.getHTMLElement())}layout(y,D){this.view.layout(y,D),(0,f.isNumber)(D)&&this.findController?.layout(D)}style(y){const D=`.${this.view.domId}`,z=[];y.treeIndentGuidesStroke&&(z.push(`.monaco-list${D}:hover .monaco-tl-indent > .indent-guide, .monaco-list${D}.always .monaco-tl-indent > .indent-guide  { border-color: ${y.treeInactiveIndentGuidesStroke}; }`),z.push(`.monaco-list${D} .monaco-tl-indent > .indent-guide.active { border-color: ${y.treeIndentGuidesStroke}; }`));const V=y.treeStickyScrollBackground??y.listBackground;V&&(z.push(`.monaco-list${D} .monaco-scrollable-element .monaco-tree-sticky-container { background-color: ${V}; }`),z.push(`.monaco-list${D} .monaco-scrollable-element .monaco-tree-sticky-container .monaco-tree-sticky-row { background-color: ${V}; }`)),y.treeStickyScrollBorder&&z.push(`.monaco-list${D} .monaco-scrollable-element .monaco-tree-sticky-container { border-bottom: 1px solid ${y.treeStickyScrollBorder}; }`),y.treeStickyScrollShadow&&z.push(`.monaco-list${D} .monaco-scrollable-element .monaco-tree-sticky-container .monaco-tree-sticky-container-shadow { box-shadow: ${y.treeStickyScrollShadow} 0 6px 6px -6px inset; height: 3px; }`),y.listFocusForeground&&(z.push(`.monaco-list${D}.sticky-scroll-focused .monaco-scrollable-element .monaco-tree-sticky-container:focus .monaco-list-row.focused { color: ${y.listFocusForeground}; }`),z.push(`.monaco-list${D}:not(.sticky-scroll-focused) .monaco-scrollable-element .monaco-tree-sticky-container .monaco-list-row.focused { color: inherit; }`));const q=(0,i.asCssValueWithDefault)(y.listFocusAndSelectionOutline,(0,i.asCssValueWithDefault)(y.listSelectionOutline,y.listFocusOutline??""));q&&(z.push(`.monaco-list${D}.sticky-scroll-focused .monaco-scrollable-element .monaco-tree-sticky-container:focus .monaco-list-row.focused.selected { outline: 1px solid ${q}; outline-offset: -1px;}`),z.push(`.monaco-list${D}:not(.sticky-scroll-focused) .monaco-scrollable-element .monaco-tree-sticky-container .monaco-list-row.focused.selected { outline: inherit;}`)),y.listFocusOutline&&(z.push(`.monaco-list${D}.sticky-scroll-focused .monaco-scrollable-element .monaco-tree-sticky-container:focus .monaco-list-row.focused { outline: 1px solid ${y.listFocusOutline}; outline-offset: -1px; }`),z.push(`.monaco-list${D}:not(.sticky-scroll-focused) .monaco-scrollable-element .monaco-tree-sticky-container .monaco-list-row.focused { outline: inherit; }`),z.push(`.monaco-workbench.context-menu-visible .monaco-list${D}.last-focused.sticky-scroll-focused .monaco-scrollable-element .monaco-tree-sticky-container .monaco-list-row.passive-focused { outline: 1px solid ${y.listFocusOutline}; outline-offset: -1px; }`),z.push(`.monaco-workbench.context-menu-visible .monaco-list${D}.last-focused.sticky-scroll-focused .monaco-list-rows .monaco-list-row.focused { outline: inherit; }`),z.push(`.monaco-workbench.context-menu-visible .monaco-list${D}.last-focused:not(.sticky-scroll-focused) .monaco-tree-sticky-container .monaco-list-rows .monaco-list-row.focused { outline: inherit; }`)),this.styleElement.textContent=z.join(`
`),this.view.style(y)}getParentElement(y){const D=this.model.getParentNodeLocation(y);return this.model.getNode(D).element}getFirstElementChild(y){return this.model.getFirstElementChild(y)}getNode(y){return this.model.getNode(y)}getNodeLocation(y){return this.model.getNodeLocation(y)}collapse(y,D=!1){return this.model.setCollapsed(y,!0,D)}expand(y,D=!1){return this.model.setCollapsed(y,!1,D)}toggleCollapsed(y,D=!1){return this.model.setCollapsed(y,void 0,D)}expandAll(){this.model.setCollapsed(this.model.rootRef,!1,!0)}collapseAll(){this.model.setCollapsed(this.model.rootRef,!0,!0)}isCollapsible(y){return this.model.isCollapsible(y)}setCollapsible(y,D){return this.model.setCollapsible(y,D)}isCollapsed(y){return this.model.isCollapsed(y)}expandTo(y){this.model.expandTo(y)}triggerTypeNavigation(){this.view.triggerTypeNavigation()}openFind(){this.findController?.open()}closeFind(){this.findController?.close()}refilter(){this._onWillRefilter.fire(void 0),this.model.refilter()}setAnchor(y){if(typeof y>"u")return this.view.setAnchor(void 0);this.eventBufferer.bufferEvents(()=>{const D=this.model.getNode(y);this.anchor.set([D]);const z=this.model.getListIndex(y);z>-1&&this.view.setAnchor(z,!0)})}getAnchor(){return(0,e.firstOrDefault)(this.anchor.get(),void 0)}setSelection(y,D){this.eventBufferer.bufferEvents(()=>{const z=y.map(q=>this.model.getNode(q));this.selection.set(z,D);const V=y.map(q=>this.model.getListIndex(q)).filter(q=>q>-1);this.view.setSelection(V,D,!0)})}getSelection(){return this.selection.get()}setFocus(y,D){this.eventBufferer.bufferEvents(()=>{const z=y.map(q=>this.model.getNode(q));this.focus.set(z,D);const V=y.map(q=>this.model.getListIndex(q)).filter(q=>q>-1);this.view.setFocus(V,D,!0)})}focusNext(y=1,D=!1,z,V=(0,i.isKeyboardEvent)(z)&&z.altKey?void 0:this.focusNavigationFilter){this.view.focusNext(y,D,z,V)}focusPrevious(y=1,D=!1,z,V=(0,i.isKeyboardEvent)(z)&&z.altKey?void 0:this.focusNavigationFilter){this.view.focusPrevious(y,D,z,V)}focusNextPage(y,D=(0,i.isKeyboardEvent)(y)&&y.altKey?void 0:this.focusNavigationFilter){return this.view.focusNextPage(y,D)}focusPreviousPage(y,D=(0,i.isKeyboardEvent)(y)&&y.altKey?void 0:this.focusNavigationFilter){return this.view.focusPreviousPage(y,D,()=>this.stickyScrollController?.height??0)}focusLast(y,D=(0,i.isKeyboardEvent)(y)&&y.altKey?void 0:this.focusNavigationFilter){this.view.focusLast(y,D)}focusFirst(y,D=(0,i.isKeyboardEvent)(y)&&y.altKey?void 0:this.focusNavigationFilter){this.view.focusFirst(y,D)}getFocus(){return this.focus.get()}getStickyScrollFocus(){const y=this.stickyScrollController?.getFocus();return y!==void 0?[y]:[]}getFocusedPart(){return this.stickyScrollController?.focusedLast()?P.StickyScroll:P.Tree}reveal(y,D){this.model.expandTo(y);const z=this.model.getListIndex(y);if(z!==-1)if(!this.stickyScrollController)this.view.reveal(z,D);else{const V=this.stickyScrollController.nodePositionTopBelowWidget(this.getNode(y));this.view.reveal(z,D,V)}}getRelativeTop(y){const D=this.model.getListIndex(y);if(D===-1)return null;const z=this.stickyScrollController?.getNode(this.getNode(y));return this.view.getRelativeTop(D,z?.position??this.stickyScrollController?.height)}getViewState(y=this.options.identityProvider){if(!y)throw new g.TreeError(this._user,"Can't get tree view state without an identity provider");const D=se=>y.getId(se).toString(),z=$.empty(this.scrollTop);for(const se of this.getFocus())z.focus.add(D(se));for(const se of this.getSelection())z.selection.add(D(se));const V=this.model.getNode(),q=[V];for(;q.length>0;){const se=q.shift();se!==V&&se.collapsible&&(z.expanded[D(se.element)]=se.collapsed?0:1),q.push(...se.children)}return z}onLeftArrow(y){y.preventDefault(),y.stopPropagation();const D=this.view.getFocusedElements();if(D.length===0)return;const z=D[0],V=this.model.getNodeLocation(z);if(!this.model.setCollapsed(V,!0)){const se=this.model.getParentNodeLocation(V);if(!se)return;const ae=this.model.getListIndex(se);this.view.reveal(ae),this.view.setFocus([ae])}}onRightArrow(y){y.preventDefault(),y.stopPropagation();const D=this.view.getFocusedElements();if(D.length===0)return;const z=D[0],V=this.model.getNodeLocation(z);if(!this.model.setCollapsed(V,!1)){if(!z.children.some(ge=>ge.visible))return;const[se]=this.view.getFocus(),ae=se+1;this.view.reveal(ae),this.view.setFocus([ae])}}onSpace(y){y.preventDefault(),y.stopPropagation();const D=this.view.getFocusedElements();if(D.length===0)return;const z=D[0],V=this.model.getNodeLocation(z),q=y.browserEvent.altKey;this.model.setCollapsed(V,void 0,q)}navigate(y){return new J(this.view,this.model,y)}dispose(){(0,c.dispose)(this.disposables),this.stickyScrollController?.dispose(),this.view.dispose()}}t.AbstractTree=G;class J{constructor(y,D,z){this.view=y,this.model=D,z?this.index=this.model.getListIndex(z):this.index=-1}current(){return this.index<0||this.index>=this.view.length?null:this.view.element(this.index).element}previous(){return this.index--,this.current()}next(){return this.index++,this.current()}first(){return this.index=0,this.current()}last(){return this.index=this.view.length-1,this.current()}}}),define(_e[144],Se([1,0,143,134,34,36]),function(ue,t,i,n,O,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DataTree=void 0;class N extends i.AbstractTree{constructor(w,u,m,v,g,d={}){super(w,u,m,v,d),this.user=w,this.dataSource=g,this.nodesByIdentity=new Map,this.identityProvider=d.identityProvider}getInput(){return this.input}setInput(w,u){if(u&&!this.identityProvider)throw new O.TreeError(this.user,"Can't restore tree view state without an identity provider");if(this.input=w,!w){this.nodesByIdentity.clear(),this.model.setChildren(null,I.Iterable.empty());return}if(!u){this._refresh(w);return}const m=[],v=[],g=e=>{const s=this.identityProvider.getId(e).toString();return!u.expanded[s]},d=e=>{const s=this.identityProvider.getId(e.element).toString();u.focus.has(s)&&m.push(e.element),u.selection.has(s)&&v.push(e.element)};this._refresh(w,g,d),this.setFocus(m),this.setSelection(v),u&&typeof u.scrollTop=="number"&&(this.scrollTop=u.scrollTop)}updateChildren(w=this.input){if(typeof this.input>"u")throw new O.TreeError(this.user,"Tree input not set");let u;this.identityProvider&&(u=m=>{const v=this.identityProvider.getId(m).toString(),g=this.nodesByIdentity.get(v);if(g)return g.collapsed}),this._refresh(w,u)}resort(w=this.input,u=!0){this.model.resort(w===this.input?null:w,u)}refresh(w){if(w===void 0){this.view.rerender();return}this.model.rerender(w)}_refresh(w,u,m){let v;if(this.identityProvider){const g=new Set,d=m;m=e=>{const s=this.identityProvider.getId(e.element).toString();g.add(s),this.nodesByIdentity.set(s,e),d?.(e)},v=e=>{const s=this.identityProvider.getId(e.element).toString();g.has(s)||this.nodesByIdentity.delete(s)}}this.model.setChildren(w===this.input?null:w,this.iterate(w,u).elements,{onDidCreateNode:m,onDidDeleteNode:v})}iterate(w,u){const m=[...this.dataSource.getChildren(w)];return{elements:I.Iterable.map(m,g=>{const{elements:d,size:e}=this.iterate(g,u),s=this.dataSource.hasChildren?this.dataSource.hasChildren(g):void 0,r=e===0?void 0:u&&u(g);return{element:g,children:d,collapsible:s,collapsed:r}}),size:m.length}}createModel(w,u,m){return new n.ObjectTreeModel(w,u,m)}}t.DataTree=N}),define(_e[84],Se([1,0,9,13,47,38,35,6,3,2,71,11,10]),function(ue,t,i,n,O,I,N,b,w,u,m,v,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IPCLogger=t.ProxyChannel=t.StaticRouter=t.IPCClient=t.IPCServer=t.ChannelClient=t.RequestInitiator=t.ChannelServer=t.BufferWriter=t.BufferReader=void 0,t.serialize=B,t.deserialize=F,t.getDelayedChannel=$,t.getNextTickChannel=ee,v=qe(v);var d;(function(re){re[re.Promise=100]="Promise",re[re.PromiseCancel=101]="PromiseCancel",re[re.EventListen=102]="EventListen",re[re.EventDispose=103]="EventDispose"})(d||(d={}));function e(re){switch(re){case d.Promise:return"req";case d.PromiseCancel:return"cancel";case d.EventListen:return"subscribe";case d.EventDispose:return"unsubscribe"}}var s;(function(re){re[re.Initialize=200]="Initialize",re[re.PromiseSuccess=201]="PromiseSuccess",re[re.PromiseError=202]="PromiseError",re[re.PromiseErrorObj=203]="PromiseErrorObj",re[re.EventFire=204]="EventFire"})(s||(s={}));function r(re){switch(re){case s.Initialize:return"init";case s.PromiseSuccess:return"reply:";case s.PromiseError:case s.PromiseErrorObj:return"replyErr:";case s.EventFire:return"event:"}}var l;(function(re){re[re.Uninitialized=0]="Uninitialized",re[re.Idle=1]="Idle"})(l||(l={}));function o(re){let ie=0;for(let fe=0;;fe+=7){const ve=re.read(1);if(ie|=(ve.buffer[0]&127)<<fe,!(ve.buffer[0]&128))return ie}}const p=f(0);function A(re,ie){if(ie===0){re.write(p);return}let fe=0;for(let Ne=ie;Ne!==0;Ne=Ne>>>7)fe++;const ve=O.VSBuffer.alloc(fe);for(let Ne=0;ie!==0;Ne++)ve.buffer[Ne]=ie&127,ie=ie>>>7,ie>0&&(ve.buffer[Ne]|=128);re.write(ve)}class L{constructor(ie){this.buffer=ie,this.pos=0}read(ie){const fe=this.buffer.slice(this.pos,this.pos+ie);return this.pos+=fe.byteLength,fe}}t.BufferReader=L;class c{constructor(){this.buffers=[]}get buffer(){return O.VSBuffer.concat(this.buffers)}write(ie){this.buffers.push(ie)}}t.BufferWriter=c;var a;(function(re){re[re.Undefined=0]="Undefined",re[re.String=1]="String",re[re.Buffer=2]="Buffer",re[re.VSBuffer=3]="VSBuffer",re[re.Array=4]="Array",re[re.Object=5]="Object",re[re.Int=6]="Int"})(a||(a={}));function f(re){const ie=O.VSBuffer.alloc(1);return ie.writeUInt8(re,0),ie}const _={Undefined:f(a.Undefined),String:f(a.String),Buffer:f(a.Buffer),VSBuffer:f(a.VSBuffer),Array:f(a.Array),Object:f(a.Object),Uint:f(a.Int)},H=typeof Buffer<"u";function B(re,ie){if(typeof ie>"u")re.write(_.Undefined);else if(typeof ie=="string"){const fe=O.VSBuffer.fromString(ie);re.write(_.String),A(re,fe.byteLength),re.write(fe)}else if(H&&Buffer.isBuffer(ie)){const fe=O.VSBuffer.wrap(ie);re.write(_.Buffer),A(re,fe.byteLength),re.write(fe)}else if(ie instanceof O.VSBuffer)re.write(_.VSBuffer),A(re,ie.byteLength),re.write(ie);else if(Array.isArray(ie)){re.write(_.Array),A(re,ie.length);for(const fe of ie)B(re,fe)}else if(typeof ie=="number"&&(ie|0)===ie)re.write(_.Uint),A(re,ie);else{const fe=O.VSBuffer.fromString(JSON.stringify(ie));re.write(_.Object),A(re,fe.byteLength),re.write(fe)}}function F(re){switch(re.read(1).readUInt8(0)){case a.Undefined:return;case a.String:return re.read(o(re)).toString();case a.Buffer:return re.read(o(re)).buffer;case a.VSBuffer:return re.read(o(re));case a.Array:{const fe=o(re),ve=[];for(let Ne=0;Ne<fe;Ne++)ve.push(F(re));return ve}case a.Object:return JSON.parse(re.read(o(re)).toString());case a.Int:return o(re)}}class E{constructor(ie,fe,ve=null,Ne=1e3){this.protocol=ie,this.ctx=fe,this.logger=ve,this.timeoutDelay=Ne,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(ne=>this.onRawMessage(ne)),this.sendResponse({type:s.Initialize})}registerChannel(ie,fe){this.channels.set(ie,fe),setTimeout(()=>this.flushPendingRequests(ie),0)}sendResponse(ie){switch(ie.type){case s.Initialize:{const fe=this.send([ie.type]);this.logger?.logOutgoing(fe,0,k.OtherSide,r(ie.type));return}case s.PromiseSuccess:case s.PromiseError:case s.EventFire:case s.PromiseErrorObj:{const fe=this.send([ie.type,ie.id],ie.data);this.logger?.logOutgoing(fe,ie.id,k.OtherSide,r(ie.type),ie.data);return}}}send(ie,fe=void 0){const ve=new c;return B(ve,ie),B(ve,fe),this.sendBuffer(ve.buffer)}sendBuffer(ie){try{return this.protocol.send(ie),ie.byteLength}catch{return 0}}onRawMessage(ie){const fe=new L(ie),ve=F(fe),Ne=F(fe),ne=ve[0];switch(ne){case d.Promise:return this.logger?.logIncoming(ie.byteLength,ve[1],k.OtherSide,`${e(ne)}: ${ve[2]}.${ve[3]}`,Ne),this.onPromise({type:ne,id:ve[1],channelName:ve[2],name:ve[3],arg:Ne});case d.EventListen:return this.logger?.logIncoming(ie.byteLength,ve[1],k.OtherSide,`${e(ne)}: ${ve[2]}.${ve[3]}`,Ne),this.onEventListen({type:ne,id:ve[1],channelName:ve[2],name:ve[3],arg:Ne});case d.PromiseCancel:return this.logger?.logIncoming(ie.byteLength,ve[1],k.OtherSide,`${e(ne)}`),this.disposeActiveRequest({type:ne,id:ve[1]});case d.EventDispose:return this.logger?.logIncoming(ie.byteLength,ve[1],k.OtherSide,`${e(ne)}`),this.disposeActiveRequest({type:ne,id:ve[1]})}}onPromise(ie){const fe=this.channels.get(ie.channelName);if(!fe){this.collectPendingRequest(ie);return}const ve=new I.CancellationTokenSource;let Ne;try{Ne=fe.call(this.ctx,ie.name,ie.arg,ve.token)}catch(Le){Ne=Promise.reject(Le)}const ne=ie.id;Ne.then(Le=>{this.sendResponse({id:ne,data:Le,type:s.PromiseSuccess})},Le=>{Le instanceof Error?this.sendResponse({id:ne,data:{message:Le.message,name:Le.name,stack:Le.stack?Le.stack.split(`
`):void 0},type:s.PromiseError}):this.sendResponse({id:ne,data:Le,type:s.PromiseErrorObj})}).finally(()=>{Ee.dispose(),this.activeRequests.delete(ie.id)});const Ee=(0,u.toDisposable)(()=>ve.cancel());this.activeRequests.set(ie.id,Ee)}onEventListen(ie){const fe=this.channels.get(ie.channelName);if(!fe){this.collectPendingRequest(ie);return}const ve=ie.id,ne=fe.listen(this.ctx,ie.name,ie.arg)(Ee=>this.sendResponse({id:ve,data:Ee,type:s.EventFire}));this.activeRequests.set(ie.id,ne)}disposeActiveRequest(ie){const fe=this.activeRequests.get(ie.id);fe&&(fe.dispose(),this.activeRequests.delete(ie.id))}collectPendingRequest(ie){let fe=this.pendingRequests.get(ie.channelName);fe||(fe=[],this.pendingRequests.set(ie.channelName,fe));const ve=setTimeout(()=>{console.error(`Unknown channel: ${ie.channelName}`),ie.type===d.Promise&&this.sendResponse({id:ie.id,data:{name:"Unknown channel",message:`Channel name '${ie.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:s.PromiseError})},this.timeoutDelay);fe.push({request:ie,timeoutTimer:ve})}flushPendingRequests(ie){const fe=this.pendingRequests.get(ie);if(fe){for(const ve of fe)switch(clearTimeout(ve.timeoutTimer),ve.request.type){case d.Promise:this.onPromise(ve.request);break;case d.EventListen:this.onEventListen(ve.request);break}this.pendingRequests.delete(ie)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,u.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}t.ChannelServer=E;var k;(function(re){re[re.LocalSide=0]="LocalSide",re[re.OtherSide=1]="OtherSide"})(k||(t.RequestInitiator=k={}));class W{constructor(ie,fe=null){this.protocol=ie,this.isDisposed=!1,this.state=l.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new w.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(ve=>this.onBuffer(ve)),this.logger=fe}getChannel(ie){const fe=this;return{call(ve,Ne,ne){return fe.isDisposed?Promise.reject(new b.CancellationError):fe.requestPromise(ie,ve,Ne,ne)},listen(ve,Ne){return fe.isDisposed?w.Event.None:fe.requestEvent(ie,ve,Ne)}}}requestPromise(ie,fe,ve,Ne=I.CancellationToken.None){const ne=this.lastRequestId++,Ee=d.Promise,Le={id:ne,type:Ee,channelName:ie,name:fe,arg:ve};if(Ne.isCancellationRequested)return Promise.reject(new b.CancellationError);let Ce;return new Promise((ze,Xe)=>{if(Ne.isCancellationRequested)return Xe(new b.CancellationError);const oe=()=>{const P=G=>{switch(G.type){case s.PromiseSuccess:this.handlers.delete(ne),ze(G.data);break;case s.PromiseError:{this.handlers.delete(ne);const J=new Error(G.data.message);J.stack=Array.isArray(G.data.stack)?G.data.stack.join(`
`):G.data.stack,J.name=G.data.name,Xe(J);break}case s.PromiseErrorObj:this.handlers.delete(ne),Xe(G.data);break}};this.handlers.set(ne,P),this.sendRequest(Le)};let x=null;this.state===l.Idle?oe():(x=(0,n.createCancelablePromise)(P=>this.whenInitialized()),x.then(()=>{x=null,oe()}));const h=()=>{x?(x.cancel(),x=null):this.sendRequest({id:ne,type:d.PromiseCancel}),Xe(new b.CancellationError)},S=Ne.onCancellationRequested(h);Ce=(0,u.combinedDisposable)((0,u.toDisposable)(h),S),this.activeRequests.add(Ce)}).finally(()=>{Ce.dispose(),this.activeRequests.delete(Ce)})}requestEvent(ie,fe,ve){const Ne=this.lastRequestId++,ne=d.EventListen,Ee={id:Ne,type:ne,channelName:ie,name:fe,arg:ve};let Le=null;const Ce=new w.Emitter({onWillAddFirstListener:()=>{Le=(0,n.createCancelablePromise)(ze=>this.whenInitialized()),Le.then(()=>{Le=null,this.activeRequests.add(Ce),this.sendRequest(Ee)})},onDidRemoveLastListener:()=>{Le?(Le.cancel(),Le=null):(this.activeRequests.delete(Ce),this.sendRequest({id:Ne,type:d.EventDispose}))}}),Fe=ze=>Ce.fire(ze.data);return this.handlers.set(Ne,Fe),Ce.event}sendRequest(ie){switch(ie.type){case d.Promise:case d.EventListen:{const fe=this.send([ie.type,ie.id,ie.channelName,ie.name],ie.arg);this.logger?.logOutgoing(fe,ie.id,k.LocalSide,`${e(ie.type)}: ${ie.channelName}.${ie.name}`,ie.arg);return}case d.PromiseCancel:case d.EventDispose:{const fe=this.send([ie.type,ie.id]);this.logger?.logOutgoing(fe,ie.id,k.LocalSide,e(ie.type));return}}}send(ie,fe=void 0){const ve=new c;return B(ve,ie),B(ve,fe),this.sendBuffer(ve.buffer)}sendBuffer(ie){try{return this.protocol.send(ie),ie.byteLength}catch{return 0}}onBuffer(ie){const fe=new L(ie),ve=F(fe),Ne=F(fe),ne=ve[0];switch(ne){case s.Initialize:return this.logger?.logIncoming(ie.byteLength,0,k.LocalSide,r(ne)),this.onResponse({type:ve[0]});case s.PromiseSuccess:case s.PromiseError:case s.EventFire:case s.PromiseErrorObj:return this.logger?.logIncoming(ie.byteLength,ve[1],k.LocalSide,r(ne),Ne),this.onResponse({type:ve[0],id:ve[1],data:Ne})}}onResponse(ie){if(ie.type===s.Initialize){this.state=l.Idle,this._onDidInitialize.fire();return}this.handlers.get(ie.id)?.(ie)}get onDidInitializePromise(){return w.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===l.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,u.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}t.ChannelClient=W,lt([N.memoize],W.prototype,"onDidInitializePromise",null);class R{get connections(){const ie=[];return this._connections.forEach(fe=>ie.push(fe)),ie}constructor(ie,fe,ve){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new w.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new w.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,this.disposables=new u.DisposableStore,this.disposables.add(ie(({protocol:Ne,onDidClientDisconnect:ne})=>{const Ee=w.Event.once(Ne.onMessage);this.disposables.add(Ee(Le=>{const Ce=new L(Le),Fe=F(Ce),ze=new E(Ne,Fe,fe,ve),Xe=new W(Ne,fe);this.channels.forEach((x,h)=>ze.registerChannel(h,x));const oe={channelServer:ze,channelClient:Xe,ctx:Fe};this._connections.add(oe),this._onDidAddConnection.fire(oe),this.disposables.add(ne(()=>{ze.dispose(),Xe.dispose(),this._connections.delete(oe),this._onDidRemoveConnection.fire(oe)}))}))}))}getChannel(ie,fe){const ve=this;return{call(Ne,ne,Ee){let Le;if((0,g.isFunction)(fe)){const Fe=(0,i.getRandomElement)(ve.connections.filter(fe));Le=Fe?Promise.resolve(Fe):w.Event.toPromise(w.Event.filter(ve.onDidAddConnection,fe))}else Le=fe.routeCall(ve,Ne,ne);const Ce=Le.then(Fe=>Fe.channelClient.getChannel(ie));return $(Ce).call(Ne,ne,Ee)},listen(Ne,ne){if((0,g.isFunction)(fe))return ve.getMulticastEvent(ie,fe,Ne,ne);const Ee=fe.routeEvent(ve,Ne,ne).then(Le=>Le.channelClient.getChannel(ie));return $(Ee).listen(Ne,ne)}}}getMulticastEvent(ie,fe,ve,Ne){const ne=this;let Ee;const Le=new w.Emitter({onWillAddFirstListener:()=>{Ee=new u.DisposableStore;const Ce=new w.EventMultiplexer,Fe=new Map,ze=oe=>{const h=oe.channelClient.getChannel(ie).listen(ve,Ne),S=Ce.add(h);Fe.set(oe,S)},Xe=oe=>{const x=Fe.get(oe);x&&(x.dispose(),Fe.delete(oe))};ne.connections.filter(fe).forEach(ze),w.Event.filter(ne.onDidAddConnection,fe)(ze,void 0,Ee),ne.onDidRemoveConnection(Xe,void 0,Ee),Ce.event(Le.fire,Le,Ee),Ee.add(Ce)},onDidRemoveLastListener:()=>{Ee?.dispose(),Ee=void 0}});return Le.event}registerChannel(ie,fe){this.channels.set(ie,fe);for(const ve of this._connections)ve.channelServer.registerChannel(ie,fe)}dispose(){this.disposables.dispose();for(const ie of this._connections)ie.channelClient.dispose(),ie.channelServer.dispose();this._connections.clear(),this.channels.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}t.IPCServer=R;class C{constructor(ie,fe,ve=null){const Ne=new c;B(Ne,fe),ie.send(Ne.buffer),this.channelClient=new W(ie,ve),this.channelServer=new E(ie,fe,ve)}getChannel(ie){return this.channelClient.getChannel(ie)}registerChannel(ie,fe){this.channelServer.registerChannel(ie,fe)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}t.IPCClient=C;function $(re){return{call(ie,fe,ve){return re.then(Ne=>Ne.call(ie,fe,ve))},listen(ie,fe){const ve=new w.Relay;return re.then(Ne=>ve.input=Ne.listen(ie,fe)),ve.event}}}function ee(re){let ie=!1;return{call(fe,ve,Ne){return ie?re.call(fe,ve,Ne):(0,n.timeout)(0).then(()=>ie=!0).then(()=>re.call(fe,ve,Ne))},listen(fe,ve){if(ie)return re.listen(fe,ve);const Ne=new w.Relay;return(0,n.timeout)(0).then(()=>ie=!0).then(()=>Ne.input=re.listen(fe,ve)),Ne.event}}}class Y{constructor(ie){this.fn=ie}routeCall(ie){return this.route(ie)}routeEvent(ie){return this.route(ie)}async route(ie){for(const fe of ie.connections)if(await Promise.resolve(this.fn(fe.ctx)))return Promise.resolve(fe);return await w.Event.toPromise(ie.onDidAddConnection),await this.route(ie)}}t.StaticRouter=Y;var Z;(function(re){function ie(ne,Ee,Le){const Ce=ne,Fe=Le&&Le.disableMarshalling,ze=new Map;for(const Xe in Ce)ve(Xe)&&ze.set(Xe,w.Event.buffer(Ce[Xe],!0,void 0,Ee));return new class{listen(Xe,oe,x){const h=ze.get(oe);if(h)return h;const S=Ce[oe];if(typeof S=="function"){if(Ne(oe))return S.call(Ce,x);if(ve(oe))return ze.set(oe,w.Event.buffer(Ce[oe],!0,void 0,Ee)),ze.get(oe)}throw new b.ErrorNoTelemetry(`Event not found: ${oe}`)}call(Xe,oe,x){const h=Ce[oe];if(typeof h=="function"){if(!Fe&&Array.isArray(x))for(let P=0;P<x.length;P++)x[P]=(0,m.revive)(x[P]);let S=h.apply(Ce,x);return S instanceof Promise||(S=Promise.resolve(S)),S}throw new b.ErrorNoTelemetry(`Method not found: ${oe}`)}}}re.fromService=ie;function fe(ne,Ee){const Le=Ee&&Ee.disableMarshalling;return new Proxy({},{get(Ce,Fe){if(typeof Fe=="string")return Ee?.properties?.has(Fe)?Ee.properties.get(Fe):Ne(Fe)?function(ze){return ne.listen(Fe,ze)}:ve(Fe)?ne.listen(Fe):async function(...ze){let Xe;Ee&&!(0,g.isUndefinedOrNull)(Ee.context)?Xe=[Ee.context,...ze]:Xe=ze;const oe=await ne.call(Fe,Xe);return Le?oe:(0,m.revive)(oe)};throw new b.ErrorNoTelemetry(`Property not found: ${String(Fe)}`)}})}re.toService=fe;function ve(ne){return ne[0]==="o"&&ne[1]==="n"&&v.isUpperAsciiLetter(ne.charCodeAt(2))}function Ne(ne){return/^onDynamic/.test(ne)&&v.isUpperAsciiLetter(ne.charCodeAt(9))}})(Z||(t.ProxyChannel=Z={}));const ce=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function he(re){if(Array.isArray(re))return re;if(re&&typeof re=="object"&&typeof re.toString=="function"){const ie=re.toString();if(ie!=="[object Object]")return ie}return re}function ye(re){return Array.isArray(re)?re.map(he):he(re)}function Re(re,ie,fe,ve,Ne,ne,Ee){Ee=ye(Ee);const Le=ce[Ne],Ce=Le[ve%Le.length];let Fe=[`%c[${re}]%c[${String(ie).padStart(7," ")}]%c[len: ${String(fe).padStart(5," ")}]%c${String(ve).padStart(5," ")} - ${ne}`,"color: darkgreen","color: grey","color: grey",`color: ${Ce}`];/\($/.test(ne)?(Fe=Fe.concat(Ee),Fe.push(")")):Fe.push(Ee),console.log.apply(console,Fe)}class Pe{constructor(ie,fe){this._outgoingPrefix=ie,this._incomingPrefix=fe,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(ie,fe,ve,Ne,ne){this._totalOutgoing+=ie,Re(this._outgoingPrefix,this._totalOutgoing,ie,fe,ve,Ne,ne)}logIncoming(ie,fe,ve,Ne,ne){this._totalIncoming+=ie,Re(this._incomingPrefix,this._totalIncoming,ie,fe,ve,Ne,ne)}}t.IPCLogger=Pe}),define(_e[145],Se([1,0,47,3,84,109,39]),function(ue,t,i,n,O,I,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Client=void 0;class b extends O.IPCClient{static createProtocol(){const u=n.Event.fromNodeEventEmitter(N.ipcRenderer,"vscode:message",(m,v)=>i.VSBuffer.wrap(v));return N.ipcRenderer.send("vscode:hello"),new I.Protocol(N.ipcRenderer,u)}constructor(u){const m=b.createProtocol();super(m,u),this.protocol=m}dispose(){this.protocol.disconnect(),super.dispose()}}t.Client=b}),define(_e[55],Se([1,0]),function(ue,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IInstantiationService=t._util=void 0,t.createDecorator=O,t.refineServiceDecorator=I;var i;(function(N){N.serviceIds=new Map,N.DI_TARGET="$di$target",N.DI_DEPENDENCIES="$di$dependencies";function b(w){return w[N.DI_DEPENDENCIES]||[]}N.getServiceDependencies=b})(i||(t._util=i={})),t.IInstantiationService=O("instantiationService");function n(N,b,w){b[i.DI_TARGET]===b?b[i.DI_DEPENDENCIES].push({id:N,index:w}):(b[i.DI_DEPENDENCIES]=[{id:N,index:w}],b[i.DI_TARGET]=b)}function O(N){if(i.serviceIds.has(N))return i.serviceIds.get(N);const b=function(w,u,m){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");n(b,w,m)};return b.toString=()=>N,i.serviceIds.set(N,b),b}function I(N){return N}}),define(_e[146],Se([1,0,55]),function(ue,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.NullDiagnosticsService=t.IDiagnosticsService=t.ID=void 0,t.isRemoteDiagnosticError=n,t.ID="diagnosticsService",t.IDiagnosticsService=(0,i.createDecorator)(t.ID);function n(I){return!!I.hostName&&!!I.errorMessage}class O{async getPerformanceInfo(N,b){return{}}async getSystemInfo(N,b){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(N,b){return""}async getWorkspaceFileExtensions(N){return{extensions:[]}}async reportWorkspaceStats(N){}}t.NullDiagnosticsService=O}),define(_e[147],Se([1,0,107,29,11,10,16,12,55,5,40,25]),function(ue,t,i,n,O,I,N,b,w,u,m,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ByteSize=t.ETAG_DISABLED=t.FileKind=t.FILES_READONLY_FROM_PERMISSIONS_CONFIG=t.FILES_READONLY_EXCLUDE_CONFIG=t.FILES_READONLY_INCLUDE_CONFIG=t.FILES_EXCLUDE_CONFIG=t.FILES_ASSOCIATIONS_CONFIG=t.HotExitConfiguration=t.AutoSaveConfiguration=t.FileOperationResult=t.NotModifiedSinceFileOperationError=t.TooLargeFileOperationError=t.FileOperationError=t.FileChangesEvent=t.FileChangeType=t.FileOperationEvent=t.FileOperation=t.FileSystemProviderError=t.FileSystemProviderErrorCode=t.FileSystemProviderCapabilities=t.FileChangeFilter=t.FilePermission=t.FileType=t.IFileService=void 0,t.isFileOpenForWriteOptions=g,t.isFileSystemWatcher=r,t.hasReadWriteCapability=o,t.hasFileFolderCopyCapability=p,t.hasFileCloneCapability=A,t.hasOpenReadWriteCloseCapability=L,t.hasFileReadStreamCapability=c,t.hasFileAtomicReadCapability=a,t.hasFileAtomicWriteCapability=f,t.hasFileAtomicDeleteCapability=_,t.hasReadonlyCapability=H,t.createFileSystemProviderError=E,t.ensureFileSystemProviderError=k,t.markAsFileSystemProviderError=W,t.toFileSystemProviderErrorCode=R,t.toFileOperationResult=C,t.isParent=ce,t.etag=ie,t.whenProviderRegistered=fe,t.getLargeFileConfirmationLimit=Ne,t.IFileService=(0,w.createDecorator)("fileService");function g(ne){return ne.create===!0}var d;(function(ne){ne[ne.Unknown=0]="Unknown",ne[ne.File=1]="File",ne[ne.Directory=2]="Directory",ne[ne.SymbolicLink=64]="SymbolicLink"})(d||(t.FileType=d={}));var e;(function(ne){ne[ne.Readonly=1]="Readonly",ne[ne.Locked=2]="Locked"})(e||(t.FilePermission=e={}));var s;(function(ne){ne[ne.UPDATED=2]="UPDATED",ne[ne.ADDED=4]="ADDED",ne[ne.DELETED=8]="DELETED"})(s||(t.FileChangeFilter=s={}));function r(ne){const Ee=ne;return!!Ee&&typeof Ee.onDidChange=="function"}var l;(function(ne){ne[ne.None=0]="None",ne[ne.FileReadWrite=2]="FileReadWrite",ne[ne.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",ne[ne.FileReadStream=16]="FileReadStream",ne[ne.FileFolderCopy=8]="FileFolderCopy",ne[ne.PathCaseSensitive=1024]="PathCaseSensitive",ne[ne.Readonly=2048]="Readonly",ne[ne.Trash=4096]="Trash",ne[ne.FileWriteUnlock=8192]="FileWriteUnlock",ne[ne.FileAtomicRead=16384]="FileAtomicRead",ne[ne.FileAtomicWrite=32768]="FileAtomicWrite",ne[ne.FileAtomicDelete=65536]="FileAtomicDelete",ne[ne.FileClone=131072]="FileClone"})(l||(t.FileSystemProviderCapabilities=l={}));function o(ne){return!!(ne.capabilities&l.FileReadWrite)}function p(ne){return!!(ne.capabilities&l.FileFolderCopy)}function A(ne){return!!(ne.capabilities&l.FileClone)}function L(ne){return!!(ne.capabilities&l.FileOpenReadWriteClose)}function c(ne){return!!(ne.capabilities&l.FileReadStream)}function a(ne){return o(ne)?!!(ne.capabilities&l.FileAtomicRead):!1}function f(ne){return o(ne)?!!(ne.capabilities&l.FileAtomicWrite):!1}function _(ne){return!!(ne.capabilities&l.FileAtomicDelete)}function H(ne){return!!(ne.capabilities&l.Readonly)}var B;(function(ne){ne.FileExists="EntryExists",ne.FileNotFound="EntryNotFound",ne.FileNotADirectory="EntryNotADirectory",ne.FileIsADirectory="EntryIsADirectory",ne.FileExceedsStorageQuota="EntryExceedsStorageQuota",ne.FileTooLarge="EntryTooLarge",ne.FileWriteLocked="EntryWriteLocked",ne.NoPermissions="NoPermissions",ne.Unavailable="Unavailable",ne.Unknown="Unknown"})(B||(t.FileSystemProviderErrorCode=B={}));class F extends Error{static create(Ee,Le){const Ce=new F(Ee.toString(),Le);return W(Ce,Le),Ce}constructor(Ee,Le){super(Ee),this.code=Le}}t.FileSystemProviderError=F;function E(ne,Ee){return F.create(ne,Ee)}function k(ne){return ne||E((0,b.localize)(1865,null),B.Unknown)}function W(ne,Ee){return ne.name=Ee?`${Ee} (FileSystemError)`:"FileSystemError",ne}function R(ne){if(!ne)return B.Unknown;if(ne instanceof F)return ne.code;const Ee=/^(.+) \(FileSystemError\)$/.exec(ne.name);if(!Ee)return B.Unknown;switch(Ee[1]){case B.FileExists:return B.FileExists;case B.FileIsADirectory:return B.FileIsADirectory;case B.FileNotADirectory:return B.FileNotADirectory;case B.FileNotFound:return B.FileNotFound;case B.FileTooLarge:return B.FileTooLarge;case B.FileWriteLocked:return B.FileWriteLocked;case B.NoPermissions:return B.NoPermissions;case B.Unavailable:return B.Unavailable}return B.Unknown}function C(ne){if(ne instanceof he)return ne.fileOperationResult;switch(R(ne)){case B.FileNotFound:return Pe.FILE_NOT_FOUND;case B.FileIsADirectory:return Pe.FILE_IS_DIRECTORY;case B.FileNotADirectory:return Pe.FILE_NOT_DIRECTORY;case B.FileWriteLocked:return Pe.FILE_WRITE_LOCKED;case B.NoPermissions:return Pe.FILE_PERMISSION_DENIED;case B.FileExists:return Pe.FILE_MOVE_CONFLICT;case B.FileTooLarge:return Pe.FILE_TOO_LARGE;default:return Pe.FILE_OTHER_ERROR}}var $;(function(ne){ne[ne.CREATE=0]="CREATE",ne[ne.DELETE=1]="DELETE",ne[ne.MOVE=2]="MOVE",ne[ne.COPY=3]="COPY",ne[ne.WRITE=4]="WRITE"})($||(t.FileOperation=$={}));class ee{constructor(Ee,Le,Ce){this.resource=Ee,this.operation=Le,this.target=Ce}isOperation(Ee){return this.operation===Ee}}t.FileOperationEvent=ee;var Y;(function(ne){ne[ne.UPDATED=0]="UPDATED",ne[ne.ADDED=1]="ADDED",ne[ne.DELETED=2]="DELETED"})(Y||(t.FileChangeType=Y={}));class Z{static{this.MIXED_CORRELATION=null}constructor(Ee,Le){this.ignorePathCasing=Le,this.correlationId=void 0,this.added=new v.Lazy(()=>{const Ce=i.TernarySearchTree.forUris(()=>this.ignorePathCasing);return Ce.fill(this.rawAdded.map(Fe=>[Fe,!0])),Ce}),this.updated=new v.Lazy(()=>{const Ce=i.TernarySearchTree.forUris(()=>this.ignorePathCasing);return Ce.fill(this.rawUpdated.map(Fe=>[Fe,!0])),Ce}),this.deleted=new v.Lazy(()=>{const Ce=i.TernarySearchTree.forUris(()=>this.ignorePathCasing);return Ce.fill(this.rawDeleted.map(Fe=>[Fe,!0])),Ce}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const Ce of Ee){switch(Ce.type){case Y.ADDED:this.rawAdded.push(Ce.resource);break;case Y.UPDATED:this.rawUpdated.push(Ce.resource);break;case Y.DELETED:this.rawDeleted.push(Ce.resource);break}this.correlationId!==Z.MIXED_CORRELATION&&(typeof Ce.cId=="number"?this.correlationId===void 0?this.correlationId=Ce.cId:this.correlationId!==Ce.cId&&(this.correlationId=Z.MIXED_CORRELATION):this.correlationId!==void 0&&(this.correlationId=Z.MIXED_CORRELATION))}}contains(Ee,...Le){return this.doContains(Ee,{includeChildren:!1},...Le)}affects(Ee,...Le){return this.doContains(Ee,{includeChildren:!0},...Le)}doContains(Ee,Le,...Ce){if(!Ee)return!1;const Fe=Ce.length>0;return!!((!Fe||Ce.includes(Y.ADDED))&&(this.added.value.get(Ee)||Le.includeChildren&&this.added.value.findSuperstr(Ee))||(!Fe||Ce.includes(Y.UPDATED))&&(this.updated.value.get(Ee)||Le.includeChildren&&this.updated.value.findSuperstr(Ee))||(!Fe||Ce.includes(Y.DELETED))&&(this.deleted.value.findSubstr(Ee)||Le.includeChildren&&this.deleted.value.findSuperstr(Ee)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(Ee){return this.correlationId===Ee}hasCorrelation(){return typeof this.correlationId=="number"}}t.FileChangesEvent=Z;function ce(ne,Ee,Le){return!ne||!Ee||ne===Ee||Ee.length>ne.length?!1:(Ee.charAt(Ee.length-1)!==n.sep&&(Ee+=n.sep),Le?(0,O.startsWithIgnoreCase)(ne,Ee):ne.indexOf(Ee)===0)}class he extends Error{constructor(Ee,Le,Ce){super(Ee),this.fileOperationResult=Le,this.options=Ce}}t.FileOperationError=he;class ye extends he{constructor(Ee,Le,Ce,Fe){super(Ee,Le,Fe),this.fileOperationResult=Le,this.size=Ce}}t.TooLargeFileOperationError=ye;class Re extends he{constructor(Ee,Le,Ce){super(Ee,Pe.FILE_NOT_MODIFIED_SINCE,Ce),this.stat=Le}}t.NotModifiedSinceFileOperationError=Re;var Pe;(function(ne){ne[ne.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",ne[ne.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",ne[ne.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",ne[ne.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",ne[ne.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",ne[ne.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",ne[ne.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",ne[ne.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",ne[ne.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",ne[ne.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",ne[ne.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(Pe||(t.FileOperationResult=Pe={})),t.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},t.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},t.FILES_ASSOCIATIONS_CONFIG="files.associations",t.FILES_EXCLUDE_CONFIG="files.exclude",t.FILES_READONLY_INCLUDE_CONFIG="files.readonlyInclude",t.FILES_READONLY_EXCLUDE_CONFIG="files.readonlyExclude",t.FILES_READONLY_FROM_PERMISSIONS_CONFIG="files.readonlyFromPermissions";var re;(function(ne){ne[ne.FILE=0]="FILE",ne[ne.FOLDER=1]="FOLDER",ne[ne.ROOT_FOLDER=2]="ROOT_FOLDER"})(re||(t.FileKind=re={})),t.ETAG_DISABLED="";function ie(ne){if(!(typeof ne.size!="number"||typeof ne.mtime!="number"))return ne.mtime.toString(29)+ne.size.toString(31)}async function fe(ne,Ee){if(!Ee.hasProvider(N.URI.from({scheme:ne.scheme})))return new Promise(Le=>{const Ce=Ee.onDidChangeFileSystemProviderRegistrations(Fe=>{Fe.scheme===ne.scheme&&Fe.added&&(Ce.dispose(),Le())})})}class ve{static{this.KB=1024}static{this.MB=ve.KB*ve.KB}static{this.GB=ve.MB*ve.KB}static{this.TB=ve.GB*ve.KB}static formatSize(Ee){return(0,I.isNumber)(Ee)||(Ee=0),Ee<ve.KB?(0,b.localize)(1866,null,Ee.toFixed(0)):Ee<ve.MB?(0,b.localize)(1867,null,(Ee/ve.KB).toFixed(2)):Ee<ve.GB?(0,b.localize)(1868,null,(Ee/ve.MB).toFixed(2)):Ee<ve.TB?(0,b.localize)(1869,null,(Ee/ve.GB).toFixed(2)):(0,b.localize)(1870,null,(Ee/ve.TB).toFixed(2))}}t.ByteSize=ve;function Ne(ne){const Ee=typeof ne=="string"||ne?.scheme===m.Schemas.vscodeRemote;return typeof ne!="string"&&ne?.scheme===m.Schemas.file?1024*ve.MB:Ee?10*ve.MB:u.isWeb?50*ve.MB:1024*ve.MB}}),define(_e[148],Se([1,0,55]),function(ue,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.MainProcessService=t.IMainProcessService=void 0,t.IMainProcessService=(0,i.createDecorator)("mainProcessService");class n{constructor(I,N){this.server=I,this.router=N}getChannel(I){return this.server.getChannel(I,this.router)}registerChannel(I,N){this.server.registerChannel(I,N)}}t.MainProcessService=n}),define(_e[149],Se([1,0,2,145]),function(ue,t,i,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ElectronIPCMainProcessService=void 0;class O extends i.Disposable{constructor(N){super(),this.mainProcessConnection=this._register(new n.Client(`window:${N}`))}getChannel(N){return this.mainProcessConnection.getChannel(N)}registerChannel(N,b){this.mainProcessConnection.registerChannel(N,b)}}t.ElectronIPCMainProcessService=O});var ki=this&&this.__param||function(ue,t){return function(i,n){t(i,n,ue)}};define(_e[150],Se([1,0,84,148]),function(ue,t,i,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.NativeHostService=void 0;let O=class{constructor(N,b){return this.windowId=N,i.ProxyChannel.toService(b.getChannel("nativeHost"),{context:N,properties:(()=>{const w=new Map;return w.set("windowId",N),w})()})}};t.NativeHostService=O,t.NativeHostService=O=lt([ki(1,n.IMainProcessService)],O)}),define(_e[85],Se([1,0,42,10]),function(ue,t,i,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Registry=void 0,i=qe(i),n=qe(n);class O{constructor(){this.data=new Map}add(N,b){i.ok(n.isString(N)),i.ok(n.isObject(b)),i.ok(!this.data.has(N),"There is already an extension with this id"),this.data.set(N,b)}knows(N){return this.data.has(N)}as(N){return this.data.get(N)||null}}t.Registry=new O}),define(_e[151],Se([1,0,3,92,85]),function(ue,t,i,n,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Extensions=void 0,O=qe(O),t.Extensions={JSONContribution:"base.contributions.json"};function I(w){return w.length>0&&w.charAt(w.length-1)==="#"?w.substring(0,w.length-1):w}class N{constructor(){this._onDidChangeSchema=new i.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(u,m){this.schemasById[I(u)]=m,this._onDidChangeSchema.fire(u)}notifySchemaChanged(u){this._onDidChangeSchema.fire(u)}getSchemaContributions(){return{schemas:this.schemasById}}getSchemaContent(u){const m=this.schemasById[u];return m?(0,n.getCompressedContent)(m):void 0}hasSchemaContent(u){return!!this.schemasById[u]}}const b=new N;O.Registry.add(t.Extensions.JSONContribution,b)}),define(_e[152],Se([1,0,13,20,48,21,3,10,16,12,151,85]),function(ue,t,i,n,O,I,N,b,w,u,m,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.spinningLoading=t.syncing=t.gotoNextLocation=t.gotoPreviousLocation=t.widgetClose=t.iconsSchemaId=t.IconFontDefinition=t.IconContribution=t.Extensions=void 0,t.registerIcon=r,t.getIconRegistry=l,v=qe(v),t.Extensions={IconContribution:"base.contributions.icons"};var g;(function(L){function c(a,f){let _=a.defaults;for(;I.ThemeIcon.isThemeIcon(_);){const H=s.getIcon(_.id);if(!H)return;_=H.defaults}return _}L.getDefinition=c})(g||(t.IconContribution=g={}));var d;(function(L){function c(f){return{weight:f.weight,style:f.style,src:f.src.map(_=>({format:_.format,location:_.location.toString()}))}}L.toJSONObject=c;function a(f){const _=H=>(0,b.isString)(H)?H:void 0;if(f&&Array.isArray(f.src)&&f.src.every(H=>(0,b.isString)(H.format)&&(0,b.isString)(H.location)))return{weight:_(f.weight),style:_(f.style),src:f.src.map(H=>({format:H.format,location:w.URI.parse(H.location)}))}}L.fromJSONObject=a})(d||(t.IconFontDefinition=d={}));class e{constructor(){this._onDidChange=new N.Emitter,this.onDidChange=this._onDidChange.event,this.iconSchema={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,u.localize)(2364,null)},fontCharacter:{type:"string",description:(0,u.localize)(2365,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.iconReferenceSchema={type:"string",pattern:`^${I.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.iconsById={},this.iconFontsById={}}registerIcon(c,a,f,_){const H=this.iconsById[c];if(H){if(f&&!H.description){H.description=f,this.iconSchema.properties[c].markdownDescription=`${f} $(${c})`;const E=this.iconReferenceSchema.enum.indexOf(c);E!==-1&&(this.iconReferenceSchema.enumDescriptions[E]=f),this._onDidChange.fire()}return H}const B={id:c,description:f,defaults:a,deprecationMessage:_};this.iconsById[c]=B;const F={$ref:"#/definitions/icons"};return _&&(F.deprecationMessage=_),f&&(F.markdownDescription=`${f}: $(${c})`),this.iconSchema.properties[c]=F,this.iconReferenceSchema.enum.push(c),this.iconReferenceSchema.enumDescriptions.push(f||""),this._onDidChange.fire(),{id:c}}deregisterIcon(c){delete this.iconsById[c],delete this.iconSchema.properties[c];const a=this.iconReferenceSchema.enum.indexOf(c);a!==-1&&(this.iconReferenceSchema.enum.splice(a,1),this.iconReferenceSchema.enumDescriptions.splice(a,1)),this._onDidChange.fire()}getIcons(){return Object.keys(this.iconsById).map(c=>this.iconsById[c])}getIcon(c){return this.iconsById[c]}getIconSchema(){return this.iconSchema}getIconReferenceSchema(){return this.iconReferenceSchema}registerIconFont(c,a){const f=this.iconFontsById[c];return f||(this.iconFontsById[c]=a,this._onDidChange.fire(),a)}deregisterIconFont(c){delete this.iconFontsById[c]}getIconFont(c){return this.iconFontsById[c]}toString(){const c=(H,B)=>H.id.localeCompare(B.id),a=H=>{for(;I.ThemeIcon.isThemeIcon(H.defaults);)H=this.iconsById[H.defaults.id];return`codicon codicon-${H?H.id:""}`},f=[];f.push("| preview     | identifier                        | default codicon ID                | description"),f.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const _=Object.keys(this.iconsById).map(H=>this.iconsById[H]);for(const H of _.filter(B=>!!B.description).sort(c))f.push(`|<i class="${a(H)}"></i>|${H.id}|${I.ThemeIcon.isThemeIcon(H.defaults)?H.defaults.id:H.id}|${H.description||""}|`);f.push("| preview     | identifier                        "),f.push("| ----------- | --------------------------------- |");for(const H of _.filter(B=>!I.ThemeIcon.isThemeIcon(B.defaults)).sort(c))f.push(`|<i class="${a(H)}"></i>|${H.id}|`);return f.join(`
`)}}const s=new e;v.Registry.add(t.Extensions.IconContribution,s);function r(L,c,a,f){return s.registerIcon(L,c,a,f)}function l(){return s}function o(){const L=(0,O.getCodiconFontCharacters)();for(const c in L){const a="\\"+L[c].toString(16);s.registerIcon(c,{fontCharacter:a})}}o(),t.iconsSchemaId="vscode://schemas/icons";const p=v.Registry.as(m.Extensions.JSONContribution);p.registerSchema(t.iconsSchemaId,s.getIconSchema());const A=new i.RunOnceScheduler(()=>p.notifySchemaChanged(t.iconsSchemaId),200);s.onDidChange(()=>{A.isScheduled()||A.schedule()}),t.widgetClose=r("widget-close",n.Codicon.close,(0,u.localize)(2366,null)),t.gotoPreviousLocation=r("goto-previous-location",n.Codicon.arrowUp,(0,u.localize)(2367,null)),t.gotoNextLocation=r("goto-next-location",n.Codicon.arrowDown,(0,u.localize)(2368,null)),t.syncing=I.ThemeIcon.modify(n.Codicon.sync,"spin"),t.spinningLoading=I.ThemeIcon.modify(n.Codicon.loading,"spin")}),define(_e[153],Se([1,0,4,3,2,21,152]),function(ue,t,i,n,O,I,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.UnthemedProductIconTheme=void 0,t.getIconsStyleSheet=b;function b(u){const m=new O.DisposableStore,v=m.add(new n.Emitter),g=(0,N.getIconRegistry)();return m.add(g.onDidChange(()=>v.fire())),u&&m.add(u.onDidProductIconThemeChange(()=>v.fire())),{dispose:()=>m.dispose(),onDidChange:v.event,getCSS(){const d=u?u.getProductIconTheme():new w,e={},s=[],r=[];for(const l of g.getIcons()){const o=d.getIcon(l);if(!o)continue;const p=o.font,A=`--vscode-icon-${l.id}-font-family`,L=`--vscode-icon-${l.id}-content`;p?(e[p.id]=p.definition,r.push(`${A}: ${(0,i.asCSSPropertyValue)(p.id)};`,`${L}: '${o.fontCharacter}';`),s.push(`.codicon-${l.id}:before { content: '${o.fontCharacter}'; font-family: ${(0,i.asCSSPropertyValue)(p.id)}; }`)):(r.push(`${L}: '${o.fontCharacter}'; ${A}: 'codicon';`),s.push(`.codicon-${l.id}:before { content: '${o.fontCharacter}'; }`))}for(const l in e){const o=e[l],p=o.weight?`font-weight: ${o.weight};`:"",A=o.style?`font-style: ${o.style};`:"",L=o.src.map(c=>`${(0,i.asCSSUrl)(c.location)} format('${c.format}')`).join(", ");s.push(`@font-face { src: ${L}; font-family: ${(0,i.asCSSPropertyValue)(l)};${p}${A} font-display: block; }`)}return s.push(`:root { ${r.join(" ")} }`),s.join(`
`)}}}class w{getIcon(m){const v=(0,N.getIconRegistry)();let g=m.defaults;for(;I.ThemeIcon.isThemeIcon(g);){const d=v.getIcon(g.id);if(!d)return;g=d.defaults}return g}}t.UnthemedProductIconTheme=w}),define(_e[154],Se([1,0,5]),function(ue,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DEFAULT_CUSTOM_TITLEBAR_HEIGHT=t.CustomTitleBarVisibility=t.TitlebarStyle=t.TitleBarSetting=t.WindowMinimumSize=void 0,t.isOpenedAuxiliaryWindow=n,t.isWorkspaceToOpen=O,t.isFolderToOpen=I,t.isFileToOpen=N,t.getMenuBarVisibility=b,t.hasCustomTitlebar=v,t.hasNativeTitlebar=g,t.getTitleBarStyle=d,t.useWindowControlsOverlay=e,t.useNativeFullScreen=s,t.zoomLevelToZoomFactor=r,t.WindowMinimumSize={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function n(l){return typeof l.parentId=="number"}function O(l){return!!l.workspaceUri}function I(l){return!!l.folderUri}function N(l){return!!l.fileUri}function b(l){const o=g(l),p=l.getValue("window.menuBarVisibility");return p==="default"||o&&p==="compact"||i.isMacintosh&&i.isNative?"classic":p}var w;(function(l){l.TITLE_BAR_STYLE="window.titleBarStyle",l.CUSTOM_TITLE_BAR_VISIBILITY="window.customTitleBarVisibility"})(w||(t.TitleBarSetting=w={}));var u;(function(l){l.NATIVE="native",l.CUSTOM="custom"})(u||(t.TitlebarStyle=u={}));var m;(function(l){l.AUTO="auto",l.WINDOWED="windowed",l.NEVER="never"})(m||(t.CustomTitleBarVisibility=m={}));function v(l,o){return!0}function g(l,o){return o||(o=d(l)),o===u.NATIVE}function d(l){if(i.isWeb)return u.CUSTOM;const o=l.getValue("window");if(o){if(i.isMacintosh&&o.nativeTabs===!0||i.isMacintosh&&o.nativeFullScreen===!1)return u.NATIVE;const L=o.titleBarStyle;if(L===u.NATIVE||L===u.CUSTOM)return L}return i.isLinux?u.NATIVE:u.CUSTOM}t.DEFAULT_CUSTOM_TITLEBAR_HEIGHT=35;function e(l){if(i.isMacintosh||i.isWeb||g(l))return!1;if(i.isLinux){const o=l.getValue("window.experimentalControlOverlay");if(typeof o=="boolean")return o}return!0}function s(l){const o=l.getValue("window");return!o||typeof o.nativeFullScreen!="boolean"||o.nativeTabs?!0:o.nativeFullScreen!==!1}function r(l=0){return Math.pow(1.2,l)}}),define(_e[155],Se([1,0,18,4,24,39,154]),function(ue,t,i,n,O,I,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.MIN_ZOOM_LEVEL=t.MAX_ZOOM_LEVEL=t.ApplyZoomTarget=void 0,t.applyZoom=w,t.zoomIn=m,t.zoomOut=v;var b;(function(g){g[g.ACTIVE_WINDOW=1]="ACTIVE_WINDOW",g[g.ALL_WINDOWS=2]="ALL_WINDOWS"})(b||(t.ApplyZoomTarget=b={})),t.MAX_ZOOM_LEVEL=8,t.MIN_ZOOM_LEVEL=-8;function w(g,d){g=Math.min(Math.max(g,t.MIN_ZOOM_LEVEL),t.MAX_ZOOM_LEVEL);const e=[];d===b.ACTIVE_WINDOW?e.push((0,n.getActiveWindow)()):d===b.ALL_WINDOWS?e.push(...Array.from((0,n.getWindows)()).map(({window:s})=>s)):e.push(d);for(const s of e)u(s)?.webFrame?.setZoomLevel(g),(0,i.setZoomFactor)((0,N.zoomLevelToZoomFactor)(g),s),(0,i.setZoomLevel)(g,s)}function u(g){if(g===O.mainWindow)return{ipcRenderer:I.ipcRenderer,webFrame:I.webFrame};{const d=g;if(d?.vscode?.ipcRenderer&&d?.vscode?.webFrame)return d.vscode}}function m(g){w((0,i.getZoomLevel)(typeof g=="number"?(0,n.getActiveWindow)():g)+1,g)}function v(g){w((0,i.getZoomLevel)(typeof g=="number"?(0,n.getActiveWindow)():g)-1,g)}}),define(_e[156],Se([1,0,12,4,144,13,110,39,146,147,149,150,153,155,15,8,24,124,114]),function(ue,t,i,n,O,I,N,b,w,u,m,v,g,d,e,s,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.startup=k;const l=/\s--inspect(?:-brk|port)?=(?<port>\d+)?/,o=/\s--inspect-port=(?<port>\d+)/;class p{getHeight(R){return 22}getTemplateId(R){return B(R)?"process":_(R)?"machine":(0,w.isRemoteDiagnosticError)(R)?"error":H(R)?"header":""}}class A{hasChildren(R){return(0,w.isRemoteDiagnosticError)(R)?!1:B(R)?!!R.children?.length:!0}getChildren(R){return B(R)?R.children?R.children:[]:(0,w.isRemoteDiagnosticError)(R)?[]:H(R)?R.processRoots.length>1?R.processRoots:[R.processRoots[0].rootProcess]:_(R)?[R.rootProcess]:[R.processes]}}class L{constructor(){this.templateId="header"}renderTemplate(R){const C=(0,n.append)(R,(0,n.$)(".row")),$=(0,n.append)(C,(0,n.$)(".nameLabel")),ee=(0,n.append)(C,(0,n.$)(".cpu")),Y=(0,n.append)(C,(0,n.$)(".memory")),Z=(0,n.append)(C,(0,n.$)(".pid"));return{name:$,CPU:ee,memory:Y,PID:Z}}renderElement(R,C,$,ee){$.name.textContent=(0,i.localize)(162,null),$.CPU.textContent=(0,i.localize)(163,null),$.PID.textContent=(0,i.localize)(164,null),$.memory.textContent=(0,i.localize)(165,null)}disposeTemplate(R){}}class c{constructor(){this.templateId="machine"}renderTemplate(R){const C=Object.create(null),$=(0,n.append)(R,(0,n.$)(".row"));return C.name=(0,n.append)($,(0,n.$)(".nameLabel")),C}renderElement(R,C,$,ee){$.name.textContent=R.element.name}disposeTemplate(R){}}class a{constructor(){this.templateId="error"}renderTemplate(R){const C=Object.create(null),$=(0,n.append)(R,(0,n.$)(".row"));return C.name=(0,n.append)($,(0,n.$)(".nameLabel")),C}renderElement(R,C,$,ee){$.name.textContent=R.element.errorMessage}disposeTemplate(R){}}class f{constructor(R,C,$){this.platform=R,this.totalMem=C,this.mapPidToName=$,this.templateId="process"}renderTemplate(R){const C=(0,n.append)(R,(0,n.$)(".row")),$=(0,n.append)(C,(0,n.$)(".nameLabel")),ee=(0,n.append)(C,(0,n.$)(".cpu")),Y=(0,n.append)(C,(0,n.$)(".memory")),Z=(0,n.append)(C,(0,n.$)(".pid"));return{name:$,CPU:ee,PID:Z,memory:Y}}renderElement(R,C,$,ee){const{element:Y}=R,Z=Y.pid.toFixed(0);let ce=Y.name;this.mapPidToName.has(Y.pid)&&(ce=this.mapPidToName.get(Y.pid)),$.name.textContent=ce,$.name.title=Y.cmd,$.CPU.textContent=Y.load.toFixed(0),$.PID.textContent=Z,$.PID.parentElement.id=`pid-${Z}`;const he=this.platform==="win32"?Y.mem:this.totalMem*(Y.mem/100);$.memory.textContent=(he/u.ByteSize.MB).toFixed(0)}disposeTemplate(R){}}function _(W){return!!W.name&&!!W.rootProcess}function H(W){return!!W.processRoots}function B(W){return!!W.pid}class F{constructor(R,C){this.data=C,this.mapPidToName=new Map;const $=new m.ElectronIPCMainProcessService(R);this.nativeHostService=new v.NativeHostService(R,$),this.applyStyles(C.styles),this.setEventHandlers(C),b.ipcRenderer.on("vscode:pidToNameResponse",(ee,Y)=>{this.mapPidToName.clear();for(const[Z,ce]of Y)this.mapPidToName.set(Z,ce)}),b.ipcRenderer.on("vscode:listProcessesResponse",async(ee,Y)=>{Y.forEach((Z,ce)=>{B(Z.rootProcess)&&(Z.rootProcess.name=ce===0?`${this.data.applicationName} main`:"remote agent")}),this.tree?(this.tree.setInput({processes:{processRoots:Y}}),this.tree.layout(r.mainWindow.innerHeight,r.mainWindow.innerWidth)):await this.createProcessTree(Y),this.requestProcessList(0)}),this.lastRequestTime=Date.now(),b.ipcRenderer.send("vscode:pidToNameRequest"),b.ipcRenderer.send("vscode:listProcesses")}setEventHandlers(R){r.mainWindow.document.onkeydown=C=>{const $=R.platform==="darwin"?C.metaKey:C.ctrlKey;$&&C.keyCode===87&&(C.stopPropagation(),C.preventDefault(),b.ipcRenderer.send("vscode:closeProcessExplorer")),$&&C.keyCode===187&&(0,d.zoomIn)(r.mainWindow),$&&C.keyCode===189&&(0,d.zoomOut)(r.mainWindow)}}async createProcessTree(R){const C=r.mainWindow.document.getElementById("process-list");if(!C)return;const{totalmem:$}=await this.nativeHostService.getOSStatistics(),ee=[new f(this.data.platform,$,this.mapPidToName),new L,new c,new a];this.tree=new O.DataTree("processExplorer",C,new p,ee,new A,{identityProvider:{getId:Y=>B(Y)?Y.pid.toString():(0,w.isRemoteDiagnosticError)(Y)?Y.hostName:H(Y)?"processes":_(Y)?Y.name:"header"}}),this.tree.setInput({processes:{processRoots:R}}),this.tree.layout(r.mainWindow.innerHeight,r.mainWindow.innerWidth),this.tree.onKeyDown(Y=>{const Z=new e.StandardKeyboardEvent(Y);if(Z.keyCode===s.KeyCode.KeyE&&Z.altKey){const ce=this.getSelectedPids();Promise.all(ce.map(he=>this.nativeHostService.killProcess(he,"SIGTERM"))).then(()=>this.tree?.refresh())}}),this.tree.onContextMenu(Y=>{B(Y.element)&&this.showContextMenu(Y.element,!0)}),C.style.height=`${r.mainWindow.innerHeight}px`,r.mainWindow.addEventListener("resize",()=>{C.style.height=`${r.mainWindow.innerHeight}px`,this.tree?.layout(r.mainWindow.innerHeight,r.mainWindow.innerWidth)})}isDebuggable(R){const C=l.exec(R);return C&&C.groups.port!=="0"||R.indexOf("node ")>=0||R.indexOf("node.exe")>=0}attachTo(R){const C={type:"node",request:"attach",name:`process ${R.pid}`};let $=l.exec(R.cmd);$?C.port=Number($.groups.port):C.processId=String(R.pid),$=o.exec(R.cmd),$&&(C.port=Number($.groups.port)),b.ipcRenderer.send("vscode:workbenchCommand",{id:"debug.startFromConfig",from:"processExplorer",args:[C]})}applyStyles(R){const C=(0,n.createStyleSheet)(),$=[];R.listFocusBackground&&($.push(`.monaco-list:focus .monaco-list-row.focused { background-color: ${R.listFocusBackground}; }`),$.push(`.monaco-list:focus .monaco-list-row.focused:hover { background-color: ${R.listFocusBackground}; }`)),R.listFocusForeground&&$.push(`.monaco-list:focus .monaco-list-row.focused { color: ${R.listFocusForeground}; }`),R.listActiveSelectionBackground&&($.push(`.monaco-list:focus .monaco-list-row.selected { background-color: ${R.listActiveSelectionBackground}; }`),$.push(`.monaco-list:focus .monaco-list-row.selected:hover { background-color: ${R.listActiveSelectionBackground}; }`)),R.listActiveSelectionForeground&&$.push(`.monaco-list:focus .monaco-list-row.selected { color: ${R.listActiveSelectionForeground}; }`),R.listHoverBackground&&$.push(`.monaco-list-row:hover:not(.selected):not(.focused) { background-color: ${R.listHoverBackground}; }`),R.listHoverForeground&&$.push(`.monaco-list-row:hover:not(.selected):not(.focused) { color: ${R.listHoverForeground}; }`),R.listFocusOutline&&$.push(`.monaco-list:focus .monaco-list-row.focused { outline: 1px solid ${R.listFocusOutline}; outline-offset: -1px; }`),R.listHoverOutline&&$.push(`.monaco-list-row:hover { outline: 1px dashed ${R.listHoverOutline}; outline-offset: -1px; }`),R.scrollbarShadowColor&&$.push(`
				.monaco-scrollable-element > .shadow.top {
					box-shadow: ${R.scrollbarShadowColor} 0 6px 6px -6px inset;
				}

				.monaco-scrollable-element > .shadow.left {
					box-shadow: ${R.scrollbarShadowColor} 6px 0 6px -6px inset;
				}

				.monaco-scrollable-element > .shadow.top.left {
					box-shadow: ${R.scrollbarShadowColor} 6px 6px 6px -6px inset;
				}
			`),R.scrollbarSliderBackgroundColor&&$.push(`
				.monaco-scrollable-element > .scrollbar > .slider {
					background: ${R.scrollbarSliderBackgroundColor};
				}
			`),R.scrollbarSliderHoverBackgroundColor&&$.push(`
				.monaco-scrollable-element > .scrollbar > .slider:hover {
					background: ${R.scrollbarSliderHoverBackgroundColor};
				}
			`),R.scrollbarSliderActiveBackgroundColor&&$.push(`
				.monaco-scrollable-element > .scrollbar > .slider.active {
					background: ${R.scrollbarSliderActiveBackgroundColor};
				}
			`),C.textContent=$.join(`
`),R.color&&(r.mainWindow.document.body.style.color=R.color)}showContextMenu(R,C){const $=[],ee=Number(R.pid);C&&($.push({accelerator:"Alt+E",label:(0,i.localize)(166,null),click:()=>{this.nativeHostService.killProcess(ee,"SIGTERM")}}),$.push({label:(0,i.localize)(167,null),click:()=>{this.nativeHostService.killProcess(ee,"SIGKILL")}}),$.push({type:"separator"})),$.push({label:(0,i.localize)(168,null),click:()=>{const Y=this.getSelectedPids();Y?.includes(ee)||(Y.length=0,Y.push(ee));const Z=Y?.map(ce=>r.mainWindow.document.getElementById(`pid-${ce}`)).filter(ce=>!!ce);if(Z){const ce=Z.map(he=>he.innerText).filter(he=>!!he);this.nativeHostService.writeClipboardText(ce.join(`
`))}}}),$.push({label:(0,i.localize)(169,null),click:()=>{const Y=r.mainWindow.document.getElementById("process-list");Y&&this.nativeHostService.writeClipboardText(Y.innerText)}}),R&&C&&this.isDebuggable(R.cmd)&&($.push({type:"separator"}),$.push({label:(0,i.localize)(170,null),click:()=>{this.attachTo(R)}})),(0,N.popup)($)}requestProcessList(R){setTimeout(()=>{const C=Date.now(),$=R+C-this.lastRequestTime;this.lastRequestTime=C,$>1e3?(b.ipcRenderer.send("vscode:pidToNameRequest"),b.ipcRenderer.send("vscode:listProcesses")):this.requestProcessList($)},200)}getSelectedPids(){return this.tree?.getSelection()?.map(R=>{if(!(!R||!("pid"in R)))return R.pid}).filter(R=>!!R)}}function E(){const W=(0,n.createStyleSheet)();W.id="codiconStyles";const R=(0,g.getIconsStyleSheet)(void 0);function C(){W.textContent=R.getCSS()}const $=new I.RunOnceScheduler(C,0);R.onDidChange(()=>$.schedule()),$.schedule()}function k(W){const R=W.data.platform==="win32"?"windows":W.data.platform==="linux"?"linux":"mac";r.mainWindow.document.body.classList.add(R),E(),(0,d.applyZoom)(W.data.zoomLevel,r.mainWindow),new F(W.windowId,W.data)}})}).call(this);

//# sourceMappingURL=https://main.vscode-cdn.net/sourcemaps/532bdf24071d0a26ceea0844dcdf5ee8cfabd562/core/vs/code/electron-sandbox/processExplorer/processExplorerMain.js.map
