/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var pe=["require","exports","vs/base/common/platform","vs/base/common/path","vs/base/common/strings","vs/base/common/extpath","vs/base/common/uri","vs/base/common/charCode","vs/base/common/async","fs","vs/base/common/errors","vs/base/common/lifecycle","vs/base/common/cancellation","vs/nls","vs/base/common/arrays","vs/base/common/lazy","vs/base/common/map","vs/base/common/event","vs/base/common/process","vs/base/common/network","vs/base/common/resources","vs/base/node/pfs","os","vs/base/common/functional","vs/base/common/normalization","vs/base/common/types","vs/nls.messages","vs/platform/environment/node/argv","vs/platform/instantiation/common/instantiation","vs/platform/files/common/files","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/iterator","vs/base/common/linkedList","vs/base/common/marshallingIds","vs/base/common/ports","vs/base/common/stopwatch","vs/base/common/cache","vs/base/common/symbols","vs/base/common/uint","vs/base/common/ternarySearchTree","vs/base/node/ports","vs/base/common/glob","vs/base/node/extpath","vs/base/node/terminalEncoding","child_process","vs/platform/environment/node/argvHelper","vs/platform/environment/node/stdin","vs/platform/environment/node/wait","vs/platform/files/common/watcher","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/product/common/product","vs/platform/profiling/common/profiling","net","util","minimist","assert","vs/code/node/cli","vs/base/node/unc"],be=function(re){for(var e=[],c=0,t=re.length;c<t;c++)e[c]=pe[re[c]];return e};define(pe[30],be([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MonotonousArray=void 0,e.findLast=c,e.findLastIdx=t,e.findLastMonotonous=I,e.findLastIdxMonotonous=S,e.findFirstMonotonous=Y,e.findFirstIdxMonotonousOrArrLen=U,e.findFirstIdxMonotonous=O,e.findFirstMax=B,e.findLastMax=M,e.findFirstMin=T,e.findMaxIdx=C,e.mapFindFirst=u;function c(r,a){const _=t(r,a);if(_!==-1)return r[_]}function t(r,a,_=r.length-1){for(let L=_;L>=0;L--){const b=r[L];if(a(b))return L}return-1}function I(r,a){const _=S(r,a);return _===-1?void 0:r[_]}function S(r,a,_=0,L=r.length){let b=_,k=L;for(;b<k;){const D=Math.floor((b+k)/2);a(r[D])?b=D+1:k=D}return b-1}function Y(r,a){const _=U(r,a);return _===r.length?void 0:r[_]}function U(r,a,_=0,L=r.length){let b=_,k=L;for(;b<k;){const D=Math.floor((b+k)/2);a(r[D])?k=D:b=D+1}return b}function O(r,a,_=0,L=r.length){const b=U(r,a,_,L);return b===r.length?-1:b}class R{static{this.assertInvariants=!1}constructor(a){this._array=a,this._findLastMonotonousLastIdx=0}findLastMonotonous(a){if(R.assertInvariants){if(this._prevFindLastPredicate){for(const L of this._array)if(this._prevFindLastPredicate(L)&&!a(L))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this._prevFindLastPredicate=a}const _=S(this._array,a,this._findLastMonotonousLastIdx);return this._findLastMonotonousLastIdx=_+1,_===-1?void 0:this._array[_]}}e.MonotonousArray=R;function B(r,a){if(r.length===0)return;let _=r[0];for(let L=1;L<r.length;L++){const b=r[L];a(b,_)>0&&(_=b)}return _}function M(r,a){if(r.length===0)return;let _=r[0];for(let L=1;L<r.length;L++){const b=r[L];a(b,_)>=0&&(_=b)}return _}function T(r,a){return B(r,(_,L)=>-a(_,L))}function C(r,a){if(r.length===0)return-1;let _=0;for(let L=1;L<r.length;L++){const b=r[L];a(b,r[_])>0&&(_=L)}return _}function u(r,a){for(const _ of r){const L=a(_);if(L!==void 0)return L}}}),define(pe[7],be([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharCode=void 0;var c;(function(t){t[t.Null=0]="Null",t[t.Backspace=8]="Backspace",t[t.Tab=9]="Tab",t[t.LineFeed=10]="LineFeed",t[t.CarriageReturn=13]="CarriageReturn",t[t.Space=32]="Space",t[t.ExclamationMark=33]="ExclamationMark",t[t.DoubleQuote=34]="DoubleQuote",t[t.Hash=35]="Hash",t[t.DollarSign=36]="DollarSign",t[t.PercentSign=37]="PercentSign",t[t.Ampersand=38]="Ampersand",t[t.SingleQuote=39]="SingleQuote",t[t.OpenParen=40]="OpenParen",t[t.CloseParen=41]="CloseParen",t[t.Asterisk=42]="Asterisk",t[t.Plus=43]="Plus",t[t.Comma=44]="Comma",t[t.Dash=45]="Dash",t[t.Period=46]="Period",t[t.Slash=47]="Slash",t[t.Digit0=48]="Digit0",t[t.Digit1=49]="Digit1",t[t.Digit2=50]="Digit2",t[t.Digit3=51]="Digit3",t[t.Digit4=52]="Digit4",t[t.Digit5=53]="Digit5",t[t.Digit6=54]="Digit6",t[t.Digit7=55]="Digit7",t[t.Digit8=56]="Digit8",t[t.Digit9=57]="Digit9",t[t.Colon=58]="Colon",t[t.Semicolon=59]="Semicolon",t[t.LessThan=60]="LessThan",t[t.Equals=61]="Equals",t[t.GreaterThan=62]="GreaterThan",t[t.QuestionMark=63]="QuestionMark",t[t.AtSign=64]="AtSign",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.OpenSquareBracket=91]="OpenSquareBracket",t[t.Backslash=92]="Backslash",t[t.CloseSquareBracket=93]="CloseSquareBracket",t[t.Caret=94]="Caret",t[t.Underline=95]="Underline",t[t.BackTick=96]="BackTick",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.OpenCurlyBrace=123]="OpenCurlyBrace",t[t.Pipe=124]="Pipe",t[t.CloseCurlyBrace=125]="CloseCurlyBrace",t[t.Tilde=126]="Tilde",t[t.NoBreakSpace=160]="NoBreakSpace",t[t.U_Combining_Grave_Accent=768]="U_Combining_Grave_Accent",t[t.U_Combining_Acute_Accent=769]="U_Combining_Acute_Accent",t[t.U_Combining_Circumflex_Accent=770]="U_Combining_Circumflex_Accent",t[t.U_Combining_Tilde=771]="U_Combining_Tilde",t[t.U_Combining_Macron=772]="U_Combining_Macron",t[t.U_Combining_Overline=773]="U_Combining_Overline",t[t.U_Combining_Breve=774]="U_Combining_Breve",t[t.U_Combining_Dot_Above=775]="U_Combining_Dot_Above",t[t.U_Combining_Diaeresis=776]="U_Combining_Diaeresis",t[t.U_Combining_Hook_Above=777]="U_Combining_Hook_Above",t[t.U_Combining_Ring_Above=778]="U_Combining_Ring_Above",t[t.U_Combining_Double_Acute_Accent=779]="U_Combining_Double_Acute_Accent",t[t.U_Combining_Caron=780]="U_Combining_Caron",t[t.U_Combining_Vertical_Line_Above=781]="U_Combining_Vertical_Line_Above",t[t.U_Combining_Double_Vertical_Line_Above=782]="U_Combining_Double_Vertical_Line_Above",t[t.U_Combining_Double_Grave_Accent=783]="U_Combining_Double_Grave_Accent",t[t.U_Combining_Candrabindu=784]="U_Combining_Candrabindu",t[t.U_Combining_Inverted_Breve=785]="U_Combining_Inverted_Breve",t[t.U_Combining_Turned_Comma_Above=786]="U_Combining_Turned_Comma_Above",t[t.U_Combining_Comma_Above=787]="U_Combining_Comma_Above",t[t.U_Combining_Reversed_Comma_Above=788]="U_Combining_Reversed_Comma_Above",t[t.U_Combining_Comma_Above_Right=789]="U_Combining_Comma_Above_Right",t[t.U_Combining_Grave_Accent_Below=790]="U_Combining_Grave_Accent_Below",t[t.U_Combining_Acute_Accent_Below=791]="U_Combining_Acute_Accent_Below",t[t.U_Combining_Left_Tack_Below=792]="U_Combining_Left_Tack_Below",t[t.U_Combining_Right_Tack_Below=793]="U_Combining_Right_Tack_Below",t[t.U_Combining_Left_Angle_Above=794]="U_Combining_Left_Angle_Above",t[t.U_Combining_Horn=795]="U_Combining_Horn",t[t.U_Combining_Left_Half_Ring_Below=796]="U_Combining_Left_Half_Ring_Below",t[t.U_Combining_Up_Tack_Below=797]="U_Combining_Up_Tack_Below",t[t.U_Combining_Down_Tack_Below=798]="U_Combining_Down_Tack_Below",t[t.U_Combining_Plus_Sign_Below=799]="U_Combining_Plus_Sign_Below",t[t.U_Combining_Minus_Sign_Below=800]="U_Combining_Minus_Sign_Below",t[t.U_Combining_Palatalized_Hook_Below=801]="U_Combining_Palatalized_Hook_Below",t[t.U_Combining_Retroflex_Hook_Below=802]="U_Combining_Retroflex_Hook_Below",t[t.U_Combining_Dot_Below=803]="U_Combining_Dot_Below",t[t.U_Combining_Diaeresis_Below=804]="U_Combining_Diaeresis_Below",t[t.U_Combining_Ring_Below=805]="U_Combining_Ring_Below",t[t.U_Combining_Comma_Below=806]="U_Combining_Comma_Below",t[t.U_Combining_Cedilla=807]="U_Combining_Cedilla",t[t.U_Combining_Ogonek=808]="U_Combining_Ogonek",t[t.U_Combining_Vertical_Line_Below=809]="U_Combining_Vertical_Line_Below",t[t.U_Combining_Bridge_Below=810]="U_Combining_Bridge_Below",t[t.U_Combining_Inverted_Double_Arch_Below=811]="U_Combining_Inverted_Double_Arch_Below",t[t.U_Combining_Caron_Below=812]="U_Combining_Caron_Below",t[t.U_Combining_Circumflex_Accent_Below=813]="U_Combining_Circumflex_Accent_Below",t[t.U_Combining_Breve_Below=814]="U_Combining_Breve_Below",t[t.U_Combining_Inverted_Breve_Below=815]="U_Combining_Inverted_Breve_Below",t[t.U_Combining_Tilde_Below=816]="U_Combining_Tilde_Below",t[t.U_Combining_Macron_Below=817]="U_Combining_Macron_Below",t[t.U_Combining_Low_Line=818]="U_Combining_Low_Line",t[t.U_Combining_Double_Low_Line=819]="U_Combining_Double_Low_Line",t[t.U_Combining_Tilde_Overlay=820]="U_Combining_Tilde_Overlay",t[t.U_Combining_Short_Stroke_Overlay=821]="U_Combining_Short_Stroke_Overlay",t[t.U_Combining_Long_Stroke_Overlay=822]="U_Combining_Long_Stroke_Overlay",t[t.U_Combining_Short_Solidus_Overlay=823]="U_Combining_Short_Solidus_Overlay",t[t.U_Combining_Long_Solidus_Overlay=824]="U_Combining_Long_Solidus_Overlay",t[t.U_Combining_Right_Half_Ring_Below=825]="U_Combining_Right_Half_Ring_Below",t[t.U_Combining_Inverted_Bridge_Below=826]="U_Combining_Inverted_Bridge_Below",t[t.U_Combining_Square_Below=827]="U_Combining_Square_Below",t[t.U_Combining_Seagull_Below=828]="U_Combining_Seagull_Below",t[t.U_Combining_X_Above=829]="U_Combining_X_Above",t[t.U_Combining_Vertical_Tilde=830]="U_Combining_Vertical_Tilde",t[t.U_Combining_Double_Overline=831]="U_Combining_Double_Overline",t[t.U_Combining_Grave_Tone_Mark=832]="U_Combining_Grave_Tone_Mark",t[t.U_Combining_Acute_Tone_Mark=833]="U_Combining_Acute_Tone_Mark",t[t.U_Combining_Greek_Perispomeni=834]="U_Combining_Greek_Perispomeni",t[t.U_Combining_Greek_Koronis=835]="U_Combining_Greek_Koronis",t[t.U_Combining_Greek_Dialytika_Tonos=836]="U_Combining_Greek_Dialytika_Tonos",t[t.U_Combining_Greek_Ypogegrammeni=837]="U_Combining_Greek_Ypogegrammeni",t[t.U_Combining_Bridge_Above=838]="U_Combining_Bridge_Above",t[t.U_Combining_Equals_Sign_Below=839]="U_Combining_Equals_Sign_Below",t[t.U_Combining_Double_Vertical_Line_Below=840]="U_Combining_Double_Vertical_Line_Below",t[t.U_Combining_Left_Angle_Below=841]="U_Combining_Left_Angle_Below",t[t.U_Combining_Not_Tilde_Above=842]="U_Combining_Not_Tilde_Above",t[t.U_Combining_Homothetic_Above=843]="U_Combining_Homothetic_Above",t[t.U_Combining_Almost_Equal_To_Above=844]="U_Combining_Almost_Equal_To_Above",t[t.U_Combining_Left_Right_Arrow_Below=845]="U_Combining_Left_Right_Arrow_Below",t[t.U_Combining_Upwards_Arrow_Below=846]="U_Combining_Upwards_Arrow_Below",t[t.U_Combining_Grapheme_Joiner=847]="U_Combining_Grapheme_Joiner",t[t.U_Combining_Right_Arrowhead_Above=848]="U_Combining_Right_Arrowhead_Above",t[t.U_Combining_Left_Half_Ring_Above=849]="U_Combining_Left_Half_Ring_Above",t[t.U_Combining_Fermata=850]="U_Combining_Fermata",t[t.U_Combining_X_Below=851]="U_Combining_X_Below",t[t.U_Combining_Left_Arrowhead_Below=852]="U_Combining_Left_Arrowhead_Below",t[t.U_Combining_Right_Arrowhead_Below=853]="U_Combining_Right_Arrowhead_Below",t[t.U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below=854]="U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below",t[t.U_Combining_Right_Half_Ring_Above=855]="U_Combining_Right_Half_Ring_Above",t[t.U_Combining_Dot_Above_Right=856]="U_Combining_Dot_Above_Right",t[t.U_Combining_Asterisk_Below=857]="U_Combining_Asterisk_Below",t[t.U_Combining_Double_Ring_Below=858]="U_Combining_Double_Ring_Below",t[t.U_Combining_Zigzag_Above=859]="U_Combining_Zigzag_Above",t[t.U_Combining_Double_Breve_Below=860]="U_Combining_Double_Breve_Below",t[t.U_Combining_Double_Breve=861]="U_Combining_Double_Breve",t[t.U_Combining_Double_Macron=862]="U_Combining_Double_Macron",t[t.U_Combining_Double_Macron_Below=863]="U_Combining_Double_Macron_Below",t[t.U_Combining_Double_Tilde=864]="U_Combining_Double_Tilde",t[t.U_Combining_Double_Inverted_Breve=865]="U_Combining_Double_Inverted_Breve",t[t.U_Combining_Double_Rightwards_Arrow_Below=866]="U_Combining_Double_Rightwards_Arrow_Below",t[t.U_Combining_Latin_Small_Letter_A=867]="U_Combining_Latin_Small_Letter_A",t[t.U_Combining_Latin_Small_Letter_E=868]="U_Combining_Latin_Small_Letter_E",t[t.U_Combining_Latin_Small_Letter_I=869]="U_Combining_Latin_Small_Letter_I",t[t.U_Combining_Latin_Small_Letter_O=870]="U_Combining_Latin_Small_Letter_O",t[t.U_Combining_Latin_Small_Letter_U=871]="U_Combining_Latin_Small_Letter_U",t[t.U_Combining_Latin_Small_Letter_C=872]="U_Combining_Latin_Small_Letter_C",t[t.U_Combining_Latin_Small_Letter_D=873]="U_Combining_Latin_Small_Letter_D",t[t.U_Combining_Latin_Small_Letter_H=874]="U_Combining_Latin_Small_Letter_H",t[t.U_Combining_Latin_Small_Letter_M=875]="U_Combining_Latin_Small_Letter_M",t[t.U_Combining_Latin_Small_Letter_R=876]="U_Combining_Latin_Small_Letter_R",t[t.U_Combining_Latin_Small_Letter_T=877]="U_Combining_Latin_Small_Letter_T",t[t.U_Combining_Latin_Small_Letter_V=878]="U_Combining_Latin_Small_Letter_V",t[t.U_Combining_Latin_Small_Letter_X=879]="U_Combining_Latin_Small_Letter_X",t[t.LINE_SEPARATOR=8232]="LINE_SEPARATOR",t[t.PARAGRAPH_SEPARATOR=8233]="PARAGRAPH_SEPARATOR",t[t.NEXT_LINE=133]="NEXT_LINE",t[t.U_CIRCUMFLEX=94]="U_CIRCUMFLEX",t[t.U_GRAVE_ACCENT=96]="U_GRAVE_ACCENT",t[t.U_DIAERESIS=168]="U_DIAERESIS",t[t.U_MACRON=175]="U_MACRON",t[t.U_ACUTE_ACCENT=180]="U_ACUTE_ACCENT",t[t.U_CEDILLA=184]="U_CEDILLA",t[t.U_MODIFIER_LETTER_LEFT_ARROWHEAD=706]="U_MODIFIER_LETTER_LEFT_ARROWHEAD",t[t.U_MODIFIER_LETTER_RIGHT_ARROWHEAD=707]="U_MODIFIER_LETTER_RIGHT_ARROWHEAD",t[t.U_MODIFIER_LETTER_UP_ARROWHEAD=708]="U_MODIFIER_LETTER_UP_ARROWHEAD",t[t.U_MODIFIER_LETTER_DOWN_ARROWHEAD=709]="U_MODIFIER_LETTER_DOWN_ARROWHEAD",t[t.U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING=722]="U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING",t[t.U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING=723]="U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING",t[t.U_MODIFIER_LETTER_UP_TACK=724]="U_MODIFIER_LETTER_UP_TACK",t[t.U_MODIFIER_LETTER_DOWN_TACK=725]="U_MODIFIER_LETTER_DOWN_TACK",t[t.U_MODIFIER_LETTER_PLUS_SIGN=726]="U_MODIFIER_LETTER_PLUS_SIGN",t[t.U_MODIFIER_LETTER_MINUS_SIGN=727]="U_MODIFIER_LETTER_MINUS_SIGN",t[t.U_BREVE=728]="U_BREVE",t[t.U_DOT_ABOVE=729]="U_DOT_ABOVE",t[t.U_RING_ABOVE=730]="U_RING_ABOVE",t[t.U_OGONEK=731]="U_OGONEK",t[t.U_SMALL_TILDE=732]="U_SMALL_TILDE",t[t.U_DOUBLE_ACUTE_ACCENT=733]="U_DOUBLE_ACUTE_ACCENT",t[t.U_MODIFIER_LETTER_RHOTIC_HOOK=734]="U_MODIFIER_LETTER_RHOTIC_HOOK",t[t.U_MODIFIER_LETTER_CROSS_ACCENT=735]="U_MODIFIER_LETTER_CROSS_ACCENT",t[t.U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR=741]="U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR",t[t.U_MODIFIER_LETTER_HIGH_TONE_BAR=742]="U_MODIFIER_LETTER_HIGH_TONE_BAR",t[t.U_MODIFIER_LETTER_MID_TONE_BAR=743]="U_MODIFIER_LETTER_MID_TONE_BAR",t[t.U_MODIFIER_LETTER_LOW_TONE_BAR=744]="U_MODIFIER_LETTER_LOW_TONE_BAR",t[t.U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR=745]="U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR",t[t.U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK=746]="U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK",t[t.U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK=747]="U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK",t[t.U_MODIFIER_LETTER_UNASPIRATED=749]="U_MODIFIER_LETTER_UNASPIRATED",t[t.U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD=751]="U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD",t[t.U_MODIFIER_LETTER_LOW_UP_ARROWHEAD=752]="U_MODIFIER_LETTER_LOW_UP_ARROWHEAD",t[t.U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD=753]="U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD",t[t.U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD=754]="U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD",t[t.U_MODIFIER_LETTER_LOW_RING=755]="U_MODIFIER_LETTER_LOW_RING",t[t.U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT=756]="U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT",t[t.U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT=757]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT",t[t.U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT=758]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT",t[t.U_MODIFIER_LETTER_LOW_TILDE=759]="U_MODIFIER_LETTER_LOW_TILDE",t[t.U_MODIFIER_LETTER_RAISED_COLON=760]="U_MODIFIER_LETTER_RAISED_COLON",t[t.U_MODIFIER_LETTER_BEGIN_HIGH_TONE=761]="U_MODIFIER_LETTER_BEGIN_HIGH_TONE",t[t.U_MODIFIER_LETTER_END_HIGH_TONE=762]="U_MODIFIER_LETTER_END_HIGH_TONE",t[t.U_MODIFIER_LETTER_BEGIN_LOW_TONE=763]="U_MODIFIER_LETTER_BEGIN_LOW_TONE",t[t.U_MODIFIER_LETTER_END_LOW_TONE=764]="U_MODIFIER_LETTER_END_LOW_TONE",t[t.U_MODIFIER_LETTER_SHELF=765]="U_MODIFIER_LETTER_SHELF",t[t.U_MODIFIER_LETTER_OPEN_SHELF=766]="U_MODIFIER_LETTER_OPEN_SHELF",t[t.U_MODIFIER_LETTER_LOW_LEFT_ARROW=767]="U_MODIFIER_LETTER_LOW_LEFT_ARROW",t[t.U_GREEK_LOWER_NUMERAL_SIGN=885]="U_GREEK_LOWER_NUMERAL_SIGN",t[t.U_GREEK_TONOS=900]="U_GREEK_TONOS",t[t.U_GREEK_DIALYTIKA_TONOS=901]="U_GREEK_DIALYTIKA_TONOS",t[t.U_GREEK_KORONIS=8125]="U_GREEK_KORONIS",t[t.U_GREEK_PSILI=8127]="U_GREEK_PSILI",t[t.U_GREEK_PERISPOMENI=8128]="U_GREEK_PERISPOMENI",t[t.U_GREEK_DIALYTIKA_AND_PERISPOMENI=8129]="U_GREEK_DIALYTIKA_AND_PERISPOMENI",t[t.U_GREEK_PSILI_AND_VARIA=8141]="U_GREEK_PSILI_AND_VARIA",t[t.U_GREEK_PSILI_AND_OXIA=8142]="U_GREEK_PSILI_AND_OXIA",t[t.U_GREEK_PSILI_AND_PERISPOMENI=8143]="U_GREEK_PSILI_AND_PERISPOMENI",t[t.U_GREEK_DASIA_AND_VARIA=8157]="U_GREEK_DASIA_AND_VARIA",t[t.U_GREEK_DASIA_AND_OXIA=8158]="U_GREEK_DASIA_AND_OXIA",t[t.U_GREEK_DASIA_AND_PERISPOMENI=8159]="U_GREEK_DASIA_AND_PERISPOMENI",t[t.U_GREEK_DIALYTIKA_AND_VARIA=8173]="U_GREEK_DIALYTIKA_AND_VARIA",t[t.U_GREEK_DIALYTIKA_AND_OXIA=8174]="U_GREEK_DIALYTIKA_AND_OXIA",t[t.U_GREEK_VARIA=8175]="U_GREEK_VARIA",t[t.U_GREEK_OXIA=8189]="U_GREEK_OXIA",t[t.U_GREEK_DASIA=8190]="U_GREEK_DASIA",t[t.U_IDEOGRAPHIC_FULL_STOP=12290]="U_IDEOGRAPHIC_FULL_STOP",t[t.U_LEFT_CORNER_BRACKET=12300]="U_LEFT_CORNER_BRACKET",t[t.U_RIGHT_CORNER_BRACKET=12301]="U_RIGHT_CORNER_BRACKET",t[t.U_LEFT_BLACK_LENTICULAR_BRACKET=12304]="U_LEFT_BLACK_LENTICULAR_BRACKET",t[t.U_RIGHT_BLACK_LENTICULAR_BRACKET=12305]="U_RIGHT_BLACK_LENTICULAR_BRACKET",t[t.U_OVERLINE=8254]="U_OVERLINE",t[t.UTF8_BOM=65279]="UTF8_BOM",t[t.U_FULLWIDTH_SEMICOLON=65307]="U_FULLWIDTH_SEMICOLON",t[t.U_FULLWIDTH_COMMA=65292]="U_FULLWIDTH_COMMA"})(c||(e.CharCode=c={}))}),define(pe[31],be([0,1]),function(re,e){"use strict";var c;Object.defineProperty(e,"__esModule",{value:!0}),e.SetWithKey=void 0,e.groupBy=t,e.diffSets=I,e.diffMaps=S,e.intersection=Y;function t(O,R){const B=Object.create(null);for(const M of O){const T=R(M);let C=B[T];C||(C=B[T]=[]),C.push(M)}return B}function I(O,R){const B=[],M=[];for(const T of O)R.has(T)||B.push(T);for(const T of R)O.has(T)||M.push(T);return{removed:B,added:M}}function S(O,R){const B=[],M=[];for(const[T,C]of O)R.has(T)||B.push(C);for(const[T,C]of R)O.has(T)||M.push(C);return{removed:B,added:M}}function Y(O,R){const B=new Set;for(const M of R)O.has(M)&&B.add(M);return B}class U{static{c=Symbol.toStringTag}constructor(R,B){this.toKey=B,this._map=new Map,this[c]="SetWithKey";for(const M of R)this.add(M)}get size(){return this._map.size}add(R){const B=this.toKey(R);return this._map.set(B,R),this}delete(R){return this._map.delete(this.toKey(R))}has(R){return this._map.has(this.toKey(R))}*entries(){for(const R of this._map.values())yield[R,R]}keys(){return this.values()}*values(){for(const R of this._map.values())yield R}clear(){this._map.clear()}forEach(R,B){this._map.forEach(M=>R.call(B,M,M,this))}[Symbol.iterator](){return this.values()}}e.SetWithKey=U}),define(pe[10],be([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.ReadonlyError=e.CancellationError=e.errorHandler=e.ErrorHandler=void 0,e.setUnexpectedErrorHandler=t,e.isSigPipeError=I,e.onUnexpectedError=S,e.onUnexpectedExternalError=Y,e.transformErrorForSerialization=U,e.transformErrorFromSerialization=O,e.isCancellationError=B,e.canceled=T,e.illegalArgument=C,e.illegalState=u,e.getErrorMessage=a;class c{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(i){setTimeout(()=>{throw i.stack?k.isErrorNoTelemetry(i)?new k(i.message+`

`+i.stack):new Error(i.message+`

`+i.stack):i},0)}}addListener(i){return this.listeners.push(i),()=>{this._removeListener(i)}}emit(i){this.listeners.forEach(s=>{s(i)})}_removeListener(i){this.listeners.splice(this.listeners.indexOf(i),1)}setUnexpectedErrorHandler(i){this.unexpectedErrorHandler=i}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(i){this.unexpectedErrorHandler(i),this.emit(i)}onUnexpectedExternalError(i){this.unexpectedErrorHandler(i)}}e.ErrorHandler=c,e.errorHandler=new c;function t(n){e.errorHandler.setUnexpectedErrorHandler(n)}function I(n){if(!n||typeof n!="object")return!1;const i=n;return i.code==="EPIPE"&&i.syscall?.toUpperCase()==="WRITE"}function S(n){B(n)||e.errorHandler.onUnexpectedError(n)}function Y(n){B(n)||e.errorHandler.onUnexpectedExternalError(n)}function U(n){if(n instanceof Error){const{name:i,message:s}=n,g=n.stacktrace||n.stack;return{$isError:!0,name:i,message:s,stack:g,noTelemetry:k.isErrorNoTelemetry(n)}}return n}function O(n){let i;return n.noTelemetry?i=new k:(i=new Error,i.name=n.name),i.message=n.message,i.stack=n.stack,i}const R="Canceled";function B(n){return n instanceof M?!0:n instanceof Error&&n.name===R&&n.message===R}class M extends Error{constructor(){super(R),this.name=this.message}}e.CancellationError=M;function T(){const n=new Error(R);return n.name=n.message,n}function C(n){return n?new Error(`Illegal argument: ${n}`):new Error("Illegal argument")}function u(n){return n?new Error(`Illegal state: ${n}`):new Error("Illegal state")}class r extends TypeError{constructor(i){super(i?`${i} is read-only and cannot be changed`:"Cannot change read-only property")}}e.ReadonlyError=r;function a(n){return n?n.message?n.message:n.stack?n.stack.split(`
`)[0]:String(n):"Error"}class _ extends Error{constructor(i){super("NotImplemented"),i&&(this.message=i)}}e.NotImplementedError=_;class L extends Error{constructor(i){super("NotSupported"),i&&(this.message=i)}}e.NotSupportedError=L;class b extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.ExpectedError=b;class k extends Error{constructor(i){super(i),this.name="CodeExpectedError"}static fromError(i){if(i instanceof k)return i;const s=new k;return s.message=i.message,s.stack=i.stack,s}static isErrorNoTelemetry(i){return i.name==="CodeExpectedError"}}e.ErrorNoTelemetry=k;class D extends Error{constructor(i){super(i||"An unexpected bug occurred."),Object.setPrototypeOf(this,D.prototype)}}e.BugIndicatingError=D}),define(pe[14],be([0,1,10,30]),function(re,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Permutation=e.CallbackIterable=e.ArrayQueue=e.booleanComparator=e.numberComparator=e.CompareResult=void 0,e.tail=I,e.tail2=S,e.equals=Y,e.removeFastWithoutKeepingOrder=U,e.binarySearch=O,e.binarySearch2=R,e.quickSelect=B,e.groupBy=M,e.groupAdjacentBy=T,e.forEachAdjacent=C,e.forEachWithNeighbors=u,e.sortedDiff=r,e.delta=a,e.top=_,e.topAsync=L,e.coalesce=k,e.coalesceInPlace=D,e.move=n,e.isFalsyOrEmpty=i,e.isNonEmptyArray=s,e.distinct=g,e.uniqueFilter=N,e.firstOrDefault=h,e.lastOrDefault=m,e.commonPrefixLength=l,e.range=f,e.index=y,e.insert=A,e.remove=p,e.arrayInsert=j,e.shuffle=x,e.pushToStart=J,e.pushToEnd=G,e.pushMany=le,e.mapArrayOrNot=W,e.asArray=K,e.getRandomElement=Z,e.insertInto=ee,e.splice=q,e.compareBy=te,e.tieBreakComparators=ue,e.reverseOrder=se,e.findAsync=Le;function I(P,$=0){return P[P.length-(1+$)]}function S(P){if(P.length===0)throw new Error("Invalid tail call");return[P.slice(0,P.length-1),P[P.length-1]]}function Y(P,$,E=(o,v)=>o===v){if(P===$)return!0;if(!P||!$||P.length!==$.length)return!1;for(let o=0,v=P.length;o<v;o++)if(!E(P[o],$[o]))return!1;return!0}function U(P,$){const E=P.length-1;$<E&&(P[$]=P[E]),P.pop()}function O(P,$,E){return R(P.length,o=>E(P[o],$))}function R(P,$){let E=0,o=P-1;for(;E<=o;){const v=(E+o)/2|0,V=$(v);if(V<0)E=v+1;else if(V>0)o=v-1;else return v}return-(E+1)}function B(P,$,E){if(P=P|0,P>=$.length)throw new TypeError("invalid index");const o=$[Math.floor($.length*Math.random())],v=[],V=[],X=[];for(const de of $){const ve=E(de,o);ve<0?v.push(de):ve>0?V.push(de):X.push(de)}return P<v.length?B(P,v,E):P<v.length+X.length?X[0]:B(P-(v.length+X.length),V,E)}function M(P,$){const E=[];let o;for(const v of P.slice(0).sort($))!o||$(o[0],v)!==0?(o=[v],E.push(o)):o.push(v);return E}function*T(P,$){let E,o;for(const v of P)o!==void 0&&$(o,v)?E.push(v):(E&&(yield E),E=[v]),o=v;E&&(yield E)}function C(P,$){for(let E=0;E<=P.length;E++)$(E===0?void 0:P[E-1],E===P.length?void 0:P[E])}function u(P,$){for(let E=0;E<P.length;E++)$(E===0?void 0:P[E-1],P[E],E+1===P.length?void 0:P[E+1])}function r(P,$,E){const o=[];function v(de,ve,De){if(ve===0&&De.length===0)return;const Ie=o[o.length-1];Ie&&Ie.start+Ie.deleteCount===de?(Ie.deleteCount+=ve,Ie.toInsert.push(...De)):o.push({start:de,deleteCount:ve,toInsert:De})}let V=0,X=0;for(;;){if(V===P.length){v(V,0,$.slice(X));break}if(X===$.length){v(V,P.length-V,[]);break}const de=P[V],ve=$[X],De=E(de,ve);De===0?(V+=1,X+=1):De<0?(v(V,1,[]),V+=1):De>0&&(v(V,0,[ve]),X+=1)}return o}function a(P,$,E){const o=r(P,$,E),v=[],V=[];for(const X of o)v.push(...P.slice(X.start,X.start+X.deleteCount)),V.push(...X.toInsert);return{removed:v,added:V}}function _(P,$,E){if(E===0)return[];const o=P.slice(0,E).sort($);return b(P,$,o,E,P.length),o}function L(P,$,E,o,v){return E===0?Promise.resolve([]):new Promise((V,X)=>{(async()=>{const de=P.length,ve=P.slice(0,E).sort($);for(let De=E,Ie=Math.min(E+o,de);De<de;De=Ie,Ie=Math.min(Ie+o,de)){if(De>E&&await new Promise(_e=>setTimeout(_e)),v&&v.isCancellationRequested)throw new c.CancellationError;b(P,$,ve,De,Ie)}return ve})().then(V,X)})}function b(P,$,E,o,v){for(const V=E.length;o<v;o++){const X=P[o];if($(X,E[V-1])<0){E.pop();const de=(0,t.findFirstIdxMonotonousOrArrLen)(E,ve=>$(X,ve)<0);E.splice(de,0,X)}}}function k(P){return P.filter($=>!!$)}function D(P){let $=0;for(let E=0;E<P.length;E++)P[E]&&(P[$]=P[E],$+=1);P.length=$}function n(P,$,E){P.splice(E,0,P.splice($,1)[0])}function i(P){return!Array.isArray(P)||P.length===0}function s(P){return Array.isArray(P)&&P.length>0}function g(P,$=E=>E){const E=new Set;return P.filter(o=>{const v=$(o);return E.has(v)?!1:(E.add(v),!0)})}function N(P){const $=new Set;return E=>{const o=P(E);return $.has(o)?!1:($.add(o),!0)}}function h(P,$){return P.length>0?P[0]:$}function m(P,$){return P.length>0?P[P.length-1]:$}function l(P,$,E=(o,v)=>o===v){let o=0;for(let v=0,V=Math.min(P.length,$.length);v<V&&E(P[v],$[v]);v++)o++;return o}function f(P,$){let E=typeof $=="number"?P:0;typeof $=="number"?E=P:(E=0,$=P);const o=[];if(E<=$)for(let v=E;v<$;v++)o.push(v);else for(let v=E;v>$;v--)o.push(v);return o}function y(P,$,E){return P.reduce((o,v)=>(o[$(v)]=E?E(v):v,o),Object.create(null))}function A(P,$){return P.push($),()=>p(P,$)}function p(P,$){const E=P.indexOf($);if(E>-1)return P.splice(E,1),$}function j(P,$,E){const o=P.slice(0,$),v=P.slice($);return o.concat(E,v)}function x(P,$){let E;if(typeof $=="number"){let o=$;E=()=>{const v=Math.sin(o++)*179426549;return v-Math.floor(v)}}else E=Math.random;for(let o=P.length-1;o>0;o-=1){const v=Math.floor(E()*(o+1)),V=P[o];P[o]=P[v],P[v]=V}}function J(P,$){const E=P.indexOf($);E>-1&&(P.splice(E,1),P.unshift($))}function G(P,$){const E=P.indexOf($);E>-1&&(P.splice(E,1),P.push($))}function le(P,$){for(const E of $)P.push(E)}function W(P,$){return Array.isArray(P)?P.map($):$(P)}function K(P){return Array.isArray(P)?P:[P]}function Z(P){return P[Math.floor(Math.random()*P.length)]}function ee(P,$,E){const o=z(P,$),v=P.length,V=E.length;P.length=v+V;for(let X=v-1;X>=o;X--)P[X+V]=P[X];for(let X=0;X<V;X++)P[X+o]=E[X]}function q(P,$,E,o){const v=z(P,$);let V=P.splice(v,E);return V===void 0&&(V=[]),ee(P,v,o),V}function z(P,$){return $<0?Math.max($+P.length,0):Math.min($,P.length)}var H;(function(P){function $(V){return V<0}P.isLessThan=$;function E(V){return V<=0}P.isLessThanOrEqual=E;function o(V){return V>0}P.isGreaterThan=o;function v(V){return V===0}P.isNeitherLessOrGreaterThan=v,P.greaterThan=1,P.lessThan=-1,P.neitherLessOrGreaterThan=0})(H||(e.CompareResult=H={}));function te(P,$){return(E,o)=>$(P(E),P(o))}function ue(...P){return($,E)=>{for(const o of P){const v=o($,E);if(!H.isNeitherLessOrGreaterThan(v))return v}return H.neitherLessOrGreaterThan}}const w=(P,$)=>P-$;e.numberComparator=w;const ie=(P,$)=>(0,e.numberComparator)(P?1:0,$?1:0);e.booleanComparator=ie;function se(P){return($,E)=>-P($,E)}class oe{constructor($){this.items=$,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile($){let E=this.firstIdx;for(;E<this.items.length&&$(this.items[E]);)E++;const o=E===this.firstIdx?null:this.items.slice(this.firstIdx,E);return this.firstIdx=E,o}takeFromEndWhile($){let E=this.lastIdx;for(;E>=0&&$(this.items[E]);)E--;const o=E===this.lastIdx?null:this.items.slice(E+1,this.lastIdx+1);return this.lastIdx=E,o}peek(){if(this.length!==0)return this.items[this.firstIdx]}peekLast(){if(this.length!==0)return this.items[this.lastIdx]}dequeue(){const $=this.items[this.firstIdx];return this.firstIdx++,$}removeLast(){const $=this.items[this.lastIdx];return this.lastIdx--,$}takeCount($){const E=this.items.slice(this.firstIdx,this.firstIdx+$);return this.firstIdx+=$,E}}e.ArrayQueue=oe;class ce{static{this.empty=new ce($=>{})}constructor($){this.iterate=$}forEach($){this.iterate(E=>($(E),!0))}toArray(){const $=[];return this.iterate(E=>($.push(E),!0)),$}filter($){return new ce(E=>this.iterate(o=>$(o)?E(o):!0))}map($){return new ce(E=>this.iterate(o=>E($(o))))}some($){let E=!1;return this.iterate(o=>(E=$(o),!E)),E}findFirst($){let E;return this.iterate(o=>$(o)?(E=o,!1):!0),E}findLast($){let E;return this.iterate(o=>($(o)&&(E=o),!0)),E}findLastMaxBy($){let E,o=!0;return this.iterate(v=>((o||H.isGreaterThan($(v,E)))&&(o=!1,E=v),!0)),E}}e.CallbackIterable=ce;class fe{constructor($){this._indexMap=$}static createSortPermutation($,E){const o=Array.from($.keys()).sort((v,V)=>E($[v],$[V]));return new fe(o)}apply($){return $.map((E,o)=>$[this._indexMap[o]])}inverse(){const $=this._indexMap.slice();for(let E=0;E<this._indexMap.length;E++)$[this._indexMap[E]]=E;return new fe($)}}e.Permutation=fe;async function Le(P,$){return(await Promise.all(P.map(async(o,v)=>({element:o,ok:await $(o,v)})))).find(o=>o.ok)?.element}}),define(pe[23],be([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createSingleCallFunction=c;function c(t,I){const S=this;let Y=!1,U;return function(){if(Y)return U;if(Y=!0,I)try{U=t.apply(S,arguments)}finally{I()}else U=t.apply(S,arguments);return U}}}),define(pe[32],be([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var c;(function(t){function I(i){return i&&typeof i=="object"&&typeof i[Symbol.iterator]=="function"}t.is=I;const S=Object.freeze([]);function Y(){return S}t.empty=Y;function*U(i){yield i}t.single=U;function O(i){return I(i)?i:U(i)}t.wrap=O;function R(i){return i||S}t.from=R;function*B(i){for(let s=i.length-1;s>=0;s--)yield i[s]}t.reverse=B;function M(i){return!i||i[Symbol.iterator]().next().done===!0}t.isEmpty=M;function T(i){return i[Symbol.iterator]().next().value}t.first=T;function C(i,s){let g=0;for(const N of i)if(s(N,g++))return!0;return!1}t.some=C;function u(i,s){for(const g of i)if(s(g))return g}t.find=u;function*r(i,s){for(const g of i)s(g)&&(yield g)}t.filter=r;function*a(i,s){let g=0;for(const N of i)yield s(N,g++)}t.map=a;function*_(i,s){let g=0;for(const N of i)yield*s(N,g++)}t.flatMap=_;function*L(...i){for(const s of i)yield*s}t.concat=L;function b(i,s,g){let N=g;for(const h of i)N=s(N,h);return N}t.reduce=b;function*k(i,s,g=i.length){for(s<0&&(s+=i.length),g<0?g+=i.length:g>i.length&&(g=i.length);s<g;s++)yield i[s]}t.slice=k;function D(i,s=Number.POSITIVE_INFINITY){const g=[];if(s===0)return[g,i];const N=i[Symbol.iterator]();for(let h=0;h<s;h++){const m=N.next();if(m.done)return[g,t.empty()];g.push(m.value)}return[g,{[Symbol.iterator](){return N}}]}t.consume=D;async function n(i){const s=[];for await(const g of i)s.push(g);return Promise.resolve(s)}t.asyncToArray=n})(c||(e.Iterable=c={}))}),define(pe[15],be([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class c{constructor(I){this.executor=I,this._didRun=!1}get hasValue(){return this._didRun}get value(){if(!this._didRun)try{this._value=this.executor()}catch(I){this._error=I}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}}e.Lazy=c}),define(pe[33],be([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class c{static{this.Undefined=new c(void 0)}constructor(S){this.element=S,this.next=c.Undefined,this.prev=c.Undefined}}class t{constructor(){this._first=c.Undefined,this._last=c.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===c.Undefined}clear(){let S=this._first;for(;S!==c.Undefined;){const Y=S.next;S.prev=c.Undefined,S.next=c.Undefined,S=Y}this._first=c.Undefined,this._last=c.Undefined,this._size=0}unshift(S){return this._insert(S,!1)}push(S){return this._insert(S,!0)}_insert(S,Y){const U=new c(S);if(this._first===c.Undefined)this._first=U,this._last=U;else if(Y){const R=this._last;this._last=U,U.prev=R,R.next=U}else{const R=this._first;this._first=U,U.next=R,R.prev=U}this._size+=1;let O=!1;return()=>{O||(O=!0,this._remove(U))}}shift(){if(this._first!==c.Undefined){const S=this._first.element;return this._remove(this._first),S}}pop(){if(this._last!==c.Undefined){const S=this._last.element;return this._remove(this._last),S}}_remove(S){if(S.prev!==c.Undefined&&S.next!==c.Undefined){const Y=S.prev;Y.next=S.next,S.next.prev=Y}else S.prev===c.Undefined&&S.next===c.Undefined?(this._first=c.Undefined,this._last=c.Undefined):S.next===c.Undefined?(this._last=this._last.prev,this._last.next=c.Undefined):S.prev===c.Undefined&&(this._first=this._first.next,this._first.prev=c.Undefined);this._size-=1}*[Symbol.iterator](){let S=this._first;for(;S!==c.Undefined;)yield S.element,S=S.next}}e.LinkedList=t}),define(pe[16],be([0,1]),function(re,e){"use strict";var c,t,I;Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.BidirectionalMap=e.CounterSet=e.MRUCache=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=void 0,e.getOrSet=S,e.mapToString=Y,e.setToString=U,e.mapsStrictEqualIgnoreOrder=k;function S(D,n,i){let s=D.get(n);return s===void 0&&(s=i,D.set(n,s)),s}function Y(D){const n=[];return D.forEach((i,s)=>{n.push(`${s} => ${i}`)}),`Map(${D.size}) {${n.join(", ")}}`}function U(D){const n=[];return D.forEach(i=>{n.push(i)}),`Set(${D.size}) {${n.join(", ")}}`}class O{constructor(n,i){this.uri=n,this.value=i}}function R(D){return Array.isArray(D)}class B{static{this.defaultToKey=n=>n.toString()}constructor(n,i){if(this[c]="ResourceMap",n instanceof B)this.map=new Map(n.map),this.toKey=i??B.defaultToKey;else if(R(n)){this.map=new Map,this.toKey=i??B.defaultToKey;for(const[s,g]of n)this.set(s,g)}else this.map=new Map,this.toKey=n??B.defaultToKey}set(n,i){return this.map.set(this.toKey(n),new O(n,i)),this}get(n){return this.map.get(this.toKey(n))?.value}has(n){return this.map.has(this.toKey(n))}get size(){return this.map.size}clear(){this.map.clear()}delete(n){return this.map.delete(this.toKey(n))}forEach(n,i){typeof i<"u"&&(n=n.bind(i));for(const[s,g]of this.map)n(g.value,g.uri,this)}*values(){for(const n of this.map.values())yield n.value}*keys(){for(const n of this.map.values())yield n.uri}*entries(){for(const n of this.map.values())yield[n.uri,n.value]}*[(c=Symbol.toStringTag,Symbol.iterator)](){for(const[,n]of this.map)yield[n.uri,n.value]}}e.ResourceMap=B;class M{constructor(n,i){this[t]="ResourceSet",!n||typeof n=="function"?this._map=new B(n):(this._map=new B(i),n.forEach(this.add,this))}get size(){return this._map.size}add(n){return this._map.set(n,n),this}clear(){this._map.clear()}delete(n){return this._map.delete(n)}forEach(n,i){this._map.forEach((s,g)=>n.call(i,g,g,this))}has(n){return this._map.has(n)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(t=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=M;var T;(function(D){D[D.None=0]="None",D[D.AsOld=1]="AsOld",D[D.AsNew=2]="AsNew"})(T||(e.Touch=T={}));class C{constructor(){this[I]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(n){return this._map.has(n)}get(n,i=T.None){const s=this._map.get(n);if(s)return i!==T.None&&this.touch(s,i),s.value}set(n,i,s=T.None){let g=this._map.get(n);if(g)g.value=i,s!==T.None&&this.touch(g,s);else{switch(g={key:n,value:i,next:void 0,previous:void 0},s){case T.None:this.addItemLast(g);break;case T.AsOld:this.addItemFirst(g);break;case T.AsNew:this.addItemLast(g);break;default:this.addItemLast(g);break}this._map.set(n,g),this._size++}return this}delete(n){return!!this.remove(n)}remove(n){const i=this._map.get(n);if(i)return this._map.delete(n),this.removeItem(i),this._size--,i.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const n=this._head;return this._map.delete(n.key),this.removeItem(n),this._size--,n.value}forEach(n,i){const s=this._state;let g=this._head;for(;g;){if(i?n.bind(i)(g.value,g.key,this):n(g.value,g.key,this),this._state!==s)throw new Error("LinkedMap got modified during iteration.");g=g.next}}keys(){const n=this,i=this._state;let s=this._head;const g={[Symbol.iterator](){return g},next(){if(n._state!==i)throw new Error("LinkedMap got modified during iteration.");if(s){const N={value:s.key,done:!1};return s=s.next,N}else return{value:void 0,done:!0}}};return g}values(){const n=this,i=this._state;let s=this._head;const g={[Symbol.iterator](){return g},next(){if(n._state!==i)throw new Error("LinkedMap got modified during iteration.");if(s){const N={value:s.value,done:!1};return s=s.next,N}else return{value:void 0,done:!0}}};return g}entries(){const n=this,i=this._state;let s=this._head;const g={[Symbol.iterator](){return g},next(){if(n._state!==i)throw new Error("LinkedMap got modified during iteration.");if(s){const N={value:[s.key,s.value],done:!1};return s=s.next,N}else return{value:void 0,done:!0}}};return g}[(I=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(n){if(n>=this.size)return;if(n===0){this.clear();return}let i=this._head,s=this.size;for(;i&&s>n;)this._map.delete(i.key),i=i.next,s--;this._head=i,this._size=s,i&&(i.previous=void 0),this._state++}trimNew(n){if(n>=this.size)return;if(n===0){this.clear();return}let i=this._tail,s=this.size;for(;i&&s>n;)this._map.delete(i.key),i=i.previous,s--;this._tail=i,this._size=s,i&&(i.next=void 0),this._state++}addItemFirst(n){if(!this._head&&!this._tail)this._tail=n;else if(this._head)n.next=this._head,this._head.previous=n;else throw new Error("Invalid list");this._head=n,this._state++}addItemLast(n){if(!this._head&&!this._tail)this._head=n;else if(this._tail)n.previous=this._tail,this._tail.next=n;else throw new Error("Invalid list");this._tail=n,this._state++}removeItem(n){if(n===this._head&&n===this._tail)this._head=void 0,this._tail=void 0;else if(n===this._head){if(!n.next)throw new Error("Invalid list");n.next.previous=void 0,this._head=n.next}else if(n===this._tail){if(!n.previous)throw new Error("Invalid list");n.previous.next=void 0,this._tail=n.previous}else{const i=n.next,s=n.previous;if(!i||!s)throw new Error("Invalid list");i.previous=s,s.next=i}n.next=void 0,n.previous=void 0,this._state++}touch(n,i){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(i!==T.AsOld&&i!==T.AsNew)){if(i===T.AsOld){if(n===this._head)return;const s=n.next,g=n.previous;n===this._tail?(g.next=void 0,this._tail=g):(s.previous=g,g.next=s),n.previous=void 0,n.next=this._head,this._head.previous=n,this._head=n,this._state++}else if(i===T.AsNew){if(n===this._tail)return;const s=n.next,g=n.previous;n===this._head?(s.previous=void 0,this._head=s):(s.previous=g,g.next=s),n.next=void 0,n.previous=this._tail,this._tail.next=n,this._tail=n,this._state++}}}toJSON(){const n=[];return this.forEach((i,s)=>{n.push([s,i])}),n}fromJSON(n){this.clear();for(const[i,s]of n)this.set(i,s)}}e.LinkedMap=C;class u extends C{constructor(n,i=1){super(),this._limit=n,this._ratio=Math.min(Math.max(0,i),1)}get limit(){return this._limit}set limit(n){this._limit=n,this.checkTrim()}get ratio(){return this._ratio}set ratio(n){this._ratio=Math.min(Math.max(0,n),1),this.checkTrim()}get(n,i=T.AsNew){return super.get(n,i)}peek(n){return super.get(n,T.None)}set(n,i){return super.set(n,i,T.AsNew),this}checkTrim(){this.size>this._limit&&this.trim(Math.round(this._limit*this._ratio))}}class r extends u{constructor(n,i=1){super(n,i)}trim(n){this.trimOld(n)}set(n,i){return super.set(n,i),this.checkTrim(),this}}e.LRUCache=r;class a extends u{constructor(n,i=1){super(n,i)}trim(n){this.trimNew(n)}set(n,i){return this._limit<=this.size&&!this.has(n)&&this.trim(Math.round(this._limit*this._ratio)-1),super.set(n,i),this}}e.MRUCache=a;class _{constructor(){this.map=new Map}add(n){return this.map.set(n,(this.map.get(n)||0)+1),this}delete(n){let i=this.map.get(n)||0;return i===0?!1:(i--,i===0?this.map.delete(n):this.map.set(n,i),!0)}has(n){return this.map.has(n)}}e.CounterSet=_;class L{constructor(n){if(this._m1=new Map,this._m2=new Map,n)for(const[i,s]of n)this.set(i,s)}clear(){this._m1.clear(),this._m2.clear()}set(n,i){this._m1.set(n,i),this._m2.set(i,n)}get(n){return this._m1.get(n)}getKey(n){return this._m2.get(n)}delete(n){const i=this._m1.get(n);return i===void 0?!1:(this._m1.delete(n),this._m2.delete(i),!0)}forEach(n,i){this._m1.forEach((s,g)=>{n.call(i,s,g,this)})}keys(){return this._m1.keys()}values(){return this._m1.values()}}e.BidirectionalMap=L;class b{constructor(){this.map=new Map}add(n,i){let s=this.map.get(n);s||(s=new Set,this.map.set(n,s)),s.add(i)}delete(n,i){const s=this.map.get(n);s&&(s.delete(i),s.size===0&&this.map.delete(n))}forEach(n,i){const s=this.map.get(n);s&&s.forEach(i)}get(n){const i=this.map.get(n);return i||new Set}}e.SetMap=b;function k(D,n){if(D===n)return!0;if(D.size!==n.size)return!1;for(const[i,s]of D)if(!n.has(i)||n.get(i)!==s)return!1;for(const[i]of n)if(!D.has(i))return!1;return!0}}),define(pe[11],be([0,1,14,31,16,23,32]),function(re,e,c,t,I,S,Y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DisposableMap=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MandatoryMutableDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.DisposableTracker=void 0,e.setDisposableTracker=B,e.trackDisposable=M,e.markAsDisposed=T,e.markAsSingleton=r,e.isDisposable=a,e.dispose=_,e.disposeIfDisposable=L,e.combinedDisposable=b,e.toDisposable=k,e.disposeOnReturn=f;const U=!1;let O=null;class R{constructor(){this.livingDisposables=new Map}static{this.idx=0}getDisposableData(p){let j=this.livingDisposables.get(p);return j||(j={parent:null,source:null,isSingleton:!1,value:p,idx:R.idx++},this.livingDisposables.set(p,j)),j}trackDisposable(p){const j=this.getDisposableData(p);j.source||(j.source=new Error().stack)}setParent(p,j){const x=this.getDisposableData(p);x.parent=j}markAsDisposed(p){this.livingDisposables.delete(p)}markAsSingleton(p){this.getDisposableData(p).isSingleton=!0}getRootParent(p,j){const x=j.get(p);if(x)return x;const J=p.parent?this.getRootParent(this.getDisposableData(p.parent),j):p;return j.set(p,J),J}getTrackedDisposables(){const p=new Map;return[...this.livingDisposables.entries()].filter(([,x])=>x.source!==null&&!this.getRootParent(x,p).isSingleton).flatMap(([x])=>x)}computeLeakingDisposables(p=10,j){let x;if(j)x=j;else{const K=new Map,Z=[...this.livingDisposables.values()].filter(q=>q.source!==null&&!this.getRootParent(q,K).isSingleton);if(Z.length===0)return;const ee=new Set(Z.map(q=>q.value));if(x=Z.filter(q=>!(q.parent&&ee.has(q.parent))),x.length===0)throw new Error("There are cyclic diposable chains!")}if(!x)return;function J(K){function Z(q,z){for(;q.length>0&&z.some(H=>typeof H=="string"?H===q[0]:q[0].match(H));)q.shift()}const ee=K.source.split(`
`).map(q=>q.trim().replace("at ","")).filter(q=>q!=="");return Z(ee,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),ee.reverse()}const G=new I.SetMap;for(const K of x){const Z=J(K);for(let ee=0;ee<=Z.length;ee++)G.add(Z.slice(0,ee).join(`
`),K)}x.sort((0,c.compareBy)(K=>K.idx,c.numberComparator));let le="",W=0;for(const K of x.slice(0,p)){W++;const Z=J(K),ee=[];for(let q=0;q<Z.length;q++){let z=Z[q];z=`(shared with ${G.get(Z.slice(0,q+1).join(`
`)).size}/${x.length} leaks) at ${z}`;const te=G.get(Z.slice(0,q).join(`
`)),ue=(0,t.groupBy)([...te].map(w=>J(w)[q]),w=>w);delete ue[Z[q]];for(const[w,ie]of Object.entries(ue))ee.unshift(`    - stacktraces of ${ie.length} other leaks continue with ${w}`);ee.unshift(z)}le+=`


==================== Leaking disposable ${W}/${x.length}: ${K.value.constructor.name} ====================
${ee.join(`
`)}
============================================================

`}return x.length>p&&(le+=`


... and ${x.length-p} more leaking disposables

`),{leaks:x,details:le}}}e.DisposableTracker=R;function B(A){O=A}if(U){const A="__is_disposable_tracked__";B(new class{trackDisposable(p){const j=new Error("Potentially leaked disposable").stack;setTimeout(()=>{p[A]||console.log(j)},3e3)}setParent(p,j){if(p&&p!==n.None)try{p[A]=!0}catch{}}markAsDisposed(p){if(p&&p!==n.None)try{p[A]=!0}catch{}}markAsSingleton(p){}})}function M(A){return O?.trackDisposable(A),A}function T(A){O?.markAsDisposed(A)}function C(A,p){O?.setParent(A,p)}function u(A,p){if(O)for(const j of A)O.setParent(j,p)}function r(A){return O?.markAsSingleton(A),A}function a(A){return typeof A=="object"&&A!==null&&typeof A.dispose=="function"&&A.dispose.length===0}function _(A){if(Y.Iterable.is(A)){const p=[];for(const j of A)if(j)try{j.dispose()}catch(x){p.push(x)}if(p.length===1)throw p[0];if(p.length>1)throw new AggregateError(p,"Encountered errors while disposing of store");return Array.isArray(A)?[]:A}else if(A)return A.dispose(),A}function L(A){for(const p of A)a(p)&&p.dispose();return[]}function b(...A){const p=k(()=>_(A));return u(A,p),p}function k(A){const p=M({dispose:(0,S.createSingleCallFunction)(()=>{T(p),A()})});return p}class D{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this._toDispose=new Set,this._isDisposed=!1,M(this)}dispose(){this._isDisposed||(T(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){if(this._toDispose.size!==0)try{_(this._toDispose)}finally{this._toDispose.clear()}}add(p){if(!p)return p;if(p===this)throw new Error("Cannot register a disposable on itself!");return C(p,this),this._isDisposed?D.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(p),p}delete(p){if(p){if(p===this)throw new Error("Cannot dispose a disposable on itself!");this._toDispose.delete(p),p.dispose()}}deleteAndLeak(p){p&&this._toDispose.has(p)&&(this._toDispose.delete(p),C(p,null))}}e.DisposableStore=D;class n{static{this.None=Object.freeze({dispose(){}})}constructor(){this._store=new D,M(this),C(this._store,this)}dispose(){T(this),this._store.dispose()}_register(p){if(p===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(p)}}e.Disposable=n;class i{constructor(){this._isDisposed=!1,M(this)}get value(){return this._isDisposed?void 0:this._value}set value(p){this._isDisposed||p===this._value||(this._value?.dispose(),p&&C(p,this),this._value=p)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,T(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const p=this._value;return this._value=void 0,p&&C(p,null),p}}e.MutableDisposable=i;class s{constructor(p){this._disposable=new i,this._isDisposed=!1,this._disposable.value=p}get value(){return this._disposable.value}set value(p){this._isDisposed||p===this._disposable.value||(this._disposable.value=p)}dispose(){this._isDisposed=!0,this._disposable.dispose()}}e.MandatoryMutableDisposable=s;class g{constructor(p){this._disposable=p,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter===0&&this._disposable.dispose(),this}}e.RefCountedDisposable=g;class N{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,M(this)}set(p){let j=p;return this.unset=()=>j=void 0,this.isset=()=>j!==void 0,this.dispose=()=>{j&&(j(),j=void 0,T(this))},this}}e.SafeDisposable=N;class h{constructor(){this.references=new Map}acquire(p,...j){let x=this.references.get(p);x||(x={counter:0,object:this.createReferencedObject(p,...j)},this.references.set(p,x));const{object:J}=x,G=(0,S.createSingleCallFunction)(()=>{--x.counter===0&&(this.destroyReferencedObject(p,x.object),this.references.delete(p))});return x.counter++,{object:J,dispose:G}}}e.ReferenceCollection=h;class m{constructor(p){this.referenceCollection=p}async acquire(p,...j){const x=this.referenceCollection.acquire(p,...j);try{return{object:await x.object,dispose:()=>x.dispose()}}catch(J){throw x.dispose(),J}}}e.AsyncReferenceCollection=m;class l{constructor(p){this.object=p}dispose(){}}e.ImmortalReference=l;function f(A){const p=new D;try{A(p)}finally{p.dispose()}}class y{constructor(){this._store=new Map,this._isDisposed=!1,M(this)}dispose(){T(this),this._isDisposed=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this._store.size)try{_(this._store.values())}finally{this._store.clear()}}has(p){return this._store.has(p)}get size(){return this._store.size}get(p){return this._store.get(p)}set(p,j,x=!1){this._isDisposed&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),x||this._store.get(p)?.dispose(),this._store.set(p,j)}deleteAndDispose(p){this._store.get(p)?.dispose(),this._store.delete(p)}deleteAndLeak(p){const j=this._store.get(p);return this._store.delete(p),j}keys(){return this._store.keys()}values(){return this._store.values()}[Symbol.iterator](){return this._store[Symbol.iterator]()}}e.DisposableMap=y}),define(pe[34],be([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MarshalledId=void 0;var c;(function(t){t[t.Uri=1]="Uri",t[t.Regexp=2]="Regexp",t[t.ScmResource=3]="ScmResource",t[t.ScmResourceGroup=4]="ScmResourceGroup",t[t.ScmProvider=5]="ScmProvider",t[t.CommentController=6]="CommentController",t[t.CommentThread=7]="CommentThread",t[t.CommentThreadInstance=8]="CommentThreadInstance",t[t.CommentThreadReply=9]="CommentThreadReply",t[t.CommentNode=10]="CommentNode",t[t.CommentThreadNode=11]="CommentThreadNode",t[t.TimelineActionContext=12]="TimelineActionContext",t[t.NotebookCellActionContext=13]="NotebookCellActionContext",t[t.NotebookActionContext=14]="NotebookActionContext",t[t.TerminalContext=15]="TerminalContext",t[t.TestItemContext=16]="TestItemContext",t[t.Date=17]="Date",t[t.TestMessageMenuArgs=18]="TestMessageMenuArgs"})(c||(e.MarshalledId=c={}))}),define(pe[24],be([0,1,16]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=void 0,e.normalizeNFC=I,e.normalizeNFD=Y;const t=new c.LRUCache(1e4);function I(R){return O(R,"NFC",t)}const S=new c.LRUCache(1e4);function Y(R){return O(R,"NFD",S)}const U=/[^\u0000-\u0080]/;function O(R,B,M){if(!R)return R;const T=M.get(R);if(T)return T;let C;return U.test(R)?C=R.normalize(B):C=R,M.set(R,C),C}e.removeAccents=function(){const R=/[\u0300-\u036f]/g;return function(B){return Y(B).replace(R,"")}}()}),define(pe[35],be([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPort=c;function c(){return 1025+Math.floor(64510*Math.random())}}),define(pe[36],be([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const c=globalThis.performance&&typeof globalThis.performance.now=="function";class t{static create(S){return new t(S)}constructor(S){this._now=c&&S===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this._startTime=this._now(),this._stopTime=-1}stop(){this._stopTime=this._now()}reset(){this._startTime=this._now(),this._stopTime=-1}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}}e.StopWatch=t}),define(pe[17],be([0,1,10,23,11,33,36]),function(re,e,c,t,I,S,Y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ValueWithChangeEvent=e.Relay=e.EventBufferer=e.DynamicListEventMultiplexer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.createEventDeliveryQueue=e.Emitter=e.ListenerRefusalError=e.ListenerLeakError=e.EventProfiling=e.Event=void 0,e.setGlobalLeakWarningThreshold=C;const U=!1,O=!1,R=!1;var B;(function(J){J.None=()=>I.Disposable.None;function G(_e){if(R){const{onDidAddListener:ae}=_e,me=r.create();let he=0;_e.onDidAddListener=()=>{++he===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),me.print()),ae?.()}}}function le(_e,ae){return ie(_e,()=>{},0,void 0,!0,void 0,ae)}J.defer=le;function W(_e){return(ae,me=null,he)=>{let Ee=!1,Ae;return Ae=_e(Re=>{if(!Ee)return Ae?Ae.dispose():Ee=!0,ae.call(me,Re)},null,he),Ee&&Ae.dispose(),Ae}}J.once=W;function K(_e,ae){return J.once(J.filter(_e,ae))}J.onceIf=K;function Z(_e,ae,me){return ue((he,Ee=null,Ae)=>_e(Re=>he.call(Ee,ae(Re)),null,Ae),me)}J.map=Z;function ee(_e,ae,me){return ue((he,Ee=null,Ae)=>_e(Re=>{ae(Re),he.call(Ee,Re)},null,Ae),me)}J.forEach=ee;function q(_e,ae,me){return ue((he,Ee=null,Ae)=>_e(Re=>ae(Re)&&he.call(Ee,Re),null,Ae),me)}J.filter=q;function z(_e){return _e}J.signal=z;function H(..._e){return(ae,me=null,he)=>{const Ee=(0,I.combinedDisposable)(..._e.map(Ae=>Ae(Re=>ae.call(me,Re))));return w(Ee,he)}}J.any=H;function te(_e,ae,me,he){let Ee=me;return Z(_e,Ae=>(Ee=ae(Ee,Ae),Ee),he)}J.reduce=te;function ue(_e,ae){let me;const he={onWillAddFirstListener(){me=_e(Ee.fire,Ee)},onDidRemoveLastListener(){me?.dispose()}};ae||G(he);const Ee=new i(he);return ae?.add(Ee),Ee.event}function w(_e,ae){return ae instanceof Array?ae.push(_e):ae&&ae.add(_e),_e}function ie(_e,ae,me=100,he=!1,Ee=!1,Ae,Re){let Te,Oe,we,Fe=0,qe;const He={leakWarningThreshold:Ae,onWillAddFirstListener(){Te=_e(Ke=>{Fe++,Oe=ae(Oe,Ke),he&&!we&&(Ce.fire(Oe),Oe=void 0),qe=()=>{const $e=Oe;Oe=void 0,we=void 0,(!he||Fe>1)&&Ce.fire($e),Fe=0},typeof me=="number"?(clearTimeout(we),we=setTimeout(qe,me)):we===void 0&&(we=0,queueMicrotask(qe))})},onWillRemoveListener(){Ee&&Fe>0&&qe?.()},onDidRemoveLastListener(){qe=void 0,Te.dispose()}};Re||G(He);const Ce=new i(He);return Re?.add(Ce),Ce.event}J.debounce=ie;function se(_e,ae=0,me){return J.debounce(_e,(he,Ee)=>he?(he.push(Ee),he):[Ee],ae,void 0,!0,void 0,me)}J.accumulate=se;function oe(_e,ae=(he,Ee)=>he===Ee,me){let he=!0,Ee;return q(_e,Ae=>{const Re=he||!ae(Ae,Ee);return he=!1,Ee=Ae,Re},me)}J.latch=oe;function ce(_e,ae,me){return[J.filter(_e,ae,me),J.filter(_e,he=>!ae(he),me)]}J.split=ce;function fe(_e,ae=!1,me=[],he){let Ee=me.slice(),Ae=_e(Oe=>{Ee?Ee.push(Oe):Te.fire(Oe)});he&&he.add(Ae);const Re=()=>{Ee?.forEach(Oe=>Te.fire(Oe)),Ee=null},Te=new i({onWillAddFirstListener(){Ae||(Ae=_e(Oe=>Te.fire(Oe)),he&&he.add(Ae))},onDidAddFirstListener(){Ee&&(ae?setTimeout(Re):Re())},onDidRemoveLastListener(){Ae&&Ae.dispose(),Ae=null}});return he&&he.add(Te),Te.event}J.buffer=fe;function Le(_e,ae){return(he,Ee,Ae)=>{const Re=ae(new $);return _e(function(Te){const Oe=Re.evaluate(Te);Oe!==P&&he.call(Ee,Oe)},void 0,Ae)}}J.chain=Le;const P=Symbol("HaltChainable");class ${constructor(){this.steps=[]}map(ae){return this.steps.push(ae),this}forEach(ae){return this.steps.push(me=>(ae(me),me)),this}filter(ae){return this.steps.push(me=>ae(me)?me:P),this}reduce(ae,me){let he=me;return this.steps.push(Ee=>(he=ae(he,Ee),he)),this}latch(ae=(me,he)=>me===he){let me=!0,he;return this.steps.push(Ee=>{const Ae=me||!ae(Ee,he);return me=!1,he=Ee,Ae?Ee:P}),this}evaluate(ae){for(const me of this.steps)if(ae=me(ae),ae===P)break;return ae}}function E(_e,ae,me=he=>he){const he=(...Te)=>Re.fire(me(...Te)),Ee=()=>_e.on(ae,he),Ae=()=>_e.removeListener(ae,he),Re=new i({onWillAddFirstListener:Ee,onDidRemoveLastListener:Ae});return Re.event}J.fromNodeEventEmitter=E;function o(_e,ae,me=he=>he){const he=(...Te)=>Re.fire(me(...Te)),Ee=()=>_e.addEventListener(ae,he),Ae=()=>_e.removeEventListener(ae,he),Re=new i({onWillAddFirstListener:Ee,onDidRemoveLastListener:Ae});return Re.event}J.fromDOMEventEmitter=o;function v(_e){return new Promise(ae=>W(_e)(ae))}J.toPromise=v;function V(_e){const ae=new i;return _e.then(me=>{ae.fire(me)},()=>{ae.fire(void 0)}).finally(()=>{ae.dispose()}),ae.event}J.fromPromise=V;function X(_e,ae){return _e(me=>ae.fire(me))}J.forward=X;function de(_e,ae,me){return ae(me),_e(he=>ae(he))}J.runAndSubscribe=de;class ve{constructor(ae,me){this._observable=ae,this._counter=0,this._hasChanged=!1;const he={onWillAddFirstListener:()=>{ae.addObserver(this),this._observable.reportChanges()},onDidRemoveLastListener:()=>{ae.removeObserver(this)}};me||G(he),this.emitter=new i(he),me&&me.add(this.emitter)}beginUpdate(ae){this._counter++}handlePossibleChange(ae){}handleChange(ae,me){this._hasChanged=!0}endUpdate(ae){this._counter--,this._counter===0&&(this._observable.reportChanges(),this._hasChanged&&(this._hasChanged=!1,this.emitter.fire(this._observable.get())))}}function De(_e,ae){return new ve(_e,ae).emitter.event}J.fromObservable=De;function Ie(_e){return(ae,me,he)=>{let Ee=0,Ae=!1;const Re={beginUpdate(){Ee++},endUpdate(){Ee--,Ee===0&&(_e.reportChanges(),Ae&&(Ae=!1,ae.call(me)))},handlePossibleChange(){},handleChange(){Ae=!0}};_e.addObserver(Re),_e.reportChanges();const Te={dispose(){_e.removeObserver(Re)}};return he instanceof I.DisposableStore?he.add(Te):Array.isArray(he)&&he.push(Te),Te}}J.fromObservableLight=Ie})(B||(e.Event=B={}));class M{static{this.all=new Set}static{this._idPool=0}constructor(G){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${G}_${M._idPool++}`,M.all.add(this)}start(G){this._stopWatch=new Y.StopWatch,this.listenerCount=G}stop(){if(this._stopWatch){const G=this._stopWatch.elapsed();this.durations.push(G),this.elapsedOverall+=G,this.invocationCount+=1,this._stopWatch=void 0}}}e.EventProfiling=M;let T=-1;function C(J){const G=T;return T=J,{dispose(){T=G}}}class u{static{this._idPool=1}constructor(G,le,W=(u._idPool++).toString(16).padStart(3,"0")){this._errorHandler=G,this.threshold=le,this.name=W,this._warnCountdown=0}dispose(){this._stacks?.clear()}check(G,le){const W=this.threshold;if(W<=0||le<W)return;this._stacks||(this._stacks=new Map);const K=this._stacks.get(G.value)||0;if(this._stacks.set(G.value,K+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=W*.5;const[Z,ee]=this.getMostFrequentStack(),q=`[${this.name}] potential listener LEAK detected, having ${le} listeners already. MOST frequent listener (${ee}):`;console.warn(q),console.warn(Z);const z=new a(q,Z);this._errorHandler(z)}return()=>{const Z=this._stacks.get(G.value)||0;this._stacks.set(G.value,Z-1)}}getMostFrequentStack(){if(!this._stacks)return;let G,le=0;for(const[W,K]of this._stacks)(!G||le<K)&&(G=[W,K],le=K);return G}}class r{static create(){const G=new Error;return new r(G.stack??"")}constructor(G){this.value=G}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class a extends Error{constructor(G,le){super(G),this.name="ListenerLeakError",this.stack=le}}e.ListenerLeakError=a;class _ extends Error{constructor(G,le){super(G),this.name="ListenerRefusalError",this.stack=le}}e.ListenerRefusalError=_;let L=0;class b{constructor(G){this.value=G,this.id=L++}}const k=2,D=(J,G)=>{if(J instanceof b)G(J);else for(let le=0;le<J.length;le++){const W=J[le];W&&G(W)}};let n;if(U){const J=[];setInterval(()=>{J.length!==0&&(console.warn("[LEAKING LISTENERS] GC'ed these listeners that were NOT yet disposed:"),console.warn(J.join(`
`)),J.length=0)},3e3),n=new FinalizationRegistry(G=>{typeof G=="string"&&J.push(G)})}class i{constructor(G){this._size=0,this._options=G,this._leakageMon=T>0||this._options?.leakWarningThreshold?new u(G?.onListenerError??c.onUnexpectedError,this._options?.leakWarningThreshold??T):void 0,this._perfMon=this._options?._profName?new M(this._options._profName):void 0,this._deliveryQueue=this._options?.deliveryQueue}dispose(){if(!this._disposed){if(this._disposed=!0,this._deliveryQueue?.current===this&&this._deliveryQueue.reset(),this._listeners){if(O){const G=this._listeners;queueMicrotask(()=>{D(G,le=>le.stack?.print())})}this._listeners=void 0,this._size=0}this._options?.onDidRemoveLastListener?.(),this._leakageMon?.dispose()}}get event(){return this._event??=(G,le,W)=>{if(this._leakageMon&&this._size>this._leakageMon.threshold**2){const z=`[${this._leakageMon.name}] REFUSES to accept new listeners because it exceeded its threshold by far (${this._size} vs ${this._leakageMon.threshold})`;console.warn(z);const H=this._leakageMon.getMostFrequentStack()??["UNKNOWN stack",-1],te=new _(`${z}. HINT: Stack shows most frequent listener (${H[1]}-times)`,H[0]);return(this._options?.onListenerError||c.onUnexpectedError)(te),I.Disposable.None}if(this._disposed)return I.Disposable.None;le&&(G=G.bind(le));const K=new b(G);let Z,ee;this._leakageMon&&this._size>=Math.ceil(this._leakageMon.threshold*.2)&&(K.stack=r.create(),Z=this._leakageMon.check(K.stack,this._size+1)),O&&(K.stack=ee??r.create()),this._listeners?this._listeners instanceof b?(this._deliveryQueue??=new g,this._listeners=[this._listeners,K]):this._listeners.push(K):(this._options?.onWillAddFirstListener?.(this),this._listeners=K,this._options?.onDidAddFirstListener?.(this)),this._size++;const q=(0,I.toDisposable)(()=>{n?.unregister(q),Z?.(),this._removeListener(K)});if(W instanceof I.DisposableStore?W.add(q):Array.isArray(W)&&W.push(q),n){const z=new Error().stack.split(`
`).slice(2,3).join(`
`).trim(),H=/(file:|vscode-file:\/\/vscode-app)?(\/[^:]*:\d+:\d+)/.exec(z);n.register(q,H?.[2]??z,q)}return q},this._event}_removeListener(G){if(this._options?.onWillRemoveListener?.(this),!this._listeners)return;if(this._size===1){this._listeners=void 0,this._options?.onDidRemoveLastListener?.(this),this._size=0;return}const le=this._listeners,W=le.indexOf(G);if(W===-1)throw console.log("disposed?",this._disposed),console.log("size?",this._size),console.log("arr?",JSON.stringify(this._listeners)),new Error("Attempted to dispose unknown listener");this._size--,le[W]=void 0;const K=this._deliveryQueue.current===this;if(this._size*k<=le.length){let Z=0;for(let ee=0;ee<le.length;ee++)le[ee]?le[Z++]=le[ee]:K&&(this._deliveryQueue.end--,Z<this._deliveryQueue.i&&this._deliveryQueue.i--);le.length=Z}}_deliver(G,le){if(!G)return;const W=this._options?.onListenerError||c.onUnexpectedError;if(!W){G.value(le);return}try{G.value(le)}catch(K){W(K)}}_deliverQueue(G){const le=G.current._listeners;for(;G.i<G.end;)this._deliver(le[G.i++],G.value);G.reset()}fire(G){if(this._deliveryQueue?.current&&(this._deliverQueue(this._deliveryQueue),this._perfMon?.stop()),this._perfMon?.start(this._size),this._listeners)if(this._listeners instanceof b)this._deliver(this._listeners,G);else{const le=this._deliveryQueue;le.enqueue(this,G,this._listeners.length),this._deliverQueue(le)}this._perfMon?.stop()}hasListeners(){return this._size>0}}e.Emitter=i;const s=()=>new g;e.createEventDeliveryQueue=s;class g{constructor(){this.i=-1,this.end=0}enqueue(G,le,W){this.i=0,this.end=W,this.current=G,this.value=le}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class N extends i{async fireAsync(G,le,W){if(this._listeners)for(this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new S.LinkedList),D(this._listeners,K=>this._asyncDeliveryQueue.push([K.value,G]));this._asyncDeliveryQueue.size>0&&!le.isCancellationRequested;){const[K,Z]=this._asyncDeliveryQueue.shift(),ee=[],q={...Z,token:le,waitUntil:z=>{if(Object.isFrozen(ee))throw new Error("waitUntil can NOT be called asynchronous");W&&(z=W(z,K)),ee.push(z)}};try{K(q)}catch(z){(0,c.onUnexpectedError)(z);continue}Object.freeze(ee),await Promise.allSettled(ee).then(z=>{for(const H of z)H.status==="rejected"&&(0,c.onUnexpectedError)(H.reason)})}}}e.AsyncEmitter=N;class h extends i{get isPaused(){return this._isPaused!==0}constructor(G){super(G),this._isPaused=0,this._eventQueue=new S.LinkedList,this._mergeFn=G?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused===0)if(this._mergeFn){if(this._eventQueue.size>0){const G=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(G))}}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(G){this._size&&(this._isPaused!==0?this._eventQueue.push(G):super.fire(G))}}e.PauseableEmitter=h;class m extends h{constructor(G){super(G),this._delay=G.delay??100}fire(G){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(G)}}e.DebounceEmitter=m;class l extends i{constructor(G){super(G),this._queuedEvents=[],this._mergeFn=G?.merge}fire(G){this.hasListeners()&&(this._queuedEvents.push(G),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(le=>super.fire(le)),this._queuedEvents=[]}))}}e.MicrotaskEmitter=l;class f{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new i({onWillAddFirstListener:()=>this.onFirstListenerAdd(),onDidRemoveLastListener:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(G){const le={event:G,listener:null};this.events.push(le),this.hasListeners&&this.hook(le);const W=()=>{this.hasListeners&&this.unhook(le);const K=this.events.indexOf(le);this.events.splice(K,1)};return(0,I.toDisposable)((0,t.createSingleCallFunction)(W))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(G=>this.hook(G))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(G=>this.unhook(G))}hook(G){G.listener=G.event(le=>this.emitter.fire(le))}unhook(G){G.listener?.dispose(),G.listener=null}dispose(){this.emitter.dispose();for(const G of this.events)G.listener?.dispose();this.events=[]}}e.EventMultiplexer=f;class y{constructor(G,le,W,K){this._store=new I.DisposableStore;const Z=this._store.add(new f),ee=this._store.add(new I.DisposableMap);function q(z){ee.set(z,Z.add(K(z)))}for(const z of G)q(z);this._store.add(le(z=>{q(z)})),this._store.add(W(z=>{ee.deleteAndDispose(z)})),this.event=Z.event}dispose(){this._store.dispose()}}e.DynamicListEventMultiplexer=y;class A{constructor(){this.data=[]}wrapEvent(G,le,W){return(K,Z,ee)=>G(q=>{const z=this.data[this.data.length-1];if(!le){z?z.buffers.push(()=>K.call(Z,q)):K.call(Z,q);return}const H=z;if(!H){K.call(Z,le(W,q));return}H.items??=[],H.items.push(q),H.buffers.length===0&&z.buffers.push(()=>{H.reducedResult??=W?H.items.reduce(le,W):H.items.reduce(le),K.call(Z,H.reducedResult)})},void 0,ee)}bufferEvents(G){const le={buffers:new Array};this.data.push(le);const W=G();return this.data.pop(),le.buffers.forEach(K=>K()),W}}e.EventBufferer=A;class p{constructor(){this.listening=!1,this.inputEvent=B.None,this.inputEventListener=I.Disposable.None,this.emitter=new i({onDidAddFirstListener:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onDidRemoveLastListener:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(G){this.inputEvent=G,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=G(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=p;class j{static const(G){return new x(G)}constructor(G){this._value=G,this._onDidChange=new i,this.onDidChange=this._onDidChange.event}get value(){return this._value}set value(G){G!==this._value&&(this._value=G,this._onDidChange.fire(void 0))}}e.ValueWithChangeEvent=j;class x{constructor(G){this.value=G,this.onDidChange=B.None}}}),define(pe[12],be([0,1,17]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0,e.cancelOnDispose=U;const t=Object.freeze(function(O,R){const B=setTimeout(O.bind(R),0);return{dispose(){clearTimeout(B)}}});var I;(function(O){function R(B){return B===O.None||B===O.Cancelled||B instanceof S?!0:!B||typeof B!="object"?!1:typeof B.isCancellationRequested=="boolean"&&typeof B.onCancellationRequested=="function"}O.isCancellationToken=R,O.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:c.Event.None}),O.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:t})})(I||(e.CancellationToken=I={}));class S{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?t:(this._emitter||(this._emitter=new c.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class Y{constructor(R){this._token=void 0,this._parentListener=void 0,this._parentListener=R&&R.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new S),this._token}cancel(){this._token?this._token instanceof S&&this._token.cancel():this._token=I.Cancelled}dispose(R=!1){R&&this.cancel(),this._parentListener?.dispose(),this._token?this._token instanceof S&&this._token.dispose():this._token=I.None}}e.CancellationTokenSource=Y;function U(O){const R=new Y;return O.add({dispose(){R.cancel()}}),R.token}}),define(pe[37],be([0,1,12]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0,e.identity=I;class t{constructor(O){this.task=O,this.result=null}get(){if(this.result)return this.result;const O=new c.CancellationTokenSource,R=this.task(O.token);return this.result={promise:R,dispose:()=>{this.result=null,O.cancel(),O.dispose()}},this.result}}e.Cache=t;function I(U){return U}class S{constructor(O,R){this.lastCache=void 0,this.lastArgKey=void 0,typeof O=="function"?(this._fn=O,this._computeKey=I):(this._fn=R,this._computeKey=O.getCacheKey)}get(O){const R=this._computeKey(O);return this.lastArgKey!==R&&(this.lastArgKey=R,this.lastCache=this._fn(O)),this.lastCache}}e.LRUCachedFunction=S;class Y{get cachedValues(){return this._map}constructor(O,R){this._map=new Map,this._map2=new Map,typeof O=="function"?(this._fn=O,this._computeKey=I):(this._fn=R,this._computeKey=O.getCacheKey)}get(O){const R=this._computeKey(O);if(this._map2.has(R))return this._map2.get(R);const B=this._fn(O);return this._map.set(O,B),this._map2.set(R,B),B}}e.CachedFunction=Y}),define(pe[38],be([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MicrotaskDelay=void 0,e.MicrotaskDelay=Symbol("MicrotaskDelay")}),define(pe[25],be([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isString=c,e.isStringArray=t,e.isObject=I,e.isTypedArray=S,e.isNumber=Y,e.isIterable=U,e.isBoolean=O,e.isUndefined=R,e.isDefined=B,e.isUndefinedOrNull=M,e.assertType=T,e.assertIsDefined=C,e.assertAllDefined=u,e.isEmptyObject=a,e.isFunction=_,e.areFunctions=L,e.validateConstraints=b,e.validateConstraint=k,e.upcast=D;function c(n){return typeof n=="string"}function t(n){return Array.isArray(n)&&n.every(i=>c(i))}function I(n){return typeof n=="object"&&n!==null&&!Array.isArray(n)&&!(n instanceof RegExp)&&!(n instanceof Date)}function S(n){const i=Object.getPrototypeOf(Uint8Array);return typeof n=="object"&&n instanceof i}function Y(n){return typeof n=="number"&&!isNaN(n)}function U(n){return!!n&&typeof n[Symbol.iterator]=="function"}function O(n){return n===!0||n===!1}function R(n){return typeof n>"u"}function B(n){return!M(n)}function M(n){return R(n)||n===null}function T(n,i){if(!n)throw new Error(i?`Unexpected type, expected '${i}'`:"Unexpected type")}function C(n){if(M(n))throw new Error("Assertion Failed: argument is undefined or null");return n}function u(...n){const i=[];for(let s=0;s<n.length;s++){const g=n[s];if(M(g))throw new Error(`Assertion Failed: argument at index ${s} is undefined or null`);i.push(g)}return i}const r=Object.prototype.hasOwnProperty;function a(n){if(!I(n))return!1;for(const i in n)if(r.call(n,i))return!1;return!0}function _(n){return typeof n=="function"}function L(...n){return n.length>0&&n.every(_)}function b(n,i){const s=Math.min(n.length,i.length);for(let g=0;g<s;g++)k(n[g],i[g])}function k(n,i){if(c(i)){if(typeof n!==i)throw new Error(`argument does not match constraint: typeof ${i}`)}else if(_(i)){try{if(n instanceof i)return}catch{}if(!M(n)&&n.constructor===i||i.length===1&&i.call(void 0,n)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}function D(n){return n}}),define(pe[39],be([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Constants=void 0,e.toUint8=t,e.toUint32=I;var c;(function(S){S[S.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",S[S.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",S[S.MAX_UINT_8=255]="MAX_UINT_8",S[S.MAX_UINT_16=65535]="MAX_UINT_16",S[S.MAX_UINT_32=4294967295]="MAX_UINT_32",S[S.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(c||(e.Constants=c={}));function t(S){return S<0?0:S>c.MAX_UINT_8?c.MAX_UINT_8:S|0}function I(S){return S<0?0:S>c.MAX_UINT_32?c.MAX_UINT_32:S|0}}),define(pe[4],be([0,1,37,7,15,39]),function(re,e,c,t,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.GraphemeBreakType=e.UTF8_BOM_CHARACTER=e.UNUSUAL_LINE_TERMINATORS=e.GraphemeIterator=e.CodePointIterator=void 0,e.isFalsyOrWhitespace=Y,e.format=O,e.format2=B,e.htmlAttributeEncodeValue=M,e.escape=T,e.escapeRegExpCharacters=C,e.count=u,e.truncate=r,e.truncateMiddle=a,e.trim=_,e.ltrim=L,e.rtrim=b,e.convertSimple2RegExpPattern=k,e.stripWildcards=D,e.createRegExp=n,e.regExpLeadsToEndlessLoop=i,e.splitLines=s,e.splitLinesIncludeSeparators=g,e.firstNonWhitespaceIndex=N,e.getLeadingWhitespace=h,e.lastNonWhitespaceIndex=m,e.replaceAsync=l,e.compare=f,e.compareSubstring=y,e.compareIgnoreCase=A,e.compareSubstringIgnoreCase=p,e.isAsciiDigit=j,e.isLowerAsciiLetter=x,e.isUpperAsciiLetter=J,e.equalsIgnoreCase=G,e.startsWithIgnoreCase=le,e.commonPrefixLength=W,e.commonSuffixLength=K,e.isHighSurrogate=Z,e.isLowSurrogate=ee,e.computeCodePoint=q,e.getNextCodePoint=z,e.nextCharLength=w,e.prevCharLength=ie,e.getCharContainingOffset=se,e.charCount=oe,e.containsRTL=Le,e.isBasicASCII=$,e.containsUnusualLineTerminators=E,e.isFullWidthCharacter=o,e.isEmojiImprecise=v,e.lcut=V,e.forAnsiStringParts=de,e.removeAnsiEscapeCodes=ve,e.removeAnsiEscapeCodesFromPrompt=Ie,e.startsWithUTF8BOM=_e,e.stripUTF8BOM=ae,e.fuzzyContains=me,e.containsUppercaseCharacter=he,e.uppercaseFirstLetter=Ee,e.getNLines=Ae,e.singleLetterHash=Re,e.getGraphemeBreakType=Te,e.getLeftDeleteOffset=He;function Y(d){return!d||typeof d!="string"?!0:d.trim().length===0}const U=/{(\d+)}/g;function O(d,...F){return F.length===0?d:d.replace(U,function(Q,ne){const ge=parseInt(ne,10);return isNaN(ge)||ge<0||ge>=F.length?Q:F[ge]})}const R=/{([^}]+)}/g;function B(d,F){return Object.keys(F).length===0?d:d.replace(R,(Q,ne)=>F[ne]??Q)}function M(d){return d.replace(/[<>"'&]/g,F=>{switch(F){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return F})}function T(d){return d.replace(/[<>&]/g,function(F){switch(F){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return F}})}function C(d){return d.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function u(d,F){let Q=0,ne=d.indexOf(F);for(;ne!==-1;)Q++,ne=d.indexOf(F,ne+F.length);return Q}function r(d,F,Q="\u2026"){return d.length<=F?d:`${d.substr(0,F)}${Q}`}function a(d,F,Q="\u2026"){if(d.length<=F)return d;const ne=Math.ceil(F/2)-Q.length/2,ge=Math.floor(F/2)-Q.length/2;return`${d.substr(0,ne)}${Q}${d.substr(d.length-ge)}`}function _(d,F=" "){const Q=L(d,F);return b(Q,F)}function L(d,F){if(!d||!F)return d;const Q=F.length;if(Q===0||d.length===0)return d;let ne=0;for(;d.indexOf(F,ne)===ne;)ne=ne+Q;return d.substring(ne)}function b(d,F){if(!d||!F)return d;const Q=F.length,ne=d.length;if(Q===0||ne===0)return d;let ge=ne,ye=-1;for(;ye=d.lastIndexOf(F,ge-1),!(ye===-1||ye+Q!==ge);){if(ye===0)return"";ge=ye}return d.substring(0,ge)}function k(d){return d.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function D(d){return d.replace(/\*/g,"")}function n(d,F,Q={}){if(!d)throw new Error("Cannot create regex from empty string");F||(d=C(d)),Q.wholeWord&&(/\B/.test(d.charAt(0))||(d="\\b"+d),/\B/.test(d.charAt(d.length-1))||(d=d+"\\b"));let ne="";return Q.global&&(ne+="g"),Q.matchCase||(ne+="i"),Q.multiline&&(ne+="m"),Q.unicode&&(ne+="u"),new RegExp(d,ne)}function i(d){return d.source==="^"||d.source==="^$"||d.source==="$"||d.source==="^\\s*$"?!1:!!(d.exec("")&&d.lastIndex===0)}function s(d){return d.split(/\r\n|\r|\n/)}function g(d){const F=[],Q=d.split(/(\r\n|\r|\n)/);for(let ne=0;ne<Math.ceil(Q.length/2);ne++)F.push(Q[2*ne]+(Q[2*ne+1]??""));return F}function N(d){for(let F=0,Q=d.length;F<Q;F++){const ne=d.charCodeAt(F);if(ne!==t.CharCode.Space&&ne!==t.CharCode.Tab)return F}return-1}function h(d,F=0,Q=d.length){for(let ne=F;ne<Q;ne++){const ge=d.charCodeAt(ne);if(ge!==t.CharCode.Space&&ge!==t.CharCode.Tab)return d.substring(F,ne)}return d.substring(F,Q)}function m(d,F=d.length-1){for(let Q=F;Q>=0;Q--){const ne=d.charCodeAt(Q);if(ne!==t.CharCode.Space&&ne!==t.CharCode.Tab)return Q}return-1}function l(d,F,Q){const ne=[];let ge=0;for(const ye of d.matchAll(F)){if(ne.push(d.slice(ge,ye.index)),ye.index===void 0)throw new Error("match.index should be defined");ge=ye.index+ye[0].length,ne.push(Q(ye[0],...ye.slice(1),ye.index,d,ye.groups))}return ne.push(d.slice(ge)),Promise.all(ne).then(ye=>ye.join(""))}function f(d,F){return d<F?-1:d>F?1:0}function y(d,F,Q=0,ne=d.length,ge=0,ye=F.length){for(;Q<ne&&ge<ye;Q++,ge++){const Ne=d.charCodeAt(Q),Me=F.charCodeAt(ge);if(Ne<Me)return-1;if(Ne>Me)return 1}const Se=ne-Q,We=ye-ge;return Se<We?-1:Se>We?1:0}function A(d,F){return p(d,F,0,d.length,0,F.length)}function p(d,F,Q=0,ne=d.length,ge=0,ye=F.length){for(;Q<ne&&ge<ye;Q++,ge++){let Ne=d.charCodeAt(Q),Me=F.charCodeAt(ge);if(Ne===Me)continue;if(Ne>=128||Me>=128)return y(d.toLowerCase(),F.toLowerCase(),Q,ne,ge,ye);x(Ne)&&(Ne-=32),x(Me)&&(Me-=32);const Ue=Ne-Me;if(Ue!==0)return Ue}const Se=ne-Q,We=ye-ge;return Se<We?-1:Se>We?1:0}function j(d){return d>=t.CharCode.Digit0&&d<=t.CharCode.Digit9}function x(d){return d>=t.CharCode.a&&d<=t.CharCode.z}function J(d){return d>=t.CharCode.A&&d<=t.CharCode.Z}function G(d,F){return d.length===F.length&&p(d,F)===0}function le(d,F){const Q=F.length;return F.length>d.length?!1:p(d,F,0,Q)===0}function W(d,F){const Q=Math.min(d.length,F.length);let ne;for(ne=0;ne<Q;ne++)if(d.charCodeAt(ne)!==F.charCodeAt(ne))return ne;return Q}function K(d,F){const Q=Math.min(d.length,F.length);let ne;const ge=d.length-1,ye=F.length-1;for(ne=0;ne<Q;ne++)if(d.charCodeAt(ge-ne)!==F.charCodeAt(ye-ne))return ne;return Q}function Z(d){return 55296<=d&&d<=56319}function ee(d){return 56320<=d&&d<=57343}function q(d,F){return(d-55296<<10)+(F-56320)+65536}function z(d,F,Q){const ne=d.charCodeAt(Q);if(Z(ne)&&Q+1<F){const ge=d.charCodeAt(Q+1);if(ee(ge))return q(ne,ge)}return ne}function H(d,F){const Q=d.charCodeAt(F-1);if(ee(Q)&&F>1){const ne=d.charCodeAt(F-2);if(Z(ne))return q(ne,Q)}return Q}class te{get offset(){return this._offset}constructor(F,Q=0){this._str=F,this._len=F.length,this._offset=Q}setOffset(F){this._offset=F}prevCodePoint(){const F=H(this._str,this._offset);return this._offset-=F>=S.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,F}nextCodePoint(){const F=z(this._str,this._len,this._offset);return this._offset+=F>=S.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,F}eol(){return this._offset>=this._len}}e.CodePointIterator=te;class ue{get offset(){return this._iterator.offset}constructor(F,Q=0){this._iterator=new te(F,Q)}nextGraphemeLength(){const F=Fe.getInstance(),Q=this._iterator,ne=Q.offset;let ge=F.getGraphemeBreakType(Q.nextCodePoint());for(;!Q.eol();){const ye=Q.offset,Se=F.getGraphemeBreakType(Q.nextCodePoint());if(Oe(ge,Se)){Q.setOffset(ye);break}ge=Se}return Q.offset-ne}prevGraphemeLength(){const F=Fe.getInstance(),Q=this._iterator,ne=Q.offset;let ge=F.getGraphemeBreakType(Q.prevCodePoint());for(;Q.offset>0;){const ye=Q.offset,Se=F.getGraphemeBreakType(Q.prevCodePoint());if(Oe(Se,ge)){Q.setOffset(ye);break}ge=Se}return ne-Q.offset}eol(){return this._iterator.eol()}}e.GraphemeIterator=ue;function w(d,F){return new ue(d,F).nextGraphemeLength()}function ie(d,F){return new ue(d,F).prevGraphemeLength()}function se(d,F){F>0&&ee(d.charCodeAt(F))&&F--;const Q=F+w(d,F);return[Q-ie(d,Q),Q]}function oe(d){const F=new ue(d);let Q=0;for(;!F.eol();)Q++,F.nextGraphemeLength();return Q}let ce;function fe(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function Le(d){return ce||(ce=fe()),ce.test(d)}const P=/^[\t\n\r\x20-\x7E]*$/;function $(d){return P.test(d)}e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function E(d){return e.UNUSUAL_LINE_TERMINATORS.test(d)}function o(d){return d>=11904&&d<=55215||d>=63744&&d<=64255||d>=65281&&d<=65374}function v(d){return d>=127462&&d<=127487||d===8986||d===8987||d===9200||d===9203||d>=9728&&d<=10175||d===11088||d===11093||d>=127744&&d<=128591||d>=128640&&d<=128764||d>=128992&&d<=129008||d>=129280&&d<=129535||d>=129648&&d<=129782}function V(d,F,Q=""){const ne=d.trimStart();if(ne.length<F)return ne;const ge=/\b/g;let ye=0;for(;ge.test(ne)&&!(ne.length-ge.lastIndex<F);)ye=ge.lastIndex,ge.lastIndex+=1;return ye===0?ne:Q+ne.substring(ye).trimStart()}const X=/(?:(?:\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~])|(:?\x1b\].*?\x07)/g;function*de(d){let F=0;for(const Q of d.matchAll(X))F!==Q.index&&(yield{isCode:!1,str:d.substring(F,Q.index)}),yield{isCode:!0,str:Q[0]},F=Q.index+Q[0].length;F!==d.length&&(yield{isCode:!1,str:d.substring(F)})}function ve(d){return d&&(d=d.replace(X,"")),d}const De=/\\\[.*?\\\]/g;function Ie(d){return ve(d).replace(De,"")}e.UTF8_BOM_CHARACTER=String.fromCharCode(t.CharCode.UTF8_BOM);function _e(d){return!!(d&&d.length>0&&d.charCodeAt(0)===t.CharCode.UTF8_BOM)}function ae(d){return _e(d)?d.substr(1):d}function me(d,F){if(!d||!F||d.length<F.length)return!1;const Q=F.length,ne=d.toLowerCase();let ge=0,ye=-1;for(;ge<Q;){const Se=ne.indexOf(F[ge],ye+1);if(Se<0)return!1;ye=Se,ge++}return!0}function he(d,F=!1){return d?(F&&(d=d.replace(/\\./g,"")),d.toLowerCase()!==d):!1}function Ee(d){return d.charAt(0).toUpperCase()+d.slice(1)}function Ae(d,F=1){if(F===0)return"";let Q=-1;do Q=d.indexOf(`
`,Q+1),F--;while(F>0&&Q>=0);return Q===-1?d:(d[Q-1]==="\r"&&Q--,d.substr(0,Q))}function Re(d){const F=t.CharCode.Z-t.CharCode.A+1;return d=d%(2*F),d<F?String.fromCharCode(t.CharCode.a+d):String.fromCharCode(t.CharCode.A+d-F)}function Te(d){return Fe.getInstance().getGraphemeBreakType(d)}function Oe(d,F){return d===we.Other?F!==we.Extend&&F!==we.SpacingMark:d===we.CR&&F===we.LF?!1:d===we.Control||d===we.CR||d===we.LF||F===we.Control||F===we.CR||F===we.LF?!0:!(d===we.L&&(F===we.L||F===we.V||F===we.LV||F===we.LVT)||(d===we.LV||d===we.V)&&(F===we.V||F===we.T)||(d===we.LVT||d===we.T)&&F===we.T||F===we.Extend||F===we.ZWJ||F===we.SpacingMark||d===we.Prepend||d===we.ZWJ&&F===we.Extended_Pictographic||d===we.Regional_Indicator&&F===we.Regional_Indicator)}var we;(function(d){d[d.Other=0]="Other",d[d.Prepend=1]="Prepend",d[d.CR=2]="CR",d[d.LF=3]="LF",d[d.Control=4]="Control",d[d.Extend=5]="Extend",d[d.Regional_Indicator=6]="Regional_Indicator",d[d.SpacingMark=7]="SpacingMark",d[d.L=8]="L",d[d.V=9]="V",d[d.T=10]="T",d[d.LV=11]="LV",d[d.LVT=12]="LVT",d[d.ZWJ=13]="ZWJ",d[d.Extended_Pictographic=14]="Extended_Pictographic"})(we||(e.GraphemeBreakType=we={}));class Fe{static{this._INSTANCE=null}static getInstance(){return Fe._INSTANCE||(Fe._INSTANCE=new Fe),Fe._INSTANCE}constructor(){this._data=qe()}getGraphemeBreakType(F){if(F<32)return F===t.CharCode.LineFeed?we.LF:F===t.CharCode.CarriageReturn?we.CR:we.Control;if(F<127)return we.Other;const Q=this._data,ne=Q.length/3;let ge=1;for(;ge<=ne;)if(F<Q[3*ge])ge=2*ge;else if(F>Q[3*ge+1])ge=2*ge+1;else return Q[3*ge+2];return we.Other}}function qe(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function He(d,F){if(d===0)return 0;const Q=Ce(d,F);if(Q!==void 0)return Q;const ne=new te(F,d);return ne.prevCodePoint(),ne.offset}function Ce(d,F){const Q=new te(F,d);let ne=Q.prevCodePoint();for(;Ke(ne)||ne===$e.emojiVariantSelector||ne===$e.enclosingKeyCap;){if(Q.offset===0)return;ne=Q.prevCodePoint()}if(!v(ne))return;let ge=Q.offset;return ge>0&&Q.prevCodePoint()===$e.zwj&&(ge=Q.offset),ge}function Ke(d){return 127995<=d&&d<=127999}var $e;(function(d){d[d.zwj=8205]="zwj",d[d.emojiVariantSelector=65039]="emojiVariantSelector",d[d.enclosingKeyCap=8419]="enclosingKeyCap"})($e||($e={})),e.noBreakWhitespace="\xA0";class je{static{this.ambiguousCharacterData=new I.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.cache=new c.LRUCachedFunction({getCacheKey:JSON.stringify},F=>{function Q(Ue){const Be=new Map;for(let ke=0;ke<Ue.length;ke+=2)Be.set(Ue[ke],Ue[ke+1]);return Be}function ne(Ue,Be){const ke=new Map(Ue);for(const[Ve,Qe]of Be)ke.set(Ve,Qe);return ke}function ge(Ue,Be){if(!Ue)return Be;const ke=new Map;for(const[Ve,Qe]of Ue)Be.has(Ve)&&ke.set(Ve,Qe);return ke}const ye=this.ambiguousCharacterData.value;let Se=F.filter(Ue=>!Ue.startsWith("_")&&Ue in ye);Se.length===0&&(Se=["_default"]);let We;for(const Ue of Se){const Be=Q(ye[Ue]);We=ge(We,Be)}const Ne=Q(ye._common),Me=ne(Ne,We);return new je(Me)})}static getInstance(F){return je.cache.get(Array.from(F))}static{this._locales=new I.Lazy(()=>Object.keys(je.ambiguousCharacterData.value).filter(F=>!F.startsWith("_")))}static getLocales(){return je._locales.value}constructor(F){this.confusableDictionary=F}isAmbiguous(F){return this.confusableDictionary.has(F)}containsAmbiguousCharacter(F){for(let Q=0;Q<F.length;Q++){const ne=F.codePointAt(Q);if(typeof ne=="number"&&this.isAmbiguous(ne))return!0}return!1}getPrimaryConfusable(F){return this.confusableDictionary.get(F)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}e.AmbiguousCharacters=je;class ze{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this._data=void 0}static getData(){return this._data||(this._data=new Set(ze.getRawData())),this._data}static isInvisibleCharacter(F){return ze.getData().has(F)}static containsInvisibleCharacter(F){for(let Q=0;Q<F.length;Q++){const ne=F.codePointAt(Q);if(typeof ne=="number"&&ze.isInvisibleCharacter(ne))return!0}return!1}static get codePoints(){return ze.getData()}}e.InvisibleCharacters=ze}),define(pe[40],be([0,1,14,7,4]),function(re,e,c,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class S{constructor(){this._value="",this._pos=0}reset(u){return this._value=u,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(u){const r=u.charCodeAt(0),a=this._value.charCodeAt(this._pos);return r-a}value(){return this._value[this._pos]}}e.StringIterator=S;class Y{constructor(u=!0){this._caseSensitive=u}reset(u){return this._value=u,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let u=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===t.CharCode.Period)if(u)this._from++;else break;else u=!1;return this}cmp(u){return this._caseSensitive?(0,I.compareSubstring)(u,this._value,0,u.length,this._from,this._to):(0,I.compareSubstringIgnoreCase)(u,this._value,0,u.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=Y;class U{constructor(u=!0,r=!0){this._splitOnBackslash=u,this._caseSensitive=r}reset(u){this._from=0,this._to=0,this._value=u,this._valueLen=u.length;for(let r=u.length-1;r>=0;r--,this._valueLen--){const a=this._value.charCodeAt(r);if(!(a===t.CharCode.Slash||this._splitOnBackslash&&a===t.CharCode.Backslash))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let u=!0;for(;this._to<this._valueLen;this._to++){const r=this._value.charCodeAt(this._to);if(r===t.CharCode.Slash||this._splitOnBackslash&&r===t.CharCode.Backslash)if(u)this._from++;else break;else u=!1}return this}cmp(u){return this._caseSensitive?(0,I.compareSubstring)(u,this._value,0,u.length,this._from,this._to):(0,I.compareSubstringIgnoreCase)(u,this._value,0,u.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=U;var O;(function(C){C[C.Scheme=1]="Scheme",C[C.Authority=2]="Authority",C[C.Path=3]="Path",C[C.Query=4]="Query",C[C.Fragment=5]="Fragment"})(O||(O={}));class R{constructor(u,r){this._ignorePathCasing=u,this._ignoreQueryAndFragment=r,this._states=[],this._stateIdx=0}reset(u){return this._value=u,this._states=[],this._value.scheme&&this._states.push(O.Scheme),this._value.authority&&this._states.push(O.Authority),this._value.path&&(this._pathIterator=new U(!1,!this._ignorePathCasing(u)),this._pathIterator.reset(u.path),this._pathIterator.value()&&this._states.push(O.Path)),this._ignoreQueryAndFragment(u)||(this._value.query&&this._states.push(O.Query),this._value.fragment&&this._states.push(O.Fragment)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===O.Path&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===O.Path&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(u){if(this._states[this._stateIdx]===O.Scheme)return(0,I.compareIgnoreCase)(u,this._value.scheme);if(this._states[this._stateIdx]===O.Authority)return(0,I.compareIgnoreCase)(u,this._value.authority);if(this._states[this._stateIdx]===O.Path)return this._pathIterator.cmp(u);if(this._states[this._stateIdx]===O.Query)return(0,I.compare)(u,this._value.query);if(this._states[this._stateIdx]===O.Fragment)return(0,I.compare)(u,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===O.Scheme)return this._value.scheme;if(this._states[this._stateIdx]===O.Authority)return this._value.authority;if(this._states[this._stateIdx]===O.Path)return this._pathIterator.value();if(this._states[this._stateIdx]===O.Query)return this._value.query;if(this._states[this._stateIdx]===O.Fragment)return this._value.fragment;throw new Error}}e.UriIterator=R;class B{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const u=this.right;return this.right=u.left,u.left=this,this.updateHeight(),u.updateHeight(),u}rotateRight(){const u=this.left;return this.left=u.right,u.right=this,this.updateHeight(),u.updateHeight(),u}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var M;(function(C){C[C.Left=-1]="Left",C[C.Mid=0]="Mid",C[C.Right=1]="Right"})(M||(M={}));class T{static forUris(u=()=>!1,r=()=>!1){return new T(new R(u,r))}static forPaths(u=!1){return new T(new U(void 0,!u))}static forStrings(){return new T(new S)}static forConfigKeys(){return new T(new Y)}constructor(u){this._iter=u}clear(){this._root=void 0}fill(u,r){if(r){const a=r.slice(0);(0,c.shuffle)(a);for(const _ of a)this.set(_,u)}else{const a=u.slice(0);(0,c.shuffle)(a);for(const _ of a)this.set(_[0],_[1])}}set(u,r){const a=this._iter.reset(u);let _;this._root||(this._root=new B,this._root.segment=a.value());const L=[];for(_=this._root;;){const k=a.cmp(_.segment);if(k>0)_.left||(_.left=new B,_.left.segment=a.value()),L.push([M.Left,_]),_=_.left;else if(k<0)_.right||(_.right=new B,_.right.segment=a.value()),L.push([M.Right,_]),_=_.right;else if(a.hasNext())a.next(),_.mid||(_.mid=new B,_.mid.segment=a.value()),L.push([M.Mid,_]),_=_.mid;else break}const b=_.value;_.value=r,_.key=u;for(let k=L.length-1;k>=0;k--){const D=L[k][1];D.updateHeight();const n=D.balanceFactor();if(n<-1||n>1){const i=L[k][0],s=L[k+1][0];if(i===M.Right&&s===M.Right)L[k][1]=D.rotateLeft();else if(i===M.Left&&s===M.Left)L[k][1]=D.rotateRight();else if(i===M.Right&&s===M.Left)D.right=L[k+1][1]=L[k+1][1].rotateRight(),L[k][1]=D.rotateLeft();else if(i===M.Left&&s===M.Right)D.left=L[k+1][1]=L[k+1][1].rotateLeft(),L[k][1]=D.rotateRight();else throw new Error;if(k>0)switch(L[k-1][0]){case M.Left:L[k-1][1].left=L[k][1];break;case M.Right:L[k-1][1].right=L[k][1];break;case M.Mid:L[k-1][1].mid=L[k][1];break}else this._root=L[0][1]}}return b}get(u){return this._getNode(u)?.value}_getNode(u){const r=this._iter.reset(u);let a=this._root;for(;a;){const _=r.cmp(a.segment);if(_>0)a=a.left;else if(_<0)a=a.right;else if(r.hasNext())r.next(),a=a.mid;else break}return a}has(u){const r=this._getNode(u);return!(r?.value===void 0&&r?.mid===void 0)}delete(u){return this._delete(u,!1)}deleteSuperstr(u){return this._delete(u,!0)}_delete(u,r){const a=this._iter.reset(u),_=[];let L=this._root;for(;L;){const b=a.cmp(L.segment);if(b>0)_.push([M.Left,L]),L=L.left;else if(b<0)_.push([M.Right,L]),L=L.right;else if(a.hasNext())a.next(),_.push([M.Mid,L]),L=L.mid;else break}if(L){if(r?(L.left=void 0,L.mid=void 0,L.right=void 0,L.height=1):(L.key=void 0,L.value=void 0),!L.mid&&!L.value)if(L.left&&L.right){const b=this._min(L.right);if(b.key){const{key:k,value:D,segment:n}=b;this._delete(b.key,!1),L.key=k,L.value=D,L.segment=n}}else{const b=L.left??L.right;if(_.length>0){const[k,D]=_[_.length-1];switch(k){case M.Left:D.left=b;break;case M.Mid:D.mid=b;break;case M.Right:D.right=b;break}}else this._root=b}for(let b=_.length-1;b>=0;b--){const k=_[b][1];k.updateHeight();const D=k.balanceFactor();if(D>1?(k.right.balanceFactor()>=0||(k.right=k.right.rotateRight()),_[b][1]=k.rotateLeft()):D<-1&&(k.left.balanceFactor()<=0||(k.left=k.left.rotateLeft()),_[b][1]=k.rotateRight()),b>0)switch(_[b-1][0]){case M.Left:_[b-1][1].left=_[b][1];break;case M.Right:_[b-1][1].right=_[b][1];break;case M.Mid:_[b-1][1].mid=_[b][1];break}else this._root=_[0][1]}}}_min(u){for(;u.left;)u=u.left;return u}findSubstr(u){const r=this._iter.reset(u);let a=this._root,_;for(;a;){const L=r.cmp(a.segment);if(L>0)a=a.left;else if(L<0)a=a.right;else if(r.hasNext())r.next(),_=a.value||_,a=a.mid;else break}return a&&a.value||_}findSuperstr(u){return this._findSuperstrOrElement(u,!1)}_findSuperstrOrElement(u,r){const a=this._iter.reset(u);let _=this._root;for(;_;){const L=a.cmp(_.segment);if(L>0)_=_.left;else if(L<0)_=_.right;else if(a.hasNext())a.next(),_=_.mid;else return _.mid?this._entries(_.mid):r?_.value:void 0}}hasElementOrSubtree(u){return this._findSuperstrOrElement(u,!0)!==void 0}forEach(u){for(const[r,a]of this)u(a,r)}*[Symbol.iterator](){yield*this._entries(this._root)}_entries(u){const r=[];return this._dfsEntries(u,r),r[Symbol.iterator]()}_dfsEntries(u,r){u&&(u.left&&this._dfsEntries(u.left,r),u.value&&r.push([u.key,u.value]),u.mid&&this._dfsEntries(u.mid,r),u.right&&this._dfsEntries(u.right,r))}_isBalanced(){const u=r=>{if(!r)return!0;const a=r.balanceFactor();return a<-1||a>1?!1:u(r.left)&&u(r.right)};return u(this._root)}}e.TernarySearchTree=T});var Ye=this&&this.__createBinding||(Object.create?function(re,e,c,t){t===void 0&&(t=c);var I=Object.getOwnPropertyDescriptor(e,c);(!I||("get"in I?!e.__esModule:I.writable||I.configurable))&&(I={enumerable:!0,get:function(){return e[c]}}),Object.defineProperty(re,t,I)}:function(re,e,c,t){t===void 0&&(t=c),re[t]=e[c]}),Xe=this&&this.__setModuleDefault||(Object.create?function(re,e){Object.defineProperty(re,"default",{enumerable:!0,value:e})}:function(re,e){re.default=e}),Pe=this&&this.__importStar||function(re){if(re&&re.__esModule)return re;var e={};if(re!=null)for(var c in re)c!=="default"&&Object.prototype.hasOwnProperty.call(re,c)&&Ye(e,re,c);return Xe(e,re),e};define(pe[41],be([0,1,53]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BROWSER_RESTRICTED_PORTS=void 0,e.findFreePort=t,e.findFreePortFaster=S,c=Pe(c);function t(U,O,R,B=1){let M=!1;return new Promise(T=>{const C=setTimeout(()=>{if(!M)return M=!0,T(0)},R);I(U,O,B,u=>{if(!M)return M=!0,clearTimeout(C),T(u)})})}function I(U,O,R,B){if(O===0)return B(0);const M=new c.Socket;M.once("connect",()=>(Y(M),I(U+R,O-1,R,B))),M.once("data",()=>{}),M.once("error",T=>(Y(M),T.code!=="ECONNREFUSED"?I(U+R,O-1,R,B):B(U))),M.connect(U,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function S(U,O,R,B="127.0.0.1"){let M=!1,T,C=1;const u=c.createServer({pauseOnConnect:!0});function r(a,_){M||(M=!0,u.removeAllListeners(),u.close(),T&&clearTimeout(T),_(a))}return new Promise(a=>{T=setTimeout(()=>{r(0,a)},R),u.on("listening",()=>{r(U,a)}),u.on("error",_=>{_&&(_.code==="EADDRINUSE"||_.code==="EACCES")&&C<O?(U++,C++,u.listen(U,B)):r(0,a)}),u.on("close",()=>{r(0,a)}),u.listen(U,B)})}function Y(U){try{U.removeAllListeners("connect"),U.removeAllListeners("error"),U.end(),U.destroy(),U.unref()}catch(O){console.error(O)}}}),function(){function re(){function e(){return process.uncHostAllowlist}function c(O){const R=new Set;if(Array.isArray(O))for(const B of O)typeof B=="string"&&R.add(B);return Array.from(R)}function t(){const O=e();return O?Array.from(O):[]}function I(O){if(process.platform!=="win32")return;const R=e();if(R)if(typeof O=="string")R.add(O.toLowerCase());else for(const B of c(O))I(B)}function S(O){if(typeof O!="string")return;const R=["\\\\.\\UNC\\","\\\\?\\UNC\\","\\\\"];let B;for(const M of R){if(O.indexOf(M)!==0)continue;const C=O.indexOf("\\",M.length);if(C===-1)continue;const u=O.substring(M.length,C);if(u){B=u;break}}return B}function Y(){process.platform==="win32"&&(process.restrictUNCAccess=!1)}function U(){return process.platform!=="win32"?!0:process.restrictUNCAccess===!1}return{getUNCHostAllowlist:t,addUNCHostToAllowlist:I,getUNCHost:S,disableUNCAccessRestrictions:Y,isUNCAccessRestrictionsDisabled:U}}typeof define=="function"?define("vs/base/node/unc",[],function(){return re()}):typeof module=="object"&&typeof module.exports=="object"?module.exports=re():console.trace("vs/base/node/unc defined in UNKNOWN context (neither requirejs or commonjs)")}(),define(pe[26],be([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNLSMessages=c,e.getNLSLanguage=t;function c(){return globalThis._VSCODE_NLS_MESSAGES}function t(){return globalThis._VSCODE_NLS_LANGUAGE}}),define(pe[13],be([0,1,26,26]),function(re,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNLSMessages=e.getNLSLanguage=void 0,e.localize=Y,e.localize2=O,Object.defineProperty(e,"getNLSLanguage",{enumerable:!0,get:function(){return t.getNLSLanguage}}),Object.defineProperty(e,"getNLSMessages",{enumerable:!0,get:function(){return t.getNLSMessages}});const I=(0,c.getNLSLanguage)()==="pseudo"||typeof document<"u"&&document.location&&document.location.hash.indexOf("pseudo=true")>=0;function S(R,B){let M;return B.length===0?M=R:M=R.replace(/\{(\d+)\}/g,(T,C)=>{const u=C[0],r=B[u];let a=T;return typeof r=="string"?a=r:(typeof r=="number"||typeof r=="boolean"||r===void 0||r===null)&&(a=String(r)),a}),I&&(M="\uFF3B"+M.replace(/[aouei]/g,"$&$&")+"\uFF3D"),M}function Y(R,B,...M){return S(typeof R=="number"?U(R,B):B,M)}function U(R,B){const M=(0,c.getNLSMessages)()?.[R];if(typeof M!="string"){if(typeof B=="string")return B;throw new Error(`!!! NLS MISSING: ${R} !!!`)}return M}function O(R,B,...M){let T;typeof R=="number"?T=U(R,B):T=B;const C=S(T,M);return{value:C,original:B===T?C:S(B,M)}}}),define(pe[2],be([0,1,13]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.platformLocale=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isMobile=e.isIOS=e.webWorkerOrigin=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.Platform=e.LANGUAGE_DEFAULT=void 0,e.PlatformToString=i,e.isLittleEndian=l,e.isBigSurOrNewer=f,c=Pe(c),e.LANGUAGE_DEFAULT="en";let t=!1,I=!1,S=!1,Y=!1,U=!1,O=!1,R=!1,B=!1,M=!1,T=!1,C,u=e.LANGUAGE_DEFAULT,r=e.LANGUAGE_DEFAULT,a,_;const L=globalThis;let b;typeof L.vscode<"u"&&typeof L.vscode.process<"u"?b=L.vscode.process:typeof process<"u"&&typeof process?.versions?.node=="string"&&(b=process);const k=typeof b?.versions?.electron=="string",D=k&&b?.type==="renderer";if(typeof b=="object"){t=b.platform==="win32",I=b.platform==="darwin",S=b.platform==="linux",Y=S&&!!b.env.SNAP&&!!b.env.SNAP_REVISION,R=k,M=!!b.env.CI||!!b.env.BUILD_ARTIFACTSTAGINGDIRECTORY,C=e.LANGUAGE_DEFAULT,u=e.LANGUAGE_DEFAULT;const y=b.env.VSCODE_NLS_CONFIG;if(y)try{const A=JSON.parse(y);C=A.userLocale,r=A.osLocale,u=A.resolvedLanguage||e.LANGUAGE_DEFAULT,a=A.languagePack?.translationsConfigFile}catch{}U=!0}else typeof navigator=="object"&&!D?(_=navigator.userAgent,t=_.indexOf("Windows")>=0,I=_.indexOf("Macintosh")>=0,B=(_.indexOf("Macintosh")>=0||_.indexOf("iPad")>=0||_.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,S=_.indexOf("Linux")>=0,T=_?.indexOf("Mobi")>=0,O=!0,u=c.getNLSLanguage()||e.LANGUAGE_DEFAULT,C=navigator.language.toLowerCase(),r=C):console.error("Unable to resolve platform.");var n;(function(y){y[y.Web=0]="Web",y[y.Mac=1]="Mac",y[y.Linux=2]="Linux",y[y.Windows=3]="Windows"})(n||(e.Platform=n={}));function i(y){switch(y){case n.Web:return"Web";case n.Mac:return"Mac";case n.Linux:return"Linux";case n.Windows:return"Windows"}}let s=n.Web;I?s=n.Mac:t?s=n.Windows:S&&(s=n.Linux),e.isWindows=t,e.isMacintosh=I,e.isLinux=S,e.isLinuxSnap=Y,e.isNative=U,e.isElectron=R,e.isWeb=O,e.isWebWorker=O&&typeof L.importScripts=="function",e.webWorkerOrigin=e.isWebWorker?L.origin:void 0,e.isIOS=B,e.isMobile=T,e.isCI=M,e.platform=s,e.userAgent=_,e.language=u;var g;(function(y){function A(){return e.language}y.value=A;function p(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}y.isDefaultVariant=p;function j(){return e.language==="en"}y.isDefault=j})(g||(e.Language=g={})),e.locale=C,e.platformLocale=r,e.translationsConfigFile=a,e.setTimeout0IsFaster=typeof L.postMessage=="function"&&!L.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const y=[];L.addEventListener("message",p=>{if(p.data&&p.data.vscodeScheduleAsyncWork)for(let j=0,x=y.length;j<x;j++){const J=y[j];if(J.id===p.data.vscodeScheduleAsyncWork){y.splice(j,1),J.callback();return}}});let A=0;return p=>{const j=++A;y.push({id:j,callback:p}),L.postMessage({vscodeScheduleAsyncWork:j},"*")}}return y=>setTimeout(y)})();var N;(function(y){y[y.Windows=1]="Windows",y[y.Macintosh=2]="Macintosh",y[y.Linux=3]="Linux"})(N||(e.OperatingSystem=N={})),e.OS=I||B?N.Macintosh:t?N.Windows:N.Linux;let h=!0,m=!1;function l(){if(!m){m=!0;const y=new Uint8Array(2);y[0]=1,y[1]=2,h=new Uint16Array(y.buffer)[0]===513}return h}e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0);function f(y){return parseFloat(y)>=20}}),define(pe[18],be([0,1,2]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let t;const I=globalThis.vscode;if(typeof I<"u"&&typeof I.process<"u"){const S=I.process;t={get platform(){return S.platform},get arch(){return S.arch},get env(){return S.env},cwd(){return S.cwd()}}}else typeof process<"u"&&typeof process?.versions?.node=="string"?t={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:t={get platform(){return c.isWindows?"win32":c.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=t.cwd,e.env=t.env,e.platform=t.platform,e.arch=t.arch}),define(pe[3],be([0,1,18]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0,c=Pe(c);const t=65,I=97,S=90,Y=122,U=46,O=47,R=92,B=58,M=63;class T extends Error{constructor(s,g,N){let h;typeof g=="string"&&g.indexOf("not ")===0?(h="must not be",g=g.replace(/^not /,"")):h="must be";const m=s.indexOf(".")!==-1?"property":"argument";let l=`The "${s}" ${m} ${h} of type ${g}`;l+=`. Received type ${typeof N}`,super(l),this.code="ERR_INVALID_ARG_TYPE"}}function C(i,s){if(i===null||typeof i!="object")throw new T(s,"Object",i)}function u(i,s){if(typeof i!="string")throw new T(s,"string",i)}const r=c.platform==="win32";function a(i){return i===O||i===R}function _(i){return i===O}function L(i){return i>=t&&i<=S||i>=I&&i<=Y}function b(i,s,g,N){let h="",m=0,l=-1,f=0,y=0;for(let A=0;A<=i.length;++A){if(A<i.length)y=i.charCodeAt(A);else{if(N(y))break;y=O}if(N(y)){if(!(l===A-1||f===1))if(f===2){if(h.length<2||m!==2||h.charCodeAt(h.length-1)!==U||h.charCodeAt(h.length-2)!==U){if(h.length>2){const p=h.lastIndexOf(g);p===-1?(h="",m=0):(h=h.slice(0,p),m=h.length-1-h.lastIndexOf(g)),l=A,f=0;continue}else if(h.length!==0){h="",m=0,l=A,f=0;continue}}s&&(h+=h.length>0?`${g}..`:"..",m=2)}else h.length>0?h+=`${g}${i.slice(l+1,A)}`:h=i.slice(l+1,A),m=A-l-1;l=A,f=0}else y===U&&f!==-1?++f:f=-1}return h}function k(i){return i?`${i[0]==="."?"":"."}${i}`:""}function D(i,s){C(s,"pathObject");const g=s.dir||s.root,N=s.base||`${s.name||""}${k(s.ext)}`;return g?g===s.root?`${g}${N}`:`${g}${i}${N}`:N}e.win32={resolve(...i){let s="",g="",N=!1;for(let h=i.length-1;h>=-1;h--){let m;if(h>=0){if(m=i[h],u(m,`paths[${h}]`),m.length===0)continue}else s.length===0?m=c.cwd():(m=c.env[`=${s}`]||c.cwd(),(m===void 0||m.slice(0,2).toLowerCase()!==s.toLowerCase()&&m.charCodeAt(2)===R)&&(m=`${s}\\`));const l=m.length;let f=0,y="",A=!1;const p=m.charCodeAt(0);if(l===1)a(p)&&(f=1,A=!0);else if(a(p))if(A=!0,a(m.charCodeAt(1))){let j=2,x=j;for(;j<l&&!a(m.charCodeAt(j));)j++;if(j<l&&j!==x){const J=m.slice(x,j);for(x=j;j<l&&a(m.charCodeAt(j));)j++;if(j<l&&j!==x){for(x=j;j<l&&!a(m.charCodeAt(j));)j++;(j===l||j!==x)&&(y=`\\\\${J}\\${m.slice(x,j)}`,f=j)}}}else f=1;else L(p)&&m.charCodeAt(1)===B&&(y=m.slice(0,2),f=2,l>2&&a(m.charCodeAt(2))&&(A=!0,f=3));if(y.length>0)if(s.length>0){if(y.toLowerCase()!==s.toLowerCase())continue}else s=y;if(N){if(s.length>0)break}else if(g=`${m.slice(f)}\\${g}`,N=A,A&&s.length>0)break}return g=b(g,!N,"\\",a),N?`${s}\\${g}`:`${s}${g}`||"."},normalize(i){u(i,"path");const s=i.length;if(s===0)return".";let g=0,N,h=!1;const m=i.charCodeAt(0);if(s===1)return _(m)?"\\":i;if(a(m))if(h=!0,a(i.charCodeAt(1))){let f=2,y=f;for(;f<s&&!a(i.charCodeAt(f));)f++;if(f<s&&f!==y){const A=i.slice(y,f);for(y=f;f<s&&a(i.charCodeAt(f));)f++;if(f<s&&f!==y){for(y=f;f<s&&!a(i.charCodeAt(f));)f++;if(f===s)return`\\\\${A}\\${i.slice(y)}\\`;f!==y&&(N=`\\\\${A}\\${i.slice(y,f)}`,g=f)}}}else g=1;else L(m)&&i.charCodeAt(1)===B&&(N=i.slice(0,2),g=2,s>2&&a(i.charCodeAt(2))&&(h=!0,g=3));let l=g<s?b(i.slice(g),!h,"\\",a):"";return l.length===0&&!h&&(l="."),l.length>0&&a(i.charCodeAt(s-1))&&(l+="\\"),N===void 0?h?`\\${l}`:l:h?`${N}\\${l}`:`${N}${l}`},isAbsolute(i){u(i,"path");const s=i.length;if(s===0)return!1;const g=i.charCodeAt(0);return a(g)||s>2&&L(g)&&i.charCodeAt(1)===B&&a(i.charCodeAt(2))},join(...i){if(i.length===0)return".";let s,g;for(let m=0;m<i.length;++m){const l=i[m];u(l,"path"),l.length>0&&(s===void 0?s=g=l:s+=`\\${l}`)}if(s===void 0)return".";let N=!0,h=0;if(typeof g=="string"&&a(g.charCodeAt(0))){++h;const m=g.length;m>1&&a(g.charCodeAt(1))&&(++h,m>2&&(a(g.charCodeAt(2))?++h:N=!1))}if(N){for(;h<s.length&&a(s.charCodeAt(h));)h++;h>=2&&(s=`\\${s.slice(h)}`)}return e.win32.normalize(s)},relative(i,s){if(u(i,"from"),u(s,"to"),i===s)return"";const g=e.win32.resolve(i),N=e.win32.resolve(s);if(g===N||(i=g.toLowerCase(),s=N.toLowerCase(),i===s))return"";let h=0;for(;h<i.length&&i.charCodeAt(h)===R;)h++;let m=i.length;for(;m-1>h&&i.charCodeAt(m-1)===R;)m--;const l=m-h;let f=0;for(;f<s.length&&s.charCodeAt(f)===R;)f++;let y=s.length;for(;y-1>f&&s.charCodeAt(y-1)===R;)y--;const A=y-f,p=l<A?l:A;let j=-1,x=0;for(;x<p;x++){const G=i.charCodeAt(h+x);if(G!==s.charCodeAt(f+x))break;G===R&&(j=x)}if(x!==p){if(j===-1)return N}else{if(A>p){if(s.charCodeAt(f+x)===R)return N.slice(f+x+1);if(x===2)return N.slice(f+x)}l>p&&(i.charCodeAt(h+x)===R?j=x:x===2&&(j=3)),j===-1&&(j=0)}let J="";for(x=h+j+1;x<=m;++x)(x===m||i.charCodeAt(x)===R)&&(J+=J.length===0?"..":"\\..");return f+=j,J.length>0?`${J}${N.slice(f,y)}`:(N.charCodeAt(f)===R&&++f,N.slice(f,y))},toNamespacedPath(i){if(typeof i!="string"||i.length===0)return i;const s=e.win32.resolve(i);if(s.length<=2)return i;if(s.charCodeAt(0)===R){if(s.charCodeAt(1)===R){const g=s.charCodeAt(2);if(g!==M&&g!==U)return`\\\\?\\UNC\\${s.slice(2)}`}}else if(L(s.charCodeAt(0))&&s.charCodeAt(1)===B&&s.charCodeAt(2)===R)return`\\\\?\\${s}`;return i},dirname(i){u(i,"path");const s=i.length;if(s===0)return".";let g=-1,N=0;const h=i.charCodeAt(0);if(s===1)return a(h)?i:".";if(a(h)){if(g=N=1,a(i.charCodeAt(1))){let f=2,y=f;for(;f<s&&!a(i.charCodeAt(f));)f++;if(f<s&&f!==y){for(y=f;f<s&&a(i.charCodeAt(f));)f++;if(f<s&&f!==y){for(y=f;f<s&&!a(i.charCodeAt(f));)f++;if(f===s)return i;f!==y&&(g=N=f+1)}}}}else L(h)&&i.charCodeAt(1)===B&&(g=s>2&&a(i.charCodeAt(2))?3:2,N=g);let m=-1,l=!0;for(let f=s-1;f>=N;--f)if(a(i.charCodeAt(f))){if(!l){m=f;break}}else l=!1;if(m===-1){if(g===-1)return".";m=g}return i.slice(0,m)},basename(i,s){s!==void 0&&u(s,"suffix"),u(i,"path");let g=0,N=-1,h=!0,m;if(i.length>=2&&L(i.charCodeAt(0))&&i.charCodeAt(1)===B&&(g=2),s!==void 0&&s.length>0&&s.length<=i.length){if(s===i)return"";let l=s.length-1,f=-1;for(m=i.length-1;m>=g;--m){const y=i.charCodeAt(m);if(a(y)){if(!h){g=m+1;break}}else f===-1&&(h=!1,f=m+1),l>=0&&(y===s.charCodeAt(l)?--l===-1&&(N=m):(l=-1,N=f))}return g===N?N=f:N===-1&&(N=i.length),i.slice(g,N)}for(m=i.length-1;m>=g;--m)if(a(i.charCodeAt(m))){if(!h){g=m+1;break}}else N===-1&&(h=!1,N=m+1);return N===-1?"":i.slice(g,N)},extname(i){u(i,"path");let s=0,g=-1,N=0,h=-1,m=!0,l=0;i.length>=2&&i.charCodeAt(1)===B&&L(i.charCodeAt(0))&&(s=N=2);for(let f=i.length-1;f>=s;--f){const y=i.charCodeAt(f);if(a(y)){if(!m){N=f+1;break}continue}h===-1&&(m=!1,h=f+1),y===U?g===-1?g=f:l!==1&&(l=1):g!==-1&&(l=-1)}return g===-1||h===-1||l===0||l===1&&g===h-1&&g===N+1?"":i.slice(g,h)},format:D.bind(null,"\\"),parse(i){u(i,"path");const s={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return s;const g=i.length;let N=0,h=i.charCodeAt(0);if(g===1)return a(h)?(s.root=s.dir=i,s):(s.base=s.name=i,s);if(a(h)){if(N=1,a(i.charCodeAt(1))){let j=2,x=j;for(;j<g&&!a(i.charCodeAt(j));)j++;if(j<g&&j!==x){for(x=j;j<g&&a(i.charCodeAt(j));)j++;if(j<g&&j!==x){for(x=j;j<g&&!a(i.charCodeAt(j));)j++;j===g?N=j:j!==x&&(N=j+1)}}}}else if(L(h)&&i.charCodeAt(1)===B){if(g<=2)return s.root=s.dir=i,s;if(N=2,a(i.charCodeAt(2))){if(g===3)return s.root=s.dir=i,s;N=3}}N>0&&(s.root=i.slice(0,N));let m=-1,l=N,f=-1,y=!0,A=i.length-1,p=0;for(;A>=N;--A){if(h=i.charCodeAt(A),a(h)){if(!y){l=A+1;break}continue}f===-1&&(y=!1,f=A+1),h===U?m===-1?m=A:p!==1&&(p=1):m!==-1&&(p=-1)}return f!==-1&&(m===-1||p===0||p===1&&m===f-1&&m===l+1?s.base=s.name=i.slice(l,f):(s.name=i.slice(l,m),s.base=i.slice(l,f),s.ext=i.slice(m,f))),l>0&&l!==N?s.dir=i.slice(0,l-1):s.dir=s.root,s},sep:"\\",delimiter:";",win32:null,posix:null};const n=(()=>{if(r){const i=/\\/g;return()=>{const s=c.cwd().replace(i,"/");return s.slice(s.indexOf("/"))}}return()=>c.cwd()})();e.posix={resolve(...i){let s="",g=!1;for(let N=i.length-1;N>=-1&&!g;N--){const h=N>=0?i[N]:n();u(h,`paths[${N}]`),h.length!==0&&(s=`${h}/${s}`,g=h.charCodeAt(0)===O)}return s=b(s,!g,"/",_),g?`/${s}`:s.length>0?s:"."},normalize(i){if(u(i,"path"),i.length===0)return".";const s=i.charCodeAt(0)===O,g=i.charCodeAt(i.length-1)===O;return i=b(i,!s,"/",_),i.length===0?s?"/":g?"./":".":(g&&(i+="/"),s?`/${i}`:i)},isAbsolute(i){return u(i,"path"),i.length>0&&i.charCodeAt(0)===O},join(...i){if(i.length===0)return".";let s;for(let g=0;g<i.length;++g){const N=i[g];u(N,"path"),N.length>0&&(s===void 0?s=N:s+=`/${N}`)}return s===void 0?".":e.posix.normalize(s)},relative(i,s){if(u(i,"from"),u(s,"to"),i===s||(i=e.posix.resolve(i),s=e.posix.resolve(s),i===s))return"";const g=1,N=i.length,h=N-g,m=1,l=s.length-m,f=h<l?h:l;let y=-1,A=0;for(;A<f;A++){const j=i.charCodeAt(g+A);if(j!==s.charCodeAt(m+A))break;j===O&&(y=A)}if(A===f)if(l>f){if(s.charCodeAt(m+A)===O)return s.slice(m+A+1);if(A===0)return s.slice(m+A)}else h>f&&(i.charCodeAt(g+A)===O?y=A:A===0&&(y=0));let p="";for(A=g+y+1;A<=N;++A)(A===N||i.charCodeAt(A)===O)&&(p+=p.length===0?"..":"/..");return`${p}${s.slice(m+y)}`},toNamespacedPath(i){return i},dirname(i){if(u(i,"path"),i.length===0)return".";const s=i.charCodeAt(0)===O;let g=-1,N=!0;for(let h=i.length-1;h>=1;--h)if(i.charCodeAt(h)===O){if(!N){g=h;break}}else N=!1;return g===-1?s?"/":".":s&&g===1?"//":i.slice(0,g)},basename(i,s){s!==void 0&&u(s,"ext"),u(i,"path");let g=0,N=-1,h=!0,m;if(s!==void 0&&s.length>0&&s.length<=i.length){if(s===i)return"";let l=s.length-1,f=-1;for(m=i.length-1;m>=0;--m){const y=i.charCodeAt(m);if(y===O){if(!h){g=m+1;break}}else f===-1&&(h=!1,f=m+1),l>=0&&(y===s.charCodeAt(l)?--l===-1&&(N=m):(l=-1,N=f))}return g===N?N=f:N===-1&&(N=i.length),i.slice(g,N)}for(m=i.length-1;m>=0;--m)if(i.charCodeAt(m)===O){if(!h){g=m+1;break}}else N===-1&&(h=!1,N=m+1);return N===-1?"":i.slice(g,N)},extname(i){u(i,"path");let s=-1,g=0,N=-1,h=!0,m=0;for(let l=i.length-1;l>=0;--l){const f=i.charCodeAt(l);if(f===O){if(!h){g=l+1;break}continue}N===-1&&(h=!1,N=l+1),f===U?s===-1?s=l:m!==1&&(m=1):s!==-1&&(m=-1)}return s===-1||N===-1||m===0||m===1&&s===N-1&&s===g+1?"":i.slice(s,N)},format:D.bind(null,"/"),parse(i){u(i,"path");const s={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return s;const g=i.charCodeAt(0)===O;let N;g?(s.root="/",N=1):N=0;let h=-1,m=0,l=-1,f=!0,y=i.length-1,A=0;for(;y>=N;--y){const p=i.charCodeAt(y);if(p===O){if(!f){m=y+1;break}continue}l===-1&&(f=!1,l=y+1),p===U?h===-1?h=y:A!==1&&(A=1):h!==-1&&(A=-1)}if(l!==-1){const p=m===0&&g?1:m;h===-1||A===0||A===1&&h===l-1&&h===m+1?s.base=s.name=i.slice(p,l):(s.name=i.slice(p,h),s.base=i.slice(p,l),s.ext=i.slice(h,l))}return m>0?s.dir=i.slice(0,m-1):g&&(s.dir="/"),s},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=r?e.win32.normalize:e.posix.normalize,e.isAbsolute=r?e.win32.isAbsolute:e.posix.isAbsolute,e.join=r?e.win32.join:e.posix.join,e.resolve=r?e.win32.resolve:e.posix.resolve,e.relative=r?e.win32.relative:e.posix.relative,e.dirname=r?e.win32.dirname:e.posix.dirname,e.basename=r?e.win32.basename:e.posix.basename,e.extname=r?e.win32.extname:e.posix.extname,e.format=r?e.win32.format:e.posix.format,e.parse=r?e.win32.parse:e.posix.parse,e.toNamespacedPath=r?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=r?e.win32.sep:e.posix.sep,e.delimiter=r?e.win32.delimiter:e.posix.delimiter}),define(pe[5],be([0,1,7,3,2,4,25]),function(re,e,c,t,I,S,Y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPathSeparator=U,e.toSlashes=O,e.toPosixPath=R,e.getRoot=B,e.isUNC=M,e.isValidBasename=r,e.isEqual=a,e.isEqualOrParent=_,e.isWindowsDriveLetter=L,e.sanitizeFilePath=b,e.removeTrailingPathSeparator=k,e.isRootOrDriveLetter=D,e.hasDriveLetter=n,e.getDriveLetter=i,e.indexOfPath=s,e.parseLineAndColumnAware=g,e.randomPath=m;function U(l){return l===c.CharCode.Slash||l===c.CharCode.Backslash}function O(l){return l.replace(/[\\/]/g,t.posix.sep)}function R(l){return l.indexOf("/")===-1&&(l=O(l)),/^[a-zA-Z]:(\/|$)/.test(l)&&(l="/"+l),l}function B(l,f=t.posix.sep){if(!l)return"";const y=l.length,A=l.charCodeAt(0);if(U(A)){if(U(l.charCodeAt(1))&&!U(l.charCodeAt(2))){let j=3;const x=j;for(;j<y&&!U(l.charCodeAt(j));j++);if(x!==j&&!U(l.charCodeAt(j+1))){for(j+=1;j<y;j++)if(U(l.charCodeAt(j)))return l.slice(0,j+1).replace(/[\\/]/g,f)}}return f}else if(L(A)&&l.charCodeAt(1)===c.CharCode.Colon)return U(l.charCodeAt(2))?l.slice(0,2)+f:l.slice(0,2);let p=l.indexOf("://");if(p!==-1){for(p+=3;p<y;p++)if(U(l.charCodeAt(p)))return l.slice(0,p+1)}return""}function M(l){if(!I.isWindows||!l||l.length<5)return!1;let f=l.charCodeAt(0);if(f!==c.CharCode.Backslash||(f=l.charCodeAt(1),f!==c.CharCode.Backslash))return!1;let y=2;const A=y;for(;y<l.length&&(f=l.charCodeAt(y),f!==c.CharCode.Backslash);y++);return!(A===y||(f=l.charCodeAt(y+1),isNaN(f)||f===c.CharCode.Backslash))}const T=/[\\/:\*\?"<>\|]/g,C=/[/]/g,u=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function r(l,f=I.isWindows){const y=f?T:C;return!(!l||l.length===0||/^\s+$/.test(l)||(y.lastIndex=0,y.test(l))||f&&u.test(l)||l==="."||l===".."||f&&l[l.length-1]==="."||f&&l.length!==l.trim().length||l.length>255)}function a(l,f,y){const A=l===f;return!y||A?A:!l||!f?!1:(0,S.equalsIgnoreCase)(l,f)}function _(l,f,y,A=t.sep){if(l===f)return!0;if(!l||!f||f.length>l.length)return!1;if(y){if(!(0,S.startsWithIgnoreCase)(l,f))return!1;if(f.length===l.length)return!0;let j=f.length;return f.charAt(f.length-1)===A&&j--,l.charAt(j)===A}return f.charAt(f.length-1)!==A&&(f+=A),l.indexOf(f)===0}function L(l){return l>=c.CharCode.A&&l<=c.CharCode.Z||l>=c.CharCode.a&&l<=c.CharCode.z}function b(l,f){return I.isWindows&&l.endsWith(":")&&(l+=t.sep),(0,t.isAbsolute)(l)||(l=(0,t.join)(f,l)),l=(0,t.normalize)(l),k(l)}function k(l){return I.isWindows?(l=(0,S.rtrim)(l,t.sep),l.endsWith(":")&&(l+=t.sep)):(l=(0,S.rtrim)(l,t.sep),l||(l=t.sep)),l}function D(l){const f=(0,t.normalize)(l);return I.isWindows?l.length>3?!1:n(f)&&(l.length===2||f.charCodeAt(2)===c.CharCode.Backslash):f===t.posix.sep}function n(l,f=I.isWindows){return f?L(l.charCodeAt(0))&&l.charCodeAt(1)===c.CharCode.Colon:!1}function i(l,f=I.isWindows){return n(l,f)?l[0]:void 0}function s(l,f,y){return f.length>l.length?-1:l===f?0:(y&&(l=l.toLowerCase(),f=f.toLowerCase()),l.indexOf(f))}function g(l){const f=l.split(":");let y,A,p;for(const j of f){const x=Number(j);(0,Y.isNumber)(x)?A===void 0?A=x:p===void 0&&(p=x):y=y?[y,j].join(":"):j}if(!y)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:y,line:A!==void 0?A:void 0,column:p!==void 0?p:A!==void 0?1:void 0}}const N="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",h="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function m(l,f,y=8){let A="";for(let j=0;j<y;j++){let x;j===0&&I.isWindows&&!f&&(y===3||y===4)?x=h:x=N,A+=x.charAt(Math.floor(Math.random()*x.length))}let p;return f?p=`${f}-${A}`:p=A,l?(0,t.join)(l,p):p}}),define(pe[6],be([0,1,7,34,3,2]),function(re,e,c,t,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URI=void 0,e.isUriComponents=a,e.uriToFsPath=n,I=Pe(I);const Y=/^\w[\w\d+.-]*$/,U=/^\//,O=/^\/\//;function R(h,m){if(!h.scheme&&m)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${h.authority}", path: "${h.path}", query: "${h.query}", fragment: "${h.fragment}"}`);if(h.scheme&&!Y.test(h.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(h.path){if(h.authority){if(!U.test(h.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(O.test(h.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function B(h,m){return!h&&!m?"file":h}function M(h,m){switch(h){case"https":case"http":case"file":m?m[0]!==C&&(m=C+m):m=C;break}return m}const T="",C="/",u=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class r{static isUri(m){return m instanceof r?!0:m?typeof m.authority=="string"&&typeof m.fragment=="string"&&typeof m.path=="string"&&typeof m.query=="string"&&typeof m.scheme=="string"&&typeof m.fsPath=="string"&&typeof m.with=="function"&&typeof m.toString=="function":!1}constructor(m,l,f,y,A,p=!1){typeof m=="object"?(this.scheme=m.scheme||T,this.authority=m.authority||T,this.path=m.path||T,this.query=m.query||T,this.fragment=m.fragment||T):(this.scheme=B(m,p),this.authority=l||T,this.path=M(this.scheme,f||T),this.query=y||T,this.fragment=A||T,R(this,p))}get fsPath(){return n(this,!1)}with(m){if(!m)return this;let{scheme:l,authority:f,path:y,query:A,fragment:p}=m;return l===void 0?l=this.scheme:l===null&&(l=T),f===void 0?f=this.authority:f===null&&(f=T),y===void 0?y=this.path:y===null&&(y=T),A===void 0?A=this.query:A===null&&(A=T),p===void 0?p=this.fragment:p===null&&(p=T),l===this.scheme&&f===this.authority&&y===this.path&&A===this.query&&p===this.fragment?this:new L(l,f,y,A,p)}static parse(m,l=!1){const f=u.exec(m);return f?new L(f[2]||T,N(f[4]||T),N(f[5]||T),N(f[7]||T),N(f[9]||T),l):new L(T,T,T,T,T)}static file(m){let l=T;if(S.isWindows&&(m=m.replace(/\\/g,C)),m[0]===C&&m[1]===C){const f=m.indexOf(C,2);f===-1?(l=m.substring(2),m=C):(l=m.substring(2,f),m=m.substring(f)||C)}return new L("file",l,m,T,T)}static from(m,l){return new L(m.scheme,m.authority,m.path,m.query,m.fragment,l)}static joinPath(m,...l){if(!m.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let f;return S.isWindows&&m.scheme==="file"?f=r.file(I.win32.join(n(m,!0),...l)).path:f=I.posix.join(m.path,...l),m.with({path:f})}toString(m=!1){return i(this,m)}toJSON(){return this}static revive(m){if(m){if(m instanceof r)return m;{const l=new L(m);return l._formatted=m.external??null,l._fsPath=m._sep===_?m.fsPath??null:null,l}}else return m}[Symbol.for("debug.description")](){return`URI(${this.toString()})`}}e.URI=r;function a(h){return!h||typeof h!="object"?!1:typeof h.scheme=="string"&&(typeof h.authority=="string"||typeof h.authority>"u")&&(typeof h.path=="string"||typeof h.path>"u")&&(typeof h.query=="string"||typeof h.query>"u")&&(typeof h.fragment=="string"||typeof h.fragment>"u")}const _=S.isWindows?1:void 0;class L extends r{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=n(this,!1)),this._fsPath}toString(m=!1){return m?i(this,!0):(this._formatted||(this._formatted=i(this,!1)),this._formatted)}toJSON(){const m={$mid:t.MarshalledId.Uri};return this._fsPath&&(m.fsPath=this._fsPath,m._sep=_),this._formatted&&(m.external=this._formatted),this.path&&(m.path=this.path),this.scheme&&(m.scheme=this.scheme),this.authority&&(m.authority=this.authority),this.query&&(m.query=this.query),this.fragment&&(m.fragment=this.fragment),m}}const b={[c.CharCode.Colon]:"%3A",[c.CharCode.Slash]:"%2F",[c.CharCode.QuestionMark]:"%3F",[c.CharCode.Hash]:"%23",[c.CharCode.OpenSquareBracket]:"%5B",[c.CharCode.CloseSquareBracket]:"%5D",[c.CharCode.AtSign]:"%40",[c.CharCode.ExclamationMark]:"%21",[c.CharCode.DollarSign]:"%24",[c.CharCode.Ampersand]:"%26",[c.CharCode.SingleQuote]:"%27",[c.CharCode.OpenParen]:"%28",[c.CharCode.CloseParen]:"%29",[c.CharCode.Asterisk]:"%2A",[c.CharCode.Plus]:"%2B",[c.CharCode.Comma]:"%2C",[c.CharCode.Semicolon]:"%3B",[c.CharCode.Equals]:"%3D",[c.CharCode.Space]:"%20"};function k(h,m,l){let f,y=-1;for(let A=0;A<h.length;A++){const p=h.charCodeAt(A);if(p>=c.CharCode.a&&p<=c.CharCode.z||p>=c.CharCode.A&&p<=c.CharCode.Z||p>=c.CharCode.Digit0&&p<=c.CharCode.Digit9||p===c.CharCode.Dash||p===c.CharCode.Period||p===c.CharCode.Underline||p===c.CharCode.Tilde||m&&p===c.CharCode.Slash||l&&p===c.CharCode.OpenSquareBracket||l&&p===c.CharCode.CloseSquareBracket||l&&p===c.CharCode.Colon)y!==-1&&(f+=encodeURIComponent(h.substring(y,A)),y=-1),f!==void 0&&(f+=h.charAt(A));else{f===void 0&&(f=h.substr(0,A));const j=b[p];j!==void 0?(y!==-1&&(f+=encodeURIComponent(h.substring(y,A)),y=-1),f+=j):y===-1&&(y=A)}}return y!==-1&&(f+=encodeURIComponent(h.substring(y))),f!==void 0?f:h}function D(h){let m;for(let l=0;l<h.length;l++){const f=h.charCodeAt(l);f===c.CharCode.Hash||f===c.CharCode.QuestionMark?(m===void 0&&(m=h.substr(0,l)),m+=b[f]):m!==void 0&&(m+=h[l])}return m!==void 0?m:h}function n(h,m){let l;return h.authority&&h.path.length>1&&h.scheme==="file"?l=`//${h.authority}${h.path}`:h.path.charCodeAt(0)===c.CharCode.Slash&&(h.path.charCodeAt(1)>=c.CharCode.A&&h.path.charCodeAt(1)<=c.CharCode.Z||h.path.charCodeAt(1)>=c.CharCode.a&&h.path.charCodeAt(1)<=c.CharCode.z)&&h.path.charCodeAt(2)===c.CharCode.Colon?m?l=h.path.substr(1):l=h.path[1].toLowerCase()+h.path.substr(2):l=h.path,S.isWindows&&(l=l.replace(/\//g,"\\")),l}function i(h,m){const l=m?D:k;let f="",{scheme:y,authority:A,path:p,query:j,fragment:x}=h;if(y&&(f+=y,f+=":"),(A||y==="file")&&(f+=C,f+=C),A){let J=A.indexOf("@");if(J!==-1){const G=A.substr(0,J);A=A.substr(J+1),J=G.lastIndexOf(":"),J===-1?f+=l(G,!1,!1):(f+=l(G.substr(0,J),!1,!1),f+=":",f+=l(G.substr(J+1),!1,!0)),f+="@"}A=A.toLowerCase(),J=A.lastIndexOf(":"),J===-1?f+=l(A,!1,!0):(f+=l(A.substr(0,J),!1,!0),f+=A.substr(J))}if(p){if(p.length>=3&&p.charCodeAt(0)===c.CharCode.Slash&&p.charCodeAt(2)===c.CharCode.Colon){const J=p.charCodeAt(1);J>=c.CharCode.A&&J<=c.CharCode.Z&&(p=`/${String.fromCharCode(J+32)}:${p.substr(3)}`)}else if(p.length>=2&&p.charCodeAt(1)===c.CharCode.Colon){const J=p.charCodeAt(0);J>=c.CharCode.A&&J<=c.CharCode.Z&&(p=`${String.fromCharCode(J+32)}:${p.substr(2)}`)}f+=l(p,!0,!1)}return j&&(f+="?",f+=l(j,!1,!1)),x&&(f+="#",f+=m?x:k(x,!1,!1)),f}function s(h){try{return decodeURIComponent(h)}catch{return h.length>3?h.substr(0,3)+s(h.substr(3)):h}}const g=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function N(h){return h.match(g)?h.replace(g,m=>s(m)):h}}),define(pe[19],be([0,1,10,2,4,6,3]),function(re,e,c,t,I,S,Y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.VSCODE_AUTHORITY=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0,e.matchesScheme=O,e.matchesSomeScheme=R,e.getServerRootPath=M,c=Pe(c),t=Pe(t),Y=Pe(Y);var U;(function(u){u.inMemory="inmemory",u.vscode="vscode",u.internal="private",u.walkThrough="walkThrough",u.walkThroughSnippet="walkThroughSnippet",u.http="http",u.https="https",u.file="file",u.mailto="mailto",u.untitled="untitled",u.data="data",u.command="command",u.vscodeRemote="vscode-remote",u.vscodeRemoteResource="vscode-remote-resource",u.vscodeManagedRemoteResource="vscode-managed-remote-resource",u.vscodeUserData="vscode-userdata",u.vscodeCustomEditor="vscode-custom-editor",u.vscodeNotebookCell="vscode-notebook-cell",u.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",u.vscodeNotebookCellMetadataDiff="vscode-notebook-cell-metadata-diff",u.vscodeNotebookCellOutput="vscode-notebook-cell-output",u.vscodeNotebookCellOutputDiff="vscode-notebook-cell-output-diff",u.vscodeNotebookMetadata="vscode-notebook-metadata",u.vscodeInteractiveInput="vscode-interactive-input",u.vscodeSettings="vscode-settings",u.vscodeWorkspaceTrust="vscode-workspace-trust",u.vscodeTerminal="vscode-terminal",u.vscodeChatCodeBlock="vscode-chat-code-block",u.vscodeChatCodeCompareBlock="vscode-chat-code-compare-block",u.vscodeChatSesssion="vscode-chat-editor",u.webviewPanel="webview-panel",u.vscodeWebview="vscode-webview",u.extension="extension",u.vscodeFileResource="vscode-file",u.tmp="tmp",u.vsls="vsls",u.vscodeSourceControl="vscode-scm",u.commentsInput="comment",u.codeSetting="code-setting",u.outputChannel="output"})(U||(e.Schemas=U={}));function O(u,r){return S.URI.isUri(u)?(0,I.equalsIgnoreCase)(u.scheme,r):(0,I.startsWithIgnoreCase)(u,r+":")}function R(u,...r){return r.some(a=>O(u,a))}e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class B{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._serverRootPath="/"}setPreferredWebSchema(r){this._preferredWebSchema=r}setDelegate(r){this._delegate=r}setServerRootPath(r,a){this._serverRootPath=M(r,a)}getServerRootPath(){return this._serverRootPath}get _remoteResourcesPath(){return Y.posix.join(this._serverRootPath,U.vscodeRemoteResource)}set(r,a,_){this._hosts[r]=a,this._ports[r]=_}setConnectionToken(r,a){this._connectionTokens[r]=a}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(r){if(this._delegate)try{return this._delegate(r)}catch(D){return c.onUnexpectedError(D),r}const a=r.authority;let _=this._hosts[a];_&&_.indexOf(":")!==-1&&_.indexOf("[")===-1&&(_=`[${_}]`);const L=this._ports[a],b=this._connectionTokens[a];let k=`path=${encodeURIComponent(r.path)}`;return typeof b=="string"&&(k+=`&${e.connectionTokenQueryName}=${encodeURIComponent(b)}`),S.URI.from({scheme:t.isWeb?this._preferredWebSchema:U.vscodeRemoteResource,authority:`${_}:${L}`,path:this._remoteResourcesPath,query:k})}}e.RemoteAuthorities=new B;function M(u,r){return Y.posix.join(r??"/",`${u.quality??"oss"}-${u.commit??"dev"}`)}e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked",e.VSCODE_AUTHORITY="vscode-app";class T{static{this.FALLBACK_AUTHORITY=e.VSCODE_AUTHORITY}asBrowserUri(r){const a=this.toUri(r,re);return this.uriToBrowserUri(a)}uriToBrowserUri(r){return r.scheme===U.vscodeRemote?e.RemoteAuthorities.rewrite(r):r.scheme===U.file&&(t.isNative||t.webWorkerOrigin===`${U.vscodeFileResource}://${T.FALLBACK_AUTHORITY}`)?r.with({scheme:U.vscodeFileResource,authority:r.authority||T.FALLBACK_AUTHORITY,query:null,fragment:null}):r}asFileUri(r){const a=this.toUri(r,re);return this.uriToFileUri(a)}uriToFileUri(r){return r.scheme===U.vscodeFileResource?r.with({scheme:U.file,authority:r.authority!==T.FALLBACK_AUTHORITY?r.authority:null,query:null,fragment:null}):r}toUri(r,a){if(S.URI.isUri(r))return r;if(globalThis._VSCODE_FILE_ROOT){const _=globalThis._VSCODE_FILE_ROOT;if(/^\w[\w\d+.-]*:\/\//.test(_))return S.URI.joinPath(S.URI.parse(_,!0),r);const L=Y.join(_,r);return S.URI.file(L)}return S.URI.parse(a.toUrl(r))}}e.FileAccess=new T;var C;(function(u){const r=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);u.CoopAndCoep=Object.freeze(r.get("3"));const a="vscode-coi";function _(b){let k;typeof b=="string"?k=new URL(b).searchParams:b instanceof URL?k=b.searchParams:S.URI.isUri(b)&&(k=new URL(b.toString(!0)).searchParams);const D=k?.get(a);if(D)return r.get(D)}u.getHeadersFromQuery=_;function L(b,k,D){if(!globalThis.crossOriginIsolated)return;const n=k&&D?"3":D?"2":"1";b instanceof URLSearchParams?b.set(a,n):b[a]=n}u.addSearchParam=L})(C||(e.COI=C={}))}),define(pe[20],be([0,1,7,5,19,3,2,4,6]),function(re,e,c,t,I,S,Y,U,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=void 0,e.originalFSPath=R,e.distinctParents=M,e.toLocalResource=C,t=Pe(t),S=Pe(S);function R(u){return(0,O.uriToFsPath)(u,!0)}class B{constructor(r){this._ignorePathCasing=r}compare(r,a,_=!1){return r===a?0:(0,U.compare)(this.getComparisonKey(r,_),this.getComparisonKey(a,_))}isEqual(r,a,_=!1){return r===a?!0:!r||!a?!1:this.getComparisonKey(r,_)===this.getComparisonKey(a,_)}getComparisonKey(r,a=!1){return r.with({path:this._ignorePathCasing(r)?r.path.toLowerCase():void 0,fragment:a?null:void 0}).toString()}ignorePathCasing(r){return this._ignorePathCasing(r)}isEqualOrParent(r,a,_=!1){if(r.scheme===a.scheme){if(r.scheme===I.Schemas.file)return t.isEqualOrParent(R(r),R(a),this._ignorePathCasing(r))&&r.query===a.query&&(_||r.fragment===a.fragment);if((0,e.isEqualAuthority)(r.authority,a.authority))return t.isEqualOrParent(r.path,a.path,this._ignorePathCasing(r),"/")&&r.query===a.query&&(_||r.fragment===a.fragment)}return!1}joinPath(r,...a){return O.URI.joinPath(r,...a)}basenameOrAuthority(r){return(0,e.basename)(r)||r.authority}basename(r){return S.posix.basename(r.path)}extname(r){return S.posix.extname(r.path)}dirname(r){if(r.path.length===0)return r;let a;return r.scheme===I.Schemas.file?a=O.URI.file(S.dirname(R(r))).path:(a=S.posix.dirname(r.path),r.authority&&a.length&&a.charCodeAt(0)!==c.CharCode.Slash&&(console.error(`dirname("${r.toString})) resulted in a relative path`),a="/")),r.with({path:a})}normalizePath(r){if(!r.path.length)return r;let a;return r.scheme===I.Schemas.file?a=O.URI.file(S.normalize(R(r))).path:a=S.posix.normalize(r.path),r.with({path:a})}relativePath(r,a){if(r.scheme!==a.scheme||!(0,e.isEqualAuthority)(r.authority,a.authority))return;if(r.scheme===I.Schemas.file){const b=S.relative(R(r),R(a));return Y.isWindows?t.toSlashes(b):b}let _=r.path||"/";const L=a.path||"/";if(this._ignorePathCasing(r)){let b=0;for(const k=Math.min(_.length,L.length);b<k&&!(_.charCodeAt(b)!==L.charCodeAt(b)&&_.charAt(b).toLowerCase()!==L.charAt(b).toLowerCase());b++);_=L.substr(0,b)+_.substr(b)}return S.posix.relative(_,L)}resolvePath(r,a){if(r.scheme===I.Schemas.file){const _=O.URI.file(S.resolve(R(r),a));return r.with({authority:_.authority,path:_.path})}return a=t.toPosixPath(a),r.with({path:S.posix.resolve(r.path,a)})}isAbsolutePath(r){return!!r.path&&r.path[0]==="/"}isEqualAuthority(r,a){return r===a||r!==void 0&&a!==void 0&&(0,U.equalsIgnoreCase)(r,a)}hasTrailingPathSeparator(r,a=S.sep){if(r.scheme===I.Schemas.file){const _=R(r);return _.length>t.getRoot(_).length&&_[_.length-1]===a}else{const _=r.path;return _.length>1&&_.charCodeAt(_.length-1)===c.CharCode.Slash&&!/^[a-zA-Z]:(\/$|\\$)/.test(r.fsPath)}}removeTrailingPathSeparator(r,a=S.sep){return(0,e.hasTrailingPathSeparator)(r,a)?r.with({path:r.path.substr(0,r.path.length-1)}):r}addTrailingPathSeparator(r,a=S.sep){let _=!1;if(r.scheme===I.Schemas.file){const L=R(r);_=L!==void 0&&L.length===t.getRoot(L).length&&L[L.length-1]===a}else{a="/";const L=r.path;_=L.length===1&&L.charCodeAt(L.length-1)===c.CharCode.Slash}return!_&&!(0,e.hasTrailingPathSeparator)(r,a)?r.with({path:r.path+"/"}):r}}e.ExtUri=B,e.extUri=new B(()=>!1),e.extUriBiasedIgnorePathCase=new B(u=>u.scheme===I.Schemas.file?!Y.isLinux:!0),e.extUriIgnorePathCase=new B(u=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function M(u,r){const a=[];for(let _=0;_<u.length;_++){const L=r(u[_]);u.some((b,k)=>k===_?!1:(0,e.isEqualOrParent)(L,r(b)))||a.push(u[_])}return a}var T;(function(u){u.META_DATA_LABEL="label",u.META_DATA_DESCRIPTION="description",u.META_DATA_SIZE="size",u.META_DATA_MIME="mime";function r(a){const _=new Map;a.path.substring(a.path.indexOf(";")+1,a.path.lastIndexOf(";")).split(";").forEach(k=>{const[D,n]=k.split(":");D&&n&&_.set(D,n)});const b=a.path.substring(0,a.path.indexOf(";"));return b&&_.set(u.META_DATA_MIME,b),_}u.parseMetaData=r})(T||(e.DataUri=T={}));function C(u,r,a){if(r){let _=u.path;return _&&_[0]!==S.posix.sep&&(_=S.posix.sep+_),u.with({scheme:a,authority:r,path:_})}return u.with({scheme:a})}}),define(pe[8],be([0,1,12,10,17,11,20,2,38,15]),function(re,e,c,t,I,S,Y,U,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AsyncIterableSource=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.LazyStatefulPromise=e.StatefulPromise=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.GlobalIdleValue=e.AbstractIdleValue=e._runWhenIdle=e.runWhenGlobalIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.LimitedQueue=e.Queue=e.Limiter=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=void 0,e.isThenable=B,e.createCancelablePromise=M,e.raceCancellation=T,e.raceCancellationError=C,e.raceCancellablePromises=u,e.raceTimeout=r,e.asPromise=a,e.promiseWithResolvers=_,e.timeout=h,e.disposableTimeout=m,e.sequence=l,e.first=f,e.firstParallel=y,e.retry=z,e.createCancelableAsyncIterable=P;function B(E){return!!E&&typeof E.then=="function"}function M(E){const o=new c.CancellationTokenSource,v=E(o.token),V=new Promise((X,de)=>{const ve=o.token.onCancellationRequested(()=>{ve.dispose(),de(new t.CancellationError)});Promise.resolve(v).then(De=>{ve.dispose(),o.dispose(),X(De)},De=>{ve.dispose(),o.dispose(),de(De)})});return new class{cancel(){o.cancel(),o.dispose()}then(X,de){return V.then(X,de)}catch(X){return this.then(void 0,X)}finally(X){return V.finally(X)}}}function T(E,o,v){return new Promise((V,X)=>{const de=o.onCancellationRequested(()=>{de.dispose(),V(v)});E.then(V,X).finally(()=>de.dispose())})}function C(E,o){return new Promise((v,V)=>{const X=o.onCancellationRequested(()=>{X.dispose(),V(new t.CancellationError)});E.then(v,V).finally(()=>X.dispose())})}async function u(E){let o=-1;const v=E.map((V,X)=>V.then(de=>(o=X,de)));try{return await Promise.race(v)}finally{E.forEach((V,X)=>{X!==o&&V.cancel()})}}function r(E,o,v){let V;const X=setTimeout(()=>{V?.(void 0),v?.()},o);return Promise.race([E.finally(()=>clearTimeout(X)),new Promise(de=>V=de)])}function a(E){return new Promise((o,v)=>{const V=E();B(V)?V.then(o,v):o(V)})}function _(){let E,o;return{promise:new Promise((V,X)=>{E=V,o=X}),resolve:E,reject:o}}class L{constructor(){this.isDisposed=!1,this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(o){if(this.isDisposed)return Promise.reject(new Error("Throttler is disposed"));if(this.activePromise){if(this.queuedPromiseFactory=o,!this.queuedPromise){const v=()=>{if(this.queuedPromise=null,this.isDisposed)return;const V=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,V};this.queuedPromise=new Promise(V=>{this.activePromise.then(v,v).then(V)})}return new Promise((v,V)=>{this.queuedPromise.then(v,V)})}return this.activePromise=o(),new Promise((v,V)=>{this.activePromise.then(X=>{this.activePromise=null,v(X)},X=>{this.activePromise=null,V(X)})})}dispose(){this.isDisposed=!0}}e.Throttler=L;class b{constructor(){this.current=Promise.resolve(null)}queue(o){return this.current=this.current.then(()=>o(),()=>o())}}e.Sequencer=b;class k{constructor(){this.promiseMap=new Map}queue(o,v){const X=(this.promiseMap.get(o)??Promise.resolve()).catch(()=>{}).then(v).finally(()=>{this.promiseMap.get(o)===X&&this.promiseMap.delete(o)});return this.promiseMap.set(o,X),X}}e.SequencerByKey=k;const D=(E,o)=>{let v=!0;const V=setTimeout(()=>{v=!1,o()},E);return{isTriggered:()=>v,dispose:()=>{clearTimeout(V),v=!1}}},n=E=>{let o=!0;return queueMicrotask(()=>{o&&(o=!1,E())}),{isTriggered:()=>o,dispose:()=>{o=!1}}};class i{constructor(o){this.defaultDelay=o,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(o,v=this.defaultDelay){this.task=o,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((X,de)=>{this.doResolve=X,this.doReject=de}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const X=this.task;return this.task=null,X()}}));const V=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=v===O.MicrotaskDelay?n(V):D(v,V),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new t.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=i;class s{constructor(o){this.delayer=new i(o),this.throttler=new L}trigger(o,v){return this.delayer.trigger(()=>this.throttler.queue(o),v)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose(),this.throttler.dispose()}}e.ThrottledDelayer=s;class g{constructor(){this._isOpen=!1,this._promise=new Promise((o,v)=>{this._completePromise=o})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=g;class N extends g{constructor(o){super(),this._timeout=setTimeout(()=>this.open(),o)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=N;function h(E,o){return o?new Promise((v,V)=>{const X=setTimeout(()=>{de.dispose(),v()},E),de=o.onCancellationRequested(()=>{clearTimeout(X),de.dispose(),V(new t.CancellationError)})}):M(v=>h(E,v))}function m(E,o=0,v){const V=setTimeout(()=>{E(),v&&X.dispose()},o),X=(0,S.toDisposable)(()=>{clearTimeout(V),v?.deleteAndLeak(X)});return v?.add(X),X}function l(E){const o=[];let v=0;const V=E.length;function X(){return v<V?E[v++]():null}function de(ve){ve!=null&&o.push(ve);const De=X();return De?De.then(de):Promise.resolve(o)}return Promise.resolve(null).then(de)}function f(E,o=V=>!!V,v=null){let V=0;const X=E.length,de=()=>{if(V>=X)return Promise.resolve(v);const ve=E[V++];return Promise.resolve(ve()).then(Ie=>o(Ie)?Promise.resolve(Ie):de())};return de()}function y(E,o=V=>!!V,v=null){if(E.length===0)return Promise.resolve(v);let V=E.length;const X=()=>{V=-1;for(const de of E)de.cancel?.()};return new Promise((de,ve)=>{for(const De of E)De.then(Ie=>{--V>=0&&o(Ie)?(X(),de(Ie)):V===0&&de(v)}).catch(Ie=>{--V>=0&&(X(),ve(Ie))})})}class A{constructor(o){this._size=0,this._isDisposed=!1,this.maxDegreeOfParalellism=o,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new I.Emitter}whenIdle(){return this.size>0?I.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(o){if(this._isDisposed)throw new Error("Object has been disposed");return this._size++,new Promise((v,V)=>{this.outstandingPromises.push({factory:o,c:v,e:V}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const o=this.outstandingPromises.shift();this.runningPromises++;const v=o.factory();v.then(o.c,o.e),v.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._isDisposed||(this.runningPromises--,--this._size===0&&this._onDrained.fire(),this.outstandingPromises.length>0&&this.consume())}clear(){if(this._isDisposed)throw new Error("Object has been disposed");this.outstandingPromises.length=0,this._size=this.runningPromises}dispose(){this._isDisposed=!0,this.outstandingPromises.length=0,this._size=0,this._onDrained.dispose()}}e.Limiter=A;class p extends A{constructor(){super(1)}}e.Queue=p;class j{constructor(){this.sequentializer=new H,this.tasks=0}queue(o){return this.sequentializer.isRunning()?this.sequentializer.queue(()=>this.sequentializer.run(this.tasks++,o())):this.sequentializer.run(this.tasks++,o())}}e.LimitedQueue=j;class x{constructor(){this.queues=new Map,this.drainers=new Set,this.drainListeners=void 0,this.drainListenerCount=0}async whenDrained(){if(this.isDrained())return;const o=new w;return this.drainers.add(o),o.p}isDrained(){for(const[,o]of this.queues)if(o.size>0)return!1;return!0}queueSize(o,v=Y.extUri){const V=v.getComparisonKey(o);return this.queues.get(V)?.size??0}queueFor(o,v,V=Y.extUri){const X=V.getComparisonKey(o);let de=this.queues.get(X);if(!de){de=new p;const ve=this.drainListenerCount++,De=I.Event.once(de.onDrained)(()=>{de?.dispose(),this.queues.delete(X),this.onDidQueueDrain(),this.drainListeners?.deleteAndDispose(ve),this.drainListeners?.size===0&&(this.drainListeners.dispose(),this.drainListeners=void 0)});this.drainListeners||(this.drainListeners=new S.DisposableMap),this.drainListeners.set(ve,De),this.queues.set(X,de)}return de.queue(v)}onDidQueueDrain(){this.isDrained()&&this.releaseDrainers()}releaseDrainers(){for(const o of this.drainers)o.complete();this.drainers.clear()}dispose(){for(const[,o]of this.queues)o.dispose();this.queues.clear(),this.releaseDrainers(),this.drainListeners?.dispose()}}e.ResourceQueue=x;class J{constructor(o,v){this._isDisposed=!1,this._token=-1,typeof o=="function"&&typeof v=="number"&&this.setIfNotSet(o,v)}dispose(){this.cancel(),this._isDisposed=!0}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(o,v){if(this._isDisposed)throw new t.BugIndicatingError("Calling 'cancelAndSet' on a disposed TimeoutTimer");this.cancel(),this._token=setTimeout(()=>{this._token=-1,o()},v)}setIfNotSet(o,v){if(this._isDisposed)throw new t.BugIndicatingError("Calling 'setIfNotSet' on a disposed TimeoutTimer");this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,o()},v))}}e.TimeoutTimer=J;class G{constructor(){this.disposable=void 0,this.isDisposed=!1}cancel(){this.disposable?.dispose(),this.disposable=void 0}cancelAndSet(o,v,V=globalThis){if(this.isDisposed)throw new t.BugIndicatingError("Calling 'cancelAndSet' on a disposed IntervalTimer");this.cancel();const X=V.setInterval(()=>{o()},v);this.disposable=(0,S.toDisposable)(()=>{V.clearInterval(X),this.disposable=void 0})}dispose(){this.cancel(),this.isDisposed=!0}}e.IntervalTimer=G;class le{constructor(o,v){this.timeoutToken=-1,this.runner=o,this.timeout=v,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(o=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,o)}get delay(){return this.timeout}set delay(o){this.timeout=o}isScheduled(){return this.timeoutToken!==-1}flush(){this.isScheduled()&&(this.cancel(),this.doRun())}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}e.RunOnceScheduler=le;class W{constructor(o,v){v%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${v}ms is not a multiple of 1000ms.`),this.runner=o,this.timeout=v,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(o=this.timeout){o%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${o}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(o/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}e.ProcessTimeRunOnceScheduler=W;class K extends le{constructor(o,v){super(o,v),this.units=[]}work(o){this.units.push(o),this.isScheduled()||this.schedule()}doRun(){const o=this.units;this.units=[],this.runner?.(o)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=K;class Z extends S.Disposable{constructor(o,v){super(),this.options=o,this.handler=v,this.pendingWork=[],this.throttler=this._register(new S.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(o){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+o.length>this.options.maxBufferedWork)return!1}else if(this.pending+o.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}for(const v of o)this.pendingWork.push(v);return this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new le(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=Z,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e._runWhenIdle=(E,o)=>{(0,U.setTimeout0)(()=>{if(v)return;const V=Date.now()+15;o(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,V-Date.now())}}))});let v=!1;return{dispose(){v||(v=!0)}}}:e._runWhenIdle=(E,o,v)=>{const V=E.requestIdleCallback(o,typeof v=="number"?{timeout:v}:void 0);let X=!1;return{dispose(){X||(X=!0,E.cancelIdleCallback(V))}}},e.runWhenGlobalIdle=E=>(0,e._runWhenIdle)(globalThis,E)}();class ee{constructor(o,v){this._didRun=!1,this._executor=()=>{try{this._value=v()}catch(V){this._error=V}finally{this._didRun=!0}},this._handle=(0,e._runWhenIdle)(o,()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.AbstractIdleValue=ee;class q extends ee{constructor(o){super(globalThis,o)}}e.GlobalIdleValue=q;async function z(E,o,v){let V;for(let X=0;X<v;X++)try{return await E()}catch(de){V=de,await h(o)}throw V}class H{isRunning(o){return typeof o=="number"?this._running?.taskId===o:!!this._running}get running(){return this._running?.promise}cancelRunning(){this._running?.cancel()}run(o,v,V){return this._running={taskId:o,cancel:()=>V?.(),promise:v},v.then(()=>this.doneRunning(o),()=>this.doneRunning(o)),v}doneRunning(o){this._running&&o===this._running.taskId&&(this._running=void 0,this.runQueued())}runQueued(){if(this._queued){const o=this._queued;this._queued=void 0,o.run().then(o.promiseResolve,o.promiseReject)}}queue(o){if(this._queued)this._queued.run=o;else{const{promise:v,resolve:V,reject:X}=_();this._queued={run:o,promise:v,promiseResolve:V,promiseReject:X}}return this._queued.promise}hasQueued(){return!!this._queued}async join(){return this._queued?.promise??this._running?.promise}}e.TaskSequentializer=H;class te{constructor(o,v=()=>Date.now()){this.interval=o,this.nowFn=v,this.lastIncrementTime=0,this.value=0}increment(){const o=this.nowFn();return o-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=o,this.value=0),this.value++,this.value}}e.IntervalCounter=te;var ue;(function(E){E[E.Resolved=0]="Resolved",E[E.Rejected=1]="Rejected"})(ue||(ue={}));class w{get isRejected(){return this.outcome?.outcome===ue.Rejected}get isResolved(){return this.outcome?.outcome===ue.Resolved}get isSettled(){return!!this.outcome}get value(){return this.outcome?.outcome===ue.Resolved?this.outcome?.value:void 0}constructor(){this.p=new Promise((o,v)=>{this.completeCallback=o,this.errorCallback=v})}complete(o){return new Promise(v=>{this.completeCallback(o),this.outcome={outcome:ue.Resolved,value:o},v()})}error(o){return new Promise(v=>{this.errorCallback(o),this.outcome={outcome:ue.Rejected,value:o},v()})}cancel(){return this.error(new t.CancellationError)}}e.DeferredPromise=w;var ie;(function(E){async function o(V){let X;const de=await Promise.all(V.map(ve=>ve.then(De=>De,De=>{X||(X=De)})));if(typeof X<"u")throw X;return de}E.settled=o;function v(V){return new Promise(async(X,de)=>{try{await V(X,de)}catch(ve){de(ve)}})}E.withAsyncBody=v})(ie||(e.Promises=ie={}));class se{get value(){return this._value}get error(){return this._error}get isResolved(){return this._isResolved}constructor(o){this._value=void 0,this._error=void 0,this._isResolved=!1,this.promise=o.then(v=>(this._value=v,this._isResolved=!0,v),v=>{throw this._error=v,this._isResolved=!0,v})}requireValue(){if(!this._isResolved)throw new t.BugIndicatingError("Promise is not resolved yet");if(this._error)throw this._error;return this._value}}e.StatefulPromise=se;class oe{constructor(o){this._compute=o,this._promise=new R.Lazy(()=>new se(this._compute()))}requireValue(){return this._promise.value.requireValue()}getPromise(){return this._promise.value.promise}get currentValue(){return this._promise.rawValue?.value}}e.LazyStatefulPromise=oe;var ce;(function(E){E[E.Initial=0]="Initial",E[E.DoneOK=1]="DoneOK",E[E.DoneError=2]="DoneError"})(ce||(ce={}));class fe{static fromArray(o){return new fe(v=>{v.emitMany(o)})}static fromPromise(o){return new fe(async v=>{v.emitMany(await o)})}static fromPromises(o){return new fe(async v=>{await Promise.all(o.map(async V=>v.emitOne(await V)))})}static merge(o){return new fe(async v=>{await Promise.all(o.map(async V=>{for await(const X of V)v.emitOne(X)}))})}static{this.EMPTY=fe.fromArray([])}constructor(o,v){this._state=ce.Initial,this._results=[],this._error=null,this._onReturn=v,this._onStateChanged=new I.Emitter,queueMicrotask(async()=>{const V={emitOne:X=>this.emitOne(X),emitMany:X=>this.emitMany(X),reject:X=>this.reject(X)};try{await Promise.resolve(o(V)),this.resolve()}catch(X){this.reject(X)}finally{V.emitOne=void 0,V.emitMany=void 0,V.reject=void 0}})}[Symbol.asyncIterator](){let o=0;return{next:async()=>{do{if(this._state===ce.DoneError)throw this._error;if(o<this._results.length)return{done:!1,value:this._results[o++]};if(this._state===ce.DoneOK)return{done:!0,value:void 0};await I.Event.toPromise(this._onStateChanged.event)}while(!0)},return:async()=>(this._onReturn?.(),{done:!0,value:void 0})}}static map(o,v){return new fe(async V=>{for await(const X of o)V.emitOne(v(X))})}map(o){return fe.map(this,o)}static filter(o,v){return new fe(async V=>{for await(const X of o)v(X)&&V.emitOne(X)})}filter(o){return fe.filter(this,o)}static coalesce(o){return fe.filter(o,v=>!!v)}coalesce(){return fe.coalesce(this)}static async toPromise(o){const v=[];for await(const V of o)v.push(V);return v}toPromise(){return fe.toPromise(this)}emitOne(o){this._state===ce.Initial&&(this._results.push(o),this._onStateChanged.fire())}emitMany(o){this._state===ce.Initial&&(this._results=this._results.concat(o),this._onStateChanged.fire())}resolve(){this._state===ce.Initial&&(this._state=ce.DoneOK,this._onStateChanged.fire())}reject(o){this._state===ce.Initial&&(this._state=ce.DoneError,this._error=o,this._onStateChanged.fire())}}e.AsyncIterableObject=fe;class Le extends fe{constructor(o,v){super(v),this._source=o}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=Le;function P(E){const o=new c.CancellationTokenSource,v=E(o.token);return new Le(o,async V=>{const X=o.token.onCancellationRequested(()=>{X.dispose(),o.dispose(),V.reject(new t.CancellationError)});try{for await(const de of v){if(o.token.isCancellationRequested)return;V.emitOne(de)}X.dispose(),o.dispose()}catch(de){X.dispose(),o.dispose(),V.reject(de)}})}class ${constructor(o){this._deferred=new w,this._asyncIterable=new fe(X=>{if(v){X.reject(v);return}return V&&X.emitMany(V),this._errorFn=de=>X.reject(de),this._emitFn=de=>X.emitOne(de),this._deferred.p},o);let v,V;this._emitFn=X=>{V||(V=[]),V.push(X)},this._errorFn=X=>{v||(v=X)}}get asyncIterable(){return this._asyncIterable}resolve(){this._deferred.complete()}reject(o){this._errorFn(o),this._deferred.complete()}emitOne(o){this._emitFn(o)}}e.AsyncIterableSource=$}),define(pe[42],be([0,1,14,8,7,5,16,3,2,4]),function(re,e,c,t,I,S,Y,U,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.GLOB_SPLIT=e.GLOBSTAR=void 0,e.getEmptyExpression=B,e.splitGlobAware=r,e.match=j,e.parse=x,e.isRelativePattern=J,e.getBasenameTerms=G,e.getPathTerms=le,e.patternsEquals=ee;function B(){return Object.create(null)}e.GLOBSTAR="**",e.GLOB_SPLIT="/";const M="[/\\\\]",T="[^/\\\\]",C=/\//g;function u(q,z){switch(q){case 0:return"";case 1:return`${T}*?`;default:return`(?:${M}|${T}+${M}${z?`|${M}${T}+`:""})*?`}}function r(q,z){if(!q)return[];const H=[];let te=!1,ue=!1,w="";for(const ie of q){switch(ie){case z:if(!te&&!ue){H.push(w),w="";continue}break;case"{":te=!0;break;case"}":te=!1;break;case"[":ue=!0;break;case"]":ue=!1;break}w+=ie}return w&&H.push(w),H}function a(q){if(!q)return"";let z="";const H=r(q,e.GLOB_SPLIT);if(H.every(te=>te===e.GLOBSTAR))z=".*";else{let te=!1;H.forEach((ue,w)=>{if(ue===e.GLOBSTAR){if(te)return;z+=u(2,w===H.length-1)}else{let ie=!1,se="",oe=!1,ce="";for(const fe of ue){if(fe!=="}"&&ie){se+=fe;continue}if(oe&&(fe!=="]"||!ce)){let Le;fe==="-"?Le=fe:(fe==="^"||fe==="!")&&!ce?Le="^":fe===e.GLOB_SPLIT?Le="":Le=(0,R.escapeRegExpCharacters)(fe),ce+=Le;continue}switch(fe){case"{":ie=!0;continue;case"[":oe=!0;continue;case"}":{const P=`(?:${r(se,",").map($=>a($)).join("|")})`;z+=P,ie=!1,se="";break}case"]":{z+="["+ce+"]",oe=!1,ce="";break}case"?":z+=T;continue;case"*":z+=u(1);continue;default:z+=(0,R.escapeRegExpCharacters)(fe)}}w<H.length-1&&(H[w+1]!==e.GLOBSTAR||w+2<H.length)&&(z+=M)}te=ue===e.GLOBSTAR})}return z}const _=/^\*\*\/\*\.[\w\.-]+$/,L=/^\*\*\/([\w\.-]+)\/?$/,b=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,k=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,D=/^\*\*((\/[\w\.-]+)+)\/?$/,n=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,i=new Y.LRUCache(1e4),s=function(){return!1},g=function(){return null};function N(q,z){if(!q)return g;let H;typeof q!="string"?H=q.pattern:H=q,H=H.trim();const te=`${H}_${!!z.trimForExclusions}`;let ue=i.get(te);if(ue)return h(ue,q);let w;return _.test(H)?ue=l(H.substr(4),H):(w=L.exec(m(H,z)))?ue=f(w[1],H):(z.trimForExclusions?k:b).test(H)?ue=y(H,z):(w=D.exec(m(H,z)))?ue=A(w[1].substr(1),H,!0):(w=n.exec(m(H,z)))?ue=A(w[1],H,!1):ue=p(H),i.set(te,ue),h(ue,q)}function h(q,z){if(typeof z=="string")return q;const H=function(te,ue){return(0,S.isEqualOrParent)(te,z.base,!O.isLinux)?q((0,R.ltrim)(te.substr(z.base.length),U.sep),ue):null};return H.allBasenames=q.allBasenames,H.allPaths=q.allPaths,H.basenames=q.basenames,H.patterns=q.patterns,H}function m(q,z){return z.trimForExclusions&&q.endsWith("/**")?q.substr(0,q.length-2):q}function l(q,z){return function(H,te){return typeof H=="string"&&H.endsWith(q)?z:null}}function f(q,z){const H=`/${q}`,te=`\\${q}`,ue=function(ie,se){return typeof ie!="string"?null:se?se===q?z:null:ie===q||ie.endsWith(H)||ie.endsWith(te)?z:null},w=[q];return ue.basenames=w,ue.patterns=[z],ue.allBasenames=w,ue}function y(q,z){const H=Z(q.slice(1,-1).split(",").map(se=>N(se,z)).filter(se=>se!==g),q),te=H.length;if(!te)return g;if(te===1)return H[0];const ue=function(se,oe){for(let ce=0,fe=H.length;ce<fe;ce++)if(H[ce](se,oe))return q;return null},w=H.find(se=>!!se.allBasenames);w&&(ue.allBasenames=w.allBasenames);const ie=H.reduce((se,oe)=>oe.allPaths?se.concat(oe.allPaths):se,[]);return ie.length&&(ue.allPaths=ie),ue}function A(q,z,H){const te=U.sep===U.posix.sep,ue=te?q:q.replace(C,U.sep),w=U.sep+ue,ie=U.posix.sep+q;let se;return H?se=function(oe,ce){return typeof oe=="string"&&(oe===ue||oe.endsWith(w)||!te&&(oe===q||oe.endsWith(ie)))?z:null}:se=function(oe,ce){return typeof oe=="string"&&(oe===ue||!te&&oe===q)?z:null},se.allPaths=[(H?"*/":"./")+q],se}function p(q){try{const z=new RegExp(`^${a(q)}$`);return function(H){return z.lastIndex=0,typeof H=="string"&&z.test(H)?q:null}}catch{return g}}function j(q,z,H){return!q||typeof z!="string"?!1:x(q)(z,void 0,H)}function x(q,z={}){if(!q)return s;if(typeof q=="string"||J(q)){const H=N(q,z);if(H===g)return s;const te=function(ue,w){return!!H(ue,w)};return H.allBasenames&&(te.allBasenames=H.allBasenames),H.allPaths&&(te.allPaths=H.allPaths),te}return W(q,z)}function J(q){const z=q;return z?typeof z.base=="string"&&typeof z.pattern=="string":!1}function G(q){return q.allBasenames||[]}function le(q){return q.allPaths||[]}function W(q,z){const H=Z(Object.getOwnPropertyNames(q).map(se=>K(se,q[se],z)).filter(se=>se!==g)),te=H.length;if(!te)return g;if(!H.some(se=>!!se.requiresSiblings)){if(te===1)return H[0];const se=function(fe,Le){let P;for(let $=0,E=H.length;$<E;$++){const o=H[$](fe,Le);if(typeof o=="string")return o;(0,t.isThenable)(o)&&(P||(P=[]),P.push(o))}return P?(async()=>{for(const $ of P){const E=await $;if(typeof E=="string")return E}return null})():null},oe=H.find(fe=>!!fe.allBasenames);oe&&(se.allBasenames=oe.allBasenames);const ce=H.reduce((fe,Le)=>Le.allPaths?fe.concat(Le.allPaths):fe,[]);return ce.length&&(se.allPaths=ce),se}const ue=function(se,oe,ce){let fe,Le;for(let P=0,$=H.length;P<$;P++){const E=H[P];E.requiresSiblings&&ce&&(oe||(oe=(0,U.basename)(se)),fe||(fe=oe.substr(0,oe.length-(0,U.extname)(se).length)));const o=E(se,oe,fe,ce);if(typeof o=="string")return o;(0,t.isThenable)(o)&&(Le||(Le=[]),Le.push(o))}return Le?(async()=>{for(const P of Le){const $=await P;if(typeof $=="string")return $}return null})():null},w=H.find(se=>!!se.allBasenames);w&&(ue.allBasenames=w.allBasenames);const ie=H.reduce((se,oe)=>oe.allPaths?se.concat(oe.allPaths):se,[]);return ie.length&&(ue.allPaths=ie),ue}function K(q,z,H){if(z===!1)return g;const te=N(q,H);if(te===g)return g;if(typeof z=="boolean")return te;if(z){const ue=z.when;if(typeof ue=="string"){const w=(ie,se,oe,ce)=>{if(!ce||!te(ie,se))return null;const fe=ue.replace("$(basename)",()=>oe),Le=ce(fe);return(0,t.isThenable)(Le)?Le.then(P=>P?q:null):Le?q:null};return w.requiresSiblings=!0,w}}return te}function Z(q,z){const H=q.filter(se=>!!se.basenames);if(H.length<2)return q;const te=H.reduce((se,oe)=>{const ce=oe.basenames;return ce?se.concat(ce):se},[]);let ue;if(z){ue=[];for(let se=0,oe=te.length;se<oe;se++)ue.push(z)}else ue=H.reduce((se,oe)=>{const ce=oe.patterns;return ce?se.concat(ce):se},[]);const w=function(se,oe){if(typeof se!="string")return null;if(!oe){let fe;for(fe=se.length;fe>0;fe--){const Le=se.charCodeAt(fe-1);if(Le===I.CharCode.Slash||Le===I.CharCode.Backslash)break}oe=se.substr(fe)}const ce=te.indexOf(oe);return ce!==-1?ue[ce]:null};w.basenames=te,w.patterns=ue,w.allBasenames=te;const ie=q.filter(se=>!se.basenames);return ie.push(w),ie}function ee(q,z){return(0,c.equals)(q,z,(H,te)=>typeof H=="string"&&typeof te=="string"?H===te:typeof H!="string"&&typeof te!="string"?H.base===te.base&&H.pattern===te.pattern:!1)}}),define(pe[21],be([0,1,9,22,54,8,5,24,3,2,20,6]),function(re,e,c,t,I,S,Y,U,O,R,B,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.SymlinkSupport=e.RimRafMode=void 0,e.rimrafSync=a,e.readdirSync=b,e.whenDeleted=n,e.configureFlushOnWrite=h,e.writeFileSync=l,c=Pe(c);var T;(function(W){W[W.UNLINK=0]="UNLINK",W[W.MOVE=1]="MOVE"})(T||(e.RimRafMode=T={}));async function C(W,K=T.UNLINK,Z){if((0,Y.isRootOrDriveLetter)(W))throw new Error("rimraf - will refuse to recursively delete root");return K===T.UNLINK?r(W):u(W,Z)}async function u(W,K=(0,Y.randomPath)((0,t.tmpdir)())){try{try{await c.promises.rename(W,K)}catch(Z){return Z.code==="ENOENT"?void 0:r(W)}r(K).catch(Z=>{})}catch(Z){if(Z.code!=="ENOENT")throw Z}}async function r(W){return c.promises.rm(W,{recursive:!0,force:!0,maxRetries:3})}function a(W){if((0,Y.isRootOrDriveLetter)(W))throw new Error("rimraf - will refuse to recursively delete root");c.rmSync(W,{recursive:!0,force:!0,maxRetries:3})}async function _(W,K){return k(await(K?L(W):c.promises.readdir(W)))}async function L(W){try{return await c.promises.readdir(W,{withFileTypes:!0})}catch(ee){console.warn("[node.js fs] readdir with filetypes failed with error: ",ee)}const K=[],Z=await _(W);for(const ee of Z){let q=!1,z=!1,H=!1;try{const te=await c.promises.lstat((0,O.join)(W,ee));q=te.isFile(),z=te.isDirectory(),H=te.isSymbolicLink()}catch(te){console.warn("[node.js fs] unexpected error from lstat after readdir: ",te)}K.push({name:ee,isFile:()=>q,isDirectory:()=>z,isSymbolicLink:()=>H})}return K}function b(W){return k(c.readdirSync(W))}function k(W){return W.map(K=>typeof K=="string"?R.isMacintosh?(0,U.normalizeNFC)(K):K:(K.name=R.isMacintosh?(0,U.normalizeNFC)(K.name):K.name,K))}async function D(W){const K=await _(W),Z=[];for(const ee of K)await i.existsDirectory((0,O.join)(W,ee))&&Z.push(ee);return Z}function n(W,K=1e3){return new Promise(Z=>{let ee=!1;const q=setInterval(()=>{ee||(ee=!0,c.access(W,z=>{ee=!1,z&&(clearInterval(q),Z(void 0))}))},K)})}var i;(function(W){async function K(q){let z;try{if(z=await c.promises.lstat(q),!z.isSymbolicLink())return{stat:z}}catch{}try{return{stat:await c.promises.stat(q),symbolicLink:z?.isSymbolicLink()?{dangling:!1}:void 0}}catch(H){if(H.code==="ENOENT"&&z)return{stat:z,symbolicLink:{dangling:!0}};if(R.isWindows&&H.code==="EACCES")try{return{stat:await c.promises.stat(await c.promises.readlink(q)),symbolicLink:{dangling:!1}}}catch(te){if(te.code==="ENOENT"&&z)return{stat:z,symbolicLink:{dangling:!0}};throw te}throw H}}W.stat=K;async function Z(q){try{const{stat:z,symbolicLink:H}=await W.stat(q);return z.isFile()&&H?.dangling!==!0}catch{}return!1}W.existsFile=Z;async function ee(q){try{const{stat:z,symbolicLink:H}=await W.stat(q);return z.isDirectory()&&H?.dangling!==!0}catch{}return!1}W.existsDirectory=ee})(i||(e.SymlinkSupport=i={}));const s=new S.ResourceQueue;function g(W,K,Z){return s.queueFor(M.URI.file(W),()=>{const ee=f(Z);return new Promise((q,z)=>m(W,K,ee,H=>H?z(H):q()))},B.extUriBiasedIgnorePathCase)}let N=!0;function h(W){N=W}function m(W,K,Z,ee){if(!N)return c.writeFile(W,K,{mode:Z.mode,flag:Z.flag},ee);c.open(W,Z.flag,Z.mode,(q,z)=>{if(q)return ee(q);c.writeFile(z,K,H=>{if(H)return c.close(z,()=>ee(H));c.fdatasync(z,te=>(te&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",te),h(!1)),c.close(z,ue=>ee(ue))))})})}function l(W,K,Z){const ee=f(Z);if(!N)return c.writeFileSync(W,K,{mode:ee.mode,flag:ee.flag});const q=c.openSync(W,ee.flag,ee.mode);try{c.writeFileSync(q,K);try{c.fdatasyncSync(q)}catch(z){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",z),h(!1)}}finally{c.closeSync(q)}}function f(W){return W?{mode:typeof W.mode=="number"?W.mode:438,flag:typeof W.flag=="string"?W.flag:"w"}:{mode:438,flag:"w"}}async function y(W,K,Z=6e4){if(W!==K)try{R.isWindows&&typeof Z=="number"?await A(W,K,Date.now(),Z):await c.promises.rename(W,K)}catch(ee){if(W.toLowerCase()!==K.toLowerCase()&&ee.code==="EXDEV"||W.endsWith("."))await p(W,K,{preserveSymlinks:!1}),await C(W,T.MOVE);else throw ee}}async function A(W,K,Z,ee,q=0){try{return await c.promises.rename(W,K)}catch(z){if(z.code!=="EACCES"&&z.code!=="EPERM"&&z.code!=="EBUSY")throw z;if(Date.now()-Z>=ee)throw console.error(`[node.js fs] rename failed after ${q} retries with error: ${z}`),z;if(q===0){let H=!1;try{const{stat:te}=await i.stat(K);te.isFile()||(H=!0)}catch{}if(H)throw z}return await(0,S.timeout)(Math.min(100,q*10)),A(W,K,Z,ee,q+1)}}async function p(W,K,Z){return x(W,K,{root:{source:W,target:K},options:Z,handledSourcePaths:new Set})}const j=511;async function x(W,K,Z){if(Z.handledSourcePaths.has(W))return;Z.handledSourcePaths.add(W);const{stat:ee,symbolicLink:q}=await i.stat(W);if(q){if(Z.options.preserveSymlinks)try{return await le(W,K,Z)}catch{}if(q.dangling)return}return ee.isDirectory()?J(W,K,ee.mode&j,Z):G(W,K,ee.mode&j)}async function J(W,K,Z,ee){await c.promises.mkdir(K,{recursive:!0,mode:Z});const q=await _(W);for(const z of q)await x((0,O.join)(W,z),(0,O.join)(K,z),ee)}async function G(W,K,Z){await c.promises.copyFile(W,K),await c.promises.chmod(K,Z)}async function le(W,K,Z){let ee=await c.promises.readlink(W);(0,Y.isEqualOrParent)(ee,Z.root.source,!R.isLinux)&&(ee=(0,O.join)(Z.root.target,ee.substr(Z.root.source.length+1))),await c.promises.symlink(ee,K)}e.Promises=new class{get read(){return(W,K,Z,ee,q)=>new Promise((z,H)=>{c.read(W,K,Z,ee,q,(te,ue,w)=>te?H(te):z({bytesRead:ue,buffer:w}))})}get write(){return(W,K,Z,ee,q)=>new Promise((z,H)=>{c.write(W,K,Z,ee,q,(te,ue,w)=>te?H(te):z({bytesWritten:ue,buffer:w}))})}get fdatasync(){return(0,I.promisify)(c.fdatasync)}get open(){return(0,I.promisify)(c.open)}get close(){return(0,I.promisify)(c.close)}get realpath(){return(0,I.promisify)(c.realpath)}async exists(W){try{return await c.promises.access(W),!0}catch{return!1}}get readdir(){return _}get readDirsInDir(){return D}get writeFile(){return g}get rm(){return C}get rename(){return y}get copy(){return p}}}),define(pe[43],be([0,1,9,3,2,4,21]),function(re,e,c,t,I,S,Y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realcaseSync=U,e.realcase=O,e.realpath=R,e.realpathSync=B,c=Pe(c);function U(T){if(I.isLinux)return T;const C=(0,t.dirname)(T);if(T===C)return T;const u=((0,t.basename)(T)||T).toLowerCase();try{const a=(0,Y.readdirSync)(C).filter(_=>_.toLowerCase()===u);if(a.length===1){const _=U(C);if(_)return(0,t.join)(_,a[0])}else if(a.length>1){const _=a.indexOf(u);if(_>=0){const L=U(C);if(L)return(0,t.join)(L,a[_])}}}catch{}return null}async function O(T,C){if(I.isLinux)return T;const u=(0,t.dirname)(T);if(T===u)return T;const r=((0,t.basename)(T)||T).toLowerCase();try{if(C?.isCancellationRequested)return null;const _=(await Y.Promises.readdir(u)).filter(L=>L.toLowerCase()===r);if(_.length===1){const L=await O(u,C);if(L)return(0,t.join)(L,_[0])}else if(_.length>1){const L=_.indexOf(r);if(L>=0){const b=await O(u,C);if(b)return(0,t.join)(b,_[L])}}}catch{}return null}async function R(T){try{return await Y.Promises.realpath(T)}catch{const u=M(T);return await c.promises.access(u,c.constants.R_OK),u}}function B(T){try{return c.realpathSync(T)}catch{const u=M(T);return c.accessSync(u,c.constants.R_OK),u}}function M(T){return(0,S.rtrim)((0,t.normalize)(T),t.sep)}}),define(pe[44],be([0,1,45,2]),function(re,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveTerminalEncoding=O;const I={437:"cp437",850:"cp850",852:"cp852",855:"cp855",857:"cp857",860:"cp860",861:"cp861",863:"cp863",865:"cp865",866:"cp866",869:"cp869",936:"cp936",1252:"cp1252"};function S(R){const B=R.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return Y[B]||B}const Y={ibm866:"cp866",big5:"cp950"},U="utf8";async function O(R){let B;const M=process.env.VSCODE_CLI_ENCODING;M?(R&&console.log(`Found VSCODE_CLI_ENCODING variable: ${M}`),B=Promise.resolve(M)):t.isWindows?B=new Promise(C=>{R&&console.log('Running "chcp" to detect terminal encoding...'),(0,c.exec)("chcp",(u,r,a)=>{if(r){R&&console.log(`Output from "chcp" command is: ${r}`);const _=Object.keys(I);for(const L of _)if(r.indexOf(L)>=0)return C(I[L])}return C(void 0)})}):B=new Promise(C=>{R&&console.log('Running "locale charmap" to detect terminal encoding...'),(0,c.exec)("locale charmap",(u,r,a)=>C(r))});const T=await B;return R&&console.log(`Detected raw terminal encoding: ${T}`),!T||T.toLowerCase()==="utf-8"||T.toLowerCase()===U?U:S(T)}});var Ge=this&&this.__importDefault||function(re){return re&&re.__esModule?re:{default:re}};define(pe[27],be([0,1,55,2,13]),function(re,e,c,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OPTIONS=e.NATIVE_CLI_COMMANDS=void 0,e.parseArgs=U,e.formatOptions=R,e.buildHelpMessage=C,e.buildVersionMessage=u,c=Ge(c);const S={o:(0,I.localize)(1713,null),e:(0,I.localize)(1714,null),t:(0,I.localize)(1715,null)};e.NATIVE_CLI_COMMANDS=["tunnel","serve-web"],e.OPTIONS={tunnel:{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,I.localize)(1716,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"},user:{type:"subcommand",options:{login:{type:"subcommand",options:{provider:{type:"string"},"access-token":{type:"string"}}}}}}},"serve-web":{type:"subcommand",description:"Run a server that displays the editor UI in browsers.",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,I.localize)(1717,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"}}},diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,I.localize)(1718,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,I.localize)(1719,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,I.localize)(1720,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,I.localize)(1721,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,I.localize)(1722,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,I.localize)(1723,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,I.localize)(1724,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,I.localize)(1725,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,I.localize)(1726,null)},profile:{type:"string",cat:"o",args:"profileName",description:(0,I.localize)(1727,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,I.localize)(1728,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,I.localize)(1729,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,I.localize)(1730,null)},"show-versions":{type:"boolean",cat:"e",description:(0,I.localize)(1731,null)},category:{type:"string",allowEmptyValue:!0,cat:"e",description:(0,I.localize)(1732,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,I.localize)(1733,null)},"pre-release":{type:"boolean",cat:"e",description:(0,I.localize)(1734,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,I.localize)(1735,null)},"update-extensions":{type:"boolean",cat:"e",description:(0,I.localize)(1736,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,I.localize)(1737,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,I.localize)(1738,null)},verbose:{type:"boolean",cat:"t",global:!0,description:(0,I.localize)(1739,null)},log:{type:"string[]",cat:"t",args:"level",global:!0,description:(0,I.localize)(1740,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,I.localize)(1741,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,I.localize)(1742,null)},"prof-append-timers":{type:"string"},"prof-duration-markers":{type:"string[]"},"prof-duration-markers-file":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,I.localize)(1743,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,I.localize)(1744,null)},sync:{type:"string",cat:"t",description:(0,I.localize)(1745,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,I.localize)(1746,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,I.localize)(1747,null)},"disable-lcd-text":{type:"boolean",cat:"t",description:(0,I.localize)(1748,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,I.localize)(1749,null)},"disable-chromium-sandbox":{type:"boolean",cat:"t",description:(0,I.localize)(1750,null)},sandbox:{type:"boolean"},telemetry:{type:"boolean",cat:"t",description:(0,I.localize)(1751,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"inspect-sharedprocess":{type:"string",allowEmptyValue:!0},"inspect-brk-sharedprocess":{type:"string",allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"use-inmemory-secretstorage":{type:"boolean",deprecates:["disable-keytar"]},"password-store":{type:"string"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"preserve-env":{type:"boolean"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},"disable-gpu-sandbox":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},"ozone-platform":{type:"string"},"enable-tracing":{type:"string"},"trace-startup-format":{type:"string"},"trace-startup-file":{type:"string"},"trace-startup-duration":{type:"string"},_:{type:"string[]"}};const Y={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function U(r,a,_=Y){const L=r.find(h=>h.length>0&&h[0]!=="-"),b={},k=["_"],D=[],n={};let i;for(const h in a){const m=a[h];m.type==="subcommand"?h===L&&(i=m):(m.alias&&(b[h]=m.alias),m.type==="string"||m.type==="string[]"?(k.push(h),m.deprecates&&k.push(...m.deprecates)):m.type==="boolean"&&(D.push(h),m.deprecates&&D.push(...m.deprecates)),m.global&&(n[h]=m))}if(i&&L){const h=n;for(const y in i.options)h[y]=i.options[y];const m=r.filter(y=>y!==L),l=_.getSubcommandReporter?_.getSubcommandReporter(L):void 0,f=U(m,h,l);return{[L]:f,_:[]}}const s=(0,c.default)(r,{string:k,boolean:D,alias:b}),g={},N=s;g._=s._.map(h=>String(h)).filter(h=>h.length>0),delete N._;for(const h in a){const m=a[h];if(m.type==="subcommand")continue;m.alias&&delete N[m.alias];let l=N[h];if(m.deprecates)for(const f of m.deprecates)N.hasOwnProperty(f)&&(l||(l=N[f],l&&_.onDeprecatedOption(f,m.deprecationMessage||(0,I.localize)(1752,null,h))),delete N[f]);if(typeof l<"u"){if(m.type==="string[]"){if(Array.isArray(l)||(l=[l]),!m.allowEmptyValue){const f=l.filter(y=>y.length>0);f.length!==l.length&&(_.onEmptyValue(h),l=f.length>0?f:void 0)}}else m.type==="string"&&(Array.isArray(l)?(l=l.pop(),_.onMultipleValues(h,l)):!l&&!m.allowEmptyValue&&(_.onEmptyValue(h),l=void 0));g[h]=l,m.deprecationMessage&&_.onDeprecatedOption(h,m.deprecationMessage)}delete N[h]}for(const h in N)_.onUnknownOption(h);return g}function O(r,a){let _="";return a.args&&(Array.isArray(a.args)?_=` <${a.args.join("> <")}>`:_=` <${a.args}>`),a.alias?`-${a.alias} --${r}${_}`:`--${r}${_}`}function R(r,a){const _=[];for(const L in r){const b=r[L],k=O(L,b);_.push([k,b.description])}return B(_,a)}function B(r,a){const L=r.reduce((D,n)=>Math.max(D,n[0].length),12)+2+1;if(a-L<25)return r.reduce((D,n)=>D.concat([`  ${n[0]}`,`      ${n[1]}`]),[]);const b=a-L-1,k=[];for(const D of r){const n=D[0],i=T(D[1],b),s=M(L-n.length-2);k.push("  "+n+s+i[0]);for(let g=1;g<i.length;g++)k.push(M(L)+i[g])}return k}function M(r){return" ".repeat(r)}function T(r,a){const _=[];for(;r.length;){const L=r.length<a?r.length:r.lastIndexOf(" ",a),b=r.slice(0,L).trim();r=r.slice(L),_.push(b)}return _}function C(r,a,_,L,b){const k=process.stdout.isTTY&&process.stdout.columns||80,D=b?.noInputFiles!==!0?`[${(0,I.localize)(1753,null)}...]`:"",n=[`${r} ${_}`];n.push(""),n.push(`${(0,I.localize)(1754,null)}: ${a} [${(0,I.localize)(1755,null)}]${D}`),n.push(""),b?.noPipe!==!0&&(t.isWindows?n.push((0,I.localize)(1756,null,a)):n.push((0,I.localize)(1757,null,a)),n.push(""));const i={},s=[];for(const g in L){const N=L[g];if(N.type==="subcommand")N.description&&s.push({command:g,description:N.description});else if(N.description&&N.cat){let h=i[N.cat];h||(i[N.cat]=h={}),h[g]=N}}for(const g in i){const N=g,h=i[N];h&&(n.push(S[N]),n.push(...R(h,k)),n.push(""))}return s.length&&(n.push((0,I.localize)(1758,null)),n.push(...B(s.map(g=>[g.command,g.description]),k)),n.push("")),n.join(`
`)}function u(r,a){return`${r||(0,I.localize)(1759,null)}
${a||(0,I.localize)(1760,null)}
${process.arch}`}});var Ge=this&&this.__importDefault||function(re){return re&&re.__esModule?re:{default:re}};define(pe[46],be([0,1,56,13,27]),function(re,e,c,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseMainProcessArgv=U,e.parseCLIProcessArgv=O,e.addArg=R,e.isLaunchedFromCli=B,c=Ge(c);function S(M,T){const C=(b,k)=>{console.warn((0,t.localize)(1761,null,b,k))},u=b=>{console.warn((0,t.localize)(1762,null,b))},r=(b,k)=>{console.warn((0,t.localize)(1763,null,b,k))},a=b=>({onUnknownOption:k=>{I.NATIVE_CLI_COMMANDS.includes(b)||console.warn((0,t.localize)(1764,null,k,b))},onMultipleValues:C,onEmptyValue:u,onDeprecatedOption:r,getSubcommandReporter:I.NATIVE_CLI_COMMANDS.includes(b)?a:void 0}),_={onUnknownOption:b=>{console.warn((0,t.localize)(1765,null,b))},onMultipleValues:C,onEmptyValue:u,onDeprecatedOption:r,getSubcommandReporter:a},L=(0,I.parseArgs)(M,I.OPTIONS,T?_:void 0);return L.goto&&L._.forEach(b=>(0,c.default)(/^(\w:)?[^:]+(:\d*){0,2}:?$/.test(b),(0,t.localize)(1766,null))),L}function Y(M){const T=M.findIndex(C=>!/^-/.test(C));if(T>-1)return[...M.slice(0,T),...M.slice(T+1)]}function U(M){let[,...T]=M;process.env.VSCODE_DEV&&(T=Y(T)||[]);const C=!B(process.env);return S(T,C)}function O(M){let[,,...T]=M;return process.env.VSCODE_DEV&&(T=Y(T)||[]),S(T,!0)}function R(M,...T){const C=M.indexOf("--");return C===-1?M.push(...T):M.splice(C,0,...T),M}function B(M){return M.VSCODE_CLI==="1"}}),define(pe[47],be([0,1,9,22,8,5,44]),function(re,e,c,t,I,S,Y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasStdinWithoutTty=U,e.stdinDataListener=O,e.getStdinFilePath=R,e.readFromStdin=B,c=Pe(c);function U(){try{return!process.stdin.isTTY}catch{}return!1}function O(M){return new Promise(T=>{const C=()=>T(!0);setTimeout(()=>{process.stdin.removeListener("data",C),T(!1)},M),process.stdin.once("data",C)})}function R(){return(0,S.randomPath)((0,t.tmpdir)(),"code-stdin",3)}async function B(M,T,C){let[u,r]=await Promise.all([(0,Y.resolveTerminalEncoding)(T),new Promise((L,b)=>{re(["@vscode/iconv-lite-umd"],L,b)}).then(Pe),c.promises.appendFile(M,"")]);r.encodingExists(u)||(console.log(`Unsupported terminal encoding: ${u}, falling back to UTF-8.`),u="utf8");const a=new I.Queue,_=r.getDecoder(u);process.stdin.on("data",L=>{const b=_.write(L);a.queue(()=>c.promises.appendFile(M,b))}),process.stdin.on("end",()=>{const L=_.end();a.queue(async()=>{try{typeof L=="string"&&await c.promises.appendFile(M,L)}finally{C?.()}})})}}),define(pe[48],be([0,1,9,22,5]),function(re,e,c,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createWaitMarkerFileSync=S;function S(Y){const U=(0,I.randomPath)((0,t.tmpdir)());try{return(0,c.writeFileSync)(U,""),Y&&console.log(`Marker file for --wait created: ${U}`),U}catch(O){Y&&console.error(`Failed to create marker file for --wait: ${O}`);return}}}),define(pe[28],be([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IInstantiationService=e._util=void 0,e.createDecorator=I,e.refineServiceDecorator=S;var c;(function(Y){Y.serviceIds=new Map,Y.DI_TARGET="$di$target",Y.DI_DEPENDENCIES="$di$dependencies";function U(O){return O[Y.DI_DEPENDENCIES]||[]}Y.getServiceDependencies=U})(c||(e._util=c={})),e.IInstantiationService=I("instantiationService");function t(Y,U,O){U[c.DI_TARGET]===U?U[c.DI_DEPENDENCIES].push({id:Y,index:O}):(U[c.DI_DEPENDENCIES]=[{id:Y,index:O}],U[c.DI_TARGET]=U)}function I(Y){if(c.serviceIds.has(Y))return c.serviceIds.get(Y);const U=function(O,R,B){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");t(U,O,B)};return U.toString=()=>Y,c.serviceIds.set(Y,U),U}function S(Y){return Y}}),define(pe[29],be([0,1,40,3,4,25,6,13,28,2,19,15]),function(re,e,c,t,I,S,Y,U,O,R,B,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ByteSize=e.ETAG_DISABLED=e.FileKind=e.FILES_READONLY_FROM_PERMISSIONS_CONFIG=e.FILES_READONLY_EXCLUDE_CONFIG=e.FILES_READONLY_INCLUDE_CONFIG=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.TooLargeFileOperationError=e.FileOperationError=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FileChangeFilter=e.FilePermission=e.FileType=e.IFileService=void 0,e.isFileOpenForWriteOptions=T,e.isFileSystemWatcher=a,e.hasReadWriteCapability=L,e.hasFileFolderCopyCapability=b,e.hasFileCloneCapability=k,e.hasOpenReadWriteCloseCapability=D,e.hasFileReadStreamCapability=n,e.hasFileAtomicReadCapability=i,e.hasFileAtomicWriteCapability=s,e.hasFileAtomicDeleteCapability=g,e.hasReadonlyCapability=N,e.createFileSystemProviderError=l,e.ensureFileSystemProviderError=f,e.markAsFileSystemProviderError=y,e.toFileSystemProviderErrorCode=A,e.toFileOperationResult=p,e.isParent=le,e.etag=z,e.whenProviderRegistered=H,e.getLargeFileConfirmationLimit=ue,e.IFileService=(0,O.createDecorator)("fileService");function T(w){return w.create===!0}var C;(function(w){w[w.Unknown=0]="Unknown",w[w.File=1]="File",w[w.Directory=2]="Directory",w[w.SymbolicLink=64]="SymbolicLink"})(C||(e.FileType=C={}));var u;(function(w){w[w.Readonly=1]="Readonly",w[w.Locked=2]="Locked"})(u||(e.FilePermission=u={}));var r;(function(w){w[w.UPDATED=2]="UPDATED",w[w.ADDED=4]="ADDED",w[w.DELETED=8]="DELETED"})(r||(e.FileChangeFilter=r={}));function a(w){const ie=w;return!!ie&&typeof ie.onDidChange=="function"}var _;(function(w){w[w.None=0]="None",w[w.FileReadWrite=2]="FileReadWrite",w[w.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",w[w.FileReadStream=16]="FileReadStream",w[w.FileFolderCopy=8]="FileFolderCopy",w[w.PathCaseSensitive=1024]="PathCaseSensitive",w[w.Readonly=2048]="Readonly",w[w.Trash=4096]="Trash",w[w.FileWriteUnlock=8192]="FileWriteUnlock",w[w.FileAtomicRead=16384]="FileAtomicRead",w[w.FileAtomicWrite=32768]="FileAtomicWrite",w[w.FileAtomicDelete=65536]="FileAtomicDelete",w[w.FileClone=131072]="FileClone"})(_||(e.FileSystemProviderCapabilities=_={}));function L(w){return!!(w.capabilities&_.FileReadWrite)}function b(w){return!!(w.capabilities&_.FileFolderCopy)}function k(w){return!!(w.capabilities&_.FileClone)}function D(w){return!!(w.capabilities&_.FileOpenReadWriteClose)}function n(w){return!!(w.capabilities&_.FileReadStream)}function i(w){return L(w)?!!(w.capabilities&_.FileAtomicRead):!1}function s(w){return L(w)?!!(w.capabilities&_.FileAtomicWrite):!1}function g(w){return!!(w.capabilities&_.FileAtomicDelete)}function N(w){return!!(w.capabilities&_.Readonly)}var h;(function(w){w.FileExists="EntryExists",w.FileNotFound="EntryNotFound",w.FileNotADirectory="EntryNotADirectory",w.FileIsADirectory="EntryIsADirectory",w.FileExceedsStorageQuota="EntryExceedsStorageQuota",w.FileTooLarge="EntryTooLarge",w.FileWriteLocked="EntryWriteLocked",w.NoPermissions="NoPermissions",w.Unavailable="Unavailable",w.Unknown="Unknown"})(h||(e.FileSystemProviderErrorCode=h={}));class m extends Error{static create(ie,se){const oe=new m(ie.toString(),se);return y(oe,se),oe}constructor(ie,se){super(ie),this.code=se}}e.FileSystemProviderError=m;function l(w,ie){return m.create(w,ie)}function f(w){return w||l((0,U.localize)(1865,null),h.Unknown)}function y(w,ie){return w.name=ie?`${ie} (FileSystemError)`:"FileSystemError",w}function A(w){if(!w)return h.Unknown;if(w instanceof m)return w.code;const ie=/^(.+) \(FileSystemError\)$/.exec(w.name);if(!ie)return h.Unknown;switch(ie[1]){case h.FileExists:return h.FileExists;case h.FileIsADirectory:return h.FileIsADirectory;case h.FileNotADirectory:return h.FileNotADirectory;case h.FileNotFound:return h.FileNotFound;case h.FileTooLarge:return h.FileTooLarge;case h.FileWriteLocked:return h.FileWriteLocked;case h.NoPermissions:return h.NoPermissions;case h.Unavailable:return h.Unavailable}return h.Unknown}function p(w){if(w instanceof W)return w.fileOperationResult;switch(A(w)){case h.FileNotFound:return ee.FILE_NOT_FOUND;case h.FileIsADirectory:return ee.FILE_IS_DIRECTORY;case h.FileNotADirectory:return ee.FILE_NOT_DIRECTORY;case h.FileWriteLocked:return ee.FILE_WRITE_LOCKED;case h.NoPermissions:return ee.FILE_PERMISSION_DENIED;case h.FileExists:return ee.FILE_MOVE_CONFLICT;case h.FileTooLarge:return ee.FILE_TOO_LARGE;default:return ee.FILE_OTHER_ERROR}}var j;(function(w){w[w.CREATE=0]="CREATE",w[w.DELETE=1]="DELETE",w[w.MOVE=2]="MOVE",w[w.COPY=3]="COPY",w[w.WRITE=4]="WRITE"})(j||(e.FileOperation=j={}));class x{constructor(ie,se,oe){this.resource=ie,this.operation=se,this.target=oe}isOperation(ie){return this.operation===ie}}e.FileOperationEvent=x;var J;(function(w){w[w.UPDATED=0]="UPDATED",w[w.ADDED=1]="ADDED",w[w.DELETED=2]="DELETED"})(J||(e.FileChangeType=J={}));class G{static{this.MIXED_CORRELATION=null}constructor(ie,se){this.ignorePathCasing=se,this.correlationId=void 0,this.added=new M.Lazy(()=>{const oe=c.TernarySearchTree.forUris(()=>this.ignorePathCasing);return oe.fill(this.rawAdded.map(ce=>[ce,!0])),oe}),this.updated=new M.Lazy(()=>{const oe=c.TernarySearchTree.forUris(()=>this.ignorePathCasing);return oe.fill(this.rawUpdated.map(ce=>[ce,!0])),oe}),this.deleted=new M.Lazy(()=>{const oe=c.TernarySearchTree.forUris(()=>this.ignorePathCasing);return oe.fill(this.rawDeleted.map(ce=>[ce,!0])),oe}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const oe of ie){switch(oe.type){case J.ADDED:this.rawAdded.push(oe.resource);break;case J.UPDATED:this.rawUpdated.push(oe.resource);break;case J.DELETED:this.rawDeleted.push(oe.resource);break}this.correlationId!==G.MIXED_CORRELATION&&(typeof oe.cId=="number"?this.correlationId===void 0?this.correlationId=oe.cId:this.correlationId!==oe.cId&&(this.correlationId=G.MIXED_CORRELATION):this.correlationId!==void 0&&(this.correlationId=G.MIXED_CORRELATION))}}contains(ie,...se){return this.doContains(ie,{includeChildren:!1},...se)}affects(ie,...se){return this.doContains(ie,{includeChildren:!0},...se)}doContains(ie,se,...oe){if(!ie)return!1;const ce=oe.length>0;return!!((!ce||oe.includes(J.ADDED))&&(this.added.value.get(ie)||se.includeChildren&&this.added.value.findSuperstr(ie))||(!ce||oe.includes(J.UPDATED))&&(this.updated.value.get(ie)||se.includeChildren&&this.updated.value.findSuperstr(ie))||(!ce||oe.includes(J.DELETED))&&(this.deleted.value.findSubstr(ie)||se.includeChildren&&this.deleted.value.findSuperstr(ie)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(ie){return this.correlationId===ie}hasCorrelation(){return typeof this.correlationId=="number"}}e.FileChangesEvent=G;function le(w,ie,se){return!w||!ie||w===ie||ie.length>w.length?!1:(ie.charAt(ie.length-1)!==t.sep&&(ie+=t.sep),se?(0,I.startsWithIgnoreCase)(w,ie):w.indexOf(ie)===0)}class W extends Error{constructor(ie,se,oe){super(ie),this.fileOperationResult=se,this.options=oe}}e.FileOperationError=W;class K extends W{constructor(ie,se,oe,ce){super(ie,se,ce),this.fileOperationResult=se,this.size=oe}}e.TooLargeFileOperationError=K;class Z extends W{constructor(ie,se,oe){super(ie,ee.FILE_NOT_MODIFIED_SINCE,oe),this.stat=se}}e.NotModifiedSinceFileOperationError=Z;var ee;(function(w){w[w.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",w[w.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",w[w.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",w[w.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",w[w.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",w[w.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",w[w.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",w[w.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",w[w.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",w[w.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",w[w.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(ee||(e.FileOperationResult=ee={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude",e.FILES_READONLY_INCLUDE_CONFIG="files.readonlyInclude",e.FILES_READONLY_EXCLUDE_CONFIG="files.readonlyExclude",e.FILES_READONLY_FROM_PERMISSIONS_CONFIG="files.readonlyFromPermissions";var q;(function(w){w[w.FILE=0]="FILE",w[w.FOLDER=1]="FOLDER",w[w.ROOT_FOLDER=2]="ROOT_FOLDER"})(q||(e.FileKind=q={})),e.ETAG_DISABLED="";function z(w){if(!(typeof w.size!="number"||typeof w.mtime!="number"))return w.mtime.toString(29)+w.size.toString(31)}async function H(w,ie){if(!ie.hasProvider(Y.URI.from({scheme:w.scheme})))return new Promise(se=>{const oe=ie.onDidChangeFileSystemProviderRegistrations(ce=>{ce.scheme===w.scheme&&ce.added&&(oe.dispose(),se())})})}class te{static{this.KB=1024}static{this.MB=te.KB*te.KB}static{this.GB=te.MB*te.KB}static{this.TB=te.GB*te.KB}static formatSize(ie){return(0,S.isNumber)(ie)||(ie=0),ie<te.KB?(0,U.localize)(1866,null,ie.toFixed(0)):ie<te.MB?(0,U.localize)(1867,null,(ie/te.KB).toFixed(2)):ie<te.GB?(0,U.localize)(1868,null,(ie/te.MB).toFixed(2)):ie<te.TB?(0,U.localize)(1869,null,(ie/te.GB).toFixed(2)):(0,U.localize)(1870,null,(ie/te.TB).toFixed(2))}}e.ByteSize=te;function ue(w){const ie=typeof w=="string"||w?.scheme===B.Schemas.vscodeRemote;return typeof w!="string"&&w?.scheme===B.Schemas.file?1024*te.MB:ie?10*te.MB:R.isWeb?50*te.MB:1024*te.MB}}),define(pe[49],be([0,1,42,11,3,2,6,29]),function(re,e,c,t,I,S,Y,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractUniversalWatcherClient=e.AbstractNonRecursiveWatcherClient=e.AbstractWatcherClient=void 0,e.isWatchRequestWithCorrelation=O,e.isRecursiveWatchRequest=R,e.reviveFileChanges=C,e.coalesceEvents=u,e.normalizeWatcherPattern=r,e.parseWatcherPatterns=a,e.isFiltered=L,e.requestFilterToString=b;function O(k){return typeof k.correlationId=="number"}function R(k){return k.recursive===!0}class B extends t.Disposable{static{this.MAX_RESTARTS=5}constructor(D,n,i,s){super(),this.onFileChanges=D,this.onLogMessage=n,this.verboseLogging=i,this.options=s,this.watcherDisposables=this._register(new t.MutableDisposable),this.requests=void 0,this.restartCounter=0}init(){const D=new t.DisposableStore;this.watcherDisposables.value=D,this.watcher=this.createWatcher(D),this.watcher.setVerboseLogging(this.verboseLogging),D.add(this.watcher.onDidChangeFile(n=>this.onFileChanges(n))),D.add(this.watcher.onDidLogMessage(n=>this.onLogMessage(n))),D.add(this.watcher.onDidError(n=>this.onError(n.error,n.request)))}onError(D,n){this.canRestart(D,n)?this.restartCounter<B.MAX_RESTARTS&&this.requests?(this.error(`restarting watcher after unexpected error: ${D}`),this.restart(this.requests)):this.error(`gave up attempting to restart watcher after unexpected error: ${D}`):this.error(D)}canRestart(D,n){return!(!this.options.restartOnError||n||D.indexOf("No space left on device")!==-1||D.indexOf("EMFILE")!==-1)}restart(D){this.restartCounter++,this.init(),this.watch(D)}async watch(D){this.requests=D,await this.watcher?.watch(D)}async setVerboseLogging(D){this.verboseLogging=D,await this.watcher?.setVerboseLogging(D)}error(D){this.onLogMessage({type:"error",message:`[File Watcher (${this.options.type})] ${D}`})}trace(D){this.onLogMessage({type:"trace",message:`[File Watcher (${this.options.type})] ${D}`})}dispose(){return this.watcher=void 0,super.dispose()}}e.AbstractWatcherClient=B;class M extends B{constructor(D,n,i){super(D,n,i,{type:"node.js",restartOnError:!1})}}e.AbstractNonRecursiveWatcherClient=M;class T extends B{constructor(D,n,i){super(D,n,i,{type:"universal",restartOnError:!0})}}e.AbstractUniversalWatcherClient=T;function C(k){return k.map(D=>({type:D.type,resource:Y.URI.revive(D.resource),cId:D.cId}))}function u(k){const D=new _;for(const n of k)D.processEvent(n);return D.coalesce()}function r(k,D){return typeof D=="string"&&!D.startsWith(c.GLOBSTAR)&&!(0,I.isAbsolute)(D)?{base:k,pattern:D}:D}function a(k,D){const n=[];for(const i of D)n.push((0,c.parse)(r(k,i)));return n}class _{constructor(){this.coalesced=new Set,this.mapPathToChange=new Map}toKey(D){return S.isLinux?D.resource.fsPath:D.resource.fsPath.toLowerCase()}processEvent(D){const n=this.mapPathToChange.get(this.toKey(D));let i=!1;if(n){const s=n.type,g=D.type;n.resource.fsPath!==D.resource.fsPath&&(D.type===U.FileChangeType.DELETED||D.type===U.FileChangeType.ADDED)?i=!0:s===U.FileChangeType.ADDED&&g===U.FileChangeType.DELETED?(this.mapPathToChange.delete(this.toKey(D)),this.coalesced.delete(n)):s===U.FileChangeType.DELETED&&g===U.FileChangeType.ADDED?n.type=U.FileChangeType.UPDATED:s===U.FileChangeType.ADDED&&g===U.FileChangeType.UPDATED||(n.type=g)}else i=!0;i&&(this.coalesced.add(D),this.mapPathToChange.set(this.toKey(D),D))}coalesce(){const D=[],n=[];return Array.from(this.coalesced).filter(i=>i.type!==U.FileChangeType.DELETED?(D.push(i),!1):!0).sort((i,s)=>i.resource.fsPath.length-s.resource.fsPath.length).filter(i=>n.some(s=>(0,U.isParent)(i.resource.fsPath,s,!S.isLinux))?!1:(n.push(i.resource.fsPath),!0)).concat(D)}}function L(k,D){if(typeof D=="number")switch(k.type){case U.FileChangeType.ADDED:return(D&U.FileChangeFilter.ADDED)===0;case U.FileChangeType.DELETED:return(D&U.FileChangeFilter.DELETED)===0;case U.FileChangeType.UPDATED:return(D&U.FileChangeFilter.UPDATED)===0}return!1}function b(k){if(typeof k=="number"){const D=[];return k&U.FileChangeFilter.ADDED&&D.push("Added"),k&U.FileChangeFilter.DELETED&&D.push("Deleted"),k&U.FileChangeFilter.UPDATED&&D.push("Updated"),D.length===0?"<all>":`[${D.join(", ")}]`}return"<none>"}}),define(pe[50],be([0,1,9,8,12,5,11,24,3,2,20,6,43,21,29,49]),function(re,e,c,t,I,S,Y,U,O,R,B,M,T,C,u,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSFileWatcherLibrary=void 0,e.watchFileContents=_;class a extends Y.Disposable{static{this.FILE_DELETE_HANDLER_DELAY=100}static{this.FILE_CHANGES_HANDLER_DELAY=75}get isReusingRecursiveWatcher(){return this._isReusingRecursiveWatcher}get failed(){return this.didFail}constructor(b,k,D,n,i,s){super(),this.request=b,this.recursiveWatcher=k,this.onDidFilesChange=D,this.onDidWatchFail=n,this.onLogMessage=i,this.verboseLogging=s,this.throttledFileChangesEmitter=this._register(new t.ThrottledWorker({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},g=>this.onDidFilesChange(g))),this.fileChangesAggregator=this._register(new t.RunOnceWorker(g=>this.handleFileChanges(g),a.FILE_CHANGES_HANDLER_DELAY)),this.excludes=(0,r.parseWatcherPatterns)(this.request.path,this.request.excludes),this.includes=this.request.includes?(0,r.parseWatcherPatterns)(this.request.path,this.request.includes):void 0,this.filter=(0,r.isWatchRequestWithCorrelation)(this.request)?this.request.filter:void 0,this.cts=new I.CancellationTokenSource,this.ready=this.watch(),this._isReusingRecursiveWatcher=!1,this.didFail=!1}async watch(){try{const b=await this.normalizePath(this.request);if(this.cts.token.isCancellationRequested)return;const k=await c.promises.stat(b);if(this.cts.token.isCancellationRequested)return;this._register(await this.doWatch(b,k.isDirectory()))}catch(b){b.code!=="ENOENT"?this.error(b):this.trace(`ignoring a path for watching who's stat info failed to resolve: ${this.request.path} (error: ${b})`),this.notifyWatchFailed()}}notifyWatchFailed(){this.didFail=!0,this.onDidWatchFail?.()}async normalizePath(b){let k=b.path;try{k=await C.Promises.realpath(b.path),b.path===k&&(k=await(0,T.realcase)(b.path,this.cts.token)??b.path),b.path!==k&&this.trace(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${b.path}, real: ${k})`)}catch{}return k}async doWatch(b,k){const D=new Y.DisposableStore;return this.doWatchWithExistingWatcher(b,k,D)?(this.trace(`reusing an existing recursive watcher for ${this.request.path}`),this._isReusingRecursiveWatcher=!0):(this._isReusingRecursiveWatcher=!1,await this.doWatchWithNodeJS(b,k,D)),D}doWatchWithExistingWatcher(b,k,D){if(k)return!1;const n=M.URI.file(this.request.path),i=this.recursiveWatcher?.subscribe(this.request.path,async(s,g)=>{if(!D.isDisposed)if(s){const N=await this.doWatch(b,k);D.isDisposed?N.dispose():D.add(N)}else g&&(typeof g.cId=="number"||typeof this.request.correlationId=="number")&&this.onFileChange({resource:n,type:g.type,cId:this.request.correlationId},!0)});return i?(D.add(i),!0):!1}async doWatchWithNodeJS(b,k,D){if(R.isMacintosh&&(0,S.isEqualOrParent)(b,"/Volumes/",!0)){this.error(`Refusing to watch ${b} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`);return}const n=new I.CancellationTokenSource(this.cts.token);D.add((0,Y.toDisposable)(()=>n.dispose(!0)));const i=new Y.DisposableStore;D.add(i);try{const s=M.URI.file(this.request.path),g=(0,O.basename)(b),N=(0,c.watch)(b);i.add((0,Y.toDisposable)(()=>{N.removeAllListeners(),N.close()})),this.trace(`Started watching: '${b}'`);const h=new Set;if(k)try{for(const l of await C.Promises.readdir(b))h.add(l)}catch(l){this.error(l)}if(n.token.isCancellationRequested)return;const m=new Map;i.add((0,Y.toDisposable)(()=>{for(const[,l]of m)l.dispose();m.clear()})),N.on("error",(l,f)=>{n.token.isCancellationRequested||(this.error(`Failed to watch ${b} for changes using fs.watch() (${l}, ${f})`),this.notifyWatchFailed())}),N.on("change",(l,f)=>{if(n.token.isCancellationRequested)return;this.verboseLogging&&this.traceWithCorrelation(`[raw] ["${l}"] ${f}`);let y="";if(f&&(y=f.toString(),R.isMacintosh&&(y=(0,U.normalizeNFC)(y))),!(!y||l!=="change"&&l!=="rename"))if(k)if(l==="rename"){m.get(y)?.dispose();const A=setTimeout(async()=>{if(m.delete(y),y===g&&!await C.Promises.exists(b)){this.onWatchedPathDeleted(s);return}if(n.token.isCancellationRequested)return;const p=await this.existsChildStrictCase((0,O.join)(b,y));if(n.token.isCancellationRequested)return;let j;p?h.has(y)?j=u.FileChangeType.UPDATED:(j=u.FileChangeType.ADDED,h.add(y)):(h.delete(y),j=u.FileChangeType.DELETED),this.onFileChange({resource:(0,B.joinPath)(s,y),type:j,cId:this.request.correlationId})},a.FILE_DELETE_HANDLER_DELAY);m.set(y,(0,Y.toDisposable)(()=>clearTimeout(A)))}else{let A;h.has(y)?A=u.FileChangeType.UPDATED:(A=u.FileChangeType.ADDED,h.add(y)),this.onFileChange({resource:(0,B.joinPath)(s,y),type:A,cId:this.request.correlationId})}else if(l==="rename"||y!==g){const A=setTimeout(async()=>{const p=await C.Promises.exists(b);n.token.isCancellationRequested||(p?(this.onFileChange({resource:s,type:u.FileChangeType.UPDATED,cId:this.request.correlationId},!0),i.add(await this.doWatch(b,!1))):this.onWatchedPathDeleted(s))},a.FILE_DELETE_HANDLER_DELAY);i.clear(),i.add((0,Y.toDisposable)(()=>clearTimeout(A)))}else this.onFileChange({resource:s,type:u.FileChangeType.UPDATED,cId:this.request.correlationId},!0)})}catch(s){n.token.isCancellationRequested||this.error(`Failed to watch ${b} for changes using fs.watch() (${s.toString()})`),this.notifyWatchFailed()}}onWatchedPathDeleted(b){this.warn("Watcher shutdown because watched path got deleted"),this.onFileChange({resource:b,type:u.FileChangeType.DELETED,cId:this.request.correlationId},!0),this.fileChangesAggregator.flush(),this.notifyWatchFailed()}onFileChange(b,k=!1){this.cts.token.isCancellationRequested||(this.verboseLogging&&this.traceWithCorrelation(`${b.type===u.FileChangeType.ADDED?"[ADDED]":b.type===u.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${b.resource.fsPath}`),!k&&this.excludes.some(D=>D(b.resource.fsPath))?this.verboseLogging&&this.traceWithCorrelation(` >> ignored (excluded) ${b.resource.fsPath}`):!k&&this.includes&&this.includes.length>0&&!this.includes.some(D=>D(b.resource.fsPath))?this.verboseLogging&&this.traceWithCorrelation(` >> ignored (not included) ${b.resource.fsPath}`):this.fileChangesAggregator.work(b))}handleFileChanges(b){const k=(0,r.coalesceEvents)(b),D=[];for(const i of k){if((0,r.isFiltered)(i,this.filter)){this.verboseLogging&&this.traceWithCorrelation(` >> ignored (filtered) ${i.resource.fsPath}`);continue}D.push(i)}if(D.length===0)return;if(this.verboseLogging)for(const i of D)this.traceWithCorrelation(` >> normalized ${i.type===u.FileChangeType.ADDED?"[ADDED]":i.type===u.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${i.resource.fsPath}`);this.throttledFileChangesEmitter.work(D)?this.throttledFileChangesEmitter.pending>0&&this.trace(`started throttling events due to large amount of file change events at once (pending: ${this.throttledFileChangesEmitter.pending}, most recent change: ${D[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.warn(`started ignoring events due to too many file change events at once (incoming: ${D.length}, most recent change: ${D[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}async existsChildStrictCase(b){if(R.isLinux)return C.Promises.exists(b);try{const k=(0,O.basename)(b);return(await C.Promises.readdir((0,O.dirname)(b))).some(n=>n===k)}catch(k){return this.trace(k),!1}}setVerboseLogging(b){this.verboseLogging=b}error(b){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"error",message:`[File Watcher (node.js)] ${b}`})}warn(b){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"warn",message:`[File Watcher (node.js)] ${b}`})}trace(b){!this.cts.token.isCancellationRequested&&this.verboseLogging&&this.onLogMessage?.({type:"trace",message:`[File Watcher (node.js)] ${b}`})}traceWithCorrelation(b){!this.cts.token.isCancellationRequested&&this.verboseLogging&&this.trace(`${b}${typeof this.request.correlationId=="number"?` <${this.request.correlationId}> `:""}`)}dispose(){this.cts.dispose(!0),super.dispose()}}e.NodeJSFileWatcherLibrary=a;async function _(L,b,k,D,n=512){const i=await C.Promises.open(L,"r"),s=Buffer.allocUnsafe(n),g=new I.CancellationTokenSource(D);let N,h=!1;const m={path:L,excludes:[],recursive:!1},l=new a(m,void 0,f=>{(async()=>{for(const{type:y}of f)if(y===u.FileChangeType.UPDATED){if(h)return;h=!0;try{for(;!g.token.isCancellationRequested;){const{bytesRead:A}=await C.Promises.read(i,s,0,n,null);if(!A||g.token.isCancellationRequested)break;b(s.slice(0,A))}}catch(A){N=new Error(A),g.dispose(!0)}finally{h=!1}}})()});return await l.ready,k(),new Promise((f,y)=>{g.token.onCancellationRequested(async()=>{l.dispose();try{await C.Promises.close(i)}catch(A){N=new Error(A)}N?y(N):f()})})}}),define(pe[51],be([0,1,18]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let t;const I=globalThis.vscode;if(typeof I<"u"&&typeof I.context<"u"){const S=I.context.configuration();if(S)t=S.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){t=globalThis._VSCODE_PRODUCT_JSON;const{serviceUrl:S,searchUrl:Y,itemUrl:U,controlUrl:O}=t.extensionsGallery||{};Object.assign(t,{extensionsGallery:{serviceUrl:c.env.VSCODE_GALLERY_SERVICE_URL||S,searchUrl:c.env.VSCODE_GALLERY_SEARCH_URL||Y,itemUrl:c.env.VSCODE_GALLERY_ITEM_URL||U,controlUrl:c.env.VSCODE_GALLERY_CONTROL_URL||O}});try{const R=(...M)=>M.reduce((T,C)=>(Object.keys(C).forEach(u=>{Array.isArray(T[u])&&Array.isArray(C[u])?T[u]=C[u]:typeof T[u]=="object"&&typeof C[u]=="object"?T[u]=R(T[u],C[u]):T[u]=C[u]}),T),{}),B=globalThis._VSCODE_USER_PRODUCT_JSON||{};t=R(t,B)}catch{}if(c.env.VSCODE_DEV&&Object.assign(t,{nameShort:`${t.nameShort} Dev`,nameLong:`${t.nameLong} Dev`,dataFolderName:`${t.dataFolderName}-dev`,serverDataFolderName:t.serverDataFolderName?`${t.serverDataFolderName}-dev`:void 0}),!t.version){const R=globalThis._VSCODE_PACKAGE_JSON;Object.assign(t,{version:R.version,release:R.release})}}else t={},Object.keys(t).length===0&&Object.assign(t,{version:"1.91.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=t}),define(pe[52],be([0,1,3,28]),function(re,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Utils=e.IV8InspectProfilingService=void 0,e.IV8InspectProfilingService=(0,t.createDecorator)("IV8InspectProfilingService");var I;(function(S){function Y(O){return!!(O.samples&&O.timeDeltas)}S.isValidProfile=Y;function U(O,R="noAbsolutePaths"){for(const B of O.nodes)B.callFrame&&B.callFrame.url&&((0,c.isAbsolute)(B.callFrame.url)||/^\w[\w\d+.-]*:\/\/\/?/.test(B.callFrame.url))&&(B.callFrame.url=(0,c.join)(R,(0,c.basename)(B.callFrame.url)));return O}S.rewriteAbsolutePaths=U})(I||(e.Utils=I={}))});var Ge=this&&this.__importDefault||function(re){return re&&re.__esModule?re:{default:re}};define(pe[57],be([0,1,45,9,22,17,3,2,35,21,41,50,27,46,47,48,51,12,5,52,19,18,58,6,8]),function(re,e,c,t,I,S,Y,U,O,R,B,M,T,C,u,r,a,_,L,b,k,D,n,i,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=N,a=Ge(a);function g(l){return!!l["install-source"]||!!l["list-extensions"]||!!l["install-extension"]||!!l["uninstall-extension"]||!!l["update-extensions"]||!!l["locate-extension"]||!!l.telemetry}async function N(l){let f;try{f=(0,C.parseCLIProcessArgv)(l)}catch(y){console.error(y.message);return}for(const y of T.NATIVE_CLI_COMMANDS)if(f[y]){if(!a.default.tunnelApplicationName){console.error(`'${y}' command not supported in ${a.default.applicationName}`);return}const A={...process.env};delete A.ELECTRON_RUN_AS_NODE;const p=l.slice(l.indexOf(y)+1);return new Promise((j,x)=>{let J;const G=["ignore","pipe","pipe"];if(process.env.VSCODE_DEV)J=(0,c.spawn)("cargo",["run","--",y,...p],{cwd:(0,Y.join)(h(),"cli"),stdio:G,env:A});else{const le=process.platform==="darwin"?(0,Y.join)((0,Y.dirname)((0,Y.dirname)(process.execPath)),"Resources","app"):(0,Y.dirname)(process.execPath),W=(0,Y.join)(le,"bin",`${a.default.tunnelApplicationName}${U.isWindows?".exe":""}`);J=(0,c.spawn)(W,[y,...p],{cwd:(0,D.cwd)(),stdio:G,env:A})}J.stdout.pipe(process.stdout),J.stderr.pipe(process.stderr),J.on("exit",j),J.on("error",x)})}if(f.help){const y=`${a.default.applicationName}${U.isWindows?".exe":""}`;console.log((0,T.buildHelpMessage)(a.default.nameLong,y,a.default.version,T.OPTIONS))}else if(f.version)console.log((0,T.buildVersionMessage)(a.default.version,a.default.commit));else if(f["locate-shell-integration-path"]){let y;switch(f["locate-shell-integration-path"]){case"bash":y="shellIntegration-bash.sh";break;case"pwsh":y="shellIntegration.ps1";break;case"zsh":y="shellIntegration-rc.zsh";break;case"fish":y="fish_xdg_data/fish/vendor_conf.d/shellIntegration.fish";break;default:throw new Error("Error using --locate-shell-integration-path: Invalid shell type")}console.log((0,Y.join)(h(),"out","vs","workbench","contrib","terminal","browser","media",y))}else if(g(f)){await(await new Promise((A,p)=>{re([["vs","code","node","cliProcessMain"].join("/")],A,p)}).then(Pe)).main(f);return}else if(f["file-write"]){const y=f._[0],A=f._[1];if(U.isWindows)for(const p of[y,A])(0,L.isUNC)(p)&&(0,n.addUNCHostToAllowlist)(i.URI.file(p).authority);if(!y||!A||y===A||!(0,Y.isAbsolute)(y)||!(0,Y.isAbsolute)(A)||!(0,t.existsSync)(y)||!(0,t.statSync)(y).isFile()||!(0,t.existsSync)(A)||!(0,t.statSync)(A).isFile())throw new Error("Using --file-write with invalid arguments.");try{let p=0,j=!1;f["file-chmod"]&&(p=(0,t.statSync)(A).mode,p&128||((0,t.chmodSync)(A,p|128),j=!0));const x=(0,t.readFileSync)(y);U.isWindows?((0,t.truncateSync)(A,0),(0,R.writeFileSync)(A,x,{flag:"r+"})):(0,R.writeFileSync)(A,x),j&&(0,t.chmodSync)(A,p)}catch(p){throw p.message=`Error using --file-write: ${p.message}`,p}}else{const y={...process.env,ELECTRON_NO_ATTACH_CONSOLE:"1"};delete y.ELECTRON_RUN_AS_NODE;const A=[];f.verbose&&(y.ELECTRON_ENABLE_LOGGING="1"),(f.verbose||f.status)&&A.push(async W=>{W.stdout?.on("data",K=>console.log(K.toString("utf8").trim())),W.stderr?.on("data",K=>console.log(K.toString("utf8").trim())),await S.Event.toPromise(S.Event.fromNodeEventEmitter(W,"exit"))});const p=f._.some(W=>W==="-");p&&(f._=f._.filter(W=>W!=="-"),l=l.filter(W=>W!=="-"));let j;if((0,u.hasStdinWithoutTty)())if(p){j=(0,u.getStdinFilePath)();try{const W=new s.DeferredPromise;await(0,u.readFromStdin)(j,!!f.verbose,()=>W.complete()),f.wait||A.push(()=>W.p),(0,C.addArg)(l,j),(0,C.addArg)(l,"--skip-add-to-recently-opened"),console.log(`Reading from stdin via: ${j}`)}catch(W){console.log(`Failed to create file to read via stdin: ${W.toString()}`),j=void 0}}else A.push(W=>(0,u.stdinDataListener)(1e3).then(K=>{K&&(U.isWindows?console.log(`Run with '${a.default.applicationName} -' to read output from another program (e.g. 'echo Hello World | ${a.default.applicationName} -').`):console.log(`Run with '${a.default.applicationName} -' to read from stdin (e.g. 'ps aux | grep code | ${a.default.applicationName} -').`))}));const x=U.isMacintosh&&(0,I.release)()>"20.0.0";let J;if(f.wait&&(J=(0,r.createWaitMarkerFileSync)(f.verbose),J&&(0,C.addArg)(l,"--waitMarkerFilePath",J),A.push(async W=>{let K;x?K=new Promise(Z=>{W.on("exit",(ee,q)=>{(ee!==0||q)&&Z()})}):K=S.Event.toPromise(S.Event.fromNodeEventEmitter(W,"exit"));try{await Promise.race([(0,R.whenDeleted)(J),S.Event.toPromise(S.Event.fromNodeEventEmitter(W,"error")),K])}finally{j&&(0,t.unlinkSync)(j)}})),f["prof-startup"]){const W="127.0.0.1",K=await(0,B.findFreePort)((0,O.randomPort)(),10,3e3),Z=await(0,B.findFreePort)(K+1,10,3e3),ee=await(0,B.findFreePort)(Z+1,10,3e3);if(K*Z*ee===0)throw new Error("Failed to find free ports for profiler. Make sure to shutdown all instances of the editor first.");const q=(0,L.randomPath)((0,I.homedir)(),"prof");(0,C.addArg)(l,`--inspect-brk=${W}:${K}`),(0,C.addArg)(l,`--remote-debugging-port=${W}:${Z}`),(0,C.addArg)(l,`--inspect-brk-extensions=${W}:${ee}`),(0,C.addArg)(l,"--prof-startup-prefix",q),(0,C.addArg)(l,"--no-cached-data"),(0,R.writeFileSync)(q,l.slice(-6).join("|")),A.push(async z=>{class H{static async start(ue,w,ie){const se=await new Promise((ce,fe)=>{re(["v8-inspect-profiler"],ce,fe)}).then(Pe);let oe;try{oe=await se.startProfiling({...ie,host:W})}catch{console.error(`FAILED to start profiling for '${ue}' on port '${ie.port}'`)}return{async stop(){if(!oe)return;let ce="";const fe=await oe.stop();process.env.VSCODE_DEV||(fe.profile=b.Utils.rewriteAbsolutePaths(fe.profile,"piiRemoved"),ce=".txt"),(0,R.writeFileSync)(`${w}.${ue}.cpuprofile${ce}`,JSON.stringify(fe.profile,void 0,4))}}}}try{const te=H.start("main",q,{port:K}),ue=H.start("extHost",q,{port:ee,tries:300}),w=H.start("renderer",q,{port:Z,tries:200,target:function(ce){return ce.filter(fe=>fe.webSocketDebuggerUrl?fe.type==="page"?fe.url.indexOf("workbench/workbench.html")>0||fe.url.indexOf("workbench/workbench-dev.html")>0||fe.url.indexOf("workbench/workbench.esm.html")>0||fe.url.indexOf("workbench/workbench-dev.esm.html")>0:!0:!1)[0]}}),ie=await te,se=await ue,oe=await w;await(0,R.whenDeleted)(q),await ie.stop(),await oe.stop(),await se.stop(),(0,R.writeFileSync)(q,"")}catch{console.error("Failed to profile startup. Make sure to quit Code first.")}})}const G={detached:!0,env:y};f.verbose||(G.stdio="ignore");let le;if(!x)!f.verbose&&f.status&&(G.stdio=["ignore","pipe","ignore"]),le=(0,c.spawn)(process.execPath,l.slice(2),G);else{const W=["-n","-g"];if(W.push("-a",process.execPath),f.verbose||f.status){W.push("--wait-apps");for(const K of f.verbose?["stdout","stderr"]:["stdout"]){const Z=(0,L.randomPath)((0,I.tmpdir)(),`code-${K}`);(0,R.writeFileSync)(Z,""),W.push(`--${K}`,Z),A.push(async ee=>{try{const q=K==="stdout"?process.stdout:process.stderr,z=new _.CancellationTokenSource;ee.on("close",()=>{setTimeout(()=>z.dispose(!0),200)}),await(0,M.watchFileContents)(Z,H=>q.write(H),()=>{},z.token)}finally{(0,t.unlinkSync)(Z)}})}}for(const K in y)K!=="_"&&(W.push("--env"),W.push(`${K}=${y[K]}`));if(W.push("--args",...l.slice(2)),y.VSCODE_DEV){const K=".",Z=W.indexOf(K);Z!==-1&&(W[Z]=(0,Y.resolve)(K))}le=(0,c.spawn)("open",W,{...G,env:{}})}return Promise.all(A.map(W=>W(le)))}}function h(){return(0,Y.dirname)(k.FileAccess.asFileUri("").fsPath)}function m(l){setTimeout(()=>process.exit(l),0)}N(process.argv).then(()=>m(0)).then(null,l=>{console.error(l.message||l.stack||l),m(1)})})}).call(this);

//# sourceMappingURL=https://main.vscode-cdn.net/sourcemaps/532bdf24071d0a26ceea0844dcdf5ee8cfabd562/core/vs/code/node/cli.js.map
