/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ce=["require","exports","vs/base/common/lifecycle","vs/base/common/types","vs/nls","vs/base/common/event","vs/platform/log/common/log","vs/base/common/errors","vs/base/common/async","vs/platform/files/common/files","vs/platform/instantiation/common/instantiation","vs/base/common/platform","vs/base/common/uri","vs/base/common/buffer","vs/base/common/network","vs/base/common/path","vs/base/common/resources","vs/platform/environment/common/environment","vs/platform/telemetry/common/telemetry","vs/base/common/arrays","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/cancellation","vs/platform/extensions/common/extensions","vs/platform/uriIdentity/common/uriIdentity","vs/platform/userDataProfile/common/userDataProfile","vs/base/common/map","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/objects","vs/base/common/uuid","vs/base/node/pfs","vs/platform/configuration/common/configuration","vs/base/common/strings","fs","vs/platform/product/common/productService","vs/base/common/json","os","vs/base/common/process","vs/platform/registry/common/platform","vs/base/common/errorMessage","vs/platform/policy/common/policy","vs/platform/configuration/common/configurationRegistry","vs/platform/telemetry/common/telemetryUtils","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/base/common/hash","vs/platform/extensions/common/extensionValidator","vs/base/common/semver/semver","vs/platform/request/common/request","vs/base/common/stream","vs/base/common/marshalling","vs/base/common/ternarySearchTree","vs/base/node/zip","vs/platform/instantiation/common/descriptors","vs/platform/files/common/watcher","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/common/extensionsScannerService","vs/base/common/decorators","vs/base/common/severity","vs/base/common/processes","vs/amdX","vs/base/node/processes","vs/base/parts/ipc/common/ipc","child_process","vs/platform/download/common/download","vs/platform/files/common/io","vs/base/common/extpath","vs/platform/instantiation/common/serviceCollection","vs/base/common/iterator","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/remoteHosts","vs/platform/languagePacks/common/languagePacks","vs/platform/state/node/stateService","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/storage/common/storage","vs/base/common/amd","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/jsonSchema","vs/base/common/numbers","vs/base/common/skipList","vs/base/node/macAddress","vs/base/parts/request/common/request","vs/base/common/date","vs/base/common/jsonErrorMessages","vs/base/common/console","vs/base/node/id","vs/base/node/powershell","vs/base/node/shell","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/platform/contextkey/common/scanner","vs/base/common/charCode","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensions/common/extensionsApiProposals","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/contextkey/common/contextkey","vs/platform/files/node/watcher/baseWatcher","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/log/node/loggerService","vs/platform/policy/common/filePolicyService","vs/platform/policy/node/nativePolicyService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/download/common/downloadService","vs/platform/request/node/proxy","url","vs/platform/shell/node/shellEnv","vs/platform/state/node/state","vs/platform/extensionManagement/common/extensionManagementCLI","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/languagePacks/node/languagePacks","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/common/telemetryService","vs/platform/product/common/product","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/telemetry","vs/platform/telemetry/node/telemetryUtils","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userData/common/fileUserDataProvider","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/externalServices/common/serviceMachineId","vs/platform/externalServices/common/marketplace","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/userDataProfile/node/userDataProfile","vs/platform/request/node/requestService","vs/base/common/lazy","vs/base/common/marshallingIds","path","vs/base/common/glob","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/base/common/linkedList","vs/platform/environment/node/argvHelper","crypto","https","vs/base/common/stopwatch","zlib","vs/code/node/cliProcessMain","vs/base/node/unc"],de=function(J){for(var e=[],b=0,C=J.length;b<C;b++)e[b]=ce[J[b]];return e};define(ce[75],de([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoaderStats=e.LoaderEventType=e.canASAR=e.isESM=void 0,e.isESM=!1,e.canASAR=!0;var b;(function(S){S[S.LoaderAvailable=1]="LoaderAvailable",S[S.BeginLoadingScript=10]="BeginLoadingScript",S[S.EndLoadingScriptOK=11]="EndLoadingScriptOK",S[S.EndLoadingScriptError=12]="EndLoadingScriptError",S[S.BeginInvokeFactory=21]="BeginInvokeFactory",S[S.EndInvokeFactory=22]="EndInvokeFactory",S[S.NodeBeginEvaluatingScript=31]="NodeBeginEvaluatingScript",S[S.NodeEndEvaluatingScript=32]="NodeEndEvaluatingScript",S[S.NodeBeginNativeRequire=33]="NodeBeginNativeRequire",S[S.NodeEndNativeRequire=34]="NodeEndNativeRequire",S[S.CachedDataFound=60]="CachedDataFound",S[S.CachedDataMissed=61]="CachedDataMissed",S[S.CachedDataRejected=62]="CachedDataRejected",S[S.CachedDataCreated=63]="CachedDataCreated"})(b||(e.LoaderEventType=b={}));class C{static get(){const R=new Map,k=new Map,D=new Map,p=new Map;function u(v,I){v.has(I.detail)||v.set(I.detail,-I.timestamp)}function f(v,I){const w=v.get(I.detail);w&&(w>=0||v.set(I.detail,w+I.timestamp))}let h=[];typeof J=="function"&&typeof J.getStats=="function"&&(h=J.getStats().slice(0).sort((v,I)=>v.timestamp-I.timestamp));for(const v of h)switch(v.type){case b.BeginLoadingScript:u(R,v);break;case b.EndLoadingScriptOK:case b.EndLoadingScriptError:f(R,v);break;case b.BeginInvokeFactory:u(k,v);break;case b.EndInvokeFactory:f(k,v);break;case b.NodeBeginNativeRequire:u(D,v);break;case b.NodeEndNativeRequire:f(D,v);break;case b.NodeBeginEvaluatingScript:u(p,v);break;case b.NodeEndEvaluatingScript:f(p,v);break}let m=0;D.forEach(v=>m+=v);function a(v){const I=[];return v.forEach((w,y)=>I.push([y,w])),I}return{amdLoad:a(R),amdInvoke:a(k),nodeRequire:a(D),nodeEval:a(p),nodeRequireTotal:m}}static toMarkdownTable(R,k){let D="";const p=[];return R.forEach((u,f)=>{p[f]=u.length}),k.forEach(u=>{u.forEach((f,h)=>{typeof f>"u"&&(f=u[h]="-");const m=f.toString().length;p[h]=Math.max(m,p[h])})}),R.forEach((u,f)=>{D+=`| ${u+" ".repeat(p[f]-u.toString().length)} `}),D+=`|
`,R.forEach((u,f)=>{D+=`| ${"-".repeat(p[f])} `}),D+=`|
`,k.forEach(u=>{u.forEach((f,h)=>{typeof f<"u"&&(D+=`| ${f+" ".repeat(p[h]-f.toString().length)} `)}),D+=`|
`}),D}}e.LoaderStats=C}),define(ce[55],de([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.memoize=C,e.debounce=S,e.throttle=R;function b(k){return(D,p,u)=>{let f=null,h=null;if(typeof u.value=="function"?(f="value",h=u.value):typeof u.get=="function"&&(f="get",h=u.get),!h)throw new Error("not supported");u[f]=k(h,p)}}function C(k,D,p){let u=null,f=null;if(typeof p.value=="function"?(u="value",f=p.value,f.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof p.get=="function"&&(u="get",f=p.get),!f)throw new Error("not supported");const h=`$memoize$${D}`;p[u]=function(...m){return this.hasOwnProperty(h)||Object.defineProperty(this,h,{configurable:!1,enumerable:!1,writable:!1,value:f.apply(this,m)}),this[h]}}function S(k,D,p){return b((u,f)=>{const h=`$debounce$${f}`,m=`$debounce$result$${f}`;return function(...a){this[m]||(this[m]=p?p():void 0),clearTimeout(this[h]),D&&(this[m]=D(this[m],...a),a=[this[m]]),this[h]=setTimeout(()=>{u.apply(this,a),this[m]=p?p():void 0},k)}})}function R(k,D,p){return b((u,f)=>{const h=`$throttle$timer$${f}`,m=`$throttle$result$${f}`,a=`$throttle$lastRun$${f}`,v=`$throttle$pending$${f}`;return function(...I){if(this[m]||(this[m]=p?p():void 0),(this[a]===null||this[a]===void 0)&&(this[a]=-Number.MAX_VALUE),D&&(this[m]=D(this[m],...I)),this[v])return;const w=this[a]+k;w<=Date.now()?(this[a]=Date.now(),u.apply(this,[this[m]]),this[m]=p?p():void 0):(this[v]=!0,this[h]=setTimeout(()=>{this[v]=!1,this[a]=Date.now(),u.apply(this,[this[m]]),this[m]=p?p():void 0},w-Date.now()))}})}}),define(ce[76],de([0,1,7]),function(J,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=C,e.assertNever=S,e.assert=R,e.softAssert=k,e.assertFn=D,e.checkAdjacentItems=p;function C(u,f){if(!u)throw new Error(f?`Assertion failed (${f})`:"Assertion Failed")}function S(u,f="Unreachable"){throw new Error(f)}function R(u,f="unexpected state"){if(!u)throw new b.BugIndicatingError(`Assertion Failed: ${f}`)}function k(u){u||(0,b.onUnexpectedError)(new b.BugIndicatingError("Soft Assertion Failed"))}function D(u){if(!u()){debugger;u(),(0,b.onUnexpectedError)(new b.BugIndicatingError("Assertion Failed"))}}function p(u,f){let h=0;for(;h<u.length-1;){const m=u[h],a=u[h+1];if(!f(m,a))return!1;h++}return!0}}),define(ce[34],de([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.createScanner=k,e.getLocation=h,e.parse=m,e.parseTree=a,e.findNodeAtLocation=v,e.getNodePath=I,e.getNodeValue=w,e.contains=y,e.findNodeAtOffset=d,e.visit=O,e.getNodeType=E;var b;(function(i){i[i.None=0]="None",i[i.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=2]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",i[i.InvalidUnicode=4]="InvalidUnicode",i[i.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",i[i.InvalidCharacter=6]="InvalidCharacter"})(b||(e.ScanError=b={}));var C;(function(i){i[i.OpenBraceToken=1]="OpenBraceToken",i[i.CloseBraceToken=2]="CloseBraceToken",i[i.OpenBracketToken=3]="OpenBracketToken",i[i.CloseBracketToken=4]="CloseBracketToken",i[i.CommaToken=5]="CommaToken",i[i.ColonToken=6]="ColonToken",i[i.NullKeyword=7]="NullKeyword",i[i.TrueKeyword=8]="TrueKeyword",i[i.FalseKeyword=9]="FalseKeyword",i[i.StringLiteral=10]="StringLiteral",i[i.NumericLiteral=11]="NumericLiteral",i[i.LineCommentTrivia=12]="LineCommentTrivia",i[i.BlockCommentTrivia=13]="BlockCommentTrivia",i[i.LineBreakTrivia=14]="LineBreakTrivia",i[i.Trivia=15]="Trivia",i[i.Unknown=16]="Unknown",i[i.EOF=17]="EOF"})(C||(e.SyntaxKind=C={}));var S;(function(i){i[i.InvalidSymbol=1]="InvalidSymbol",i[i.InvalidNumberFormat=2]="InvalidNumberFormat",i[i.PropertyNameExpected=3]="PropertyNameExpected",i[i.ValueExpected=4]="ValueExpected",i[i.ColonExpected=5]="ColonExpected",i[i.CommaExpected=6]="CommaExpected",i[i.CloseBraceExpected=7]="CloseBraceExpected",i[i.CloseBracketExpected=8]="CloseBracketExpected",i[i.EndOfFileExpected=9]="EndOfFileExpected",i[i.InvalidCommentToken=10]="InvalidCommentToken",i[i.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=12]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",i[i.InvalidUnicode=14]="InvalidUnicode",i[i.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",i[i.InvalidCharacter=16]="InvalidCharacter"})(S||(e.ParseErrorCode=S={}));var R;(function(i){i.DEFAULT={allowTrailingComma:!0}})(R||(e.ParseOptions=R={}));function k(i,l=!1){let r=0;const n=i.length;let t="",s=0,o=C.Unknown,c=b.None;function g(Q){let re=0,ae=0;for(;re<Q;){const ue=i.charCodeAt(r);if(ue>=f._0&&ue<=f._9)ae=ae*16+ue-f._0;else if(ue>=f.A&&ue<=f.F)ae=ae*16+ue-f.A+10;else if(ue>=f.a&&ue<=f.f)ae=ae*16+ue-f.a+10;else break;r++,re++}return re<Q&&(ae=-1),ae}function T(Q){r=Q,t="",s=0,o=C.Unknown,c=b.None}function N(){const Q=r;if(i.charCodeAt(r)===f._0)r++;else for(r++;r<i.length&&u(i.charCodeAt(r));)r++;if(r<i.length&&i.charCodeAt(r)===f.dot)if(r++,r<i.length&&u(i.charCodeAt(r)))for(r++;r<i.length&&u(i.charCodeAt(r));)r++;else return c=b.UnexpectedEndOfNumber,i.substring(Q,r);let re=r;if(r<i.length&&(i.charCodeAt(r)===f.E||i.charCodeAt(r)===f.e))if(r++,(r<i.length&&i.charCodeAt(r)===f.plus||i.charCodeAt(r)===f.minus)&&r++,r<i.length&&u(i.charCodeAt(r))){for(r++;r<i.length&&u(i.charCodeAt(r));)r++;re=r}else c=b.UnexpectedEndOfNumber;return i.substring(Q,re)}function A(){let Q="",re=r;for(;;){if(r>=n){Q+=i.substring(re,r),c=b.UnexpectedEndOfString;break}const ae=i.charCodeAt(r);if(ae===f.doubleQuote){Q+=i.substring(re,r),r++;break}if(ae===f.backslash){if(Q+=i.substring(re,r),r++,r>=n){c=b.UnexpectedEndOfString;break}switch(i.charCodeAt(r++)){case f.doubleQuote:Q+='"';break;case f.backslash:Q+="\\";break;case f.slash:Q+="/";break;case f.b:Q+="\b";break;case f.f:Q+="\f";break;case f.n:Q+=`
`;break;case f.r:Q+="\r";break;case f.t:Q+="	";break;case f.u:{const pe=g(4);pe>=0?Q+=String.fromCharCode(pe):c=b.InvalidUnicode;break}default:c=b.InvalidEscapeCharacter}re=r;continue}if(ae>=0&&ae<=31)if(p(ae)){Q+=i.substring(re,r),c=b.UnexpectedEndOfString;break}else c=b.InvalidCharacter;r++}return Q}function L(){if(t="",c=b.None,s=r,r>=n)return s=n,o=C.EOF;let Q=i.charCodeAt(r);if(D(Q)){do r++,t+=String.fromCharCode(Q),Q=i.charCodeAt(r);while(D(Q));return o=C.Trivia}if(p(Q))return r++,t+=String.fromCharCode(Q),Q===f.carriageReturn&&i.charCodeAt(r)===f.lineFeed&&(r++,t+=`
`),o=C.LineBreakTrivia;switch(Q){case f.openBrace:return r++,o=C.OpenBraceToken;case f.closeBrace:return r++,o=C.CloseBraceToken;case f.openBracket:return r++,o=C.OpenBracketToken;case f.closeBracket:return r++,o=C.CloseBracketToken;case f.colon:return r++,o=C.ColonToken;case f.comma:return r++,o=C.CommaToken;case f.doubleQuote:return r++,t=A(),o=C.StringLiteral;case f.slash:{const re=r-1;if(i.charCodeAt(r+1)===f.slash){for(r+=2;r<n&&!p(i.charCodeAt(r));)r++;return t=i.substring(re,r),o=C.LineCommentTrivia}if(i.charCodeAt(r+1)===f.asterisk){r+=2;const ae=n-1;let ue=!1;for(;r<ae;){if(i.charCodeAt(r)===f.asterisk&&i.charCodeAt(r+1)===f.slash){r+=2,ue=!0;break}r++}return ue||(r++,c=b.UnexpectedEndOfComment),t=i.substring(re,r),o=C.BlockCommentTrivia}return t+=String.fromCharCode(Q),r++,o=C.Unknown}case f.minus:if(t+=String.fromCharCode(Q),r++,r===n||!u(i.charCodeAt(r)))return o=C.Unknown;case f._0:case f._1:case f._2:case f._3:case f._4:case f._5:case f._6:case f._7:case f._8:case f._9:return t+=N(),o=C.NumericLiteral;default:for(;r<n&&M(Q);)r++,Q=i.charCodeAt(r);if(s!==r){switch(t=i.substring(s,r),t){case"true":return o=C.TrueKeyword;case"false":return o=C.FalseKeyword;case"null":return o=C.NullKeyword}return o=C.Unknown}return t+=String.fromCharCode(Q),r++,o=C.Unknown}}function M(Q){if(D(Q)||p(Q))return!1;switch(Q){case f.closeBrace:case f.closeBracket:case f.openBrace:case f.openBracket:case f.doubleQuote:case f.colon:case f.comma:case f.slash:return!1}return!0}function B(){let Q;do Q=L();while(Q>=C.LineCommentTrivia&&Q<=C.Trivia);return Q}return{setPosition:T,getPosition:()=>r,scan:l?B:L,getToken:()=>o,getTokenValue:()=>t,getTokenOffset:()=>s,getTokenLength:()=>r-s,getTokenError:()=>c}}function D(i){return i===f.space||i===f.tab||i===f.verticalTab||i===f.formFeed||i===f.nonBreakingSpace||i===f.ogham||i>=f.enQuad&&i<=f.zeroWidthSpace||i===f.narrowNoBreakSpace||i===f.mathematicalSpace||i===f.ideographicSpace||i===f.byteOrderMark}function p(i){return i===f.lineFeed||i===f.carriageReturn||i===f.lineSeparator||i===f.paragraphSeparator}function u(i){return i>=f._0&&i<=f._9}var f;(function(i){i[i.nullCharacter=0]="nullCharacter",i[i.maxAsciiCharacter=127]="maxAsciiCharacter",i[i.lineFeed=10]="lineFeed",i[i.carriageReturn=13]="carriageReturn",i[i.lineSeparator=8232]="lineSeparator",i[i.paragraphSeparator=8233]="paragraphSeparator",i[i.nextLine=133]="nextLine",i[i.space=32]="space",i[i.nonBreakingSpace=160]="nonBreakingSpace",i[i.enQuad=8192]="enQuad",i[i.emQuad=8193]="emQuad",i[i.enSpace=8194]="enSpace",i[i.emSpace=8195]="emSpace",i[i.threePerEmSpace=8196]="threePerEmSpace",i[i.fourPerEmSpace=8197]="fourPerEmSpace",i[i.sixPerEmSpace=8198]="sixPerEmSpace",i[i.figureSpace=8199]="figureSpace",i[i.punctuationSpace=8200]="punctuationSpace",i[i.thinSpace=8201]="thinSpace",i[i.hairSpace=8202]="hairSpace",i[i.zeroWidthSpace=8203]="zeroWidthSpace",i[i.narrowNoBreakSpace=8239]="narrowNoBreakSpace",i[i.ideographicSpace=12288]="ideographicSpace",i[i.mathematicalSpace=8287]="mathematicalSpace",i[i.ogham=5760]="ogham",i[i._=95]="_",i[i.$=36]="$",i[i._0=48]="_0",i[i._1=49]="_1",i[i._2=50]="_2",i[i._3=51]="_3",i[i._4=52]="_4",i[i._5=53]="_5",i[i._6=54]="_6",i[i._7=55]="_7",i[i._8=56]="_8",i[i._9=57]="_9",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.ampersand=38]="ampersand",i[i.asterisk=42]="asterisk",i[i.at=64]="at",i[i.backslash=92]="backslash",i[i.bar=124]="bar",i[i.caret=94]="caret",i[i.closeBrace=125]="closeBrace",i[i.closeBracket=93]="closeBracket",i[i.closeParen=41]="closeParen",i[i.colon=58]="colon",i[i.comma=44]="comma",i[i.dot=46]="dot",i[i.doubleQuote=34]="doubleQuote",i[i.equals=61]="equals",i[i.exclamation=33]="exclamation",i[i.greaterThan=62]="greaterThan",i[i.lessThan=60]="lessThan",i[i.minus=45]="minus",i[i.openBrace=123]="openBrace",i[i.openBracket=91]="openBracket",i[i.openParen=40]="openParen",i[i.percent=37]="percent",i[i.plus=43]="plus",i[i.question=63]="question",i[i.semicolon=59]="semicolon",i[i.singleQuote=39]="singleQuote",i[i.slash=47]="slash",i[i.tilde=126]="tilde",i[i.backspace=8]="backspace",i[i.formFeed=12]="formFeed",i[i.byteOrderMark=65279]="byteOrderMark",i[i.tab=9]="tab",i[i.verticalTab=11]="verticalTab"})(f||(f={}));function h(i,l){const r=[],n=new Object;let t;const s={value:{},offset:0,length:0,type:"object",parent:void 0};let o=!1;function c(g,T,N,A){s.value=g,s.offset=T,s.length=N,s.type=A,s.colonOffset=void 0,t=s}try{O(i,{onObjectBegin:(g,T)=>{if(l<=g)throw n;t=void 0,o=l>g,r.push("")},onObjectProperty:(g,T,N)=>{if(l<T||(c(g,T,N,"property"),r[r.length-1]=g,l<=T+N))throw n},onObjectEnd:(g,T)=>{if(l<=g)throw n;t=void 0,r.pop()},onArrayBegin:(g,T)=>{if(l<=g)throw n;t=void 0,r.push(0)},onArrayEnd:(g,T)=>{if(l<=g)throw n;t=void 0,r.pop()},onLiteralValue:(g,T,N)=>{if(l<T||(c(g,T,N,E(g)),l<=T+N))throw n},onSeparator:(g,T,N)=>{if(l<=T)throw n;if(g===":"&&t&&t.type==="property")t.colonOffset=T,o=!1,t=void 0;else if(g===","){const A=r[r.length-1];typeof A=="number"?r[r.length-1]=A+1:(o=!0,r[r.length-1]=""),t=void 0}}})}catch(g){if(g!==n)throw g}return{path:r,previousNode:t,isAtPropertyKey:o,matches:g=>{let T=0;for(let N=0;T<g.length&&N<r.length;N++)if(g[T]===r[N]||g[T]==="*")T++;else if(g[T]!=="**")return!1;return T===g.length}}}function m(i,l=[],r=R.DEFAULT){let n=null,t=[];const s=[];function o(g){Array.isArray(t)?t.push(g):n!==null&&(t[n]=g)}return O(i,{onObjectBegin:()=>{const g={};o(g),s.push(t),t=g,n=null},onObjectProperty:g=>{n=g},onObjectEnd:()=>{t=s.pop()},onArrayBegin:()=>{const g=[];o(g),s.push(t),t=g,n=null},onArrayEnd:()=>{t=s.pop()},onLiteralValue:o,onError:(g,T,N)=>{l.push({error:g,offset:T,length:N})}},r),t[0]}function a(i,l=[],r=R.DEFAULT){let n={type:"array",offset:-1,length:-1,children:[],parent:void 0};function t(g){n.type==="property"&&(n.length=g-n.offset,n=n.parent)}function s(g){return n.children.push(g),g}O(i,{onObjectBegin:g=>{n=s({type:"object",offset:g,length:-1,parent:n,children:[]})},onObjectProperty:(g,T,N)=>{n=s({type:"property",offset:T,length:-1,parent:n,children:[]}),n.children.push({type:"string",value:g,offset:T,length:N,parent:n})},onObjectEnd:(g,T)=>{n.length=g+T-n.offset,n=n.parent,t(g+T)},onArrayBegin:(g,T)=>{n=s({type:"array",offset:g,length:-1,parent:n,children:[]})},onArrayEnd:(g,T)=>{n.length=g+T-n.offset,n=n.parent,t(g+T)},onLiteralValue:(g,T,N)=>{s({type:E(g),offset:T,length:N,parent:n,value:g}),t(T+N)},onSeparator:(g,T,N)=>{n.type==="property"&&(g===":"?n.colonOffset=T:g===","&&t(T))},onError:(g,T,N)=>{l.push({error:g,offset:T,length:N})}},r);const c=n.children[0];return c&&delete c.parent,c}function v(i,l){if(!i)return;let r=i;for(const n of l)if(typeof n=="string"){if(r.type!=="object"||!Array.isArray(r.children))return;let t=!1;for(const s of r.children)if(Array.isArray(s.children)&&s.children[0].value===n){r=s.children[1],t=!0;break}if(!t)return}else{const t=n;if(r.type!=="array"||t<0||!Array.isArray(r.children)||t>=r.children.length)return;r=r.children[t]}return r}function I(i){if(!i.parent||!i.parent.children)return[];const l=I(i.parent);if(i.parent.type==="property"){const r=i.parent.children[0].value;l.push(r)}else if(i.parent.type==="array"){const r=i.parent.children.indexOf(i);r!==-1&&l.push(r)}return l}function w(i){switch(i.type){case"array":return i.children.map(w);case"object":{const l=Object.create(null);for(const r of i.children){const n=r.children[1];n&&(l[r.children[0].value]=w(n))}return l}case"null":case"string":case"number":case"boolean":return i.value;default:return}}function y(i,l,r=!1){return l>=i.offset&&l<i.offset+i.length||r&&l===i.offset+i.length}function d(i,l,r=!1){if(y(i,l,r)){const n=i.children;if(Array.isArray(n))for(let t=0;t<n.length&&n[t].offset<=l;t++){const s=d(n[t],l,r);if(s)return s}return i}}function O(i,l,r=R.DEFAULT){const n=k(i,!1);function t(K){return K?()=>K(n.getTokenOffset(),n.getTokenLength()):()=>!0}function s(K){return K?ie=>K(ie,n.getTokenOffset(),n.getTokenLength()):()=>!0}const o=t(l.onObjectBegin),c=s(l.onObjectProperty),g=t(l.onObjectEnd),T=t(l.onArrayBegin),N=t(l.onArrayEnd),A=s(l.onLiteralValue),L=s(l.onSeparator),M=t(l.onComment),B=s(l.onError),Q=r&&r.disallowComments,re=r&&r.allowTrailingComma;function ae(){for(;;){const K=n.scan();switch(n.getTokenError()){case b.InvalidUnicode:ue(S.InvalidUnicode);break;case b.InvalidEscapeCharacter:ue(S.InvalidEscapeCharacter);break;case b.UnexpectedEndOfNumber:ue(S.UnexpectedEndOfNumber);break;case b.UnexpectedEndOfComment:Q||ue(S.UnexpectedEndOfComment);break;case b.UnexpectedEndOfString:ue(S.UnexpectedEndOfString);break;case b.InvalidCharacter:ue(S.InvalidCharacter);break}switch(K){case C.LineCommentTrivia:case C.BlockCommentTrivia:Q?ue(S.InvalidCommentToken):M();break;case C.Unknown:ue(S.InvalidSymbol);break;case C.Trivia:case C.LineBreakTrivia:break;default:return K}}}function ue(K,ie=[],ne=[]){if(B(K),ie.length+ne.length>0){let F=n.getToken();for(;F!==C.EOF;){if(ie.indexOf(F)!==-1){ae();break}else if(ne.indexOf(F)!==-1)break;F=ae()}}}function pe(K){const ie=n.getTokenValue();return K?A(ie):c(ie),ae(),!0}function $(){switch(n.getToken()){case C.NumericLiteral:{let K=0;try{K=JSON.parse(n.getTokenValue()),typeof K!="number"&&(ue(S.InvalidNumberFormat),K=0)}catch{ue(S.InvalidNumberFormat)}A(K);break}case C.NullKeyword:A(null);break;case C.TrueKeyword:A(!0);break;case C.FalseKeyword:A(!1);break;default:return!1}return ae(),!0}function Z(){return n.getToken()!==C.StringLiteral?(ue(S.PropertyNameExpected,[],[C.CloseBraceToken,C.CommaToken]),!1):(pe(!1),n.getToken()===C.ColonToken?(L(":"),ae(),q()||ue(S.ValueExpected,[],[C.CloseBraceToken,C.CommaToken])):ue(S.ColonExpected,[],[C.CloseBraceToken,C.CommaToken]),!0)}function _(){o(),ae();let K=!1;for(;n.getToken()!==C.CloseBraceToken&&n.getToken()!==C.EOF;){if(n.getToken()===C.CommaToken){if(K||ue(S.ValueExpected,[],[]),L(","),ae(),n.getToken()===C.CloseBraceToken&&re)break}else K&&ue(S.CommaExpected,[],[]);Z()||ue(S.ValueExpected,[],[C.CloseBraceToken,C.CommaToken]),K=!0}return g(),n.getToken()!==C.CloseBraceToken?ue(S.CloseBraceExpected,[C.CloseBraceToken],[]):ae(),!0}function W(){T(),ae();let K=!1;for(;n.getToken()!==C.CloseBracketToken&&n.getToken()!==C.EOF;){if(n.getToken()===C.CommaToken){if(K||ue(S.ValueExpected,[],[]),L(","),ae(),n.getToken()===C.CloseBracketToken&&re)break}else K&&ue(S.CommaExpected,[],[]);q()||ue(S.ValueExpected,[],[C.CloseBracketToken,C.CommaToken]),K=!0}return N(),n.getToken()!==C.CloseBracketToken?ue(S.CloseBracketExpected,[C.CloseBracketToken],[]):ae(),!0}function q(){switch(n.getToken()){case C.OpenBracketToken:return W();case C.OpenBraceToken:return _();case C.StringLiteral:return pe(!0);default:return $()}}return ae(),n.getToken()===C.EOF?r.allowEmptyContent?!0:(ue(S.ValueExpected,[],[]),!1):q()?(n.getToken()!==C.EOF&&ue(S.EndOfFileExpected,[],[]),!0):(ue(S.ValueExpected,[],[]),!1)}function E(i){switch(typeof i){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(i){if(Array.isArray(i))return"array"}else return"null";return"object"}default:return"null"}}}),define(ce[77],de([0,1,34]),function(J,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.format=C,e.toFormattedString=S,e.getEOL=D,e.isEOL=p;function C(u,f,h){let m,a,v,I,w;if(f){for(I=f.offset,w=I+f.length,v=I;v>0&&!p(u,v-1);)v--;let c=w;for(;c<u.length&&!p(u,c);)c++;a=u.substring(v,c),m=k(a,h)}else a=u,m=0,v=0,I=0,w=u.length;const y=D(h,u);let d=!1,O=0,E;h.insertSpaces?E=R(" ",h.tabSize||4):E="	";const i=(0,b.createScanner)(a,!1);let l=!1;function r(){return y+R(E,m+O)}function n(){let c=i.scan();for(d=!1;c===b.SyntaxKind.Trivia||c===b.SyntaxKind.LineBreakTrivia;)d=d||c===b.SyntaxKind.LineBreakTrivia,c=i.scan();return l=c===b.SyntaxKind.Unknown||i.getTokenError()!==b.ScanError.None,c}const t=[];function s(c,g,T){!l&&g<w&&T>I&&u.substring(g,T)!==c&&t.push({offset:g,length:T-g,content:c})}let o=n();if(o!==b.SyntaxKind.EOF){const c=i.getTokenOffset()+v,g=R(E,m);s(g,v,c)}for(;o!==b.SyntaxKind.EOF;){let c=i.getTokenOffset()+i.getTokenLength()+v,g=n(),T="";for(;!d&&(g===b.SyntaxKind.LineCommentTrivia||g===b.SyntaxKind.BlockCommentTrivia);){const A=i.getTokenOffset()+v;s(" ",c,A),c=i.getTokenOffset()+i.getTokenLength()+v,T=g===b.SyntaxKind.LineCommentTrivia?r():"",g=n()}if(g===b.SyntaxKind.CloseBraceToken)o!==b.SyntaxKind.OpenBraceToken&&(O--,T=r());else if(g===b.SyntaxKind.CloseBracketToken)o!==b.SyntaxKind.OpenBracketToken&&(O--,T=r());else{switch(o){case b.SyntaxKind.OpenBracketToken:case b.SyntaxKind.OpenBraceToken:O++,T=r();break;case b.SyntaxKind.CommaToken:case b.SyntaxKind.LineCommentTrivia:T=r();break;case b.SyntaxKind.BlockCommentTrivia:d?T=r():T=" ";break;case b.SyntaxKind.ColonToken:T=" ";break;case b.SyntaxKind.StringLiteral:if(g===b.SyntaxKind.ColonToken){T="";break}case b.SyntaxKind.NullKeyword:case b.SyntaxKind.TrueKeyword:case b.SyntaxKind.FalseKeyword:case b.SyntaxKind.NumericLiteral:case b.SyntaxKind.CloseBraceToken:case b.SyntaxKind.CloseBracketToken:g===b.SyntaxKind.LineCommentTrivia||g===b.SyntaxKind.BlockCommentTrivia?T=" ":g!==b.SyntaxKind.CommaToken&&g!==b.SyntaxKind.EOF&&(l=!0);break;case b.SyntaxKind.Unknown:l=!0;break}d&&(g===b.SyntaxKind.LineCommentTrivia||g===b.SyntaxKind.BlockCommentTrivia)&&(T=r())}const N=i.getTokenOffset()+v;s(T,c,N),o=g}return t}function S(u,f){const h=JSON.stringify(u,void 0,f.insertSpaces?f.tabSize||4:"	");return f.eol!==void 0?h.replace(/\r\n|\r|\n/g,f.eol):h}function R(u,f){let h="";for(let m=0;m<f;m++)h+=u;return h}function k(u,f){let h=0,m=0;const a=f.tabSize||4;for(;h<u.length;){const v=u.charAt(h);if(v===" ")m++;else if(v==="	")m+=a;else break;h++}return Math.floor(m/a)}function D(u,f){for(let h=0;h<f.length;h++){const m=f.charAt(h);if(m==="\r")return h+1<f.length&&f.charAt(h+1)===`
`?`\r
`:"\r";if(m===`
`)return`
`}return u&&u.eol||`
`}function p(u,f){return`\r
`.indexOf(u.charAt(f))!==-1}}),define(ce[78],de([0,1,34,77]),function(J,e,b,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeProperty=S,e.setProperty=R,e.withFormatting=k,e.applyEdit=D,e.applyEdits=p;function S(u,f,h){return R(u,f,void 0,h)}function R(u,f,h,m,a){const v=f.slice(),I=[],w=(0,b.parseTree)(u,I);let y,d;for(;v.length>0&&(d=v.pop(),y=(0,b.findNodeAtLocation)(w,v),y===void 0&&h!==void 0);)typeof d=="string"?h={[d]:h}:h=[h];if(y)if(y.type==="object"&&typeof d=="string"&&Array.isArray(y.children)){const O=(0,b.findNodeAtLocation)(y,[d]);if(O!==void 0)if(h===void 0){if(!O.parent)throw new Error("Malformed AST");const E=y.children.indexOf(O.parent);let i,l=O.parent.offset+O.parent.length;if(E>0){const r=y.children[E-1];i=r.offset+r.length}else i=y.offset+1,y.children.length>1&&(l=y.children[1].offset);return k(u,{offset:i,length:l-i,content:""},m)}else return k(u,{offset:O.offset,length:O.length,content:JSON.stringify(h)},m);else{if(h===void 0)return[];const E=`${JSON.stringify(d)}: ${JSON.stringify(h)}`,i=a?a(y.children.map(r=>r.children[0].value)):y.children.length;let l;if(i>0){const r=y.children[i-1];l={offset:r.offset+r.length,length:0,content:","+E}}else y.children.length===0?l={offset:y.offset+1,length:0,content:E}:l={offset:y.offset+1,length:0,content:E+","};return k(u,l,m)}}else if(y.type==="array"&&typeof d=="number"&&Array.isArray(y.children))if(h!==void 0){const O=`${JSON.stringify(h)}`;let E;if(y.children.length===0||d===0)E={offset:y.offset+1,length:0,content:y.children.length===0?O:O+","};else{const i=d===-1||d>y.children.length?y.children.length:d,l=y.children[i-1];E={offset:l.offset+l.length,length:0,content:","+O}}return k(u,E,m)}else{const O=d,E=y.children[O];let i;if(y.children.length===1)i={offset:y.offset+1,length:y.length-2,content:""};else if(y.children.length-1===O){const l=y.children[O-1],r=l.offset+l.length,n=y.offset+y.length;i={offset:r,length:n-2-r,content:""}}else i={offset:E.offset,length:y.children[O+1].offset-E.offset,content:""};return k(u,i,m)}else throw new Error(`Can not add ${typeof d!="number"?"index":"property"} to parent of type ${y.type}`);else return h===void 0?[]:k(u,{offset:w?w.offset:0,length:w?w.length:0,content:JSON.stringify(h)},m)}function k(u,f,h){let m=D(u,f),a=f.offset,v=f.offset+f.content.length;if(f.length===0||f.content.length===0){for(;a>0&&!(0,C.isEOL)(m,a-1);)a--;for(;v<m.length&&!(0,C.isEOL)(m,v);)v++}const I=(0,C.format)(m,{offset:a,length:v-a},h);for(let y=I.length-1;y>=0;y--){const d=I[y];m=D(m,d),a=Math.min(a,d.offset),v=Math.max(v,d.offset+d.length),v+=d.content.length-d.length}const w=u.length-(m.length-v)-a;return[{offset:a,length:w,content:m.substring(a,v)}]}function D(u,f){return u.substring(0,f.offset)+f.content+u.substring(f.offset+f.length)}function p(u,f){const h=f.slice(0).sort((a,v)=>{const I=a.offset-v.offset;return I===0?a.length-v.length:I});let m=u.length;for(let a=h.length-1;a>=0;a--){const v=h[a];if(v.offset+v.length<=m)u=D(u,v);else throw new Error("Overlapping edit");m=v.offset}return u}}),define(ce[79],de([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getCompressedContent=b;function b(R){let k=!1;const D=new Map,p=new Map;if(S(R,I=>{if(R===I)return!0;const w=JSON.stringify(I);if(w.length<30)return!0;const y=D.get(w);if(!y){const d={schemas:[I]};return D.set(w,d),p.set(I,d),!0}return y.schemas.push(I),p.set(I,y),k=!0,!1}),D.clear(),!k)return JSON.stringify(R);let f="$defs";for(;R.hasOwnProperty(f);)f+="_";const h=[];function m(I){return JSON.stringify(I,(w,y)=>{if(y!==I){const d=p.get(y);if(d&&d.schemas.length>1)return d.id||(d.id=`_${h.length}`,h.push(d.schemas[0])),{$ref:`#/${f}/${d.id}`}}return y})}const a=m(R),v=[];for(let I=0;I<h.length;I++)v.push(`"_${I}":${m(h[I])}`);return v.length?`${a.substring(0,a.length-1)},"${f}":{${v.join(",")}}}`:a}function C(R){return typeof R=="object"&&R!==null}function S(R,k){if(!R||typeof R!="object")return;const D=(...a)=>{for(const v of a)C(v)&&h.push(v)},p=(...a)=>{for(const v of a)if(C(v))for(const I in v){const w=v[I];C(w)&&h.push(w)}},u=(...a)=>{for(const v of a)if(Array.isArray(v))for(const I of v)C(I)&&h.push(I)},f=a=>{if(Array.isArray(a))for(const v of a)C(v)&&h.push(v);else C(a)&&h.push(a)},h=[R];let m=h.pop();for(;m;)k(m)&&(D(m.additionalItems,m.additionalProperties,m.not,m.contains,m.propertyNames,m.if,m.then,m.else,m.unevaluatedItems,m.unevaluatedProperties),p(m.definitions,m.$defs,m.properties,m.patternProperties,m.dependencies,m.dependentSchemas),u(m.anyOf,m.allOf,m.oneOf,m.prefixItems),f(m.items)),m=h.pop()}}),define(ce[80],de([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=void 0,e.clamp=b,e.rot=C,e.isPointWithinTriangle=D;function b(p,u,f){return Math.min(Math.max(p,u),f)}function C(p,u){return(u+p%u)%u}class S{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=S;class R{constructor(){this._n=1,this._val=0}update(u){return this._val=this._val+(u-this._val)/this._n,this._n+=1,this._val}get value(){return this._val}}e.MovingAverage=R;class k{constructor(u){this._n=0,this._val=0,this._values=[],this._index=0,this._sum=0,this._values=new Array(u),this._values.fill(0,0,u)}update(u){const f=this._values[this._index];return this._values[this._index]=u,this._index=(this._index+1)%this._values.length,this._sum-=f,this._sum+=u,this._n<this._values.length&&(this._n+=1),this._val=this._sum/this._n,this._val}get value(){return this._val}}e.SlidingWindowAverage=k;function D(p,u,f,h,m,a,v,I){const w=v-f,y=I-h,d=m-f,O=a-h,E=p-f,i=u-h,l=w*w+y*y,r=w*d+y*O,n=w*E+y*i,t=d*d+O*O,s=d*E+O*i,o=1/(l*t-r*r),c=(t*n-r*s)*o,g=(l*s-r*n)*o;return c>=0&&g>=0&&c+g<1}}),function(){function J(S){const R=[];typeof S=="number"&&R.push("code/timeOrigin",S);function k(p){R.push(p,Date.now())}function D(){const p=[];for(let u=0;u<R.length;u+=2)p.push({name:R[u],startTime:R[u+1]});return p}return{mark:k,getMarks:D}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?J():{mark(S){performance.mark(S)},getMarks(){let S=performance.timeOrigin;typeof S!="number"&&(S=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const R=[{name:"code/timeOrigin",startTime:Math.round(S)}];for(const k of performance.getEntriesByType("mark"))R.push({name:k.name,startTime:Math.round(S+k.startTime)});return R}};if(typeof process=="object"){const S=performance?.timeOrigin;return J(S)}else return console.trace("perf-util loaded in UNKNOWN environment"),J()}function b(S){return S.MonacoPerformanceMarks||(S.MonacoPerformanceMarks=e()),S.MonacoPerformanceMarks}var C;typeof global=="object"?C=global:typeof self=="object"?C=self:C={},typeof define=="function"?define("vs/base/common/performance",[],function(){return b(C)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=b(C):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),C.perf=b(C))}(),function(J,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var b=e();for(var C in b)(typeof exports=="object"?exports:J)[C]=b[C]}}(typeof self<"u"?self:this,function(){return function(J){var e={};function b(C){if(e[C])return e[C].exports;var S=e[C]={i:C,l:!1,exports:{}};return J[C].call(S.exports,S,S.exports,b),S.l=!0,S.exports}return b.m=J,b.c=e,b.d=function(C,S,R){b.o(C,S)||Object.defineProperty(C,S,{enumerable:!0,get:R})},b.r=function(C){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(C,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(C,"__esModule",{value:!0})},b.t=function(C,S){if(1&S&&(C=b(C)),8&S||4&S&&typeof C=="object"&&C&&C.__esModule)return C;var R=Object.create(null);if(b.r(R),Object.defineProperty(R,"default",{enumerable:!0,value:C}),2&S&&typeof C!="string")for(var k in C)b.d(R,k,function(D){return C[D]}.bind(null,k));return R},b.n=function(C){var S=C&&C.__esModule?function(){return C.default}:function(){return C};return b.d(S,"a",S),S},b.o=function(C,S){return Object.prototype.hasOwnProperty.call(C,S)},b.p="",b(b.s=0)}([function(J,e,b){(function(C){var S;e=J.exports=F,S=typeof C=="object"&&C.env&&C.env.NODE_DEBUG&&/\bsemver\b/i.test(C.env.NODE_DEBUG)?function(){var z=Array.prototype.slice.call(arguments,0);z.unshift("SEMVER"),console.log.apply(console,z)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var R=256,k=Number.MAX_SAFE_INTEGER||9007199254740991,D=e.re=[],p=e.src=[],u=0,f=u++;p[f]="0|[1-9]\\d*";var h=u++;p[h]="[0-9]+";var m=u++;p[m]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var a=u++;p[a]="("+p[f]+")\\.("+p[f]+")\\.("+p[f]+")";var v=u++;p[v]="("+p[h]+")\\.("+p[h]+")\\.("+p[h]+")";var I=u++;p[I]="(?:"+p[f]+"|"+p[m]+")";var w=u++;p[w]="(?:"+p[h]+"|"+p[m]+")";var y=u++;p[y]="(?:-("+p[I]+"(?:\\."+p[I]+")*))";var d=u++;p[d]="(?:-?("+p[w]+"(?:\\."+p[w]+")*))";var O=u++;p[O]="[0-9A-Za-z-]+";var E=u++;p[E]="(?:\\+("+p[O]+"(?:\\."+p[O]+")*))";var i=u++,l="v?"+p[a]+p[y]+"?"+p[E]+"?";p[i]="^"+l+"$";var r="[v=\\s]*"+p[v]+p[d]+"?"+p[E]+"?",n=u++;p[n]="^"+r+"$";var t=u++;p[t]="((?:<|>)?=?)";var s=u++;p[s]=p[h]+"|x|X|\\*";var o=u++;p[o]=p[f]+"|x|X|\\*";var c=u++;p[c]="[v=\\s]*("+p[o]+")(?:\\.("+p[o]+")(?:\\.("+p[o]+")(?:"+p[y]+")?"+p[E]+"?)?)?";var g=u++;p[g]="[v=\\s]*("+p[s]+")(?:\\.("+p[s]+")(?:\\.("+p[s]+")(?:"+p[d]+")?"+p[E]+"?)?)?";var T=u++;p[T]="^"+p[t]+"\\s*"+p[c]+"$";var N=u++;p[N]="^"+p[t]+"\\s*"+p[g]+"$";var A=u++;p[A]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var L=u++;p[L]="(?:~>?)";var M=u++;p[M]="(\\s*)"+p[L]+"\\s+",D[M]=new RegExp(p[M],"g");var B=u++;p[B]="^"+p[L]+p[c]+"$";var Q=u++;p[Q]="^"+p[L]+p[g]+"$";var re=u++;p[re]="(?:\\^)";var ae=u++;p[ae]="(\\s*)"+p[re]+"\\s+",D[ae]=new RegExp(p[ae],"g");var ue=u++;p[ue]="^"+p[re]+p[c]+"$";var pe=u++;p[pe]="^"+p[re]+p[g]+"$";var $=u++;p[$]="^"+p[t]+"\\s*("+r+")$|^$";var Z=u++;p[Z]="^"+p[t]+"\\s*("+l+")$|^$";var _=u++;p[_]="(\\s*)"+p[t]+"\\s*("+r+"|"+p[c]+")",D[_]=new RegExp(p[_],"g");var W=u++;p[W]="^\\s*("+p[c]+")\\s+-\\s+("+p[c]+")\\s*$";var q=u++;p[q]="^\\s*("+p[g]+")\\s+-\\s+("+p[g]+")\\s*$";var K=u++;p[K]="(<|>)?=?\\s*\\*";for(var ie=0;ie<35;ie++)S(ie,p[ie]),D[ie]||(D[ie]=new RegExp(p[ie]));function ne(z,ee){if(z instanceof F)return z;if(typeof z!="string"||z.length>R||!(ee?D[n]:D[i]).test(z))return null;try{return new F(z,ee)}catch{return null}}function F(z,ee){if(z instanceof F){if(z.loose===ee)return z;z=z.version}else if(typeof z!="string")throw new TypeError("Invalid Version: "+z);if(z.length>R)throw new TypeError("version is longer than "+R+" characters");if(!(this instanceof F))return new F(z,ee);S("SemVer",z,ee),this.loose=ee;var te=z.trim().match(ee?D[n]:D[i]);if(!te)throw new TypeError("Invalid Version: "+z);if(this.raw=z,this.major=+te[1],this.minor=+te[2],this.patch=+te[3],this.major>k||this.major<0)throw new TypeError("Invalid major version");if(this.minor>k||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>k||this.patch<0)throw new TypeError("Invalid patch version");te[4]?this.prerelease=te[4].split(".").map(function(ve){if(/^[0-9]+$/.test(ve)){var Ie=+ve;if(Ie>=0&&Ie<k)return Ie}return ve}):this.prerelease=[],this.build=te[5]?te[5].split("."):[],this.format()}e.parse=ne,e.valid=function(z,ee){var te=ne(z,ee);return te?te.version:null},e.clean=function(z,ee){var te=ne(z.trim().replace(/^[=v]+/,""),ee);return te?te.version:null},e.SemVer=F,F.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},F.prototype.toString=function(){return this.version},F.prototype.compare=function(z){return S("SemVer.compare",this.version,this.loose,z),z instanceof F||(z=new F(z,this.loose)),this.compareMain(z)||this.comparePre(z)},F.prototype.compareMain=function(z){return z instanceof F||(z=new F(z,this.loose)),V(this.major,z.major)||V(this.minor,z.minor)||V(this.patch,z.patch)},F.prototype.comparePre=function(z){if(z instanceof F||(z=new F(z,this.loose)),this.prerelease.length&&!z.prerelease.length)return-1;if(!this.prerelease.length&&z.prerelease.length)return 1;if(!this.prerelease.length&&!z.prerelease.length)return 0;var ee=0;do{var te=this.prerelease[ee],ve=z.prerelease[ee];if(S("prerelease compare",ee,te,ve),te===void 0&&ve===void 0)return 0;if(ve===void 0)return 1;if(te===void 0)return-1;if(te!==ve)return V(te,ve)}while(++ee)},F.prototype.inc=function(z,ee){switch(z){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",ee);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",ee);break;case"prepatch":this.prerelease.length=0,this.inc("patch",ee),this.inc("pre",ee);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",ee),this.inc("pre",ee);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var te=this.prerelease.length;--te>=0;)typeof this.prerelease[te]=="number"&&(this.prerelease[te]++,te=-2);te===-1&&this.prerelease.push(0)}ee&&(this.prerelease[0]===ee?isNaN(this.prerelease[1])&&(this.prerelease=[ee,0]):this.prerelease=[ee,0]);break;default:throw new Error("invalid increment argument: "+z)}return this.format(),this.raw=this.version,this},e.inc=function(z,ee,te,ve){typeof te=="string"&&(ve=te,te=void 0);try{return new F(z,te).inc(ee,ve).version}catch{return null}},e.diff=function(z,ee){if(Y(z,ee))return null;var te=ne(z),ve=ne(ee);if(te.prerelease.length||ve.prerelease.length){for(var Ie in te)if((Ie==="major"||Ie==="minor"||Ie==="patch")&&te[Ie]!==ve[Ie])return"pre"+Ie;return"prerelease"}for(var Ie in te)if((Ie==="major"||Ie==="minor"||Ie==="patch")&&te[Ie]!==ve[Ie])return Ie},e.compareIdentifiers=V;var j=/^[0-9]+$/;function V(z,ee){var te=j.test(z),ve=j.test(ee);return te&&ve&&(z=+z,ee=+ee),te&&!ve?-1:ve&&!te?1:z<ee?-1:z>ee?1:0}function P(z,ee,te){return new F(z,te).compare(new F(ee,te))}function x(z,ee,te){return P(z,ee,te)>0}function X(z,ee,te){return P(z,ee,te)<0}function Y(z,ee,te){return P(z,ee,te)===0}function G(z,ee,te){return P(z,ee,te)!==0}function U(z,ee,te){return P(z,ee,te)>=0}function H(z,ee,te){return P(z,ee,te)<=0}function se(z,ee,te,ve){var Ie;switch(ee){case"===":typeof z=="object"&&(z=z.version),typeof te=="object"&&(te=te.version),Ie=z===te;break;case"!==":typeof z=="object"&&(z=z.version),typeof te=="object"&&(te=te.version),Ie=z!==te;break;case"":case"=":case"==":Ie=Y(z,te,ve);break;case"!=":Ie=G(z,te,ve);break;case">":Ie=x(z,te,ve);break;case">=":Ie=U(z,te,ve);break;case"<":Ie=X(z,te,ve);break;case"<=":Ie=H(z,te,ve);break;default:throw new TypeError("Invalid operator: "+ee)}return Ie}function le(z,ee){if(z instanceof le){if(z.loose===ee)return z;z=z.value}if(!(this instanceof le))return new le(z,ee);S("comparator",z,ee),this.loose=ee,this.parse(z),this.semver===he?this.value="":this.value=this.operator+this.semver.version,S("comp",this)}e.rcompareIdentifiers=function(z,ee){return V(ee,z)},e.major=function(z,ee){return new F(z,ee).major},e.minor=function(z,ee){return new F(z,ee).minor},e.patch=function(z,ee){return new F(z,ee).patch},e.compare=P,e.compareLoose=function(z,ee){return P(z,ee,!0)},e.rcompare=function(z,ee,te){return P(ee,z,te)},e.sort=function(z,ee){return z.sort(function(te,ve){return e.compare(te,ve,ee)})},e.rsort=function(z,ee){return z.sort(function(te,ve){return e.rcompare(te,ve,ee)})},e.gt=x,e.lt=X,e.eq=Y,e.neq=G,e.gte=U,e.lte=H,e.cmp=se,e.Comparator=le;var he={};function Se(z,ee){if(z instanceof Se)return z.loose===ee?z:new Se(z.raw,ee);if(z instanceof le)return new Se(z.value,ee);if(!(this instanceof Se))return new Se(z,ee);if(this.loose=ee,this.raw=z,this.set=z.split(/\s*\|\|\s*/).map(function(te){return this.parseRange(te.trim())},this).filter(function(te){return te.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+z);this.format()}function fe(z){return!z||z.toLowerCase()==="x"||z==="*"}function ge(z,ee,te,ve,Ie,ke,Re,Ne,Oe,Ae,We,Le,Fe){return((ee=fe(te)?"":fe(ve)?">="+te+".0.0":fe(Ie)?">="+te+"."+ve+".0":">="+ee)+" "+(Ne=fe(Oe)?"":fe(Ae)?"<"+(+Oe+1)+".0.0":fe(We)?"<"+Oe+"."+(+Ae+1)+".0":Le?"<="+Oe+"."+Ae+"."+We+"-"+Le:"<="+Ne)).trim()}function me(z,ee){for(var te=0;te<z.length;te++)if(!z[te].test(ee))return!1;if(ee.prerelease.length){for(te=0;te<z.length;te++)if(S(z[te].semver),z[te].semver!==he&&z[te].semver.prerelease.length>0){var ve=z[te].semver;if(ve.major===ee.major&&ve.minor===ee.minor&&ve.patch===ee.patch)return!0}return!1}return!0}function Ee(z,ee,te){try{ee=new Se(ee,te)}catch{return!1}return ee.test(z)}function ye(z,ee,te,ve){var Ie,ke,Re,Ne,Oe;switch(z=new F(z,ve),ee=new Se(ee,ve),te){case">":Ie=x,ke=H,Re=X,Ne=">",Oe=">=";break;case"<":Ie=X,ke=U,Re=x,Ne="<",Oe="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Ee(z,ee,ve))return!1;for(var Ae=0;Ae<ee.set.length;++Ae){var We=ee.set[Ae],Le=null,Fe=null;if(We.forEach(function(xe){xe.semver===he&&(xe=new le(">=0.0.0")),Le=Le||xe,Fe=Fe||xe,Ie(xe.semver,Le.semver,ve)?Le=xe:Re(xe.semver,Fe.semver,ve)&&(Fe=xe)}),Le.operator===Ne||Le.operator===Oe||(!Fe.operator||Fe.operator===Ne)&&ke(z,Fe.semver)||Fe.operator===Oe&&Re(z,Fe.semver))return!1}return!0}le.prototype.parse=function(z){var ee=this.loose?D[$]:D[Z],te=z.match(ee);if(!te)throw new TypeError("Invalid comparator: "+z);this.operator=te[1],this.operator==="="&&(this.operator=""),te[2]?this.semver=new F(te[2],this.loose):this.semver=he},le.prototype.toString=function(){return this.value},le.prototype.test=function(z){return S("Comparator.test",z,this.loose),this.semver===he||(typeof z=="string"&&(z=new F(z,this.loose)),se(z,this.operator,this.semver,this.loose))},le.prototype.intersects=function(z,ee){if(!(z instanceof le))throw new TypeError("a Comparator is required");var te;if(this.operator==="")return te=new Se(z.value,ee),Ee(this.value,te,ee);if(z.operator==="")return te=new Se(this.value,ee),Ee(z.semver,te,ee);var ve=!(this.operator!==">="&&this.operator!==">"||z.operator!==">="&&z.operator!==">"),Ie=!(this.operator!=="<="&&this.operator!=="<"||z.operator!=="<="&&z.operator!=="<"),ke=this.semver.version===z.semver.version,Re=!(this.operator!==">="&&this.operator!=="<="||z.operator!==">="&&z.operator!=="<="),Ne=se(this.semver,"<",z.semver,ee)&&(this.operator===">="||this.operator===">")&&(z.operator==="<="||z.operator==="<"),Oe=se(this.semver,">",z.semver,ee)&&(this.operator==="<="||this.operator==="<")&&(z.operator===">="||z.operator===">");return ve||Ie||ke&&Re||Ne||Oe},e.Range=Se,Se.prototype.format=function(){return this.range=this.set.map(function(z){return z.join(" ").trim()}).join("||").trim(),this.range},Se.prototype.toString=function(){return this.range},Se.prototype.parseRange=function(z){var ee=this.loose;z=z.trim(),S("range",z,ee);var te=ee?D[q]:D[W];z=z.replace(te,ge),S("hyphen replace",z),z=z.replace(D[_],"$1$2$3"),S("comparator trim",z,D[_]),z=(z=(z=z.replace(D[M],"$1~")).replace(D[ae],"$1^")).split(/\s+/).join(" ");var ve=ee?D[$]:D[Z],Ie=z.split(" ").map(function(ke){return function(Re,Ne){return S("comp",Re),Re=function(Oe,Ae){return Oe.trim().split(/\s+/).map(function(We){return function(Le,Fe){S("caret",Le,Fe);var xe=Fe?D[pe]:D[ue];return Le.replace(xe,function(Ue,be,Ce,De,Te){var Me;return S("caret",Le,Ue,be,Ce,De,Te),fe(be)?Me="":fe(Ce)?Me=">="+be+".0.0 <"+(+be+1)+".0.0":fe(De)?Me=be==="0"?">="+be+"."+Ce+".0 <"+be+"."+(+Ce+1)+".0":">="+be+"."+Ce+".0 <"+(+be+1)+".0.0":Te?(S("replaceCaret pr",Te),Te.charAt(0)!=="-"&&(Te="-"+Te),Me=be==="0"?Ce==="0"?">="+be+"."+Ce+"."+De+Te+" <"+be+"."+Ce+"."+(+De+1):">="+be+"."+Ce+"."+De+Te+" <"+be+"."+(+Ce+1)+".0":">="+be+"."+Ce+"."+De+Te+" <"+(+be+1)+".0.0"):(S("no pr"),Me=be==="0"?Ce==="0"?">="+be+"."+Ce+"."+De+" <"+be+"."+Ce+"."+(+De+1):">="+be+"."+Ce+"."+De+" <"+be+"."+(+Ce+1)+".0":">="+be+"."+Ce+"."+De+" <"+(+be+1)+".0.0"),S("caret return",Me),Me})}(We,Ae)}).join(" ")}(Re,Ne),S("caret",Re),Re=function(Oe,Ae){return Oe.trim().split(/\s+/).map(function(We){return function(Le,Fe){var xe=Fe?D[Q]:D[B];return Le.replace(xe,function(Ue,be,Ce,De,Te){var Me;return S("tilde",Le,Ue,be,Ce,De,Te),fe(be)?Me="":fe(Ce)?Me=">="+be+".0.0 <"+(+be+1)+".0.0":fe(De)?Me=">="+be+"."+Ce+".0 <"+be+"."+(+Ce+1)+".0":Te?(S("replaceTilde pr",Te),Te.charAt(0)!=="-"&&(Te="-"+Te),Me=">="+be+"."+Ce+"."+De+Te+" <"+be+"."+(+Ce+1)+".0"):Me=">="+be+"."+Ce+"."+De+" <"+be+"."+(+Ce+1)+".0",S("tilde return",Me),Me})}(We,Ae)}).join(" ")}(Re,Ne),S("tildes",Re),Re=function(Oe,Ae){return S("replaceXRanges",Oe,Ae),Oe.split(/\s+/).map(function(We){return function(Le,Fe){Le=Le.trim();var xe=Fe?D[N]:D[T];return Le.replace(xe,function(Ue,be,Ce,De,Te,Me){S("xRange",Le,Ue,be,Ce,De,Te,Me);var je=fe(Ce),_e=je||fe(De),ze=_e||fe(Te);return be==="="&&ze&&(be=""),je?Ue=be===">"||be==="<"?"<0.0.0":"*":be&&ze?(_e&&(De=0),ze&&(Te=0),be===">"?(be=">=",_e?(Ce=+Ce+1,De=0,Te=0):ze&&(De=+De+1,Te=0)):be==="<="&&(be="<",_e?Ce=+Ce+1:De=+De+1),Ue=be+Ce+"."+De+"."+Te):_e?Ue=">="+Ce+".0.0 <"+(+Ce+1)+".0.0":ze&&(Ue=">="+Ce+"."+De+".0 <"+Ce+"."+(+De+1)+".0"),S("xRange return",Ue),Ue})}(We,Ae)}).join(" ")}(Re,Ne),S("xrange",Re),Re=function(Oe,Ae){return S("replaceStars",Oe,Ae),Oe.trim().replace(D[K],"")}(Re,Ne),S("stars",Re),Re}(ke,ee)}).join(" ").split(/\s+/);return this.loose&&(Ie=Ie.filter(function(ke){return!!ke.match(ve)})),Ie=Ie.map(function(ke){return new le(ke,ee)})},Se.prototype.intersects=function(z,ee){if(!(z instanceof Se))throw new TypeError("a Range is required");return this.set.some(function(te){return te.every(function(ve){return z.set.some(function(Ie){return Ie.every(function(ke){return ve.intersects(ke,ee)})})})})},e.toComparators=function(z,ee){return new Se(z,ee).set.map(function(te){return te.map(function(ve){return ve.value}).join(" ").trim().split(" ")})},Se.prototype.test=function(z){if(!z)return!1;typeof z=="string"&&(z=new F(z,this.loose));for(var ee=0;ee<this.set.length;ee++)if(me(this.set[ee],z))return!0;return!1},e.satisfies=Ee,e.maxSatisfying=function(z,ee,te){var ve=null,Ie=null;try{var ke=new Se(ee,te)}catch{return null}return z.forEach(function(Re){ke.test(Re)&&(ve&&Ie.compare(Re)!==-1||(Ie=new F(ve=Re,te)))}),ve},e.minSatisfying=function(z,ee,te){var ve=null,Ie=null;try{var ke=new Se(ee,te)}catch{return null}return z.forEach(function(Re){ke.test(Re)&&(ve&&Ie.compare(Re)!==1||(Ie=new F(ve=Re,te)))}),ve},e.validRange=function(z,ee){try{return new Se(z,ee).range||"*"}catch{return null}},e.ltr=function(z,ee,te){return ye(z,ee,"<",te)},e.gtr=function(z,ee,te){return ye(z,ee,">",te)},e.outside=ye,e.prerelease=function(z,ee){var te=ne(z,ee);return te&&te.prerelease.length?te.prerelease:null},e.intersects=function(z,ee,te){return z=new Se(z,te),ee=new Se(ee,te),z.intersects(ee)},e.coerce=function(z){if(z instanceof F)return z;if(typeof z!="string")return null;var ee=z.match(D[A]);return ee==null?null:ne((ee[1]||"0")+"."+(ee[2]||"0")+"."+(ee[3]||"0"))}}).call(this,b(1))},function(J,e){var b,C,S=J.exports={};function R(){throw new Error("setTimeout has not been defined")}function k(){throw new Error("clearTimeout has not been defined")}function D(w){if(b===setTimeout)return setTimeout(w,0);if((b===R||!b)&&setTimeout)return b=setTimeout,setTimeout(w,0);try{return b(w,0)}catch{try{return b.call(null,w,0)}catch{return b.call(this,w,0)}}}(function(){try{b=typeof setTimeout=="function"?setTimeout:R}catch{b=R}try{C=typeof clearTimeout=="function"?clearTimeout:k}catch{C=k}})();var p,u=[],f=!1,h=-1;function m(){f&&p&&(f=!1,p.length?u=p.concat(u):h=-1,u.length&&a())}function a(){if(!f){var w=D(m);f=!0;for(var y=u.length;y;){for(p=u,u=[];++h<y;)p&&p[h].run();h=-1,y=u.length}p=null,f=!1,function(d){if(C===clearTimeout)return clearTimeout(d);if((C===k||!C)&&clearTimeout)return C=clearTimeout,clearTimeout(d);try{C(d)}catch{try{return C.call(null,d)}catch{return C.call(this,d)}}}(w)}}function v(w,y){this.fun=w,this.array=y}function I(){}S.nextTick=function(w){var y=new Array(arguments.length-1);if(arguments.length>1)for(var d=1;d<arguments.length;d++)y[d-1]=arguments[d];u.push(new v(w,y)),u.length!==1||f||D(a)},v.prototype.run=function(){this.fun.apply(null,this.array)},S.title="browser",S.browser=!0,S.env={},S.argv=[],S.version="",S.versions={},S.on=I,S.addListener=I,S.once=I,S.off=I,S.removeListener=I,S.removeAllListeners=I,S.emit=I,S.prependListener=I,S.prependOnceListener=I,S.listeners=function(w){return[]},S.binding=function(w){throw new Error("process.binding is not supported")},S.cwd=function(){return"/"},S.chdir=function(w){throw new Error("process.chdir is not supported")},S.umask=function(){return 0}}])}),define(ce[81],de([0,1]),function(J,e){"use strict";var b;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class C{constructor(D,p,u){this.level=D,this.key=p,this.value=u,this.forward=[]}}const S=void 0;class R{constructor(D,p=2**16){this.comparator=D,this[b]="SkipList",this._level=0,this._size=0,this._maxLevel=Math.max(1,Math.log2(p)|0),this._header=new C(this._maxLevel,S,S)}get size(){return this._size}clear(){this._header=new C(this._maxLevel,S,S),this._size=0}has(D){return!!R._search(this,D,this.comparator)}get(D){return R._search(this,D,this.comparator)?.value}set(D,p){return R._insert(this,D,p,this.comparator)&&(this._size+=1),this}delete(D){const p=R._delete(this,D,this.comparator);return p&&(this._size-=1),p}forEach(D,p){let u=this._header.forward[0];for(;u;)D.call(p,u.value,u.key,this),u=u.forward[0]}[(b=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let D=this._header.forward[0];for(;D;)yield[D.key,D.value],D=D.forward[0]}*keys(){let D=this._header.forward[0];for(;D;)yield D.key,D=D.forward[0]}*values(){let D=this._header.forward[0];for(;D;)yield D.value,D=D.forward[0]}toString(){let D="[SkipList]:",p=this._header.forward[0];for(;p;)D+=`node(${p.key}, ${p.value}, lvl:${p.level})`,p=p.forward[0];return D}static _search(D,p,u){let f=D._header;for(let h=D._level-1;h>=0;h--)for(;f.forward[h]&&u(f.forward[h].key,p)<0;)f=f.forward[h];if(f=f.forward[0],f&&u(f.key,p)===0)return f}static _insert(D,p,u,f){const h=[];let m=D._header;for(let a=D._level-1;a>=0;a--){for(;m.forward[a]&&f(m.forward[a].key,p)<0;)m=m.forward[a];h[a]=m}if(m=m.forward[0],m&&f(m.key,p)===0)return m.value=u,!1;{const a=R._randomLevel(D);if(a>D._level){for(let v=D._level;v<a;v++)h[v]=D._header;D._level=a}m=new C(a,p,u);for(let v=0;v<a;v++)m.forward[v]=h[v].forward[v],h[v].forward[v]=m;return!0}}static _randomLevel(D,p=.5){let u=1;for(;Math.random()<p&&u<D._maxLevel;)u+=1;return u}static _delete(D,p,u){const f=[];let h=D._header;for(let m=D._level-1;m>=0;m--){for(;h.forward[m]&&u(h.forward[m].key,p)<0;)h=h.forward[m];f[m]=h}if(h=h.forward[0],!h||u(h.key,p)!==0)return!1;for(let m=0;m<D._level&&f[m].forward[m]===h;m++)f[m].forward[m]=h.forward[m];for(;D._level>0&&D._header.forward[D._level-1]===S;)D._level-=1;return!0}}e.SkipList=R}),define(ce[47],de([0,1,7,2]),function(J,e,b,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isReadable=S,e.isReadableStream=R,e.isReadableBufferedStream=k,e.newWriteableStream=D,e.consumeReadable=u,e.peekReadable=f,e.consumeStream=h,e.listenStream=m,e.peekStream=a,e.toStream=v,e.emptyStream=I,e.toReadable=w,e.transform=y,e.prefixedReadable=d,e.prefixedStream=O;function S(E){const i=E;return i?typeof i.read=="function":!1}function R(E){const i=E;return i?[i.on,i.pause,i.resume,i.destroy].every(l=>typeof l=="function"):!1}function k(E){const i=E;return i?R(i.stream)&&Array.isArray(i.buffer)&&typeof i.ended=="boolean":!1}function D(E,i){return new p(E,i)}class p{constructor(i,l){this.reducer=i,this.options=l,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(i){if(!this.state.destroyed){if(this.state.flowing)this.emitData(i);else if(this.buffer.data.push(i),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(l=>this.pendingWritePromises.push(l))}}error(i){this.state.destroyed||(this.state.flowing?this.emitError(i):this.buffer.error.push(i))}end(i){this.state.destroyed||(typeof i<"u"&&this.write(i),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(i){this.listeners.data.slice(0).forEach(l=>l(i))}emitError(i){this.listeners.error.length===0?(0,b.onUnexpectedError)(i):this.listeners.error.slice(0).forEach(l=>l(i))}emitEnd(){this.listeners.end.slice(0).forEach(i=>i())}on(i,l){if(!this.state.destroyed)switch(i){case"data":this.listeners.data.push(l),this.resume();break;case"end":this.listeners.end.push(l),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(l),this.state.flowing&&this.flowErrors();break}}removeListener(i,l){if(this.state.destroyed)return;let r;switch(i){case"data":r=this.listeners.data;break;case"end":r=this.listeners.end;break;case"error":r=this.listeners.error;break}if(r){const n=r.indexOf(l);n>=0&&r.splice(n,1)}}flowData(){if(this.buffer.data.length>0){const i=this.reducer(this.buffer.data);this.emitData(i),this.buffer.data.length=0;const l=[...this.pendingWritePromises];this.pendingWritePromises.length=0,l.forEach(r=>r())}}flowErrors(){if(this.listeners.error.length>0){for(const i of this.buffer.error)this.emitError(i);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function u(E,i){const l=[];let r;for(;(r=E.read())!==null;)l.push(r);return i(l)}function f(E,i,l){const r=[];let n;for(;(n=E.read())!==null&&r.length<l;)r.push(n);return n===null&&r.length>0?i(r):{read:()=>{if(r.length>0)return r.shift();if(typeof n<"u"){const t=n;return n=void 0,t}return E.read()}}}function h(E,i){return new Promise((l,r)=>{const n=[];m(E,{onData:t=>{i&&n.push(t)},onError:t=>{i?r(t):l(void 0)},onEnd:()=>{l(i?i(n):void 0)}})})}function m(E,i,l){E.on("error",r=>{l?.isCancellationRequested||i.onError(r)}),E.on("end",()=>{l?.isCancellationRequested||i.onEnd()}),E.on("data",r=>{l?.isCancellationRequested||i.onData(r)})}function a(E,i){return new Promise((l,r)=>{const n=new C.DisposableStore,t=[],s=g=>{if(t.push(g),t.length>i)return n.dispose(),E.pause(),l({stream:E,buffer:t,ended:!1})},o=g=>(n.dispose(),r(g)),c=()=>(n.dispose(),l({stream:E,buffer:t,ended:!0}));n.add((0,C.toDisposable)(()=>E.removeListener("error",o))),E.on("error",o),n.add((0,C.toDisposable)(()=>E.removeListener("end",c))),E.on("end",c),n.add((0,C.toDisposable)(()=>E.removeListener("data",s))),E.on("data",s)})}function v(E,i){const l=D(i);return l.end(E),l}function I(){const E=D(()=>{throw new Error("not supported")});return E.end(),E}function w(E){let i=!1;return{read:()=>i?null:(i=!0,E)}}function y(E,i,l){const r=D(l);return m(E,{onData:n=>r.write(i.data(n)),onError:n=>r.error(i.error?i.error(n):n),onEnd:()=>r.end()}),r}function d(E,i,l){let r=!1;return{read:()=>{const n=i.read();return r?n:(r=!0,n!==null?l([E,n]):E)}}}function O(E,i,l){let r=!1;const n=D(l);return m(i,{onData:t=>r?n.write(t):(r=!0,n.write(l([E,t]))),onError:t=>n.error(t),onEnd:()=>{r||(r=!0,n.write(E)),n.end()}}),n}});var $e=this&&this.__createBinding||(Object.create?function(J,e,b,C){C===void 0&&(C=b);var S=Object.getOwnPropertyDescriptor(e,b);(!S||("get"in S?!e.__esModule:S.writable||S.configurable))&&(S={enumerable:!0,get:function(){return e[b]}}),Object.defineProperty(J,C,S)}:function(J,e,b,C){C===void 0&&(C=b),J[C]=e[b]}),Be=this&&this.__setModuleDefault||(Object.create?function(J,e){Object.defineProperty(J,"default",{enumerable:!0,value:e})}:function(J,e){J.default=e}),we=this&&this.__importStar||function(J){if(J&&J.__esModule)return J;var e={};if(J!=null)for(var b in J)b!=="default"&&Object.prototype.hasOwnProperty.call(J,b)&&$e(e,J,b);return Be(e,J),e};define(ce[13],de([0,1,147,47]),function(J,e,b,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.VSBuffer=void 0,e.binaryIndexOf=u,e.readUInt16LE=f,e.writeUInt16LE=h,e.readUInt32BE=m,e.writeUInt32BE=a,e.readUInt32LE=v,e.writeUInt32LE=I,e.readUInt8=w,e.writeUInt8=y,e.readableToBuffer=d,e.bufferToReadable=O,e.streamToBuffer=E,e.bufferedStreamToBuffer=i,e.bufferToStream=l,e.streamToBufferReadableStream=r,e.newWriteableBufferStream=n,e.prefixedBufferReadable=t,e.prefixedBufferStream=s,e.decodeBase64=o,e.encodeBase64=T,C=we(C);const S=typeof Buffer<"u",R=new b.Lazy(()=>new Uint8Array(256));let k,D;class p{static alloc(A){return S?new p(Buffer.allocUnsafe(A)):new p(new Uint8Array(A))}static wrap(A){return S&&!Buffer.isBuffer(A)&&(A=Buffer.from(A.buffer,A.byteOffset,A.byteLength)),new p(A)}static fromString(A,L){return!(L?.dontUseNodeBuffer||!1)&&S?new p(Buffer.from(A)):(k||(k=new TextEncoder),new p(k.encode(A)))}static fromByteArray(A){const L=p.alloc(A.length);for(let M=0,B=A.length;M<B;M++)L.buffer[M]=A[M];return L}static concat(A,L){if(typeof L>"u"){L=0;for(let Q=0,re=A.length;Q<re;Q++)L+=A[Q].byteLength}const M=p.alloc(L);let B=0;for(let Q=0,re=A.length;Q<re;Q++){const ae=A[Q];M.set(ae,B),B+=ae.byteLength}return M}constructor(A){this.buffer=A,this.byteLength=this.buffer.byteLength}clone(){const A=p.alloc(this.byteLength);return A.set(this),A}toString(){return S?this.buffer.toString():(D||(D=new TextDecoder),D.decode(this.buffer))}slice(A,L){return new p(this.buffer.subarray(A,L))}set(A,L){if(A instanceof p)this.buffer.set(A.buffer,L);else if(A instanceof Uint8Array)this.buffer.set(A,L);else if(A instanceof ArrayBuffer)this.buffer.set(new Uint8Array(A),L);else if(ArrayBuffer.isView(A))this.buffer.set(new Uint8Array(A.buffer,A.byteOffset,A.byteLength),L);else throw new Error("Unknown argument 'array'")}readUInt32BE(A){return m(this.buffer,A)}writeUInt32BE(A,L){a(this.buffer,A,L)}readUInt32LE(A){return v(this.buffer,A)}writeUInt32LE(A,L){I(this.buffer,A,L)}readUInt8(A){return w(this.buffer,A)}writeUInt8(A,L){y(this.buffer,A,L)}indexOf(A,L=0){return u(this.buffer,A instanceof p?A.buffer:A,L)}}e.VSBuffer=p;function u(N,A,L=0){const M=A.byteLength,B=N.byteLength;if(M===0)return 0;if(M===1)return N.indexOf(A[0]);if(M>B-L)return-1;const Q=R.value;Q.fill(A.length);for(let pe=0;pe<A.length;pe++)Q[A[pe]]=A.length-pe-1;let re=L+A.length-1,ae=re,ue=-1;for(;re<B;)if(N[re]===A[ae]){if(ae===0){ue=re;break}re--,ae--}else re+=Math.max(A.length-ae,Q[N[re]]),ae=A.length-1;return ue}function f(N,A){return N[A+0]<<0>>>0|N[A+1]<<8>>>0}function h(N,A,L){N[L+0]=A&255,A=A>>>8,N[L+1]=A&255}function m(N,A){return N[A]*2**24+N[A+1]*2**16+N[A+2]*2**8+N[A+3]}function a(N,A,L){N[L+3]=A,A=A>>>8,N[L+2]=A,A=A>>>8,N[L+1]=A,A=A>>>8,N[L]=A}function v(N,A){return N[A+0]<<0>>>0|N[A+1]<<8>>>0|N[A+2]<<16>>>0|N[A+3]<<24>>>0}function I(N,A,L){N[L+0]=A&255,A=A>>>8,N[L+1]=A&255,A=A>>>8,N[L+2]=A&255,A=A>>>8,N[L+3]=A&255}function w(N,A){return N[A]}function y(N,A,L){N[L]=A}function d(N){return C.consumeReadable(N,A=>p.concat(A))}function O(N){return C.toReadable(N)}function E(N){return C.consumeStream(N,A=>p.concat(A))}async function i(N){return N.ended?p.concat(N.buffer):p.concat([...N.buffer,await E(N.stream)])}function l(N){return C.toStream(N,A=>p.concat(A))}function r(N){return C.transform(N,{data:A=>typeof A=="string"?p.fromString(A):p.wrap(A)},A=>p.concat(A))}function n(N){return C.newWriteableStream(A=>p.concat(A),N)}function t(N,A){return C.prefixedReadable(N,A,L=>p.concat(L))}function s(N,A){return C.prefixedStream(N,A,L=>p.concat(L))}function o(N){let A=0,L=0,M=0;const B=new Uint8Array(Math.floor(N.length/4*3)),Q=ae=>{switch(L){case 3:B[M++]=A|ae,L=0;break;case 2:B[M++]=A|ae>>>2,A=ae<<6,L=3;break;case 1:B[M++]=A|ae>>>4,A=ae<<4,L=2;break;default:A=ae<<2,L=1}};for(let ae=0;ae<N.length;ae++){const ue=N.charCodeAt(ae);if(ue>=65&&ue<=90)Q(ue-65);else if(ue>=97&&ue<=122)Q(ue-97+26);else if(ue>=48&&ue<=57)Q(ue-48+52);else if(ue===43||ue===45)Q(62);else if(ue===47||ue===95)Q(63);else{if(ue===61)break;throw new SyntaxError(`Unexpected base64 character ${N[ae]}`)}}const re=M;for(;L>0;)Q(0);return p.wrap(B).slice(0,re)}const c="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",g="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function T({buffer:N},A=!0,L=!1){const M=L?g:c;let B="";const Q=N.byteLength%3;let re=0;for(;re<N.byteLength-Q;re+=3){const ae=N[re+0],ue=N[re+1],pe=N[re+2];B+=M[ae>>>2],B+=M[(ae<<4|ue>>>4)&63],B+=M[(ue<<2|pe>>>6)&63],B+=M[pe&63]}if(Q===1){const ae=N[re+0];B+=M[ae>>>2],B+=M[ae<<4&63],A&&(B+="==")}else if(Q===2){const ae=N[re+0],ue=N[re+1];B+=M[ae>>>2],B+=M[(ae<<4|ue>>>4)&63],B+=M[ue<<2&63],A&&(B+="=")}return B}}),define(ce[27],de([0,1,3]),function(J,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deepClone=C,e.deepFreeze=S,e.cloneAndChange=k,e.mixin=p,e.equals=u,e.safeStringify=f,e.distinct=h,e.getCaseInsensitive=m,e.filter=a,e.getAllPropertyNames=v,e.getAllMethodNames=I,e.createProxyObject=w,e.mapValues=y;function C(d){if(!d||typeof d!="object"||d instanceof RegExp)return d;const O=Array.isArray(d)?[]:{};return Object.entries(d).forEach(([E,i])=>{O[E]=i&&typeof i=="object"?C(i):i}),O}function S(d){if(!d||typeof d!="object")return d;const O=[d];for(;O.length>0;){const E=O.shift();Object.freeze(E);for(const i in E)if(R.call(E,i)){const l=E[i];typeof l=="object"&&!Object.isFrozen(l)&&!(0,b.isTypedArray)(l)&&O.push(l)}}return d}const R=Object.prototype.hasOwnProperty;function k(d,O){return D(d,O,new Set)}function D(d,O,E){if((0,b.isUndefinedOrNull)(d))return d;const i=O(d);if(typeof i<"u")return i;if(Array.isArray(d)){const l=[];for(const r of d)l.push(D(r,O,E));return l}if((0,b.isObject)(d)){if(E.has(d))throw new Error("Cannot clone recursive data-structure");E.add(d);const l={};for(const r in d)R.call(d,r)&&(l[r]=D(d[r],O,E));return E.delete(d),l}return d}function p(d,O,E=!0){return(0,b.isObject)(d)?((0,b.isObject)(O)&&Object.keys(O).forEach(i=>{i in d?E&&((0,b.isObject)(d[i])&&(0,b.isObject)(O[i])?p(d[i],O[i],E):d[i]=O[i]):d[i]=O[i]}),d):O}function u(d,O){if(d===O)return!0;if(d==null||O===null||O===void 0||typeof d!=typeof O||typeof d!="object"||Array.isArray(d)!==Array.isArray(O))return!1;let E,i;if(Array.isArray(d)){if(d.length!==O.length)return!1;for(E=0;E<d.length;E++)if(!u(d[E],O[E]))return!1}else{const l=[];for(i in d)l.push(i);l.sort();const r=[];for(i in O)r.push(i);if(r.sort(),!u(l,r))return!1;for(E=0;E<l.length;E++)if(!u(d[l[E]],O[l[E]]))return!1}return!0}function f(d){const O=new Set;return JSON.stringify(d,(E,i)=>{if((0,b.isObject)(i)||Array.isArray(i)){if(O.has(i))return"[Circular]";O.add(i)}return typeof i=="bigint"?`[BigInt ${i.toString()}]`:i})}function h(d,O){const E=Object.create(null);return!d||!O||Object.keys(O).forEach(l=>{const r=d[l],n=O[l];u(r,n)||(E[l]=n)}),E}function m(d,O){const E=O.toLowerCase(),i=Object.keys(d).find(l=>l.toLowerCase()===E);return i?d[i]:d[O]}function a(d,O){const E=Object.create(null);for(const[i,l]of Object.entries(d))O(i,l)&&(E[i]=l);return E}function v(d){let O=[];for(;Object.prototype!==d;)O=O.concat(Object.getOwnPropertyNames(d)),d=Object.getPrototypeOf(d);return O}function I(d){const O=[];for(const E of v(d))typeof d[E]=="function"&&O.push(E);return O}function w(d,O){const E=l=>function(){const r=Array.prototype.slice.call(arguments,0);return O(l,r)},i={};for(const l of d)i[l]=E(l);return i}function y(d,O){const E={};for(const[i,l]of Object.entries(d))E[i]=O(l,i);return E}}),define(ce[43],de([0,1,31]),function(J,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.Hasher=void 0,e.hash=C,e.doHash=S,e.numberHash=R,e.stringHash=D,e.toHexString=I,b=we(b);function C(y){return S(y,0)}function S(y,d){switch(typeof y){case"object":return y===null?R(349,d):Array.isArray(y)?p(y,d):u(y,d);case"string":return D(y,d);case"boolean":return k(y,d);case"number":return R(y,d);case"undefined":return R(937,d);default:return R(617,d)}}function R(y,d){return(d<<5)-d+y|0}function k(y,d){return R(y?433:863,d)}function D(y,d){d=R(149417,d);for(let O=0,E=y.length;O<E;O++)d=R(y.charCodeAt(O),d);return d}function p(y,d){return d=R(104579,d),y.reduce((O,E)=>S(E,O),d)}function u(y,d){return d=R(181387,d),Object.keys(y).sort().reduce((O,E)=>(O=D(E,O),S(y[E],O)),d)}class f{constructor(){this._value=0}get value(){return this._value}hash(d){return this._value=S(d,this._value),this._value}}e.Hasher=f;var h;(function(y){y[y.BLOCK_SIZE=64]="BLOCK_SIZE",y[y.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(h||(h={}));function m(y,d,O=32){const E=O-d,i=~((1<<E)-1);return(y<<d|(i&y)>>>E)>>>0}function a(y,d=0,O=y.byteLength,E=0){for(let i=0;i<O;i++)y[d+i]=E}function v(y,d,O="0"){for(;y.length<d;)y=O+y;return y}function I(y,d=32){return y instanceof ArrayBuffer?Array.from(new Uint8Array(y)).map(O=>O.toString(16).padStart(2,"0")).join(""):v((y>>>0).toString(16),d/4)}class w{static{this._bigBlock32=new DataView(new ArrayBuffer(320))}constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(h.BLOCK_SIZE+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(d){const O=d.length;if(O===0)return;const E=this._buff;let i=this._buffLen,l=this._leftoverHighSurrogate,r,n;for(l!==0?(r=l,n=-1,l=0):(r=d.charCodeAt(0),n=0);;){let t=r;if(b.isHighSurrogate(r))if(n+1<O){const s=d.charCodeAt(n+1);b.isLowSurrogate(s)?(n++,t=b.computeCodePoint(r,s)):t=h.UNICODE_REPLACEMENT}else{l=r;break}else b.isLowSurrogate(r)&&(t=h.UNICODE_REPLACEMENT);if(i=this._push(E,i,t),n++,n<O)r=d.charCodeAt(n);else break}this._buffLen=i,this._leftoverHighSurrogate=l}_push(d,O,E){return E<128?d[O++]=E:E<2048?(d[O++]=192|(E&1984)>>>6,d[O++]=128|(E&63)>>>0):E<65536?(d[O++]=224|(E&61440)>>>12,d[O++]=128|(E&4032)>>>6,d[O++]=128|(E&63)>>>0):(d[O++]=240|(E&1835008)>>>18,d[O++]=128|(E&258048)>>>12,d[O++]=128|(E&4032)>>>6,d[O++]=128|(E&63)>>>0),O>=h.BLOCK_SIZE&&(this._step(),O-=h.BLOCK_SIZE,this._totalLen+=h.BLOCK_SIZE,d[0]=d[h.BLOCK_SIZE+0],d[1]=d[h.BLOCK_SIZE+1],d[2]=d[h.BLOCK_SIZE+2]),O}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,h.UNICODE_REPLACEMENT)),this._totalLen+=this._buffLen,this._wrapUp()),I(this._h0)+I(this._h1)+I(this._h2)+I(this._h3)+I(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,a(this._buff,this._buffLen),this._buffLen>56&&(this._step(),a(this._buff));const d=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(d/4294967296),!1),this._buffDV.setUint32(60,d%4294967296,!1),this._step()}_step(){const d=w._bigBlock32,O=this._buffDV;for(let c=0;c<64;c+=4)d.setUint32(c,O.getUint32(c,!1),!1);for(let c=64;c<320;c+=4)d.setUint32(c,m(d.getUint32(c-12,!1)^d.getUint32(c-32,!1)^d.getUint32(c-56,!1)^d.getUint32(c-64,!1),1),!1);let E=this._h0,i=this._h1,l=this._h2,r=this._h3,n=this._h4,t,s,o;for(let c=0;c<80;c++)c<20?(t=i&l|~i&r,s=1518500249):c<40?(t=i^l^r,s=1859775393):c<60?(t=i&l|i&r|l&r,s=2400959708):(t=i^l^r,s=3395469782),o=m(E,5)+t+n+s+d.getUint32(c*4,!1)&4294967295,n=r,r=l,l=m(i,30),i=E,E=o;this._h0=this._h0+E&4294967295,this._h1=this._h1+i&4294967295,this._h2=this._h2+l&4294967295,this._h3=this._h3+r&4294967295,this._h4=this._h4+n&4294967295}}e.StringSHA1=w}),define(ce[56],de([0,1,31]),function(J,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),b=we(b);var C;(function(S){S[S.Ignore=0]="Ignore",S[S.Info=1]="Info",S[S.Warning=2]="Warning",S[S.Error=3]="Error"})(C||(C={})),function(S){const R="error",k="warning",D="warn",p="info",u="ignore";function f(m){return m?b.equalsIgnoreCase(R,m)?S.Error:b.equalsIgnoreCase(k,m)||b.equalsIgnoreCase(D,m)?S.Warning:b.equalsIgnoreCase(p,m)?S.Info:S.Ignore:S.Ignore}S.fromValue=f;function h(m){switch(m){case S.Error:return R;case S.Warning:return k;case S.Info:return p;default:return u}}S.toString=h}(C||(C={})),e.default=C}),define(ce[28],de([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=void 0,e.isUUID=C;const b=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function C(S){return b.test(S)}e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let S;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?S=crypto.getRandomValues.bind(crypto):S=function(D){for(let p=0;p<D.length;p++)D[p]=Math.floor(Math.random()*256);return D};const R=new Uint8Array(16),k=[];for(let D=0;D<256;D++)k.push(D.toString(16).padStart(2,"0"));return function(){S(R),R[6]=R[6]&15|64,R[8]=R[8]&63|128;let p=0,u="";return u+=k[R[p++]],u+=k[R[p++]],u+=k[R[p++]],u+=k[R[p++]],u+="-",u+=k[R[p++]],u+=k[R[p++]],u+="-",u+=k[R[p++]],u+=k[R[p++]],u+="-",u+=k[R[p++]],u+=k[R[p++]],u+="-",u+=k[R[p++]],u+=k[R[p++]],u+=k[R[p++]],u+=k[R[p++]],u+=k[R[p++]],u+=k[R[p++]],u}}()}),define(ce[82],de([0,1,35]),function(J,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=R;const C=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function S(k){const D=k.replace(/\-/g,":").toLowerCase();return!C.has(D)}function R(){const k=(0,b.networkInterfaces)();for(const D in k){const p=k[D];if(p){for(const{mac:u}of p)if(S(u))return u}}throw new Error("Unable to retrieve mac address (unexpected format)")}}),define(ce[83],de([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OfflineError=void 0,e.isOfflineError=C;const b="Offline";function C(R){return R instanceof S?!0:R instanceof Error&&R.name===b&&R.message===b}class S extends Error{constructor(){super(b),this.name=this.message}}e.OfflineError=S}),define(ce[84],de([0,1,4]),function(J,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fromNow=u,e.fromNowByDay=f,e.getDurationString=h,e.toLocalISOString=m;const C=60,S=C*60,R=S*24,k=R*7,D=R*30,p=R*365;function u(a,v,I,w){typeof a!="number"&&(a=a.getTime());const y=Math.round((new Date().getTime()-a)/1e3);if(y<-30)return(0,b.localize)(42,null,u(new Date().getTime()+y*1e3,!1));if(!w&&y<30)return(0,b.localize)(43,null);let d;return y<C?(d=y,v?d===1?I?(0,b.localize)(44,null,d):(0,b.localize)(45,null,d):I?(0,b.localize)(46,null,d):(0,b.localize)(47,null,d):d===1?I?(0,b.localize)(48,null,d):(0,b.localize)(49,null,d):I?(0,b.localize)(50,null,d):(0,b.localize)(51,null,d)):y<S?(d=Math.floor(y/C),v?d===1?I?(0,b.localize)(52,null,d):(0,b.localize)(53,null,d):I?(0,b.localize)(54,null,d):(0,b.localize)(55,null,d):d===1?I?(0,b.localize)(56,null,d):(0,b.localize)(57,null,d):I?(0,b.localize)(58,null,d):(0,b.localize)(59,null,d)):y<R?(d=Math.floor(y/S),v?d===1?I?(0,b.localize)(60,null,d):(0,b.localize)(61,null,d):I?(0,b.localize)(62,null,d):(0,b.localize)(63,null,d):d===1?I?(0,b.localize)(64,null,d):(0,b.localize)(65,null,d):I?(0,b.localize)(66,null,d):(0,b.localize)(67,null,d)):y<k?(d=Math.floor(y/R),v?d===1?(0,b.localize)(68,null,d):(0,b.localize)(69,null,d):d===1?(0,b.localize)(70,null,d):(0,b.localize)(71,null,d)):y<D?(d=Math.floor(y/k),v?d===1?I?(0,b.localize)(72,null,d):(0,b.localize)(73,null,d):I?(0,b.localize)(74,null,d):(0,b.localize)(75,null,d):d===1?I?(0,b.localize)(76,null,d):(0,b.localize)(77,null,d):I?(0,b.localize)(78,null,d):(0,b.localize)(79,null,d)):y<p?(d=Math.floor(y/D),v?d===1?I?(0,b.localize)(80,null,d):(0,b.localize)(81,null,d):I?(0,b.localize)(82,null,d):(0,b.localize)(83,null,d):d===1?I?(0,b.localize)(84,null,d):(0,b.localize)(85,null,d):I?(0,b.localize)(86,null,d):(0,b.localize)(87,null,d)):(d=Math.floor(y/p),v?d===1?I?(0,b.localize)(88,null,d):(0,b.localize)(89,null,d):I?(0,b.localize)(90,null,d):(0,b.localize)(91,null,d):d===1?I?(0,b.localize)(92,null,d):(0,b.localize)(93,null,d):I?(0,b.localize)(94,null,d):(0,b.localize)(95,null,d))}function f(a,v,I){typeof a!="number"&&(a=a.getTime());const w=new Date;w.setHours(0,0,0,0);const y=new Date(w.getTime());return y.setDate(y.getDate()-1),a>w.getTime()?(0,b.localize)(96,null):a>y.getTime()?(0,b.localize)(97,null):u(a,v,I)}function h(a,v){const I=Math.abs(a/1e3);return I<1?v?(0,b.localize)(98,null,a):(0,b.localize)(99,null,a):I<C?v?(0,b.localize)(100,null,Math.round(a)/1e3):(0,b.localize)(101,null,Math.round(a)/1e3):I<S?v?(0,b.localize)(102,null,Math.round(a/(1e3*C))):(0,b.localize)(103,null,Math.round(a/(1e3*C))):I<R?v?(0,b.localize)(104,null,Math.round(a/(1e3*S))):(0,b.localize)(105,null,Math.round(a/(1e3*S))):(0,b.localize)(106,null,Math.round(a/(1e3*R)))}function m(a){return a.getFullYear()+"-"+String(a.getMonth()+1).padStart(2,"0")+"-"+String(a.getDate()).padStart(2,"0")+"T"+String(a.getHours()).padStart(2,"0")+":"+String(a.getMinutes()).padStart(2,"0")+":"+String(a.getSeconds()).padStart(2,"0")+"."+(a.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(ce[38],de([0,1,19,3,4]),function(J,e,b,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=p,e.isErrorWithActions=u,e.createErrorWithActions=f,b=we(b),C=we(C),S=we(S);function R(h,m){return m&&(h.stack||h.stacktrace)?S.localize(107,null,D(h),k(h.stack)||k(h.stacktrace)):D(h)}function k(h){return Array.isArray(h)?h.join(`
`):h}function D(h){return h.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${h.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof h.code=="string"&&typeof h.errno=="number"&&typeof h.syscall=="string"?S.localize(108,null,h.message):h.message||S.localize(109,null)}function p(h=null,m=!1){if(!h)return S.localize(110,null);if(Array.isArray(h)){const a=b.coalesce(h),v=p(a[0],m);return a.length>1?S.localize(111,null,v,a.length):v}if(C.isString(h))return h;if(h.detail){const a=h.detail;if(a.error)return R(a.error,m);if(a.exception)return R(a.exception,m)}return h.stack?R(h,m):h.message?h.message:S.localize(112,null)}function u(h){const m=h;return m instanceof Error&&Array.isArray(m.actions)}function f(h,m){let a;return typeof h=="string"?a=new Error(h):a=h,a.actions=m,a}}),define(ce[85],de([0,1,4,34]),function(J,e,b,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getParseErrorMessage=S;function S(R){switch(R){case C.ParseErrorCode.InvalidSymbol:return(0,b.localize)(113,null);case C.ParseErrorCode.InvalidNumberFormat:return(0,b.localize)(114,null);case C.ParseErrorCode.PropertyNameExpected:return(0,b.localize)(115,null);case C.ParseErrorCode.ValueExpected:return(0,b.localize)(116,null);case C.ParseErrorCode.ColonExpected:return(0,b.localize)(117,null);case C.ParseErrorCode.CommaExpected:return(0,b.localize)(118,null);case C.ParseErrorCode.CloseBraceExpected:return(0,b.localize)(119,null);case C.ParseErrorCode.CloseBracketExpected:return(0,b.localize)(120,null);case C.ParseErrorCode.EndOfFileExpected:return(0,b.localize)(121,null);default:return""}}}),define(ce[57],de([0,1,11]),function(J,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminateResponseCode=e.Source=void 0,e.sanitizeProcessEnvironment=R,e.removeDangerousEnvVariables=k;var C;(function(D){D[D.stdout=0]="stdout",D[D.stderr=1]="stderr"})(C||(e.Source=C={}));var S;(function(D){D[D.Success=0]="Success",D[D.Unknown=1]="Unknown",D[D.AccessDenied=2]="AccessDenied",D[D.ProcessNotFound=3]="ProcessNotFound"})(S||(e.TerminateResponseCode=S={}));function R(D,...p){const u=p.reduce((m,a)=>(m[a]=!0,m),{}),f=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(D).filter(m=>!u[m]).forEach(m=>{for(let a=0;a<f.length;a++)if(m.search(f[a])!==-1){delete D[m];break}})}function k(D){D&&(delete D.DEBUG,b.isLinux&&delete D.LD_PRELOAD)}}),define(ce[86],de([0,1,12]),function(J,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isRemoteConsoleLog=C,e.parse=S,e.getFirstFrame=R,e.log=D;function C(u){const f=u;return f&&typeof f.type=="string"&&typeof f.severity=="string"}function S(u){const f=[];let h;try{const m=JSON.parse(u.arguments),a=m[m.length-1];a&&a.__$stack&&(m.pop(),h=a.__$stack),f.push(...m)}catch{f.push("Unable to log remote console arguments",u.arguments)}return{args:f,stack:h}}function R(u){if(typeof u!="string")return R(S(u).stack);const f=u;if(f){const h=k(f),m=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(h||"");if(m&&m.length===4)return{uri:b.URI.file(m[1]),line:Number(m[2]),column:Number(m[3])}}}function k(u){if(!u)return u;const f=u.indexOf(`
`);return f===-1?u:u.substring(0,f)}function D(u,f){const{args:h,stack:m}=S(u),a=typeof h[0]=="string"&&h.length===1;let v=k(m);v&&(v=`(${v.trim()})`);let I=[];if(typeof h[0]=="string"?v&&a?I=[`%c[${f}] %c${h[0]} %c${v}`,p("blue"),p(""),p("grey")]:I=[`%c[${f}] %c${h[0]}`,p("blue"),p(""),...h.slice(1)]:I=[`%c[${f}]%`,p("blue"),...h],v&&!a&&I.push(v),typeof console[u.severity]!="function")throw new Error("Unknown console method");console[u.severity].apply(console,I)}function p(u){return`color: ${u}`}}),define(ce[48],de([0,1,13,12,148]),function(J,e,b,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.stringify=R,e.parse=k,e.revive=p;function R(u){return JSON.stringify(u,D)}function k(u){let f=JSON.parse(u);return f=p(f),f}function D(u,f){return f instanceof RegExp?{$mid:S.MarshalledId.Regexp,source:f.source,flags:f.flags}:f}function p(u,f=0){if(!u||f>200)return u;if(typeof u=="object"){switch(u.$mid){case S.MarshalledId.Uri:return C.URI.revive(u);case S.MarshalledId.Regexp:return new RegExp(u.source,u.flags);case S.MarshalledId.Date:return new Date(u.source)}if(u instanceof b.VSBuffer||u instanceof Uint8Array)return u;if(Array.isArray(u))for(let h=0;h<u.length;++h)u[h]=p(u[h],f+1);else for(const h in u)Object.hasOwnProperty.call(u,h)&&(u[h]=p(u[h],f+1))}return u}}),define(ce[58],de([0,1,75,14,11,3,12]),function(J,e,b,C,S,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.importAMDNodeModule=f,e.resolveAmdNodeModulePath=h,S=we(S);class D{constructor(a,v,I){this.id=a,this.dependencies=v,this.callback=I}}class p{static{this.INSTANCE=new p}constructor(){this._isWebWorker=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this._isRenderer=typeof document=="object",this._defineCalls=[],this._initialized=!1}_initialize(){this._initialized||(this._initialized=!0,globalThis.define=(a,v,I)=>{typeof a!="string"&&(I=v,v=a,a=null),(typeof v!="object"||!Array.isArray(v))&&(I=v,v=null),this._defineCalls.push(new D(a,v,I))},globalThis.define.amd=!0,this._isRenderer?this._amdPolicy=globalThis._VSCODE_WEB_PACKAGE_TTP??window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(a){if(a.startsWith(window.location.origin)||a.startsWith(`${C.Schemas.vscodeFileResource}://${C.VSCODE_AUTHORITY}`))return a;throw new Error(`[trusted_script_src] Invalid script url: ${a}`)}}):this._isWebWorker&&(this._amdPolicy=globalThis._VSCODE_WEB_PACKAGE_TTP??globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(a){return a}})))}async load(a){this._initialize();const v=await(this._isWebWorker?this._workerLoadScript(a):this._isRenderer?this._rendererLoadScript(a):this._nodeJSLoadScript(a));if(!v){console.warn(`Did not receive a define call from script ${a}`);return}const I={},w=[],y=[];if(Array.isArray(v.dependencies))for(const d of v.dependencies)d==="exports"?w.push(I):y.push(d);if(y.length>0)throw new Error(`Cannot resolve dependencies for script ${a}. The dependencies are: ${y.join(", ")}`);return typeof v.callback=="function"?v.callback(...w)??I:v.callback}_rendererLoadScript(a){return new Promise((v,I)=>{const w=document.createElement("script");w.setAttribute("async","async"),w.setAttribute("type","text/javascript");const y=()=>{w.removeEventListener("load",d),w.removeEventListener("error",O)},d=E=>{y(),v(this._defineCalls.pop())},O=E=>{y(),I(E)};w.addEventListener("load",d),w.addEventListener("error",O),this._amdPolicy&&(a=this._amdPolicy.createScriptURL(a)),w.setAttribute("src",a),window.document.getElementsByTagName("head")[0].appendChild(w)})}async _workerLoadScript(a){return this._amdPolicy&&(a=this._amdPolicy.createScriptURL(a)),b.isESM?await new Promise((v,I)=>{J([a],v,I)}).then(we):importScripts(a),this._defineCalls.pop()}async _nodeJSLoadScript(a){try{const v=globalThis._VSCODE_NODE_MODULES.fs,I=globalThis._VSCODE_NODE_MODULES.vm,w=globalThis._VSCODE_NODE_MODULES.module,y=k.URI.parse(a).fsPath,d=v.readFileSync(y).toString(),O=w.wrap(d.replace(/^#!.*/,""));return new I.Script(O).runInThisContext().apply(),this._defineCalls.pop()}catch(v){throw v}}}const u=new Map;async function f(m,a,v){if(b.isESM){v===void 0&&(v=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit);const I=a?`${m}/${a}`:m;if(u.has(I))return u.get(I);let w;if(/^\w[\w\d+.-]*:\/\//.test(I))w=I;else{const E=`${b.canASAR&&v&&!S.isWeb?C.nodeModulesAsarPath:C.nodeModulesPath}/${I}`;w=C.FileAccess.asBrowserUri(E).toString(!0)}const y=p.INSTANCE.load(w);return u.set(I,y),y}else return await new Promise((I,w)=>{J([m],I,w)}).then(we)}function h(m,a){(0,R.assertType)(b.isESM);const I=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit,w=b.canASAR&&I&&!S.isWeb,y=`${m}/${a}`,O=`${w?C.nodeModulesAsarPath:C.nodeModulesPath}/${y}`;return C.FileAccess.asBrowserUri(O).toString(!0)}}),define(ce[87],de([0,1,35,49,28,82,11]),function(J,e,b,C,S,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.virtualMachineHint=void 0,e.getMachineId=p,e.getSqmMachineId=h,e.getdevDeviceId=m,S=we(S),e.virtualMachineHint=new class{_isVirtualMachineMacAddress(a){return this._virtualMachineOUIs||(this._virtualMachineOUIs=C.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(a)}value(){if(this._value===void 0){let a=0,v=0;const I=(0,b.networkInterfaces)();for(const w in I){const y=I[w];if(y)for(const{mac:d,internal:O}of y)O||(v+=1,this._isVirtualMachineMacAddress(d.toUpperCase())&&(a+=1))}this._value=v>0?a/v:0}return this._value}};let D;async function p(a){return D||(D=(async()=>await u(a)||S.generateUuid())()),D}async function u(a){try{const v=await new Promise((w,y)=>{J(["crypto"],w,y)}).then(we),I=(0,R.getMac)();return v.createHash("sha256").update(I,"utf8").digest("hex")}catch(v){a(v);return}}const f="Software\\Microsoft\\SQMClient";async function h(a){if(k.isWindows){const v=await new Promise((I,w)=>{J(["@vscode/windows-registry"],I,w)}).then(we);try{return v.GetStringRegKey("HKEY_LOCAL_MACHINE",f,"MachineId")||""}catch(I){return a(I),""}}return""}async function m(a){try{return await(await new Promise((w,y)=>{J(["@vscode/deviceid"],w,y)}).then(we)).getDeviceId()}catch(v){return a(v),""}}}),define(ce[88],de([0,1,35,15,29]),function(J,e,b,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.enumeratePowerShellInstallations=d,e.getFirstAvailablePowerShellInstallation=O,b=we(b),C=we(C),S=we(S);const R=/^\d+$/,k=/^Microsoft.PowerShell_.*/,D=/^Microsoft.PowerShellPreview_.*/;var p;(function(E){E[E.x64=0]="x64",E[E.x86=1]="x86",E[E.ARM=2]="ARM"})(p||(p={}));let u;switch(process.arch){case"ia32":u=p.x86;break;case"arm":case"arm64":u=p.ARM;break;default:u=p.x64;break}let f;process.env.PROCESSOR_ARCHITEW6432?f=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?p.ARM:p.x64:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?f=p.ARM:process.env.PROCESSOR_ARCHITECTURE==="X86"?f=p.x86:f=p.x64;class h{constructor(i,l,r){this.exePath=i,this.displayName=l,this.knownToExist=r}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await S.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function m({useAlternateBitness:E=!1}={}){return E?u===p.x64?process.env["ProgramFiles(x86)"]||null:f===p.x64&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function a({useAlternateBitness:E=!1,findPreview:i=!1}={}){const l=m({useAlternateBitness:E});if(!l)return null;const r=C.join(l,"PowerShell");if(!await S.SymlinkSupport.existsDirectory(r))return null;let n=-1,t=null;for(const c of await S.Promises.readdir(r)){let g=-1;if(i){const N=c.indexOf("-");if(N<0)continue;const A=c.substring(0,N);if(!R.test(A)||c.substring(N+1)!=="preview")continue;g=parseInt(A,10)}else{if(!R.test(c))continue;g=parseInt(c,10)}if(g<=n)continue;const T=C.join(r,c,"pwsh.exe");await S.SymlinkSupport.existsFile(T)&&(t=T,n=g)}if(!t)return null;const s=l.includes("x86")?" (x86)":"",o=i?" Preview":"";return new h(t,`PowerShell${o}${s}`,!0)}async function v({findPreview:E}={}){if(!process.env.LOCALAPPDATA)return null;const i=C.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await S.SymlinkSupport.existsDirectory(i))return null;const{pwshMsixDirRegex:l,pwshMsixName:r}=E?{pwshMsixDirRegex:D,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:k,pwshMsixName:"PowerShell (Store)"};for(const n of await S.Promises.readdir(i))if(l.test(n)){const t=C.join(i,n,"pwsh.exe");return new h(t,r)}return null}function I(){const E=C.join(b.homedir(),".dotnet","tools","pwsh.exe");return new h(E,".NET Core PowerShell Global Tool")}function w(){const E=C.join(process.env.windir,u===p.x86&&f!==p.x86?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new h(E,"Windows PowerShell",!0)}async function*y(){let E=await a();E&&(yield E),E=await a({useAlternateBitness:!0}),E&&(yield E),E=await v(),E&&(yield E),E=I(),E&&(yield E),E=await a({findPreview:!0}),E&&(yield E),E=await v({findPreview:!0}),E&&(yield E),E=await a({useAlternateBitness:!0,findPreview:!0}),E&&(yield E),E=w(),E&&(yield E)}async function*d(){for await(const E of y())await E.exists()&&(yield E)}async function O(){for await(const E of d())return E;return null}}),define(ce[59],de([0,1,32,15,11,36,57,3,29]),function(J,e,b,C,S,R,k,D,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.TerminateResponseCode=e.Source=void 0,e.getWindowsShell=u,e.createQueuedSender=f,C=we(C),S=we(S),R=we(R),D=we(D),p=we(p),Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return k.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return k.TerminateResponseCode}});function u(m=R.env){return m.comspec||"cmd.exe"}function f(m){let a=[],v=!1;const I=function(w){if(v){a.push(w);return}(!m.send(w,d=>{if(d&&console.error(d),v=!1,a.length>0){const O=a.slice(0);a=[],O.forEach(E=>I(E))}})||S.isWindows)&&(v=!0)};return{send:I}}var h;(function(m){async function a(v,I,w){if(C.isAbsolute(v))return v;if(I===void 0&&(I=R.cwd()),C.dirname(v)!=="."||(w===void 0&&D.isString(R.env.PATH)&&(w=R.env.PATH.split(C.delimiter)),w===void 0||w.length===0))return C.join(I,v);async function d(O){if(await p.Promises.exists(O)){let E;try{E=await b.promises.stat(O)}catch(i){i.message.startsWith("EACCES")&&(E=await b.promises.lstat(O))}return E?!E.isDirectory():!1}return!1}for(const O of w){let E;if(C.isAbsolute(O)?E=C.join(O,v):E=C.join(I,O,v),await d(E))return E;let i=E+".com";if(await d(i)||(i=E+".exe",await d(i)))return i}return C.join(I,v)}m.findExecutable=a})(h||(e.win32=h={}))}),define(ce[89],de([0,1,35,11,88,59]),function(J,e,b,C,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShell=k,C=we(C),R=we(R);async function k(h,m){return h===C.OperatingSystem.Windows?C.isWindows?f():R.getWindowsShell(m):p(h,m)}let D=null;function p(h,m){if(C.isLinux&&h===C.OperatingSystem.Macintosh||C.isMacintosh&&h===C.OperatingSystem.Linux)return"/bin/bash";if(!D){let a;if(C.isWindows)a="/bin/bash";else{if(a=m.SHELL,!a)try{a=(0,b.userInfo)().shell}catch{}a||(a="sh"),a==="/bin/false"&&(a="/bin/bash")}D=a}return D}let u=null;async function f(){return u||(u=(await(0,S.getFirstAvailablePowerShellInstallation)()).exePath),u}}),define(ce[50],de([0,1,32,8,15,3,29,4]),function(J,e,b,C,S,R,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtractError=e.CorruptZipMessage=void 0,e.zip=w,e.extract=y,e.buffer=O,S=we(S),D=we(D),e.CorruptZipMessage="end of central directory record signature not found";const p=new RegExp(e.CorruptZipMessage);class u extends Error{constructor(i,l){let r=l.message;switch(i){case"CorruptZip":r=`Corrupt ZIP: ${r}`;break}super(r),this.type=i,this.cause=l}}e.ExtractError=u;function f(E){const i=E.externalFileAttributes>>16||33188;return[448,56,7].map(l=>i&l).reduce((l,r)=>l+r,i&61440)}function h(E){if(E instanceof u)return E;let i;return p.test(E.message)&&(i="CorruptZip"),new u(i,E)}function m(E,i,l,r,n,t){const s=S.dirname(i),o=S.join(r,s);if(!o.startsWith(r))return Promise.reject(new Error(D.localize(142,null,i)));const c=S.join(r,i);let g;return t.onCancellationRequested(()=>{g?.destroy()}),Promise.resolve(b.promises.mkdir(o,{recursive:!0})).then(()=>new Promise((T,N)=>{if(!t.isCancellationRequested)try{g=(0,b.createWriteStream)(c,{mode:l}),g.once("close",()=>T()),g.once("error",N),E.once("error",N),E.pipe(g)}catch(A){N(A)}}))}function a(E,i,l,r){let n=(0,C.createCancelablePromise)(()=>Promise.resolve()),t=0;const s=r.onCancellationRequested(()=>{n.cancel(),E.close()});return new Promise((o,c)=>{const g=new C.Sequencer,T=N=>{N.isCancellationRequested||(t++,E.readEntry())};E.once("error",c),E.once("close",()=>n.then(()=>{r.isCancellationRequested||E.entryCount===t?o():c(new u("Incomplete",new Error(D.localize(143,null,t,E.entryCount))))},c)),E.readEntry(),E.on("entry",N=>{if(r.isCancellationRequested)return;if(!l.sourcePathRegex.test(N.fileName)){T(r);return}const A=N.fileName.replace(l.sourcePathRegex,"");if(/\/$/.test(A)){const B=S.join(i,A);n=(0,C.createCancelablePromise)(Q=>b.promises.mkdir(B,{recursive:!0}).then(()=>T(Q)).then(void 0,c));return}const L=I(E,N),M=f(N);n=(0,C.createCancelablePromise)(B=>g.queue(()=>L.then(Q=>m(Q,A,M,i,l,B).then(()=>T(B)))).then(null,c))})}).finally(()=>s.dispose())}async function v(E,i=!1){const{open:l}=await new Promise((r,n)=>{J(["yauzl"],r,n)}).then(we);return new Promise((r,n)=>{l(E,i?{lazyEntries:!0}:void 0,(t,s)=>{t?n(h(t)):r((0,R.assertIsDefined)(s))})})}function I(E,i){return new Promise((l,r)=>{E.openReadStream(i,(n,t)=>{n?r(h(n)):l((0,R.assertIsDefined)(t))})})}async function w(E,i){const{ZipFile:l}=await new Promise((r,n)=>{J(["yazl"],r,n)}).then(we);return new Promise((r,n)=>{const t=new l;i.forEach(o=>{o.contents?t.addBuffer(typeof o.contents=="string"?Buffer.from(o.contents,"utf8"):o.contents,o.path):o.localPath&&t.addFile(o.localPath,o.path)}),t.end();const s=(0,b.createWriteStream)(E);t.outputStream.pipe(s),t.outputStream.once("error",n),s.once("error",n),s.once("finish",()=>r(E))})}function y(E,i,l={},r){const n=new RegExp(l.sourcePath?`^${l.sourcePath}`:"");let t=v(E,!0);return l.overwrite&&(t=t.then(s=>k.Promises.rm(i).then(()=>s))),t.then(s=>a(s,i,{sourcePathRegex:n},r))}function d(E,i){return v(E).then(l=>new Promise((r,n)=>{l.on("entry",t=>{t.fileName===i&&I(l,t).then(s=>r(s),s=>n(s))}),l.once("close",()=>n(new Error(D.localize(144,null,i))))}))}function O(E,i){return d(E,i).then(l=>new Promise((r,n)=>{const t=[];l.once("error",n),l.on("data",s=>t.push(s)),l.on("end",()=>r(Buffer.concat(t)))}))}});var Pe=this&&this.__decorate||function(J,e,b,C){var S=arguments.length,R=S<3?e:C===null?C=Object.getOwnPropertyDescriptor(e,b):C,k;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")R=Reflect.decorate(J,e,b,C);else for(var D=J.length-1;D>=0;D--)(k=J[D])&&(R=(S<3?k(R):S>3?k(e,b,R):k(e,b))||R);return S>3&&R&&Object.defineProperty(e,b,R),R};define(ce[60],de([0,1,19,8,13,21,55,7,5,2,48,31,3]),function(J,e,b,C,S,R,k,D,p,u,f,h,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.ProxyChannel=e.StaticRouter=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.BufferWriter=e.BufferReader=void 0,e.serialize=o,e.deserialize=c,e.getDelayedChannel=M,e.getNextTickChannel=B,h=we(h);var a;(function(_){_[_.Promise=100]="Promise",_[_.PromiseCancel=101]="PromiseCancel",_[_.EventListen=102]="EventListen",_[_.EventDispose=103]="EventDispose"})(a||(a={}));function v(_){switch(_){case a.Promise:return"req";case a.PromiseCancel:return"cancel";case a.EventListen:return"subscribe";case a.EventDispose:return"unsubscribe"}}var I;(function(_){_[_.Initialize=200]="Initialize",_[_.PromiseSuccess=201]="PromiseSuccess",_[_.PromiseError=202]="PromiseError",_[_.PromiseErrorObj=203]="PromiseErrorObj",_[_.EventFire=204]="EventFire"})(I||(I={}));function w(_){switch(_){case I.Initialize:return"init";case I.PromiseSuccess:return"reply:";case I.PromiseError:case I.PromiseErrorObj:return"replyErr:";case I.EventFire:return"event:"}}var y;(function(_){_[_.Uninitialized=0]="Uninitialized",_[_.Idle=1]="Idle"})(y||(y={}));function d(_){let W=0;for(let q=0;;q+=7){const K=_.read(1);if(W|=(K.buffer[0]&127)<<q,!(K.buffer[0]&128))return W}}const O=n(0);function E(_,W){if(W===0){_.write(O);return}let q=0;for(let ie=W;ie!==0;ie=ie>>>7)q++;const K=S.VSBuffer.alloc(q);for(let ie=0;W!==0;ie++)K.buffer[ie]=W&127,W=W>>>7,W>0&&(K.buffer[ie]|=128);_.write(K)}class i{constructor(W){this.buffer=W,this.pos=0}read(W){const q=this.buffer.slice(this.pos,this.pos+W);return this.pos+=q.byteLength,q}}e.BufferReader=i;class l{constructor(){this.buffers=[]}get buffer(){return S.VSBuffer.concat(this.buffers)}write(W){this.buffers.push(W)}}e.BufferWriter=l;var r;(function(_){_[_.Undefined=0]="Undefined",_[_.String=1]="String",_[_.Buffer=2]="Buffer",_[_.VSBuffer=3]="VSBuffer",_[_.Array=4]="Array",_[_.Object=5]="Object",_[_.Int=6]="Int"})(r||(r={}));function n(_){const W=S.VSBuffer.alloc(1);return W.writeUInt8(_,0),W}const t={Undefined:n(r.Undefined),String:n(r.String),Buffer:n(r.Buffer),VSBuffer:n(r.VSBuffer),Array:n(r.Array),Object:n(r.Object),Uint:n(r.Int)},s=typeof Buffer<"u";function o(_,W){if(typeof W>"u")_.write(t.Undefined);else if(typeof W=="string"){const q=S.VSBuffer.fromString(W);_.write(t.String),E(_,q.byteLength),_.write(q)}else if(s&&Buffer.isBuffer(W)){const q=S.VSBuffer.wrap(W);_.write(t.Buffer),E(_,q.byteLength),_.write(q)}else if(W instanceof S.VSBuffer)_.write(t.VSBuffer),E(_,W.byteLength),_.write(W);else if(Array.isArray(W)){_.write(t.Array),E(_,W.length);for(const q of W)o(_,q)}else if(typeof W=="number"&&(W|0)===W)_.write(t.Uint),E(_,W);else{const q=S.VSBuffer.fromString(JSON.stringify(W));_.write(t.Object),E(_,q.byteLength),_.write(q)}}function c(_){switch(_.read(1).readUInt8(0)){case r.Undefined:return;case r.String:return _.read(d(_)).toString();case r.Buffer:return _.read(d(_)).buffer;case r.VSBuffer:return _.read(d(_));case r.Array:{const q=d(_),K=[];for(let ie=0;ie<q;ie++)K.push(c(_));return K}case r.Object:return JSON.parse(_.read(d(_)).toString());case r.Int:return d(_)}}class g{constructor(W,q,K=null,ie=1e3){this.protocol=W,this.ctx=q,this.logger=K,this.timeoutDelay=ie,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(ne=>this.onRawMessage(ne)),this.sendResponse({type:I.Initialize})}registerChannel(W,q){this.channels.set(W,q),setTimeout(()=>this.flushPendingRequests(W),0)}sendResponse(W){switch(W.type){case I.Initialize:{const q=this.send([W.type]);this.logger?.logOutgoing(q,0,T.OtherSide,w(W.type));return}case I.PromiseSuccess:case I.PromiseError:case I.EventFire:case I.PromiseErrorObj:{const q=this.send([W.type,W.id],W.data);this.logger?.logOutgoing(q,W.id,T.OtherSide,w(W.type),W.data);return}}}send(W,q=void 0){const K=new l;return o(K,W),o(K,q),this.sendBuffer(K.buffer)}sendBuffer(W){try{return this.protocol.send(W),W.byteLength}catch{return 0}}onRawMessage(W){const q=new i(W),K=c(q),ie=c(q),ne=K[0];switch(ne){case a.Promise:return this.logger?.logIncoming(W.byteLength,K[1],T.OtherSide,`${v(ne)}: ${K[2]}.${K[3]}`,ie),this.onPromise({type:ne,id:K[1],channelName:K[2],name:K[3],arg:ie});case a.EventListen:return this.logger?.logIncoming(W.byteLength,K[1],T.OtherSide,`${v(ne)}: ${K[2]}.${K[3]}`,ie),this.onEventListen({type:ne,id:K[1],channelName:K[2],name:K[3],arg:ie});case a.PromiseCancel:return this.logger?.logIncoming(W.byteLength,K[1],T.OtherSide,`${v(ne)}`),this.disposeActiveRequest({type:ne,id:K[1]});case a.EventDispose:return this.logger?.logIncoming(W.byteLength,K[1],T.OtherSide,`${v(ne)}`),this.disposeActiveRequest({type:ne,id:K[1]})}}onPromise(W){const q=this.channels.get(W.channelName);if(!q){this.collectPendingRequest(W);return}const K=new R.CancellationTokenSource;let ie;try{ie=q.call(this.ctx,W.name,W.arg,K.token)}catch(j){ie=Promise.reject(j)}const ne=W.id;ie.then(j=>{this.sendResponse({id:ne,data:j,type:I.PromiseSuccess})},j=>{j instanceof Error?this.sendResponse({id:ne,data:{message:j.message,name:j.name,stack:j.stack?j.stack.split(`
`):void 0},type:I.PromiseError}):this.sendResponse({id:ne,data:j,type:I.PromiseErrorObj})}).finally(()=>{F.dispose(),this.activeRequests.delete(W.id)});const F=(0,u.toDisposable)(()=>K.cancel());this.activeRequests.set(W.id,F)}onEventListen(W){const q=this.channels.get(W.channelName);if(!q){this.collectPendingRequest(W);return}const K=W.id,ne=q.listen(this.ctx,W.name,W.arg)(F=>this.sendResponse({id:K,data:F,type:I.EventFire}));this.activeRequests.set(W.id,ne)}disposeActiveRequest(W){const q=this.activeRequests.get(W.id);q&&(q.dispose(),this.activeRequests.delete(W.id))}collectPendingRequest(W){let q=this.pendingRequests.get(W.channelName);q||(q=[],this.pendingRequests.set(W.channelName,q));const K=setTimeout(()=>{console.error(`Unknown channel: ${W.channelName}`),W.type===a.Promise&&this.sendResponse({id:W.id,data:{name:"Unknown channel",message:`Channel name '${W.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:I.PromiseError})},this.timeoutDelay);q.push({request:W,timeoutTimer:K})}flushPendingRequests(W){const q=this.pendingRequests.get(W);if(q){for(const K of q)switch(clearTimeout(K.timeoutTimer),K.request.type){case a.Promise:this.onPromise(K.request);break;case a.EventListen:this.onEventListen(K.request);break}this.pendingRequests.delete(W)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,u.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelServer=g;var T;(function(_){_[_.LocalSide=0]="LocalSide",_[_.OtherSide=1]="OtherSide"})(T||(e.RequestInitiator=T={}));class N{constructor(W,q=null){this.protocol=W,this.isDisposed=!1,this.state=y.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new p.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(K=>this.onBuffer(K)),this.logger=q}getChannel(W){const q=this;return{call(K,ie,ne){return q.isDisposed?Promise.reject(new D.CancellationError):q.requestPromise(W,K,ie,ne)},listen(K,ie){return q.isDisposed?p.Event.None:q.requestEvent(W,K,ie)}}}requestPromise(W,q,K,ie=R.CancellationToken.None){const ne=this.lastRequestId++,F=a.Promise,j={id:ne,type:F,channelName:W,name:q,arg:K};if(ie.isCancellationRequested)return Promise.reject(new D.CancellationError);let V;return new Promise((x,X)=>{if(ie.isCancellationRequested)return X(new D.CancellationError);const Y=()=>{const se=le=>{switch(le.type){case I.PromiseSuccess:this.handlers.delete(ne),x(le.data);break;case I.PromiseError:{this.handlers.delete(ne);const he=new Error(le.data.message);he.stack=Array.isArray(le.data.stack)?le.data.stack.join(`
`):le.data.stack,he.name=le.data.name,X(he);break}case I.PromiseErrorObj:this.handlers.delete(ne),X(le.data);break}};this.handlers.set(ne,se),this.sendRequest(j)};let G=null;this.state===y.Idle?Y():(G=(0,C.createCancelablePromise)(se=>this.whenInitialized()),G.then(()=>{G=null,Y()}));const U=()=>{G?(G.cancel(),G=null):this.sendRequest({id:ne,type:a.PromiseCancel}),X(new D.CancellationError)},H=ie.onCancellationRequested(U);V=(0,u.combinedDisposable)((0,u.toDisposable)(U),H),this.activeRequests.add(V)}).finally(()=>{V.dispose(),this.activeRequests.delete(V)})}requestEvent(W,q,K){const ie=this.lastRequestId++,ne=a.EventListen,F={id:ie,type:ne,channelName:W,name:q,arg:K};let j=null;const V=new p.Emitter({onWillAddFirstListener:()=>{j=(0,C.createCancelablePromise)(x=>this.whenInitialized()),j.then(()=>{j=null,this.activeRequests.add(V),this.sendRequest(F)})},onDidRemoveLastListener:()=>{j?(j.cancel(),j=null):(this.activeRequests.delete(V),this.sendRequest({id:ie,type:a.EventDispose}))}}),P=x=>V.fire(x.data);return this.handlers.set(ie,P),V.event}sendRequest(W){switch(W.type){case a.Promise:case a.EventListen:{const q=this.send([W.type,W.id,W.channelName,W.name],W.arg);this.logger?.logOutgoing(q,W.id,T.LocalSide,`${v(W.type)}: ${W.channelName}.${W.name}`,W.arg);return}case a.PromiseCancel:case a.EventDispose:{const q=this.send([W.type,W.id]);this.logger?.logOutgoing(q,W.id,T.LocalSide,v(W.type));return}}}send(W,q=void 0){const K=new l;return o(K,W),o(K,q),this.sendBuffer(K.buffer)}sendBuffer(W){try{return this.protocol.send(W),W.byteLength}catch{return 0}}onBuffer(W){const q=new i(W),K=c(q),ie=c(q),ne=K[0];switch(ne){case I.Initialize:return this.logger?.logIncoming(W.byteLength,0,T.LocalSide,w(ne)),this.onResponse({type:K[0]});case I.PromiseSuccess:case I.PromiseError:case I.EventFire:case I.PromiseErrorObj:return this.logger?.logIncoming(W.byteLength,K[1],T.LocalSide,w(ne),ie),this.onResponse({type:K[0],id:K[1],data:ie})}}onResponse(W){if(W.type===I.Initialize){this.state=y.Idle,this._onDidInitialize.fire();return}this.handlers.get(W.id)?.(W)}get onDidInitializePromise(){return p.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===y.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,u.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelClient=N,Pe([k.memoize],N.prototype,"onDidInitializePromise",null);class A{get connections(){const W=[];return this._connections.forEach(q=>W.push(q)),W}constructor(W,q,K){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new p.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new p.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,this.disposables=new u.DisposableStore,this.disposables.add(W(({protocol:ie,onDidClientDisconnect:ne})=>{const F=p.Event.once(ie.onMessage);this.disposables.add(F(j=>{const V=new i(j),P=c(V),x=new g(ie,P,q,K),X=new N(ie,q);this.channels.forEach((G,U)=>x.registerChannel(U,G));const Y={channelServer:x,channelClient:X,ctx:P};this._connections.add(Y),this._onDidAddConnection.fire(Y),this.disposables.add(ne(()=>{x.dispose(),X.dispose(),this._connections.delete(Y),this._onDidRemoveConnection.fire(Y)}))}))}))}getChannel(W,q){const K=this;return{call(ie,ne,F){let j;if((0,m.isFunction)(q)){const P=(0,b.getRandomElement)(K.connections.filter(q));j=P?Promise.resolve(P):p.Event.toPromise(p.Event.filter(K.onDidAddConnection,q))}else j=q.routeCall(K,ie,ne);const V=j.then(P=>P.channelClient.getChannel(W));return M(V).call(ie,ne,F)},listen(ie,ne){if((0,m.isFunction)(q))return K.getMulticastEvent(W,q,ie,ne);const F=q.routeEvent(K,ie,ne).then(j=>j.channelClient.getChannel(W));return M(F).listen(ie,ne)}}}getMulticastEvent(W,q,K,ie){const ne=this;let F;const j=new p.Emitter({onWillAddFirstListener:()=>{F=new u.DisposableStore;const V=new p.EventMultiplexer,P=new Map,x=Y=>{const U=Y.channelClient.getChannel(W).listen(K,ie),H=V.add(U);P.set(Y,H)},X=Y=>{const G=P.get(Y);G&&(G.dispose(),P.delete(Y))};ne.connections.filter(q).forEach(x),p.Event.filter(ne.onDidAddConnection,q)(x,void 0,F),ne.onDidRemoveConnection(X,void 0,F),V.event(j.fire,j,F),F.add(V)},onDidRemoveLastListener:()=>{F?.dispose(),F=void 0}});return j.event}registerChannel(W,q){this.channels.set(W,q);for(const K of this._connections)K.channelServer.registerChannel(W,q)}dispose(){this.disposables.dispose();for(const W of this._connections)W.channelClient.dispose(),W.channelServer.dispose();this._connections.clear(),this.channels.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=A;class L{constructor(W,q,K=null){const ie=new l;o(ie,q),W.send(ie.buffer),this.channelClient=new N(W,K),this.channelServer=new g(W,q,K)}getChannel(W){return this.channelClient.getChannel(W)}registerChannel(W,q){this.channelServer.registerChannel(W,q)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=L;function M(_){return{call(W,q,K){return _.then(ie=>ie.call(W,q,K))},listen(W,q){const K=new p.Relay;return _.then(ie=>K.input=ie.listen(W,q)),K.event}}}function B(_){let W=!1;return{call(q,K,ie){return W?_.call(q,K,ie):(0,C.timeout)(0).then(()=>W=!0).then(()=>_.call(q,K,ie))},listen(q,K){if(W)return _.listen(q,K);const ie=new p.Relay;return(0,C.timeout)(0).then(()=>W=!0).then(()=>ie.input=_.listen(q,K)),ie.event}}}class Q{constructor(W){this.fn=W}routeCall(W){return this.route(W)}routeEvent(W){return this.route(W)}async route(W){for(const q of W.connections)if(await Promise.resolve(this.fn(q.ctx)))return Promise.resolve(q);return await p.Event.toPromise(W.onDidAddConnection),await this.route(W)}}e.StaticRouter=Q;var re;(function(_){function W(ne,F,j){const V=ne,P=j&&j.disableMarshalling,x=new Map;for(const X in V)K(X)&&x.set(X,p.Event.buffer(V[X],!0,void 0,F));return new class{listen(X,Y,G){const U=x.get(Y);if(U)return U;const H=V[Y];if(typeof H=="function"){if(ie(Y))return H.call(V,G);if(K(Y))return x.set(Y,p.Event.buffer(V[Y],!0,void 0,F)),x.get(Y)}throw new D.ErrorNoTelemetry(`Event not found: ${Y}`)}call(X,Y,G){const U=V[Y];if(typeof U=="function"){if(!P&&Array.isArray(G))for(let se=0;se<G.length;se++)G[se]=(0,f.revive)(G[se]);let H=U.apply(V,G);return H instanceof Promise||(H=Promise.resolve(H)),H}throw new D.ErrorNoTelemetry(`Method not found: ${Y}`)}}}_.fromService=W;function q(ne,F){const j=F&&F.disableMarshalling;return new Proxy({},{get(V,P){if(typeof P=="string")return F?.properties?.has(P)?F.properties.get(P):ie(P)?function(x){return ne.listen(P,x)}:K(P)?ne.listen(P):async function(...x){let X;F&&!(0,m.isUndefinedOrNull)(F.context)?X=[F.context,...x]:X=x;const Y=await ne.call(P,X);return j?Y:(0,f.revive)(Y)};throw new D.ErrorNoTelemetry(`Property not found: ${String(P)}`)}})}_.toService=q;function K(ne){return ne[0]==="o"&&ne[1]==="n"&&h.isUpperAsciiLetter(ne.charCodeAt(2))}function ie(ne){return/^onDynamic/.test(ne)&&h.isUpperAsciiLetter(ne.charCodeAt(9))}})(re||(e.ProxyChannel=re={}));const ae=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function ue(_){if(Array.isArray(_))return _;if(_&&typeof _=="object"&&typeof _.toString=="function"){const W=_.toString();if(W!=="[object Object]")return W}return _}function pe(_){return Array.isArray(_)?_.map(ue):ue(_)}function $(_,W,q,K,ie,ne,F){F=pe(F);const j=ae[ie],V=j[K%j.length];let P=[`%c[${_}]%c[${String(W).padStart(7," ")}]%c[len: ${String(q).padStart(5," ")}]%c${String(K).padStart(5," ")} - ${ne}`,"color: darkgreen","color: grey","color: grey",`color: ${V}`];/\($/.test(ne)?(P=P.concat(F),P.push(")")):P.push(F),console.log.apply(console,P)}class Z{constructor(W,q){this._outgoingPrefix=W,this._incomingPrefix=q,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(W,q,K,ie,ne){this._totalOutgoing+=W,$(this._outgoingPrefix,this._totalOutgoing,W,q,K,ie,ne)}logIncoming(W,q,K,ie,ne){this._totalIncoming+=W,$(this._incomingPrefix,this._totalIncoming,W,q,K,ie,ne)}}e.IPCLogger=Z}),define(ce[90],de([0,1,61,8,13,21,86,7,5,2,27,59,57,60]),function(J,e,b,C,S,R,k,D,p,u,f,h,m,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0,D=we(D);class v extends a.ChannelServer{constructor(y){super({send:d=>{try{process.send?.(d.buffer.toString("base64"))}catch{}},onMessage:p.Event.fromNodeEventEmitter(process,"message",d=>S.VSBuffer.wrap(Buffer.from(d,"base64")))},y),process.once("disconnect",()=>this.dispose())}}e.Server=v;class I{constructor(y,d){this.modulePath=y,this.options=d,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new p.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const O=d&&d.timeout?d.timeout:6e4;this.disposeDelayer=new C.Delayer(O),this.child=null,this._client=null}getChannel(y){const d=this;return{call(O,E,i){return d.requestPromise(y,O,E,i)},listen(O,E){return d.requestEvent(y,O,E)}}}requestPromise(y,d,O,E=R.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(E.isCancellationRequested)return Promise.reject(D.canceled());this.disposeDelayer.cancel();const i=this.getCachedChannel(y),l=(0,C.createCancelablePromise)(t=>i.call(d,O,t)),r=E.onCancellationRequested(()=>l.cancel()),n=(0,u.toDisposable)(()=>l.cancel());return this.activeRequests.add(n),l.finally(()=>{r.dispose(),this.activeRequests.delete(n),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),l}requestEvent(y,d,O){if(!this.disposeDelayer)return p.Event.None;this.disposeDelayer.cancel();let E;const i=new p.Emitter({onWillAddFirstListener:()=>{E=this.getCachedChannel(y).listen(d,O)(i.fire,i),this.activeRequests.add(E)},onDidRemoveLastListener:()=>{this.activeRequests.delete(E),E.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return i.event}get client(){if(!this._client){const y=this.options&&this.options.args?this.options.args:[],d=Object.create(null);d.env={...(0,f.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(d.env={...d.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(d.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(d.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(d.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),d.execArgv===void 0&&(d.execArgv=process.execArgv.filter(o=>!/^--inspect(-brk)?=/.test(o)).filter(o=>!o.startsWith("--vscode-"))),(0,m.removeDangerousEnvVariables)(d.env),this.child=(0,b.fork)(this.modulePath,y,d);const O=new p.Emitter,i=p.Event.fromNodeEventEmitter(this.child,"message",o=>o)(o=>{if((0,k.isRemoteConsoleLog)(o)){(0,k.log)(o,`IPC Library: ${this.options.serverName}`);return}O.fire(S.VSBuffer.wrap(Buffer.from(o,"base64")))}),l=this.options.useQueue?(0,h.createQueuedSender)(this.child):this.child,r=o=>this.child&&this.child.connected&&l.send(o.buffer.toString("base64")),n=O.event,t={send:r,onMessage:n};this._client=new a.ChannelClient(t);const s=()=>this.disposeClient();process.once("exit",s),this.child.on("error",o=>console.warn('IPC "'+this.options.serverName+'" errored with '+o)),this.child.on("exit",(o,c)=>{process.removeListener("exit",s),i.dispose(),this.activeRequests.forEach(g=>(0,u.dispose)(g)),this.activeRequests.clear(),o!==0&&c!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+o+" and signal "+c),this.disposeDelayer?.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:o,signal:c})})}return this._client}getCachedChannel(y){let d=this.channels.get(y);return d||(d=this.client.getChannel(y),this.channels.set(y,d)),d}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer?.cancel(),this.disposeDelayer=void 0,this.disposeClient(),this.activeRequests.clear()}}e.Client=I}),define(ce[91],de([0,1,8,5,2,48,3]),function(J,e,b,C,S,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.StorageHint=void 0,e.isStorageItemsChangeEvent=p;var D;(function(m){m[m.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",m[m.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(D||(e.StorageHint=D={}));function p(m){const a=m;return a?.changed instanceof Map||a?.deleted instanceof Set}var u;(function(m){m[m.None=0]="None",m[m.Initialized=1]="Initialized",m[m.Closed=2]="Closed"})(u||(e.StorageState=u={}));class f extends S.Disposable{static{this.DEFAULT_FLUSH_DELAY=100}constructor(a,v=Object.create(null)){super(),this.database=a,this.options=v,this._onDidChangeStorage=this._register(new C.PauseableEmitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=u.None,this.cache=new Map,this.flushDelayer=this._register(new b.ThrottledDelayer(f.DEFAULT_FLUSH_DELAY)),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(a=>this.onDidChangeItemsExternal(a)))}onDidChangeItemsExternal(a){this._onDidChangeStorage.pause();try{a.changed?.forEach((v,I)=>this.acceptExternal(I,v)),a.deleted?.forEach(v=>this.acceptExternal(v,void 0))}finally{this._onDidChangeStorage.resume()}}acceptExternal(a,v){if(this.state===u.Closed)return;let I=!1;(0,k.isUndefinedOrNull)(v)?I=this.cache.delete(a):this.cache.get(a)!==v&&(this.cache.set(a,v),I=!0),I&&this._onDidChangeStorage.fire({key:a,external:!0})}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===u.None&&(this.state=u.Initialized,this.options.hint!==D.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(a,v){const I=this.cache.get(a);return(0,k.isUndefinedOrNull)(I)?v:I}getBoolean(a,v){const I=this.get(a);return(0,k.isUndefinedOrNull)(I)?v:I==="true"}getNumber(a,v){const I=this.get(a);return(0,k.isUndefinedOrNull)(I)?v:parseInt(I,10)}getObject(a,v){const I=this.get(a);return(0,k.isUndefinedOrNull)(I)?v:(0,R.parse)(I)}async set(a,v,I=!1){if(this.state===u.Closed)return;if((0,k.isUndefinedOrNull)(v))return this.delete(a,I);const w=(0,k.isObject)(v)||Array.isArray(v)?(0,R.stringify)(v):String(v);if(this.cache.get(a)!==w)return this.cache.set(a,w),this.pendingInserts.set(a,w),this.pendingDeletes.delete(a),this._onDidChangeStorage.fire({key:a,external:I}),this.doFlush()}async delete(a,v=!1){if(!(this.state===u.Closed||!this.cache.delete(a)))return this.pendingDeletes.has(a)||this.pendingDeletes.add(a),this.pendingInserts.delete(a),this._onDidChangeStorage.fire({key:a,external:v}),this.doFlush()}async optimize(){if(this.state!==u.Closed)return await this.flush(0),this.database.optimize()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=u.Closed;try{await this.doFlush(0)}catch{}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const a={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(a).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(a){if(!(this.state===u.Closed||this.pendingClose))return this.doFlush(a)}async doFlush(a){return this.options.hint===D.STORAGE_IN_MEMORY?this.flushPending():this.flushDelayer.trigger(()=>this.flushPending(),a)}async whenFlushed(){if(this.hasPending)return new Promise(a=>this.whenFlushedCallbacks.push(a))}isInMemory(){return this.options.hint===D.STORAGE_IN_MEMORY}}e.Storage=f;class h{constructor(){this.onDidChangeItemsExternal=C.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(a){a.insert?.forEach((v,I)=>this.items.set(I,v)),a.delete?.forEach(v=>this.items.delete(v))}async optimize(){}async close(){}}e.InMemoryStorageDatabase=h}),define(ce[92],de([0,1,93,7,4]),function(J,e,b,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Scanner=e.TokenType=void 0;var R;(function(f){f[f.LParen=0]="LParen",f[f.RParen=1]="RParen",f[f.Neg=2]="Neg",f[f.Eq=3]="Eq",f[f.NotEq=4]="NotEq",f[f.Lt=5]="Lt",f[f.LtEq=6]="LtEq",f[f.Gt=7]="Gt",f[f.GtEq=8]="GtEq",f[f.RegexOp=9]="RegexOp",f[f.RegexStr=10]="RegexStr",f[f.True=11]="True",f[f.False=12]="False",f[f.In=13]="In",f[f.Not=14]="Not",f[f.And=15]="And",f[f.Or=16]="Or",f[f.Str=17]="Str",f[f.QuotedStr=18]="QuotedStr",f[f.Error=19]="Error",f[f.EOF=20]="EOF"})(R||(e.TokenType=R={}));function k(...f){switch(f.length){case 1:return(0,S.localize)(1693,null,f[0]);case 2:return(0,S.localize)(1694,null,f[0],f[1]);case 3:return(0,S.localize)(1695,null,f[0],f[1],f[2]);default:return}}const D=(0,S.localize)(1696,null),p=(0,S.localize)(1697,null);class u{constructor(){this._input="",this._start=0,this._current=0,this._tokens=[],this._errors=[],this.stringRe=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(h){switch(h.type){case R.LParen:return"(";case R.RParen:return")";case R.Neg:return"!";case R.Eq:return h.isTripleEq?"===":"==";case R.NotEq:return h.isTripleEq?"!==":"!=";case R.Lt:return"<";case R.LtEq:return"<=";case R.Gt:return">=";case R.GtEq:return">=";case R.RegexOp:return"=~";case R.RegexStr:return h.lexeme;case R.True:return"true";case R.False:return"false";case R.In:return"in";case R.Not:return"not";case R.And:return"&&";case R.Or:return"||";case R.Str:return h.lexeme;case R.QuotedStr:return h.lexeme;case R.Error:return h.lexeme;case R.EOF:return"EOF";default:throw(0,C.illegalState)(`unhandled token type: ${JSON.stringify(h)}; have you forgotten to add a case?`)}}static{this._regexFlags=new Set(["i","g","s","m","y","u"].map(h=>h.charCodeAt(0)))}static{this._keywords=new Map([["not",R.Not],["in",R.In],["false",R.False],["true",R.True]])}get errors(){return this._errors}reset(h){return this._input=h,this._start=0,this._current=0,this._tokens=[],this._errors=[],this}scan(){for(;!this._isAtEnd();)switch(this._start=this._current,this._advance()){case b.CharCode.OpenParen:this._addToken(R.LParen);break;case b.CharCode.CloseParen:this._addToken(R.RParen);break;case b.CharCode.ExclamationMark:if(this._match(b.CharCode.Equals)){const m=this._match(b.CharCode.Equals);this._tokens.push({type:R.NotEq,offset:this._start,isTripleEq:m})}else this._addToken(R.Neg);break;case b.CharCode.SingleQuote:this._quotedString();break;case b.CharCode.Slash:this._regex();break;case b.CharCode.Equals:if(this._match(b.CharCode.Equals)){const m=this._match(b.CharCode.Equals);this._tokens.push({type:R.Eq,offset:this._start,isTripleEq:m})}else this._match(b.CharCode.Tilde)?this._addToken(R.RegexOp):this._error(k("==","=~"));break;case b.CharCode.LessThan:this._addToken(this._match(b.CharCode.Equals)?R.LtEq:R.Lt);break;case b.CharCode.GreaterThan:this._addToken(this._match(b.CharCode.Equals)?R.GtEq:R.Gt);break;case b.CharCode.Ampersand:this._match(b.CharCode.Ampersand)?this._addToken(R.And):this._error(k("&&"));break;case b.CharCode.Pipe:this._match(b.CharCode.Pipe)?this._addToken(R.Or):this._error(k("||"));break;case b.CharCode.Space:case b.CharCode.CarriageReturn:case b.CharCode.Tab:case b.CharCode.LineFeed:case b.CharCode.NoBreakSpace:break;default:this._string()}return this._start=this._current,this._addToken(R.EOF),Array.from(this._tokens)}_match(h){return this._isAtEnd()||this._input.charCodeAt(this._current)!==h?!1:(this._current++,!0)}_advance(){return this._input.charCodeAt(this._current++)}_peek(){return this._isAtEnd()?b.CharCode.Null:this._input.charCodeAt(this._current)}_addToken(h){this._tokens.push({type:h,offset:this._start})}_error(h){const m=this._start,a=this._input.substring(this._start,this._current),v={type:R.Error,offset:this._start,lexeme:a};this._errors.push({offset:m,lexeme:a,additionalInfo:h}),this._tokens.push(v)}_string(){this.stringRe.lastIndex=this._start;const h=this.stringRe.exec(this._input);if(h){this._current=this._start+h[0].length;const m=this._input.substring(this._start,this._current),a=u._keywords.get(m);a?this._addToken(a):this._tokens.push({type:R.Str,lexeme:m,offset:this._start})}}_quotedString(){for(;this._peek()!==b.CharCode.SingleQuote&&!this._isAtEnd();)this._advance();if(this._isAtEnd()){this._error(D);return}this._advance(),this._tokens.push({type:R.QuotedStr,lexeme:this._input.substring(this._start+1,this._current-1),offset:this._start+1})}_regex(){let h=this._current,m=!1,a=!1;for(;;){if(h>=this._input.length){this._current=h,this._error(p);return}const I=this._input.charCodeAt(h);if(m)m=!1;else if(I===b.CharCode.Slash&&!a){h++;break}else I===b.CharCode.OpenSquareBracket?a=!0:I===b.CharCode.Backslash?m=!0:I===b.CharCode.CloseSquareBracket&&(a=!1);h++}for(;h<this._input.length&&u._regexFlags.has(this._input.charCodeAt(h));)h++;this._current=h;const v=this._input.substring(this._start,this._current);this._tokens.push({type:R.RegexStr,lexeme:v,offset:this._start})}_isAtEnd(){return this._current>=this._input.length}}e.Scanner=u}),define(ce[94],de([0,1,84,55,14,15,36,16,12]),function(J,e,b,C,S,R,k,D,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractNativeEnvironmentService=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=void 0,e.parseExtensionHostDebugPort=f,e.parseDebugParams=h,e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=/^([^.]+\..+)[:=](.+)$/;class u{get appRoot(){return(0,R.dirname)(S.FileAccess.asFileUri("").fsPath)}get userHome(){return p.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return p.URI.file((0,R.join)(this.userDataPath,"User"))}get tmpDir(){return p.URI.file(this.paths.tmpDir)}get cacheHome(){return p.URI.file(this.userDataPath)}get stateResource(){return(0,D.joinPath)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:S.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,D.joinPath)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const a=(0,b.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,R.join)(this.userDataPath,"logs",a)}return p.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,D.joinPath)(p.URI.file((0,R.join)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,D.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,D.joinPath)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,D.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const a=k.env.VSCODE_PORTABLE;return a?p.URI.file((0,R.join)(a,"argv.json")):(0,D.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return p.URI.file((0,R.join)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const a=this.args["builtin-extensions-dir"];return a?(0,R.resolve)(a):(0,R.normalize)((0,R.join)(S.FileAccess.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const a=this.args["extensions-download-dir"];return a?p.URI.file((0,R.resolve)(a)):p.URI.file((0,R.join)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const a=this.args["extensions-dir"];if(a)return(0,R.resolve)(a);const v=k.env.VSCODE_EXTENSIONS;if(v)return v;const I=k.env.VSCODE_PORTABLE;return I?(0,R.join)(I,"extensions"):(0,D.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const a=this.args.extensionDevelopmentPath;if(Array.isArray(a))return a.map(v=>/^[^:/?#]+?:\/\//.test(v)?p.URI.parse(v):p.URI.file((0,R.normalize)(v)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(a=>a==="ui"||a==="workspace"||a==="web"?a:"workspace")}get extensionTestsLocationURI(){const a=this.args.extensionTestsPath;if(a)return/^[^:/?#]+?:\/\//.test(a)?p.URI.parse(a):p.URI.file((0,R.normalize)(a))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const a=this.args["disable-extension"];if(a){if(typeof a=="string")return[a];if(Array.isArray(a)&&a.length>0)return a}return!1}get debugExtensionHost(){return f(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!k.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(a=>!e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.test(a))}get extensionLogLevel(){const a=[];for(const v of this.args.log||[]){const I=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.exec(v);I&&I[1]&&I[2]&&a.push([I[1],I[2]])}return a.length?a:void 0}get serviceMachineIdResource(){return(0,D.joinPath)(p.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const a=k.env.VSCODE_PORTABLE;return a?p.URI.file((0,R.join)(a,"policy.json")):(0,D.joinPath)(this.userHome,this.productService.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(a){this.args.continueOn=a}get args(){return this._args}constructor(a,v,I){this._args=a,this.paths=v,this.productService=I,this.editSessionId=this.args.editSessionId}}e.AbstractNativeEnvironmentService=u,Pe([C.memoize],u.prototype,"appRoot",null),Pe([C.memoize],u.prototype,"userHome",null),Pe([C.memoize],u.prototype,"userDataPath",null),Pe([C.memoize],u.prototype,"appSettingsHome",null),Pe([C.memoize],u.prototype,"tmpDir",null),Pe([C.memoize],u.prototype,"cacheHome",null),Pe([C.memoize],u.prototype,"stateResource",null),Pe([C.memoize],u.prototype,"userRoamingDataHome",null),Pe([C.memoize],u.prototype,"userDataSyncHome",null),Pe([C.memoize],u.prototype,"sync",null),Pe([C.memoize],u.prototype,"machineSettingsResource",null),Pe([C.memoize],u.prototype,"workspaceStorageHome",null),Pe([C.memoize],u.prototype,"localHistoryHome",null),Pe([C.memoize],u.prototype,"keyboardLayoutResource",null),Pe([C.memoize],u.prototype,"argvResource",null),Pe([C.memoize],u.prototype,"isExtensionDevelopment",null),Pe([C.memoize],u.prototype,"untitledWorkspacesHome",null),Pe([C.memoize],u.prototype,"builtinExtensionsPath",null),Pe([C.memoize],u.prototype,"extensionsPath",null),Pe([C.memoize],u.prototype,"extensionDevelopmentLocationURI",null),Pe([C.memoize],u.prototype,"extensionDevelopmentKind",null),Pe([C.memoize],u.prototype,"extensionTestsLocationURI",null),Pe([C.memoize],u.prototype,"debugExtensionHost",null),Pe([C.memoize],u.prototype,"logLevel",null),Pe([C.memoize],u.prototype,"extensionLogLevel",null),Pe([C.memoize],u.prototype,"serviceMachineIdResource",null),Pe([C.memoize],u.prototype,"disableTelemetry",null),Pe([C.memoize],u.prototype,"disableWorkspaceTrust",null),Pe([C.memoize],u.prototype,"useInMemorySecretStorage",null),Pe([C.memoize],u.prototype,"policyFile",null);function f(m,a){return h(m["inspect-extensions"],m["inspect-brk-extensions"],5870,a,m.debugId,m.extensionEnvironment)}function h(m,a,v,I,w,y){const O=Number(a||m)||(I?null:v),E=O?!!a:!1;let i;if(y)try{i=JSON.parse(y)}catch{}return{port:O,break:E,debugId:w,env:i}}}),function(){function J(e,b,C){function S(k,D){const p=R(k,D),u=[p];return e.isAbsolute(p)||u.unshift(C),e.resolve(...u)}function R(k,D){process.env.VSCODE_DEV&&(D="code-oss-dev");const p=process.env.VSCODE_PORTABLE;if(p)return e.join(p,"user-data");let u=process.env.VSCODE_APPDATA;if(u)return e.join(u,D);const f=k["user-data-dir"];if(f)return f;switch(process.platform){case"win32":if(u=process.env.APPDATA,!u){const h=process.env.USERPROFILE;if(typeof h!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");u=e.join(h,"AppData","Roaming")}break;case"darwin":u=e.join(b.homedir(),"Library","Application Support");break;case"linux":u=process.env.XDG_CONFIG_HOME||e.join(b.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(u,D)}return{getUserDataPath:S}}if(typeof define=="function")define(ce[95],de([149,35,36]),function(e,b,C){return J(e,b,C.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),b=require("os");module.exports=J(e,b,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(ce[96],de([0,1,35,94,95]),function(J,e,b,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0,e.parsePtyHostDebugPort=k,e.parseSharedProcessDebugPort=D;class R extends C.AbstractNativeEnvironmentService{constructor(u,f){super(u,{homeDir:(0,b.homedir)(),tmpDir:(0,b.tmpdir)(),userDataDir:(0,S.getUserDataPath)(u,f.nameShort)},f)}}e.NativeEnvironmentService=R;function k(p,u){return(0,C.parseDebugParams)(p["inspect-ptyhost"],p["inspect-brk-ptyhost"],5877,u,p.extensionEnvironment)}function D(p,u){return(0,C.parseDebugParams)(p["inspect-sharedprocess"],p["inspect-brk-sharedprocess"],5879,u,p.extensionEnvironment)}}),define(ce[97],de([0,1,3,4]),function(J,e,b,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=S;function S(k,D,p,u){try{R(k,D,p,u)}catch(f){k.error(f?.message??f)}return D}function R(k,D,p,u){const f=(h,m,a)=>{const v=h[m];if((0,b.isString)(v)){const I=v,w=I.length;if(w>1&&I[0]==="%"&&I[w-1]==="%"){const y=I.substr(1,w-2);let d=p[y];d===void 0&&u&&(d=u[y]);const O=typeof d=="string"?d:d?.message,E=u?.[y],i=typeof E=="string"?E:E?.message;if(!O){i||k.warn(`[${D.name}]: ${(0,C.localize)(1814,null,y)}`);return}if(a&&(m==="title"||m==="category")&&i&&i!==O){const l={value:O,original:i};h[m]=l}else h[m]=O}}else if((0,b.isObject)(v))for(const I in v)v.hasOwnProperty(I)&&(I==="commands"?f(v,I,!0):f(v,I,a));else if(Array.isArray(v))for(let I=0;I<v.length;I++)f(v,I,a)};for(const h in D)D.hasOwnProperty(h)&&f(D,h)}}),define(ce[98],de([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0;const b={activeComment:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.activeComment.d.ts"},aiRelatedInformation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts"},aiTextSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiTextSearchProvider.d.ts"},aiTextSearchProviderNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiTextSearchProviderNew.d.ts"},attributableCoverage:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.attributableCoverage.d.ts"},authLearnMore:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authLearnMore.d.ts"},authSession:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts"},canonicalUriProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts"},chatParticipantAdditions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantAdditions.d.ts"},chatParticipantPrivate:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantPrivate.d.ts",version:2},chatProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts"},chatTab:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts"},chatVariableResolver:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariableResolver.d.ts"},codeActionAI:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts"},codeActionRanges:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionRanges.d.ts"},codiconDecoration:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts"},commentReactor:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReactor.d.ts"},commentReveal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReveal.d.ts"},commentThreadApplicability:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentThreadApplicability.d.ts"},commentingRangeHint:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentingRangeHint.d.ts"},commentsDraftState:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts"},contribAccessibilityHelpContent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribAccessibilityHelpContent.d.ts"},contribCommentEditorActionsMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts"},contribCommentPeekContext:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts"},contribCommentThreadAdditionalMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts"},contribCommentsViewThreadMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentsViewThreadMenus.d.ts"},contribDebugCreateConfiguration:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribDebugCreateConfiguration.d.ts"},contribDiffEditorGutterToolBarMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribDiffEditorGutterToolBarMenus.d.ts"},contribEditSessions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts"},contribEditorContentMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts"},contribIssueReporter:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribIssueReporter.d.ts"},contribLabelFormatterWorkspaceTooltip:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts"},contribMenuBarHome:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts"},contribMergeEditorMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts"},contribMultiDiffEditorMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMultiDiffEditorMenus.d.ts"},contribNotebookStaticPreloads:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts"},contribRemoteHelp:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts"},contribShareMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts"},contribSourceControlHistoryItemChangesMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemChangesMenu.d.ts"},contribSourceControlHistoryItemGroupMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemGroupMenu.d.ts"},contribSourceControlHistoryItemMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemMenu.d.ts"},contribSourceControlHistoryTitleMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryTitleMenu.d.ts"},contribSourceControlInputBoxMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts"},contribSourceControlTitleMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlTitleMenu.d.ts"},contribStatusBarItems:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts"},contribViewContainerTitle:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewContainerTitle.d.ts"},contribViewsRemote:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts"},contribViewsWelcome:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts"},createFileSystemWatcher:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts"},customEditorMove:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts"},debugVisualization:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugVisualization.d.ts"},defaultChatParticipant:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatParticipant.d.ts"},diffCommand:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts"},diffContentOptions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts"},documentFiltersExclusive:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts"},documentPaste:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts"},editSessionIdentityProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts"},editorHoverVerbosityLevel:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorHoverVerbosityLevel.d.ts"},editorInsets:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts"},embeddings:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.embeddings.d.ts"},extensionRuntime:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts"},extensionsAny:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts"},externalUriOpener:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts"},fileComments:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts"},fileSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts"},fileSearchProviderNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProviderNew.d.ts"},findFiles2:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2.d.ts"},findFiles2New:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2New.d.ts"},findTextInFiles:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts"},findTextInFilesNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFilesNew.d.ts"},fsChunks:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts"},idToken:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts"},inlineCompletionsAdditions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts"},inlineEdit:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineEdit.d.ts"},interactive:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts"},interactiveWindow:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts"},ipc:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts"},languageModelSystem:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageModelSystem.d.ts"},languageStatusText:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts"},lmTools:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.lmTools.d.ts",version:6},mappedEditsProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts"},multiDocumentHighlightProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.multiDocumentHighlightProvider.d.ts"},newSymbolNamesProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.newSymbolNamesProvider.d.ts"},notebookCellExecution:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecution.d.ts"},notebookCellExecutionState:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts"},notebookControllerAffinityHidden:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts"},notebookDeprecated:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts"},notebookExecution:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts"},notebookKernelSource:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts"},notebookLiveShare:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts"},notebookMessaging:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts"},notebookMime:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts"},notebookReplDocument:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookReplDocument.d.ts"},notebookVariableProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts"},portsAttributes:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts"},profileContentHandlers:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts"},quickDiffProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts"},quickInputButtonLocation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickInputButtonLocation.d.ts"},quickPickItemTooltip:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts"},quickPickSortByLabel:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts"},resolvers:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts"},scmActionButton:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts"},scmHistoryProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts"},scmMultiDiffEditor:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmMultiDiffEditor.d.ts"},scmSelectedProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts"},scmTextDocument:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts"},scmValidation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts"},shareProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts"},showLocal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts"},speech:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts"},tabInputMultiDiff:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputMultiDiff.d.ts"},tabInputTextMerge:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts"},taskPresentationGroup:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts"},telemetry:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts"},terminalDataWriteEvent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts"},terminalDimensions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts"},terminalExecuteCommandEvent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts"},terminalQuickFixProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts"},terminalSelection:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts"},testObserver:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts"},testRelatedCode:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testRelatedCode.d.ts"},textSearchCompleteNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchCompleteNew.d.ts"},textSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts"},textSearchProviderNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProviderNew.d.ts"},timeline:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts"},tokenInformation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts"},treeViewActiveItem:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts"},treeViewMarkdownMessage:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts"},treeViewReveal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts"},tunnelFactory:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts"},tunnels:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts"},workspaceTrust:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"}};e.allApiProposals=Object.freeze(b)}),define(ce[51],de([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class b{constructor(S,R=[],k=!1){this.ctor=S,this.staticArguments=R,this.supportsDelayedInstantiation=k}}e.SyncDescriptor=b}),define(ce[99],de([0,1,51]),function(J,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.registerSingleton=R,e.getSingletonServiceDescriptors=k;const C=[];var S;(function(D){D[D.Eager=0]="Eager",D[D.Delayed=1]="Delayed"})(S||(e.InstantiationType=S={}));function R(D,p,u){p instanceof b.SyncDescriptor||(p=new b.SyncDescriptor(p,[],!!u)),C.push([D,p])}function k(){return C}}),define(ce[100],de([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class b{constructor(R,k){this.key=R,this.data=k,this.incoming=new Map,this.outgoing=new Map}}e.Node=b;class C{constructor(R){this._hashFn=R,this._nodes=new Map}roots(){const R=[];for(const k of this._nodes.values())k.outgoing.size===0&&R.push(k);return R}insertEdge(R,k){const D=this.lookupOrInsertNode(R),p=this.lookupOrInsertNode(k);D.outgoing.set(p.key,p),p.incoming.set(D.key,D)}removeNode(R){const k=this._hashFn(R);this._nodes.delete(k);for(const D of this._nodes.values())D.outgoing.delete(k),D.incoming.delete(k)}lookupOrInsertNode(R){const k=this._hashFn(R);let D=this._nodes.get(k);return D||(D=new b(k,R),this._nodes.set(k,D)),D}lookup(R){return this._nodes.get(this._hashFn(R))}isEmpty(){return this._nodes.size===0}toString(){const R=[];for(const[k,D]of this._nodes)R.push(`${k}
	(-> incoming)[${[...D.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...D.outgoing.keys()].join(",")}]
`);return R.join(`
`)}findCycleSlow(){for(const[R,k]of this._nodes){const D=new Set([R]),p=this._findCycle(k,D);if(p)return p}}_findCycle(R,k){for(const[D,p]of R.outgoing){if(k.has(D))return[...k,D].join(" -> ");k.add(D);const u=this._findCycle(p,k);if(u)return u;k.delete(D)}}}e.Graph=C}),define(ce[30],de([0,1,3,12,10]),function(J,e,b,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.IConfigurationService=void 0,e.isConfigurationOverrides=R,e.isConfigurationUpdateOverrides=k,e.ConfigurationTargetToString=p,e.isConfigured=u,e.toValuesTree=f,e.addToValueTree=h,e.removeFromValueTree=m,e.getConfigurationValue=v,e.merge=I,e.getLanguageTagSettingPlainKey=w,b=we(b),e.IConfigurationService=(0,S.createDecorator)("configurationService");function R(y){return y&&typeof y=="object"&&(!y.overrideIdentifier||typeof y.overrideIdentifier=="string")&&(!y.resource||y.resource instanceof C.URI)}function k(y){return y&&typeof y=="object"&&(!y.overrideIdentifiers||Array.isArray(y.overrideIdentifiers))&&!y.overrideIdentifier&&(!y.resource||y.resource instanceof C.URI)}var D;(function(y){y[y.APPLICATION=1]="APPLICATION",y[y.USER=2]="USER",y[y.USER_LOCAL=3]="USER_LOCAL",y[y.USER_REMOTE=4]="USER_REMOTE",y[y.WORKSPACE=5]="WORKSPACE",y[y.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",y[y.DEFAULT=7]="DEFAULT",y[y.MEMORY=8]="MEMORY"})(D||(e.ConfigurationTarget=D={}));function p(y){switch(y){case D.APPLICATION:return"APPLICATION";case D.USER:return"USER";case D.USER_LOCAL:return"USER_LOCAL";case D.USER_REMOTE:return"USER_REMOTE";case D.WORKSPACE:return"WORKSPACE";case D.WORKSPACE_FOLDER:return"WORKSPACE_FOLDER";case D.DEFAULT:return"DEFAULT";case D.MEMORY:return"MEMORY"}}function u(y){return y.applicationValue!==void 0||y.userValue!==void 0||y.userLocalValue!==void 0||y.userRemoteValue!==void 0||y.workspaceValue!==void 0||y.workspaceFolderValue!==void 0}function f(y,d){const O=Object.create(null);for(const E in y)h(O,E,y[E],d);return O}function h(y,d,O,E){const i=d.split("."),l=i.pop();let r=y;for(let n=0;n<i.length;n++){const t=i[n];let s=r[t];switch(typeof s){case"undefined":s=r[t]=Object.create(null);break;case"object":if(s===null){E(`Ignoring ${d} as ${i.slice(0,n+1).join(".")} is null`);return}break;default:E(`Ignoring ${d} as ${i.slice(0,n+1).join(".")} is ${JSON.stringify(s)}`);return}r=s}if(typeof r=="object"&&r!==null)try{r[l]=O}catch{E(`Ignoring ${d} as ${i.join(".")} is ${JSON.stringify(r)}`)}else E(`Ignoring ${d} as ${i.join(".")} is ${JSON.stringify(r)}`)}function m(y,d){const O=d.split(".");a(y,O)}function a(y,d){const O=d.shift();if(d.length===0){delete y[O];return}if(Object.keys(y).indexOf(O)!==-1){const E=y[O];typeof E=="object"&&!Array.isArray(E)&&(a(E,d),Object.keys(E).length===0&&delete y[O])}}function v(y,d,O){function E(r,n){let t=r;for(const s of n){if(typeof t!="object"||t===null)return;t=t[s]}return t}const i=d.split("."),l=E(y,i);return typeof l>"u"?O:l}function I(y,d,O){Object.keys(d).forEach(E=>{E!=="__proto__"&&(E in y?b.isObject(y[E])&&b.isObject(d[E])?I(y[E],d[E],O):O&&(y[E]=d[E]):y[E]=d[E])})}function w(y){return y.replace(/[\[\]]/g,"")}}),define(ce[101],de([0,1,93,11,31,92,10,4,7]),function(J,e,b,C,S,R,k,D,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.ContextKeyExpr=e.Parser=e.ContextKeyExprType=void 0,e.setConstant=f,e.validateWhenClauses=n,e.expressionsAreEqualWithConstantSubstitution=t,e.implies=ne;const u=new Map;u.set("false",!1),u.set("true",!0),u.set("isMac",C.isMacintosh),u.set("isLinux",C.isLinux),u.set("isWindows",C.isWindows),u.set("isWeb",C.isWeb),u.set("isMacNative",C.isMacintosh&&!C.isWeb),u.set("isEdge",C.isEdge),u.set("isFirefox",C.isFirefox),u.set("isChrome",C.isChrome),u.set("isSafari",C.isSafari);function f(V,P){if(u.get(V)!==void 0)throw(0,p.illegalArgument)("contextkey.setConstant(k, v) invoked with already set constant `k`");u.set(V,P)}const h=Object.prototype.hasOwnProperty;var m;(function(V){V[V.False=0]="False",V[V.True=1]="True",V[V.Defined=2]="Defined",V[V.Not=3]="Not",V[V.Equals=4]="Equals",V[V.NotEquals=5]="NotEquals",V[V.And=6]="And",V[V.Regex=7]="Regex",V[V.NotRegex=8]="NotRegex",V[V.Or=9]="Or",V[V.In=10]="In",V[V.NotIn=11]="NotIn",V[V.Greater=12]="Greater",V[V.GreaterEquals=13]="GreaterEquals",V[V.Smaller=14]="Smaller",V[V.SmallerEquals=15]="SmallerEquals"})(m||(e.ContextKeyExprType=m={}));const a={regexParsingWithErrorRecovery:!0},v=(0,D.localize)(1673,null),I=(0,D.localize)(1674,null),w=(0,D.localize)(1675,null),y=(0,D.localize)(1676,null),d=(0,D.localize)(1677,null),O=(0,D.localize)(1678,null),E=(0,D.localize)(1679,null),i=(0,D.localize)(1680,null);class l{static{this._parseError=new Error}get lexingErrors(){return this._scanner.errors}get parsingErrors(){return this._parsingErrors}constructor(P=a){this._config=P,this._scanner=new R.Scanner,this._tokens=[],this._current=0,this._parsingErrors=[],this._flagsGYRe=/g|y/g}parse(P){if(P===""){this._parsingErrors.push({message:v,offset:0,lexeme:"",additionalInfo:I});return}this._tokens=this._scanner.reset(P).scan(),this._current=0,this._parsingErrors=[];try{const x=this._expr();if(!this._isAtEnd()){const X=this._peek(),Y=X.type===R.TokenType.Str?O:void 0;throw this._parsingErrors.push({message:d,offset:X.offset,lexeme:R.Scanner.getLexeme(X),additionalInfo:Y}),l._parseError}return x}catch(x){if(x!==l._parseError)throw x;return}}_expr(){return this._or()}_or(){const P=[this._and()];for(;this._matchOne(R.TokenType.Or);){const x=this._and();P.push(x)}return P.length===1?P[0]:r.or(...P)}_and(){const P=[this._term()];for(;this._matchOne(R.TokenType.And);){const x=this._term();P.push(x)}return P.length===1?P[0]:r.and(...P)}_term(){if(this._matchOne(R.TokenType.Neg)){const P=this._peek();switch(P.type){case R.TokenType.True:return this._advance(),o.INSTANCE;case R.TokenType.False:return this._advance(),c.INSTANCE;case R.TokenType.LParen:{this._advance();const x=this._expr();return this._consume(R.TokenType.RParen,y),x?.negate()}case R.TokenType.Str:return this._advance(),M.create(P.lexeme);default:throw this._errExpectedButGot("KEY | true | false | '(' expression ')'",P)}}return this._primary()}_primary(){const P=this._peek();switch(P.type){case R.TokenType.True:return this._advance(),r.true();case R.TokenType.False:return this._advance(),r.false();case R.TokenType.LParen:{this._advance();const x=this._expr();return this._consume(R.TokenType.RParen,y),x}case R.TokenType.Str:{const x=P.lexeme;if(this._advance(),this._matchOne(R.TokenType.RegexOp)){const Y=this._peek();if(!this._config.regexParsingWithErrorRecovery){if(this._advance(),Y.type!==R.TokenType.RegexStr)throw this._errExpectedButGot("REGEX",Y);const G=Y.lexeme,U=G.lastIndexOf("/"),H=U===G.length-1?void 0:this._removeFlagsGY(G.substring(U+1));let se;try{se=new RegExp(G.substring(1,U),H)}catch{throw this._errExpectedButGot("REGEX",Y)}return pe.create(x,se)}switch(Y.type){case R.TokenType.RegexStr:case R.TokenType.Error:{const G=[Y.lexeme];this._advance();let U=this._peek(),H=0;for(let fe=0;fe<Y.lexeme.length;fe++)Y.lexeme.charCodeAt(fe)===b.CharCode.OpenParen?H++:Y.lexeme.charCodeAt(fe)===b.CharCode.CloseParen&&H--;for(;!this._isAtEnd()&&U.type!==R.TokenType.And&&U.type!==R.TokenType.Or;){switch(U.type){case R.TokenType.LParen:H++;break;case R.TokenType.RParen:H--;break;case R.TokenType.RegexStr:case R.TokenType.QuotedStr:for(let fe=0;fe<U.lexeme.length;fe++)U.lexeme.charCodeAt(fe)===b.CharCode.OpenParen?H++:Y.lexeme.charCodeAt(fe)===b.CharCode.CloseParen&&H--}if(H<0)break;G.push(R.Scanner.getLexeme(U)),this._advance(),U=this._peek()}const se=G.join(""),le=se.lastIndexOf("/"),he=le===se.length-1?void 0:this._removeFlagsGY(se.substring(le+1));let Se;try{Se=new RegExp(se.substring(1,le),he)}catch{throw this._errExpectedButGot("REGEX",Y)}return r.regex(x,Se)}case R.TokenType.QuotedStr:{const G=Y.lexeme;this._advance();let U=null;if(!(0,S.isFalsyOrWhitespace)(G)){const H=G.indexOf("/"),se=G.lastIndexOf("/");if(H!==se&&H>=0){const le=G.slice(H+1,se),he=G[se+1]==="i"?"i":"";try{U=new RegExp(le,he)}catch{throw this._errExpectedButGot("REGEX",Y)}}}if(U===null)throw this._errExpectedButGot("REGEX",Y);return pe.create(x,U)}default:throw this._errExpectedButGot("REGEX",this._peek())}}if(this._matchOne(R.TokenType.Not)){this._consume(R.TokenType.In,w);const Y=this._value();return r.notIn(x,Y)}switch(this._peek().type){case R.TokenType.Eq:{this._advance();const Y=this._value();if(this._previous().type===R.TokenType.QuotedStr)return r.equals(x,Y);switch(Y){case"true":return r.has(x);case"false":return r.not(x);default:return r.equals(x,Y)}}case R.TokenType.NotEq:{this._advance();const Y=this._value();if(this._previous().type===R.TokenType.QuotedStr)return r.notEquals(x,Y);switch(Y){case"true":return r.not(x);case"false":return r.has(x);default:return r.notEquals(x,Y)}}case R.TokenType.Lt:return this._advance(),ae.create(x,this._value());case R.TokenType.LtEq:return this._advance(),ue.create(x,this._value());case R.TokenType.Gt:return this._advance(),Q.create(x,this._value());case R.TokenType.GtEq:return this._advance(),re.create(x,this._value());case R.TokenType.In:return this._advance(),r.in(x,this._value());default:return r.has(x)}}case R.TokenType.EOF:throw this._parsingErrors.push({message:E,offset:P.offset,lexeme:"",additionalInfo:i}),l._parseError;default:throw this._errExpectedButGot(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this._peek())}}_value(){const P=this._peek();switch(P.type){case R.TokenType.Str:case R.TokenType.QuotedStr:return this._advance(),P.lexeme;case R.TokenType.True:return this._advance(),"true";case R.TokenType.False:return this._advance(),"false";case R.TokenType.In:return this._advance(),"in";default:return""}}_removeFlagsGY(P){return P.replaceAll(this._flagsGYRe,"")}_previous(){return this._tokens[this._current-1]}_matchOne(P){return this._check(P)?(this._advance(),!0):!1}_advance(){return this._isAtEnd()||this._current++,this._previous()}_consume(P,x){if(this._check(P))return this._advance();throw this._errExpectedButGot(x,this._peek())}_errExpectedButGot(P,x,X){const Y=(0,D.localize)(1681,null,P,R.Scanner.getLexeme(x)),G=x.offset,U=R.Scanner.getLexeme(x);return this._parsingErrors.push({message:Y,offset:G,lexeme:U,additionalInfo:X}),l._parseError}_check(P){return this._peek().type===P}_peek(){return this._tokens[this._current]}_isAtEnd(){return this._peek().type===R.TokenType.EOF}}e.Parser=l;class r{static false(){return o.INSTANCE}static true(){return c.INSTANCE}static has(P){return g.create(P)}static equals(P,x){return T.create(P,x)}static notEquals(P,x){return L.create(P,x)}static regex(P,x){return pe.create(P,x)}static in(P,x){return N.create(P,x)}static notIn(P,x){return A.create(P,x)}static not(P){return M.create(P)}static and(...P){return _.create(P,null,!0)}static or(...P){return W.create(P,null,!0)}static greater(P,x){return Q.create(P,x)}static greaterEquals(P,x){return re.create(P,x)}static smaller(P,x){return ae.create(P,x)}static smallerEquals(P,x){return ue.create(P,x)}static{this._parser=new l({regexParsingWithErrorRecovery:!1})}static deserialize(P){return P==null?void 0:this._parser.parse(P)}}e.ContextKeyExpr=r;function n(V){const P=new l({regexParsingWithErrorRecovery:!1});return V.map(x=>(P.parse(x),P.lexingErrors.length>0?P.lexingErrors.map(X=>({errorMessage:X.additionalInfo?(0,D.localize)(1682,null,X.additionalInfo):(0,D.localize)(1683,null),offset:X.offset,length:X.lexeme.length})):P.parsingErrors.length>0?P.parsingErrors.map(X=>({errorMessage:X.additionalInfo?`${X.message}. ${X.additionalInfo}`:X.message,offset:X.offset,length:X.lexeme.length})):[]))}function t(V,P){const x=V?V.substituteConstants():void 0,X=P?P.substituteConstants():void 0;return!x&&!X?!0:!x||!X?!1:x.equals(X)}function s(V,P){return V.cmp(P)}class o{static{this.INSTANCE=new o}constructor(){this.type=m.False}cmp(P){return this.type-P.type}equals(P){return P.type===this.type}substituteConstants(){return this}evaluate(P){return!1}serialize(){return"false"}keys(){return[]}map(P){return this}negate(){return c.INSTANCE}}e.ContextKeyFalseExpr=o;class c{static{this.INSTANCE=new c}constructor(){this.type=m.True}cmp(P){return this.type-P.type}equals(P){return P.type===this.type}substituteConstants(){return this}evaluate(P){return!0}serialize(){return"true"}keys(){return[]}map(P){return this}negate(){return o.INSTANCE}}e.ContextKeyTrueExpr=c;class g{static create(P,x=null){const X=u.get(P);return typeof X=="boolean"?X?c.INSTANCE:o.INSTANCE:new g(P,x)}constructor(P,x){this.key=P,this.negated=x,this.type=m.Defined}cmp(P){return P.type!==this.type?this.type-P.type:K(this.key,P.key)}equals(P){return P.type===this.type?this.key===P.key:!1}substituteConstants(){const P=u.get(this.key);return typeof P=="boolean"?P?c.INSTANCE:o.INSTANCE:this}evaluate(P){return!!P.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(P){return P.mapDefined(this.key)}negate(){return this.negated||(this.negated=M.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=g;class T{static create(P,x,X=null){if(typeof x=="boolean")return x?g.create(P,X):M.create(P,X);const Y=u.get(P);return typeof Y=="boolean"?x===(Y?"true":"false")?c.INSTANCE:o.INSTANCE:new T(P,x,X)}constructor(P,x,X){this.key=P,this.value=x,this.negated=X,this.type=m.Equals}cmp(P){return P.type!==this.type?this.type-P.type:ie(this.key,this.value,P.key,P.value)}equals(P){return P.type===this.type?this.key===P.key&&this.value===P.value:!1}substituteConstants(){const P=u.get(this.key);if(typeof P=="boolean"){const x=P?"true":"false";return this.value===x?c.INSTANCE:o.INSTANCE}return this}evaluate(P){return P.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(P){return P.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=L.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=T;class N{static create(P,x){return new N(P,x)}constructor(P,x){this.key=P,this.valueKey=x,this.type=m.In,this.negated=null}cmp(P){return P.type!==this.type?this.type-P.type:ie(this.key,this.valueKey,P.key,P.valueKey)}equals(P){return P.type===this.type?this.key===P.key&&this.valueKey===P.valueKey:!1}substituteConstants(){return this}evaluate(P){const x=P.getValue(this.valueKey),X=P.getValue(this.key);return Array.isArray(x)?x.includes(X):typeof X=="string"&&typeof x=="object"&&x!==null?h.call(x,X):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(P){return P.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=A.create(this.key,this.valueKey)),this.negated}}e.ContextKeyInExpr=N;class A{static create(P,x){return new A(P,x)}constructor(P,x){this.key=P,this.valueKey=x,this.type=m.NotIn,this._negated=N.create(P,x)}cmp(P){return P.type!==this.type?this.type-P.type:this._negated.cmp(P._negated)}equals(P){return P.type===this.type?this._negated.equals(P._negated):!1}substituteConstants(){return this}evaluate(P){return!this._negated.evaluate(P)}serialize(){return`${this.key} not in '${this.valueKey}'`}keys(){return this._negated.keys()}map(P){return P.mapNotIn(this.key,this.valueKey)}negate(){return this._negated}}e.ContextKeyNotInExpr=A;class L{static create(P,x,X=null){if(typeof x=="boolean")return x?M.create(P,X):g.create(P,X);const Y=u.get(P);return typeof Y=="boolean"?x===(Y?"true":"false")?o.INSTANCE:c.INSTANCE:new L(P,x,X)}constructor(P,x,X){this.key=P,this.value=x,this.negated=X,this.type=m.NotEquals}cmp(P){return P.type!==this.type?this.type-P.type:ie(this.key,this.value,P.key,P.value)}equals(P){return P.type===this.type?this.key===P.key&&this.value===P.value:!1}substituteConstants(){const P=u.get(this.key);if(typeof P=="boolean"){const x=P?"true":"false";return this.value===x?o.INSTANCE:c.INSTANCE}return this}evaluate(P){return P.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(P){return P.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=T.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=L;class M{static create(P,x=null){const X=u.get(P);return typeof X=="boolean"?X?o.INSTANCE:c.INSTANCE:new M(P,x)}constructor(P,x){this.key=P,this.negated=x,this.type=m.Not}cmp(P){return P.type!==this.type?this.type-P.type:K(this.key,P.key)}equals(P){return P.type===this.type?this.key===P.key:!1}substituteConstants(){const P=u.get(this.key);return typeof P=="boolean"?P?o.INSTANCE:c.INSTANCE:this}evaluate(P){return!P.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(P){return P.mapNot(this.key)}negate(){return this.negated||(this.negated=g.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=M;function B(V,P){if(typeof V=="string"){const x=parseFloat(V);isNaN(x)||(V=x)}return typeof V=="string"||typeof V=="number"?P(V):o.INSTANCE}class Q{static create(P,x,X=null){return B(x,Y=>new Q(P,Y,X))}constructor(P,x,X){this.key=P,this.value=x,this.negated=X,this.type=m.Greater}cmp(P){return P.type!==this.type?this.type-P.type:ie(this.key,this.value,P.key,P.value)}equals(P){return P.type===this.type?this.key===P.key&&this.value===P.value:!1}substituteConstants(){return this}evaluate(P){return typeof this.value=="string"?!1:parseFloat(P.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(P){return P.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=ue.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=Q;class re{static create(P,x,X=null){return B(x,Y=>new re(P,Y,X))}constructor(P,x,X){this.key=P,this.value=x,this.negated=X,this.type=m.GreaterEquals}cmp(P){return P.type!==this.type?this.type-P.type:ie(this.key,this.value,P.key,P.value)}equals(P){return P.type===this.type?this.key===P.key&&this.value===P.value:!1}substituteConstants(){return this}evaluate(P){return typeof this.value=="string"?!1:parseFloat(P.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(P){return P.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=ae.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=re;class ae{static create(P,x,X=null){return B(x,Y=>new ae(P,Y,X))}constructor(P,x,X){this.key=P,this.value=x,this.negated=X,this.type=m.Smaller}cmp(P){return P.type!==this.type?this.type-P.type:ie(this.key,this.value,P.key,P.value)}equals(P){return P.type===this.type?this.key===P.key&&this.value===P.value:!1}substituteConstants(){return this}evaluate(P){return typeof this.value=="string"?!1:parseFloat(P.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(P){return P.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=re.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=ae;class ue{static create(P,x,X=null){return B(x,Y=>new ue(P,Y,X))}constructor(P,x,X){this.key=P,this.value=x,this.negated=X,this.type=m.SmallerEquals}cmp(P){return P.type!==this.type?this.type-P.type:ie(this.key,this.value,P.key,P.value)}equals(P){return P.type===this.type?this.key===P.key&&this.value===P.value:!1}substituteConstants(){return this}evaluate(P){return typeof this.value=="string"?!1:parseFloat(P.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(P){return P.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=Q.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=ue;class pe{static create(P,x){return new pe(P,x)}constructor(P,x){this.key=P,this.regexp=x,this.type=m.Regex,this.negated=null}cmp(P){if(P.type!==this.type)return this.type-P.type;if(this.key<P.key)return-1;if(this.key>P.key)return 1;const x=this.regexp?this.regexp.source:"",X=P.regexp?P.regexp.source:"";return x<X?-1:x>X?1:0}equals(P){if(P.type===this.type){const x=this.regexp?this.regexp.source:"",X=P.regexp?P.regexp.source:"";return this.key===P.key&&x===X}return!1}substituteConstants(){return this}evaluate(P){const x=P.getValue(this.key);return this.regexp?this.regexp.test(x):!1}serialize(){const P=this.regexp?`/${this.regexp.source}/${this.regexp.flags}`:"/invalid/";return`${this.key} =~ ${P}`}keys(){return[this.key]}map(P){return P.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=$.create(this)),this.negated}}e.ContextKeyRegexExpr=pe;class ${static create(P){return new $(P)}constructor(P){this._actual=P,this.type=m.NotRegex}cmp(P){return P.type!==this.type?this.type-P.type:this._actual.cmp(P._actual)}equals(P){return P.type===this.type?this._actual.equals(P._actual):!1}substituteConstants(){return this}evaluate(P){return!this._actual.evaluate(P)}serialize(){return`!(${this._actual.serialize()})`}keys(){return this._actual.keys()}map(P){return new $(this._actual.map(P))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=$;function Z(V){let P=null;for(let x=0,X=V.length;x<X;x++){const Y=V[x].substituteConstants();if(V[x]!==Y&&P===null){P=[];for(let G=0;G<x;G++)P[G]=V[G]}P!==null&&(P[x]=Y)}return P===null?V:P}class _{static create(P,x,X){return _._normalizeArr(P,x,X)}constructor(P,x){this.expr=P,this.negated=x,this.type=m.And}cmp(P){if(P.type!==this.type)return this.type-P.type;if(this.expr.length<P.expr.length)return-1;if(this.expr.length>P.expr.length)return 1;for(let x=0,X=this.expr.length;x<X;x++){const Y=s(this.expr[x],P.expr[x]);if(Y!==0)return Y}return 0}equals(P){if(P.type===this.type){if(this.expr.length!==P.expr.length)return!1;for(let x=0,X=this.expr.length;x<X;x++)if(!this.expr[x].equals(P.expr[x]))return!1;return!0}return!1}substituteConstants(){const P=Z(this.expr);return P===this.expr?this:_.create(P,this.negated,!1)}evaluate(P){for(let x=0,X=this.expr.length;x<X;x++)if(!this.expr[x].evaluate(P))return!1;return!0}static _normalizeArr(P,x,X){const Y=[];let G=!1;for(const U of P)if(U){if(U.type===m.True){G=!0;continue}if(U.type===m.False)return o.INSTANCE;if(U.type===m.And){Y.push(...U.expr);continue}Y.push(U)}if(Y.length===0&&G)return c.INSTANCE;if(Y.length!==0){if(Y.length===1)return Y[0];Y.sort(s);for(let U=1;U<Y.length;U++)Y[U-1].equals(Y[U])&&(Y.splice(U,1),U--);if(Y.length===1)return Y[0];for(;Y.length>1;){const U=Y[Y.length-1];if(U.type!==m.Or)break;Y.pop();const H=Y.pop(),se=Y.length===0,le=W.create(U.expr.map(he=>_.create([he,H],null,X)),null,se);le&&(Y.push(le),Y.sort(s))}if(Y.length===1)return Y[0];if(X){for(let U=0;U<Y.length;U++)for(let H=U+1;H<Y.length;H++)if(Y[U].negate().equals(Y[H]))return o.INSTANCE;if(Y.length===1)return Y[0]}return new _(Y,x)}}serialize(){return this.expr.map(P=>P.serialize()).join(" && ")}keys(){const P=[];for(const x of this.expr)P.push(...x.keys());return P}map(P){return new _(this.expr.map(x=>x.map(P)),null)}negate(){if(!this.negated){const P=[];for(const x of this.expr)P.push(x.negate());this.negated=W.create(P,this,!0)}return this.negated}}e.ContextKeyAndExpr=_;class W{static create(P,x,X){return W._normalizeArr(P,x,X)}constructor(P,x){this.expr=P,this.negated=x,this.type=m.Or}cmp(P){if(P.type!==this.type)return this.type-P.type;if(this.expr.length<P.expr.length)return-1;if(this.expr.length>P.expr.length)return 1;for(let x=0,X=this.expr.length;x<X;x++){const Y=s(this.expr[x],P.expr[x]);if(Y!==0)return Y}return 0}equals(P){if(P.type===this.type){if(this.expr.length!==P.expr.length)return!1;for(let x=0,X=this.expr.length;x<X;x++)if(!this.expr[x].equals(P.expr[x]))return!1;return!0}return!1}substituteConstants(){const P=Z(this.expr);return P===this.expr?this:W.create(P,this.negated,!1)}evaluate(P){for(let x=0,X=this.expr.length;x<X;x++)if(this.expr[x].evaluate(P))return!0;return!1}static _normalizeArr(P,x,X){let Y=[],G=!1;if(P){for(let U=0,H=P.length;U<H;U++){const se=P[U];if(se){if(se.type===m.False){G=!0;continue}if(se.type===m.True)return c.INSTANCE;if(se.type===m.Or){Y=Y.concat(se.expr);continue}Y.push(se)}}if(Y.length===0&&G)return o.INSTANCE;Y.sort(s)}if(Y.length!==0){if(Y.length===1)return Y[0];for(let U=1;U<Y.length;U++)Y[U-1].equals(Y[U])&&(Y.splice(U,1),U--);if(Y.length===1)return Y[0];if(X){for(let U=0;U<Y.length;U++)for(let H=U+1;H<Y.length;H++)if(Y[U].negate().equals(Y[H]))return c.INSTANCE;if(Y.length===1)return Y[0]}return new W(Y,x)}}serialize(){return this.expr.map(P=>P.serialize()).join(" || ")}keys(){const P=[];for(const x of this.expr)P.push(...x.keys());return P}map(P){return new W(this.expr.map(x=>x.map(P)),null)}negate(){if(!this.negated){const P=[];for(const x of this.expr)P.push(x.negate());for(;P.length>1;){const x=P.shift(),X=P.shift(),Y=[];for(const G of j(x))for(const U of j(X))Y.push(_.create([G,U],null,!1));P.unshift(W.create(Y,null,!1))}this.negated=W.create(P,this,!0)}return this.negated}}e.ContextKeyOrExpr=W;class q extends g{static{this._info=[]}static all(){return q._info.values()}constructor(P,x,X){super(P,null),this._defaultValue=x,typeof X=="object"?q._info.push({...X,key:P}):X!==!0&&q._info.push({key:P,description:X,type:x!=null?typeof x:void 0})}bindTo(P){return P.createKey(this.key,this._defaultValue)}getValue(P){return P.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(P){return T.create(this.key,P)}notEqualsTo(P){return L.create(this.key,P)}}e.RawContextKey=q,e.IContextKeyService=(0,k.createDecorator)("contextKeyService");function K(V,P){return V<P?-1:V>P?1:0}function ie(V,P,x,X){return V<x?-1:V>x?1:P<X?-1:P>X?1:0}function ne(V,P){if(V.type===m.False||P.type===m.True)return!0;if(V.type===m.Or)return P.type===m.Or?F(V.expr,P.expr):!1;if(P.type===m.Or){for(const x of P.expr)if(ne(V,x))return!0;return!1}if(V.type===m.And){if(P.type===m.And)return F(P.expr,V.expr);for(const x of V.expr)if(ne(x,P))return!0;return!1}return V.equals(P)}function F(V,P){let x=0,X=0;for(;x<V.length&&X<P.length;){const Y=V[x].cmp(P[X]);if(Y<0)return!1;Y===0&&x++,X++}return x===V.length}function j(V){return V.type===m.Or?V.expr:[V]}}),define(ce[62],de([0,1,10]),function(J,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=(0,b.createDecorator)("downloadService")}),define(ce[17],de([0,1,10]),function(J,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,b.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,b.refineServiceDecorator)(e.IEnvironmentService)}),define(ce[63],de([0,1,13,7,4,9]),function(J,e,b,C,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=k;async function k(f,h,m,a,v,I){let w;try{await D(f,h,m,a,v,I)}catch(y){w=y}finally{w&&v.errorTransformer&&(w=v.errorTransformer(w)),typeof w<"u"&&m.error(w),m.end()}}async function D(f,h,m,a,v,I){p(I);const w=await f.open(h,{create:!1});try{p(I);let y=0,d=0,O=v&&typeof v.length=="number"?v.length:void 0,E=b.VSBuffer.alloc(Math.min(v.bufferSize,typeof O=="number"?O:v.bufferSize)),i=v&&typeof v.position=="number"?v.position:0,l=0;do d=await f.read(w,i,E.buffer,l,E.byteLength-l),i+=d,l+=d,y+=d,typeof O=="number"&&(O-=d),l===E.byteLength&&(await m.write(a(E)),E=b.VSBuffer.alloc(Math.min(v.bufferSize,typeof O=="number"?O:v.bufferSize)),l=0);while(d>0&&(typeof O!="number"||O>0)&&p(I)&&u(y,v));if(l>0){let r=l;typeof O=="number"&&(r=Math.min(l,O)),m.write(a(E.slice(0,r)))}}catch(y){throw(0,R.ensureFileSystemProviderError)(y)}finally{await f.close(w)}}function p(f){if(f.isCancellationRequested)throw(0,C.canceled)();return!0}function u(f,h){if(typeof h?.limits?.size=="number"&&f>h.limits.size)throw(0,R.createFileSystemProviderError)((0,S.localize)(1898,null),R.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(ce[102],de([0,1,32,2,52,5,9,12,8]),function(J,e,b,C,S,R,k,D,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BaseWatcher=void 0;class u extends C.Disposable{constructor(){super(),this._onDidChangeFile=this._register(new R.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidLogMessage=this._register(new R.Emitter),this.onDidLogMessage=this._onDidLogMessage.event,this._onDidWatchFail=this._register(new R.Emitter),this.onDidWatchFail=this._onDidWatchFail.event,this.allNonCorrelatedWatchRequests=new Set,this.allCorrelatedWatchRequests=new Map,this.suspendedWatchRequests=this._register(new C.DisposableMap),this.suspendedWatchRequestsWithPolling=new Set,this.updateWatchersDelayer=this._register(new p.ThrottledDelayer(this.getUpdateWatchersDelay())),this.suspendedWatchRequestPollingInterval=5007,this.joinWatch=new p.DeferredPromise,this.verboseLogging=!1,this._register(this.onDidWatchFail(h=>this.handleDidWatchFail(h)))}handleDidWatchFail(h){this.isCorrelated(h)&&this.suspendWatchRequest(h)}isCorrelated(h){return(0,S.isWatchRequestWithCorrelation)(h)}async watch(h){this.joinWatch.isSettled||this.joinWatch.complete(),this.joinWatch=new p.DeferredPromise;try{this.allCorrelatedWatchRequests.clear(),this.allNonCorrelatedWatchRequests.clear();for(const m of h)this.isCorrelated(m)?this.allCorrelatedWatchRequests.set(m.correlationId,m):this.allNonCorrelatedWatchRequests.add(m);for(const[m]of this.suspendedWatchRequests)this.allCorrelatedWatchRequests.has(m)||(this.suspendedWatchRequests.deleteAndDispose(m),this.suspendedWatchRequestsWithPolling.delete(m));return await this.updateWatchers(!1)}finally{this.joinWatch.complete()}}updateWatchers(h){return this.updateWatchersDelayer.trigger(()=>this.doWatch([...this.allNonCorrelatedWatchRequests,...Array.from(this.allCorrelatedWatchRequests.values()).filter(m=>!this.suspendedWatchRequests.has(m.correlationId))]),h?this.getUpdateWatchersDelay():0)}getUpdateWatchersDelay(){return 800}isSuspended(h){return typeof h.correlationId!="number"?!1:this.suspendedWatchRequestsWithPolling.has(h.correlationId)?"polling":this.suspendedWatchRequests.has(h.correlationId)}async suspendWatchRequest(h){if(this.suspendedWatchRequests.has(h.correlationId))return;const m=new C.DisposableStore;this.suspendedWatchRequests.set(h.correlationId,m),await this.joinWatch.p,!m.isDisposed&&(this.monitorSuspendedWatchRequest(h,m),this.updateWatchers(!0))}resumeWatchRequest(h){this.suspendedWatchRequests.deleteAndDispose(h.correlationId),this.suspendedWatchRequestsWithPolling.delete(h.correlationId),this.updateWatchers(!1)}monitorSuspendedWatchRequest(h,m){this.doMonitorWithExistingWatcher(h,m)?(this.trace(`reusing an existing recursive watcher to monitor ${h.path}`),this.suspendedWatchRequestsWithPolling.delete(h.correlationId)):(this.doMonitorWithNodeJS(h,m),this.suspendedWatchRequestsWithPolling.add(h.correlationId))}doMonitorWithExistingWatcher(h,m){const a=this.recursiveWatcher?.subscribe(h.path,(v,I)=>{m.isDisposed||(v?this.monitorSuspendedWatchRequest(h,m):I?.type===k.FileChangeType.ADDED&&this.onMonitoredPathAdded(h))});return a?(m.add(a),!0):!1}doMonitorWithNodeJS(h,m){let a=!1;const v=(I,w)=>{if(m.isDisposed)return;const y=this.isPathNotFound(I),d=this.isPathNotFound(w),O=a;a=y,!y&&(d||O)&&this.onMonitoredPathAdded(h)};this.trace(`starting fs.watchFile() on ${h.path} (correlationId: ${h.correlationId})`);try{(0,b.watchFile)(h.path,{persistent:!1,interval:this.suspendedWatchRequestPollingInterval},v)}catch(I){this.warn(`fs.watchFile() failed with error ${I} on path ${h.path} (correlationId: ${h.correlationId})`)}m.add((0,C.toDisposable)(()=>{this.trace(`stopping fs.watchFile() on ${h.path} (correlationId: ${h.correlationId})`);try{(0,b.unwatchFile)(h.path,v)}catch(I){this.warn(`fs.unwatchFile() failed with error ${I} on path ${h.path} (correlationId: ${h.correlationId})`)}}))}onMonitoredPathAdded(h){this.trace(`detected ${h.path} exists again, resuming watcher (correlationId: ${h.correlationId})`);const m={resource:D.URI.file(h.path),type:k.FileChangeType.ADDED,cId:h.correlationId};this._onDidChangeFile.fire([m]),this.traceEvent(m,h),this.resumeWatchRequest(h)}isPathNotFound(h){return h.ctimeMs===0&&h.ino===0}async stop(){this.suspendedWatchRequests.clearAndDisposeAll(),this.suspendedWatchRequestsWithPolling.clear()}traceEvent(h,m){if(this.verboseLogging){const a=` >> normalized ${h.type===k.FileChangeType.ADDED?"[ADDED]":h.type===k.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${h.resource.fsPath}`;this.traceWithCorrelation(a,m)}}traceWithCorrelation(h,m){this.verboseLogging&&this.trace(`${h}${typeof m.correlationId=="number"?` <${m.correlationId}> `:""}`)}requestToString(h){return`${h.path} (excludes: ${h.excludes.length>0?h.excludes:"<none>"}, includes: ${h.includes&&h.includes.length>0?JSON.stringify(h.includes):"<all>"}, filter: ${(0,S.requestFilterToString)(h.filter)}, correlationId: ${typeof h.correlationId=="number"?h.correlationId:"<none>"})`}async setVerboseLogging(h){this.verboseLogging=h}}e.BaseWatcher=u}),define(ce[103],de([0,1,5,150,102,11,151,64]),function(J,e,b,C,S,R,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class p extends S.BaseWatcher{constructor(f){super(),this.recursiveWatcher=f,this.onDidError=b.Event.None,this.watchers=new Set}async doWatch(f){f=this.removeDuplicateRequests(f);const h=[],m=new Set(Array.from(this.watchers));for(const a of f){const v=this.findWatcher(a);v&&(0,C.patternsEquals)(v.request.excludes,a.excludes)&&(0,C.patternsEquals)(v.request.includes,a.includes)?m.delete(v):h.push(a)}h.length&&this.trace(`Request to start watching: ${h.map(a=>this.requestToString(a)).join(",")}`),m.size&&this.trace(`Request to stop watching: ${Array.from(m).map(a=>this.requestToString(a.request)).join(",")}`);for(const a of m)this.stopWatching(a);for(const a of h)this.startWatching(a)}findWatcher(f){for(const h of this.watchers)if(typeof f.correlationId=="number"||typeof h.request.correlationId=="number"){if(h.request.correlationId===f.correlationId)return h}else if((0,D.isEqual)(h.request.path,f.path,!R.isLinux))return h}startWatching(f){const h=new k.NodeJSFileWatcherLibrary(f,this.recursiveWatcher,a=>this._onDidChangeFile.fire(a),()=>this._onDidWatchFail.fire(f),a=>this._onDidLogMessage.fire(a),this.verboseLogging),m={request:f,instance:h};this.watchers.add(m)}async stop(){await super.stop();for(const f of this.watchers)this.stopWatching(f)}stopWatching(f){this.trace("stopping file watcher",f),this.watchers.delete(f),f.instance.dispose()}removeDuplicateRequests(f){const h=new Map;for(const m of f){const a=R.isLinux?m.path:m.path.toLowerCase();let v=h.get(m.correlationId);v||(v=new Map,h.set(m.correlationId,v)),v.has(a)&&this.trace(`ignoring a request for watching who's path is already watched: ${this.requestToString(m)}`),v.set(a,m)}return Array.from(h.values()).map(m=>Array.from(m.values())).flat()}async setVerboseLogging(f){super.setVerboseLogging(f);for(const h of this.watchers)h.instance.setVerboseLogging(f)}trace(f,h){this.verboseLogging&&this._onDidLogMessage.fire({type:"trace",message:this.toMessage(f,h)})}warn(f){this._onDidLogMessage.fire({type:"warn",message:this.toMessage(f)})}toMessage(f,h){return h?`[File Watcher (node.js)] ${f} (${this.requestToString(h.request)})`:`[File Watcher (node.js)] ${f}`}}e.NodeJSWatcher=p}),define(ce[104],de([0,1,52,103]),function(J,e,b,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class S extends b.AbstractNonRecursiveWatcherClient{constructor(k,D,p){super(k,D,p),this.init()}createWatcher(k){return k.add(new C.NodeJSWatcher(void 0))}}e.NodeJSWatcherClient=S}),define(ce[105],de([0,1,14,60,90,52]),function(J,e,b,C,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class k extends R.AbstractUniversalWatcherClient{constructor(p,u,f){super(p,u,f),this.init()}createWatcher(p){const u=p.add(new S.Client(b.FileAccess.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return p.add(u.onDidProcessExit(({code:f,signal:h})=>this.onError(`terminated by itself with code ${f}, signal: ${h} (ETERM)`))),C.ProxyChannel.toService((0,C.getNextTickChannel)(u.getChannel("watcher")))}}e.UniversalWatcherClient=k}),define(ce[65],de([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class b{constructor(...S){this._entries=new Map;for(const[R,k]of S)this.set(R,k)}set(S,R){const k=this._entries.get(S);return this._entries.set(S,R),k}has(S){return this._entries.has(S)}get(S){return this._entries.get(S)}}e.ServiceCollection=b}),define(ce[106],de([0,1,8,7,2,51,100,10,65,152]),function(J,e,b,C,S,R,k,D,p,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const f=!1;class h extends Error{constructor(w){super("cyclic dependency between services"),this.message=w.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${w.toString()}`}}class m{constructor(w=new p.ServiceCollection,y=!1,d,O=f){this._services=w,this._strict=y,this._parent=d,this._enableTracing=O,this._isDisposed=!1,this._servicesToMaybeDispose=new Set,this._children=new Set,this._activeInstantiations=new Set,this._services.set(D.IInstantiationService,this),this._globalGraph=O?d?._globalGraph??new k.Graph(E=>E):void 0}dispose(){if(!this._isDisposed){this._isDisposed=!0,(0,S.dispose)(this._children),this._children.clear();for(const w of this._servicesToMaybeDispose)(0,S.isDisposable)(w)&&w.dispose();this._servicesToMaybeDispose.clear()}}_throwIfDisposed(){if(this._isDisposed)throw new Error("InstantiationService has been disposed")}createChild(w,y){this._throwIfDisposed();const d=this,O=new class extends m{dispose(){d._children.delete(O),super.dispose()}}(w,this._strict,this,this._enableTracing);return this._children.add(O),y?.add(O),O}invokeFunction(w,...y){this._throwIfDisposed();const d=v.traceInvocation(this._enableTracing,w);let O=!1;try{return w({get:i=>{if(O)throw(0,C.illegalState)("service accessor is only valid during the invocation of its target method");const l=this._getOrCreateServiceInstance(i,d);if(!l)throw new Error(`[invokeFunction] unknown service '${i}'`);return l}},...y)}finally{O=!0,d.stop()}}createInstance(w,...y){this._throwIfDisposed();let d,O;return w instanceof R.SyncDescriptor?(d=v.traceCreation(this._enableTracing,w.ctor),O=this._createInstance(w.ctor,w.staticArguments.concat(y),d)):(d=v.traceCreation(this._enableTracing,w),O=this._createInstance(w,y,d)),d.stop(),O}_createInstance(w,y=[],d){const O=D._util.getServiceDependencies(w).sort((l,r)=>l.index-r.index),E=[];for(const l of O){const r=this._getOrCreateServiceInstance(l.id,d);r||this._throwIfStrict(`[createInstance] ${w.name} depends on UNKNOWN service ${l.id}.`,!1),E.push(r)}const i=O.length>0?O[0].index:y.length;if(y.length!==i){console.trace(`[createInstance] First service dependency of ${w.name} at position ${i+1} conflicts with ${y.length} static arguments`);const l=i-y.length;l>0?y=y.concat(new Array(l)):y=y.slice(0,i)}return Reflect.construct(w,y.concat(E))}_setCreatedServiceInstance(w,y){if(this._services.get(w)instanceof R.SyncDescriptor)this._services.set(w,y);else if(this._parent)this._parent._setCreatedServiceInstance(w,y);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(w){const y=this._services.get(w);return!y&&this._parent?this._parent._getServiceInstanceOrDescriptor(w):y}_getOrCreateServiceInstance(w,y){this._globalGraph&&this._globalGraphImplicitDependency&&this._globalGraph.insertEdge(this._globalGraphImplicitDependency,String(w));const d=this._getServiceInstanceOrDescriptor(w);return d instanceof R.SyncDescriptor?this._safeCreateAndCacheServiceInstance(w,d,y.branch(w,!0)):(y.branch(w,!1),d)}_safeCreateAndCacheServiceInstance(w,y,d){if(this._activeInstantiations.has(w))throw new Error(`illegal state - RECURSIVELY instantiating service '${w}'`);this._activeInstantiations.add(w);try{return this._createAndCacheServiceInstance(w,y,d)}finally{this._activeInstantiations.delete(w)}}_createAndCacheServiceInstance(w,y,d){const O=new k.Graph(r=>r.id.toString());let E=0;const i=[{id:w,desc:y,_trace:d}],l=new Set;for(;i.length;){const r=i.pop();if(!l.has(String(r.id))){if(l.add(String(r.id)),O.lookupOrInsertNode(r),E++>1e3)throw new h(O);for(const n of D._util.getServiceDependencies(r.desc.ctor)){const t=this._getServiceInstanceOrDescriptor(n.id);if(t||this._throwIfStrict(`[createInstance] ${w} depends on ${n.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(r.id),String(n.id)),t instanceof R.SyncDescriptor){const s={id:n.id,desc:t,_trace:r._trace.branch(n.id,!0)};O.insertEdge(r,s),i.push(s)}}}}for(;;){const r=O.roots();if(r.length===0){if(!O.isEmpty())throw new h(O);break}for(const{data:n}of r){if(this._getServiceInstanceOrDescriptor(n.id)instanceof R.SyncDescriptor){const s=this._createServiceInstanceWithOwner(n.id,n.desc.ctor,n.desc.staticArguments,n.desc.supportsDelayedInstantiation,n._trace);this._setCreatedServiceInstance(n.id,s)}O.removeNode(n)}}return this._getServiceInstanceOrDescriptor(w)}_createServiceInstanceWithOwner(w,y,d=[],O,E){if(this._services.get(w)instanceof R.SyncDescriptor)return this._createServiceInstance(w,y,d,O,E,this._servicesToMaybeDispose);if(this._parent)return this._parent._createServiceInstanceWithOwner(w,y,d,O,E);throw new Error(`illegalState - creating UNKNOWN service instance ${y.name}`)}_createServiceInstance(w,y,d=[],O,E,i){if(O){const l=new m(void 0,this._strict,this,this._enableTracing);l._globalGraphImplicitDependency=String(w);const r=new Map,n=new b.GlobalIdleValue(()=>{const t=l._createInstance(y,d,E);for(const[s,o]of r){const c=t[s];if(typeof c=="function")for(const g of o)g.disposable=c.apply(t,g.listener)}return r.clear(),i.add(t),t});return new Proxy(Object.create(null),{get(t,s){if(!n.isInitialized&&typeof s=="string"&&(s.startsWith("onDid")||s.startsWith("onWill"))){let g=r.get(s);return g||(g=new u.LinkedList,r.set(s,g)),(N,A,L)=>{if(n.isInitialized)return n.value[s](N,A,L);{const M={listener:[N,A,L],disposable:void 0},B=g.push(M);return(0,S.toDisposable)(()=>{B(),M.disposable?.dispose()})}}}if(s in t)return t[s];const o=n.value;let c=o[s];return typeof c!="function"||(c=c.bind(o),t[s]=c),c},set(t,s,o){return n.value[s]=o,!0},getPrototypeOf(t){return y.prototype}})}else{const l=this._createInstance(y,d,E);return i.add(l),l}}_throwIfStrict(w,y){if(y&&console.warn(w),this._strict)throw new Error(w)}}e.InstantiationService=m;var a;(function(I){I[I.None=0]="None",I[I.Creation=1]="Creation",I[I.Invocation=2]="Invocation",I[I.Branch=3]="Branch"})(a||(a={}));class v{static{this.all=new Set}static{this._None=new class extends v{constructor(){super(a.None,null)}stop(){}branch(){return this}}}static traceInvocation(w,y){return w?new v(a.Invocation,y.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):v._None}static traceCreation(w,y){return w?new v(a.Creation,y.name):v._None}static{this._totals=0}constructor(w,y){this.type=w,this.name=y,this._start=Date.now(),this._dep=[]}branch(w,y){const d=new v(a.Branch,w.toString());return this._dep.push([w,y,d]),d}stop(){const w=Date.now()-this._start;v._totals+=w;let y=!1;function d(E,i){const l=[],r=new Array(E+1).join("	");for(const[n,t,s]of i._dep)if(t&&s){y=!0,l.push(`${r}CREATES -> ${n}`);const o=d(E+1,s);o&&l.push(o)}else l.push(`${r}uses -> ${n}`);return l.join(`
`)}const O=[`${this.type===a.Creation?"CREATE":"CALL"} ${this.name}`,`${d(1,this)}`,`DONE, took ${w.toFixed(2)}ms (grand total ${v._totals.toFixed(2)}ms)`];(w>2||y)&&v.all.add(O.join(`
`))}}e.Trace=v}),define(ce[6],de([0,1,4,38,5,43,2,25,11,16,3,12,101,10]),function(J,e,b,C,S,R,k,D,p,u,f,h,m,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_LOG_LEVEL=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.MultiplexLogger=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.isLogLevel=I,e.log=y,e.getLogLevel=c,e.LogLevelToString=g,e.LogLevelToLocalizedString=T,e.parseLogLevel=N,b=we(b),e.ILogService=(0,a.createDecorator)("logService"),e.ILoggerService=(0,a.createDecorator)("loggerService");function v(){return new Date().toISOString()}function I(A){return(0,f.isNumber)(A)}var w;(function(A){A[A.Off=0]="Off",A[A.Trace=1]="Trace",A[A.Debug=2]="Debug",A[A.Info=3]="Info",A[A.Warning=4]="Warning",A[A.Error=5]="Error"})(w||(e.LogLevel=w={})),e.DEFAULT_LOG_LEVEL=w.Info;function y(A,L,M){switch(L){case w.Trace:A.trace(M);break;case w.Debug:A.debug(M);break;case w.Info:A.info(M);break;case w.Warning:A.warn(M);break;case w.Error:A.error(M);break;case w.Off:break;default:throw new Error(`Invalid log level ${L}`)}}function d(A,L=!1){let M="";for(let B=0;B<A.length;B++){let Q=A[B];if(Q instanceof Error&&(Q=(0,C.toErrorMessage)(Q,L)),typeof Q=="object")try{Q=JSON.stringify(Q)}catch{}M+=(B>0?" ":"")+Q}return M}class O extends k.Disposable{constructor(){super(...arguments),this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new S.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(L){this.level!==L&&(this.level=L,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}checkLogLevel(L){return this.level!==w.Off&&this.level<=L}}e.AbstractLogger=O;class E extends O{constructor(L){super(),this.logAlways=L}checkLogLevel(L){return this.logAlways||super.checkLogLevel(L)}trace(L,...M){this.checkLogLevel(w.Trace)&&this.log(w.Trace,d([L,...M],!0))}debug(L,...M){this.checkLogLevel(w.Debug)&&this.log(w.Debug,d([L,...M]))}info(L,...M){this.checkLogLevel(w.Info)&&this.log(w.Info,d([L,...M]))}warn(L,...M){this.checkLogLevel(w.Warning)&&this.log(w.Warning,d([L,...M]))}error(L,...M){if(this.checkLogLevel(w.Error))if(L instanceof Error){const B=Array.prototype.slice.call(arguments);B[0]=L.stack,this.log(w.Error,d(B))}else this.log(w.Error,d([L,...M]))}flush(){}}e.AbstractMessageLogger=E;class i extends O{constructor(L=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(L),this.useColors=!p.isWindows}trace(L,...M){this.checkLogLevel(w.Trace)&&(this.useColors?console.log(`\x1B[90m[main ${v()}]\x1B[0m`,L,...M):console.log(`[main ${v()}]`,L,...M))}debug(L,...M){this.checkLogLevel(w.Debug)&&(this.useColors?console.log(`\x1B[90m[main ${v()}]\x1B[0m`,L,...M):console.log(`[main ${v()}]`,L,...M))}info(L,...M){this.checkLogLevel(w.Info)&&(this.useColors?console.log(`\x1B[90m[main ${v()}]\x1B[0m`,L,...M):console.log(`[main ${v()}]`,L,...M))}warn(L,...M){this.checkLogLevel(w.Warning)&&(this.useColors?console.warn(`\x1B[93m[main ${v()}]\x1B[0m`,L,...M):console.warn(`[main ${v()}]`,L,...M))}error(L,...M){this.checkLogLevel(w.Error)&&(this.useColors?console.error(`\x1B[91m[main ${v()}]\x1B[0m`,L,...M):console.error(`[main ${v()}]`,L,...M))}flush(){}}e.ConsoleMainLogger=i;class l extends O{constructor(L=e.DEFAULT_LOG_LEVEL,M=!0){super(),this.useColors=M,this.setLevel(L)}trace(L,...M){this.checkLogLevel(w.Trace)&&(this.useColors?console.log("%cTRACE","color: #888",L,...M):console.log(L,...M))}debug(L,...M){this.checkLogLevel(w.Debug)&&(this.useColors?console.log("%cDEBUG","background: #eee; color: #888",L,...M):console.log(L,...M))}info(L,...M){this.checkLogLevel(w.Info)&&(this.useColors?console.log("%c INFO","color: #33f",L,...M):console.log(L,...M))}warn(L,...M){this.checkLogLevel(w.Warning)&&(this.useColors?console.log("%c WARN","color: #993",L,...M):console.log(L,...M))}error(L,...M){this.checkLogLevel(w.Error)&&(this.useColors?console.log("%c  ERR","color: #f33",L,...M):console.error(L,...M))}flush(){}}e.ConsoleLogger=l;class r extends O{constructor(L,M=e.DEFAULT_LOG_LEVEL){super(),this.adapter=L,this.setLevel(M)}trace(L,...M){this.checkLogLevel(w.Trace)&&this.adapter.log(w.Trace,[this.extractMessage(L),...M])}debug(L,...M){this.checkLogLevel(w.Debug)&&this.adapter.log(w.Debug,[this.extractMessage(L),...M])}info(L,...M){this.checkLogLevel(w.Info)&&this.adapter.log(w.Info,[this.extractMessage(L),...M])}warn(L,...M){this.checkLogLevel(w.Warning)&&this.adapter.log(w.Warning,[this.extractMessage(L),...M])}error(L,...M){this.checkLogLevel(w.Error)&&this.adapter.log(w.Error,[this.extractMessage(L),...M])}extractMessage(L){return typeof L=="string"?L:(0,C.toErrorMessage)(L,this.checkLogLevel(w.Trace))}flush(){}}e.AdapterLogger=r;class n extends O{constructor(L){super(),this.loggers=L,L.length&&this.setLevel(L[0].getLevel())}setLevel(L){for(const M of this.loggers)M.setLevel(L);super.setLevel(L)}trace(L,...M){for(const B of this.loggers)B.trace(L,...M)}debug(L,...M){for(const B of this.loggers)B.debug(L,...M)}info(L,...M){for(const B of this.loggers)B.info(L,...M)}warn(L,...M){for(const B of this.loggers)B.warn(L,...M)}error(L,...M){for(const B of this.loggers)B.error(L,...M)}flush(){for(const L of this.loggers)L.flush()}dispose(){for(const L of this.loggers)L.dispose();super.dispose()}}e.MultiplexLogger=n;class t extends k.Disposable{constructor(L,M,B){if(super(),this.logLevel=L,this.logsHome=M,this._loggers=new D.ResourceMap,this._onDidChangeLoggers=this._register(new S.Emitter),this.onDidChangeLoggers=this._onDidChangeLoggers.event,this._onDidChangeLogLevel=this._register(new S.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event,this._onDidChangeVisibility=this._register(new S.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,B)for(const Q of B)this._loggers.set(Q.resource,{logger:void 0,info:Q})}getLoggerEntry(L){return(0,f.isString)(L)?[...this._loggers.values()].find(M=>M.info.id===L):this._loggers.get(L)}getLogger(L){return this.getLoggerEntry(L)?.logger}createLogger(L,M){const B=this.toResource(L),Q=(0,f.isString)(L)?L:M?.id??(0,R.hash)(B.toString()).toString(16);let re=this._loggers.get(B)?.logger;const ae=M?.logLevel==="always"?w.Trace:M?.logLevel;re||(re=this.doCreateLogger(B,ae??this.getLogLevel(B)??this.logLevel,{...M,id:Q}));const ue={logger:re,info:{resource:B,id:Q,logLevel:ae,name:M?.name,hidden:M?.hidden,extensionId:M?.extensionId,when:M?.when}};return this.registerLogger(ue.info),this._loggers.set(B,ue),re}toResource(L){return(0,f.isString)(L)?(0,u.joinPath)(this.logsHome,`${L}.log`):L}setLogLevel(L,M){if(h.URI.isUri(L)){const B=L,Q=M,re=this._loggers.get(B);re&&Q!==re.info.logLevel&&(re.info.logLevel=Q===this.logLevel?void 0:Q,re.logger?.setLevel(Q),this._loggers.set(re.info.resource,re),this._onDidChangeLogLevel.fire([B,Q]))}else{this.logLevel=L;for(const[B,Q]of this._loggers.entries())this._loggers.get(B)?.info.logLevel===void 0&&Q.logger?.setLevel(this.logLevel);this._onDidChangeLogLevel.fire(this.logLevel)}}setVisibility(L,M){const B=this.getLoggerEntry(L);B&&M!==!B.info.hidden&&(B.info.hidden=!M,this._loggers.set(B.info.resource,B),this._onDidChangeVisibility.fire([B.info.resource,M]))}getLogLevel(L){let M;return L&&(M=this._loggers.get(L)?.info.logLevel),M??this.logLevel}registerLogger(L){const M=this._loggers.get(L.resource);M?M.info.hidden!==L.hidden&&this.setVisibility(L.resource,!L.hidden):(this._loggers.set(L.resource,{info:L,logger:void 0}),this._onDidChangeLoggers.fire({added:[L],removed:[]}))}deregisterLogger(L){const M=this._loggers.get(L);M&&(M.logger&&M.logger.dispose(),this._loggers.delete(L),this._onDidChangeLoggers.fire({added:[],removed:[M.info]}))}*getRegisteredLoggers(){for(const L of this._loggers.values())yield L.info}getRegisteredLogger(L){return this._loggers.get(L)?.info}dispose(){this._loggers.forEach(L=>L.logger?.dispose()),this._loggers.clear(),super.dispose()}}e.AbstractLoggerService=t;class s{constructor(){this.onDidChangeLogLevel=new S.Emitter().event}setLevel(L){}getLevel(){return w.Info}trace(L,...M){}debug(L,...M){}info(L,...M){}warn(L,...M){}error(L,...M){}critical(L,...M){}dispose(){}flush(){}}e.NullLogger=s;class o extends s{}e.NullLogService=o;function c(A){if(A.verbose)return w.Trace;if(typeof A.logLevel=="string"){const L=N(A.logLevel.toLowerCase());if(L!==void 0)return L}return e.DEFAULT_LOG_LEVEL}function g(A){switch(A){case w.Trace:return"trace";case w.Debug:return"debug";case w.Info:return"info";case w.Warning:return"warn";case w.Error:return"error";case w.Off:return"off"}}function T(A){switch(A){case w.Trace:return{original:"Trace",value:b.localize(1959,null)};case w.Debug:return{original:"Debug",value:b.localize(1960,null)};case w.Info:return{original:"Info",value:b.localize(1961,null)};case w.Warning:return{original:"Warning",value:b.localize(1962,null)};case w.Error:return{original:"Error",value:b.localize(1963,null)};case w.Off:return{original:"Off",value:b.localize(1964,null)}}}function N(A){switch(A){case"trace":return w.Trace;case"debug":return w.Debug;case"info":return w.Info;case"warn":return w.Warning;case"error":return w.Error;case"critical":return w.Error;case"off":return w.Off}}e.CONTEXT_LOG_LEVEL=new m.RawContextKey("logLevel",g(w.Info))}),define(ce[107],de([0,1,19,8,7,5,64,2,15,52,6]),function(J,e,b,C,S,R,k,D,p,u,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class h extends D.Disposable{constructor(a,v){super(),this.logService=a,this.options=v,this._onDidChangeFile=this._register(new R.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidWatchError=this._register(new R.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.universalWatchRequests=[],this.universalWatchRequestDelayer=this._register(new C.ThrottledDelayer(0)),this.nonRecursiveWatchRequests=[],this.nonRecursiveWatchRequestDelayer=this._register(new C.ThrottledDelayer(0))}watch(a,v){return v.recursive||this.options?.watcher?.forceUniversal?this.watchUniversal(a,v):this.watchNonRecursive(a,v)}watchUniversal(a,v){const I={path:this.toWatchPath(a),excludes:v.excludes,includes:v.includes,recursive:v.recursive,filter:v.filter,correlationId:v.correlationId},w=(0,b.insert)(this.universalWatchRequests,I);return this.refreshUniversalWatchers(),(0,D.toDisposable)(()=>{w(),this.refreshUniversalWatchers()})}refreshUniversalWatchers(){this.universalWatchRequestDelayer.trigger(()=>this.doRefreshUniversalWatchers()).catch(a=>(0,S.onUnexpectedError)(a))}doRefreshUniversalWatchers(){this.universalWatcher||(this.universalWatcher=this._register(this.createUniversalWatcher(v=>this._onDidChangeFile.fire((0,u.reviveFileChanges)(v)),v=>this.onWatcherLogMessage(v),this.logService.getLevel()===f.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.universalWatcher?.setVerboseLogging(this.logService.getLevel()===f.LogLevel.Trace)})));const a=this.options?.watcher?.recursive?.usePolling;if(a===!0)for(const v of this.universalWatchRequests)(0,u.isRecursiveWatchRequest)(v)&&(v.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(a))for(const v of this.universalWatchRequests)(0,u.isRecursiveWatchRequest)(v)&&a.includes(v.path)&&(v.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);return this.universalWatcher.watch(this.universalWatchRequests)}watchNonRecursive(a,v){const I={path:this.toWatchPath(a),excludes:v.excludes,includes:v.includes,recursive:!1,filter:v.filter,correlationId:v.correlationId},w=(0,b.insert)(this.nonRecursiveWatchRequests,I);return this.refreshNonRecursiveWatchers(),(0,D.toDisposable)(()=>{w(),this.refreshNonRecursiveWatchers()})}refreshNonRecursiveWatchers(){this.nonRecursiveWatchRequestDelayer.trigger(()=>this.doRefreshNonRecursiveWatchers()).catch(a=>(0,S.onUnexpectedError)(a))}doRefreshNonRecursiveWatchers(){return this.nonRecursiveWatcher||(this.nonRecursiveWatcher=this._register(this.createNonRecursiveWatcher(a=>this._onDidChangeFile.fire((0,u.reviveFileChanges)(a)),a=>this.onWatcherLogMessage(a),this.logService.getLevel()===f.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.nonRecursiveWatcher?.setVerboseLogging(this.logService.getLevel()===f.LogLevel.Trace)}))),this.nonRecursiveWatcher.watch(this.nonRecursiveWatchRequests)}onWatcherLogMessage(a){a.type==="error"&&this._onDidWatchError.fire(a.message),this.logWatcherMessage(a)}logWatcherMessage(a){this.logService[a.type](a.message)}toFilePath(a){return(0,p.normalize)(a.fsPath)}toWatchPath(a){const v=this.toFilePath(a);return(0,k.removeTrailingPathSeparator)(v)}}e.AbstractDiskFileSystemProvider=h});var oe=this&&this.__param||function(J,e){return function(b,C){e(b,C,J)}};define(ce[108],de([0,1,19,8,13,21,5,43,66,2,49,14,109,16,47,4,9,63,6,7]),function(J,e,b,C,S,R,k,D,p,u,f,h,m,a,v,I,w,y,d,O){"use strict";var E;Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let i=class extends u.Disposable{static{E=this}constructor(r){super(),this.logService=r,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new k.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new k.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new k.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new k.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this.internalOnDidFilesChange=this._register(new k.Emitter),this._onDidUncorrelatedFilesChange=this._register(new k.Emitter),this.onDidFilesChange=this._onDidUncorrelatedFilesChange.event,this._onDidWatchError=this._register(new k.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.activeWatchers=new Map,this.writeQueue=this._register(new C.ResourceQueue)}registerProvider(r,n){if(this.provider.has(r))throw new Error(`A filesystem provider for the scheme '${r}' is already registered.`);(0,m.mark)(`code/registerFilesystem/${r}`);const t=new u.DisposableStore;return this.provider.set(r,n),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:r,provider:n}),t.add(n.onDidChangeFile(s=>{const o=new w.FileChangesEvent(s,!this.isPathCaseSensitive(n));this.internalOnDidFilesChange.fire(o),o.hasCorrelation()||this._onDidUncorrelatedFilesChange.fire(o)})),typeof n.onDidWatchError=="function"&&t.add(n.onDidWatchError(s=>this._onDidWatchError.fire(new Error(s)))),t.add(n.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:n,scheme:r}))),(0,u.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:r,provider:n}),this.provider.delete(r),(0,u.dispose)(t)})}getProvider(r){return this.provider.get(r)}async activateProvider(r){const n=[];this._onWillActivateFileSystemProvider.fire({scheme:r,join(t){n.push(t)}}),!this.provider.has(r)&&await C.Promises.settled(n)}async canHandleResource(r){return await this.activateProvider(r.scheme),this.hasProvider(r)}hasProvider(r){return this.provider.has(r.scheme)}hasCapability(r,n){const t=this.provider.get(r.scheme);return!!(t&&t.capabilities&n)}listCapabilities(){return p.Iterable.map(this.provider,([r,n])=>({scheme:r,capabilities:n.capabilities}))}async withProvider(r){if(!(0,a.isAbsolutePath)(r))throw new w.FileOperationError((0,I.localize)(1871,null,this.resourceForError(r)),w.FileOperationResult.FILE_INVALID_PATH);await this.activateProvider(r.scheme);const n=this.provider.get(r.scheme);if(!n){const t=new O.ErrorNoTelemetry;throw t.message=(0,I.localize)(1872,null,r.toString()),t}return n}async withReadProvider(r){const n=await this.withProvider(r);if((0,w.hasOpenReadWriteCloseCapability)(n)||(0,w.hasReadWriteCapability)(n)||(0,w.hasFileReadStreamCapability)(n))return n;throw new Error(`Filesystem provider for scheme '${r.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(r){const n=await this.withProvider(r);if((0,w.hasOpenReadWriteCloseCapability)(n)||(0,w.hasReadWriteCapability)(n))return n;throw new Error(`Filesystem provider for scheme '${r.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(r,n){try{return await this.doResolveFile(r,n)}catch(t){throw(0,w.toFileSystemProviderErrorCode)(t)===w.FileSystemProviderErrorCode.FileNotFound?new w.FileOperationError((0,I.localize)(1873,null,this.resourceForError(r)),w.FileOperationResult.FILE_NOT_FOUND):(0,w.ensureFileSystemProviderError)(t)}}async doResolveFile(r,n){const t=await this.withProvider(r),s=this.isPathCaseSensitive(t),o=n?.resolveTo,c=n?.resolveSingleChildDescendants,g=n?.resolveMetadata,T=await t.stat(r);let N;return this.toFileStat(t,r,T,void 0,!!g,(A,L)=>(N||(N=f.TernarySearchTree.forUris(()=>!s),N.set(r,!0),o&&N.fill(!0,o)),N.get(A.resource)||N.findSuperstr(A.resource.with({query:null,fragment:null}))?!0:A.isDirectory&&c?L===1:!1))}async toFileStat(r,n,t,s,o,c){const{providerExtUri:g}=this.getExtUri(r),T={resource:n,name:g.basename(n),isFile:(t.type&w.FileType.File)!==0,isDirectory:(t.type&w.FileType.Directory)!==0,isSymbolicLink:(t.type&w.FileType.SymbolicLink)!==0,mtime:t.mtime,ctime:t.ctime,size:t.size,readonly:!!((t.permissions??0)&w.FilePermission.Readonly)||!!(r.capabilities&w.FileSystemProviderCapabilities.Readonly),locked:!!((t.permissions??0)&w.FilePermission.Locked),etag:(0,w.etag)({mtime:t.mtime,size:t.size}),children:void 0};if(T.isDirectory&&c(T,s)){try{const N=await r.readdir(n),A=await C.Promises.settled(N.map(async([L,M])=>{try{const B=g.joinPath(n,L),Q=o?await r.stat(B):{type:M};return await this.toFileStat(r,B,Q,N.length,o,c)}catch(B){return this.logService.trace(B),null}}));T.children=(0,b.coalesce)(A)}catch(N){this.logService.trace(N),T.children=[]}return T}return T}async resolveAll(r){return C.Promises.settled(r.map(async n=>{try{return{stat:await this.doResolveFile(n.resource,n.options),success:!0}}catch(t){return this.logService.trace(t),{stat:void 0,success:!1}}}))}async stat(r){const n=await this.withProvider(r),t=await n.stat(r);return this.toFileStat(n,r,t,void 0,!0,()=>!1)}async exists(r){const n=await this.withProvider(r);try{return!!await n.stat(r)}catch{return!1}}async canCreateFile(r,n){try{await this.doValidateCreateFile(r,n)}catch(t){return t}return!0}async doValidateCreateFile(r,n){if(!n?.overwrite&&await this.exists(r))throw new w.FileOperationError((0,I.localize)(1874,null,this.resourceForError(r)),w.FileOperationResult.FILE_MODIFIED_SINCE,n)}async createFile(r,n=S.VSBuffer.fromString(""),t){await this.doValidateCreateFile(r,t);const s=await this.writeFile(r,n);return this._onDidRunOperation.fire(new w.FileOperationEvent(r,w.FileOperation.CREATE,s)),s}async writeFile(r,n,t){const s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(r),r),{providerExtUri:o}=this.getExtUri(s);let c=t;if((0,w.hasFileAtomicWriteCapability)(s)&&!c?.atomic){const g=s.enforceAtomicWriteFile?.(r);g&&(c={...t,atomic:g})}try{await this.validateWriteFile(s,r,c)||await this.mkdirp(s,o.dirname(r));let T;if((0,w.hasReadWriteCapability)(s)&&!(n instanceof S.VSBuffer))if((0,v.isReadableStream)(n)){const N=await(0,v.peekStream)(n,3);N.ended?T=S.VSBuffer.concat(N.buffer):T=N}else T=(0,v.peekReadable)(n,N=>S.VSBuffer.concat(N),3);else T=n;!(0,w.hasOpenReadWriteCloseCapability)(s)||(0,w.hasReadWriteCapability)(s)&&T instanceof S.VSBuffer||(0,w.hasReadWriteCapability)(s)&&(0,w.hasFileAtomicWriteCapability)(s)&&c?.atomic?await this.doWriteUnbuffered(s,r,c,T):await this.doWriteBuffered(s,r,c,T instanceof S.VSBuffer?(0,S.bufferToReadable)(T):T),this._onDidRunOperation.fire(new w.FileOperationEvent(r,w.FileOperation.WRITE))}catch(g){throw new w.FileOperationError((0,I.localize)(1875,null,this.resourceForError(r),(0,w.ensureFileSystemProviderError)(g).toString()),(0,w.toFileOperationResult)(g),c)}return this.resolve(r,{resolveMetadata:!0})}async validateWriteFile(r,n,t){const s=!!t?.unlock;if(s&&!(r.capabilities&w.FileSystemProviderCapabilities.FileWriteUnlock))throw new Error((0,I.localize)(1876,null,this.resourceForError(n)));if(!!t?.atomic){if(!(r.capabilities&w.FileSystemProviderCapabilities.FileAtomicWrite))throw new Error((0,I.localize)(1877,null,this.resourceForError(n)));if(!(r.capabilities&w.FileSystemProviderCapabilities.FileReadWrite))throw new Error((0,I.localize)(1878,null,this.resourceForError(n)));if(s)throw new Error((0,I.localize)(1879,null,this.resourceForError(n)))}let c;try{c=await r.stat(n)}catch{return}if(c.type&w.FileType.Directory)throw new w.FileOperationError((0,I.localize)(1880,null,this.resourceForError(n)),w.FileOperationResult.FILE_IS_DIRECTORY,t);if(this.throwIfFileIsReadonly(n,c),typeof t?.mtime=="number"&&typeof t.etag=="string"&&t.etag!==w.ETAG_DISABLED&&typeof c.mtime=="number"&&typeof c.size=="number"&&t.mtime<c.mtime&&t.etag!==(0,w.etag)({mtime:t.mtime,size:c.size}))throw new w.FileOperationError((0,I.localize)(1881,null),w.FileOperationResult.FILE_MODIFIED_SINCE,t);return c}async readFile(r,n,t){const s=await this.withReadProvider(r);return n?.atomic?this.doReadFileAtomic(s,r,n,t):this.doReadFile(s,r,n,t)}async doReadFileAtomic(r,n,t,s){return new Promise((o,c)=>{this.writeQueue.queueFor(n,async()=>{try{const g=await this.doReadFile(r,n,t,s);o(g)}catch(g){c(g)}},this.getExtUri(r).providerExtUri)})}async doReadFile(r,n,t,s){const o=await this.doReadFileStream(r,n,{...t,preferUnbuffered:!0},s);return{...o,value:await(0,S.streamToBuffer)(o.value)}}async readFileStream(r,n,t){const s=await this.withReadProvider(r);return this.doReadFileStream(s,r,n,t)}async doReadFileStream(r,n,t,s){const o=new R.CancellationTokenSource(s);let c=t;(0,w.hasFileAtomicReadCapability)(r)&&r.enforceAtomicReadFile?.(n)&&(c={...t,atomic:!0});const g=this.validateReadFile(n,c).then(N=>N,N=>{throw o.dispose(!0),N});let T;try{return typeof c?.etag=="string"&&c.etag!==w.ETAG_DISABLED&&await g,c?.atomic&&(0,w.hasFileAtomicReadCapability)(r)||!((0,w.hasOpenReadWriteCloseCapability)(r)||(0,w.hasFileReadStreamCapability)(r))||(0,w.hasReadWriteCapability)(r)&&c?.preferUnbuffered?T=this.readFileUnbuffered(r,n,c):(0,w.hasFileReadStreamCapability)(r)?T=this.readFileStreamed(r,n,o.token,c):T=this.readFileBuffered(r,n,o.token,c),T.on("end",()=>o.dispose()),T.on("error",()=>o.dispose()),{...await g,value:T}}catch(N){throw T&&await(0,v.consumeStream)(T),this.restoreReadError(N,n,c)}}restoreReadError(r,n,t){const s=(0,I.localize)(1882,null,this.resourceForError(n),(0,w.ensureFileSystemProviderError)(r).toString());return r instanceof w.NotModifiedSinceFileOperationError?new w.NotModifiedSinceFileOperationError(s,r.stat,t):r instanceof w.TooLargeFileOperationError?new w.TooLargeFileOperationError(s,r.fileOperationResult,r.size,r.options):new w.FileOperationError(s,(0,w.toFileOperationResult)(r),t)}readFileStreamed(r,n,t,s=Object.create(null)){const o=r.readFileStream(n,s,t);return(0,v.transform)(o,{data:c=>c instanceof S.VSBuffer?c:S.VSBuffer.wrap(c),error:c=>this.restoreReadError(c,n,s)},c=>S.VSBuffer.concat(c))}readFileBuffered(r,n,t,s=Object.create(null)){const o=(0,S.newWriteableBufferStream)();return(0,y.readFileIntoStream)(r,n,o,c=>c,{...s,bufferSize:this.BUFFER_SIZE,errorTransformer:c=>this.restoreReadError(c,n,s)},t),o}readFileUnbuffered(r,n,t){const s=(0,v.newWriteableStream)(o=>S.VSBuffer.concat(o));return(async()=>{try{let o;t?.atomic&&(0,w.hasFileAtomicReadCapability)(r)?o=await r.readFile(n,{atomic:!0}):o=await r.readFile(n),typeof t?.position=="number"&&(o=o.slice(t.position)),typeof t?.length=="number"&&(o=o.slice(0,t.length)),this.validateReadFileLimits(n,o.byteLength,t),s.end(S.VSBuffer.wrap(o))}catch(o){s.error(o),s.end()}})(),s}async validateReadFile(r,n){const t=await this.resolve(r,{resolveMetadata:!0});if(t.isDirectory)throw new w.FileOperationError((0,I.localize)(1883,null,this.resourceForError(r)),w.FileOperationResult.FILE_IS_DIRECTORY,n);if(typeof n?.etag=="string"&&n.etag!==w.ETAG_DISABLED&&n.etag===t.etag)throw new w.NotModifiedSinceFileOperationError((0,I.localize)(1884,null),t,n);return this.validateReadFileLimits(r,t.size,n),t}validateReadFileLimits(r,n,t){if(typeof t?.limits?.size=="number"&&n>t.limits.size)throw new w.TooLargeFileOperationError((0,I.localize)(1885,null,this.resourceForError(r)),w.FileOperationResult.FILE_TOO_LARGE,n,t)}async canMove(r,n,t){return this.doCanMoveCopy(r,n,"move",t)}async canCopy(r,n,t){return this.doCanMoveCopy(r,n,"copy",t)}async doCanMoveCopy(r,n,t,s){if(r.toString()!==n.toString())try{const o=t==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(r),r):await this.withReadProvider(r),c=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(n),n);await this.doValidateMoveCopy(o,r,c,n,t,s)}catch(o){return o}return!0}async move(r,n,t){const s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(r),r),o=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(n),n),c=await this.doMoveCopy(s,r,o,n,"move",!!t),g=await this.resolve(n,{resolveMetadata:!0});return this._onDidRunOperation.fire(new w.FileOperationEvent(r,c==="move"?w.FileOperation.MOVE:w.FileOperation.COPY,g)),g}async copy(r,n,t){const s=await this.withReadProvider(r),o=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(n),n),c=await this.doMoveCopy(s,r,o,n,"copy",!!t),g=await this.resolve(n,{resolveMetadata:!0});return this._onDidRunOperation.fire(new w.FileOperationEvent(r,c==="copy"?w.FileOperation.COPY:w.FileOperation.MOVE,g)),g}async doMoveCopy(r,n,t,s,o,c){if(n.toString()===s.toString())return o;const{exists:g,isSameResourceWithDifferentPathCase:T}=await this.doValidateMoveCopy(r,n,t,s,o,c);if(g&&!T&&c&&await this.del(s,{recursive:!0}),await this.mkdirp(t,this.getExtUri(t).providerExtUri.dirname(s)),o==="copy"){if(r===t&&(0,w.hasFileFolderCopyCapability)(r))await r.copy(n,s,{overwrite:c});else{const N=await this.resolve(n);N.isDirectory?await this.doCopyFolder(r,N,t,s):await this.doCopyFile(r,n,t,s)}return o}else return r===t?(await r.rename(n,s,{overwrite:c}),o):(await this.doMoveCopy(r,n,t,s,"copy",c),await this.del(n,{recursive:!0}),"copy")}async doCopyFile(r,n,t,s){if((0,w.hasOpenReadWriteCloseCapability)(r)&&(0,w.hasOpenReadWriteCloseCapability)(t))return this.doPipeBuffered(r,n,t,s);if((0,w.hasOpenReadWriteCloseCapability)(r)&&(0,w.hasReadWriteCapability)(t))return this.doPipeBufferedToUnbuffered(r,n,t,s);if((0,w.hasReadWriteCapability)(r)&&(0,w.hasOpenReadWriteCloseCapability)(t))return this.doPipeUnbufferedToBuffered(r,n,t,s);if((0,w.hasReadWriteCapability)(r)&&(0,w.hasReadWriteCapability)(t))return this.doPipeUnbuffered(r,n,t,s)}async doCopyFolder(r,n,t,s){await t.mkdir(s),Array.isArray(n.children)&&await C.Promises.settled(n.children.map(async o=>{const c=this.getExtUri(t).providerExtUri.joinPath(s,o.name);return o.isDirectory?this.doCopyFolder(r,await this.resolve(o.resource),t,c):this.doCopyFile(r,o.resource,t,c)}))}async doValidateMoveCopy(r,n,t,s,o,c){let g=!1;if(r===t){const{providerExtUri:N,isPathCaseSensitive:A}=this.getExtUri(r);if(A||(g=N.isEqual(n,s)),g&&o==="copy")throw new Error((0,I.localize)(1886,null,this.resourceForError(n),this.resourceForError(s)));if(!g&&N.isEqualOrParent(s,n))throw new Error((0,I.localize)(1887,null,this.resourceForError(n),this.resourceForError(s)))}const T=await this.exists(s);if(T&&!g){if(!c)throw new w.FileOperationError((0,I.localize)(1888,null,this.resourceForError(n),this.resourceForError(s)),w.FileOperationResult.FILE_MOVE_CONFLICT);if(r===t){const{providerExtUri:N}=this.getExtUri(r);if(N.isEqualOrParent(n,s))throw new Error((0,I.localize)(1889,null,this.resourceForError(n),this.resourceForError(s)))}}return{exists:T,isSameResourceWithDifferentPathCase:g}}getExtUri(r){const n=this.isPathCaseSensitive(r);return{providerExtUri:n?a.extUri:a.extUriIgnorePathCase,isPathCaseSensitive:n}}isPathCaseSensitive(r){return!!(r.capabilities&w.FileSystemProviderCapabilities.PathCaseSensitive)}async createFolder(r){const n=this.throwIfFileSystemIsReadonly(await this.withProvider(r),r);await this.mkdirp(n,r);const t=await this.resolve(r,{resolveMetadata:!0});return this._onDidRunOperation.fire(new w.FileOperationEvent(r,w.FileOperation.CREATE,t)),t}async mkdirp(r,n){const t=[],{providerExtUri:s}=this.getExtUri(r);for(;!s.isEqual(n,s.dirname(n));)try{if(!((await r.stat(n)).type&w.FileType.Directory))throw new Error((0,I.localize)(1890,null,this.resourceForError(n)));break}catch(o){if((0,w.toFileSystemProviderErrorCode)(o)!==w.FileSystemProviderErrorCode.FileNotFound)throw o;t.push(s.basename(n)),n=s.dirname(n)}for(let o=t.length-1;o>=0;o--){n=s.joinPath(n,t[o]);try{await r.mkdir(n)}catch(c){if((0,w.toFileSystemProviderErrorCode)(c)!==w.FileSystemProviderErrorCode.FileExists)throw c}}}async canDelete(r,n){try{await this.doValidateDelete(r,n)}catch(t){return t}return!0}async doValidateDelete(r,n){const t=this.throwIfFileSystemIsReadonly(await this.withProvider(r),r),s=!!n?.useTrash;if(s&&!(t.capabilities&w.FileSystemProviderCapabilities.Trash))throw new Error((0,I.localize)(1891,null,this.resourceForError(r)));const o=n?.atomic;if(o&&!(t.capabilities&w.FileSystemProviderCapabilities.FileAtomicDelete))throw new Error((0,I.localize)(1892,null,this.resourceForError(r)));if(s&&o)throw new Error((0,I.localize)(1893,null,this.resourceForError(r)));let c;try{c=await t.stat(r)}catch{}if(c)this.throwIfFileIsReadonly(r,c);else throw new w.FileOperationError((0,I.localize)(1894,null,this.resourceForError(r)),w.FileOperationResult.FILE_NOT_FOUND);if(!!!n?.recursive){const T=await this.resolve(r);if(T.isDirectory&&Array.isArray(T.children)&&T.children.length>0)throw new Error((0,I.localize)(1895,null,this.resourceForError(r)))}return t}async del(r,n){const t=await this.doValidateDelete(r,n);let s=n;if((0,w.hasFileAtomicDeleteCapability)(t)&&!s?.atomic){const T=t.enforceAtomicDelete?.(r);T&&(s={...n,atomic:T})}const o=!!s?.useTrash,c=!!s?.recursive,g=s?.atomic??!1;await t.delete(r,{recursive:c,useTrash:o,atomic:g}),this._onDidRunOperation.fire(new w.FileOperationEvent(r,w.FileOperation.DELETE))}async cloneFile(r,n){const t=await this.withProvider(r),s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(n),n);if(!(t===s&&this.getExtUri(t).providerExtUri.isEqual(r,n)))return t===s&&(0,w.hasFileCloneCapability)(t)?t.cloneFile(r,n):(await this.mkdirp(s,this.getExtUri(s).providerExtUri.dirname(n)),t===s&&(0,w.hasFileFolderCopyCapability)(t)?this.writeQueue.queueFor(r,()=>t.copy(r,n,{overwrite:!0}),this.getExtUri(t).providerExtUri):this.writeQueue.queueFor(r,()=>this.doCopyFile(t,r,s,n),this.getExtUri(t).providerExtUri))}static{this.WATCHER_CORRELATION_IDS=0}createWatcher(r,n){return this.watch(r,{...n,correlationId:E.WATCHER_CORRELATION_IDS++})}watch(r,n={recursive:!1,excludes:[]}){const t=new u.DisposableStore;let s=!1,o=()=>{s=!0};t.add((0,u.toDisposable)(()=>o())),(async()=>{try{const g=await this.doWatch(r,n);s?(0,u.dispose)(g):o=()=>(0,u.dispose)(g)}catch(g){this.logService.error(g)}})();const c=n.correlationId;if(typeof c=="number"){const g=t.add(new k.Emitter);return t.add(this.internalOnDidFilesChange.event(N=>{N.correlates(c)&&g.fire(N)})),{onDidChange:g.event,dispose:()=>t.dispose()}}return t}async doWatch(r,n){const t=await this.withProvider(r),s=(0,D.hash)([this.getExtUri(t).providerExtUri.getComparisonKey(r),n]);let o=this.activeWatchers.get(s);return o||(o={count:0,disposable:t.watch(r,n)},this.activeWatchers.set(s,o)),o.count+=1,(0,u.toDisposable)(()=>{o&&(o.count--,o.count===0&&((0,u.dispose)(o.disposable),this.activeWatchers.delete(s)))})}dispose(){super.dispose();for(const[,r]of this.activeWatchers)(0,u.dispose)(r.disposable);this.activeWatchers.clear()}async doWriteBuffered(r,n,t,s){return this.writeQueue.queueFor(n,async()=>{const o=await r.open(n,{create:!0,unlock:t?.unlock??!1});try{(0,v.isReadableStream)(s)||(0,v.isReadableBufferedStream)(s)?await this.doWriteStreamBufferedQueued(r,o,s):await this.doWriteReadableBufferedQueued(r,o,s)}catch(c){throw(0,w.ensureFileSystemProviderError)(c)}finally{await r.close(o)}},this.getExtUri(r).providerExtUri)}async doWriteStreamBufferedQueued(r,n,t){let s=0,o;if((0,v.isReadableBufferedStream)(t)){if(t.buffer.length>0){const c=S.VSBuffer.concat(t.buffer);await this.doWriteBuffer(r,n,c,c.byteLength,s,0),s+=c.byteLength}if(t.ended)return;o=t.stream}else o=t;return new Promise((c,g)=>{(0,v.listenStream)(o,{onData:async T=>{o.pause();try{await this.doWriteBuffer(r,n,T,T.byteLength,s,0)}catch(N){return g(N)}s+=T.byteLength,setTimeout(()=>o.resume())},onError:T=>g(T),onEnd:()=>c()})})}async doWriteReadableBufferedQueued(r,n,t){let s=0,o;for(;(o=t.read())!==null;)await this.doWriteBuffer(r,n,o,o.byteLength,s,0),s+=o.byteLength}async doWriteBuffer(r,n,t,s,o,c){let g=0;for(;g<s;){const T=await r.write(n,o+g,t.buffer,c+g,s-g);g+=T}}async doWriteUnbuffered(r,n,t,s){return this.writeQueue.queueFor(n,()=>this.doWriteUnbufferedQueued(r,n,t,s),this.getExtUri(r).providerExtUri)}async doWriteUnbufferedQueued(r,n,t,s){let o;s instanceof S.VSBuffer?o=s:(0,v.isReadableStream)(s)?o=await(0,S.streamToBuffer)(s):(0,v.isReadableBufferedStream)(s)?o=await(0,S.bufferedStreamToBuffer)(s):o=(0,S.readableToBuffer)(s),await r.writeFile(n,o.buffer,{create:!0,overwrite:!0,unlock:t?.unlock??!1,atomic:t?.atomic??!1})}async doPipeBuffered(r,n,t,s){return this.writeQueue.queueFor(s,()=>this.doPipeBufferedQueued(r,n,t,s),this.getExtUri(t).providerExtUri)}async doPipeBufferedQueued(r,n,t,s){let o,c;try{o=await r.open(n,{create:!1}),c=await t.open(s,{create:!0,unlock:!1});const g=S.VSBuffer.alloc(this.BUFFER_SIZE);let T=0,N=0,A=0;do A=await r.read(o,T,g.buffer,N,g.byteLength-N),await this.doWriteBuffer(t,c,g,A,T,N),T+=A,N+=A,N===g.byteLength&&(N=0);while(A>0)}catch(g){throw(0,w.ensureFileSystemProviderError)(g)}finally{await C.Promises.settled([typeof o=="number"?r.close(o):Promise.resolve(),typeof c=="number"?t.close(c):Promise.resolve()])}}async doPipeUnbuffered(r,n,t,s){return this.writeQueue.queueFor(s,()=>this.doPipeUnbufferedQueued(r,n,t,s),this.getExtUri(t).providerExtUri)}async doPipeUnbufferedQueued(r,n,t,s){return t.writeFile(s,await r.readFile(n),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async doPipeUnbufferedToBuffered(r,n,t,s){return this.writeQueue.queueFor(s,()=>this.doPipeUnbufferedToBufferedQueued(r,n,t,s),this.getExtUri(t).providerExtUri)}async doPipeUnbufferedToBufferedQueued(r,n,t,s){const o=await t.open(s,{create:!0,unlock:!1});try{const c=await r.readFile(n);await this.doWriteBuffer(t,o,S.VSBuffer.wrap(c),c.byteLength,0,0)}catch(c){throw(0,w.ensureFileSystemProviderError)(c)}finally{await t.close(o)}}async doPipeBufferedToUnbuffered(r,n,t,s){const o=await(0,S.streamToBuffer)(this.readFileBuffered(r,n,R.CancellationToken.None));await this.doWriteUnbuffered(t,s,void 0,o)}throwIfFileSystemIsReadonly(r,n){if(r.capabilities&w.FileSystemProviderCapabilities.Readonly)throw new w.FileOperationError((0,I.localize)(1896,null,this.resourceForError(n)),w.FileOperationResult.FILE_PERMISSION_DENIED);return r}throwIfFileIsReadonly(r,n){if((n.permissions??0)&w.FilePermission.Readonly)throw new w.FileOperationError((0,I.localize)(1897,null,this.resourceForError(r)),w.FileOperationResult.FILE_PERMISSION_DENIED)}resourceForError(r){return r.scheme===h.Schemas.file?r.fsPath:r.toString(!0)}};e.FileService=i,e.FileService=i=E=Pe([oe(0,d.ILogService)],i)}),define(ce[110],de([0,1,32,8,25,13,5,64,2,15,11,16,47,29,4,9,63,107,105,104]),function(J,e,b,C,S,R,k,D,p,u,f,h,m,a,v,I,w,y,d,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0;class E extends y.AbstractDiskFileSystemProvider{static{this.TRACE_LOG_RESOURCE_LOCKS=!1}constructor(l,r){super(l,r),this.onDidChangeCapabilities=k.Event.None,this.resourceLocks=new S.ResourceMap(n=>h.extUriBiasedIgnorePathCase.getComparisonKey(n)),this.mapHandleToPos=new Map,this.mapHandleToLock=new Map,this.writeHandles=new Map}get capabilities(){return this._capabilities||(this._capabilities=I.FileSystemProviderCapabilities.FileReadWrite|I.FileSystemProviderCapabilities.FileOpenReadWriteClose|I.FileSystemProviderCapabilities.FileReadStream|I.FileSystemProviderCapabilities.FileFolderCopy|I.FileSystemProviderCapabilities.FileWriteUnlock|I.FileSystemProviderCapabilities.FileAtomicRead|I.FileSystemProviderCapabilities.FileAtomicWrite|I.FileSystemProviderCapabilities.FileAtomicDelete|I.FileSystemProviderCapabilities.FileClone,f.isLinux&&(this._capabilities|=I.FileSystemProviderCapabilities.PathCaseSensitive)),this._capabilities}async stat(l){try{const{stat:r,symbolicLink:n}=await a.SymlinkSupport.stat(this.toFilePath(l));return{type:this.toType(r,n),ctime:r.birthtime.getTime(),mtime:r.mtime.getTime(),size:r.size,permissions:r.mode&128?void 0:I.FilePermission.Locked}}catch(r){throw this.toFileSystemProviderError(r)}}async statIgnoreError(l){try{return await this.stat(l)}catch{return}}async readdir(l){try{const r=await a.Promises.readdir(this.toFilePath(l),{withFileTypes:!0}),n=[];return await Promise.all(r.map(async t=>{try{let s;t.isSymbolicLink()?s=(await this.stat((0,h.joinPath)(l,t.name))).type:s=this.toType(t),n.push([t.name,s])}catch(s){this.logService.trace(s)}})),n}catch(r){throw this.toFileSystemProviderError(r)}}toType(l,r){let n;return r?.dangling?n=I.FileType.Unknown:l.isFile()?n=I.FileType.File:l.isDirectory()?n=I.FileType.Directory:n=I.FileType.Unknown,r&&(n|=I.FileType.SymbolicLink),n}async createResourceLock(l){const r=this.toFilePath(l);this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${r})`);let n;for(;n=this.resourceLocks.get(l);)this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${r})`),await n.wait();const t=new C.Barrier;return this.resourceLocks.set(l,t),this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${r})`),(0,p.toDisposable)(()=>{this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${r})`),this.resourceLocks.get(l)===t&&(this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${r})`),this.resourceLocks.delete(l)),this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${r})`),t.open()})}async readFile(l,r){let n;try{r?.atomic&&(this.traceLock(`[Disk FileSystemProvider]: atomic read operation started (${this.toFilePath(l)})`),n=await this.createResourceLock(l));const t=this.toFilePath(l);return await b.promises.readFile(t)}catch(t){throw this.toFileSystemProviderError(t)}finally{n?.dispose()}}traceLock(l){E.TRACE_LOG_RESOURCE_LOCKS&&this.logService.trace(l)}readFileStream(l,r,n){const t=(0,m.newWriteableStream)(s=>R.VSBuffer.concat(s.map(o=>R.VSBuffer.wrap(o))).buffer);return(0,w.readFileIntoStream)(this,l,t,s=>s.buffer,{...r,bufferSize:256*1024},n),t}async writeFile(l,r,n){return n?.atomic!==!1&&n?.atomic?.postfix&&await this.canWriteFileAtomic(l)?this.doWriteFileAtomic(l,(0,h.joinPath)((0,h.dirname)(l),`${(0,h.basename)(l)}${n.atomic.postfix}`),r,n):this.doWriteFile(l,r,n)}async canWriteFileAtomic(l){try{const r=this.toFilePath(l),{symbolicLink:n}=await a.SymlinkSupport.stat(r);if(n)return!1}catch{}return!0}async doWriteFileAtomic(l,r,n,t){const s=new p.DisposableStore;try{s.add(await this.createResourceLock(l)),s.add(await this.createResourceLock(r)),await this.doWriteFile(r,n,t,!0);try{await this.rename(r,l,{overwrite:!0})}catch(o){try{await this.delete(r,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw o}}finally{s.dispose()}}async doWriteFile(l,r,n,t){let s;try{const o=this.toFilePath(l);if(!n.create||!n.overwrite){if(await a.Promises.exists(o)){if(!n.overwrite)throw(0,I.createFileSystemProviderError)((0,v.localize)(1901,null),I.FileSystemProviderErrorCode.FileExists)}else if(!n.create)throw(0,I.createFileSystemProviderError)((0,v.localize)(1902,null),I.FileSystemProviderErrorCode.FileNotFound)}s=await this.open(l,{create:!0,unlock:n.unlock},t),await this.write(s,0,r,0,r.byteLength)}catch(o){throw await this.toFileSystemProviderWriteError(l,o)}finally{typeof s=="number"&&await this.close(s)}}static{this.canFlush=!0}static configureFlushOnWrite(l){E.canFlush=l}async open(l,r,n){const t=this.toFilePath(l);let s;(0,I.isFileOpenForWriteOptions)(r)&&!n&&(s=await this.createResourceLock(l));let o;try{if((0,I.isFileOpenForWriteOptions)(r)&&r.unlock)try{const{stat:g}=await a.SymlinkSupport.stat(t);g.mode&128||await b.promises.chmod(t,g.mode|128)}catch(g){g.code!=="ENOENT"&&this.logService.trace(g)}let c;if((0,I.isFileOpenForWriteOptions)(r)){if(f.isWindows)try{await b.promises.truncate(t,0),c="r+"}catch(g){g.code!=="ENOENT"&&this.logService.trace(g)}c||(c="w")}else c="r";o=await a.Promises.open(t,c)}catch(c){throw s?.dispose(),(0,I.isFileOpenForWriteOptions)(r)?await this.toFileSystemProviderWriteError(l,c):this.toFileSystemProviderError(c)}if(this.mapHandleToPos.set(o,0),(0,I.isFileOpenForWriteOptions)(r)&&this.writeHandles.set(o,l),s){const c=this.mapHandleToLock.get(o);this.traceLock(`[Disk FileSystemProvider]: open() - storing lock for handle ${o} (${t})`),this.mapHandleToLock.set(o,s),c&&(this.traceLock(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${o} (${t})`),c.dispose())}return o}async close(l){const r=this.mapHandleToLock.get(l);try{if(this.mapHandleToPos.delete(l),this.writeHandles.delete(l)&&E.canFlush)try{await a.Promises.fdatasync(l)}catch(n){E.configureFlushOnWrite(!1),this.logService.error(n)}return await a.Promises.close(l)}catch(n){throw this.toFileSystemProviderError(n)}finally{r&&(this.mapHandleToLock.get(l)===r&&(this.traceLock(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${l}`),this.mapHandleToLock.delete(l)),this.traceLock(`[Disk FileSystemProvider]: close() - disposing lock for handle ${l}`),r.dispose())}}async read(l,r,n,t,s){const o=this.normalizePos(l,r);let c=null;try{c=(await a.Promises.read(l,n,t,s,o)).bytesRead}catch(g){throw this.toFileSystemProviderError(g)}finally{this.updatePos(l,o,c)}return c}normalizePos(l,r){return r===this.mapHandleToPos.get(l)?null:r}updatePos(l,r,n){const t=this.mapHandleToPos.get(l);typeof t=="number"&&(typeof r=="number"||(typeof n=="number"?this.mapHandleToPos.set(l,t+n):this.mapHandleToPos.delete(l)))}async write(l,r,n,t,s){return(0,C.retry)(()=>this.doWrite(l,r,n,t,s),100,3)}async doWrite(l,r,n,t,s){const o=this.normalizePos(l,r);let c=null;try{c=(await a.Promises.write(l,n,t,s,o)).bytesWritten}catch(g){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(l),g)}finally{this.updatePos(l,o,c)}return c}async mkdir(l){try{await b.promises.mkdir(this.toFilePath(l))}catch(r){throw this.toFileSystemProviderError(r)}}async delete(l,r){try{const n=this.toFilePath(l);if(r.recursive){let t;r?.atomic!==!1&&r.atomic.postfix&&(t=(0,u.join)((0,u.dirname)(n),`${(0,u.basename)(n)}${r.atomic.postfix}`)),await a.Promises.rm(n,a.RimRafMode.MOVE,t)}else try{await b.promises.unlink(n)}catch(t){if(t.code==="EPERM"||t.code==="EISDIR"){let s=!1;try{const{stat:o,symbolicLink:c}=await a.SymlinkSupport.stat(n);s=o.isDirectory()&&!c}catch{}if(s)await b.promises.rmdir(n);else throw t}else throw t}}catch(n){throw this.toFileSystemProviderError(n)}}async rename(l,r,n){const t=this.toFilePath(l),s=this.toFilePath(r);if(t!==s)try{await this.validateMoveCopy(l,r,"move",n.overwrite),await a.Promises.rename(t,s)}catch(o){throw(o.code==="EINVAL"||o.code==="EBUSY"||o.code==="ENAMETOOLONG")&&(o=new Error((0,v.localize)(1903,null,(0,u.basename)(t),(0,u.basename)((0,u.dirname)(s)),o.toString()))),this.toFileSystemProviderError(o)}}async copy(l,r,n){const t=this.toFilePath(l),s=this.toFilePath(r);if(t!==s)try{await this.validateMoveCopy(l,r,"copy",n.overwrite),await a.Promises.copy(t,s,{preserveSymlinks:!0})}catch(o){throw(o.code==="EINVAL"||o.code==="EBUSY"||o.code==="ENAMETOOLONG")&&(o=new Error((0,v.localize)(1904,null,(0,u.basename)(t),(0,u.basename)((0,u.dirname)(s)),o.toString()))),this.toFileSystemProviderError(o)}}async validateMoveCopy(l,r,n,t){const s=this.toFilePath(l),o=this.toFilePath(r);let c=!1;if(!!(this.capabilities&I.FileSystemProviderCapabilities.PathCaseSensitive)||(c=(0,D.isEqual)(s,o,!0)),c){if(n==="copy")throw(0,I.createFileSystemProviderError)((0,v.localize)(1905,null),I.FileSystemProviderErrorCode.FileExists);if(n==="move")return}const T=await this.statIgnoreError(l);if(!T)throw(0,I.createFileSystemProviderError)((0,v.localize)(1906,null),I.FileSystemProviderErrorCode.FileNotFound);const N=await this.statIgnoreError(r);if(N){if(!t)throw(0,I.createFileSystemProviderError)((0,v.localize)(1907,null),I.FileSystemProviderErrorCode.FileExists);T.type&I.FileType.File&&N.type&I.FileType.File||await this.delete(r,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(l,r){return this.doCloneFile(l,r,!1)}async doCloneFile(l,r,n){const t=this.toFilePath(l),s=this.toFilePath(r),o=!!(this.capabilities&I.FileSystemProviderCapabilities.PathCaseSensitive);if((0,D.isEqual)(t,s,!o))return;const c=new p.DisposableStore;try{c.add(await this.createResourceLock(l)),c.add(await this.createResourceLock(r)),n&&await b.promises.mkdir((0,u.dirname)(s),{recursive:!0}),await b.promises.copyFile(t,s)}catch(g){if(g.code==="ENOENT"&&!n)return this.doCloneFile(l,r,!0);throw this.toFileSystemProviderError(g)}finally{c.dispose()}}createUniversalWatcher(l,r,n){return new d.UniversalWatcherClient(t=>l(t),t=>r(t),n)}createNonRecursiveWatcher(l,r,n){return new O.NodeJSWatcherClient(t=>l(t),t=>r(t),n)}toFileSystemProviderError(l){if(l instanceof I.FileSystemProviderError)return l;let r=l,n;switch(l.code){case"ENOENT":n=I.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":n=I.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":n=I.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":n=I.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":n=I.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":r=`${l.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,n=I.FileSystemProviderErrorCode.Unknown;break;default:n=I.FileSystemProviderErrorCode.Unknown}return(0,I.createFileSystemProviderError)(r,n)}async toFileSystemProviderWriteError(l,r){let n=this.toFileSystemProviderError(r);if(l&&n.code===I.FileSystemProviderErrorCode.NoPermissions)try{const{stat:t}=await a.SymlinkSupport.stat(this.toFilePath(l));t.mode&128||(n=(0,I.createFileSystemProviderError)(r,I.FileSystemProviderErrorCode.FileWriteLocked))}catch(t){this.logService.trace(t)}return n}}e.DiskFileSystemProvider=E}),define(ce[111],de([0,1,2,6]),function(J,e,b,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogService=void 0;class S extends b.Disposable{constructor(k,D=[]){super(),this.logger=new C.MultiplexLogger([k,...D]),this._register(k.onDidChangeLogLevel(p=>this.setLevel(p)))}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(k){this.logger.setLevel(k)}getLevel(){return this.logger.getLevel()}trace(k,...D){this.logger.trace(k,...D)}debug(k,...D){this.logger.debug(k,...D)}info(k,...D){this.logger.info(k,...D)}warn(k,...D){this.logger.warn(k,...D)}error(k,...D){this.logger.error(k,...D)}flush(){this.logger.flush()}}e.LogService=S}),define(ce[112],de([0,1,9,6]),function(J,e,b,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;var S;(function(u){u[u.Trace=0]="Trace",u[u.Debug=1]="Debug",u[u.Info=2]="Info",u[u.Warning=3]="Warning",u[u.Error=4]="Error",u[u.Critical=5]="Critical",u[u.Off=6]="Off"})(S||(S={}));async function R(u,f,h,m,a){try{const v=await new Promise((w,y)=>{J(["@vscode/spdlog"],w,y)}).then(we);v.setFlushOn(S.Trace);const I=await v.createAsyncRotatingLogger(u,f,h,m);return a?I.clearFormatters():I.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),I}catch(v){console.error(v)}return null}function k(u,f,h){switch(f){case C.LogLevel.Trace:u.trace(h);break;case C.LogLevel.Debug:u.debug(h);break;case C.LogLevel.Info:u.info(h);break;case C.LogLevel.Warning:u.warn(h);break;case C.LogLevel.Error:u.error(h);break;case C.LogLevel.Off:break;default:throw new Error(`Invalid log level ${f}`)}}function D(u,f){switch(f){case C.LogLevel.Trace:u.setLevel(S.Trace);break;case C.LogLevel.Debug:u.setLevel(S.Debug);break;case C.LogLevel.Info:u.setLevel(S.Info);break;case C.LogLevel.Warning:u.setLevel(S.Warning);break;case C.LogLevel.Error:u.setLevel(S.Error);break;case C.LogLevel.Off:u.setLevel(S.Off);break;default:throw new Error(`Invalid log level ${f}`)}}class p extends C.AbstractMessageLogger{constructor(f,h,m,a,v){super(),this.buffer=[],this.setLevel(v),this._loggerCreationPromise=this._createSpdLogLogger(f,h,m,a),this._register(this.onDidChangeLogLevel(I=>{this._logger&&D(this._logger,I)}))}async _createSpdLogLogger(f,h,m,a){const v=m?6:1,I=30/v*b.ByteSize.MB,w=await R(f,h,I,v,a);if(w){this._logger=w,D(this._logger,this.getLevel());for(const{level:y,message:d}of this.buffer)k(this._logger,y,d);this.buffer=[]}}log(f,h){this._logger?k(this._logger,f,h):this.getLevel()<=f&&this.buffer.push({level:f,message:h})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger()),super.dispose()}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=p}),define(ce[113],de([0,1,28,6,112]),function(J,e,b,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerService=void 0;class R extends C.AbstractLoggerService{doCreateLogger(D,p,u){return new S.SpdLogLogger((0,b.generateUuid)(),D.fsPath,!u?.donotRotate,!!u?.donotUseFormatters,p)}}e.LoggerService=R}),define(ce[39],de([0,1,5,66,2,10]),function(J,e,b,C,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullPolicyService=e.AbstractPolicyService=e.IPolicyService=void 0,e.IPolicyService=(0,R.createDecorator)("policy");class k extends S.Disposable{constructor(){super(...arguments),this.policyDefinitions={},this.policies=new Map,this._onDidChange=this._register(new b.Emitter),this.onDidChange=this._onDidChange.event}async updatePolicyDefinitions(u){const f=Object.keys(this.policyDefinitions).length;return this.policyDefinitions={...u,...this.policyDefinitions},f!==Object.keys(this.policyDefinitions).length&&await this._updatePolicyDefinitions(u),C.Iterable.reduce(this.policies.entries(),(h,[m,a])=>({...h,[m]:a}),{})}getPolicyValue(u){return this.policies.get(u)}serialize(){return C.Iterable.reduce(Object.entries(this.policyDefinitions),(u,[f,h])=>({...u,[f]:{definition:h,value:this.policies.get(f)}}),{})}}e.AbstractPolicyService=k;class D{constructor(){this.onDidChange=b.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.NullPolicyService=D}),define(ce[114],de([0,1,8,5,66,3,9,6,39]),function(J,e,b,C,S,R,k,D,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FilePolicyService=void 0;function u(h,m){const a=[];for(const v of new Set(S.Iterable.concat(h.keys(),m.keys())))h.get(v)!==m.get(v)&&a.push(v);return a}let f=class extends p.AbstractPolicyService{constructor(m,a,v){super(),this.file=m,this.fileService=a,this.logService=v,this.throttledDelayer=this._register(new b.ThrottledDelayer(500));const I=C.Event.filter(a.onDidFilesChange,w=>w.affects(m));this._register(a.watch(m)),this._register(I(()=>this.throttledDelayer.trigger(()=>this.refresh())))}async _updatePolicyDefinitions(){await this.refresh()}async read(){const m=new Map;try{const a=await this.fileService.readFile(this.file),v=JSON.parse(a.value.toString());if(!(0,R.isObject)(v))throw new Error("Policy file isn't a JSON object");for(const I of Object.keys(v))this.policyDefinitions[I]&&m.set(I,v[I])}catch(a){a.fileOperationResult!==k.FileOperationResult.FILE_NOT_FOUND&&this.logService.error("[FilePolicyService] Failed to read policies",a)}return m}async refresh(){const m=await this.read(),a=u(this.policies,m);this.policies=m,a.length>0&&this._onDidChange.fire(a)}};e.FilePolicyService=f,e.FilePolicyService=f=Pe([oe(1,k.IFileService),oe(2,D.ILogService)],f)}),define(ce[115],de([0,1,39,8,2,6]),function(J,e,b,C,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativePolicyService=void 0;let k=class extends b.AbstractPolicyService{constructor(p,u){super(),this.logService=p,this.productName=u,this.throttler=new C.Throttler,this.watcher=this._register(new S.MutableDisposable)}async _updatePolicyDefinitions(p){this.logService.trace(`NativePolicyService#_updatePolicyDefinitions - Found ${Object.keys(p).length} policy definitions`);const{createWatcher:u}=await new Promise((f,h)=>{J(["@vscode/policy-watcher"],f,h)}).then(we);await this.throttler.queue(()=>new Promise((f,h)=>{try{this.watcher.value=u(this.productName,p,m=>{this._onDidPolicyChange(m),f()})}catch(m){this.logService.error("NativePolicyService#_updatePolicyDefinitions - Error creating watcher:",m),h(m)}}))}_onDidPolicyChange(p){this.logService.trace(`NativePolicyService#_onDidPolicyChange - Updated policy values: ${JSON.stringify(p)}`);for(const u in p){const f=p[u];f===void 0?this.policies.delete(u):this.policies.set(u,f)}this._onDidChange.fire(Object.keys(p))}};e.NativePolicyService=k,e.NativePolicyService=k=Pe([oe(0,R.ILogService)],k)}),define(ce[33],de([0,1,10]),function(J,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,b.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(ce[37],de([0,1,76,3]),function(J,e,b,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0,b=we(b),C=we(C);class S{constructor(){this.data=new Map}add(k,D){b.ok(C.isString(k)),b.ok(C.isObject(D)),b.ok(!this.data.has(k),"There is already an extension with this id"),this.data.set(k,D)}knows(k){return this.data.has(k)}as(k){return this.data.get(k)||null}}e.Registry=new S}),define(ce[116],de([0,1,5,79,37]),function(J,e,b,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,S=we(S),e.Extensions={JSONContribution:"base.contributions.json"};function R(p){return p.length>0&&p.charAt(p.length-1)==="#"?p.substring(0,p.length-1):p}class k{constructor(){this._onDidChangeSchema=new b.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(u,f){this.schemasById[R(u)]=f,this._onDidChangeSchema.fire(u)}notifySchemaChanged(u){this._onDidChangeSchema.fire(u)}getSchemaContributions(){return{schemas:this.schemasById}}getSchemaContent(u){const f=this.schemasById[u];return f?(0,C.getCompressedContent)(f):void 0}hasSchemaContent(u){return!!this.schemasById[u]}}const D=new k;S.Registry.add(e.Extensions.JSONContribution,D)}),define(ce[40],de([0,1,19,5,3,4,30,116,37]),function(J,e,b,C,S,R,k,D,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0,e.overrideIdentifiersFromKey=I,e.keyFromOverrideIdentifiers=w,e.getDefaultValue=y,e.validateProperty=O,e.getScopes=E,e.getAllConfigurationProperties=i,e.parseScope=l,S=we(S),R=we(R);var u;(function(r){r.Multiline="multilineText",r.Singleline="singlelineText"})(u||(e.EditPresentationTypes=u={})),e.Extensions={Configuration:"base.contributions.configuration"};var f;(function(r){r[r.APPLICATION=1]="APPLICATION",r[r.MACHINE=2]="MACHINE",r[r.WINDOW=3]="WINDOW",r[r.RESOURCE=4]="RESOURCE",r[r.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",r[r.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(f||(e.ConfigurationScope=f={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const h=p.Registry.as(D.Extensions.JSONContribution);class m{constructor(){this.registeredConfigurationDefaults=[],this.overrideIdentifiers=new Set,this._onDidSchemaChange=new C.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new C.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:R.localize(1662,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.policyConfigurations=new Map,this.excludedConfigurationProperties={},h.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(n,t=!0){this.registerConfigurations([n],t)}registerConfigurations(n,t=!0){const s=new Set;this.doRegisterConfigurations(n,t,s),h.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:s})}deregisterConfigurations(n){const t=new Set;this.doDeregisterConfigurations(n,t),h.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:t})}updateConfigurations({add:n,remove:t}){const s=new Set;this.doDeregisterConfigurations(t,s),this.doRegisterConfigurations(n,!1,s),h.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:s})}registerDefaultConfigurations(n){const t=new Set;this.doRegisterDefaultConfigurations(n,t),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:t,defaultsOverrides:!0})}doRegisterDefaultConfigurations(n,t){this.registeredConfigurationDefaults.push(...n);const s=[];for(const{overrides:o,source:c}of n)for(const g in o){t.add(g);const T=this.configurationDefaultsOverrides.get(g)??this.configurationDefaultsOverrides.set(g,{configurationDefaultOverrides:[]}).get(g),N=o[g];if(T.configurationDefaultOverrides.push({value:N,source:c}),e.OVERRIDE_PROPERTY_REGEX.test(g)){const A=this.mergeDefaultConfigurationsForOverrideIdentifier(g,N,c,T.configurationDefaultOverrideValue);if(!A)continue;T.configurationDefaultOverrideValue=A,this.updateDefaultOverrideProperty(g,A,c),s.push(...I(g))}else{const A=this.mergeDefaultConfigurationsForConfigurationProperty(g,N,c,T.configurationDefaultOverrideValue);if(!A)continue;T.configurationDefaultOverrideValue=A;const L=this.configurationProperties[g];L&&(this.updatePropertyDefaultValue(g,L),this.updateSchema(g,L))}}this.doRegisterOverrideIdentifiers(s)}deregisterDefaultConfigurations(n){const t=new Set;this.doDeregisterDefaultConfigurations(n,t),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:t,defaultsOverrides:!0})}doDeregisterDefaultConfigurations(n,t){for(const s of n){const o=this.registeredConfigurationDefaults.indexOf(s);o!==-1&&this.registeredConfigurationDefaults.splice(o,1)}for(const{overrides:s,source:o}of n)for(const c in s){const g=this.configurationDefaultsOverrides.get(c);if(!g)continue;const T=g.configurationDefaultOverrides.findIndex(N=>o?N.source?.id===o.id:N.value===s[c]);if(T!==-1){if(g.configurationDefaultOverrides.splice(T,1),g.configurationDefaultOverrides.length===0&&this.configurationDefaultsOverrides.delete(c),e.OVERRIDE_PROPERTY_REGEX.test(c)){let N;for(const A of g.configurationDefaultOverrides)N=this.mergeDefaultConfigurationsForOverrideIdentifier(c,A.value,A.source,N);N&&!S.isEmptyObject(N.value)?(g.configurationDefaultOverrideValue=N,this.updateDefaultOverrideProperty(c,N,o)):(this.configurationDefaultsOverrides.delete(c),delete this.configurationProperties[c],delete this.defaultLanguageConfigurationOverridesNode.properties[c])}else{let N;for(const L of g.configurationDefaultOverrides)N=this.mergeDefaultConfigurationsForConfigurationProperty(c,L.value,L.source,N);g.configurationDefaultOverrideValue=N;const A=this.configurationProperties[c];A&&(this.updatePropertyDefaultValue(c,A),this.updateSchema(c,A))}t.add(c)}}this.updateOverridePropertyPatternKey()}updateDefaultOverrideProperty(n,t,s){const o={type:"object",default:t.value,description:R.localize(1663,null,(0,k.getLanguageTagSettingPlainKey)(n)),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:t.value,source:s,defaultValueSource:s};this.configurationProperties[n]=o,this.defaultLanguageConfigurationOverridesNode.properties[n]=o}mergeDefaultConfigurationsForOverrideIdentifier(n,t,s,o){const c=o?.value||{},g=o?.source??new Map;if(!(g instanceof Map)){console.error("objectConfigurationSources is not a Map");return}for(const T of Object.keys(t)){const N=t[T];if(S.isObject(N)&&(S.isUndefined(c[T])||S.isObject(c[T]))){if(c[T]={...c[T]??{},...N},s)for(const L in N)g.set(`${T}.${L}`,s)}else c[T]=N,s?g.set(T,s):g.delete(T)}return{value:c,source:g}}mergeDefaultConfigurationsForConfigurationProperty(n,t,s,o){const c=this.configurationProperties[n],g=o?.value??c?.defaultDefaultValue;let T=s;if(S.isObject(t)&&(c!==void 0&&c.type==="object"||c===void 0&&(S.isUndefined(g)||S.isObject(g)))){if(T=o?.source??new Map,!(T instanceof Map)){console.error("defaultValueSource is not a Map");return}for(const A in t)s&&T.set(`${n}.${A}`,s);t={...S.isObject(g)?g:{},...t}}return{value:t,source:T}}deltaConfiguration(n){let t=!1;const s=new Set;n.removedDefaults&&(this.doDeregisterDefaultConfigurations(n.removedDefaults,s),t=!0),n.addedDefaults&&(this.doRegisterDefaultConfigurations(n.addedDefaults,s),t=!0),n.removedConfigurations&&this.doDeregisterConfigurations(n.removedConfigurations,s),n.addedConfigurations&&this.doRegisterConfigurations(n.addedConfigurations,!1,s),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:s,defaultsOverrides:t})}notifyConfigurationSchemaUpdated(...n){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(n){this.doRegisterOverrideIdentifiers(n),this._onDidSchemaChange.fire()}doRegisterOverrideIdentifiers(n){for(const t of n)this.overrideIdentifiers.add(t);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(n,t,s){n.forEach(o=>{this.validateAndRegisterProperties(o,t,o.extensionInfo,o.restrictedProperties,void 0,s),this.configurationContributors.push(o),this.registerJSONConfiguration(o)})}doDeregisterConfigurations(n,t){const s=o=>{if(o.properties)for(const c in o.properties){t.add(c);const g=this.configurationProperties[c];g?.policy?.name&&this.policyConfigurations.delete(g.policy.name),delete this.configurationProperties[c],this.removeFromSchema(c,o.properties[c])}o.allOf?.forEach(c=>s(c))};for(const o of n){s(o);const c=this.configurationContributors.indexOf(o);c!==-1&&this.configurationContributors.splice(c,1)}}validateAndRegisterProperties(n,t=!0,s,o,c=f.WINDOW,g){c=S.isUndefinedOrNull(n.scope)?c:n.scope;const T=n.properties;if(T)for(const A in T){const L=T[A];if(t&&O(A,L)){delete T[A];continue}if(L.source=s,L.defaultDefaultValue=T[A].default,this.updatePropertyDefaultValue(A,L),e.OVERRIDE_PROPERTY_REGEX.test(A)?L.scope=void 0:(L.scope=S.isUndefinedOrNull(L.scope)?c:L.scope,L.restricted=S.isUndefinedOrNull(L.restricted)?!!o?.includes(A):L.restricted),T[A].hasOwnProperty("included")&&!T[A].included){this.excludedConfigurationProperties[A]=T[A],delete T[A];continue}else this.configurationProperties[A]=T[A],T[A].policy?.name&&this.policyConfigurations.set(T[A].policy.name,A);!T[A].deprecationMessage&&T[A].markdownDeprecationMessage&&(T[A].deprecationMessage=T[A].markdownDeprecationMessage),g.add(A)}const N=n.allOf;if(N)for(const A of N)this.validateAndRegisterProperties(A,t,s,o,c,g)}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getPolicyConfigurations(){return this.policyConfigurations}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getRegisteredDefaultConfigurations(){return[...this.registeredConfigurationDefaults]}getConfigurationDefaultsOverrides(){const n=new Map;for(const[t,s]of this.configurationDefaultsOverrides)s.configurationDefaultOverrideValue&&n.set(t,s.configurationDefaultOverrideValue);return n}registerJSONConfiguration(n){const t=s=>{const o=s.properties;if(o)for(const g in o)this.updateSchema(g,o[g]);s.allOf?.forEach(t)};t(n)}updateSchema(n,t){switch(e.allSettings.properties[n]=t,t.scope){case f.APPLICATION:e.applicationSettings.properties[n]=t;break;case f.MACHINE:e.machineSettings.properties[n]=t;break;case f.MACHINE_OVERRIDABLE:e.machineOverridableSettings.properties[n]=t;break;case f.WINDOW:e.windowSettings.properties[n]=t;break;case f.RESOURCE:e.resourceSettings.properties[n]=t;break;case f.LANGUAGE_OVERRIDABLE:e.resourceSettings.properties[n]=t,this.resourceLanguageSettingsSchema.properties[n]=t;break}}removeFromSchema(n,t){switch(delete e.allSettings.properties[n],t.scope){case f.APPLICATION:delete e.applicationSettings.properties[n];break;case f.MACHINE:delete e.machineSettings.properties[n];break;case f.MACHINE_OVERRIDABLE:delete e.machineOverridableSettings.properties[n];break;case f.WINDOW:delete e.windowSettings.properties[n];break;case f.RESOURCE:case f.LANGUAGE_OVERRIDABLE:delete e.resourceSettings.properties[n],delete this.resourceLanguageSettingsSchema.properties[n];break}}updateOverridePropertyPatternKey(){for(const n of this.overrideIdentifiers.values()){const t=`[${n}]`,s={type:"object",description:R.localize(1664,null),errorMessage:R.localize(1665,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(t,s),e.allSettings.properties[t]=s,e.applicationSettings.properties[t]=s,e.machineSettings.properties[t]=s,e.machineOverridableSettings.properties[t]=s,e.windowSettings.properties[t]=s,e.resourceSettings.properties[t]=s}}registerOverridePropertyPatternKey(){const n={type:"object",description:R.localize(1666,null),errorMessage:R.localize(1667,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(n,t){const s=this.configurationDefaultsOverrides.get(n)?.configurationDefaultOverrideValue;let o,c;s&&(!t.disallowConfigurationDefault||!s.source)&&(o=s.value,c=s.source),S.isUndefined(o)&&(o=t.defaultDefaultValue,c=void 0),S.isUndefined(o)&&(o=y(t.type)),t.default=o,t.defaultValueSource=c}}const a="\\[([^\\]]+)\\]",v=new RegExp(a,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${a})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function I(r){const n=[];if(e.OVERRIDE_PROPERTY_REGEX.test(r)){let t=v.exec(r);for(;t?.length;){const s=t[1].trim();s&&n.push(s),t=v.exec(r)}}return(0,b.distinct)(n)}function w(r){return r.reduce((n,t)=>`${n}[${t}]`,"")}function y(r){switch(Array.isArray(r)?r[0]:r){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const d=new m;p.Registry.add(e.Extensions.Configuration,d);function O(r,n){return r.trim()?e.OVERRIDE_PROPERTY_REGEX.test(r)?R.localize(1669,null,r):d.getConfigurationProperties()[r]!==void 0?R.localize(1670,null,r):n.policy?.name&&d.getPolicyConfigurations().get(n.policy?.name)!==void 0?R.localize(1671,null,r,n.policy?.name,d.getPolicyConfigurations().get(n.policy?.name)):null:R.localize(1668,null)}function E(){const r=[],n=d.getConfigurationProperties();for(const t of Object.keys(n))r.push([t,n[t].scope]);return r.push(["launch",f.RESOURCE]),r.push(["task",f.RESOURCE]),r}function i(r){const n={};for(const t of r){const s=t.properties;if(S.isObject(s))for(const o in s)n[o]=s[o];t.allOf&&Object.assign(n,i(t.allOf))}return n}function l(r){switch(r){case"application":return f.APPLICATION;case"machine":return f.MACHINE;case"resource":return f.RESOURCE;case"machine-overridable":return f.MACHINE_OVERRIDABLE;case"language-overridable":return f.LANGUAGE_OVERRIDABLE;default:return f.WINDOW}}}),define(ce[67],de([0,1,19,5,34,2,25,27,3,12,30,40,9,37]),function(J,e,b,C,S,R,k,D,p,u,f,h,m,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0,e.mergeChanges=E,b=we(b),S=we(S),D=we(D),p=we(p);function v(n){return Object.isFrozen(n)?n:D.deepFreeze(n)}class I{static createEmptyModel(t){return new I({},[],[],void 0,t)}constructor(t,s,o,c,g){this._contents=t,this._keys=s,this._overrides=o,this.raw=c,this.logService=g,this.overrideConfigurations=new Map}get rawConfiguration(){if(!this._rawConfiguration)if(this.raw?.length){const t=this.raw.map(s=>{if(s instanceof I)return s;const o=new w("",this.logService);return o.parseRaw(s),o.configurationModel});this._rawConfiguration=t.reduce((s,o)=>o===s?o:s.merge(o),t[0])}else this._rawConfiguration=this;return this._rawConfiguration}get contents(){return this._contents}get overrides(){return this._overrides}get keys(){return this._keys}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(t){return t?(0,f.getConfigurationValue)(this.contents,t):this.contents}inspect(t,s){const o=this;return{get value(){return v(o.rawConfiguration.getValue(t))},get override(){return s?v(o.rawConfiguration.getOverrideValue(t,s)):void 0},get merged(){return v(s?o.rawConfiguration.override(s).getValue(t):o.rawConfiguration.getValue(t))},get overrides(){const c=[];for(const{contents:g,identifiers:T,keys:N}of o.rawConfiguration.overrides){const A=new I(g,N,[],void 0,o.logService).getValue(t);A!==void 0&&c.push({identifiers:T,value:A})}return c.length?v(c):void 0}}}getOverrideValue(t,s){const o=this.getContentsForOverrideIdentifer(s);return o?t?(0,f.getConfigurationValue)(o,t):o:void 0}getKeysForOverrideIdentifier(t){const s=[];for(const o of this.overrides)o.identifiers.includes(t)&&s.push(...o.keys);return b.distinct(s)}getAllOverrideIdentifiers(){const t=[];for(const s of this.overrides)t.push(...s.identifiers);return b.distinct(t)}override(t){let s=this.overrideConfigurations.get(t);return s||(s=this.createOverrideConfigurationModel(t),this.overrideConfigurations.set(t,s)),s}merge(...t){const s=D.deepClone(this.contents),o=D.deepClone(this.overrides),c=[...this.keys],g=this.raw?.length?[...this.raw]:[this];for(const T of t)if(g.push(...T.raw?.length?T.raw:[T]),!T.isEmpty()){this.mergeContents(s,T.contents);for(const N of T.overrides){const[A]=o.filter(L=>b.equals(L.identifiers,N.identifiers));A?(this.mergeContents(A.contents,N.contents),A.keys.push(...N.keys),A.keys=b.distinct(A.keys)):o.push(D.deepClone(N))}for(const N of T.keys)c.indexOf(N)===-1&&c.push(N)}return new I(s,c,o,g.every(T=>T instanceof I)?void 0:g,this.logService)}createOverrideConfigurationModel(t){const s=this.getContentsForOverrideIdentifer(t);if(!s||typeof s!="object"||!Object.keys(s).length)return this;const o={};for(const c of b.distinct([...Object.keys(this.contents),...Object.keys(s)])){let g=this.contents[c];const T=s[c];T&&(typeof g=="object"&&typeof T=="object"?(g=D.deepClone(g),this.mergeContents(g,T)):g=T),o[c]=g}return new I(o,this.keys,this.overrides,void 0,this.logService)}mergeContents(t,s){for(const o of Object.keys(s)){if(o in t&&p.isObject(t[o])&&p.isObject(s[o])){this.mergeContents(t[o],s[o]);continue}t[o]=D.deepClone(s[o])}}getContentsForOverrideIdentifer(t){let s=null,o=null;const c=g=>{g&&(o?this.mergeContents(o,g):o=D.deepClone(g))};for(const g of this.overrides)g.identifiers.length===1&&g.identifiers[0]===t?s=g.contents:g.identifiers.includes(t)&&c(g.contents);return c(s),o}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(t,s){this.updateValue(t,s,!0)}setValue(t,s){this.updateValue(t,s,!1)}removeValue(t){const s=this.keys.indexOf(t);s!==-1&&(this.keys.splice(s,1),(0,f.removeFromValueTree)(this.contents,t),h.OVERRIDE_PROPERTY_REGEX.test(t)&&this.overrides.splice(this.overrides.findIndex(o=>b.equals(o.identifiers,(0,h.overrideIdentifiersFromKey)(t))),1))}updateValue(t,s,o){if((0,f.addToValueTree)(this.contents,t,s,c=>this.logService.error(c)),o=o||this.keys.indexOf(t)===-1,o&&this.keys.push(t),h.OVERRIDE_PROPERTY_REGEX.test(t)){const c=(0,h.overrideIdentifiersFromKey)(t),g={identifiers:c,keys:Object.keys(this.contents[t]),contents:(0,f.toValuesTree)(this.contents[t],N=>this.logService.error(N))},T=this.overrides.findIndex(N=>b.equals(N.identifiers,c));T!==-1?this.overrides[T]=g:this.overrides.push(g)}}}e.ConfigurationModel=I;class w{constructor(t,s){this._name=t,this.logService=s,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||I.createEmptyModel(this.logService)}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(t,s){if(!p.isUndefinedOrNull(t)){const o=this.doParseContent(t);this.parseRaw(o,s)}}reparse(t){this._raw&&this.parseRaw(this._raw,t)}parseRaw(t,s){this._raw=t;const{contents:o,keys:c,overrides:g,restricted:T,hasExcludedProperties:N}=this.doParseRaw(t,s);this._configurationModel=new I(o,c,g,N?[t]:void 0,this.logService),this._restrictedConfigurations=T||[]}doParseContent(t){let s={},o=null,c=[];const g=[],T=[];function N(L){Array.isArray(c)?c.push(L):o!==null&&(c[o]=L)}const A={onObjectBegin:()=>{const L={};N(L),g.push(c),c=L,o=null},onObjectProperty:L=>{o=L},onObjectEnd:()=>{c=g.pop()},onArrayBegin:()=>{const L=[];N(L),g.push(c),c=L,o=null},onArrayEnd:()=>{c=g.pop()},onLiteralValue:N,onError:(L,M,B)=>{T.push({error:L,offset:M,length:B})}};if(t)try{S.visit(t,A),s=c[0]||{}}catch(L){this.logService.error(`Error while parsing settings file ${this._name}: ${L}`),this._parseErrors=[L]}return s}doParseRaw(t,s){const o=a.Registry.as(h.Extensions.Configuration).getConfigurationProperties(),c=this.filter(t,o,!0,s);t=c.raw;const g=(0,f.toValuesTree)(t,A=>this.logService.error(`Conflict in settings file ${this._name}: ${A}`)),T=Object.keys(t),N=this.toOverrides(t,A=>this.logService.error(`Conflict in settings file ${this._name}: ${A}`));return{contents:g,keys:T,overrides:N,restricted:c.restricted,hasExcludedProperties:c.hasExcludedProperties}}filter(t,s,o,c){let g=!1;if(!c?.scopes&&!c?.skipRestricted&&!c?.exclude?.length)return{raw:t,restricted:[],hasExcludedProperties:g};const T={},N=[];for(const A in t)if(h.OVERRIDE_PROPERTY_REGEX.test(A)&&o){const L=this.filter(t[A],s,!1,c);T[A]=L.raw,g=g||L.hasExcludedProperties,N.push(...L.restricted)}else{const L=s[A],M=L?typeof L.scope<"u"?L.scope:h.ConfigurationScope.WINDOW:void 0;L?.restricted&&N.push(A),!c.exclude?.includes(A)&&(c.include?.includes(A)||(M===void 0||c.scopes===void 0||c.scopes.includes(M))&&!(c.skipRestricted&&L?.restricted))?T[A]=t[A]:g=!0}return{raw:T,restricted:N,hasExcludedProperties:g}}toOverrides(t,s){const o=[];for(const c of Object.keys(t))if(h.OVERRIDE_PROPERTY_REGEX.test(c)){const g={};for(const T in t[c])g[T]=t[c][T];o.push({identifiers:(0,h.overrideIdentifiersFromKey)(c),keys:Object.keys(g),contents:(0,f.toValuesTree)(g,s)})}return o}}e.ConfigurationModelParser=w;class y extends R.Disposable{constructor(t,s,o,c,g){super(),this.userSettingsResource=t,this.parseOptions=s,this.fileService=c,this.logService=g,this._onDidChange=this._register(new C.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new w(this.userSettingsResource.toString(),g),this._register(this.fileService.watch(o.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(C.Event.any(C.Event.filter(this.fileService.onDidFilesChange,T=>T.contains(this.userSettingsResource)),C.Event.filter(this.fileService.onDidRunOperation,T=>(T.isOperation(m.FileOperation.CREATE)||T.isOperation(m.FileOperation.COPY)||T.isOperation(m.FileOperation.DELETE)||T.isOperation(m.FileOperation.WRITE))&&o.isEqual(T.resource,t)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const t=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(t.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return I.createEmptyModel(this.logService)}}reparse(t){return t&&(this.parseOptions=t),this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=y;class d{constructor(t,s,o,c,g,T,N,A,L,M,B,Q,re){this.key=t,this.overrides=s,this._value=o,this.overrideIdentifiers=c,this.defaultConfiguration=g,this.policyConfiguration=T,this.applicationConfiguration=N,this.userConfiguration=A,this.localUserConfiguration=L,this.remoteUserConfiguration=M,this.workspaceConfiguration=B,this.folderConfigurationModel=Q,this.memoryConfigurationModel=re}get value(){return v(this._value)}toInspectValue(t){return t?.value!==void 0||t?.override!==void 0||t?.overrides!==void 0?t:void 0}get defaultInspectValue(){return this._defaultInspectValue||(this._defaultInspectValue=this.defaultConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._defaultInspectValue}get defaultValue(){return this.defaultInspectValue.merged}get default(){return this.toInspectValue(this.defaultInspectValue)}get policyInspectValue(){return this._policyInspectValue===void 0&&(this._policyInspectValue=this.policyConfiguration?this.policyConfiguration.inspect(this.key):null),this._policyInspectValue}get policyValue(){return this.policyInspectValue?.merged}get policy(){return this.policyInspectValue?.value!==void 0?{value:this.policyInspectValue.value}:void 0}get applicationInspectValue(){return this._applicationInspectValue===void 0&&(this._applicationInspectValue=this.applicationConfiguration?this.applicationConfiguration.inspect(this.key):null),this._applicationInspectValue}get applicationValue(){return this.applicationInspectValue?.merged}get application(){return this.toInspectValue(this.applicationInspectValue)}get userInspectValue(){return this._userInspectValue||(this._userInspectValue=this.userConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._userInspectValue}get userValue(){return this.userInspectValue.merged}get user(){return this.toInspectValue(this.userInspectValue)}get userLocalInspectValue(){return this._userLocalInspectValue||(this._userLocalInspectValue=this.localUserConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._userLocalInspectValue}get userLocalValue(){return this.userLocalInspectValue.merged}get userLocal(){return this.toInspectValue(this.userLocalInspectValue)}get userRemoteInspectValue(){return this._userRemoteInspectValue||(this._userRemoteInspectValue=this.remoteUserConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._userRemoteInspectValue}get userRemoteValue(){return this.userRemoteInspectValue.merged}get userRemote(){return this.toInspectValue(this.userRemoteInspectValue)}get workspaceInspectValue(){return this._workspaceInspectValue===void 0&&(this._workspaceInspectValue=this.workspaceConfiguration?this.workspaceConfiguration.inspect(this.key,this.overrides.overrideIdentifier):null),this._workspaceInspectValue}get workspaceValue(){return this.workspaceInspectValue?.merged}get workspace(){return this.toInspectValue(this.workspaceInspectValue)}get workspaceFolderInspectValue(){return this._workspaceFolderInspectValue===void 0&&(this._workspaceFolderInspectValue=this.folderConfigurationModel?this.folderConfigurationModel.inspect(this.key,this.overrides.overrideIdentifier):null),this._workspaceFolderInspectValue}get workspaceFolderValue(){return this.workspaceFolderInspectValue?.merged}get workspaceFolder(){return this.toInspectValue(this.workspaceFolderInspectValue)}get memoryInspectValue(){return this._memoryInspectValue===void 0&&(this._memoryInspectValue=this.memoryConfigurationModel.inspect(this.key,this.overrides.overrideIdentifier)),this._memoryInspectValue}get memoryValue(){return this.memoryInspectValue.merged}get memory(){return this.toInspectValue(this.memoryInspectValue)}}class O{constructor(t,s,o,c,g,T,N,A,L,M){this._defaultConfiguration=t,this._policyConfiguration=s,this._applicationConfiguration=o,this._localUserConfiguration=c,this._remoteUserConfiguration=g,this._workspaceConfiguration=T,this._folderConfigurations=N,this._memoryConfiguration=A,this._memoryConfigurationByResource=L,this.logService=M,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new k.ResourceMap,this._userConfiguration=null}getValue(t,s,o){return this.getConsolidatedConfigurationModel(t,s,o).getValue(t)}updateValue(t,s,o={}){let c;o.resource?(c=this._memoryConfigurationByResource.get(o.resource),c||(c=I.createEmptyModel(this.logService),this._memoryConfigurationByResource.set(o.resource,c))):c=this._memoryConfiguration,s===void 0?c.removeValue(t):c.setValue(t,s),o.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(t,s,o){const c=this.getConsolidatedConfigurationModel(t,s,o),g=this.getFolderConfigurationModelForResource(s.resource,o),T=s.resource?this._memoryConfigurationByResource.get(s.resource)||this._memoryConfiguration:this._memoryConfiguration,N=new Set;for(const A of c.overrides)for(const L of A.identifiers)c.getOverrideValue(t,L)!==void 0&&N.add(L);return new d(t,s,c.getValue(t),N.size?[...N]:void 0,this._defaultConfiguration,this._policyConfiguration.isEmpty()?void 0:this._policyConfiguration,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,o?this._workspaceConfiguration:void 0,g||void 0,T)}keys(t){const s=this.getFolderConfigurationModelForResource(void 0,t);return{default:this._defaultConfiguration.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this._workspaceConfiguration.keys.slice(0),workspaceFolder:s?s.keys.slice(0):[]}}updateDefaultConfiguration(t){this._defaultConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updatePolicyConfiguration(t){this._policyConfiguration=t}updateApplicationConfiguration(t){this._applicationConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(t){this._localUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(t){this._remoteUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(t){this._workspaceConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(t,s){this._folderConfigurations.set(t,s),this._foldersConsolidatedConfigurations.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this._foldersConsolidatedConfigurations.delete(t)}compareAndUpdateDefaultConfiguration(t,s){const o=[];if(!s){const{added:c,updated:g,removed:T}=l(this._defaultConfiguration,t);s=[...c,...g,...T]}for(const c of s)for(const g of(0,h.overrideIdentifiersFromKey)(c)){const T=this._defaultConfiguration.getKeysForOverrideIdentifier(g),N=t.getKeysForOverrideIdentifier(g),A=[...N.filter(L=>T.indexOf(L)===-1),...T.filter(L=>N.indexOf(L)===-1),...T.filter(L=>!D.equals(this._defaultConfiguration.override(g).getValue(L),t.override(g).getValue(L)))];o.push([g,A])}return this.updateDefaultConfiguration(t),{keys:s,overrides:o}}compareAndUpdatePolicyConfiguration(t){const{added:s,updated:o,removed:c}=l(this._policyConfiguration,t),g=[...s,...o,...c];return g.length&&this.updatePolicyConfiguration(t),{keys:g,overrides:[]}}compareAndUpdateApplicationConfiguration(t){const{added:s,updated:o,removed:c,overrides:g}=l(this.applicationConfiguration,t),T=[...s,...o,...c];return T.length&&this.updateApplicationConfiguration(t),{keys:T,overrides:g}}compareAndUpdateLocalUserConfiguration(t){const{added:s,updated:o,removed:c,overrides:g}=l(this.localUserConfiguration,t),T=[...s,...o,...c];return T.length&&this.updateLocalUserConfiguration(t),{keys:T,overrides:g}}compareAndUpdateRemoteUserConfiguration(t){const{added:s,updated:o,removed:c,overrides:g}=l(this.remoteUserConfiguration,t),T=[...s,...o,...c];return T.length&&this.updateRemoteUserConfiguration(t),{keys:T,overrides:g}}compareAndUpdateWorkspaceConfiguration(t){const{added:s,updated:o,removed:c,overrides:g}=l(this.workspaceConfiguration,t),T=[...s,...o,...c];return T.length&&this.updateWorkspaceConfiguration(t),{keys:T,overrides:g}}compareAndUpdateFolderConfiguration(t,s){const o=this.folderConfigurations.get(t),{added:c,updated:g,removed:T,overrides:N}=l(o,s),A=[...c,...g,...T];return(A.length||!o)&&this.updateFolderConfiguration(t,s),{keys:A,overrides:N}}compareAndDeleteFolderConfiguration(t){const s=this.folderConfigurations.get(t);if(!s)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:o,updated:c,removed:g,overrides:T}=l(s,void 0);return{keys:[...o,...c,...g],overrides:T}}get defaults(){return this._defaultConfiguration}get applicationConfiguration(){return this._applicationConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration)),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidatedConfigurationModel(t,s,o){let c=this.getConsolidatedConfigurationModelForResource(s,o);return s.overrideIdentifier&&(c=c.override(s.overrideIdentifier)),!this._policyConfiguration.isEmpty()&&this._policyConfiguration.getValue(t)!==void 0&&(c=c.merge(this._policyConfiguration)),c}getConsolidatedConfigurationModelForResource({resource:t},s){let o=this.getWorkspaceConsolidatedConfiguration();if(s&&t){const c=s.getFolder(t);c&&(o=this.getFolderConsolidatedConfiguration(c.uri)||o);const g=this._memoryConfigurationByResource.get(t);g&&(o=o.merge(g))}return o}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.applicationConfiguration,this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration)),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(t){let s=this._foldersConsolidatedConfigurations.get(t);if(!s){const o=this.getWorkspaceConsolidatedConfiguration(),c=this._folderConfigurations.get(t);c?(s=o.merge(c),this._foldersConsolidatedConfigurations.set(t,s)):s=o}return s}getFolderConfigurationModelForResource(t,s){if(s&&t){const o=s.getFolder(t);if(o)return this._folderConfigurations.get(o.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},policy:{contents:this._policyConfiguration.contents,overrides:this._policyConfiguration.overrides,keys:this._policyConfiguration.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((t,s)=>{const{contents:o,overrides:c,keys:g}=this._folderConfigurations.get(s);return t.push([s,{contents:o,overrides:c,keys:g}]),t},[])}}allKeys(){const t=new Set;return this._defaultConfiguration.keys.forEach(s=>t.add(s)),this.userConfiguration.keys.forEach(s=>t.add(s)),this._workspaceConfiguration.keys.forEach(s=>t.add(s)),this._folderConfigurations.forEach(s=>s.keys.forEach(o=>t.add(o))),[...t.values()]}allOverrideIdentifiers(){const t=new Set;return this._defaultConfiguration.getAllOverrideIdentifiers().forEach(s=>t.add(s)),this.userConfiguration.getAllOverrideIdentifiers().forEach(s=>t.add(s)),this._workspaceConfiguration.getAllOverrideIdentifiers().forEach(s=>t.add(s)),this._folderConfigurations.forEach(s=>s.getAllOverrideIdentifiers().forEach(o=>t.add(o))),[...t.values()]}getAllKeysForOverrideIdentifier(t){const s=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(t).forEach(o=>s.add(o)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(o=>s.add(o)),this._workspaceConfiguration.getKeysForOverrideIdentifier(t).forEach(o=>s.add(o)),this._folderConfigurations.forEach(o=>o.getKeysForOverrideIdentifier(t).forEach(c=>s.add(c))),[...s.values()]}static parse(t,s){const o=this.parseConfigurationModel(t.defaults,s),c=this.parseConfigurationModel(t.policy,s),g=this.parseConfigurationModel(t.application,s),T=this.parseConfigurationModel(t.user,s),N=this.parseConfigurationModel(t.workspace,s),A=t.folders.reduce((L,M)=>(L.set(u.URI.revive(M[0]),this.parseConfigurationModel(M[1],s)),L),new k.ResourceMap);return new O(o,c,g,T,I.createEmptyModel(s),N,A,I.createEmptyModel(s),new k.ResourceMap,s)}static parseConfigurationModel(t,s){return new I(t.contents,t.keys,t.overrides,void 0,s)}}e.Configuration=O;function E(...n){if(n.length===0)return{keys:[],overrides:[]};if(n.length===1)return n[0];const t=new Set,s=new Map;for(const c of n)c.keys.forEach(g=>t.add(g)),c.overrides.forEach(([g,T])=>{const N=(0,k.getOrSet)(s,g,new Set);T.forEach(A=>N.add(A))});const o=[];return s.forEach((c,g)=>o.push([g,[...c.values()]])),{keys:[...t.values()],overrides:o}}class i{constructor(t,s,o,c,g){this.change=t,this.previous=s,this.currentConfiguraiton=o,this.currentWorkspace=c,this.logService=g,this._marker=`
`,this._markerCode1=this._marker.charCodeAt(0),this._markerCode2=46,this.affectedKeys=new Set,this._previousConfiguration=void 0;for(const T of t.keys)this.affectedKeys.add(T);for(const[,T]of t.overrides)for(const N of T)this.affectedKeys.add(N);this._affectsConfigStr=this._marker;for(const T of this.affectedKeys)this._affectsConfigStr+=T+this._marker}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=O.parse(this.previous.data,this.logService)),this._previousConfiguration}affectsConfiguration(t,s){const o=this._marker+t,c=this._affectsConfigStr.indexOf(o);if(c<0)return!1;const g=c+o.length;if(g>=this._affectsConfigStr.length)return!1;const T=this._affectsConfigStr.charCodeAt(g);if(T!==this._markerCode1&&T!==this._markerCode2)return!1;if(s){const N=this.previousConfiguration?this.previousConfiguration.getValue(t,s,this.previous?.workspace):void 0,A=this.currentConfiguraiton.getValue(t,s,this.currentWorkspace);return!D.equals(N,A)}return!0}}e.ConfigurationChangeEvent=i;function l(n,t){const{added:s,removed:o,updated:c}=r(t?.rawConfiguration,n?.rawConfiguration),g=[],T=n?.getAllOverrideIdentifiers()||[],N=t?.getAllOverrideIdentifiers()||[];if(t){const A=N.filter(L=>!T.includes(L));for(const L of A)g.push([L,t.getKeysForOverrideIdentifier(L)])}if(n){const A=T.filter(L=>!N.includes(L));for(const L of A)g.push([L,n.getKeysForOverrideIdentifier(L)])}if(t&&n){for(const A of T)if(N.includes(A)){const L=r({contents:n.getOverrideValue(void 0,A)||{},keys:n.getKeysForOverrideIdentifier(A)},{contents:t.getOverrideValue(void 0,A)||{},keys:t.getKeysForOverrideIdentifier(A)});g.push([A,[...L.added,...L.removed,...L.updated]])}}return{added:s,removed:o,updated:c,overrides:g}}function r(n,t){const s=n?t?n.keys.filter(g=>t.keys.indexOf(g)===-1):[...n.keys]:[],o=t?n?t.keys.filter(g=>n.keys.indexOf(g)===-1):[...t.keys]:[],c=[];if(n&&t){for(const g of t.keys)if(n.keys.indexOf(g)!==-1){const T=(0,f.getConfigurationValue)(t.contents,g),N=(0,f.getConfigurationValue)(n.contents,g);D.equals(T,N)||c.push(g)}}return{added:s,removed:o,updated:c}}}),define(ce[117],de([0,1,19,5,2,27,3,67,40,6,39,37]),function(J,e,b,C,S,R,k,D,p,u,f,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyConfiguration=e.NullPolicyConfiguration=e.DefaultConfiguration=void 0;class m extends S.Disposable{get configurationModel(){return this._configurationModel}constructor(w){super(),this.logService=w,this._onDidChangeConfiguration=this._register(new C.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this._configurationModel=D.ConfigurationModel.createEmptyModel(this.logService)}async initialize(){return this.resetConfigurationModel(),this._register(h.Registry.as(p.Extensions.Configuration).onDidUpdateConfiguration(({properties:w,defaultsOverrides:y})=>this.onDidUpdateConfiguration(Array.from(w),y))),this.configurationModel}reload(){return this.resetConfigurationModel(),this.configurationModel}onDidUpdateConfiguration(w,y){this.updateConfigurationModel(w,h.Registry.as(p.Extensions.Configuration).getConfigurationProperties()),this._onDidChangeConfiguration.fire({defaults:this.configurationModel,properties:w})}getConfigurationDefaultOverrides(){return{}}resetConfigurationModel(){this._configurationModel=D.ConfigurationModel.createEmptyModel(this.logService);const w=h.Registry.as(p.Extensions.Configuration).getConfigurationProperties();this.updateConfigurationModel(Object.keys(w),w)}updateConfigurationModel(w,y){const d=this.getConfigurationDefaultOverrides();for(const O of w){const E=d[O],i=y[O];E!==void 0?this._configurationModel.setValue(O,E):i?this._configurationModel.setValue(O,i.default):this._configurationModel.removeValue(O)}}}e.DefaultConfiguration=m;class a{constructor(){this.onDidChangeConfiguration=C.Event.None,this.configurationModel=D.ConfigurationModel.createEmptyModel(new u.NullLogService)}async initialize(){return this.configurationModel}}e.NullPolicyConfiguration=a;let v=class extends S.Disposable{get configurationModel(){return this._configurationModel}constructor(w,y,d){super(),this.defaultConfiguration=w,this.policyService=y,this.logService=d,this._onDidChangeConfiguration=this._register(new C.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this._configurationModel=D.ConfigurationModel.createEmptyModel(this.logService)}async initialize(){return this.logService.trace("PolicyConfiguration#initialize"),this.update(await this.updatePolicyDefinitions(this.defaultConfiguration.configurationModel.keys),!1),this._register(this.policyService.onDidChange(w=>this.onDidChangePolicies(w))),this._register(this.defaultConfiguration.onDidChangeConfiguration(async({properties:w})=>this.update(await this.updatePolicyDefinitions(w),!0))),this._configurationModel}async updatePolicyDefinitions(w){this.logService.trace("PolicyConfiguration#updatePolicyDefinitions",w);const y={},d=[],O=h.Registry.as(p.Extensions.Configuration).getConfigurationProperties();for(const E of w){const i=O[E];if(!i){d.push(E);continue}if(i.policy){if(i.type!=="string"&&i.type!=="number"){this.logService.warn(`Policy ${i.policy.name} has unsupported type ${i.type}`);continue}d.push(E),y[i.policy.name]={type:i.type}}}return(0,k.isEmptyObject)(y)||await this.policyService.updatePolicyDefinitions(y),d}onDidChangePolicies(w){this.logService.trace("PolicyConfiguration#onDidChangePolicies",w);const y=h.Registry.as(p.Extensions.Configuration).getPolicyConfigurations(),d=(0,b.coalesce)(w.map(O=>y.get(O)));this.update(d,!0)}update(w,y){this.logService.trace("PolicyConfiguration#update",w);const d=h.Registry.as(p.Extensions.Configuration).getConfigurationProperties(),O=[],E=this._configurationModel.isEmpty();for(const i of w){const l=d[i]?.policy?.name;if(l){const r=this.policyService.getPolicyValue(l);(E?r!==void 0:!(0,R.equals)(this._configurationModel.getValue(i),r))&&O.push([i,r])}else this._configurationModel.getValue(i)!==void 0&&O.push([i,void 0])}if(O.length){this.logService.trace("PolicyConfiguration#changed",O);const i=this._configurationModel;this._configurationModel=D.ConfigurationModel.createEmptyModel(this.logService);for(const l of i.keys)this._configurationModel.setValue(l,i.getValue(l));for(const[l,r]of O)r===void 0?this._configurationModel.removeValue(l):this._configurationModel.setValue(l,r);y&&this._onDidChangeConfiguration.fire(this._configurationModel)}}};e.PolicyConfiguration=v,e.PolicyConfiguration=v=Pe([oe(1,f.IPolicyService),oe(2,u.ILogService)],v)}),define(ce[118],de([0,1,19,8,13,5,34,78,2,25,27,11,16,30,67,40,117,9,39]),function(J,e,b,C,S,R,k,D,p,u,f,h,m,a,v,I,w,y,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class O extends p.Disposable{constructor(l,r,n,t){super(),this.settingsResource=l,this.logService=t,this._onDidChangeConfiguration=this._register(new R.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.defaultConfiguration=this._register(new w.DefaultConfiguration(t)),this.policyConfiguration=n instanceof d.NullPolicyService?new w.NullPolicyConfiguration:this._register(new w.PolicyConfiguration(this.defaultConfiguration,n,t)),this.userConfiguration=this._register(new v.UserSettings(this.settingsResource,{},m.extUriBiasedIgnorePathCase,r,t)),this.configuration=new v.Configuration(this.defaultConfiguration.configurationModel,this.policyConfiguration.configurationModel,v.ConfigurationModel.createEmptyModel(t),v.ConfigurationModel.createEmptyModel(t),v.ConfigurationModel.createEmptyModel(t),v.ConfigurationModel.createEmptyModel(t),new u.ResourceMap,v.ConfigurationModel.createEmptyModel(t),new u.ResourceMap,t),this.configurationEditing=new E(l,r,this),this.reloadConfigurationScheduler=this._register(new C.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(this.defaultConfiguration.onDidChangeConfiguration(({defaults:s,properties:o})=>this.onDidDefaultConfigurationChange(s,o))),this._register(this.policyConfiguration.onDidChangeConfiguration(s=>this.onDidPolicyConfigurationChange(s))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const[l,r,n]=await Promise.all([this.defaultConfiguration.initialize(),this.policyConfiguration.initialize(),this.userConfiguration.loadConfiguration()]);this.configuration=new v.Configuration(l,r,v.ConfigurationModel.createEmptyModel(this.logService),n,v.ConfigurationModel.createEmptyModel(this.logService),v.ConfigurationModel.createEmptyModel(this.logService),new u.ResourceMap,v.ConfigurationModel.createEmptyModel(this.logService),new u.ResourceMap,this.logService)}getConfigurationData(){return this.configuration.toData()}getValue(l,r){const n=typeof l=="string"?l:void 0,t=(0,a.isConfigurationOverrides)(l)?l:(0,a.isConfigurationOverrides)(r)?r:{};return this.configuration.getValue(n,t,void 0)}async updateValue(l,r,n,t,s){const o=(0,a.isConfigurationUpdateOverrides)(n)?n:(0,a.isConfigurationOverrides)(n)?{resource:n.resource,overrideIdentifiers:n.overrideIdentifier?[n.overrideIdentifier]:void 0}:void 0,c=o?t:n;if(c!==void 0&&c!==a.ConfigurationTarget.USER_LOCAL&&c!==a.ConfigurationTarget.USER)throw new Error(`Unable to write ${l} to target ${c}.`);o?.overrideIdentifiers&&(o.overrideIdentifiers=(0,b.distinct)(o.overrideIdentifiers),o.overrideIdentifiers=o.overrideIdentifiers.length?o.overrideIdentifiers:void 0);const g=this.inspect(l,{resource:o?.resource,overrideIdentifier:o?.overrideIdentifiers?o.overrideIdentifiers[0]:void 0});if(g.policyValue!==void 0)throw new Error(`Unable to write ${l} because it is configured in system policy.`);if((0,f.equals)(r,g.defaultValue)&&(r=void 0),o?.overrideIdentifiers?.length&&o.overrideIdentifiers.length>1){const N=o.overrideIdentifiers.sort(),A=this.configuration.localUserConfiguration.overrides.find(L=>(0,b.equals)([...L.identifiers].sort(),N));A&&(o.overrideIdentifiers=A.identifiers)}const T=o?.overrideIdentifiers?.length?[(0,I.keyFromOverrideIdentifiers)(o.overrideIdentifiers),l]:[l];await this.configurationEditing.write(T,r),await this.reloadConfiguration()}inspect(l,r={}){return this.configuration.inspect(l,r,void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const l=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(l)}onDidChangeUserConfiguration(l){const r=this.configuration.toData(),n=this.configuration.compareAndUpdateLocalUserConfiguration(l);this.trigger(n,r,a.ConfigurationTarget.USER)}onDidDefaultConfigurationChange(l,r){const n=this.configuration.toData(),t=this.configuration.compareAndUpdateDefaultConfiguration(l,r);this.trigger(t,n,a.ConfigurationTarget.DEFAULT)}onDidPolicyConfigurationChange(l){const r=this.configuration.toData(),n=this.configuration.compareAndUpdatePolicyConfiguration(l);this.trigger(n,r,a.ConfigurationTarget.DEFAULT)}trigger(l,r,n){const t=new v.ConfigurationChangeEvent(l,{data:r},this.configuration,void 0,this.logService);t.source=n,this._onDidChangeConfiguration.fire(t)}}e.ConfigurationService=O;class E{constructor(l,r,n){this.settingsResource=l,this.fileService=r,this.configurationService=n,this.queue=new C.Queue}write(l,r){return this.queue.queue(()=>this.doWriteConfiguration(l,r))}async doWriteConfiguration(l,r){let n;try{n=(await this.fileService.readFile(this.settingsResource)).value.toString()}catch(o){if(o.fileOperationResult===y.FileOperationResult.FILE_NOT_FOUND)n="{}";else throw o}const t=[];if((0,k.parse)(n,t,{allowTrailingComma:!0,allowEmptyContent:!0}),t.length>0)throw new Error("Unable to write into the settings file. Please open the file to correct errors/warnings in the file and try again.");const s=this.getEdits(n,l,r);n=(0,D.applyEdits)(n,s),await this.fileService.writeFile(this.settingsResource,S.VSBuffer.fromString(n))}getEdits(l,r,n){const{tabSize:t,insertSpaces:s,eol:o}=this.formattingOptions;if(!r.length){const c=JSON.stringify(n,null,s?" ".repeat(t):"	");return[{content:c,length:c.length,offset:0}]}return(0,D.setProperty)(l,r,n,{tabSize:t,insertSpaces:s,eol:o})}get formattingOptions(){if(!this._formattingOptions){let l=h.OS===h.OperatingSystem.Linux||h.OS===h.OperatingSystem.Macintosh?`
`:`\r
`;const r=this.configurationService.getValue("files.eol",{overrideIdentifier:"jsonc"});r&&typeof r=="string"&&r!=="auto"&&(l=r),this._formattingOptions={eol:l,insertSpaces:!!this.configurationService.getValue("editor.insertSpaces",{overrideIdentifier:"jsonc"}),tabSize:this.configurationService.getValue("editor.tabSize",{overrideIdentifier:"jsonc"})}}return this._formattingOptions}}}),define(ce[68],de([0,1,14]),function(J,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteAuthority=C,e.getRemoteName=S,e.parseAuthorityWithPort=R,e.parseAuthorityWithOptionalPort=k;function C(p){return p.scheme===b.Schemas.vscodeRemote?p.authority:void 0}function S(p){if(!p)return;const u=p.indexOf("+");return u<0?p:p.substr(0,u)}function R(p){const{host:u,port:f}=D(p);if(typeof f>"u")throw new Error(`Invalid remote authority: ${p}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:u,port:f}}function k(p,u){let{host:f,port:h}=D(p);return typeof h>"u"&&(h=u),{host:f,port:h}}function D(p){const u=p.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(u)return{host:u[1],port:parseInt(u[2],10)};const f=p.match(/^(\[[0-9a-z:]+\])$/);if(f)return{host:f[1],port:void 0};const h=p.match(/(.*):(\d+)$/);return h?{host:h[1],port:parseInt(h[2],10)}:{host:p,port:void 0}}}),define(ce[22],de([0,1,31,10,68]),function(J,e,b,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.ExtensionIdentifierMap=e.ExtensionIdentifierSet=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=void 0,e.getWorkspaceSupportTypeMessage=R,e.isApplicationScopedExtension=h,e.isLanguagePackExtension=m,e.isAuthenticationProviderExtension=a,e.isResolverExtension=v,e.parseApiProposals=I,e.parseEnabledApiProposalNames=w,b=we(b),e.USER_MANIFEST_CACHE_FILE="extensions.user.cache",e.BUILTIN_MANIFEST_CACHE_FILE="extensions.builtin.cache",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function R(y){if(typeof y=="object"&&y!==null&&y.supported!==!0)return y.description}e.EXTENSION_CATEGORIES=["AI","Azure","Chat","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var k;(function(y){y[y.System=0]="System",y[y.User=1]="User"})(k||(e.ExtensionType=k={}));var D;(function(y){y.WIN32_X64="win32-x64",y.WIN32_ARM64="win32-arm64",y.LINUX_X64="linux-x64",y.LINUX_ARM64="linux-arm64",y.LINUX_ARMHF="linux-armhf",y.LINUX_PPC64LE="linux-ppc64le",y.LINUX_RISCV64="linux-riscv64",y.ALPINE_X64="alpine-x64",y.ALPINE_ARM64="alpine-arm64",y.DARWIN_X64="darwin-x64",y.DARWIN_ARM64="darwin-arm64",y.WEB="web",y.UNIVERSAL="universal",y.UNKNOWN="unknown",y.UNDEFINED="undefined"})(D||(e.TargetPlatform=D={}));class p{constructor(d){this.value=d,this._lower=d.toLowerCase()}static equals(d,O){if(typeof d>"u"||d===null)return typeof O>"u"||O===null;if(typeof O>"u"||O===null)return!1;if(typeof d=="string"||typeof O=="string"){const E=typeof d=="string"?d:d.value,i=typeof O=="string"?O:O.value;return b.equalsIgnoreCase(E,i)}return d._lower===O._lower}static toKey(d){return typeof d=="string"?d.toLowerCase():d._lower}}e.ExtensionIdentifier=p;class u{get size(){return this._set.size}constructor(d){if(this._set=new Set,d)for(const O of d)this.add(O)}add(d){this._set.add(p.toKey(d))}delete(d){return this._set.delete(p.toKey(d))}has(d){return this._set.has(p.toKey(d))}}e.ExtensionIdentifierSet=u;class f{constructor(){this._map=new Map}clear(){this._map.clear()}delete(d){this._map.delete(p.toKey(d))}get(d){return this._map.get(p.toKey(d))}has(d){return this._map.has(p.toKey(d))}set(d,O){this._map.set(p.toKey(d),O)}values(){return this._map.values()}forEach(d){this._map.forEach(d)}[Symbol.iterator](){return this._map[Symbol.iterator]()}}e.ExtensionIdentifierMap=f;function h(y){return m(y)}function m(y){return y.contributes&&y.contributes.localizations?y.contributes.localizations.length>0:!1}function a(y){return y.contributes&&y.contributes.authentication?y.contributes.authentication.length>0:!1}function v(y,d){if(d){const O=`onResolveRemoteAuthority:${(0,S.getRemoteName)(d)}`;return!!y.activationEvents?.includes(O)}return!1}function I(y){return y.map(d=>{const[O,E]=d.split("@");return{proposalName:O,version:E?parseInt(E):void 0}})}function w(y){return y.map(d=>d.split("@")[0])}e.IBuiltinExtensionsScannerService=(0,C.createDecorator)("IBuiltinExtensionsScannerService")}),define(ce[20],de([0,1,11,4,22,10]),function(J,e,b,C,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.ExtensionsLocalizedLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.ExtensionGalleryError=e.ExtensionGalleryErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.ExtensionInstallSource=e.EXTENSION_INSTALL_CLIENT_TARGET_PLATFORM_CONTEXT=e.EXTENSION_INSTALL_DEP_PACK_CONTEXT=e.EXTENSION_INSTALL_SOURCE_CONTEXT=e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.TargetPlatformToString=D,e.toTargetPlatform=p,e.getTargetPlatform=u,e.isNotWebExtensionInWebTargetPlatform=f,e.isTargetPlatformCompatible=h,e.isIExtensionIdentifier=m,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension",e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT="skipWalkthrough",e.EXTENSION_INSTALL_SOURCE_CONTEXT="extensionInstallSource",e.EXTENSION_INSTALL_DEP_PACK_CONTEXT="dependecyOrPackExtensionInstall",e.EXTENSION_INSTALL_CLIENT_TARGET_PLATFORM_CONTEXT="clientTargetPlatform";var k;(function(i){i.COMMAND="command",i.SETTINGS_SYNC="settingsSync"})(k||(e.ExtensionInstallSource=k={}));function D(i){switch(i){case S.TargetPlatform.WIN32_X64:return"Windows 64 bit";case S.TargetPlatform.WIN32_ARM64:return"Windows ARM";case S.TargetPlatform.LINUX_X64:return"Linux 64 bit";case S.TargetPlatform.LINUX_ARM64:return"Linux ARM 64";case S.TargetPlatform.LINUX_ARMHF:return"Linux ARM";case S.TargetPlatform.LINUX_PPC64LE:return"Linux PowerPC64";case S.TargetPlatform.LINUX_RISCV64:return"Linux RISC-V 64";case S.TargetPlatform.ALPINE_X64:return"Alpine Linux 64 bit";case S.TargetPlatform.ALPINE_ARM64:return"Alpine ARM 64";case S.TargetPlatform.DARWIN_X64:return"Mac";case S.TargetPlatform.DARWIN_ARM64:return"Mac Silicon";case S.TargetPlatform.WEB:return"Web";case S.TargetPlatform.UNIVERSAL:return S.TargetPlatform.UNIVERSAL;case S.TargetPlatform.UNKNOWN:return S.TargetPlatform.UNKNOWN;case S.TargetPlatform.UNDEFINED:return S.TargetPlatform.UNDEFINED}}function p(i){switch(i){case S.TargetPlatform.WIN32_X64:return S.TargetPlatform.WIN32_X64;case S.TargetPlatform.WIN32_ARM64:return S.TargetPlatform.WIN32_ARM64;case S.TargetPlatform.LINUX_X64:return S.TargetPlatform.LINUX_X64;case S.TargetPlatform.LINUX_ARM64:return S.TargetPlatform.LINUX_ARM64;case S.TargetPlatform.LINUX_ARMHF:return S.TargetPlatform.LINUX_ARMHF;case S.TargetPlatform.LINUX_PPC64LE:return S.TargetPlatform.LINUX_PPC64LE;case S.TargetPlatform.LINUX_RISCV64:return S.TargetPlatform.LINUX_RISCV64;case S.TargetPlatform.ALPINE_X64:return S.TargetPlatform.ALPINE_X64;case S.TargetPlatform.ALPINE_ARM64:return S.TargetPlatform.ALPINE_ARM64;case S.TargetPlatform.DARWIN_X64:return S.TargetPlatform.DARWIN_X64;case S.TargetPlatform.DARWIN_ARM64:return S.TargetPlatform.DARWIN_ARM64;case S.TargetPlatform.WEB:return S.TargetPlatform.WEB;case S.TargetPlatform.UNIVERSAL:return S.TargetPlatform.UNIVERSAL;default:return S.TargetPlatform.UNKNOWN}}function u(i,l){switch(i){case b.Platform.Windows:return l==="x64"?S.TargetPlatform.WIN32_X64:l==="arm64"?S.TargetPlatform.WIN32_ARM64:S.TargetPlatform.UNKNOWN;case b.Platform.Linux:return l==="x64"?S.TargetPlatform.LINUX_X64:l==="arm64"?S.TargetPlatform.LINUX_ARM64:l==="arm"?S.TargetPlatform.LINUX_ARMHF:l==="ppc64le"?S.TargetPlatform.LINUX_PPC64LE:l==="riscv64"?S.TargetPlatform.LINUX_RISCV64:S.TargetPlatform.UNKNOWN;case"alpine":return l==="x64"?S.TargetPlatform.ALPINE_X64:l==="arm64"?S.TargetPlatform.ALPINE_ARM64:S.TargetPlatform.UNKNOWN;case b.Platform.Mac:return l==="x64"?S.TargetPlatform.DARWIN_X64:l==="arm64"?S.TargetPlatform.DARWIN_ARM64:S.TargetPlatform.UNKNOWN;case b.Platform.Web:return S.TargetPlatform.WEB}}function f(i,l){return l===S.TargetPlatform.WEB&&!i.includes(S.TargetPlatform.WEB)}function h(i,l,r){return f(l,r)?!1:i===S.TargetPlatform.UNDEFINED||i===S.TargetPlatform.UNIVERSAL?!0:i===S.TargetPlatform.UNKNOWN?!1:i===r}function m(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(!i.uuid||typeof i.uuid=="string")}var a;(function(i){i[i.NoneOrRelevance=0]="NoneOrRelevance",i[i.LastUpdatedDate=1]="LastUpdatedDate",i[i.Title=2]="Title",i[i.PublisherName=3]="PublisherName",i[i.InstallCount=4]="InstallCount",i[i.PublishedDate=10]="PublishedDate",i[i.AverageRating=6]="AverageRating",i[i.WeightedRating=12]="WeightedRating"})(a||(e.SortBy=a={}));var v;(function(i){i[i.Default=0]="Default",i[i.Ascending=1]="Ascending",i[i.Descending=2]="Descending"})(v||(e.SortOrder=v={}));var I;(function(i){i.Install="install",i.Uninstall="uninstall"})(I||(e.StatisticType=I={}));var w;(function(i){i[i.None=1]="None",i[i.Install=2]="Install",i[i.Update=3]="Update",i[i.Migrate=4]="Migrate"})(w||(e.InstallOperation=w={})),e.IExtensionGalleryService=(0,R.createDecorator)("extensionGalleryService");var y;(function(i){i.Timeout="Timeout",i.Cancelled="Cancelled",i.Failed="Failed",i.DownloadFailedWriting="DownloadFailedWriting",i.Offline="Offline"})(y||(e.ExtensionGalleryErrorCode=y={}));class d extends Error{constructor(l,r){super(l),this.code=r,this.name=r}}e.ExtensionGalleryError=d;var O;(function(i){i.Unsupported="Unsupported",i.Deprecated="Deprecated",i.Malicious="Malicious",i.Incompatible="Incompatible",i.IncompatibleApi="IncompatibleApi",i.IncompatibleTargetPlatform="IncompatibleTargetPlatform",i.ReleaseVersionNotFound="ReleaseVersionNotFound",i.Invalid="Invalid",i.Download="Download",i.DownloadSignature="DownloadSignature",i.DownloadFailedWriting="DownloadFailedWriting",i.UpdateMetadata="UpdateMetadata",i.Extract="Extract",i.Scanning="Scanning",i.ScanningExtension="ScanningExtension",i.ReadUninstalled="ReadUninstalled",i.UnsetUninstalled="UnsetUninstalled",i.Delete="Delete",i.Rename="Rename",i.IntializeDefaultProfile="IntializeDefaultProfile",i.AddToProfile="AddToProfile",i.InstalledExtensionNotFound="InstalledExtensionNotFound",i.PostInstall="PostInstall",i.CorruptZip="CorruptZip",i.IncompleteZip="IncompleteZip",i.Signature="Signature",i.NotAllowed="NotAllowed",i.Gallery="Gallery",i.Cancelled="Cancelled",i.Unknown="Unknown",i.Internal="Internal"})(O||(e.ExtensionManagementErrorCode=O={}));class E extends Error{constructor(l,r){super(l),this.code=r,this.name=r}}e.ExtensionManagementError=E,e.IExtensionManagementService=(0,R.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,R.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,R.createDecorator)("IExtensionTipsService"),e.ExtensionsLocalizedLabel=(0,C.localize2)(1780,"Extensions"),e.PreferencesLocalizedLabel=(0,C.localize2)(1781,"Preferences")}),define(ce[119],de([0,1,2,22,9]),function(J,e,b,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class R extends b.Disposable{constructor(D,p,u,f,h){super(),this.userDataProfilesService=D,this.fileService=p,this.uriIdentityService=u,this.logService=h,this._register(f.onDidInstallExtensions(m=>this.onDidInstallExtensions(m))),this._register(f.onDidUninstallExtension(m=>this.onDidUnInstallExtension(m)))}onDidInstallExtensions(D){for(const p of D)p.local&&this.invalidate(p.profileLocation)}onDidUnInstallExtension(D){D.error||this.invalidate(D.profileLocation)}async invalidate(D){if(D)for(const p of this.userDataProfilesService.profiles)this.uriIdentityService.extUri.isEqual(p.extensionsResource,D)&&await this.deleteUserCacheFile(p);else await this.deleteUserCacheFile(this.userDataProfilesService.defaultProfile)}async deleteUserCacheFile(D){try{await this.fileService.del(this.uriIdentityService.extUri.joinPath(D.cacheHome,C.USER_MANIFEST_CACHE_FILE))}catch(p){(0,S.toFileOperationResult)(p)!==S.FileOperationResult.FILE_NOT_FOUND&&this.logService.error(p)}}}e.ExtensionsManifestCache=R});var Ve=this&&this.__importDefault||function(J){return J&&J.__esModule?J:{default:J}};define(ce[44],de([0,1,16,56,4,45,22,98]),function(J,e,b,C,S,R,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isValidVersionStr=f,e.parseVersion=h,e.normalizeVersion=m,e.isValidVersion=a,e.validateExtensionManifest=v,e.isValidExtensionVersion=I,e.isEngineValid=w,e.areApiProposalsCompatible=y,C=Ve(C),S=we(S),R=we(R);const p=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,u=/^-(\d{4})(\d{2})(\d{2})$/;function f(E){return E=E.trim(),E==="*"||p.test(E)}function h(E){if(!f(E))return null;if(E=E.trim(),E==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const i=E.match(p);return i?{hasCaret:i[1]==="^",hasGreaterEquals:i[1]===">=",majorBase:i[2]==="x"?0:parseInt(i[2],10),majorMustEqual:i[2]!=="x",minorBase:i[4]==="x"?0:parseInt(i[4],10),minorMustEqual:i[4]!=="x",patchBase:i[6]==="x"?0:parseInt(i[6],10),patchMustEqual:i[6]!=="x",preRelease:i[8]||null}:null}function m(E){if(!E)return null;const i=E.majorBase,l=E.majorMustEqual,r=E.minorBase;let n=E.minorMustEqual;const t=E.patchBase;let s=E.patchMustEqual;E.hasCaret&&(i===0||(n=!1),s=!1);let o=0;if(E.preRelease){const c=u.exec(E.preRelease);if(c){const[,g,T,N]=c;o=Date.UTC(Number(g),Number(T)-1,Number(N))}}return{majorBase:i,majorMustEqual:l,minorBase:r,minorMustEqual:n,patchBase:t,patchMustEqual:s,isMinimum:E.hasGreaterEquals,notBefore:o}}function a(E,i,l){let r;typeof E=="string"?r=m(h(E)):r=E;let n;i instanceof Date?n=i.getTime():typeof i=="string"&&(n=new Date(i).getTime());let t;if(typeof l=="string"?t=m(h(l)):t=l,!r||!t)return!1;const s=r.majorBase,o=r.minorBase,c=r.patchBase;let g=t.majorBase,T=t.minorBase,N=t.patchBase;const A=t.notBefore;let L=t.majorMustEqual,M=t.minorMustEqual,B=t.patchMustEqual;return t.isMinimum?s>g?!0:s<g?!1:o>T?!0:o<T||n&&n<A?!1:c>=N:(s===1&&g===0&&(!L||!M||!B)&&(g=1,T=0,N=0,L=!0,M=!1,B=!1),s<g?!1:s>g?!L:o<T?!1:o>T?!M:c<N?!1:c>N?!B:!(n&&n<A))}function v(E,i,l,r,n,t){const s=[];if(typeof r.publisher<"u"&&typeof r.publisher!="string")return s.push([C.default.Error,S.localize(1832,null)]),s;if(typeof r.name!="string")return s.push([C.default.Error,S.localize(1833,null,"name")]),s;if(typeof r.version!="string")return s.push([C.default.Error,S.localize(1834,null,"version")]),s;if(!r.engines)return s.push([C.default.Error,S.localize(1835,null,"engines")]),s;if(typeof r.engines.vscode!="string")return s.push([C.default.Error,S.localize(1836,null,"engines.vscode")]),s;if(typeof r.extensionDependencies<"u"&&!O(r.extensionDependencies))return s.push([C.default.Error,S.localize(1837,null,"extensionDependencies")]),s;if(typeof r.activationEvents<"u"){if(!O(r.activationEvents))return s.push([C.default.Error,S.localize(1838,null,"activationEvents")]),s;if(typeof r.main>"u"&&typeof r.browser>"u")return s.push([C.default.Error,S.localize(1839,null,"activationEvents","main","browser")]),s}if(typeof r.extensionKind<"u"&&typeof r.main>"u"&&s.push([C.default.Warning,S.localize(1840,null,"extensionKind")]),typeof r.main<"u"){if(typeof r.main!="string")return s.push([C.default.Error,S.localize(1841,null,"main")]),s;{const g=(0,b.joinPath)(l,r.main);(0,b.isEqualOrParent)(g,l)||s.push([C.default.Warning,S.localize(1842,null,g.path,l.path)])}}if(typeof r.browser<"u"){if(typeof r.browser!="string")return s.push([C.default.Error,S.localize(1843,null,"browser")]),s;{const g=(0,b.joinPath)(l,r.browser);(0,b.isEqualOrParent)(g,l)||s.push([C.default.Warning,S.localize(1844,null,g.path,l.path)])}}if(!R.valid(r.version))return s.push([C.default.Error,S.localize(1845,null)]),s;const o=[];if(!I(E,i,r,n,o))for(const g of o)s.push([C.default.Error,g]);if(t&&r.enabledApiProposals?.length){const g=[];if(!y([...r.enabledApiProposals],g))for(const T of g)s.push([C.default.Error,T])}return s}function I(E,i,l,r,n){return r||typeof l.main>"u"&&typeof l.browser>"u"?!0:d(E,i,l.engines.vscode,n)}function w(E,i,l){return E==="*"||d(i,l,E)}function y(E,i){if(E.length===0)return!0;const l=Array.isArray(i)?i:void 0,r=(l?void 0:i)??D.allApiProposals,n=[],t=(0,k.parseApiProposals)(E);for(const{proposalName:s,version:o}of t){const c=r[s];c&&o&&c.version!==o&&n.push(S.localize(1846,null,s))}return l?.push(...n),n.length===0}function d(E,i,l,r=[]){const n=m(h(l));if(!n)return r.push(S.localize(1847,null,l)),!1;if(n.majorBase===0){if(!n.majorMustEqual||!n.minorMustEqual)return r.push(S.localize(1848,null,l)),!1}else if(!n.majorMustEqual)return r.push(S.localize(1849,null,l)),!1;return a(E,i,n)?!0:(r.push(S.localize(1850,null,E,l)),!1)}function O(E){if(!Array.isArray(E))return!1;for(let i=0,l=E.length;i<l;i++)if(typeof E[i]!="string")return!1;return!0}}),define(ce[69],de([0,1,21,2,11,4,20,10]),function(J,e,b,C,S,R,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackBaseService=e.ILanguagePackService=void 0,e.getLocale=p;function p(f){return f.tags.find(h=>h.startsWith("lp-"))?.split("lp-")[1]}e.ILanguagePackService=(0,D.createDecorator)("languagePackService");let u=class extends C.Disposable{constructor(h){super(),this.extensionGalleryService=h}async getAvailableLanguages(){const h=new b.CancellationTokenSource;setTimeout(()=>h.cancel(),1e3);let m;try{m=await this.extensionGalleryService.query({text:'category:"language packs"',pageSize:20},h.token)}catch{return[]}const v=m.firstPage.filter(I=>I.properties.localizedLanguages?.length&&I.tags.some(w=>w.startsWith("lp-"))).map(I=>{const w=I.properties.localizedLanguages?.[0],y=p(I);return{...this.createQuickPickItem(y,w,I),extensionId:I.identifier.id,galleryExtension:I}});return v.push(this.createQuickPickItem("en","English")),v}createQuickPickItem(h,m,a){const v=m??h;let I;if(v!==h&&(I=`(${h})`),h.toLowerCase()===S.language.toLowerCase()&&(I??="",I+=(0,R.localize)(1928,null)),a?.installCount){I??="";const w=a.installCount;let y;w>1e6?y=`${Math.floor(w/1e5)/10}M`:w>1e3?y=`${Math.floor(w/1e3)}K`:y=String(w),I+=` $(cloud-download) ${y}`}return{id:h,label:v,description:I}}};e.LanguagePackBaseService=u,e.LanguagePackBaseService=u=Pe([oe(0,k.IExtensionGalleryService)],u)}),define(ce[46],de([0,1,13,7,2,4,40,10,6,37]),function(J,e,b,C,S,R,k,D,p,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractRequestService=e.IRequestService=void 0,e.isSuccess=m,e.hasNoContent=a,e.asText=v,e.asTextOrError=I,e.asJson=w,e.updateProxyConfigurationsScope=y,e.IRequestService=(0,D.createDecorator)("requestService");class f{constructor(i){this.original=i}toJSON(){if(!this.headers){const i=Object.create(null);for(const l in this.original)l.toLowerCase()==="authorization"||l.toLowerCase()==="proxy-authorization"?i[l]="*****":i[l]=this.original[l];this.headers=i}return this.headers}}class h extends S.Disposable{constructor(i){super(),this.counter=0,this.logger=i.createLogger("network",{name:(0,R.localize)(2050,null),when:p.CONTEXT_LOG_LEVEL.isEqualTo((0,p.LogLevelToString)(p.LogLevel.Trace)).serialize()})}async logAndRequest(i,l,r){const n=`${i} #${++this.counter}: ${l.url}`;this.logger.trace(`${n} - begin`,l.type,new f(l.headers??{}));try{const t=await r();return this.logger.trace(`${n} - end`,l.type,t.res.statusCode,t.res.headers),t}catch(t){throw this.logger.error(`${n} - error`,l.type,(0,C.getErrorMessage)(t)),t}}}e.AbstractRequestService=h;function m(E){return E.res.statusCode&&E.res.statusCode>=200&&E.res.statusCode<300||E.res.statusCode===1223}function a(E){return E.res.statusCode===204}async function v(E){return a(E)?null:(await(0,b.streamToBuffer)(E.stream)).toString()}async function I(E){if(!m(E))throw new Error("Server returned "+E.res.statusCode);return v(E)}async function w(E){if(!m(E))throw new Error("Server returned "+E.res.statusCode);if(a(E))return null;const l=(await(0,b.streamToBuffer)(E.stream)).toString();try{return JSON.parse(l)}catch(r){throw r.message+=`:
`+l,r}}function y(E){O(E)}let d;function O(E){const i=u.Registry.as(k.Extensions.Configuration),l=d;d={id:"http",order:15,title:(0,R.localize)(2051,null),type:"object",scope:E,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,R.localize)(2052,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,R.localize)(2053,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,R.localize)(2054,null),restricted:!0},"http.noProxy":{type:"array",items:{type:"string"},markdownDescription:(0,R.localize)(2055,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,R.localize)(2056,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,R.localize)(2057,null),(0,R.localize)(2058,null),(0,R.localize)(2059,null),(0,R.localize)(2060,null)],default:"override",description:(0,R.localize)(2061,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,R.localize)(2062,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,R.localize)(2063,null),restricted:!0}}},i.updateConfigurations({add:[d],remove:l?[l]:[]})}O(k.ConfigurationScope.APPLICATION)}),define(ce[120],de([0,1,21,14,9,46]),function(J,e,b,C,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadService=void 0;let k=class{constructor(p,u){this.requestService=p,this.fileService=u}async download(p,u,f=b.CancellationToken.None){if(p.scheme===C.Schemas.file||p.scheme===C.Schemas.vscodeRemote){await this.fileService.copy(p,u);return}const h={type:"GET",url:p.toString(!0)},m=await this.requestService.request(h,f);if(m.res.statusCode===200)await this.fileService.writeFile(u,m.stream);else{const a=await(0,R.asTextOrError)(m);throw new Error(`Expected 200, got back ${m.res.statusCode} instead.

${a}`)}}};e.DownloadService=k,e.DownloadService=k=Pe([oe(0,R.IRequestService),oe(1,S.IFileService)],k)}),define(ce[121],de([0,1,122,3]),function(J,e,b,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=R;function S(k,D){return k.protocol==="http:"?D.HTTP_PROXY||D.http_proxy||null:k.protocol==="https:"&&(D.HTTPS_PROXY||D.https_proxy||D.HTTP_PROXY||D.http_proxy)||null}async function R(k,D,p={}){const u=(0,b.parse)(k),f=p.proxyUrl||S(u,D);if(!f)return null;const h=(0,b.parse)(f);if(!/^https?:$/.test(h.protocol||""))return null;const m={host:h.hostname||"",port:(h.port?+h.port:0)||(h.protocol==="https"?443:80),auth:h.auth,rejectUnauthorized:(0,C.isBoolean)(p.strictSSL)?p.strictSSL:!0};if(u.protocol==="http:"){const a=await new Promise((v,I)=>{J(["http-proxy-agent"],v,I)}).then(we);return new a.HttpProxyAgent(f,m)}else{const a=await new Promise((v,I)=>{J(["https-proxy-agent"],v,I)}).then(we);return new a.HttpsProxyAgent(f,m)}}}),define(ce[123],de([0,1,61,15,4,21,38,7,11,28,89,153,8,80]),function(J,e,b,C,S,R,k,D,p,u,f,h,m,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=I;let v;async function I(y,d,O,E){return O["force-disable-user-env"]?(d.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):p.isWindows?(d.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,h.isLaunchedFromCli)(E)&&!O["force-user-env"]?(d.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,h.isLaunchedFromCli)(E)?d.trace("resolveShellEnv(): running (--force-user-env)"):d.trace("resolveShellEnv(): running (macOS/Linux)"),v||(v=m.Promises.withAsyncBody(async(i,l)=>{const r=new R.CancellationTokenSource;let n=1e4;const t=y.getValue("application.shellEnvironmentResolutionTimeout");typeof t=="number"&&(n=(0,a.clamp)(t,1,120)*1e3);const s=setTimeout(()=>{r.dispose(!0),l(new Error((0,S.localize)(2064,null)))},n);try{i(await w(d,r.token))}catch(o){!(0,D.isCancellationError)(o)&&!r.token.isCancellationRequested?l(new Error((0,S.localize)(2065,null,(0,k.toErrorMessage)(o)))):i({})}finally{clearTimeout(s),r.dispose()}})),v)}async function w(y,d){const O=process.env.ELECTRON_RUN_AS_NODE;y.trace("getUnixShellEnvironment#runAsNode",O);const E=process.env.ELECTRON_NO_ATTACH_CONSOLE;y.trace("getUnixShellEnvironment#noAttach",E);const i=(0,u.generateUuid)().replace(/-/g,"").substr(0,12),l=new RegExp(i+"({.*})"+i),r={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};y.trace("getUnixShellEnvironment#env",r);const n=await(0,f.getSystemShell)(p.OS,r);return y.trace("getUnixShellEnvironment#shell",n),new Promise((t,s)=>{if(d.isCancellationRequested)return s(new D.CancellationError);const o=(0,C.basename)(n);let c,g;const T="";/^pwsh(-preview)?$/.test(o)?(c=`& '${process.execPath}' ${T} -p '''${i}'' + JSON.stringify(process.env) + ''${i}'''`,g=["-Login","-Command"]):o==="nu"?(c=`^'${process.execPath}' ${T} -p '"${i}" + JSON.stringify(process.env) + "${i}"'`,g=["-i","-l","-c"]):o==="xonsh"?(c=`import os, json; print("${i}", json.dumps(dict(os.environ)), "${i}")`,g=["-i","-l","-c"]):(c=`'${process.execPath}' ${T} -p '"${i}" + JSON.stringify(process.env) + "${i}"'`,o==="tcsh"||o==="csh"?g=["-ic"]:g=["-i","-l","-c"]),y.trace("getUnixShellEnvironment#spawn",JSON.stringify(g),c);const N=(0,b.spawn)(n,[...g,c],{detached:!0,stdio:["ignore","pipe","pipe"],env:r});d.onCancellationRequested(()=>(N.kill(),s(new D.CancellationError))),N.on("error",M=>{y.error("getUnixShellEnvironment#errorChildProcess",(0,k.toErrorMessage)(M)),s(M)});const A=[];N.stdout.on("data",M=>A.push(M));const L=[];N.stderr.on("data",M=>L.push(M)),N.on("close",(M,B)=>{const Q=Buffer.concat(A).toString("utf8");y.trace("getUnixShellEnvironment#raw",Q);const re=Buffer.concat(L).toString("utf8");if(re.trim()&&y.trace("getUnixShellEnvironment#stderr",re),M||B)return s(new Error((0,S.localize)(2066,null,M,B)));const ae=l.exec(Q),ue=ae?ae[1]:"{}";try{const pe=JSON.parse(ue);O?pe.ELECTRON_RUN_AS_NODE=O:delete pe.ELECTRON_RUN_AS_NODE,E?pe.ELECTRON_NO_ATTACH_CONSOLE=E:delete pe.ELECTRON_NO_ATTACH_CONSOLE,delete pe.VSCODE_RESOLVING_ENVIRONMENT,delete pe.XDG_RUNTIME_DIR,y.trace("getUnixShellEnvironment#result",pe),t(pe)}catch(pe){y.error("getUnixShellEnvironment#errorCaught",(0,k.toErrorMessage)(pe)),s(pe)}})})}}),define(ce[124],de([0,1,10]),function(J,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateService=e.IStateReadService=void 0,e.IStateReadService=(0,b.createDecorator)("stateReadService"),e.IStateService=(0,b.createDecorator)("stateService")}),define(ce[70],de([0,1,8,13,2,3,17,9,6]),function(J,e,b,C,S,R,k,D,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateService=e.StateReadonlyService=e.FileStorage=e.SaveStrategy=void 0;var u;(function(a){a[a.IMMEDIATE=0]="IMMEDIATE",a[a.DELAYED=1]="DELAYED"})(u||(e.SaveStrategy=u={}));class f extends S.Disposable{constructor(v,I,w,y){super(),this.storagePath=v,this.saveStrategy=I,this.logService=w,this.fileService=y,this.storage=Object.create(null),this.lastSavedStorageContents="",this.flushDelayer=this._register(new b.ThrottledDelayer(this.saveStrategy===u.IMMEDIATE?0:100)),this.initializing=void 0,this.closing=void 0}init(){return this.initializing||(this.initializing=this.doInit()),this.initializing}async doInit(){try{this.lastSavedStorageContents=(await this.fileService.readFile(this.storagePath)).value.toString(),this.storage=JSON.parse(this.lastSavedStorageContents)}catch(v){v.fileOperationResult!==D.FileOperationResult.FILE_NOT_FOUND&&this.logService.error(v)}}getItem(v,I){const w=this.storage[v];return(0,R.isUndefinedOrNull)(w)?I:w}setItem(v,I){this.setItems([{key:v,data:I}])}setItems(v){let I=!1;for(const{key:w,data:y}of v)this.storage[w]!==y&&((0,R.isUndefinedOrNull)(y)?(0,R.isUndefined)(this.storage[w])||(this.storage[w]=void 0,I=!0):(this.storage[w]=y,I=!0));I&&this.save()}removeItem(v){(0,R.isUndefined)(this.storage[v])||(this.storage[v]=void 0,this.save())}async save(){if(!this.closing)return this.flushDelayer.trigger(()=>this.doSave())}async doSave(){if(!this.initializing)return;await this.initializing;const v=JSON.stringify(this.storage,null,4);if(v!==this.lastSavedStorageContents)try{await this.fileService.writeFile(this.storagePath,C.VSBuffer.fromString(v),{atomic:{postfix:".vsctmp"}}),this.lastSavedStorageContents=v}catch(I){this.logService.error(I)}}async close(){return this.closing||(this.closing=this.flushDelayer.trigger(()=>this.doSave(),0)),this.closing}}e.FileStorage=f;let h=class extends S.Disposable{constructor(v,I,w,y){super(),this.fileStorage=this._register(new f(I.stateResource,v,w,y))}async init(){await this.fileStorage.init()}getItem(v,I){return this.fileStorage.getItem(v,I)}};e.StateReadonlyService=h,e.StateReadonlyService=h=Pe([oe(1,k.IEnvironmentService),oe(2,p.ILogService),oe(3,D.IFileService)],h);class m extends h{setItem(v,I){this.fileStorage.setItem(v,I)}setItems(v){this.fileStorage.setItems(v)}removeItem(v){this.fileStorage.removeItem(v)}close(){return this.fileStorage.close()}}e.StateService=m}),define(ce[71],de([0,1,11,36,28]),function(J,e,b,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveCommonProperties=k,e.verifyMicrosoftInternalDomain=D;function R(p){if(b.platform===b.Platform.Linux&&/^penguin(\.|$)/i.test(p))return"chromebook"}function k(p,u,f,h,m,a,v,I,w,y){const d=Object.create(null);d["common.machineId"]=a,d["common.sqmId"]=v,d["common.devDeviceId"]=I,d.sessionID=(0,S.generateUuid)()+Date.now(),d.commitHash=h,d.version=m,d["common.platformVersion"]=(p||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),d["common.platform"]=(0,b.PlatformToString)(b.platform),d["common.nodePlatform"]=C.platform,d["common.nodeArch"]=f,d["common.product"]=y||"desktop",w&&(d["common.msftInternal"]=w);let O=0;const E=Date.now();Object.defineProperties(d,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-E,enumerable:!0},"common.sequence":{get:()=>O++,enumerable:!0}}),b.isLinuxSnap&&(d["common.snap"]="true");const i=R(u);return i&&(d["common.platformDetail"]=i),d}function D(p){const u=C.env.USERDNSDOMAIN;if(!u)return!1;const f=u.toLowerCase();return p.some(h=>f===h)}}),define(ce[18],de([0,1,10]),function(J,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_CRASH_REPORTER_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.devDeviceIdKey=e.sqmIdKey=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,b.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,b.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.sqmIdKey="telemetry.sqmId",e.devDeviceIdKey="telemetry.devDeviceId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_CRASH_REPORTER_SETTING_ID="telemetry.enableCrashReporter",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var C;(function(R){R[R.NONE=0]="NONE",R[R.CRASH=1]="CRASH",R[R.ERROR=2]="ERROR",R[R.USAGE=3]="USAGE"})(C||(e.TelemetryLevel=C={}));var S;(function(R){R.OFF="off",R.CRASH="crash",R.ERROR="error",R.ON="all"})(S||(e.TelemetryConfiguration=S={}))}),define(ce[72],de([0,1,58,7,10,6,18]),function(J,e,b,C,S,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSignatureVerificationService=e.ExtensionSignatureVerificationError=e.ExtensionSignatureVerificationCode=e.IExtensionSignatureVerificationService=void 0,e.IExtensionSignatureVerificationService=(0,S.createDecorator)("IExtensionSignatureVerificationService");var D;(function(f){f.Success="Success",f.RequiredArgumentMissing="RequiredArgumentMissing",f.InvalidArgument="InvalidArgument",f.PackageIsUnreadable="PackageIsUnreadable",f.UnhandledException="UnhandledException",f.SignatureManifestIsMissing="SignatureManifestIsMissing",f.SignatureManifestIsUnreadable="SignatureManifestIsUnreadable",f.SignatureIsMissing="SignatureIsMissing",f.SignatureIsUnreadable="SignatureIsUnreadable",f.CertificateIsUnreadable="CertificateIsUnreadable",f.SignatureArchiveIsUnreadable="SignatureArchiveIsUnreadable",f.FileAlreadyExists="FileAlreadyExists",f.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip",f.SignatureArchiveHasSameSignatureFile="SignatureArchiveHasSameSignatureFile",f.PackageIntegrityCheckFailed="PackageIntegrityCheckFailed",f.SignatureIsInvalid="SignatureIsInvalid",f.SignatureManifestIsInvalid="SignatureManifestIsInvalid",f.SignatureIntegrityCheckFailed="SignatureIntegrityCheckFailed",f.EntryIsMissing="EntryIsMissing",f.EntryIsTampered="EntryIsTampered",f.Untrusted="Untrusted",f.CertificateRevoked="CertificateRevoked",f.SignatureIsNotValid="SignatureIsNotValid",f.UnknownError="UnknownError",f.PackageIsInvalidZip="PackageIsInvalidZip",f.SignatureArchiveHasTooManyEntries="SignatureArchiveHasTooManyEntries"})(D||(e.ExtensionSignatureVerificationCode=D={}));class p extends Error{constructor(h){super(h),this.code=h}}e.ExtensionSignatureVerificationError=p;let u=class{constructor(h,m){this.logService=h,this.telemetryService=m}vsceSign(){return this.moduleLoadingPromise||(this.moduleLoadingPromise=this.resolveVsceSign()),this.moduleLoadingPromise}async resolveVsceSign(){return(0,b.importAMDNodeModule)("@vscode/vsce-sign","src/main.js")}async verify(h,m,a,v){let I;const w=h.identifier.id;try{I=await this.vsceSign()}catch(E){return this.logService.error("Could not load vsce-sign module",(0,C.getErrorMessage)(E)),this.logService.info(`Extension signature verification is not done: ${w}`),!1}const y=new Date().getTime();let d;try{this.logService.trace(`Verifying extension signature for ${w}...`),d=await I.verify(m,a,this.logService.getLevel()===R.LogLevel.Trace)}catch(E){d={code:D.UnknownError,didExecute:!1,output:(0,C.getErrorMessage)(E)}}const O=new Date().getTime()-y;if(this.logService.info(`Extension signature verification result for ${w}: ${d.code}. Executed: ${d.didExecute}. Duration: ${O}ms.`),this.logService.trace(`Extension signature verification output for ${w}:
${d.output}`),this.telemetryService.publicLog2("extensionsignature:verification",{extensionId:w,extensionVersion:h.version,code:d.code,internalCode:d.internalCode,duration:O,didExecute:d.didExecute,clientTargetPlatform:v}),d.code===D.Success)return!0;throw new p(d.code)}};e.ExtensionSignatureVerificationService=u,e.ExtensionSignatureVerificationService=u=Pe([oe(0,R.ILogService),oe(1,k.ITelemetryService)],u)}),define(ce[41],de([0,1,27,3,68,71,18]),function(J,e,b,C,S,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullAppender=e.extensionTelemetryLogChannelId=e.telemetryLogId=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TelemetryTrustedValue=void 0,e.supportsTelemetry=f,e.isLoggingOnly=h,e.getTelemetryLevel=m,e.validateTelemetryData=a,e.cleanRemoteAuthority=I,e.isInternalTelemetry=y,e.getPiiPathsFromEnvironment=d,e.cleanData=i;class D{constructor(r){this.value=r,this.isTrustedTelemetryValue=!0}}e.TelemetryTrustedValue=D;class p{constructor(){this.telemetryLevel=k.TelemetryLevel.NONE,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.devDeviceId="someValue.devDeviceId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.NullTelemetryServiceShape=p,e.NullTelemetryService=new p;class u{async publicLog(r,n,t){}async publicLogError(r,n,t){}}e.NullEndpointTelemetryService=u,e.telemetryLogId="telemetry",e.extensionTelemetryLogChannelId="extensionTelemetryLog",e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function f(l,r){return!r.isBuilt&&!r.disableTelemetry?!0:!(r.disableTelemetry||!l.enableTelemetry)}function h(l,r){return r.extensionTestsLocationURI?!0:!(r.isBuilt||r.disableTelemetry||l.enableTelemetry&&l.aiConfig?.ariaKey)}function m(l){const r=l.getValue(k.TELEMETRY_SETTING_ID),n=l.getValue(k.TELEMETRY_CRASH_REPORTER_SETTING_ID);if(l.getValue(k.TELEMETRY_OLD_SETTING_ID)===!1||n===!1)return k.TelemetryLevel.NONE;switch(r??k.TelemetryConfiguration.ON){case k.TelemetryConfiguration.ON:return k.TelemetryLevel.USAGE;case k.TelemetryConfiguration.ERROR:return k.TelemetryLevel.ERROR;case k.TelemetryConfiguration.CRASH:return k.TelemetryLevel.CRASH;case k.TelemetryConfiguration.OFF:return k.TelemetryLevel.NONE}}function a(l){const r={},n={},t={};w(l,t);for(let s in t){s=s.length>150?s.substr(s.length-149):s;const o=t[s];typeof o=="number"?n[s]=o:typeof o=="boolean"?n[s]=o?1:0:typeof o=="string"?(o.length>8192&&console.warn(`Telemetry property: ${s} has been trimmed to 8192, the original length is ${o.length}`),r[s]=o.substring(0,8191)):typeof o<"u"&&o!==null&&(r[s]=o)}return{properties:r,measurements:n}}const v=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function I(l){if(!l)return"none";const r=(0,S.getRemoteName)(l);return v.has(r)?r:"other"}function w(l,r,n=0,t){if(l)for(const s of Object.getOwnPropertyNames(l)){const o=l[s],c=t?t+s:s;Array.isArray(o)?r[c]=(0,b.safeStringify)(o):o instanceof Date?r[c]=o.toISOString():(0,C.isObject)(o)?n<2?w(o,r,n+1,c+"."):r[c]=(0,b.safeStringify)(o):r[c]=o}}function y(l,r){const n=l.msftInternalDomains||[],t=r.getValue("telemetry.internalTesting");return(0,R.verifyMicrosoftInternalDomain)(n)||t}function d(l){return[l.appRoot,l.extensionsPath,l.userHome.fsPath,l.tmpDir.fsPath,l.userDataPath]}function O(l,r){if(!l||!l.includes("/")&&!l.includes("\\"))return l;let n=l;const t=[];for(const g of r)for(;;){const T=g.exec(l);if(!T)break;t.push([T.index,g.lastIndex])}const s=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,o=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let c=0;for(n="";;){const g=o.exec(l);if(!g)break;const T=t.some(([N,A])=>g.index<A&&N<o.lastIndex);!s.test(g[0])&&!T&&(n+=l.substring(c,g.index)+"<REDACTED: user-file-path>",c=o.lastIndex)}return c<l.length&&(n+=l.substr(c)),n}function E(l){if(!l)return l;const r=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"CLI Credentials",regex:/((login|psexec|(certutil|psexec)\.exe).{1,50}(\s-u(ser(name)?)?\s+.{3,100})?\s-(admin|user|vm|root)?p(ass(word)?)?\s+["']?[^$\-\/\s]|(^|[\s\r\n\\])net(\.exe)?.{1,5}(user\s+|share\s+\/user:| user -? secrets ? set) \s + [^ $\s \/])/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const n of r)if(n.regex.test(l))return`<REDACTED: ${n.label}>`;return l}function i(l,r){return(0,b.cloneAndChange)(l,n=>{if(n instanceof D||Object.hasOwnProperty.call(n,"isTrustedTelemetryValue"))return n.value;if(typeof n=="string"){let t=n.replaceAll("%20"," ");t=O(t,r);for(const s of r)t=t.replace(s,"");return t=E(t),t}})}}),define(ce[26],de([0,1,31,20,22,11,12,7,36,41]),function(J,e,b,C,S,R,k,D,p,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BetterMergeId=e.ExtensionKey=void 0,e.areSameExtensions=f,e.getIdAndVersion=v,e.getExtensionId=I,e.adoptToGalleryExtensionId=w,e.getGalleryExtensionId=y,e.groupByExtension=d,e.getLocalExtensionTelemetryData=O,e.getGalleryExtensionTelemetryData=E,e.getExtensionDependencies=i,e.computeTargetPlatform=r;function f(n,t){return n.uuid&&t.uuid?n.uuid===t.uuid:n.id===t.id?!0:(0,b.compareIgnoreCase)(n.id,t.id)===0}const h=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class m{static create(t){const s=t.manifest?t.manifest.version:t.version,o=t.manifest?t.targetPlatform:t.properties.targetPlatform;return new m(t.identifier,s,o)}static parse(t){const s=h.exec(t);return s&&s[1]&&s[2]?new m({id:s[1]},s[2],s[4]||void 0):null}constructor(t,s,o=S.TargetPlatform.UNDEFINED){this.identifier=t,this.version=s,this.targetPlatform=o,this.id=t.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!==S.TargetPlatform.UNDEFINED?`-${this.targetPlatform}`:""}`}equals(t){return t instanceof m?f(this,t)&&this.version===t.version&&this.targetPlatform===t.targetPlatform:!1}}e.ExtensionKey=m;const a=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function v(n){const t=a.exec(n);return t&&t[1]?[w(t[1]),t[2]]:[w(n),void 0]}function I(n,t){return`${n}.${t}`}function w(n){return n.toLowerCase()}function y(n,t){return w(I(n??S.UNDEFINED_PUBLISHER,t))}function d(n,t){const s=[],o=c=>{for(const g of s)if(g.some(T=>f(t(T),t(c))))return g;return null};for(const c of n){const g=o(c);g?g.push(c):s.push([c])}return s}function O(n){return{id:n.identifier.id,name:n.manifest.name,galleryId:null,publisherId:n.publisherId,publisherName:n.manifest.publisher,publisherDisplayName:n.publisherDisplayName,dependencies:n.manifest.extensionDependencies&&n.manifest.extensionDependencies.length>0}}function E(n){return{id:new u.TelemetryTrustedValue(n.identifier.id),name:new u.TelemetryTrustedValue(n.name),version:n.version,galleryId:n.identifier.uuid,publisherId:n.publisherId,publisherName:n.publisher,publisherDisplayName:n.publisherDisplayName,isPreReleaseVersion:n.properties.isPreReleaseVersion,dependencies:!!(n.properties.dependencies&&n.properties.dependencies.length>0),isSigned:n.isSigned,...n.telemetryData}}e.BetterMergeId=new S.ExtensionIdentifier("pprice.better-merge");function i(n,t){const s=[],o=t.manifest.extensionDependencies?.slice(0)??[];for(;o.length;){const c=o.shift();if(c&&s.every(g=>!f(g.identifier,{id:c}))){const g=n.filter(T=>f(T.identifier,{id:c}));g.length===1&&(s.push(g[0]),o.push(...g[0].manifest.extensionDependencies?.slice(0)??[]))}}return s}async function l(n,t){if(!R.isLinux)return!1;let s;try{s=(await n.readFile(k.URI.file("/etc/os-release"))).value.toString()}catch{try{s=(await n.readFile(k.URI.file("/usr/lib/os-release"))).value.toString()}catch(c){t.debug("Error while getting the os-release file.",(0,D.getErrorMessage)(c))}}return!!s&&(s.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function r(n,t){const s=await l(n,t),o=(0,C.getTargetPlatform)(s?"alpine":R.platform,p.arch);return t.debug("ComputeTargetPlatform:",o),o}}),define(ce[125],de([0,1,21,7,14,16,45,12,4,20,26,22]),function(J,e,b,C,S,R,k,D,p,u,f,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionManagementCLI=void 0;const m=I=>(0,p.localize)(1782,null,I),a=(0,p.localize)(1783,null,"ms-dotnettools.csharp");let v=class{constructor(w,y,d){this.logger=w,this.extensionManagementService=y,this.extensionGalleryService=d}get location(){}async listExtensions(w,y,d){let O=await this.extensionManagementService.getInstalled(h.ExtensionType.User,d);const E=h.EXTENSION_CATEGORIES.map(l=>l.toLowerCase());if(y&&y!==""){if(E.indexOf(y.toLowerCase())<0){this.logger.info("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}O=O.filter(l=>l.manifest.categories?l.manifest.categories.map(n=>n.toLowerCase()).indexOf(y.toLowerCase())>-1:!1)}else if(y===""){this.logger.info("Possible Categories: "),E.forEach(l=>{this.logger.info(l)});return}this.location&&this.logger.info((0,p.localize)(1784,null,this.location)),O=O.sort((l,r)=>l.identifier.id.localeCompare(r.identifier.id));let i;for(const l of O)i!==l.identifier.id&&(i=l.identifier.id,this.logger.info(w?`${i}@${l.manifest.version}`:i))}async installExtensions(w,y,d,O){const E=[];try{w.length&&this.logger.info(this.location?(0,p.localize)(1785,null,this.location):(0,p.localize)(1786,null));const i=[],l=[],r=(t,s,o)=>{l.push({id:t,version:s!=="prerelease"?s:void 0,installOptions:{...d,isBuiltin:o,installPreReleaseVersion:s==="prerelease"||d.installPreReleaseVersion}})};for(const t of w)if(t instanceof D.URI)i.push({vsix:t,installOptions:d});else{const[s,o]=(0,f.getIdAndVersion)(t);r(s,o,!1)}for(const t of y)if(t instanceof D.URI)i.push({vsix:t,installOptions:{...d,isBuiltin:!0,donotIncludePackAndDependencies:!0}});else{const[s,o]=(0,f.getIdAndVersion)(t);r(s,o,!0)}const n=await this.extensionManagementService.getInstalled(void 0,d.profileLocation);if(i.length&&await Promise.all(i.map(async({vsix:t,installOptions:s})=>{try{await this.installVSIX(t,s,O,n)}catch(o){this.logger.error(o),E.push(t.toString())}})),l.length){const t=await this.installGalleryExtensions(l,n,O);E.push(...t)}}catch(i){throw this.logger.error((0,p.localize)(1787,null,(0,C.getErrorMessage)(i))),i}if(E.length)throw new Error((0,p.localize)(1788,null,E.join(", ")))}async updateExtensions(w){const y=await this.extensionManagementService.getInstalled(h.ExtensionType.User,w),d=[];for(const l of y)l.identifier.uuid&&d.push({...l.identifier,preRelease:l.preRelease});this.logger.trace((0,p.localize)(1789,null,d.length));const O=await this.extensionGalleryService.getExtensions(d,{compatible:!0},b.CancellationToken.None),E=[];for(const l of O)for(const r of y)(0,f.areSameExtensions)(r.identifier,l.identifier)&&(0,k.gt)(l.version,r.manifest.version)&&E.push({extension:l,options:{operation:u.InstallOperation.Update,installPreReleaseVersion:r.preRelease,profileLocation:w,isApplicationScoped:r.isApplicationScoped}});if(!E.length){this.logger.info((0,p.localize)(1790,null));return}this.logger.info((0,p.localize)(1791,null,E.map(l=>l.extension.identifier.id).join(", ")));const i=await this.extensionManagementService.installGalleryExtensions(E);for(const l of i)l.error?this.logger.error((0,p.localize)(1792,null,l.identifier.id,(0,C.getErrorMessage)(l.error))):this.logger.info((0,p.localize)(1793,null,l.identifier.id,l.local?.manifest.version))}async installGalleryExtensions(w,y,d){if(w=w.filter(({id:l,version:r})=>{const n=y.find(t=>(0,f.areSameExtensions)(t.identifier,{id:l}));if(n){if(!d&&(!r||r==="prerelease"&&n.preRelease))return this.logger.info((0,p.localize)(1794,null,l,n.manifest.version,l)),!1;if(r&&n.manifest.version===r)return this.logger.info((0,p.localize)(1795,null,`${l}@${r}`)),!1}return!0}),!w.length)return[];const O=[],E=[],i=await this.getGalleryExtensions(w);if(await Promise.all(w.map(async({id:l,version:r,installOptions:n})=>{const t=i.get(l.toLowerCase());if(!t){this.logger.error(`${m(r?`${l}@${r}`:l)}
${a}`),O.push(l);return}try{const o=await this.extensionGalleryService.getManifest(t,b.CancellationToken.None);if(o&&!this.validateExtensionKind(o))return}catch(o){this.logger.error(o.message||o.stack||o),O.push(l);return}const s=y.find(o=>(0,f.areSameExtensions)(o.identifier,t.identifier));if(s){if(t.version===s.manifest.version){this.logger.info((0,p.localize)(1796,null,r?`${l}@${r}`:l));return}this.logger.info((0,p.localize)(1797,null,l,t.version))}n.isBuiltin?this.logger.info(r?(0,p.localize)(1798,null,l,r):(0,p.localize)(1799,null,l)):this.logger.info(r?(0,p.localize)(1800,null,l,r):(0,p.localize)(1801,null,l)),E.push({extension:t,options:{...n,installGivenVersion:!!r,isApplicationScoped:n.isApplicationScoped||s?.isApplicationScoped}})})),E.length){const l=await this.extensionManagementService.installGalleryExtensions(E);for(const r of l)r.error?(this.logger.error((0,p.localize)(1802,null,r.identifier.id,(0,C.getErrorMessage)(r.error))),O.push(r.identifier.id)):this.logger.info((0,p.localize)(1803,null,r.identifier.id,r.local?.manifest.version))}return O}async installVSIX(w,y,d,O){const E=await this.extensionManagementService.getManifest(w);if(!E)throw new Error("Invalid vsix");if(await this.validateVSIX(E,d,y.profileLocation,O))try{await this.extensionManagementService.install(w,{...y,installGivenVersion:!0}),this.logger.info((0,p.localize)(1804,null,(0,R.basename)(w)))}catch(l){if((0,C.isCancellationError)(l))this.logger.info((0,p.localize)(1805,null,(0,R.basename)(w)));else throw l}}async getGalleryExtensions(w){const y=new Map,d=w.some(i=>i.installOptions.installPreReleaseVersion),O=await this.extensionManagementService.getTargetPlatform(),E=[];for(const i of w)u.EXTENSION_IDENTIFIER_REGEX.test(i.id)&&E.push({...i,preRelease:d});if(E.length){const i=await this.extensionGalleryService.getExtensions(E,{targetPlatform:O},b.CancellationToken.None);for(const l of i)y.set(l.identifier.id.toLowerCase(),l)}return y}validateExtensionKind(w){return!0}async validateVSIX(w,y,d,O){if(!y){const E={id:(0,f.getGalleryExtensionId)(w.publisher,w.name)},i=O.find(l=>(0,f.areSameExtensions)(E,l.identifier)&&(0,k.gt)(l.manifest.version,w.version));if(i)return this.logger.info((0,p.localize)(1806,null,i.identifier.id,i.manifest.version,w.version)),!1}return this.validateExtensionKind(w)}async uninstallExtensions(w,y,d){const O=async i=>{if(i instanceof D.URI){const l=await this.extensionManagementService.getManifest(i);return(0,f.getExtensionId)(l.publisher,l.name)}return i},E=[];for(const i of w){const l=await O(i),n=(await this.extensionManagementService.getInstalled(void 0,d)).filter(t=>(0,f.areSameExtensions)(t.identifier,{id:l}));if(!n.length)throw new Error(`${this.notInstalled(l)}
${a}`);if(n.some(t=>t.type===h.ExtensionType.System)){this.logger.info((0,p.localize)(1807,null,l));return}if(!y&&n.some(t=>t.isBuiltin)){this.logger.info((0,p.localize)(1808,null,l));return}this.logger.info((0,p.localize)(1809,null,l));for(const t of n)await this.extensionManagementService.uninstall(t,{profileLocation:d}),E.push(t);this.location?this.logger.info((0,p.localize)(1810,null,l,this.location)):this.logger.info((0,p.localize)(1811,null,l))}}async locateExtension(w){const y=await this.extensionManagementService.getInstalled();w.forEach(d=>{y.forEach(O=>{if(O.identifier.id===d&&O.location.scheme===S.Schemas.file){this.logger.info(O.location.fsPath);return}})})}notInstalled(w){return this.location?(0,p.localize)(1812,null,w,this.location):(0,p.localize)(1813,null,w)}};e.ExtensionManagementCLI=v,e.ExtensionManagementCLI=v=Pe([oe(1,u.IExtensionManagementService),oe(2,u.IExtensionGalleryService)],v)}),define(ce[126],de([0,1,7,5,2,25,26,22,9]),function(J,e,b,C,S,R,k,D,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsWatcher=void 0;class u extends S.Disposable{constructor(h,m,a,v,I,w,y){super(),this.extensionManagementService=h,this.extensionsScannerService=m,this.userDataProfilesService=a,this.extensionsProfileScannerService=v,this.uriIdentityService=I,this.fileService=w,this.logService=y,this._onDidChangeExtensionsByAnotherSource=this._register(new C.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.allExtensions=new Map,this.extensionsProfileWatchDisposables=this._register(new S.DisposableMap),this.initialize().then(null,d=>y.error("Error while initializing Extensions Watcher",(0,b.getErrorMessage)(d)))}async initialize(){await this.extensionsScannerService.initializeDefaultProfileExtensions(),await this.onDidChangeProfiles(this.userDataProfilesService.profiles),this.registerListeners(),await this.uninstallExtensionsNotInProfiles()}registerListeners(){this._register(this.userDataProfilesService.onDidChangeProfiles(h=>this.onDidChangeProfiles(h.added))),this._register(this.extensionsProfileScannerService.onAddExtensions(h=>this.onAddExtensions(h))),this._register(this.extensionsProfileScannerService.onDidAddExtensions(h=>this.onDidAddExtensions(h))),this._register(this.extensionsProfileScannerService.onRemoveExtensions(h=>this.onRemoveExtensions(h))),this._register(this.extensionsProfileScannerService.onDidRemoveExtensions(h=>this.onDidRemoveExtensions(h))),this._register(this.fileService.onDidFilesChange(h=>this.onDidFilesChange(h)))}async onDidChangeProfiles(h){try{h.length&&await Promise.all(h.map(m=>(this.extensionsProfileWatchDisposables.set(m.id,(0,S.combinedDisposable)(this.fileService.watch(this.uriIdentityService.extUri.dirname(m.extensionsResource)),this.fileService.watch(m.extensionsResource))),this.populateExtensionsFromProfile(m.extensionsResource))))}catch(m){throw this.logService.error(m),m}}async onAddExtensions(h){for(const m of h.extensions)this.addExtensionWithKey(this.getKey(m.identifier,m.version),h.profileLocation)}async onDidAddExtensions(h){for(const m of h.extensions){const a=this.getKey(m.identifier,m.version);h.error?this.removeExtensionWithKey(a,h.profileLocation):this.addExtensionWithKey(a,h.profileLocation)}}async onRemoveExtensions(h){for(const m of h.extensions)this.removeExtensionWithKey(this.getKey(m.identifier,m.version),h.profileLocation)}async onDidRemoveExtensions(h){const m=[],a=[];for(const v of h.extensions){const I=this.getKey(v.identifier,v.version);h.error?this.addExtensionWithKey(I,h.profileLocation):(this.removeExtensionWithKey(I,h.profileLocation),this.allExtensions.has(I)||(this.logService.debug("Extension is removed from all profiles",v.identifier.id,v.version),a.push(this.extensionManagementService.scanInstalledExtensionAtLocation(v.location).then(w=>{w?m.push(w):this.logService.info("Extension not found at the location",v.location.toString())},w=>this.logService.error(w)))))}try{await Promise.all(a),m.length&&await this.uninstallExtensionsNotInProfiles(m)}catch(v){this.logService.error(v)}}onDidFilesChange(h){for(const m of this.userDataProfilesService.profiles)h.contains(m.extensionsResource,p.FileChangeType.UPDATED,p.FileChangeType.ADDED)&&this.onDidExtensionsProfileChange(m.extensionsResource)}async onDidExtensionsProfileChange(h){const m=[],a=[],v=await this.extensionsProfileScannerService.scanProfileExtensions(h),I=new Set,w=new Set;for(const[y,d]of this.allExtensions)d.has(h)&&w.add(y);for(const y of v){const d=this.getKey(y.identifier,y.version);I.add(d),w.has(d)||(m.push(y.identifier),this.addExtensionWithKey(d,h))}for(const y of w)if(!I.has(y)){const d=this.fromKey(y);d&&(a.push(d.identifier),this.removeExtensionWithKey(y,h))}(m.length||a.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:m.length?{extensions:m,profileLocation:h}:void 0,removed:a.length?{extensions:a,profileLocation:h}:void 0})}async populateExtensionsFromProfile(h){const m=await this.extensionsProfileScannerService.scanProfileExtensions(h);for(const a of m)this.addExtensionWithKey(this.getKey(a.identifier,a.version),h)}async uninstallExtensionsNotInProfiles(h){h||(h=(await this.extensionManagementService.scanAllUserInstalledExtensions()).filter(a=>!this.allExtensions.has(this.getKey(a.identifier,a.manifest.version)))),h.length&&await this.extensionManagementService.markAsUninstalled(...h)}addExtensionWithKey(h,m){let a=this.allExtensions.get(h);a||this.allExtensions.set(h,a=new R.ResourceSet(v=>this.uriIdentityService.extUri.getComparisonKey(v))),a.add(m)}removeExtensionWithKey(h,m){const a=this.allExtensions.get(h);a&&a.delete(m),a?.size||this.allExtensions.delete(h)}getKey(h,m){return`${D.ExtensionIdentifier.toKey(h.id)}@${m}`}fromKey(h){const[m,a]=(0,k.getIdAndVersion)(h);return a?{identifier:{id:m},version:a}:void 0}}e.ExtensionsWatcher=u}),define(ce[127],de([0,1,32,154,19,8,2,14,15,29,17,20,26,6,69,12]),function(J,e,b,C,S,R,k,D,p,u,f,h,m,a,v,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLanguagePackService=void 0,b=we(b);let w=class extends v.LanguagePackBaseService{constructor(E,i,l,r){super(l),this.extensionManagementService=E,this.logService=r,this.cache=this._register(new y(i,r)),this.extensionManagementService.registerParticipant({postInstall:async n=>this.postInstallExtension(n),postUninstall:async n=>this.postUninstallExtension(n)})}async getBuiltInExtensionTranslationsUri(E,i){const r=(await this.cache.getLanguagePacks())[i];if(!r){this.logService.warn(`No language pack found for ${i}`);return}const n=r.translations[E];return n?I.URI.file(n):void 0}async getInstalledLanguages(){const E=await this.cache.getLanguagePacks(),i=Object.keys(E).map(l=>{const r=E[l];return{...this.createQuickPickItem(l,r.label),extensionId:r.extensions[0].extensionIdentifier.id}});return i.push(this.createQuickPickItem("en","English")),i.sort((l,r)=>l.label.localeCompare(r.label)),i}async postInstallExtension(E){E&&E.manifest&&E.manifest.contributes&&E.manifest.contributes.localizations&&E.manifest.contributes.localizations.length&&(this.logService.info("Adding language packs from the extension",E.identifier.id),await this.update())}async postUninstallExtension(E){const i=await this.cache.getLanguagePacks();Object.keys(i).some(l=>i[l]&&i[l].extensions.some(r=>(0,m.areSameExtensions)(r.extensionIdentifier,E.identifier)))&&(this.logService.info("Removing language packs from the extension",E.identifier.id),await this.update())}async update(){const[E,i]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),l=await this.cache.update(i);return!(0,S.equals)(Object.keys(E),Object.keys(l))}};e.NativeLanguagePackService=w,e.NativeLanguagePackService=w=Pe([oe(0,h.IExtensionManagementService),oe(1,f.INativeEnvironmentService),oe(2,h.IExtensionGalleryService),oe(3,a.ILogService)],w);let y=class extends k.Disposable{constructor(E,i){super(),this.logService=i,this.languagePacks={},this.languagePacksFilePath=(0,p.join)(E.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new R.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(E){return this.withLanguagePacks(i=>{Object.keys(i).forEach(l=>delete i[l]),this.createLanguagePacksFromExtensions(i,...E)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(E,...i){for(const l of i)l&&l.manifest&&l.manifest.contributes&&l.manifest.contributes.localizations&&l.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(E,l);Object.keys(E).forEach(l=>this.updateHash(E[l]))}createLanguagePacksFromExtension(E,i){const l=i.identifier,r=i.manifest.contributes&&i.manifest.contributes.localizations?i.manifest.contributes.localizations:[];for(const n of r)if(i.location.scheme===D.Schemas.file&&d(n)){let t=E[n.languageId];t||(t={hash:"",extensions:[],translations:{},label:n.localizedLanguageName??n.languageName},E[n.languageId]=t);const s=t.extensions.filter(o=>(0,m.areSameExtensions)(o.extensionIdentifier,l))[0];s?s.version=i.manifest.version:t.extensions.push({extensionIdentifier:l,version:i.manifest.version});for(const o of n.translations)t.translations[o.id]=(0,p.join)(i.location.fsPath,o.path)}}updateHash(E){if(E){const i=(0,C.createHash)("md5");for(const l of E.extensions)i.update(l.extensionIdentifier.uuid||l.extensionIdentifier.id).update(l.version);E.hash=i.digest("hex")}}withLanguagePacks(E=()=>null){return this.languagePacksFileLimiter.queue(()=>{let i=null;return b.promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,l=>l.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(l)).then(l=>{try{return JSON.parse(l)}catch{return{}}}).then(l=>(i=E(l),l)).then(l=>{for(const n of Object.keys(l))l[n]||delete l[n];this.languagePacks=l,this.initializedCache=!0;const r=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",r),u.Promises.writeFile(this.languagePacksFilePath,r)}).then(()=>i,l=>this.logService.error(l))})}};y=Pe([oe(0,f.INativeEnvironmentService),oe(1,a.ILogService)],y);function d(O){if(typeof O.languageId!="string"||!Array.isArray(O.translations)||O.translations.length===0)return!1;for(const E of O.translations)if(typeof E.id!="string"||typeof E.path!="string")return!1;return!(O.languageName&&typeof O.languageName!="string"||O.localizedLanguageName&&typeof O.localizedLanguageName!="string")}}),define(ce[128],de([0,1,58,7,27,11,41]),function(J,e,b,C,S,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractOneDataSystemAppender=void 0;const D="https://0.0.0.0/OneCollector/1.0",p="https://0.0.0.0/ping";async function u(h,m,a){R.isWeb;const v=await(0,b.importAMDNodeModule)("@microsoft/1ds-core-js","dist/ms.core.js"),I=await(0,b.importAMDNodeModule)("@microsoft/1ds-post-js","dist/ms.post.js"),w=new v.AppInsightsCore,y=new I.PostChannel,d={instrumentationKey:h,endpointUrl:D,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[y]]};if(a){d.extensionConfig={};const O={alwaysUseXhrOverride:!0,ignoreMc1Ms0CookieProcessing:!0,httpXHROverride:a};d.extensionConfig[y.identifier]=O}return w.initialize(d,[]),w.addTelemetryInitializer(O=>{O.ext=O.ext??{},O.ext.web=O.ext.web??{},O.ext.web.consentDetails='{"GPC_DataSharingOptIn":false}',m&&(O.ext.utc=O.ext.utc??{},O.ext.utc.flags=8462029)}),w}class f{constructor(m,a,v,I,w){this._isInternalTelemetry=m,this._eventPrefix=a,this._defaultData=v,this._xhrOverride=w,this.endPointUrl=D,this.endPointHealthUrl=p,this._defaultData||(this._defaultData={}),typeof I=="function"?this._aiCoreOrKey=I():this._aiCoreOrKey=I,this._asyncAiCore=null}_withAIClient(m){if(this._aiCoreOrKey){if(typeof this._aiCoreOrKey!="string"){m(this._aiCoreOrKey);return}this._asyncAiCore||(this._asyncAiCore=u(this._aiCoreOrKey,this._isInternalTelemetry,this._xhrOverride)),this._asyncAiCore.then(a=>{m(a)},a=>{(0,C.onUnexpectedError)(a),console.error(a)})}}log(m,a){if(!this._aiCoreOrKey)return;a=(0,S.mixin)(a,this._defaultData),a=(0,k.validateTelemetryData)(a);const v=this._eventPrefix+"/"+m;try{this._withAIClient(I=>{I.pluginVersionString=a?.properties.version??"Unknown",I.track({name:v,baseData:{name:v,properties:a?.properties,measurements:a?.measurements}})})}catch{}}flush(){return this._aiCoreOrKey?new Promise(m=>{this._withAIClient(a=>{a.unload(!0,()=>{this._aiCoreOrKey=void 0,m(void 0)})})}):Promise.resolve(void 0)}}e.AbstractOneDataSystemAppender=f});var Ve=this&&this.__importDefault||function(J){return J&&J.__esModule?J:{default:J}};define(ce[129],de([0,1,2,27,11,31,4,30,40,130,33,37,18,41]),function(J,e,b,C,S,R,k,D,p,u,f,h,m,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0,u=Ve(u);let v=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor(y,d,O){this._configurationService=d,this._productService=O,this._experimentProperties={},this._disposables=new b.DisposableStore,this._cleanupPatterns=[],this._appenders=y.appenders,this._commonProperties=y.commonProperties??Object.create(null),this.sessionId=this._commonProperties.sessionID,this.machineId=this._commonProperties["common.machineId"],this.sqmId=this._commonProperties["common.sqmId"],this.devDeviceId=this._commonProperties["common.devDeviceId"],this.firstSessionDate=this._commonProperties["common.firstSessionDate"],this.msftInternal=this._commonProperties["common.msftInternal"],this._piiPaths=y.piiPaths||[],this._telemetryLevel=m.TelemetryLevel.USAGE,this._sendErrorTelemetry=!!y.sendErrorTelemetry,this._cleanupPatterns=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const E of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,R.escapeRegExpCharacters)(E),"gi")),E.indexOf("\\")>=0&&this._cleanupPatterns.push(new RegExp((0,R.escapeRegExpCharacters)(E.replace(/\\/g,"/")),"gi"));this._updateTelemetryLevel(),this._disposables.add(this._configurationService.onDidChangeConfiguration(E=>{(E.affectsConfiguration(m.TELEMETRY_SETTING_ID)||E.affectsConfiguration(m.TELEMETRY_OLD_SETTING_ID)||E.affectsConfiguration(m.TELEMETRY_CRASH_REPORTER_SETTING_ID))&&this._updateTelemetryLevel()}))}setExperimentProperty(y,d){this._experimentProperties[y]=d}_updateTelemetryLevel(){let y=(0,a.getTelemetryLevel)(this._configurationService);const d=this._productService.enabledTelemetryLevels;if(d){this._sendErrorTelemetry=this.sendErrorTelemetry?d.error:!1;const O=d.usage?m.TelemetryLevel.USAGE:d.error?m.TelemetryLevel.ERROR:m.TelemetryLevel.NONE;y=Math.min(y,O)}this._telemetryLevel=y}get sendErrorTelemetry(){return this._sendErrorTelemetry}get telemetryLevel(){return this._telemetryLevel}dispose(){this._disposables.dispose()}_log(y,d,O){this._telemetryLevel<d||(O=(0,C.mixin)(O,this._experimentProperties),O=(0,a.cleanData)(O,this._cleanupPatterns),O=(0,C.mixin)(O,this._commonProperties),this._appenders.forEach(E=>E.log(y,O)))}publicLog(y,d){this._log(y,m.TelemetryLevel.USAGE,d)}publicLog2(y,d){this.publicLog(y,d)}publicLogError(y,d){this._sendErrorTelemetry&&this._log(y,m.TelemetryLevel.ERROR,d)}publicLogError2(y,d){this.publicLogError(y,d)}};e.TelemetryService=v,e.TelemetryService=v=Pe([oe(1,D.IConfigurationService),oe(2,f.IProductService)],v);function I(){const w=(0,k.localize)(2068,null,u.default.nameLong),y=u.default.privacyStatementUrl?(0,k.localize)(2070,null,"https://aka.ms/vscode-telemetry",u.default.privacyStatementUrl):(0,k.localize)(2069,null,"https://aka.ms/vscode-telemetry"),d=S.isWeb?"":(0,k.localize)(2071,null),O=(0,k.localize)(2072,null),E=(0,k.localize)(2073,null),i=(0,k.localize)(2074,null),l=(0,k.localize)(2075,null),r=`
|       | ${O} | ${E} | ${i} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,n=(0,k.localize)(2076,null);return`
${w} ${y} ${d}

&nbsp;

${l}
${r}

&nbsp;

${n}
`}h.Registry.as(p.Extensions.Configuration).registerConfiguration({id:m.TELEMETRY_SECTION_ID,order:1,type:"object",title:(0,k.localize)(2077,null),properties:{[m.TELEMETRY_SETTING_ID]:{type:"string",enum:[m.TelemetryConfiguration.ON,m.TelemetryConfiguration.ERROR,m.TelemetryConfiguration.CRASH,m.TelemetryConfiguration.OFF],enumDescriptions:[(0,k.localize)(2078,null),(0,k.localize)(2079,null),(0,k.localize)(2080,null),(0,k.localize)(2081,null)],markdownDescription:I(),default:m.TelemetryConfiguration.OFF,restricted:!0,scope:p.ConfigurationScope.APPLICATION,tags:["usesOnlineServices","telemetry"]}}}),h.Registry.as(p.Extensions.Configuration).registerConfiguration({id:m.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,k.localize)(2082,null),properties:{[m.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:u.default.privacyStatementUrl?(0,k.localize)(2084,null,u.default.nameLong,u.default.privacyStatementUrl):(0,k.localize)(2083,null,u.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,k.localize)(2085,null,`\`#${m.TELEMETRY_SETTING_ID}#\``),scope:p.ConfigurationScope.APPLICATION,tags:["usesOnlineServices","telemetry"]}}})}),define(ce[131],de([0,1,13,21,155,128]),function(J,e,b,C,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OneDataSystemAppender=void 0,S=we(S);async function k(f,h){const m=await h.request(f,C.CancellationToken.None),a=(await(0,b.streamToBuffer)(m.stream)).toString(),v=m.res.statusCode??200;return{headers:m.res.headers,statusCode:v,responseData:a}}async function D(f){const h={method:f.type,headers:f.headers};return new Promise((a,v)=>{const I=S.request(f.url??"",h,w=>{w.on("data",function(y){a({headers:w.headers,statusCode:w.statusCode??200,responseData:y.toString()})}),w.on("error",function(y){v(y)})});I.write(f.data,w=>{w&&v(w)}),I.end()})}async function p(f,h,m){const a=typeof h.data=="string"?h.data:new TextDecoder().decode(h.data),v={type:"POST",headers:{...h.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(h.data).toString()},url:h.urlString,data:a};try{const I=f?await k(v,f):await D(v);m(I.statusCode,I.headers,I.responseData)}catch{m(0,{})}}class u extends R.AbstractOneDataSystemAppender{constructor(h,m,a,v,I){const w={sendPOST:(y,d)=>{p(h,y,d)}};super(m,a,v,I,w)}}e.OneDataSystemAppender=u}),define(ce[132],de([0,1,32,15,29]),function(J,e,b,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildTelemetryMessage=R,b=we(b);async function R(k,D){const p=Object.create(null),u=(h,m)=>{const a=JSON.parse(h);p[m]=a};if(D){const h=[],m=await S.Promises.readdir(D);for(const v of m)try{(await b.promises.stat((0,C.join)(D,v))).isDirectory()&&h.push(v)}catch{}const a=[];for(const v of h)(await S.Promises.readdir((0,C.join)(D,v))).filter(w=>w==="telemetry.json").length===1&&a.push(v);for(const v of a){const I=(await b.promises.readFile((0,C.join)(D,v,"telemetry.json"))).toString();u(I,v)}}let f=(await b.promises.readFile((0,C.join)(k,"telemetry-core.json"))).toString();return u(f,"vscode-core"),f=(await b.promises.readFile((0,C.join)(k,"telemetry-extensions.json"))).toString(),u(f,"vscode-extensions"),JSON.stringify(p,null,4)}}),define(ce[133],de([0,1,11,87,18]),function(J,e,b,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMachineId=R,e.resolveSqmId=k,e.resolvedevDeviceId=D;async function R(p,u){let f=p.getItem(S.machineIdKey);return(typeof f!="string"||b.isMacintosh&&f==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(f=await(0,C.getMachineId)(u.error.bind(u))),f}async function k(p,u){let f=p.getItem(S.sqmIdKey);return typeof f!="string"&&(f=await(0,C.getSqmMachineId)(u.error.bind(u))),f}async function D(p,u){let f=p.getItem(S.devDeviceIdKey);return typeof f!="string"&&(f=await(0,C.getdevDeviceId)(u.error.bind(u))),f}}),define(ce[23],de([0,1,10]),function(J,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,b.createDecorator)("IUriIdentityService")}),define(ce[134],de([0,1,23,99,9,16,81,5,2]),function(J,e,b,C,S,R,k,D,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class u{static{this._clock=0}constructor(m){this.uri=m,this.time=u._clock++}touch(){return this.time=u._clock++,this}}let f=class{constructor(m){this._fileService=m,this._dispooables=new p.DisposableStore,this._limit=2**16;const a=new Map,v=I=>{let w=a.get(I.scheme);return w===void 0&&(w=m.hasProvider(I)&&!this._fileService.hasCapability(I,S.FileSystemProviderCapabilities.PathCaseSensitive),a.set(I.scheme,w)),w};this._dispooables.add(D.Event.any(m.onDidChangeFileSystemProviderRegistrations,m.onDidChangeFileSystemProviderCapabilities)(I=>{a.delete(I.scheme)})),this.extUri=new R.ExtUri(v),this._canonicalUris=new k.SkipList((I,w)=>this.extUri.compare(I,w,!0),this._limit)}dispose(){this._dispooables.dispose(),this._canonicalUris.clear()}asCanonicalUri(m){this._fileService.hasProvider(m)&&(m=(0,R.normalizePath)(m));const a=this._canonicalUris.get(m);return a?a.touch().uri.with({fragment:m.fragment}):(this._canonicalUris.set(m,new u(m)),this._checkTrim(),m)}_checkTrim(){if(this._canonicalUris.size<this._limit)return;const m=[...this._canonicalUris.entries()].sort((v,I)=>v[1].time<I[1].time?1:v[1].time>I[1].time?-1:0);u._clock=0,this._canonicalUris.clear();const a=this._limit*.5;for(let v=0;v<a;v++)this._canonicalUris.set(m[v][0],m[v][1].touch())}};e.UriIdentityService=f,e.UriIdentityService=f=Pe([oe(0,S.IFileService)],f),(0,C.registerSingleton)(b.IUriIdentityService,f,C.InstantiationType.Delayed)}),define(ce[135],de([0,1,5,2,9,49,25]),function(J,e,b,C,S,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileUserDataProvider=void 0;class D extends C.Disposable{constructor(u,f,h,m,a,v){super(),this.fileSystemScheme=u,this.fileSystemProvider=f,this.userDataScheme=h,this.userDataProfilesService=m,this.uriIdentityService=a,this.logService=v,this.capabilities=this.fileSystemProvider.capabilities,this.onDidChangeCapabilities=this.fileSystemProvider.onDidChangeCapabilities,this._onDidChangeFile=this._register(new b.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.watchResources=R.TernarySearchTree.forUris(()=>!(this.capabilities&S.FileSystemProviderCapabilities.PathCaseSensitive)),this.atomicReadWriteResources=new k.ResourceSet(I=>this.uriIdentityService.extUri.getComparisonKey(this.toFileSystemResource(I))),this.updateAtomicReadWritesResources(),this._register(m.onDidChangeProfiles(()=>this.updateAtomicReadWritesResources())),this._register(this.fileSystemProvider.onDidChangeFile(I=>this.handleFileChanges(I)))}updateAtomicReadWritesResources(){this.atomicReadWriteResources.clear();for(const u of this.userDataProfilesService.profiles)this.atomicReadWriteResources.add(u.settingsResource),this.atomicReadWriteResources.add(u.keybindingsResource),this.atomicReadWriteResources.add(u.tasksResource),this.atomicReadWriteResources.add(u.extensionsResource)}open(u,f){return this.fileSystemProvider.open(this.toFileSystemResource(u),f)}close(u){return this.fileSystemProvider.close(u)}read(u,f,h,m,a){return this.fileSystemProvider.read(u,f,h,m,a)}write(u,f,h,m,a){return this.fileSystemProvider.write(u,f,h,m,a)}watch(u,f){this.watchResources.set(u,u);const h=this.fileSystemProvider.watch(this.toFileSystemResource(u),f);return(0,C.toDisposable)(()=>{this.watchResources.delete(u),h.dispose()})}stat(u){return this.fileSystemProvider.stat(this.toFileSystemResource(u))}mkdir(u){return this.fileSystemProvider.mkdir(this.toFileSystemResource(u))}rename(u,f,h){return this.fileSystemProvider.rename(this.toFileSystemResource(u),this.toFileSystemResource(f),h)}readFile(u,f){return this.fileSystemProvider.readFile(this.toFileSystemResource(u),f)}readFileStream(u,f,h){return this.fileSystemProvider.readFileStream(this.toFileSystemResource(u),f,h)}readdir(u){return this.fileSystemProvider.readdir(this.toFileSystemResource(u))}enforceAtomicReadFile(u){return this.atomicReadWriteResources.has(u)}writeFile(u,f,h){return this.fileSystemProvider.writeFile(this.toFileSystemResource(u),f,h)}enforceAtomicWriteFile(u){return this.atomicReadWriteResources.has(u)?{postfix:".vsctmp"}:!1}delete(u,f){return this.fileSystemProvider.delete(this.toFileSystemResource(u),f)}copy(u,f,h){if((0,S.hasFileFolderCopyCapability)(this.fileSystemProvider))return this.fileSystemProvider.copy(this.toFileSystemResource(u),this.toFileSystemResource(f),h);throw new Error("copy not supported")}cloneFile(u,f){if((0,S.hasFileCloneCapability)(this.fileSystemProvider))return this.fileSystemProvider.cloneFile(this.toFileSystemResource(u),this.toFileSystemResource(f));throw new Error("clone not supported")}handleFileChanges(u){const f=[];for(const h of u){if(h.resource.scheme!==this.fileSystemScheme)continue;const m=this.toUserDataResource(h.resource);this.watchResources.findSubstr(m)&&f.push({resource:m,type:h.type,cId:h.cId})}f.length&&(this.logService.debug("User data changed"),this._onDidChangeFile.fire(f))}toFileSystemResource(u){return u.with({scheme:this.fileSystemScheme})}toUserDataResource(u){return u.with({scheme:this.userDataScheme})}}e.FileUserDataProvider=D}),define(ce[136],de([0,1,4,15,49,16,12,10,14]),function(J,e,b,C,S,R,k,D,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.STANDALONE_EDITOR_WORKSPACE_ID=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.WorkspaceFolder=e.Workspace=e.WorkbenchState=e.UNKNOWN_EMPTY_WINDOW_WORKSPACE=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.IWorkspaceContextService=void 0,e.isSingleFolderWorkspaceIdentifier=u,e.isEmptyWorkspaceIdentifier=f,e.toWorkspaceIdentifier=h,e.isWorkspaceIdentifier=m,e.reviveIdentifier=a,e.isWorkspace=I,e.isWorkspaceFolder=w,e.toWorkspaceFolder=O,e.isUntitledWorkspace=E,e.isTemporaryWorkspace=i,e.isStandaloneEditorWorkspace=l,e.isSavedWorkspace=r,e.hasWorkspaceFileExtension=n,e.IWorkspaceContextService=(0,D.createDecorator)("contextService");function u(t){const s=t;return typeof s?.id=="string"&&k.URI.isUri(s.uri)}function f(t){return typeof t?.id=="string"&&!u(t)&&!m(t)}e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"},e.UNKNOWN_EMPTY_WINDOW_WORKSPACE={id:"empty-window"};function h(t,s){if(typeof t=="string"||typeof t>"u")return typeof t=="string"?{id:(0,C.basename)(t)}:s?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:e.UNKNOWN_EMPTY_WINDOW_WORKSPACE;const o=t;return o.configuration?{id:o.id,configPath:o.configuration}:o.folders.length===1?{id:o.id,uri:o.folders[0].uri}:{id:o.id}}function m(t){const s=t;return typeof s?.id=="string"&&k.URI.isUri(s.configPath)}function a(t){const s=t;if(s?.uri)return{id:s.id,uri:k.URI.revive(s.uri)};const o=t;if(o?.configPath)return{id:o.id,configPath:k.URI.revive(o.configPath)};if(t?.id)return{id:t.id}}var v;(function(t){t[t.EMPTY=1]="EMPTY",t[t.FOLDER=2]="FOLDER",t[t.WORKSPACE=3]="WORKSPACE"})(v||(e.WorkbenchState=v={}));function I(t){const s=t;return!!(s&&typeof s=="object"&&typeof s.id=="string"&&Array.isArray(s.folders))}function w(t){const s=t;return!!(s&&typeof s=="object"&&k.URI.isUri(s.uri)&&typeof s.name=="string"&&typeof s.toResource=="function")}class y{constructor(s,o,c,g,T){this._id=s,this._transient=c,this._configuration=g,this._ignorePathCasing=T,this._foldersMap=S.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0),this.folders=o}update(s){this._id=s.id,this._configuration=s.configuration,this._transient=s.transient,this._ignorePathCasing=s._ignorePathCasing,this.folders=s.folders}get folders(){return this._folders}set folders(s){this._folders=s,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(s){this._configuration=s}getFolder(s){return s&&this._foldersMap.findSubstr(s)||null}updateFoldersMap(){this._foldersMap=S.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0);for(const s of this.folders)this._foldersMap.set(s.uri,s)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=y;class d{constructor(s,o){this.raw=o,this.uri=s.uri,this.index=s.index,this.name=s.name}toResource(s){return(0,R.joinPath)(this.uri,s)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=d;function O(t){return new d({uri:t,index:0,name:(0,R.basenameOrAuthority)(t)},{uri:t.toString()})}e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,b.localize)(2489,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function E(t,s){return R.extUriBiasedIgnorePathCase.isEqualOrParent(t,s.untitledWorkspacesHome)}function i(t){let s;return k.URI.isUri(t)?s=t:s=t.configuration,s?.scheme===p.Schemas.tmp}e.STANDALONE_EDITOR_WORKSPACE_ID="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function l(t){return t.id===e.STANDALONE_EDITOR_WORKSPACE_ID}function r(t,s){return!E(t,s)&&!i(t)}function n(t){return(typeof t=="string"?(0,C.extname)(t):(0,R.extname)(t))===e.WORKSPACE_SUFFIX}}),define(ce[24],de([0,1,43,5,2,16,12,4,17,9,10,6,136,25,23,8,28,31,3]),function(J,e,b,C,S,R,k,D,p,u,f,h,m,a,v,I,w,y,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryUserDataProfilesService=e.UserDataProfilesService=e.IUserDataProfilesService=e.ProfileResourceType=void 0,e.isUserDataProfile=E,e.reviveProfile=i,e.toUserDataProfile=l;var O;(function(t){t.Settings="settings",t.Keybindings="keybindings",t.Snippets="snippets",t.Tasks="tasks",t.Extensions="extensions",t.GlobalState="globalState"})(O||(e.ProfileResourceType=O={}));function E(t){const s=t;return!!(s&&typeof s=="object"&&typeof s.id=="string"&&typeof s.isDefault=="boolean"&&typeof s.name=="string"&&k.URI.isUri(s.location)&&k.URI.isUri(s.globalStorageHome)&&k.URI.isUri(s.settingsResource)&&k.URI.isUri(s.keybindingsResource)&&k.URI.isUri(s.tasksResource)&&k.URI.isUri(s.snippetsHome)&&k.URI.isUri(s.extensionsResource))}e.IUserDataProfilesService=(0,f.createDecorator)("IUserDataProfilesService");function i(t,s){return{id:t.id,isDefault:t.isDefault,name:t.name,shortName:t.shortName,icon:t.icon,location:k.URI.revive(t.location).with({scheme:s}),globalStorageHome:k.URI.revive(t.globalStorageHome).with({scheme:s}),settingsResource:k.URI.revive(t.settingsResource).with({scheme:s}),keybindingsResource:k.URI.revive(t.keybindingsResource).with({scheme:s}),tasksResource:k.URI.revive(t.tasksResource).with({scheme:s}),snippetsHome:k.URI.revive(t.snippetsHome).with({scheme:s}),extensionsResource:k.URI.revive(t.extensionsResource).with({scheme:s}),cacheHome:k.URI.revive(t.cacheHome).with({scheme:s}),useDefaultFlags:t.useDefaultFlags,isTransient:t.isTransient}}function l(t,s,o,c,g,T){return{id:t,name:s,location:o,isDefault:!1,shortName:g?.shortName,icon:g?.icon,globalStorageHome:T&&g?.useDefaultFlags?.globalState?T.globalStorageHome:(0,R.joinPath)(o,"globalStorage"),settingsResource:T&&g?.useDefaultFlags?.settings?T.settingsResource:(0,R.joinPath)(o,"settings.json"),keybindingsResource:T&&g?.useDefaultFlags?.keybindings?T.keybindingsResource:(0,R.joinPath)(o,"keybindings.json"),tasksResource:T&&g?.useDefaultFlags?.tasks?T.tasksResource:(0,R.joinPath)(o,"tasks.json"),snippetsHome:T&&g?.useDefaultFlags?.snippets?T.snippetsHome:(0,R.joinPath)(o,"snippets"),extensionsResource:T&&g?.useDefaultFlags?.extensions?T.extensionsResource:(0,R.joinPath)(o,"extensions.json"),cacheHome:(0,R.joinPath)(c,t),useDefaultFlags:g?.useDefaultFlags,isTransient:g?.transient}}let r=class extends S.Disposable{static{this.PROFILES_KEY="userDataProfiles"}static{this.PROFILE_ASSOCIATIONS_KEY="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.profilesObject.profiles,...this.transientProfilesObject.profiles]}constructor(s,o,c,g){super(),this.environmentService=s,this.fileService=o,this.uriIdentityService=c,this.logService=g,this.enabled=!0,this._onDidChangeProfiles=this._register(new C.Emitter),this.onDidChangeProfiles=this._onDidChangeProfiles.event,this._onWillCreateProfile=this._register(new C.Emitter),this.onWillCreateProfile=this._onWillCreateProfile.event,this._onWillRemoveProfile=this._register(new C.Emitter),this.onWillRemoveProfile=this._onWillRemoveProfile.event,this._onDidResetWorkspaces=this._register(new C.Emitter),this.onDidResetWorkspaces=this._onDidResetWorkspaces.event,this.profileCreationPromises=new Map,this.transientProfilesObject={profiles:[],folders:new a.ResourceMap,workspaces:new a.ResourceMap,emptyWindows:new Map},this.profilesHome=(0,R.joinPath)(this.environmentService.userRoamingDataHome,"profiles"),this.profilesCacheHome=(0,R.joinPath)(this.environmentService.cacheHome,"CachedProfilesData")}init(){this._profilesObject=void 0}setEnablement(s){this.enabled!==s&&(this._profilesObject=void 0,this.enabled=s)}isEnabled(){return this.enabled}get profilesObject(){if(!this._profilesObject){const s=this.createDefaultProfile(),o=[s];if(this.enabled)try{for(const T of this.getStoredProfiles()){if(!T.name||!(0,d.isString)(T.name)||!T.location){this.logService.warn("Skipping the invalid stored profile",T.location||T.name);continue}o.push(l((0,R.basename)(T.location),T.name,T.location,this.profilesCacheHome,{shortName:T.shortName,icon:T.icon,useDefaultFlags:T.useDefaultFlags},s))}}catch(T){this.logService.error(T)}const c=new a.ResourceMap,g=new Map;if(o.length)try{const T=this.getStoredProfileAssociations();if(T.workspaces)for(const[N,A]of Object.entries(T.workspaces)){const L=k.URI.parse(N),M=o.find(B=>B.id===A);M&&c.set(L,M)}if(T.emptyWindows)for(const[N,A]of Object.entries(T.emptyWindows)){const L=o.find(M=>M.id===A);L&&g.set(N,L)}}catch(T){this.logService.error(T)}this._profilesObject={profiles:o,workspaces:c,emptyWindows:g}}return this._profilesObject}createDefaultProfile(){const s=l("__default__profile__",(0,D.localize)(2442,null),this.environmentService.userRoamingDataHome,this.profilesCacheHome);return{...s,extensionsResource:this.getDefaultProfileExtensionsLocation()??s.extensionsResource,isDefault:!0}}async createTransientProfile(s){const o="Temp",c=new RegExp(`${(0,y.escapeRegExpCharacters)(o)}\\s(\\d+)`);let g=0;for(const N of this.profiles){const A=c.exec(N.name),L=A?parseInt(A[1]):0;g=L>g?L:g}const T=`${o} ${g+1}`;return this.createProfile((0,b.hash)((0,w.generateUuid)()).toString(16),T,{transient:!0},s)}async createNamedProfile(s,o,c){return this.createProfile((0,b.hash)((0,w.generateUuid)()).toString(16),s,o,c)}async createProfile(s,o,c,g){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");const T=await this.doCreateProfile(s,o,c);return g&&await this.setProfileForWorkspace(g,T),T}async doCreateProfile(s,o,c){if(!(0,d.isString)(o)||!o)throw new Error("Name of the profile is mandatory and must be of type `string`");let g=this.profileCreationPromises.get(o);return g||(g=(async()=>{try{if(this.profiles.find(L=>L.name===o||L.id===s))throw new Error(`Profile with ${o} name already exists`);const N=l(s,o,(0,R.joinPath)(this.profilesHome,s),this.profilesCacheHome,c,this.defaultProfile);await this.fileService.createFolder(N.location);const A=[];return this._onWillCreateProfile.fire({profile:N,join(L){A.push(L)}}),await I.Promises.settled(A),this.updateProfiles([N],[],[]),N}finally{this.profileCreationPromises.delete(o)}})(),this.profileCreationPromises.set(o,g)),g}async updateProfile(s,o){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");let c=this.profiles.find(g=>g.id===s.id);if(!c)throw new Error(`Profile '${s.name}' does not exist`);return c=l(c.id,o.name??c.name,c.location,this.profilesCacheHome,{shortName:o.shortName??c.shortName,icon:o.icon===null?void 0:o.icon??c.icon,transient:o.transient??c.isTransient,useDefaultFlags:o.useDefaultFlags??c.useDefaultFlags},this.defaultProfile),this.updateProfiles([],[],[c]),c}async removeProfile(s){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");if(s.isDefault)throw new Error("Cannot remove default profile");const o=this.profiles.find(g=>g.id===s.id);if(!o)throw new Error(`Profile '${s.name}' does not exist`);const c=[];this._onWillRemoveProfile.fire({profile:o,join(g){c.push(g)}});try{await Promise.allSettled(c)}catch(g){this.logService.error(g)}for(const g of[...this.profilesObject.emptyWindows.keys()])o.id===this.profilesObject.emptyWindows.get(g)?.id&&this.profilesObject.emptyWindows.delete(g);for(const g of[...this.profilesObject.workspaces.keys()])o.id===this.profilesObject.workspaces.get(g)?.id&&this.profilesObject.workspaces.delete(g);this.updateStoredProfileAssociations(),this.updateProfiles([],[o],[]);try{await this.fileService.del(o.cacheHome,{recursive:!0})}catch(g){(0,u.toFileOperationResult)(g)!==u.FileOperationResult.FILE_NOT_FOUND&&this.logService.error(g)}}async setProfileForWorkspace(s,o){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");const c=this.profiles.find(g=>g.id===o.id);if(!c)throw new Error(`Profile '${o.name}' does not exist`);this.updateWorkspaceAssociation(s,c)}unsetWorkspace(s,o){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");this.updateWorkspaceAssociation(s,void 0,o)}async resetWorkspaces(){this.transientProfilesObject.folders.clear(),this.transientProfilesObject.workspaces.clear(),this.transientProfilesObject.emptyWindows.clear(),this.profilesObject.workspaces.clear(),this.profilesObject.emptyWindows.clear(),this.updateStoredProfileAssociations(),this._onDidResetWorkspaces.fire()}async cleanUp(){if(this.enabled&&await this.fileService.exists(this.profilesHome)){const s=await this.fileService.resolve(this.profilesHome);await Promise.all((s.children||[]).filter(o=>o.isDirectory&&this.profiles.every(c=>!this.uriIdentityService.extUri.isEqual(c.location,o.resource))).map(o=>this.fileService.del(o.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.enabled)return;const s=this.transientProfilesObject.profiles.filter(o=>!this.isProfileAssociatedToWorkspace(o));await Promise.allSettled(s.map(o=>this.removeProfile(o)))}getProfileForWorkspace(s){const o=this.getWorkspace(s),c=k.URI.isUri(o)?this.profilesObject.workspaces.get(o):this.profilesObject.emptyWindows.get(o);return c||((0,m.isSingleFolderWorkspaceIdentifier)(s)?this.transientProfilesObject.folders.get(s.uri):(0,m.isWorkspaceIdentifier)(s)?this.transientProfilesObject.workspaces.get(s.configPath):this.transientProfilesObject.emptyWindows.get(s.id))}getWorkspace(s){return(0,m.isSingleFolderWorkspaceIdentifier)(s)?s.uri:(0,m.isWorkspaceIdentifier)(s)?s.configPath:s.id}isProfileAssociatedToWorkspace(s){return!!([...this.profilesObject.emptyWindows.values()].some(o=>this.uriIdentityService.extUri.isEqual(o.location,s.location))||[...this.profilesObject.workspaces.values()].some(o=>this.uriIdentityService.extUri.isEqual(o.location,s.location))||[...this.transientProfilesObject.emptyWindows.values()].some(o=>this.uriIdentityService.extUri.isEqual(o.location,s.location))||[...this.transientProfilesObject.workspaces.values()].some(o=>this.uriIdentityService.extUri.isEqual(o.location,s.location))||[...this.transientProfilesObject.folders.values()].some(o=>this.uriIdentityService.extUri.isEqual(o.location,s.location)))}updateProfiles(s,o,c){const g=[...this.profiles,...s],T=[],N=this.transientProfilesObject.profiles;this.transientProfilesObject.profiles=[];for(let A of g){if(A.isDefault||o.some(M=>A.id===M.id))continue;A=c.find(M=>A.id===M.id)??A;const L=N.find(M=>A.id===M.id);if(A.isTransient)this.transientProfilesObject.profiles.push(A);else{if(L){for(const[M,B]of this.transientProfilesObject.emptyWindows.entries())if(A.id===B.id){this.updateWorkspaceAssociation({id:M},A);break}for(const[M,B]of this.transientProfilesObject.workspaces.entries())if(A.id===B.id){this.updateWorkspaceAssociation({id:"",configPath:M},A);break}for(const[M,B]of this.transientProfilesObject.folders.entries())if(A.id===B.id){this.updateWorkspaceAssociation({id:"",uri:M},A);break}}T.push({location:A.location,name:A.name,shortName:A.shortName,icon:A.icon,useDefaultFlags:A.useDefaultFlags})}}this.saveStoredProfiles(T),this._profilesObject=void 0,this.triggerProfilesChanges(s,o,c)}triggerProfilesChanges(s,o,c){this._onDidChangeProfiles.fire({added:s,removed:o,updated:c,all:this.profiles})}updateWorkspaceAssociation(s,o,c){if(c=o?.isTransient?!0:c,c)(0,m.isSingleFolderWorkspaceIdentifier)(s)?(this.transientProfilesObject.folders.delete(s.uri),o&&this.transientProfilesObject.folders.set(s.uri,o)):(0,m.isWorkspaceIdentifier)(s)?(this.transientProfilesObject.workspaces.delete(s.configPath),o&&this.transientProfilesObject.workspaces.set(s.configPath,o)):(this.transientProfilesObject.emptyWindows.delete(s.id),o&&this.transientProfilesObject.emptyWindows.set(s.id,o));else{this.updateWorkspaceAssociation(s,void 0,!0);const g=this.getWorkspace(s);k.URI.isUri(g)?(this.profilesObject.workspaces.delete(g),o&&this.profilesObject.workspaces.set(g,o)):(this.profilesObject.emptyWindows.delete(g),o&&this.profilesObject.emptyWindows.set(g,o)),this.updateStoredProfileAssociations()}}updateStoredProfileAssociations(){const s={};for(const[c,g]of this.profilesObject.workspaces.entries())s[c.toString()]=g.id;const o={};for(const[c,g]of this.profilesObject.emptyWindows.entries())o[c.toString()]=g.id;this.saveStoredProfileAssociations({workspaces:s,emptyWindows:o}),this._profilesObject=void 0}migrateStoredProfileAssociations(s){const o={},c=this.createDefaultProfile();if(s.workspaces)for(const[T,N]of Object.entries(s.workspaces)){const A=k.URI.parse(N);o[T]=this.uriIdentityService.extUri.isEqual(A,c.location)?c.id:this.uriIdentityService.extUri.basename(A)}const g={};if(s.emptyWindows)for(const[T,N]of Object.entries(s.emptyWindows)){const A=k.URI.parse(N);g[T]=this.uriIdentityService.extUri.isEqual(A,c.location)?c.id:this.uriIdentityService.extUri.basename(A)}return{workspaces:o,emptyWindows:g}}getStoredProfiles(){return[]}saveStoredProfiles(s){throw new Error("not implemented")}getStoredProfileAssociations(){return{}}saveStoredProfileAssociations(s){throw new Error("not implemented")}getDefaultProfileExtensionsLocation(){}};e.UserDataProfilesService=r,e.UserDataProfilesService=r=Pe([oe(0,p.IEnvironmentService),oe(1,u.IFileService),oe(2,v.IUriIdentityService),oe(3,h.ILogService)],r);class n extends r{constructor(){super(...arguments),this.storedProfiles=[],this.storedProfileAssociations={}}getStoredProfiles(){return this.storedProfiles}saveStoredProfiles(s){this.storedProfiles=s}getStoredProfileAssociations(){return this.storedProfileAssociations}saveStoredProfileAssociations(s){this.storedProfileAssociations=s}}e.InMemoryUserDataProfilesService=n}),define(ce[53],de([0,1,19,8,21,7,5,2,25,11,3,12,4,20,26,22,44,6,33,18,23,24]),function(J,e,b,C,S,R,k,D,p,u,f,h,m,a,v,I,w,y,d,O,E,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionTask=e.AbstractExtensionManagementService=void 0,e.toExtensionManagementError=r,m=we(m);let l=class extends D.Disposable{get onInstallExtension(){return this._onInstallExtension.event}get onDidInstallExtensions(){return this._onDidInstallExtensions.event}get onUninstallExtension(){return this._onUninstallExtension.event}get onDidUninstallExtension(){return this._onDidUninstallExtension.event}get onDidUpdateExtensionMetadata(){return this._onDidUpdateExtensionMetadata.event}constructor(o,c,g,T,N,A){super(),this.galleryService=o,this.telemetryService=c,this.uriIdentityService=g,this.logService=T,this.productService=N,this.userDataProfilesService=A,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new k.Emitter),this._onDidInstallExtensions=this._register(new k.Emitter),this._onUninstallExtension=this._register(new k.Emitter),this._onDidUninstallExtension=this._register(new k.Emitter),this._onDidUpdateExtensionMetadata=this._register(new k.Emitter),this.participants=[],this._register((0,D.toDisposable)(()=>{this.installingExtensions.forEach(({task:L})=>L.cancel()),this.uninstallingExtensions.forEach(L=>L.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async canInstall(o){const c=await this.getTargetPlatform();return o.allTargetPlatforms.some(g=>(0,a.isTargetPlatformCompatible)(g,o.allTargetPlatforms,c))}async installFromGallery(o,c={}){try{const T=(await this.installGalleryExtensions([{extension:o,options:c}])).find(({identifier:N})=>(0,v.areSameExtensions)(N,o.identifier));if(T?.local)return T?.local;throw T?.error?T.error:new a.ExtensionManagementError(`Unknown error while installing extension ${o.identifier.id}`,a.ExtensionManagementErrorCode.Unknown)}catch(g){throw r(g)}}async installGalleryExtensions(o){if(!this.galleryService.isEnabled())throw new a.ExtensionManagementError(m.localize(1767,null),a.ExtensionManagementErrorCode.NotAllowed);const c=[],g=[];return await Promise.allSettled(o.map(async({extension:T,options:N})=>{try{const A=await this.checkAndGetCompatibleVersion(T,!!N?.installGivenVersion,!!N?.installPreReleaseVersion,N.productVersion??{version:this.productService.version,date:this.productService.date});g.push({...A,options:N})}catch(A){c.push({identifier:T.identifier,operation:a.InstallOperation.Install,source:T,error:A,profileLocation:N.profileLocation??this.getCurrentExtensionsManifestLocation()})}})),g.length&&c.push(...await this.installExtensions(g)),c}async uninstall(o,c){return this.logService.trace("ExtensionManagementService#uninstall",o.identifier.id),this.uninstallExtensions([{extension:o,options:c}])}async toggleAppliationScope(o,c){if((0,I.isApplicationScopedExtension)(o.manifest)||o.isBuiltin)return o;if(o.isApplicationScoped){let g=await this.updateMetadata(o,{isApplicationScoped:!1},this.userDataProfilesService.defaultProfile.extensionsResource);this.uriIdentityService.extUri.isEqual(c,this.userDataProfilesService.defaultProfile.extensionsResource)||(g=await this.copyExtension(o,this.userDataProfilesService.defaultProfile.extensionsResource,c));for(const T of this.userDataProfilesService.profiles){const N=(await this.getInstalled(I.ExtensionType.User,T.extensionsResource)).find(A=>(0,v.areSameExtensions)(A.identifier,o.identifier));N?this._onDidUpdateExtensionMetadata.fire({local:N,profileLocation:T.extensionsResource}):this._onDidUninstallExtension.fire({identifier:o.identifier,profileLocation:T.extensionsResource})}return g}else{const g=this.uriIdentityService.extUri.isEqual(c,this.userDataProfilesService.defaultProfile.extensionsResource)?await this.updateMetadata(o,{isApplicationScoped:!0},this.userDataProfilesService.defaultProfile.extensionsResource):await this.copyExtension(o,c,this.userDataProfilesService.defaultProfile.extensionsResource,{isApplicationScoped:!0});return this._onDidInstallExtensions.fire([{identifier:g.identifier,operation:a.InstallOperation.Install,local:g,profileLocation:this.userDataProfilesService.defaultProfile.extensionsResource,applicationScoped:!0}]),g}}getExtensionsControlManifest(){const o=new Date().getTime();return(!this.extensionsControlManifest||o-this.lastReportTimestamp>1e3*60*5)&&(this.extensionsControlManifest=this.updateControlCache(),this.lastReportTimestamp=o),this.extensionsControlManifest}registerParticipant(o){this.participants.push(o)}async resetPinnedStateForAllUserExtensions(o){try{await this.joinAllSettled(this.userDataProfilesService.profiles.map(async c=>{const g=await this.getInstalled(I.ExtensionType.User,c.extensionsResource);await this.joinAllSettled(g.map(async T=>{T.pinned!==o&&await this.updateMetadata(T,{pinned:o},c.extensionsResource)}))}))}catch(c){throw this.logService.error("Error while resetting pinned state for all user extensions",(0,R.getErrorMessage)(c)),c}}async installExtensions(o){const c=new Map,g=new Map,T=[],N=(L,M)=>`${v.ExtensionKey.create(L).toString()}-${M.toString()}`,A=(L,M,B,Q)=>{const re=this.createInstallExtensionTask(L,M,B),ae=`${(0,v.getGalleryExtensionId)(L.publisher,L.name)}-${B.profileLocation.toString()}`;g.set(ae,{task:re,root:Q}),this._onInstallExtension.fire({identifier:re.identifier,source:M,profileLocation:B.profileLocation}),this.logService.info("Installing extension:",re.identifier.id,B),h.URI.isUri(M)||this.installingExtensions.set(N(M,B.profileLocation),{task:re,waitingTasks:[]})};try{for(const{manifest:L,extension:M,options:B}of o){const Q=B.isApplicationScoped||B.isBuiltin||(0,I.isApplicationScopedExtension)(L),re={...B,installOnlyNewlyAddedFromExtensionPack:B.installOnlyNewlyAddedFromExtensionPack??!h.URI.isUri(M),isApplicationScoped:Q,profileLocation:Q?this.userDataProfilesService.defaultProfile.extensionsResource:B.profileLocation??this.getCurrentExtensionsManifestLocation(),productVersion:B.productVersion??{version:this.productService.version,date:this.productService.date}},ae=h.URI.isUri(M)?void 0:this.installingExtensions.get(N(M,re.profileLocation));ae?(this.logService.info("Extension is already requested to install",ae.task.identifier.id,re.profileLocation.toString()),T.push(ae.task.waitUntilTaskIsFinished())):A(L,M,re,void 0)}return await Promise.all([...g.values()].map(async({task:L})=>{if(L.options.donotIncludePackAndDependencies)this.logService.info("Installing the extension without checking dependencies and pack",L.identifier.id);else try{const M=await this.getAllDepsAndPackExtensions(L.identifier,L.manifest,!!L.options.installOnlyNewlyAddedFromExtensionPack,!!L.options.installPreReleaseVersion,L.options.profileLocation,L.options.productVersion),B=await this.getInstalled(void 0,L.options.profileLocation,L.options.productVersion),Q={...L.options,context:{...L.options.context,[a.EXTENSION_INSTALL_DEP_PACK_CONTEXT]:!0}};for(const{gallery:re,manifest:ae}of(0,b.distinct)(M,({gallery:ue})=>ue.identifier.id)){if(g.has(`${re.identifier.id.toLowerCase()}-${Q.profileLocation.toString()}`))continue;const ue=this.installingExtensions.get(N(re,Q.profileLocation));if(ue){if(this.canWaitForTask(L,ue.task)){const pe=ue.task.identifier;this.logService.info("Waiting for already requested installing extension",pe.id,L.identifier.id,Q.profileLocation.toString()),ue.waitingTasks.push(L),T.push(k.Event.toPromise(k.Event.filter(this.onDidInstallExtensions,$=>$.some(Z=>(0,v.areSameExtensions)(Z.identifier,pe)))).then($=>{if(this.logService.info("Finished waiting for already requested installing extension",pe.id,L.identifier.id,Q.profileLocation.toString()),!$.find(_=>(0,v.areSameExtensions)(_.identifier,pe))?.local)throw new Error(`Extension ${pe.id} is not installed`)}))}}else B.some(({identifier:pe})=>(0,v.areSameExtensions)(pe,re.identifier))||A(ae,re,Q,L)}}catch(M){if(h.URI.isUri(L.source))(0,b.isNonEmptyArray)(L.manifest.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",L.identifier.id,M.message),(0,b.isNonEmptyArray)(L.manifest.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",L.identifier.id,M.message);else throw this.logService.error("Error while preparing to install dependencies and extension packs of the extension:",L.identifier.id),M}})),await this.joinAllSettled([...g.entries()].map(async([L,{task:M}])=>{const B=new Date().getTime();let Q;try{Q=await M.run(),await this.joinAllSettled(this.participants.map(re=>re.postInstall(Q,M.source,M.options,S.CancellationToken.None)),a.ExtensionManagementErrorCode.PostInstall)}catch(re){const ae=r(re);throw h.URI.isUri(M.source)||n(this.telemetryService,M.operation===a.InstallOperation.Update?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,v.getGalleryExtensionTelemetryData)(M.source),error:ae,source:M.options.context?.[a.EXTENSION_INSTALL_SOURCE_CONTEXT]}),c.set(L,{error:ae,identifier:M.identifier,operation:M.operation,source:M.source,context:M.options.context,profileLocation:M.options.profileLocation,applicationScoped:M.options.isApplicationScoped}),this.logService.error("Error while installing the extension",M.identifier.id,(0,R.getErrorMessage)(ae),M.options.profileLocation.toString()),ae}if(!h.URI.isUri(M.source)){const re=M.operation===a.InstallOperation.Update,ae=re?void 0:(new Date().getTime()-M.source.lastUpdated)/1e3;if(n(this.telemetryService,re?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,v.getGalleryExtensionTelemetryData)(M.source),verificationStatus:M.verificationStatus,duration:new Date().getTime()-B,durationSinceUpdate:ae,source:M.options.context?.[a.EXTENSION_INSTALL_SOURCE_CONTEXT]}),u.isWeb&&M.operation!==a.InstallOperation.Update)try{await this.galleryService.reportStatistic(Q.manifest.publisher,Q.manifest.name,Q.manifest.version,a.StatisticType.Install)}catch{}}c.set(L,{local:Q,identifier:M.identifier,operation:M.operation,source:M.source,context:M.options.context,profileLocation:M.options.profileLocation,applicationScoped:Q.isApplicationScoped})})),T.length&&await this.joinAllSettled(T),[...c.values()]}catch(L){const M=(re,ae,ue)=>{const pe=[];re.manifest.extensionDependencies?.length&&pe.push(...re.manifest.extensionDependencies),re.manifest.extensionPack?.length&&pe.push(...re.manifest.extensionPack);for(const $ of pe){if(ue.includes($.toLowerCase()))continue;ue.push($.toLowerCase());const Z=c.get(`${$.toLowerCase()}-${ae.toString()}`);Z?.local&&(ue=M(Z.local,ae,ue))}return ue},B=re=>({identifier:re.identifier,operation:a.InstallOperation.Install,source:re.source,context:re.options.context,profileLocation:re.options.profileLocation,error:L}),Q=[];for(const[re,{task:ae,root:ue}]of g){const pe=c.get(re);pe?pe.local&&ue&&!c.get(`${ue.identifier.id.toLowerCase()}-${ae.options.profileLocation.toString()}`)?.local&&(Q.push(this.createUninstallExtensionTask(pe.local,{versionOnly:!0,profileLocation:ae.options.profileLocation})),c.set(re,B(ae))):(ae.cancel(),c.set(re,B(ae)))}for(const[re,{task:ae}]of g){const ue=c.get(re);if(!ue?.local||ae.options.donotIncludePackAndDependencies)continue;M(ue.local,ae.options.profileLocation,[ue.local.identifier.id.toLowerCase()]).slice(1).some($=>g.has(`${$.toLowerCase()}-${ae.options.profileLocation.toString()}`)&&!c.get(`${$.toLowerCase()}-${ae.options.profileLocation.toString()}`)?.local)&&(Q.push(this.createUninstallExtensionTask(ue.local,{versionOnly:!0,profileLocation:ae.options.profileLocation})),c.set(re,B(ae)))}throw Q.length&&await Promise.allSettled(Q.map(async re=>{try{await re.run(),this.logService.info("Rollback: Uninstalled extension",re.extension.identifier.id)}catch(ae){this.logService.warn("Rollback: Error while uninstalling extension",re.extension.identifier.id,(0,R.getErrorMessage)(ae))}})),L}finally{for(const{task:L}of g.values())L.source&&!h.URI.isUri(L.source)&&this.installingExtensions.delete(N(L.source,L.options.profileLocation));if(c.size){const L=[...c.values()];for(const M of L)M.local&&this.logService.info("Extension installed successfully:",M.identifier.id,M.profileLocation.toString());this._onDidInstallExtensions.fire(L)}}}canWaitForTask(o,c){for(const[,{task:g,waitingTasks:T}]of this.installingExtensions.entries())if(g===o&&(T.includes(c)||T.some(N=>this.canWaitForTask(N,c)))||g===c&&T[0]&&!this.canWaitForTask(o,T[0]))return!1;return!0}async joinAllSettled(o,c){const g=[],T=[],N=await Promise.allSettled(o);for(const L of N)L.status==="fulfilled"?g.push(L.value):T.push(r(L.reason,c));if(!T.length)return g;if(T.length===1)throw T[0];let A=new a.ExtensionManagementError("",a.ExtensionManagementErrorCode.Unknown);for(const L of T)A=new a.ExtensionManagementError(A.message?`${A.message}, ${L.message}`:L.message,L.code!==a.ExtensionManagementErrorCode.Unknown&&L.code!==a.ExtensionManagementErrorCode.Internal?L.code:A.code);throw A}async getAllDepsAndPackExtensions(o,c,g,T,N,A){if(!this.galleryService.isEnabled())return[];const L=await this.getInstalled(void 0,N,A),M=[],B=[],Q=async(re,ae)=>{M.push(re);const ue=ae.extensionDependencies||[],pe=[...ue];if(ae.extensionPack){const $=g?L.find(Z=>(0,v.areSameExtensions)(Z.identifier,re)):void 0;for(const Z of ae.extensionPack)$&&$.manifest.extensionPack&&$.manifest.extensionPack.some(_=>(0,v.areSameExtensions)({id:_},{id:Z}))||pe.every(_=>!(0,v.areSameExtensions)({id:_},{id:Z}))&&pe.push(Z)}if(pe.length){const $=pe.filter(Z=>M.every(_=>!(0,v.areSameExtensions)(_,{id:Z})));if($.length){const Z=await this.galleryService.getExtensions($.map(_=>({id:_,preRelease:T})),S.CancellationToken.None);for(const _ of Z){if(M.find(K=>(0,v.areSameExtensions)(K,_.identifier)))continue;const W=ue.some(K=>(0,v.areSameExtensions)({id:K},_.identifier));let q;try{q=await this.checkAndGetCompatibleVersion(_,!1,T,A)}catch(K){if(W)throw K;this.logService.info("Skipping the packed extension as it cannot be installed",_.identifier.id,(0,R.getErrorMessage)(K));continue}B.push({gallery:q.extension,manifest:q.manifest}),await Q(q.extension.identifier,q.manifest)}}}};return await Q(o,c),B}async checkAndGetCompatibleVersion(o,c,g,T){let N;const A=await this.getExtensionsControlManifest();if(A.malicious.some(B=>(0,v.areSameExtensions)(o.identifier,B)))throw new a.ExtensionManagementError(m.localize(1768,null,o.identifier.id),a.ExtensionManagementErrorCode.Malicious);const L=A.deprecated[o.identifier.id.toLowerCase()];if(L?.extension?.autoMigrate){if(this.logService.info(`The '${o.identifier.id}' extension is deprecated, fetching the compatible '${L.extension.id}' extension instead.`),N=(await this.galleryService.getExtensions([{id:L.extension.id,preRelease:L.extension.preRelease}],{targetPlatform:await this.getTargetPlatform(),compatible:!0,productVersion:T},S.CancellationToken.None))[0],!N)throw new a.ExtensionManagementError(m.localize(1769,null,o.identifier.id,L.extension.id),a.ExtensionManagementErrorCode.Deprecated)}else{if(!await this.canInstall(o)){const B=await this.getTargetPlatform();throw new a.ExtensionManagementError(m.localize(1770,null,o.identifier.id,this.productService.nameLong,(0,a.TargetPlatformToString)(B)),a.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}if(N=await this.getCompatibleVersion(o,c,g,T),!N){const B=[];throw(0,w.areApiProposalsCompatible)(o.properties.enabledApiProposals??[],B)?!g&&o.properties.isPreReleaseVersion&&(await this.galleryService.getExtensions([o.identifier],S.CancellationToken.None))[0]?new a.ExtensionManagementError(m.localize(1772,null,o.displayName??o.identifier.id),a.ExtensionManagementErrorCode.ReleaseVersionNotFound):new a.ExtensionManagementError(m.localize(1773,null,o.identifier.id,this.productService.nameLong,this.productService.version),a.ExtensionManagementErrorCode.Incompatible):new a.ExtensionManagementError(m.localize(1771,null,o.displayName??o.identifier.id,B[0]),a.ExtensionManagementErrorCode.IncompatibleApi)}}this.logService.info("Getting Manifest...",N.identifier.id);const M=await this.galleryService.getManifest(N,S.CancellationToken.None);if(M===null)throw new a.ExtensionManagementError(`Missing manifest for extension ${N.identifier.id}`,a.ExtensionManagementErrorCode.Invalid);if(M.version!==N.version)throw new a.ExtensionManagementError(`Cannot install '${N.identifier.id}' extension because of version mismatch in Marketplace`,a.ExtensionManagementErrorCode.Invalid);return{extension:N,manifest:M}}async getCompatibleVersion(o,c,g,T){const N=await this.getTargetPlatform();let A=null;return!c&&o.hasPreReleaseVersion&&o.properties.isPreReleaseVersion!==g&&(A=(await this.galleryService.getExtensions([{...o.identifier,preRelease:g}],{targetPlatform:N,compatible:!0,productVersion:T},S.CancellationToken.None))[0]||null),!A&&await this.galleryService.isExtensionCompatible(o,g,N,T)&&(A=o),A||(c?A=(await this.galleryService.getExtensions([{...o.identifier,version:o.version}],{targetPlatform:N,compatible:!0,productVersion:T},S.CancellationToken.None))[0]||null:A=await this.galleryService.getCompatibleExtension(o,g,N,T)),A}async uninstallExtensions(o){const c=(B,Q)=>`${B.identifier.id.toLowerCase()}${Q.versionOnly?`-${B.manifest.version}`:""}@${Q.profileLocation.toString()}`,g=(B,Q)=>{const re=this.createUninstallExtensionTask(B,Q);return this.uninstallingExtensions.set(c(re.extension,Q),re),this.logService.info("Uninstalling extension from the profile:",`${B.identifier.id}@${B.manifest.version}`,Q.profileLocation.toString()),this._onUninstallExtension.fire({identifier:B.identifier,profileLocation:Q.profileLocation,applicationScoped:B.isApplicationScoped}),re},T=(B,Q,re)=>{re?this.logService.error("Failed to uninstall extension from the profile:",`${B.identifier.id}@${B.manifest.version}`,Q.profileLocation.toString(),re.message):this.logService.info("Successfully uninstalled extension from the profile",`${B.identifier.id}@${B.manifest.version}`,Q.profileLocation.toString()),n(this.telemetryService,"extensionGallery:uninstall",{extensionData:(0,v.getLocalExtensionTelemetryData)(B),error:re}),this._onDidUninstallExtension.fire({identifier:B.identifier,error:re?.code,profileLocation:Q.profileLocation,applicationScoped:B.isApplicationScoped})},N=[],A=[],L=[],M=new p.ResourceMap;for(const{extension:B,options:Q}of o){const re={...Q,profileLocation:B.isApplicationScoped?this.userDataProfilesService.defaultProfile.extensionsResource:Q?.profileLocation??this.getCurrentExtensionsManifestLocation()},ae=this.uninstallingExtensions.get(c(B,re));ae?(this.logService.info("Extensions is already requested to uninstall",B.identifier.id),L.push(ae.waitUntilTaskIsFinished())):N.push(g(B,re))}try{for(const B of N.slice(0)){let Q=M.get(B.options.profileLocation);if(Q||M.set(B.options.profileLocation,Q=await this.getInstalled(I.ExtensionType.User,B.options.profileLocation)),B.options.donotIncludePack)this.logService.info("Uninstalling the extension without including packed extension",`${B.extension.identifier.id}@${B.extension.manifest.version}`);else{const re=this.getAllPackExtensionsToUninstall(B.extension,Q);for(const ae of re)this.uninstallingExtensions.has(c(ae,B.options))?this.logService.info("Extensions is already requested to uninstall",ae.identifier.id):N.push(g(ae,B.options))}B.options.donotCheckDependents?this.logService.info("Uninstalling the extension without checking dependents",`${B.extension.identifier.id}@${B.extension.manifest.version}`):this.checkForDependents(N.map(re=>re.extension),Q,B.extension)}await this.joinAllSettled(N.map(async B=>{try{if(await B.run(),await this.joinAllSettled(this.participants.map(Q=>Q.postUninstall(B.extension,B.options,S.CancellationToken.None))),B.extension.identifier.uuid)try{await this.galleryService.reportStatistic(B.extension.manifest.publisher,B.extension.manifest.name,B.extension.manifest.version,a.StatisticType.Uninstall)}catch{}}catch(Q){const re=r(Q);throw T(B.extension,B.options,re),re}finally{A.push(B)}})),L.length&&await this.joinAllSettled(L);for(const B of N)T(B.extension,B.options)}catch(B){const Q=r(B);for(const re of N){try{re.cancel()}catch{}A.includes(re)||T(re.extension,re.options,Q)}throw Q}finally{for(const B of N)this.uninstallingExtensions.delete(c(B.extension,B.options))||this.logService.warn("Uninstallation task is not found in the cache",B.extension.identifier.id)}}checkForDependents(o,c,g){for(const T of o){const N=this.getDependents(T,c);if(N.length){const A=N.filter(L=>!o.some(M=>(0,v.areSameExtensions)(M.identifier,L.identifier)));if(A.length)throw new Error(this.getDependentsErrorMessage(T,A,g))}}}getDependentsErrorMessage(o,c,g){return g===o?c.length===1?m.localize(1774,null,g.manifest.displayName||g.manifest.name,c[0].manifest.displayName||c[0].manifest.name):c.length===2?m.localize(1775,null,g.manifest.displayName||g.manifest.name,c[0].manifest.displayName||c[0].manifest.name,c[1].manifest.displayName||c[1].manifest.name):m.localize(1776,null,g.manifest.displayName||g.manifest.name,c[0].manifest.displayName||c[0].manifest.name,c[1].manifest.displayName||c[1].manifest.name):c.length===1?m.localize(1777,null,g.manifest.displayName||g.manifest.name,o.manifest.displayName||o.manifest.name,c[0].manifest.displayName||c[0].manifest.name):c.length===2?m.localize(1778,null,g.manifest.displayName||g.manifest.name,o.manifest.displayName||o.manifest.name,c[0].manifest.displayName||c[0].manifest.name,c[1].manifest.displayName||c[1].manifest.name):m.localize(1779,null,g.manifest.displayName||g.manifest.name,o.manifest.displayName||o.manifest.name,c[0].manifest.displayName||c[0].manifest.name,c[1].manifest.displayName||c[1].manifest.name)}getAllPackExtensionsToUninstall(o,c,g=[]){if(g.indexOf(o)!==-1)return[];g.push(o);const T=o.manifest.extensionPack?o.manifest.extensionPack:[];if(T.length){const N=c.filter(L=>!L.isBuiltin&&T.some(M=>(0,v.areSameExtensions)({id:M},L.identifier))),A=[];for(const L of N)A.push(...this.getAllPackExtensionsToUninstall(L,c,g));return[...N,...A]}return[]}getDependents(o,c){return c.filter(g=>g.manifest.extensionDependencies&&g.manifest.extensionDependencies.some(T=>(0,v.areSameExtensions)({id:T},o.identifier)))}async updateControlCache(){try{return this.logService.trace("ExtensionManagementService.updateControlCache"),await this.galleryService.getExtensionsControlManifest()}catch(o){return this.logService.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest",(0,R.getErrorMessage)(o)),{malicious:[],deprecated:{},search:[]}}}};e.AbstractExtensionManagementService=l,e.AbstractExtensionManagementService=l=Pe([oe(0,a.IExtensionGalleryService),oe(1,O.ITelemetryService),oe(2,E.IUriIdentityService),oe(3,y.ILogService),oe(4,d.IProductService),oe(5,i.IUserDataProfilesService)],l);function r(s,o){if(s instanceof a.ExtensionManagementError)return s;let c;return s instanceof a.ExtensionGalleryError?c=new a.ExtensionManagementError(s.message,s.code===a.ExtensionGalleryErrorCode.DownloadFailedWriting?a.ExtensionManagementErrorCode.DownloadFailedWriting:a.ExtensionManagementErrorCode.Gallery):c=new a.ExtensionManagementError(s.message,(0,R.isCancellationError)(s)?a.ExtensionManagementErrorCode.Cancelled:o??a.ExtensionManagementErrorCode.Internal),c.stack=s.stack,c}function n(s,o,{extensionData:c,verificationStatus:g,duration:T,error:N,source:A,durationSinceUpdate:L}){let M,B;(0,f.isDefined)(g)&&(g===!0?g="Verified":(g===!1||(M=a.ExtensionManagementErrorCode.Signature,B=g),g="Unverified")),N&&(M=N.code,N.code===a.ExtensionManagementErrorCode.Signature&&(B=N.message)),s.publicLog(o,{...c,verificationStatus:g,success:!N,duration:T,errorcode:M,errorcodeDetail:B,durationSinceUpdate:L,source:A})}class t{constructor(){this.barrier=new C.Barrier}async waitUntilTaskIsFinished(){return await this.barrier.wait(),this.cancellablePromise}run(){return this.cancellablePromise||(this.cancellablePromise=(0,C.createCancelablePromise)(o=>this.doRun(o))),this.barrier.open(),this.cancellablePromise}cancel(){this.cancellablePromise||(this.cancellablePromise=(0,C.createCancelablePromise)(o=>new Promise((c,g)=>{const T=o.onCancellationRequested(()=>{T.dispose(),g(new R.CancellationError)})})),this.barrier.open()),this.cancellablePromise.cancel()}}e.AbstractExtensionTask=t}),define(ce[42],de([0,1,8,13,2,5,25,12,20,26,9,10,6,24,23,3,7,18]),function(J,e,b,C,S,R,k,D,p,u,f,h,m,a,v,I,w,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsProfileScannerService=e.IExtensionsProfileScannerService=e.ExtensionsProfileScanningError=e.ExtensionsProfileScanningErrorCode=void 0;var d;(function(r){r.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",r.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(d||(e.ExtensionsProfileScanningErrorCode=d={}));class O extends Error{constructor(n,t){super(n),this.code=t}}e.ExtensionsProfileScanningError=O,e.IExtensionsProfileScannerService=(0,h.createDecorator)("IExtensionsProfileScannerService");let E=class extends S.Disposable{constructor(n,t,s,o,c,g){super(),this.extensionsLocation=n,this.fileService=t,this.userDataProfilesService=s,this.uriIdentityService=o,this.telemetryService=c,this.logService=g,this._onAddExtensions=this._register(new R.Emitter),this.onAddExtensions=this._onAddExtensions.event,this._onDidAddExtensions=this._register(new R.Emitter),this.onDidAddExtensions=this._onDidAddExtensions.event,this._onRemoveExtensions=this._register(new R.Emitter),this.onRemoveExtensions=this._onRemoveExtensions.event,this._onDidRemoveExtensions=this._register(new R.Emitter),this.onDidRemoveExtensions=this._onDidRemoveExtensions.event,this.resourcesAccessQueueMap=new k.ResourceMap}scanProfileExtensions(n,t){return this.withProfileExtensions(n,void 0,t)}async addExtensionsToProfile(n,t,s){const o=[],c=[];try{return await this.withProfileExtensions(t,g=>{const T=[];if(s)T.push(...g);else for(const N of g)n.some(([A])=>(0,u.areSameExtensions)(A.identifier,N.identifier)&&A.manifest.version!==N.version)?o.push(N):T.push(N);for(const[N,A]of n){const L=T.findIndex(B=>(0,u.areSameExtensions)(B.identifier,N.identifier)&&B.version===N.manifest.version),M={identifier:N.identifier,version:N.manifest.version,location:N.location,metadata:A};L===-1?(c.push(M),T.push(M)):T.splice(L,1,M)}return c.length&&this._onAddExtensions.fire({extensions:c,profileLocation:t}),o.length&&this._onRemoveExtensions.fire({extensions:o,profileLocation:t}),T}),c.length&&this._onDidAddExtensions.fire({extensions:c,profileLocation:t}),o.length&&this._onDidRemoveExtensions.fire({extensions:o,profileLocation:t}),c}catch(g){throw c.length&&this._onDidAddExtensions.fire({extensions:c,error:g,profileLocation:t}),o.length&&this._onDidRemoveExtensions.fire({extensions:o,error:g,profileLocation:t}),g}}async updateMetadata(n,t){const s=[];return await this.withProfileExtensions(t,o=>{const c=[];for(const g of o){const T=n.find(([N])=>(0,u.areSameExtensions)(N.identifier,g.identifier)&&N.manifest.version===g.version);T&&(g.metadata={...g.metadata,...T[1]},s.push(g)),c.push(g)}return c}),s}async removeExtensionFromProfile(n,t){const s=[];try{await this.withProfileExtensions(t,o=>{const c=[];for(const g of o)(0,u.areSameExtensions)(g.identifier,n.identifier)?s.push(g):c.push(g);return s.length&&this._onRemoveExtensions.fire({extensions:s,profileLocation:t}),c}),s.length&&this._onDidRemoveExtensions.fire({extensions:s,profileLocation:t})}catch(o){throw s.length&&this._onDidRemoveExtensions.fire({extensions:s,error:o,profileLocation:t}),o}}async withProfileExtensions(n,t,s){return this.getResourceAccessQueue(n).queue(async()=>{let o=[],c;try{const g=await this.fileService.readFile(n);c=JSON.parse(g.value.toString().trim()||"[]")}catch(g){if((0,f.toFileOperationResult)(g)!==f.FileOperationResult.FILE_NOT_FOUND)throw g;if(this.uriIdentityService.extUri.isEqual(n,this.userDataProfilesService.defaultProfile.extensionsResource)&&(c=await this.migrateFromOldDefaultProfileExtensionsLocation()),!c&&s?.bailOutWhenFileNotFound)throw new O((0,w.getErrorMessage)(g),d.ERROR_PROFILE_NOT_FOUND)}if(c){Array.isArray(c)||this.reportAndThrowInvalidConentError(n);let g=!1;for(const T of c){i(T)||this.reportAndThrowInvalidConentError(n);let N;if((0,I.isString)(T.relativeLocation)&&T.relativeLocation)N=this.resolveExtensionLocation(T.relativeLocation);else if((0,I.isString)(T.location)){this.logService.warn(`Extensions profile: Ignoring extension with invalid location: ${T.location}`);continue}else{N=D.URI.revive(T.location);const A=this.toRelativePath(N);A&&(g=!0,T.relativeLocation=A)}(0,I.isUndefined)(T.metadata?.hasPreReleaseVersion)&&T.metadata?.preRelease&&(g=!0,T.metadata.hasPreReleaseVersion=!0),o.push({identifier:T.identifier,location:N,version:T.version,metadata:T.metadata})}g&&await this.fileService.writeFile(n,C.VSBuffer.fromString(JSON.stringify(c)))}if(t){o=t(o);const g=o.map(T=>({identifier:T.identifier,version:T.version,location:T.location.toJSON(),relativeLocation:this.toRelativePath(T.location),metadata:T.metadata}));await this.fileService.writeFile(n,C.VSBuffer.fromString(JSON.stringify(g)))}return o})}reportAndThrowInvalidConentError(n){const t=new O(`Invalid extensions content in ${n.toString()}`,d.ERROR_INVALID_CONTENT);throw this.telemetryService.publicLogError2("extensionsProfileScanningError",{code:t.code}),t}toRelativePath(n){return this.uriIdentityService.extUri.isEqual(this.uriIdentityService.extUri.dirname(n),this.extensionsLocation)?this.uriIdentityService.extUri.basename(n):void 0}resolveExtensionLocation(n){return this.uriIdentityService.extUri.joinPath(this.extensionsLocation,n)}async migrateFromOldDefaultProfileExtensionsLocation(){return this._migrationPromise||(this._migrationPromise=(async()=>{const n=this.uriIdentityService.extUri.joinPath(this.userDataProfilesService.defaultProfile.location,"extensions.json"),t=this.uriIdentityService.extUri.joinPath(this.extensionsLocation,".init-default-profile-extensions");let s;try{s=(await this.fileService.readFile(n)).value.toString()}catch(c){if((0,f.toFileOperationResult)(c)===f.FileOperationResult.FILE_NOT_FOUND)return;throw c}this.logService.info("Migrating extensions from old default profile location",n.toString());let o;try{const c=JSON.parse(s);Array.isArray(c)&&c.every(g=>i(g))?o=c:this.logService.warn("Skipping migrating from old default profile locaiton: Found invalid data",c)}catch(c){this.logService.error(c)}if(o)try{await this.fileService.createFile(this.userDataProfilesService.defaultProfile.extensionsResource,C.VSBuffer.fromString(JSON.stringify(o)),{overwrite:!1}),this.logService.info("Migrated extensions from old default profile location to new location",n.toString(),this.userDataProfilesService.defaultProfile.extensionsResource.toString())}catch(c){if((0,f.toFileOperationResult)(c)===f.FileOperationResult.FILE_MODIFIED_SINCE)this.logService.info("Migration from old default profile location to new location is done by another window",n.toString(),this.userDataProfilesService.defaultProfile.extensionsResource.toString());else throw c}try{await this.fileService.del(n)}catch(c){(0,f.toFileOperationResult)(c)!==f.FileOperationResult.FILE_NOT_FOUND&&this.logService.error(c)}try{await this.fileService.del(t)}catch(c){(0,f.toFileOperationResult)(c)!==f.FileOperationResult.FILE_NOT_FOUND&&this.logService.error(c)}return o})()),this._migrationPromise}getResourceAccessQueue(n){let t=this.resourcesAccessQueueMap.get(n);return t||(t=new b.Queue,this.resourcesAccessQueueMap.set(n,t)),t}};e.AbstractExtensionsProfileScannerService=E,e.AbstractExtensionsProfileScannerService=E=Pe([oe(1,f.IFileService),oe(2,a.IUserDataProfilesService),oe(3,v.IUriIdentityService),oe(4,y.ITelemetryService),oe(5,m.ILogService)],E);function i(r){return(0,I.isObject)(r)&&(0,p.isIExtensionIdentifier)(r.identifier)&&(l(r.location)||(0,I.isString)(r.location)&&r.location)&&((0,I.isUndefined)(r.relativeLocation)||(0,I.isString)(r.relativeLocation))&&r.version&&(0,I.isString)(r.version)}function l(r){return r?(0,I.isString)(r.path)&&(0,I.isString)(r.scheme):!1}});var Ve=this&&this.__importDefault||function(J){return J&&J.__esModule?J:{default:J}};define(ce[54],de([0,1,19,8,27,13,7,34,85,2,14,15,11,16,45,56,3,12,4,17,26,22,44,9,10,6,33,5,48,42,24,23,97]),function(J,e,b,C,S,R,k,D,p,u,f,h,m,a,v,I,w,y,d,O,E,i,l,r,n,t,s,o,c,g,T,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtensionsScannerService=e.ExtensionScannerInput=e.AbstractExtensionsScannerService=e.IExtensionsScannerService=e.Translations=void 0,e.toExtensionDescription=ae,S=we(S),h=we(h),m=we(m),v=we(v),I=Ve(I);var L;(function(pe){function $(Z,_){if(Z===_)return!0;const W=Object.keys(Z),q=new Set;for(const K of Object.keys(_))q.add(K);if(W.length!==q.size)return!1;for(const K of W){if(Z[K]!==_[K])return!1;q.delete(K)}return q.size===0}pe.equals=$})(L||(e.Translations=L={})),e.IExtensionsScannerService=(0,n.createDecorator)("IExtensionsScannerService");let M=class extends u.Disposable{constructor($,Z,_,W,q,K,ie,ne,F,j,V,P){super(),this.systemExtensionsLocation=$,this.userExtensionsLocation=Z,this.extensionsControlLocation=_,this.currentProfile=W,this.userDataProfilesService=q,this.extensionsProfileScannerService=K,this.fileService=ie,this.logService=ne,this.environmentService=F,this.productService=j,this.uriIdentityService=V,this.instantiationService=P,this._onDidChangeCache=this._register(new o.Emitter),this.onDidChangeCache=this._onDidChangeCache.event,this.obsoleteFile=(0,a.joinPath)(this.userExtensionsLocation,".obsolete"),this.systemExtensionsCachedScanner=this._register(this.instantiationService.createInstance(re,this.currentProfile,this.obsoleteFile)),this.userExtensionsCachedScanner=this._register(this.instantiationService.createInstance(re,this.currentProfile,this.obsoleteFile)),this.extensionsScanner=this._register(this.instantiationService.createInstance(Q,this.obsoleteFile)),this.initializeDefaultProfileExtensionsPromise=void 0,this._register(this.systemExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(i.ExtensionType.System))),this._register(this.userExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(i.ExtensionType.User)))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,E.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async scanAllExtensions($,Z,_){const[W,q]=await Promise.all([this.scanSystemExtensions($),this.scanUserExtensions(Z)]),K=_?await this.scanExtensionsUnderDevelopment($,[...W,...q]):[];return this.dedupExtensions(W,q,K,await this.getTargetPlatform(),!0)}async scanSystemExtensions($){const Z=[];Z.push(this.scanDefaultSystemExtensions(!!$.useCache,$.language)),Z.push(this.scanDevSystemExtensions($.language,!!$.checkControlFile));const[_,W]=await Promise.all(Z);return this.applyScanOptions([..._,...W],i.ExtensionType.System,$,!1)}async scanUserExtensions($){const Z=$.profileLocation??this.userExtensionsLocation;this.logService.trace("Started scanning user extensions",Z);const _=this.uriIdentityService.extUri.isEqual($.profileLocation,this.userDataProfilesService.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,W=await this.createExtensionScannerInput(Z,!!$.profileLocation,i.ExtensionType.User,!$.includeUninstalled,$.language,!0,_,$.productVersion??this.getProductVersion()),q=$.useCache&&!W.devMode&&W.excludeObsolete?this.userExtensionsCachedScanner:this.extensionsScanner;let K;try{K=await q.scanExtensions(W)}catch(ie){if(ie instanceof g.ExtensionsProfileScanningError&&ie.code===g.ExtensionsProfileScanningErrorCode.ERROR_PROFILE_NOT_FOUND)await this.doInitializeDefaultProfileExtensions(),K=await q.scanExtensions(W);else throw ie}return K=await this.applyScanOptions(K,i.ExtensionType.User,$,!0),this.logService.trace("Scanned user extensions:",K.length),K}async scanExtensionsUnderDevelopment($,Z){if(this.environmentService.isExtensionDevelopment&&this.environmentService.extensionDevelopmentLocationURI){const _=(await Promise.all(this.environmentService.extensionDevelopmentLocationURI.filter(W=>W.scheme===f.Schemas.file).map(async W=>{const q=await this.createExtensionScannerInput(W,!1,i.ExtensionType.User,!0,$.language,!1,void 0,$.productVersion??this.getProductVersion());return(await this.extensionsScanner.scanOneOrMultipleExtensions(q)).map(ie=>(ie.type=Z.find(ne=>(0,E.areSameExtensions)(ne.identifier,ie.identifier))?.type??ie.type,this.extensionsScanner.validate(ie,q)))}))).flat();return this.applyScanOptions(_,"development",$,!0)}return[]}async scanExistingExtension($,Z,_){const W=await this.createExtensionScannerInput($,!1,Z,!0,_.language,!0,void 0,_.productVersion??this.getProductVersion()),q=await this.extensionsScanner.scanExtension(W);return!q||!_.includeInvalid&&!q.isValid?null:q}async scanOneOrMultipleExtensions($,Z,_){const W=await this.createExtensionScannerInput($,!1,Z,!0,_.language,!0,void 0,_.productVersion??this.getProductVersion()),q=await this.extensionsScanner.scanOneOrMultipleExtensions(W);return this.applyScanOptions(q,Z,_,!0)}async scanMultipleExtensions($,Z,_){const W=[];return await Promise.all($.map(async q=>{const K=await this.scanOneOrMultipleExtensions(q,Z,_);W.push(...K)})),this.applyScanOptions(W,Z,_,!0)}async scanMetadata($){const Z=(0,a.joinPath)($,"package.json"),_=(await this.fileService.readFile(Z)).value.toString();return JSON.parse(_).__metadata}async updateMetadata($,Z){const _=(0,a.joinPath)($,"package.json"),W=(await this.fileService.readFile(_)).value.toString(),q=JSON.parse(W);Z.isMachineScoped===!1&&delete Z.isMachineScoped,Z.isBuiltin===!1&&delete Z.isBuiltin,q.__metadata={...q.__metadata,...Z},await this.fileService.writeFile((0,a.joinPath)($,"package.json"),R.VSBuffer.fromString(JSON.stringify(q,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.extensionsProfileScannerService.scanProfileExtensions(this.userDataProfilesService.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch($){if($ instanceof g.ExtensionsProfileScanningError&&$.code===g.ExtensionsProfileScanningErrorCode.ERROR_PROFILE_NOT_FOUND)await this.doInitializeDefaultProfileExtensions();else throw $}}async doInitializeDefaultProfileExtensions(){return this.initializeDefaultProfileExtensionsPromise||(this.initializeDefaultProfileExtensionsPromise=(async()=>{try{this.logService.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const $=await this.scanUserExtensions({includeInvalid:!0});if($.length)await this.extensionsProfileScannerService.addExtensionsToProfile($.map(Z=>[Z,Z.metadata]),this.userDataProfilesService.defaultProfile.extensionsResource);else try{await this.fileService.createFile(this.userDataProfilesService.defaultProfile.extensionsResource,R.VSBuffer.fromString(JSON.stringify([])))}catch(Z){(0,r.toFileOperationResult)(Z)!==r.FileOperationResult.FILE_NOT_FOUND&&this.logService.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,k.getErrorMessage)(Z))}this.logService.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch($){this.logService.error($)}finally{this.initializeDefaultProfileExtensionsPromise=void 0}})()),this.initializeDefaultProfileExtensionsPromise}async applyScanOptions($,Z,_,W){return _.includeAllVersions||($=this.dedupExtensions(Z===i.ExtensionType.System?$:void 0,Z===i.ExtensionType.User?$:void 0,Z==="development"?$:void 0,await this.getTargetPlatform(),W)),_.includeInvalid||($=$.filter(q=>q.isValid)),$.sort((q,K)=>{const ie=h.basename(q.location.fsPath),ne=h.basename(K.location.fsPath);return ie<ne?-1:ie>ne?1:0})}dedupExtensions($,Z,_,W,q){const K=(ne,F,j)=>{if(ne.isValid&&!F.isValid)return!1;if(ne.isValid===F.isValid){if(q&&v.gt(ne.manifest.version,F.manifest.version))return this.logService.debug(`Skipping extension ${F.location.path} with lower version ${F.manifest.version} in favour of ${ne.location.path} with version ${ne.manifest.version}`),!1;if(v.eq(ne.manifest.version,F.manifest.version)){if(ne.type===i.ExtensionType.System)return this.logService.debug(`Skipping extension ${F.location.path} in favour of system extension ${ne.location.path} with same version`),!1;if(ne.targetPlatform===W)return this.logService.debug(`Skipping extension ${F.location.path} from different target platform ${F.targetPlatform}`),!1}}return j?this.logService.warn(`Overwriting user extension ${ne.location.path} with ${F.location.path}.`):this.logService.debug(`Overwriting user extension ${ne.location.path} with ${F.location.path}.`),!0},ie=new i.ExtensionIdentifierMap;return $?.forEach(ne=>{const F=ie.get(ne.identifier.id);(!F||K(F,ne,!1))&&ie.set(ne.identifier.id,ne)}),Z?.forEach(ne=>{const F=ie.get(ne.identifier.id);if(!F&&$&&ne.type===i.ExtensionType.System){this.logService.debug(`Skipping obsolete system extension ${ne.location.path}.`);return}(!F||K(F,ne,!1))&&ie.set(ne.identifier.id,ne)}),_?.forEach(ne=>{const F=ie.get(ne.identifier.id);(!F||K(F,ne,!0))&&ie.set(ne.identifier.id,ne),ie.set(ne.identifier.id,ne)}),[...ie.values()]}async scanDefaultSystemExtensions($,Z){this.logService.trace("Started scanning system extensions");const _=await this.createExtensionScannerInput(this.systemExtensionsLocation,!1,i.ExtensionType.System,!0,Z,!0,void 0,this.getProductVersion()),q=await($&&!_.devMode?this.systemExtensionsCachedScanner:this.extensionsScanner).scanExtensions(_);return this.logService.trace("Scanned system extensions:",q.length),q}async scanDevSystemExtensions($,Z){const _=this.environmentService.isBuilt?[]:this.productService.builtInExtensions;if(!_?.length)return[];this.logService.trace("Started scanning dev system extensions");const W=Z?await this.getBuiltInExtensionControl():{},q=[],K=y.URI.file(h.normalize(h.join(f.FileAccess.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const ne of _){const F=W[ne.name]||"marketplace";switch(F){case"disabled":break;case"marketplace":q.push((0,a.joinPath)(K,ne.name));break;default:q.push(y.URI.file(F));break}}const ie=await Promise.all(q.map(async ne=>this.extensionsScanner.scanExtension(await this.createExtensionScannerInput(ne,!1,i.ExtensionType.System,!0,$,!0,void 0,this.getProductVersion()))));return this.logService.trace("Scanned dev system extensions:",ie.length),(0,b.coalesce)(ie)}async getBuiltInExtensionControl(){try{const $=await this.fileService.readFile(this.extensionsControlLocation);return JSON.parse($.value.toString())}catch{return{}}}async createExtensionScannerInput($,Z,_,W,q,K,ie,ne){const F=await this.getTranslations(q??m.language),j=await this.getMtime($),V=Z&&!this.uriIdentityService.extUri.isEqual($,this.userDataProfilesService.defaultProfile.extensionsResource)?this.userDataProfilesService.defaultProfile.extensionsResource:void 0,P=V?await this.getMtime(V):void 0;return new B($,j,V,P,Z,ie,_,W,K,ne.version,ne.date,this.productService.commit,!this.environmentService.isBuilt,q,F)}async getMtime($){try{const Z=await this.fileService.stat($);if(typeof Z.mtime=="number")return Z.mtime}catch{}}getProductVersion(){return{version:this.productService.version,date:this.productService.date}}};e.AbstractExtensionsScannerService=M,e.AbstractExtensionsScannerService=M=Pe([oe(4,T.IUserDataProfilesService),oe(5,g.IExtensionsProfileScannerService),oe(6,r.IFileService),oe(7,t.ILogService),oe(8,O.IEnvironmentService),oe(9,s.IProductService),oe(10,N.IUriIdentityService),oe(11,n.IInstantiationService)],M);class B{constructor($,Z,_,W,q,K,ie,ne,F,j,V,P,x,X,Y){this.location=$,this.mtime=Z,this.applicationExtensionslocation=_,this.applicationExtensionslocationMtime=W,this.profile=q,this.profileScanOptions=K,this.type=ie,this.excludeObsolete=ne,this.validate=F,this.productVersion=j,this.productDate=V,this.productCommit=P,this.devMode=x,this.language=X,this.translations=Y}static createNlsConfiguration($){return{language:$.language,pseudo:$.language==="pseudo",devMode:$.devMode,translations:$.translations}}static equals($,Z){return(0,a.isEqual)($.location,Z.location)&&$.mtime===Z.mtime&&(0,a.isEqual)($.applicationExtensionslocation,Z.applicationExtensionslocation)&&$.applicationExtensionslocationMtime===Z.applicationExtensionslocationMtime&&$.profile===Z.profile&&S.equals($.profileScanOptions,Z.profileScanOptions)&&$.type===Z.type&&$.excludeObsolete===Z.excludeObsolete&&$.validate===Z.validate&&$.productVersion===Z.productVersion&&$.productDate===Z.productDate&&$.productCommit===Z.productCommit&&$.devMode===Z.devMode&&$.language===Z.language&&L.equals($.translations,Z.translations)}}e.ExtensionScannerInput=B;let Q=class extends u.Disposable{constructor($,Z,_,W,q,K,ie){super(),this.obsoleteFile=$,this.extensionsProfileScannerService=Z,this.uriIdentityService=_,this.fileService=W,this.environmentService=K,this.logService=ie,this.extensionsEnabledWithApiProposalVersion=q.extensionsEnabledWithApiProposalVersion?.map(ne=>ne.toLowerCase())??[]}async scanExtensions($){const Z=$.profile?await this.scanExtensionsFromProfile($):await this.scanExtensionsFromLocation($);let _={};if($.excludeObsolete&&$.type===i.ExtensionType.User)try{const W=(await this.fileService.readFile(this.obsoleteFile)).value.toString();_=JSON.parse(W)}catch{}return(0,w.isEmptyObject)(_)?Z:Z.filter(W=>!_[E.ExtensionKey.create(W).toString()])}async scanExtensionsFromLocation($){const Z=await this.fileService.resolve($.location);if(!Z.children?.length)return[];const _=await Promise.all(Z.children.map(async W=>{if(!W.isDirectory||$.type===i.ExtensionType.User&&(0,a.basename)(W.resource).indexOf(".")===0)return null;const q=new B(W.resource,$.mtime,$.applicationExtensionslocation,$.applicationExtensionslocationMtime,$.profile,$.profileScanOptions,$.type,$.excludeObsolete,$.validate,$.productVersion,$.productDate,$.productCommit,$.devMode,$.language,$.translations);return this.scanExtension(q)}));return(0,b.coalesce)(_).sort((W,q)=>W.location.path<q.location.path?-1:1)}async scanExtensionsFromProfile($){let Z=await this.scanExtensionsFromProfileResource($.location,()=>!0,$);if($.applicationExtensionslocation&&!this.uriIdentityService.extUri.isEqual($.location,$.applicationExtensionslocation)){Z=Z.filter(W=>!W.metadata?.isApplicationScoped);const _=await this.scanExtensionsFromProfileResource($.applicationExtensionslocation,W=>!!W.metadata?.isBuiltin||!!W.metadata?.isApplicationScoped,$);Z.push(..._)}return Z}async scanExtensionsFromProfileResource($,Z,_){const W=await this.extensionsProfileScannerService.scanProfileExtensions($,_.profileScanOptions);if(!W.length)return[];const q=await Promise.all(W.map(async K=>{if(Z(K)){const ie=new B(K.location,_.mtime,_.applicationExtensionslocation,_.applicationExtensionslocationMtime,_.profile,_.profileScanOptions,_.type,_.excludeObsolete,_.validate,_.productVersion,_.productDate,_.productCommit,_.devMode,_.language,_.translations);return this.scanExtension(ie,K.metadata)}return null}));return(0,b.coalesce)(q)}async scanOneOrMultipleExtensions($){try{if(await this.fileService.exists((0,a.joinPath)($.location,"package.json"))){const Z=await this.scanExtension($);return Z?[Z]:[]}else return await this.scanExtensions($)}catch(Z){return this.logService.error(`Error scanning extensions at ${$.location.path}:`,(0,k.getErrorMessage)(Z)),[]}}async scanExtension($,Z){try{let _=await this.scanExtensionManifest($.location);if(_){_.publisher||(_.publisher=i.UNDEFINED_PUBLISHER),Z=Z??_.__metadata,delete _.__metadata;const W=(0,E.getGalleryExtensionId)(_.publisher,_.name),q=Z?.id?{id:W,uuid:Z.id}:{id:W},K=Z?.isSystem?i.ExtensionType.System:$.type,ie=K===i.ExtensionType.System||!!Z?.isBuiltin;_=await this.translateManifest($.location,_,B.createNlsConfiguration($));let ne={type:K,identifier:q,manifest:_,location:$.location,isBuiltin:ie,targetPlatform:Z?.targetPlatform??i.TargetPlatform.UNDEFINED,publisherDisplayName:Z?.publisherDisplayName,metadata:Z,isValid:!0,validations:[]};return $.validate&&(ne=this.validate(ne,$)),_.enabledApiProposals&&(!this.environmentService.isBuilt||this.extensionsEnabledWithApiProposalVersion.includes(W.toLowerCase()))&&(_.originalEnabledApiProposals=_.enabledApiProposals,_.enabledApiProposals=(0,i.parseEnabledApiProposalNames)([..._.enabledApiProposals])),ne}}catch(_){$.type!==i.ExtensionType.System&&this.logService.error(_)}return null}validate($,Z){let _=!0;const W=this.environmentService.isBuilt&&this.extensionsEnabledWithApiProposalVersion.includes($.identifier.id.toLowerCase()),q=(0,l.validateExtensionManifest)(Z.productVersion,Z.productDate,Z.location,$.manifest,$.isBuiltin,W);for(const[K,ie]of q)K===I.default.Error&&(_=!1,this.logService.error(this.formatMessage(Z.location,ie)));return $.isValid=_,$.validations=q,$}async scanExtensionManifest($){const Z=(0,a.joinPath)($,"package.json");let _;try{_=(await this.fileService.readFile(Z)).value.toString()}catch(q){return(0,r.toFileOperationResult)(q)!==r.FileOperationResult.FILE_NOT_FOUND&&this.logService.error(this.formatMessage($,(0,d.localize)(1815,null,Z.path,q.message))),null}let W;try{W=JSON.parse(_)}catch{const K=[];(0,D.parse)(_,K);for(const ie of K)this.logService.error(this.formatMessage($,(0,d.localize)(1816,null,Z.path,ie.offset,ie.length,(0,p.getParseErrorMessage)(ie.error))));return null}return(0,D.getNodeType)(W)!=="object"?(this.logService.error(this.formatMessage($,(0,d.localize)(1817,null,Z.path))),null):W}async translateManifest($,Z,_){const W=await this.getLocalizedMessages($,Z,_);if(W)try{const q=[],K=await this.resolveOriginalMessageBundle(W.default,q);if(q.length>0)return q.forEach(ne=>{this.logService.error(this.formatMessage($,(0,d.localize)(1818,null,W.default?.path,(0,p.getParseErrorMessage)(ne.error))))}),Z;if((0,D.getNodeType)(W)!=="object")return this.logService.error(this.formatMessage($,(0,d.localize)(1819,null,W.default?.path))),Z;const ie=W.values||Object.create(null);return(0,A.localizeManifest)(this.logService,Z,ie,K)}catch{}return Z}async getLocalizedMessages($,Z,_){const W=(0,a.joinPath)($,"package.nls.json"),q=(F,j)=>{j.forEach(V=>{this.logService.error(this.formatMessage($,(0,d.localize)(1820,null,F?.path,(0,p.getParseErrorMessage)(V.error))))})},K=F=>{this.logService.error(this.formatMessage($,(0,d.localize)(1821,null,F?.path)))},ie=`${Z.publisher}.${Z.name}`,ne=_.translations[ie];if(ne)try{const F=y.URI.file(ne),j=(await this.fileService.readFile(F)).value.toString(),V=[],P=(0,D.parse)(j,V);return V.length>0?(q(F,V),{values:void 0,default:W}):(0,D.getNodeType)(P)!=="object"?(K(F),{values:void 0,default:W}):{values:P.contents?P.contents.package:void 0,default:W}}catch{return{values:void 0,default:W}}else{if(!await this.fileService.exists(W))return;let j;try{j=await this.findMessageBundles($,_)}catch{return}if(!j.localized)return{values:void 0,default:j.original};try{const V=(await this.fileService.readFile(j.localized)).value.toString(),P=[],x=(0,D.parse)(V,P);return P.length>0?(q(j.localized,P),{values:void 0,default:j.original}):(0,D.getNodeType)(x)!=="object"?(K(j.localized),{values:void 0,default:j.original}):{values:x,default:j.original}}catch{return{values:void 0,default:j.original}}}}async resolveOriginalMessageBundle($,Z){if($)try{const _=(await this.fileService.readFile($)).value.toString();return(0,D.parse)(_,Z)}catch{}}findMessageBundles($,Z){return new Promise((_,W)=>{const q=K=>{const ie=(0,a.joinPath)($,`package.nls.${K}.json`);this.fileService.exists(ie).then(ne=>{ne&&_({localized:ie,original:(0,a.joinPath)($,"package.nls.json")});const F=K.lastIndexOf("-");F===-1?_({localized:(0,a.joinPath)($,"package.nls.json"),original:null}):(K=K.substring(0,F),q(K))})};if(Z.devMode||Z.pseudo||!Z.language)return _({localized:(0,a.joinPath)($,"package.nls.json"),original:null});q(Z.language)})}formatMessage($,Z){return`[${$.path}]: ${Z}`}};Q=Pe([oe(1,g.IExtensionsProfileScannerService),oe(2,N.IUriIdentityService),oe(3,r.IFileService),oe(4,s.IProductService),oe(5,O.IEnvironmentService),oe(6,t.ILogService)],Q);let re=class extends Q{constructor($,Z,_,W,q,K,ie,ne,F){super(Z,W,q,K,ie,ne,F),this.currentProfile=$,this.userDataProfilesService=_,this.cacheValidatorThrottler=this._register(new C.ThrottledDelayer(3e3)),this._onDidChangeCache=this._register(new o.Emitter),this.onDidChangeCache=this._onDidChangeCache.event}async scanExtensions($){const Z=this.getCacheFile($),_=await this.readExtensionCache(Z);if(this.input=$,_&&_.input&&B.equals(_.input,this.input))return this.logService.debug("Using cached extensions scan result",$.type===i.ExtensionType.System?"system":"user",$.location.toString()),this.cacheValidatorThrottler.trigger(()=>this.validateCache()),_.result.map(q=>(q.location=y.URI.revive(q.location),q));const W=await super.scanExtensions($);return await this.writeExtensionCache(Z,{input:$,result:W}),W}async readExtensionCache($){try{const Z=await this.fileService.readFile($),_=JSON.parse(Z.value.toString());return{result:_.result,input:(0,c.revive)(_.input)}}catch(Z){this.logService.debug("Error while reading the extension cache file:",$.path,(0,k.getErrorMessage)(Z))}return null}async writeExtensionCache($,Z){try{await this.fileService.writeFile($,R.VSBuffer.fromString(JSON.stringify(Z)))}catch(_){this.logService.debug("Error while writing the extension cache file:",$.path,(0,k.getErrorMessage)(_))}}async validateCache(){if(!this.input)return;const $=this.getCacheFile(this.input),Z=await this.readExtensionCache($);if(!Z)return;const _=Z.result,W=JSON.parse(JSON.stringify(await super.scanExtensions(this.input)));if(!S.equals(W,_))try{this.logService.info("Invalidating Cache",_,W),await this.fileService.del($),this._onDidChangeCache.fire()}catch(q){this.logService.error(q)}}getCacheFile($){const Z=this.getProfile($);return this.uriIdentityService.extUri.joinPath(Z.cacheHome,$.type===i.ExtensionType.System?i.BUILTIN_MANIFEST_CACHE_FILE:i.USER_MANIFEST_CACHE_FILE)}getProfile($){return $.type===i.ExtensionType.System?this.userDataProfilesService.defaultProfile:$.profile?this.uriIdentityService.extUri.isEqual($.location,this.currentProfile.extensionsResource)?this.currentProfile:this.userDataProfilesService.profiles.find(Z=>this.uriIdentityService.extUri.isEqual($.location,Z.extensionsResource))??this.currentProfile:this.userDataProfilesService.defaultProfile}};re=Pe([oe(2,T.IUserDataProfilesService),oe(3,g.IExtensionsProfileScannerService),oe(4,N.IUriIdentityService),oe(5,r.IFileService),oe(6,s.IProductService),oe(7,O.IEnvironmentService),oe(8,t.ILogService)],re);function ae(pe,$){const Z=(0,E.getExtensionId)(pe.manifest.publisher,pe.manifest.name);return{id:Z,identifier:new i.ExtensionIdentifier(Z),isBuiltin:pe.type===i.ExtensionType.System,isUserBuiltin:pe.type===i.ExtensionType.User&&pe.isBuiltin,isUnderDevelopment:$,extensionLocation:pe.location,uuid:pe.identifier.uuid,targetPlatform:pe.targetPlatform,publisherDisplayName:pe.publisherDisplayName,...pe.manifest}}class ue extends M{constructor($,Z,_,W,q,K,ie,ne,F,j,V,P){super($,Z,(0,a.joinPath)(_,".vscode-oss-dev","extensions","control.json"),W,q,K,ie,ne,F,j,V,P),this.translationsPromise=(async()=>{if(m.translationsConfigFile)try{const x=await this.fileService.readFile(y.URI.file(m.translationsConfigFile));return JSON.parse(x.value.toString())}catch{}return Object.create(null)})()}getTranslations($){return this.translationsPromise}}e.NativeExtensionsScannerService=ue}),define(ce[137],de([0,1,61,8,38,5,2,14,15,29,6,24]),function(J,e,b,C,S,R,k,D,p,u,f,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let m=class extends k.Disposable{constructor(v,I){super(),this.userDataProfilesService=v,this.logService=I,this.processesLimiter=new C.Limiter(5)}async postUninstall(v){const I=this.parseScript(v,"uninstall");I&&(this.logService.info(v.identifier.id,v.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(async()=>{try{await this.runLifecycleHook(I.script,"uninstall",I.args,!0,v),this.logService.info("Finished running post uninstall script",v.identifier.id,v.manifest.version)}catch(w){this.logService.error("Failed to run post uninstall script",v.identifier.id,v.manifest.version),this.logService.error(w)}}));try{await u.Promises.rm(this.getExtensionStoragePath(v))}catch(w){this.logService.error("Error while removing extension storage path",v.identifier.id),this.logService.error(w)}}parseScript(v,I){const w=`vscode:${I}`;if(v.location.scheme===D.Schemas.file&&v.manifest&&v.manifest.scripts&&typeof v.manifest.scripts[w]=="string"){const y=v.manifest.scripts[w].split(" ");return y.length<2||y[0]!=="node"||!y[1]?(this.logService.warn(v.identifier.id,v.manifest.version,`${w} should be a node script`),null):{script:(0,p.join)(v.location.fsPath,y[1]),args:y.slice(2)||[]}}return null}runLifecycleHook(v,I,w,y,d){return new Promise((O,E)=>{const i=this.start(v,I,w,d);let l;const r=n=>{l&&(clearTimeout(l),l=null),n?E(n):O(void 0)};i.on("error",n=>{r((0,S.toErrorMessage)(n)||"Unknown")}),i.on("exit",(n,t)=>{r(n?`post-${I} process exited with code ${n}`:void 0)}),y&&(l=setTimeout(()=>{l=null,i.kill(),E("timed out")},5e3))})}start(v,I,w,y){const d={silent:!0,execArgv:void 0},O=(0,b.fork)(v,[`--type=extension-post-${I}`,...w],d);O.stdout.setEncoding("utf8"),O.stderr.setEncoding("utf8");const E=R.Event.fromNodeEventEmitter(O.stdout,"data"),i=R.Event.fromNodeEventEmitter(O.stderr,"data");this._register(E(n=>this.logService.info(y.identifier.id,y.manifest.version,`post-${I}`,n))),this._register(i(n=>this.logService.error(y.identifier.id,y.manifest.version,`post-${I}`,n)));const l=R.Event.any(R.Event.map(E,n=>({data:`%c${n}`,format:[""]}),this._store),R.Event.map(i,n=>({data:`%c${n}`,format:["color: red"]}),this._store));return R.Event.debounce(l,(n,t)=>n?{data:n.data+t.data,format:[...n.format,...t.format]}:{data:t.data,format:t.format},100,void 0,void 0,void 0,this._store)(n=>{console.group(y.identifier.id),console.log(n.data,...n.format),console.groupEnd()}),O}getExtensionStoragePath(v){return(0,p.join)(this.userDataProfilesService.defaultProfile.globalStorageHome.fsPath,v.identifier.id.toLowerCase())}};e.ExtensionsLifecycle=m,e.ExtensionsLifecycle=m=Pe([oe(0,h.IUserDataProfilesService),oe(1,f.ILogService)],m)}),define(ce[73],de([0,1,50,4,53,20]),function(J,e,b,C,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fromExtractError=k,e.getManifest=D;function k(p){let u=R.ExtensionManagementErrorCode.Extract;return p instanceof b.ExtractError&&(p.type==="CorruptZip"?u=R.ExtensionManagementErrorCode.CorruptZip:p.type==="Incomplete"&&(u=R.ExtensionManagementErrorCode.IncompleteZip)),(0,S.toExtensionManagementError)(p,u)}async function D(p){let u;try{u=await(0,b.buffer)(p,"extension/package.json")}catch(f){throw k(f)}try{return JSON.parse(u.toString("utf8"))}catch{throw new R.ExtensionManagementError((0,C.localize)(1831,null),R.ExtensionManagementErrorCode.Invalid)}}}),define(ce[138],de([0,1,8,7,2,14,16,45,28,29,50,30,17,53,20,26,73,72,9,6,18]),function(J,e,b,C,S,R,k,D,p,u,f,h,m,a,v,I,w,y,d,O,E){"use strict";var i;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0,D=we(D);let l=class extends S.Disposable{static{i=this}static{this.SignatureArchiveExtension=".sigzip"}constructor(n,t,s,o,c,g,T){super(),this.fileService=t,this.extensionGalleryService=s,this.configurationService=o,this.extensionSignatureVerificationService=c,this.telemetryService=g,this.logService=T,this.extensionsDownloadDir=n.extensionsDownloadLocation,this.cache=20,this.cleanUpPromise=this.cleanUp()}async download(n,t,s,o){await this.cleanUpPromise;const c=await this.downloadVSIX(n,t);let g=!1;if(s&&this.shouldVerifySignature(n)){let T;try{T=await this.downloadSignatureArchive(n)}catch(N){try{await this.delete(c)}catch(A){this.logService.error(A)}throw N}try{g=await this.extensionSignatureVerificationService.verify(n,c.fsPath,T.fsPath,o)}catch(N){if(g=N.code,g===y.ExtensionSignatureVerificationCode.PackageIsInvalidZip||g===y.ExtensionSignatureVerificationCode.SignatureArchiveIsInvalidZip){try{await this.delete(c)}catch(A){this.logService.error(A)}throw new v.ExtensionManagementError(f.CorruptZipMessage,v.ExtensionManagementErrorCode.CorruptZip)}}finally{try{await this.delete(T)}catch(N){this.logService.error(N)}}}return{location:c,verificationStatus:g}}shouldVerifySignature(n){return n.isSigned||this.logService.info(`Extension is not signed: ${n.identifier.id}`),!1}async downloadVSIX(n,t){try{const s=(0,k.joinPath)(this.extensionsDownloadDir,this.getName(n)),o=await this.doDownload(n,"vsix",async()=>{await this.downloadFile(n,s,c=>this.extensionGalleryService.download(n,c,t));try{await this.validate(s.fsPath,"extension/package.json")}catch(c){try{await this.fileService.del(s)}catch(g){this.logService.warn(`Error while deleting: ${s.path}`,(0,C.getErrorMessage)(g))}throw c}},2);return o>1&&this.telemetryService.publicLog2("extensiongallery:downloadvsix:retry",{extensionId:n.identifier.id,attempts:o}),s}catch(s){throw(0,a.toExtensionManagementError)(s,v.ExtensionManagementErrorCode.Download)}}async downloadSignatureArchive(n){try{const t=(0,k.joinPath)(this.extensionsDownloadDir,`.${(0,p.generateUuid)()}`),s=await this.doDownload(n,"sigzip",async()=>{await this.extensionGalleryService.downloadSignatureArchive(n,t);try{await this.validate(t.fsPath,".signature.p7s")}catch(o){try{await this.fileService.del(t)}catch(c){this.logService.warn(`Error while deleting: ${t.path}`,(0,C.getErrorMessage)(c))}throw o}},2);return s>1&&this.telemetryService.publicLog2("extensiongallery:downloadsigzip:retry",{extensionId:n.identifier.id,attempts:s}),t}catch(t){throw(0,a.toExtensionManagementError)(t,v.ExtensionManagementErrorCode.DownloadSignature)}}async downloadFile(n,t,s){if(await this.fileService.exists(t))return;if(t.scheme!==R.Schemas.file){await s(t);return}const o=(0,k.joinPath)(this.extensionsDownloadDir,`.${(0,p.generateUuid)()}`);try{await s(o)}catch(c){try{await this.fileService.del(o)}catch{}throw c}try{await u.Promises.rename(o.fsPath,t.fsPath,2*60*1e3)}catch(c){try{await this.fileService.del(o)}catch{}let g=!1;try{g=await this.fileService.exists(t)}catch{}if(g)this.logService.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",n.identifier.id,t.path);else throw this.logService.info(`Rename failed because of ${(0,C.getErrorMessage)(c)}. Deleted the file from downloaded location`,o.path),c}}async doDownload(n,t,s,o){let c=1;for(;;)try{return await s(),c}catch(g){if(c++>o)throw g;this.logService.warn(`Failed downloading ${t}. ${(0,C.getErrorMessage)(g)}. Retry again...`,n.identifier.id)}}async validate(n,t){try{await(0,f.buffer)(n,t)}catch(s){throw(0,w.fromExtractError)(s)}}async delete(n){await this.cleanUpPromise,await this.fileService.del(n)}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downloads cache dir does not exist");return}const n=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(n.children){const t=[],s=[],o=[];for(const T of n.children)if(T.name.endsWith(i.SignatureArchiveExtension))o.push(T.resource);else{const N=I.ExtensionKey.parse(T.name);N&&s.push([N,T])}const c=(0,I.groupByExtension)(s,([T])=>T),g=[];for(const T of c)T.sort((N,A)=>D.rcompare(N[0].version,A[0].version)),t.push(...T.slice(1).map(N=>N[1].resource)),g.push(T[0][1]);g.sort((T,N)=>T.mtime-N.mtime),t.push(...g.slice(0,Math.max(0,g.length-this.cache)).map(T=>T.resource)),t.push(...o),await b.Promises.settled(t.map(T=>(this.logService.trace("Deleting from cache",T.path),this.fileService.del(T))))}}catch(n){this.logService.error(n)}}getName(n){return this.cache?I.ExtensionKey.create(n).toString().toLowerCase():(0,p.generateUuid)()}};e.ExtensionsDownloader=l,e.ExtensionsDownloader=l=i=Pe([oe(0,m.INativeEnvironmentService),oe(1,d.IFileService),oe(2,v.IExtensionGalleryService),oe(3,h.IConfigurationService),oe(4,y.IExtensionSignatureVerificationService),oe(5,E.ITelemetryService),oe(6,O.ILogService)],l)}),define(ce[139],de([0,1,32,8,13,21,38,7,5,43,2,25,14,15,16,45,3,12,28,29,50,4,62,17,53,20,26,42,54,138,137,73,119,126,22,44,9,10,6,33,18,23,24]),function(J,e,b,C,S,R,k,D,p,u,f,h,m,a,v,I,w,y,d,O,E,i,l,r,n,t,s,o,c,g,T,N,A,L,M,B,Q,re,ae,ue,pe,$,Z){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScanner=e.ExtensionManagementService=e.INativeServerExtensionManagementService=void 0,b=we(b),a=we(a),I=we(I),O=we(O),i=we(i),e.INativeServerExtensionManagementService=(0,re.refineServiceDecorator)(t.IExtensionManagementService);const _=".vsctmp";let W=class extends n.AbstractExtensionManagementService{constructor(F,j,V,P,x,X,Y,G,U,H,se,le){super(F,j,se,V,H,le),this.extensionsScannerService=x,this.extensionsProfileScannerService=X,this.downloadService=Y,this.instantiationService=G,this.fileService=U,this.extractingGalleryExtensions=new Map,this.knownDirectories=new h.ResourceSet;const he=this._register(G.createInstance(T.ExtensionsLifecycle));this.extensionsScanner=this._register(G.createInstance(q,fe=>he.postUninstall(fe))),this.manifestCache=this._register(new A.ExtensionsManifestCache(le,U,se,this,this.logService)),this.extensionsDownloader=this._register(G.createInstance(g.ExtensionsDownloader));const Se=this._register(new L.ExtensionsWatcher(this,this.extensionsScannerService,le,X,se,U,V));this._register(Se.onDidChangeExtensionsByAnotherSource(fe=>this.onDidChangeExtensionsFromAnotherSource(fe))),this.watchForExtensionsNotInstalledBySystem()}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,s.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async zip(F){this.logService.trace("ExtensionManagementService#zip",F.identifier.id);const j=await this.collectFiles(F),V=await(0,E.zip)((0,v.joinPath)(this.extensionsDownloader.extensionsDownloadDir,(0,d.generateUuid)()).fsPath,j);return y.URI.file(V)}async getManifest(F){const{location:j,cleanup:V}=await this.downloadVsix(F),P=a.resolve(j.fsPath);try{return await(0,N.getManifest)(P)}finally{await V()}}getInstalled(F,j=this.userDataProfilesService.defaultProfile.extensionsResource,V={version:this.productService.version,date:this.productService.date}){return this.extensionsScanner.scanExtensions(F??null,j,V)}scanAllUserInstalledExtensions(){return this.extensionsScanner.scanAllUserExtensions(!1)}scanInstalledExtensionAtLocation(F){return this.extensionsScanner.scanUserExtensionAtLocation(F)}async install(F,j={}){this.logService.trace("ExtensionManagementService#install",F.toString());const{location:V,cleanup:P}=await this.downloadVsix(F);try{const x=await(0,N.getManifest)(a.resolve(V.fsPath)),X=(0,s.getGalleryExtensionId)(x.publisher,x.name);if(x.engines&&x.engines.vscode&&!(0,B.isEngineValid)(x.engines.vscode,this.productService.version,this.productService.date))throw new Error(i.localize(1822,null,X,this.productService.version));const G=(await this.installExtensions([{manifest:x,extension:V,options:j}])).find(({identifier:U})=>(0,s.areSameExtensions)(U,{id:X}));if(G?.local)return G.local;throw G?.error?G.error:(0,n.toExtensionManagementError)(new Error(`Unknown error while installing extension ${X}`))}finally{await P()}}async installFromLocation(F,j){this.logService.trace("ExtensionManagementService#installFromLocation",F.toString());const V=await this.extensionsScanner.scanUserExtensionAtLocation(F);if(!V||!V.manifest.name||!V.manifest.version)throw new Error(`Cannot find a valid extension from the location ${F.toString()}`);return await this.addExtensionsToProfile([[V,{source:"resource"}]],j),this.logService.info("Successfully installed extension",V.identifier.id,j.toString()),V}async installExtensionsFromProfile(F,j,V){this.logService.trace("ExtensionManagementService#installExtensionsFromProfile",F,j.toString(),V.toString());const P=(await this.getInstalled(M.ExtensionType.User,j)).filter(x=>F.some(X=>(0,s.areSameExtensions)(X,x.identifier)));if(P.length){const x=await Promise.all(P.map(X=>this.extensionsScanner.scanMetadata(X,j)));await this.addExtensionsToProfile(P.map((X,Y)=>[X,x[Y]]),V),this.logService.info("Successfully installed extensions",P.map(X=>X.identifier.id),V.toString())}return P}async updateMetadata(F,j,V){return this.logService.trace("ExtensionManagementService#updateMetadata",F.identifier.id),j.isPreReleaseVersion&&(j.preRelease=!0,j.hasPreReleaseVersion=!0),j.isMachineScoped===!1&&(j.isMachineScoped=void 0),j.isBuiltin===!1&&(j.isBuiltin=void 0),j.pinned===!1&&(j.pinned=void 0),F=await this.extensionsScanner.updateMetadata(F,j,V),this.manifestCache.invalidate(V),this._onDidUpdateExtensionMetadata.fire({local:F,profileLocation:V}),F}async reinstallFromGallery(F){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",F.identifier.id),!this.galleryService.isEnabled())throw new Error(i.localize(1823,null));const j=await this.getTargetPlatform(),[V]=await this.galleryService.getExtensions([{...F.identifier,preRelease:F.preRelease}],{targetPlatform:j,compatible:!0},R.CancellationToken.None);if(!V)throw new Error(i.localize(1824,null));await this.extensionsScanner.setUninstalled(F);try{await this.extensionsScanner.removeUninstalledExtension(F)}catch(P){throw new Error(i.localize(1825,null,(0,k.toErrorMessage)(P)))}return this.installFromGallery(V)}copyExtension(F,j,V,P){return this.extensionsScanner.copyExtension(F,j,V,P)}copyExtensions(F,j){return this.extensionsScanner.copyExtensions(F,j,{version:this.productService.version,date:this.productService.date})}markAsUninstalled(...F){return this.extensionsScanner.setUninstalled(...F)}async cleanUp(){this.logService.trace("ExtensionManagementService#cleanUp");try{await this.extensionsScanner.cleanUp()}catch(F){this.logService.error(F)}}async download(F,j,V){const{location:P}=await this.extensionsDownloader.download(F,j,!V);return P}async downloadVsix(F){if(F.scheme===m.Schemas.file)return{location:F,async cleanup(){}};this.logService.trace("Downloading extension from",F.toString());const j=(0,v.joinPath)(this.extensionsDownloader.extensionsDownloadDir,(0,d.generateUuid)());return await this.downloadService.download(F,j),this.logService.info("Downloaded extension to",j.toString()),{location:j,cleanup:async()=>{try{await this.fileService.del(j)}catch(P){this.logService.error(P)}}}}getCurrentExtensionsManifestLocation(){return this.userDataProfilesService.defaultProfile.extensionsResource}createInstallExtensionTask(F,j,V){const P=j instanceof y.URI?new s.ExtensionKey({id:(0,s.getGalleryExtensionId)(F.publisher,F.name)},F.version):s.ExtensionKey.create(j);return this.instantiationService.createInstance(K,P,F,j,V,(x,X)=>{if(j instanceof y.URI)return this.extractVSIX(P,j,V,X);let Y=this.extractingGalleryExtensions.get(P.toString());return Y||(this.extractingGalleryExtensions.set(P.toString(),Y=this.downloadAndExtractGalleryExtension(P,j,x,V,X)),Y.finally(()=>this.extractingGalleryExtensions.delete(P.toString()))),Y},this.extensionsScanner)}createUninstallExtensionTask(F,j){return new ie(F,j,this.extensionsProfileScannerService)}async downloadAndExtractGalleryExtension(F,j,V,P,x){const{verificationStatus:X,location:Y}=await this.extensionsDownloader.download(j,V,!P.donotVerifySignature,P.context?.[t.EXTENSION_INSTALL_CLIENT_TARGET_PLATFORM_CONTEXT]);try{if(x.isCancellationRequested)throw new D.CancellationError;const G=await(0,N.getManifest)(Y.fsPath);if(!new s.ExtensionKey(j.identifier,j.version).equals(new s.ExtensionKey({id:(0,s.getGalleryExtensionId)(G.publisher,G.name)},G.version)))throw new t.ExtensionManagementError(i.localize(1826,null,j.identifier.id),t.ExtensionManagementErrorCode.Invalid);return{local:await this.extensionsScanner.extractUserExtension(F,Y.fsPath,{id:j.identifier.uuid,publisherId:j.publisherId,publisherDisplayName:j.publisherDisplayName,targetPlatform:j.properties.targetPlatform,isApplicationScoped:P.isApplicationScoped,isMachineScoped:P.isMachineScoped,isBuiltin:P.isBuiltin,isPreReleaseVersion:j.properties.isPreReleaseVersion,hasPreReleaseVersion:j.properties.isPreReleaseVersion,installedTimestamp:Date.now(),pinned:P.installGivenVersion?!0:!!P.pinned,preRelease:(0,w.isBoolean)(P.preRelease)?P.preRelease:P.installPreReleaseVersion||j.properties.isPreReleaseVersion,source:"gallery"},!1,x),verificationStatus:X}}catch(G){try{await this.extensionsDownloader.delete(Y)}catch(U){this.logService.warn("Error while deleting the downloaded file",Y.toString(),(0,D.getErrorMessage)(U))}throw(0,n.toExtensionManagementError)(G)}}async extractVSIX(F,j,V,P){return{local:await this.extensionsScanner.extractUserExtension(F,a.resolve(j.fsPath),{isApplicationScoped:V.isApplicationScoped,isMachineScoped:V.isMachineScoped,isBuiltin:V.isBuiltin,installedTimestamp:Date.now(),pinned:V.installGivenVersion?!0:!!V.pinned,source:"vsix"},V.keepExisting??!0,P)}}async collectFiles(F){const j=async P=>{let x=await O.Promises.readdir(P);x=x.map(G=>a.join(P,G));const X=await Promise.all(x.map(G=>b.promises.stat(G)));let Y=Promise.resolve([]);return X.forEach((G,U)=>{const H=x[U];G.isFile()&&(Y=Y.then(se=>[...se,H])),G.isDirectory()&&(Y=Y.then(se=>j(H).then(le=>[...se,...le])))}),Y};return(await j(F.location.fsPath)).map(P=>({path:`extension/${a.relative(F.location.fsPath,P)}`,localPath:P}))}async onDidChangeExtensionsFromAnotherSource({added:F,removed:j}){if(j){const V=F&&this.uriIdentityService.extUri.isEqual(j.profileLocation,F.profileLocation)?j.extensions.filter(P=>F.extensions.every(x=>!(0,s.areSameExtensions)(x,P))):j.extensions;for(const P of V)this.logService.info("Extensions removed from another source",P.id,j.profileLocation.toString()),this._onDidUninstallExtension.fire({identifier:P,profileLocation:j.profileLocation})}if(F){const P=(await this.getInstalled(M.ExtensionType.User,F.profileLocation)).filter(x=>F.extensions.some(X=>(0,s.areSameExtensions)(X,x.identifier)));this._onDidInstallExtensions.fire(P.map(x=>(this.logService.info("Extensions added from another source",x.identifier.id,F.profileLocation.toString()),{identifier:x.identifier,local:x,profileLocation:F.profileLocation,operation:t.InstallOperation.None})))}}async watchForExtensionsNotInstalledBySystem(){this._register(this.extensionsScanner.onExtract(j=>this.knownDirectories.add(j)));const F=await this.fileService.resolve(this.extensionsScannerService.userExtensionsLocation);for(const j of F.children??[])j.isDirectory&&this.knownDirectories.add(j.resource);this._register(this.fileService.watch(this.extensionsScannerService.userExtensionsLocation)),this._register(this.fileService.onDidFilesChange(j=>this.onDidFilesChange(j)))}async onDidFilesChange(F){if(!F.affects(this.extensionsScannerService.userExtensionsLocation,Q.FileChangeType.ADDED))return;const j=[];for(const V of F.rawAdded){if(this.knownDirectories.has(V)||!this.uriIdentityService.extUri.isEqual(this.uriIdentityService.extUri.dirname(V),this.extensionsScannerService.userExtensionsLocation)||this.uriIdentityService.extUri.isEqual(V,this.uriIdentityService.extUri.joinPath(this.extensionsScannerService.userExtensionsLocation,".obsolete"))||this.uriIdentityService.extUri.basename(V).startsWith(".")||!(await this.fileService.stat(V)).isDirectory)continue;const P=await this.extensionsScanner.scanUserExtensionAtLocation(V);P&&P.installedTimestamp===void 0&&(this.knownDirectories.add(V),j.push(P))}j.length&&(await this.addExtensionsToProfile(j.map(V=>[V,void 0]),this.userDataProfilesService.defaultProfile.extensionsResource),this.logService.info("Added extensions to default profile from external source",j.map(V=>V.identifier.id)))}async addExtensionsToProfile(F,j){const V=F.map(P=>P[0]);await this.setInstalled(V),await this.extensionsProfileScannerService.addExtensionsToProfile(F,j),this._onDidInstallExtensions.fire(V.map(P=>({local:P,identifier:P.identifier,operation:t.InstallOperation.None,profileLocation:j})))}async setInstalled(F){const j=await this.extensionsScanner.getUninstalledExtensions();for(const V of F){const P=s.ExtensionKey.create(V);j[P.toString()]&&(this.logService.trace("Removing the extension from uninstalled list:",P.id),await this.extensionsScanner.setInstalled(P),this.logService.info("Removed the extension from uninstalled list:",P.id))}}};e.ExtensionManagementService=W,e.ExtensionManagementService=W=Pe([oe(0,t.IExtensionGalleryService),oe(1,pe.ITelemetryService),oe(2,ae.ILogService),oe(3,r.INativeEnvironmentService),oe(4,c.IExtensionsScannerService),oe(5,o.IExtensionsProfileScannerService),oe(6,l.IDownloadService),oe(7,re.IInstantiationService),oe(8,Q.IFileService),oe(9,ue.IProductService),oe(10,$.IUriIdentityService),oe(11,Z.IUserDataProfilesService)],W);let q=class extends f.Disposable{constructor(F,j,V,P,x,X,Y){super(),this.beforeRemovingExtension=F,this.fileService=j,this.extensionsScannerService=V,this.extensionsProfileScannerService=P,this.uriIdentityService=x,this.telemetryService=X,this.logService=Y,this._onExtract=this._register(new p.Emitter),this.onExtract=this._onExtract.event,this.scanAllExtensionPromise=new h.ResourceMap,this.scanUserExtensionsPromise=new h.ResourceMap,this.uninstalledResource=(0,v.joinPath)(this.extensionsScannerService.userExtensionsLocation,".obsolete"),this.uninstalledFileLimiter=new C.Queue}async cleanUp(){await this.removeTemporarilyDeletedFolders(),await this.removeUninstalledExtensions()}async scanExtensions(F,j,V){try{const P={includeInvalid:!0,profileLocation:j,productVersion:V};let x=[];if(F===null||F===M.ExtensionType.System){let X=this.scanAllExtensionPromise.get(j);X||(X=this.extensionsScannerService.scanAllExtensions({includeInvalid:!0,useCache:!0},P,!1).finally(()=>this.scanAllExtensionPromise.delete(j)),this.scanAllExtensionPromise.set(j,X)),x.push(...await X)}else if(F===M.ExtensionType.User){let X=this.scanUserExtensionsPromise.get(j);X||(X=this.extensionsScannerService.scanUserExtensions(P).finally(()=>this.scanUserExtensionsPromise.delete(j)),this.scanUserExtensionsPromise.set(j,X)),x.push(...await X)}return x=F!==null?x.filter(X=>X.type===F):x,await Promise.all(x.map(X=>this.toLocalExtension(X)))}catch(P){throw(0,n.toExtensionManagementError)(P,t.ExtensionManagementErrorCode.Scanning)}}async scanAllUserExtensions(F){try{const j=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!F,includeInvalid:!0});return await Promise.all(j.map(V=>this.toLocalExtension(V)))}catch(j){throw(0,n.toExtensionManagementError)(j,t.ExtensionManagementErrorCode.Scanning)}}async scanUserExtensionAtLocation(F){try{const j=await this.extensionsScannerService.scanExistingExtension(F,M.ExtensionType.User,{includeInvalid:!0});if(j)return await this.toLocalExtension(j)}catch(j){this.logService.error(j)}return null}async extractUserExtension(F,j,V,P,x){const X=F.toString(),Y=y.URI.file(a.join(this.extensionsScannerService.userExtensionsLocation.fsPath,`.${(0,d.generateUuid)()}`)),G=y.URI.file(a.join(this.extensionsScannerService.userExtensionsLocation.fsPath,X));if(await this.fileService.exists(G)){if(!P)try{return await this.scanLocalExtension(G,M.ExtensionType.User)}catch(U){this.logService.warn(`Error while scanning the existing extension at ${G.path}. Deleting the existing extension and extracting it.`,(0,D.getErrorMessage)(U))}try{await this.deleteExtensionFromLocation(F.id,G,"removeExisting")}catch{throw new t.ExtensionManagementError(i.localize(1827,null,G.fsPath,F.id),t.ExtensionManagementErrorCode.Delete)}}try{if(x.isCancellationRequested)throw new D.CancellationError;try{this.logService.trace(`Started extracting the extension from ${j} to ${G.fsPath}`),await(0,E.extract)(j,Y.fsPath,{sourcePath:"extension",overwrite:!0},x),this.logService.info(`Extracted extension to ${G}:`,F.id)}catch(U){throw(0,N.fromExtractError)(U)}try{await this.extensionsScannerService.updateMetadata(Y,V)}catch(U){throw this.telemetryService.publicLog2("extension:extract",{extensionId:F.id,code:`${(0,Q.toFileOperationResult)(U)}`}),(0,n.toExtensionManagementError)(U,t.ExtensionManagementErrorCode.UpdateMetadata)}if(x.isCancellationRequested)throw new D.CancellationError;try{this.logService.trace(`Started renaming the extension from ${Y.fsPath} to ${G.fsPath}`),await this.rename(Y.fsPath,G.fsPath),this.logService.info("Renamed to",G.fsPath)}catch(U){if(U.code==="ENOTEMPTY"){this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",F.id);try{await this.fileService.del(Y,{recursive:!0})}catch{}}else throw this.logService.info(`Rename failed because of ${(0,D.getErrorMessage)(U)}. Deleted from extracted location`,Y),U}this._onExtract.fire(G)}catch(U){try{await this.fileService.del(Y,{recursive:!0})}catch{}throw U}return this.scanLocalExtension(G,M.ExtensionType.User)}async scanMetadata(F,j){return j?(await this.getScannedExtension(F,j))?.metadata:this.extensionsScannerService.scanMetadata(F.location)}async getScannedExtension(F,j){return(await this.extensionsProfileScannerService.scanProfileExtensions(j)).find(P=>(0,s.areSameExtensions)(P.identifier,F.identifier))}async updateMetadata(F,j,V){try{V?await this.extensionsProfileScannerService.updateMetadata([[F,j]],V):await this.extensionsScannerService.updateMetadata(F.location,j)}catch(P){throw this.telemetryService.publicLog2("extension:extract",{extensionId:F.identifier.id,code:`${(0,Q.toFileOperationResult)(P)}`,isProfile:!!V}),(0,n.toExtensionManagementError)(P,t.ExtensionManagementErrorCode.UpdateMetadata)}return this.scanLocalExtension(F.location,F.type,V)}async getUninstalledExtensions(){try{return await this.withUninstalledExtensions()}catch(F){throw(0,n.toExtensionManagementError)(F,t.ExtensionManagementErrorCode.ReadUninstalled)}}async setUninstalled(...F){const j=F.map(V=>s.ExtensionKey.create(V));await this.withUninstalledExtensions(V=>j.forEach(P=>{V[P.toString()]=!0,this.logService.info("Marked extension as uninstalled",P.toString())}))}async setInstalled(F){try{await this.withUninstalledExtensions(j=>delete j[F.toString()])}catch(j){throw(0,n.toExtensionManagementError)(j,t.ExtensionManagementErrorCode.UnsetUninstalled)}}async removeExtension(F,j){if(this.uriIdentityService.extUri.isEqualOrParent(F.location,this.extensionsScannerService.userExtensionsLocation))return this.deleteExtensionFromLocation(F.identifier.id,F.location,j)}async removeUninstalledExtension(F){await this.removeExtension(F,"uninstalled"),await this.withUninstalledExtensions(j=>delete j[s.ExtensionKey.create(F).toString()])}async copyExtension(F,j,V,P){const x=await this.getScannedExtension(F,j),X=await this.getScannedExtension(F,V);if(P={...x?.metadata,...P},X)if(this.uriIdentityService.extUri.isEqual(X.location,F.location))await this.extensionsProfileScannerService.updateMetadata([[F,{...X.metadata,...P}]],V);else{const Y=await this.scanLocalExtension(X.location,F.type,V);await this.extensionsProfileScannerService.removeExtensionFromProfile(Y,V),await this.extensionsProfileScannerService.addExtensionsToProfile([[F,{...X.metadata,...P}]],V)}else await this.extensionsProfileScannerService.addExtensionsToProfile([[F,P]],V);return this.scanLocalExtension(F.location,F.type,V)}async copyExtensions(F,j,V){const P=await this.scanExtensions(M.ExtensionType.User,F,V),x=await Promise.all(P.filter(X=>!X.isApplicationScoped).map(async X=>[X,await this.scanMetadata(X,F)]));await this.extensionsProfileScannerService.addExtensionsToProfile(x,j)}async deleteExtensionFromLocation(F,j,V){this.logService.trace(`Deleting ${V} extension from disk`,F,j.fsPath);const P=this.uriIdentityService.extUri.joinPath(this.uriIdentityService.extUri.dirname(j),`${this.uriIdentityService.extUri.basename(j)}.${(0,u.hash)((0,d.generateUuid)()).toString(16)}${_}`);await this.rename(j.fsPath,P.fsPath),await this.fileService.del(P,{recursive:!0}),this.logService.info(`Deleted ${V} extension from disk`,F,j.fsPath)}withUninstalledExtensions(F){return this.uninstalledFileLimiter.queue(async()=>{let j;try{j=(await this.fileService.readFile(this.uninstalledResource,"utf8")).value.toString()}catch(P){if((0,Q.toFileOperationResult)(P)!==Q.FileOperationResult.FILE_NOT_FOUND)throw P}let V={};if(j)try{V=JSON.parse(j)}catch{}return F&&(F(V),Object.keys(V).length?await this.fileService.writeFile(this.uninstalledResource,S.VSBuffer.fromString(JSON.stringify(V))):await this.fileService.del(this.uninstalledResource)),V})}async rename(F,j){try{await O.Promises.rename(F,j,2*60*1e3)}catch(V){throw(0,n.toExtensionManagementError)(V,t.ExtensionManagementErrorCode.Rename)}}async scanLocalExtension(F,j,V){try{if(V){const x=(await this.extensionsScannerService.scanUserExtensions({profileLocation:V})).find(X=>this.uriIdentityService.extUri.isEqual(X.location,F));if(x)return await this.toLocalExtension(x)}else{const P=await this.extensionsScannerService.scanExistingExtension(F,j,{includeInvalid:!0});if(P)return await this.toLocalExtension(P)}throw new t.ExtensionManagementError(i.localize(1828,null,F.path),t.ExtensionManagementErrorCode.ScanningExtension)}catch(P){throw(0,n.toExtensionManagementError)(P,t.ExtensionManagementErrorCode.ScanningExtension)}}async toLocalExtension(F){const j=await this.fileService.resolve(F.location);let V,P;return j.children&&(V=j.children.find(({name:x})=>/^readme(\.txt|\.md|)$/i.test(x))?.resource,P=j.children.find(({name:x})=>/^changelog(\.txt|\.md|)$/i.test(x))?.resource),{identifier:F.identifier,type:F.type,isBuiltin:F.isBuiltin||!!F.metadata?.isBuiltin,location:F.location,manifest:F.manifest,targetPlatform:F.targetPlatform,validations:F.validations,isValid:F.isValid,readmeUrl:V,changelogUrl:P,publisherDisplayName:F.metadata?.publisherDisplayName,publisherId:F.metadata?.publisherId||null,isApplicationScoped:!!F.metadata?.isApplicationScoped,isMachineScoped:!!F.metadata?.isMachineScoped,isPreReleaseVersion:!!F.metadata?.isPreReleaseVersion,hasPreReleaseVersion:!!F.metadata?.hasPreReleaseVersion,preRelease:!!F.metadata?.preRelease,installedTimestamp:F.metadata?.installedTimestamp,updated:!!F.metadata?.updated,pinned:!!F.metadata?.pinned,isWorkspaceScoped:!1,source:F.metadata?.source??(F.identifier.uuid?"gallery":"vsix")}}async removeUninstalledExtensions(){const F=await this.getUninstalledExtensions();if(Object.keys(F).length===0){this.logService.debug("No uninstalled extensions found.");return}this.logService.debug("Removing uninstalled extensions:",Object.keys(F));const j=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),V=new Set;for(const x of j)F[s.ExtensionKey.create(x).toString()]||V.add(x.identifier.id.toLowerCase());try{const x=(0,s.groupByExtension)(j,X=>X.identifier);await C.Promises.settled(x.map(async X=>{const Y=X.sort((G,U)=>I.rcompare(G.manifest.version,U.manifest.version))[0];V.has(Y.identifier.id.toLowerCase())||await this.beforeRemovingExtension(await this.toLocalExtension(Y))}))}catch(x){this.logService.error(x)}const P=j.filter(x=>x.metadata&&F[s.ExtensionKey.create(x).toString()]);await Promise.allSettled(P.map(x=>this.removeUninstalledExtension(x)))}async removeTemporarilyDeletedFolders(){this.logService.trace("ExtensionManagementService#removeTempDeleteFolders");let F;try{F=await this.fileService.resolve(this.extensionsScannerService.userExtensionsLocation)}catch(j){(0,Q.toFileOperationResult)(j)!==Q.FileOperationResult.FILE_NOT_FOUND&&this.logService.error(j);return}if(F?.children)try{await Promise.allSettled(F.children.map(async j=>{if(!(!j.isDirectory||!j.name.endsWith(_))){this.logService.trace("Deleting the temporarily deleted folder",j.resource.toString());try{await this.fileService.del(j.resource,{recursive:!0}),this.logService.trace("Deleted the temporarily deleted folder",j.resource.toString())}catch(V){(0,Q.toFileOperationResult)(V)!==Q.FileOperationResult.FILE_NOT_FOUND&&this.logService.error(V)}}}))}catch{}}};e.ExtensionsScanner=q,e.ExtensionsScanner=q=Pe([oe(1,Q.IFileService),oe(2,c.IExtensionsScannerService),oe(3,o.IExtensionsProfileScannerService),oe(4,$.IUriIdentityService),oe(5,pe.ITelemetryService),oe(6,ae.ILogService)],q);let K=class extends n.AbstractExtensionTask{get operation(){return this.options.operation??this._operation}get verificationStatus(){return this._verificationStatus}constructor(F,j,V,P,x,X,Y,G,U,H,se,le){super(),this.extensionKey=F,this.manifest=j,this.source=V,this.options=P,this.extractExtensionFn=x,this.extensionsScanner=X,this.uriIdentityService=Y,this.galleryService=G,this.userDataProfilesService=U,this.extensionsScannerService=H,this.extensionsProfileScannerService=se,this.logService=le,this._operation=t.InstallOperation.Install,this.identifier=this.extensionKey.identifier}async doRun(F){const V=(await this.extensionsScanner.scanExtensions(M.ExtensionType.User,this.options.profileLocation,this.options.productVersion)).find(Y=>(0,s.areSameExtensions)(Y.identifier,this.identifier));V&&(this._operation=t.InstallOperation.Update);const P={isApplicationScoped:this.options.isApplicationScoped||V?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||V?.isMachineScoped,isBuiltin:this.options.isBuiltin||V?.isBuiltin,isSystem:V?.type===M.ExtensionType.System?!0:void 0,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:this.options.pinned??V?.pinned,source:this.source instanceof y.URI?"vsix":"gallery"};let x;if(this.source instanceof y.URI){if(V&&this.extensionKey.equals(new s.ExtensionKey(V.identifier,V.manifest.version)))try{await this.extensionsScanner.removeExtension(V,"existing")}catch{throw new Error(i.localize(1829,null,this.manifest.displayName||this.manifest.name))}const Y=await this.unsetIfUninstalled(this.extensionKey);if(Y)try{await this.extensionsScanner.removeExtension(Y,"existing")}catch{throw new Error(i.localize(1830,null,this.manifest.displayName||this.manifest.name))}}else{if(P.id=this.source.identifier.uuid,P.publisherId=this.source.publisherId,P.publisherDisplayName=this.source.publisherDisplayName,P.targetPlatform=this.source.properties.targetPlatform,P.updated=!!V,P.isPreReleaseVersion=this.source.properties.isPreReleaseVersion,P.hasPreReleaseVersion=V?.hasPreReleaseVersion||this.source.properties.isPreReleaseVersion,P.preRelease=(0,w.isBoolean)(this.options.preRelease)?this.options.preRelease:this.options.installPreReleaseVersion||this.source.properties.isPreReleaseVersion||V?.preRelease,V&&V.type!==M.ExtensionType.System&&V.manifest.version===this.source.version)return this.extensionsScanner.updateMetadata(V,P,this.options.profileLocation);x=await this.unsetIfUninstalled(this.extensionKey)}if(F.isCancellationRequested)throw(0,n.toExtensionManagementError)(new D.CancellationError);if(!x){const Y=await this.extractExtensionFn(this.operation,F);x=Y.local,this._verificationStatus=Y.verificationStatus}if(this.uriIdentityService.extUri.isEqual(this.userDataProfilesService.defaultProfile.extensionsResource,this.options.profileLocation))try{await this.extensionsScannerService.initializeDefaultProfileExtensions()}catch(Y){throw(0,n.toExtensionManagementError)(Y,t.ExtensionManagementErrorCode.IntializeDefaultProfile)}if(F.isCancellationRequested)throw(0,n.toExtensionManagementError)(new D.CancellationError);try{await this.extensionsProfileScannerService.addExtensionsToProfile([[x,P]],this.options.profileLocation,!x.isValid)}catch(Y){throw(0,n.toExtensionManagementError)(Y,t.ExtensionManagementErrorCode.AddToProfile)}const X=await this.extensionsScanner.scanLocalExtension(x.location,M.ExtensionType.User,this.options.profileLocation);if(!X)throw new t.ExtensionManagementError("Cannot find the installed extension",t.ExtensionManagementErrorCode.InstalledExtensionNotFound);return this.source instanceof y.URI&&this.updateMetadata(x,F),X}async unsetIfUninstalled(F){return(await this.extensionsScanner.getUninstalledExtensions())[F.toString()]?(this.logService.trace("Removing the extension from uninstalled list:",F.id),await this.extensionsScanner.setInstalled(F),this.logService.info("Removed the extension from uninstalled list:",F.id),(await this.extensionsScanner.scanAllUserExtensions(!0)).find(P=>s.ExtensionKey.create(P).equals(F))):void 0}async updateMetadata(F,j){try{let[V]=await this.galleryService.getExtensions([{id:F.identifier.id,version:F.manifest.version}],j);if(V||([V]=await this.galleryService.getExtensions([{id:F.identifier.id}],j)),V){const P={id:V.identifier.uuid,publisherDisplayName:V.publisherDisplayName,publisherId:V.publisherId,isPreReleaseVersion:V.properties.isPreReleaseVersion,hasPreReleaseVersion:F.hasPreReleaseVersion||V.properties.isPreReleaseVersion,preRelease:V.properties.isPreReleaseVersion||this.options.installPreReleaseVersion};await this.extensionsScanner.updateMetadata(F,P,this.options.profileLocation)}}catch{}}};K=Pe([oe(6,$.IUriIdentityService),oe(7,t.IExtensionGalleryService),oe(8,Z.IUserDataProfilesService),oe(9,c.IExtensionsScannerService),oe(10,o.IExtensionsProfileScannerService),oe(11,ae.ILogService)],K);class ie extends n.AbstractExtensionTask{constructor(F,j,V){super(),this.extension=F,this.options=j,this.extensionsProfileScannerService=V}async doRun(F){await this.extensionsProfileScannerService.removeExtensionFromProfile(this.extension,this.options.profileLocation)}}}),define(ce[140],de([0,1,6,24,23,18,42,9,17,12]),function(J,e,b,C,S,R,k,D,p,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsProfileScannerService=void 0;let f=class extends k.AbstractExtensionsProfileScannerService{constructor(m,a,v,I,w,y){super(u.URI.file(m.extensionsPath),a,v,I,w,y)}};e.ExtensionsProfileScannerService=f,e.ExtensionsProfileScannerService=f=Pe([oe(0,p.INativeEnvironmentService),oe(1,D.IFileService),oe(2,C.IUserDataProfilesService),oe(3,S.IUriIdentityService),oe(4,R.ITelemetryService),oe(5,b.ILogService)],f)}),define(ce[141],de([0,1,12,17,42,54,9,10,6,33,23,24]),function(J,e,b,C,S,R,k,D,p,u,f,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScannerService=void 0;let m=class extends R.NativeExtensionsScannerService{constructor(v,I,w,y,d,O,E,i){super(b.URI.file(d.builtinExtensionsPath),b.URI.file(d.extensionsPath),d.userHome,v.defaultProfile,v,I,w,y,d,O,E,i)}};e.ExtensionsScannerService=m,e.ExtensionsScannerService=m=Pe([oe(0,h.IUserDataProfilesService),oe(1,S.IExtensionsProfileScannerService),oe(2,k.IFileService),oe(3,p.ILogService),oe(4,C.INativeEnvironmentService),oe(5,u.IProductService),oe(6,f.IUriIdentityService),oe(7,D.IInstantiationService)],m)}),define(ce[74],de([0,1,8,5,2,109,3,91,10,24]),function(J,e,b,C,S,R,k,D,p,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageService=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.TARGET_KEY=e.IS_NEW_KEY=void 0,e.loadKeyTargets=a,e.isProfileUsingDefaultStorage=I,e.logStorage=y,e.IS_NEW_KEY="__$__isNewStorageMarker",e.TARGET_KEY="__$__targetStorageMarker",e.IStorageService=(0,p.createDecorator)("storageService");var f;(function(d){d[d.NONE=0]="NONE",d[d.SHUTDOWN=1]="SHUTDOWN"})(f||(e.WillSaveStateReason=f={}));var h;(function(d){d[d.APPLICATION=-1]="APPLICATION",d[d.PROFILE=0]="PROFILE",d[d.WORKSPACE=1]="WORKSPACE"})(h||(e.StorageScope=h={}));var m;(function(d){d[d.USER=0]="USER",d[d.MACHINE=1]="MACHINE"})(m||(e.StorageTarget=m={}));function a(d){const O=d.get(e.TARGET_KEY);if(O)try{return JSON.parse(O)}catch{}return Object.create(null)}class v extends S.Disposable{static{this.DEFAULT_FLUSH_INTERVAL=60*1e3}constructor(O={flushInterval:v.DEFAULT_FLUSH_INTERVAL}){super(),this.options=O,this._onDidChangeValue=this._register(new C.PauseableEmitter),this._onDidChangeTarget=this._register(new C.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new C.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new b.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new S.MutableDisposable),this._workspaceKeyTargets=void 0,this._profileKeyTargets=void 0,this._applicationKeyTargets=void 0}onDidChangeValue(O,E,i){return C.Event.filter(this._onDidChangeValue.event,l=>l.scope===O&&(E===void 0||l.key===E),i)}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,b.runWhenGlobalIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,S.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,R.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,R.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(O,E){const{key:i,external:l}=E;if(i===e.TARGET_KEY){switch(O){case h.APPLICATION:this._applicationKeyTargets=void 0;break;case h.PROFILE:this._profileKeyTargets=void 0;break;case h.WORKSPACE:this._workspaceKeyTargets=void 0;break}this._onDidChangeTarget.fire({scope:O})}else this._onDidChangeValue.fire({scope:O,key:i,target:this.getKeyTargets(O)[i],external:l})}emitWillSaveState(O){this._onWillSaveState.fire({reason:O})}get(O,E,i){return this.getStorage(E)?.get(O,i)}getBoolean(O,E,i){return this.getStorage(E)?.getBoolean(O,i)}getNumber(O,E,i){return this.getStorage(E)?.getNumber(O,i)}getObject(O,E,i){return this.getStorage(E)?.getObject(O,i)}storeAll(O,E){this.withPausedEmitters(()=>{for(const i of O)this.store(i.key,i.value,i.scope,i.target,E)})}store(O,E,i,l,r=!1){if((0,k.isUndefinedOrNull)(E)){this.remove(O,i,r);return}this.withPausedEmitters(()=>{this.updateKeyTarget(O,i,l),this.getStorage(i)?.set(O,E,r)})}remove(O,E,i=!1){this.withPausedEmitters(()=>{this.updateKeyTarget(O,E,void 0),this.getStorage(E)?.delete(O,i)})}withPausedEmitters(O){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{O()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(O,E){const i=[],l=this.getKeyTargets(O);for(const r of Object.keys(l))l[r]===E&&i.push(r);return i}updateKeyTarget(O,E,i,l=!1){const r=this.getKeyTargets(E);typeof i=="number"?r[O]!==i&&(r[O]=i,this.getStorage(E)?.set(e.TARGET_KEY,JSON.stringify(r),l)):typeof r[O]=="number"&&(delete r[O],this.getStorage(E)?.set(e.TARGET_KEY,JSON.stringify(r),l))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(h.WORKSPACE)),this._workspaceKeyTargets}get profileKeyTargets(){return this._profileKeyTargets||(this._profileKeyTargets=this.loadKeyTargets(h.PROFILE)),this._profileKeyTargets}get applicationKeyTargets(){return this._applicationKeyTargets||(this._applicationKeyTargets=this.loadKeyTargets(h.APPLICATION)),this._applicationKeyTargets}getKeyTargets(O){switch(O){case h.APPLICATION:return this.applicationKeyTargets;case h.PROFILE:return this.profileKeyTargets;default:return this.workspaceKeyTargets}}loadKeyTargets(O){const E=this.getStorage(O);return E?a(E):Object.create(null)}isNew(O){return this.getBoolean(e.IS_NEW_KEY,O)===!0}async flush(O=f.NONE){this._onWillSaveState.fire({reason:O});const E=this.getStorage(h.APPLICATION),i=this.getStorage(h.PROFILE),l=this.getStorage(h.WORKSPACE);switch(O){case f.NONE:await b.Promises.settled([E?.whenFlushed()??Promise.resolve(),i?.whenFlushed()??Promise.resolve(),l?.whenFlushed()??Promise.resolve()]);break;case f.SHUTDOWN:await b.Promises.settled([E?.flush(0)??Promise.resolve(),i?.flush(0)??Promise.resolve(),l?.flush(0)??Promise.resolve()]);break}}async log(){const O=this.getStorage(h.APPLICATION)?.items??new Map,E=this.getStorage(h.PROFILE)?.items??new Map,i=this.getStorage(h.WORKSPACE)?.items??new Map;return y(O,E,i,this.getLogDetails(h.APPLICATION)??"",this.getLogDetails(h.PROFILE)??"",this.getLogDetails(h.WORKSPACE)??"")}async optimize(O){return await this.flush(),this.getStorage(O)?.optimize()}async switch(O,E){return this.emitWillSaveState(f.NONE),(0,u.isUserDataProfile)(O)?this.switchToProfile(O,E):this.switchToWorkspace(O,E)}canSwitchProfile(O,E){return!(O.id===E.id||I(E)&&I(O))}switchData(O,E,i){this.withPausedEmitters(()=>{const l=new Set;for(const[r,n]of O)l.add(r),E.get(r)!==n&&this.emitDidChangeValue(i,{key:r,external:!0});for(const[r]of E.items)l.has(r)||this.emitDidChangeValue(i,{key:r,external:!0})})}}e.AbstractStorageService=v;function I(d){return d.isDefault||!!d.useDefaultFlags?.globalState}class w extends v{constructor(){super(),this.applicationStorage=this._register(new D.Storage(new D.InMemoryStorageDatabase,{hint:D.StorageHint.STORAGE_IN_MEMORY})),this.profileStorage=this._register(new D.Storage(new D.InMemoryStorageDatabase,{hint:D.StorageHint.STORAGE_IN_MEMORY})),this.workspaceStorage=this._register(new D.Storage(new D.InMemoryStorageDatabase,{hint:D.StorageHint.STORAGE_IN_MEMORY})),this._register(this.workspaceStorage.onDidChangeStorage(O=>this.emitDidChangeValue(h.WORKSPACE,O))),this._register(this.profileStorage.onDidChangeStorage(O=>this.emitDidChangeValue(h.PROFILE,O))),this._register(this.applicationStorage.onDidChangeStorage(O=>this.emitDidChangeValue(h.APPLICATION,O)))}getStorage(O){switch(O){case h.APPLICATION:return this.applicationStorage;case h.PROFILE:return this.profileStorage;default:return this.workspaceStorage}}getLogDetails(O){switch(O){case h.APPLICATION:return"inMemory (application)";case h.PROFILE:return"inMemory (profile)";default:return"inMemory (workspace)"}}async doInitialize(){}async switchToProfile(){}async switchToWorkspace(){}shouldFlushWhenIdle(){return!1}hasScope(O){return!1}}e.InMemoryStorageService=w;async function y(d,O,E,i,l,r){const n=L=>{try{return JSON.parse(L)}catch{return L}},t=new Map,s=new Map;d.forEach((L,M)=>{t.set(M,L),s.set(M,n(L))});const o=new Map,c=new Map;O.forEach((L,M)=>{o.set(M,L),c.set(M,n(L))});const g=new Map,T=new Map;E.forEach((L,M)=>{g.set(M,L),T.set(M,n(L))}),console.group(i!==l?`Storage: Application (path: ${i})`:`Storage: Application & Profile (path: ${i}, default profile)`);const N=[];if(t.forEach((L,M)=>{N.push({key:M,value:L})}),console.table(N),console.groupEnd(),console.log(s),i!==l){console.group(`Storage: Profile (path: ${l}, profile specific)`);const L=[];o.forEach((M,B)=>{L.push({key:B,value:M})}),console.table(L),console.groupEnd(),console.log(c)}console.group(`Storage: Workspace (path: ${r})`);const A=[];g.forEach((L,M)=>{A.push({key:M,value:L})}),console.table(A),console.groupEnd(),console.log(T)}}),define(ce[142],de([0,1,13,28,74]),function(J,e,b,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=R;async function R(k,D,p){let u=p&&p.get("storage.serviceMachineId",S.StorageScope.APPLICATION)||null;if(u)return u;try{const h=(await D.readFile(k.serviceMachineIdResource)).value.toString();u=(0,C.isUUID)(h)?h:null}catch{u=null}if(!u){u=(0,C.generateUuid)();try{await D.writeFile(k.serviceMachineIdResource,b.VSBuffer.fromString(u))}catch{}}return p?.store("storage.serviceMachineId",u,S.StorageScope.APPLICATION,S.StorageTarget.MACHINE),u}}),define(ce[143],de([0,1,142,18,41]),function(J,e,b,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=R;async function R(k,D,p,u,f,h,m){const a={"X-Market-Client-Id":`VSCode ${k}`,"User-Agent":`VSCode ${k} (${D.nameShort})`};if((0,S.supportsTelemetry)(D,p)&&(0,S.getTelemetryLevel)(u)===C.TelemetryLevel.USAGE){const v=await(0,b.getServiceMachineId)(p,f,h);a["X-Market-User-Id"]=v,a["VSCode-SessionId"]=m.machineId||v}return a}}),define(ce[144],de([0,1,19,21,7,11,36,3,12,83,30,17,20,26,22,44,9,6,33,46,143,74,18,156]),function(J,e,b,C,S,R,k,D,p,u,f,h,m,a,v,I,w,y,d,O,E,i,l,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGalleryServiceWithNoStorageService=e.ExtensionGalleryService=void 0,e.sortExtensionVersions=j;const n=R.isWeb?v.TargetPlatform.WEB:(0,m.getTargetPlatform)(R.platform,k.arch),t="X-Market-Search-Activity-Id";var s;(function(G){G[G.None=0]="None",G[G.IncludeVersions=1]="IncludeVersions",G[G.IncludeFiles=2]="IncludeFiles",G[G.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",G[G.IncludeSharedAccounts=8]="IncludeSharedAccounts",G[G.IncludeVersionProperties=16]="IncludeVersionProperties",G[G.ExcludeNonValidated=32]="ExcludeNonValidated",G[G.IncludeInstallationTargets=64]="IncludeInstallationTargets",G[G.IncludeAssetUri=128]="IncludeAssetUri",G[G.IncludeStatistics=256]="IncludeStatistics",G[G.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",G[G.Unpublished=4096]="Unpublished",G[G.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(s||(s={}));function o(...G){return String(G.reduce((U,H)=>U|H,0))}var c;(function(G){G[G.Tag=1]="Tag",G[G.ExtensionId=4]="ExtensionId",G[G.Category=5]="Category",G[G.ExtensionName=7]="ExtensionName",G[G.Target=8]="Target",G[G.Featured=9]="Featured",G[G.SearchText=10]="SearchText",G[G.ExcludeWithFlags=12]="ExcludeWithFlags"})(c||(c={}));const g={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},T={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",EnabledApiProposals:"Microsoft.VisualStudio.Code.EnabledApiProposals",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink",SupportLink:"Microsoft.VisualStudio.Services.Links.Support",ExecutesCode:"Microsoft.VisualStudio.Code.ExecutesCode"},A={pageNumber:1,pageSize:10,sortBy:m.SortBy.NoneOrRelevance,sortOrder:m.SortOrder.Default,flags:s.None,criteria:[],assetTypes:[]};class L{constructor(U=A){this.state=U}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}get criteria(){return this.state.criteria}withPage(U,H=this.state.pageSize){return new L({...this.state,pageNumber:U,pageSize:H})}withFilter(U,...H){const se=[...this.state.criteria,...H.length?H.map(le=>({filterType:U,value:le})):[{filterType:U}]];return new L({...this.state,criteria:se})}withSortBy(U){return new L({...this.state,sortBy:U})}withSortOrder(U){return new L({...this.state,sortOrder:U})}withFlags(...U){return new L({...this.state,flags:U.reduce((H,se)=>H|se,0)})}withAssetTypes(...U){return new L({...this.state,assetTypes:U})}withSource(U){return new L({...this.state,source:U})}get raw(){const{criteria:U,pageNumber:H,pageSize:se,sortBy:le,sortOrder:he,flags:Se,assetTypes:fe}=this.state;return{filters:[{criteria:U,pageNumber:H,pageSize:se,sortBy:le,sortOrder:he}],assetTypes:fe,flags:Se}}get searchText(){const U=this.state.criteria.filter(H=>H.filterType===c.SearchText)[0];return U&&U.value?U.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(U=>String(U.filterType)),flags:this.state.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.state.source,searchTextLength:this.searchText.length}}}function M(G,U){const H=(G||[]).filter(se=>se.statisticName===U)[0];return H?H.value:0}function B(G){const U="Microsoft.VisualStudio.Code.Translation.";return G.files.filter(se=>se.assetType.indexOf(U)===0).reduce((se,le)=>{const he=ae(G,le.assetType);return he&&se.push([le.assetType.substring(U.length),he]),se},[])}function Q(G){if(G.properties){const U=G.properties.filter(le=>le.key===g.Repository),H=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),se=U.filter(le=>H.test(le.value))[0];return se?{uri:se.value,fallbackUri:se.value}:null}return ae(G,g.Repository)}function re(G){return{uri:`${G.fallbackAssetUri}/${g.VSIX}?redirect=true${G.targetPlatform?`&targetPlatform=${G.targetPlatform}`:""}`,fallbackUri:`${G.fallbackAssetUri}/${g.VSIX}${G.targetPlatform?`?targetPlatform=${G.targetPlatform}`:""}`}}function ae(G,U){return G.files.filter(se=>se.assetType===U)[0]?{uri:`${G.assetUri}/${U}${G.targetPlatform?`?targetPlatform=${G.targetPlatform}`:""}`,fallbackUri:`${G.fallbackAssetUri}/${U}${G.targetPlatform?`?targetPlatform=${G.targetPlatform}`:""}`}:null}function ue(G,U){const H=G.properties?G.properties.filter(le=>le.key===U):[],se=H.length>0&&H[0].value;return se?se.split(",").map(le=>(0,a.adoptToGalleryExtensionId)(le)):[]}function pe(G){const U=G.properties?G.properties.filter(H=>H.key===T.Engine):[];return U.length>0&&U[0].value||""}function $(G){const U=G.properties?G.properties.filter(H=>H.key===T.PreRelease):[];return U.length>0&&U[0].value==="true"}function Z(G){const U=G.properties?G.properties.filter(H=>H.key===T.ExecutesCode):[];return U.length>0?U[0].value==="true":void 0}function _(G){const U=G.properties?G.properties.filter(se=>se.key===T.EnabledApiProposals):[],H=U.length>0&&U[0].value||"";return H?H.split(","):[]}function W(G){const U=G.properties?G.properties.filter(se=>se.key===T.LocalizedLanguages):[],H=U.length>0&&U[0].value||"";return H?H.split(","):[]}function q(G){return G.properties?.find(U=>U.key===T.SponsorLink)?.value}function K(G){return G.properties?.find(U=>U.key===T.SupportLink)?.value}function ie(G){return G.indexOf("preview")!==-1}function ne(G){return G.targetPlatform?(0,m.toTargetPlatform)(G.targetPlatform):v.TargetPlatform.UNDEFINED}function F(G){const U=(0,b.distinct)(G.versions.map(ne)),H=!!G.tags?.includes(m.WEB_EXTENSION_TAG),se=U.indexOf(v.TargetPlatform.WEB);return H?se===-1&&U.push(v.TargetPlatform.WEB):se!==-1&&U.splice(se,1),U}function j(G,U){for(let H=0;H<G.length;H++){const se=G[H];if(se.version===G[H-1]?.version){let le=H;if(ne(se)===U)for(;le>0&&G[le-1].version===se.version;)le--;le!==H&&(G.splice(H,1),G.splice(le,0,se))}}return G}function V(G,U,H){G.telemetryData={index:U,querySource:H,queryActivityId:G.queryContext?.[t]}}function P(G,U,H,se){const le=G.versions[0],he={manifest:ae(U,g.Manifest),readme:ae(U,g.Details),changelog:ae(U,g.Changelog),license:ae(U,g.License),repository:Q(U),download:re(U),icon:ae(U,g.Icon),signature:ae(U,g.Signature),coreTranslations:B(U)};return{type:"gallery",identifier:{id:(0,a.getGalleryExtensionId)(G.publisher.publisherName,G.extensionName),uuid:G.extensionId},name:G.extensionName,version:U.version,displayName:G.displayName,publisherId:G.publisher.publisherId,publisher:G.publisher.publisherName,publisherDisplayName:G.publisher.displayName,publisherDomain:G.publisher.domain?{link:G.publisher.domain,verified:!!G.publisher.isDomainVerified}:void 0,publisherSponsorLink:q(le),description:G.shortDescription??"",installCount:M(G.statistics,"install"),rating:M(G.statistics,"averagerating"),ratingCount:M(G.statistics,"ratingcount"),categories:G.categories||[],tags:G.tags||[],releaseDate:Date.parse(G.releaseDate),lastUpdated:Date.parse(G.lastUpdated),allTargetPlatforms:H,assets:he,properties:{dependencies:ue(U,T.Dependency),extensionPack:ue(U,T.ExtensionPack),engine:pe(U),enabledApiProposals:_(U),localizedLanguages:W(U),targetPlatform:ne(U),isPreReleaseVersion:$(U),executesCode:Z(U)},hasPreReleaseVersion:$(le),hasReleaseVersion:!0,preview:ie(G.flags),isSigned:!!he.signature,queryContext:se,supportLink:K(le)}}let x=class{constructor(U,H,se,le,he,Se,fe,ge){this.requestService=H,this.logService=se,this.environmentService=le,this.telemetryService=he,this.fileService=Se,this.productService=fe,this.configurationService=ge;const me=fe.extensionsGallery,Ee=me?.servicePPEUrl&&ge.getValue("_extensionsGallery.enablePPE");this.extensionsGalleryUrl=Ee?me.servicePPEUrl:me?.serviceUrl,this.extensionsGallerySearchUrl=Ee?void 0:me?.searchUrl,this.extensionsControlUrl=me?.controlUrl,this.extensionsEnabledWithApiProposalVersion=fe.extensionsEnabledWithApiProposalVersion?.map(ye=>ye.toLowerCase())??[],this.commonHeadersPromise=(0,E.resolveMarketplaceHeaders)(fe.version,fe,this.environmentService,this.configurationService,this.fileService,U,this.telemetryService)}api(U=""){return`${this.extensionsGalleryUrl}${U}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(U,H,se){const le=C.CancellationToken.isCancellationToken(H)?{}:H,he=C.CancellationToken.isCancellationToken(H)?H:se,Se=await this.doGetExtensions(U,le,he),fe=Se.map(me=>me.identifier.uuid),ge=[];for(const me of U)me.uuid&&!fe.includes(me.uuid)&&ge.push({...me,uuid:void 0});if(ge.length){this.telemetryService.publicLog2("galleryService:additionalQueryByName",{count:ge.length});const me=await this.doGetExtensions(ge,le,he);Se.push(...me)}return Se}async doGetExtensions(U,H,se){const le=[],he=[],Se=[],fe=[];let ge=!0;for(const ye of U){ye.uuid?he.push(ye.uuid):le.push(ye.id);const z=!!(ye.version||ye.preRelease);Se.push({id:ye.id,uuid:ye.uuid,includePreRelease:z}),ye.version&&fe.push({id:ye.id,uuid:ye.uuid,version:ye.version}),ge=ge&&!!ye.hasPreRelease&&!z}if(!he.length&&!le.length)return[];let me=new L().withPage(1,U.length);he.length&&(me=me.withFilter(c.ExtensionId,...he)),le.length&&(me=me.withFilter(c.ExtensionName,...le)),(H.queryAllVersions||ge)&&(me=me.withFlags(me.flags,s.IncludeVersions)),H.source&&(me=me.withSource(H.source));const{extensions:Ee}=await this.queryGalleryExtensions(me,{targetPlatform:H.targetPlatform??n,includePreRelease:Se,versions:fe,compatible:!!H.compatible,productVersion:H.productVersion??{version:this.productService.version,date:this.productService.date}},se);return H.source&&Ee.forEach((ye,z)=>V(ye,z,H.source)),Ee}async getCompatibleExtension(U,H,se,le={version:this.productService.version,date:this.productService.date}){if((0,m.isNotWebExtensionInWebTargetPlatform)(U.allTargetPlatforms,se))return null;if(await this.isExtensionCompatible(U,H,se))return U;const he=new L().withFlags(s.IncludeVersions).withPage(1,1).withFilter(c.ExtensionId,U.identifier.uuid),{extensions:Se}=await this.queryGalleryExtensions(he,{targetPlatform:se,compatible:!0,includePreRelease:H,productVersion:le},C.CancellationToken.None);return Se[0]||null}async isExtensionCompatible(U,H,se,le={version:this.productService.version,date:this.productService.date}){if(!(0,m.isTargetPlatformCompatible)(U.properties.targetPlatform,U.allTargetPlatforms,se)||!H&&U.properties.isPreReleaseVersion)return!1;let he=U.properties.engine;if(!he){const Se=await this.getManifest(U,C.CancellationToken.None);if(!Se)throw new Error("Manifest was not found");he=Se.engines.vscode}return!(!(0,I.isEngineValid)(he,le.version,le.date)||!this.areApiProposalsCompatible(U.identifier,U.properties.enabledApiProposals))}areApiProposalsCompatible(U,H){return!H||!this.extensionsEnabledWithApiProposalVersion.includes(U.id.toLowerCase())?!0:(0,I.areApiProposalsCompatible)(H)}async isValidVersion(U,H,se,le,he,Se,fe={version:this.productService.version,date:this.productService.date}){if(!(0,m.isTargetPlatformCompatible)(ne(H),he,Se)||se!=="any"&&$(H)!==(se==="prerelease"))return!1;if(le)try{const ge=await this.getEngine(U,H);if(!(0,I.isEngineValid)(ge,fe.version,fe.date))return!1}catch(ge){return this.logService.error(`Error while getting the engine for the version ${H.version}.`,(0,S.getErrorMessage)(ge)),!1}return!0}async query(U,H){let se=U.text||"";const le=U.pageSize??50;let he=new L().withPage(1,le);se?(se=se.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(Ee,ye,z)=>(he=he.withFilter(c.Category,z||ye),"")),se=se.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(Ee,ye,z)=>(he=he.withFilter(c.Tag,z||ye),"")),se=se.replace(/\bfeatured(\s+|\b|$)/g,()=>(he=he.withFilter(c.Featured),"")),se=se.trim(),se&&(se=se.length<200?se:se.substring(0,200),he=he.withFilter(c.SearchText,se)),he=he.withSortBy(m.SortBy.NoneOrRelevance)):U.ids?he=he.withFilter(c.ExtensionId,...U.ids):U.names?he=he.withFilter(c.ExtensionName,...U.names):he=he.withSortBy(m.SortBy.InstallCount),typeof U.sortBy=="number"&&(he=he.withSortBy(U.sortBy)),typeof U.sortOrder=="number"&&(he=he.withSortOrder(U.sortOrder)),U.source&&(he=he.withSource(U.source));const Se=async(Ee,ye)=>{const{extensions:z,total:ee}=await this.queryGalleryExtensions(Ee,{targetPlatform:n,compatible:!1,includePreRelease:!!U.includePreRelease,productVersion:U.productVersion??{version:this.productService.version,date:this.productService.date}},ye);return z.forEach((te,ve)=>V(te,(Ee.pageNumber-1)*Ee.pageSize+ve,U.source)),{extensions:z,total:ee}},{extensions:fe,total:ge}=await Se(he,H),me=async(Ee,ye)=>{if(ye.isCancellationRequested)throw new S.CancellationError;const{extensions:z}=await Se(he.withPage(Ee+1),ye);return z};return{firstPage:fe,total:ge,pageSize:he.pageSize,getPage:me}}async queryGalleryExtensions(U,H,se){const le=U.flags;U.flags&s.IncludeLatestVersionOnly&&U.flags&s.IncludeVersions&&(U=U.withFlags(U.flags&~s.IncludeVersions,s.IncludeLatestVersionOnly)),!(U.flags&s.IncludeLatestVersionOnly)&&!(U.flags&s.IncludeVersions)&&(U=U.withFlags(U.flags,s.IncludeLatestVersionOnly)),H.versions?.length&&(U=U.withFlags(U.flags&~s.IncludeLatestVersionOnly,s.IncludeVersions)),U=U.withFlags(U.flags,s.IncludeAssetUri,s.IncludeCategoryAndTags,s.IncludeFiles,s.IncludeStatistics,s.IncludeVersionProperties);const{galleryExtensions:he,total:Se,context:fe}=await this.queryRawGalleryExtensions(U,se);if(!(U.flags&s.IncludeLatestVersionOnly)){const ye=[];for(const z of he){const ee=await this.toGalleryExtensionWithCriteria(z,H,fe);ee&&ye.push(ee)}return{extensions:ye,total:Se}}const me=[],Ee=new Map;for(let ye=0;ye<he.length;ye++){const z=he[ye],ee={id:(0,a.getGalleryExtensionId)(z.publisher.publisherName,z.extensionName),uuid:z.extensionId},te=(0,D.isBoolean)(H.includePreRelease)?H.includePreRelease:!!H.includePreRelease.find(Ie=>(0,a.areSameExtensions)(Ie,ee))?.includePreRelease;if(H.compatible&&(0,m.isNotWebExtensionInWebTargetPlatform)(F(z),H.targetPlatform))continue;const ve=await this.toGalleryExtensionWithCriteria(z,H,fe);!ve||ve.properties.isPreReleaseVersion&&(!te||!ve.hasReleaseVersion)||!ve.properties.isPreReleaseVersion&&ve.properties.targetPlatform!==H.targetPlatform&&ve.hasPreReleaseVersion?Ee.set(z.extensionId,ye):me.push([ye,ve])}if(Ee.size){const ye=new r.StopWatch,z=new L().withFlags(le&~s.IncludeLatestVersionOnly,s.IncludeVersions).withPage(1,Ee.size).withFilter(c.ExtensionId,...Ee.keys()),{extensions:ee}=await this.queryGalleryExtensions(z,H,se);this.telemetryService.publicLog2("galleryService:additionalQuery",{duration:ye.elapsed(),count:Ee.size});for(const te of ee){const ve=Ee.get(te.identifier.uuid);me.push([ve,te])}}return{extensions:me.sort((ye,z)=>ye[0]-z[0]).map(([,ye])=>ye),total:Se}}async toGalleryExtensionWithCriteria(U,H,se){const le={id:(0,a.getGalleryExtensionId)(U.publisher.publisherName,U.extensionName),uuid:U.extensionId},he=H.versions?.find(me=>(0,a.areSameExtensions)(me,le))?.version,Se=(0,D.isBoolean)(H.includePreRelease)?H.includePreRelease:!!H.includePreRelease.find(me=>(0,a.areSameExtensions)(me,le))?.includePreRelease,fe=F(U),ge=j(U.versions,H.targetPlatform);if(H.compatible&&(0,m.isNotWebExtensionInWebTargetPlatform)(fe,H.targetPlatform))return null;for(let me=0;me<ge.length;me++){const Ee=ge[me];if(!(he&&Ee.version!==he)){if(await this.isValidVersion(le.id,Ee,Se?"any":"release",H.compatible,fe,H.targetPlatform,H.productVersion)){if(H.compatible&&!this.areApiProposalsCompatible(le,_(Ee)))continue;return P(U,Ee,fe,se)}if(he&&Ee.version===he)return null}}return he||H.compatible?null:P(U,U.versions[0],fe)}async queryRawGalleryExtensions(U,H){if(!this.isEnabled())throw new Error("No extension gallery service configured.");U=U.withFlags(U.flags,s.ExcludeNonValidated).withFilter(c.Target,"Microsoft.VisualStudio.Code").withFilter(c.ExcludeWithFlags,o(s.Unpublished));const se=await this.commonHeadersPromise,le=JSON.stringify(U.raw),he={...se,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(le.length)},Se=new r.StopWatch;let fe,ge,me=0;try{if(fe=await this.requestService.request({type:"POST",url:this.extensionsGallerySearchUrl&&U.criteria.some(ye=>ye.filterType===c.SearchText)?this.extensionsGallerySearchUrl:this.api("/extensionquery"),data:le,headers:he},H),fe.res.statusCode&&fe.res.statusCode>=400&&fe.res.statusCode<500)return{galleryExtensions:[],total:me};const Ee=await(0,O.asJson)(fe);if(Ee){const ye=Ee.results[0],z=ye.extensions,ee=ye.resultMetadata&&ye.resultMetadata.filter(te=>te.metadataType==="ResultCount")[0];return me=ee&&ee.metadataItems.filter(te=>te.name==="TotalCount")[0].count||0,{galleryExtensions:z,total:me,context:fe.res.headers.activityid?{[t]:fe.res.headers.activityid}:{}}}return{galleryExtensions:[],total:me}}catch(Ee){if((0,S.isCancellationError)(Ee))throw ge=m.ExtensionGalleryErrorCode.Cancelled,Ee;{const ye=(0,S.getErrorMessage)(Ee);throw ge=(0,u.isOfflineError)(Ee)?m.ExtensionGalleryErrorCode.Offline:ye.startsWith("XHR timeout")?m.ExtensionGalleryErrorCode.Timeout:m.ExtensionGalleryErrorCode.Failed,new m.ExtensionGalleryError(ye,ge)}}finally{this.telemetryService.publicLog2("galleryService:query",{...U.telemetryData,requestBodySize:String(le.length),duration:Se.elapsed(),success:!!fe&&(0,O.isSuccess)(fe),responseBodySize:fe?.res.headers["Content-Length"],statusCode:fe?String(fe.res.statusCode):void 0,errorCode:ge,count:String(me)})}}async reportStatistic(U,H,se,le){if(!this.isEnabled())return;const he=R.isWeb?this.api(`/itemName/${U}.${H}/version/${se}/statType/${le===m.StatisticType.Install?"1":"3"}/vscodewebextension`):this.api(`/publishers/${U}/extensions/${H}/${se}/stats?statType=${le}`),Se=R.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",ge={...await this.commonHeadersPromise,Accept:Se};try{await this.requestService.request({type:"POST",url:he,headers:ge},C.CancellationToken.None)}catch{}}async download(U,H,se){this.logService.trace("ExtensionGalleryService#download",U.identifier.id);const le=(0,a.getGalleryExtensionTelemetryData)(U),he=new Date().getTime(),Se=se===m.InstallOperation.Install?"install":se===m.InstallOperation.Update?"update":"",fe=Se?{uri:`${U.assets.download.uri}${p.URI.parse(U.assets.download.uri).query?"&":"?"}${Se}=true`,fallbackUri:`${U.assets.download.fallbackUri}${p.URI.parse(U.assets.download.fallbackUri).query?"&":"?"}${Se}=true`}:U.assets.download,ge=U.queryContext?.[t]?{[t]:U.queryContext[t]}:void 0,me=await this.getAsset(U.identifier.id,fe,g.VSIX,ge?{headers:ge}:void 0);try{await this.fileService.writeFile(H,me.stream)}catch(Ee){try{await this.fileService.del(H)}catch(ye){this.logService.warn(`Error while deleting the file ${H.toString()}`,(0,S.getErrorMessage)(ye))}throw new m.ExtensionGalleryError((0,S.getErrorMessage)(Ee),m.ExtensionGalleryErrorCode.DownloadFailedWriting)}this.telemetryService.publicLog("galleryService:downloadVSIX",{...le,duration:new Date().getTime()-he})}async downloadSignatureArchive(U,H){if(!U.assets.signature)throw new Error("No signature asset found");this.logService.trace("ExtensionGalleryService#downloadSignatureArchive",U.identifier.id);const se=await this.getAsset(U.identifier.id,U.assets.signature,g.Signature);try{await this.fileService.writeFile(H,se.stream)}catch(le){try{await this.fileService.del(H)}catch(he){this.logService.warn(`Error while deleting the file ${H.toString()}`,(0,S.getErrorMessage)(he))}throw new m.ExtensionGalleryError((0,S.getErrorMessage)(le),m.ExtensionGalleryErrorCode.DownloadFailedWriting)}}async getReadme(U,H){if(U.assets.readme){const se=await this.getAsset(U.identifier.id,U.assets.readme,g.Details,{},H);return await(0,O.asTextOrError)(se)||""}return""}async getManifest(U,H){if(U.assets.manifest){const se=await this.getAsset(U.identifier.id,U.assets.manifest,g.Manifest,{},H),le=await(0,O.asTextOrError)(se);return le?JSON.parse(le):null}return null}async getManifestFromRawExtensionVersion(U,H,se){const le=ae(H,g.Manifest);if(!le)throw new Error("Manifest was not found");const he={"Accept-Encoding":"gzip"},Se=await this.getAsset(U,le,g.Manifest,{headers:he});return await(0,O.asJson)(Se)}async getCoreTranslation(U,H){const se=U.assets.coreTranslations.filter(le=>le[0]===H.toUpperCase())[0];if(se){const le=await this.getAsset(U.identifier.id,se[1],se[0]),he=await(0,O.asTextOrError)(le);return he?JSON.parse(he):null}return null}async getChangelog(U,H){if(U.assets.changelog){const se=await this.getAsset(U.identifier.id,U.assets.changelog,g.Changelog,{},H);return await(0,O.asTextOrError)(se)||""}return""}async getAllCompatibleVersions(U,H,se){let le=new L().withFlags(s.IncludeVersions,s.IncludeCategoryAndTags,s.IncludeFiles,s.IncludeVersionProperties).withPage(1,1);U.uuid?le=le.withFilter(c.ExtensionId,U.uuid):le=le.withFilter(c.ExtensionName,U.id);const{galleryExtensions:he}=await this.queryRawGalleryExtensions(le,C.CancellationToken.None);if(!he.length)return[];const Se=F(he[0]);if((0,m.isNotWebExtensionInWebTargetPlatform)(Se,se))return[];const fe=[];await Promise.all(he[0].versions.map(async Ee=>{try{await this.isValidVersion(U.id,Ee,H?"any":"release",!0,Se,se)&&this.areApiProposalsCompatible(U,_(Ee))&&fe.push(Ee)}catch{}}));const ge=[],me=new Set;for(const Ee of j(fe,se))me.has(Ee.version)||(me.add(Ee.version),ge.push({version:Ee.version,date:Ee.lastUpdated,isPreReleaseVersion:$(Ee)}));return ge}async getAsset(U,H,se,le={},he=C.CancellationToken.None){const Se=await this.commonHeadersPromise,fe={type:"GET"},ge={...Se,...le.headers||{}};le={...le,...fe,headers:ge};const me=H.uri,Ee=H.fallbackUri,ye={...le,url:me};try{const z=await this.requestService.request(ye,he);if(z.res.statusCode===200)return z;const ee=await(0,O.asTextOrError)(z);throw new Error(`Expected 200, got back ${z.res.statusCode} instead.

${ee}`)}catch(z){if((0,S.isCancellationError)(z))throw z;const ee=(0,S.getErrorMessage)(z);this.telemetryService.publicLog2("galleryService:cdnFallback",{extension:U,assetType:se,message:ee});const te={...le,url:Ee};return this.requestService.request(te,he)}}async getEngine(U,H){let se=pe(H);if(!se){this.telemetryService.publicLog2("galleryService:engineFallback",{extension:U,version:H.version});const le=await this.getManifestFromRawExtensionVersion(U,H,C.CancellationToken.None);if(!le)throw new Error("Manifest was not found");se=le.engines.vscode}return se}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return{malicious:[],deprecated:{},search:[]};const U=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},C.CancellationToken.None);if(U.res.statusCode!==200)throw new Error("Could not get extensions report.");const H=await(0,O.asJson)(U),se=[],le={},he=[],Se=[];if(H){for(const fe of H.malicious)se.push({id:fe});if(H.migrateToPreRelease)for(const[fe,ge]of Object.entries(H.migrateToPreRelease))(!ge.engine||(0,I.isEngineValid)(ge.engine,this.productService.version,this.productService.date))&&(le[fe.toLowerCase()]={disallowInstall:!0,extension:{id:ge.id,displayName:ge.displayName,autoMigrate:{storage:!!ge.migrateStorage},preRelease:!0}});if(H.deprecated)for(const[fe,ge]of Object.entries(H.deprecated))ge&&(le[fe.toLowerCase()]=(0,D.isBoolean)(ge)?{}:ge);if(H.search)for(const fe of H.search)he.push(fe);if(Array.isArray(H.extensionsEnabledWithPreRelease))for(const fe of H.extensionsEnabledWithPreRelease)Se.push(fe.toLowerCase())}return{malicious:se,deprecated:le,search:he,extensionsEnabledWithPreRelease:Se}}};x=Pe([oe(1,O.IRequestService),oe(2,y.ILogService),oe(3,h.IEnvironmentService),oe(4,l.ITelemetryService),oe(5,w.IFileService),oe(6,d.IProductService),oe(7,f.IConfigurationService)],x);let X=class extends x{constructor(U,H,se,le,he,Se,fe,ge){super(U,H,se,le,he,Se,fe,ge)}};e.ExtensionGalleryService=X,e.ExtensionGalleryService=X=Pe([oe(0,i.IStorageService),oe(1,O.IRequestService),oe(2,y.ILogService),oe(3,h.IEnvironmentService),oe(4,l.ITelemetryService),oe(5,w.IFileService),oe(6,d.IProductService),oe(7,f.IConfigurationService)],X);let Y=class extends x{constructor(U,H,se,le,he,Se,fe){super(void 0,U,H,se,le,he,Se,fe)}};e.ExtensionGalleryServiceWithNoStorageService=Y,e.ExtensionGalleryServiceWithNoStorageService=Y=Pe([oe(0,O.IRequestService),oe(1,y.ILogService),oe(2,h.IEnvironmentService),oe(3,l.ITelemetryService),oe(4,w.IFileService),oe(5,d.IProductService),oe(6,f.IConfigurationService)],Y)}),define(ce[145],de([0,1,12,17,9,6,124,23,24,3,70]),function(J,e,b,C,S,R,k,D,p,u,f){"use strict";var h,m;Object.defineProperty(e,"__esModule",{value:!0}),e.ServerUserDataProfilesService=e.UserDataProfilesService=e.UserDataProfilesReadonlyService=void 0;let a=class extends p.UserDataProfilesService{static{h=this}static{this.PROFILE_ASSOCIATIONS_MIGRATION_KEY="profileAssociationsMigration"}constructor(y,d,O,E,i){super(O,E,d,i),this.stateReadonlyService=y,this.nativeEnvironmentService=O}getStoredProfiles(){return this.stateReadonlyService.getItem(h.PROFILES_KEY,[]).map(d=>({...d,location:(0,u.isString)(d.location)?this.uriIdentityService.extUri.joinPath(this.profilesHome,d.location):b.URI.revive(d.location)}))}getStoredProfileAssociations(){const y=this.stateReadonlyService.getItem(h.PROFILE_ASSOCIATIONS_KEY,{});return this.stateReadonlyService.getItem(h.PROFILE_ASSOCIATIONS_MIGRATION_KEY,!1)?y:this.migrateStoredProfileAssociations(y)}getDefaultProfileExtensionsLocation(){return this.uriIdentityService.extUri.joinPath(b.URI.file(this.nativeEnvironmentService.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};e.UserDataProfilesReadonlyService=a,e.UserDataProfilesReadonlyService=a=h=Pe([oe(0,k.IStateReadService),oe(1,D.IUriIdentityService),oe(2,C.INativeEnvironmentService),oe(3,S.IFileService),oe(4,R.ILogService)],a);let v=m=class extends a{constructor(y,d,O,E,i){super(y,d,O,E,i),this.stateService=y}saveStoredProfiles(y){y.length?this.stateService.setItem(m.PROFILES_KEY,y.map(d=>({...d,location:this.uriIdentityService.extUri.basename(d.location)}))):this.stateService.removeItem(m.PROFILES_KEY)}getStoredProfiles(){const y=super.getStoredProfiles();return this.stateService.getItem("userDataProfilesMigration",!1)||(this.saveStoredProfiles(y),this.stateService.setItem("userDataProfilesMigration",!0)),y}saveStoredProfileAssociations(y){y.emptyWindows||y.workspaces?this.stateService.setItem(m.PROFILE_ASSOCIATIONS_KEY,y):this.stateService.removeItem(m.PROFILE_ASSOCIATIONS_KEY)}getStoredProfileAssociations(){const y="workspaceAndProfileInfo",d=this.stateService.getItem(y,void 0);if(d){this.stateService.removeItem(y);const E=d.reduce((i,{workspace:l,profile:r})=>(i[b.URI.revive(l).toString()]=b.URI.revive(r).toString(),i),{});this.stateService.setItem(m.PROFILE_ASSOCIATIONS_KEY,{workspaces:E})}const O=super.getStoredProfileAssociations();return this.stateService.getItem(m.PROFILE_ASSOCIATIONS_MIGRATION_KEY,!1)||(this.saveStoredProfileAssociations(O),this.stateService.setItem(m.PROFILE_ASSOCIATIONS_MIGRATION_KEY,!0)),O}};e.UserDataProfilesService=v,e.UserDataProfilesService=v=m=Pe([oe(0,k.IStateService),oe(1,D.IUriIdentityService),oe(2,C.INativeEnvironmentService),oe(3,S.IFileService),oe(4,R.ILogService)],v);let I=class extends v{constructor(y,d,O,E){super(new f.StateService(f.SaveStrategy.IMMEDIATE,d,E,O),y,d,O,E)}async init(){return await this.stateService.init(),super.init()}};e.ServerUserDataProfilesService=I,e.ServerUserDataProfilesService=I=Pe([oe(0,D.IUriIdentityService),oe(1,C.INativeEnvironmentService),oe(2,S.IFileService),oe(3,R.ILogService)],I)}),define(ce[146],de([0,1,122,8,13,7,3,30,17,123,6,46,121,157]),function(J,e,b,C,S,R,k,D,p,u,f,h,m,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0,e.nodeRequest=w;let v=class extends h.AbstractRequestService{constructor(d,O,E,i){super(i),this.configurationService=d,this.environmentService=O,this.logService=E,this.configure(),this._register(d.onDidChangeConfiguration(l=>{l.affectsConfiguration("http")&&this.configure()}))}configure(){const d=this.configurationService.getValue("http");this.proxyUrl=d?.proxy,this.strictSSL=!!d?.proxyStrictSSL,this.authorization=d?.proxyAuthorization}async request(d,O){const{proxyUrl:E,strictSSL:i}=this;let l;try{l=await(0,u.getResolvedShellEnv)(this.configurationService,this.logService,this.environmentService.args,process.env)}catch(t){this.shellEnvErrorLogged||(this.shellEnvErrorLogged=!0,this.logService.error("resolving shell environment failed",(0,R.getErrorMessage)(t)))}const r={...process.env,...l},n=d.agent?d.agent:await(0,m.getProxyAgent)(d.url||"",r,{proxyUrl:E,strictSSL:i});return d.agent=n,d.strictSSL=i,this.authorization&&(d.headers={...d.headers||{},"Proxy-Authorization":this.authorization}),this.logAndRequest(d.isChromiumNetwork?"electron":"node",d,()=>w(d,O))}async resolveProxy(d){}async lookupAuthorization(d){}async lookupKerberosAuthorization(d){try{const O=await new Promise((n,t)=>{J(["kerberos"],n,t)}).then(we),E=new URL(d),i=this.configurationService.getValue("http.proxyKerberosServicePrincipal")||(process.platform==="win32"?`HTTP/${E.hostname}`:`HTTP@${E.hostname}`);return this.logService.debug("RequestService#lookupKerberosAuthorization Kerberos authentication lookup",`proxyURL:${E}`,`spn:${i}`),"Negotiate "+await(await O.initializeClient(i)).step("")}catch(O){this.logService.debug("RequestService#lookupKerberosAuthorization Kerberos authentication failed",O);return}}async loadCertificates(){return(await new Promise((O,E)=>{J(["@vscode/proxy-agent"],O,E)}).then(we)).loadSystemCertificates({log:this.logService})}};e.RequestService=v,e.RequestService=v=Pe([oe(0,D.IConfigurationService),oe(1,p.INativeEnvironmentService),oe(2,f.ILogService),oe(3,f.ILoggerService)],v);async function I(y){return((0,b.parse)(y.url).protocol==="https:"?await new Promise((E,i)=>{J(["https"],E,i)}).then(we):await new Promise((E,i)=>{J(["http"],E,i)}).then(we)).request}async function w(y,d){return C.Promises.withAsyncBody(async(O,E)=>{const i=(0,b.parse)(y.url),l=y.getRawRequest?y.getRawRequest(y):await I(y),r={hostname:i.hostname,port:i.port?parseInt(i.port):i.protocol==="https:"?443:80,protocol:i.protocol,path:i.path,method:y.type||"GET",headers:y.headers,agent:y.agent,rejectUnauthorized:(0,k.isBoolean)(y.strictSSL)?y.strictSSL:!0};y.user&&y.password&&(r.auth=y.user+":"+y.password);const n=l(r,t=>{const s=(0,k.isNumber)(y.followRedirects)?y.followRedirects:3;if(t.statusCode&&t.statusCode>=300&&t.statusCode<400&&s>0&&t.headers.location)w({...y,url:t.headers.location,followRedirects:s-1},d).then(O,E);else{let o=t;!y.isChromiumNetwork&&t.headers["content-encoding"]==="gzip"&&(o=t.pipe((0,a.createGunzip)())),O({res:t,stream:(0,S.streamToBufferReadableStream)(o)})}});n.on("error",E),y.timeout&&n.setTimeout(y.timeout),y.isChromiumNetwork&&n.removeHeader("Content-Length"),y.data&&typeof y.data=="string"&&n.write(y.data),n.end(),d.onCancellationRequested(()=>{n.abort(),E(new R.CancellationError)})})}});var Ve=this&&this.__importDefault||function(J){return J&&J.__esModule?J:{default:J}};define(ce[158],de([0,1,32,35,8,38,7,2,14,15,11,36,12,30,118,62,120,17,96,144,20,72,125,42,54,139,141,9,108,110,51,106,65,69,127,6,114,39,115,130,33,46,146,70,71,18,129,41,131,132,23,134,24,145,133,140,111,113,4,135,159]),function(J,e,b,C,S,R,k,D,p,u,f,h,m,a,v,I,w,y,d,O,E,i,l,r,n,t,s,o,c,g,T,N,A,L,M,B,Q,re,ae,ue,pe,$,Z,_,W,q,K,ie,ne,F,j,V,P,x,X,Y,G,U,H,se,le){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=Se,b=we(b),ue=Ve(ue);class he extends D.Disposable{constructor(ge){super(),this.argv=ge,this.registerListeners()}registerListeners(){process.once("exit",()=>this.dispose())}async run(){const[ge,me]=await this.initServices();return ge.invokeFunction(async Ee=>{const ye=Ee.get(B.ILogService),z=Ee.get(o.IFileService),ee=Ee.get(y.INativeEnvironmentService),te=Ee.get(P.IUserDataProfilesService);ye.info("CLI main",this.argv),this.registerErrorHandler(ye),await this.doRun(ee,z,te,ge),await Promise.all(me.map(ve=>{(0,S.raceTimeout)(ve.flush(),1e3)}))})}async initServices(){const ge=new A.ServiceCollection,me={_serviceBrand:void 0,...ue.default};ge.set(pe.IProductService,me);const Ee=new d.NativeEnvironmentService(this.argv,me);ge.set(y.INativeEnvironmentService,Ee),await Promise.all([this.allowWindowsUNCPath(Ee.appSettingsHome.with({scheme:p.Schemas.file}).fsPath),this.allowWindowsUNCPath(Ee.extensionsPath)].map(Ce=>Ce?b.promises.mkdir(Ce,{recursive:!0}):void 0));const ye=new U.LoggerService((0,B.getLogLevel)(Ee),Ee.logsHome);ge.set(B.ILoggerService,ye);const z=this._register(ye.createLogger("cli",{name:(0,H.localize)(171,null)})),ee=[];ye.getLogLevel()===B.LogLevel.Trace&&ee.push(new B.ConsoleLogger(ye.getLogLevel()));const te=this._register(new G.LogService(z,ee));ge.set(B.ILogService,te);const ve=this._register(new c.FileService(te));ge.set(o.IFileService,ve);const Ie=this._register(new g.DiskFileSystemProvider(te));ve.registerProvider(p.Schemas.file,Ie);const ke=new V.UriIdentityService(ve);ge.set(j.IUriIdentityService,ke);const Re=new _.StateReadonlyService(_.SaveStrategy.DELAYED,Ee,te,ve),Ne=new x.UserDataProfilesReadonlyService(Re,ke,Ee,ve,te);ge.set(P.IUserDataProfilesService,Ne),ve.registerProvider(p.Schemas.vscodeUserData,new se.FileUserDataProvider(p.Schemas.file,Ie,p.Schemas.vscodeUserData,Ne,ke,te));const Oe=f.isWindows&&me.win32RegValueName?this._register(new ae.NativePolicyService(te,me.win32RegValueName)):Ee.policyFile?this._register(new Q.FilePolicyService(Ee.policyFile,ve,te)):new re.NullPolicyService;ge.set(re.IPolicyService,Oe);const Ae=this._register(new v.ConfigurationService(Ne.defaultProfile.settingsResource,ve,Oe,te));ge.set(a.IConfigurationService,Ae),await Promise.all([Re.init(),Ae.initialize()]);let We;try{We=await(0,X.resolveMachineId)(Re,te)}catch(Ce){Ce.code!=="ENOENT"&&te.error(Ce)}const Le=await(0,X.resolveSqmId)(Re,te),Fe=await(0,X.resolvedevDeviceId)(Re,te);Ne.init(),ge.set(j.IUriIdentityService,new V.UriIdentityService(ve));const xe=new Z.RequestService(Ae,Ee,te,ye);ge.set($.IRequestService,xe),ge.set(I.IDownloadService,new T.SyncDescriptor(w.DownloadService,void 0,!0)),ge.set(r.IExtensionsProfileScannerService,new T.SyncDescriptor(Y.ExtensionsProfileScannerService,void 0,!0)),ge.set(n.IExtensionsScannerService,new T.SyncDescriptor(s.ExtensionsScannerService,void 0,!0)),ge.set(i.IExtensionSignatureVerificationService,new T.SyncDescriptor(i.ExtensionSignatureVerificationService,void 0,!0)),ge.set(t.INativeServerExtensionManagementService,new T.SyncDescriptor(t.ExtensionManagementService,void 0,!0)),ge.set(E.IExtensionGalleryService,new T.SyncDescriptor(O.ExtensionGalleryServiceWithNoStorageService,void 0,!0)),ge.set(L.ILanguagePackService,new T.SyncDescriptor(M.NativeLanguagePackService,void 0,!1));const Ue=[],be=(0,ie.isInternalTelemetry)(me,Ae);if((0,ie.supportsTelemetry)(me,Ee)){me.aiConfig&&me.aiConfig.ariaKey&&Ue.push(new ne.OneDataSystemAppender(xe,be,"monacoworkbench",null,me.aiConfig.ariaKey));const Ce={appenders:Ue,sendErrorTelemetry:!1,commonProperties:(0,W.resolveCommonProperties)((0,C.release)(),(0,C.hostname)(),process.arch,me.commit,me.version,We,Le,Fe,be),piiPaths:(0,ie.getPiiPathsFromEnvironment)(Ee)};ge.set(q.ITelemetryService,new T.SyncDescriptor(K.TelemetryService,[Ce],!1))}else ge.set(q.ITelemetryService,ie.NullTelemetryService);return[new N.InstantiationService(ge),Ue]}allowWindowsUNCPath(ge){if(f.isWindows){const me=(0,le.getUNCHost)(ge);me&&(0,le.addUNCHostToAllowlist)(me)}return ge}registerErrorHandler(ge){(0,k.setUnexpectedErrorHandler)(me=>{const Ee=(0,R.toErrorMessage)(me,!0);Ee&&ge.error(`[uncaught exception in CLI]: ${Ee}`)}),process.on("uncaughtException",me=>{(0,k.isSigPipeError)(me)||(0,k.onUnexpectedError)(me)}),process.on("unhandledRejection",me=>(0,k.onUnexpectedError)(me))}async doRun(ge,me,Ee,ye){let z;if(ge.args.profile&&(z=Ee.profiles.find(te=>te.name===ge.args.profile),!z))throw new Error(`Profile '${ge.args.profile}' not found.`);const ee=(z??Ee.defaultProfile).extensionsResource;if(this.argv["list-extensions"])return ye.createInstance(l.ExtensionManagementCLI,new B.ConsoleLogger(B.LogLevel.Info,!1)).listExtensions(!!this.argv["show-versions"],this.argv.category,ee);if(this.argv["install-extension"]||this.argv["install-builtin-extension"]){const te={isMachineScoped:!!this.argv["do-not-sync"],installPreReleaseVersion:!!this.argv["pre-release"],profileLocation:ee};return ye.createInstance(l.ExtensionManagementCLI,new B.ConsoleLogger(B.LogLevel.Info,!1)).installExtensions(this.asExtensionIdOrVSIX(this.argv["install-extension"]||[]),this.asExtensionIdOrVSIX(this.argv["install-builtin-extension"]||[]),te,!!this.argv.force)}else{if(this.argv["uninstall-extension"])return ye.createInstance(l.ExtensionManagementCLI,new B.ConsoleLogger(B.LogLevel.Info,!1)).uninstallExtensions(this.asExtensionIdOrVSIX(this.argv["uninstall-extension"]),!!this.argv.force,ee);if(this.argv["update-extensions"])return ye.createInstance(l.ExtensionManagementCLI,new B.ConsoleLogger(B.LogLevel.Info,!1)).updateExtensions(ee);if(this.argv["locate-extension"])return ye.createInstance(l.ExtensionManagementCLI,new B.ConsoleLogger(B.LogLevel.Info,!1)).locateExtension(this.argv["locate-extension"]);this.argv.telemetry&&console.log(await(0,F.buildTelemetryMessage)(ge.appRoot,ge.extensionsPath))}}asExtensionIdOrVSIX(ge){return ge.map(me=>/\.vsix$/i.test(me)?m.URI.file((0,u.isAbsolute)(me)?me:(0,u.join)((0,h.cwd)(),me)):me)}}async function Se(fe){const ge=new he(fe);try{await ge.run()}finally{ge.dispose()}}})}).call(this);

//# sourceMappingURL=https://main.vscode-cdn.net/sourcemaps/532bdf24071d0a26ceea0844dcdf5ee8cfabd562/core/vs/code/node/cliProcessMain.js.map
