/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var he=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/base/common/platform","vs/base/common/async","vs/platform/files/common/files","vs/base/common/errors","vs/nls","vs/base/common/uri","vs/platform/log/common/log","vs/base/common/types","vs/base/common/path","vs/base/common/buffer","vs/platform/environment/common/environment","vs/platform/storage/common/storage","vs/base/common/arrays","vs/platform/telemetry/common/telemetry","vs/platform/userDataProfile/common/userDataProfile","vs/base/common/resources","vs/platform/configuration/common/configuration","vs/base/common/network","vs/platform/product/common/productService","vs/platform/userDataSync/common/userDataSync","vs/base/common/cancellation","vs/base/common/strings","vs/platform/extensionManagement/common/extensionManagement","vs/platform/uriIdentity/common/uriIdentity","vs/base/common/objects","vs/base/node/pfs","vs/base/common/map","vs/base/common/uuid","fs","vs/platform/extensions/common/extensions","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/json","vs/base/common/process","os","vs/base/common/charCode","vs/platform/userDataSync/common/abstractSynchronizer","vs/base/common/errorMessage","vs/base/common/extpath","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/base/common/jsonFormatter","vs/platform/files/common/watcher","vs/platform/configuration/common/configurationRegistry","vs/platform/telemetry/common/telemetryUtils","vs/platform/externalServices/common/serviceMachineId","vs/base/common/stream","vs/base/common/ternarySearchTree","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/base/common/lazy","vs/base/common/stopwatch","vs/base/common/hash","vs/platform/ipc/common/mainProcessService","vs/platform/native/common/native","vs/platform/policy/common/policy","vs/platform/extensions/common/extensionValidator","vs/base/common/semver/semver","vs/platform/request/common/request","vs/platform/userDataProfile/common/userDataProfileStorageService","vs/base/common/iterator","vs/base/common/jsonEdit","vs/base/common/marshallingIds","net","vs/base/common/date","vs/base/common/marshalling","vs/amdX","child_process","vs/base/node/zip","vs/base/parts/ipc/common/ipc.net","vs/base/parts/storage/common/storage","vs/platform/instantiation/common/descriptors","vs/platform/extensionRecommendations/common/extensionRecommendations","crypto","vs/platform/instantiation/common/serviceCollection","vs/platform/configuration/common/configurationModels","vs/platform/languagePacks/common/languagePacks","vs/platform/storage/common/storageIpc","vs/platform/tunnel/common/tunnel","vs/platform/userDataSync/common/content","vs/platform/userDataSync/common/userDataSyncAccount","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/extensionManagement/common/extensionStorage","vs/platform/userDataSync/common/userDataSyncMachines","vs/base/common/decorators","vs/base/common/functional","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/severity","vs/nls.messages","vs/base/common/processes","vs/base/common/glob","vs/base/common/uriIpc","vs/base/parts/ipc/node/ipc.cp","vs/platform/contextkey/common/contextkey","vs/platform/diagnostics/common/diagnostics","vs/platform/download/common/download","vs/platform/files/common/io","vs/base/common/performance","vs/platform/lifecycle/node/sharedProcessLifecycleService","vs/platform/product/common/product","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteHosts","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/remoteTunnel/common/remoteTunnel","vs/platform/sign/common/sign","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryLogAppender","vs/platform/telemetry/common/telemetryService","vs/platform/userDataSync/common/ignoredExtensions","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/extensionManagement/common/extensionEnablementService","vs/platform/userDataSync/common/extensionsSync","vs/platform/userDataSync/common/globalStateSync","vs/platform/userDataSync/common/keybindingsSync","vs/platform/userDataSync/common/settingsSync","vs/platform/userDataSync/common/snippetsSync","vs/platform/userDataSync/common/tasksSync","vs/platform/userDataSync/common/userDataProfilesManifestSync","vs/platform/userDataSync/common/userDataSyncStoreService","vs/base/parts/ipc/node/ipc.net","vs/base/common/amd","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/assert","vs/base/common/jsonSchema","vs/base/common/skipList","vs/base/common/cache","vs/base/common/symbols","vs/base/common/uint","vs/base/node/macAddress","vs/base/node/nodeStreams","vs/base/node/ports","vs/base/parts/request/common/request","vs/base/parts/sandbox/node/electronTypes","vs/base/common/jsonErrorMessages","vs/base/common/desktopEnvironmentInfo","vs/base/common/mime","vs/base/common/console","vs/base/node/id","vs/base/node/osDisplayProtocolInfo","vs/base/node/osReleaseInfo","vs/base/node/extpath","vs/base/node/processes","vs/base/node/ps","vs/base/parts/ipc/node/ipc.mp","vs/platform/contextkey/common/scanner","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionRecommendations/common/extensionRecommendationsIpc","vs/platform/extensions/common/extensionsApiProposals","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/checksum/common/checksumService","vs/platform/checksum/node/checksumService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/baseWatcher","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/code/node/sharedProcess/contrib/logsDataCleaner","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logIpc","vs/platform/log/common/logService","vs/platform/native/common/nativeHostService","vs/platform/policy/common/policyIpc","vs/code/node/sharedProcess/contrib/codeCacheCleaner","vs/code/node/sharedProcess/contrib/languagePackCachedDataCleaner","vs/platform/profiling/common/profiling","vs/platform/profiling/node/profilingService","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/managedSocket","vs/platform/remote/common/remoteAgentConnection","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/extensionManagement/node/extensionsManifestCache","vs/code/node/sharedProcess/contrib/localizationsUpdater","vs/platform/remote/common/sharedProcessTunnelService","vs/platform/download/common/downloadService","vs/platform/request/common/requestIpc","vs/platform/sharedProcess/common/sharedProcess","vs/platform/sign/common/abstractSignService","vs/platform/sign/node/signService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/extensionManagement/common/unsupportedExtensionsMigration","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/languagePacks/node/languagePacks","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/customEndpointTelemetryService","vs/platform/tunnel/node/sharedProcessTunnelService","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userData/common/fileUserDataProvider","vs/platform/userDataSync/common/extensionsMerge","vs/platform/userDataSync/common/keybindingsMerge","vs/platform/userDataSync/common/snippetsMerge","vs/platform/userDataSync/common/userDataProfilesManifestMerge","vs/platform/userDataSync/common/globalStateMerge","vs/platform/userDataSync/common/settingsMerge","vs/platform/userDataSync/common/userDataSyncLog","vs/platform/windows/node/windowTracker","vs/code/node/sharedProcess/contrib/userDataProfilesCleaner","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/code/node/sharedProcess/contrib/extensions","vs/platform/extensionManagement/common/extensionTipsService","vs/platform/extensionManagement/node/extensionTipsService","vs/platform/externalServices/common/marketplace","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/remoteTunnel/node/remoteTunnelService","vs/platform/storage/common/storageService","vs/platform/userDataProfile/common/userDataProfileIpc","vs/platform/userDataProfile/node/userDataProfileStorageService","vs/platform/userDataSync/common/userDataSyncEnablementService","vs/platform/userDataSync/common/userDataSyncLocalStoreService","vs/platform/userDataSync/common/userDataAutoSyncService","vs/platform/userDataSync/common/userDataSyncResourceProvider","vs/platform/userDataSync/common/userDataSyncService","vs/platform/userDataSync/common/userDataSyncServiceIpc","vs/platform/userDataSync/common/userDataSyncIpc","vs/platform/userDataSync/node/userDataAutoSyncService","vs/platform/workspaces/node/workspaces","vs/code/node/sharedProcess/contrib/storageDataCleaner","vs/platform/remote/node/nodeSocketFactory","vs/platform/tunnel/node/tunnelService","stream","readline","util","path","https","zlib","vs/code/node/sharedProcess/sharedProcessMain"],fe=function(ce){for(var e=[],R=0,a=ce.length;R<a;R++)e[R]=he[ce[R]];return e};define(he[130],fe([0,1]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoaderStats=e.LoaderEventType=e.canASAR=e.isESM=void 0,e.isESM=!1,e.canASAR=!0;var R;(function(_){_[_.LoaderAvailable=1]="LoaderAvailable",_[_.BeginLoadingScript=10]="BeginLoadingScript",_[_.EndLoadingScriptOK=11]="EndLoadingScriptOK",_[_.EndLoadingScriptError=12]="EndLoadingScriptError",_[_.BeginInvokeFactory=21]="BeginInvokeFactory",_[_.EndInvokeFactory=22]="EndInvokeFactory",_[_.NodeBeginEvaluatingScript=31]="NodeBeginEvaluatingScript",_[_.NodeEndEvaluatingScript=32]="NodeEndEvaluatingScript",_[_.NodeBeginNativeRequire=33]="NodeBeginNativeRequire",_[_.NodeEndNativeRequire=34]="NodeEndNativeRequire",_[_.CachedDataFound=60]="CachedDataFound",_[_.CachedDataMissed=61]="CachedDataMissed",_[_.CachedDataRejected=62]="CachedDataRejected",_[_.CachedDataCreated=63]="CachedDataCreated"})(R||(e.LoaderEventType=R={}));class a{static get(){const T=new Map,k=new Map,L=new Map,D=new Map;function E(l,g){l.has(g.detail)||l.set(g.detail,-g.timestamp)}function P(l,g){const I=l.get(g.detail);I&&(I>=0||l.set(g.detail,I+g.timestamp))}let S=[];typeof ce=="function"&&typeof ce.getStats=="function"&&(S=ce.getStats().slice(0).sort((l,g)=>l.timestamp-g.timestamp));for(const l of S)switch(l.type){case R.BeginLoadingScript:E(T,l);break;case R.EndLoadingScriptOK:case R.EndLoadingScriptError:P(T,l);break;case R.BeginInvokeFactory:E(k,l);break;case R.EndInvokeFactory:P(k,l);break;case R.NodeBeginNativeRequire:E(L,l);break;case R.NodeEndNativeRequire:P(L,l);break;case R.NodeBeginEvaluatingScript:E(D,l);break;case R.NodeEndEvaluatingScript:P(D,l);break}let m=0;L.forEach(l=>m+=l);function d(l){const g=[];return l.forEach((I,v)=>g.push([v,I])),g}return{amdLoad:d(T),amdInvoke:d(k),nodeRequire:d(L),nodeEval:d(D),nodeRequireTotal:m}}static toMarkdownTable(T,k){let L="";const D=[];return T.forEach((E,P)=>{D[P]=E.length}),k.forEach(E=>{E.forEach((P,S)=>{typeof P>"u"&&(P=E[S]="-");const m=P.toString().length;D[S]=Math.max(m,D[S])})}),T.forEach((E,P)=>{L+=`| ${E+" ".repeat(D[P]-E.toString().length)} `}),L+=`|
`,T.forEach((E,P)=>{L+=`| ${"-".repeat(D[P])} `}),L+=`|
`,k.forEach(E=>{E.forEach((P,S)=>{typeof P<"u"&&(L+=`| ${P+" ".repeat(D[S]-P.toString().length)} `)}),L+=`|
`}),L}}e.LoaderStats=a}),define(he[131],fe([0,1]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MonotonousArray=void 0,e.findLast=R,e.findLastIdx=a,e.findLastMonotonous=_,e.findLastIdxMonotonous=T,e.findFirstMonotonous=k,e.findFirstIdxMonotonousOrArrLen=L,e.findFirstIdxMonotonous=D,e.findFirstMax=P,e.findLastMax=S,e.findFirstMin=m,e.findMaxIdx=d,e.mapFindFirst=l;function R(g,I){const v=a(g,I);if(v!==-1)return g[v]}function a(g,I,v=g.length-1){for(let f=v;f>=0;f--){const C=g[f];if(I(C))return f}return-1}function _(g,I){const v=T(g,I);return v===-1?void 0:g[v]}function T(g,I,v=0,f=g.length){let C=v,p=f;for(;C<p;){const c=Math.floor((C+p)/2);I(g[c])?C=c+1:p=c}return C-1}function k(g,I){const v=L(g,I);return v===g.length?void 0:g[v]}function L(g,I,v=0,f=g.length){let C=v,p=f;for(;C<p;){const c=Math.floor((C+p)/2);I(g[c])?p=c:C=c+1}return C}function D(g,I,v=0,f=g.length){const C=L(g,I,v,f);return C===g.length?-1:C}class E{static{this.assertInvariants=!1}constructor(I){this._array=I,this._findLastMonotonousLastIdx=0}findLastMonotonous(I){if(E.assertInvariants){if(this._prevFindLastPredicate){for(const f of this._array)if(this._prevFindLastPredicate(f)&&!I(f))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this._prevFindLastPredicate=I}const v=T(this._array,I,this._findLastMonotonousLastIdx);return this._findLastMonotonousLastIdx=v+1,v===-1?void 0:this._array[v]}}e.MonotonousArray=E;function P(g,I){if(g.length===0)return;let v=g[0];for(let f=1;f<g.length;f++){const C=g[f];I(C,v)>0&&(v=C)}return v}function S(g,I){if(g.length===0)return;let v=g[0];for(let f=1;f<g.length;f++){const C=g[f];I(C,v)>=0&&(v=C)}return v}function m(g,I){return P(g,(v,f)=>-I(v,f))}function d(g,I){if(g.length===0)return-1;let v=0;for(let f=1;f<g.length;f++){const C=g[f];I(C,g[v])>0&&(v=f)}return v}function l(g,I){for(const v of g){const f=I(v);if(f!==void 0)return f}}}),define(he[39],fe([0,1]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharCode=void 0;var R;(function(a){a[a.Null=0]="Null",a[a.Backspace=8]="Backspace",a[a.Tab=9]="Tab",a[a.LineFeed=10]="LineFeed",a[a.CarriageReturn=13]="CarriageReturn",a[a.Space=32]="Space",a[a.ExclamationMark=33]="ExclamationMark",a[a.DoubleQuote=34]="DoubleQuote",a[a.Hash=35]="Hash",a[a.DollarSign=36]="DollarSign",a[a.PercentSign=37]="PercentSign",a[a.Ampersand=38]="Ampersand",a[a.SingleQuote=39]="SingleQuote",a[a.OpenParen=40]="OpenParen",a[a.CloseParen=41]="CloseParen",a[a.Asterisk=42]="Asterisk",a[a.Plus=43]="Plus",a[a.Comma=44]="Comma",a[a.Dash=45]="Dash",a[a.Period=46]="Period",a[a.Slash=47]="Slash",a[a.Digit0=48]="Digit0",a[a.Digit1=49]="Digit1",a[a.Digit2=50]="Digit2",a[a.Digit3=51]="Digit3",a[a.Digit4=52]="Digit4",a[a.Digit5=53]="Digit5",a[a.Digit6=54]="Digit6",a[a.Digit7=55]="Digit7",a[a.Digit8=56]="Digit8",a[a.Digit9=57]="Digit9",a[a.Colon=58]="Colon",a[a.Semicolon=59]="Semicolon",a[a.LessThan=60]="LessThan",a[a.Equals=61]="Equals",a[a.GreaterThan=62]="GreaterThan",a[a.QuestionMark=63]="QuestionMark",a[a.AtSign=64]="AtSign",a[a.A=65]="A",a[a.B=66]="B",a[a.C=67]="C",a[a.D=68]="D",a[a.E=69]="E",a[a.F=70]="F",a[a.G=71]="G",a[a.H=72]="H",a[a.I=73]="I",a[a.J=74]="J",a[a.K=75]="K",a[a.L=76]="L",a[a.M=77]="M",a[a.N=78]="N",a[a.O=79]="O",a[a.P=80]="P",a[a.Q=81]="Q",a[a.R=82]="R",a[a.S=83]="S",a[a.T=84]="T",a[a.U=85]="U",a[a.V=86]="V",a[a.W=87]="W",a[a.X=88]="X",a[a.Y=89]="Y",a[a.Z=90]="Z",a[a.OpenSquareBracket=91]="OpenSquareBracket",a[a.Backslash=92]="Backslash",a[a.CloseSquareBracket=93]="CloseSquareBracket",a[a.Caret=94]="Caret",a[a.Underline=95]="Underline",a[a.BackTick=96]="BackTick",a[a.a=97]="a",a[a.b=98]="b",a[a.c=99]="c",a[a.d=100]="d",a[a.e=101]="e",a[a.f=102]="f",a[a.g=103]="g",a[a.h=104]="h",a[a.i=105]="i",a[a.j=106]="j",a[a.k=107]="k",a[a.l=108]="l",a[a.m=109]="m",a[a.n=110]="n",a[a.o=111]="o",a[a.p=112]="p",a[a.q=113]="q",a[a.r=114]="r",a[a.s=115]="s",a[a.t=116]="t",a[a.u=117]="u",a[a.v=118]="v",a[a.w=119]="w",a[a.x=120]="x",a[a.y=121]="y",a[a.z=122]="z",a[a.OpenCurlyBrace=123]="OpenCurlyBrace",a[a.Pipe=124]="Pipe",a[a.CloseCurlyBrace=125]="CloseCurlyBrace",a[a.Tilde=126]="Tilde",a[a.NoBreakSpace=160]="NoBreakSpace",a[a.U_Combining_Grave_Accent=768]="U_Combining_Grave_Accent",a[a.U_Combining_Acute_Accent=769]="U_Combining_Acute_Accent",a[a.U_Combining_Circumflex_Accent=770]="U_Combining_Circumflex_Accent",a[a.U_Combining_Tilde=771]="U_Combining_Tilde",a[a.U_Combining_Macron=772]="U_Combining_Macron",a[a.U_Combining_Overline=773]="U_Combining_Overline",a[a.U_Combining_Breve=774]="U_Combining_Breve",a[a.U_Combining_Dot_Above=775]="U_Combining_Dot_Above",a[a.U_Combining_Diaeresis=776]="U_Combining_Diaeresis",a[a.U_Combining_Hook_Above=777]="U_Combining_Hook_Above",a[a.U_Combining_Ring_Above=778]="U_Combining_Ring_Above",a[a.U_Combining_Double_Acute_Accent=779]="U_Combining_Double_Acute_Accent",a[a.U_Combining_Caron=780]="U_Combining_Caron",a[a.U_Combining_Vertical_Line_Above=781]="U_Combining_Vertical_Line_Above",a[a.U_Combining_Double_Vertical_Line_Above=782]="U_Combining_Double_Vertical_Line_Above",a[a.U_Combining_Double_Grave_Accent=783]="U_Combining_Double_Grave_Accent",a[a.U_Combining_Candrabindu=784]="U_Combining_Candrabindu",a[a.U_Combining_Inverted_Breve=785]="U_Combining_Inverted_Breve",a[a.U_Combining_Turned_Comma_Above=786]="U_Combining_Turned_Comma_Above",a[a.U_Combining_Comma_Above=787]="U_Combining_Comma_Above",a[a.U_Combining_Reversed_Comma_Above=788]="U_Combining_Reversed_Comma_Above",a[a.U_Combining_Comma_Above_Right=789]="U_Combining_Comma_Above_Right",a[a.U_Combining_Grave_Accent_Below=790]="U_Combining_Grave_Accent_Below",a[a.U_Combining_Acute_Accent_Below=791]="U_Combining_Acute_Accent_Below",a[a.U_Combining_Left_Tack_Below=792]="U_Combining_Left_Tack_Below",a[a.U_Combining_Right_Tack_Below=793]="U_Combining_Right_Tack_Below",a[a.U_Combining_Left_Angle_Above=794]="U_Combining_Left_Angle_Above",a[a.U_Combining_Horn=795]="U_Combining_Horn",a[a.U_Combining_Left_Half_Ring_Below=796]="U_Combining_Left_Half_Ring_Below",a[a.U_Combining_Up_Tack_Below=797]="U_Combining_Up_Tack_Below",a[a.U_Combining_Down_Tack_Below=798]="U_Combining_Down_Tack_Below",a[a.U_Combining_Plus_Sign_Below=799]="U_Combining_Plus_Sign_Below",a[a.U_Combining_Minus_Sign_Below=800]="U_Combining_Minus_Sign_Below",a[a.U_Combining_Palatalized_Hook_Below=801]="U_Combining_Palatalized_Hook_Below",a[a.U_Combining_Retroflex_Hook_Below=802]="U_Combining_Retroflex_Hook_Below",a[a.U_Combining_Dot_Below=803]="U_Combining_Dot_Below",a[a.U_Combining_Diaeresis_Below=804]="U_Combining_Diaeresis_Below",a[a.U_Combining_Ring_Below=805]="U_Combining_Ring_Below",a[a.U_Combining_Comma_Below=806]="U_Combining_Comma_Below",a[a.U_Combining_Cedilla=807]="U_Combining_Cedilla",a[a.U_Combining_Ogonek=808]="U_Combining_Ogonek",a[a.U_Combining_Vertical_Line_Below=809]="U_Combining_Vertical_Line_Below",a[a.U_Combining_Bridge_Below=810]="U_Combining_Bridge_Below",a[a.U_Combining_Inverted_Double_Arch_Below=811]="U_Combining_Inverted_Double_Arch_Below",a[a.U_Combining_Caron_Below=812]="U_Combining_Caron_Below",a[a.U_Combining_Circumflex_Accent_Below=813]="U_Combining_Circumflex_Accent_Below",a[a.U_Combining_Breve_Below=814]="U_Combining_Breve_Below",a[a.U_Combining_Inverted_Breve_Below=815]="U_Combining_Inverted_Breve_Below",a[a.U_Combining_Tilde_Below=816]="U_Combining_Tilde_Below",a[a.U_Combining_Macron_Below=817]="U_Combining_Macron_Below",a[a.U_Combining_Low_Line=818]="U_Combining_Low_Line",a[a.U_Combining_Double_Low_Line=819]="U_Combining_Double_Low_Line",a[a.U_Combining_Tilde_Overlay=820]="U_Combining_Tilde_Overlay",a[a.U_Combining_Short_Stroke_Overlay=821]="U_Combining_Short_Stroke_Overlay",a[a.U_Combining_Long_Stroke_Overlay=822]="U_Combining_Long_Stroke_Overlay",a[a.U_Combining_Short_Solidus_Overlay=823]="U_Combining_Short_Solidus_Overlay",a[a.U_Combining_Long_Solidus_Overlay=824]="U_Combining_Long_Solidus_Overlay",a[a.U_Combining_Right_Half_Ring_Below=825]="U_Combining_Right_Half_Ring_Below",a[a.U_Combining_Inverted_Bridge_Below=826]="U_Combining_Inverted_Bridge_Below",a[a.U_Combining_Square_Below=827]="U_Combining_Square_Below",a[a.U_Combining_Seagull_Below=828]="U_Combining_Seagull_Below",a[a.U_Combining_X_Above=829]="U_Combining_X_Above",a[a.U_Combining_Vertical_Tilde=830]="U_Combining_Vertical_Tilde",a[a.U_Combining_Double_Overline=831]="U_Combining_Double_Overline",a[a.U_Combining_Grave_Tone_Mark=832]="U_Combining_Grave_Tone_Mark",a[a.U_Combining_Acute_Tone_Mark=833]="U_Combining_Acute_Tone_Mark",a[a.U_Combining_Greek_Perispomeni=834]="U_Combining_Greek_Perispomeni",a[a.U_Combining_Greek_Koronis=835]="U_Combining_Greek_Koronis",a[a.U_Combining_Greek_Dialytika_Tonos=836]="U_Combining_Greek_Dialytika_Tonos",a[a.U_Combining_Greek_Ypogegrammeni=837]="U_Combining_Greek_Ypogegrammeni",a[a.U_Combining_Bridge_Above=838]="U_Combining_Bridge_Above",a[a.U_Combining_Equals_Sign_Below=839]="U_Combining_Equals_Sign_Below",a[a.U_Combining_Double_Vertical_Line_Below=840]="U_Combining_Double_Vertical_Line_Below",a[a.U_Combining_Left_Angle_Below=841]="U_Combining_Left_Angle_Below",a[a.U_Combining_Not_Tilde_Above=842]="U_Combining_Not_Tilde_Above",a[a.U_Combining_Homothetic_Above=843]="U_Combining_Homothetic_Above",a[a.U_Combining_Almost_Equal_To_Above=844]="U_Combining_Almost_Equal_To_Above",a[a.U_Combining_Left_Right_Arrow_Below=845]="U_Combining_Left_Right_Arrow_Below",a[a.U_Combining_Upwards_Arrow_Below=846]="U_Combining_Upwards_Arrow_Below",a[a.U_Combining_Grapheme_Joiner=847]="U_Combining_Grapheme_Joiner",a[a.U_Combining_Right_Arrowhead_Above=848]="U_Combining_Right_Arrowhead_Above",a[a.U_Combining_Left_Half_Ring_Above=849]="U_Combining_Left_Half_Ring_Above",a[a.U_Combining_Fermata=850]="U_Combining_Fermata",a[a.U_Combining_X_Below=851]="U_Combining_X_Below",a[a.U_Combining_Left_Arrowhead_Below=852]="U_Combining_Left_Arrowhead_Below",a[a.U_Combining_Right_Arrowhead_Below=853]="U_Combining_Right_Arrowhead_Below",a[a.U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below=854]="U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below",a[a.U_Combining_Right_Half_Ring_Above=855]="U_Combining_Right_Half_Ring_Above",a[a.U_Combining_Dot_Above_Right=856]="U_Combining_Dot_Above_Right",a[a.U_Combining_Asterisk_Below=857]="U_Combining_Asterisk_Below",a[a.U_Combining_Double_Ring_Below=858]="U_Combining_Double_Ring_Below",a[a.U_Combining_Zigzag_Above=859]="U_Combining_Zigzag_Above",a[a.U_Combining_Double_Breve_Below=860]="U_Combining_Double_Breve_Below",a[a.U_Combining_Double_Breve=861]="U_Combining_Double_Breve",a[a.U_Combining_Double_Macron=862]="U_Combining_Double_Macron",a[a.U_Combining_Double_Macron_Below=863]="U_Combining_Double_Macron_Below",a[a.U_Combining_Double_Tilde=864]="U_Combining_Double_Tilde",a[a.U_Combining_Double_Inverted_Breve=865]="U_Combining_Double_Inverted_Breve",a[a.U_Combining_Double_Rightwards_Arrow_Below=866]="U_Combining_Double_Rightwards_Arrow_Below",a[a.U_Combining_Latin_Small_Letter_A=867]="U_Combining_Latin_Small_Letter_A",a[a.U_Combining_Latin_Small_Letter_E=868]="U_Combining_Latin_Small_Letter_E",a[a.U_Combining_Latin_Small_Letter_I=869]="U_Combining_Latin_Small_Letter_I",a[a.U_Combining_Latin_Small_Letter_O=870]="U_Combining_Latin_Small_Letter_O",a[a.U_Combining_Latin_Small_Letter_U=871]="U_Combining_Latin_Small_Letter_U",a[a.U_Combining_Latin_Small_Letter_C=872]="U_Combining_Latin_Small_Letter_C",a[a.U_Combining_Latin_Small_Letter_D=873]="U_Combining_Latin_Small_Letter_D",a[a.U_Combining_Latin_Small_Letter_H=874]="U_Combining_Latin_Small_Letter_H",a[a.U_Combining_Latin_Small_Letter_M=875]="U_Combining_Latin_Small_Letter_M",a[a.U_Combining_Latin_Small_Letter_R=876]="U_Combining_Latin_Small_Letter_R",a[a.U_Combining_Latin_Small_Letter_T=877]="U_Combining_Latin_Small_Letter_T",a[a.U_Combining_Latin_Small_Letter_V=878]="U_Combining_Latin_Small_Letter_V",a[a.U_Combining_Latin_Small_Letter_X=879]="U_Combining_Latin_Small_Letter_X",a[a.LINE_SEPARATOR=8232]="LINE_SEPARATOR",a[a.PARAGRAPH_SEPARATOR=8233]="PARAGRAPH_SEPARATOR",a[a.NEXT_LINE=133]="NEXT_LINE",a[a.U_CIRCUMFLEX=94]="U_CIRCUMFLEX",a[a.U_GRAVE_ACCENT=96]="U_GRAVE_ACCENT",a[a.U_DIAERESIS=168]="U_DIAERESIS",a[a.U_MACRON=175]="U_MACRON",a[a.U_ACUTE_ACCENT=180]="U_ACUTE_ACCENT",a[a.U_CEDILLA=184]="U_CEDILLA",a[a.U_MODIFIER_LETTER_LEFT_ARROWHEAD=706]="U_MODIFIER_LETTER_LEFT_ARROWHEAD",a[a.U_MODIFIER_LETTER_RIGHT_ARROWHEAD=707]="U_MODIFIER_LETTER_RIGHT_ARROWHEAD",a[a.U_MODIFIER_LETTER_UP_ARROWHEAD=708]="U_MODIFIER_LETTER_UP_ARROWHEAD",a[a.U_MODIFIER_LETTER_DOWN_ARROWHEAD=709]="U_MODIFIER_LETTER_DOWN_ARROWHEAD",a[a.U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING=722]="U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING",a[a.U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING=723]="U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING",a[a.U_MODIFIER_LETTER_UP_TACK=724]="U_MODIFIER_LETTER_UP_TACK",a[a.U_MODIFIER_LETTER_DOWN_TACK=725]="U_MODIFIER_LETTER_DOWN_TACK",a[a.U_MODIFIER_LETTER_PLUS_SIGN=726]="U_MODIFIER_LETTER_PLUS_SIGN",a[a.U_MODIFIER_LETTER_MINUS_SIGN=727]="U_MODIFIER_LETTER_MINUS_SIGN",a[a.U_BREVE=728]="U_BREVE",a[a.U_DOT_ABOVE=729]="U_DOT_ABOVE",a[a.U_RING_ABOVE=730]="U_RING_ABOVE",a[a.U_OGONEK=731]="U_OGONEK",a[a.U_SMALL_TILDE=732]="U_SMALL_TILDE",a[a.U_DOUBLE_ACUTE_ACCENT=733]="U_DOUBLE_ACUTE_ACCENT",a[a.U_MODIFIER_LETTER_RHOTIC_HOOK=734]="U_MODIFIER_LETTER_RHOTIC_HOOK",a[a.U_MODIFIER_LETTER_CROSS_ACCENT=735]="U_MODIFIER_LETTER_CROSS_ACCENT",a[a.U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR=741]="U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR",a[a.U_MODIFIER_LETTER_HIGH_TONE_BAR=742]="U_MODIFIER_LETTER_HIGH_TONE_BAR",a[a.U_MODIFIER_LETTER_MID_TONE_BAR=743]="U_MODIFIER_LETTER_MID_TONE_BAR",a[a.U_MODIFIER_LETTER_LOW_TONE_BAR=744]="U_MODIFIER_LETTER_LOW_TONE_BAR",a[a.U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR=745]="U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR",a[a.U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK=746]="U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK",a[a.U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK=747]="U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK",a[a.U_MODIFIER_LETTER_UNASPIRATED=749]="U_MODIFIER_LETTER_UNASPIRATED",a[a.U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD=751]="U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD",a[a.U_MODIFIER_LETTER_LOW_UP_ARROWHEAD=752]="U_MODIFIER_LETTER_LOW_UP_ARROWHEAD",a[a.U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD=753]="U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD",a[a.U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD=754]="U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD",a[a.U_MODIFIER_LETTER_LOW_RING=755]="U_MODIFIER_LETTER_LOW_RING",a[a.U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT=756]="U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT",a[a.U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT=757]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT",a[a.U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT=758]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT",a[a.U_MODIFIER_LETTER_LOW_TILDE=759]="U_MODIFIER_LETTER_LOW_TILDE",a[a.U_MODIFIER_LETTER_RAISED_COLON=760]="U_MODIFIER_LETTER_RAISED_COLON",a[a.U_MODIFIER_LETTER_BEGIN_HIGH_TONE=761]="U_MODIFIER_LETTER_BEGIN_HIGH_TONE",a[a.U_MODIFIER_LETTER_END_HIGH_TONE=762]="U_MODIFIER_LETTER_END_HIGH_TONE",a[a.U_MODIFIER_LETTER_BEGIN_LOW_TONE=763]="U_MODIFIER_LETTER_BEGIN_LOW_TONE",a[a.U_MODIFIER_LETTER_END_LOW_TONE=764]="U_MODIFIER_LETTER_END_LOW_TONE",a[a.U_MODIFIER_LETTER_SHELF=765]="U_MODIFIER_LETTER_SHELF",a[a.U_MODIFIER_LETTER_OPEN_SHELF=766]="U_MODIFIER_LETTER_OPEN_SHELF",a[a.U_MODIFIER_LETTER_LOW_LEFT_ARROW=767]="U_MODIFIER_LETTER_LOW_LEFT_ARROW",a[a.U_GREEK_LOWER_NUMERAL_SIGN=885]="U_GREEK_LOWER_NUMERAL_SIGN",a[a.U_GREEK_TONOS=900]="U_GREEK_TONOS",a[a.U_GREEK_DIALYTIKA_TONOS=901]="U_GREEK_DIALYTIKA_TONOS",a[a.U_GREEK_KORONIS=8125]="U_GREEK_KORONIS",a[a.U_GREEK_PSILI=8127]="U_GREEK_PSILI",a[a.U_GREEK_PERISPOMENI=8128]="U_GREEK_PERISPOMENI",a[a.U_GREEK_DIALYTIKA_AND_PERISPOMENI=8129]="U_GREEK_DIALYTIKA_AND_PERISPOMENI",a[a.U_GREEK_PSILI_AND_VARIA=8141]="U_GREEK_PSILI_AND_VARIA",a[a.U_GREEK_PSILI_AND_OXIA=8142]="U_GREEK_PSILI_AND_OXIA",a[a.U_GREEK_PSILI_AND_PERISPOMENI=8143]="U_GREEK_PSILI_AND_PERISPOMENI",a[a.U_GREEK_DASIA_AND_VARIA=8157]="U_GREEK_DASIA_AND_VARIA",a[a.U_GREEK_DASIA_AND_OXIA=8158]="U_GREEK_DASIA_AND_OXIA",a[a.U_GREEK_DASIA_AND_PERISPOMENI=8159]="U_GREEK_DASIA_AND_PERISPOMENI",a[a.U_GREEK_DIALYTIKA_AND_VARIA=8173]="U_GREEK_DIALYTIKA_AND_VARIA",a[a.U_GREEK_DIALYTIKA_AND_OXIA=8174]="U_GREEK_DIALYTIKA_AND_OXIA",a[a.U_GREEK_VARIA=8175]="U_GREEK_VARIA",a[a.U_GREEK_OXIA=8189]="U_GREEK_OXIA",a[a.U_GREEK_DASIA=8190]="U_GREEK_DASIA",a[a.U_IDEOGRAPHIC_FULL_STOP=12290]="U_IDEOGRAPHIC_FULL_STOP",a[a.U_LEFT_CORNER_BRACKET=12300]="U_LEFT_CORNER_BRACKET",a[a.U_RIGHT_CORNER_BRACKET=12301]="U_RIGHT_CORNER_BRACKET",a[a.U_LEFT_BLACK_LENTICULAR_BRACKET=12304]="U_LEFT_BLACK_LENTICULAR_BRACKET",a[a.U_RIGHT_BLACK_LENTICULAR_BRACKET=12305]="U_RIGHT_BLACK_LENTICULAR_BRACKET",a[a.U_OVERLINE=8254]="U_OVERLINE",a[a.UTF8_BOM=65279]="UTF8_BOM",a[a.U_FULLWIDTH_SEMICOLON=65307]="U_FULLWIDTH_SEMICOLON",a[a.U_FULLWIDTH_COMMA=65292]="U_FULLWIDTH_COMMA"})(R||(e.CharCode=R={}))}),define(he[132],fe([0,1]),function(ce,e){"use strict";var R;Object.defineProperty(e,"__esModule",{value:!0}),e.SetWithKey=void 0,e.groupBy=a,e.diffSets=_,e.diffMaps=T,e.intersection=k;function a(D,E){const P=Object.create(null);for(const S of D){const m=E(S);let d=P[m];d||(d=P[m]=[]),d.push(S)}return P}function _(D,E){const P=[],S=[];for(const m of D)E.has(m)||P.push(m);for(const m of E)D.has(m)||S.push(m);return{removed:P,added:S}}function T(D,E){const P=[],S=[];for(const[m,d]of D)E.has(m)||P.push(d);for(const[m,d]of E)D.has(m)||S.push(d);return{removed:P,added:S}}function k(D,E){const P=new Set;for(const S of E)D.has(S)&&P.add(S);return P}class L{static{R=Symbol.toStringTag}constructor(E,P){this.toKey=P,this._map=new Map,this[R]="SetWithKey";for(const S of E)this.add(S)}get size(){return this._map.size}add(E){const P=this.toKey(E);return this._map.set(P,E),this}delete(E){return this._map.delete(this.toKey(E))}has(E){return this._map.has(this.toKey(E))}*entries(){for(const E of this._map.values())yield[E,E]}keys(){return this.values()}*values(){for(const E of this._map.values())yield E}clear(){this._map.clear()}forEach(E,P){this._map.forEach(S=>E.call(P,S,S,this))}[Symbol.iterator](){return this.values()}}e.SetWithKey=L}),define(he[88],fe([0,1]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.memoize=a,e.debounce=_,e.throttle=T;function R(k){return(L,D,E)=>{let P=null,S=null;if(typeof E.value=="function"?(P="value",S=E.value):typeof E.get=="function"&&(P="get",S=E.get),!S)throw new Error("not supported");E[P]=k(S,D)}}function a(k,L,D){let E=null,P=null;if(typeof D.value=="function"?(E="value",P=D.value,P.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof D.get=="function"&&(E="get",P=D.get),!P)throw new Error("not supported");const S=`$memoize$${L}`;D[E]=function(...m){return this.hasOwnProperty(S)||Object.defineProperty(this,S,{configurable:!1,enumerable:!1,writable:!1,value:P.apply(this,m)}),this[S]}}function _(k,L,D){return R((E,P)=>{const S=`$debounce$${P}`,m=`$debounce$result$${P}`;return function(...d){this[m]||(this[m]=D?D():void 0),clearTimeout(this[S]),L&&(this[m]=L(this[m],...d),d=[this[m]]),this[S]=setTimeout(()=>{E.apply(this,d),this[m]=D?D():void 0},k)}})}function T(k,L,D){return R((E,P)=>{const S=`$throttle$timer$${P}`,m=`$throttle$result$${P}`,d=`$throttle$lastRun$${P}`,l=`$throttle$pending$${P}`;return function(...g){if(this[m]||(this[m]=D?D():void 0),(this[d]===null||this[d]===void 0)&&(this[d]=-Number.MAX_VALUE),L&&(this[m]=L(this[m],...g)),this[l])return;const I=this[d]+k;I<=Date.now()?(this[d]=Date.now(),E.apply(this,[this[m]]),this[m]=D?D():void 0):(this[l]=!0,this[S]=setTimeout(()=>{this[l]=!1,this[d]=Date.now(),E.apply(this,[this[m]]),this[m]=D?D():void 0},I-Date.now()))}})}}),define(he[8],fe([0,1]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.ReadonlyError=e.CancellationError=e.errorHandler=e.ErrorHandler=void 0,e.setUnexpectedErrorHandler=a,e.isSigPipeError=_,e.onUnexpectedError=T,e.onUnexpectedExternalError=k,e.transformErrorForSerialization=L,e.transformErrorFromSerialization=D,e.isCancellationError=P,e.canceled=m,e.illegalArgument=d,e.illegalState=l,e.getErrorMessage=I;class R{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(i){setTimeout(()=>{throw i.stack?p.isErrorNoTelemetry(i)?new p(i.message+`

`+i.stack):new Error(i.message+`

`+i.stack):i},0)}}addListener(i){return this.listeners.push(i),()=>{this._removeListener(i)}}emit(i){this.listeners.forEach(n=>{n(i)})}_removeListener(i){this.listeners.splice(this.listeners.indexOf(i),1)}setUnexpectedErrorHandler(i){this.unexpectedErrorHandler=i}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(i){this.unexpectedErrorHandler(i),this.emit(i)}onUnexpectedExternalError(i){this.unexpectedErrorHandler(i)}}e.ErrorHandler=R,e.errorHandler=new R;function a(u){e.errorHandler.setUnexpectedErrorHandler(u)}function _(u){if(!u||typeof u!="object")return!1;const i=u;return i.code==="EPIPE"&&i.syscall?.toUpperCase()==="WRITE"}function T(u){P(u)||e.errorHandler.onUnexpectedError(u)}function k(u){P(u)||e.errorHandler.onUnexpectedExternalError(u)}function L(u){if(u instanceof Error){const{name:i,message:n}=u,t=u.stacktrace||u.stack;return{$isError:!0,name:i,message:n,stack:t,noTelemetry:p.isErrorNoTelemetry(u)}}return u}function D(u){let i;return u.noTelemetry?i=new p:(i=new Error,i.name=u.name),i.message=u.message,i.stack=u.stack,i}const E="Canceled";function P(u){return u instanceof S?!0:u instanceof Error&&u.name===E&&u.message===E}class S extends Error{constructor(){super(E),this.name=this.message}}e.CancellationError=S;function m(){const u=new Error(E);return u.name=u.message,u}function d(u){return u?new Error(`Illegal argument: ${u}`):new Error("Illegal argument")}function l(u){return u?new Error(`Illegal state: ${u}`):new Error("Illegal state")}class g extends TypeError{constructor(i){super(i?`${i} is read-only and cannot be changed`:"Cannot change read-only property")}}e.ReadonlyError=g;function I(u){return u?u.message?u.message:u.stack?u.stack.split(`
`)[0]:String(u):"Error"}class v extends Error{constructor(i){super("NotImplemented"),i&&(this.message=i)}}e.NotImplementedError=v;class f extends Error{constructor(i){super("NotSupported"),i&&(this.message=i)}}e.NotSupportedError=f;class C extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.ExpectedError=C;class p extends Error{constructor(i){super(i),this.name="CodeExpectedError"}static fromError(i){if(i instanceof p)return i;const n=new p;return n.message=i.message,n.stack=i.stack,n}static isErrorNoTelemetry(i){return i.name==="CodeExpectedError"}}e.ErrorNoTelemetry=p;class c extends Error{constructor(i){super(i||"An unexpected bug occurred."),Object.setPrototypeOf(this,c.prototype)}}e.BugIndicatingError=c}),define(he[17],fe([0,1,8,131]),function(ce,e,R,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Permutation=e.CallbackIterable=e.ArrayQueue=e.booleanComparator=e.numberComparator=e.CompareResult=void 0,e.tail=_,e.tail2=T,e.equals=k,e.removeFastWithoutKeepingOrder=L,e.binarySearch=D,e.binarySearch2=E,e.quickSelect=P,e.groupBy=S,e.groupAdjacentBy=m,e.forEachAdjacent=d,e.forEachWithNeighbors=l,e.sortedDiff=g,e.delta=I,e.top=v,e.topAsync=f,e.coalesce=p,e.coalesceInPlace=c,e.move=u,e.isFalsyOrEmpty=i,e.isNonEmptyArray=n,e.distinct=t,e.uniqueFilter=s,e.firstOrDefault=r,e.lastOrDefault=o,e.commonPrefixLength=h,e.range=y,e.index=A,e.insert=b,e.remove=w,e.arrayInsert=O,e.shuffle=F,e.pushToStart=N,e.pushToEnd=M,e.pushMany=V,e.mapArrayOrNot=z,e.asArray=J,e.getRandomElement=j,e.insertInto=te,e.splice=q,e.compareBy=ne,e.tieBreakComparators=le,e.reverseOrder=H,e.findAsync=oe;function _(Q,X=0){return Q[Q.length-(1+X)]}function T(Q){if(Q.length===0)throw new Error("Invalid tail call");return[Q.slice(0,Q.length-1),Q[Q.length-1]]}function k(Q,X,x=($,ie)=>$===ie){if(Q===X)return!0;if(!Q||!X||Q.length!==X.length)return!1;for(let $=0,ie=Q.length;$<ie;$++)if(!x(Q[$],X[$]))return!1;return!0}function L(Q,X){const x=Q.length-1;X<x&&(Q[X]=Q[x]),Q.pop()}function D(Q,X,x){return E(Q.length,$=>x(Q[$],X))}function E(Q,X){let x=0,$=Q-1;for(;x<=$;){const ie=(x+$)/2|0,ae=X(ie);if(ae<0)x=ie+1;else if(ae>0)$=ie-1;else return ie}return-(x+1)}function P(Q,X,x){if(Q=Q|0,Q>=X.length)throw new TypeError("invalid index");const $=X[Math.floor(X.length*Math.random())],ie=[],ae=[],ue=[];for(const Se of X){const Ee=x(Se,$);Ee<0?ie.push(Se):Ee>0?ae.push(Se):ue.push(Se)}return Q<ie.length?P(Q,ie,x):Q<ie.length+ue.length?ue[0]:P(Q-(ie.length+ue.length),ae,x)}function S(Q,X){const x=[];let $;for(const ie of Q.slice(0).sort(X))!$||X($[0],ie)!==0?($=[ie],x.push($)):$.push(ie);return x}function*m(Q,X){let x,$;for(const ie of Q)$!==void 0&&X($,ie)?x.push(ie):(x&&(yield x),x=[ie]),$=ie;x&&(yield x)}function d(Q,X){for(let x=0;x<=Q.length;x++)X(x===0?void 0:Q[x-1],x===Q.length?void 0:Q[x])}function l(Q,X){for(let x=0;x<Q.length;x++)X(x===0?void 0:Q[x-1],Q[x],x+1===Q.length?void 0:Q[x+1])}function g(Q,X,x){const $=[];function ie(Se,Ee,Re){if(Ee===0&&Re.length===0)return;const Te=$[$.length-1];Te&&Te.start+Te.deleteCount===Se?(Te.deleteCount+=Ee,Te.toInsert.push(...Re)):$.push({start:Se,deleteCount:Ee,toInsert:Re})}let ae=0,ue=0;for(;;){if(ae===Q.length){ie(ae,0,X.slice(ue));break}if(ue===X.length){ie(ae,Q.length-ae,[]);break}const Se=Q[ae],Ee=X[ue],Re=x(Se,Ee);Re===0?(ae+=1,ue+=1):Re<0?(ie(ae,1,[]),ae+=1):Re>0&&(ie(ae,0,[Ee]),ue+=1)}return $}function I(Q,X,x){const $=g(Q,X,x),ie=[],ae=[];for(const ue of $)ie.push(...Q.slice(ue.start,ue.start+ue.deleteCount)),ae.push(...ue.toInsert);return{removed:ie,added:ae}}function v(Q,X,x){if(x===0)return[];const $=Q.slice(0,x).sort(X);return C(Q,X,$,x,Q.length),$}function f(Q,X,x,$,ie){return x===0?Promise.resolve([]):new Promise((ae,ue)=>{(async()=>{const Se=Q.length,Ee=Q.slice(0,x).sort(X);for(let Re=x,Te=Math.min(x+$,Se);Re<Se;Re=Te,Te=Math.min(Te+$,Se)){if(Re>x&&await new Promise(we=>setTimeout(we)),ie&&ie.isCancellationRequested)throw new R.CancellationError;C(Q,X,Ee,Re,Te)}return Ee})().then(ae,ue)})}function C(Q,X,x,$,ie){for(const ae=x.length;$<ie;$++){const ue=Q[$];if(X(ue,x[ae-1])<0){x.pop();const Se=(0,a.findFirstIdxMonotonousOrArrLen)(x,Ee=>X(ue,Ee)<0);x.splice(Se,0,ue)}}}function p(Q){return Q.filter(X=>!!X)}function c(Q){let X=0;for(let x=0;x<Q.length;x++)Q[x]&&(Q[X]=Q[x],X+=1);Q.length=X}function u(Q,X,x){Q.splice(x,0,Q.splice(X,1)[0])}function i(Q){return!Array.isArray(Q)||Q.length===0}function n(Q){return Array.isArray(Q)&&Q.length>0}function t(Q,X=x=>x){const x=new Set;return Q.filter($=>{const ie=X($);return x.has(ie)?!1:(x.add(ie),!0)})}function s(Q){const X=new Set;return x=>{const $=Q(x);return X.has($)?!1:(X.add($),!0)}}function r(Q,X){return Q.length>0?Q[0]:X}function o(Q,X){return Q.length>0?Q[Q.length-1]:X}function h(Q,X,x=($,ie)=>$===ie){let $=0;for(let ie=0,ae=Math.min(Q.length,X.length);ie<ae&&x(Q[ie],X[ie]);ie++)$++;return $}function y(Q,X){let x=typeof X=="number"?Q:0;typeof X=="number"?x=Q:(x=0,X=Q);const $=[];if(x<=X)for(let ie=x;ie<X;ie++)$.push(ie);else for(let ie=x;ie>X;ie--)$.push(ie);return $}function A(Q,X,x){return Q.reduce(($,ie)=>($[X(ie)]=x?x(ie):ie,$),Object.create(null))}function b(Q,X){return Q.push(X),()=>w(Q,X)}function w(Q,X){const x=Q.indexOf(X);if(x>-1)return Q.splice(x,1),X}function O(Q,X,x){const $=Q.slice(0,X),ie=Q.slice(X);return $.concat(x,ie)}function F(Q,X){let x;if(typeof X=="number"){let $=X;x=()=>{const ie=Math.sin($++)*179426549;return ie-Math.floor(ie)}}else x=Math.random;for(let $=Q.length-1;$>0;$-=1){const ie=Math.floor(x()*($+1)),ae=Q[$];Q[$]=Q[ie],Q[ie]=ae}}function N(Q,X){const x=Q.indexOf(X);x>-1&&(Q.splice(x,1),Q.unshift(X))}function M(Q,X){const x=Q.indexOf(X);x>-1&&(Q.splice(x,1),Q.push(X))}function V(Q,X){for(const x of X)Q.push(x)}function z(Q,X){return Array.isArray(Q)?Q.map(X):X(Q)}function J(Q){return Array.isArray(Q)?Q:[Q]}function j(Q){return Q[Math.floor(Math.random()*Q.length)]}function te(Q,X,x){const $=B(Q,X),ie=Q.length,ae=x.length;Q.length=ie+ae;for(let ue=ie-1;ue>=$;ue--)Q[ue+ae]=Q[ue];for(let ue=0;ue<ae;ue++)Q[ue+$]=x[ue]}function q(Q,X,x,$){const ie=B(Q,X);let ae=Q.splice(ie,x);return ae===void 0&&(ae=[]),te(Q,ie,$),ae}function B(Q,X){return X<0?Math.max(X+Q.length,0):Math.min(X,Q.length)}var Z;(function(Q){function X(ae){return ae<0}Q.isLessThan=X;function x(ae){return ae<=0}Q.isLessThanOrEqual=x;function $(ae){return ae>0}Q.isGreaterThan=$;function ie(ae){return ae===0}Q.isNeitherLessOrGreaterThan=ie,Q.greaterThan=1,Q.lessThan=-1,Q.neitherLessOrGreaterThan=0})(Z||(e.CompareResult=Z={}));function ne(Q,X){return(x,$)=>X(Q(x),Q($))}function le(...Q){return(X,x)=>{for(const $ of Q){const ie=$(X,x);if(!Z.isNeitherLessOrGreaterThan(ie))return ie}return Z.neitherLessOrGreaterThan}}const ee=(Q,X)=>Q-X;e.numberComparator=ee;const K=(Q,X)=>(0,e.numberComparator)(Q?1:0,X?1:0);e.booleanComparator=K;function H(Q){return(X,x)=>-Q(X,x)}class W{constructor(X){this.items=X,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(X){let x=this.firstIdx;for(;x<this.items.length&&X(this.items[x]);)x++;const $=x===this.firstIdx?null:this.items.slice(this.firstIdx,x);return this.firstIdx=x,$}takeFromEndWhile(X){let x=this.lastIdx;for(;x>=0&&X(this.items[x]);)x--;const $=x===this.lastIdx?null:this.items.slice(x+1,this.lastIdx+1);return this.lastIdx=x,$}peek(){if(this.length!==0)return this.items[this.firstIdx]}peekLast(){if(this.length!==0)return this.items[this.lastIdx]}dequeue(){const X=this.items[this.firstIdx];return this.firstIdx++,X}removeLast(){const X=this.items[this.lastIdx];return this.lastIdx--,X}takeCount(X){const x=this.items.slice(this.firstIdx,this.firstIdx+X);return this.firstIdx+=X,x}}e.ArrayQueue=W;class U{static{this.empty=new U(X=>{})}constructor(X){this.iterate=X}forEach(X){this.iterate(x=>(X(x),!0))}toArray(){const X=[];return this.iterate(x=>(X.push(x),!0)),X}filter(X){return new U(x=>this.iterate($=>X($)?x($):!0))}map(X){return new U(x=>this.iterate($=>x(X($))))}some(X){let x=!1;return this.iterate($=>(x=X($),!x)),x}findFirst(X){let x;return this.iterate($=>X($)?(x=$,!1):!0),x}findLast(X){let x;return this.iterate($=>(X($)&&(x=$),!0)),x}findLastMaxBy(X){let x,$=!0;return this.iterate(ie=>(($||Z.isGreaterThan(X(ie,x)))&&($=!1,x=ie),!0)),x}}e.CallbackIterable=U;class G{constructor(X){this._indexMap=X}static createSortPermutation(X,x){const $=Array.from(X.keys()).sort((ie,ae)=>x(X[ie],X[ae]));return new G($)}apply(X){return X.map((x,$)=>X[this._indexMap[$]])}inverse(){const X=this._indexMap.slice();for(let x=0;x<this._indexMap.length;x++)X[this._indexMap[x]]=x;return new G(X)}}e.Permutation=G;async function oe(Q,X){return(await Promise.all(Q.map(async($,ie)=>({element:$,ok:await X($,ie)})))).find($=>$.ok)?.element}}),define(he[133],fe([0,1,8]),function(ce,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=a,e.assertNever=_,e.assert=T,e.softAssert=k,e.assertFn=L,e.checkAdjacentItems=D;function a(E,P){if(!E)throw new Error(P?`Assertion failed (${P})`:"Assertion Failed")}function _(E,P="Unreachable"){throw new Error(P)}function T(E,P="unexpected state"){if(!E)throw new R.BugIndicatingError(`Assertion Failed: ${P}`)}function k(E){E||(0,R.onUnexpectedError)(new R.BugIndicatingError("Soft Assertion Failed"))}function L(E){if(!E()){debugger;E(),(0,R.onUnexpectedError)(new R.BugIndicatingError("Assertion Failed"))}}function D(E,P){let S=0;for(;S<E.length-1;){const m=E[S],d=E[S+1];if(!P(m,d))return!1;S++}return!0}}),define(he[89],fe([0,1]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createSingleCallFunction=R;function R(a,_){const T=this;let k=!1,L;return function(){if(k)return L;if(k=!0,_)try{L=a.apply(T,arguments)}finally{_()}else L=a.apply(T,arguments);return L}}}),define(he[63],fe([0,1]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var R;(function(a){function _(i){return i&&typeof i=="object"&&typeof i[Symbol.iterator]=="function"}a.is=_;const T=Object.freeze([]);function k(){return T}a.empty=k;function*L(i){yield i}a.single=L;function D(i){return _(i)?i:L(i)}a.wrap=D;function E(i){return i||T}a.from=E;function*P(i){for(let n=i.length-1;n>=0;n--)yield i[n]}a.reverse=P;function S(i){return!i||i[Symbol.iterator]().next().done===!0}a.isEmpty=S;function m(i){return i[Symbol.iterator]().next().value}a.first=m;function d(i,n){let t=0;for(const s of i)if(n(s,t++))return!0;return!1}a.some=d;function l(i,n){for(const t of i)if(n(t))return t}a.find=l;function*g(i,n){for(const t of i)n(t)&&(yield t)}a.filter=g;function*I(i,n){let t=0;for(const s of i)yield n(s,t++)}a.map=I;function*v(i,n){let t=0;for(const s of i)yield*n(s,t++)}a.flatMap=v;function*f(...i){for(const n of i)yield*n}a.concat=f;function C(i,n,t){let s=t;for(const r of i)s=n(s,r);return s}a.reduce=C;function*p(i,n,t=i.length){for(n<0&&(n+=i.length),t<0?t+=i.length:t>i.length&&(t=i.length);n<t;n++)yield i[n]}a.slice=p;function c(i,n=Number.POSITIVE_INFINITY){const t=[];if(n===0)return[t,i];const s=i[Symbol.iterator]();for(let r=0;r<n;r++){const o=s.next();if(o.done)return[t,a.empty()];t.push(o.value)}return[t,{[Symbol.iterator](){return s}}]}a.consume=c;async function u(i){const n=[];for await(const t of i)n.push(t);return Promise.resolve(n)}a.asyncToArray=u})(R||(e.Iterable=R={}))}),define(he[36],fe([0,1]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.createScanner=k,e.getLocation=S,e.parse=m,e.parseTree=d,e.findNodeAtLocation=l,e.getNodePath=g,e.getNodeValue=I,e.contains=v,e.findNodeAtOffset=f,e.visit=C,e.getNodeType=p;var R;(function(c){c[c.None=0]="None",c[c.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",c[c.UnexpectedEndOfString=2]="UnexpectedEndOfString",c[c.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",c[c.InvalidUnicode=4]="InvalidUnicode",c[c.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",c[c.InvalidCharacter=6]="InvalidCharacter"})(R||(e.ScanError=R={}));var a;(function(c){c[c.OpenBraceToken=1]="OpenBraceToken",c[c.CloseBraceToken=2]="CloseBraceToken",c[c.OpenBracketToken=3]="OpenBracketToken",c[c.CloseBracketToken=4]="CloseBracketToken",c[c.CommaToken=5]="CommaToken",c[c.ColonToken=6]="ColonToken",c[c.NullKeyword=7]="NullKeyword",c[c.TrueKeyword=8]="TrueKeyword",c[c.FalseKeyword=9]="FalseKeyword",c[c.StringLiteral=10]="StringLiteral",c[c.NumericLiteral=11]="NumericLiteral",c[c.LineCommentTrivia=12]="LineCommentTrivia",c[c.BlockCommentTrivia=13]="BlockCommentTrivia",c[c.LineBreakTrivia=14]="LineBreakTrivia",c[c.Trivia=15]="Trivia",c[c.Unknown=16]="Unknown",c[c.EOF=17]="EOF"})(a||(e.SyntaxKind=a={}));var _;(function(c){c[c.InvalidSymbol=1]="InvalidSymbol",c[c.InvalidNumberFormat=2]="InvalidNumberFormat",c[c.PropertyNameExpected=3]="PropertyNameExpected",c[c.ValueExpected=4]="ValueExpected",c[c.ColonExpected=5]="ColonExpected",c[c.CommaExpected=6]="CommaExpected",c[c.CloseBraceExpected=7]="CloseBraceExpected",c[c.CloseBracketExpected=8]="CloseBracketExpected",c[c.EndOfFileExpected=9]="EndOfFileExpected",c[c.InvalidCommentToken=10]="InvalidCommentToken",c[c.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",c[c.UnexpectedEndOfString=12]="UnexpectedEndOfString",c[c.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",c[c.InvalidUnicode=14]="InvalidUnicode",c[c.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",c[c.InvalidCharacter=16]="InvalidCharacter"})(_||(e.ParseErrorCode=_={}));var T;(function(c){c.DEFAULT={allowTrailingComma:!0}})(T||(e.ParseOptions=T={}));function k(c,u=!1){let i=0;const n=c.length;let t="",s=0,r=a.Unknown,o=R.None;function h(N){let M=0,V=0;for(;M<N;){const z=c.charCodeAt(i);if(z>=P._0&&z<=P._9)V=V*16+z-P._0;else if(z>=P.A&&z<=P.F)V=V*16+z-P.A+10;else if(z>=P.a&&z<=P.f)V=V*16+z-P.a+10;else break;i++,M++}return M<N&&(V=-1),V}function y(N){i=N,t="",s=0,r=a.Unknown,o=R.None}function A(){const N=i;if(c.charCodeAt(i)===P._0)i++;else for(i++;i<c.length&&E(c.charCodeAt(i));)i++;if(i<c.length&&c.charCodeAt(i)===P.dot)if(i++,i<c.length&&E(c.charCodeAt(i)))for(i++;i<c.length&&E(c.charCodeAt(i));)i++;else return o=R.UnexpectedEndOfNumber,c.substring(N,i);let M=i;if(i<c.length&&(c.charCodeAt(i)===P.E||c.charCodeAt(i)===P.e))if(i++,(i<c.length&&c.charCodeAt(i)===P.plus||c.charCodeAt(i)===P.minus)&&i++,i<c.length&&E(c.charCodeAt(i))){for(i++;i<c.length&&E(c.charCodeAt(i));)i++;M=i}else o=R.UnexpectedEndOfNumber;return c.substring(N,M)}function b(){let N="",M=i;for(;;){if(i>=n){N+=c.substring(M,i),o=R.UnexpectedEndOfString;break}const V=c.charCodeAt(i);if(V===P.doubleQuote){N+=c.substring(M,i),i++;break}if(V===P.backslash){if(N+=c.substring(M,i),i++,i>=n){o=R.UnexpectedEndOfString;break}switch(c.charCodeAt(i++)){case P.doubleQuote:N+='"';break;case P.backslash:N+="\\";break;case P.slash:N+="/";break;case P.b:N+="\b";break;case P.f:N+="\f";break;case P.n:N+=`
`;break;case P.r:N+="\r";break;case P.t:N+="	";break;case P.u:{const J=h(4);J>=0?N+=String.fromCharCode(J):o=R.InvalidUnicode;break}default:o=R.InvalidEscapeCharacter}M=i;continue}if(V>=0&&V<=31)if(D(V)){N+=c.substring(M,i),o=R.UnexpectedEndOfString;break}else o=R.InvalidCharacter;i++}return N}function w(){if(t="",o=R.None,s=i,i>=n)return s=n,r=a.EOF;let N=c.charCodeAt(i);if(L(N)){do i++,t+=String.fromCharCode(N),N=c.charCodeAt(i);while(L(N));return r=a.Trivia}if(D(N))return i++,t+=String.fromCharCode(N),N===P.carriageReturn&&c.charCodeAt(i)===P.lineFeed&&(i++,t+=`
`),r=a.LineBreakTrivia;switch(N){case P.openBrace:return i++,r=a.OpenBraceToken;case P.closeBrace:return i++,r=a.CloseBraceToken;case P.openBracket:return i++,r=a.OpenBracketToken;case P.closeBracket:return i++,r=a.CloseBracketToken;case P.colon:return i++,r=a.ColonToken;case P.comma:return i++,r=a.CommaToken;case P.doubleQuote:return i++,t=b(),r=a.StringLiteral;case P.slash:{const M=i-1;if(c.charCodeAt(i+1)===P.slash){for(i+=2;i<n&&!D(c.charCodeAt(i));)i++;return t=c.substring(M,i),r=a.LineCommentTrivia}if(c.charCodeAt(i+1)===P.asterisk){i+=2;const V=n-1;let z=!1;for(;i<V;){if(c.charCodeAt(i)===P.asterisk&&c.charCodeAt(i+1)===P.slash){i+=2,z=!0;break}i++}return z||(i++,o=R.UnexpectedEndOfComment),t=c.substring(M,i),r=a.BlockCommentTrivia}return t+=String.fromCharCode(N),i++,r=a.Unknown}case P.minus:if(t+=String.fromCharCode(N),i++,i===n||!E(c.charCodeAt(i)))return r=a.Unknown;case P._0:case P._1:case P._2:case P._3:case P._4:case P._5:case P._6:case P._7:case P._8:case P._9:return t+=A(),r=a.NumericLiteral;default:for(;i<n&&O(N);)i++,N=c.charCodeAt(i);if(s!==i){switch(t=c.substring(s,i),t){case"true":return r=a.TrueKeyword;case"false":return r=a.FalseKeyword;case"null":return r=a.NullKeyword}return r=a.Unknown}return t+=String.fromCharCode(N),i++,r=a.Unknown}}function O(N){if(L(N)||D(N))return!1;switch(N){case P.closeBrace:case P.closeBracket:case P.openBrace:case P.openBracket:case P.doubleQuote:case P.colon:case P.comma:case P.slash:return!1}return!0}function F(){let N;do N=w();while(N>=a.LineCommentTrivia&&N<=a.Trivia);return N}return{setPosition:y,getPosition:()=>i,scan:u?F:w,getToken:()=>r,getTokenValue:()=>t,getTokenOffset:()=>s,getTokenLength:()=>i-s,getTokenError:()=>o}}function L(c){return c===P.space||c===P.tab||c===P.verticalTab||c===P.formFeed||c===P.nonBreakingSpace||c===P.ogham||c>=P.enQuad&&c<=P.zeroWidthSpace||c===P.narrowNoBreakSpace||c===P.mathematicalSpace||c===P.ideographicSpace||c===P.byteOrderMark}function D(c){return c===P.lineFeed||c===P.carriageReturn||c===P.lineSeparator||c===P.paragraphSeparator}function E(c){return c>=P._0&&c<=P._9}var P;(function(c){c[c.nullCharacter=0]="nullCharacter",c[c.maxAsciiCharacter=127]="maxAsciiCharacter",c[c.lineFeed=10]="lineFeed",c[c.carriageReturn=13]="carriageReturn",c[c.lineSeparator=8232]="lineSeparator",c[c.paragraphSeparator=8233]="paragraphSeparator",c[c.nextLine=133]="nextLine",c[c.space=32]="space",c[c.nonBreakingSpace=160]="nonBreakingSpace",c[c.enQuad=8192]="enQuad",c[c.emQuad=8193]="emQuad",c[c.enSpace=8194]="enSpace",c[c.emSpace=8195]="emSpace",c[c.threePerEmSpace=8196]="threePerEmSpace",c[c.fourPerEmSpace=8197]="fourPerEmSpace",c[c.sixPerEmSpace=8198]="sixPerEmSpace",c[c.figureSpace=8199]="figureSpace",c[c.punctuationSpace=8200]="punctuationSpace",c[c.thinSpace=8201]="thinSpace",c[c.hairSpace=8202]="hairSpace",c[c.zeroWidthSpace=8203]="zeroWidthSpace",c[c.narrowNoBreakSpace=8239]="narrowNoBreakSpace",c[c.ideographicSpace=12288]="ideographicSpace",c[c.mathematicalSpace=8287]="mathematicalSpace",c[c.ogham=5760]="ogham",c[c._=95]="_",c[c.$=36]="$",c[c._0=48]="_0",c[c._1=49]="_1",c[c._2=50]="_2",c[c._3=51]="_3",c[c._4=52]="_4",c[c._5=53]="_5",c[c._6=54]="_6",c[c._7=55]="_7",c[c._8=56]="_8",c[c._9=57]="_9",c[c.a=97]="a",c[c.b=98]="b",c[c.c=99]="c",c[c.d=100]="d",c[c.e=101]="e",c[c.f=102]="f",c[c.g=103]="g",c[c.h=104]="h",c[c.i=105]="i",c[c.j=106]="j",c[c.k=107]="k",c[c.l=108]="l",c[c.m=109]="m",c[c.n=110]="n",c[c.o=111]="o",c[c.p=112]="p",c[c.q=113]="q",c[c.r=114]="r",c[c.s=115]="s",c[c.t=116]="t",c[c.u=117]="u",c[c.v=118]="v",c[c.w=119]="w",c[c.x=120]="x",c[c.y=121]="y",c[c.z=122]="z",c[c.A=65]="A",c[c.B=66]="B",c[c.C=67]="C",c[c.D=68]="D",c[c.E=69]="E",c[c.F=70]="F",c[c.G=71]="G",c[c.H=72]="H",c[c.I=73]="I",c[c.J=74]="J",c[c.K=75]="K",c[c.L=76]="L",c[c.M=77]="M",c[c.N=78]="N",c[c.O=79]="O",c[c.P=80]="P",c[c.Q=81]="Q",c[c.R=82]="R",c[c.S=83]="S",c[c.T=84]="T",c[c.U=85]="U",c[c.V=86]="V",c[c.W=87]="W",c[c.X=88]="X",c[c.Y=89]="Y",c[c.Z=90]="Z",c[c.ampersand=38]="ampersand",c[c.asterisk=42]="asterisk",c[c.at=64]="at",c[c.backslash=92]="backslash",c[c.bar=124]="bar",c[c.caret=94]="caret",c[c.closeBrace=125]="closeBrace",c[c.closeBracket=93]="closeBracket",c[c.closeParen=41]="closeParen",c[c.colon=58]="colon",c[c.comma=44]="comma",c[c.dot=46]="dot",c[c.doubleQuote=34]="doubleQuote",c[c.equals=61]="equals",c[c.exclamation=33]="exclamation",c[c.greaterThan=62]="greaterThan",c[c.lessThan=60]="lessThan",c[c.minus=45]="minus",c[c.openBrace=123]="openBrace",c[c.openBracket=91]="openBracket",c[c.openParen=40]="openParen",c[c.percent=37]="percent",c[c.plus=43]="plus",c[c.question=63]="question",c[c.semicolon=59]="semicolon",c[c.singleQuote=39]="singleQuote",c[c.slash=47]="slash",c[c.tilde=126]="tilde",c[c.backspace=8]="backspace",c[c.formFeed=12]="formFeed",c[c.byteOrderMark=65279]="byteOrderMark",c[c.tab=9]="tab",c[c.verticalTab=11]="verticalTab"})(P||(P={}));function S(c,u){const i=[],n=new Object;let t;const s={value:{},offset:0,length:0,type:"object",parent:void 0};let r=!1;function o(h,y,A,b){s.value=h,s.offset=y,s.length=A,s.type=b,s.colonOffset=void 0,t=s}try{C(c,{onObjectBegin:(h,y)=>{if(u<=h)throw n;t=void 0,r=u>h,i.push("")},onObjectProperty:(h,y,A)=>{if(u<y||(o(h,y,A,"property"),i[i.length-1]=h,u<=y+A))throw n},onObjectEnd:(h,y)=>{if(u<=h)throw n;t=void 0,i.pop()},onArrayBegin:(h,y)=>{if(u<=h)throw n;t=void 0,i.push(0)},onArrayEnd:(h,y)=>{if(u<=h)throw n;t=void 0,i.pop()},onLiteralValue:(h,y,A)=>{if(u<y||(o(h,y,A,p(h)),u<=y+A))throw n},onSeparator:(h,y,A)=>{if(u<=y)throw n;if(h===":"&&t&&t.type==="property")t.colonOffset=y,r=!1,t=void 0;else if(h===","){const b=i[i.length-1];typeof b=="number"?i[i.length-1]=b+1:(r=!0,i[i.length-1]=""),t=void 0}}})}catch(h){if(h!==n)throw h}return{path:i,previousNode:t,isAtPropertyKey:r,matches:h=>{let y=0;for(let A=0;y<h.length&&A<i.length;A++)if(h[y]===i[A]||h[y]==="*")y++;else if(h[y]!=="**")return!1;return y===h.length}}}function m(c,u=[],i=T.DEFAULT){let n=null,t=[];const s=[];function r(h){Array.isArray(t)?t.push(h):n!==null&&(t[n]=h)}return C(c,{onObjectBegin:()=>{const h={};r(h),s.push(t),t=h,n=null},onObjectProperty:h=>{n=h},onObjectEnd:()=>{t=s.pop()},onArrayBegin:()=>{const h=[];r(h),s.push(t),t=h,n=null},onArrayEnd:()=>{t=s.pop()},onLiteralValue:r,onError:(h,y,A)=>{u.push({error:h,offset:y,length:A})}},i),t[0]}function d(c,u=[],i=T.DEFAULT){let n={type:"array",offset:-1,length:-1,children:[],parent:void 0};function t(h){n.type==="property"&&(n.length=h-n.offset,n=n.parent)}function s(h){return n.children.push(h),h}C(c,{onObjectBegin:h=>{n=s({type:"object",offset:h,length:-1,parent:n,children:[]})},onObjectProperty:(h,y,A)=>{n=s({type:"property",offset:y,length:-1,parent:n,children:[]}),n.children.push({type:"string",value:h,offset:y,length:A,parent:n})},onObjectEnd:(h,y)=>{n.length=h+y-n.offset,n=n.parent,t(h+y)},onArrayBegin:(h,y)=>{n=s({type:"array",offset:h,length:-1,parent:n,children:[]})},onArrayEnd:(h,y)=>{n.length=h+y-n.offset,n=n.parent,t(h+y)},onLiteralValue:(h,y,A)=>{s({type:p(h),offset:y,length:A,parent:n,value:h}),t(y+A)},onSeparator:(h,y,A)=>{n.type==="property"&&(h===":"?n.colonOffset=y:h===","&&t(y))},onError:(h,y,A)=>{u.push({error:h,offset:y,length:A})}},i);const o=n.children[0];return o&&delete o.parent,o}function l(c,u){if(!c)return;let i=c;for(const n of u)if(typeof n=="string"){if(i.type!=="object"||!Array.isArray(i.children))return;let t=!1;for(const s of i.children)if(Array.isArray(s.children)&&s.children[0].value===n){i=s.children[1],t=!0;break}if(!t)return}else{const t=n;if(i.type!=="array"||t<0||!Array.isArray(i.children)||t>=i.children.length)return;i=i.children[t]}return i}function g(c){if(!c.parent||!c.parent.children)return[];const u=g(c.parent);if(c.parent.type==="property"){const i=c.parent.children[0].value;u.push(i)}else if(c.parent.type==="array"){const i=c.parent.children.indexOf(c);i!==-1&&u.push(i)}return u}function I(c){switch(c.type){case"array":return c.children.map(I);case"object":{const u=Object.create(null);for(const i of c.children){const n=i.children[1];n&&(u[i.children[0].value]=I(n))}return u}case"null":case"string":case"number":case"boolean":return c.value;default:return}}function v(c,u,i=!1){return u>=c.offset&&u<c.offset+c.length||i&&u===c.offset+c.length}function f(c,u,i=!1){if(v(c,u,i)){const n=c.children;if(Array.isArray(n))for(let t=0;t<n.length&&n[t].offset<=u;t++){const s=f(n[t],u,i);if(s)return s}return c}}function C(c,u,i=T.DEFAULT){const n=k(c,!1);function t(ne){return ne?()=>ne(n.getTokenOffset(),n.getTokenLength()):()=>!0}function s(ne){return ne?le=>ne(le,n.getTokenOffset(),n.getTokenLength()):()=>!0}const r=t(u.onObjectBegin),o=s(u.onObjectProperty),h=t(u.onObjectEnd),y=t(u.onArrayBegin),A=t(u.onArrayEnd),b=s(u.onLiteralValue),w=s(u.onSeparator),O=t(u.onComment),F=s(u.onError),N=i&&i.disallowComments,M=i&&i.allowTrailingComma;function V(){for(;;){const ne=n.scan();switch(n.getTokenError()){case R.InvalidUnicode:z(_.InvalidUnicode);break;case R.InvalidEscapeCharacter:z(_.InvalidEscapeCharacter);break;case R.UnexpectedEndOfNumber:z(_.UnexpectedEndOfNumber);break;case R.UnexpectedEndOfComment:N||z(_.UnexpectedEndOfComment);break;case R.UnexpectedEndOfString:z(_.UnexpectedEndOfString);break;case R.InvalidCharacter:z(_.InvalidCharacter);break}switch(ne){case a.LineCommentTrivia:case a.BlockCommentTrivia:N?z(_.InvalidCommentToken):O();break;case a.Unknown:z(_.InvalidSymbol);break;case a.Trivia:case a.LineBreakTrivia:break;default:return ne}}}function z(ne,le=[],ee=[]){if(F(ne),le.length+ee.length>0){let K=n.getToken();for(;K!==a.EOF;){if(le.indexOf(K)!==-1){V();break}else if(ee.indexOf(K)!==-1)break;K=V()}}}function J(ne){const le=n.getTokenValue();return ne?b(le):o(le),V(),!0}function j(){switch(n.getToken()){case a.NumericLiteral:{let ne=0;try{ne=JSON.parse(n.getTokenValue()),typeof ne!="number"&&(z(_.InvalidNumberFormat),ne=0)}catch{z(_.InvalidNumberFormat)}b(ne);break}case a.NullKeyword:b(null);break;case a.TrueKeyword:b(!0);break;case a.FalseKeyword:b(!1);break;default:return!1}return V(),!0}function te(){return n.getToken()!==a.StringLiteral?(z(_.PropertyNameExpected,[],[a.CloseBraceToken,a.CommaToken]),!1):(J(!1),n.getToken()===a.ColonToken?(w(":"),V(),Z()||z(_.ValueExpected,[],[a.CloseBraceToken,a.CommaToken])):z(_.ColonExpected,[],[a.CloseBraceToken,a.CommaToken]),!0)}function q(){r(),V();let ne=!1;for(;n.getToken()!==a.CloseBraceToken&&n.getToken()!==a.EOF;){if(n.getToken()===a.CommaToken){if(ne||z(_.ValueExpected,[],[]),w(","),V(),n.getToken()===a.CloseBraceToken&&M)break}else ne&&z(_.CommaExpected,[],[]);te()||z(_.ValueExpected,[],[a.CloseBraceToken,a.CommaToken]),ne=!0}return h(),n.getToken()!==a.CloseBraceToken?z(_.CloseBraceExpected,[a.CloseBraceToken],[]):V(),!0}function B(){y(),V();let ne=!1;for(;n.getToken()!==a.CloseBracketToken&&n.getToken()!==a.EOF;){if(n.getToken()===a.CommaToken){if(ne||z(_.ValueExpected,[],[]),w(","),V(),n.getToken()===a.CloseBracketToken&&M)break}else ne&&z(_.CommaExpected,[],[]);Z()||z(_.ValueExpected,[],[a.CloseBracketToken,a.CommaToken]),ne=!0}return A(),n.getToken()!==a.CloseBracketToken?z(_.CloseBracketExpected,[a.CloseBracketToken],[]):V(),!0}function Z(){switch(n.getToken()){case a.OpenBracketToken:return B();case a.OpenBraceToken:return q();case a.StringLiteral:return J(!0);default:return j()}}return V(),n.getToken()===a.EOF?i.allowEmptyContent?!0:(z(_.ValueExpected,[],[]),!1):Z()?(n.getToken()!==a.EOF&&z(_.EndOfFileExpected,[],[]),!0):(z(_.ValueExpected,[],[]),!1)}function p(c){switch(typeof c){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(c){if(Array.isArray(c))return"array"}else return"null";return"object"}default:return"null"}}}),define(he[45],fe([0,1,36]),function(ce,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.format=a,e.toFormattedString=_,e.getEOL=L,e.isEOL=D;function a(E,P,S){let m,d,l,g,I;if(P){for(g=P.offset,I=g+P.length,l=g;l>0&&!D(E,l-1);)l--;let o=I;for(;o<E.length&&!D(E,o);)o++;d=E.substring(l,o),m=k(d,S)}else d=E,m=0,l=0,g=0,I=E.length;const v=L(S,E);let f=!1,C=0,p;S.insertSpaces?p=T(" ",S.tabSize||4):p="	";const c=(0,R.createScanner)(d,!1);let u=!1;function i(){return v+T(p,m+C)}function n(){let o=c.scan();for(f=!1;o===R.SyntaxKind.Trivia||o===R.SyntaxKind.LineBreakTrivia;)f=f||o===R.SyntaxKind.LineBreakTrivia,o=c.scan();return u=o===R.SyntaxKind.Unknown||c.getTokenError()!==R.ScanError.None,o}const t=[];function s(o,h,y){!u&&h<I&&y>g&&E.substring(h,y)!==o&&t.push({offset:h,length:y-h,content:o})}let r=n();if(r!==R.SyntaxKind.EOF){const o=c.getTokenOffset()+l,h=T(p,m);s(h,l,o)}for(;r!==R.SyntaxKind.EOF;){let o=c.getTokenOffset()+c.getTokenLength()+l,h=n(),y="";for(;!f&&(h===R.SyntaxKind.LineCommentTrivia||h===R.SyntaxKind.BlockCommentTrivia);){const b=c.getTokenOffset()+l;s(" ",o,b),o=c.getTokenOffset()+c.getTokenLength()+l,y=h===R.SyntaxKind.LineCommentTrivia?i():"",h=n()}if(h===R.SyntaxKind.CloseBraceToken)r!==R.SyntaxKind.OpenBraceToken&&(C--,y=i());else if(h===R.SyntaxKind.CloseBracketToken)r!==R.SyntaxKind.OpenBracketToken&&(C--,y=i());else{switch(r){case R.SyntaxKind.OpenBracketToken:case R.SyntaxKind.OpenBraceToken:C++,y=i();break;case R.SyntaxKind.CommaToken:case R.SyntaxKind.LineCommentTrivia:y=i();break;case R.SyntaxKind.BlockCommentTrivia:f?y=i():y=" ";break;case R.SyntaxKind.ColonToken:y=" ";break;case R.SyntaxKind.StringLiteral:if(h===R.SyntaxKind.ColonToken){y="";break}case R.SyntaxKind.NullKeyword:case R.SyntaxKind.TrueKeyword:case R.SyntaxKind.FalseKeyword:case R.SyntaxKind.NumericLiteral:case R.SyntaxKind.CloseBraceToken:case R.SyntaxKind.CloseBracketToken:h===R.SyntaxKind.LineCommentTrivia||h===R.SyntaxKind.BlockCommentTrivia?y=" ":h!==R.SyntaxKind.CommaToken&&h!==R.SyntaxKind.EOF&&(u=!0);break;case R.SyntaxKind.Unknown:u=!0;break}f&&(h===R.SyntaxKind.LineCommentTrivia||h===R.SyntaxKind.BlockCommentTrivia)&&(y=i())}const A=c.getTokenOffset()+l;s(y,o,A),r=h}return t}function _(E,P){const S=JSON.stringify(E,void 0,P.insertSpaces?P.tabSize||4:"	");return P.eol!==void 0?S.replace(/\r\n|\r|\n/g,P.eol):S}function T(E,P){let S="";for(let m=0;m<P;m++)S+=E;return S}function k(E,P){let S=0,m=0;const d=P.tabSize||4;for(;S<E.length;){const l=E.charAt(S);if(l===" ")m++;else if(l==="	")m+=d;else break;S++}return Math.floor(m/d)}function L(E,P){for(let S=0;S<P.length;S++){const m=P.charAt(S);if(m==="\r")return S+1<P.length&&P.charAt(S+1)===`
`?`\r
`:"\r";if(m===`
`)return`
`}return E&&E.eol||`
`}function D(E,P){return`\r
`.indexOf(E.charAt(P))!==-1}}),define(he[64],fe([0,1,36,45]),function(ce,e,R,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeProperty=_,e.setProperty=T,e.withFormatting=k,e.applyEdit=L,e.applyEdits=D;function _(E,P,S){return T(E,P,void 0,S)}function T(E,P,S,m,d){const l=P.slice(),g=[],I=(0,R.parseTree)(E,g);let v,f;for(;l.length>0&&(f=l.pop(),v=(0,R.findNodeAtLocation)(I,l),v===void 0&&S!==void 0);)typeof f=="string"?S={[f]:S}:S=[S];if(v)if(v.type==="object"&&typeof f=="string"&&Array.isArray(v.children)){const C=(0,R.findNodeAtLocation)(v,[f]);if(C!==void 0)if(S===void 0){if(!C.parent)throw new Error("Malformed AST");const p=v.children.indexOf(C.parent);let c,u=C.parent.offset+C.parent.length;if(p>0){const i=v.children[p-1];c=i.offset+i.length}else c=v.offset+1,v.children.length>1&&(u=v.children[1].offset);return k(E,{offset:c,length:u-c,content:""},m)}else return k(E,{offset:C.offset,length:C.length,content:JSON.stringify(S)},m);else{if(S===void 0)return[];const p=`${JSON.stringify(f)}: ${JSON.stringify(S)}`,c=d?d(v.children.map(i=>i.children[0].value)):v.children.length;let u;if(c>0){const i=v.children[c-1];u={offset:i.offset+i.length,length:0,content:","+p}}else v.children.length===0?u={offset:v.offset+1,length:0,content:p}:u={offset:v.offset+1,length:0,content:p+","};return k(E,u,m)}}else if(v.type==="array"&&typeof f=="number"&&Array.isArray(v.children))if(S!==void 0){const C=`${JSON.stringify(S)}`;let p;if(v.children.length===0||f===0)p={offset:v.offset+1,length:0,content:v.children.length===0?C:C+","};else{const c=f===-1||f>v.children.length?v.children.length:f,u=v.children[c-1];p={offset:u.offset+u.length,length:0,content:","+C}}return k(E,p,m)}else{const C=f,p=v.children[C];let c;if(v.children.length===1)c={offset:v.offset+1,length:v.length-2,content:""};else if(v.children.length-1===C){const u=v.children[C-1],i=u.offset+u.length,n=v.offset+v.length;c={offset:i,length:n-2-i,content:""}}else c={offset:p.offset,length:v.children[C+1].offset-p.offset,content:""};return k(E,c,m)}else throw new Error(`Can not add ${typeof f!="number"?"index":"property"} to parent of type ${v.type}`);else return S===void 0?[]:k(E,{offset:I?I.offset:0,length:I?I.length:0,content:JSON.stringify(S)},m)}function k(E,P,S){let m=L(E,P),d=P.offset,l=P.offset+P.content.length;if(P.length===0||P.content.length===0){for(;d>0&&!(0,a.isEOL)(m,d-1);)d--;for(;l<m.length&&!(0,a.isEOL)(m,l);)l++}const g=(0,a.format)(m,{offset:d,length:l-d},S);for(let v=g.length-1;v>=0;v--){const f=g[v];m=L(m,f),d=Math.min(d,f.offset),l=Math.max(l,f.offset+f.length),l+=f.content.length-f.length}const I=E.length-(m.length-l)-d;return[{offset:d,length:I,content:m.substring(d,l)}]}function L(E,P){return E.substring(0,P.offset)+P.content+E.substring(P.offset+P.length)}function D(E,P){const S=P.slice(0).sort((d,l)=>{const g=d.offset-l.offset;return g===0?d.length-l.length:g});let m=E.length;for(let d=S.length-1;d>=0;d--){const l=S[d];if(l.offset+l.length<=m)E=L(E,l);else throw new Error("Overlapping edit");m=l.offset}return E}}),define(he[134],fe([0,1]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getCompressedContent=R;function R(T){let k=!1;const L=new Map,D=new Map;if(_(T,g=>{if(T===g)return!0;const I=JSON.stringify(g);if(I.length<30)return!0;const v=L.get(I);if(!v){const f={schemas:[g]};return L.set(I,f),D.set(g,f),!0}return v.schemas.push(g),D.set(g,v),k=!0,!1}),L.clear(),!k)return JSON.stringify(T);let P="$defs";for(;T.hasOwnProperty(P);)P+="_";const S=[];function m(g){return JSON.stringify(g,(I,v)=>{if(v!==g){const f=D.get(v);if(f&&f.schemas.length>1)return f.id||(f.id=`_${S.length}`,S.push(f.schemas[0])),{$ref:`#/${P}/${f.id}`}}return v})}const d=m(T),l=[];for(let g=0;g<S.length;g++)l.push(`"_${g}":${m(S[g])}`);return l.length?`${d.substring(0,d.length-1)},"${P}":{${l.join(",")}}}`:d}function a(T){return typeof T=="object"&&T!==null}function _(T,k){if(!T||typeof T!="object")return;const L=(...d)=>{for(const l of d)a(l)&&S.push(l)},D=(...d)=>{for(const l of d)if(a(l))for(const g in l){const I=l[g];a(I)&&S.push(I)}},E=(...d)=>{for(const l of d)if(Array.isArray(l))for(const g of l)a(g)&&S.push(g)},P=d=>{if(Array.isArray(d))for(const l of d)a(l)&&S.push(l);else a(d)&&S.push(d)},S=[T];let m=S.pop();for(;m;)k(m)&&(L(m.additionalItems,m.additionalProperties,m.not,m.contains,m.propertyNames,m.if,m.then,m.else,m.unevaluatedItems,m.unevaluatedProperties),D(m.definitions,m.$defs,m.properties,m.patternProperties,m.dependencies,m.dependentSchemas),E(m.anyOf,m.allOf,m.oneOf,m.prefixItems),P(m.items)),m=S.pop()}}),define(he[53],fe([0,1]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class R{constructor(_){this.executor=_,this._didRun=!1}get hasValue(){return this._didRun}get value(){if(!this._didRun)try{this._value=this.executor()}catch(_){this._error=_}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}}e.Lazy=R}),define(he[90],fe([0,1]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class R{static{this.Undefined=new R(void 0)}constructor(T){this.element=T,this.next=R.Undefined,this.prev=R.Undefined}}class a{constructor(){this._first=R.Undefined,this._last=R.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===R.Undefined}clear(){let T=this._first;for(;T!==R.Undefined;){const k=T.next;T.prev=R.Undefined,T.next=R.Undefined,T=k}this._first=R.Undefined,this._last=R.Undefined,this._size=0}unshift(T){return this._insert(T,!1)}push(T){return this._insert(T,!0)}_insert(T,k){const L=new R(T);if(this._first===R.Undefined)this._first=L,this._last=L;else if(k){const E=this._last;this._last=L,L.prev=E,E.next=L}else{const E=this._first;this._first=L,L.next=E,E.prev=L}this._size+=1;let D=!1;return()=>{D||(D=!0,this._remove(L))}}shift(){if(this._first!==R.Undefined){const T=this._first.element;return this._remove(this._first),T}}pop(){if(this._last!==R.Undefined){const T=this._last.element;return this._remove(this._last),T}}_remove(T){if(T.prev!==R.Undefined&&T.next!==R.Undefined){const k=T.prev;k.next=T.next,T.next.prev=k}else T.prev===R.Undefined&&T.next===R.Undefined?(this._first=R.Undefined,this._last=R.Undefined):T.next===R.Undefined?(this._last=this._last.prev,this._last.next=R.Undefined):T.prev===R.Undefined&&(this._first=this._first.next,this._first.prev=R.Undefined);this._size-=1}*[Symbol.iterator](){let T=this._first;for(;T!==R.Undefined;)yield T.element,T=T.next}}e.LinkedList=a}),define(he[31],fe([0,1]),function(ce,e){"use strict";var R,a,_;Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.BidirectionalMap=e.CounterSet=e.MRUCache=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=void 0,e.getOrSet=T,e.mapToString=k,e.setToString=L,e.mapsStrictEqualIgnoreOrder=p;function T(c,u,i){let n=c.get(u);return n===void 0&&(n=i,c.set(u,n)),n}function k(c){const u=[];return c.forEach((i,n)=>{u.push(`${n} => ${i}`)}),`Map(${c.size}) {${u.join(", ")}}`}function L(c){const u=[];return c.forEach(i=>{u.push(i)}),`Set(${c.size}) {${u.join(", ")}}`}class D{constructor(u,i){this.uri=u,this.value=i}}function E(c){return Array.isArray(c)}class P{static{this.defaultToKey=u=>u.toString()}constructor(u,i){if(this[R]="ResourceMap",u instanceof P)this.map=new Map(u.map),this.toKey=i??P.defaultToKey;else if(E(u)){this.map=new Map,this.toKey=i??P.defaultToKey;for(const[n,t]of u)this.set(n,t)}else this.map=new Map,this.toKey=u??P.defaultToKey}set(u,i){return this.map.set(this.toKey(u),new D(u,i)),this}get(u){return this.map.get(this.toKey(u))?.value}has(u){return this.map.has(this.toKey(u))}get size(){return this.map.size}clear(){this.map.clear()}delete(u){return this.map.delete(this.toKey(u))}forEach(u,i){typeof i<"u"&&(u=u.bind(i));for(const[n,t]of this.map)u(t.value,t.uri,this)}*values(){for(const u of this.map.values())yield u.value}*keys(){for(const u of this.map.values())yield u.uri}*entries(){for(const u of this.map.values())yield[u.uri,u.value]}*[(R=Symbol.toStringTag,Symbol.iterator)](){for(const[,u]of this.map)yield[u.uri,u.value]}}e.ResourceMap=P;class S{constructor(u,i){this[a]="ResourceSet",!u||typeof u=="function"?this._map=new P(u):(this._map=new P(i),u.forEach(this.add,this))}get size(){return this._map.size}add(u){return this._map.set(u,u),this}clear(){this._map.clear()}delete(u){return this._map.delete(u)}forEach(u,i){this._map.forEach((n,t)=>u.call(i,t,t,this))}has(u){return this._map.has(u)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(a=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=S;var m;(function(c){c[c.None=0]="None",c[c.AsOld=1]="AsOld",c[c.AsNew=2]="AsNew"})(m||(e.Touch=m={}));class d{constructor(){this[_]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(u){return this._map.has(u)}get(u,i=m.None){const n=this._map.get(u);if(n)return i!==m.None&&this.touch(n,i),n.value}set(u,i,n=m.None){let t=this._map.get(u);if(t)t.value=i,n!==m.None&&this.touch(t,n);else{switch(t={key:u,value:i,next:void 0,previous:void 0},n){case m.None:this.addItemLast(t);break;case m.AsOld:this.addItemFirst(t);break;case m.AsNew:this.addItemLast(t);break;default:this.addItemLast(t);break}this._map.set(u,t),this._size++}return this}delete(u){return!!this.remove(u)}remove(u){const i=this._map.get(u);if(i)return this._map.delete(u),this.removeItem(i),this._size--,i.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const u=this._head;return this._map.delete(u.key),this.removeItem(u),this._size--,u.value}forEach(u,i){const n=this._state;let t=this._head;for(;t;){if(i?u.bind(i)(t.value,t.key,this):u(t.value,t.key,this),this._state!==n)throw new Error("LinkedMap got modified during iteration.");t=t.next}}keys(){const u=this,i=this._state;let n=this._head;const t={[Symbol.iterator](){return t},next(){if(u._state!==i)throw new Error("LinkedMap got modified during iteration.");if(n){const s={value:n.key,done:!1};return n=n.next,s}else return{value:void 0,done:!0}}};return t}values(){const u=this,i=this._state;let n=this._head;const t={[Symbol.iterator](){return t},next(){if(u._state!==i)throw new Error("LinkedMap got modified during iteration.");if(n){const s={value:n.value,done:!1};return n=n.next,s}else return{value:void 0,done:!0}}};return t}entries(){const u=this,i=this._state;let n=this._head;const t={[Symbol.iterator](){return t},next(){if(u._state!==i)throw new Error("LinkedMap got modified during iteration.");if(n){const s={value:[n.key,n.value],done:!1};return n=n.next,s}else return{value:void 0,done:!0}}};return t}[(_=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(u){if(u>=this.size)return;if(u===0){this.clear();return}let i=this._head,n=this.size;for(;i&&n>u;)this._map.delete(i.key),i=i.next,n--;this._head=i,this._size=n,i&&(i.previous=void 0),this._state++}trimNew(u){if(u>=this.size)return;if(u===0){this.clear();return}let i=this._tail,n=this.size;for(;i&&n>u;)this._map.delete(i.key),i=i.previous,n--;this._tail=i,this._size=n,i&&(i.next=void 0),this._state++}addItemFirst(u){if(!this._head&&!this._tail)this._tail=u;else if(this._head)u.next=this._head,this._head.previous=u;else throw new Error("Invalid list");this._head=u,this._state++}addItemLast(u){if(!this._head&&!this._tail)this._head=u;else if(this._tail)u.previous=this._tail,this._tail.next=u;else throw new Error("Invalid list");this._tail=u,this._state++}removeItem(u){if(u===this._head&&u===this._tail)this._head=void 0,this._tail=void 0;else if(u===this._head){if(!u.next)throw new Error("Invalid list");u.next.previous=void 0,this._head=u.next}else if(u===this._tail){if(!u.previous)throw new Error("Invalid list");u.previous.next=void 0,this._tail=u.previous}else{const i=u.next,n=u.previous;if(!i||!n)throw new Error("Invalid list");i.previous=n,n.next=i}u.next=void 0,u.previous=void 0,this._state++}touch(u,i){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(i!==m.AsOld&&i!==m.AsNew)){if(i===m.AsOld){if(u===this._head)return;const n=u.next,t=u.previous;u===this._tail?(t.next=void 0,this._tail=t):(n.previous=t,t.next=n),u.previous=void 0,u.next=this._head,this._head.previous=u,this._head=u,this._state++}else if(i===m.AsNew){if(u===this._tail)return;const n=u.next,t=u.previous;u===this._head?(n.previous=void 0,this._head=n):(n.previous=t,t.next=n),u.next=void 0,u.previous=this._tail,this._tail.next=u,this._tail=u,this._state++}}}toJSON(){const u=[];return this.forEach((i,n)=>{u.push([n,i])}),u}fromJSON(u){this.clear();for(const[i,n]of u)this.set(i,n)}}e.LinkedMap=d;class l extends d{constructor(u,i=1){super(),this._limit=u,this._ratio=Math.min(Math.max(0,i),1)}get limit(){return this._limit}set limit(u){this._limit=u,this.checkTrim()}get ratio(){return this._ratio}set ratio(u){this._ratio=Math.min(Math.max(0,u),1),this.checkTrim()}get(u,i=m.AsNew){return super.get(u,i)}peek(u){return super.get(u,m.None)}set(u,i){return super.set(u,i,m.AsNew),this}checkTrim(){this.size>this._limit&&this.trim(Math.round(this._limit*this._ratio))}}class g extends l{constructor(u,i=1){super(u,i)}trim(u){this.trimOld(u)}set(u,i){return super.set(u,i),this.checkTrim(),this}}e.LRUCache=g;class I extends l{constructor(u,i=1){super(u,i)}trim(u){this.trimNew(u)}set(u,i){return this._limit<=this.size&&!this.has(u)&&this.trim(Math.round(this._limit*this._ratio)-1),super.set(u,i),this}}e.MRUCache=I;class v{constructor(){this.map=new Map}add(u){return this.map.set(u,(this.map.get(u)||0)+1),this}delete(u){let i=this.map.get(u)||0;return i===0?!1:(i--,i===0?this.map.delete(u):this.map.set(u,i),!0)}has(u){return this.map.has(u)}}e.CounterSet=v;class f{constructor(u){if(this._m1=new Map,this._m2=new Map,u)for(const[i,n]of u)this.set(i,n)}clear(){this._m1.clear(),this._m2.clear()}set(u,i){this._m1.set(u,i),this._m2.set(i,u)}get(u){return this._m1.get(u)}getKey(u){return this._m2.get(u)}delete(u){const i=this._m1.get(u);return i===void 0?!1:(this._m1.delete(u),this._m2.delete(i),!0)}forEach(u,i){this._m1.forEach((n,t)=>{u.call(i,n,t,this)})}keys(){return this._m1.keys()}values(){return this._m1.values()}}e.BidirectionalMap=f;class C{constructor(){this.map=new Map}add(u,i){let n=this.map.get(u);n||(n=new Set,this.map.set(u,n)),n.add(i)}delete(u,i){const n=this.map.get(u);n&&(n.delete(i),n.size===0&&this.map.delete(u))}forEach(u,i){const n=this.map.get(u);n&&n.forEach(i)}get(u){const i=this.map.get(u);return i||new Set}}e.SetMap=C;function p(c,u){if(c===u)return!0;if(c.size!==u.size)return!1;for(const[i,n]of c)if(!u.has(i)||u.get(i)!==n)return!1;for(const[i]of u)if(!c.has(i))return!1;return!0}}),define(he[2],fe([0,1,17,132,31,89,63]),function(ce,e,R,a,_,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DisposableMap=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MandatoryMutableDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.DisposableTracker=void 0,e.setDisposableTracker=P,e.trackDisposable=S,e.markAsDisposed=m,e.markAsSingleton=g,e.isDisposable=I,e.dispose=v,e.disposeIfDisposable=f,e.combinedDisposable=C,e.toDisposable=p,e.disposeOnReturn=y;const L=!1;let D=null;class E{constructor(){this.livingDisposables=new Map}static{this.idx=0}getDisposableData(w){let O=this.livingDisposables.get(w);return O||(O={parent:null,source:null,isSingleton:!1,value:w,idx:E.idx++},this.livingDisposables.set(w,O)),O}trackDisposable(w){const O=this.getDisposableData(w);O.source||(O.source=new Error().stack)}setParent(w,O){const F=this.getDisposableData(w);F.parent=O}markAsDisposed(w){this.livingDisposables.delete(w)}markAsSingleton(w){this.getDisposableData(w).isSingleton=!0}getRootParent(w,O){const F=O.get(w);if(F)return F;const N=w.parent?this.getRootParent(this.getDisposableData(w.parent),O):w;return O.set(w,N),N}getTrackedDisposables(){const w=new Map;return[...this.livingDisposables.entries()].filter(([,F])=>F.source!==null&&!this.getRootParent(F,w).isSingleton).flatMap(([F])=>F)}computeLeakingDisposables(w=10,O){let F;if(O)F=O;else{const J=new Map,j=[...this.livingDisposables.values()].filter(q=>q.source!==null&&!this.getRootParent(q,J).isSingleton);if(j.length===0)return;const te=new Set(j.map(q=>q.value));if(F=j.filter(q=>!(q.parent&&te.has(q.parent))),F.length===0)throw new Error("There are cyclic diposable chains!")}if(!F)return;function N(J){function j(q,B){for(;q.length>0&&B.some(Z=>typeof Z=="string"?Z===q[0]:q[0].match(Z));)q.shift()}const te=J.source.split(`
`).map(q=>q.trim().replace("at ","")).filter(q=>q!=="");return j(te,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),te.reverse()}const M=new _.SetMap;for(const J of F){const j=N(J);for(let te=0;te<=j.length;te++)M.add(j.slice(0,te).join(`
`),J)}F.sort((0,R.compareBy)(J=>J.idx,R.numberComparator));let V="",z=0;for(const J of F.slice(0,w)){z++;const j=N(J),te=[];for(let q=0;q<j.length;q++){let B=j[q];B=`(shared with ${M.get(j.slice(0,q+1).join(`
`)).size}/${F.length} leaks) at ${B}`;const ne=M.get(j.slice(0,q).join(`
`)),le=(0,a.groupBy)([...ne].map(ee=>N(ee)[q]),ee=>ee);delete le[j[q]];for(const[ee,K]of Object.entries(le))te.unshift(`    - stacktraces of ${K.length} other leaks continue with ${ee}`);te.unshift(B)}V+=`


==================== Leaking disposable ${z}/${F.length}: ${J.value.constructor.name} ====================
${te.join(`
`)}
============================================================

`}return F.length>w&&(V+=`


... and ${F.length-w} more leaking disposables

`),{leaks:F,details:V}}}e.DisposableTracker=E;function P(b){D=b}if(L){const b="__is_disposable_tracked__";P(new class{trackDisposable(w){const O=new Error("Potentially leaked disposable").stack;setTimeout(()=>{w[b]||console.log(O)},3e3)}setParent(w,O){if(w&&w!==u.None)try{w[b]=!0}catch{}}markAsDisposed(w){if(w&&w!==u.None)try{w[b]=!0}catch{}}markAsSingleton(w){}})}function S(b){return D?.trackDisposable(b),b}function m(b){D?.markAsDisposed(b)}function d(b,w){D?.setParent(b,w)}function l(b,w){if(D)for(const O of b)D.setParent(O,w)}function g(b){return D?.markAsSingleton(b),b}function I(b){return typeof b=="object"&&b!==null&&typeof b.dispose=="function"&&b.dispose.length===0}function v(b){if(k.Iterable.is(b)){const w=[];for(const O of b)if(O)try{O.dispose()}catch(F){w.push(F)}if(w.length===1)throw w[0];if(w.length>1)throw new AggregateError(w,"Encountered errors while disposing of store");return Array.isArray(b)?[]:b}else if(b)return b.dispose(),b}function f(b){for(const w of b)I(w)&&w.dispose();return[]}function C(...b){const w=p(()=>v(b));return l(b,w),w}function p(b){const w=S({dispose:(0,T.createSingleCallFunction)(()=>{m(w),b()})});return w}class c{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this._toDispose=new Set,this._isDisposed=!1,S(this)}dispose(){this._isDisposed||(m(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){if(this._toDispose.size!==0)try{v(this._toDispose)}finally{this._toDispose.clear()}}add(w){if(!w)return w;if(w===this)throw new Error("Cannot register a disposable on itself!");return d(w,this),this._isDisposed?c.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(w),w}delete(w){if(w){if(w===this)throw new Error("Cannot dispose a disposable on itself!");this._toDispose.delete(w),w.dispose()}}deleteAndLeak(w){w&&this._toDispose.has(w)&&(this._toDispose.delete(w),d(w,null))}}e.DisposableStore=c;class u{static{this.None=Object.freeze({dispose(){}})}constructor(){this._store=new c,S(this),d(this._store,this)}dispose(){m(this),this._store.dispose()}_register(w){if(w===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(w)}}e.Disposable=u;class i{constructor(){this._isDisposed=!1,S(this)}get value(){return this._isDisposed?void 0:this._value}set value(w){this._isDisposed||w===this._value||(this._value?.dispose(),w&&d(w,this),this._value=w)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,m(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const w=this._value;return this._value=void 0,w&&d(w,null),w}}e.MutableDisposable=i;class n{constructor(w){this._disposable=new i,this._isDisposed=!1,this._disposable.value=w}get value(){return this._disposable.value}set value(w){this._isDisposed||w===this._disposable.value||(this._disposable.value=w)}dispose(){this._isDisposed=!0,this._disposable.dispose()}}e.MandatoryMutableDisposable=n;class t{constructor(w){this._disposable=w,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter===0&&this._disposable.dispose(),this}}e.RefCountedDisposable=t;class s{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,S(this)}set(w){let O=w;return this.unset=()=>O=void 0,this.isset=()=>O!==void 0,this.dispose=()=>{O&&(O(),O=void 0,m(this))},this}}e.SafeDisposable=s;class r{constructor(){this.references=new Map}acquire(w,...O){let F=this.references.get(w);F||(F={counter:0,object:this.createReferencedObject(w,...O)},this.references.set(w,F));const{object:N}=F,M=(0,T.createSingleCallFunction)(()=>{--F.counter===0&&(this.destroyReferencedObject(w,F.object),this.references.delete(w))});return F.counter++,{object:N,dispose:M}}}e.ReferenceCollection=r;class o{constructor(w){this.referenceCollection=w}async acquire(w,...O){const F=this.referenceCollection.acquire(w,...O);try{return{object:await F.object,dispose:()=>F.dispose()}}catch(N){throw F.dispose(),N}}}e.AsyncReferenceCollection=o;class h{constructor(w){this.object=w}dispose(){}}e.ImmortalReference=h;function y(b){const w=new c;try{b(w)}finally{w.dispose()}}class A{constructor(){this._store=new Map,this._isDisposed=!1,S(this)}dispose(){m(this),this._isDisposed=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this._store.size)try{v(this._store.values())}finally{this._store.clear()}}has(w){return this._store.has(w)}get size(){return this._store.size}get(w){return this._store.get(w)}set(w,O,F=!1){this._isDisposed&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),F||this._store.get(w)?.dispose(),this._store.set(w,O)}deleteAndDispose(w){this._store.get(w)?.dispose(),this._store.delete(w)}deleteAndLeak(w){const O=this._store.get(w);return this._store.delete(w),O}keys(){return this._store.keys()}values(){return this._store.values()}[Symbol.iterator](){return this._store[Symbol.iterator]()}}e.DisposableMap=A}),define(he[65],fe([0,1]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MarshalledId=void 0;var R;(function(a){a[a.Uri=1]="Uri",a[a.Regexp=2]="Regexp",a[a.ScmResource=3]="ScmResource",a[a.ScmResourceGroup=4]="ScmResourceGroup",a[a.ScmProvider=5]="ScmProvider",a[a.CommentController=6]="CommentController",a[a.CommentThread=7]="CommentThread",a[a.CommentThreadInstance=8]="CommentThreadInstance",a[a.CommentThreadReply=9]="CommentThreadReply",a[a.CommentNode=10]="CommentNode",a[a.CommentThreadNode=11]="CommentThreadNode",a[a.TimelineActionContext=12]="TimelineActionContext",a[a.NotebookCellActionContext=13]="NotebookCellActionContext",a[a.NotebookActionContext=14]="NotebookActionContext",a[a.TerminalContext=15]="TerminalContext",a[a.TestItemContext=16]="TestItemContext",a[a.Date=17]="Date",a[a.TestMessageMenuArgs=18]="TestMessageMenuArgs"})(R||(e.MarshalledId=R={}))}),define(he[91],fe([0,1,31]),function(ce,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=void 0,e.normalizeNFC=_,e.normalizeNFD=k;const a=new R.LRUCache(1e4);function _(E){return D(E,"NFC",a)}const T=new R.LRUCache(1e4);function k(E){return D(E,"NFD",T)}const L=/[^\u0000-\u0080]/;function D(E,P,S){if(!E)return E;const m=S.get(E);if(m)return m;let d;return L.test(E)?d=E.normalize(P):d=E,S.set(E,d),d}e.removeAccents=function(){const E=/[\u0300-\u036f]/g;return function(P){return k(P).replace(E,"")}}()}),function(){function ce(_){const T=[];typeof _=="number"&&T.push("code/timeOrigin",_);function k(D){T.push(D,Date.now())}function L(){const D=[];for(let E=0;E<T.length;E+=2)D.push({name:T[E],startTime:T[E+1]});return D}return{mark:k,getMarks:L}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?ce():{mark(_){performance.mark(_)},getMarks(){let _=performance.timeOrigin;typeof _!="number"&&(_=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const T=[{name:"code/timeOrigin",startTime:Math.round(_)}];for(const k of performance.getEntriesByType("mark"))T.push({name:k.name,startTime:Math.round(_+k.startTime)});return T}};if(typeof process=="object"){const _=performance?.timeOrigin;return ce(_)}else return console.trace("perf-util loaded in UNKNOWN environment"),ce()}function R(_){return _.MonacoPerformanceMarks||(_.MonacoPerformanceMarks=e()),_.MonacoPerformanceMarks}var a;typeof global=="object"?a=global:typeof self=="object"?a=self:a={},typeof define=="function"?define("vs/base/common/performance",[],function(){return R(a)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=R(a):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),a.perf=R(a))}(),function(ce,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var R=e();for(var a in R)(typeof exports=="object"?exports:ce)[a]=R[a]}}(typeof self<"u"?self:this,function(){return function(ce){var e={};function R(a){if(e[a])return e[a].exports;var _=e[a]={i:a,l:!1,exports:{}};return ce[a].call(_.exports,_,_.exports,R),_.l=!0,_.exports}return R.m=ce,R.c=e,R.d=function(a,_,T){R.o(a,_)||Object.defineProperty(a,_,{enumerable:!0,get:T})},R.r=function(a){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(a,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(a,"__esModule",{value:!0})},R.t=function(a,_){if(1&_&&(a=R(a)),8&_||4&_&&typeof a=="object"&&a&&a.__esModule)return a;var T=Object.create(null);if(R.r(T),Object.defineProperty(T,"default",{enumerable:!0,value:a}),2&_&&typeof a!="string")for(var k in a)R.d(T,k,function(L){return a[L]}.bind(null,k));return T},R.n=function(a){var _=a&&a.__esModule?function(){return a.default}:function(){return a};return R.d(_,"a",_),_},R.o=function(a,_){return Object.prototype.hasOwnProperty.call(a,_)},R.p="",R(R.s=0)}([function(ce,e,R){(function(a){var _;e=ce.exports=K,_=typeof a=="object"&&a.env&&a.env.NODE_DEBUG&&/\bsemver\b/i.test(a.env.NODE_DEBUG)?function(){var re=Array.prototype.slice.call(arguments,0);re.unshift("SEMVER"),console.log.apply(console,re)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var T=256,k=Number.MAX_SAFE_INTEGER||9007199254740991,L=e.re=[],D=e.src=[],E=0,P=E++;D[P]="0|[1-9]\\d*";var S=E++;D[S]="[0-9]+";var m=E++;D[m]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var d=E++;D[d]="("+D[P]+")\\.("+D[P]+")\\.("+D[P]+")";var l=E++;D[l]="("+D[S]+")\\.("+D[S]+")\\.("+D[S]+")";var g=E++;D[g]="(?:"+D[P]+"|"+D[m]+")";var I=E++;D[I]="(?:"+D[S]+"|"+D[m]+")";var v=E++;D[v]="(?:-("+D[g]+"(?:\\."+D[g]+")*))";var f=E++;D[f]="(?:-?("+D[I]+"(?:\\."+D[I]+")*))";var C=E++;D[C]="[0-9A-Za-z-]+";var p=E++;D[p]="(?:\\+("+D[C]+"(?:\\."+D[C]+")*))";var c=E++,u="v?"+D[d]+D[v]+"?"+D[p]+"?";D[c]="^"+u+"$";var i="[v=\\s]*"+D[l]+D[f]+"?"+D[p]+"?",n=E++;D[n]="^"+i+"$";var t=E++;D[t]="((?:<|>)?=?)";var s=E++;D[s]=D[S]+"|x|X|\\*";var r=E++;D[r]=D[P]+"|x|X|\\*";var o=E++;D[o]="[v=\\s]*("+D[r]+")(?:\\.("+D[r]+")(?:\\.("+D[r]+")(?:"+D[v]+")?"+D[p]+"?)?)?";var h=E++;D[h]="[v=\\s]*("+D[s]+")(?:\\.("+D[s]+")(?:\\.("+D[s]+")(?:"+D[f]+")?"+D[p]+"?)?)?";var y=E++;D[y]="^"+D[t]+"\\s*"+D[o]+"$";var A=E++;D[A]="^"+D[t]+"\\s*"+D[h]+"$";var b=E++;D[b]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var w=E++;D[w]="(?:~>?)";var O=E++;D[O]="(\\s*)"+D[w]+"\\s+",L[O]=new RegExp(D[O],"g");var F=E++;D[F]="^"+D[w]+D[o]+"$";var N=E++;D[N]="^"+D[w]+D[h]+"$";var M=E++;D[M]="(?:\\^)";var V=E++;D[V]="(\\s*)"+D[M]+"\\s+",L[V]=new RegExp(D[V],"g");var z=E++;D[z]="^"+D[M]+D[o]+"$";var J=E++;D[J]="^"+D[M]+D[h]+"$";var j=E++;D[j]="^"+D[t]+"\\s*("+i+")$|^$";var te=E++;D[te]="^"+D[t]+"\\s*("+u+")$|^$";var q=E++;D[q]="(\\s*)"+D[t]+"\\s*("+i+"|"+D[o]+")",L[q]=new RegExp(D[q],"g");var B=E++;D[B]="^\\s*("+D[o]+")\\s+-\\s+("+D[o]+")\\s*$";var Z=E++;D[Z]="^\\s*("+D[h]+")\\s+-\\s+("+D[h]+")\\s*$";var ne=E++;D[ne]="(<|>)?=?\\s*\\*";for(var le=0;le<35;le++)_(le,D[le]),L[le]||(L[le]=new RegExp(D[le]));function ee(re,de){if(re instanceof K)return re;if(typeof re!="string"||re.length>T||!(de?L[n]:L[c]).test(re))return null;try{return new K(re,de)}catch{return null}}function K(re,de){if(re instanceof K){if(re.loose===de)return re;re=re.version}else if(typeof re!="string")throw new TypeError("Invalid Version: "+re);if(re.length>T)throw new TypeError("version is longer than "+T+" characters");if(!(this instanceof K))return new K(re,de);_("SemVer",re,de),this.loose=de;var me=re.trim().match(de?L[n]:L[c]);if(!me)throw new TypeError("Invalid Version: "+re);if(this.raw=re,this.major=+me[1],this.minor=+me[2],this.patch=+me[3],this.major>k||this.major<0)throw new TypeError("Invalid major version");if(this.minor>k||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>k||this.patch<0)throw new TypeError("Invalid patch version");me[4]?this.prerelease=me[4].split(".").map(function(be){if(/^[0-9]+$/.test(be)){var Ce=+be;if(Ce>=0&&Ce<k)return Ce}return be}):this.prerelease=[],this.build=me[5]?me[5].split("."):[],this.format()}e.parse=ee,e.valid=function(re,de){var me=ee(re,de);return me?me.version:null},e.clean=function(re,de){var me=ee(re.trim().replace(/^[=v]+/,""),de);return me?me.version:null},e.SemVer=K,K.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},K.prototype.toString=function(){return this.version},K.prototype.compare=function(re){return _("SemVer.compare",this.version,this.loose,re),re instanceof K||(re=new K(re,this.loose)),this.compareMain(re)||this.comparePre(re)},K.prototype.compareMain=function(re){return re instanceof K||(re=new K(re,this.loose)),W(this.major,re.major)||W(this.minor,re.minor)||W(this.patch,re.patch)},K.prototype.comparePre=function(re){if(re instanceof K||(re=new K(re,this.loose)),this.prerelease.length&&!re.prerelease.length)return-1;if(!this.prerelease.length&&re.prerelease.length)return 1;if(!this.prerelease.length&&!re.prerelease.length)return 0;var de=0;do{var me=this.prerelease[de],be=re.prerelease[de];if(_("prerelease compare",de,me,be),me===void 0&&be===void 0)return 0;if(be===void 0)return 1;if(me===void 0)return-1;if(me!==be)return W(me,be)}while(++de)},K.prototype.inc=function(re,de){switch(re){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",de);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",de);break;case"prepatch":this.prerelease.length=0,this.inc("patch",de),this.inc("pre",de);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",de),this.inc("pre",de);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var me=this.prerelease.length;--me>=0;)typeof this.prerelease[me]=="number"&&(this.prerelease[me]++,me=-2);me===-1&&this.prerelease.push(0)}de&&(this.prerelease[0]===de?isNaN(this.prerelease[1])&&(this.prerelease=[de,0]):this.prerelease=[de,0]);break;default:throw new Error("invalid increment argument: "+re)}return this.format(),this.raw=this.version,this},e.inc=function(re,de,me,be){typeof me=="string"&&(be=me,me=void 0);try{return new K(re,me).inc(de,be).version}catch{return null}},e.diff=function(re,de){if(Q(re,de))return null;var me=ee(re),be=ee(de);if(me.prerelease.length||be.prerelease.length){for(var Ce in me)if((Ce==="major"||Ce==="minor"||Ce==="patch")&&me[Ce]!==be[Ce])return"pre"+Ce;return"prerelease"}for(var Ce in me)if((Ce==="major"||Ce==="minor"||Ce==="patch")&&me[Ce]!==be[Ce])return Ce},e.compareIdentifiers=W;var H=/^[0-9]+$/;function W(re,de){var me=H.test(re),be=H.test(de);return me&&be&&(re=+re,de=+de),me&&!be?-1:be&&!me?1:re<de?-1:re>de?1:0}function U(re,de,me){return new K(re,me).compare(new K(de,me))}function G(re,de,me){return U(re,de,me)>0}function oe(re,de,me){return U(re,de,me)<0}function Q(re,de,me){return U(re,de,me)===0}function X(re,de,me){return U(re,de,me)!==0}function x(re,de,me){return U(re,de,me)>=0}function $(re,de,me){return U(re,de,me)<=0}function ie(re,de,me,be){var Ce;switch(de){case"===":typeof re=="object"&&(re=re.version),typeof me=="object"&&(me=me.version),Ce=re===me;break;case"!==":typeof re=="object"&&(re=re.version),typeof me=="object"&&(me=me.version),Ce=re!==me;break;case"":case"=":case"==":Ce=Q(re,me,be);break;case"!=":Ce=X(re,me,be);break;case">":Ce=G(re,me,be);break;case">=":Ce=x(re,me,be);break;case"<":Ce=oe(re,me,be);break;case"<=":Ce=$(re,me,be);break;default:throw new TypeError("Invalid operator: "+de)}return Ce}function ae(re,de){if(re instanceof ae){if(re.loose===de)return re;re=re.value}if(!(this instanceof ae))return new ae(re,de);_("comparator",re,de),this.loose=de,this.parse(re),this.semver===ue?this.value="":this.value=this.operator+this.semver.version,_("comp",this)}e.rcompareIdentifiers=function(re,de){return W(de,re)},e.major=function(re,de){return new K(re,de).major},e.minor=function(re,de){return new K(re,de).minor},e.patch=function(re,de){return new K(re,de).patch},e.compare=U,e.compareLoose=function(re,de){return U(re,de,!0)},e.rcompare=function(re,de,me){return U(de,re,me)},e.sort=function(re,de){return re.sort(function(me,be){return e.compare(me,be,de)})},e.rsort=function(re,de){return re.sort(function(me,be){return e.rcompare(me,be,de)})},e.gt=G,e.lt=oe,e.eq=Q,e.neq=X,e.gte=x,e.lte=$,e.cmp=ie,e.Comparator=ae;var ue={};function Se(re,de){if(re instanceof Se)return re.loose===de?re:new Se(re.raw,de);if(re instanceof ae)return new Se(re.value,de);if(!(this instanceof Se))return new Se(re,de);if(this.loose=de,this.raw=re,this.set=re.split(/\s*\|\|\s*/).map(function(me){return this.parseRange(me.trim())},this).filter(function(me){return me.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+re);this.format()}function Ee(re){return!re||re.toLowerCase()==="x"||re==="*"}function Re(re,de,me,be,Ce,Ue,_e,Ae,Fe,xe,ze,Me,$e){return((de=Ee(me)?"":Ee(be)?">="+me+".0.0":Ee(Ce)?">="+me+"."+be+".0":">="+de)+" "+(Ae=Ee(Fe)?"":Ee(xe)?"<"+(+Fe+1)+".0.0":Ee(ze)?"<"+Fe+"."+(+xe+1)+".0":Me?"<="+Fe+"."+xe+"."+ze+"-"+Me:"<="+Ae)).trim()}function Te(re,de){for(var me=0;me<re.length;me++)if(!re[me].test(de))return!1;if(de.prerelease.length){for(me=0;me<re.length;me++)if(_(re[me].semver),re[me].semver!==ue&&re[me].semver.prerelease.length>0){var be=re[me].semver;if(be.major===de.major&&be.minor===de.minor&&be.patch===de.patch)return!0}return!1}return!0}function we(re,de,me){try{de=new Se(de,me)}catch{return!1}return de.test(re)}function ve(re,de,me,be){var Ce,Ue,_e,Ae,Fe;switch(re=new K(re,be),de=new Se(de,be),me){case">":Ce=G,Ue=$,_e=oe,Ae=">",Fe=">=";break;case"<":Ce=oe,Ue=x,_e=G,Ae="<",Fe="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(we(re,de,be))return!1;for(var xe=0;xe<de.set.length;++xe){var ze=de.set[xe],Me=null,$e=null;if(ze.forEach(function(qe){qe.semver===ue&&(qe=new ae(">=0.0.0")),Me=Me||qe,$e=$e||qe,Ce(qe.semver,Me.semver,be)?Me=qe:_e(qe.semver,$e.semver,be)&&($e=qe)}),Me.operator===Ae||Me.operator===Fe||(!$e.operator||$e.operator===Ae)&&Ue(re,$e.semver)||$e.operator===Fe&&_e(re,$e.semver))return!1}return!0}ae.prototype.parse=function(re){var de=this.loose?L[j]:L[te],me=re.match(de);if(!me)throw new TypeError("Invalid comparator: "+re);this.operator=me[1],this.operator==="="&&(this.operator=""),me[2]?this.semver=new K(me[2],this.loose):this.semver=ue},ae.prototype.toString=function(){return this.value},ae.prototype.test=function(re){return _("Comparator.test",re,this.loose),this.semver===ue||(typeof re=="string"&&(re=new K(re,this.loose)),ie(re,this.operator,this.semver,this.loose))},ae.prototype.intersects=function(re,de){if(!(re instanceof ae))throw new TypeError("a Comparator is required");var me;if(this.operator==="")return me=new Se(re.value,de),we(this.value,me,de);if(re.operator==="")return me=new Se(this.value,de),we(re.semver,me,de);var be=!(this.operator!==">="&&this.operator!==">"||re.operator!==">="&&re.operator!==">"),Ce=!(this.operator!=="<="&&this.operator!=="<"||re.operator!=="<="&&re.operator!=="<"),Ue=this.semver.version===re.semver.version,_e=!(this.operator!==">="&&this.operator!=="<="||re.operator!==">="&&re.operator!=="<="),Ae=ie(this.semver,"<",re.semver,de)&&(this.operator===">="||this.operator===">")&&(re.operator==="<="||re.operator==="<"),Fe=ie(this.semver,">",re.semver,de)&&(this.operator==="<="||this.operator==="<")&&(re.operator===">="||re.operator===">");return be||Ce||Ue&&_e||Ae||Fe},e.Range=Se,Se.prototype.format=function(){return this.range=this.set.map(function(re){return re.join(" ").trim()}).join("||").trim(),this.range},Se.prototype.toString=function(){return this.range},Se.prototype.parseRange=function(re){var de=this.loose;re=re.trim(),_("range",re,de);var me=de?L[Z]:L[B];re=re.replace(me,Re),_("hyphen replace",re),re=re.replace(L[q],"$1$2$3"),_("comparator trim",re,L[q]),re=(re=(re=re.replace(L[O],"$1~")).replace(L[V],"$1^")).split(/\s+/).join(" ");var be=de?L[j]:L[te],Ce=re.split(" ").map(function(Ue){return function(_e,Ae){return _("comp",_e),_e=function(Fe,xe){return Fe.trim().split(/\s+/).map(function(ze){return function(Me,$e){_("caret",Me,$e);var qe=$e?L[J]:L[z];return Me.replace(qe,function(Be,Oe,se,ge,pe){var ye;return _("caret",Me,Be,Oe,se,ge,pe),Ee(Oe)?ye="":Ee(se)?ye=">="+Oe+".0.0 <"+(+Oe+1)+".0.0":Ee(ge)?ye=Oe==="0"?">="+Oe+"."+se+".0 <"+Oe+"."+(+se+1)+".0":">="+Oe+"."+se+".0 <"+(+Oe+1)+".0.0":pe?(_("replaceCaret pr",pe),pe.charAt(0)!=="-"&&(pe="-"+pe),ye=Oe==="0"?se==="0"?">="+Oe+"."+se+"."+ge+pe+" <"+Oe+"."+se+"."+(+ge+1):">="+Oe+"."+se+"."+ge+pe+" <"+Oe+"."+(+se+1)+".0":">="+Oe+"."+se+"."+ge+pe+" <"+(+Oe+1)+".0.0"):(_("no pr"),ye=Oe==="0"?se==="0"?">="+Oe+"."+se+"."+ge+" <"+Oe+"."+se+"."+(+ge+1):">="+Oe+"."+se+"."+ge+" <"+Oe+"."+(+se+1)+".0":">="+Oe+"."+se+"."+ge+" <"+(+Oe+1)+".0.0"),_("caret return",ye),ye})}(ze,xe)}).join(" ")}(_e,Ae),_("caret",_e),_e=function(Fe,xe){return Fe.trim().split(/\s+/).map(function(ze){return function(Me,$e){var qe=$e?L[N]:L[F];return Me.replace(qe,function(Be,Oe,se,ge,pe){var ye;return _("tilde",Me,Be,Oe,se,ge,pe),Ee(Oe)?ye="":Ee(se)?ye=">="+Oe+".0.0 <"+(+Oe+1)+".0.0":Ee(ge)?ye=">="+Oe+"."+se+".0 <"+Oe+"."+(+se+1)+".0":pe?(_("replaceTilde pr",pe),pe.charAt(0)!=="-"&&(pe="-"+pe),ye=">="+Oe+"."+se+"."+ge+pe+" <"+Oe+"."+(+se+1)+".0"):ye=">="+Oe+"."+se+"."+ge+" <"+Oe+"."+(+se+1)+".0",_("tilde return",ye),ye})}(ze,xe)}).join(" ")}(_e,Ae),_("tildes",_e),_e=function(Fe,xe){return _("replaceXRanges",Fe,xe),Fe.split(/\s+/).map(function(ze){return function(Me,$e){Me=Me.trim();var qe=$e?L[A]:L[y];return Me.replace(qe,function(Be,Oe,se,ge,pe,ye){_("xRange",Me,Be,Oe,se,ge,pe,ye);var Le=Ee(se),ke=Le||Ee(ge),We=ke||Ee(pe);return Oe==="="&&We&&(Oe=""),Le?Be=Oe===">"||Oe==="<"?"<0.0.0":"*":Oe&&We?(ke&&(ge=0),We&&(pe=0),Oe===">"?(Oe=">=",ke?(se=+se+1,ge=0,pe=0):We&&(ge=+ge+1,pe=0)):Oe==="<="&&(Oe="<",ke?se=+se+1:ge=+ge+1),Be=Oe+se+"."+ge+"."+pe):ke?Be=">="+se+".0.0 <"+(+se+1)+".0.0":We&&(Be=">="+se+"."+ge+".0 <"+se+"."+(+ge+1)+".0"),_("xRange return",Be),Be})}(ze,xe)}).join(" ")}(_e,Ae),_("xrange",_e),_e=function(Fe,xe){return _("replaceStars",Fe,xe),Fe.trim().replace(L[ne],"")}(_e,Ae),_("stars",_e),_e}(Ue,de)}).join(" ").split(/\s+/);return this.loose&&(Ce=Ce.filter(function(Ue){return!!Ue.match(be)})),Ce=Ce.map(function(Ue){return new ae(Ue,de)})},Se.prototype.intersects=function(re,de){if(!(re instanceof Se))throw new TypeError("a Range is required");return this.set.some(function(me){return me.every(function(be){return re.set.some(function(Ce){return Ce.every(function(Ue){return be.intersects(Ue,de)})})})})},e.toComparators=function(re,de){return new Se(re,de).set.map(function(me){return me.map(function(be){return be.value}).join(" ").trim().split(" ")})},Se.prototype.test=function(re){if(!re)return!1;typeof re=="string"&&(re=new K(re,this.loose));for(var de=0;de<this.set.length;de++)if(Te(this.set[de],re))return!0;return!1},e.satisfies=we,e.maxSatisfying=function(re,de,me){var be=null,Ce=null;try{var Ue=new Se(de,me)}catch{return null}return re.forEach(function(_e){Ue.test(_e)&&(be&&Ce.compare(_e)!==-1||(Ce=new K(be=_e,me)))}),be},e.minSatisfying=function(re,de,me){var be=null,Ce=null;try{var Ue=new Se(de,me)}catch{return null}return re.forEach(function(_e){Ue.test(_e)&&(be&&Ce.compare(_e)!==1||(Ce=new K(be=_e,me)))}),be},e.validRange=function(re,de){try{return new Se(re,de).range||"*"}catch{return null}},e.ltr=function(re,de,me){return ve(re,de,"<",me)},e.gtr=function(re,de,me){return ve(re,de,">",me)},e.outside=ve,e.prerelease=function(re,de){var me=ee(re,de);return me&&me.prerelease.length?me.prerelease:null},e.intersects=function(re,de,me){return re=new Se(re,me),de=new Se(de,me),re.intersects(de)},e.coerce=function(re){if(re instanceof K)return re;if(typeof re!="string")return null;var de=re.match(L[b]);return de==null?null:ee((de[1]||"0")+"."+(de[2]||"0")+"."+(de[3]||"0"))}}).call(this,R(1))},function(ce,e){var R,a,_=ce.exports={};function T(){throw new Error("setTimeout has not been defined")}function k(){throw new Error("clearTimeout has not been defined")}function L(I){if(R===setTimeout)return setTimeout(I,0);if((R===T||!R)&&setTimeout)return R=setTimeout,setTimeout(I,0);try{return R(I,0)}catch{try{return R.call(null,I,0)}catch{return R.call(this,I,0)}}}(function(){try{R=typeof setTimeout=="function"?setTimeout:T}catch{R=T}try{a=typeof clearTimeout=="function"?clearTimeout:k}catch{a=k}})();var D,E=[],P=!1,S=-1;function m(){P&&D&&(P=!1,D.length?E=D.concat(E):S=-1,E.length&&d())}function d(){if(!P){var I=L(m);P=!0;for(var v=E.length;v;){for(D=E,E=[];++S<v;)D&&D[S].run();S=-1,v=E.length}D=null,P=!1,function(f){if(a===clearTimeout)return clearTimeout(f);if((a===k||!a)&&clearTimeout)return a=clearTimeout,clearTimeout(f);try{a(f)}catch{try{return a.call(null,f)}catch{return a.call(this,f)}}}(I)}}function l(I,v){this.fun=I,this.array=v}function g(){}_.nextTick=function(I){var v=new Array(arguments.length-1);if(arguments.length>1)for(var f=1;f<arguments.length;f++)v[f-1]=arguments[f];E.push(new l(I,v)),E.length!==1||P||L(d)},l.prototype.run=function(){this.fun.apply(null,this.array)},_.title="browser",_.browser=!0,_.env={},_.argv=[],_.version="",_.versions={},_.on=g,_.addListener=g,_.once=g,_.off=g,_.removeListener=g,_.removeAllListeners=g,_.emit=g,_.prependListener=g,_.prependOnceListener=g,_.listeners=function(I){return[]},_.binding=function(I){throw new Error("process.binding is not supported")},_.cwd=function(){return"/"},_.chdir=function(I){throw new Error("process.chdir is not supported")},_.umask=function(){return 0}}])}),define(he[135],fe([0,1]),function(ce,e){"use strict";var R;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class a{constructor(L,D,E){this.level=L,this.key=D,this.value=E,this.forward=[]}}const _=void 0;class T{constructor(L,D=2**16){this.comparator=L,this[R]="SkipList",this._level=0,this._size=0,this._maxLevel=Math.max(1,Math.log2(D)|0),this._header=new a(this._maxLevel,_,_)}get size(){return this._size}clear(){this._header=new a(this._maxLevel,_,_),this._size=0}has(L){return!!T._search(this,L,this.comparator)}get(L){return T._search(this,L,this.comparator)?.value}set(L,D){return T._insert(this,L,D,this.comparator)&&(this._size+=1),this}delete(L){const D=T._delete(this,L,this.comparator);return D&&(this._size-=1),D}forEach(L,D){let E=this._header.forward[0];for(;E;)L.call(D,E.value,E.key,this),E=E.forward[0]}[(R=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let L=this._header.forward[0];for(;L;)yield[L.key,L.value],L=L.forward[0]}*keys(){let L=this._header.forward[0];for(;L;)yield L.key,L=L.forward[0]}*values(){let L=this._header.forward[0];for(;L;)yield L.value,L=L.forward[0]}toString(){let L="[SkipList]:",D=this._header.forward[0];for(;D;)L+=`node(${D.key}, ${D.value}, lvl:${D.level})`,D=D.forward[0];return L}static _search(L,D,E){let P=L._header;for(let S=L._level-1;S>=0;S--)for(;P.forward[S]&&E(P.forward[S].key,D)<0;)P=P.forward[S];if(P=P.forward[0],P&&E(P.key,D)===0)return P}static _insert(L,D,E,P){const S=[];let m=L._header;for(let d=L._level-1;d>=0;d--){for(;m.forward[d]&&P(m.forward[d].key,D)<0;)m=m.forward[d];S[d]=m}if(m=m.forward[0],m&&P(m.key,D)===0)return m.value=E,!1;{const d=T._randomLevel(L);if(d>L._level){for(let l=L._level;l<d;l++)S[l]=L._header;L._level=d}m=new a(d,D,E);for(let l=0;l<d;l++)m.forward[l]=S[l].forward[l],S[l].forward[l]=m;return!0}}static _randomLevel(L,D=.5){let E=1;for(;Math.random()<D&&E<L._maxLevel;)E+=1;return E}static _delete(L,D,E){const P=[];let S=L._header;for(let m=L._level-1;m>=0;m--){for(;S.forward[m]&&E(S.forward[m].key,D)<0;)S=S.forward[m];P[m]=S}if(S=S.forward[0],!S||E(S.key,D)!==0)return!1;for(let m=0;m<L._level&&P[m].forward[m]===S;m++)P[m].forward[m]=S.forward[m];for(;L._level>0&&L._header.forward[L._level-1]===_;)L._level-=1;return!0}}e.SkipList=T}),define(he[54],fe([0,1]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const R=globalThis.performance&&typeof globalThis.performance.now=="function";class a{static create(T){return new a(T)}constructor(T){this._now=R&&T===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this._startTime=this._now(),this._stopTime=-1}stop(){this._stopTime=this._now()}reset(){this._startTime=this._now(),this._stopTime=-1}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}}e.StopWatch=a}),define(he[3],fe([0,1,8,89,2,90,54]),function(ce,e,R,a,_,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ValueWithChangeEvent=e.Relay=e.EventBufferer=e.DynamicListEventMultiplexer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.createEventDeliveryQueue=e.Emitter=e.ListenerRefusalError=e.ListenerLeakError=e.EventProfiling=e.Event=void 0,e.setGlobalLeakWarningThreshold=d;const L=!1,D=!1,E=!1;var P;(function(N){N.None=()=>_.Disposable.None;function M(we){if(E){const{onDidAddListener:ve}=we,re=g.create();let de=0;we.onDidAddListener=()=>{++de===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),re.print()),ve?.()}}}function V(we,ve){return K(we,()=>{},0,void 0,!0,void 0,ve)}N.defer=V;function z(we){return(ve,re=null,de)=>{let me=!1,be;return be=we(Ce=>{if(!me)return be?be.dispose():me=!0,ve.call(re,Ce)},null,de),me&&be.dispose(),be}}N.once=z;function J(we,ve){return N.once(N.filter(we,ve))}N.onceIf=J;function j(we,ve,re){return le((de,me=null,be)=>we(Ce=>de.call(me,ve(Ce)),null,be),re)}N.map=j;function te(we,ve,re){return le((de,me=null,be)=>we(Ce=>{ve(Ce),de.call(me,Ce)},null,be),re)}N.forEach=te;function q(we,ve,re){return le((de,me=null,be)=>we(Ce=>ve(Ce)&&de.call(me,Ce),null,be),re)}N.filter=q;function B(we){return we}N.signal=B;function Z(...we){return(ve,re=null,de)=>{const me=(0,_.combinedDisposable)(...we.map(be=>be(Ce=>ve.call(re,Ce))));return ee(me,de)}}N.any=Z;function ne(we,ve,re,de){let me=re;return j(we,be=>(me=ve(me,be),me),de)}N.reduce=ne;function le(we,ve){let re;const de={onWillAddFirstListener(){re=we(me.fire,me)},onDidRemoveLastListener(){re?.dispose()}};ve||M(de);const me=new i(de);return ve?.add(me),me.event}function ee(we,ve){return ve instanceof Array?ve.push(we):ve&&ve.add(we),we}function K(we,ve,re=100,de=!1,me=!1,be,Ce){let Ue,_e,Ae,Fe=0,xe;const ze={leakWarningThreshold:be,onWillAddFirstListener(){Ue=we($e=>{Fe++,_e=ve(_e,$e),de&&!Ae&&(Me.fire(_e),_e=void 0),xe=()=>{const qe=_e;_e=void 0,Ae=void 0,(!de||Fe>1)&&Me.fire(qe),Fe=0},typeof re=="number"?(clearTimeout(Ae),Ae=setTimeout(xe,re)):Ae===void 0&&(Ae=0,queueMicrotask(xe))})},onWillRemoveListener(){me&&Fe>0&&xe?.()},onDidRemoveLastListener(){xe=void 0,Ue.dispose()}};Ce||M(ze);const Me=new i(ze);return Ce?.add(Me),Me.event}N.debounce=K;function H(we,ve=0,re){return N.debounce(we,(de,me)=>de?(de.push(me),de):[me],ve,void 0,!0,void 0,re)}N.accumulate=H;function W(we,ve=(de,me)=>de===me,re){let de=!0,me;return q(we,be=>{const Ce=de||!ve(be,me);return de=!1,me=be,Ce},re)}N.latch=W;function U(we,ve,re){return[N.filter(we,ve,re),N.filter(we,de=>!ve(de),re)]}N.split=U;function G(we,ve=!1,re=[],de){let me=re.slice(),be=we(_e=>{me?me.push(_e):Ue.fire(_e)});de&&de.add(be);const Ce=()=>{me?.forEach(_e=>Ue.fire(_e)),me=null},Ue=new i({onWillAddFirstListener(){be||(be=we(_e=>Ue.fire(_e)),de&&de.add(be))},onDidAddFirstListener(){me&&(ve?setTimeout(Ce):Ce())},onDidRemoveLastListener(){be&&be.dispose(),be=null}});return de&&de.add(Ue),Ue.event}N.buffer=G;function oe(we,ve){return(de,me,be)=>{const Ce=ve(new X);return we(function(Ue){const _e=Ce.evaluate(Ue);_e!==Q&&de.call(me,_e)},void 0,be)}}N.chain=oe;const Q=Symbol("HaltChainable");class X{constructor(){this.steps=[]}map(ve){return this.steps.push(ve),this}forEach(ve){return this.steps.push(re=>(ve(re),re)),this}filter(ve){return this.steps.push(re=>ve(re)?re:Q),this}reduce(ve,re){let de=re;return this.steps.push(me=>(de=ve(de,me),de)),this}latch(ve=(re,de)=>re===de){let re=!0,de;return this.steps.push(me=>{const be=re||!ve(me,de);return re=!1,de=me,be?me:Q}),this}evaluate(ve){for(const re of this.steps)if(ve=re(ve),ve===Q)break;return ve}}function x(we,ve,re=de=>de){const de=(...Ue)=>Ce.fire(re(...Ue)),me=()=>we.on(ve,de),be=()=>we.removeListener(ve,de),Ce=new i({onWillAddFirstListener:me,onDidRemoveLastListener:be});return Ce.event}N.fromNodeEventEmitter=x;function $(we,ve,re=de=>de){const de=(...Ue)=>Ce.fire(re(...Ue)),me=()=>we.addEventListener(ve,de),be=()=>we.removeEventListener(ve,de),Ce=new i({onWillAddFirstListener:me,onDidRemoveLastListener:be});return Ce.event}N.fromDOMEventEmitter=$;function ie(we){return new Promise(ve=>z(we)(ve))}N.toPromise=ie;function ae(we){const ve=new i;return we.then(re=>{ve.fire(re)},()=>{ve.fire(void 0)}).finally(()=>{ve.dispose()}),ve.event}N.fromPromise=ae;function ue(we,ve){return we(re=>ve.fire(re))}N.forward=ue;function Se(we,ve,re){return ve(re),we(de=>ve(de))}N.runAndSubscribe=Se;class Ee{constructor(ve,re){this._observable=ve,this._counter=0,this._hasChanged=!1;const de={onWillAddFirstListener:()=>{ve.addObserver(this),this._observable.reportChanges()},onDidRemoveLastListener:()=>{ve.removeObserver(this)}};re||M(de),this.emitter=new i(de),re&&re.add(this.emitter)}beginUpdate(ve){this._counter++}handlePossibleChange(ve){}handleChange(ve,re){this._hasChanged=!0}endUpdate(ve){this._counter--,this._counter===0&&(this._observable.reportChanges(),this._hasChanged&&(this._hasChanged=!1,this.emitter.fire(this._observable.get())))}}function Re(we,ve){return new Ee(we,ve).emitter.event}N.fromObservable=Re;function Te(we){return(ve,re,de)=>{let me=0,be=!1;const Ce={beginUpdate(){me++},endUpdate(){me--,me===0&&(we.reportChanges(),be&&(be=!1,ve.call(re)))},handlePossibleChange(){},handleChange(){be=!0}};we.addObserver(Ce),we.reportChanges();const Ue={dispose(){we.removeObserver(Ce)}};return de instanceof _.DisposableStore?de.add(Ue):Array.isArray(de)&&de.push(Ue),Ue}}N.fromObservableLight=Te})(P||(e.Event=P={}));class S{static{this.all=new Set}static{this._idPool=0}constructor(M){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${M}_${S._idPool++}`,S.all.add(this)}start(M){this._stopWatch=new k.StopWatch,this.listenerCount=M}stop(){if(this._stopWatch){const M=this._stopWatch.elapsed();this.durations.push(M),this.elapsedOverall+=M,this.invocationCount+=1,this._stopWatch=void 0}}}e.EventProfiling=S;let m=-1;function d(N){const M=m;return m=N,{dispose(){m=M}}}class l{static{this._idPool=1}constructor(M,V,z=(l._idPool++).toString(16).padStart(3,"0")){this._errorHandler=M,this.threshold=V,this.name=z,this._warnCountdown=0}dispose(){this._stacks?.clear()}check(M,V){const z=this.threshold;if(z<=0||V<z)return;this._stacks||(this._stacks=new Map);const J=this._stacks.get(M.value)||0;if(this._stacks.set(M.value,J+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=z*.5;const[j,te]=this.getMostFrequentStack(),q=`[${this.name}] potential listener LEAK detected, having ${V} listeners already. MOST frequent listener (${te}):`;console.warn(q),console.warn(j);const B=new I(q,j);this._errorHandler(B)}return()=>{const j=this._stacks.get(M.value)||0;this._stacks.set(M.value,j-1)}}getMostFrequentStack(){if(!this._stacks)return;let M,V=0;for(const[z,J]of this._stacks)(!M||V<J)&&(M=[z,J],V=J);return M}}class g{static create(){const M=new Error;return new g(M.stack??"")}constructor(M){this.value=M}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class I extends Error{constructor(M,V){super(M),this.name="ListenerLeakError",this.stack=V}}e.ListenerLeakError=I;class v extends Error{constructor(M,V){super(M),this.name="ListenerRefusalError",this.stack=V}}e.ListenerRefusalError=v;let f=0;class C{constructor(M){this.value=M,this.id=f++}}const p=2,c=(N,M)=>{if(N instanceof C)M(N);else for(let V=0;V<N.length;V++){const z=N[V];z&&M(z)}};let u;if(L){const N=[];setInterval(()=>{N.length!==0&&(console.warn("[LEAKING LISTENERS] GC'ed these listeners that were NOT yet disposed:"),console.warn(N.join(`
`)),N.length=0)},3e3),u=new FinalizationRegistry(M=>{typeof M=="string"&&N.push(M)})}class i{constructor(M){this._size=0,this._options=M,this._leakageMon=m>0||this._options?.leakWarningThreshold?new l(M?.onListenerError??R.onUnexpectedError,this._options?.leakWarningThreshold??m):void 0,this._perfMon=this._options?._profName?new S(this._options._profName):void 0,this._deliveryQueue=this._options?.deliveryQueue}dispose(){if(!this._disposed){if(this._disposed=!0,this._deliveryQueue?.current===this&&this._deliveryQueue.reset(),this._listeners){if(D){const M=this._listeners;queueMicrotask(()=>{c(M,V=>V.stack?.print())})}this._listeners=void 0,this._size=0}this._options?.onDidRemoveLastListener?.(),this._leakageMon?.dispose()}}get event(){return this._event??=(M,V,z)=>{if(this._leakageMon&&this._size>this._leakageMon.threshold**2){const B=`[${this._leakageMon.name}] REFUSES to accept new listeners because it exceeded its threshold by far (${this._size} vs ${this._leakageMon.threshold})`;console.warn(B);const Z=this._leakageMon.getMostFrequentStack()??["UNKNOWN stack",-1],ne=new v(`${B}. HINT: Stack shows most frequent listener (${Z[1]}-times)`,Z[0]);return(this._options?.onListenerError||R.onUnexpectedError)(ne),_.Disposable.None}if(this._disposed)return _.Disposable.None;V&&(M=M.bind(V));const J=new C(M);let j,te;this._leakageMon&&this._size>=Math.ceil(this._leakageMon.threshold*.2)&&(J.stack=g.create(),j=this._leakageMon.check(J.stack,this._size+1)),D&&(J.stack=te??g.create()),this._listeners?this._listeners instanceof C?(this._deliveryQueue??=new t,this._listeners=[this._listeners,J]):this._listeners.push(J):(this._options?.onWillAddFirstListener?.(this),this._listeners=J,this._options?.onDidAddFirstListener?.(this)),this._size++;const q=(0,_.toDisposable)(()=>{u?.unregister(q),j?.(),this._removeListener(J)});if(z instanceof _.DisposableStore?z.add(q):Array.isArray(z)&&z.push(q),u){const B=new Error().stack.split(`
`).slice(2,3).join(`
`).trim(),Z=/(file:|vscode-file:\/\/vscode-app)?(\/[^:]*:\d+:\d+)/.exec(B);u.register(q,Z?.[2]??B,q)}return q},this._event}_removeListener(M){if(this._options?.onWillRemoveListener?.(this),!this._listeners)return;if(this._size===1){this._listeners=void 0,this._options?.onDidRemoveLastListener?.(this),this._size=0;return}const V=this._listeners,z=V.indexOf(M);if(z===-1)throw console.log("disposed?",this._disposed),console.log("size?",this._size),console.log("arr?",JSON.stringify(this._listeners)),new Error("Attempted to dispose unknown listener");this._size--,V[z]=void 0;const J=this._deliveryQueue.current===this;if(this._size*p<=V.length){let j=0;for(let te=0;te<V.length;te++)V[te]?V[j++]=V[te]:J&&(this._deliveryQueue.end--,j<this._deliveryQueue.i&&this._deliveryQueue.i--);V.length=j}}_deliver(M,V){if(!M)return;const z=this._options?.onListenerError||R.onUnexpectedError;if(!z){M.value(V);return}try{M.value(V)}catch(J){z(J)}}_deliverQueue(M){const V=M.current._listeners;for(;M.i<M.end;)this._deliver(V[M.i++],M.value);M.reset()}fire(M){if(this._deliveryQueue?.current&&(this._deliverQueue(this._deliveryQueue),this._perfMon?.stop()),this._perfMon?.start(this._size),this._listeners)if(this._listeners instanceof C)this._deliver(this._listeners,M);else{const V=this._deliveryQueue;V.enqueue(this,M,this._listeners.length),this._deliverQueue(V)}this._perfMon?.stop()}hasListeners(){return this._size>0}}e.Emitter=i;const n=()=>new t;e.createEventDeliveryQueue=n;class t{constructor(){this.i=-1,this.end=0}enqueue(M,V,z){this.i=0,this.end=z,this.current=M,this.value=V}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class s extends i{async fireAsync(M,V,z){if(this._listeners)for(this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new T.LinkedList),c(this._listeners,J=>this._asyncDeliveryQueue.push([J.value,M]));this._asyncDeliveryQueue.size>0&&!V.isCancellationRequested;){const[J,j]=this._asyncDeliveryQueue.shift(),te=[],q={...j,token:V,waitUntil:B=>{if(Object.isFrozen(te))throw new Error("waitUntil can NOT be called asynchronous");z&&(B=z(B,J)),te.push(B)}};try{J(q)}catch(B){(0,R.onUnexpectedError)(B);continue}Object.freeze(te),await Promise.allSettled(te).then(B=>{for(const Z of B)Z.status==="rejected"&&(0,R.onUnexpectedError)(Z.reason)})}}}e.AsyncEmitter=s;class r extends i{get isPaused(){return this._isPaused!==0}constructor(M){super(M),this._isPaused=0,this._eventQueue=new T.LinkedList,this._mergeFn=M?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused===0)if(this._mergeFn){if(this._eventQueue.size>0){const M=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(M))}}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(M){this._size&&(this._isPaused!==0?this._eventQueue.push(M):super.fire(M))}}e.PauseableEmitter=r;class o extends r{constructor(M){super(M),this._delay=M.delay??100}fire(M){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(M)}}e.DebounceEmitter=o;class h extends i{constructor(M){super(M),this._queuedEvents=[],this._mergeFn=M?.merge}fire(M){this.hasListeners()&&(this._queuedEvents.push(M),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(V=>super.fire(V)),this._queuedEvents=[]}))}}e.MicrotaskEmitter=h;class y{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new i({onWillAddFirstListener:()=>this.onFirstListenerAdd(),onDidRemoveLastListener:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(M){const V={event:M,listener:null};this.events.push(V),this.hasListeners&&this.hook(V);const z=()=>{this.hasListeners&&this.unhook(V);const J=this.events.indexOf(V);this.events.splice(J,1)};return(0,_.toDisposable)((0,a.createSingleCallFunction)(z))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(M=>this.hook(M))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(M=>this.unhook(M))}hook(M){M.listener=M.event(V=>this.emitter.fire(V))}unhook(M){M.listener?.dispose(),M.listener=null}dispose(){this.emitter.dispose();for(const M of this.events)M.listener?.dispose();this.events=[]}}e.EventMultiplexer=y;class A{constructor(M,V,z,J){this._store=new _.DisposableStore;const j=this._store.add(new y),te=this._store.add(new _.DisposableMap);function q(B){te.set(B,j.add(J(B)))}for(const B of M)q(B);this._store.add(V(B=>{q(B)})),this._store.add(z(B=>{te.deleteAndDispose(B)})),this.event=j.event}dispose(){this._store.dispose()}}e.DynamicListEventMultiplexer=A;class b{constructor(){this.data=[]}wrapEvent(M,V,z){return(J,j,te)=>M(q=>{const B=this.data[this.data.length-1];if(!V){B?B.buffers.push(()=>J.call(j,q)):J.call(j,q);return}const Z=B;if(!Z){J.call(j,V(z,q));return}Z.items??=[],Z.items.push(q),Z.buffers.length===0&&B.buffers.push(()=>{Z.reducedResult??=z?Z.items.reduce(V,z):Z.items.reduce(V),J.call(j,Z.reducedResult)})},void 0,te)}bufferEvents(M){const V={buffers:new Array};this.data.push(V);const z=M();return this.data.pop(),V.buffers.forEach(J=>J()),z}}e.EventBufferer=b;class w{constructor(){this.listening=!1,this.inputEvent=P.None,this.inputEventListener=_.Disposable.None,this.emitter=new i({onDidAddFirstListener:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onDidRemoveLastListener:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(M){this.inputEvent=M,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=M(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=w;class O{static const(M){return new F(M)}constructor(M){this._value=M,this._onDidChange=new i,this.onDidChange=this._onDidChange.event}get value(){return this._value}set value(M){M!==this._value&&(this._value=M,this._onDidChange.fire(void 0))}}e.ValueWithChangeEvent=O;class F{constructor(M){this.value=M,this.onDidChange=P.None}}}),define(he[25],fe([0,1,3]),function(ce,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0,e.cancelOnDispose=L;const a=Object.freeze(function(D,E){const P=setTimeout(D.bind(E),0);return{dispose(){clearTimeout(P)}}});var _;(function(D){function E(P){return P===D.None||P===D.Cancelled||P instanceof T?!0:!P||typeof P!="object"?!1:typeof P.isCancellationRequested=="boolean"&&typeof P.onCancellationRequested=="function"}D.isCancellationToken=E,D.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:R.Event.None}),D.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:a})})(_||(e.CancellationToken=_={}));class T{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?a:(this._emitter||(this._emitter=new R.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class k{constructor(E){this._token=void 0,this._parentListener=void 0,this._parentListener=E&&E.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new T),this._token}cancel(){this._token?this._token instanceof T&&this._token.cancel():this._token=_.Cancelled}dispose(E=!1){E&&this.cancel(),this._parentListener?.dispose(),this._token?this._token instanceof T&&this._token.dispose():this._token=_.None}}e.CancellationTokenSource=k;function L(D){const E=new k;return D.add({dispose(){E.cancel()}}),E.token}}),define(he[136],fe([0,1,25]),function(ce,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0,e.identity=_;class a{constructor(D){this.task=D,this.result=null}get(){if(this.result)return this.result;const D=new R.CancellationTokenSource,E=this.task(D.token);return this.result={promise:E,dispose:()=>{this.result=null,D.cancel(),D.dispose()}},this.result}}e.Cache=a;function _(L){return L}class T{constructor(D,E){this.lastCache=void 0,this.lastArgKey=void 0,typeof D=="function"?(this._fn=D,this._computeKey=_):(this._fn=E,this._computeKey=D.getCacheKey)}get(D){const E=this._computeKey(D);return this.lastArgKey!==E&&(this.lastArgKey=E,this.lastCache=this._fn(D)),this.lastCache}}e.LRUCachedFunction=T;class k{get cachedValues(){return this._map}constructor(D,E){this._map=new Map,this._map2=new Map,typeof D=="function"?(this._fn=D,this._computeKey=_):(this._fn=E,this._computeKey=D.getCacheKey)}get(D){const E=this._computeKey(D);if(this._map2.has(E))return this._map2.get(E);const P=this._fn(D);return this._map.set(D,P),this._map2.set(E,P),P}}e.CachedFunction=k}),define(he[50],fe([0,1,8,2]),function(ce,e,R,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isReadable=_,e.isReadableStream=T,e.isReadableBufferedStream=k,e.newWriteableStream=L,e.consumeReadable=E,e.peekReadable=P,e.consumeStream=S,e.listenStream=m,e.peekStream=d,e.toStream=l,e.emptyStream=g,e.toReadable=I,e.transform=v,e.prefixedReadable=f,e.prefixedStream=C;function _(p){const c=p;return c?typeof c.read=="function":!1}function T(p){const c=p;return c?[c.on,c.pause,c.resume,c.destroy].every(u=>typeof u=="function"):!1}function k(p){const c=p;return c?T(c.stream)&&Array.isArray(c.buffer)&&typeof c.ended=="boolean":!1}function L(p,c){return new D(p,c)}class D{constructor(c,u){this.reducer=c,this.options=u,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(c){if(!this.state.destroyed){if(this.state.flowing)this.emitData(c);else if(this.buffer.data.push(c),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(u=>this.pendingWritePromises.push(u))}}error(c){this.state.destroyed||(this.state.flowing?this.emitError(c):this.buffer.error.push(c))}end(c){this.state.destroyed||(typeof c<"u"&&this.write(c),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(c){this.listeners.data.slice(0).forEach(u=>u(c))}emitError(c){this.listeners.error.length===0?(0,R.onUnexpectedError)(c):this.listeners.error.slice(0).forEach(u=>u(c))}emitEnd(){this.listeners.end.slice(0).forEach(c=>c())}on(c,u){if(!this.state.destroyed)switch(c){case"data":this.listeners.data.push(u),this.resume();break;case"end":this.listeners.end.push(u),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(u),this.state.flowing&&this.flowErrors();break}}removeListener(c,u){if(this.state.destroyed)return;let i;switch(c){case"data":i=this.listeners.data;break;case"end":i=this.listeners.end;break;case"error":i=this.listeners.error;break}if(i){const n=i.indexOf(u);n>=0&&i.splice(n,1)}}flowData(){if(this.buffer.data.length>0){const c=this.reducer(this.buffer.data);this.emitData(c),this.buffer.data.length=0;const u=[...this.pendingWritePromises];this.pendingWritePromises.length=0,u.forEach(i=>i())}}flowErrors(){if(this.listeners.error.length>0){for(const c of this.buffer.error)this.emitError(c);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function E(p,c){const u=[];let i;for(;(i=p.read())!==null;)u.push(i);return c(u)}function P(p,c,u){const i=[];let n;for(;(n=p.read())!==null&&i.length<u;)i.push(n);return n===null&&i.length>0?c(i):{read:()=>{if(i.length>0)return i.shift();if(typeof n<"u"){const t=n;return n=void 0,t}return p.read()}}}function S(p,c){return new Promise((u,i)=>{const n=[];m(p,{onData:t=>{c&&n.push(t)},onError:t=>{c?i(t):u(void 0)},onEnd:()=>{u(c?c(n):void 0)}})})}function m(p,c,u){p.on("error",i=>{u?.isCancellationRequested||c.onError(i)}),p.on("end",()=>{u?.isCancellationRequested||c.onEnd()}),p.on("data",i=>{u?.isCancellationRequested||c.onData(i)})}function d(p,c){return new Promise((u,i)=>{const n=new a.DisposableStore,t=[],s=h=>{if(t.push(h),t.length>c)return n.dispose(),p.pause(),u({stream:p,buffer:t,ended:!1})},r=h=>(n.dispose(),i(h)),o=()=>(n.dispose(),u({stream:p,buffer:t,ended:!0}));n.add((0,a.toDisposable)(()=>p.removeListener("error",r))),p.on("error",r),n.add((0,a.toDisposable)(()=>p.removeListener("end",o))),p.on("end",o),n.add((0,a.toDisposable)(()=>p.removeListener("data",s))),p.on("data",s)})}function l(p,c){const u=L(c);return u.end(p),u}function g(){const p=L(()=>{throw new Error("not supported")});return p.end(),p}function I(p){let c=!1;return{read:()=>c?null:(c=!0,p)}}function v(p,c,u){const i=L(u);return m(p,{onData:n=>i.write(c.data(n)),onError:n=>i.error(c.error?c.error(n):n),onEnd:()=>i.end()}),i}function f(p,c,u){let i=!1;return{read:()=>{const n=c.read();return i?n:(i=!0,n!==null?u([p,n]):p)}}}function C(p,c,u){let i=!1;const n=L(u);return m(c,{onData:t=>i?n.write(t):(i=!0,n.write(u([p,t]))),onError:t=>n.error(t),onEnd:()=>{i||(i=!0,n.write(p)),n.end()}}),n}});var Tt=this&&this.__createBinding||(Object.create?function(ce,e,R,a){a===void 0&&(a=R);var _=Object.getOwnPropertyDescriptor(e,R);(!_||("get"in _?!e.__esModule:_.writable||_.configurable))&&(_={enumerable:!0,get:function(){return e[R]}}),Object.defineProperty(ce,a,_)}:function(ce,e,R,a){a===void 0&&(a=R),ce[a]=e[R]}),Lt=this&&this.__setModuleDefault||(Object.create?function(ce,e){Object.defineProperty(ce,"default",{enumerable:!0,value:e})}:function(ce,e){ce.default=e}),De=this&&this.__importStar||function(ce){if(ce&&ce.__esModule)return ce;var e={};if(ce!=null)for(var R in ce)R!=="default"&&Object.prototype.hasOwnProperty.call(ce,R)&&Tt(e,ce,R);return Lt(e,ce),e};define(he[14],fe([0,1,53,50]),function(ce,e,R,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.VSBuffer=void 0,e.binaryIndexOf=E,e.readUInt16LE=P,e.writeUInt16LE=S,e.readUInt32BE=m,e.writeUInt32BE=d,e.readUInt32LE=l,e.writeUInt32LE=g,e.readUInt8=I,e.writeUInt8=v,e.readableToBuffer=f,e.bufferToReadable=C,e.streamToBuffer=p,e.bufferedStreamToBuffer=c,e.bufferToStream=u,e.streamToBufferReadableStream=i,e.newWriteableBufferStream=n,e.prefixedBufferReadable=t,e.prefixedBufferStream=s,e.decodeBase64=r,e.encodeBase64=y,a=De(a);const _=typeof Buffer<"u",T=new R.Lazy(()=>new Uint8Array(256));let k,L;class D{static alloc(b){return _?new D(Buffer.allocUnsafe(b)):new D(new Uint8Array(b))}static wrap(b){return _&&!Buffer.isBuffer(b)&&(b=Buffer.from(b.buffer,b.byteOffset,b.byteLength)),new D(b)}static fromString(b,w){return!(w?.dontUseNodeBuffer||!1)&&_?new D(Buffer.from(b)):(k||(k=new TextEncoder),new D(k.encode(b)))}static fromByteArray(b){const w=D.alloc(b.length);for(let O=0,F=b.length;O<F;O++)w.buffer[O]=b[O];return w}static concat(b,w){if(typeof w>"u"){w=0;for(let N=0,M=b.length;N<M;N++)w+=b[N].byteLength}const O=D.alloc(w);let F=0;for(let N=0,M=b.length;N<M;N++){const V=b[N];O.set(V,F),F+=V.byteLength}return O}constructor(b){this.buffer=b,this.byteLength=this.buffer.byteLength}clone(){const b=D.alloc(this.byteLength);return b.set(this),b}toString(){return _?this.buffer.toString():(L||(L=new TextDecoder),L.decode(this.buffer))}slice(b,w){return new D(this.buffer.subarray(b,w))}set(b,w){if(b instanceof D)this.buffer.set(b.buffer,w);else if(b instanceof Uint8Array)this.buffer.set(b,w);else if(b instanceof ArrayBuffer)this.buffer.set(new Uint8Array(b),w);else if(ArrayBuffer.isView(b))this.buffer.set(new Uint8Array(b.buffer,b.byteOffset,b.byteLength),w);else throw new Error("Unknown argument 'array'")}readUInt32BE(b){return m(this.buffer,b)}writeUInt32BE(b,w){d(this.buffer,b,w)}readUInt32LE(b){return l(this.buffer,b)}writeUInt32LE(b,w){g(this.buffer,b,w)}readUInt8(b){return I(this.buffer,b)}writeUInt8(b,w){v(this.buffer,b,w)}indexOf(b,w=0){return E(this.buffer,b instanceof D?b.buffer:b,w)}}e.VSBuffer=D;function E(A,b,w=0){const O=b.byteLength,F=A.byteLength;if(O===0)return 0;if(O===1)return A.indexOf(b[0]);if(O>F-w)return-1;const N=T.value;N.fill(b.length);for(let J=0;J<b.length;J++)N[b[J]]=b.length-J-1;let M=w+b.length-1,V=M,z=-1;for(;M<F;)if(A[M]===b[V]){if(V===0){z=M;break}M--,V--}else M+=Math.max(b.length-V,N[A[M]]),V=b.length-1;return z}function P(A,b){return A[b+0]<<0>>>0|A[b+1]<<8>>>0}function S(A,b,w){A[w+0]=b&255,b=b>>>8,A[w+1]=b&255}function m(A,b){return A[b]*2**24+A[b+1]*2**16+A[b+2]*2**8+A[b+3]}function d(A,b,w){A[w+3]=b,b=b>>>8,A[w+2]=b,b=b>>>8,A[w+1]=b,b=b>>>8,A[w]=b}function l(A,b){return A[b+0]<<0>>>0|A[b+1]<<8>>>0|A[b+2]<<16>>>0|A[b+3]<<24>>>0}function g(A,b,w){A[w+0]=b&255,b=b>>>8,A[w+1]=b&255,b=b>>>8,A[w+2]=b&255,b=b>>>8,A[w+3]=b&255}function I(A,b){return A[b]}function v(A,b,w){A[w]=b}function f(A){return a.consumeReadable(A,b=>D.concat(b))}function C(A){return a.toReadable(A)}function p(A){return a.consumeStream(A,b=>D.concat(b))}async function c(A){return A.ended?D.concat(A.buffer):D.concat([...A.buffer,await p(A.stream)])}function u(A){return a.toStream(A,b=>D.concat(b))}function i(A){return a.transform(A,{data:b=>typeof b=="string"?D.fromString(b):D.wrap(b)},b=>D.concat(b))}function n(A){return a.newWriteableStream(b=>D.concat(b),A)}function t(A,b){return a.prefixedReadable(A,b,w=>D.concat(w))}function s(A,b){return a.prefixedStream(A,b,w=>D.concat(w))}function r(A){let b=0,w=0,O=0;const F=new Uint8Array(Math.floor(A.length/4*3)),N=V=>{switch(w){case 3:F[O++]=b|V,w=0;break;case 2:F[O++]=b|V>>>2,b=V<<6,w=3;break;case 1:F[O++]=b|V>>>4,b=V<<4,w=2;break;default:b=V<<2,w=1}};for(let V=0;V<A.length;V++){const z=A.charCodeAt(V);if(z>=65&&z<=90)N(z-65);else if(z>=97&&z<=122)N(z-97+26);else if(z>=48&&z<=57)N(z-48+52);else if(z===43||z===45)N(62);else if(z===47||z===95)N(63);else{if(z===61)break;throw new SyntaxError(`Unexpected base64 character ${A[V]}`)}}const M=O;for(;w>0;)N(0);return D.wrap(F).slice(0,M)}const o="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",h="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function y({buffer:A},b=!0,w=!1){const O=w?h:o;let F="";const N=A.byteLength%3;let M=0;for(;M<A.byteLength-N;M+=3){const V=A[M+0],z=A[M+1],J=A[M+2];F+=O[V>>>2],F+=O[(V<<4|z>>>4)&63],F+=O[(z<<2|J>>>6)&63],F+=O[J&63]}if(N===1){const V=A[M+0];F+=O[V>>>2],F+=O[V<<4&63],b&&(F+="==")}else if(N===2){const V=A[M+0],z=A[M+1];F+=O[V>>>2],F+=O[(V<<4|z>>>4)&63],F+=O[z<<2&63],b&&(F+="=")}return F}}),define(he[137],fe([0,1]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MicrotaskDelay=void 0,e.MicrotaskDelay=Symbol("MicrotaskDelay")}),define(he[12],fe([0,1]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isString=R,e.isStringArray=a,e.isObject=_,e.isTypedArray=T,e.isNumber=k,e.isIterable=L,e.isBoolean=D,e.isUndefined=E,e.isDefined=P,e.isUndefinedOrNull=S,e.assertType=m,e.assertIsDefined=d,e.assertAllDefined=l,e.isEmptyObject=I,e.isFunction=v,e.areFunctions=f,e.validateConstraints=C,e.validateConstraint=p,e.upcast=c;function R(u){return typeof u=="string"}function a(u){return Array.isArray(u)&&u.every(i=>R(i))}function _(u){return typeof u=="object"&&u!==null&&!Array.isArray(u)&&!(u instanceof RegExp)&&!(u instanceof Date)}function T(u){const i=Object.getPrototypeOf(Uint8Array);return typeof u=="object"&&u instanceof i}function k(u){return typeof u=="number"&&!isNaN(u)}function L(u){return!!u&&typeof u[Symbol.iterator]=="function"}function D(u){return u===!0||u===!1}function E(u){return typeof u>"u"}function P(u){return!S(u)}function S(u){return E(u)||u===null}function m(u,i){if(!u)throw new Error(i?`Unexpected type, expected '${i}'`:"Unexpected type")}function d(u){if(S(u))throw new Error("Assertion Failed: argument is undefined or null");return u}function l(...u){const i=[];for(let n=0;n<u.length;n++){const t=u[n];if(S(t))throw new Error(`Assertion Failed: argument at index ${n} is undefined or null`);i.push(t)}return i}const g=Object.prototype.hasOwnProperty;function I(u){if(!_(u))return!1;for(const i in u)if(g.call(u,i))return!1;return!0}function v(u){return typeof u=="function"}function f(...u){return u.length>0&&u.every(v)}function C(u,i){const n=Math.min(u.length,i.length);for(let t=0;t<n;t++)p(u[t],i[t])}function p(u,i){if(R(i)){if(typeof u!==i)throw new Error(`argument does not match constraint: typeof ${i}`)}else if(v(i)){try{if(u instanceof i)return}catch{}if(!S(u)&&u.constructor===i||i.length===1&&i.call(void 0,u)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}function c(u){return u}}),define(he[29],fe([0,1,12]),function(ce,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deepClone=a,e.deepFreeze=_,e.cloneAndChange=k,e.mixin=D,e.equals=E,e.safeStringify=P,e.distinct=S,e.getCaseInsensitive=m,e.filter=d,e.getAllPropertyNames=l,e.getAllMethodNames=g,e.createProxyObject=I,e.mapValues=v;function a(f){if(!f||typeof f!="object"||f instanceof RegExp)return f;const C=Array.isArray(f)?[]:{};return Object.entries(f).forEach(([p,c])=>{C[p]=c&&typeof c=="object"?a(c):c}),C}function _(f){if(!f||typeof f!="object")return f;const C=[f];for(;C.length>0;){const p=C.shift();Object.freeze(p);for(const c in p)if(T.call(p,c)){const u=p[c];typeof u=="object"&&!Object.isFrozen(u)&&!(0,R.isTypedArray)(u)&&C.push(u)}}return f}const T=Object.prototype.hasOwnProperty;function k(f,C){return L(f,C,new Set)}function L(f,C,p){if((0,R.isUndefinedOrNull)(f))return f;const c=C(f);if(typeof c<"u")return c;if(Array.isArray(f)){const u=[];for(const i of f)u.push(L(i,C,p));return u}if((0,R.isObject)(f)){if(p.has(f))throw new Error("Cannot clone recursive data-structure");p.add(f);const u={};for(const i in f)T.call(f,i)&&(u[i]=L(f[i],C,p));return p.delete(f),u}return f}function D(f,C,p=!0){return(0,R.isObject)(f)?((0,R.isObject)(C)&&Object.keys(C).forEach(c=>{c in f?p&&((0,R.isObject)(f[c])&&(0,R.isObject)(C[c])?D(f[c],C[c],p):f[c]=C[c]):f[c]=C[c]}),f):C}function E(f,C){if(f===C)return!0;if(f==null||C===null||C===void 0||typeof f!=typeof C||typeof f!="object"||Array.isArray(f)!==Array.isArray(C))return!1;let p,c;if(Array.isArray(f)){if(f.length!==C.length)return!1;for(p=0;p<f.length;p++)if(!E(f[p],C[p]))return!1}else{const u=[];for(c in f)u.push(c);u.sort();const i=[];for(c in C)i.push(c);if(i.sort(),!E(u,i))return!1;for(p=0;p<u.length;p++)if(!E(f[u[p]],C[u[p]]))return!1}return!0}function P(f){const C=new Set;return JSON.stringify(f,(p,c)=>{if((0,R.isObject)(c)||Array.isArray(c)){if(C.has(c))return"[Circular]";C.add(c)}return typeof c=="bigint"?`[BigInt ${c.toString()}]`:c})}function S(f,C){const p=Object.create(null);return!f||!C||Object.keys(C).forEach(u=>{const i=f[u],n=C[u];E(i,n)||(p[u]=n)}),p}function m(f,C){const p=C.toLowerCase(),c=Object.keys(f).find(u=>u.toLowerCase()===p);return c?f[c]:f[C]}function d(f,C){const p=Object.create(null);for(const[c,u]of Object.entries(f))C(c,u)&&(p[c]=u);return p}function l(f){let C=[];for(;Object.prototype!==f;)C=C.concat(Object.getOwnPropertyNames(f)),f=Object.getPrototypeOf(f);return C}function g(f){const C=[];for(const p of l(f))typeof f[p]=="function"&&C.push(p);return C}function I(f,C){const p=u=>function(){const i=Array.prototype.slice.call(arguments,0);return C(u,i)},c={};for(const u of f)c[u]=p(u);return c}function v(f,C){const p={};for(const[c,u]of Object.entries(f))p[c]=C(u,c);return p}}),define(he[138],fe([0,1]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Constants=void 0,e.toUint8=a,e.toUint32=_;var R;(function(T){T[T.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",T[T.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",T[T.MAX_UINT_8=255]="MAX_UINT_8",T[T.MAX_UINT_16=65535]="MAX_UINT_16",T[T.MAX_UINT_32=4294967295]="MAX_UINT_32",T[T.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(R||(e.Constants=R={}));function a(T){return T<0?0:T>R.MAX_UINT_8?R.MAX_UINT_8:T|0}function _(T){return T<0?0:T>R.MAX_UINT_32?R.MAX_UINT_32:T|0}}),define(he[26],fe([0,1,136,39,53,138]),function(ce,e,R,a,_,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.GraphemeBreakType=e.UTF8_BOM_CHARACTER=e.UNUSUAL_LINE_TERMINATORS=e.GraphemeIterator=e.CodePointIterator=void 0,e.isFalsyOrWhitespace=k,e.format=D,e.format2=P,e.htmlAttributeEncodeValue=S,e.escape=m,e.escapeRegExpCharacters=d,e.count=l,e.truncate=g,e.truncateMiddle=I,e.trim=v,e.ltrim=f,e.rtrim=C,e.convertSimple2RegExpPattern=p,e.stripWildcards=c,e.createRegExp=u,e.regExpLeadsToEndlessLoop=i,e.splitLines=n,e.splitLinesIncludeSeparators=t,e.firstNonWhitespaceIndex=s,e.getLeadingWhitespace=r,e.lastNonWhitespaceIndex=o,e.replaceAsync=h,e.compare=y,e.compareSubstring=A,e.compareIgnoreCase=b,e.compareSubstringIgnoreCase=w,e.isAsciiDigit=O,e.isLowerAsciiLetter=F,e.isUpperAsciiLetter=N,e.equalsIgnoreCase=M,e.startsWithIgnoreCase=V,e.commonPrefixLength=z,e.commonSuffixLength=J,e.isHighSurrogate=j,e.isLowSurrogate=te,e.computeCodePoint=q,e.getNextCodePoint=B,e.nextCharLength=ee,e.prevCharLength=K,e.getCharContainingOffset=H,e.charCount=W,e.containsRTL=oe,e.isBasicASCII=X,e.containsUnusualLineTerminators=x,e.isFullWidthCharacter=$,e.isEmojiImprecise=ie,e.lcut=ae,e.forAnsiStringParts=Se,e.removeAnsiEscapeCodes=Ee,e.removeAnsiEscapeCodesFromPrompt=Te,e.startsWithUTF8BOM=we,e.stripUTF8BOM=ve,e.fuzzyContains=re,e.containsUppercaseCharacter=de,e.uppercaseFirstLetter=me,e.getNLines=be,e.singleLetterHash=Ce,e.getGraphemeBreakType=Ue,e.getLeftDeleteOffset=ze;function k(se){return!se||typeof se!="string"?!0:se.trim().length===0}const L=/{(\d+)}/g;function D(se,...ge){return ge.length===0?se:se.replace(L,function(pe,ye){const Le=parseInt(ye,10);return isNaN(Le)||Le<0||Le>=ge.length?pe:ge[Le]})}const E=/{([^}]+)}/g;function P(se,ge){return Object.keys(ge).length===0?se:se.replace(E,(pe,ye)=>ge[ye]??pe)}function S(se){return se.replace(/[<>"'&]/g,ge=>{switch(ge){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return ge})}function m(se){return se.replace(/[<>&]/g,function(ge){switch(ge){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ge}})}function d(se){return se.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function l(se,ge){let pe=0,ye=se.indexOf(ge);for(;ye!==-1;)pe++,ye=se.indexOf(ge,ye+ge.length);return pe}function g(se,ge,pe="\u2026"){return se.length<=ge?se:`${se.substr(0,ge)}${pe}`}function I(se,ge,pe="\u2026"){if(se.length<=ge)return se;const ye=Math.ceil(ge/2)-pe.length/2,Le=Math.floor(ge/2)-pe.length/2;return`${se.substr(0,ye)}${pe}${se.substr(se.length-Le)}`}function v(se,ge=" "){const pe=f(se,ge);return C(pe,ge)}function f(se,ge){if(!se||!ge)return se;const pe=ge.length;if(pe===0||se.length===0)return se;let ye=0;for(;se.indexOf(ge,ye)===ye;)ye=ye+pe;return se.substring(ye)}function C(se,ge){if(!se||!ge)return se;const pe=ge.length,ye=se.length;if(pe===0||ye===0)return se;let Le=ye,ke=-1;for(;ke=se.lastIndexOf(ge,Le-1),!(ke===-1||ke+pe!==Le);){if(ke===0)return"";Le=ke}return se.substring(0,Le)}function p(se){return se.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function c(se){return se.replace(/\*/g,"")}function u(se,ge,pe={}){if(!se)throw new Error("Cannot create regex from empty string");ge||(se=d(se)),pe.wholeWord&&(/\B/.test(se.charAt(0))||(se="\\b"+se),/\B/.test(se.charAt(se.length-1))||(se=se+"\\b"));let ye="";return pe.global&&(ye+="g"),pe.matchCase||(ye+="i"),pe.multiline&&(ye+="m"),pe.unicode&&(ye+="u"),new RegExp(se,ye)}function i(se){return se.source==="^"||se.source==="^$"||se.source==="$"||se.source==="^\\s*$"?!1:!!(se.exec("")&&se.lastIndex===0)}function n(se){return se.split(/\r\n|\r|\n/)}function t(se){const ge=[],pe=se.split(/(\r\n|\r|\n)/);for(let ye=0;ye<Math.ceil(pe.length/2);ye++)ge.push(pe[2*ye]+(pe[2*ye+1]??""));return ge}function s(se){for(let ge=0,pe=se.length;ge<pe;ge++){const ye=se.charCodeAt(ge);if(ye!==a.CharCode.Space&&ye!==a.CharCode.Tab)return ge}return-1}function r(se,ge=0,pe=se.length){for(let ye=ge;ye<pe;ye++){const Le=se.charCodeAt(ye);if(Le!==a.CharCode.Space&&Le!==a.CharCode.Tab)return se.substring(ge,ye)}return se.substring(ge,pe)}function o(se,ge=se.length-1){for(let pe=ge;pe>=0;pe--){const ye=se.charCodeAt(pe);if(ye!==a.CharCode.Space&&ye!==a.CharCode.Tab)return pe}return-1}function h(se,ge,pe){const ye=[];let Le=0;for(const ke of se.matchAll(ge)){if(ye.push(se.slice(Le,ke.index)),ke.index===void 0)throw new Error("match.index should be defined");Le=ke.index+ke[0].length,ye.push(pe(ke[0],...ke.slice(1),ke.index,se,ke.groups))}return ye.push(se.slice(Le)),Promise.all(ye).then(ke=>ke.join(""))}function y(se,ge){return se<ge?-1:se>ge?1:0}function A(se,ge,pe=0,ye=se.length,Le=0,ke=ge.length){for(;pe<ye&&Le<ke;pe++,Le++){const Ge=se.charCodeAt(pe),Ye=ge.charCodeAt(Le);if(Ge<Ye)return-1;if(Ge>Ye)return 1}const We=ye-pe,Je=ke-Le;return We<Je?-1:We>Je?1:0}function b(se,ge){return w(se,ge,0,se.length,0,ge.length)}function w(se,ge,pe=0,ye=se.length,Le=0,ke=ge.length){for(;pe<ye&&Le<ke;pe++,Le++){let Ge=se.charCodeAt(pe),Ye=ge.charCodeAt(Le);if(Ge===Ye)continue;if(Ge>=128||Ye>=128)return A(se.toLowerCase(),ge.toLowerCase(),pe,ye,Le,ke);F(Ge)&&(Ge-=32),F(Ye)&&(Ye-=32);const je=Ge-Ye;if(je!==0)return je}const We=ye-pe,Je=ke-Le;return We<Je?-1:We>Je?1:0}function O(se){return se>=a.CharCode.Digit0&&se<=a.CharCode.Digit9}function F(se){return se>=a.CharCode.a&&se<=a.CharCode.z}function N(se){return se>=a.CharCode.A&&se<=a.CharCode.Z}function M(se,ge){return se.length===ge.length&&w(se,ge)===0}function V(se,ge){const pe=ge.length;return ge.length>se.length?!1:w(se,ge,0,pe)===0}function z(se,ge){const pe=Math.min(se.length,ge.length);let ye;for(ye=0;ye<pe;ye++)if(se.charCodeAt(ye)!==ge.charCodeAt(ye))return ye;return pe}function J(se,ge){const pe=Math.min(se.length,ge.length);let ye;const Le=se.length-1,ke=ge.length-1;for(ye=0;ye<pe;ye++)if(se.charCodeAt(Le-ye)!==ge.charCodeAt(ke-ye))return ye;return pe}function j(se){return 55296<=se&&se<=56319}function te(se){return 56320<=se&&se<=57343}function q(se,ge){return(se-55296<<10)+(ge-56320)+65536}function B(se,ge,pe){const ye=se.charCodeAt(pe);if(j(ye)&&pe+1<ge){const Le=se.charCodeAt(pe+1);if(te(Le))return q(ye,Le)}return ye}function Z(se,ge){const pe=se.charCodeAt(ge-1);if(te(pe)&&ge>1){const ye=se.charCodeAt(ge-2);if(j(ye))return q(ye,pe)}return pe}class ne{get offset(){return this._offset}constructor(ge,pe=0){this._str=ge,this._len=ge.length,this._offset=pe}setOffset(ge){this._offset=ge}prevCodePoint(){const ge=Z(this._str,this._offset);return this._offset-=ge>=T.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,ge}nextCodePoint(){const ge=B(this._str,this._len,this._offset);return this._offset+=ge>=T.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,ge}eol(){return this._offset>=this._len}}e.CodePointIterator=ne;class le{get offset(){return this._iterator.offset}constructor(ge,pe=0){this._iterator=new ne(ge,pe)}nextGraphemeLength(){const ge=Fe.getInstance(),pe=this._iterator,ye=pe.offset;let Le=ge.getGraphemeBreakType(pe.nextCodePoint());for(;!pe.eol();){const ke=pe.offset,We=ge.getGraphemeBreakType(pe.nextCodePoint());if(_e(Le,We)){pe.setOffset(ke);break}Le=We}return pe.offset-ye}prevGraphemeLength(){const ge=Fe.getInstance(),pe=this._iterator,ye=pe.offset;let Le=ge.getGraphemeBreakType(pe.prevCodePoint());for(;pe.offset>0;){const ke=pe.offset,We=ge.getGraphemeBreakType(pe.prevCodePoint());if(_e(We,Le)){pe.setOffset(ke);break}Le=We}return ye-pe.offset}eol(){return this._iterator.eol()}}e.GraphemeIterator=le;function ee(se,ge){return new le(se,ge).nextGraphemeLength()}function K(se,ge){return new le(se,ge).prevGraphemeLength()}function H(se,ge){ge>0&&te(se.charCodeAt(ge))&&ge--;const pe=ge+ee(se,ge);return[pe-K(se,pe),pe]}function W(se){const ge=new le(se);let pe=0;for(;!ge.eol();)pe++,ge.nextGraphemeLength();return pe}let U;function G(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function oe(se){return U||(U=G()),U.test(se)}const Q=/^[\t\n\r\x20-\x7E]*$/;function X(se){return Q.test(se)}e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function x(se){return e.UNUSUAL_LINE_TERMINATORS.test(se)}function $(se){return se>=11904&&se<=55215||se>=63744&&se<=64255||se>=65281&&se<=65374}function ie(se){return se>=127462&&se<=127487||se===8986||se===8987||se===9200||se===9203||se>=9728&&se<=10175||se===11088||se===11093||se>=127744&&se<=128591||se>=128640&&se<=128764||se>=128992&&se<=129008||se>=129280&&se<=129535||se>=129648&&se<=129782}function ae(se,ge,pe=""){const ye=se.trimStart();if(ye.length<ge)return ye;const Le=/\b/g;let ke=0;for(;Le.test(ye)&&!(ye.length-Le.lastIndex<ge);)ke=Le.lastIndex,Le.lastIndex+=1;return ke===0?ye:pe+ye.substring(ke).trimStart()}const ue=/(?:(?:\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~])|(:?\x1b\].*?\x07)/g;function*Se(se){let ge=0;for(const pe of se.matchAll(ue))ge!==pe.index&&(yield{isCode:!1,str:se.substring(ge,pe.index)}),yield{isCode:!0,str:pe[0]},ge=pe.index+pe[0].length;ge!==se.length&&(yield{isCode:!1,str:se.substring(ge)})}function Ee(se){return se&&(se=se.replace(ue,"")),se}const Re=/\\\[.*?\\\]/g;function Te(se){return Ee(se).replace(Re,"")}e.UTF8_BOM_CHARACTER=String.fromCharCode(a.CharCode.UTF8_BOM);function we(se){return!!(se&&se.length>0&&se.charCodeAt(0)===a.CharCode.UTF8_BOM)}function ve(se){return we(se)?se.substr(1):se}function re(se,ge){if(!se||!ge||se.length<ge.length)return!1;const pe=ge.length,ye=se.toLowerCase();let Le=0,ke=-1;for(;Le<pe;){const We=ye.indexOf(ge[Le],ke+1);if(We<0)return!1;ke=We,Le++}return!0}function de(se,ge=!1){return se?(ge&&(se=se.replace(/\\./g,"")),se.toLowerCase()!==se):!1}function me(se){return se.charAt(0).toUpperCase()+se.slice(1)}function be(se,ge=1){if(ge===0)return"";let pe=-1;do pe=se.indexOf(`
`,pe+1),ge--;while(ge>0&&pe>=0);return pe===-1?se:(se[pe-1]==="\r"&&pe--,se.substr(0,pe))}function Ce(se){const ge=a.CharCode.Z-a.CharCode.A+1;return se=se%(2*ge),se<ge?String.fromCharCode(a.CharCode.a+se):String.fromCharCode(a.CharCode.A+se-ge)}function Ue(se){return Fe.getInstance().getGraphemeBreakType(se)}function _e(se,ge){return se===Ae.Other?ge!==Ae.Extend&&ge!==Ae.SpacingMark:se===Ae.CR&&ge===Ae.LF?!1:se===Ae.Control||se===Ae.CR||se===Ae.LF||ge===Ae.Control||ge===Ae.CR||ge===Ae.LF?!0:!(se===Ae.L&&(ge===Ae.L||ge===Ae.V||ge===Ae.LV||ge===Ae.LVT)||(se===Ae.LV||se===Ae.V)&&(ge===Ae.V||ge===Ae.T)||(se===Ae.LVT||se===Ae.T)&&ge===Ae.T||ge===Ae.Extend||ge===Ae.ZWJ||ge===Ae.SpacingMark||se===Ae.Prepend||se===Ae.ZWJ&&ge===Ae.Extended_Pictographic||se===Ae.Regional_Indicator&&ge===Ae.Regional_Indicator)}var Ae;(function(se){se[se.Other=0]="Other",se[se.Prepend=1]="Prepend",se[se.CR=2]="CR",se[se.LF=3]="LF",se[se.Control=4]="Control",se[se.Extend=5]="Extend",se[se.Regional_Indicator=6]="Regional_Indicator",se[se.SpacingMark=7]="SpacingMark",se[se.L=8]="L",se[se.V=9]="V",se[se.T=10]="T",se[se.LV=11]="LV",se[se.LVT=12]="LVT",se[se.ZWJ=13]="ZWJ",se[se.Extended_Pictographic=14]="Extended_Pictographic"})(Ae||(e.GraphemeBreakType=Ae={}));class Fe{static{this._INSTANCE=null}static getInstance(){return Fe._INSTANCE||(Fe._INSTANCE=new Fe),Fe._INSTANCE}constructor(){this._data=xe()}getGraphemeBreakType(ge){if(ge<32)return ge===a.CharCode.LineFeed?Ae.LF:ge===a.CharCode.CarriageReturn?Ae.CR:Ae.Control;if(ge<127)return Ae.Other;const pe=this._data,ye=pe.length/3;let Le=1;for(;Le<=ye;)if(ge<pe[3*Le])Le=2*Le;else if(ge>pe[3*Le+1])Le=2*Le+1;else return pe[3*Le+2];return Ae.Other}}function xe(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function ze(se,ge){if(se===0)return 0;const pe=Me(se,ge);if(pe!==void 0)return pe;const ye=new ne(ge,se);return ye.prevCodePoint(),ye.offset}function Me(se,ge){const pe=new ne(ge,se);let ye=pe.prevCodePoint();for(;$e(ye)||ye===qe.emojiVariantSelector||ye===qe.enclosingKeyCap;){if(pe.offset===0)return;ye=pe.prevCodePoint()}if(!ie(ye))return;let Le=pe.offset;return Le>0&&pe.prevCodePoint()===qe.zwj&&(Le=pe.offset),Le}function $e(se){return 127995<=se&&se<=127999}var qe;(function(se){se[se.zwj=8205]="zwj",se[se.emojiVariantSelector=65039]="emojiVariantSelector",se[se.enclosingKeyCap=8419]="enclosingKeyCap"})(qe||(qe={})),e.noBreakWhitespace="\xA0";class Be{static{this.ambiguousCharacterData=new _.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.cache=new R.LRUCachedFunction({getCacheKey:JSON.stringify},ge=>{function pe(je){const Ze=new Map;for(let Xe=0;Xe<je.length;Xe+=2)Ze.set(je[Xe],je[Xe+1]);return Ze}function ye(je,Ze){const Xe=new Map(je);for(const[nt,at]of Ze)Xe.set(nt,at);return Xe}function Le(je,Ze){if(!je)return Ze;const Xe=new Map;for(const[nt,at]of je)Ze.has(nt)&&Xe.set(nt,at);return Xe}const ke=this.ambiguousCharacterData.value;let We=ge.filter(je=>!je.startsWith("_")&&je in ke);We.length===0&&(We=["_default"]);let Je;for(const je of We){const Ze=pe(ke[je]);Je=Le(Je,Ze)}const Ge=pe(ke._common),Ye=ye(Ge,Je);return new Be(Ye)})}static getInstance(ge){return Be.cache.get(Array.from(ge))}static{this._locales=new _.Lazy(()=>Object.keys(Be.ambiguousCharacterData.value).filter(ge=>!ge.startsWith("_")))}static getLocales(){return Be._locales.value}constructor(ge){this.confusableDictionary=ge}isAmbiguous(ge){return this.confusableDictionary.has(ge)}containsAmbiguousCharacter(ge){for(let pe=0;pe<ge.length;pe++){const ye=ge.codePointAt(pe);if(typeof ye=="number"&&this.isAmbiguous(ye))return!0}return!1}getPrimaryConfusable(ge){return this.confusableDictionary.get(ge)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}e.AmbiguousCharacters=Be;class Oe{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this._data=void 0}static getData(){return this._data||(this._data=new Set(Oe.getRawData())),this._data}static isInvisibleCharacter(ge){return Oe.getData().has(ge)}static containsInvisibleCharacter(ge){for(let pe=0;pe<ge.length;pe++){const ye=ge.codePointAt(pe);if(typeof ye=="number"&&Oe.isInvisibleCharacter(ye))return!0}return!1}static get codePoints(){return Oe.getData()}}e.InvisibleCharacters=Oe}),define(he[55],fe([0,1,26]),function(ce,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.Hasher=void 0,e.hash=a,e.doHash=_,e.numberHash=T,e.stringHash=L,e.toHexString=g,R=De(R);function a(v){return _(v,0)}function _(v,f){switch(typeof v){case"object":return v===null?T(349,f):Array.isArray(v)?D(v,f):E(v,f);case"string":return L(v,f);case"boolean":return k(v,f);case"number":return T(v,f);case"undefined":return T(937,f);default:return T(617,f)}}function T(v,f){return(f<<5)-f+v|0}function k(v,f){return T(v?433:863,f)}function L(v,f){f=T(149417,f);for(let C=0,p=v.length;C<p;C++)f=T(v.charCodeAt(C),f);return f}function D(v,f){return f=T(104579,f),v.reduce((C,p)=>_(p,C),f)}function E(v,f){return f=T(181387,f),Object.keys(v).sort().reduce((C,p)=>(C=L(p,C),_(v[p],C)),f)}class P{constructor(){this._value=0}get value(){return this._value}hash(f){return this._value=_(f,this._value),this._value}}e.Hasher=P;var S;(function(v){v[v.BLOCK_SIZE=64]="BLOCK_SIZE",v[v.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(S||(S={}));function m(v,f,C=32){const p=C-f,c=~((1<<p)-1);return(v<<f|(c&v)>>>p)>>>0}function d(v,f=0,C=v.byteLength,p=0){for(let c=0;c<C;c++)v[f+c]=p}function l(v,f,C="0"){for(;v.length<f;)v=C+v;return v}function g(v,f=32){return v instanceof ArrayBuffer?Array.from(new Uint8Array(v)).map(C=>C.toString(16).padStart(2,"0")).join(""):l((v>>>0).toString(16),f/4)}class I{static{this._bigBlock32=new DataView(new ArrayBuffer(320))}constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(S.BLOCK_SIZE+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(f){const C=f.length;if(C===0)return;const p=this._buff;let c=this._buffLen,u=this._leftoverHighSurrogate,i,n;for(u!==0?(i=u,n=-1,u=0):(i=f.charCodeAt(0),n=0);;){let t=i;if(R.isHighSurrogate(i))if(n+1<C){const s=f.charCodeAt(n+1);R.isLowSurrogate(s)?(n++,t=R.computeCodePoint(i,s)):t=S.UNICODE_REPLACEMENT}else{u=i;break}else R.isLowSurrogate(i)&&(t=S.UNICODE_REPLACEMENT);if(c=this._push(p,c,t),n++,n<C)i=f.charCodeAt(n);else break}this._buffLen=c,this._leftoverHighSurrogate=u}_push(f,C,p){return p<128?f[C++]=p:p<2048?(f[C++]=192|(p&1984)>>>6,f[C++]=128|(p&63)>>>0):p<65536?(f[C++]=224|(p&61440)>>>12,f[C++]=128|(p&4032)>>>6,f[C++]=128|(p&63)>>>0):(f[C++]=240|(p&1835008)>>>18,f[C++]=128|(p&258048)>>>12,f[C++]=128|(p&4032)>>>6,f[C++]=128|(p&63)>>>0),C>=S.BLOCK_SIZE&&(this._step(),C-=S.BLOCK_SIZE,this._totalLen+=S.BLOCK_SIZE,f[0]=f[S.BLOCK_SIZE+0],f[1]=f[S.BLOCK_SIZE+1],f[2]=f[S.BLOCK_SIZE+2]),C}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,S.UNICODE_REPLACEMENT)),this._totalLen+=this._buffLen,this._wrapUp()),g(this._h0)+g(this._h1)+g(this._h2)+g(this._h3)+g(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,d(this._buff,this._buffLen),this._buffLen>56&&(this._step(),d(this._buff));const f=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(f/4294967296),!1),this._buffDV.setUint32(60,f%4294967296,!1),this._step()}_step(){const f=I._bigBlock32,C=this._buffDV;for(let o=0;o<64;o+=4)f.setUint32(o,C.getUint32(o,!1),!1);for(let o=64;o<320;o+=4)f.setUint32(o,m(f.getUint32(o-12,!1)^f.getUint32(o-32,!1)^f.getUint32(o-56,!1)^f.getUint32(o-64,!1),1),!1);let p=this._h0,c=this._h1,u=this._h2,i=this._h3,n=this._h4,t,s,r;for(let o=0;o<80;o++)o<20?(t=c&u|~c&i,s=1518500249):o<40?(t=c^u^i,s=1859775393):o<60?(t=c&u|c&i|u&i,s=2400959708):(t=c^u^i,s=3395469782),r=m(p,5)+t+n+s+f.getUint32(o*4,!1)&4294967295,n=i,i=u,u=m(c,30),c=p,p=r;this._h0=this._h0+p&4294967295,this._h1=this._h1+c&4294967295,this._h2=this._h2+u&4294967295,this._h3=this._h3+i&4294967295,this._h4=this._h4+n&4294967295}}e.StringSHA1=I}),define(he[92],fe([0,1,26]),function(ce,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),R=De(R);var a;(function(_){_[_.Ignore=0]="Ignore",_[_.Info=1]="Info",_[_.Warning=2]="Warning",_[_.Error=3]="Error"})(a||(a={})),function(_){const T="error",k="warning",L="warn",D="info",E="ignore";function P(m){return m?R.equalsIgnoreCase(T,m)?_.Error:R.equalsIgnoreCase(k,m)||R.equalsIgnoreCase(L,m)?_.Warning:R.equalsIgnoreCase(D,m)?_.Info:_.Ignore:_.Ignore}_.fromValue=P;function S(m){switch(m){case _.Error:return T;case _.Warning:return k;case _.Info:return D;default:return E}}_.toString=S}(a||(a={})),e.default=a}),define(he[51],fe([0,1,17,39,26]),function(ce,e,R,a,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class T{constructor(){this._value="",this._pos=0}reset(l){return this._value=l,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(l){const g=l.charCodeAt(0),I=this._value.charCodeAt(this._pos);return g-I}value(){return this._value[this._pos]}}e.StringIterator=T;class k{constructor(l=!0){this._caseSensitive=l}reset(l){return this._value=l,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let l=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===a.CharCode.Period)if(l)this._from++;else break;else l=!1;return this}cmp(l){return this._caseSensitive?(0,_.compareSubstring)(l,this._value,0,l.length,this._from,this._to):(0,_.compareSubstringIgnoreCase)(l,this._value,0,l.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=k;class L{constructor(l=!0,g=!0){this._splitOnBackslash=l,this._caseSensitive=g}reset(l){this._from=0,this._to=0,this._value=l,this._valueLen=l.length;for(let g=l.length-1;g>=0;g--,this._valueLen--){const I=this._value.charCodeAt(g);if(!(I===a.CharCode.Slash||this._splitOnBackslash&&I===a.CharCode.Backslash))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let l=!0;for(;this._to<this._valueLen;this._to++){const g=this._value.charCodeAt(this._to);if(g===a.CharCode.Slash||this._splitOnBackslash&&g===a.CharCode.Backslash)if(l)this._from++;else break;else l=!1}return this}cmp(l){return this._caseSensitive?(0,_.compareSubstring)(l,this._value,0,l.length,this._from,this._to):(0,_.compareSubstringIgnoreCase)(l,this._value,0,l.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=L;var D;(function(d){d[d.Scheme=1]="Scheme",d[d.Authority=2]="Authority",d[d.Path=3]="Path",d[d.Query=4]="Query",d[d.Fragment=5]="Fragment"})(D||(D={}));class E{constructor(l,g){this._ignorePathCasing=l,this._ignoreQueryAndFragment=g,this._states=[],this._stateIdx=0}reset(l){return this._value=l,this._states=[],this._value.scheme&&this._states.push(D.Scheme),this._value.authority&&this._states.push(D.Authority),this._value.path&&(this._pathIterator=new L(!1,!this._ignorePathCasing(l)),this._pathIterator.reset(l.path),this._pathIterator.value()&&this._states.push(D.Path)),this._ignoreQueryAndFragment(l)||(this._value.query&&this._states.push(D.Query),this._value.fragment&&this._states.push(D.Fragment)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===D.Path&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===D.Path&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(l){if(this._states[this._stateIdx]===D.Scheme)return(0,_.compareIgnoreCase)(l,this._value.scheme);if(this._states[this._stateIdx]===D.Authority)return(0,_.compareIgnoreCase)(l,this._value.authority);if(this._states[this._stateIdx]===D.Path)return this._pathIterator.cmp(l);if(this._states[this._stateIdx]===D.Query)return(0,_.compare)(l,this._value.query);if(this._states[this._stateIdx]===D.Fragment)return(0,_.compare)(l,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===D.Scheme)return this._value.scheme;if(this._states[this._stateIdx]===D.Authority)return this._value.authority;if(this._states[this._stateIdx]===D.Path)return this._pathIterator.value();if(this._states[this._stateIdx]===D.Query)return this._value.query;if(this._states[this._stateIdx]===D.Fragment)return this._value.fragment;throw new Error}}e.UriIterator=E;class P{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const l=this.right;return this.right=l.left,l.left=this,this.updateHeight(),l.updateHeight(),l}rotateRight(){const l=this.left;return this.left=l.right,l.right=this,this.updateHeight(),l.updateHeight(),l}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var S;(function(d){d[d.Left=-1]="Left",d[d.Mid=0]="Mid",d[d.Right=1]="Right"})(S||(S={}));class m{static forUris(l=()=>!1,g=()=>!1){return new m(new E(l,g))}static forPaths(l=!1){return new m(new L(void 0,!l))}static forStrings(){return new m(new T)}static forConfigKeys(){return new m(new k)}constructor(l){this._iter=l}clear(){this._root=void 0}fill(l,g){if(g){const I=g.slice(0);(0,R.shuffle)(I);for(const v of I)this.set(v,l)}else{const I=l.slice(0);(0,R.shuffle)(I);for(const v of I)this.set(v[0],v[1])}}set(l,g){const I=this._iter.reset(l);let v;this._root||(this._root=new P,this._root.segment=I.value());const f=[];for(v=this._root;;){const p=I.cmp(v.segment);if(p>0)v.left||(v.left=new P,v.left.segment=I.value()),f.push([S.Left,v]),v=v.left;else if(p<0)v.right||(v.right=new P,v.right.segment=I.value()),f.push([S.Right,v]),v=v.right;else if(I.hasNext())I.next(),v.mid||(v.mid=new P,v.mid.segment=I.value()),f.push([S.Mid,v]),v=v.mid;else break}const C=v.value;v.value=g,v.key=l;for(let p=f.length-1;p>=0;p--){const c=f[p][1];c.updateHeight();const u=c.balanceFactor();if(u<-1||u>1){const i=f[p][0],n=f[p+1][0];if(i===S.Right&&n===S.Right)f[p][1]=c.rotateLeft();else if(i===S.Left&&n===S.Left)f[p][1]=c.rotateRight();else if(i===S.Right&&n===S.Left)c.right=f[p+1][1]=f[p+1][1].rotateRight(),f[p][1]=c.rotateLeft();else if(i===S.Left&&n===S.Right)c.left=f[p+1][1]=f[p+1][1].rotateLeft(),f[p][1]=c.rotateRight();else throw new Error;if(p>0)switch(f[p-1][0]){case S.Left:f[p-1][1].left=f[p][1];break;case S.Right:f[p-1][1].right=f[p][1];break;case S.Mid:f[p-1][1].mid=f[p][1];break}else this._root=f[0][1]}}return C}get(l){return this._getNode(l)?.value}_getNode(l){const g=this._iter.reset(l);let I=this._root;for(;I;){const v=g.cmp(I.segment);if(v>0)I=I.left;else if(v<0)I=I.right;else if(g.hasNext())g.next(),I=I.mid;else break}return I}has(l){const g=this._getNode(l);return!(g?.value===void 0&&g?.mid===void 0)}delete(l){return this._delete(l,!1)}deleteSuperstr(l){return this._delete(l,!0)}_delete(l,g){const I=this._iter.reset(l),v=[];let f=this._root;for(;f;){const C=I.cmp(f.segment);if(C>0)v.push([S.Left,f]),f=f.left;else if(C<0)v.push([S.Right,f]),f=f.right;else if(I.hasNext())I.next(),v.push([S.Mid,f]),f=f.mid;else break}if(f){if(g?(f.left=void 0,f.mid=void 0,f.right=void 0,f.height=1):(f.key=void 0,f.value=void 0),!f.mid&&!f.value)if(f.left&&f.right){const C=this._min(f.right);if(C.key){const{key:p,value:c,segment:u}=C;this._delete(C.key,!1),f.key=p,f.value=c,f.segment=u}}else{const C=f.left??f.right;if(v.length>0){const[p,c]=v[v.length-1];switch(p){case S.Left:c.left=C;break;case S.Mid:c.mid=C;break;case S.Right:c.right=C;break}}else this._root=C}for(let C=v.length-1;C>=0;C--){const p=v[C][1];p.updateHeight();const c=p.balanceFactor();if(c>1?(p.right.balanceFactor()>=0||(p.right=p.right.rotateRight()),v[C][1]=p.rotateLeft()):c<-1&&(p.left.balanceFactor()<=0||(p.left=p.left.rotateLeft()),v[C][1]=p.rotateRight()),C>0)switch(v[C-1][0]){case S.Left:v[C-1][1].left=v[C][1];break;case S.Right:v[C-1][1].right=v[C][1];break;case S.Mid:v[C-1][1].mid=v[C][1];break}else this._root=v[0][1]}}}_min(l){for(;l.left;)l=l.left;return l}findSubstr(l){const g=this._iter.reset(l);let I=this._root,v;for(;I;){const f=g.cmp(I.segment);if(f>0)I=I.left;else if(f<0)I=I.right;else if(g.hasNext())g.next(),v=I.value||v,I=I.mid;else break}return I&&I.value||v}findSuperstr(l){return this._findSuperstrOrElement(l,!1)}_findSuperstrOrElement(l,g){const I=this._iter.reset(l);let v=this._root;for(;v;){const f=I.cmp(v.segment);if(f>0)v=v.left;else if(f<0)v=v.right;else if(I.hasNext())I.next(),v=v.mid;else return v.mid?this._entries(v.mid):g?v.value:void 0}}hasElementOrSubtree(l){return this._findSuperstrOrElement(l,!0)!==void 0}forEach(l){for(const[g,I]of this)l(I,g)}*[Symbol.iterator](){yield*this._entries(this._root)}_entries(l){const g=[];return this._dfsEntries(l,g),g[Symbol.iterator]()}_dfsEntries(l,g){l&&(l.left&&this._dfsEntries(l.left,g),l.value&&g.push([l.key,l.value]),l.mid&&this._dfsEntries(l.mid,g),l.right&&this._dfsEntries(l.right,g))}_isBalanced(){const l=g=>{if(!g)return!0;const I=g.balanceFactor();return I<-1||I>1?!1:l(g.left)&&l(g.right)};return l(this._root)}}e.TernarySearchTree=m}),define(he[32],fe([0,1]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=void 0,e.isUUID=a;const R=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function a(_){return R.test(_)}e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let _;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?_=crypto.getRandomValues.bind(crypto):_=function(L){for(let D=0;D<L.length;D++)L[D]=Math.floor(Math.random()*256);return L};const T=new Uint8Array(16),k=[];for(let L=0;L<256;L++)k.push(L.toString(16).padStart(2,"0"));return function(){_(T),T[6]=T[6]&15|64,T[8]=T[8]&63|128;let D=0,E="";return E+=k[T[D++]],E+=k[T[D++]],E+=k[T[D++]],E+=k[T[D++]],E+="-",E+=k[T[D++]],E+=k[T[D++]],E+="-",E+=k[T[D++]],E+=k[T[D++]],E+="-",E+=k[T[D++]],E+=k[T[D++]],E+="-",E+=k[T[D++]],E+=k[T[D++]],E+=k[T[D++]],E+=k[T[D++]],E+=k[T[D++]],E+=k[T[D++]],E}}()}),define(he[139],fe([0,1,38]),function(ce,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=T;const a=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function _(k){const L=k.replace(/\-/g,":").toLowerCase();return!a.has(L)}function T(){const k=(0,R.networkInterfaces)();for(const L in k){const D=k[L];if(D){for(const{mac:E}of D)if(_(E))return E}}throw new Error("Unable to retrieve mac address (unexpected format)")}}),define(he[140],fe([0,1,242,14]),function(ce,e,R,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StreamSplitter=void 0;class _ extends R.Transform{constructor(k){if(super(),typeof k=="number")this.splitter=k,this.spitterLen=1;else{const L=Buffer.isBuffer(k)?k:Buffer.from(k);this.splitter=L.length===1?L[0]:L,this.spitterLen=L.length}}_transform(k,L,D){this.buffer?this.buffer=Buffer.concat([this.buffer,k]):this.buffer=k;let E=0;for(;E<this.buffer.length;){const P=typeof this.splitter=="number"?this.buffer.indexOf(this.splitter,E):(0,a.binaryIndexOf)(this.buffer,this.splitter,E);if(P===-1)break;this.push(this.buffer.slice(E,P+this.spitterLen)),E=P+this.spitterLen}this.buffer=E===this.buffer.length?void 0:this.buffer.slice(E),D()}_flush(k){this.buffer&&this.push(this.buffer),k()}}e.StreamSplitter=_}),define(he[141],fe([0,1,66]),function(ce,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BROWSER_RESTRICTED_PORTS=void 0,e.findFreePort=a,e.findFreePortFaster=T,R=De(R);function a(L,D,E,P=1){let S=!1;return new Promise(m=>{const d=setTimeout(()=>{if(!S)return S=!0,m(0)},E);_(L,D,P,l=>{if(!S)return S=!0,clearTimeout(d),m(l)})})}function _(L,D,E,P){if(D===0)return P(0);const S=new R.Socket;S.once("connect",()=>(k(S),_(L+E,D-1,E,P))),S.once("data",()=>{}),S.once("error",m=>(k(S),m.code!=="ECONNREFUSED"?_(L+E,D-1,E,P):P(L))),S.connect(L,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function T(L,D,E,P="127.0.0.1"){let S=!1,m,d=1;const l=R.createServer({pauseOnConnect:!0});function g(I,v){S||(S=!0,l.removeAllListeners(),l.close(),m&&clearTimeout(m),v(I))}return new Promise(I=>{m=setTimeout(()=>{g(0,I)},E),l.on("listening",()=>{g(L,I)}),l.on("error",v=>{v&&(v.code==="EADDRINUSE"||v.code==="EACCES")&&d<D?(L++,d++,l.listen(L,P)):g(0,I)}),l.on("close",()=>{g(0,I)}),l.listen(L,P)})}function k(L){try{L.removeAllListeners("connect"),L.removeAllListeners("error"),L.end(),L.destroy(),L.unref()}catch(D){console.error(D)}}}),define(he[142],fe([0,1]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OfflineError=void 0,e.isOfflineError=a;const R="Offline";function a(T){return T instanceof _?!0:T instanceof Error&&T.name===R&&T.message===R}class _ extends Error{constructor(){super(R),this.name=this.message}}e.OfflineError=_}),define(he[143],fe([0,1]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isUtilityProcess=R;function R(a){return!!a.parentPort}}),define(he[93],fe([0,1]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNLSMessages=R,e.getNLSLanguage=a;function R(){return globalThis._VSCODE_NLS_MESSAGES}function a(){return globalThis._VSCODE_NLS_LANGUAGE}}),define(he[9],fe([0,1,93,93]),function(ce,e,R,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNLSMessages=e.getNLSLanguage=void 0,e.localize=k,e.localize2=D,Object.defineProperty(e,"getNLSLanguage",{enumerable:!0,get:function(){return a.getNLSLanguage}}),Object.defineProperty(e,"getNLSMessages",{enumerable:!0,get:function(){return a.getNLSMessages}});const _=(0,R.getNLSLanguage)()==="pseudo"||typeof document<"u"&&document.location&&document.location.hash.indexOf("pseudo=true")>=0;function T(E,P){let S;return P.length===0?S=E:S=E.replace(/\{(\d+)\}/g,(m,d)=>{const l=d[0],g=P[l];let I=m;return typeof g=="string"?I=g:(typeof g=="number"||typeof g=="boolean"||g===void 0||g===null)&&(I=String(g)),I}),_&&(S="\uFF3B"+S.replace(/[aouei]/g,"$&$&")+"\uFF3D"),S}function k(E,P,...S){return T(typeof E=="number"?L(E,P):P,S)}function L(E,P){const S=(0,R.getNLSMessages)()?.[E];if(typeof S!="string"){if(typeof P=="string")return P;throw new Error(`!!! NLS MISSING: ${E} !!!`)}return S}function D(E,P,...S){let m;typeof E=="number"?m=L(E,P):m=P;const d=T(m,S);return{value:d,original:P===m?d:T(P,S)}}}),define(he[67],fe([0,1,9]),function(ce,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fromNow=E,e.fromNowByDay=P,e.getDurationString=S,e.toLocalISOString=m;const a=60,_=a*60,T=_*24,k=T*7,L=T*30,D=T*365;function E(d,l,g,I){typeof d!="number"&&(d=d.getTime());const v=Math.round((new Date().getTime()-d)/1e3);if(v<-30)return(0,R.localize)(42,null,E(new Date().getTime()+v*1e3,!1));if(!I&&v<30)return(0,R.localize)(43,null);let f;return v<a?(f=v,l?f===1?g?(0,R.localize)(44,null,f):(0,R.localize)(45,null,f):g?(0,R.localize)(46,null,f):(0,R.localize)(47,null,f):f===1?g?(0,R.localize)(48,null,f):(0,R.localize)(49,null,f):g?(0,R.localize)(50,null,f):(0,R.localize)(51,null,f)):v<_?(f=Math.floor(v/a),l?f===1?g?(0,R.localize)(52,null,f):(0,R.localize)(53,null,f):g?(0,R.localize)(54,null,f):(0,R.localize)(55,null,f):f===1?g?(0,R.localize)(56,null,f):(0,R.localize)(57,null,f):g?(0,R.localize)(58,null,f):(0,R.localize)(59,null,f)):v<T?(f=Math.floor(v/_),l?f===1?g?(0,R.localize)(60,null,f):(0,R.localize)(61,null,f):g?(0,R.localize)(62,null,f):(0,R.localize)(63,null,f):f===1?g?(0,R.localize)(64,null,f):(0,R.localize)(65,null,f):g?(0,R.localize)(66,null,f):(0,R.localize)(67,null,f)):v<k?(f=Math.floor(v/T),l?f===1?(0,R.localize)(68,null,f):(0,R.localize)(69,null,f):f===1?(0,R.localize)(70,null,f):(0,R.localize)(71,null,f)):v<L?(f=Math.floor(v/k),l?f===1?g?(0,R.localize)(72,null,f):(0,R.localize)(73,null,f):g?(0,R.localize)(74,null,f):(0,R.localize)(75,null,f):f===1?g?(0,R.localize)(76,null,f):(0,R.localize)(77,null,f):g?(0,R.localize)(78,null,f):(0,R.localize)(79,null,f)):v<D?(f=Math.floor(v/L),l?f===1?g?(0,R.localize)(80,null,f):(0,R.localize)(81,null,f):g?(0,R.localize)(82,null,f):(0,R.localize)(83,null,f):f===1?g?(0,R.localize)(84,null,f):(0,R.localize)(85,null,f):g?(0,R.localize)(86,null,f):(0,R.localize)(87,null,f)):(f=Math.floor(v/D),l?f===1?g?(0,R.localize)(88,null,f):(0,R.localize)(89,null,f):g?(0,R.localize)(90,null,f):(0,R.localize)(91,null,f):f===1?g?(0,R.localize)(92,null,f):(0,R.localize)(93,null,f):g?(0,R.localize)(94,null,f):(0,R.localize)(95,null,f))}function P(d,l,g){typeof d!="number"&&(d=d.getTime());const I=new Date;I.setHours(0,0,0,0);const v=new Date(I.getTime());return v.setDate(v.getDate()-1),d>I.getTime()?(0,R.localize)(96,null):d>v.getTime()?(0,R.localize)(97,null):E(d,l,g)}function S(d,l){const g=Math.abs(d/1e3);return g<1?l?(0,R.localize)(98,null,d):(0,R.localize)(99,null,d):g<a?l?(0,R.localize)(100,null,Math.round(d)/1e3):(0,R.localize)(101,null,Math.round(d)/1e3):g<_?l?(0,R.localize)(102,null,Math.round(d/(1e3*a))):(0,R.localize)(103,null,Math.round(d/(1e3*a))):g<T?l?(0,R.localize)(104,null,Math.round(d/(1e3*_))):(0,R.localize)(105,null,Math.round(d/(1e3*_))):(0,R.localize)(106,null,Math.round(d/(1e3*T)))}function m(d){return d.getFullYear()+"-"+String(d.getMonth()+1).padStart(2,"0")+"-"+String(d.getDate()).padStart(2,"0")+"T"+String(d.getHours()).padStart(2,"0")+":"+String(d.getMinutes()).padStart(2,"0")+":"+String(d.getSeconds()).padStart(2,"0")+"."+(d.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(he[41],fe([0,1,17,12,9]),function(ce,e,R,a,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=D,e.isErrorWithActions=E,e.createErrorWithActions=P,R=De(R),a=De(a),_=De(_);function T(S,m){return m&&(S.stack||S.stacktrace)?_.localize(107,null,L(S),k(S.stack)||k(S.stacktrace)):L(S)}function k(S){return Array.isArray(S)?S.join(`
`):S}function L(S){return S.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${S.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof S.code=="string"&&typeof S.errno=="number"&&typeof S.syscall=="string"?_.localize(108,null,S.message):S.message||_.localize(109,null)}function D(S=null,m=!1){if(!S)return _.localize(110,null);if(Array.isArray(S)){const d=R.coalesce(S),l=D(d[0],m);return d.length>1?_.localize(111,null,l,d.length):l}if(a.isString(S))return S;if(S.detail){const d=S.detail;if(d.error)return T(d.error,m);if(d.exception)return T(d.exception,m)}return S.stack?T(S,m):S.message?S.message:_.localize(112,null)}function E(S){const m=S;return m instanceof Error&&Array.isArray(m.actions)}function P(S,m){let d;return typeof S=="string"?d=new Error(S):d=S,d.actions=m,d}}),define(he[144],fe([0,1,9,36]),function(ce,e,R,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getParseErrorMessage=_;function _(T){switch(T){case a.ParseErrorCode.InvalidSymbol:return(0,R.localize)(113,null);case a.ParseErrorCode.InvalidNumberFormat:return(0,R.localize)(114,null);case a.ParseErrorCode.PropertyNameExpected:return(0,R.localize)(115,null);case a.ParseErrorCode.ValueExpected:return(0,R.localize)(116,null);case a.ParseErrorCode.ColonExpected:return(0,R.localize)(117,null);case a.ParseErrorCode.CommaExpected:return(0,R.localize)(118,null);case a.ParseErrorCode.CloseBraceExpected:return(0,R.localize)(119,null);case a.ParseErrorCode.CloseBracketExpected:return(0,R.localize)(120,null);case a.ParseErrorCode.EndOfFileExpected:return(0,R.localize)(121,null);default:return""}}}),define(he[5],fe([0,1,9]),function(ce,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.platformLocale=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isMobile=e.isIOS=e.webWorkerOrigin=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.Platform=e.LANGUAGE_DEFAULT=void 0,e.PlatformToString=i,e.isLittleEndian=h,e.isBigSurOrNewer=y,R=De(R),e.LANGUAGE_DEFAULT="en";let a=!1,_=!1,T=!1,k=!1,L=!1,D=!1,E=!1,P=!1,S=!1,m=!1,d,l=e.LANGUAGE_DEFAULT,g=e.LANGUAGE_DEFAULT,I,v;const f=globalThis;let C;typeof f.vscode<"u"&&typeof f.vscode.process<"u"?C=f.vscode.process:typeof process<"u"&&typeof process?.versions?.node=="string"&&(C=process);const p=typeof C?.versions?.electron=="string",c=p&&C?.type==="renderer";if(typeof C=="object"){a=C.platform==="win32",_=C.platform==="darwin",T=C.platform==="linux",k=T&&!!C.env.SNAP&&!!C.env.SNAP_REVISION,E=p,S=!!C.env.CI||!!C.env.BUILD_ARTIFACTSTAGINGDIRECTORY,d=e.LANGUAGE_DEFAULT,l=e.LANGUAGE_DEFAULT;const A=C.env.VSCODE_NLS_CONFIG;if(A)try{const b=JSON.parse(A);d=b.userLocale,g=b.osLocale,l=b.resolvedLanguage||e.LANGUAGE_DEFAULT,I=b.languagePack?.translationsConfigFile}catch{}L=!0}else typeof navigator=="object"&&!c?(v=navigator.userAgent,a=v.indexOf("Windows")>=0,_=v.indexOf("Macintosh")>=0,P=(v.indexOf("Macintosh")>=0||v.indexOf("iPad")>=0||v.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,T=v.indexOf("Linux")>=0,m=v?.indexOf("Mobi")>=0,D=!0,l=R.getNLSLanguage()||e.LANGUAGE_DEFAULT,d=navigator.language.toLowerCase(),g=d):console.error("Unable to resolve platform.");var u;(function(A){A[A.Web=0]="Web",A[A.Mac=1]="Mac",A[A.Linux=2]="Linux",A[A.Windows=3]="Windows"})(u||(e.Platform=u={}));function i(A){switch(A){case u.Web:return"Web";case u.Mac:return"Mac";case u.Linux:return"Linux";case u.Windows:return"Windows"}}let n=u.Web;_?n=u.Mac:a?n=u.Windows:T&&(n=u.Linux),e.isWindows=a,e.isMacintosh=_,e.isLinux=T,e.isLinuxSnap=k,e.isNative=L,e.isElectron=E,e.isWeb=D,e.isWebWorker=D&&typeof f.importScripts=="function",e.webWorkerOrigin=e.isWebWorker?f.origin:void 0,e.isIOS=P,e.isMobile=m,e.isCI=S,e.platform=n,e.userAgent=v,e.language=l;var t;(function(A){function b(){return e.language}A.value=b;function w(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}A.isDefaultVariant=w;function O(){return e.language==="en"}A.isDefault=O})(t||(e.Language=t={})),e.locale=d,e.platformLocale=g,e.translationsConfigFile=I,e.setTimeout0IsFaster=typeof f.postMessage=="function"&&!f.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const A=[];f.addEventListener("message",w=>{if(w.data&&w.data.vscodeScheduleAsyncWork)for(let O=0,F=A.length;O<F;O++){const N=A[O];if(N.id===w.data.vscodeScheduleAsyncWork){A.splice(O,1),N.callback();return}}});let b=0;return w=>{const O=++b;A.push({id:O,callback:w}),f.postMessage({vscodeScheduleAsyncWork:O},"*")}}return A=>setTimeout(A)})();var s;(function(A){A[A.Windows=1]="Windows",A[A.Macintosh=2]="Macintosh",A[A.Linux=3]="Linux"})(s||(e.OperatingSystem=s={})),e.OS=_||P?s.Macintosh:a?s.Windows:s.Linux;let r=!0,o=!1;function h(){if(!o){o=!0;const A=new Uint8Array(2);A[0]=1,A[1]=2,r=new Uint16Array(A.buffer)[0]===513}return r}e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0);function y(A){return parseFloat(A)>=20}}),define(he[37],fe([0,1,5]),function(ce,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let a;const _=globalThis.vscode;if(typeof _<"u"&&typeof _.process<"u"){const T=_.process;a={get platform(){return T.platform},get arch(){return T.arch},get env(){return T.env},cwd(){return T.cwd()}}}else typeof process<"u"&&typeof process?.versions?.node=="string"?a={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:a={get platform(){return R.isWindows?"win32":R.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=a.cwd,e.env=a.env,e.platform=a.platform,e.arch=a.arch}),define(he[145],fe([0,1,37]),function(ce,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getDesktopEnvironment=k;var a;(function(L){L.UNKNOWN="UNKNOWN",L.CINNAMON="CINNAMON",L.DEEPIN="DEEPIN",L.GNOME="GNOME",L.KDE3="KDE3",L.KDE4="KDE4",L.KDE5="KDE5",L.KDE6="KDE6",L.PANTHEON="PANTHEON",L.UNITY="UNITY",L.XFCE="XFCE",L.UKUI="UKUI",L.LXQT="LXQT"})(a||(a={}));const _="XDG_CURRENT_DESKTOP",T="KDE_SESSION_VERSION";function k(){const L=R.env[_];if(L){const E=L.split(":").map(P=>P.trim()).filter(P=>P.length>0);for(const P of E)switch(P){case"Unity":{const S=R.env.DESKTOP_SESSION;return S&&S.includes("gnome-fallback")?a.GNOME:a.UNITY}case"Deepin":return a.DEEPIN;case"GNOME":return a.GNOME;case"X-Cinnamon":return a.CINNAMON;case"KDE":{const S=R.env[T];return S==="5"?a.KDE5:S==="6"?a.KDE6:a.KDE4}case"Pantheon":return a.PANTHEON;case"XFCE":return a.XFCE;case"UKUI":return a.UKUI;case"LXQt":return a.LXQT}}const D=R.env.DESKTOP_SESSION;if(D)switch(D){case"deepin":return a.DEEPIN;case"gnome":case"mate":return a.GNOME;case"kde4":case"kde-plasma":return a.KDE4;case"kde":return T in R.env?a.KDE4:a.KDE3;case"xfce":case"xubuntu":return a.XFCE;case"ukui":return a.UKUI}return"GNOME_DESKTOP_SESSION_ID"in R.env?a.GNOME:"KDE_FULL_SESSION"in R.env?T in R.env?a.KDE4:a.KDE3:a.UNKNOWN}}),define(he[13],fe([0,1,37]),function(ce,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0,R=De(R);const a=65,_=97,T=90,k=122,L=46,D=47,E=92,P=58,S=63;class m extends Error{constructor(n,t,s){let r;typeof t=="string"&&t.indexOf("not ")===0?(r="must not be",t=t.replace(/^not /,"")):r="must be";const o=n.indexOf(".")!==-1?"property":"argument";let h=`The "${n}" ${o} ${r} of type ${t}`;h+=`. Received type ${typeof s}`,super(h),this.code="ERR_INVALID_ARG_TYPE"}}function d(i,n){if(i===null||typeof i!="object")throw new m(n,"Object",i)}function l(i,n){if(typeof i!="string")throw new m(n,"string",i)}const g=R.platform==="win32";function I(i){return i===D||i===E}function v(i){return i===D}function f(i){return i>=a&&i<=T||i>=_&&i<=k}function C(i,n,t,s){let r="",o=0,h=-1,y=0,A=0;for(let b=0;b<=i.length;++b){if(b<i.length)A=i.charCodeAt(b);else{if(s(A))break;A=D}if(s(A)){if(!(h===b-1||y===1))if(y===2){if(r.length<2||o!==2||r.charCodeAt(r.length-1)!==L||r.charCodeAt(r.length-2)!==L){if(r.length>2){const w=r.lastIndexOf(t);w===-1?(r="",o=0):(r=r.slice(0,w),o=r.length-1-r.lastIndexOf(t)),h=b,y=0;continue}else if(r.length!==0){r="",o=0,h=b,y=0;continue}}n&&(r+=r.length>0?`${t}..`:"..",o=2)}else r.length>0?r+=`${t}${i.slice(h+1,b)}`:r=i.slice(h+1,b),o=b-h-1;h=b,y=0}else A===L&&y!==-1?++y:y=-1}return r}function p(i){return i?`${i[0]==="."?"":"."}${i}`:""}function c(i,n){d(n,"pathObject");const t=n.dir||n.root,s=n.base||`${n.name||""}${p(n.ext)}`;return t?t===n.root?`${t}${s}`:`${t}${i}${s}`:s}e.win32={resolve(...i){let n="",t="",s=!1;for(let r=i.length-1;r>=-1;r--){let o;if(r>=0){if(o=i[r],l(o,`paths[${r}]`),o.length===0)continue}else n.length===0?o=R.cwd():(o=R.env[`=${n}`]||R.cwd(),(o===void 0||o.slice(0,2).toLowerCase()!==n.toLowerCase()&&o.charCodeAt(2)===E)&&(o=`${n}\\`));const h=o.length;let y=0,A="",b=!1;const w=o.charCodeAt(0);if(h===1)I(w)&&(y=1,b=!0);else if(I(w))if(b=!0,I(o.charCodeAt(1))){let O=2,F=O;for(;O<h&&!I(o.charCodeAt(O));)O++;if(O<h&&O!==F){const N=o.slice(F,O);for(F=O;O<h&&I(o.charCodeAt(O));)O++;if(O<h&&O!==F){for(F=O;O<h&&!I(o.charCodeAt(O));)O++;(O===h||O!==F)&&(A=`\\\\${N}\\${o.slice(F,O)}`,y=O)}}}else y=1;else f(w)&&o.charCodeAt(1)===P&&(A=o.slice(0,2),y=2,h>2&&I(o.charCodeAt(2))&&(b=!0,y=3));if(A.length>0)if(n.length>0){if(A.toLowerCase()!==n.toLowerCase())continue}else n=A;if(s){if(n.length>0)break}else if(t=`${o.slice(y)}\\${t}`,s=b,b&&n.length>0)break}return t=C(t,!s,"\\",I),s?`${n}\\${t}`:`${n}${t}`||"."},normalize(i){l(i,"path");const n=i.length;if(n===0)return".";let t=0,s,r=!1;const o=i.charCodeAt(0);if(n===1)return v(o)?"\\":i;if(I(o))if(r=!0,I(i.charCodeAt(1))){let y=2,A=y;for(;y<n&&!I(i.charCodeAt(y));)y++;if(y<n&&y!==A){const b=i.slice(A,y);for(A=y;y<n&&I(i.charCodeAt(y));)y++;if(y<n&&y!==A){for(A=y;y<n&&!I(i.charCodeAt(y));)y++;if(y===n)return`\\\\${b}\\${i.slice(A)}\\`;y!==A&&(s=`\\\\${b}\\${i.slice(A,y)}`,t=y)}}}else t=1;else f(o)&&i.charCodeAt(1)===P&&(s=i.slice(0,2),t=2,n>2&&I(i.charCodeAt(2))&&(r=!0,t=3));let h=t<n?C(i.slice(t),!r,"\\",I):"";return h.length===0&&!r&&(h="."),h.length>0&&I(i.charCodeAt(n-1))&&(h+="\\"),s===void 0?r?`\\${h}`:h:r?`${s}\\${h}`:`${s}${h}`},isAbsolute(i){l(i,"path");const n=i.length;if(n===0)return!1;const t=i.charCodeAt(0);return I(t)||n>2&&f(t)&&i.charCodeAt(1)===P&&I(i.charCodeAt(2))},join(...i){if(i.length===0)return".";let n,t;for(let o=0;o<i.length;++o){const h=i[o];l(h,"path"),h.length>0&&(n===void 0?n=t=h:n+=`\\${h}`)}if(n===void 0)return".";let s=!0,r=0;if(typeof t=="string"&&I(t.charCodeAt(0))){++r;const o=t.length;o>1&&I(t.charCodeAt(1))&&(++r,o>2&&(I(t.charCodeAt(2))?++r:s=!1))}if(s){for(;r<n.length&&I(n.charCodeAt(r));)r++;r>=2&&(n=`\\${n.slice(r)}`)}return e.win32.normalize(n)},relative(i,n){if(l(i,"from"),l(n,"to"),i===n)return"";const t=e.win32.resolve(i),s=e.win32.resolve(n);if(t===s||(i=t.toLowerCase(),n=s.toLowerCase(),i===n))return"";let r=0;for(;r<i.length&&i.charCodeAt(r)===E;)r++;let o=i.length;for(;o-1>r&&i.charCodeAt(o-1)===E;)o--;const h=o-r;let y=0;for(;y<n.length&&n.charCodeAt(y)===E;)y++;let A=n.length;for(;A-1>y&&n.charCodeAt(A-1)===E;)A--;const b=A-y,w=h<b?h:b;let O=-1,F=0;for(;F<w;F++){const M=i.charCodeAt(r+F);if(M!==n.charCodeAt(y+F))break;M===E&&(O=F)}if(F!==w){if(O===-1)return s}else{if(b>w){if(n.charCodeAt(y+F)===E)return s.slice(y+F+1);if(F===2)return s.slice(y+F)}h>w&&(i.charCodeAt(r+F)===E?O=F:F===2&&(O=3)),O===-1&&(O=0)}let N="";for(F=r+O+1;F<=o;++F)(F===o||i.charCodeAt(F)===E)&&(N+=N.length===0?"..":"\\..");return y+=O,N.length>0?`${N}${s.slice(y,A)}`:(s.charCodeAt(y)===E&&++y,s.slice(y,A))},toNamespacedPath(i){if(typeof i!="string"||i.length===0)return i;const n=e.win32.resolve(i);if(n.length<=2)return i;if(n.charCodeAt(0)===E){if(n.charCodeAt(1)===E){const t=n.charCodeAt(2);if(t!==S&&t!==L)return`\\\\?\\UNC\\${n.slice(2)}`}}else if(f(n.charCodeAt(0))&&n.charCodeAt(1)===P&&n.charCodeAt(2)===E)return`\\\\?\\${n}`;return i},dirname(i){l(i,"path");const n=i.length;if(n===0)return".";let t=-1,s=0;const r=i.charCodeAt(0);if(n===1)return I(r)?i:".";if(I(r)){if(t=s=1,I(i.charCodeAt(1))){let y=2,A=y;for(;y<n&&!I(i.charCodeAt(y));)y++;if(y<n&&y!==A){for(A=y;y<n&&I(i.charCodeAt(y));)y++;if(y<n&&y!==A){for(A=y;y<n&&!I(i.charCodeAt(y));)y++;if(y===n)return i;y!==A&&(t=s=y+1)}}}}else f(r)&&i.charCodeAt(1)===P&&(t=n>2&&I(i.charCodeAt(2))?3:2,s=t);let o=-1,h=!0;for(let y=n-1;y>=s;--y)if(I(i.charCodeAt(y))){if(!h){o=y;break}}else h=!1;if(o===-1){if(t===-1)return".";o=t}return i.slice(0,o)},basename(i,n){n!==void 0&&l(n,"suffix"),l(i,"path");let t=0,s=-1,r=!0,o;if(i.length>=2&&f(i.charCodeAt(0))&&i.charCodeAt(1)===P&&(t=2),n!==void 0&&n.length>0&&n.length<=i.length){if(n===i)return"";let h=n.length-1,y=-1;for(o=i.length-1;o>=t;--o){const A=i.charCodeAt(o);if(I(A)){if(!r){t=o+1;break}}else y===-1&&(r=!1,y=o+1),h>=0&&(A===n.charCodeAt(h)?--h===-1&&(s=o):(h=-1,s=y))}return t===s?s=y:s===-1&&(s=i.length),i.slice(t,s)}for(o=i.length-1;o>=t;--o)if(I(i.charCodeAt(o))){if(!r){t=o+1;break}}else s===-1&&(r=!1,s=o+1);return s===-1?"":i.slice(t,s)},extname(i){l(i,"path");let n=0,t=-1,s=0,r=-1,o=!0,h=0;i.length>=2&&i.charCodeAt(1)===P&&f(i.charCodeAt(0))&&(n=s=2);for(let y=i.length-1;y>=n;--y){const A=i.charCodeAt(y);if(I(A)){if(!o){s=y+1;break}continue}r===-1&&(o=!1,r=y+1),A===L?t===-1?t=y:h!==1&&(h=1):t!==-1&&(h=-1)}return t===-1||r===-1||h===0||h===1&&t===r-1&&t===s+1?"":i.slice(t,r)},format:c.bind(null,"\\"),parse(i){l(i,"path");const n={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return n;const t=i.length;let s=0,r=i.charCodeAt(0);if(t===1)return I(r)?(n.root=n.dir=i,n):(n.base=n.name=i,n);if(I(r)){if(s=1,I(i.charCodeAt(1))){let O=2,F=O;for(;O<t&&!I(i.charCodeAt(O));)O++;if(O<t&&O!==F){for(F=O;O<t&&I(i.charCodeAt(O));)O++;if(O<t&&O!==F){for(F=O;O<t&&!I(i.charCodeAt(O));)O++;O===t?s=O:O!==F&&(s=O+1)}}}}else if(f(r)&&i.charCodeAt(1)===P){if(t<=2)return n.root=n.dir=i,n;if(s=2,I(i.charCodeAt(2))){if(t===3)return n.root=n.dir=i,n;s=3}}s>0&&(n.root=i.slice(0,s));let o=-1,h=s,y=-1,A=!0,b=i.length-1,w=0;for(;b>=s;--b){if(r=i.charCodeAt(b),I(r)){if(!A){h=b+1;break}continue}y===-1&&(A=!1,y=b+1),r===L?o===-1?o=b:w!==1&&(w=1):o!==-1&&(w=-1)}return y!==-1&&(o===-1||w===0||w===1&&o===y-1&&o===h+1?n.base=n.name=i.slice(h,y):(n.name=i.slice(h,o),n.base=i.slice(h,y),n.ext=i.slice(o,y))),h>0&&h!==s?n.dir=i.slice(0,h-1):n.dir=n.root,n},sep:"\\",delimiter:";",win32:null,posix:null};const u=(()=>{if(g){const i=/\\/g;return()=>{const n=R.cwd().replace(i,"/");return n.slice(n.indexOf("/"))}}return()=>R.cwd()})();e.posix={resolve(...i){let n="",t=!1;for(let s=i.length-1;s>=-1&&!t;s--){const r=s>=0?i[s]:u();l(r,`paths[${s}]`),r.length!==0&&(n=`${r}/${n}`,t=r.charCodeAt(0)===D)}return n=C(n,!t,"/",v),t?`/${n}`:n.length>0?n:"."},normalize(i){if(l(i,"path"),i.length===0)return".";const n=i.charCodeAt(0)===D,t=i.charCodeAt(i.length-1)===D;return i=C(i,!n,"/",v),i.length===0?n?"/":t?"./":".":(t&&(i+="/"),n?`/${i}`:i)},isAbsolute(i){return l(i,"path"),i.length>0&&i.charCodeAt(0)===D},join(...i){if(i.length===0)return".";let n;for(let t=0;t<i.length;++t){const s=i[t];l(s,"path"),s.length>0&&(n===void 0?n=s:n+=`/${s}`)}return n===void 0?".":e.posix.normalize(n)},relative(i,n){if(l(i,"from"),l(n,"to"),i===n||(i=e.posix.resolve(i),n=e.posix.resolve(n),i===n))return"";const t=1,s=i.length,r=s-t,o=1,h=n.length-o,y=r<h?r:h;let A=-1,b=0;for(;b<y;b++){const O=i.charCodeAt(t+b);if(O!==n.charCodeAt(o+b))break;O===D&&(A=b)}if(b===y)if(h>y){if(n.charCodeAt(o+b)===D)return n.slice(o+b+1);if(b===0)return n.slice(o+b)}else r>y&&(i.charCodeAt(t+b)===D?A=b:b===0&&(A=0));let w="";for(b=t+A+1;b<=s;++b)(b===s||i.charCodeAt(b)===D)&&(w+=w.length===0?"..":"/..");return`${w}${n.slice(o+A)}`},toNamespacedPath(i){return i},dirname(i){if(l(i,"path"),i.length===0)return".";const n=i.charCodeAt(0)===D;let t=-1,s=!0;for(let r=i.length-1;r>=1;--r)if(i.charCodeAt(r)===D){if(!s){t=r;break}}else s=!1;return t===-1?n?"/":".":n&&t===1?"//":i.slice(0,t)},basename(i,n){n!==void 0&&l(n,"ext"),l(i,"path");let t=0,s=-1,r=!0,o;if(n!==void 0&&n.length>0&&n.length<=i.length){if(n===i)return"";let h=n.length-1,y=-1;for(o=i.length-1;o>=0;--o){const A=i.charCodeAt(o);if(A===D){if(!r){t=o+1;break}}else y===-1&&(r=!1,y=o+1),h>=0&&(A===n.charCodeAt(h)?--h===-1&&(s=o):(h=-1,s=y))}return t===s?s=y:s===-1&&(s=i.length),i.slice(t,s)}for(o=i.length-1;o>=0;--o)if(i.charCodeAt(o)===D){if(!r){t=o+1;break}}else s===-1&&(r=!1,s=o+1);return s===-1?"":i.slice(t,s)},extname(i){l(i,"path");let n=-1,t=0,s=-1,r=!0,o=0;for(let h=i.length-1;h>=0;--h){const y=i.charCodeAt(h);if(y===D){if(!r){t=h+1;break}continue}s===-1&&(r=!1,s=h+1),y===L?n===-1?n=h:o!==1&&(o=1):n!==-1&&(o=-1)}return n===-1||s===-1||o===0||o===1&&n===s-1&&n===t+1?"":i.slice(n,s)},format:c.bind(null,"/"),parse(i){l(i,"path");const n={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return n;const t=i.charCodeAt(0)===D;let s;t?(n.root="/",s=1):s=0;let r=-1,o=0,h=-1,y=!0,A=i.length-1,b=0;for(;A>=s;--A){const w=i.charCodeAt(A);if(w===D){if(!y){o=A+1;break}continue}h===-1&&(y=!1,h=A+1),w===L?r===-1?r=A:b!==1&&(b=1):r!==-1&&(b=-1)}if(h!==-1){const w=o===0&&t?1:o;r===-1||b===0||b===1&&r===h-1&&r===o+1?n.base=n.name=i.slice(w,h):(n.name=i.slice(w,r),n.base=i.slice(w,h),n.ext=i.slice(r,h))}return o>0?n.dir=i.slice(0,o-1):t&&(n.dir="/"),n},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=g?e.win32.normalize:e.posix.normalize,e.isAbsolute=g?e.win32.isAbsolute:e.posix.isAbsolute,e.join=g?e.win32.join:e.posix.join,e.resolve=g?e.win32.resolve:e.posix.resolve,e.relative=g?e.win32.relative:e.posix.relative,e.dirname=g?e.win32.dirname:e.posix.dirname,e.basename=g?e.win32.basename:e.posix.basename,e.extname=g?e.win32.extname:e.posix.extname,e.format=g?e.win32.format:e.posix.format,e.parse=g?e.win32.parse:e.posix.parse,e.toNamespacedPath=g?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=g?e.win32.sep:e.posix.sep,e.delimiter=g?e.win32.delimiter:e.posix.delimiter}),define(he[42],fe([0,1,39,13,5,26,12]),function(ce,e,R,a,_,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPathSeparator=L,e.toSlashes=D,e.toPosixPath=E,e.getRoot=P,e.isUNC=S,e.isValidBasename=g,e.isEqual=I,e.isEqualOrParent=v,e.isWindowsDriveLetter=f,e.sanitizeFilePath=C,e.removeTrailingPathSeparator=p,e.isRootOrDriveLetter=c,e.hasDriveLetter=u,e.getDriveLetter=i,e.indexOfPath=n,e.parseLineAndColumnAware=t,e.randomPath=o;function L(h){return h===R.CharCode.Slash||h===R.CharCode.Backslash}function D(h){return h.replace(/[\\/]/g,a.posix.sep)}function E(h){return h.indexOf("/")===-1&&(h=D(h)),/^[a-zA-Z]:(\/|$)/.test(h)&&(h="/"+h),h}function P(h,y=a.posix.sep){if(!h)return"";const A=h.length,b=h.charCodeAt(0);if(L(b)){if(L(h.charCodeAt(1))&&!L(h.charCodeAt(2))){let O=3;const F=O;for(;O<A&&!L(h.charCodeAt(O));O++);if(F!==O&&!L(h.charCodeAt(O+1))){for(O+=1;O<A;O++)if(L(h.charCodeAt(O)))return h.slice(0,O+1).replace(/[\\/]/g,y)}}return y}else if(f(b)&&h.charCodeAt(1)===R.CharCode.Colon)return L(h.charCodeAt(2))?h.slice(0,2)+y:h.slice(0,2);let w=h.indexOf("://");if(w!==-1){for(w+=3;w<A;w++)if(L(h.charCodeAt(w)))return h.slice(0,w+1)}return""}function S(h){if(!_.isWindows||!h||h.length<5)return!1;let y=h.charCodeAt(0);if(y!==R.CharCode.Backslash||(y=h.charCodeAt(1),y!==R.CharCode.Backslash))return!1;let A=2;const b=A;for(;A<h.length&&(y=h.charCodeAt(A),y!==R.CharCode.Backslash);A++);return!(b===A||(y=h.charCodeAt(A+1),isNaN(y)||y===R.CharCode.Backslash))}const m=/[\\/:\*\?"<>\|]/g,d=/[/]/g,l=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function g(h,y=_.isWindows){const A=y?m:d;return!(!h||h.length===0||/^\s+$/.test(h)||(A.lastIndex=0,A.test(h))||y&&l.test(h)||h==="."||h===".."||y&&h[h.length-1]==="."||y&&h.length!==h.trim().length||h.length>255)}function I(h,y,A){const b=h===y;return!A||b?b:!h||!y?!1:(0,T.equalsIgnoreCase)(h,y)}function v(h,y,A,b=a.sep){if(h===y)return!0;if(!h||!y||y.length>h.length)return!1;if(A){if(!(0,T.startsWithIgnoreCase)(h,y))return!1;if(y.length===h.length)return!0;let O=y.length;return y.charAt(y.length-1)===b&&O--,h.charAt(O)===b}return y.charAt(y.length-1)!==b&&(y+=b),h.indexOf(y)===0}function f(h){return h>=R.CharCode.A&&h<=R.CharCode.Z||h>=R.CharCode.a&&h<=R.CharCode.z}function C(h,y){return _.isWindows&&h.endsWith(":")&&(h+=a.sep),(0,a.isAbsolute)(h)||(h=(0,a.join)(y,h)),h=(0,a.normalize)(h),p(h)}function p(h){return _.isWindows?(h=(0,T.rtrim)(h,a.sep),h.endsWith(":")&&(h+=a.sep)):(h=(0,T.rtrim)(h,a.sep),h||(h=a.sep)),h}function c(h){const y=(0,a.normalize)(h);return _.isWindows?h.length>3?!1:u(y)&&(h.length===2||y.charCodeAt(2)===R.CharCode.Backslash):y===a.posix.sep}function u(h,y=_.isWindows){return y?f(h.charCodeAt(0))&&h.charCodeAt(1)===R.CharCode.Colon:!1}function i(h,y=_.isWindows){return u(h,y)?h[0]:void 0}function n(h,y,A){return y.length>h.length?-1:h===y?0:(A&&(h=h.toLowerCase(),y=y.toLowerCase()),h.indexOf(y))}function t(h){const y=h.split(":");let A,b,w;for(const O of y){const F=Number(O);(0,k.isNumber)(F)?b===void 0?b=F:w===void 0&&(w=F):A=A?[A,O].join(":"):O}if(!A)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:A,line:b!==void 0?b:void 0,column:w!==void 0?w:b!==void 0?1:void 0}}const s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",r="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function o(h,y,A=8){let b="";for(let O=0;O<A;O++){let F;O===0&&_.isWindows&&!y&&(A===3||A===4)?F=r:F=s,b+=F.charAt(Math.floor(Math.random()*F.length))}let w;return y?w=`${y}-${b}`:w=b,h?(0,a.join)(h,w):w}}),define(he[146],fe([0,1,13]),function(ce,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Mimes=void 0,e.getMediaOrTextMime=T,e.getMediaMime=k,e.getExtensionForMimeType=L,e.normalizeMimeType=E,e.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const a={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},_={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function T(P){const S=(0,R.extname)(P),m=a[S.toLowerCase()];return m!==void 0?m:k(P)}function k(P){const S=(0,R.extname)(P);return _[S.toLowerCase()]}function L(P){for(const S in _)if(_[S]===P)return S}const D=/^(.+)\/(.+?)(;.+)?$/;function E(P,S){const m=D.exec(P);return m?`${m[1].toLowerCase()}/${m[2].toLowerCase()}${m[3]??""}`:S?void 0:P}}),define(he[94],fe([0,1,5]),function(ce,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminateResponseCode=e.Source=void 0,e.sanitizeProcessEnvironment=T,e.removeDangerousEnvVariables=k;var a;(function(L){L[L.stdout=0]="stdout",L[L.stderr=1]="stderr"})(a||(e.Source=a={}));var _;(function(L){L[L.Success=0]="Success",L[L.Unknown=1]="Unknown",L[L.AccessDenied=2]="AccessDenied",L[L.ProcessNotFound=3]="ProcessNotFound"})(_||(e.TerminateResponseCode=_={}));function T(L,...D){const E=D.reduce((m,d)=>(m[d]=!0,m),{}),P=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(L).filter(m=>!E[m]).forEach(m=>{for(let d=0;d<P.length;d++)if(m.search(P[d])!==-1){delete L[m];break}})}function k(L){L&&(delete L.DEBUG,R.isLinux&&delete L.LD_PRELOAD)}}),define(he[10],fe([0,1,39,65,13,5]),function(ce,e,R,a,_,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URI=void 0,e.isUriComponents=I,e.uriToFsPath=u,_=De(_);const k=/^\w[\w\d+.-]*$/,L=/^\//,D=/^\/\//;function E(r,o){if(!r.scheme&&o)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${r.authority}", path: "${r.path}", query: "${r.query}", fragment: "${r.fragment}"}`);if(r.scheme&&!k.test(r.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(r.path){if(r.authority){if(!L.test(r.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(D.test(r.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function P(r,o){return!r&&!o?"file":r}function S(r,o){switch(r){case"https":case"http":case"file":o?o[0]!==d&&(o=d+o):o=d;break}return o}const m="",d="/",l=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class g{static isUri(o){return o instanceof g?!0:o?typeof o.authority=="string"&&typeof o.fragment=="string"&&typeof o.path=="string"&&typeof o.query=="string"&&typeof o.scheme=="string"&&typeof o.fsPath=="string"&&typeof o.with=="function"&&typeof o.toString=="function":!1}constructor(o,h,y,A,b,w=!1){typeof o=="object"?(this.scheme=o.scheme||m,this.authority=o.authority||m,this.path=o.path||m,this.query=o.query||m,this.fragment=o.fragment||m):(this.scheme=P(o,w),this.authority=h||m,this.path=S(this.scheme,y||m),this.query=A||m,this.fragment=b||m,E(this,w))}get fsPath(){return u(this,!1)}with(o){if(!o)return this;let{scheme:h,authority:y,path:A,query:b,fragment:w}=o;return h===void 0?h=this.scheme:h===null&&(h=m),y===void 0?y=this.authority:y===null&&(y=m),A===void 0?A=this.path:A===null&&(A=m),b===void 0?b=this.query:b===null&&(b=m),w===void 0?w=this.fragment:w===null&&(w=m),h===this.scheme&&y===this.authority&&A===this.path&&b===this.query&&w===this.fragment?this:new f(h,y,A,b,w)}static parse(o,h=!1){const y=l.exec(o);return y?new f(y[2]||m,s(y[4]||m),s(y[5]||m),s(y[7]||m),s(y[9]||m),h):new f(m,m,m,m,m)}static file(o){let h=m;if(T.isWindows&&(o=o.replace(/\\/g,d)),o[0]===d&&o[1]===d){const y=o.indexOf(d,2);y===-1?(h=o.substring(2),o=d):(h=o.substring(2,y),o=o.substring(y)||d)}return new f("file",h,o,m,m)}static from(o,h){return new f(o.scheme,o.authority,o.path,o.query,o.fragment,h)}static joinPath(o,...h){if(!o.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let y;return T.isWindows&&o.scheme==="file"?y=g.file(_.win32.join(u(o,!0),...h)).path:y=_.posix.join(o.path,...h),o.with({path:y})}toString(o=!1){return i(this,o)}toJSON(){return this}static revive(o){if(o){if(o instanceof g)return o;{const h=new f(o);return h._formatted=o.external??null,h._fsPath=o._sep===v?o.fsPath??null:null,h}}else return o}[Symbol.for("debug.description")](){return`URI(${this.toString()})`}}e.URI=g;function I(r){return!r||typeof r!="object"?!1:typeof r.scheme=="string"&&(typeof r.authority=="string"||typeof r.authority>"u")&&(typeof r.path=="string"||typeof r.path>"u")&&(typeof r.query=="string"||typeof r.query>"u")&&(typeof r.fragment=="string"||typeof r.fragment>"u")}const v=T.isWindows?1:void 0;class f extends g{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=u(this,!1)),this._fsPath}toString(o=!1){return o?i(this,!0):(this._formatted||(this._formatted=i(this,!1)),this._formatted)}toJSON(){const o={$mid:a.MarshalledId.Uri};return this._fsPath&&(o.fsPath=this._fsPath,o._sep=v),this._formatted&&(o.external=this._formatted),this.path&&(o.path=this.path),this.scheme&&(o.scheme=this.scheme),this.authority&&(o.authority=this.authority),this.query&&(o.query=this.query),this.fragment&&(o.fragment=this.fragment),o}}const C={[R.CharCode.Colon]:"%3A",[R.CharCode.Slash]:"%2F",[R.CharCode.QuestionMark]:"%3F",[R.CharCode.Hash]:"%23",[R.CharCode.OpenSquareBracket]:"%5B",[R.CharCode.CloseSquareBracket]:"%5D",[R.CharCode.AtSign]:"%40",[R.CharCode.ExclamationMark]:"%21",[R.CharCode.DollarSign]:"%24",[R.CharCode.Ampersand]:"%26",[R.CharCode.SingleQuote]:"%27",[R.CharCode.OpenParen]:"%28",[R.CharCode.CloseParen]:"%29",[R.CharCode.Asterisk]:"%2A",[R.CharCode.Plus]:"%2B",[R.CharCode.Comma]:"%2C",[R.CharCode.Semicolon]:"%3B",[R.CharCode.Equals]:"%3D",[R.CharCode.Space]:"%20"};function p(r,o,h){let y,A=-1;for(let b=0;b<r.length;b++){const w=r.charCodeAt(b);if(w>=R.CharCode.a&&w<=R.CharCode.z||w>=R.CharCode.A&&w<=R.CharCode.Z||w>=R.CharCode.Digit0&&w<=R.CharCode.Digit9||w===R.CharCode.Dash||w===R.CharCode.Period||w===R.CharCode.Underline||w===R.CharCode.Tilde||o&&w===R.CharCode.Slash||h&&w===R.CharCode.OpenSquareBracket||h&&w===R.CharCode.CloseSquareBracket||h&&w===R.CharCode.Colon)A!==-1&&(y+=encodeURIComponent(r.substring(A,b)),A=-1),y!==void 0&&(y+=r.charAt(b));else{y===void 0&&(y=r.substr(0,b));const O=C[w];O!==void 0?(A!==-1&&(y+=encodeURIComponent(r.substring(A,b)),A=-1),y+=O):A===-1&&(A=b)}}return A!==-1&&(y+=encodeURIComponent(r.substring(A))),y!==void 0?y:r}function c(r){let o;for(let h=0;h<r.length;h++){const y=r.charCodeAt(h);y===R.CharCode.Hash||y===R.CharCode.QuestionMark?(o===void 0&&(o=r.substr(0,h)),o+=C[y]):o!==void 0&&(o+=r[h])}return o!==void 0?o:r}function u(r,o){let h;return r.authority&&r.path.length>1&&r.scheme==="file"?h=`//${r.authority}${r.path}`:r.path.charCodeAt(0)===R.CharCode.Slash&&(r.path.charCodeAt(1)>=R.CharCode.A&&r.path.charCodeAt(1)<=R.CharCode.Z||r.path.charCodeAt(1)>=R.CharCode.a&&r.path.charCodeAt(1)<=R.CharCode.z)&&r.path.charCodeAt(2)===R.CharCode.Colon?o?h=r.path.substr(1):h=r.path[1].toLowerCase()+r.path.substr(2):h=r.path,T.isWindows&&(h=h.replace(/\//g,"\\")),h}function i(r,o){const h=o?c:p;let y="",{scheme:A,authority:b,path:w,query:O,fragment:F}=r;if(A&&(y+=A,y+=":"),(b||A==="file")&&(y+=d,y+=d),b){let N=b.indexOf("@");if(N!==-1){const M=b.substr(0,N);b=b.substr(N+1),N=M.lastIndexOf(":"),N===-1?y+=h(M,!1,!1):(y+=h(M.substr(0,N),!1,!1),y+=":",y+=h(M.substr(N+1),!1,!0)),y+="@"}b=b.toLowerCase(),N=b.lastIndexOf(":"),N===-1?y+=h(b,!1,!0):(y+=h(b.substr(0,N),!1,!0),y+=b.substr(N))}if(w){if(w.length>=3&&w.charCodeAt(0)===R.CharCode.Slash&&w.charCodeAt(2)===R.CharCode.Colon){const N=w.charCodeAt(1);N>=R.CharCode.A&&N<=R.CharCode.Z&&(w=`/${String.fromCharCode(N+32)}:${w.substr(3)}`)}else if(w.length>=2&&w.charCodeAt(1)===R.CharCode.Colon){const N=w.charCodeAt(0);N>=R.CharCode.A&&N<=R.CharCode.Z&&(w=`${String.fromCharCode(N+32)}:${w.substr(2)}`)}y+=h(w,!0,!1)}return O&&(y+="?",y+=h(O,!1,!1)),F&&(y+="#",y+=o?F:p(F,!1,!1)),y}function n(r){try{return decodeURIComponent(r)}catch{return r.length>3?r.substr(0,3)+n(r.substr(3)):r}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function s(r){return r.match(t)?r.replace(t,o=>n(o)):r}}),define(he[147],fe([0,1,10]),function(ce,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isRemoteConsoleLog=a,e.parse=_,e.getFirstFrame=T,e.log=L;function a(E){const P=E;return P&&typeof P.type=="string"&&typeof P.severity=="string"}function _(E){const P=[];let S;try{const m=JSON.parse(E.arguments),d=m[m.length-1];d&&d.__$stack&&(m.pop(),S=d.__$stack),P.push(...m)}catch{P.push("Unable to log remote console arguments",E.arguments)}return{args:P,stack:S}}function T(E){if(typeof E!="string")return T(_(E).stack);const P=E;if(P){const S=k(P),m=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(S||"");if(m&&m.length===4)return{uri:R.URI.file(m[1]),line:Number(m[2]),column:Number(m[3])}}}function k(E){if(!E)return E;const P=E.indexOf(`
`);return P===-1?E:E.substring(0,P)}function L(E,P){const{args:S,stack:m}=_(E),d=typeof S[0]=="string"&&S.length===1;let l=k(m);l&&(l=`(${l.trim()})`);let g=[];if(typeof S[0]=="string"?l&&d?g=[`%c[${P}] %c${S[0]} %c${l}`,D("blue"),D(""),D("grey")]:g=[`%c[${P}] %c${S[0]}`,D("blue"),D(""),...S.slice(1)]:g=[`%c[${P}]%`,D("blue"),...S],l&&!d&&g.push(l),typeof console[E.severity]!="function")throw new Error("Unknown console method");console[E.severity].apply(console,g)}function D(E){return`color: ${E}`}}),define(he[68],fe([0,1,14,10,65]),function(ce,e,R,a,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.stringify=T,e.parse=k,e.revive=D;function T(E){return JSON.stringify(E,L)}function k(E){let P=JSON.parse(E);return P=D(P),P}function L(E,P){return P instanceof RegExp?{$mid:_.MarshalledId.Regexp,source:P.source,flags:P.flags}:P}function D(E,P=0){if(!E||P>200)return E;if(typeof E=="object"){switch(E.$mid){case _.MarshalledId.Uri:return a.URI.revive(E);case _.MarshalledId.Regexp:return new RegExp(E.source,E.flags);case _.MarshalledId.Date:return new Date(E.source)}if(E instanceof R.VSBuffer||E instanceof Uint8Array)return E;if(Array.isArray(E))for(let S=0;S<E.length;++S)E[S]=D(E[S],P+1);else for(const S in E)Object.hasOwnProperty.call(E,S)&&(E[S]=D(E[S],P+1))}return E}}),define(he[22],fe([0,1,8,5,26,10,13]),function(ce,e,R,a,_,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.VSCODE_AUTHORITY=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0,e.matchesScheme=D,e.matchesSomeScheme=E,e.getServerRootPath=S,R=De(R),a=De(a),k=De(k);var L;(function(l){l.inMemory="inmemory",l.vscode="vscode",l.internal="private",l.walkThrough="walkThrough",l.walkThroughSnippet="walkThroughSnippet",l.http="http",l.https="https",l.file="file",l.mailto="mailto",l.untitled="untitled",l.data="data",l.command="command",l.vscodeRemote="vscode-remote",l.vscodeRemoteResource="vscode-remote-resource",l.vscodeManagedRemoteResource="vscode-managed-remote-resource",l.vscodeUserData="vscode-userdata",l.vscodeCustomEditor="vscode-custom-editor",l.vscodeNotebookCell="vscode-notebook-cell",l.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",l.vscodeNotebookCellMetadataDiff="vscode-notebook-cell-metadata-diff",l.vscodeNotebookCellOutput="vscode-notebook-cell-output",l.vscodeNotebookCellOutputDiff="vscode-notebook-cell-output-diff",l.vscodeNotebookMetadata="vscode-notebook-metadata",l.vscodeInteractiveInput="vscode-interactive-input",l.vscodeSettings="vscode-settings",l.vscodeWorkspaceTrust="vscode-workspace-trust",l.vscodeTerminal="vscode-terminal",l.vscodeChatCodeBlock="vscode-chat-code-block",l.vscodeChatCodeCompareBlock="vscode-chat-code-compare-block",l.vscodeChatSesssion="vscode-chat-editor",l.webviewPanel="webview-panel",l.vscodeWebview="vscode-webview",l.extension="extension",l.vscodeFileResource="vscode-file",l.tmp="tmp",l.vsls="vsls",l.vscodeSourceControl="vscode-scm",l.commentsInput="comment",l.codeSetting="code-setting",l.outputChannel="output"})(L||(e.Schemas=L={}));function D(l,g){return T.URI.isUri(l)?(0,_.equalsIgnoreCase)(l.scheme,g):(0,_.startsWithIgnoreCase)(l,g+":")}function E(l,...g){return g.some(I=>D(l,I))}e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class P{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._serverRootPath="/"}setPreferredWebSchema(g){this._preferredWebSchema=g}setDelegate(g){this._delegate=g}setServerRootPath(g,I){this._serverRootPath=S(g,I)}getServerRootPath(){return this._serverRootPath}get _remoteResourcesPath(){return k.posix.join(this._serverRootPath,L.vscodeRemoteResource)}set(g,I,v){this._hosts[g]=I,this._ports[g]=v}setConnectionToken(g,I){this._connectionTokens[g]=I}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(g){if(this._delegate)try{return this._delegate(g)}catch(c){return R.onUnexpectedError(c),g}const I=g.authority;let v=this._hosts[I];v&&v.indexOf(":")!==-1&&v.indexOf("[")===-1&&(v=`[${v}]`);const f=this._ports[I],C=this._connectionTokens[I];let p=`path=${encodeURIComponent(g.path)}`;return typeof C=="string"&&(p+=`&${e.connectionTokenQueryName}=${encodeURIComponent(C)}`),T.URI.from({scheme:a.isWeb?this._preferredWebSchema:L.vscodeRemoteResource,authority:`${v}:${f}`,path:this._remoteResourcesPath,query:p})}}e.RemoteAuthorities=new P;function S(l,g){return k.posix.join(g??"/",`${l.quality??"oss"}-${l.commit??"dev"}`)}e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked",e.VSCODE_AUTHORITY="vscode-app";class m{static{this.FALLBACK_AUTHORITY=e.VSCODE_AUTHORITY}asBrowserUri(g){const I=this.toUri(g,ce);return this.uriToBrowserUri(I)}uriToBrowserUri(g){return g.scheme===L.vscodeRemote?e.RemoteAuthorities.rewrite(g):g.scheme===L.file&&(a.isNative||a.webWorkerOrigin===`${L.vscodeFileResource}://${m.FALLBACK_AUTHORITY}`)?g.with({scheme:L.vscodeFileResource,authority:g.authority||m.FALLBACK_AUTHORITY,query:null,fragment:null}):g}asFileUri(g){const I=this.toUri(g,ce);return this.uriToFileUri(I)}uriToFileUri(g){return g.scheme===L.vscodeFileResource?g.with({scheme:L.file,authority:g.authority!==m.FALLBACK_AUTHORITY?g.authority:null,query:null,fragment:null}):g}toUri(g,I){if(T.URI.isUri(g))return g;if(globalThis._VSCODE_FILE_ROOT){const v=globalThis._VSCODE_FILE_ROOT;if(/^\w[\w\d+.-]*:\/\//.test(v))return T.URI.joinPath(T.URI.parse(v,!0),g);const f=k.join(v,g);return T.URI.file(f)}return T.URI.parse(I.toUrl(g))}}e.FileAccess=new m;var d;(function(l){const g=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);l.CoopAndCoep=Object.freeze(g.get("3"));const I="vscode-coi";function v(C){let p;typeof C=="string"?p=new URL(C).searchParams:C instanceof URL?p=C.searchParams:T.URI.isUri(C)&&(p=new URL(C.toString(!0)).searchParams);const c=p?.get(I);if(c)return g.get(c)}l.getHeadersFromQuery=v;function f(C,p,c){if(!globalThis.crossOriginIsolated)return;const u=p&&c?"3":c?"2":"1";C instanceof URLSearchParams?C.set(I,u):C[I]=u}l.addSearchParam=f})(d||(e.COI=d={}))}),define(he[69],fe([0,1,130,22,5,12,10]),function(ce,e,R,a,_,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.importAMDNodeModule=P,e.resolveAmdNodeModulePath=S,_=De(_);class L{constructor(d,l,g){this.id=d,this.dependencies=l,this.callback=g}}class D{static{this.INSTANCE=new D}constructor(){this._isWebWorker=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this._isRenderer=typeof document=="object",this._defineCalls=[],this._initialized=!1}_initialize(){this._initialized||(this._initialized=!0,globalThis.define=(d,l,g)=>{typeof d!="string"&&(g=l,l=d,d=null),(typeof l!="object"||!Array.isArray(l))&&(g=l,l=null),this._defineCalls.push(new L(d,l,g))},globalThis.define.amd=!0,this._isRenderer?this._amdPolicy=globalThis._VSCODE_WEB_PACKAGE_TTP??window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(d){if(d.startsWith(window.location.origin)||d.startsWith(`${a.Schemas.vscodeFileResource}://${a.VSCODE_AUTHORITY}`))return d;throw new Error(`[trusted_script_src] Invalid script url: ${d}`)}}):this._isWebWorker&&(this._amdPolicy=globalThis._VSCODE_WEB_PACKAGE_TTP??globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(d){return d}})))}async load(d){this._initialize();const l=await(this._isWebWorker?this._workerLoadScript(d):this._isRenderer?this._rendererLoadScript(d):this._nodeJSLoadScript(d));if(!l){console.warn(`Did not receive a define call from script ${d}`);return}const g={},I=[],v=[];if(Array.isArray(l.dependencies))for(const f of l.dependencies)f==="exports"?I.push(g):v.push(f);if(v.length>0)throw new Error(`Cannot resolve dependencies for script ${d}. The dependencies are: ${v.join(", ")}`);return typeof l.callback=="function"?l.callback(...I)??g:l.callback}_rendererLoadScript(d){return new Promise((l,g)=>{const I=document.createElement("script");I.setAttribute("async","async"),I.setAttribute("type","text/javascript");const v=()=>{I.removeEventListener("load",f),I.removeEventListener("error",C)},f=p=>{v(),l(this._defineCalls.pop())},C=p=>{v(),g(p)};I.addEventListener("load",f),I.addEventListener("error",C),this._amdPolicy&&(d=this._amdPolicy.createScriptURL(d)),I.setAttribute("src",d),window.document.getElementsByTagName("head")[0].appendChild(I)})}async _workerLoadScript(d){return this._amdPolicy&&(d=this._amdPolicy.createScriptURL(d)),R.isESM?await new Promise((l,g)=>{ce([d],l,g)}).then(De):importScripts(d),this._defineCalls.pop()}async _nodeJSLoadScript(d){try{const l=globalThis._VSCODE_NODE_MODULES.fs,g=globalThis._VSCODE_NODE_MODULES.vm,I=globalThis._VSCODE_NODE_MODULES.module,v=k.URI.parse(d).fsPath,f=l.readFileSync(v).toString(),C=I.wrap(f.replace(/^#!.*/,""));return new g.Script(C).runInThisContext().apply(),this._defineCalls.pop()}catch(l){throw l}}}const E=new Map;async function P(m,d,l){if(R.isESM){l===void 0&&(l=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit);const g=d?`${m}/${d}`:m;if(E.has(g))return E.get(g);let I;if(/^\w[\w\d+.-]*:\/\//.test(g))I=g;else{const p=`${R.canASAR&&l&&!_.isWeb?a.nodeModulesAsarPath:a.nodeModulesPath}/${g}`;I=a.FileAccess.asBrowserUri(p).toString(!0)}const v=D.INSTANCE.load(I);return E.set(g,v),v}else return await new Promise((g,I)=>{ce([m],g,I)}).then(De)}function S(m,d){(0,T.assertType)(R.isESM);const g=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit,I=R.canASAR&&g&&!_.isWeb,v=`${m}/${d}`,C=`${I?a.nodeModulesAsarPath:a.nodeModulesPath}/${v}`;return a.FileAccess.asBrowserUri(C).toString(!0)}}),define(he[20],fe([0,1,39,42,22,13,5,26,10]),function(ce,e,R,a,_,T,k,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=void 0,e.originalFSPath=E,e.distinctParents=S,e.toLocalResource=d,a=De(a),T=De(T);function E(l){return(0,D.uriToFsPath)(l,!0)}class P{constructor(g){this._ignorePathCasing=g}compare(g,I,v=!1){return g===I?0:(0,L.compare)(this.getComparisonKey(g,v),this.getComparisonKey(I,v))}isEqual(g,I,v=!1){return g===I?!0:!g||!I?!1:this.getComparisonKey(g,v)===this.getComparisonKey(I,v)}getComparisonKey(g,I=!1){return g.with({path:this._ignorePathCasing(g)?g.path.toLowerCase():void 0,fragment:I?null:void 0}).toString()}ignorePathCasing(g){return this._ignorePathCasing(g)}isEqualOrParent(g,I,v=!1){if(g.scheme===I.scheme){if(g.scheme===_.Schemas.file)return a.isEqualOrParent(E(g),E(I),this._ignorePathCasing(g))&&g.query===I.query&&(v||g.fragment===I.fragment);if((0,e.isEqualAuthority)(g.authority,I.authority))return a.isEqualOrParent(g.path,I.path,this._ignorePathCasing(g),"/")&&g.query===I.query&&(v||g.fragment===I.fragment)}return!1}joinPath(g,...I){return D.URI.joinPath(g,...I)}basenameOrAuthority(g){return(0,e.basename)(g)||g.authority}basename(g){return T.posix.basename(g.path)}extname(g){return T.posix.extname(g.path)}dirname(g){if(g.path.length===0)return g;let I;return g.scheme===_.Schemas.file?I=D.URI.file(T.dirname(E(g))).path:(I=T.posix.dirname(g.path),g.authority&&I.length&&I.charCodeAt(0)!==R.CharCode.Slash&&(console.error(`dirname("${g.toString})) resulted in a relative path`),I="/")),g.with({path:I})}normalizePath(g){if(!g.path.length)return g;let I;return g.scheme===_.Schemas.file?I=D.URI.file(T.normalize(E(g))).path:I=T.posix.normalize(g.path),g.with({path:I})}relativePath(g,I){if(g.scheme!==I.scheme||!(0,e.isEqualAuthority)(g.authority,I.authority))return;if(g.scheme===_.Schemas.file){const C=T.relative(E(g),E(I));return k.isWindows?a.toSlashes(C):C}let v=g.path||"/";const f=I.path||"/";if(this._ignorePathCasing(g)){let C=0;for(const p=Math.min(v.length,f.length);C<p&&!(v.charCodeAt(C)!==f.charCodeAt(C)&&v.charAt(C).toLowerCase()!==f.charAt(C).toLowerCase());C++);v=f.substr(0,C)+v.substr(C)}return T.posix.relative(v,f)}resolvePath(g,I){if(g.scheme===_.Schemas.file){const v=D.URI.file(T.resolve(E(g),I));return g.with({authority:v.authority,path:v.path})}return I=a.toPosixPath(I),g.with({path:T.posix.resolve(g.path,I)})}isAbsolutePath(g){return!!g.path&&g.path[0]==="/"}isEqualAuthority(g,I){return g===I||g!==void 0&&I!==void 0&&(0,L.equalsIgnoreCase)(g,I)}hasTrailingPathSeparator(g,I=T.sep){if(g.scheme===_.Schemas.file){const v=E(g);return v.length>a.getRoot(v).length&&v[v.length-1]===I}else{const v=g.path;return v.length>1&&v.charCodeAt(v.length-1)===R.CharCode.Slash&&!/^[a-zA-Z]:(\/$|\\$)/.test(g.fsPath)}}removeTrailingPathSeparator(g,I=T.sep){return(0,e.hasTrailingPathSeparator)(g,I)?g.with({path:g.path.substr(0,g.path.length-1)}):g}addTrailingPathSeparator(g,I=T.sep){let v=!1;if(g.scheme===_.Schemas.file){const f=E(g);v=f!==void 0&&f.length===a.getRoot(f).length&&f[f.length-1]===I}else{I="/";const f=g.path;v=f.length===1&&f.charCodeAt(f.length-1)===R.CharCode.Slash}return!v&&!(0,e.hasTrailingPathSeparator)(g,I)?g.with({path:g.path+"/"}):g}}e.ExtUri=P,e.extUri=new P(()=>!1),e.extUriBiasedIgnorePathCase=new P(l=>l.scheme===_.Schemas.file?!k.isLinux:!0),e.extUriIgnorePathCase=new P(l=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function S(l,g){const I=[];for(let v=0;v<l.length;v++){const f=g(l[v]);l.some((C,p)=>p===v?!1:(0,e.isEqualOrParent)(f,g(C)))||I.push(l[v])}return I}var m;(function(l){l.META_DATA_LABEL="label",l.META_DATA_DESCRIPTION="description",l.META_DATA_SIZE="size",l.META_DATA_MIME="mime";function g(I){const v=new Map;I.path.substring(I.path.indexOf(";")+1,I.path.lastIndexOf(";")).split(";").forEach(p=>{const[c,u]=p.split(":");c&&u&&v.set(c,u)});const C=I.path.substring(0,I.path.indexOf(";"));return C&&v.set(l.META_DATA_MIME,C),v}l.parseMetaData=g})(m||(e.DataUri=m={}));function d(l,g,I){if(g){let v=l.path;return v&&v[0]!==T.posix.sep&&(v=T.posix.sep+v),l.with({scheme:I,authority:g,path:v})}return l.with({scheme:I})}}),define(he[6],fe([0,1,25,8,3,2,20,5,137,53]),function(ce,e,R,a,_,T,k,L,D,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AsyncIterableSource=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.LazyStatefulPromise=e.StatefulPromise=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.GlobalIdleValue=e.AbstractIdleValue=e._runWhenIdle=e.runWhenGlobalIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.LimitedQueue=e.Queue=e.Limiter=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=void 0,e.isThenable=P,e.createCancelablePromise=S,e.raceCancellation=m,e.raceCancellationError=d,e.raceCancellablePromises=l,e.raceTimeout=g,e.asPromise=I,e.promiseWithResolvers=v,e.timeout=r,e.disposableTimeout=o,e.sequence=h,e.first=y,e.firstParallel=A,e.retry=B,e.createCancelableAsyncIterable=Q;function P(x){return!!x&&typeof x.then=="function"}function S(x){const $=new R.CancellationTokenSource,ie=x($.token),ae=new Promise((ue,Se)=>{const Ee=$.token.onCancellationRequested(()=>{Ee.dispose(),Se(new a.CancellationError)});Promise.resolve(ie).then(Re=>{Ee.dispose(),$.dispose(),ue(Re)},Re=>{Ee.dispose(),$.dispose(),Se(Re)})});return new class{cancel(){$.cancel(),$.dispose()}then(ue,Se){return ae.then(ue,Se)}catch(ue){return this.then(void 0,ue)}finally(ue){return ae.finally(ue)}}}function m(x,$,ie){return new Promise((ae,ue)=>{const Se=$.onCancellationRequested(()=>{Se.dispose(),ae(ie)});x.then(ae,ue).finally(()=>Se.dispose())})}function d(x,$){return new Promise((ie,ae)=>{const ue=$.onCancellationRequested(()=>{ue.dispose(),ae(new a.CancellationError)});x.then(ie,ae).finally(()=>ue.dispose())})}async function l(x){let $=-1;const ie=x.map((ae,ue)=>ae.then(Se=>($=ue,Se)));try{return await Promise.race(ie)}finally{x.forEach((ae,ue)=>{ue!==$&&ae.cancel()})}}function g(x,$,ie){let ae;const ue=setTimeout(()=>{ae?.(void 0),ie?.()},$);return Promise.race([x.finally(()=>clearTimeout(ue)),new Promise(Se=>ae=Se)])}function I(x){return new Promise(($,ie)=>{const ae=x();P(ae)?ae.then($,ie):$(ae)})}function v(){let x,$;return{promise:new Promise((ae,ue)=>{x=ae,$=ue}),resolve:x,reject:$}}class f{constructor(){this.isDisposed=!1,this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue($){if(this.isDisposed)return Promise.reject(new Error("Throttler is disposed"));if(this.activePromise){if(this.queuedPromiseFactory=$,!this.queuedPromise){const ie=()=>{if(this.queuedPromise=null,this.isDisposed)return;const ae=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,ae};this.queuedPromise=new Promise(ae=>{this.activePromise.then(ie,ie).then(ae)})}return new Promise((ie,ae)=>{this.queuedPromise.then(ie,ae)})}return this.activePromise=$(),new Promise((ie,ae)=>{this.activePromise.then(ue=>{this.activePromise=null,ie(ue)},ue=>{this.activePromise=null,ae(ue)})})}dispose(){this.isDisposed=!0}}e.Throttler=f;class C{constructor(){this.current=Promise.resolve(null)}queue($){return this.current=this.current.then(()=>$(),()=>$())}}e.Sequencer=C;class p{constructor(){this.promiseMap=new Map}queue($,ie){const ue=(this.promiseMap.get($)??Promise.resolve()).catch(()=>{}).then(ie).finally(()=>{this.promiseMap.get($)===ue&&this.promiseMap.delete($)});return this.promiseMap.set($,ue),ue}}e.SequencerByKey=p;const c=(x,$)=>{let ie=!0;const ae=setTimeout(()=>{ie=!1,$()},x);return{isTriggered:()=>ie,dispose:()=>{clearTimeout(ae),ie=!1}}},u=x=>{let $=!0;return queueMicrotask(()=>{$&&($=!1,x())}),{isTriggered:()=>$,dispose:()=>{$=!1}}};class i{constructor($){this.defaultDelay=$,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger($,ie=this.defaultDelay){this.task=$,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((ue,Se)=>{this.doResolve=ue,this.doReject=Se}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const ue=this.task;return this.task=null,ue()}}));const ae=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=ie===D.MicrotaskDelay?u(ae):c(ie,ae),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new a.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=i;class n{constructor($){this.delayer=new i($),this.throttler=new f}trigger($,ie){return this.delayer.trigger(()=>this.throttler.queue($),ie)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose(),this.throttler.dispose()}}e.ThrottledDelayer=n;class t{constructor(){this._isOpen=!1,this._promise=new Promise(($,ie)=>{this._completePromise=$})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=t;class s extends t{constructor($){super(),this._timeout=setTimeout(()=>this.open(),$)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=s;function r(x,$){return $?new Promise((ie,ae)=>{const ue=setTimeout(()=>{Se.dispose(),ie()},x),Se=$.onCancellationRequested(()=>{clearTimeout(ue),Se.dispose(),ae(new a.CancellationError)})}):S(ie=>r(x,ie))}function o(x,$=0,ie){const ae=setTimeout(()=>{x(),ie&&ue.dispose()},$),ue=(0,T.toDisposable)(()=>{clearTimeout(ae),ie?.deleteAndLeak(ue)});return ie?.add(ue),ue}function h(x){const $=[];let ie=0;const ae=x.length;function ue(){return ie<ae?x[ie++]():null}function Se(Ee){Ee!=null&&$.push(Ee);const Re=ue();return Re?Re.then(Se):Promise.resolve($)}return Promise.resolve(null).then(Se)}function y(x,$=ae=>!!ae,ie=null){let ae=0;const ue=x.length,Se=()=>{if(ae>=ue)return Promise.resolve(ie);const Ee=x[ae++];return Promise.resolve(Ee()).then(Te=>$(Te)?Promise.resolve(Te):Se())};return Se()}function A(x,$=ae=>!!ae,ie=null){if(x.length===0)return Promise.resolve(ie);let ae=x.length;const ue=()=>{ae=-1;for(const Se of x)Se.cancel?.()};return new Promise((Se,Ee)=>{for(const Re of x)Re.then(Te=>{--ae>=0&&$(Te)?(ue(),Se(Te)):ae===0&&Se(ie)}).catch(Te=>{--ae>=0&&(ue(),Ee(Te))})})}class b{constructor($){this._size=0,this._isDisposed=!1,this.maxDegreeOfParalellism=$,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new _.Emitter}whenIdle(){return this.size>0?_.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this._onDrained.event}get size(){return this._size}queue($){if(this._isDisposed)throw new Error("Object has been disposed");return this._size++,new Promise((ie,ae)=>{this.outstandingPromises.push({factory:$,c:ie,e:ae}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const $=this.outstandingPromises.shift();this.runningPromises++;const ie=$.factory();ie.then($.c,$.e),ie.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._isDisposed||(this.runningPromises--,--this._size===0&&this._onDrained.fire(),this.outstandingPromises.length>0&&this.consume())}clear(){if(this._isDisposed)throw new Error("Object has been disposed");this.outstandingPromises.length=0,this._size=this.runningPromises}dispose(){this._isDisposed=!0,this.outstandingPromises.length=0,this._size=0,this._onDrained.dispose()}}e.Limiter=b;class w extends b{constructor(){super(1)}}e.Queue=w;class O{constructor(){this.sequentializer=new Z,this.tasks=0}queue($){return this.sequentializer.isRunning()?this.sequentializer.queue(()=>this.sequentializer.run(this.tasks++,$())):this.sequentializer.run(this.tasks++,$())}}e.LimitedQueue=O;class F{constructor(){this.queues=new Map,this.drainers=new Set,this.drainListeners=void 0,this.drainListenerCount=0}async whenDrained(){if(this.isDrained())return;const $=new ee;return this.drainers.add($),$.p}isDrained(){for(const[,$]of this.queues)if($.size>0)return!1;return!0}queueSize($,ie=k.extUri){const ae=ie.getComparisonKey($);return this.queues.get(ae)?.size??0}queueFor($,ie,ae=k.extUri){const ue=ae.getComparisonKey($);let Se=this.queues.get(ue);if(!Se){Se=new w;const Ee=this.drainListenerCount++,Re=_.Event.once(Se.onDrained)(()=>{Se?.dispose(),this.queues.delete(ue),this.onDidQueueDrain(),this.drainListeners?.deleteAndDispose(Ee),this.drainListeners?.size===0&&(this.drainListeners.dispose(),this.drainListeners=void 0)});this.drainListeners||(this.drainListeners=new T.DisposableMap),this.drainListeners.set(Ee,Re),this.queues.set(ue,Se)}return Se.queue(ie)}onDidQueueDrain(){this.isDrained()&&this.releaseDrainers()}releaseDrainers(){for(const $ of this.drainers)$.complete();this.drainers.clear()}dispose(){for(const[,$]of this.queues)$.dispose();this.queues.clear(),this.releaseDrainers(),this.drainListeners?.dispose()}}e.ResourceQueue=F;class N{constructor($,ie){this._isDisposed=!1,this._token=-1,typeof $=="function"&&typeof ie=="number"&&this.setIfNotSet($,ie)}dispose(){this.cancel(),this._isDisposed=!0}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet($,ie){if(this._isDisposed)throw new a.BugIndicatingError("Calling 'cancelAndSet' on a disposed TimeoutTimer");this.cancel(),this._token=setTimeout(()=>{this._token=-1,$()},ie)}setIfNotSet($,ie){if(this._isDisposed)throw new a.BugIndicatingError("Calling 'setIfNotSet' on a disposed TimeoutTimer");this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,$()},ie))}}e.TimeoutTimer=N;class M{constructor(){this.disposable=void 0,this.isDisposed=!1}cancel(){this.disposable?.dispose(),this.disposable=void 0}cancelAndSet($,ie,ae=globalThis){if(this.isDisposed)throw new a.BugIndicatingError("Calling 'cancelAndSet' on a disposed IntervalTimer");this.cancel();const ue=ae.setInterval(()=>{$()},ie);this.disposable=(0,T.toDisposable)(()=>{ae.clearInterval(ue),this.disposable=void 0})}dispose(){this.cancel(),this.isDisposed=!0}}e.IntervalTimer=M;class V{constructor($,ie){this.timeoutToken=-1,this.runner=$,this.timeout=ie,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule($=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,$)}get delay(){return this.timeout}set delay($){this.timeout=$}isScheduled(){return this.timeoutToken!==-1}flush(){this.isScheduled()&&(this.cancel(),this.doRun())}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}e.RunOnceScheduler=V;class z{constructor($,ie){ie%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${ie}ms is not a multiple of 1000ms.`),this.runner=$,this.timeout=ie,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule($=this.timeout){$%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${$}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil($/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}e.ProcessTimeRunOnceScheduler=z;class J extends V{constructor($,ie){super($,ie),this.units=[]}work($){this.units.push($),this.isScheduled()||this.schedule()}doRun(){const $=this.units;this.units=[],this.runner?.($)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=J;class j extends T.Disposable{constructor($,ie){super(),this.options=$,this.handler=ie,this.pendingWork=[],this.throttler=this._register(new T.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work($){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+$.length>this.options.maxBufferedWork)return!1}else if(this.pending+$.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}for(const ie of $)this.pendingWork.push(ie);return this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new V(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=j,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e._runWhenIdle=(x,$)=>{(0,L.setTimeout0)(()=>{if(ie)return;const ae=Date.now()+15;$(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,ae-Date.now())}}))});let ie=!1;return{dispose(){ie||(ie=!0)}}}:e._runWhenIdle=(x,$,ie)=>{const ae=x.requestIdleCallback($,typeof ie=="number"?{timeout:ie}:void 0);let ue=!1;return{dispose(){ue||(ue=!0,x.cancelIdleCallback(ae))}}},e.runWhenGlobalIdle=x=>(0,e._runWhenIdle)(globalThis,x)}();class te{constructor($,ie){this._didRun=!1,this._executor=()=>{try{this._value=ie()}catch(ae){this._error=ae}finally{this._didRun=!0}},this._handle=(0,e._runWhenIdle)($,()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.AbstractIdleValue=te;class q extends te{constructor($){super(globalThis,$)}}e.GlobalIdleValue=q;async function B(x,$,ie){let ae;for(let ue=0;ue<ie;ue++)try{return await x()}catch(Se){ae=Se,await r($)}throw ae}class Z{isRunning($){return typeof $=="number"?this._running?.taskId===$:!!this._running}get running(){return this._running?.promise}cancelRunning(){this._running?.cancel()}run($,ie,ae){return this._running={taskId:$,cancel:()=>ae?.(),promise:ie},ie.then(()=>this.doneRunning($),()=>this.doneRunning($)),ie}doneRunning($){this._running&&$===this._running.taskId&&(this._running=void 0,this.runQueued())}runQueued(){if(this._queued){const $=this._queued;this._queued=void 0,$.run().then($.promiseResolve,$.promiseReject)}}queue($){if(this._queued)this._queued.run=$;else{const{promise:ie,resolve:ae,reject:ue}=v();this._queued={run:$,promise:ie,promiseResolve:ae,promiseReject:ue}}return this._queued.promise}hasQueued(){return!!this._queued}async join(){return this._queued?.promise??this._running?.promise}}e.TaskSequentializer=Z;class ne{constructor($,ie=()=>Date.now()){this.interval=$,this.nowFn=ie,this.lastIncrementTime=0,this.value=0}increment(){const $=this.nowFn();return $-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=$,this.value=0),this.value++,this.value}}e.IntervalCounter=ne;var le;(function(x){x[x.Resolved=0]="Resolved",x[x.Rejected=1]="Rejected"})(le||(le={}));class ee{get isRejected(){return this.outcome?.outcome===le.Rejected}get isResolved(){return this.outcome?.outcome===le.Resolved}get isSettled(){return!!this.outcome}get value(){return this.outcome?.outcome===le.Resolved?this.outcome?.value:void 0}constructor(){this.p=new Promise(($,ie)=>{this.completeCallback=$,this.errorCallback=ie})}complete($){return new Promise(ie=>{this.completeCallback($),this.outcome={outcome:le.Resolved,value:$},ie()})}error($){return new Promise(ie=>{this.errorCallback($),this.outcome={outcome:le.Rejected,value:$},ie()})}cancel(){return this.error(new a.CancellationError)}}e.DeferredPromise=ee;var K;(function(x){async function $(ae){let ue;const Se=await Promise.all(ae.map(Ee=>Ee.then(Re=>Re,Re=>{ue||(ue=Re)})));if(typeof ue<"u")throw ue;return Se}x.settled=$;function ie(ae){return new Promise(async(ue,Se)=>{try{await ae(ue,Se)}catch(Ee){Se(Ee)}})}x.withAsyncBody=ie})(K||(e.Promises=K={}));class H{get value(){return this._value}get error(){return this._error}get isResolved(){return this._isResolved}constructor($){this._value=void 0,this._error=void 0,this._isResolved=!1,this.promise=$.then(ie=>(this._value=ie,this._isResolved=!0,ie),ie=>{throw this._error=ie,this._isResolved=!0,ie})}requireValue(){if(!this._isResolved)throw new a.BugIndicatingError("Promise is not resolved yet");if(this._error)throw this._error;return this._value}}e.StatefulPromise=H;class W{constructor($){this._compute=$,this._promise=new E.Lazy(()=>new H(this._compute()))}requireValue(){return this._promise.value.requireValue()}getPromise(){return this._promise.value.promise}get currentValue(){return this._promise.rawValue?.value}}e.LazyStatefulPromise=W;var U;(function(x){x[x.Initial=0]="Initial",x[x.DoneOK=1]="DoneOK",x[x.DoneError=2]="DoneError"})(U||(U={}));class G{static fromArray($){return new G(ie=>{ie.emitMany($)})}static fromPromise($){return new G(async ie=>{ie.emitMany(await $)})}static fromPromises($){return new G(async ie=>{await Promise.all($.map(async ae=>ie.emitOne(await ae)))})}static merge($){return new G(async ie=>{await Promise.all($.map(async ae=>{for await(const ue of ae)ie.emitOne(ue)}))})}static{this.EMPTY=G.fromArray([])}constructor($,ie){this._state=U.Initial,this._results=[],this._error=null,this._onReturn=ie,this._onStateChanged=new _.Emitter,queueMicrotask(async()=>{const ae={emitOne:ue=>this.emitOne(ue),emitMany:ue=>this.emitMany(ue),reject:ue=>this.reject(ue)};try{await Promise.resolve($(ae)),this.resolve()}catch(ue){this.reject(ue)}finally{ae.emitOne=void 0,ae.emitMany=void 0,ae.reject=void 0}})}[Symbol.asyncIterator](){let $=0;return{next:async()=>{do{if(this._state===U.DoneError)throw this._error;if($<this._results.length)return{done:!1,value:this._results[$++]};if(this._state===U.DoneOK)return{done:!0,value:void 0};await _.Event.toPromise(this._onStateChanged.event)}while(!0)},return:async()=>(this._onReturn?.(),{done:!0,value:void 0})}}static map($,ie){return new G(async ae=>{for await(const ue of $)ae.emitOne(ie(ue))})}map($){return G.map(this,$)}static filter($,ie){return new G(async ae=>{for await(const ue of $)ie(ue)&&ae.emitOne(ue)})}filter($){return G.filter(this,$)}static coalesce($){return G.filter($,ie=>!!ie)}coalesce(){return G.coalesce(this)}static async toPromise($){const ie=[];for await(const ae of $)ie.push(ae);return ie}toPromise(){return G.toPromise(this)}emitOne($){this._state===U.Initial&&(this._results.push($),this._onStateChanged.fire())}emitMany($){this._state===U.Initial&&(this._results=this._results.concat($),this._onStateChanged.fire())}resolve(){this._state===U.Initial&&(this._state=U.DoneOK,this._onStateChanged.fire())}reject($){this._state===U.Initial&&(this._state=U.DoneError,this._error=$,this._onStateChanged.fire())}}e.AsyncIterableObject=G;class oe extends G{constructor($,ie){super(ie),this._source=$}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=oe;function Q(x){const $=new R.CancellationTokenSource,ie=x($.token);return new oe($,async ae=>{const ue=$.token.onCancellationRequested(()=>{ue.dispose(),$.dispose(),ae.reject(new a.CancellationError)});try{for await(const Se of ie){if($.token.isCancellationRequested)return;ae.emitOne(Se)}ue.dispose(),$.dispose()}catch(Se){ue.dispose(),$.dispose(),ae.reject(Se)}})}class X{constructor($){this._deferred=new ee,this._asyncIterable=new G(ue=>{if(ie){ue.reject(ie);return}return ae&&ue.emitMany(ae),this._errorFn=Se=>ue.reject(Se),this._emitFn=Se=>ue.emitOne(Se),this._deferred.p},$);let ie,ae;this._emitFn=ue=>{ae||(ae=[]),ae.push(ue)},this._errorFn=ue=>{ie||(ie=ue)}}get asyncIterable(){return this._asyncIterable}resolve(){this._deferred.complete()}reject($){this._errorFn($),this._deferred.complete()}emitOne($){this._emitFn($)}}e.AsyncIterableSource=X}),define(he[95],fe([0,1,17,6,39,42,31,13,5,26]),function(ce,e,R,a,_,T,k,L,D,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.GLOB_SPLIT=e.GLOBSTAR=void 0,e.getEmptyExpression=P,e.splitGlobAware=g,e.match=O,e.parse=F,e.isRelativePattern=N,e.getBasenameTerms=M,e.getPathTerms=V,e.patternsEquals=te;function P(){return Object.create(null)}e.GLOBSTAR="**",e.GLOB_SPLIT="/";const S="[/\\\\]",m="[^/\\\\]",d=/\//g;function l(q,B){switch(q){case 0:return"";case 1:return`${m}*?`;default:return`(?:${S}|${m}+${S}${B?`|${S}${m}+`:""})*?`}}function g(q,B){if(!q)return[];const Z=[];let ne=!1,le=!1,ee="";for(const K of q){switch(K){case B:if(!ne&&!le){Z.push(ee),ee="";continue}break;case"{":ne=!0;break;case"}":ne=!1;break;case"[":le=!0;break;case"]":le=!1;break}ee+=K}return ee&&Z.push(ee),Z}function I(q){if(!q)return"";let B="";const Z=g(q,e.GLOB_SPLIT);if(Z.every(ne=>ne===e.GLOBSTAR))B=".*";else{let ne=!1;Z.forEach((le,ee)=>{if(le===e.GLOBSTAR){if(ne)return;B+=l(2,ee===Z.length-1)}else{let K=!1,H="",W=!1,U="";for(const G of le){if(G!=="}"&&K){H+=G;continue}if(W&&(G!=="]"||!U)){let oe;G==="-"?oe=G:(G==="^"||G==="!")&&!U?oe="^":G===e.GLOB_SPLIT?oe="":oe=(0,E.escapeRegExpCharacters)(G),U+=oe;continue}switch(G){case"{":K=!0;continue;case"[":W=!0;continue;case"}":{const Q=`(?:${g(H,",").map(X=>I(X)).join("|")})`;B+=Q,K=!1,H="";break}case"]":{B+="["+U+"]",W=!1,U="";break}case"?":B+=m;continue;case"*":B+=l(1);continue;default:B+=(0,E.escapeRegExpCharacters)(G)}}ee<Z.length-1&&(Z[ee+1]!==e.GLOBSTAR||ee+2<Z.length)&&(B+=S)}ne=le===e.GLOBSTAR})}return B}const v=/^\*\*\/\*\.[\w\.-]+$/,f=/^\*\*\/([\w\.-]+)\/?$/,C=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,p=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,c=/^\*\*((\/[\w\.-]+)+)\/?$/,u=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,i=new k.LRUCache(1e4),n=function(){return!1},t=function(){return null};function s(q,B){if(!q)return t;let Z;typeof q!="string"?Z=q.pattern:Z=q,Z=Z.trim();const ne=`${Z}_${!!B.trimForExclusions}`;let le=i.get(ne);if(le)return r(le,q);let ee;return v.test(Z)?le=h(Z.substr(4),Z):(ee=f.exec(o(Z,B)))?le=y(ee[1],Z):(B.trimForExclusions?p:C).test(Z)?le=A(Z,B):(ee=c.exec(o(Z,B)))?le=b(ee[1].substr(1),Z,!0):(ee=u.exec(o(Z,B)))?le=b(ee[1],Z,!1):le=w(Z),i.set(ne,le),r(le,q)}function r(q,B){if(typeof B=="string")return q;const Z=function(ne,le){return(0,T.isEqualOrParent)(ne,B.base,!D.isLinux)?q((0,E.ltrim)(ne.substr(B.base.length),L.sep),le):null};return Z.allBasenames=q.allBasenames,Z.allPaths=q.allPaths,Z.basenames=q.basenames,Z.patterns=q.patterns,Z}function o(q,B){return B.trimForExclusions&&q.endsWith("/**")?q.substr(0,q.length-2):q}function h(q,B){return function(Z,ne){return typeof Z=="string"&&Z.endsWith(q)?B:null}}function y(q,B){const Z=`/${q}`,ne=`\\${q}`,le=function(K,H){return typeof K!="string"?null:H?H===q?B:null:K===q||K.endsWith(Z)||K.endsWith(ne)?B:null},ee=[q];return le.basenames=ee,le.patterns=[B],le.allBasenames=ee,le}function A(q,B){const Z=j(q.slice(1,-1).split(",").map(H=>s(H,B)).filter(H=>H!==t),q),ne=Z.length;if(!ne)return t;if(ne===1)return Z[0];const le=function(H,W){for(let U=0,G=Z.length;U<G;U++)if(Z[U](H,W))return q;return null},ee=Z.find(H=>!!H.allBasenames);ee&&(le.allBasenames=ee.allBasenames);const K=Z.reduce((H,W)=>W.allPaths?H.concat(W.allPaths):H,[]);return K.length&&(le.allPaths=K),le}function b(q,B,Z){const ne=L.sep===L.posix.sep,le=ne?q:q.replace(d,L.sep),ee=L.sep+le,K=L.posix.sep+q;let H;return Z?H=function(W,U){return typeof W=="string"&&(W===le||W.endsWith(ee)||!ne&&(W===q||W.endsWith(K)))?B:null}:H=function(W,U){return typeof W=="string"&&(W===le||!ne&&W===q)?B:null},H.allPaths=[(Z?"*/":"./")+q],H}function w(q){try{const B=new RegExp(`^${I(q)}$`);return function(Z){return B.lastIndex=0,typeof Z=="string"&&B.test(Z)?q:null}}catch{return t}}function O(q,B,Z){return!q||typeof B!="string"?!1:F(q)(B,void 0,Z)}function F(q,B={}){if(!q)return n;if(typeof q=="string"||N(q)){const Z=s(q,B);if(Z===t)return n;const ne=function(le,ee){return!!Z(le,ee)};return Z.allBasenames&&(ne.allBasenames=Z.allBasenames),Z.allPaths&&(ne.allPaths=Z.allPaths),ne}return z(q,B)}function N(q){const B=q;return B?typeof B.base=="string"&&typeof B.pattern=="string":!1}function M(q){return q.allBasenames||[]}function V(q){return q.allPaths||[]}function z(q,B){const Z=j(Object.getOwnPropertyNames(q).map(H=>J(H,q[H],B)).filter(H=>H!==t)),ne=Z.length;if(!ne)return t;if(!Z.some(H=>!!H.requiresSiblings)){if(ne===1)return Z[0];const H=function(G,oe){let Q;for(let X=0,x=Z.length;X<x;X++){const $=Z[X](G,oe);if(typeof $=="string")return $;(0,a.isThenable)($)&&(Q||(Q=[]),Q.push($))}return Q?(async()=>{for(const X of Q){const x=await X;if(typeof x=="string")return x}return null})():null},W=Z.find(G=>!!G.allBasenames);W&&(H.allBasenames=W.allBasenames);const U=Z.reduce((G,oe)=>oe.allPaths?G.concat(oe.allPaths):G,[]);return U.length&&(H.allPaths=U),H}const le=function(H,W,U){let G,oe;for(let Q=0,X=Z.length;Q<X;Q++){const x=Z[Q];x.requiresSiblings&&U&&(W||(W=(0,L.basename)(H)),G||(G=W.substr(0,W.length-(0,L.extname)(H).length)));const $=x(H,W,G,U);if(typeof $=="string")return $;(0,a.isThenable)($)&&(oe||(oe=[]),oe.push($))}return oe?(async()=>{for(const Q of oe){const X=await Q;if(typeof X=="string")return X}return null})():null},ee=Z.find(H=>!!H.allBasenames);ee&&(le.allBasenames=ee.allBasenames);const K=Z.reduce((H,W)=>W.allPaths?H.concat(W.allPaths):H,[]);return K.length&&(le.allPaths=K),le}function J(q,B,Z){if(B===!1)return t;const ne=s(q,Z);if(ne===t)return t;if(typeof B=="boolean")return ne;if(B){const le=B.when;if(typeof le=="string"){const ee=(K,H,W,U)=>{if(!U||!ne(K,H))return null;const G=le.replace("$(basename)",()=>W),oe=U(G);return(0,a.isThenable)(oe)?oe.then(Q=>Q?q:null):oe?q:null};return ee.requiresSiblings=!0,ee}}return ne}function j(q,B){const Z=q.filter(H=>!!H.basenames);if(Z.length<2)return q;const ne=Z.reduce((H,W)=>{const U=W.basenames;return U?H.concat(U):H},[]);let le;if(B){le=[];for(let H=0,W=ne.length;H<W;H++)le.push(B)}else le=Z.reduce((H,W)=>{const U=W.patterns;return U?H.concat(U):H},[]);const ee=function(H,W){if(typeof H!="string")return null;if(!W){let G;for(G=H.length;G>0;G--){const oe=H.charCodeAt(G-1);if(oe===_.CharCode.Slash||oe===_.CharCode.Backslash)break}W=H.substr(G)}const U=ne.indexOf(W);return U!==-1?le[U]:null};ee.basenames=ne,ee.patterns=le,ee.allBasenames=ne;const K=q.filter(H=>!H.basenames);return K.push(ee),K}function te(q,B){return(0,R.equals)(q,B,(Z,ne)=>typeof Z=="string"&&typeof ne=="string"?Z===ne:typeof Z!="string"&&typeof ne!="string"?Z.base===ne.base&&Z.pattern===ne.pattern:!1)}}),define(he[96],fe([0,1,14,65,10]),function(ce,e,R,a,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DefaultURITransformer=e.URITransformer=void 0,e.transformOutgoingURIs=D,e.transformIncomingURIs=P,e.transformAndReviveIncomingURIs=S;function T(m){return m.toJSON()}class k{constructor(d){this._uriTransformer=d}transformIncoming(d){const l=this._uriTransformer.transformIncoming(d);return l===d?d:T(_.URI.from(l))}transformOutgoing(d){const l=this._uriTransformer.transformOutgoing(d);return l===d?d:T(_.URI.from(l))}transformOutgoingURI(d){const l=this._uriTransformer.transformOutgoing(d);return l===d?d:_.URI.from(l)}transformOutgoingScheme(d){return this._uriTransformer.transformOutgoingScheme(d)}}e.URITransformer=k,e.DefaultURITransformer=new class{transformIncoming(m){return m}transformOutgoing(m){return m}transformOutgoingURI(m){return m}transformOutgoingScheme(m){return m}};function L(m,d,l){if(!m||l>200)return null;if(typeof m=="object"){if(m instanceof _.URI)return d.transformOutgoing(m);for(const g in m)if(Object.hasOwnProperty.call(m,g)){const I=L(m[g],d,l+1);I!==null&&(m[g]=I)}}return null}function D(m,d){const l=L(m,d,0);return l===null?m:l}function E(m,d,l,g){if(!m||g>200)return null;if(typeof m=="object"){if(m.$mid===a.MarshalledId.Uri)return l?_.URI.revive(d.transformIncoming(m)):d.transformIncoming(m);if(m instanceof R.VSBuffer)return null;for(const I in m)if(Object.hasOwnProperty.call(m,I)){const v=E(m[I],d,l,g+1);v!==null&&(m[I]=v)}}return null}function P(m,d){const l=E(m,d,!1,0);return l===null?m:l}function S(m,d){const l=E(m,d,!0,0);return l===null?m:l}}),define(he[148],fe([0,1,38,51,32,139,5]),function(ce,e,R,a,_,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.virtualMachineHint=void 0,e.getMachineId=D,e.getSqmMachineId=S,e.getdevDeviceId=m,_=De(_),e.virtualMachineHint=new class{_isVirtualMachineMacAddress(d){return this._virtualMachineOUIs||(this._virtualMachineOUIs=a.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(d)}value(){if(this._value===void 0){let d=0,l=0;const g=(0,R.networkInterfaces)();for(const I in g){const v=g[I];if(v)for(const{mac:f,internal:C}of v)C||(l+=1,this._isVirtualMachineMacAddress(f.toUpperCase())&&(d+=1))}this._value=l>0?d/l:0}return this._value}};let L;async function D(d){return L||(L=(async()=>await E(d)||_.generateUuid())()),L}async function E(d){try{const l=await new Promise((I,v)=>{ce(["crypto"],I,v)}).then(De),g=(0,T.getMac)();return l.createHash("sha256").update(g,"utf8").digest("hex")}catch(l){d(l);return}}const P="Software\\Microsoft\\SQMClient";async function S(d){if(k.isWindows){const l=await new Promise((g,I)=>{ce(["@vscode/windows-registry"],g,I)}).then(De);try{return l.GetStringRegKey("HKEY_LOCAL_MACHINE",P,"MachineId")||""}catch(g){return d(g),""}}return""}async function m(d){try{return await(await new Promise((I,v)=>{ce(["@vscode/deviceid"],I,v)}).then(De)).getDeviceId()}catch(l){return d(l),""}}}),define(he[149],fe([0,1,33,13,37]),function(ce,e,R,a,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getDisplayProtocol=E,e.getCodeDisplayProtocol=P;const T="XDG_SESSION_TYPE",k="WAYLAND_DISPLAY",L="XDG_RUNTIME_DIR";var D;(function(S){S.Wayland="wayland",S.XWayland="xwayland",S.X11="x11",S.Unknown="unknown"})(D||(D={}));async function E(S){const m=_.env[T];if(m)return m===D.Wayland||m===D.X11?m:D.Unknown;if(_.env[k]){const l=_.env[L];if(l){const g=(0,a.join)(l,"wayland-0");try{return await R.promises.access(g,R.constants.R_OK),D.Wayland}catch(I){return S(I),D.Unknown}}else return D.Unknown}else return D.X11}function P(S,m){if(m)switch(m){case"auto":return S;case"x11":return S===D.Wayland?D.XWayland:D.X11;case"wayland":return D.Wayland;default:return D.Unknown}else return S===D.Wayland?D.XWayland:D.X11}}),define(he[150],fe([0,1,33,243,5]),function(ce,e,R,a,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getOSReleaseInfo=T,_=De(_);async function T(k){if(_.isMacintosh||_.isWindows)return;let L;for(const D of["/etc/os-release","/usr/lib/os-release","/etc/lsb-release"])try{L=await R.promises.open(D,R.constants.R_OK);break}catch{}if(!L){k("Unable to retrieve release information from known identifier paths.");return}try{const D=new Set(["ID","DISTRIB_ID","ID_LIKE","VERSION_ID","DISTRIB_RELEASE"]),E={id:"unknown"};for await(const P of(0,a.createInterface)({input:L.createReadStream(),crlfDelay:1/0})){if(!P.includes("="))continue;const S=P.split("=")[0].toUpperCase().trim();if(D.has(S)){const m=P.split("=")[1].replace(/"/g,"").toLowerCase().trim();S==="ID"||S==="DISTRIB_ID"?E.id=m:S==="ID_LIKE"?E.id_like=m:(S==="VERSION_ID"||S==="DISTRIB_RELEASE")&&(E.version_id=m)}}return E}catch(D){k(D)}}}),define(he[30],fe([0,1,33,38,244,6,42,91,13,5,20,10]),function(ce,e,R,a,_,T,k,L,D,E,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.SymlinkSupport=e.RimRafMode=void 0,e.rimrafSync=I,e.readdirSync=C,e.whenDeleted=u,e.configureFlushOnWrite=r,e.writeFileSync=h,R=De(R);var m;(function(z){z[z.UNLINK=0]="UNLINK",z[z.MOVE=1]="MOVE"})(m||(e.RimRafMode=m={}));async function d(z,J=m.UNLINK,j){if((0,k.isRootOrDriveLetter)(z))throw new Error("rimraf - will refuse to recursively delete root");return J===m.UNLINK?g(z):l(z,j)}async function l(z,J=(0,k.randomPath)((0,a.tmpdir)())){try{try{await R.promises.rename(z,J)}catch(j){return j.code==="ENOENT"?void 0:g(z)}g(J).catch(j=>{})}catch(j){if(j.code!=="ENOENT")throw j}}async function g(z){return R.promises.rm(z,{recursive:!0,force:!0,maxRetries:3})}function I(z){if((0,k.isRootOrDriveLetter)(z))throw new Error("rimraf - will refuse to recursively delete root");R.rmSync(z,{recursive:!0,force:!0,maxRetries:3})}async function v(z,J){return p(await(J?f(z):R.promises.readdir(z)))}async function f(z){try{return await R.promises.readdir(z,{withFileTypes:!0})}catch(te){console.warn("[node.js fs] readdir with filetypes failed with error: ",te)}const J=[],j=await v(z);for(const te of j){let q=!1,B=!1,Z=!1;try{const ne=await R.promises.lstat((0,D.join)(z,te));q=ne.isFile(),B=ne.isDirectory(),Z=ne.isSymbolicLink()}catch(ne){console.warn("[node.js fs] unexpected error from lstat after readdir: ",ne)}J.push({name:te,isFile:()=>q,isDirectory:()=>B,isSymbolicLink:()=>Z})}return J}function C(z){return p(R.readdirSync(z))}function p(z){return z.map(J=>typeof J=="string"?E.isMacintosh?(0,L.normalizeNFC)(J):J:(J.name=E.isMacintosh?(0,L.normalizeNFC)(J.name):J.name,J))}async function c(z){const J=await v(z),j=[];for(const te of J)await i.existsDirectory((0,D.join)(z,te))&&j.push(te);return j}function u(z,J=1e3){return new Promise(j=>{let te=!1;const q=setInterval(()=>{te||(te=!0,R.access(z,B=>{te=!1,B&&(clearInterval(q),j(void 0))}))},J)})}var i;(function(z){async function J(q){let B;try{if(B=await R.promises.lstat(q),!B.isSymbolicLink())return{stat:B}}catch{}try{return{stat:await R.promises.stat(q),symbolicLink:B?.isSymbolicLink()?{dangling:!1}:void 0}}catch(Z){if(Z.code==="ENOENT"&&B)return{stat:B,symbolicLink:{dangling:!0}};if(E.isWindows&&Z.code==="EACCES")try{return{stat:await R.promises.stat(await R.promises.readlink(q)),symbolicLink:{dangling:!1}}}catch(ne){if(ne.code==="ENOENT"&&B)return{stat:B,symbolicLink:{dangling:!0}};throw ne}throw Z}}z.stat=J;async function j(q){try{const{stat:B,symbolicLink:Z}=await z.stat(q);return B.isFile()&&Z?.dangling!==!0}catch{}return!1}z.existsFile=j;async function te(q){try{const{stat:B,symbolicLink:Z}=await z.stat(q);return B.isDirectory()&&Z?.dangling!==!0}catch{}return!1}z.existsDirectory=te})(i||(e.SymlinkSupport=i={}));const n=new T.ResourceQueue;function t(z,J,j){return n.queueFor(S.URI.file(z),()=>{const te=y(j);return new Promise((q,B)=>o(z,J,te,Z=>Z?B(Z):q()))},P.extUriBiasedIgnorePathCase)}let s=!0;function r(z){s=z}function o(z,J,j,te){if(!s)return R.writeFile(z,J,{mode:j.mode,flag:j.flag},te);R.open(z,j.flag,j.mode,(q,B)=>{if(q)return te(q);R.writeFile(B,J,Z=>{if(Z)return R.close(B,()=>te(Z));R.fdatasync(B,ne=>(ne&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",ne),r(!1)),R.close(B,le=>te(le))))})})}function h(z,J,j){const te=y(j);if(!s)return R.writeFileSync(z,J,{mode:te.mode,flag:te.flag});const q=R.openSync(z,te.flag,te.mode);try{R.writeFileSync(q,J);try{R.fdatasyncSync(q)}catch(B){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",B),r(!1)}}finally{R.closeSync(q)}}function y(z){return z?{mode:typeof z.mode=="number"?z.mode:438,flag:typeof z.flag=="string"?z.flag:"w"}:{mode:438,flag:"w"}}async function A(z,J,j=6e4){if(z!==J)try{E.isWindows&&typeof j=="number"?await b(z,J,Date.now(),j):await R.promises.rename(z,J)}catch(te){if(z.toLowerCase()!==J.toLowerCase()&&te.code==="EXDEV"||z.endsWith("."))await w(z,J,{preserveSymlinks:!1}),await d(z,m.MOVE);else throw te}}async function b(z,J,j,te,q=0){try{return await R.promises.rename(z,J)}catch(B){if(B.code!=="EACCES"&&B.code!=="EPERM"&&B.code!=="EBUSY")throw B;if(Date.now()-j>=te)throw console.error(`[node.js fs] rename failed after ${q} retries with error: ${B}`),B;if(q===0){let Z=!1;try{const{stat:ne}=await i.stat(J);ne.isFile()||(Z=!0)}catch{}if(Z)throw B}return await(0,T.timeout)(Math.min(100,q*10)),b(z,J,j,te,q+1)}}async function w(z,J,j){return F(z,J,{root:{source:z,target:J},options:j,handledSourcePaths:new Set})}const O=511;async function F(z,J,j){if(j.handledSourcePaths.has(z))return;j.handledSourcePaths.add(z);const{stat:te,symbolicLink:q}=await i.stat(z);if(q){if(j.options.preserveSymlinks)try{return await V(z,J,j)}catch{}if(q.dangling)return}return te.isDirectory()?N(z,J,te.mode&O,j):M(z,J,te.mode&O)}async function N(z,J,j,te){await R.promises.mkdir(J,{recursive:!0,mode:j});const q=await v(z);for(const B of q)await F((0,D.join)(z,B),(0,D.join)(J,B),te)}async function M(z,J,j){await R.promises.copyFile(z,J),await R.promises.chmod(J,j)}async function V(z,J,j){let te=await R.promises.readlink(z);(0,k.isEqualOrParent)(te,j.root.source,!E.isLinux)&&(te=(0,D.join)(j.root.target,te.substr(j.root.source.length+1))),await R.promises.symlink(te,J)}e.Promises=new class{get read(){return(z,J,j,te,q)=>new Promise((B,Z)=>{R.read(z,J,j,te,q,(ne,le,ee)=>ne?Z(ne):B({bytesRead:le,buffer:ee}))})}get write(){return(z,J,j,te,q)=>new Promise((B,Z)=>{R.write(z,J,j,te,q,(ne,le,ee)=>ne?Z(ne):B({bytesWritten:le,buffer:ee}))})}get fdatasync(){return(0,_.promisify)(R.fdatasync)}get open(){return(0,_.promisify)(R.open)}get close(){return(0,_.promisify)(R.close)}get realpath(){return(0,_.promisify)(R.realpath)}async exists(z){try{return await R.promises.access(z),!0}catch{return!1}}get readdir(){return v}get readDirsInDir(){return c}get writeFile(){return t}get rm(){return d}get rename(){return A}get copy(){return w}}}),define(he[151],fe([0,1,33,13,5,26,30]),function(ce,e,R,a,_,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realcaseSync=L,e.realcase=D,e.realpath=E,e.realpathSync=P,R=De(R);function L(m){if(_.isLinux)return m;const d=(0,a.dirname)(m);if(m===d)return m;const l=((0,a.basename)(m)||m).toLowerCase();try{const I=(0,k.readdirSync)(d).filter(v=>v.toLowerCase()===l);if(I.length===1){const v=L(d);if(v)return(0,a.join)(v,I[0])}else if(I.length>1){const v=I.indexOf(l);if(v>=0){const f=L(d);if(f)return(0,a.join)(f,I[v])}}}catch{}return null}async function D(m,d){if(_.isLinux)return m;const l=(0,a.dirname)(m);if(m===l)return m;const g=((0,a.basename)(m)||m).toLowerCase();try{if(d?.isCancellationRequested)return null;const v=(await k.Promises.readdir(l)).filter(f=>f.toLowerCase()===g);if(v.length===1){const f=await D(l,d);if(f)return(0,a.join)(f,v[0])}else if(v.length>1){const f=v.indexOf(g);if(f>=0){const C=await D(l,d);if(C)return(0,a.join)(C,v[f])}}}catch{}return null}async function E(m){try{return await k.Promises.realpath(m)}catch{const l=S(m);return await R.promises.access(l,R.constants.R_OK),l}}function P(m){try{return R.realpathSync(m)}catch{const l=S(m);return R.accessSync(l,R.constants.R_OK),l}}function S(m){return(0,T.rtrim)((0,a.normalize)(m),a.sep)}}),define(he[152],fe([0,1,33,13,5,37,94,12,30]),function(ce,e,R,a,_,T,k,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.TerminateResponseCode=e.Source=void 0,e.getWindowsShell=E,e.createQueuedSender=P,a=De(a),_=De(_),T=De(T),L=De(L),D=De(D),Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return k.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return k.TerminateResponseCode}});function E(m=T.env){return m.comspec||"cmd.exe"}function P(m){let d=[],l=!1;const g=function(I){if(l){d.push(I);return}(!m.send(I,f=>{if(f&&console.error(f),l=!1,d.length>0){const C=d.slice(0);d=[],C.forEach(p=>g(p))}})||_.isWindows)&&(l=!0)};return{send:g}}var S;(function(m){async function d(l,g,I){if(a.isAbsolute(l))return l;if(g===void 0&&(g=T.cwd()),a.dirname(l)!=="."||(I===void 0&&L.isString(T.env.PATH)&&(I=T.env.PATH.split(a.delimiter)),I===void 0||I.length===0))return a.join(g,l);async function f(C){if(await D.Promises.exists(C)){let p;try{p=await R.promises.stat(C)}catch(c){c.message.startsWith("EACCES")&&(p=await R.promises.lstat(C))}return p?!p.isDirectory():!1}return!1}for(const C of I){let p;if(a.isAbsolute(C)?p=a.join(C,l):p=a.join(g,C,l),await f(p))return p;let c=p+".com";if(await f(c)||(c=p+".exe",await f(c)))return c}return a.join(g,l)}m.findExecutable=d})(S||(e.win32=S={}))}),define(he[153],fe([0,1,70,22]),function(ce,e,R,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=_;function _(k){return new Promise((L,D)=>{let E;const P=new Map;function S(d,l,g,I,v){const f=P.get(l);if(d===k||f){const C={name:m(g),cmd:g,pid:d,ppid:l,load:I,mem:v};P.set(d,C),d===k&&(E=C),f&&(f.children||(f.children=[]),f.children.push(C),f.children.length>1&&(f.children=f.children.sort((p,c)=>p.pid-c.pid)))}}function m(d){const l=/--utility-sub-type=network/i,g=/--crashes-directory/i,I=/\\pipe\\winpty-control/i,v=/conhost\.exe.+--headless/i,f=/--type=([a-zA-Z-]+)/;if(g.exec(d))return"electron-crash-reporter";if(I.exec(d))return"winpty-agent";if(v.exec(d))return"conpty-agent";let C=f.exec(d);if(C&&C.length===2)return C[1]==="renderer"?"window":C[1]==="utility"?l.exec(d)?"utility-network-service":"utility-process":C[1]==="extensionHost"?"extension-host":C[1];const p=/[a-zA-Z-]+\.js/g;let c="";do C=p.exec(d),C&&(c+=C+" ");while(C);return c&&d.indexOf("node ")<0&&d.indexOf("node.exe")<0?`electron-nodejs (${c})`:d}if(process.platform==="win32"){const d=l=>l.indexOf("\\\\?\\")===0||l.indexOf("\\??\\")===0?l.substring(4):l.indexOf('"\\\\?\\')===0||l.indexOf('"\\??\\')===0?'"'+l.substring(5):l;new Promise((l,g)=>{ce(["@vscode/windows-process-tree"],l,g)}).then(De).then(l=>{l.getProcessList(k,g=>{if(!g){D(new Error(`Root process ${k} not found`));return}l.getProcessCpuUsage(g,I=>{const v=new Map;I.forEach(f=>{const C=d(f.commandLine||"");v.set(f.pid,{name:m(C),cmd:C,pid:f.pid,ppid:f.ppid,load:f.cpu||0,mem:f.memory||0})}),E=v.get(k),E?(v.forEach(f=>{const C=v.get(f.ppid);C&&(C.children||(C.children=[]),C.children.push(f))}),v.forEach(f=>{f.children&&(f.children=f.children.sort((C,p)=>C.pid-p.pid))}),L(E)):D(new Error(`Root process ${k} not found`))})},l.ProcessDataFlag.CommandLine|l.ProcessDataFlag.Memory)})}else{let d=function(){let l=[E];const g=[];for(;l.length;){const v=l.shift();v&&(g.push(v.pid),v.children&&(l=l.concat(v.children)))}let I=JSON.stringify(a.FileAccess.asFileUri("vs/base/node/cpuUsage.sh").fsPath);I+=" "+g.join(" "),(0,R.exec)(I,{},(v,f,C)=>{if(v||C)D(v||new Error(C.toString()));else{const p=f.toString().split(`
`);for(let c=0;c<g.length;c++){const u=P.get(g[c]);u.load=parseFloat(p[c])}if(!E){D(new Error(`Root process ${k} not found`));return}L(E)}})};(0,R.exec)("which ps",{},(l,g,I)=>{if(l||I)if(process.platform!=="linux")D(l||new Error(I.toString()));else{const v=JSON.stringify(a.FileAccess.asFileUri("vs/base/node/ps.sh").fsPath);(0,R.exec)(v,{},(f,C,p)=>{f||p?D(f||new Error(p.toString())):(T(C,S),d())})}else{const v=g.toString().trim();(0,R.exec)(`${v} -ax -o pid=,ppid=,pcpu=,pmem=,command=`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(C,p,c)=>{C||c&&!c.includes("screen size is bogus")?D(C||new Error(c.toString())):(T(p,S),process.platform==="linux"?d():E?L(E):D(new Error(`Root process ${k} not found`)))})}})}})}function T(k,L){const D=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,E=k.toString().split(`
`);for(const P of E){const S=D.exec(P.trim());S&&S.length===6&&L(parseInt(S[1]),parseInt(S[2]),S[5],parseFloat(S[3]),parseFloat(S[4]))}}}),define(he[71],fe([0,1,33,6,13,12,30,9]),function(ce,e,R,a,_,T,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtractError=e.CorruptZipMessage=void 0,e.zip=I,e.extract=v,e.buffer=C,_=De(_),L=De(L),e.CorruptZipMessage="end of central directory record signature not found";const D=new RegExp(e.CorruptZipMessage);class E extends Error{constructor(c,u){let i=u.message;switch(c){case"CorruptZip":i=`Corrupt ZIP: ${i}`;break}super(i),this.type=c,this.cause=u}}e.ExtractError=E;function P(p){const c=p.externalFileAttributes>>16||33188;return[448,56,7].map(u=>c&u).reduce((u,i)=>u+i,c&61440)}function S(p){if(p instanceof E)return p;let c;return D.test(p.message)&&(c="CorruptZip"),new E(c,p)}function m(p,c,u,i,n,t){const s=_.dirname(c),r=_.join(i,s);if(!r.startsWith(i))return Promise.reject(new Error(L.localize(142,null,c)));const o=_.join(i,c);let h;return t.onCancellationRequested(()=>{h?.destroy()}),Promise.resolve(R.promises.mkdir(r,{recursive:!0})).then(()=>new Promise((y,A)=>{if(!t.isCancellationRequested)try{h=(0,R.createWriteStream)(o,{mode:u}),h.once("close",()=>y()),h.once("error",A),p.once("error",A),p.pipe(h)}catch(b){A(b)}}))}function d(p,c,u,i){let n=(0,a.createCancelablePromise)(()=>Promise.resolve()),t=0;const s=i.onCancellationRequested(()=>{n.cancel(),p.close()});return new Promise((r,o)=>{const h=new a.Sequencer,y=A=>{A.isCancellationRequested||(t++,p.readEntry())};p.once("error",o),p.once("close",()=>n.then(()=>{i.isCancellationRequested||p.entryCount===t?r():o(new E("Incomplete",new Error(L.localize(143,null,t,p.entryCount))))},o)),p.readEntry(),p.on("entry",A=>{if(i.isCancellationRequested)return;if(!u.sourcePathRegex.test(A.fileName)){y(i);return}const b=A.fileName.replace(u.sourcePathRegex,"");if(/\/$/.test(b)){const F=_.join(c,b);n=(0,a.createCancelablePromise)(N=>R.promises.mkdir(F,{recursive:!0}).then(()=>y(N)).then(void 0,o));return}const w=g(p,A),O=P(A);n=(0,a.createCancelablePromise)(F=>h.queue(()=>w.then(N=>m(N,b,O,c,u,F).then(()=>y(F)))).then(null,o))})}).finally(()=>s.dispose())}async function l(p,c=!1){const{open:u}=await new Promise((i,n)=>{ce(["yauzl"],i,n)}).then(De);return new Promise((i,n)=>{u(p,c?{lazyEntries:!0}:void 0,(t,s)=>{t?n(S(t)):i((0,T.assertIsDefined)(s))})})}function g(p,c){return new Promise((u,i)=>{p.openReadStream(c,(n,t)=>{n?i(S(n)):u((0,T.assertIsDefined)(t))})})}async function I(p,c){const{ZipFile:u}=await new Promise((i,n)=>{ce(["yazl"],i,n)}).then(De);return new Promise((i,n)=>{const t=new u;c.forEach(r=>{r.contents?t.addBuffer(typeof r.contents=="string"?Buffer.from(r.contents,"utf8"):r.contents,r.path):r.localPath&&t.addFile(r.localPath,r.path)}),t.end();const s=(0,R.createWriteStream)(p);t.outputStream.pipe(s),t.outputStream.once("error",n),s.once("error",n),s.once("finish",()=>i(p))})}function v(p,c,u={},i){const n=new RegExp(u.sourcePath?`^${u.sourcePath}`:"");let t=l(p,!0);return u.overwrite&&(t=t.then(s=>k.Promises.rm(c).then(()=>s))),t.then(s=>d(s,c,{sourcePathRegex:n},i))}function f(p,c){return l(p).then(u=>new Promise((i,n)=>{u.on("entry",t=>{t.fileName===c&&g(u,t).then(s=>i(s),s=>n(s))}),u.once("close",()=>n(new Error(L.localize(144,null,c))))}))}function C(p,c){return f(p,c).then(u=>new Promise((i,n)=>{const t=[];u.once("error",n),u.on("data",s=>t.push(s)),u.on("end",()=>i(Buffer.concat(t)))}))}});var Ie=this&&this.__decorate||function(ce,e,R,a){var _=arguments.length,T=_<3?e:a===null?a=Object.getOwnPropertyDescriptor(e,R):a,k;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")T=Reflect.decorate(ce,e,R,a);else for(var L=ce.length-1;L>=0;L--)(k=ce[L])&&(T=(_<3?k(T):_>3?k(e,R,T):k(e,R))||T);return _>3&&T&&Object.defineProperty(e,R,T),T};define(he[43],fe([0,1,17,6,14,25,88,8,3,2,68,26,12]),function(ce,e,R,a,_,T,k,L,D,E,P,S,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.ProxyChannel=e.StaticRouter=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.BufferWriter=e.BufferReader=void 0,e.serialize=r,e.deserialize=o,e.getDelayedChannel=O,e.getNextTickChannel=F,S=De(S);var d;(function(q){q[q.Promise=100]="Promise",q[q.PromiseCancel=101]="PromiseCancel",q[q.EventListen=102]="EventListen",q[q.EventDispose=103]="EventDispose"})(d||(d={}));function l(q){switch(q){case d.Promise:return"req";case d.PromiseCancel:return"cancel";case d.EventListen:return"subscribe";case d.EventDispose:return"unsubscribe"}}var g;(function(q){q[q.Initialize=200]="Initialize",q[q.PromiseSuccess=201]="PromiseSuccess",q[q.PromiseError=202]="PromiseError",q[q.PromiseErrorObj=203]="PromiseErrorObj",q[q.EventFire=204]="EventFire"})(g||(g={}));function I(q){switch(q){case g.Initialize:return"init";case g.PromiseSuccess:return"reply:";case g.PromiseError:case g.PromiseErrorObj:return"replyErr:";case g.EventFire:return"event:"}}var v;(function(q){q[q.Uninitialized=0]="Uninitialized",q[q.Idle=1]="Idle"})(v||(v={}));function f(q){let B=0;for(let Z=0;;Z+=7){const ne=q.read(1);if(B|=(ne.buffer[0]&127)<<Z,!(ne.buffer[0]&128))return B}}const C=n(0);function p(q,B){if(B===0){q.write(C);return}let Z=0;for(let le=B;le!==0;le=le>>>7)Z++;const ne=_.VSBuffer.alloc(Z);for(let le=0;B!==0;le++)ne.buffer[le]=B&127,B=B>>>7,B>0&&(ne.buffer[le]|=128);q.write(ne)}class c{constructor(B){this.buffer=B,this.pos=0}read(B){const Z=this.buffer.slice(this.pos,this.pos+B);return this.pos+=Z.byteLength,Z}}e.BufferReader=c;class u{constructor(){this.buffers=[]}get buffer(){return _.VSBuffer.concat(this.buffers)}write(B){this.buffers.push(B)}}e.BufferWriter=u;var i;(function(q){q[q.Undefined=0]="Undefined",q[q.String=1]="String",q[q.Buffer=2]="Buffer",q[q.VSBuffer=3]="VSBuffer",q[q.Array=4]="Array",q[q.Object=5]="Object",q[q.Int=6]="Int"})(i||(i={}));function n(q){const B=_.VSBuffer.alloc(1);return B.writeUInt8(q,0),B}const t={Undefined:n(i.Undefined),String:n(i.String),Buffer:n(i.Buffer),VSBuffer:n(i.VSBuffer),Array:n(i.Array),Object:n(i.Object),Uint:n(i.Int)},s=typeof Buffer<"u";function r(q,B){if(typeof B>"u")q.write(t.Undefined);else if(typeof B=="string"){const Z=_.VSBuffer.fromString(B);q.write(t.String),p(q,Z.byteLength),q.write(Z)}else if(s&&Buffer.isBuffer(B)){const Z=_.VSBuffer.wrap(B);q.write(t.Buffer),p(q,Z.byteLength),q.write(Z)}else if(B instanceof _.VSBuffer)q.write(t.VSBuffer),p(q,B.byteLength),q.write(B);else if(Array.isArray(B)){q.write(t.Array),p(q,B.length);for(const Z of B)r(q,Z)}else if(typeof B=="number"&&(B|0)===B)q.write(t.Uint),p(q,B);else{const Z=_.VSBuffer.fromString(JSON.stringify(B));q.write(t.Object),p(q,Z.byteLength),q.write(Z)}}function o(q){switch(q.read(1).readUInt8(0)){case i.Undefined:return;case i.String:return q.read(f(q)).toString();case i.Buffer:return q.read(f(q)).buffer;case i.VSBuffer:return q.read(f(q));case i.Array:{const Z=f(q),ne=[];for(let le=0;le<Z;le++)ne.push(o(q));return ne}case i.Object:return JSON.parse(q.read(f(q)).toString());case i.Int:return f(q)}}class h{constructor(B,Z,ne=null,le=1e3){this.protocol=B,this.ctx=Z,this.logger=ne,this.timeoutDelay=le,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(ee=>this.onRawMessage(ee)),this.sendResponse({type:g.Initialize})}registerChannel(B,Z){this.channels.set(B,Z),setTimeout(()=>this.flushPendingRequests(B),0)}sendResponse(B){switch(B.type){case g.Initialize:{const Z=this.send([B.type]);this.logger?.logOutgoing(Z,0,y.OtherSide,I(B.type));return}case g.PromiseSuccess:case g.PromiseError:case g.EventFire:case g.PromiseErrorObj:{const Z=this.send([B.type,B.id],B.data);this.logger?.logOutgoing(Z,B.id,y.OtherSide,I(B.type),B.data);return}}}send(B,Z=void 0){const ne=new u;return r(ne,B),r(ne,Z),this.sendBuffer(ne.buffer)}sendBuffer(B){try{return this.protocol.send(B),B.byteLength}catch{return 0}}onRawMessage(B){const Z=new c(B),ne=o(Z),le=o(Z),ee=ne[0];switch(ee){case d.Promise:return this.logger?.logIncoming(B.byteLength,ne[1],y.OtherSide,`${l(ee)}: ${ne[2]}.${ne[3]}`,le),this.onPromise({type:ee,id:ne[1],channelName:ne[2],name:ne[3],arg:le});case d.EventListen:return this.logger?.logIncoming(B.byteLength,ne[1],y.OtherSide,`${l(ee)}: ${ne[2]}.${ne[3]}`,le),this.onEventListen({type:ee,id:ne[1],channelName:ne[2],name:ne[3],arg:le});case d.PromiseCancel:return this.logger?.logIncoming(B.byteLength,ne[1],y.OtherSide,`${l(ee)}`),this.disposeActiveRequest({type:ee,id:ne[1]});case d.EventDispose:return this.logger?.logIncoming(B.byteLength,ne[1],y.OtherSide,`${l(ee)}`),this.disposeActiveRequest({type:ee,id:ne[1]})}}onPromise(B){const Z=this.channels.get(B.channelName);if(!Z){this.collectPendingRequest(B);return}const ne=new T.CancellationTokenSource;let le;try{le=Z.call(this.ctx,B.name,B.arg,ne.token)}catch(H){le=Promise.reject(H)}const ee=B.id;le.then(H=>{this.sendResponse({id:ee,data:H,type:g.PromiseSuccess})},H=>{H instanceof Error?this.sendResponse({id:ee,data:{message:H.message,name:H.name,stack:H.stack?H.stack.split(`
`):void 0},type:g.PromiseError}):this.sendResponse({id:ee,data:H,type:g.PromiseErrorObj})}).finally(()=>{K.dispose(),this.activeRequests.delete(B.id)});const K=(0,E.toDisposable)(()=>ne.cancel());this.activeRequests.set(B.id,K)}onEventListen(B){const Z=this.channels.get(B.channelName);if(!Z){this.collectPendingRequest(B);return}const ne=B.id,ee=Z.listen(this.ctx,B.name,B.arg)(K=>this.sendResponse({id:ne,data:K,type:g.EventFire}));this.activeRequests.set(B.id,ee)}disposeActiveRequest(B){const Z=this.activeRequests.get(B.id);Z&&(Z.dispose(),this.activeRequests.delete(B.id))}collectPendingRequest(B){let Z=this.pendingRequests.get(B.channelName);Z||(Z=[],this.pendingRequests.set(B.channelName,Z));const ne=setTimeout(()=>{console.error(`Unknown channel: ${B.channelName}`),B.type===d.Promise&&this.sendResponse({id:B.id,data:{name:"Unknown channel",message:`Channel name '${B.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:g.PromiseError})},this.timeoutDelay);Z.push({request:B,timeoutTimer:ne})}flushPendingRequests(B){const Z=this.pendingRequests.get(B);if(Z){for(const ne of Z)switch(clearTimeout(ne.timeoutTimer),ne.request.type){case d.Promise:this.onPromise(ne.request);break;case d.EventListen:this.onEventListen(ne.request);break}this.pendingRequests.delete(B)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,E.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelServer=h;var y;(function(q){q[q.LocalSide=0]="LocalSide",q[q.OtherSide=1]="OtherSide"})(y||(e.RequestInitiator=y={}));class A{constructor(B,Z=null){this.protocol=B,this.isDisposed=!1,this.state=v.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new D.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(ne=>this.onBuffer(ne)),this.logger=Z}getChannel(B){const Z=this;return{call(ne,le,ee){return Z.isDisposed?Promise.reject(new L.CancellationError):Z.requestPromise(B,ne,le,ee)},listen(ne,le){return Z.isDisposed?D.Event.None:Z.requestEvent(B,ne,le)}}}requestPromise(B,Z,ne,le=T.CancellationToken.None){const ee=this.lastRequestId++,K=d.Promise,H={id:ee,type:K,channelName:B,name:Z,arg:ne};if(le.isCancellationRequested)return Promise.reject(new L.CancellationError);let W;return new Promise((G,oe)=>{if(le.isCancellationRequested)return oe(new L.CancellationError);const Q=()=>{const ie=ae=>{switch(ae.type){case g.PromiseSuccess:this.handlers.delete(ee),G(ae.data);break;case g.PromiseError:{this.handlers.delete(ee);const ue=new Error(ae.data.message);ue.stack=Array.isArray(ae.data.stack)?ae.data.stack.join(`
`):ae.data.stack,ue.name=ae.data.name,oe(ue);break}case g.PromiseErrorObj:this.handlers.delete(ee),oe(ae.data);break}};this.handlers.set(ee,ie),this.sendRequest(H)};let X=null;this.state===v.Idle?Q():(X=(0,a.createCancelablePromise)(ie=>this.whenInitialized()),X.then(()=>{X=null,Q()}));const x=()=>{X?(X.cancel(),X=null):this.sendRequest({id:ee,type:d.PromiseCancel}),oe(new L.CancellationError)},$=le.onCancellationRequested(x);W=(0,E.combinedDisposable)((0,E.toDisposable)(x),$),this.activeRequests.add(W)}).finally(()=>{W.dispose(),this.activeRequests.delete(W)})}requestEvent(B,Z,ne){const le=this.lastRequestId++,ee=d.EventListen,K={id:le,type:ee,channelName:B,name:Z,arg:ne};let H=null;const W=new D.Emitter({onWillAddFirstListener:()=>{H=(0,a.createCancelablePromise)(G=>this.whenInitialized()),H.then(()=>{H=null,this.activeRequests.add(W),this.sendRequest(K)})},onDidRemoveLastListener:()=>{H?(H.cancel(),H=null):(this.activeRequests.delete(W),this.sendRequest({id:le,type:d.EventDispose}))}}),U=G=>W.fire(G.data);return this.handlers.set(le,U),W.event}sendRequest(B){switch(B.type){case d.Promise:case d.EventListen:{const Z=this.send([B.type,B.id,B.channelName,B.name],B.arg);this.logger?.logOutgoing(Z,B.id,y.LocalSide,`${l(B.type)}: ${B.channelName}.${B.name}`,B.arg);return}case d.PromiseCancel:case d.EventDispose:{const Z=this.send([B.type,B.id]);this.logger?.logOutgoing(Z,B.id,y.LocalSide,l(B.type));return}}}send(B,Z=void 0){const ne=new u;return r(ne,B),r(ne,Z),this.sendBuffer(ne.buffer)}sendBuffer(B){try{return this.protocol.send(B),B.byteLength}catch{return 0}}onBuffer(B){const Z=new c(B),ne=o(Z),le=o(Z),ee=ne[0];switch(ee){case g.Initialize:return this.logger?.logIncoming(B.byteLength,0,y.LocalSide,I(ee)),this.onResponse({type:ne[0]});case g.PromiseSuccess:case g.PromiseError:case g.EventFire:case g.PromiseErrorObj:return this.logger?.logIncoming(B.byteLength,ne[1],y.LocalSide,I(ee),le),this.onResponse({type:ne[0],id:ne[1],data:le})}}onResponse(B){if(B.type===g.Initialize){this.state=v.Idle,this._onDidInitialize.fire();return}this.handlers.get(B.id)?.(B)}get onDidInitializePromise(){return D.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===v.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,E.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelClient=A,Ie([k.memoize],A.prototype,"onDidInitializePromise",null);class b{get connections(){const B=[];return this._connections.forEach(Z=>B.push(Z)),B}constructor(B,Z,ne){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new D.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new D.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,this.disposables=new E.DisposableStore,this.disposables.add(B(({protocol:le,onDidClientDisconnect:ee})=>{const K=D.Event.once(le.onMessage);this.disposables.add(K(H=>{const W=new c(H),U=o(W),G=new h(le,U,Z,ne),oe=new A(le,Z);this.channels.forEach((X,x)=>G.registerChannel(x,X));const Q={channelServer:G,channelClient:oe,ctx:U};this._connections.add(Q),this._onDidAddConnection.fire(Q),this.disposables.add(ee(()=>{G.dispose(),oe.dispose(),this._connections.delete(Q),this._onDidRemoveConnection.fire(Q)}))}))}))}getChannel(B,Z){const ne=this;return{call(le,ee,K){let H;if((0,m.isFunction)(Z)){const U=(0,R.getRandomElement)(ne.connections.filter(Z));H=U?Promise.resolve(U):D.Event.toPromise(D.Event.filter(ne.onDidAddConnection,Z))}else H=Z.routeCall(ne,le,ee);const W=H.then(U=>U.channelClient.getChannel(B));return O(W).call(le,ee,K)},listen(le,ee){if((0,m.isFunction)(Z))return ne.getMulticastEvent(B,Z,le,ee);const K=Z.routeEvent(ne,le,ee).then(H=>H.channelClient.getChannel(B));return O(K).listen(le,ee)}}}getMulticastEvent(B,Z,ne,le){const ee=this;let K;const H=new D.Emitter({onWillAddFirstListener:()=>{K=new E.DisposableStore;const W=new D.EventMultiplexer,U=new Map,G=Q=>{const x=Q.channelClient.getChannel(B).listen(ne,le),$=W.add(x);U.set(Q,$)},oe=Q=>{const X=U.get(Q);X&&(X.dispose(),U.delete(Q))};ee.connections.filter(Z).forEach(G),D.Event.filter(ee.onDidAddConnection,Z)(G,void 0,K),ee.onDidRemoveConnection(oe,void 0,K),W.event(H.fire,H,K),K.add(W)},onDidRemoveLastListener:()=>{K?.dispose(),K=void 0}});return H.event}registerChannel(B,Z){this.channels.set(B,Z);for(const ne of this._connections)ne.channelServer.registerChannel(B,Z)}dispose(){this.disposables.dispose();for(const B of this._connections)B.channelClient.dispose(),B.channelServer.dispose();this._connections.clear(),this.channels.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=b;class w{constructor(B,Z,ne=null){const le=new u;r(le,Z),B.send(le.buffer),this.channelClient=new A(B,ne),this.channelServer=new h(B,Z,ne)}getChannel(B){return this.channelClient.getChannel(B)}registerChannel(B,Z){this.channelServer.registerChannel(B,Z)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=w;function O(q){return{call(B,Z,ne){return q.then(le=>le.call(B,Z,ne))},listen(B,Z){const ne=new D.Relay;return q.then(le=>ne.input=le.listen(B,Z)),ne.event}}}function F(q){let B=!1;return{call(Z,ne,le){return B?q.call(Z,ne,le):(0,a.timeout)(0).then(()=>B=!0).then(()=>q.call(Z,ne,le))},listen(Z,ne){if(B)return q.listen(Z,ne);const le=new D.Relay;return(0,a.timeout)(0).then(()=>B=!0).then(()=>le.input=q.listen(Z,ne)),le.event}}}class N{constructor(B){this.fn=B}routeCall(B){return this.route(B)}routeEvent(B){return this.route(B)}async route(B){for(const Z of B.connections)if(await Promise.resolve(this.fn(Z.ctx)))return Promise.resolve(Z);return await D.Event.toPromise(B.onDidAddConnection),await this.route(B)}}e.StaticRouter=N;var M;(function(q){function B(ee,K,H){const W=ee,U=H&&H.disableMarshalling,G=new Map;for(const oe in W)ne(oe)&&G.set(oe,D.Event.buffer(W[oe],!0,void 0,K));return new class{listen(oe,Q,X){const x=G.get(Q);if(x)return x;const $=W[Q];if(typeof $=="function"){if(le(Q))return $.call(W,X);if(ne(Q))return G.set(Q,D.Event.buffer(W[Q],!0,void 0,K)),G.get(Q)}throw new L.ErrorNoTelemetry(`Event not found: ${Q}`)}call(oe,Q,X){const x=W[Q];if(typeof x=="function"){if(!U&&Array.isArray(X))for(let ie=0;ie<X.length;ie++)X[ie]=(0,P.revive)(X[ie]);let $=x.apply(W,X);return $ instanceof Promise||($=Promise.resolve($)),$}throw new L.ErrorNoTelemetry(`Method not found: ${Q}`)}}}q.fromService=B;function Z(ee,K){const H=K&&K.disableMarshalling;return new Proxy({},{get(W,U){if(typeof U=="string")return K?.properties?.has(U)?K.properties.get(U):le(U)?function(G){return ee.listen(U,G)}:ne(U)?ee.listen(U):async function(...G){let oe;K&&!(0,m.isUndefinedOrNull)(K.context)?oe=[K.context,...G]:oe=G;const Q=await ee.call(U,oe);return H?Q:(0,P.revive)(Q)};throw new L.ErrorNoTelemetry(`Property not found: ${String(U)}`)}})}q.toService=Z;function ne(ee){return ee[0]==="o"&&ee[1]==="n"&&S.isUpperAsciiLetter(ee.charCodeAt(2))}function le(ee){return/^onDynamic/.test(ee)&&S.isUpperAsciiLetter(ee.charCodeAt(9))}})(M||(e.ProxyChannel=M={}));const V=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function z(q){if(Array.isArray(q))return q;if(q&&typeof q=="object"&&typeof q.toString=="function"){const B=q.toString();if(B!=="[object Object]")return B}return q}function J(q){return Array.isArray(q)?q.map(z):z(q)}function j(q,B,Z,ne,le,ee,K){K=J(K);const H=V[le],W=H[ne%H.length];let U=[`%c[${q}]%c[${String(B).padStart(7," ")}]%c[len: ${String(Z).padStart(5," ")}]%c${String(ne).padStart(5," ")} - ${ee}`,"color: darkgreen","color: grey","color: grey",`color: ${W}`];/\($/.test(ee)?(U=U.concat(K),U.push(")")):U.push(K),console.log.apply(console,U)}class te{constructor(B,Z){this._outgoingPrefix=B,this._incomingPrefix=Z,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(B,Z,ne,le,ee){this._totalOutgoing+=B,j(this._outgoingPrefix,this._totalOutgoing,B,Z,ne,le,ee)}logIncoming(B,Z,ne,le,ee){this._totalIncoming+=B,j(this._incomingPrefix,this._totalIncoming,B,Z,ne,le,ee)}}e.IPCLogger=te}),define(he[72],fe([0,1,14,3,2,43]),function(ce,e,R,a,_,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var k;(function(t){t.Created="created",t.Read="read",t.Write="write",t.Open="open",t.Error="error",t.Close="close",t.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",t.NodeEndReceived="nodeEndReceived",t.NodeEndSent="nodeEndSent",t.NodeDrainBegin="nodeDrainBegin",t.NodeDrainEnd="nodeDrainEnd",t.zlibInflateError="zlibInflateError",t.zlibInflateData="zlibInflateData",t.zlibInflateInitialWrite="zlibInflateInitialWrite",t.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",t.zlibInflateWrite="zlibInflateWrite",t.zlibInflateFlushFired="zlibInflateFlushFired",t.zlibDeflateError="zlibDeflateError",t.zlibDeflateData="zlibDeflateData",t.zlibDeflateWrite="zlibDeflateWrite",t.zlibDeflateFlushFired="zlibDeflateFlushFired",t.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",t.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",t.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",t.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",t.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",t.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",t.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",t.ProtocolHeaderRead="protocolHeaderRead",t.ProtocolMessageRead="protocolMessageRead",t.ProtocolHeaderWrite="protocolHeaderWrite",t.ProtocolMessageWrite="protocolMessageWrite",t.ProtocolWrite="protocolWrite"})(k||(e.SocketDiagnosticsEventType=k={}));var L;(function(t){t.enableDiagnostics=!1,t.records=[];const s=new WeakMap;let r=0;function o(y,A){if(!s.has(y)){const b=String(++r);s.set(y,b)}return s.get(y)}function h(y,A,b,w){if(!t.enableDiagnostics)return;const O=o(y,A);if(w instanceof R.VSBuffer||w instanceof Uint8Array||w instanceof ArrayBuffer||ArrayBuffer.isView(w)){const F=R.VSBuffer.alloc(w.byteLength);F.set(w),t.records.push({timestamp:Date.now(),id:O,label:A,type:b,buff:F})}else t.records.push({timestamp:Date.now(),id:O,label:A,type:b,data:w})}t.traceSocketEvent=h})(L||(e.SocketDiagnostics=L={}));var D;(function(t){t[t.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",t[t.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(D||(e.SocketCloseEventType=D={}));let E=null;function P(){return E||(E=R.VSBuffer.alloc(0)),E}class S{get byteLength(){return this._totalLength}constructor(){this._chunks=[],this._totalLength=0}acceptChunk(s){this._chunks.push(s),this._totalLength+=s.byteLength}read(s){return this._read(s,!0)}peek(s){return this._read(s,!1)}_read(s,r){if(s===0)return P();if(s>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===s){const A=this._chunks[0];return r&&(this._chunks.shift(),this._totalLength-=s),A}if(this._chunks[0].byteLength>s){const A=this._chunks[0].slice(0,s);return r&&(this._chunks[0]=this._chunks[0].slice(s),this._totalLength-=s),A}const o=R.VSBuffer.alloc(s);let h=0,y=0;for(;s>0;){const A=this._chunks[y];if(A.byteLength>s){const b=A.slice(0,s);o.set(b,h),h+=s,r&&(this._chunks[y]=A.slice(s),this._totalLength-=s),s-=s}else o.set(A,h),h+=A.byteLength,r?(this._chunks.shift(),this._totalLength-=A.byteLength):y++,s-=A.byteLength}return o}}e.ChunkStream=S;var m;(function(t){t[t.None=0]="None",t[t.Regular=1]="Regular",t[t.Control=2]="Control",t[t.Ack=3]="Ack",t[t.Disconnect=5]="Disconnect",t[t.ReplayRequest=6]="ReplayRequest",t[t.Pause=7]="Pause",t[t.Resume=8]="Resume",t[t.KeepAlive=9]="KeepAlive"})(m||(m={}));function d(t){switch(t){case m.None:return"None";case m.Regular:return"Regular";case m.Control:return"Control";case m.Ack:return"Ack";case m.Disconnect:return"Disconnect";case m.ReplayRequest:return"ReplayRequest";case m.Pause:return"PauseWriting";case m.Resume:return"ResumeWriting";case m.KeepAlive:return"KeepAlive"}}var l;(function(t){t[t.HeaderLength=13]="HeaderLength",t[t.AcknowledgeTime=2e3]="AcknowledgeTime",t[t.TimeoutTime=2e4]="TimeoutTime",t[t.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",t[t.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",t[t.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(l||(e.ProtocolConstants=l={}));class g{constructor(s,r,o,h){this.type=s,this.id=r,this.ack=o,this.data=h,this.writtenTime=0}get size(){return this.data.byteLength}}class I extends _.Disposable{constructor(s){super(),this._onMessage=this._register(new a.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:l.HeaderLength,messageType:m.None,id:0,ack:0},this._socket=s,this._isDisposed=!1,this._incomingData=new S,this._register(this._socket.onData(r=>this.acceptChunk(r))),this.lastReadTime=Date.now()}acceptChunk(s){if(!(!s||s.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(s);this._incomingData.byteLength>=this._state.readLen;){const r=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=r.readUInt32BE(9),this._state.messageType=r.readUInt8(0),this._state.id=r.readUInt32BE(1),this._state.ack=r.readUInt32BE(5),this._socket.traceSocketEvent(k.ProtocolHeaderRead,{messageType:d(this._state.messageType),id:this._state.id,ack:this._state.ack,messageSize:this._state.readLen});else{const o=this._state.messageType,h=this._state.id,y=this._state.ack;if(this._state.readHead=!0,this._state.readLen=l.HeaderLength,this._state.messageType=m.None,this._state.id=0,this._state.ack=0,this._socket.traceSocketEvent(k.ProtocolMessageRead,r),this._onMessage.fire(new g(o,h,y,r)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class v{constructor(s){this._writeNowTimeout=null,this._isDisposed=!1,this._isPaused=!1,this._socket=s,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}pause(){this._isPaused=!0}resume(){this._isPaused=!1,this._scheduleWriting()}write(s){if(this._isDisposed)return;s.writtenTime=Date.now(),this.lastWriteTime=Date.now();const r=R.VSBuffer.alloc(l.HeaderLength);r.writeUInt8(s.type,0),r.writeUInt32BE(s.id,1),r.writeUInt32BE(s.ack,5),r.writeUInt32BE(s.data.byteLength,9),this._socket.traceSocketEvent(k.ProtocolHeaderWrite,{messageType:d(s.type),id:s.id,ack:s.ack,messageSize:s.data.byteLength}),this._socket.traceSocketEvent(k.ProtocolMessageWrite,s.data),this._writeSoon(r,s.data)}_bufferAdd(s,r){const o=this._totalLength===0;return this._data.push(s,r),this._totalLength+=s.byteLength+r.byteLength,o}_bufferTake(){const s=R.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,s}_writeSoon(s,r){this._bufferAdd(s,r)&&this._scheduleWriting()}_scheduleWriting(){this._writeNowTimeout||(this._writeNowTimeout=setTimeout(()=>{this._writeNowTimeout=null,this._writeNow()}))}_writeNow(){if(this._totalLength===0||this._isPaused)return;const s=this._bufferTake();this._socket.traceSocketEvent(k.ProtocolWrite,{byteLength:s.byteLength}),this._socket.write(s)}}class f extends _.Disposable{constructor(s){super(),this._onMessage=new a.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new a.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=s,this._socketWriter=this._register(new v(this._socket)),this._socketReader=this._register(new I(this._socket)),this._register(this._socketReader.onMessage(r=>{r.type===m.Regular&&this._onMessage.fire(r.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(s){this._socketWriter.write(new g(m.Regular,0,0,s))}}e.Protocol=f;class C extends T.IPCClient{static fromSocket(s,r){return new C(new f(s),r)}get onDidDispose(){return this.protocol.onDidDispose}constructor(s,r,o=null){super(s,r,o),this.protocol=s}dispose(){super.dispose();const s=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),s.end()}}e.Client=C;class p{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new a.Emitter({onWillAddFirstListener:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onDidRemoveLastListener:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(s){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(s):this._emitter.fire(s):this._bufferedMessages.push(s)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=p;class c{constructor(s){this.data=s,this.next=null}}class u{constructor(){this._first=null,this._last=null}length(){let s=0,r=this._first;for(;r;)r=r.next,s++;return s}peek(){return this._first?this._first.data:null}toArray(){const s=[];let r=0,o=this._first;for(;o;)s[r++]=o.data,o=o.next;return s}pop(){if(this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(s){const r=new c(s);if(!this._first){this._first=r,this._last=r;return}this._last.next=r,this._last=r}}class i{static{this._HISTORY_LENGTH=10}static{this._INSTANCE=null}static getInstance(){return i._INSTANCE||(i._INSTANCE=new i),i._INSTANCE}constructor(){this.lastRuns=[];const s=Date.now();for(let r=0;r<i._HISTORY_LENGTH;r++)this.lastRuns[r]=s-1e3*r;setInterval(()=>{for(let r=i._HISTORY_LENGTH;r>=1;r--)this.lastRuns[r]=this.lastRuns[r-1];this.lastRuns[0]=Date.now()},1e3)}load(){const s=Date.now(),r=(1+i._HISTORY_LENGTH)*1e3;let o=0;for(let h=0;h<i._HISTORY_LENGTH;h++)s-this.lastRuns[h]<=r&&o++;return 1-o/i._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}class n{get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}constructor(s){this._onControlMessage=new p,this.onControlMessage=this._onControlMessage.event,this._onMessage=new p,this.onMessage=this._onMessage.event,this._onDidDispose=new p,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new p,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new p,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=s.loadEstimator??i.getInstance(),this._shouldSendKeepAlive=s.sendKeepAlive??!0,this._isReconnecting=!1,this._outgoingUnackMsg=new u,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socketDisposables=new _.DisposableStore,this._socket=s.socket,this._socketWriter=this._socketDisposables.add(new v(this._socket)),this._socketReader=this._socketDisposables.add(new I(this._socket)),this._socketDisposables.add(this._socketReader.onMessage(r=>this._receiveMessage(r))),this._socketDisposables.add(this._socket.onClose(r=>this._onSocketClose.fire(r))),s.initialChunk&&this._socketReader.acceptChunk(s.initialChunk),this._shouldSendKeepAlive?this._keepAliveInterval=setInterval(()=>{this._sendKeepAlive()},l.KeepAliveSendTime):this._keepAliveInterval=null}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._keepAliveInterval&&(clearInterval(this._keepAliveInterval),this._keepAliveInterval=null),this._socketDisposables.dispose()}drain(){return this._socketWriter.drain()}sendDisconnect(){if(!this._didSendDisconnect){this._didSendDisconnect=!0;const s=new g(m.Disconnect,0,0,P());this._socketWriter.write(s),this._socketWriter.flush()}}sendPause(){const s=new g(m.Pause,0,0,P());this._socketWriter.write(s)}sendResume(){const s=new g(m.Resume,0,0,P());this._socketWriter.write(s)}pauseSocketWriting(){this._socketWriter.pause()}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(s,r){this._isReconnecting=!0,this._socketDisposables.dispose(),this._socketDisposables=new _.DisposableStore,this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socket=s,this._socketWriter=this._socketDisposables.add(new v(this._socket)),this._socketReader=this._socketDisposables.add(new I(this._socket)),this._socketDisposables.add(this._socketReader.onMessage(o=>this._receiveMessage(o))),this._socketDisposables.add(this._socket.onClose(o=>this._onSocketClose.fire(o))),this._socketReader.acceptChunk(r)}endAcceptReconnection(){this._isReconnecting=!1,this._incomingAckId=this._incomingMsgId;const s=new g(m.Ack,0,this._incomingAckId,P());this._socketWriter.write(s);const r=this._outgoingUnackMsg.toArray();for(let o=0,h=r.length;o<h;o++)this._socketWriter.write(r[o]);this._recvAckCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(s){if(s.ack>this._outgoingAckId){this._outgoingAckId=s.ack;do{const r=this._outgoingUnackMsg.peek();if(r&&r.id<=s.ack)this._outgoingUnackMsg.pop();else break}while(!0)}switch(s.type){case m.None:break;case m.Regular:{if(s.id>this._incomingMsgId)if(s.id!==this._incomingMsgId+1){const r=Date.now();r-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=r,this._socketWriter.write(new g(m.ReplayRequest,0,0,P())))}else this._incomingMsgId=s.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(s.data);break}case m.Control:{this._onControlMessage.fire(s.data);break}case m.Ack:break;case m.Disconnect:{this._onDidDispose.fire();break}case m.ReplayRequest:{const r=this._outgoingUnackMsg.toArray();for(let o=0,h=r.length;o<h;o++)this._socketWriter.write(r[o]);this._recvAckCheck();break}case m.Pause:{this._socketWriter.pause();break}case m.Resume:{this._socketWriter.resume();break}case m.KeepAlive:break}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(s){const r=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const o=new g(m.Regular,r,this._incomingAckId,s);this._outgoingUnackMsg.push(o),this._isReconnecting||(this._socketWriter.write(o),this._recvAckCheck())}sendControl(s){const r=new g(m.Control,0,0,s);this._socketWriter.write(r)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const s=Date.now()-this._incomingMsgLastTime;if(s>=l.AcknowledgeTime){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},l.AcknowledgeTime-s+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const s=this._outgoingUnackMsg.peek(),r=Date.now()-s.writtenTime,o=Date.now()-this._socketReader.lastReadTime,h=Date.now()-this._lastSocketTimeoutTime;if(r>=l.TimeoutTime&&o>=l.TimeoutTime&&h>=l.TimeoutTime&&!this._loadEstimator.hasHighLoad()){this._lastSocketTimeoutTime=Date.now(),this._onSocketTimeout.fire({unacknowledgedMsgCount:this._outgoingUnackMsg.length(),timeSinceOldestUnacknowledgedMsg:r,timeSinceLastReceivedSomeData:o});return}const y=Math.max(l.TimeoutTime-r,l.TimeoutTime-o,l.TimeoutTime-h,500);this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},y)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const s=new g(m.Ack,0,this._incomingAckId,P());this._socketWriter.write(s)}_sendKeepAlive(){this._incomingAckId=this._incomingMsgId;const s=new g(m.KeepAlive,0,this._incomingAckId,P());this._socketWriter.write(s)}}e.PersistentProtocol=n}),define(he[97],fe([0,1,70,6,14,25,147,8,3,2,29,152,94,43]),function(ce,e,R,a,_,T,k,L,D,E,P,S,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0,L=De(L);class l extends d.ChannelServer{constructor(v){super({send:f=>{try{process.send?.(f.buffer.toString("base64"))}catch{}},onMessage:D.Event.fromNodeEventEmitter(process,"message",f=>_.VSBuffer.wrap(Buffer.from(f,"base64")))},v),process.once("disconnect",()=>this.dispose())}}e.Server=l;class g{constructor(v,f){this.modulePath=v,this.options=f,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new D.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const C=f&&f.timeout?f.timeout:6e4;this.disposeDelayer=new a.Delayer(C),this.child=null,this._client=null}getChannel(v){const f=this;return{call(C,p,c){return f.requestPromise(v,C,p,c)},listen(C,p){return f.requestEvent(v,C,p)}}}requestPromise(v,f,C,p=T.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(p.isCancellationRequested)return Promise.reject(L.canceled());this.disposeDelayer.cancel();const c=this.getCachedChannel(v),u=(0,a.createCancelablePromise)(t=>c.call(f,C,t)),i=p.onCancellationRequested(()=>u.cancel()),n=(0,E.toDisposable)(()=>u.cancel());return this.activeRequests.add(n),u.finally(()=>{i.dispose(),this.activeRequests.delete(n),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),u}requestEvent(v,f,C){if(!this.disposeDelayer)return D.Event.None;this.disposeDelayer.cancel();let p;const c=new D.Emitter({onWillAddFirstListener:()=>{p=this.getCachedChannel(v).listen(f,C)(c.fire,c),this.activeRequests.add(p)},onDidRemoveLastListener:()=>{this.activeRequests.delete(p),p.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return c.event}get client(){if(!this._client){const v=this.options&&this.options.args?this.options.args:[],f=Object.create(null);f.env={...(0,P.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(f.env={...f.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(f.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(f.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(f.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),f.execArgv===void 0&&(f.execArgv=process.execArgv.filter(r=>!/^--inspect(-brk)?=/.test(r)).filter(r=>!r.startsWith("--vscode-"))),(0,m.removeDangerousEnvVariables)(f.env),this.child=(0,R.fork)(this.modulePath,v,f);const C=new D.Emitter,c=D.Event.fromNodeEventEmitter(this.child,"message",r=>r)(r=>{if((0,k.isRemoteConsoleLog)(r)){(0,k.log)(r,`IPC Library: ${this.options.serverName}`);return}C.fire(_.VSBuffer.wrap(Buffer.from(r,"base64")))}),u=this.options.useQueue?(0,S.createQueuedSender)(this.child):this.child,i=r=>this.child&&this.child.connected&&u.send(r.buffer.toString("base64")),n=C.event,t={send:i,onMessage:n};this._client=new d.ChannelClient(t);const s=()=>this.disposeClient();process.once("exit",s),this.child.on("error",r=>console.warn('IPC "'+this.options.serverName+'" errored with '+r)),this.child.on("exit",(r,o)=>{process.removeListener("exit",s),c.dispose(),this.activeRequests.forEach(h=>(0,E.dispose)(h)),this.activeRequests.clear(),r!==0&&o!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+r+" and signal "+o),this.disposeDelayer?.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:r,signal:o})})}return this._client}getCachedChannel(v){let f=this.channels.get(v);return f||(f=this.client.getChannel(v),this.channels.set(v,f)),f}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer?.cancel(),this.disposeDelayer=void 0,this.disposeClient(),this.activeRequests.clear()}}e.Client=g}),define(he[154],fe([0,1,143,14,43,3,12,17]),function(ce,e,R,a,_,T,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0,e.once=P;class D{constructor(m){this.port=m,this.onMessage=T.Event.fromNodeEventEmitter(this.port,"message",d=>d.data?a.VSBuffer.wrap(d.data):a.VSBuffer.alloc(0)),m.start()}send(m){this.port.postMessage(m.buffer)}disconnect(){this.port.close()}}class E extends _.IPCServer{static getOnDidClientConnect(m){(0,k.assertType)((0,R.isUtilityProcess)(process),"Electron Utility Process");const d=new T.Emitter;return process.parentPort.on("message",l=>{if(m?.handledClientConnection(l))return;const g=(0,L.firstOrDefault)(l.ports);g&&d.fire(g)}),T.Event.map(d.event,l=>({protocol:new D(l),onDidClientDisconnect:T.Event.fromNodeEventEmitter(l,"close")}))}constructor(m){super(E.getOnDidClientConnect(m))}}e.Server=E;function P(S,m,d){const l=g=>{g.data===m&&(S.removeListener("message",l),d())};S.on("message",l)}}),define(he[73],fe([0,1,6,3,2,68,12]),function(ce,e,R,a,_,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.StorageHint=void 0,e.isStorageItemsChangeEvent=D;var L;(function(m){m[m.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",m[m.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(L||(e.StorageHint=L={}));function D(m){const d=m;return d?.changed instanceof Map||d?.deleted instanceof Set}var E;(function(m){m[m.None=0]="None",m[m.Initialized=1]="Initialized",m[m.Closed=2]="Closed"})(E||(e.StorageState=E={}));class P extends _.Disposable{static{this.DEFAULT_FLUSH_DELAY=100}constructor(d,l=Object.create(null)){super(),this.database=d,this.options=l,this._onDidChangeStorage=this._register(new a.PauseableEmitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=E.None,this.cache=new Map,this.flushDelayer=this._register(new R.ThrottledDelayer(P.DEFAULT_FLUSH_DELAY)),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(d=>this.onDidChangeItemsExternal(d)))}onDidChangeItemsExternal(d){this._onDidChangeStorage.pause();try{d.changed?.forEach((l,g)=>this.acceptExternal(g,l)),d.deleted?.forEach(l=>this.acceptExternal(l,void 0))}finally{this._onDidChangeStorage.resume()}}acceptExternal(d,l){if(this.state===E.Closed)return;let g=!1;(0,k.isUndefinedOrNull)(l)?g=this.cache.delete(d):this.cache.get(d)!==l&&(this.cache.set(d,l),g=!0),g&&this._onDidChangeStorage.fire({key:d,external:!0})}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===E.None&&(this.state=E.Initialized,this.options.hint!==L.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(d,l){const g=this.cache.get(d);return(0,k.isUndefinedOrNull)(g)?l:g}getBoolean(d,l){const g=this.get(d);return(0,k.isUndefinedOrNull)(g)?l:g==="true"}getNumber(d,l){const g=this.get(d);return(0,k.isUndefinedOrNull)(g)?l:parseInt(g,10)}getObject(d,l){const g=this.get(d);return(0,k.isUndefinedOrNull)(g)?l:(0,T.parse)(g)}async set(d,l,g=!1){if(this.state===E.Closed)return;if((0,k.isUndefinedOrNull)(l))return this.delete(d,g);const I=(0,k.isObject)(l)||Array.isArray(l)?(0,T.stringify)(l):String(l);if(this.cache.get(d)!==I)return this.cache.set(d,I),this.pendingInserts.set(d,I),this.pendingDeletes.delete(d),this._onDidChangeStorage.fire({key:d,external:g}),this.doFlush()}async delete(d,l=!1){if(!(this.state===E.Closed||!this.cache.delete(d)))return this.pendingDeletes.has(d)||this.pendingDeletes.add(d),this.pendingInserts.delete(d),this._onDidChangeStorage.fire({key:d,external:l}),this.doFlush()}async optimize(){if(this.state!==E.Closed)return await this.flush(0),this.database.optimize()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=E.Closed;try{await this.doFlush(0)}catch{}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const d={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(d).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(d){if(!(this.state===E.Closed||this.pendingClose))return this.doFlush(d)}async doFlush(d){return this.options.hint===L.STORAGE_IN_MEMORY?this.flushPending():this.flushDelayer.trigger(()=>this.flushPending(),d)}async whenFlushed(){if(this.hasPending)return new Promise(d=>this.whenFlushedCallbacks.push(d))}isInMemory(){return this.options.hint===L.STORAGE_IN_MEMORY}}e.Storage=P;class S{constructor(){this.onDidChangeItemsExternal=a.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(d){d.insert?.forEach((l,g)=>this.items.set(g,l)),d.delete?.forEach(l=>this.items.delete(l))}async optimize(){}async close(){}}e.InMemoryStorageDatabase=S}),define(he[155],fe([0,1,39,8,9]),function(ce,e,R,a,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Scanner=e.TokenType=void 0;var T;(function(P){P[P.LParen=0]="LParen",P[P.RParen=1]="RParen",P[P.Neg=2]="Neg",P[P.Eq=3]="Eq",P[P.NotEq=4]="NotEq",P[P.Lt=5]="Lt",P[P.LtEq=6]="LtEq",P[P.Gt=7]="Gt",P[P.GtEq=8]="GtEq",P[P.RegexOp=9]="RegexOp",P[P.RegexStr=10]="RegexStr",P[P.True=11]="True",P[P.False=12]="False",P[P.In=13]="In",P[P.Not=14]="Not",P[P.And=15]="And",P[P.Or=16]="Or",P[P.Str=17]="Str",P[P.QuotedStr=18]="QuotedStr",P[P.Error=19]="Error",P[P.EOF=20]="EOF"})(T||(e.TokenType=T={}));function k(...P){switch(P.length){case 1:return(0,_.localize)(1693,null,P[0]);case 2:return(0,_.localize)(1694,null,P[0],P[1]);case 3:return(0,_.localize)(1695,null,P[0],P[1],P[2]);default:return}}const L=(0,_.localize)(1696,null),D=(0,_.localize)(1697,null);class E{constructor(){this._input="",this._start=0,this._current=0,this._tokens=[],this._errors=[],this.stringRe=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(S){switch(S.type){case T.LParen:return"(";case T.RParen:return")";case T.Neg:return"!";case T.Eq:return S.isTripleEq?"===":"==";case T.NotEq:return S.isTripleEq?"!==":"!=";case T.Lt:return"<";case T.LtEq:return"<=";case T.Gt:return">=";case T.GtEq:return">=";case T.RegexOp:return"=~";case T.RegexStr:return S.lexeme;case T.True:return"true";case T.False:return"false";case T.In:return"in";case T.Not:return"not";case T.And:return"&&";case T.Or:return"||";case T.Str:return S.lexeme;case T.QuotedStr:return S.lexeme;case T.Error:return S.lexeme;case T.EOF:return"EOF";default:throw(0,a.illegalState)(`unhandled token type: ${JSON.stringify(S)}; have you forgotten to add a case?`)}}static{this._regexFlags=new Set(["i","g","s","m","y","u"].map(S=>S.charCodeAt(0)))}static{this._keywords=new Map([["not",T.Not],["in",T.In],["false",T.False],["true",T.True]])}get errors(){return this._errors}reset(S){return this._input=S,this._start=0,this._current=0,this._tokens=[],this._errors=[],this}scan(){for(;!this._isAtEnd();)switch(this._start=this._current,this._advance()){case R.CharCode.OpenParen:this._addToken(T.LParen);break;case R.CharCode.CloseParen:this._addToken(T.RParen);break;case R.CharCode.ExclamationMark:if(this._match(R.CharCode.Equals)){const m=this._match(R.CharCode.Equals);this._tokens.push({type:T.NotEq,offset:this._start,isTripleEq:m})}else this._addToken(T.Neg);break;case R.CharCode.SingleQuote:this._quotedString();break;case R.CharCode.Slash:this._regex();break;case R.CharCode.Equals:if(this._match(R.CharCode.Equals)){const m=this._match(R.CharCode.Equals);this._tokens.push({type:T.Eq,offset:this._start,isTripleEq:m})}else this._match(R.CharCode.Tilde)?this._addToken(T.RegexOp):this._error(k("==","=~"));break;case R.CharCode.LessThan:this._addToken(this._match(R.CharCode.Equals)?T.LtEq:T.Lt);break;case R.CharCode.GreaterThan:this._addToken(this._match(R.CharCode.Equals)?T.GtEq:T.Gt);break;case R.CharCode.Ampersand:this._match(R.CharCode.Ampersand)?this._addToken(T.And):this._error(k("&&"));break;case R.CharCode.Pipe:this._match(R.CharCode.Pipe)?this._addToken(T.Or):this._error(k("||"));break;case R.CharCode.Space:case R.CharCode.CarriageReturn:case R.CharCode.Tab:case R.CharCode.LineFeed:case R.CharCode.NoBreakSpace:break;default:this._string()}return this._start=this._current,this._addToken(T.EOF),Array.from(this._tokens)}_match(S){return this._isAtEnd()||this._input.charCodeAt(this._current)!==S?!1:(this._current++,!0)}_advance(){return this._input.charCodeAt(this._current++)}_peek(){return this._isAtEnd()?R.CharCode.Null:this._input.charCodeAt(this._current)}_addToken(S){this._tokens.push({type:S,offset:this._start})}_error(S){const m=this._start,d=this._input.substring(this._start,this._current),l={type:T.Error,offset:this._start,lexeme:d};this._errors.push({offset:m,lexeme:d,additionalInfo:S}),this._tokens.push(l)}_string(){this.stringRe.lastIndex=this._start;const S=this.stringRe.exec(this._input);if(S){this._current=this._start+S[0].length;const m=this._input.substring(this._start,this._current),d=E._keywords.get(m);d?this._addToken(d):this._tokens.push({type:T.Str,lexeme:m,offset:this._start})}}_quotedString(){for(;this._peek()!==R.CharCode.SingleQuote&&!this._isAtEnd();)this._advance();if(this._isAtEnd()){this._error(L);return}this._advance(),this._tokens.push({type:T.QuotedStr,lexeme:this._input.substring(this._start+1,this._current-1),offset:this._start+1})}_regex(){let S=this._current,m=!1,d=!1;for(;;){if(S>=this._input.length){this._current=S,this._error(D);return}const g=this._input.charCodeAt(S);if(m)m=!1;else if(g===R.CharCode.Slash&&!d){S++;break}else g===R.CharCode.OpenSquareBracket?d=!0:g===R.CharCode.Backslash?m=!0:g===R.CharCode.CloseSquareBracket&&(d=!1);S++}for(;S<this._input.length&&E._regexFlags.has(this._input.charCodeAt(S));)S++;this._current=S;const l=this._input.substring(this._start,this._current);this._tokens.push({type:T.RegexStr,lexeme:l,offset:this._start})}_isAtEnd(){return this._current>=this._input.length}}e.Scanner=E}),define(he[156],fe([0,1,67,88,22,13,37,20,10]),function(ce,e,R,a,_,T,k,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractNativeEnvironmentService=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=void 0,e.parseExtensionHostDebugPort=P,e.parseDebugParams=S,e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=/^([^.]+\..+)[:=](.+)$/;class E{get appRoot(){return(0,T.dirname)(_.FileAccess.asFileUri("").fsPath)}get userHome(){return D.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return D.URI.file((0,T.join)(this.userDataPath,"User"))}get tmpDir(){return D.URI.file(this.paths.tmpDir)}get cacheHome(){return D.URI.file(this.userDataPath)}get stateResource(){return(0,L.joinPath)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:_.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,L.joinPath)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const d=(0,R.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,T.join)(this.userDataPath,"logs",d)}return D.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,L.joinPath)(D.URI.file((0,T.join)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,L.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,L.joinPath)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,L.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const d=k.env.VSCODE_PORTABLE;return d?D.URI.file((0,T.join)(d,"argv.json")):(0,L.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return D.URI.file((0,T.join)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const d=this.args["builtin-extensions-dir"];return d?(0,T.resolve)(d):(0,T.normalize)((0,T.join)(_.FileAccess.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const d=this.args["extensions-download-dir"];return d?D.URI.file((0,T.resolve)(d)):D.URI.file((0,T.join)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const d=this.args["extensions-dir"];if(d)return(0,T.resolve)(d);const l=k.env.VSCODE_EXTENSIONS;if(l)return l;const g=k.env.VSCODE_PORTABLE;return g?(0,T.join)(g,"extensions"):(0,L.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const d=this.args.extensionDevelopmentPath;if(Array.isArray(d))return d.map(l=>/^[^:/?#]+?:\/\//.test(l)?D.URI.parse(l):D.URI.file((0,T.normalize)(l)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(d=>d==="ui"||d==="workspace"||d==="web"?d:"workspace")}get extensionTestsLocationURI(){const d=this.args.extensionTestsPath;if(d)return/^[^:/?#]+?:\/\//.test(d)?D.URI.parse(d):D.URI.file((0,T.normalize)(d))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const d=this.args["disable-extension"];if(d){if(typeof d=="string")return[d];if(Array.isArray(d)&&d.length>0)return d}return!1}get debugExtensionHost(){return P(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!k.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(d=>!e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.test(d))}get extensionLogLevel(){const d=[];for(const l of this.args.log||[]){const g=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.exec(l);g&&g[1]&&g[2]&&d.push([g[1],g[2]])}return d.length?d:void 0}get serviceMachineIdResource(){return(0,L.joinPath)(D.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const d=k.env.VSCODE_PORTABLE;return d?D.URI.file((0,T.join)(d,"policy.json")):(0,L.joinPath)(this.userHome,this.productService.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(d){this.args.continueOn=d}get args(){return this._args}constructor(d,l,g){this._args=d,this.paths=l,this.productService=g,this.editSessionId=this.args.editSessionId}}e.AbstractNativeEnvironmentService=E,Ie([a.memoize],E.prototype,"appRoot",null),Ie([a.memoize],E.prototype,"userHome",null),Ie([a.memoize],E.prototype,"userDataPath",null),Ie([a.memoize],E.prototype,"appSettingsHome",null),Ie([a.memoize],E.prototype,"tmpDir",null),Ie([a.memoize],E.prototype,"cacheHome",null),Ie([a.memoize],E.prototype,"stateResource",null),Ie([a.memoize],E.prototype,"userRoamingDataHome",null),Ie([a.memoize],E.prototype,"userDataSyncHome",null),Ie([a.memoize],E.prototype,"sync",null),Ie([a.memoize],E.prototype,"machineSettingsResource",null),Ie([a.memoize],E.prototype,"workspaceStorageHome",null),Ie([a.memoize],E.prototype,"localHistoryHome",null),Ie([a.memoize],E.prototype,"keyboardLayoutResource",null),Ie([a.memoize],E.prototype,"argvResource",null),Ie([a.memoize],E.prototype,"isExtensionDevelopment",null),Ie([a.memoize],E.prototype,"untitledWorkspacesHome",null),Ie([a.memoize],E.prototype,"builtinExtensionsPath",null),Ie([a.memoize],E.prototype,"extensionsPath",null),Ie([a.memoize],E.prototype,"extensionDevelopmentLocationURI",null),Ie([a.memoize],E.prototype,"extensionDevelopmentKind",null),Ie([a.memoize],E.prototype,"extensionTestsLocationURI",null),Ie([a.memoize],E.prototype,"debugExtensionHost",null),Ie([a.memoize],E.prototype,"logLevel",null),Ie([a.memoize],E.prototype,"extensionLogLevel",null),Ie([a.memoize],E.prototype,"serviceMachineIdResource",null),Ie([a.memoize],E.prototype,"disableTelemetry",null),Ie([a.memoize],E.prototype,"disableWorkspaceTrust",null),Ie([a.memoize],E.prototype,"useInMemorySecretStorage",null),Ie([a.memoize],E.prototype,"policyFile",null);function P(m,d){return S(m["inspect-extensions"],m["inspect-brk-extensions"],5870,d,m.debugId,m.extensionEnvironment)}function S(m,d,l,g,I,v){const C=Number(d||m)||(g?null:l),p=C?!!d:!1;let c;if(v)try{c=JSON.parse(v)}catch{}return{port:C,break:p,debugId:I,env:c}}}),function(){function ce(e,R,a){function _(k,L){const D=T(k,L),E=[D];return e.isAbsolute(D)||E.unshift(a),e.resolve(...E)}function T(k,L){process.env.VSCODE_DEV&&(L="code-oss-dev");const D=process.env.VSCODE_PORTABLE;if(D)return e.join(D,"user-data");let E=process.env.VSCODE_APPDATA;if(E)return e.join(E,L);const P=k["user-data-dir"];if(P)return P;switch(process.platform){case"win32":if(E=process.env.APPDATA,!E){const S=process.env.USERPROFILE;if(typeof S!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");E=e.join(S,"AppData","Roaming")}break;case"darwin":E=e.join(R.homedir(),"Library","Application Support");break;case"linux":E=process.env.XDG_CONFIG_HOME||e.join(R.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(E,L)}return{getUserDataPath:_}}if(typeof define=="function")define(he[157],fe([245,38,37]),function(e,R,a){return ce(e,R,a.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),R=require("os");module.exports=ce(e,R,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(he[158],fe([0,1,38,156,157]),function(ce,e,R,a,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0,e.parsePtyHostDebugPort=k,e.parseSharedProcessDebugPort=L;class T extends a.AbstractNativeEnvironmentService{constructor(E,P){super(E,{homeDir:(0,R.homedir)(),tmpDir:(0,R.tmpdir)(),userDataDir:(0,_.getUserDataPath)(E,P.nameShort)},P)}}e.NativeEnvironmentService=T;function k(D,E){return(0,a.parseDebugParams)(D["inspect-ptyhost"],D["inspect-brk-ptyhost"],5877,E,D.extensionEnvironment)}function L(D,E){return(0,a.parseDebugParams)(D["inspect-sharedprocess"],D["inspect-brk-sharedprocess"],5879,E,D.extensionEnvironment)}}),define(he[159],fe([0,1,12,9]),function(ce,e,R,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=_;function _(k,L,D,E){try{T(k,L,D,E)}catch(P){k.error(P?.message??P)}return L}function T(k,L,D,E){const P=(S,m,d)=>{const l=S[m];if((0,R.isString)(l)){const g=l,I=g.length;if(I>1&&g[0]==="%"&&g[I-1]==="%"){const v=g.substr(1,I-2);let f=D[v];f===void 0&&E&&(f=E[v]);const C=typeof f=="string"?f:f?.message,p=E?.[v],c=typeof p=="string"?p:p?.message;if(!C){c||k.warn(`[${L.name}]: ${(0,a.localize)(1814,null,v)}`);return}if(d&&(m==="title"||m==="category")&&c&&c!==C){const u={value:C,original:c};S[m]=u}else S[m]=C}}else if((0,R.isObject)(l))for(const g in l)l.hasOwnProperty(g)&&(g==="commands"?P(l,g,!0):P(l,g,d));else if(Array.isArray(l))for(let g=0;g<l.length;g++)P(l,g,d)};for(const S in L)L.hasOwnProperty(S)&&P(L,S)}}),define(he[160],fe([0,1]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionRecommendationNotificationServiceChannel=e.ExtensionRecommendationNotificationServiceChannelClient=void 0;class R{constructor(T){this.channel=T}get ignoredRecommendations(){throw new Error("not supported")}promptImportantExtensionsInstallNotification(T){return this.channel.call("promptImportantExtensionsInstallNotification",[T])}promptWorkspaceRecommendations(T){throw new Error("not supported")}hasToIgnoreRecommendationNotifications(){throw new Error("not supported")}}e.ExtensionRecommendationNotificationServiceChannelClient=R;class a{constructor(T){this.service=T}listen(T,k){throw new Error(`Event not found: ${k}`)}call(T,k,L){switch(k){case"promptImportantExtensionsInstallNotification":return this.service.promptImportantExtensionsInstallNotification(L[0])}throw new Error(`Call not found: ${k}`)}}e.ExtensionRecommendationNotificationServiceChannel=a}),define(he[161],fe([0,1]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0;const R={activeComment:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.activeComment.d.ts"},aiRelatedInformation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts"},aiTextSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiTextSearchProvider.d.ts"},aiTextSearchProviderNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiTextSearchProviderNew.d.ts"},attributableCoverage:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.attributableCoverage.d.ts"},authLearnMore:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authLearnMore.d.ts"},authSession:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts"},canonicalUriProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts"},chatParticipantAdditions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantAdditions.d.ts"},chatParticipantPrivate:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantPrivate.d.ts",version:2},chatProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts"},chatTab:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts"},chatVariableResolver:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariableResolver.d.ts"},codeActionAI:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts"},codeActionRanges:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionRanges.d.ts"},codiconDecoration:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts"},commentReactor:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReactor.d.ts"},commentReveal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReveal.d.ts"},commentThreadApplicability:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentThreadApplicability.d.ts"},commentingRangeHint:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentingRangeHint.d.ts"},commentsDraftState:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts"},contribAccessibilityHelpContent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribAccessibilityHelpContent.d.ts"},contribCommentEditorActionsMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts"},contribCommentPeekContext:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts"},contribCommentThreadAdditionalMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts"},contribCommentsViewThreadMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentsViewThreadMenus.d.ts"},contribDebugCreateConfiguration:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribDebugCreateConfiguration.d.ts"},contribDiffEditorGutterToolBarMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribDiffEditorGutterToolBarMenus.d.ts"},contribEditSessions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts"},contribEditorContentMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts"},contribIssueReporter:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribIssueReporter.d.ts"},contribLabelFormatterWorkspaceTooltip:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts"},contribMenuBarHome:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts"},contribMergeEditorMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts"},contribMultiDiffEditorMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMultiDiffEditorMenus.d.ts"},contribNotebookStaticPreloads:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts"},contribRemoteHelp:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts"},contribShareMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts"},contribSourceControlHistoryItemChangesMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemChangesMenu.d.ts"},contribSourceControlHistoryItemGroupMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemGroupMenu.d.ts"},contribSourceControlHistoryItemMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemMenu.d.ts"},contribSourceControlHistoryTitleMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryTitleMenu.d.ts"},contribSourceControlInputBoxMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts"},contribSourceControlTitleMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlTitleMenu.d.ts"},contribStatusBarItems:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts"},contribViewContainerTitle:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewContainerTitle.d.ts"},contribViewsRemote:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts"},contribViewsWelcome:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts"},createFileSystemWatcher:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts"},customEditorMove:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts"},debugVisualization:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugVisualization.d.ts"},defaultChatParticipant:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatParticipant.d.ts"},diffCommand:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts"},diffContentOptions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts"},documentFiltersExclusive:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts"},documentPaste:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts"},editSessionIdentityProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts"},editorHoverVerbosityLevel:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorHoverVerbosityLevel.d.ts"},editorInsets:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts"},embeddings:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.embeddings.d.ts"},extensionRuntime:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts"},extensionsAny:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts"},externalUriOpener:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts"},fileComments:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts"},fileSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts"},fileSearchProviderNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProviderNew.d.ts"},findFiles2:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2.d.ts"},findFiles2New:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2New.d.ts"},findTextInFiles:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts"},findTextInFilesNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFilesNew.d.ts"},fsChunks:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts"},idToken:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts"},inlineCompletionsAdditions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts"},inlineEdit:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineEdit.d.ts"},interactive:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts"},interactiveWindow:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts"},ipc:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts"},languageModelSystem:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageModelSystem.d.ts"},languageStatusText:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts"},lmTools:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.lmTools.d.ts",version:6},mappedEditsProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts"},multiDocumentHighlightProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.multiDocumentHighlightProvider.d.ts"},newSymbolNamesProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.newSymbolNamesProvider.d.ts"},notebookCellExecution:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecution.d.ts"},notebookCellExecutionState:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts"},notebookControllerAffinityHidden:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts"},notebookDeprecated:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts"},notebookExecution:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts"},notebookKernelSource:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts"},notebookLiveShare:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts"},notebookMessaging:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts"},notebookMime:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts"},notebookReplDocument:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookReplDocument.d.ts"},notebookVariableProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts"},portsAttributes:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts"},profileContentHandlers:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts"},quickDiffProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts"},quickInputButtonLocation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickInputButtonLocation.d.ts"},quickPickItemTooltip:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts"},quickPickSortByLabel:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts"},resolvers:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts"},scmActionButton:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts"},scmHistoryProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts"},scmMultiDiffEditor:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmMultiDiffEditor.d.ts"},scmSelectedProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts"},scmTextDocument:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts"},scmValidation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts"},shareProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts"},showLocal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts"},speech:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts"},tabInputMultiDiff:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputMultiDiff.d.ts"},tabInputTextMerge:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts"},taskPresentationGroup:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts"},telemetry:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts"},terminalDataWriteEvent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts"},terminalDimensions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts"},terminalExecuteCommandEvent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts"},terminalQuickFixProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts"},terminalSelection:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts"},testObserver:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts"},testRelatedCode:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testRelatedCode.d.ts"},textSearchCompleteNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchCompleteNew.d.ts"},textSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts"},textSearchProviderNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProviderNew.d.ts"},timeline:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts"},tokenInformation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts"},treeViewActiveItem:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts"},treeViewMarkdownMessage:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts"},treeViewReveal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts"},tunnelFactory:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts"},tunnels:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts"},workspaceTrust:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"}};e.allApiProposals=Object.freeze(R)}),define(he[74],fe([0,1]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class R{constructor(_,T=[],k=!1){this.ctor=_,this.staticArguments=T,this.supportsDelayedInstantiation=k}}e.SyncDescriptor=R}),define(he[162],fe([0,1,74]),function(ce,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.registerSingleton=T,e.getSingletonServiceDescriptors=k;const a=[];var _;(function(L){L[L.Eager=0]="Eager",L[L.Delayed=1]="Delayed"})(_||(e.InstantiationType=_={}));function T(L,D,E){D instanceof R.SyncDescriptor||(D=new R.SyncDescriptor(D,[],!!E)),a.push([L,D])}function k(){return a}}),define(he[163],fe([0,1]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class R{constructor(T,k){this.key=T,this.data=k,this.incoming=new Map,this.outgoing=new Map}}e.Node=R;class a{constructor(T){this._hashFn=T,this._nodes=new Map}roots(){const T=[];for(const k of this._nodes.values())k.outgoing.size===0&&T.push(k);return T}insertEdge(T,k){const L=this.lookupOrInsertNode(T),D=this.lookupOrInsertNode(k);L.outgoing.set(D.key,D),D.incoming.set(L.key,L)}removeNode(T){const k=this._hashFn(T);this._nodes.delete(k);for(const L of this._nodes.values())L.outgoing.delete(k),L.incoming.delete(k)}lookupOrInsertNode(T){const k=this._hashFn(T);let L=this._nodes.get(k);return L||(L=new R(k,T),this._nodes.set(k,L)),L}lookup(T){return this._nodes.get(this._hashFn(T))}isEmpty(){return this._nodes.size===0}toString(){const T=[];for(const[k,L]of this._nodes)T.push(`${k}
	(-> incoming)[${[...L.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...L.outgoing.keys()].join(",")}]
`);return T.join(`
`)}findCycleSlow(){for(const[T,k]of this._nodes){const L=new Set([T]),D=this._findCycle(k,L);if(D)return D}}_findCycle(T,k){for(const[L,D]of T.outgoing){if(k.has(L))return[...k,L].join(" -> ");k.add(L);const E=this._findCycle(D,k);if(E)return E;k.delete(L)}}}e.Graph=a}),define(he[4],fe([0,1]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IInstantiationService=e._util=void 0,e.createDecorator=_,e.refineServiceDecorator=T;var R;(function(k){k.serviceIds=new Map,k.DI_TARGET="$di$target",k.DI_DEPENDENCIES="$di$dependencies";function L(D){return D[k.DI_DEPENDENCIES]||[]}k.getServiceDependencies=L})(R||(e._util=R={})),e.IInstantiationService=_("instantiationService");function a(k,L,D){L[R.DI_TARGET]===L?L[R.DI_DEPENDENCIES].push({id:k,index:D}):(L[R.DI_DEPENDENCIES]=[{id:k,index:D}],L[R.DI_TARGET]=L)}function _(k){if(R.serviceIds.has(k))return R.serviceIds.get(k);const L=function(D,E,P){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");a(L,D,P)};return L.toString=()=>k,R.serviceIds.set(k,L),L}function T(k){return k}}),define(he[164],fe([0,1,4]),function(ce,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IChecksumService=void 0,e.IChecksumService=(0,R.createDecorator)("checksumService")}),define(he[21],fe([0,1,12,10,4]),function(ce,e,R,a,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.IConfigurationService=void 0,e.isConfigurationOverrides=T,e.isConfigurationUpdateOverrides=k,e.ConfigurationTargetToString=D,e.isConfigured=E,e.toValuesTree=P,e.addToValueTree=S,e.removeFromValueTree=m,e.getConfigurationValue=l,e.merge=g,e.getLanguageTagSettingPlainKey=I,R=De(R),e.IConfigurationService=(0,_.createDecorator)("configurationService");function T(v){return v&&typeof v=="object"&&(!v.overrideIdentifier||typeof v.overrideIdentifier=="string")&&(!v.resource||v.resource instanceof a.URI)}function k(v){return v&&typeof v=="object"&&(!v.overrideIdentifiers||Array.isArray(v.overrideIdentifiers))&&!v.overrideIdentifier&&(!v.resource||v.resource instanceof a.URI)}var L;(function(v){v[v.APPLICATION=1]="APPLICATION",v[v.USER=2]="USER",v[v.USER_LOCAL=3]="USER_LOCAL",v[v.USER_REMOTE=4]="USER_REMOTE",v[v.WORKSPACE=5]="WORKSPACE",v[v.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",v[v.DEFAULT=7]="DEFAULT",v[v.MEMORY=8]="MEMORY"})(L||(e.ConfigurationTarget=L={}));function D(v){switch(v){case L.APPLICATION:return"APPLICATION";case L.USER:return"USER";case L.USER_LOCAL:return"USER_LOCAL";case L.USER_REMOTE:return"USER_REMOTE";case L.WORKSPACE:return"WORKSPACE";case L.WORKSPACE_FOLDER:return"WORKSPACE_FOLDER";case L.DEFAULT:return"DEFAULT";case L.MEMORY:return"MEMORY"}}function E(v){return v.applicationValue!==void 0||v.userValue!==void 0||v.userLocalValue!==void 0||v.userRemoteValue!==void 0||v.workspaceValue!==void 0||v.workspaceFolderValue!==void 0}function P(v,f){const C=Object.create(null);for(const p in v)S(C,p,v[p],f);return C}function S(v,f,C,p){const c=f.split("."),u=c.pop();let i=v;for(let n=0;n<c.length;n++){const t=c[n];let s=i[t];switch(typeof s){case"undefined":s=i[t]=Object.create(null);break;case"object":if(s===null){p(`Ignoring ${f} as ${c.slice(0,n+1).join(".")} is null`);return}break;default:p(`Ignoring ${f} as ${c.slice(0,n+1).join(".")} is ${JSON.stringify(s)}`);return}i=s}if(typeof i=="object"&&i!==null)try{i[u]=C}catch{p(`Ignoring ${f} as ${c.join(".")} is ${JSON.stringify(i)}`)}else p(`Ignoring ${f} as ${c.join(".")} is ${JSON.stringify(i)}`)}function m(v,f){const C=f.split(".");d(v,C)}function d(v,f){const C=f.shift();if(f.length===0){delete v[C];return}if(Object.keys(v).indexOf(C)!==-1){const p=v[C];typeof p=="object"&&!Array.isArray(p)&&(d(p,f),Object.keys(p).length===0&&delete v[C])}}function l(v,f,C){function p(i,n){let t=i;for(const s of n){if(typeof t!="object"||t===null)return;t=t[s]}return t}const c=f.split("."),u=p(v,c);return typeof u>"u"?C:u}function g(v,f,C){Object.keys(f).forEach(p=>{p!=="__proto__"&&(p in v?R.isObject(v[p])&&R.isObject(f[p])?g(v[p],f[p],C):C&&(v[p]=f[p]):v[p]=f[p])})}function I(v){return v.replace(/[\[\]]/g,"")}}),define(he[98],fe([0,1,39,5,26,155,4,9,8]),function(ce,e,R,a,_,T,k,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.ContextKeyExpr=e.Parser=e.ContextKeyExprType=void 0,e.setConstant=P,e.validateWhenClauses=n,e.expressionsAreEqualWithConstantSubstitution=t,e.implies=ee;const E=new Map;E.set("false",!1),E.set("true",!0),E.set("isMac",a.isMacintosh),E.set("isLinux",a.isLinux),E.set("isWindows",a.isWindows),E.set("isWeb",a.isWeb),E.set("isMacNative",a.isMacintosh&&!a.isWeb),E.set("isEdge",a.isEdge),E.set("isFirefox",a.isFirefox),E.set("isChrome",a.isChrome),E.set("isSafari",a.isSafari);function P(W,U){if(E.get(W)!==void 0)throw(0,D.illegalArgument)("contextkey.setConstant(k, v) invoked with already set constant `k`");E.set(W,U)}const S=Object.prototype.hasOwnProperty;var m;(function(W){W[W.False=0]="False",W[W.True=1]="True",W[W.Defined=2]="Defined",W[W.Not=3]="Not",W[W.Equals=4]="Equals",W[W.NotEquals=5]="NotEquals",W[W.And=6]="And",W[W.Regex=7]="Regex",W[W.NotRegex=8]="NotRegex",W[W.Or=9]="Or",W[W.In=10]="In",W[W.NotIn=11]="NotIn",W[W.Greater=12]="Greater",W[W.GreaterEquals=13]="GreaterEquals",W[W.Smaller=14]="Smaller",W[W.SmallerEquals=15]="SmallerEquals"})(m||(e.ContextKeyExprType=m={}));const d={regexParsingWithErrorRecovery:!0},l=(0,L.localize)(1673,null),g=(0,L.localize)(1674,null),I=(0,L.localize)(1675,null),v=(0,L.localize)(1676,null),f=(0,L.localize)(1677,null),C=(0,L.localize)(1678,null),p=(0,L.localize)(1679,null),c=(0,L.localize)(1680,null);class u{static{this._parseError=new Error}get lexingErrors(){return this._scanner.errors}get parsingErrors(){return this._parsingErrors}constructor(U=d){this._config=U,this._scanner=new T.Scanner,this._tokens=[],this._current=0,this._parsingErrors=[],this._flagsGYRe=/g|y/g}parse(U){if(U===""){this._parsingErrors.push({message:l,offset:0,lexeme:"",additionalInfo:g});return}this._tokens=this._scanner.reset(U).scan(),this._current=0,this._parsingErrors=[];try{const G=this._expr();if(!this._isAtEnd()){const oe=this._peek(),Q=oe.type===T.TokenType.Str?C:void 0;throw this._parsingErrors.push({message:f,offset:oe.offset,lexeme:T.Scanner.getLexeme(oe),additionalInfo:Q}),u._parseError}return G}catch(G){if(G!==u._parseError)throw G;return}}_expr(){return this._or()}_or(){const U=[this._and()];for(;this._matchOne(T.TokenType.Or);){const G=this._and();U.push(G)}return U.length===1?U[0]:i.or(...U)}_and(){const U=[this._term()];for(;this._matchOne(T.TokenType.And);){const G=this._term();U.push(G)}return U.length===1?U[0]:i.and(...U)}_term(){if(this._matchOne(T.TokenType.Neg)){const U=this._peek();switch(U.type){case T.TokenType.True:return this._advance(),r.INSTANCE;case T.TokenType.False:return this._advance(),o.INSTANCE;case T.TokenType.LParen:{this._advance();const G=this._expr();return this._consume(T.TokenType.RParen,v),G?.negate()}case T.TokenType.Str:return this._advance(),O.create(U.lexeme);default:throw this._errExpectedButGot("KEY | true | false | '(' expression ')'",U)}}return this._primary()}_primary(){const U=this._peek();switch(U.type){case T.TokenType.True:return this._advance(),i.true();case T.TokenType.False:return this._advance(),i.false();case T.TokenType.LParen:{this._advance();const G=this._expr();return this._consume(T.TokenType.RParen,v),G}case T.TokenType.Str:{const G=U.lexeme;if(this._advance(),this._matchOne(T.TokenType.RegexOp)){const Q=this._peek();if(!this._config.regexParsingWithErrorRecovery){if(this._advance(),Q.type!==T.TokenType.RegexStr)throw this._errExpectedButGot("REGEX",Q);const X=Q.lexeme,x=X.lastIndexOf("/"),$=x===X.length-1?void 0:this._removeFlagsGY(X.substring(x+1));let ie;try{ie=new RegExp(X.substring(1,x),$)}catch{throw this._errExpectedButGot("REGEX",Q)}return J.create(G,ie)}switch(Q.type){case T.TokenType.RegexStr:case T.TokenType.Error:{const X=[Q.lexeme];this._advance();let x=this._peek(),$=0;for(let Ee=0;Ee<Q.lexeme.length;Ee++)Q.lexeme.charCodeAt(Ee)===R.CharCode.OpenParen?$++:Q.lexeme.charCodeAt(Ee)===R.CharCode.CloseParen&&$--;for(;!this._isAtEnd()&&x.type!==T.TokenType.And&&x.type!==T.TokenType.Or;){switch(x.type){case T.TokenType.LParen:$++;break;case T.TokenType.RParen:$--;break;case T.TokenType.RegexStr:case T.TokenType.QuotedStr:for(let Ee=0;Ee<x.lexeme.length;Ee++)x.lexeme.charCodeAt(Ee)===R.CharCode.OpenParen?$++:Q.lexeme.charCodeAt(Ee)===R.CharCode.CloseParen&&$--}if($<0)break;X.push(T.Scanner.getLexeme(x)),this._advance(),x=this._peek()}const ie=X.join(""),ae=ie.lastIndexOf("/"),ue=ae===ie.length-1?void 0:this._removeFlagsGY(ie.substring(ae+1));let Se;try{Se=new RegExp(ie.substring(1,ae),ue)}catch{throw this._errExpectedButGot("REGEX",Q)}return i.regex(G,Se)}case T.TokenType.QuotedStr:{const X=Q.lexeme;this._advance();let x=null;if(!(0,_.isFalsyOrWhitespace)(X)){const $=X.indexOf("/"),ie=X.lastIndexOf("/");if($!==ie&&$>=0){const ae=X.slice($+1,ie),ue=X[ie+1]==="i"?"i":"";try{x=new RegExp(ae,ue)}catch{throw this._errExpectedButGot("REGEX",Q)}}}if(x===null)throw this._errExpectedButGot("REGEX",Q);return J.create(G,x)}default:throw this._errExpectedButGot("REGEX",this._peek())}}if(this._matchOne(T.TokenType.Not)){this._consume(T.TokenType.In,I);const Q=this._value();return i.notIn(G,Q)}switch(this._peek().type){case T.TokenType.Eq:{this._advance();const Q=this._value();if(this._previous().type===T.TokenType.QuotedStr)return i.equals(G,Q);switch(Q){case"true":return i.has(G);case"false":return i.not(G);default:return i.equals(G,Q)}}case T.TokenType.NotEq:{this._advance();const Q=this._value();if(this._previous().type===T.TokenType.QuotedStr)return i.notEquals(G,Q);switch(Q){case"true":return i.not(G);case"false":return i.has(G);default:return i.notEquals(G,Q)}}case T.TokenType.Lt:return this._advance(),V.create(G,this._value());case T.TokenType.LtEq:return this._advance(),z.create(G,this._value());case T.TokenType.Gt:return this._advance(),N.create(G,this._value());case T.TokenType.GtEq:return this._advance(),M.create(G,this._value());case T.TokenType.In:return this._advance(),i.in(G,this._value());default:return i.has(G)}}case T.TokenType.EOF:throw this._parsingErrors.push({message:p,offset:U.offset,lexeme:"",additionalInfo:c}),u._parseError;default:throw this._errExpectedButGot(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this._peek())}}_value(){const U=this._peek();switch(U.type){case T.TokenType.Str:case T.TokenType.QuotedStr:return this._advance(),U.lexeme;case T.TokenType.True:return this._advance(),"true";case T.TokenType.False:return this._advance(),"false";case T.TokenType.In:return this._advance(),"in";default:return""}}_removeFlagsGY(U){return U.replaceAll(this._flagsGYRe,"")}_previous(){return this._tokens[this._current-1]}_matchOne(U){return this._check(U)?(this._advance(),!0):!1}_advance(){return this._isAtEnd()||this._current++,this._previous()}_consume(U,G){if(this._check(U))return this._advance();throw this._errExpectedButGot(G,this._peek())}_errExpectedButGot(U,G,oe){const Q=(0,L.localize)(1681,null,U,T.Scanner.getLexeme(G)),X=G.offset,x=T.Scanner.getLexeme(G);return this._parsingErrors.push({message:Q,offset:X,lexeme:x,additionalInfo:oe}),u._parseError}_check(U){return this._peek().type===U}_peek(){return this._tokens[this._current]}_isAtEnd(){return this._peek().type===T.TokenType.EOF}}e.Parser=u;class i{static false(){return r.INSTANCE}static true(){return o.INSTANCE}static has(U){return h.create(U)}static equals(U,G){return y.create(U,G)}static notEquals(U,G){return w.create(U,G)}static regex(U,G){return J.create(U,G)}static in(U,G){return A.create(U,G)}static notIn(U,G){return b.create(U,G)}static not(U){return O.create(U)}static and(...U){return q.create(U,null,!0)}static or(...U){return B.create(U,null,!0)}static greater(U,G){return N.create(U,G)}static greaterEquals(U,G){return M.create(U,G)}static smaller(U,G){return V.create(U,G)}static smallerEquals(U,G){return z.create(U,G)}static{this._parser=new u({regexParsingWithErrorRecovery:!1})}static deserialize(U){return U==null?void 0:this._parser.parse(U)}}e.ContextKeyExpr=i;function n(W){const U=new u({regexParsingWithErrorRecovery:!1});return W.map(G=>(U.parse(G),U.lexingErrors.length>0?U.lexingErrors.map(oe=>({errorMessage:oe.additionalInfo?(0,L.localize)(1682,null,oe.additionalInfo):(0,L.localize)(1683,null),offset:oe.offset,length:oe.lexeme.length})):U.parsingErrors.length>0?U.parsingErrors.map(oe=>({errorMessage:oe.additionalInfo?`${oe.message}. ${oe.additionalInfo}`:oe.message,offset:oe.offset,length:oe.lexeme.length})):[]))}function t(W,U){const G=W?W.substituteConstants():void 0,oe=U?U.substituteConstants():void 0;return!G&&!oe?!0:!G||!oe?!1:G.equals(oe)}function s(W,U){return W.cmp(U)}class r{static{this.INSTANCE=new r}constructor(){this.type=m.False}cmp(U){return this.type-U.type}equals(U){return U.type===this.type}substituteConstants(){return this}evaluate(U){return!1}serialize(){return"false"}keys(){return[]}map(U){return this}negate(){return o.INSTANCE}}e.ContextKeyFalseExpr=r;class o{static{this.INSTANCE=new o}constructor(){this.type=m.True}cmp(U){return this.type-U.type}equals(U){return U.type===this.type}substituteConstants(){return this}evaluate(U){return!0}serialize(){return"true"}keys(){return[]}map(U){return this}negate(){return r.INSTANCE}}e.ContextKeyTrueExpr=o;class h{static create(U,G=null){const oe=E.get(U);return typeof oe=="boolean"?oe?o.INSTANCE:r.INSTANCE:new h(U,G)}constructor(U,G){this.key=U,this.negated=G,this.type=m.Defined}cmp(U){return U.type!==this.type?this.type-U.type:ne(this.key,U.key)}equals(U){return U.type===this.type?this.key===U.key:!1}substituteConstants(){const U=E.get(this.key);return typeof U=="boolean"?U?o.INSTANCE:r.INSTANCE:this}evaluate(U){return!!U.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(U){return U.mapDefined(this.key)}negate(){return this.negated||(this.negated=O.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=h;class y{static create(U,G,oe=null){if(typeof G=="boolean")return G?h.create(U,oe):O.create(U,oe);const Q=E.get(U);return typeof Q=="boolean"?G===(Q?"true":"false")?o.INSTANCE:r.INSTANCE:new y(U,G,oe)}constructor(U,G,oe){this.key=U,this.value=G,this.negated=oe,this.type=m.Equals}cmp(U){return U.type!==this.type?this.type-U.type:le(this.key,this.value,U.key,U.value)}equals(U){return U.type===this.type?this.key===U.key&&this.value===U.value:!1}substituteConstants(){const U=E.get(this.key);if(typeof U=="boolean"){const G=U?"true":"false";return this.value===G?o.INSTANCE:r.INSTANCE}return this}evaluate(U){return U.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(U){return U.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=w.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=y;class A{static create(U,G){return new A(U,G)}constructor(U,G){this.key=U,this.valueKey=G,this.type=m.In,this.negated=null}cmp(U){return U.type!==this.type?this.type-U.type:le(this.key,this.valueKey,U.key,U.valueKey)}equals(U){return U.type===this.type?this.key===U.key&&this.valueKey===U.valueKey:!1}substituteConstants(){return this}evaluate(U){const G=U.getValue(this.valueKey),oe=U.getValue(this.key);return Array.isArray(G)?G.includes(oe):typeof oe=="string"&&typeof G=="object"&&G!==null?S.call(G,oe):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(U){return U.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=b.create(this.key,this.valueKey)),this.negated}}e.ContextKeyInExpr=A;class b{static create(U,G){return new b(U,G)}constructor(U,G){this.key=U,this.valueKey=G,this.type=m.NotIn,this._negated=A.create(U,G)}cmp(U){return U.type!==this.type?this.type-U.type:this._negated.cmp(U._negated)}equals(U){return U.type===this.type?this._negated.equals(U._negated):!1}substituteConstants(){return this}evaluate(U){return!this._negated.evaluate(U)}serialize(){return`${this.key} not in '${this.valueKey}'`}keys(){return this._negated.keys()}map(U){return U.mapNotIn(this.key,this.valueKey)}negate(){return this._negated}}e.ContextKeyNotInExpr=b;class w{static create(U,G,oe=null){if(typeof G=="boolean")return G?O.create(U,oe):h.create(U,oe);const Q=E.get(U);return typeof Q=="boolean"?G===(Q?"true":"false")?r.INSTANCE:o.INSTANCE:new w(U,G,oe)}constructor(U,G,oe){this.key=U,this.value=G,this.negated=oe,this.type=m.NotEquals}cmp(U){return U.type!==this.type?this.type-U.type:le(this.key,this.value,U.key,U.value)}equals(U){return U.type===this.type?this.key===U.key&&this.value===U.value:!1}substituteConstants(){const U=E.get(this.key);if(typeof U=="boolean"){const G=U?"true":"false";return this.value===G?r.INSTANCE:o.INSTANCE}return this}evaluate(U){return U.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(U){return U.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=y.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=w;class O{static create(U,G=null){const oe=E.get(U);return typeof oe=="boolean"?oe?r.INSTANCE:o.INSTANCE:new O(U,G)}constructor(U,G){this.key=U,this.negated=G,this.type=m.Not}cmp(U){return U.type!==this.type?this.type-U.type:ne(this.key,U.key)}equals(U){return U.type===this.type?this.key===U.key:!1}substituteConstants(){const U=E.get(this.key);return typeof U=="boolean"?U?r.INSTANCE:o.INSTANCE:this}evaluate(U){return!U.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(U){return U.mapNot(this.key)}negate(){return this.negated||(this.negated=h.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=O;function F(W,U){if(typeof W=="string"){const G=parseFloat(W);isNaN(G)||(W=G)}return typeof W=="string"||typeof W=="number"?U(W):r.INSTANCE}class N{static create(U,G,oe=null){return F(G,Q=>new N(U,Q,oe))}constructor(U,G,oe){this.key=U,this.value=G,this.negated=oe,this.type=m.Greater}cmp(U){return U.type!==this.type?this.type-U.type:le(this.key,this.value,U.key,U.value)}equals(U){return U.type===this.type?this.key===U.key&&this.value===U.value:!1}substituteConstants(){return this}evaluate(U){return typeof this.value=="string"?!1:parseFloat(U.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(U){return U.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=z.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=N;class M{static create(U,G,oe=null){return F(G,Q=>new M(U,Q,oe))}constructor(U,G,oe){this.key=U,this.value=G,this.negated=oe,this.type=m.GreaterEquals}cmp(U){return U.type!==this.type?this.type-U.type:le(this.key,this.value,U.key,U.value)}equals(U){return U.type===this.type?this.key===U.key&&this.value===U.value:!1}substituteConstants(){return this}evaluate(U){return typeof this.value=="string"?!1:parseFloat(U.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(U){return U.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=V.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=M;class V{static create(U,G,oe=null){return F(G,Q=>new V(U,Q,oe))}constructor(U,G,oe){this.key=U,this.value=G,this.negated=oe,this.type=m.Smaller}cmp(U){return U.type!==this.type?this.type-U.type:le(this.key,this.value,U.key,U.value)}equals(U){return U.type===this.type?this.key===U.key&&this.value===U.value:!1}substituteConstants(){return this}evaluate(U){return typeof this.value=="string"?!1:parseFloat(U.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(U){return U.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=M.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=V;class z{static create(U,G,oe=null){return F(G,Q=>new z(U,Q,oe))}constructor(U,G,oe){this.key=U,this.value=G,this.negated=oe,this.type=m.SmallerEquals}cmp(U){return U.type!==this.type?this.type-U.type:le(this.key,this.value,U.key,U.value)}equals(U){return U.type===this.type?this.key===U.key&&this.value===U.value:!1}substituteConstants(){return this}evaluate(U){return typeof this.value=="string"?!1:parseFloat(U.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(U){return U.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=N.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=z;class J{static create(U,G){return new J(U,G)}constructor(U,G){this.key=U,this.regexp=G,this.type=m.Regex,this.negated=null}cmp(U){if(U.type!==this.type)return this.type-U.type;if(this.key<U.key)return-1;if(this.key>U.key)return 1;const G=this.regexp?this.regexp.source:"",oe=U.regexp?U.regexp.source:"";return G<oe?-1:G>oe?1:0}equals(U){if(U.type===this.type){const G=this.regexp?this.regexp.source:"",oe=U.regexp?U.regexp.source:"";return this.key===U.key&&G===oe}return!1}substituteConstants(){return this}evaluate(U){const G=U.getValue(this.key);return this.regexp?this.regexp.test(G):!1}serialize(){const U=this.regexp?`/${this.regexp.source}/${this.regexp.flags}`:"/invalid/";return`${this.key} =~ ${U}`}keys(){return[this.key]}map(U){return U.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=j.create(this)),this.negated}}e.ContextKeyRegexExpr=J;class j{static create(U){return new j(U)}constructor(U){this._actual=U,this.type=m.NotRegex}cmp(U){return U.type!==this.type?this.type-U.type:this._actual.cmp(U._actual)}equals(U){return U.type===this.type?this._actual.equals(U._actual):!1}substituteConstants(){return this}evaluate(U){return!this._actual.evaluate(U)}serialize(){return`!(${this._actual.serialize()})`}keys(){return this._actual.keys()}map(U){return new j(this._actual.map(U))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=j;function te(W){let U=null;for(let G=0,oe=W.length;G<oe;G++){const Q=W[G].substituteConstants();if(W[G]!==Q&&U===null){U=[];for(let X=0;X<G;X++)U[X]=W[X]}U!==null&&(U[G]=Q)}return U===null?W:U}class q{static create(U,G,oe){return q._normalizeArr(U,G,oe)}constructor(U,G){this.expr=U,this.negated=G,this.type=m.And}cmp(U){if(U.type!==this.type)return this.type-U.type;if(this.expr.length<U.expr.length)return-1;if(this.expr.length>U.expr.length)return 1;for(let G=0,oe=this.expr.length;G<oe;G++){const Q=s(this.expr[G],U.expr[G]);if(Q!==0)return Q}return 0}equals(U){if(U.type===this.type){if(this.expr.length!==U.expr.length)return!1;for(let G=0,oe=this.expr.length;G<oe;G++)if(!this.expr[G].equals(U.expr[G]))return!1;return!0}return!1}substituteConstants(){const U=te(this.expr);return U===this.expr?this:q.create(U,this.negated,!1)}evaluate(U){for(let G=0,oe=this.expr.length;G<oe;G++)if(!this.expr[G].evaluate(U))return!1;return!0}static _normalizeArr(U,G,oe){const Q=[];let X=!1;for(const x of U)if(x){if(x.type===m.True){X=!0;continue}if(x.type===m.False)return r.INSTANCE;if(x.type===m.And){Q.push(...x.expr);continue}Q.push(x)}if(Q.length===0&&X)return o.INSTANCE;if(Q.length!==0){if(Q.length===1)return Q[0];Q.sort(s);for(let x=1;x<Q.length;x++)Q[x-1].equals(Q[x])&&(Q.splice(x,1),x--);if(Q.length===1)return Q[0];for(;Q.length>1;){const x=Q[Q.length-1];if(x.type!==m.Or)break;Q.pop();const $=Q.pop(),ie=Q.length===0,ae=B.create(x.expr.map(ue=>q.create([ue,$],null,oe)),null,ie);ae&&(Q.push(ae),Q.sort(s))}if(Q.length===1)return Q[0];if(oe){for(let x=0;x<Q.length;x++)for(let $=x+1;$<Q.length;$++)if(Q[x].negate().equals(Q[$]))return r.INSTANCE;if(Q.length===1)return Q[0]}return new q(Q,G)}}serialize(){return this.expr.map(U=>U.serialize()).join(" && ")}keys(){const U=[];for(const G of this.expr)U.push(...G.keys());return U}map(U){return new q(this.expr.map(G=>G.map(U)),null)}negate(){if(!this.negated){const U=[];for(const G of this.expr)U.push(G.negate());this.negated=B.create(U,this,!0)}return this.negated}}e.ContextKeyAndExpr=q;class B{static create(U,G,oe){return B._normalizeArr(U,G,oe)}constructor(U,G){this.expr=U,this.negated=G,this.type=m.Or}cmp(U){if(U.type!==this.type)return this.type-U.type;if(this.expr.length<U.expr.length)return-1;if(this.expr.length>U.expr.length)return 1;for(let G=0,oe=this.expr.length;G<oe;G++){const Q=s(this.expr[G],U.expr[G]);if(Q!==0)return Q}return 0}equals(U){if(U.type===this.type){if(this.expr.length!==U.expr.length)return!1;for(let G=0,oe=this.expr.length;G<oe;G++)if(!this.expr[G].equals(U.expr[G]))return!1;return!0}return!1}substituteConstants(){const U=te(this.expr);return U===this.expr?this:B.create(U,this.negated,!1)}evaluate(U){for(let G=0,oe=this.expr.length;G<oe;G++)if(this.expr[G].evaluate(U))return!0;return!1}static _normalizeArr(U,G,oe){let Q=[],X=!1;if(U){for(let x=0,$=U.length;x<$;x++){const ie=U[x];if(ie){if(ie.type===m.False){X=!0;continue}if(ie.type===m.True)return o.INSTANCE;if(ie.type===m.Or){Q=Q.concat(ie.expr);continue}Q.push(ie)}}if(Q.length===0&&X)return r.INSTANCE;Q.sort(s)}if(Q.length!==0){if(Q.length===1)return Q[0];for(let x=1;x<Q.length;x++)Q[x-1].equals(Q[x])&&(Q.splice(x,1),x--);if(Q.length===1)return Q[0];if(oe){for(let x=0;x<Q.length;x++)for(let $=x+1;$<Q.length;$++)if(Q[x].negate().equals(Q[$]))return o.INSTANCE;if(Q.length===1)return Q[0]}return new B(Q,G)}}serialize(){return this.expr.map(U=>U.serialize()).join(" || ")}keys(){const U=[];for(const G of this.expr)U.push(...G.keys());return U}map(U){return new B(this.expr.map(G=>G.map(U)),null)}negate(){if(!this.negated){const U=[];for(const G of this.expr)U.push(G.negate());for(;U.length>1;){const G=U.shift(),oe=U.shift(),Q=[];for(const X of H(G))for(const x of H(oe))Q.push(q.create([X,x],null,!1));U.unshift(B.create(Q,null,!1))}this.negated=B.create(U,this,!0)}return this.negated}}e.ContextKeyOrExpr=B;class Z extends h{static{this._info=[]}static all(){return Z._info.values()}constructor(U,G,oe){super(U,null),this._defaultValue=G,typeof oe=="object"?Z._info.push({...oe,key:U}):oe!==!0&&Z._info.push({key:U,description:oe,type:G!=null?typeof G:void 0})}bindTo(U){return U.createKey(this.key,this._defaultValue)}getValue(U){return U.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(U){return y.create(this.key,U)}notEqualsTo(U){return w.create(this.key,U)}}e.RawContextKey=Z,e.IContextKeyService=(0,k.createDecorator)("contextKeyService");function ne(W,U){return W<U?-1:W>U?1:0}function le(W,U,G,oe){return W<G?-1:W>G?1:U<oe?-1:U>oe?1:0}function ee(W,U){if(W.type===m.False||U.type===m.True)return!0;if(W.type===m.Or)return U.type===m.Or?K(W.expr,U.expr):!1;if(U.type===m.Or){for(const G of U.expr)if(ee(W,G))return!0;return!1}if(W.type===m.And){if(U.type===m.And)return K(U.expr,W.expr);for(const G of W.expr)if(ee(G,U))return!0;return!1}return W.equals(U)}function K(W,U){let G=0,oe=0;for(;G<W.length&&oe<U.length;){const Q=W[G].cmp(U[oe]);if(Q<0)return!1;Q===0&&G++,oe++}return G===W.length}function H(W){return W.type===m.Or?W.expr:[W]}}),define(he[99],fe([0,1,4]),function(ce,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullDiagnosticsService=e.IDiagnosticsService=e.ID=void 0,e.isRemoteDiagnosticError=a,e.ID="diagnosticsService",e.IDiagnosticsService=(0,R.createDecorator)(e.ID);function a(T){return!!T.hostName&&!!T.errorMessage}class _{async getPerformanceInfo(k,L){return{}}async getSystemInfo(k,L){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(k,L){return""}async getWorkspaceFileExtensions(k){return{extensions:[]}}async reportWorkspaceStats(k){}}e.NullDiagnosticsService=_}),define(he[100],fe([0,1,4]),function(ce,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=(0,R.createDecorator)("downloadService")}),define(he[15],fe([0,1,4]),function(ce,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,R.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,R.refineServiceDecorator)(e.IEnvironmentService)}),define(he[75],fe([0,1,4]),function(ce,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionRecommendationNotificationService=e.RecommendationsNotificationResult=e.RecommendationSource=void 0,e.RecommendationSourceToString=_;var a;(function(k){k[k.FILE=1]="FILE",k[k.WORKSPACE=2]="WORKSPACE",k[k.EXE=3]="EXE"})(a||(e.RecommendationSource=a={}));function _(k){switch(k){case a.FILE:return"file";case a.WORKSPACE:return"workspace";case a.EXE:return"exe"}}var T;(function(k){k.Ignored="ignored",k.Cancelled="cancelled",k.TooMany="toomany",k.IncompatibleWindow="incompatibleWindow",k.Accepted="reacted"})(T||(e.RecommendationsNotificationResult=T={})),e.IExtensionRecommendationNotificationService=(0,R.createDecorator)("IExtensionRecommendationNotificationService")}),define(he[7],fe([0,1,51,13,26,12,10,9,4,5,22,53]),function(ce,e,R,a,_,T,k,L,D,E,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ByteSize=e.ETAG_DISABLED=e.FileKind=e.FILES_READONLY_FROM_PERMISSIONS_CONFIG=e.FILES_READONLY_EXCLUDE_CONFIG=e.FILES_READONLY_INCLUDE_CONFIG=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.TooLargeFileOperationError=e.FileOperationError=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FileChangeFilter=e.FilePermission=e.FileType=e.IFileService=void 0,e.isFileOpenForWriteOptions=m,e.isFileSystemWatcher=I,e.hasReadWriteCapability=f,e.hasFileFolderCopyCapability=C,e.hasFileCloneCapability=p,e.hasOpenReadWriteCloseCapability=c,e.hasFileReadStreamCapability=u,e.hasFileAtomicReadCapability=i,e.hasFileAtomicWriteCapability=n,e.hasFileAtomicDeleteCapability=t,e.hasReadonlyCapability=s,e.createFileSystemProviderError=h,e.ensureFileSystemProviderError=y,e.markAsFileSystemProviderError=A,e.toFileSystemProviderErrorCode=b,e.toFileOperationResult=w,e.isParent=V,e.etag=B,e.whenProviderRegistered=Z,e.getLargeFileConfirmationLimit=le,e.IFileService=(0,D.createDecorator)("fileService");function m(ee){return ee.create===!0}var d;(function(ee){ee[ee.Unknown=0]="Unknown",ee[ee.File=1]="File",ee[ee.Directory=2]="Directory",ee[ee.SymbolicLink=64]="SymbolicLink"})(d||(e.FileType=d={}));var l;(function(ee){ee[ee.Readonly=1]="Readonly",ee[ee.Locked=2]="Locked"})(l||(e.FilePermission=l={}));var g;(function(ee){ee[ee.UPDATED=2]="UPDATED",ee[ee.ADDED=4]="ADDED",ee[ee.DELETED=8]="DELETED"})(g||(e.FileChangeFilter=g={}));function I(ee){const K=ee;return!!K&&typeof K.onDidChange=="function"}var v;(function(ee){ee[ee.None=0]="None",ee[ee.FileReadWrite=2]="FileReadWrite",ee[ee.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",ee[ee.FileReadStream=16]="FileReadStream",ee[ee.FileFolderCopy=8]="FileFolderCopy",ee[ee.PathCaseSensitive=1024]="PathCaseSensitive",ee[ee.Readonly=2048]="Readonly",ee[ee.Trash=4096]="Trash",ee[ee.FileWriteUnlock=8192]="FileWriteUnlock",ee[ee.FileAtomicRead=16384]="FileAtomicRead",ee[ee.FileAtomicWrite=32768]="FileAtomicWrite",ee[ee.FileAtomicDelete=65536]="FileAtomicDelete",ee[ee.FileClone=131072]="FileClone"})(v||(e.FileSystemProviderCapabilities=v={}));function f(ee){return!!(ee.capabilities&v.FileReadWrite)}function C(ee){return!!(ee.capabilities&v.FileFolderCopy)}function p(ee){return!!(ee.capabilities&v.FileClone)}function c(ee){return!!(ee.capabilities&v.FileOpenReadWriteClose)}function u(ee){return!!(ee.capabilities&v.FileReadStream)}function i(ee){return f(ee)?!!(ee.capabilities&v.FileAtomicRead):!1}function n(ee){return f(ee)?!!(ee.capabilities&v.FileAtomicWrite):!1}function t(ee){return!!(ee.capabilities&v.FileAtomicDelete)}function s(ee){return!!(ee.capabilities&v.Readonly)}var r;(function(ee){ee.FileExists="EntryExists",ee.FileNotFound="EntryNotFound",ee.FileNotADirectory="EntryNotADirectory",ee.FileIsADirectory="EntryIsADirectory",ee.FileExceedsStorageQuota="EntryExceedsStorageQuota",ee.FileTooLarge="EntryTooLarge",ee.FileWriteLocked="EntryWriteLocked",ee.NoPermissions="NoPermissions",ee.Unavailable="Unavailable",ee.Unknown="Unknown"})(r||(e.FileSystemProviderErrorCode=r={}));class o extends Error{static create(K,H){const W=new o(K.toString(),H);return A(W,H),W}constructor(K,H){super(K),this.code=H}}e.FileSystemProviderError=o;function h(ee,K){return o.create(ee,K)}function y(ee){return ee||h((0,L.localize)(1865,null),r.Unknown)}function A(ee,K){return ee.name=K?`${K} (FileSystemError)`:"FileSystemError",ee}function b(ee){if(!ee)return r.Unknown;if(ee instanceof o)return ee.code;const K=/^(.+) \(FileSystemError\)$/.exec(ee.name);if(!K)return r.Unknown;switch(K[1]){case r.FileExists:return r.FileExists;case r.FileIsADirectory:return r.FileIsADirectory;case r.FileNotADirectory:return r.FileNotADirectory;case r.FileNotFound:return r.FileNotFound;case r.FileTooLarge:return r.FileTooLarge;case r.FileWriteLocked:return r.FileWriteLocked;case r.NoPermissions:return r.NoPermissions;case r.Unavailable:return r.Unavailable}return r.Unknown}function w(ee){if(ee instanceof z)return ee.fileOperationResult;switch(b(ee)){case r.FileNotFound:return te.FILE_NOT_FOUND;case r.FileIsADirectory:return te.FILE_IS_DIRECTORY;case r.FileNotADirectory:return te.FILE_NOT_DIRECTORY;case r.FileWriteLocked:return te.FILE_WRITE_LOCKED;case r.NoPermissions:return te.FILE_PERMISSION_DENIED;case r.FileExists:return te.FILE_MOVE_CONFLICT;case r.FileTooLarge:return te.FILE_TOO_LARGE;default:return te.FILE_OTHER_ERROR}}var O;(function(ee){ee[ee.CREATE=0]="CREATE",ee[ee.DELETE=1]="DELETE",ee[ee.MOVE=2]="MOVE",ee[ee.COPY=3]="COPY",ee[ee.WRITE=4]="WRITE"})(O||(e.FileOperation=O={}));class F{constructor(K,H,W){this.resource=K,this.operation=H,this.target=W}isOperation(K){return this.operation===K}}e.FileOperationEvent=F;var N;(function(ee){ee[ee.UPDATED=0]="UPDATED",ee[ee.ADDED=1]="ADDED",ee[ee.DELETED=2]="DELETED"})(N||(e.FileChangeType=N={}));class M{static{this.MIXED_CORRELATION=null}constructor(K,H){this.ignorePathCasing=H,this.correlationId=void 0,this.added=new S.Lazy(()=>{const W=R.TernarySearchTree.forUris(()=>this.ignorePathCasing);return W.fill(this.rawAdded.map(U=>[U,!0])),W}),this.updated=new S.Lazy(()=>{const W=R.TernarySearchTree.forUris(()=>this.ignorePathCasing);return W.fill(this.rawUpdated.map(U=>[U,!0])),W}),this.deleted=new S.Lazy(()=>{const W=R.TernarySearchTree.forUris(()=>this.ignorePathCasing);return W.fill(this.rawDeleted.map(U=>[U,!0])),W}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const W of K){switch(W.type){case N.ADDED:this.rawAdded.push(W.resource);break;case N.UPDATED:this.rawUpdated.push(W.resource);break;case N.DELETED:this.rawDeleted.push(W.resource);break}this.correlationId!==M.MIXED_CORRELATION&&(typeof W.cId=="number"?this.correlationId===void 0?this.correlationId=W.cId:this.correlationId!==W.cId&&(this.correlationId=M.MIXED_CORRELATION):this.correlationId!==void 0&&(this.correlationId=M.MIXED_CORRELATION))}}contains(K,...H){return this.doContains(K,{includeChildren:!1},...H)}affects(K,...H){return this.doContains(K,{includeChildren:!0},...H)}doContains(K,H,...W){if(!K)return!1;const U=W.length>0;return!!((!U||W.includes(N.ADDED))&&(this.added.value.get(K)||H.includeChildren&&this.added.value.findSuperstr(K))||(!U||W.includes(N.UPDATED))&&(this.updated.value.get(K)||H.includeChildren&&this.updated.value.findSuperstr(K))||(!U||W.includes(N.DELETED))&&(this.deleted.value.findSubstr(K)||H.includeChildren&&this.deleted.value.findSuperstr(K)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(K){return this.correlationId===K}hasCorrelation(){return typeof this.correlationId=="number"}}e.FileChangesEvent=M;function V(ee,K,H){return!ee||!K||ee===K||K.length>ee.length?!1:(K.charAt(K.length-1)!==a.sep&&(K+=a.sep),H?(0,_.startsWithIgnoreCase)(ee,K):ee.indexOf(K)===0)}class z extends Error{constructor(K,H,W){super(K),this.fileOperationResult=H,this.options=W}}e.FileOperationError=z;class J extends z{constructor(K,H,W,U){super(K,H,U),this.fileOperationResult=H,this.size=W}}e.TooLargeFileOperationError=J;class j extends z{constructor(K,H,W){super(K,te.FILE_NOT_MODIFIED_SINCE,W),this.stat=H}}e.NotModifiedSinceFileOperationError=j;var te;(function(ee){ee[ee.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",ee[ee.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",ee[ee.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",ee[ee.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",ee[ee.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",ee[ee.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",ee[ee.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",ee[ee.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",ee[ee.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",ee[ee.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",ee[ee.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(te||(e.FileOperationResult=te={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude",e.FILES_READONLY_INCLUDE_CONFIG="files.readonlyInclude",e.FILES_READONLY_EXCLUDE_CONFIG="files.readonlyExclude",e.FILES_READONLY_FROM_PERMISSIONS_CONFIG="files.readonlyFromPermissions";var q;(function(ee){ee[ee.FILE=0]="FILE",ee[ee.FOLDER=1]="FOLDER",ee[ee.ROOT_FOLDER=2]="ROOT_FOLDER"})(q||(e.FileKind=q={})),e.ETAG_DISABLED="";function B(ee){if(!(typeof ee.size!="number"||typeof ee.mtime!="number"))return ee.mtime.toString(29)+ee.size.toString(31)}async function Z(ee,K){if(!K.hasProvider(k.URI.from({scheme:ee.scheme})))return new Promise(H=>{const W=K.onDidChangeFileSystemProviderRegistrations(U=>{U.scheme===ee.scheme&&U.added&&(W.dispose(),H())})})}class ne{static{this.KB=1024}static{this.MB=ne.KB*ne.KB}static{this.GB=ne.MB*ne.KB}static{this.TB=ne.GB*ne.KB}static formatSize(K){return(0,T.isNumber)(K)||(K=0),K<ne.KB?(0,L.localize)(1866,null,K.toFixed(0)):K<ne.MB?(0,L.localize)(1867,null,(K/ne.KB).toFixed(2)):K<ne.GB?(0,L.localize)(1868,null,(K/ne.MB).toFixed(2)):K<ne.TB?(0,L.localize)(1869,null,(K/ne.GB).toFixed(2)):(0,L.localize)(1870,null,(K/ne.TB).toFixed(2))}}e.ByteSize=ne;function le(ee){const K=typeof ee=="string"||ee?.scheme===P.Schemas.vscodeRemote;return typeof ee!="string"&&ee?.scheme===P.Schemas.file?1024*ne.MB:K?10*ne.MB:E.isWeb?50*ne.MB:1024*ne.MB}});var Y=this&&this.__param||function(ce,e){return function(R,a){e(R,a,ce)}};define(he[165],fe([0,1,76,50,7]),function(ce,e,R,a,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ChecksumService=void 0;let T=class{constructor(L){this.fileService=L}async checksum(L){const D=(await this.fileService.readFileStream(L)).value;return new Promise((E,P)=>{const S=(0,R.createHash)("sha256");(0,a.listenStream)(D,{onData:m=>S.update(m.buffer),onError:m=>P(m),onEnd:()=>E(S.digest("base64").replace(/=+$/,""))})})}};e.ChecksumService=T,e.ChecksumService=T=Ie([Y(0,_.IFileService)],T)}),define(he[101],fe([0,1,14,8,9,7]),function(ce,e,R,a,_,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=k;async function k(P,S,m,d,l,g){let I;try{await L(P,S,m,d,l,g)}catch(v){I=v}finally{I&&l.errorTransformer&&(I=l.errorTransformer(I)),typeof I<"u"&&m.error(I),m.end()}}async function L(P,S,m,d,l,g){D(g);const I=await P.open(S,{create:!1});try{D(g);let v=0,f=0,C=l&&typeof l.length=="number"?l.length:void 0,p=R.VSBuffer.alloc(Math.min(l.bufferSize,typeof C=="number"?C:l.bufferSize)),c=l&&typeof l.position=="number"?l.position:0,u=0;do f=await P.read(I,c,p.buffer,u,p.byteLength-u),c+=f,u+=f,v+=f,typeof C=="number"&&(C-=f),u===p.byteLength&&(await m.write(d(p)),p=R.VSBuffer.alloc(Math.min(l.bufferSize,typeof C=="number"?C:l.bufferSize)),u=0);while(f>0&&(typeof C!="number"||C>0)&&D(g)&&E(v,l));if(u>0){let i=u;typeof C=="number"&&(i=Math.min(u,C)),m.write(d(p.slice(0,i)))}}catch(v){throw(0,T.ensureFileSystemProviderError)(v)}finally{await P.close(I)}}function D(P){if(P.isCancellationRequested)throw(0,a.canceled)();return!0}function E(P,S){if(typeof S?.limits?.size=="number"&&P>S.limits.size)throw(0,T.createFileSystemProviderError)((0,_.localize)(1898,null),T.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(he[46],fe([0,1,95,2,13,5,10,7]),function(ce,e,R,a,_,T,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractUniversalWatcherClient=e.AbstractNonRecursiveWatcherClient=e.AbstractWatcherClient=void 0,e.isWatchRequestWithCorrelation=D,e.isRecursiveWatchRequest=E,e.reviveFileChanges=d,e.coalesceEvents=l,e.normalizeWatcherPattern=g,e.parseWatcherPatterns=I,e.isFiltered=f,e.requestFilterToString=C;function D(p){return typeof p.correlationId=="number"}function E(p){return p.recursive===!0}class P extends a.Disposable{static{this.MAX_RESTARTS=5}constructor(c,u,i,n){super(),this.onFileChanges=c,this.onLogMessage=u,this.verboseLogging=i,this.options=n,this.watcherDisposables=this._register(new a.MutableDisposable),this.requests=void 0,this.restartCounter=0}init(){const c=new a.DisposableStore;this.watcherDisposables.value=c,this.watcher=this.createWatcher(c),this.watcher.setVerboseLogging(this.verboseLogging),c.add(this.watcher.onDidChangeFile(u=>this.onFileChanges(u))),c.add(this.watcher.onDidLogMessage(u=>this.onLogMessage(u))),c.add(this.watcher.onDidError(u=>this.onError(u.error,u.request)))}onError(c,u){this.canRestart(c,u)?this.restartCounter<P.MAX_RESTARTS&&this.requests?(this.error(`restarting watcher after unexpected error: ${c}`),this.restart(this.requests)):this.error(`gave up attempting to restart watcher after unexpected error: ${c}`):this.error(c)}canRestart(c,u){return!(!this.options.restartOnError||u||c.indexOf("No space left on device")!==-1||c.indexOf("EMFILE")!==-1)}restart(c){this.restartCounter++,this.init(),this.watch(c)}async watch(c){this.requests=c,await this.watcher?.watch(c)}async setVerboseLogging(c){this.verboseLogging=c,await this.watcher?.setVerboseLogging(c)}error(c){this.onLogMessage({type:"error",message:`[File Watcher (${this.options.type})] ${c}`})}trace(c){this.onLogMessage({type:"trace",message:`[File Watcher (${this.options.type})] ${c}`})}dispose(){return this.watcher=void 0,super.dispose()}}e.AbstractWatcherClient=P;class S extends P{constructor(c,u,i){super(c,u,i,{type:"node.js",restartOnError:!1})}}e.AbstractNonRecursiveWatcherClient=S;class m extends P{constructor(c,u,i){super(c,u,i,{type:"universal",restartOnError:!0})}}e.AbstractUniversalWatcherClient=m;function d(p){return p.map(c=>({type:c.type,resource:k.URI.revive(c.resource),cId:c.cId}))}function l(p){const c=new v;for(const u of p)c.processEvent(u);return c.coalesce()}function g(p,c){return typeof c=="string"&&!c.startsWith(R.GLOBSTAR)&&!(0,_.isAbsolute)(c)?{base:p,pattern:c}:c}function I(p,c){const u=[];for(const i of c)u.push((0,R.parse)(g(p,i)));return u}class v{constructor(){this.coalesced=new Set,this.mapPathToChange=new Map}toKey(c){return T.isLinux?c.resource.fsPath:c.resource.fsPath.toLowerCase()}processEvent(c){const u=this.mapPathToChange.get(this.toKey(c));let i=!1;if(u){const n=u.type,t=c.type;u.resource.fsPath!==c.resource.fsPath&&(c.type===L.FileChangeType.DELETED||c.type===L.FileChangeType.ADDED)?i=!0:n===L.FileChangeType.ADDED&&t===L.FileChangeType.DELETED?(this.mapPathToChange.delete(this.toKey(c)),this.coalesced.delete(u)):n===L.FileChangeType.DELETED&&t===L.FileChangeType.ADDED?u.type=L.FileChangeType.UPDATED:n===L.FileChangeType.ADDED&&t===L.FileChangeType.UPDATED||(u.type=t)}else i=!0;i&&(this.coalesced.add(c),this.mapPathToChange.set(this.toKey(c),c))}coalesce(){const c=[],u=[];return Array.from(this.coalesced).filter(i=>i.type!==L.FileChangeType.DELETED?(c.push(i),!1):!0).sort((i,n)=>i.resource.fsPath.length-n.resource.fsPath.length).filter(i=>u.some(n=>(0,L.isParent)(i.resource.fsPath,n,!T.isLinux))?!1:(u.push(i.resource.fsPath),!0)).concat(c)}}function f(p,c){if(typeof c=="number")switch(p.type){case L.FileChangeType.ADDED:return(c&L.FileChangeFilter.ADDED)===0;case L.FileChangeType.DELETED:return(c&L.FileChangeFilter.DELETED)===0;case L.FileChangeType.UPDATED:return(c&L.FileChangeFilter.UPDATED)===0}return!1}function C(p){if(typeof p=="number"){const c=[];return p&L.FileChangeFilter.ADDED&&c.push("Added"),p&L.FileChangeFilter.DELETED&&c.push("Deleted"),p&L.FileChangeFilter.UPDATED&&c.push("Updated"),c.length===0?"<all>":`[${c.join(", ")}]`}return"<none>"}}),define(he[166],fe([0,1,14,41,8,3,2,50,32,7,46]),function(ce,e,R,a,_,T,k,L,D,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderClient=e.LOCAL_FILE_SYSTEM_CHANNEL_NAME=void 0,e.LOCAL_FILE_SYSTEM_CHANNEL_NAME="localFilesystem";class S extends k.Disposable{constructor(d,l){super(),this.channel=d,this.extraCapabilities=l,this.onDidChangeCapabilities=T.Event.None,this._onDidChange=this._register(new T.Emitter),this.onDidChangeFile=this._onDidChange.event,this._onDidWatchError=this._register(new T.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.sessionId=(0,D.generateUuid)(),this.registerFileChangeListeners()}get capabilities(){return this._capabilities||(this._capabilities=E.FileSystemProviderCapabilities.FileReadWrite|E.FileSystemProviderCapabilities.FileOpenReadWriteClose|E.FileSystemProviderCapabilities.FileReadStream|E.FileSystemProviderCapabilities.FileFolderCopy|E.FileSystemProviderCapabilities.FileWriteUnlock|E.FileSystemProviderCapabilities.FileAtomicRead|E.FileSystemProviderCapabilities.FileAtomicWrite|E.FileSystemProviderCapabilities.FileAtomicDelete|E.FileSystemProviderCapabilities.FileClone,this.extraCapabilities.pathCaseSensitive&&(this._capabilities|=E.FileSystemProviderCapabilities.PathCaseSensitive),this.extraCapabilities.trash&&(this._capabilities|=E.FileSystemProviderCapabilities.Trash)),this._capabilities}stat(d){return this.channel.call("stat",[d])}readdir(d){return this.channel.call("readdir",[d])}async readFile(d,l){const{buffer:g}=await this.channel.call("readFile",[d,l]);return g}readFileStream(d,l,g){const I=(0,L.newWriteableStream)(f=>R.VSBuffer.concat(f.map(C=>R.VSBuffer.wrap(C))).buffer),v=new k.DisposableStore;return v.add(this.channel.listen("readFileStream",[d,l])(f=>{if(f instanceof R.VSBuffer)I.write(f.buffer);else{if(f==="end")I.end();else{let C;if(f instanceof Error)C=f;else{const p=f;C=(0,E.createFileSystemProviderError)(p.message??(0,a.toErrorMessage)(p),p.code??E.FileSystemProviderErrorCode.Unknown)}I.error(C),I.end()}v.dispose()}})),v.add(g.onCancellationRequested(()=>{I.error((0,_.canceled)()),I.end(),v.dispose()})),I}writeFile(d,l,g){return this.channel.call("writeFile",[d,R.VSBuffer.wrap(l),g])}open(d,l){return this.channel.call("open",[d,l])}close(d){return this.channel.call("close",[d])}async read(d,l,g,I,v){const[f,C]=await this.channel.call("read",[d,l,v]);return g.set(f.buffer.slice(0,C),I),C}write(d,l,g,I,v){return this.channel.call("write",[d,l,R.VSBuffer.wrap(g),I,v])}mkdir(d){return this.channel.call("mkdir",[d])}delete(d,l){return this.channel.call("delete",[d,l])}rename(d,l,g){return this.channel.call("rename",[d,l,g])}copy(d,l,g){return this.channel.call("copy",[d,l,g])}cloneFile(d,l){return this.channel.call("cloneFile",[d,l])}registerFileChangeListeners(){this._register(this.channel.listen("fileChange",[this.sessionId])(d=>{if(Array.isArray(d)){const l=d;this._onDidChange.fire((0,P.reviveFileChanges)(l))}else{const l=d;this._onDidWatchError.fire(l)}}))}watch(d,l){const g=(0,D.generateUuid)();return this.channel.call("watch",[this.sessionId,g,d,l]),(0,k.toDisposable)(()=>this.channel.call("unwatch",[this.sessionId,g]))}}e.DiskFileSystemProviderClient=S}),define(he[167],fe([0,1,33,2,46,3,7,10,6]),function(ce,e,R,a,_,T,k,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BaseWatcher=void 0;class E extends a.Disposable{constructor(){super(),this._onDidChangeFile=this._register(new T.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidLogMessage=this._register(new T.Emitter),this.onDidLogMessage=this._onDidLogMessage.event,this._onDidWatchFail=this._register(new T.Emitter),this.onDidWatchFail=this._onDidWatchFail.event,this.allNonCorrelatedWatchRequests=new Set,this.allCorrelatedWatchRequests=new Map,this.suspendedWatchRequests=this._register(new a.DisposableMap),this.suspendedWatchRequestsWithPolling=new Set,this.updateWatchersDelayer=this._register(new D.ThrottledDelayer(this.getUpdateWatchersDelay())),this.suspendedWatchRequestPollingInterval=5007,this.joinWatch=new D.DeferredPromise,this.verboseLogging=!1,this._register(this.onDidWatchFail(S=>this.handleDidWatchFail(S)))}handleDidWatchFail(S){this.isCorrelated(S)&&this.suspendWatchRequest(S)}isCorrelated(S){return(0,_.isWatchRequestWithCorrelation)(S)}async watch(S){this.joinWatch.isSettled||this.joinWatch.complete(),this.joinWatch=new D.DeferredPromise;try{this.allCorrelatedWatchRequests.clear(),this.allNonCorrelatedWatchRequests.clear();for(const m of S)this.isCorrelated(m)?this.allCorrelatedWatchRequests.set(m.correlationId,m):this.allNonCorrelatedWatchRequests.add(m);for(const[m]of this.suspendedWatchRequests)this.allCorrelatedWatchRequests.has(m)||(this.suspendedWatchRequests.deleteAndDispose(m),this.suspendedWatchRequestsWithPolling.delete(m));return await this.updateWatchers(!1)}finally{this.joinWatch.complete()}}updateWatchers(S){return this.updateWatchersDelayer.trigger(()=>this.doWatch([...this.allNonCorrelatedWatchRequests,...Array.from(this.allCorrelatedWatchRequests.values()).filter(m=>!this.suspendedWatchRequests.has(m.correlationId))]),S?this.getUpdateWatchersDelay():0)}getUpdateWatchersDelay(){return 800}isSuspended(S){return typeof S.correlationId!="number"?!1:this.suspendedWatchRequestsWithPolling.has(S.correlationId)?"polling":this.suspendedWatchRequests.has(S.correlationId)}async suspendWatchRequest(S){if(this.suspendedWatchRequests.has(S.correlationId))return;const m=new a.DisposableStore;this.suspendedWatchRequests.set(S.correlationId,m),await this.joinWatch.p,!m.isDisposed&&(this.monitorSuspendedWatchRequest(S,m),this.updateWatchers(!0))}resumeWatchRequest(S){this.suspendedWatchRequests.deleteAndDispose(S.correlationId),this.suspendedWatchRequestsWithPolling.delete(S.correlationId),this.updateWatchers(!1)}monitorSuspendedWatchRequest(S,m){this.doMonitorWithExistingWatcher(S,m)?(this.trace(`reusing an existing recursive watcher to monitor ${S.path}`),this.suspendedWatchRequestsWithPolling.delete(S.correlationId)):(this.doMonitorWithNodeJS(S,m),this.suspendedWatchRequestsWithPolling.add(S.correlationId))}doMonitorWithExistingWatcher(S,m){const d=this.recursiveWatcher?.subscribe(S.path,(l,g)=>{m.isDisposed||(l?this.monitorSuspendedWatchRequest(S,m):g?.type===k.FileChangeType.ADDED&&this.onMonitoredPathAdded(S))});return d?(m.add(d),!0):!1}doMonitorWithNodeJS(S,m){let d=!1;const l=(g,I)=>{if(m.isDisposed)return;const v=this.isPathNotFound(g),f=this.isPathNotFound(I),C=d;d=v,!v&&(f||C)&&this.onMonitoredPathAdded(S)};this.trace(`starting fs.watchFile() on ${S.path} (correlationId: ${S.correlationId})`);try{(0,R.watchFile)(S.path,{persistent:!1,interval:this.suspendedWatchRequestPollingInterval},l)}catch(g){this.warn(`fs.watchFile() failed with error ${g} on path ${S.path} (correlationId: ${S.correlationId})`)}m.add((0,a.toDisposable)(()=>{this.trace(`stopping fs.watchFile() on ${S.path} (correlationId: ${S.correlationId})`);try{(0,R.unwatchFile)(S.path,l)}catch(g){this.warn(`fs.unwatchFile() failed with error ${g} on path ${S.path} (correlationId: ${S.correlationId})`)}}))}onMonitoredPathAdded(S){this.trace(`detected ${S.path} exists again, resuming watcher (correlationId: ${S.correlationId})`);const m={resource:L.URI.file(S.path),type:k.FileChangeType.ADDED,cId:S.correlationId};this._onDidChangeFile.fire([m]),this.traceEvent(m,S),this.resumeWatchRequest(S)}isPathNotFound(S){return S.ctimeMs===0&&S.ino===0}async stop(){this.suspendedWatchRequests.clearAndDisposeAll(),this.suspendedWatchRequestsWithPolling.clear()}traceEvent(S,m){if(this.verboseLogging){const d=` >> normalized ${S.type===k.FileChangeType.ADDED?"[ADDED]":S.type===k.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${S.resource.fsPath}`;this.traceWithCorrelation(d,m)}}traceWithCorrelation(S,m){this.verboseLogging&&this.trace(`${S}${typeof m.correlationId=="number"?` <${m.correlationId}> `:""}`)}requestToString(S){return`${S.path} (excludes: ${S.excludes.length>0?S.excludes:"<none>"}, includes: ${S.includes&&S.includes.length>0?JSON.stringify(S.includes):"<all>"}, filter: ${(0,_.requestFilterToString)(S.filter)}, correlationId: ${typeof S.correlationId=="number"?S.correlationId:"<none>"})`}async setVerboseLogging(S){this.verboseLogging=S}}e.BaseWatcher=E}),define(he[168],fe([0,1,33,6,25,42,2,91,13,5,20,10,151,30,7,46]),function(ce,e,R,a,_,T,k,L,D,E,P,S,m,d,l,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSFileWatcherLibrary=void 0,e.watchFileContents=v;class I extends k.Disposable{static{this.FILE_DELETE_HANDLER_DELAY=100}static{this.FILE_CHANGES_HANDLER_DELAY=75}get isReusingRecursiveWatcher(){return this._isReusingRecursiveWatcher}get failed(){return this.didFail}constructor(C,p,c,u,i,n){super(),this.request=C,this.recursiveWatcher=p,this.onDidFilesChange=c,this.onDidWatchFail=u,this.onLogMessage=i,this.verboseLogging=n,this.throttledFileChangesEmitter=this._register(new a.ThrottledWorker({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},t=>this.onDidFilesChange(t))),this.fileChangesAggregator=this._register(new a.RunOnceWorker(t=>this.handleFileChanges(t),I.FILE_CHANGES_HANDLER_DELAY)),this.excludes=(0,g.parseWatcherPatterns)(this.request.path,this.request.excludes),this.includes=this.request.includes?(0,g.parseWatcherPatterns)(this.request.path,this.request.includes):void 0,this.filter=(0,g.isWatchRequestWithCorrelation)(this.request)?this.request.filter:void 0,this.cts=new _.CancellationTokenSource,this.ready=this.watch(),this._isReusingRecursiveWatcher=!1,this.didFail=!1}async watch(){try{const C=await this.normalizePath(this.request);if(this.cts.token.isCancellationRequested)return;const p=await R.promises.stat(C);if(this.cts.token.isCancellationRequested)return;this._register(await this.doWatch(C,p.isDirectory()))}catch(C){C.code!=="ENOENT"?this.error(C):this.trace(`ignoring a path for watching who's stat info failed to resolve: ${this.request.path} (error: ${C})`),this.notifyWatchFailed()}}notifyWatchFailed(){this.didFail=!0,this.onDidWatchFail?.()}async normalizePath(C){let p=C.path;try{p=await d.Promises.realpath(C.path),C.path===p&&(p=await(0,m.realcase)(C.path,this.cts.token)??C.path),C.path!==p&&this.trace(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${C.path}, real: ${p})`)}catch{}return p}async doWatch(C,p){const c=new k.DisposableStore;return this.doWatchWithExistingWatcher(C,p,c)?(this.trace(`reusing an existing recursive watcher for ${this.request.path}`),this._isReusingRecursiveWatcher=!0):(this._isReusingRecursiveWatcher=!1,await this.doWatchWithNodeJS(C,p,c)),c}doWatchWithExistingWatcher(C,p,c){if(p)return!1;const u=S.URI.file(this.request.path),i=this.recursiveWatcher?.subscribe(this.request.path,async(n,t)=>{if(!c.isDisposed)if(n){const s=await this.doWatch(C,p);c.isDisposed?s.dispose():c.add(s)}else t&&(typeof t.cId=="number"||typeof this.request.correlationId=="number")&&this.onFileChange({resource:u,type:t.type,cId:this.request.correlationId},!0)});return i?(c.add(i),!0):!1}async doWatchWithNodeJS(C,p,c){if(E.isMacintosh&&(0,T.isEqualOrParent)(C,"/Volumes/",!0)){this.error(`Refusing to watch ${C} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`);return}const u=new _.CancellationTokenSource(this.cts.token);c.add((0,k.toDisposable)(()=>u.dispose(!0)));const i=new k.DisposableStore;c.add(i);try{const n=S.URI.file(this.request.path),t=(0,D.basename)(C),s=(0,R.watch)(C);i.add((0,k.toDisposable)(()=>{s.removeAllListeners(),s.close()})),this.trace(`Started watching: '${C}'`);const r=new Set;if(p)try{for(const h of await d.Promises.readdir(C))r.add(h)}catch(h){this.error(h)}if(u.token.isCancellationRequested)return;const o=new Map;i.add((0,k.toDisposable)(()=>{for(const[,h]of o)h.dispose();o.clear()})),s.on("error",(h,y)=>{u.token.isCancellationRequested||(this.error(`Failed to watch ${C} for changes using fs.watch() (${h}, ${y})`),this.notifyWatchFailed())}),s.on("change",(h,y)=>{if(u.token.isCancellationRequested)return;this.verboseLogging&&this.traceWithCorrelation(`[raw] ["${h}"] ${y}`);let A="";if(y&&(A=y.toString(),E.isMacintosh&&(A=(0,L.normalizeNFC)(A))),!(!A||h!=="change"&&h!=="rename"))if(p)if(h==="rename"){o.get(A)?.dispose();const b=setTimeout(async()=>{if(o.delete(A),A===t&&!await d.Promises.exists(C)){this.onWatchedPathDeleted(n);return}if(u.token.isCancellationRequested)return;const w=await this.existsChildStrictCase((0,D.join)(C,A));if(u.token.isCancellationRequested)return;let O;w?r.has(A)?O=l.FileChangeType.UPDATED:(O=l.FileChangeType.ADDED,r.add(A)):(r.delete(A),O=l.FileChangeType.DELETED),this.onFileChange({resource:(0,P.joinPath)(n,A),type:O,cId:this.request.correlationId})},I.FILE_DELETE_HANDLER_DELAY);o.set(A,(0,k.toDisposable)(()=>clearTimeout(b)))}else{let b;r.has(A)?b=l.FileChangeType.UPDATED:(b=l.FileChangeType.ADDED,r.add(A)),this.onFileChange({resource:(0,P.joinPath)(n,A),type:b,cId:this.request.correlationId})}else if(h==="rename"||A!==t){const b=setTimeout(async()=>{const w=await d.Promises.exists(C);u.token.isCancellationRequested||(w?(this.onFileChange({resource:n,type:l.FileChangeType.UPDATED,cId:this.request.correlationId},!0),i.add(await this.doWatch(C,!1))):this.onWatchedPathDeleted(n))},I.FILE_DELETE_HANDLER_DELAY);i.clear(),i.add((0,k.toDisposable)(()=>clearTimeout(b)))}else this.onFileChange({resource:n,type:l.FileChangeType.UPDATED,cId:this.request.correlationId},!0)})}catch(n){u.token.isCancellationRequested||this.error(`Failed to watch ${C} for changes using fs.watch() (${n.toString()})`),this.notifyWatchFailed()}}onWatchedPathDeleted(C){this.warn("Watcher shutdown because watched path got deleted"),this.onFileChange({resource:C,type:l.FileChangeType.DELETED,cId:this.request.correlationId},!0),this.fileChangesAggregator.flush(),this.notifyWatchFailed()}onFileChange(C,p=!1){this.cts.token.isCancellationRequested||(this.verboseLogging&&this.traceWithCorrelation(`${C.type===l.FileChangeType.ADDED?"[ADDED]":C.type===l.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${C.resource.fsPath}`),!p&&this.excludes.some(c=>c(C.resource.fsPath))?this.verboseLogging&&this.traceWithCorrelation(` >> ignored (excluded) ${C.resource.fsPath}`):!p&&this.includes&&this.includes.length>0&&!this.includes.some(c=>c(C.resource.fsPath))?this.verboseLogging&&this.traceWithCorrelation(` >> ignored (not included) ${C.resource.fsPath}`):this.fileChangesAggregator.work(C))}handleFileChanges(C){const p=(0,g.coalesceEvents)(C),c=[];for(const i of p){if((0,g.isFiltered)(i,this.filter)){this.verboseLogging&&this.traceWithCorrelation(` >> ignored (filtered) ${i.resource.fsPath}`);continue}c.push(i)}if(c.length===0)return;if(this.verboseLogging)for(const i of c)this.traceWithCorrelation(` >> normalized ${i.type===l.FileChangeType.ADDED?"[ADDED]":i.type===l.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${i.resource.fsPath}`);this.throttledFileChangesEmitter.work(c)?this.throttledFileChangesEmitter.pending>0&&this.trace(`started throttling events due to large amount of file change events at once (pending: ${this.throttledFileChangesEmitter.pending}, most recent change: ${c[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.warn(`started ignoring events due to too many file change events at once (incoming: ${c.length}, most recent change: ${c[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}async existsChildStrictCase(C){if(E.isLinux)return d.Promises.exists(C);try{const p=(0,D.basename)(C);return(await d.Promises.readdir((0,D.dirname)(C))).some(u=>u===p)}catch(p){return this.trace(p),!1}}setVerboseLogging(C){this.verboseLogging=C}error(C){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"error",message:`[File Watcher (node.js)] ${C}`})}warn(C){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"warn",message:`[File Watcher (node.js)] ${C}`})}trace(C){!this.cts.token.isCancellationRequested&&this.verboseLogging&&this.onLogMessage?.({type:"trace",message:`[File Watcher (node.js)] ${C}`})}traceWithCorrelation(C){!this.cts.token.isCancellationRequested&&this.verboseLogging&&this.trace(`${C}${typeof this.request.correlationId=="number"?` <${this.request.correlationId}> `:""}`)}dispose(){this.cts.dispose(!0),super.dispose()}}e.NodeJSFileWatcherLibrary=I;async function v(f,C,p,c,u=512){const i=await d.Promises.open(f,"r"),n=Buffer.allocUnsafe(u),t=new _.CancellationTokenSource(c);let s,r=!1;const o={path:f,excludes:[],recursive:!1},h=new I(o,void 0,y=>{(async()=>{for(const{type:A}of y)if(A===l.FileChangeType.UPDATED){if(r)return;r=!0;try{for(;!t.token.isCancellationRequested;){const{bytesRead:b}=await d.Promises.read(i,n,0,u,null);if(!b||t.token.isCancellationRequested)break;C(n.slice(0,b))}}catch(b){s=new Error(b),t.dispose(!0)}finally{r=!1}}})()});return await h.ready,p(),new Promise((y,A)=>{t.token.onCancellationRequested(async()=>{h.dispose();try{await d.Promises.close(i)}catch(b){s=new Error(b)}s?A(s):y()})})}}),define(he[169],fe([0,1,3,95,167,5,168,42]),function(ce,e,R,a,_,T,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class D extends _.BaseWatcher{constructor(P){super(),this.recursiveWatcher=P,this.onDidError=R.Event.None,this.watchers=new Set}async doWatch(P){P=this.removeDuplicateRequests(P);const S=[],m=new Set(Array.from(this.watchers));for(const d of P){const l=this.findWatcher(d);l&&(0,a.patternsEquals)(l.request.excludes,d.excludes)&&(0,a.patternsEquals)(l.request.includes,d.includes)?m.delete(l):S.push(d)}S.length&&this.trace(`Request to start watching: ${S.map(d=>this.requestToString(d)).join(",")}`),m.size&&this.trace(`Request to stop watching: ${Array.from(m).map(d=>this.requestToString(d.request)).join(",")}`);for(const d of m)this.stopWatching(d);for(const d of S)this.startWatching(d)}findWatcher(P){for(const S of this.watchers)if(typeof P.correlationId=="number"||typeof S.request.correlationId=="number"){if(S.request.correlationId===P.correlationId)return S}else if((0,L.isEqual)(S.request.path,P.path,!T.isLinux))return S}startWatching(P){const S=new k.NodeJSFileWatcherLibrary(P,this.recursiveWatcher,d=>this._onDidChangeFile.fire(d),()=>this._onDidWatchFail.fire(P),d=>this._onDidLogMessage.fire(d),this.verboseLogging),m={request:P,instance:S};this.watchers.add(m)}async stop(){await super.stop();for(const P of this.watchers)this.stopWatching(P)}stopWatching(P){this.trace("stopping file watcher",P),this.watchers.delete(P),P.instance.dispose()}removeDuplicateRequests(P){const S=new Map;for(const m of P){const d=T.isLinux?m.path:m.path.toLowerCase();let l=S.get(m.correlationId);l||(l=new Map,S.set(m.correlationId,l)),l.has(d)&&this.trace(`ignoring a request for watching who's path is already watched: ${this.requestToString(m)}`),l.set(d,m)}return Array.from(S.values()).map(m=>Array.from(m.values())).flat()}async setVerboseLogging(P){super.setVerboseLogging(P);for(const S of this.watchers)S.instance.setVerboseLogging(P)}trace(P,S){this.verboseLogging&&this._onDidLogMessage.fire({type:"trace",message:this.toMessage(P,S)})}warn(P){this._onDidLogMessage.fire({type:"warn",message:this.toMessage(P)})}toMessage(P,S){return S?`[File Watcher (node.js)] ${P} (${this.requestToString(S.request)})`:`[File Watcher (node.js)] ${P}`}}e.NodeJSWatcher=D}),define(he[170],fe([0,1,46,169]),function(ce,e,R,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class _ extends R.AbstractNonRecursiveWatcherClient{constructor(k,L,D){super(k,L,D),this.init()}createWatcher(k){return k.add(new a.NodeJSWatcher(void 0))}}e.NodeJSWatcherClient=_}),define(he[171],fe([0,1,22,43,97,46]),function(ce,e,R,a,_,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class k extends T.AbstractUniversalWatcherClient{constructor(D,E,P){super(D,E,P),this.init()}createWatcher(D){const E=D.add(new _.Client(R.FileAccess.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return D.add(E.onDidProcessExit(({code:P,signal:S})=>this.onError(`terminated by itself with code ${P}, signal: ${S} (ETERM)`))),a.ProxyChannel.toService((0,a.getNextTickChannel)(E.getChannel("watcher")))}}e.UniversalWatcherClient=k}),define(he[77],fe([0,1]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class R{constructor(..._){this._entries=new Map;for(const[T,k]of _)this.set(T,k)}set(_,T){const k=this._entries.get(_);return this._entries.set(_,T),k}has(_){return this._entries.has(_)}get(_){return this._entries.get(_)}}e.ServiceCollection=R}),define(he[172],fe([0,1,6,8,2,74,163,4,77,90]),function(ce,e,R,a,_,T,k,L,D,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const P=!1;class S extends Error{constructor(I){super("cyclic dependency between services"),this.message=I.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${I.toString()}`}}class m{constructor(I=new D.ServiceCollection,v=!1,f,C=P){this._services=I,this._strict=v,this._parent=f,this._enableTracing=C,this._isDisposed=!1,this._servicesToMaybeDispose=new Set,this._children=new Set,this._activeInstantiations=new Set,this._services.set(L.IInstantiationService,this),this._globalGraph=C?f?._globalGraph??new k.Graph(p=>p):void 0}dispose(){if(!this._isDisposed){this._isDisposed=!0,(0,_.dispose)(this._children),this._children.clear();for(const I of this._servicesToMaybeDispose)(0,_.isDisposable)(I)&&I.dispose();this._servicesToMaybeDispose.clear()}}_throwIfDisposed(){if(this._isDisposed)throw new Error("InstantiationService has been disposed")}createChild(I,v){this._throwIfDisposed();const f=this,C=new class extends m{dispose(){f._children.delete(C),super.dispose()}}(I,this._strict,this,this._enableTracing);return this._children.add(C),v?.add(C),C}invokeFunction(I,...v){this._throwIfDisposed();const f=l.traceInvocation(this._enableTracing,I);let C=!1;try{return I({get:c=>{if(C)throw(0,a.illegalState)("service accessor is only valid during the invocation of its target method");const u=this._getOrCreateServiceInstance(c,f);if(!u)throw new Error(`[invokeFunction] unknown service '${c}'`);return u}},...v)}finally{C=!0,f.stop()}}createInstance(I,...v){this._throwIfDisposed();let f,C;return I instanceof T.SyncDescriptor?(f=l.traceCreation(this._enableTracing,I.ctor),C=this._createInstance(I.ctor,I.staticArguments.concat(v),f)):(f=l.traceCreation(this._enableTracing,I),C=this._createInstance(I,v,f)),f.stop(),C}_createInstance(I,v=[],f){const C=L._util.getServiceDependencies(I).sort((u,i)=>u.index-i.index),p=[];for(const u of C){const i=this._getOrCreateServiceInstance(u.id,f);i||this._throwIfStrict(`[createInstance] ${I.name} depends on UNKNOWN service ${u.id}.`,!1),p.push(i)}const c=C.length>0?C[0].index:v.length;if(v.length!==c){console.trace(`[createInstance] First service dependency of ${I.name} at position ${c+1} conflicts with ${v.length} static arguments`);const u=c-v.length;u>0?v=v.concat(new Array(u)):v=v.slice(0,c)}return Reflect.construct(I,v.concat(p))}_setCreatedServiceInstance(I,v){if(this._services.get(I)instanceof T.SyncDescriptor)this._services.set(I,v);else if(this._parent)this._parent._setCreatedServiceInstance(I,v);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(I){const v=this._services.get(I);return!v&&this._parent?this._parent._getServiceInstanceOrDescriptor(I):v}_getOrCreateServiceInstance(I,v){this._globalGraph&&this._globalGraphImplicitDependency&&this._globalGraph.insertEdge(this._globalGraphImplicitDependency,String(I));const f=this._getServiceInstanceOrDescriptor(I);return f instanceof T.SyncDescriptor?this._safeCreateAndCacheServiceInstance(I,f,v.branch(I,!0)):(v.branch(I,!1),f)}_safeCreateAndCacheServiceInstance(I,v,f){if(this._activeInstantiations.has(I))throw new Error(`illegal state - RECURSIVELY instantiating service '${I}'`);this._activeInstantiations.add(I);try{return this._createAndCacheServiceInstance(I,v,f)}finally{this._activeInstantiations.delete(I)}}_createAndCacheServiceInstance(I,v,f){const C=new k.Graph(i=>i.id.toString());let p=0;const c=[{id:I,desc:v,_trace:f}],u=new Set;for(;c.length;){const i=c.pop();if(!u.has(String(i.id))){if(u.add(String(i.id)),C.lookupOrInsertNode(i),p++>1e3)throw new S(C);for(const n of L._util.getServiceDependencies(i.desc.ctor)){const t=this._getServiceInstanceOrDescriptor(n.id);if(t||this._throwIfStrict(`[createInstance] ${I} depends on ${n.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(i.id),String(n.id)),t instanceof T.SyncDescriptor){const s={id:n.id,desc:t,_trace:i._trace.branch(n.id,!0)};C.insertEdge(i,s),c.push(s)}}}}for(;;){const i=C.roots();if(i.length===0){if(!C.isEmpty())throw new S(C);break}for(const{data:n}of i){if(this._getServiceInstanceOrDescriptor(n.id)instanceof T.SyncDescriptor){const s=this._createServiceInstanceWithOwner(n.id,n.desc.ctor,n.desc.staticArguments,n.desc.supportsDelayedInstantiation,n._trace);this._setCreatedServiceInstance(n.id,s)}C.removeNode(n)}}return this._getServiceInstanceOrDescriptor(I)}_createServiceInstanceWithOwner(I,v,f=[],C,p){if(this._services.get(I)instanceof T.SyncDescriptor)return this._createServiceInstance(I,v,f,C,p,this._servicesToMaybeDispose);if(this._parent)return this._parent._createServiceInstanceWithOwner(I,v,f,C,p);throw new Error(`illegalState - creating UNKNOWN service instance ${v.name}`)}_createServiceInstance(I,v,f=[],C,p,c){if(C){const u=new m(void 0,this._strict,this,this._enableTracing);u._globalGraphImplicitDependency=String(I);const i=new Map,n=new R.GlobalIdleValue(()=>{const t=u._createInstance(v,f,p);for(const[s,r]of i){const o=t[s];if(typeof o=="function")for(const h of r)h.disposable=o.apply(t,h.listener)}return i.clear(),c.add(t),t});return new Proxy(Object.create(null),{get(t,s){if(!n.isInitialized&&typeof s=="string"&&(s.startsWith("onDid")||s.startsWith("onWill"))){let h=i.get(s);return h||(h=new E.LinkedList,i.set(s,h)),(A,b,w)=>{if(n.isInitialized)return n.value[s](A,b,w);{const O={listener:[A,b,w],disposable:void 0},F=h.push(O);return(0,_.toDisposable)(()=>{F(),O.disposable?.dispose()})}}}if(s in t)return t[s];const r=n.value;let o=r[s];return typeof o!="function"||(o=o.bind(r),t[s]=o),o},set(t,s,r){return n.value[s]=r,!0},getPrototypeOf(t){return v.prototype}})}else{const u=this._createInstance(v,f,p);return c.add(u),u}}_throwIfStrict(I,v){if(v&&console.warn(I),this._strict)throw new Error(I)}}e.InstantiationService=m;var d;(function(g){g[g.None=0]="None",g[g.Creation=1]="Creation",g[g.Invocation=2]="Invocation",g[g.Branch=3]="Branch"})(d||(d={}));class l{static{this.all=new Set}static{this._None=new class extends l{constructor(){super(d.None,null)}stop(){}branch(){return this}}}static traceInvocation(I,v){return I?new l(d.Invocation,v.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):l._None}static traceCreation(I,v){return I?new l(d.Creation,v.name):l._None}static{this._totals=0}constructor(I,v){this.type=I,this.name=v,this._start=Date.now(),this._dep=[]}branch(I,v){const f=new l(d.Branch,I.toString());return this._dep.push([I,v,f]),f}stop(){const I=Date.now()-this._start;l._totals+=I;let v=!1;function f(p,c){const u=[],i=new Array(p+1).join("	");for(const[n,t,s]of c._dep)if(t&&s){v=!0,u.push(`${i}CREATES -> ${n}`);const r=f(p+1,s);r&&u.push(r)}else u.push(`${i}uses -> ${n}`);return u.join(`
`)}const C=[`${this.type===d.Creation?"CREATE":"CALL"} ${this.name}`,`${f(1,this)}`,`DONE, took ${I.toFixed(2)}ms (grand total ${l._totals.toFixed(2)}ms)`];(I>2||v)&&l.all.add(C.join(`
`))}}e.Trace=l}),define(he[56],fe([0,1,4]),function(ce,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MainProcessService=e.IMainProcessService=void 0,e.IMainProcessService=(0,R.createDecorator)("mainProcessService");class a{constructor(T,k){this.server=T,this.router=k}getChannel(T){return this.server.getChannel(T,this.router)}registerChannel(T,k){this.server.registerChannel(T,k)}}e.MainProcessService=a}),define(he[11],fe([0,1,9,41,3,55,2,31,5,20,12,10,98,4]),function(ce,e,R,a,_,T,k,L,D,E,P,S,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_LOG_LEVEL=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.MultiplexLogger=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.isLogLevel=g,e.log=v,e.getLogLevel=o,e.LogLevelToString=h,e.LogLevelToLocalizedString=y,e.parseLogLevel=A,R=De(R),e.ILogService=(0,d.createDecorator)("logService"),e.ILoggerService=(0,d.createDecorator)("loggerService");function l(){return new Date().toISOString()}function g(b){return(0,P.isNumber)(b)}var I;(function(b){b[b.Off=0]="Off",b[b.Trace=1]="Trace",b[b.Debug=2]="Debug",b[b.Info=3]="Info",b[b.Warning=4]="Warning",b[b.Error=5]="Error"})(I||(e.LogLevel=I={})),e.DEFAULT_LOG_LEVEL=I.Info;function v(b,w,O){switch(w){case I.Trace:b.trace(O);break;case I.Debug:b.debug(O);break;case I.Info:b.info(O);break;case I.Warning:b.warn(O);break;case I.Error:b.error(O);break;case I.Off:break;default:throw new Error(`Invalid log level ${w}`)}}function f(b,w=!1){let O="";for(let F=0;F<b.length;F++){let N=b[F];if(N instanceof Error&&(N=(0,a.toErrorMessage)(N,w)),typeof N=="object")try{N=JSON.stringify(N)}catch{}O+=(F>0?" ":"")+N}return O}class C extends k.Disposable{constructor(){super(...arguments),this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new _.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(w){this.level!==w&&(this.level=w,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}checkLogLevel(w){return this.level!==I.Off&&this.level<=w}}e.AbstractLogger=C;class p extends C{constructor(w){super(),this.logAlways=w}checkLogLevel(w){return this.logAlways||super.checkLogLevel(w)}trace(w,...O){this.checkLogLevel(I.Trace)&&this.log(I.Trace,f([w,...O],!0))}debug(w,...O){this.checkLogLevel(I.Debug)&&this.log(I.Debug,f([w,...O]))}info(w,...O){this.checkLogLevel(I.Info)&&this.log(I.Info,f([w,...O]))}warn(w,...O){this.checkLogLevel(I.Warning)&&this.log(I.Warning,f([w,...O]))}error(w,...O){if(this.checkLogLevel(I.Error))if(w instanceof Error){const F=Array.prototype.slice.call(arguments);F[0]=w.stack,this.log(I.Error,f(F))}else this.log(I.Error,f([w,...O]))}flush(){}}e.AbstractMessageLogger=p;class c extends C{constructor(w=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(w),this.useColors=!D.isWindows}trace(w,...O){this.checkLogLevel(I.Trace)&&(this.useColors?console.log(`\x1B[90m[main ${l()}]\x1B[0m`,w,...O):console.log(`[main ${l()}]`,w,...O))}debug(w,...O){this.checkLogLevel(I.Debug)&&(this.useColors?console.log(`\x1B[90m[main ${l()}]\x1B[0m`,w,...O):console.log(`[main ${l()}]`,w,...O))}info(w,...O){this.checkLogLevel(I.Info)&&(this.useColors?console.log(`\x1B[90m[main ${l()}]\x1B[0m`,w,...O):console.log(`[main ${l()}]`,w,...O))}warn(w,...O){this.checkLogLevel(I.Warning)&&(this.useColors?console.warn(`\x1B[93m[main ${l()}]\x1B[0m`,w,...O):console.warn(`[main ${l()}]`,w,...O))}error(w,...O){this.checkLogLevel(I.Error)&&(this.useColors?console.error(`\x1B[91m[main ${l()}]\x1B[0m`,w,...O):console.error(`[main ${l()}]`,w,...O))}flush(){}}e.ConsoleMainLogger=c;class u extends C{constructor(w=e.DEFAULT_LOG_LEVEL,O=!0){super(),this.useColors=O,this.setLevel(w)}trace(w,...O){this.checkLogLevel(I.Trace)&&(this.useColors?console.log("%cTRACE","color: #888",w,...O):console.log(w,...O))}debug(w,...O){this.checkLogLevel(I.Debug)&&(this.useColors?console.log("%cDEBUG","background: #eee; color: #888",w,...O):console.log(w,...O))}info(w,...O){this.checkLogLevel(I.Info)&&(this.useColors?console.log("%c INFO","color: #33f",w,...O):console.log(w,...O))}warn(w,...O){this.checkLogLevel(I.Warning)&&(this.useColors?console.log("%c WARN","color: #993",w,...O):console.log(w,...O))}error(w,...O){this.checkLogLevel(I.Error)&&(this.useColors?console.log("%c  ERR","color: #f33",w,...O):console.error(w,...O))}flush(){}}e.ConsoleLogger=u;class i extends C{constructor(w,O=e.DEFAULT_LOG_LEVEL){super(),this.adapter=w,this.setLevel(O)}trace(w,...O){this.checkLogLevel(I.Trace)&&this.adapter.log(I.Trace,[this.extractMessage(w),...O])}debug(w,...O){this.checkLogLevel(I.Debug)&&this.adapter.log(I.Debug,[this.extractMessage(w),...O])}info(w,...O){this.checkLogLevel(I.Info)&&this.adapter.log(I.Info,[this.extractMessage(w),...O])}warn(w,...O){this.checkLogLevel(I.Warning)&&this.adapter.log(I.Warning,[this.extractMessage(w),...O])}error(w,...O){this.checkLogLevel(I.Error)&&this.adapter.log(I.Error,[this.extractMessage(w),...O])}extractMessage(w){return typeof w=="string"?w:(0,a.toErrorMessage)(w,this.checkLogLevel(I.Trace))}flush(){}}e.AdapterLogger=i;class n extends C{constructor(w){super(),this.loggers=w,w.length&&this.setLevel(w[0].getLevel())}setLevel(w){for(const O of this.loggers)O.setLevel(w);super.setLevel(w)}trace(w,...O){for(const F of this.loggers)F.trace(w,...O)}debug(w,...O){for(const F of this.loggers)F.debug(w,...O)}info(w,...O){for(const F of this.loggers)F.info(w,...O)}warn(w,...O){for(const F of this.loggers)F.warn(w,...O)}error(w,...O){for(const F of this.loggers)F.error(w,...O)}flush(){for(const w of this.loggers)w.flush()}dispose(){for(const w of this.loggers)w.dispose();super.dispose()}}e.MultiplexLogger=n;class t extends k.Disposable{constructor(w,O,F){if(super(),this.logLevel=w,this.logsHome=O,this._loggers=new L.ResourceMap,this._onDidChangeLoggers=this._register(new _.Emitter),this.onDidChangeLoggers=this._onDidChangeLoggers.event,this._onDidChangeLogLevel=this._register(new _.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event,this._onDidChangeVisibility=this._register(new _.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,F)for(const N of F)this._loggers.set(N.resource,{logger:void 0,info:N})}getLoggerEntry(w){return(0,P.isString)(w)?[...this._loggers.values()].find(O=>O.info.id===w):this._loggers.get(w)}getLogger(w){return this.getLoggerEntry(w)?.logger}createLogger(w,O){const F=this.toResource(w),N=(0,P.isString)(w)?w:O?.id??(0,T.hash)(F.toString()).toString(16);let M=this._loggers.get(F)?.logger;const V=O?.logLevel==="always"?I.Trace:O?.logLevel;M||(M=this.doCreateLogger(F,V??this.getLogLevel(F)??this.logLevel,{...O,id:N}));const z={logger:M,info:{resource:F,id:N,logLevel:V,name:O?.name,hidden:O?.hidden,extensionId:O?.extensionId,when:O?.when}};return this.registerLogger(z.info),this._loggers.set(F,z),M}toResource(w){return(0,P.isString)(w)?(0,E.joinPath)(this.logsHome,`${w}.log`):w}setLogLevel(w,O){if(S.URI.isUri(w)){const F=w,N=O,M=this._loggers.get(F);M&&N!==M.info.logLevel&&(M.info.logLevel=N===this.logLevel?void 0:N,M.logger?.setLevel(N),this._loggers.set(M.info.resource,M),this._onDidChangeLogLevel.fire([F,N]))}else{this.logLevel=w;for(const[F,N]of this._loggers.entries())this._loggers.get(F)?.info.logLevel===void 0&&N.logger?.setLevel(this.logLevel);this._onDidChangeLogLevel.fire(this.logLevel)}}setVisibility(w,O){const F=this.getLoggerEntry(w);F&&O!==!F.info.hidden&&(F.info.hidden=!O,this._loggers.set(F.info.resource,F),this._onDidChangeVisibility.fire([F.info.resource,O]))}getLogLevel(w){let O;return w&&(O=this._loggers.get(w)?.info.logLevel),O??this.logLevel}registerLogger(w){const O=this._loggers.get(w.resource);O?O.info.hidden!==w.hidden&&this.setVisibility(w.resource,!w.hidden):(this._loggers.set(w.resource,{info:w,logger:void 0}),this._onDidChangeLoggers.fire({added:[w],removed:[]}))}deregisterLogger(w){const O=this._loggers.get(w);O&&(O.logger&&O.logger.dispose(),this._loggers.delete(w),this._onDidChangeLoggers.fire({added:[],removed:[O.info]}))}*getRegisteredLoggers(){for(const w of this._loggers.values())yield w.info}getRegisteredLogger(w){return this._loggers.get(w)?.info}dispose(){this._loggers.forEach(w=>w.logger?.dispose()),this._loggers.clear(),super.dispose()}}e.AbstractLoggerService=t;class s{constructor(){this.onDidChangeLogLevel=new _.Emitter().event}setLevel(w){}getLevel(){return I.Info}trace(w,...O){}debug(w,...O){}info(w,...O){}warn(w,...O){}error(w,...O){}critical(w,...O){}dispose(){}flush(){}}e.NullLogger=s;class r extends s{}e.NullLogService=r;function o(b){if(b.verbose)return I.Trace;if(typeof b.logLevel=="string"){const w=A(b.logLevel.toLowerCase());if(w!==void 0)return w}return e.DEFAULT_LOG_LEVEL}function h(b){switch(b){case I.Trace:return"trace";case I.Debug:return"debug";case I.Info:return"info";case I.Warning:return"warn";case I.Error:return"error";case I.Off:return"off"}}function y(b){switch(b){case I.Trace:return{original:"Trace",value:R.localize(1959,null)};case I.Debug:return{original:"Debug",value:R.localize(1960,null)};case I.Info:return{original:"Info",value:R.localize(1961,null)};case I.Warning:return{original:"Warning",value:R.localize(1962,null)};case I.Error:return{original:"Error",value:R.localize(1963,null)};case I.Off:return{original:"Off",value:R.localize(1964,null)}}}function A(b){switch(b){case"trace":return I.Trace;case"debug":return I.Debug;case"info":return I.Info;case"warn":return I.Warning;case"error":return I.Error;case"critical":return I.Error;case"off":return I.Off}}e.CONTEXT_LOG_LEVEL=new m.RawContextKey("logLevel",h(I.Info))}),define(he[173],fe([0,1,6,8,2,22,13,20,30,15,11]),function(ce,e,R,a,_,T,k,L,D,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogsDataCleaner=void 0;let S=class extends _.Disposable{constructor(d,l){super(),this.environmentService=d,this.logService=l,this._register(new R.RunOnceScheduler(()=>{this.cleanUpOldLogs()},10*1e3)).schedule()}async cleanUpOldLogs(){this.logService.trace("[logs cleanup]: Starting to clean up old logs.");try{const d=(0,L.basename)(this.environmentService.logsHome),l=(0,L.dirname)(this.environmentService.logsHome.with({scheme:T.Schemas.file})).fsPath,v=(await D.Promises.readdir(l)).filter(C=>/^\d{8}T\d{6}$/.test(C)).sort().filter(C=>C!==d),f=v.slice(0,Math.max(0,v.length-9));f.length>0&&(this.logService.trace(`[logs cleanup]: Removing log folders '${f.join(", ")}'`),await Promise.all(f.map(C=>D.Promises.rm((0,k.join)(l,C)))))}catch(d){(0,a.onUnexpectedError)(d)}}};e.LogsDataCleaner=S,e.LogsDataCleaner=S=Ie([Y(0,E.IEnvironmentService),Y(1,P.ILogService)],S)}),define(he[174],fe([0,1,17,6,8,3,42,2,13,46,11]),function(ce,e,R,a,_,T,k,L,D,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class S extends L.Disposable{constructor(d,l){super(),this.logService=d,this.options=l,this._onDidChangeFile=this._register(new T.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidWatchError=this._register(new T.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.universalWatchRequests=[],this.universalWatchRequestDelayer=this._register(new a.ThrottledDelayer(0)),this.nonRecursiveWatchRequests=[],this.nonRecursiveWatchRequestDelayer=this._register(new a.ThrottledDelayer(0))}watch(d,l){return l.recursive||this.options?.watcher?.forceUniversal?this.watchUniversal(d,l):this.watchNonRecursive(d,l)}watchUniversal(d,l){const g={path:this.toWatchPath(d),excludes:l.excludes,includes:l.includes,recursive:l.recursive,filter:l.filter,correlationId:l.correlationId},I=(0,R.insert)(this.universalWatchRequests,g);return this.refreshUniversalWatchers(),(0,L.toDisposable)(()=>{I(),this.refreshUniversalWatchers()})}refreshUniversalWatchers(){this.universalWatchRequestDelayer.trigger(()=>this.doRefreshUniversalWatchers()).catch(d=>(0,_.onUnexpectedError)(d))}doRefreshUniversalWatchers(){this.universalWatcher||(this.universalWatcher=this._register(this.createUniversalWatcher(l=>this._onDidChangeFile.fire((0,E.reviveFileChanges)(l)),l=>this.onWatcherLogMessage(l),this.logService.getLevel()===P.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.universalWatcher?.setVerboseLogging(this.logService.getLevel()===P.LogLevel.Trace)})));const d=this.options?.watcher?.recursive?.usePolling;if(d===!0)for(const l of this.universalWatchRequests)(0,E.isRecursiveWatchRequest)(l)&&(l.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(d))for(const l of this.universalWatchRequests)(0,E.isRecursiveWatchRequest)(l)&&d.includes(l.path)&&(l.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);return this.universalWatcher.watch(this.universalWatchRequests)}watchNonRecursive(d,l){const g={path:this.toWatchPath(d),excludes:l.excludes,includes:l.includes,recursive:!1,filter:l.filter,correlationId:l.correlationId},I=(0,R.insert)(this.nonRecursiveWatchRequests,g);return this.refreshNonRecursiveWatchers(),(0,L.toDisposable)(()=>{I(),this.refreshNonRecursiveWatchers()})}refreshNonRecursiveWatchers(){this.nonRecursiveWatchRequestDelayer.trigger(()=>this.doRefreshNonRecursiveWatchers()).catch(d=>(0,_.onUnexpectedError)(d))}doRefreshNonRecursiveWatchers(){return this.nonRecursiveWatcher||(this.nonRecursiveWatcher=this._register(this.createNonRecursiveWatcher(d=>this._onDidChangeFile.fire((0,E.reviveFileChanges)(d)),d=>this.onWatcherLogMessage(d),this.logService.getLevel()===P.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.nonRecursiveWatcher?.setVerboseLogging(this.logService.getLevel()===P.LogLevel.Trace)}))),this.nonRecursiveWatcher.watch(this.nonRecursiveWatchRequests)}onWatcherLogMessage(d){d.type==="error"&&this._onDidWatchError.fire(d.message),this.logWatcherMessage(d)}logWatcherMessage(d){this.logService[d.type](d.message)}toFilePath(d){return(0,D.normalize)(d.fsPath)}toWatchPath(d){const l=this.toFilePath(d);return(0,k.removeTrailingPathSeparator)(l)}}e.AbstractDiskFileSystemProvider=S}),define(he[175],fe([0,1,17,6,14,25,3,55,63,2,51,22,102,20,50,9,7,101,11,8]),function(ce,e,R,a,_,T,k,L,D,E,P,S,m,d,l,g,I,v,f,C){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let c=class extends E.Disposable{static{p=this}constructor(i){super(),this.logService=i,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new k.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new k.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new k.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new k.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this.internalOnDidFilesChange=this._register(new k.Emitter),this._onDidUncorrelatedFilesChange=this._register(new k.Emitter),this.onDidFilesChange=this._onDidUncorrelatedFilesChange.event,this._onDidWatchError=this._register(new k.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.activeWatchers=new Map,this.writeQueue=this._register(new a.ResourceQueue)}registerProvider(i,n){if(this.provider.has(i))throw new Error(`A filesystem provider for the scheme '${i}' is already registered.`);(0,m.mark)(`code/registerFilesystem/${i}`);const t=new E.DisposableStore;return this.provider.set(i,n),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:i,provider:n}),t.add(n.onDidChangeFile(s=>{const r=new I.FileChangesEvent(s,!this.isPathCaseSensitive(n));this.internalOnDidFilesChange.fire(r),r.hasCorrelation()||this._onDidUncorrelatedFilesChange.fire(r)})),typeof n.onDidWatchError=="function"&&t.add(n.onDidWatchError(s=>this._onDidWatchError.fire(new Error(s)))),t.add(n.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:n,scheme:i}))),(0,E.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:i,provider:n}),this.provider.delete(i),(0,E.dispose)(t)})}getProvider(i){return this.provider.get(i)}async activateProvider(i){const n=[];this._onWillActivateFileSystemProvider.fire({scheme:i,join(t){n.push(t)}}),!this.provider.has(i)&&await a.Promises.settled(n)}async canHandleResource(i){return await this.activateProvider(i.scheme),this.hasProvider(i)}hasProvider(i){return this.provider.has(i.scheme)}hasCapability(i,n){const t=this.provider.get(i.scheme);return!!(t&&t.capabilities&n)}listCapabilities(){return D.Iterable.map(this.provider,([i,n])=>({scheme:i,capabilities:n.capabilities}))}async withProvider(i){if(!(0,d.isAbsolutePath)(i))throw new I.FileOperationError((0,g.localize)(1871,null,this.resourceForError(i)),I.FileOperationResult.FILE_INVALID_PATH);await this.activateProvider(i.scheme);const n=this.provider.get(i.scheme);if(!n){const t=new C.ErrorNoTelemetry;throw t.message=(0,g.localize)(1872,null,i.toString()),t}return n}async withReadProvider(i){const n=await this.withProvider(i);if((0,I.hasOpenReadWriteCloseCapability)(n)||(0,I.hasReadWriteCapability)(n)||(0,I.hasFileReadStreamCapability)(n))return n;throw new Error(`Filesystem provider for scheme '${i.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(i){const n=await this.withProvider(i);if((0,I.hasOpenReadWriteCloseCapability)(n)||(0,I.hasReadWriteCapability)(n))return n;throw new Error(`Filesystem provider for scheme '${i.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(i,n){try{return await this.doResolveFile(i,n)}catch(t){throw(0,I.toFileSystemProviderErrorCode)(t)===I.FileSystemProviderErrorCode.FileNotFound?new I.FileOperationError((0,g.localize)(1873,null,this.resourceForError(i)),I.FileOperationResult.FILE_NOT_FOUND):(0,I.ensureFileSystemProviderError)(t)}}async doResolveFile(i,n){const t=await this.withProvider(i),s=this.isPathCaseSensitive(t),r=n?.resolveTo,o=n?.resolveSingleChildDescendants,h=n?.resolveMetadata,y=await t.stat(i);let A;return this.toFileStat(t,i,y,void 0,!!h,(b,w)=>(A||(A=P.TernarySearchTree.forUris(()=>!s),A.set(i,!0),r&&A.fill(!0,r)),A.get(b.resource)||A.findSuperstr(b.resource.with({query:null,fragment:null}))?!0:b.isDirectory&&o?w===1:!1))}async toFileStat(i,n,t,s,r,o){const{providerExtUri:h}=this.getExtUri(i),y={resource:n,name:h.basename(n),isFile:(t.type&I.FileType.File)!==0,isDirectory:(t.type&I.FileType.Directory)!==0,isSymbolicLink:(t.type&I.FileType.SymbolicLink)!==0,mtime:t.mtime,ctime:t.ctime,size:t.size,readonly:!!((t.permissions??0)&I.FilePermission.Readonly)||!!(i.capabilities&I.FileSystemProviderCapabilities.Readonly),locked:!!((t.permissions??0)&I.FilePermission.Locked),etag:(0,I.etag)({mtime:t.mtime,size:t.size}),children:void 0};if(y.isDirectory&&o(y,s)){try{const A=await i.readdir(n),b=await a.Promises.settled(A.map(async([w,O])=>{try{const F=h.joinPath(n,w),N=r?await i.stat(F):{type:O};return await this.toFileStat(i,F,N,A.length,r,o)}catch(F){return this.logService.trace(F),null}}));y.children=(0,R.coalesce)(b)}catch(A){this.logService.trace(A),y.children=[]}return y}return y}async resolveAll(i){return a.Promises.settled(i.map(async n=>{try{return{stat:await this.doResolveFile(n.resource,n.options),success:!0}}catch(t){return this.logService.trace(t),{stat:void 0,success:!1}}}))}async stat(i){const n=await this.withProvider(i),t=await n.stat(i);return this.toFileStat(n,i,t,void 0,!0,()=>!1)}async exists(i){const n=await this.withProvider(i);try{return!!await n.stat(i)}catch{return!1}}async canCreateFile(i,n){try{await this.doValidateCreateFile(i,n)}catch(t){return t}return!0}async doValidateCreateFile(i,n){if(!n?.overwrite&&await this.exists(i))throw new I.FileOperationError((0,g.localize)(1874,null,this.resourceForError(i)),I.FileOperationResult.FILE_MODIFIED_SINCE,n)}async createFile(i,n=_.VSBuffer.fromString(""),t){await this.doValidateCreateFile(i,t);const s=await this.writeFile(i,n);return this._onDidRunOperation.fire(new I.FileOperationEvent(i,I.FileOperation.CREATE,s)),s}async writeFile(i,n,t){const s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(i),i),{providerExtUri:r}=this.getExtUri(s);let o=t;if((0,I.hasFileAtomicWriteCapability)(s)&&!o?.atomic){const h=s.enforceAtomicWriteFile?.(i);h&&(o={...t,atomic:h})}try{await this.validateWriteFile(s,i,o)||await this.mkdirp(s,r.dirname(i));let y;if((0,I.hasReadWriteCapability)(s)&&!(n instanceof _.VSBuffer))if((0,l.isReadableStream)(n)){const A=await(0,l.peekStream)(n,3);A.ended?y=_.VSBuffer.concat(A.buffer):y=A}else y=(0,l.peekReadable)(n,A=>_.VSBuffer.concat(A),3);else y=n;!(0,I.hasOpenReadWriteCloseCapability)(s)||(0,I.hasReadWriteCapability)(s)&&y instanceof _.VSBuffer||(0,I.hasReadWriteCapability)(s)&&(0,I.hasFileAtomicWriteCapability)(s)&&o?.atomic?await this.doWriteUnbuffered(s,i,o,y):await this.doWriteBuffered(s,i,o,y instanceof _.VSBuffer?(0,_.bufferToReadable)(y):y),this._onDidRunOperation.fire(new I.FileOperationEvent(i,I.FileOperation.WRITE))}catch(h){throw new I.FileOperationError((0,g.localize)(1875,null,this.resourceForError(i),(0,I.ensureFileSystemProviderError)(h).toString()),(0,I.toFileOperationResult)(h),o)}return this.resolve(i,{resolveMetadata:!0})}async validateWriteFile(i,n,t){const s=!!t?.unlock;if(s&&!(i.capabilities&I.FileSystemProviderCapabilities.FileWriteUnlock))throw new Error((0,g.localize)(1876,null,this.resourceForError(n)));if(!!t?.atomic){if(!(i.capabilities&I.FileSystemProviderCapabilities.FileAtomicWrite))throw new Error((0,g.localize)(1877,null,this.resourceForError(n)));if(!(i.capabilities&I.FileSystemProviderCapabilities.FileReadWrite))throw new Error((0,g.localize)(1878,null,this.resourceForError(n)));if(s)throw new Error((0,g.localize)(1879,null,this.resourceForError(n)))}let o;try{o=await i.stat(n)}catch{return}if(o.type&I.FileType.Directory)throw new I.FileOperationError((0,g.localize)(1880,null,this.resourceForError(n)),I.FileOperationResult.FILE_IS_DIRECTORY,t);if(this.throwIfFileIsReadonly(n,o),typeof t?.mtime=="number"&&typeof t.etag=="string"&&t.etag!==I.ETAG_DISABLED&&typeof o.mtime=="number"&&typeof o.size=="number"&&t.mtime<o.mtime&&t.etag!==(0,I.etag)({mtime:t.mtime,size:o.size}))throw new I.FileOperationError((0,g.localize)(1881,null),I.FileOperationResult.FILE_MODIFIED_SINCE,t);return o}async readFile(i,n,t){const s=await this.withReadProvider(i);return n?.atomic?this.doReadFileAtomic(s,i,n,t):this.doReadFile(s,i,n,t)}async doReadFileAtomic(i,n,t,s){return new Promise((r,o)=>{this.writeQueue.queueFor(n,async()=>{try{const h=await this.doReadFile(i,n,t,s);r(h)}catch(h){o(h)}},this.getExtUri(i).providerExtUri)})}async doReadFile(i,n,t,s){const r=await this.doReadFileStream(i,n,{...t,preferUnbuffered:!0},s);return{...r,value:await(0,_.streamToBuffer)(r.value)}}async readFileStream(i,n,t){const s=await this.withReadProvider(i);return this.doReadFileStream(s,i,n,t)}async doReadFileStream(i,n,t,s){const r=new T.CancellationTokenSource(s);let o=t;(0,I.hasFileAtomicReadCapability)(i)&&i.enforceAtomicReadFile?.(n)&&(o={...t,atomic:!0});const h=this.validateReadFile(n,o).then(A=>A,A=>{throw r.dispose(!0),A});let y;try{return typeof o?.etag=="string"&&o.etag!==I.ETAG_DISABLED&&await h,o?.atomic&&(0,I.hasFileAtomicReadCapability)(i)||!((0,I.hasOpenReadWriteCloseCapability)(i)||(0,I.hasFileReadStreamCapability)(i))||(0,I.hasReadWriteCapability)(i)&&o?.preferUnbuffered?y=this.readFileUnbuffered(i,n,o):(0,I.hasFileReadStreamCapability)(i)?y=this.readFileStreamed(i,n,r.token,o):y=this.readFileBuffered(i,n,r.token,o),y.on("end",()=>r.dispose()),y.on("error",()=>r.dispose()),{...await h,value:y}}catch(A){throw y&&await(0,l.consumeStream)(y),this.restoreReadError(A,n,o)}}restoreReadError(i,n,t){const s=(0,g.localize)(1882,null,this.resourceForError(n),(0,I.ensureFileSystemProviderError)(i).toString());return i instanceof I.NotModifiedSinceFileOperationError?new I.NotModifiedSinceFileOperationError(s,i.stat,t):i instanceof I.TooLargeFileOperationError?new I.TooLargeFileOperationError(s,i.fileOperationResult,i.size,i.options):new I.FileOperationError(s,(0,I.toFileOperationResult)(i),t)}readFileStreamed(i,n,t,s=Object.create(null)){const r=i.readFileStream(n,s,t);return(0,l.transform)(r,{data:o=>o instanceof _.VSBuffer?o:_.VSBuffer.wrap(o),error:o=>this.restoreReadError(o,n,s)},o=>_.VSBuffer.concat(o))}readFileBuffered(i,n,t,s=Object.create(null)){const r=(0,_.newWriteableBufferStream)();return(0,v.readFileIntoStream)(i,n,r,o=>o,{...s,bufferSize:this.BUFFER_SIZE,errorTransformer:o=>this.restoreReadError(o,n,s)},t),r}readFileUnbuffered(i,n,t){const s=(0,l.newWriteableStream)(r=>_.VSBuffer.concat(r));return(async()=>{try{let r;t?.atomic&&(0,I.hasFileAtomicReadCapability)(i)?r=await i.readFile(n,{atomic:!0}):r=await i.readFile(n),typeof t?.position=="number"&&(r=r.slice(t.position)),typeof t?.length=="number"&&(r=r.slice(0,t.length)),this.validateReadFileLimits(n,r.byteLength,t),s.end(_.VSBuffer.wrap(r))}catch(r){s.error(r),s.end()}})(),s}async validateReadFile(i,n){const t=await this.resolve(i,{resolveMetadata:!0});if(t.isDirectory)throw new I.FileOperationError((0,g.localize)(1883,null,this.resourceForError(i)),I.FileOperationResult.FILE_IS_DIRECTORY,n);if(typeof n?.etag=="string"&&n.etag!==I.ETAG_DISABLED&&n.etag===t.etag)throw new I.NotModifiedSinceFileOperationError((0,g.localize)(1884,null),t,n);return this.validateReadFileLimits(i,t.size,n),t}validateReadFileLimits(i,n,t){if(typeof t?.limits?.size=="number"&&n>t.limits.size)throw new I.TooLargeFileOperationError((0,g.localize)(1885,null,this.resourceForError(i)),I.FileOperationResult.FILE_TOO_LARGE,n,t)}async canMove(i,n,t){return this.doCanMoveCopy(i,n,"move",t)}async canCopy(i,n,t){return this.doCanMoveCopy(i,n,"copy",t)}async doCanMoveCopy(i,n,t,s){if(i.toString()!==n.toString())try{const r=t==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(i),i):await this.withReadProvider(i),o=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(n),n);await this.doValidateMoveCopy(r,i,o,n,t,s)}catch(r){return r}return!0}async move(i,n,t){const s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(i),i),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(n),n),o=await this.doMoveCopy(s,i,r,n,"move",!!t),h=await this.resolve(n,{resolveMetadata:!0});return this._onDidRunOperation.fire(new I.FileOperationEvent(i,o==="move"?I.FileOperation.MOVE:I.FileOperation.COPY,h)),h}async copy(i,n,t){const s=await this.withReadProvider(i),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(n),n),o=await this.doMoveCopy(s,i,r,n,"copy",!!t),h=await this.resolve(n,{resolveMetadata:!0});return this._onDidRunOperation.fire(new I.FileOperationEvent(i,o==="copy"?I.FileOperation.COPY:I.FileOperation.MOVE,h)),h}async doMoveCopy(i,n,t,s,r,o){if(n.toString()===s.toString())return r;const{exists:h,isSameResourceWithDifferentPathCase:y}=await this.doValidateMoveCopy(i,n,t,s,r,o);if(h&&!y&&o&&await this.del(s,{recursive:!0}),await this.mkdirp(t,this.getExtUri(t).providerExtUri.dirname(s)),r==="copy"){if(i===t&&(0,I.hasFileFolderCopyCapability)(i))await i.copy(n,s,{overwrite:o});else{const A=await this.resolve(n);A.isDirectory?await this.doCopyFolder(i,A,t,s):await this.doCopyFile(i,n,t,s)}return r}else return i===t?(await i.rename(n,s,{overwrite:o}),r):(await this.doMoveCopy(i,n,t,s,"copy",o),await this.del(n,{recursive:!0}),"copy")}async doCopyFile(i,n,t,s){if((0,I.hasOpenReadWriteCloseCapability)(i)&&(0,I.hasOpenReadWriteCloseCapability)(t))return this.doPipeBuffered(i,n,t,s);if((0,I.hasOpenReadWriteCloseCapability)(i)&&(0,I.hasReadWriteCapability)(t))return this.doPipeBufferedToUnbuffered(i,n,t,s);if((0,I.hasReadWriteCapability)(i)&&(0,I.hasOpenReadWriteCloseCapability)(t))return this.doPipeUnbufferedToBuffered(i,n,t,s);if((0,I.hasReadWriteCapability)(i)&&(0,I.hasReadWriteCapability)(t))return this.doPipeUnbuffered(i,n,t,s)}async doCopyFolder(i,n,t,s){await t.mkdir(s),Array.isArray(n.children)&&await a.Promises.settled(n.children.map(async r=>{const o=this.getExtUri(t).providerExtUri.joinPath(s,r.name);return r.isDirectory?this.doCopyFolder(i,await this.resolve(r.resource),t,o):this.doCopyFile(i,r.resource,t,o)}))}async doValidateMoveCopy(i,n,t,s,r,o){let h=!1;if(i===t){const{providerExtUri:A,isPathCaseSensitive:b}=this.getExtUri(i);if(b||(h=A.isEqual(n,s)),h&&r==="copy")throw new Error((0,g.localize)(1886,null,this.resourceForError(n),this.resourceForError(s)));if(!h&&A.isEqualOrParent(s,n))throw new Error((0,g.localize)(1887,null,this.resourceForError(n),this.resourceForError(s)))}const y=await this.exists(s);if(y&&!h){if(!o)throw new I.FileOperationError((0,g.localize)(1888,null,this.resourceForError(n),this.resourceForError(s)),I.FileOperationResult.FILE_MOVE_CONFLICT);if(i===t){const{providerExtUri:A}=this.getExtUri(i);if(A.isEqualOrParent(n,s))throw new Error((0,g.localize)(1889,null,this.resourceForError(n),this.resourceForError(s)))}}return{exists:y,isSameResourceWithDifferentPathCase:h}}getExtUri(i){const n=this.isPathCaseSensitive(i);return{providerExtUri:n?d.extUri:d.extUriIgnorePathCase,isPathCaseSensitive:n}}isPathCaseSensitive(i){return!!(i.capabilities&I.FileSystemProviderCapabilities.PathCaseSensitive)}async createFolder(i){const n=this.throwIfFileSystemIsReadonly(await this.withProvider(i),i);await this.mkdirp(n,i);const t=await this.resolve(i,{resolveMetadata:!0});return this._onDidRunOperation.fire(new I.FileOperationEvent(i,I.FileOperation.CREATE,t)),t}async mkdirp(i,n){const t=[],{providerExtUri:s}=this.getExtUri(i);for(;!s.isEqual(n,s.dirname(n));)try{if(!((await i.stat(n)).type&I.FileType.Directory))throw new Error((0,g.localize)(1890,null,this.resourceForError(n)));break}catch(r){if((0,I.toFileSystemProviderErrorCode)(r)!==I.FileSystemProviderErrorCode.FileNotFound)throw r;t.push(s.basename(n)),n=s.dirname(n)}for(let r=t.length-1;r>=0;r--){n=s.joinPath(n,t[r]);try{await i.mkdir(n)}catch(o){if((0,I.toFileSystemProviderErrorCode)(o)!==I.FileSystemProviderErrorCode.FileExists)throw o}}}async canDelete(i,n){try{await this.doValidateDelete(i,n)}catch(t){return t}return!0}async doValidateDelete(i,n){const t=this.throwIfFileSystemIsReadonly(await this.withProvider(i),i),s=!!n?.useTrash;if(s&&!(t.capabilities&I.FileSystemProviderCapabilities.Trash))throw new Error((0,g.localize)(1891,null,this.resourceForError(i)));const r=n?.atomic;if(r&&!(t.capabilities&I.FileSystemProviderCapabilities.FileAtomicDelete))throw new Error((0,g.localize)(1892,null,this.resourceForError(i)));if(s&&r)throw new Error((0,g.localize)(1893,null,this.resourceForError(i)));let o;try{o=await t.stat(i)}catch{}if(o)this.throwIfFileIsReadonly(i,o);else throw new I.FileOperationError((0,g.localize)(1894,null,this.resourceForError(i)),I.FileOperationResult.FILE_NOT_FOUND);if(!!!n?.recursive){const y=await this.resolve(i);if(y.isDirectory&&Array.isArray(y.children)&&y.children.length>0)throw new Error((0,g.localize)(1895,null,this.resourceForError(i)))}return t}async del(i,n){const t=await this.doValidateDelete(i,n);let s=n;if((0,I.hasFileAtomicDeleteCapability)(t)&&!s?.atomic){const y=t.enforceAtomicDelete?.(i);y&&(s={...n,atomic:y})}const r=!!s?.useTrash,o=!!s?.recursive,h=s?.atomic??!1;await t.delete(i,{recursive:o,useTrash:r,atomic:h}),this._onDidRunOperation.fire(new I.FileOperationEvent(i,I.FileOperation.DELETE))}async cloneFile(i,n){const t=await this.withProvider(i),s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(n),n);if(!(t===s&&this.getExtUri(t).providerExtUri.isEqual(i,n)))return t===s&&(0,I.hasFileCloneCapability)(t)?t.cloneFile(i,n):(await this.mkdirp(s,this.getExtUri(s).providerExtUri.dirname(n)),t===s&&(0,I.hasFileFolderCopyCapability)(t)?this.writeQueue.queueFor(i,()=>t.copy(i,n,{overwrite:!0}),this.getExtUri(t).providerExtUri):this.writeQueue.queueFor(i,()=>this.doCopyFile(t,i,s,n),this.getExtUri(t).providerExtUri))}static{this.WATCHER_CORRELATION_IDS=0}createWatcher(i,n){return this.watch(i,{...n,correlationId:p.WATCHER_CORRELATION_IDS++})}watch(i,n={recursive:!1,excludes:[]}){const t=new E.DisposableStore;let s=!1,r=()=>{s=!0};t.add((0,E.toDisposable)(()=>r())),(async()=>{try{const h=await this.doWatch(i,n);s?(0,E.dispose)(h):r=()=>(0,E.dispose)(h)}catch(h){this.logService.error(h)}})();const o=n.correlationId;if(typeof o=="number"){const h=t.add(new k.Emitter);return t.add(this.internalOnDidFilesChange.event(A=>{A.correlates(o)&&h.fire(A)})),{onDidChange:h.event,dispose:()=>t.dispose()}}return t}async doWatch(i,n){const t=await this.withProvider(i),s=(0,L.hash)([this.getExtUri(t).providerExtUri.getComparisonKey(i),n]);let r=this.activeWatchers.get(s);return r||(r={count:0,disposable:t.watch(i,n)},this.activeWatchers.set(s,r)),r.count+=1,(0,E.toDisposable)(()=>{r&&(r.count--,r.count===0&&((0,E.dispose)(r.disposable),this.activeWatchers.delete(s)))})}dispose(){super.dispose();for(const[,i]of this.activeWatchers)(0,E.dispose)(i.disposable);this.activeWatchers.clear()}async doWriteBuffered(i,n,t,s){return this.writeQueue.queueFor(n,async()=>{const r=await i.open(n,{create:!0,unlock:t?.unlock??!1});try{(0,l.isReadableStream)(s)||(0,l.isReadableBufferedStream)(s)?await this.doWriteStreamBufferedQueued(i,r,s):await this.doWriteReadableBufferedQueued(i,r,s)}catch(o){throw(0,I.ensureFileSystemProviderError)(o)}finally{await i.close(r)}},this.getExtUri(i).providerExtUri)}async doWriteStreamBufferedQueued(i,n,t){let s=0,r;if((0,l.isReadableBufferedStream)(t)){if(t.buffer.length>0){const o=_.VSBuffer.concat(t.buffer);await this.doWriteBuffer(i,n,o,o.byteLength,s,0),s+=o.byteLength}if(t.ended)return;r=t.stream}else r=t;return new Promise((o,h)=>{(0,l.listenStream)(r,{onData:async y=>{r.pause();try{await this.doWriteBuffer(i,n,y,y.byteLength,s,0)}catch(A){return h(A)}s+=y.byteLength,setTimeout(()=>r.resume())},onError:y=>h(y),onEnd:()=>o()})})}async doWriteReadableBufferedQueued(i,n,t){let s=0,r;for(;(r=t.read())!==null;)await this.doWriteBuffer(i,n,r,r.byteLength,s,0),s+=r.byteLength}async doWriteBuffer(i,n,t,s,r,o){let h=0;for(;h<s;){const y=await i.write(n,r+h,t.buffer,o+h,s-h);h+=y}}async doWriteUnbuffered(i,n,t,s){return this.writeQueue.queueFor(n,()=>this.doWriteUnbufferedQueued(i,n,t,s),this.getExtUri(i).providerExtUri)}async doWriteUnbufferedQueued(i,n,t,s){let r;s instanceof _.VSBuffer?r=s:(0,l.isReadableStream)(s)?r=await(0,_.streamToBuffer)(s):(0,l.isReadableBufferedStream)(s)?r=await(0,_.bufferedStreamToBuffer)(s):r=(0,_.readableToBuffer)(s),await i.writeFile(n,r.buffer,{create:!0,overwrite:!0,unlock:t?.unlock??!1,atomic:t?.atomic??!1})}async doPipeBuffered(i,n,t,s){return this.writeQueue.queueFor(s,()=>this.doPipeBufferedQueued(i,n,t,s),this.getExtUri(t).providerExtUri)}async doPipeBufferedQueued(i,n,t,s){let r,o;try{r=await i.open(n,{create:!1}),o=await t.open(s,{create:!0,unlock:!1});const h=_.VSBuffer.alloc(this.BUFFER_SIZE);let y=0,A=0,b=0;do b=await i.read(r,y,h.buffer,A,h.byteLength-A),await this.doWriteBuffer(t,o,h,b,y,A),y+=b,A+=b,A===h.byteLength&&(A=0);while(b>0)}catch(h){throw(0,I.ensureFileSystemProviderError)(h)}finally{await a.Promises.settled([typeof r=="number"?i.close(r):Promise.resolve(),typeof o=="number"?t.close(o):Promise.resolve()])}}async doPipeUnbuffered(i,n,t,s){return this.writeQueue.queueFor(s,()=>this.doPipeUnbufferedQueued(i,n,t,s),this.getExtUri(t).providerExtUri)}async doPipeUnbufferedQueued(i,n,t,s){return t.writeFile(s,await i.readFile(n),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async doPipeUnbufferedToBuffered(i,n,t,s){return this.writeQueue.queueFor(s,()=>this.doPipeUnbufferedToBufferedQueued(i,n,t,s),this.getExtUri(t).providerExtUri)}async doPipeUnbufferedToBufferedQueued(i,n,t,s){const r=await t.open(s,{create:!0,unlock:!1});try{const o=await i.readFile(n);await this.doWriteBuffer(t,r,_.VSBuffer.wrap(o),o.byteLength,0,0)}catch(o){throw(0,I.ensureFileSystemProviderError)(o)}finally{await t.close(r)}}async doPipeBufferedToUnbuffered(i,n,t,s){const r=await(0,_.streamToBuffer)(this.readFileBuffered(i,n,T.CancellationToken.None));await this.doWriteUnbuffered(t,s,void 0,r)}throwIfFileSystemIsReadonly(i,n){if(i.capabilities&I.FileSystemProviderCapabilities.Readonly)throw new I.FileOperationError((0,g.localize)(1896,null,this.resourceForError(n)),I.FileOperationResult.FILE_PERMISSION_DENIED);return i}throwIfFileIsReadonly(i,n){if((n.permissions??0)&I.FilePermission.Readonly)throw new I.FileOperationError((0,g.localize)(1897,null,this.resourceForError(i)),I.FileOperationResult.FILE_PERMISSION_DENIED)}resourceForError(i){return i.scheme===S.Schemas.file?i.fsPath:i.toString(!0)}};e.FileService=c,e.FileService=c=p=Ie([Y(0,f.ILogService)],c)}),define(he[176],fe([0,1,33,6,31,14,3,42,2,13,5,20,50,30,9,7,101,174,171,170]),function(ce,e,R,a,_,T,k,L,D,E,P,S,m,d,l,g,I,v,f,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0;class p extends v.AbstractDiskFileSystemProvider{static{this.TRACE_LOG_RESOURCE_LOCKS=!1}constructor(u,i){super(u,i),this.onDidChangeCapabilities=k.Event.None,this.resourceLocks=new _.ResourceMap(n=>S.extUriBiasedIgnorePathCase.getComparisonKey(n)),this.mapHandleToPos=new Map,this.mapHandleToLock=new Map,this.writeHandles=new Map}get capabilities(){return this._capabilities||(this._capabilities=g.FileSystemProviderCapabilities.FileReadWrite|g.FileSystemProviderCapabilities.FileOpenReadWriteClose|g.FileSystemProviderCapabilities.FileReadStream|g.FileSystemProviderCapabilities.FileFolderCopy|g.FileSystemProviderCapabilities.FileWriteUnlock|g.FileSystemProviderCapabilities.FileAtomicRead|g.FileSystemProviderCapabilities.FileAtomicWrite|g.FileSystemProviderCapabilities.FileAtomicDelete|g.FileSystemProviderCapabilities.FileClone,P.isLinux&&(this._capabilities|=g.FileSystemProviderCapabilities.PathCaseSensitive)),this._capabilities}async stat(u){try{const{stat:i,symbolicLink:n}=await d.SymlinkSupport.stat(this.toFilePath(u));return{type:this.toType(i,n),ctime:i.birthtime.getTime(),mtime:i.mtime.getTime(),size:i.size,permissions:i.mode&128?void 0:g.FilePermission.Locked}}catch(i){throw this.toFileSystemProviderError(i)}}async statIgnoreError(u){try{return await this.stat(u)}catch{return}}async readdir(u){try{const i=await d.Promises.readdir(this.toFilePath(u),{withFileTypes:!0}),n=[];return await Promise.all(i.map(async t=>{try{let s;t.isSymbolicLink()?s=(await this.stat((0,S.joinPath)(u,t.name))).type:s=this.toType(t),n.push([t.name,s])}catch(s){this.logService.trace(s)}})),n}catch(i){throw this.toFileSystemProviderError(i)}}toType(u,i){let n;return i?.dangling?n=g.FileType.Unknown:u.isFile()?n=g.FileType.File:u.isDirectory()?n=g.FileType.Directory:n=g.FileType.Unknown,i&&(n|=g.FileType.SymbolicLink),n}async createResourceLock(u){const i=this.toFilePath(u);this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${i})`);let n;for(;n=this.resourceLocks.get(u);)this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${i})`),await n.wait();const t=new a.Barrier;return this.resourceLocks.set(u,t),this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${i})`),(0,D.toDisposable)(()=>{this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${i})`),this.resourceLocks.get(u)===t&&(this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${i})`),this.resourceLocks.delete(u)),this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${i})`),t.open()})}async readFile(u,i){let n;try{i?.atomic&&(this.traceLock(`[Disk FileSystemProvider]: atomic read operation started (${this.toFilePath(u)})`),n=await this.createResourceLock(u));const t=this.toFilePath(u);return await R.promises.readFile(t)}catch(t){throw this.toFileSystemProviderError(t)}finally{n?.dispose()}}traceLock(u){p.TRACE_LOG_RESOURCE_LOCKS&&this.logService.trace(u)}readFileStream(u,i,n){const t=(0,m.newWriteableStream)(s=>T.VSBuffer.concat(s.map(r=>T.VSBuffer.wrap(r))).buffer);return(0,I.readFileIntoStream)(this,u,t,s=>s.buffer,{...i,bufferSize:256*1024},n),t}async writeFile(u,i,n){return n?.atomic!==!1&&n?.atomic?.postfix&&await this.canWriteFileAtomic(u)?this.doWriteFileAtomic(u,(0,S.joinPath)((0,S.dirname)(u),`${(0,S.basename)(u)}${n.atomic.postfix}`),i,n):this.doWriteFile(u,i,n)}async canWriteFileAtomic(u){try{const i=this.toFilePath(u),{symbolicLink:n}=await d.SymlinkSupport.stat(i);if(n)return!1}catch{}return!0}async doWriteFileAtomic(u,i,n,t){const s=new D.DisposableStore;try{s.add(await this.createResourceLock(u)),s.add(await this.createResourceLock(i)),await this.doWriteFile(i,n,t,!0);try{await this.rename(i,u,{overwrite:!0})}catch(r){try{await this.delete(i,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw r}}finally{s.dispose()}}async doWriteFile(u,i,n,t){let s;try{const r=this.toFilePath(u);if(!n.create||!n.overwrite){if(await d.Promises.exists(r)){if(!n.overwrite)throw(0,g.createFileSystemProviderError)((0,l.localize)(1901,null),g.FileSystemProviderErrorCode.FileExists)}else if(!n.create)throw(0,g.createFileSystemProviderError)((0,l.localize)(1902,null),g.FileSystemProviderErrorCode.FileNotFound)}s=await this.open(u,{create:!0,unlock:n.unlock},t),await this.write(s,0,i,0,i.byteLength)}catch(r){throw await this.toFileSystemProviderWriteError(u,r)}finally{typeof s=="number"&&await this.close(s)}}static{this.canFlush=!0}static configureFlushOnWrite(u){p.canFlush=u}async open(u,i,n){const t=this.toFilePath(u);let s;(0,g.isFileOpenForWriteOptions)(i)&&!n&&(s=await this.createResourceLock(u));let r;try{if((0,g.isFileOpenForWriteOptions)(i)&&i.unlock)try{const{stat:h}=await d.SymlinkSupport.stat(t);h.mode&128||await R.promises.chmod(t,h.mode|128)}catch(h){h.code!=="ENOENT"&&this.logService.trace(h)}let o;if((0,g.isFileOpenForWriteOptions)(i)){if(P.isWindows)try{await R.promises.truncate(t,0),o="r+"}catch(h){h.code!=="ENOENT"&&this.logService.trace(h)}o||(o="w")}else o="r";r=await d.Promises.open(t,o)}catch(o){throw s?.dispose(),(0,g.isFileOpenForWriteOptions)(i)?await this.toFileSystemProviderWriteError(u,o):this.toFileSystemProviderError(o)}if(this.mapHandleToPos.set(r,0),(0,g.isFileOpenForWriteOptions)(i)&&this.writeHandles.set(r,u),s){const o=this.mapHandleToLock.get(r);this.traceLock(`[Disk FileSystemProvider]: open() - storing lock for handle ${r} (${t})`),this.mapHandleToLock.set(r,s),o&&(this.traceLock(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${r} (${t})`),o.dispose())}return r}async close(u){const i=this.mapHandleToLock.get(u);try{if(this.mapHandleToPos.delete(u),this.writeHandles.delete(u)&&p.canFlush)try{await d.Promises.fdatasync(u)}catch(n){p.configureFlushOnWrite(!1),this.logService.error(n)}return await d.Promises.close(u)}catch(n){throw this.toFileSystemProviderError(n)}finally{i&&(this.mapHandleToLock.get(u)===i&&(this.traceLock(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${u}`),this.mapHandleToLock.delete(u)),this.traceLock(`[Disk FileSystemProvider]: close() - disposing lock for handle ${u}`),i.dispose())}}async read(u,i,n,t,s){const r=this.normalizePos(u,i);let o=null;try{o=(await d.Promises.read(u,n,t,s,r)).bytesRead}catch(h){throw this.toFileSystemProviderError(h)}finally{this.updatePos(u,r,o)}return o}normalizePos(u,i){return i===this.mapHandleToPos.get(u)?null:i}updatePos(u,i,n){const t=this.mapHandleToPos.get(u);typeof t=="number"&&(typeof i=="number"||(typeof n=="number"?this.mapHandleToPos.set(u,t+n):this.mapHandleToPos.delete(u)))}async write(u,i,n,t,s){return(0,a.retry)(()=>this.doWrite(u,i,n,t,s),100,3)}async doWrite(u,i,n,t,s){const r=this.normalizePos(u,i);let o=null;try{o=(await d.Promises.write(u,n,t,s,r)).bytesWritten}catch(h){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(u),h)}finally{this.updatePos(u,r,o)}return o}async mkdir(u){try{await R.promises.mkdir(this.toFilePath(u))}catch(i){throw this.toFileSystemProviderError(i)}}async delete(u,i){try{const n=this.toFilePath(u);if(i.recursive){let t;i?.atomic!==!1&&i.atomic.postfix&&(t=(0,E.join)((0,E.dirname)(n),`${(0,E.basename)(n)}${i.atomic.postfix}`)),await d.Promises.rm(n,d.RimRafMode.MOVE,t)}else try{await R.promises.unlink(n)}catch(t){if(t.code==="EPERM"||t.code==="EISDIR"){let s=!1;try{const{stat:r,symbolicLink:o}=await d.SymlinkSupport.stat(n);s=r.isDirectory()&&!o}catch{}if(s)await R.promises.rmdir(n);else throw t}else throw t}}catch(n){throw this.toFileSystemProviderError(n)}}async rename(u,i,n){const t=this.toFilePath(u),s=this.toFilePath(i);if(t!==s)try{await this.validateMoveCopy(u,i,"move",n.overwrite),await d.Promises.rename(t,s)}catch(r){throw(r.code==="EINVAL"||r.code==="EBUSY"||r.code==="ENAMETOOLONG")&&(r=new Error((0,l.localize)(1903,null,(0,E.basename)(t),(0,E.basename)((0,E.dirname)(s)),r.toString()))),this.toFileSystemProviderError(r)}}async copy(u,i,n){const t=this.toFilePath(u),s=this.toFilePath(i);if(t!==s)try{await this.validateMoveCopy(u,i,"copy",n.overwrite),await d.Promises.copy(t,s,{preserveSymlinks:!0})}catch(r){throw(r.code==="EINVAL"||r.code==="EBUSY"||r.code==="ENAMETOOLONG")&&(r=new Error((0,l.localize)(1904,null,(0,E.basename)(t),(0,E.basename)((0,E.dirname)(s)),r.toString()))),this.toFileSystemProviderError(r)}}async validateMoveCopy(u,i,n,t){const s=this.toFilePath(u),r=this.toFilePath(i);let o=!1;if(!!(this.capabilities&g.FileSystemProviderCapabilities.PathCaseSensitive)||(o=(0,L.isEqual)(s,r,!0)),o){if(n==="copy")throw(0,g.createFileSystemProviderError)((0,l.localize)(1905,null),g.FileSystemProviderErrorCode.FileExists);if(n==="move")return}const y=await this.statIgnoreError(u);if(!y)throw(0,g.createFileSystemProviderError)((0,l.localize)(1906,null),g.FileSystemProviderErrorCode.FileNotFound);const A=await this.statIgnoreError(i);if(A){if(!t)throw(0,g.createFileSystemProviderError)((0,l.localize)(1907,null),g.FileSystemProviderErrorCode.FileExists);y.type&g.FileType.File&&A.type&g.FileType.File||await this.delete(i,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(u,i){return this.doCloneFile(u,i,!1)}async doCloneFile(u,i,n){const t=this.toFilePath(u),s=this.toFilePath(i),r=!!(this.capabilities&g.FileSystemProviderCapabilities.PathCaseSensitive);if((0,L.isEqual)(t,s,!r))return;const o=new D.DisposableStore;try{o.add(await this.createResourceLock(u)),o.add(await this.createResourceLock(i)),n&&await R.promises.mkdir((0,E.dirname)(s),{recursive:!0}),await R.promises.copyFile(t,s)}catch(h){if(h.code==="ENOENT"&&!n)return this.doCloneFile(u,i,!0);throw this.toFileSystemProviderError(h)}finally{o.dispose()}}createUniversalWatcher(u,i,n){return new f.UniversalWatcherClient(t=>u(t),t=>i(t),n)}createNonRecursiveWatcher(u,i,n){return new C.NodeJSWatcherClient(t=>u(t),t=>i(t),n)}toFileSystemProviderError(u){if(u instanceof g.FileSystemProviderError)return u;let i=u,n;switch(u.code){case"ENOENT":n=g.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":n=g.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":n=g.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":n=g.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":n=g.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":i=`${u.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,n=g.FileSystemProviderErrorCode.Unknown;break;default:n=g.FileSystemProviderErrorCode.Unknown}return(0,g.createFileSystemProviderError)(i,n)}async toFileSystemProviderWriteError(u,i){let n=this.toFileSystemProviderError(i);if(u&&n.code===g.FileSystemProviderErrorCode.NoPermissions)try{const{stat:t}=await d.SymlinkSupport.stat(this.toFilePath(u));t.mode&128||(n=(0,g.createFileSystemProviderError)(i,g.FileSystemProviderErrorCode.FileWriteLocked))}catch(t){this.logService.trace(t)}return n}}e.DiskFileSystemProvider=p}),define(he[103],fe([0,1,3,2,4,11]),function(ce,e,R,a,_,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessLifecycleService=e.ISharedProcessLifecycleService=void 0,e.ISharedProcessLifecycleService=(0,_.createDecorator)("sharedProcessLifecycleService");let k=class extends a.Disposable{constructor(D){super(),this.logService=D,this._onWillShutdown=this._register(new R.Emitter),this.onWillShutdown=this._onWillShutdown.event}fireOnWillShutdown(){this.logService.trace("Lifecycle#onWillShutdown.fire()"),this._onWillShutdown.fire()}};e.SharedProcessLifecycleService=k,e.SharedProcessLifecycleService=k=Ie([Y(0,T.ILogService)],k)}),define(he[177],fe([0,1,10,3,11,2]),function(ce,e,R,a,_,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteLoggerChannelClient=e.LoggerChannel=e.LoggerChannelClient=void 0;class k extends _.AbstractLoggerService{constructor(S,m,d,l,g){super(m,d,l),this.windowId=S,this.channel=g,this._register(g.listen("onDidChangeLogLevel",S)(I=>{(0,_.isLogLevel)(I)?super.setLogLevel(I):super.setLogLevel(R.URI.revive(I[0]),I[1])})),this._register(g.listen("onDidChangeVisibility",S)(([I,v])=>super.setVisibility(R.URI.revive(I),v))),this._register(g.listen("onDidChangeLoggers",S)(({added:I,removed:v})=>{for(const f of I)super.registerLogger({...f,resource:R.URI.revive(f.resource)});for(const f of v)super.deregisterLogger(f.resource)}))}createConsoleMainLogger(){return new _.AdapterLogger({log:(S,m)=>{this.channel.call("consoleLog",[S,m])}})}registerLogger(S){super.registerLogger(S),this.channel.call("registerLogger",[S,this.windowId])}deregisterLogger(S){super.deregisterLogger(S),this.channel.call("deregisterLogger",[S,this.windowId])}setLogLevel(S,m){super.setLogLevel(S,m),this.channel.call("setLogLevel",[S,m])}setVisibility(S,m){super.setVisibility(S,m),this.channel.call("setVisibility",[this.toResource(S),m])}doCreateLogger(S,m,d){return new L(this.channel,S,m,d,this.windowId)}static setLogLevel(S,m,d){return S.call("setLogLevel",[m,d])}}e.LoggerChannelClient=k;class L extends _.AbstractMessageLogger{constructor(S,m,d,l,g){super(l?.logLevel==="always"),this.channel=S,this.file=m,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(d),this.channel.call("createLogger",[m,l,g]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(S,m){const d=[[S,m]];this.isLoggerCreated?this.doLog(d):this.buffer.push(...d)}doLog(S){this.channel.call("log",[this.file,S])}}class D{constructor(S,m){this.loggerService=S,this.getUriTransformer=m}listen(S,m){const d=this.getUriTransformer(S);switch(m){case"onDidChangeLoggers":return a.Event.map(this.loggerService.onDidChangeLoggers,l=>({added:[...l.added].map(g=>this.transformLogger(g,d)),removed:[...l.removed].map(g=>this.transformLogger(g,d))}));case"onDidChangeVisibility":return a.Event.map(this.loggerService.onDidChangeVisibility,l=>[d.transformOutgoingURI(l[0]),l[1]]);case"onDidChangeLogLevel":return a.Event.map(this.loggerService.onDidChangeLogLevel,l=>(0,_.isLogLevel)(l)?l:[d.transformOutgoingURI(l[0]),l[1]])}throw new Error(`Event not found: ${m}`)}async call(S,m,d){const l=this.getUriTransformer(S);switch(m){case"setLogLevel":return(0,_.isLogLevel)(d[0])?this.loggerService.setLogLevel(d[0]):this.loggerService.setLogLevel(R.URI.revive(l.transformIncoming(d[0][0])),d[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.loggerService.getRegisteredLoggers()].map(g=>this.transformLogger(g,l)))}throw new Error(`Call not found: ${m}`)}transformLogger(S,m){return{...S,resource:m.transformOutgoingURI(S.resource)}}}e.LoggerChannel=D;class E extends T.Disposable{constructor(S,m){super(),m.call("setLogLevel",[S.getLogLevel()]),this._register(S.onDidChangeLogLevel(d=>m.call("setLogLevel",[d]))),m.call("getRegisteredLoggers").then(d=>{for(const l of d)S.registerLogger({...l,resource:R.URI.revive(l.resource)})}),this._register(m.listen("onDidChangeVisibility")(([d,l])=>S.setVisibility(R.URI.revive(d),l))),this._register(m.listen("onDidChangeLoggers")(({added:d,removed:l})=>{for(const g of d)S.registerLogger({...g,resource:R.URI.revive(g.resource)});for(const g of l)S.deregisterLogger(g.resource)}))}}e.RemoteLoggerChannelClient=E}),define(he[178],fe([0,1,2,11]),function(ce,e,R,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogService=void 0;class _ extends R.Disposable{constructor(k,L=[]){super(),this.logger=new a.MultiplexLogger([k,...L]),this._register(k.onDidChangeLogLevel(D=>this.setLevel(D)))}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(k){this.logger.setLevel(k)}getLevel(){return this.logger.getLevel()}trace(k,...L){this.logger.trace(k,...L)}debug(k,...L){this.logger.debug(k,...L)}info(k,...L){this.logger.info(k,...L)}warn(k,...L){this.logger.warn(k,...L)}error(k,...L){this.logger.error(k,...L)}flush(){this.logger.flush()}}e.LogService=_}),define(he[57],fe([0,1,4]),function(ce,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeHostService=void 0,e.INativeHostService=(0,R.createDecorator)("nativeHostService")}),define(he[179],fe([0,1,43,56]),function(ce,e,R,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeHostService=void 0;let _=class{constructor(k,L){return this.windowId=k,R.ProxyChannel.toService(L.getChannel("nativeHost"),{context:k,properties:(()=>{const D=new Map;return D.set("windowId",k),D})()})}};e.NativeHostService=_,e.NativeHostService=_=Ie([Y(1,a.IMainProcessService)],_)}),define(he[58],fe([0,1,3,63,2,4]),function(ce,e,R,a,_,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullPolicyService=e.AbstractPolicyService=e.IPolicyService=void 0,e.IPolicyService=(0,T.createDecorator)("policy");class k extends _.Disposable{constructor(){super(...arguments),this.policyDefinitions={},this.policies=new Map,this._onDidChange=this._register(new R.Emitter),this.onDidChange=this._onDidChange.event}async updatePolicyDefinitions(E){const P=Object.keys(this.policyDefinitions).length;return this.policyDefinitions={...E,...this.policyDefinitions},P!==Object.keys(this.policyDefinitions).length&&await this._updatePolicyDefinitions(E),a.Iterable.reduce(this.policies.entries(),(S,[m,d])=>({...S,[m]:d}),{})}getPolicyValue(E){return this.policies.get(E)}serialize(){return a.Iterable.reduce(Object.entries(this.policyDefinitions),(E,[P,S])=>({...E,[P]:{definition:S,value:this.policies.get(P)}}),{})}}e.AbstractPolicyService=k;class L{constructor(){this.onDidChange=R.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.NullPolicyService=L}),define(he[180],fe([0,1,3,2,58]),function(ce,e,R,a,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyChannelClient=e.PolicyChannel=void 0;class T{constructor(D){this.service=D,this.disposables=new a.DisposableStore}listen(D,E){switch(E){case"onDidChange":return R.Event.map(this.service.onDidChange,P=>P.reduce((S,m)=>({...S,[m]:this.service.getPolicyValue(m)??null}),{}),this.disposables)}throw new Error(`Event not found: ${E}`)}call(D,E,P){switch(E){case"updatePolicyDefinitions":return this.service.updatePolicyDefinitions(P)}throw new Error(`Call not found: ${E}`)}dispose(){this.disposables.dispose()}}e.PolicyChannel=T;class k extends _.AbstractPolicyService{constructor(D,E){super(),this.channel=E;for(const P in D){const{definition:S,value:m}=D[P];this.policyDefinitions[P]=S,m!==void 0&&this.policies.set(P,m)}this.channel.listen("onDidChange")(P=>{for(const S in P){const m=P[S];m===null?this.policies.delete(S):this.policies.set(S,m)}this._onDidChange.fire(Object.keys(P))})}async _updatePolicyDefinitions(D){const E=await this.channel.call("updatePolicyDefinitions",D);for(const P in E)this.policies.set(P,E[P])}}e.PolicyChannelClient=k}),define(he[104],fe([0,1,37]),function(ce,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let a;const _=globalThis.vscode;if(typeof _<"u"&&typeof _.context<"u"){const T=_.context.configuration();if(T)a=T.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){a=globalThis._VSCODE_PRODUCT_JSON;const{serviceUrl:T,searchUrl:k,itemUrl:L,controlUrl:D}=a.extensionsGallery||{};Object.assign(a,{extensionsGallery:{serviceUrl:R.env.VSCODE_GALLERY_SERVICE_URL||T,searchUrl:R.env.VSCODE_GALLERY_SEARCH_URL||k,itemUrl:R.env.VSCODE_GALLERY_ITEM_URL||L,controlUrl:R.env.VSCODE_GALLERY_CONTROL_URL||D}});try{const E=(...S)=>S.reduce((m,d)=>(Object.keys(d).forEach(l=>{Array.isArray(m[l])&&Array.isArray(d[l])?m[l]=d[l]:typeof m[l]=="object"&&typeof d[l]=="object"?m[l]=E(m[l],d[l]):m[l]=d[l]}),m),{}),P=globalThis._VSCODE_USER_PRODUCT_JSON||{};a=E(a,P)}catch{}if(R.env.VSCODE_DEV&&Object.assign(a,{nameShort:`${a.nameShort} Dev`,nameLong:`${a.nameLong} Dev`,dataFolderName:`${a.dataFolderName}-dev`,serverDataFolderName:a.serverDataFolderName?`${a.serverDataFolderName}-dev`:void 0}),!a.version){const E=globalThis._VSCODE_PACKAGE_JSON;Object.assign(a,{version:E.version,release:E.release})}}else a={},Object.keys(a).length===0&&Object.assign(a,{version:"1.91.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=a}),define(he[23],fe([0,1,4]),function(ce,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,R.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(he[181],fe([0,1,33,6,8,2,13,30,11,23]),function(ce,e,R,a,_,T,k,L,D,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeCacheCleaner=void 0,R=De(R);let P=class extends T.Disposable{constructor(m,d,l){super(),this.productService=d,this.logService=l,this._DataMaxAge=this.productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,m&&this._register(new a.RunOnceScheduler(()=>{this.cleanUpCodeCaches(m)},3e4)).schedule()}async cleanUpCodeCaches(m){this.logService.trace("[code cache cleanup]: Starting to clean up old code cache folders.");try{const d=Date.now(),l=(0,k.dirname)(m),g=(0,k.basename)(m),I=await L.Promises.readdir(l);await Promise.all(I.map(async v=>{if(v===g)return;const f=(0,k.join)(l,v),C=await R.promises.stat(f);if(C.isDirectory()&&d-C.mtime.getTime()>this._DataMaxAge)return this.logService.trace(`[code cache cleanup]: Removing code cache folder ${v}.`),L.Promises.rm(f)}))}catch(d){(0,_.onUnexpectedError)(d)}}};e.CodeCacheCleaner=P,e.CodeCacheCleaner=P=Ie([Y(1,E.IProductService),Y(2,D.ILogService)],P)}),define(he[182],fe([0,1,33,6,8,2,13,30,15,11,23]),function(ce,e,R,a,_,T,k,L,D,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackCachedDataCleaner=void 0,R=De(R);let S=class extends T.Disposable{constructor(d,l,g){super(),this.environmentService=d,this.logService=l,this.productService=g,this._DataMaxAge=this.productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,this.environmentService.isBuilt&&this._register(new a.RunOnceScheduler(()=>{this.cleanUpLanguagePackCache()},4e4)).schedule()}async cleanUpLanguagePackCache(){this.logService.trace("[language pack cache cleanup]: Starting to clean up unused language packs.");try{const d=Object.create(null),l=JSON.parse(await R.promises.readFile((0,k.join)(this.environmentService.userDataPath,"languagepacks.json"),"utf8"));for(const C of Object.keys(l)){const p=l[C];d[`${p.hash}.${C}`]=!0}const g=(0,k.join)(this.environmentService.userDataPath,"clp");if(!await L.Promises.exists(g))return;const v=await L.Promises.readdir(g);for(const C of v){if(d[C]){this.logService.trace(`[language pack cache cleanup]: Skipping folder ${C}. Language pack still in use.`);continue}this.logService.trace(`[language pack cache cleanup]: Removing unused language pack: ${C}`),await L.Promises.rm((0,k.join)(g,C))}const f=Date.now();for(const C of Object.keys(d)){const p=(0,k.join)(g,C),c=await L.Promises.readdir(p);for(const u of c){if(u==="tcf.json")continue;const i=(0,k.join)(p,u),n=await R.promises.stat(i);n.isDirectory()&&f-n.mtime.getTime()>this._DataMaxAge&&(this.logService.trace(`[language pack cache cleanup]: Removing language pack cache folder: ${(0,k.join)(C,u)}`),await L.Promises.rm(i))}}}catch(d){(0,_.onUnexpectedError)(d)}}};e.LanguagePackCachedDataCleaner=S,e.LanguagePackCachedDataCleaner=S=Ie([Y(0,D.INativeEnvironmentService),Y(1,E.ILogService),Y(2,P.IProductService)],S)}),define(he[183],fe([0,1,13,4]),function(ce,e,R,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Utils=e.IV8InspectProfilingService=void 0,e.IV8InspectProfilingService=(0,a.createDecorator)("IV8InspectProfilingService");var _;(function(T){function k(D){return!!(D.samples&&D.timeDeltas)}T.isValidProfile=k;function L(D,E="noAbsolutePaths"){for(const P of D.nodes)P.callFrame&&P.callFrame.url&&((0,R.isAbsolute)(P.callFrame.url)||/^\w[\w\d+.-]*:\/\/\/?/.test(P.callFrame.url))&&(P.callFrame.url=(0,R.join)(E,(0,R.basename)(P.callFrame.url)));return D}T.rewriteAbsolutePaths=L})(_||(e.Utils=_={}))}),define(he[184],fe([0,1,32]),function(ce,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InspectProfilingService=void 0;class a{constructor(){this._sessions=new Map}async startProfiling(T){const L=await(await new Promise((E,P)=>{ce(["v8-inspect-profiler"],E,P)}).then(De)).startProfiling({host:T.host,port:T.port,checkForPaused:!0}),D=(0,R.generateUuid)();return this._sessions.set(D,L),D}async stopProfiling(T){const k=this._sessions.get(T);if(!k)throw new Error(`UNKNOWN session '${T}'`);const L=await k.stop();return this._sessions.delete(T),L.profile}}e.InspectProfilingService=a}),define(he[44],fe([0,1,133,12]),function(ce,e,R,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0,R=De(R),a=De(a);class _{constructor(){this.data=new Map}add(k,L){R.ok(a.isString(k)),R.ok(a.isObject(L)),R.ok(!this.data.has(k),"There is already an extension with this id"),this.data.set(k,L)}knows(k){return this.data.has(k)}as(k){return this.data.get(k)||null}}e.Registry=new _}),define(he[105],fe([0,1,3,134,44]),function(ce,e,R,a,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,_=De(_),e.Extensions={JSONContribution:"base.contributions.json"};function T(D){return D.length>0&&D.charAt(D.length-1)==="#"?D.substring(0,D.length-1):D}class k{constructor(){this._onDidChangeSchema=new R.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(E,P){this.schemasById[T(E)]=P,this._onDidChangeSchema.fire(E)}notifySchemaChanged(E){this._onDidChangeSchema.fire(E)}getSchemaContributions(){return{schemas:this.schemasById}}getSchemaContent(E){const P=this.schemasById[E];return P?(0,a.getCompressedContent)(P):void 0}hasSchemaContent(E){return!!this.schemasById[E]}}const L=new k;_.Registry.add(e.Extensions.JSONContribution,L)}),define(he[47],fe([0,1,17,3,12,9,21,105,44]),function(ce,e,R,a,_,T,k,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0,e.overrideIdentifiersFromKey=g,e.keyFromOverrideIdentifiers=I,e.getDefaultValue=v,e.validateProperty=C,e.getScopes=p,e.getAllConfigurationProperties=c,e.parseScope=u,_=De(_),T=De(T);var E;(function(i){i.Multiline="multilineText",i.Singleline="singlelineText"})(E||(e.EditPresentationTypes=E={})),e.Extensions={Configuration:"base.contributions.configuration"};var P;(function(i){i[i.APPLICATION=1]="APPLICATION",i[i.MACHINE=2]="MACHINE",i[i.WINDOW=3]="WINDOW",i[i.RESOURCE=4]="RESOURCE",i[i.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",i[i.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(P||(e.ConfigurationScope=P={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const S=D.Registry.as(L.Extensions.JSONContribution);class m{constructor(){this.registeredConfigurationDefaults=[],this.overrideIdentifiers=new Set,this._onDidSchemaChange=new a.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new a.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:T.localize(1662,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.policyConfigurations=new Map,this.excludedConfigurationProperties={},S.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(n,t=!0){this.registerConfigurations([n],t)}registerConfigurations(n,t=!0){const s=new Set;this.doRegisterConfigurations(n,t,s),S.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:s})}deregisterConfigurations(n){const t=new Set;this.doDeregisterConfigurations(n,t),S.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:t})}updateConfigurations({add:n,remove:t}){const s=new Set;this.doDeregisterConfigurations(t,s),this.doRegisterConfigurations(n,!1,s),S.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:s})}registerDefaultConfigurations(n){const t=new Set;this.doRegisterDefaultConfigurations(n,t),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:t,defaultsOverrides:!0})}doRegisterDefaultConfigurations(n,t){this.registeredConfigurationDefaults.push(...n);const s=[];for(const{overrides:r,source:o}of n)for(const h in r){t.add(h);const y=this.configurationDefaultsOverrides.get(h)??this.configurationDefaultsOverrides.set(h,{configurationDefaultOverrides:[]}).get(h),A=r[h];if(y.configurationDefaultOverrides.push({value:A,source:o}),e.OVERRIDE_PROPERTY_REGEX.test(h)){const b=this.mergeDefaultConfigurationsForOverrideIdentifier(h,A,o,y.configurationDefaultOverrideValue);if(!b)continue;y.configurationDefaultOverrideValue=b,this.updateDefaultOverrideProperty(h,b,o),s.push(...g(h))}else{const b=this.mergeDefaultConfigurationsForConfigurationProperty(h,A,o,y.configurationDefaultOverrideValue);if(!b)continue;y.configurationDefaultOverrideValue=b;const w=this.configurationProperties[h];w&&(this.updatePropertyDefaultValue(h,w),this.updateSchema(h,w))}}this.doRegisterOverrideIdentifiers(s)}deregisterDefaultConfigurations(n){const t=new Set;this.doDeregisterDefaultConfigurations(n,t),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:t,defaultsOverrides:!0})}doDeregisterDefaultConfigurations(n,t){for(const s of n){const r=this.registeredConfigurationDefaults.indexOf(s);r!==-1&&this.registeredConfigurationDefaults.splice(r,1)}for(const{overrides:s,source:r}of n)for(const o in s){const h=this.configurationDefaultsOverrides.get(o);if(!h)continue;const y=h.configurationDefaultOverrides.findIndex(A=>r?A.source?.id===r.id:A.value===s[o]);if(y!==-1){if(h.configurationDefaultOverrides.splice(y,1),h.configurationDefaultOverrides.length===0&&this.configurationDefaultsOverrides.delete(o),e.OVERRIDE_PROPERTY_REGEX.test(o)){let A;for(const b of h.configurationDefaultOverrides)A=this.mergeDefaultConfigurationsForOverrideIdentifier(o,b.value,b.source,A);A&&!_.isEmptyObject(A.value)?(h.configurationDefaultOverrideValue=A,this.updateDefaultOverrideProperty(o,A,r)):(this.configurationDefaultsOverrides.delete(o),delete this.configurationProperties[o],delete this.defaultLanguageConfigurationOverridesNode.properties[o])}else{let A;for(const w of h.configurationDefaultOverrides)A=this.mergeDefaultConfigurationsForConfigurationProperty(o,w.value,w.source,A);h.configurationDefaultOverrideValue=A;const b=this.configurationProperties[o];b&&(this.updatePropertyDefaultValue(o,b),this.updateSchema(o,b))}t.add(o)}}this.updateOverridePropertyPatternKey()}updateDefaultOverrideProperty(n,t,s){const r={type:"object",default:t.value,description:T.localize(1663,null,(0,k.getLanguageTagSettingPlainKey)(n)),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:t.value,source:s,defaultValueSource:s};this.configurationProperties[n]=r,this.defaultLanguageConfigurationOverridesNode.properties[n]=r}mergeDefaultConfigurationsForOverrideIdentifier(n,t,s,r){const o=r?.value||{},h=r?.source??new Map;if(!(h instanceof Map)){console.error("objectConfigurationSources is not a Map");return}for(const y of Object.keys(t)){const A=t[y];if(_.isObject(A)&&(_.isUndefined(o[y])||_.isObject(o[y]))){if(o[y]={...o[y]??{},...A},s)for(const w in A)h.set(`${y}.${w}`,s)}else o[y]=A,s?h.set(y,s):h.delete(y)}return{value:o,source:h}}mergeDefaultConfigurationsForConfigurationProperty(n,t,s,r){const o=this.configurationProperties[n],h=r?.value??o?.defaultDefaultValue;let y=s;if(_.isObject(t)&&(o!==void 0&&o.type==="object"||o===void 0&&(_.isUndefined(h)||_.isObject(h)))){if(y=r?.source??new Map,!(y instanceof Map)){console.error("defaultValueSource is not a Map");return}for(const b in t)s&&y.set(`${n}.${b}`,s);t={..._.isObject(h)?h:{},...t}}return{value:t,source:y}}deltaConfiguration(n){let t=!1;const s=new Set;n.removedDefaults&&(this.doDeregisterDefaultConfigurations(n.removedDefaults,s),t=!0),n.addedDefaults&&(this.doRegisterDefaultConfigurations(n.addedDefaults,s),t=!0),n.removedConfigurations&&this.doDeregisterConfigurations(n.removedConfigurations,s),n.addedConfigurations&&this.doRegisterConfigurations(n.addedConfigurations,!1,s),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:s,defaultsOverrides:t})}notifyConfigurationSchemaUpdated(...n){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(n){this.doRegisterOverrideIdentifiers(n),this._onDidSchemaChange.fire()}doRegisterOverrideIdentifiers(n){for(const t of n)this.overrideIdentifiers.add(t);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(n,t,s){n.forEach(r=>{this.validateAndRegisterProperties(r,t,r.extensionInfo,r.restrictedProperties,void 0,s),this.configurationContributors.push(r),this.registerJSONConfiguration(r)})}doDeregisterConfigurations(n,t){const s=r=>{if(r.properties)for(const o in r.properties){t.add(o);const h=this.configurationProperties[o];h?.policy?.name&&this.policyConfigurations.delete(h.policy.name),delete this.configurationProperties[o],this.removeFromSchema(o,r.properties[o])}r.allOf?.forEach(o=>s(o))};for(const r of n){s(r);const o=this.configurationContributors.indexOf(r);o!==-1&&this.configurationContributors.splice(o,1)}}validateAndRegisterProperties(n,t=!0,s,r,o=P.WINDOW,h){o=_.isUndefinedOrNull(n.scope)?o:n.scope;const y=n.properties;if(y)for(const b in y){const w=y[b];if(t&&C(b,w)){delete y[b];continue}if(w.source=s,w.defaultDefaultValue=y[b].default,this.updatePropertyDefaultValue(b,w),e.OVERRIDE_PROPERTY_REGEX.test(b)?w.scope=void 0:(w.scope=_.isUndefinedOrNull(w.scope)?o:w.scope,w.restricted=_.isUndefinedOrNull(w.restricted)?!!r?.includes(b):w.restricted),y[b].hasOwnProperty("included")&&!y[b].included){this.excludedConfigurationProperties[b]=y[b],delete y[b];continue}else this.configurationProperties[b]=y[b],y[b].policy?.name&&this.policyConfigurations.set(y[b].policy.name,b);!y[b].deprecationMessage&&y[b].markdownDeprecationMessage&&(y[b].deprecationMessage=y[b].markdownDeprecationMessage),h.add(b)}const A=n.allOf;if(A)for(const b of A)this.validateAndRegisterProperties(b,t,s,r,o,h)}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getPolicyConfigurations(){return this.policyConfigurations}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getRegisteredDefaultConfigurations(){return[...this.registeredConfigurationDefaults]}getConfigurationDefaultsOverrides(){const n=new Map;for(const[t,s]of this.configurationDefaultsOverrides)s.configurationDefaultOverrideValue&&n.set(t,s.configurationDefaultOverrideValue);return n}registerJSONConfiguration(n){const t=s=>{const r=s.properties;if(r)for(const h in r)this.updateSchema(h,r[h]);s.allOf?.forEach(t)};t(n)}updateSchema(n,t){switch(e.allSettings.properties[n]=t,t.scope){case P.APPLICATION:e.applicationSettings.properties[n]=t;break;case P.MACHINE:e.machineSettings.properties[n]=t;break;case P.MACHINE_OVERRIDABLE:e.machineOverridableSettings.properties[n]=t;break;case P.WINDOW:e.windowSettings.properties[n]=t;break;case P.RESOURCE:e.resourceSettings.properties[n]=t;break;case P.LANGUAGE_OVERRIDABLE:e.resourceSettings.properties[n]=t,this.resourceLanguageSettingsSchema.properties[n]=t;break}}removeFromSchema(n,t){switch(delete e.allSettings.properties[n],t.scope){case P.APPLICATION:delete e.applicationSettings.properties[n];break;case P.MACHINE:delete e.machineSettings.properties[n];break;case P.MACHINE_OVERRIDABLE:delete e.machineOverridableSettings.properties[n];break;case P.WINDOW:delete e.windowSettings.properties[n];break;case P.RESOURCE:case P.LANGUAGE_OVERRIDABLE:delete e.resourceSettings.properties[n],delete this.resourceLanguageSettingsSchema.properties[n];break}}updateOverridePropertyPatternKey(){for(const n of this.overrideIdentifiers.values()){const t=`[${n}]`,s={type:"object",description:T.localize(1664,null),errorMessage:T.localize(1665,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(t,s),e.allSettings.properties[t]=s,e.applicationSettings.properties[t]=s,e.machineSettings.properties[t]=s,e.machineOverridableSettings.properties[t]=s,e.windowSettings.properties[t]=s,e.resourceSettings.properties[t]=s}}registerOverridePropertyPatternKey(){const n={type:"object",description:T.localize(1666,null),errorMessage:T.localize(1667,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(n,t){const s=this.configurationDefaultsOverrides.get(n)?.configurationDefaultOverrideValue;let r,o;s&&(!t.disallowConfigurationDefault||!s.source)&&(r=s.value,o=s.source),_.isUndefined(r)&&(r=t.defaultDefaultValue,o=void 0),_.isUndefined(r)&&(r=v(t.type)),t.default=r,t.defaultValueSource=o}}const d="\\[([^\\]]+)\\]",l=new RegExp(d,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${d})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function g(i){const n=[];if(e.OVERRIDE_PROPERTY_REGEX.test(i)){let t=l.exec(i);for(;t?.length;){const s=t[1].trim();s&&n.push(s),t=l.exec(i)}}return(0,R.distinct)(n)}function I(i){return i.reduce((n,t)=>`${n}[${t}]`,"")}function v(i){switch(Array.isArray(i)?i[0]:i){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const f=new m;D.Registry.add(e.Extensions.Configuration,f);function C(i,n){return i.trim()?e.OVERRIDE_PROPERTY_REGEX.test(i)?T.localize(1669,null,i):f.getConfigurationProperties()[i]!==void 0?T.localize(1670,null,i):n.policy?.name&&f.getPolicyConfigurations().get(n.policy?.name)!==void 0?T.localize(1671,null,i,n.policy?.name,f.getPolicyConfigurations().get(n.policy?.name)):null:T.localize(1668,null)}function p(){const i=[],n=f.getConfigurationProperties();for(const t of Object.keys(n))i.push([t,n[t].scope]);return i.push(["launch",P.RESOURCE]),i.push(["task",P.RESOURCE]),i}function c(i){const n={};for(const t of i){const s=t.properties;if(_.isObject(s))for(const r in s)n[r]=s[r];t.allOf&&Object.assign(n,c(t.allOf))}return n}function u(i){switch(i){case"application":return P.APPLICATION;case"machine":return P.MACHINE;case"resource":return P.RESOURCE;case"machine-overridable":return P.MACHINE_OVERRIDABLE;case"language-overridable":return P.LANGUAGE_OVERRIDABLE;default:return P.WINDOW}}}),define(he[78],fe([0,1,17,3,36,2,31,29,12,10,21,47,7,44]),function(ce,e,R,a,_,T,k,L,D,E,P,S,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0,e.mergeChanges=p,R=De(R),_=De(_),L=De(L),D=De(D);function l(n){return Object.isFrozen(n)?n:L.deepFreeze(n)}class g{static createEmptyModel(t){return new g({},[],[],void 0,t)}constructor(t,s,r,o,h){this._contents=t,this._keys=s,this._overrides=r,this.raw=o,this.logService=h,this.overrideConfigurations=new Map}get rawConfiguration(){if(!this._rawConfiguration)if(this.raw?.length){const t=this.raw.map(s=>{if(s instanceof g)return s;const r=new I("",this.logService);return r.parseRaw(s),r.configurationModel});this._rawConfiguration=t.reduce((s,r)=>r===s?r:s.merge(r),t[0])}else this._rawConfiguration=this;return this._rawConfiguration}get contents(){return this._contents}get overrides(){return this._overrides}get keys(){return this._keys}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(t){return t?(0,P.getConfigurationValue)(this.contents,t):this.contents}inspect(t,s){const r=this;return{get value(){return l(r.rawConfiguration.getValue(t))},get override(){return s?l(r.rawConfiguration.getOverrideValue(t,s)):void 0},get merged(){return l(s?r.rawConfiguration.override(s).getValue(t):r.rawConfiguration.getValue(t))},get overrides(){const o=[];for(const{contents:h,identifiers:y,keys:A}of r.rawConfiguration.overrides){const b=new g(h,A,[],void 0,r.logService).getValue(t);b!==void 0&&o.push({identifiers:y,value:b})}return o.length?l(o):void 0}}}getOverrideValue(t,s){const r=this.getContentsForOverrideIdentifer(s);return r?t?(0,P.getConfigurationValue)(r,t):r:void 0}getKeysForOverrideIdentifier(t){const s=[];for(const r of this.overrides)r.identifiers.includes(t)&&s.push(...r.keys);return R.distinct(s)}getAllOverrideIdentifiers(){const t=[];for(const s of this.overrides)t.push(...s.identifiers);return R.distinct(t)}override(t){let s=this.overrideConfigurations.get(t);return s||(s=this.createOverrideConfigurationModel(t),this.overrideConfigurations.set(t,s)),s}merge(...t){const s=L.deepClone(this.contents),r=L.deepClone(this.overrides),o=[...this.keys],h=this.raw?.length?[...this.raw]:[this];for(const y of t)if(h.push(...y.raw?.length?y.raw:[y]),!y.isEmpty()){this.mergeContents(s,y.contents);for(const A of y.overrides){const[b]=r.filter(w=>R.equals(w.identifiers,A.identifiers));b?(this.mergeContents(b.contents,A.contents),b.keys.push(...A.keys),b.keys=R.distinct(b.keys)):r.push(L.deepClone(A))}for(const A of y.keys)o.indexOf(A)===-1&&o.push(A)}return new g(s,o,r,h.every(y=>y instanceof g)?void 0:h,this.logService)}createOverrideConfigurationModel(t){const s=this.getContentsForOverrideIdentifer(t);if(!s||typeof s!="object"||!Object.keys(s).length)return this;const r={};for(const o of R.distinct([...Object.keys(this.contents),...Object.keys(s)])){let h=this.contents[o];const y=s[o];y&&(typeof h=="object"&&typeof y=="object"?(h=L.deepClone(h),this.mergeContents(h,y)):h=y),r[o]=h}return new g(r,this.keys,this.overrides,void 0,this.logService)}mergeContents(t,s){for(const r of Object.keys(s)){if(r in t&&D.isObject(t[r])&&D.isObject(s[r])){this.mergeContents(t[r],s[r]);continue}t[r]=L.deepClone(s[r])}}getContentsForOverrideIdentifer(t){let s=null,r=null;const o=h=>{h&&(r?this.mergeContents(r,h):r=L.deepClone(h))};for(const h of this.overrides)h.identifiers.length===1&&h.identifiers[0]===t?s=h.contents:h.identifiers.includes(t)&&o(h.contents);return o(s),r}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(t,s){this.updateValue(t,s,!0)}setValue(t,s){this.updateValue(t,s,!1)}removeValue(t){const s=this.keys.indexOf(t);s!==-1&&(this.keys.splice(s,1),(0,P.removeFromValueTree)(this.contents,t),S.OVERRIDE_PROPERTY_REGEX.test(t)&&this.overrides.splice(this.overrides.findIndex(r=>R.equals(r.identifiers,(0,S.overrideIdentifiersFromKey)(t))),1))}updateValue(t,s,r){if((0,P.addToValueTree)(this.contents,t,s,o=>this.logService.error(o)),r=r||this.keys.indexOf(t)===-1,r&&this.keys.push(t),S.OVERRIDE_PROPERTY_REGEX.test(t)){const o=(0,S.overrideIdentifiersFromKey)(t),h={identifiers:o,keys:Object.keys(this.contents[t]),contents:(0,P.toValuesTree)(this.contents[t],A=>this.logService.error(A))},y=this.overrides.findIndex(A=>R.equals(A.identifiers,o));y!==-1?this.overrides[y]=h:this.overrides.push(h)}}}e.ConfigurationModel=g;class I{constructor(t,s){this._name=t,this.logService=s,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||g.createEmptyModel(this.logService)}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(t,s){if(!D.isUndefinedOrNull(t)){const r=this.doParseContent(t);this.parseRaw(r,s)}}reparse(t){this._raw&&this.parseRaw(this._raw,t)}parseRaw(t,s){this._raw=t;const{contents:r,keys:o,overrides:h,restricted:y,hasExcludedProperties:A}=this.doParseRaw(t,s);this._configurationModel=new g(r,o,h,A?[t]:void 0,this.logService),this._restrictedConfigurations=y||[]}doParseContent(t){let s={},r=null,o=[];const h=[],y=[];function A(w){Array.isArray(o)?o.push(w):r!==null&&(o[r]=w)}const b={onObjectBegin:()=>{const w={};A(w),h.push(o),o=w,r=null},onObjectProperty:w=>{r=w},onObjectEnd:()=>{o=h.pop()},onArrayBegin:()=>{const w=[];A(w),h.push(o),o=w,r=null},onArrayEnd:()=>{o=h.pop()},onLiteralValue:A,onError:(w,O,F)=>{y.push({error:w,offset:O,length:F})}};if(t)try{_.visit(t,b),s=o[0]||{}}catch(w){this.logService.error(`Error while parsing settings file ${this._name}: ${w}`),this._parseErrors=[w]}return s}doParseRaw(t,s){const r=d.Registry.as(S.Extensions.Configuration).getConfigurationProperties(),o=this.filter(t,r,!0,s);t=o.raw;const h=(0,P.toValuesTree)(t,b=>this.logService.error(`Conflict in settings file ${this._name}: ${b}`)),y=Object.keys(t),A=this.toOverrides(t,b=>this.logService.error(`Conflict in settings file ${this._name}: ${b}`));return{contents:h,keys:y,overrides:A,restricted:o.restricted,hasExcludedProperties:o.hasExcludedProperties}}filter(t,s,r,o){let h=!1;if(!o?.scopes&&!o?.skipRestricted&&!o?.exclude?.length)return{raw:t,restricted:[],hasExcludedProperties:h};const y={},A=[];for(const b in t)if(S.OVERRIDE_PROPERTY_REGEX.test(b)&&r){const w=this.filter(t[b],s,!1,o);y[b]=w.raw,h=h||w.hasExcludedProperties,A.push(...w.restricted)}else{const w=s[b],O=w?typeof w.scope<"u"?w.scope:S.ConfigurationScope.WINDOW:void 0;w?.restricted&&A.push(b),!o.exclude?.includes(b)&&(o.include?.includes(b)||(O===void 0||o.scopes===void 0||o.scopes.includes(O))&&!(o.skipRestricted&&w?.restricted))?y[b]=t[b]:h=!0}return{raw:y,restricted:A,hasExcludedProperties:h}}toOverrides(t,s){const r=[];for(const o of Object.keys(t))if(S.OVERRIDE_PROPERTY_REGEX.test(o)){const h={};for(const y in t[o])h[y]=t[o][y];r.push({identifiers:(0,S.overrideIdentifiersFromKey)(o),keys:Object.keys(h),contents:(0,P.toValuesTree)(h,s)})}return r}}e.ConfigurationModelParser=I;class v extends T.Disposable{constructor(t,s,r,o,h){super(),this.userSettingsResource=t,this.parseOptions=s,this.fileService=o,this.logService=h,this._onDidChange=this._register(new a.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new I(this.userSettingsResource.toString(),h),this._register(this.fileService.watch(r.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(a.Event.any(a.Event.filter(this.fileService.onDidFilesChange,y=>y.contains(this.userSettingsResource)),a.Event.filter(this.fileService.onDidRunOperation,y=>(y.isOperation(m.FileOperation.CREATE)||y.isOperation(m.FileOperation.COPY)||y.isOperation(m.FileOperation.DELETE)||y.isOperation(m.FileOperation.WRITE))&&r.isEqual(y.resource,t)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const t=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(t.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return g.createEmptyModel(this.logService)}}reparse(t){return t&&(this.parseOptions=t),this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=v;class f{constructor(t,s,r,o,h,y,A,b,w,O,F,N,M){this.key=t,this.overrides=s,this._value=r,this.overrideIdentifiers=o,this.defaultConfiguration=h,this.policyConfiguration=y,this.applicationConfiguration=A,this.userConfiguration=b,this.localUserConfiguration=w,this.remoteUserConfiguration=O,this.workspaceConfiguration=F,this.folderConfigurationModel=N,this.memoryConfigurationModel=M}get value(){return l(this._value)}toInspectValue(t){return t?.value!==void 0||t?.override!==void 0||t?.overrides!==void 0?t:void 0}get defaultInspectValue(){return this._defaultInspectValue||(this._defaultInspectValue=this.defaultConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._defaultInspectValue}get defaultValue(){return this.defaultInspectValue.merged}get default(){return this.toInspectValue(this.defaultInspectValue)}get policyInspectValue(){return this._policyInspectValue===void 0&&(this._policyInspectValue=this.policyConfiguration?this.policyConfiguration.inspect(this.key):null),this._policyInspectValue}get policyValue(){return this.policyInspectValue?.merged}get policy(){return this.policyInspectValue?.value!==void 0?{value:this.policyInspectValue.value}:void 0}get applicationInspectValue(){return this._applicationInspectValue===void 0&&(this._applicationInspectValue=this.applicationConfiguration?this.applicationConfiguration.inspect(this.key):null),this._applicationInspectValue}get applicationValue(){return this.applicationInspectValue?.merged}get application(){return this.toInspectValue(this.applicationInspectValue)}get userInspectValue(){return this._userInspectValue||(this._userInspectValue=this.userConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._userInspectValue}get userValue(){return this.userInspectValue.merged}get user(){return this.toInspectValue(this.userInspectValue)}get userLocalInspectValue(){return this._userLocalInspectValue||(this._userLocalInspectValue=this.localUserConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._userLocalInspectValue}get userLocalValue(){return this.userLocalInspectValue.merged}get userLocal(){return this.toInspectValue(this.userLocalInspectValue)}get userRemoteInspectValue(){return this._userRemoteInspectValue||(this._userRemoteInspectValue=this.remoteUserConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._userRemoteInspectValue}get userRemoteValue(){return this.userRemoteInspectValue.merged}get userRemote(){return this.toInspectValue(this.userRemoteInspectValue)}get workspaceInspectValue(){return this._workspaceInspectValue===void 0&&(this._workspaceInspectValue=this.workspaceConfiguration?this.workspaceConfiguration.inspect(this.key,this.overrides.overrideIdentifier):null),this._workspaceInspectValue}get workspaceValue(){return this.workspaceInspectValue?.merged}get workspace(){return this.toInspectValue(this.workspaceInspectValue)}get workspaceFolderInspectValue(){return this._workspaceFolderInspectValue===void 0&&(this._workspaceFolderInspectValue=this.folderConfigurationModel?this.folderConfigurationModel.inspect(this.key,this.overrides.overrideIdentifier):null),this._workspaceFolderInspectValue}get workspaceFolderValue(){return this.workspaceFolderInspectValue?.merged}get workspaceFolder(){return this.toInspectValue(this.workspaceFolderInspectValue)}get memoryInspectValue(){return this._memoryInspectValue===void 0&&(this._memoryInspectValue=this.memoryConfigurationModel.inspect(this.key,this.overrides.overrideIdentifier)),this._memoryInspectValue}get memoryValue(){return this.memoryInspectValue.merged}get memory(){return this.toInspectValue(this.memoryInspectValue)}}class C{constructor(t,s,r,o,h,y,A,b,w,O){this._defaultConfiguration=t,this._policyConfiguration=s,this._applicationConfiguration=r,this._localUserConfiguration=o,this._remoteUserConfiguration=h,this._workspaceConfiguration=y,this._folderConfigurations=A,this._memoryConfiguration=b,this._memoryConfigurationByResource=w,this.logService=O,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new k.ResourceMap,this._userConfiguration=null}getValue(t,s,r){return this.getConsolidatedConfigurationModel(t,s,r).getValue(t)}updateValue(t,s,r={}){let o;r.resource?(o=this._memoryConfigurationByResource.get(r.resource),o||(o=g.createEmptyModel(this.logService),this._memoryConfigurationByResource.set(r.resource,o))):o=this._memoryConfiguration,s===void 0?o.removeValue(t):o.setValue(t,s),r.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(t,s,r){const o=this.getConsolidatedConfigurationModel(t,s,r),h=this.getFolderConfigurationModelForResource(s.resource,r),y=s.resource?this._memoryConfigurationByResource.get(s.resource)||this._memoryConfiguration:this._memoryConfiguration,A=new Set;for(const b of o.overrides)for(const w of b.identifiers)o.getOverrideValue(t,w)!==void 0&&A.add(w);return new f(t,s,o.getValue(t),A.size?[...A]:void 0,this._defaultConfiguration,this._policyConfiguration.isEmpty()?void 0:this._policyConfiguration,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,r?this._workspaceConfiguration:void 0,h||void 0,y)}keys(t){const s=this.getFolderConfigurationModelForResource(void 0,t);return{default:this._defaultConfiguration.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this._workspaceConfiguration.keys.slice(0),workspaceFolder:s?s.keys.slice(0):[]}}updateDefaultConfiguration(t){this._defaultConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updatePolicyConfiguration(t){this._policyConfiguration=t}updateApplicationConfiguration(t){this._applicationConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(t){this._localUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(t){this._remoteUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(t){this._workspaceConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(t,s){this._folderConfigurations.set(t,s),this._foldersConsolidatedConfigurations.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this._foldersConsolidatedConfigurations.delete(t)}compareAndUpdateDefaultConfiguration(t,s){const r=[];if(!s){const{added:o,updated:h,removed:y}=u(this._defaultConfiguration,t);s=[...o,...h,...y]}for(const o of s)for(const h of(0,S.overrideIdentifiersFromKey)(o)){const y=this._defaultConfiguration.getKeysForOverrideIdentifier(h),A=t.getKeysForOverrideIdentifier(h),b=[...A.filter(w=>y.indexOf(w)===-1),...y.filter(w=>A.indexOf(w)===-1),...y.filter(w=>!L.equals(this._defaultConfiguration.override(h).getValue(w),t.override(h).getValue(w)))];r.push([h,b])}return this.updateDefaultConfiguration(t),{keys:s,overrides:r}}compareAndUpdatePolicyConfiguration(t){const{added:s,updated:r,removed:o}=u(this._policyConfiguration,t),h=[...s,...r,...o];return h.length&&this.updatePolicyConfiguration(t),{keys:h,overrides:[]}}compareAndUpdateApplicationConfiguration(t){const{added:s,updated:r,removed:o,overrides:h}=u(this.applicationConfiguration,t),y=[...s,...r,...o];return y.length&&this.updateApplicationConfiguration(t),{keys:y,overrides:h}}compareAndUpdateLocalUserConfiguration(t){const{added:s,updated:r,removed:o,overrides:h}=u(this.localUserConfiguration,t),y=[...s,...r,...o];return y.length&&this.updateLocalUserConfiguration(t),{keys:y,overrides:h}}compareAndUpdateRemoteUserConfiguration(t){const{added:s,updated:r,removed:o,overrides:h}=u(this.remoteUserConfiguration,t),y=[...s,...r,...o];return y.length&&this.updateRemoteUserConfiguration(t),{keys:y,overrides:h}}compareAndUpdateWorkspaceConfiguration(t){const{added:s,updated:r,removed:o,overrides:h}=u(this.workspaceConfiguration,t),y=[...s,...r,...o];return y.length&&this.updateWorkspaceConfiguration(t),{keys:y,overrides:h}}compareAndUpdateFolderConfiguration(t,s){const r=this.folderConfigurations.get(t),{added:o,updated:h,removed:y,overrides:A}=u(r,s),b=[...o,...h,...y];return(b.length||!r)&&this.updateFolderConfiguration(t,s),{keys:b,overrides:A}}compareAndDeleteFolderConfiguration(t){const s=this.folderConfigurations.get(t);if(!s)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:r,updated:o,removed:h,overrides:y}=u(s,void 0);return{keys:[...r,...o,...h],overrides:y}}get defaults(){return this._defaultConfiguration}get applicationConfiguration(){return this._applicationConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration)),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidatedConfigurationModel(t,s,r){let o=this.getConsolidatedConfigurationModelForResource(s,r);return s.overrideIdentifier&&(o=o.override(s.overrideIdentifier)),!this._policyConfiguration.isEmpty()&&this._policyConfiguration.getValue(t)!==void 0&&(o=o.merge(this._policyConfiguration)),o}getConsolidatedConfigurationModelForResource({resource:t},s){let r=this.getWorkspaceConsolidatedConfiguration();if(s&&t){const o=s.getFolder(t);o&&(r=this.getFolderConsolidatedConfiguration(o.uri)||r);const h=this._memoryConfigurationByResource.get(t);h&&(r=r.merge(h))}return r}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.applicationConfiguration,this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration)),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(t){let s=this._foldersConsolidatedConfigurations.get(t);if(!s){const r=this.getWorkspaceConsolidatedConfiguration(),o=this._folderConfigurations.get(t);o?(s=r.merge(o),this._foldersConsolidatedConfigurations.set(t,s)):s=r}return s}getFolderConfigurationModelForResource(t,s){if(s&&t){const r=s.getFolder(t);if(r)return this._folderConfigurations.get(r.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},policy:{contents:this._policyConfiguration.contents,overrides:this._policyConfiguration.overrides,keys:this._policyConfiguration.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((t,s)=>{const{contents:r,overrides:o,keys:h}=this._folderConfigurations.get(s);return t.push([s,{contents:r,overrides:o,keys:h}]),t},[])}}allKeys(){const t=new Set;return this._defaultConfiguration.keys.forEach(s=>t.add(s)),this.userConfiguration.keys.forEach(s=>t.add(s)),this._workspaceConfiguration.keys.forEach(s=>t.add(s)),this._folderConfigurations.forEach(s=>s.keys.forEach(r=>t.add(r))),[...t.values()]}allOverrideIdentifiers(){const t=new Set;return this._defaultConfiguration.getAllOverrideIdentifiers().forEach(s=>t.add(s)),this.userConfiguration.getAllOverrideIdentifiers().forEach(s=>t.add(s)),this._workspaceConfiguration.getAllOverrideIdentifiers().forEach(s=>t.add(s)),this._folderConfigurations.forEach(s=>s.getAllOverrideIdentifiers().forEach(r=>t.add(r))),[...t.values()]}getAllKeysForOverrideIdentifier(t){const s=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(t).forEach(r=>s.add(r)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(r=>s.add(r)),this._workspaceConfiguration.getKeysForOverrideIdentifier(t).forEach(r=>s.add(r)),this._folderConfigurations.forEach(r=>r.getKeysForOverrideIdentifier(t).forEach(o=>s.add(o))),[...s.values()]}static parse(t,s){const r=this.parseConfigurationModel(t.defaults,s),o=this.parseConfigurationModel(t.policy,s),h=this.parseConfigurationModel(t.application,s),y=this.parseConfigurationModel(t.user,s),A=this.parseConfigurationModel(t.workspace,s),b=t.folders.reduce((w,O)=>(w.set(E.URI.revive(O[0]),this.parseConfigurationModel(O[1],s)),w),new k.ResourceMap);return new C(r,o,h,y,g.createEmptyModel(s),A,b,g.createEmptyModel(s),new k.ResourceMap,s)}static parseConfigurationModel(t,s){return new g(t.contents,t.keys,t.overrides,void 0,s)}}e.Configuration=C;function p(...n){if(n.length===0)return{keys:[],overrides:[]};if(n.length===1)return n[0];const t=new Set,s=new Map;for(const o of n)o.keys.forEach(h=>t.add(h)),o.overrides.forEach(([h,y])=>{const A=(0,k.getOrSet)(s,h,new Set);y.forEach(b=>A.add(b))});const r=[];return s.forEach((o,h)=>r.push([h,[...o.values()]])),{keys:[...t.values()],overrides:r}}class c{constructor(t,s,r,o,h){this.change=t,this.previous=s,this.currentConfiguraiton=r,this.currentWorkspace=o,this.logService=h,this._marker=`
`,this._markerCode1=this._marker.charCodeAt(0),this._markerCode2=46,this.affectedKeys=new Set,this._previousConfiguration=void 0;for(const y of t.keys)this.affectedKeys.add(y);for(const[,y]of t.overrides)for(const A of y)this.affectedKeys.add(A);this._affectsConfigStr=this._marker;for(const y of this.affectedKeys)this._affectsConfigStr+=y+this._marker}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=C.parse(this.previous.data,this.logService)),this._previousConfiguration}affectsConfiguration(t,s){const r=this._marker+t,o=this._affectsConfigStr.indexOf(r);if(o<0)return!1;const h=o+r.length;if(h>=this._affectsConfigStr.length)return!1;const y=this._affectsConfigStr.charCodeAt(h);if(y!==this._markerCode1&&y!==this._markerCode2)return!1;if(s){const A=this.previousConfiguration?this.previousConfiguration.getValue(t,s,this.previous?.workspace):void 0,b=this.currentConfiguraiton.getValue(t,s,this.currentWorkspace);return!L.equals(A,b)}return!0}}e.ConfigurationChangeEvent=c;function u(n,t){const{added:s,removed:r,updated:o}=i(t?.rawConfiguration,n?.rawConfiguration),h=[],y=n?.getAllOverrideIdentifiers()||[],A=t?.getAllOverrideIdentifiers()||[];if(t){const b=A.filter(w=>!y.includes(w));for(const w of b)h.push([w,t.getKeysForOverrideIdentifier(w)])}if(n){const b=y.filter(w=>!A.includes(w));for(const w of b)h.push([w,n.getKeysForOverrideIdentifier(w)])}if(t&&n){for(const b of y)if(A.includes(b)){const w=i({contents:n.getOverrideValue(void 0,b)||{},keys:n.getKeysForOverrideIdentifier(b)},{contents:t.getOverrideValue(void 0,b)||{},keys:t.getKeysForOverrideIdentifier(b)});h.push([b,[...w.added,...w.removed,...w.updated]])}}return{added:s,removed:r,updated:o,overrides:h}}function i(n,t){const s=n?t?n.keys.filter(h=>t.keys.indexOf(h)===-1):[...n.keys]:[],r=t?n?t.keys.filter(h=>n.keys.indexOf(h)===-1):[...t.keys]:[],o=[];if(n&&t){for(const h of t.keys)if(n.keys.indexOf(h)!==-1){const y=(0,P.getConfigurationValue)(t.contents,h),A=(0,P.getConfigurationValue)(n.contents,h);L.equals(y,A)||o.push(h)}}return{added:s,removed:r,updated:o}}}),define(he[185],fe([0,1,17,3,2,29,12,78,47,11,58,44]),function(ce,e,R,a,_,T,k,L,D,E,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyConfiguration=e.NullPolicyConfiguration=e.DefaultConfiguration=void 0;class m extends _.Disposable{get configurationModel(){return this._configurationModel}constructor(I){super(),this.logService=I,this._onDidChangeConfiguration=this._register(new a.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this._configurationModel=L.ConfigurationModel.createEmptyModel(this.logService)}async initialize(){return this.resetConfigurationModel(),this._register(S.Registry.as(D.Extensions.Configuration).onDidUpdateConfiguration(({properties:I,defaultsOverrides:v})=>this.onDidUpdateConfiguration(Array.from(I),v))),this.configurationModel}reload(){return this.resetConfigurationModel(),this.configurationModel}onDidUpdateConfiguration(I,v){this.updateConfigurationModel(I,S.Registry.as(D.Extensions.Configuration).getConfigurationProperties()),this._onDidChangeConfiguration.fire({defaults:this.configurationModel,properties:I})}getConfigurationDefaultOverrides(){return{}}resetConfigurationModel(){this._configurationModel=L.ConfigurationModel.createEmptyModel(this.logService);const I=S.Registry.as(D.Extensions.Configuration).getConfigurationProperties();this.updateConfigurationModel(Object.keys(I),I)}updateConfigurationModel(I,v){const f=this.getConfigurationDefaultOverrides();for(const C of I){const p=f[C],c=v[C];p!==void 0?this._configurationModel.setValue(C,p):c?this._configurationModel.setValue(C,c.default):this._configurationModel.removeValue(C)}}}e.DefaultConfiguration=m;class d{constructor(){this.onDidChangeConfiguration=a.Event.None,this.configurationModel=L.ConfigurationModel.createEmptyModel(new E.NullLogService)}async initialize(){return this.configurationModel}}e.NullPolicyConfiguration=d;let l=class extends _.Disposable{get configurationModel(){return this._configurationModel}constructor(I,v,f){super(),this.defaultConfiguration=I,this.policyService=v,this.logService=f,this._onDidChangeConfiguration=this._register(new a.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this._configurationModel=L.ConfigurationModel.createEmptyModel(this.logService)}async initialize(){return this.logService.trace("PolicyConfiguration#initialize"),this.update(await this.updatePolicyDefinitions(this.defaultConfiguration.configurationModel.keys),!1),this._register(this.policyService.onDidChange(I=>this.onDidChangePolicies(I))),this._register(this.defaultConfiguration.onDidChangeConfiguration(async({properties:I})=>this.update(await this.updatePolicyDefinitions(I),!0))),this._configurationModel}async updatePolicyDefinitions(I){this.logService.trace("PolicyConfiguration#updatePolicyDefinitions",I);const v={},f=[],C=S.Registry.as(D.Extensions.Configuration).getConfigurationProperties();for(const p of I){const c=C[p];if(!c){f.push(p);continue}if(c.policy){if(c.type!=="string"&&c.type!=="number"){this.logService.warn(`Policy ${c.policy.name} has unsupported type ${c.type}`);continue}f.push(p),v[c.policy.name]={type:c.type}}}return(0,k.isEmptyObject)(v)||await this.policyService.updatePolicyDefinitions(v),f}onDidChangePolicies(I){this.logService.trace("PolicyConfiguration#onDidChangePolicies",I);const v=S.Registry.as(D.Extensions.Configuration).getPolicyConfigurations(),f=(0,R.coalesce)(I.map(C=>v.get(C)));this.update(f,!0)}update(I,v){this.logService.trace("PolicyConfiguration#update",I);const f=S.Registry.as(D.Extensions.Configuration).getConfigurationProperties(),C=[],p=this._configurationModel.isEmpty();for(const c of I){const u=f[c]?.policy?.name;if(u){const i=this.policyService.getPolicyValue(u);(p?i!==void 0:!(0,T.equals)(this._configurationModel.getValue(c),i))&&C.push([c,i])}else this._configurationModel.getValue(c)!==void 0&&C.push([c,void 0])}if(C.length){this.logService.trace("PolicyConfiguration#changed",C);const c=this._configurationModel;this._configurationModel=L.ConfigurationModel.createEmptyModel(this.logService);for(const u of c.keys)this._configurationModel.setValue(u,c.getValue(u));for(const[u,i]of C)i===void 0?this._configurationModel.removeValue(u):this._configurationModel.setValue(u,i);v&&this._onDidChangeConfiguration.fire(this._configurationModel)}}};e.PolicyConfiguration=l,e.PolicyConfiguration=l=Ie([Y(1,P.IPolicyService),Y(2,E.ILogService)],l)}),define(he[186],fe([0,1,17,6,14,3,36,64,2,31,29,5,20,21,78,47,185,7,58]),function(ce,e,R,a,_,T,k,L,D,E,P,S,m,d,l,g,I,v,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class C extends D.Disposable{constructor(u,i,n,t){super(),this.settingsResource=u,this.logService=t,this._onDidChangeConfiguration=this._register(new T.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.defaultConfiguration=this._register(new I.DefaultConfiguration(t)),this.policyConfiguration=n instanceof f.NullPolicyService?new I.NullPolicyConfiguration:this._register(new I.PolicyConfiguration(this.defaultConfiguration,n,t)),this.userConfiguration=this._register(new l.UserSettings(this.settingsResource,{},m.extUriBiasedIgnorePathCase,i,t)),this.configuration=new l.Configuration(this.defaultConfiguration.configurationModel,this.policyConfiguration.configurationModel,l.ConfigurationModel.createEmptyModel(t),l.ConfigurationModel.createEmptyModel(t),l.ConfigurationModel.createEmptyModel(t),l.ConfigurationModel.createEmptyModel(t),new E.ResourceMap,l.ConfigurationModel.createEmptyModel(t),new E.ResourceMap,t),this.configurationEditing=new p(u,i,this),this.reloadConfigurationScheduler=this._register(new a.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(this.defaultConfiguration.onDidChangeConfiguration(({defaults:s,properties:r})=>this.onDidDefaultConfigurationChange(s,r))),this._register(this.policyConfiguration.onDidChangeConfiguration(s=>this.onDidPolicyConfigurationChange(s))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const[u,i,n]=await Promise.all([this.defaultConfiguration.initialize(),this.policyConfiguration.initialize(),this.userConfiguration.loadConfiguration()]);this.configuration=new l.Configuration(u,i,l.ConfigurationModel.createEmptyModel(this.logService),n,l.ConfigurationModel.createEmptyModel(this.logService),l.ConfigurationModel.createEmptyModel(this.logService),new E.ResourceMap,l.ConfigurationModel.createEmptyModel(this.logService),new E.ResourceMap,this.logService)}getConfigurationData(){return this.configuration.toData()}getValue(u,i){const n=typeof u=="string"?u:void 0,t=(0,d.isConfigurationOverrides)(u)?u:(0,d.isConfigurationOverrides)(i)?i:{};return this.configuration.getValue(n,t,void 0)}async updateValue(u,i,n,t,s){const r=(0,d.isConfigurationUpdateOverrides)(n)?n:(0,d.isConfigurationOverrides)(n)?{resource:n.resource,overrideIdentifiers:n.overrideIdentifier?[n.overrideIdentifier]:void 0}:void 0,o=r?t:n;if(o!==void 0&&o!==d.ConfigurationTarget.USER_LOCAL&&o!==d.ConfigurationTarget.USER)throw new Error(`Unable to write ${u} to target ${o}.`);r?.overrideIdentifiers&&(r.overrideIdentifiers=(0,R.distinct)(r.overrideIdentifiers),r.overrideIdentifiers=r.overrideIdentifiers.length?r.overrideIdentifiers:void 0);const h=this.inspect(u,{resource:r?.resource,overrideIdentifier:r?.overrideIdentifiers?r.overrideIdentifiers[0]:void 0});if(h.policyValue!==void 0)throw new Error(`Unable to write ${u} because it is configured in system policy.`);if((0,P.equals)(i,h.defaultValue)&&(i=void 0),r?.overrideIdentifiers?.length&&r.overrideIdentifiers.length>1){const A=r.overrideIdentifiers.sort(),b=this.configuration.localUserConfiguration.overrides.find(w=>(0,R.equals)([...w.identifiers].sort(),A));b&&(r.overrideIdentifiers=b.identifiers)}const y=r?.overrideIdentifiers?.length?[(0,g.keyFromOverrideIdentifiers)(r.overrideIdentifiers),u]:[u];await this.configurationEditing.write(y,i),await this.reloadConfiguration()}inspect(u,i={}){return this.configuration.inspect(u,i,void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const u=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(u)}onDidChangeUserConfiguration(u){const i=this.configuration.toData(),n=this.configuration.compareAndUpdateLocalUserConfiguration(u);this.trigger(n,i,d.ConfigurationTarget.USER)}onDidDefaultConfigurationChange(u,i){const n=this.configuration.toData(),t=this.configuration.compareAndUpdateDefaultConfiguration(u,i);this.trigger(t,n,d.ConfigurationTarget.DEFAULT)}onDidPolicyConfigurationChange(u){const i=this.configuration.toData(),n=this.configuration.compareAndUpdatePolicyConfiguration(u);this.trigger(n,i,d.ConfigurationTarget.DEFAULT)}trigger(u,i,n){const t=new l.ConfigurationChangeEvent(u,{data:i},this.configuration,void 0,this.logService);t.source=n,this._onDidChangeConfiguration.fire(t)}}e.ConfigurationService=C;class p{constructor(u,i,n){this.settingsResource=u,this.fileService=i,this.configurationService=n,this.queue=new a.Queue}write(u,i){return this.queue.queue(()=>this.doWriteConfiguration(u,i))}async doWriteConfiguration(u,i){let n;try{n=(await this.fileService.readFile(this.settingsResource)).value.toString()}catch(r){if(r.fileOperationResult===v.FileOperationResult.FILE_NOT_FOUND)n="{}";else throw r}const t=[];if((0,k.parse)(n,t,{allowTrailingComma:!0,allowEmptyContent:!0}),t.length>0)throw new Error("Unable to write into the settings file. Please open the file to correct errors/warnings in the file and try again.");const s=this.getEdits(n,u,i);n=(0,L.applyEdits)(n,s),await this.fileService.writeFile(this.settingsResource,_.VSBuffer.fromString(n))}getEdits(u,i,n){const{tabSize:t,insertSpaces:s,eol:r}=this.formattingOptions;if(!i.length){const o=JSON.stringify(n,null,s?" ".repeat(t):"	");return[{content:o,length:o.length,offset:0}]}return(0,L.setProperty)(u,i,n,{tabSize:t,insertSpaces:s,eol:r})}get formattingOptions(){if(!this._formattingOptions){let u=S.OS===S.OperatingSystem.Linux||S.OS===S.OperatingSystem.Macintosh?`
`:`\r
`;const i=this.configurationService.getValue("files.eol",{overrideIdentifier:"jsonc"});i&&typeof i=="string"&&i!=="auto"&&(u=i),this._formattingOptions={eol:u,insertSpaces:!!this.configurationService.getValue("editor.insertSpaces",{overrideIdentifier:"jsonc"}),tabSize:this.configurationService.getValue("editor.tabSize",{overrideIdentifier:"jsonc"})}}return this._formattingOptions}}}),define(he[187],fe([0,1,14,3,2,72]),function(ce,e,R,a,_,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ManagedSocket=e.socketRawEndHeaderSequence=e.makeRawSocketHeaders=void 0,e.connectManagedSocket=L;const k=(E,P,S)=>{const m=new Uint8Array(16);for(let g=0;g<16;g++)m[g]=Math.round(Math.random()*256);const d=(0,R.encodeBase64)(R.VSBuffer.wrap(m));return[`GET ws://localhost${E}?${P}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${d}`].join(`\r
`)+`\r
\r
`};e.makeRawSocketHeaders=k,e.socketRawEndHeaderSequence=R.VSBuffer.fromString(`\r
\r
`);async function L(E,P,S,m,d){E.write(R.VSBuffer.fromString((0,e.makeRawSocketHeaders)(P,S,m)));const l=new _.DisposableStore;try{return await new Promise((g,I)=>{let v;l.add(E.onData(f=>{v?v=R.VSBuffer.concat([v,f],v.byteLength+f.byteLength):v=f;const C=v.indexOf(e.socketRawEndHeaderSequence);if(C===-1)return;g(E),E.pauseData();const p=v.slice(C+e.socketRawEndHeaderSequence.byteLength);p.byteLength&&d.onData.fire(p)})),l.add(E.onClose(f=>I(f??new Error("socket closed")))),l.add(E.onEnd(()=>I(new Error("socket ended"))))})}catch(g){throw E.dispose(),g}finally{l.dispose()}}class D extends _.Disposable{constructor(P,S){super(),this.debugLabel=P,this.pausableDataEmitter=this._register(new a.PauseableEmitter),this.onData=(...m)=>(this.pausableDataEmitter.isPaused&&queueMicrotask(()=>this.pausableDataEmitter.resume()),this.pausableDataEmitter.event(...m)),this.didDisposeEmitter=this._register(new a.Emitter),this.onDidDispose=this.didDisposeEmitter.event,this.ended=!1,this._register(S.onData),this._register(S.onData.event(m=>this.pausableDataEmitter.fire(m))),this.onClose=this._register(S.onClose).event,this.onEnd=this._register(S.onEnd).event}pauseData(){this.pausableDataEmitter.pause()}drain(){return Promise.resolve()}end(){this.ended=!0,this.closeRemote()}traceSocketEvent(P,S){T.SocketDiagnostics.traceSocketEvent(this,this.debugLabel,P,S)}dispose(){this.ended||this.closeRemote(),this.didDisposeEmitter.fire(),super.dispose()}}e.ManagedSocket=D}),define(he[106],fe([0,1,8,4]),function(ce,e,R,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.WebSocketRemoteConnection=e.ManagedRemoteConnection=e.RemoteConnectionType=e.IRemoteAuthorityResolverService=void 0,e.getRemoteAuthorityPrefix=E,e.IRemoteAuthorityResolverService=(0,a.createDecorator)("remoteAuthorityResolverService");var _;(function(P){P[P.WebSocket=0]="WebSocket",P[P.Managed=1]="Managed"})(_||(e.RemoteConnectionType=_={}));class T{constructor(S){this.id=S,this.type=_.Managed}toString(){return`Managed(${this.id})`}}e.ManagedRemoteConnection=T;class k{constructor(S,m){this.host=S,this.port=m,this.type=_.WebSocket}toString(){return`WebSocket(${this.host}:${this.port})`}}e.WebSocketRemoteConnection=k;var L;(function(P){P.Unknown="Unknown",P.NotAvailable="NotAvailable",P.TemporarilyNotAvailable="TemporarilyNotAvailable",P.NoResolverFound="NoResolverFound",P.InvalidAuthority="InvalidAuthority"})(L||(e.RemoteAuthorityResolverErrorCode=L={}));class D extends R.ErrorNoTelemetry{static isNotAvailable(S){return S instanceof D&&S._code===L.NotAvailable}static isTemporarilyNotAvailable(S){return S instanceof D&&S._code===L.TemporarilyNotAvailable}static isNoResolverFound(S){return S instanceof D&&S._code===L.NoResolverFound}static isInvalidAuthority(S){return S instanceof D&&S._code===L.InvalidAuthority}static isHandled(S){return S instanceof D&&S.isHandled}constructor(S,m=L.Unknown,d){super(S),this._message=S,this._code=m,this._detail=d,this.isHandled=m===L.NotAvailable&&d===!0,Object.setPrototypeOf(this,D.prototype)}}e.RemoteAuthorityResolverError=D;function E(P){const S=P.indexOf("+");return S===-1?P:P.substring(0,S)}}),define(he[188],fe([0,1,6,14,25,8,3,2,22,102,54,32,72,106]),function(ce,e,R,a,_,T,k,L,D,E,P,S,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.PersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.ConnectionType=void 0,e.connectRemoteAgentManagement=h,e.connectRemoteAgentExtensionHost=y,e.connectRemoteAgentTunnel=b,E=De(E);const l=30*1e3;var g;(function(H){H[H.Management=1]="Management",H[H.ExtensionHost=2]="ExtensionHost",H[H.Tunnel=3]="Tunnel"})(g||(e.ConnectionType=g={}));function I(H){switch(H){case g.Management:return"Management";case g.ExtensionHost:return"ExtensionHost";case g.Tunnel:return"Tunnel"}}function v(H){const W=new _.CancellationTokenSource;return setTimeout(()=>W.cancel(),H),W.token}function f(H,W){if(H.isCancellationRequested||W.isCancellationRequested)return _.CancellationToken.Cancelled;const U=new _.CancellationTokenSource;return H.onCancellationRequested(()=>U.cancel()),W.onCancellationRequested(()=>U.cancel()),U.token}class C{get didTimeout(){return this._state==="timedout"}constructor(W){this._state="pending",this._disposables=new L.DisposableStore,{promise:this.promise,resolve:this._resolvePromise,reject:this._rejectPromise}=(0,R.promiseWithResolvers)(),W.isCancellationRequested?this._timeout():this._disposables.add(W.onCancellationRequested(()=>this._timeout()))}registerDisposable(W){this._state==="pending"?this._disposables.add(W):W.dispose()}_timeout(){this._state==="pending"&&(this._disposables.dispose(),this._state="timedout",this._rejectPromise(this._createTimeoutError()))}_createTimeoutError(){const W=new Error("Time limit reached");return W.code="ETIMEDOUT",W.syscall="connect",W}resolve(W){this._state==="pending"&&(this._disposables.dispose(),this._state="resolved",this._resolvePromise(W))}reject(W){this._state==="pending"&&(this._disposables.dispose(),this._state="rejected",this._rejectPromise(W))}}function p(H,W){const U=new C(W);return U.registerDisposable(H.onControlMessage(G=>{const oe=JSON.parse(G.toString()),Q=B(oe);Q?U.reject(Q):U.resolve(oe)})),U.promise}function c(H,W,U,G,oe,Q,X,x){const $=new C(x),ie=P.StopWatch.create(!1);return H.info(`Creating a socket (${X})...`),E.mark(`code/willCreateSocket/${Q}`),W.connect(U,G,oe,X).then(ae=>{$.didTimeout?(E.mark(`code/didCreateSocketError/${Q}`),H.info(`Creating a socket (${X}) finished after ${ie.elapsed()} ms, but this is too late and has timed out already.`),ae?.dispose()):(E.mark(`code/didCreateSocketOK/${Q}`),H.info(`Creating a socket (${X}) was successful after ${ie.elapsed()} ms.`),$.resolve(ae))},ae=>{E.mark(`code/didCreateSocketError/${Q}`),H.info(`Creating a socket (${X}) returned an error after ${ie.elapsed()} ms.`),H.error(ae),$.reject(ae)}),$.promise}function u(H,W){const U=new C(W);return H.then(G=>{U.didTimeout||U.resolve(G)},G=>{U.didTimeout||U.reject(G)}),U.promise}async function i(H,W,U,G){const oe=ee(H,W);H.logService.trace(`${oe} 1/6. invoking socketFactory.connect().`);let Q;try{Q=await c(H.logService,H.remoteSocketFactoryService,H.connectTo,D.RemoteAuthorities.getServerRootPath(),`reconnectionToken=${H.reconnectionToken}&reconnection=${H.reconnectionProtocol?"true":"false"}`,I(W),`renderer-${I(W)}-${H.reconnectionToken}`,G)}catch(ae){throw H.logService.error(`${oe} socketFactory.connect() failed or timed out. Error:`),H.logService.error(ae),ae}H.logService.trace(`${oe} 2/6. socketFactory.connect() was successful.`);let X,x;H.reconnectionProtocol?(H.reconnectionProtocol.beginAcceptReconnection(Q,null),X=H.reconnectionProtocol,x=!1):(X=new m.PersistentProtocol({socket:Q}),x=!0),H.logService.trace(`${oe} 3/6. sending AuthRequest control message.`);const $=await u(H.signService.createNewMessage((0,S.generateUuid)()),G),ie={type:"auth",auth:H.connectionToken||"00000000000000000000",data:$.data};X.sendControl(a.VSBuffer.fromString(JSON.stringify(ie)));try{const ae=await p(X,f(G,v(1e4)));if(ae.type!=="sign"||typeof ae.data!="string"){const Re=new Error("Unexpected handshake message");throw Re.code="VSCODE_CONNECTION_ERROR",Re}if(H.logService.trace(`${oe} 4/6. received SignRequest control message.`),!await u(H.signService.validate($,ae.signedData),G)){const Re=new Error("Refused to connect to unsupported server");throw Re.code="VSCODE_CONNECTION_ERROR",Re}const Se=await u(H.signService.sign(ae.data),G),Ee={type:"connectionType",commit:H.commit,signedData:Se,desiredConnectionType:W};return U&&(Ee.args=U),H.logService.trace(`${oe} 5/6. sending ConnectionTypeRequest control message.`),X.sendControl(a.VSBuffer.fromString(JSON.stringify(Ee))),{protocol:X,ownsProtocol:x}}catch(ae){throw ae&&ae.code==="ETIMEDOUT"&&(H.logService.error(`${oe} the handshake timed out. Error:`),H.logService.error(ae)),ae&&ae.code==="VSCODE_CONNECTION_ERROR"&&(H.logService.error(`${oe} received error control message when negotiating connection. Error:`),H.logService.error(ae)),x&&q(X),ae}}async function n(H,W,U,G){const oe=Date.now(),Q=ee(H,W),{protocol:X,ownsProtocol:x}=await i(H,W,U,G),$=new C(G);return $.registerDisposable(X.onControlMessage(ie=>{const ae=JSON.parse(ie.toString()),ue=B(ae);ue?(H.logService.error(`${Q} received error control message when negotiating connection. Error:`),H.logService.error(ue),x&&q(X),$.reject(ue)):(H.reconnectionProtocol?.endAcceptReconnection(),H.logService.trace(`${Q} 6/6. handshake finished, connection is up and running after ${K(oe)}!`),$.resolve({protocol:X,firstMessage:ae}))})),$.promise}async function t(H,W){const{protocol:U}=await n(H,g.Management,void 0,W);return{protocol:U}}async function s(H,W,U){const{protocol:G,firstMessage:oe}=await n(H,g.ExtensionHost,W,U),Q=oe&&oe.debugPort;return{protocol:G,debugPort:Q}}async function r(H,W,U){const G=Date.now(),oe=ee(H,g.Tunnel),{protocol:Q}=await i(H,g.Tunnel,W,U);return H.logService.trace(`${oe} 6/6. handshake finished, connection is up and running after ${K(G)}!`),Q}async function o(H,W,U){const{connectTo:G,connectionToken:oe}=await H.addressProvider.getAddress();return{commit:H.commit,quality:H.quality,connectTo:G,connectionToken:oe,reconnectionToken:W,reconnectionProtocol:U,remoteSocketFactoryService:H.remoteSocketFactoryService,signService:H.signService,logService:H.logService}}async function h(H,W,U){return A(H,async G=>{const{protocol:oe}=await t(G,_.CancellationToken.None);return new j(H,W,U,G.reconnectionToken,oe)})}async function y(H,W){return A(H,async U=>{const{protocol:G,debugPort:oe}=await s(U,W,_.CancellationToken.None);return new te(H,W,U.reconnectionToken,G,oe)})}async function A(H,W){for(let G=1;;G++)try{const oe=(0,S.generateUuid)(),Q=await o(H,oe,null);return await W(Q)}catch(oe){if(G<5)H.logService.error(`[remote-connection][attempt ${G}] An error occurred in initial connection! Will retry... Error:`),H.logService.error(oe);else throw H.logService.error(`[remote-connection][attempt ${G}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),H.logService.error(oe),J.triggerPermanentFailure(0,0,d.RemoteAuthorityResolverError.isHandled(oe)),oe}}async function b(H,W,U){const G=await o(H,(0,S.generateUuid)(),null);return await r(G,{host:W,port:U},_.CancellationToken.None)}function w(H){return(0,R.createCancelablePromise)(W=>new Promise((U,G)=>{const oe=setTimeout(U,H*1e3);W.onCancellationRequested(()=>{clearTimeout(oe),U()})}))}var O;(function(H){H[H.ConnectionLost=0]="ConnectionLost",H[H.ReconnectionWait=1]="ReconnectionWait",H[H.ReconnectionRunning=2]="ReconnectionRunning",H[H.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",H[H.ConnectionGain=4]="ConnectionGain"})(O||(e.PersistentConnectionEventType=O={}));class F{constructor(W,U){this.reconnectionToken=W,this.millisSinceLastIncomingData=U,this.type=O.ConnectionLost}}e.ConnectionLostEvent=F;class N{constructor(W,U,G,oe){this.reconnectionToken=W,this.millisSinceLastIncomingData=U,this.durationSeconds=G,this.cancellableTimer=oe,this.type=O.ReconnectionWait}skipWait(){this.cancellableTimer.cancel()}}e.ReconnectionWaitEvent=N;class M{constructor(W,U,G){this.reconnectionToken=W,this.millisSinceLastIncomingData=U,this.attempt=G,this.type=O.ReconnectionRunning}}e.ReconnectionRunningEvent=M;class V{constructor(W,U,G){this.reconnectionToken=W,this.millisSinceLastIncomingData=U,this.attempt=G,this.type=O.ConnectionGain}}e.ConnectionGainEvent=V;class z{constructor(W,U,G,oe){this.reconnectionToken=W,this.millisSinceLastIncomingData=U,this.attempt=G,this.handled=oe,this.type=O.ReconnectionPermanentFailure}}e.ReconnectionPermanentFailureEvent=z;class J extends L.Disposable{static triggerPermanentFailure(W,U,G){this._permanentFailure=!0,this._permanentFailureMillisSinceLastIncomingData=W,this._permanentFailureAttempt=U,this._permanentFailureHandled=G,this._instances.forEach(oe=>oe._gotoPermanentFailure(this._permanentFailureMillisSinceLastIncomingData,this._permanentFailureAttempt,this._permanentFailureHandled))}static debugTriggerReconnection(){this._instances.forEach(W=>W._beginReconnecting())}static debugPauseSocketWriting(){this._instances.forEach(W=>W._pauseSocketWriting())}static{this._permanentFailure=!1}static{this._permanentFailureMillisSinceLastIncomingData=0}static{this._permanentFailureAttempt=0}static{this._permanentFailureHandled=!1}static{this._instances=[]}get _isPermanentFailure(){return this._permanentFailure||J._permanentFailure}constructor(W,U,G,oe,Q){super(),this._connectionType=W,this._options=U,this.reconnectionToken=G,this.protocol=oe,this._reconnectionFailureIsFatal=Q,this._onDidStateChange=this._register(new k.Emitter),this.onDidStateChange=this._onDidStateChange.event,this._permanentFailure=!1,this._isReconnecting=!1,this._isDisposed=!1,this._onDidStateChange.fire(new V(this.reconnectionToken,0,0)),this._register(oe.onSocketClose(X=>{const x=le(this._connectionType,this.reconnectionToken,!0);X?X.type===m.SocketCloseEventType.NodeSocketCloseEvent?(this._options.logService.info(`${x} received socket close event (hadError: ${X.hadError}).`),X.error&&this._options.logService.error(X.error)):(this._options.logService.info(`${x} received socket close event (wasClean: ${X.wasClean}, code: ${X.code}, reason: ${X.reason}).`),X.event&&this._options.logService.error(X.event)):this._options.logService.info(`${x} received socket close event.`),this._beginReconnecting()})),this._register(oe.onSocketTimeout(X=>{const x=le(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${x} received socket timeout event (unacknowledgedMsgCount: ${X.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${X.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${X.timeSinceLastReceivedSomeData}).`),this._beginReconnecting()})),J._instances.push(this),this._register((0,L.toDisposable)(()=>{const X=J._instances.indexOf(this);X>=0&&J._instances.splice(X,1)})),this._isPermanentFailure&&this._gotoPermanentFailure(J._permanentFailureMillisSinceLastIncomingData,J._permanentFailureAttempt,J._permanentFailureHandled)}dispose(){super.dispose(),this._isDisposed=!0}async _beginReconnecting(){if(!this._isReconnecting)try{this._isReconnecting=!0,await this._runReconnectingLoop()}finally{this._isReconnecting=!1}}async _runReconnectingLoop(){if(this._isPermanentFailure||this._isDisposed)return;const W=le(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${W} starting reconnecting loop. You can get more information with the trace log level.`),this._onDidStateChange.fire(new F(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const U=[0,5,5,10,10,10,10,10,30];let G=-1;do{G++;const oe=G<U.length?U[G]:U[U.length-1];try{if(oe>0){const X=w(oe);this._onDidStateChange.fire(new N(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),oe,X)),this._options.logService.info(`${W} waiting for ${oe} seconds before reconnecting...`);try{await X}catch{}}if(this._isPermanentFailure){this._options.logService.error(`${W} permanent failure occurred while running the reconnecting loop.`);break}this._onDidStateChange.fire(new M(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),G+1)),this._options.logService.info(`${W} resolving connection...`);const Q=await o(this._options,this.reconnectionToken,this.protocol);this._options.logService.info(`${W} connecting to ${Q.connectTo}...`),await this._reconnect(Q,v(l)),this._options.logService.info(`${W} reconnected!`),this._onDidStateChange.fire(new V(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),G+1));break}catch(Q){if(Q.code==="VSCODE_CONNECTION_ERROR"){this._options.logService.error(`${W} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this._options.logService.error(Q),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),G+1,!1);break}if(G>360){this._options.logService.error(`${W} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this._options.logService.error(Q),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),G+1,!1);break}if(d.RemoteAuthorityResolverError.isTemporarilyNotAvailable(Q)){this._options.logService.info(`${W} A temporarily not available error occurred while trying to reconnect, will try again...`),this._options.logService.trace(Q);continue}if((Q.code==="ETIMEDOUT"||Q.code==="ENETUNREACH"||Q.code==="ECONNREFUSED"||Q.code==="ECONNRESET")&&Q.syscall==="connect"){this._options.logService.info(`${W} A network error occurred while trying to reconnect, will try again...`),this._options.logService.trace(Q);continue}if((0,T.isCancellationError)(Q)){this._options.logService.info(`${W} A promise cancelation error occurred while trying to reconnect, will try again...`),this._options.logService.trace(Q);continue}if(Q instanceof d.RemoteAuthorityResolverError){this._options.logService.error(`${W} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this._options.logService.error(Q),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),G+1,d.RemoteAuthorityResolverError.isHandled(Q));break}this._options.logService.error(`${W} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this._options.logService.error(Q),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),G+1,!1);break}}while(!this._isPermanentFailure&&!this._isDisposed)}_onReconnectionPermanentFailure(W,U,G){this._reconnectionFailureIsFatal?J.triggerPermanentFailure(W,U,G):this._gotoPermanentFailure(W,U,G)}_gotoPermanentFailure(W,U,G){this._onDidStateChange.fire(new z(this.reconnectionToken,W,U,G)),q(this.protocol)}_pauseSocketWriting(){this.protocol.pauseSocketWriting()}}e.PersistentConnection=J;class j extends J{constructor(W,U,G,oe,Q){super(g.Management,W,oe,Q,!0),this.client=this._register(new m.Client(Q,{remoteAuthority:U,clientId:G},W.ipcLogger))}async _reconnect(W,U){await t(W,U)}}e.ManagementPersistentConnection=j;class te extends J{constructor(W,U,G,oe,Q){super(g.ExtensionHost,W,G,oe,!1),this._startArguments=U,this.debugPort=Q}async _reconnect(W,U){await s(W,this._startArguments,U)}}e.ExtensionHostPersistentConnection=te;function q(H){try{H.acceptDisconnect();const W=H.getSocket();H.dispose(),W.dispose()}catch(W){(0,T.onUnexpectedError)(W)}}function B(H){if(H&&H.type==="error"){const W=new Error(`Connection error: ${H.reason}`);return W.code="VSCODE_CONNECTION_ERROR",W}return null}function Z(H,W){for(;H.length<W;)H+=" ";return H}function ne(H,W){return`[remote-connection][${Z(I(H),13)}][${W.substr(0,5)}\u2026]`}function le(H,W,U){return`${ne(H,W)}[${U?"reconnect":"initial"}]`}function ee(H,W){return`${le(W,H.reconnectionToken,!!H.reconnectionProtocol)}[${H.connectTo}]`}function K(H){return`${Date.now()-H} ms`}}),define(he[107],fe([0,1,22]),function(ce,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteAuthority=a,e.getRemoteName=_,e.parseAuthorityWithPort=T,e.parseAuthorityWithOptionalPort=k;function a(D){return D.scheme===R.Schemas.vscodeRemote?D.authority:void 0}function _(D){if(!D)return;const E=D.indexOf("+");return E<0?D:D.substr(0,E)}function T(D){const{host:E,port:P}=L(D);if(typeof P>"u")throw new Error(`Invalid remote authority: ${D}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:E,port:P}}function k(D,E){let{host:P,port:S}=L(D);return typeof S>"u"&&(S=E),{host:P,port:S}}function L(D){const E=D.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(E)return{host:E[1],port:parseInt(E[2],10)};const P=D.match(/^(\[[0-9a-z:]+\])$/);if(P)return{host:P[1],port:void 0};const S=D.match(/(.*):(\d+)$/);return S?{host:S[1],port:parseInt(S[2],10)}:{host:D,port:void 0}}}),define(he[34],fe([0,1,26,4,107]),function(ce,e,R,a,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.ExtensionIdentifierMap=e.ExtensionIdentifierSet=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=void 0,e.getWorkspaceSupportTypeMessage=T,e.isApplicationScopedExtension=S,e.isLanguagePackExtension=m,e.isAuthenticationProviderExtension=d,e.isResolverExtension=l,e.parseApiProposals=g,e.parseEnabledApiProposalNames=I,R=De(R),e.USER_MANIFEST_CACHE_FILE="extensions.user.cache",e.BUILTIN_MANIFEST_CACHE_FILE="extensions.builtin.cache",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function T(v){if(typeof v=="object"&&v!==null&&v.supported!==!0)return v.description}e.EXTENSION_CATEGORIES=["AI","Azure","Chat","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var k;(function(v){v[v.System=0]="System",v[v.User=1]="User"})(k||(e.ExtensionType=k={}));var L;(function(v){v.WIN32_X64="win32-x64",v.WIN32_ARM64="win32-arm64",v.LINUX_X64="linux-x64",v.LINUX_ARM64="linux-arm64",v.LINUX_ARMHF="linux-armhf",v.LINUX_PPC64LE="linux-ppc64le",v.LINUX_RISCV64="linux-riscv64",v.ALPINE_X64="alpine-x64",v.ALPINE_ARM64="alpine-arm64",v.DARWIN_X64="darwin-x64",v.DARWIN_ARM64="darwin-arm64",v.WEB="web",v.UNIVERSAL="universal",v.UNKNOWN="unknown",v.UNDEFINED="undefined"})(L||(e.TargetPlatform=L={}));class D{constructor(f){this.value=f,this._lower=f.toLowerCase()}static equals(f,C){if(typeof f>"u"||f===null)return typeof C>"u"||C===null;if(typeof C>"u"||C===null)return!1;if(typeof f=="string"||typeof C=="string"){const p=typeof f=="string"?f:f.value,c=typeof C=="string"?C:C.value;return R.equalsIgnoreCase(p,c)}return f._lower===C._lower}static toKey(f){return typeof f=="string"?f.toLowerCase():f._lower}}e.ExtensionIdentifier=D;class E{get size(){return this._set.size}constructor(f){if(this._set=new Set,f)for(const C of f)this.add(C)}add(f){this._set.add(D.toKey(f))}delete(f){return this._set.delete(D.toKey(f))}has(f){return this._set.has(D.toKey(f))}}e.ExtensionIdentifierSet=E;class P{constructor(){this._map=new Map}clear(){this._map.clear()}delete(f){this._map.delete(D.toKey(f))}get(f){return this._map.get(D.toKey(f))}has(f){return this._map.has(D.toKey(f))}set(f,C){this._map.set(D.toKey(f),C)}values(){return this._map.values()}forEach(f){this._map.forEach(f)}[Symbol.iterator](){return this._map[Symbol.iterator]()}}e.ExtensionIdentifierMap=P;function S(v){return m(v)}function m(v){return v.contributes&&v.contributes.localizations?v.contributes.localizations.length>0:!1}function d(v){return v.contributes&&v.contributes.authentication?v.contributes.authentication.length>0:!1}function l(v,f){if(f){const C=`onResolveRemoteAuthority:${(0,_.getRemoteName)(f)}`;return!!v.activationEvents?.includes(C)}return!1}function g(v){return v.map(f=>{const[C,p]=f.split("@");return{proposalName:C,version:p?parseInt(p):void 0}})}function I(v){return v.map(f=>f.split("@")[0])}e.IBuiltinExtensionsScannerService=(0,a.createDecorator)("IBuiltinExtensionsScannerService")}),define(he[27],fe([0,1,5,9,34,4]),function(ce,e,R,a,_,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.ExtensionsLocalizedLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.ExtensionGalleryError=e.ExtensionGalleryErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.ExtensionInstallSource=e.EXTENSION_INSTALL_CLIENT_TARGET_PLATFORM_CONTEXT=e.EXTENSION_INSTALL_DEP_PACK_CONTEXT=e.EXTENSION_INSTALL_SOURCE_CONTEXT=e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.TargetPlatformToString=L,e.toTargetPlatform=D,e.getTargetPlatform=E,e.isNotWebExtensionInWebTargetPlatform=P,e.isTargetPlatformCompatible=S,e.isIExtensionIdentifier=m,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension",e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT="skipWalkthrough",e.EXTENSION_INSTALL_SOURCE_CONTEXT="extensionInstallSource",e.EXTENSION_INSTALL_DEP_PACK_CONTEXT="dependecyOrPackExtensionInstall",e.EXTENSION_INSTALL_CLIENT_TARGET_PLATFORM_CONTEXT="clientTargetPlatform";var k;(function(c){c.COMMAND="command",c.SETTINGS_SYNC="settingsSync"})(k||(e.ExtensionInstallSource=k={}));function L(c){switch(c){case _.TargetPlatform.WIN32_X64:return"Windows 64 bit";case _.TargetPlatform.WIN32_ARM64:return"Windows ARM";case _.TargetPlatform.LINUX_X64:return"Linux 64 bit";case _.TargetPlatform.LINUX_ARM64:return"Linux ARM 64";case _.TargetPlatform.LINUX_ARMHF:return"Linux ARM";case _.TargetPlatform.LINUX_PPC64LE:return"Linux PowerPC64";case _.TargetPlatform.LINUX_RISCV64:return"Linux RISC-V 64";case _.TargetPlatform.ALPINE_X64:return"Alpine Linux 64 bit";case _.TargetPlatform.ALPINE_ARM64:return"Alpine ARM 64";case _.TargetPlatform.DARWIN_X64:return"Mac";case _.TargetPlatform.DARWIN_ARM64:return"Mac Silicon";case _.TargetPlatform.WEB:return"Web";case _.TargetPlatform.UNIVERSAL:return _.TargetPlatform.UNIVERSAL;case _.TargetPlatform.UNKNOWN:return _.TargetPlatform.UNKNOWN;case _.TargetPlatform.UNDEFINED:return _.TargetPlatform.UNDEFINED}}function D(c){switch(c){case _.TargetPlatform.WIN32_X64:return _.TargetPlatform.WIN32_X64;case _.TargetPlatform.WIN32_ARM64:return _.TargetPlatform.WIN32_ARM64;case _.TargetPlatform.LINUX_X64:return _.TargetPlatform.LINUX_X64;case _.TargetPlatform.LINUX_ARM64:return _.TargetPlatform.LINUX_ARM64;case _.TargetPlatform.LINUX_ARMHF:return _.TargetPlatform.LINUX_ARMHF;case _.TargetPlatform.LINUX_PPC64LE:return _.TargetPlatform.LINUX_PPC64LE;case _.TargetPlatform.LINUX_RISCV64:return _.TargetPlatform.LINUX_RISCV64;case _.TargetPlatform.ALPINE_X64:return _.TargetPlatform.ALPINE_X64;case _.TargetPlatform.ALPINE_ARM64:return _.TargetPlatform.ALPINE_ARM64;case _.TargetPlatform.DARWIN_X64:return _.TargetPlatform.DARWIN_X64;case _.TargetPlatform.DARWIN_ARM64:return _.TargetPlatform.DARWIN_ARM64;case _.TargetPlatform.WEB:return _.TargetPlatform.WEB;case _.TargetPlatform.UNIVERSAL:return _.TargetPlatform.UNIVERSAL;default:return _.TargetPlatform.UNKNOWN}}function E(c,u){switch(c){case R.Platform.Windows:return u==="x64"?_.TargetPlatform.WIN32_X64:u==="arm64"?_.TargetPlatform.WIN32_ARM64:_.TargetPlatform.UNKNOWN;case R.Platform.Linux:return u==="x64"?_.TargetPlatform.LINUX_X64:u==="arm64"?_.TargetPlatform.LINUX_ARM64:u==="arm"?_.TargetPlatform.LINUX_ARMHF:u==="ppc64le"?_.TargetPlatform.LINUX_PPC64LE:u==="riscv64"?_.TargetPlatform.LINUX_RISCV64:_.TargetPlatform.UNKNOWN;case"alpine":return u==="x64"?_.TargetPlatform.ALPINE_X64:u==="arm64"?_.TargetPlatform.ALPINE_ARM64:_.TargetPlatform.UNKNOWN;case R.Platform.Mac:return u==="x64"?_.TargetPlatform.DARWIN_X64:u==="arm64"?_.TargetPlatform.DARWIN_ARM64:_.TargetPlatform.UNKNOWN;case R.Platform.Web:return _.TargetPlatform.WEB}}function P(c,u){return u===_.TargetPlatform.WEB&&!c.includes(_.TargetPlatform.WEB)}function S(c,u,i){return P(u,i)?!1:c===_.TargetPlatform.UNDEFINED||c===_.TargetPlatform.UNIVERSAL?!0:c===_.TargetPlatform.UNKNOWN?!1:c===i}function m(c){return c&&typeof c=="object"&&typeof c.id=="string"&&(!c.uuid||typeof c.uuid=="string")}var d;(function(c){c[c.NoneOrRelevance=0]="NoneOrRelevance",c[c.LastUpdatedDate=1]="LastUpdatedDate",c[c.Title=2]="Title",c[c.PublisherName=3]="PublisherName",c[c.InstallCount=4]="InstallCount",c[c.PublishedDate=10]="PublishedDate",c[c.AverageRating=6]="AverageRating",c[c.WeightedRating=12]="WeightedRating"})(d||(e.SortBy=d={}));var l;(function(c){c[c.Default=0]="Default",c[c.Ascending=1]="Ascending",c[c.Descending=2]="Descending"})(l||(e.SortOrder=l={}));var g;(function(c){c.Install="install",c.Uninstall="uninstall"})(g||(e.StatisticType=g={}));var I;(function(c){c[c.None=1]="None",c[c.Install=2]="Install",c[c.Update=3]="Update",c[c.Migrate=4]="Migrate"})(I||(e.InstallOperation=I={})),e.IExtensionGalleryService=(0,T.createDecorator)("extensionGalleryService");var v;(function(c){c.Timeout="Timeout",c.Cancelled="Cancelled",c.Failed="Failed",c.DownloadFailedWriting="DownloadFailedWriting",c.Offline="Offline"})(v||(e.ExtensionGalleryErrorCode=v={}));class f extends Error{constructor(u,i){super(u),this.code=i,this.name=i}}e.ExtensionGalleryError=f;var C;(function(c){c.Unsupported="Unsupported",c.Deprecated="Deprecated",c.Malicious="Malicious",c.Incompatible="Incompatible",c.IncompatibleApi="IncompatibleApi",c.IncompatibleTargetPlatform="IncompatibleTargetPlatform",c.ReleaseVersionNotFound="ReleaseVersionNotFound",c.Invalid="Invalid",c.Download="Download",c.DownloadSignature="DownloadSignature",c.DownloadFailedWriting="DownloadFailedWriting",c.UpdateMetadata="UpdateMetadata",c.Extract="Extract",c.Scanning="Scanning",c.ScanningExtension="ScanningExtension",c.ReadUninstalled="ReadUninstalled",c.UnsetUninstalled="UnsetUninstalled",c.Delete="Delete",c.Rename="Rename",c.IntializeDefaultProfile="IntializeDefaultProfile",c.AddToProfile="AddToProfile",c.InstalledExtensionNotFound="InstalledExtensionNotFound",c.PostInstall="PostInstall",c.CorruptZip="CorruptZip",c.IncompleteZip="IncompleteZip",c.Signature="Signature",c.NotAllowed="NotAllowed",c.Gallery="Gallery",c.Cancelled="Cancelled",c.Unknown="Unknown",c.Internal="Internal"})(C||(e.ExtensionManagementErrorCode=C={}));class p extends Error{constructor(u,i){super(u),this.code=i,this.name=i}}e.ExtensionManagementError=p,e.IExtensionManagementService=(0,T.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,T.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,T.createDecorator)("IExtensionTipsService"),e.ExtensionsLocalizedLabel=(0,a.localize2)(1780,"Extensions"),e.PreferencesLocalizedLabel=(0,a.localize2)(1781,"Preferences")}),define(he[189],fe([0,1,3,2,29,10,96,27]),function(ce,e,R,a,_,T,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsChannel=e.ExtensionManagementChannelClient=e.ExtensionManagementChannel=void 0;function D(I,v){return I?T.URI.revive(v?v.transformIncoming(I):I):void 0}function E(I,v){return v?v.transformOutgoingURI(I):I}function P(I,v){v=v||k.DefaultURITransformer;const f=I.manifest;return{...(0,k.transformAndReviveIncomingURIs)({...I,manifest:void 0},v),manifest:f}}function S(I,v){return I?.profileLocation?(0,k.transformAndReviveIncomingURIs)(I,v??k.DefaultURITransformer):I}function m(I,v){return v?(0,_.cloneAndChange)(I,f=>f instanceof T.URI?v.transformOutgoingURI(f):void 0):I}class d{constructor(v,f){this.service=v,this.getUriTransformer=f,this.onInstallExtension=R.Event.buffer(v.onInstallExtension,!0),this.onDidInstallExtensions=R.Event.buffer(v.onDidInstallExtensions,!0),this.onUninstallExtension=R.Event.buffer(v.onUninstallExtension,!0),this.onDidUninstallExtension=R.Event.buffer(v.onDidUninstallExtension,!0),this.onDidUpdateExtensionMetadata=R.Event.buffer(v.onDidUpdateExtensionMetadata,!0)}listen(v,f){const C=this.getUriTransformer(v);switch(f){case"onInstallExtension":return R.Event.map(this.onInstallExtension,p=>({...p,profileLocation:p.profileLocation?E(p.profileLocation,C):p.profileLocation}));case"onDidInstallExtensions":return R.Event.map(this.onDidInstallExtensions,p=>p.map(c=>({...c,local:c.local?m(c.local,C):c.local,profileLocation:c.profileLocation?E(c.profileLocation,C):c.profileLocation})));case"onUninstallExtension":return R.Event.map(this.onUninstallExtension,p=>({...p,profileLocation:p.profileLocation?E(p.profileLocation,C):p.profileLocation}));case"onDidUninstallExtension":return R.Event.map(this.onDidUninstallExtension,p=>({...p,profileLocation:p.profileLocation?E(p.profileLocation,C):p.profileLocation}));case"onDidUpdateExtensionMetadata":return R.Event.map(this.onDidUpdateExtensionMetadata,p=>({local:m(p.local,C),profileLocation:E(p.profileLocation,C)}))}throw new Error("Invalid listen")}async call(v,f,C){const p=this.getUriTransformer(v);switch(f){case"zip":{const c=P(C[0],p),u=await this.service.zip(c);return E(u,p)}case"install":return this.service.install(D(C[0],p),S(C[1],p));case"installFromLocation":return this.service.installFromLocation(D(C[0],p),D(C[1],p));case"installExtensionsFromProfile":return this.service.installExtensionsFromProfile(C[0],D(C[1],p),D(C[2],p));case"getManifest":return this.service.getManifest(D(C[0],p));case"getTargetPlatform":return this.service.getTargetPlatform();case"canInstall":return this.service.canInstall(C[0]);case"installFromGallery":return this.service.installFromGallery(C[0],S(C[1],p));case"installGalleryExtensions":{const c=C[0];return this.service.installGalleryExtensions(c.map(({extension:u,options:i})=>({extension:u,options:S(i,p)??{}})))}case"uninstall":return this.service.uninstall(P(C[0],p),S(C[1],p));case"uninstallExtensions":{const c=C[0];return this.service.uninstallExtensions(c.map(({extension:u,options:i})=>({extension:P(u,p),options:S(i,p)})))}case"reinstallFromGallery":return this.service.reinstallFromGallery(P(C[0],p));case"getInstalled":return(await this.service.getInstalled(C[0],D(C[1],p),C[2])).map(u=>m(u,p));case"toggleAppliationScope":{const c=await this.service.toggleAppliationScope(P(C[0],p),D(C[1],p));return m(c,p)}case"copyExtensions":return this.service.copyExtensions(D(C[0],p),D(C[1],p));case"updateMetadata":{const c=await this.service.updateMetadata(P(C[0],p),C[1],D(C[2],p));return m(c,p)}case"resetPinnedStateForAllUserExtensions":return this.service.resetPinnedStateForAllUserExtensions(C[0]);case"getExtensionsControlManifest":return this.service.getExtensionsControlManifest();case"download":return this.service.download(C[0],C[1],C[2]);case"cleanUp":return this.service.cleanUp()}throw new Error("Invalid call")}}e.ExtensionManagementChannel=d;class l extends a.Disposable{get onInstallExtension(){return this._onInstallExtension.event}get onDidInstallExtensions(){return this._onDidInstallExtensions.event}get onUninstallExtension(){return this._onUninstallExtension.event}get onDidUninstallExtension(){return this._onDidUninstallExtension.event}get onDidUpdateExtensionMetadata(){return this._onDidUpdateExtensionMetadata.event}constructor(v){super(),this.channel=v,this._onInstallExtension=this._register(new R.Emitter),this._onDidInstallExtensions=this._register(new R.Emitter),this._onUninstallExtension=this._register(new R.Emitter),this._onDidUninstallExtension=this._register(new R.Emitter),this._onDidUpdateExtensionMetadata=this._register(new R.Emitter),this._register(this.channel.listen("onInstallExtension")(f=>this.fireEvent(this._onInstallExtension,{...f,source:this.isUriComponents(f.source)?T.URI.revive(f.source):f.source,profileLocation:T.URI.revive(f.profileLocation)}))),this._register(this.channel.listen("onDidInstallExtensions")(f=>this.fireEvent(this._onDidInstallExtensions,f.map(C=>({...C,local:C.local?P(C.local,null):C.local,source:this.isUriComponents(C.source)?T.URI.revive(C.source):C.source,profileLocation:T.URI.revive(C.profileLocation)}))))),this._register(this.channel.listen("onUninstallExtension")(f=>this.fireEvent(this._onUninstallExtension,{...f,profileLocation:T.URI.revive(f.profileLocation)}))),this._register(this.channel.listen("onDidUninstallExtension")(f=>this.fireEvent(this._onDidUninstallExtension,{...f,profileLocation:T.URI.revive(f.profileLocation)}))),this._register(this.channel.listen("onDidUpdateExtensionMetadata")(f=>this.fireEvent(this._onDidUpdateExtensionMetadata,{profileLocation:T.URI.revive(f.profileLocation),local:P(f.local,null)})))}fireEvent(v,f){v.fire(f)}isUriComponents(v){return v?typeof v.path=="string"&&typeof v.scheme=="string":!1}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=this.channel.call("getTargetPlatform")),this._targetPlatformPromise}async canInstall(v){const f=await this.getTargetPlatform();return v.allTargetPlatforms.some(C=>(0,L.isTargetPlatformCompatible)(C,v.allTargetPlatforms,f))}zip(v){return Promise.resolve(this.channel.call("zip",[v]).then(f=>T.URI.revive(f)))}install(v,f){return Promise.resolve(this.channel.call("install",[v,f])).then(C=>P(C,null))}installFromLocation(v,f){return Promise.resolve(this.channel.call("installFromLocation",[v,f])).then(C=>P(C,null))}async installExtensionsFromProfile(v,f,C){return(await this.channel.call("installExtensionsFromProfile",[v,f,C])).map(c=>P(c,null))}getManifest(v){return Promise.resolve(this.channel.call("getManifest",[v]))}installFromGallery(v,f){return Promise.resolve(this.channel.call("installFromGallery",[v,f])).then(C=>P(C,null))}async installGalleryExtensions(v){return(await this.channel.call("installGalleryExtensions",[v])).map(C=>({...C,local:C.local?P(C.local,null):C.local,source:this.isUriComponents(C.source)?T.URI.revive(C.source):C.source,profileLocation:T.URI.revive(C.profileLocation)}))}uninstall(v,f){if(v.isWorkspaceScoped)throw new Error("Cannot uninstall a workspace extension");return Promise.resolve(this.channel.call("uninstall",[v,f]))}uninstallExtensions(v){if(v.some(f=>f.extension.isWorkspaceScoped))throw new Error("Cannot uninstall a workspace extension");return Promise.resolve(this.channel.call("uninstallExtensions",[v]))}reinstallFromGallery(v){return Promise.resolve(this.channel.call("reinstallFromGallery",[v])).then(f=>P(f,null))}getInstalled(v=null,f,C){return Promise.resolve(this.channel.call("getInstalled",[v,f,C])).then(p=>p.map(c=>P(c,null)))}updateMetadata(v,f,C){return Promise.resolve(this.channel.call("updateMetadata",[v,f,C])).then(p=>P(p,null))}resetPinnedStateForAllUserExtensions(v){return this.channel.call("resetPinnedStateForAllUserExtensions",[v])}toggleAppliationScope(v,f){return this.channel.call("toggleAppliationScope",[v,f]).then(C=>P(C,null))}copyExtensions(v,f){return this.channel.call("copyExtensions",[v,f])}getExtensionsControlManifest(){return Promise.resolve(this.channel.call("getExtensionsControlManifest"))}async download(v,f,C){const p=await this.channel.call("download",[v,f,C]);return T.URI.revive(p)}async cleanUp(){return this.channel.call("cleanUp")}registerParticipant(){throw new Error("Not Supported")}}e.ExtensionManagementChannelClient=l;class g{constructor(v){this.service=v}listen(v,f){throw new Error("Invalid listen")}call(v,f,C){switch(f){case"getConfigBasedTips":return this.service.getConfigBasedTips(T.URI.revive(C[0]));case"getImportantExecutableBasedTips":return this.service.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.service.getOtherExecutableBasedTips()}throw new Error("Invalid call")}}e.ExtensionTipsChannel=g}),define(he[190],fe([0,1,2,34,7]),function(ce,e,R,a,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class T extends R.Disposable{constructor(L,D,E,P,S){super(),this.userDataProfilesService=L,this.fileService=D,this.uriIdentityService=E,this.logService=S,this._register(P.onDidInstallExtensions(m=>this.onDidInstallExtensions(m))),this._register(P.onDidUninstallExtension(m=>this.onDidUnInstallExtension(m)))}onDidInstallExtensions(L){for(const D of L)D.local&&this.invalidate(D.profileLocation)}onDidUnInstallExtension(L){L.error||this.invalidate(L.profileLocation)}async invalidate(L){if(L)for(const D of this.userDataProfilesService.profiles)this.uriIdentityService.extUri.isEqual(D.extensionsResource,L)&&await this.deleteUserCacheFile(D);else await this.deleteUserCacheFile(this.userDataProfilesService.defaultProfile)}async deleteUserCacheFile(L){try{await this.fileService.del(this.uriIdentityService.extUri.joinPath(L.cacheHome,a.USER_MANIFEST_CACHE_FILE))}catch(D){(0,_.toFileOperationResult)(D)!==_.FileOperationResult.FILE_NOT_FOUND&&this.logService.error(D)}}}e.ExtensionsManifestCache=T});var it=this&&this.__importDefault||function(ce){return ce&&ce.__esModule?ce:{default:ce}};define(he[59],fe([0,1,20,92,9,60,34,161]),function(ce,e,R,a,_,T,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isValidVersionStr=P,e.parseVersion=S,e.normalizeVersion=m,e.isValidVersion=d,e.validateExtensionManifest=l,e.isValidExtensionVersion=g,e.isEngineValid=I,e.areApiProposalsCompatible=v,a=it(a),_=De(_),T=De(T);const D=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,E=/^-(\d{4})(\d{2})(\d{2})$/;function P(p){return p=p.trim(),p==="*"||D.test(p)}function S(p){if(!P(p))return null;if(p=p.trim(),p==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const c=p.match(D);return c?{hasCaret:c[1]==="^",hasGreaterEquals:c[1]===">=",majorBase:c[2]==="x"?0:parseInt(c[2],10),majorMustEqual:c[2]!=="x",minorBase:c[4]==="x"?0:parseInt(c[4],10),minorMustEqual:c[4]!=="x",patchBase:c[6]==="x"?0:parseInt(c[6],10),patchMustEqual:c[6]!=="x",preRelease:c[8]||null}:null}function m(p){if(!p)return null;const c=p.majorBase,u=p.majorMustEqual,i=p.minorBase;let n=p.minorMustEqual;const t=p.patchBase;let s=p.patchMustEqual;p.hasCaret&&(c===0||(n=!1),s=!1);let r=0;if(p.preRelease){const o=E.exec(p.preRelease);if(o){const[,h,y,A]=o;r=Date.UTC(Number(h),Number(y)-1,Number(A))}}return{majorBase:c,majorMustEqual:u,minorBase:i,minorMustEqual:n,patchBase:t,patchMustEqual:s,isMinimum:p.hasGreaterEquals,notBefore:r}}function d(p,c,u){let i;typeof p=="string"?i=m(S(p)):i=p;let n;c instanceof Date?n=c.getTime():typeof c=="string"&&(n=new Date(c).getTime());let t;if(typeof u=="string"?t=m(S(u)):t=u,!i||!t)return!1;const s=i.majorBase,r=i.minorBase,o=i.patchBase;let h=t.majorBase,y=t.minorBase,A=t.patchBase;const b=t.notBefore;let w=t.majorMustEqual,O=t.minorMustEqual,F=t.patchMustEqual;return t.isMinimum?s>h?!0:s<h?!1:r>y?!0:r<y||n&&n<b?!1:o>=A:(s===1&&h===0&&(!w||!O||!F)&&(h=1,y=0,A=0,w=!0,O=!1,F=!1),s<h?!1:s>h?!w:r<y?!1:r>y?!O:o<A?!1:o>A?!F:!(n&&n<b))}function l(p,c,u,i,n,t){const s=[];if(typeof i.publisher<"u"&&typeof i.publisher!="string")return s.push([a.default.Error,_.localize(1832,null)]),s;if(typeof i.name!="string")return s.push([a.default.Error,_.localize(1833,null,"name")]),s;if(typeof i.version!="string")return s.push([a.default.Error,_.localize(1834,null,"version")]),s;if(!i.engines)return s.push([a.default.Error,_.localize(1835,null,"engines")]),s;if(typeof i.engines.vscode!="string")return s.push([a.default.Error,_.localize(1836,null,"engines.vscode")]),s;if(typeof i.extensionDependencies<"u"&&!C(i.extensionDependencies))return s.push([a.default.Error,_.localize(1837,null,"extensionDependencies")]),s;if(typeof i.activationEvents<"u"){if(!C(i.activationEvents))return s.push([a.default.Error,_.localize(1838,null,"activationEvents")]),s;if(typeof i.main>"u"&&typeof i.browser>"u")return s.push([a.default.Error,_.localize(1839,null,"activationEvents","main","browser")]),s}if(typeof i.extensionKind<"u"&&typeof i.main>"u"&&s.push([a.default.Warning,_.localize(1840,null,"extensionKind")]),typeof i.main<"u"){if(typeof i.main!="string")return s.push([a.default.Error,_.localize(1841,null,"main")]),s;{const h=(0,R.joinPath)(u,i.main);(0,R.isEqualOrParent)(h,u)||s.push([a.default.Warning,_.localize(1842,null,h.path,u.path)])}}if(typeof i.browser<"u"){if(typeof i.browser!="string")return s.push([a.default.Error,_.localize(1843,null,"browser")]),s;{const h=(0,R.joinPath)(u,i.browser);(0,R.isEqualOrParent)(h,u)||s.push([a.default.Warning,_.localize(1844,null,h.path,u.path)])}}if(!T.valid(i.version))return s.push([a.default.Error,_.localize(1845,null)]),s;const r=[];if(!g(p,c,i,n,r))for(const h of r)s.push([a.default.Error,h]);if(t&&i.enabledApiProposals?.length){const h=[];if(!v([...i.enabledApiProposals],h))for(const y of h)s.push([a.default.Error,y])}return s}function g(p,c,u,i,n){return i||typeof u.main>"u"&&typeof u.browser>"u"?!0:f(p,c,u.engines.vscode,n)}function I(p,c,u){return p==="*"||f(c,u,p)}function v(p,c){if(p.length===0)return!0;const u=Array.isArray(c)?c:void 0,i=(u?void 0:c)??L.allApiProposals,n=[],t=(0,k.parseApiProposals)(p);for(const{proposalName:s,version:r}of t){const o=i[s];o&&r&&o.version!==r&&n.push(_.localize(1846,null,s))}return u?.push(...n),n.length===0}function f(p,c,u,i=[]){const n=m(S(u));if(!n)return i.push(_.localize(1847,null,u)),!1;if(n.majorBase===0){if(!n.majorMustEqual||!n.minorMustEqual)return i.push(_.localize(1848,null,u)),!1}else if(!n.majorMustEqual)return i.push(_.localize(1849,null,u)),!1;return d(p,c,n)?!0:(i.push(_.localize(1850,null,p,u)),!1)}function C(p){if(!Array.isArray(p))return!1;for(let c=0,u=p.length;c<u;c++)if(typeof p[c]!="string")return!1;return!0}}),define(he[79],fe([0,1,25,2,5,9,27,4]),function(ce,e,R,a,_,T,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackBaseService=e.ILanguagePackService=void 0,e.getLocale=D;function D(P){return P.tags.find(S=>S.startsWith("lp-"))?.split("lp-")[1]}e.ILanguagePackService=(0,L.createDecorator)("languagePackService");let E=class extends a.Disposable{constructor(S){super(),this.extensionGalleryService=S}async getAvailableLanguages(){const S=new R.CancellationTokenSource;setTimeout(()=>S.cancel(),1e3);let m;try{m=await this.extensionGalleryService.query({text:'category:"language packs"',pageSize:20},S.token)}catch{return[]}const l=m.firstPage.filter(g=>g.properties.localizedLanguages?.length&&g.tags.some(I=>I.startsWith("lp-"))).map(g=>{const I=g.properties.localizedLanguages?.[0],v=D(g);return{...this.createQuickPickItem(v,I,g),extensionId:g.identifier.id,galleryExtension:g}});return l.push(this.createQuickPickItem("en","English")),l}createQuickPickItem(S,m,d){const l=m??S;let g;if(l!==S&&(g=`(${S})`),S.toLowerCase()===_.language.toLowerCase()&&(g??="",g+=(0,T.localize)(1928,null)),d?.installCount){g??="";const I=d.installCount;let v;I>1e6?v=`${Math.floor(I/1e5)/10}M`:I>1e3?v=`${Math.floor(I/1e3)}K`:v=String(I),g+=` $(cloud-download) ${v}`}return{id:S,label:l,description:g}}};e.LanguagePackBaseService=E,e.LanguagePackBaseService=E=Ie([Y(0,k.IExtensionGalleryService)],E)}),define(he[191],fe([0,1,2,79]),function(ce,e,R,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsUpdater=void 0;let _=class extends R.Disposable{constructor(k){super(),this.localizationsService=k,this.updateLocalizations()}updateLocalizations(){this.localizationsService.update()}};e.LocalizationsUpdater=_,e.LocalizationsUpdater=_=Ie([Y(0,a.ILanguagePackService)],_)}),define(he[108],fe([0,1,2,4]),function(ce,e,R,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteSocketFactoryService=e.IRemoteSocketFactoryService=void 0,e.IRemoteSocketFactoryService=(0,a.createDecorator)("remoteSocketFactoryService");class _{constructor(){this.factories={}}register(k,L){return this.factories[k]??=[],this.factories[k].push(L),(0,R.toDisposable)(()=>{const D=this.factories[k]?.indexOf(L);typeof D=="number"&&D>=0&&this.factories[k]?.splice(D,1)})}getSocketFactory(k){return(this.factories[k.type]||[]).find(D=>D.supports(k))}connect(k,L,D,E){const P=this.getSocketFactory(k);if(!P)throw new Error(`No socket factory found for ${k}`);return P.connect(k,L,D,E)}}e.RemoteSocketFactoryService=_}),define(he[192],fe([0,1,4]),function(ce,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcSharedProcessTunnelChannelName=e.ISharedProcessTunnelService=void 0,e.ISharedProcessTunnelService=(0,R.createDecorator)("sharedProcessTunnelService"),e.ipcSharedProcessTunnelChannelName="sharedProcessTunnel"}),define(he[109],fe([0,1,4,9]),function(ce,e,R,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LOGGER_NAME=e.LOG_ID=e.CONFIGURATION_KEY_PREVENT_SLEEP=e.CONFIGURATION_KEY_HOST_NAME=e.CONFIGURATION_KEY_PREFIX=e.TunnelStates=e.INACTIVE_TUNNEL_MODE=e.IRemoteTunnelService=void 0,e.IRemoteTunnelService=(0,R.createDecorator)("IRemoteTunnelService"),e.INACTIVE_TUNNEL_MODE={active:!1};var _;(function(T){T.disconnected=k=>({type:"disconnected",onTokenFailed:k}),T.connected=(k,L)=>({type:"connected",info:k,serviceInstallFailed:L}),T.connecting=k=>({type:"connecting",progress:k}),T.uninitialized={type:"uninitialized"}})(_||(e.TunnelStates=_={})),e.CONFIGURATION_KEY_PREFIX="remote.tunnels.access",e.CONFIGURATION_KEY_HOST_NAME=e.CONFIGURATION_KEY_PREFIX+".hostNameOverride",e.CONFIGURATION_KEY_PREVENT_SLEEP=e.CONFIGURATION_KEY_PREFIX+".preventSleep",e.LOG_ID="remoteTunnelService",e.LOGGER_NAME=(0,a.localize)(2044,null)}),define(he[61],fe([0,1,14,8,2,9,47,4,11,44]),function(ce,e,R,a,_,T,k,L,D,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractRequestService=e.IRequestService=void 0,e.isSuccess=m,e.hasNoContent=d,e.asText=l,e.asTextOrError=g,e.asJson=I,e.updateProxyConfigurationsScope=v,e.IRequestService=(0,L.createDecorator)("requestService");class P{constructor(c){this.original=c}toJSON(){if(!this.headers){const c=Object.create(null);for(const u in this.original)u.toLowerCase()==="authorization"||u.toLowerCase()==="proxy-authorization"?c[u]="*****":c[u]=this.original[u];this.headers=c}return this.headers}}class S extends _.Disposable{constructor(c){super(),this.counter=0,this.logger=c.createLogger("network",{name:(0,T.localize)(2050,null),when:D.CONTEXT_LOG_LEVEL.isEqualTo((0,D.LogLevelToString)(D.LogLevel.Trace)).serialize()})}async logAndRequest(c,u,i){const n=`${c} #${++this.counter}: ${u.url}`;this.logger.trace(`${n} - begin`,u.type,new P(u.headers??{}));try{const t=await i();return this.logger.trace(`${n} - end`,u.type,t.res.statusCode,t.res.headers),t}catch(t){throw this.logger.error(`${n} - error`,u.type,(0,a.getErrorMessage)(t)),t}}}e.AbstractRequestService=S;function m(p){return p.res.statusCode&&p.res.statusCode>=200&&p.res.statusCode<300||p.res.statusCode===1223}function d(p){return p.res.statusCode===204}async function l(p){return d(p)?null:(await(0,R.streamToBuffer)(p.stream)).toString()}async function g(p){if(!m(p))throw new Error("Server returned "+p.res.statusCode);return l(p)}async function I(p){if(!m(p))throw new Error("Server returned "+p.res.statusCode);if(d(p))return null;const u=(await(0,R.streamToBuffer)(p.stream)).toString();try{return JSON.parse(u)}catch(i){throw i.message+=`:
`+u,i}}function v(p){C(p)}let f;function C(p){const c=E.Registry.as(k.Extensions.Configuration),u=f;f={id:"http",order:15,title:(0,T.localize)(2051,null),type:"object",scope:p,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,T.localize)(2052,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,T.localize)(2053,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,T.localize)(2054,null),restricted:!0},"http.noProxy":{type:"array",items:{type:"string"},markdownDescription:(0,T.localize)(2055,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,T.localize)(2056,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,T.localize)(2057,null),(0,T.localize)(2058,null),(0,T.localize)(2059,null),(0,T.localize)(2060,null)],default:"override",description:(0,T.localize)(2061,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,T.localize)(2062,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,T.localize)(2063,null),restricted:!0}}},c.updateConfigurations({add:[f],remove:u?[u]:[]})}C(k.ConfigurationScope.APPLICATION)}),define(he[193],fe([0,1,25,22,7,61]),function(ce,e,R,a,_,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadService=void 0;let k=class{constructor(D,E){this.requestService=D,this.fileService=E}async download(D,E,P=R.CancellationToken.None){if(D.scheme===a.Schemas.file||D.scheme===a.Schemas.vscodeRemote){await this.fileService.copy(D,E);return}const S={type:"GET",url:D.toString(!0)},m=await this.requestService.request(S,P);if(m.res.statusCode===200)await this.fileService.writeFile(E,m.stream);else{const d=await(0,T.asTextOrError)(m);throw new Error(`Expected 200, got back ${m.res.statusCode} instead.

${d}`)}}};e.DownloadService=k,e.DownloadService=k=Ie([Y(0,T.IRequestService),Y(1,_.IFileService)],k)}),define(he[194],fe([0,1,14,25]),function(ce,e,R,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestChannelClient=e.RequestChannel=void 0;class _{constructor(L){this.service=L}listen(L,D){throw new Error("Invalid listen")}call(L,D,E,P=a.CancellationToken.None){switch(D){case"request":return this.service.request(E[0],P).then(async({res:S,stream:m})=>{const d=await(0,R.streamToBuffer)(m);return[{statusCode:S.statusCode,headers:S.headers},d]});case"resolveProxy":return this.service.resolveProxy(E[0]);case"lookupAuthorization":return this.service.lookupAuthorization(E[0]);case"lookupKerberosAuthorization":return this.service.lookupKerberosAuthorization(E[0]);case"loadCertificates":return this.service.loadCertificates()}throw new Error("Invalid call")}}e.RequestChannel=_;class T{constructor(L){this.channel=L}async request(L,D){const[E,P]=await this.channel.call("request",[L],D);return{res:E,stream:(0,R.bufferToStream)(P)}}async resolveProxy(L){return this.channel.call("resolveProxy",[L])}async lookupAuthorization(L){return this.channel.call("lookupAuthorization",[L])}async lookupKerberosAuthorization(L){return this.channel.call("lookupKerberosAuthorization",[L])}async loadCertificates(){return this.channel.call("loadCertificates")}}e.RequestChannelClient=T}),define(he[195],fe([0,1]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessRawConnection=e.SharedProcessChannelConnection=e.SharedProcessLifecycle=void 0,e.SharedProcessLifecycle={exit:"vscode:electron-main->shared-process=exit",ipcReady:"vscode:shared-process->electron-main=ipc-ready",initDone:"vscode:shared-process->electron-main=init-done"},e.SharedProcessChannelConnection={request:"vscode:createSharedProcessChannelConnection",response:"vscode:createSharedProcessChannelConnectionResult"},e.SharedProcessRawConnection={request:"vscode:createSharedProcessRawConnection",response:"vscode:createSharedProcessRawConnectionResult"}}),define(he[196],fe([0,1]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractSignService=void 0;class R{constructor(){this.validators=new Map}static{this._nextId=1}async createNewMessage(_){try{const T=await this.getValidator();if(T){const k=String(R._nextId++);return this.validators.set(k,T),{id:k,data:T.createNewMessage(_)}}}catch{}return{id:"",data:_}}async validate(_,T){if(!_.id)return!0;const k=this.validators.get(_.id);if(!k)return!1;this.validators.delete(_.id);try{return k.validate(T)==="ok"}catch{return!1}finally{k.dispose?.()}}async sign(_){try{return await this.signValue(_)}catch{}return _}}e.AbstractSignService=R}),define(he[110],fe([0,1,4]),function(ce,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,R.createDecorator)(e.SIGN_SERVICE_ID)}),define(he[197],fe([0,1,69,196]),function(ce,e,R,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class _ extends a.AbstractSignService{getValidator(){return this.vsda().then(k=>new k.validator)}signValue(k){return this.vsda().then(L=>new L.signer().sign(k))}async vsda(){return(0,R.importAMDNodeModule)("vsda","index.js")}}e.SignService=_}),define(he[80],fe([0,1,3,2]),function(ce,e,R,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageClient=e.WorkspaceStorageDatabaseClient=e.ProfileStorageDatabaseClient=e.ApplicationStorageDatabaseClient=void 0;class _ extends a.Disposable{constructor(S,m,d){super(),this.channel=S,this.profile=m,this.workspace=d}async getItems(){const S={profile:this.profile,workspace:this.workspace},m=await this.channel.call("getItems",S);return new Map(m)}updateItems(S){const m={profile:this.profile,workspace:this.workspace};return S.insert&&(m.insert=Array.from(S.insert.entries())),S.delete&&(m.delete=Array.from(S.delete.values())),this.channel.call("updateItems",m)}optimize(){const S={profile:this.profile,workspace:this.workspace};return this.channel.call("optimize",S)}}class T extends _{constructor(S,m){super(S,m,void 0),this._onDidChangeItemsExternal=this._register(new R.Emitter),this.onDidChangeItemsExternal=this._onDidChangeItemsExternal.event,this.registerListeners()}registerListeners(){this._register(this.channel.listen("onDidChangeStorage",{profile:this.profile})(S=>this.onDidChangeStorage(S)))}onDidChangeStorage(S){(Array.isArray(S.changed)||Array.isArray(S.deleted))&&this._onDidChangeItemsExternal.fire({changed:S.changed?new Map(S.changed):void 0,deleted:S.deleted?new Set(S.deleted):void 0})}}class k extends T{constructor(S){super(S,void 0)}async close(){this.dispose()}}e.ApplicationStorageDatabaseClient=k;class L extends T{constructor(S,m){super(S,m)}async close(){this.dispose()}}e.ProfileStorageDatabaseClient=L;class D extends _{constructor(S,m){super(S,void 0,m),this.onDidChangeItemsExternal=R.Event.None}async close(){this.dispose()}}e.WorkspaceStorageDatabaseClient=D;class E{constructor(S){this.channel=S}isUsed(S){const m={payload:S,profile:void 0,workspace:void 0};return this.channel.call("isUsed",m)}}e.StorageClient=E}),define(he[111],fe([0,1,5,37,32]),function(ce,e,R,a,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveCommonProperties=k,e.verifyMicrosoftInternalDomain=L;function T(D){if(R.platform===R.Platform.Linux&&/^penguin(\.|$)/i.test(D))return"chromebook"}function k(D,E,P,S,m,d,l,g,I,v){const f=Object.create(null);f["common.machineId"]=d,f["common.sqmId"]=l,f["common.devDeviceId"]=g,f.sessionID=(0,_.generateUuid)()+Date.now(),f.commitHash=S,f.version=m,f["common.platformVersion"]=(D||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),f["common.platform"]=(0,R.PlatformToString)(R.platform),f["common.nodePlatform"]=a.platform,f["common.nodeArch"]=P,f["common.product"]=v||"desktop",I&&(f["common.msftInternal"]=I);let C=0;const p=Date.now();Object.defineProperties(f,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-p,enumerable:!0},"common.sequence":{get:()=>C++,enumerable:!0}}),R.isLinuxSnap&&(f["common.snap"]="true");const c=T(E);return c&&(f["common.platformDetail"]=c),f}function L(D){const E=a.env.USERDNSDOMAIN;if(!E)return!1;const P=E.toLowerCase();return D.some(S=>P===S)}}),define(he[18],fe([0,1,4]),function(ce,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_CRASH_REPORTER_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.devDeviceIdKey=e.sqmIdKey=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,R.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,R.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.sqmIdKey="telemetry.sqmId",e.devDeviceIdKey="telemetry.devDeviceId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_CRASH_REPORTER_SETTING_ID="telemetry.enableCrashReporter",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var a;(function(T){T[T.NONE=0]="NONE",T[T.CRASH=1]="CRASH",T[T.ERROR=2]="ERROR",T[T.USAGE=3]="USAGE"})(a||(e.TelemetryLevel=a={}));var _;(function(T){T.OFF="off",T.CRASH="crash",T.ERROR="error",T.ON="all"})(_||(e.TelemetryConfiguration=_={}))}),define(he[198],fe([0,1,33,38,6,36,22,13,5,54,10,148,30,153,99,7,23,18]),function(ce,e,R,a,_,T,k,L,D,E,P,S,m,d,l,g,I,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=void 0,e.collectWorkspaceStats=C,e.getMachineInfo=c,e.collectLaunchConfigs=u,R=De(R),a=De(a);const f=new Map;async function C(n,t){const s=`${n}::${t.join(":")}`,r=f.get(s);if(r)return r;const o=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i},{tag:"cursorrules",filePattern:/^\.cursorrules$/i}],h=new Map,y=new Map,A=2e4;function b(O,F,N,M){const V=F.substring(O.length+1);return _.Promises.withAsyncBody(async z=>{let J;M.readdirCount++;try{J=await m.Promises.readdir(F,{withFileTypes:!0})}catch{z();return}if(M.count>=A){M.count+=J.length,M.maxReached=!0,z();return}let j=J.length;if(j===0){z();return}let te=J;M.count+J.length>A&&(M.maxReached=!0,j=A-M.count,te=J.slice(0,j)),M.count+=J.length;for(const q of te)if(q.isDirectory()){if(N.includes(q.name)||await b(O,(0,L.join)(F,q.name),N,M),--j===0){z();return}}else{const B=q.name.lastIndexOf(".");if(B>=0){const Z=q.name.substring(B+1);Z&&h.set(Z,(h.get(Z)??0)+1)}for(const Z of o)Z.relativePathPattern?.test(V)!==!1&&Z.filePattern.test(q.name)&&y.set(Z.tag,(y.get(Z.tag)??0)+1);if(--j===0){z();return}}})}const w=_.Promises.withAsyncBody(async O=>{const F={count:0,maxReached:!1,readdirCount:0},N=new E.StopWatch(!0);await b(n,n,t,F);const M=await u(n);O({configFiles:p(y),fileTypes:p(h),fileCount:F.count,maxFilesReached:F.maxReached,launchConfigFiles:M,totalScanTime:N.elapsed(),totalReaddirCount:F.readdirCount})});return f.set(s,w),w}function p(n){return Array.from(n.entries(),([t,s])=>({name:t,count:s})).sort((t,s)=>s.count-t.count)}function c(){const n={os:`${a.type()} ${a.arch()} ${a.release()}`,memory:`${(a.totalmem()/g.ByteSize.GB).toFixed(2)}GB (${(a.freemem()/g.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(S.virtualMachineHint.value()*100)}%`},t=a.cpus();return t&&t.length>0&&(n.cpus=`${t[0].model} (${t.length} x ${t[0].speed})`),n}async function u(n){try{const t=new Map,s=(0,L.join)(n,".vscode","launch.json"),r=await R.promises.readFile(s),o=[],h=(0,T.parse)(r.toString(),o);if(o.length)return console.log(`Unable to parse ${s}`),[];if((0,T.getNodeType)(h)==="object"&&h.configurations)for(const y of h.configurations){const A=y.type;A&&(t.has(A)?t.set(A,t.get(A)+1):t.set(A,1))}return p(t)}catch{return[]}}let i=class{constructor(t,s){this.telemetryService=t,this.productService=s}formatMachineInfo(t){const s=[];return s.push(`OS Version:       ${t.os}`),s.push(`CPUs:             ${t.cpus}`),s.push(`Memory (System):  ${t.memory}`),s.push(`VM:               ${t.vmHint}`),s.join(`
`)}formatEnvironment(t){const s=[];s.push(`Version:          ${this.productService.nameShort} ${this.productService.version} ${this.productService.release||"Release unknown"} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),s.push(`OS Version:       ${a.type()} ${a.arch()} ${a.release()}`);const r=a.cpus();return r&&r.length>0&&s.push(`CPUs:             ${r[0].model} (${r.length} x ${r[0].speed})`),s.push(`Memory (System):  ${(a.totalmem()/g.ByteSize.GB).toFixed(2)}GB (${(a.freemem()/g.ByteSize.GB).toFixed(2)}GB free)`),D.isWindows||s.push(`Load (avg):       ${a.loadavg().map(o=>Math.round(o)).join(", ")}`),s.push(`VM:               ${Math.round(S.virtualMachineHint.value()*100)}%`),s.push(`Screen Reader:    ${t.screenReader?"yes":"no"}`),s.push(`Process Argv:     ${t.mainArguments.join(" ")}`),s.push(`GPU Status:       ${this.expandGPUFeatures(t.gpuFeatureStatus)}`),s.join(`
`)}async getPerformanceInfo(t,s){return Promise.all([(0,d.listProcesses)(t.mainPID),this.formatWorkspaceMetadata(t)]).then(async r=>{let[o,h]=r,y=this.formatProcessList(t,o);return s.forEach(A=>{if((0,l.isRemoteDiagnosticError)(A))y+=`
${A.errorMessage}`,h+=`
${A.errorMessage}`;else if(y+=`

Remote: ${A.hostName}`,A.processes&&(y+=`
${this.formatProcessList(t,A.processes)}`),A.workspaceMetadata){h+=`
|  Remote: ${A.hostName}`;for(const b of Object.keys(A.workspaceMetadata)){const w=A.workspaceMetadata[b];let O=`${w.fileCount} files`;w.maxFilesReached&&(O=`more than ${O}`),h+=`|    Folder (${b}): ${O}`,h+=this.formatWorkspaceStats(w)}}}),{processInfo:y,workspaceInfo:h}})}async getSystemInfo(t,s){const{memory:r,vmHint:o,os:h,cpus:y}=c(),A={os:h,memory:r,cpus:y,vmHint:o,processArgs:`${t.mainArguments.join(" ")}`,gpuStatus:t.gpuFeatureStatus,screenReader:`${t.screenReader?"yes":"no"}`,remoteData:s};return D.isWindows||(A.load=`${a.loadavg().map(b=>Math.round(b)).join(", ")}`),D.isLinux&&(A.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(A)}async getDiagnostics(t,s){const r=[];return(0,d.listProcesses)(t.mainPID).then(async o=>(r.push(""),r.push(this.formatEnvironment(t)),r.push(""),r.push(this.formatProcessList(t,o)),t.windows.some(h=>h.folderURIs&&h.folderURIs.length>0&&!h.remoteAuthority)&&(r.push(""),r.push("Workspace Stats: "),r.push(await this.formatWorkspaceMetadata(t))),s.forEach(h=>{if((0,l.isRemoteDiagnosticError)(h))r.push(`
${h.errorMessage}`);else if(r.push(`

`),r.push(`Remote:           ${h.hostName}`),r.push(this.formatMachineInfo(h.machineInfo)),h.processes&&r.push(this.formatProcessList(t,h.processes)),h.workspaceMetadata)for(const y of Object.keys(h.workspaceMetadata)){const A=h.workspaceMetadata[y];let b=`${A.fileCount} files`;A.maxFilesReached&&(b=`more than ${b}`),r.push(`Folder (${y}): ${b}`),r.push(this.formatWorkspaceStats(A))}}),r.push(""),r.push(""),r.join(`
`)))}formatWorkspaceStats(t){const s=[];let o=0;const h=(w,O)=>{const F=` ${w}(${O})`;o+F.length>60?(s.push(y),y="|                 ",o=y.length):o+=F.length,y+=F};let y="|      File types:";const A=10,b=t.fileTypes.length>A?A:t.fileTypes.length;for(let w=0;w<b;w++){const O=t.fileTypes[w];h(O.name,O.count)}if(s.push(y),t.configFiles.length>=0&&(y="|      Conf files:",o=0,t.configFiles.forEach(w=>{h(w.name,w.count)}),s.push(y)),t.launchConfigFiles.length>0){let w="|      Launch Configs:";t.launchConfigFiles.forEach(O=>{const F=O.count>1?` ${O.name}(${O.count})`:` ${O.name}`;w+=F}),s.push(w)}return s.join(`
`)}expandGPUFeatures(t){const s=Math.max(...Object.keys(t).map(r=>r.length));return Object.keys(t).map(r=>`${r}:  ${" ".repeat(s-r.length)}  ${t[r]}`).join(`
                  `)}formatWorkspaceMetadata(t){const s=[],r=[];return t.windows.forEach(o=>{o.folderURIs.length===0||o.remoteAuthority||(s.push(`|  Window (${o.title})`),o.folderURIs.forEach(h=>{const y=P.URI.revive(h);if(y.scheme===k.Schemas.file){const A=y.fsPath;r.push(C(A,["node_modules",".git"]).then(b=>{let w=`${b.fileCount} files`;b.maxFilesReached&&(w=`more than ${w}`),s.push(`|    Folder (${(0,L.basename)(A)}): ${w}`),s.push(this.formatWorkspaceStats(b))}).catch(b=>{s.push(`|      Error: Unable to collect workspace stats for folder ${A} (${b.toString()})`)}))}else s.push(`|    Folder (${y.toString()}): Workspace stats not available.`)}))}),Promise.all(r).then(o=>s.join(`
`)).catch(o=>`Unable to collect workspace stats: ${o}`)}formatProcessList(t,s){const r=new Map;t.windows.forEach(h=>r.set(h.pid,`window [${h.id}] (${h.title})`)),t.pidToNames.forEach(({pid:h,name:y})=>r.set(h,y));const o=[];return o.push("CPU %	Mem MB	   PID	Process"),s&&this.formatProcessItem(t.mainPID,r,o,s,0),o.join(`
`)}formatProcessItem(t,s,r,o,h){const y=h===0;let A;y?A=o.pid===t?`${this.productService.applicationName} main`:"remote agent":s.has(o.pid)?A=s.get(o.pid):A=`${"  ".repeat(h)} ${o.name}`;const b=process.platform==="win32"?o.mem:a.totalmem()*(o.mem/100);r.push(`${o.load.toFixed(0).padStart(5," ")}	${(b/g.ByteSize.MB).toFixed(0).padStart(6," ")}	${o.pid.toFixed(0).padStart(6," ")}	${A}`),Array.isArray(o.children)&&o.children.forEach(w=>this.formatProcessItem(t,s,r,w,h+1))}async getWorkspaceFileExtensions(t){const s=new Set;for(const{uri:r}of t.folders){const o=P.URI.revive(r);if(o.scheme!==k.Schemas.file)continue;const h=o.fsPath;try{(await C(h,["node_modules",".git"])).fileTypes.forEach(A=>s.add(A.name))}catch{}}return{extensions:[...s]}}async reportWorkspaceStats(t){for(const{uri:s}of t.folders){const r=P.URI.revive(s);if(r.scheme!==k.Schemas.file)continue;const o=r.fsPath;try{const h=await C(o,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":t.telemetryId,rendererSessionId:t.rendererSessionId}),h.fileTypes.forEach(y=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:t.rendererSessionId,type:y.name,count:y.count})}),h.launchConfigFiles.forEach(y=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:t.rendererSessionId,type:y.name,count:y.count})}),h.configFiles.forEach(y=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:t.rendererSessionId,type:y.name,count:y.count})}),this.telemetryService.publicLog2("workspace.stats.metadata",{duration:h.totalScanTime,reachedLimit:h.maxFilesReached,fileCount:h.fileCount,readdirCount:h.totalReaddirCount})}catch{}}}};e.DiagnosticsService=i,e.DiagnosticsService=i=Ie([Y(0,v.ITelemetryService),Y(1,I.IProductService)],i)}),define(he[112],fe([0,1,69,8,4,11,18]),function(ce,e,R,a,_,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSignatureVerificationService=e.ExtensionSignatureVerificationError=e.ExtensionSignatureVerificationCode=e.IExtensionSignatureVerificationService=void 0,e.IExtensionSignatureVerificationService=(0,_.createDecorator)("IExtensionSignatureVerificationService");var L;(function(P){P.Success="Success",P.RequiredArgumentMissing="RequiredArgumentMissing",P.InvalidArgument="InvalidArgument",P.PackageIsUnreadable="PackageIsUnreadable",P.UnhandledException="UnhandledException",P.SignatureManifestIsMissing="SignatureManifestIsMissing",P.SignatureManifestIsUnreadable="SignatureManifestIsUnreadable",P.SignatureIsMissing="SignatureIsMissing",P.SignatureIsUnreadable="SignatureIsUnreadable",P.CertificateIsUnreadable="CertificateIsUnreadable",P.SignatureArchiveIsUnreadable="SignatureArchiveIsUnreadable",P.FileAlreadyExists="FileAlreadyExists",P.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip",P.SignatureArchiveHasSameSignatureFile="SignatureArchiveHasSameSignatureFile",P.PackageIntegrityCheckFailed="PackageIntegrityCheckFailed",P.SignatureIsInvalid="SignatureIsInvalid",P.SignatureManifestIsInvalid="SignatureManifestIsInvalid",P.SignatureIntegrityCheckFailed="SignatureIntegrityCheckFailed",P.EntryIsMissing="EntryIsMissing",P.EntryIsTampered="EntryIsTampered",P.Untrusted="Untrusted",P.CertificateRevoked="CertificateRevoked",P.SignatureIsNotValid="SignatureIsNotValid",P.UnknownError="UnknownError",P.PackageIsInvalidZip="PackageIsInvalidZip",P.SignatureArchiveHasTooManyEntries="SignatureArchiveHasTooManyEntries"})(L||(e.ExtensionSignatureVerificationCode=L={}));class D extends Error{constructor(S){super(S),this.code=S}}e.ExtensionSignatureVerificationError=D;let E=class{constructor(S,m){this.logService=S,this.telemetryService=m}vsceSign(){return this.moduleLoadingPromise||(this.moduleLoadingPromise=this.resolveVsceSign()),this.moduleLoadingPromise}async resolveVsceSign(){return(0,R.importAMDNodeModule)("@vscode/vsce-sign","src/main.js")}async verify(S,m,d,l){let g;const I=S.identifier.id;try{g=await this.vsceSign()}catch(p){return this.logService.error("Could not load vsce-sign module",(0,a.getErrorMessage)(p)),this.logService.info(`Extension signature verification is not done: ${I}`),!1}const v=new Date().getTime();let f;try{this.logService.trace(`Verifying extension signature for ${I}...`),f=await g.verify(m,d,this.logService.getLevel()===T.LogLevel.Trace)}catch(p){f={code:L.UnknownError,didExecute:!1,output:(0,a.getErrorMessage)(p)}}const C=new Date().getTime()-v;if(this.logService.info(`Extension signature verification result for ${I}: ${f.code}. Executed: ${f.didExecute}. Duration: ${C}ms.`),this.logService.trace(`Extension signature verification output for ${I}:
${f.output}`),this.telemetryService.publicLog2("extensionsignature:verification",{extensionId:I,extensionVersion:S.version,code:f.code,internalCode:f.internalCode,duration:C,didExecute:f.didExecute,clientTargetPlatform:l}),f.code===L.Success)return!0;throw new D(f.code)}};e.ExtensionSignatureVerificationService=E,e.ExtensionSignatureVerificationService=E=Ie([Y(0,T.ILogService),Y(1,k.ITelemetryService)],E)}),define(he[113],fe([0,1]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class R{constructor(T){this.appenders=T}listen(T,k){throw new Error(`Event not found: ${k}`)}call(T,k,{eventName:L,data:D}){return this.appenders.forEach(E=>E.log(L,D)),Promise.resolve(null)}}e.TelemetryAppenderChannel=R;class a{constructor(T){this.channel=T}log(T,k){return this.channel.call("log",{eventName:T,data:k}).then(void 0,L=>`Failed to log telemetry: ${console.warn(L)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=a}),define(he[48],fe([0,1,29,12,107,111,18]),function(ce,e,R,a,_,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullAppender=e.extensionTelemetryLogChannelId=e.telemetryLogId=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TelemetryTrustedValue=void 0,e.supportsTelemetry=P,e.isLoggingOnly=S,e.getTelemetryLevel=m,e.validateTelemetryData=d,e.cleanRemoteAuthority=g,e.isInternalTelemetry=v,e.getPiiPathsFromEnvironment=f,e.cleanData=c;class L{constructor(i){this.value=i,this.isTrustedTelemetryValue=!0}}e.TelemetryTrustedValue=L;class D{constructor(){this.telemetryLevel=k.TelemetryLevel.NONE,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.devDeviceId="someValue.devDeviceId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.NullTelemetryServiceShape=D,e.NullTelemetryService=new D;class E{async publicLog(i,n,t){}async publicLogError(i,n,t){}}e.NullEndpointTelemetryService=E,e.telemetryLogId="telemetry",e.extensionTelemetryLogChannelId="extensionTelemetryLog",e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function P(u,i){return!i.isBuilt&&!i.disableTelemetry?!0:!(i.disableTelemetry||!u.enableTelemetry)}function S(u,i){return i.extensionTestsLocationURI?!0:!(i.isBuilt||i.disableTelemetry||u.enableTelemetry&&u.aiConfig?.ariaKey)}function m(u){const i=u.getValue(k.TELEMETRY_SETTING_ID),n=u.getValue(k.TELEMETRY_CRASH_REPORTER_SETTING_ID);if(u.getValue(k.TELEMETRY_OLD_SETTING_ID)===!1||n===!1)return k.TelemetryLevel.NONE;switch(i??k.TelemetryConfiguration.ON){case k.TelemetryConfiguration.ON:return k.TelemetryLevel.USAGE;case k.TelemetryConfiguration.ERROR:return k.TelemetryLevel.ERROR;case k.TelemetryConfiguration.CRASH:return k.TelemetryLevel.CRASH;case k.TelemetryConfiguration.OFF:return k.TelemetryLevel.NONE}}function d(u){const i={},n={},t={};I(u,t);for(let s in t){s=s.length>150?s.substr(s.length-149):s;const r=t[s];typeof r=="number"?n[s]=r:typeof r=="boolean"?n[s]=r?1:0:typeof r=="string"?(r.length>8192&&console.warn(`Telemetry property: ${s} has been trimmed to 8192, the original length is ${r.length}`),i[s]=r.substring(0,8191)):typeof r<"u"&&r!==null&&(i[s]=r)}return{properties:i,measurements:n}}const l=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function g(u){if(!u)return"none";const i=(0,_.getRemoteName)(u);return l.has(i)?i:"other"}function I(u,i,n=0,t){if(u)for(const s of Object.getOwnPropertyNames(u)){const r=u[s],o=t?t+s:s;Array.isArray(r)?i[o]=(0,R.safeStringify)(r):r instanceof Date?i[o]=r.toISOString():(0,a.isObject)(r)?n<2?I(r,i,n+1,o+"."):i[o]=(0,R.safeStringify)(r):i[o]=r}}function v(u,i){const n=u.msftInternalDomains||[],t=i.getValue("telemetry.internalTesting");return(0,T.verifyMicrosoftInternalDomain)(n)||t}function f(u){return[u.appRoot,u.extensionsPath,u.userHome.fsPath,u.tmpDir.fsPath,u.userDataPath]}function C(u,i){if(!u||!u.includes("/")&&!u.includes("\\"))return u;let n=u;const t=[];for(const h of i)for(;;){const y=h.exec(u);if(!y)break;t.push([y.index,h.lastIndex])}const s=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,r=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let o=0;for(n="";;){const h=r.exec(u);if(!h)break;const y=t.some(([A,b])=>h.index<b&&A<r.lastIndex);!s.test(h[0])&&!y&&(n+=u.substring(o,h.index)+"<REDACTED: user-file-path>",o=r.lastIndex)}return o<u.length&&(n+=u.substr(o)),n}function p(u){if(!u)return u;const i=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"CLI Credentials",regex:/((login|psexec|(certutil|psexec)\.exe).{1,50}(\s-u(ser(name)?)?\s+.{3,100})?\s-(admin|user|vm|root)?p(ass(word)?)?\s+["']?[^$\-\/\s]|(^|[\s\r\n\\])net(\.exe)?.{1,5}(user\s+|share\s+\/user:| user -? secrets ? set) \s + [^ $\s \/])/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const n of i)if(n.regex.test(u))return`<REDACTED: ${n.label}>`;return u}function c(u,i){return(0,R.cloneAndChange)(u,n=>{if(n instanceof L||Object.hasOwnProperty.call(n,"isTrustedTelemetryValue"))return n.value;if(typeof n=="string"){let t=n.replaceAll("%20"," ");t=C(t,i);for(const s of i)t=t.replace(s,"");return t=p(t),t}})}}),define(he[35],fe([0,1,26,27,34,5,10,8,37,48]),function(ce,e,R,a,_,T,k,L,D,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BetterMergeId=e.ExtensionKey=void 0,e.areSameExtensions=P,e.getIdAndVersion=l,e.getExtensionId=g,e.adoptToGalleryExtensionId=I,e.getGalleryExtensionId=v,e.groupByExtension=f,e.getLocalExtensionTelemetryData=C,e.getGalleryExtensionTelemetryData=p,e.getExtensionDependencies=c,e.computeTargetPlatform=i;function P(n,t){return n.uuid&&t.uuid?n.uuid===t.uuid:n.id===t.id?!0:(0,R.compareIgnoreCase)(n.id,t.id)===0}const S=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class m{static create(t){const s=t.manifest?t.manifest.version:t.version,r=t.manifest?t.targetPlatform:t.properties.targetPlatform;return new m(t.identifier,s,r)}static parse(t){const s=S.exec(t);return s&&s[1]&&s[2]?new m({id:s[1]},s[2],s[4]||void 0):null}constructor(t,s,r=_.TargetPlatform.UNDEFINED){this.identifier=t,this.version=s,this.targetPlatform=r,this.id=t.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!==_.TargetPlatform.UNDEFINED?`-${this.targetPlatform}`:""}`}equals(t){return t instanceof m?P(this,t)&&this.version===t.version&&this.targetPlatform===t.targetPlatform:!1}}e.ExtensionKey=m;const d=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function l(n){const t=d.exec(n);return t&&t[1]?[I(t[1]),t[2]]:[I(n),void 0]}function g(n,t){return`${n}.${t}`}function I(n){return n.toLowerCase()}function v(n,t){return I(g(n??_.UNDEFINED_PUBLISHER,t))}function f(n,t){const s=[],r=o=>{for(const h of s)if(h.some(y=>P(t(y),t(o))))return h;return null};for(const o of n){const h=r(o);h?h.push(o):s.push([o])}return s}function C(n){return{id:n.identifier.id,name:n.manifest.name,galleryId:null,publisherId:n.publisherId,publisherName:n.manifest.publisher,publisherDisplayName:n.publisherDisplayName,dependencies:n.manifest.extensionDependencies&&n.manifest.extensionDependencies.length>0}}function p(n){return{id:new E.TelemetryTrustedValue(n.identifier.id),name:new E.TelemetryTrustedValue(n.name),version:n.version,galleryId:n.identifier.uuid,publisherId:n.publisherId,publisherName:n.publisher,publisherDisplayName:n.publisherDisplayName,isPreReleaseVersion:n.properties.isPreReleaseVersion,dependencies:!!(n.properties.dependencies&&n.properties.dependencies.length>0),isSigned:n.isSigned,...n.telemetryData}}e.BetterMergeId=new _.ExtensionIdentifier("pprice.better-merge");function c(n,t){const s=[],r=t.manifest.extensionDependencies?.slice(0)??[];for(;r.length;){const o=r.shift();if(o&&s.every(h=>!P(h.identifier,{id:o}))){const h=n.filter(y=>P(y.identifier,{id:o}));h.length===1&&(s.push(h[0]),r.push(...h[0].manifest.extensionDependencies?.slice(0)??[]))}}return s}async function u(n,t){if(!T.isLinux)return!1;let s;try{s=(await n.readFile(k.URI.file("/etc/os-release"))).value.toString()}catch{try{s=(await n.readFile(k.URI.file("/usr/lib/os-release"))).value.toString()}catch(o){t.debug("Error while getting the os-release file.",(0,L.getErrorMessage)(o))}}return!!s&&(s.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function i(n,t){const s=await u(n,t),r=(0,a.getTargetPlatform)(s?"alpine":T.platform,D.arch);return t.debug("ComputeTargetPlatform:",r),r}}),define(he[199],fe([0,1,25,27,35,34]),function(ce,e,R,a,_,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.migrateUnsupportedExtensions=k;async function k(L,D,E,P,S){try{const m=await L.getExtensionsControlManifest();if(!m.deprecated)return;const d=await L.getInstalled(T.ExtensionType.User);for(const[l,g]of Object.entries(m.deprecated)){if(!g?.extension)continue;const{id:I,autoMigrate:v,preRelease:f}=g.extension;if(!v)continue;const C=d.find(c=>(0,_.areSameExtensions)(c.identifier,{id:l}));if(!C)continue;const p=(await D.getExtensions([{id:I,preRelease:f}],{targetPlatform:await L.getTargetPlatform(),compatible:!0},R.CancellationToken.None))[0];if(!p){S.info(`Skipping migrating '${C.identifier.id}' extension because, the comaptible target '${I}' extension is not found`);continue}try{S.info(`Migrating '${C.identifier.id}' extension to '${I}' extension...`);const c=!P.getDisabledExtensions().some(i=>(0,_.areSameExtensions)(i,C.identifier));await L.uninstall(C),S.info(`Uninstalled the unsupported extension '${C.identifier.id}'`);let u=d.find(i=>(0,_.areSameExtensions)(i.identifier,{id:I}));(!u||!u.isPreReleaseVersion&&c)&&(u=await L.installFromGallery(p,{installPreReleaseVersion:!0,isMachineScoped:C.isMachineScoped,operation:a.InstallOperation.Migrate}),S.info(`Installed the pre-release extension '${u.identifier.id}'`),c||(await P.disableExtension(u.identifier),S.info(`Disabled the pre-release extension '${u.identifier.id}' because the unsupported extension '${C.identifier.id}' is disabled`)),v.storage&&(E.addToMigrationList((0,_.getExtensionId)(C.manifest.publisher,C.manifest.name),(0,_.getExtensionId)(u.manifest.publisher,u.manifest.name)),S.info("Added pre-release extension to the storage migration list"))),S.info(`Migrated '${C.identifier.id}' extension to '${I}' extension.`)}catch(c){S.error(c)}}}catch(m){S.error(m)}}}),define(he[200],fe([0,1,8,3,2,31,35,34,7]),function(ce,e,R,a,_,T,k,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsWatcher=void 0;class E extends _.Disposable{constructor(S,m,d,l,g,I,v){super(),this.extensionManagementService=S,this.extensionsScannerService=m,this.userDataProfilesService=d,this.extensionsProfileScannerService=l,this.uriIdentityService=g,this.fileService=I,this.logService=v,this._onDidChangeExtensionsByAnotherSource=this._register(new a.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.allExtensions=new Map,this.extensionsProfileWatchDisposables=this._register(new _.DisposableMap),this.initialize().then(null,f=>v.error("Error while initializing Extensions Watcher",(0,R.getErrorMessage)(f)))}async initialize(){await this.extensionsScannerService.initializeDefaultProfileExtensions(),await this.onDidChangeProfiles(this.userDataProfilesService.profiles),this.registerListeners(),await this.uninstallExtensionsNotInProfiles()}registerListeners(){this._register(this.userDataProfilesService.onDidChangeProfiles(S=>this.onDidChangeProfiles(S.added))),this._register(this.extensionsProfileScannerService.onAddExtensions(S=>this.onAddExtensions(S))),this._register(this.extensionsProfileScannerService.onDidAddExtensions(S=>this.onDidAddExtensions(S))),this._register(this.extensionsProfileScannerService.onRemoveExtensions(S=>this.onRemoveExtensions(S))),this._register(this.extensionsProfileScannerService.onDidRemoveExtensions(S=>this.onDidRemoveExtensions(S))),this._register(this.fileService.onDidFilesChange(S=>this.onDidFilesChange(S)))}async onDidChangeProfiles(S){try{S.length&&await Promise.all(S.map(m=>(this.extensionsProfileWatchDisposables.set(m.id,(0,_.combinedDisposable)(this.fileService.watch(this.uriIdentityService.extUri.dirname(m.extensionsResource)),this.fileService.watch(m.extensionsResource))),this.populateExtensionsFromProfile(m.extensionsResource))))}catch(m){throw this.logService.error(m),m}}async onAddExtensions(S){for(const m of S.extensions)this.addExtensionWithKey(this.getKey(m.identifier,m.version),S.profileLocation)}async onDidAddExtensions(S){for(const m of S.extensions){const d=this.getKey(m.identifier,m.version);S.error?this.removeExtensionWithKey(d,S.profileLocation):this.addExtensionWithKey(d,S.profileLocation)}}async onRemoveExtensions(S){for(const m of S.extensions)this.removeExtensionWithKey(this.getKey(m.identifier,m.version),S.profileLocation)}async onDidRemoveExtensions(S){const m=[],d=[];for(const l of S.extensions){const g=this.getKey(l.identifier,l.version);S.error?this.addExtensionWithKey(g,S.profileLocation):(this.removeExtensionWithKey(g,S.profileLocation),this.allExtensions.has(g)||(this.logService.debug("Extension is removed from all profiles",l.identifier.id,l.version),d.push(this.extensionManagementService.scanInstalledExtensionAtLocation(l.location).then(I=>{I?m.push(I):this.logService.info("Extension not found at the location",l.location.toString())},I=>this.logService.error(I)))))}try{await Promise.all(d),m.length&&await this.uninstallExtensionsNotInProfiles(m)}catch(l){this.logService.error(l)}}onDidFilesChange(S){for(const m of this.userDataProfilesService.profiles)S.contains(m.extensionsResource,D.FileChangeType.UPDATED,D.FileChangeType.ADDED)&&this.onDidExtensionsProfileChange(m.extensionsResource)}async onDidExtensionsProfileChange(S){const m=[],d=[],l=await this.extensionsProfileScannerService.scanProfileExtensions(S),g=new Set,I=new Set;for(const[v,f]of this.allExtensions)f.has(S)&&I.add(v);for(const v of l){const f=this.getKey(v.identifier,v.version);g.add(f),I.has(f)||(m.push(v.identifier),this.addExtensionWithKey(f,S))}for(const v of I)if(!g.has(v)){const f=this.fromKey(v);f&&(d.push(f.identifier),this.removeExtensionWithKey(v,S))}(m.length||d.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:m.length?{extensions:m,profileLocation:S}:void 0,removed:d.length?{extensions:d,profileLocation:S}:void 0})}async populateExtensionsFromProfile(S){const m=await this.extensionsProfileScannerService.scanProfileExtensions(S);for(const d of m)this.addExtensionWithKey(this.getKey(d.identifier,d.version),S)}async uninstallExtensionsNotInProfiles(S){S||(S=(await this.extensionManagementService.scanAllUserInstalledExtensions()).filter(d=>!this.allExtensions.has(this.getKey(d.identifier,d.manifest.version)))),S.length&&await this.extensionManagementService.markAsUninstalled(...S)}addExtensionWithKey(S,m){let d=this.allExtensions.get(S);d||this.allExtensions.set(S,d=new T.ResourceSet(l=>this.uriIdentityService.extUri.getComparisonKey(l))),d.add(m)}removeExtensionWithKey(S,m){const d=this.allExtensions.get(S);d&&d.delete(m),d?.size||this.allExtensions.delete(S)}getKey(S,m){return`${L.ExtensionIdentifier.toKey(S.id)}@${m}`}fromKey(S){const[m,d]=(0,k.getIdAndVersion)(S);return d?{identifier:{id:m},version:d}:void 0}}e.ExtensionsWatcher=E}),define(he[201],fe([0,1,33,76,17,6,2,22,13,30,15,27,35,11,79,10]),function(ce,e,R,a,_,T,k,L,D,E,P,S,m,d,l,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLanguagePackService=void 0,R=De(R);let I=class extends l.LanguagePackBaseService{constructor(p,c,u,i){super(u),this.extensionManagementService=p,this.logService=i,this.cache=this._register(new v(c,i)),this.extensionManagementService.registerParticipant({postInstall:async n=>this.postInstallExtension(n),postUninstall:async n=>this.postUninstallExtension(n)})}async getBuiltInExtensionTranslationsUri(p,c){const i=(await this.cache.getLanguagePacks())[c];if(!i){this.logService.warn(`No language pack found for ${c}`);return}const n=i.translations[p];return n?g.URI.file(n):void 0}async getInstalledLanguages(){const p=await this.cache.getLanguagePacks(),c=Object.keys(p).map(u=>{const i=p[u];return{...this.createQuickPickItem(u,i.label),extensionId:i.extensions[0].extensionIdentifier.id}});return c.push(this.createQuickPickItem("en","English")),c.sort((u,i)=>u.label.localeCompare(i.label)),c}async postInstallExtension(p){p&&p.manifest&&p.manifest.contributes&&p.manifest.contributes.localizations&&p.manifest.contributes.localizations.length&&(this.logService.info("Adding language packs from the extension",p.identifier.id),await this.update())}async postUninstallExtension(p){const c=await this.cache.getLanguagePacks();Object.keys(c).some(u=>c[u]&&c[u].extensions.some(i=>(0,m.areSameExtensions)(i.extensionIdentifier,p.identifier)))&&(this.logService.info("Removing language packs from the extension",p.identifier.id),await this.update())}async update(){const[p,c]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),u=await this.cache.update(c);return!(0,_.equals)(Object.keys(p),Object.keys(u))}};e.NativeLanguagePackService=I,e.NativeLanguagePackService=I=Ie([Y(0,S.IExtensionManagementService),Y(1,P.INativeEnvironmentService),Y(2,S.IExtensionGalleryService),Y(3,d.ILogService)],I);let v=class extends k.Disposable{constructor(p,c){super(),this.logService=c,this.languagePacks={},this.languagePacksFilePath=(0,D.join)(p.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new T.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(p){return this.withLanguagePacks(c=>{Object.keys(c).forEach(u=>delete c[u]),this.createLanguagePacksFromExtensions(c,...p)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(p,...c){for(const u of c)u&&u.manifest&&u.manifest.contributes&&u.manifest.contributes.localizations&&u.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(p,u);Object.keys(p).forEach(u=>this.updateHash(p[u]))}createLanguagePacksFromExtension(p,c){const u=c.identifier,i=c.manifest.contributes&&c.manifest.contributes.localizations?c.manifest.contributes.localizations:[];for(const n of i)if(c.location.scheme===L.Schemas.file&&f(n)){let t=p[n.languageId];t||(t={hash:"",extensions:[],translations:{},label:n.localizedLanguageName??n.languageName},p[n.languageId]=t);const s=t.extensions.filter(r=>(0,m.areSameExtensions)(r.extensionIdentifier,u))[0];s?s.version=c.manifest.version:t.extensions.push({extensionIdentifier:u,version:c.manifest.version});for(const r of n.translations)t.translations[r.id]=(0,D.join)(c.location.fsPath,r.path)}}updateHash(p){if(p){const c=(0,a.createHash)("md5");for(const u of p.extensions)c.update(u.extensionIdentifier.uuid||u.extensionIdentifier.id).update(u.version);p.hash=c.digest("hex")}}withLanguagePacks(p=()=>null){return this.languagePacksFileLimiter.queue(()=>{let c=null;return R.promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,u=>u.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(u)).then(u=>{try{return JSON.parse(u)}catch{return{}}}).then(u=>(c=p(u),u)).then(u=>{for(const n of Object.keys(u))u[n]||delete u[n];this.languagePacks=u,this.initializedCache=!0;const i=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",i),E.Promises.writeFile(this.languagePacksFilePath,i)}).then(()=>c,u=>this.logService.error(u))})}};v=Ie([Y(0,P.INativeEnvironmentService),Y(1,d.ILogService)],v);function f(C){if(typeof C.languageId!="string"||!Array.isArray(C.translations)||C.translations.length===0)return!1;for(const p of C.translations)if(typeof p.id!="string"||typeof p.path!="string")return!1;return!(C.languageName&&typeof C.languageName!="string"||C.localizedLanguageName&&typeof C.localizedLanguageName!="string")}}),define(he[202],fe([0,1,69,8,29,5,48]),function(ce,e,R,a,_,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractOneDataSystemAppender=void 0;const L="https://0.0.0.0/OneCollector/1.0",D="https://0.0.0.0/ping";async function E(S,m,d){T.isWeb;const l=await(0,R.importAMDNodeModule)("@microsoft/1ds-core-js","dist/ms.core.js"),g=await(0,R.importAMDNodeModule)("@microsoft/1ds-post-js","dist/ms.post.js"),I=new l.AppInsightsCore,v=new g.PostChannel,f={instrumentationKey:S,endpointUrl:L,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[v]]};if(d){f.extensionConfig={};const C={alwaysUseXhrOverride:!0,ignoreMc1Ms0CookieProcessing:!0,httpXHROverride:d};f.extensionConfig[v.identifier]=C}return I.initialize(f,[]),I.addTelemetryInitializer(C=>{C.ext=C.ext??{},C.ext.web=C.ext.web??{},C.ext.web.consentDetails='{"GPC_DataSharingOptIn":false}',m&&(C.ext.utc=C.ext.utc??{},C.ext.utc.flags=8462029)}),I}class P{constructor(m,d,l,g,I){this._isInternalTelemetry=m,this._eventPrefix=d,this._defaultData=l,this._xhrOverride=I,this.endPointUrl=L,this.endPointHealthUrl=D,this._defaultData||(this._defaultData={}),typeof g=="function"?this._aiCoreOrKey=g():this._aiCoreOrKey=g,this._asyncAiCore=null}_withAIClient(m){if(this._aiCoreOrKey){if(typeof this._aiCoreOrKey!="string"){m(this._aiCoreOrKey);return}this._asyncAiCore||(this._asyncAiCore=E(this._aiCoreOrKey,this._isInternalTelemetry,this._xhrOverride)),this._asyncAiCore.then(d=>{m(d)},d=>{(0,a.onUnexpectedError)(d),console.error(d)})}}log(m,d){if(!this._aiCoreOrKey)return;d=(0,_.mixin)(d,this._defaultData),d=(0,k.validateTelemetryData)(d);const l=this._eventPrefix+"/"+m;try{this._withAIClient(g=>{g.pluginVersionString=d?.properties.version??"Unknown",g.track({name:l,baseData:{name:l,properties:d?.properties,measurements:d?.measurements}})})}catch{}}flush(){return this._aiCoreOrKey?new Promise(m=>{this._withAIClient(d=>{d.unload(!0,()=>{this._aiCoreOrKey=void 0,m(void 0)})})}):Promise.resolve(void 0)}}e.AbstractOneDataSystemAppender=P}),define(he[114],fe([0,1,2,9,15,11,23,48]),function(ce,e,R,a,_,T,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryLogAppender=void 0;let D=class extends R.Disposable{constructor(P,S,m,d,l=""){super(),this.prefix=l;const g=S.getLogger(L.telemetryLogId);if(g)this.logger=this._register(g);else{const v=(0,L.isLoggingOnly)(d,m)?" (Not Sent)":"",f=()=>(0,L.supportsTelemetry)(d,m)&&P.getLevel()===T.LogLevel.Trace;this.logger=this._register(S.createLogger(L.telemetryLogId,{name:(0,a.localize)(2067,null,v),hidden:!f()})),this._register(P.onDidChangeLogLevel(()=>S.setVisibility(L.telemetryLogId,f()))),this.logger.info("Below are logs for every telemetry event sent from VS Code once the log level is set to trace."),this.logger.info("===========================================================")}}flush(){return Promise.resolve(void 0)}log(P,S){this.logger.trace(`${this.prefix}telemetry/${P}`,(0,L.validateTelemetryData)(S))}};e.TelemetryLogAppender=D,e.TelemetryLogAppender=D=Ie([Y(0,T.ILogService),Y(1,T.ILoggerService),Y(2,_.IEnvironmentService),Y(3,k.IProductService)],D)});var it=this&&this.__importDefault||function(ce){return ce&&ce.__esModule?ce:{default:ce}};define(he[115],fe([0,1,2,29,5,26,9,21,47,104,23,44,18,48]),function(ce,e,R,a,_,T,k,L,D,E,P,S,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0,E=it(E);let l=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor(v,f,C){this._configurationService=f,this._productService=C,this._experimentProperties={},this._disposables=new R.DisposableStore,this._cleanupPatterns=[],this._appenders=v.appenders,this._commonProperties=v.commonProperties??Object.create(null),this.sessionId=this._commonProperties.sessionID,this.machineId=this._commonProperties["common.machineId"],this.sqmId=this._commonProperties["common.sqmId"],this.devDeviceId=this._commonProperties["common.devDeviceId"],this.firstSessionDate=this._commonProperties["common.firstSessionDate"],this.msftInternal=this._commonProperties["common.msftInternal"],this._piiPaths=v.piiPaths||[],this._telemetryLevel=m.TelemetryLevel.USAGE,this._sendErrorTelemetry=!!v.sendErrorTelemetry,this._cleanupPatterns=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const p of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,T.escapeRegExpCharacters)(p),"gi")),p.indexOf("\\")>=0&&this._cleanupPatterns.push(new RegExp((0,T.escapeRegExpCharacters)(p.replace(/\\/g,"/")),"gi"));this._updateTelemetryLevel(),this._disposables.add(this._configurationService.onDidChangeConfiguration(p=>{(p.affectsConfiguration(m.TELEMETRY_SETTING_ID)||p.affectsConfiguration(m.TELEMETRY_OLD_SETTING_ID)||p.affectsConfiguration(m.TELEMETRY_CRASH_REPORTER_SETTING_ID))&&this._updateTelemetryLevel()}))}setExperimentProperty(v,f){this._experimentProperties[v]=f}_updateTelemetryLevel(){let v=(0,d.getTelemetryLevel)(this._configurationService);const f=this._productService.enabledTelemetryLevels;if(f){this._sendErrorTelemetry=this.sendErrorTelemetry?f.error:!1;const C=f.usage?m.TelemetryLevel.USAGE:f.error?m.TelemetryLevel.ERROR:m.TelemetryLevel.NONE;v=Math.min(v,C)}this._telemetryLevel=v}get sendErrorTelemetry(){return this._sendErrorTelemetry}get telemetryLevel(){return this._telemetryLevel}dispose(){this._disposables.dispose()}_log(v,f,C){this._telemetryLevel<f||(C=(0,a.mixin)(C,this._experimentProperties),C=(0,d.cleanData)(C,this._cleanupPatterns),C=(0,a.mixin)(C,this._commonProperties),this._appenders.forEach(p=>p.log(v,C)))}publicLog(v,f){this._log(v,m.TelemetryLevel.USAGE,f)}publicLog2(v,f){this.publicLog(v,f)}publicLogError(v,f){this._sendErrorTelemetry&&this._log(v,m.TelemetryLevel.ERROR,f)}publicLogError2(v,f){this.publicLogError(v,f)}};e.TelemetryService=l,e.TelemetryService=l=Ie([Y(1,L.IConfigurationService),Y(2,P.IProductService)],l);function g(){const I=(0,k.localize)(2068,null,E.default.nameLong),v=E.default.privacyStatementUrl?(0,k.localize)(2070,null,"https://aka.ms/vscode-telemetry",E.default.privacyStatementUrl):(0,k.localize)(2069,null,"https://aka.ms/vscode-telemetry"),f=_.isWeb?"":(0,k.localize)(2071,null),C=(0,k.localize)(2072,null),p=(0,k.localize)(2073,null),c=(0,k.localize)(2074,null),u=(0,k.localize)(2075,null),i=`
|       | ${C} | ${p} | ${c} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,n=(0,k.localize)(2076,null);return`
${I} ${v} ${f}

&nbsp;

${u}
${i}

&nbsp;

${n}
`}S.Registry.as(D.Extensions.Configuration).registerConfiguration({id:m.TELEMETRY_SECTION_ID,order:1,type:"object",title:(0,k.localize)(2077,null),properties:{[m.TELEMETRY_SETTING_ID]:{type:"string",enum:[m.TelemetryConfiguration.ON,m.TelemetryConfiguration.ERROR,m.TelemetryConfiguration.CRASH,m.TelemetryConfiguration.OFF],enumDescriptions:[(0,k.localize)(2078,null),(0,k.localize)(2079,null),(0,k.localize)(2080,null),(0,k.localize)(2081,null)],markdownDescription:g(),default:m.TelemetryConfiguration.OFF,restricted:!0,scope:D.ConfigurationScope.APPLICATION,tags:["usesOnlineServices","telemetry"]}}}),S.Registry.as(D.Extensions.Configuration).registerConfiguration({id:m.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,k.localize)(2082,null),properties:{[m.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:E.default.privacyStatementUrl?(0,k.localize)(2084,null,E.default.nameLong,E.default.privacyStatementUrl):(0,k.localize)(2083,null,E.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,k.localize)(2085,null,`\`#${m.TELEMETRY_SETTING_ID}#\``),scope:D.ConfigurationScope.APPLICATION,tags:["usesOnlineServices","telemetry"]}}})}),define(he[203],fe([0,1,14,25,246,202]),function(ce,e,R,a,_,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OneDataSystemAppender=void 0,_=De(_);async function k(P,S){const m=await S.request(P,a.CancellationToken.None),d=(await(0,R.streamToBuffer)(m.stream)).toString(),l=m.res.statusCode??200;return{headers:m.res.headers,statusCode:l,responseData:d}}async function L(P){const S={method:P.type,headers:P.headers};return new Promise((d,l)=>{const g=_.request(P.url??"",S,I=>{I.on("data",function(v){d({headers:I.headers,statusCode:I.statusCode??200,responseData:v.toString()})}),I.on("error",function(v){l(v)})});g.write(P.data,I=>{I&&l(I)}),g.end()})}async function D(P,S,m){const d=typeof S.data=="string"?S.data:new TextDecoder().decode(S.data),l={type:"POST",headers:{...S.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(S.data).toString()},url:S.urlString,data:d};try{const g=P?await k(l,P):await L(l);m(g.statusCode,g.headers,g.responseData)}catch{m(0,{})}}class E extends T.AbstractOneDataSystemAppender{constructor(S,m,d,l,g){const I={sendPOST:(v,f)=>{D(S,v,f)}};super(m,d,l,g,I)}}e.OneDataSystemAppender=E}),define(he[204],fe([0,1,22,97,21,15,11,23,18,113,114,115]),function(ce,e,R,a,_,T,k,L,D,E,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CustomEndpointTelemetryService=void 0;let m=class{constructor(l,g,I,v,f,C){this.configurationService=l,this.telemetryService=g,this.logService=I,this.loggerService=v,this.environmentService=f,this.productService=C,this.customTelemetryServices=new Map}getCustomTelemetryService(l){if(!this.customTelemetryServices.has(l.id)){const g=Object.create(null);g["common.vscodemachineid"]=this.telemetryService.machineId,g["common.vscodesessionid"]=this.telemetryService.sessionId;const I=[l.id,JSON.stringify(g),l.aiKey],f=new a.Client(R.FileAccess.asFileUri("bootstrap-fork").fsPath,{serverName:"Debug Telemetry",timeout:1e3*60*5,args:I,env:{ELECTRON_RUN_AS_NODE:1,VSCODE_PIPE_LOGGING:"true",VSCODE_AMD_ENTRYPOINT:"vs/workbench/contrib/debug/node/telemetryApp"}}).getChannel("telemetryAppender"),C=[new E.TelemetryAppenderClient(f),new P.TelemetryLogAppender(this.logService,this.loggerService,this.environmentService,this.productService,`[${l.id}] `)];this.customTelemetryServices.set(l.id,new S.TelemetryService({appenders:C,sendErrorTelemetry:l.sendErrorTelemetry},this.configurationService,this.productService))}return this.customTelemetryServices.get(l.id)}publicLog(l,g,I){this.getCustomTelemetryService(l).publicLog(g,I)}publicLogError(l,g,I){this.getCustomTelemetryService(l).publicLogError(g,I)}};e.CustomEndpointTelemetryService=m,e.CustomEndpointTelemetryService=m=Ie([Y(0,_.IConfigurationService),Y(1,D.ITelemetryService),Y(2,k.ILogService),Y(3,k.ILoggerService),Y(4,T.IEnvironmentService),Y(5,L.IProductService)],m)}),define(he[81],fe([0,1,3,2,5,10,21,4,11]),function(ce,e,R,a,_,T,k,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.ALL_INTERFACES_ADDRESSES=e.LOCALHOST_ADDRESSES=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.isTunnelProvider=S,e.extractLocalHostUriMetaDataForPortMapping=d,e.extractQueryLocalHostUriMetaDataForPortMapping=l,e.isLocalhost=g,e.isAllInterfaces=I,e.isPortPrivileged=v,e.ITunnelService=(0,L.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,L.createDecorator)("sharedTunnelsService");var E;(function(p){p.Http="http",p.Https="https"})(E||(e.TunnelProtocol=E={}));var P;(function(p){p.ConstantPrivate="constantPrivate",p.Private="private",p.Public="public"})(P||(e.TunnelPrivacyId=P={}));function S(p){return!!p.forwardPort}var m;(function(p){p[p.Notify=1]="Notify",p[p.OpenBrowser=2]="OpenBrowser",p[p.OpenPreview=3]="OpenPreview",p[p.Silent=4]="Silent",p[p.Ignore=5]="Ignore",p[p.OpenBrowserOnce=6]="OpenBrowserOnce"})(m||(e.ProvidedOnAutoForward=m={}));function d(p){if(p.scheme!=="http"&&p.scheme!=="https")return;const c=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(p.authority);if(c)return{address:c[1],port:+c[2]}}function l(p){if(p.scheme!=="http"&&p.scheme!=="https"||!p.query)return;const c=p.query.split("&");for(const u of c){const i=u.split("=")[1];if(/^https?:/.exec(i)){const n=d(T.URI.parse(i));if(n)return n}}}e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function g(p){return e.LOCALHOST_ADDRESSES.indexOf(p)>=0}e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function I(p){return e.ALL_INTERFACES_ADDRESSES.indexOf(p)>=0}function v(p,c,u,i){if(u===_.OperatingSystem.Windows)return!1;if(u===_.OperatingSystem.Macintosh&&I(c)){const n=/(\d+)\.(\d+)\.(\d+)/g.exec(i);if(n?.length===4&&parseInt(n[1])>=18)return!1}return p<1024}class f{constructor(c,u,i){this.remoteAddress=c,this.localAddress=u,this._dispose=i,this._onDispose=new R.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}e.DisposableTunnel=f;let C=class extends a.Disposable{constructor(c,u){super(),this.logService=c,this.configurationService=u,this._onTunnelOpened=new R.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new R.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new R.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._canChangeProtocol=!0,this._privacyOptions=[],this._factoryInProgress=new Set}get hasTunnelProvider(){return!!this._tunnelProvider}get defaultTunnelHost(){const c=this.configurationService.getValue("remote.localPortHost");return!c||c==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(c){return this._tunnelProvider=c,c?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(c){this._canElevate=c.elevation,this._privacyOptions=c.privacyOptions,this._canChangeProtocol=c.protocol}get canChangeProtocol(){return this._canChangeProtocol}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const c=[],u=Array.from(this._tunnels.values());for(const i of u){const n=Array.from(i.values());for(const t of n){const s=await t.value;s&&typeof s!="string"&&c.push(s)}}return c}async dispose(){super.dispose();for(const c of this._tunnels.values()){for(const{value:u}of c.values())await u.then(i=>typeof i!="string"?i?.dispose():void 0);c.clear()}this._tunnels.clear()}setEnvironmentTunnel(c,u,i,n,t){this.addTunnelToMap(c,u,Promise.resolve({tunnelRemoteHost:c,tunnelRemotePort:u,localAddress:i,privacy:n,protocol:t,dispose:()=>Promise.resolve()}))}async getExistingTunnel(c,u){(I(c)||g(c))&&(c=e.LOCALHOST_ADDRESSES[0]);const i=this.getTunnelFromMap(c,u);if(i)return++i.refcount,i.value}openTunnel(c,u,i,n,t,s=!1,r,o){this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${u}:${i} on local port ${t}.`);const h=this._tunnelProvider??c;if(!h)return;if(u||(u="localhost"),n||(n=this.defaultTunnelHost),this._tunnelProvider&&this._factoryInProgress.has(i)){this.logService.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const y=this.retainOrCreateTunnel(h,u,i,n,t,s,r,o);return y?y.then(A=>{if(A){if(typeof A=="string")return this.logService.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.removeEmptyOrErrorTunnelFromMap(u,i),A}else{this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyOrErrorTunnelFromMap(u,i);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const b=this.makeTunnel(A);return(A.tunnelRemoteHost!==u||A.tunnelRemotePort!==i)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),r&&A.privacy!==r&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this._onTunnelOpened.fire(b),b}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),y)}makeTunnel(c){return{tunnelRemotePort:c.tunnelRemotePort,tunnelRemoteHost:c.tunnelRemoteHost,tunnelLocalPort:c.tunnelLocalPort,localAddress:c.localAddress,privacy:c.privacy,protocol:c.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${c.tunnelRemoteHost}:${c.tunnelRemotePort} `);const u=this._tunnels.get(c.tunnelRemoteHost);if(u){const i=u.get(c.tunnelRemotePort);i&&(i.refcount--,await this.tryDisposeTunnel(c.tunnelRemoteHost,c.tunnelRemotePort,i))}}}}async tryDisposeTunnel(c,u,i){if(i.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${c}:${u}.`);const n=i.value.then(async t=>{t&&typeof t!="string"&&(await t.dispose(!0),this._onTunnelClosed.fire({host:t.tunnelRemoteHost,port:t.tunnelRemotePort}))});return this._tunnels.has(c)&&this._tunnels.get(c).delete(u),n}}async closeTunnel(c,u){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${c}:${u} `);const i=this._tunnels.get(c);if(i&&i.has(u)){const n=i.get(u);n.refcount=0,await this.tryDisposeTunnel(c,u,n)}}addTunnelToMap(c,u,i){this._tunnels.has(c)||this._tunnels.set(c,new Map),this._tunnels.get(c).set(u,{refcount:1,value:i})}async removeEmptyOrErrorTunnelFromMap(c,u){const i=this._tunnels.get(c);if(i){const n=i.get(u),t=n?await n.value:void 0;(!t||typeof t=="string")&&i.delete(u),i.size===0&&this._tunnels.delete(c)}}getTunnelFromMap(c,u){const i=[c];g(c)?(i.push(...e.LOCALHOST_ADDRESSES),i.push(...e.ALL_INTERFACES_ADDRESSES)):I(c)&&i.push(...e.ALL_INTERFACES_ADDRESSES);const n=i.map(t=>this._tunnels.get(t));for(const t of n){const s=t?.get(u);if(s)return s}}canTunnel(c){return!!d(c)}createWithProvider(c,u,i,n,t,s,r){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${u}:${i} on local port ${n}.`);const o=i;this._factoryInProgress.add(o);const h=n===void 0?i:n,y={elevationRequired:t?this.isPortPrivileged(h):!1},A={remoteAddress:{host:u,port:i},localAddressPort:n,privacy:s,public:s?s!==P.Private:void 0,protocol:r},b=c.forwardPort(A,y);return b?(this.addTunnelToMap(u,i,b),b.finally(()=>{this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this._factoryInProgress.delete(o)})):this._factoryInProgress.delete(o),b}};e.AbstractTunnelService=C,e.AbstractTunnelService=C=Ie([Y(0,D.ILogService),Y(1,k.IConfigurationService)],C)}),define(he[205],fe([0,1,11,81,2,8,6]),function(ce,e,R,a,_,T,k){"use strict";var L;Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessTunnelService=void 0;class D extends _.Disposable{constructor(){super(),this._address=null,this._addressPromise=null}async getAddress(){return this._address?this._address:(this._addressPromise||(this._addressPromise=new k.DeferredPromise),this._addressPromise.p)}setAddress(S){this._address=S,this._addressPromise&&(this._addressPromise.complete(S),this._addressPromise=null)}setTunnel(S){this._register(S)}}let E=class extends _.Disposable{static{L=this}static{this._lastId=0}constructor(S,m){super(),this._tunnelService=S,this._logService=m,this._tunnels=new Map,this._disposedTunnels=new Set}dispose(){super.dispose(),this._tunnels.forEach(S=>S.dispose())}async createTunnel(){return{id:String(++L._lastId)}}async startTunnel(S,m,d,l,g,I,v){const f=new D,C=await Promise.resolve(this._tunnelService.openTunnel(S,f,d,l,g,I,v));if(!C||typeof C=="string")throw this._logService.info(`[SharedProcessTunnelService] Could not create a tunnel to ${d}:${l} (remote).`),f.dispose(),new Error("Could not create tunnel");if(this._disposedTunnels.has(m))throw this._disposedTunnels.delete(m),f.dispose(),await C.dispose(),(0,T.canceled)();return f.setTunnel(C),this._tunnels.set(m,f),this._logService.info(`[SharedProcessTunnelService] Created tunnel ${m}: ${C.localAddress} (local) to ${d}:${l} (remote).`),{tunnelLocalPort:C.tunnelLocalPort,localAddress:C.localAddress}}async setAddress(S,m){const d=this._tunnels.get(S);d&&d.setAddress(m)}async destroyTunnel(S){const m=this._tunnels.get(S);if(m){this._logService.info(`[SharedProcessTunnelService] Disposing tunnel ${S}.`),this._tunnels.delete(S),await m.dispose();return}this._disposedTunnels.add(S)}};e.SharedProcessTunnelService=E,e.SharedProcessTunnelService=E=L=Ie([Y(0,a.ISharedTunnelsService),Y(1,R.ILogService)],E)}),define(he[28],fe([0,1,4]),function(ce,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,R.createDecorator)("IUriIdentityService")}),define(he[206],fe([0,1,28,162,7,20,135,3,2]),function(ce,e,R,a,_,T,k,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class E{static{this._clock=0}constructor(m){this.uri=m,this.time=E._clock++}touch(){return this.time=E._clock++,this}}let P=class{constructor(m){this._fileService=m,this._dispooables=new D.DisposableStore,this._limit=2**16;const d=new Map,l=g=>{let I=d.get(g.scheme);return I===void 0&&(I=m.hasProvider(g)&&!this._fileService.hasCapability(g,_.FileSystemProviderCapabilities.PathCaseSensitive),d.set(g.scheme,I)),I};this._dispooables.add(L.Event.any(m.onDidChangeFileSystemProviderRegistrations,m.onDidChangeFileSystemProviderCapabilities)(g=>{d.delete(g.scheme)})),this.extUri=new T.ExtUri(l),this._canonicalUris=new k.SkipList((g,I)=>this.extUri.compare(g,I,!0),this._limit)}dispose(){this._dispooables.dispose(),this._canonicalUris.clear()}asCanonicalUri(m){this._fileService.hasProvider(m)&&(m=(0,T.normalizePath)(m));const d=this._canonicalUris.get(m);return d?d.touch().uri.with({fragment:m.fragment}):(this._canonicalUris.set(m,new E(m)),this._checkTrim(),m)}_checkTrim(){if(this._canonicalUris.size<this._limit)return;const m=[...this._canonicalUris.entries()].sort((l,g)=>l[1].time<g[1].time?1:l[1].time>g[1].time?-1:0);E._clock=0,this._canonicalUris.clear();const d=this._limit*.5;for(let l=0;l<d;l++)this._canonicalUris.set(m[l][0],m[l][1].touch())}};e.UriIdentityService=P,e.UriIdentityService=P=Ie([Y(0,_.IFileService)],P),(0,a.registerSingleton)(R.IUriIdentityService,P,a.InstantiationType.Delayed)}),define(he[207],fe([0,1,3,2,7,51,31]),function(ce,e,R,a,_,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileUserDataProvider=void 0;class L extends a.Disposable{constructor(E,P,S,m,d,l){super(),this.fileSystemScheme=E,this.fileSystemProvider=P,this.userDataScheme=S,this.userDataProfilesService=m,this.uriIdentityService=d,this.logService=l,this.capabilities=this.fileSystemProvider.capabilities,this.onDidChangeCapabilities=this.fileSystemProvider.onDidChangeCapabilities,this._onDidChangeFile=this._register(new R.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.watchResources=T.TernarySearchTree.forUris(()=>!(this.capabilities&_.FileSystemProviderCapabilities.PathCaseSensitive)),this.atomicReadWriteResources=new k.ResourceSet(g=>this.uriIdentityService.extUri.getComparisonKey(this.toFileSystemResource(g))),this.updateAtomicReadWritesResources(),this._register(m.onDidChangeProfiles(()=>this.updateAtomicReadWritesResources())),this._register(this.fileSystemProvider.onDidChangeFile(g=>this.handleFileChanges(g)))}updateAtomicReadWritesResources(){this.atomicReadWriteResources.clear();for(const E of this.userDataProfilesService.profiles)this.atomicReadWriteResources.add(E.settingsResource),this.atomicReadWriteResources.add(E.keybindingsResource),this.atomicReadWriteResources.add(E.tasksResource),this.atomicReadWriteResources.add(E.extensionsResource)}open(E,P){return this.fileSystemProvider.open(this.toFileSystemResource(E),P)}close(E){return this.fileSystemProvider.close(E)}read(E,P,S,m,d){return this.fileSystemProvider.read(E,P,S,m,d)}write(E,P,S,m,d){return this.fileSystemProvider.write(E,P,S,m,d)}watch(E,P){this.watchResources.set(E,E);const S=this.fileSystemProvider.watch(this.toFileSystemResource(E),P);return(0,a.toDisposable)(()=>{this.watchResources.delete(E),S.dispose()})}stat(E){return this.fileSystemProvider.stat(this.toFileSystemResource(E))}mkdir(E){return this.fileSystemProvider.mkdir(this.toFileSystemResource(E))}rename(E,P,S){return this.fileSystemProvider.rename(this.toFileSystemResource(E),this.toFileSystemResource(P),S)}readFile(E,P){return this.fileSystemProvider.readFile(this.toFileSystemResource(E),P)}readFileStream(E,P,S){return this.fileSystemProvider.readFileStream(this.toFileSystemResource(E),P,S)}readdir(E){return this.fileSystemProvider.readdir(this.toFileSystemResource(E))}enforceAtomicReadFile(E){return this.atomicReadWriteResources.has(E)}writeFile(E,P,S){return this.fileSystemProvider.writeFile(this.toFileSystemResource(E),P,S)}enforceAtomicWriteFile(E){return this.atomicReadWriteResources.has(E)?{postfix:".vsctmp"}:!1}delete(E,P){return this.fileSystemProvider.delete(this.toFileSystemResource(E),P)}copy(E,P,S){if((0,_.hasFileFolderCopyCapability)(this.fileSystemProvider))return this.fileSystemProvider.copy(this.toFileSystemResource(E),this.toFileSystemResource(P),S);throw new Error("copy not supported")}cloneFile(E,P){if((0,_.hasFileCloneCapability)(this.fileSystemProvider))return this.fileSystemProvider.cloneFile(this.toFileSystemResource(E),this.toFileSystemResource(P));throw new Error("clone not supported")}handleFileChanges(E){const P=[];for(const S of E){if(S.resource.scheme!==this.fileSystemScheme)continue;const m=this.toUserDataResource(S.resource);this.watchResources.findSubstr(m)&&P.push({resource:m,type:S.type,cId:S.cId})}P.length&&(this.logService.debug("User data changed"),this._onDidChangeFile.fire(P))}toFileSystemResource(E){return E.with({scheme:this.fileSystemScheme})}toUserDataResource(E){return E.with({scheme:this.userDataScheme})}}e.FileUserDataProvider=L}),define(he[82],fe([0,1,64]),function(ce,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.edit=a,e.getLineStartOffset=_,e.getLineEndOffset=T;function a(k,L,D,E){const P=(0,R.setProperty)(k,L,D,E)[0];return P&&(k=k.substring(0,P.offset)+P.content+k.substring(P.offset+P.length)),k}function _(k,L,D){let E=D;for(;E>=0;){if(k.charAt(E)===L.charAt(L.length-1)&&L.length===1)return E+1;if(E--,L.length===2&&E>=0&&k.charAt(E)===L.charAt(0))return E+2}return 0}function T(k,L,D){let E=D;for(;E>=0;)if(k.charAt(E)===L.charAt(L.length-1)&&L.length===1||(E++,L.length===2&&E>=0&&k.charAt(E)===L.charAt(1)))return E;return k.length-1}}),define(he[208],fe([0,1,29,60,12]),function(ce,e,R,a,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=T,a=De(a);function T(d,l,g,I,v,f){const C=[],p=[],c=[];if(!l){const M=d.filter(({identifier:V})=>v.every(z=>z.toLowerCase()!==V.id.toLowerCase()));return{local:{added:C,removed:p,updated:c},remote:M.length>0?{added:M,updated:[],removed:[],all:M}:null}}d=d.map(S),l=l.map(S),g=g?g.map(S):null;const u=new Map,i=M=>{M.uuid&&u.set(M.id.toLowerCase(),M.uuid)};d.forEach(({identifier:M})=>i(M)),l.forEach(({identifier:M})=>i(M)),g?.forEach(({identifier:M})=>i(M)),I?.forEach(({identifier:M})=>i(M)),f?.forEach(M=>i(M));const n=M=>{const V=M.identifier.uuid||u.get(M.identifier.id.toLowerCase());return V?`uuid:${V}`:`id:${M.identifier.id.toLowerCase()}`},t=(M,V)=>(M.set(n(V),V),M),s=d.reduce(t,new Map),r=l.reduce(t,new Map),o=l.reduce((M,V)=>t(M,(0,R.deepClone)(V)),new Map),h=g?g.reduce(t,new Map):null,y=I.reduce(t,new Map),A=v.reduce((M,V)=>{const z=u.get(V.toLowerCase());return M.add(z?`uuid:${z}`:`id:${V.toLowerCase()}`)},new Set),b=f?f.reduce((M,{id:V,uuid:z})=>(z=z??u.get(V.toLowerCase()),M.add(z?`uuid:${z}`:`id:${V.toLowerCase()}`)),new Set):null,w=k(s,r,A,!1);if(w.added.size>0||w.removed.size>0||w.updated.size>0){const M=k(h,s,A,!1),V=k(h,r,A,!0),z=(J,j,te,q)=>{let B,Z,ne;return j.installed?(B=q.pinned,ne=q.preRelease,B&&(Z=q.version)):(B=te.pinned,ne=te.preRelease,B&&(Z=te.version)),B===void 0&&(B=j.pinned,B&&(Z=j.version)),ne===void 0&&(ne=j.preRelease),{...q,installed:j.installed||te.installed,pinned:B,preRelease:ne,version:Z??(te.version&&(!j.installed||a.gt(te.version,j.version))?te.version:j.version),state:D(j,te,h?.get(J))}};for(const J of V.removed.values()){const j=s.get(J);if(!j)continue;const te=(0,_.assertIsDefined)(h?.get(J)),q=b&&!b.has(J)&&te.installed;j.installed&&q?p.push(j.identifier):o.set(J,j)}for(const J of V.added.values()){const j=(0,_.assertIsDefined)(r.get(J)),te=s.get(J);if(te){if(w.updated.has(J)){const q=z(J,te,j,j);L(te,j,!1,!1)||c.push(m(q,J)),o.set(J,q)}}else j.installed&&C.push(m(j,J))}for(const J of V.updated.values()){const j=(0,_.assertIsDefined)(r.get(J)),te=(0,_.assertIsDefined)(h?.get(J)),q=s.get(J);if(q)if(b&&!b.has(J)&&te.installed&&q.installed&&!j.installed)p.push(q.identifier);else{const Z=z(J,q,j,j);c.push(m(Z,J)),o.set(J,Z)}else j.installed&&C.push(m(j,J))}for(const J of M.added.values())V.added.has(J)||o.set(J,(0,_.assertIsDefined)(s.get(J)));for(const J of M.updated.values()){if(V.removed.has(J)||V.updated.has(J))continue;const j=(0,_.assertIsDefined)(s.get(J)),te=(0,_.assertIsDefined)(r.get(J));o.set(J,z(J,j,te,j))}for(const J of M.removed.values())V.updated.has(J)||V.removed.has(J)||y.has(J)||(0,_.assertIsDefined)(r.get(J)).installed&&b&&(b.has(J)||!(0,_.assertIsDefined)(h?.get(J)).installed||o.delete(J))}const O=[],F=k(r,o,new Set,!0),N=F.added.size>0||F.updated.size>0||F.removed.size>0;return N&&o.forEach((M,V)=>O.push(m(M,V))),{local:{added:C,removed:p,updated:c},remote:N?{added:[...F.added].map(M=>o.get(M)),updated:[...F.updated].map(M=>o.get(M)),removed:[...F.removed].map(M=>r.get(M)),all:O}:null}}function k(d,l,g,I){const v=d?[...d.keys()].filter(u=>!g.has(u)):[],f=[...l.keys()].filter(u=>!g.has(u)),C=f.filter(u=>!v.includes(u)).reduce((u,i)=>(u.add(i),u),new Set),p=v.filter(u=>!f.includes(u)).reduce((u,i)=>(u.add(i),u),new Set),c=new Set;for(const u of v){if(p.has(u))continue;const i=d.get(u),n=l.get(u);(!n||!L(i,n,I,!0))&&c.add(u)}return{added:C,removed:p,updated:c}}function L(d,l,g,I){return!(d.disabled!==l.disabled||!!d.isApplicationScoped!=!!l.isApplicationScoped||I&&d.installed!==l.installed||d.installed&&l.installed&&(d.preRelease!==l.preRelease||d.pinned!==l.pinned||l.pinned&&d.version!==l.version)||!P(d.state,l.state)||g&&d.version!==l.version)}function D(d,l,g){const I=d.state,v=l.state,f=g?.state;if(!l.version||I&&a.gt(d.version,l.version))return I;if(v&&a.gt(l.version,d.version)||!I)return v;if(!v)return I;const C=(0,R.deepClone)(I),p=f?E(f,v):{added:Object.keys(v).reduce((u,i)=>(u.add(i),u),new Set),removed:new Set,updated:new Set},c=f?E(f,I):{added:Object.keys(I).reduce((u,i)=>(u.add(i),u),new Set),removed:new Set,updated:new Set};for(const u of[...p.added.values(),...p.updated.values()])C[u]=v[u];for(const u of p.removed.values())c.updated.has(u)||delete C[u];return C}function E(d,l){const g=Object.keys(d),I=Object.keys(l),v=I.filter(p=>!g.includes(p)).reduce((p,c)=>(p.add(c),p),new Set),f=g.filter(p=>!I.includes(p)).reduce((p,c)=>(p.add(c),p),new Set),C=new Set;for(const p of g){if(f.has(p))continue;const c=d[p],u=l[p];(0,R.equals)(c,u)||C.add(p)}return{added:v,removed:f,updated:C}}function P(d={},l={}){const{added:g,removed:I,updated:v}=E(d,l);return g.size===0&&I.size===0&&v.size===0}function S(d){return{...d,disabled:!!d.disabled,installed:!!d.installed}}function m(d,l){const g={...d,identifier:{id:d.identifier.id,uuid:l.startsWith("uuid:")?l.substring(5):void 0},preRelease:!!d.preRelease,pinned:!!d.pinned};return d.disabled||delete g.disabled,d.installed||delete g.installed,d.state||delete g.state,d.isApplicationScoped||delete g.isApplicationScoped,g}}),define(he[116],fe([0,1,17,21,4]),function(ce,e,R,a,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IgnoredExtensionsManagementService=e.IIgnoredExtensionsManagementService=void 0,e.IIgnoredExtensionsManagementService=(0,_.createDecorator)("IIgnoredExtensionsManagementService");let T=class{constructor(L){this.configurationService=L}hasToNeverSyncExtension(L){return this.getConfiguredIgnoredExtensions().includes(L.toLowerCase())}hasToAlwaysSyncExtension(L){return this.getConfiguredIgnoredExtensions().includes(`-${L.toLowerCase()}`)}updateIgnoredExtensions(L,D){let E=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(P=>P.toLowerCase());return E=E.filter(P=>P!==L&&P!==`-${L}`),D&&E.push(L.toLowerCase()),this.configurationService.updateValue("settingsSync.ignoredExtensions",E.length?E:void 0,a.ConfigurationTarget.USER)}updateSynchronizedExtensions(L,D){let E=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(P=>P.toLowerCase());return E=E.filter(P=>P!==L&&P!==`-${L}`),D&&E.push(`-${L.toLowerCase()}`),this.configurationService.updateValue("settingsSync.ignoredExtensions",E.length?E:void 0,a.ConfigurationTarget.USER)}getIgnoredExtensions(L){const D=L.filter(m=>m.isMachineScoped).map(m=>m.identifier.id.toLowerCase()),E=this.getConfiguredIgnoredExtensions().map(m=>m.toLowerCase()),P=[],S=[];if(Array.isArray(E))for(const m of E)m.startsWith("-")?S.push(m.substring(1)):P.push(m);return(0,R.distinct)([...D,...P].filter(m=>!S.includes(m)))}getConfiguredIgnoredExtensions(){let L=this.configurationService.inspect("settingsSync.ignoredExtensions").userValue;return L!==void 0||(L=this.configurationService.inspect("sync.ignoredExtensions").userValue,L!==void 0)?L:(this.configurationService.getValue("settingsSync.ignoredExtensions")||[]).map(D=>D.toLowerCase())}};e.IgnoredExtensionsManagementService=T,e.IgnoredExtensionsManagementService=T=Ie([Y(0,a.IConfigurationService)],T)}),define(he[209],fe([0,1,17,36,29,98,82]),function(ce,e,R,a,_,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=D,_=De(_),k=De(k);function L(p){return(0,a.parse)(p)||[]}async function D(p,c,u,i,n){const t=L(p),s=L(c),r=u?L(u):null,o=[...t,...s,...r||[]].map(z=>z.key),h=await n.resolveUserBindings(o),y=P(t,s,r,h);if(!y.hasLocalForwarded&&!y.hasRemoteForwarded)return{mergeContent:p,hasChanges:!1,hasConflicts:!1};if(!y.hasLocalForwarded&&y.hasRemoteForwarded)return{mergeContent:c,hasChanges:!0,hasConflicts:!1};if(y.hasLocalForwarded&&!y.hasRemoteForwarded)return{mergeContent:p,hasChanges:!0,hasConflicts:!1};const A=m(t),b=m(s),w=r?m(r):null,O=l(A,b,h),F=w?l(w,A,h):{added:[...A.keys()].reduce((z,J)=>(z.add(J),z),new Set),removed:new Set,updated:new Set},N=w?l(w,b,h):{added:[...b.keys()].reduce((z,J)=>(z.add(J),z),new Set),removed:new Set,updated:new Set},M=E(O,F,N);let V=p;for(const z of M.removed.values())M.conflicts.has(z)||(V=f(V,z,i));for(const z of M.added.values()){if(M.conflicts.has(z))continue;const J=b.get(z);if(J.some(j=>j.command!==`-${z}`&&y.conflicts.has(h[j.key]))){M.conflicts.add(z);continue}V=v(V,J,i)}for(const z of M.updated.values()){if(M.conflicts.has(z))continue;const J=b.get(z);if(J.some(j=>j.command!==`-${z}`&&y.conflicts.has(h[j.key]))){M.conflicts.add(z);continue}V=C(V,z,J,i)}return{mergeContent:V,hasChanges:!0,hasConflicts:M.conflicts.size>0}}function E(p,c,u){const i=new Set,n=new Set,t=new Set,s=new Set;for(const r of c.removed.values())u.updated.has(r)&&s.add(r);for(const r of u.removed.values())s.has(r)||(c.updated.has(r)?s.add(r):n.add(r));for(const r of c.added.values())s.has(r)||u.added.has(r)&&p.updated.has(r)&&s.add(r);for(const r of u.added.values())s.has(r)||(c.added.has(r)?p.updated.has(r)&&s.add(r):i.add(r));for(const r of c.updated.values())s.has(r)||u.updated.has(r)&&p.updated.has(r)&&s.add(r);for(const r of u.updated.values())s.has(r)||(c.updated.has(r)?p.updated.has(r)&&s.add(r):t.add(r));return{added:i,removed:n,updated:t,conflicts:s}}function P(p,c,u,i){const n=new Set,t=S(p,i),s=S(c,i),r=u?S(u,i):null,o=d(t,s);if(o.added.size===0&&o.removed.size===0&&o.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!1,added:n,removed:n,updated:n,conflicts:n};const h=r?d(r,t):{added:[...t.keys()].reduce((F,N)=>(F.add(N),F),new Set),removed:new Set,updated:new Set};if(h.added.size===0&&h.removed.size===0&&h.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!0,added:n,removed:n,updated:n,conflicts:n};const y=r?d(r,s):{added:[...s.keys()].reduce((F,N)=>(F.add(N),F),new Set),removed:new Set,updated:new Set};if(y.added.size===0&&y.removed.size===0&&y.updated.size===0)return{hasLocalForwarded:!0,hasRemoteForwarded:!1,added:n,removed:n,updated:n,conflicts:n};const{added:A,removed:b,updated:w,conflicts:O}=E(o,h,y);return{hasLocalForwarded:!0,hasRemoteForwarded:!0,added:A,removed:b,updated:w,conflicts:O}}function S(p,c){const u=new Map;for(const i of p){const n=c[i.key];let t=u.get(n);t||(t=[],u.set(n,t)),t.push(i)}return u}function m(p){const c=new Map;for(const u of p){const i=u.command[0]==="-"?u.command.substring(1):u.command;let n=c.get(i);n||(n=[],c.set(i,n)),n.push(u)}return c}function d(p,c){const u=[...p.keys()],i=[...c.keys()],n=i.filter(r=>!u.includes(r)).reduce((r,o)=>(r.add(o),r),new Set),t=u.filter(r=>!i.includes(r)).reduce((r,o)=>(r.add(o),r),new Set),s=new Set;for(const r of u){if(t.has(r))continue;const o=p.get(r).map(y=>({...y,key:r})),h=c.get(r).map(y=>({...y,key:r}));(0,R.equals)(o,h,(y,A)=>I(y,A))||s.add(r)}return{added:n,removed:t,updated:s}}function l(p,c,u){const i=[...p.keys()],n=[...c.keys()],t=n.filter(o=>!i.includes(o)).reduce((o,h)=>(o.add(h),o),new Set),s=i.filter(o=>!n.includes(o)).reduce((o,h)=>(o.add(h),o),new Set),r=new Set;for(const o of i){if(s.has(o))continue;const h=p.get(o).map(A=>({...A,key:u[A.key]})),y=c.get(o).map(A=>({...A,key:u[A.key]}));g(h,y)||r.add(o)}return{added:t,removed:s,updated:r}}function g(p,c){return!(!(0,R.equals)(p.filter(({command:u})=>u[0]!=="-"),c.filter(({command:u})=>u[0]!=="-"),(u,i)=>I(u,i))||!(0,R.equals)(p.filter(({command:u})=>u[0]==="-"),c.filter(({command:u})=>u[0]==="-"),(u,i)=>I(u,i)))}function I(p,c){if(p.command!==c.command||p.key!==c.key)return!1;const u=T.ContextKeyExpr.deserialize(p.when),i=T.ContextKeyExpr.deserialize(c.when);return!(u&&!i||!u&&i||u&&i&&!u.equals(i)||!_.equals(p.args,c.args))}function v(p,c,u){for(const i of c)p=k.edit(p,[-1],i,u);return p}function f(p,c,u){const i=L(p);for(let n=i.length-1;n>=0;n--)(i[n].command===c||i[n].command===`-${c}`)&&(p=k.edit(p,[n],void 0,u));return p}function C(p,c,u,i){const n=L(p),t=n.findIndex(s=>s.command===c||s.command===`-${c}`);for(let s=n.length-1;s>=0;s--)(n[s].command===c||n[s].command===`-${c}`)&&(p=k.edit(p,[s],void 0,i));for(let s=u.length-1;s>=0;s--)p=k.edit(p,[t],u[s],i);return p}}),define(he[210],fe([0,1]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=R,e.areSame=_;function R(T,k,L){const D={},E={},P=new Set;if(!k)return{local:{added:D,updated:E,removed:[...P.values()]},remote:{added:T,updated:{},removed:[]},conflicts:[]};const S=a(T,k);if(S.added.size===0&&S.removed.size===0&&S.updated.size===0)return{local:{added:D,updated:E,removed:[...P.values()]},remote:{added:{},updated:{},removed:[]},conflicts:[]};const m=a(L,T),d=a(L,k),l={},g={},I=new Set,v=new Set;for(const f of m.removed.values())d.updated.has(f)?D[f]=k[f]:I.add(f);for(const f of d.removed.values())v.has(f)||(m.updated.has(f)?v.add(f):P.add(f));for(const f of m.updated.values())v.has(f)||(d.updated.has(f)?S.updated.has(f)&&v.add(f):g[f]=T[f]);for(const f of d.updated.values())v.has(f)||(m.updated.has(f)?S.updated.has(f)&&v.add(f):T[f]!==void 0&&(E[f]=k[f]));for(const f of m.added.values())v.has(f)||(d.added.has(f)?S.updated.has(f)&&v.add(f):l[f]=T[f]);for(const f of d.added.values())v.has(f)||(m.added.has(f)?S.updated.has(f)&&v.add(f):D[f]=k[f]);return{local:{added:D,removed:[...P.values()],updated:E},remote:{added:l,removed:[...I.values()],updated:g},conflicts:[...v.values()]}}function a(T,k){const L=T?Object.keys(T):[],D=k?Object.keys(k):[],E=D.filter(m=>!L.includes(m)).reduce((m,d)=>(m.add(d),m),new Set),P=L.filter(m=>!D.includes(m)).reduce((m,d)=>(m.add(d),m),new Set),S=new Set;for(const m of L){if(P.has(m))continue;const d=T[m],l=k[m];d!==l&&S.add(m)}return{added:E,removed:P,updated:S}}function _(T,k){const{added:L,removed:D,updated:E}=a(T,k);return L.size===0&&D.size===0&&E.size===0}}),define(he[211],fe([0,1,29]),function(ce,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=a;function a(T,k,L,D){const E={added:[],removed:[],updated:[]};let P={added:[],removed:[],updated:[]};if(!k){const m=T.filter(({id:d})=>!D.includes(d));return m.length?P.added=m:P=null,{local:E,remote:P}}const S=_(T,k,D);if(S.added.length>0||S.removed.length>0||S.updated.length>0){const m=_(L,T,D),d=_(L,k,D);for(const l of d.removed){const g=T.find(I=>I.id===l);g&&E.removed.push(g)}for(const l of d.added){const g=k.find(I=>I.id===l);m.added.includes(l)?S.updated.includes(l)&&E.updated.push(g):E.added.push(g)}for(const l of d.updated)E.updated.push(k.find(g=>g.id===l));for(const l of m.added)d.added.includes(l)||P.added.push(T.find(g=>g.id===l));for(const l of m.updated)d.removed.includes(l)||d.updated.includes(l)||P.updated.push(T.find(g=>g.id===l));for(const l of m.removed){const g=k.find(I=>I.id===l);g&&P.removed.push(g)}}return P.added.length===0&&P.removed.length===0&&P.updated.length===0&&(P=null),{local:E,remote:P}}function _(T,k,L){T=T?T.filter(({id:d})=>!L.includes(d)):[],k=k.filter(({id:d})=>!L.includes(d));const D=T.map(({id:d})=>d),E=k.map(({id:d})=>d),P=E.filter(d=>!D.includes(d)),S=D.filter(d=>!E.includes(d)),m=[];for(const{id:d,name:l,shortName:g,icon:I,useDefaultFlags:v}of T){if(S.includes(d))continue;const f=k.find(C=>C.id===d);(!f||f.name!==l||f.shortName!==g||f.icon!==I||!(0,R.equals)(f.useDefaultFlags,v))&&m.push(d)}return{added:P,removed:S,updated:m}}}),define(he[24],fe([0,1,17,12,9,47,27,4,105,44]),function(ce,e,R,a,_,T,k,L,D,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PREVIEW_DIR_NAME=e.USER_DATA_SYNC_SCHEME=e.USER_DATA_SYNC_LOG_ID=e.IUserDataSyncLogService=e.IUserDataSyncUtilService=e.IUserDataAutoSyncService=e.IUserDataSyncResourceProviderService=e.IUserDataSyncService=e.IUserDataSyncEnablementService=e.SYNC_SERVICE_URL_TYPE=e.MergeState=e.Change=e.SyncStatus=e.UserDataAutoSyncError=e.UserDataSyncStoreError=e.UserDataSyncError=e.UserDataSyncErrorCode=e.HEADER_EXECUTION_ID=e.HEADER_OPERATION_ID=e.IUserDataSyncLocalStoreService=e.IUserDataSyncStoreService=e.IUserDataSyncStoreManagementService=e.ALL_SYNC_RESOURCES=e.SyncResource=e.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM=e.USER_DATA_SYNC_CONFIGURATION_SCOPE=void 0,e.getDisallowedIgnoredSettings=P,e.getDefaultIgnoredSettings=S,e.getIgnoredSettingsForExtension=m,e.registerConfiguration=l,e.isAuthenticationProvider=g,e.getPathSegments=v,e.getLastSyncResourceUri=f,e.createSyncHeaders=C,e.getEnablementKey=r;function P(){const o=E.Registry.as(T.Extensions.Configuration).getConfigurationProperties();return Object.keys(o).filter(h=>!!o[h].disallowSyncIgnore)}function S(o=!1){const h=E.Registry.as(T.Extensions.Configuration).getConfigurationProperties(),y=d(h,o),A=P();return(0,R.distinct)([...y,...A])}function m(o){if(!o.contributes?.configuration)return[];const h=Array.isArray(o.contributes.configuration)?o.contributes.configuration:[o.contributes.configuration];if(!h.length)return[];const y=(0,T.getAllConfigurationProperties)(h);return d(y,!1)}function d(o,h){const y=new Set;for(const A in o){if(h&&o[A].source)continue;const b=(0,a.isString)(o[A].scope)?(0,T.parseScope)(o[A].scope):o[A].scope;(o[A].ignoreSync||b===T.ConfigurationScope.MACHINE||b===T.ConfigurationScope.MACHINE_OVERRIDABLE)&&y.add(A)}return[...y.values()]}e.USER_DATA_SYNC_CONFIGURATION_SCOPE="settingsSync",e.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM="settingsSync.keybindingsPerPlatform";function l(){const o="vscode://schemas/ignoredSettings",h=E.Registry.as(T.Extensions.Configuration);h.registerConfiguration({id:"settingsSync",order:30,title:(0,_.localize)(2455,null),type:"object",properties:{[e.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM]:{type:"boolean",description:(0,_.localize)(2456,null),default:!0,scope:T.ConfigurationScope.APPLICATION,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredExtensions":{type:"array",markdownDescription:(0,_.localize)(2457,null),items:[{type:"string",pattern:k.EXTENSION_IDENTIFIER_PATTERN,errorMessage:(0,_.localize)(2458,null)}],default:[],scope:T.ConfigurationScope.APPLICATION,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredSettings":{type:"array",description:(0,_.localize)(2459,null),default:[],scope:T.ConfigurationScope.APPLICATION,$ref:o,additionalProperties:!0,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]}}});const y=E.Registry.as(D.Extensions.JSONContribution),A=()=>{const b=P(),w=S(),O=Object.keys(T.allSettings.properties).filter(M=>!w.includes(M)),F=w.filter(M=>!b.includes(M)),N={items:{type:"string",enum:[...O,...F.map(M=>`-${M}`)]}};y.registerSchema(o,N)};return h.onDidUpdateConfiguration(()=>A())}function g(o){return o&&(0,a.isObject)(o)&&(0,a.isString)(o.id)&&Array.isArray(o.scopes)}var I;(function(o){o.Settings="settings",o.Keybindings="keybindings",o.Snippets="snippets",o.Tasks="tasks",o.Extensions="extensions",o.GlobalState="globalState",o.Profiles="profiles",o.WorkspaceState="workspaceState"})(I||(e.SyncResource=I={})),e.ALL_SYNC_RESOURCES=[I.Settings,I.Keybindings,I.Snippets,I.Tasks,I.Extensions,I.GlobalState,I.Profiles];function v(o,...h){return o?[o,...h]:h}function f(o,h,y,A){return A.joinPath(y.userDataSyncHome,...v(o,h,`lastSync${h}.json`))}e.IUserDataSyncStoreManagementService=(0,L.createDecorator)("IUserDataSyncStoreManagementService"),e.IUserDataSyncStoreService=(0,L.createDecorator)("IUserDataSyncStoreService"),e.IUserDataSyncLocalStoreService=(0,L.createDecorator)("IUserDataSyncLocalStoreService"),e.HEADER_OPERATION_ID="x-operation-id",e.HEADER_EXECUTION_ID="X-Execution-Id";function C(o){const h={};return h[e.HEADER_EXECUTION_ID]=o,h}var p;(function(o){o.Unauthorized="Unauthorized",o.Forbidden="Forbidden",o.NotFound="NotFound",o.MethodNotFound="MethodNotFound",o.Conflict="Conflict",o.Gone="Gone",o.PreconditionFailed="PreconditionFailed",o.TooLarge="TooLarge",o.UpgradeRequired="UpgradeRequired",o.PreconditionRequired="PreconditionRequired",o.TooManyRequests="RemoteTooManyRequests",o.TooManyRequestsAndRetryAfter="TooManyRequestsAndRetryAfter",o.RequestFailed="RequestFailed",o.RequestCanceled="RequestCanceled",o.RequestTimeout="RequestTimeout",o.RequestProtocolNotSupported="RequestProtocolNotSupported",o.RequestPathNotEscaped="RequestPathNotEscaped",o.RequestHeadersNotObject="RequestHeadersNotObject",o.NoCollection="NoCollection",o.NoRef="NoRef",o.EmptyResponse="EmptyResponse",o.TurnedOff="TurnedOff",o.SessionExpired="SessionExpired",o.ServiceChanged="ServiceChanged",o.DefaultServiceChanged="DefaultServiceChanged",o.LocalTooManyProfiles="LocalTooManyProfiles",o.LocalTooManyRequests="LocalTooManyRequests",o.LocalPreconditionFailed="LocalPreconditionFailed",o.LocalInvalidContent="LocalInvalidContent",o.LocalError="LocalError",o.IncompatibleLocalContent="IncompatibleLocalContent",o.IncompatibleRemoteContent="IncompatibleRemoteContent",o.Unknown="Unknown"})(p||(e.UserDataSyncErrorCode=p={}));class c extends Error{constructor(h,y,A,b){super(h),this.code=y,this.resource=A,this.operationId=b,this.name=`${this.code} (UserDataSyncError) syncResource:${this.resource||"unknown"} operationId:${this.operationId||"unknown"}`}}e.UserDataSyncError=c;class u extends c{constructor(h,y,A,b,w){super(h,A,void 0,w),this.url=y,this.serverCode=b}}e.UserDataSyncStoreError=u;class i extends c{constructor(h,y){super(h,y)}}e.UserDataAutoSyncError=i,function(o){function h(y){if(y instanceof o)return y;const A=/^(.+) \(UserDataSyncError\) syncResource:(.+) operationId:(.+)$/.exec(y.name);if(A&&A[1]){const b=A[2]==="unknown"?void 0:A[2],w=A[3]==="unknown"?void 0:A[3];return new o(y.message,A[1],b,w)}return new o(y.message,p.Unknown)}o.toUserDataSyncError=h}(c||(e.UserDataSyncError=c={}));var n;(function(o){o.Uninitialized="uninitialized",o.Idle="idle",o.Syncing="syncing",o.HasConflicts="hasConflicts"})(n||(e.SyncStatus=n={}));var t;(function(o){o[o.None=0]="None",o[o.Added=1]="Added",o[o.Modified=2]="Modified",o[o.Deleted=3]="Deleted"})(t||(e.Change=t={}));var s;(function(o){o.Preview="preview",o.Conflict="conflict",o.Accepted="accepted"})(s||(e.MergeState=s={})),e.SYNC_SERVICE_URL_TYPE="sync.store.url.type";function r(o){return`sync.enable.${o}`}e.IUserDataSyncEnablementService=(0,L.createDecorator)("IUserDataSyncEnablementService"),e.IUserDataSyncService=(0,L.createDecorator)("IUserDataSyncService"),e.IUserDataSyncResourceProviderService=(0,L.createDecorator)("IUserDataSyncResourceProviderService"),e.IUserDataAutoSyncService=(0,L.createDecorator)("IUserDataAutoSyncService"),e.IUserDataSyncUtilService=(0,L.createDecorator)("IUserDataSyncUtilService"),e.IUserDataSyncLogService=(0,L.createDecorator)("IUserDataSyncLogService"),e.USER_DATA_SYNC_LOG_ID="userDataSync",e.USER_DATA_SYNC_SCHEME="vscode-userdata-sync",e.PREVIEW_DIR_NAME="preview"}),define(he[212],fe([0,1,29,24]),function(ce,e,R,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=_,R=De(R);function _(k,L,D,E,P){if(!L)return{remote:{added:Object.keys(k),removed:[],updated:[],all:Object.keys(k).length>0?k:null},local:{added:{},removed:[],updated:{}}};const S=T(k,L);if(S.added.size===0&&S.removed.size===0&&S.updated.size===0)return{remote:{added:[],removed:[],updated:[],all:null},local:{added:{},removed:[],updated:{}}};const m=D?T(D,L):{added:Object.keys(L).reduce((f,C)=>(f.add(C),f),new Set),removed:new Set,updated:new Set},d=D?T(D,k):{added:Object.keys(k).reduce((f,C)=>(f.add(C),f),new Set),removed:new Set,updated:new Set},l={added:{},removed:[],updated:{}},g=R.deepClone(L),I=!D;for(const f of d.added.values())f!==a.SYNC_SERVICE_URL_TYPE&&I&&m.added.has(f)||(g[f]=k[f]);for(const f of d.updated.values())g[f]=k[f];for(const f of d.removed.values())E.unregistered.includes(f)||delete g[f];for(const f of m.added.values()){const C=L[f];if(E.machine.includes(f)){P.info(`GlobalState: Skipped adding ${f} in local storage because it is declared as machine scoped.`);continue}if(D&&d.added.has(f))continue;const p=k[f];p&&p.value===C.value||f===a.SYNC_SERVICE_URL_TYPE&&I&&d.added.has(f)||(p?l.updated[f]=C:l.added[f]=C)}for(const f of m.updated.values()){const C=L[f];if(E.machine.includes(f)){P.info(`GlobalState: Skipped updating ${f} in local storage because it is declared as machine scoped.`);continue}if(d.updated.has(f)||d.removed.has(f))continue;const p=k[f];p&&p.value===C.value||(l.updated[f]=C)}for(const f of m.removed.values()){if(E.machine.includes(f)){P.trace(`GlobalState: Skipped removing ${f} in local storage because it is declared as machine scoped.`);continue}d.updated.has(f)||d.removed.has(f)||l.removed.push(f)}const v=T(L,g);return{local:l,remote:{added:[...v.added],updated:[...v.updated],removed:[...v.removed],all:v.added.size===0&&v.removed.size===0&&v.updated.size===0?null:g}}}function T(k,L){const D=Object.keys(k),E=Object.keys(L),P=E.filter(d=>!D.includes(d)).reduce((d,l)=>(d.add(l),d),new Set),S=D.filter(d=>!E.includes(d)).reduce((d,l)=>(d.add(l),d),new Set),m=new Set;for(const d of D){if(S.has(d))continue;const l=k[d],g=L[d];R.equals(l,g)||m.add(d)}return{added:P,removed:S,updated:m}}}),define(he[213],fe([0,1,17,36,64,45,29,82,24]),function(ce,e,R,a,_,T,k,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getIgnoredSettings=E,e.removeComments=m,e.updateIgnoredSettings=d,e.merge=l,e.isEmpty=I,e.addSetting=f,k=De(k),L=De(L);function E(o,h,y){let A=[];y?A=S(y):A=P(h);const b=[],w=[...(0,D.getDisallowedIgnoredSettings)()];if(Array.isArray(A))for(const O of A)O.startsWith("-")?w.push(O.substring(1)):b.push(O);return(0,R.distinct)([...o,...b].filter(O=>!w.includes(O)))}function P(o){let h=o.inspect("settingsSync.ignoredSettings").userValue;return h!==void 0||(h=o.inspect("sync.ignoredSettings").userValue,h!==void 0)?h:o.getValue("settingsSync.ignoredSettings")||[]}function S(o){const h=(0,a.parse)(o);return h?h["settingsSync.ignoredSettings"]||h["sync.ignoredSettings"]||[]:[]}function m(o,h){const y=(0,a.parse)(o)||{};let A="{}";for(const b of Object.keys(y)){const w=(0,_.setProperty)(A,[b],y[b],h);A=(0,_.applyEdits)(A,w)}return A}function d(o,h,y,A){if(y.length){const b=r(h),w=(0,a.parse)(h)||{},O=(0,a.parse)(o);if(!O)return o;const F=[];for(const N of y){const M=w[N],V=O[N];M===void 0?o=L.edit(o,[N],void 0,A):V!==void 0?o=L.edit(o,[N],M,A):F.push(u(N,b))}F.sort((N,M)=>N.startOffset-M.startOffset),F.forEach(N=>o=f(N.setting.key,h,o,A))}return o}function l(o,h,y,A,b,w){const O=d(o,h,A,w),F=y!==O,N=y!==h;if(!F&&!N)return{conflictsSettings:[],localContent:null,remoteContent:null,hasConflicts:!1};if(F&&!N)return{conflictsSettings:[],localContent:null,remoteContent:O,hasConflicts:!1};if(N&&!F)return{conflictsSettings:[],localContent:d(h,o,A,w),remoteContent:null,hasConflicts:!1};if(y===null&&I(o)){const U=g(o,h,A)?null:d(h,o,A,w);return{conflictsSettings:[],localContent:U,remoteContent:null,hasConflicts:!1}}let M=o,V=h;const z=(0,a.parse)(o),J=(0,a.parse)(h),j=y?(0,a.parse)(y):null,te=A.reduce((U,G)=>(U.add(G),U),new Set),q=v(z,J,te),B=v(j,z,te),Z=v(j,J,te),ne=new Map,le=new Set,ee=U=>{le.add(U);const G=b.filter(({key:oe})=>oe===U)[0];G?(M=L.edit(M,[U],G.value,w),V=L.edit(V,[U],G.value,w)):ne.set(U,{key:U,localValue:z[U],remoteValue:J[U]})};for(const U of B.removed.values())Z.updated.has(U)?ee(U):V=L.edit(V,[U],void 0,w);for(const U of Z.removed.values())le.has(U)||(B.updated.has(U)?ee(U):M=L.edit(M,[U],void 0,w));for(const U of B.updated.values())le.has(U)||(Z.updated.has(U)?q.updated.has(U)&&ee(U):V=L.edit(V,[U],z[U],w));for(const U of Z.updated.values())le.has(U)||(B.updated.has(U)?q.updated.has(U)&&ee(U):M=L.edit(M,[U],J[U],w));for(const U of B.added.values())le.has(U)||(Z.added.has(U)?q.updated.has(U)&&ee(U):V=f(U,M,V,w));for(const U of Z.added.values())le.has(U)||(B.added.has(U)?q.updated.has(U)&&ee(U):M=f(U,V,M,w));const K=ne.size>0||!g(M,V,A),H=K||!g(M,o,[]),W=K||!g(V,h,[]);return{localContent:H?M:null,remoteContent:W?V:null,conflictsSettings:[...ne.values()],hasConflicts:K}}function g(o,h,y){if(o===h)return!0;const A=(0,a.parse)(o),b=(0,a.parse)(h),w=y.reduce((N,M)=>(N.add(M),N),new Set),O=r(o).filter(N=>!(N.setting&&w.has(N.setting.key))),F=r(h).filter(N=>!(N.setting&&w.has(N.setting.key)));if(O.length!==F.length)return!1;for(let N=0;N<O.length;N++){const M=O[N],V=F[N];if(M.setting&&V.setting){if(M.setting.key!==V.setting.key||!k.equals(A[M.setting.key],b[M.setting.key]))return!1}else if(!M.setting&&!V.setting){if(M.value!==V.value)return!1}else return!1}return!0}function I(o){return o?r(o).length===0:!0}function v(o,h,y){const A=o?Object.keys(o).filter(N=>!y.has(N)):[],b=Object.keys(h).filter(N=>!y.has(N)),w=b.filter(N=>!A.includes(N)).reduce((N,M)=>(N.add(M),N),new Set),O=A.filter(N=>!b.includes(N)).reduce((N,M)=>(N.add(M),N),new Set),F=new Set;if(o)for(const N of A){if(O.has(N))continue;const M=o[N],V=h[N];k.equals(M,V)||F.add(N)}return{added:w,removed:O,updated:F}}function f(o,h,y,A){const b=(0,a.parse)(h),w=r(h),O=r(y),F=C(o,w,O);return p(y,o,b[o],F,O,A)}function C(o,h,y){const A=h.findIndex(w=>w.setting?.key===o),b=h[A-1];if(b){if(b.setting){const O=u(b.setting.key,y);if(O)return{index:y.indexOf(O),insertAfter:!0}}else{const O=i(A,h);if(O){const F=u(O.setting.key,y);if(F){const N=n(y.indexOf(F),y),M=t(h,O,h[A]);if(N){const V=t(y,F,N),z=s(M,V);return z?{index:y.indexOf(z),insertAfter:!0}:{index:y.indexOf(N),insertAfter:!1}}else{const V=t(y,F,y[y.length-1]),z=s(M,V);return z?{index:y.indexOf(z),insertAfter:!0}:{index:y.length-1,insertAfter:!0}}}}}const w=h[A+1];if(w)if(w.setting){const O=u(w.setting.key,y);if(O)return{index:y.indexOf(O),insertAfter:!1}}else{const O=n(A,h);if(O){const F=u(O.setting.key,y);if(F){const N=i(y.indexOf(F),y),M=t(h,h[A],O);if(N){const V=t(y,N,F),z=s(M.reverse(),V.reverse());return z?{index:y.indexOf(z),insertAfter:!1}:{index:y.indexOf(N),insertAfter:!0}}else{const V=t(y,y[0],F),z=s(M.reverse(),V.reverse());return z?{index:y.indexOf(z),insertAfter:!1}:{index:0,insertAfter:!1}}}}}}return{index:y.length-1,insertAfter:!0}}function p(o,h,y,A,b,w){let O;return A.index===-1?O=(0,_.setProperty)(o,[h],y,w):O=c(o,h,y,A,b,w).map(F=>(0,_.withFormatting)(o,F,w)[0]),(0,_.applyEdits)(o,O)}function c(o,h,y,A,b,w){const O=`${JSON.stringify(h)}: ${JSON.stringify(y)}`,F=(0,T.getEOL)(w,o),N=b[A.index];if(A.insertAfter){const M=[];if(N.setting)M.push({offset:N.endOffset,length:0,content:","+O});else{const V=n(A.index,b),z=i(A.index,b),J=z?.setting?.commaOffset;z&&J===void 0&&M.push({offset:z.endOffset,length:0,content:","});const j=J!==void 0&&J>N.endOffset;M.push({offset:j?J+1:N.endOffset,length:0,content:V?F+O+",":F+O})}return M}else{if(N.setting)return[{offset:N.startOffset,length:0,content:O+","}];const M=(b[A.index-1]&&!b[A.index-1].setting?F:"")+O+(n(A.index,b)?",":"")+F;return[{offset:N.startOffset,length:0,content:M}]}}function u(o,h){return h.filter(y=>y.setting?.key===o)[0]}function i(o,h){for(let y=o-1;y>=0;y--)if(h[y].setting)return h[y]}function n(o,h){for(let y=o+1;y<h.length;y++)if(h[y].setting)return h[y]}function t(o,h,y){const A=o.indexOf(h),b=o.indexOf(y);return o.filter((w,O)=>A<O&&O<b)}function s(o,h){if(o.length&&h.length){let y=0;for(;y<h.length&&y<o.length;y++)if(o[y].value!==h[y].value)return h[y-1];return h[y-1]}}function r(o){const h=[];let y=-1,A,b;const w={onObjectBegin:O=>{y++},onObjectProperty:(O,F,N)=>{y===0&&(A=F,b=O)},onObjectEnd:(O,F)=>{y--,y===0&&h.push({startOffset:A,endOffset:O+F,value:o.substring(A,O+F),setting:{key:b,commaOffset:void 0}})},onArrayBegin:(O,F)=>{y++},onArrayEnd:(O,F)=>{y--,y===0&&h.push({startOffset:A,endOffset:O+F,value:o.substring(A,O+F),setting:{key:b,commaOffset:void 0}})},onLiteralValue:(O,F,N)=>{y===0&&h.push({startOffset:A,endOffset:F+N,value:o.substring(A,F+N),setting:{key:b,commaOffset:void 0}})},onSeparator:(O,F,N)=>{if(y===0&&O===","){let M=h.length-1;for(;M>=0&&!h[M].setting;M--);const V=h[M];V&&h.splice(M,1,{startOffset:V.startOffset,endOffset:V.endOffset,value:V.value,setting:{key:V.setting.key,commaOffset:F}})}},onComment:(O,F)=>{y===0&&h.push({startOffset:O,endOffset:O+F,value:o.substring(O,O+F)})}};return(0,a.visit)(o,w),h}}),define(he[83],fe([0,1,3,2,4,24]),function(ce,e,R,a,_,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncAccountService=e.IUserDataSyncAccountService=void 0,e.IUserDataSyncAccountService=(0,_.createDecorator)("IUserDataSyncAccountService");let k=class extends a.Disposable{get account(){return this._account}constructor(D,E){super(),this.userDataSyncStoreService=D,this.logService=E,this._onDidChangeAccount=this._register(new R.Emitter),this.onDidChangeAccount=this._onDidChangeAccount.event,this._onTokenFailed=this._register(new R.Emitter),this.onTokenFailed=this._onTokenFailed.event,this.wasTokenFailed=!1,this._register(D.onTokenFailed(P=>{this.logService.info("Settings Sync auth token failed",this.account?.authenticationProviderId,this.wasTokenFailed,P),this.updateAccount(void 0),P===T.UserDataSyncErrorCode.Forbidden?this._onTokenFailed.fire(!0):this._onTokenFailed.fire(this.wasTokenFailed),this.wasTokenFailed=!0})),this._register(D.onTokenSucceed(()=>this.wasTokenFailed=!1))}async updateAccount(D){(D&&this._account?D.token!==this._account.token||D.authenticationProviderId!==this._account.authenticationProviderId:D!==this._account)&&(this._account=D,this._account&&this.userDataSyncStoreService.setAuthToken(this._account.token,this._account.authenticationProviderId),this._onDidChangeAccount.fire(D))}};e.UserDataSyncAccountService=k,e.UserDataSyncAccountService=k=Ie([Y(0,T.IUserDataSyncStoreService),Y(1,T.IUserDataSyncLogService)],k)}),define(he[214],fe([0,1,20,9,15,11,24]),function(ce,e,R,a,_,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncLogService=void 0;let L=class extends T.AbstractLogger{constructor(E,P){super(),this.logger=this._register(E.createLogger((0,R.joinPath)(P.logsHome,`${k.USER_DATA_SYNC_LOG_ID}.log`),{id:k.USER_DATA_SYNC_LOG_ID,name:(0,a.localize)(2460,null)}))}trace(E,...P){this.logger.trace(E,...P)}debug(E,...P){this.logger.debug(E,...P)}info(E,...P){this.logger.info(E,...P)}warn(E,...P){this.logger.warn(E,...P)}error(E,...P){this.logger.error(E,...P)}flush(){this.logger.flush()}};e.UserDataSyncLogService=L,e.UserDataSyncLogService=L=Ie([Y(0,T.ILoggerService),Y(1,_.IEnvironmentService)],L)}),define(he[215],fe([0,1,6,3,2]),function(ce,e,R,a,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class T extends _.Disposable{constructor({onDidOpenMainWindow:L,onDidFocusMainWindow:D,getActiveWindowId:E}){super(),this.disposables=this._register(new _.DisposableStore),a.Event.latch(a.Event.any(L,D))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=(0,R.createCancelablePromise)(()=>E()),(async()=>{try{const S=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:S}catch{}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(L){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=L}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=T}),define(he[117],fe([0,1,9,13,51,20,10,4,22]),function(ce,e,R,a,_,T,k,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.STANDALONE_EDITOR_WORKSPACE_ID=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.WorkspaceFolder=e.Workspace=e.WorkbenchState=e.UNKNOWN_EMPTY_WINDOW_WORKSPACE=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.IWorkspaceContextService=void 0,e.isSingleFolderWorkspaceIdentifier=E,e.isEmptyWorkspaceIdentifier=P,e.toWorkspaceIdentifier=S,e.isWorkspaceIdentifier=m,e.reviveIdentifier=d,e.isWorkspace=g,e.isWorkspaceFolder=I,e.toWorkspaceFolder=C,e.isUntitledWorkspace=p,e.isTemporaryWorkspace=c,e.isStandaloneEditorWorkspace=u,e.isSavedWorkspace=i,e.hasWorkspaceFileExtension=n,e.IWorkspaceContextService=(0,L.createDecorator)("contextService");function E(t){const s=t;return typeof s?.id=="string"&&k.URI.isUri(s.uri)}function P(t){return typeof t?.id=="string"&&!E(t)&&!m(t)}e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"},e.UNKNOWN_EMPTY_WINDOW_WORKSPACE={id:"empty-window"};function S(t,s){if(typeof t=="string"||typeof t>"u")return typeof t=="string"?{id:(0,a.basename)(t)}:s?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:e.UNKNOWN_EMPTY_WINDOW_WORKSPACE;const r=t;return r.configuration?{id:r.id,configPath:r.configuration}:r.folders.length===1?{id:r.id,uri:r.folders[0].uri}:{id:r.id}}function m(t){const s=t;return typeof s?.id=="string"&&k.URI.isUri(s.configPath)}function d(t){const s=t;if(s?.uri)return{id:s.id,uri:k.URI.revive(s.uri)};const r=t;if(r?.configPath)return{id:r.id,configPath:k.URI.revive(r.configPath)};if(t?.id)return{id:t.id}}var l;(function(t){t[t.EMPTY=1]="EMPTY",t[t.FOLDER=2]="FOLDER",t[t.WORKSPACE=3]="WORKSPACE"})(l||(e.WorkbenchState=l={}));function g(t){const s=t;return!!(s&&typeof s=="object"&&typeof s.id=="string"&&Array.isArray(s.folders))}function I(t){const s=t;return!!(s&&typeof s=="object"&&k.URI.isUri(s.uri)&&typeof s.name=="string"&&typeof s.toResource=="function")}class v{constructor(s,r,o,h,y){this._id=s,this._transient=o,this._configuration=h,this._ignorePathCasing=y,this._foldersMap=_.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0),this.folders=r}update(s){this._id=s.id,this._configuration=s.configuration,this._transient=s.transient,this._ignorePathCasing=s._ignorePathCasing,this.folders=s.folders}get folders(){return this._folders}set folders(s){this._folders=s,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(s){this._configuration=s}getFolder(s){return s&&this._foldersMap.findSubstr(s)||null}updateFoldersMap(){this._foldersMap=_.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0);for(const s of this.folders)this._foldersMap.set(s.uri,s)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=v;class f{constructor(s,r){this.raw=r,this.uri=s.uri,this.index=s.index,this.name=s.name}toResource(s){return(0,T.joinPath)(this.uri,s)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=f;function C(t){return new f({uri:t,index:0,name:(0,T.basenameOrAuthority)(t)},{uri:t.toString()})}e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,R.localize)(2489,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function p(t,s){return T.extUriBiasedIgnorePathCase.isEqualOrParent(t,s.untitledWorkspacesHome)}function c(t){let s;return k.URI.isUri(t)?s=t:s=t.configuration,s?.scheme===D.Schemas.tmp}e.STANDALONE_EDITOR_WORKSPACE_ID="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function u(t){return t.id===e.STANDALONE_EDITOR_WORKSPACE_ID}function i(t,s){return!p(t,s)&&!c(t)}function n(t){return(typeof t=="string"?(0,a.extname)(t):(0,T.extname)(t))===e.WORKSPACE_SUFFIX}}),define(he[19],fe([0,1,55,3,2,20,10,9,15,7,4,11,117,31,28,6,32,26,12]),function(ce,e,R,a,_,T,k,L,D,E,P,S,m,d,l,g,I,v,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryUserDataProfilesService=e.UserDataProfilesService=e.IUserDataProfilesService=e.ProfileResourceType=void 0,e.isUserDataProfile=p,e.reviveProfile=c,e.toUserDataProfile=u;var C;(function(t){t.Settings="settings",t.Keybindings="keybindings",t.Snippets="snippets",t.Tasks="tasks",t.Extensions="extensions",t.GlobalState="globalState"})(C||(e.ProfileResourceType=C={}));function p(t){const s=t;return!!(s&&typeof s=="object"&&typeof s.id=="string"&&typeof s.isDefault=="boolean"&&typeof s.name=="string"&&k.URI.isUri(s.location)&&k.URI.isUri(s.globalStorageHome)&&k.URI.isUri(s.settingsResource)&&k.URI.isUri(s.keybindingsResource)&&k.URI.isUri(s.tasksResource)&&k.URI.isUri(s.snippetsHome)&&k.URI.isUri(s.extensionsResource))}e.IUserDataProfilesService=(0,P.createDecorator)("IUserDataProfilesService");function c(t,s){return{id:t.id,isDefault:t.isDefault,name:t.name,shortName:t.shortName,icon:t.icon,location:k.URI.revive(t.location).with({scheme:s}),globalStorageHome:k.URI.revive(t.globalStorageHome).with({scheme:s}),settingsResource:k.URI.revive(t.settingsResource).with({scheme:s}),keybindingsResource:k.URI.revive(t.keybindingsResource).with({scheme:s}),tasksResource:k.URI.revive(t.tasksResource).with({scheme:s}),snippetsHome:k.URI.revive(t.snippetsHome).with({scheme:s}),extensionsResource:k.URI.revive(t.extensionsResource).with({scheme:s}),cacheHome:k.URI.revive(t.cacheHome).with({scheme:s}),useDefaultFlags:t.useDefaultFlags,isTransient:t.isTransient}}function u(t,s,r,o,h,y){return{id:t,name:s,location:r,isDefault:!1,shortName:h?.shortName,icon:h?.icon,globalStorageHome:y&&h?.useDefaultFlags?.globalState?y.globalStorageHome:(0,T.joinPath)(r,"globalStorage"),settingsResource:y&&h?.useDefaultFlags?.settings?y.settingsResource:(0,T.joinPath)(r,"settings.json"),keybindingsResource:y&&h?.useDefaultFlags?.keybindings?y.keybindingsResource:(0,T.joinPath)(r,"keybindings.json"),tasksResource:y&&h?.useDefaultFlags?.tasks?y.tasksResource:(0,T.joinPath)(r,"tasks.json"),snippetsHome:y&&h?.useDefaultFlags?.snippets?y.snippetsHome:(0,T.joinPath)(r,"snippets"),extensionsResource:y&&h?.useDefaultFlags?.extensions?y.extensionsResource:(0,T.joinPath)(r,"extensions.json"),cacheHome:(0,T.joinPath)(o,t),useDefaultFlags:h?.useDefaultFlags,isTransient:h?.transient}}let i=class extends _.Disposable{static{this.PROFILES_KEY="userDataProfiles"}static{this.PROFILE_ASSOCIATIONS_KEY="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.profilesObject.profiles,...this.transientProfilesObject.profiles]}constructor(s,r,o,h){super(),this.environmentService=s,this.fileService=r,this.uriIdentityService=o,this.logService=h,this.enabled=!0,this._onDidChangeProfiles=this._register(new a.Emitter),this.onDidChangeProfiles=this._onDidChangeProfiles.event,this._onWillCreateProfile=this._register(new a.Emitter),this.onWillCreateProfile=this._onWillCreateProfile.event,this._onWillRemoveProfile=this._register(new a.Emitter),this.onWillRemoveProfile=this._onWillRemoveProfile.event,this._onDidResetWorkspaces=this._register(new a.Emitter),this.onDidResetWorkspaces=this._onDidResetWorkspaces.event,this.profileCreationPromises=new Map,this.transientProfilesObject={profiles:[],folders:new d.ResourceMap,workspaces:new d.ResourceMap,emptyWindows:new Map},this.profilesHome=(0,T.joinPath)(this.environmentService.userRoamingDataHome,"profiles"),this.profilesCacheHome=(0,T.joinPath)(this.environmentService.cacheHome,"CachedProfilesData")}init(){this._profilesObject=void 0}setEnablement(s){this.enabled!==s&&(this._profilesObject=void 0,this.enabled=s)}isEnabled(){return this.enabled}get profilesObject(){if(!this._profilesObject){const s=this.createDefaultProfile(),r=[s];if(this.enabled)try{for(const y of this.getStoredProfiles()){if(!y.name||!(0,f.isString)(y.name)||!y.location){this.logService.warn("Skipping the invalid stored profile",y.location||y.name);continue}r.push(u((0,T.basename)(y.location),y.name,y.location,this.profilesCacheHome,{shortName:y.shortName,icon:y.icon,useDefaultFlags:y.useDefaultFlags},s))}}catch(y){this.logService.error(y)}const o=new d.ResourceMap,h=new Map;if(r.length)try{const y=this.getStoredProfileAssociations();if(y.workspaces)for(const[A,b]of Object.entries(y.workspaces)){const w=k.URI.parse(A),O=r.find(F=>F.id===b);O&&o.set(w,O)}if(y.emptyWindows)for(const[A,b]of Object.entries(y.emptyWindows)){const w=r.find(O=>O.id===b);w&&h.set(A,w)}}catch(y){this.logService.error(y)}this._profilesObject={profiles:r,workspaces:o,emptyWindows:h}}return this._profilesObject}createDefaultProfile(){const s=u("__default__profile__",(0,L.localize)(2442,null),this.environmentService.userRoamingDataHome,this.profilesCacheHome);return{...s,extensionsResource:this.getDefaultProfileExtensionsLocation()??s.extensionsResource,isDefault:!0}}async createTransientProfile(s){const r="Temp",o=new RegExp(`${(0,v.escapeRegExpCharacters)(r)}\\s(\\d+)`);let h=0;for(const A of this.profiles){const b=o.exec(A.name),w=b?parseInt(b[1]):0;h=w>h?w:h}const y=`${r} ${h+1}`;return this.createProfile((0,R.hash)((0,I.generateUuid)()).toString(16),y,{transient:!0},s)}async createNamedProfile(s,r,o){return this.createProfile((0,R.hash)((0,I.generateUuid)()).toString(16),s,r,o)}async createProfile(s,r,o,h){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");const y=await this.doCreateProfile(s,r,o);return h&&await this.setProfileForWorkspace(h,y),y}async doCreateProfile(s,r,o){if(!(0,f.isString)(r)||!r)throw new Error("Name of the profile is mandatory and must be of type `string`");let h=this.profileCreationPromises.get(r);return h||(h=(async()=>{try{if(this.profiles.find(w=>w.name===r||w.id===s))throw new Error(`Profile with ${r} name already exists`);const A=u(s,r,(0,T.joinPath)(this.profilesHome,s),this.profilesCacheHome,o,this.defaultProfile);await this.fileService.createFolder(A.location);const b=[];return this._onWillCreateProfile.fire({profile:A,join(w){b.push(w)}}),await g.Promises.settled(b),this.updateProfiles([A],[],[]),A}finally{this.profileCreationPromises.delete(r)}})(),this.profileCreationPromises.set(r,h)),h}async updateProfile(s,r){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");let o=this.profiles.find(h=>h.id===s.id);if(!o)throw new Error(`Profile '${s.name}' does not exist`);return o=u(o.id,r.name??o.name,o.location,this.profilesCacheHome,{shortName:r.shortName??o.shortName,icon:r.icon===null?void 0:r.icon??o.icon,transient:r.transient??o.isTransient,useDefaultFlags:r.useDefaultFlags??o.useDefaultFlags},this.defaultProfile),this.updateProfiles([],[],[o]),o}async removeProfile(s){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");if(s.isDefault)throw new Error("Cannot remove default profile");const r=this.profiles.find(h=>h.id===s.id);if(!r)throw new Error(`Profile '${s.name}' does not exist`);const o=[];this._onWillRemoveProfile.fire({profile:r,join(h){o.push(h)}});try{await Promise.allSettled(o)}catch(h){this.logService.error(h)}for(const h of[...this.profilesObject.emptyWindows.keys()])r.id===this.profilesObject.emptyWindows.get(h)?.id&&this.profilesObject.emptyWindows.delete(h);for(const h of[...this.profilesObject.workspaces.keys()])r.id===this.profilesObject.workspaces.get(h)?.id&&this.profilesObject.workspaces.delete(h);this.updateStoredProfileAssociations(),this.updateProfiles([],[r],[]);try{await this.fileService.del(r.cacheHome,{recursive:!0})}catch(h){(0,E.toFileOperationResult)(h)!==E.FileOperationResult.FILE_NOT_FOUND&&this.logService.error(h)}}async setProfileForWorkspace(s,r){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");const o=this.profiles.find(h=>h.id===r.id);if(!o)throw new Error(`Profile '${r.name}' does not exist`);this.updateWorkspaceAssociation(s,o)}unsetWorkspace(s,r){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");this.updateWorkspaceAssociation(s,void 0,r)}async resetWorkspaces(){this.transientProfilesObject.folders.clear(),this.transientProfilesObject.workspaces.clear(),this.transientProfilesObject.emptyWindows.clear(),this.profilesObject.workspaces.clear(),this.profilesObject.emptyWindows.clear(),this.updateStoredProfileAssociations(),this._onDidResetWorkspaces.fire()}async cleanUp(){if(this.enabled&&await this.fileService.exists(this.profilesHome)){const s=await this.fileService.resolve(this.profilesHome);await Promise.all((s.children||[]).filter(r=>r.isDirectory&&this.profiles.every(o=>!this.uriIdentityService.extUri.isEqual(o.location,r.resource))).map(r=>this.fileService.del(r.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.enabled)return;const s=this.transientProfilesObject.profiles.filter(r=>!this.isProfileAssociatedToWorkspace(r));await Promise.allSettled(s.map(r=>this.removeProfile(r)))}getProfileForWorkspace(s){const r=this.getWorkspace(s),o=k.URI.isUri(r)?this.profilesObject.workspaces.get(r):this.profilesObject.emptyWindows.get(r);return o||((0,m.isSingleFolderWorkspaceIdentifier)(s)?this.transientProfilesObject.folders.get(s.uri):(0,m.isWorkspaceIdentifier)(s)?this.transientProfilesObject.workspaces.get(s.configPath):this.transientProfilesObject.emptyWindows.get(s.id))}getWorkspace(s){return(0,m.isSingleFolderWorkspaceIdentifier)(s)?s.uri:(0,m.isWorkspaceIdentifier)(s)?s.configPath:s.id}isProfileAssociatedToWorkspace(s){return!!([...this.profilesObject.emptyWindows.values()].some(r=>this.uriIdentityService.extUri.isEqual(r.location,s.location))||[...this.profilesObject.workspaces.values()].some(r=>this.uriIdentityService.extUri.isEqual(r.location,s.location))||[...this.transientProfilesObject.emptyWindows.values()].some(r=>this.uriIdentityService.extUri.isEqual(r.location,s.location))||[...this.transientProfilesObject.workspaces.values()].some(r=>this.uriIdentityService.extUri.isEqual(r.location,s.location))||[...this.transientProfilesObject.folders.values()].some(r=>this.uriIdentityService.extUri.isEqual(r.location,s.location)))}updateProfiles(s,r,o){const h=[...this.profiles,...s],y=[],A=this.transientProfilesObject.profiles;this.transientProfilesObject.profiles=[];for(let b of h){if(b.isDefault||r.some(O=>b.id===O.id))continue;b=o.find(O=>b.id===O.id)??b;const w=A.find(O=>b.id===O.id);if(b.isTransient)this.transientProfilesObject.profiles.push(b);else{if(w){for(const[O,F]of this.transientProfilesObject.emptyWindows.entries())if(b.id===F.id){this.updateWorkspaceAssociation({id:O},b);break}for(const[O,F]of this.transientProfilesObject.workspaces.entries())if(b.id===F.id){this.updateWorkspaceAssociation({id:"",configPath:O},b);break}for(const[O,F]of this.transientProfilesObject.folders.entries())if(b.id===F.id){this.updateWorkspaceAssociation({id:"",uri:O},b);break}}y.push({location:b.location,name:b.name,shortName:b.shortName,icon:b.icon,useDefaultFlags:b.useDefaultFlags})}}this.saveStoredProfiles(y),this._profilesObject=void 0,this.triggerProfilesChanges(s,r,o)}triggerProfilesChanges(s,r,o){this._onDidChangeProfiles.fire({added:s,removed:r,updated:o,all:this.profiles})}updateWorkspaceAssociation(s,r,o){if(o=r?.isTransient?!0:o,o)(0,m.isSingleFolderWorkspaceIdentifier)(s)?(this.transientProfilesObject.folders.delete(s.uri),r&&this.transientProfilesObject.folders.set(s.uri,r)):(0,m.isWorkspaceIdentifier)(s)?(this.transientProfilesObject.workspaces.delete(s.configPath),r&&this.transientProfilesObject.workspaces.set(s.configPath,r)):(this.transientProfilesObject.emptyWindows.delete(s.id),r&&this.transientProfilesObject.emptyWindows.set(s.id,r));else{this.updateWorkspaceAssociation(s,void 0,!0);const h=this.getWorkspace(s);k.URI.isUri(h)?(this.profilesObject.workspaces.delete(h),r&&this.profilesObject.workspaces.set(h,r)):(this.profilesObject.emptyWindows.delete(h),r&&this.profilesObject.emptyWindows.set(h,r)),this.updateStoredProfileAssociations()}}updateStoredProfileAssociations(){const s={};for(const[o,h]of this.profilesObject.workspaces.entries())s[o.toString()]=h.id;const r={};for(const[o,h]of this.profilesObject.emptyWindows.entries())r[o.toString()]=h.id;this.saveStoredProfileAssociations({workspaces:s,emptyWindows:r}),this._profilesObject=void 0}migrateStoredProfileAssociations(s){const r={},o=this.createDefaultProfile();if(s.workspaces)for(const[y,A]of Object.entries(s.workspaces)){const b=k.URI.parse(A);r[y]=this.uriIdentityService.extUri.isEqual(b,o.location)?o.id:this.uriIdentityService.extUri.basename(b)}const h={};if(s.emptyWindows)for(const[y,A]of Object.entries(s.emptyWindows)){const b=k.URI.parse(A);h[y]=this.uriIdentityService.extUri.isEqual(b,o.location)?o.id:this.uriIdentityService.extUri.basename(b)}return{workspaces:r,emptyWindows:h}}getStoredProfiles(){return[]}saveStoredProfiles(s){throw new Error("not implemented")}getStoredProfileAssociations(){return{}}saveStoredProfileAssociations(s){throw new Error("not implemented")}getDefaultProfileExtensionsLocation(){}};e.UserDataProfilesService=i,e.UserDataProfilesService=i=Ie([Y(0,D.IEnvironmentService),Y(1,E.IFileService),Y(2,l.IUriIdentityService),Y(3,S.ILogService)],i);class n extends i{constructor(){super(...arguments),this.storedProfiles=[],this.storedProfileAssociations={}}getStoredProfiles(){return this.storedProfiles}saveStoredProfiles(s){this.storedProfiles=s}getStoredProfileAssociations(){return this.storedProfileAssociations}saveStoredProfileAssociations(s){this.storedProfileAssociations=s}}e.InMemoryUserDataProfilesService=n}),define(he[216],fe([0,1,6,2,19]),function(ce,e,R,a,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesCleaner=void 0;let T=class extends a.Disposable{constructor(L){super(),this._register(new R.RunOnceScheduler(()=>{L.cleanUp()},10*1e3)).schedule()}};e.UserDataProfilesCleaner=T,e.UserDataProfilesCleaner=T=Ie([Y(0,_.IUserDataProfilesService)],T)}),define(he[84],fe([0,1,17,6,25,8,3,2,31,5,12,10,9,27,35,34,59,11,23,18,28,19]),function(ce,e,R,a,_,T,k,L,D,E,P,S,m,d,l,g,I,v,f,C,p,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionTask=e.AbstractExtensionManagementService=void 0,e.toExtensionManagementError=i,m=De(m);let u=class extends L.Disposable{get onInstallExtension(){return this._onInstallExtension.event}get onDidInstallExtensions(){return this._onDidInstallExtensions.event}get onUninstallExtension(){return this._onUninstallExtension.event}get onDidUninstallExtension(){return this._onDidUninstallExtension.event}get onDidUpdateExtensionMetadata(){return this._onDidUpdateExtensionMetadata.event}constructor(r,o,h,y,A,b){super(),this.galleryService=r,this.telemetryService=o,this.uriIdentityService=h,this.logService=y,this.productService=A,this.userDataProfilesService=b,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new k.Emitter),this._onDidInstallExtensions=this._register(new k.Emitter),this._onUninstallExtension=this._register(new k.Emitter),this._onDidUninstallExtension=this._register(new k.Emitter),this._onDidUpdateExtensionMetadata=this._register(new k.Emitter),this.participants=[],this._register((0,L.toDisposable)(()=>{this.installingExtensions.forEach(({task:w})=>w.cancel()),this.uninstallingExtensions.forEach(w=>w.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async canInstall(r){const o=await this.getTargetPlatform();return r.allTargetPlatforms.some(h=>(0,d.isTargetPlatformCompatible)(h,r.allTargetPlatforms,o))}async installFromGallery(r,o={}){try{const y=(await this.installGalleryExtensions([{extension:r,options:o}])).find(({identifier:A})=>(0,l.areSameExtensions)(A,r.identifier));if(y?.local)return y?.local;throw y?.error?y.error:new d.ExtensionManagementError(`Unknown error while installing extension ${r.identifier.id}`,d.ExtensionManagementErrorCode.Unknown)}catch(h){throw i(h)}}async installGalleryExtensions(r){if(!this.galleryService.isEnabled())throw new d.ExtensionManagementError(m.localize(1767,null),d.ExtensionManagementErrorCode.NotAllowed);const o=[],h=[];return await Promise.allSettled(r.map(async({extension:y,options:A})=>{try{const b=await this.checkAndGetCompatibleVersion(y,!!A?.installGivenVersion,!!A?.installPreReleaseVersion,A.productVersion??{version:this.productService.version,date:this.productService.date});h.push({...b,options:A})}catch(b){o.push({identifier:y.identifier,operation:d.InstallOperation.Install,source:y,error:b,profileLocation:A.profileLocation??this.getCurrentExtensionsManifestLocation()})}})),h.length&&o.push(...await this.installExtensions(h)),o}async uninstall(r,o){return this.logService.trace("ExtensionManagementService#uninstall",r.identifier.id),this.uninstallExtensions([{extension:r,options:o}])}async toggleAppliationScope(r,o){if((0,g.isApplicationScopedExtension)(r.manifest)||r.isBuiltin)return r;if(r.isApplicationScoped){let h=await this.updateMetadata(r,{isApplicationScoped:!1},this.userDataProfilesService.defaultProfile.extensionsResource);this.uriIdentityService.extUri.isEqual(o,this.userDataProfilesService.defaultProfile.extensionsResource)||(h=await this.copyExtension(r,this.userDataProfilesService.defaultProfile.extensionsResource,o));for(const y of this.userDataProfilesService.profiles){const A=(await this.getInstalled(g.ExtensionType.User,y.extensionsResource)).find(b=>(0,l.areSameExtensions)(b.identifier,r.identifier));A?this._onDidUpdateExtensionMetadata.fire({local:A,profileLocation:y.extensionsResource}):this._onDidUninstallExtension.fire({identifier:r.identifier,profileLocation:y.extensionsResource})}return h}else{const h=this.uriIdentityService.extUri.isEqual(o,this.userDataProfilesService.defaultProfile.extensionsResource)?await this.updateMetadata(r,{isApplicationScoped:!0},this.userDataProfilesService.defaultProfile.extensionsResource):await this.copyExtension(r,o,this.userDataProfilesService.defaultProfile.extensionsResource,{isApplicationScoped:!0});return this._onDidInstallExtensions.fire([{identifier:h.identifier,operation:d.InstallOperation.Install,local:h,profileLocation:this.userDataProfilesService.defaultProfile.extensionsResource,applicationScoped:!0}]),h}}getExtensionsControlManifest(){const r=new Date().getTime();return(!this.extensionsControlManifest||r-this.lastReportTimestamp>1e3*60*5)&&(this.extensionsControlManifest=this.updateControlCache(),this.lastReportTimestamp=r),this.extensionsControlManifest}registerParticipant(r){this.participants.push(r)}async resetPinnedStateForAllUserExtensions(r){try{await this.joinAllSettled(this.userDataProfilesService.profiles.map(async o=>{const h=await this.getInstalled(g.ExtensionType.User,o.extensionsResource);await this.joinAllSettled(h.map(async y=>{y.pinned!==r&&await this.updateMetadata(y,{pinned:r},o.extensionsResource)}))}))}catch(o){throw this.logService.error("Error while resetting pinned state for all user extensions",(0,T.getErrorMessage)(o)),o}}async installExtensions(r){const o=new Map,h=new Map,y=[],A=(w,O)=>`${l.ExtensionKey.create(w).toString()}-${O.toString()}`,b=(w,O,F,N)=>{const M=this.createInstallExtensionTask(w,O,F),V=`${(0,l.getGalleryExtensionId)(w.publisher,w.name)}-${F.profileLocation.toString()}`;h.set(V,{task:M,root:N}),this._onInstallExtension.fire({identifier:M.identifier,source:O,profileLocation:F.profileLocation}),this.logService.info("Installing extension:",M.identifier.id,F),S.URI.isUri(O)||this.installingExtensions.set(A(O,F.profileLocation),{task:M,waitingTasks:[]})};try{for(const{manifest:w,extension:O,options:F}of r){const N=F.isApplicationScoped||F.isBuiltin||(0,g.isApplicationScopedExtension)(w),M={...F,installOnlyNewlyAddedFromExtensionPack:F.installOnlyNewlyAddedFromExtensionPack??!S.URI.isUri(O),isApplicationScoped:N,profileLocation:N?this.userDataProfilesService.defaultProfile.extensionsResource:F.profileLocation??this.getCurrentExtensionsManifestLocation(),productVersion:F.productVersion??{version:this.productService.version,date:this.productService.date}},V=S.URI.isUri(O)?void 0:this.installingExtensions.get(A(O,M.profileLocation));V?(this.logService.info("Extension is already requested to install",V.task.identifier.id,M.profileLocation.toString()),y.push(V.task.waitUntilTaskIsFinished())):b(w,O,M,void 0)}return await Promise.all([...h.values()].map(async({task:w})=>{if(w.options.donotIncludePackAndDependencies)this.logService.info("Installing the extension without checking dependencies and pack",w.identifier.id);else try{const O=await this.getAllDepsAndPackExtensions(w.identifier,w.manifest,!!w.options.installOnlyNewlyAddedFromExtensionPack,!!w.options.installPreReleaseVersion,w.options.profileLocation,w.options.productVersion),F=await this.getInstalled(void 0,w.options.profileLocation,w.options.productVersion),N={...w.options,context:{...w.options.context,[d.EXTENSION_INSTALL_DEP_PACK_CONTEXT]:!0}};for(const{gallery:M,manifest:V}of(0,R.distinct)(O,({gallery:z})=>z.identifier.id)){if(h.has(`${M.identifier.id.toLowerCase()}-${N.profileLocation.toString()}`))continue;const z=this.installingExtensions.get(A(M,N.profileLocation));if(z){if(this.canWaitForTask(w,z.task)){const J=z.task.identifier;this.logService.info("Waiting for already requested installing extension",J.id,w.identifier.id,N.profileLocation.toString()),z.waitingTasks.push(w),y.push(k.Event.toPromise(k.Event.filter(this.onDidInstallExtensions,j=>j.some(te=>(0,l.areSameExtensions)(te.identifier,J)))).then(j=>{if(this.logService.info("Finished waiting for already requested installing extension",J.id,w.identifier.id,N.profileLocation.toString()),!j.find(q=>(0,l.areSameExtensions)(q.identifier,J))?.local)throw new Error(`Extension ${J.id} is not installed`)}))}}else F.some(({identifier:J})=>(0,l.areSameExtensions)(J,M.identifier))||b(V,M,N,w)}}catch(O){if(S.URI.isUri(w.source))(0,R.isNonEmptyArray)(w.manifest.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",w.identifier.id,O.message),(0,R.isNonEmptyArray)(w.manifest.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",w.identifier.id,O.message);else throw this.logService.error("Error while preparing to install dependencies and extension packs of the extension:",w.identifier.id),O}})),await this.joinAllSettled([...h.entries()].map(async([w,{task:O}])=>{const F=new Date().getTime();let N;try{N=await O.run(),await this.joinAllSettled(this.participants.map(M=>M.postInstall(N,O.source,O.options,_.CancellationToken.None)),d.ExtensionManagementErrorCode.PostInstall)}catch(M){const V=i(M);throw S.URI.isUri(O.source)||n(this.telemetryService,O.operation===d.InstallOperation.Update?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,l.getGalleryExtensionTelemetryData)(O.source),error:V,source:O.options.context?.[d.EXTENSION_INSTALL_SOURCE_CONTEXT]}),o.set(w,{error:V,identifier:O.identifier,operation:O.operation,source:O.source,context:O.options.context,profileLocation:O.options.profileLocation,applicationScoped:O.options.isApplicationScoped}),this.logService.error("Error while installing the extension",O.identifier.id,(0,T.getErrorMessage)(V),O.options.profileLocation.toString()),V}if(!S.URI.isUri(O.source)){const M=O.operation===d.InstallOperation.Update,V=M?void 0:(new Date().getTime()-O.source.lastUpdated)/1e3;if(n(this.telemetryService,M?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,l.getGalleryExtensionTelemetryData)(O.source),verificationStatus:O.verificationStatus,duration:new Date().getTime()-F,durationSinceUpdate:V,source:O.options.context?.[d.EXTENSION_INSTALL_SOURCE_CONTEXT]}),E.isWeb&&O.operation!==d.InstallOperation.Update)try{await this.galleryService.reportStatistic(N.manifest.publisher,N.manifest.name,N.manifest.version,d.StatisticType.Install)}catch{}}o.set(w,{local:N,identifier:O.identifier,operation:O.operation,source:O.source,context:O.options.context,profileLocation:O.options.profileLocation,applicationScoped:N.isApplicationScoped})})),y.length&&await this.joinAllSettled(y),[...o.values()]}catch(w){const O=(M,V,z)=>{const J=[];M.manifest.extensionDependencies?.length&&J.push(...M.manifest.extensionDependencies),M.manifest.extensionPack?.length&&J.push(...M.manifest.extensionPack);for(const j of J){if(z.includes(j.toLowerCase()))continue;z.push(j.toLowerCase());const te=o.get(`${j.toLowerCase()}-${V.toString()}`);te?.local&&(z=O(te.local,V,z))}return z},F=M=>({identifier:M.identifier,operation:d.InstallOperation.Install,source:M.source,context:M.options.context,profileLocation:M.options.profileLocation,error:w}),N=[];for(const[M,{task:V,root:z}]of h){const J=o.get(M);J?J.local&&z&&!o.get(`${z.identifier.id.toLowerCase()}-${V.options.profileLocation.toString()}`)?.local&&(N.push(this.createUninstallExtensionTask(J.local,{versionOnly:!0,profileLocation:V.options.profileLocation})),o.set(M,F(V))):(V.cancel(),o.set(M,F(V)))}for(const[M,{task:V}]of h){const z=o.get(M);if(!z?.local||V.options.donotIncludePackAndDependencies)continue;O(z.local,V.options.profileLocation,[z.local.identifier.id.toLowerCase()]).slice(1).some(j=>h.has(`${j.toLowerCase()}-${V.options.profileLocation.toString()}`)&&!o.get(`${j.toLowerCase()}-${V.options.profileLocation.toString()}`)?.local)&&(N.push(this.createUninstallExtensionTask(z.local,{versionOnly:!0,profileLocation:V.options.profileLocation})),o.set(M,F(V)))}throw N.length&&await Promise.allSettled(N.map(async M=>{try{await M.run(),this.logService.info("Rollback: Uninstalled extension",M.extension.identifier.id)}catch(V){this.logService.warn("Rollback: Error while uninstalling extension",M.extension.identifier.id,(0,T.getErrorMessage)(V))}})),w}finally{for(const{task:w}of h.values())w.source&&!S.URI.isUri(w.source)&&this.installingExtensions.delete(A(w.source,w.options.profileLocation));if(o.size){const w=[...o.values()];for(const O of w)O.local&&this.logService.info("Extension installed successfully:",O.identifier.id,O.profileLocation.toString());this._onDidInstallExtensions.fire(w)}}}canWaitForTask(r,o){for(const[,{task:h,waitingTasks:y}]of this.installingExtensions.entries())if(h===r&&(y.includes(o)||y.some(A=>this.canWaitForTask(A,o)))||h===o&&y[0]&&!this.canWaitForTask(r,y[0]))return!1;return!0}async joinAllSettled(r,o){const h=[],y=[],A=await Promise.allSettled(r);for(const w of A)w.status==="fulfilled"?h.push(w.value):y.push(i(w.reason,o));if(!y.length)return h;if(y.length===1)throw y[0];let b=new d.ExtensionManagementError("",d.ExtensionManagementErrorCode.Unknown);for(const w of y)b=new d.ExtensionManagementError(b.message?`${b.message}, ${w.message}`:w.message,w.code!==d.ExtensionManagementErrorCode.Unknown&&w.code!==d.ExtensionManagementErrorCode.Internal?w.code:b.code);throw b}async getAllDepsAndPackExtensions(r,o,h,y,A,b){if(!this.galleryService.isEnabled())return[];const w=await this.getInstalled(void 0,A,b),O=[],F=[],N=async(M,V)=>{O.push(M);const z=V.extensionDependencies||[],J=[...z];if(V.extensionPack){const j=h?w.find(te=>(0,l.areSameExtensions)(te.identifier,M)):void 0;for(const te of V.extensionPack)j&&j.manifest.extensionPack&&j.manifest.extensionPack.some(q=>(0,l.areSameExtensions)({id:q},{id:te}))||J.every(q=>!(0,l.areSameExtensions)({id:q},{id:te}))&&J.push(te)}if(J.length){const j=J.filter(te=>O.every(q=>!(0,l.areSameExtensions)(q,{id:te})));if(j.length){const te=await this.galleryService.getExtensions(j.map(q=>({id:q,preRelease:y})),_.CancellationToken.None);for(const q of te){if(O.find(ne=>(0,l.areSameExtensions)(ne,q.identifier)))continue;const B=z.some(ne=>(0,l.areSameExtensions)({id:ne},q.identifier));let Z;try{Z=await this.checkAndGetCompatibleVersion(q,!1,y,b)}catch(ne){if(B)throw ne;this.logService.info("Skipping the packed extension as it cannot be installed",q.identifier.id,(0,T.getErrorMessage)(ne));continue}F.push({gallery:Z.extension,manifest:Z.manifest}),await N(Z.extension.identifier,Z.manifest)}}}};return await N(r,o),F}async checkAndGetCompatibleVersion(r,o,h,y){let A;const b=await this.getExtensionsControlManifest();if(b.malicious.some(F=>(0,l.areSameExtensions)(r.identifier,F)))throw new d.ExtensionManagementError(m.localize(1768,null,r.identifier.id),d.ExtensionManagementErrorCode.Malicious);const w=b.deprecated[r.identifier.id.toLowerCase()];if(w?.extension?.autoMigrate){if(this.logService.info(`The '${r.identifier.id}' extension is deprecated, fetching the compatible '${w.extension.id}' extension instead.`),A=(await this.galleryService.getExtensions([{id:w.extension.id,preRelease:w.extension.preRelease}],{targetPlatform:await this.getTargetPlatform(),compatible:!0,productVersion:y},_.CancellationToken.None))[0],!A)throw new d.ExtensionManagementError(m.localize(1769,null,r.identifier.id,w.extension.id),d.ExtensionManagementErrorCode.Deprecated)}else{if(!await this.canInstall(r)){const F=await this.getTargetPlatform();throw new d.ExtensionManagementError(m.localize(1770,null,r.identifier.id,this.productService.nameLong,(0,d.TargetPlatformToString)(F)),d.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}if(A=await this.getCompatibleVersion(r,o,h,y),!A){const F=[];throw(0,I.areApiProposalsCompatible)(r.properties.enabledApiProposals??[],F)?!h&&r.properties.isPreReleaseVersion&&(await this.galleryService.getExtensions([r.identifier],_.CancellationToken.None))[0]?new d.ExtensionManagementError(m.localize(1772,null,r.displayName??r.identifier.id),d.ExtensionManagementErrorCode.ReleaseVersionNotFound):new d.ExtensionManagementError(m.localize(1773,null,r.identifier.id,this.productService.nameLong,this.productService.version),d.ExtensionManagementErrorCode.Incompatible):new d.ExtensionManagementError(m.localize(1771,null,r.displayName??r.identifier.id,F[0]),d.ExtensionManagementErrorCode.IncompatibleApi)}}this.logService.info("Getting Manifest...",A.identifier.id);const O=await this.galleryService.getManifest(A,_.CancellationToken.None);if(O===null)throw new d.ExtensionManagementError(`Missing manifest for extension ${A.identifier.id}`,d.ExtensionManagementErrorCode.Invalid);if(O.version!==A.version)throw new d.ExtensionManagementError(`Cannot install '${A.identifier.id}' extension because of version mismatch in Marketplace`,d.ExtensionManagementErrorCode.Invalid);return{extension:A,manifest:O}}async getCompatibleVersion(r,o,h,y){const A=await this.getTargetPlatform();let b=null;return!o&&r.hasPreReleaseVersion&&r.properties.isPreReleaseVersion!==h&&(b=(await this.galleryService.getExtensions([{...r.identifier,preRelease:h}],{targetPlatform:A,compatible:!0,productVersion:y},_.CancellationToken.None))[0]||null),!b&&await this.galleryService.isExtensionCompatible(r,h,A,y)&&(b=r),b||(o?b=(await this.galleryService.getExtensions([{...r.identifier,version:r.version}],{targetPlatform:A,compatible:!0,productVersion:y},_.CancellationToken.None))[0]||null:b=await this.galleryService.getCompatibleExtension(r,h,A,y)),b}async uninstallExtensions(r){const o=(F,N)=>`${F.identifier.id.toLowerCase()}${N.versionOnly?`-${F.manifest.version}`:""}@${N.profileLocation.toString()}`,h=(F,N)=>{const M=this.createUninstallExtensionTask(F,N);return this.uninstallingExtensions.set(o(M.extension,N),M),this.logService.info("Uninstalling extension from the profile:",`${F.identifier.id}@${F.manifest.version}`,N.profileLocation.toString()),this._onUninstallExtension.fire({identifier:F.identifier,profileLocation:N.profileLocation,applicationScoped:F.isApplicationScoped}),M},y=(F,N,M)=>{M?this.logService.error("Failed to uninstall extension from the profile:",`${F.identifier.id}@${F.manifest.version}`,N.profileLocation.toString(),M.message):this.logService.info("Successfully uninstalled extension from the profile",`${F.identifier.id}@${F.manifest.version}`,N.profileLocation.toString()),n(this.telemetryService,"extensionGallery:uninstall",{extensionData:(0,l.getLocalExtensionTelemetryData)(F),error:M}),this._onDidUninstallExtension.fire({identifier:F.identifier,error:M?.code,profileLocation:N.profileLocation,applicationScoped:F.isApplicationScoped})},A=[],b=[],w=[],O=new D.ResourceMap;for(const{extension:F,options:N}of r){const M={...N,profileLocation:F.isApplicationScoped?this.userDataProfilesService.defaultProfile.extensionsResource:N?.profileLocation??this.getCurrentExtensionsManifestLocation()},V=this.uninstallingExtensions.get(o(F,M));V?(this.logService.info("Extensions is already requested to uninstall",F.identifier.id),w.push(V.waitUntilTaskIsFinished())):A.push(h(F,M))}try{for(const F of A.slice(0)){let N=O.get(F.options.profileLocation);if(N||O.set(F.options.profileLocation,N=await this.getInstalled(g.ExtensionType.User,F.options.profileLocation)),F.options.donotIncludePack)this.logService.info("Uninstalling the extension without including packed extension",`${F.extension.identifier.id}@${F.extension.manifest.version}`);else{const M=this.getAllPackExtensionsToUninstall(F.extension,N);for(const V of M)this.uninstallingExtensions.has(o(V,F.options))?this.logService.info("Extensions is already requested to uninstall",V.identifier.id):A.push(h(V,F.options))}F.options.donotCheckDependents?this.logService.info("Uninstalling the extension without checking dependents",`${F.extension.identifier.id}@${F.extension.manifest.version}`):this.checkForDependents(A.map(M=>M.extension),N,F.extension)}await this.joinAllSettled(A.map(async F=>{try{if(await F.run(),await this.joinAllSettled(this.participants.map(N=>N.postUninstall(F.extension,F.options,_.CancellationToken.None))),F.extension.identifier.uuid)try{await this.galleryService.reportStatistic(F.extension.manifest.publisher,F.extension.manifest.name,F.extension.manifest.version,d.StatisticType.Uninstall)}catch{}}catch(N){const M=i(N);throw y(F.extension,F.options,M),M}finally{b.push(F)}})),w.length&&await this.joinAllSettled(w);for(const F of A)y(F.extension,F.options)}catch(F){const N=i(F);for(const M of A){try{M.cancel()}catch{}b.includes(M)||y(M.extension,M.options,N)}throw N}finally{for(const F of A)this.uninstallingExtensions.delete(o(F.extension,F.options))||this.logService.warn("Uninstallation task is not found in the cache",F.extension.identifier.id)}}checkForDependents(r,o,h){for(const y of r){const A=this.getDependents(y,o);if(A.length){const b=A.filter(w=>!r.some(O=>(0,l.areSameExtensions)(O.identifier,w.identifier)));if(b.length)throw new Error(this.getDependentsErrorMessage(y,b,h))}}}getDependentsErrorMessage(r,o,h){return h===r?o.length===1?m.localize(1774,null,h.manifest.displayName||h.manifest.name,o[0].manifest.displayName||o[0].manifest.name):o.length===2?m.localize(1775,null,h.manifest.displayName||h.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name):m.localize(1776,null,h.manifest.displayName||h.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name):o.length===1?m.localize(1777,null,h.manifest.displayName||h.manifest.name,r.manifest.displayName||r.manifest.name,o[0].manifest.displayName||o[0].manifest.name):o.length===2?m.localize(1778,null,h.manifest.displayName||h.manifest.name,r.manifest.displayName||r.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name):m.localize(1779,null,h.manifest.displayName||h.manifest.name,r.manifest.displayName||r.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name)}getAllPackExtensionsToUninstall(r,o,h=[]){if(h.indexOf(r)!==-1)return[];h.push(r);const y=r.manifest.extensionPack?r.manifest.extensionPack:[];if(y.length){const A=o.filter(w=>!w.isBuiltin&&y.some(O=>(0,l.areSameExtensions)({id:O},w.identifier))),b=[];for(const w of A)b.push(...this.getAllPackExtensionsToUninstall(w,o,h));return[...A,...b]}return[]}getDependents(r,o){return o.filter(h=>h.manifest.extensionDependencies&&h.manifest.extensionDependencies.some(y=>(0,l.areSameExtensions)({id:y},r.identifier)))}async updateControlCache(){try{return this.logService.trace("ExtensionManagementService.updateControlCache"),await this.galleryService.getExtensionsControlManifest()}catch(r){return this.logService.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest",(0,T.getErrorMessage)(r)),{malicious:[],deprecated:{},search:[]}}}};e.AbstractExtensionManagementService=u,e.AbstractExtensionManagementService=u=Ie([Y(0,d.IExtensionGalleryService),Y(1,C.ITelemetryService),Y(2,p.IUriIdentityService),Y(3,v.ILogService),Y(4,f.IProductService),Y(5,c.IUserDataProfilesService)],u);function i(s,r){if(s instanceof d.ExtensionManagementError)return s;let o;return s instanceof d.ExtensionGalleryError?o=new d.ExtensionManagementError(s.message,s.code===d.ExtensionGalleryErrorCode.DownloadFailedWriting?d.ExtensionManagementErrorCode.DownloadFailedWriting:d.ExtensionManagementErrorCode.Gallery):o=new d.ExtensionManagementError(s.message,(0,T.isCancellationError)(s)?d.ExtensionManagementErrorCode.Cancelled:r??d.ExtensionManagementErrorCode.Internal),o.stack=s.stack,o}function n(s,r,{extensionData:o,verificationStatus:h,duration:y,error:A,source:b,durationSinceUpdate:w}){let O,F;(0,P.isDefined)(h)&&(h===!0?h="Verified":(h===!1||(O=d.ExtensionManagementErrorCode.Signature,F=h),h="Unverified")),A&&(O=A.code,A.code===d.ExtensionManagementErrorCode.Signature&&(F=A.message)),s.publicLog(r,{...o,verificationStatus:h,success:!A,duration:y,errorcode:O,errorcodeDetail:F,durationSinceUpdate:w,source:b})}class t{constructor(){this.barrier=new a.Barrier}async waitUntilTaskIsFinished(){return await this.barrier.wait(),this.cancellablePromise}run(){return this.cancellablePromise||(this.cancellablePromise=(0,a.createCancelablePromise)(r=>this.doRun(r))),this.barrier.open(),this.cancellablePromise}cancel(){this.cancellablePromise||(this.cancellablePromise=(0,a.createCancelablePromise)(r=>new Promise((o,h)=>{const y=r.onCancellationRequested(()=>{y.dispose(),h(new T.CancellationError)})})),this.barrier.open()),this.cancellablePromise.cancel()}}e.AbstractExtensionTask=t}),define(he[52],fe([0,1,6,14,2,3,31,10,27,35,7,4,11,19,28,12,8,18]),function(ce,e,R,a,_,T,k,L,D,E,P,S,m,d,l,g,I,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsProfileScannerService=e.IExtensionsProfileScannerService=e.ExtensionsProfileScanningError=e.ExtensionsProfileScanningErrorCode=void 0;var f;(function(i){i.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",i.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(f||(e.ExtensionsProfileScanningErrorCode=f={}));class C extends Error{constructor(n,t){super(n),this.code=t}}e.ExtensionsProfileScanningError=C,e.IExtensionsProfileScannerService=(0,S.createDecorator)("IExtensionsProfileScannerService");let p=class extends _.Disposable{constructor(n,t,s,r,o,h){super(),this.extensionsLocation=n,this.fileService=t,this.userDataProfilesService=s,this.uriIdentityService=r,this.telemetryService=o,this.logService=h,this._onAddExtensions=this._register(new T.Emitter),this.onAddExtensions=this._onAddExtensions.event,this._onDidAddExtensions=this._register(new T.Emitter),this.onDidAddExtensions=this._onDidAddExtensions.event,this._onRemoveExtensions=this._register(new T.Emitter),this.onRemoveExtensions=this._onRemoveExtensions.event,this._onDidRemoveExtensions=this._register(new T.Emitter),this.onDidRemoveExtensions=this._onDidRemoveExtensions.event,this.resourcesAccessQueueMap=new k.ResourceMap}scanProfileExtensions(n,t){return this.withProfileExtensions(n,void 0,t)}async addExtensionsToProfile(n,t,s){const r=[],o=[];try{return await this.withProfileExtensions(t,h=>{const y=[];if(s)y.push(...h);else for(const A of h)n.some(([b])=>(0,E.areSameExtensions)(b.identifier,A.identifier)&&b.manifest.version!==A.version)?r.push(A):y.push(A);for(const[A,b]of n){const w=y.findIndex(F=>(0,E.areSameExtensions)(F.identifier,A.identifier)&&F.version===A.manifest.version),O={identifier:A.identifier,version:A.manifest.version,location:A.location,metadata:b};w===-1?(o.push(O),y.push(O)):y.splice(w,1,O)}return o.length&&this._onAddExtensions.fire({extensions:o,profileLocation:t}),r.length&&this._onRemoveExtensions.fire({extensions:r,profileLocation:t}),y}),o.length&&this._onDidAddExtensions.fire({extensions:o,profileLocation:t}),r.length&&this._onDidRemoveExtensions.fire({extensions:r,profileLocation:t}),o}catch(h){throw o.length&&this._onDidAddExtensions.fire({extensions:o,error:h,profileLocation:t}),r.length&&this._onDidRemoveExtensions.fire({extensions:r,error:h,profileLocation:t}),h}}async updateMetadata(n,t){const s=[];return await this.withProfileExtensions(t,r=>{const o=[];for(const h of r){const y=n.find(([A])=>(0,E.areSameExtensions)(A.identifier,h.identifier)&&A.manifest.version===h.version);y&&(h.metadata={...h.metadata,...y[1]},s.push(h)),o.push(h)}return o}),s}async removeExtensionFromProfile(n,t){const s=[];try{await this.withProfileExtensions(t,r=>{const o=[];for(const h of r)(0,E.areSameExtensions)(h.identifier,n.identifier)?s.push(h):o.push(h);return s.length&&this._onRemoveExtensions.fire({extensions:s,profileLocation:t}),o}),s.length&&this._onDidRemoveExtensions.fire({extensions:s,profileLocation:t})}catch(r){throw s.length&&this._onDidRemoveExtensions.fire({extensions:s,error:r,profileLocation:t}),r}}async withProfileExtensions(n,t,s){return this.getResourceAccessQueue(n).queue(async()=>{let r=[],o;try{const h=await this.fileService.readFile(n);o=JSON.parse(h.value.toString().trim()||"[]")}catch(h){if((0,P.toFileOperationResult)(h)!==P.FileOperationResult.FILE_NOT_FOUND)throw h;if(this.uriIdentityService.extUri.isEqual(n,this.userDataProfilesService.defaultProfile.extensionsResource)&&(o=await this.migrateFromOldDefaultProfileExtensionsLocation()),!o&&s?.bailOutWhenFileNotFound)throw new C((0,I.getErrorMessage)(h),f.ERROR_PROFILE_NOT_FOUND)}if(o){Array.isArray(o)||this.reportAndThrowInvalidConentError(n);let h=!1;for(const y of o){c(y)||this.reportAndThrowInvalidConentError(n);let A;if((0,g.isString)(y.relativeLocation)&&y.relativeLocation)A=this.resolveExtensionLocation(y.relativeLocation);else if((0,g.isString)(y.location)){this.logService.warn(`Extensions profile: Ignoring extension with invalid location: ${y.location}`);continue}else{A=L.URI.revive(y.location);const b=this.toRelativePath(A);b&&(h=!0,y.relativeLocation=b)}(0,g.isUndefined)(y.metadata?.hasPreReleaseVersion)&&y.metadata?.preRelease&&(h=!0,y.metadata.hasPreReleaseVersion=!0),r.push({identifier:y.identifier,location:A,version:y.version,metadata:y.metadata})}h&&await this.fileService.writeFile(n,a.VSBuffer.fromString(JSON.stringify(o)))}if(t){r=t(r);const h=r.map(y=>({identifier:y.identifier,version:y.version,location:y.location.toJSON(),relativeLocation:this.toRelativePath(y.location),metadata:y.metadata}));await this.fileService.writeFile(n,a.VSBuffer.fromString(JSON.stringify(h)))}return r})}reportAndThrowInvalidConentError(n){const t=new C(`Invalid extensions content in ${n.toString()}`,f.ERROR_INVALID_CONTENT);throw this.telemetryService.publicLogError2("extensionsProfileScanningError",{code:t.code}),t}toRelativePath(n){return this.uriIdentityService.extUri.isEqual(this.uriIdentityService.extUri.dirname(n),this.extensionsLocation)?this.uriIdentityService.extUri.basename(n):void 0}resolveExtensionLocation(n){return this.uriIdentityService.extUri.joinPath(this.extensionsLocation,n)}async migrateFromOldDefaultProfileExtensionsLocation(){return this._migrationPromise||(this._migrationPromise=(async()=>{const n=this.uriIdentityService.extUri.joinPath(this.userDataProfilesService.defaultProfile.location,"extensions.json"),t=this.uriIdentityService.extUri.joinPath(this.extensionsLocation,".init-default-profile-extensions");let s;try{s=(await this.fileService.readFile(n)).value.toString()}catch(o){if((0,P.toFileOperationResult)(o)===P.FileOperationResult.FILE_NOT_FOUND)return;throw o}this.logService.info("Migrating extensions from old default profile location",n.toString());let r;try{const o=JSON.parse(s);Array.isArray(o)&&o.every(h=>c(h))?r=o:this.logService.warn("Skipping migrating from old default profile locaiton: Found invalid data",o)}catch(o){this.logService.error(o)}if(r)try{await this.fileService.createFile(this.userDataProfilesService.defaultProfile.extensionsResource,a.VSBuffer.fromString(JSON.stringify(r)),{overwrite:!1}),this.logService.info("Migrated extensions from old default profile location to new location",n.toString(),this.userDataProfilesService.defaultProfile.extensionsResource.toString())}catch(o){if((0,P.toFileOperationResult)(o)===P.FileOperationResult.FILE_MODIFIED_SINCE)this.logService.info("Migration from old default profile location to new location is done by another window",n.toString(),this.userDataProfilesService.defaultProfile.extensionsResource.toString());else throw o}try{await this.fileService.del(n)}catch(o){(0,P.toFileOperationResult)(o)!==P.FileOperationResult.FILE_NOT_FOUND&&this.logService.error(o)}try{await this.fileService.del(t)}catch(o){(0,P.toFileOperationResult)(o)!==P.FileOperationResult.FILE_NOT_FOUND&&this.logService.error(o)}return r})()),this._migrationPromise}getResourceAccessQueue(n){let t=this.resourcesAccessQueueMap.get(n);return t||(t=new R.Queue,this.resourcesAccessQueueMap.set(n,t)),t}};e.AbstractExtensionsProfileScannerService=p,e.AbstractExtensionsProfileScannerService=p=Ie([Y(1,P.IFileService),Y(2,d.IUserDataProfilesService),Y(3,l.IUriIdentityService),Y(4,v.ITelemetryService),Y(5,m.ILogService)],p);function c(i){return(0,g.isObject)(i)&&(0,D.isIExtensionIdentifier)(i.identifier)&&(u(i.location)||(0,g.isString)(i.location)&&i.location)&&((0,g.isUndefined)(i.relativeLocation)||(0,g.isString)(i.relativeLocation))&&i.version&&(0,g.isString)(i.version)}function u(i){return i?(0,g.isString)(i.path)&&(0,g.isString)(i.scheme):!1}});var it=this&&this.__importDefault||function(ce){return ce&&ce.__esModule?ce:{default:ce}};define(he[85],fe([0,1,17,6,29,14,8,36,144,2,22,13,5,20,60,92,12,10,9,15,35,34,59,7,4,11,23,3,68,52,19,28,159]),function(ce,e,R,a,_,T,k,L,D,E,P,S,m,d,l,g,I,v,f,C,p,c,u,i,n,t,s,r,o,h,y,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtensionsScannerService=e.ExtensionScannerInput=e.AbstractExtensionsScannerService=e.IExtensionsScannerService=e.Translations=void 0,e.toExtensionDescription=V,_=De(_),S=De(S),m=De(m),l=De(l),g=it(g);var w;(function(J){function j(te,q){if(te===q)return!0;const B=Object.keys(te),Z=new Set;for(const ne of Object.keys(q))Z.add(ne);if(B.length!==Z.size)return!1;for(const ne of B){if(te[ne]!==q[ne])return!1;Z.delete(ne)}return Z.size===0}J.equals=j})(w||(e.Translations=w={})),e.IExtensionsScannerService=(0,n.createDecorator)("IExtensionsScannerService");let O=class extends E.Disposable{constructor(j,te,q,B,Z,ne,le,ee,K,H,W,U){super(),this.systemExtensionsLocation=j,this.userExtensionsLocation=te,this.extensionsControlLocation=q,this.currentProfile=B,this.userDataProfilesService=Z,this.extensionsProfileScannerService=ne,this.fileService=le,this.logService=ee,this.environmentService=K,this.productService=H,this.uriIdentityService=W,this.instantiationService=U,this._onDidChangeCache=this._register(new r.Emitter),this.onDidChangeCache=this._onDidChangeCache.event,this.obsoleteFile=(0,d.joinPath)(this.userExtensionsLocation,".obsolete"),this.systemExtensionsCachedScanner=this._register(this.instantiationService.createInstance(M,this.currentProfile,this.obsoleteFile)),this.userExtensionsCachedScanner=this._register(this.instantiationService.createInstance(M,this.currentProfile,this.obsoleteFile)),this.extensionsScanner=this._register(this.instantiationService.createInstance(N,this.obsoleteFile)),this.initializeDefaultProfileExtensionsPromise=void 0,this._register(this.systemExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(c.ExtensionType.System))),this._register(this.userExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(c.ExtensionType.User)))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,p.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async scanAllExtensions(j,te,q){const[B,Z]=await Promise.all([this.scanSystemExtensions(j),this.scanUserExtensions(te)]),ne=q?await this.scanExtensionsUnderDevelopment(j,[...B,...Z]):[];return this.dedupExtensions(B,Z,ne,await this.getTargetPlatform(),!0)}async scanSystemExtensions(j){const te=[];te.push(this.scanDefaultSystemExtensions(!!j.useCache,j.language)),te.push(this.scanDevSystemExtensions(j.language,!!j.checkControlFile));const[q,B]=await Promise.all(te);return this.applyScanOptions([...q,...B],c.ExtensionType.System,j,!1)}async scanUserExtensions(j){const te=j.profileLocation??this.userExtensionsLocation;this.logService.trace("Started scanning user extensions",te);const q=this.uriIdentityService.extUri.isEqual(j.profileLocation,this.userDataProfilesService.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,B=await this.createExtensionScannerInput(te,!!j.profileLocation,c.ExtensionType.User,!j.includeUninstalled,j.language,!0,q,j.productVersion??this.getProductVersion()),Z=j.useCache&&!B.devMode&&B.excludeObsolete?this.userExtensionsCachedScanner:this.extensionsScanner;let ne;try{ne=await Z.scanExtensions(B)}catch(le){if(le instanceof h.ExtensionsProfileScanningError&&le.code===h.ExtensionsProfileScanningErrorCode.ERROR_PROFILE_NOT_FOUND)await this.doInitializeDefaultProfileExtensions(),ne=await Z.scanExtensions(B);else throw le}return ne=await this.applyScanOptions(ne,c.ExtensionType.User,j,!0),this.logService.trace("Scanned user extensions:",ne.length),ne}async scanExtensionsUnderDevelopment(j,te){if(this.environmentService.isExtensionDevelopment&&this.environmentService.extensionDevelopmentLocationURI){const q=(await Promise.all(this.environmentService.extensionDevelopmentLocationURI.filter(B=>B.scheme===P.Schemas.file).map(async B=>{const Z=await this.createExtensionScannerInput(B,!1,c.ExtensionType.User,!0,j.language,!1,void 0,j.productVersion??this.getProductVersion());return(await this.extensionsScanner.scanOneOrMultipleExtensions(Z)).map(le=>(le.type=te.find(ee=>(0,p.areSameExtensions)(ee.identifier,le.identifier))?.type??le.type,this.extensionsScanner.validate(le,Z)))}))).flat();return this.applyScanOptions(q,"development",j,!0)}return[]}async scanExistingExtension(j,te,q){const B=await this.createExtensionScannerInput(j,!1,te,!0,q.language,!0,void 0,q.productVersion??this.getProductVersion()),Z=await this.extensionsScanner.scanExtension(B);return!Z||!q.includeInvalid&&!Z.isValid?null:Z}async scanOneOrMultipleExtensions(j,te,q){const B=await this.createExtensionScannerInput(j,!1,te,!0,q.language,!0,void 0,q.productVersion??this.getProductVersion()),Z=await this.extensionsScanner.scanOneOrMultipleExtensions(B);return this.applyScanOptions(Z,te,q,!0)}async scanMultipleExtensions(j,te,q){const B=[];return await Promise.all(j.map(async Z=>{const ne=await this.scanOneOrMultipleExtensions(Z,te,q);B.push(...ne)})),this.applyScanOptions(B,te,q,!0)}async scanMetadata(j){const te=(0,d.joinPath)(j,"package.json"),q=(await this.fileService.readFile(te)).value.toString();return JSON.parse(q).__metadata}async updateMetadata(j,te){const q=(0,d.joinPath)(j,"package.json"),B=(await this.fileService.readFile(q)).value.toString(),Z=JSON.parse(B);te.isMachineScoped===!1&&delete te.isMachineScoped,te.isBuiltin===!1&&delete te.isBuiltin,Z.__metadata={...Z.__metadata,...te},await this.fileService.writeFile((0,d.joinPath)(j,"package.json"),T.VSBuffer.fromString(JSON.stringify(Z,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.extensionsProfileScannerService.scanProfileExtensions(this.userDataProfilesService.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(j){if(j instanceof h.ExtensionsProfileScanningError&&j.code===h.ExtensionsProfileScanningErrorCode.ERROR_PROFILE_NOT_FOUND)await this.doInitializeDefaultProfileExtensions();else throw j}}async doInitializeDefaultProfileExtensions(){return this.initializeDefaultProfileExtensionsPromise||(this.initializeDefaultProfileExtensionsPromise=(async()=>{try{this.logService.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const j=await this.scanUserExtensions({includeInvalid:!0});if(j.length)await this.extensionsProfileScannerService.addExtensionsToProfile(j.map(te=>[te,te.metadata]),this.userDataProfilesService.defaultProfile.extensionsResource);else try{await this.fileService.createFile(this.userDataProfilesService.defaultProfile.extensionsResource,T.VSBuffer.fromString(JSON.stringify([])))}catch(te){(0,i.toFileOperationResult)(te)!==i.FileOperationResult.FILE_NOT_FOUND&&this.logService.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,k.getErrorMessage)(te))}this.logService.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(j){this.logService.error(j)}finally{this.initializeDefaultProfileExtensionsPromise=void 0}})()),this.initializeDefaultProfileExtensionsPromise}async applyScanOptions(j,te,q,B){return q.includeAllVersions||(j=this.dedupExtensions(te===c.ExtensionType.System?j:void 0,te===c.ExtensionType.User?j:void 0,te==="development"?j:void 0,await this.getTargetPlatform(),B)),q.includeInvalid||(j=j.filter(Z=>Z.isValid)),j.sort((Z,ne)=>{const le=S.basename(Z.location.fsPath),ee=S.basename(ne.location.fsPath);return le<ee?-1:le>ee?1:0})}dedupExtensions(j,te,q,B,Z){const ne=(ee,K,H)=>{if(ee.isValid&&!K.isValid)return!1;if(ee.isValid===K.isValid){if(Z&&l.gt(ee.manifest.version,K.manifest.version))return this.logService.debug(`Skipping extension ${K.location.path} with lower version ${K.manifest.version} in favour of ${ee.location.path} with version ${ee.manifest.version}`),!1;if(l.eq(ee.manifest.version,K.manifest.version)){if(ee.type===c.ExtensionType.System)return this.logService.debug(`Skipping extension ${K.location.path} in favour of system extension ${ee.location.path} with same version`),!1;if(ee.targetPlatform===B)return this.logService.debug(`Skipping extension ${K.location.path} from different target platform ${K.targetPlatform}`),!1}}return H?this.logService.warn(`Overwriting user extension ${ee.location.path} with ${K.location.path}.`):this.logService.debug(`Overwriting user extension ${ee.location.path} with ${K.location.path}.`),!0},le=new c.ExtensionIdentifierMap;return j?.forEach(ee=>{const K=le.get(ee.identifier.id);(!K||ne(K,ee,!1))&&le.set(ee.identifier.id,ee)}),te?.forEach(ee=>{const K=le.get(ee.identifier.id);if(!K&&j&&ee.type===c.ExtensionType.System){this.logService.debug(`Skipping obsolete system extension ${ee.location.path}.`);return}(!K||ne(K,ee,!1))&&le.set(ee.identifier.id,ee)}),q?.forEach(ee=>{const K=le.get(ee.identifier.id);(!K||ne(K,ee,!0))&&le.set(ee.identifier.id,ee),le.set(ee.identifier.id,ee)}),[...le.values()]}async scanDefaultSystemExtensions(j,te){this.logService.trace("Started scanning system extensions");const q=await this.createExtensionScannerInput(this.systemExtensionsLocation,!1,c.ExtensionType.System,!0,te,!0,void 0,this.getProductVersion()),Z=await(j&&!q.devMode?this.systemExtensionsCachedScanner:this.extensionsScanner).scanExtensions(q);return this.logService.trace("Scanned system extensions:",Z.length),Z}async scanDevSystemExtensions(j,te){const q=this.environmentService.isBuilt?[]:this.productService.builtInExtensions;if(!q?.length)return[];this.logService.trace("Started scanning dev system extensions");const B=te?await this.getBuiltInExtensionControl():{},Z=[],ne=v.URI.file(S.normalize(S.join(P.FileAccess.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const ee of q){const K=B[ee.name]||"marketplace";switch(K){case"disabled":break;case"marketplace":Z.push((0,d.joinPath)(ne,ee.name));break;default:Z.push(v.URI.file(K));break}}const le=await Promise.all(Z.map(async ee=>this.extensionsScanner.scanExtension(await this.createExtensionScannerInput(ee,!1,c.ExtensionType.System,!0,j,!0,void 0,this.getProductVersion()))));return this.logService.trace("Scanned dev system extensions:",le.length),(0,R.coalesce)(le)}async getBuiltInExtensionControl(){try{const j=await this.fileService.readFile(this.extensionsControlLocation);return JSON.parse(j.value.toString())}catch{return{}}}async createExtensionScannerInput(j,te,q,B,Z,ne,le,ee){const K=await this.getTranslations(Z??m.language),H=await this.getMtime(j),W=te&&!this.uriIdentityService.extUri.isEqual(j,this.userDataProfilesService.defaultProfile.extensionsResource)?this.userDataProfilesService.defaultProfile.extensionsResource:void 0,U=W?await this.getMtime(W):void 0;return new F(j,H,W,U,te,le,q,B,ne,ee.version,ee.date,this.productService.commit,!this.environmentService.isBuilt,Z,K)}async getMtime(j){try{const te=await this.fileService.stat(j);if(typeof te.mtime=="number")return te.mtime}catch{}}getProductVersion(){return{version:this.productService.version,date:this.productService.date}}};e.AbstractExtensionsScannerService=O,e.AbstractExtensionsScannerService=O=Ie([Y(4,y.IUserDataProfilesService),Y(5,h.IExtensionsProfileScannerService),Y(6,i.IFileService),Y(7,t.ILogService),Y(8,C.IEnvironmentService),Y(9,s.IProductService),Y(10,A.IUriIdentityService),Y(11,n.IInstantiationService)],O);class F{constructor(j,te,q,B,Z,ne,le,ee,K,H,W,U,G,oe,Q){this.location=j,this.mtime=te,this.applicationExtensionslocation=q,this.applicationExtensionslocationMtime=B,this.profile=Z,this.profileScanOptions=ne,this.type=le,this.excludeObsolete=ee,this.validate=K,this.productVersion=H,this.productDate=W,this.productCommit=U,this.devMode=G,this.language=oe,this.translations=Q}static createNlsConfiguration(j){return{language:j.language,pseudo:j.language==="pseudo",devMode:j.devMode,translations:j.translations}}static equals(j,te){return(0,d.isEqual)(j.location,te.location)&&j.mtime===te.mtime&&(0,d.isEqual)(j.applicationExtensionslocation,te.applicationExtensionslocation)&&j.applicationExtensionslocationMtime===te.applicationExtensionslocationMtime&&j.profile===te.profile&&_.equals(j.profileScanOptions,te.profileScanOptions)&&j.type===te.type&&j.excludeObsolete===te.excludeObsolete&&j.validate===te.validate&&j.productVersion===te.productVersion&&j.productDate===te.productDate&&j.productCommit===te.productCommit&&j.devMode===te.devMode&&j.language===te.language&&w.equals(j.translations,te.translations)}}e.ExtensionScannerInput=F;let N=class extends E.Disposable{constructor(j,te,q,B,Z,ne,le){super(),this.obsoleteFile=j,this.extensionsProfileScannerService=te,this.uriIdentityService=q,this.fileService=B,this.environmentService=ne,this.logService=le,this.extensionsEnabledWithApiProposalVersion=Z.extensionsEnabledWithApiProposalVersion?.map(ee=>ee.toLowerCase())??[]}async scanExtensions(j){const te=j.profile?await this.scanExtensionsFromProfile(j):await this.scanExtensionsFromLocation(j);let q={};if(j.excludeObsolete&&j.type===c.ExtensionType.User)try{const B=(await this.fileService.readFile(this.obsoleteFile)).value.toString();q=JSON.parse(B)}catch{}return(0,I.isEmptyObject)(q)?te:te.filter(B=>!q[p.ExtensionKey.create(B).toString()])}async scanExtensionsFromLocation(j){const te=await this.fileService.resolve(j.location);if(!te.children?.length)return[];const q=await Promise.all(te.children.map(async B=>{if(!B.isDirectory||j.type===c.ExtensionType.User&&(0,d.basename)(B.resource).indexOf(".")===0)return null;const Z=new F(B.resource,j.mtime,j.applicationExtensionslocation,j.applicationExtensionslocationMtime,j.profile,j.profileScanOptions,j.type,j.excludeObsolete,j.validate,j.productVersion,j.productDate,j.productCommit,j.devMode,j.language,j.translations);return this.scanExtension(Z)}));return(0,R.coalesce)(q).sort((B,Z)=>B.location.path<Z.location.path?-1:1)}async scanExtensionsFromProfile(j){let te=await this.scanExtensionsFromProfileResource(j.location,()=>!0,j);if(j.applicationExtensionslocation&&!this.uriIdentityService.extUri.isEqual(j.location,j.applicationExtensionslocation)){te=te.filter(B=>!B.metadata?.isApplicationScoped);const q=await this.scanExtensionsFromProfileResource(j.applicationExtensionslocation,B=>!!B.metadata?.isBuiltin||!!B.metadata?.isApplicationScoped,j);te.push(...q)}return te}async scanExtensionsFromProfileResource(j,te,q){const B=await this.extensionsProfileScannerService.scanProfileExtensions(j,q.profileScanOptions);if(!B.length)return[];const Z=await Promise.all(B.map(async ne=>{if(te(ne)){const le=new F(ne.location,q.mtime,q.applicationExtensionslocation,q.applicationExtensionslocationMtime,q.profile,q.profileScanOptions,q.type,q.excludeObsolete,q.validate,q.productVersion,q.productDate,q.productCommit,q.devMode,q.language,q.translations);return this.scanExtension(le,ne.metadata)}return null}));return(0,R.coalesce)(Z)}async scanOneOrMultipleExtensions(j){try{if(await this.fileService.exists((0,d.joinPath)(j.location,"package.json"))){const te=await this.scanExtension(j);return te?[te]:[]}else return await this.scanExtensions(j)}catch(te){return this.logService.error(`Error scanning extensions at ${j.location.path}:`,(0,k.getErrorMessage)(te)),[]}}async scanExtension(j,te){try{let q=await this.scanExtensionManifest(j.location);if(q){q.publisher||(q.publisher=c.UNDEFINED_PUBLISHER),te=te??q.__metadata,delete q.__metadata;const B=(0,p.getGalleryExtensionId)(q.publisher,q.name),Z=te?.id?{id:B,uuid:te.id}:{id:B},ne=te?.isSystem?c.ExtensionType.System:j.type,le=ne===c.ExtensionType.System||!!te?.isBuiltin;q=await this.translateManifest(j.location,q,F.createNlsConfiguration(j));let ee={type:ne,identifier:Z,manifest:q,location:j.location,isBuiltin:le,targetPlatform:te?.targetPlatform??c.TargetPlatform.UNDEFINED,publisherDisplayName:te?.publisherDisplayName,metadata:te,isValid:!0,validations:[]};return j.validate&&(ee=this.validate(ee,j)),q.enabledApiProposals&&(!this.environmentService.isBuilt||this.extensionsEnabledWithApiProposalVersion.includes(B.toLowerCase()))&&(q.originalEnabledApiProposals=q.enabledApiProposals,q.enabledApiProposals=(0,c.parseEnabledApiProposalNames)([...q.enabledApiProposals])),ee}}catch(q){j.type!==c.ExtensionType.System&&this.logService.error(q)}return null}validate(j,te){let q=!0;const B=this.environmentService.isBuilt&&this.extensionsEnabledWithApiProposalVersion.includes(j.identifier.id.toLowerCase()),Z=(0,u.validateExtensionManifest)(te.productVersion,te.productDate,te.location,j.manifest,j.isBuiltin,B);for(const[ne,le]of Z)ne===g.default.Error&&(q=!1,this.logService.error(this.formatMessage(te.location,le)));return j.isValid=q,j.validations=Z,j}async scanExtensionManifest(j){const te=(0,d.joinPath)(j,"package.json");let q;try{q=(await this.fileService.readFile(te)).value.toString()}catch(Z){return(0,i.toFileOperationResult)(Z)!==i.FileOperationResult.FILE_NOT_FOUND&&this.logService.error(this.formatMessage(j,(0,f.localize)(1815,null,te.path,Z.message))),null}let B;try{B=JSON.parse(q)}catch{const ne=[];(0,L.parse)(q,ne);for(const le of ne)this.logService.error(this.formatMessage(j,(0,f.localize)(1816,null,te.path,le.offset,le.length,(0,D.getParseErrorMessage)(le.error))));return null}return(0,L.getNodeType)(B)!=="object"?(this.logService.error(this.formatMessage(j,(0,f.localize)(1817,null,te.path))),null):B}async translateManifest(j,te,q){const B=await this.getLocalizedMessages(j,te,q);if(B)try{const Z=[],ne=await this.resolveOriginalMessageBundle(B.default,Z);if(Z.length>0)return Z.forEach(ee=>{this.logService.error(this.formatMessage(j,(0,f.localize)(1818,null,B.default?.path,(0,D.getParseErrorMessage)(ee.error))))}),te;if((0,L.getNodeType)(B)!=="object")return this.logService.error(this.formatMessage(j,(0,f.localize)(1819,null,B.default?.path))),te;const le=B.values||Object.create(null);return(0,b.localizeManifest)(this.logService,te,le,ne)}catch{}return te}async getLocalizedMessages(j,te,q){const B=(0,d.joinPath)(j,"package.nls.json"),Z=(K,H)=>{H.forEach(W=>{this.logService.error(this.formatMessage(j,(0,f.localize)(1820,null,K?.path,(0,D.getParseErrorMessage)(W.error))))})},ne=K=>{this.logService.error(this.formatMessage(j,(0,f.localize)(1821,null,K?.path)))},le=`${te.publisher}.${te.name}`,ee=q.translations[le];if(ee)try{const K=v.URI.file(ee),H=(await this.fileService.readFile(K)).value.toString(),W=[],U=(0,L.parse)(H,W);return W.length>0?(Z(K,W),{values:void 0,default:B}):(0,L.getNodeType)(U)!=="object"?(ne(K),{values:void 0,default:B}):{values:U.contents?U.contents.package:void 0,default:B}}catch{return{values:void 0,default:B}}else{if(!await this.fileService.exists(B))return;let H;try{H=await this.findMessageBundles(j,q)}catch{return}if(!H.localized)return{values:void 0,default:H.original};try{const W=(await this.fileService.readFile(H.localized)).value.toString(),U=[],G=(0,L.parse)(W,U);return U.length>0?(Z(H.localized,U),{values:void 0,default:H.original}):(0,L.getNodeType)(G)!=="object"?(ne(H.localized),{values:void 0,default:H.original}):{values:G,default:H.original}}catch{return{values:void 0,default:H.original}}}}async resolveOriginalMessageBundle(j,te){if(j)try{const q=(await this.fileService.readFile(j)).value.toString();return(0,L.parse)(q,te)}catch{}}findMessageBundles(j,te){return new Promise((q,B)=>{const Z=ne=>{const le=(0,d.joinPath)(j,`package.nls.${ne}.json`);this.fileService.exists(le).then(ee=>{ee&&q({localized:le,original:(0,d.joinPath)(j,"package.nls.json")});const K=ne.lastIndexOf("-");K===-1?q({localized:(0,d.joinPath)(j,"package.nls.json"),original:null}):(ne=ne.substring(0,K),Z(ne))})};if(te.devMode||te.pseudo||!te.language)return q({localized:(0,d.joinPath)(j,"package.nls.json"),original:null});Z(te.language)})}formatMessage(j,te){return`[${j.path}]: ${te}`}};N=Ie([Y(1,h.IExtensionsProfileScannerService),Y(2,A.IUriIdentityService),Y(3,i.IFileService),Y(4,s.IProductService),Y(5,C.IEnvironmentService),Y(6,t.ILogService)],N);let M=class extends N{constructor(j,te,q,B,Z,ne,le,ee,K){super(te,B,Z,ne,le,ee,K),this.currentProfile=j,this.userDataProfilesService=q,this.cacheValidatorThrottler=this._register(new a.ThrottledDelayer(3e3)),this._onDidChangeCache=this._register(new r.Emitter),this.onDidChangeCache=this._onDidChangeCache.event}async scanExtensions(j){const te=this.getCacheFile(j),q=await this.readExtensionCache(te);if(this.input=j,q&&q.input&&F.equals(q.input,this.input))return this.logService.debug("Using cached extensions scan result",j.type===c.ExtensionType.System?"system":"user",j.location.toString()),this.cacheValidatorThrottler.trigger(()=>this.validateCache()),q.result.map(Z=>(Z.location=v.URI.revive(Z.location),Z));const B=await super.scanExtensions(j);return await this.writeExtensionCache(te,{input:j,result:B}),B}async readExtensionCache(j){try{const te=await this.fileService.readFile(j),q=JSON.parse(te.value.toString());return{result:q.result,input:(0,o.revive)(q.input)}}catch(te){this.logService.debug("Error while reading the extension cache file:",j.path,(0,k.getErrorMessage)(te))}return null}async writeExtensionCache(j,te){try{await this.fileService.writeFile(j,T.VSBuffer.fromString(JSON.stringify(te)))}catch(q){this.logService.debug("Error while writing the extension cache file:",j.path,(0,k.getErrorMessage)(q))}}async validateCache(){if(!this.input)return;const j=this.getCacheFile(this.input),te=await this.readExtensionCache(j);if(!te)return;const q=te.result,B=JSON.parse(JSON.stringify(await super.scanExtensions(this.input)));if(!_.equals(B,q))try{this.logService.info("Invalidating Cache",q,B),await this.fileService.del(j),this._onDidChangeCache.fire()}catch(Z){this.logService.error(Z)}}getCacheFile(j){const te=this.getProfile(j);return this.uriIdentityService.extUri.joinPath(te.cacheHome,j.type===c.ExtensionType.System?c.BUILTIN_MANIFEST_CACHE_FILE:c.USER_MANIFEST_CACHE_FILE)}getProfile(j){return j.type===c.ExtensionType.System?this.userDataProfilesService.defaultProfile:j.profile?this.uriIdentityService.extUri.isEqual(j.location,this.currentProfile.extensionsResource)?this.currentProfile:this.userDataProfilesService.profiles.find(te=>this.uriIdentityService.extUri.isEqual(j.location,te.extensionsResource))??this.currentProfile:this.userDataProfilesService.defaultProfile}};M=Ie([Y(2,y.IUserDataProfilesService),Y(3,h.IExtensionsProfileScannerService),Y(4,A.IUriIdentityService),Y(5,i.IFileService),Y(6,s.IProductService),Y(7,C.IEnvironmentService),Y(8,t.ILogService)],M);function V(J,j){const te=(0,p.getExtensionId)(J.manifest.publisher,J.manifest.name);return{id:te,identifier:new c.ExtensionIdentifier(te),isBuiltin:J.type===c.ExtensionType.System,isUserBuiltin:J.type===c.ExtensionType.User&&J.isBuiltin,isUnderDevelopment:j,extensionLocation:J.location,uuid:J.identifier.uuid,targetPlatform:J.targetPlatform,publisherDisplayName:J.publisherDisplayName,...J.manifest}}class z extends O{constructor(j,te,q,B,Z,ne,le,ee,K,H,W,U){super(j,te,(0,d.joinPath)(q,".vscode-oss-dev","extensions","control.json"),B,Z,ne,le,ee,K,H,W,U),this.translationsPromise=(async()=>{if(m.translationsConfigFile)try{const G=await this.fileService.readFile(v.URI.file(m.translationsConfigFile));return JSON.parse(G.value.toString())}catch{}return Object.create(null)})()}getTranslations(j){return this.translationsPromise}}e.NativeExtensionsScannerService=z}),define(he[217],fe([0,1,70,6,41,3,2,22,13,30,11,19]),function(ce,e,R,a,_,T,k,L,D,E,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let m=class extends k.Disposable{constructor(l,g){super(),this.userDataProfilesService=l,this.logService=g,this.processesLimiter=new a.Limiter(5)}async postUninstall(l){const g=this.parseScript(l,"uninstall");g&&(this.logService.info(l.identifier.id,l.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(async()=>{try{await this.runLifecycleHook(g.script,"uninstall",g.args,!0,l),this.logService.info("Finished running post uninstall script",l.identifier.id,l.manifest.version)}catch(I){this.logService.error("Failed to run post uninstall script",l.identifier.id,l.manifest.version),this.logService.error(I)}}));try{await E.Promises.rm(this.getExtensionStoragePath(l))}catch(I){this.logService.error("Error while removing extension storage path",l.identifier.id),this.logService.error(I)}}parseScript(l,g){const I=`vscode:${g}`;if(l.location.scheme===L.Schemas.file&&l.manifest&&l.manifest.scripts&&typeof l.manifest.scripts[I]=="string"){const v=l.manifest.scripts[I].split(" ");return v.length<2||v[0]!=="node"||!v[1]?(this.logService.warn(l.identifier.id,l.manifest.version,`${I} should be a node script`),null):{script:(0,D.join)(l.location.fsPath,v[1]),args:v.slice(2)||[]}}return null}runLifecycleHook(l,g,I,v,f){return new Promise((C,p)=>{const c=this.start(l,g,I,f);let u;const i=n=>{u&&(clearTimeout(u),u=null),n?p(n):C(void 0)};c.on("error",n=>{i((0,_.toErrorMessage)(n)||"Unknown")}),c.on("exit",(n,t)=>{i(n?`post-${g} process exited with code ${n}`:void 0)}),v&&(u=setTimeout(()=>{u=null,c.kill(),p("timed out")},5e3))})}start(l,g,I,v){const f={silent:!0,execArgv:void 0},C=(0,R.fork)(l,[`--type=extension-post-${g}`,...I],f);C.stdout.setEncoding("utf8"),C.stderr.setEncoding("utf8");const p=T.Event.fromNodeEventEmitter(C.stdout,"data"),c=T.Event.fromNodeEventEmitter(C.stderr,"data");this._register(p(n=>this.logService.info(v.identifier.id,v.manifest.version,`post-${g}`,n))),this._register(c(n=>this.logService.error(v.identifier.id,v.manifest.version,`post-${g}`,n)));const u=T.Event.any(T.Event.map(p,n=>({data:`%c${n}`,format:[""]}),this._store),T.Event.map(c,n=>({data:`%c${n}`,format:["color: red"]}),this._store));return T.Event.debounce(u,(n,t)=>n?{data:n.data+t.data,format:[...n.format,...t.format]}:{data:t.data,format:t.format},100,void 0,void 0,void 0,this._store)(n=>{console.group(v.identifier.id),console.log(n.data,...n.format),console.groupEnd()}),C}getExtensionStoragePath(l){return(0,D.join)(this.userDataProfilesService.defaultProfile.globalStorageHome.fsPath,l.identifier.id.toLowerCase())}};e.ExtensionsLifecycle=m,e.ExtensionsLifecycle=m=Ie([Y(0,S.IUserDataProfilesService),Y(1,P.ILogService)],m)}),define(he[118],fe([0,1,71,9,84,27]),function(ce,e,R,a,_,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fromExtractError=k,e.getManifest=L;function k(D){let E=T.ExtensionManagementErrorCode.Extract;return D instanceof R.ExtractError&&(D.type==="CorruptZip"?E=T.ExtensionManagementErrorCode.CorruptZip:D.type==="Incomplete"&&(E=T.ExtensionManagementErrorCode.IncompleteZip)),(0,_.toExtensionManagementError)(D,E)}async function L(D){let E;try{E=await(0,R.buffer)(D,"extension/package.json")}catch(P){throw k(P)}try{return JSON.parse(E.toString("utf8"))}catch{throw new T.ExtensionManagementError((0,a.localize)(1831,null),T.ExtensionManagementErrorCode.Invalid)}}}),define(he[218],fe([0,1,6,8,2,22,20,60,32,30,71,21,15,84,27,35,118,112,7,11,18]),function(ce,e,R,a,_,T,k,L,D,E,P,S,m,d,l,g,I,v,f,C,p){"use strict";var c;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0,L=De(L);let u=class extends _.Disposable{static{c=this}static{this.SignatureArchiveExtension=".sigzip"}constructor(n,t,s,r,o,h,y){super(),this.fileService=t,this.extensionGalleryService=s,this.configurationService=r,this.extensionSignatureVerificationService=o,this.telemetryService=h,this.logService=y,this.extensionsDownloadDir=n.extensionsDownloadLocation,this.cache=20,this.cleanUpPromise=this.cleanUp()}async download(n,t,s,r){await this.cleanUpPromise;const o=await this.downloadVSIX(n,t);let h=!1;if(s&&this.shouldVerifySignature(n)){let y;try{y=await this.downloadSignatureArchive(n)}catch(A){try{await this.delete(o)}catch(b){this.logService.error(b)}throw A}try{h=await this.extensionSignatureVerificationService.verify(n,o.fsPath,y.fsPath,r)}catch(A){if(h=A.code,h===v.ExtensionSignatureVerificationCode.PackageIsInvalidZip||h===v.ExtensionSignatureVerificationCode.SignatureArchiveIsInvalidZip){try{await this.delete(o)}catch(b){this.logService.error(b)}throw new l.ExtensionManagementError(P.CorruptZipMessage,l.ExtensionManagementErrorCode.CorruptZip)}}finally{try{await this.delete(y)}catch(A){this.logService.error(A)}}}return{location:o,verificationStatus:h}}shouldVerifySignature(n){return n.isSigned||this.logService.info(`Extension is not signed: ${n.identifier.id}`),!1}async downloadVSIX(n,t){try{const s=(0,k.joinPath)(this.extensionsDownloadDir,this.getName(n)),r=await this.doDownload(n,"vsix",async()=>{await this.downloadFile(n,s,o=>this.extensionGalleryService.download(n,o,t));try{await this.validate(s.fsPath,"extension/package.json")}catch(o){try{await this.fileService.del(s)}catch(h){this.logService.warn(`Error while deleting: ${s.path}`,(0,a.getErrorMessage)(h))}throw o}},2);return r>1&&this.telemetryService.publicLog2("extensiongallery:downloadvsix:retry",{extensionId:n.identifier.id,attempts:r}),s}catch(s){throw(0,d.toExtensionManagementError)(s,l.ExtensionManagementErrorCode.Download)}}async downloadSignatureArchive(n){try{const t=(0,k.joinPath)(this.extensionsDownloadDir,`.${(0,D.generateUuid)()}`),s=await this.doDownload(n,"sigzip",async()=>{await this.extensionGalleryService.downloadSignatureArchive(n,t);try{await this.validate(t.fsPath,".signature.p7s")}catch(r){try{await this.fileService.del(t)}catch(o){this.logService.warn(`Error while deleting: ${t.path}`,(0,a.getErrorMessage)(o))}throw r}},2);return s>1&&this.telemetryService.publicLog2("extensiongallery:downloadsigzip:retry",{extensionId:n.identifier.id,attempts:s}),t}catch(t){throw(0,d.toExtensionManagementError)(t,l.ExtensionManagementErrorCode.DownloadSignature)}}async downloadFile(n,t,s){if(await this.fileService.exists(t))return;if(t.scheme!==T.Schemas.file){await s(t);return}const r=(0,k.joinPath)(this.extensionsDownloadDir,`.${(0,D.generateUuid)()}`);try{await s(r)}catch(o){try{await this.fileService.del(r)}catch{}throw o}try{await E.Promises.rename(r.fsPath,t.fsPath,2*60*1e3)}catch(o){try{await this.fileService.del(r)}catch{}let h=!1;try{h=await this.fileService.exists(t)}catch{}if(h)this.logService.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",n.identifier.id,t.path);else throw this.logService.info(`Rename failed because of ${(0,a.getErrorMessage)(o)}. Deleted the file from downloaded location`,r.path),o}}async doDownload(n,t,s,r){let o=1;for(;;)try{return await s(),o}catch(h){if(o++>r)throw h;this.logService.warn(`Failed downloading ${t}. ${(0,a.getErrorMessage)(h)}. Retry again...`,n.identifier.id)}}async validate(n,t){try{await(0,P.buffer)(n,t)}catch(s){throw(0,I.fromExtractError)(s)}}async delete(n){await this.cleanUpPromise,await this.fileService.del(n)}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downloads cache dir does not exist");return}const n=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(n.children){const t=[],s=[],r=[];for(const y of n.children)if(y.name.endsWith(c.SignatureArchiveExtension))r.push(y.resource);else{const A=g.ExtensionKey.parse(y.name);A&&s.push([A,y])}const o=(0,g.groupByExtension)(s,([y])=>y),h=[];for(const y of o)y.sort((A,b)=>L.rcompare(A[0].version,b[0].version)),t.push(...y.slice(1).map(A=>A[1].resource)),h.push(y[0][1]);h.sort((y,A)=>y.mtime-A.mtime),t.push(...h.slice(0,Math.max(0,h.length-this.cache)).map(y=>y.resource)),t.push(...r),await R.Promises.settled(t.map(y=>(this.logService.trace("Deleting from cache",y.path),this.fileService.del(y))))}}catch(n){this.logService.error(n)}}getName(n){return this.cache?g.ExtensionKey.create(n).toString().toLowerCase():(0,D.generateUuid)()}};e.ExtensionsDownloader=u,e.ExtensionsDownloader=u=c=Ie([Y(0,m.INativeEnvironmentService),Y(1,f.IFileService),Y(2,l.IExtensionGalleryService),Y(3,S.IConfigurationService),Y(4,v.IExtensionSignatureVerificationService),Y(5,p.ITelemetryService),Y(6,C.ILogService)],u)}),define(he[119],fe([0,1,33,6,14,25,41,8,3,55,2,31,22,13,20,60,12,10,32,30,71,9,100,15,84,27,35,52,85,218,217,118,190,200,34,59,7,4,11,23,18,28,19]),function(ce,e,R,a,_,T,k,L,D,E,P,S,m,d,l,g,I,v,f,C,p,c,u,i,n,t,s,r,o,h,y,A,b,w,O,F,N,M,V,z,J,j,te){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScanner=e.ExtensionManagementService=e.INativeServerExtensionManagementService=void 0,R=De(R),d=De(d),g=De(g),C=De(C),c=De(c),e.INativeServerExtensionManagementService=(0,M.refineServiceDecorator)(t.IExtensionManagementService);const q=".vsctmp";let B=class extends n.AbstractExtensionManagementService{constructor(K,H,W,U,G,oe,Q,X,x,$,ie,ae){super(K,H,ie,W,$,ae),this.extensionsScannerService=G,this.extensionsProfileScannerService=oe,this.downloadService=Q,this.instantiationService=X,this.fileService=x,this.extractingGalleryExtensions=new Map,this.knownDirectories=new S.ResourceSet;const ue=this._register(X.createInstance(y.ExtensionsLifecycle));this.extensionsScanner=this._register(X.createInstance(Z,Ee=>ue.postUninstall(Ee))),this.manifestCache=this._register(new b.ExtensionsManifestCache(ae,x,ie,this,this.logService)),this.extensionsDownloader=this._register(X.createInstance(h.ExtensionsDownloader));const Se=this._register(new w.ExtensionsWatcher(this,this.extensionsScannerService,ae,oe,ie,x,W));this._register(Se.onDidChangeExtensionsByAnotherSource(Ee=>this.onDidChangeExtensionsFromAnotherSource(Ee))),this.watchForExtensionsNotInstalledBySystem()}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,s.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async zip(K){this.logService.trace("ExtensionManagementService#zip",K.identifier.id);const H=await this.collectFiles(K),W=await(0,p.zip)((0,l.joinPath)(this.extensionsDownloader.extensionsDownloadDir,(0,f.generateUuid)()).fsPath,H);return v.URI.file(W)}async getManifest(K){const{location:H,cleanup:W}=await this.downloadVsix(K),U=d.resolve(H.fsPath);try{return await(0,A.getManifest)(U)}finally{await W()}}getInstalled(K,H=this.userDataProfilesService.defaultProfile.extensionsResource,W={version:this.productService.version,date:this.productService.date}){return this.extensionsScanner.scanExtensions(K??null,H,W)}scanAllUserInstalledExtensions(){return this.extensionsScanner.scanAllUserExtensions(!1)}scanInstalledExtensionAtLocation(K){return this.extensionsScanner.scanUserExtensionAtLocation(K)}async install(K,H={}){this.logService.trace("ExtensionManagementService#install",K.toString());const{location:W,cleanup:U}=await this.downloadVsix(K);try{const G=await(0,A.getManifest)(d.resolve(W.fsPath)),oe=(0,s.getGalleryExtensionId)(G.publisher,G.name);if(G.engines&&G.engines.vscode&&!(0,F.isEngineValid)(G.engines.vscode,this.productService.version,this.productService.date))throw new Error(c.localize(1822,null,oe,this.productService.version));const X=(await this.installExtensions([{manifest:G,extension:W,options:H}])).find(({identifier:x})=>(0,s.areSameExtensions)(x,{id:oe}));if(X?.local)return X.local;throw X?.error?X.error:(0,n.toExtensionManagementError)(new Error(`Unknown error while installing extension ${oe}`))}finally{await U()}}async installFromLocation(K,H){this.logService.trace("ExtensionManagementService#installFromLocation",K.toString());const W=await this.extensionsScanner.scanUserExtensionAtLocation(K);if(!W||!W.manifest.name||!W.manifest.version)throw new Error(`Cannot find a valid extension from the location ${K.toString()}`);return await this.addExtensionsToProfile([[W,{source:"resource"}]],H),this.logService.info("Successfully installed extension",W.identifier.id,H.toString()),W}async installExtensionsFromProfile(K,H,W){this.logService.trace("ExtensionManagementService#installExtensionsFromProfile",K,H.toString(),W.toString());const U=(await this.getInstalled(O.ExtensionType.User,H)).filter(G=>K.some(oe=>(0,s.areSameExtensions)(oe,G.identifier)));if(U.length){const G=await Promise.all(U.map(oe=>this.extensionsScanner.scanMetadata(oe,H)));await this.addExtensionsToProfile(U.map((oe,Q)=>[oe,G[Q]]),W),this.logService.info("Successfully installed extensions",U.map(oe=>oe.identifier.id),W.toString())}return U}async updateMetadata(K,H,W){return this.logService.trace("ExtensionManagementService#updateMetadata",K.identifier.id),H.isPreReleaseVersion&&(H.preRelease=!0,H.hasPreReleaseVersion=!0),H.isMachineScoped===!1&&(H.isMachineScoped=void 0),H.isBuiltin===!1&&(H.isBuiltin=void 0),H.pinned===!1&&(H.pinned=void 0),K=await this.extensionsScanner.updateMetadata(K,H,W),this.manifestCache.invalidate(W),this._onDidUpdateExtensionMetadata.fire({local:K,profileLocation:W}),K}async reinstallFromGallery(K){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",K.identifier.id),!this.galleryService.isEnabled())throw new Error(c.localize(1823,null));const H=await this.getTargetPlatform(),[W]=await this.galleryService.getExtensions([{...K.identifier,preRelease:K.preRelease}],{targetPlatform:H,compatible:!0},T.CancellationToken.None);if(!W)throw new Error(c.localize(1824,null));await this.extensionsScanner.setUninstalled(K);try{await this.extensionsScanner.removeUninstalledExtension(K)}catch(U){throw new Error(c.localize(1825,null,(0,k.toErrorMessage)(U)))}return this.installFromGallery(W)}copyExtension(K,H,W,U){return this.extensionsScanner.copyExtension(K,H,W,U)}copyExtensions(K,H){return this.extensionsScanner.copyExtensions(K,H,{version:this.productService.version,date:this.productService.date})}markAsUninstalled(...K){return this.extensionsScanner.setUninstalled(...K)}async cleanUp(){this.logService.trace("ExtensionManagementService#cleanUp");try{await this.extensionsScanner.cleanUp()}catch(K){this.logService.error(K)}}async download(K,H,W){const{location:U}=await this.extensionsDownloader.download(K,H,!W);return U}async downloadVsix(K){if(K.scheme===m.Schemas.file)return{location:K,async cleanup(){}};this.logService.trace("Downloading extension from",K.toString());const H=(0,l.joinPath)(this.extensionsDownloader.extensionsDownloadDir,(0,f.generateUuid)());return await this.downloadService.download(K,H),this.logService.info("Downloaded extension to",H.toString()),{location:H,cleanup:async()=>{try{await this.fileService.del(H)}catch(U){this.logService.error(U)}}}}getCurrentExtensionsManifestLocation(){return this.userDataProfilesService.defaultProfile.extensionsResource}createInstallExtensionTask(K,H,W){const U=H instanceof v.URI?new s.ExtensionKey({id:(0,s.getGalleryExtensionId)(K.publisher,K.name)},K.version):s.ExtensionKey.create(H);return this.instantiationService.createInstance(ne,U,K,H,W,(G,oe)=>{if(H instanceof v.URI)return this.extractVSIX(U,H,W,oe);let Q=this.extractingGalleryExtensions.get(U.toString());return Q||(this.extractingGalleryExtensions.set(U.toString(),Q=this.downloadAndExtractGalleryExtension(U,H,G,W,oe)),Q.finally(()=>this.extractingGalleryExtensions.delete(U.toString()))),Q},this.extensionsScanner)}createUninstallExtensionTask(K,H){return new le(K,H,this.extensionsProfileScannerService)}async downloadAndExtractGalleryExtension(K,H,W,U,G){const{verificationStatus:oe,location:Q}=await this.extensionsDownloader.download(H,W,!U.donotVerifySignature,U.context?.[t.EXTENSION_INSTALL_CLIENT_TARGET_PLATFORM_CONTEXT]);try{if(G.isCancellationRequested)throw new L.CancellationError;const X=await(0,A.getManifest)(Q.fsPath);if(!new s.ExtensionKey(H.identifier,H.version).equals(new s.ExtensionKey({id:(0,s.getGalleryExtensionId)(X.publisher,X.name)},X.version)))throw new t.ExtensionManagementError(c.localize(1826,null,H.identifier.id),t.ExtensionManagementErrorCode.Invalid);return{local:await this.extensionsScanner.extractUserExtension(K,Q.fsPath,{id:H.identifier.uuid,publisherId:H.publisherId,publisherDisplayName:H.publisherDisplayName,targetPlatform:H.properties.targetPlatform,isApplicationScoped:U.isApplicationScoped,isMachineScoped:U.isMachineScoped,isBuiltin:U.isBuiltin,isPreReleaseVersion:H.properties.isPreReleaseVersion,hasPreReleaseVersion:H.properties.isPreReleaseVersion,installedTimestamp:Date.now(),pinned:U.installGivenVersion?!0:!!U.pinned,preRelease:(0,I.isBoolean)(U.preRelease)?U.preRelease:U.installPreReleaseVersion||H.properties.isPreReleaseVersion,source:"gallery"},!1,G),verificationStatus:oe}}catch(X){try{await this.extensionsDownloader.delete(Q)}catch(x){this.logService.warn("Error while deleting the downloaded file",Q.toString(),(0,L.getErrorMessage)(x))}throw(0,n.toExtensionManagementError)(X)}}async extractVSIX(K,H,W,U){return{local:await this.extensionsScanner.extractUserExtension(K,d.resolve(H.fsPath),{isApplicationScoped:W.isApplicationScoped,isMachineScoped:W.isMachineScoped,isBuiltin:W.isBuiltin,installedTimestamp:Date.now(),pinned:W.installGivenVersion?!0:!!W.pinned,source:"vsix"},W.keepExisting??!0,U)}}async collectFiles(K){const H=async U=>{let G=await C.Promises.readdir(U);G=G.map(X=>d.join(U,X));const oe=await Promise.all(G.map(X=>R.promises.stat(X)));let Q=Promise.resolve([]);return oe.forEach((X,x)=>{const $=G[x];X.isFile()&&(Q=Q.then(ie=>[...ie,$])),X.isDirectory()&&(Q=Q.then(ie=>H($).then(ae=>[...ie,...ae])))}),Q};return(await H(K.location.fsPath)).map(U=>({path:`extension/${d.relative(K.location.fsPath,U)}`,localPath:U}))}async onDidChangeExtensionsFromAnotherSource({added:K,removed:H}){if(H){const W=K&&this.uriIdentityService.extUri.isEqual(H.profileLocation,K.profileLocation)?H.extensions.filter(U=>K.extensions.every(G=>!(0,s.areSameExtensions)(G,U))):H.extensions;for(const U of W)this.logService.info("Extensions removed from another source",U.id,H.profileLocation.toString()),this._onDidUninstallExtension.fire({identifier:U,profileLocation:H.profileLocation})}if(K){const U=(await this.getInstalled(O.ExtensionType.User,K.profileLocation)).filter(G=>K.extensions.some(oe=>(0,s.areSameExtensions)(oe,G.identifier)));this._onDidInstallExtensions.fire(U.map(G=>(this.logService.info("Extensions added from another source",G.identifier.id,K.profileLocation.toString()),{identifier:G.identifier,local:G,profileLocation:K.profileLocation,operation:t.InstallOperation.None})))}}async watchForExtensionsNotInstalledBySystem(){this._register(this.extensionsScanner.onExtract(H=>this.knownDirectories.add(H)));const K=await this.fileService.resolve(this.extensionsScannerService.userExtensionsLocation);for(const H of K.children??[])H.isDirectory&&this.knownDirectories.add(H.resource);this._register(this.fileService.watch(this.extensionsScannerService.userExtensionsLocation)),this._register(this.fileService.onDidFilesChange(H=>this.onDidFilesChange(H)))}async onDidFilesChange(K){if(!K.affects(this.extensionsScannerService.userExtensionsLocation,N.FileChangeType.ADDED))return;const H=[];for(const W of K.rawAdded){if(this.knownDirectories.has(W)||!this.uriIdentityService.extUri.isEqual(this.uriIdentityService.extUri.dirname(W),this.extensionsScannerService.userExtensionsLocation)||this.uriIdentityService.extUri.isEqual(W,this.uriIdentityService.extUri.joinPath(this.extensionsScannerService.userExtensionsLocation,".obsolete"))||this.uriIdentityService.extUri.basename(W).startsWith(".")||!(await this.fileService.stat(W)).isDirectory)continue;const U=await this.extensionsScanner.scanUserExtensionAtLocation(W);U&&U.installedTimestamp===void 0&&(this.knownDirectories.add(W),H.push(U))}H.length&&(await this.addExtensionsToProfile(H.map(W=>[W,void 0]),this.userDataProfilesService.defaultProfile.extensionsResource),this.logService.info("Added extensions to default profile from external source",H.map(W=>W.identifier.id)))}async addExtensionsToProfile(K,H){const W=K.map(U=>U[0]);await this.setInstalled(W),await this.extensionsProfileScannerService.addExtensionsToProfile(K,H),this._onDidInstallExtensions.fire(W.map(U=>({local:U,identifier:U.identifier,operation:t.InstallOperation.None,profileLocation:H})))}async setInstalled(K){const H=await this.extensionsScanner.getUninstalledExtensions();for(const W of K){const U=s.ExtensionKey.create(W);H[U.toString()]&&(this.logService.trace("Removing the extension from uninstalled list:",U.id),await this.extensionsScanner.setInstalled(U),this.logService.info("Removed the extension from uninstalled list:",U.id))}}};e.ExtensionManagementService=B,e.ExtensionManagementService=B=Ie([Y(0,t.IExtensionGalleryService),Y(1,J.ITelemetryService),Y(2,V.ILogService),Y(3,i.INativeEnvironmentService),Y(4,o.IExtensionsScannerService),Y(5,r.IExtensionsProfileScannerService),Y(6,u.IDownloadService),Y(7,M.IInstantiationService),Y(8,N.IFileService),Y(9,z.IProductService),Y(10,j.IUriIdentityService),Y(11,te.IUserDataProfilesService)],B);let Z=class extends P.Disposable{constructor(K,H,W,U,G,oe,Q){super(),this.beforeRemovingExtension=K,this.fileService=H,this.extensionsScannerService=W,this.extensionsProfileScannerService=U,this.uriIdentityService=G,this.telemetryService=oe,this.logService=Q,this._onExtract=this._register(new D.Emitter),this.onExtract=this._onExtract.event,this.scanAllExtensionPromise=new S.ResourceMap,this.scanUserExtensionsPromise=new S.ResourceMap,this.uninstalledResource=(0,l.joinPath)(this.extensionsScannerService.userExtensionsLocation,".obsolete"),this.uninstalledFileLimiter=new a.Queue}async cleanUp(){await this.removeTemporarilyDeletedFolders(),await this.removeUninstalledExtensions()}async scanExtensions(K,H,W){try{const U={includeInvalid:!0,profileLocation:H,productVersion:W};let G=[];if(K===null||K===O.ExtensionType.System){let oe=this.scanAllExtensionPromise.get(H);oe||(oe=this.extensionsScannerService.scanAllExtensions({includeInvalid:!0,useCache:!0},U,!1).finally(()=>this.scanAllExtensionPromise.delete(H)),this.scanAllExtensionPromise.set(H,oe)),G.push(...await oe)}else if(K===O.ExtensionType.User){let oe=this.scanUserExtensionsPromise.get(H);oe||(oe=this.extensionsScannerService.scanUserExtensions(U).finally(()=>this.scanUserExtensionsPromise.delete(H)),this.scanUserExtensionsPromise.set(H,oe)),G.push(...await oe)}return G=K!==null?G.filter(oe=>oe.type===K):G,await Promise.all(G.map(oe=>this.toLocalExtension(oe)))}catch(U){throw(0,n.toExtensionManagementError)(U,t.ExtensionManagementErrorCode.Scanning)}}async scanAllUserExtensions(K){try{const H=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!K,includeInvalid:!0});return await Promise.all(H.map(W=>this.toLocalExtension(W)))}catch(H){throw(0,n.toExtensionManagementError)(H,t.ExtensionManagementErrorCode.Scanning)}}async scanUserExtensionAtLocation(K){try{const H=await this.extensionsScannerService.scanExistingExtension(K,O.ExtensionType.User,{includeInvalid:!0});if(H)return await this.toLocalExtension(H)}catch(H){this.logService.error(H)}return null}async extractUserExtension(K,H,W,U,G){const oe=K.toString(),Q=v.URI.file(d.join(this.extensionsScannerService.userExtensionsLocation.fsPath,`.${(0,f.generateUuid)()}`)),X=v.URI.file(d.join(this.extensionsScannerService.userExtensionsLocation.fsPath,oe));if(await this.fileService.exists(X)){if(!U)try{return await this.scanLocalExtension(X,O.ExtensionType.User)}catch(x){this.logService.warn(`Error while scanning the existing extension at ${X.path}. Deleting the existing extension and extracting it.`,(0,L.getErrorMessage)(x))}try{await this.deleteExtensionFromLocation(K.id,X,"removeExisting")}catch{throw new t.ExtensionManagementError(c.localize(1827,null,X.fsPath,K.id),t.ExtensionManagementErrorCode.Delete)}}try{if(G.isCancellationRequested)throw new L.CancellationError;try{this.logService.trace(`Started extracting the extension from ${H} to ${X.fsPath}`),await(0,p.extract)(H,Q.fsPath,{sourcePath:"extension",overwrite:!0},G),this.logService.info(`Extracted extension to ${X}:`,K.id)}catch(x){throw(0,A.fromExtractError)(x)}try{await this.extensionsScannerService.updateMetadata(Q,W)}catch(x){throw this.telemetryService.publicLog2("extension:extract",{extensionId:K.id,code:`${(0,N.toFileOperationResult)(x)}`}),(0,n.toExtensionManagementError)(x,t.ExtensionManagementErrorCode.UpdateMetadata)}if(G.isCancellationRequested)throw new L.CancellationError;try{this.logService.trace(`Started renaming the extension from ${Q.fsPath} to ${X.fsPath}`),await this.rename(Q.fsPath,X.fsPath),this.logService.info("Renamed to",X.fsPath)}catch(x){if(x.code==="ENOTEMPTY"){this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",K.id);try{await this.fileService.del(Q,{recursive:!0})}catch{}}else throw this.logService.info(`Rename failed because of ${(0,L.getErrorMessage)(x)}. Deleted from extracted location`,Q),x}this._onExtract.fire(X)}catch(x){try{await this.fileService.del(Q,{recursive:!0})}catch{}throw x}return this.scanLocalExtension(X,O.ExtensionType.User)}async scanMetadata(K,H){return H?(await this.getScannedExtension(K,H))?.metadata:this.extensionsScannerService.scanMetadata(K.location)}async getScannedExtension(K,H){return(await this.extensionsProfileScannerService.scanProfileExtensions(H)).find(U=>(0,s.areSameExtensions)(U.identifier,K.identifier))}async updateMetadata(K,H,W){try{W?await this.extensionsProfileScannerService.updateMetadata([[K,H]],W):await this.extensionsScannerService.updateMetadata(K.location,H)}catch(U){throw this.telemetryService.publicLog2("extension:extract",{extensionId:K.identifier.id,code:`${(0,N.toFileOperationResult)(U)}`,isProfile:!!W}),(0,n.toExtensionManagementError)(U,t.ExtensionManagementErrorCode.UpdateMetadata)}return this.scanLocalExtension(K.location,K.type,W)}async getUninstalledExtensions(){try{return await this.withUninstalledExtensions()}catch(K){throw(0,n.toExtensionManagementError)(K,t.ExtensionManagementErrorCode.ReadUninstalled)}}async setUninstalled(...K){const H=K.map(W=>s.ExtensionKey.create(W));await this.withUninstalledExtensions(W=>H.forEach(U=>{W[U.toString()]=!0,this.logService.info("Marked extension as uninstalled",U.toString())}))}async setInstalled(K){try{await this.withUninstalledExtensions(H=>delete H[K.toString()])}catch(H){throw(0,n.toExtensionManagementError)(H,t.ExtensionManagementErrorCode.UnsetUninstalled)}}async removeExtension(K,H){if(this.uriIdentityService.extUri.isEqualOrParent(K.location,this.extensionsScannerService.userExtensionsLocation))return this.deleteExtensionFromLocation(K.identifier.id,K.location,H)}async removeUninstalledExtension(K){await this.removeExtension(K,"uninstalled"),await this.withUninstalledExtensions(H=>delete H[s.ExtensionKey.create(K).toString()])}async copyExtension(K,H,W,U){const G=await this.getScannedExtension(K,H),oe=await this.getScannedExtension(K,W);if(U={...G?.metadata,...U},oe)if(this.uriIdentityService.extUri.isEqual(oe.location,K.location))await this.extensionsProfileScannerService.updateMetadata([[K,{...oe.metadata,...U}]],W);else{const Q=await this.scanLocalExtension(oe.location,K.type,W);await this.extensionsProfileScannerService.removeExtensionFromProfile(Q,W),await this.extensionsProfileScannerService.addExtensionsToProfile([[K,{...oe.metadata,...U}]],W)}else await this.extensionsProfileScannerService.addExtensionsToProfile([[K,U]],W);return this.scanLocalExtension(K.location,K.type,W)}async copyExtensions(K,H,W){const U=await this.scanExtensions(O.ExtensionType.User,K,W),G=await Promise.all(U.filter(oe=>!oe.isApplicationScoped).map(async oe=>[oe,await this.scanMetadata(oe,K)]));await this.extensionsProfileScannerService.addExtensionsToProfile(G,H)}async deleteExtensionFromLocation(K,H,W){this.logService.trace(`Deleting ${W} extension from disk`,K,H.fsPath);const U=this.uriIdentityService.extUri.joinPath(this.uriIdentityService.extUri.dirname(H),`${this.uriIdentityService.extUri.basename(H)}.${(0,E.hash)((0,f.generateUuid)()).toString(16)}${q}`);await this.rename(H.fsPath,U.fsPath),await this.fileService.del(U,{recursive:!0}),this.logService.info(`Deleted ${W} extension from disk`,K,H.fsPath)}withUninstalledExtensions(K){return this.uninstalledFileLimiter.queue(async()=>{let H;try{H=(await this.fileService.readFile(this.uninstalledResource,"utf8")).value.toString()}catch(U){if((0,N.toFileOperationResult)(U)!==N.FileOperationResult.FILE_NOT_FOUND)throw U}let W={};if(H)try{W=JSON.parse(H)}catch{}return K&&(K(W),Object.keys(W).length?await this.fileService.writeFile(this.uninstalledResource,_.VSBuffer.fromString(JSON.stringify(W))):await this.fileService.del(this.uninstalledResource)),W})}async rename(K,H){try{await C.Promises.rename(K,H,2*60*1e3)}catch(W){throw(0,n.toExtensionManagementError)(W,t.ExtensionManagementErrorCode.Rename)}}async scanLocalExtension(K,H,W){try{if(W){const G=(await this.extensionsScannerService.scanUserExtensions({profileLocation:W})).find(oe=>this.uriIdentityService.extUri.isEqual(oe.location,K));if(G)return await this.toLocalExtension(G)}else{const U=await this.extensionsScannerService.scanExistingExtension(K,H,{includeInvalid:!0});if(U)return await this.toLocalExtension(U)}throw new t.ExtensionManagementError(c.localize(1828,null,K.path),t.ExtensionManagementErrorCode.ScanningExtension)}catch(U){throw(0,n.toExtensionManagementError)(U,t.ExtensionManagementErrorCode.ScanningExtension)}}async toLocalExtension(K){const H=await this.fileService.resolve(K.location);let W,U;return H.children&&(W=H.children.find(({name:G})=>/^readme(\.txt|\.md|)$/i.test(G))?.resource,U=H.children.find(({name:G})=>/^changelog(\.txt|\.md|)$/i.test(G))?.resource),{identifier:K.identifier,type:K.type,isBuiltin:K.isBuiltin||!!K.metadata?.isBuiltin,location:K.location,manifest:K.manifest,targetPlatform:K.targetPlatform,validations:K.validations,isValid:K.isValid,readmeUrl:W,changelogUrl:U,publisherDisplayName:K.metadata?.publisherDisplayName,publisherId:K.metadata?.publisherId||null,isApplicationScoped:!!K.metadata?.isApplicationScoped,isMachineScoped:!!K.metadata?.isMachineScoped,isPreReleaseVersion:!!K.metadata?.isPreReleaseVersion,hasPreReleaseVersion:!!K.metadata?.hasPreReleaseVersion,preRelease:!!K.metadata?.preRelease,installedTimestamp:K.metadata?.installedTimestamp,updated:!!K.metadata?.updated,pinned:!!K.metadata?.pinned,isWorkspaceScoped:!1,source:K.metadata?.source??(K.identifier.uuid?"gallery":"vsix")}}async removeUninstalledExtensions(){const K=await this.getUninstalledExtensions();if(Object.keys(K).length===0){this.logService.debug("No uninstalled extensions found.");return}this.logService.debug("Removing uninstalled extensions:",Object.keys(K));const H=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),W=new Set;for(const G of H)K[s.ExtensionKey.create(G).toString()]||W.add(G.identifier.id.toLowerCase());try{const G=(0,s.groupByExtension)(H,oe=>oe.identifier);await a.Promises.settled(G.map(async oe=>{const Q=oe.sort((X,x)=>g.rcompare(X.manifest.version,x.manifest.version))[0];W.has(Q.identifier.id.toLowerCase())||await this.beforeRemovingExtension(await this.toLocalExtension(Q))}))}catch(G){this.logService.error(G)}const U=H.filter(G=>G.metadata&&K[s.ExtensionKey.create(G).toString()]);await Promise.allSettled(U.map(G=>this.removeUninstalledExtension(G)))}async removeTemporarilyDeletedFolders(){this.logService.trace("ExtensionManagementService#removeTempDeleteFolders");let K;try{K=await this.fileService.resolve(this.extensionsScannerService.userExtensionsLocation)}catch(H){(0,N.toFileOperationResult)(H)!==N.FileOperationResult.FILE_NOT_FOUND&&this.logService.error(H);return}if(K?.children)try{await Promise.allSettled(K.children.map(async H=>{if(!(!H.isDirectory||!H.name.endsWith(q))){this.logService.trace("Deleting the temporarily deleted folder",H.resource.toString());try{await this.fileService.del(H.resource,{recursive:!0}),this.logService.trace("Deleted the temporarily deleted folder",H.resource.toString())}catch(W){(0,N.toFileOperationResult)(W)!==N.FileOperationResult.FILE_NOT_FOUND&&this.logService.error(W)}}}))}catch{}}};e.ExtensionsScanner=Z,e.ExtensionsScanner=Z=Ie([Y(1,N.IFileService),Y(2,o.IExtensionsScannerService),Y(3,r.IExtensionsProfileScannerService),Y(4,j.IUriIdentityService),Y(5,J.ITelemetryService),Y(6,V.ILogService)],Z);let ne=class extends n.AbstractExtensionTask{get operation(){return this.options.operation??this._operation}get verificationStatus(){return this._verificationStatus}constructor(K,H,W,U,G,oe,Q,X,x,$,ie,ae){super(),this.extensionKey=K,this.manifest=H,this.source=W,this.options=U,this.extractExtensionFn=G,this.extensionsScanner=oe,this.uriIdentityService=Q,this.galleryService=X,this.userDataProfilesService=x,this.extensionsScannerService=$,this.extensionsProfileScannerService=ie,this.logService=ae,this._operation=t.InstallOperation.Install,this.identifier=this.extensionKey.identifier}async doRun(K){const W=(await this.extensionsScanner.scanExtensions(O.ExtensionType.User,this.options.profileLocation,this.options.productVersion)).find(Q=>(0,s.areSameExtensions)(Q.identifier,this.identifier));W&&(this._operation=t.InstallOperation.Update);const U={isApplicationScoped:this.options.isApplicationScoped||W?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||W?.isMachineScoped,isBuiltin:this.options.isBuiltin||W?.isBuiltin,isSystem:W?.type===O.ExtensionType.System?!0:void 0,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:this.options.pinned??W?.pinned,source:this.source instanceof v.URI?"vsix":"gallery"};let G;if(this.source instanceof v.URI){if(W&&this.extensionKey.equals(new s.ExtensionKey(W.identifier,W.manifest.version)))try{await this.extensionsScanner.removeExtension(W,"existing")}catch{throw new Error(c.localize(1829,null,this.manifest.displayName||this.manifest.name))}const Q=await this.unsetIfUninstalled(this.extensionKey);if(Q)try{await this.extensionsScanner.removeExtension(Q,"existing")}catch{throw new Error(c.localize(1830,null,this.manifest.displayName||this.manifest.name))}}else{if(U.id=this.source.identifier.uuid,U.publisherId=this.source.publisherId,U.publisherDisplayName=this.source.publisherDisplayName,U.targetPlatform=this.source.properties.targetPlatform,U.updated=!!W,U.isPreReleaseVersion=this.source.properties.isPreReleaseVersion,U.hasPreReleaseVersion=W?.hasPreReleaseVersion||this.source.properties.isPreReleaseVersion,U.preRelease=(0,I.isBoolean)(this.options.preRelease)?this.options.preRelease:this.options.installPreReleaseVersion||this.source.properties.isPreReleaseVersion||W?.preRelease,W&&W.type!==O.ExtensionType.System&&W.manifest.version===this.source.version)return this.extensionsScanner.updateMetadata(W,U,this.options.profileLocation);G=await this.unsetIfUninstalled(this.extensionKey)}if(K.isCancellationRequested)throw(0,n.toExtensionManagementError)(new L.CancellationError);if(!G){const Q=await this.extractExtensionFn(this.operation,K);G=Q.local,this._verificationStatus=Q.verificationStatus}if(this.uriIdentityService.extUri.isEqual(this.userDataProfilesService.defaultProfile.extensionsResource,this.options.profileLocation))try{await this.extensionsScannerService.initializeDefaultProfileExtensions()}catch(Q){throw(0,n.toExtensionManagementError)(Q,t.ExtensionManagementErrorCode.IntializeDefaultProfile)}if(K.isCancellationRequested)throw(0,n.toExtensionManagementError)(new L.CancellationError);try{await this.extensionsProfileScannerService.addExtensionsToProfile([[G,U]],this.options.profileLocation,!G.isValid)}catch(Q){throw(0,n.toExtensionManagementError)(Q,t.ExtensionManagementErrorCode.AddToProfile)}const oe=await this.extensionsScanner.scanLocalExtension(G.location,O.ExtensionType.User,this.options.profileLocation);if(!oe)throw new t.ExtensionManagementError("Cannot find the installed extension",t.ExtensionManagementErrorCode.InstalledExtensionNotFound);return this.source instanceof v.URI&&this.updateMetadata(G,K),oe}async unsetIfUninstalled(K){return(await this.extensionsScanner.getUninstalledExtensions())[K.toString()]?(this.logService.trace("Removing the extension from uninstalled list:",K.id),await this.extensionsScanner.setInstalled(K),this.logService.info("Removed the extension from uninstalled list:",K.id),(await this.extensionsScanner.scanAllUserExtensions(!0)).find(U=>s.ExtensionKey.create(U).equals(K))):void 0}async updateMetadata(K,H){try{let[W]=await this.galleryService.getExtensions([{id:K.identifier.id,version:K.manifest.version}],H);if(W||([W]=await this.galleryService.getExtensions([{id:K.identifier.id}],H)),W){const U={id:W.identifier.uuid,publisherDisplayName:W.publisherDisplayName,publisherId:W.publisherId,isPreReleaseVersion:W.properties.isPreReleaseVersion,hasPreReleaseVersion:K.hasPreReleaseVersion||W.properties.isPreReleaseVersion,preRelease:W.properties.isPreReleaseVersion||this.options.installPreReleaseVersion};await this.extensionsScanner.updateMetadata(K,U,this.options.profileLocation)}}catch{}}};ne=Ie([Y(6,j.IUriIdentityService),Y(7,t.IExtensionGalleryService),Y(8,te.IUserDataProfilesService),Y(9,o.IExtensionsScannerService),Y(10,r.IExtensionsProfileScannerService),Y(11,V.ILogService)],ne);class le extends n.AbstractExtensionTask{constructor(K,H,W){super(),this.extension=K,this.options=H,this.extensionsProfileScannerService=W}async doRun(K){await this.extensionsProfileScannerService.removeExtensionFromProfile(this.extension,this.options.profileLocation)}}}),define(he[219],fe([0,1,11,19,28,18,52,7,15,10]),function(ce,e,R,a,_,T,k,L,D,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsProfileScannerService=void 0;let P=class extends k.AbstractExtensionsProfileScannerService{constructor(m,d,l,g,I,v){super(E.URI.file(m.extensionsPath),d,l,g,I,v)}};e.ExtensionsProfileScannerService=P,e.ExtensionsProfileScannerService=P=Ie([Y(0,D.INativeEnvironmentService),Y(1,L.IFileService),Y(2,a.IUserDataProfilesService),Y(3,_.IUriIdentityService),Y(4,T.ITelemetryService),Y(5,R.ILogService)],P)}),define(he[220],fe([0,1,10,15,52,85,7,4,11,23,28,19]),function(ce,e,R,a,_,T,k,L,D,E,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScannerService=void 0;let m=class extends T.NativeExtensionsScannerService{constructor(l,g,I,v,f,C,p,c){super(R.URI.file(f.builtinExtensionsPath),R.URI.file(f.extensionsPath),f.userHome,l.defaultProfile,l,g,I,v,f,C,p,c)}};e.ExtensionsScannerService=m,e.ExtensionsScannerService=m=Ie([Y(0,S.IUserDataProfilesService),Y(1,_.IExtensionsProfileScannerService),Y(2,k.IFileService),Y(3,D.ILogService),Y(4,a.INativeEnvironmentService),Y(5,E.IProductService),Y(6,P.IUriIdentityService),Y(7,L.IInstantiationService)],m)}),define(he[16],fe([0,1,6,3,2,102,12,73,4,19]),function(ce,e,R,a,_,T,k,L,D,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageService=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.TARGET_KEY=e.IS_NEW_KEY=void 0,e.loadKeyTargets=d,e.isProfileUsingDefaultStorage=g,e.logStorage=v,e.IS_NEW_KEY="__$__isNewStorageMarker",e.TARGET_KEY="__$__targetStorageMarker",e.IStorageService=(0,D.createDecorator)("storageService");var P;(function(f){f[f.NONE=0]="NONE",f[f.SHUTDOWN=1]="SHUTDOWN"})(P||(e.WillSaveStateReason=P={}));var S;(function(f){f[f.APPLICATION=-1]="APPLICATION",f[f.PROFILE=0]="PROFILE",f[f.WORKSPACE=1]="WORKSPACE"})(S||(e.StorageScope=S={}));var m;(function(f){f[f.USER=0]="USER",f[f.MACHINE=1]="MACHINE"})(m||(e.StorageTarget=m={}));function d(f){const C=f.get(e.TARGET_KEY);if(C)try{return JSON.parse(C)}catch{}return Object.create(null)}class l extends _.Disposable{static{this.DEFAULT_FLUSH_INTERVAL=60*1e3}constructor(C={flushInterval:l.DEFAULT_FLUSH_INTERVAL}){super(),this.options=C,this._onDidChangeValue=this._register(new a.PauseableEmitter),this._onDidChangeTarget=this._register(new a.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new a.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new R.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new _.MutableDisposable),this._workspaceKeyTargets=void 0,this._profileKeyTargets=void 0,this._applicationKeyTargets=void 0}onDidChangeValue(C,p,c){return a.Event.filter(this._onDidChangeValue.event,u=>u.scope===C&&(p===void 0||u.key===p),c)}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,R.runWhenGlobalIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,_.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,T.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,T.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(C,p){const{key:c,external:u}=p;if(c===e.TARGET_KEY){switch(C){case S.APPLICATION:this._applicationKeyTargets=void 0;break;case S.PROFILE:this._profileKeyTargets=void 0;break;case S.WORKSPACE:this._workspaceKeyTargets=void 0;break}this._onDidChangeTarget.fire({scope:C})}else this._onDidChangeValue.fire({scope:C,key:c,target:this.getKeyTargets(C)[c],external:u})}emitWillSaveState(C){this._onWillSaveState.fire({reason:C})}get(C,p,c){return this.getStorage(p)?.get(C,c)}getBoolean(C,p,c){return this.getStorage(p)?.getBoolean(C,c)}getNumber(C,p,c){return this.getStorage(p)?.getNumber(C,c)}getObject(C,p,c){return this.getStorage(p)?.getObject(C,c)}storeAll(C,p){this.withPausedEmitters(()=>{for(const c of C)this.store(c.key,c.value,c.scope,c.target,p)})}store(C,p,c,u,i=!1){if((0,k.isUndefinedOrNull)(p)){this.remove(C,c,i);return}this.withPausedEmitters(()=>{this.updateKeyTarget(C,c,u),this.getStorage(c)?.set(C,p,i)})}remove(C,p,c=!1){this.withPausedEmitters(()=>{this.updateKeyTarget(C,p,void 0),this.getStorage(p)?.delete(C,c)})}withPausedEmitters(C){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{C()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(C,p){const c=[],u=this.getKeyTargets(C);for(const i of Object.keys(u))u[i]===p&&c.push(i);return c}updateKeyTarget(C,p,c,u=!1){const i=this.getKeyTargets(p);typeof c=="number"?i[C]!==c&&(i[C]=c,this.getStorage(p)?.set(e.TARGET_KEY,JSON.stringify(i),u)):typeof i[C]=="number"&&(delete i[C],this.getStorage(p)?.set(e.TARGET_KEY,JSON.stringify(i),u))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(S.WORKSPACE)),this._workspaceKeyTargets}get profileKeyTargets(){return this._profileKeyTargets||(this._profileKeyTargets=this.loadKeyTargets(S.PROFILE)),this._profileKeyTargets}get applicationKeyTargets(){return this._applicationKeyTargets||(this._applicationKeyTargets=this.loadKeyTargets(S.APPLICATION)),this._applicationKeyTargets}getKeyTargets(C){switch(C){case S.APPLICATION:return this.applicationKeyTargets;case S.PROFILE:return this.profileKeyTargets;default:return this.workspaceKeyTargets}}loadKeyTargets(C){const p=this.getStorage(C);return p?d(p):Object.create(null)}isNew(C){return this.getBoolean(e.IS_NEW_KEY,C)===!0}async flush(C=P.NONE){this._onWillSaveState.fire({reason:C});const p=this.getStorage(S.APPLICATION),c=this.getStorage(S.PROFILE),u=this.getStorage(S.WORKSPACE);switch(C){case P.NONE:await R.Promises.settled([p?.whenFlushed()??Promise.resolve(),c?.whenFlushed()??Promise.resolve(),u?.whenFlushed()??Promise.resolve()]);break;case P.SHUTDOWN:await R.Promises.settled([p?.flush(0)??Promise.resolve(),c?.flush(0)??Promise.resolve(),u?.flush(0)??Promise.resolve()]);break}}async log(){const C=this.getStorage(S.APPLICATION)?.items??new Map,p=this.getStorage(S.PROFILE)?.items??new Map,c=this.getStorage(S.WORKSPACE)?.items??new Map;return v(C,p,c,this.getLogDetails(S.APPLICATION)??"",this.getLogDetails(S.PROFILE)??"",this.getLogDetails(S.WORKSPACE)??"")}async optimize(C){return await this.flush(),this.getStorage(C)?.optimize()}async switch(C,p){return this.emitWillSaveState(P.NONE),(0,E.isUserDataProfile)(C)?this.switchToProfile(C,p):this.switchToWorkspace(C,p)}canSwitchProfile(C,p){return!(C.id===p.id||g(p)&&g(C))}switchData(C,p,c){this.withPausedEmitters(()=>{const u=new Set;for(const[i,n]of C)u.add(i),p.get(i)!==n&&this.emitDidChangeValue(c,{key:i,external:!0});for(const[i]of p.items)u.has(i)||this.emitDidChangeValue(c,{key:i,external:!0})})}}e.AbstractStorageService=l;function g(f){return f.isDefault||!!f.useDefaultFlags?.globalState}class I extends l{constructor(){super(),this.applicationStorage=this._register(new L.Storage(new L.InMemoryStorageDatabase,{hint:L.StorageHint.STORAGE_IN_MEMORY})),this.profileStorage=this._register(new L.Storage(new L.InMemoryStorageDatabase,{hint:L.StorageHint.STORAGE_IN_MEMORY})),this.workspaceStorage=this._register(new L.Storage(new L.InMemoryStorageDatabase,{hint:L.StorageHint.STORAGE_IN_MEMORY})),this._register(this.workspaceStorage.onDidChangeStorage(C=>this.emitDidChangeValue(S.WORKSPACE,C))),this._register(this.profileStorage.onDidChangeStorage(C=>this.emitDidChangeValue(S.PROFILE,C))),this._register(this.applicationStorage.onDidChangeStorage(C=>this.emitDidChangeValue(S.APPLICATION,C)))}getStorage(C){switch(C){case S.APPLICATION:return this.applicationStorage;case S.PROFILE:return this.profileStorage;default:return this.workspaceStorage}}getLogDetails(C){switch(C){case S.APPLICATION:return"inMemory (application)";case S.PROFILE:return"inMemory (profile)";default:return"inMemory (workspace)"}}async doInitialize(){}async switchToProfile(){}async switchToWorkspace(){}shouldFlushWhenIdle(){return!1}hasScope(C){return!1}}e.InMemoryStorageService=I;async function v(f,C,p,c,u,i){const n=w=>{try{return JSON.parse(w)}catch{return w}},t=new Map,s=new Map;f.forEach((w,O)=>{t.set(O,w),s.set(O,n(w))});const r=new Map,o=new Map;C.forEach((w,O)=>{r.set(O,w),o.set(O,n(w))});const h=new Map,y=new Map;p.forEach((w,O)=>{h.set(O,w),y.set(O,n(w))}),console.group(c!==u?`Storage: Application (path: ${c})`:`Storage: Application & Profile (path: ${c}, default profile)`);const A=[];if(t.forEach((w,O)=>{A.push({key:O,value:w})}),console.table(A),console.groupEnd(),console.log(s),c!==u){console.group(`Storage: Profile (path: ${u}, profile specific)`);const w=[];r.forEach((O,F)=>{w.push({key:F,value:O})}),console.table(w),console.groupEnd(),console.log(o)}console.group(`Storage: Workspace (path: ${i})`);const b=[];h.forEach((w,O)=>{b.push({key:O,value:w})}),console.table(b),console.groupEnd(),console.log(y)}}),define(he[120],fe([0,1,3,2,12,27,35,16]),function(ce,e,R,a,_,T,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageManager=e.GlobalExtensionEnablementService=void 0;let D=class extends a.Disposable{constructor(S,m){super(),this._onDidChangeEnablement=new R.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this.storageManager=this._register(new E(S)),this._register(this.storageManager.onDidChange(d=>this._onDidChangeEnablement.fire({extensions:d,source:"storage"}))),this._register(m.onDidInstallExtensions(d=>d.forEach(({local:l,operation:g})=>{l&&g===T.InstallOperation.Migrate&&this._removeFromDisabledExtensions(l.identifier)})))}async enableExtension(S,m){return this._removeFromDisabledExtensions(S)?(this._onDidChangeEnablement.fire({extensions:[S],source:m}),!0):!1}async disableExtension(S,m){return this._addToDisabledExtensions(S)?(this._onDidChangeEnablement.fire({extensions:[S],source:m}),!0):!1}getDisabledExtensions(){return this._getExtensions(T.DISABLED_EXTENSIONS_STORAGE_PATH)}async getDisabledExtensionsAsync(){return this.getDisabledExtensions()}_addToDisabledExtensions(S){const m=this.getDisabledExtensions();return m.every(d=>!(0,k.areSameExtensions)(d,S))?(m.push(S),this._setDisabledExtensions(m),!0):!1}_removeFromDisabledExtensions(S){const m=this.getDisabledExtensions();for(let d=0;d<m.length;d++){const l=m[d];if((0,k.areSameExtensions)(l,S))return m.splice(d,1),this._setDisabledExtensions(m),!0}return!1}_setDisabledExtensions(S){this._setExtensions(T.DISABLED_EXTENSIONS_STORAGE_PATH,S)}_getExtensions(S){return this.storageManager.get(S,L.StorageScope.PROFILE)}_setExtensions(S,m){this.storageManager.set(S,m,L.StorageScope.PROFILE)}};e.GlobalExtensionEnablementService=D,e.GlobalExtensionEnablementService=D=Ie([Y(0,L.IStorageService),Y(1,T.IExtensionManagementService)],D);class E extends a.Disposable{constructor(S){super(),this.storageService=S,this.storage=Object.create(null),this._onDidChange=this._register(new R.Emitter),this.onDidChange=this._onDidChange.event,this._register(S.onDidChangeValue(L.StorageScope.PROFILE,void 0,this._register(new a.DisposableStore))(m=>this.onDidStorageChange(m)))}get(S,m){let d;return m===L.StorageScope.PROFILE?((0,_.isUndefinedOrNull)(this.storage[S])&&(this.storage[S]=this._get(S,m)),d=this.storage[S]):d=this._get(S,m),JSON.parse(d)}set(S,m,d){const l=JSON.stringify(m.map(({id:I,uuid:v})=>({id:I,uuid:v})));this._get(S,d)!==l&&(d===L.StorageScope.PROFILE&&(m.length?this.storage[S]=l:delete this.storage[S]),this._set(S,m.length?l:void 0,d))}onDidStorageChange(S){if(!(0,_.isUndefinedOrNull)(this.storage[S.key])&&this._get(S.key,S.scope)!==this.storage[S.key]){const d=this.get(S.key,S.scope);delete this.storage[S.key];const l=this.get(S.key,S.scope),g=d.filter(v=>!l.some(f=>(0,k.areSameExtensions)(v,f))),I=l.filter(v=>!d.some(f=>(0,k.areSameExtensions)(f,v)));(g.length||I.length)&&this._onDidChange.fire([...g,...I])}}_get(S,m){return this.storageService.get(S,m,"[]")}_set(S,m,d){m?this.storageService.store(S,m,d,L.StorageTarget.MACHINE):this.storageService.remove(S,d)}}e.StorageManager=E}),define(he[86],fe([0,1,4,3,2,16,35,23,17,11,12]),function(ce,e,R,a,_,T,k,L,D,E,P){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStorageService=e.IExtensionStorageService=void 0,e.IExtensionStorageService=(0,R.createDecorator)("IExtensionStorageService");const m=/^extensionKeys\/([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;let d=class extends _.Disposable{static{S=this}static{this.LARGE_STATE_WARNING_THRESHOLD=512*1024}static toKey(g){return`extensionKeys/${(0,k.adoptToGalleryExtensionId)(g.id)}@${g.version}`}static fromKey(g){const I=m.exec(g);if(I&&I[1])return{id:I[1],version:I[2]}}static async removeOutdatedExtensionVersions(g,I){const v=await g.getInstalled(),f=[];for(const[C,p]of S.readAllExtensionsWithKeysForSync(I)){const c=v.find(u=>(0,k.areSameExtensions)(u.identifier,{id:C}))?.manifest.version;for(const u of p)c!==u&&f.push(S.toKey({id:C,version:u}))}for(const C of f)I.remove(C,T.StorageScope.PROFILE)}static readAllExtensionsWithKeysForSync(g){const I=new Map,v=g.keys(T.StorageScope.PROFILE,T.StorageTarget.MACHINE);for(const f of v){const C=S.fromKey(f);if(C){let p=I.get(C.id.toLowerCase());p||I.set(C.id.toLowerCase(),p=[]),p.push(C.version)}}return I}constructor(g,I,v){super(),this.storageService=g,this.productService=I,this.logService=v,this._onDidChangeExtensionStorageToSync=this._register(new a.Emitter),this.onDidChangeExtensionStorageToSync=this._onDidChangeExtensionStorageToSync.event,this.extensionsWithKeysForSync=S.readAllExtensionsWithKeysForSync(g),this._register(this.storageService.onDidChangeValue(T.StorageScope.PROFILE,void 0,this._register(new _.DisposableStore))(f=>this.onDidChangeStorageValue(f)))}onDidChangeStorageValue(g){if(this.extensionsWithKeysForSync.has(g.key.toLowerCase())){this._onDidChangeExtensionStorageToSync.fire();return}const I=S.fromKey(g.key);if(I){if(this.storageService.get(g.key,T.StorageScope.PROFILE)===void 0)this.extensionsWithKeysForSync.delete(I.id.toLowerCase());else{let v=this.extensionsWithKeysForSync.get(I.id.toLowerCase());v||this.extensionsWithKeysForSync.set(I.id.toLowerCase(),v=[]),v.push(I.version),this._onDidChangeExtensionStorageToSync.fire()}return}}getExtensionId(g){if((0,P.isString)(g))return g;const I=g.manifest?g.manifest.publisher:g.publisher,v=g.manifest?g.manifest.name:g.name;return(0,k.getExtensionId)(I,v)}getExtensionState(g,I){const v=this.getExtensionId(g),f=this.getExtensionStateRaw(g,I);if(f)try{return JSON.parse(f)}catch(C){this.logService.error(`[mainThreadStorage] unexpected error parsing storage contents (extensionId: ${v}, global: ${I}): ${C}`)}}getExtensionStateRaw(g,I){const v=this.getExtensionId(g),f=this.storageService.get(v,I?T.StorageScope.PROFILE:T.StorageScope.WORKSPACE);return f&&f?.length>S.LARGE_STATE_WARNING_THRESHOLD&&this.logService.warn(`[mainThreadStorage] large extension state detected (extensionId: ${v}, global: ${I}): ${f.length/1024}kb. Consider to use 'storageUri' or 'globalStorageUri' to store this data on disk instead.`),f}setExtensionState(g,I,v){const f=this.getExtensionId(g);I===void 0?this.storageService.remove(f,v?T.StorageScope.PROFILE:T.StorageScope.WORKSPACE):this.storageService.store(f,JSON.stringify(I),v?T.StorageScope.PROFILE:T.StorageScope.WORKSPACE,T.StorageTarget.MACHINE)}setKeysForSync(g,I){this.storageService.store(S.toKey(g),JSON.stringify(I),T.StorageScope.PROFILE,T.StorageTarget.MACHINE)}getKeysForSync(g){const I=this.productService.extensionSyncedKeys?.[g.id.toLowerCase()],v=this.storageService.get(S.toKey(g),T.StorageScope.PROFILE),f=v?JSON.parse(v):void 0;return f&&I?(0,D.distinct)([...f,...I]):f||I}addToMigrationList(g,I){if(g!==I){const v=this.migrationList.filter(f=>!f.includes(g)&&!f.includes(I));v.push([g,I]),this.migrationList=v}}getSourceExtensionToMigrate(g){const I=this.migrationList.find(([,v])=>g===v);return I?I[0]:void 0}get migrationList(){const g=this.storageService.get("extensionStorage.migrationList",T.StorageScope.APPLICATION,"[]");try{const I=JSON.parse(g);if(Array.isArray(I))return I}catch{}return[]}set migrationList(g){g.length?this.storageService.store("extensionStorage.migrationList",JSON.stringify(g),T.StorageScope.APPLICATION,T.StorageTarget.MACHINE):this.storageService.remove("extensionStorage.migrationList",T.StorageScope.APPLICATION)}};e.ExtensionStorageService=d,e.ExtensionStorageService=d=S=Ie([Y(0,T.IStorageService),Y(1,L.IProductService),Y(2,E.ILogService)],d)}),define(he[221],fe([0,1,2,27,86,199,119,11,16]),function(ce,e,R,a,_,T,k,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsContributions=void 0;let E=class extends R.Disposable{constructor(S,m,d,l,g,I){super(),S.cleanUp(),(0,T.migrateUnsupportedExtensions)(S,m,d,l,I),_.ExtensionStorageService.removeOutdatedExtensionVersions(S,g)}};e.ExtensionsContributions=E,e.ExtensionsContributions=E=Ie([Y(0,k.INativeServerExtensionManagementService),Y(1,a.IExtensionGalleryService),Y(2,_.IExtensionStorageService),Y(3,a.IGlobalExtensionEnablementService),Y(4,D.IStorageService),Y(5,L.ILogService)],E)}),define(he[222],fe([0,1,17,2,20,10,7,23,6,3,13,5,37,35,75,34,16]),function(ce,e,R,a,_,T,k,L,D,E,P,S,m,d,l,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractNativeExtensionTipsService=e.ExtensionTipsService=void 0;let v=class extends a.Disposable{constructor(u,i){super(),this.fileService=u,this.productService=i,this.allConfigBasedTips=new Map,this.productService.configBasedExtensionTips&&Object.entries(this.productService.configBasedExtensionTips).forEach(([,n])=>this.allConfigBasedTips.set(n.configPath,n))}getConfigBasedTips(u){return this.getValidConfigBasedTips(u)}async getImportantExecutableBasedTips(){return[]}async getOtherExecutableBasedTips(){return[]}async getValidConfigBasedTips(u){const i=[];for(const[n,t]of this.allConfigBasedTips)if(!(t.configScheme&&t.configScheme!==u.scheme))try{const s=(await this.fileService.readFile((0,_.joinPath)(u,n))).value.toString();for(const[r,o]of Object.entries(t.recommendations))(!o.contentPattern||new RegExp(o.contentPattern,"mig").test(s))&&i.push({extensionId:r,extensionName:o.name,configName:t.configName,important:!!o.important,isExtensionPack:!!o.isExtensionPack,whenNotInstalled:o.whenNotInstalled})}catch{}return i}};e.ExtensionTipsService=v,e.ExtensionTipsService=v=Ie([Y(0,k.IFileService),Y(1,L.IProductService)],v);const f="extensionTips/promptedExecutableTips",C="extensionTips/lastPromptedMediumImpExeTime";class p extends v{constructor(u,i,n,t,s,r,o,h){super(o,h),this.userHome=u,this.windowEvents=i,this.telemetryService=n,this.extensionManagementService=t,this.storageService=s,this.extensionRecommendationNotificationService=r,this.highImportanceExecutableTips=new Map,this.mediumImportanceExecutableTips=new Map,this.allOtherExecutableTips=new Map,this.highImportanceTipsByExe=new Map,this.mediumImportanceTipsByExe=new Map,h.exeBasedExtensionTips&&Object.entries(h.exeBasedExtensionTips).forEach(([y,A])=>{const b=[],w=[],O=[];Object.entries(A.recommendations).forEach(([F,N])=>{N.important?A.important?b.push({extensionId:F,extensionName:N.name,isExtensionPack:!!N.isExtensionPack}):w.push({extensionId:F,extensionName:N.name,isExtensionPack:!!N.isExtensionPack}):O.push({extensionId:F,extensionName:N.name,isExtensionPack:!!N.isExtensionPack})}),b.length&&this.highImportanceExecutableTips.set(y,{exeFriendlyName:A.friendlyName,windowsPath:A.windowsPath,recommendations:b}),w.length&&this.mediumImportanceExecutableTips.set(y,{exeFriendlyName:A.friendlyName,windowsPath:A.windowsPath,recommendations:w}),O.length&&this.allOtherExecutableTips.set(y,{exeFriendlyName:A.friendlyName,windowsPath:A.windowsPath,recommendations:O})}),(0,D.disposableTimeout)(async()=>{await this.collectTips(),this.promptHighImportanceExeBasedTip(),this.promptMediumImportanceExeBasedTip()},3e3,this._store)}async getImportantExecutableBasedTips(){const u=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),i=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips);return[...u,...i]}getOtherExecutableBasedTips(){return this.getValidExecutableBasedExtensionTips(this.allOtherExecutableTips)}async collectTips(){const u=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),i=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips),n=await this.extensionManagementService.getInstalled();this.highImportanceTipsByExe=this.groupImportantTipsByExe(u,n),this.mediumImportanceTipsByExe=this.groupImportantTipsByExe(i,n)}groupImportantTipsByExe(u,i){const n=new Map;u.forEach(h=>n.set(h.extensionId.toLowerCase(),h));const{installed:t,uninstalled:s}=this.groupByInstalled([...n.keys()],i);for(const h of t){const y=n.get(h);y&&this.telemetryService.publicLog2("exeExtensionRecommendations:alreadyInstalled",{extensionId:h,exeName:y.exeName})}for(const h of s){const y=n.get(h);y&&this.telemetryService.publicLog2("exeExtensionRecommendations:notInstalled",{extensionId:h,exeName:y.exeName})}const r=this.getPromptedExecutableTips(),o=new Map;for(const h of s){const y=n.get(h);if(y&&(!r[y.exeName]||!r[y.exeName].includes(y.extensionId))){let A=o.get(y.exeName);A||(A=[],o.set(y.exeName,A)),A.push(y)}}return o}promptHighImportanceExeBasedTip(){if(this.highImportanceTipsByExe.size===0)return;const[u,i]=[...this.highImportanceTipsByExe.entries()][0];this.promptExeRecommendations(i).then(n=>{switch(n){case l.RecommendationsNotificationResult.Accepted:this.addToRecommendedExecutables(i[0].exeName,i);break;case l.RecommendationsNotificationResult.Ignored:this.highImportanceTipsByExe.delete(u);break;case l.RecommendationsNotificationResult.IncompatibleWindow:{const t=E.Event.once(E.Event.latch(E.Event.any(this.windowEvents.onDidOpenMainWindow,this.windowEvents.onDidFocusMainWindow)));this._register(t(()=>this.promptHighImportanceExeBasedTip()));break}case l.RecommendationsNotificationResult.TooMany:{const t=this._register(new a.MutableDisposable);t.value=(0,D.disposableTimeout)(()=>{t.dispose(),this.promptHighImportanceExeBasedTip()},60*60*1e3);break}}})}promptMediumImportanceExeBasedTip(){if(this.mediumImportanceTipsByExe.size===0)return;const u=this.getLastPromptedMediumExeTime(),i=Date.now()-u,n=7*24*60*60*1e3;if(i<n){const r=this._register(new a.MutableDisposable);r.value=(0,D.disposableTimeout)(()=>{r.dispose(),this.promptMediumImportanceExeBasedTip()},n-i);return}const[t,s]=[...this.mediumImportanceTipsByExe.entries()][0];this.promptExeRecommendations(s).then(r=>{switch(r){case l.RecommendationsNotificationResult.Accepted:{this.updateLastPromptedMediumExeTime(Date.now()),this.mediumImportanceTipsByExe.delete(t),this.addToRecommendedExecutables(s[0].exeName,s);const o=this._register(new a.MutableDisposable);o.value=(0,D.disposableTimeout)(()=>{o.dispose(),this.promptMediumImportanceExeBasedTip()},n);break}case l.RecommendationsNotificationResult.Ignored:this.mediumImportanceTipsByExe.delete(t),this.promptMediumImportanceExeBasedTip();break;case l.RecommendationsNotificationResult.IncompatibleWindow:{const o=E.Event.once(E.Event.latch(E.Event.any(this.windowEvents.onDidOpenMainWindow,this.windowEvents.onDidFocusMainWindow)));this._register(o(()=>this.promptMediumImportanceExeBasedTip()));break}case l.RecommendationsNotificationResult.TooMany:{const o=this._register(new a.MutableDisposable);o.value=(0,D.disposableTimeout)(()=>{o.dispose(),this.promptMediumImportanceExeBasedTip()},60*60*1e3);break}}})}async promptExeRecommendations(u){const i=await this.extensionManagementService.getInstalled(g.ExtensionType.User),n=u.filter(t=>!t.whenNotInstalled||t.whenNotInstalled.every(s=>i.every(r=>!(0,d.areSameExtensions)(r.identifier,{id:s})))).map(({extensionId:t})=>t.toLowerCase());return this.extensionRecommendationNotificationService.promptImportantExtensionsInstallNotification({extensions:n,source:l.RecommendationSource.EXE,name:u[0].exeFriendlyName,searchValue:`@exe:"${u[0].exeName}"`})}getLastPromptedMediumExeTime(){let u=this.storageService.getNumber(C,I.StorageScope.APPLICATION);return u||(u=Date.now(),this.updateLastPromptedMediumExeTime(u)),u}updateLastPromptedMediumExeTime(u){this.storageService.store(C,u,I.StorageScope.APPLICATION,I.StorageTarget.MACHINE)}getPromptedExecutableTips(){return JSON.parse(this.storageService.get(f,I.StorageScope.APPLICATION,"{}"))}addToRecommendedExecutables(u,i){const n=this.getPromptedExecutableTips();n[u]=i.map(({extensionId:t})=>t.toLowerCase()),this.storageService.store(f,JSON.stringify(n),I.StorageScope.APPLICATION,I.StorageTarget.USER)}groupByInstalled(u,i){const n=[],t=[],s=i.reduce((r,o)=>(r.add(o.identifier.id.toLowerCase()),r),new Set);return u.forEach(r=>{s.has(r.toLowerCase())?n.push(r):t.push(r)}),{installed:n,uninstalled:t}}async getValidExecutableBasedExtensionTips(u){const i=[],n=new Map;for(const t of u.keys()){const s=u.get(t);if(!s||!(0,R.isNonEmptyArray)(s.recommendations))continue;const r=[];S.isWindows?s.windowsPath&&r.push(s.windowsPath.replace("%USERPROFILE%",()=>m.env.USERPROFILE).replace("%ProgramFiles(x86)%",()=>m.env["ProgramFiles(x86)"]).replace("%ProgramFiles%",()=>m.env.ProgramFiles).replace("%APPDATA%",()=>m.env.APPDATA).replace("%WINDIR%",()=>m.env.WINDIR)):(r.push((0,P.join)("/usr/local/bin",t)),r.push((0,P.join)("/usr/bin",t)),r.push((0,P.join)(this.userHome.fsPath,t)));for(const o of r){let h=n.get(o);if(h===void 0&&(h=await this.fileService.exists(T.URI.file(o)),n.set(o,h)),h)for(const{extensionId:y,extensionName:A,isExtensionPack:b,whenNotInstalled:w}of s.recommendations)i.push({extensionId:y,extensionName:A,isExtensionPack:b,exeName:t,exeFriendlyName:s.exeFriendlyName,windowsPath:s.windowsPath,whenNotInstalled:w})}}return i}}e.AbstractNativeExtensionTipsService=p}),define(he[223],fe([0,1,27,7,23,15,75,57,16,18,222]),function(ce,e,R,a,_,T,k,L,D,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;let S=class extends P.AbstractNativeExtensionTipsService{constructor(d,l,g,I,v,f,C,p){super(d.userHome,v,l,g,I,f,C,p)}};e.ExtensionTipsService=S,e.ExtensionTipsService=S=Ie([Y(0,T.INativeEnvironmentService),Y(1,E.ITelemetryService),Y(2,R.IExtensionManagementService),Y(3,D.IStorageService),Y(4,L.INativeHostService),Y(5,k.IExtensionRecommendationNotificationService),Y(6,a.IFileService),Y(7,_.IProductService)],S)}),define(he[49],fe([0,1,14,32,16]),function(ce,e,R,a,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=T;async function T(k,L,D){let E=D&&D.get("storage.serviceMachineId",_.StorageScope.APPLICATION)||null;if(E)return E;try{const S=(await L.readFile(k.serviceMachineIdResource)).value.toString();E=(0,a.isUUID)(S)?S:null}catch{E=null}if(!E){E=(0,a.generateUuid)();try{await L.writeFile(k.serviceMachineIdResource,R.VSBuffer.fromString(E))}catch{}}return D?.store("storage.serviceMachineId",E,_.StorageScope.APPLICATION,_.StorageTarget.MACHINE),E}}),define(he[224],fe([0,1,49,18,48]),function(ce,e,R,a,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=T;async function T(k,L,D,E,P,S,m){const d={"X-Market-Client-Id":`VSCode ${k}`,"User-Agent":`VSCode ${k} (${L.nameShort})`};if((0,_.supportsTelemetry)(L,D)&&(0,_.getTelemetryLevel)(E)===a.TelemetryLevel.USAGE){const l=await(0,R.getServiceMachineId)(D,P,S);d["X-Market-User-Id"]=l,d["VSCode-SessionId"]=m.machineId||l}return d}}),define(he[225],fe([0,1,17,25,8,5,37,12,10,142,21,15,27,35,34,59,7,11,23,61,224,16,18,54]),function(ce,e,R,a,_,T,k,L,D,E,P,S,m,d,l,g,I,v,f,C,p,c,u,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGalleryServiceWithNoStorageService=e.ExtensionGalleryService=void 0,e.sortExtensionVersions=H;const n=T.isWeb?l.TargetPlatform.WEB:(0,m.getTargetPlatform)(T.platform,k.arch),t="X-Market-Search-Activity-Id";var s;(function(X){X[X.None=0]="None",X[X.IncludeVersions=1]="IncludeVersions",X[X.IncludeFiles=2]="IncludeFiles",X[X.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",X[X.IncludeSharedAccounts=8]="IncludeSharedAccounts",X[X.IncludeVersionProperties=16]="IncludeVersionProperties",X[X.ExcludeNonValidated=32]="ExcludeNonValidated",X[X.IncludeInstallationTargets=64]="IncludeInstallationTargets",X[X.IncludeAssetUri=128]="IncludeAssetUri",X[X.IncludeStatistics=256]="IncludeStatistics",X[X.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",X[X.Unpublished=4096]="Unpublished",X[X.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(s||(s={}));function r(...X){return String(X.reduce((x,$)=>x|$,0))}var o;(function(X){X[X.Tag=1]="Tag",X[X.ExtensionId=4]="ExtensionId",X[X.Category=5]="Category",X[X.ExtensionName=7]="ExtensionName",X[X.Target=8]="Target",X[X.Featured=9]="Featured",X[X.SearchText=10]="SearchText",X[X.ExcludeWithFlags=12]="ExcludeWithFlags"})(o||(o={}));const h={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},y={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",EnabledApiProposals:"Microsoft.VisualStudio.Code.EnabledApiProposals",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink",SupportLink:"Microsoft.VisualStudio.Services.Links.Support",ExecutesCode:"Microsoft.VisualStudio.Code.ExecutesCode"},b={pageNumber:1,pageSize:10,sortBy:m.SortBy.NoneOrRelevance,sortOrder:m.SortOrder.Default,flags:s.None,criteria:[],assetTypes:[]};class w{constructor(x=b){this.state=x}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}get criteria(){return this.state.criteria}withPage(x,$=this.state.pageSize){return new w({...this.state,pageNumber:x,pageSize:$})}withFilter(x,...$){const ie=[...this.state.criteria,...$.length?$.map(ae=>({filterType:x,value:ae})):[{filterType:x}]];return new w({...this.state,criteria:ie})}withSortBy(x){return new w({...this.state,sortBy:x})}withSortOrder(x){return new w({...this.state,sortOrder:x})}withFlags(...x){return new w({...this.state,flags:x.reduce(($,ie)=>$|ie,0)})}withAssetTypes(...x){return new w({...this.state,assetTypes:x})}withSource(x){return new w({...this.state,source:x})}get raw(){const{criteria:x,pageNumber:$,pageSize:ie,sortBy:ae,sortOrder:ue,flags:Se,assetTypes:Ee}=this.state;return{filters:[{criteria:x,pageNumber:$,pageSize:ie,sortBy:ae,sortOrder:ue}],assetTypes:Ee,flags:Se}}get searchText(){const x=this.state.criteria.filter($=>$.filterType===o.SearchText)[0];return x&&x.value?x.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(x=>String(x.filterType)),flags:this.state.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.state.source,searchTextLength:this.searchText.length}}}function O(X,x){const $=(X||[]).filter(ie=>ie.statisticName===x)[0];return $?$.value:0}function F(X){const x="Microsoft.VisualStudio.Code.Translation.";return X.files.filter(ie=>ie.assetType.indexOf(x)===0).reduce((ie,ae)=>{const ue=V(X,ae.assetType);return ue&&ie.push([ae.assetType.substring(x.length),ue]),ie},[])}function N(X){if(X.properties){const x=X.properties.filter(ae=>ae.key===h.Repository),$=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),ie=x.filter(ae=>$.test(ae.value))[0];return ie?{uri:ie.value,fallbackUri:ie.value}:null}return V(X,h.Repository)}function M(X){return{uri:`${X.fallbackAssetUri}/${h.VSIX}?redirect=true${X.targetPlatform?`&targetPlatform=${X.targetPlatform}`:""}`,fallbackUri:`${X.fallbackAssetUri}/${h.VSIX}${X.targetPlatform?`?targetPlatform=${X.targetPlatform}`:""}`}}function V(X,x){return X.files.filter(ie=>ie.assetType===x)[0]?{uri:`${X.assetUri}/${x}${X.targetPlatform?`?targetPlatform=${X.targetPlatform}`:""}`,fallbackUri:`${X.fallbackAssetUri}/${x}${X.targetPlatform?`?targetPlatform=${X.targetPlatform}`:""}`}:null}function z(X,x){const $=X.properties?X.properties.filter(ae=>ae.key===x):[],ie=$.length>0&&$[0].value;return ie?ie.split(",").map(ae=>(0,d.adoptToGalleryExtensionId)(ae)):[]}function J(X){const x=X.properties?X.properties.filter($=>$.key===y.Engine):[];return x.length>0&&x[0].value||""}function j(X){const x=X.properties?X.properties.filter($=>$.key===y.PreRelease):[];return x.length>0&&x[0].value==="true"}function te(X){const x=X.properties?X.properties.filter($=>$.key===y.ExecutesCode):[];return x.length>0?x[0].value==="true":void 0}function q(X){const x=X.properties?X.properties.filter(ie=>ie.key===y.EnabledApiProposals):[],$=x.length>0&&x[0].value||"";return $?$.split(","):[]}function B(X){const x=X.properties?X.properties.filter(ie=>ie.key===y.LocalizedLanguages):[],$=x.length>0&&x[0].value||"";return $?$.split(","):[]}function Z(X){return X.properties?.find(x=>x.key===y.SponsorLink)?.value}function ne(X){return X.properties?.find(x=>x.key===y.SupportLink)?.value}function le(X){return X.indexOf("preview")!==-1}function ee(X){return X.targetPlatform?(0,m.toTargetPlatform)(X.targetPlatform):l.TargetPlatform.UNDEFINED}function K(X){const x=(0,R.distinct)(X.versions.map(ee)),$=!!X.tags?.includes(m.WEB_EXTENSION_TAG),ie=x.indexOf(l.TargetPlatform.WEB);return $?ie===-1&&x.push(l.TargetPlatform.WEB):ie!==-1&&x.splice(ie,1),x}function H(X,x){for(let $=0;$<X.length;$++){const ie=X[$];if(ie.version===X[$-1]?.version){let ae=$;if(ee(ie)===x)for(;ae>0&&X[ae-1].version===ie.version;)ae--;ae!==$&&(X.splice($,1),X.splice(ae,0,ie))}}return X}function W(X,x,$){X.telemetryData={index:x,querySource:$,queryActivityId:X.queryContext?.[t]}}function U(X,x,$,ie){const ae=X.versions[0],ue={manifest:V(x,h.Manifest),readme:V(x,h.Details),changelog:V(x,h.Changelog),license:V(x,h.License),repository:N(x),download:M(x),icon:V(x,h.Icon),signature:V(x,h.Signature),coreTranslations:F(x)};return{type:"gallery",identifier:{id:(0,d.getGalleryExtensionId)(X.publisher.publisherName,X.extensionName),uuid:X.extensionId},name:X.extensionName,version:x.version,displayName:X.displayName,publisherId:X.publisher.publisherId,publisher:X.publisher.publisherName,publisherDisplayName:X.publisher.displayName,publisherDomain:X.publisher.domain?{link:X.publisher.domain,verified:!!X.publisher.isDomainVerified}:void 0,publisherSponsorLink:Z(ae),description:X.shortDescription??"",installCount:O(X.statistics,"install"),rating:O(X.statistics,"averagerating"),ratingCount:O(X.statistics,"ratingcount"),categories:X.categories||[],tags:X.tags||[],releaseDate:Date.parse(X.releaseDate),lastUpdated:Date.parse(X.lastUpdated),allTargetPlatforms:$,assets:ue,properties:{dependencies:z(x,y.Dependency),extensionPack:z(x,y.ExtensionPack),engine:J(x),enabledApiProposals:q(x),localizedLanguages:B(x),targetPlatform:ee(x),isPreReleaseVersion:j(x),executesCode:te(x)},hasPreReleaseVersion:j(ae),hasReleaseVersion:!0,preview:le(X.flags),isSigned:!!ue.signature,queryContext:ie,supportLink:ne(ae)}}let G=class{constructor(x,$,ie,ae,ue,Se,Ee,Re){this.requestService=$,this.logService=ie,this.environmentService=ae,this.telemetryService=ue,this.fileService=Se,this.productService=Ee,this.configurationService=Re;const Te=Ee.extensionsGallery,we=Te?.servicePPEUrl&&Re.getValue("_extensionsGallery.enablePPE");this.extensionsGalleryUrl=we?Te.servicePPEUrl:Te?.serviceUrl,this.extensionsGallerySearchUrl=we?void 0:Te?.searchUrl,this.extensionsControlUrl=Te?.controlUrl,this.extensionsEnabledWithApiProposalVersion=Ee.extensionsEnabledWithApiProposalVersion?.map(ve=>ve.toLowerCase())??[],this.commonHeadersPromise=(0,p.resolveMarketplaceHeaders)(Ee.version,Ee,this.environmentService,this.configurationService,this.fileService,x,this.telemetryService)}api(x=""){return`${this.extensionsGalleryUrl}${x}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(x,$,ie){const ae=a.CancellationToken.isCancellationToken($)?{}:$,ue=a.CancellationToken.isCancellationToken($)?$:ie,Se=await this.doGetExtensions(x,ae,ue),Ee=Se.map(Te=>Te.identifier.uuid),Re=[];for(const Te of x)Te.uuid&&!Ee.includes(Te.uuid)&&Re.push({...Te,uuid:void 0});if(Re.length){this.telemetryService.publicLog2("galleryService:additionalQueryByName",{count:Re.length});const Te=await this.doGetExtensions(Re,ae,ue);Se.push(...Te)}return Se}async doGetExtensions(x,$,ie){const ae=[],ue=[],Se=[],Ee=[];let Re=!0;for(const ve of x){ve.uuid?ue.push(ve.uuid):ae.push(ve.id);const re=!!(ve.version||ve.preRelease);Se.push({id:ve.id,uuid:ve.uuid,includePreRelease:re}),ve.version&&Ee.push({id:ve.id,uuid:ve.uuid,version:ve.version}),Re=Re&&!!ve.hasPreRelease&&!re}if(!ue.length&&!ae.length)return[];let Te=new w().withPage(1,x.length);ue.length&&(Te=Te.withFilter(o.ExtensionId,...ue)),ae.length&&(Te=Te.withFilter(o.ExtensionName,...ae)),($.queryAllVersions||Re)&&(Te=Te.withFlags(Te.flags,s.IncludeVersions)),$.source&&(Te=Te.withSource($.source));const{extensions:we}=await this.queryGalleryExtensions(Te,{targetPlatform:$.targetPlatform??n,includePreRelease:Se,versions:Ee,compatible:!!$.compatible,productVersion:$.productVersion??{version:this.productService.version,date:this.productService.date}},ie);return $.source&&we.forEach((ve,re)=>W(ve,re,$.source)),we}async getCompatibleExtension(x,$,ie,ae={version:this.productService.version,date:this.productService.date}){if((0,m.isNotWebExtensionInWebTargetPlatform)(x.allTargetPlatforms,ie))return null;if(await this.isExtensionCompatible(x,$,ie))return x;const ue=new w().withFlags(s.IncludeVersions).withPage(1,1).withFilter(o.ExtensionId,x.identifier.uuid),{extensions:Se}=await this.queryGalleryExtensions(ue,{targetPlatform:ie,compatible:!0,includePreRelease:$,productVersion:ae},a.CancellationToken.None);return Se[0]||null}async isExtensionCompatible(x,$,ie,ae={version:this.productService.version,date:this.productService.date}){if(!(0,m.isTargetPlatformCompatible)(x.properties.targetPlatform,x.allTargetPlatforms,ie)||!$&&x.properties.isPreReleaseVersion)return!1;let ue=x.properties.engine;if(!ue){const Se=await this.getManifest(x,a.CancellationToken.None);if(!Se)throw new Error("Manifest was not found");ue=Se.engines.vscode}return!(!(0,g.isEngineValid)(ue,ae.version,ae.date)||!this.areApiProposalsCompatible(x.identifier,x.properties.enabledApiProposals))}areApiProposalsCompatible(x,$){return!$||!this.extensionsEnabledWithApiProposalVersion.includes(x.id.toLowerCase())?!0:(0,g.areApiProposalsCompatible)($)}async isValidVersion(x,$,ie,ae,ue,Se,Ee={version:this.productService.version,date:this.productService.date}){if(!(0,m.isTargetPlatformCompatible)(ee($),ue,Se)||ie!=="any"&&j($)!==(ie==="prerelease"))return!1;if(ae)try{const Re=await this.getEngine(x,$);if(!(0,g.isEngineValid)(Re,Ee.version,Ee.date))return!1}catch(Re){return this.logService.error(`Error while getting the engine for the version ${$.version}.`,(0,_.getErrorMessage)(Re)),!1}return!0}async query(x,$){let ie=x.text||"";const ae=x.pageSize??50;let ue=new w().withPage(1,ae);ie?(ie=ie.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(we,ve,re)=>(ue=ue.withFilter(o.Category,re||ve),"")),ie=ie.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(we,ve,re)=>(ue=ue.withFilter(o.Tag,re||ve),"")),ie=ie.replace(/\bfeatured(\s+|\b|$)/g,()=>(ue=ue.withFilter(o.Featured),"")),ie=ie.trim(),ie&&(ie=ie.length<200?ie:ie.substring(0,200),ue=ue.withFilter(o.SearchText,ie)),ue=ue.withSortBy(m.SortBy.NoneOrRelevance)):x.ids?ue=ue.withFilter(o.ExtensionId,...x.ids):x.names?ue=ue.withFilter(o.ExtensionName,...x.names):ue=ue.withSortBy(m.SortBy.InstallCount),typeof x.sortBy=="number"&&(ue=ue.withSortBy(x.sortBy)),typeof x.sortOrder=="number"&&(ue=ue.withSortOrder(x.sortOrder)),x.source&&(ue=ue.withSource(x.source));const Se=async(we,ve)=>{const{extensions:re,total:de}=await this.queryGalleryExtensions(we,{targetPlatform:n,compatible:!1,includePreRelease:!!x.includePreRelease,productVersion:x.productVersion??{version:this.productService.version,date:this.productService.date}},ve);return re.forEach((me,be)=>W(me,(we.pageNumber-1)*we.pageSize+be,x.source)),{extensions:re,total:de}},{extensions:Ee,total:Re}=await Se(ue,$),Te=async(we,ve)=>{if(ve.isCancellationRequested)throw new _.CancellationError;const{extensions:re}=await Se(ue.withPage(we+1),ve);return re};return{firstPage:Ee,total:Re,pageSize:ue.pageSize,getPage:Te}}async queryGalleryExtensions(x,$,ie){const ae=x.flags;x.flags&s.IncludeLatestVersionOnly&&x.flags&s.IncludeVersions&&(x=x.withFlags(x.flags&~s.IncludeVersions,s.IncludeLatestVersionOnly)),!(x.flags&s.IncludeLatestVersionOnly)&&!(x.flags&s.IncludeVersions)&&(x=x.withFlags(x.flags,s.IncludeLatestVersionOnly)),$.versions?.length&&(x=x.withFlags(x.flags&~s.IncludeLatestVersionOnly,s.IncludeVersions)),x=x.withFlags(x.flags,s.IncludeAssetUri,s.IncludeCategoryAndTags,s.IncludeFiles,s.IncludeStatistics,s.IncludeVersionProperties);const{galleryExtensions:ue,total:Se,context:Ee}=await this.queryRawGalleryExtensions(x,ie);if(!(x.flags&s.IncludeLatestVersionOnly)){const ve=[];for(const re of ue){const de=await this.toGalleryExtensionWithCriteria(re,$,Ee);de&&ve.push(de)}return{extensions:ve,total:Se}}const Te=[],we=new Map;for(let ve=0;ve<ue.length;ve++){const re=ue[ve],de={id:(0,d.getGalleryExtensionId)(re.publisher.publisherName,re.extensionName),uuid:re.extensionId},me=(0,L.isBoolean)($.includePreRelease)?$.includePreRelease:!!$.includePreRelease.find(Ce=>(0,d.areSameExtensions)(Ce,de))?.includePreRelease;if($.compatible&&(0,m.isNotWebExtensionInWebTargetPlatform)(K(re),$.targetPlatform))continue;const be=await this.toGalleryExtensionWithCriteria(re,$,Ee);!be||be.properties.isPreReleaseVersion&&(!me||!be.hasReleaseVersion)||!be.properties.isPreReleaseVersion&&be.properties.targetPlatform!==$.targetPlatform&&be.hasPreReleaseVersion?we.set(re.extensionId,ve):Te.push([ve,be])}if(we.size){const ve=new i.StopWatch,re=new w().withFlags(ae&~s.IncludeLatestVersionOnly,s.IncludeVersions).withPage(1,we.size).withFilter(o.ExtensionId,...we.keys()),{extensions:de}=await this.queryGalleryExtensions(re,$,ie);this.telemetryService.publicLog2("galleryService:additionalQuery",{duration:ve.elapsed(),count:we.size});for(const me of de){const be=we.get(me.identifier.uuid);Te.push([be,me])}}return{extensions:Te.sort((ve,re)=>ve[0]-re[0]).map(([,ve])=>ve),total:Se}}async toGalleryExtensionWithCriteria(x,$,ie){const ae={id:(0,d.getGalleryExtensionId)(x.publisher.publisherName,x.extensionName),uuid:x.extensionId},ue=$.versions?.find(Te=>(0,d.areSameExtensions)(Te,ae))?.version,Se=(0,L.isBoolean)($.includePreRelease)?$.includePreRelease:!!$.includePreRelease.find(Te=>(0,d.areSameExtensions)(Te,ae))?.includePreRelease,Ee=K(x),Re=H(x.versions,$.targetPlatform);if($.compatible&&(0,m.isNotWebExtensionInWebTargetPlatform)(Ee,$.targetPlatform))return null;for(let Te=0;Te<Re.length;Te++){const we=Re[Te];if(!(ue&&we.version!==ue)){if(await this.isValidVersion(ae.id,we,Se?"any":"release",$.compatible,Ee,$.targetPlatform,$.productVersion)){if($.compatible&&!this.areApiProposalsCompatible(ae,q(we)))continue;return U(x,we,Ee,ie)}if(ue&&we.version===ue)return null}}return ue||$.compatible?null:U(x,x.versions[0],Ee)}async queryRawGalleryExtensions(x,$){if(!this.isEnabled())throw new Error("No extension gallery service configured.");x=x.withFlags(x.flags,s.ExcludeNonValidated).withFilter(o.Target,"Microsoft.VisualStudio.Code").withFilter(o.ExcludeWithFlags,r(s.Unpublished));const ie=await this.commonHeadersPromise,ae=JSON.stringify(x.raw),ue={...ie,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(ae.length)},Se=new i.StopWatch;let Ee,Re,Te=0;try{if(Ee=await this.requestService.request({type:"POST",url:this.extensionsGallerySearchUrl&&x.criteria.some(ve=>ve.filterType===o.SearchText)?this.extensionsGallerySearchUrl:this.api("/extensionquery"),data:ae,headers:ue},$),Ee.res.statusCode&&Ee.res.statusCode>=400&&Ee.res.statusCode<500)return{galleryExtensions:[],total:Te};const we=await(0,C.asJson)(Ee);if(we){const ve=we.results[0],re=ve.extensions,de=ve.resultMetadata&&ve.resultMetadata.filter(me=>me.metadataType==="ResultCount")[0];return Te=de&&de.metadataItems.filter(me=>me.name==="TotalCount")[0].count||0,{galleryExtensions:re,total:Te,context:Ee.res.headers.activityid?{[t]:Ee.res.headers.activityid}:{}}}return{galleryExtensions:[],total:Te}}catch(we){if((0,_.isCancellationError)(we))throw Re=m.ExtensionGalleryErrorCode.Cancelled,we;{const ve=(0,_.getErrorMessage)(we);throw Re=(0,E.isOfflineError)(we)?m.ExtensionGalleryErrorCode.Offline:ve.startsWith("XHR timeout")?m.ExtensionGalleryErrorCode.Timeout:m.ExtensionGalleryErrorCode.Failed,new m.ExtensionGalleryError(ve,Re)}}finally{this.telemetryService.publicLog2("galleryService:query",{...x.telemetryData,requestBodySize:String(ae.length),duration:Se.elapsed(),success:!!Ee&&(0,C.isSuccess)(Ee),responseBodySize:Ee?.res.headers["Content-Length"],statusCode:Ee?String(Ee.res.statusCode):void 0,errorCode:Re,count:String(Te)})}}async reportStatistic(x,$,ie,ae){if(!this.isEnabled())return;const ue=T.isWeb?this.api(`/itemName/${x}.${$}/version/${ie}/statType/${ae===m.StatisticType.Install?"1":"3"}/vscodewebextension`):this.api(`/publishers/${x}/extensions/${$}/${ie}/stats?statType=${ae}`),Se=T.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",Re={...await this.commonHeadersPromise,Accept:Se};try{await this.requestService.request({type:"POST",url:ue,headers:Re},a.CancellationToken.None)}catch{}}async download(x,$,ie){this.logService.trace("ExtensionGalleryService#download",x.identifier.id);const ae=(0,d.getGalleryExtensionTelemetryData)(x),ue=new Date().getTime(),Se=ie===m.InstallOperation.Install?"install":ie===m.InstallOperation.Update?"update":"",Ee=Se?{uri:`${x.assets.download.uri}${D.URI.parse(x.assets.download.uri).query?"&":"?"}${Se}=true`,fallbackUri:`${x.assets.download.fallbackUri}${D.URI.parse(x.assets.download.fallbackUri).query?"&":"?"}${Se}=true`}:x.assets.download,Re=x.queryContext?.[t]?{[t]:x.queryContext[t]}:void 0,Te=await this.getAsset(x.identifier.id,Ee,h.VSIX,Re?{headers:Re}:void 0);try{await this.fileService.writeFile($,Te.stream)}catch(we){try{await this.fileService.del($)}catch(ve){this.logService.warn(`Error while deleting the file ${$.toString()}`,(0,_.getErrorMessage)(ve))}throw new m.ExtensionGalleryError((0,_.getErrorMessage)(we),m.ExtensionGalleryErrorCode.DownloadFailedWriting)}this.telemetryService.publicLog("galleryService:downloadVSIX",{...ae,duration:new Date().getTime()-ue})}async downloadSignatureArchive(x,$){if(!x.assets.signature)throw new Error("No signature asset found");this.logService.trace("ExtensionGalleryService#downloadSignatureArchive",x.identifier.id);const ie=await this.getAsset(x.identifier.id,x.assets.signature,h.Signature);try{await this.fileService.writeFile($,ie.stream)}catch(ae){try{await this.fileService.del($)}catch(ue){this.logService.warn(`Error while deleting the file ${$.toString()}`,(0,_.getErrorMessage)(ue))}throw new m.ExtensionGalleryError((0,_.getErrorMessage)(ae),m.ExtensionGalleryErrorCode.DownloadFailedWriting)}}async getReadme(x,$){if(x.assets.readme){const ie=await this.getAsset(x.identifier.id,x.assets.readme,h.Details,{},$);return await(0,C.asTextOrError)(ie)||""}return""}async getManifest(x,$){if(x.assets.manifest){const ie=await this.getAsset(x.identifier.id,x.assets.manifest,h.Manifest,{},$),ae=await(0,C.asTextOrError)(ie);return ae?JSON.parse(ae):null}return null}async getManifestFromRawExtensionVersion(x,$,ie){const ae=V($,h.Manifest);if(!ae)throw new Error("Manifest was not found");const ue={"Accept-Encoding":"gzip"},Se=await this.getAsset(x,ae,h.Manifest,{headers:ue});return await(0,C.asJson)(Se)}async getCoreTranslation(x,$){const ie=x.assets.coreTranslations.filter(ae=>ae[0]===$.toUpperCase())[0];if(ie){const ae=await this.getAsset(x.identifier.id,ie[1],ie[0]),ue=await(0,C.asTextOrError)(ae);return ue?JSON.parse(ue):null}return null}async getChangelog(x,$){if(x.assets.changelog){const ie=await this.getAsset(x.identifier.id,x.assets.changelog,h.Changelog,{},$);return await(0,C.asTextOrError)(ie)||""}return""}async getAllCompatibleVersions(x,$,ie){let ae=new w().withFlags(s.IncludeVersions,s.IncludeCategoryAndTags,s.IncludeFiles,s.IncludeVersionProperties).withPage(1,1);x.uuid?ae=ae.withFilter(o.ExtensionId,x.uuid):ae=ae.withFilter(o.ExtensionName,x.id);const{galleryExtensions:ue}=await this.queryRawGalleryExtensions(ae,a.CancellationToken.None);if(!ue.length)return[];const Se=K(ue[0]);if((0,m.isNotWebExtensionInWebTargetPlatform)(Se,ie))return[];const Ee=[];await Promise.all(ue[0].versions.map(async we=>{try{await this.isValidVersion(x.id,we,$?"any":"release",!0,Se,ie)&&this.areApiProposalsCompatible(x,q(we))&&Ee.push(we)}catch{}}));const Re=[],Te=new Set;for(const we of H(Ee,ie))Te.has(we.version)||(Te.add(we.version),Re.push({version:we.version,date:we.lastUpdated,isPreReleaseVersion:j(we)}));return Re}async getAsset(x,$,ie,ae={},ue=a.CancellationToken.None){const Se=await this.commonHeadersPromise,Ee={type:"GET"},Re={...Se,...ae.headers||{}};ae={...ae,...Ee,headers:Re};const Te=$.uri,we=$.fallbackUri,ve={...ae,url:Te};try{const re=await this.requestService.request(ve,ue);if(re.res.statusCode===200)return re;const de=await(0,C.asTextOrError)(re);throw new Error(`Expected 200, got back ${re.res.statusCode} instead.

${de}`)}catch(re){if((0,_.isCancellationError)(re))throw re;const de=(0,_.getErrorMessage)(re);this.telemetryService.publicLog2("galleryService:cdnFallback",{extension:x,assetType:ie,message:de});const me={...ae,url:we};return this.requestService.request(me,ue)}}async getEngine(x,$){let ie=J($);if(!ie){this.telemetryService.publicLog2("galleryService:engineFallback",{extension:x,version:$.version});const ae=await this.getManifestFromRawExtensionVersion(x,$,a.CancellationToken.None);if(!ae)throw new Error("Manifest was not found");ie=ae.engines.vscode}return ie}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return{malicious:[],deprecated:{},search:[]};const x=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},a.CancellationToken.None);if(x.res.statusCode!==200)throw new Error("Could not get extensions report.");const $=await(0,C.asJson)(x),ie=[],ae={},ue=[],Se=[];if($){for(const Ee of $.malicious)ie.push({id:Ee});if($.migrateToPreRelease)for(const[Ee,Re]of Object.entries($.migrateToPreRelease))(!Re.engine||(0,g.isEngineValid)(Re.engine,this.productService.version,this.productService.date))&&(ae[Ee.toLowerCase()]={disallowInstall:!0,extension:{id:Re.id,displayName:Re.displayName,autoMigrate:{storage:!!Re.migrateStorage},preRelease:!0}});if($.deprecated)for(const[Ee,Re]of Object.entries($.deprecated))Re&&(ae[Ee.toLowerCase()]=(0,L.isBoolean)(Re)?{}:Re);if($.search)for(const Ee of $.search)ue.push(Ee);if(Array.isArray($.extensionsEnabledWithPreRelease))for(const Ee of $.extensionsEnabledWithPreRelease)Se.push(Ee.toLowerCase())}return{malicious:ie,deprecated:ae,search:ue,extensionsEnabledWithPreRelease:Se}}};G=Ie([Y(1,C.IRequestService),Y(2,v.ILogService),Y(3,S.IEnvironmentService),Y(4,u.ITelemetryService),Y(5,I.IFileService),Y(6,f.IProductService),Y(7,P.IConfigurationService)],G);let oe=class extends G{constructor(x,$,ie,ae,ue,Se,Ee,Re){super(x,$,ie,ae,ue,Se,Ee,Re)}};e.ExtensionGalleryService=oe,e.ExtensionGalleryService=oe=Ie([Y(0,c.IStorageService),Y(1,C.IRequestService),Y(2,v.ILogService),Y(3,S.IEnvironmentService),Y(4,u.ITelemetryService),Y(5,I.IFileService),Y(6,f.IProductService),Y(7,P.IConfigurationService)],oe);let Q=class extends G{constructor(x,$,ie,ae,ue,Se,Ee){super(void 0,x,$,ie,ae,ue,Se,Ee)}};e.ExtensionGalleryServiceWithNoStorageService=Q,e.ExtensionGalleryServiceWithNoStorageService=Q=Ie([Y(0,C.IRequestService),Y(1,v.ILogService),Y(2,S.IEnvironmentService),Y(3,u.ITelemetryService),Y(4,I.IFileService),Y(5,f.IProductService),Y(6,P.IConfigurationService)],Q)}),define(he[226],fe([0,1,109,3,18,15,2,11,13,70,23,5,6,103,21,9,38,16,12,140,20]),function(ce,e,R,a,_,T,k,L,D,E,P,S,m,d,l,g,I,v,f,C,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteTunnelService=void 0;const c=[R.CONFIGURATION_KEY_HOST_NAME,R.CONFIGURATION_KEY_PREVENT_SLEEP],u="remoteTunnelSession",i="remoteTunnelIsService";let n=class extends k.Disposable{constructor(o,h,y,A,b,w,O){super(),this.telemetryService=o,this.productService=h,this.environmentService=y,this.configurationService=w,this.storageService=O,this._onDidTokenFailedEmitter=new a.Emitter,this.onDidTokenFailed=this._onDidTokenFailedEmitter.event,this._onDidChangeTunnelStatusEmitter=new a.Emitter,this.onDidChangeTunnelStatus=this._onDidChangeTunnelStatusEmitter.event,this._onDidChangeModeEmitter=new a.Emitter,this.onDidChangeMode=this._onDidChangeModeEmitter.event,this._mode=R.INACTIVE_TUNNEL_MODE,this._initialized=!1,this.defaultOnOutput=(F,N)=>{N?this._logger.error(F):this._logger.info(F)},this._logger=this._register(A.createLogger((0,p.joinPath)(y.logsHome,`${R.LOG_ID}.log`),{id:R.LOG_ID,name:R.LOGGER_NAME})),this._startTunnelProcessDelayer=new m.Delayer(100),this._register(this._logger.onDidChangeLogLevel(F=>this._logger.info("Log level changed to "+(0,L.LogLevelToString)(F)))),this._register(b.onWillShutdown(()=>{this._tunnelProcess?.cancel(),this._tunnelProcess=void 0,this.dispose()})),this._register(w.onDidChangeConfiguration(F=>{c.some(N=>F.affectsConfiguration(N))&&this._startTunnelProcessDelayer.trigger(()=>this.updateTunnelProcess())})),this._mode=this._restoreMode(),this._tunnelStatus=R.TunnelStates.uninitialized}async getTunnelStatus(){return this._tunnelStatus}setTunnelStatus(o){this._tunnelStatus=o,this._onDidChangeTunnelStatusEmitter.fire(o)}setMode(o){s(this._mode,o)||(this._mode=o,this._storeMode(o),this._onDidChangeModeEmitter.fire(this._mode),o.active?(this._logger.info(`Session updated: ${o.session.accountLabel} (${o.session.providerId}) (service=${o.asService})`),o.session.token&&this._logger.info(`Session token updated: ${o.session.accountLabel} (${o.session.providerId})`)):this._logger.info("Session reset"))}getMode(){return Promise.resolve(this._mode)}async initialize(o){if(this._initialized)return this._tunnelStatus;this._initialized=!0,this.setMode(o);try{await this._startTunnelProcessDelayer.trigger(()=>this.updateTunnelProcess())}catch(h){this._logger.error(h)}return this._tunnelStatus}getTunnelCommandLocation(){if(!this._tunnelCommand){let o;S.isMacintosh?o=this.environmentService.appRoot:o=(0,D.dirname)((0,D.dirname)(this.environmentService.appRoot)),this._tunnelCommand=(0,D.join)(o,"bin",`${this.productService.tunnelApplicationName}${S.isWindows?".exe":""}`)}return this._tunnelCommand}async startTunnel(o){if(s(this._mode,o)&&this._tunnelStatus.type!=="disconnected")return this._tunnelStatus;this.setMode(o);try{await this._startTunnelProcessDelayer.trigger(()=>this.updateTunnelProcess())}catch(h){this._logger.error(h)}return this._tunnelStatus}async stopTunnel(){if(this._tunnelProcess&&(this._tunnelProcess.cancel(),this._tunnelProcess=void 0),this._mode.active){const o=this._mode.asService;this.setMode(R.INACTIVE_TUNNEL_MODE);try{o&&this.runCodeTunnelCommand("uninstallService",["service","uninstall"])}catch(h){this._logger.error(h)}}try{await this.runCodeTunnelCommand("stop",["kill"])}catch(o){this._logger.error(o)}this.setTunnelStatus(R.TunnelStates.disconnected())}async updateTunnelProcess(){this.telemetryService.publicLog2("remoteTunnel.enablement",{enabled:this._mode.active,service:this._mode.active&&this._mode.asService}),this._tunnelProcess&&(this._tunnelProcess.cancel(),this._tunnelProcess=void 0);let o="",h=!1;const y=(N,M)=>{M?this._logger.error(N):o+=N,!this.environmentService.isBuilt&&N.startsWith("   Compiling")&&this.setTunnelStatus(R.TunnelStates.connecting((0,g.localize)(2045,null)))},A=this.runCodeTunnelCommand("status",["status"],y);this._tunnelProcess=A;try{if(await A,this._tunnelProcess!==A)return;let N;try{N=JSON.parse(o.trim().split(`
`).find(M=>M.startsWith("{")))}catch{this._logger.error(`Could not parse status output: ${JSON.stringify(o.trim())}`),this.setTunnelStatus(R.TunnelStates.disconnected());return}if(h=N.service_installed,this._logger.info(N.tunnel?"Other tunnel running, attaching...":"No other tunnel running"),!N.tunnel&&!this._mode.active){this.setTunnelStatus(R.TunnelStates.disconnected());return}}catch(N){this._logger.error(N),this.setTunnelStatus(R.TunnelStates.disconnected());return}finally{this._tunnelProcess===A&&(this._tunnelProcess=void 0)}const b=this._mode.active?this._mode.session:void 0;if(b&&b.token){const N=b.token;this.setTunnelStatus(R.TunnelStates.connecting((0,g.localize)(2046,null,b.accountLabel,b.providerId)));const M=(z,J)=>{z=z.replaceAll(N,"*".repeat(4)),y(z,J)},V=this.runCodeTunnelCommand("login",["user","login","--provider",b.providerId,"--log",(0,L.LogLevelToString)(this._logger.getLevel())],M,{VSCODE_CLI_ACCESS_TOKEN:N});this._tunnelProcess=V;try{if(await V,this._tunnelProcess!==V)return}catch(z){this._logger.error(z),this._tunnelProcess=void 0,this._onDidTokenFailedEmitter.fire(b),this.setTunnelStatus(R.TunnelStates.disconnected(b));return}}const w=this._getTunnelName();w?this.setTunnelStatus(R.TunnelStates.connecting((0,g.localize)(2047,null,w))):this.setTunnelStatus(R.TunnelStates.connecting((0,g.localize)(2048,null)));const O=["--accept-server-license-terms","--log",(0,L.LogLevelToString)(this._logger.getLevel())];w?O.push("--name",w):O.push("--random-name");let F=!1;return this._mode.active&&this._mode.asService&&!h&&(F=await this.installTunnelService(O)===!1),this.serverOrAttachTunnel(b,O,F)}async installTunnelService(o){let h;try{h=await this.runCodeTunnelCommand("serviceInstall",["service","install",...o])}catch(y){this._logger.error(y),h=1}if(h!==0){const y=(0,g.localize)(2049,null);return this._logger.warn(y),this.setTunnelStatus(R.TunnelStates.connecting(y)),!1}return!0}async serverOrAttachTunnel(o,h,y){h.push("--parent-process-id",String(process.pid)),this._preventSleep()&&h.push("--no-sleep");let A=!1;const b=this.runCodeTunnelCommand("tunnel",h,(w,O)=>{O?this._logger.error(w):this._logger.info(w),w.includes("Connected to an existing tunnel process")&&(A=!0);const F=w.match(/Open this link in your browser (https:\/\/([^\/\s]+)\/([^\/\s]+)\/([^\/\s]+))/);if(F){const N={link:F[1],domain:F[2],tunnelName:F[4],isAttached:A};this.setTunnelStatus(R.TunnelStates.connected(N,y))}else w.match(/error refreshing token/)&&(b.cancel(),this._onDidTokenFailedEmitter.fire(o),this.setTunnelStatus(R.TunnelStates.disconnected(o)))});this._tunnelProcess=b,b.finally(()=>{b===this._tunnelProcess&&(this._logger.info("tunnel process terminated"),this._tunnelProcess=void 0,this._mode=R.INACTIVE_TUNNEL_MODE,this.setTunnelStatus(R.TunnelStates.disconnected()))})}runCodeTunnelCommand(o,h,y=this.defaultOnOutput,A){return(0,m.createCancelablePromise)(b=>new Promise((w,O)=>{b.isCancellationRequested&&w(-1);let F;const N=["ignore","pipe","pipe"];if(b.onCancellationRequested(()=>{F&&(this._logger.info(`${o} terminating(${F.pid})`),F.kill())}),!this.environmentService.isBuilt)y(`Building tunnel CLI from sources and run
`,!1),y(`${o} Spawning: cargo run -- tunnel ${h.join(" ")}
`,!1),F=(0,E.spawn)("cargo",["run","--","tunnel",...h],{cwd:(0,D.join)(this.environmentService.appRoot,"cli"),stdio:N,env:{...process.env,RUST_BACKTRACE:"1",...A}});else{y(`Running tunnel CLI
`,!1);const M=this.getTunnelCommandLocation();y(`${o} Spawning: ${M} tunnel ${h.join(" ")}
`,!1),F=(0,E.spawn)(M,["tunnel",...h],{cwd:(0,I.homedir)(),stdio:N,env:{...process.env,...A}})}F.stdout.pipe(new C.StreamSplitter(`
`)).on("data",M=>{if(F){const V=M.toString();y(V,!1)}}),F.stderr.pipe(new C.StreamSplitter(`
`)).on("data",M=>{if(F){const V=M.toString();y(V,!0)}}),F.on("exit",M=>{F&&(y(`${o} exit(${F.pid}): + ${M} `,!1),F=void 0,w(M||0))}),F.on("error",M=>{F&&(y(`${o} error(${F.pid}): + ${M} `,!0),F=void 0,O())})}))}async getTunnelName(){return this._getTunnelName()}_preventSleep(){return!!this.configurationService.getValue(R.CONFIGURATION_KEY_PREVENT_SLEEP)}_getTunnelName(){let o=this.configurationService.getValue(R.CONFIGURATION_KEY_HOST_NAME)||(0,I.hostname)();return o=o.replace(/^-+/g,"").replace(/[^\w-]/g,"").substring(0,20),o||void 0}_restoreMode(){try{const o=this.storageService.get(u,v.StorageScope.APPLICATION),h=this.storageService.getBoolean(i,v.StorageScope.APPLICATION,!1);if(o){const y=JSON.parse(o);if(y&&(0,f.isString)(y.accountLabel)&&(0,f.isString)(y.sessionId)&&(0,f.isString)(y.providerId))return{active:!0,session:y,asService:h};this._logger.error("Problems restoring session from storage, invalid format",y)}}catch(o){this._logger.error("Problems restoring session from storage",o)}return R.INACTIVE_TUNNEL_MODE}_storeMode(o){if(o.active){const h={providerId:o.session.providerId,sessionId:o.session.sessionId,accountLabel:o.session.accountLabel};this.storageService.store(u,JSON.stringify(h),v.StorageScope.APPLICATION,v.StorageTarget.MACHINE),this.storageService.store(i,o.asService,v.StorageScope.APPLICATION,v.StorageTarget.MACHINE)}else this.storageService.remove(u,v.StorageScope.APPLICATION),this.storageService.remove(i,v.StorageScope.APPLICATION)}};e.RemoteTunnelService=n,e.RemoteTunnelService=n=Ie([Y(0,_.ITelemetryService),Y(1,P.IProductService),Y(2,T.INativeEnvironmentService),Y(3,L.ILoggerService),Y(4,d.ISharedProcessLifecycleService),Y(5,l.IConfigurationService),Y(6,v.IStorageService)],n);function t(r,o){return r&&o?r.sessionId===o.sessionId&&r.providerId===o.providerId&&r.token===o.token:r===o}const s=(r,o)=>r.active!==o.active?!1:r.active&&o.active?r.asService===o.asService&&t(r.session,o.session):!0}),define(he[227],fe([0,1,6,2,22,20,73,16,80,19]),function(ce,e,R,a,_,T,k,L,D,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteStorageService=void 0;class P extends L.AbstractStorageService{constructor(m,d,l,g){super(),this.initialWorkspace=m,this.initialProfiles=d,this.remoteService=l,this.environmentService=g,this.applicationStorageProfile=this.initialProfiles.defaultProfile,this.applicationStorage=this.createApplicationStorage(),this.profileStorageProfile=this.initialProfiles.currentProfile,this.profileStorageDisposables=this._register(new a.DisposableStore),this.profileStorage=this.createProfileStorage(this.profileStorageProfile),this.workspaceStorageId=this.initialWorkspace?.id,this.workspaceStorageDisposables=this._register(new a.DisposableStore),this.workspaceStorage=this.createWorkspaceStorage(this.initialWorkspace)}createApplicationStorage(){const m=this._register(new D.ApplicationStorageDatabaseClient(this.remoteService.getChannel("storage"))),d=this._register(new k.Storage(m));return this._register(d.onDidChangeStorage(l=>this.emitDidChangeValue(L.StorageScope.APPLICATION,l))),d}createProfileStorage(m){this.profileStorageDisposables.clear(),this.profileStorageProfile=m;let d;if((0,L.isProfileUsingDefaultStorage)(m))d=this.applicationStorage;else{const l=this.profileStorageDisposables.add(new D.ProfileStorageDatabaseClient(this.remoteService.getChannel("storage"),m));d=this.profileStorageDisposables.add(new k.Storage(l))}return this.profileStorageDisposables.add(d.onDidChangeStorage(l=>this.emitDidChangeValue(L.StorageScope.PROFILE,l))),d}createWorkspaceStorage(m){this.workspaceStorageDisposables.clear(),this.workspaceStorageId=m?.id;let d;if(m){const l=this.workspaceStorageDisposables.add(new D.WorkspaceStorageDatabaseClient(this.remoteService.getChannel("storage"),m));d=this.workspaceStorageDisposables.add(new k.Storage(l)),this.workspaceStorageDisposables.add(d.onDidChangeStorage(g=>this.emitDidChangeValue(L.StorageScope.WORKSPACE,g)))}return d}async doInitialize(){await R.Promises.settled([this.applicationStorage.init(),this.profileStorage.init(),this.workspaceStorage?.init()??Promise.resolve()])}getStorage(m){switch(m){case L.StorageScope.APPLICATION:return this.applicationStorage;case L.StorageScope.PROFILE:return this.profileStorage;default:return this.workspaceStorage}}getLogDetails(m){switch(m){case L.StorageScope.APPLICATION:return this.applicationStorageProfile.globalStorageHome.with({scheme:_.Schemas.file}).fsPath;case L.StorageScope.PROFILE:return this.profileStorageProfile?.globalStorageHome.with({scheme:_.Schemas.file}).fsPath;default:return this.workspaceStorageId?`${(0,T.joinPath)(this.environmentService.workspaceStorageHome,this.workspaceStorageId,"state.vscdb").with({scheme:_.Schemas.file}).fsPath}`:void 0}}async close(){this.stopFlushWhenIdle(),this.emitWillSaveState(L.WillSaveStateReason.SHUTDOWN),await R.Promises.settled([this.applicationStorage.close(),this.profileStorage.close(),this.workspaceStorage?.close()??Promise.resolve()])}async switchToProfile(m){if(!this.canSwitchProfile(this.profileStorageProfile,m))return;const d=this.profileStorage,l=d.items;d!==this.applicationStorage&&await d.close(),this.profileStorage=this.createProfileStorage(m),await this.profileStorage.init(),this.switchData(l,this.profileStorage,L.StorageScope.PROFILE)}async switchToWorkspace(m,d){const l=this.workspaceStorage,g=l?.items??new Map;await l?.close(),this.workspaceStorage=this.createWorkspaceStorage(m),await this.workspaceStorage.init(),this.switchData(g,this.workspaceStorage,L.StorageScope.WORKSPACE)}hasScope(m){return(0,E.isUserDataProfile)(m)?this.profileStorageProfile.id===m.id:this.workspaceStorageId===m.id}}e.RemoteStorageService=P}),define(he[228],fe([0,1,3,2,19,96]),function(ce,e,R,a,_,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesService=e.RemoteUserDataProfilesServiceChannel=void 0;class k{constructor(E,P){this.service=E,this.getUriTransformer=P}listen(E,P){const S=this.getUriTransformer(E);switch(P){case"onDidChangeProfiles":return R.Event.map(this.service.onDidChangeProfiles,m=>({all:m.all.map(d=>(0,T.transformOutgoingURIs)({...d},S)),added:m.added.map(d=>(0,T.transformOutgoingURIs)({...d},S)),removed:m.removed.map(d=>(0,T.transformOutgoingURIs)({...d},S)),updated:m.updated.map(d=>(0,T.transformOutgoingURIs)({...d},S))}))}throw new Error(`Invalid listen ${P}`)}async call(E,P,S){const m=this.getUriTransformer(E);switch(P){case"createProfile":{const d=await this.service.createProfile(S[0],S[1],S[2]);return(0,T.transformOutgoingURIs)({...d},m)}case"updateProfile":{let d=(0,_.reviveProfile)((0,T.transformIncomingURIs)(S[0],m),this.service.profilesHome.scheme);return d=await this.service.updateProfile(d,S[1]),(0,T.transformOutgoingURIs)({...d},m)}case"removeProfile":{const d=(0,_.reviveProfile)((0,T.transformIncomingURIs)(S[0],m),this.service.profilesHome.scheme);return this.service.removeProfile(d)}}throw new Error(`Invalid call ${P}`)}}e.RemoteUserDataProfilesServiceChannel=k;class L extends a.Disposable{get defaultProfile(){return this.profiles[0]}get profiles(){return this._profiles}constructor(E,P,S){super(),this.profilesHome=P,this.channel=S,this._profiles=[],this._onDidChangeProfiles=this._register(new R.Emitter),this.onDidChangeProfiles=this._onDidChangeProfiles.event,this.enabled=!0,this._profiles=E.map(m=>(0,_.reviveProfile)(m,this.profilesHome.scheme)),this._register(this.channel.listen("onDidChangeProfiles")(m=>{const d=m.added.map(I=>(0,_.reviveProfile)(I,this.profilesHome.scheme)),l=m.removed.map(I=>(0,_.reviveProfile)(I,this.profilesHome.scheme)),g=m.updated.map(I=>(0,_.reviveProfile)(I,this.profilesHome.scheme));this._profiles=m.all.map(I=>(0,_.reviveProfile)(I,this.profilesHome.scheme)),this._onDidChangeProfiles.fire({added:d,removed:l,updated:g,all:this.profiles})})),this.onDidResetWorkspaces=this.channel.listen("onDidResetWorkspaces")}setEnablement(E){this.enabled=E}isEnabled(){return this.enabled}async createNamedProfile(E,P,S){const m=await this.channel.call("createNamedProfile",[E,P,S]);return(0,_.reviveProfile)(m,this.profilesHome.scheme)}async createProfile(E,P,S,m){const d=await this.channel.call("createProfile",[E,P,S,m]);return(0,_.reviveProfile)(d,this.profilesHome.scheme)}async createTransientProfile(E){const P=await this.channel.call("createTransientProfile",[E]);return(0,_.reviveProfile)(P,this.profilesHome.scheme)}async setProfileForWorkspace(E,P){await this.channel.call("setProfileForWorkspace",[E,P])}removeProfile(E){return this.channel.call("removeProfile",[E])}async updateProfile(E,P){const S=await this.channel.call("updateProfile",[E,P]);return(0,_.reviveProfile)(S,this.profilesHome.scheme)}resetWorkspaces(){return this.channel.call("resetWorkspaces")}cleanUp(){return this.channel.call("cleanUp")}cleanUpTransientProfiles(){return this.channel.call("cleanUpTransientProfiles")}}e.UserDataProfilesService=L}),define(he[62],fe([0,1,2,73,4,16,3,80,19]),function(ce,e,R,a,_,T,k,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteUserDataProfileStorageService=e.AbstractUserDataProfileStorageService=e.IUserDataProfileStorageService=void 0,e.IUserDataProfileStorageService=(0,_.createDecorator)("IUserDataProfileStorageService");let E=class extends R.Disposable{constructor(d,l){super(),this.storageService=l,d&&(this.storageServicesMap=this._register(new R.DisposableMap))}async readStorageData(d){return this.withProfileScopedStorageService(d,async l=>this.getItems(l))}async updateStorageData(d,l,g){return this.withProfileScopedStorageService(d,async I=>this.writeItems(I,l,g))}async withProfileScopedStorageService(d,l){if(this.storageService.hasScope(d))return l(this.storageService);let g=this.storageServicesMap?.get(d.id);if(!g){g=new S(this.createStorageDatabase(d)),this.storageServicesMap?.set(d.id,g);try{await g.initialize()}catch(I){throw this.storageServicesMap?.has(d.id)?this.storageServicesMap.deleteAndDispose(d.id):g.dispose(),I}}try{const I=await l(g);return await g.flush(),I}finally{this.storageServicesMap?.has(d.id)||g.dispose()}}getItems(d){const l=new Map,g=I=>{for(const v of d.keys(T.StorageScope.PROFILE,I))l.set(v,{value:d.get(v,T.StorageScope.PROFILE),target:I})};return g(T.StorageTarget.USER),g(T.StorageTarget.MACHINE),l}writeItems(d,l,g){d.storeAll(Array.from(l.entries()).map(([I,v])=>({key:I,value:v,scope:T.StorageScope.PROFILE,target:g})),!0)}};e.AbstractUserDataProfileStorageService=E,e.AbstractUserDataProfileStorageService=E=Ie([Y(1,T.IStorageService)],E);class P extends E{constructor(d,l,g,I,v){super(d,I),this.remoteService=l;const f=l.getChannel("profileStorageListener"),C=this._register(new R.MutableDisposable);this._onDidChange=this._register(new k.Emitter({onWillAddFirstListener:()=>{C.value=f.listen("onDidChange")(p=>{v.trace("profile storage changes",p),this._onDidChange.fire({targetChanges:p.targetChanges.map(c=>(0,D.reviveProfile)(c,g.profilesHome.scheme)),valueChanges:p.valueChanges.map(c=>({...c,profile:(0,D.reviveProfile)(c.profile,g.profilesHome.scheme)}))})})},onDidRemoveLastListener:()=>C.value=void 0})),this.onDidChange=this._onDidChange.event}async createStorageDatabase(d){const l=this.remoteService.getChannel("storage");return(0,T.isProfileUsingDefaultStorage)(d)?new L.ApplicationStorageDatabaseClient(l):new L.ProfileStorageDatabaseClient(l,d)}}e.RemoteUserDataProfileStorageService=P;class S extends T.AbstractStorageService{constructor(d){super({flushInterval:100}),this.profileStorageDatabase=d}async doInitialize(){const d=await this.profileStorageDatabase,l=new a.Storage(d);return this._register(l.onDidChangeStorage(g=>{this.emitDidChangeValue(T.StorageScope.PROFILE,g)})),this._register((0,R.toDisposable)(()=>{l.close(),l.dispose(),(0,R.isDisposable)(d)&&d.dispose()})),this.profileStorage=l,this.profileStorage.init()}getStorage(d){return d===T.StorageScope.PROFILE?this.profileStorage:void 0}getLogDetails(){}async switchToProfile(){}async switchToWorkspace(){}hasScope(){return!1}}}),define(he[229],fe([0,1,16,11,19,56,62]),function(ce,e,R,a,_,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessUserDataProfileStorageService=void 0;let L=class extends k.RemoteUserDataProfileStorageService{constructor(E,P,S,m){super(!0,E,P,S,m)}};e.SharedProcessUserDataProfileStorageService=L,e.SharedProcessUserDataProfileStorageService=L=Ie([Y(0,T.IMainProcessService),Y(1,_.IUserDataProfilesService),Y(2,R.IStorageService),Y(3,a.ILogService)],L)}),define(he[40],fe([0,1,17,6,14,25,3,36,2,26,12,9,21,15,7,11,49,16,18,28,24,19]),function(ce,e,R,a,_,T,k,L,D,E,P,S,m,d,l,g,I,v,f,C,p,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractInitializer=e.AbstractJsonFileSynchroniser=e.AbstractFileSynchroniser=e.AbstractSynchroniser=void 0,e.isRemoteUserData=u,e.isSyncData=i,e.getSyncResourceLogLabel=n;function u(h){return!!(h&&h.ref!==void 0&&typeof h.ref=="string"&&h.ref!==""&&h.syncData!==void 0&&(h.syncData===null||i(h.syncData)))}function i(h){return!!(h&&h.version!==void 0&&typeof h.version=="number"&&h.content!==void 0&&typeof h.content=="string"&&(Object.keys(h).length===2||Object.keys(h).length===3&&h.machineId!==void 0&&typeof h.machineId=="string"))}function n(h,y){return`${(0,E.uppercaseFirstLetter)(h)}${y.isDefault?"":` (${y.name})`}`}let t=class extends D.Disposable{get status(){return this._status}get conflicts(){return{...this.syncResource,conflicts:this._conflicts}}constructor(y,A,b,w,O,F,N,M,V,z,J,j){super(),this.syncResource=y,this.collection=A,this.fileService=b,this.environmentService=w,this.storageService=O,this.userDataSyncStoreService=F,this.userDataSyncLocalStoreService=N,this.userDataSyncEnablementService=M,this.telemetryService=V,this.logService=z,this.configurationService=J,this.syncPreviewPromise=null,this._status=p.SyncStatus.Idle,this._onDidChangStatus=this._register(new k.Emitter),this.onDidChangeStatus=this._onDidChangStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new k.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this.localChangeTriggerThrottler=this._register(new a.ThrottledDelayer(50)),this._onDidChangeLocal=this._register(new k.Emitter),this.onDidChangeLocal=this._onDidChangeLocal.event,this.lastSyncUserDataStateKey=`${this.collection?`${this.collection}.`:""}${this.syncResource.syncResource}.lastSyncUserData`,this.hasSyncResourceStateVersionChanged=!1,this.syncHeaders={},this.resource=this.syncResource.syncResource,this.syncResourceLogLabel=n(y.syncResource,y.profile),this.extUri=j.extUri,this.syncFolder=this.extUri.joinPath(w.userDataSyncHome,...(0,p.getPathSegments)(y.profile.isDefault?void 0:y.profile.id,y.syncResource)),this.syncPreviewFolder=this.extUri.joinPath(this.syncFolder,p.PREVIEW_DIR_NAME),this.lastSyncResource=(0,p.getLastSyncResourceUri)(y.profile.isDefault?void 0:y.profile.id,y.syncResource,w,this.extUri),this.currentMachineIdPromise=(0,I.getServiceMachineId)(w,b,O)}triggerLocalChange(){this.localChangeTriggerThrottler.trigger(()=>this.doTriggerLocalChange())}async doTriggerLocalChange(){if(this.status===p.SyncStatus.HasConflicts){this.logService.info(`${this.syncResourceLogLabel}: In conflicts state and local change detected. Syncing again...`);const y=await this.syncPreviewPromise;this.syncPreviewPromise=null;const A=await this.performSync(y.remoteUserData,y.lastSyncUserData,!0,this.getUserDataSyncConfiguration());this.setStatus(A)}else{this.logService.trace(`${this.syncResourceLogLabel}: Checking for local changes...`);const y=await this.getLastSyncUserData();(y?await this.hasRemoteChanged(y):!0)&&this._onDidChangeLocal.fire()}}setStatus(y){this._status!==y&&(this._status=y,this._onDidChangStatus.fire(y))}async sync(y,A={}){await this._sync(y,!0,this.getUserDataSyncConfiguration(),A)}async preview(y,A,b={}){return this._sync(y,!1,A,b)}async apply(y,A={}){try{this.syncHeaders={...A};const b=await this.doApply(y);return this.setStatus(b),this.syncPreviewPromise}finally{this.syncHeaders={}}}async _sync(y,A,b,w){try{if(this.syncHeaders={...w},this.status===p.SyncStatus.HasConflicts)return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as there are conflicts.`),this.syncPreviewPromise;if(this.status===p.SyncStatus.Syncing)return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as it is running already.`),this.syncPreviewPromise;this.logService.trace(`${this.syncResourceLogLabel}: Started synchronizing ${this.resource.toLowerCase()}...`),this.setStatus(p.SyncStatus.Syncing);let O=p.SyncStatus.Idle;try{const F=await this.getLastSyncUserData(),N=await this.getLatestRemoteUserData(y,F);return O=await this.performSync(N,F,A,b),O===p.SyncStatus.HasConflicts?this.logService.info(`${this.syncResourceLogLabel}: Detected conflicts while synchronizing ${this.resource.toLowerCase()}.`):O===p.SyncStatus.Idle&&this.logService.trace(`${this.syncResourceLogLabel}: Finished synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise||null}finally{this.setStatus(O)}}finally{this.syncHeaders={}}}async replace(y){const A=this.parseSyncData(y);if(!A)return!1;await this.stop();try{this.logService.trace(`${this.syncResourceLogLabel}: Started resetting ${this.resource.toLowerCase()}...`),this.setStatus(p.SyncStatus.Syncing);const b=await this.getLastSyncUserData(),w=await this.getLatestRemoteUserData(null,b),O=await this.isRemoteDataFromCurrentMachine(w),F=await this.generateSyncPreview({ref:w.ref,syncData:A},b,O,this.getUserDataSyncConfiguration(),T.CancellationToken.None),N=[];for(const M of F){const V=await this.getAcceptResult(M,M.remoteResource,void 0,T.CancellationToken.None),{remoteChange:z}=await this.getAcceptResult(M,M.previewResource,M.remoteContent,T.CancellationToken.None);N.push([M,{...V,remoteChange:z!==p.Change.None?z:p.Change.Modified}])}await this.applyResult(w,b,N,!1),this.logService.info(`${this.syncResourceLogLabel}: Finished resetting ${this.resource.toLowerCase()}.`)}finally{this.setStatus(p.SyncStatus.Idle)}return!0}async isRemoteDataFromCurrentMachine(y){const A=await this.currentMachineIdPromise;return!!y.syncData?.machineId&&y.syncData.machineId===A}async getLatestRemoteUserData(y,A){if(A){const b=y?y[this.resource]:void 0;if(A.ref===b||b===void 0&&A.syncData===null)return A}return this.getRemoteUserData(A)}async performSync(y,A,b,w){if(y.syncData&&y.syncData.version>this.version)throw this.telemetryService.publicLog2("sync/incompatible",{source:this.resource}),new p.UserDataSyncError((0,S.localize)(2443,null,this.resource,this.version,y.syncData.version),p.UserDataSyncErrorCode.IncompatibleLocalContent,this.resource);try{return await this.doSync(y,A,b,w)}catch(O){if(O instanceof p.UserDataSyncError)switch(O.code){case p.UserDataSyncErrorCode.LocalPreconditionFailed:return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize ${this.syncResourceLogLabel} as there is a new local version available. Synchronizing again...`),this.performSync(y,A,b,w);case p.UserDataSyncErrorCode.Conflict:case p.UserDataSyncErrorCode.PreconditionFailed:return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize as there is a new remote version available. Synchronizing again...`),y=await this.getRemoteUserData(null),A=await this.getLastSyncUserData(),this.performSync(y,A,b,w)}throw O}}async doSync(y,A,b,w){try{const O=await this.isRemoteDataFromCurrentMachine(y),F=!O&&A===null&&this.getStoredLastSyncUserDataStateContent()!==void 0,N=b&&!F;this.syncPreviewPromise||(this.syncPreviewPromise=(0,a.createCancelablePromise)(V=>this.doGenerateSyncResourcePreview(y,A,O,N,w,V)));let M=await this.syncPreviewPromise;if(b&&F){this.logService.info(`${this.syncResourceLogLabel}: Accepting remote because it was synced before and the last sync data is not available.`);for(const V of M.resourcePreviews)M=await this.accept(V.remoteResource)||M}return this.updateConflicts(M.resourcePreviews),M.resourcePreviews.some(({mergeState:V})=>V===p.MergeState.Conflict)?p.SyncStatus.HasConflicts:b?await this.doApply(!1):p.SyncStatus.Syncing}catch(O){throw this.syncPreviewPromise=null,O}}async merge(y){return await this.updateSyncResourcePreview(y,async A=>{const b=await this.getMergeResult(A,T.CancellationToken.None);await this.fileService.writeFile(A.previewResource,_.VSBuffer.fromString(b?.content||""));const w=b&&!b.hasConflicts?await this.getAcceptResult(A,A.previewResource,void 0,T.CancellationToken.None):void 0;return A.acceptResult=w,A.mergeState=b.hasConflicts?p.MergeState.Conflict:w?p.MergeState.Accepted:p.MergeState.Preview,A.localChange=w?w.localChange:b.localChange,A.remoteChange=w?w.remoteChange:b.remoteChange,A}),this.syncPreviewPromise}async accept(y,A){return await this.updateSyncResourcePreview(y,async b=>{const w=await this.getAcceptResult(b,y,A,T.CancellationToken.None);return b.acceptResult=w,b.mergeState=p.MergeState.Accepted,b.localChange=w.localChange,b.remoteChange=w.remoteChange,b}),this.syncPreviewPromise}async discard(y){return await this.updateSyncResourcePreview(y,async A=>{const b=await this.getMergeResult(A,T.CancellationToken.None);return await this.fileService.writeFile(A.previewResource,_.VSBuffer.fromString(b.content||"")),A.acceptResult=void 0,A.mergeState=p.MergeState.Preview,A.localChange=b.localChange,A.remoteChange=b.remoteChange,A}),this.syncPreviewPromise}async updateSyncResourcePreview(y,A){if(!this.syncPreviewPromise)return;let b=await this.syncPreviewPromise;const w=b.resourcePreviews.findIndex(({localResource:O,remoteResource:F,previewResource:N})=>this.extUri.isEqual(O,y)||this.extUri.isEqual(F,y)||this.extUri.isEqual(N,y));w!==-1&&(this.syncPreviewPromise=(0,a.createCancelablePromise)(async O=>{const F=[...b.resourcePreviews];return F[w]=await A(F[w]),{...b,resourcePreviews:F}}),b=await this.syncPreviewPromise,this.updateConflicts(b.resourcePreviews),b.resourcePreviews.some(({mergeState:O})=>O===p.MergeState.Conflict)?this.setStatus(p.SyncStatus.HasConflicts):this.setStatus(p.SyncStatus.Syncing))}async doApply(y){if(!this.syncPreviewPromise)return p.SyncStatus.Idle;const A=await this.syncPreviewPromise;return A.resourcePreviews.some(({mergeState:b})=>b===p.MergeState.Conflict)?p.SyncStatus.HasConflicts:A.resourcePreviews.some(({mergeState:b})=>b!==p.MergeState.Accepted)?p.SyncStatus.Syncing:(await this.applyResult(A.remoteUserData,A.lastSyncUserData,A.resourcePreviews.map(b=>[b,b.acceptResult]),y),this.syncPreviewPromise=null,await this.clearPreviewFolder(),p.SyncStatus.Idle)}async clearPreviewFolder(){try{await this.fileService.del(this.syncPreviewFolder,{recursive:!0})}catch{}}updateConflicts(y){const A=y.filter(({mergeState:b})=>b===p.MergeState.Conflict);(0,R.equals)(this._conflicts,A,(b,w)=>this.extUri.isEqual(b.previewResource,w.previewResource))||(this._conflicts=A,this._onDidChangeConflicts.fire(this.conflicts))}async hasPreviouslySynced(){const y=await this.getLastSyncUserData();return!!y&&y.syncData!==null}async resolvePreviewContent(y){const A=this.syncPreviewPromise?await this.syncPreviewPromise:null;if(A)for(const b of A.resourcePreviews){if(this.extUri.isEqual(b.acceptedResource,y))return b.acceptResult?b.acceptResult.content:null;if(this.extUri.isEqual(b.remoteResource,y))return b.remoteContent;if(this.extUri.isEqual(b.localResource,y))return b.localContent;if(this.extUri.isEqual(b.baseResource,y))return b.baseContent}return null}async resetLocal(){this.storageService.remove(this.lastSyncUserDataStateKey,v.StorageScope.APPLICATION);try{await this.fileService.del(this.lastSyncResource)}catch(y){(0,l.toFileOperationResult)(y)!==l.FileOperationResult.FILE_NOT_FOUND&&this.logService.error(y)}}async doGenerateSyncResourcePreview(y,A,b,w,O,F){const N=await this.generateSyncPreview(y,A,b,O,F),M=[];for(const V of N){const z=V.previewResource.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"});if(V.localChange===p.Change.None&&V.remoteChange===p.Change.None)M.push({...V,acceptedResource:z,acceptResult:{content:null,localChange:p.Change.None,remoteChange:p.Change.None},mergeState:p.MergeState.Accepted});else{const J=w?await this.getMergeResult(V,F):void 0;if(F.isCancellationRequested)break;await this.fileService.writeFile(V.previewResource,_.VSBuffer.fromString(J?.content||""));const j=J&&!J.hasConflicts?await this.getAcceptResult(V,V.previewResource,void 0,F):void 0;M.push({...V,acceptResult:j,mergeState:J?.hasConflicts?p.MergeState.Conflict:j?p.MergeState.Accepted:p.MergeState.Preview,localChange:j?j.localChange:J?J.localChange:V.localChange,remoteChange:j?j.remoteChange:J?J.remoteChange:V.remoteChange})}}return{syncResource:this.resource,profile:this.syncResource.profile,remoteUserData:y,lastSyncUserData:A,resourcePreviews:M,isLastSyncFromCurrentMachine:b}}async getLastSyncUserData(){let y=this.getStoredLastSyncUserDataStateContent();if(y||(y=await this.migrateLastSyncUserData()),!y)return this.logService.info(`${this.syncResourceLogLabel}: Last sync data state does not exist.`),null;const A=JSON.parse(y),b=this.userDataSyncEnablementService.getResourceSyncStateVersion(this.resource);if(this.hasSyncResourceStateVersionChanged=!!A.version&&!!b&&A.version!==b,this.hasSyncResourceStateVersionChanged)return this.logService.info(`${this.syncResourceLogLabel}: Reset last sync state because last sync state version ${A.version} is not compatible with current sync state version ${b}.`),await this.resetLocal(),null;let w,O=1;for(;w===void 0&&O++<6;)try{const F=await this.readLastSyncStoredRemoteUserData();F&&(F.ref===A.ref?w=F.syncData:this.logService.info(`${this.syncResourceLogLabel}: Last sync data stored locally is not same as the last sync state.`));break}catch(F){if(F instanceof l.FileOperationError&&F.fileOperationResult===l.FileOperationResult.FILE_NOT_FOUND){this.logService.info(`${this.syncResourceLogLabel}: Last sync resource does not exist locally.`);break}else{if(F instanceof p.UserDataSyncError)throw F;this.logService.error(F,O)}}if(w===void 0)try{const F=await this.userDataSyncStoreService.resolveResourceContent(this.resource,A.ref,this.collection,this.syncHeaders);w=F===null?null:this.parseSyncData(F),await this.writeLastSyncStoredRemoteUserData({ref:A.ref,syncData:w})}catch(F){if(F instanceof p.UserDataSyncError&&F.code===p.UserDataSyncErrorCode.NotFound)this.logService.info(`${this.syncResourceLogLabel}: Last sync resource does not exist remotely.`);else throw F}return w===void 0?null:{...A,syncData:w}}async updateLastSyncUserData(y,A={}){if(A.ref||A.version)throw new Error("Cannot have core properties as additional");const b=this.userDataSyncEnablementService.getResourceSyncStateVersion(this.resource),w={ref:y.ref,version:b,...A};this.storageService.store(this.lastSyncUserDataStateKey,JSON.stringify(w),v.StorageScope.APPLICATION,v.StorageTarget.MACHINE),await this.writeLastSyncStoredRemoteUserData(y)}getStoredLastSyncUserDataStateContent(){return this.storageService.get(this.lastSyncUserDataStateKey,v.StorageScope.APPLICATION)}async readLastSyncStoredRemoteUserData(){const y=(await this.fileService.readFile(this.lastSyncResource)).value.toString();try{const A=y?JSON.parse(y):void 0;if(u(A))return A}catch(A){this.logService.error(A)}}async writeLastSyncStoredRemoteUserData(y){await this.fileService.writeFile(this.lastSyncResource,_.VSBuffer.fromString(JSON.stringify(y)))}async migrateLastSyncUserData(){try{const y=await this.fileService.readFile(this.lastSyncResource),A=JSON.parse(y.value.toString());await this.fileService.del(this.lastSyncResource),A.ref&&A.content!==void 0?(this.storageService.store(this.lastSyncUserDataStateKey,JSON.stringify({...A,content:void 0}),v.StorageScope.APPLICATION,v.StorageTarget.MACHINE),await this.writeLastSyncStoredRemoteUserData({ref:A.ref,syncData:A.content===null?null:JSON.parse(A.content)})):this.logService.info(`${this.syncResourceLogLabel}: Migrating last sync user data. Invalid data.`,A)}catch(y){y instanceof l.FileOperationError&&y.fileOperationResult===l.FileOperationResult.FILE_NOT_FOUND?this.logService.info(`${this.syncResourceLogLabel}: Migrating last sync user data. Resource does not exist.`):this.logService.error(y)}return this.storageService.get(this.lastSyncUserDataStateKey,v.StorageScope.APPLICATION)}async getRemoteUserData(y){const{ref:A,content:b}=await this.getUserData(y);let w=null;return b!==null&&(w=this.parseSyncData(b)),{ref:A,syncData:w}}parseSyncData(y){try{const A=JSON.parse(y);if(i(A))return A}catch(A){this.logService.error(A)}throw new p.UserDataSyncError((0,S.localize)(2444,null),p.UserDataSyncErrorCode.IncompatibleRemoteContent,this.resource)}async getUserData(y){const A=y?{ref:y.ref,content:y.syncData?JSON.stringify(y.syncData):null}:null;return this.userDataSyncStoreService.readResource(this.resource,A,this.collection,this.syncHeaders)}async updateRemoteUserData(y,A){const b=await this.currentMachineIdPromise,w={version:this.version,machineId:b,content:y};try{return A=await this.userDataSyncStoreService.writeResource(this.resource,JSON.stringify(w),A,this.collection,this.syncHeaders),{ref:A,syncData:w}}catch(O){throw O instanceof p.UserDataSyncError&&O.code===p.UserDataSyncErrorCode.TooLarge&&(O=new p.UserDataSyncError(O.message,O.code,this.resource)),O}}async backupLocal(y){const A={version:this.version,content:y};return this.userDataSyncLocalStoreService.writeResource(this.resource,JSON.stringify(A),new Date,this.syncResource.profile.isDefault?void 0:this.syncResource.profile.id)}async stop(){this.status!==p.SyncStatus.Idle&&(this.logService.trace(`${this.syncResourceLogLabel}: Stopping synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise&&(this.syncPreviewPromise.cancel(),this.syncPreviewPromise=null),this.updateConflicts([]),await this.clearPreviewFolder(),this.setStatus(p.SyncStatus.Idle),this.logService.info(`${this.syncResourceLogLabel}: Stopped synchronizing ${this.resource.toLowerCase()}.`))}getUserDataSyncConfiguration(){return this.configurationService.getValue(p.USER_DATA_SYNC_CONFIGURATION_SCOPE)}};e.AbstractSynchroniser=t,e.AbstractSynchroniser=t=Ie([Y(2,l.IFileService),Y(3,d.IEnvironmentService),Y(4,v.IStorageService),Y(5,p.IUserDataSyncStoreService),Y(6,p.IUserDataSyncLocalStoreService),Y(7,p.IUserDataSyncEnablementService),Y(8,f.ITelemetryService),Y(9,p.IUserDataSyncLogService),Y(10,m.IConfigurationService),Y(11,C.IUriIdentityService)],t);let s=class extends t{constructor(y,A,b,w,O,F,N,M,V,z,J,j,te){super(A,b,w,O,F,N,M,V,z,J,j,te),this.file=y,this._register(this.fileService.watch(this.extUri.dirname(y))),this._register(this.fileService.onDidFilesChange(q=>this.onFileChanges(q)))}async getLocalFileContent(){try{return await this.fileService.readFile(this.file)}catch{return null}}async updateLocalFileContent(y,A,b){try{A?await this.fileService.writeFile(this.file,_.VSBuffer.fromString(y),b?void 0:A):await this.fileService.createFile(this.file,_.VSBuffer.fromString(y),{overwrite:b})}catch(w){throw w instanceof l.FileOperationError&&w.fileOperationResult===l.FileOperationResult.FILE_NOT_FOUND||w instanceof l.FileOperationError&&w.fileOperationResult===l.FileOperationResult.FILE_MODIFIED_SINCE?new p.UserDataSyncError(w.message,p.UserDataSyncErrorCode.LocalPreconditionFailed):w}}async deleteLocalFile(){try{await this.fileService.del(this.file)}catch(y){if(!(y instanceof l.FileOperationError&&y.fileOperationResult===l.FileOperationResult.FILE_NOT_FOUND))throw y}}onFileChanges(y){y.contains(this.file)&&this.triggerLocalChange()}};e.AbstractFileSynchroniser=s,e.AbstractFileSynchroniser=s=Ie([Y(3,l.IFileService),Y(4,d.IEnvironmentService),Y(5,v.IStorageService),Y(6,p.IUserDataSyncStoreService),Y(7,p.IUserDataSyncLocalStoreService),Y(8,p.IUserDataSyncEnablementService),Y(9,f.ITelemetryService),Y(10,p.IUserDataSyncLogService),Y(11,m.IConfigurationService),Y(12,C.IUriIdentityService)],s);let r=class extends s{constructor(y,A,b,w,O,F,N,M,V,z,J,j,te,q){super(y,A,b,w,O,F,N,M,V,z,J,te,q),this.userDataSyncUtilService=j,this._formattingOptions=void 0}hasErrors(y,A){const b=[],w=(0,L.parse)(y,b,{allowEmptyContent:!0,allowTrailingComma:!0});return b.length>0||!(0,P.isUndefined)(w)&&A!==Array.isArray(w)}getFormattingOptions(){return this._formattingOptions||(this._formattingOptions=this.userDataSyncUtilService.resolveFormattingOptions(this.file)),this._formattingOptions}};e.AbstractJsonFileSynchroniser=r,e.AbstractJsonFileSynchroniser=r=Ie([Y(3,l.IFileService),Y(4,d.IEnvironmentService),Y(5,v.IStorageService),Y(6,p.IUserDataSyncStoreService),Y(7,p.IUserDataSyncLocalStoreService),Y(8,p.IUserDataSyncEnablementService),Y(9,f.ITelemetryService),Y(10,p.IUserDataSyncLogService),Y(11,p.IUserDataSyncUtilService),Y(12,m.IConfigurationService),Y(13,C.IUriIdentityService)],r);let o=class{constructor(y,A,b,w,O,F,N){this.resource=y,this.userDataProfilesService=A,this.environmentService=b,this.logService=w,this.fileService=O,this.storageService=F,this.extUri=N.extUri,this.lastSyncResource=(0,p.getLastSyncResourceUri)(void 0,this.resource,b,this.extUri)}async initialize({ref:y,content:A}){if(!A){this.logService.info("Remote content does not exist.",this.resource);return}const b=this.parseSyncData(A);if(b)try{await this.doInitialize({ref:y,syncData:b})}catch(w){this.logService.error(w)}}parseSyncData(y){try{const A=JSON.parse(y);if(i(A))return A}catch(A){this.logService.error(A)}this.logService.info("Cannot parse sync data as it is not compatible with the current version.",this.resource)}async updateLastSyncUserData(y,A={}){if(A.ref||A.version)throw new Error("Cannot have core properties as additional");const b={ref:y.ref,version:void 0,...A};this.storageService.store(`${this.resource}.lastSyncUserData`,JSON.stringify(b),v.StorageScope.APPLICATION,v.StorageTarget.MACHINE),await this.fileService.writeFile(this.lastSyncResource,_.VSBuffer.fromString(JSON.stringify(y)))}};e.AbstractInitializer=o,e.AbstractInitializer=o=Ie([Y(1,c.IUserDataProfilesService),Y(2,d.IEnvironmentService),Y(3,g.ILogService),Y(4,l.IFileService),Y(5,v.IStorageService),Y(6,C.IUriIdentityService)],o)}),define(he[121],fe([0,1,6,25,8,3,45,2,26,21,15,120,27,35,86,34,7,4,77,11,16,18,28,19,40,208,116,24,62]),function(ce,e,R,a,_,T,k,L,D,E,P,S,m,d,l,g,I,v,f,C,p,c,u,i,n,t,s,r,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsInitializer=e.LocalExtensionsProvider=e.ExtensionsSynchroniser=void 0,e.parseExtensions=y,e.stringify=A;async function h(F,N){const M=JSON.parse(F.content);if(F.version===1||F.version===2){const V=(await N.getInstalled(g.ExtensionType.System)).filter(z=>z.isBuiltin);for(const z of M)F.version===1&&(z.enabled===!1&&(z.disabled=!0),delete z.enabled),F.version===2&&V.every(J=>!(0,d.areSameExtensions)(J.identifier,z.identifier))&&(z.installed=!0)}return M}function y(F){return JSON.parse(F.content)}function A(F,N){return F.sort((M,V)=>!M.identifier.uuid&&V.identifier.uuid?-1:M.identifier.uuid&&!V.identifier.uuid?1:(0,D.compare)(M.identifier.id,V.identifier.id)),N?(0,k.toFormattedString)(F,{}):JSON.stringify(F)}let b=class extends n.AbstractSynchroniser{constructor(N,M,V,z,J,j,te,q,B,Z,ne,le,ee,K,H,W,U){super({syncResource:r.SyncResource.Extensions,profile:N},M,z,V,J,j,te,le,ee,Z,ne,H),this.extensionManagementService=q,this.ignoredExtensionsManagementService=B,this.instantiationService=U,this.version=6,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"extensions.json"),this.baseResource=this.previewResource.with({scheme:r.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:r.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:r.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:r.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this.localExtensionsProvider=this.instantiationService.createInstance(w),this._register(T.Event.any(T.Event.filter(this.extensionManagementService.onDidInstallExtensions,G=>G.some(({local:oe})=>!!oe)),T.Event.filter(this.extensionManagementService.onDidUninstallExtension,G=>!G.error),T.Event.filter(W.onDidChange,G=>G.valueChanges.some(({profile:oe,changes:Q})=>this.syncResource.profile.id===oe.id&&Q.some(X=>X.key===m.DISABLED_EXTENSIONS_STORAGE_PATH))),K.onDidChangeExtensionStorageToSync)(()=>this.triggerLocalChange()))}async generateSyncPreview(N,M){const V=N.syncData?await h(N.syncData,this.extensionManagementService):null,z=M?.skippedExtensions??[],J=M?.builtinExtensions??null,j=M?.syncData?await h(M.syncData,this.extensionManagementService):null,{localExtensions:te,ignoredExtensions:q}=await this.localExtensionsProvider.getLocalExtensions(this.syncResource.profile);V?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote extensions with local extensions...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote extensions does not exist. Synchronizing extensions for the first time.`);const{local:B,remote:Z}=(0,t.merge)(te,V,j,z,q,J),ne={local:B,remote:Z,content:this.getPreviewContent(te,B.added,B.updated,B.removed),localChange:B.added.length>0||B.removed.length>0||B.updated.length>0?r.Change.Modified:r.Change.None,remoteChange:Z!==null?r.Change.Modified:r.Change.None},le=this.stringify(te,!1);return[{skippedExtensions:z,builtinExtensions:J,baseResource:this.baseResource,baseContent:j?this.stringify(j,!1):le,localResource:this.localResource,localContent:le,localExtensions:te,remoteResource:this.remoteResource,remoteExtensions:V,remoteContent:V?this.stringify(V,!1):null,previewResource:this.previewResource,previewResult:ne,localChange:ne.localChange,remoteChange:ne.remoteChange,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(N){const M=N.syncData?await h(N.syncData,this.extensionManagementService):null,{localExtensions:V,ignoredExtensions:z}=await this.localExtensionsProvider.getLocalExtensions(this.syncResource.profile),{remote:J}=(0,t.merge)(V,M,M,N.skippedExtensions||[],z,N.builtinExtensions||[]);return J!==null}getPreviewContent(N,M,V,z){const J=[...M,...V],j=new Set,te=q=>{j.add(q.id.toLowerCase()),q.uuid&&j.add(q.uuid)};J.forEach(({identifier:q})=>te(q)),z.forEach(te);for(const q of N)j.has(q.identifier.id.toLowerCase())||q.identifier.uuid&&j.has(q.identifier.uuid)||J.push(q);return this.stringify(J,!1)}async getMergeResult(N,M){return{...N.previewResult,hasConflicts:!1}}async getAcceptResult(N,M,V,z){if(this.extUri.isEqual(M,this.localResource))return this.acceptLocal(N);if(this.extUri.isEqual(M,this.remoteResource))return this.acceptRemote(N);if(this.extUri.isEqual(M,this.previewResource))return N.previewResult;throw new Error(`Invalid Resource: ${M.toString()}`)}async acceptLocal(N){const M=await this.extensionManagementService.getInstalled(void 0,this.syncResource.profile.extensionsResource),V=this.ignoredExtensionsManagementService.getIgnoredExtensions(M),z=(0,t.merge)(N.localExtensions,null,null,N.skippedExtensions,V,N.builtinExtensions),{local:J,remote:j}=z;return{content:N.localContent,local:J,remote:j,localChange:J.added.length>0||J.removed.length>0||J.updated.length>0?r.Change.Modified:r.Change.None,remoteChange:j!==null?r.Change.Modified:r.Change.None}}async acceptRemote(N){const M=await this.extensionManagementService.getInstalled(void 0,this.syncResource.profile.extensionsResource),V=this.ignoredExtensionsManagementService.getIgnoredExtensions(M),z=N.remoteContent?JSON.parse(N.remoteContent):null;if(z!==null){const J=(0,t.merge)(N.localExtensions,z,N.localExtensions,[],V,N.builtinExtensions),{local:j,remote:te}=J;return{content:N.remoteContent,local:j,remote:te,localChange:j.added.length>0||j.removed.length>0||j.updated.length>0?r.Change.Modified:r.Change.None,remoteChange:te!==null?r.Change.Modified:r.Change.None}}else return{content:N.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:r.Change.None,remoteChange:r.Change.None}}async applyResult(N,M,V,z){let{skippedExtensions:J,builtinExtensions:j,localExtensions:te}=V[0][0];const{local:q,remote:B,localChange:Z,remoteChange:ne}=V[0][1];if(Z===r.Change.None&&ne===r.Change.None&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing extensions.`),Z!==r.Change.None&&(await this.backupLocal(JSON.stringify(te)),J=await this.localExtensionsProvider.updateLocalExtensions(q.added,q.removed,q.updated,J,this.syncResource.profile)),B){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote extensions...`);const le=JSON.stringify(B.all);N=await this.updateRemoteUserData(le,z?null:N.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote extensions.${B.added.length?` Added: ${JSON.stringify(B.added.map(ee=>ee.identifier.id))}.`:""}${B.updated.length?` Updated: ${JSON.stringify(B.updated.map(ee=>ee.identifier.id))}.`:""}${B.removed.length?` Removed: ${JSON.stringify(B.removed.map(ee=>ee.identifier.id))}.`:""}`)}M?.ref!==N.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized extensions...`),j=this.computeBuiltinExtensions(te,j),await this.updateLastSyncUserData(N,{skippedExtensions:J,builtinExtensions:j}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized extensions.${J.length?` Skipped: ${JSON.stringify(J.map(le=>le.identifier.id))}.`:""}`))}computeBuiltinExtensions(N,M){const V=new Set,z=[];for(const J of N)V.add(J.identifier.id.toLowerCase()),J.installed||z.push(J.identifier);if(M)for(const J of M)V.has(J.id.toLowerCase())||z.push(J);return z}async resolveContent(N){if(this.extUri.isEqual(this.remoteResource,N)||this.extUri.isEqual(this.baseResource,N)||this.extUri.isEqual(this.localResource,N)||this.extUri.isEqual(this.acceptedResource,N)){const M=await this.resolvePreviewContent(N);return M&&this.stringify(JSON.parse(M),!0)}return null}stringify(N,M){return A(N,M)}async hasLocalData(){try{const{localExtensions:N}=await this.localExtensionsProvider.getLocalExtensions(this.syncResource.profile);if(N.some(M=>M.installed||M.disabled))return!0}catch{}return!1}};e.ExtensionsSynchroniser=b,e.ExtensionsSynchroniser=b=Ie([Y(2,P.IEnvironmentService),Y(3,I.IFileService),Y(4,p.IStorageService),Y(5,r.IUserDataSyncStoreService),Y(6,r.IUserDataSyncLocalStoreService),Y(7,m.IExtensionManagementService),Y(8,s.IIgnoredExtensionsManagementService),Y(9,r.IUserDataSyncLogService),Y(10,E.IConfigurationService),Y(11,r.IUserDataSyncEnablementService),Y(12,c.ITelemetryService),Y(13,l.IExtensionStorageService),Y(14,u.IUriIdentityService),Y(15,o.IUserDataProfileStorageService),Y(16,v.IInstantiationService)],b);let w=class{constructor(N,M,V,z,J,j){this.extensionManagementService=N,this.userDataProfileStorageService=M,this.extensionGalleryService=V,this.ignoredExtensionsManagementService=z,this.instantiationService=J,this.logService=j}async getLocalExtensions(N){const M=await this.extensionManagementService.getInstalled(void 0,N.extensionsResource),V=this.ignoredExtensionsManagementService.getIgnoredExtensions(M);return{localExtensions:await this.withProfileScopedServices(N,async(J,j)=>{const te=J.getDisabledExtensions();return M.map(q=>{const{identifier:B,isBuiltin:Z,manifest:ne,preRelease:le,pinned:ee,isApplicationScoped:K}=q,H={identifier:B,preRelease:le,version:ne.version,pinned:!!ee};K&&!(0,g.isApplicationScopedExtension)(ne)&&(H.isApplicationScoped=K),te.some(W=>(0,d.areSameExtensions)(W,B))&&(H.disabled=!0),Z||(H.installed=!0);try{const W=j.getKeysForSync({id:B.id,version:ne.version});if(W){const U=j.getExtensionState(q,!0)||{};H.state=Object.keys(U).reduce((G,oe)=>(W.includes(oe)&&(G[oe]=U[oe]),G),{})}}catch(W){this.logService.info(`${(0,n.getSyncResourceLogLabel)(r.SyncResource.Extensions,N)}: Error while parsing extension state`,(0,_.getErrorMessage)(W))}return H})}),ignoredExtensions:V}}async updateLocalExtensions(N,M,V,z,J){const j=(0,n.getSyncResourceLogLabel)(r.SyncResource.Extensions,J),te=[],q=new Map,B=[],Z=[],ne=await this.extensionManagementService.getInstalled(void 0,J.extensionsResource);if((N.length||V.length)&&await this.withProfileScopedServices(J,async(K,H)=>{await R.Promises.settled([...N,...V].map(async W=>{const U=ne.find(Q=>(0,d.areSameExtensions)(Q.identifier,W.identifier));if(U&&U.isBuiltin){W.state&&U.manifest.version===W.version&&this.updateExtensionState(W.state,U,U.manifest.version,H),K.getDisabledExtensions().some(X=>(0,d.areSameExtensions)(X,W.identifier))!==!!W.disabled&&(W.disabled?(this.logService.trace(`${j}: Disabling extension...`,W.identifier.id),await K.disableExtension(W.identifier),this.logService.info(`${j}: Disabled extension`,W.identifier.id)):(this.logService.trace(`${j}: Enabling extension...`,W.identifier.id),await K.enableExtension(W.identifier),this.logService.info(`${j}: Enabled extension`,W.identifier.id))),B.push(W.identifier);return}const G=W.pinned?W.version:void 0,oe=(await this.extensionGalleryService.getExtensions([{...W.identifier,version:G,preRelease:G?void 0:W.preRelease}],a.CancellationToken.None))[0];if(W.state&&(U?U.manifest.version===W.version:oe)&&this.updateExtensionState(W.state,U||oe,U?.manifest.version,H),oe)try{K.getDisabledExtensions().some(X=>(0,d.areSameExtensions)(X,W.identifier))!==!!W.disabled&&(W.disabled?(this.logService.trace(`${j}: Disabling extension...`,W.identifier.id,oe.version),await K.disableExtension(oe.identifier),this.logService.info(`${j}: Disabled extension`,W.identifier.id,oe.version)):(this.logService.trace(`${j}: Enabling extension...`,W.identifier.id,oe.version),await K.enableExtension(oe.identifier),this.logService.info(`${j}: Enabled extension`,W.identifier.id,oe.version))),(!U||U.preRelease!==W.preRelease||U.pinned!==W.pinned||G&&U.manifest.version!==G)&&(await this.extensionManagementService.canInstall(oe)?(te.push({extension:oe,options:{isMachineScoped:!1,donotIncludePackAndDependencies:!0,installGivenVersion:W.pinned&&!!W.version,pinned:W.pinned,installPreReleaseVersion:W.preRelease,profileLocation:J.extensionsResource,isApplicationScoped:W.isApplicationScoped,context:{[m.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT]:!0,[m.EXTENSION_INSTALL_SOURCE_CONTEXT]:m.ExtensionInstallSource.SETTINGS_SYNC}}}),q.set(oe.identifier.id.toLowerCase(),W)):(this.logService.info(`${j}: Skipped synchronizing extension because it cannot be installed.`,oe.displayName||oe.identifier.id),Z.push(W)))}catch(Q){Z.push(W),this.logService.error(Q),this.logService.info(`${j}: Skipped synchronizing extension`,oe.displayName||oe.identifier.id)}else Z.push(W),this.logService.info(`${j}: Skipped synchronizing extension because the extension is not found.`,W.identifier.id)}))}),M.length){const K=ne.filter(({identifier:H,isBuiltin:W})=>!W&&M.some(U=>(0,d.areSameExtensions)(H,U)));await R.Promises.settled(K.map(async H=>{this.logService.trace(`${j}: Uninstalling local extension...`,H.identifier.id),await this.extensionManagementService.uninstall(H,{donotIncludePack:!0,donotCheckDependents:!0,profileLocation:J.extensionsResource}),this.logService.info(`${j}: Uninstalled local extension.`,H.identifier.id),B.push(H.identifier)}))}const le=await this.extensionManagementService.installGalleryExtensions(te);for(const{identifier:K,local:H,error:W,source:U}of le){const G=U;if(H)this.logService.info(`${j}: Installed extension.`,K.id,G.version),B.push(K);else{const oe=q.get(K.id.toLowerCase());oe&&(Z.push(oe),this.logService.info(`${j}: Skipped synchronizing extension`,G.displayName||G.identifier.id)),W instanceof m.ExtensionManagementError&&[m.ExtensionManagementErrorCode.Incompatible,m.ExtensionManagementErrorCode.IncompatibleApi,m.ExtensionManagementErrorCode.IncompatibleTargetPlatform].includes(W.code)?this.logService.info(`${j}: Skipped synchronizing extension because the compatible extension is not found.`,G.displayName||G.identifier.id):W&&this.logService.error(W)}}const ee=[];for(const K of z)B.some(H=>(0,d.areSameExtensions)(H,K.identifier))||ee.push(K);for(const K of Z)ee.some(H=>(0,d.areSameExtensions)(H.identifier,K.identifier))||ee.push(K);return ee}updateExtensionState(N,M,V,z){const J=z.getExtensionState(M,!0)||{},j=V?z.getKeysForSync({id:M.identifier.id,version:V}):void 0;j?j.forEach(te=>{J[te]=N[te]}):Object.keys(N).forEach(te=>J[te]=N[te]),z.setExtensionState(M,J,!0)}async withProfileScopedServices(N,M){return this.userDataProfileStorageService.withProfileScopedStorageService(N,async V=>{const z=new L.DisposableStore,J=z.add(this.instantiationService.createChild(new f.ServiceCollection([p.IStorageService,V]))),j=z.add(J.createInstance(S.GlobalExtensionEnablementService)),te=z.add(J.createInstance(l.ExtensionStorageService));try{return await M(j,te)}finally{z.dispose()}})}};e.LocalExtensionsProvider=w,e.LocalExtensionsProvider=w=Ie([Y(0,m.IExtensionManagementService),Y(1,o.IUserDataProfileStorageService),Y(2,m.IExtensionGalleryService),Y(3,s.IIgnoredExtensionsManagementService),Y(4,v.IInstantiationService),Y(5,r.IUserDataSyncLogService)],w);let O=class extends n.AbstractInitializer{constructor(N,M,V,z,J,j,te,q){super(r.SyncResource.Extensions,z,J,j,V,te,q),this.extensionManagementService=N,this.ignoredExtensionsManagementService=M}async parseExtensions(N){return N.syncData?await h(N.syncData,this.extensionManagementService):null}generatePreview(N,M){const V=[],z=[],J=[];for(const j of N){if(this.ignoredExtensionsManagementService.hasToNeverSyncExtension(j.identifier.id))continue;const te=M.find(q=>(0,d.areSameExtensions)(q.identifier,j.identifier));te?(V.push(te),j.disabled&&J.push(j.identifier)):j.installed&&(z.push({...j.identifier,preRelease:!!j.preRelease}),j.disabled&&J.push(j.identifier))}return{installedExtensions:V,newExtensions:z,disabledExtensions:J,remoteExtensions:N}}};e.AbstractExtensionsInitializer=O,e.AbstractExtensionsInitializer=O=Ie([Y(0,m.IExtensionManagementService),Y(1,s.IIgnoredExtensionsManagementService),Y(2,I.IFileService),Y(3,i.IUserDataProfilesService),Y(4,P.IEnvironmentService),Y(5,C.ILogService),Y(6,p.IStorageService),Y(7,u.IUriIdentityService)],O)}),define(he[122],fe([0,1,14,8,3,36,45,5,32,21,15,7,11,49,16,18,28,40,82,212,24,19,62,4]),function(ce,e,R,a,_,T,k,L,D,E,P,S,m,d,l,g,I,v,f,C,p,c,u,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreTypeSynchronizer=e.GlobalStateInitializer=e.LocalGlobalStateProvider=e.GlobalStateSynchroniser=void 0,e.stringify=s;const n="globalState.argv.",t=["locale"];function s(b,w){const O=b.storage?Object.keys(b.storage).sort():[],F={};return O.forEach(N=>F[N]=b.storage[N]),b.storage=F,w?(0,k.toFormattedString)(b,{}):JSON.stringify(b)}const r=1;let o=class extends v.AbstractSynchroniser{constructor(w,O,F,N,M,V,z,J,j,te,q,B,Z,ne){super({syncResource:p.SyncResource.GlobalState,profile:w},O,N,J,B,M,V,j,te,z,q,Z),this.userDataProfileStorageService=F,this.version=r,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"globalState.json"),this.baseResource=this.previewResource.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this.localGlobalStateProvider=ne.createInstance(h),this._register(N.watch(this.extUri.dirname(this.environmentService.argvResource))),this._register(_.Event.any(_.Event.filter(N.onDidFilesChange,le=>le.contains(this.environmentService.argvResource)),_.Event.filter(F.onDidChange,le=>!!(le.targetChanges.some(ee=>this.syncResource.profile.id===ee.id)||le.valueChanges.some(({profile:ee,changes:K})=>this.syncResource.profile.id===ee.id&&K.some(H=>H.target===l.StorageTarget.USER)))))(()=>this.triggerLocalChange()))}async generateSyncPreview(w,O,F){const N=w.syncData?JSON.parse(w.syncData.content):null;O=O===null&&F?w:O;const M=O&&O.syncData?JSON.parse(O.syncData.content):null,V=await this.localGlobalStateProvider.getLocalGlobalState(this.syncResource.profile);N?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote ui state with local ui state...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote ui state does not exist. Synchronizing ui state for the first time.`);const z=await this.getStorageKeys(M),{local:J,remote:j}=(0,C.merge)(V.storage,N?N.storage:null,M?M.storage:null,z,this.logService),te={content:null,local:J,remote:j,localChange:Object.keys(J.added).length>0||Object.keys(J.updated).length>0||J.removed.length>0?p.Change.Modified:p.Change.None,remoteChange:j.all!==null?p.Change.Modified:p.Change.None},q=s(V,!1);return[{baseResource:this.baseResource,baseContent:M?s(M,!1):q,localResource:this.localResource,localContent:q,localUserData:V,remoteResource:this.remoteResource,remoteContent:N?s(N,!1):null,previewResource:this.previewResource,previewResult:te,localChange:te.localChange,remoteChange:te.remoteChange,acceptedResource:this.acceptedResource,storageKeys:z}]}async hasRemoteChanged(w){const O=w.syncData?JSON.parse(w.syncData.content):null;if(O===null)return!0;const F=await this.localGlobalStateProvider.getLocalGlobalState(this.syncResource.profile),N=await this.getStorageKeys(O),{remote:M}=(0,C.merge)(F.storage,O.storage,O.storage,N,this.logService);return M.all!==null}async getMergeResult(w,O){return{...w.previewResult,hasConflicts:!1}}async getAcceptResult(w,O,F,N){if(this.extUri.isEqual(O,this.localResource))return this.acceptLocal(w);if(this.extUri.isEqual(O,this.remoteResource))return this.acceptRemote(w);if(this.extUri.isEqual(O,this.previewResource))return w.previewResult;throw new Error(`Invalid Resource: ${O.toString()}`)}async acceptLocal(w){return{content:w.localContent,local:{added:{},removed:[],updated:{}},remote:{added:Object.keys(w.localUserData.storage),removed:[],updated:[],all:w.localUserData.storage},localChange:p.Change.None,remoteChange:p.Change.Modified}}async acceptRemote(w){if(w.remoteContent!==null){const O=JSON.parse(w.remoteContent),{local:F,remote:N}=(0,C.merge)(w.localUserData.storage,O.storage,null,w.storageKeys,this.logService);return{content:w.remoteContent,local:F,remote:N,localChange:Object.keys(F.added).length>0||Object.keys(F.updated).length>0||F.removed.length>0?p.Change.Modified:p.Change.None,remoteChange:N!==null?p.Change.Modified:p.Change.None}}else return{content:w.remoteContent,local:{added:{},removed:[],updated:{}},remote:{added:[],removed:[],updated:[],all:null},localChange:p.Change.None,remoteChange:p.Change.None}}async applyResult(w,O,F,N){const{localUserData:M}=F[0][0],{local:V,remote:z,localChange:J,remoteChange:j}=F[0][1];if(J===p.Change.None&&j===p.Change.None&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing ui state.`),J!==p.Change.None&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local ui state...`),await this.backupLocal(JSON.stringify(M)),await this.localGlobalStateProvider.writeLocalGlobalState(V,this.syncResource.profile),this.logService.info(`${this.syncResourceLogLabel}: Updated local ui state`)),j!==p.Change.None){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote ui state...`);const te=JSON.stringify({storage:z.all});w=await this.updateRemoteUserData(te,N?null:w.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote ui state.${z.added.length?` Added: ${z.added}.`:""}${z.updated.length?` Updated: ${z.updated}.`:""}${z.removed.length?` Removed: ${z.removed}.`:""}`)}O?.ref!==w.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized ui state...`),await this.updateLastSyncUserData(w),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized ui state`))}async resolveContent(w){if(this.extUri.isEqual(this.remoteResource,w)||this.extUri.isEqual(this.baseResource,w)||this.extUri.isEqual(this.localResource,w)||this.extUri.isEqual(this.acceptedResource,w)){const O=await this.resolvePreviewContent(w);return O&&s(JSON.parse(O),!0)}return null}async hasLocalData(){try{const{storage:w}=await this.localGlobalStateProvider.getLocalGlobalState(this.syncResource.profile);if(Object.keys(w).length>1||w[`${n}.locale`]?.value!=="en")return!0}catch{}return!1}async getStorageKeys(w){const O=await this.userDataProfileStorageService.readStorageData(this.syncResource.profile),F=[],N=[];for(const[z,J]of O)J.target===l.StorageTarget.USER?F.push(z):J.target===l.StorageTarget.MACHINE&&N.push(z);const M=[...F,...N],V=w?.storage?Object.keys(w.storage).filter(z=>!z.startsWith(n)&&!M.includes(z)&&O.get(z)!==void 0):[];if(!L.isWeb){const z=[...p.ALL_SYNC_RESOURCES.map(J=>(0,p.getEnablementKey)(J)),p.SYNC_SERVICE_URL_TYPE];V.push(...z),N.push(...z)}return{user:F,machine:N,unregistered:V}}};e.GlobalStateSynchroniser=o,e.GlobalStateSynchroniser=o=Ie([Y(2,u.IUserDataProfileStorageService),Y(3,S.IFileService),Y(4,p.IUserDataSyncStoreService),Y(5,p.IUserDataSyncLocalStoreService),Y(6,p.IUserDataSyncLogService),Y(7,P.IEnvironmentService),Y(8,p.IUserDataSyncEnablementService),Y(9,g.ITelemetryService),Y(10,E.IConfigurationService),Y(11,l.IStorageService),Y(12,I.IUriIdentityService),Y(13,i.IInstantiationService)],o);let h=class{constructor(w,O,F,N){this.fileService=w,this.environmentService=O,this.userDataProfileStorageService=F,this.logService=N}async getLocalGlobalState(w){const O={};if(w.isDefault){const N=await this.getLocalArgvContent(),M=(0,T.parse)(N);for(const V of t)M[V]!==void 0&&(O[`${n}${V}`]={version:1,value:M[V]})}const F=await this.userDataProfileStorageService.readStorageData(w);for(const[N,M]of F)M.value&&M.target===l.StorageTarget.USER&&(O[N]={version:1,value:M.value});return{storage:O}}async getLocalArgvContent(){try{this.logService.debug("GlobalStateSync#getLocalArgvContent",this.environmentService.argvResource);const w=await this.fileService.readFile(this.environmentService.argvResource);return this.logService.debug("GlobalStateSync#getLocalArgvContent - Resolved",this.environmentService.argvResource),w.value.toString()}catch(w){this.logService.debug((0,a.getErrorMessage)(w))}return"{}"}async writeLocalGlobalState({added:w,removed:O,updated:F},N){const M=(0,v.getSyncResourceLogLabel)(p.SyncResource.GlobalState,N),V={},z=new Map,J=await this.userDataProfileStorageService.readStorageData(N),j=(te,q)=>{for(const B of te){if(B.startsWith(n)){V[B.substring(n.length)]=q?q[B].value:void 0;continue}if(q){const Z=q[B];Z.value!==J.get(B)?.value&&z.set(B,Z.value)}else J.get(B)!==void 0&&z.set(B,void 0)}};if(j(Object.keys(w),w),j(Object.keys(F),F),j(O),Object.keys(V).length){this.logService.trace(`${M}: Updating locale...`);const te=await this.getLocalArgvContent();let q=te;for(const B of Object.keys(V))q=(0,f.edit)(q,[B],V[B],{});te!==q&&(this.logService.trace(`${M}: Updating locale...`),await this.fileService.writeFile(this.environmentService.argvResource,R.VSBuffer.fromString(q)),this.logService.info(`${M}: Updated locale.`)),this.logService.info(`${M}: Updated locale`)}z.size&&(this.logService.trace(`${M}: Updating global state...`),await this.userDataProfileStorageService.updateStorageData(N,z,l.StorageTarget.USER),this.logService.info(`${M}: Updated global state`,[...z.keys()]))}};e.LocalGlobalStateProvider=h,e.LocalGlobalStateProvider=h=Ie([Y(0,S.IFileService),Y(1,P.IEnvironmentService),Y(2,u.IUserDataProfileStorageService),Y(3,p.IUserDataSyncLogService)],h);let y=class extends v.AbstractInitializer{constructor(w,O,F,N,M,V){super(p.SyncResource.GlobalState,F,N,M,O,w,V)}async doInitialize(w){const O=w.syncData?JSON.parse(w.syncData.content):null;if(!O){this.logService.info("Skipping initializing global state because remote global state does not exist.");return}const F={},N={};for(const M of Object.keys(O.storage))M.startsWith(n)?F[M.substring(n.length)]=O.storage[M].value:this.storageService.get(M,l.StorageScope.PROFILE)===void 0&&(N[M]=O.storage[M].value);if(Object.keys(F).length){let M="{}";try{M=(await this.fileService.readFile(this.environmentService.argvResource)).value.toString()}catch{}for(const V of Object.keys(F))M=(0,f.edit)(M,[V],F[V],{});await this.fileService.writeFile(this.environmentService.argvResource,R.VSBuffer.fromString(M))}if(Object.keys(N).length){const M=[];for(const V of Object.keys(N))M.push({key:V,value:N[V],scope:l.StorageScope.PROFILE,target:l.StorageTarget.USER});this.storageService.storeAll(M,!0)}}};e.GlobalStateInitializer=y,e.GlobalStateInitializer=y=Ie([Y(0,l.IStorageService),Y(1,S.IFileService),Y(2,c.IUserDataProfilesService),Y(3,P.IEnvironmentService),Y(4,p.IUserDataSyncLogService),Y(5,I.IUriIdentityService)],y);let A=class{constructor(w,O,F,N,M){this.userDataSyncStoreClient=w,this.storageService=O,this.environmentService=F,this.fileService=N,this.logService=M}getSyncStoreType(w){return this.parseGlobalState(w)?.storage[p.SYNC_SERVICE_URL_TYPE]?.value}async sync(w){const O=(0,p.createSyncHeaders)((0,D.generateUuid)());try{return await this.doSync(w,O)}catch(F){if(F instanceof p.UserDataSyncError)switch(F.code){case p.UserDataSyncErrorCode.PreconditionFailed:return this.logService.info("Failed to synchronize UserDataSyncStoreType as there is a new remote version available. Synchronizing again..."),this.doSync(w,O)}throw F}}async doSync(w,O){const F=await this.userDataSyncStoreClient.readResource(p.SyncResource.GlobalState,null,void 0,O),N=this.parseGlobalState(F)||{storage:{}};N.storage[p.SYNC_SERVICE_URL_TYPE]={value:w,version:r};const M=await(0,d.getServiceMachineId)(this.environmentService,this.fileService,this.storageService),V={version:r,machineId:M,content:s(N,!1)};await this.userDataSyncStoreClient.writeResource(p.SyncResource.GlobalState,JSON.stringify(V),F.ref,void 0,O)}parseGlobalState({content:w}){if(!w)return null;const O=JSON.parse(w);if((0,v.isSyncData)(O))return O?JSON.parse(O.content):null;throw new Error("Invalid remote data")}};e.UserDataSyncStoreTypeSynchronizer=A,e.UserDataSyncStoreTypeSynchronizer=A=Ie([Y(1,l.IStorageService),Y(2,P.IEnvironmentService),Y(3,S.IFileService),Y(4,m.ILogService)],A)}),define(he[123],fe([0,1,17,14,3,36,5,12,9,21,15,7,16,18,28,19,40,209,24]),function(ce,e,R,a,_,T,k,L,D,E,P,S,m,d,l,g,I,v,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeybindingsInitializer=e.KeybindingsSynchroniser=void 0,e.getKeybindingsContentFromSyncContent=C;function C(u,i,n){try{const t=JSON.parse(u);if(!i)return(0,L.isUndefined)(t.all)?null:t.all;switch(k.OS){case k.OperatingSystem.Macintosh:return(0,L.isUndefined)(t.mac)?null:t.mac;case k.OperatingSystem.Linux:return(0,L.isUndefined)(t.linux)?null:t.linux;case k.OperatingSystem.Windows:return(0,L.isUndefined)(t.windows)?null:t.windows}}catch(t){return n.error(t),null}}let p=class extends I.AbstractJsonFileSynchroniser{constructor(i,n,t,s,r,o,h,y,A,b,w,O,F){super(i.keybindingsResource,{syncResource:f.SyncResource.Keybindings,profile:i},n,y,A,b,t,s,h,O,r,w,o,F),this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"keybindings.json"),this.baseResource=this.previewResource.with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(_.Event.filter(o.onDidChangeConfiguration,N=>N.affectsConfiguration("settingsSync.keybindingsPerPlatform"))(()=>this.triggerLocalChange()))}async generateSyncPreview(i,n,t,s){const r=i.syncData?C(i.syncData.content,s.keybindingsPerPlatform??this.syncKeybindingsPerPlatform(),this.logService):null;n=n===null&&t?i:n;const o=n?this.getKeybindingsContentFromLastSyncUserData(n):null,h=await this.getLocalFileContent(),y=await this.getFormattingOptions();let A=null,b=!1,w=!1,O=!1;if(r){let M=h?h.value.toString():"[]";if(M=M||"[]",this.hasErrors(M,!0))throw new f.UserDataSyncError((0,D.localize)(2445,null),f.UserDataSyncErrorCode.LocalInvalidContent,this.resource);if(!o||o!==M||o!==r){this.logService.trace(`${this.syncResourceLogLabel}: Merging remote keybindings with local keybindings...`);const V=await(0,v.merge)(M,r,o,y,this.userDataSyncUtilService);V.hasChanges&&(A=V.mergeContent,O=V.hasConflicts,b=O||V.mergeContent!==M,w=O||V.mergeContent!==r)}}else h&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote keybindings does not exist. Synchronizing keybindings for the first time.`),A=h.value.toString(),w=!0);const F={content:O?o:A,localChange:b?h?f.Change.Modified:f.Change.Added:f.Change.None,remoteChange:w?f.Change.Modified:f.Change.None,hasConflicts:O},N=h?h.value.toString():null;return[{fileContent:h,baseResource:this.baseResource,baseContent:o,localResource:this.localResource,localContent:N,localChange:F.localChange,remoteResource:this.remoteResource,remoteContent:r,remoteChange:F.remoteChange,previewResource:this.previewResource,previewResult:F,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(i){const n=this.getKeybindingsContentFromLastSyncUserData(i);if(n===null)return!0;const t=await this.getLocalFileContent(),s=t?t.value.toString():"",r=await this.getFormattingOptions(),o=await(0,v.merge)(s||"[]",n,n,r,this.userDataSyncUtilService);return o.hasConflicts||o.mergeContent!==n}async getMergeResult(i,n){return i.previewResult}async getAcceptResult(i,n,t,s){if(this.extUri.isEqual(n,this.localResource))return{content:i.fileContent?i.fileContent.value.toString():null,localChange:f.Change.None,remoteChange:f.Change.Modified};if(this.extUri.isEqual(n,this.remoteResource))return{content:i.remoteContent,localChange:f.Change.Modified,remoteChange:f.Change.None};if(this.extUri.isEqual(n,this.previewResource))return t===void 0?{content:i.previewResult.content,localChange:i.previewResult.localChange,remoteChange:i.previewResult.remoteChange}:{content:t,localChange:f.Change.Modified,remoteChange:f.Change.Modified};throw new Error(`Invalid Resource: ${n.toString()}`)}async applyResult(i,n,t,s){const{fileContent:r}=t[0][0];let{content:o,localChange:h,remoteChange:y}=t[0][1];if(h===f.Change.None&&y===f.Change.None&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing keybindings.`),o!==null&&(o=o.trim(),o=o||"[]",this.hasErrors(o,!0)))throw new f.UserDataSyncError((0,D.localize)(2446,null),f.UserDataSyncErrorCode.LocalInvalidContent,this.resource);if(h!==f.Change.None&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local keybindings...`),r&&await this.backupLocal(this.toSyncContent(r.value.toString())),await this.updateLocalFileContent(o||"[]",r,s),this.logService.info(`${this.syncResourceLogLabel}: Updated local keybindings`)),y!==f.Change.None){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote keybindings...`);const A=this.toSyncContent(o||"[]",i.syncData?.content);i=await this.updateRemoteUserData(A,s?null:i.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote keybindings`)}try{await this.fileService.del(this.previewResource)}catch{}n?.ref!==i.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized keybindings...`),await this.updateLastSyncUserData(i,{platformSpecific:this.syncKeybindingsPerPlatform()}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized keybindings`))}async hasLocalData(){try{const i=await this.getLocalFileContent();if(i){const n=(0,T.parse)(i.value.toString());if((0,R.isNonEmptyArray)(n))return!0}}catch(i){if(i.fileOperationResult!==S.FileOperationResult.FILE_NOT_FOUND)return!0}return!1}async resolveContent(i){return this.extUri.isEqual(this.remoteResource,i)||this.extUri.isEqual(this.baseResource,i)||this.extUri.isEqual(this.localResource,i)||this.extUri.isEqual(this.acceptedResource,i)?this.resolvePreviewContent(i):null}getKeybindingsContentFromLastSyncUserData(i){return!i.syncData||i.platformSpecific!==void 0&&i.platformSpecific!==this.syncKeybindingsPerPlatform()?null:C(i.syncData.content,this.syncKeybindingsPerPlatform(),this.logService)}toSyncContent(i,n){let t={};try{t=JSON.parse(n||"{}")}catch(s){this.logService.error(s)}switch(this.syncKeybindingsPerPlatform()?delete t.all:t.all=i,k.OS){case k.OperatingSystem.Macintosh:t.mac=i;break;case k.OperatingSystem.Linux:t.linux=i;break;case k.OperatingSystem.Windows:t.windows=i;break}return JSON.stringify(t)}syncKeybindingsPerPlatform(){return!!this.configurationService.getValue(f.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM)}};e.KeybindingsSynchroniser=p,e.KeybindingsSynchroniser=p=Ie([Y(2,f.IUserDataSyncStoreService),Y(3,f.IUserDataSyncLocalStoreService),Y(4,f.IUserDataSyncLogService),Y(5,E.IConfigurationService),Y(6,f.IUserDataSyncEnablementService),Y(7,S.IFileService),Y(8,P.IEnvironmentService),Y(9,m.IStorageService),Y(10,f.IUserDataSyncUtilService),Y(11,d.ITelemetryService),Y(12,l.IUriIdentityService)],p);let c=class extends I.AbstractInitializer{constructor(i,n,t,s,r,o){super(f.SyncResource.Keybindings,n,t,s,i,r,o)}async doInitialize(i){const n=i.syncData?this.getKeybindingsContentFromSyncContent(i.syncData.content):null;if(!n){this.logService.info("Skipping initializing keybindings because remote keybindings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing keybindings because local keybindings exist.");return}await this.fileService.writeFile(this.userDataProfilesService.defaultProfile.keybindingsResource,a.VSBuffer.fromString(n)),await this.updateLastSyncUserData(i)}async isEmpty(){try{const i=await this.fileService.readFile(this.userDataProfilesService.defaultProfile.settingsResource),n=(0,T.parse)(i.value.toString());return!(0,R.isNonEmptyArray)(n)}catch(i){return i.fileOperationResult===S.FileOperationResult.FILE_NOT_FOUND}}getKeybindingsContentFromSyncContent(i){try{return C(i,!0,this.logService)}catch(n){return this.logService.error(n),null}}};e.KeybindingsInitializer=c,e.KeybindingsInitializer=c=Ie([Y(0,S.IFileService),Y(1,g.IUserDataProfilesService),Y(2,P.IEnvironmentService),Y(3,f.IUserDataSyncLogService),Y(4,m.IStorageService),Y(5,l.IUriIdentityService)],c)}),define(he[124],fe([0,1,17,14,3,9,21,78,15,27,34,7,16,18,28,19,40,213,24]),function(ce,e,R,a,_,T,k,L,D,E,P,S,m,d,l,g,I,v,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SettingsInitializer=e.SettingsSynchroniser=void 0,e.parseSettingsSyncContent=p;function C(i){return i&&i.settings&&typeof i.settings=="string"&&Object.keys(i).length===1}function p(i){const n=JSON.parse(i);return C(n)?n:{settings:i}}let c=class extends I.AbstractJsonFileSynchroniser{constructor(n,t,s,r,o,h,y,A,b,w,O,F,N,M){super(n.settingsResource,{syncResource:f.SyncResource.Settings,profile:n},t,s,r,o,h,y,O,F,A,b,w,M),this.profile=n,this.extensionManagementService=N,this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"settings.json"),this.baseResource=this.previewResource.with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this.coreIgnoredSettings=void 0,this.systemExtensionsIgnoredSettings=void 0,this.userExtensionsIgnoredSettings=void 0}async getRemoteUserDataSyncConfiguration(n){const t=await this.getLastSyncUserData(),s=await this.getLatestRemoteUserData(n,t),r=this.getSettingsSyncContent(s),o=new L.ConfigurationModelParser(f.USER_DATA_SYNC_CONFIGURATION_SCOPE,this.logService);return r?.settings&&o.parse(r.settings),o.configurationModel.getValue(f.USER_DATA_SYNC_CONFIGURATION_SCOPE)||{}}async generateSyncPreview(n,t,s){const r=await this.getLocalFileContent(),o=await this.getFormattingOptions(),h=this.getSettingsSyncContent(n);t=t===null&&s?n:t;const y=t?this.getSettingsSyncContent(t):null,A=await this.getIgnoredSettings();let b=null,w=!1,O=!1,F=!1;if(h){let z=r?r.value.toString().trim():"{}";z=z||"{}",this.validateContent(z),this.logService.trace(`${this.syncResourceLogLabel}: Merging remote settings with local settings...`);const J=(0,v.merge)(z,h.settings,y?y.settings:null,A,[],o);b=J.localContent||J.remoteContent,w=J.localContent!==null,O=J.remoteContent!==null,F=J.hasConflicts}else r&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote settings does not exist. Synchronizing settings for the first time.`),b=r.value.toString().trim()||"{}",this.validateContent(b),O=!0);const N=r?r.value.toString():null,M=y?.settings??null,V={content:F?M:b,localChange:w?f.Change.Modified:f.Change.None,remoteChange:O?f.Change.Modified:f.Change.None,hasConflicts:F};return[{fileContent:r,baseResource:this.baseResource,baseContent:M,localResource:this.localResource,localContent:N,localChange:V.localChange,remoteResource:this.remoteResource,remoteContent:h?h.settings:null,remoteChange:V.remoteChange,previewResource:this.previewResource,previewResult:V,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(n){const t=this.getSettingsSyncContent(n);if(t===null)return!0;const s=await this.getLocalFileContent(),r=s?s.value.toString().trim():"",o=await this.getIgnoredSettings(),h=await this.getFormattingOptions();return(0,v.merge)(r||"{}",t.settings,t.settings,o,[],h).remoteContent!==null}async getMergeResult(n,t){const s=await this.getFormattingOptions(),r=await this.getIgnoredSettings();return{...n.previewResult,content:n.previewResult.content?(0,v.updateIgnoredSettings)(n.previewResult.content,"{}",r,s):null}}async getAcceptResult(n,t,s,r){const o=await this.getFormattingOptions(),h=await this.getIgnoredSettings();if(this.extUri.isEqual(t,this.localResource))return{content:n.fileContent?(0,v.updateIgnoredSettings)(n.fileContent.value.toString(),"{}",h,o):null,localChange:f.Change.None,remoteChange:f.Change.Modified};if(this.extUri.isEqual(t,this.remoteResource))return{content:n.remoteContent!==null?(0,v.updateIgnoredSettings)(n.remoteContent,n.fileContent?n.fileContent.value.toString():"{}",h,o):null,localChange:f.Change.Modified,remoteChange:f.Change.None};if(this.extUri.isEqual(t,this.previewResource))return s===void 0?{content:n.previewResult.content,localChange:n.previewResult.localChange,remoteChange:n.previewResult.remoteChange}:{content:s!==null?(0,v.updateIgnoredSettings)(s,n.fileContent?n.fileContent.value.toString():"{}",h,o):null,localChange:f.Change.Modified,remoteChange:f.Change.Modified};throw new Error(`Invalid Resource: ${t.toString()}`)}async applyResult(n,t,s,r){const{fileContent:o}=s[0][0];let{content:h,localChange:y,remoteChange:A}=s[0][1];if(y===f.Change.None&&A===f.Change.None&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing settings.`),h=h?h.trim():"{}",h=h||"{}",this.validateContent(h),y!==f.Change.None&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local settings...`),o&&await this.backupLocal(JSON.stringify(this.toSettingsSyncContent(o.value.toString()))),await this.updateLocalFileContent(h,o,r),await this.configurationService.reloadConfiguration(k.ConfigurationTarget.USER_LOCAL),this.logService.info(`${this.syncResourceLogLabel}: Updated local settings`)),A!==f.Change.None){const b=await this.getFormattingOptions(),w=this.getSettingsSyncContent(n),O=await this.getIgnoredSettings(h);h=(0,v.updateIgnoredSettings)(h,w?w.settings:"{}",O,b),this.logService.trace(`${this.syncResourceLogLabel}: Updating remote settings...`),n=await this.updateRemoteUserData(JSON.stringify(this.toSettingsSyncContent(h)),r?null:n.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote settings`)}try{await this.fileService.del(this.previewResource)}catch{}t?.ref!==n.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized settings...`),await this.updateLastSyncUserData(n),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized settings`))}async hasLocalData(){try{const n=await this.getLocalFileContent();if(n)return!(0,v.isEmpty)(n.value.toString())}catch(n){if(n.fileOperationResult!==S.FileOperationResult.FILE_NOT_FOUND)return!0}return!1}async resolveContent(n){return this.extUri.isEqual(this.remoteResource,n)||this.extUri.isEqual(this.localResource,n)||this.extUri.isEqual(this.acceptedResource,n)||this.extUri.isEqual(this.baseResource,n)?this.resolvePreviewContent(n):null}async resolvePreviewContent(n){let t=await super.resolvePreviewContent(n);if(t){const s=await this.getFormattingOptions(),r=await this.getIgnoredSettings();t=(0,v.updateIgnoredSettings)(t,"{}",r,s)}return t}getSettingsSyncContent(n){return n.syncData?this.parseSettingsSyncContent(n.syncData.content):null}parseSettingsSyncContent(n){try{return p(n)}catch(t){this.logService.error(t)}return null}toSettingsSyncContent(n){return{settings:n}}async getIgnoredSettings(n){if(this.coreIgnoredSettings||(this.coreIgnoredSettings=this.userDataSyncUtilService.resolveDefaultCoreIgnoredSettings()),this.systemExtensionsIgnoredSettings||(this.systemExtensionsIgnoredSettings=this.getIgnoredSettingForSystemExtensions()),!this.userExtensionsIgnoredSettings){this.userExtensionsIgnoredSettings=this.getIgnoredSettingForUserExtensions();const s=this._register(_.Event.any(_.Event.filter(this.extensionManagementService.onDidInstallExtensions,r=>r.some(({local:o})=>!!o)),_.Event.filter(this.extensionManagementService.onDidUninstallExtension,r=>!r.error))(()=>{s.dispose(),this.userExtensionsIgnoredSettings=void 0}))}const t=(await Promise.all([this.coreIgnoredSettings,this.systemExtensionsIgnoredSettings,this.userExtensionsIgnoredSettings])).flat();return(0,v.getIgnoredSettings)(t,this.configurationService,n)}async getIgnoredSettingForSystemExtensions(){const n=await this.extensionManagementService.getInstalled(P.ExtensionType.System);return(0,R.distinct)(n.map(t=>(0,f.getIgnoredSettingsForExtension)(t.manifest)).flat())}async getIgnoredSettingForUserExtensions(){const n=await this.extensionManagementService.getInstalled(P.ExtensionType.User,this.profile.extensionsResource);return(0,R.distinct)(n.map(t=>(0,f.getIgnoredSettingsForExtension)(t.manifest)).flat())}validateContent(n){if(this.hasErrors(n,!1))throw new f.UserDataSyncError((0,T.localize)(2447,null),f.UserDataSyncErrorCode.LocalInvalidContent,this.resource)}};e.SettingsSynchroniser=c,e.SettingsSynchroniser=c=Ie([Y(2,S.IFileService),Y(3,D.IEnvironmentService),Y(4,m.IStorageService),Y(5,f.IUserDataSyncStoreService),Y(6,f.IUserDataSyncLocalStoreService),Y(7,f.IUserDataSyncLogService),Y(8,f.IUserDataSyncUtilService),Y(9,k.IConfigurationService),Y(10,f.IUserDataSyncEnablementService),Y(11,d.ITelemetryService),Y(12,E.IExtensionManagementService),Y(13,l.IUriIdentityService)],c);let u=class extends I.AbstractInitializer{constructor(n,t,s,r,o,h){super(f.SyncResource.Settings,t,s,r,n,o,h)}async doInitialize(n){const t=n.syncData?this.parseSettingsSyncContent(n.syncData.content):null;if(!t){this.logService.info("Skipping initializing settings because remote settings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing settings because local settings exist.");return}await this.fileService.writeFile(this.userDataProfilesService.defaultProfile.settingsResource,a.VSBuffer.fromString(t.settings)),await this.updateLastSyncUserData(n)}async isEmpty(){try{const n=await this.fileService.readFile(this.userDataProfilesService.defaultProfile.settingsResource);return(0,v.isEmpty)(n.value.toString().trim())}catch(n){return n.fileOperationResult===S.FileOperationResult.FILE_NOT_FOUND}}parseSettingsSyncContent(n){try{return p(n)}catch(t){this.logService.error(t)}return null}};e.SettingsInitializer=u,e.SettingsInitializer=u=Ie([Y(0,S.IFileService),Y(1,g.IUserDataProfilesService),Y(2,D.IEnvironmentService),Y(3,f.IUserDataSyncLogService),Y(4,m.IStorageService),Y(5,l.IUriIdentityService)],u)}),define(he[125],fe([0,1,14,3,29,21,15,7,16,18,28,19,40,210,24]),function(ce,e,R,a,_,T,k,L,D,E,P,S,m,d,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnippetsInitializer=e.SnippetsSynchroniser=void 0,e.parseSnippets=g;function g(f){return JSON.parse(f.content)}let I=class extends m.AbstractSynchroniser{constructor(C,p,c,u,i,n,t,s,r,o,h,y){super({syncResource:l.SyncResource.Snippets,profile:C},p,u,c,i,n,t,o,h,s,r,y),this.version=1,this.snippetsFolder=C.snippetsHome,this._register(this.fileService.watch(c.userRoamingDataHome)),this._register(this.fileService.watch(this.snippetsFolder)),this._register(a.Event.filter(this.fileService.onDidFilesChange,A=>A.affects(this.snippetsFolder))(()=>this.triggerLocalChange()))}async generateSyncPreview(C,p,c){const u=await this.getSnippetsFileContents(),i=this.toSnippetsContents(u),n=C.syncData?this.parseSnippets(C.syncData):null;p=p===null&&c?C:p;const t=p&&p.syncData?this.parseSnippets(p.syncData):null;n?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote snippets with local snippets...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote snippets does not exist. Synchronizing snippets for the first time.`);const s=(0,d.merge)(i,n,t);return this.getResourcePreviews(s,u,n||{},t||{})}async hasRemoteChanged(C){const p=C.syncData?this.parseSnippets(C.syncData):null;if(p===null)return!0;const c=await this.getSnippetsFileContents(),u=this.toSnippetsContents(c),i=(0,d.merge)(u,p,p);return Object.keys(i.remote.added).length>0||Object.keys(i.remote.updated).length>0||i.remote.removed.length>0||i.conflicts.length>0}async getMergeResult(C,p){return C.previewResult}async getAcceptResult(C,p,c,u){if(this.extUri.isEqualOrParent(p,this.syncPreviewFolder.with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"local"})))return{content:C.fileContent?C.fileContent.value.toString():null,localChange:l.Change.None,remoteChange:C.fileContent?C.remoteContent!==null?l.Change.Modified:l.Change.Added:l.Change.Deleted};if(this.extUri.isEqualOrParent(p,this.syncPreviewFolder.with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"remote"})))return{content:C.remoteContent,localChange:C.remoteContent!==null?C.fileContent?l.Change.Modified:l.Change.Added:l.Change.Deleted,remoteChange:l.Change.None};if(this.extUri.isEqualOrParent(p,this.syncPreviewFolder))return c===void 0?{content:C.previewResult.content,localChange:C.previewResult.localChange,remoteChange:C.previewResult.remoteChange}:{content:c,localChange:c===null?C.fileContent!==null?l.Change.Deleted:l.Change.None:l.Change.Modified,remoteChange:c===null?C.remoteContent!==null?l.Change.Deleted:l.Change.None:l.Change.Modified};throw new Error(`Invalid Resource: ${p.toString()}`)}async applyResult(C,p,c,u){const i=c.map(([n,t])=>({...n,acceptResult:t}));i.every(({localChange:n,remoteChange:t})=>n===l.Change.None&&t===l.Change.None)&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing snippets.`),i.some(({localChange:n})=>n!==l.Change.None)&&(await this.updateLocalBackup(i),await this.updateLocalSnippets(i,u)),i.some(({remoteChange:n})=>n!==l.Change.None)&&(C=await this.updateRemoteSnippets(i,C,u)),p?.ref!==C.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized snippets...`),await this.updateLastSyncUserData(C),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized snippets`));for(const{previewResource:n}of i)try{await this.fileService.del(n)}catch{}}getResourcePreviews(C,p,c,u){const i=new Map;for(const n of Object.keys(C.local.added)){const t={content:C.local.added[n],hasConflicts:!1,localChange:l.Change.Added,remoteChange:l.Change.None};i.set(n,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:null,fileContent:null,localResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"local"}),localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:c[n],previewResource:this.extUri.joinPath(this.syncPreviewFolder,n),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const n of Object.keys(C.local.updated)){const t={content:C.local.updated[n],hasConflicts:!1,localChange:l.Change.Modified,remoteChange:l.Change.None},s=p[n]?p[n].value.toString():null;i.set(n,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:u[n]??null,localResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:p[n],localContent:s,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:c[n],previewResource:this.extUri.joinPath(this.syncPreviewFolder,n),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const n of C.local.removed){const t={content:null,hasConflicts:!1,localChange:l.Change.Deleted,remoteChange:l.Change.None},s=p[n]?p[n].value.toString():null;i.set(n,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:u[n]??null,localResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:p[n],localContent:s,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,n),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const n of Object.keys(C.remote.added)){const t={content:C.remote.added[n],hasConflicts:!1,localChange:l.Change.None,remoteChange:l.Change.Added},s=p[n]?p[n].value.toString():null;i.set(n,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:u[n]??null,localResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:p[n],localContent:s,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,n),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const n of Object.keys(C.remote.updated)){const t={content:C.remote.updated[n],hasConflicts:!1,localChange:l.Change.None,remoteChange:l.Change.Modified},s=p[n]?p[n].value.toString():null;i.set(n,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:u[n]??null,localResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:p[n],localContent:s,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:c[n],previewResource:this.extUri.joinPath(this.syncPreviewFolder,n),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const n of C.remote.removed){const t={content:null,hasConflicts:!1,localChange:l.Change.None,remoteChange:l.Change.Deleted};i.set(n,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:u[n]??null,localResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:null,localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:c[n],previewResource:this.extUri.joinPath(this.syncPreviewFolder,n),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const n of C.conflicts){const t={content:u[n]??null,hasConflicts:!0,localChange:p[n]?l.Change.Modified:l.Change.Added,remoteChange:c[n]?l.Change.Modified:l.Change.Added},s=p[n]?p[n].value.toString():null;i.set(n,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:u[n]??null,localResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:p[n]||null,localContent:s,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:c[n]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,n),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const n of Object.keys(p))if(!i.has(n)){const t={content:p[n]?p[n].value.toString():null,hasConflicts:!1,localChange:l.Change.None,remoteChange:l.Change.None},s=p[n]?p[n].value.toString():null;i.set(n,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:u[n]??null,localResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:p[n]||null,localContent:s,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:c[n]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,n),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}return[...i.values()]}async resolveContent(C){return this.extUri.isEqualOrParent(C,this.syncPreviewFolder.with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"remote"}))||this.extUri.isEqualOrParent(C,this.syncPreviewFolder.with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"local"}))||this.extUri.isEqualOrParent(C,this.syncPreviewFolder.with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"base"}))||this.extUri.isEqualOrParent(C,this.syncPreviewFolder.with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"accepted"}))?this.resolvePreviewContent(C):null}async hasLocalData(){try{const C=await this.getSnippetsFileContents();if(Object.keys(C).length)return!0}catch{}return!1}async updateLocalBackup(C){const p={};for(const c of C)c.fileContent&&(p[this.extUri.basename(c.localResource)]=c.fileContent);await this.backupLocal(JSON.stringify(this.toSnippetsContents(p)))}async updateLocalSnippets(C,p){for(const{fileContent:c,acceptResult:u,localResource:i,remoteResource:n,localChange:t}of C)if(t!==l.Change.None){const s=n?this.extUri.basename(n):this.extUri.basename(i),r=this.extUri.joinPath(this.snippetsFolder,s);t===l.Change.Deleted?(this.logService.trace(`${this.syncResourceLogLabel}: Deleting snippet...`,this.extUri.basename(r)),await this.fileService.del(r),this.logService.info(`${this.syncResourceLogLabel}: Deleted snippet`,this.extUri.basename(r))):t===l.Change.Added?(this.logService.trace(`${this.syncResourceLogLabel}: Creating snippet...`,this.extUri.basename(r)),await this.fileService.createFile(r,R.VSBuffer.fromString(u.content),{overwrite:p}),this.logService.info(`${this.syncResourceLogLabel}: Created snippet`,this.extUri.basename(r))):(this.logService.trace(`${this.syncResourceLogLabel}: Updating snippet...`,this.extUri.basename(r)),await this.fileService.writeFile(r,R.VSBuffer.fromString(u.content),p?void 0:c),this.logService.info(`${this.syncResourceLogLabel}: Updated snippet`,this.extUri.basename(r)))}}async updateRemoteSnippets(C,p,c){const u=p.syncData?this.parseSnippets(p.syncData):{},i=(0,_.deepClone)(u);for(const{acceptResult:n,localResource:t,remoteResource:s,remoteChange:r}of C)if(r!==l.Change.None){const o=t?this.extUri.basename(t):this.extUri.basename(s);r===l.Change.Deleted?delete i[o]:i[o]=n.content}return(0,d.areSame)(u,i)||(this.logService.trace(`${this.syncResourceLogLabel}: Updating remote snippets...`),p=await this.updateRemoteUserData(JSON.stringify(i),c?null:p.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote snippets`)),p}parseSnippets(C){return g(C)}toSnippetsContents(C){const p={};for(const c of Object.keys(C))p[c]=C[c].value.toString();return p}async getSnippetsFileContents(){const C={};let p;try{p=await this.fileService.resolve(this.snippetsFolder)}catch(c){if(c instanceof L.FileOperationError&&c.fileOperationResult===L.FileOperationResult.FILE_NOT_FOUND)return C;throw c}for(const c of p.children||[]){const u=c.resource,i=this.extUri.extname(u);if(i===".json"||i===".code-snippets"){const n=this.extUri.relativePath(this.snippetsFolder,u),t=await this.fileService.readFile(u);C[n]=t}}return C}};e.SnippetsSynchroniser=I,e.SnippetsSynchroniser=I=Ie([Y(2,k.IEnvironmentService),Y(3,L.IFileService),Y(4,D.IStorageService),Y(5,l.IUserDataSyncStoreService),Y(6,l.IUserDataSyncLocalStoreService),Y(7,l.IUserDataSyncLogService),Y(8,T.IConfigurationService),Y(9,l.IUserDataSyncEnablementService),Y(10,E.ITelemetryService),Y(11,P.IUriIdentityService)],I);let v=class extends m.AbstractInitializer{constructor(C,p,c,u,i,n){super(l.SyncResource.Snippets,p,c,u,C,i,n)}async doInitialize(C){const p=C.syncData?JSON.parse(C.syncData.content):null;if(!p){this.logService.info("Skipping initializing snippets because remote snippets does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing snippets because local snippets exist.");return}for(const u of Object.keys(p)){const i=p[u];if(i){const n=this.extUri.joinPath(this.userDataProfilesService.defaultProfile.snippetsHome,u);await this.fileService.createFile(n,R.VSBuffer.fromString(i)),this.logService.info("Created snippet",this.extUri.basename(n))}}await this.updateLastSyncUserData(C)}async isEmpty(){try{return!(await this.fileService.resolve(this.userDataProfilesService.defaultProfile.snippetsHome)).children?.length}catch(C){return C.fileOperationResult===L.FileOperationResult.FILE_NOT_FOUND}}};e.SnippetsInitializer=v,e.SnippetsInitializer=v=Ie([Y(0,L.IFileService),Y(1,S.IUserDataProfilesService),Y(2,k.IEnvironmentService),Y(3,l.IUserDataSyncLogService),Y(4,D.IStorageService),Y(5,P.IUriIdentityService)],v)}),define(he[126],fe([0,1,14,21,15,7,16,18,28,19,40,24]),function(ce,e,R,a,_,T,k,L,D,E,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TasksInitializer=e.TasksSynchroniser=void 0,e.getTasksContentFromSyncContent=m;function m(I,v){try{return JSON.parse(I).tasks??null}catch(f){return v.error(f),null}}let d=class extends P.AbstractFileSynchroniser{constructor(v,f,C,p,c,u,i,n,t,s,r,o){super(v.tasksResource,{syncResource:S.SyncResource.Tasks,profile:v},f,n,t,s,C,p,i,r,c,u,o),this.version=1,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"tasks.json"),this.baseResource=this.previewResource.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"accepted"})}async generateSyncPreview(v,f,C,p){const c=v.syncData?m(v.syncData.content,this.logService):null;f=f===null&&C?v:f;const u=f?.syncData?m(f.syncData.content,this.logService):null,i=await this.getLocalFileContent();let n=null,t=!1,s=!1,r=!1;if(v.syncData){const y=i?i.value.toString():null;if(!u||u!==y||u!==c){this.logService.trace(`${this.syncResourceLogLabel}: Merging remote tasks with local tasks...`);const A=g(y,c,u);n=A.content,r=A.hasConflicts,t=A.hasLocalChanged,s=A.hasRemoteChanged}}else i&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote tasks does not exist. Synchronizing tasks for the first time.`),n=i.value.toString(),s=!0);const o={content:r?u:n,localChange:t?i?S.Change.Modified:S.Change.Added:S.Change.None,remoteChange:s?S.Change.Modified:S.Change.None,hasConflicts:r},h=i?i.value.toString():null;return[{fileContent:i,baseResource:this.baseResource,baseContent:u,localResource:this.localResource,localContent:h,localChange:o.localChange,remoteResource:this.remoteResource,remoteContent:c,remoteChange:o.remoteChange,previewResource:this.previewResource,previewResult:o,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(v){const f=v?.syncData?m(v.syncData.content,this.logService):null;if(f===null)return!0;const C=await this.getLocalFileContent(),p=C?C.value.toString():null,c=g(p,f,f);return c.hasLocalChanged||c.hasRemoteChanged}async getMergeResult(v,f){return v.previewResult}async getAcceptResult(v,f,C,p){if(this.extUri.isEqual(f,this.localResource))return{content:v.fileContent?v.fileContent.value.toString():null,localChange:S.Change.None,remoteChange:S.Change.Modified};if(this.extUri.isEqual(f,this.remoteResource))return{content:v.remoteContent,localChange:S.Change.Modified,remoteChange:S.Change.None};if(this.extUri.isEqual(f,this.previewResource))return C===void 0?{content:v.previewResult.content,localChange:v.previewResult.localChange,remoteChange:v.previewResult.remoteChange}:{content:C,localChange:S.Change.Modified,remoteChange:S.Change.Modified};throw new Error(`Invalid Resource: ${f.toString()}`)}async applyResult(v,f,C,p){const{fileContent:c}=C[0][0],{content:u,localChange:i,remoteChange:n}=C[0][1];if(i===S.Change.None&&n===S.Change.None&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing tasks.`),i!==S.Change.None&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local tasks...`),c&&await this.backupLocal(JSON.stringify(this.toTasksSyncContent(c.value.toString()))),u?await this.updateLocalFileContent(u,c,p):await this.deleteLocalFile(),this.logService.info(`${this.syncResourceLogLabel}: Updated local tasks`)),n!==S.Change.None){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote tasks...`);const t=JSON.stringify(this.toTasksSyncContent(u));v=await this.updateRemoteUserData(t,p?null:v.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote tasks`)}try{await this.fileService.del(this.previewResource)}catch{}f?.ref!==v.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized tasks...`),await this.updateLastSyncUserData(v),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized tasks`))}async hasLocalData(){return this.fileService.exists(this.file)}async resolveContent(v){return this.extUri.isEqual(this.remoteResource,v)||this.extUri.isEqual(this.baseResource,v)||this.extUri.isEqual(this.localResource,v)||this.extUri.isEqual(this.acceptedResource,v)?this.resolvePreviewContent(v):null}toTasksSyncContent(v){return v?{tasks:v}:{}}};e.TasksSynchroniser=d,e.TasksSynchroniser=d=Ie([Y(2,S.IUserDataSyncStoreService),Y(3,S.IUserDataSyncLocalStoreService),Y(4,S.IUserDataSyncLogService),Y(5,a.IConfigurationService),Y(6,S.IUserDataSyncEnablementService),Y(7,T.IFileService),Y(8,_.IEnvironmentService),Y(9,k.IStorageService),Y(10,L.ITelemetryService),Y(11,D.IUriIdentityService)],d);let l=class extends P.AbstractInitializer{constructor(v,f,C,p,c,u){super(S.SyncResource.Tasks,f,C,p,v,c,u),this.tasksResource=this.userDataProfilesService.defaultProfile.tasksResource}async doInitialize(v){const f=v.syncData?m(v.syncData.content,this.logService):null;if(!f){this.logService.info("Skipping initializing tasks because remote tasks does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing tasks because local tasks exist.");return}await this.fileService.writeFile(this.tasksResource,R.VSBuffer.fromString(f)),await this.updateLastSyncUserData(v)}async isEmpty(){return this.fileService.exists(this.tasksResource)}};e.TasksInitializer=l,e.TasksInitializer=l=Ie([Y(0,T.IFileService),Y(1,E.IUserDataProfilesService),Y(2,_.IEnvironmentService),Y(3,S.IUserDataSyncLogService),Y(4,k.IStorageService),Y(5,D.IUriIdentityService)],l);function g(I,v,f){if(I===null&&v===null&&f===null)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};if(I===v)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};const C=f!==I,p=f!==v;return!C&&!p?{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1}:C&&!p?{content:I,hasRemoteChanged:!0,hasLocalChanged:!1,hasConflicts:!1}:p&&!C?{content:v,hasLocalChanged:!0,hasRemoteChanged:!1,hasConflicts:!1}:{content:I,hasLocalChanged:!0,hasRemoteChanged:!0,hasConflicts:!0}}}),define(he[127],fe([0,1,45,21,15,7,16,18,28,19,40,211,24]),function(ce,e,R,a,_,T,k,L,D,E,P,S,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesManifestSynchroniser=void 0,e.stringifyLocalProfiles=l,e.parseUserDataProfilesManifest=g;let d=class extends P.AbstractSynchroniser{constructor(v,f,C,p,c,u,i,n,t,s,r,o,h){super({syncResource:m.SyncResource.Profiles,profile:v},f,p,c,u,i,n,r,o,t,s,h),this.userDataProfilesService=C,this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"profiles.json"),this.baseResource=this.previewResource.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(C.onDidChangeProfiles(()=>this.triggerLocalChange()))}async getLastSyncedProfiles(){const v=await this.getLastSyncUserData();return v?.syncData?g(v.syncData):null}async getRemoteSyncedProfiles(v){const f=await this.getLastSyncUserData(),C=await this.getLatestRemoteUserData(v,f);return C?.syncData?g(C.syncData):null}async generateSyncPreview(v,f,C){if(!this.userDataProfilesService.isEnabled())throw new m.UserDataSyncError("Cannot sync profiles because they are disabled",m.UserDataSyncErrorCode.LocalError);const p=v.syncData?g(v.syncData):null,c=f?.syncData?g(f.syncData):null,u=this.getLocalUserDataProfiles(),{local:i,remote:n}=(0,S.merge)(u,p,c,[]),t={local:i,remote:n,content:c?this.stringifyRemoteProfiles(c):null,localChange:i.added.length>0||i.removed.length>0||i.updated.length>0?m.Change.Modified:m.Change.None,remoteChange:n!==null?m.Change.Modified:m.Change.None},s=l(u,!1);return[{baseResource:this.baseResource,baseContent:c?this.stringifyRemoteProfiles(c):null,localResource:this.localResource,localContent:s,remoteResource:this.remoteResource,remoteContent:p?this.stringifyRemoteProfiles(p):null,remoteProfiles:p,previewResource:this.previewResource,previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(v){const f=v?.syncData?g(v.syncData):null,C=this.getLocalUserDataProfiles(),{remote:p}=(0,S.merge)(C,f,f,[]);return!!p?.added.length||!!p?.removed.length||!!p?.updated.length}async getMergeResult(v,f){return{...v.previewResult,hasConflicts:!1}}async getAcceptResult(v,f,C,p){if(this.extUri.isEqual(f,this.localResource))return this.acceptLocal(v);if(this.extUri.isEqual(f,this.remoteResource))return this.acceptRemote(v);if(this.extUri.isEqual(f,this.previewResource))return v.previewResult;throw new Error(`Invalid Resource: ${f.toString()}`)}async acceptLocal(v){const f=this.getLocalUserDataProfiles(),C=(0,S.merge)(f,null,null,[]),{local:p,remote:c}=C;return{content:v.localContent,local:p,remote:c,localChange:p.added.length>0||p.removed.length>0||p.updated.length>0?m.Change.Modified:m.Change.None,remoteChange:c!==null?m.Change.Modified:m.Change.None}}async acceptRemote(v){const f=v.remoteContent?JSON.parse(v.remoteContent):null,C=[],p=[];for(const c of this.getLocalUserDataProfiles()){const u=f?.find(i=>i.id===c.id);u&&(C.push({id:c.id,name:c.name,collection:u.collection}),p.push(c))}if(f!==null){const c=(0,S.merge)(p,f,C,[]),{local:u,remote:i}=c;return{content:v.remoteContent,local:u,remote:i,localChange:u.added.length>0||u.removed.length>0||u.updated.length>0?m.Change.Modified:m.Change.None,remoteChange:i!==null?m.Change.Modified:m.Change.None}}else return{content:v.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:m.Change.None,remoteChange:m.Change.None}}async applyResult(v,f,C,p){const{local:c,remote:u,localChange:i,remoteChange:n}=C[0][1];i===m.Change.None&&n===m.Change.None&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing profiles.`);const t=C[0][0].remoteProfiles||[];if(t.length+(u?.added.length??0)-(u?.removed.length??0)>20)throw new m.UserDataSyncError("Too many profiles to sync. Please remove some profiles and try again.",m.UserDataSyncErrorCode.LocalTooManyProfiles);if(i!==m.Change.None&&(await this.backupLocal(l(this.getLocalUserDataProfiles(),!1)),await Promise.all(c.removed.map(async s=>{this.logService.trace(`${this.syncResourceLogLabel}: Removing '${s.name}' profile...`),await this.userDataProfilesService.removeProfile(s),this.logService.info(`${this.syncResourceLogLabel}: Removed profile '${s.name}'.`)})),await Promise.all(c.added.map(async s=>{this.logService.trace(`${this.syncResourceLogLabel}: Creating '${s.name}' profile...`),await this.userDataProfilesService.createProfile(s.id,s.name,{shortName:s.shortName,icon:s.icon,useDefaultFlags:s.useDefaultFlags}),this.logService.info(`${this.syncResourceLogLabel}: Created profile '${s.name}'.`)})),await Promise.all(c.updated.map(async s=>{const r=this.userDataProfilesService.profiles.find(o=>o.id===s.id);r?(this.logService.trace(`${this.syncResourceLogLabel}: Updating '${s.name}' profile...`),await this.userDataProfilesService.updateProfile(r,{name:s.name,shortName:s.shortName,icon:s.icon,useDefaultFlags:s.useDefaultFlags}),this.logService.info(`${this.syncResourceLogLabel}: Updated profile '${s.name}'.`)):this.logService.info(`${this.syncResourceLogLabel}: Could not find profile with id '${s.id}' to update.`)}))),n!==m.Change.None){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote profiles...`);const s=[],r=t.length+(u?.added.length??0)<=20;if(r)for(const o of u?.added||[]){const h=await this.userDataSyncStoreService.createCollection(this.syncHeaders);s.push(h),t.push({id:o.id,name:o.name,collection:h,shortName:o.shortName,icon:o.icon,useDefaultFlags:o.useDefaultFlags})}else this.logService.info(`${this.syncResourceLogLabel}: Could not create remote profiles as there are too many profiles.`);for(const o of u?.removed||[])t.splice(t.findIndex(({id:h})=>o.id===h),1);for(const o of u?.updated||[]){const h=t.find(({id:y})=>o.id===y);h&&t.splice(t.indexOf(h),1,{...h,id:o.id,name:o.name,shortName:o.shortName,icon:o.icon,useDefaultFlags:o.useDefaultFlags})}try{v=await this.updateRemoteProfiles(t,p?null:v.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote profiles.${r&&u?.added.length?` Added: ${JSON.stringify(u.added.map(o=>o.name))}.`:""}${u?.updated.length?` Updated: ${JSON.stringify(u.updated.map(o=>o.name))}.`:""}${u?.removed.length?` Removed: ${JSON.stringify(u.removed.map(o=>o.name))}.`:""}`)}catch(o){if(s.length){this.logService.info(`${this.syncResourceLogLabel}: Failed to update remote profiles. Cleaning up added collections...`);for(const h of s)await this.userDataSyncStoreService.deleteCollection(h,this.syncHeaders)}throw o}for(const o of u?.removed||[])await this.userDataSyncStoreService.deleteCollection(o.collection,this.syncHeaders)}f?.ref!==v.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized profiles...`),await this.updateLastSyncUserData(v),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized profiles.`))}async updateRemoteProfiles(v,f){return this.updateRemoteUserData(this.stringifyRemoteProfiles(v),f)}async hasLocalData(){return this.getLocalUserDataProfiles().length>0}async resolveContent(v){if(this.extUri.isEqual(this.remoteResource,v)||this.extUri.isEqual(this.baseResource,v)||this.extUri.isEqual(this.localResource,v)||this.extUri.isEqual(this.acceptedResource,v)){const f=await this.resolvePreviewContent(v);return f&&(0,R.toFormattedString)(JSON.parse(f),{})}return null}getLocalUserDataProfiles(){return this.userDataProfilesService.profiles.filter(v=>!v.isDefault&&!v.isTransient)}stringifyRemoteProfiles(v){return JSON.stringify([...v].sort((f,C)=>f.name.localeCompare(C.name)))}};e.UserDataProfilesManifestSynchroniser=d,e.UserDataProfilesManifestSynchroniser=d=Ie([Y(2,E.IUserDataProfilesService),Y(3,T.IFileService),Y(4,_.IEnvironmentService),Y(5,k.IStorageService),Y(6,m.IUserDataSyncStoreService),Y(7,m.IUserDataSyncLocalStoreService),Y(8,m.IUserDataSyncLogService),Y(9,a.IConfigurationService),Y(10,m.IUserDataSyncEnablementService),Y(11,L.ITelemetryService),Y(12,D.IUriIdentityService)],d);function l(I,v){const f=[...I].sort((C,p)=>C.name.localeCompare(p.name)).map(C=>({id:C.id,name:C.name}));return v?(0,R.toFormattedString)(f,{}):JSON.stringify(f)}function g(I){return JSON.parse(I.content)}}),define(he[230],fe([0,1,3,2,5,15,16,18,24]),function(ce,e,R,a,_,T,k,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncEnablementService=void 0;const E="sync.enable";let P=class extends a.Disposable{constructor(m,d,l,g){super(),this.storageService=m,this.telemetryService=d,this.environmentService=l,this.userDataSyncStoreManagementService=g,this._onDidChangeEnablement=new R.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this._onDidChangeResourceEnablement=new R.Emitter,this.onDidChangeResourceEnablement=this._onDidChangeResourceEnablement.event,this._register(m.onDidChangeValue(k.StorageScope.APPLICATION,void 0,this._register(new a.DisposableStore))(I=>this.onDidStorageChange(I)))}isEnabled(){switch(this.environmentService.sync){case"on":return!0;case"off":return!1}return this.storageService.getBoolean(E,k.StorageScope.APPLICATION,!1)}canToggleEnablement(){return this.userDataSyncStoreManagementService.userDataSyncStore!==void 0&&this.environmentService.sync===void 0}setEnablement(m){m&&!this.canToggleEnablement()||(this.telemetryService.publicLog2(E,{enabled:m}),this.storageService.store(E,m,k.StorageScope.APPLICATION,k.StorageTarget.MACHINE))}isResourceEnabled(m){return this.storageService.getBoolean((0,D.getEnablementKey)(m),k.StorageScope.APPLICATION,!0)}setResourceEnablement(m,d){if(this.isResourceEnabled(m)!==d){const l=(0,D.getEnablementKey)(m);this.storeResourceEnablement(l,d)}}getResourceSyncStateVersion(m){}storeResourceEnablement(m,d){this.storageService.store(m,d,k.StorageScope.APPLICATION,_.isWeb?k.StorageTarget.USER:k.StorageTarget.MACHINE)}onDidStorageChange(m){if(E===m.key){this._onDidChangeEnablement.fire(this.isEnabled());return}const d=D.ALL_SYNC_RESOURCES.filter(l=>(0,D.getEnablementKey)(l)===m.key)[0];if(d){this._onDidChangeResourceEnablement.fire([d,this.isResourceEnabled(d)]);return}}};e.UserDataSyncEnablementService=P,e.UserDataSyncEnablementService=P=Ie([Y(0,k.IStorageService),Y(1,L.ITelemetryService),Y(2,T.IEnvironmentService),Y(3,D.IUserDataSyncStoreManagementService)],P)}),define(he[231],fe([0,1,6,14,67,2,20,21,15,7,19,24]),function(ce,e,R,a,_,T,k,L,D,E,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncLocalStoreService=void 0;let m=class extends T.Disposable{constructor(l,g,I,v,f){super(),this.environmentService=l,this.fileService=g,this.configurationService=I,this.logService=v,this.userDataProfilesService=f,this.cleanUp()}async cleanUp(){for(const g of this.userDataProfilesService.profiles)for(const I of S.ALL_SYNC_RESOURCES)try{await this.cleanUpBackup(this.getResourceBackupHome(I,g.isDefault?void 0:g.id))}catch(v){this.logService.error(v)}let l;try{l=await this.fileService.resolve(this.environmentService.userDataSyncHome)}catch(g){(0,E.toFileOperationResult)(g)!==E.FileOperationResult.FILE_NOT_FOUND&&this.logService.error(g);return}if(l.children){for(const g of l.children)if(g.isDirectory&&!S.ALL_SYNC_RESOURCES.includes(g.name)&&!this.userDataProfilesService.profiles.some(I=>I.id===g.name))try{this.logService.info("Deleting non existing profile from backup",g.resource.path),await this.fileService.del(g.resource,{recursive:!0})}catch(I){this.logService.error(I)}}}async getAllResourceRefs(l,g,I){const v=this.getResourceBackupHome(l,g,I);try{const f=await this.fileService.resolve(v);if(f.children)return f.children.filter(p=>p.isFile&&!p.name.startsWith("lastSync")).sort().reverse().map(p=>({ref:p.name,created:this.getCreationTime(p)}))}catch(f){if((0,E.toFileOperationResult)(f)!==E.FileOperationResult.FILE_NOT_FOUND)throw f}return[]}async resolveResourceContent(l,g,I,v){const f=this.getResourceBackupHome(l,I,v),C=(0,k.joinPath)(f,g);try{return(await this.fileService.readFile(C)).value.toString()}catch(p){return this.logService.error(p),null}}async writeResource(l,g,I,v,f){const C=this.getResourceBackupHome(l,v,f),p=(0,k.joinPath)(C,`${(0,_.toLocalISOString)(I).replace(/-|:|\.\d+Z$/g,"")}.json`);try{await this.fileService.writeFile(p,a.VSBuffer.fromString(g))}catch(c){this.logService.error(c)}}getResourceBackupHome(l,g,I=this.environmentService.userDataSyncHome){return(0,k.joinPath)(I,...g?[g,l]:[l])}async cleanUpBackup(l){try{try{if(!await this.fileService.exists(l))return}catch{return}const g=await this.fileService.resolve(l);if(g.children){const I=g.children.filter(p=>p.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(p.name)).sort(),v=1e3*60*60*24*(this.configurationService.getValue("sync.localBackupDuration")||30);let f=I.filter(p=>Date.now()-this.getCreationTime(p)>v);const C=I.length-f.length;C<10&&(f=f.slice(10-C)),await R.Promises.settled(f.map(async p=>{this.logService.info("Deleting from backup",p.resource.path),await this.fileService.del(p.resource)}))}}catch(g){this.logService.error(g)}}getCreationTime(l){return new Date(parseInt(l.name.substring(0,4)),parseInt(l.name.substring(4,6))-1,parseInt(l.name.substring(6,8)),parseInt(l.name.substring(9,11)),parseInt(l.name.substring(11,13)),parseInt(l.name.substring(13,15))).getTime()}};e.UserDataSyncLocalStoreService=m,e.UserDataSyncLocalStoreService=m=Ie([Y(0,D.IEnvironmentService),Y(1,E.IFileService),Y(2,L.IConfigurationService),Y(3,S.IUserDataSyncLogService),Y(4,P.IUserDataProfilesService)],m)}),define(he[87],fe([0,1,3,2,5,26,9,15,7,4,23,49,16,24]),function(ce,e,R,a,_,T,k,L,D,E,P,S,m,d){"use strict";var l;Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncMachinesService=e.IUserDataSyncMachinesService=void 0,e.isWebPlatform=c,e.IUserDataSyncMachinesService=(0,E.createDecorator)("IUserDataSyncMachinesService");const g="sync.currentMachineName",I="Safari",v="Chrome",f="Edge",C="Firefox",p="Android";function c(n){switch(n){case I:case v:case f:case C:case p:case(0,_.PlatformToString)(_.Platform.Web):return!0}return!1}function u(){return _.isSafari?I:_.isChrome?v:_.isEdge?f:_.isFirefox?C:_.isAndroid?p:(0,_.PlatformToString)(_.isWeb?_.Platform.Web:_.platform)}let i=class extends a.Disposable{static{l=this}static{this.VERSION=1}static{this.RESOURCE="machines"}constructor(t,s,r,o,h,y){super(),this.storageService=r,this.userDataSyncStoreService=o,this.logService=h,this.productService=y,this._onDidChange=this._register(new R.Emitter),this.onDidChange=this._onDidChange.event,this.userData=null,this.currentMachineIdPromise=(0,S.getServiceMachineId)(t,s,r)}async getMachines(t){const s=await this.currentMachineIdPromise;return(await this.readMachinesData(t)).machines.map(o=>({...o,isCurrent:o.id===s}))}async addCurrentMachine(t){const s=await this.currentMachineIdPromise,r=await this.readMachinesData(t);r.machines.some(({id:o})=>o===s)||(r.machines.push({id:s,name:this.computeCurrentMachineName(r.machines),platform:u()}),await this.writeMachinesData(r))}async removeCurrentMachine(t){const s=await this.currentMachineIdPromise,r=await this.readMachinesData(t),o=r.machines.filter(({id:h})=>h!==s);o.length!==r.machines.length&&(r.machines=o,await this.writeMachinesData(r))}async renameMachine(t,s,r){const o=await this.readMachinesData(r),h=o.machines.find(({id:y})=>y===t);if(h){h.name=s,await this.writeMachinesData(o);const y=await this.currentMachineIdPromise;t===y&&this.storageService.store(g,s,m.StorageScope.APPLICATION,m.StorageTarget.MACHINE)}}async setEnablements(t){const s=await this.readMachinesData();for(const[r,o]of t){const h=s.machines.find(y=>y.id===r);h&&(h.disabled=o?void 0:!0)}await this.writeMachinesData(s)}computeCurrentMachineName(t){const s=this.storageService.get(g,m.StorageScope.APPLICATION);if(s)return s;const r=`${this.productService.embedderIdentifier?`${this.productService.embedderIdentifier} - `:""}${u()} (${this.productService.nameShort})`,o=new RegExp(`${(0,T.escapeRegExpCharacters)(r)}\\s#(\\d+)`);let h=0;for(const y of t){const A=o.exec(y.name),b=A?parseInt(A[1]):0;h=b>h?b:h}return`${r} #${h+1}`}async readMachinesData(t){this.userData=await this.readUserData(t);const s=this.parse(this.userData);if(s.version!==l.VERSION)throw new Error((0,k.localize)(2461,null,this.productService.nameLong));return s}async writeMachinesData(t){const s=JSON.stringify(t),r=await this.userDataSyncStoreService.writeResource(l.RESOURCE,s,this.userData?.ref||null);this.userData={ref:r,content:s},this._onDidChange.fire()}async readUserData(t){if(this.userData){const s=t&&t.latest?t.latest[l.RESOURCE]:void 0;if(this.userData.ref===s)return this.userData;if(s===void 0&&this.userData.content===null)return this.userData}return this.userDataSyncStoreService.readResource(l.RESOURCE,this.userData)}parse(t){if(t.content!==null)try{return JSON.parse(t.content)}catch(s){this.logService.error(s)}return{version:l.VERSION,machines:[]}}};e.UserDataSyncMachinesService=i,e.UserDataSyncMachinesService=i=l=Ie([Y(0,L.IEnvironmentService),Y(1,D.IFileService),Y(2,m.IStorageService),Y(3,d.IUserDataSyncStoreService),Y(4,d.IUserDataSyncLogService),Y(5,P.IProductService)],i)}),define(he[232],fe([0,1,6,67,41,8,3,2,5,20,10,9,23,16,18,24,83,87]),function(ce,e,R,a,_,T,k,L,D,E,P,S,m,d,l,g,I,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;const f="sync.disableMachineEventually",C="sync.sessionId",p="sync.storeUrl",c="sync.productQuality";let u=class extends L.Disposable{get syncUrl(){const t=this.storageService.get(p,d.StorageScope.APPLICATION);return t?P.URI.parse(t):void 0}set syncUrl(t){t?this.storageService.store(p,t.toString(),d.StorageScope.APPLICATION,d.StorageTarget.MACHINE):this.storageService.remove(p,d.StorageScope.APPLICATION)}get productQuality(){return this.storageService.get(c,d.StorageScope.APPLICATION)}set productQuality(t){t?this.storageService.store(c,t,d.StorageScope.APPLICATION,d.StorageTarget.MACHINE):this.storageService.remove(c,d.StorageScope.APPLICATION)}constructor(t,s,r,o,h,y,A,b,w,O){super(),this.userDataSyncStoreManagementService=s,this.userDataSyncStoreService=r,this.userDataSyncEnablementService=o,this.userDataSyncService=h,this.logService=y,this.userDataSyncAccountService=A,this.telemetryService=b,this.userDataSyncMachinesService=w,this.storageService=O,this.autoSync=this._register(new L.MutableDisposable),this.successiveFailures=0,this.lastSyncTriggerTime=void 0,this.suspendUntilRestart=!1,this._onError=this._register(new k.Emitter),this.onError=this._onError.event,this.sources=[],this.syncTriggerDelayer=this._register(new R.ThrottledDelayer(this.getSyncTriggerDelayTime())),this.lastSyncUrl=this.syncUrl,this.syncUrl=s.userDataSyncStore?.url,this.previousProductQuality=this.productQuality,this.productQuality=t.quality,this.syncUrl&&(this.logService.info("Using settings sync service",this.syncUrl.toString()),this._register(s.onDidChangeUserDataSyncStore(()=>{(0,E.isEqual)(this.syncUrl,s.userDataSyncStore?.url)||(this.lastSyncUrl=this.syncUrl,this.syncUrl=s.userDataSyncStore?.url,this.syncUrl&&this.logService.info("Using settings sync service",this.syncUrl.toString()))})),this.userDataSyncEnablementService.isEnabled()?this.logService.info("Auto Sync is enabled."):this.logService.info("Auto Sync is disabled."),this.updateAutoSync(),this.hasToDisableMachineEventually()&&this.disableMachineEventually(),this._register(A.onDidChangeAccount(()=>this.updateAutoSync())),this._register(r.onDidChangeDonotMakeRequestsUntil(()=>this.updateAutoSync())),this._register(h.onDidChangeLocal(F=>this.triggerSync([F],!1,!1))),this._register(k.Event.filter(this.userDataSyncEnablementService.onDidChangeResourceEnablement,([,F])=>F)(()=>this.triggerSync(["resourceEnablement"],!1,!1))),this._register(this.userDataSyncStoreManagementService.onDidChangeUserDataSyncStore(()=>this.triggerSync(["userDataSyncStoreChanged"],!1,!1))))}updateAutoSync(){const{enabled:t,message:s}=this.isAutoSyncEnabled();t?this.autoSync.value===void 0&&(this.autoSync.value=new i(this.lastSyncUrl,1e3*60*5,this.userDataSyncStoreManagementService,this.userDataSyncStoreService,this.userDataSyncService,this.userDataSyncMachinesService,this.logService,this.telemetryService,this.storageService),this.autoSync.value.register(this.autoSync.value.onDidStartSync(()=>this.lastSyncTriggerTime=new Date().getTime())),this.autoSync.value.register(this.autoSync.value.onDidFinishSync(r=>this.onDidFinishSync(r))),this.startAutoSync()&&this.autoSync.value.start()):(this.syncTriggerDelayer.cancel(),this.autoSync.value!==void 0?(s&&this.logService.info(s),this.autoSync.clear()):s&&this.userDataSyncEnablementService.isEnabled()&&this.logService.info(s))}startAutoSync(){return!0}isAutoSyncEnabled(){return this.userDataSyncEnablementService.isEnabled()?this.userDataSyncAccountService.account?this.userDataSyncStoreService.donotMakeRequestsUntil?{enabled:!1,message:`Auto Sync: Suspended until ${(0,a.toLocalISOString)(this.userDataSyncStoreService.donotMakeRequestsUntil)} because server is not accepting requests until then.`}:this.suspendUntilRestart?{enabled:!1,message:"Auto Sync: Suspended until restart."}:{enabled:!0}:{enabled:!1,message:"Auto Sync: Suspended until auth token is available."}:{enabled:!1,message:"Auto Sync: Disabled."}}async turnOn(){this.stopDisableMachineEventually(),this.lastSyncUrl=this.syncUrl,this.updateEnablement(!0)}async turnOff(t,s,r){try{this.userDataSyncAccountService.account&&!r&&await this.userDataSyncMachinesService.removeCurrentMachine(),this.updateEnablement(!1),this.storageService.remove(C,d.StorageScope.APPLICATION),t?(this.telemetryService.publicLog2("sync/turnOffEveryWhere"),await this.userDataSyncService.reset()):await this.userDataSyncService.resetLocal()}catch(o){if(this.logService.error(o),s)this.updateEnablement(!1);else throw o}}updateEnablement(t){this.userDataSyncEnablementService.isEnabled()!==t&&(this.userDataSyncEnablementService.setEnablement(t),this.updateAutoSync())}hasProductQualityChanged(){return!!this.previousProductQuality&&!!this.productQuality&&this.previousProductQuality!==this.productQuality}async onDidFinishSync(t){if(!t){this.successiveFailures=0;return}const s=g.UserDataSyncError.toUserDataSyncError(t);s instanceof g.UserDataAutoSyncError&&this.telemetryService.publicLog2("autosync/error",{code:s.code,service:this.userDataSyncStoreManagementService.userDataSyncStore.url.toString()}),s.code===g.UserDataSyncErrorCode.SessionExpired?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because current session is expired")):s.code===g.UserDataSyncErrorCode.TurnedOff?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because sync is turned off in the cloud")):s.code===g.UserDataSyncErrorCode.LocalTooManyRequests?(this.suspendUntilRestart=!0,this.logService.info("Auto Sync: Suspended sync because of making too many requests to server"),this.updateAutoSync()):s.code===g.UserDataSyncErrorCode.TooManyRequests?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because of making too many requests to server")):s.code===g.UserDataSyncErrorCode.MethodNotFound?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because current client is making requests to server that are not supported")):s.code===g.UserDataSyncErrorCode.UpgradeRequired||s.code===g.UserDataSyncErrorCode.Gone?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because current client is not compatible with server. Requires client upgrade.")):s.code===g.UserDataSyncErrorCode.IncompatibleLocalContent?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${s.resource} content with newer version than of client. Requires client upgrade.`)):s.code===g.UserDataSyncErrorCode.IncompatibleRemoteContent?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${s.resource} content with older version than of client. Requires server reset.`)):s.code===g.UserDataSyncErrorCode.ServiceChanged||s.code===g.UserDataSyncErrorCode.DefaultServiceChanged?D.isWeb&&s.code===g.UserDataSyncErrorCode.DefaultServiceChanged&&!this.hasProductQualityChanged()?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because default sync service is changed.")):(await this.turnOff(!1,!0,!0),await this.turnOn(),this.logService.info("Auto Sync: Sync Service changed. Turned off auto sync, reset local state and turned on auto sync.")):(this.logService.error(s),this.successiveFailures++),this._onError.fire(s)}async disableMachineEventually(){this.storageService.store(f,!0,d.StorageScope.APPLICATION,d.StorageTarget.MACHINE),await(0,R.timeout)(1e3*60*10),this.hasToDisableMachineEventually()&&(this.stopDisableMachineEventually(),!this.userDataSyncEnablementService.isEnabled()&&this.userDataSyncAccountService.account&&await this.userDataSyncMachinesService.removeCurrentMachine())}hasToDisableMachineEventually(){return this.storageService.getBoolean(f,d.StorageScope.APPLICATION,!1)}stopDisableMachineEventually(){this.storageService.remove(f,d.StorageScope.APPLICATION)}async triggerSync(t,s,r){if(this.autoSync.value===void 0)return this.syncTriggerDelayer.cancel();if(s&&this.lastSyncTriggerTime&&Math.round((new Date().getTime()-this.lastSyncTriggerTime)/1e3)<10){this.logService.debug("Auto Sync: Skipped. Limited to once per 10 seconds.");return}return this.sources.push(...t),this.syncTriggerDelayer.trigger(async()=>{this.logService.trace("activity sources",...this.sources);const o=this.userDataSyncAccountService.account?.authenticationProviderId||"";this.telemetryService.publicLog2("sync/triggered",{sources:this.sources,providerId:o}),this.sources=[],this.autoSync.value&&await this.autoSync.value.sync("Activity",r)},this.successiveFailures?this.getSyncTriggerDelayTime()*1*Math.min(Math.pow(2,this.successiveFailures),60):this.getSyncTriggerDelayTime())}getSyncTriggerDelayTime(){return 2e3}};e.UserDataAutoSyncService=u,e.UserDataAutoSyncService=u=Ie([Y(0,m.IProductService),Y(1,g.IUserDataSyncStoreManagementService),Y(2,g.IUserDataSyncStoreService),Y(3,g.IUserDataSyncEnablementService),Y(4,g.IUserDataSyncService),Y(5,g.IUserDataSyncLogService),Y(6,I.IUserDataSyncAccountService),Y(7,l.ITelemetryService),Y(8,v.IUserDataSyncMachinesService),Y(9,d.IStorageService)],u);class i extends L.Disposable{static{this.INTERVAL_SYNCING="Interval"}constructor(t,s,r,o,h,y,A,b,w){super(),this.lastSyncUrl=t,this.interval=s,this.userDataSyncStoreManagementService=r,this.userDataSyncStoreService=o,this.userDataSyncService=h,this.userDataSyncMachinesService=y,this.logService=A,this.telemetryService=b,this.storageService=w,this.intervalHandler=this._register(new L.MutableDisposable),this._onDidStartSync=this._register(new k.Emitter),this.onDidStartSync=this._onDidStartSync.event,this._onDidFinishSync=this._register(new k.Emitter),this.onDidFinishSync=this._onDidFinishSync.event,this.manifest=null}start(){this._register(this.onDidFinishSync(()=>this.waitUntilNextIntervalAndSync())),this._register((0,L.toDisposable)(()=>{this.syncPromise&&(this.syncPromise.cancel(),this.logService.info("Auto sync: Cancelled sync that is in progress"),this.syncPromise=void 0),this.syncTask?.stop(),this.logService.info("Auto Sync: Stopped")})),this.sync(i.INTERVAL_SYNCING,!1)}waitUntilNextIntervalAndSync(){this.intervalHandler.value=(0,R.disposableTimeout)(()=>{this.sync(i.INTERVAL_SYNCING,!1),this.intervalHandler.value=void 0},this.interval)}sync(t,s){const r=(0,R.createCancelablePromise)(async o=>{if(this.syncPromise)try{this.logService.debug("Auto Sync: Waiting until sync is finished."),await this.syncPromise}catch(h){if((0,T.isCancellationError)(h))return}return this.doSync(t,s,o)});return this.syncPromise=r,this.syncPromise.finally(()=>this.syncPromise=void 0),this.syncPromise}hasSyncServiceChanged(){return this.lastSyncUrl!==void 0&&!(0,E.isEqual)(this.lastSyncUrl,this.userDataSyncStoreManagementService.userDataSyncStore?.url)}async hasDefaultServiceChanged(){const t=await this.userDataSyncStoreManagementService.getPreviousUserDataSyncStore(),s=this.userDataSyncStoreManagementService.userDataSyncStore;return!!s&&!!t&&(!(0,E.isEqual)(s.defaultUrl,t.defaultUrl)||!(0,E.isEqual)(s.insidersUrl,t.insidersUrl)||!(0,E.isEqual)(s.stableUrl,t.stableUrl))}async doSync(t,s,r){this.logService.info(`Auto Sync: Triggered by ${t}`),this._onDidStartSync.fire();let o;try{await this.createAndRunSyncTask(s,r)}catch(h){if(this.logService.error(h),o=h,g.UserDataSyncError.toUserDataSyncError(h).code===g.UserDataSyncErrorCode.MethodNotFound)try{this.logService.info("Auto Sync: Client is making invalid requests. Cleaning up data..."),await this.userDataSyncService.cleanUpRemoteData(),this.logService.info("Auto Sync: Retrying sync..."),await this.createAndRunSyncTask(s,r),o=void 0}catch(y){this.logService.error(y),o=y}}this._onDidFinishSync.fire(o)}async createAndRunSyncTask(t,s){if(this.syncTask=await this.userDataSyncService.createSyncTask(this.manifest,t),s.isCancellationRequested)return;if(this.manifest=this.syncTask.manifest,this.manifest===null&&await this.userDataSyncService.hasPreviouslySynced())throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new g.UserDataAutoSyncError((0,S.localize)(2448,null),g.UserDataSyncErrorCode.DefaultServiceChanged):new g.UserDataAutoSyncError((0,S.localize)(2449,null),g.UserDataSyncErrorCode.ServiceChanged):new g.UserDataAutoSyncError((0,S.localize)(2450,null),g.UserDataSyncErrorCode.TurnedOff);const r=this.storageService.get(C,d.StorageScope.APPLICATION);if(r&&this.manifest&&r!==this.manifest.session)throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new g.UserDataAutoSyncError((0,S.localize)(2451,null),g.UserDataSyncErrorCode.DefaultServiceChanged):new g.UserDataAutoSyncError((0,S.localize)(2452,null),g.UserDataSyncErrorCode.ServiceChanged):new g.UserDataAutoSyncError((0,S.localize)(2453,null),g.UserDataSyncErrorCode.SessionExpired);const o=await this.userDataSyncMachinesService.getMachines(this.manifest||void 0);if(s.isCancellationRequested)return;const h=o.find(A=>A.isCurrent);if(h?.disabled)throw new g.UserDataAutoSyncError((0,S.localize)(2454,null),g.UserDataSyncErrorCode.TurnedOff);const y=new Date().getTime();if(await this.syncTask.run(),this.telemetryService.publicLog2("settingsSync:sync",{duration:new Date().getTime()-y}),this.manifest===null)try{this.manifest=await this.userDataSyncStoreService.manifest(null)}catch(A){throw new g.UserDataAutoSyncError((0,_.toErrorMessage)(A),A instanceof g.UserDataSyncError?A.code:g.UserDataSyncErrorCode.Unknown)}this.manifest&&this.manifest.session!==r&&this.storageService.store(C,this.manifest.session,d.StorageScope.APPLICATION,d.StorageTarget.MACHINE),!s.isCancellationRequested&&(h||await this.userDataSyncMachinesService.addCurrentMachine(this.manifest||void 0))}register(t){return super._register(t)}}}),define(he[233],fe([0,1,10,9,15,7,49,16,28,24,19,40,125,124,123,21,126,121,122,4,127,45,26]),function(ce,e,R,a,_,T,k,L,D,E,P,S,m,d,l,g,I,v,f,C,p,c,u){"use strict";var i;Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncResourceProviderService=void 0;let n=class{static{i=this}static{this.NOT_EXISTING_RESOURCE="not-existing-resource"}static{this.REMOTE_BACKUP_AUTHORITY="remote-backup"}static{this.LOCAL_BACKUP_AUTHORITY="local-backup"}constructor(s,r,o,h,y,A,b,w,O,F){this.userDataSyncStoreService=s,this.userDataSyncLocalStoreService=r,this.logService=o,this.environmentService=y,this.storageService=A,this.fileService=b,this.userDataProfilesService=w,this.configurationService=O,this.instantiationService=F,this.extUri=h.extUri}async getRemoteSyncedProfiles(){const s=await this.userDataSyncStoreService.readResource(E.SyncResource.Profiles,null,void 0);if(s.content){const r=this.parseSyncData(s.content,E.SyncResource.Profiles);return(0,p.parseUserDataProfilesManifest)(r)}return[]}async getLocalSyncedProfiles(s){const r=await this.userDataSyncLocalStoreService.getAllResourceRefs(E.SyncResource.Profiles,void 0,s);if(r.length){const o=await this.userDataSyncLocalStoreService.resolveResourceContent(E.SyncResource.Profiles,r[0].ref,void 0,s);if(o){const h=this.parseSyncData(o,E.SyncResource.Profiles);return(0,p.parseUserDataProfilesManifest)(h)}}return[]}async getLocalSyncedMachines(s){const r=await this.userDataSyncLocalStoreService.getAllResourceRefs("machines",void 0,s);if(r.length){const o=await this.userDataSyncLocalStoreService.resolveResourceContent("machines",r[0].ref,void 0,s);if(o)return JSON.parse(o).machines.map(y=>({...y,isCurrent:!1}))}return[]}async getRemoteSyncResourceHandles(s,r){return(await this.userDataSyncStoreService.getAllResourceRefs(s,r?.collection)).map(({created:h,ref:y})=>({created:h,uri:this.toUri({remote:!0,syncResource:s,profile:r?.id??this.userDataProfilesService.defaultProfile.id,location:void 0,collection:r?.collection,ref:y,node:void 0})}))}async getLocalSyncResourceHandles(s,r,o){return(await this.userDataSyncLocalStoreService.getAllResourceRefs(s,r?.collection,o)).map(({created:y,ref:A})=>({created:y,uri:this.toUri({remote:!1,syncResource:s,profile:r?.id??this.userDataProfilesService.defaultProfile.id,collection:r?.collection,ref:A,node:void 0,location:o})}))}resolveUserDataSyncResource({uri:s}){const r=this.resolveUri(s),o=r?this.userDataProfilesService.profiles.find(h=>h.id===r.profile):void 0;return r&&o?{profile:o,syncResource:r?.syncResource}:void 0}async getAssociatedResources({uri:s}){const r=this.resolveUri(s);if(!r)return[];const o=this.userDataProfilesService.profiles.find(h=>h.id===r.profile);switch(r.syncResource){case E.SyncResource.Settings:return this.getSettingsAssociatedResources(s,o);case E.SyncResource.Keybindings:return this.getKeybindingsAssociatedResources(s,o);case E.SyncResource.Tasks:return this.getTasksAssociatedResources(s,o);case E.SyncResource.Snippets:return this.getSnippetsAssociatedResources(s,o);case E.SyncResource.GlobalState:return this.getGlobalStateAssociatedResources(s,o);case E.SyncResource.Extensions:return this.getExtensionsAssociatedResources(s,o);case E.SyncResource.Profiles:return this.getProfilesAssociatedResources(s,o);case E.SyncResource.WorkspaceState:return[]}}async getMachineId({uri:s}){const r=this.resolveUri(s);if(r){if(r.remote){if(r.ref){const{content:o}=await this.getUserData(r.syncResource,r.ref,r.collection);if(o)return this.parseSyncData(o,r.syncResource)?.machineId}return}if(r.location){if(r.ref){const o=await this.userDataSyncLocalStoreService.resolveResourceContent(r.syncResource,r.ref,r.collection,r.location);if(o)return this.parseSyncData(o,r.syncResource)?.machineId}return}return(0,k.getServiceMachineId)(this.environmentService,this.fileService,this.storageService)}}async resolveContent(s){const r=this.resolveUri(s);if(!r||r.node===i.NOT_EXISTING_RESOURCE)return null;if(r.ref){const o=await this.getContentFromStore(r.remote,r.syncResource,r.collection,r.ref,r.location);return r.node&&o?this.resolveNodeContent(r.syncResource,o,r.node):o}return!r.remote&&!r.node?this.resolveLatestContent(r.syncResource,r.profile):null}async getContentFromStore(s,r,o,h,y){if(s){const{content:A}=await this.getUserData(r,h,o);return A}return this.userDataSyncLocalStoreService.resolveResourceContent(r,h,o,y)}resolveNodeContent(s,r,o){const h=this.parseSyncData(r,s);switch(s){case E.SyncResource.Settings:return this.resolveSettingsNodeContent(h,o);case E.SyncResource.Keybindings:return this.resolveKeybindingsNodeContent(h,o);case E.SyncResource.Tasks:return this.resolveTasksNodeContent(h,o);case E.SyncResource.Snippets:return this.resolveSnippetsNodeContent(h,o);case E.SyncResource.GlobalState:return this.resolveGlobalStateNodeContent(h,o);case E.SyncResource.Extensions:return this.resolveExtensionsNodeContent(h,o);case E.SyncResource.Profiles:return this.resolveProfileNodeContent(h,o);case E.SyncResource.WorkspaceState:return null}}async resolveLatestContent(s,r){const o=this.userDataProfilesService.profiles.find(h=>h.id===r);if(!o)return null;switch(s){case E.SyncResource.GlobalState:return this.resolveLatestGlobalStateContent(o);case E.SyncResource.Extensions:return this.resolveLatestExtensionsContent(o);case E.SyncResource.Profiles:return this.resolveLatestProfilesContent(o);case E.SyncResource.Settings:return null;case E.SyncResource.Keybindings:return null;case E.SyncResource.Tasks:return null;case E.SyncResource.Snippets:return null;case E.SyncResource.WorkspaceState:return null}}getSettingsAssociatedResources(s,r){const o=this.extUri.joinPath(s,"settings.json"),h=r?r.settingsResource:this.extUri.joinPath(s,i.NOT_EXISTING_RESOURCE);return[{resource:o,comparableResource:h}]}resolveSettingsNodeContent(s,r){switch(r){case"settings.json":return(0,d.parseSettingsSyncContent)(s.content).settings}return null}getKeybindingsAssociatedResources(s,r){const o=this.extUri.joinPath(s,"keybindings.json"),h=r?r.keybindingsResource:this.extUri.joinPath(s,i.NOT_EXISTING_RESOURCE);return[{resource:o,comparableResource:h}]}resolveKeybindingsNodeContent(s,r){switch(r){case"keybindings.json":return(0,l.getKeybindingsContentFromSyncContent)(s.content,!!this.configurationService.getValue(E.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM),this.logService)}return null}getTasksAssociatedResources(s,r){const o=this.extUri.joinPath(s,"tasks.json"),h=r?r.tasksResource:this.extUri.joinPath(s,i.NOT_EXISTING_RESOURCE);return[{resource:o,comparableResource:h}]}resolveTasksNodeContent(s,r){switch(r){case"tasks.json":return(0,I.getTasksContentFromSyncContent)(s.content,this.logService)}return null}async getSnippetsAssociatedResources(s,r){const o=await this.resolveContent(s);if(o){const h=this.parseSyncData(o,E.SyncResource.Snippets);if(h){const y=(0,m.parseSnippets)(h),A=[];for(const b of Object.keys(y)){const w=this.extUri.joinPath(s,b),O=r?this.extUri.joinPath(r.snippetsHome,b):this.extUri.joinPath(s,i.NOT_EXISTING_RESOURCE);A.push({resource:w,comparableResource:O})}return A}}return[]}resolveSnippetsNodeContent(s,r){return(0,m.parseSnippets)(s)[r]||null}getExtensionsAssociatedResources(s,r){const o=this.extUri.joinPath(s,"extensions.json"),h=r?this.toUri({remote:!1,syncResource:E.SyncResource.Extensions,profile:r.id,location:void 0,collection:void 0,ref:void 0,node:void 0}):this.extUri.joinPath(s,i.NOT_EXISTING_RESOURCE);return[{resource:o,comparableResource:h}]}resolveExtensionsNodeContent(s,r){switch(r){case"extensions.json":return(0,v.stringify)((0,v.parseExtensions)(s),!0)}return null}async resolveLatestExtensionsContent(s){const{localExtensions:r}=await this.instantiationService.createInstance(v.LocalExtensionsProvider).getLocalExtensions(s);return(0,v.stringify)(r,!0)}getGlobalStateAssociatedResources(s,r){const o=this.extUri.joinPath(s,"globalState.json"),h=r?this.toUri({remote:!1,syncResource:E.SyncResource.GlobalState,profile:r.id,location:void 0,collection:void 0,ref:void 0,node:void 0}):this.extUri.joinPath(s,i.NOT_EXISTING_RESOURCE);return[{resource:o,comparableResource:h}]}resolveGlobalStateNodeContent(s,r){switch(r){case"globalState.json":return(0,f.stringify)(JSON.parse(s.content),!0)}return null}async resolveLatestGlobalStateContent(s){const r=await this.instantiationService.createInstance(f.LocalGlobalStateProvider).getLocalGlobalState(s);return(0,f.stringify)(r,!0)}getProfilesAssociatedResources(s,r){const o=this.extUri.joinPath(s,"profiles.json"),h=this.toUri({remote:!1,syncResource:E.SyncResource.Profiles,profile:this.userDataProfilesService.defaultProfile.id,location:void 0,collection:void 0,ref:void 0,node:void 0});return[{resource:o,comparableResource:h}]}resolveProfileNodeContent(s,r){switch(r){case"profiles.json":return(0,c.toFormattedString)(JSON.parse(s.content),{})}return null}async resolveLatestProfilesContent(s){return(0,p.stringifyLocalProfiles)(this.userDataProfilesService.profiles.filter(r=>!r.isDefault&&!r.isTransient),!0)}toUri(s){const r=s.remote?i.REMOTE_BACKUP_AUTHORITY:i.LOCAL_BACKUP_AUTHORITY,o=[];return s.location&&(o.push(`scheme:${s.location.scheme}`),o.push(`authority:${s.location.authority}`),o.push((0,u.trim)(s.location.path,"/"))),o.push(`syncResource:${s.syncResource}`),o.push(`profile:${s.profile}`),s.collection&&o.push(`collection:${s.collection}`),s.ref&&o.push(`ref:${s.ref}`),s.node&&o.push(s.node),this.extUri.joinPath(R.URI.from({scheme:E.USER_DATA_SYNC_SCHEME,authority:r,path:"/",query:s.location?.query,fragment:s.location?.fragment}),...o)}resolveUri(s){if(s.scheme!==E.USER_DATA_SYNC_SCHEME)return;const r=[];for(;s.path!=="/";)r.unshift(this.extUri.basename(s)),s=this.extUri.dirname(s);if(r.length<2)return;const o=s.authority===i.REMOTE_BACKUP_AUTHORITY;let h,y;const A=[];let b,w,O,F,N;for(;r.length;){const M=r.shift();M.startsWith("scheme:")?h=M.substring(7):M.startsWith("authority:")?y=M.substring(10):M.startsWith("syncResource:")?b=M.substring(13):M.startsWith("profile:")?w=M.substring(8):M.startsWith("collection:")?O=M.substring(11):M.startsWith("ref:")?F=M.substring(4):b?N=M:A.push(M)}return{remote:o,syncResource:b,profile:w,collection:O,ref:F,node:N,location:h&&y!==void 0?this.extUri.joinPath(R.URI.from({scheme:h,authority:y,query:s.query,fragment:s.fragment,path:"/"}),...A):void 0}}parseSyncData(s,r){try{const o=JSON.parse(s);if((0,S.isSyncData)(o))return o}catch(o){this.logService.error(o)}throw new E.UserDataSyncError((0,a.localize)(2462,null),E.UserDataSyncErrorCode.IncompatibleRemoteContent,r)}async getUserData(s,r,o){const h=await this.userDataSyncStoreService.resolveResourceContent(s,r,o);return{ref:r,content:h}}};e.UserDataSyncResourceProviderService=n,e.UserDataSyncResourceProviderService=n=i=Ie([Y(0,E.IUserDataSyncStoreService),Y(1,E.IUserDataSyncLocalStoreService),Y(2,E.IUserDataSyncLogService),Y(3,D.IUriIdentityService),Y(4,_.IEnvironmentService),Y(5,L.IStorageService),Y(6,T.IFileService),Y(7,P.IUserDataProfilesService),Y(8,g.IConfigurationService),Y(9,C.IInstantiationService)],n)}),define(he[234],fe([0,1,17,6,25,41,3,2,20,12,32,21,27,7,4,16,18,19,121,122,123,124,125,126,127,24]),function(ce,e,R,a,_,T,k,L,D,E,P,S,m,d,l,g,I,v,f,C,p,c,u,i,n,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncService=void 0;const s="sync.lastSyncTime";let r=class extends L.Disposable{get status(){return this._status}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}constructor(b,w,O,F,N,M,V,z,J,j,te){super(),this.fileService=b,this.userDataSyncStoreService=w,this.userDataSyncStoreManagementService=O,this.instantiationService=F,this.logService=N,this.telemetryService=M,this.storageService=V,this.userDataSyncEnablementService=z,this.userDataProfilesService=J,this.userDataSyncResourceProviderService=j,this.userDataSyncLocalStoreService=te,this._status=t.SyncStatus.Uninitialized,this._onDidChangeStatus=this._register(new k.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._onDidChangeLocal=this._register(new k.Emitter),this.onDidChangeLocal=this._onDidChangeLocal.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new k.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._syncErrors=[],this._onSyncErrors=this._register(new k.Emitter),this.onSyncErrors=this._onSyncErrors.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new k.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onDidResetLocal=this._register(new k.Emitter),this.onDidResetLocal=this._onDidResetLocal.event,this._onDidResetRemote=this._register(new k.Emitter),this.onDidResetRemote=this._onDidResetRemote.event,this.activeProfileSynchronizers=new Map,this._status=O.userDataSyncStore?t.SyncStatus.Idle:t.SyncStatus.Uninitialized,this._lastSyncTime=this.storageService.getNumber(s,g.StorageScope.APPLICATION,void 0),this._register((0,L.toDisposable)(()=>this.clearActiveProfileSynchronizers())),this._register(new a.RunOnceScheduler(()=>this.cleanUpStaleStorageData(),5*1e3)).schedule()}async createSyncTask(b,w){this.checkEnablement(),this.logService.info("Sync started.");const O=new Date().getTime(),F=(0,P.generateUuid)();try{const z=(0,t.createSyncHeaders)(F);w&&(z["Cache-Control"]="no-cache"),b=await this.userDataSyncStoreService.manifest(b,z)}catch(z){const J=t.UserDataSyncError.toUserDataSyncError(z);throw y(J,F,this.userDataSyncStoreManagementService,this.telemetryService),J}const N=!1,M=this;let V;return{manifest:b,async run(){if(N)throw new Error("Can run a task only once");V=(0,a.createCancelablePromise)(z=>M.sync(b,!1,F,z)),await V.finally(()=>V=void 0),M.logService.info(`Sync done. Took ${new Date().getTime()-O}ms`),M.updateLastSyncTime()},stop(){return V?.cancel(),M.stop()}}}async createManualSyncTask(){if(this.checkEnablement(),this.userDataSyncEnablementService.isEnabled())throw new t.UserDataSyncError("Cannot start manual sync when sync is enabled",t.UserDataSyncErrorCode.LocalError);this.logService.info("Sync started.");const b=new Date().getTime(),w=(0,P.generateUuid)(),O=(0,t.createSyncHeaders)(w);let F;try{F=await this.userDataSyncStoreService.manifest(null,O)}catch(V){const z=t.UserDataSyncError.toUserDataSyncError(V);throw y(z,w,this.userDataSyncStoreManagementService,this.telemetryService),z}await this.resetLocal();const N=this,M=new _.CancellationTokenSource;return{id:w,async merge(){return N.sync(F,!0,w,M.token)},async apply(){try{try{await N.applyManualSync(F,w,M.token)}catch(V){if(t.UserDataSyncError.toUserDataSyncError(V).code===t.UserDataSyncErrorCode.MethodNotFound)N.logService.info("Client is making invalid requests. Cleaning up data..."),await N.cleanUpRemoteData(),N.logService.info("Applying manual sync again..."),await N.applyManualSync(F,w,M.token);else throw V}}catch(V){throw N.logService.error(V),V}N.logService.info(`Sync done. Took ${new Date().getTime()-b}ms`),N.updateLastSyncTime()},async stop(){M.cancel(),await N.stop(),await N.resetLocal()}}}async sync(b,w,O,F){this._syncErrors=[];try{this.status!==t.SyncStatus.HasConflicts&&this.setStatus(t.SyncStatus.Syncing);const N=this.getOrCreateActiveProfileSynchronizer(this.userDataProfilesService.defaultProfile,void 0);this._syncErrors.push(...await this.syncProfile(N,b,w,O,F));const M=N.enabled.find(V=>V.resource===t.SyncResource.Profiles);if(M){const V=await M.getLastSyncedProfiles()||[];if(F.isCancellationRequested)return;await this.syncRemoteProfiles(V,b,w,O,F)}}finally{this.status!==t.SyncStatus.HasConflicts&&this.setStatus(t.SyncStatus.Idle),this._onSyncErrors.fire(this._syncErrors)}}async syncRemoteProfiles(b,w,O,F,N){for(const M of b){if(N.isCancellationRequested)return;const V=this.userDataProfilesService.profiles.find(J=>J.id===M.id);if(!V){this.logService.error(`Profile with id:${M.id} and name: ${M.name} does not exist locally to sync.`);continue}this.logService.info("Syncing profile.",M.name);const z=this.getOrCreateActiveProfileSynchronizer(V,M);this._syncErrors.push(...await this.syncProfile(z,w,O,F,N))}for(const[M,V]of this.activeProfileSynchronizers.entries())this.userDataProfilesService.profiles.some(z=>z.id===V[0].profile.id)||(await V[0].resetLocal(),V[1].dispose(),this.activeProfileSynchronizers.delete(M))}async applyManualSync(b,w,O){const F=this.getActiveProfileSynchronizers();for(const J of F){if(O.isCancellationRequested)return;await J.apply(w,O)}const N=F.find(J=>J.profile.isDefault);if(!N)return;const M=N.enabled.find(J=>J.resource===t.SyncResource.Profiles);if(!M)return;const z=(await M.getRemoteSyncedProfiles(b?.latest??null)||[]).filter(J=>F.every(j=>j.profile.id!==J.id));z.length&&await this.syncRemoteProfiles(z,b,!1,w,O)}async syncProfile(b,w,O,F,N){return(await b.sync(w,O,F,N)).map(([V,z])=>({profile:b.profile,syncResource:V,error:z}))}async stop(){this.status!==t.SyncStatus.Idle&&await Promise.allSettled(this.getActiveProfileSynchronizers().map(b=>b.stop()))}async resolveContent(b){const w=await this.userDataSyncResourceProviderService.resolveContent(b);if(w)return w;for(const O of this.getActiveProfileSynchronizers())for(const F of O.enabled){const N=await F.resolveContent(b);if(N)return N}return null}async replace(b){this.checkEnablement();const w=this.userDataSyncResourceProviderService.resolveUserDataSyncResource(b);if(!w)return;const O=await this.resolveContent(b.uri);O&&await this.performAction(w.profile,async F=>{if(w.syncResource===F.resource)return await F.replace(O),!0})}async accept(b,w,O,F){this.checkEnablement(),await this.performAction(b.profile,async N=>{if(b.syncResource===N.resource)return await N.accept(w,O),F&&await N.apply((0,E.isBoolean)(F)?!1:F.force,(0,t.createSyncHeaders)((0,P.generateUuid)())),!0})}async hasLocalData(){return!!await this.performAction(this.userDataProfilesService.defaultProfile,async w=>{if(w.resource!==t.SyncResource.GlobalState&&await w.hasLocalData())return!0})}async hasPreviouslySynced(){return!!await this.performAction(this.userDataProfilesService.defaultProfile,async w=>{if(await w.hasPreviouslySynced())return!0})}async reset(){this.checkEnablement(),await this.resetRemote(),await this.resetLocal()}async resetRemote(){this.checkEnablement();try{await this.userDataSyncStoreService.clear(),this.logService.info("Cleared data on server")}catch(b){this.logService.error(b)}this._onDidResetRemote.fire()}async resetLocal(){this.checkEnablement(),this._lastSyncTime=void 0,this.storageService.remove(s,g.StorageScope.APPLICATION);for(const[b]of this.activeProfileSynchronizers.values())try{await b.resetLocal()}catch(w){this.logService.error(w)}this.clearActiveProfileSynchronizers(),this._onDidResetLocal.fire(),this.logService.info("Did reset the local sync state.")}async cleanUpStaleStorageData(){const b=this.storageService.keys(g.StorageScope.APPLICATION,g.StorageTarget.MACHINE),w=[];for(const F of b){if(!F.endsWith(".lastSyncUserData"))continue;const N=F.split(".");N.length===3&&w.push([F,N[0]])}if(!w.length)return;const O=new L.DisposableStore;try{let F=this.activeProfileSynchronizers.get(this.userDataProfilesService.defaultProfile.id)?.[0];F||(F=O.add(this.instantiationService.createInstance(o,this.userDataProfilesService.defaultProfile,void 0)));const N=F.enabled.find(z=>z.resource===t.SyncResource.Profiles);if(!N)return;const V=(await N.getLastSyncedProfiles())?.map(z=>z.collection)??[];for(const[z,J]of w)V.includes(J)||(this.logService.info(`Removing last sync state for stale profile: ${J}`),this.storageService.remove(z,g.StorageScope.APPLICATION))}finally{O.dispose()}}async cleanUpRemoteData(){const b=await this.userDataSyncResourceProviderService.getRemoteSyncedProfiles(),w=b.map(M=>M.collection),O=await this.userDataSyncStoreService.getAllCollections(),F=O.filter(M=>!w.includes(M));F.length&&(this.logService.info(`Deleting ${F.length} redundant collections on server`),await Promise.allSettled(F.map(M=>this.userDataSyncStoreService.deleteCollection(M))),this.logService.info("Deleted redundant collections on server"));const N=b.filter(M=>O.includes(M.collection));if(N.length!==b.length){const M=this.instantiationService.createInstance(n.UserDataProfilesManifestSynchroniser,this.userDataProfilesService.defaultProfile,void 0);try{this.logService.info("Resetting the last synced state of profiles"),await M.resetLocal(),this.logService.info("Did reset the last synced state of profiles"),this.logService.info("Updating remote profiles with invalid collections on server"),await M.updateRemoteProfiles(N,null),this.logService.info("Updated remote profiles on server")}finally{M.dispose()}}}async saveRemoteActivityData(b){this.checkEnablement();const w=await this.userDataSyncStoreService.getActivityData();await this.fileService.writeFile(b,w)}async extractActivityData(b,w){const O=(await this.fileService.readFile(b)).value.toString(),F=JSON.parse(O);if(F.resources)for(const N in F.resources)for(const M of F.resources[N])await this.userDataSyncLocalStoreService.writeResource(N,M.content,new Date(M.created*1e3),void 0,w);if(F.collections)for(const N in F.collections)for(const M in F.collections[N].resources)for(const V of F.collections[N].resources?.[M]??[])await this.userDataSyncLocalStoreService.writeResource(M,V.content,new Date(V.created*1e3),N,w)}async performAction(b,w){const O=new L.DisposableStore;try{const F=this.activeProfileSynchronizers.get(b.id);if(F){const J=await this.performActionWithProfileSynchronizer(F[0],w,O);return(0,E.isUndefined)(J)?null:J}if(b.isDefault){const J=O.add(this.instantiationService.createInstance(o,b,void 0)),j=await this.performActionWithProfileSynchronizer(J,w,O);return(0,E.isUndefined)(j)?null:j}if(this.userDataProfilesService.isEnabled())return null;const N=O.add(this.instantiationService.createInstance(n.UserDataProfilesManifestSynchroniser,b,void 0)),M=await this.userDataSyncStoreService.manifest(null),z=(await N.getRemoteSyncedProfiles(M?.latest??null)||[]).find(J=>J.id===b.id);if(z){const J=O.add(this.instantiationService.createInstance(o,b,z.collection)),j=await this.performActionWithProfileSynchronizer(J,w,O);return(0,E.isUndefined)(j)?null:j}return null}finally{O.dispose()}}async performActionWithProfileSynchronizer(b,w,O){const F=[...b.enabled,...b.disabled.reduce((N,M)=>(M!==t.SyncResource.WorkspaceState&&N.push(O.add(b.createSynchronizer(M))),N),[])];for(const N of F){const M=await w(N);if(!(0,E.isUndefined)(M))return M}}setStatus(b){const w=this._status;this._status!==b&&(this._status=b,this._onDidChangeStatus.fire(b),w===t.SyncStatus.HasConflicts&&this.updateLastSyncTime())}updateConflicts(){const b=this.getActiveProfileSynchronizers().map(w=>w.conflicts).flat();(0,R.equals)(this._conflicts,b,(w,O)=>w.profile.id===O.profile.id&&w.syncResource===O.syncResource&&(0,R.equals)(w.conflicts,O.conflicts,(F,N)=>(0,D.isEqual)(F.previewResource,N.previewResource)))||(this._conflicts=b,this._onDidChangeConflicts.fire(b))}updateLastSyncTime(){this.status===t.SyncStatus.Idle&&(this._lastSyncTime=new Date().getTime(),this.storageService.store(s,this._lastSyncTime,g.StorageScope.APPLICATION,g.StorageTarget.MACHINE),this._onDidChangeLastSyncTime.fire(this._lastSyncTime))}getOrCreateActiveProfileSynchronizer(b,w){let O=this.activeProfileSynchronizers.get(b.id);if(O&&O[0].collection!==w?.collection&&(this.logService.error("Profile synchronizer collection does not match with the remote sync profile collection"),O[1].dispose(),O=void 0,this.activeProfileSynchronizers.delete(b.id)),!O){const F=new L.DisposableStore,N=F.add(this.instantiationService.createInstance(o,b,w?.collection));F.add(N.onDidChangeStatus(M=>this.setStatus(M))),F.add(N.onDidChangeConflicts(M=>this.updateConflicts())),F.add(N.onDidChangeLocal(M=>this._onDidChangeLocal.fire(M))),this.activeProfileSynchronizers.set(b.id,O=[N,F])}return O[0]}getActiveProfileSynchronizers(){const b=[];for(const[w]of this.activeProfileSynchronizers.values())b.push(w);return b}clearActiveProfileSynchronizers(){this.activeProfileSynchronizers.forEach(([,b])=>b.dispose()),this.activeProfileSynchronizers.clear()}checkEnablement(){if(!this.userDataSyncStoreManagementService.userDataSyncStore)throw new Error("Not enabled")}};e.UserDataSyncService=r,e.UserDataSyncService=r=Ie([Y(0,d.IFileService),Y(1,t.IUserDataSyncStoreService),Y(2,t.IUserDataSyncStoreManagementService),Y(3,l.IInstantiationService),Y(4,t.IUserDataSyncLogService),Y(5,I.ITelemetryService),Y(6,g.IStorageService),Y(7,t.IUserDataSyncEnablementService),Y(8,v.IUserDataProfilesService),Y(9,t.IUserDataSyncResourceProviderService),Y(10,t.IUserDataSyncLocalStoreService)],r);let o=class extends L.Disposable{get enabled(){return this._enabled.sort((b,w)=>b[1]-w[1]).map(([b])=>b)}get disabled(){return t.ALL_SYNC_RESOURCES.filter(b=>!this.userDataSyncEnablementService.isResourceEnabled(b))}get status(){return this._status}get conflicts(){return this._conflicts}constructor(b,w,O,F,N,M,V,z,J,j){super(),this.profile=b,this.collection=w,this.userDataSyncEnablementService=O,this.instantiationService=F,this.extensionGalleryService=N,this.userDataSyncStoreManagementService=M,this.telemetryService=V,this.logService=z,this.userDataProfilesService=J,this.configurationService=j,this._enabled=[],this._status=t.SyncStatus.Idle,this._onDidChangeStatus=this._register(new k.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._onDidChangeLocal=this._register(new k.Emitter),this.onDidChangeLocal=this._onDidChangeLocal.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new k.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._register(O.onDidChangeResourceEnablement(([te,q])=>this.onDidChangeResourceEnablement(te,q))),this._register((0,L.toDisposable)(()=>this._enabled.splice(0,this._enabled.length).forEach(([,,te])=>te.dispose())));for(const te of t.ALL_SYNC_RESOURCES)O.isResourceEnabled(te)&&this.registerSynchronizer(te)}onDidChangeResourceEnablement(b,w){w?this.registerSynchronizer(b):this.deRegisterSynchronizer(b)}registerSynchronizer(b){if(this._enabled.some(([N])=>N.resource===b))return;if(b===t.SyncResource.Extensions&&!this.extensionGalleryService.isEnabled()){this.logService.info("Skipping extensions sync because gallery is not configured");return}if(b===t.SyncResource.Profiles&&(!this.profile.isDefault||!this.userDataProfilesService.isEnabled())||b===t.SyncResource.WorkspaceState)return;if(b!==t.SyncResource.Profiles&&this.profile.useDefaultFlags?.[b]){this.logService.debug(`Skipping syncing ${b} in ${this.profile.name} because it is already synced by default profile`);return}const w=new L.DisposableStore,O=w.add(this.createSynchronizer(b));w.add(O.onDidChangeStatus(()=>this.updateStatus())),w.add(O.onDidChangeConflicts(()=>this.updateConflicts())),w.add(O.onDidChangeLocal(()=>this._onDidChangeLocal.fire(b)));const F=this.getOrder(b);this._enabled.push([O,F,w])}deRegisterSynchronizer(b){const w=this._enabled.findIndex(([O])=>O.resource===b);if(w!==-1){const[[O,,F]]=this._enabled.splice(w,1);F.dispose(),this.updateStatus(),O.stop().then(null,N=>this.logService.error(N))}}createSynchronizer(b){switch(b){case t.SyncResource.Settings:return this.instantiationService.createInstance(c.SettingsSynchroniser,this.profile,this.collection);case t.SyncResource.Keybindings:return this.instantiationService.createInstance(p.KeybindingsSynchroniser,this.profile,this.collection);case t.SyncResource.Snippets:return this.instantiationService.createInstance(u.SnippetsSynchroniser,this.profile,this.collection);case t.SyncResource.Tasks:return this.instantiationService.createInstance(i.TasksSynchroniser,this.profile,this.collection);case t.SyncResource.GlobalState:return this.instantiationService.createInstance(C.GlobalStateSynchroniser,this.profile,this.collection);case t.SyncResource.Extensions:return this.instantiationService.createInstance(f.ExtensionsSynchroniser,this.profile,this.collection);case t.SyncResource.Profiles:return this.instantiationService.createInstance(n.UserDataProfilesManifestSynchroniser,this.profile,this.collection)}}async sync(b,w,O,F){if(F.isCancellationRequested)return[];const N=this.enabled;if(!N.length)return[];try{const M=[],V=(0,t.createSyncHeaders)(O),z=(this.collection?b?.collections?.[this.collection]?.latest:b?.latest)??null,J=w?await this.getUserDataSyncConfiguration(z):{};for(const j of N){if(F.isCancellationRequested)return[];if(!this.userDataSyncEnablementService.isResourceEnabled(j.resource))return[];try{if(w){const te=await j.preview(z,J,V);if(te)for(const q of te.resourcePreviews)(q.localChange!==t.Change.None||q.remoteChange!==t.Change.None)&&q.mergeState===t.MergeState.Preview&&await j.merge(q.previewResource)}else await j.sync(z,V)}catch(te){const q=t.UserDataSyncError.toUserDataSyncError(te);if(y(q,O,this.userDataSyncStoreManagementService,this.telemetryService),h(te))throw q;this.logService.error(te),this.logService.error(`${j.resource}: ${(0,T.toErrorMessage)(te)}`),M.push([j.resource,q])}}return M}finally{this.updateStatus()}}async apply(b,w){const O=(0,t.createSyncHeaders)(b);for(const F of this.enabled){if(w.isCancellationRequested)return;try{await F.apply(!1,O)}catch(N){const M=t.UserDataSyncError.toUserDataSyncError(N);if(y(M,b,this.userDataSyncStoreManagementService,this.telemetryService),h(N))throw M;this.logService.error(N),this.logService.error(`${F.resource}: ${(0,T.toErrorMessage)(N)}`)}}}async stop(){for(const b of this.enabled)try{b.status!==t.SyncStatus.Idle&&await b.stop()}catch(w){this.logService.error(w)}}async resetLocal(){for(const b of this.enabled)try{await b.resetLocal()}catch(w){this.logService.error(`${b.resource}: ${(0,T.toErrorMessage)(w)}`),this.logService.error(w)}}async getUserDataSyncConfiguration(b){if(!this.profile.isDefault)return{};const w=this.configurationService.getValue(t.USER_DATA_SYNC_CONFIGURATION_SCOPE),O=this.enabled.find(F=>F instanceof c.SettingsSynchroniser);if(O){const F=await O.getRemoteUserDataSyncConfiguration(b);return{...w,...F}}return w}setStatus(b){this._status!==b&&(this._status=b,this._onDidChangeStatus.fire(b))}updateStatus(){return this.updateConflicts(),this.enabled.some(b=>b.status===t.SyncStatus.HasConflicts)?this.setStatus(t.SyncStatus.HasConflicts):this.enabled.some(b=>b.status===t.SyncStatus.Syncing)?this.setStatus(t.SyncStatus.Syncing):this.setStatus(t.SyncStatus.Idle)}updateConflicts(){const b=this.enabled.filter(w=>w.status===t.SyncStatus.HasConflicts).filter(w=>w.conflicts.conflicts.length>0).map(w=>w.conflicts);(0,R.equals)(this._conflicts,b,(w,O)=>w.syncResource===O.syncResource&&(0,R.equals)(w.conflicts,O.conflicts,(F,N)=>(0,D.isEqual)(F.previewResource,N.previewResource)))||(this._conflicts=b,this._onDidChangeConflicts.fire(b))}getOrder(b){switch(b){case t.SyncResource.Settings:return 0;case t.SyncResource.Keybindings:return 1;case t.SyncResource.Snippets:return 2;case t.SyncResource.Tasks:return 3;case t.SyncResource.GlobalState:return 4;case t.SyncResource.Extensions:return 5;case t.SyncResource.Profiles:return 6;case t.SyncResource.WorkspaceState:return 7}}};o=Ie([Y(2,t.IUserDataSyncEnablementService),Y(3,l.IInstantiationService),Y(4,m.IExtensionGalleryService),Y(5,t.IUserDataSyncStoreManagementService),Y(6,I.ITelemetryService),Y(7,t.IUserDataSyncLogService),Y(8,v.IUserDataProfilesService),Y(9,S.IConfigurationService)],o);function h(A){if(A instanceof t.UserDataSyncError)switch(A.code){case t.UserDataSyncErrorCode.MethodNotFound:case t.UserDataSyncErrorCode.TooLarge:case t.UserDataSyncErrorCode.TooManyRequests:case t.UserDataSyncErrorCode.TooManyRequestsAndRetryAfter:case t.UserDataSyncErrorCode.LocalTooManyRequests:case t.UserDataSyncErrorCode.LocalTooManyProfiles:case t.UserDataSyncErrorCode.Gone:case t.UserDataSyncErrorCode.UpgradeRequired:case t.UserDataSyncErrorCode.IncompatibleRemoteContent:case t.UserDataSyncErrorCode.IncompatibleLocalContent:return!0}return!1}function y(A,b,w,O){O.publicLog2("sync/error",{code:A.code,serverCode:A instanceof t.UserDataSyncStoreError?String(A.serverCode):void 0,url:A instanceof t.UserDataSyncStoreError?A.url:void 0,resource:A.resource,executionId:b,service:w.userDataSyncStore.url.toString()})}}),define(he[235],fe([0,1,3,2,10,19,24]),function(ce,e,R,a,_,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncServiceChannelClient=e.UserDataSyncServiceChannel=void 0;function L(m,d){return{...m,profile:(0,T.reviveProfile)(m.profile,d.profilesHome.scheme)}}function D(m){return{created:m.created,uri:_.URI.revive(m.uri)}}class E{constructor(d,l,g){this.service=d,this.userDataProfilesService=l,this.logService=g,this.manualSyncTasks=new Map,this.onManualSynchronizeResources=new R.Emitter}listen(d,l){switch(l){case"onDidChangeStatus":return this.service.onDidChangeStatus;case"onDidChangeConflicts":return this.service.onDidChangeConflicts;case"onDidChangeLocal":return this.service.onDidChangeLocal;case"onDidChangeLastSyncTime":return this.service.onDidChangeLastSyncTime;case"onSyncErrors":return this.service.onSyncErrors;case"onDidResetLocal":return this.service.onDidResetLocal;case"onDidResetRemote":return this.service.onDidResetRemote;case"manualSync/onSynchronizeResources":return this.onManualSynchronizeResources.event}throw new Error(`[UserDataSyncServiceChannel] Event not found: ${l}`)}async call(d,l,g){try{return await this._call(d,l,g)}catch(I){throw this.logService.error(I),I}}async _call(d,l,g){switch(l){case"_getInitialData":return Promise.resolve([this.service.status,this.service.conflicts,this.service.lastSyncTime]);case"reset":return this.service.reset();case"resetRemote":return this.service.resetRemote();case"resetLocal":return this.service.resetLocal();case"hasPreviouslySynced":return this.service.hasPreviouslySynced();case"hasLocalData":return this.service.hasLocalData();case"resolveContent":return this.service.resolveContent(_.URI.revive(g[0]));case"accept":return this.service.accept(L(g[0],this.userDataProfilesService),_.URI.revive(g[1]),g[2],g[3]);case"replace":return this.service.replace(D(g[0]));case"cleanUpRemoteData":return this.service.cleanUpRemoteData();case"getRemoteActivityData":return this.service.saveRemoteActivityData(_.URI.revive(g[0]));case"extractActivityData":return this.service.extractActivityData(_.URI.revive(g[0]),_.URI.revive(g[1]));case"createManualSyncTask":return this.createManualSyncTask()}if(l.startsWith("manualSync/")){const I=l.substring(11),v=g[0],f=this.getManualSyncTask(v);switch(g=g.slice(1),I){case"merge":return f.merge();case"apply":return f.apply().then(()=>this.manualSyncTasks.delete(this.createKey(f.id)));case"stop":return f.stop().finally(()=>this.manualSyncTasks.delete(this.createKey(f.id)))}}throw new Error("Invalid call")}getManualSyncTask(d){const l=this.manualSyncTasks.get(this.createKey(d));if(!l)throw new Error(`Manual sync taks not found: ${d}`);return l}async createManualSyncTask(){const d=await this.service.createManualSyncTask();return this.manualSyncTasks.set(this.createKey(d.id),d),d.id}createKey(d){return`manualSyncTask-${d}`}}e.UserDataSyncServiceChannel=E;let P=class extends a.Disposable{get status(){return this._status}get onDidChangeLocal(){return this.channel.listen("onDidChangeLocal")}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}get onDidResetLocal(){return this.channel.listen("onDidResetLocal")}get onDidResetRemote(){return this.channel.listen("onDidResetRemote")}constructor(d,l){super(),this.userDataProfilesService=l,this._status=k.SyncStatus.Uninitialized,this._onDidChangeStatus=this._register(new R.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new R.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new R.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onSyncErrors=this._register(new R.Emitter),this.onSyncErrors=this._onSyncErrors.event,this.channel={call(g,I,v){return d.call(g,I,v).then(null,f=>{throw k.UserDataSyncError.toUserDataSyncError(f)})},listen(g,I){return d.listen(g,I)}},this.channel.call("_getInitialData").then(([g,I,v])=>{this.updateStatus(g),this.updateConflicts(I),v&&this.updateLastSyncTime(v),this._register(this.channel.listen("onDidChangeStatus")(f=>this.updateStatus(f))),this._register(this.channel.listen("onDidChangeLastSyncTime")(f=>this.updateLastSyncTime(f)))}),this._register(this.channel.listen("onDidChangeConflicts")(g=>this.updateConflicts(g))),this._register(this.channel.listen("onSyncErrors")(g=>this._onSyncErrors.fire(g.map(I=>({...I,error:k.UserDataSyncError.toUserDataSyncError(I.error)})))))}createSyncTask(){throw new Error("not supported")}async createManualSyncTask(){const d=await this.channel.call("createManualSyncTask"),l=this;return new S(d,{async call(I,v,f){return l.channel.call(`manualSync/${I}`,[d,...Array.isArray(v)?v:[v]],f)},listen(){throw new Error("not supported")}})}reset(){return this.channel.call("reset")}resetRemote(){return this.channel.call("resetRemote")}resetLocal(){return this.channel.call("resetLocal")}hasPreviouslySynced(){return this.channel.call("hasPreviouslySynced")}hasLocalData(){return this.channel.call("hasLocalData")}accept(d,l,g,I){return this.channel.call("accept",[d,l,g,I])}resolveContent(d){return this.channel.call("resolveContent",[d])}cleanUpRemoteData(){return this.channel.call("cleanUpRemoteData")}replace(d){return this.channel.call("replace",[d])}saveRemoteActivityData(d){return this.channel.call("getRemoteActivityData",[d])}extractActivityData(d,l){return this.channel.call("extractActivityData",[d,l])}async updateStatus(d){this._status=d,this._onDidChangeStatus.fire(d)}async updateConflicts(d){this._conflicts=d.map(l=>({syncResource:l.syncResource,profile:(0,T.reviveProfile)(l.profile,this.userDataProfilesService.profilesHome.scheme),conflicts:l.conflicts.map(g=>({...g,baseResource:_.URI.revive(g.baseResource),localResource:_.URI.revive(g.localResource),remoteResource:_.URI.revive(g.remoteResource),previewResource:_.URI.revive(g.previewResource)}))})),this._onDidChangeConflicts.fire(this._conflicts)}updateLastSyncTime(d){this._lastSyncTime!==d&&(this._lastSyncTime=d,this._onDidChangeLastSyncTime.fire(d))}};e.UserDataSyncServiceChannelClient=P,e.UserDataSyncServiceChannelClient=P=Ie([Y(1,T.IUserDataProfilesService)],P);class S extends a.Disposable{constructor(d,l){super(),this.id=d,this.channel=l}async merge(){return this.channel.call("merge")}async apply(){return this.channel.call("apply")}stop(){return this.channel.call("stop")}dispose(){this.channel.call("dispose"),super.dispose()}}}),define(he[128],fe([0,1,6,25,8,3,2,146,5,20,12,10,32,21,15,7,23,61,49,16,24]),function(ce,e,R,a,_,T,k,L,D,E,P,S,m,d,l,g,I,v,f,C,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestsSession=e.UserDataSyncStoreService=e.UserDataSyncStoreClient=e.UserDataSyncStoreManagementService=e.AbstractUserDataSyncStoreManagementService=void 0;const c="configurationSync.store",u="sync.previous.store",i="sync.donot-make-requests-until",n="sync.user-session-id",t="sync.machine-session-id",s=100,r=1e3*60*5;let o=class extends k.Disposable{get userDataSyncStore(){return this._userDataSyncStore}get userDataSyncStoreType(){return this.storageService.get(p.SYNC_SERVICE_URL_TYPE,C.StorageScope.APPLICATION)}set userDataSyncStoreType(O){this.storageService.store(p.SYNC_SERVICE_URL_TYPE,O,C.StorageScope.APPLICATION,D.isWeb?C.StorageTarget.USER:C.StorageTarget.MACHINE)}constructor(O,F,N){super(),this.productService=O,this.configurationService=F,this.storageService=N,this._onDidChangeUserDataSyncStore=this._register(new T.Emitter),this.onDidChangeUserDataSyncStore=this._onDidChangeUserDataSyncStore.event,this.updateUserDataSyncStore();const M=this._register(new k.DisposableStore);this._register(T.Event.filter(N.onDidChangeValue(C.StorageScope.APPLICATION,p.SYNC_SERVICE_URL_TYPE,M),()=>this.userDataSyncStoreType!==this.userDataSyncStore?.type,M)(()=>this.updateUserDataSyncStore()))}updateUserDataSyncStore(){this._userDataSyncStore=this.toUserDataSyncStore(this.productService[c]),this._onDidChangeUserDataSyncStore.fire()}toUserDataSyncStore(O){if(O&&(O=D.isWeb&&O.web?{...O,...O.web}:O,(0,P.isString)(O.url)&&(0,P.isObject)(O.authenticationProviders)&&Object.keys(O.authenticationProviders).every(F=>Array.isArray(O.authenticationProviders[F].scopes)))){const F=O,N=!!F.canSwitch,M=F.url===F.insidersUrl?"insiders":"stable",V=(N?this.userDataSyncStoreType:void 0)||M,z=V==="insiders"?F.insidersUrl:V==="stable"?F.stableUrl:F.url;return{url:S.URI.parse(z),type:V,defaultType:M,defaultUrl:S.URI.parse(F.url),stableUrl:S.URI.parse(F.stableUrl),insidersUrl:S.URI.parse(F.insidersUrl),canSwitch:N,authenticationProviders:Object.keys(F.authenticationProviders).reduce((J,j)=>(J.push({id:j,scopes:F.authenticationProviders[j].scopes}),J),[])}}}};e.AbstractUserDataSyncStoreManagementService=o,e.AbstractUserDataSyncStoreManagementService=o=Ie([Y(0,I.IProductService),Y(1,d.IConfigurationService),Y(2,C.IStorageService)],o);let h=class extends o{constructor(O,F,N){super(O,F,N);const M=this.storageService.get(u,C.StorageScope.APPLICATION);M&&(this.previousConfigurationSyncStore=JSON.parse(M));const V=this.productService[c];V?this.storageService.store(u,JSON.stringify(V),C.StorageScope.APPLICATION,C.StorageTarget.MACHINE):this.storageService.remove(u,C.StorageScope.APPLICATION)}async switch(O){O!==this.userDataSyncStoreType&&(this.userDataSyncStoreType=O,this.updateUserDataSyncStore())}async getPreviousUserDataSyncStore(){return this.toUserDataSyncStore(this.previousConfigurationSyncStore)}};e.UserDataSyncStoreManagementService=h,e.UserDataSyncStoreManagementService=h=Ie([Y(0,I.IProductService),Y(1,d.IConfigurationService),Y(2,C.IStorageService)],h);let y=class extends k.Disposable{get donotMakeRequestsUntil(){return this._donotMakeRequestsUntil}constructor(O,F,N,M,V,z,J){super(),this.requestService=N,this.logService=M,this.storageService=J,this._onTokenFailed=this._register(new T.Emitter),this.onTokenFailed=this._onTokenFailed.event,this._onTokenSucceed=this._register(new T.Emitter),this.onTokenSucceed=this._onTokenSucceed.event,this._donotMakeRequestsUntil=void 0,this._onDidChangeDonotMakeRequestsUntil=this._register(new T.Emitter),this.onDidChangeDonotMakeRequestsUntil=this._onDidChangeDonotMakeRequestsUntil.event,this.resetDonotMakeRequestsUntilPromise=void 0,this.updateUserDataSyncStoreUrl(O),this.commonHeadersPromise=(0,f.getServiceMachineId)(V,z,J).then(j=>{const te={"X-Client-Name":`${F.applicationName}${D.isWeb?"-web":""}`,"X-Client-Version":F.version};return F.commit&&(te["X-Client-Commit"]=F.commit),te}),this.session=new b(s,r,this.requestService,this.logService),this.initDonotMakeRequestsUntil(),this._register((0,k.toDisposable)(()=>{this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0)}))}setAuthToken(O,F){this.authToken={token:O,type:F}}updateUserDataSyncStoreUrl(O){this.userDataSyncStoreUrl=O?(0,E.joinPath)(O,"v1"):void 0}initDonotMakeRequestsUntil(){const O=this.storageService.getNumber(i,C.StorageScope.APPLICATION);O&&Date.now()<O&&this.setDonotMakeRequestsUntil(new Date(O))}setDonotMakeRequestsUntil(O){this._donotMakeRequestsUntil?.getTime()!==O?.getTime()&&(this._donotMakeRequestsUntil=O,this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0),this._donotMakeRequestsUntil?(this.storageService.store(i,this._donotMakeRequestsUntil.getTime(),C.StorageScope.APPLICATION,C.StorageTarget.MACHINE),this.resetDonotMakeRequestsUntilPromise=(0,R.createCancelablePromise)(F=>(0,R.timeout)(this._donotMakeRequestsUntil.getTime()-Date.now(),F).then(()=>this.setDonotMakeRequestsUntil(void 0))),this.resetDonotMakeRequestsUntilPromise.then(null,F=>null)):this.storageService.remove(i,C.StorageScope.APPLICATION),this._onDidChangeDonotMakeRequestsUntil.fire())}async getAllCollections(O={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const F=(0,E.joinPath)(this.userDataSyncStoreUrl,"collection").toString();O={...O},O["Content-Type"]="application/json";const N=await this.request(F,{type:"GET",headers:O},[],a.CancellationToken.None);return(await(0,v.asJson)(N))?.map(({id:M})=>M)||[]}async createCollection(O={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const F=(0,E.joinPath)(this.userDataSyncStoreUrl,"collection").toString();O={...O},O["Content-Type"]=L.Mimes.text;const N=await this.request(F,{type:"POST",headers:O},[],a.CancellationToken.None),M=await(0,v.asTextOrError)(N);if(!M)throw new p.UserDataSyncStoreError("Server did not return the collection id",F,p.UserDataSyncErrorCode.NoCollection,N.res.statusCode,N.res.headers[p.HEADER_OPERATION_ID]);return M}async deleteCollection(O,F={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const N=O?(0,E.joinPath)(this.userDataSyncStoreUrl,"collection",O).toString():(0,E.joinPath)(this.userDataSyncStoreUrl,"collection").toString();F={...F},await this.request(N,{type:"DELETE",headers:F},[],a.CancellationToken.None)}async getAllResourceRefs(O,F){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const N=this.getResourceUrl(this.userDataSyncStoreUrl,F,O),M={},V=await this.request(N.toString(),{type:"GET",headers:M},[],a.CancellationToken.None);return(await(0,v.asJson)(V)||[]).map(({url:J,created:j})=>({ref:(0,E.relativePath)(N,N.with({path:J})),created:j*1e3}))}async resolveResourceContent(O,F,N,M={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const V=(0,E.joinPath)(this.getResourceUrl(this.userDataSyncStoreUrl,N,O),F).toString();M={...M},M["Cache-Control"]="no-cache";const z=await this.request(V,{type:"GET",headers:M},[],a.CancellationToken.None);return await(0,v.asTextOrError)(z)}async deleteResource(O,F,N){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const M=F!==null?(0,E.joinPath)(this.getResourceUrl(this.userDataSyncStoreUrl,N,O),F).toString():this.getResourceUrl(this.userDataSyncStoreUrl,N,O).toString(),V={};await this.request(M,{type:"DELETE",headers:V},[],a.CancellationToken.None)}async deleteResources(){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const O=(0,E.joinPath)(this.userDataSyncStoreUrl,"resource").toString(),F={"Content-Type":L.Mimes.text};await this.request(O,{type:"DELETE",headers:F},[],a.CancellationToken.None)}async readResource(O,F,N,M={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const V=(0,E.joinPath)(this.getResourceUrl(this.userDataSyncStoreUrl,N,O),"latest").toString();M={...M},M["Cache-Control"]="no-cache",F&&(M["If-None-Match"]=F.ref);const z=await this.request(V,{type:"GET",headers:M},[304],a.CancellationToken.None);let J=null;if(z.res.statusCode===304&&(J=F),J===null){const j=z.res.headers.etag;if(!j)throw new p.UserDataSyncStoreError("Server did not return the ref",V,p.UserDataSyncErrorCode.NoRef,z.res.statusCode,z.res.headers[p.HEADER_OPERATION_ID]);const te=await(0,v.asTextOrError)(z);if(!te&&z.res.statusCode===304)throw new p.UserDataSyncStoreError("Empty response",V,p.UserDataSyncErrorCode.EmptyResponse,z.res.statusCode,z.res.headers[p.HEADER_OPERATION_ID]);J={ref:j,content:te}}return J}async writeResource(O,F,N,M,V={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const z=this.getResourceUrl(this.userDataSyncStoreUrl,M,O).toString();V={...V},V["Content-Type"]=L.Mimes.text,N&&(V["If-Match"]=N);const J=await this.request(z,{type:"POST",data:F,headers:V},[],a.CancellationToken.None),j=J.res.headers.etag;if(!j)throw new p.UserDataSyncStoreError("Server did not return the ref",z,p.UserDataSyncErrorCode.NoRef,J.res.statusCode,J.res.headers[p.HEADER_OPERATION_ID]);return j}async manifest(O,F={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const N=(0,E.joinPath)(this.userDataSyncStoreUrl,"manifest").toString();F={...F},F["Content-Type"]="application/json",O&&(F["If-None-Match"]=O.ref);const M=await this.request(N,{type:"GET",headers:F},[304],a.CancellationToken.None);let V=null;if(M.res.statusCode===304&&(V=O),!V){const J=M.res.headers.etag;if(!J)throw new p.UserDataSyncStoreError("Server did not return the ref",N,p.UserDataSyncErrorCode.NoRef,M.res.statusCode,M.res.headers[p.HEADER_OPERATION_ID]);const j=await(0,v.asTextOrError)(M);if(!j&&M.res.statusCode===304)throw new p.UserDataSyncStoreError("Empty response",N,p.UserDataSyncErrorCode.EmptyResponse,M.res.statusCode,M.res.headers[p.HEADER_OPERATION_ID]);j&&(V={...JSON.parse(j),ref:J})}const z=this.storageService.get(n,C.StorageScope.APPLICATION);return z&&V&&z!==V.session&&this.clearSession(),V===null&&z&&this.clearSession(),V&&this.storageService.store(n,V.session,C.StorageScope.APPLICATION,C.StorageTarget.MACHINE),V}async clear(){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");await this.deleteCollection(),await this.deleteResources(),this.clearSession()}async getActivityData(){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const O=(0,E.joinPath)(this.userDataSyncStoreUrl,"download").toString(),F={},N=await this.request(O,{type:"GET",headers:F},[],a.CancellationToken.None);if(!(0,v.isSuccess)(N))throw new p.UserDataSyncStoreError("Server returned "+N.res.statusCode,O,p.UserDataSyncErrorCode.EmptyResponse,N.res.statusCode,N.res.headers[p.HEADER_OPERATION_ID]);if((0,v.hasNoContent)(N))throw new p.UserDataSyncStoreError("Empty response",O,p.UserDataSyncErrorCode.EmptyResponse,N.res.statusCode,N.res.headers[p.HEADER_OPERATION_ID]);return N.stream}getResourceUrl(O,F,N){return F?(0,E.joinPath)(O,"collection",F,"resource",N):(0,E.joinPath)(O,"resource",N)}clearSession(){this.storageService.remove(n,C.StorageScope.APPLICATION),this.storageService.remove(t,C.StorageScope.APPLICATION)}async request(O,F,N,M){if(!this.authToken)throw new p.UserDataSyncStoreError("No Auth Token Available",O,p.UserDataSyncErrorCode.Unauthorized,void 0,void 0);if(this._donotMakeRequestsUntil&&Date.now()<this._donotMakeRequestsUntil.getTime())throw new p.UserDataSyncStoreError(`${F.type} request '${O}' failed because of too many requests (429).`,O,p.UserDataSyncErrorCode.TooManyRequestsAndRetryAfter,void 0,void 0);this.setDonotMakeRequestsUntil(void 0);const V=await this.commonHeadersPromise;F.headers={...F.headers||{},...V,"X-Account-Type":this.authToken.type,authorization:`Bearer ${this.authToken.token}`},this.addSessionHeaders(F.headers),this.logService.trace("Sending request to server",{url:O,type:F.type,headers:{...F.headers,authorization:void 0}});let z;try{z=await this.session.request(O,F,M)}catch(B){if(!(B instanceof p.UserDataSyncStoreError)){let Z=p.UserDataSyncErrorCode.RequestFailed;const ne=(0,_.getErrorMessage)(B).toLowerCase();ne.includes("xhr timeout")?Z=p.UserDataSyncErrorCode.RequestTimeout:ne.includes("protocol")&&ne.includes("not supported")?Z=p.UserDataSyncErrorCode.RequestProtocolNotSupported:ne.includes("request path contains unescaped characters")?Z=p.UserDataSyncErrorCode.RequestPathNotEscaped:ne.includes("headers must be an object")?Z=p.UserDataSyncErrorCode.RequestHeadersNotObject:(0,_.isCancellationError)(B)&&(Z=p.UserDataSyncErrorCode.RequestCanceled),B=new p.UserDataSyncStoreError(`Connection refused for the request '${O}'.`,O,Z,void 0,void 0)}throw this.logService.info("Request failed",O),B}const J=z.res.headers[p.HEADER_OPERATION_ID],j={url:O,status:z.res.statusCode,"execution-id":F.headers[p.HEADER_EXECUTION_ID],"operation-id":J},te=(0,v.isSuccess)(z)||z.res.statusCode&&N.includes(z.res.statusCode);let q="";if(te?this.logService.trace("Request succeeded",j):(q=await(0,v.asText)(z)||"",this.logService.info("Request failed",j,q)),z.res.statusCode===401||z.res.statusCode===403){if(this.authToken=void 0,z.res.statusCode===401)throw this._onTokenFailed.fire(p.UserDataSyncErrorCode.Unauthorized),new p.UserDataSyncStoreError(`${F.type} request '${O}' failed because of Unauthorized (401).`,O,p.UserDataSyncErrorCode.Unauthorized,z.res.statusCode,J);if(z.res.statusCode===403)throw this._onTokenFailed.fire(p.UserDataSyncErrorCode.Forbidden),new p.UserDataSyncStoreError(`${F.type} request '${O}' failed because the access is forbidden (403).`,O,p.UserDataSyncErrorCode.Forbidden,z.res.statusCode,J)}if(this._onTokenSucceed.fire(),z.res.statusCode===404)throw new p.UserDataSyncStoreError(`${F.type} request '${O}' failed because the requested resource is not found (404).`,O,p.UserDataSyncErrorCode.NotFound,z.res.statusCode,J);if(z.res.statusCode===405)throw new p.UserDataSyncStoreError(`${F.type} request '${O}' failed because the requested endpoint is not found (405). ${q}`,O,p.UserDataSyncErrorCode.MethodNotFound,z.res.statusCode,J);if(z.res.statusCode===409)throw new p.UserDataSyncStoreError(`${F.type} request '${O}' failed because of Conflict (409). There is new data for this resource. Make the request again with latest data.`,O,p.UserDataSyncErrorCode.Conflict,z.res.statusCode,J);if(z.res.statusCode===410)throw new p.UserDataSyncStoreError(`${F.type} request '${O}' failed because the requested resource is not longer available (410).`,O,p.UserDataSyncErrorCode.Gone,z.res.statusCode,J);if(z.res.statusCode===412)throw new p.UserDataSyncStoreError(`${F.type} request '${O}' failed because of Precondition Failed (412). There is new data for this resource. Make the request again with latest data.`,O,p.UserDataSyncErrorCode.PreconditionFailed,z.res.statusCode,J);if(z.res.statusCode===413)throw new p.UserDataSyncStoreError(`${F.type} request '${O}' failed because of too large payload (413).`,O,p.UserDataSyncErrorCode.TooLarge,z.res.statusCode,J);if(z.res.statusCode===426)throw new p.UserDataSyncStoreError(`${F.type} request '${O}' failed with status Upgrade Required (426). Please upgrade the client and try again.`,O,p.UserDataSyncErrorCode.UpgradeRequired,z.res.statusCode,J);if(z.res.statusCode===429){const B=z.res.headers["retry-after"];throw B?(this.setDonotMakeRequestsUntil(new Date(Date.now()+parseInt(B)*1e3)),new p.UserDataSyncStoreError(`${F.type} request '${O}' failed because of too many requests (429).`,O,p.UserDataSyncErrorCode.TooManyRequestsAndRetryAfter,z.res.statusCode,J)):new p.UserDataSyncStoreError(`${F.type} request '${O}' failed because of too many requests (429).`,O,p.UserDataSyncErrorCode.TooManyRequests,z.res.statusCode,J)}if(!te)throw new p.UserDataSyncStoreError("Server returned "+z.res.statusCode,O,p.UserDataSyncErrorCode.Unknown,z.res.statusCode,J);return z}addSessionHeaders(O){let F=this.storageService.get(t,C.StorageScope.APPLICATION);F===void 0&&(F=(0,m.generateUuid)(),this.storageService.store(t,F,C.StorageScope.APPLICATION,C.StorageTarget.MACHINE)),O["X-Machine-Session-Id"]=F;const N=this.storageService.get(n,C.StorageScope.APPLICATION);N!==void 0&&(O["X-User-Session-Id"]=N)}};e.UserDataSyncStoreClient=y,e.UserDataSyncStoreClient=y=Ie([Y(1,I.IProductService),Y(2,v.IRequestService),Y(3,p.IUserDataSyncLogService),Y(4,l.IEnvironmentService),Y(5,g.IFileService),Y(6,C.IStorageService)],y);let A=class extends y{constructor(O,F,N,M,V,z,J){super(O.userDataSyncStore?.url,F,N,M,V,z,J),this._register(O.onDidChangeUserDataSyncStore(()=>this.updateUserDataSyncStoreUrl(O.userDataSyncStore?.url)))}};e.UserDataSyncStoreService=A,e.UserDataSyncStoreService=A=Ie([Y(0,p.IUserDataSyncStoreManagementService),Y(1,I.IProductService),Y(2,v.IRequestService),Y(3,p.IUserDataSyncLogService),Y(4,l.IEnvironmentService),Y(5,g.IFileService),Y(6,C.IStorageService)],A);class b{constructor(O,F,N,M){this.limit=O,this.interval=F,this.requestService=N,this.logService=M,this.requests=[],this.startTime=void 0}request(O,F,N){if(this.isExpired()&&this.reset(),F.url=O,this.requests.length>=this.limit)throw this.logService.info("Too many requests",...this.requests),new p.UserDataSyncStoreError(`Too many requests. Only ${this.limit} requests allowed in ${this.interval/(1e3*60)} minutes.`,O,p.UserDataSyncErrorCode.LocalTooManyRequests,void 0,void 0);return this.startTime=this.startTime||new Date,this.requests.push(O),this.requestService.request(F,N)}isExpired(){return this.startTime!==void 0&&new Date().getTime()-this.startTime.getTime()>this.interval}reset(){this.requests=[],this.startTime=void 0}}e.RequestsSession=b}),define(he[236],fe([0,1,3,2,10,21,23,16,128]),function(ce,e,R,a,_,T,k,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreManagementServiceChannelClient=e.UserDataSyncStoreManagementServiceChannel=e.UserDataSyncAccountServiceChannelClient=e.UserDataSyncAccountServiceChannel=void 0;class E{constructor(l){this.service=l}listen(l,g){switch(g){case"onDidChangeAccount":return this.service.onDidChangeAccount;case"onTokenFailed":return this.service.onTokenFailed}throw new Error(`[UserDataSyncAccountServiceChannel] Event not found: ${g}`)}call(l,g,I){switch(g){case"_getInitialData":return Promise.resolve(this.service.account);case"updateAccount":return this.service.updateAccount(I)}throw new Error("Invalid call")}}e.UserDataSyncAccountServiceChannel=E;class P extends a.Disposable{get account(){return this._account}get onTokenFailed(){return this.channel.listen("onTokenFailed")}constructor(l){super(),this.channel=l,this._onDidChangeAccount=this._register(new R.Emitter),this.onDidChangeAccount=this._onDidChangeAccount.event,this.channel.call("_getInitialData").then(g=>{this._account=g,this._register(this.channel.listen("onDidChangeAccount")(I=>{this._account=I,this._onDidChangeAccount.fire(I)}))})}updateAccount(l){return this.channel.call("updateAccount",l)}}e.UserDataSyncAccountServiceChannelClient=P;class S{constructor(l){this.service=l}listen(l,g){switch(g){case"onDidChangeUserDataSyncStore":return this.service.onDidChangeUserDataSyncStore}throw new Error(`[UserDataSyncStoreManagementServiceChannel] Event not found: ${g}`)}call(l,g,I){switch(g){case"switch":return this.service.switch(I[0]);case"getPreviousUserDataSyncStore":return this.service.getPreviousUserDataSyncStore()}throw new Error("Invalid call")}}e.UserDataSyncStoreManagementServiceChannel=S;let m=class extends D.AbstractUserDataSyncStoreManagementService{constructor(l,g,I,v){super(g,I,v),this.channel=l,this._register(this.channel.listen("onDidChangeUserDataSyncStore")(()=>this.updateUserDataSyncStore()))}async switch(l){return this.channel.call("switch",[l])}async getPreviousUserDataSyncStore(){const l=await this.channel.call("getPreviousUserDataSyncStore");return this.revive(l)}revive(l){return{url:_.URI.revive(l.url),type:l.type,defaultUrl:_.URI.revive(l.defaultUrl),insidersUrl:_.URI.revive(l.insidersUrl),stableUrl:_.URI.revive(l.stableUrl),canSwitch:l.canSwitch,authenticationProviders:l.authenticationProviders}}};e.UserDataSyncStoreManagementServiceChannelClient=m,e.UserDataSyncStoreManagementServiceChannelClient=m=Ie([Y(1,k.IProductService),Y(2,T.IConfigurationService),Y(3,L.IStorageService)],m)}),define(he[237],fe([0,1,3,57,23,16,18,232,24,83,87]),function(ce,e,R,a,_,T,k,L,D,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;let S=class extends L.UserDataAutoSyncService{constructor(d,l,g,I,v,f,C,p,c,u,i){super(d,l,g,I,v,C,p,c,u,i),this._register(R.Event.debounce(R.Event.any(R.Event.map(f.onDidFocusMainWindow,()=>"windowFocus"),R.Event.map(f.onDidOpenMainWindow,()=>"windowOpen")),(n,t)=>n?[...n,t]:[t],1e3)(n=>this.triggerSync(n,!0,!1)))}};e.UserDataAutoSyncService=S,e.UserDataAutoSyncService=S=Ie([Y(0,_.IProductService),Y(1,D.IUserDataSyncStoreManagementService),Y(2,D.IUserDataSyncStoreService),Y(3,D.IUserDataSyncEnablementService),Y(4,D.IUserDataSyncService),Y(5,a.INativeHostService),Y(6,D.IUserDataSyncLogService),Y(7,E.IUserDataSyncAccountService),Y(8,k.ITelemetryService),Y(9,P.IUserDataSyncMachinesService),Y(10,T.IStorageService)],S)}),define(he[238],fe([0,1,76,22,5,20]),function(ce,e,R,a,_,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NON_EMPTY_WORKSPACE_ID_LENGTH=void 0,e.getWorkspaceIdentifier=k,e.getSingleFolderWorkspaceIdentifier=L,e.createEmptyWorkspaceIdentifier=D,e.NON_EMPTY_WORKSPACE_ID_LENGTH=128/4;function k(E){function P(){let S=E.scheme===a.Schemas.file?(0,T.originalFSPath)(E):E.toString();return _.isLinux||(S=S.toLowerCase()),(0,R.createHash)("md5").update(S).digest("hex")}return{id:P(),configPath:E}}function L(E,P){function S(){if(E.scheme!==a.Schemas.file)return(0,R.createHash)("md5").update(E.toString()).digest("hex");if(!P)return;let d;return _.isLinux?d=P.ino:_.isMacintosh?d=P.birthtime.getTime():_.isWindows&&(typeof P.birthtimeMs=="number"?d=Math.floor(P.birthtimeMs):d=P.birthtime.getTime()),(0,R.createHash)("md5").update(E.fsPath).update(d?String(d):"").digest("hex")}const m=S();if(typeof m=="string")return{id:m,uri:E}}function D(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}}),define(he[239],fe([0,1,6,8,2,13,30,15,11,80,117,238,57,56,22]),function(ce,e,R,a,_,T,k,L,D,E,P,S,m,d,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UnusedWorkspaceStorageDataCleaner=void 0;let g=class extends _.Disposable{constructor(v,f,C,p){super(),this.environmentService=v,this.logService=f,this.nativeHostService=C,this.mainProcessService=p,this._register(new R.RunOnceScheduler(()=>{this.cleanUpStorage()},30*1e3)).schedule()}async cleanUpStorage(){this.logService.trace("[storage cleanup]: Starting to clean up workspace storage folders for unused empty workspaces.");try{const v=this.environmentService.workspaceStorageHome.with({scheme:l.Schemas.file}).fsPath,f=await k.Promises.readdir(v),C=new E.StorageClient(this.mainProcessService.getChannel("storage"));await Promise.all(f.map(async p=>{const c=(0,T.join)(v,p);p.length===S.NON_EMPTY_WORKSPACE_ID_LENGTH||p===P.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE.id||(await this.nativeHostService.getWindows({includeAuxiliaryWindows:!1})).some(n=>n.workspace?.id===p)||await C.isUsed(c)||(this.logService.trace(`[storage cleanup]: Deleting workspace storage folder ${p} as it seems to be an unused empty workspace.`),await k.Promises.rm(c))}))}catch(v){(0,a.onUnexpectedError)(v)}}};e.UnusedWorkspaceStorageDataCleaner=g,e.UnusedWorkspaceStorageDataCleaner=g=Ie([Y(0,L.INativeEnvironmentService),Y(1,D.ILogService),Y(2,m.INativeHostService),Y(3,d.IMainProcessService)],g)}),define(he[129],fe([0,1,76,66,38,247,14,8,3,2,13,5,32,43,72]),function(ce,e,R,a,_,T,k,L,D,E,P,S,m,d,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0,e.createRandomIPCHandle=t,e.createStaticIPCHandle=s,e.serve=h,e.connect=y;const g=3e4;class I{traceSocketEvent(b,w){l.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,b,w)}constructor(b,w=""){this._canWrite=!0,this.debugLabel=w,this.socket=b,this.traceSocketEvent(l.SocketDiagnosticsEventType.Created,{type:"NodeSocket"}),this._errorListener=F=>{if(this.traceSocketEvent(l.SocketDiagnosticsEventType.Error,{code:F?.code,message:F?.message}),F){if(F.code==="EPIPE")return;(0,L.onUnexpectedError)(F)}},this.socket.on("error",this._errorListener);let O;this._closeListener=F=>{this.traceSocketEvent(l.SocketDiagnosticsEventType.Close,{hadError:F}),this._canWrite=!1,O&&clearTimeout(O)},this.socket.on("close",this._closeListener),this._endListener=()=>{this.traceSocketEvent(l.SocketDiagnosticsEventType.NodeEndReceived),this._canWrite=!1,O=setTimeout(()=>b.destroy(),g)},this.socket.on("end",this._endListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.off("close",this._closeListener),this.socket.off("end",this._endListener),this.socket.destroy()}onData(b){const w=O=>{this.traceSocketEvent(l.SocketDiagnosticsEventType.Read,O),b(k.VSBuffer.wrap(O))};return this.socket.on("data",w),{dispose:()=>this.socket.off("data",w)}}onClose(b){const w=O=>{b({type:l.SocketCloseEventType.NodeSocketCloseEvent,hadError:O,error:void 0})};return this.socket.on("close",w),{dispose:()=>this.socket.off("close",w)}}onEnd(b){const w=()=>{b()};return this.socket.on("end",w),{dispose:()=>this.socket.off("end",w)}}write(b){if(!(this.socket.destroyed||!this._canWrite))try{this.traceSocketEvent(l.SocketDiagnosticsEventType.Write,b),this.socket.write(b.buffer,w=>{if(w){if(w.code==="EPIPE")return;(0,L.onUnexpectedError)(w)}})}catch(w){if(w.code==="EPIPE")return;(0,L.onUnexpectedError)(w)}}end(){this.traceSocketEvent(l.SocketDiagnosticsEventType.NodeEndSent),this.socket.end()}drain(){return this.traceSocketEvent(l.SocketDiagnosticsEventType.NodeDrainBegin),new Promise((b,w)=>{if(this.socket.bufferSize===0){this.traceSocketEvent(l.SocketDiagnosticsEventType.NodeDrainEnd),b();return}const O=()=>{this.socket.off("close",O),this.socket.off("end",O),this.socket.off("error",O),this.socket.off("timeout",O),this.socket.off("drain",O),this.traceSocketEvent(l.SocketDiagnosticsEventType.NodeDrainEnd),b()};this.socket.on("close",O),this.socket.on("end",O),this.socket.on("error",O),this.socket.on("timeout",O),this.socket.on("drain",O)})}}e.NodeSocket=I;var v;(function(A){A[A.MinHeaderByteSize=2]="MinHeaderByteSize",A[A.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(v||(v={}));var f;(function(A){A[A.PeekHeader=1]="PeekHeader",A[A.ReadHeader=2]="ReadHeader",A[A.ReadBody=3]="ReadBody",A[A.Fin=4]="Fin"})(f||(f={}));class C extends E.Disposable{get permessageDeflate(){return this._flowManager.permessageDeflate}get recordedInflateBytes(){return this._flowManager.recordedInflateBytes}traceSocketEvent(b,w){this.socket.traceSocketEvent(b,w)}constructor(b,w,O,F){super(),this._onData=this._register(new D.Emitter),this._onClose=this._register(new D.Emitter),this._isEnded=!1,this._state={state:f.PeekHeader,readLen:v.MinHeaderByteSize,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=b,this.traceSocketEvent(l.SocketDiagnosticsEventType.Created,{type:"WebSocketNodeSocket",permessageDeflate:w,inflateBytesLength:O?.byteLength||0,recordInflateBytes:F}),this._flowManager=this._register(new p(this,w,O,F,this._onData,(N,M)=>this._write(N,M))),this._register(this._flowManager.onError(N=>{console.error(N),(0,L.onUnexpectedError)(N),this._onClose.fire({type:l.SocketCloseEventType.NodeSocketCloseEvent,hadError:!0,error:N})})),this._incomingData=new l.ChunkStream,this._register(this.socket.onData(N=>this._acceptChunk(N))),this._register(this.socket.onClose(async N=>{this._flowManager.isProcessingReadQueue()&&await D.Event.toPromise(this._flowManager.onDidFinishProcessingReadQueue),this._onClose.fire(N)}))}dispose(){this._flowManager.isProcessingWriteQueue()?this._register(this._flowManager.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(b){return this._onData.event(b)}onClose(b){return this._onClose.event(b)}onEnd(b){return this.socket.onEnd(b)}write(b){let w=0;for(;w<b.byteLength;)this._flowManager.writeMessage(b.slice(w,Math.min(w+v.MaxWebSocketMessageLength,b.byteLength)),{compressed:!0,opcode:2}),w+=v.MaxWebSocketMessageLength}_write(b,{compressed:w,opcode:O}){if(this._isEnded)return;this.traceSocketEvent(l.SocketDiagnosticsEventType.WebSocketNodeSocketWrite,b);let F=v.MinHeaderByteSize;b.byteLength<126?F+=0:b.byteLength<2**16?F+=2:F+=8;const N=k.VSBuffer.alloc(F),M=w?64:0,V=O&15;if(N.writeUInt8(128|M|V,0),b.byteLength<126)N.writeUInt8(b.byteLength,1);else if(b.byteLength<2**16){N.writeUInt8(126,1);let z=1;N.writeUInt8(b.byteLength>>>8&255,++z),N.writeUInt8(b.byteLength>>>0&255,++z)}else{N.writeUInt8(127,1);let z=1;N.writeUInt8(0,++z),N.writeUInt8(0,++z),N.writeUInt8(0,++z),N.writeUInt8(0,++z),N.writeUInt8(b.byteLength>>>24&255,++z),N.writeUInt8(b.byteLength>>>16&255,++z),N.writeUInt8(b.byteLength>>>8&255,++z),N.writeUInt8(b.byteLength>>>0&255,++z)}this.socket.write(k.VSBuffer.concat([N,b]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(b){if(b.byteLength!==0){for(this._incomingData.acceptChunk(b);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===f.PeekHeader){const w=this._incomingData.peek(this._state.readLen),O=w.readUInt8(0),F=(O&128)>>>7,N=(O&64)>>>6,M=O&15,V=w.readUInt8(1),z=(V&128)>>>7,J=V&127;this._state.state=f.ReadHeader,this._state.readLen=v.MinHeaderByteSize+(z?4:0)+(J===126?2:0)+(J===127?8:0),this._state.fin=F,this._state.firstFrameOfMessage&&(this._state.compressed=!!N),this._state.firstFrameOfMessage=!!F,this._state.mask=0,this._state.opcode=M,this.traceSocketEvent(l.SocketDiagnosticsEventType.WebSocketNodeSocketPeekedHeader,{headerSize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,opcode:this._state.opcode})}else if(this._state.state===f.ReadHeader){const w=this._incomingData.read(this._state.readLen),O=w.readUInt8(1),F=(O&128)>>>7;let N=O&127,M=1;N===126?N=w.readUInt8(++M)*2**8+w.readUInt8(++M):N===127&&(N=w.readUInt8(++M)*0+w.readUInt8(++M)*0+w.readUInt8(++M)*0+w.readUInt8(++M)*0+w.readUInt8(++M)*2**24+w.readUInt8(++M)*2**16+w.readUInt8(++M)*2**8+w.readUInt8(++M));let V=0;F&&(V=w.readUInt8(++M)*2**24+w.readUInt8(++M)*2**16+w.readUInt8(++M)*2**8+w.readUInt8(++M)),this._state.state=f.ReadBody,this._state.readLen=N,this._state.mask=V,this.traceSocketEvent(l.SocketDiagnosticsEventType.WebSocketNodeSocketPeekedHeader,{bodySize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,mask:this._state.mask,opcode:this._state.opcode})}else if(this._state.state===f.ReadBody){const w=this._incomingData.read(this._state.readLen);this.traceSocketEvent(l.SocketDiagnosticsEventType.WebSocketNodeSocketReadData,w),i(w,this._state.mask),this.traceSocketEvent(l.SocketDiagnosticsEventType.WebSocketNodeSocketUnmaskedData,w),this._state.state=f.PeekHeader,this._state.readLen=v.MinHeaderByteSize,this._state.mask=0,this._state.opcode<=2?this._flowManager.acceptFrame(w,this._state.compressed,!!this._state.fin):this._state.opcode===9&&this._flowManager.writeMessage(w,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent(l.SocketDiagnosticsEventType.WebSocketNodeSocketDrainBegin),this._flowManager.isProcessingWriteQueue()&&await D.Event.toPromise(this._flowManager.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent(l.SocketDiagnosticsEventType.WebSocketNodeSocketDrainEnd)}}e.WebSocketNodeSocket=C;class p extends E.Disposable{get permessageDeflate(){return!!(this._zlibInflateStream&&this._zlibDeflateStream)}get recordedInflateBytes(){return this._zlibInflateStream?this._zlibInflateStream.recordedInflateBytes:k.VSBuffer.alloc(0)}constructor(b,w,O,F,N,M){super(),this._tracer=b,this._onData=N,this._writeFn=M,this._onError=this._register(new D.Emitter),this.onError=this._onError.event,this._writeQueue=[],this._readQueue=[],this._onDidFinishProcessingReadQueue=this._register(new D.Emitter),this.onDidFinishProcessingReadQueue=this._onDidFinishProcessingReadQueue.event,this._onDidFinishProcessingWriteQueue=this._register(new D.Emitter),this.onDidFinishProcessingWriteQueue=this._onDidFinishProcessingWriteQueue.event,this._isProcessingWriteQueue=!1,this._isProcessingReadQueue=!1,w?(this._zlibInflateStream=this._register(new c(this._tracer,F,O,{windowBits:15})),this._zlibDeflateStream=this._register(new u(this._tracer,{windowBits:15})),this._register(this._zlibInflateStream.onError(V=>this._onError.fire(V))),this._register(this._zlibDeflateStream.onError(V=>this._onError.fire(V)))):(this._zlibInflateStream=null,this._zlibDeflateStream=null)}writeMessage(b,w){this._writeQueue.push({data:b,options:w}),this._processWriteQueue()}async _processWriteQueue(){if(!this._isProcessingWriteQueue){for(this._isProcessingWriteQueue=!0;this._writeQueue.length>0;){const{data:b,options:w}=this._writeQueue.shift();if(this._zlibDeflateStream&&w.compressed){const O=await this._deflateMessage(this._zlibDeflateStream,b);this._writeFn(O,w)}else this._writeFn(b,{...w,compressed:!1})}this._isProcessingWriteQueue=!1,this._onDidFinishProcessingWriteQueue.fire()}}isProcessingWriteQueue(){return this._isProcessingWriteQueue}_deflateMessage(b,w){return new Promise((O,F)=>{b.write(w),b.flush(N=>O(N))})}acceptFrame(b,w,O){this._readQueue.push({data:b,isCompressed:w,isLastFrameOfMessage:O}),this._processReadQueue()}async _processReadQueue(){if(!this._isProcessingReadQueue){for(this._isProcessingReadQueue=!0;this._readQueue.length>0;){const b=this._readQueue.shift();if(this._zlibInflateStream&&b.isCompressed){const w=await this._inflateFrame(this._zlibInflateStream,b.data,b.isLastFrameOfMessage);this._onData.fire(w)}else this._onData.fire(b.data)}this._isProcessingReadQueue=!1,this._onDidFinishProcessingReadQueue.fire()}}isProcessingReadQueue(){return this._isProcessingReadQueue}_inflateFrame(b,w,O){return new Promise((F,N)=>{b.write(w),O&&b.write(k.VSBuffer.fromByteArray([0,0,255,255])),b.flush(M=>F(M))})}}class c extends E.Disposable{get recordedInflateBytes(){return this._recordInflateBytes?k.VSBuffer.concat(this._recordedInflateBytes):k.VSBuffer.alloc(0)}constructor(b,w,O,F){super(),this._tracer=b,this._recordInflateBytes=w,this._onError=this._register(new D.Emitter),this.onError=this._onError.event,this._recordedInflateBytes=[],this._pendingInflateData=[],this._zlibInflate=(0,T.createInflateRaw)(F),this._zlibInflate.on("error",N=>{this._tracer.traceSocketEvent(l.SocketDiagnosticsEventType.zlibInflateError,{message:N?.message,code:N?.code}),this._onError.fire(N)}),this._zlibInflate.on("data",N=>{this._tracer.traceSocketEvent(l.SocketDiagnosticsEventType.zlibInflateData,N),this._pendingInflateData.push(k.VSBuffer.wrap(N))}),O&&(this._tracer.traceSocketEvent(l.SocketDiagnosticsEventType.zlibInflateInitialWrite,O.buffer),this._zlibInflate.write(O.buffer),this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent(l.SocketDiagnosticsEventType.zlibInflateInitialFlushFired),this._pendingInflateData.length=0}))}write(b){this._recordInflateBytes&&this._recordedInflateBytes.push(b.clone()),this._tracer.traceSocketEvent(l.SocketDiagnosticsEventType.zlibInflateWrite,b),this._zlibInflate.write(b.buffer)}flush(b){this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent(l.SocketDiagnosticsEventType.zlibInflateFlushFired);const w=k.VSBuffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,b(w)})}}class u extends E.Disposable{constructor(b,w){super(),this._tracer=b,this._onError=this._register(new D.Emitter),this.onError=this._onError.event,this._pendingDeflateData=[],this._zlibDeflate=(0,T.createDeflateRaw)({windowBits:15}),this._zlibDeflate.on("error",O=>{this._tracer.traceSocketEvent(l.SocketDiagnosticsEventType.zlibDeflateError,{message:O?.message,code:O?.code}),this._onError.fire(O)}),this._zlibDeflate.on("data",O=>{this._tracer.traceSocketEvent(l.SocketDiagnosticsEventType.zlibDeflateData,O),this._pendingDeflateData.push(k.VSBuffer.wrap(O))})}write(b){this._tracer.traceSocketEvent(l.SocketDiagnosticsEventType.zlibDeflateWrite,b.buffer),this._zlibDeflate.write(b.buffer)}flush(b){this._zlibDeflate.flush(2,()=>{this._tracer.traceSocketEvent(l.SocketDiagnosticsEventType.zlibDeflateFlushFired);let w=k.VSBuffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,w=w.slice(0,w.byteLength-4),b(w)})}}function i(A,b){if(b===0)return;const w=A.byteLength>>>2;for(let z=0;z<w;z++){const J=A.readUInt32BE(z*4);A.writeUInt32BE(J^b,z*4)}const O=w*4,F=A.byteLength-O,N=b>>>24&255,M=b>>>16&255,V=b>>>8&255;F>=1&&A.writeUInt8(A.readUInt8(O)^N,O),F>=2&&A.writeUInt8(A.readUInt8(O+1)^M,O+1),F>=3&&A.writeUInt8(A.readUInt8(O+2)^V,O+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const n={[S.Platform.Linux]:107,[S.Platform.Mac]:103};function t(){const A=(0,m.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${A}-sock`;const b=process.platform!=="darwin"&&e.XDG_RUNTIME_DIR?e.XDG_RUNTIME_DIR:(0,_.tmpdir)(),w=(0,P.join)(b,`vscode-ipc-${A}.sock`);return r(w),w}function s(A,b,w){const F=(0,R.createHash)("sha256").update(A).digest("hex").substr(0,8);if(process.platform==="win32")return`\\\\.\\pipe\\${F}-${w}-${b}-sock`;const N=w.substr(0,4),M=b.substr(0,6);let V;return process.platform!=="darwin"&&e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?V=(0,P.join)(e.XDG_RUNTIME_DIR,`vscode-${F}-${N}-${M}.sock`):V=(0,P.join)(A,`${N}-${M}.sock`),r(V),V}function r(A){const b=n[S.platform];typeof b=="number"&&A.length>=b&&console.warn(`WARNING: IPC handle "${A}" is longer than ${b} chars, try a shorter --user-data-dir`)}class o extends d.IPCServer{static toClientConnectionEvent(b){const w=D.Event.fromNodeEventEmitter(b,"connection");return D.Event.map(w,O=>({protocol:new l.Protocol(new I(O,"ipc-server-connection")),onDidClientDisconnect:D.Event.once(D.Event.fromNodeEventEmitter(O,"close"))}))}constructor(b){super(o.toClientConnectionEvent(b)),this.server=b}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=o;function h(A){return new Promise((b,w)=>{const O=(0,a.createServer)();O.on("error",w),O.listen(A,()=>{O.removeListener("error",w),b(new o(O))})})}function y(A,b){return new Promise((w,O)=>{const F=(0,a.createConnection)(A,()=>{F.removeListener("error",O),w(l.Client.fromSocket(new I(F,`ipc-client${b}`),b))});F.once("error",O)})}}),define(he[240],fe([0,1,66,129,187]),function(ce,e,R,a,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,R=De(R),e.nodeSocketFactory=new class{supports(T){return!0}connect({host:T,port:k},L,D,E){return new Promise((P,S)=>{const m=R.createConnection({host:T,port:k},()=>{m.removeListener("error",S),m.write((0,_.makeRawSocketHeaders)(L,D,E));const d=l=>{l.toString().indexOf(`\r
\r
`)>=0&&(m.off("data",d),P(new a.NodeSocket(m,E)))};m.on("data",d)});m.setNoDelay(!0),m.once("error",S)})}}}),define(he[241],fe([0,1,66,38,141,129,6,2,5,21,11,23,188,108,110,81,14]),function(ce,e,R,a,_,T,k,L,D,E,P,S,m,d,l,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedTunnelsService=e.TunnelService=e.BaseTunnelService=e.NodeRemoteTunnel=void 0,R=De(R),a=De(a);async function v(u,i,n,t,s){let r;for(let o=3;o&&(r?.dispose(),r=await new f(u,i,n,t,s).waitForReady(),!(s&&_.BROWSER_RESTRICTED_PORTS[s]||!_.BROWSER_RESTRICTED_PORTS[r.tunnelLocalPort]));o--);return r}class f extends L.Disposable{constructor(i,n,t,s,r){super(),this.defaultTunnelHost=n,this.suggestedLocalPort=r,this.privacy=g.TunnelPrivacyId.Private,this._socketsDispose=new Map,this._options=i,this._server=R.createServer(),this._barrier=new k.Barrier,this._listeningListener=()=>this._barrier.open(),this._server.on("listening",this._listeningListener),this._connectionListener=o=>this._onConnection(o),this._server.on("connection",this._connectionListener),this._errorListener=()=>{},this._server.on("error",this._errorListener),this.tunnelRemotePort=s,this.tunnelRemoteHost=t}async dispose(){super.dispose(),this._server.removeListener("listening",this._listeningListener),this._server.removeListener("connection",this._connectionListener),this._server.removeListener("error",this._errorListener),this._server.close(),Array.from(this._socketsDispose.values()).forEach(n=>{n()})}async waitForReady(){const i=this.suggestedLocalPort??this.tunnelRemotePort,n=(0,g.isAllInterfaces)(this.defaultTunnelHost)?"0.0.0.0":"127.0.0.1";let t=await(0,_.findFreePortFaster)(i,2,1e3,n),s=null;return this._server.listen(t,this.defaultTunnelHost),await this._barrier.wait(),s=this._server.address(),s||(t=0,this._server.listen(t,this.defaultTunnelHost),await this._barrier.wait(),s=this._server.address()),this.tunnelLocalPort=s.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${s.port}`,this}async _onConnection(i){i.pause();const n=(0,g.isLocalhost)(this.tunnelRemoteHost)||(0,g.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,t=await(0,m.connectRemoteAgentTunnel)(this._options,n,this.tunnelRemotePort),s=t.getSocket(),r=t.readEntireBuffer();t.dispose(),r.byteLength>0&&i.write(r.buffer),i.on("end",()=>{i.localAddress&&this._socketsDispose.delete(i.localAddress),s.end()}),i.on("close",()=>s.end()),i.on("error",()=>{i.localAddress&&this._socketsDispose.delete(i.localAddress),s instanceof T.NodeSocket?s.socket.destroy():s.end()}),s instanceof T.NodeSocket?this._mirrorNodeSocket(i,s):this._mirrorGenericSocket(i,s),i.localAddress&&this._socketsDispose.set(i.localAddress,()=>{i.end(),s.end()})}_mirrorGenericSocket(i,n){n.onClose(()=>i.destroy()),n.onEnd(()=>i.end()),n.onData(t=>i.write(t.buffer)),i.on("data",t=>n.write(I.VSBuffer.wrap(t))),i.resume()}_mirrorNodeSocket(i,n){const t=n.socket;t.on("end",()=>i.end()),t.on("close",()=>i.end()),t.on("error",()=>{i.destroy()}),t.pipe(i),i.pipe(t)}}e.NodeRemoteTunnel=f;let C=class extends g.AbstractTunnelService{constructor(i,n,t,s,r){super(n,r),this.remoteSocketFactoryService=i,this.signService=t,this.productService=s}isPortPrivileged(i){return(0,g.isPortPrivileged)(i,this.defaultTunnelHost,D.OS,a.release())}retainOrCreateTunnel(i,n,t,s,r,o,h,y){const A=this.getTunnelFromMap(n,t);if(A)return++A.refcount,A.value;if((0,g.isTunnelProvider)(i))return this.createWithProvider(i,n,t,r,o,h,y);{this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${n}:${t} on local port ${r}.`);const b={commit:this.productService.commit,quality:this.productService.quality,addressProvider:i,remoteSocketFactoryService:this.remoteSocketFactoryService,signService:this.signService,logService:this.logService,ipcLogger:null},w=v(b,s,n,t,r);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.addTunnelToMap(n,t,w),w}}};e.BaseTunnelService=C,e.BaseTunnelService=C=Ie([Y(0,d.IRemoteSocketFactoryService),Y(1,P.ILogService),Y(2,l.ISignService),Y(3,S.IProductService),Y(4,E.IConfigurationService)],C);let p=class extends C{constructor(i,n,t,s,r){super(i,n,t,s,r)}};e.TunnelService=p,e.TunnelService=p=Ie([Y(0,d.IRemoteSocketFactoryService),Y(1,P.ILogService),Y(2,l.ISignService),Y(3,S.IProductService),Y(4,E.IConfigurationService)],p);let c=class extends L.Disposable{constructor(i,n,t,s,r){super(),this.remoteSocketFactoryService=i,this.logService=n,this.productService=t,this.signService=s,this.configurationService=r,this._tunnelServices=new Map}async openTunnel(i,n,t,s,r,o,h,y,A){if(this.logService.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${t}:${s} on local port ${o}.`),!this._tunnelServices.has(i)){const b=new p(this.remoteSocketFactoryService,this.logService,this.signService,this.productService,this.configurationService);this._register(b),this._tunnelServices.set(i,b),b.onTunnelClosed(async()=>{(await b.tunnels).length===0&&(b.dispose(),this._tunnelServices.delete(i))})}return this._tunnelServices.get(i).openTunnel(n,t,s,r,o,h,y,A)}};e.SharedTunnelsService=c,e.SharedTunnelsService=c=Ie([Y(0,d.IRemoteSocketFactoryService),Y(1,P.ILogService),Y(2,S.IProductService),Y(3,l.ISignService),Y(4,E.IConfigurationService)],c)});var it=this&&this.__importDefault||function(ce){return ce&&ce.__esModule?ce:{default:ce}};define(he[248],fe([0,1,38,41,8,2,22,10,17,3,43,154,181,182,191,173,239,164,165,21,186,99,198,100,193,15,120,225,27,112,189,119,75,7,175,176,74,4,172,77,79,201,11,177,104,23,61,16,111,18,113,114,115,48,204,86,116,24,83,231,236,214,87,230,234,235,128,62,229,215,110,197,81,241,192,205,28,206,5,207,166,184,183,85,220,19,52,180,58,228,203,216,109,233,221,9,178,103,226,219,194,160,57,179,237,223,56,227,108,106,240,158,195,150,145,149]),function(ce,e,R,a,_,T,k,L,D,E,P,S,m,d,l,g,I,v,f,C,p,c,u,i,n,t,s,r,o,h,y,A,b,w,O,F,N,M,V,z,J,j,te,q,B,Z,ne,le,ee,K,H,W,U,G,oe,Q,X,x,$,ie,ae,ue,Se,Ee,Re,Te,we,ve,re,de,me,be,Ce,Ue,_e,Ae,Fe,xe,ze,Me,$e,qe,Be,Oe,se,ge,pe,ye,Le,ke,We,Je,Ge,Ye,je,Ze,Xe,nt,at,At,_t,Ot,kt,Ut,Nt,Ft,yt,Mt,wt,xt,Wt,$t,ut,qt,Bt,It){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=bt,B=it(B);class zt extends T.Disposable{constructor(Pe){super(),this.configuration=Pe,this.server=this._register(new S.Server(this)),this.lifecycleService=void 0,this.onDidWindowConnectRaw=this._register(new E.Emitter),this.registerListeners()}registerListeners(){let Pe=!1;const Ne=()=>{Pe||(Pe=!0,this.lifecycleService?.fireOnWillShutdown(),this.dispose())};process.once("exit",Ne),(0,S.once)(process.parentPort,ut.SharedProcessLifecycle.exit,Ne)}async init(){const Pe=await this.initServices();(0,x.registerConfiguration)(),Pe.invokeFunction(Ne=>{const He=Ne.get(te.ILogService),Ve=Ne.get(K.ITelemetryService),et=Ne.get(ge.IUserDataProfilesService);He.trace("sharedProcess configuration",JSON.stringify(this.configuration)),this.initChannels(Ne),this.registerErrorHandler(He),this.reportProfilesInfo(Ve,et),this._register(et.onDidChangeProfiles(()=>this.reportProfilesInfo(Ve,et))),this.reportClientOSInfo(Ve,He)}),this._register((0,T.combinedDisposable)(Pe.createInstance(m.CodeCacheCleaner,this.configuration.codeCachePath),Pe.createInstance(d.LanguagePackCachedDataCleaner),Pe.createInstance(I.UnusedWorkspaceStorageDataCleaner),Pe.createInstance(g.LogsDataCleaner),Pe.createInstance(l.LocalizationsUpdater),Pe.createInstance(je.ExtensionsContributions),Pe.createInstance(Je.UserDataProfilesCleaner)))}async initServices(){const Pe=new z.ServiceCollection,Ne={_serviceBrand:void 0,...B.default};Pe.set(Z.IProductService,Ne);const He=new P.StaticRouter(Qe=>Qe==="main"),Ve=new yt.MainProcessService(this.server,He);Pe.set(yt.IMainProcessService,Ve);const et=this.configuration.policiesData?new ye.PolicyChannelClient(this.configuration.policiesData,Ve.getChannel("policy")):new Le.NullPolicyService;Pe.set(Le.IPolicyService,et);const Ke=new $t.NativeEnvironmentService(this.configuration.args,Ne);Pe.set(t.INativeEnvironmentService,Ke);const ot=new q.LoggerChannelClient(void 0,this.configuration.logLevel,Ke.logsHome,this.configuration.loggers.map(Qe=>({...Qe,resource:L.URI.revive(Qe.resource)})),Ve.getChannel("logger"));Pe.set(te.ILoggerService,ot);const dt=this._register(ot.createLogger("sharedprocess",{name:(0,Ze.localize)(172,null)})),pt=this._register(new te.ConsoleLogger(dt.getLevel())),tt=this._register(new Xe.LogService(dt,[pt]));Pe.set(te.ILogService,tt),this.lifecycleService=this._register(new nt.SharedProcessLifecycleService(tt)),Pe.set(nt.ISharedProcessLifecycleService,this.lifecycleService);const st=this._register(new O.FileService(tt));Pe.set(w.IFileService,st);const St=this._register(new F.DiskFileSystemProvider(tt));st.registerProvider(k.Schemas.file,St);const ft=new xe.UriIdentityService(st);Pe.set(Fe.IUriIdentityService,ft);const rt=this._register(new ke.UserDataProfilesService(this.configuration.profiles.all,L.URI.revive(this.configuration.profiles.home).with({scheme:Ke.userRoamingDataHome.scheme}),Ve.getChannel("userDataProfiles")));Pe.set(ge.IUserDataProfilesService,rt);const vt=this._register(new Me.FileUserDataProvider(k.Schemas.file,this._register(new $e.DiskFileSystemProviderClient(Ve.getChannel($e.LOCAL_FILE_SYSTEM_CHANNEL_NAME),{pathCaseSensitive:ze.isLinux})),k.Schemas.vscodeUserData,rt,ft,tt));st.registerProvider(k.Schemas.vscodeUserData,vt);const ct=this._register(new p.ConfigurationService(rt.defaultProfile.settingsResource,st,et,tt));Pe.set(C.IConfigurationService,ct);const Et=new Mt.RemoteStorageService(void 0,{defaultProfile:rt.defaultProfile,currentProfile:rt.defaultProfile},Ve,Ke);Pe.set(le.IStorageService,Et),this._register((0,T.toDisposable)(()=>Et.flush())),await Promise.all([ct.initialize(),Et.initialize()]);const Pt=new _t.RequestChannelClient(Ve.getChannel("request"));Pe.set(ne.IRequestService,Pt),Pe.set(v.IChecksumService,new N.SyncDescriptor(f.ChecksumService,void 0,!1)),Pe.set(Be.IV8InspectProfilingService,new N.SyncDescriptor(qe.InspectProfilingService,void 0,!1));const Rt=new Ut.NativeHostService(-1,Ve);Pe.set(kt.INativeHostService,Rt),Pe.set(i.IDownloadService,new N.SyncDescriptor(n.DownloadService,void 0,!0));const Vt=this._register(new de.ActiveWindowManager(Rt)),Ht=new P.StaticRouter(Qe=>Vt.getActiveClientId().then(mt=>Qe===mt));Pe.set(b.IExtensionRecommendationNotificationService,new Ot.ExtensionRecommendationNotificationServiceChannelClient(this.server.getChannel("extensionRecommendationNotification",Ht)));let gt;const lt=[],Ct=(0,G.isInternalTelemetry)(Ne,ct);if((0,G.supportsTelemetry)(Ne,Ke)){const Qe=new W.TelemetryLogAppender(tt,ot,Ke,Ne);if(lt.push(Qe),!(0,G.isLoggingOnly)(Ne,Ke)&&Ne.aiConfig?.ariaKey){const mt=new We.OneDataSystemAppender(Pt,Ct,"monacoworkbench",null,Ne.aiConfig.ariaKey);this._register((0,T.toDisposable)(()=>mt.flush())),lt.push(mt)}gt=new U.TelemetryService({appenders:lt,commonProperties:(0,ee.resolveCommonProperties)((0,R.release)(),(0,R.hostname)(),process.arch,Ne.commit,Ne.version,this.configuration.machineId,this.configuration.sqmId,this.configuration.devDeviceId,Ct),sendErrorTelemetry:!0,piiPaths:(0,G.getPiiPathsFromEnvironment)(Ke)},ct,Ne)}else{gt=G.NullTelemetryService;const Qe=G.NullAppender;lt.push(Qe)}this.server.registerChannel("telemetryAppender",new H.TelemetryAppenderChannel(lt)),Pe.set(K.ITelemetryService,gt);const Gt=new oe.CustomEndpointTelemetryService(ct,gt,tt,ot,Ke,Ne);Pe.set(K.ICustomEndpointTelemetryService,Gt),Pe.set(pe.IExtensionsProfileScannerService,new N.SyncDescriptor(At.ExtensionsProfileScannerService,void 0,!0)),Pe.set(Oe.IExtensionsScannerService,new N.SyncDescriptor(se.ExtensionsScannerService,void 0,!0)),Pe.set(h.IExtensionSignatureVerificationService,new N.SyncDescriptor(h.ExtensionSignatureVerificationService,void 0,!0)),Pe.set(A.INativeServerExtensionManagementService,new N.SyncDescriptor(A.ExtensionManagementService,void 0,!0)),Pe.set(o.IExtensionGalleryService,new N.SyncDescriptor(r.ExtensionGalleryService,void 0,!0)),Pe.set(o.IExtensionTipsService,new N.SyncDescriptor(Ft.ExtensionTipsService,void 0,!1)),Pe.set(J.ILanguagePackService,new N.SyncDescriptor(j.NativeLanguagePackService,void 0,!1)),Pe.set(c.IDiagnosticsService,new N.SyncDescriptor(u.DiagnosticsService,void 0,!1)),Pe.set($.IUserDataSyncAccountService,new N.SyncDescriptor($.UserDataSyncAccountService,void 0,!0)),Pe.set(x.IUserDataSyncLogService,new N.SyncDescriptor(ue.UserDataSyncLogService,void 0,!0)),Pe.set(x.IUserDataSyncUtilService,P.ProxyChannel.toService(this.server.getChannel("userDataSyncUtil",Qe=>Qe.ctx!=="main"))),Pe.set(o.IGlobalExtensionEnablementService,new N.SyncDescriptor(s.GlobalExtensionEnablementService,void 0,!1)),Pe.set(X.IIgnoredExtensionsManagementService,new N.SyncDescriptor(X.IgnoredExtensionsManagementService,void 0,!0)),Pe.set(Q.IExtensionStorageService,new N.SyncDescriptor(Q.ExtensionStorageService)),Pe.set(x.IUserDataSyncStoreManagementService,new N.SyncDescriptor(we.UserDataSyncStoreManagementService,void 0,!0)),Pe.set(x.IUserDataSyncStoreService,new N.SyncDescriptor(we.UserDataSyncStoreService,void 0,!0)),Pe.set(Se.IUserDataSyncMachinesService,new N.SyncDescriptor(Se.UserDataSyncMachinesService,void 0,!0)),Pe.set(x.IUserDataSyncLocalStoreService,new N.SyncDescriptor(ie.UserDataSyncLocalStoreService,void 0,!1)),Pe.set(x.IUserDataSyncEnablementService,new N.SyncDescriptor(Ee.UserDataSyncEnablementService,void 0,!0)),Pe.set(x.IUserDataSyncService,new N.SyncDescriptor(Re.UserDataSyncService,void 0,!1)),Pe.set(ve.IUserDataProfileStorageService,new N.SyncDescriptor(re.SharedProcessUserDataProfileStorageService,void 0,!0)),Pe.set(x.IUserDataSyncResourceProviderService,new N.SyncDescriptor(Ye.UserDataSyncResourceProviderService,void 0,!0)),Pe.set(me.ISignService,new N.SyncDescriptor(be.SignService,void 0,!1));const Dt=new wt.RemoteSocketFactoryService;return Pe.set(wt.IRemoteSocketFactoryService,Dt),Dt.register(xt.RemoteConnectionType.WebSocket,Wt.nodeSocketFactory),Pe.set(Ce.ISharedTunnelsService,new N.SyncDescriptor(Ue.SharedTunnelsService)),Pe.set(_e.ISharedProcessTunnelService,new N.SyncDescriptor(Ae.SharedProcessTunnelService)),Pe.set(Ge.IRemoteTunnelService,new N.SyncDescriptor(at.RemoteTunnelService)),new V.InstantiationService(Pe)}initChannels(Pe){const Ne=new y.ExtensionManagementChannel(Pe.get(o.IExtensionManagementService),()=>null);this.server.registerChannel("extensions",Ne);const He=P.ProxyChannel.fromService(Pe.get(J.ILanguagePackService),this._store);this.server.registerChannel("languagePacks",He);const Ve=P.ProxyChannel.fromService(Pe.get(c.IDiagnosticsService),this._store);this.server.registerChannel("diagnostics",Ve);const et=new y.ExtensionTipsChannel(Pe.get(o.IExtensionTipsService));this.server.registerChannel("extensionTipsService",et);const Ke=P.ProxyChannel.fromService(Pe.get(v.IChecksumService),this._store);this.server.registerChannel("checksum",Ke);const ot=P.ProxyChannel.fromService(Pe.get(Be.IV8InspectProfilingService),this._store);this.server.registerChannel("v8InspectProfiling",ot);const dt=P.ProxyChannel.fromService(Pe.get(Se.IUserDataSyncMachinesService),this._store);this.server.registerChannel("userDataSyncMachines",dt);const pt=P.ProxyChannel.fromService(Pe.get(K.ICustomEndpointTelemetryService),this._store);this.server.registerChannel("customEndpointTelemetry",pt);const tt=new ae.UserDataSyncAccountServiceChannel(Pe.get($.IUserDataSyncAccountService));this.server.registerChannel("userDataSyncAccount",tt);const st=new ae.UserDataSyncStoreManagementServiceChannel(Pe.get(x.IUserDataSyncStoreManagementService));this.server.registerChannel("userDataSyncStoreManagement",st);const St=new Te.UserDataSyncServiceChannel(Pe.get(x.IUserDataSyncService),Pe.get(ge.IUserDataProfilesService),Pe.get(te.ILogService));this.server.registerChannel("userDataSync",St);const ft=this._register(Pe.get(M.IInstantiationService).createInstance(Nt.UserDataAutoSyncService));this.server.registerChannel("userDataAutoSync",P.ProxyChannel.fromService(ft,this._store)),this.server.registerChannel("IUserDataSyncResourceProviderService",P.ProxyChannel.fromService(Pe.get(x.IUserDataSyncResourceProviderService),this._store));const rt=P.ProxyChannel.fromService(Pe.get(_e.ISharedProcessTunnelService),this._store);this.server.registerChannel(_e.ipcSharedProcessTunnelChannelName,rt);const vt=P.ProxyChannel.fromService(Pe.get(Ge.IRemoteTunnelService),this._store);this.server.registerChannel("remoteTunnel",vt)}registerErrorHandler(Pe){process.on("uncaughtException",Ne=>(0,_.onUnexpectedError)(Ne)),process.on("unhandledRejection",Ne=>(0,_.onUnexpectedError)(Ne)),(0,_.setUnexpectedErrorHandler)(Ne=>{const He=(0,a.toErrorMessage)(Ne,!0);He&&Pe.error(`[uncaught exception in sharedProcess]: ${He}`)})}reportProfilesInfo(Pe,Ne){Pe.publicLog2("profilesInfo",{count:Ne.profiles.length})}async reportClientOSInfo(Pe,Ne){if(ze.isLinux){const[He,Ve]=await Promise.all([(0,qt.getOSReleaseInfo)(Ne.error.bind(Ne)),(0,It.getDisplayProtocol)(Ne.error.bind(Ne))]),et=(0,Bt.getDesktopEnvironment)(),Ke=(0,It.getCodeDisplayProtocol)(Ve,this.configuration.args["ozone-platform"]);He&&Pe.publicLog2("clientPlatformInfo",{platformId:He.id,platformVersionId:He.version_id,platformIdLike:He.id_like,desktopEnvironment:et,displayProtocol:Ve,codeDisplayProtocol:Ke})}}handledClientConnection(Pe){if(Pe.data!==ut.SharedProcessRawConnection.response)return!1;const Ne=(0,D.firstOrDefault)(Pe.ports);return Ne?(this.onDidWindowConnectRaw.fire(Ne),!0):!1}}async function bt(ht){try{const Pe=new zt(ht);process.parentPort.postMessage(ut.SharedProcessLifecycle.ipcReady),await Pe.init(),process.parentPort.postMessage(ut.SharedProcessLifecycle.initDone)}catch(Pe){process.parentPort.postMessage({error:Pe.toString()})}}const jt=setTimeout(()=>{process.parentPort.postMessage({warning:"[SharedProcess] did not receive configuration within 30s..."})},3e4);process.parentPort.once("message",ht=>{clearTimeout(jt),bt(ht.data)})})}).call(this);

//# sourceMappingURL=https://main.vscode-cdn.net/sourcemaps/532bdf24071d0a26ceea0844dcdf5ee8cfabd562/core/vs/code/node/sharedProcess/sharedProcessMain.js.map
