/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Ee=["require","exports","vs/base/common/platform","vs/base/common/path","vs/base/common/lifecycle","vs/base/common/uri","vs/base/common/event","vs/base/common/strings","vs/base/common/async","vs/base/common/errors","vs/base/common/types","vs/base/common/charCode","vs/base/common/arrays","vs/base/common/cancellation","vs/base/common/extpath","fs","vs/base/common/lazy","vs/base/common/buffer","vs/platform/files/common/files","vs/platform/files/common/watcher","vs/base/common/map","vs/base/common/normalization","vs/nls","vs/base/common/resources","vs/base/common/glob","vs/base/node/pfs","vs/base/parts/ipc/common/ipc","vs/base/common/functional","vs/base/common/marshallingIds","vs/base/common/ternarySearchTree","vs/base/parts/sandbox/node/electronTypes","vs/nls.messages","vs/base/common/process","vs/base/common/processes","vs/base/common/network","vs/base/node/extpath","vs/platform/files/node/watcher/baseWatcher","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/decorators","vs/base/common/iterator","vs/base/common/linkedList","vs/base/common/stopwatch","vs/base/common/cache","vs/base/common/stream","vs/base/common/symbols","vs/base/common/objects","vs/base/common/uint","vs/base/common/errorMessage","vs/base/common/console","vs/base/common/marshalling","os","vs/base/node/processes","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/ipc/node/ipc.mp","vs/platform/instantiation/common/instantiation","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/parcel/parcelWatcher","vs/platform/files/node/watcher/watcherStats","vs/platform/files/node/watcher/watcher","util","child_process","@parcel/watcher","vs/platform/files/node/watcher/watcherMain"],pe=function(ce){for(var e=[],p=0,t=ce.length;p<t;p++)e[p]=Ee[ce[p]];return e};define(Ee[38],pe([0,1]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MonotonousArray=void 0,e.findLast=p,e.findLastIdx=t,e.findLastMonotonous=$,e.findLastIdxMonotonous=W,e.findFirstMonotonous=V,e.findFirstIdxMonotonousOrArrLen=k,e.findFirstIdxMonotonous=T,e.findFirstMax=N,e.findLastMax=E,e.findFirstMin=y,e.findMaxIdx=M,e.mapFindFirst=a;function p(r,d){const b=t(r,d);if(b!==-1)return r[b]}function t(r,d,b=r.length-1){for(let c=b;c>=0;c--){const v=r[c];if(d(v))return c}return-1}function $(r,d){const b=W(r,d);return b===-1?void 0:r[b]}function W(r,d,b=0,c=r.length){let v=b,w=c;for(;v<w;){const l=Math.floor((v+w)/2);d(r[l])?v=l+1:w=l}return v-1}function V(r,d){const b=k(r,d);return b===r.length?void 0:r[b]}function k(r,d,b=0,c=r.length){let v=b,w=c;for(;v<w;){const l=Math.floor((v+w)/2);d(r[l])?w=l:v=l+1}return v}function T(r,d,b=0,c=r.length){const v=k(r,d,b,c);return v===r.length?-1:v}class P{static{this.assertInvariants=!1}constructor(d){this._array=d,this._findLastMonotonousLastIdx=0}findLastMonotonous(d){if(P.assertInvariants){if(this._prevFindLastPredicate){for(const c of this._array)if(this._prevFindLastPredicate(c)&&!d(c))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this._prevFindLastPredicate=d}const b=W(this._array,d,this._findLastMonotonousLastIdx);return this._findLastMonotonousLastIdx=b+1,b===-1?void 0:this._array[b]}}e.MonotonousArray=P;function N(r,d){if(r.length===0)return;let b=r[0];for(let c=1;c<r.length;c++){const v=r[c];d(v,b)>0&&(b=v)}return b}function E(r,d){if(r.length===0)return;let b=r[0];for(let c=1;c<r.length;c++){const v=r[c];d(v,b)>=0&&(b=v)}return b}function y(r,d){return N(r,(b,c)=>-d(b,c))}function M(r,d){if(r.length===0)return-1;let b=0;for(let c=1;c<r.length;c++){const v=r[c];d(v,r[b])>0&&(b=c)}return b}function a(r,d){for(const b of r){const c=d(b);if(c!==void 0)return c}}}),define(Ee[11],pe([0,1]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharCode=void 0;var p;(function(t){t[t.Null=0]="Null",t[t.Backspace=8]="Backspace",t[t.Tab=9]="Tab",t[t.LineFeed=10]="LineFeed",t[t.CarriageReturn=13]="CarriageReturn",t[t.Space=32]="Space",t[t.ExclamationMark=33]="ExclamationMark",t[t.DoubleQuote=34]="DoubleQuote",t[t.Hash=35]="Hash",t[t.DollarSign=36]="DollarSign",t[t.PercentSign=37]="PercentSign",t[t.Ampersand=38]="Ampersand",t[t.SingleQuote=39]="SingleQuote",t[t.OpenParen=40]="OpenParen",t[t.CloseParen=41]="CloseParen",t[t.Asterisk=42]="Asterisk",t[t.Plus=43]="Plus",t[t.Comma=44]="Comma",t[t.Dash=45]="Dash",t[t.Period=46]="Period",t[t.Slash=47]="Slash",t[t.Digit0=48]="Digit0",t[t.Digit1=49]="Digit1",t[t.Digit2=50]="Digit2",t[t.Digit3=51]="Digit3",t[t.Digit4=52]="Digit4",t[t.Digit5=53]="Digit5",t[t.Digit6=54]="Digit6",t[t.Digit7=55]="Digit7",t[t.Digit8=56]="Digit8",t[t.Digit9=57]="Digit9",t[t.Colon=58]="Colon",t[t.Semicolon=59]="Semicolon",t[t.LessThan=60]="LessThan",t[t.Equals=61]="Equals",t[t.GreaterThan=62]="GreaterThan",t[t.QuestionMark=63]="QuestionMark",t[t.AtSign=64]="AtSign",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.OpenSquareBracket=91]="OpenSquareBracket",t[t.Backslash=92]="Backslash",t[t.CloseSquareBracket=93]="CloseSquareBracket",t[t.Caret=94]="Caret",t[t.Underline=95]="Underline",t[t.BackTick=96]="BackTick",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.OpenCurlyBrace=123]="OpenCurlyBrace",t[t.Pipe=124]="Pipe",t[t.CloseCurlyBrace=125]="CloseCurlyBrace",t[t.Tilde=126]="Tilde",t[t.NoBreakSpace=160]="NoBreakSpace",t[t.U_Combining_Grave_Accent=768]="U_Combining_Grave_Accent",t[t.U_Combining_Acute_Accent=769]="U_Combining_Acute_Accent",t[t.U_Combining_Circumflex_Accent=770]="U_Combining_Circumflex_Accent",t[t.U_Combining_Tilde=771]="U_Combining_Tilde",t[t.U_Combining_Macron=772]="U_Combining_Macron",t[t.U_Combining_Overline=773]="U_Combining_Overline",t[t.U_Combining_Breve=774]="U_Combining_Breve",t[t.U_Combining_Dot_Above=775]="U_Combining_Dot_Above",t[t.U_Combining_Diaeresis=776]="U_Combining_Diaeresis",t[t.U_Combining_Hook_Above=777]="U_Combining_Hook_Above",t[t.U_Combining_Ring_Above=778]="U_Combining_Ring_Above",t[t.U_Combining_Double_Acute_Accent=779]="U_Combining_Double_Acute_Accent",t[t.U_Combining_Caron=780]="U_Combining_Caron",t[t.U_Combining_Vertical_Line_Above=781]="U_Combining_Vertical_Line_Above",t[t.U_Combining_Double_Vertical_Line_Above=782]="U_Combining_Double_Vertical_Line_Above",t[t.U_Combining_Double_Grave_Accent=783]="U_Combining_Double_Grave_Accent",t[t.U_Combining_Candrabindu=784]="U_Combining_Candrabindu",t[t.U_Combining_Inverted_Breve=785]="U_Combining_Inverted_Breve",t[t.U_Combining_Turned_Comma_Above=786]="U_Combining_Turned_Comma_Above",t[t.U_Combining_Comma_Above=787]="U_Combining_Comma_Above",t[t.U_Combining_Reversed_Comma_Above=788]="U_Combining_Reversed_Comma_Above",t[t.U_Combining_Comma_Above_Right=789]="U_Combining_Comma_Above_Right",t[t.U_Combining_Grave_Accent_Below=790]="U_Combining_Grave_Accent_Below",t[t.U_Combining_Acute_Accent_Below=791]="U_Combining_Acute_Accent_Below",t[t.U_Combining_Left_Tack_Below=792]="U_Combining_Left_Tack_Below",t[t.U_Combining_Right_Tack_Below=793]="U_Combining_Right_Tack_Below",t[t.U_Combining_Left_Angle_Above=794]="U_Combining_Left_Angle_Above",t[t.U_Combining_Horn=795]="U_Combining_Horn",t[t.U_Combining_Left_Half_Ring_Below=796]="U_Combining_Left_Half_Ring_Below",t[t.U_Combining_Up_Tack_Below=797]="U_Combining_Up_Tack_Below",t[t.U_Combining_Down_Tack_Below=798]="U_Combining_Down_Tack_Below",t[t.U_Combining_Plus_Sign_Below=799]="U_Combining_Plus_Sign_Below",t[t.U_Combining_Minus_Sign_Below=800]="U_Combining_Minus_Sign_Below",t[t.U_Combining_Palatalized_Hook_Below=801]="U_Combining_Palatalized_Hook_Below",t[t.U_Combining_Retroflex_Hook_Below=802]="U_Combining_Retroflex_Hook_Below",t[t.U_Combining_Dot_Below=803]="U_Combining_Dot_Below",t[t.U_Combining_Diaeresis_Below=804]="U_Combining_Diaeresis_Below",t[t.U_Combining_Ring_Below=805]="U_Combining_Ring_Below",t[t.U_Combining_Comma_Below=806]="U_Combining_Comma_Below",t[t.U_Combining_Cedilla=807]="U_Combining_Cedilla",t[t.U_Combining_Ogonek=808]="U_Combining_Ogonek",t[t.U_Combining_Vertical_Line_Below=809]="U_Combining_Vertical_Line_Below",t[t.U_Combining_Bridge_Below=810]="U_Combining_Bridge_Below",t[t.U_Combining_Inverted_Double_Arch_Below=811]="U_Combining_Inverted_Double_Arch_Below",t[t.U_Combining_Caron_Below=812]="U_Combining_Caron_Below",t[t.U_Combining_Circumflex_Accent_Below=813]="U_Combining_Circumflex_Accent_Below",t[t.U_Combining_Breve_Below=814]="U_Combining_Breve_Below",t[t.U_Combining_Inverted_Breve_Below=815]="U_Combining_Inverted_Breve_Below",t[t.U_Combining_Tilde_Below=816]="U_Combining_Tilde_Below",t[t.U_Combining_Macron_Below=817]="U_Combining_Macron_Below",t[t.U_Combining_Low_Line=818]="U_Combining_Low_Line",t[t.U_Combining_Double_Low_Line=819]="U_Combining_Double_Low_Line",t[t.U_Combining_Tilde_Overlay=820]="U_Combining_Tilde_Overlay",t[t.U_Combining_Short_Stroke_Overlay=821]="U_Combining_Short_Stroke_Overlay",t[t.U_Combining_Long_Stroke_Overlay=822]="U_Combining_Long_Stroke_Overlay",t[t.U_Combining_Short_Solidus_Overlay=823]="U_Combining_Short_Solidus_Overlay",t[t.U_Combining_Long_Solidus_Overlay=824]="U_Combining_Long_Solidus_Overlay",t[t.U_Combining_Right_Half_Ring_Below=825]="U_Combining_Right_Half_Ring_Below",t[t.U_Combining_Inverted_Bridge_Below=826]="U_Combining_Inverted_Bridge_Below",t[t.U_Combining_Square_Below=827]="U_Combining_Square_Below",t[t.U_Combining_Seagull_Below=828]="U_Combining_Seagull_Below",t[t.U_Combining_X_Above=829]="U_Combining_X_Above",t[t.U_Combining_Vertical_Tilde=830]="U_Combining_Vertical_Tilde",t[t.U_Combining_Double_Overline=831]="U_Combining_Double_Overline",t[t.U_Combining_Grave_Tone_Mark=832]="U_Combining_Grave_Tone_Mark",t[t.U_Combining_Acute_Tone_Mark=833]="U_Combining_Acute_Tone_Mark",t[t.U_Combining_Greek_Perispomeni=834]="U_Combining_Greek_Perispomeni",t[t.U_Combining_Greek_Koronis=835]="U_Combining_Greek_Koronis",t[t.U_Combining_Greek_Dialytika_Tonos=836]="U_Combining_Greek_Dialytika_Tonos",t[t.U_Combining_Greek_Ypogegrammeni=837]="U_Combining_Greek_Ypogegrammeni",t[t.U_Combining_Bridge_Above=838]="U_Combining_Bridge_Above",t[t.U_Combining_Equals_Sign_Below=839]="U_Combining_Equals_Sign_Below",t[t.U_Combining_Double_Vertical_Line_Below=840]="U_Combining_Double_Vertical_Line_Below",t[t.U_Combining_Left_Angle_Below=841]="U_Combining_Left_Angle_Below",t[t.U_Combining_Not_Tilde_Above=842]="U_Combining_Not_Tilde_Above",t[t.U_Combining_Homothetic_Above=843]="U_Combining_Homothetic_Above",t[t.U_Combining_Almost_Equal_To_Above=844]="U_Combining_Almost_Equal_To_Above",t[t.U_Combining_Left_Right_Arrow_Below=845]="U_Combining_Left_Right_Arrow_Below",t[t.U_Combining_Upwards_Arrow_Below=846]="U_Combining_Upwards_Arrow_Below",t[t.U_Combining_Grapheme_Joiner=847]="U_Combining_Grapheme_Joiner",t[t.U_Combining_Right_Arrowhead_Above=848]="U_Combining_Right_Arrowhead_Above",t[t.U_Combining_Left_Half_Ring_Above=849]="U_Combining_Left_Half_Ring_Above",t[t.U_Combining_Fermata=850]="U_Combining_Fermata",t[t.U_Combining_X_Below=851]="U_Combining_X_Below",t[t.U_Combining_Left_Arrowhead_Below=852]="U_Combining_Left_Arrowhead_Below",t[t.U_Combining_Right_Arrowhead_Below=853]="U_Combining_Right_Arrowhead_Below",t[t.U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below=854]="U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below",t[t.U_Combining_Right_Half_Ring_Above=855]="U_Combining_Right_Half_Ring_Above",t[t.U_Combining_Dot_Above_Right=856]="U_Combining_Dot_Above_Right",t[t.U_Combining_Asterisk_Below=857]="U_Combining_Asterisk_Below",t[t.U_Combining_Double_Ring_Below=858]="U_Combining_Double_Ring_Below",t[t.U_Combining_Zigzag_Above=859]="U_Combining_Zigzag_Above",t[t.U_Combining_Double_Breve_Below=860]="U_Combining_Double_Breve_Below",t[t.U_Combining_Double_Breve=861]="U_Combining_Double_Breve",t[t.U_Combining_Double_Macron=862]="U_Combining_Double_Macron",t[t.U_Combining_Double_Macron_Below=863]="U_Combining_Double_Macron_Below",t[t.U_Combining_Double_Tilde=864]="U_Combining_Double_Tilde",t[t.U_Combining_Double_Inverted_Breve=865]="U_Combining_Double_Inverted_Breve",t[t.U_Combining_Double_Rightwards_Arrow_Below=866]="U_Combining_Double_Rightwards_Arrow_Below",t[t.U_Combining_Latin_Small_Letter_A=867]="U_Combining_Latin_Small_Letter_A",t[t.U_Combining_Latin_Small_Letter_E=868]="U_Combining_Latin_Small_Letter_E",t[t.U_Combining_Latin_Small_Letter_I=869]="U_Combining_Latin_Small_Letter_I",t[t.U_Combining_Latin_Small_Letter_O=870]="U_Combining_Latin_Small_Letter_O",t[t.U_Combining_Latin_Small_Letter_U=871]="U_Combining_Latin_Small_Letter_U",t[t.U_Combining_Latin_Small_Letter_C=872]="U_Combining_Latin_Small_Letter_C",t[t.U_Combining_Latin_Small_Letter_D=873]="U_Combining_Latin_Small_Letter_D",t[t.U_Combining_Latin_Small_Letter_H=874]="U_Combining_Latin_Small_Letter_H",t[t.U_Combining_Latin_Small_Letter_M=875]="U_Combining_Latin_Small_Letter_M",t[t.U_Combining_Latin_Small_Letter_R=876]="U_Combining_Latin_Small_Letter_R",t[t.U_Combining_Latin_Small_Letter_T=877]="U_Combining_Latin_Small_Letter_T",t[t.U_Combining_Latin_Small_Letter_V=878]="U_Combining_Latin_Small_Letter_V",t[t.U_Combining_Latin_Small_Letter_X=879]="U_Combining_Latin_Small_Letter_X",t[t.LINE_SEPARATOR=8232]="LINE_SEPARATOR",t[t.PARAGRAPH_SEPARATOR=8233]="PARAGRAPH_SEPARATOR",t[t.NEXT_LINE=133]="NEXT_LINE",t[t.U_CIRCUMFLEX=94]="U_CIRCUMFLEX",t[t.U_GRAVE_ACCENT=96]="U_GRAVE_ACCENT",t[t.U_DIAERESIS=168]="U_DIAERESIS",t[t.U_MACRON=175]="U_MACRON",t[t.U_ACUTE_ACCENT=180]="U_ACUTE_ACCENT",t[t.U_CEDILLA=184]="U_CEDILLA",t[t.U_MODIFIER_LETTER_LEFT_ARROWHEAD=706]="U_MODIFIER_LETTER_LEFT_ARROWHEAD",t[t.U_MODIFIER_LETTER_RIGHT_ARROWHEAD=707]="U_MODIFIER_LETTER_RIGHT_ARROWHEAD",t[t.U_MODIFIER_LETTER_UP_ARROWHEAD=708]="U_MODIFIER_LETTER_UP_ARROWHEAD",t[t.U_MODIFIER_LETTER_DOWN_ARROWHEAD=709]="U_MODIFIER_LETTER_DOWN_ARROWHEAD",t[t.U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING=722]="U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING",t[t.U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING=723]="U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING",t[t.U_MODIFIER_LETTER_UP_TACK=724]="U_MODIFIER_LETTER_UP_TACK",t[t.U_MODIFIER_LETTER_DOWN_TACK=725]="U_MODIFIER_LETTER_DOWN_TACK",t[t.U_MODIFIER_LETTER_PLUS_SIGN=726]="U_MODIFIER_LETTER_PLUS_SIGN",t[t.U_MODIFIER_LETTER_MINUS_SIGN=727]="U_MODIFIER_LETTER_MINUS_SIGN",t[t.U_BREVE=728]="U_BREVE",t[t.U_DOT_ABOVE=729]="U_DOT_ABOVE",t[t.U_RING_ABOVE=730]="U_RING_ABOVE",t[t.U_OGONEK=731]="U_OGONEK",t[t.U_SMALL_TILDE=732]="U_SMALL_TILDE",t[t.U_DOUBLE_ACUTE_ACCENT=733]="U_DOUBLE_ACUTE_ACCENT",t[t.U_MODIFIER_LETTER_RHOTIC_HOOK=734]="U_MODIFIER_LETTER_RHOTIC_HOOK",t[t.U_MODIFIER_LETTER_CROSS_ACCENT=735]="U_MODIFIER_LETTER_CROSS_ACCENT",t[t.U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR=741]="U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR",t[t.U_MODIFIER_LETTER_HIGH_TONE_BAR=742]="U_MODIFIER_LETTER_HIGH_TONE_BAR",t[t.U_MODIFIER_LETTER_MID_TONE_BAR=743]="U_MODIFIER_LETTER_MID_TONE_BAR",t[t.U_MODIFIER_LETTER_LOW_TONE_BAR=744]="U_MODIFIER_LETTER_LOW_TONE_BAR",t[t.U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR=745]="U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR",t[t.U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK=746]="U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK",t[t.U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK=747]="U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK",t[t.U_MODIFIER_LETTER_UNASPIRATED=749]="U_MODIFIER_LETTER_UNASPIRATED",t[t.U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD=751]="U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD",t[t.U_MODIFIER_LETTER_LOW_UP_ARROWHEAD=752]="U_MODIFIER_LETTER_LOW_UP_ARROWHEAD",t[t.U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD=753]="U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD",t[t.U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD=754]="U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD",t[t.U_MODIFIER_LETTER_LOW_RING=755]="U_MODIFIER_LETTER_LOW_RING",t[t.U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT=756]="U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT",t[t.U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT=757]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT",t[t.U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT=758]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT",t[t.U_MODIFIER_LETTER_LOW_TILDE=759]="U_MODIFIER_LETTER_LOW_TILDE",t[t.U_MODIFIER_LETTER_RAISED_COLON=760]="U_MODIFIER_LETTER_RAISED_COLON",t[t.U_MODIFIER_LETTER_BEGIN_HIGH_TONE=761]="U_MODIFIER_LETTER_BEGIN_HIGH_TONE",t[t.U_MODIFIER_LETTER_END_HIGH_TONE=762]="U_MODIFIER_LETTER_END_HIGH_TONE",t[t.U_MODIFIER_LETTER_BEGIN_LOW_TONE=763]="U_MODIFIER_LETTER_BEGIN_LOW_TONE",t[t.U_MODIFIER_LETTER_END_LOW_TONE=764]="U_MODIFIER_LETTER_END_LOW_TONE",t[t.U_MODIFIER_LETTER_SHELF=765]="U_MODIFIER_LETTER_SHELF",t[t.U_MODIFIER_LETTER_OPEN_SHELF=766]="U_MODIFIER_LETTER_OPEN_SHELF",t[t.U_MODIFIER_LETTER_LOW_LEFT_ARROW=767]="U_MODIFIER_LETTER_LOW_LEFT_ARROW",t[t.U_GREEK_LOWER_NUMERAL_SIGN=885]="U_GREEK_LOWER_NUMERAL_SIGN",t[t.U_GREEK_TONOS=900]="U_GREEK_TONOS",t[t.U_GREEK_DIALYTIKA_TONOS=901]="U_GREEK_DIALYTIKA_TONOS",t[t.U_GREEK_KORONIS=8125]="U_GREEK_KORONIS",t[t.U_GREEK_PSILI=8127]="U_GREEK_PSILI",t[t.U_GREEK_PERISPOMENI=8128]="U_GREEK_PERISPOMENI",t[t.U_GREEK_DIALYTIKA_AND_PERISPOMENI=8129]="U_GREEK_DIALYTIKA_AND_PERISPOMENI",t[t.U_GREEK_PSILI_AND_VARIA=8141]="U_GREEK_PSILI_AND_VARIA",t[t.U_GREEK_PSILI_AND_OXIA=8142]="U_GREEK_PSILI_AND_OXIA",t[t.U_GREEK_PSILI_AND_PERISPOMENI=8143]="U_GREEK_PSILI_AND_PERISPOMENI",t[t.U_GREEK_DASIA_AND_VARIA=8157]="U_GREEK_DASIA_AND_VARIA",t[t.U_GREEK_DASIA_AND_OXIA=8158]="U_GREEK_DASIA_AND_OXIA",t[t.U_GREEK_DASIA_AND_PERISPOMENI=8159]="U_GREEK_DASIA_AND_PERISPOMENI",t[t.U_GREEK_DIALYTIKA_AND_VARIA=8173]="U_GREEK_DIALYTIKA_AND_VARIA",t[t.U_GREEK_DIALYTIKA_AND_OXIA=8174]="U_GREEK_DIALYTIKA_AND_OXIA",t[t.U_GREEK_VARIA=8175]="U_GREEK_VARIA",t[t.U_GREEK_OXIA=8189]="U_GREEK_OXIA",t[t.U_GREEK_DASIA=8190]="U_GREEK_DASIA",t[t.U_IDEOGRAPHIC_FULL_STOP=12290]="U_IDEOGRAPHIC_FULL_STOP",t[t.U_LEFT_CORNER_BRACKET=12300]="U_LEFT_CORNER_BRACKET",t[t.U_RIGHT_CORNER_BRACKET=12301]="U_RIGHT_CORNER_BRACKET",t[t.U_LEFT_BLACK_LENTICULAR_BRACKET=12304]="U_LEFT_BLACK_LENTICULAR_BRACKET",t[t.U_RIGHT_BLACK_LENTICULAR_BRACKET=12305]="U_RIGHT_BLACK_LENTICULAR_BRACKET",t[t.U_OVERLINE=8254]="U_OVERLINE",t[t.UTF8_BOM=65279]="UTF8_BOM",t[t.U_FULLWIDTH_SEMICOLON=65307]="U_FULLWIDTH_SEMICOLON",t[t.U_FULLWIDTH_COMMA=65292]="U_FULLWIDTH_COMMA"})(p||(e.CharCode=p={}))}),define(Ee[39],pe([0,1]),function(ce,e){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.SetWithKey=void 0,e.groupBy=t,e.diffSets=$,e.diffMaps=W,e.intersection=V;function t(T,P){const N=Object.create(null);for(const E of T){const y=P(E);let M=N[y];M||(M=N[y]=[]),M.push(E)}return N}function $(T,P){const N=[],E=[];for(const y of T)P.has(y)||N.push(y);for(const y of P)T.has(y)||E.push(y);return{removed:N,added:E}}function W(T,P){const N=[],E=[];for(const[y,M]of T)P.has(y)||N.push(M);for(const[y,M]of P)T.has(y)||E.push(M);return{removed:N,added:E}}function V(T,P){const N=new Set;for(const E of P)T.has(E)&&N.add(E);return N}class k{static{p=Symbol.toStringTag}constructor(P,N){this.toKey=N,this._map=new Map,this[p]="SetWithKey";for(const E of P)this.add(E)}get size(){return this._map.size}add(P){const N=this.toKey(P);return this._map.set(N,P),this}delete(P){return this._map.delete(this.toKey(P))}has(P){return this._map.has(this.toKey(P))}*entries(){for(const P of this._map.values())yield[P,P]}keys(){return this.values()}*values(){for(const P of this._map.values())yield P}clear(){this._map.clear()}forEach(P,N){this._map.forEach(E=>P.call(N,E,E,this))}[Symbol.iterator](){return this.values()}}e.SetWithKey=k}),define(Ee[40],pe([0,1]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.memoize=t,e.debounce=$,e.throttle=W;function p(V){return(k,T,P)=>{let N=null,E=null;if(typeof P.value=="function"?(N="value",E=P.value):typeof P.get=="function"&&(N="get",E=P.get),!E)throw new Error("not supported");P[N]=V(E,T)}}function t(V,k,T){let P=null,N=null;if(typeof T.value=="function"?(P="value",N=T.value,N.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof T.get=="function"&&(P="get",N=T.get),!N)throw new Error("not supported");const E=`$memoize$${k}`;T[P]=function(...y){return this.hasOwnProperty(E)||Object.defineProperty(this,E,{configurable:!1,enumerable:!1,writable:!1,value:N.apply(this,y)}),this[E]}}function $(V,k,T){return p((P,N)=>{const E=`$debounce$${N}`,y=`$debounce$result$${N}`;return function(...M){this[y]||(this[y]=T?T():void 0),clearTimeout(this[E]),k&&(this[y]=k(this[y],...M),M=[this[y]]),this[E]=setTimeout(()=>{P.apply(this,M),this[y]=T?T():void 0},V)}})}function W(V,k,T){return p((P,N)=>{const E=`$throttle$timer$${N}`,y=`$throttle$result$${N}`,M=`$throttle$lastRun$${N}`,a=`$throttle$pending$${N}`;return function(...r){if(this[y]||(this[y]=T?T():void 0),(this[M]===null||this[M]===void 0)&&(this[M]=-Number.MAX_VALUE),k&&(this[y]=k(this[y],...r)),this[a])return;const d=this[M]+V;d<=Date.now()?(this[M]=Date.now(),P.apply(this,[this[y]]),this[y]=T?T():void 0):(this[a]=!0,this[E]=setTimeout(()=>{this[a]=!1,this[M]=Date.now(),P.apply(this,[this[y]]),this[y]=T?T():void 0},d-Date.now()))}})}}),define(Ee[9],pe([0,1]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.ReadonlyError=e.CancellationError=e.errorHandler=e.ErrorHandler=void 0,e.setUnexpectedErrorHandler=t,e.isSigPipeError=$,e.onUnexpectedError=W,e.onUnexpectedExternalError=V,e.transformErrorForSerialization=k,e.transformErrorFromSerialization=T,e.isCancellationError=N,e.canceled=y,e.illegalArgument=M,e.illegalState=a,e.getErrorMessage=d;class p{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(i){setTimeout(()=>{throw i.stack?w.isErrorNoTelemetry(i)?new w(i.message+`

`+i.stack):new Error(i.message+`

`+i.stack):i},0)}}addListener(i){return this.listeners.push(i),()=>{this._removeListener(i)}}emit(i){this.listeners.forEach(s=>{s(i)})}_removeListener(i){this.listeners.splice(this.listeners.indexOf(i),1)}setUnexpectedErrorHandler(i){this.unexpectedErrorHandler=i}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(i){this.unexpectedErrorHandler(i),this.emit(i)}onUnexpectedExternalError(i){this.unexpectedErrorHandler(i)}}e.ErrorHandler=p,e.errorHandler=new p;function t(n){e.errorHandler.setUnexpectedErrorHandler(n)}function $(n){if(!n||typeof n!="object")return!1;const i=n;return i.code==="EPIPE"&&i.syscall?.toUpperCase()==="WRITE"}function W(n){N(n)||e.errorHandler.onUnexpectedError(n)}function V(n){N(n)||e.errorHandler.onUnexpectedExternalError(n)}function k(n){if(n instanceof Error){const{name:i,message:s}=n,o=n.stacktrace||n.stack;return{$isError:!0,name:i,message:s,stack:o,noTelemetry:w.isErrorNoTelemetry(n)}}return n}function T(n){let i;return n.noTelemetry?i=new w:(i=new Error,i.name=n.name),i.message=n.message,i.stack=n.stack,i}const P="Canceled";function N(n){return n instanceof E?!0:n instanceof Error&&n.name===P&&n.message===P}class E extends Error{constructor(){super(P),this.name=this.message}}e.CancellationError=E;function y(){const n=new Error(P);return n.name=n.message,n}function M(n){return n?new Error(`Illegal argument: ${n}`):new Error("Illegal argument")}function a(n){return n?new Error(`Illegal state: ${n}`):new Error("Illegal state")}class r extends TypeError{constructor(i){super(i?`${i} is read-only and cannot be changed`:"Cannot change read-only property")}}e.ReadonlyError=r;function d(n){return n?n.message?n.message:n.stack?n.stack.split(`
`)[0]:String(n):"Error"}class b extends Error{constructor(i){super("NotImplemented"),i&&(this.message=i)}}e.NotImplementedError=b;class c extends Error{constructor(i){super("NotSupported"),i&&(this.message=i)}}e.NotSupportedError=c;class v extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.ExpectedError=v;class w extends Error{constructor(i){super(i),this.name="CodeExpectedError"}static fromError(i){if(i instanceof w)return i;const s=new w;return s.message=i.message,s.stack=i.stack,s}static isErrorNoTelemetry(i){return i.name==="CodeExpectedError"}}e.ErrorNoTelemetry=w;class l extends Error{constructor(i){super(i||"An unexpected bug occurred."),Object.setPrototypeOf(this,l.prototype)}}e.BugIndicatingError=l}),define(Ee[12],pe([0,1,9,38]),function(ce,e,p,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Permutation=e.CallbackIterable=e.ArrayQueue=e.booleanComparator=e.numberComparator=e.CompareResult=void 0,e.tail=$,e.tail2=W,e.equals=V,e.removeFastWithoutKeepingOrder=k,e.binarySearch=T,e.binarySearch2=P,e.quickSelect=N,e.groupBy=E,e.groupAdjacentBy=y,e.forEachAdjacent=M,e.forEachWithNeighbors=a,e.sortedDiff=r,e.delta=d,e.top=b,e.topAsync=c,e.coalesce=w,e.coalesceInPlace=l,e.move=n,e.isFalsyOrEmpty=i,e.isNonEmptyArray=s,e.distinct=o,e.uniqueFilter=U,e.firstOrDefault=_,e.lastOrDefault=m,e.commonPrefixLength=f,e.range=A,e.index=R,e.insert=u,e.remove=D,e.arrayInsert=C,e.shuffle=x,e.pushToStart=X,e.pushToEnd=H,e.pushMany=se,e.mapArrayOrNot=K,e.asArray=ie,e.getRandomElement=re,e.insertInto=oe,e.splice=I,e.compareBy=j,e.tieBreakComparators=Y,e.reverseOrder=ee,e.findAsync=we;function $(B,z=0){return B[B.length-(1+z)]}function W(B){if(B.length===0)throw new Error("Invalid tail call");return[B.slice(0,B.length-1),B[B.length-1]]}function V(B,z,O=(h,q)=>h===q){if(B===z)return!0;if(!B||!z||B.length!==z.length)return!1;for(let h=0,q=B.length;h<q;h++)if(!O(B[h],z[h]))return!1;return!0}function k(B,z){const O=B.length-1;z<O&&(B[z]=B[O]),B.pop()}function T(B,z,O){return P(B.length,h=>O(B[h],z))}function P(B,z){let O=0,h=B-1;for(;O<=h;){const q=(O+h)/2|0,Q=z(q);if(Q<0)O=q+1;else if(Q>0)h=q-1;else return q}return-(O+1)}function N(B,z,O){if(B=B|0,B>=z.length)throw new TypeError("invalid index");const h=z[Math.floor(z.length*Math.random())],q=[],Q=[],te=[];for(const de of z){const ye=O(de,h);ye<0?q.push(de):ye>0?Q.push(de):te.push(de)}return B<q.length?N(B,q,O):B<q.length+te.length?te[0]:N(B-(q.length+te.length),Q,O)}function E(B,z){const O=[];let h;for(const q of B.slice(0).sort(z))!h||z(h[0],q)!==0?(h=[q],O.push(h)):h.push(q);return O}function*y(B,z){let O,h;for(const q of B)h!==void 0&&z(h,q)?O.push(q):(O&&(yield O),O=[q]),h=q;O&&(yield O)}function M(B,z){for(let O=0;O<=B.length;O++)z(O===0?void 0:B[O-1],O===B.length?void 0:B[O])}function a(B,z){for(let O=0;O<B.length;O++)z(O===0?void 0:B[O-1],B[O],O+1===B.length?void 0:B[O+1])}function r(B,z,O){const h=[];function q(de,ye,Le){if(ye===0&&Le.length===0)return;const Se=h[h.length-1];Se&&Se.start+Se.deleteCount===de?(Se.deleteCount+=ye,Se.toInsert.push(...Le)):h.push({start:de,deleteCount:ye,toInsert:Le})}let Q=0,te=0;for(;;){if(Q===B.length){q(Q,0,z.slice(te));break}if(te===z.length){q(Q,B.length-Q,[]);break}const de=B[Q],ye=z[te],Le=O(de,ye);Le===0?(Q+=1,te+=1):Le<0?(q(Q,1,[]),Q+=1):Le>0&&(q(Q,0,[ye]),te+=1)}return h}function d(B,z,O){const h=r(B,z,O),q=[],Q=[];for(const te of h)q.push(...B.slice(te.start,te.start+te.deleteCount)),Q.push(...te.toInsert);return{removed:q,added:Q}}function b(B,z,O){if(O===0)return[];const h=B.slice(0,O).sort(z);return v(B,z,h,O,B.length),h}function c(B,z,O,h,q){return O===0?Promise.resolve([]):new Promise((Q,te)=>{(async()=>{const de=B.length,ye=B.slice(0,O).sort(z);for(let Le=O,Se=Math.min(O+h,de);Le<de;Le=Se,Se=Math.min(Se+h,de)){if(Le>O&&await new Promise(ge=>setTimeout(ge)),q&&q.isCancellationRequested)throw new p.CancellationError;v(B,z,ye,Le,Se)}return ye})().then(Q,te)})}function v(B,z,O,h,q){for(const Q=O.length;h<q;h++){const te=B[h];if(z(te,O[Q-1])<0){O.pop();const de=(0,t.findFirstIdxMonotonousOrArrLen)(O,ye=>z(te,ye)<0);O.splice(de,0,te)}}}function w(B){return B.filter(z=>!!z)}function l(B){let z=0;for(let O=0;O<B.length;O++)B[O]&&(B[z]=B[O],z+=1);B.length=z}function n(B,z,O){B.splice(O,0,B.splice(z,1)[0])}function i(B){return!Array.isArray(B)||B.length===0}function s(B){return Array.isArray(B)&&B.length>0}function o(B,z=O=>O){const O=new Set;return B.filter(h=>{const q=z(h);return O.has(q)?!1:(O.add(q),!0)})}function U(B){const z=new Set;return O=>{const h=B(O);return z.has(h)?!1:(z.add(h),!0)}}function _(B,z){return B.length>0?B[0]:z}function m(B,z){return B.length>0?B[B.length-1]:z}function f(B,z,O=(h,q)=>h===q){let h=0;for(let q=0,Q=Math.min(B.length,z.length);q<Q&&O(B[q],z[q]);q++)h++;return h}function A(B,z){let O=typeof z=="number"?B:0;typeof z=="number"?O=B:(O=0,z=B);const h=[];if(O<=z)for(let q=O;q<z;q++)h.push(q);else for(let q=O;q>z;q--)h.push(q);return h}function R(B,z,O){return B.reduce((h,q)=>(h[z(q)]=O?O(q):q,h),Object.create(null))}function u(B,z){return B.push(z),()=>D(B,z)}function D(B,z){const O=B.indexOf(z);if(O>-1)return B.splice(O,1),z}function C(B,z,O){const h=B.slice(0,z),q=B.slice(z);return h.concat(O,q)}function x(B,z){let O;if(typeof z=="number"){let h=z;O=()=>{const q=Math.sin(h++)*179426549;return q-Math.floor(q)}}else O=Math.random;for(let h=B.length-1;h>0;h-=1){const q=Math.floor(O()*(h+1)),Q=B[h];B[h]=B[q],B[q]=Q}}function X(B,z){const O=B.indexOf(z);O>-1&&(B.splice(O,1),B.unshift(z))}function H(B,z){const O=B.indexOf(z);O>-1&&(B.splice(O,1),B.push(z))}function se(B,z){for(const O of z)B.push(O)}function K(B,z){return Array.isArray(B)?B.map(z):z(B)}function ie(B){return Array.isArray(B)?B:[B]}function re(B){return B[Math.floor(Math.random()*B.length)]}function oe(B,z,O){const h=g(B,z),q=B.length,Q=O.length;B.length=q+Q;for(let te=q-1;te>=h;te--)B[te+Q]=B[te];for(let te=0;te<Q;te++)B[te+h]=O[te]}function I(B,z,O,h){const q=g(B,z);let Q=B.splice(q,O);return Q===void 0&&(Q=[]),oe(B,q,h),Q}function g(B,z){return z<0?Math.max(z+B.length,0):Math.min(z,B.length)}var F;(function(B){function z(Q){return Q<0}B.isLessThan=z;function O(Q){return Q<=0}B.isLessThanOrEqual=O;function h(Q){return Q>0}B.isGreaterThan=h;function q(Q){return Q===0}B.isNeitherLessOrGreaterThan=q,B.greaterThan=1,B.lessThan=-1,B.neitherLessOrGreaterThan=0})(F||(e.CompareResult=F={}));function j(B,z){return(O,h)=>z(B(O),B(h))}function Y(...B){return(z,O)=>{for(const h of B){const q=h(z,O);if(!F.isNeitherLessOrGreaterThan(q))return q}return F.neitherLessOrGreaterThan}}const L=(B,z)=>B-z;e.numberComparator=L;const J=(B,z)=>(0,e.numberComparator)(B?1:0,z?1:0);e.booleanComparator=J;function ee(B){return(z,O)=>-B(z,O)}class ne{constructor(z){this.items=z,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(z){let O=this.firstIdx;for(;O<this.items.length&&z(this.items[O]);)O++;const h=O===this.firstIdx?null:this.items.slice(this.firstIdx,O);return this.firstIdx=O,h}takeFromEndWhile(z){let O=this.lastIdx;for(;O>=0&&z(this.items[O]);)O--;const h=O===this.lastIdx?null:this.items.slice(O+1,this.lastIdx+1);return this.lastIdx=O,h}peek(){if(this.length!==0)return this.items[this.firstIdx]}peekLast(){if(this.length!==0)return this.items[this.lastIdx]}dequeue(){const z=this.items[this.firstIdx];return this.firstIdx++,z}removeLast(){const z=this.items[this.lastIdx];return this.lastIdx--,z}takeCount(z){const O=this.items.slice(this.firstIdx,this.firstIdx+z);return this.firstIdx+=z,O}}e.ArrayQueue=ne;class le{static{this.empty=new le(z=>{})}constructor(z){this.iterate=z}forEach(z){this.iterate(O=>(z(O),!0))}toArray(){const z=[];return this.iterate(O=>(z.push(O),!0)),z}filter(z){return new le(O=>this.iterate(h=>z(h)?O(h):!0))}map(z){return new le(O=>this.iterate(h=>O(z(h))))}some(z){let O=!1;return this.iterate(h=>(O=z(h),!O)),O}findFirst(z){let O;return this.iterate(h=>z(h)?(O=h,!1):!0),O}findLast(z){let O;return this.iterate(h=>(z(h)&&(O=h),!0)),O}findLastMaxBy(z){let O,h=!0;return this.iterate(q=>((h||F.isGreaterThan(z(q,O)))&&(h=!1,O=q),!0)),O}}e.CallbackIterable=le;class fe{constructor(z){this._indexMap=z}static createSortPermutation(z,O){const h=Array.from(z.keys()).sort((q,Q)=>O(z[q],z[Q]));return new fe(h)}apply(z){return z.map((O,h)=>z[this._indexMap[h]])}inverse(){const z=this._indexMap.slice();for(let O=0;O<this._indexMap.length;O++)z[this._indexMap[O]]=O;return new fe(z)}}e.Permutation=fe;async function we(B,z){return(await Promise.all(B.map(async(h,q)=>({element:h,ok:await z(h,q)})))).find(h=>h.ok)?.element}}),define(Ee[27],pe([0,1]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createSingleCallFunction=p;function p(t,$){const W=this;let V=!1,k;return function(){if(V)return k;if(V=!0,$)try{k=t.apply(W,arguments)}finally{$()}else k=t.apply(W,arguments);return k}}}),define(Ee[41],pe([0,1]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var p;(function(t){function $(i){return i&&typeof i=="object"&&typeof i[Symbol.iterator]=="function"}t.is=$;const W=Object.freeze([]);function V(){return W}t.empty=V;function*k(i){yield i}t.single=k;function T(i){return $(i)?i:k(i)}t.wrap=T;function P(i){return i||W}t.from=P;function*N(i){for(let s=i.length-1;s>=0;s--)yield i[s]}t.reverse=N;function E(i){return!i||i[Symbol.iterator]().next().done===!0}t.isEmpty=E;function y(i){return i[Symbol.iterator]().next().value}t.first=y;function M(i,s){let o=0;for(const U of i)if(s(U,o++))return!0;return!1}t.some=M;function a(i,s){for(const o of i)if(s(o))return o}t.find=a;function*r(i,s){for(const o of i)s(o)&&(yield o)}t.filter=r;function*d(i,s){let o=0;for(const U of i)yield s(U,o++)}t.map=d;function*b(i,s){let o=0;for(const U of i)yield*s(U,o++)}t.flatMap=b;function*c(...i){for(const s of i)yield*s}t.concat=c;function v(i,s,o){let U=o;for(const _ of i)U=s(U,_);return U}t.reduce=v;function*w(i,s,o=i.length){for(s<0&&(s+=i.length),o<0?o+=i.length:o>i.length&&(o=i.length);s<o;s++)yield i[s]}t.slice=w;function l(i,s=Number.POSITIVE_INFINITY){const o=[];if(s===0)return[o,i];const U=i[Symbol.iterator]();for(let _=0;_<s;_++){const m=U.next();if(m.done)return[o,t.empty()];o.push(m.value)}return[o,{[Symbol.iterator](){return U}}]}t.consume=l;async function n(i){const s=[];for await(const o of i)s.push(o);return Promise.resolve(s)}t.asyncToArray=n})(p||(e.Iterable=p={}))}),define(Ee[16],pe([0,1]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class p{constructor($){this.executor=$,this._didRun=!1}get hasValue(){return this._didRun}get value(){if(!this._didRun)try{this._value=this.executor()}catch($){this._error=$}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}}e.Lazy=p}),define(Ee[42],pe([0,1]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class p{static{this.Undefined=new p(void 0)}constructor(W){this.element=W,this.next=p.Undefined,this.prev=p.Undefined}}class t{constructor(){this._first=p.Undefined,this._last=p.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===p.Undefined}clear(){let W=this._first;for(;W!==p.Undefined;){const V=W.next;W.prev=p.Undefined,W.next=p.Undefined,W=V}this._first=p.Undefined,this._last=p.Undefined,this._size=0}unshift(W){return this._insert(W,!1)}push(W){return this._insert(W,!0)}_insert(W,V){const k=new p(W);if(this._first===p.Undefined)this._first=k,this._last=k;else if(V){const P=this._last;this._last=k,k.prev=P,P.next=k}else{const P=this._first;this._first=k,k.next=P,P.prev=k}this._size+=1;let T=!1;return()=>{T||(T=!0,this._remove(k))}}shift(){if(this._first!==p.Undefined){const W=this._first.element;return this._remove(this._first),W}}pop(){if(this._last!==p.Undefined){const W=this._last.element;return this._remove(this._last),W}}_remove(W){if(W.prev!==p.Undefined&&W.next!==p.Undefined){const V=W.prev;V.next=W.next,W.next.prev=V}else W.prev===p.Undefined&&W.next===p.Undefined?(this._first=p.Undefined,this._last=p.Undefined):W.next===p.Undefined?(this._last=this._last.prev,this._last.next=p.Undefined):W.prev===p.Undefined&&(this._first=this._first.next,this._first.prev=p.Undefined);this._size-=1}*[Symbol.iterator](){let W=this._first;for(;W!==p.Undefined;)yield W.element,W=W.next}}e.LinkedList=t}),define(Ee[20],pe([0,1]),function(ce,e){"use strict";var p,t,$;Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.BidirectionalMap=e.CounterSet=e.MRUCache=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=void 0,e.getOrSet=W,e.mapToString=V,e.setToString=k,e.mapsStrictEqualIgnoreOrder=w;function W(l,n,i){let s=l.get(n);return s===void 0&&(s=i,l.set(n,s)),s}function V(l){const n=[];return l.forEach((i,s)=>{n.push(`${s} => ${i}`)}),`Map(${l.size}) {${n.join(", ")}}`}function k(l){const n=[];return l.forEach(i=>{n.push(i)}),`Set(${l.size}) {${n.join(", ")}}`}class T{constructor(n,i){this.uri=n,this.value=i}}function P(l){return Array.isArray(l)}class N{static{this.defaultToKey=n=>n.toString()}constructor(n,i){if(this[p]="ResourceMap",n instanceof N)this.map=new Map(n.map),this.toKey=i??N.defaultToKey;else if(P(n)){this.map=new Map,this.toKey=i??N.defaultToKey;for(const[s,o]of n)this.set(s,o)}else this.map=new Map,this.toKey=n??N.defaultToKey}set(n,i){return this.map.set(this.toKey(n),new T(n,i)),this}get(n){return this.map.get(this.toKey(n))?.value}has(n){return this.map.has(this.toKey(n))}get size(){return this.map.size}clear(){this.map.clear()}delete(n){return this.map.delete(this.toKey(n))}forEach(n,i){typeof i<"u"&&(n=n.bind(i));for(const[s,o]of this.map)n(o.value,o.uri,this)}*values(){for(const n of this.map.values())yield n.value}*keys(){for(const n of this.map.values())yield n.uri}*entries(){for(const n of this.map.values())yield[n.uri,n.value]}*[(p=Symbol.toStringTag,Symbol.iterator)](){for(const[,n]of this.map)yield[n.uri,n.value]}}e.ResourceMap=N;class E{constructor(n,i){this[t]="ResourceSet",!n||typeof n=="function"?this._map=new N(n):(this._map=new N(i),n.forEach(this.add,this))}get size(){return this._map.size}add(n){return this._map.set(n,n),this}clear(){this._map.clear()}delete(n){return this._map.delete(n)}forEach(n,i){this._map.forEach((s,o)=>n.call(i,o,o,this))}has(n){return this._map.has(n)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(t=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=E;var y;(function(l){l[l.None=0]="None",l[l.AsOld=1]="AsOld",l[l.AsNew=2]="AsNew"})(y||(e.Touch=y={}));class M{constructor(){this[$]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(n){return this._map.has(n)}get(n,i=y.None){const s=this._map.get(n);if(s)return i!==y.None&&this.touch(s,i),s.value}set(n,i,s=y.None){let o=this._map.get(n);if(o)o.value=i,s!==y.None&&this.touch(o,s);else{switch(o={key:n,value:i,next:void 0,previous:void 0},s){case y.None:this.addItemLast(o);break;case y.AsOld:this.addItemFirst(o);break;case y.AsNew:this.addItemLast(o);break;default:this.addItemLast(o);break}this._map.set(n,o),this._size++}return this}delete(n){return!!this.remove(n)}remove(n){const i=this._map.get(n);if(i)return this._map.delete(n),this.removeItem(i),this._size--,i.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const n=this._head;return this._map.delete(n.key),this.removeItem(n),this._size--,n.value}forEach(n,i){const s=this._state;let o=this._head;for(;o;){if(i?n.bind(i)(o.value,o.key,this):n(o.value,o.key,this),this._state!==s)throw new Error("LinkedMap got modified during iteration.");o=o.next}}keys(){const n=this,i=this._state;let s=this._head;const o={[Symbol.iterator](){return o},next(){if(n._state!==i)throw new Error("LinkedMap got modified during iteration.");if(s){const U={value:s.key,done:!1};return s=s.next,U}else return{value:void 0,done:!0}}};return o}values(){const n=this,i=this._state;let s=this._head;const o={[Symbol.iterator](){return o},next(){if(n._state!==i)throw new Error("LinkedMap got modified during iteration.");if(s){const U={value:s.value,done:!1};return s=s.next,U}else return{value:void 0,done:!0}}};return o}entries(){const n=this,i=this._state;let s=this._head;const o={[Symbol.iterator](){return o},next(){if(n._state!==i)throw new Error("LinkedMap got modified during iteration.");if(s){const U={value:[s.key,s.value],done:!1};return s=s.next,U}else return{value:void 0,done:!0}}};return o}[($=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(n){if(n>=this.size)return;if(n===0){this.clear();return}let i=this._head,s=this.size;for(;i&&s>n;)this._map.delete(i.key),i=i.next,s--;this._head=i,this._size=s,i&&(i.previous=void 0),this._state++}trimNew(n){if(n>=this.size)return;if(n===0){this.clear();return}let i=this._tail,s=this.size;for(;i&&s>n;)this._map.delete(i.key),i=i.previous,s--;this._tail=i,this._size=s,i&&(i.next=void 0),this._state++}addItemFirst(n){if(!this._head&&!this._tail)this._tail=n;else if(this._head)n.next=this._head,this._head.previous=n;else throw new Error("Invalid list");this._head=n,this._state++}addItemLast(n){if(!this._head&&!this._tail)this._head=n;else if(this._tail)n.previous=this._tail,this._tail.next=n;else throw new Error("Invalid list");this._tail=n,this._state++}removeItem(n){if(n===this._head&&n===this._tail)this._head=void 0,this._tail=void 0;else if(n===this._head){if(!n.next)throw new Error("Invalid list");n.next.previous=void 0,this._head=n.next}else if(n===this._tail){if(!n.previous)throw new Error("Invalid list");n.previous.next=void 0,this._tail=n.previous}else{const i=n.next,s=n.previous;if(!i||!s)throw new Error("Invalid list");i.previous=s,s.next=i}n.next=void 0,n.previous=void 0,this._state++}touch(n,i){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(i!==y.AsOld&&i!==y.AsNew)){if(i===y.AsOld){if(n===this._head)return;const s=n.next,o=n.previous;n===this._tail?(o.next=void 0,this._tail=o):(s.previous=o,o.next=s),n.previous=void 0,n.next=this._head,this._head.previous=n,this._head=n,this._state++}else if(i===y.AsNew){if(n===this._tail)return;const s=n.next,o=n.previous;n===this._head?(s.previous=void 0,this._head=s):(s.previous=o,o.next=s),n.next=void 0,n.previous=this._tail,this._tail.next=n,this._tail=n,this._state++}}}toJSON(){const n=[];return this.forEach((i,s)=>{n.push([s,i])}),n}fromJSON(n){this.clear();for(const[i,s]of n)this.set(i,s)}}e.LinkedMap=M;class a extends M{constructor(n,i=1){super(),this._limit=n,this._ratio=Math.min(Math.max(0,i),1)}get limit(){return this._limit}set limit(n){this._limit=n,this.checkTrim()}get ratio(){return this._ratio}set ratio(n){this._ratio=Math.min(Math.max(0,n),1),this.checkTrim()}get(n,i=y.AsNew){return super.get(n,i)}peek(n){return super.get(n,y.None)}set(n,i){return super.set(n,i,y.AsNew),this}checkTrim(){this.size>this._limit&&this.trim(Math.round(this._limit*this._ratio))}}class r extends a{constructor(n,i=1){super(n,i)}trim(n){this.trimOld(n)}set(n,i){return super.set(n,i),this.checkTrim(),this}}e.LRUCache=r;class d extends a{constructor(n,i=1){super(n,i)}trim(n){this.trimNew(n)}set(n,i){return this._limit<=this.size&&!this.has(n)&&this.trim(Math.round(this._limit*this._ratio)-1),super.set(n,i),this}}e.MRUCache=d;class b{constructor(){this.map=new Map}add(n){return this.map.set(n,(this.map.get(n)||0)+1),this}delete(n){let i=this.map.get(n)||0;return i===0?!1:(i--,i===0?this.map.delete(n):this.map.set(n,i),!0)}has(n){return this.map.has(n)}}e.CounterSet=b;class c{constructor(n){if(this._m1=new Map,this._m2=new Map,n)for(const[i,s]of n)this.set(i,s)}clear(){this._m1.clear(),this._m2.clear()}set(n,i){this._m1.set(n,i),this._m2.set(i,n)}get(n){return this._m1.get(n)}getKey(n){return this._m2.get(n)}delete(n){const i=this._m1.get(n);return i===void 0?!1:(this._m1.delete(n),this._m2.delete(i),!0)}forEach(n,i){this._m1.forEach((s,o)=>{n.call(i,s,o,this)})}keys(){return this._m1.keys()}values(){return this._m1.values()}}e.BidirectionalMap=c;class v{constructor(){this.map=new Map}add(n,i){let s=this.map.get(n);s||(s=new Set,this.map.set(n,s)),s.add(i)}delete(n,i){const s=this.map.get(n);s&&(s.delete(i),s.size===0&&this.map.delete(n))}forEach(n,i){const s=this.map.get(n);s&&s.forEach(i)}get(n){const i=this.map.get(n);return i||new Set}}e.SetMap=v;function w(l,n){if(l===n)return!0;if(l.size!==n.size)return!1;for(const[i,s]of l)if(!n.has(i)||n.get(i)!==s)return!1;for(const[i]of n)if(!l.has(i))return!1;return!0}}),define(Ee[4],pe([0,1,12,39,20,27,41]),function(ce,e,p,t,$,W,V){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DisposableMap=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MandatoryMutableDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.DisposableTracker=void 0,e.setDisposableTracker=N,e.trackDisposable=E,e.markAsDisposed=y,e.markAsSingleton=r,e.isDisposable=d,e.dispose=b,e.disposeIfDisposable=c,e.combinedDisposable=v,e.toDisposable=w,e.disposeOnReturn=A;const k=!1;let T=null;class P{constructor(){this.livingDisposables=new Map}static{this.idx=0}getDisposableData(D){let C=this.livingDisposables.get(D);return C||(C={parent:null,source:null,isSingleton:!1,value:D,idx:P.idx++},this.livingDisposables.set(D,C)),C}trackDisposable(D){const C=this.getDisposableData(D);C.source||(C.source=new Error().stack)}setParent(D,C){const x=this.getDisposableData(D);x.parent=C}markAsDisposed(D){this.livingDisposables.delete(D)}markAsSingleton(D){this.getDisposableData(D).isSingleton=!0}getRootParent(D,C){const x=C.get(D);if(x)return x;const X=D.parent?this.getRootParent(this.getDisposableData(D.parent),C):D;return C.set(D,X),X}getTrackedDisposables(){const D=new Map;return[...this.livingDisposables.entries()].filter(([,x])=>x.source!==null&&!this.getRootParent(x,D).isSingleton).flatMap(([x])=>x)}computeLeakingDisposables(D=10,C){let x;if(C)x=C;else{const ie=new Map,re=[...this.livingDisposables.values()].filter(I=>I.source!==null&&!this.getRootParent(I,ie).isSingleton);if(re.length===0)return;const oe=new Set(re.map(I=>I.value));if(x=re.filter(I=>!(I.parent&&oe.has(I.parent))),x.length===0)throw new Error("There are cyclic diposable chains!")}if(!x)return;function X(ie){function re(I,g){for(;I.length>0&&g.some(F=>typeof F=="string"?F===I[0]:I[0].match(F));)I.shift()}const oe=ie.source.split(`
`).map(I=>I.trim().replace("at ","")).filter(I=>I!=="");return re(oe,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),oe.reverse()}const H=new $.SetMap;for(const ie of x){const re=X(ie);for(let oe=0;oe<=re.length;oe++)H.add(re.slice(0,oe).join(`
`),ie)}x.sort((0,p.compareBy)(ie=>ie.idx,p.numberComparator));let se="",K=0;for(const ie of x.slice(0,D)){K++;const re=X(ie),oe=[];for(let I=0;I<re.length;I++){let g=re[I];g=`(shared with ${H.get(re.slice(0,I+1).join(`
`)).size}/${x.length} leaks) at ${g}`;const j=H.get(re.slice(0,I).join(`
`)),Y=(0,t.groupBy)([...j].map(L=>X(L)[I]),L=>L);delete Y[re[I]];for(const[L,J]of Object.entries(Y))oe.unshift(`    - stacktraces of ${J.length} other leaks continue with ${L}`);oe.unshift(g)}se+=`


==================== Leaking disposable ${K}/${x.length}: ${ie.value.constructor.name} ====================
${oe.join(`
`)}
============================================================

`}return x.length>D&&(se+=`


... and ${x.length-D} more leaking disposables

`),{leaks:x,details:se}}}e.DisposableTracker=P;function N(u){T=u}if(k){const u="__is_disposable_tracked__";N(new class{trackDisposable(D){const C=new Error("Potentially leaked disposable").stack;setTimeout(()=>{D[u]||console.log(C)},3e3)}setParent(D,C){if(D&&D!==n.None)try{D[u]=!0}catch{}}markAsDisposed(D){if(D&&D!==n.None)try{D[u]=!0}catch{}}markAsSingleton(D){}})}function E(u){return T?.trackDisposable(u),u}function y(u){T?.markAsDisposed(u)}function M(u,D){T?.setParent(u,D)}function a(u,D){if(T)for(const C of u)T.setParent(C,D)}function r(u){return T?.markAsSingleton(u),u}function d(u){return typeof u=="object"&&u!==null&&typeof u.dispose=="function"&&u.dispose.length===0}function b(u){if(V.Iterable.is(u)){const D=[];for(const C of u)if(C)try{C.dispose()}catch(x){D.push(x)}if(D.length===1)throw D[0];if(D.length>1)throw new AggregateError(D,"Encountered errors while disposing of store");return Array.isArray(u)?[]:u}else if(u)return u.dispose(),u}function c(u){for(const D of u)d(D)&&D.dispose();return[]}function v(...u){const D=w(()=>b(u));return a(u,D),D}function w(u){const D=E({dispose:(0,W.createSingleCallFunction)(()=>{y(D),u()})});return D}class l{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this._toDispose=new Set,this._isDisposed=!1,E(this)}dispose(){this._isDisposed||(y(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){if(this._toDispose.size!==0)try{b(this._toDispose)}finally{this._toDispose.clear()}}add(D){if(!D)return D;if(D===this)throw new Error("Cannot register a disposable on itself!");return M(D,this),this._isDisposed?l.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(D),D}delete(D){if(D){if(D===this)throw new Error("Cannot dispose a disposable on itself!");this._toDispose.delete(D),D.dispose()}}deleteAndLeak(D){D&&this._toDispose.has(D)&&(this._toDispose.delete(D),M(D,null))}}e.DisposableStore=l;class n{static{this.None=Object.freeze({dispose(){}})}constructor(){this._store=new l,E(this),M(this._store,this)}dispose(){y(this),this._store.dispose()}_register(D){if(D===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(D)}}e.Disposable=n;class i{constructor(){this._isDisposed=!1,E(this)}get value(){return this._isDisposed?void 0:this._value}set value(D){this._isDisposed||D===this._value||(this._value?.dispose(),D&&M(D,this),this._value=D)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,y(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const D=this._value;return this._value=void 0,D&&M(D,null),D}}e.MutableDisposable=i;class s{constructor(D){this._disposable=new i,this._isDisposed=!1,this._disposable.value=D}get value(){return this._disposable.value}set value(D){this._isDisposed||D===this._disposable.value||(this._disposable.value=D)}dispose(){this._isDisposed=!0,this._disposable.dispose()}}e.MandatoryMutableDisposable=s;class o{constructor(D){this._disposable=D,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter===0&&this._disposable.dispose(),this}}e.RefCountedDisposable=o;class U{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,E(this)}set(D){let C=D;return this.unset=()=>C=void 0,this.isset=()=>C!==void 0,this.dispose=()=>{C&&(C(),C=void 0,y(this))},this}}e.SafeDisposable=U;class _{constructor(){this.references=new Map}acquire(D,...C){let x=this.references.get(D);x||(x={counter:0,object:this.createReferencedObject(D,...C)},this.references.set(D,x));const{object:X}=x,H=(0,W.createSingleCallFunction)(()=>{--x.counter===0&&(this.destroyReferencedObject(D,x.object),this.references.delete(D))});return x.counter++,{object:X,dispose:H}}}e.ReferenceCollection=_;class m{constructor(D){this.referenceCollection=D}async acquire(D,...C){const x=this.referenceCollection.acquire(D,...C);try{return{object:await x.object,dispose:()=>x.dispose()}}catch(X){throw x.dispose(),X}}}e.AsyncReferenceCollection=m;class f{constructor(D){this.object=D}dispose(){}}e.ImmortalReference=f;function A(u){const D=new l;try{u(D)}finally{D.dispose()}}class R{constructor(){this._store=new Map,this._isDisposed=!1,E(this)}dispose(){y(this),this._isDisposed=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this._store.size)try{b(this._store.values())}finally{this._store.clear()}}has(D){return this._store.has(D)}get size(){return this._store.size}get(D){return this._store.get(D)}set(D,C,x=!1){this._isDisposed&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),x||this._store.get(D)?.dispose(),this._store.set(D,C)}deleteAndDispose(D){this._store.get(D)?.dispose(),this._store.delete(D)}deleteAndLeak(D){const C=this._store.get(D);return this._store.delete(D),C}keys(){return this._store.keys()}values(){return this._store.values()}[Symbol.iterator](){return this._store[Symbol.iterator]()}}e.DisposableMap=R}),define(Ee[28],pe([0,1]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MarshalledId=void 0;var p;(function(t){t[t.Uri=1]="Uri",t[t.Regexp=2]="Regexp",t[t.ScmResource=3]="ScmResource",t[t.ScmResourceGroup=4]="ScmResourceGroup",t[t.ScmProvider=5]="ScmProvider",t[t.CommentController=6]="CommentController",t[t.CommentThread=7]="CommentThread",t[t.CommentThreadInstance=8]="CommentThreadInstance",t[t.CommentThreadReply=9]="CommentThreadReply",t[t.CommentNode=10]="CommentNode",t[t.CommentThreadNode=11]="CommentThreadNode",t[t.TimelineActionContext=12]="TimelineActionContext",t[t.NotebookCellActionContext=13]="NotebookCellActionContext",t[t.NotebookActionContext=14]="NotebookActionContext",t[t.TerminalContext=15]="TerminalContext",t[t.TestItemContext=16]="TestItemContext",t[t.Date=17]="Date",t[t.TestMessageMenuArgs=18]="TestMessageMenuArgs"})(p||(e.MarshalledId=p={}))}),define(Ee[21],pe([0,1,20]),function(ce,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=void 0,e.normalizeNFC=$,e.normalizeNFD=V;const t=new p.LRUCache(1e4);function $(P){return T(P,"NFC",t)}const W=new p.LRUCache(1e4);function V(P){return T(P,"NFD",W)}const k=/[^\u0000-\u0080]/;function T(P,N,E){if(!P)return P;const y=E.get(P);if(y)return y;let M;return k.test(P)?M=P.normalize(N):M=P,E.set(P,M),M}e.removeAccents=function(){const P=/[\u0300-\u036f]/g;return function(N){return V(N).replace(P,"")}}()}),define(Ee[43],pe([0,1]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const p=globalThis.performance&&typeof globalThis.performance.now=="function";class t{static create(W){return new t(W)}constructor(W){this._now=p&&W===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this._startTime=this._now(),this._stopTime=-1}stop(){this._stopTime=this._now()}reset(){this._startTime=this._now(),this._stopTime=-1}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}}e.StopWatch=t}),define(Ee[6],pe([0,1,9,27,4,42,43]),function(ce,e,p,t,$,W,V){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ValueWithChangeEvent=e.Relay=e.EventBufferer=e.DynamicListEventMultiplexer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.createEventDeliveryQueue=e.Emitter=e.ListenerRefusalError=e.ListenerLeakError=e.EventProfiling=e.Event=void 0,e.setGlobalLeakWarningThreshold=M;const k=!1,T=!1,P=!1;var N;(function(X){X.None=()=>$.Disposable.None;function H(ge){if(P){const{onDidAddListener:ue}=ge,_e=r.create();let he=0;ge.onDidAddListener=()=>{++he===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),_e.print()),ue?.()}}}function se(ge,ue){return J(ge,()=>{},0,void 0,!0,void 0,ue)}X.defer=se;function K(ge){return(ue,_e=null,he)=>{let be=!1,Ae;return Ae=ge(Re=>{if(!be)return Ae?Ae.dispose():be=!0,ue.call(_e,Re)},null,he),be&&Ae.dispose(),Ae}}X.once=K;function ie(ge,ue){return X.once(X.filter(ge,ue))}X.onceIf=ie;function re(ge,ue,_e){return Y((he,be=null,Ae)=>ge(Re=>he.call(be,ue(Re)),null,Ae),_e)}X.map=re;function oe(ge,ue,_e){return Y((he,be=null,Ae)=>ge(Re=>{ue(Re),he.call(be,Re)},null,Ae),_e)}X.forEach=oe;function I(ge,ue,_e){return Y((he,be=null,Ae)=>ge(Re=>ue(Re)&&he.call(be,Re),null,Ae),_e)}X.filter=I;function g(ge){return ge}X.signal=g;function F(...ge){return(ue,_e=null,he)=>{const be=(0,$.combinedDisposable)(...ge.map(Ae=>Ae(Re=>ue.call(_e,Re))));return L(be,he)}}X.any=F;function j(ge,ue,_e,he){let be=_e;return re(ge,Ae=>(be=ue(be,Ae),be),he)}X.reduce=j;function Y(ge,ue){let _e;const he={onWillAddFirstListener(){_e=ge(be.fire,be)},onDidRemoveLastListener(){_e?.dispose()}};ue||H(he);const be=new i(he);return ue?.add(be),be.event}function L(ge,ue){return ue instanceof Array?ue.push(ge):ue&&ue.add(ge),ge}function J(ge,ue,_e=100,he=!1,be=!1,Ae,Re){let Te,Pe,ve,Fe=0,Be;const Ge={leakWarningThreshold:Ae,onWillAddFirstListener(){Te=ge(Ke=>{Fe++,Pe=ue(Pe,Ke),he&&!ve&&($e.fire(Pe),Pe=void 0),Be=()=>{const Ce=Pe;Pe=void 0,ve=void 0,(!he||Fe>1)&&$e.fire(Ce),Fe=0},typeof _e=="number"?(clearTimeout(ve),ve=setTimeout(Be,_e)):ve===void 0&&(ve=0,queueMicrotask(Be))})},onWillRemoveListener(){be&&Fe>0&&Be?.()},onDidRemoveLastListener(){Be=void 0,Te.dispose()}};Re||H(Ge);const $e=new i(Ge);return Re?.add($e),$e.event}X.debounce=J;function ee(ge,ue=0,_e){return X.debounce(ge,(he,be)=>he?(he.push(be),he):[be],ue,void 0,!0,void 0,_e)}X.accumulate=ee;function ne(ge,ue=(he,be)=>he===be,_e){let he=!0,be;return I(ge,Ae=>{const Re=he||!ue(Ae,be);return he=!1,be=Ae,Re},_e)}X.latch=ne;function le(ge,ue,_e){return[X.filter(ge,ue,_e),X.filter(ge,he=>!ue(he),_e)]}X.split=le;function fe(ge,ue=!1,_e=[],he){let be=_e.slice(),Ae=ge(Pe=>{be?be.push(Pe):Te.fire(Pe)});he&&he.add(Ae);const Re=()=>{be?.forEach(Pe=>Te.fire(Pe)),be=null},Te=new i({onWillAddFirstListener(){Ae||(Ae=ge(Pe=>Te.fire(Pe)),he&&he.add(Ae))},onDidAddFirstListener(){be&&(ue?setTimeout(Re):Re())},onDidRemoveLastListener(){Ae&&Ae.dispose(),Ae=null}});return he&&he.add(Te),Te.event}X.buffer=fe;function we(ge,ue){return(he,be,Ae)=>{const Re=ue(new z);return ge(function(Te){const Pe=Re.evaluate(Te);Pe!==B&&he.call(be,Pe)},void 0,Ae)}}X.chain=we;const B=Symbol("HaltChainable");class z{constructor(){this.steps=[]}map(ue){return this.steps.push(ue),this}forEach(ue){return this.steps.push(_e=>(ue(_e),_e)),this}filter(ue){return this.steps.push(_e=>ue(_e)?_e:B),this}reduce(ue,_e){let he=_e;return this.steps.push(be=>(he=ue(he,be),he)),this}latch(ue=(_e,he)=>_e===he){let _e=!0,he;return this.steps.push(be=>{const Ae=_e||!ue(be,he);return _e=!1,he=be,Ae?be:B}),this}evaluate(ue){for(const _e of this.steps)if(ue=_e(ue),ue===B)break;return ue}}function O(ge,ue,_e=he=>he){const he=(...Te)=>Re.fire(_e(...Te)),be=()=>ge.on(ue,he),Ae=()=>ge.removeListener(ue,he),Re=new i({onWillAddFirstListener:be,onDidRemoveLastListener:Ae});return Re.event}X.fromNodeEventEmitter=O;function h(ge,ue,_e=he=>he){const he=(...Te)=>Re.fire(_e(...Te)),be=()=>ge.addEventListener(ue,he),Ae=()=>ge.removeEventListener(ue,he),Re=new i({onWillAddFirstListener:be,onDidRemoveLastListener:Ae});return Re.event}X.fromDOMEventEmitter=h;function q(ge){return new Promise(ue=>K(ge)(ue))}X.toPromise=q;function Q(ge){const ue=new i;return ge.then(_e=>{ue.fire(_e)},()=>{ue.fire(void 0)}).finally(()=>{ue.dispose()}),ue.event}X.fromPromise=Q;function te(ge,ue){return ge(_e=>ue.fire(_e))}X.forward=te;function de(ge,ue,_e){return ue(_e),ge(he=>ue(he))}X.runAndSubscribe=de;class ye{constructor(ue,_e){this._observable=ue,this._counter=0,this._hasChanged=!1;const he={onWillAddFirstListener:()=>{ue.addObserver(this),this._observable.reportChanges()},onDidRemoveLastListener:()=>{ue.removeObserver(this)}};_e||H(he),this.emitter=new i(he),_e&&_e.add(this.emitter)}beginUpdate(ue){this._counter++}handlePossibleChange(ue){}handleChange(ue,_e){this._hasChanged=!0}endUpdate(ue){this._counter--,this._counter===0&&(this._observable.reportChanges(),this._hasChanged&&(this._hasChanged=!1,this.emitter.fire(this._observable.get())))}}function Le(ge,ue){return new ye(ge,ue).emitter.event}X.fromObservable=Le;function Se(ge){return(ue,_e,he)=>{let be=0,Ae=!1;const Re={beginUpdate(){be++},endUpdate(){be--,be===0&&(ge.reportChanges(),Ae&&(Ae=!1,ue.call(_e)))},handlePossibleChange(){},handleChange(){Ae=!0}};ge.addObserver(Re),ge.reportChanges();const Te={dispose(){ge.removeObserver(Re)}};return he instanceof $.DisposableStore?he.add(Te):Array.isArray(he)&&he.push(Te),Te}}X.fromObservableLight=Se})(N||(e.Event=N={}));class E{static{this.all=new Set}static{this._idPool=0}constructor(H){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${H}_${E._idPool++}`,E.all.add(this)}start(H){this._stopWatch=new V.StopWatch,this.listenerCount=H}stop(){if(this._stopWatch){const H=this._stopWatch.elapsed();this.durations.push(H),this.elapsedOverall+=H,this.invocationCount+=1,this._stopWatch=void 0}}}e.EventProfiling=E;let y=-1;function M(X){const H=y;return y=X,{dispose(){y=H}}}class a{static{this._idPool=1}constructor(H,se,K=(a._idPool++).toString(16).padStart(3,"0")){this._errorHandler=H,this.threshold=se,this.name=K,this._warnCountdown=0}dispose(){this._stacks?.clear()}check(H,se){const K=this.threshold;if(K<=0||se<K)return;this._stacks||(this._stacks=new Map);const ie=this._stacks.get(H.value)||0;if(this._stacks.set(H.value,ie+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=K*.5;const[re,oe]=this.getMostFrequentStack(),I=`[${this.name}] potential listener LEAK detected, having ${se} listeners already. MOST frequent listener (${oe}):`;console.warn(I),console.warn(re);const g=new d(I,re);this._errorHandler(g)}return()=>{const re=this._stacks.get(H.value)||0;this._stacks.set(H.value,re-1)}}getMostFrequentStack(){if(!this._stacks)return;let H,se=0;for(const[K,ie]of this._stacks)(!H||se<ie)&&(H=[K,ie],se=ie);return H}}class r{static create(){const H=new Error;return new r(H.stack??"")}constructor(H){this.value=H}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class d extends Error{constructor(H,se){super(H),this.name="ListenerLeakError",this.stack=se}}e.ListenerLeakError=d;class b extends Error{constructor(H,se){super(H),this.name="ListenerRefusalError",this.stack=se}}e.ListenerRefusalError=b;let c=0;class v{constructor(H){this.value=H,this.id=c++}}const w=2,l=(X,H)=>{if(X instanceof v)H(X);else for(let se=0;se<X.length;se++){const K=X[se];K&&H(K)}};let n;if(k){const X=[];setInterval(()=>{X.length!==0&&(console.warn("[LEAKING LISTENERS] GC'ed these listeners that were NOT yet disposed:"),console.warn(X.join(`
`)),X.length=0)},3e3),n=new FinalizationRegistry(H=>{typeof H=="string"&&X.push(H)})}class i{constructor(H){this._size=0,this._options=H,this._leakageMon=y>0||this._options?.leakWarningThreshold?new a(H?.onListenerError??p.onUnexpectedError,this._options?.leakWarningThreshold??y):void 0,this._perfMon=this._options?._profName?new E(this._options._profName):void 0,this._deliveryQueue=this._options?.deliveryQueue}dispose(){if(!this._disposed){if(this._disposed=!0,this._deliveryQueue?.current===this&&this._deliveryQueue.reset(),this._listeners){if(T){const H=this._listeners;queueMicrotask(()=>{l(H,se=>se.stack?.print())})}this._listeners=void 0,this._size=0}this._options?.onDidRemoveLastListener?.(),this._leakageMon?.dispose()}}get event(){return this._event??=(H,se,K)=>{if(this._leakageMon&&this._size>this._leakageMon.threshold**2){const g=`[${this._leakageMon.name}] REFUSES to accept new listeners because it exceeded its threshold by far (${this._size} vs ${this._leakageMon.threshold})`;console.warn(g);const F=this._leakageMon.getMostFrequentStack()??["UNKNOWN stack",-1],j=new b(`${g}. HINT: Stack shows most frequent listener (${F[1]}-times)`,F[0]);return(this._options?.onListenerError||p.onUnexpectedError)(j),$.Disposable.None}if(this._disposed)return $.Disposable.None;se&&(H=H.bind(se));const ie=new v(H);let re,oe;this._leakageMon&&this._size>=Math.ceil(this._leakageMon.threshold*.2)&&(ie.stack=r.create(),re=this._leakageMon.check(ie.stack,this._size+1)),T&&(ie.stack=oe??r.create()),this._listeners?this._listeners instanceof v?(this._deliveryQueue??=new o,this._listeners=[this._listeners,ie]):this._listeners.push(ie):(this._options?.onWillAddFirstListener?.(this),this._listeners=ie,this._options?.onDidAddFirstListener?.(this)),this._size++;const I=(0,$.toDisposable)(()=>{n?.unregister(I),re?.(),this._removeListener(ie)});if(K instanceof $.DisposableStore?K.add(I):Array.isArray(K)&&K.push(I),n){const g=new Error().stack.split(`
`).slice(2,3).join(`
`).trim(),F=/(file:|vscode-file:\/\/vscode-app)?(\/[^:]*:\d+:\d+)/.exec(g);n.register(I,F?.[2]??g,I)}return I},this._event}_removeListener(H){if(this._options?.onWillRemoveListener?.(this),!this._listeners)return;if(this._size===1){this._listeners=void 0,this._options?.onDidRemoveLastListener?.(this),this._size=0;return}const se=this._listeners,K=se.indexOf(H);if(K===-1)throw console.log("disposed?",this._disposed),console.log("size?",this._size),console.log("arr?",JSON.stringify(this._listeners)),new Error("Attempted to dispose unknown listener");this._size--,se[K]=void 0;const ie=this._deliveryQueue.current===this;if(this._size*w<=se.length){let re=0;for(let oe=0;oe<se.length;oe++)se[oe]?se[re++]=se[oe]:ie&&(this._deliveryQueue.end--,re<this._deliveryQueue.i&&this._deliveryQueue.i--);se.length=re}}_deliver(H,se){if(!H)return;const K=this._options?.onListenerError||p.onUnexpectedError;if(!K){H.value(se);return}try{H.value(se)}catch(ie){K(ie)}}_deliverQueue(H){const se=H.current._listeners;for(;H.i<H.end;)this._deliver(se[H.i++],H.value);H.reset()}fire(H){if(this._deliveryQueue?.current&&(this._deliverQueue(this._deliveryQueue),this._perfMon?.stop()),this._perfMon?.start(this._size),this._listeners)if(this._listeners instanceof v)this._deliver(this._listeners,H);else{const se=this._deliveryQueue;se.enqueue(this,H,this._listeners.length),this._deliverQueue(se)}this._perfMon?.stop()}hasListeners(){return this._size>0}}e.Emitter=i;const s=()=>new o;e.createEventDeliveryQueue=s;class o{constructor(){this.i=-1,this.end=0}enqueue(H,se,K){this.i=0,this.end=K,this.current=H,this.value=se}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class U extends i{async fireAsync(H,se,K){if(this._listeners)for(this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new W.LinkedList),l(this._listeners,ie=>this._asyncDeliveryQueue.push([ie.value,H]));this._asyncDeliveryQueue.size>0&&!se.isCancellationRequested;){const[ie,re]=this._asyncDeliveryQueue.shift(),oe=[],I={...re,token:se,waitUntil:g=>{if(Object.isFrozen(oe))throw new Error("waitUntil can NOT be called asynchronous");K&&(g=K(g,ie)),oe.push(g)}};try{ie(I)}catch(g){(0,p.onUnexpectedError)(g);continue}Object.freeze(oe),await Promise.allSettled(oe).then(g=>{for(const F of g)F.status==="rejected"&&(0,p.onUnexpectedError)(F.reason)})}}}e.AsyncEmitter=U;class _ extends i{get isPaused(){return this._isPaused!==0}constructor(H){super(H),this._isPaused=0,this._eventQueue=new W.LinkedList,this._mergeFn=H?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused===0)if(this._mergeFn){if(this._eventQueue.size>0){const H=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(H))}}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(H){this._size&&(this._isPaused!==0?this._eventQueue.push(H):super.fire(H))}}e.PauseableEmitter=_;class m extends _{constructor(H){super(H),this._delay=H.delay??100}fire(H){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(H)}}e.DebounceEmitter=m;class f extends i{constructor(H){super(H),this._queuedEvents=[],this._mergeFn=H?.merge}fire(H){this.hasListeners()&&(this._queuedEvents.push(H),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(se=>super.fire(se)),this._queuedEvents=[]}))}}e.MicrotaskEmitter=f;class A{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new i({onWillAddFirstListener:()=>this.onFirstListenerAdd(),onDidRemoveLastListener:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(H){const se={event:H,listener:null};this.events.push(se),this.hasListeners&&this.hook(se);const K=()=>{this.hasListeners&&this.unhook(se);const ie=this.events.indexOf(se);this.events.splice(ie,1)};return(0,$.toDisposable)((0,t.createSingleCallFunction)(K))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(H=>this.hook(H))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(H=>this.unhook(H))}hook(H){H.listener=H.event(se=>this.emitter.fire(se))}unhook(H){H.listener?.dispose(),H.listener=null}dispose(){this.emitter.dispose();for(const H of this.events)H.listener?.dispose();this.events=[]}}e.EventMultiplexer=A;class R{constructor(H,se,K,ie){this._store=new $.DisposableStore;const re=this._store.add(new A),oe=this._store.add(new $.DisposableMap);function I(g){oe.set(g,re.add(ie(g)))}for(const g of H)I(g);this._store.add(se(g=>{I(g)})),this._store.add(K(g=>{oe.deleteAndDispose(g)})),this.event=re.event}dispose(){this._store.dispose()}}e.DynamicListEventMultiplexer=R;class u{constructor(){this.data=[]}wrapEvent(H,se,K){return(ie,re,oe)=>H(I=>{const g=this.data[this.data.length-1];if(!se){g?g.buffers.push(()=>ie.call(re,I)):ie.call(re,I);return}const F=g;if(!F){ie.call(re,se(K,I));return}F.items??=[],F.items.push(I),F.buffers.length===0&&g.buffers.push(()=>{F.reducedResult??=K?F.items.reduce(se,K):F.items.reduce(se),ie.call(re,F.reducedResult)})},void 0,oe)}bufferEvents(H){const se={buffers:new Array};this.data.push(se);const K=H();return this.data.pop(),se.buffers.forEach(ie=>ie()),K}}e.EventBufferer=u;class D{constructor(){this.listening=!1,this.inputEvent=N.None,this.inputEventListener=$.Disposable.None,this.emitter=new i({onDidAddFirstListener:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onDidRemoveLastListener:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(H){this.inputEvent=H,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=H(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=D;class C{static const(H){return new x(H)}constructor(H){this._value=H,this._onDidChange=new i,this.onDidChange=this._onDidChange.event}get value(){return this._value}set value(H){H!==this._value&&(this._value=H,this._onDidChange.fire(void 0))}}e.ValueWithChangeEvent=C;class x{constructor(H){this.value=H,this.onDidChange=N.None}}}),define(Ee[13],pe([0,1,6]),function(ce,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0,e.cancelOnDispose=k;const t=Object.freeze(function(T,P){const N=setTimeout(T.bind(P),0);return{dispose(){clearTimeout(N)}}});var $;(function(T){function P(N){return N===T.None||N===T.Cancelled||N instanceof W?!0:!N||typeof N!="object"?!1:typeof N.isCancellationRequested=="boolean"&&typeof N.onCancellationRequested=="function"}T.isCancellationToken=P,T.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:p.Event.None}),T.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:t})})($||(e.CancellationToken=$={}));class W{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?t:(this._emitter||(this._emitter=new p.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class V{constructor(P){this._token=void 0,this._parentListener=void 0,this._parentListener=P&&P.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new W),this._token}cancel(){this._token?this._token instanceof W&&this._token.cancel():this._token=$.Cancelled}dispose(P=!1){P&&this.cancel(),this._parentListener?.dispose(),this._token?this._token instanceof W&&this._token.dispose():this._token=$.None}}e.CancellationTokenSource=V;function k(T){const P=new V;return T.add({dispose(){P.cancel()}}),P.token}}),define(Ee[44],pe([0,1,13]),function(ce,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0,e.identity=$;class t{constructor(T){this.task=T,this.result=null}get(){if(this.result)return this.result;const T=new p.CancellationTokenSource,P=this.task(T.token);return this.result={promise:P,dispose:()=>{this.result=null,T.cancel(),T.dispose()}},this.result}}e.Cache=t;function $(k){return k}class W{constructor(T,P){this.lastCache=void 0,this.lastArgKey=void 0,typeof T=="function"?(this._fn=T,this._computeKey=$):(this._fn=P,this._computeKey=T.getCacheKey)}get(T){const P=this._computeKey(T);return this.lastArgKey!==P&&(this.lastArgKey=P,this.lastCache=this._fn(T)),this.lastCache}}e.LRUCachedFunction=W;class V{get cachedValues(){return this._map}constructor(T,P){this._map=new Map,this._map2=new Map,typeof T=="function"?(this._fn=T,this._computeKey=$):(this._fn=P,this._computeKey=T.getCacheKey)}get(T){const P=this._computeKey(T);if(this._map2.has(P))return this._map2.get(P);const N=this._fn(T);return this._map.set(T,N),this._map2.set(P,N),N}}e.CachedFunction=V}),define(Ee[45],pe([0,1,9,4]),function(ce,e,p,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isReadable=$,e.isReadableStream=W,e.isReadableBufferedStream=V,e.newWriteableStream=k,e.consumeReadable=P,e.peekReadable=N,e.consumeStream=E,e.listenStream=y,e.peekStream=M,e.toStream=a,e.emptyStream=r,e.toReadable=d,e.transform=b,e.prefixedReadable=c,e.prefixedStream=v;function $(w){const l=w;return l?typeof l.read=="function":!1}function W(w){const l=w;return l?[l.on,l.pause,l.resume,l.destroy].every(n=>typeof n=="function"):!1}function V(w){const l=w;return l?W(l.stream)&&Array.isArray(l.buffer)&&typeof l.ended=="boolean":!1}function k(w,l){return new T(w,l)}class T{constructor(l,n){this.reducer=l,this.options=n,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(l){if(!this.state.destroyed){if(this.state.flowing)this.emitData(l);else if(this.buffer.data.push(l),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(n=>this.pendingWritePromises.push(n))}}error(l){this.state.destroyed||(this.state.flowing?this.emitError(l):this.buffer.error.push(l))}end(l){this.state.destroyed||(typeof l<"u"&&this.write(l),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(l){this.listeners.data.slice(0).forEach(n=>n(l))}emitError(l){this.listeners.error.length===0?(0,p.onUnexpectedError)(l):this.listeners.error.slice(0).forEach(n=>n(l))}emitEnd(){this.listeners.end.slice(0).forEach(l=>l())}on(l,n){if(!this.state.destroyed)switch(l){case"data":this.listeners.data.push(n),this.resume();break;case"end":this.listeners.end.push(n),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(n),this.state.flowing&&this.flowErrors();break}}removeListener(l,n){if(this.state.destroyed)return;let i;switch(l){case"data":i=this.listeners.data;break;case"end":i=this.listeners.end;break;case"error":i=this.listeners.error;break}if(i){const s=i.indexOf(n);s>=0&&i.splice(s,1)}}flowData(){if(this.buffer.data.length>0){const l=this.reducer(this.buffer.data);this.emitData(l),this.buffer.data.length=0;const n=[...this.pendingWritePromises];this.pendingWritePromises.length=0,n.forEach(i=>i())}}flowErrors(){if(this.listeners.error.length>0){for(const l of this.buffer.error)this.emitError(l);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function P(w,l){const n=[];let i;for(;(i=w.read())!==null;)n.push(i);return l(n)}function N(w,l,n){const i=[];let s;for(;(s=w.read())!==null&&i.length<n;)i.push(s);return s===null&&i.length>0?l(i):{read:()=>{if(i.length>0)return i.shift();if(typeof s<"u"){const o=s;return s=void 0,o}return w.read()}}}function E(w,l){return new Promise((n,i)=>{const s=[];y(w,{onData:o=>{l&&s.push(o)},onError:o=>{l?i(o):n(void 0)},onEnd:()=>{n(l?l(s):void 0)}})})}function y(w,l,n){w.on("error",i=>{n?.isCancellationRequested||l.onError(i)}),w.on("end",()=>{n?.isCancellationRequested||l.onEnd()}),w.on("data",i=>{n?.isCancellationRequested||l.onData(i)})}function M(w,l){return new Promise((n,i)=>{const s=new t.DisposableStore,o=[],U=f=>{if(o.push(f),o.length>l)return s.dispose(),w.pause(),n({stream:w,buffer:o,ended:!1})},_=f=>(s.dispose(),i(f)),m=()=>(s.dispose(),n({stream:w,buffer:o,ended:!0}));s.add((0,t.toDisposable)(()=>w.removeListener("error",_))),w.on("error",_),s.add((0,t.toDisposable)(()=>w.removeListener("end",m))),w.on("end",m),s.add((0,t.toDisposable)(()=>w.removeListener("data",U))),w.on("data",U)})}function a(w,l){const n=k(l);return n.end(w),n}function r(){const w=k(()=>{throw new Error("not supported")});return w.end(),w}function d(w){let l=!1;return{read:()=>l?null:(l=!0,w)}}function b(w,l,n){const i=k(n);return y(w,{onData:s=>i.write(l.data(s)),onError:s=>i.error(l.error?l.error(s):s),onEnd:()=>i.end()}),i}function c(w,l,n){let i=!1;return{read:()=>{const s=l.read();return i?s:(i=!0,s!==null?n([w,s]):w)}}}function v(w,l,n){let i=!1;const s=k(n);return y(l,{onData:o=>i?s.write(o):(i=!0,s.write(n([w,o]))),onError:o=>s.error(o),onEnd:()=>{i||(i=!0,s.write(w)),s.end()}}),s}});var Qe=this&&this.__createBinding||(Object.create?function(ce,e,p,t){t===void 0&&(t=p);var $=Object.getOwnPropertyDescriptor(e,p);(!$||("get"in $?!e.__esModule:$.writable||$.configurable))&&($={enumerable:!0,get:function(){return e[p]}}),Object.defineProperty(ce,t,$)}:function(ce,e,p,t){t===void 0&&(t=p),ce[t]=e[p]}),Ye=this&&this.__setModuleDefault||(Object.create?function(ce,e){Object.defineProperty(ce,"default",{enumerable:!0,value:e})}:function(ce,e){ce.default=e}),Ie=this&&this.__importStar||function(ce){if(ce&&ce.__esModule)return ce;var e={};if(ce!=null)for(var p in ce)p!=="default"&&Object.prototype.hasOwnProperty.call(ce,p)&&Qe(e,ce,p);return Ye(e,ce),e};define(Ee[17],pe([0,1,16,45]),function(ce,e,p,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.VSBuffer=void 0,e.binaryIndexOf=P,e.readUInt16LE=N,e.writeUInt16LE=E,e.readUInt32BE=y,e.writeUInt32BE=M,e.readUInt32LE=a,e.writeUInt32LE=r,e.readUInt8=d,e.writeUInt8=b,e.readableToBuffer=c,e.bufferToReadable=v,e.streamToBuffer=w,e.bufferedStreamToBuffer=l,e.bufferToStream=n,e.streamToBufferReadableStream=i,e.newWriteableBufferStream=s,e.prefixedBufferReadable=o,e.prefixedBufferStream=U,e.decodeBase64=_,e.encodeBase64=A,t=Ie(t);const $=typeof Buffer<"u",W=new p.Lazy(()=>new Uint8Array(256));let V,k;class T{static alloc(u){return $?new T(Buffer.allocUnsafe(u)):new T(new Uint8Array(u))}static wrap(u){return $&&!Buffer.isBuffer(u)&&(u=Buffer.from(u.buffer,u.byteOffset,u.byteLength)),new T(u)}static fromString(u,D){return!(D?.dontUseNodeBuffer||!1)&&$?new T(Buffer.from(u)):(V||(V=new TextEncoder),new T(V.encode(u)))}static fromByteArray(u){const D=T.alloc(u.length);for(let C=0,x=u.length;C<x;C++)D.buffer[C]=u[C];return D}static concat(u,D){if(typeof D>"u"){D=0;for(let X=0,H=u.length;X<H;X++)D+=u[X].byteLength}const C=T.alloc(D);let x=0;for(let X=0,H=u.length;X<H;X++){const se=u[X];C.set(se,x),x+=se.byteLength}return C}constructor(u){this.buffer=u,this.byteLength=this.buffer.byteLength}clone(){const u=T.alloc(this.byteLength);return u.set(this),u}toString(){return $?this.buffer.toString():(k||(k=new TextDecoder),k.decode(this.buffer))}slice(u,D){return new T(this.buffer.subarray(u,D))}set(u,D){if(u instanceof T)this.buffer.set(u.buffer,D);else if(u instanceof Uint8Array)this.buffer.set(u,D);else if(u instanceof ArrayBuffer)this.buffer.set(new Uint8Array(u),D);else if(ArrayBuffer.isView(u))this.buffer.set(new Uint8Array(u.buffer,u.byteOffset,u.byteLength),D);else throw new Error("Unknown argument 'array'")}readUInt32BE(u){return y(this.buffer,u)}writeUInt32BE(u,D){M(this.buffer,u,D)}readUInt32LE(u){return a(this.buffer,u)}writeUInt32LE(u,D){r(this.buffer,u,D)}readUInt8(u){return d(this.buffer,u)}writeUInt8(u,D){b(this.buffer,u,D)}indexOf(u,D=0){return P(this.buffer,u instanceof T?u.buffer:u,D)}}e.VSBuffer=T;function P(R,u,D=0){const C=u.byteLength,x=R.byteLength;if(C===0)return 0;if(C===1)return R.indexOf(u[0]);if(C>x-D)return-1;const X=W.value;X.fill(u.length);for(let ie=0;ie<u.length;ie++)X[u[ie]]=u.length-ie-1;let H=D+u.length-1,se=H,K=-1;for(;H<x;)if(R[H]===u[se]){if(se===0){K=H;break}H--,se--}else H+=Math.max(u.length-se,X[R[H]]),se=u.length-1;return K}function N(R,u){return R[u+0]<<0>>>0|R[u+1]<<8>>>0}function E(R,u,D){R[D+0]=u&255,u=u>>>8,R[D+1]=u&255}function y(R,u){return R[u]*2**24+R[u+1]*2**16+R[u+2]*2**8+R[u+3]}function M(R,u,D){R[D+3]=u,u=u>>>8,R[D+2]=u,u=u>>>8,R[D+1]=u,u=u>>>8,R[D]=u}function a(R,u){return R[u+0]<<0>>>0|R[u+1]<<8>>>0|R[u+2]<<16>>>0|R[u+3]<<24>>>0}function r(R,u,D){R[D+0]=u&255,u=u>>>8,R[D+1]=u&255,u=u>>>8,R[D+2]=u&255,u=u>>>8,R[D+3]=u&255}function d(R,u){return R[u]}function b(R,u,D){R[D]=u}function c(R){return t.consumeReadable(R,u=>T.concat(u))}function v(R){return t.toReadable(R)}function w(R){return t.consumeStream(R,u=>T.concat(u))}async function l(R){return R.ended?T.concat(R.buffer):T.concat([...R.buffer,await w(R.stream)])}function n(R){return t.toStream(R,u=>T.concat(u))}function i(R){return t.transform(R,{data:u=>typeof u=="string"?T.fromString(u):T.wrap(u)},u=>T.concat(u))}function s(R){return t.newWriteableStream(u=>T.concat(u),R)}function o(R,u){return t.prefixedReadable(R,u,D=>T.concat(D))}function U(R,u){return t.prefixedStream(R,u,D=>T.concat(D))}function _(R){let u=0,D=0,C=0;const x=new Uint8Array(Math.floor(R.length/4*3)),X=se=>{switch(D){case 3:x[C++]=u|se,D=0;break;case 2:x[C++]=u|se>>>2,u=se<<6,D=3;break;case 1:x[C++]=u|se>>>4,u=se<<4,D=2;break;default:u=se<<2,D=1}};for(let se=0;se<R.length;se++){const K=R.charCodeAt(se);if(K>=65&&K<=90)X(K-65);else if(K>=97&&K<=122)X(K-97+26);else if(K>=48&&K<=57)X(K-48+52);else if(K===43||K===45)X(62);else if(K===47||K===95)X(63);else{if(K===61)break;throw new SyntaxError(`Unexpected base64 character ${R[se]}`)}}const H=C;for(;D>0;)X(0);return T.wrap(x).slice(0,H)}const m="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",f="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function A({buffer:R},u=!0,D=!1){const C=D?f:m;let x="";const X=R.byteLength%3;let H=0;for(;H<R.byteLength-X;H+=3){const se=R[H+0],K=R[H+1],ie=R[H+2];x+=C[se>>>2],x+=C[(se<<4|K>>>4)&63],x+=C[(K<<2|ie>>>6)&63],x+=C[ie&63]}if(X===1){const se=R[H+0];x+=C[se>>>2],x+=C[se<<4&63],u&&(x+="==")}else if(X===2){const se=R[H+0],K=R[H+1];x+=C[se>>>2],x+=C[(se<<4|K>>>4)&63],x+=C[K<<2&63],u&&(x+="=")}return x}}),define(Ee[46],pe([0,1]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MicrotaskDelay=void 0,e.MicrotaskDelay=Symbol("MicrotaskDelay")}),define(Ee[10],pe([0,1]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isString=p,e.isStringArray=t,e.isObject=$,e.isTypedArray=W,e.isNumber=V,e.isIterable=k,e.isBoolean=T,e.isUndefined=P,e.isDefined=N,e.isUndefinedOrNull=E,e.assertType=y,e.assertIsDefined=M,e.assertAllDefined=a,e.isEmptyObject=d,e.isFunction=b,e.areFunctions=c,e.validateConstraints=v,e.validateConstraint=w,e.upcast=l;function p(n){return typeof n=="string"}function t(n){return Array.isArray(n)&&n.every(i=>p(i))}function $(n){return typeof n=="object"&&n!==null&&!Array.isArray(n)&&!(n instanceof RegExp)&&!(n instanceof Date)}function W(n){const i=Object.getPrototypeOf(Uint8Array);return typeof n=="object"&&n instanceof i}function V(n){return typeof n=="number"&&!isNaN(n)}function k(n){return!!n&&typeof n[Symbol.iterator]=="function"}function T(n){return n===!0||n===!1}function P(n){return typeof n>"u"}function N(n){return!E(n)}function E(n){return P(n)||n===null}function y(n,i){if(!n)throw new Error(i?`Unexpected type, expected '${i}'`:"Unexpected type")}function M(n){if(E(n))throw new Error("Assertion Failed: argument is undefined or null");return n}function a(...n){const i=[];for(let s=0;s<n.length;s++){const o=n[s];if(E(o))throw new Error(`Assertion Failed: argument at index ${s} is undefined or null`);i.push(o)}return i}const r=Object.prototype.hasOwnProperty;function d(n){if(!$(n))return!1;for(const i in n)if(r.call(n,i))return!1;return!0}function b(n){return typeof n=="function"}function c(...n){return n.length>0&&n.every(b)}function v(n,i){const s=Math.min(n.length,i.length);for(let o=0;o<s;o++)w(n[o],i[o])}function w(n,i){if(p(i)){if(typeof n!==i)throw new Error(`argument does not match constraint: typeof ${i}`)}else if(b(i)){try{if(n instanceof i)return}catch{}if(!E(n)&&n.constructor===i||i.length===1&&i.call(void 0,n)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}function l(n){return n}}),define(Ee[47],pe([0,1,10]),function(ce,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deepClone=t,e.deepFreeze=$,e.cloneAndChange=V,e.mixin=T,e.equals=P,e.safeStringify=N,e.distinct=E,e.getCaseInsensitive=y,e.filter=M,e.getAllPropertyNames=a,e.getAllMethodNames=r,e.createProxyObject=d,e.mapValues=b;function t(c){if(!c||typeof c!="object"||c instanceof RegExp)return c;const v=Array.isArray(c)?[]:{};return Object.entries(c).forEach(([w,l])=>{v[w]=l&&typeof l=="object"?t(l):l}),v}function $(c){if(!c||typeof c!="object")return c;const v=[c];for(;v.length>0;){const w=v.shift();Object.freeze(w);for(const l in w)if(W.call(w,l)){const n=w[l];typeof n=="object"&&!Object.isFrozen(n)&&!(0,p.isTypedArray)(n)&&v.push(n)}}return c}const W=Object.prototype.hasOwnProperty;function V(c,v){return k(c,v,new Set)}function k(c,v,w){if((0,p.isUndefinedOrNull)(c))return c;const l=v(c);if(typeof l<"u")return l;if(Array.isArray(c)){const n=[];for(const i of c)n.push(k(i,v,w));return n}if((0,p.isObject)(c)){if(w.has(c))throw new Error("Cannot clone recursive data-structure");w.add(c);const n={};for(const i in c)W.call(c,i)&&(n[i]=k(c[i],v,w));return w.delete(c),n}return c}function T(c,v,w=!0){return(0,p.isObject)(c)?((0,p.isObject)(v)&&Object.keys(v).forEach(l=>{l in c?w&&((0,p.isObject)(c[l])&&(0,p.isObject)(v[l])?T(c[l],v[l],w):c[l]=v[l]):c[l]=v[l]}),c):v}function P(c,v){if(c===v)return!0;if(c==null||v===null||v===void 0||typeof c!=typeof v||typeof c!="object"||Array.isArray(c)!==Array.isArray(v))return!1;let w,l;if(Array.isArray(c)){if(c.length!==v.length)return!1;for(w=0;w<c.length;w++)if(!P(c[w],v[w]))return!1}else{const n=[];for(l in c)n.push(l);n.sort();const i=[];for(l in v)i.push(l);if(i.sort(),!P(n,i))return!1;for(w=0;w<n.length;w++)if(!P(c[n[w]],v[n[w]]))return!1}return!0}function N(c){const v=new Set;return JSON.stringify(c,(w,l)=>{if((0,p.isObject)(l)||Array.isArray(l)){if(v.has(l))return"[Circular]";v.add(l)}return typeof l=="bigint"?`[BigInt ${l.toString()}]`:l})}function E(c,v){const w=Object.create(null);return!c||!v||Object.keys(v).forEach(n=>{const i=c[n],s=v[n];P(i,s)||(w[n]=s)}),w}function y(c,v){const w=v.toLowerCase(),l=Object.keys(c).find(n=>n.toLowerCase()===w);return l?c[l]:c[v]}function M(c,v){const w=Object.create(null);for(const[l,n]of Object.entries(c))v(l,n)&&(w[l]=n);return w}function a(c){let v=[];for(;Object.prototype!==c;)v=v.concat(Object.getOwnPropertyNames(c)),c=Object.getPrototypeOf(c);return v}function r(c){const v=[];for(const w of a(c))typeof c[w]=="function"&&v.push(w);return v}function d(c,v){const w=n=>function(){const i=Array.prototype.slice.call(arguments,0);return v(n,i)},l={};for(const n of c)l[n]=w(n);return l}function b(c,v){const w={};for(const[l,n]of Object.entries(c))w[l]=v(n,l);return w}}),define(Ee[48],pe([0,1]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Constants=void 0,e.toUint8=t,e.toUint32=$;var p;(function(W){W[W.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",W[W.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",W[W.MAX_UINT_8=255]="MAX_UINT_8",W[W.MAX_UINT_16=65535]="MAX_UINT_16",W[W.MAX_UINT_32=4294967295]="MAX_UINT_32",W[W.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(p||(e.Constants=p={}));function t(W){return W<0?0:W>p.MAX_UINT_8?p.MAX_UINT_8:W|0}function $(W){return W<0?0:W>p.MAX_UINT_32?p.MAX_UINT_32:W|0}}),define(Ee[7],pe([0,1,44,11,16,48]),function(ce,e,p,t,$,W){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.GraphemeBreakType=e.UTF8_BOM_CHARACTER=e.UNUSUAL_LINE_TERMINATORS=e.GraphemeIterator=e.CodePointIterator=void 0,e.isFalsyOrWhitespace=V,e.format=T,e.format2=N,e.htmlAttributeEncodeValue=E,e.escape=y,e.escapeRegExpCharacters=M,e.count=a,e.truncate=r,e.truncateMiddle=d,e.trim=b,e.ltrim=c,e.rtrim=v,e.convertSimple2RegExpPattern=w,e.stripWildcards=l,e.createRegExp=n,e.regExpLeadsToEndlessLoop=i,e.splitLines=s,e.splitLinesIncludeSeparators=o,e.firstNonWhitespaceIndex=U,e.getLeadingWhitespace=_,e.lastNonWhitespaceIndex=m,e.replaceAsync=f,e.compare=A,e.compareSubstring=R,e.compareIgnoreCase=u,e.compareSubstringIgnoreCase=D,e.isAsciiDigit=C,e.isLowerAsciiLetter=x,e.isUpperAsciiLetter=X,e.equalsIgnoreCase=H,e.startsWithIgnoreCase=se,e.commonPrefixLength=K,e.commonSuffixLength=ie,e.isHighSurrogate=re,e.isLowSurrogate=oe,e.computeCodePoint=I,e.getNextCodePoint=g,e.nextCharLength=L,e.prevCharLength=J,e.getCharContainingOffset=ee,e.charCount=ne,e.containsRTL=we,e.isBasicASCII=z,e.containsUnusualLineTerminators=O,e.isFullWidthCharacter=h,e.isEmojiImprecise=q,e.lcut=Q,e.forAnsiStringParts=de,e.removeAnsiEscapeCodes=ye,e.removeAnsiEscapeCodesFromPrompt=Se,e.startsWithUTF8BOM=ge,e.stripUTF8BOM=ue,e.fuzzyContains=_e,e.containsUppercaseCharacter=he,e.uppercaseFirstLetter=be,e.getNLines=Ae,e.singleLetterHash=Re,e.getGraphemeBreakType=Te,e.getLeftDeleteOffset=Ge;function V(S){return!S||typeof S!="string"?!0:S.trim().length===0}const k=/{(\d+)}/g;function T(S,...G){return G.length===0?S:S.replace(k,function(Z,ae){const me=parseInt(ae,10);return isNaN(me)||me<0||me>=G.length?Z:G[me]})}const P=/{([^}]+)}/g;function N(S,G){return Object.keys(G).length===0?S:S.replace(P,(Z,ae)=>G[ae]??Z)}function E(S){return S.replace(/[<>"'&]/g,G=>{switch(G){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return G})}function y(S){return S.replace(/[<>&]/g,function(G){switch(G){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return G}})}function M(S){return S.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function a(S,G){let Z=0,ae=S.indexOf(G);for(;ae!==-1;)Z++,ae=S.indexOf(G,ae+G.length);return Z}function r(S,G,Z="\u2026"){return S.length<=G?S:`${S.substr(0,G)}${Z}`}function d(S,G,Z="\u2026"){if(S.length<=G)return S;const ae=Math.ceil(G/2)-Z.length/2,me=Math.floor(G/2)-Z.length/2;return`${S.substr(0,ae)}${Z}${S.substr(S.length-me)}`}function b(S,G=" "){const Z=c(S,G);return v(Z,G)}function c(S,G){if(!S||!G)return S;const Z=G.length;if(Z===0||S.length===0)return S;let ae=0;for(;S.indexOf(G,ae)===ae;)ae=ae+Z;return S.substring(ae)}function v(S,G){if(!S||!G)return S;const Z=G.length,ae=S.length;if(Z===0||ae===0)return S;let me=ae,De=-1;for(;De=S.lastIndexOf(G,me-1),!(De===-1||De+Z!==me);){if(De===0)return"";me=De}return S.substring(0,me)}function w(S){return S.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function l(S){return S.replace(/\*/g,"")}function n(S,G,Z={}){if(!S)throw new Error("Cannot create regex from empty string");G||(S=M(S)),Z.wholeWord&&(/\B/.test(S.charAt(0))||(S="\\b"+S),/\B/.test(S.charAt(S.length-1))||(S=S+"\\b"));let ae="";return Z.global&&(ae+="g"),Z.matchCase||(ae+="i"),Z.multiline&&(ae+="m"),Z.unicode&&(ae+="u"),new RegExp(S,ae)}function i(S){return S.source==="^"||S.source==="^$"||S.source==="$"||S.source==="^\\s*$"?!1:!!(S.exec("")&&S.lastIndex===0)}function s(S){return S.split(/\r\n|\r|\n/)}function o(S){const G=[],Z=S.split(/(\r\n|\r|\n)/);for(let ae=0;ae<Math.ceil(Z.length/2);ae++)G.push(Z[2*ae]+(Z[2*ae+1]??""));return G}function U(S){for(let G=0,Z=S.length;G<Z;G++){const ae=S.charCodeAt(G);if(ae!==t.CharCode.Space&&ae!==t.CharCode.Tab)return G}return-1}function _(S,G=0,Z=S.length){for(let ae=G;ae<Z;ae++){const me=S.charCodeAt(ae);if(me!==t.CharCode.Space&&me!==t.CharCode.Tab)return S.substring(G,ae)}return S.substring(G,Z)}function m(S,G=S.length-1){for(let Z=G;Z>=0;Z--){const ae=S.charCodeAt(Z);if(ae!==t.CharCode.Space&&ae!==t.CharCode.Tab)return Z}return-1}function f(S,G,Z){const ae=[];let me=0;for(const De of S.matchAll(G)){if(ae.push(S.slice(me,De.index)),De.index===void 0)throw new Error("match.index should be defined");me=De.index+De[0].length,ae.push(Z(De[0],...De.slice(1),De.index,S,De.groups))}return ae.push(S.slice(me)),Promise.all(ae).then(De=>De.join(""))}function A(S,G){return S<G?-1:S>G?1:0}function R(S,G,Z=0,ae=S.length,me=0,De=G.length){for(;Z<ae&&me<De;Z++,me++){const Ne=S.charCodeAt(Z),Me=G.charCodeAt(me);if(Ne<Me)return-1;if(Ne>Me)return 1}const Oe=ae-Z,We=De-me;return Oe<We?-1:Oe>We?1:0}function u(S,G){return D(S,G,0,S.length,0,G.length)}function D(S,G,Z=0,ae=S.length,me=0,De=G.length){for(;Z<ae&&me<De;Z++,me++){let Ne=S.charCodeAt(Z),Me=G.charCodeAt(me);if(Ne===Me)continue;if(Ne>=128||Me>=128)return R(S.toLowerCase(),G.toLowerCase(),Z,ae,me,De);x(Ne)&&(Ne-=32),x(Me)&&(Me-=32);const Ue=Ne-Me;if(Ue!==0)return Ue}const Oe=ae-Z,We=De-me;return Oe<We?-1:Oe>We?1:0}function C(S){return S>=t.CharCode.Digit0&&S<=t.CharCode.Digit9}function x(S){return S>=t.CharCode.a&&S<=t.CharCode.z}function X(S){return S>=t.CharCode.A&&S<=t.CharCode.Z}function H(S,G){return S.length===G.length&&D(S,G)===0}function se(S,G){const Z=G.length;return G.length>S.length?!1:D(S,G,0,Z)===0}function K(S,G){const Z=Math.min(S.length,G.length);let ae;for(ae=0;ae<Z;ae++)if(S.charCodeAt(ae)!==G.charCodeAt(ae))return ae;return Z}function ie(S,G){const Z=Math.min(S.length,G.length);let ae;const me=S.length-1,De=G.length-1;for(ae=0;ae<Z;ae++)if(S.charCodeAt(me-ae)!==G.charCodeAt(De-ae))return ae;return Z}function re(S){return 55296<=S&&S<=56319}function oe(S){return 56320<=S&&S<=57343}function I(S,G){return(S-55296<<10)+(G-56320)+65536}function g(S,G,Z){const ae=S.charCodeAt(Z);if(re(ae)&&Z+1<G){const me=S.charCodeAt(Z+1);if(oe(me))return I(ae,me)}return ae}function F(S,G){const Z=S.charCodeAt(G-1);if(oe(Z)&&G>1){const ae=S.charCodeAt(G-2);if(re(ae))return I(ae,Z)}return Z}class j{get offset(){return this._offset}constructor(G,Z=0){this._str=G,this._len=G.length,this._offset=Z}setOffset(G){this._offset=G}prevCodePoint(){const G=F(this._str,this._offset);return this._offset-=G>=W.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,G}nextCodePoint(){const G=g(this._str,this._len,this._offset);return this._offset+=G>=W.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,G}eol(){return this._offset>=this._len}}e.CodePointIterator=j;class Y{get offset(){return this._iterator.offset}constructor(G,Z=0){this._iterator=new j(G,Z)}nextGraphemeLength(){const G=Fe.getInstance(),Z=this._iterator,ae=Z.offset;let me=G.getGraphemeBreakType(Z.nextCodePoint());for(;!Z.eol();){const De=Z.offset,Oe=G.getGraphemeBreakType(Z.nextCodePoint());if(Pe(me,Oe)){Z.setOffset(De);break}me=Oe}return Z.offset-ae}prevGraphemeLength(){const G=Fe.getInstance(),Z=this._iterator,ae=Z.offset;let me=G.getGraphemeBreakType(Z.prevCodePoint());for(;Z.offset>0;){const De=Z.offset,Oe=G.getGraphemeBreakType(Z.prevCodePoint());if(Pe(Oe,me)){Z.setOffset(De);break}me=Oe}return ae-Z.offset}eol(){return this._iterator.eol()}}e.GraphemeIterator=Y;function L(S,G){return new Y(S,G).nextGraphemeLength()}function J(S,G){return new Y(S,G).prevGraphemeLength()}function ee(S,G){G>0&&oe(S.charCodeAt(G))&&G--;const Z=G+L(S,G);return[Z-J(S,Z),Z]}function ne(S){const G=new Y(S);let Z=0;for(;!G.eol();)Z++,G.nextGraphemeLength();return Z}let le;function fe(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function we(S){return le||(le=fe()),le.test(S)}const B=/^[\t\n\r\x20-\x7E]*$/;function z(S){return B.test(S)}e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function O(S){return e.UNUSUAL_LINE_TERMINATORS.test(S)}function h(S){return S>=11904&&S<=55215||S>=63744&&S<=64255||S>=65281&&S<=65374}function q(S){return S>=127462&&S<=127487||S===8986||S===8987||S===9200||S===9203||S>=9728&&S<=10175||S===11088||S===11093||S>=127744&&S<=128591||S>=128640&&S<=128764||S>=128992&&S<=129008||S>=129280&&S<=129535||S>=129648&&S<=129782}function Q(S,G,Z=""){const ae=S.trimStart();if(ae.length<G)return ae;const me=/\b/g;let De=0;for(;me.test(ae)&&!(ae.length-me.lastIndex<G);)De=me.lastIndex,me.lastIndex+=1;return De===0?ae:Z+ae.substring(De).trimStart()}const te=/(?:(?:\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~])|(:?\x1b\].*?\x07)/g;function*de(S){let G=0;for(const Z of S.matchAll(te))G!==Z.index&&(yield{isCode:!1,str:S.substring(G,Z.index)}),yield{isCode:!0,str:Z[0]},G=Z.index+Z[0].length;G!==S.length&&(yield{isCode:!1,str:S.substring(G)})}function ye(S){return S&&(S=S.replace(te,"")),S}const Le=/\\\[.*?\\\]/g;function Se(S){return ye(S).replace(Le,"")}e.UTF8_BOM_CHARACTER=String.fromCharCode(t.CharCode.UTF8_BOM);function ge(S){return!!(S&&S.length>0&&S.charCodeAt(0)===t.CharCode.UTF8_BOM)}function ue(S){return ge(S)?S.substr(1):S}function _e(S,G){if(!S||!G||S.length<G.length)return!1;const Z=G.length,ae=S.toLowerCase();let me=0,De=-1;for(;me<Z;){const Oe=ae.indexOf(G[me],De+1);if(Oe<0)return!1;De=Oe,me++}return!0}function he(S,G=!1){return S?(G&&(S=S.replace(/\\./g,"")),S.toLowerCase()!==S):!1}function be(S){return S.charAt(0).toUpperCase()+S.slice(1)}function Ae(S,G=1){if(G===0)return"";let Z=-1;do Z=S.indexOf(`
`,Z+1),G--;while(G>0&&Z>=0);return Z===-1?S:(S[Z-1]==="\r"&&Z--,S.substr(0,Z))}function Re(S){const G=t.CharCode.Z-t.CharCode.A+1;return S=S%(2*G),S<G?String.fromCharCode(t.CharCode.a+S):String.fromCharCode(t.CharCode.A+S-G)}function Te(S){return Fe.getInstance().getGraphemeBreakType(S)}function Pe(S,G){return S===ve.Other?G!==ve.Extend&&G!==ve.SpacingMark:S===ve.CR&&G===ve.LF?!1:S===ve.Control||S===ve.CR||S===ve.LF||G===ve.Control||G===ve.CR||G===ve.LF?!0:!(S===ve.L&&(G===ve.L||G===ve.V||G===ve.LV||G===ve.LVT)||(S===ve.LV||S===ve.V)&&(G===ve.V||G===ve.T)||(S===ve.LVT||S===ve.T)&&G===ve.T||G===ve.Extend||G===ve.ZWJ||G===ve.SpacingMark||S===ve.Prepend||S===ve.ZWJ&&G===ve.Extended_Pictographic||S===ve.Regional_Indicator&&G===ve.Regional_Indicator)}var ve;(function(S){S[S.Other=0]="Other",S[S.Prepend=1]="Prepend",S[S.CR=2]="CR",S[S.LF=3]="LF",S[S.Control=4]="Control",S[S.Extend=5]="Extend",S[S.Regional_Indicator=6]="Regional_Indicator",S[S.SpacingMark=7]="SpacingMark",S[S.L=8]="L",S[S.V=9]="V",S[S.T=10]="T",S[S.LV=11]="LV",S[S.LVT=12]="LVT",S[S.ZWJ=13]="ZWJ",S[S.Extended_Pictographic=14]="Extended_Pictographic"})(ve||(e.GraphemeBreakType=ve={}));class Fe{static{this._INSTANCE=null}static getInstance(){return Fe._INSTANCE||(Fe._INSTANCE=new Fe),Fe._INSTANCE}constructor(){this._data=Be()}getGraphemeBreakType(G){if(G<32)return G===t.CharCode.LineFeed?ve.LF:G===t.CharCode.CarriageReturn?ve.CR:ve.Control;if(G<127)return ve.Other;const Z=this._data,ae=Z.length/3;let me=1;for(;me<=ae;)if(G<Z[3*me])me=2*me;else if(G>Z[3*me+1])me=2*me+1;else return Z[3*me+2];return ve.Other}}function Be(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Ge(S,G){if(S===0)return 0;const Z=$e(S,G);if(Z!==void 0)return Z;const ae=new j(G,S);return ae.prevCodePoint(),ae.offset}function $e(S,G){const Z=new j(G,S);let ae=Z.prevCodePoint();for(;Ke(ae)||ae===Ce.emojiVariantSelector||ae===Ce.enclosingKeyCap;){if(Z.offset===0)return;ae=Z.prevCodePoint()}if(!q(ae))return;let me=Z.offset;return me>0&&Z.prevCodePoint()===Ce.zwj&&(me=Z.offset),me}function Ke(S){return 127995<=S&&S<=127999}var Ce;(function(S){S[S.zwj=8205]="zwj",S[S.emojiVariantSelector=65039]="emojiVariantSelector",S[S.enclosingKeyCap=8419]="enclosingKeyCap"})(Ce||(Ce={})),e.noBreakWhitespace="\xA0";class je{static{this.ambiguousCharacterData=new $.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.cache=new p.LRUCachedFunction({getCacheKey:JSON.stringify},G=>{function Z(Ue){const qe=new Map;for(let ke=0;ke<Ue.length;ke+=2)qe.set(Ue[ke],Ue[ke+1]);return qe}function ae(Ue,qe){const ke=new Map(Ue);for(const[He,Ve]of qe)ke.set(He,Ve);return ke}function me(Ue,qe){if(!Ue)return qe;const ke=new Map;for(const[He,Ve]of Ue)qe.has(He)&&ke.set(He,Ve);return ke}const De=this.ambiguousCharacterData.value;let Oe=G.filter(Ue=>!Ue.startsWith("_")&&Ue in De);Oe.length===0&&(Oe=["_default"]);let We;for(const Ue of Oe){const qe=Z(De[Ue]);We=me(We,qe)}const Ne=Z(De._common),Me=ae(Ne,We);return new je(Me)})}static getInstance(G){return je.cache.get(Array.from(G))}static{this._locales=new $.Lazy(()=>Object.keys(je.ambiguousCharacterData.value).filter(G=>!G.startsWith("_")))}static getLocales(){return je._locales.value}constructor(G){this.confusableDictionary=G}isAmbiguous(G){return this.confusableDictionary.has(G)}containsAmbiguousCharacter(G){for(let Z=0;Z<G.length;Z++){const ae=G.codePointAt(Z);if(typeof ae=="number"&&this.isAmbiguous(ae))return!0}return!1}getPrimaryConfusable(G){return this.confusableDictionary.get(G)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}e.AmbiguousCharacters=je;class ze{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this._data=void 0}static getData(){return this._data||(this._data=new Set(ze.getRawData())),this._data}static isInvisibleCharacter(G){return ze.getData().has(G)}static containsInvisibleCharacter(G){for(let Z=0;Z<G.length;Z++){const ae=G.codePointAt(Z);if(typeof ae=="number"&&ze.isInvisibleCharacter(ae))return!0}return!1}static get codePoints(){return ze.getData()}}e.InvisibleCharacters=ze}),define(Ee[29],pe([0,1,12,11,7]),function(ce,e,p,t,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class W{constructor(){this._value="",this._pos=0}reset(a){return this._value=a,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(a){const r=a.charCodeAt(0),d=this._value.charCodeAt(this._pos);return r-d}value(){return this._value[this._pos]}}e.StringIterator=W;class V{constructor(a=!0){this._caseSensitive=a}reset(a){return this._value=a,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let a=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===t.CharCode.Period)if(a)this._from++;else break;else a=!1;return this}cmp(a){return this._caseSensitive?(0,$.compareSubstring)(a,this._value,0,a.length,this._from,this._to):(0,$.compareSubstringIgnoreCase)(a,this._value,0,a.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=V;class k{constructor(a=!0,r=!0){this._splitOnBackslash=a,this._caseSensitive=r}reset(a){this._from=0,this._to=0,this._value=a,this._valueLen=a.length;for(let r=a.length-1;r>=0;r--,this._valueLen--){const d=this._value.charCodeAt(r);if(!(d===t.CharCode.Slash||this._splitOnBackslash&&d===t.CharCode.Backslash))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let a=!0;for(;this._to<this._valueLen;this._to++){const r=this._value.charCodeAt(this._to);if(r===t.CharCode.Slash||this._splitOnBackslash&&r===t.CharCode.Backslash)if(a)this._from++;else break;else a=!1}return this}cmp(a){return this._caseSensitive?(0,$.compareSubstring)(a,this._value,0,a.length,this._from,this._to):(0,$.compareSubstringIgnoreCase)(a,this._value,0,a.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=k;var T;(function(M){M[M.Scheme=1]="Scheme",M[M.Authority=2]="Authority",M[M.Path=3]="Path",M[M.Query=4]="Query",M[M.Fragment=5]="Fragment"})(T||(T={}));class P{constructor(a,r){this._ignorePathCasing=a,this._ignoreQueryAndFragment=r,this._states=[],this._stateIdx=0}reset(a){return this._value=a,this._states=[],this._value.scheme&&this._states.push(T.Scheme),this._value.authority&&this._states.push(T.Authority),this._value.path&&(this._pathIterator=new k(!1,!this._ignorePathCasing(a)),this._pathIterator.reset(a.path),this._pathIterator.value()&&this._states.push(T.Path)),this._ignoreQueryAndFragment(a)||(this._value.query&&this._states.push(T.Query),this._value.fragment&&this._states.push(T.Fragment)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===T.Path&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===T.Path&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(a){if(this._states[this._stateIdx]===T.Scheme)return(0,$.compareIgnoreCase)(a,this._value.scheme);if(this._states[this._stateIdx]===T.Authority)return(0,$.compareIgnoreCase)(a,this._value.authority);if(this._states[this._stateIdx]===T.Path)return this._pathIterator.cmp(a);if(this._states[this._stateIdx]===T.Query)return(0,$.compare)(a,this._value.query);if(this._states[this._stateIdx]===T.Fragment)return(0,$.compare)(a,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===T.Scheme)return this._value.scheme;if(this._states[this._stateIdx]===T.Authority)return this._value.authority;if(this._states[this._stateIdx]===T.Path)return this._pathIterator.value();if(this._states[this._stateIdx]===T.Query)return this._value.query;if(this._states[this._stateIdx]===T.Fragment)return this._value.fragment;throw new Error}}e.UriIterator=P;class N{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const a=this.right;return this.right=a.left,a.left=this,this.updateHeight(),a.updateHeight(),a}rotateRight(){const a=this.left;return this.left=a.right,a.right=this,this.updateHeight(),a.updateHeight(),a}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var E;(function(M){M[M.Left=-1]="Left",M[M.Mid=0]="Mid",M[M.Right=1]="Right"})(E||(E={}));class y{static forUris(a=()=>!1,r=()=>!1){return new y(new P(a,r))}static forPaths(a=!1){return new y(new k(void 0,!a))}static forStrings(){return new y(new W)}static forConfigKeys(){return new y(new V)}constructor(a){this._iter=a}clear(){this._root=void 0}fill(a,r){if(r){const d=r.slice(0);(0,p.shuffle)(d);for(const b of d)this.set(b,a)}else{const d=a.slice(0);(0,p.shuffle)(d);for(const b of d)this.set(b[0],b[1])}}set(a,r){const d=this._iter.reset(a);let b;this._root||(this._root=new N,this._root.segment=d.value());const c=[];for(b=this._root;;){const w=d.cmp(b.segment);if(w>0)b.left||(b.left=new N,b.left.segment=d.value()),c.push([E.Left,b]),b=b.left;else if(w<0)b.right||(b.right=new N,b.right.segment=d.value()),c.push([E.Right,b]),b=b.right;else if(d.hasNext())d.next(),b.mid||(b.mid=new N,b.mid.segment=d.value()),c.push([E.Mid,b]),b=b.mid;else break}const v=b.value;b.value=r,b.key=a;for(let w=c.length-1;w>=0;w--){const l=c[w][1];l.updateHeight();const n=l.balanceFactor();if(n<-1||n>1){const i=c[w][0],s=c[w+1][0];if(i===E.Right&&s===E.Right)c[w][1]=l.rotateLeft();else if(i===E.Left&&s===E.Left)c[w][1]=l.rotateRight();else if(i===E.Right&&s===E.Left)l.right=c[w+1][1]=c[w+1][1].rotateRight(),c[w][1]=l.rotateLeft();else if(i===E.Left&&s===E.Right)l.left=c[w+1][1]=c[w+1][1].rotateLeft(),c[w][1]=l.rotateRight();else throw new Error;if(w>0)switch(c[w-1][0]){case E.Left:c[w-1][1].left=c[w][1];break;case E.Right:c[w-1][1].right=c[w][1];break;case E.Mid:c[w-1][1].mid=c[w][1];break}else this._root=c[0][1]}}return v}get(a){return this._getNode(a)?.value}_getNode(a){const r=this._iter.reset(a);let d=this._root;for(;d;){const b=r.cmp(d.segment);if(b>0)d=d.left;else if(b<0)d=d.right;else if(r.hasNext())r.next(),d=d.mid;else break}return d}has(a){const r=this._getNode(a);return!(r?.value===void 0&&r?.mid===void 0)}delete(a){return this._delete(a,!1)}deleteSuperstr(a){return this._delete(a,!0)}_delete(a,r){const d=this._iter.reset(a),b=[];let c=this._root;for(;c;){const v=d.cmp(c.segment);if(v>0)b.push([E.Left,c]),c=c.left;else if(v<0)b.push([E.Right,c]),c=c.right;else if(d.hasNext())d.next(),b.push([E.Mid,c]),c=c.mid;else break}if(c){if(r?(c.left=void 0,c.mid=void 0,c.right=void 0,c.height=1):(c.key=void 0,c.value=void 0),!c.mid&&!c.value)if(c.left&&c.right){const v=this._min(c.right);if(v.key){const{key:w,value:l,segment:n}=v;this._delete(v.key,!1),c.key=w,c.value=l,c.segment=n}}else{const v=c.left??c.right;if(b.length>0){const[w,l]=b[b.length-1];switch(w){case E.Left:l.left=v;break;case E.Mid:l.mid=v;break;case E.Right:l.right=v;break}}else this._root=v}for(let v=b.length-1;v>=0;v--){const w=b[v][1];w.updateHeight();const l=w.balanceFactor();if(l>1?(w.right.balanceFactor()>=0||(w.right=w.right.rotateRight()),b[v][1]=w.rotateLeft()):l<-1&&(w.left.balanceFactor()<=0||(w.left=w.left.rotateLeft()),b[v][1]=w.rotateRight()),v>0)switch(b[v-1][0]){case E.Left:b[v-1][1].left=b[v][1];break;case E.Right:b[v-1][1].right=b[v][1];break;case E.Mid:b[v-1][1].mid=b[v][1];break}else this._root=b[0][1]}}}_min(a){for(;a.left;)a=a.left;return a}findSubstr(a){const r=this._iter.reset(a);let d=this._root,b;for(;d;){const c=r.cmp(d.segment);if(c>0)d=d.left;else if(c<0)d=d.right;else if(r.hasNext())r.next(),b=d.value||b,d=d.mid;else break}return d&&d.value||b}findSuperstr(a){return this._findSuperstrOrElement(a,!1)}_findSuperstrOrElement(a,r){const d=this._iter.reset(a);let b=this._root;for(;b;){const c=d.cmp(b.segment);if(c>0)b=b.left;else if(c<0)b=b.right;else if(d.hasNext())d.next(),b=b.mid;else return b.mid?this._entries(b.mid):r?b.value:void 0}}hasElementOrSubtree(a){return this._findSuperstrOrElement(a,!0)!==void 0}forEach(a){for(const[r,d]of this)a(d,r)}*[Symbol.iterator](){yield*this._entries(this._root)}_entries(a){const r=[];return this._dfsEntries(a,r),r[Symbol.iterator]()}_dfsEntries(a,r){a&&(a.left&&this._dfsEntries(a.left,r),a.value&&r.push([a.key,a.value]),a.mid&&this._dfsEntries(a.mid,r),a.right&&this._dfsEntries(a.right,r))}_isBalanced(){const a=r=>{if(!r)return!0;const d=r.balanceFactor();return d<-1||d>1?!1:a(r.left)&&a(r.right)};return a(this._root)}}e.TernarySearchTree=y}),define(Ee[30],pe([0,1]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isUtilityProcess=p;function p(t){return!!t.parentPort}}),define(Ee[31],pe([0,1]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNLSMessages=p,e.getNLSLanguage=t;function p(){return globalThis._VSCODE_NLS_MESSAGES}function t(){return globalThis._VSCODE_NLS_LANGUAGE}}),define(Ee[22],pe([0,1,31,31]),function(ce,e,p,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNLSMessages=e.getNLSLanguage=void 0,e.localize=V,e.localize2=T,Object.defineProperty(e,"getNLSLanguage",{enumerable:!0,get:function(){return t.getNLSLanguage}}),Object.defineProperty(e,"getNLSMessages",{enumerable:!0,get:function(){return t.getNLSMessages}});const $=(0,p.getNLSLanguage)()==="pseudo"||typeof document<"u"&&document.location&&document.location.hash.indexOf("pseudo=true")>=0;function W(P,N){let E;return N.length===0?E=P:E=P.replace(/\{(\d+)\}/g,(y,M)=>{const a=M[0],r=N[a];let d=y;return typeof r=="string"?d=r:(typeof r=="number"||typeof r=="boolean"||r===void 0||r===null)&&(d=String(r)),d}),$&&(E="\uFF3B"+E.replace(/[aouei]/g,"$&$&")+"\uFF3D"),E}function V(P,N,...E){return W(typeof P=="number"?k(P,N):N,E)}function k(P,N){const E=(0,p.getNLSMessages)()?.[P];if(typeof E!="string"){if(typeof N=="string")return N;throw new Error(`!!! NLS MISSING: ${P} !!!`)}return E}function T(P,N,...E){let y;typeof P=="number"?y=k(P,N):y=N;const M=W(y,E);return{value:M,original:N===y?M:W(N,E)}}}),define(Ee[49],pe([0,1,12,10,22]),function(ce,e,p,t,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=T,e.isErrorWithActions=P,e.createErrorWithActions=N,p=Ie(p),t=Ie(t),$=Ie($);function W(E,y){return y&&(E.stack||E.stacktrace)?$.localize(107,null,k(E),V(E.stack)||V(E.stacktrace)):k(E)}function V(E){return Array.isArray(E)?E.join(`
`):E}function k(E){return E.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${E.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof E.code=="string"&&typeof E.errno=="number"&&typeof E.syscall=="string"?$.localize(108,null,E.message):E.message||$.localize(109,null)}function T(E=null,y=!1){if(!E)return $.localize(110,null);if(Array.isArray(E)){const M=p.coalesce(E),a=T(M[0],y);return M.length>1?$.localize(111,null,a,M.length):a}if(t.isString(E))return E;if(E.detail){const M=E.detail;if(M.error)return W(M.error,y);if(M.exception)return W(M.exception,y)}return E.stack?W(E,y):E.message?E.message:$.localize(112,null)}function P(E){const y=E;return y instanceof Error&&Array.isArray(y.actions)}function N(E,y){let M;return typeof E=="string"?M=new Error(E):M=E,M.actions=y,M}}),define(Ee[2],pe([0,1,22]),function(ce,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.platformLocale=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isMobile=e.isIOS=e.webWorkerOrigin=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.Platform=e.LANGUAGE_DEFAULT=void 0,e.PlatformToString=i,e.isLittleEndian=f,e.isBigSurOrNewer=A,p=Ie(p),e.LANGUAGE_DEFAULT="en";let t=!1,$=!1,W=!1,V=!1,k=!1,T=!1,P=!1,N=!1,E=!1,y=!1,M,a=e.LANGUAGE_DEFAULT,r=e.LANGUAGE_DEFAULT,d,b;const c=globalThis;let v;typeof c.vscode<"u"&&typeof c.vscode.process<"u"?v=c.vscode.process:typeof process<"u"&&typeof process?.versions?.node=="string"&&(v=process);const w=typeof v?.versions?.electron=="string",l=w&&v?.type==="renderer";if(typeof v=="object"){t=v.platform==="win32",$=v.platform==="darwin",W=v.platform==="linux",V=W&&!!v.env.SNAP&&!!v.env.SNAP_REVISION,P=w,E=!!v.env.CI||!!v.env.BUILD_ARTIFACTSTAGINGDIRECTORY,M=e.LANGUAGE_DEFAULT,a=e.LANGUAGE_DEFAULT;const R=v.env.VSCODE_NLS_CONFIG;if(R)try{const u=JSON.parse(R);M=u.userLocale,r=u.osLocale,a=u.resolvedLanguage||e.LANGUAGE_DEFAULT,d=u.languagePack?.translationsConfigFile}catch{}k=!0}else typeof navigator=="object"&&!l?(b=navigator.userAgent,t=b.indexOf("Windows")>=0,$=b.indexOf("Macintosh")>=0,N=(b.indexOf("Macintosh")>=0||b.indexOf("iPad")>=0||b.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,W=b.indexOf("Linux")>=0,y=b?.indexOf("Mobi")>=0,T=!0,a=p.getNLSLanguage()||e.LANGUAGE_DEFAULT,M=navigator.language.toLowerCase(),r=M):console.error("Unable to resolve platform.");var n;(function(R){R[R.Web=0]="Web",R[R.Mac=1]="Mac",R[R.Linux=2]="Linux",R[R.Windows=3]="Windows"})(n||(e.Platform=n={}));function i(R){switch(R){case n.Web:return"Web";case n.Mac:return"Mac";case n.Linux:return"Linux";case n.Windows:return"Windows"}}let s=n.Web;$?s=n.Mac:t?s=n.Windows:W&&(s=n.Linux),e.isWindows=t,e.isMacintosh=$,e.isLinux=W,e.isLinuxSnap=V,e.isNative=k,e.isElectron=P,e.isWeb=T,e.isWebWorker=T&&typeof c.importScripts=="function",e.webWorkerOrigin=e.isWebWorker?c.origin:void 0,e.isIOS=N,e.isMobile=y,e.isCI=E,e.platform=s,e.userAgent=b,e.language=a;var o;(function(R){function u(){return e.language}R.value=u;function D(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}R.isDefaultVariant=D;function C(){return e.language==="en"}R.isDefault=C})(o||(e.Language=o={})),e.locale=M,e.platformLocale=r,e.translationsConfigFile=d,e.setTimeout0IsFaster=typeof c.postMessage=="function"&&!c.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const R=[];c.addEventListener("message",D=>{if(D.data&&D.data.vscodeScheduleAsyncWork)for(let C=0,x=R.length;C<x;C++){const X=R[C];if(X.id===D.data.vscodeScheduleAsyncWork){R.splice(C,1),X.callback();return}}});let u=0;return D=>{const C=++u;R.push({id:C,callback:D}),c.postMessage({vscodeScheduleAsyncWork:C},"*")}}return R=>setTimeout(R)})();var U;(function(R){R[R.Windows=1]="Windows",R[R.Macintosh=2]="Macintosh",R[R.Linux=3]="Linux"})(U||(e.OperatingSystem=U={})),e.OS=$||N?U.Macintosh:t?U.Windows:U.Linux;let _=!0,m=!1;function f(){if(!m){m=!0;const R=new Uint8Array(2);R[0]=1,R[1]=2,_=new Uint16Array(R.buffer)[0]===513}return _}e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0);function A(R){return parseFloat(R)>=20}}),define(Ee[32],pe([0,1,2]),function(ce,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let t;const $=globalThis.vscode;if(typeof $<"u"&&typeof $.process<"u"){const W=$.process;t={get platform(){return W.platform},get arch(){return W.arch},get env(){return W.env},cwd(){return W.cwd()}}}else typeof process<"u"&&typeof process?.versions?.node=="string"?t={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:t={get platform(){return p.isWindows?"win32":p.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=t.cwd,e.env=t.env,e.platform=t.platform,e.arch=t.arch}),define(Ee[3],pe([0,1,32]),function(ce,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0,p=Ie(p);const t=65,$=97,W=90,V=122,k=46,T=47,P=92,N=58,E=63;class y extends Error{constructor(s,o,U){let _;typeof o=="string"&&o.indexOf("not ")===0?(_="must not be",o=o.replace(/^not /,"")):_="must be";const m=s.indexOf(".")!==-1?"property":"argument";let f=`The "${s}" ${m} ${_} of type ${o}`;f+=`. Received type ${typeof U}`,super(f),this.code="ERR_INVALID_ARG_TYPE"}}function M(i,s){if(i===null||typeof i!="object")throw new y(s,"Object",i)}function a(i,s){if(typeof i!="string")throw new y(s,"string",i)}const r=p.platform==="win32";function d(i){return i===T||i===P}function b(i){return i===T}function c(i){return i>=t&&i<=W||i>=$&&i<=V}function v(i,s,o,U){let _="",m=0,f=-1,A=0,R=0;for(let u=0;u<=i.length;++u){if(u<i.length)R=i.charCodeAt(u);else{if(U(R))break;R=T}if(U(R)){if(!(f===u-1||A===1))if(A===2){if(_.length<2||m!==2||_.charCodeAt(_.length-1)!==k||_.charCodeAt(_.length-2)!==k){if(_.length>2){const D=_.lastIndexOf(o);D===-1?(_="",m=0):(_=_.slice(0,D),m=_.length-1-_.lastIndexOf(o)),f=u,A=0;continue}else if(_.length!==0){_="",m=0,f=u,A=0;continue}}s&&(_+=_.length>0?`${o}..`:"..",m=2)}else _.length>0?_+=`${o}${i.slice(f+1,u)}`:_=i.slice(f+1,u),m=u-f-1;f=u,A=0}else R===k&&A!==-1?++A:A=-1}return _}function w(i){return i?`${i[0]==="."?"":"."}${i}`:""}function l(i,s){M(s,"pathObject");const o=s.dir||s.root,U=s.base||`${s.name||""}${w(s.ext)}`;return o?o===s.root?`${o}${U}`:`${o}${i}${U}`:U}e.win32={resolve(...i){let s="",o="",U=!1;for(let _=i.length-1;_>=-1;_--){let m;if(_>=0){if(m=i[_],a(m,`paths[${_}]`),m.length===0)continue}else s.length===0?m=p.cwd():(m=p.env[`=${s}`]||p.cwd(),(m===void 0||m.slice(0,2).toLowerCase()!==s.toLowerCase()&&m.charCodeAt(2)===P)&&(m=`${s}\\`));const f=m.length;let A=0,R="",u=!1;const D=m.charCodeAt(0);if(f===1)d(D)&&(A=1,u=!0);else if(d(D))if(u=!0,d(m.charCodeAt(1))){let C=2,x=C;for(;C<f&&!d(m.charCodeAt(C));)C++;if(C<f&&C!==x){const X=m.slice(x,C);for(x=C;C<f&&d(m.charCodeAt(C));)C++;if(C<f&&C!==x){for(x=C;C<f&&!d(m.charCodeAt(C));)C++;(C===f||C!==x)&&(R=`\\\\${X}\\${m.slice(x,C)}`,A=C)}}}else A=1;else c(D)&&m.charCodeAt(1)===N&&(R=m.slice(0,2),A=2,f>2&&d(m.charCodeAt(2))&&(u=!0,A=3));if(R.length>0)if(s.length>0){if(R.toLowerCase()!==s.toLowerCase())continue}else s=R;if(U){if(s.length>0)break}else if(o=`${m.slice(A)}\\${o}`,U=u,u&&s.length>0)break}return o=v(o,!U,"\\",d),U?`${s}\\${o}`:`${s}${o}`||"."},normalize(i){a(i,"path");const s=i.length;if(s===0)return".";let o=0,U,_=!1;const m=i.charCodeAt(0);if(s===1)return b(m)?"\\":i;if(d(m))if(_=!0,d(i.charCodeAt(1))){let A=2,R=A;for(;A<s&&!d(i.charCodeAt(A));)A++;if(A<s&&A!==R){const u=i.slice(R,A);for(R=A;A<s&&d(i.charCodeAt(A));)A++;if(A<s&&A!==R){for(R=A;A<s&&!d(i.charCodeAt(A));)A++;if(A===s)return`\\\\${u}\\${i.slice(R)}\\`;A!==R&&(U=`\\\\${u}\\${i.slice(R,A)}`,o=A)}}}else o=1;else c(m)&&i.charCodeAt(1)===N&&(U=i.slice(0,2),o=2,s>2&&d(i.charCodeAt(2))&&(_=!0,o=3));let f=o<s?v(i.slice(o),!_,"\\",d):"";return f.length===0&&!_&&(f="."),f.length>0&&d(i.charCodeAt(s-1))&&(f+="\\"),U===void 0?_?`\\${f}`:f:_?`${U}\\${f}`:`${U}${f}`},isAbsolute(i){a(i,"path");const s=i.length;if(s===0)return!1;const o=i.charCodeAt(0);return d(o)||s>2&&c(o)&&i.charCodeAt(1)===N&&d(i.charCodeAt(2))},join(...i){if(i.length===0)return".";let s,o;for(let m=0;m<i.length;++m){const f=i[m];a(f,"path"),f.length>0&&(s===void 0?s=o=f:s+=`\\${f}`)}if(s===void 0)return".";let U=!0,_=0;if(typeof o=="string"&&d(o.charCodeAt(0))){++_;const m=o.length;m>1&&d(o.charCodeAt(1))&&(++_,m>2&&(d(o.charCodeAt(2))?++_:U=!1))}if(U){for(;_<s.length&&d(s.charCodeAt(_));)_++;_>=2&&(s=`\\${s.slice(_)}`)}return e.win32.normalize(s)},relative(i,s){if(a(i,"from"),a(s,"to"),i===s)return"";const o=e.win32.resolve(i),U=e.win32.resolve(s);if(o===U||(i=o.toLowerCase(),s=U.toLowerCase(),i===s))return"";let _=0;for(;_<i.length&&i.charCodeAt(_)===P;)_++;let m=i.length;for(;m-1>_&&i.charCodeAt(m-1)===P;)m--;const f=m-_;let A=0;for(;A<s.length&&s.charCodeAt(A)===P;)A++;let R=s.length;for(;R-1>A&&s.charCodeAt(R-1)===P;)R--;const u=R-A,D=f<u?f:u;let C=-1,x=0;for(;x<D;x++){const H=i.charCodeAt(_+x);if(H!==s.charCodeAt(A+x))break;H===P&&(C=x)}if(x!==D){if(C===-1)return U}else{if(u>D){if(s.charCodeAt(A+x)===P)return U.slice(A+x+1);if(x===2)return U.slice(A+x)}f>D&&(i.charCodeAt(_+x)===P?C=x:x===2&&(C=3)),C===-1&&(C=0)}let X="";for(x=_+C+1;x<=m;++x)(x===m||i.charCodeAt(x)===P)&&(X+=X.length===0?"..":"\\..");return A+=C,X.length>0?`${X}${U.slice(A,R)}`:(U.charCodeAt(A)===P&&++A,U.slice(A,R))},toNamespacedPath(i){if(typeof i!="string"||i.length===0)return i;const s=e.win32.resolve(i);if(s.length<=2)return i;if(s.charCodeAt(0)===P){if(s.charCodeAt(1)===P){const o=s.charCodeAt(2);if(o!==E&&o!==k)return`\\\\?\\UNC\\${s.slice(2)}`}}else if(c(s.charCodeAt(0))&&s.charCodeAt(1)===N&&s.charCodeAt(2)===P)return`\\\\?\\${s}`;return i},dirname(i){a(i,"path");const s=i.length;if(s===0)return".";let o=-1,U=0;const _=i.charCodeAt(0);if(s===1)return d(_)?i:".";if(d(_)){if(o=U=1,d(i.charCodeAt(1))){let A=2,R=A;for(;A<s&&!d(i.charCodeAt(A));)A++;if(A<s&&A!==R){for(R=A;A<s&&d(i.charCodeAt(A));)A++;if(A<s&&A!==R){for(R=A;A<s&&!d(i.charCodeAt(A));)A++;if(A===s)return i;A!==R&&(o=U=A+1)}}}}else c(_)&&i.charCodeAt(1)===N&&(o=s>2&&d(i.charCodeAt(2))?3:2,U=o);let m=-1,f=!0;for(let A=s-1;A>=U;--A)if(d(i.charCodeAt(A))){if(!f){m=A;break}}else f=!1;if(m===-1){if(o===-1)return".";m=o}return i.slice(0,m)},basename(i,s){s!==void 0&&a(s,"suffix"),a(i,"path");let o=0,U=-1,_=!0,m;if(i.length>=2&&c(i.charCodeAt(0))&&i.charCodeAt(1)===N&&(o=2),s!==void 0&&s.length>0&&s.length<=i.length){if(s===i)return"";let f=s.length-1,A=-1;for(m=i.length-1;m>=o;--m){const R=i.charCodeAt(m);if(d(R)){if(!_){o=m+1;break}}else A===-1&&(_=!1,A=m+1),f>=0&&(R===s.charCodeAt(f)?--f===-1&&(U=m):(f=-1,U=A))}return o===U?U=A:U===-1&&(U=i.length),i.slice(o,U)}for(m=i.length-1;m>=o;--m)if(d(i.charCodeAt(m))){if(!_){o=m+1;break}}else U===-1&&(_=!1,U=m+1);return U===-1?"":i.slice(o,U)},extname(i){a(i,"path");let s=0,o=-1,U=0,_=-1,m=!0,f=0;i.length>=2&&i.charCodeAt(1)===N&&c(i.charCodeAt(0))&&(s=U=2);for(let A=i.length-1;A>=s;--A){const R=i.charCodeAt(A);if(d(R)){if(!m){U=A+1;break}continue}_===-1&&(m=!1,_=A+1),R===k?o===-1?o=A:f!==1&&(f=1):o!==-1&&(f=-1)}return o===-1||_===-1||f===0||f===1&&o===_-1&&o===U+1?"":i.slice(o,_)},format:l.bind(null,"\\"),parse(i){a(i,"path");const s={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return s;const o=i.length;let U=0,_=i.charCodeAt(0);if(o===1)return d(_)?(s.root=s.dir=i,s):(s.base=s.name=i,s);if(d(_)){if(U=1,d(i.charCodeAt(1))){let C=2,x=C;for(;C<o&&!d(i.charCodeAt(C));)C++;if(C<o&&C!==x){for(x=C;C<o&&d(i.charCodeAt(C));)C++;if(C<o&&C!==x){for(x=C;C<o&&!d(i.charCodeAt(C));)C++;C===o?U=C:C!==x&&(U=C+1)}}}}else if(c(_)&&i.charCodeAt(1)===N){if(o<=2)return s.root=s.dir=i,s;if(U=2,d(i.charCodeAt(2))){if(o===3)return s.root=s.dir=i,s;U=3}}U>0&&(s.root=i.slice(0,U));let m=-1,f=U,A=-1,R=!0,u=i.length-1,D=0;for(;u>=U;--u){if(_=i.charCodeAt(u),d(_)){if(!R){f=u+1;break}continue}A===-1&&(R=!1,A=u+1),_===k?m===-1?m=u:D!==1&&(D=1):m!==-1&&(D=-1)}return A!==-1&&(m===-1||D===0||D===1&&m===A-1&&m===f+1?s.base=s.name=i.slice(f,A):(s.name=i.slice(f,m),s.base=i.slice(f,A),s.ext=i.slice(m,A))),f>0&&f!==U?s.dir=i.slice(0,f-1):s.dir=s.root,s},sep:"\\",delimiter:";",win32:null,posix:null};const n=(()=>{if(r){const i=/\\/g;return()=>{const s=p.cwd().replace(i,"/");return s.slice(s.indexOf("/"))}}return()=>p.cwd()})();e.posix={resolve(...i){let s="",o=!1;for(let U=i.length-1;U>=-1&&!o;U--){const _=U>=0?i[U]:n();a(_,`paths[${U}]`),_.length!==0&&(s=`${_}/${s}`,o=_.charCodeAt(0)===T)}return s=v(s,!o,"/",b),o?`/${s}`:s.length>0?s:"."},normalize(i){if(a(i,"path"),i.length===0)return".";const s=i.charCodeAt(0)===T,o=i.charCodeAt(i.length-1)===T;return i=v(i,!s,"/",b),i.length===0?s?"/":o?"./":".":(o&&(i+="/"),s?`/${i}`:i)},isAbsolute(i){return a(i,"path"),i.length>0&&i.charCodeAt(0)===T},join(...i){if(i.length===0)return".";let s;for(let o=0;o<i.length;++o){const U=i[o];a(U,"path"),U.length>0&&(s===void 0?s=U:s+=`/${U}`)}return s===void 0?".":e.posix.normalize(s)},relative(i,s){if(a(i,"from"),a(s,"to"),i===s||(i=e.posix.resolve(i),s=e.posix.resolve(s),i===s))return"";const o=1,U=i.length,_=U-o,m=1,f=s.length-m,A=_<f?_:f;let R=-1,u=0;for(;u<A;u++){const C=i.charCodeAt(o+u);if(C!==s.charCodeAt(m+u))break;C===T&&(R=u)}if(u===A)if(f>A){if(s.charCodeAt(m+u)===T)return s.slice(m+u+1);if(u===0)return s.slice(m+u)}else _>A&&(i.charCodeAt(o+u)===T?R=u:u===0&&(R=0));let D="";for(u=o+R+1;u<=U;++u)(u===U||i.charCodeAt(u)===T)&&(D+=D.length===0?"..":"/..");return`${D}${s.slice(m+R)}`},toNamespacedPath(i){return i},dirname(i){if(a(i,"path"),i.length===0)return".";const s=i.charCodeAt(0)===T;let o=-1,U=!0;for(let _=i.length-1;_>=1;--_)if(i.charCodeAt(_)===T){if(!U){o=_;break}}else U=!1;return o===-1?s?"/":".":s&&o===1?"//":i.slice(0,o)},basename(i,s){s!==void 0&&a(s,"ext"),a(i,"path");let o=0,U=-1,_=!0,m;if(s!==void 0&&s.length>0&&s.length<=i.length){if(s===i)return"";let f=s.length-1,A=-1;for(m=i.length-1;m>=0;--m){const R=i.charCodeAt(m);if(R===T){if(!_){o=m+1;break}}else A===-1&&(_=!1,A=m+1),f>=0&&(R===s.charCodeAt(f)?--f===-1&&(U=m):(f=-1,U=A))}return o===U?U=A:U===-1&&(U=i.length),i.slice(o,U)}for(m=i.length-1;m>=0;--m)if(i.charCodeAt(m)===T){if(!_){o=m+1;break}}else U===-1&&(_=!1,U=m+1);return U===-1?"":i.slice(o,U)},extname(i){a(i,"path");let s=-1,o=0,U=-1,_=!0,m=0;for(let f=i.length-1;f>=0;--f){const A=i.charCodeAt(f);if(A===T){if(!_){o=f+1;break}continue}U===-1&&(_=!1,U=f+1),A===k?s===-1?s=f:m!==1&&(m=1):s!==-1&&(m=-1)}return s===-1||U===-1||m===0||m===1&&s===U-1&&s===o+1?"":i.slice(s,U)},format:l.bind(null,"/"),parse(i){a(i,"path");const s={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return s;const o=i.charCodeAt(0)===T;let U;o?(s.root="/",U=1):U=0;let _=-1,m=0,f=-1,A=!0,R=i.length-1,u=0;for(;R>=U;--R){const D=i.charCodeAt(R);if(D===T){if(!A){m=R+1;break}continue}f===-1&&(A=!1,f=R+1),D===k?_===-1?_=R:u!==1&&(u=1):_!==-1&&(u=-1)}if(f!==-1){const D=m===0&&o?1:m;_===-1||u===0||u===1&&_===f-1&&_===m+1?s.base=s.name=i.slice(D,f):(s.name=i.slice(D,_),s.base=i.slice(D,f),s.ext=i.slice(_,f))}return m>0?s.dir=i.slice(0,m-1):o&&(s.dir="/"),s},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=r?e.win32.normalize:e.posix.normalize,e.isAbsolute=r?e.win32.isAbsolute:e.posix.isAbsolute,e.join=r?e.win32.join:e.posix.join,e.resolve=r?e.win32.resolve:e.posix.resolve,e.relative=r?e.win32.relative:e.posix.relative,e.dirname=r?e.win32.dirname:e.posix.dirname,e.basename=r?e.win32.basename:e.posix.basename,e.extname=r?e.win32.extname:e.posix.extname,e.format=r?e.win32.format:e.posix.format,e.parse=r?e.win32.parse:e.posix.parse,e.toNamespacedPath=r?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=r?e.win32.sep:e.posix.sep,e.delimiter=r?e.win32.delimiter:e.posix.delimiter}),define(Ee[14],pe([0,1,11,3,2,7,10]),function(ce,e,p,t,$,W,V){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPathSeparator=k,e.toSlashes=T,e.toPosixPath=P,e.getRoot=N,e.isUNC=E,e.isValidBasename=r,e.isEqual=d,e.isEqualOrParent=b,e.isWindowsDriveLetter=c,e.sanitizeFilePath=v,e.removeTrailingPathSeparator=w,e.isRootOrDriveLetter=l,e.hasDriveLetter=n,e.getDriveLetter=i,e.indexOfPath=s,e.parseLineAndColumnAware=o,e.randomPath=m;function k(f){return f===p.CharCode.Slash||f===p.CharCode.Backslash}function T(f){return f.replace(/[\\/]/g,t.posix.sep)}function P(f){return f.indexOf("/")===-1&&(f=T(f)),/^[a-zA-Z]:(\/|$)/.test(f)&&(f="/"+f),f}function N(f,A=t.posix.sep){if(!f)return"";const R=f.length,u=f.charCodeAt(0);if(k(u)){if(k(f.charCodeAt(1))&&!k(f.charCodeAt(2))){let C=3;const x=C;for(;C<R&&!k(f.charCodeAt(C));C++);if(x!==C&&!k(f.charCodeAt(C+1))){for(C+=1;C<R;C++)if(k(f.charCodeAt(C)))return f.slice(0,C+1).replace(/[\\/]/g,A)}}return A}else if(c(u)&&f.charCodeAt(1)===p.CharCode.Colon)return k(f.charCodeAt(2))?f.slice(0,2)+A:f.slice(0,2);let D=f.indexOf("://");if(D!==-1){for(D+=3;D<R;D++)if(k(f.charCodeAt(D)))return f.slice(0,D+1)}return""}function E(f){if(!$.isWindows||!f||f.length<5)return!1;let A=f.charCodeAt(0);if(A!==p.CharCode.Backslash||(A=f.charCodeAt(1),A!==p.CharCode.Backslash))return!1;let R=2;const u=R;for(;R<f.length&&(A=f.charCodeAt(R),A!==p.CharCode.Backslash);R++);return!(u===R||(A=f.charCodeAt(R+1),isNaN(A)||A===p.CharCode.Backslash))}const y=/[\\/:\*\?"<>\|]/g,M=/[/]/g,a=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function r(f,A=$.isWindows){const R=A?y:M;return!(!f||f.length===0||/^\s+$/.test(f)||(R.lastIndex=0,R.test(f))||A&&a.test(f)||f==="."||f===".."||A&&f[f.length-1]==="."||A&&f.length!==f.trim().length||f.length>255)}function d(f,A,R){const u=f===A;return!R||u?u:!f||!A?!1:(0,W.equalsIgnoreCase)(f,A)}function b(f,A,R,u=t.sep){if(f===A)return!0;if(!f||!A||A.length>f.length)return!1;if(R){if(!(0,W.startsWithIgnoreCase)(f,A))return!1;if(A.length===f.length)return!0;let C=A.length;return A.charAt(A.length-1)===u&&C--,f.charAt(C)===u}return A.charAt(A.length-1)!==u&&(A+=u),f.indexOf(A)===0}function c(f){return f>=p.CharCode.A&&f<=p.CharCode.Z||f>=p.CharCode.a&&f<=p.CharCode.z}function v(f,A){return $.isWindows&&f.endsWith(":")&&(f+=t.sep),(0,t.isAbsolute)(f)||(f=(0,t.join)(A,f)),f=(0,t.normalize)(f),w(f)}function w(f){return $.isWindows?(f=(0,W.rtrim)(f,t.sep),f.endsWith(":")&&(f+=t.sep)):(f=(0,W.rtrim)(f,t.sep),f||(f=t.sep)),f}function l(f){const A=(0,t.normalize)(f);return $.isWindows?f.length>3?!1:n(A)&&(f.length===2||A.charCodeAt(2)===p.CharCode.Backslash):A===t.posix.sep}function n(f,A=$.isWindows){return A?c(f.charCodeAt(0))&&f.charCodeAt(1)===p.CharCode.Colon:!1}function i(f,A=$.isWindows){return n(f,A)?f[0]:void 0}function s(f,A,R){return A.length>f.length?-1:f===A?0:(R&&(f=f.toLowerCase(),A=A.toLowerCase()),f.indexOf(A))}function o(f){const A=f.split(":");let R,u,D;for(const C of A){const x=Number(C);(0,V.isNumber)(x)?u===void 0?u=x:D===void 0&&(D=x):R=R?[R,C].join(":"):C}if(!R)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:R,line:u!==void 0?u:void 0,column:D!==void 0?D:u!==void 0?1:void 0}}const U="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",_="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function m(f,A,R=8){let u="";for(let C=0;C<R;C++){let x;C===0&&$.isWindows&&!A&&(R===3||R===4)?x=_:x=U,u+=x.charAt(Math.floor(Math.random()*x.length))}let D;return A?D=`${A}-${u}`:D=u,f?(0,t.join)(f,D):D}}),define(Ee[33],pe([0,1,2]),function(ce,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminateResponseCode=e.Source=void 0,e.sanitizeProcessEnvironment=W,e.removeDangerousEnvVariables=V;var t;(function(k){k[k.stdout=0]="stdout",k[k.stderr=1]="stderr"})(t||(e.Source=t={}));var $;(function(k){k[k.Success=0]="Success",k[k.Unknown=1]="Unknown",k[k.AccessDenied=2]="AccessDenied",k[k.ProcessNotFound=3]="ProcessNotFound"})($||(e.TerminateResponseCode=$={}));function W(k,...T){const P=T.reduce((y,M)=>(y[M]=!0,y),{}),N=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(k).filter(y=>!P[y]).forEach(y=>{for(let M=0;M<N.length;M++)if(y.search(N[M])!==-1){delete k[y];break}})}function V(k){k&&(delete k.DEBUG,p.isLinux&&delete k.LD_PRELOAD)}}),define(Ee[5],pe([0,1,11,28,3,2]),function(ce,e,p,t,$,W){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URI=void 0,e.isUriComponents=d,e.uriToFsPath=n,$=Ie($);const V=/^\w[\w\d+.-]*$/,k=/^\//,T=/^\/\//;function P(_,m){if(!_.scheme&&m)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${_.authority}", path: "${_.path}", query: "${_.query}", fragment: "${_.fragment}"}`);if(_.scheme&&!V.test(_.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(_.path){if(_.authority){if(!k.test(_.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(T.test(_.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function N(_,m){return!_&&!m?"file":_}function E(_,m){switch(_){case"https":case"http":case"file":m?m[0]!==M&&(m=M+m):m=M;break}return m}const y="",M="/",a=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class r{static isUri(m){return m instanceof r?!0:m?typeof m.authority=="string"&&typeof m.fragment=="string"&&typeof m.path=="string"&&typeof m.query=="string"&&typeof m.scheme=="string"&&typeof m.fsPath=="string"&&typeof m.with=="function"&&typeof m.toString=="function":!1}constructor(m,f,A,R,u,D=!1){typeof m=="object"?(this.scheme=m.scheme||y,this.authority=m.authority||y,this.path=m.path||y,this.query=m.query||y,this.fragment=m.fragment||y):(this.scheme=N(m,D),this.authority=f||y,this.path=E(this.scheme,A||y),this.query=R||y,this.fragment=u||y,P(this,D))}get fsPath(){return n(this,!1)}with(m){if(!m)return this;let{scheme:f,authority:A,path:R,query:u,fragment:D}=m;return f===void 0?f=this.scheme:f===null&&(f=y),A===void 0?A=this.authority:A===null&&(A=y),R===void 0?R=this.path:R===null&&(R=y),u===void 0?u=this.query:u===null&&(u=y),D===void 0?D=this.fragment:D===null&&(D=y),f===this.scheme&&A===this.authority&&R===this.path&&u===this.query&&D===this.fragment?this:new c(f,A,R,u,D)}static parse(m,f=!1){const A=a.exec(m);return A?new c(A[2]||y,U(A[4]||y),U(A[5]||y),U(A[7]||y),U(A[9]||y),f):new c(y,y,y,y,y)}static file(m){let f=y;if(W.isWindows&&(m=m.replace(/\\/g,M)),m[0]===M&&m[1]===M){const A=m.indexOf(M,2);A===-1?(f=m.substring(2),m=M):(f=m.substring(2,A),m=m.substring(A)||M)}return new c("file",f,m,y,y)}static from(m,f){return new c(m.scheme,m.authority,m.path,m.query,m.fragment,f)}static joinPath(m,...f){if(!m.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let A;return W.isWindows&&m.scheme==="file"?A=r.file($.win32.join(n(m,!0),...f)).path:A=$.posix.join(m.path,...f),m.with({path:A})}toString(m=!1){return i(this,m)}toJSON(){return this}static revive(m){if(m){if(m instanceof r)return m;{const f=new c(m);return f._formatted=m.external??null,f._fsPath=m._sep===b?m.fsPath??null:null,f}}else return m}[Symbol.for("debug.description")](){return`URI(${this.toString()})`}}e.URI=r;function d(_){return!_||typeof _!="object"?!1:typeof _.scheme=="string"&&(typeof _.authority=="string"||typeof _.authority>"u")&&(typeof _.path=="string"||typeof _.path>"u")&&(typeof _.query=="string"||typeof _.query>"u")&&(typeof _.fragment=="string"||typeof _.fragment>"u")}const b=W.isWindows?1:void 0;class c extends r{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=n(this,!1)),this._fsPath}toString(m=!1){return m?i(this,!0):(this._formatted||(this._formatted=i(this,!1)),this._formatted)}toJSON(){const m={$mid:t.MarshalledId.Uri};return this._fsPath&&(m.fsPath=this._fsPath,m._sep=b),this._formatted&&(m.external=this._formatted),this.path&&(m.path=this.path),this.scheme&&(m.scheme=this.scheme),this.authority&&(m.authority=this.authority),this.query&&(m.query=this.query),this.fragment&&(m.fragment=this.fragment),m}}const v={[p.CharCode.Colon]:"%3A",[p.CharCode.Slash]:"%2F",[p.CharCode.QuestionMark]:"%3F",[p.CharCode.Hash]:"%23",[p.CharCode.OpenSquareBracket]:"%5B",[p.CharCode.CloseSquareBracket]:"%5D",[p.CharCode.AtSign]:"%40",[p.CharCode.ExclamationMark]:"%21",[p.CharCode.DollarSign]:"%24",[p.CharCode.Ampersand]:"%26",[p.CharCode.SingleQuote]:"%27",[p.CharCode.OpenParen]:"%28",[p.CharCode.CloseParen]:"%29",[p.CharCode.Asterisk]:"%2A",[p.CharCode.Plus]:"%2B",[p.CharCode.Comma]:"%2C",[p.CharCode.Semicolon]:"%3B",[p.CharCode.Equals]:"%3D",[p.CharCode.Space]:"%20"};function w(_,m,f){let A,R=-1;for(let u=0;u<_.length;u++){const D=_.charCodeAt(u);if(D>=p.CharCode.a&&D<=p.CharCode.z||D>=p.CharCode.A&&D<=p.CharCode.Z||D>=p.CharCode.Digit0&&D<=p.CharCode.Digit9||D===p.CharCode.Dash||D===p.CharCode.Period||D===p.CharCode.Underline||D===p.CharCode.Tilde||m&&D===p.CharCode.Slash||f&&D===p.CharCode.OpenSquareBracket||f&&D===p.CharCode.CloseSquareBracket||f&&D===p.CharCode.Colon)R!==-1&&(A+=encodeURIComponent(_.substring(R,u)),R=-1),A!==void 0&&(A+=_.charAt(u));else{A===void 0&&(A=_.substr(0,u));const C=v[D];C!==void 0?(R!==-1&&(A+=encodeURIComponent(_.substring(R,u)),R=-1),A+=C):R===-1&&(R=u)}}return R!==-1&&(A+=encodeURIComponent(_.substring(R))),A!==void 0?A:_}function l(_){let m;for(let f=0;f<_.length;f++){const A=_.charCodeAt(f);A===p.CharCode.Hash||A===p.CharCode.QuestionMark?(m===void 0&&(m=_.substr(0,f)),m+=v[A]):m!==void 0&&(m+=_[f])}return m!==void 0?m:_}function n(_,m){let f;return _.authority&&_.path.length>1&&_.scheme==="file"?f=`//${_.authority}${_.path}`:_.path.charCodeAt(0)===p.CharCode.Slash&&(_.path.charCodeAt(1)>=p.CharCode.A&&_.path.charCodeAt(1)<=p.CharCode.Z||_.path.charCodeAt(1)>=p.CharCode.a&&_.path.charCodeAt(1)<=p.CharCode.z)&&_.path.charCodeAt(2)===p.CharCode.Colon?m?f=_.path.substr(1):f=_.path[1].toLowerCase()+_.path.substr(2):f=_.path,W.isWindows&&(f=f.replace(/\//g,"\\")),f}function i(_,m){const f=m?l:w;let A="",{scheme:R,authority:u,path:D,query:C,fragment:x}=_;if(R&&(A+=R,A+=":"),(u||R==="file")&&(A+=M,A+=M),u){let X=u.indexOf("@");if(X!==-1){const H=u.substr(0,X);u=u.substr(X+1),X=H.lastIndexOf(":"),X===-1?A+=f(H,!1,!1):(A+=f(H.substr(0,X),!1,!1),A+=":",A+=f(H.substr(X+1),!1,!0)),A+="@"}u=u.toLowerCase(),X=u.lastIndexOf(":"),X===-1?A+=f(u,!1,!0):(A+=f(u.substr(0,X),!1,!0),A+=u.substr(X))}if(D){if(D.length>=3&&D.charCodeAt(0)===p.CharCode.Slash&&D.charCodeAt(2)===p.CharCode.Colon){const X=D.charCodeAt(1);X>=p.CharCode.A&&X<=p.CharCode.Z&&(D=`/${String.fromCharCode(X+32)}:${D.substr(3)}`)}else if(D.length>=2&&D.charCodeAt(1)===p.CharCode.Colon){const X=D.charCodeAt(0);X>=p.CharCode.A&&X<=p.CharCode.Z&&(D=`${String.fromCharCode(X+32)}:${D.substr(2)}`)}A+=f(D,!0,!1)}return C&&(A+="?",A+=f(C,!1,!1)),x&&(A+="#",A+=m?x:w(x,!1,!1)),A}function s(_){try{return decodeURIComponent(_)}catch{return _.length>3?_.substr(0,3)+s(_.substr(3)):_}}const o=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function U(_){return _.match(o)?_.replace(o,m=>s(m)):_}}),define(Ee[50],pe([0,1,5]),function(ce,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isRemoteConsoleLog=t,e.parse=$,e.getFirstFrame=W,e.log=k;function t(P){const N=P;return N&&typeof N.type=="string"&&typeof N.severity=="string"}function $(P){const N=[];let E;try{const y=JSON.parse(P.arguments),M=y[y.length-1];M&&M.__$stack&&(y.pop(),E=M.__$stack),N.push(...y)}catch{N.push("Unable to log remote console arguments",P.arguments)}return{args:N,stack:E}}function W(P){if(typeof P!="string")return W($(P).stack);const N=P;if(N){const E=V(N),y=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(E||"");if(y&&y.length===4)return{uri:p.URI.file(y[1]),line:Number(y[2]),column:Number(y[3])}}}function V(P){if(!P)return P;const N=P.indexOf(`
`);return N===-1?P:P.substring(0,N)}function k(P,N){const{args:E,stack:y}=$(P),M=typeof E[0]=="string"&&E.length===1;let a=V(y);a&&(a=`(${a.trim()})`);let r=[];if(typeof E[0]=="string"?a&&M?r=[`%c[${N}] %c${E[0]} %c${a}`,T("blue"),T(""),T("grey")]:r=[`%c[${N}] %c${E[0]}`,T("blue"),T(""),...E.slice(1)]:r=[`%c[${N}]%`,T("blue"),...E],a&&!M&&r.push(a),typeof console[P.severity]!="function")throw new Error("Unknown console method");console[P.severity].apply(console,r)}function T(P){return`color: ${P}`}}),define(Ee[51],pe([0,1,17,5,28]),function(ce,e,p,t,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.stringify=W,e.parse=V,e.revive=T;function W(P){return JSON.stringify(P,k)}function V(P){let N=JSON.parse(P);return N=T(N),N}function k(P,N){return N instanceof RegExp?{$mid:$.MarshalledId.Regexp,source:N.source,flags:N.flags}:N}function T(P,N=0){if(!P||N>200)return P;if(typeof P=="object"){switch(P.$mid){case $.MarshalledId.Uri:return t.URI.revive(P);case $.MarshalledId.Regexp:return new RegExp(P.source,P.flags);case $.MarshalledId.Date:return new Date(P.source)}if(P instanceof p.VSBuffer||P instanceof Uint8Array)return P;if(Array.isArray(P))for(let E=0;E<P.length;++E)P[E]=T(P[E],N+1);else for(const E in P)Object.hasOwnProperty.call(P,E)&&(P[E]=T(P[E],N+1))}return P}}),define(Ee[34],pe([0,1,9,2,7,5,3]),function(ce,e,p,t,$,W,V){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.VSCODE_AUTHORITY=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0,e.matchesScheme=T,e.matchesSomeScheme=P,e.getServerRootPath=E,p=Ie(p),t=Ie(t),V=Ie(V);var k;(function(a){a.inMemory="inmemory",a.vscode="vscode",a.internal="private",a.walkThrough="walkThrough",a.walkThroughSnippet="walkThroughSnippet",a.http="http",a.https="https",a.file="file",a.mailto="mailto",a.untitled="untitled",a.data="data",a.command="command",a.vscodeRemote="vscode-remote",a.vscodeRemoteResource="vscode-remote-resource",a.vscodeManagedRemoteResource="vscode-managed-remote-resource",a.vscodeUserData="vscode-userdata",a.vscodeCustomEditor="vscode-custom-editor",a.vscodeNotebookCell="vscode-notebook-cell",a.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",a.vscodeNotebookCellMetadataDiff="vscode-notebook-cell-metadata-diff",a.vscodeNotebookCellOutput="vscode-notebook-cell-output",a.vscodeNotebookCellOutputDiff="vscode-notebook-cell-output-diff",a.vscodeNotebookMetadata="vscode-notebook-metadata",a.vscodeInteractiveInput="vscode-interactive-input",a.vscodeSettings="vscode-settings",a.vscodeWorkspaceTrust="vscode-workspace-trust",a.vscodeTerminal="vscode-terminal",a.vscodeChatCodeBlock="vscode-chat-code-block",a.vscodeChatCodeCompareBlock="vscode-chat-code-compare-block",a.vscodeChatSesssion="vscode-chat-editor",a.webviewPanel="webview-panel",a.vscodeWebview="vscode-webview",a.extension="extension",a.vscodeFileResource="vscode-file",a.tmp="tmp",a.vsls="vsls",a.vscodeSourceControl="vscode-scm",a.commentsInput="comment",a.codeSetting="code-setting",a.outputChannel="output"})(k||(e.Schemas=k={}));function T(a,r){return W.URI.isUri(a)?(0,$.equalsIgnoreCase)(a.scheme,r):(0,$.startsWithIgnoreCase)(a,r+":")}function P(a,...r){return r.some(d=>T(a,d))}e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class N{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._serverRootPath="/"}setPreferredWebSchema(r){this._preferredWebSchema=r}setDelegate(r){this._delegate=r}setServerRootPath(r,d){this._serverRootPath=E(r,d)}getServerRootPath(){return this._serverRootPath}get _remoteResourcesPath(){return V.posix.join(this._serverRootPath,k.vscodeRemoteResource)}set(r,d,b){this._hosts[r]=d,this._ports[r]=b}setConnectionToken(r,d){this._connectionTokens[r]=d}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(r){if(this._delegate)try{return this._delegate(r)}catch(l){return p.onUnexpectedError(l),r}const d=r.authority;let b=this._hosts[d];b&&b.indexOf(":")!==-1&&b.indexOf("[")===-1&&(b=`[${b}]`);const c=this._ports[d],v=this._connectionTokens[d];let w=`path=${encodeURIComponent(r.path)}`;return typeof v=="string"&&(w+=`&${e.connectionTokenQueryName}=${encodeURIComponent(v)}`),W.URI.from({scheme:t.isWeb?this._preferredWebSchema:k.vscodeRemoteResource,authority:`${b}:${c}`,path:this._remoteResourcesPath,query:w})}}e.RemoteAuthorities=new N;function E(a,r){return V.posix.join(r??"/",`${a.quality??"oss"}-${a.commit??"dev"}`)}e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked",e.VSCODE_AUTHORITY="vscode-app";class y{static{this.FALLBACK_AUTHORITY=e.VSCODE_AUTHORITY}asBrowserUri(r){const d=this.toUri(r,ce);return this.uriToBrowserUri(d)}uriToBrowserUri(r){return r.scheme===k.vscodeRemote?e.RemoteAuthorities.rewrite(r):r.scheme===k.file&&(t.isNative||t.webWorkerOrigin===`${k.vscodeFileResource}://${y.FALLBACK_AUTHORITY}`)?r.with({scheme:k.vscodeFileResource,authority:r.authority||y.FALLBACK_AUTHORITY,query:null,fragment:null}):r}asFileUri(r){const d=this.toUri(r,ce);return this.uriToFileUri(d)}uriToFileUri(r){return r.scheme===k.vscodeFileResource?r.with({scheme:k.file,authority:r.authority!==y.FALLBACK_AUTHORITY?r.authority:null,query:null,fragment:null}):r}toUri(r,d){if(W.URI.isUri(r))return r;if(globalThis._VSCODE_FILE_ROOT){const b=globalThis._VSCODE_FILE_ROOT;if(/^\w[\w\d+.-]*:\/\//.test(b))return W.URI.joinPath(W.URI.parse(b,!0),r);const c=V.join(b,r);return W.URI.file(c)}return W.URI.parse(d.toUrl(r))}}e.FileAccess=new y;var M;(function(a){const r=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);a.CoopAndCoep=Object.freeze(r.get("3"));const d="vscode-coi";function b(v){let w;typeof v=="string"?w=new URL(v).searchParams:v instanceof URL?w=v.searchParams:W.URI.isUri(v)&&(w=new URL(v.toString(!0)).searchParams);const l=w?.get(d);if(l)return r.get(l)}a.getHeadersFromQuery=b;function c(v,w,l){if(!globalThis.crossOriginIsolated)return;const n=w&&l?"3":l?"2":"1";v instanceof URLSearchParams?v.set(d,n):v[d]=n}a.addSearchParam=c})(M||(e.COI=M={}))}),define(Ee[23],pe([0,1,11,14,34,3,2,7,5]),function(ce,e,p,t,$,W,V,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=void 0,e.originalFSPath=P,e.distinctParents=E,e.toLocalResource=M,t=Ie(t),W=Ie(W);function P(a){return(0,T.uriToFsPath)(a,!0)}class N{constructor(r){this._ignorePathCasing=r}compare(r,d,b=!1){return r===d?0:(0,k.compare)(this.getComparisonKey(r,b),this.getComparisonKey(d,b))}isEqual(r,d,b=!1){return r===d?!0:!r||!d?!1:this.getComparisonKey(r,b)===this.getComparisonKey(d,b)}getComparisonKey(r,d=!1){return r.with({path:this._ignorePathCasing(r)?r.path.toLowerCase():void 0,fragment:d?null:void 0}).toString()}ignorePathCasing(r){return this._ignorePathCasing(r)}isEqualOrParent(r,d,b=!1){if(r.scheme===d.scheme){if(r.scheme===$.Schemas.file)return t.isEqualOrParent(P(r),P(d),this._ignorePathCasing(r))&&r.query===d.query&&(b||r.fragment===d.fragment);if((0,e.isEqualAuthority)(r.authority,d.authority))return t.isEqualOrParent(r.path,d.path,this._ignorePathCasing(r),"/")&&r.query===d.query&&(b||r.fragment===d.fragment)}return!1}joinPath(r,...d){return T.URI.joinPath(r,...d)}basenameOrAuthority(r){return(0,e.basename)(r)||r.authority}basename(r){return W.posix.basename(r.path)}extname(r){return W.posix.extname(r.path)}dirname(r){if(r.path.length===0)return r;let d;return r.scheme===$.Schemas.file?d=T.URI.file(W.dirname(P(r))).path:(d=W.posix.dirname(r.path),r.authority&&d.length&&d.charCodeAt(0)!==p.CharCode.Slash&&(console.error(`dirname("${r.toString})) resulted in a relative path`),d="/")),r.with({path:d})}normalizePath(r){if(!r.path.length)return r;let d;return r.scheme===$.Schemas.file?d=T.URI.file(W.normalize(P(r))).path:d=W.posix.normalize(r.path),r.with({path:d})}relativePath(r,d){if(r.scheme!==d.scheme||!(0,e.isEqualAuthority)(r.authority,d.authority))return;if(r.scheme===$.Schemas.file){const v=W.relative(P(r),P(d));return V.isWindows?t.toSlashes(v):v}let b=r.path||"/";const c=d.path||"/";if(this._ignorePathCasing(r)){let v=0;for(const w=Math.min(b.length,c.length);v<w&&!(b.charCodeAt(v)!==c.charCodeAt(v)&&b.charAt(v).toLowerCase()!==c.charAt(v).toLowerCase());v++);b=c.substr(0,v)+b.substr(v)}return W.posix.relative(b,c)}resolvePath(r,d){if(r.scheme===$.Schemas.file){const b=T.URI.file(W.resolve(P(r),d));return r.with({authority:b.authority,path:b.path})}return d=t.toPosixPath(d),r.with({path:W.posix.resolve(r.path,d)})}isAbsolutePath(r){return!!r.path&&r.path[0]==="/"}isEqualAuthority(r,d){return r===d||r!==void 0&&d!==void 0&&(0,k.equalsIgnoreCase)(r,d)}hasTrailingPathSeparator(r,d=W.sep){if(r.scheme===$.Schemas.file){const b=P(r);return b.length>t.getRoot(b).length&&b[b.length-1]===d}else{const b=r.path;return b.length>1&&b.charCodeAt(b.length-1)===p.CharCode.Slash&&!/^[a-zA-Z]:(\/$|\\$)/.test(r.fsPath)}}removeTrailingPathSeparator(r,d=W.sep){return(0,e.hasTrailingPathSeparator)(r,d)?r.with({path:r.path.substr(0,r.path.length-1)}):r}addTrailingPathSeparator(r,d=W.sep){let b=!1;if(r.scheme===$.Schemas.file){const c=P(r);b=c!==void 0&&c.length===t.getRoot(c).length&&c[c.length-1]===d}else{d="/";const c=r.path;b=c.length===1&&c.charCodeAt(c.length-1)===p.CharCode.Slash}return!b&&!(0,e.hasTrailingPathSeparator)(r,d)?r.with({path:r.path+"/"}):r}}e.ExtUri=N,e.extUri=new N(()=>!1),e.extUriBiasedIgnorePathCase=new N(a=>a.scheme===$.Schemas.file?!V.isLinux:!0),e.extUriIgnorePathCase=new N(a=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function E(a,r){const d=[];for(let b=0;b<a.length;b++){const c=r(a[b]);a.some((v,w)=>w===b?!1:(0,e.isEqualOrParent)(c,r(v)))||d.push(a[b])}return d}var y;(function(a){a.META_DATA_LABEL="label",a.META_DATA_DESCRIPTION="description",a.META_DATA_SIZE="size",a.META_DATA_MIME="mime";function r(d){const b=new Map;d.path.substring(d.path.indexOf(";")+1,d.path.lastIndexOf(";")).split(";").forEach(w=>{const[l,n]=w.split(":");l&&n&&b.set(l,n)});const v=d.path.substring(0,d.path.indexOf(";"));return v&&b.set(a.META_DATA_MIME,v),b}a.parseMetaData=r})(y||(e.DataUri=y={}));function M(a,r,d){if(r){let b=a.path;return b&&b[0]!==W.posix.sep&&(b=W.posix.sep+b),a.with({scheme:d,authority:r,path:b})}return a.with({scheme:d})}}),define(Ee[8],pe([0,1,13,9,6,4,23,2,46,16]),function(ce,e,p,t,$,W,V,k,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AsyncIterableSource=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.LazyStatefulPromise=e.StatefulPromise=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.GlobalIdleValue=e.AbstractIdleValue=e._runWhenIdle=e.runWhenGlobalIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.LimitedQueue=e.Queue=e.Limiter=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=void 0,e.isThenable=N,e.createCancelablePromise=E,e.raceCancellation=y,e.raceCancellationError=M,e.raceCancellablePromises=a,e.raceTimeout=r,e.asPromise=d,e.promiseWithResolvers=b,e.timeout=_,e.disposableTimeout=m,e.sequence=f,e.first=A,e.firstParallel=R,e.retry=g,e.createCancelableAsyncIterable=B;function N(O){return!!O&&typeof O.then=="function"}function E(O){const h=new p.CancellationTokenSource,q=O(h.token),Q=new Promise((te,de)=>{const ye=h.token.onCancellationRequested(()=>{ye.dispose(),de(new t.CancellationError)});Promise.resolve(q).then(Le=>{ye.dispose(),h.dispose(),te(Le)},Le=>{ye.dispose(),h.dispose(),de(Le)})});return new class{cancel(){h.cancel(),h.dispose()}then(te,de){return Q.then(te,de)}catch(te){return this.then(void 0,te)}finally(te){return Q.finally(te)}}}function y(O,h,q){return new Promise((Q,te)=>{const de=h.onCancellationRequested(()=>{de.dispose(),Q(q)});O.then(Q,te).finally(()=>de.dispose())})}function M(O,h){return new Promise((q,Q)=>{const te=h.onCancellationRequested(()=>{te.dispose(),Q(new t.CancellationError)});O.then(q,Q).finally(()=>te.dispose())})}async function a(O){let h=-1;const q=O.map((Q,te)=>Q.then(de=>(h=te,de)));try{return await Promise.race(q)}finally{O.forEach((Q,te)=>{te!==h&&Q.cancel()})}}function r(O,h,q){let Q;const te=setTimeout(()=>{Q?.(void 0),q?.()},h);return Promise.race([O.finally(()=>clearTimeout(te)),new Promise(de=>Q=de)])}function d(O){return new Promise((h,q)=>{const Q=O();N(Q)?Q.then(h,q):h(Q)})}function b(){let O,h;return{promise:new Promise((Q,te)=>{O=Q,h=te}),resolve:O,reject:h}}class c{constructor(){this.isDisposed=!1,this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(h){if(this.isDisposed)return Promise.reject(new Error("Throttler is disposed"));if(this.activePromise){if(this.queuedPromiseFactory=h,!this.queuedPromise){const q=()=>{if(this.queuedPromise=null,this.isDisposed)return;const Q=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,Q};this.queuedPromise=new Promise(Q=>{this.activePromise.then(q,q).then(Q)})}return new Promise((q,Q)=>{this.queuedPromise.then(q,Q)})}return this.activePromise=h(),new Promise((q,Q)=>{this.activePromise.then(te=>{this.activePromise=null,q(te)},te=>{this.activePromise=null,Q(te)})})}dispose(){this.isDisposed=!0}}e.Throttler=c;class v{constructor(){this.current=Promise.resolve(null)}queue(h){return this.current=this.current.then(()=>h(),()=>h())}}e.Sequencer=v;class w{constructor(){this.promiseMap=new Map}queue(h,q){const te=(this.promiseMap.get(h)??Promise.resolve()).catch(()=>{}).then(q).finally(()=>{this.promiseMap.get(h)===te&&this.promiseMap.delete(h)});return this.promiseMap.set(h,te),te}}e.SequencerByKey=w;const l=(O,h)=>{let q=!0;const Q=setTimeout(()=>{q=!1,h()},O);return{isTriggered:()=>q,dispose:()=>{clearTimeout(Q),q=!1}}},n=O=>{let h=!0;return queueMicrotask(()=>{h&&(h=!1,O())}),{isTriggered:()=>h,dispose:()=>{h=!1}}};class i{constructor(h){this.defaultDelay=h,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(h,q=this.defaultDelay){this.task=h,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((te,de)=>{this.doResolve=te,this.doReject=de}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const te=this.task;return this.task=null,te()}}));const Q=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=q===T.MicrotaskDelay?n(Q):l(q,Q),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new t.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=i;class s{constructor(h){this.delayer=new i(h),this.throttler=new c}trigger(h,q){return this.delayer.trigger(()=>this.throttler.queue(h),q)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose(),this.throttler.dispose()}}e.ThrottledDelayer=s;class o{constructor(){this._isOpen=!1,this._promise=new Promise((h,q)=>{this._completePromise=h})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=o;class U extends o{constructor(h){super(),this._timeout=setTimeout(()=>this.open(),h)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=U;function _(O,h){return h?new Promise((q,Q)=>{const te=setTimeout(()=>{de.dispose(),q()},O),de=h.onCancellationRequested(()=>{clearTimeout(te),de.dispose(),Q(new t.CancellationError)})}):E(q=>_(O,q))}function m(O,h=0,q){const Q=setTimeout(()=>{O(),q&&te.dispose()},h),te=(0,W.toDisposable)(()=>{clearTimeout(Q),q?.deleteAndLeak(te)});return q?.add(te),te}function f(O){const h=[];let q=0;const Q=O.length;function te(){return q<Q?O[q++]():null}function de(ye){ye!=null&&h.push(ye);const Le=te();return Le?Le.then(de):Promise.resolve(h)}return Promise.resolve(null).then(de)}function A(O,h=Q=>!!Q,q=null){let Q=0;const te=O.length,de=()=>{if(Q>=te)return Promise.resolve(q);const ye=O[Q++];return Promise.resolve(ye()).then(Se=>h(Se)?Promise.resolve(Se):de())};return de()}function R(O,h=Q=>!!Q,q=null){if(O.length===0)return Promise.resolve(q);let Q=O.length;const te=()=>{Q=-1;for(const de of O)de.cancel?.()};return new Promise((de,ye)=>{for(const Le of O)Le.then(Se=>{--Q>=0&&h(Se)?(te(),de(Se)):Q===0&&de(q)}).catch(Se=>{--Q>=0&&(te(),ye(Se))})})}class u{constructor(h){this._size=0,this._isDisposed=!1,this.maxDegreeOfParalellism=h,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new $.Emitter}whenIdle(){return this.size>0?$.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(h){if(this._isDisposed)throw new Error("Object has been disposed");return this._size++,new Promise((q,Q)=>{this.outstandingPromises.push({factory:h,c:q,e:Q}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const h=this.outstandingPromises.shift();this.runningPromises++;const q=h.factory();q.then(h.c,h.e),q.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._isDisposed||(this.runningPromises--,--this._size===0&&this._onDrained.fire(),this.outstandingPromises.length>0&&this.consume())}clear(){if(this._isDisposed)throw new Error("Object has been disposed");this.outstandingPromises.length=0,this._size=this.runningPromises}dispose(){this._isDisposed=!0,this.outstandingPromises.length=0,this._size=0,this._onDrained.dispose()}}e.Limiter=u;class D extends u{constructor(){super(1)}}e.Queue=D;class C{constructor(){this.sequentializer=new F,this.tasks=0}queue(h){return this.sequentializer.isRunning()?this.sequentializer.queue(()=>this.sequentializer.run(this.tasks++,h())):this.sequentializer.run(this.tasks++,h())}}e.LimitedQueue=C;class x{constructor(){this.queues=new Map,this.drainers=new Set,this.drainListeners=void 0,this.drainListenerCount=0}async whenDrained(){if(this.isDrained())return;const h=new L;return this.drainers.add(h),h.p}isDrained(){for(const[,h]of this.queues)if(h.size>0)return!1;return!0}queueSize(h,q=V.extUri){const Q=q.getComparisonKey(h);return this.queues.get(Q)?.size??0}queueFor(h,q,Q=V.extUri){const te=Q.getComparisonKey(h);let de=this.queues.get(te);if(!de){de=new D;const ye=this.drainListenerCount++,Le=$.Event.once(de.onDrained)(()=>{de?.dispose(),this.queues.delete(te),this.onDidQueueDrain(),this.drainListeners?.deleteAndDispose(ye),this.drainListeners?.size===0&&(this.drainListeners.dispose(),this.drainListeners=void 0)});this.drainListeners||(this.drainListeners=new W.DisposableMap),this.drainListeners.set(ye,Le),this.queues.set(te,de)}return de.queue(q)}onDidQueueDrain(){this.isDrained()&&this.releaseDrainers()}releaseDrainers(){for(const h of this.drainers)h.complete();this.drainers.clear()}dispose(){for(const[,h]of this.queues)h.dispose();this.queues.clear(),this.releaseDrainers(),this.drainListeners?.dispose()}}e.ResourceQueue=x;class X{constructor(h,q){this._isDisposed=!1,this._token=-1,typeof h=="function"&&typeof q=="number"&&this.setIfNotSet(h,q)}dispose(){this.cancel(),this._isDisposed=!0}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(h,q){if(this._isDisposed)throw new t.BugIndicatingError("Calling 'cancelAndSet' on a disposed TimeoutTimer");this.cancel(),this._token=setTimeout(()=>{this._token=-1,h()},q)}setIfNotSet(h,q){if(this._isDisposed)throw new t.BugIndicatingError("Calling 'setIfNotSet' on a disposed TimeoutTimer");this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,h()},q))}}e.TimeoutTimer=X;class H{constructor(){this.disposable=void 0,this.isDisposed=!1}cancel(){this.disposable?.dispose(),this.disposable=void 0}cancelAndSet(h,q,Q=globalThis){if(this.isDisposed)throw new t.BugIndicatingError("Calling 'cancelAndSet' on a disposed IntervalTimer");this.cancel();const te=Q.setInterval(()=>{h()},q);this.disposable=(0,W.toDisposable)(()=>{Q.clearInterval(te),this.disposable=void 0})}dispose(){this.cancel(),this.isDisposed=!0}}e.IntervalTimer=H;class se{constructor(h,q){this.timeoutToken=-1,this.runner=h,this.timeout=q,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(h=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,h)}get delay(){return this.timeout}set delay(h){this.timeout=h}isScheduled(){return this.timeoutToken!==-1}flush(){this.isScheduled()&&(this.cancel(),this.doRun())}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}e.RunOnceScheduler=se;class K{constructor(h,q){q%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${q}ms is not a multiple of 1000ms.`),this.runner=h,this.timeout=q,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(h=this.timeout){h%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${h}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(h/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}e.ProcessTimeRunOnceScheduler=K;class ie extends se{constructor(h,q){super(h,q),this.units=[]}work(h){this.units.push(h),this.isScheduled()||this.schedule()}doRun(){const h=this.units;this.units=[],this.runner?.(h)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=ie;class re extends W.Disposable{constructor(h,q){super(),this.options=h,this.handler=q,this.pendingWork=[],this.throttler=this._register(new W.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(h){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+h.length>this.options.maxBufferedWork)return!1}else if(this.pending+h.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}for(const q of h)this.pendingWork.push(q);return this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new se(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=re,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e._runWhenIdle=(O,h)=>{(0,k.setTimeout0)(()=>{if(q)return;const Q=Date.now()+15;h(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,Q-Date.now())}}))});let q=!1;return{dispose(){q||(q=!0)}}}:e._runWhenIdle=(O,h,q)=>{const Q=O.requestIdleCallback(h,typeof q=="number"?{timeout:q}:void 0);let te=!1;return{dispose(){te||(te=!0,O.cancelIdleCallback(Q))}}},e.runWhenGlobalIdle=O=>(0,e._runWhenIdle)(globalThis,O)}();class oe{constructor(h,q){this._didRun=!1,this._executor=()=>{try{this._value=q()}catch(Q){this._error=Q}finally{this._didRun=!0}},this._handle=(0,e._runWhenIdle)(h,()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.AbstractIdleValue=oe;class I extends oe{constructor(h){super(globalThis,h)}}e.GlobalIdleValue=I;async function g(O,h,q){let Q;for(let te=0;te<q;te++)try{return await O()}catch(de){Q=de,await _(h)}throw Q}class F{isRunning(h){return typeof h=="number"?this._running?.taskId===h:!!this._running}get running(){return this._running?.promise}cancelRunning(){this._running?.cancel()}run(h,q,Q){return this._running={taskId:h,cancel:()=>Q?.(),promise:q},q.then(()=>this.doneRunning(h),()=>this.doneRunning(h)),q}doneRunning(h){this._running&&h===this._running.taskId&&(this._running=void 0,this.runQueued())}runQueued(){if(this._queued){const h=this._queued;this._queued=void 0,h.run().then(h.promiseResolve,h.promiseReject)}}queue(h){if(this._queued)this._queued.run=h;else{const{promise:q,resolve:Q,reject:te}=b();this._queued={run:h,promise:q,promiseResolve:Q,promiseReject:te}}return this._queued.promise}hasQueued(){return!!this._queued}async join(){return this._queued?.promise??this._running?.promise}}e.TaskSequentializer=F;class j{constructor(h,q=()=>Date.now()){this.interval=h,this.nowFn=q,this.lastIncrementTime=0,this.value=0}increment(){const h=this.nowFn();return h-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=h,this.value=0),this.value++,this.value}}e.IntervalCounter=j;var Y;(function(O){O[O.Resolved=0]="Resolved",O[O.Rejected=1]="Rejected"})(Y||(Y={}));class L{get isRejected(){return this.outcome?.outcome===Y.Rejected}get isResolved(){return this.outcome?.outcome===Y.Resolved}get isSettled(){return!!this.outcome}get value(){return this.outcome?.outcome===Y.Resolved?this.outcome?.value:void 0}constructor(){this.p=new Promise((h,q)=>{this.completeCallback=h,this.errorCallback=q})}complete(h){return new Promise(q=>{this.completeCallback(h),this.outcome={outcome:Y.Resolved,value:h},q()})}error(h){return new Promise(q=>{this.errorCallback(h),this.outcome={outcome:Y.Rejected,value:h},q()})}cancel(){return this.error(new t.CancellationError)}}e.DeferredPromise=L;var J;(function(O){async function h(Q){let te;const de=await Promise.all(Q.map(ye=>ye.then(Le=>Le,Le=>{te||(te=Le)})));if(typeof te<"u")throw te;return de}O.settled=h;function q(Q){return new Promise(async(te,de)=>{try{await Q(te,de)}catch(ye){de(ye)}})}O.withAsyncBody=q})(J||(e.Promises=J={}));class ee{get value(){return this._value}get error(){return this._error}get isResolved(){return this._isResolved}constructor(h){this._value=void 0,this._error=void 0,this._isResolved=!1,this.promise=h.then(q=>(this._value=q,this._isResolved=!0,q),q=>{throw this._error=q,this._isResolved=!0,q})}requireValue(){if(!this._isResolved)throw new t.BugIndicatingError("Promise is not resolved yet");if(this._error)throw this._error;return this._value}}e.StatefulPromise=ee;class ne{constructor(h){this._compute=h,this._promise=new P.Lazy(()=>new ee(this._compute()))}requireValue(){return this._promise.value.requireValue()}getPromise(){return this._promise.value.promise}get currentValue(){return this._promise.rawValue?.value}}e.LazyStatefulPromise=ne;var le;(function(O){O[O.Initial=0]="Initial",O[O.DoneOK=1]="DoneOK",O[O.DoneError=2]="DoneError"})(le||(le={}));class fe{static fromArray(h){return new fe(q=>{q.emitMany(h)})}static fromPromise(h){return new fe(async q=>{q.emitMany(await h)})}static fromPromises(h){return new fe(async q=>{await Promise.all(h.map(async Q=>q.emitOne(await Q)))})}static merge(h){return new fe(async q=>{await Promise.all(h.map(async Q=>{for await(const te of Q)q.emitOne(te)}))})}static{this.EMPTY=fe.fromArray([])}constructor(h,q){this._state=le.Initial,this._results=[],this._error=null,this._onReturn=q,this._onStateChanged=new $.Emitter,queueMicrotask(async()=>{const Q={emitOne:te=>this.emitOne(te),emitMany:te=>this.emitMany(te),reject:te=>this.reject(te)};try{await Promise.resolve(h(Q)),this.resolve()}catch(te){this.reject(te)}finally{Q.emitOne=void 0,Q.emitMany=void 0,Q.reject=void 0}})}[Symbol.asyncIterator](){let h=0;return{next:async()=>{do{if(this._state===le.DoneError)throw this._error;if(h<this._results.length)return{done:!1,value:this._results[h++]};if(this._state===le.DoneOK)return{done:!0,value:void 0};await $.Event.toPromise(this._onStateChanged.event)}while(!0)},return:async()=>(this._onReturn?.(),{done:!0,value:void 0})}}static map(h,q){return new fe(async Q=>{for await(const te of h)Q.emitOne(q(te))})}map(h){return fe.map(this,h)}static filter(h,q){return new fe(async Q=>{for await(const te of h)q(te)&&Q.emitOne(te)})}filter(h){return fe.filter(this,h)}static coalesce(h){return fe.filter(h,q=>!!q)}coalesce(){return fe.coalesce(this)}static async toPromise(h){const q=[];for await(const Q of h)q.push(Q);return q}toPromise(){return fe.toPromise(this)}emitOne(h){this._state===le.Initial&&(this._results.push(h),this._onStateChanged.fire())}emitMany(h){this._state===le.Initial&&(this._results=this._results.concat(h),this._onStateChanged.fire())}resolve(){this._state===le.Initial&&(this._state=le.DoneOK,this._onStateChanged.fire())}reject(h){this._state===le.Initial&&(this._state=le.DoneError,this._error=h,this._onStateChanged.fire())}}e.AsyncIterableObject=fe;class we extends fe{constructor(h,q){super(q),this._source=h}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=we;function B(O){const h=new p.CancellationTokenSource,q=O(h.token);return new we(h,async Q=>{const te=h.token.onCancellationRequested(()=>{te.dispose(),h.dispose(),Q.reject(new t.CancellationError)});try{for await(const de of q){if(h.token.isCancellationRequested)return;Q.emitOne(de)}te.dispose(),h.dispose()}catch(de){te.dispose(),h.dispose(),Q.reject(de)}})}class z{constructor(h){this._deferred=new L,this._asyncIterable=new fe(te=>{if(q){te.reject(q);return}return Q&&te.emitMany(Q),this._errorFn=de=>te.reject(de),this._emitFn=de=>te.emitOne(de),this._deferred.p},h);let q,Q;this._emitFn=te=>{Q||(Q=[]),Q.push(te)},this._errorFn=te=>{q||(q=te)}}get asyncIterable(){return this._asyncIterable}resolve(){this._deferred.complete()}reject(h){this._errorFn(h),this._deferred.complete()}emitOne(h){this._emitFn(h)}}e.AsyncIterableSource=z}),define(Ee[24],pe([0,1,12,8,11,14,20,3,2,7]),function(ce,e,p,t,$,W,V,k,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.GLOB_SPLIT=e.GLOBSTAR=void 0,e.getEmptyExpression=N,e.splitGlobAware=r,e.match=C,e.parse=x,e.isRelativePattern=X,e.getBasenameTerms=H,e.getPathTerms=se,e.patternsEquals=oe;function N(){return Object.create(null)}e.GLOBSTAR="**",e.GLOB_SPLIT="/";const E="[/\\\\]",y="[^/\\\\]",M=/\//g;function a(I,g){switch(I){case 0:return"";case 1:return`${y}*?`;default:return`(?:${E}|${y}+${E}${g?`|${E}${y}+`:""})*?`}}function r(I,g){if(!I)return[];const F=[];let j=!1,Y=!1,L="";for(const J of I){switch(J){case g:if(!j&&!Y){F.push(L),L="";continue}break;case"{":j=!0;break;case"}":j=!1;break;case"[":Y=!0;break;case"]":Y=!1;break}L+=J}return L&&F.push(L),F}function d(I){if(!I)return"";let g="";const F=r(I,e.GLOB_SPLIT);if(F.every(j=>j===e.GLOBSTAR))g=".*";else{let j=!1;F.forEach((Y,L)=>{if(Y===e.GLOBSTAR){if(j)return;g+=a(2,L===F.length-1)}else{let J=!1,ee="",ne=!1,le="";for(const fe of Y){if(fe!=="}"&&J){ee+=fe;continue}if(ne&&(fe!=="]"||!le)){let we;fe==="-"?we=fe:(fe==="^"||fe==="!")&&!le?we="^":fe===e.GLOB_SPLIT?we="":we=(0,P.escapeRegExpCharacters)(fe),le+=we;continue}switch(fe){case"{":J=!0;continue;case"[":ne=!0;continue;case"}":{const B=`(?:${r(ee,",").map(z=>d(z)).join("|")})`;g+=B,J=!1,ee="";break}case"]":{g+="["+le+"]",ne=!1,le="";break}case"?":g+=y;continue;case"*":g+=a(1);continue;default:g+=(0,P.escapeRegExpCharacters)(fe)}}L<F.length-1&&(F[L+1]!==e.GLOBSTAR||L+2<F.length)&&(g+=E)}j=Y===e.GLOBSTAR})}return g}const b=/^\*\*\/\*\.[\w\.-]+$/,c=/^\*\*\/([\w\.-]+)\/?$/,v=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,w=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,l=/^\*\*((\/[\w\.-]+)+)\/?$/,n=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,i=new V.LRUCache(1e4),s=function(){return!1},o=function(){return null};function U(I,g){if(!I)return o;let F;typeof I!="string"?F=I.pattern:F=I,F=F.trim();const j=`${F}_${!!g.trimForExclusions}`;let Y=i.get(j);if(Y)return _(Y,I);let L;return b.test(F)?Y=f(F.substr(4),F):(L=c.exec(m(F,g)))?Y=A(L[1],F):(g.trimForExclusions?w:v).test(F)?Y=R(F,g):(L=l.exec(m(F,g)))?Y=u(L[1].substr(1),F,!0):(L=n.exec(m(F,g)))?Y=u(L[1],F,!1):Y=D(F),i.set(j,Y),_(Y,I)}function _(I,g){if(typeof g=="string")return I;const F=function(j,Y){return(0,W.isEqualOrParent)(j,g.base,!T.isLinux)?I((0,P.ltrim)(j.substr(g.base.length),k.sep),Y):null};return F.allBasenames=I.allBasenames,F.allPaths=I.allPaths,F.basenames=I.basenames,F.patterns=I.patterns,F}function m(I,g){return g.trimForExclusions&&I.endsWith("/**")?I.substr(0,I.length-2):I}function f(I,g){return function(F,j){return typeof F=="string"&&F.endsWith(I)?g:null}}function A(I,g){const F=`/${I}`,j=`\\${I}`,Y=function(J,ee){return typeof J!="string"?null:ee?ee===I?g:null:J===I||J.endsWith(F)||J.endsWith(j)?g:null},L=[I];return Y.basenames=L,Y.patterns=[g],Y.allBasenames=L,Y}function R(I,g){const F=re(I.slice(1,-1).split(",").map(ee=>U(ee,g)).filter(ee=>ee!==o),I),j=F.length;if(!j)return o;if(j===1)return F[0];const Y=function(ee,ne){for(let le=0,fe=F.length;le<fe;le++)if(F[le](ee,ne))return I;return null},L=F.find(ee=>!!ee.allBasenames);L&&(Y.allBasenames=L.allBasenames);const J=F.reduce((ee,ne)=>ne.allPaths?ee.concat(ne.allPaths):ee,[]);return J.length&&(Y.allPaths=J),Y}function u(I,g,F){const j=k.sep===k.posix.sep,Y=j?I:I.replace(M,k.sep),L=k.sep+Y,J=k.posix.sep+I;let ee;return F?ee=function(ne,le){return typeof ne=="string"&&(ne===Y||ne.endsWith(L)||!j&&(ne===I||ne.endsWith(J)))?g:null}:ee=function(ne,le){return typeof ne=="string"&&(ne===Y||!j&&ne===I)?g:null},ee.allPaths=[(F?"*/":"./")+I],ee}function D(I){try{const g=new RegExp(`^${d(I)}$`);return function(F){return g.lastIndex=0,typeof F=="string"&&g.test(F)?I:null}}catch{return o}}function C(I,g,F){return!I||typeof g!="string"?!1:x(I)(g,void 0,F)}function x(I,g={}){if(!I)return s;if(typeof I=="string"||X(I)){const F=U(I,g);if(F===o)return s;const j=function(Y,L){return!!F(Y,L)};return F.allBasenames&&(j.allBasenames=F.allBasenames),F.allPaths&&(j.allPaths=F.allPaths),j}return K(I,g)}function X(I){const g=I;return g?typeof g.base=="string"&&typeof g.pattern=="string":!1}function H(I){return I.allBasenames||[]}function se(I){return I.allPaths||[]}function K(I,g){const F=re(Object.getOwnPropertyNames(I).map(ee=>ie(ee,I[ee],g)).filter(ee=>ee!==o)),j=F.length;if(!j)return o;if(!F.some(ee=>!!ee.requiresSiblings)){if(j===1)return F[0];const ee=function(fe,we){let B;for(let z=0,O=F.length;z<O;z++){const h=F[z](fe,we);if(typeof h=="string")return h;(0,t.isThenable)(h)&&(B||(B=[]),B.push(h))}return B?(async()=>{for(const z of B){const O=await z;if(typeof O=="string")return O}return null})():null},ne=F.find(fe=>!!fe.allBasenames);ne&&(ee.allBasenames=ne.allBasenames);const le=F.reduce((fe,we)=>we.allPaths?fe.concat(we.allPaths):fe,[]);return le.length&&(ee.allPaths=le),ee}const Y=function(ee,ne,le){let fe,we;for(let B=0,z=F.length;B<z;B++){const O=F[B];O.requiresSiblings&&le&&(ne||(ne=(0,k.basename)(ee)),fe||(fe=ne.substr(0,ne.length-(0,k.extname)(ee).length)));const h=O(ee,ne,fe,le);if(typeof h=="string")return h;(0,t.isThenable)(h)&&(we||(we=[]),we.push(h))}return we?(async()=>{for(const B of we){const z=await B;if(typeof z=="string")return z}return null})():null},L=F.find(ee=>!!ee.allBasenames);L&&(Y.allBasenames=L.allBasenames);const J=F.reduce((ee,ne)=>ne.allPaths?ee.concat(ne.allPaths):ee,[]);return J.length&&(Y.allPaths=J),Y}function ie(I,g,F){if(g===!1)return o;const j=U(I,F);if(j===o)return o;if(typeof g=="boolean")return j;if(g){const Y=g.when;if(typeof Y=="string"){const L=(J,ee,ne,le)=>{if(!le||!j(J,ee))return null;const fe=Y.replace("$(basename)",()=>ne),we=le(fe);return(0,t.isThenable)(we)?we.then(B=>B?I:null):we?I:null};return L.requiresSiblings=!0,L}}return j}function re(I,g){const F=I.filter(ee=>!!ee.basenames);if(F.length<2)return I;const j=F.reduce((ee,ne)=>{const le=ne.basenames;return le?ee.concat(le):ee},[]);let Y;if(g){Y=[];for(let ee=0,ne=j.length;ee<ne;ee++)Y.push(g)}else Y=F.reduce((ee,ne)=>{const le=ne.patterns;return le?ee.concat(le):ee},[]);const L=function(ee,ne){if(typeof ee!="string")return null;if(!ne){let fe;for(fe=ee.length;fe>0;fe--){const we=ee.charCodeAt(fe-1);if(we===$.CharCode.Slash||we===$.CharCode.Backslash)break}ne=ee.substr(fe)}const le=j.indexOf(ne);return le!==-1?Y[le]:null};L.basenames=j,L.patterns=Y,L.allBasenames=j;const J=I.filter(ee=>!ee.basenames);return J.push(L),J}function oe(I,g){return(0,p.equals)(I,g,(F,j)=>typeof F=="string"&&typeof j=="string"?F===j:typeof F!="string"&&typeof j!="string"?F.base===j.base&&F.pattern===j.pattern:!1)}}),define(Ee[25],pe([0,1,15,52,61,8,14,21,3,2,23,5]),function(ce,e,p,t,$,W,V,k,T,P,N,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.SymlinkSupport=e.RimRafMode=void 0,e.rimrafSync=d,e.readdirSync=v,e.whenDeleted=n,e.configureFlushOnWrite=_,e.writeFileSync=f,p=Ie(p);var y;(function(K){K[K.UNLINK=0]="UNLINK",K[K.MOVE=1]="MOVE"})(y||(e.RimRafMode=y={}));async function M(K,ie=y.UNLINK,re){if((0,V.isRootOrDriveLetter)(K))throw new Error("rimraf - will refuse to recursively delete root");return ie===y.UNLINK?r(K):a(K,re)}async function a(K,ie=(0,V.randomPath)((0,t.tmpdir)())){try{try{await p.promises.rename(K,ie)}catch(re){return re.code==="ENOENT"?void 0:r(K)}r(ie).catch(re=>{})}catch(re){if(re.code!=="ENOENT")throw re}}async function r(K){return p.promises.rm(K,{recursive:!0,force:!0,maxRetries:3})}function d(K){if((0,V.isRootOrDriveLetter)(K))throw new Error("rimraf - will refuse to recursively delete root");p.rmSync(K,{recursive:!0,force:!0,maxRetries:3})}async function b(K,ie){return w(await(ie?c(K):p.promises.readdir(K)))}async function c(K){try{return await p.promises.readdir(K,{withFileTypes:!0})}catch(oe){console.warn("[node.js fs] readdir with filetypes failed with error: ",oe)}const ie=[],re=await b(K);for(const oe of re){let I=!1,g=!1,F=!1;try{const j=await p.promises.lstat((0,T.join)(K,oe));I=j.isFile(),g=j.isDirectory(),F=j.isSymbolicLink()}catch(j){console.warn("[node.js fs] unexpected error from lstat after readdir: ",j)}ie.push({name:oe,isFile:()=>I,isDirectory:()=>g,isSymbolicLink:()=>F})}return ie}function v(K){return w(p.readdirSync(K))}function w(K){return K.map(ie=>typeof ie=="string"?P.isMacintosh?(0,k.normalizeNFC)(ie):ie:(ie.name=P.isMacintosh?(0,k.normalizeNFC)(ie.name):ie.name,ie))}async function l(K){const ie=await b(K),re=[];for(const oe of ie)await i.existsDirectory((0,T.join)(K,oe))&&re.push(oe);return re}function n(K,ie=1e3){return new Promise(re=>{let oe=!1;const I=setInterval(()=>{oe||(oe=!0,p.access(K,g=>{oe=!1,g&&(clearInterval(I),re(void 0))}))},ie)})}var i;(function(K){async function ie(I){let g;try{if(g=await p.promises.lstat(I),!g.isSymbolicLink())return{stat:g}}catch{}try{return{stat:await p.promises.stat(I),symbolicLink:g?.isSymbolicLink()?{dangling:!1}:void 0}}catch(F){if(F.code==="ENOENT"&&g)return{stat:g,symbolicLink:{dangling:!0}};if(P.isWindows&&F.code==="EACCES")try{return{stat:await p.promises.stat(await p.promises.readlink(I)),symbolicLink:{dangling:!1}}}catch(j){if(j.code==="ENOENT"&&g)return{stat:g,symbolicLink:{dangling:!0}};throw j}throw F}}K.stat=ie;async function re(I){try{const{stat:g,symbolicLink:F}=await K.stat(I);return g.isFile()&&F?.dangling!==!0}catch{}return!1}K.existsFile=re;async function oe(I){try{const{stat:g,symbolicLink:F}=await K.stat(I);return g.isDirectory()&&F?.dangling!==!0}catch{}return!1}K.existsDirectory=oe})(i||(e.SymlinkSupport=i={}));const s=new W.ResourceQueue;function o(K,ie,re){return s.queueFor(E.URI.file(K),()=>{const oe=A(re);return new Promise((I,g)=>m(K,ie,oe,F=>F?g(F):I()))},N.extUriBiasedIgnorePathCase)}let U=!0;function _(K){U=K}function m(K,ie,re,oe){if(!U)return p.writeFile(K,ie,{mode:re.mode,flag:re.flag},oe);p.open(K,re.flag,re.mode,(I,g)=>{if(I)return oe(I);p.writeFile(g,ie,F=>{if(F)return p.close(g,()=>oe(F));p.fdatasync(g,j=>(j&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",j),_(!1)),p.close(g,Y=>oe(Y))))})})}function f(K,ie,re){const oe=A(re);if(!U)return p.writeFileSync(K,ie,{mode:oe.mode,flag:oe.flag});const I=p.openSync(K,oe.flag,oe.mode);try{p.writeFileSync(I,ie);try{p.fdatasyncSync(I)}catch(g){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",g),_(!1)}}finally{p.closeSync(I)}}function A(K){return K?{mode:typeof K.mode=="number"?K.mode:438,flag:typeof K.flag=="string"?K.flag:"w"}:{mode:438,flag:"w"}}async function R(K,ie,re=6e4){if(K!==ie)try{P.isWindows&&typeof re=="number"?await u(K,ie,Date.now(),re):await p.promises.rename(K,ie)}catch(oe){if(K.toLowerCase()!==ie.toLowerCase()&&oe.code==="EXDEV"||K.endsWith("."))await D(K,ie,{preserveSymlinks:!1}),await M(K,y.MOVE);else throw oe}}async function u(K,ie,re,oe,I=0){try{return await p.promises.rename(K,ie)}catch(g){if(g.code!=="EACCES"&&g.code!=="EPERM"&&g.code!=="EBUSY")throw g;if(Date.now()-re>=oe)throw console.error(`[node.js fs] rename failed after ${I} retries with error: ${g}`),g;if(I===0){let F=!1;try{const{stat:j}=await i.stat(ie);j.isFile()||(F=!0)}catch{}if(F)throw g}return await(0,W.timeout)(Math.min(100,I*10)),u(K,ie,re,oe,I+1)}}async function D(K,ie,re){return x(K,ie,{root:{source:K,target:ie},options:re,handledSourcePaths:new Set})}const C=511;async function x(K,ie,re){if(re.handledSourcePaths.has(K))return;re.handledSourcePaths.add(K);const{stat:oe,symbolicLink:I}=await i.stat(K);if(I){if(re.options.preserveSymlinks)try{return await se(K,ie,re)}catch{}if(I.dangling)return}return oe.isDirectory()?X(K,ie,oe.mode&C,re):H(K,ie,oe.mode&C)}async function X(K,ie,re,oe){await p.promises.mkdir(ie,{recursive:!0,mode:re});const I=await b(K);for(const g of I)await x((0,T.join)(K,g),(0,T.join)(ie,g),oe)}async function H(K,ie,re){await p.promises.copyFile(K,ie),await p.promises.chmod(ie,re)}async function se(K,ie,re){let oe=await p.promises.readlink(K);(0,V.isEqualOrParent)(oe,re.root.source,!P.isLinux)&&(oe=(0,T.join)(re.root.target,oe.substr(re.root.source.length+1))),await p.promises.symlink(oe,ie)}e.Promises=new class{get read(){return(K,ie,re,oe,I)=>new Promise((g,F)=>{p.read(K,ie,re,oe,I,(j,Y,L)=>j?F(j):g({bytesRead:Y,buffer:L}))})}get write(){return(K,ie,re,oe,I)=>new Promise((g,F)=>{p.write(K,ie,re,oe,I,(j,Y,L)=>j?F(j):g({bytesWritten:Y,buffer:L}))})}get fdatasync(){return(0,$.promisify)(p.fdatasync)}get open(){return(0,$.promisify)(p.open)}get close(){return(0,$.promisify)(p.close)}get realpath(){return(0,$.promisify)(p.realpath)}async exists(K){try{return await p.promises.access(K),!0}catch{return!1}}get readdir(){return b}get readDirsInDir(){return l}get writeFile(){return o}get rm(){return M}get rename(){return R}get copy(){return D}}}),define(Ee[35],pe([0,1,15,3,2,7,25]),function(ce,e,p,t,$,W,V){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realcaseSync=k,e.realcase=T,e.realpath=P,e.realpathSync=N,p=Ie(p);function k(y){if($.isLinux)return y;const M=(0,t.dirname)(y);if(y===M)return y;const a=((0,t.basename)(y)||y).toLowerCase();try{const d=(0,V.readdirSync)(M).filter(b=>b.toLowerCase()===a);if(d.length===1){const b=k(M);if(b)return(0,t.join)(b,d[0])}else if(d.length>1){const b=d.indexOf(a);if(b>=0){const c=k(M);if(c)return(0,t.join)(c,d[b])}}}catch{}return null}async function T(y,M){if($.isLinux)return y;const a=(0,t.dirname)(y);if(y===a)return y;const r=((0,t.basename)(y)||y).toLowerCase();try{if(M?.isCancellationRequested)return null;const b=(await V.Promises.readdir(a)).filter(c=>c.toLowerCase()===r);if(b.length===1){const c=await T(a,M);if(c)return(0,t.join)(c,b[0])}else if(b.length>1){const c=b.indexOf(r);if(c>=0){const v=await T(a,M);if(v)return(0,t.join)(v,b[c])}}}catch{}return null}async function P(y){try{return await V.Promises.realpath(y)}catch{const a=E(y);return await p.promises.access(a,p.constants.R_OK),a}}function N(y){try{return p.realpathSync(y)}catch{const a=E(y);return p.accessSync(a,p.constants.R_OK),a}}function E(y){return(0,W.rtrim)((0,t.normalize)(y),t.sep)}}),define(Ee[53],pe([0,1,15,3,2,32,33,10,25]),function(ce,e,p,t,$,W,V,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.TerminateResponseCode=e.Source=void 0,e.getWindowsShell=P,e.createQueuedSender=N,t=Ie(t),$=Ie($),W=Ie(W),k=Ie(k),T=Ie(T),Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return V.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return V.TerminateResponseCode}});function P(y=W.env){return y.comspec||"cmd.exe"}function N(y){let M=[],a=!1;const r=function(d){if(a){M.push(d);return}(!y.send(d,c=>{if(c&&console.error(c),a=!1,M.length>0){const v=M.slice(0);M=[],v.forEach(w=>r(w))}})||$.isWindows)&&(a=!0)};return{send:r}}var E;(function(y){async function M(a,r,d){if(t.isAbsolute(a))return a;if(r===void 0&&(r=W.cwd()),t.dirname(a)!=="."||(d===void 0&&k.isString(W.env.PATH)&&(d=W.env.PATH.split(t.delimiter)),d===void 0||d.length===0))return t.join(r,a);async function c(v){if(await T.Promises.exists(v)){let w;try{w=await p.promises.stat(v)}catch(l){l.message.startsWith("EACCES")&&(w=await p.promises.lstat(v))}return w?!w.isDirectory():!1}return!1}for(const v of d){let w;if(t.isAbsolute(v)?w=t.join(v,a):w=t.join(r,v,a),await c(w))return w;let l=w+".com";if(await c(l)||(l=w+".exe",await c(l)))return l}return t.join(r,a)}y.findExecutable=M})(E||(e.win32=E={}))});var Xe=this&&this.__decorate||function(ce,e,p,t){var $=arguments.length,W=$<3?e:t===null?t=Object.getOwnPropertyDescriptor(e,p):t,V;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")W=Reflect.decorate(ce,e,p,t);else for(var k=ce.length-1;k>=0;k--)(V=ce[k])&&(W=($<3?V(W):$>3?V(e,p,W):V(e,p))||W);return $>3&&W&&Object.defineProperty(e,p,W),W};define(Ee[26],pe([0,1,12,8,17,13,40,9,6,4,51,7,10]),function(ce,e,p,t,$,W,V,k,T,P,N,E,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.ProxyChannel=e.StaticRouter=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.BufferWriter=e.BufferReader=void 0,e.serialize=_,e.deserialize=m,e.getDelayedChannel=C,e.getNextTickChannel=x,E=Ie(E);var M;(function(I){I[I.Promise=100]="Promise",I[I.PromiseCancel=101]="PromiseCancel",I[I.EventListen=102]="EventListen",I[I.EventDispose=103]="EventDispose"})(M||(M={}));function a(I){switch(I){case M.Promise:return"req";case M.PromiseCancel:return"cancel";case M.EventListen:return"subscribe";case M.EventDispose:return"unsubscribe"}}var r;(function(I){I[I.Initialize=200]="Initialize",I[I.PromiseSuccess=201]="PromiseSuccess",I[I.PromiseError=202]="PromiseError",I[I.PromiseErrorObj=203]="PromiseErrorObj",I[I.EventFire=204]="EventFire"})(r||(r={}));function d(I){switch(I){case r.Initialize:return"init";case r.PromiseSuccess:return"reply:";case r.PromiseError:case r.PromiseErrorObj:return"replyErr:";case r.EventFire:return"event:"}}var b;(function(I){I[I.Uninitialized=0]="Uninitialized",I[I.Idle=1]="Idle"})(b||(b={}));function c(I){let g=0;for(let F=0;;F+=7){const j=I.read(1);if(g|=(j.buffer[0]&127)<<F,!(j.buffer[0]&128))return g}}const v=s(0);function w(I,g){if(g===0){I.write(v);return}let F=0;for(let Y=g;Y!==0;Y=Y>>>7)F++;const j=$.VSBuffer.alloc(F);for(let Y=0;g!==0;Y++)j.buffer[Y]=g&127,g=g>>>7,g>0&&(j.buffer[Y]|=128);I.write(j)}class l{constructor(g){this.buffer=g,this.pos=0}read(g){const F=this.buffer.slice(this.pos,this.pos+g);return this.pos+=F.byteLength,F}}e.BufferReader=l;class n{constructor(){this.buffers=[]}get buffer(){return $.VSBuffer.concat(this.buffers)}write(g){this.buffers.push(g)}}e.BufferWriter=n;var i;(function(I){I[I.Undefined=0]="Undefined",I[I.String=1]="String",I[I.Buffer=2]="Buffer",I[I.VSBuffer=3]="VSBuffer",I[I.Array=4]="Array",I[I.Object=5]="Object",I[I.Int=6]="Int"})(i||(i={}));function s(I){const g=$.VSBuffer.alloc(1);return g.writeUInt8(I,0),g}const o={Undefined:s(i.Undefined),String:s(i.String),Buffer:s(i.Buffer),VSBuffer:s(i.VSBuffer),Array:s(i.Array),Object:s(i.Object),Uint:s(i.Int)},U=typeof Buffer<"u";function _(I,g){if(typeof g>"u")I.write(o.Undefined);else if(typeof g=="string"){const F=$.VSBuffer.fromString(g);I.write(o.String),w(I,F.byteLength),I.write(F)}else if(U&&Buffer.isBuffer(g)){const F=$.VSBuffer.wrap(g);I.write(o.Buffer),w(I,F.byteLength),I.write(F)}else if(g instanceof $.VSBuffer)I.write(o.VSBuffer),w(I,g.byteLength),I.write(g);else if(Array.isArray(g)){I.write(o.Array),w(I,g.length);for(const F of g)_(I,F)}else if(typeof g=="number"&&(g|0)===g)I.write(o.Uint),w(I,g);else{const F=$.VSBuffer.fromString(JSON.stringify(g));I.write(o.Object),w(I,F.byteLength),I.write(F)}}function m(I){switch(I.read(1).readUInt8(0)){case i.Undefined:return;case i.String:return I.read(c(I)).toString();case i.Buffer:return I.read(c(I)).buffer;case i.VSBuffer:return I.read(c(I));case i.Array:{const F=c(I),j=[];for(let Y=0;Y<F;Y++)j.push(m(I));return j}case i.Object:return JSON.parse(I.read(c(I)).toString());case i.Int:return c(I)}}class f{constructor(g,F,j=null,Y=1e3){this.protocol=g,this.ctx=F,this.logger=j,this.timeoutDelay=Y,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(L=>this.onRawMessage(L)),this.sendResponse({type:r.Initialize})}registerChannel(g,F){this.channels.set(g,F),setTimeout(()=>this.flushPendingRequests(g),0)}sendResponse(g){switch(g.type){case r.Initialize:{const F=this.send([g.type]);this.logger?.logOutgoing(F,0,A.OtherSide,d(g.type));return}case r.PromiseSuccess:case r.PromiseError:case r.EventFire:case r.PromiseErrorObj:{const F=this.send([g.type,g.id],g.data);this.logger?.logOutgoing(F,g.id,A.OtherSide,d(g.type),g.data);return}}}send(g,F=void 0){const j=new n;return _(j,g),_(j,F),this.sendBuffer(j.buffer)}sendBuffer(g){try{return this.protocol.send(g),g.byteLength}catch{return 0}}onRawMessage(g){const F=new l(g),j=m(F),Y=m(F),L=j[0];switch(L){case M.Promise:return this.logger?.logIncoming(g.byteLength,j[1],A.OtherSide,`${a(L)}: ${j[2]}.${j[3]}`,Y),this.onPromise({type:L,id:j[1],channelName:j[2],name:j[3],arg:Y});case M.EventListen:return this.logger?.logIncoming(g.byteLength,j[1],A.OtherSide,`${a(L)}: ${j[2]}.${j[3]}`,Y),this.onEventListen({type:L,id:j[1],channelName:j[2],name:j[3],arg:Y});case M.PromiseCancel:return this.logger?.logIncoming(g.byteLength,j[1],A.OtherSide,`${a(L)}`),this.disposeActiveRequest({type:L,id:j[1]});case M.EventDispose:return this.logger?.logIncoming(g.byteLength,j[1],A.OtherSide,`${a(L)}`),this.disposeActiveRequest({type:L,id:j[1]})}}onPromise(g){const F=this.channels.get(g.channelName);if(!F){this.collectPendingRequest(g);return}const j=new W.CancellationTokenSource;let Y;try{Y=F.call(this.ctx,g.name,g.arg,j.token)}catch(ee){Y=Promise.reject(ee)}const L=g.id;Y.then(ee=>{this.sendResponse({id:L,data:ee,type:r.PromiseSuccess})},ee=>{ee instanceof Error?this.sendResponse({id:L,data:{message:ee.message,name:ee.name,stack:ee.stack?ee.stack.split(`
`):void 0},type:r.PromiseError}):this.sendResponse({id:L,data:ee,type:r.PromiseErrorObj})}).finally(()=>{J.dispose(),this.activeRequests.delete(g.id)});const J=(0,P.toDisposable)(()=>j.cancel());this.activeRequests.set(g.id,J)}onEventListen(g){const F=this.channels.get(g.channelName);if(!F){this.collectPendingRequest(g);return}const j=g.id,L=F.listen(this.ctx,g.name,g.arg)(J=>this.sendResponse({id:j,data:J,type:r.EventFire}));this.activeRequests.set(g.id,L)}disposeActiveRequest(g){const F=this.activeRequests.get(g.id);F&&(F.dispose(),this.activeRequests.delete(g.id))}collectPendingRequest(g){let F=this.pendingRequests.get(g.channelName);F||(F=[],this.pendingRequests.set(g.channelName,F));const j=setTimeout(()=>{console.error(`Unknown channel: ${g.channelName}`),g.type===M.Promise&&this.sendResponse({id:g.id,data:{name:"Unknown channel",message:`Channel name '${g.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:r.PromiseError})},this.timeoutDelay);F.push({request:g,timeoutTimer:j})}flushPendingRequests(g){const F=this.pendingRequests.get(g);if(F){for(const j of F)switch(clearTimeout(j.timeoutTimer),j.request.type){case M.Promise:this.onPromise(j.request);break;case M.EventListen:this.onEventListen(j.request);break}this.pendingRequests.delete(g)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,P.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelServer=f;var A;(function(I){I[I.LocalSide=0]="LocalSide",I[I.OtherSide=1]="OtherSide"})(A||(e.RequestInitiator=A={}));class R{constructor(g,F=null){this.protocol=g,this.isDisposed=!1,this.state=b.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new T.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(j=>this.onBuffer(j)),this.logger=F}getChannel(g){const F=this;return{call(j,Y,L){return F.isDisposed?Promise.reject(new k.CancellationError):F.requestPromise(g,j,Y,L)},listen(j,Y){return F.isDisposed?T.Event.None:F.requestEvent(g,j,Y)}}}requestPromise(g,F,j,Y=W.CancellationToken.None){const L=this.lastRequestId++,J=M.Promise,ee={id:L,type:J,channelName:g,name:F,arg:j};if(Y.isCancellationRequested)return Promise.reject(new k.CancellationError);let ne;return new Promise((fe,we)=>{if(Y.isCancellationRequested)return we(new k.CancellationError);const B=()=>{const q=Q=>{switch(Q.type){case r.PromiseSuccess:this.handlers.delete(L),fe(Q.data);break;case r.PromiseError:{this.handlers.delete(L);const te=new Error(Q.data.message);te.stack=Array.isArray(Q.data.stack)?Q.data.stack.join(`
`):Q.data.stack,te.name=Q.data.name,we(te);break}case r.PromiseErrorObj:this.handlers.delete(L),we(Q.data);break}};this.handlers.set(L,q),this.sendRequest(ee)};let z=null;this.state===b.Idle?B():(z=(0,t.createCancelablePromise)(q=>this.whenInitialized()),z.then(()=>{z=null,B()}));const O=()=>{z?(z.cancel(),z=null):this.sendRequest({id:L,type:M.PromiseCancel}),we(new k.CancellationError)},h=Y.onCancellationRequested(O);ne=(0,P.combinedDisposable)((0,P.toDisposable)(O),h),this.activeRequests.add(ne)}).finally(()=>{ne.dispose(),this.activeRequests.delete(ne)})}requestEvent(g,F,j){const Y=this.lastRequestId++,L=M.EventListen,J={id:Y,type:L,channelName:g,name:F,arg:j};let ee=null;const ne=new T.Emitter({onWillAddFirstListener:()=>{ee=(0,t.createCancelablePromise)(fe=>this.whenInitialized()),ee.then(()=>{ee=null,this.activeRequests.add(ne),this.sendRequest(J)})},onDidRemoveLastListener:()=>{ee?(ee.cancel(),ee=null):(this.activeRequests.delete(ne),this.sendRequest({id:Y,type:M.EventDispose}))}}),le=fe=>ne.fire(fe.data);return this.handlers.set(Y,le),ne.event}sendRequest(g){switch(g.type){case M.Promise:case M.EventListen:{const F=this.send([g.type,g.id,g.channelName,g.name],g.arg);this.logger?.logOutgoing(F,g.id,A.LocalSide,`${a(g.type)}: ${g.channelName}.${g.name}`,g.arg);return}case M.PromiseCancel:case M.EventDispose:{const F=this.send([g.type,g.id]);this.logger?.logOutgoing(F,g.id,A.LocalSide,a(g.type));return}}}send(g,F=void 0){const j=new n;return _(j,g),_(j,F),this.sendBuffer(j.buffer)}sendBuffer(g){try{return this.protocol.send(g),g.byteLength}catch{return 0}}onBuffer(g){const F=new l(g),j=m(F),Y=m(F),L=j[0];switch(L){case r.Initialize:return this.logger?.logIncoming(g.byteLength,0,A.LocalSide,d(L)),this.onResponse({type:j[0]});case r.PromiseSuccess:case r.PromiseError:case r.EventFire:case r.PromiseErrorObj:return this.logger?.logIncoming(g.byteLength,j[1],A.LocalSide,d(L),Y),this.onResponse({type:j[0],id:j[1],data:Y})}}onResponse(g){if(g.type===r.Initialize){this.state=b.Idle,this._onDidInitialize.fire();return}this.handlers.get(g.id)?.(g)}get onDidInitializePromise(){return T.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===b.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,P.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelClient=R,Xe([V.memoize],R.prototype,"onDidInitializePromise",null);class u{get connections(){const g=[];return this._connections.forEach(F=>g.push(F)),g}constructor(g,F,j){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new T.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new T.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,this.disposables=new P.DisposableStore,this.disposables.add(g(({protocol:Y,onDidClientDisconnect:L})=>{const J=T.Event.once(Y.onMessage);this.disposables.add(J(ee=>{const ne=new l(ee),le=m(ne),fe=new f(Y,le,F,j),we=new R(Y,F);this.channels.forEach((z,O)=>fe.registerChannel(O,z));const B={channelServer:fe,channelClient:we,ctx:le};this._connections.add(B),this._onDidAddConnection.fire(B),this.disposables.add(L(()=>{fe.dispose(),we.dispose(),this._connections.delete(B),this._onDidRemoveConnection.fire(B)}))}))}))}getChannel(g,F){const j=this;return{call(Y,L,J){let ee;if((0,y.isFunction)(F)){const le=(0,p.getRandomElement)(j.connections.filter(F));ee=le?Promise.resolve(le):T.Event.toPromise(T.Event.filter(j.onDidAddConnection,F))}else ee=F.routeCall(j,Y,L);const ne=ee.then(le=>le.channelClient.getChannel(g));return C(ne).call(Y,L,J)},listen(Y,L){if((0,y.isFunction)(F))return j.getMulticastEvent(g,F,Y,L);const J=F.routeEvent(j,Y,L).then(ee=>ee.channelClient.getChannel(g));return C(J).listen(Y,L)}}}getMulticastEvent(g,F,j,Y){const L=this;let J;const ee=new T.Emitter({onWillAddFirstListener:()=>{J=new P.DisposableStore;const ne=new T.EventMultiplexer,le=new Map,fe=B=>{const O=B.channelClient.getChannel(g).listen(j,Y),h=ne.add(O);le.set(B,h)},we=B=>{const z=le.get(B);z&&(z.dispose(),le.delete(B))};L.connections.filter(F).forEach(fe),T.Event.filter(L.onDidAddConnection,F)(fe,void 0,J),L.onDidRemoveConnection(we,void 0,J),ne.event(ee.fire,ee,J),J.add(ne)},onDidRemoveLastListener:()=>{J?.dispose(),J=void 0}});return ee.event}registerChannel(g,F){this.channels.set(g,F);for(const j of this._connections)j.channelServer.registerChannel(g,F)}dispose(){this.disposables.dispose();for(const g of this._connections)g.channelClient.dispose(),g.channelServer.dispose();this._connections.clear(),this.channels.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=u;class D{constructor(g,F,j=null){const Y=new n;_(Y,F),g.send(Y.buffer),this.channelClient=new R(g,j),this.channelServer=new f(g,F,j)}getChannel(g){return this.channelClient.getChannel(g)}registerChannel(g,F){this.channelServer.registerChannel(g,F)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=D;function C(I){return{call(g,F,j){return I.then(Y=>Y.call(g,F,j))},listen(g,F){const j=new T.Relay;return I.then(Y=>j.input=Y.listen(g,F)),j.event}}}function x(I){let g=!1;return{call(F,j,Y){return g?I.call(F,j,Y):(0,t.timeout)(0).then(()=>g=!0).then(()=>I.call(F,j,Y))},listen(F,j){if(g)return I.listen(F,j);const Y=new T.Relay;return(0,t.timeout)(0).then(()=>g=!0).then(()=>Y.input=I.listen(F,j)),Y.event}}}class X{constructor(g){this.fn=g}routeCall(g){return this.route(g)}routeEvent(g){return this.route(g)}async route(g){for(const F of g.connections)if(await Promise.resolve(this.fn(F.ctx)))return Promise.resolve(F);return await T.Event.toPromise(g.onDidAddConnection),await this.route(g)}}e.StaticRouter=X;var H;(function(I){function g(L,J,ee){const ne=L,le=ee&&ee.disableMarshalling,fe=new Map;for(const we in ne)j(we)&&fe.set(we,T.Event.buffer(ne[we],!0,void 0,J));return new class{listen(we,B,z){const O=fe.get(B);if(O)return O;const h=ne[B];if(typeof h=="function"){if(Y(B))return h.call(ne,z);if(j(B))return fe.set(B,T.Event.buffer(ne[B],!0,void 0,J)),fe.get(B)}throw new k.ErrorNoTelemetry(`Event not found: ${B}`)}call(we,B,z){const O=ne[B];if(typeof O=="function"){if(!le&&Array.isArray(z))for(let q=0;q<z.length;q++)z[q]=(0,N.revive)(z[q]);let h=O.apply(ne,z);return h instanceof Promise||(h=Promise.resolve(h)),h}throw new k.ErrorNoTelemetry(`Method not found: ${B}`)}}}I.fromService=g;function F(L,J){const ee=J&&J.disableMarshalling;return new Proxy({},{get(ne,le){if(typeof le=="string")return J?.properties?.has(le)?J.properties.get(le):Y(le)?function(fe){return L.listen(le,fe)}:j(le)?L.listen(le):async function(...fe){let we;J&&!(0,y.isUndefinedOrNull)(J.context)?we=[J.context,...fe]:we=fe;const B=await L.call(le,we);return ee?B:(0,N.revive)(B)};throw new k.ErrorNoTelemetry(`Property not found: ${String(le)}`)}})}I.toService=F;function j(L){return L[0]==="o"&&L[1]==="n"&&E.isUpperAsciiLetter(L.charCodeAt(2))}function Y(L){return/^onDynamic/.test(L)&&E.isUpperAsciiLetter(L.charCodeAt(9))}})(H||(e.ProxyChannel=H={}));const se=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function K(I){if(Array.isArray(I))return I;if(I&&typeof I=="object"&&typeof I.toString=="function"){const g=I.toString();if(g!=="[object Object]")return g}return I}function ie(I){return Array.isArray(I)?I.map(K):K(I)}function re(I,g,F,j,Y,L,J){J=ie(J);const ee=se[Y],ne=ee[j%ee.length];let le=[`%c[${I}]%c[${String(g).padStart(7," ")}]%c[len: ${String(F).padStart(5," ")}]%c${String(j).padStart(5," ")} - ${L}`,"color: darkgreen","color: grey","color: grey",`color: ${ne}`];/\($/.test(L)?(le=le.concat(J),le.push(")")):le.push(J),console.log.apply(console,le)}class oe{constructor(g,F){this._outgoingPrefix=g,this._incomingPrefix=F,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(g,F,j,Y,L){this._totalOutgoing+=g,re(this._outgoingPrefix,this._totalOutgoing,g,F,j,Y,L)}logIncoming(g,F,j,Y,L){this._totalIncoming+=g,re(this._incomingPrefix,this._totalIncoming,g,F,j,Y,L)}}e.IPCLogger=oe}),define(Ee[54],pe([0,1,62,8,17,13,50,9,6,4,47,53,33,26]),function(ce,e,p,t,$,W,V,k,T,P,N,E,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0,k=Ie(k);class a extends M.ChannelServer{constructor(b){super({send:c=>{try{process.send?.(c.buffer.toString("base64"))}catch{}},onMessage:T.Event.fromNodeEventEmitter(process,"message",c=>$.VSBuffer.wrap(Buffer.from(c,"base64")))},b),process.once("disconnect",()=>this.dispose())}}e.Server=a;class r{constructor(b,c){this.modulePath=b,this.options=c,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new T.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const v=c&&c.timeout?c.timeout:6e4;this.disposeDelayer=new t.Delayer(v),this.child=null,this._client=null}getChannel(b){const c=this;return{call(v,w,l){return c.requestPromise(b,v,w,l)},listen(v,w){return c.requestEvent(b,v,w)}}}requestPromise(b,c,v,w=W.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(w.isCancellationRequested)return Promise.reject(k.canceled());this.disposeDelayer.cancel();const l=this.getCachedChannel(b),n=(0,t.createCancelablePromise)(o=>l.call(c,v,o)),i=w.onCancellationRequested(()=>n.cancel()),s=(0,P.toDisposable)(()=>n.cancel());return this.activeRequests.add(s),n.finally(()=>{i.dispose(),this.activeRequests.delete(s),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),n}requestEvent(b,c,v){if(!this.disposeDelayer)return T.Event.None;this.disposeDelayer.cancel();let w;const l=new T.Emitter({onWillAddFirstListener:()=>{w=this.getCachedChannel(b).listen(c,v)(l.fire,l),this.activeRequests.add(w)},onDidRemoveLastListener:()=>{this.activeRequests.delete(w),w.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return l.event}get client(){if(!this._client){const b=this.options&&this.options.args?this.options.args:[],c=Object.create(null);c.env={...(0,N.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(c.env={...c.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(c.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(c.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(c.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),c.execArgv===void 0&&(c.execArgv=process.execArgv.filter(_=>!/^--inspect(-brk)?=/.test(_)).filter(_=>!_.startsWith("--vscode-"))),(0,y.removeDangerousEnvVariables)(c.env),this.child=(0,p.fork)(this.modulePath,b,c);const v=new T.Emitter,l=T.Event.fromNodeEventEmitter(this.child,"message",_=>_)(_=>{if((0,V.isRemoteConsoleLog)(_)){(0,V.log)(_,`IPC Library: ${this.options.serverName}`);return}v.fire($.VSBuffer.wrap(Buffer.from(_,"base64")))}),n=this.options.useQueue?(0,E.createQueuedSender)(this.child):this.child,i=_=>this.child&&this.child.connected&&n.send(_.buffer.toString("base64")),s=v.event,o={send:i,onMessage:s};this._client=new M.ChannelClient(o);const U=()=>this.disposeClient();process.once("exit",U),this.child.on("error",_=>console.warn('IPC "'+this.options.serverName+'" errored with '+_)),this.child.on("exit",(_,m)=>{process.removeListener("exit",U),l.dispose(),this.activeRequests.forEach(f=>(0,P.dispose)(f)),this.activeRequests.clear(),_!==0&&m!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+_+" and signal "+m),this.disposeDelayer?.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:_,signal:m})})}return this._client}getCachedChannel(b){let c=this.channels.get(b);return c||(c=this.client.getChannel(b),this.channels.set(b,c)),c}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer?.cancel(),this.disposeDelayer=void 0,this.disposeClient(),this.activeRequests.clear()}}e.Client=r}),define(Ee[55],pe([0,1,30,17,26,6,10,12]),function(ce,e,p,t,$,W,V,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0,e.once=N;class T{constructor(y){this.port=y,this.onMessage=W.Event.fromNodeEventEmitter(this.port,"message",M=>M.data?t.VSBuffer.wrap(M.data):t.VSBuffer.alloc(0)),y.start()}send(y){this.port.postMessage(y.buffer)}disconnect(){this.port.close()}}class P extends $.IPCServer{static getOnDidClientConnect(y){(0,V.assertType)((0,p.isUtilityProcess)(process),"Electron Utility Process");const M=new W.Emitter;return process.parentPort.on("message",a=>{if(y?.handledClientConnection(a))return;const r=(0,k.firstOrDefault)(a.ports);r&&M.fire(r)}),W.Event.map(M.event,a=>({protocol:new T(a),onDidClientDisconnect:W.Event.fromNodeEventEmitter(a,"close")}))}constructor(y){super(P.getOnDidClientConnect(y))}}e.Server=P;function N(E,y,M){const a=r=>{r.data===y&&(E.removeListener("message",a),M())};E.on("message",a)}}),define(Ee[56],pe([0,1]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IInstantiationService=e._util=void 0,e.createDecorator=$,e.refineServiceDecorator=W;var p;(function(V){V.serviceIds=new Map,V.DI_TARGET="$di$target",V.DI_DEPENDENCIES="$di$dependencies";function k(T){return T[V.DI_DEPENDENCIES]||[]}V.getServiceDependencies=k})(p||(e._util=p={})),e.IInstantiationService=$("instantiationService");function t(V,k,T){k[p.DI_TARGET]===k?k[p.DI_DEPENDENCIES].push({id:V,index:T}):(k[p.DI_DEPENDENCIES]=[{id:V,index:T}],k[p.DI_TARGET]=k)}function $(V){if(p.serviceIds.has(V))return p.serviceIds.get(V);const k=function(T,P,N){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");t(k,T,N)};return k.toString=()=>V,p.serviceIds.set(V,k),k}function W(V){return V}}),define(Ee[18],pe([0,1,29,3,7,10,5,22,56,2,34,16]),function(ce,e,p,t,$,W,V,k,T,P,N,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ByteSize=e.ETAG_DISABLED=e.FileKind=e.FILES_READONLY_FROM_PERMISSIONS_CONFIG=e.FILES_READONLY_EXCLUDE_CONFIG=e.FILES_READONLY_INCLUDE_CONFIG=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.TooLargeFileOperationError=e.FileOperationError=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FileChangeFilter=e.FilePermission=e.FileType=e.IFileService=void 0,e.isFileOpenForWriteOptions=y,e.isFileSystemWatcher=d,e.hasReadWriteCapability=c,e.hasFileFolderCopyCapability=v,e.hasFileCloneCapability=w,e.hasOpenReadWriteCloseCapability=l,e.hasFileReadStreamCapability=n,e.hasFileAtomicReadCapability=i,e.hasFileAtomicWriteCapability=s,e.hasFileAtomicDeleteCapability=o,e.hasReadonlyCapability=U,e.createFileSystemProviderError=f,e.ensureFileSystemProviderError=A,e.markAsFileSystemProviderError=R,e.toFileSystemProviderErrorCode=u,e.toFileOperationResult=D,e.isParent=se,e.etag=g,e.whenProviderRegistered=F,e.getLargeFileConfirmationLimit=Y,e.IFileService=(0,T.createDecorator)("fileService");function y(L){return L.create===!0}var M;(function(L){L[L.Unknown=0]="Unknown",L[L.File=1]="File",L[L.Directory=2]="Directory",L[L.SymbolicLink=64]="SymbolicLink"})(M||(e.FileType=M={}));var a;(function(L){L[L.Readonly=1]="Readonly",L[L.Locked=2]="Locked"})(a||(e.FilePermission=a={}));var r;(function(L){L[L.UPDATED=2]="UPDATED",L[L.ADDED=4]="ADDED",L[L.DELETED=8]="DELETED"})(r||(e.FileChangeFilter=r={}));function d(L){const J=L;return!!J&&typeof J.onDidChange=="function"}var b;(function(L){L[L.None=0]="None",L[L.FileReadWrite=2]="FileReadWrite",L[L.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",L[L.FileReadStream=16]="FileReadStream",L[L.FileFolderCopy=8]="FileFolderCopy",L[L.PathCaseSensitive=1024]="PathCaseSensitive",L[L.Readonly=2048]="Readonly",L[L.Trash=4096]="Trash",L[L.FileWriteUnlock=8192]="FileWriteUnlock",L[L.FileAtomicRead=16384]="FileAtomicRead",L[L.FileAtomicWrite=32768]="FileAtomicWrite",L[L.FileAtomicDelete=65536]="FileAtomicDelete",L[L.FileClone=131072]="FileClone"})(b||(e.FileSystemProviderCapabilities=b={}));function c(L){return!!(L.capabilities&b.FileReadWrite)}function v(L){return!!(L.capabilities&b.FileFolderCopy)}function w(L){return!!(L.capabilities&b.FileClone)}function l(L){return!!(L.capabilities&b.FileOpenReadWriteClose)}function n(L){return!!(L.capabilities&b.FileReadStream)}function i(L){return c(L)?!!(L.capabilities&b.FileAtomicRead):!1}function s(L){return c(L)?!!(L.capabilities&b.FileAtomicWrite):!1}function o(L){return!!(L.capabilities&b.FileAtomicDelete)}function U(L){return!!(L.capabilities&b.Readonly)}var _;(function(L){L.FileExists="EntryExists",L.FileNotFound="EntryNotFound",L.FileNotADirectory="EntryNotADirectory",L.FileIsADirectory="EntryIsADirectory",L.FileExceedsStorageQuota="EntryExceedsStorageQuota",L.FileTooLarge="EntryTooLarge",L.FileWriteLocked="EntryWriteLocked",L.NoPermissions="NoPermissions",L.Unavailable="Unavailable",L.Unknown="Unknown"})(_||(e.FileSystemProviderErrorCode=_={}));class m extends Error{static create(J,ee){const ne=new m(J.toString(),ee);return R(ne,ee),ne}constructor(J,ee){super(J),this.code=ee}}e.FileSystemProviderError=m;function f(L,J){return m.create(L,J)}function A(L){return L||f((0,k.localize)(1865,null),_.Unknown)}function R(L,J){return L.name=J?`${J} (FileSystemError)`:"FileSystemError",L}function u(L){if(!L)return _.Unknown;if(L instanceof m)return L.code;const J=/^(.+) \(FileSystemError\)$/.exec(L.name);if(!J)return _.Unknown;switch(J[1]){case _.FileExists:return _.FileExists;case _.FileIsADirectory:return _.FileIsADirectory;case _.FileNotADirectory:return _.FileNotADirectory;case _.FileNotFound:return _.FileNotFound;case _.FileTooLarge:return _.FileTooLarge;case _.FileWriteLocked:return _.FileWriteLocked;case _.NoPermissions:return _.NoPermissions;case _.Unavailable:return _.Unavailable}return _.Unknown}function D(L){if(L instanceof K)return L.fileOperationResult;switch(u(L)){case _.FileNotFound:return oe.FILE_NOT_FOUND;case _.FileIsADirectory:return oe.FILE_IS_DIRECTORY;case _.FileNotADirectory:return oe.FILE_NOT_DIRECTORY;case _.FileWriteLocked:return oe.FILE_WRITE_LOCKED;case _.NoPermissions:return oe.FILE_PERMISSION_DENIED;case _.FileExists:return oe.FILE_MOVE_CONFLICT;case _.FileTooLarge:return oe.FILE_TOO_LARGE;default:return oe.FILE_OTHER_ERROR}}var C;(function(L){L[L.CREATE=0]="CREATE",L[L.DELETE=1]="DELETE",L[L.MOVE=2]="MOVE",L[L.COPY=3]="COPY",L[L.WRITE=4]="WRITE"})(C||(e.FileOperation=C={}));class x{constructor(J,ee,ne){this.resource=J,this.operation=ee,this.target=ne}isOperation(J){return this.operation===J}}e.FileOperationEvent=x;var X;(function(L){L[L.UPDATED=0]="UPDATED",L[L.ADDED=1]="ADDED",L[L.DELETED=2]="DELETED"})(X||(e.FileChangeType=X={}));class H{static{this.MIXED_CORRELATION=null}constructor(J,ee){this.ignorePathCasing=ee,this.correlationId=void 0,this.added=new E.Lazy(()=>{const ne=p.TernarySearchTree.forUris(()=>this.ignorePathCasing);return ne.fill(this.rawAdded.map(le=>[le,!0])),ne}),this.updated=new E.Lazy(()=>{const ne=p.TernarySearchTree.forUris(()=>this.ignorePathCasing);return ne.fill(this.rawUpdated.map(le=>[le,!0])),ne}),this.deleted=new E.Lazy(()=>{const ne=p.TernarySearchTree.forUris(()=>this.ignorePathCasing);return ne.fill(this.rawDeleted.map(le=>[le,!0])),ne}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const ne of J){switch(ne.type){case X.ADDED:this.rawAdded.push(ne.resource);break;case X.UPDATED:this.rawUpdated.push(ne.resource);break;case X.DELETED:this.rawDeleted.push(ne.resource);break}this.correlationId!==H.MIXED_CORRELATION&&(typeof ne.cId=="number"?this.correlationId===void 0?this.correlationId=ne.cId:this.correlationId!==ne.cId&&(this.correlationId=H.MIXED_CORRELATION):this.correlationId!==void 0&&(this.correlationId=H.MIXED_CORRELATION))}}contains(J,...ee){return this.doContains(J,{includeChildren:!1},...ee)}affects(J,...ee){return this.doContains(J,{includeChildren:!0},...ee)}doContains(J,ee,...ne){if(!J)return!1;const le=ne.length>0;return!!((!le||ne.includes(X.ADDED))&&(this.added.value.get(J)||ee.includeChildren&&this.added.value.findSuperstr(J))||(!le||ne.includes(X.UPDATED))&&(this.updated.value.get(J)||ee.includeChildren&&this.updated.value.findSuperstr(J))||(!le||ne.includes(X.DELETED))&&(this.deleted.value.findSubstr(J)||ee.includeChildren&&this.deleted.value.findSuperstr(J)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(J){return this.correlationId===J}hasCorrelation(){return typeof this.correlationId=="number"}}e.FileChangesEvent=H;function se(L,J,ee){return!L||!J||L===J||J.length>L.length?!1:(J.charAt(J.length-1)!==t.sep&&(J+=t.sep),ee?(0,$.startsWithIgnoreCase)(L,J):L.indexOf(J)===0)}class K extends Error{constructor(J,ee,ne){super(J),this.fileOperationResult=ee,this.options=ne}}e.FileOperationError=K;class ie extends K{constructor(J,ee,ne,le){super(J,ee,le),this.fileOperationResult=ee,this.size=ne}}e.TooLargeFileOperationError=ie;class re extends K{constructor(J,ee,ne){super(J,oe.FILE_NOT_MODIFIED_SINCE,ne),this.stat=ee}}e.NotModifiedSinceFileOperationError=re;var oe;(function(L){L[L.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",L[L.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",L[L.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",L[L.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",L[L.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",L[L.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",L[L.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",L[L.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",L[L.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",L[L.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",L[L.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(oe||(e.FileOperationResult=oe={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude",e.FILES_READONLY_INCLUDE_CONFIG="files.readonlyInclude",e.FILES_READONLY_EXCLUDE_CONFIG="files.readonlyExclude",e.FILES_READONLY_FROM_PERMISSIONS_CONFIG="files.readonlyFromPermissions";var I;(function(L){L[L.FILE=0]="FILE",L[L.FOLDER=1]="FOLDER",L[L.ROOT_FOLDER=2]="ROOT_FOLDER"})(I||(e.FileKind=I={})),e.ETAG_DISABLED="";function g(L){if(!(typeof L.size!="number"||typeof L.mtime!="number"))return L.mtime.toString(29)+L.size.toString(31)}async function F(L,J){if(!J.hasProvider(V.URI.from({scheme:L.scheme})))return new Promise(ee=>{const ne=J.onDidChangeFileSystemProviderRegistrations(le=>{le.scheme===L.scheme&&le.added&&(ne.dispose(),ee())})})}class j{static{this.KB=1024}static{this.MB=j.KB*j.KB}static{this.GB=j.MB*j.KB}static{this.TB=j.GB*j.KB}static formatSize(J){return(0,W.isNumber)(J)||(J=0),J<j.KB?(0,k.localize)(1866,null,J.toFixed(0)):J<j.MB?(0,k.localize)(1867,null,(J/j.KB).toFixed(2)):J<j.GB?(0,k.localize)(1868,null,(J/j.MB).toFixed(2)):J<j.TB?(0,k.localize)(1869,null,(J/j.GB).toFixed(2)):(0,k.localize)(1870,null,(J/j.TB).toFixed(2))}}e.ByteSize=j;function Y(L){const J=typeof L=="string"||L?.scheme===N.Schemas.vscodeRemote;return typeof L!="string"&&L?.scheme===N.Schemas.file?1024*j.MB:J?10*j.MB:P.isWeb?50*j.MB:1024*j.MB}}),define(Ee[19],pe([0,1,24,4,3,2,5,18]),function(ce,e,p,t,$,W,V,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractUniversalWatcherClient=e.AbstractNonRecursiveWatcherClient=e.AbstractWatcherClient=void 0,e.isWatchRequestWithCorrelation=T,e.isRecursiveWatchRequest=P,e.reviveFileChanges=M,e.coalesceEvents=a,e.normalizeWatcherPattern=r,e.parseWatcherPatterns=d,e.isFiltered=c,e.requestFilterToString=v;function T(w){return typeof w.correlationId=="number"}function P(w){return w.recursive===!0}class N extends t.Disposable{static{this.MAX_RESTARTS=5}constructor(l,n,i,s){super(),this.onFileChanges=l,this.onLogMessage=n,this.verboseLogging=i,this.options=s,this.watcherDisposables=this._register(new t.MutableDisposable),this.requests=void 0,this.restartCounter=0}init(){const l=new t.DisposableStore;this.watcherDisposables.value=l,this.watcher=this.createWatcher(l),this.watcher.setVerboseLogging(this.verboseLogging),l.add(this.watcher.onDidChangeFile(n=>this.onFileChanges(n))),l.add(this.watcher.onDidLogMessage(n=>this.onLogMessage(n))),l.add(this.watcher.onDidError(n=>this.onError(n.error,n.request)))}onError(l,n){this.canRestart(l,n)?this.restartCounter<N.MAX_RESTARTS&&this.requests?(this.error(`restarting watcher after unexpected error: ${l}`),this.restart(this.requests)):this.error(`gave up attempting to restart watcher after unexpected error: ${l}`):this.error(l)}canRestart(l,n){return!(!this.options.restartOnError||n||l.indexOf("No space left on device")!==-1||l.indexOf("EMFILE")!==-1)}restart(l){this.restartCounter++,this.init(),this.watch(l)}async watch(l){this.requests=l,await this.watcher?.watch(l)}async setVerboseLogging(l){this.verboseLogging=l,await this.watcher?.setVerboseLogging(l)}error(l){this.onLogMessage({type:"error",message:`[File Watcher (${this.options.type})] ${l}`})}trace(l){this.onLogMessage({type:"trace",message:`[File Watcher (${this.options.type})] ${l}`})}dispose(){return this.watcher=void 0,super.dispose()}}e.AbstractWatcherClient=N;class E extends N{constructor(l,n,i){super(l,n,i,{type:"node.js",restartOnError:!1})}}e.AbstractNonRecursiveWatcherClient=E;class y extends N{constructor(l,n,i){super(l,n,i,{type:"universal",restartOnError:!0})}}e.AbstractUniversalWatcherClient=y;function M(w){return w.map(l=>({type:l.type,resource:V.URI.revive(l.resource),cId:l.cId}))}function a(w){const l=new b;for(const n of w)l.processEvent(n);return l.coalesce()}function r(w,l){return typeof l=="string"&&!l.startsWith(p.GLOBSTAR)&&!(0,$.isAbsolute)(l)?{base:w,pattern:l}:l}function d(w,l){const n=[];for(const i of l)n.push((0,p.parse)(r(w,i)));return n}class b{constructor(){this.coalesced=new Set,this.mapPathToChange=new Map}toKey(l){return W.isLinux?l.resource.fsPath:l.resource.fsPath.toLowerCase()}processEvent(l){const n=this.mapPathToChange.get(this.toKey(l));let i=!1;if(n){const s=n.type,o=l.type;n.resource.fsPath!==l.resource.fsPath&&(l.type===k.FileChangeType.DELETED||l.type===k.FileChangeType.ADDED)?i=!0:s===k.FileChangeType.ADDED&&o===k.FileChangeType.DELETED?(this.mapPathToChange.delete(this.toKey(l)),this.coalesced.delete(n)):s===k.FileChangeType.DELETED&&o===k.FileChangeType.ADDED?n.type=k.FileChangeType.UPDATED:s===k.FileChangeType.ADDED&&o===k.FileChangeType.UPDATED||(n.type=o)}else i=!0;i&&(this.coalesced.add(l),this.mapPathToChange.set(this.toKey(l),l))}coalesce(){const l=[],n=[];return Array.from(this.coalesced).filter(i=>i.type!==k.FileChangeType.DELETED?(l.push(i),!1):!0).sort((i,s)=>i.resource.fsPath.length-s.resource.fsPath.length).filter(i=>n.some(s=>(0,k.isParent)(i.resource.fsPath,s,!W.isLinux))?!1:(n.push(i.resource.fsPath),!0)).concat(l)}}function c(w,l){if(typeof l=="number")switch(w.type){case k.FileChangeType.ADDED:return(l&k.FileChangeFilter.ADDED)===0;case k.FileChangeType.DELETED:return(l&k.FileChangeFilter.DELETED)===0;case k.FileChangeType.UPDATED:return(l&k.FileChangeFilter.UPDATED)===0}return!1}function v(w){if(typeof w=="number"){const l=[];return w&k.FileChangeFilter.ADDED&&l.push("Added"),w&k.FileChangeFilter.DELETED&&l.push("Deleted"),w&k.FileChangeFilter.UPDATED&&l.push("Updated"),l.length===0?"<all>":`[${l.join(", ")}]`}return"<none>"}}),define(Ee[36],pe([0,1,15,4,19,6,18,5,8]),function(ce,e,p,t,$,W,V,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BaseWatcher=void 0;class P extends t.Disposable{constructor(){super(),this._onDidChangeFile=this._register(new W.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidLogMessage=this._register(new W.Emitter),this.onDidLogMessage=this._onDidLogMessage.event,this._onDidWatchFail=this._register(new W.Emitter),this.onDidWatchFail=this._onDidWatchFail.event,this.allNonCorrelatedWatchRequests=new Set,this.allCorrelatedWatchRequests=new Map,this.suspendedWatchRequests=this._register(new t.DisposableMap),this.suspendedWatchRequestsWithPolling=new Set,this.updateWatchersDelayer=this._register(new T.ThrottledDelayer(this.getUpdateWatchersDelay())),this.suspendedWatchRequestPollingInterval=5007,this.joinWatch=new T.DeferredPromise,this.verboseLogging=!1,this._register(this.onDidWatchFail(E=>this.handleDidWatchFail(E)))}handleDidWatchFail(E){this.isCorrelated(E)&&this.suspendWatchRequest(E)}isCorrelated(E){return(0,$.isWatchRequestWithCorrelation)(E)}async watch(E){this.joinWatch.isSettled||this.joinWatch.complete(),this.joinWatch=new T.DeferredPromise;try{this.allCorrelatedWatchRequests.clear(),this.allNonCorrelatedWatchRequests.clear();for(const y of E)this.isCorrelated(y)?this.allCorrelatedWatchRequests.set(y.correlationId,y):this.allNonCorrelatedWatchRequests.add(y);for(const[y]of this.suspendedWatchRequests)this.allCorrelatedWatchRequests.has(y)||(this.suspendedWatchRequests.deleteAndDispose(y),this.suspendedWatchRequestsWithPolling.delete(y));return await this.updateWatchers(!1)}finally{this.joinWatch.complete()}}updateWatchers(E){return this.updateWatchersDelayer.trigger(()=>this.doWatch([...this.allNonCorrelatedWatchRequests,...Array.from(this.allCorrelatedWatchRequests.values()).filter(y=>!this.suspendedWatchRequests.has(y.correlationId))]),E?this.getUpdateWatchersDelay():0)}getUpdateWatchersDelay(){return 800}isSuspended(E){return typeof E.correlationId!="number"?!1:this.suspendedWatchRequestsWithPolling.has(E.correlationId)?"polling":this.suspendedWatchRequests.has(E.correlationId)}async suspendWatchRequest(E){if(this.suspendedWatchRequests.has(E.correlationId))return;const y=new t.DisposableStore;this.suspendedWatchRequests.set(E.correlationId,y),await this.joinWatch.p,!y.isDisposed&&(this.monitorSuspendedWatchRequest(E,y),this.updateWatchers(!0))}resumeWatchRequest(E){this.suspendedWatchRequests.deleteAndDispose(E.correlationId),this.suspendedWatchRequestsWithPolling.delete(E.correlationId),this.updateWatchers(!1)}monitorSuspendedWatchRequest(E,y){this.doMonitorWithExistingWatcher(E,y)?(this.trace(`reusing an existing recursive watcher to monitor ${E.path}`),this.suspendedWatchRequestsWithPolling.delete(E.correlationId)):(this.doMonitorWithNodeJS(E,y),this.suspendedWatchRequestsWithPolling.add(E.correlationId))}doMonitorWithExistingWatcher(E,y){const M=this.recursiveWatcher?.subscribe(E.path,(a,r)=>{y.isDisposed||(a?this.monitorSuspendedWatchRequest(E,y):r?.type===V.FileChangeType.ADDED&&this.onMonitoredPathAdded(E))});return M?(y.add(M),!0):!1}doMonitorWithNodeJS(E,y){let M=!1;const a=(r,d)=>{if(y.isDisposed)return;const b=this.isPathNotFound(r),c=this.isPathNotFound(d),v=M;M=b,!b&&(c||v)&&this.onMonitoredPathAdded(E)};this.trace(`starting fs.watchFile() on ${E.path} (correlationId: ${E.correlationId})`);try{(0,p.watchFile)(E.path,{persistent:!1,interval:this.suspendedWatchRequestPollingInterval},a)}catch(r){this.warn(`fs.watchFile() failed with error ${r} on path ${E.path} (correlationId: ${E.correlationId})`)}y.add((0,t.toDisposable)(()=>{this.trace(`stopping fs.watchFile() on ${E.path} (correlationId: ${E.correlationId})`);try{(0,p.unwatchFile)(E.path,a)}catch(r){this.warn(`fs.unwatchFile() failed with error ${r} on path ${E.path} (correlationId: ${E.correlationId})`)}}))}onMonitoredPathAdded(E){this.trace(`detected ${E.path} exists again, resuming watcher (correlationId: ${E.correlationId})`);const y={resource:k.URI.file(E.path),type:V.FileChangeType.ADDED,cId:E.correlationId};this._onDidChangeFile.fire([y]),this.traceEvent(y,E),this.resumeWatchRequest(E)}isPathNotFound(E){return E.ctimeMs===0&&E.ino===0}async stop(){this.suspendedWatchRequests.clearAndDisposeAll(),this.suspendedWatchRequestsWithPolling.clear()}traceEvent(E,y){if(this.verboseLogging){const M=` >> normalized ${E.type===V.FileChangeType.ADDED?"[ADDED]":E.type===V.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${E.resource.fsPath}`;this.traceWithCorrelation(M,y)}}traceWithCorrelation(E,y){this.verboseLogging&&this.trace(`${E}${typeof y.correlationId=="number"?` <${y.correlationId}> `:""}`)}requestToString(E){return`${E.path} (excludes: ${E.excludes.length>0?E.excludes:"<none>"}, includes: ${E.includes&&E.includes.length>0?JSON.stringify(E.includes):"<all>"}, filter: ${(0,$.requestFilterToString)(E.filter)}, correlationId: ${typeof E.correlationId=="number"?E.correlationId:"<none>"})`}async setVerboseLogging(E){this.verboseLogging=E}}e.BaseWatcher=P}),define(Ee[37],pe([0,1,15,8,13,14,4,21,3,2,23,5,35,25,18,19]),function(ce,e,p,t,$,W,V,k,T,P,N,E,y,M,a,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSFileWatcherLibrary=void 0,e.watchFileContents=b;class d extends V.Disposable{static{this.FILE_DELETE_HANDLER_DELAY=100}static{this.FILE_CHANGES_HANDLER_DELAY=75}get isReusingRecursiveWatcher(){return this._isReusingRecursiveWatcher}get failed(){return this.didFail}constructor(v,w,l,n,i,s){super(),this.request=v,this.recursiveWatcher=w,this.onDidFilesChange=l,this.onDidWatchFail=n,this.onLogMessage=i,this.verboseLogging=s,this.throttledFileChangesEmitter=this._register(new t.ThrottledWorker({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},o=>this.onDidFilesChange(o))),this.fileChangesAggregator=this._register(new t.RunOnceWorker(o=>this.handleFileChanges(o),d.FILE_CHANGES_HANDLER_DELAY)),this.excludes=(0,r.parseWatcherPatterns)(this.request.path,this.request.excludes),this.includes=this.request.includes?(0,r.parseWatcherPatterns)(this.request.path,this.request.includes):void 0,this.filter=(0,r.isWatchRequestWithCorrelation)(this.request)?this.request.filter:void 0,this.cts=new $.CancellationTokenSource,this.ready=this.watch(),this._isReusingRecursiveWatcher=!1,this.didFail=!1}async watch(){try{const v=await this.normalizePath(this.request);if(this.cts.token.isCancellationRequested)return;const w=await p.promises.stat(v);if(this.cts.token.isCancellationRequested)return;this._register(await this.doWatch(v,w.isDirectory()))}catch(v){v.code!=="ENOENT"?this.error(v):this.trace(`ignoring a path for watching who's stat info failed to resolve: ${this.request.path} (error: ${v})`),this.notifyWatchFailed()}}notifyWatchFailed(){this.didFail=!0,this.onDidWatchFail?.()}async normalizePath(v){let w=v.path;try{w=await M.Promises.realpath(v.path),v.path===w&&(w=await(0,y.realcase)(v.path,this.cts.token)??v.path),v.path!==w&&this.trace(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${v.path}, real: ${w})`)}catch{}return w}async doWatch(v,w){const l=new V.DisposableStore;return this.doWatchWithExistingWatcher(v,w,l)?(this.trace(`reusing an existing recursive watcher for ${this.request.path}`),this._isReusingRecursiveWatcher=!0):(this._isReusingRecursiveWatcher=!1,await this.doWatchWithNodeJS(v,w,l)),l}doWatchWithExistingWatcher(v,w,l){if(w)return!1;const n=E.URI.file(this.request.path),i=this.recursiveWatcher?.subscribe(this.request.path,async(s,o)=>{if(!l.isDisposed)if(s){const U=await this.doWatch(v,w);l.isDisposed?U.dispose():l.add(U)}else o&&(typeof o.cId=="number"||typeof this.request.correlationId=="number")&&this.onFileChange({resource:n,type:o.type,cId:this.request.correlationId},!0)});return i?(l.add(i),!0):!1}async doWatchWithNodeJS(v,w,l){if(P.isMacintosh&&(0,W.isEqualOrParent)(v,"/Volumes/",!0)){this.error(`Refusing to watch ${v} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`);return}const n=new $.CancellationTokenSource(this.cts.token);l.add((0,V.toDisposable)(()=>n.dispose(!0)));const i=new V.DisposableStore;l.add(i);try{const s=E.URI.file(this.request.path),o=(0,T.basename)(v),U=(0,p.watch)(v);i.add((0,V.toDisposable)(()=>{U.removeAllListeners(),U.close()})),this.trace(`Started watching: '${v}'`);const _=new Set;if(w)try{for(const f of await M.Promises.readdir(v))_.add(f)}catch(f){this.error(f)}if(n.token.isCancellationRequested)return;const m=new Map;i.add((0,V.toDisposable)(()=>{for(const[,f]of m)f.dispose();m.clear()})),U.on("error",(f,A)=>{n.token.isCancellationRequested||(this.error(`Failed to watch ${v} for changes using fs.watch() (${f}, ${A})`),this.notifyWatchFailed())}),U.on("change",(f,A)=>{if(n.token.isCancellationRequested)return;this.verboseLogging&&this.traceWithCorrelation(`[raw] ["${f}"] ${A}`);let R="";if(A&&(R=A.toString(),P.isMacintosh&&(R=(0,k.normalizeNFC)(R))),!(!R||f!=="change"&&f!=="rename"))if(w)if(f==="rename"){m.get(R)?.dispose();const u=setTimeout(async()=>{if(m.delete(R),R===o&&!await M.Promises.exists(v)){this.onWatchedPathDeleted(s);return}if(n.token.isCancellationRequested)return;const D=await this.existsChildStrictCase((0,T.join)(v,R));if(n.token.isCancellationRequested)return;let C;D?_.has(R)?C=a.FileChangeType.UPDATED:(C=a.FileChangeType.ADDED,_.add(R)):(_.delete(R),C=a.FileChangeType.DELETED),this.onFileChange({resource:(0,N.joinPath)(s,R),type:C,cId:this.request.correlationId})},d.FILE_DELETE_HANDLER_DELAY);m.set(R,(0,V.toDisposable)(()=>clearTimeout(u)))}else{let u;_.has(R)?u=a.FileChangeType.UPDATED:(u=a.FileChangeType.ADDED,_.add(R)),this.onFileChange({resource:(0,N.joinPath)(s,R),type:u,cId:this.request.correlationId})}else if(f==="rename"||R!==o){const u=setTimeout(async()=>{const D=await M.Promises.exists(v);n.token.isCancellationRequested||(D?(this.onFileChange({resource:s,type:a.FileChangeType.UPDATED,cId:this.request.correlationId},!0),i.add(await this.doWatch(v,!1))):this.onWatchedPathDeleted(s))},d.FILE_DELETE_HANDLER_DELAY);i.clear(),i.add((0,V.toDisposable)(()=>clearTimeout(u)))}else this.onFileChange({resource:s,type:a.FileChangeType.UPDATED,cId:this.request.correlationId},!0)})}catch(s){n.token.isCancellationRequested||this.error(`Failed to watch ${v} for changes using fs.watch() (${s.toString()})`),this.notifyWatchFailed()}}onWatchedPathDeleted(v){this.warn("Watcher shutdown because watched path got deleted"),this.onFileChange({resource:v,type:a.FileChangeType.DELETED,cId:this.request.correlationId},!0),this.fileChangesAggregator.flush(),this.notifyWatchFailed()}onFileChange(v,w=!1){this.cts.token.isCancellationRequested||(this.verboseLogging&&this.traceWithCorrelation(`${v.type===a.FileChangeType.ADDED?"[ADDED]":v.type===a.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${v.resource.fsPath}`),!w&&this.excludes.some(l=>l(v.resource.fsPath))?this.verboseLogging&&this.traceWithCorrelation(` >> ignored (excluded) ${v.resource.fsPath}`):!w&&this.includes&&this.includes.length>0&&!this.includes.some(l=>l(v.resource.fsPath))?this.verboseLogging&&this.traceWithCorrelation(` >> ignored (not included) ${v.resource.fsPath}`):this.fileChangesAggregator.work(v))}handleFileChanges(v){const w=(0,r.coalesceEvents)(v),l=[];for(const i of w){if((0,r.isFiltered)(i,this.filter)){this.verboseLogging&&this.traceWithCorrelation(` >> ignored (filtered) ${i.resource.fsPath}`);continue}l.push(i)}if(l.length===0)return;if(this.verboseLogging)for(const i of l)this.traceWithCorrelation(` >> normalized ${i.type===a.FileChangeType.ADDED?"[ADDED]":i.type===a.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${i.resource.fsPath}`);this.throttledFileChangesEmitter.work(l)?this.throttledFileChangesEmitter.pending>0&&this.trace(`started throttling events due to large amount of file change events at once (pending: ${this.throttledFileChangesEmitter.pending}, most recent change: ${l[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.warn(`started ignoring events due to too many file change events at once (incoming: ${l.length}, most recent change: ${l[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}async existsChildStrictCase(v){if(P.isLinux)return M.Promises.exists(v);try{const w=(0,T.basename)(v);return(await M.Promises.readdir((0,T.dirname)(v))).some(n=>n===w)}catch(w){return this.trace(w),!1}}setVerboseLogging(v){this.verboseLogging=v}error(v){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"error",message:`[File Watcher (node.js)] ${v}`})}warn(v){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"warn",message:`[File Watcher (node.js)] ${v}`})}trace(v){!this.cts.token.isCancellationRequested&&this.verboseLogging&&this.onLogMessage?.({type:"trace",message:`[File Watcher (node.js)] ${v}`})}traceWithCorrelation(v){!this.cts.token.isCancellationRequested&&this.verboseLogging&&this.trace(`${v}${typeof this.request.correlationId=="number"?` <${this.request.correlationId}> `:""}`)}dispose(){this.cts.dispose(!0),super.dispose()}}e.NodeJSFileWatcherLibrary=d;async function b(c,v,w,l,n=512){const i=await M.Promises.open(c,"r"),s=Buffer.allocUnsafe(n),o=new $.CancellationTokenSource(l);let U,_=!1;const m={path:c,excludes:[],recursive:!1},f=new d(m,void 0,A=>{(async()=>{for(const{type:R}of A)if(R===a.FileChangeType.UPDATED){if(_)return;_=!0;try{for(;!o.token.isCancellationRequested;){const{bytesRead:u}=await M.Promises.read(i,s,0,n,null);if(!u||o.token.isCancellationRequested)break;v(s.slice(0,u))}}catch(u){U=new Error(u),o.dispose(!0)}finally{_=!1}}})()});return await f.ready,w(),new Promise((A,R)=>{o.token.onCancellationRequested(async()=>{f.dispose();try{await M.Promises.close(i)}catch(u){U=new Error(u)}U?R(U):A()})})}}),define(Ee[57],pe([0,1,6,24,36,2,37,14]),function(ce,e,p,t,$,W,V,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class T extends $.BaseWatcher{constructor(N){super(),this.recursiveWatcher=N,this.onDidError=p.Event.None,this.watchers=new Set}async doWatch(N){N=this.removeDuplicateRequests(N);const E=[],y=new Set(Array.from(this.watchers));for(const M of N){const a=this.findWatcher(M);a&&(0,t.patternsEquals)(a.request.excludes,M.excludes)&&(0,t.patternsEquals)(a.request.includes,M.includes)?y.delete(a):E.push(M)}E.length&&this.trace(`Request to start watching: ${E.map(M=>this.requestToString(M)).join(",")}`),y.size&&this.trace(`Request to stop watching: ${Array.from(y).map(M=>this.requestToString(M.request)).join(",")}`);for(const M of y)this.stopWatching(M);for(const M of E)this.startWatching(M)}findWatcher(N){for(const E of this.watchers)if(typeof N.correlationId=="number"||typeof E.request.correlationId=="number"){if(E.request.correlationId===N.correlationId)return E}else if((0,k.isEqual)(E.request.path,N.path,!W.isLinux))return E}startWatching(N){const E=new V.NodeJSFileWatcherLibrary(N,this.recursiveWatcher,M=>this._onDidChangeFile.fire(M),()=>this._onDidWatchFail.fire(N),M=>this._onDidLogMessage.fire(M),this.verboseLogging),y={request:N,instance:E};this.watchers.add(y)}async stop(){await super.stop();for(const N of this.watchers)this.stopWatching(N)}stopWatching(N){this.trace("stopping file watcher",N),this.watchers.delete(N),N.instance.dispose()}removeDuplicateRequests(N){const E=new Map;for(const y of N){const M=W.isLinux?y.path:y.path.toLowerCase();let a=E.get(y.correlationId);a||(a=new Map,E.set(y.correlationId,a)),a.has(M)&&this.trace(`ignoring a request for watching who's path is already watched: ${this.requestToString(y)}`),a.set(M,y)}return Array.from(E.values()).map(y=>Array.from(y.values())).flat()}async setVerboseLogging(N){super.setVerboseLogging(N);for(const E of this.watchers)E.instance.setVerboseLogging(N)}trace(N,E){this.verboseLogging&&this._onDidLogMessage.fire({type:"trace",message:this.toMessage(N,E)})}warn(N){this._onDidLogMessage.fire({type:"warn",message:this.toMessage(N)})}toMessage(N,E){return E?`[File Watcher (node.js)] ${N} (${this.requestToString(E.request)})`:`[File Watcher (node.js)] ${N}`}}e.NodeJSWatcher=T}),define(Ee[58],pe([0,1,63,15,52,5,8,13,49,6,14,24,36,29,21,3,2,35,37,18,19,4]),function(ce,e,p,t,$,W,V,k,T,P,N,E,y,M,a,r,d,b,c,v,w,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParcelWatcher=e.ParcelWatcherInstance=void 0,p=Ie(p);class n extends l.Disposable{get failed(){return this.didFail}get stopped(){return this.didStop}constructor(o,U,_,m,f,A){super(),this.ready=o,this.request=U,this.restarts=_,this.token=m,this.worker=f,this.stopFn=A,this._onDidStop=this._register(new P.Emitter),this.onDidStop=this._onDidStop.event,this._onDidFail=this._register(new P.Emitter),this.onDidFail=this._onDidFail.event,this.didFail=!1,this.didStop=!1,this.includes=this.request.includes?(0,w.parseWatcherPatterns)(this.request.path,this.request.includes):void 0,this.excludes=this.request.excludes?(0,w.parseWatcherPatterns)(this.request.path,this.request.excludes):void 0,this.subscriptions=new Map,this._register((0,l.toDisposable)(()=>this.subscriptions.clear()))}subscribe(o,U){o=W.URI.file(o).fsPath;let _=this.subscriptions.get(o);return _||(_=new Set,this.subscriptions.set(o,_)),_.add(U),(0,l.toDisposable)(()=>{const m=this.subscriptions.get(o);m&&(m.delete(U),m.size===0&&this.subscriptions.delete(o))})}get subscriptionsCount(){return this.subscriptions.size}notifyFileChange(o,U){const _=this.subscriptions.get(o);if(_)for(const m of _)m(U)}notifyWatchFailed(){this.didFail=!0,this._onDidFail.fire()}include(o){return!this.includes||this.includes.length===0?!0:this.includes.some(U=>U(o))}exclude(o){return!!this.excludes?.some(U=>U(o))}async stop(o){this.didStop=!0;try{await this.stopFn()}finally{this._onDidStop.fire({joinRestart:o}),this.dispose()}}}e.ParcelWatcherInstance=n;class i extends y.BaseWatcher{static{this.MAP_PARCEL_WATCHER_ACTION_TO_FILE_CHANGE=new Map([["create",v.FileChangeType.ADDED],["update",v.FileChangeType.UPDATED],["delete",v.FileChangeType.DELETED]])}static{this.PARCEL_WATCHER_BACKEND=d.isWindows?"windows":d.isLinux?"inotify":"fs-events"}static{this.FILE_CHANGES_HANDLER_DELAY=75}constructor(){super(),this._onDidError=this._register(new P.Emitter),this.onDidError=this._onDidError.event,this.watchers=new Set,this.throttledFileChangesEmitter=this._register(new V.ThrottledWorker({maxWorkChunkSize:500,throttleDelay:200,maxBufferedWork:3e4},o=>this._onDidChangeFile.fire(o))),this.enospcErrorLogged=!1,this.registerListeners()}registerListeners(){process.on("uncaughtException",o=>this.onUnexpectedError(o)),process.on("unhandledRejection",o=>this.onUnexpectedError(o))}async doWatch(o){o=this.removeDuplicateRequests(o);const U=[],_=new Set(Array.from(this.watchers));for(const m of o){const f=this.findWatcher(m);f&&(0,E.patternsEquals)(f.request.excludes,m.excludes)&&(0,E.patternsEquals)(f.request.includes,m.includes)&&f.request.pollingInterval===m.pollingInterval?_.delete(f):U.push(m)}U.length&&this.trace(`Request to start watching: ${U.map(m=>this.requestToString(m)).join(",")}`),_.size&&this.trace(`Request to stop watching: ${Array.from(_).map(m=>this.requestToString(m.request)).join(",")}`);for(const m of _)await this.stopWatching(m);for(const m of U)m.pollingInterval?this.startPolling(m,m.pollingInterval):await this.startWatching(m)}findWatcher(o){for(const U of this.watchers)if(this.isCorrelated(o)||this.isCorrelated(U.request)){if(U.request.correlationId===o.correlationId)return U}else if((0,N.isEqual)(U.request.path,o.path,!d.isLinux))return U}startPolling(o,U,_=0){const m=new k.CancellationTokenSource,f=new V.DeferredPromise,A=(0,N.randomPath)((0,$.tmpdir)(),"vscode-watcher-snapshot"),R=new n(f.p,o,_,m.token,new V.RunOnceWorker(H=>this.handleParcelEvents(H,R),i.FILE_CHANGES_HANDLER_DELAY),async()=>{m.dispose(!0),R.worker.flush(),R.worker.dispose(),X.dispose(),(0,t.unlinkSync)(A)});this.watchers.add(R);const{realPath:u,realPathDiffers:D,realPathLength:C}=this.normalizePath(o);this.trace(`Started watching: '${u}' with polling interval '${U}'`);let x=0;const X=new V.RunOnceScheduler(async()=>{if(x++,!m.token.isCancellationRequested){if(x>1){const H=await p.getEventsSince(u,A,{ignore:o.excludes,backend:i.PARCEL_WATCHER_BACKEND});if(m.token.isCancellationRequested)return;this.onParcelEvents(H,R,D,C)}await p.writeSnapshot(u,A,{ignore:o.excludes,backend:i.PARCEL_WATCHER_BACKEND}),x===1&&f.complete(),!m.token.isCancellationRequested&&X.schedule()}},U);X.schedule(0)}async startWatching(o,U=0){const _=new k.CancellationTokenSource,m=new V.DeferredPromise,f=new n(m.p,o,U,_.token,new V.RunOnceWorker(D=>this.handleParcelEvents(D,f),i.FILE_CHANGES_HANDLER_DELAY),async()=>{_.dispose(!0),f.worker.flush(),f.worker.dispose(),await(await m.p)?.unsubscribe()});this.watchers.add(f);const{realPath:A,realPathDiffers:R,realPathLength:u}=this.normalizePath(o);try{const D=await p.subscribe(A,(C,x)=>{f.token.isCancellationRequested||(C&&this.onUnexpectedError(C,o),this.onParcelEvents(x,f,R,u))},{backend:i.PARCEL_WATCHER_BACKEND,ignore:f.request.excludes});this.trace(`Started watching: '${A}' with backend '${i.PARCEL_WATCHER_BACKEND}'`),m.complete(D)}catch(D){this.onUnexpectedError(D,o),m.complete(void 0),f.notifyWatchFailed(),this._onDidWatchFail.fire(o)}}onParcelEvents(o,U,_,m){if(o.length===0)return;this.normalizeEvents(o,U.request,_,m);const f=this.handleIncludes(U,o);for(const A of f)U.worker.work(A)}handleIncludes(o,U){const _=[];for(const{path:m,type:f}of U){const A=i.MAP_PARCEL_WATCHER_ACTION_TO_FILE_CHANGE.get(f);this.verboseLogging&&this.traceWithCorrelation(`${A===v.FileChangeType.ADDED?"[ADDED]":A===v.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${m}`,o.request),o.include(m)?_.push({type:A,resource:W.URI.file(m),cId:o.request.correlationId}):this.verboseLogging&&this.traceWithCorrelation(` >> ignored (not included) ${m}`,o.request)}return _}handleParcelEvents(o,U){const _=(0,w.coalesceEvents)(o),{events:m,rootDeleted:f}=this.filterEvents(_,U);this.emitEvents(m,U),f&&this.onWatchedPathDeleted(U)}emitEvents(o,U){if(o.length===0)return;this.throttledFileChangesEmitter.work(o)?this.throttledFileChangesEmitter.pending>0&&this.trace(`started throttling events due to large amount of file change events at once (pending: ${this.throttledFileChangesEmitter.pending}, most recent change: ${o[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`,U):this.warn(`started ignoring events due to too many file change events at once (incoming: ${o.length}, most recent change: ${o[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}normalizePath(o){let U=o.path,_=!1,m=o.path.length;try{U=(0,b.realpathSync)(o.path),o.path===U&&(U=(0,b.realcaseSync)(o.path)??o.path),o.path!==U&&(m=U.length,_=!0,this.trace(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${o.path}, real: ${U})`))}catch{}return{realPath:U,realPathDiffers:_,realPathLength:m}}normalizeEvents(o,U,_,m){for(const f of o)d.isMacintosh&&(f.path=(0,a.normalizeNFC)(f.path)),d.isWindows&&U.path.length<=3&&(f.path=(0,r.normalize)(f.path)),_&&(f.path=U.path+f.path.substr(m))}filterEvents(o,U){const _=[];let m=!1;const f=this.isCorrelated(U.request)?U.request.filter:void 0;for(const A of o){if(U.subscriptionsCount>0&&U.notifyFileChange(A.resource.fsPath,A),m=A.type===v.FileChangeType.DELETED&&(0,N.isEqual)(A.resource.fsPath,U.request.path,!d.isLinux),(0,w.isFiltered)(A,f)||m&&!this.isCorrelated(U.request)){this.verboseLogging&&this.traceWithCorrelation(` >> ignored (filtered) ${A.resource.fsPath}`,U.request);continue}this.traceEvent(A,U.request),_.push(A)}return{events:_,rootDeleted:m}}onWatchedPathDeleted(o){this.warn("Watcher shutdown because watched path got deleted",o);let U=!1;this.isCorrelated(o.request)||(U=this.legacyMonitorRequest(o)),U||(o.notifyWatchFailed(),this._onDidWatchFail.fire(o.request))}legacyMonitorRequest(o){const U=(0,r.dirname)(o.request.path);if((0,t.existsSync)(U)){this.trace("Trying to watch on the parent path to restart the watcher...",o);const _=new c.NodeJSFileWatcherLibrary({path:U,excludes:[],recursive:!1,correlationId:o.request.correlationId},void 0,m=>{if(!o.token.isCancellationRequested){for(const{resource:f,type:A}of m)if((0,N.isEqual)(f.fsPath,o.request.path,!d.isLinux)&&(A===v.FileChangeType.ADDED||A===v.FileChangeType.UPDATED)&&this.isPathValid(o.request.path)){this.warn("Watcher restarts because watched path got created again",o),_.dispose(),this.restartWatching(o);break}}},void 0,m=>this._onDidLogMessage.fire(m),this.verboseLogging);return o.token.onCancellationRequested(()=>_.dispose()),!0}return!1}onUnexpectedError(o,U){const _=(0,T.toErrorMessage)(o);_.indexOf("No space left on device")!==-1?this.enospcErrorLogged||(this.error("Inotify limit reached (ENOSPC)",U),this.enospcErrorLogged=!0):(this.error(`Unexpected error: ${_} (EUNKNOWN)`,U),this._onDidError.fire({request:U,error:_}))}async stop(){await super.stop();for(const o of this.watchers)await this.stopWatching(o)}restartWatching(o,U=800){const _=new V.RunOnceScheduler(async()=>{if(o.token.isCancellationRequested)return;const m=new V.DeferredPromise;try{await this.stopWatching(o,m.p),o.request.pollingInterval?this.startPolling(o.request,o.request.pollingInterval,o.restarts+1):await this.startWatching(o.request,o.restarts+1)}finally{m.complete()}},U);_.schedule(),o.token.onCancellationRequested(()=>_.dispose())}async stopWatching(o,U){this.trace("stopping file watcher",o),this.watchers.delete(o);try{await o.stop(U)}catch(_){this.error(`Unexpected error stopping watcher: ${(0,T.toErrorMessage)(_)}`,o.request)}}removeDuplicateRequests(o,U=!0){o.sort((f,A)=>f.path.length-A.path.length);const _=new Map;for(const f of o){if(f.excludes.includes(E.GLOBSTAR))continue;const A=d.isLinux?f.path:f.path.toLowerCase();let R=_.get(f.correlationId);R||(R=new Map,_.set(f.correlationId,R)),R.has(A)&&this.trace(`ignoring a request for watching who's path is already watched: ${this.requestToString(f)}`),R.set(A,f)}const m=[];for(const f of _.values()){const A=M.TernarySearchTree.forPaths(!d.isLinux);for(const R of f.values()){if(A.findSubstr(R.path))try{if((0,b.realpathSync)(R.path)===R.path){this.trace(`ignoring a request for watching who's parent is already watched: ${this.requestToString(R)}`);continue}}catch(u){this.trace(`ignoring a request for watching who's realpath failed to resolve: ${this.requestToString(R)} (error: ${u})`),this._onDidWatchFail.fire(R);continue}if(U&&!this.isPathValid(R.path)){this._onDidWatchFail.fire(R);continue}A.set(R.path,R)}m.push(...Array.from(A).map(([,R])=>R))}return m}isPathValid(o){try{if(!(0,t.statSync)(o).isDirectory())return this.trace(`ignoring a path for watching that is a file and not a folder: ${o}`),!1}catch(U){return this.trace(`ignoring a path for watching who's stat info failed to resolve: ${o} (error: ${U})`),!1}return!0}subscribe(o,U){for(const _ of this.watchers){if(_.failed||!(0,N.isEqualOrParent)(o,_.request.path,!d.isLinux)||_.exclude(o)||!_.include(o))continue;const m=new l.DisposableStore;return m.add(P.Event.once(_.onDidStop)(async f=>{await f.joinRestart,!m.isDisposed&&U(!0)})),m.add(P.Event.once(_.onDidFail)(()=>U(!0))),m.add(_.subscribe(o,f=>U(null,f))),m}}trace(o,U){this.verboseLogging&&this._onDidLogMessage.fire({type:"trace",message:this.toMessage(o,U?.request)})}warn(o,U){this._onDidLogMessage.fire({type:"warn",message:this.toMessage(o,U?.request)})}error(o,U){this._onDidLogMessage.fire({type:"error",message:this.toMessage(o,U)})}toMessage(o,U){return U?`[File Watcher (parcel)] ${o} (path: ${U.path})`:`[File Watcher (parcel)] ${o}`}get recursiveWatcher(){return this}}e.ParcelWatcher=i}),define(Ee[59],pe([0,1,19]),function(ce,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeStats=t;function t(a,r,d){const b=[],c=T(a.filter(C=>C.recursive)),v=c.filter(C=>r.isSuspended(C)===!1),w=c.filter(C=>r.isSuspended(C)==="polling"),l=c.filter(C=>r.isSuspended(C)===!0),n=W(c,r),i=V(r),s=T(a.filter(C=>!C.recursive)),o=s.filter(C=>d.isSuspended(C)===!1),U=s.filter(C=>d.isSuspended(C)==="polling"),_=s.filter(C=>d.isSuspended(C)===!0),m=W(s,d),f=k(d);b.push("[Summary]"),b.push(`- Recursive Requests:     total: ${c.length}, suspended: ${n.suspended}, polling: ${n.polling}`),b.push(`- Non-Recursive Requests: total: ${s.length}, suspended: ${m.suspended}, polling: ${m.polling}`),b.push(`- Recursive Watchers:     total: ${r.watchers.size}, active: ${i.active}, failed: ${i.failed}, stopped: ${i.stopped}`),b.push(`- Non-Recursive Watchers: total: ${d.watchers.size}, active: ${f.active}, failed: ${f.failed}, reusing: ${f.reusing}`),b.push(`- I/O Handles Impact:     total: ${n.polling+m.polling+i.active+f.active}`),b.push(`
[Recursive Requests (${c.length}, suspended: ${n.suspended}, polling: ${n.polling})]:`);const A=[];for(const C of[v,w,l].flat())N(A,C,r);b.push(...$(A));const R=[];y(R,r),b.push(...$(R)),b.push(`
[Non-Recursive Requests (${s.length}, suspended: ${m.suspended}, polling: ${m.polling})]:`);const u=[];for(const C of[o,U,_].flat())N(u,C,d);b.push(...$(u));const D=[];return M(D,d),b.push(...$(D)),`

[File Watcher] request stats:

${b.join(`
`)}

`}function $(a){let r=0;for(const d of a)r=Math.max(r,d.split("	")[0].length);for(let d=0;d<a.length;d++){const c=a[d].split("	");if(c.length===2){const v=" ".repeat(r-c[0].length);a[d]=`${c[0]}${v}	${c[1]}`}}return a}function W(a,r){let d=0,b=0;for(const c of a){const v=r.isSuspended(c);v!==!1&&(b++,v==="polling"&&d++)}return{suspended:b,polling:d}}function V(a){let r=0,d=0,b=0;for(const c of a.watchers.values())!c.failed&&!c.stopped&&r++,c.failed&&d++,c.stopped&&b++;return{active:r,failed:d,stopped:b}}function k(a){let r=0,d=0,b=0;for(const c of a.watchers)!c.instance.failed&&!c.instance.isReusingRecursiveWatcher&&r++,c.instance.failed&&d++,c.instance.isReusingRecursiveWatcher&&b++;return{active:r,failed:d,reusing:b}}function T(a){return a.sort((r,d)=>{const b=P(r)?r.path:r.request.path,c=P(d)?d.path:d.request.path,v=Math.min(b.length,c.length);for(let w=0;w<v;w++)if(b[w]!==c[w])return b[w]<c[w]?-1:1;return b.length-c.length}),a}function P(a){return typeof a?.path=="string"}function N(a,r,d){const b=[],c=d.isSuspended(r);c!==!1&&(c==="polling"?b.push("[SUSPENDED <polling>]"):b.push("[SUSPENDED <non-polling>]")),a.push(` ${r.path}	${b.length>0?b.join(" ")+" ":""}(${E(r)})`)}function E(a){return`excludes: ${a.excludes.length>0?a.excludes:"<none>"}, includes: ${a.includes&&a.includes.length>0?JSON.stringify(a.includes):"<all>"}, filter: ${(0,p.requestFilterToString)(a.filter)}, correlationId: ${typeof a.correlationId=="number"?a.correlationId:"<none>"}`}function y(a,r){const d=T(Array.from(r.watchers.values())),{active:b,failed:c,stopped:v}=V(r);a.push(`
[Recursive Watchers (${d.length}, active: ${b}, failed: ${c}, stopped: ${v})]:`);for(const w of d){const l=[];w.failed&&l.push("[FAILED]"),w.stopped&&l.push("[STOPPED]"),w.subscriptionsCount>0&&l.push(`[SUBSCRIBED:${w.subscriptionsCount}]`),w.restarts>0&&l.push(`[RESTARTED:${w.restarts}]`),a.push(` ${w.request.path}	${l.length>0?l.join(" ")+" ":""}(${E(w.request)})`)}}function M(a,r){const d=T(Array.from(r.watchers.values())),b=d.filter(i=>!i.instance.failed&&!i.instance.isReusingRecursiveWatcher),c=d.filter(i=>i.instance.failed),v=d.filter(i=>i.instance.isReusingRecursiveWatcher),{active:w,failed:l,reusing:n}=k(r);a.push(`
[Non-Recursive Watchers (${d.length}, active: ${w}, failed: ${l}, reusing: ${n})]:`);for(const i of[b,c,v].flat()){const s=[];i.instance.failed&&s.push("[FAILED]"),i.instance.isReusingRecursiveWatcher&&s.push("[REUSING]"),a.push(` ${i.request.path}	${s.length>0?s.join(" ")+" ":""}(${E(i.request)})`)}}}),define(Ee[60],pe([0,1,4,6,58,57,8,59]),function(ce,e,p,t,$,W,V,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcher=void 0;class T extends p.Disposable{constructor(){super(...arguments),this.recursiveWatcher=this._register(new $.ParcelWatcher),this.nonRecursiveWatcher=this._register(new W.NodeJSWatcher(this.recursiveWatcher)),this.onDidChangeFile=t.Event.any(this.recursiveWatcher.onDidChangeFile,this.nonRecursiveWatcher.onDidChangeFile),this.onDidError=t.Event.any(this.recursiveWatcher.onDidError,this.nonRecursiveWatcher.onDidError),this._onDidLogMessage=this._register(new t.Emitter),this.onDidLogMessage=t.Event.any(this._onDidLogMessage.event,this.recursiveWatcher.onDidLogMessage,this.nonRecursiveWatcher.onDidLogMessage),this.requests=[]}async watch(N){this.requests=N;let E;try{await this.recursiveWatcher.watch(N.filter(y=>y.recursive))}catch(y){E=y}try{await this.nonRecursiveWatcher.watch(N.filter(y=>!y.recursive))}catch(y){E||(E=y)}if(E)throw E}async setVerboseLogging(N){N&&this.requests.length>0&&this._onDidLogMessage.fire({type:"trace",message:(0,k.computeStats)(this.requests,this.recursiveWatcher,this.nonRecursiveWatcher)}),await V.Promises.settled([this.recursiveWatcher.setVerboseLogging(N),this.nonRecursiveWatcher.setVerboseLogging(N)])}async stop(){await V.Promises.settled([this.recursiveWatcher.stop(),this.nonRecursiveWatcher.stop()])}}e.UniversalWatcher=T}),define(Ee[64],pe([0,1,4,26,54,55,30,60]),function(ce,e,p,t,$,W,V,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let T;(0,V.isUtilityProcess)(process)?T=new W.Server:T=new $.Server("watcher");const P=new k.UniversalWatcher;T.registerChannel("watcher",t.ProxyChannel.fromService(P,new p.DisposableStore))})}).call(this);

//# sourceMappingURL=https://main.vscode-cdn.net/sourcemaps/532bdf24071d0a26ceea0844dcdf5ee8cfabd562/core/vs/platform/files/node/watcher/watcherMain.js.map
