/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var V=["require","exports","vs/platform/instantiation/common/instantiation","vs/base/common/errors","vs/nls","vs/base/common/arrays","vs/base/common/charCode","vs/base/browser/trustedTypes","vs/base/common/ternarySearchTree","vs/base/common/strings","vs/base/common/errorMessage","vs/base/common/types","vs/base/browser/defaultWorkerFactory","vs/base/common/lifecycle","vs/platform/contextkey/common/scanner","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/extensions","vs/platform/contextkey/common/contextkey","vs/base/common/platform","vs/platform/log/common/log","vs/base/common/uri","vs/platform/profiling/common/profiling","vs/base/common/path","vs/platform/profiling/common/profilingModel","vs/platform/profiling/common/profilingTelemetrySpec","vs/platform/telemetry/common/telemetry","vs/platform/profiling/electron-sandbox/profileAnalysisWorkerService","vs/base/common/network","vs/base/common/worker/simpleWorker","vs/base/common/event","vs/base/common/hash","vs/base/common/map","vs/base/common/resources","vs/platform/profiling/electron-sandbox/profileAnalysisWorker"],B=function(D){for(var t=[],c=0,I=D.length;c<I;c++)t[c]=V[D[c]];return t};define(V[7],B([0,1,3]),function(D,t,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.createTrustedTypesPolicy=I;function I(S,n){const T=globalThis.MonacoEnvironment;if(T?.createTrustedTypesPolicy)try{return T.createTrustedTypesPolicy(S,n)}catch(y){(0,c.onUnexpectedError)(y);return}try{return globalThis.trustedTypes?.createPolicy(S,n)}catch(y){(0,c.onUnexpectedError)(y);return}}}),define(V[8],B([0,1,5,6,9]),function(D,t,c,I,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.TernarySearchTree=t.UriIterator=t.PathIterator=t.ConfigKeysIterator=t.StringIterator=void 0;class n{constructor(){this._value="",this._pos=0}reset(a){return this._value=a,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(a){const p=a.charCodeAt(0),s=this._value.charCodeAt(this._pos);return p-s}value(){return this._value[this._pos]}}t.StringIterator=n;class T{constructor(a=!0){this._caseSensitive=a}reset(a){return this._value=a,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let a=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===I.CharCode.Period)if(a)this._from++;else break;else a=!1;return this}cmp(a){return this._caseSensitive?(0,S.compareSubstring)(a,this._value,0,a.length,this._from,this._to):(0,S.compareSubstringIgnoreCase)(a,this._value,0,a.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}t.ConfigKeysIterator=T;class y{constructor(a=!0,p=!0){this._splitOnBackslash=a,this._caseSensitive=p}reset(a){this._from=0,this._to=0,this._value=a,this._valueLen=a.length;for(let p=a.length-1;p>=0;p--,this._valueLen--){const s=this._value.charCodeAt(p);if(!(s===I.CharCode.Slash||this._splitOnBackslash&&s===I.CharCode.Backslash))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let a=!0;for(;this._to<this._valueLen;this._to++){const p=this._value.charCodeAt(this._to);if(p===I.CharCode.Slash||this._splitOnBackslash&&p===I.CharCode.Backslash)if(a)this._from++;else break;else a=!1}return this}cmp(a){return this._caseSensitive?(0,S.compareSubstring)(a,this._value,0,a.length,this._from,this._to):(0,S.compareSubstringIgnoreCase)(a,this._value,0,a.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}t.PathIterator=y;var E;(function(b){b[b.Scheme=1]="Scheme",b[b.Authority=2]="Authority",b[b.Path=3]="Path",b[b.Query=4]="Query",b[b.Fragment=5]="Fragment"})(E||(E={}));class _{constructor(a,p){this._ignorePathCasing=a,this._ignoreQueryAndFragment=p,this._states=[],this._stateIdx=0}reset(a){return this._value=a,this._states=[],this._value.scheme&&this._states.push(E.Scheme),this._value.authority&&this._states.push(E.Authority),this._value.path&&(this._pathIterator=new y(!1,!this._ignorePathCasing(a)),this._pathIterator.reset(a.path),this._pathIterator.value()&&this._states.push(E.Path)),this._ignoreQueryAndFragment(a)||(this._value.query&&this._states.push(E.Query),this._value.fragment&&this._states.push(E.Fragment)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===E.Path&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===E.Path&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(a){if(this._states[this._stateIdx]===E.Scheme)return(0,S.compareIgnoreCase)(a,this._value.scheme);if(this._states[this._stateIdx]===E.Authority)return(0,S.compareIgnoreCase)(a,this._value.authority);if(this._states[this._stateIdx]===E.Path)return this._pathIterator.cmp(a);if(this._states[this._stateIdx]===E.Query)return(0,S.compare)(a,this._value.query);if(this._states[this._stateIdx]===E.Fragment)return(0,S.compare)(a,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===E.Scheme)return this._value.scheme;if(this._states[this._stateIdx]===E.Authority)return this._value.authority;if(this._states[this._stateIdx]===E.Path)return this._pathIterator.value();if(this._states[this._stateIdx]===E.Query)return this._value.query;if(this._states[this._stateIdx]===E.Fragment)return this._value.fragment;throw new Error}}t.UriIterator=_;class f{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const a=this.right;return this.right=a.left,a.left=this,this.updateHeight(),a.updateHeight(),a}rotateRight(){const a=this.left;return this.left=a.right,a.right=this,this.updateHeight(),a.updateHeight(),a}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var o;(function(b){b[b.Left=-1]="Left",b[b.Mid=0]="Mid",b[b.Right=1]="Right"})(o||(o={}));class m{static forUris(a=()=>!1,p=()=>!1){return new m(new _(a,p))}static forPaths(a=!1){return new m(new y(void 0,!a))}static forStrings(){return new m(new n)}static forConfigKeys(){return new m(new T)}constructor(a){this._iter=a}clear(){this._root=void 0}fill(a,p){if(p){const s=p.slice(0);(0,c.shuffle)(s);for(const u of s)this.set(u,a)}else{const s=a.slice(0);(0,c.shuffle)(s);for(const u of s)this.set(u[0],u[1])}}set(a,p){const s=this._iter.reset(a);let u;this._root||(this._root=new f,this._root.segment=s.value());const d=[];for(u=this._root;;){const v=s.cmp(u.segment);if(v>0)u.left||(u.left=new f,u.left.segment=s.value()),d.push([o.Left,u]),u=u.left;else if(v<0)u.right||(u.right=new f,u.right.segment=s.value()),d.push([o.Right,u]),u=u.right;else if(s.hasNext())s.next(),u.mid||(u.mid=new f,u.mid.segment=s.value()),d.push([o.Mid,u]),u=u.mid;else break}const C=u.value;u.value=p,u.key=a;for(let v=d.length-1;v>=0;v--){const L=d[v][1];L.updateHeight();const R=L.balanceFactor();if(R<-1||R>1){const N=d[v][0],x=d[v+1][0];if(N===o.Right&&x===o.Right)d[v][1]=L.rotateLeft();else if(N===o.Left&&x===o.Left)d[v][1]=L.rotateRight();else if(N===o.Right&&x===o.Left)L.right=d[v+1][1]=d[v+1][1].rotateRight(),d[v][1]=L.rotateLeft();else if(N===o.Left&&x===o.Right)L.left=d[v+1][1]=d[v+1][1].rotateLeft(),d[v][1]=L.rotateRight();else throw new Error;if(v>0)switch(d[v-1][0]){case o.Left:d[v-1][1].left=d[v][1];break;case o.Right:d[v-1][1].right=d[v][1];break;case o.Mid:d[v-1][1].mid=d[v][1];break}else this._root=d[0][1]}}return C}get(a){return this._getNode(a)?.value}_getNode(a){const p=this._iter.reset(a);let s=this._root;for(;s;){const u=p.cmp(s.segment);if(u>0)s=s.left;else if(u<0)s=s.right;else if(p.hasNext())p.next(),s=s.mid;else break}return s}has(a){const p=this._getNode(a);return!(p?.value===void 0&&p?.mid===void 0)}delete(a){return this._delete(a,!1)}deleteSuperstr(a){return this._delete(a,!0)}_delete(a,p){const s=this._iter.reset(a),u=[];let d=this._root;for(;d;){const C=s.cmp(d.segment);if(C>0)u.push([o.Left,d]),d=d.left;else if(C<0)u.push([o.Right,d]),d=d.right;else if(s.hasNext())s.next(),u.push([o.Mid,d]),d=d.mid;else break}if(d){if(p?(d.left=void 0,d.mid=void 0,d.right=void 0,d.height=1):(d.key=void 0,d.value=void 0),!d.mid&&!d.value)if(d.left&&d.right){const C=this._min(d.right);if(C.key){const{key:v,value:L,segment:R}=C;this._delete(C.key,!1),d.key=v,d.value=L,d.segment=R}}else{const C=d.left??d.right;if(u.length>0){const[v,L]=u[u.length-1];switch(v){case o.Left:L.left=C;break;case o.Mid:L.mid=C;break;case o.Right:L.right=C;break}}else this._root=C}for(let C=u.length-1;C>=0;C--){const v=u[C][1];v.updateHeight();const L=v.balanceFactor();if(L>1?(v.right.balanceFactor()>=0||(v.right=v.right.rotateRight()),u[C][1]=v.rotateLeft()):L<-1&&(v.left.balanceFactor()<=0||(v.left=v.left.rotateLeft()),u[C][1]=v.rotateRight()),C>0)switch(u[C-1][0]){case o.Left:u[C-1][1].left=u[C][1];break;case o.Right:u[C-1][1].right=u[C][1];break;case o.Mid:u[C-1][1].mid=u[C][1];break}else this._root=u[0][1]}}}_min(a){for(;a.left;)a=a.left;return a}findSubstr(a){const p=this._iter.reset(a);let s=this._root,u;for(;s;){const d=p.cmp(s.segment);if(d>0)s=s.left;else if(d<0)s=s.right;else if(p.hasNext())p.next(),u=s.value||u,s=s.mid;else break}return s&&s.value||u}findSuperstr(a){return this._findSuperstrOrElement(a,!1)}_findSuperstrOrElement(a,p){const s=this._iter.reset(a);let u=this._root;for(;u;){const d=s.cmp(u.segment);if(d>0)u=u.left;else if(d<0)u=u.right;else if(s.hasNext())s.next(),u=u.mid;else return u.mid?this._entries(u.mid):p?u.value:void 0}}hasElementOrSubtree(a){return this._findSuperstrOrElement(a,!0)!==void 0}forEach(a){for(const[p,s]of this)a(s,p)}*[Symbol.iterator](){yield*this._entries(this._root)}_entries(a){const p=[];return this._dfsEntries(a,p),p[Symbol.iterator]()}_dfsEntries(a,p){a&&(a.left&&this._dfsEntries(a.left,p),a.value&&p.push([a.key,a.value]),a.mid&&this._dfsEntries(a.mid,p),a.right&&this._dfsEntries(a.right,p))}_isBalanced(){const a=p=>{if(!p)return!0;const s=p.balanceFactor();return s<-1||s>1?!1:a(p.left)&&a(p.right)};return a(this._root)}}t.TernarySearchTree=m});var de=this&&this.__createBinding||(Object.create?function(D,t,c,I){I===void 0&&(I=c);var S=Object.getOwnPropertyDescriptor(t,c);(!S||("get"in S?!t.__esModule:S.writable||S.configurable))&&(S={enumerable:!0,get:function(){return t[c]}}),Object.defineProperty(D,I,S)}:function(D,t,c,I){I===void 0&&(I=c),D[I]=t[c]}),me=this&&this.__setModuleDefault||(Object.create?function(D,t){Object.defineProperty(D,"default",{enumerable:!0,value:t})}:function(D,t){D.default=t}),ae=this&&this.__importStar||function(D){if(D&&D.__esModule)return D;var t={};if(D!=null)for(var c in D)c!=="default"&&Object.prototype.hasOwnProperty.call(D,c)&&de(t,D,c);return me(t,D),t};define(V[10],B([0,1,5,11,4]),function(D,t,c,I,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.toErrorMessage=E,t.isErrorWithActions=_,t.createErrorWithActions=f,c=ae(c),I=ae(I),S=ae(S);function n(o,m){return m&&(o.stack||o.stacktrace)?S.localize(107,null,y(o),T(o.stack)||T(o.stacktrace)):y(o)}function T(o){return Array.isArray(o)?o.join(`
`):o}function y(o){return o.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${o.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof o.code=="string"&&typeof o.errno=="number"&&typeof o.syscall=="string"?S.localize(108,null,o.message):o.message||S.localize(109,null)}function E(o=null,m=!1){if(!o)return S.localize(110,null);if(Array.isArray(o)){const b=c.coalesce(o),a=E(b[0],m);return b.length>1?S.localize(111,null,a,b.length):a}if(I.isString(o))return o;if(o.detail){const b=o.detail;if(b.error)return n(b.error,m);if(b.exception)return n(b.exception,m)}return o.stack?n(o,m):o.message?o.message:S.localize(112,null)}function _(o){const m=o;return m instanceof Error&&Array.isArray(m.actions)}function f(o,m){let b;return typeof o=="string"?b=new Error(o):b=o,b.actions=m,b}}),define(V[12],B([0,1,7,3,27,28,13,5,4]),function(D,t,c,I,S,n,T,y,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.WorkerDescriptor=void 0,t.createBlobWorker=o,t.createWebWorker=C;const _=!1;let f;typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope"&&globalThis.workerttPolicy!==void 0?f=globalThis.workerttPolicy:f=(0,c.createTrustedTypesPolicy)("defaultWorkerFactory",{createScriptURL:v=>v});function o(v,L){if(!v.startsWith("blob:"))throw new URIError("Not a blob-url: "+v);return new Worker(f?f.createScriptURL(v):v,{...L,type:_?"module":void 0})}function m(v,L){const R=globalThis.MonacoEnvironment;if(R){if(typeof R.getWorker=="function")return R.getWorker("workerMain.js",L);if(typeof R.getWorkerUrl=="function"){const N=R.getWorkerUrl("workerMain.js",L);return new Worker(f?f.createScriptURL(N):N,{name:L,type:_?"module":void 0})}}if(typeof D=="function"){const N=D.toUrl("vs/base/worker/workerMain.js"),x="vs/base/worker/defaultWorkerFactory.js",$=D.toUrl(x).slice(0,-x.length),M=b(L,N,$);return new Worker(f?f.createScriptURL(M):M,{name:L,type:_?"module":void 0})}if(v){const N=b(L,v.toString(!0)),x=new Worker(f?f.createScriptURL(N):N,{name:L,type:_?"module":void 0});return _?a(x):x}throw new Error("You must define a function MonacoEnvironment.getWorkerUrl or MonacoEnvironment.getWorker")}function b(v,L,R){if(!(/^((http:)|(https:)|(file:))/.test(L)&&L.substring(0,globalThis.origin.length)!==globalThis.origin)){const x=L.lastIndexOf("?"),$=L.lastIndexOf("#",x),M=x>0?new URLSearchParams(L.substring(x+1,~$?$:void 0)):new URLSearchParams;S.COI.addSearchParam(M,!0,!0),M.toString()?L=`${L}?${M.toString()}#${v}`:L=`${L}#${v}`}const N=new Blob([(0,y.coalesce)([`/*${v}*/`,R?`globalThis.MonacoEnvironment = { baseUrl: '${R}' };`:void 0,`globalThis._VSCODE_NLS_MESSAGES = ${JSON.stringify((0,E.getNLSMessages)())};`,`globalThis._VSCODE_NLS_LANGUAGE = ${JSON.stringify((0,E.getNLSLanguage)())};`,`globalThis._VSCODE_FILE_ROOT = '${globalThis._VSCODE_FILE_ROOT}';`,"const ttPolicy = globalThis.trustedTypes?.createPolicy('defaultWorkerFactory', { createScriptURL: value => value });","globalThis.workerttPolicy = ttPolicy;",_?`await import(ttPolicy?.createScriptURL('${L}') ?? '${L}');`:`importScripts(ttPolicy?.createScriptURL('${L}') ?? '${L}');`,_?"globalThis.postMessage({ type: 'vscode-worker-ready' });":void 0,`/*${v}*/`]).join("")],{type:"application/javascript"});return URL.createObjectURL(N)}function a(v){return new Promise((L,R)=>{v.onmessage=function(N){N.data.type==="vscode-worker-ready"&&(v.onmessage=null,L(v))},v.onerror=R})}function p(v){return typeof v.then=="function"}class s extends T.Disposable{constructor(L,R,N,x,$,M){super(),this.id=N,this.label=x;const W=m(L,x);p(W)?this.worker=W:this.worker=Promise.resolve(W),this.postMessage(R,[]),this.worker.then(q=>{q.onmessage=function(U){$(U.data)},q.onmessageerror=M,typeof q.addEventListener=="function"&&q.addEventListener("error",M)}),this._register((0,T.toDisposable)(()=>{this.worker?.then(q=>{q.onmessage=null,q.onmessageerror=null,q.removeEventListener("error",M),q.terminate()}),this.worker=null}))}getId(){return this.id}postMessage(L,R){this.worker?.then(N=>{try{N.postMessage(L,R)}catch(x){(0,I.onUnexpectedError)(x),(0,I.onUnexpectedError)(new Error(`FAILED to post message to '${this.label}'-worker`,{cause:x}))}})}}class u{constructor(L,R){this.amdModuleId=L,this.label=R,this.esmModuleLocation=_?S.FileAccess.asBrowserUri(`${L}.esm.js`):void 0}}t.WorkerDescriptor=u;class d{static{this.LAST_WORKER_ID=0}constructor(){this._webWorkerFailedBeforeError=!1}create(L,R,N){const x=++d.LAST_WORKER_ID;if(this._webWorkerFailedBeforeError)throw this._webWorkerFailedBeforeError;return new s(L.esmModuleLocation,L.amdModuleId,x,L.label||"anonymous"+x,R,$=>{(0,n.logOnceWebWorkerWarning)($),this._webWorkerFailedBeforeError=$,N($)})}}function C(v,L){const R=typeof v=="string"?new u(v,L):v;return new n.SimpleWorkerClient(new d,R)}}),define(V[14],B([0,1,6,3,4]),function(D,t,c,I,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Scanner=t.TokenType=void 0;var n;(function(f){f[f.LParen=0]="LParen",f[f.RParen=1]="RParen",f[f.Neg=2]="Neg",f[f.Eq=3]="Eq",f[f.NotEq=4]="NotEq",f[f.Lt=5]="Lt",f[f.LtEq=6]="LtEq",f[f.Gt=7]="Gt",f[f.GtEq=8]="GtEq",f[f.RegexOp=9]="RegexOp",f[f.RegexStr=10]="RegexStr",f[f.True=11]="True",f[f.False=12]="False",f[f.In=13]="In",f[f.Not=14]="Not",f[f.And=15]="And",f[f.Or=16]="Or",f[f.Str=17]="Str",f[f.QuotedStr=18]="QuotedStr",f[f.Error=19]="Error",f[f.EOF=20]="EOF"})(n||(t.TokenType=n={}));function T(...f){switch(f.length){case 1:return(0,S.localize)(1693,null,f[0]);case 2:return(0,S.localize)(1694,null,f[0],f[1]);case 3:return(0,S.localize)(1695,null,f[0],f[1],f[2]);default:return}}const y=(0,S.localize)(1696,null),E=(0,S.localize)(1697,null);class _{constructor(){this._input="",this._start=0,this._current=0,this._tokens=[],this._errors=[],this.stringRe=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(o){switch(o.type){case n.LParen:return"(";case n.RParen:return")";case n.Neg:return"!";case n.Eq:return o.isTripleEq?"===":"==";case n.NotEq:return o.isTripleEq?"!==":"!=";case n.Lt:return"<";case n.LtEq:return"<=";case n.Gt:return">=";case n.GtEq:return">=";case n.RegexOp:return"=~";case n.RegexStr:return o.lexeme;case n.True:return"true";case n.False:return"false";case n.In:return"in";case n.Not:return"not";case n.And:return"&&";case n.Or:return"||";case n.Str:return o.lexeme;case n.QuotedStr:return o.lexeme;case n.Error:return o.lexeme;case n.EOF:return"EOF";default:throw(0,I.illegalState)(`unhandled token type: ${JSON.stringify(o)}; have you forgotten to add a case?`)}}static{this._regexFlags=new Set(["i","g","s","m","y","u"].map(o=>o.charCodeAt(0)))}static{this._keywords=new Map([["not",n.Not],["in",n.In],["false",n.False],["true",n.True]])}get errors(){return this._errors}reset(o){return this._input=o,this._start=0,this._current=0,this._tokens=[],this._errors=[],this}scan(){for(;!this._isAtEnd();)switch(this._start=this._current,this._advance()){case c.CharCode.OpenParen:this._addToken(n.LParen);break;case c.CharCode.CloseParen:this._addToken(n.RParen);break;case c.CharCode.ExclamationMark:if(this._match(c.CharCode.Equals)){const m=this._match(c.CharCode.Equals);this._tokens.push({type:n.NotEq,offset:this._start,isTripleEq:m})}else this._addToken(n.Neg);break;case c.CharCode.SingleQuote:this._quotedString();break;case c.CharCode.Slash:this._regex();break;case c.CharCode.Equals:if(this._match(c.CharCode.Equals)){const m=this._match(c.CharCode.Equals);this._tokens.push({type:n.Eq,offset:this._start,isTripleEq:m})}else this._match(c.CharCode.Tilde)?this._addToken(n.RegexOp):this._error(T("==","=~"));break;case c.CharCode.LessThan:this._addToken(this._match(c.CharCode.Equals)?n.LtEq:n.Lt);break;case c.CharCode.GreaterThan:this._addToken(this._match(c.CharCode.Equals)?n.GtEq:n.Gt);break;case c.CharCode.Ampersand:this._match(c.CharCode.Ampersand)?this._addToken(n.And):this._error(T("&&"));break;case c.CharCode.Pipe:this._match(c.CharCode.Pipe)?this._addToken(n.Or):this._error(T("||"));break;case c.CharCode.Space:case c.CharCode.CarriageReturn:case c.CharCode.Tab:case c.CharCode.LineFeed:case c.CharCode.NoBreakSpace:break;default:this._string()}return this._start=this._current,this._addToken(n.EOF),Array.from(this._tokens)}_match(o){return this._isAtEnd()||this._input.charCodeAt(this._current)!==o?!1:(this._current++,!0)}_advance(){return this._input.charCodeAt(this._current++)}_peek(){return this._isAtEnd()?c.CharCode.Null:this._input.charCodeAt(this._current)}_addToken(o){this._tokens.push({type:o,offset:this._start})}_error(o){const m=this._start,b=this._input.substring(this._start,this._current),a={type:n.Error,offset:this._start,lexeme:b};this._errors.push({offset:m,lexeme:b,additionalInfo:o}),this._tokens.push(a)}_string(){this.stringRe.lastIndex=this._start;const o=this.stringRe.exec(this._input);if(o){this._current=this._start+o[0].length;const m=this._input.substring(this._start,this._current),b=_._keywords.get(m);b?this._addToken(b):this._tokens.push({type:n.Str,lexeme:m,offset:this._start})}}_quotedString(){for(;this._peek()!==c.CharCode.SingleQuote&&!this._isAtEnd();)this._advance();if(this._isAtEnd()){this._error(y);return}this._advance(),this._tokens.push({type:n.QuotedStr,lexeme:this._input.substring(this._start+1,this._current-1),offset:this._start+1})}_regex(){let o=this._current,m=!1,b=!1;for(;;){if(o>=this._input.length){this._current=o,this._error(E);return}const p=this._input.charCodeAt(o);if(m)m=!1;else if(p===c.CharCode.Slash&&!b){o++;break}else p===c.CharCode.OpenSquareBracket?b=!0:p===c.CharCode.Backslash?m=!0:p===c.CharCode.CloseSquareBracket&&(b=!1);o++}for(;o<this._input.length&&_._regexFlags.has(this._input.charCodeAt(o));)o++;this._current=o;const a=this._input.substring(this._start,this._current);this._tokens.push({type:n.RegexStr,lexeme:a,offset:this._start})}_isAtEnd(){return this._current>=this._input.length}}t.Scanner=_}),define(V[15],B([0,1]),function(D,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SyncDescriptor=void 0;class c{constructor(S,n=[],T=!1){this.ctor=S,this.staticArguments=n,this.supportsDelayedInstantiation=T}}t.SyncDescriptor=c}),define(V[16],B([0,1,15]),function(D,t,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.InstantiationType=void 0,t.registerSingleton=n,t.getSingletonServiceDescriptors=T;const I=[];var S;(function(y){y[y.Eager=0]="Eager",y[y.Delayed=1]="Delayed"})(S||(t.InstantiationType=S={}));function n(y,E,_){E instanceof c.SyncDescriptor||(E=new c.SyncDescriptor(E,[],!!_)),I.push([y,E])}function T(){return I}}),define(V[2],B([0,1]),function(D,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IInstantiationService=t._util=void 0,t.createDecorator=S,t.refineServiceDecorator=n;var c;(function(T){T.serviceIds=new Map,T.DI_TARGET="$di$target",T.DI_DEPENDENCIES="$di$dependencies";function y(E){return E[T.DI_DEPENDENCIES]||[]}T.getServiceDependencies=y})(c||(t._util=c={})),t.IInstantiationService=S("instantiationService");function I(T,y,E){y[c.DI_TARGET]===y?y[c.DI_DEPENDENCIES].push({id:T,index:E}):(y[c.DI_DEPENDENCIES]=[{id:T,index:E}],y[c.DI_TARGET]=y)}function S(T){if(c.serviceIds.has(T))return c.serviceIds.get(T);const y=function(E,_,f){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");I(y,E,f)};return y.toString=()=>T,c.serviceIds.set(T,y),y}function n(T){return T}}),define(V[17],B([0,1,6,18,9,14,2,4,3]),function(D,t,c,I,S,n,T,y,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IContextKeyService=t.RawContextKey=t.ContextKeyOrExpr=t.ContextKeyAndExpr=t.ContextKeyNotRegexExpr=t.ContextKeyRegexExpr=t.ContextKeySmallerEqualsExpr=t.ContextKeySmallerExpr=t.ContextKeyGreaterEqualsExpr=t.ContextKeyGreaterExpr=t.ContextKeyNotExpr=t.ContextKeyNotEqualsExpr=t.ContextKeyNotInExpr=t.ContextKeyInExpr=t.ContextKeyEqualsExpr=t.ContextKeyDefinedExpr=t.ContextKeyTrueExpr=t.ContextKeyFalseExpr=t.ContextKeyExpr=t.Parser=t.ContextKeyExprType=void 0,t.setConstant=f,t.validateWhenClauses=x,t.expressionsAreEqualWithConstantSubstitution=$,t.implies=oe;const _=new Map;_.set("false",!1),_.set("true",!0),_.set("isMac",I.isMacintosh),_.set("isLinux",I.isLinux),_.set("isWindows",I.isWindows),_.set("isWeb",I.isWeb),_.set("isMacNative",I.isMacintosh&&!I.isWeb),_.set("isEdge",I.isEdge),_.set("isFirefox",I.isFirefox),_.set("isChrome",I.isChrome),_.set("isSafari",I.isSafari);function f(k,e){if(_.get(k)!==void 0)throw(0,E.illegalArgument)("contextkey.setConstant(k, v) invoked with already set constant `k`");_.set(k,e)}const o=Object.prototype.hasOwnProperty;var m;(function(k){k[k.False=0]="False",k[k.True=1]="True",k[k.Defined=2]="Defined",k[k.Not=3]="Not",k[k.Equals=4]="Equals",k[k.NotEquals=5]="NotEquals",k[k.And=6]="And",k[k.Regex=7]="Regex",k[k.NotRegex=8]="NotRegex",k[k.Or=9]="Or",k[k.In=10]="In",k[k.NotIn=11]="NotIn",k[k.Greater=12]="Greater",k[k.GreaterEquals=13]="GreaterEquals",k[k.Smaller=14]="Smaller",k[k.SmallerEquals=15]="SmallerEquals"})(m||(t.ContextKeyExprType=m={}));const b={regexParsingWithErrorRecovery:!0},a=(0,y.localize)(1673,null),p=(0,y.localize)(1674,null),s=(0,y.localize)(1675,null),u=(0,y.localize)(1676,null),d=(0,y.localize)(1677,null),C=(0,y.localize)(1678,null),v=(0,y.localize)(1679,null),L=(0,y.localize)(1680,null);class R{static{this._parseError=new Error}get lexingErrors(){return this._scanner.errors}get parsingErrors(){return this._parsingErrors}constructor(e=b){this._config=e,this._scanner=new n.Scanner,this._tokens=[],this._current=0,this._parsingErrors=[],this._flagsGYRe=/g|y/g}parse(e){if(e===""){this._parsingErrors.push({message:a,offset:0,lexeme:"",additionalInfo:p});return}this._tokens=this._scanner.reset(e).scan(),this._current=0,this._parsingErrors=[];try{const r=this._expr();if(!this._isAtEnd()){const g=this._peek(),h=g.type===n.TokenType.Str?C:void 0;throw this._parsingErrors.push({message:d,offset:g.offset,lexeme:n.Scanner.getLexeme(g),additionalInfo:h}),R._parseError}return r}catch(r){if(r!==R._parseError)throw r;return}}_expr(){return this._or()}_or(){const e=[this._and()];for(;this._matchOne(n.TokenType.Or);){const r=this._and();e.push(r)}return e.length===1?e[0]:N.or(...e)}_and(){const e=[this._term()];for(;this._matchOne(n.TokenType.And);){const r=this._term();e.push(r)}return e.length===1?e[0]:N.and(...e)}_term(){if(this._matchOne(n.TokenType.Neg)){const e=this._peek();switch(e.type){case n.TokenType.True:return this._advance(),W.INSTANCE;case n.TokenType.False:return this._advance(),q.INSTANCE;case n.TokenType.LParen:{this._advance();const r=this._expr();return this._consume(n.TokenType.RParen,u),r?.negate()}case n.TokenType.Str:return this._advance(),l.create(e.lexeme);default:throw this._errExpectedButGot("KEY | true | false | '(' expression ')'",e)}}return this._primary()}_primary(){const e=this._peek();switch(e.type){case n.TokenType.True:return this._advance(),N.true();case n.TokenType.False:return this._advance(),N.false();case n.TokenType.LParen:{this._advance();const r=this._expr();return this._consume(n.TokenType.RParen,u),r}case n.TokenType.Str:{const r=e.lexeme;if(this._advance(),this._matchOne(n.TokenType.RegexOp)){const h=this._peek();if(!this._config.regexParsingWithErrorRecovery){if(this._advance(),h.type!==n.TokenType.RegexStr)throw this._errExpectedButGot("REGEX",h);const P=h.lexeme,w=P.lastIndexOf("/"),G=w===P.length-1?void 0:this._removeFlagsGY(P.substring(w+1));let z;try{z=new RegExp(P.substring(1,w),G)}catch{throw this._errExpectedButGot("REGEX",h)}return re.create(r,z)}switch(h.type){case n.TokenType.RegexStr:case n.TokenType.Error:{const P=[h.lexeme];this._advance();let w=this._peek(),G=0;for(let Y=0;Y<h.lexeme.length;Y++)h.lexeme.charCodeAt(Y)===c.CharCode.OpenParen?G++:h.lexeme.charCodeAt(Y)===c.CharCode.CloseParen&&G--;for(;!this._isAtEnd()&&w.type!==n.TokenType.And&&w.type!==n.TokenType.Or;){switch(w.type){case n.TokenType.LParen:G++;break;case n.TokenType.RParen:G--;break;case n.TokenType.RegexStr:case n.TokenType.QuotedStr:for(let Y=0;Y<w.lexeme.length;Y++)w.lexeme.charCodeAt(Y)===c.CharCode.OpenParen?G++:h.lexeme.charCodeAt(Y)===c.CharCode.CloseParen&&G--}if(G<0)break;P.push(n.Scanner.getLexeme(w)),this._advance(),w=this._peek()}const z=P.join(""),J=z.lastIndexOf("/"),ne=J===z.length-1?void 0:this._removeFlagsGY(z.substring(J+1));let le;try{le=new RegExp(z.substring(1,J),ne)}catch{throw this._errExpectedButGot("REGEX",h)}return N.regex(r,le)}case n.TokenType.QuotedStr:{const P=h.lexeme;this._advance();let w=null;if(!(0,S.isFalsyOrWhitespace)(P)){const G=P.indexOf("/"),z=P.lastIndexOf("/");if(G!==z&&G>=0){const J=P.slice(G+1,z),ne=P[z+1]==="i"?"i":"";try{w=new RegExp(J,ne)}catch{throw this._errExpectedButGot("REGEX",h)}}}if(w===null)throw this._errExpectedButGot("REGEX",h);return re.create(r,w)}default:throw this._errExpectedButGot("REGEX",this._peek())}}if(this._matchOne(n.TokenType.Not)){this._consume(n.TokenType.In,s);const h=this._value();return N.notIn(r,h)}switch(this._peek().type){case n.TokenType.Eq:{this._advance();const h=this._value();if(this._previous().type===n.TokenType.QuotedStr)return N.equals(r,h);switch(h){case"true":return N.has(r);case"false":return N.not(r);default:return N.equals(r,h)}}case n.TokenType.NotEq:{this._advance();const h=this._value();if(this._previous().type===n.TokenType.QuotedStr)return N.notEquals(r,h);switch(h){case"true":return N.not(r);case"false":return N.has(r);default:return N.notEquals(r,h)}}case n.TokenType.Lt:return this._advance(),Q.create(r,this._value());case n.TokenType.LtEq:return this._advance(),H.create(r,this._value());case n.TokenType.Gt:return this._advance(),F.create(r,this._value());case n.TokenType.GtEq:return this._advance(),j.create(r,this._value());case n.TokenType.In:return this._advance(),N.in(r,this._value());default:return N.has(r)}}case n.TokenType.EOF:throw this._parsingErrors.push({message:v,offset:e.offset,lexeme:"",additionalInfo:L}),R._parseError;default:throw this._errExpectedButGot(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this._peek())}}_value(){const e=this._peek();switch(e.type){case n.TokenType.Str:case n.TokenType.QuotedStr:return this._advance(),e.lexeme;case n.TokenType.True:return this._advance(),"true";case n.TokenType.False:return this._advance(),"false";case n.TokenType.In:return this._advance(),"in";default:return""}}_removeFlagsGY(e){return e.replaceAll(this._flagsGYRe,"")}_previous(){return this._tokens[this._current-1]}_matchOne(e){return this._check(e)?(this._advance(),!0):!1}_advance(){return this._isAtEnd()||this._current++,this._previous()}_consume(e,r){if(this._check(e))return this._advance();throw this._errExpectedButGot(r,this._peek())}_errExpectedButGot(e,r,g){const h=(0,y.localize)(1681,null,e,n.Scanner.getLexeme(r)),P=r.offset,w=n.Scanner.getLexeme(r);return this._parsingErrors.push({message:h,offset:P,lexeme:w,additionalInfo:g}),R._parseError}_check(e){return this._peek().type===e}_peek(){return this._tokens[this._current]}_isAtEnd(){return this._peek().type===n.TokenType.EOF}}t.Parser=R;class N{static false(){return W.INSTANCE}static true(){return q.INSTANCE}static has(e){return U.create(e)}static equals(e,r){return Z.create(e,r)}static notEquals(e,r){return i.create(e,r)}static regex(e,r){return re.create(e,r)}static in(e,r){return ee.create(e,r)}static notIn(e,r){return A.create(e,r)}static not(e){return l.create(e)}static and(...e){return X.create(e,null,!0)}static or(...e){return K.create(e,null,!0)}static greater(e,r){return F.create(e,r)}static greaterEquals(e,r){return j.create(e,r)}static smaller(e,r){return Q.create(e,r)}static smallerEquals(e,r){return H.create(e,r)}static{this._parser=new R({regexParsingWithErrorRecovery:!1})}static deserialize(e){return e==null?void 0:this._parser.parse(e)}}t.ContextKeyExpr=N;function x(k){const e=new R({regexParsingWithErrorRecovery:!1});return k.map(r=>(e.parse(r),e.lexingErrors.length>0?e.lexingErrors.map(g=>({errorMessage:g.additionalInfo?(0,y.localize)(1682,null,g.additionalInfo):(0,y.localize)(1683,null),offset:g.offset,length:g.lexeme.length})):e.parsingErrors.length>0?e.parsingErrors.map(g=>({errorMessage:g.additionalInfo?`${g.message}. ${g.additionalInfo}`:g.message,offset:g.offset,length:g.lexeme.length})):[]))}function $(k,e){const r=k?k.substituteConstants():void 0,g=e?e.substituteConstants():void 0;return!r&&!g?!0:!r||!g?!1:r.equals(g)}function M(k,e){return k.cmp(e)}class W{static{this.INSTANCE=new W}constructor(){this.type=m.False}cmp(e){return this.type-e.type}equals(e){return e.type===this.type}substituteConstants(){return this}evaluate(e){return!1}serialize(){return"false"}keys(){return[]}map(e){return this}negate(){return q.INSTANCE}}t.ContextKeyFalseExpr=W;class q{static{this.INSTANCE=new q}constructor(){this.type=m.True}cmp(e){return this.type-e.type}equals(e){return e.type===this.type}substituteConstants(){return this}evaluate(e){return!0}serialize(){return"true"}keys(){return[]}map(e){return this}negate(){return W.INSTANCE}}t.ContextKeyTrueExpr=q;class U{static create(e,r=null){const g=_.get(e);return typeof g=="boolean"?g?q.INSTANCE:W.INSTANCE:new U(e,r)}constructor(e,r){this.key=e,this.negated=r,this.type=m.Defined}cmp(e){return e.type!==this.type?this.type-e.type:he(this.key,e.key)}equals(e){return e.type===this.type?this.key===e.key:!1}substituteConstants(){const e=_.get(this.key);return typeof e=="boolean"?e?q.INSTANCE:W.INSTANCE:this}evaluate(e){return!!e.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(e){return e.mapDefined(this.key)}negate(){return this.negated||(this.negated=l.create(this.key,this)),this.negated}}t.ContextKeyDefinedExpr=U;class Z{static create(e,r,g=null){if(typeof r=="boolean")return r?U.create(e,g):l.create(e,g);const h=_.get(e);return typeof h=="boolean"?r===(h?"true":"false")?q.INSTANCE:W.INSTANCE:new Z(e,r,g)}constructor(e,r,g){this.key=e,this.value=r,this.negated=g,this.type=m.Equals}cmp(e){return e.type!==this.type?this.type-e.type:te(this.key,this.value,e.key,e.value)}equals(e){return e.type===this.type?this.key===e.key&&this.value===e.value:!1}substituteConstants(){const e=_.get(this.key);if(typeof e=="boolean"){const r=e?"true":"false";return this.value===r?q.INSTANCE:W.INSTANCE}return this}evaluate(e){return e.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(e){return e.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=i.create(this.key,this.value,this)),this.negated}}t.ContextKeyEqualsExpr=Z;class ee{static create(e,r){return new ee(e,r)}constructor(e,r){this.key=e,this.valueKey=r,this.type=m.In,this.negated=null}cmp(e){return e.type!==this.type?this.type-e.type:te(this.key,this.valueKey,e.key,e.valueKey)}equals(e){return e.type===this.type?this.key===e.key&&this.valueKey===e.valueKey:!1}substituteConstants(){return this}evaluate(e){const r=e.getValue(this.valueKey),g=e.getValue(this.key);return Array.isArray(r)?r.includes(g):typeof g=="string"&&typeof r=="object"&&r!==null?o.call(r,g):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(e){return e.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=A.create(this.key,this.valueKey)),this.negated}}t.ContextKeyInExpr=ee;class A{static create(e,r){return new A(e,r)}constructor(e,r){this.key=e,this.valueKey=r,this.type=m.NotIn,this._negated=ee.create(e,r)}cmp(e){return e.type!==this.type?this.type-e.type:this._negated.cmp(e._negated)}equals(e){return e.type===this.type?this._negated.equals(e._negated):!1}substituteConstants(){return this}evaluate(e){return!this._negated.evaluate(e)}serialize(){return`${this.key} not in '${this.valueKey}'`}keys(){return this._negated.keys()}map(e){return e.mapNotIn(this.key,this.valueKey)}negate(){return this._negated}}t.ContextKeyNotInExpr=A;class i{static create(e,r,g=null){if(typeof r=="boolean")return r?l.create(e,g):U.create(e,g);const h=_.get(e);return typeof h=="boolean"?r===(h?"true":"false")?W.INSTANCE:q.INSTANCE:new i(e,r,g)}constructor(e,r,g){this.key=e,this.value=r,this.negated=g,this.type=m.NotEquals}cmp(e){return e.type!==this.type?this.type-e.type:te(this.key,this.value,e.key,e.value)}equals(e){return e.type===this.type?this.key===e.key&&this.value===e.value:!1}substituteConstants(){const e=_.get(this.key);if(typeof e=="boolean"){const r=e?"true":"false";return this.value===r?W.INSTANCE:q.INSTANCE}return this}evaluate(e){return e.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(e){return e.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=Z.create(this.key,this.value,this)),this.negated}}t.ContextKeyNotEqualsExpr=i;class l{static create(e,r=null){const g=_.get(e);return typeof g=="boolean"?g?W.INSTANCE:q.INSTANCE:new l(e,r)}constructor(e,r){this.key=e,this.negated=r,this.type=m.Not}cmp(e){return e.type!==this.type?this.type-e.type:he(this.key,e.key)}equals(e){return e.type===this.type?this.key===e.key:!1}substituteConstants(){const e=_.get(this.key);return typeof e=="boolean"?e?W.INSTANCE:q.INSTANCE:this}evaluate(e){return!e.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(e){return e.mapNot(this.key)}negate(){return this.negated||(this.negated=U.create(this.key,this)),this.negated}}t.ContextKeyNotExpr=l;function O(k,e){if(typeof k=="string"){const r=parseFloat(k);isNaN(r)||(k=r)}return typeof k=="string"||typeof k=="number"?e(k):W.INSTANCE}class F{static create(e,r,g=null){return O(r,h=>new F(e,h,g))}constructor(e,r,g){this.key=e,this.value=r,this.negated=g,this.type=m.Greater}cmp(e){return e.type!==this.type?this.type-e.type:te(this.key,this.value,e.key,e.value)}equals(e){return e.type===this.type?this.key===e.key&&this.value===e.value:!1}substituteConstants(){return this}evaluate(e){return typeof this.value=="string"?!1:parseFloat(e.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(e){return e.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=H.create(this.key,this.value,this)),this.negated}}t.ContextKeyGreaterExpr=F;class j{static create(e,r,g=null){return O(r,h=>new j(e,h,g))}constructor(e,r,g){this.key=e,this.value=r,this.negated=g,this.type=m.GreaterEquals}cmp(e){return e.type!==this.type?this.type-e.type:te(this.key,this.value,e.key,e.value)}equals(e){return e.type===this.type?this.key===e.key&&this.value===e.value:!1}substituteConstants(){return this}evaluate(e){return typeof this.value=="string"?!1:parseFloat(e.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(e){return e.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=Q.create(this.key,this.value,this)),this.negated}}t.ContextKeyGreaterEqualsExpr=j;class Q{static create(e,r,g=null){return O(r,h=>new Q(e,h,g))}constructor(e,r,g){this.key=e,this.value=r,this.negated=g,this.type=m.Smaller}cmp(e){return e.type!==this.type?this.type-e.type:te(this.key,this.value,e.key,e.value)}equals(e){return e.type===this.type?this.key===e.key&&this.value===e.value:!1}substituteConstants(){return this}evaluate(e){return typeof this.value=="string"?!1:parseFloat(e.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(e){return e.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=j.create(this.key,this.value,this)),this.negated}}t.ContextKeySmallerExpr=Q;class H{static create(e,r,g=null){return O(r,h=>new H(e,h,g))}constructor(e,r,g){this.key=e,this.value=r,this.negated=g,this.type=m.SmallerEquals}cmp(e){return e.type!==this.type?this.type-e.type:te(this.key,this.value,e.key,e.value)}equals(e){return e.type===this.type?this.key===e.key&&this.value===e.value:!1}substituteConstants(){return this}evaluate(e){return typeof this.value=="string"?!1:parseFloat(e.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(e){return e.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=F.create(this.key,this.value,this)),this.negated}}t.ContextKeySmallerEqualsExpr=H;class re{static create(e,r){return new re(e,r)}constructor(e,r){this.key=e,this.regexp=r,this.type=m.Regex,this.negated=null}cmp(e){if(e.type!==this.type)return this.type-e.type;if(this.key<e.key)return-1;if(this.key>e.key)return 1;const r=this.regexp?this.regexp.source:"",g=e.regexp?e.regexp.source:"";return r<g?-1:r>g?1:0}equals(e){if(e.type===this.type){const r=this.regexp?this.regexp.source:"",g=e.regexp?e.regexp.source:"";return this.key===e.key&&r===g}return!1}substituteConstants(){return this}evaluate(e){const r=e.getValue(this.key);return this.regexp?this.regexp.test(r):!1}serialize(){const e=this.regexp?`/${this.regexp.source}/${this.regexp.flags}`:"/invalid/";return`${this.key} =~ ${e}`}keys(){return[this.key]}map(e){return e.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=se.create(this)),this.negated}}t.ContextKeyRegexExpr=re;class se{static create(e){return new se(e)}constructor(e){this._actual=e,this.type=m.NotRegex}cmp(e){return e.type!==this.type?this.type-e.type:this._actual.cmp(e._actual)}equals(e){return e.type===this.type?this._actual.equals(e._actual):!1}substituteConstants(){return this}evaluate(e){return!this._actual.evaluate(e)}serialize(){return`!(${this._actual.serialize()})`}keys(){return this._actual.keys()}map(e){return new se(this._actual.map(e))}negate(){return this._actual}}t.ContextKeyNotRegexExpr=se;function ce(k){let e=null;for(let r=0,g=k.length;r<g;r++){const h=k[r].substituteConstants();if(k[r]!==h&&e===null){e=[];for(let P=0;P<r;P++)e[P]=k[P]}e!==null&&(e[r]=h)}return e===null?k:e}class X{static create(e,r,g){return X._normalizeArr(e,r,g)}constructor(e,r){this.expr=e,this.negated=r,this.type=m.And}cmp(e){if(e.type!==this.type)return this.type-e.type;if(this.expr.length<e.expr.length)return-1;if(this.expr.length>e.expr.length)return 1;for(let r=0,g=this.expr.length;r<g;r++){const h=M(this.expr[r],e.expr[r]);if(h!==0)return h}return 0}equals(e){if(e.type===this.type){if(this.expr.length!==e.expr.length)return!1;for(let r=0,g=this.expr.length;r<g;r++)if(!this.expr[r].equals(e.expr[r]))return!1;return!0}return!1}substituteConstants(){const e=ce(this.expr);return e===this.expr?this:X.create(e,this.negated,!1)}evaluate(e){for(let r=0,g=this.expr.length;r<g;r++)if(!this.expr[r].evaluate(e))return!1;return!0}static _normalizeArr(e,r,g){const h=[];let P=!1;for(const w of e)if(w){if(w.type===m.True){P=!0;continue}if(w.type===m.False)return W.INSTANCE;if(w.type===m.And){h.push(...w.expr);continue}h.push(w)}if(h.length===0&&P)return q.INSTANCE;if(h.length!==0){if(h.length===1)return h[0];h.sort(M);for(let w=1;w<h.length;w++)h[w-1].equals(h[w])&&(h.splice(w,1),w--);if(h.length===1)return h[0];for(;h.length>1;){const w=h[h.length-1];if(w.type!==m.Or)break;h.pop();const G=h.pop(),z=h.length===0,J=K.create(w.expr.map(ne=>X.create([ne,G],null,g)),null,z);J&&(h.push(J),h.sort(M))}if(h.length===1)return h[0];if(g){for(let w=0;w<h.length;w++)for(let G=w+1;G<h.length;G++)if(h[w].negate().equals(h[G]))return W.INSTANCE;if(h.length===1)return h[0]}return new X(h,r)}}serialize(){return this.expr.map(e=>e.serialize()).join(" && ")}keys(){const e=[];for(const r of this.expr)e.push(...r.keys());return e}map(e){return new X(this.expr.map(r=>r.map(e)),null)}negate(){if(!this.negated){const e=[];for(const r of this.expr)e.push(r.negate());this.negated=K.create(e,this,!0)}return this.negated}}t.ContextKeyAndExpr=X;class K{static create(e,r,g){return K._normalizeArr(e,r,g)}constructor(e,r){this.expr=e,this.negated=r,this.type=m.Or}cmp(e){if(e.type!==this.type)return this.type-e.type;if(this.expr.length<e.expr.length)return-1;if(this.expr.length>e.expr.length)return 1;for(let r=0,g=this.expr.length;r<g;r++){const h=M(this.expr[r],e.expr[r]);if(h!==0)return h}return 0}equals(e){if(e.type===this.type){if(this.expr.length!==e.expr.length)return!1;for(let r=0,g=this.expr.length;r<g;r++)if(!this.expr[r].equals(e.expr[r]))return!1;return!0}return!1}substituteConstants(){const e=ce(this.expr);return e===this.expr?this:K.create(e,this.negated,!1)}evaluate(e){for(let r=0,g=this.expr.length;r<g;r++)if(this.expr[r].evaluate(e))return!0;return!1}static _normalizeArr(e,r,g){let h=[],P=!1;if(e){for(let w=0,G=e.length;w<G;w++){const z=e[w];if(z){if(z.type===m.False){P=!0;continue}if(z.type===m.True)return q.INSTANCE;if(z.type===m.Or){h=h.concat(z.expr);continue}h.push(z)}}if(h.length===0&&P)return W.INSTANCE;h.sort(M)}if(h.length!==0){if(h.length===1)return h[0];for(let w=1;w<h.length;w++)h[w-1].equals(h[w])&&(h.splice(w,1),w--);if(h.length===1)return h[0];if(g){for(let w=0;w<h.length;w++)for(let G=w+1;G<h.length;G++)if(h[w].negate().equals(h[G]))return q.INSTANCE;if(h.length===1)return h[0]}return new K(h,r)}}serialize(){return this.expr.map(e=>e.serialize()).join(" || ")}keys(){const e=[];for(const r of this.expr)e.push(...r.keys());return e}map(e){return new K(this.expr.map(r=>r.map(e)),null)}negate(){if(!this.negated){const e=[];for(const r of this.expr)e.push(r.negate());for(;e.length>1;){const r=e.shift(),g=e.shift(),h=[];for(const P of ge(r))for(const w of ge(g))h.push(X.create([P,w],null,!1));e.unshift(K.create(h,null,!1))}this.negated=K.create(e,this,!0)}return this.negated}}t.ContextKeyOrExpr=K;class ie extends U{static{this._info=[]}static all(){return ie._info.values()}constructor(e,r,g){super(e,null),this._defaultValue=r,typeof g=="object"?ie._info.push({...g,key:e}):g!==!0&&ie._info.push({key:e,description:g,type:r!=null?typeof r:void 0})}bindTo(e){return e.createKey(this.key,this._defaultValue)}getValue(e){return e.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(e){return Z.create(this.key,e)}notEqualsTo(e){return i.create(this.key,e)}}t.RawContextKey=ie,t.IContextKeyService=(0,T.createDecorator)("contextKeyService");function he(k,e){return k<e?-1:k>e?1:0}function te(k,e,r,g){return k<r?-1:k>r?1:e<g?-1:e>g?1:0}function oe(k,e){if(k.type===m.False||e.type===m.True)return!0;if(k.type===m.Or)return e.type===m.Or?fe(k.expr,e.expr):!1;if(e.type===m.Or){for(const r of e.expr)if(oe(k,r))return!0;return!1}if(k.type===m.And){if(e.type===m.And)return fe(e.expr,k.expr);for(const r of k.expr)if(oe(r,e))return!0;return!1}return k.equals(e)}function fe(k,e){let r=0,g=0;for(;r<k.length&&g<e.length;){const h=k[r].cmp(e[g]);if(h<0)return!1;h===0&&r++,g++}return r===k.length}function ge(k){return k.type===m.Or?k.expr:[k]}}),define(V[19],B([0,1,4,10,29,30,13,31,18,32,11,20,17,2]),function(D,t,c,I,S,n,T,y,E,_,f,o,m,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CONTEXT_LOG_LEVEL=t.NullLogService=t.NullLogger=t.AbstractLoggerService=t.MultiplexLogger=t.AdapterLogger=t.ConsoleLogger=t.ConsoleMainLogger=t.AbstractMessageLogger=t.AbstractLogger=t.DEFAULT_LOG_LEVEL=t.LogLevel=t.ILoggerService=t.ILogService=void 0,t.isLogLevel=p,t.log=u,t.getLogLevel=q,t.LogLevelToString=U,t.LogLevelToLocalizedString=Z,t.parseLogLevel=ee,c=ae(c),t.ILogService=(0,b.createDecorator)("logService"),t.ILoggerService=(0,b.createDecorator)("loggerService");function a(){return new Date().toISOString()}function p(A){return(0,f.isNumber)(A)}var s;(function(A){A[A.Off=0]="Off",A[A.Trace=1]="Trace",A[A.Debug=2]="Debug",A[A.Info=3]="Info",A[A.Warning=4]="Warning",A[A.Error=5]="Error"})(s||(t.LogLevel=s={})),t.DEFAULT_LOG_LEVEL=s.Info;function u(A,i,l){switch(i){case s.Trace:A.trace(l);break;case s.Debug:A.debug(l);break;case s.Info:A.info(l);break;case s.Warning:A.warn(l);break;case s.Error:A.error(l);break;case s.Off:break;default:throw new Error(`Invalid log level ${i}`)}}function d(A,i=!1){let l="";for(let O=0;O<A.length;O++){let F=A[O];if(F instanceof Error&&(F=(0,I.toErrorMessage)(F,i)),typeof F=="object")try{F=JSON.stringify(F)}catch{}l+=(O>0?" ":"")+F}return l}class C extends T.Disposable{constructor(){super(...arguments),this.level=t.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new S.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(i){this.level!==i&&(this.level=i,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}checkLogLevel(i){return this.level!==s.Off&&this.level<=i}}t.AbstractLogger=C;class v extends C{constructor(i){super(),this.logAlways=i}checkLogLevel(i){return this.logAlways||super.checkLogLevel(i)}trace(i,...l){this.checkLogLevel(s.Trace)&&this.log(s.Trace,d([i,...l],!0))}debug(i,...l){this.checkLogLevel(s.Debug)&&this.log(s.Debug,d([i,...l]))}info(i,...l){this.checkLogLevel(s.Info)&&this.log(s.Info,d([i,...l]))}warn(i,...l){this.checkLogLevel(s.Warning)&&this.log(s.Warning,d([i,...l]))}error(i,...l){if(this.checkLogLevel(s.Error))if(i instanceof Error){const O=Array.prototype.slice.call(arguments);O[0]=i.stack,this.log(s.Error,d(O))}else this.log(s.Error,d([i,...l]))}flush(){}}t.AbstractMessageLogger=v;class L extends C{constructor(i=t.DEFAULT_LOG_LEVEL){super(),this.setLevel(i),this.useColors=!E.isWindows}trace(i,...l){this.checkLogLevel(s.Trace)&&(this.useColors?console.log(`\x1B[90m[main ${a()}]\x1B[0m`,i,...l):console.log(`[main ${a()}]`,i,...l))}debug(i,...l){this.checkLogLevel(s.Debug)&&(this.useColors?console.log(`\x1B[90m[main ${a()}]\x1B[0m`,i,...l):console.log(`[main ${a()}]`,i,...l))}info(i,...l){this.checkLogLevel(s.Info)&&(this.useColors?console.log(`\x1B[90m[main ${a()}]\x1B[0m`,i,...l):console.log(`[main ${a()}]`,i,...l))}warn(i,...l){this.checkLogLevel(s.Warning)&&(this.useColors?console.warn(`\x1B[93m[main ${a()}]\x1B[0m`,i,...l):console.warn(`[main ${a()}]`,i,...l))}error(i,...l){this.checkLogLevel(s.Error)&&(this.useColors?console.error(`\x1B[91m[main ${a()}]\x1B[0m`,i,...l):console.error(`[main ${a()}]`,i,...l))}flush(){}}t.ConsoleMainLogger=L;class R extends C{constructor(i=t.DEFAULT_LOG_LEVEL,l=!0){super(),this.useColors=l,this.setLevel(i)}trace(i,...l){this.checkLogLevel(s.Trace)&&(this.useColors?console.log("%cTRACE","color: #888",i,...l):console.log(i,...l))}debug(i,...l){this.checkLogLevel(s.Debug)&&(this.useColors?console.log("%cDEBUG","background: #eee; color: #888",i,...l):console.log(i,...l))}info(i,...l){this.checkLogLevel(s.Info)&&(this.useColors?console.log("%c INFO","color: #33f",i,...l):console.log(i,...l))}warn(i,...l){this.checkLogLevel(s.Warning)&&(this.useColors?console.log("%c WARN","color: #993",i,...l):console.log(i,...l))}error(i,...l){this.checkLogLevel(s.Error)&&(this.useColors?console.log("%c  ERR","color: #f33",i,...l):console.error(i,...l))}flush(){}}t.ConsoleLogger=R;class N extends C{constructor(i,l=t.DEFAULT_LOG_LEVEL){super(),this.adapter=i,this.setLevel(l)}trace(i,...l){this.checkLogLevel(s.Trace)&&this.adapter.log(s.Trace,[this.extractMessage(i),...l])}debug(i,...l){this.checkLogLevel(s.Debug)&&this.adapter.log(s.Debug,[this.extractMessage(i),...l])}info(i,...l){this.checkLogLevel(s.Info)&&this.adapter.log(s.Info,[this.extractMessage(i),...l])}warn(i,...l){this.checkLogLevel(s.Warning)&&this.adapter.log(s.Warning,[this.extractMessage(i),...l])}error(i,...l){this.checkLogLevel(s.Error)&&this.adapter.log(s.Error,[this.extractMessage(i),...l])}extractMessage(i){return typeof i=="string"?i:(0,I.toErrorMessage)(i,this.checkLogLevel(s.Trace))}flush(){}}t.AdapterLogger=N;class x extends C{constructor(i){super(),this.loggers=i,i.length&&this.setLevel(i[0].getLevel())}setLevel(i){for(const l of this.loggers)l.setLevel(i);super.setLevel(i)}trace(i,...l){for(const O of this.loggers)O.trace(i,...l)}debug(i,...l){for(const O of this.loggers)O.debug(i,...l)}info(i,...l){for(const O of this.loggers)O.info(i,...l)}warn(i,...l){for(const O of this.loggers)O.warn(i,...l)}error(i,...l){for(const O of this.loggers)O.error(i,...l)}flush(){for(const i of this.loggers)i.flush()}dispose(){for(const i of this.loggers)i.dispose();super.dispose()}}t.MultiplexLogger=x;class $ extends T.Disposable{constructor(i,l,O){if(super(),this.logLevel=i,this.logsHome=l,this._loggers=new y.ResourceMap,this._onDidChangeLoggers=this._register(new S.Emitter),this.onDidChangeLoggers=this._onDidChangeLoggers.event,this._onDidChangeLogLevel=this._register(new S.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event,this._onDidChangeVisibility=this._register(new S.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,O)for(const F of O)this._loggers.set(F.resource,{logger:void 0,info:F})}getLoggerEntry(i){return(0,f.isString)(i)?[...this._loggers.values()].find(l=>l.info.id===i):this._loggers.get(i)}getLogger(i){return this.getLoggerEntry(i)?.logger}createLogger(i,l){const O=this.toResource(i),F=(0,f.isString)(i)?i:l?.id??(0,n.hash)(O.toString()).toString(16);let j=this._loggers.get(O)?.logger;const Q=l?.logLevel==="always"?s.Trace:l?.logLevel;j||(j=this.doCreateLogger(O,Q??this.getLogLevel(O)??this.logLevel,{...l,id:F}));const H={logger:j,info:{resource:O,id:F,logLevel:Q,name:l?.name,hidden:l?.hidden,extensionId:l?.extensionId,when:l?.when}};return this.registerLogger(H.info),this._loggers.set(O,H),j}toResource(i){return(0,f.isString)(i)?(0,_.joinPath)(this.logsHome,`${i}.log`):i}setLogLevel(i,l){if(o.URI.isUri(i)){const O=i,F=l,j=this._loggers.get(O);j&&F!==j.info.logLevel&&(j.info.logLevel=F===this.logLevel?void 0:F,j.logger?.setLevel(F),this._loggers.set(j.info.resource,j),this._onDidChangeLogLevel.fire([O,F]))}else{this.logLevel=i;for(const[O,F]of this._loggers.entries())this._loggers.get(O)?.info.logLevel===void 0&&F.logger?.setLevel(this.logLevel);this._onDidChangeLogLevel.fire(this.logLevel)}}setVisibility(i,l){const O=this.getLoggerEntry(i);O&&l!==!O.info.hidden&&(O.info.hidden=!l,this._loggers.set(O.info.resource,O),this._onDidChangeVisibility.fire([O.info.resource,l]))}getLogLevel(i){let l;return i&&(l=this._loggers.get(i)?.info.logLevel),l??this.logLevel}registerLogger(i){const l=this._loggers.get(i.resource);l?l.info.hidden!==i.hidden&&this.setVisibility(i.resource,!i.hidden):(this._loggers.set(i.resource,{info:i,logger:void 0}),this._onDidChangeLoggers.fire({added:[i],removed:[]}))}deregisterLogger(i){const l=this._loggers.get(i);l&&(l.logger&&l.logger.dispose(),this._loggers.delete(i),this._onDidChangeLoggers.fire({added:[],removed:[l.info]}))}*getRegisteredLoggers(){for(const i of this._loggers.values())yield i.info}getRegisteredLogger(i){return this._loggers.get(i)?.info}dispose(){this._loggers.forEach(i=>i.logger?.dispose()),this._loggers.clear(),super.dispose()}}t.AbstractLoggerService=$;class M{constructor(){this.onDidChangeLogLevel=new S.Emitter().event}setLevel(i){}getLevel(){return s.Info}trace(i,...l){}debug(i,...l){}info(i,...l){}warn(i,...l){}error(i,...l){}critical(i,...l){}dispose(){}flush(){}}t.NullLogger=M;class W extends M{}t.NullLogService=W;function q(A){if(A.verbose)return s.Trace;if(typeof A.logLevel=="string"){const i=ee(A.logLevel.toLowerCase());if(i!==void 0)return i}return t.DEFAULT_LOG_LEVEL}function U(A){switch(A){case s.Trace:return"trace";case s.Debug:return"debug";case s.Info:return"info";case s.Warning:return"warn";case s.Error:return"error";case s.Off:return"off"}}function Z(A){switch(A){case s.Trace:return{original:"Trace",value:c.localize(1959,null)};case s.Debug:return{original:"Debug",value:c.localize(1960,null)};case s.Info:return{original:"Info",value:c.localize(1961,null)};case s.Warning:return{original:"Warning",value:c.localize(1962,null)};case s.Error:return{original:"Error",value:c.localize(1963,null)};case s.Off:return{original:"Off",value:c.localize(1964,null)}}}function ee(A){switch(A){case"trace":return s.Trace;case"debug":return s.Debug;case"info":return s.Info;case"warn":return s.Warning;case"error":return s.Error;case"critical":return s.Error;case"off":return s.Off}}t.CONTEXT_LOG_LEVEL=new m.RawContextKey("logLevel",U(s.Info))}),define(V[21],B([0,1,22,2]),function(D,t,c,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Utils=t.IV8InspectProfilingService=void 0,t.IV8InspectProfilingService=(0,I.createDecorator)("IV8InspectProfilingService");var S;(function(n){function T(E){return!!(E.samples&&E.timeDeltas)}n.isValidProfile=T;function y(E,_="noAbsolutePaths"){for(const f of E.nodes)f.callFrame&&f.callFrame.url&&((0,c.isAbsolute)(f.callFrame.url)||/^\w[\w\d+.-]*:\/\/\/?/.test(f.callFrame.url))&&(f.callFrame.url=(0,c.join)(_,(0,c.basename)(f.callFrame.url)));return E}n.rewriteAbsolutePaths=y})(S||(t.Utils=S={}))}),define(V[23],B([0,1]),function(D,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.processNode=t.BottomUpNode=t.buildModel=void 0;const c=(y,E)=>{const _=E[y];if(_.aggregateTime)return _.aggregateTime;let f=_.selfTime;for(const o of _.children)f+=c(o,E);return _.aggregateTime=f},I=y=>{let E=0;const _=new Map,f=o=>{const m=[o.functionName,o.url,o.scriptId,o.lineNumber,o.columnNumber].join(":"),b=_.get(m);if(b)return b.id;const a=E++;return _.set(m,{id:a,callFrame:o,location:{lineNumber:o.lineNumber+1,columnNumber:o.columnNumber+1}}),a};for(const o of y.nodes)o.locationId=f(o.callFrame),o.positionTicks=o.positionTicks?.map(m=>({...m,startLocationId:f({...o.callFrame,lineNumber:m.line-1,columnNumber:0}),endLocationId:f({...o.callFrame,lineNumber:m.line,columnNumber:0})}));return[..._.values()].sort((o,m)=>o.id-m.id).map(o=>({locations:[o.location],callFrame:o.callFrame}))},S=y=>{if(!y.timeDeltas||!y.samples)return{nodes:[],locations:[],samples:y.samples||[],timeDeltas:y.timeDeltas||[],duration:y.endTime-y.startTime};const{samples:E,timeDeltas:_}=y,o=I(y).map((u,d)=>{const C=u.locations[0];return{id:d,selfTime:0,aggregateTime:0,ticks:0,callFrame:u.callFrame,src:C}}),m=new Map,b=u=>{let d=m.get(u);return d===void 0&&(d=m.size,m.set(u,d)),d},a=new Array(y.nodes.length);for(let u=0;u<y.nodes.length;u++){const d=y.nodes[u],C=b(d.id);a[C]={id:C,selfTime:0,aggregateTime:0,locationId:d.locationId,children:d.children?.map(b)||[]};for(const v of d.positionTicks||[])v.startLocationId&&(o[v.startLocationId].ticks+=v.ticks)}for(const u of a)for(const d of u.children)a[d].parent=u.id;const p=y.endTime-y.startTime;let s=p-_[0];for(let u=0;u<_.length-1;u++){const d=_[u+1];a[b(E[u])].selfTime+=d,s-=d}a.length&&(a[b(E[_.length-1])].selfTime+=s,_.push(s));for(let u=0;u<a.length;u++){const d=a[u],C=o[d.locationId];C.aggregateTime+=c(u,a),C.selfTime+=d.selfTime}return{nodes:a,locations:o,samples:E.map(b),timeDeltas:_,duration:p}};t.buildModel=S;class n{static root(){return new n({id:-1,selfTime:0,aggregateTime:0,ticks:0,callFrame:{functionName:"(root)",lineNumber:-1,columnNumber:-1,scriptId:"0",url:""}})}get id(){return this.location.id}get callFrame(){return this.location.callFrame}get src(){return this.location.src}constructor(E,_){this.location=E,this.parent=_,this.children={},this.aggregateTime=0,this.selfTime=0,this.ticks=0,this.childrenSize=0}addNode(E){this.selfTime+=E.selfTime,this.aggregateTime+=E.aggregateTime}}t.BottomUpNode=n;const T=(y,E,_,f=E)=>{let o=y.children[E.locationId];o||(o=new n(_.locations[E.locationId],y),y.childrenSize++,y.children[E.locationId]=o),o.addNode(f),E.parent&&(0,t.processNode)(o,_.nodes[E.parent],_,f)};t.processNode=T}),define(V[24],B([0,1,3]),function(D,t,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.reportSample=I;function I(n,T,y,E){const{sample:_,perfBaseline:f,source:o}=n;T.publicLog2("unresponsive.sample",{perfBaseline:f,selfTime:_.selfTime,totalTime:_.totalTime,percentage:_.percentage,functionName:_.location,callers:_.caller.map(b=>b.location).join("<"),callersAnnotated:_.caller.map(b=>`${b.percentage}|${b.location}`).join("<"),source:o});const m=new S(n);E?c.errorHandler.onUnexpectedError(m):y.error(m)}class S extends Error{constructor(T){super(`PerfSampleError: by ${T.source} in ${T.sample.location}`),this.name="PerfSampleError",this.selfTime=T.sample.selfTime;const y=[T.sample.absLocation,...T.sample.caller.map(E=>E.absLocation)];this.stack=`
	 at ${y.join(`
	 at `)}`}}}),define(V[25],B([0,1,2]),function(D,t,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.TelemetryConfiguration=t.TelemetryLevel=t.TELEMETRY_OLD_SETTING_ID=t.TELEMETRY_CRASH_REPORTER_SETTING_ID=t.TELEMETRY_SETTING_ID=t.TELEMETRY_SECTION_ID=t.devDeviceIdKey=t.sqmIdKey=t.machineIdKey=t.lastSessionDateStorageKey=t.firstSessionDateStorageKey=t.currentSessionDateStorageKey=t.ICustomEndpointTelemetryService=t.ITelemetryService=void 0,t.ITelemetryService=(0,c.createDecorator)("telemetryService"),t.ICustomEndpointTelemetryService=(0,c.createDecorator)("customEndpointTelemetryService"),t.currentSessionDateStorageKey="telemetry.currentSessionDate",t.firstSessionDateStorageKey="telemetry.firstSessionDate",t.lastSessionDateStorageKey="telemetry.lastSessionDate",t.machineIdKey="telemetry.machineId",t.sqmIdKey="telemetry.sqmId",t.devDeviceIdKey="telemetry.devDeviceId",t.TELEMETRY_SECTION_ID="telemetry",t.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",t.TELEMETRY_CRASH_REPORTER_SETTING_ID="telemetry.enableCrashReporter",t.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var I;(function(n){n[n.NONE=0]="NONE",n[n.CRASH=1]="CRASH",n[n.ERROR=2]="ERROR",n[n.USAGE=3]="USAGE"})(I||(t.TelemetryLevel=I={}));var S;(function(n){n.OFF="off",n.CRASH="crash",n.ERROR="error",n.ON="all"})(S||(t.TelemetryConfiguration=S={}))});var pe=this&&this.__decorate||function(D,t,c,I){var S=arguments.length,n=S<3?t:I===null?I=Object.getOwnPropertyDescriptor(t,c):I,T;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")n=Reflect.decorate(D,t,c,I);else for(var y=D.length-1;y>=0;y--)(T=D[y])&&(n=(S<3?T(n):S>3?T(t,c,n):T(t,c))||n);return S>3&&n&&Object.defineProperty(t,c,n),n},ue=this&&this.__param||function(D,t){return function(c,I){t(c,I,D)}};define(V[26],B([0,1,12,16,2,19,24,25]),function(D,t,c,I,S,n,T,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IProfileAnalysisWorkerService=t.ProfilingOutput=void 0;var E;(function(f){f[f.Failure=0]="Failure",f[f.Irrelevant=1]="Irrelevant",f[f.Interesting=2]="Interesting"})(E||(t.ProfilingOutput=E={})),t.IProfileAnalysisWorkerService=(0,S.createDecorator)("IProfileAnalysisWorkerService");let _=class{constructor(o,m){this._telemetryService=o,this._logService=m}async _withWorker(o){const m=(0,c.createWebWorker)("vs/platform/profiling/electron-sandbox/profileAnalysisWorker","CpuProfileAnalysisWorker");try{return await o(m.proxy)}finally{m.dispose()}}async analyseBottomUp(o,m,b,a){return this._withWorker(async p=>{const s=await p.$analyseBottomUp(o);if(s.kind===E.Interesting)for(const u of s.samples)(0,T.reportSample)({sample:u,perfBaseline:b,source:m(u.url)},this._telemetryService,this._logService,a);return s.kind})}async analyseByLocation(o,m){return this._withWorker(async b=>await b.$analyseByUrlCategory(o,m))}};_=pe([ue(0,y.ITelemetryService),ue(1,n.ILogService)],_),(0,I.registerSingleton)(t.IProfileAnalysisWorkerService,_,I.InstantiationType.Delayed)}),define(V[33],B([0,1,22,8,20,21,23,26]),function(D,t,c,I,S,n,T,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.create=E;function E(p){return new _}class _{$analyseBottomUp(s){if(!n.Utils.isValidProfile(s))return{kind:y.ProfilingOutput.Irrelevant,samples:[]};const u=(0,T.buildModel)(s),d=a(u,5).filter(C=>!C.isSpecial);return d.length===0||d[0].percentage<10?{kind:y.ProfilingOutput.Irrelevant,samples:[]}:{kind:y.ProfilingOutput.Interesting,samples:d}}$analyseByUrlCategory(s,u){const d=I.TernarySearchTree.forUris();d.fill(u);const C=(0,T.buildModel)(s),v=new Map;for(const R of C.nodes){const N=C.locations[R.locationId];let x;try{x=d.findSubstr(S.URI.parse(N.callFrame.url))}catch{}x||(x=o(N.callFrame));const M=(v.get(x)??0)+R.selfTime;v.set(x,M)}const L=[];for(const[R,N]of v)L.push([R,N]);return L}}function f(p){return p.functionName.startsWith("(")&&p.functionName.endsWith(")")}function o(p){let s=p.functionName||"(anonymous)";return p.url&&(s+="#",s+=(0,c.basename)(p.url),p.lineNumber>=0&&(s+=":",s+=p.lineNumber+1),p.columnNumber>=0&&(s+=":",s+=p.columnNumber+1)),s}function m(p){let s=p.functionName||"(anonymous)";return p.url&&(s+=" (",s+=p.url,p.lineNumber>=0&&(s+=":",s+=p.lineNumber+1),p.columnNumber>=0&&(s+=":",s+=p.columnNumber+1),s+=")"),s}function b(p,s){const u={};for(const C of p.nodes)u[C.locationId]=(u[C.locationId]||0)+C.selfTime;const d=Object.entries(u).sort(([,C],[,v])=>v-C).slice(0,s).map(([C])=>Number(C));return new Set(d)}function a(p,s){const u=T.BottomUpNode.root(),d=b(p,s);for(const L of p.nodes)d.has(L.locationId)&&((0,T.processNode)(u,L,p),u.addNode(L));const C=Object.values(u.children).sort((L,R)=>R.selfTime-L.selfTime).slice(0,s),v=[];for(const L of C){const R={selfTime:Math.round(L.selfTime/1e3),totalTime:Math.round(L.aggregateTime/1e3),location:o(L.callFrame),absLocation:m(L.callFrame),url:L.callFrame.url,caller:[],percentage:Math.round(L.selfTime/(p.duration/100)),isSpecial:f(L.callFrame)},N=[L];for(;N.length;){const x=N.pop();let $;for(const M of Object.values(x.children))(!$||$.selfTime<M.selfTime)&&($=M);if($){const M=Math.round($.selfTime/(x.selfTime/100));R.caller.push({percentage:M,location:o($.callFrame),absLocation:m($.callFrame)}),N.push($)}}v.push(R)}return v}})}).call(this);

//# sourceMappingURL=https://main.vscode-cdn.net/sourcemaps/532bdf24071d0a26ceea0844dcdf5ee8cfabd562/core/vs/platform/profiling/electron-sandbox/profileAnalysisWorker.js.map
