/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var he=["require","exports","vs/base/common/lifecycle","vs/base/common/platform","vs/base/common/event","vs/base/common/path","vs/base/common/uri","vs/base/common/errors","vs/nls","vs/platform/log/common/log","vs/base/common/types","vs/base/common/strings","vs/base/common/async","vs/base/common/charCode","vs/base/common/decorators","vs/base/common/process","vs/platform/terminal/common/terminal","vs/base/common/arrays","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/network","os","vs/platform/instantiation/common/instantiation","vs/platform/terminal/common/capabilities/capabilities","vs/base/common/lazy","vs/base/common/resources","vs/base/common/map","vs/base/common/marshallingIds","vs/base/node/pfs","child_process","vs/base/parts/ipc/common/ipc","vs/base/common/functional","vs/base/common/objects","vs/base/parts/sandbox/node/electronTypes","vs/nls.messages","vs/base/common/extpath","vs/base/common/processes","fs","vs/base/node/processes","vs/platform/contextkey/common/contextkey","vs/platform/terminal/common/environmentVariable","vs/platform/terminal/common/terminalEnvironment","vs/platform/terminal/node/childProcessMonitor","vs/platform/terminal/node/terminalEnvironment","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/assert","vs/base/common/iterator","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/stopwatch","vs/base/common/cache","vs/base/common/stream","vs/base/common/symbols","vs/base/common/uint","vs/base/common/hash","vs/base/common/ternarySearchTree","vs/base/common/uuid","vs/base/common/date","vs/base/common/errorMessage","vs/base/common/console","vs/base/common/marshalling","vs/base/common/uriIpc","vs/base/node/powershell","vs/base/node/ps","vs/base/node/shell","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/ipc/node/ipc.mp","vs/platform/contextkey/common/scanner","vs/platform/environment/common/environmentService","vs/platform/environment/node/argv","vs/platform/environment/node/userDataPath","path","vs/platform/environment/node/environmentService","vs/platform/files/common/files","vs/platform/log/common/logIpc","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/log/node/loggerService","vs/platform/product/common/product","vs/platform/product/common/productService","vs/platform/registry/common/platform","vs/platform/terminal/common/capabilities/bufferMarkCapability","vs/platform/terminal/common/capabilities/commandDetection/promptInputModel","vs/platform/terminal/common/capabilities/commandDetection/terminalCommand","vs/platform/terminal/common/capabilities/commandDetectionCapability","vs/platform/terminal/common/capabilities/cwdDetectionCapability","vs/platform/terminal/common/capabilities/partialCommandDetectionCapability","vs/platform/terminal/common/capabilities/terminalCapabilityStore","vs/platform/terminal/common/environmentVariableCollection","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/requestStore","vs/platform/terminal/common/terminalAutoResponder","vs/platform/terminal/common/terminalDataBuffering","vs/platform/terminal/common/terminalProcess","vs/platform/terminal/common/terminalStrings","vs/platform/terminal/common/xterm/shellIntegrationAddon","vs/platform/terminal/node/heartbeatService","vs/platform/terminal/node/windowsShellHelper","vs/platform/terminal/node/terminalProcess","vs/platform/terminal/node/ptyService","util","minimist","node-pty","vs/base/common/performance","@xterm/headless","vs/platform/terminal/node/ptyHostMain"],fe=function(ie){for(var e=[],o=0,t=ie.length;o<t;o++)e[o]=he[ie[o]];return e};define(he[44],fe([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MonotonousArray=void 0,e.findLast=o,e.findLastIdx=t,e.findLastMonotonous=L,e.findLastIdxMonotonous=m,e.findFirstMonotonous=W,e.findFirstIdxMonotonousOrArrLen=P,e.findFirstIdxMonotonous=_,e.findFirstMax=b,e.findLastMax=h,e.findFirstMin=g,e.findMaxIdx=l,e.mapFindFirst=u;function o(a,d){const p=t(a,d);if(p!==-1)return a[p]}function t(a,d,p=a.length-1){for(let r=p;r>=0;r--){const y=a[r];if(d(y))return r}return-1}function L(a,d){const p=m(a,d);return p===-1?void 0:a[p]}function m(a,d,p=0,r=a.length){let y=p,w=r;for(;y<w;){const C=Math.floor((y+w)/2);d(a[C])?y=C+1:w=C}return y-1}function W(a,d){const p=P(a,d);return p===a.length?void 0:a[p]}function P(a,d,p=0,r=a.length){let y=p,w=r;for(;y<w;){const C=Math.floor((y+w)/2);d(a[C])?w=C:y=C+1}return y}function _(a,d,p=0,r=a.length){const y=P(a,d,p,r);return y===a.length?-1:y}class s{static{this.assertInvariants=!1}constructor(d){this._array=d,this._findLastMonotonousLastIdx=0}findLastMonotonous(d){if(s.assertInvariants){if(this._prevFindLastPredicate){for(const r of this._array)if(this._prevFindLastPredicate(r)&&!d(r))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this._prevFindLastPredicate=d}const p=m(this._array,d,this._findLastMonotonousLastIdx);return this._findLastMonotonousLastIdx=p+1,p===-1?void 0:this._array[p]}}e.MonotonousArray=s;function b(a,d){if(a.length===0)return;let p=a[0];for(let r=1;r<a.length;r++){const y=a[r];d(y,p)>0&&(p=y)}return p}function h(a,d){if(a.length===0)return;let p=a[0];for(let r=1;r<a.length;r++){const y=a[r];d(y,p)>=0&&(p=y)}return p}function g(a,d){return b(a,(p,r)=>-d(p,r))}function l(a,d){if(a.length===0)return-1;let p=0;for(let r=1;r<a.length;r++){const y=a[r];d(y,a[p])>0&&(p=r)}return p}function u(a,d){for(const p of a){const r=d(p);if(r!==void 0)return r}}}),define(he[13],fe([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharCode=void 0;var o;(function(t){t[t.Null=0]="Null",t[t.Backspace=8]="Backspace",t[t.Tab=9]="Tab",t[t.LineFeed=10]="LineFeed",t[t.CarriageReturn=13]="CarriageReturn",t[t.Space=32]="Space",t[t.ExclamationMark=33]="ExclamationMark",t[t.DoubleQuote=34]="DoubleQuote",t[t.Hash=35]="Hash",t[t.DollarSign=36]="DollarSign",t[t.PercentSign=37]="PercentSign",t[t.Ampersand=38]="Ampersand",t[t.SingleQuote=39]="SingleQuote",t[t.OpenParen=40]="OpenParen",t[t.CloseParen=41]="CloseParen",t[t.Asterisk=42]="Asterisk",t[t.Plus=43]="Plus",t[t.Comma=44]="Comma",t[t.Dash=45]="Dash",t[t.Period=46]="Period",t[t.Slash=47]="Slash",t[t.Digit0=48]="Digit0",t[t.Digit1=49]="Digit1",t[t.Digit2=50]="Digit2",t[t.Digit3=51]="Digit3",t[t.Digit4=52]="Digit4",t[t.Digit5=53]="Digit5",t[t.Digit6=54]="Digit6",t[t.Digit7=55]="Digit7",t[t.Digit8=56]="Digit8",t[t.Digit9=57]="Digit9",t[t.Colon=58]="Colon",t[t.Semicolon=59]="Semicolon",t[t.LessThan=60]="LessThan",t[t.Equals=61]="Equals",t[t.GreaterThan=62]="GreaterThan",t[t.QuestionMark=63]="QuestionMark",t[t.AtSign=64]="AtSign",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.OpenSquareBracket=91]="OpenSquareBracket",t[t.Backslash=92]="Backslash",t[t.CloseSquareBracket=93]="CloseSquareBracket",t[t.Caret=94]="Caret",t[t.Underline=95]="Underline",t[t.BackTick=96]="BackTick",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.OpenCurlyBrace=123]="OpenCurlyBrace",t[t.Pipe=124]="Pipe",t[t.CloseCurlyBrace=125]="CloseCurlyBrace",t[t.Tilde=126]="Tilde",t[t.NoBreakSpace=160]="NoBreakSpace",t[t.U_Combining_Grave_Accent=768]="U_Combining_Grave_Accent",t[t.U_Combining_Acute_Accent=769]="U_Combining_Acute_Accent",t[t.U_Combining_Circumflex_Accent=770]="U_Combining_Circumflex_Accent",t[t.U_Combining_Tilde=771]="U_Combining_Tilde",t[t.U_Combining_Macron=772]="U_Combining_Macron",t[t.U_Combining_Overline=773]="U_Combining_Overline",t[t.U_Combining_Breve=774]="U_Combining_Breve",t[t.U_Combining_Dot_Above=775]="U_Combining_Dot_Above",t[t.U_Combining_Diaeresis=776]="U_Combining_Diaeresis",t[t.U_Combining_Hook_Above=777]="U_Combining_Hook_Above",t[t.U_Combining_Ring_Above=778]="U_Combining_Ring_Above",t[t.U_Combining_Double_Acute_Accent=779]="U_Combining_Double_Acute_Accent",t[t.U_Combining_Caron=780]="U_Combining_Caron",t[t.U_Combining_Vertical_Line_Above=781]="U_Combining_Vertical_Line_Above",t[t.U_Combining_Double_Vertical_Line_Above=782]="U_Combining_Double_Vertical_Line_Above",t[t.U_Combining_Double_Grave_Accent=783]="U_Combining_Double_Grave_Accent",t[t.U_Combining_Candrabindu=784]="U_Combining_Candrabindu",t[t.U_Combining_Inverted_Breve=785]="U_Combining_Inverted_Breve",t[t.U_Combining_Turned_Comma_Above=786]="U_Combining_Turned_Comma_Above",t[t.U_Combining_Comma_Above=787]="U_Combining_Comma_Above",t[t.U_Combining_Reversed_Comma_Above=788]="U_Combining_Reversed_Comma_Above",t[t.U_Combining_Comma_Above_Right=789]="U_Combining_Comma_Above_Right",t[t.U_Combining_Grave_Accent_Below=790]="U_Combining_Grave_Accent_Below",t[t.U_Combining_Acute_Accent_Below=791]="U_Combining_Acute_Accent_Below",t[t.U_Combining_Left_Tack_Below=792]="U_Combining_Left_Tack_Below",t[t.U_Combining_Right_Tack_Below=793]="U_Combining_Right_Tack_Below",t[t.U_Combining_Left_Angle_Above=794]="U_Combining_Left_Angle_Above",t[t.U_Combining_Horn=795]="U_Combining_Horn",t[t.U_Combining_Left_Half_Ring_Below=796]="U_Combining_Left_Half_Ring_Below",t[t.U_Combining_Up_Tack_Below=797]="U_Combining_Up_Tack_Below",t[t.U_Combining_Down_Tack_Below=798]="U_Combining_Down_Tack_Below",t[t.U_Combining_Plus_Sign_Below=799]="U_Combining_Plus_Sign_Below",t[t.U_Combining_Minus_Sign_Below=800]="U_Combining_Minus_Sign_Below",t[t.U_Combining_Palatalized_Hook_Below=801]="U_Combining_Palatalized_Hook_Below",t[t.U_Combining_Retroflex_Hook_Below=802]="U_Combining_Retroflex_Hook_Below",t[t.U_Combining_Dot_Below=803]="U_Combining_Dot_Below",t[t.U_Combining_Diaeresis_Below=804]="U_Combining_Diaeresis_Below",t[t.U_Combining_Ring_Below=805]="U_Combining_Ring_Below",t[t.U_Combining_Comma_Below=806]="U_Combining_Comma_Below",t[t.U_Combining_Cedilla=807]="U_Combining_Cedilla",t[t.U_Combining_Ogonek=808]="U_Combining_Ogonek",t[t.U_Combining_Vertical_Line_Below=809]="U_Combining_Vertical_Line_Below",t[t.U_Combining_Bridge_Below=810]="U_Combining_Bridge_Below",t[t.U_Combining_Inverted_Double_Arch_Below=811]="U_Combining_Inverted_Double_Arch_Below",t[t.U_Combining_Caron_Below=812]="U_Combining_Caron_Below",t[t.U_Combining_Circumflex_Accent_Below=813]="U_Combining_Circumflex_Accent_Below",t[t.U_Combining_Breve_Below=814]="U_Combining_Breve_Below",t[t.U_Combining_Inverted_Breve_Below=815]="U_Combining_Inverted_Breve_Below",t[t.U_Combining_Tilde_Below=816]="U_Combining_Tilde_Below",t[t.U_Combining_Macron_Below=817]="U_Combining_Macron_Below",t[t.U_Combining_Low_Line=818]="U_Combining_Low_Line",t[t.U_Combining_Double_Low_Line=819]="U_Combining_Double_Low_Line",t[t.U_Combining_Tilde_Overlay=820]="U_Combining_Tilde_Overlay",t[t.U_Combining_Short_Stroke_Overlay=821]="U_Combining_Short_Stroke_Overlay",t[t.U_Combining_Long_Stroke_Overlay=822]="U_Combining_Long_Stroke_Overlay",t[t.U_Combining_Short_Solidus_Overlay=823]="U_Combining_Short_Solidus_Overlay",t[t.U_Combining_Long_Solidus_Overlay=824]="U_Combining_Long_Solidus_Overlay",t[t.U_Combining_Right_Half_Ring_Below=825]="U_Combining_Right_Half_Ring_Below",t[t.U_Combining_Inverted_Bridge_Below=826]="U_Combining_Inverted_Bridge_Below",t[t.U_Combining_Square_Below=827]="U_Combining_Square_Below",t[t.U_Combining_Seagull_Below=828]="U_Combining_Seagull_Below",t[t.U_Combining_X_Above=829]="U_Combining_X_Above",t[t.U_Combining_Vertical_Tilde=830]="U_Combining_Vertical_Tilde",t[t.U_Combining_Double_Overline=831]="U_Combining_Double_Overline",t[t.U_Combining_Grave_Tone_Mark=832]="U_Combining_Grave_Tone_Mark",t[t.U_Combining_Acute_Tone_Mark=833]="U_Combining_Acute_Tone_Mark",t[t.U_Combining_Greek_Perispomeni=834]="U_Combining_Greek_Perispomeni",t[t.U_Combining_Greek_Koronis=835]="U_Combining_Greek_Koronis",t[t.U_Combining_Greek_Dialytika_Tonos=836]="U_Combining_Greek_Dialytika_Tonos",t[t.U_Combining_Greek_Ypogegrammeni=837]="U_Combining_Greek_Ypogegrammeni",t[t.U_Combining_Bridge_Above=838]="U_Combining_Bridge_Above",t[t.U_Combining_Equals_Sign_Below=839]="U_Combining_Equals_Sign_Below",t[t.U_Combining_Double_Vertical_Line_Below=840]="U_Combining_Double_Vertical_Line_Below",t[t.U_Combining_Left_Angle_Below=841]="U_Combining_Left_Angle_Below",t[t.U_Combining_Not_Tilde_Above=842]="U_Combining_Not_Tilde_Above",t[t.U_Combining_Homothetic_Above=843]="U_Combining_Homothetic_Above",t[t.U_Combining_Almost_Equal_To_Above=844]="U_Combining_Almost_Equal_To_Above",t[t.U_Combining_Left_Right_Arrow_Below=845]="U_Combining_Left_Right_Arrow_Below",t[t.U_Combining_Upwards_Arrow_Below=846]="U_Combining_Upwards_Arrow_Below",t[t.U_Combining_Grapheme_Joiner=847]="U_Combining_Grapheme_Joiner",t[t.U_Combining_Right_Arrowhead_Above=848]="U_Combining_Right_Arrowhead_Above",t[t.U_Combining_Left_Half_Ring_Above=849]="U_Combining_Left_Half_Ring_Above",t[t.U_Combining_Fermata=850]="U_Combining_Fermata",t[t.U_Combining_X_Below=851]="U_Combining_X_Below",t[t.U_Combining_Left_Arrowhead_Below=852]="U_Combining_Left_Arrowhead_Below",t[t.U_Combining_Right_Arrowhead_Below=853]="U_Combining_Right_Arrowhead_Below",t[t.U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below=854]="U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below",t[t.U_Combining_Right_Half_Ring_Above=855]="U_Combining_Right_Half_Ring_Above",t[t.U_Combining_Dot_Above_Right=856]="U_Combining_Dot_Above_Right",t[t.U_Combining_Asterisk_Below=857]="U_Combining_Asterisk_Below",t[t.U_Combining_Double_Ring_Below=858]="U_Combining_Double_Ring_Below",t[t.U_Combining_Zigzag_Above=859]="U_Combining_Zigzag_Above",t[t.U_Combining_Double_Breve_Below=860]="U_Combining_Double_Breve_Below",t[t.U_Combining_Double_Breve=861]="U_Combining_Double_Breve",t[t.U_Combining_Double_Macron=862]="U_Combining_Double_Macron",t[t.U_Combining_Double_Macron_Below=863]="U_Combining_Double_Macron_Below",t[t.U_Combining_Double_Tilde=864]="U_Combining_Double_Tilde",t[t.U_Combining_Double_Inverted_Breve=865]="U_Combining_Double_Inverted_Breve",t[t.U_Combining_Double_Rightwards_Arrow_Below=866]="U_Combining_Double_Rightwards_Arrow_Below",t[t.U_Combining_Latin_Small_Letter_A=867]="U_Combining_Latin_Small_Letter_A",t[t.U_Combining_Latin_Small_Letter_E=868]="U_Combining_Latin_Small_Letter_E",t[t.U_Combining_Latin_Small_Letter_I=869]="U_Combining_Latin_Small_Letter_I",t[t.U_Combining_Latin_Small_Letter_O=870]="U_Combining_Latin_Small_Letter_O",t[t.U_Combining_Latin_Small_Letter_U=871]="U_Combining_Latin_Small_Letter_U",t[t.U_Combining_Latin_Small_Letter_C=872]="U_Combining_Latin_Small_Letter_C",t[t.U_Combining_Latin_Small_Letter_D=873]="U_Combining_Latin_Small_Letter_D",t[t.U_Combining_Latin_Small_Letter_H=874]="U_Combining_Latin_Small_Letter_H",t[t.U_Combining_Latin_Small_Letter_M=875]="U_Combining_Latin_Small_Letter_M",t[t.U_Combining_Latin_Small_Letter_R=876]="U_Combining_Latin_Small_Letter_R",t[t.U_Combining_Latin_Small_Letter_T=877]="U_Combining_Latin_Small_Letter_T",t[t.U_Combining_Latin_Small_Letter_V=878]="U_Combining_Latin_Small_Letter_V",t[t.U_Combining_Latin_Small_Letter_X=879]="U_Combining_Latin_Small_Letter_X",t[t.LINE_SEPARATOR=8232]="LINE_SEPARATOR",t[t.PARAGRAPH_SEPARATOR=8233]="PARAGRAPH_SEPARATOR",t[t.NEXT_LINE=133]="NEXT_LINE",t[t.U_CIRCUMFLEX=94]="U_CIRCUMFLEX",t[t.U_GRAVE_ACCENT=96]="U_GRAVE_ACCENT",t[t.U_DIAERESIS=168]="U_DIAERESIS",t[t.U_MACRON=175]="U_MACRON",t[t.U_ACUTE_ACCENT=180]="U_ACUTE_ACCENT",t[t.U_CEDILLA=184]="U_CEDILLA",t[t.U_MODIFIER_LETTER_LEFT_ARROWHEAD=706]="U_MODIFIER_LETTER_LEFT_ARROWHEAD",t[t.U_MODIFIER_LETTER_RIGHT_ARROWHEAD=707]="U_MODIFIER_LETTER_RIGHT_ARROWHEAD",t[t.U_MODIFIER_LETTER_UP_ARROWHEAD=708]="U_MODIFIER_LETTER_UP_ARROWHEAD",t[t.U_MODIFIER_LETTER_DOWN_ARROWHEAD=709]="U_MODIFIER_LETTER_DOWN_ARROWHEAD",t[t.U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING=722]="U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING",t[t.U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING=723]="U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING",t[t.U_MODIFIER_LETTER_UP_TACK=724]="U_MODIFIER_LETTER_UP_TACK",t[t.U_MODIFIER_LETTER_DOWN_TACK=725]="U_MODIFIER_LETTER_DOWN_TACK",t[t.U_MODIFIER_LETTER_PLUS_SIGN=726]="U_MODIFIER_LETTER_PLUS_SIGN",t[t.U_MODIFIER_LETTER_MINUS_SIGN=727]="U_MODIFIER_LETTER_MINUS_SIGN",t[t.U_BREVE=728]="U_BREVE",t[t.U_DOT_ABOVE=729]="U_DOT_ABOVE",t[t.U_RING_ABOVE=730]="U_RING_ABOVE",t[t.U_OGONEK=731]="U_OGONEK",t[t.U_SMALL_TILDE=732]="U_SMALL_TILDE",t[t.U_DOUBLE_ACUTE_ACCENT=733]="U_DOUBLE_ACUTE_ACCENT",t[t.U_MODIFIER_LETTER_RHOTIC_HOOK=734]="U_MODIFIER_LETTER_RHOTIC_HOOK",t[t.U_MODIFIER_LETTER_CROSS_ACCENT=735]="U_MODIFIER_LETTER_CROSS_ACCENT",t[t.U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR=741]="U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR",t[t.U_MODIFIER_LETTER_HIGH_TONE_BAR=742]="U_MODIFIER_LETTER_HIGH_TONE_BAR",t[t.U_MODIFIER_LETTER_MID_TONE_BAR=743]="U_MODIFIER_LETTER_MID_TONE_BAR",t[t.U_MODIFIER_LETTER_LOW_TONE_BAR=744]="U_MODIFIER_LETTER_LOW_TONE_BAR",t[t.U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR=745]="U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR",t[t.U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK=746]="U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK",t[t.U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK=747]="U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK",t[t.U_MODIFIER_LETTER_UNASPIRATED=749]="U_MODIFIER_LETTER_UNASPIRATED",t[t.U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD=751]="U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD",t[t.U_MODIFIER_LETTER_LOW_UP_ARROWHEAD=752]="U_MODIFIER_LETTER_LOW_UP_ARROWHEAD",t[t.U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD=753]="U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD",t[t.U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD=754]="U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD",t[t.U_MODIFIER_LETTER_LOW_RING=755]="U_MODIFIER_LETTER_LOW_RING",t[t.U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT=756]="U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT",t[t.U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT=757]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT",t[t.U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT=758]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT",t[t.U_MODIFIER_LETTER_LOW_TILDE=759]="U_MODIFIER_LETTER_LOW_TILDE",t[t.U_MODIFIER_LETTER_RAISED_COLON=760]="U_MODIFIER_LETTER_RAISED_COLON",t[t.U_MODIFIER_LETTER_BEGIN_HIGH_TONE=761]="U_MODIFIER_LETTER_BEGIN_HIGH_TONE",t[t.U_MODIFIER_LETTER_END_HIGH_TONE=762]="U_MODIFIER_LETTER_END_HIGH_TONE",t[t.U_MODIFIER_LETTER_BEGIN_LOW_TONE=763]="U_MODIFIER_LETTER_BEGIN_LOW_TONE",t[t.U_MODIFIER_LETTER_END_LOW_TONE=764]="U_MODIFIER_LETTER_END_LOW_TONE",t[t.U_MODIFIER_LETTER_SHELF=765]="U_MODIFIER_LETTER_SHELF",t[t.U_MODIFIER_LETTER_OPEN_SHELF=766]="U_MODIFIER_LETTER_OPEN_SHELF",t[t.U_MODIFIER_LETTER_LOW_LEFT_ARROW=767]="U_MODIFIER_LETTER_LOW_LEFT_ARROW",t[t.U_GREEK_LOWER_NUMERAL_SIGN=885]="U_GREEK_LOWER_NUMERAL_SIGN",t[t.U_GREEK_TONOS=900]="U_GREEK_TONOS",t[t.U_GREEK_DIALYTIKA_TONOS=901]="U_GREEK_DIALYTIKA_TONOS",t[t.U_GREEK_KORONIS=8125]="U_GREEK_KORONIS",t[t.U_GREEK_PSILI=8127]="U_GREEK_PSILI",t[t.U_GREEK_PERISPOMENI=8128]="U_GREEK_PERISPOMENI",t[t.U_GREEK_DIALYTIKA_AND_PERISPOMENI=8129]="U_GREEK_DIALYTIKA_AND_PERISPOMENI",t[t.U_GREEK_PSILI_AND_VARIA=8141]="U_GREEK_PSILI_AND_VARIA",t[t.U_GREEK_PSILI_AND_OXIA=8142]="U_GREEK_PSILI_AND_OXIA",t[t.U_GREEK_PSILI_AND_PERISPOMENI=8143]="U_GREEK_PSILI_AND_PERISPOMENI",t[t.U_GREEK_DASIA_AND_VARIA=8157]="U_GREEK_DASIA_AND_VARIA",t[t.U_GREEK_DASIA_AND_OXIA=8158]="U_GREEK_DASIA_AND_OXIA",t[t.U_GREEK_DASIA_AND_PERISPOMENI=8159]="U_GREEK_DASIA_AND_PERISPOMENI",t[t.U_GREEK_DIALYTIKA_AND_VARIA=8173]="U_GREEK_DIALYTIKA_AND_VARIA",t[t.U_GREEK_DIALYTIKA_AND_OXIA=8174]="U_GREEK_DIALYTIKA_AND_OXIA",t[t.U_GREEK_VARIA=8175]="U_GREEK_VARIA",t[t.U_GREEK_OXIA=8189]="U_GREEK_OXIA",t[t.U_GREEK_DASIA=8190]="U_GREEK_DASIA",t[t.U_IDEOGRAPHIC_FULL_STOP=12290]="U_IDEOGRAPHIC_FULL_STOP",t[t.U_LEFT_CORNER_BRACKET=12300]="U_LEFT_CORNER_BRACKET",t[t.U_RIGHT_CORNER_BRACKET=12301]="U_RIGHT_CORNER_BRACKET",t[t.U_LEFT_BLACK_LENTICULAR_BRACKET=12304]="U_LEFT_BLACK_LENTICULAR_BRACKET",t[t.U_RIGHT_BLACK_LENTICULAR_BRACKET=12305]="U_RIGHT_BLACK_LENTICULAR_BRACKET",t[t.U_OVERLINE=8254]="U_OVERLINE",t[t.UTF8_BOM=65279]="UTF8_BOM",t[t.U_FULLWIDTH_SEMICOLON=65307]="U_FULLWIDTH_SEMICOLON",t[t.U_FULLWIDTH_COMMA=65292]="U_FULLWIDTH_COMMA"})(o||(e.CharCode=o={}))}),define(he[45],fe([0,1]),function(ie,e){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.SetWithKey=void 0,e.groupBy=t,e.diffSets=L,e.diffMaps=m,e.intersection=W;function t(_,s){const b=Object.create(null);for(const h of _){const g=s(h);let l=b[g];l||(l=b[g]=[]),l.push(h)}return b}function L(_,s){const b=[],h=[];for(const g of _)s.has(g)||b.push(g);for(const g of s)_.has(g)||h.push(g);return{removed:b,added:h}}function m(_,s){const b=[],h=[];for(const[g,l]of _)s.has(g)||b.push(l);for(const[g,l]of s)_.has(g)||h.push(l);return{removed:b,added:h}}function W(_,s){const b=new Set;for(const h of s)_.has(h)&&b.add(h);return b}class P{static{o=Symbol.toStringTag}constructor(s,b){this.toKey=b,this._map=new Map,this[o]="SetWithKey";for(const h of s)this.add(h)}get size(){return this._map.size}add(s){const b=this.toKey(s);return this._map.set(b,s),this}delete(s){return this._map.delete(this.toKey(s))}has(s){return this._map.has(this.toKey(s))}*entries(){for(const s of this._map.values())yield[s,s]}keys(){return this.values()}*values(){for(const s of this._map.values())yield s}clear(){this._map.clear()}forEach(s,b){this._map.forEach(h=>s.call(b,h,h,this))}[Symbol.iterator](){return this.values()}}e.SetWithKey=P}),define(he[14],fe([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.memoize=t,e.debounce=L,e.throttle=m;function o(W){return(P,_,s)=>{let b=null,h=null;if(typeof s.value=="function"?(b="value",h=s.value):typeof s.get=="function"&&(b="get",h=s.get),!h)throw new Error("not supported");s[b]=W(h,_)}}function t(W,P,_){let s=null,b=null;if(typeof _.value=="function"?(s="value",b=_.value,b.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof _.get=="function"&&(s="get",b=_.get),!b)throw new Error("not supported");const h=`$memoize$${P}`;_[s]=function(...g){return this.hasOwnProperty(h)||Object.defineProperty(this,h,{configurable:!1,enumerable:!1,writable:!1,value:b.apply(this,g)}),this[h]}}function L(W,P,_){return o((s,b)=>{const h=`$debounce$${b}`,g=`$debounce$result$${b}`;return function(...l){this[g]||(this[g]=_?_():void 0),clearTimeout(this[h]),P&&(this[g]=P(this[g],...l),l=[this[g]]),this[h]=setTimeout(()=>{s.apply(this,l),this[g]=_?_():void 0},W)}})}function m(W,P,_){return o((s,b)=>{const h=`$throttle$timer$${b}`,g=`$throttle$result$${b}`,l=`$throttle$lastRun$${b}`,u=`$throttle$pending$${b}`;return function(...a){if(this[g]||(this[g]=_?_():void 0),(this[l]===null||this[l]===void 0)&&(this[l]=-Number.MAX_VALUE),P&&(this[g]=P(this[g],...a)),this[u])return;const d=this[l]+W;d<=Date.now()?(this[l]=Date.now(),s.apply(this,[this[g]]),this[g]=_?_():void 0):(this[u]=!0,this[h]=setTimeout(()=>{this[u]=!1,this[l]=Date.now(),s.apply(this,[this[g]]),this[g]=_?_():void 0},d-Date.now()))}})}}),define(he[7],fe([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.ReadonlyError=e.CancellationError=e.errorHandler=e.ErrorHandler=void 0,e.setUnexpectedErrorHandler=t,e.isSigPipeError=L,e.onUnexpectedError=m,e.onUnexpectedExternalError=W,e.transformErrorForSerialization=P,e.transformErrorFromSerialization=_,e.isCancellationError=b,e.canceled=g,e.illegalArgument=l,e.illegalState=u,e.getErrorMessage=d;class o{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(n){setTimeout(()=>{throw n.stack?w.isErrorNoTelemetry(n)?new w(n.message+`

`+n.stack):new Error(n.message+`

`+n.stack):n},0)}}addListener(n){return this.listeners.push(n),()=>{this._removeListener(n)}}emit(n){this.listeners.forEach(f=>{f(n)})}_removeListener(n){this.listeners.splice(this.listeners.indexOf(n),1)}setUnexpectedErrorHandler(n){this.unexpectedErrorHandler=n}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(n){this.unexpectedErrorHandler(n),this.emit(n)}onUnexpectedExternalError(n){this.unexpectedErrorHandler(n)}}e.ErrorHandler=o,e.errorHandler=new o;function t(i){e.errorHandler.setUnexpectedErrorHandler(i)}function L(i){if(!i||typeof i!="object")return!1;const n=i;return n.code==="EPIPE"&&n.syscall?.toUpperCase()==="WRITE"}function m(i){b(i)||e.errorHandler.onUnexpectedError(i)}function W(i){b(i)||e.errorHandler.onUnexpectedExternalError(i)}function P(i){if(i instanceof Error){const{name:n,message:f}=i,R=i.stacktrace||i.stack;return{$isError:!0,name:n,message:f,stack:R,noTelemetry:w.isErrorNoTelemetry(i)}}return i}function _(i){let n;return i.noTelemetry?n=new w:(n=new Error,n.name=i.name),n.message=i.message,n.stack=i.stack,n}const s="Canceled";function b(i){return i instanceof h?!0:i instanceof Error&&i.name===s&&i.message===s}class h extends Error{constructor(){super(s),this.name=this.message}}e.CancellationError=h;function g(){const i=new Error(s);return i.name=i.message,i}function l(i){return i?new Error(`Illegal argument: ${i}`):new Error("Illegal argument")}function u(i){return i?new Error(`Illegal state: ${i}`):new Error("Illegal state")}class a extends TypeError{constructor(n){super(n?`${n} is read-only and cannot be changed`:"Cannot change read-only property")}}e.ReadonlyError=a;function d(i){return i?i.message?i.message:i.stack?i.stack.split(`
`)[0]:String(i):"Error"}class p extends Error{constructor(n){super("NotImplemented"),n&&(this.message=n)}}e.NotImplementedError=p;class r extends Error{constructor(n){super("NotSupported"),n&&(this.message=n)}}e.NotSupportedError=r;class y extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.ExpectedError=y;class w extends Error{constructor(n){super(n),this.name="CodeExpectedError"}static fromError(n){if(n instanceof w)return n;const f=new w;return f.message=n.message,f.stack=n.stack,f}static isErrorNoTelemetry(n){return n.name==="CodeExpectedError"}}e.ErrorNoTelemetry=w;class C extends Error{constructor(n){super(n||"An unexpected bug occurred."),Object.setPrototypeOf(this,C.prototype)}}e.BugIndicatingError=C}),define(he[17],fe([0,1,7,44]),function(ie,e,o,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Permutation=e.CallbackIterable=e.ArrayQueue=e.booleanComparator=e.numberComparator=e.CompareResult=void 0,e.tail=L,e.tail2=m,e.equals=W,e.removeFastWithoutKeepingOrder=P,e.binarySearch=_,e.binarySearch2=s,e.quickSelect=b,e.groupBy=h,e.groupAdjacentBy=g,e.forEachAdjacent=l,e.forEachWithNeighbors=u,e.sortedDiff=a,e.delta=d,e.top=p,e.topAsync=r,e.coalesce=w,e.coalesceInPlace=C,e.move=i,e.isFalsyOrEmpty=n,e.isNonEmptyArray=f,e.distinct=R,e.uniqueFilter=x,e.firstOrDefault=v,e.lastOrDefault=S,e.commonPrefixLength=T,e.range=O,e.index=F,e.insert=D,e.remove=E,e.arrayInsert=M,e.shuffle=A,e.pushToStart=I,e.pushToEnd=B,e.pushMany=Y,e.mapArrayOrNot=G,e.asArray=Z,e.getRandomElement=se,e.insertInto=le,e.splice=V,e.compareBy=ee,e.tieBreakComparators=ue,e.reverseOrder=de,e.findAsync=oe;function L(N,K=0){return N[N.length-(1+K)]}function m(N){if(N.length===0)throw new Error("Invalid tail call");return[N.slice(0,N.length-1),N[N.length-1]]}function W(N,K,U=(k,H)=>k===H){if(N===K)return!0;if(!N||!K||N.length!==K.length)return!1;for(let k=0,H=N.length;k<H;k++)if(!U(N[k],K[k]))return!1;return!0}function P(N,K){const U=N.length-1;K<U&&(N[K]=N[U]),N.pop()}function _(N,K,U){return s(N.length,k=>U(N[k],K))}function s(N,K){let U=0,k=N-1;for(;U<=k;){const H=(U+k)/2|0,J=K(H);if(J<0)U=H+1;else if(J>0)k=H-1;else return H}return-(U+1)}function b(N,K,U){if(N=N|0,N>=K.length)throw new TypeError("invalid index");const k=K[Math.floor(K.length*Math.random())],H=[],J=[],ne=[];for(const _e of K){const we=U(_e,k);we<0?H.push(_e):we>0?J.push(_e):ne.push(_e)}return N<H.length?b(N,H,U):N<H.length+ne.length?ne[0]:b(N-(H.length+ne.length),J,U)}function h(N,K){const U=[];let k;for(const H of N.slice(0).sort(K))!k||K(k[0],H)!==0?(k=[H],U.push(k)):k.push(H);return U}function*g(N,K){let U,k;for(const H of N)k!==void 0&&K(k,H)?U.push(H):(U&&(yield U),U=[H]),k=H;U&&(yield U)}function l(N,K){for(let U=0;U<=N.length;U++)K(U===0?void 0:N[U-1],U===N.length?void 0:N[U])}function u(N,K){for(let U=0;U<N.length;U++)K(U===0?void 0:N[U-1],N[U],U+1===N.length?void 0:N[U+1])}function a(N,K,U){const k=[];function H(_e,we,Ie){if(we===0&&Ie.length===0)return;const Ae=k[k.length-1];Ae&&Ae.start+Ae.deleteCount===_e?(Ae.deleteCount+=we,Ae.toInsert.push(...Ie)):k.push({start:_e,deleteCount:we,toInsert:Ie})}let J=0,ne=0;for(;;){if(J===N.length){H(J,0,K.slice(ne));break}if(ne===K.length){H(J,N.length-J,[]);break}const _e=N[J],we=K[ne],Ie=U(_e,we);Ie===0?(J+=1,ne+=1):Ie<0?(H(J,1,[]),J+=1):Ie>0&&(H(J,0,[we]),ne+=1)}return k}function d(N,K,U){const k=a(N,K,U),H=[],J=[];for(const ne of k)H.push(...N.slice(ne.start,ne.start+ne.deleteCount)),J.push(...ne.toInsert);return{removed:H,added:J}}function p(N,K,U){if(U===0)return[];const k=N.slice(0,U).sort(K);return y(N,K,k,U,N.length),k}function r(N,K,U,k,H){return U===0?Promise.resolve([]):new Promise((J,ne)=>{(async()=>{const _e=N.length,we=N.slice(0,U).sort(K);for(let Ie=U,Ae=Math.min(U+k,_e);Ie<_e;Ie=Ae,Ae=Math.min(Ae+k,_e)){if(Ie>U&&await new Promise(ye=>setTimeout(ye)),H&&H.isCancellationRequested)throw new o.CancellationError;y(N,K,we,Ie,Ae)}return we})().then(J,ne)})}function y(N,K,U,k,H){for(const J=U.length;k<H;k++){const ne=N[k];if(K(ne,U[J-1])<0){U.pop();const _e=(0,t.findFirstIdxMonotonousOrArrLen)(U,we=>K(ne,we)<0);U.splice(_e,0,ne)}}}function w(N){return N.filter(K=>!!K)}function C(N){let K=0;for(let U=0;U<N.length;U++)N[U]&&(N[K]=N[U],K+=1);N.length=K}function i(N,K,U){N.splice(U,0,N.splice(K,1)[0])}function n(N){return!Array.isArray(N)||N.length===0}function f(N){return Array.isArray(N)&&N.length>0}function R(N,K=U=>U){const U=new Set;return N.filter(k=>{const H=K(k);return U.has(H)?!1:(U.add(H),!0)})}function x(N){const K=new Set;return U=>{const k=N(U);return K.has(k)?!1:(K.add(k),!0)}}function v(N,K){return N.length>0?N[0]:K}function S(N,K){return N.length>0?N[N.length-1]:K}function T(N,K,U=(k,H)=>k===H){let k=0;for(let H=0,J=Math.min(N.length,K.length);H<J&&U(N[H],K[H]);H++)k++;return k}function O(N,K){let U=typeof K=="number"?N:0;typeof K=="number"?U=N:(U=0,K=N);const k=[];if(U<=K)for(let H=U;H<K;H++)k.push(H);else for(let H=U;H>K;H--)k.push(H);return k}function F(N,K,U){return N.reduce((k,H)=>(k[K(H)]=U?U(H):H,k),Object.create(null))}function D(N,K){return N.push(K),()=>E(N,K)}function E(N,K){const U=N.indexOf(K);if(U>-1)return N.splice(U,1),K}function M(N,K,U){const k=N.slice(0,K),H=N.slice(K);return k.concat(U,H)}function A(N,K){let U;if(typeof K=="number"){let k=K;U=()=>{const H=Math.sin(k++)*179426549;return H-Math.floor(H)}}else U=Math.random;for(let k=N.length-1;k>0;k-=1){const H=Math.floor(U()*(k+1)),J=N[k];N[k]=N[H],N[H]=J}}function I(N,K){const U=N.indexOf(K);U>-1&&(N.splice(U,1),N.unshift(K))}function B(N,K){const U=N.indexOf(K);U>-1&&(N.splice(U,1),N.push(K))}function Y(N,K){for(const U of K)N.push(U)}function G(N,K){return Array.isArray(N)?N.map(K):K(N)}function Z(N){return Array.isArray(N)?N:[N]}function se(N){return N[Math.floor(Math.random()*N.length)]}function le(N,K,U){const k=z(N,K),H=N.length,J=U.length;N.length=H+J;for(let ne=H-1;ne>=k;ne--)N[ne+J]=N[ne];for(let ne=0;ne<J;ne++)N[ne+k]=U[ne]}function V(N,K,U,k){const H=z(N,K);let J=N.splice(H,U);return J===void 0&&(J=[]),le(N,H,k),J}function z(N,K){return K<0?Math.max(K+N.length,0):Math.min(K,N.length)}var Q;(function(N){function K(J){return J<0}N.isLessThan=K;function U(J){return J<=0}N.isLessThanOrEqual=U;function k(J){return J>0}N.isGreaterThan=k;function H(J){return J===0}N.isNeitherLessOrGreaterThan=H,N.greaterThan=1,N.lessThan=-1,N.neitherLessOrGreaterThan=0})(Q||(e.CompareResult=Q={}));function ee(N,K){return(U,k)=>K(N(U),N(k))}function ue(...N){return(K,U)=>{for(const k of N){const H=k(K,U);if(!Q.isNeitherLessOrGreaterThan(H))return H}return Q.neitherLessOrGreaterThan}}const $=(N,K)=>N-K;e.numberComparator=$;const ae=(N,K)=>(0,e.numberComparator)(N?1:0,K?1:0);e.booleanComparator=ae;function de(N){return(K,U)=>-N(K,U)}class te{constructor(K){this.items=K,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(K){let U=this.firstIdx;for(;U<this.items.length&&K(this.items[U]);)U++;const k=U===this.firstIdx?null:this.items.slice(this.firstIdx,U);return this.firstIdx=U,k}takeFromEndWhile(K){let U=this.lastIdx;for(;U>=0&&K(this.items[U]);)U--;const k=U===this.lastIdx?null:this.items.slice(U+1,this.lastIdx+1);return this.lastIdx=U,k}peek(){if(this.length!==0)return this.items[this.firstIdx]}peekLast(){if(this.length!==0)return this.items[this.lastIdx]}dequeue(){const K=this.items[this.firstIdx];return this.firstIdx++,K}removeLast(){const K=this.items[this.lastIdx];return this.lastIdx--,K}takeCount(K){const U=this.items.slice(this.firstIdx,this.firstIdx+K);return this.firstIdx+=K,U}}e.ArrayQueue=te;class c{static{this.empty=new c(K=>{})}constructor(K){this.iterate=K}forEach(K){this.iterate(U=>(K(U),!0))}toArray(){const K=[];return this.iterate(U=>(K.push(U),!0)),K}filter(K){return new c(U=>this.iterate(k=>K(k)?U(k):!0))}map(K){return new c(U=>this.iterate(k=>U(K(k))))}some(K){let U=!1;return this.iterate(k=>(U=K(k),!U)),U}findFirst(K){let U;return this.iterate(k=>K(k)?(U=k,!1):!0),U}findLast(K){let U;return this.iterate(k=>(K(k)&&(U=k),!0)),U}findLastMaxBy(K){let U,k=!0;return this.iterate(H=>((k||Q.isGreaterThan(K(H,U)))&&(k=!1,U=H),!0)),U}}e.CallbackIterable=c;class j{constructor(K){this._indexMap=K}static createSortPermutation(K,U){const k=Array.from(K.keys()).sort((H,J)=>U(K[H],K[J]));return new j(k)}apply(K){return K.map((U,k)=>K[this._indexMap[k]])}inverse(){const K=this._indexMap.slice();for(let U=0;U<this._indexMap.length;U++)K[this._indexMap[U]]=U;return new j(K)}}e.Permutation=j;async function oe(N,K){return(await Promise.all(N.map(async(k,H)=>({element:k,ok:await K(k,H)})))).find(k=>k.ok)?.element}}),define(he[46],fe([0,1,7]),function(ie,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=t,e.assertNever=L,e.assert=m,e.softAssert=W,e.assertFn=P,e.checkAdjacentItems=_;function t(s,b){if(!s)throw new Error(b?`Assertion failed (${b})`:"Assertion Failed")}function L(s,b="Unreachable"){throw new Error(b)}function m(s,b="unexpected state"){if(!s)throw new o.BugIndicatingError(`Assertion Failed: ${b}`)}function W(s){s||(0,o.onUnexpectedError)(new o.BugIndicatingError("Soft Assertion Failed"))}function P(s){if(!s()){debugger;s(),(0,o.onUnexpectedError)(new o.BugIndicatingError("Assertion Failed"))}}function _(s,b){let h=0;for(;h<s.length-1;){const g=s[h],l=s[h+1];if(!b(g,l))return!1;h++}return!0}}),define(he[31],fe([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createSingleCallFunction=o;function o(t,L){const m=this;let W=!1,P;return function(){if(W)return P;if(W=!0,L)try{P=t.apply(m,arguments)}finally{L()}else P=t.apply(m,arguments);return P}}}),define(he[47],fe([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var o;(function(t){function L(n){return n&&typeof n=="object"&&typeof n[Symbol.iterator]=="function"}t.is=L;const m=Object.freeze([]);function W(){return m}t.empty=W;function*P(n){yield n}t.single=P;function _(n){return L(n)?n:P(n)}t.wrap=_;function s(n){return n||m}t.from=s;function*b(n){for(let f=n.length-1;f>=0;f--)yield n[f]}t.reverse=b;function h(n){return!n||n[Symbol.iterator]().next().done===!0}t.isEmpty=h;function g(n){return n[Symbol.iterator]().next().value}t.first=g;function l(n,f){let R=0;for(const x of n)if(f(x,R++))return!0;return!1}t.some=l;function u(n,f){for(const R of n)if(f(R))return R}t.find=u;function*a(n,f){for(const R of n)f(R)&&(yield R)}t.filter=a;function*d(n,f){let R=0;for(const x of n)yield f(x,R++)}t.map=d;function*p(n,f){let R=0;for(const x of n)yield*f(x,R++)}t.flatMap=p;function*r(...n){for(const f of n)yield*f}t.concat=r;function y(n,f,R){let x=R;for(const v of n)x=f(x,v);return x}t.reduce=y;function*w(n,f,R=n.length){for(f<0&&(f+=n.length),R<0?R+=n.length:R>n.length&&(R=n.length);f<R;f++)yield n[f]}t.slice=w;function C(n,f=Number.POSITIVE_INFINITY){const R=[];if(f===0)return[R,n];const x=n[Symbol.iterator]();for(let v=0;v<f;v++){const S=x.next();if(S.done)return[R,t.empty()];R.push(S.value)}return[R,{[Symbol.iterator](){return x}}]}t.consume=C;async function i(n){const f=[];for await(const R of n)f.push(R);return Promise.resolve(f)}t.asyncToArray=i})(o||(e.Iterable=o={}))}),define(he[24],fe([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class o{constructor(L){this.executor=L,this._didRun=!1}get hasValue(){return this._didRun}get value(){if(!this._didRun)try{this._value=this.executor()}catch(L){this._error=L}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}}e.Lazy=o}),define(he[48],fe([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class o{static{this.Undefined=new o(void 0)}constructor(m){this.element=m,this.next=o.Undefined,this.prev=o.Undefined}}class t{constructor(){this._first=o.Undefined,this._last=o.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===o.Undefined}clear(){let m=this._first;for(;m!==o.Undefined;){const W=m.next;m.prev=o.Undefined,m.next=o.Undefined,m=W}this._first=o.Undefined,this._last=o.Undefined,this._size=0}unshift(m){return this._insert(m,!1)}push(m){return this._insert(m,!0)}_insert(m,W){const P=new o(m);if(this._first===o.Undefined)this._first=P,this._last=P;else if(W){const s=this._last;this._last=P,P.prev=s,s.next=P}else{const s=this._first;this._first=P,P.next=s,s.prev=P}this._size+=1;let _=!1;return()=>{_||(_=!0,this._remove(P))}}shift(){if(this._first!==o.Undefined){const m=this._first.element;return this._remove(this._first),m}}pop(){if(this._last!==o.Undefined){const m=this._last.element;return this._remove(this._last),m}}_remove(m){if(m.prev!==o.Undefined&&m.next!==o.Undefined){const W=m.prev;W.next=m.next,m.next.prev=W}else m.prev===o.Undefined&&m.next===o.Undefined?(this._first=o.Undefined,this._last=o.Undefined):m.next===o.Undefined?(this._last=this._last.prev,this._last.next=o.Undefined):m.prev===o.Undefined&&(this._first=this._first.next,this._first.prev=o.Undefined);this._size-=1}*[Symbol.iterator](){let m=this._first;for(;m!==o.Undefined;)yield m.element,m=m.next}}e.LinkedList=t}),define(he[26],fe([0,1]),function(ie,e){"use strict";var o,t,L;Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.BidirectionalMap=e.CounterSet=e.MRUCache=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=void 0,e.getOrSet=m,e.mapToString=W,e.setToString=P,e.mapsStrictEqualIgnoreOrder=w;function m(C,i,n){let f=C.get(i);return f===void 0&&(f=n,C.set(i,f)),f}function W(C){const i=[];return C.forEach((n,f)=>{i.push(`${f} => ${n}`)}),`Map(${C.size}) {${i.join(", ")}}`}function P(C){const i=[];return C.forEach(n=>{i.push(n)}),`Set(${C.size}) {${i.join(", ")}}`}class _{constructor(i,n){this.uri=i,this.value=n}}function s(C){return Array.isArray(C)}class b{static{this.defaultToKey=i=>i.toString()}constructor(i,n){if(this[o]="ResourceMap",i instanceof b)this.map=new Map(i.map),this.toKey=n??b.defaultToKey;else if(s(i)){this.map=new Map,this.toKey=n??b.defaultToKey;for(const[f,R]of i)this.set(f,R)}else this.map=new Map,this.toKey=i??b.defaultToKey}set(i,n){return this.map.set(this.toKey(i),new _(i,n)),this}get(i){return this.map.get(this.toKey(i))?.value}has(i){return this.map.has(this.toKey(i))}get size(){return this.map.size}clear(){this.map.clear()}delete(i){return this.map.delete(this.toKey(i))}forEach(i,n){typeof n<"u"&&(i=i.bind(n));for(const[f,R]of this.map)i(R.value,R.uri,this)}*values(){for(const i of this.map.values())yield i.value}*keys(){for(const i of this.map.values())yield i.uri}*entries(){for(const i of this.map.values())yield[i.uri,i.value]}*[(o=Symbol.toStringTag,Symbol.iterator)](){for(const[,i]of this.map)yield[i.uri,i.value]}}e.ResourceMap=b;class h{constructor(i,n){this[t]="ResourceSet",!i||typeof i=="function"?this._map=new b(i):(this._map=new b(n),i.forEach(this.add,this))}get size(){return this._map.size}add(i){return this._map.set(i,i),this}clear(){this._map.clear()}delete(i){return this._map.delete(i)}forEach(i,n){this._map.forEach((f,R)=>i.call(n,R,R,this))}has(i){return this._map.has(i)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(t=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=h;var g;(function(C){C[C.None=0]="None",C[C.AsOld=1]="AsOld",C[C.AsNew=2]="AsNew"})(g||(e.Touch=g={}));class l{constructor(){this[L]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(i){return this._map.has(i)}get(i,n=g.None){const f=this._map.get(i);if(f)return n!==g.None&&this.touch(f,n),f.value}set(i,n,f=g.None){let R=this._map.get(i);if(R)R.value=n,f!==g.None&&this.touch(R,f);else{switch(R={key:i,value:n,next:void 0,previous:void 0},f){case g.None:this.addItemLast(R);break;case g.AsOld:this.addItemFirst(R);break;case g.AsNew:this.addItemLast(R);break;default:this.addItemLast(R);break}this._map.set(i,R),this._size++}return this}delete(i){return!!this.remove(i)}remove(i){const n=this._map.get(i);if(n)return this._map.delete(i),this.removeItem(n),this._size--,n.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const i=this._head;return this._map.delete(i.key),this.removeItem(i),this._size--,i.value}forEach(i,n){const f=this._state;let R=this._head;for(;R;){if(n?i.bind(n)(R.value,R.key,this):i(R.value,R.key,this),this._state!==f)throw new Error("LinkedMap got modified during iteration.");R=R.next}}keys(){const i=this,n=this._state;let f=this._head;const R={[Symbol.iterator](){return R},next(){if(i._state!==n)throw new Error("LinkedMap got modified during iteration.");if(f){const x={value:f.key,done:!1};return f=f.next,x}else return{value:void 0,done:!0}}};return R}values(){const i=this,n=this._state;let f=this._head;const R={[Symbol.iterator](){return R},next(){if(i._state!==n)throw new Error("LinkedMap got modified during iteration.");if(f){const x={value:f.value,done:!1};return f=f.next,x}else return{value:void 0,done:!0}}};return R}entries(){const i=this,n=this._state;let f=this._head;const R={[Symbol.iterator](){return R},next(){if(i._state!==n)throw new Error("LinkedMap got modified during iteration.");if(f){const x={value:[f.key,f.value],done:!1};return f=f.next,x}else return{value:void 0,done:!0}}};return R}[(L=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(i){if(i>=this.size)return;if(i===0){this.clear();return}let n=this._head,f=this.size;for(;n&&f>i;)this._map.delete(n.key),n=n.next,f--;this._head=n,this._size=f,n&&(n.previous=void 0),this._state++}trimNew(i){if(i>=this.size)return;if(i===0){this.clear();return}let n=this._tail,f=this.size;for(;n&&f>i;)this._map.delete(n.key),n=n.previous,f--;this._tail=n,this._size=f,n&&(n.next=void 0),this._state++}addItemFirst(i){if(!this._head&&!this._tail)this._tail=i;else if(this._head)i.next=this._head,this._head.previous=i;else throw new Error("Invalid list");this._head=i,this._state++}addItemLast(i){if(!this._head&&!this._tail)this._head=i;else if(this._tail)i.previous=this._tail,this._tail.next=i;else throw new Error("Invalid list");this._tail=i,this._state++}removeItem(i){if(i===this._head&&i===this._tail)this._head=void 0,this._tail=void 0;else if(i===this._head){if(!i.next)throw new Error("Invalid list");i.next.previous=void 0,this._head=i.next}else if(i===this._tail){if(!i.previous)throw new Error("Invalid list");i.previous.next=void 0,this._tail=i.previous}else{const n=i.next,f=i.previous;if(!n||!f)throw new Error("Invalid list");n.previous=f,f.next=n}i.next=void 0,i.previous=void 0,this._state++}touch(i,n){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(n!==g.AsOld&&n!==g.AsNew)){if(n===g.AsOld){if(i===this._head)return;const f=i.next,R=i.previous;i===this._tail?(R.next=void 0,this._tail=R):(f.previous=R,R.next=f),i.previous=void 0,i.next=this._head,this._head.previous=i,this._head=i,this._state++}else if(n===g.AsNew){if(i===this._tail)return;const f=i.next,R=i.previous;i===this._head?(f.previous=void 0,this._head=f):(f.previous=R,R.next=f),i.next=void 0,i.previous=this._tail,this._tail.next=i,this._tail=i,this._state++}}}toJSON(){const i=[];return this.forEach((n,f)=>{i.push([f,n])}),i}fromJSON(i){this.clear();for(const[n,f]of i)this.set(n,f)}}e.LinkedMap=l;class u extends l{constructor(i,n=1){super(),this._limit=i,this._ratio=Math.min(Math.max(0,n),1)}get limit(){return this._limit}set limit(i){this._limit=i,this.checkTrim()}get ratio(){return this._ratio}set ratio(i){this._ratio=Math.min(Math.max(0,i),1),this.checkTrim()}get(i,n=g.AsNew){return super.get(i,n)}peek(i){return super.get(i,g.None)}set(i,n){return super.set(i,n,g.AsNew),this}checkTrim(){this.size>this._limit&&this.trim(Math.round(this._limit*this._ratio))}}class a extends u{constructor(i,n=1){super(i,n)}trim(i){this.trimOld(i)}set(i,n){return super.set(i,n),this.checkTrim(),this}}e.LRUCache=a;class d extends u{constructor(i,n=1){super(i,n)}trim(i){this.trimNew(i)}set(i,n){return this._limit<=this.size&&!this.has(i)&&this.trim(Math.round(this._limit*this._ratio)-1),super.set(i,n),this}}e.MRUCache=d;class p{constructor(){this.map=new Map}add(i){return this.map.set(i,(this.map.get(i)||0)+1),this}delete(i){let n=this.map.get(i)||0;return n===0?!1:(n--,n===0?this.map.delete(i):this.map.set(i,n),!0)}has(i){return this.map.has(i)}}e.CounterSet=p;class r{constructor(i){if(this._m1=new Map,this._m2=new Map,i)for(const[n,f]of i)this.set(n,f)}clear(){this._m1.clear(),this._m2.clear()}set(i,n){this._m1.set(i,n),this._m2.set(n,i)}get(i){return this._m1.get(i)}getKey(i){return this._m2.get(i)}delete(i){const n=this._m1.get(i);return n===void 0?!1:(this._m1.delete(i),this._m2.delete(n),!0)}forEach(i,n){this._m1.forEach((f,R)=>{i.call(n,f,R,this)})}keys(){return this._m1.keys()}values(){return this._m1.values()}}e.BidirectionalMap=r;class y{constructor(){this.map=new Map}add(i,n){let f=this.map.get(i);f||(f=new Set,this.map.set(i,f)),f.add(n)}delete(i,n){const f=this.map.get(i);f&&(f.delete(n),f.size===0&&this.map.delete(i))}forEach(i,n){const f=this.map.get(i);f&&f.forEach(n)}get(i){const n=this.map.get(i);return n||new Set}}e.SetMap=y;function w(C,i){if(C===i)return!0;if(C.size!==i.size)return!1;for(const[n,f]of C)if(!i.has(n)||i.get(n)!==f)return!1;for(const[n]of i)if(!C.has(n))return!1;return!0}}),define(he[2],fe([0,1,17,45,26,31,47]),function(ie,e,o,t,L,m,W){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DisposableMap=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MandatoryMutableDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.DisposableTracker=void 0,e.setDisposableTracker=b,e.trackDisposable=h,e.markAsDisposed=g,e.markAsSingleton=a,e.isDisposable=d,e.dispose=p,e.disposeIfDisposable=r,e.combinedDisposable=y,e.toDisposable=w,e.disposeOnReturn=O;const P=!1;let _=null;class s{constructor(){this.livingDisposables=new Map}static{this.idx=0}getDisposableData(E){let M=this.livingDisposables.get(E);return M||(M={parent:null,source:null,isSingleton:!1,value:E,idx:s.idx++},this.livingDisposables.set(E,M)),M}trackDisposable(E){const M=this.getDisposableData(E);M.source||(M.source=new Error().stack)}setParent(E,M){const A=this.getDisposableData(E);A.parent=M}markAsDisposed(E){this.livingDisposables.delete(E)}markAsSingleton(E){this.getDisposableData(E).isSingleton=!0}getRootParent(E,M){const A=M.get(E);if(A)return A;const I=E.parent?this.getRootParent(this.getDisposableData(E.parent),M):E;return M.set(E,I),I}getTrackedDisposables(){const E=new Map;return[...this.livingDisposables.entries()].filter(([,A])=>A.source!==null&&!this.getRootParent(A,E).isSingleton).flatMap(([A])=>A)}computeLeakingDisposables(E=10,M){let A;if(M)A=M;else{const Z=new Map,se=[...this.livingDisposables.values()].filter(V=>V.source!==null&&!this.getRootParent(V,Z).isSingleton);if(se.length===0)return;const le=new Set(se.map(V=>V.value));if(A=se.filter(V=>!(V.parent&&le.has(V.parent))),A.length===0)throw new Error("There are cyclic diposable chains!")}if(!A)return;function I(Z){function se(V,z){for(;V.length>0&&z.some(Q=>typeof Q=="string"?Q===V[0]:V[0].match(Q));)V.shift()}const le=Z.source.split(`
`).map(V=>V.trim().replace("at ","")).filter(V=>V!=="");return se(le,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),le.reverse()}const B=new L.SetMap;for(const Z of A){const se=I(Z);for(let le=0;le<=se.length;le++)B.add(se.slice(0,le).join(`
`),Z)}A.sort((0,o.compareBy)(Z=>Z.idx,o.numberComparator));let Y="",G=0;for(const Z of A.slice(0,E)){G++;const se=I(Z),le=[];for(let V=0;V<se.length;V++){let z=se[V];z=`(shared with ${B.get(se.slice(0,V+1).join(`
`)).size}/${A.length} leaks) at ${z}`;const ee=B.get(se.slice(0,V).join(`
`)),ue=(0,t.groupBy)([...ee].map($=>I($)[V]),$=>$);delete ue[se[V]];for(const[$,ae]of Object.entries(ue))le.unshift(`    - stacktraces of ${ae.length} other leaks continue with ${$}`);le.unshift(z)}Y+=`


==================== Leaking disposable ${G}/${A.length}: ${Z.value.constructor.name} ====================
${le.join(`
`)}
============================================================

`}return A.length>E&&(Y+=`


... and ${A.length-E} more leaking disposables

`),{leaks:A,details:Y}}}e.DisposableTracker=s;function b(D){_=D}if(P){const D="__is_disposable_tracked__";b(new class{trackDisposable(E){const M=new Error("Potentially leaked disposable").stack;setTimeout(()=>{E[D]||console.log(M)},3e3)}setParent(E,M){if(E&&E!==i.None)try{E[D]=!0}catch{}}markAsDisposed(E){if(E&&E!==i.None)try{E[D]=!0}catch{}}markAsSingleton(E){}})}function h(D){return _?.trackDisposable(D),D}function g(D){_?.markAsDisposed(D)}function l(D,E){_?.setParent(D,E)}function u(D,E){if(_)for(const M of D)_.setParent(M,E)}function a(D){return _?.markAsSingleton(D),D}function d(D){return typeof D=="object"&&D!==null&&typeof D.dispose=="function"&&D.dispose.length===0}function p(D){if(W.Iterable.is(D)){const E=[];for(const M of D)if(M)try{M.dispose()}catch(A){E.push(A)}if(E.length===1)throw E[0];if(E.length>1)throw new AggregateError(E,"Encountered errors while disposing of store");return Array.isArray(D)?[]:D}else if(D)return D.dispose(),D}function r(D){for(const E of D)d(E)&&E.dispose();return[]}function y(...D){const E=w(()=>p(D));return u(D,E),E}function w(D){const E=h({dispose:(0,m.createSingleCallFunction)(()=>{g(E),D()})});return E}class C{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this._toDispose=new Set,this._isDisposed=!1,h(this)}dispose(){this._isDisposed||(g(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){if(this._toDispose.size!==0)try{p(this._toDispose)}finally{this._toDispose.clear()}}add(E){if(!E)return E;if(E===this)throw new Error("Cannot register a disposable on itself!");return l(E,this),this._isDisposed?C.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(E),E}delete(E){if(E){if(E===this)throw new Error("Cannot dispose a disposable on itself!");this._toDispose.delete(E),E.dispose()}}deleteAndLeak(E){E&&this._toDispose.has(E)&&(this._toDispose.delete(E),l(E,null))}}e.DisposableStore=C;class i{static{this.None=Object.freeze({dispose(){}})}constructor(){this._store=new C,h(this),l(this._store,this)}dispose(){g(this),this._store.dispose()}_register(E){if(E===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(E)}}e.Disposable=i;class n{constructor(){this._isDisposed=!1,h(this)}get value(){return this._isDisposed?void 0:this._value}set value(E){this._isDisposed||E===this._value||(this._value?.dispose(),E&&l(E,this),this._value=E)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,g(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const E=this._value;return this._value=void 0,E&&l(E,null),E}}e.MutableDisposable=n;class f{constructor(E){this._disposable=new n,this._isDisposed=!1,this._disposable.value=E}get value(){return this._disposable.value}set value(E){this._isDisposed||E===this._disposable.value||(this._disposable.value=E)}dispose(){this._isDisposed=!0,this._disposable.dispose()}}e.MandatoryMutableDisposable=f;class R{constructor(E){this._disposable=E,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter===0&&this._disposable.dispose(),this}}e.RefCountedDisposable=R;class x{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,h(this)}set(E){let M=E;return this.unset=()=>M=void 0,this.isset=()=>M!==void 0,this.dispose=()=>{M&&(M(),M=void 0,g(this))},this}}e.SafeDisposable=x;class v{constructor(){this.references=new Map}acquire(E,...M){let A=this.references.get(E);A||(A={counter:0,object:this.createReferencedObject(E,...M)},this.references.set(E,A));const{object:I}=A,B=(0,m.createSingleCallFunction)(()=>{--A.counter===0&&(this.destroyReferencedObject(E,A.object),this.references.delete(E))});return A.counter++,{object:I,dispose:B}}}e.ReferenceCollection=v;class S{constructor(E){this.referenceCollection=E}async acquire(E,...M){const A=this.referenceCollection.acquire(E,...M);try{return{object:await A.object,dispose:()=>A.dispose()}}catch(I){throw A.dispose(),I}}}e.AsyncReferenceCollection=S;class T{constructor(E){this.object=E}dispose(){}}e.ImmortalReference=T;function O(D){const E=new C;try{D(E)}finally{E.dispose()}}class F{constructor(){this._store=new Map,this._isDisposed=!1,h(this)}dispose(){g(this),this._isDisposed=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this._store.size)try{p(this._store.values())}finally{this._store.clear()}}has(E){return this._store.has(E)}get size(){return this._store.size}get(E){return this._store.get(E)}set(E,M,A=!1){this._isDisposed&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),A||this._store.get(E)?.dispose(),this._store.set(E,M)}deleteAndDispose(E){this._store.get(E)?.dispose(),this._store.delete(E)}deleteAndLeak(E){const M=this._store.get(E);return this._store.delete(E),M}keys(){return this._store.keys()}values(){return this._store.values()}[Symbol.iterator](){return this._store[Symbol.iterator]()}}e.DisposableMap=F}),define(he[27],fe([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MarshalledId=void 0;var o;(function(t){t[t.Uri=1]="Uri",t[t.Regexp=2]="Regexp",t[t.ScmResource=3]="ScmResource",t[t.ScmResourceGroup=4]="ScmResourceGroup",t[t.ScmProvider=5]="ScmProvider",t[t.CommentController=6]="CommentController",t[t.CommentThread=7]="CommentThread",t[t.CommentThreadInstance=8]="CommentThreadInstance",t[t.CommentThreadReply=9]="CommentThreadReply",t[t.CommentNode=10]="CommentNode",t[t.CommentThreadNode=11]="CommentThreadNode",t[t.TimelineActionContext=12]="TimelineActionContext",t[t.NotebookCellActionContext=13]="NotebookCellActionContext",t[t.NotebookActionContext=14]="NotebookActionContext",t[t.TerminalContext=15]="TerminalContext",t[t.TestItemContext=16]="TestItemContext",t[t.Date=17]="Date",t[t.TestMessageMenuArgs=18]="TestMessageMenuArgs"})(o||(e.MarshalledId=o={}))}),define(he[49],fe([0,1,26]),function(ie,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=void 0,e.normalizeNFC=L,e.normalizeNFD=W;const t=new o.LRUCache(1e4);function L(s){return _(s,"NFC",t)}const m=new o.LRUCache(1e4);function W(s){return _(s,"NFD",m)}const P=/[^\u0000-\u0080]/;function _(s,b,h){if(!s)return s;const g=h.get(s);if(g)return g;let l;return P.test(s)?l=s.normalize(b):l=s,h.set(s,l),l}e.removeAccents=function(){const s=/[\u0300-\u036f]/g;return function(b){return W(b).replace(s,"")}}()}),function(){function ie(L){const m=[];typeof L=="number"&&m.push("code/timeOrigin",L);function W(_){m.push(_,Date.now())}function P(){const _=[];for(let s=0;s<m.length;s+=2)_.push({name:m[s],startTime:m[s+1]});return _}return{mark:W,getMarks:P}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?ie():{mark(L){performance.mark(L)},getMarks(){let L=performance.timeOrigin;typeof L!="number"&&(L=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const m=[{name:"code/timeOrigin",startTime:Math.round(L)}];for(const W of performance.getEntriesByType("mark"))m.push({name:W.name,startTime:Math.round(L+W.startTime)});return m}};if(typeof process=="object"){const L=performance?.timeOrigin;return ie(L)}else return console.trace("perf-util loaded in UNKNOWN environment"),ie()}function o(L){return L.MonacoPerformanceMarks||(L.MonacoPerformanceMarks=e()),L.MonacoPerformanceMarks}var t;typeof global=="object"?t=global:typeof self=="object"?t=self:t={},typeof define=="function"?define("vs/base/common/performance",[],function(){return o(t)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=o(t):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),t.perf=o(t))}(),define(he[50],fe([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const o=globalThis.performance&&typeof globalThis.performance.now=="function";class t{static create(m){return new t(m)}constructor(m){this._now=o&&m===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this._startTime=this._now(),this._stopTime=-1}stop(){this._stopTime=this._now()}reset(){this._startTime=this._now(),this._stopTime=-1}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}}e.StopWatch=t}),define(he[4],fe([0,1,7,31,2,48,50]),function(ie,e,o,t,L,m,W){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ValueWithChangeEvent=e.Relay=e.EventBufferer=e.DynamicListEventMultiplexer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.createEventDeliveryQueue=e.Emitter=e.ListenerRefusalError=e.ListenerLeakError=e.EventProfiling=e.Event=void 0,e.setGlobalLeakWarningThreshold=l;const P=!1,_=!1,s=!1;var b;(function(I){I.None=()=>L.Disposable.None;function B(ye){if(s){const{onDidAddListener:me}=ye,ve=a.create();let pe=0;ye.onDidAddListener=()=>{++pe===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),ve.print()),me?.()}}}function Y(ye,me){return ae(ye,()=>{},0,void 0,!0,void 0,me)}I.defer=Y;function G(ye){return(me,ve=null,pe)=>{let be=!1,Le;return Le=ye(Ce=>{if(!be)return Le?Le.dispose():be=!0,me.call(ve,Ce)},null,pe),be&&Le.dispose(),Le}}I.once=G;function Z(ye,me){return I.once(I.filter(ye,me))}I.onceIf=Z;function se(ye,me,ve){return ue((pe,be=null,Le)=>ye(Ce=>pe.call(be,me(Ce)),null,Le),ve)}I.map=se;function le(ye,me,ve){return ue((pe,be=null,Le)=>ye(Ce=>{me(Ce),pe.call(be,Ce)},null,Le),ve)}I.forEach=le;function V(ye,me,ve){return ue((pe,be=null,Le)=>ye(Ce=>me(Ce)&&pe.call(be,Ce),null,Le),ve)}I.filter=V;function z(ye){return ye}I.signal=z;function Q(...ye){return(me,ve=null,pe)=>{const be=(0,L.combinedDisposable)(...ye.map(Le=>Le(Ce=>me.call(ve,Ce))));return $(be,pe)}}I.any=Q;function ee(ye,me,ve,pe){let be=ve;return se(ye,Le=>(be=me(be,Le),be),pe)}I.reduce=ee;function ue(ye,me){let ve;const pe={onWillAddFirstListener(){ve=ye(be.fire,be)},onDidRemoveLastListener(){ve?.dispose()}};me||B(pe);const be=new n(pe);return me?.add(be),be.event}function $(ye,me){return me instanceof Array?me.push(ye):me&&me.add(ye),ye}function ae(ye,me,ve=100,pe=!1,be=!1,Le,Ce){let Re,Te,Se,Me=0,qe;const Ge={leakWarningThreshold:Le,onWillAddFirstListener(){Re=ye(Xe=>{Me++,Te=me(Te,Xe),pe&&!Se&&(xe.fire(Te),Te=void 0),qe=()=>{const $e=Te;Te=void 0,Se=void 0,(!pe||Me>1)&&xe.fire($e),Me=0},typeof ve=="number"?(clearTimeout(Se),Se=setTimeout(qe,ve)):Se===void 0&&(Se=0,queueMicrotask(qe))})},onWillRemoveListener(){be&&Me>0&&qe?.()},onDidRemoveLastListener(){qe=void 0,Re.dispose()}};Ce||B(Ge);const xe=new n(Ge);return Ce?.add(xe),xe.event}I.debounce=ae;function de(ye,me=0,ve){return I.debounce(ye,(pe,be)=>pe?(pe.push(be),pe):[be],me,void 0,!0,void 0,ve)}I.accumulate=de;function te(ye,me=(pe,be)=>pe===be,ve){let pe=!0,be;return V(ye,Le=>{const Ce=pe||!me(Le,be);return pe=!1,be=Le,Ce},ve)}I.latch=te;function c(ye,me,ve){return[I.filter(ye,me,ve),I.filter(ye,pe=>!me(pe),ve)]}I.split=c;function j(ye,me=!1,ve=[],pe){let be=ve.slice(),Le=ye(Te=>{be?be.push(Te):Re.fire(Te)});pe&&pe.add(Le);const Ce=()=>{be?.forEach(Te=>Re.fire(Te)),be=null},Re=new n({onWillAddFirstListener(){Le||(Le=ye(Te=>Re.fire(Te)),pe&&pe.add(Le))},onDidAddFirstListener(){be&&(me?setTimeout(Ce):Ce())},onDidRemoveLastListener(){Le&&Le.dispose(),Le=null}});return pe&&pe.add(Re),Re.event}I.buffer=j;function oe(ye,me){return(pe,be,Le)=>{const Ce=me(new K);return ye(function(Re){const Te=Ce.evaluate(Re);Te!==N&&pe.call(be,Te)},void 0,Le)}}I.chain=oe;const N=Symbol("HaltChainable");class K{constructor(){this.steps=[]}map(me){return this.steps.push(me),this}forEach(me){return this.steps.push(ve=>(me(ve),ve)),this}filter(me){return this.steps.push(ve=>me(ve)?ve:N),this}reduce(me,ve){let pe=ve;return this.steps.push(be=>(pe=me(pe,be),pe)),this}latch(me=(ve,pe)=>ve===pe){let ve=!0,pe;return this.steps.push(be=>{const Le=ve||!me(be,pe);return ve=!1,pe=be,Le?be:N}),this}evaluate(me){for(const ve of this.steps)if(me=ve(me),me===N)break;return me}}function U(ye,me,ve=pe=>pe){const pe=(...Re)=>Ce.fire(ve(...Re)),be=()=>ye.on(me,pe),Le=()=>ye.removeListener(me,pe),Ce=new n({onWillAddFirstListener:be,onDidRemoveLastListener:Le});return Ce.event}I.fromNodeEventEmitter=U;function k(ye,me,ve=pe=>pe){const pe=(...Re)=>Ce.fire(ve(...Re)),be=()=>ye.addEventListener(me,pe),Le=()=>ye.removeEventListener(me,pe),Ce=new n({onWillAddFirstListener:be,onDidRemoveLastListener:Le});return Ce.event}I.fromDOMEventEmitter=k;function H(ye){return new Promise(me=>G(ye)(me))}I.toPromise=H;function J(ye){const me=new n;return ye.then(ve=>{me.fire(ve)},()=>{me.fire(void 0)}).finally(()=>{me.dispose()}),me.event}I.fromPromise=J;function ne(ye,me){return ye(ve=>me.fire(ve))}I.forward=ne;function _e(ye,me,ve){return me(ve),ye(pe=>me(pe))}I.runAndSubscribe=_e;class we{constructor(me,ve){this._observable=me,this._counter=0,this._hasChanged=!1;const pe={onWillAddFirstListener:()=>{me.addObserver(this),this._observable.reportChanges()},onDidRemoveLastListener:()=>{me.removeObserver(this)}};ve||B(pe),this.emitter=new n(pe),ve&&ve.add(this.emitter)}beginUpdate(me){this._counter++}handlePossibleChange(me){}handleChange(me,ve){this._hasChanged=!0}endUpdate(me){this._counter--,this._counter===0&&(this._observable.reportChanges(),this._hasChanged&&(this._hasChanged=!1,this.emitter.fire(this._observable.get())))}}function Ie(ye,me){return new we(ye,me).emitter.event}I.fromObservable=Ie;function Ae(ye){return(me,ve,pe)=>{let be=0,Le=!1;const Ce={beginUpdate(){be++},endUpdate(){be--,be===0&&(ye.reportChanges(),Le&&(Le=!1,me.call(ve)))},handlePossibleChange(){},handleChange(){Le=!0}};ye.addObserver(Ce),ye.reportChanges();const Re={dispose(){ye.removeObserver(Ce)}};return pe instanceof L.DisposableStore?pe.add(Re):Array.isArray(pe)&&pe.push(Re),Re}}I.fromObservableLight=Ae})(b||(e.Event=b={}));class h{static{this.all=new Set}static{this._idPool=0}constructor(B){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${B}_${h._idPool++}`,h.all.add(this)}start(B){this._stopWatch=new W.StopWatch,this.listenerCount=B}stop(){if(this._stopWatch){const B=this._stopWatch.elapsed();this.durations.push(B),this.elapsedOverall+=B,this.invocationCount+=1,this._stopWatch=void 0}}}e.EventProfiling=h;let g=-1;function l(I){const B=g;return g=I,{dispose(){g=B}}}class u{static{this._idPool=1}constructor(B,Y,G=(u._idPool++).toString(16).padStart(3,"0")){this._errorHandler=B,this.threshold=Y,this.name=G,this._warnCountdown=0}dispose(){this._stacks?.clear()}check(B,Y){const G=this.threshold;if(G<=0||Y<G)return;this._stacks||(this._stacks=new Map);const Z=this._stacks.get(B.value)||0;if(this._stacks.set(B.value,Z+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=G*.5;const[se,le]=this.getMostFrequentStack(),V=`[${this.name}] potential listener LEAK detected, having ${Y} listeners already. MOST frequent listener (${le}):`;console.warn(V),console.warn(se);const z=new d(V,se);this._errorHandler(z)}return()=>{const se=this._stacks.get(B.value)||0;this._stacks.set(B.value,se-1)}}getMostFrequentStack(){if(!this._stacks)return;let B,Y=0;for(const[G,Z]of this._stacks)(!B||Y<Z)&&(B=[G,Z],Y=Z);return B}}class a{static create(){const B=new Error;return new a(B.stack??"")}constructor(B){this.value=B}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class d extends Error{constructor(B,Y){super(B),this.name="ListenerLeakError",this.stack=Y}}e.ListenerLeakError=d;class p extends Error{constructor(B,Y){super(B),this.name="ListenerRefusalError",this.stack=Y}}e.ListenerRefusalError=p;let r=0;class y{constructor(B){this.value=B,this.id=r++}}const w=2,C=(I,B)=>{if(I instanceof y)B(I);else for(let Y=0;Y<I.length;Y++){const G=I[Y];G&&B(G)}};let i;if(P){const I=[];setInterval(()=>{I.length!==0&&(console.warn("[LEAKING LISTENERS] GC'ed these listeners that were NOT yet disposed:"),console.warn(I.join(`
`)),I.length=0)},3e3),i=new FinalizationRegistry(B=>{typeof B=="string"&&I.push(B)})}class n{constructor(B){this._size=0,this._options=B,this._leakageMon=g>0||this._options?.leakWarningThreshold?new u(B?.onListenerError??o.onUnexpectedError,this._options?.leakWarningThreshold??g):void 0,this._perfMon=this._options?._profName?new h(this._options._profName):void 0,this._deliveryQueue=this._options?.deliveryQueue}dispose(){if(!this._disposed){if(this._disposed=!0,this._deliveryQueue?.current===this&&this._deliveryQueue.reset(),this._listeners){if(_){const B=this._listeners;queueMicrotask(()=>{C(B,Y=>Y.stack?.print())})}this._listeners=void 0,this._size=0}this._options?.onDidRemoveLastListener?.(),this._leakageMon?.dispose()}}get event(){return this._event??=(B,Y,G)=>{if(this._leakageMon&&this._size>this._leakageMon.threshold**2){const z=`[${this._leakageMon.name}] REFUSES to accept new listeners because it exceeded its threshold by far (${this._size} vs ${this._leakageMon.threshold})`;console.warn(z);const Q=this._leakageMon.getMostFrequentStack()??["UNKNOWN stack",-1],ee=new p(`${z}. HINT: Stack shows most frequent listener (${Q[1]}-times)`,Q[0]);return(this._options?.onListenerError||o.onUnexpectedError)(ee),L.Disposable.None}if(this._disposed)return L.Disposable.None;Y&&(B=B.bind(Y));const Z=new y(B);let se,le;this._leakageMon&&this._size>=Math.ceil(this._leakageMon.threshold*.2)&&(Z.stack=a.create(),se=this._leakageMon.check(Z.stack,this._size+1)),_&&(Z.stack=le??a.create()),this._listeners?this._listeners instanceof y?(this._deliveryQueue??=new R,this._listeners=[this._listeners,Z]):this._listeners.push(Z):(this._options?.onWillAddFirstListener?.(this),this._listeners=Z,this._options?.onDidAddFirstListener?.(this)),this._size++;const V=(0,L.toDisposable)(()=>{i?.unregister(V),se?.(),this._removeListener(Z)});if(G instanceof L.DisposableStore?G.add(V):Array.isArray(G)&&G.push(V),i){const z=new Error().stack.split(`
`).slice(2,3).join(`
`).trim(),Q=/(file:|vscode-file:\/\/vscode-app)?(\/[^:]*:\d+:\d+)/.exec(z);i.register(V,Q?.[2]??z,V)}return V},this._event}_removeListener(B){if(this._options?.onWillRemoveListener?.(this),!this._listeners)return;if(this._size===1){this._listeners=void 0,this._options?.onDidRemoveLastListener?.(this),this._size=0;return}const Y=this._listeners,G=Y.indexOf(B);if(G===-1)throw console.log("disposed?",this._disposed),console.log("size?",this._size),console.log("arr?",JSON.stringify(this._listeners)),new Error("Attempted to dispose unknown listener");this._size--,Y[G]=void 0;const Z=this._deliveryQueue.current===this;if(this._size*w<=Y.length){let se=0;for(let le=0;le<Y.length;le++)Y[le]?Y[se++]=Y[le]:Z&&(this._deliveryQueue.end--,se<this._deliveryQueue.i&&this._deliveryQueue.i--);Y.length=se}}_deliver(B,Y){if(!B)return;const G=this._options?.onListenerError||o.onUnexpectedError;if(!G){B.value(Y);return}try{B.value(Y)}catch(Z){G(Z)}}_deliverQueue(B){const Y=B.current._listeners;for(;B.i<B.end;)this._deliver(Y[B.i++],B.value);B.reset()}fire(B){if(this._deliveryQueue?.current&&(this._deliverQueue(this._deliveryQueue),this._perfMon?.stop()),this._perfMon?.start(this._size),this._listeners)if(this._listeners instanceof y)this._deliver(this._listeners,B);else{const Y=this._deliveryQueue;Y.enqueue(this,B,this._listeners.length),this._deliverQueue(Y)}this._perfMon?.stop()}hasListeners(){return this._size>0}}e.Emitter=n;const f=()=>new R;e.createEventDeliveryQueue=f;class R{constructor(){this.i=-1,this.end=0}enqueue(B,Y,G){this.i=0,this.end=G,this.current=B,this.value=Y}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class x extends n{async fireAsync(B,Y,G){if(this._listeners)for(this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new m.LinkedList),C(this._listeners,Z=>this._asyncDeliveryQueue.push([Z.value,B]));this._asyncDeliveryQueue.size>0&&!Y.isCancellationRequested;){const[Z,se]=this._asyncDeliveryQueue.shift(),le=[],V={...se,token:Y,waitUntil:z=>{if(Object.isFrozen(le))throw new Error("waitUntil can NOT be called asynchronous");G&&(z=G(z,Z)),le.push(z)}};try{Z(V)}catch(z){(0,o.onUnexpectedError)(z);continue}Object.freeze(le),await Promise.allSettled(le).then(z=>{for(const Q of z)Q.status==="rejected"&&(0,o.onUnexpectedError)(Q.reason)})}}}e.AsyncEmitter=x;class v extends n{get isPaused(){return this._isPaused!==0}constructor(B){super(B),this._isPaused=0,this._eventQueue=new m.LinkedList,this._mergeFn=B?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused===0)if(this._mergeFn){if(this._eventQueue.size>0){const B=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(B))}}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(B){this._size&&(this._isPaused!==0?this._eventQueue.push(B):super.fire(B))}}e.PauseableEmitter=v;class S extends v{constructor(B){super(B),this._delay=B.delay??100}fire(B){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(B)}}e.DebounceEmitter=S;class T extends n{constructor(B){super(B),this._queuedEvents=[],this._mergeFn=B?.merge}fire(B){this.hasListeners()&&(this._queuedEvents.push(B),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(Y=>super.fire(Y)),this._queuedEvents=[]}))}}e.MicrotaskEmitter=T;class O{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new n({onWillAddFirstListener:()=>this.onFirstListenerAdd(),onDidRemoveLastListener:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(B){const Y={event:B,listener:null};this.events.push(Y),this.hasListeners&&this.hook(Y);const G=()=>{this.hasListeners&&this.unhook(Y);const Z=this.events.indexOf(Y);this.events.splice(Z,1)};return(0,L.toDisposable)((0,t.createSingleCallFunction)(G))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(B=>this.hook(B))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(B=>this.unhook(B))}hook(B){B.listener=B.event(Y=>this.emitter.fire(Y))}unhook(B){B.listener?.dispose(),B.listener=null}dispose(){this.emitter.dispose();for(const B of this.events)B.listener?.dispose();this.events=[]}}e.EventMultiplexer=O;class F{constructor(B,Y,G,Z){this._store=new L.DisposableStore;const se=this._store.add(new O),le=this._store.add(new L.DisposableMap);function V(z){le.set(z,se.add(Z(z)))}for(const z of B)V(z);this._store.add(Y(z=>{V(z)})),this._store.add(G(z=>{le.deleteAndDispose(z)})),this.event=se.event}dispose(){this._store.dispose()}}e.DynamicListEventMultiplexer=F;class D{constructor(){this.data=[]}wrapEvent(B,Y,G){return(Z,se,le)=>B(V=>{const z=this.data[this.data.length-1];if(!Y){z?z.buffers.push(()=>Z.call(se,V)):Z.call(se,V);return}const Q=z;if(!Q){Z.call(se,Y(G,V));return}Q.items??=[],Q.items.push(V),Q.buffers.length===0&&z.buffers.push(()=>{Q.reducedResult??=G?Q.items.reduce(Y,G):Q.items.reduce(Y),Z.call(se,Q.reducedResult)})},void 0,le)}bufferEvents(B){const Y={buffers:new Array};this.data.push(Y);const G=B();return this.data.pop(),Y.buffers.forEach(Z=>Z()),G}}e.EventBufferer=D;class E{constructor(){this.listening=!1,this.inputEvent=b.None,this.inputEventListener=L.Disposable.None,this.emitter=new n({onDidAddFirstListener:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onDidRemoveLastListener:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(B){this.inputEvent=B,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=B(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=E;class M{static const(B){return new A(B)}constructor(B){this._value=B,this._onDidChange=new n,this.onDidChange=this._onDidChange.event}get value(){return this._value}set value(B){B!==this._value&&(this._value=B,this._onDidChange.fire(void 0))}}e.ValueWithChangeEvent=M;class A{constructor(B){this.value=B,this.onDidChange=b.None}}}),define(he[18],fe([0,1,4]),function(ie,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0,e.cancelOnDispose=P;const t=Object.freeze(function(_,s){const b=setTimeout(_.bind(s),0);return{dispose(){clearTimeout(b)}}});var L;(function(_){function s(b){return b===_.None||b===_.Cancelled||b instanceof m?!0:!b||typeof b!="object"?!1:typeof b.isCancellationRequested=="boolean"&&typeof b.onCancellationRequested=="function"}_.isCancellationToken=s,_.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:o.Event.None}),_.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:t})})(L||(e.CancellationToken=L={}));class m{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?t:(this._emitter||(this._emitter=new o.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class W{constructor(s){this._token=void 0,this._parentListener=void 0,this._parentListener=s&&s.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new m),this._token}cancel(){this._token?this._token instanceof m&&this._token.cancel():this._token=L.Cancelled}dispose(s=!1){s&&this.cancel(),this._parentListener?.dispose(),this._token?this._token instanceof m&&this._token.dispose():this._token=L.None}}e.CancellationTokenSource=W;function P(_){const s=new W;return _.add({dispose(){s.cancel()}}),s.token}}),define(he[51],fe([0,1,18]),function(ie,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0,e.identity=L;class t{constructor(_){this.task=_,this.result=null}get(){if(this.result)return this.result;const _=new o.CancellationTokenSource,s=this.task(_.token);return this.result={promise:s,dispose:()=>{this.result=null,_.cancel(),_.dispose()}},this.result}}e.Cache=t;function L(P){return P}class m{constructor(_,s){this.lastCache=void 0,this.lastArgKey=void 0,typeof _=="function"?(this._fn=_,this._computeKey=L):(this._fn=s,this._computeKey=_.getCacheKey)}get(_){const s=this._computeKey(_);return this.lastArgKey!==s&&(this.lastArgKey=s,this.lastCache=this._fn(_)),this.lastCache}}e.LRUCachedFunction=m;class W{get cachedValues(){return this._map}constructor(_,s){this._map=new Map,this._map2=new Map,typeof _=="function"?(this._fn=_,this._computeKey=L):(this._fn=s,this._computeKey=_.getCacheKey)}get(_){const s=this._computeKey(_);if(this._map2.has(s))return this._map2.get(s);const b=this._fn(_);return this._map.set(_,b),this._map2.set(s,b),b}}e.CachedFunction=W}),define(he[52],fe([0,1,7,2]),function(ie,e,o,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isReadable=L,e.isReadableStream=m,e.isReadableBufferedStream=W,e.newWriteableStream=P,e.consumeReadable=s,e.peekReadable=b,e.consumeStream=h,e.listenStream=g,e.peekStream=l,e.toStream=u,e.emptyStream=a,e.toReadable=d,e.transform=p,e.prefixedReadable=r,e.prefixedStream=y;function L(w){const C=w;return C?typeof C.read=="function":!1}function m(w){const C=w;return C?[C.on,C.pause,C.resume,C.destroy].every(i=>typeof i=="function"):!1}function W(w){const C=w;return C?m(C.stream)&&Array.isArray(C.buffer)&&typeof C.ended=="boolean":!1}function P(w,C){return new _(w,C)}class _{constructor(C,i){this.reducer=C,this.options=i,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(C){if(!this.state.destroyed){if(this.state.flowing)this.emitData(C);else if(this.buffer.data.push(C),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(i=>this.pendingWritePromises.push(i))}}error(C){this.state.destroyed||(this.state.flowing?this.emitError(C):this.buffer.error.push(C))}end(C){this.state.destroyed||(typeof C<"u"&&this.write(C),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(C){this.listeners.data.slice(0).forEach(i=>i(C))}emitError(C){this.listeners.error.length===0?(0,o.onUnexpectedError)(C):this.listeners.error.slice(0).forEach(i=>i(C))}emitEnd(){this.listeners.end.slice(0).forEach(C=>C())}on(C,i){if(!this.state.destroyed)switch(C){case"data":this.listeners.data.push(i),this.resume();break;case"end":this.listeners.end.push(i),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(i),this.state.flowing&&this.flowErrors();break}}removeListener(C,i){if(this.state.destroyed)return;let n;switch(C){case"data":n=this.listeners.data;break;case"end":n=this.listeners.end;break;case"error":n=this.listeners.error;break}if(n){const f=n.indexOf(i);f>=0&&n.splice(f,1)}}flowData(){if(this.buffer.data.length>0){const C=this.reducer(this.buffer.data);this.emitData(C),this.buffer.data.length=0;const i=[...this.pendingWritePromises];this.pendingWritePromises.length=0,i.forEach(n=>n())}}flowErrors(){if(this.listeners.error.length>0){for(const C of this.buffer.error)this.emitError(C);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function s(w,C){const i=[];let n;for(;(n=w.read())!==null;)i.push(n);return C(i)}function b(w,C,i){const n=[];let f;for(;(f=w.read())!==null&&n.length<i;)n.push(f);return f===null&&n.length>0?C(n):{read:()=>{if(n.length>0)return n.shift();if(typeof f<"u"){const R=f;return f=void 0,R}return w.read()}}}function h(w,C){return new Promise((i,n)=>{const f=[];g(w,{onData:R=>{C&&f.push(R)},onError:R=>{C?n(R):i(void 0)},onEnd:()=>{i(C?C(f):void 0)}})})}function g(w,C,i){w.on("error",n=>{i?.isCancellationRequested||C.onError(n)}),w.on("end",()=>{i?.isCancellationRequested||C.onEnd()}),w.on("data",n=>{i?.isCancellationRequested||C.onData(n)})}function l(w,C){return new Promise((i,n)=>{const f=new t.DisposableStore,R=[],x=T=>{if(R.push(T),R.length>C)return f.dispose(),w.pause(),i({stream:w,buffer:R,ended:!1})},v=T=>(f.dispose(),n(T)),S=()=>(f.dispose(),i({stream:w,buffer:R,ended:!0}));f.add((0,t.toDisposable)(()=>w.removeListener("error",v))),w.on("error",v),f.add((0,t.toDisposable)(()=>w.removeListener("end",S))),w.on("end",S),f.add((0,t.toDisposable)(()=>w.removeListener("data",x))),w.on("data",x)})}function u(w,C){const i=P(C);return i.end(w),i}function a(){const w=P(()=>{throw new Error("not supported")});return w.end(),w}function d(w){let C=!1;return{read:()=>C?null:(C=!0,w)}}function p(w,C,i){const n=P(i);return g(w,{onData:f=>n.write(C.data(f)),onError:f=>n.error(C.error?C.error(f):f),onEnd:()=>n.end()}),n}function r(w,C,i){let n=!1;return{read:()=>{const f=C.read();return n?f:(n=!0,f!==null?i([w,f]):w)}}}function y(w,C,i){let n=!1;const f=P(i);return g(C,{onData:R=>n?f.write(R):(n=!0,f.write(i([w,R]))),onError:R=>f.error(R),onEnd:()=>{n||(n=!0,f.write(w)),f.end()}}),f}});var Ye=this&&this.__createBinding||(Object.create?function(ie,e,o,t){t===void 0&&(t=o);var L=Object.getOwnPropertyDescriptor(e,o);(!L||("get"in L?!e.__esModule:L.writable||L.configurable))&&(L={enumerable:!0,get:function(){return e[o]}}),Object.defineProperty(ie,t,L)}:function(ie,e,o,t){t===void 0&&(t=o),ie[t]=e[o]}),Ze=this&&this.__setModuleDefault||(Object.create?function(ie,e){Object.defineProperty(ie,"default",{enumerable:!0,value:e})}:function(ie,e){ie.default=e}),Pe=this&&this.__importStar||function(ie){if(ie&&ie.__esModule)return ie;var e={};if(ie!=null)for(var o in ie)o!=="default"&&Object.prototype.hasOwnProperty.call(ie,o)&&Ye(e,ie,o);return Ze(e,ie),e};define(he[19],fe([0,1,24,52]),function(ie,e,o,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.VSBuffer=void 0,e.binaryIndexOf=s,e.readUInt16LE=b,e.writeUInt16LE=h,e.readUInt32BE=g,e.writeUInt32BE=l,e.readUInt32LE=u,e.writeUInt32LE=a,e.readUInt8=d,e.writeUInt8=p,e.readableToBuffer=r,e.bufferToReadable=y,e.streamToBuffer=w,e.bufferedStreamToBuffer=C,e.bufferToStream=i,e.streamToBufferReadableStream=n,e.newWriteableBufferStream=f,e.prefixedBufferReadable=R,e.prefixedBufferStream=x,e.decodeBase64=v,e.encodeBase64=O,t=Pe(t);const L=typeof Buffer<"u",m=new o.Lazy(()=>new Uint8Array(256));let W,P;class _{static alloc(D){return L?new _(Buffer.allocUnsafe(D)):new _(new Uint8Array(D))}static wrap(D){return L&&!Buffer.isBuffer(D)&&(D=Buffer.from(D.buffer,D.byteOffset,D.byteLength)),new _(D)}static fromString(D,E){return!(E?.dontUseNodeBuffer||!1)&&L?new _(Buffer.from(D)):(W||(W=new TextEncoder),new _(W.encode(D)))}static fromByteArray(D){const E=_.alloc(D.length);for(let M=0,A=D.length;M<A;M++)E.buffer[M]=D[M];return E}static concat(D,E){if(typeof E>"u"){E=0;for(let I=0,B=D.length;I<B;I++)E+=D[I].byteLength}const M=_.alloc(E);let A=0;for(let I=0,B=D.length;I<B;I++){const Y=D[I];M.set(Y,A),A+=Y.byteLength}return M}constructor(D){this.buffer=D,this.byteLength=this.buffer.byteLength}clone(){const D=_.alloc(this.byteLength);return D.set(this),D}toString(){return L?this.buffer.toString():(P||(P=new TextDecoder),P.decode(this.buffer))}slice(D,E){return new _(this.buffer.subarray(D,E))}set(D,E){if(D instanceof _)this.buffer.set(D.buffer,E);else if(D instanceof Uint8Array)this.buffer.set(D,E);else if(D instanceof ArrayBuffer)this.buffer.set(new Uint8Array(D),E);else if(ArrayBuffer.isView(D))this.buffer.set(new Uint8Array(D.buffer,D.byteOffset,D.byteLength),E);else throw new Error("Unknown argument 'array'")}readUInt32BE(D){return g(this.buffer,D)}writeUInt32BE(D,E){l(this.buffer,D,E)}readUInt32LE(D){return u(this.buffer,D)}writeUInt32LE(D,E){a(this.buffer,D,E)}readUInt8(D){return d(this.buffer,D)}writeUInt8(D,E){p(this.buffer,D,E)}indexOf(D,E=0){return s(this.buffer,D instanceof _?D.buffer:D,E)}}e.VSBuffer=_;function s(F,D,E=0){const M=D.byteLength,A=F.byteLength;if(M===0)return 0;if(M===1)return F.indexOf(D[0]);if(M>A-E)return-1;const I=m.value;I.fill(D.length);for(let Z=0;Z<D.length;Z++)I[D[Z]]=D.length-Z-1;let B=E+D.length-1,Y=B,G=-1;for(;B<A;)if(F[B]===D[Y]){if(Y===0){G=B;break}B--,Y--}else B+=Math.max(D.length-Y,I[F[B]]),Y=D.length-1;return G}function b(F,D){return F[D+0]<<0>>>0|F[D+1]<<8>>>0}function h(F,D,E){F[E+0]=D&255,D=D>>>8,F[E+1]=D&255}function g(F,D){return F[D]*2**24+F[D+1]*2**16+F[D+2]*2**8+F[D+3]}function l(F,D,E){F[E+3]=D,D=D>>>8,F[E+2]=D,D=D>>>8,F[E+1]=D,D=D>>>8,F[E]=D}function u(F,D){return F[D+0]<<0>>>0|F[D+1]<<8>>>0|F[D+2]<<16>>>0|F[D+3]<<24>>>0}function a(F,D,E){F[E+0]=D&255,D=D>>>8,F[E+1]=D&255,D=D>>>8,F[E+2]=D&255,D=D>>>8,F[E+3]=D&255}function d(F,D){return F[D]}function p(F,D,E){F[E]=D}function r(F){return t.consumeReadable(F,D=>_.concat(D))}function y(F){return t.toReadable(F)}function w(F){return t.consumeStream(F,D=>_.concat(D))}async function C(F){return F.ended?_.concat(F.buffer):_.concat([...F.buffer,await w(F.stream)])}function i(F){return t.toStream(F,D=>_.concat(D))}function n(F){return t.transform(F,{data:D=>typeof D=="string"?_.fromString(D):_.wrap(D)},D=>_.concat(D))}function f(F){return t.newWriteableStream(D=>_.concat(D),F)}function R(F,D){return t.prefixedReadable(F,D,E=>_.concat(E))}function x(F,D){return t.prefixedStream(F,D,E=>_.concat(E))}function v(F){let D=0,E=0,M=0;const A=new Uint8Array(Math.floor(F.length/4*3)),I=Y=>{switch(E){case 3:A[M++]=D|Y,E=0;break;case 2:A[M++]=D|Y>>>2,D=Y<<6,E=3;break;case 1:A[M++]=D|Y>>>4,D=Y<<4,E=2;break;default:D=Y<<2,E=1}};for(let Y=0;Y<F.length;Y++){const G=F.charCodeAt(Y);if(G>=65&&G<=90)I(G-65);else if(G>=97&&G<=122)I(G-97+26);else if(G>=48&&G<=57)I(G-48+52);else if(G===43||G===45)I(62);else if(G===47||G===95)I(63);else{if(G===61)break;throw new SyntaxError(`Unexpected base64 character ${F[Y]}`)}}const B=M;for(;E>0;)I(0);return _.wrap(A).slice(0,B)}const S="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",T="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function O({buffer:F},D=!0,E=!1){const M=E?T:S;let A="";const I=F.byteLength%3;let B=0;for(;B<F.byteLength-I;B+=3){const Y=F[B+0],G=F[B+1],Z=F[B+2];A+=M[Y>>>2],A+=M[(Y<<4|G>>>4)&63],A+=M[(G<<2|Z>>>6)&63],A+=M[Z&63]}if(I===1){const Y=F[B+0];A+=M[Y>>>2],A+=M[Y<<4&63],D&&(A+="==")}else if(I===2){const Y=F[B+0],G=F[B+1];A+=M[Y>>>2],A+=M[(Y<<4|G>>>4)&63],A+=M[G<<2&63],D&&(A+="=")}return A}}),define(he[53],fe([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MicrotaskDelay=void 0,e.MicrotaskDelay=Symbol("MicrotaskDelay")}),define(he[10],fe([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isString=o,e.isStringArray=t,e.isObject=L,e.isTypedArray=m,e.isNumber=W,e.isIterable=P,e.isBoolean=_,e.isUndefined=s,e.isDefined=b,e.isUndefinedOrNull=h,e.assertType=g,e.assertIsDefined=l,e.assertAllDefined=u,e.isEmptyObject=d,e.isFunction=p,e.areFunctions=r,e.validateConstraints=y,e.validateConstraint=w,e.upcast=C;function o(i){return typeof i=="string"}function t(i){return Array.isArray(i)&&i.every(n=>o(n))}function L(i){return typeof i=="object"&&i!==null&&!Array.isArray(i)&&!(i instanceof RegExp)&&!(i instanceof Date)}function m(i){const n=Object.getPrototypeOf(Uint8Array);return typeof i=="object"&&i instanceof n}function W(i){return typeof i=="number"&&!isNaN(i)}function P(i){return!!i&&typeof i[Symbol.iterator]=="function"}function _(i){return i===!0||i===!1}function s(i){return typeof i>"u"}function b(i){return!h(i)}function h(i){return s(i)||i===null}function g(i,n){if(!i)throw new Error(n?`Unexpected type, expected '${n}'`:"Unexpected type")}function l(i){if(h(i))throw new Error("Assertion Failed: argument is undefined or null");return i}function u(...i){const n=[];for(let f=0;f<i.length;f++){const R=i[f];if(h(R))throw new Error(`Assertion Failed: argument at index ${f} is undefined or null`);n.push(R)}return n}const a=Object.prototype.hasOwnProperty;function d(i){if(!L(i))return!1;for(const n in i)if(a.call(i,n))return!1;return!0}function p(i){return typeof i=="function"}function r(...i){return i.length>0&&i.every(p)}function y(i,n){const f=Math.min(i.length,n.length);for(let R=0;R<f;R++)w(i[R],n[R])}function w(i,n){if(o(n)){if(typeof i!==n)throw new Error(`argument does not match constraint: typeof ${n}`)}else if(p(n)){try{if(i instanceof n)return}catch{}if(!h(i)&&i.constructor===n||n.length===1&&n.call(void 0,i)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}function C(i){return i}}),define(he[32],fe([0,1,10]),function(ie,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deepClone=t,e.deepFreeze=L,e.cloneAndChange=W,e.mixin=_,e.equals=s,e.safeStringify=b,e.distinct=h,e.getCaseInsensitive=g,e.filter=l,e.getAllPropertyNames=u,e.getAllMethodNames=a,e.createProxyObject=d,e.mapValues=p;function t(r){if(!r||typeof r!="object"||r instanceof RegExp)return r;const y=Array.isArray(r)?[]:{};return Object.entries(r).forEach(([w,C])=>{y[w]=C&&typeof C=="object"?t(C):C}),y}function L(r){if(!r||typeof r!="object")return r;const y=[r];for(;y.length>0;){const w=y.shift();Object.freeze(w);for(const C in w)if(m.call(w,C)){const i=w[C];typeof i=="object"&&!Object.isFrozen(i)&&!(0,o.isTypedArray)(i)&&y.push(i)}}return r}const m=Object.prototype.hasOwnProperty;function W(r,y){return P(r,y,new Set)}function P(r,y,w){if((0,o.isUndefinedOrNull)(r))return r;const C=y(r);if(typeof C<"u")return C;if(Array.isArray(r)){const i=[];for(const n of r)i.push(P(n,y,w));return i}if((0,o.isObject)(r)){if(w.has(r))throw new Error("Cannot clone recursive data-structure");w.add(r);const i={};for(const n in r)m.call(r,n)&&(i[n]=P(r[n],y,w));return w.delete(r),i}return r}function _(r,y,w=!0){return(0,o.isObject)(r)?((0,o.isObject)(y)&&Object.keys(y).forEach(C=>{C in r?w&&((0,o.isObject)(r[C])&&(0,o.isObject)(y[C])?_(r[C],y[C],w):r[C]=y[C]):r[C]=y[C]}),r):y}function s(r,y){if(r===y)return!0;if(r==null||y===null||y===void 0||typeof r!=typeof y||typeof r!="object"||Array.isArray(r)!==Array.isArray(y))return!1;let w,C;if(Array.isArray(r)){if(r.length!==y.length)return!1;for(w=0;w<r.length;w++)if(!s(r[w],y[w]))return!1}else{const i=[];for(C in r)i.push(C);i.sort();const n=[];for(C in y)n.push(C);if(n.sort(),!s(i,n))return!1;for(w=0;w<i.length;w++)if(!s(r[i[w]],y[i[w]]))return!1}return!0}function b(r){const y=new Set;return JSON.stringify(r,(w,C)=>{if((0,o.isObject)(C)||Array.isArray(C)){if(y.has(C))return"[Circular]";y.add(C)}return typeof C=="bigint"?`[BigInt ${C.toString()}]`:C})}function h(r,y){const w=Object.create(null);return!r||!y||Object.keys(y).forEach(i=>{const n=r[i],f=y[i];s(n,f)||(w[i]=f)}),w}function g(r,y){const w=y.toLowerCase(),C=Object.keys(r).find(i=>i.toLowerCase()===w);return C?r[C]:r[y]}function l(r,y){const w=Object.create(null);for(const[C,i]of Object.entries(r))y(C,i)&&(w[C]=i);return w}function u(r){let y=[];for(;Object.prototype!==r;)y=y.concat(Object.getOwnPropertyNames(r)),r=Object.getPrototypeOf(r);return y}function a(r){const y=[];for(const w of u(r))typeof r[w]=="function"&&y.push(w);return y}function d(r,y){const w=i=>function(){const n=Array.prototype.slice.call(arguments,0);return y(i,n)},C={};for(const i of r)C[i]=w(i);return C}function p(r,y){const w={};for(const[C,i]of Object.entries(r))w[C]=y(i,C);return w}}),define(he[54],fe([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Constants=void 0,e.toUint8=t,e.toUint32=L;var o;(function(m){m[m.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",m[m.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",m[m.MAX_UINT_8=255]="MAX_UINT_8",m[m.MAX_UINT_16=65535]="MAX_UINT_16",m[m.MAX_UINT_32=4294967295]="MAX_UINT_32",m[m.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(o||(e.Constants=o={}));function t(m){return m<0?0:m>o.MAX_UINT_8?o.MAX_UINT_8:m|0}function L(m){return m<0?0:m>o.MAX_UINT_32?o.MAX_UINT_32:m|0}}),define(he[11],fe([0,1,51,13,24,54]),function(ie,e,o,t,L,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.GraphemeBreakType=e.UTF8_BOM_CHARACTER=e.UNUSUAL_LINE_TERMINATORS=e.GraphemeIterator=e.CodePointIterator=void 0,e.isFalsyOrWhitespace=W,e.format=_,e.format2=b,e.htmlAttributeEncodeValue=h,e.escape=g,e.escapeRegExpCharacters=l,e.count=u,e.truncate=a,e.truncateMiddle=d,e.trim=p,e.ltrim=r,e.rtrim=y,e.convertSimple2RegExpPattern=w,e.stripWildcards=C,e.createRegExp=i,e.regExpLeadsToEndlessLoop=n,e.splitLines=f,e.splitLinesIncludeSeparators=R,e.firstNonWhitespaceIndex=x,e.getLeadingWhitespace=v,e.lastNonWhitespaceIndex=S,e.replaceAsync=T,e.compare=O,e.compareSubstring=F,e.compareIgnoreCase=D,e.compareSubstringIgnoreCase=E,e.isAsciiDigit=M,e.isLowerAsciiLetter=A,e.isUpperAsciiLetter=I,e.equalsIgnoreCase=B,e.startsWithIgnoreCase=Y,e.commonPrefixLength=G,e.commonSuffixLength=Z,e.isHighSurrogate=se,e.isLowSurrogate=le,e.computeCodePoint=V,e.getNextCodePoint=z,e.nextCharLength=$,e.prevCharLength=ae,e.getCharContainingOffset=de,e.charCount=te,e.containsRTL=oe,e.isBasicASCII=K,e.containsUnusualLineTerminators=U,e.isFullWidthCharacter=k,e.isEmojiImprecise=H,e.lcut=J,e.forAnsiStringParts=_e,e.removeAnsiEscapeCodes=we,e.removeAnsiEscapeCodesFromPrompt=Ae,e.startsWithUTF8BOM=ye,e.stripUTF8BOM=me,e.fuzzyContains=ve,e.containsUppercaseCharacter=pe,e.uppercaseFirstLetter=be,e.getNLines=Le,e.singleLetterHash=Ce,e.getGraphemeBreakType=Re,e.getLeftDeleteOffset=Ge;function W(q){return!q||typeof q!="string"?!0:q.trim().length===0}const P=/{(\d+)}/g;function _(q,...X){return X.length===0?q:q.replace(P,function(re,ce){const Ee=parseInt(ce,10);return isNaN(Ee)||Ee<0||Ee>=X.length?re:X[Ee]})}const s=/{([^}]+)}/g;function b(q,X){return Object.keys(X).length===0?q:q.replace(s,(re,ce)=>X[ce]??re)}function h(q){return q.replace(/[<>"'&]/g,X=>{switch(X){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return X})}function g(q){return q.replace(/[<>&]/g,function(X){switch(X){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return X}})}function l(q){return q.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function u(q,X){let re=0,ce=q.indexOf(X);for(;ce!==-1;)re++,ce=q.indexOf(X,ce+X.length);return re}function a(q,X,re="\u2026"){return q.length<=X?q:`${q.substr(0,X)}${re}`}function d(q,X,re="\u2026"){if(q.length<=X)return q;const ce=Math.ceil(X/2)-re.length/2,Ee=Math.floor(X/2)-re.length/2;return`${q.substr(0,ce)}${re}${q.substr(q.length-Ee)}`}function p(q,X=" "){const re=r(q,X);return y(re,X)}function r(q,X){if(!q||!X)return q;const re=X.length;if(re===0||q.length===0)return q;let ce=0;for(;q.indexOf(X,ce)===ce;)ce=ce+re;return q.substring(ce)}function y(q,X){if(!q||!X)return q;const re=X.length,ce=q.length;if(re===0||ce===0)return q;let Ee=ce,De=-1;for(;De=q.lastIndexOf(X,Ee-1),!(De===-1||De+re!==Ee);){if(De===0)return"";Ee=De}return q.substring(0,Ee)}function w(q){return q.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function C(q){return q.replace(/\*/g,"")}function i(q,X,re={}){if(!q)throw new Error("Cannot create regex from empty string");X||(q=l(q)),re.wholeWord&&(/\B/.test(q.charAt(0))||(q="\\b"+q),/\B/.test(q.charAt(q.length-1))||(q=q+"\\b"));let ce="";return re.global&&(ce+="g"),re.matchCase||(ce+="i"),re.multiline&&(ce+="m"),re.unicode&&(ce+="u"),new RegExp(q,ce)}function n(q){return q.source==="^"||q.source==="^$"||q.source==="$"||q.source==="^\\s*$"?!1:!!(q.exec("")&&q.lastIndex===0)}function f(q){return q.split(/\r\n|\r|\n/)}function R(q){const X=[],re=q.split(/(\r\n|\r|\n)/);for(let ce=0;ce<Math.ceil(re.length/2);ce++)X.push(re[2*ce]+(re[2*ce+1]??""));return X}function x(q){for(let X=0,re=q.length;X<re;X++){const ce=q.charCodeAt(X);if(ce!==t.CharCode.Space&&ce!==t.CharCode.Tab)return X}return-1}function v(q,X=0,re=q.length){for(let ce=X;ce<re;ce++){const Ee=q.charCodeAt(ce);if(Ee!==t.CharCode.Space&&Ee!==t.CharCode.Tab)return q.substring(X,ce)}return q.substring(X,re)}function S(q,X=q.length-1){for(let re=X;re>=0;re--){const ce=q.charCodeAt(re);if(ce!==t.CharCode.Space&&ce!==t.CharCode.Tab)return re}return-1}function T(q,X,re){const ce=[];let Ee=0;for(const De of q.matchAll(X)){if(ce.push(q.slice(Ee,De.index)),De.index===void 0)throw new Error("match.index should be defined");Ee=De.index+De[0].length,ce.push(re(De[0],...De.slice(1),De.index,q,De.groups))}return ce.push(q.slice(Ee)),Promise.all(ce).then(De=>De.join(""))}function O(q,X){return q<X?-1:q>X?1:0}function F(q,X,re=0,ce=q.length,Ee=0,De=X.length){for(;re<ce&&Ee<De;re++,Ee++){const Ue=q.charCodeAt(re),Ne=X.charCodeAt(Ee);if(Ue<Ne)return-1;if(Ue>Ne)return 1}const ke=ce-re,Be=De-Ee;return ke<Be?-1:ke>Be?1:0}function D(q,X){return E(q,X,0,q.length,0,X.length)}function E(q,X,re=0,ce=q.length,Ee=0,De=X.length){for(;re<ce&&Ee<De;re++,Ee++){let Ue=q.charCodeAt(re),Ne=X.charCodeAt(Ee);if(Ue===Ne)continue;if(Ue>=128||Ne>=128)return F(q.toLowerCase(),X.toLowerCase(),re,ce,Ee,De);A(Ue)&&(Ue-=32),A(Ne)&&(Ne-=32);const Oe=Ue-Ne;if(Oe!==0)return Oe}const ke=ce-re,Be=De-Ee;return ke<Be?-1:ke>Be?1:0}function M(q){return q>=t.CharCode.Digit0&&q<=t.CharCode.Digit9}function A(q){return q>=t.CharCode.a&&q<=t.CharCode.z}function I(q){return q>=t.CharCode.A&&q<=t.CharCode.Z}function B(q,X){return q.length===X.length&&E(q,X)===0}function Y(q,X){const re=X.length;return X.length>q.length?!1:E(q,X,0,re)===0}function G(q,X){const re=Math.min(q.length,X.length);let ce;for(ce=0;ce<re;ce++)if(q.charCodeAt(ce)!==X.charCodeAt(ce))return ce;return re}function Z(q,X){const re=Math.min(q.length,X.length);let ce;const Ee=q.length-1,De=X.length-1;for(ce=0;ce<re;ce++)if(q.charCodeAt(Ee-ce)!==X.charCodeAt(De-ce))return ce;return re}function se(q){return 55296<=q&&q<=56319}function le(q){return 56320<=q&&q<=57343}function V(q,X){return(q-55296<<10)+(X-56320)+65536}function z(q,X,re){const ce=q.charCodeAt(re);if(se(ce)&&re+1<X){const Ee=q.charCodeAt(re+1);if(le(Ee))return V(ce,Ee)}return ce}function Q(q,X){const re=q.charCodeAt(X-1);if(le(re)&&X>1){const ce=q.charCodeAt(X-2);if(se(ce))return V(ce,re)}return re}class ee{get offset(){return this._offset}constructor(X,re=0){this._str=X,this._len=X.length,this._offset=re}setOffset(X){this._offset=X}prevCodePoint(){const X=Q(this._str,this._offset);return this._offset-=X>=m.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,X}nextCodePoint(){const X=z(this._str,this._len,this._offset);return this._offset+=X>=m.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,X}eol(){return this._offset>=this._len}}e.CodePointIterator=ee;class ue{get offset(){return this._iterator.offset}constructor(X,re=0){this._iterator=new ee(X,re)}nextGraphemeLength(){const X=Me.getInstance(),re=this._iterator,ce=re.offset;let Ee=X.getGraphemeBreakType(re.nextCodePoint());for(;!re.eol();){const De=re.offset,ke=X.getGraphemeBreakType(re.nextCodePoint());if(Te(Ee,ke)){re.setOffset(De);break}Ee=ke}return re.offset-ce}prevGraphemeLength(){const X=Me.getInstance(),re=this._iterator,ce=re.offset;let Ee=X.getGraphemeBreakType(re.prevCodePoint());for(;re.offset>0;){const De=re.offset,ke=X.getGraphemeBreakType(re.prevCodePoint());if(Te(ke,Ee)){re.setOffset(De);break}Ee=ke}return ce-re.offset}eol(){return this._iterator.eol()}}e.GraphemeIterator=ue;function $(q,X){return new ue(q,X).nextGraphemeLength()}function ae(q,X){return new ue(q,X).prevGraphemeLength()}function de(q,X){X>0&&le(q.charCodeAt(X))&&X--;const re=X+$(q,X);return[re-ae(q,re),re]}function te(q){const X=new ue(q);let re=0;for(;!X.eol();)re++,X.nextGraphemeLength();return re}let c;function j(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function oe(q){return c||(c=j()),c.test(q)}const N=/^[\t\n\r\x20-\x7E]*$/;function K(q){return N.test(q)}e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function U(q){return e.UNUSUAL_LINE_TERMINATORS.test(q)}function k(q){return q>=11904&&q<=55215||q>=63744&&q<=64255||q>=65281&&q<=65374}function H(q){return q>=127462&&q<=127487||q===8986||q===8987||q===9200||q===9203||q>=9728&&q<=10175||q===11088||q===11093||q>=127744&&q<=128591||q>=128640&&q<=128764||q>=128992&&q<=129008||q>=129280&&q<=129535||q>=129648&&q<=129782}function J(q,X,re=""){const ce=q.trimStart();if(ce.length<X)return ce;const Ee=/\b/g;let De=0;for(;Ee.test(ce)&&!(ce.length-Ee.lastIndex<X);)De=Ee.lastIndex,Ee.lastIndex+=1;return De===0?ce:re+ce.substring(De).trimStart()}const ne=/(?:(?:\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~])|(:?\x1b\].*?\x07)/g;function*_e(q){let X=0;for(const re of q.matchAll(ne))X!==re.index&&(yield{isCode:!1,str:q.substring(X,re.index)}),yield{isCode:!0,str:re[0]},X=re.index+re[0].length;X!==q.length&&(yield{isCode:!1,str:q.substring(X)})}function we(q){return q&&(q=q.replace(ne,"")),q}const Ie=/\\\[.*?\\\]/g;function Ae(q){return we(q).replace(Ie,"")}e.UTF8_BOM_CHARACTER=String.fromCharCode(t.CharCode.UTF8_BOM);function ye(q){return!!(q&&q.length>0&&q.charCodeAt(0)===t.CharCode.UTF8_BOM)}function me(q){return ye(q)?q.substr(1):q}function ve(q,X){if(!q||!X||q.length<X.length)return!1;const re=X.length,ce=q.toLowerCase();let Ee=0,De=-1;for(;Ee<re;){const ke=ce.indexOf(X[Ee],De+1);if(ke<0)return!1;De=ke,Ee++}return!0}function pe(q,X=!1){return q?(X&&(q=q.replace(/\\./g,"")),q.toLowerCase()!==q):!1}function be(q){return q.charAt(0).toUpperCase()+q.slice(1)}function Le(q,X=1){if(X===0)return"";let re=-1;do re=q.indexOf(`
`,re+1),X--;while(X>0&&re>=0);return re===-1?q:(q[re-1]==="\r"&&re--,q.substr(0,re))}function Ce(q){const X=t.CharCode.Z-t.CharCode.A+1;return q=q%(2*X),q<X?String.fromCharCode(t.CharCode.a+q):String.fromCharCode(t.CharCode.A+q-X)}function Re(q){return Me.getInstance().getGraphemeBreakType(q)}function Te(q,X){return q===Se.Other?X!==Se.Extend&&X!==Se.SpacingMark:q===Se.CR&&X===Se.LF?!1:q===Se.Control||q===Se.CR||q===Se.LF||X===Se.Control||X===Se.CR||X===Se.LF?!0:!(q===Se.L&&(X===Se.L||X===Se.V||X===Se.LV||X===Se.LVT)||(q===Se.LV||q===Se.V)&&(X===Se.V||X===Se.T)||(q===Se.LVT||q===Se.T)&&X===Se.T||X===Se.Extend||X===Se.ZWJ||X===Se.SpacingMark||q===Se.Prepend||q===Se.ZWJ&&X===Se.Extended_Pictographic||q===Se.Regional_Indicator&&X===Se.Regional_Indicator)}var Se;(function(q){q[q.Other=0]="Other",q[q.Prepend=1]="Prepend",q[q.CR=2]="CR",q[q.LF=3]="LF",q[q.Control=4]="Control",q[q.Extend=5]="Extend",q[q.Regional_Indicator=6]="Regional_Indicator",q[q.SpacingMark=7]="SpacingMark",q[q.L=8]="L",q[q.V=9]="V",q[q.T=10]="T",q[q.LV=11]="LV",q[q.LVT=12]="LVT",q[q.ZWJ=13]="ZWJ",q[q.Extended_Pictographic=14]="Extended_Pictographic"})(Se||(e.GraphemeBreakType=Se={}));class Me{static{this._INSTANCE=null}static getInstance(){return Me._INSTANCE||(Me._INSTANCE=new Me),Me._INSTANCE}constructor(){this._data=qe()}getGraphemeBreakType(X){if(X<32)return X===t.CharCode.LineFeed?Se.LF:X===t.CharCode.CarriageReturn?Se.CR:Se.Control;if(X<127)return Se.Other;const re=this._data,ce=re.length/3;let Ee=1;for(;Ee<=ce;)if(X<re[3*Ee])Ee=2*Ee;else if(X>re[3*Ee+1])Ee=2*Ee+1;else return re[3*Ee+2];return Se.Other}}function qe(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Ge(q,X){if(q===0)return 0;const re=xe(q,X);if(re!==void 0)return re;const ce=new ee(X,q);return ce.prevCodePoint(),ce.offset}function xe(q,X){const re=new ee(X,q);let ce=re.prevCodePoint();for(;Xe(ce)||ce===$e.emojiVariantSelector||ce===$e.enclosingKeyCap;){if(re.offset===0)return;ce=re.prevCodePoint()}if(!H(ce))return;let Ee=re.offset;return Ee>0&&re.prevCodePoint()===$e.zwj&&(Ee=re.offset),Ee}function Xe(q){return 127995<=q&&q<=127999}var $e;(function(q){q[q.zwj=8205]="zwj",q[q.emojiVariantSelector=65039]="emojiVariantSelector",q[q.enclosingKeyCap=8419]="enclosingKeyCap"})($e||($e={})),e.noBreakWhitespace="\xA0";class je{static{this.ambiguousCharacterData=new L.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.cache=new o.LRUCachedFunction({getCacheKey:JSON.stringify},X=>{function re(Oe){const ze=new Map;for(let Fe=0;Fe<Oe.length;Fe+=2)ze.set(Oe[Fe],Oe[Fe+1]);return ze}function ce(Oe,ze){const Fe=new Map(Oe);for(const[Ve,Qe]of ze)Fe.set(Ve,Qe);return Fe}function Ee(Oe,ze){if(!Oe)return ze;const Fe=new Map;for(const[Ve,Qe]of Oe)ze.has(Ve)&&Fe.set(Ve,Qe);return Fe}const De=this.ambiguousCharacterData.value;let ke=X.filter(Oe=>!Oe.startsWith("_")&&Oe in De);ke.length===0&&(ke=["_default"]);let Be;for(const Oe of ke){const ze=re(De[Oe]);Be=Ee(Be,ze)}const Ue=re(De._common),Ne=ce(Ue,Be);return new je(Ne)})}static getInstance(X){return je.cache.get(Array.from(X))}static{this._locales=new L.Lazy(()=>Object.keys(je.ambiguousCharacterData.value).filter(X=>!X.startsWith("_")))}static getLocales(){return je._locales.value}constructor(X){this.confusableDictionary=X}isAmbiguous(X){return this.confusableDictionary.has(X)}containsAmbiguousCharacter(X){for(let re=0;re<X.length;re++){const ce=X.codePointAt(re);if(typeof ce=="number"&&this.isAmbiguous(ce))return!0}return!1}getPrimaryConfusable(X){return this.confusableDictionary.get(X)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}e.AmbiguousCharacters=je;class He{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this._data=void 0}static getData(){return this._data||(this._data=new Set(He.getRawData())),this._data}static isInvisibleCharacter(X){return He.getData().has(X)}static containsInvisibleCharacter(X){for(let re=0;re<X.length;re++){const ce=X.codePointAt(re);if(typeof ce=="number"&&He.isInvisibleCharacter(ce))return!0}return!1}static get codePoints(){return He.getData()}}e.InvisibleCharacters=He}),define(he[55],fe([0,1,11]),function(ie,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.Hasher=void 0,e.hash=t,e.doHash=L,e.numberHash=m,e.stringHash=P,e.toHexString=a,o=Pe(o);function t(p){return L(p,0)}function L(p,r){switch(typeof p){case"object":return p===null?m(349,r):Array.isArray(p)?_(p,r):s(p,r);case"string":return P(p,r);case"boolean":return W(p,r);case"number":return m(p,r);case"undefined":return m(937,r);default:return m(617,r)}}function m(p,r){return(r<<5)-r+p|0}function W(p,r){return m(p?433:863,r)}function P(p,r){r=m(149417,r);for(let y=0,w=p.length;y<w;y++)r=m(p.charCodeAt(y),r);return r}function _(p,r){return r=m(104579,r),p.reduce((y,w)=>L(w,y),r)}function s(p,r){return r=m(181387,r),Object.keys(p).sort().reduce((y,w)=>(y=P(w,y),L(p[w],y)),r)}class b{constructor(){this._value=0}get value(){return this._value}hash(r){return this._value=L(r,this._value),this._value}}e.Hasher=b;var h;(function(p){p[p.BLOCK_SIZE=64]="BLOCK_SIZE",p[p.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(h||(h={}));function g(p,r,y=32){const w=y-r,C=~((1<<w)-1);return(p<<r|(C&p)>>>w)>>>0}function l(p,r=0,y=p.byteLength,w=0){for(let C=0;C<y;C++)p[r+C]=w}function u(p,r,y="0"){for(;p.length<r;)p=y+p;return p}function a(p,r=32){return p instanceof ArrayBuffer?Array.from(new Uint8Array(p)).map(y=>y.toString(16).padStart(2,"0")).join(""):u((p>>>0).toString(16),r/4)}class d{static{this._bigBlock32=new DataView(new ArrayBuffer(320))}constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(h.BLOCK_SIZE+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(r){const y=r.length;if(y===0)return;const w=this._buff;let C=this._buffLen,i=this._leftoverHighSurrogate,n,f;for(i!==0?(n=i,f=-1,i=0):(n=r.charCodeAt(0),f=0);;){let R=n;if(o.isHighSurrogate(n))if(f+1<y){const x=r.charCodeAt(f+1);o.isLowSurrogate(x)?(f++,R=o.computeCodePoint(n,x)):R=h.UNICODE_REPLACEMENT}else{i=n;break}else o.isLowSurrogate(n)&&(R=h.UNICODE_REPLACEMENT);if(C=this._push(w,C,R),f++,f<y)n=r.charCodeAt(f);else break}this._buffLen=C,this._leftoverHighSurrogate=i}_push(r,y,w){return w<128?r[y++]=w:w<2048?(r[y++]=192|(w&1984)>>>6,r[y++]=128|(w&63)>>>0):w<65536?(r[y++]=224|(w&61440)>>>12,r[y++]=128|(w&4032)>>>6,r[y++]=128|(w&63)>>>0):(r[y++]=240|(w&1835008)>>>18,r[y++]=128|(w&258048)>>>12,r[y++]=128|(w&4032)>>>6,r[y++]=128|(w&63)>>>0),y>=h.BLOCK_SIZE&&(this._step(),y-=h.BLOCK_SIZE,this._totalLen+=h.BLOCK_SIZE,r[0]=r[h.BLOCK_SIZE+0],r[1]=r[h.BLOCK_SIZE+1],r[2]=r[h.BLOCK_SIZE+2]),y}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,h.UNICODE_REPLACEMENT)),this._totalLen+=this._buffLen,this._wrapUp()),a(this._h0)+a(this._h1)+a(this._h2)+a(this._h3)+a(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,l(this._buff,this._buffLen),this._buffLen>56&&(this._step(),l(this._buff));const r=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(r/4294967296),!1),this._buffDV.setUint32(60,r%4294967296,!1),this._step()}_step(){const r=d._bigBlock32,y=this._buffDV;for(let S=0;S<64;S+=4)r.setUint32(S,y.getUint32(S,!1),!1);for(let S=64;S<320;S+=4)r.setUint32(S,g(r.getUint32(S-12,!1)^r.getUint32(S-32,!1)^r.getUint32(S-56,!1)^r.getUint32(S-64,!1),1),!1);let w=this._h0,C=this._h1,i=this._h2,n=this._h3,f=this._h4,R,x,v;for(let S=0;S<80;S++)S<20?(R=C&i|~C&n,x=1518500249):S<40?(R=C^i^n,x=1859775393):S<60?(R=C&i|C&n|i&n,x=2400959708):(R=C^i^n,x=3395469782),v=g(w,5)+R+f+x+r.getUint32(S*4,!1)&4294967295,f=n,n=i,i=g(C,30),C=w,w=v;this._h0=this._h0+w&4294967295,this._h1=this._h1+C&4294967295,this._h2=this._h2+i&4294967295,this._h3=this._h3+n&4294967295,this._h4=this._h4+f&4294967295}}e.StringSHA1=d}),define(he[56],fe([0,1,17,13,11]),function(ie,e,o,t,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class m{constructor(){this._value="",this._pos=0}reset(u){return this._value=u,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(u){const a=u.charCodeAt(0),d=this._value.charCodeAt(this._pos);return a-d}value(){return this._value[this._pos]}}e.StringIterator=m;class W{constructor(u=!0){this._caseSensitive=u}reset(u){return this._value=u,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let u=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===t.CharCode.Period)if(u)this._from++;else break;else u=!1;return this}cmp(u){return this._caseSensitive?(0,L.compareSubstring)(u,this._value,0,u.length,this._from,this._to):(0,L.compareSubstringIgnoreCase)(u,this._value,0,u.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=W;class P{constructor(u=!0,a=!0){this._splitOnBackslash=u,this._caseSensitive=a}reset(u){this._from=0,this._to=0,this._value=u,this._valueLen=u.length;for(let a=u.length-1;a>=0;a--,this._valueLen--){const d=this._value.charCodeAt(a);if(!(d===t.CharCode.Slash||this._splitOnBackslash&&d===t.CharCode.Backslash))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let u=!0;for(;this._to<this._valueLen;this._to++){const a=this._value.charCodeAt(this._to);if(a===t.CharCode.Slash||this._splitOnBackslash&&a===t.CharCode.Backslash)if(u)this._from++;else break;else u=!1}return this}cmp(u){return this._caseSensitive?(0,L.compareSubstring)(u,this._value,0,u.length,this._from,this._to):(0,L.compareSubstringIgnoreCase)(u,this._value,0,u.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=P;var _;(function(l){l[l.Scheme=1]="Scheme",l[l.Authority=2]="Authority",l[l.Path=3]="Path",l[l.Query=4]="Query",l[l.Fragment=5]="Fragment"})(_||(_={}));class s{constructor(u,a){this._ignorePathCasing=u,this._ignoreQueryAndFragment=a,this._states=[],this._stateIdx=0}reset(u){return this._value=u,this._states=[],this._value.scheme&&this._states.push(_.Scheme),this._value.authority&&this._states.push(_.Authority),this._value.path&&(this._pathIterator=new P(!1,!this._ignorePathCasing(u)),this._pathIterator.reset(u.path),this._pathIterator.value()&&this._states.push(_.Path)),this._ignoreQueryAndFragment(u)||(this._value.query&&this._states.push(_.Query),this._value.fragment&&this._states.push(_.Fragment)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===_.Path&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===_.Path&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(u){if(this._states[this._stateIdx]===_.Scheme)return(0,L.compareIgnoreCase)(u,this._value.scheme);if(this._states[this._stateIdx]===_.Authority)return(0,L.compareIgnoreCase)(u,this._value.authority);if(this._states[this._stateIdx]===_.Path)return this._pathIterator.cmp(u);if(this._states[this._stateIdx]===_.Query)return(0,L.compare)(u,this._value.query);if(this._states[this._stateIdx]===_.Fragment)return(0,L.compare)(u,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===_.Scheme)return this._value.scheme;if(this._states[this._stateIdx]===_.Authority)return this._value.authority;if(this._states[this._stateIdx]===_.Path)return this._pathIterator.value();if(this._states[this._stateIdx]===_.Query)return this._value.query;if(this._states[this._stateIdx]===_.Fragment)return this._value.fragment;throw new Error}}e.UriIterator=s;class b{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const u=this.right;return this.right=u.left,u.left=this,this.updateHeight(),u.updateHeight(),u}rotateRight(){const u=this.left;return this.left=u.right,u.right=this,this.updateHeight(),u.updateHeight(),u}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var h;(function(l){l[l.Left=-1]="Left",l[l.Mid=0]="Mid",l[l.Right=1]="Right"})(h||(h={}));class g{static forUris(u=()=>!1,a=()=>!1){return new g(new s(u,a))}static forPaths(u=!1){return new g(new P(void 0,!u))}static forStrings(){return new g(new m)}static forConfigKeys(){return new g(new W)}constructor(u){this._iter=u}clear(){this._root=void 0}fill(u,a){if(a){const d=a.slice(0);(0,o.shuffle)(d);for(const p of d)this.set(p,u)}else{const d=u.slice(0);(0,o.shuffle)(d);for(const p of d)this.set(p[0],p[1])}}set(u,a){const d=this._iter.reset(u);let p;this._root||(this._root=new b,this._root.segment=d.value());const r=[];for(p=this._root;;){const w=d.cmp(p.segment);if(w>0)p.left||(p.left=new b,p.left.segment=d.value()),r.push([h.Left,p]),p=p.left;else if(w<0)p.right||(p.right=new b,p.right.segment=d.value()),r.push([h.Right,p]),p=p.right;else if(d.hasNext())d.next(),p.mid||(p.mid=new b,p.mid.segment=d.value()),r.push([h.Mid,p]),p=p.mid;else break}const y=p.value;p.value=a,p.key=u;for(let w=r.length-1;w>=0;w--){const C=r[w][1];C.updateHeight();const i=C.balanceFactor();if(i<-1||i>1){const n=r[w][0],f=r[w+1][0];if(n===h.Right&&f===h.Right)r[w][1]=C.rotateLeft();else if(n===h.Left&&f===h.Left)r[w][1]=C.rotateRight();else if(n===h.Right&&f===h.Left)C.right=r[w+1][1]=r[w+1][1].rotateRight(),r[w][1]=C.rotateLeft();else if(n===h.Left&&f===h.Right)C.left=r[w+1][1]=r[w+1][1].rotateLeft(),r[w][1]=C.rotateRight();else throw new Error;if(w>0)switch(r[w-1][0]){case h.Left:r[w-1][1].left=r[w][1];break;case h.Right:r[w-1][1].right=r[w][1];break;case h.Mid:r[w-1][1].mid=r[w][1];break}else this._root=r[0][1]}}return y}get(u){return this._getNode(u)?.value}_getNode(u){const a=this._iter.reset(u);let d=this._root;for(;d;){const p=a.cmp(d.segment);if(p>0)d=d.left;else if(p<0)d=d.right;else if(a.hasNext())a.next(),d=d.mid;else break}return d}has(u){const a=this._getNode(u);return!(a?.value===void 0&&a?.mid===void 0)}delete(u){return this._delete(u,!1)}deleteSuperstr(u){return this._delete(u,!0)}_delete(u,a){const d=this._iter.reset(u),p=[];let r=this._root;for(;r;){const y=d.cmp(r.segment);if(y>0)p.push([h.Left,r]),r=r.left;else if(y<0)p.push([h.Right,r]),r=r.right;else if(d.hasNext())d.next(),p.push([h.Mid,r]),r=r.mid;else break}if(r){if(a?(r.left=void 0,r.mid=void 0,r.right=void 0,r.height=1):(r.key=void 0,r.value=void 0),!r.mid&&!r.value)if(r.left&&r.right){const y=this._min(r.right);if(y.key){const{key:w,value:C,segment:i}=y;this._delete(y.key,!1),r.key=w,r.value=C,r.segment=i}}else{const y=r.left??r.right;if(p.length>0){const[w,C]=p[p.length-1];switch(w){case h.Left:C.left=y;break;case h.Mid:C.mid=y;break;case h.Right:C.right=y;break}}else this._root=y}for(let y=p.length-1;y>=0;y--){const w=p[y][1];w.updateHeight();const C=w.balanceFactor();if(C>1?(w.right.balanceFactor()>=0||(w.right=w.right.rotateRight()),p[y][1]=w.rotateLeft()):C<-1&&(w.left.balanceFactor()<=0||(w.left=w.left.rotateLeft()),p[y][1]=w.rotateRight()),y>0)switch(p[y-1][0]){case h.Left:p[y-1][1].left=p[y][1];break;case h.Right:p[y-1][1].right=p[y][1];break;case h.Mid:p[y-1][1].mid=p[y][1];break}else this._root=p[0][1]}}}_min(u){for(;u.left;)u=u.left;return u}findSubstr(u){const a=this._iter.reset(u);let d=this._root,p;for(;d;){const r=a.cmp(d.segment);if(r>0)d=d.left;else if(r<0)d=d.right;else if(a.hasNext())a.next(),p=d.value||p,d=d.mid;else break}return d&&d.value||p}findSuperstr(u){return this._findSuperstrOrElement(u,!1)}_findSuperstrOrElement(u,a){const d=this._iter.reset(u);let p=this._root;for(;p;){const r=d.cmp(p.segment);if(r>0)p=p.left;else if(r<0)p=p.right;else if(d.hasNext())d.next(),p=p.mid;else return p.mid?this._entries(p.mid):a?p.value:void 0}}hasElementOrSubtree(u){return this._findSuperstrOrElement(u,!0)!==void 0}forEach(u){for(const[a,d]of this)u(d,a)}*[Symbol.iterator](){yield*this._entries(this._root)}_entries(u){const a=[];return this._dfsEntries(u,a),a[Symbol.iterator]()}_dfsEntries(u,a){u&&(u.left&&this._dfsEntries(u.left,a),u.value&&a.push([u.key,u.value]),u.mid&&this._dfsEntries(u.mid,a),u.right&&this._dfsEntries(u.right,a))}_isBalanced(){const u=a=>{if(!a)return!0;const d=a.balanceFactor();return d<-1||d>1?!1:u(a.left)&&u(a.right)};return u(this._root)}}e.TernarySearchTree=g}),define(he[57],fe([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=void 0,e.isUUID=t;const o=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function t(L){return o.test(L)}e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let L;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?L=crypto.getRandomValues.bind(crypto):L=function(P){for(let _=0;_<P.length;_++)P[_]=Math.floor(Math.random()*256);return P};const m=new Uint8Array(16),W=[];for(let P=0;P<256;P++)W.push(P.toString(16).padStart(2,"0"));return function(){L(m),m[6]=m[6]&15|64,m[8]=m[8]&63|128;let _=0,s="";return s+=W[m[_++]],s+=W[m[_++]],s+=W[m[_++]],s+=W[m[_++]],s+="-",s+=W[m[_++]],s+=W[m[_++]],s+="-",s+=W[m[_++]],s+=W[m[_++]],s+="-",s+=W[m[_++]],s+=W[m[_++]],s+="-",s+=W[m[_++]],s+=W[m[_++]],s+=W[m[_++]],s+=W[m[_++]],s+=W[m[_++]],s+=W[m[_++]],s}}()}),define(he[33],fe([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isUtilityProcess=o;function o(t){return!!t.parentPort}}),define(he[34],fe([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNLSMessages=o,e.getNLSLanguage=t;function o(){return globalThis._VSCODE_NLS_MESSAGES}function t(){return globalThis._VSCODE_NLS_LANGUAGE}}),define(he[8],fe([0,1,34,34]),function(ie,e,o,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNLSMessages=e.getNLSLanguage=void 0,e.localize=W,e.localize2=_,Object.defineProperty(e,"getNLSLanguage",{enumerable:!0,get:function(){return t.getNLSLanguage}}),Object.defineProperty(e,"getNLSMessages",{enumerable:!0,get:function(){return t.getNLSMessages}});const L=(0,o.getNLSLanguage)()==="pseudo"||typeof document<"u"&&document.location&&document.location.hash.indexOf("pseudo=true")>=0;function m(s,b){let h;return b.length===0?h=s:h=s.replace(/\{(\d+)\}/g,(g,l)=>{const u=l[0],a=b[u];let d=g;return typeof a=="string"?d=a:(typeof a=="number"||typeof a=="boolean"||a===void 0||a===null)&&(d=String(a)),d}),L&&(h="\uFF3B"+h.replace(/[aouei]/g,"$&$&")+"\uFF3D"),h}function W(s,b,...h){return m(typeof s=="number"?P(s,b):b,h)}function P(s,b){const h=(0,o.getNLSMessages)()?.[s];if(typeof h!="string"){if(typeof b=="string")return b;throw new Error(`!!! NLS MISSING: ${s} !!!`)}return h}function _(s,b,...h){let g;typeof s=="number"?g=P(s,b):g=b;const l=m(g,h);return{value:l,original:b===g?l:m(b,h)}}}),define(he[58],fe([0,1,8]),function(ie,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fromNow=s,e.fromNowByDay=b,e.getDurationString=h,e.toLocalISOString=g;const t=60,L=t*60,m=L*24,W=m*7,P=m*30,_=m*365;function s(l,u,a,d){typeof l!="number"&&(l=l.getTime());const p=Math.round((new Date().getTime()-l)/1e3);if(p<-30)return(0,o.localize)(42,null,s(new Date().getTime()+p*1e3,!1));if(!d&&p<30)return(0,o.localize)(43,null);let r;return p<t?(r=p,u?r===1?a?(0,o.localize)(44,null,r):(0,o.localize)(45,null,r):a?(0,o.localize)(46,null,r):(0,o.localize)(47,null,r):r===1?a?(0,o.localize)(48,null,r):(0,o.localize)(49,null,r):a?(0,o.localize)(50,null,r):(0,o.localize)(51,null,r)):p<L?(r=Math.floor(p/t),u?r===1?a?(0,o.localize)(52,null,r):(0,o.localize)(53,null,r):a?(0,o.localize)(54,null,r):(0,o.localize)(55,null,r):r===1?a?(0,o.localize)(56,null,r):(0,o.localize)(57,null,r):a?(0,o.localize)(58,null,r):(0,o.localize)(59,null,r)):p<m?(r=Math.floor(p/L),u?r===1?a?(0,o.localize)(60,null,r):(0,o.localize)(61,null,r):a?(0,o.localize)(62,null,r):(0,o.localize)(63,null,r):r===1?a?(0,o.localize)(64,null,r):(0,o.localize)(65,null,r):a?(0,o.localize)(66,null,r):(0,o.localize)(67,null,r)):p<W?(r=Math.floor(p/m),u?r===1?(0,o.localize)(68,null,r):(0,o.localize)(69,null,r):r===1?(0,o.localize)(70,null,r):(0,o.localize)(71,null,r)):p<P?(r=Math.floor(p/W),u?r===1?a?(0,o.localize)(72,null,r):(0,o.localize)(73,null,r):a?(0,o.localize)(74,null,r):(0,o.localize)(75,null,r):r===1?a?(0,o.localize)(76,null,r):(0,o.localize)(77,null,r):a?(0,o.localize)(78,null,r):(0,o.localize)(79,null,r)):p<_?(r=Math.floor(p/P),u?r===1?a?(0,o.localize)(80,null,r):(0,o.localize)(81,null,r):a?(0,o.localize)(82,null,r):(0,o.localize)(83,null,r):r===1?a?(0,o.localize)(84,null,r):(0,o.localize)(85,null,r):a?(0,o.localize)(86,null,r):(0,o.localize)(87,null,r)):(r=Math.floor(p/_),u?r===1?a?(0,o.localize)(88,null,r):(0,o.localize)(89,null,r):a?(0,o.localize)(90,null,r):(0,o.localize)(91,null,r):r===1?a?(0,o.localize)(92,null,r):(0,o.localize)(93,null,r):a?(0,o.localize)(94,null,r):(0,o.localize)(95,null,r))}function b(l,u,a){typeof l!="number"&&(l=l.getTime());const d=new Date;d.setHours(0,0,0,0);const p=new Date(d.getTime());return p.setDate(p.getDate()-1),l>d.getTime()?(0,o.localize)(96,null):l>p.getTime()?(0,o.localize)(97,null):s(l,u,a)}function h(l,u){const a=Math.abs(l/1e3);return a<1?u?(0,o.localize)(98,null,l):(0,o.localize)(99,null,l):a<t?u?(0,o.localize)(100,null,Math.round(l)/1e3):(0,o.localize)(101,null,Math.round(l)/1e3):a<L?u?(0,o.localize)(102,null,Math.round(l/(1e3*t))):(0,o.localize)(103,null,Math.round(l/(1e3*t))):a<m?u?(0,o.localize)(104,null,Math.round(l/(1e3*L))):(0,o.localize)(105,null,Math.round(l/(1e3*L))):(0,o.localize)(106,null,Math.round(l/(1e3*m)))}function g(l){return l.getFullYear()+"-"+String(l.getMonth()+1).padStart(2,"0")+"-"+String(l.getDate()).padStart(2,"0")+"T"+String(l.getHours()).padStart(2,"0")+":"+String(l.getMinutes()).padStart(2,"0")+":"+String(l.getSeconds()).padStart(2,"0")+"."+(l.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(he[59],fe([0,1,17,10,8]),function(ie,e,o,t,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=_,e.isErrorWithActions=s,e.createErrorWithActions=b,o=Pe(o),t=Pe(t),L=Pe(L);function m(h,g){return g&&(h.stack||h.stacktrace)?L.localize(107,null,P(h),W(h.stack)||W(h.stacktrace)):P(h)}function W(h){return Array.isArray(h)?h.join(`
`):h}function P(h){return h.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${h.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof h.code=="string"&&typeof h.errno=="number"&&typeof h.syscall=="string"?L.localize(108,null,h.message):h.message||L.localize(109,null)}function _(h=null,g=!1){if(!h)return L.localize(110,null);if(Array.isArray(h)){const l=o.coalesce(h),u=_(l[0],g);return l.length>1?L.localize(111,null,u,l.length):u}if(t.isString(h))return h;if(h.detail){const l=h.detail;if(l.error)return m(l.error,g);if(l.exception)return m(l.exception,g)}return h.stack?m(h,g):h.message?h.message:L.localize(112,null)}function s(h){const g=h;return g instanceof Error&&Array.isArray(g.actions)}function b(h,g){let l;return typeof h=="string"?l=new Error(h):l=h,l.actions=g,l}}),define(he[3],fe([0,1,8]),function(ie,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.platformLocale=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isMobile=e.isIOS=e.webWorkerOrigin=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.Platform=e.LANGUAGE_DEFAULT=void 0,e.PlatformToString=n,e.isLittleEndian=T,e.isBigSurOrNewer=O,o=Pe(o),e.LANGUAGE_DEFAULT="en";let t=!1,L=!1,m=!1,W=!1,P=!1,_=!1,s=!1,b=!1,h=!1,g=!1,l,u=e.LANGUAGE_DEFAULT,a=e.LANGUAGE_DEFAULT,d,p;const r=globalThis;let y;typeof r.vscode<"u"&&typeof r.vscode.process<"u"?y=r.vscode.process:typeof process<"u"&&typeof process?.versions?.node=="string"&&(y=process);const w=typeof y?.versions?.electron=="string",C=w&&y?.type==="renderer";if(typeof y=="object"){t=y.platform==="win32",L=y.platform==="darwin",m=y.platform==="linux",W=m&&!!y.env.SNAP&&!!y.env.SNAP_REVISION,s=w,h=!!y.env.CI||!!y.env.BUILD_ARTIFACTSTAGINGDIRECTORY,l=e.LANGUAGE_DEFAULT,u=e.LANGUAGE_DEFAULT;const F=y.env.VSCODE_NLS_CONFIG;if(F)try{const D=JSON.parse(F);l=D.userLocale,a=D.osLocale,u=D.resolvedLanguage||e.LANGUAGE_DEFAULT,d=D.languagePack?.translationsConfigFile}catch{}P=!0}else typeof navigator=="object"&&!C?(p=navigator.userAgent,t=p.indexOf("Windows")>=0,L=p.indexOf("Macintosh")>=0,b=(p.indexOf("Macintosh")>=0||p.indexOf("iPad")>=0||p.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,m=p.indexOf("Linux")>=0,g=p?.indexOf("Mobi")>=0,_=!0,u=o.getNLSLanguage()||e.LANGUAGE_DEFAULT,l=navigator.language.toLowerCase(),a=l):console.error("Unable to resolve platform.");var i;(function(F){F[F.Web=0]="Web",F[F.Mac=1]="Mac",F[F.Linux=2]="Linux",F[F.Windows=3]="Windows"})(i||(e.Platform=i={}));function n(F){switch(F){case i.Web:return"Web";case i.Mac:return"Mac";case i.Linux:return"Linux";case i.Windows:return"Windows"}}let f=i.Web;L?f=i.Mac:t?f=i.Windows:m&&(f=i.Linux),e.isWindows=t,e.isMacintosh=L,e.isLinux=m,e.isLinuxSnap=W,e.isNative=P,e.isElectron=s,e.isWeb=_,e.isWebWorker=_&&typeof r.importScripts=="function",e.webWorkerOrigin=e.isWebWorker?r.origin:void 0,e.isIOS=b,e.isMobile=g,e.isCI=h,e.platform=f,e.userAgent=p,e.language=u;var R;(function(F){function D(){return e.language}F.value=D;function E(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}F.isDefaultVariant=E;function M(){return e.language==="en"}F.isDefault=M})(R||(e.Language=R={})),e.locale=l,e.platformLocale=a,e.translationsConfigFile=d,e.setTimeout0IsFaster=typeof r.postMessage=="function"&&!r.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const F=[];r.addEventListener("message",E=>{if(E.data&&E.data.vscodeScheduleAsyncWork)for(let M=0,A=F.length;M<A;M++){const I=F[M];if(I.id===E.data.vscodeScheduleAsyncWork){F.splice(M,1),I.callback();return}}});let D=0;return E=>{const M=++D;F.push({id:M,callback:E}),r.postMessage({vscodeScheduleAsyncWork:M},"*")}}return F=>setTimeout(F)})();var x;(function(F){F[F.Windows=1]="Windows",F[F.Macintosh=2]="Macintosh",F[F.Linux=3]="Linux"})(x||(e.OperatingSystem=x={})),e.OS=L||b?x.Macintosh:t?x.Windows:x.Linux;let v=!0,S=!1;function T(){if(!S){S=!0;const F=new Uint8Array(2);F[0]=1,F[1]=2,v=new Uint16Array(F.buffer)[0]===513}return v}e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0);function O(F){return parseFloat(F)>=20}}),define(he[15],fe([0,1,3]),function(ie,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let t;const L=globalThis.vscode;if(typeof L<"u"&&typeof L.process<"u"){const m=L.process;t={get platform(){return m.platform},get arch(){return m.arch},get env(){return m.env},cwd(){return m.cwd()}}}else typeof process<"u"&&typeof process?.versions?.node=="string"?t={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:t={get platform(){return o.isWindows?"win32":o.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=t.cwd,e.env=t.env,e.platform=t.platform,e.arch=t.arch}),define(he[5],fe([0,1,15]),function(ie,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0,o=Pe(o);const t=65,L=97,m=90,W=122,P=46,_=47,s=92,b=58,h=63;class g extends Error{constructor(f,R,x){let v;typeof R=="string"&&R.indexOf("not ")===0?(v="must not be",R=R.replace(/^not /,"")):v="must be";const S=f.indexOf(".")!==-1?"property":"argument";let T=`The "${f}" ${S} ${v} of type ${R}`;T+=`. Received type ${typeof x}`,super(T),this.code="ERR_INVALID_ARG_TYPE"}}function l(n,f){if(n===null||typeof n!="object")throw new g(f,"Object",n)}function u(n,f){if(typeof n!="string")throw new g(f,"string",n)}const a=o.platform==="win32";function d(n){return n===_||n===s}function p(n){return n===_}function r(n){return n>=t&&n<=m||n>=L&&n<=W}function y(n,f,R,x){let v="",S=0,T=-1,O=0,F=0;for(let D=0;D<=n.length;++D){if(D<n.length)F=n.charCodeAt(D);else{if(x(F))break;F=_}if(x(F)){if(!(T===D-1||O===1))if(O===2){if(v.length<2||S!==2||v.charCodeAt(v.length-1)!==P||v.charCodeAt(v.length-2)!==P){if(v.length>2){const E=v.lastIndexOf(R);E===-1?(v="",S=0):(v=v.slice(0,E),S=v.length-1-v.lastIndexOf(R)),T=D,O=0;continue}else if(v.length!==0){v="",S=0,T=D,O=0;continue}}f&&(v+=v.length>0?`${R}..`:"..",S=2)}else v.length>0?v+=`${R}${n.slice(T+1,D)}`:v=n.slice(T+1,D),S=D-T-1;T=D,O=0}else F===P&&O!==-1?++O:O=-1}return v}function w(n){return n?`${n[0]==="."?"":"."}${n}`:""}function C(n,f){l(f,"pathObject");const R=f.dir||f.root,x=f.base||`${f.name||""}${w(f.ext)}`;return R?R===f.root?`${R}${x}`:`${R}${n}${x}`:x}e.win32={resolve(...n){let f="",R="",x=!1;for(let v=n.length-1;v>=-1;v--){let S;if(v>=0){if(S=n[v],u(S,`paths[${v}]`),S.length===0)continue}else f.length===0?S=o.cwd():(S=o.env[`=${f}`]||o.cwd(),(S===void 0||S.slice(0,2).toLowerCase()!==f.toLowerCase()&&S.charCodeAt(2)===s)&&(S=`${f}\\`));const T=S.length;let O=0,F="",D=!1;const E=S.charCodeAt(0);if(T===1)d(E)&&(O=1,D=!0);else if(d(E))if(D=!0,d(S.charCodeAt(1))){let M=2,A=M;for(;M<T&&!d(S.charCodeAt(M));)M++;if(M<T&&M!==A){const I=S.slice(A,M);for(A=M;M<T&&d(S.charCodeAt(M));)M++;if(M<T&&M!==A){for(A=M;M<T&&!d(S.charCodeAt(M));)M++;(M===T||M!==A)&&(F=`\\\\${I}\\${S.slice(A,M)}`,O=M)}}}else O=1;else r(E)&&S.charCodeAt(1)===b&&(F=S.slice(0,2),O=2,T>2&&d(S.charCodeAt(2))&&(D=!0,O=3));if(F.length>0)if(f.length>0){if(F.toLowerCase()!==f.toLowerCase())continue}else f=F;if(x){if(f.length>0)break}else if(R=`${S.slice(O)}\\${R}`,x=D,D&&f.length>0)break}return R=y(R,!x,"\\",d),x?`${f}\\${R}`:`${f}${R}`||"."},normalize(n){u(n,"path");const f=n.length;if(f===0)return".";let R=0,x,v=!1;const S=n.charCodeAt(0);if(f===1)return p(S)?"\\":n;if(d(S))if(v=!0,d(n.charCodeAt(1))){let O=2,F=O;for(;O<f&&!d(n.charCodeAt(O));)O++;if(O<f&&O!==F){const D=n.slice(F,O);for(F=O;O<f&&d(n.charCodeAt(O));)O++;if(O<f&&O!==F){for(F=O;O<f&&!d(n.charCodeAt(O));)O++;if(O===f)return`\\\\${D}\\${n.slice(F)}\\`;O!==F&&(x=`\\\\${D}\\${n.slice(F,O)}`,R=O)}}}else R=1;else r(S)&&n.charCodeAt(1)===b&&(x=n.slice(0,2),R=2,f>2&&d(n.charCodeAt(2))&&(v=!0,R=3));let T=R<f?y(n.slice(R),!v,"\\",d):"";return T.length===0&&!v&&(T="."),T.length>0&&d(n.charCodeAt(f-1))&&(T+="\\"),x===void 0?v?`\\${T}`:T:v?`${x}\\${T}`:`${x}${T}`},isAbsolute(n){u(n,"path");const f=n.length;if(f===0)return!1;const R=n.charCodeAt(0);return d(R)||f>2&&r(R)&&n.charCodeAt(1)===b&&d(n.charCodeAt(2))},join(...n){if(n.length===0)return".";let f,R;for(let S=0;S<n.length;++S){const T=n[S];u(T,"path"),T.length>0&&(f===void 0?f=R=T:f+=`\\${T}`)}if(f===void 0)return".";let x=!0,v=0;if(typeof R=="string"&&d(R.charCodeAt(0))){++v;const S=R.length;S>1&&d(R.charCodeAt(1))&&(++v,S>2&&(d(R.charCodeAt(2))?++v:x=!1))}if(x){for(;v<f.length&&d(f.charCodeAt(v));)v++;v>=2&&(f=`\\${f.slice(v)}`)}return e.win32.normalize(f)},relative(n,f){if(u(n,"from"),u(f,"to"),n===f)return"";const R=e.win32.resolve(n),x=e.win32.resolve(f);if(R===x||(n=R.toLowerCase(),f=x.toLowerCase(),n===f))return"";let v=0;for(;v<n.length&&n.charCodeAt(v)===s;)v++;let S=n.length;for(;S-1>v&&n.charCodeAt(S-1)===s;)S--;const T=S-v;let O=0;for(;O<f.length&&f.charCodeAt(O)===s;)O++;let F=f.length;for(;F-1>O&&f.charCodeAt(F-1)===s;)F--;const D=F-O,E=T<D?T:D;let M=-1,A=0;for(;A<E;A++){const B=n.charCodeAt(v+A);if(B!==f.charCodeAt(O+A))break;B===s&&(M=A)}if(A!==E){if(M===-1)return x}else{if(D>E){if(f.charCodeAt(O+A)===s)return x.slice(O+A+1);if(A===2)return x.slice(O+A)}T>E&&(n.charCodeAt(v+A)===s?M=A:A===2&&(M=3)),M===-1&&(M=0)}let I="";for(A=v+M+1;A<=S;++A)(A===S||n.charCodeAt(A)===s)&&(I+=I.length===0?"..":"\\..");return O+=M,I.length>0?`${I}${x.slice(O,F)}`:(x.charCodeAt(O)===s&&++O,x.slice(O,F))},toNamespacedPath(n){if(typeof n!="string"||n.length===0)return n;const f=e.win32.resolve(n);if(f.length<=2)return n;if(f.charCodeAt(0)===s){if(f.charCodeAt(1)===s){const R=f.charCodeAt(2);if(R!==h&&R!==P)return`\\\\?\\UNC\\${f.slice(2)}`}}else if(r(f.charCodeAt(0))&&f.charCodeAt(1)===b&&f.charCodeAt(2)===s)return`\\\\?\\${f}`;return n},dirname(n){u(n,"path");const f=n.length;if(f===0)return".";let R=-1,x=0;const v=n.charCodeAt(0);if(f===1)return d(v)?n:".";if(d(v)){if(R=x=1,d(n.charCodeAt(1))){let O=2,F=O;for(;O<f&&!d(n.charCodeAt(O));)O++;if(O<f&&O!==F){for(F=O;O<f&&d(n.charCodeAt(O));)O++;if(O<f&&O!==F){for(F=O;O<f&&!d(n.charCodeAt(O));)O++;if(O===f)return n;O!==F&&(R=x=O+1)}}}}else r(v)&&n.charCodeAt(1)===b&&(R=f>2&&d(n.charCodeAt(2))?3:2,x=R);let S=-1,T=!0;for(let O=f-1;O>=x;--O)if(d(n.charCodeAt(O))){if(!T){S=O;break}}else T=!1;if(S===-1){if(R===-1)return".";S=R}return n.slice(0,S)},basename(n,f){f!==void 0&&u(f,"suffix"),u(n,"path");let R=0,x=-1,v=!0,S;if(n.length>=2&&r(n.charCodeAt(0))&&n.charCodeAt(1)===b&&(R=2),f!==void 0&&f.length>0&&f.length<=n.length){if(f===n)return"";let T=f.length-1,O=-1;for(S=n.length-1;S>=R;--S){const F=n.charCodeAt(S);if(d(F)){if(!v){R=S+1;break}}else O===-1&&(v=!1,O=S+1),T>=0&&(F===f.charCodeAt(T)?--T===-1&&(x=S):(T=-1,x=O))}return R===x?x=O:x===-1&&(x=n.length),n.slice(R,x)}for(S=n.length-1;S>=R;--S)if(d(n.charCodeAt(S))){if(!v){R=S+1;break}}else x===-1&&(v=!1,x=S+1);return x===-1?"":n.slice(R,x)},extname(n){u(n,"path");let f=0,R=-1,x=0,v=-1,S=!0,T=0;n.length>=2&&n.charCodeAt(1)===b&&r(n.charCodeAt(0))&&(f=x=2);for(let O=n.length-1;O>=f;--O){const F=n.charCodeAt(O);if(d(F)){if(!S){x=O+1;break}continue}v===-1&&(S=!1,v=O+1),F===P?R===-1?R=O:T!==1&&(T=1):R!==-1&&(T=-1)}return R===-1||v===-1||T===0||T===1&&R===v-1&&R===x+1?"":n.slice(R,v)},format:C.bind(null,"\\"),parse(n){u(n,"path");const f={root:"",dir:"",base:"",ext:"",name:""};if(n.length===0)return f;const R=n.length;let x=0,v=n.charCodeAt(0);if(R===1)return d(v)?(f.root=f.dir=n,f):(f.base=f.name=n,f);if(d(v)){if(x=1,d(n.charCodeAt(1))){let M=2,A=M;for(;M<R&&!d(n.charCodeAt(M));)M++;if(M<R&&M!==A){for(A=M;M<R&&d(n.charCodeAt(M));)M++;if(M<R&&M!==A){for(A=M;M<R&&!d(n.charCodeAt(M));)M++;M===R?x=M:M!==A&&(x=M+1)}}}}else if(r(v)&&n.charCodeAt(1)===b){if(R<=2)return f.root=f.dir=n,f;if(x=2,d(n.charCodeAt(2))){if(R===3)return f.root=f.dir=n,f;x=3}}x>0&&(f.root=n.slice(0,x));let S=-1,T=x,O=-1,F=!0,D=n.length-1,E=0;for(;D>=x;--D){if(v=n.charCodeAt(D),d(v)){if(!F){T=D+1;break}continue}O===-1&&(F=!1,O=D+1),v===P?S===-1?S=D:E!==1&&(E=1):S!==-1&&(E=-1)}return O!==-1&&(S===-1||E===0||E===1&&S===O-1&&S===T+1?f.base=f.name=n.slice(T,O):(f.name=n.slice(T,S),f.base=n.slice(T,O),f.ext=n.slice(S,O))),T>0&&T!==x?f.dir=n.slice(0,T-1):f.dir=f.root,f},sep:"\\",delimiter:";",win32:null,posix:null};const i=(()=>{if(a){const n=/\\/g;return()=>{const f=o.cwd().replace(n,"/");return f.slice(f.indexOf("/"))}}return()=>o.cwd()})();e.posix={resolve(...n){let f="",R=!1;for(let x=n.length-1;x>=-1&&!R;x--){const v=x>=0?n[x]:i();u(v,`paths[${x}]`),v.length!==0&&(f=`${v}/${f}`,R=v.charCodeAt(0)===_)}return f=y(f,!R,"/",p),R?`/${f}`:f.length>0?f:"."},normalize(n){if(u(n,"path"),n.length===0)return".";const f=n.charCodeAt(0)===_,R=n.charCodeAt(n.length-1)===_;return n=y(n,!f,"/",p),n.length===0?f?"/":R?"./":".":(R&&(n+="/"),f?`/${n}`:n)},isAbsolute(n){return u(n,"path"),n.length>0&&n.charCodeAt(0)===_},join(...n){if(n.length===0)return".";let f;for(let R=0;R<n.length;++R){const x=n[R];u(x,"path"),x.length>0&&(f===void 0?f=x:f+=`/${x}`)}return f===void 0?".":e.posix.normalize(f)},relative(n,f){if(u(n,"from"),u(f,"to"),n===f||(n=e.posix.resolve(n),f=e.posix.resolve(f),n===f))return"";const R=1,x=n.length,v=x-R,S=1,T=f.length-S,O=v<T?v:T;let F=-1,D=0;for(;D<O;D++){const M=n.charCodeAt(R+D);if(M!==f.charCodeAt(S+D))break;M===_&&(F=D)}if(D===O)if(T>O){if(f.charCodeAt(S+D)===_)return f.slice(S+D+1);if(D===0)return f.slice(S+D)}else v>O&&(n.charCodeAt(R+D)===_?F=D:D===0&&(F=0));let E="";for(D=R+F+1;D<=x;++D)(D===x||n.charCodeAt(D)===_)&&(E+=E.length===0?"..":"/..");return`${E}${f.slice(S+F)}`},toNamespacedPath(n){return n},dirname(n){if(u(n,"path"),n.length===0)return".";const f=n.charCodeAt(0)===_;let R=-1,x=!0;for(let v=n.length-1;v>=1;--v)if(n.charCodeAt(v)===_){if(!x){R=v;break}}else x=!1;return R===-1?f?"/":".":f&&R===1?"//":n.slice(0,R)},basename(n,f){f!==void 0&&u(f,"ext"),u(n,"path");let R=0,x=-1,v=!0,S;if(f!==void 0&&f.length>0&&f.length<=n.length){if(f===n)return"";let T=f.length-1,O=-1;for(S=n.length-1;S>=0;--S){const F=n.charCodeAt(S);if(F===_){if(!v){R=S+1;break}}else O===-1&&(v=!1,O=S+1),T>=0&&(F===f.charCodeAt(T)?--T===-1&&(x=S):(T=-1,x=O))}return R===x?x=O:x===-1&&(x=n.length),n.slice(R,x)}for(S=n.length-1;S>=0;--S)if(n.charCodeAt(S)===_){if(!v){R=S+1;break}}else x===-1&&(v=!1,x=S+1);return x===-1?"":n.slice(R,x)},extname(n){u(n,"path");let f=-1,R=0,x=-1,v=!0,S=0;for(let T=n.length-1;T>=0;--T){const O=n.charCodeAt(T);if(O===_){if(!v){R=T+1;break}continue}x===-1&&(v=!1,x=T+1),O===P?f===-1?f=T:S!==1&&(S=1):f!==-1&&(S=-1)}return f===-1||x===-1||S===0||S===1&&f===x-1&&f===R+1?"":n.slice(f,x)},format:C.bind(null,"/"),parse(n){u(n,"path");const f={root:"",dir:"",base:"",ext:"",name:""};if(n.length===0)return f;const R=n.charCodeAt(0)===_;let x;R?(f.root="/",x=1):x=0;let v=-1,S=0,T=-1,O=!0,F=n.length-1,D=0;for(;F>=x;--F){const E=n.charCodeAt(F);if(E===_){if(!O){S=F+1;break}continue}T===-1&&(O=!1,T=F+1),E===P?v===-1?v=F:D!==1&&(D=1):v!==-1&&(D=-1)}if(T!==-1){const E=S===0&&R?1:S;v===-1||D===0||D===1&&v===T-1&&v===S+1?f.base=f.name=n.slice(E,T):(f.name=n.slice(E,v),f.base=n.slice(E,T),f.ext=n.slice(v,T))}return S>0?f.dir=n.slice(0,S-1):R&&(f.dir="/"),f},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=a?e.win32.normalize:e.posix.normalize,e.isAbsolute=a?e.win32.isAbsolute:e.posix.isAbsolute,e.join=a?e.win32.join:e.posix.join,e.resolve=a?e.win32.resolve:e.posix.resolve,e.relative=a?e.win32.relative:e.posix.relative,e.dirname=a?e.win32.dirname:e.posix.dirname,e.basename=a?e.win32.basename:e.posix.basename,e.extname=a?e.win32.extname:e.posix.extname,e.format=a?e.win32.format:e.posix.format,e.parse=a?e.win32.parse:e.posix.parse,e.toNamespacedPath=a?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=a?e.win32.sep:e.posix.sep,e.delimiter=a?e.win32.delimiter:e.posix.delimiter}),define(he[35],fe([0,1,13,5,3,11,10]),function(ie,e,o,t,L,m,W){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPathSeparator=P,e.toSlashes=_,e.toPosixPath=s,e.getRoot=b,e.isUNC=h,e.isValidBasename=a,e.isEqual=d,e.isEqualOrParent=p,e.isWindowsDriveLetter=r,e.sanitizeFilePath=y,e.removeTrailingPathSeparator=w,e.isRootOrDriveLetter=C,e.hasDriveLetter=i,e.getDriveLetter=n,e.indexOfPath=f,e.parseLineAndColumnAware=R,e.randomPath=S;function P(T){return T===o.CharCode.Slash||T===o.CharCode.Backslash}function _(T){return T.replace(/[\\/]/g,t.posix.sep)}function s(T){return T.indexOf("/")===-1&&(T=_(T)),/^[a-zA-Z]:(\/|$)/.test(T)&&(T="/"+T),T}function b(T,O=t.posix.sep){if(!T)return"";const F=T.length,D=T.charCodeAt(0);if(P(D)){if(P(T.charCodeAt(1))&&!P(T.charCodeAt(2))){let M=3;const A=M;for(;M<F&&!P(T.charCodeAt(M));M++);if(A!==M&&!P(T.charCodeAt(M+1))){for(M+=1;M<F;M++)if(P(T.charCodeAt(M)))return T.slice(0,M+1).replace(/[\\/]/g,O)}}return O}else if(r(D)&&T.charCodeAt(1)===o.CharCode.Colon)return P(T.charCodeAt(2))?T.slice(0,2)+O:T.slice(0,2);let E=T.indexOf("://");if(E!==-1){for(E+=3;E<F;E++)if(P(T.charCodeAt(E)))return T.slice(0,E+1)}return""}function h(T){if(!L.isWindows||!T||T.length<5)return!1;let O=T.charCodeAt(0);if(O!==o.CharCode.Backslash||(O=T.charCodeAt(1),O!==o.CharCode.Backslash))return!1;let F=2;const D=F;for(;F<T.length&&(O=T.charCodeAt(F),O!==o.CharCode.Backslash);F++);return!(D===F||(O=T.charCodeAt(F+1),isNaN(O)||O===o.CharCode.Backslash))}const g=/[\\/:\*\?"<>\|]/g,l=/[/]/g,u=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function a(T,O=L.isWindows){const F=O?g:l;return!(!T||T.length===0||/^\s+$/.test(T)||(F.lastIndex=0,F.test(T))||O&&u.test(T)||T==="."||T===".."||O&&T[T.length-1]==="."||O&&T.length!==T.trim().length||T.length>255)}function d(T,O,F){const D=T===O;return!F||D?D:!T||!O?!1:(0,m.equalsIgnoreCase)(T,O)}function p(T,O,F,D=t.sep){if(T===O)return!0;if(!T||!O||O.length>T.length)return!1;if(F){if(!(0,m.startsWithIgnoreCase)(T,O))return!1;if(O.length===T.length)return!0;let M=O.length;return O.charAt(O.length-1)===D&&M--,T.charAt(M)===D}return O.charAt(O.length-1)!==D&&(O+=D),T.indexOf(O)===0}function r(T){return T>=o.CharCode.A&&T<=o.CharCode.Z||T>=o.CharCode.a&&T<=o.CharCode.z}function y(T,O){return L.isWindows&&T.endsWith(":")&&(T+=t.sep),(0,t.isAbsolute)(T)||(T=(0,t.join)(O,T)),T=(0,t.normalize)(T),w(T)}function w(T){return L.isWindows?(T=(0,m.rtrim)(T,t.sep),T.endsWith(":")&&(T+=t.sep)):(T=(0,m.rtrim)(T,t.sep),T||(T=t.sep)),T}function C(T){const O=(0,t.normalize)(T);return L.isWindows?T.length>3?!1:i(O)&&(T.length===2||O.charCodeAt(2)===o.CharCode.Backslash):O===t.posix.sep}function i(T,O=L.isWindows){return O?r(T.charCodeAt(0))&&T.charCodeAt(1)===o.CharCode.Colon:!1}function n(T,O=L.isWindows){return i(T,O)?T[0]:void 0}function f(T,O,F){return O.length>T.length?-1:T===O?0:(F&&(T=T.toLowerCase(),O=O.toLowerCase()),T.indexOf(O))}function R(T){const O=T.split(":");let F,D,E;for(const M of O){const A=Number(M);(0,W.isNumber)(A)?D===void 0?D=A:E===void 0&&(E=A):F=F?[F,M].join(":"):M}if(!F)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:F,line:D!==void 0?D:void 0,column:E!==void 0?E:D!==void 0?1:void 0}}const x="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",v="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function S(T,O,F=8){let D="";for(let M=0;M<F;M++){let A;M===0&&L.isWindows&&!O&&(F===3||F===4)?A=v:A=x,D+=A.charAt(Math.floor(Math.random()*A.length))}let E;return O?E=`${O}-${D}`:E=D,T?(0,t.join)(T,E):E}}),define(he[36],fe([0,1,3]),function(ie,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminateResponseCode=e.Source=void 0,e.sanitizeProcessEnvironment=m,e.removeDangerousEnvVariables=W;var t;(function(P){P[P.stdout=0]="stdout",P[P.stderr=1]="stderr"})(t||(e.Source=t={}));var L;(function(P){P[P.Success=0]="Success",P[P.Unknown=1]="Unknown",P[P.AccessDenied=2]="AccessDenied",P[P.ProcessNotFound=3]="ProcessNotFound"})(L||(e.TerminateResponseCode=L={}));function m(P,..._){const s=_.reduce((g,l)=>(g[l]=!0,g),{}),b=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(P).filter(g=>!s[g]).forEach(g=>{for(let l=0;l<b.length;l++)if(g.search(b[l])!==-1){delete P[g];break}})}function W(P){P&&(delete P.DEBUG,o.isLinux&&delete P.LD_PRELOAD)}}),define(he[6],fe([0,1,13,27,5,3]),function(ie,e,o,t,L,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URI=void 0,e.isUriComponents=d,e.uriToFsPath=i,L=Pe(L);const W=/^\w[\w\d+.-]*$/,P=/^\//,_=/^\/\//;function s(v,S){if(!v.scheme&&S)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${v.authority}", path: "${v.path}", query: "${v.query}", fragment: "${v.fragment}"}`);if(v.scheme&&!W.test(v.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(v.path){if(v.authority){if(!P.test(v.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(_.test(v.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function b(v,S){return!v&&!S?"file":v}function h(v,S){switch(v){case"https":case"http":case"file":S?S[0]!==l&&(S=l+S):S=l;break}return S}const g="",l="/",u=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class a{static isUri(S){return S instanceof a?!0:S?typeof S.authority=="string"&&typeof S.fragment=="string"&&typeof S.path=="string"&&typeof S.query=="string"&&typeof S.scheme=="string"&&typeof S.fsPath=="string"&&typeof S.with=="function"&&typeof S.toString=="function":!1}constructor(S,T,O,F,D,E=!1){typeof S=="object"?(this.scheme=S.scheme||g,this.authority=S.authority||g,this.path=S.path||g,this.query=S.query||g,this.fragment=S.fragment||g):(this.scheme=b(S,E),this.authority=T||g,this.path=h(this.scheme,O||g),this.query=F||g,this.fragment=D||g,s(this,E))}get fsPath(){return i(this,!1)}with(S){if(!S)return this;let{scheme:T,authority:O,path:F,query:D,fragment:E}=S;return T===void 0?T=this.scheme:T===null&&(T=g),O===void 0?O=this.authority:O===null&&(O=g),F===void 0?F=this.path:F===null&&(F=g),D===void 0?D=this.query:D===null&&(D=g),E===void 0?E=this.fragment:E===null&&(E=g),T===this.scheme&&O===this.authority&&F===this.path&&D===this.query&&E===this.fragment?this:new r(T,O,F,D,E)}static parse(S,T=!1){const O=u.exec(S);return O?new r(O[2]||g,x(O[4]||g),x(O[5]||g),x(O[7]||g),x(O[9]||g),T):new r(g,g,g,g,g)}static file(S){let T=g;if(m.isWindows&&(S=S.replace(/\\/g,l)),S[0]===l&&S[1]===l){const O=S.indexOf(l,2);O===-1?(T=S.substring(2),S=l):(T=S.substring(2,O),S=S.substring(O)||l)}return new r("file",T,S,g,g)}static from(S,T){return new r(S.scheme,S.authority,S.path,S.query,S.fragment,T)}static joinPath(S,...T){if(!S.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let O;return m.isWindows&&S.scheme==="file"?O=a.file(L.win32.join(i(S,!0),...T)).path:O=L.posix.join(S.path,...T),S.with({path:O})}toString(S=!1){return n(this,S)}toJSON(){return this}static revive(S){if(S){if(S instanceof a)return S;{const T=new r(S);return T._formatted=S.external??null,T._fsPath=S._sep===p?S.fsPath??null:null,T}}else return S}[Symbol.for("debug.description")](){return`URI(${this.toString()})`}}e.URI=a;function d(v){return!v||typeof v!="object"?!1:typeof v.scheme=="string"&&(typeof v.authority=="string"||typeof v.authority>"u")&&(typeof v.path=="string"||typeof v.path>"u")&&(typeof v.query=="string"||typeof v.query>"u")&&(typeof v.fragment=="string"||typeof v.fragment>"u")}const p=m.isWindows?1:void 0;class r extends a{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=i(this,!1)),this._fsPath}toString(S=!1){return S?n(this,!0):(this._formatted||(this._formatted=n(this,!1)),this._formatted)}toJSON(){const S={$mid:t.MarshalledId.Uri};return this._fsPath&&(S.fsPath=this._fsPath,S._sep=p),this._formatted&&(S.external=this._formatted),this.path&&(S.path=this.path),this.scheme&&(S.scheme=this.scheme),this.authority&&(S.authority=this.authority),this.query&&(S.query=this.query),this.fragment&&(S.fragment=this.fragment),S}}const y={[o.CharCode.Colon]:"%3A",[o.CharCode.Slash]:"%2F",[o.CharCode.QuestionMark]:"%3F",[o.CharCode.Hash]:"%23",[o.CharCode.OpenSquareBracket]:"%5B",[o.CharCode.CloseSquareBracket]:"%5D",[o.CharCode.AtSign]:"%40",[o.CharCode.ExclamationMark]:"%21",[o.CharCode.DollarSign]:"%24",[o.CharCode.Ampersand]:"%26",[o.CharCode.SingleQuote]:"%27",[o.CharCode.OpenParen]:"%28",[o.CharCode.CloseParen]:"%29",[o.CharCode.Asterisk]:"%2A",[o.CharCode.Plus]:"%2B",[o.CharCode.Comma]:"%2C",[o.CharCode.Semicolon]:"%3B",[o.CharCode.Equals]:"%3D",[o.CharCode.Space]:"%20"};function w(v,S,T){let O,F=-1;for(let D=0;D<v.length;D++){const E=v.charCodeAt(D);if(E>=o.CharCode.a&&E<=o.CharCode.z||E>=o.CharCode.A&&E<=o.CharCode.Z||E>=o.CharCode.Digit0&&E<=o.CharCode.Digit9||E===o.CharCode.Dash||E===o.CharCode.Period||E===o.CharCode.Underline||E===o.CharCode.Tilde||S&&E===o.CharCode.Slash||T&&E===o.CharCode.OpenSquareBracket||T&&E===o.CharCode.CloseSquareBracket||T&&E===o.CharCode.Colon)F!==-1&&(O+=encodeURIComponent(v.substring(F,D)),F=-1),O!==void 0&&(O+=v.charAt(D));else{O===void 0&&(O=v.substr(0,D));const M=y[E];M!==void 0?(F!==-1&&(O+=encodeURIComponent(v.substring(F,D)),F=-1),O+=M):F===-1&&(F=D)}}return F!==-1&&(O+=encodeURIComponent(v.substring(F))),O!==void 0?O:v}function C(v){let S;for(let T=0;T<v.length;T++){const O=v.charCodeAt(T);O===o.CharCode.Hash||O===o.CharCode.QuestionMark?(S===void 0&&(S=v.substr(0,T)),S+=y[O]):S!==void 0&&(S+=v[T])}return S!==void 0?S:v}function i(v,S){let T;return v.authority&&v.path.length>1&&v.scheme==="file"?T=`//${v.authority}${v.path}`:v.path.charCodeAt(0)===o.CharCode.Slash&&(v.path.charCodeAt(1)>=o.CharCode.A&&v.path.charCodeAt(1)<=o.CharCode.Z||v.path.charCodeAt(1)>=o.CharCode.a&&v.path.charCodeAt(1)<=o.CharCode.z)&&v.path.charCodeAt(2)===o.CharCode.Colon?S?T=v.path.substr(1):T=v.path[1].toLowerCase()+v.path.substr(2):T=v.path,m.isWindows&&(T=T.replace(/\//g,"\\")),T}function n(v,S){const T=S?C:w;let O="",{scheme:F,authority:D,path:E,query:M,fragment:A}=v;if(F&&(O+=F,O+=":"),(D||F==="file")&&(O+=l,O+=l),D){let I=D.indexOf("@");if(I!==-1){const B=D.substr(0,I);D=D.substr(I+1),I=B.lastIndexOf(":"),I===-1?O+=T(B,!1,!1):(O+=T(B.substr(0,I),!1,!1),O+=":",O+=T(B.substr(I+1),!1,!0)),O+="@"}D=D.toLowerCase(),I=D.lastIndexOf(":"),I===-1?O+=T(D,!1,!0):(O+=T(D.substr(0,I),!1,!0),O+=D.substr(I))}if(E){if(E.length>=3&&E.charCodeAt(0)===o.CharCode.Slash&&E.charCodeAt(2)===o.CharCode.Colon){const I=E.charCodeAt(1);I>=o.CharCode.A&&I<=o.CharCode.Z&&(E=`/${String.fromCharCode(I+32)}:${E.substr(3)}`)}else if(E.length>=2&&E.charCodeAt(1)===o.CharCode.Colon){const I=E.charCodeAt(0);I>=o.CharCode.A&&I<=o.CharCode.Z&&(E=`${String.fromCharCode(I+32)}:${E.substr(2)}`)}O+=T(E,!0,!1)}return M&&(O+="?",O+=T(M,!1,!1)),A&&(O+="#",O+=S?A:w(A,!1,!1)),O}function f(v){try{return decodeURIComponent(v)}catch{return v.length>3?v.substr(0,3)+f(v.substr(3)):v}}const R=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function x(v){return v.match(R)?v.replace(R,S=>f(S)):v}}),define(he[60],fe([0,1,6]),function(ie,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isRemoteConsoleLog=t,e.parse=L,e.getFirstFrame=m,e.log=P;function t(s){const b=s;return b&&typeof b.type=="string"&&typeof b.severity=="string"}function L(s){const b=[];let h;try{const g=JSON.parse(s.arguments),l=g[g.length-1];l&&l.__$stack&&(g.pop(),h=l.__$stack),b.push(...g)}catch{b.push("Unable to log remote console arguments",s.arguments)}return{args:b,stack:h}}function m(s){if(typeof s!="string")return m(L(s).stack);const b=s;if(b){const h=W(b),g=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(h||"");if(g&&g.length===4)return{uri:o.URI.file(g[1]),line:Number(g[2]),column:Number(g[3])}}}function W(s){if(!s)return s;const b=s.indexOf(`
`);return b===-1?s:s.substring(0,b)}function P(s,b){const{args:h,stack:g}=L(s),l=typeof h[0]=="string"&&h.length===1;let u=W(g);u&&(u=`(${u.trim()})`);let a=[];if(typeof h[0]=="string"?u&&l?a=[`%c[${b}] %c${h[0]} %c${u}`,_("blue"),_(""),_("grey")]:a=[`%c[${b}] %c${h[0]}`,_("blue"),_(""),...h.slice(1)]:a=[`%c[${b}]%`,_("blue"),...h],u&&!l&&a.push(u),typeof console[s.severity]!="function")throw new Error("Unknown console method");console[s.severity].apply(console,a)}function _(s){return`color: ${s}`}}),define(he[61],fe([0,1,19,6,27]),function(ie,e,o,t,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.stringify=m,e.parse=W,e.revive=_;function m(s){return JSON.stringify(s,P)}function W(s){let b=JSON.parse(s);return b=_(b),b}function P(s,b){return b instanceof RegExp?{$mid:L.MarshalledId.Regexp,source:b.source,flags:b.flags}:b}function _(s,b=0){if(!s||b>200)return s;if(typeof s=="object"){switch(s.$mid){case L.MarshalledId.Uri:return t.URI.revive(s);case L.MarshalledId.Regexp:return new RegExp(s.source,s.flags);case L.MarshalledId.Date:return new Date(s.source)}if(s instanceof o.VSBuffer||s instanceof Uint8Array)return s;if(Array.isArray(s))for(let h=0;h<s.length;++h)s[h]=_(s[h],b+1);else for(const h in s)Object.hasOwnProperty.call(s,h)&&(s[h]=_(s[h],b+1))}return s}}),define(he[20],fe([0,1,7,3,11,6,5]),function(ie,e,o,t,L,m,W){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.VSCODE_AUTHORITY=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0,e.matchesScheme=_,e.matchesSomeScheme=s,e.getServerRootPath=h,o=Pe(o),t=Pe(t),W=Pe(W);var P;(function(u){u.inMemory="inmemory",u.vscode="vscode",u.internal="private",u.walkThrough="walkThrough",u.walkThroughSnippet="walkThroughSnippet",u.http="http",u.https="https",u.file="file",u.mailto="mailto",u.untitled="untitled",u.data="data",u.command="command",u.vscodeRemote="vscode-remote",u.vscodeRemoteResource="vscode-remote-resource",u.vscodeManagedRemoteResource="vscode-managed-remote-resource",u.vscodeUserData="vscode-userdata",u.vscodeCustomEditor="vscode-custom-editor",u.vscodeNotebookCell="vscode-notebook-cell",u.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",u.vscodeNotebookCellMetadataDiff="vscode-notebook-cell-metadata-diff",u.vscodeNotebookCellOutput="vscode-notebook-cell-output",u.vscodeNotebookCellOutputDiff="vscode-notebook-cell-output-diff",u.vscodeNotebookMetadata="vscode-notebook-metadata",u.vscodeInteractiveInput="vscode-interactive-input",u.vscodeSettings="vscode-settings",u.vscodeWorkspaceTrust="vscode-workspace-trust",u.vscodeTerminal="vscode-terminal",u.vscodeChatCodeBlock="vscode-chat-code-block",u.vscodeChatCodeCompareBlock="vscode-chat-code-compare-block",u.vscodeChatSesssion="vscode-chat-editor",u.webviewPanel="webview-panel",u.vscodeWebview="vscode-webview",u.extension="extension",u.vscodeFileResource="vscode-file",u.tmp="tmp",u.vsls="vsls",u.vscodeSourceControl="vscode-scm",u.commentsInput="comment",u.codeSetting="code-setting",u.outputChannel="output"})(P||(e.Schemas=P={}));function _(u,a){return m.URI.isUri(u)?(0,L.equalsIgnoreCase)(u.scheme,a):(0,L.startsWithIgnoreCase)(u,a+":")}function s(u,...a){return a.some(d=>_(u,d))}e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class b{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._serverRootPath="/"}setPreferredWebSchema(a){this._preferredWebSchema=a}setDelegate(a){this._delegate=a}setServerRootPath(a,d){this._serverRootPath=h(a,d)}getServerRootPath(){return this._serverRootPath}get _remoteResourcesPath(){return W.posix.join(this._serverRootPath,P.vscodeRemoteResource)}set(a,d,p){this._hosts[a]=d,this._ports[a]=p}setConnectionToken(a,d){this._connectionTokens[a]=d}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(a){if(this._delegate)try{return this._delegate(a)}catch(C){return o.onUnexpectedError(C),a}const d=a.authority;let p=this._hosts[d];p&&p.indexOf(":")!==-1&&p.indexOf("[")===-1&&(p=`[${p}]`);const r=this._ports[d],y=this._connectionTokens[d];let w=`path=${encodeURIComponent(a.path)}`;return typeof y=="string"&&(w+=`&${e.connectionTokenQueryName}=${encodeURIComponent(y)}`),m.URI.from({scheme:t.isWeb?this._preferredWebSchema:P.vscodeRemoteResource,authority:`${p}:${r}`,path:this._remoteResourcesPath,query:w})}}e.RemoteAuthorities=new b;function h(u,a){return W.posix.join(a??"/",`${u.quality??"oss"}-${u.commit??"dev"}`)}e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked",e.VSCODE_AUTHORITY="vscode-app";class g{static{this.FALLBACK_AUTHORITY=e.VSCODE_AUTHORITY}asBrowserUri(a){const d=this.toUri(a,ie);return this.uriToBrowserUri(d)}uriToBrowserUri(a){return a.scheme===P.vscodeRemote?e.RemoteAuthorities.rewrite(a):a.scheme===P.file&&(t.isNative||t.webWorkerOrigin===`${P.vscodeFileResource}://${g.FALLBACK_AUTHORITY}`)?a.with({scheme:P.vscodeFileResource,authority:a.authority||g.FALLBACK_AUTHORITY,query:null,fragment:null}):a}asFileUri(a){const d=this.toUri(a,ie);return this.uriToFileUri(d)}uriToFileUri(a){return a.scheme===P.vscodeFileResource?a.with({scheme:P.file,authority:a.authority!==g.FALLBACK_AUTHORITY?a.authority:null,query:null,fragment:null}):a}toUri(a,d){if(m.URI.isUri(a))return a;if(globalThis._VSCODE_FILE_ROOT){const p=globalThis._VSCODE_FILE_ROOT;if(/^\w[\w\d+.-]*:\/\//.test(p))return m.URI.joinPath(m.URI.parse(p,!0),a);const r=W.join(p,a);return m.URI.file(r)}return m.URI.parse(d.toUrl(a))}}e.FileAccess=new g;var l;(function(u){const a=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);u.CoopAndCoep=Object.freeze(a.get("3"));const d="vscode-coi";function p(y){let w;typeof y=="string"?w=new URL(y).searchParams:y instanceof URL?w=y.searchParams:m.URI.isUri(y)&&(w=new URL(y.toString(!0)).searchParams);const C=w?.get(d);if(C)return a.get(C)}u.getHeadersFromQuery=p;function r(y,w,C){if(!globalThis.crossOriginIsolated)return;const i=w&&C?"3":C?"2":"1";y instanceof URLSearchParams?y.set(d,i):y[d]=i}u.addSearchParam=r})(l||(e.COI=l={}))}),define(he[25],fe([0,1,13,35,20,5,3,11,6]),function(ie,e,o,t,L,m,W,P,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=void 0,e.originalFSPath=s,e.distinctParents=h,e.toLocalResource=l,t=Pe(t),m=Pe(m);function s(u){return(0,_.uriToFsPath)(u,!0)}class b{constructor(a){this._ignorePathCasing=a}compare(a,d,p=!1){return a===d?0:(0,P.compare)(this.getComparisonKey(a,p),this.getComparisonKey(d,p))}isEqual(a,d,p=!1){return a===d?!0:!a||!d?!1:this.getComparisonKey(a,p)===this.getComparisonKey(d,p)}getComparisonKey(a,d=!1){return a.with({path:this._ignorePathCasing(a)?a.path.toLowerCase():void 0,fragment:d?null:void 0}).toString()}ignorePathCasing(a){return this._ignorePathCasing(a)}isEqualOrParent(a,d,p=!1){if(a.scheme===d.scheme){if(a.scheme===L.Schemas.file)return t.isEqualOrParent(s(a),s(d),this._ignorePathCasing(a))&&a.query===d.query&&(p||a.fragment===d.fragment);if((0,e.isEqualAuthority)(a.authority,d.authority))return t.isEqualOrParent(a.path,d.path,this._ignorePathCasing(a),"/")&&a.query===d.query&&(p||a.fragment===d.fragment)}return!1}joinPath(a,...d){return _.URI.joinPath(a,...d)}basenameOrAuthority(a){return(0,e.basename)(a)||a.authority}basename(a){return m.posix.basename(a.path)}extname(a){return m.posix.extname(a.path)}dirname(a){if(a.path.length===0)return a;let d;return a.scheme===L.Schemas.file?d=_.URI.file(m.dirname(s(a))).path:(d=m.posix.dirname(a.path),a.authority&&d.length&&d.charCodeAt(0)!==o.CharCode.Slash&&(console.error(`dirname("${a.toString})) resulted in a relative path`),d="/")),a.with({path:d})}normalizePath(a){if(!a.path.length)return a;let d;return a.scheme===L.Schemas.file?d=_.URI.file(m.normalize(s(a))).path:d=m.posix.normalize(a.path),a.with({path:d})}relativePath(a,d){if(a.scheme!==d.scheme||!(0,e.isEqualAuthority)(a.authority,d.authority))return;if(a.scheme===L.Schemas.file){const y=m.relative(s(a),s(d));return W.isWindows?t.toSlashes(y):y}let p=a.path||"/";const r=d.path||"/";if(this._ignorePathCasing(a)){let y=0;for(const w=Math.min(p.length,r.length);y<w&&!(p.charCodeAt(y)!==r.charCodeAt(y)&&p.charAt(y).toLowerCase()!==r.charAt(y).toLowerCase());y++);p=r.substr(0,y)+p.substr(y)}return m.posix.relative(p,r)}resolvePath(a,d){if(a.scheme===L.Schemas.file){const p=_.URI.file(m.resolve(s(a),d));return a.with({authority:p.authority,path:p.path})}return d=t.toPosixPath(d),a.with({path:m.posix.resolve(a.path,d)})}isAbsolutePath(a){return!!a.path&&a.path[0]==="/"}isEqualAuthority(a,d){return a===d||a!==void 0&&d!==void 0&&(0,P.equalsIgnoreCase)(a,d)}hasTrailingPathSeparator(a,d=m.sep){if(a.scheme===L.Schemas.file){const p=s(a);return p.length>t.getRoot(p).length&&p[p.length-1]===d}else{const p=a.path;return p.length>1&&p.charCodeAt(p.length-1)===o.CharCode.Slash&&!/^[a-zA-Z]:(\/$|\\$)/.test(a.fsPath)}}removeTrailingPathSeparator(a,d=m.sep){return(0,e.hasTrailingPathSeparator)(a,d)?a.with({path:a.path.substr(0,a.path.length-1)}):a}addTrailingPathSeparator(a,d=m.sep){let p=!1;if(a.scheme===L.Schemas.file){const r=s(a);p=r!==void 0&&r.length===t.getRoot(r).length&&r[r.length-1]===d}else{d="/";const r=a.path;p=r.length===1&&r.charCodeAt(r.length-1)===o.CharCode.Slash}return!p&&!(0,e.hasTrailingPathSeparator)(a,d)?a.with({path:a.path+"/"}):a}}e.ExtUri=b,e.extUri=new b(()=>!1),e.extUriBiasedIgnorePathCase=new b(u=>u.scheme===L.Schemas.file?!W.isLinux:!0),e.extUriIgnorePathCase=new b(u=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function h(u,a){const d=[];for(let p=0;p<u.length;p++){const r=a(u[p]);u.some((y,w)=>w===p?!1:(0,e.isEqualOrParent)(r,a(y)))||d.push(u[p])}return d}var g;(function(u){u.META_DATA_LABEL="label",u.META_DATA_DESCRIPTION="description",u.META_DATA_SIZE="size",u.META_DATA_MIME="mime";function a(d){const p=new Map;d.path.substring(d.path.indexOf(";")+1,d.path.lastIndexOf(";")).split(";").forEach(w=>{const[C,i]=w.split(":");C&&i&&p.set(C,i)});const y=d.path.substring(0,d.path.indexOf(";"));return y&&p.set(u.META_DATA_MIME,y),p}u.parseMetaData=a})(g||(e.DataUri=g={}));function l(u,a,d){if(a){let p=u.path;return p&&p[0]!==m.posix.sep&&(p=m.posix.sep+p),u.with({scheme:d,authority:a,path:p})}return u.with({scheme:d})}}),define(he[12],fe([0,1,18,7,4,2,25,3,53,24]),function(ie,e,o,t,L,m,W,P,_,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AsyncIterableSource=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.LazyStatefulPromise=e.StatefulPromise=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.GlobalIdleValue=e.AbstractIdleValue=e._runWhenIdle=e.runWhenGlobalIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.LimitedQueue=e.Queue=e.Limiter=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=void 0,e.isThenable=b,e.createCancelablePromise=h,e.raceCancellation=g,e.raceCancellationError=l,e.raceCancellablePromises=u,e.raceTimeout=a,e.asPromise=d,e.promiseWithResolvers=p,e.timeout=v,e.disposableTimeout=S,e.sequence=T,e.first=O,e.firstParallel=F,e.retry=z,e.createCancelableAsyncIterable=N;function b(U){return!!U&&typeof U.then=="function"}function h(U){const k=new o.CancellationTokenSource,H=U(k.token),J=new Promise((ne,_e)=>{const we=k.token.onCancellationRequested(()=>{we.dispose(),_e(new t.CancellationError)});Promise.resolve(H).then(Ie=>{we.dispose(),k.dispose(),ne(Ie)},Ie=>{we.dispose(),k.dispose(),_e(Ie)})});return new class{cancel(){k.cancel(),k.dispose()}then(ne,_e){return J.then(ne,_e)}catch(ne){return this.then(void 0,ne)}finally(ne){return J.finally(ne)}}}function g(U,k,H){return new Promise((J,ne)=>{const _e=k.onCancellationRequested(()=>{_e.dispose(),J(H)});U.then(J,ne).finally(()=>_e.dispose())})}function l(U,k){return new Promise((H,J)=>{const ne=k.onCancellationRequested(()=>{ne.dispose(),J(new t.CancellationError)});U.then(H,J).finally(()=>ne.dispose())})}async function u(U){let k=-1;const H=U.map((J,ne)=>J.then(_e=>(k=ne,_e)));try{return await Promise.race(H)}finally{U.forEach((J,ne)=>{ne!==k&&J.cancel()})}}function a(U,k,H){let J;const ne=setTimeout(()=>{J?.(void 0),H?.()},k);return Promise.race([U.finally(()=>clearTimeout(ne)),new Promise(_e=>J=_e)])}function d(U){return new Promise((k,H)=>{const J=U();b(J)?J.then(k,H):k(J)})}function p(){let U,k;return{promise:new Promise((J,ne)=>{U=J,k=ne}),resolve:U,reject:k}}class r{constructor(){this.isDisposed=!1,this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(k){if(this.isDisposed)return Promise.reject(new Error("Throttler is disposed"));if(this.activePromise){if(this.queuedPromiseFactory=k,!this.queuedPromise){const H=()=>{if(this.queuedPromise=null,this.isDisposed)return;const J=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,J};this.queuedPromise=new Promise(J=>{this.activePromise.then(H,H).then(J)})}return new Promise((H,J)=>{this.queuedPromise.then(H,J)})}return this.activePromise=k(),new Promise((H,J)=>{this.activePromise.then(ne=>{this.activePromise=null,H(ne)},ne=>{this.activePromise=null,J(ne)})})}dispose(){this.isDisposed=!0}}e.Throttler=r;class y{constructor(){this.current=Promise.resolve(null)}queue(k){return this.current=this.current.then(()=>k(),()=>k())}}e.Sequencer=y;class w{constructor(){this.promiseMap=new Map}queue(k,H){const ne=(this.promiseMap.get(k)??Promise.resolve()).catch(()=>{}).then(H).finally(()=>{this.promiseMap.get(k)===ne&&this.promiseMap.delete(k)});return this.promiseMap.set(k,ne),ne}}e.SequencerByKey=w;const C=(U,k)=>{let H=!0;const J=setTimeout(()=>{H=!1,k()},U);return{isTriggered:()=>H,dispose:()=>{clearTimeout(J),H=!1}}},i=U=>{let k=!0;return queueMicrotask(()=>{k&&(k=!1,U())}),{isTriggered:()=>k,dispose:()=>{k=!1}}};class n{constructor(k){this.defaultDelay=k,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(k,H=this.defaultDelay){this.task=k,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((ne,_e)=>{this.doResolve=ne,this.doReject=_e}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const ne=this.task;return this.task=null,ne()}}));const J=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=H===_.MicrotaskDelay?i(J):C(H,J),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new t.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=n;class f{constructor(k){this.delayer=new n(k),this.throttler=new r}trigger(k,H){return this.delayer.trigger(()=>this.throttler.queue(k),H)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose(),this.throttler.dispose()}}e.ThrottledDelayer=f;class R{constructor(){this._isOpen=!1,this._promise=new Promise((k,H)=>{this._completePromise=k})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=R;class x extends R{constructor(k){super(),this._timeout=setTimeout(()=>this.open(),k)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=x;function v(U,k){return k?new Promise((H,J)=>{const ne=setTimeout(()=>{_e.dispose(),H()},U),_e=k.onCancellationRequested(()=>{clearTimeout(ne),_e.dispose(),J(new t.CancellationError)})}):h(H=>v(U,H))}function S(U,k=0,H){const J=setTimeout(()=>{U(),H&&ne.dispose()},k),ne=(0,m.toDisposable)(()=>{clearTimeout(J),H?.deleteAndLeak(ne)});return H?.add(ne),ne}function T(U){const k=[];let H=0;const J=U.length;function ne(){return H<J?U[H++]():null}function _e(we){we!=null&&k.push(we);const Ie=ne();return Ie?Ie.then(_e):Promise.resolve(k)}return Promise.resolve(null).then(_e)}function O(U,k=J=>!!J,H=null){let J=0;const ne=U.length,_e=()=>{if(J>=ne)return Promise.resolve(H);const we=U[J++];return Promise.resolve(we()).then(Ae=>k(Ae)?Promise.resolve(Ae):_e())};return _e()}function F(U,k=J=>!!J,H=null){if(U.length===0)return Promise.resolve(H);let J=U.length;const ne=()=>{J=-1;for(const _e of U)_e.cancel?.()};return new Promise((_e,we)=>{for(const Ie of U)Ie.then(Ae=>{--J>=0&&k(Ae)?(ne(),_e(Ae)):J===0&&_e(H)}).catch(Ae=>{--J>=0&&(ne(),we(Ae))})})}class D{constructor(k){this._size=0,this._isDisposed=!1,this.maxDegreeOfParalellism=k,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new L.Emitter}whenIdle(){return this.size>0?L.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(k){if(this._isDisposed)throw new Error("Object has been disposed");return this._size++,new Promise((H,J)=>{this.outstandingPromises.push({factory:k,c:H,e:J}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const k=this.outstandingPromises.shift();this.runningPromises++;const H=k.factory();H.then(k.c,k.e),H.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._isDisposed||(this.runningPromises--,--this._size===0&&this._onDrained.fire(),this.outstandingPromises.length>0&&this.consume())}clear(){if(this._isDisposed)throw new Error("Object has been disposed");this.outstandingPromises.length=0,this._size=this.runningPromises}dispose(){this._isDisposed=!0,this.outstandingPromises.length=0,this._size=0,this._onDrained.dispose()}}e.Limiter=D;class E extends D{constructor(){super(1)}}e.Queue=E;class M{constructor(){this.sequentializer=new Q,this.tasks=0}queue(k){return this.sequentializer.isRunning()?this.sequentializer.queue(()=>this.sequentializer.run(this.tasks++,k())):this.sequentializer.run(this.tasks++,k())}}e.LimitedQueue=M;class A{constructor(){this.queues=new Map,this.drainers=new Set,this.drainListeners=void 0,this.drainListenerCount=0}async whenDrained(){if(this.isDrained())return;const k=new $;return this.drainers.add(k),k.p}isDrained(){for(const[,k]of this.queues)if(k.size>0)return!1;return!0}queueSize(k,H=W.extUri){const J=H.getComparisonKey(k);return this.queues.get(J)?.size??0}queueFor(k,H,J=W.extUri){const ne=J.getComparisonKey(k);let _e=this.queues.get(ne);if(!_e){_e=new E;const we=this.drainListenerCount++,Ie=L.Event.once(_e.onDrained)(()=>{_e?.dispose(),this.queues.delete(ne),this.onDidQueueDrain(),this.drainListeners?.deleteAndDispose(we),this.drainListeners?.size===0&&(this.drainListeners.dispose(),this.drainListeners=void 0)});this.drainListeners||(this.drainListeners=new m.DisposableMap),this.drainListeners.set(we,Ie),this.queues.set(ne,_e)}return _e.queue(H)}onDidQueueDrain(){this.isDrained()&&this.releaseDrainers()}releaseDrainers(){for(const k of this.drainers)k.complete();this.drainers.clear()}dispose(){for(const[,k]of this.queues)k.dispose();this.queues.clear(),this.releaseDrainers(),this.drainListeners?.dispose()}}e.ResourceQueue=A;class I{constructor(k,H){this._isDisposed=!1,this._token=-1,typeof k=="function"&&typeof H=="number"&&this.setIfNotSet(k,H)}dispose(){this.cancel(),this._isDisposed=!0}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(k,H){if(this._isDisposed)throw new t.BugIndicatingError("Calling 'cancelAndSet' on a disposed TimeoutTimer");this.cancel(),this._token=setTimeout(()=>{this._token=-1,k()},H)}setIfNotSet(k,H){if(this._isDisposed)throw new t.BugIndicatingError("Calling 'setIfNotSet' on a disposed TimeoutTimer");this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,k()},H))}}e.TimeoutTimer=I;class B{constructor(){this.disposable=void 0,this.isDisposed=!1}cancel(){this.disposable?.dispose(),this.disposable=void 0}cancelAndSet(k,H,J=globalThis){if(this.isDisposed)throw new t.BugIndicatingError("Calling 'cancelAndSet' on a disposed IntervalTimer");this.cancel();const ne=J.setInterval(()=>{k()},H);this.disposable=(0,m.toDisposable)(()=>{J.clearInterval(ne),this.disposable=void 0})}dispose(){this.cancel(),this.isDisposed=!0}}e.IntervalTimer=B;class Y{constructor(k,H){this.timeoutToken=-1,this.runner=k,this.timeout=H,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(k=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,k)}get delay(){return this.timeout}set delay(k){this.timeout=k}isScheduled(){return this.timeoutToken!==-1}flush(){this.isScheduled()&&(this.cancel(),this.doRun())}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}e.RunOnceScheduler=Y;class G{constructor(k,H){H%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${H}ms is not a multiple of 1000ms.`),this.runner=k,this.timeout=H,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(k=this.timeout){k%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${k}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(k/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}e.ProcessTimeRunOnceScheduler=G;class Z extends Y{constructor(k,H){super(k,H),this.units=[]}work(k){this.units.push(k),this.isScheduled()||this.schedule()}doRun(){const k=this.units;this.units=[],this.runner?.(k)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=Z;class se extends m.Disposable{constructor(k,H){super(),this.options=k,this.handler=H,this.pendingWork=[],this.throttler=this._register(new m.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(k){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+k.length>this.options.maxBufferedWork)return!1}else if(this.pending+k.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}for(const H of k)this.pendingWork.push(H);return this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new Y(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=se,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e._runWhenIdle=(U,k)=>{(0,P.setTimeout0)(()=>{if(H)return;const J=Date.now()+15;k(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,J-Date.now())}}))});let H=!1;return{dispose(){H||(H=!0)}}}:e._runWhenIdle=(U,k,H)=>{const J=U.requestIdleCallback(k,typeof H=="number"?{timeout:H}:void 0);let ne=!1;return{dispose(){ne||(ne=!0,U.cancelIdleCallback(J))}}},e.runWhenGlobalIdle=U=>(0,e._runWhenIdle)(globalThis,U)}();class le{constructor(k,H){this._didRun=!1,this._executor=()=>{try{this._value=H()}catch(J){this._error=J}finally{this._didRun=!0}},this._handle=(0,e._runWhenIdle)(k,()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.AbstractIdleValue=le;class V extends le{constructor(k){super(globalThis,k)}}e.GlobalIdleValue=V;async function z(U,k,H){let J;for(let ne=0;ne<H;ne++)try{return await U()}catch(_e){J=_e,await v(k)}throw J}class Q{isRunning(k){return typeof k=="number"?this._running?.taskId===k:!!this._running}get running(){return this._running?.promise}cancelRunning(){this._running?.cancel()}run(k,H,J){return this._running={taskId:k,cancel:()=>J?.(),promise:H},H.then(()=>this.doneRunning(k),()=>this.doneRunning(k)),H}doneRunning(k){this._running&&k===this._running.taskId&&(this._running=void 0,this.runQueued())}runQueued(){if(this._queued){const k=this._queued;this._queued=void 0,k.run().then(k.promiseResolve,k.promiseReject)}}queue(k){if(this._queued)this._queued.run=k;else{const{promise:H,resolve:J,reject:ne}=p();this._queued={run:k,promise:H,promiseResolve:J,promiseReject:ne}}return this._queued.promise}hasQueued(){return!!this._queued}async join(){return this._queued?.promise??this._running?.promise}}e.TaskSequentializer=Q;class ee{constructor(k,H=()=>Date.now()){this.interval=k,this.nowFn=H,this.lastIncrementTime=0,this.value=0}increment(){const k=this.nowFn();return k-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=k,this.value=0),this.value++,this.value}}e.IntervalCounter=ee;var ue;(function(U){U[U.Resolved=0]="Resolved",U[U.Rejected=1]="Rejected"})(ue||(ue={}));class ${get isRejected(){return this.outcome?.outcome===ue.Rejected}get isResolved(){return this.outcome?.outcome===ue.Resolved}get isSettled(){return!!this.outcome}get value(){return this.outcome?.outcome===ue.Resolved?this.outcome?.value:void 0}constructor(){this.p=new Promise((k,H)=>{this.completeCallback=k,this.errorCallback=H})}complete(k){return new Promise(H=>{this.completeCallback(k),this.outcome={outcome:ue.Resolved,value:k},H()})}error(k){return new Promise(H=>{this.errorCallback(k),this.outcome={outcome:ue.Rejected,value:k},H()})}cancel(){return this.error(new t.CancellationError)}}e.DeferredPromise=$;var ae;(function(U){async function k(J){let ne;const _e=await Promise.all(J.map(we=>we.then(Ie=>Ie,Ie=>{ne||(ne=Ie)})));if(typeof ne<"u")throw ne;return _e}U.settled=k;function H(J){return new Promise(async(ne,_e)=>{try{await J(ne,_e)}catch(we){_e(we)}})}U.withAsyncBody=H})(ae||(e.Promises=ae={}));class de{get value(){return this._value}get error(){return this._error}get isResolved(){return this._isResolved}constructor(k){this._value=void 0,this._error=void 0,this._isResolved=!1,this.promise=k.then(H=>(this._value=H,this._isResolved=!0,H),H=>{throw this._error=H,this._isResolved=!0,H})}requireValue(){if(!this._isResolved)throw new t.BugIndicatingError("Promise is not resolved yet");if(this._error)throw this._error;return this._value}}e.StatefulPromise=de;class te{constructor(k){this._compute=k,this._promise=new s.Lazy(()=>new de(this._compute()))}requireValue(){return this._promise.value.requireValue()}getPromise(){return this._promise.value.promise}get currentValue(){return this._promise.rawValue?.value}}e.LazyStatefulPromise=te;var c;(function(U){U[U.Initial=0]="Initial",U[U.DoneOK=1]="DoneOK",U[U.DoneError=2]="DoneError"})(c||(c={}));class j{static fromArray(k){return new j(H=>{H.emitMany(k)})}static fromPromise(k){return new j(async H=>{H.emitMany(await k)})}static fromPromises(k){return new j(async H=>{await Promise.all(k.map(async J=>H.emitOne(await J)))})}static merge(k){return new j(async H=>{await Promise.all(k.map(async J=>{for await(const ne of J)H.emitOne(ne)}))})}static{this.EMPTY=j.fromArray([])}constructor(k,H){this._state=c.Initial,this._results=[],this._error=null,this._onReturn=H,this._onStateChanged=new L.Emitter,queueMicrotask(async()=>{const J={emitOne:ne=>this.emitOne(ne),emitMany:ne=>this.emitMany(ne),reject:ne=>this.reject(ne)};try{await Promise.resolve(k(J)),this.resolve()}catch(ne){this.reject(ne)}finally{J.emitOne=void 0,J.emitMany=void 0,J.reject=void 0}})}[Symbol.asyncIterator](){let k=0;return{next:async()=>{do{if(this._state===c.DoneError)throw this._error;if(k<this._results.length)return{done:!1,value:this._results[k++]};if(this._state===c.DoneOK)return{done:!0,value:void 0};await L.Event.toPromise(this._onStateChanged.event)}while(!0)},return:async()=>(this._onReturn?.(),{done:!0,value:void 0})}}static map(k,H){return new j(async J=>{for await(const ne of k)J.emitOne(H(ne))})}map(k){return j.map(this,k)}static filter(k,H){return new j(async J=>{for await(const ne of k)H(ne)&&J.emitOne(ne)})}filter(k){return j.filter(this,k)}static coalesce(k){return j.filter(k,H=>!!H)}coalesce(){return j.coalesce(this)}static async toPromise(k){const H=[];for await(const J of k)H.push(J);return H}toPromise(){return j.toPromise(this)}emitOne(k){this._state===c.Initial&&(this._results.push(k),this._onStateChanged.fire())}emitMany(k){this._state===c.Initial&&(this._results=this._results.concat(k),this._onStateChanged.fire())}resolve(){this._state===c.Initial&&(this._state=c.DoneOK,this._onStateChanged.fire())}reject(k){this._state===c.Initial&&(this._state=c.DoneError,this._error=k,this._onStateChanged.fire())}}e.AsyncIterableObject=j;class oe extends j{constructor(k,H){super(H),this._source=k}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=oe;function N(U){const k=new o.CancellationTokenSource,H=U(k.token);return new oe(k,async J=>{const ne=k.token.onCancellationRequested(()=>{ne.dispose(),k.dispose(),J.reject(new t.CancellationError)});try{for await(const _e of H){if(k.token.isCancellationRequested)return;J.emitOne(_e)}ne.dispose(),k.dispose()}catch(_e){ne.dispose(),k.dispose(),J.reject(_e)}})}class K{constructor(k){this._deferred=new $,this._asyncIterable=new j(ne=>{if(H){ne.reject(H);return}return J&&ne.emitMany(J),this._errorFn=_e=>ne.reject(_e),this._emitFn=_e=>ne.emitOne(_e),this._deferred.p},k);let H,J;this._emitFn=ne=>{J||(J=[]),J.push(ne)},this._errorFn=ne=>{H||(H=ne)}}get asyncIterable(){return this._asyncIterable}resolve(){this._deferred.complete()}reject(k){this._errorFn(k),this._deferred.complete()}emitOne(k){this._emitFn(k)}}e.AsyncIterableSource=K}),define(he[62],fe([0,1,19,27,6]),function(ie,e,o,t,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DefaultURITransformer=e.URITransformer=void 0,e.transformOutgoingURIs=_,e.transformIncomingURIs=b,e.transformAndReviveIncomingURIs=h;function m(g){return g.toJSON()}class W{constructor(l){this._uriTransformer=l}transformIncoming(l){const u=this._uriTransformer.transformIncoming(l);return u===l?l:m(L.URI.from(u))}transformOutgoing(l){const u=this._uriTransformer.transformOutgoing(l);return u===l?l:m(L.URI.from(u))}transformOutgoingURI(l){const u=this._uriTransformer.transformOutgoing(l);return u===l?l:L.URI.from(u)}transformOutgoingScheme(l){return this._uriTransformer.transformOutgoingScheme(l)}}e.URITransformer=W,e.DefaultURITransformer=new class{transformIncoming(g){return g}transformOutgoing(g){return g}transformOutgoingURI(g){return g}transformOutgoingScheme(g){return g}};function P(g,l,u){if(!g||u>200)return null;if(typeof g=="object"){if(g instanceof L.URI)return l.transformOutgoing(g);for(const a in g)if(Object.hasOwnProperty.call(g,a)){const d=P(g[a],l,u+1);d!==null&&(g[a]=d)}}return null}function _(g,l){const u=P(g,l,0);return u===null?g:u}function s(g,l,u,a){if(!g||a>200)return null;if(typeof g=="object"){if(g.$mid===t.MarshalledId.Uri)return u?L.URI.revive(l.transformIncoming(g)):l.transformIncoming(g);if(g instanceof o.VSBuffer)return null;for(const d in g)if(Object.hasOwnProperty.call(g,d)){const p=s(g[d],l,u,a+1);p!==null&&(g[d]=p)}}return null}function b(g,l){const u=s(g,l,!1,0);return u===null?g:u}function h(g,l){const u=s(g,l,!0,0);return u===null?g:u}}),define(he[28],fe([0,1,37,21,101,12,35,49,5,3,25,6]),function(ie,e,o,t,L,m,W,P,_,s,b,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.SymlinkSupport=e.RimRafMode=void 0,e.rimrafSync=d,e.readdirSync=y,e.whenDeleted=i,e.configureFlushOnWrite=v,e.writeFileSync=T,o=Pe(o);var g;(function(G){G[G.UNLINK=0]="UNLINK",G[G.MOVE=1]="MOVE"})(g||(e.RimRafMode=g={}));async function l(G,Z=g.UNLINK,se){if((0,W.isRootOrDriveLetter)(G))throw new Error("rimraf - will refuse to recursively delete root");return Z===g.UNLINK?a(G):u(G,se)}async function u(G,Z=(0,W.randomPath)((0,t.tmpdir)())){try{try{await o.promises.rename(G,Z)}catch(se){return se.code==="ENOENT"?void 0:a(G)}a(Z).catch(se=>{})}catch(se){if(se.code!=="ENOENT")throw se}}async function a(G){return o.promises.rm(G,{recursive:!0,force:!0,maxRetries:3})}function d(G){if((0,W.isRootOrDriveLetter)(G))throw new Error("rimraf - will refuse to recursively delete root");o.rmSync(G,{recursive:!0,force:!0,maxRetries:3})}async function p(G,Z){return w(await(Z?r(G):o.promises.readdir(G)))}async function r(G){try{return await o.promises.readdir(G,{withFileTypes:!0})}catch(le){console.warn("[node.js fs] readdir with filetypes failed with error: ",le)}const Z=[],se=await p(G);for(const le of se){let V=!1,z=!1,Q=!1;try{const ee=await o.promises.lstat((0,_.join)(G,le));V=ee.isFile(),z=ee.isDirectory(),Q=ee.isSymbolicLink()}catch(ee){console.warn("[node.js fs] unexpected error from lstat after readdir: ",ee)}Z.push({name:le,isFile:()=>V,isDirectory:()=>z,isSymbolicLink:()=>Q})}return Z}function y(G){return w(o.readdirSync(G))}function w(G){return G.map(Z=>typeof Z=="string"?s.isMacintosh?(0,P.normalizeNFC)(Z):Z:(Z.name=s.isMacintosh?(0,P.normalizeNFC)(Z.name):Z.name,Z))}async function C(G){const Z=await p(G),se=[];for(const le of Z)await n.existsDirectory((0,_.join)(G,le))&&se.push(le);return se}function i(G,Z=1e3){return new Promise(se=>{let le=!1;const V=setInterval(()=>{le||(le=!0,o.access(G,z=>{le=!1,z&&(clearInterval(V),se(void 0))}))},Z)})}var n;(function(G){async function Z(V){let z;try{if(z=await o.promises.lstat(V),!z.isSymbolicLink())return{stat:z}}catch{}try{return{stat:await o.promises.stat(V),symbolicLink:z?.isSymbolicLink()?{dangling:!1}:void 0}}catch(Q){if(Q.code==="ENOENT"&&z)return{stat:z,symbolicLink:{dangling:!0}};if(s.isWindows&&Q.code==="EACCES")try{return{stat:await o.promises.stat(await o.promises.readlink(V)),symbolicLink:{dangling:!1}}}catch(ee){if(ee.code==="ENOENT"&&z)return{stat:z,symbolicLink:{dangling:!0}};throw ee}throw Q}}G.stat=Z;async function se(V){try{const{stat:z,symbolicLink:Q}=await G.stat(V);return z.isFile()&&Q?.dangling!==!0}catch{}return!1}G.existsFile=se;async function le(V){try{const{stat:z,symbolicLink:Q}=await G.stat(V);return z.isDirectory()&&Q?.dangling!==!0}catch{}return!1}G.existsDirectory=le})(n||(e.SymlinkSupport=n={}));const f=new m.ResourceQueue;function R(G,Z,se){return f.queueFor(h.URI.file(G),()=>{const le=O(se);return new Promise((V,z)=>S(G,Z,le,Q=>Q?z(Q):V()))},b.extUriBiasedIgnorePathCase)}let x=!0;function v(G){x=G}function S(G,Z,se,le){if(!x)return o.writeFile(G,Z,{mode:se.mode,flag:se.flag},le);o.open(G,se.flag,se.mode,(V,z)=>{if(V)return le(V);o.writeFile(z,Z,Q=>{if(Q)return o.close(z,()=>le(Q));o.fdatasync(z,ee=>(ee&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",ee),v(!1)),o.close(z,ue=>le(ue))))})})}function T(G,Z,se){const le=O(se);if(!x)return o.writeFileSync(G,Z,{mode:le.mode,flag:le.flag});const V=o.openSync(G,le.flag,le.mode);try{o.writeFileSync(V,Z);try{o.fdatasyncSync(V)}catch(z){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",z),v(!1)}}finally{o.closeSync(V)}}function O(G){return G?{mode:typeof G.mode=="number"?G.mode:438,flag:typeof G.flag=="string"?G.flag:"w"}:{mode:438,flag:"w"}}async function F(G,Z,se=6e4){if(G!==Z)try{s.isWindows&&typeof se=="number"?await D(G,Z,Date.now(),se):await o.promises.rename(G,Z)}catch(le){if(G.toLowerCase()!==Z.toLowerCase()&&le.code==="EXDEV"||G.endsWith("."))await E(G,Z,{preserveSymlinks:!1}),await l(G,g.MOVE);else throw le}}async function D(G,Z,se,le,V=0){try{return await o.promises.rename(G,Z)}catch(z){if(z.code!=="EACCES"&&z.code!=="EPERM"&&z.code!=="EBUSY")throw z;if(Date.now()-se>=le)throw console.error(`[node.js fs] rename failed after ${V} retries with error: ${z}`),z;if(V===0){let Q=!1;try{const{stat:ee}=await n.stat(Z);ee.isFile()||(Q=!0)}catch{}if(Q)throw z}return await(0,m.timeout)(Math.min(100,V*10)),D(G,Z,se,le,V+1)}}async function E(G,Z,se){return A(G,Z,{root:{source:G,target:Z},options:se,handledSourcePaths:new Set})}const M=511;async function A(G,Z,se){if(se.handledSourcePaths.has(G))return;se.handledSourcePaths.add(G);const{stat:le,symbolicLink:V}=await n.stat(G);if(V){if(se.options.preserveSymlinks)try{return await Y(G,Z,se)}catch{}if(V.dangling)return}return le.isDirectory()?I(G,Z,le.mode&M,se):B(G,Z,le.mode&M)}async function I(G,Z,se,le){await o.promises.mkdir(Z,{recursive:!0,mode:se});const V=await p(G);for(const z of V)await A((0,_.join)(G,z),(0,_.join)(Z,z),le)}async function B(G,Z,se){await o.promises.copyFile(G,Z),await o.promises.chmod(Z,se)}async function Y(G,Z,se){let le=await o.promises.readlink(G);(0,W.isEqualOrParent)(le,se.root.source,!s.isLinux)&&(le=(0,_.join)(se.root.target,le.substr(se.root.source.length+1))),await o.promises.symlink(le,Z)}e.Promises=new class{get read(){return(G,Z,se,le,V)=>new Promise((z,Q)=>{o.read(G,Z,se,le,V,(ee,ue,$)=>ee?Q(ee):z({bytesRead:ue,buffer:$}))})}get write(){return(G,Z,se,le,V)=>new Promise((z,Q)=>{o.write(G,Z,se,le,V,(ee,ue,$)=>ee?Q(ee):z({bytesWritten:ue,buffer:$}))})}get fdatasync(){return(0,L.promisify)(o.fdatasync)}get open(){return(0,L.promisify)(o.open)}get close(){return(0,L.promisify)(o.close)}get realpath(){return(0,L.promisify)(o.realpath)}async exists(G){try{return await o.promises.access(G),!0}catch{return!1}}get readdir(){return p}get readDirsInDir(){return C}get writeFile(){return R}get rm(){return l}get rename(){return F}get copy(){return E}}}),define(he[63],fe([0,1,21,5,28]),function(ie,e,o,t,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.enumeratePowerShellInstallations=r,e.getFirstAvailablePowerShellInstallation=y,o=Pe(o),t=Pe(t),L=Pe(L);const m=/^\d+$/,W=/^Microsoft.PowerShell_.*/,P=/^Microsoft.PowerShellPreview_.*/;var _;(function(w){w[w.x64=0]="x64",w[w.x86=1]="x86",w[w.ARM=2]="ARM"})(_||(_={}));let s;switch(process.arch){case"ia32":s=_.x86;break;case"arm":case"arm64":s=_.ARM;break;default:s=_.x64;break}let b;process.env.PROCESSOR_ARCHITEW6432?b=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?_.ARM:_.x64:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?b=_.ARM:process.env.PROCESSOR_ARCHITECTURE==="X86"?b=_.x86:b=_.x64;class h{constructor(C,i,n){this.exePath=C,this.displayName=i,this.knownToExist=n}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await L.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function g({useAlternateBitness:w=!1}={}){return w?s===_.x64?process.env["ProgramFiles(x86)"]||null:b===_.x64&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function l({useAlternateBitness:w=!1,findPreview:C=!1}={}){const i=g({useAlternateBitness:w});if(!i)return null;const n=t.join(i,"PowerShell");if(!await L.SymlinkSupport.existsDirectory(n))return null;let f=-1,R=null;for(const S of await L.Promises.readdir(n)){let T=-1;if(C){const F=S.indexOf("-");if(F<0)continue;const D=S.substring(0,F);if(!m.test(D)||S.substring(F+1)!=="preview")continue;T=parseInt(D,10)}else{if(!m.test(S))continue;T=parseInt(S,10)}if(T<=f)continue;const O=t.join(n,S,"pwsh.exe");await L.SymlinkSupport.existsFile(O)&&(R=O,f=T)}if(!R)return null;const x=i.includes("x86")?" (x86)":"",v=C?" Preview":"";return new h(R,`PowerShell${v}${x}`,!0)}async function u({findPreview:w}={}){if(!process.env.LOCALAPPDATA)return null;const C=t.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await L.SymlinkSupport.existsDirectory(C))return null;const{pwshMsixDirRegex:i,pwshMsixName:n}=w?{pwshMsixDirRegex:P,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:W,pwshMsixName:"PowerShell (Store)"};for(const f of await L.Promises.readdir(C))if(i.test(f)){const R=t.join(C,f,"pwsh.exe");return new h(R,n)}return null}function a(){const w=t.join(o.homedir(),".dotnet","tools","pwsh.exe");return new h(w,".NET Core PowerShell Global Tool")}function d(){const w=t.join(process.env.windir,s===_.x86&&b!==_.x86?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new h(w,"Windows PowerShell",!0)}async function*p(){let w=await l();w&&(yield w),w=await l({useAlternateBitness:!0}),w&&(yield w),w=await u(),w&&(yield w),w=a(),w&&(yield w),w=await l({findPreview:!0}),w&&(yield w),w=await u({findPreview:!0}),w&&(yield w),w=await l({useAlternateBitness:!0,findPreview:!0}),w&&(yield w),w=d(),w&&(yield w)}async function*r(){for await(const w of p())await w.exists()&&(yield w)}async function y(){for await(const w of r())return w;return null}}),define(he[38],fe([0,1,37,5,3,15,36,10,28]),function(ie,e,o,t,L,m,W,P,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.TerminateResponseCode=e.Source=void 0,e.getWindowsShell=s,e.createQueuedSender=b,t=Pe(t),L=Pe(L),m=Pe(m),P=Pe(P),_=Pe(_),Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return W.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return W.TerminateResponseCode}});function s(g=m.env){return g.comspec||"cmd.exe"}function b(g){let l=[],u=!1;const a=function(d){if(u){l.push(d);return}(!g.send(d,r=>{if(r&&console.error(r),u=!1,l.length>0){const y=l.slice(0);l=[],y.forEach(w=>a(w))}})||L.isWindows)&&(u=!0)};return{send:a}}var h;(function(g){async function l(u,a,d){if(t.isAbsolute(u))return u;if(a===void 0&&(a=m.cwd()),t.dirname(u)!=="."||(d===void 0&&P.isString(m.env.PATH)&&(d=m.env.PATH.split(t.delimiter)),d===void 0||d.length===0))return t.join(a,u);async function r(y){if(await _.Promises.exists(y)){let w;try{w=await o.promises.stat(y)}catch(C){C.message.startsWith("EACCES")&&(w=await o.promises.lstat(y))}return w?!w.isDirectory():!1}return!1}for(const y of d){let w;if(t.isAbsolute(y)?w=t.join(y,u):w=t.join(a,y,u),await r(w))return w;let C=w+".com";if(await r(C)||(C=w+".exe",await r(C)))return C}return t.join(a,u)}g.findExecutable=l})(h||(e.win32=h={}))}),define(he[64],fe([0,1,29,20]),function(ie,e,o,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=L;function L(W){return new Promise((P,_)=>{let s;const b=new Map;function h(l,u,a,d,p){const r=b.get(u);if(l===W||r){const y={name:g(a),cmd:a,pid:l,ppid:u,load:d,mem:p};b.set(l,y),l===W&&(s=y),r&&(r.children||(r.children=[]),r.children.push(y),r.children.length>1&&(r.children=r.children.sort((w,C)=>w.pid-C.pid)))}}function g(l){const u=/--utility-sub-type=network/i,a=/--crashes-directory/i,d=/\\pipe\\winpty-control/i,p=/conhost\.exe.+--headless/i,r=/--type=([a-zA-Z-]+)/;if(a.exec(l))return"electron-crash-reporter";if(d.exec(l))return"winpty-agent";if(p.exec(l))return"conpty-agent";let y=r.exec(l);if(y&&y.length===2)return y[1]==="renderer"?"window":y[1]==="utility"?u.exec(l)?"utility-network-service":"utility-process":y[1]==="extensionHost"?"extension-host":y[1];const w=/[a-zA-Z-]+\.js/g;let C="";do y=w.exec(l),y&&(C+=y+" ");while(y);return C&&l.indexOf("node ")<0&&l.indexOf("node.exe")<0?`electron-nodejs (${C})`:l}if(process.platform==="win32"){const l=u=>u.indexOf("\\\\?\\")===0||u.indexOf("\\??\\")===0?u.substring(4):u.indexOf('"\\\\?\\')===0||u.indexOf('"\\??\\')===0?'"'+u.substring(5):u;new Promise((u,a)=>{ie(["@vscode/windows-process-tree"],u,a)}).then(Pe).then(u=>{u.getProcessList(W,a=>{if(!a){_(new Error(`Root process ${W} not found`));return}u.getProcessCpuUsage(a,d=>{const p=new Map;d.forEach(r=>{const y=l(r.commandLine||"");p.set(r.pid,{name:g(y),cmd:y,pid:r.pid,ppid:r.ppid,load:r.cpu||0,mem:r.memory||0})}),s=p.get(W),s?(p.forEach(r=>{const y=p.get(r.ppid);y&&(y.children||(y.children=[]),y.children.push(r))}),p.forEach(r=>{r.children&&(r.children=r.children.sort((y,w)=>y.pid-w.pid))}),P(s)):_(new Error(`Root process ${W} not found`))})},u.ProcessDataFlag.CommandLine|u.ProcessDataFlag.Memory)})}else{let l=function(){let u=[s];const a=[];for(;u.length;){const p=u.shift();p&&(a.push(p.pid),p.children&&(u=u.concat(p.children)))}let d=JSON.stringify(t.FileAccess.asFileUri("vs/base/node/cpuUsage.sh").fsPath);d+=" "+a.join(" "),(0,o.exec)(d,{},(p,r,y)=>{if(p||y)_(p||new Error(y.toString()));else{const w=r.toString().split(`
`);for(let C=0;C<a.length;C++){const i=b.get(a[C]);i.load=parseFloat(w[C])}if(!s){_(new Error(`Root process ${W} not found`));return}P(s)}})};(0,o.exec)("which ps",{},(u,a,d)=>{if(u||d)if(process.platform!=="linux")_(u||new Error(d.toString()));else{const p=JSON.stringify(t.FileAccess.asFileUri("vs/base/node/ps.sh").fsPath);(0,o.exec)(p,{},(r,y,w)=>{r||w?_(r||new Error(w.toString())):(m(y,h),l())})}else{const p=a.toString().trim();(0,o.exec)(`${p} -ax -o pid=,ppid=,pcpu=,pmem=,command=`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(y,w,C)=>{y||C&&!C.includes("screen size is bogus")?_(y||new Error(C.toString())):(m(w,h),process.platform==="linux"?l():s?P(s):_(new Error(`Root process ${W} not found`)))})}})}})}function m(W,P){const _=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,s=W.toString().split(`
`);for(const b of s){const h=_.exec(b.trim());h&&h.length===6&&P(parseInt(h[1]),parseInt(h[2]),h[5],parseFloat(h[3]),parseFloat(h[4]))}}}),define(he[65],fe([0,1,21,3,63,38]),function(ie,e,o,t,L,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShell=W,t=Pe(t),m=Pe(m);async function W(h,g){return h===t.OperatingSystem.Windows?t.isWindows?b():m.getWindowsShell(g):_(h,g)}let P=null;function _(h,g){if(t.isLinux&&h===t.OperatingSystem.Macintosh||t.isMacintosh&&h===t.OperatingSystem.Linux)return"/bin/bash";if(!P){let l;if(t.isWindows)l="/bin/bash";else{if(l=g.SHELL,!l)try{l=(0,o.userInfo)().shell}catch{}l||(l="sh"),l==="/bin/false"&&(l="/bin/bash")}P=l}return P}let s=null;async function b(){return s||(s=(await(0,L.getFirstAvailablePowerShellInstallation)()).exePath),s}});var ge=this&&this.__decorate||function(ie,e,o,t){var L=arguments.length,m=L<3?e:t===null?t=Object.getOwnPropertyDescriptor(e,o):t,W;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")m=Reflect.decorate(ie,e,o,t);else for(var P=ie.length-1;P>=0;P--)(W=ie[P])&&(m=(L<3?W(m):L>3?W(e,o,m):W(e,o))||m);return L>3&&m&&Object.defineProperty(e,o,m),m};define(he[30],fe([0,1,17,12,19,18,14,7,4,2,61,11,10]),function(ie,e,o,t,L,m,W,P,_,s,b,h,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.ProxyChannel=e.StaticRouter=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.BufferWriter=e.BufferReader=void 0,e.serialize=v,e.deserialize=S,e.getDelayedChannel=M,e.getNextTickChannel=A,h=Pe(h);var l;(function(V){V[V.Promise=100]="Promise",V[V.PromiseCancel=101]="PromiseCancel",V[V.EventListen=102]="EventListen",V[V.EventDispose=103]="EventDispose"})(l||(l={}));function u(V){switch(V){case l.Promise:return"req";case l.PromiseCancel:return"cancel";case l.EventListen:return"subscribe";case l.EventDispose:return"unsubscribe"}}var a;(function(V){V[V.Initialize=200]="Initialize",V[V.PromiseSuccess=201]="PromiseSuccess",V[V.PromiseError=202]="PromiseError",V[V.PromiseErrorObj=203]="PromiseErrorObj",V[V.EventFire=204]="EventFire"})(a||(a={}));function d(V){switch(V){case a.Initialize:return"init";case a.PromiseSuccess:return"reply:";case a.PromiseError:case a.PromiseErrorObj:return"replyErr:";case a.EventFire:return"event:"}}var p;(function(V){V[V.Uninitialized=0]="Uninitialized",V[V.Idle=1]="Idle"})(p||(p={}));function r(V){let z=0;for(let Q=0;;Q+=7){const ee=V.read(1);if(z|=(ee.buffer[0]&127)<<Q,!(ee.buffer[0]&128))return z}}const y=f(0);function w(V,z){if(z===0){V.write(y);return}let Q=0;for(let ue=z;ue!==0;ue=ue>>>7)Q++;const ee=L.VSBuffer.alloc(Q);for(let ue=0;z!==0;ue++)ee.buffer[ue]=z&127,z=z>>>7,z>0&&(ee.buffer[ue]|=128);V.write(ee)}class C{constructor(z){this.buffer=z,this.pos=0}read(z){const Q=this.buffer.slice(this.pos,this.pos+z);return this.pos+=Q.byteLength,Q}}e.BufferReader=C;class i{constructor(){this.buffers=[]}get buffer(){return L.VSBuffer.concat(this.buffers)}write(z){this.buffers.push(z)}}e.BufferWriter=i;var n;(function(V){V[V.Undefined=0]="Undefined",V[V.String=1]="String",V[V.Buffer=2]="Buffer",V[V.VSBuffer=3]="VSBuffer",V[V.Array=4]="Array",V[V.Object=5]="Object",V[V.Int=6]="Int"})(n||(n={}));function f(V){const z=L.VSBuffer.alloc(1);return z.writeUInt8(V,0),z}const R={Undefined:f(n.Undefined),String:f(n.String),Buffer:f(n.Buffer),VSBuffer:f(n.VSBuffer),Array:f(n.Array),Object:f(n.Object),Uint:f(n.Int)},x=typeof Buffer<"u";function v(V,z){if(typeof z>"u")V.write(R.Undefined);else if(typeof z=="string"){const Q=L.VSBuffer.fromString(z);V.write(R.String),w(V,Q.byteLength),V.write(Q)}else if(x&&Buffer.isBuffer(z)){const Q=L.VSBuffer.wrap(z);V.write(R.Buffer),w(V,Q.byteLength),V.write(Q)}else if(z instanceof L.VSBuffer)V.write(R.VSBuffer),w(V,z.byteLength),V.write(z);else if(Array.isArray(z)){V.write(R.Array),w(V,z.length);for(const Q of z)v(V,Q)}else if(typeof z=="number"&&(z|0)===z)V.write(R.Uint),w(V,z);else{const Q=L.VSBuffer.fromString(JSON.stringify(z));V.write(R.Object),w(V,Q.byteLength),V.write(Q)}}function S(V){switch(V.read(1).readUInt8(0)){case n.Undefined:return;case n.String:return V.read(r(V)).toString();case n.Buffer:return V.read(r(V)).buffer;case n.VSBuffer:return V.read(r(V));case n.Array:{const Q=r(V),ee=[];for(let ue=0;ue<Q;ue++)ee.push(S(V));return ee}case n.Object:return JSON.parse(V.read(r(V)).toString());case n.Int:return r(V)}}class T{constructor(z,Q,ee=null,ue=1e3){this.protocol=z,this.ctx=Q,this.logger=ee,this.timeoutDelay=ue,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage($=>this.onRawMessage($)),this.sendResponse({type:a.Initialize})}registerChannel(z,Q){this.channels.set(z,Q),setTimeout(()=>this.flushPendingRequests(z),0)}sendResponse(z){switch(z.type){case a.Initialize:{const Q=this.send([z.type]);this.logger?.logOutgoing(Q,0,O.OtherSide,d(z.type));return}case a.PromiseSuccess:case a.PromiseError:case a.EventFire:case a.PromiseErrorObj:{const Q=this.send([z.type,z.id],z.data);this.logger?.logOutgoing(Q,z.id,O.OtherSide,d(z.type),z.data);return}}}send(z,Q=void 0){const ee=new i;return v(ee,z),v(ee,Q),this.sendBuffer(ee.buffer)}sendBuffer(z){try{return this.protocol.send(z),z.byteLength}catch{return 0}}onRawMessage(z){const Q=new C(z),ee=S(Q),ue=S(Q),$=ee[0];switch($){case l.Promise:return this.logger?.logIncoming(z.byteLength,ee[1],O.OtherSide,`${u($)}: ${ee[2]}.${ee[3]}`,ue),this.onPromise({type:$,id:ee[1],channelName:ee[2],name:ee[3],arg:ue});case l.EventListen:return this.logger?.logIncoming(z.byteLength,ee[1],O.OtherSide,`${u($)}: ${ee[2]}.${ee[3]}`,ue),this.onEventListen({type:$,id:ee[1],channelName:ee[2],name:ee[3],arg:ue});case l.PromiseCancel:return this.logger?.logIncoming(z.byteLength,ee[1],O.OtherSide,`${u($)}`),this.disposeActiveRequest({type:$,id:ee[1]});case l.EventDispose:return this.logger?.logIncoming(z.byteLength,ee[1],O.OtherSide,`${u($)}`),this.disposeActiveRequest({type:$,id:ee[1]})}}onPromise(z){const Q=this.channels.get(z.channelName);if(!Q){this.collectPendingRequest(z);return}const ee=new m.CancellationTokenSource;let ue;try{ue=Q.call(this.ctx,z.name,z.arg,ee.token)}catch(de){ue=Promise.reject(de)}const $=z.id;ue.then(de=>{this.sendResponse({id:$,data:de,type:a.PromiseSuccess})},de=>{de instanceof Error?this.sendResponse({id:$,data:{message:de.message,name:de.name,stack:de.stack?de.stack.split(`
`):void 0},type:a.PromiseError}):this.sendResponse({id:$,data:de,type:a.PromiseErrorObj})}).finally(()=>{ae.dispose(),this.activeRequests.delete(z.id)});const ae=(0,s.toDisposable)(()=>ee.cancel());this.activeRequests.set(z.id,ae)}onEventListen(z){const Q=this.channels.get(z.channelName);if(!Q){this.collectPendingRequest(z);return}const ee=z.id,$=Q.listen(this.ctx,z.name,z.arg)(ae=>this.sendResponse({id:ee,data:ae,type:a.EventFire}));this.activeRequests.set(z.id,$)}disposeActiveRequest(z){const Q=this.activeRequests.get(z.id);Q&&(Q.dispose(),this.activeRequests.delete(z.id))}collectPendingRequest(z){let Q=this.pendingRequests.get(z.channelName);Q||(Q=[],this.pendingRequests.set(z.channelName,Q));const ee=setTimeout(()=>{console.error(`Unknown channel: ${z.channelName}`),z.type===l.Promise&&this.sendResponse({id:z.id,data:{name:"Unknown channel",message:`Channel name '${z.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:a.PromiseError})},this.timeoutDelay);Q.push({request:z,timeoutTimer:ee})}flushPendingRequests(z){const Q=this.pendingRequests.get(z);if(Q){for(const ee of Q)switch(clearTimeout(ee.timeoutTimer),ee.request.type){case l.Promise:this.onPromise(ee.request);break;case l.EventListen:this.onEventListen(ee.request);break}this.pendingRequests.delete(z)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,s.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelServer=T;var O;(function(V){V[V.LocalSide=0]="LocalSide",V[V.OtherSide=1]="OtherSide"})(O||(e.RequestInitiator=O={}));class F{constructor(z,Q=null){this.protocol=z,this.isDisposed=!1,this.state=p.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new _.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(ee=>this.onBuffer(ee)),this.logger=Q}getChannel(z){const Q=this;return{call(ee,ue,$){return Q.isDisposed?Promise.reject(new P.CancellationError):Q.requestPromise(z,ee,ue,$)},listen(ee,ue){return Q.isDisposed?_.Event.None:Q.requestEvent(z,ee,ue)}}}requestPromise(z,Q,ee,ue=m.CancellationToken.None){const $=this.lastRequestId++,ae=l.Promise,de={id:$,type:ae,channelName:z,name:Q,arg:ee};if(ue.isCancellationRequested)return Promise.reject(new P.CancellationError);let te;return new Promise((j,oe)=>{if(ue.isCancellationRequested)return oe(new P.CancellationError);const N=()=>{const H=J=>{switch(J.type){case a.PromiseSuccess:this.handlers.delete($),j(J.data);break;case a.PromiseError:{this.handlers.delete($);const ne=new Error(J.data.message);ne.stack=Array.isArray(J.data.stack)?J.data.stack.join(`
`):J.data.stack,ne.name=J.data.name,oe(ne);break}case a.PromiseErrorObj:this.handlers.delete($),oe(J.data);break}};this.handlers.set($,H),this.sendRequest(de)};let K=null;this.state===p.Idle?N():(K=(0,t.createCancelablePromise)(H=>this.whenInitialized()),K.then(()=>{K=null,N()}));const U=()=>{K?(K.cancel(),K=null):this.sendRequest({id:$,type:l.PromiseCancel}),oe(new P.CancellationError)},k=ue.onCancellationRequested(U);te=(0,s.combinedDisposable)((0,s.toDisposable)(U),k),this.activeRequests.add(te)}).finally(()=>{te.dispose(),this.activeRequests.delete(te)})}requestEvent(z,Q,ee){const ue=this.lastRequestId++,$=l.EventListen,ae={id:ue,type:$,channelName:z,name:Q,arg:ee};let de=null;const te=new _.Emitter({onWillAddFirstListener:()=>{de=(0,t.createCancelablePromise)(j=>this.whenInitialized()),de.then(()=>{de=null,this.activeRequests.add(te),this.sendRequest(ae)})},onDidRemoveLastListener:()=>{de?(de.cancel(),de=null):(this.activeRequests.delete(te),this.sendRequest({id:ue,type:l.EventDispose}))}}),c=j=>te.fire(j.data);return this.handlers.set(ue,c),te.event}sendRequest(z){switch(z.type){case l.Promise:case l.EventListen:{const Q=this.send([z.type,z.id,z.channelName,z.name],z.arg);this.logger?.logOutgoing(Q,z.id,O.LocalSide,`${u(z.type)}: ${z.channelName}.${z.name}`,z.arg);return}case l.PromiseCancel:case l.EventDispose:{const Q=this.send([z.type,z.id]);this.logger?.logOutgoing(Q,z.id,O.LocalSide,u(z.type));return}}}send(z,Q=void 0){const ee=new i;return v(ee,z),v(ee,Q),this.sendBuffer(ee.buffer)}sendBuffer(z){try{return this.protocol.send(z),z.byteLength}catch{return 0}}onBuffer(z){const Q=new C(z),ee=S(Q),ue=S(Q),$=ee[0];switch($){case a.Initialize:return this.logger?.logIncoming(z.byteLength,0,O.LocalSide,d($)),this.onResponse({type:ee[0]});case a.PromiseSuccess:case a.PromiseError:case a.EventFire:case a.PromiseErrorObj:return this.logger?.logIncoming(z.byteLength,ee[1],O.LocalSide,d($),ue),this.onResponse({type:ee[0],id:ee[1],data:ue})}}onResponse(z){if(z.type===a.Initialize){this.state=p.Idle,this._onDidInitialize.fire();return}this.handlers.get(z.id)?.(z)}get onDidInitializePromise(){return _.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===p.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,s.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelClient=F,ge([W.memoize],F.prototype,"onDidInitializePromise",null);class D{get connections(){const z=[];return this._connections.forEach(Q=>z.push(Q)),z}constructor(z,Q,ee){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new _.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new _.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,this.disposables=new s.DisposableStore,this.disposables.add(z(({protocol:ue,onDidClientDisconnect:$})=>{const ae=_.Event.once(ue.onMessage);this.disposables.add(ae(de=>{const te=new C(de),c=S(te),j=new T(ue,c,Q,ee),oe=new F(ue,Q);this.channels.forEach((K,U)=>j.registerChannel(U,K));const N={channelServer:j,channelClient:oe,ctx:c};this._connections.add(N),this._onDidAddConnection.fire(N),this.disposables.add($(()=>{j.dispose(),oe.dispose(),this._connections.delete(N),this._onDidRemoveConnection.fire(N)}))}))}))}getChannel(z,Q){const ee=this;return{call(ue,$,ae){let de;if((0,g.isFunction)(Q)){const c=(0,o.getRandomElement)(ee.connections.filter(Q));de=c?Promise.resolve(c):_.Event.toPromise(_.Event.filter(ee.onDidAddConnection,Q))}else de=Q.routeCall(ee,ue,$);const te=de.then(c=>c.channelClient.getChannel(z));return M(te).call(ue,$,ae)},listen(ue,$){if((0,g.isFunction)(Q))return ee.getMulticastEvent(z,Q,ue,$);const ae=Q.routeEvent(ee,ue,$).then(de=>de.channelClient.getChannel(z));return M(ae).listen(ue,$)}}}getMulticastEvent(z,Q,ee,ue){const $=this;let ae;const de=new _.Emitter({onWillAddFirstListener:()=>{ae=new s.DisposableStore;const te=new _.EventMultiplexer,c=new Map,j=N=>{const U=N.channelClient.getChannel(z).listen(ee,ue),k=te.add(U);c.set(N,k)},oe=N=>{const K=c.get(N);K&&(K.dispose(),c.delete(N))};$.connections.filter(Q).forEach(j),_.Event.filter($.onDidAddConnection,Q)(j,void 0,ae),$.onDidRemoveConnection(oe,void 0,ae),te.event(de.fire,de,ae),ae.add(te)},onDidRemoveLastListener:()=>{ae?.dispose(),ae=void 0}});return de.event}registerChannel(z,Q){this.channels.set(z,Q);for(const ee of this._connections)ee.channelServer.registerChannel(z,Q)}dispose(){this.disposables.dispose();for(const z of this._connections)z.channelClient.dispose(),z.channelServer.dispose();this._connections.clear(),this.channels.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=D;class E{constructor(z,Q,ee=null){const ue=new i;v(ue,Q),z.send(ue.buffer),this.channelClient=new F(z,ee),this.channelServer=new T(z,Q,ee)}getChannel(z){return this.channelClient.getChannel(z)}registerChannel(z,Q){this.channelServer.registerChannel(z,Q)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=E;function M(V){return{call(z,Q,ee){return V.then(ue=>ue.call(z,Q,ee))},listen(z,Q){const ee=new _.Relay;return V.then(ue=>ee.input=ue.listen(z,Q)),ee.event}}}function A(V){let z=!1;return{call(Q,ee,ue){return z?V.call(Q,ee,ue):(0,t.timeout)(0).then(()=>z=!0).then(()=>V.call(Q,ee,ue))},listen(Q,ee){if(z)return V.listen(Q,ee);const ue=new _.Relay;return(0,t.timeout)(0).then(()=>z=!0).then(()=>ue.input=V.listen(Q,ee)),ue.event}}}class I{constructor(z){this.fn=z}routeCall(z){return this.route(z)}routeEvent(z){return this.route(z)}async route(z){for(const Q of z.connections)if(await Promise.resolve(this.fn(Q.ctx)))return Promise.resolve(Q);return await _.Event.toPromise(z.onDidAddConnection),await this.route(z)}}e.StaticRouter=I;var B;(function(V){function z($,ae,de){const te=$,c=de&&de.disableMarshalling,j=new Map;for(const oe in te)ee(oe)&&j.set(oe,_.Event.buffer(te[oe],!0,void 0,ae));return new class{listen(oe,N,K){const U=j.get(N);if(U)return U;const k=te[N];if(typeof k=="function"){if(ue(N))return k.call(te,K);if(ee(N))return j.set(N,_.Event.buffer(te[N],!0,void 0,ae)),j.get(N)}throw new P.ErrorNoTelemetry(`Event not found: ${N}`)}call(oe,N,K){const U=te[N];if(typeof U=="function"){if(!c&&Array.isArray(K))for(let H=0;H<K.length;H++)K[H]=(0,b.revive)(K[H]);let k=U.apply(te,K);return k instanceof Promise||(k=Promise.resolve(k)),k}throw new P.ErrorNoTelemetry(`Method not found: ${N}`)}}}V.fromService=z;function Q($,ae){const de=ae&&ae.disableMarshalling;return new Proxy({},{get(te,c){if(typeof c=="string")return ae?.properties?.has(c)?ae.properties.get(c):ue(c)?function(j){return $.listen(c,j)}:ee(c)?$.listen(c):async function(...j){let oe;ae&&!(0,g.isUndefinedOrNull)(ae.context)?oe=[ae.context,...j]:oe=j;const N=await $.call(c,oe);return de?N:(0,b.revive)(N)};throw new P.ErrorNoTelemetry(`Property not found: ${String(c)}`)}})}V.toService=Q;function ee($){return $[0]==="o"&&$[1]==="n"&&h.isUpperAsciiLetter($.charCodeAt(2))}function ue($){return/^onDynamic/.test($)&&h.isUpperAsciiLetter($.charCodeAt(9))}})(B||(e.ProxyChannel=B={}));const Y=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function G(V){if(Array.isArray(V))return V;if(V&&typeof V=="object"&&typeof V.toString=="function"){const z=V.toString();if(z!=="[object Object]")return z}return V}function Z(V){return Array.isArray(V)?V.map(G):G(V)}function se(V,z,Q,ee,ue,$,ae){ae=Z(ae);const de=Y[ue],te=de[ee%de.length];let c=[`%c[${V}]%c[${String(z).padStart(7," ")}]%c[len: ${String(Q).padStart(5," ")}]%c${String(ee).padStart(5," ")} - ${$}`,"color: darkgreen","color: grey","color: grey",`color: ${te}`];/\($/.test($)?(c=c.concat(ae),c.push(")")):c.push(ae),console.log.apply(console,c)}class le{constructor(z,Q){this._outgoingPrefix=z,this._incomingPrefix=Q,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(z,Q,ee,ue,$){this._totalOutgoing+=z,se(this._outgoingPrefix,this._totalOutgoing,z,Q,ee,ue,$)}logIncoming(z,Q,ee,ue,$){this._totalIncoming+=z,se(this._incomingPrefix,this._totalIncoming,z,Q,ee,ue,$)}}e.IPCLogger=le}),define(he[66],fe([0,1,29,12,19,18,60,7,4,2,32,38,36,30]),function(ie,e,o,t,L,m,W,P,_,s,b,h,g,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0,P=Pe(P);class u extends l.ChannelServer{constructor(p){super({send:r=>{try{process.send?.(r.buffer.toString("base64"))}catch{}},onMessage:_.Event.fromNodeEventEmitter(process,"message",r=>L.VSBuffer.wrap(Buffer.from(r,"base64")))},p),process.once("disconnect",()=>this.dispose())}}e.Server=u;class a{constructor(p,r){this.modulePath=p,this.options=r,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new _.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const y=r&&r.timeout?r.timeout:6e4;this.disposeDelayer=new t.Delayer(y),this.child=null,this._client=null}getChannel(p){const r=this;return{call(y,w,C){return r.requestPromise(p,y,w,C)},listen(y,w){return r.requestEvent(p,y,w)}}}requestPromise(p,r,y,w=m.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(w.isCancellationRequested)return Promise.reject(P.canceled());this.disposeDelayer.cancel();const C=this.getCachedChannel(p),i=(0,t.createCancelablePromise)(R=>C.call(r,y,R)),n=w.onCancellationRequested(()=>i.cancel()),f=(0,s.toDisposable)(()=>i.cancel());return this.activeRequests.add(f),i.finally(()=>{n.dispose(),this.activeRequests.delete(f),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),i}requestEvent(p,r,y){if(!this.disposeDelayer)return _.Event.None;this.disposeDelayer.cancel();let w;const C=new _.Emitter({onWillAddFirstListener:()=>{w=this.getCachedChannel(p).listen(r,y)(C.fire,C),this.activeRequests.add(w)},onDidRemoveLastListener:()=>{this.activeRequests.delete(w),w.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return C.event}get client(){if(!this._client){const p=this.options&&this.options.args?this.options.args:[],r=Object.create(null);r.env={...(0,b.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(r.env={...r.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(r.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(r.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(r.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),r.execArgv===void 0&&(r.execArgv=process.execArgv.filter(v=>!/^--inspect(-brk)?=/.test(v)).filter(v=>!v.startsWith("--vscode-"))),(0,g.removeDangerousEnvVariables)(r.env),this.child=(0,o.fork)(this.modulePath,p,r);const y=new _.Emitter,C=_.Event.fromNodeEventEmitter(this.child,"message",v=>v)(v=>{if((0,W.isRemoteConsoleLog)(v)){(0,W.log)(v,`IPC Library: ${this.options.serverName}`);return}y.fire(L.VSBuffer.wrap(Buffer.from(v,"base64")))}),i=this.options.useQueue?(0,h.createQueuedSender)(this.child):this.child,n=v=>this.child&&this.child.connected&&i.send(v.buffer.toString("base64")),f=y.event,R={send:n,onMessage:f};this._client=new l.ChannelClient(R);const x=()=>this.disposeClient();process.once("exit",x),this.child.on("error",v=>console.warn('IPC "'+this.options.serverName+'" errored with '+v)),this.child.on("exit",(v,S)=>{process.removeListener("exit",x),C.dispose(),this.activeRequests.forEach(T=>(0,s.dispose)(T)),this.activeRequests.clear(),v!==0&&S!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+v+" and signal "+S),this.disposeDelayer?.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:v,signal:S})})}return this._client}getCachedChannel(p){let r=this.channels.get(p);return r||(r=this.client.getChannel(p),this.channels.set(p,r)),r}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer?.cancel(),this.disposeDelayer=void 0,this.disposeClient(),this.activeRequests.clear()}}e.Client=a}),define(he[67],fe([0,1,33,19,30,4,10,17]),function(ie,e,o,t,L,m,W,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0,e.once=b;class _{constructor(g){this.port=g,this.onMessage=m.Event.fromNodeEventEmitter(this.port,"message",l=>l.data?t.VSBuffer.wrap(l.data):t.VSBuffer.alloc(0)),g.start()}send(g){this.port.postMessage(g.buffer)}disconnect(){this.port.close()}}class s extends L.IPCServer{static getOnDidClientConnect(g){(0,W.assertType)((0,o.isUtilityProcess)(process),"Electron Utility Process");const l=new m.Emitter;return process.parentPort.on("message",u=>{if(g?.handledClientConnection(u))return;const a=(0,P.firstOrDefault)(u.ports);a&&l.fire(a)}),m.Event.map(l.event,u=>({protocol:new _(u),onDidClientDisconnect:m.Event.fromNodeEventEmitter(u,"close")}))}constructor(g){super(s.getOnDidClientConnect(g))}}e.Server=s;function b(h,g,l){const u=a=>{a.data===g&&(h.removeListener("message",u),l())};h.on("message",u)}}),define(he[68],fe([0,1,13,7,8]),function(ie,e,o,t,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Scanner=e.TokenType=void 0;var m;(function(b){b[b.LParen=0]="LParen",b[b.RParen=1]="RParen",b[b.Neg=2]="Neg",b[b.Eq=3]="Eq",b[b.NotEq=4]="NotEq",b[b.Lt=5]="Lt",b[b.LtEq=6]="LtEq",b[b.Gt=7]="Gt",b[b.GtEq=8]="GtEq",b[b.RegexOp=9]="RegexOp",b[b.RegexStr=10]="RegexStr",b[b.True=11]="True",b[b.False=12]="False",b[b.In=13]="In",b[b.Not=14]="Not",b[b.And=15]="And",b[b.Or=16]="Or",b[b.Str=17]="Str",b[b.QuotedStr=18]="QuotedStr",b[b.Error=19]="Error",b[b.EOF=20]="EOF"})(m||(e.TokenType=m={}));function W(...b){switch(b.length){case 1:return(0,L.localize)(1693,null,b[0]);case 2:return(0,L.localize)(1694,null,b[0],b[1]);case 3:return(0,L.localize)(1695,null,b[0],b[1],b[2]);default:return}}const P=(0,L.localize)(1696,null),_=(0,L.localize)(1697,null);class s{constructor(){this._input="",this._start=0,this._current=0,this._tokens=[],this._errors=[],this.stringRe=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(h){switch(h.type){case m.LParen:return"(";case m.RParen:return")";case m.Neg:return"!";case m.Eq:return h.isTripleEq?"===":"==";case m.NotEq:return h.isTripleEq?"!==":"!=";case m.Lt:return"<";case m.LtEq:return"<=";case m.Gt:return">=";case m.GtEq:return">=";case m.RegexOp:return"=~";case m.RegexStr:return h.lexeme;case m.True:return"true";case m.False:return"false";case m.In:return"in";case m.Not:return"not";case m.And:return"&&";case m.Or:return"||";case m.Str:return h.lexeme;case m.QuotedStr:return h.lexeme;case m.Error:return h.lexeme;case m.EOF:return"EOF";default:throw(0,t.illegalState)(`unhandled token type: ${JSON.stringify(h)}; have you forgotten to add a case?`)}}static{this._regexFlags=new Set(["i","g","s","m","y","u"].map(h=>h.charCodeAt(0)))}static{this._keywords=new Map([["not",m.Not],["in",m.In],["false",m.False],["true",m.True]])}get errors(){return this._errors}reset(h){return this._input=h,this._start=0,this._current=0,this._tokens=[],this._errors=[],this}scan(){for(;!this._isAtEnd();)switch(this._start=this._current,this._advance()){case o.CharCode.OpenParen:this._addToken(m.LParen);break;case o.CharCode.CloseParen:this._addToken(m.RParen);break;case o.CharCode.ExclamationMark:if(this._match(o.CharCode.Equals)){const g=this._match(o.CharCode.Equals);this._tokens.push({type:m.NotEq,offset:this._start,isTripleEq:g})}else this._addToken(m.Neg);break;case o.CharCode.SingleQuote:this._quotedString();break;case o.CharCode.Slash:this._regex();break;case o.CharCode.Equals:if(this._match(o.CharCode.Equals)){const g=this._match(o.CharCode.Equals);this._tokens.push({type:m.Eq,offset:this._start,isTripleEq:g})}else this._match(o.CharCode.Tilde)?this._addToken(m.RegexOp):this._error(W("==","=~"));break;case o.CharCode.LessThan:this._addToken(this._match(o.CharCode.Equals)?m.LtEq:m.Lt);break;case o.CharCode.GreaterThan:this._addToken(this._match(o.CharCode.Equals)?m.GtEq:m.Gt);break;case o.CharCode.Ampersand:this._match(o.CharCode.Ampersand)?this._addToken(m.And):this._error(W("&&"));break;case o.CharCode.Pipe:this._match(o.CharCode.Pipe)?this._addToken(m.Or):this._error(W("||"));break;case o.CharCode.Space:case o.CharCode.CarriageReturn:case o.CharCode.Tab:case o.CharCode.LineFeed:case o.CharCode.NoBreakSpace:break;default:this._string()}return this._start=this._current,this._addToken(m.EOF),Array.from(this._tokens)}_match(h){return this._isAtEnd()||this._input.charCodeAt(this._current)!==h?!1:(this._current++,!0)}_advance(){return this._input.charCodeAt(this._current++)}_peek(){return this._isAtEnd()?o.CharCode.Null:this._input.charCodeAt(this._current)}_addToken(h){this._tokens.push({type:h,offset:this._start})}_error(h){const g=this._start,l=this._input.substring(this._start,this._current),u={type:m.Error,offset:this._start,lexeme:l};this._errors.push({offset:g,lexeme:l,additionalInfo:h}),this._tokens.push(u)}_string(){this.stringRe.lastIndex=this._start;const h=this.stringRe.exec(this._input);if(h){this._current=this._start+h[0].length;const g=this._input.substring(this._start,this._current),l=s._keywords.get(g);l?this._addToken(l):this._tokens.push({type:m.Str,lexeme:g,offset:this._start})}}_quotedString(){for(;this._peek()!==o.CharCode.SingleQuote&&!this._isAtEnd();)this._advance();if(this._isAtEnd()){this._error(P);return}this._advance(),this._tokens.push({type:m.QuotedStr,lexeme:this._input.substring(this._start+1,this._current-1),offset:this._start+1})}_regex(){let h=this._current,g=!1,l=!1;for(;;){if(h>=this._input.length){this._current=h,this._error(_);return}const a=this._input.charCodeAt(h);if(g)g=!1;else if(a===o.CharCode.Slash&&!l){h++;break}else a===o.CharCode.OpenSquareBracket?l=!0:a===o.CharCode.Backslash?g=!0:a===o.CharCode.CloseSquareBracket&&(l=!1);h++}for(;h<this._input.length&&s._regexFlags.has(this._input.charCodeAt(h));)h++;this._current=h;const u=this._input.substring(this._start,this._current);this._tokens.push({type:m.RegexStr,lexeme:u,offset:this._start})}_isAtEnd(){return this._current>=this._input.length}}e.Scanner=s}),define(he[69],fe([0,1,58,14,20,5,15,25,6]),function(ie,e,o,t,L,m,W,P,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractNativeEnvironmentService=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=void 0,e.parseExtensionHostDebugPort=b,e.parseDebugParams=h,e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=/^([^.]+\..+)[:=](.+)$/;class s{get appRoot(){return(0,m.dirname)(L.FileAccess.asFileUri("").fsPath)}get userHome(){return _.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return _.URI.file((0,m.join)(this.userDataPath,"User"))}get tmpDir(){return _.URI.file(this.paths.tmpDir)}get cacheHome(){return _.URI.file(this.userDataPath)}get stateResource(){return(0,P.joinPath)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:L.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,P.joinPath)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const l=(0,o.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,m.join)(this.userDataPath,"logs",l)}return _.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,P.joinPath)(_.URI.file((0,m.join)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,P.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,P.joinPath)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,P.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const l=W.env.VSCODE_PORTABLE;return l?_.URI.file((0,m.join)(l,"argv.json")):(0,P.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return _.URI.file((0,m.join)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const l=this.args["builtin-extensions-dir"];return l?(0,m.resolve)(l):(0,m.normalize)((0,m.join)(L.FileAccess.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const l=this.args["extensions-download-dir"];return l?_.URI.file((0,m.resolve)(l)):_.URI.file((0,m.join)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const l=this.args["extensions-dir"];if(l)return(0,m.resolve)(l);const u=W.env.VSCODE_EXTENSIONS;if(u)return u;const a=W.env.VSCODE_PORTABLE;return a?(0,m.join)(a,"extensions"):(0,P.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const l=this.args.extensionDevelopmentPath;if(Array.isArray(l))return l.map(u=>/^[^:/?#]+?:\/\//.test(u)?_.URI.parse(u):_.URI.file((0,m.normalize)(u)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(l=>l==="ui"||l==="workspace"||l==="web"?l:"workspace")}get extensionTestsLocationURI(){const l=this.args.extensionTestsPath;if(l)return/^[^:/?#]+?:\/\//.test(l)?_.URI.parse(l):_.URI.file((0,m.normalize)(l))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const l=this.args["disable-extension"];if(l){if(typeof l=="string")return[l];if(Array.isArray(l)&&l.length>0)return l}return!1}get debugExtensionHost(){return b(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!W.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(l=>!e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.test(l))}get extensionLogLevel(){const l=[];for(const u of this.args.log||[]){const a=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.exec(u);a&&a[1]&&a[2]&&l.push([a[1],a[2]])}return l.length?l:void 0}get serviceMachineIdResource(){return(0,P.joinPath)(_.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const l=W.env.VSCODE_PORTABLE;return l?_.URI.file((0,m.join)(l,"policy.json")):(0,P.joinPath)(this.userHome,this.productService.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(l){this.args.continueOn=l}get args(){return this._args}constructor(l,u,a){this._args=l,this.paths=u,this.productService=a,this.editSessionId=this.args.editSessionId}}e.AbstractNativeEnvironmentService=s,ge([t.memoize],s.prototype,"appRoot",null),ge([t.memoize],s.prototype,"userHome",null),ge([t.memoize],s.prototype,"userDataPath",null),ge([t.memoize],s.prototype,"appSettingsHome",null),ge([t.memoize],s.prototype,"tmpDir",null),ge([t.memoize],s.prototype,"cacheHome",null),ge([t.memoize],s.prototype,"stateResource",null),ge([t.memoize],s.prototype,"userRoamingDataHome",null),ge([t.memoize],s.prototype,"userDataSyncHome",null),ge([t.memoize],s.prototype,"sync",null),ge([t.memoize],s.prototype,"machineSettingsResource",null),ge([t.memoize],s.prototype,"workspaceStorageHome",null),ge([t.memoize],s.prototype,"localHistoryHome",null),ge([t.memoize],s.prototype,"keyboardLayoutResource",null),ge([t.memoize],s.prototype,"argvResource",null),ge([t.memoize],s.prototype,"isExtensionDevelopment",null),ge([t.memoize],s.prototype,"untitledWorkspacesHome",null),ge([t.memoize],s.prototype,"builtinExtensionsPath",null),ge([t.memoize],s.prototype,"extensionsPath",null),ge([t.memoize],s.prototype,"extensionDevelopmentLocationURI",null),ge([t.memoize],s.prototype,"extensionDevelopmentKind",null),ge([t.memoize],s.prototype,"extensionTestsLocationURI",null),ge([t.memoize],s.prototype,"debugExtensionHost",null),ge([t.memoize],s.prototype,"logLevel",null),ge([t.memoize],s.prototype,"extensionLogLevel",null),ge([t.memoize],s.prototype,"serviceMachineIdResource",null),ge([t.memoize],s.prototype,"disableTelemetry",null),ge([t.memoize],s.prototype,"disableWorkspaceTrust",null),ge([t.memoize],s.prototype,"useInMemorySecretStorage",null),ge([t.memoize],s.prototype,"policyFile",null);function b(g,l){return h(g["inspect-extensions"],g["inspect-brk-extensions"],5870,l,g.debugId,g.extensionEnvironment)}function h(g,l,u,a,d,p){const y=Number(l||g)||(a?null:u),w=y?!!l:!1;let C;if(p)try{C=JSON.parse(p)}catch{}return{port:y,break:w,debugId:d,env:C}}});var Ke=this&&this.__importDefault||function(ie){return ie&&ie.__esModule?ie:{default:ie}};define(he[70],fe([0,1,102,3,8]),function(ie,e,o,t,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OPTIONS=e.NATIVE_CLI_COMMANDS=void 0,e.parseArgs=P,e.formatOptions=s,e.buildHelpMessage=l,e.buildVersionMessage=u,o=Ke(o);const m={o:(0,L.localize)(1713,null),e:(0,L.localize)(1714,null),t:(0,L.localize)(1715,null)};e.NATIVE_CLI_COMMANDS=["tunnel","serve-web"],e.OPTIONS={tunnel:{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,L.localize)(1716,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"},user:{type:"subcommand",options:{login:{type:"subcommand",options:{provider:{type:"string"},"access-token":{type:"string"}}}}}}},"serve-web":{type:"subcommand",description:"Run a server that displays the editor UI in browsers.",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,L.localize)(1717,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"}}},diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,L.localize)(1718,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,L.localize)(1719,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,L.localize)(1720,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,L.localize)(1721,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,L.localize)(1722,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,L.localize)(1723,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,L.localize)(1724,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,L.localize)(1725,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,L.localize)(1726,null)},profile:{type:"string",cat:"o",args:"profileName",description:(0,L.localize)(1727,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,L.localize)(1728,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,L.localize)(1729,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,L.localize)(1730,null)},"show-versions":{type:"boolean",cat:"e",description:(0,L.localize)(1731,null)},category:{type:"string",allowEmptyValue:!0,cat:"e",description:(0,L.localize)(1732,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,L.localize)(1733,null)},"pre-release":{type:"boolean",cat:"e",description:(0,L.localize)(1734,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,L.localize)(1735,null)},"update-extensions":{type:"boolean",cat:"e",description:(0,L.localize)(1736,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,L.localize)(1737,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,L.localize)(1738,null)},verbose:{type:"boolean",cat:"t",global:!0,description:(0,L.localize)(1739,null)},log:{type:"string[]",cat:"t",args:"level",global:!0,description:(0,L.localize)(1740,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,L.localize)(1741,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,L.localize)(1742,null)},"prof-append-timers":{type:"string"},"prof-duration-markers":{type:"string[]"},"prof-duration-markers-file":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,L.localize)(1743,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,L.localize)(1744,null)},sync:{type:"string",cat:"t",description:(0,L.localize)(1745,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,L.localize)(1746,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,L.localize)(1747,null)},"disable-lcd-text":{type:"boolean",cat:"t",description:(0,L.localize)(1748,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,L.localize)(1749,null)},"disable-chromium-sandbox":{type:"boolean",cat:"t",description:(0,L.localize)(1750,null)},sandbox:{type:"boolean"},telemetry:{type:"boolean",cat:"t",description:(0,L.localize)(1751,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"inspect-sharedprocess":{type:"string",allowEmptyValue:!0},"inspect-brk-sharedprocess":{type:"string",allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"use-inmemory-secretstorage":{type:"boolean",deprecates:["disable-keytar"]},"password-store":{type:"string"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"preserve-env":{type:"boolean"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},"disable-gpu-sandbox":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},"ozone-platform":{type:"string"},"enable-tracing":{type:"string"},"trace-startup-format":{type:"string"},"trace-startup-file":{type:"string"},"trace-startup-duration":{type:"string"},_:{type:"string[]"}};const W={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function P(a,d,p=W){const r=a.find(v=>v.length>0&&v[0]!=="-"),y={},w=["_"],C=[],i={};let n;for(const v in d){const S=d[v];S.type==="subcommand"?v===r&&(n=S):(S.alias&&(y[v]=S.alias),S.type==="string"||S.type==="string[]"?(w.push(v),S.deprecates&&w.push(...S.deprecates)):S.type==="boolean"&&(C.push(v),S.deprecates&&C.push(...S.deprecates)),S.global&&(i[v]=S))}if(n&&r){const v=i;for(const F in n.options)v[F]=n.options[F];const S=a.filter(F=>F!==r),T=p.getSubcommandReporter?p.getSubcommandReporter(r):void 0,O=P(S,v,T);return{[r]:O,_:[]}}const f=(0,o.default)(a,{string:w,boolean:C,alias:y}),R={},x=f;R._=f._.map(v=>String(v)).filter(v=>v.length>0),delete x._;for(const v in d){const S=d[v];if(S.type==="subcommand")continue;S.alias&&delete x[S.alias];let T=x[v];if(S.deprecates)for(const O of S.deprecates)x.hasOwnProperty(O)&&(T||(T=x[O],T&&p.onDeprecatedOption(O,S.deprecationMessage||(0,L.localize)(1752,null,v))),delete x[O]);if(typeof T<"u"){if(S.type==="string[]"){if(Array.isArray(T)||(T=[T]),!S.allowEmptyValue){const O=T.filter(F=>F.length>0);O.length!==T.length&&(p.onEmptyValue(v),T=O.length>0?O:void 0)}}else S.type==="string"&&(Array.isArray(T)?(T=T.pop(),p.onMultipleValues(v,T)):!T&&!S.allowEmptyValue&&(p.onEmptyValue(v),T=void 0));R[v]=T,S.deprecationMessage&&p.onDeprecatedOption(v,S.deprecationMessage)}delete x[v]}for(const v in x)p.onUnknownOption(v);return R}function _(a,d){let p="";return d.args&&(Array.isArray(d.args)?p=` <${d.args.join("> <")}>`:p=` <${d.args}>`),d.alias?`-${d.alias} --${a}${p}`:`--${a}${p}`}function s(a,d){const p=[];for(const r in a){const y=a[r],w=_(r,y);p.push([w,y.description])}return b(p,d)}function b(a,d){const r=a.reduce((C,i)=>Math.max(C,i[0].length),12)+2+1;if(d-r<25)return a.reduce((C,i)=>C.concat([`  ${i[0]}`,`      ${i[1]}`]),[]);const y=d-r-1,w=[];for(const C of a){const i=C[0],n=g(C[1],y),f=h(r-i.length-2);w.push("  "+i+f+n[0]);for(let R=1;R<n.length;R++)w.push(h(r)+n[R])}return w}function h(a){return" ".repeat(a)}function g(a,d){const p=[];for(;a.length;){const r=a.length<d?a.length:a.lastIndexOf(" ",d),y=a.slice(0,r).trim();a=a.slice(r),p.push(y)}return p}function l(a,d,p,r,y){const w=process.stdout.isTTY&&process.stdout.columns||80,C=y?.noInputFiles!==!0?`[${(0,L.localize)(1753,null)}...]`:"",i=[`${a} ${p}`];i.push(""),i.push(`${(0,L.localize)(1754,null)}: ${d} [${(0,L.localize)(1755,null)}]${C}`),i.push(""),y?.noPipe!==!0&&(t.isWindows?i.push((0,L.localize)(1756,null,d)):i.push((0,L.localize)(1757,null,d)),i.push(""));const n={},f=[];for(const R in r){const x=r[R];if(x.type==="subcommand")x.description&&f.push({command:R,description:x.description});else if(x.description&&x.cat){let v=n[x.cat];v||(n[x.cat]=v={}),v[R]=x}}for(const R in n){const x=R,v=n[x];v&&(i.push(m[x]),i.push(...s(v,w)),i.push(""))}return f.length&&(i.push((0,L.localize)(1758,null)),i.push(...b(f.map(R=>[R.command,R.description]),w)),i.push("")),i.join(`
`)}function u(a,d){return`${a||(0,L.localize)(1759,null)}
${d||(0,L.localize)(1760,null)}
${process.arch}`}}),function(){function ie(e,o,t){function L(W,P){const _=m(W,P),s=[_];return e.isAbsolute(_)||s.unshift(t),e.resolve(...s)}function m(W,P){process.env.VSCODE_DEV&&(P="code-oss-dev");const _=process.env.VSCODE_PORTABLE;if(_)return e.join(_,"user-data");let s=process.env.VSCODE_APPDATA;if(s)return e.join(s,P);const b=W["user-data-dir"];if(b)return b;switch(process.platform){case"win32":if(s=process.env.APPDATA,!s){const h=process.env.USERPROFILE;if(typeof h!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");s=e.join(h,"AppData","Roaming")}break;case"darwin":s=e.join(o.homedir(),"Library","Application Support");break;case"linux":s=process.env.XDG_CONFIG_HOME||e.join(o.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(s,P)}return{getUserDataPath:L}}if(typeof define=="function")define(he[71],fe([72,21,15]),function(e,o,t){return ie(e,o,t.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),o=require("os");module.exports=ie(e,o,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(he[73],fe([0,1,21,69,71]),function(ie,e,o,t,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0,e.parsePtyHostDebugPort=W,e.parseSharedProcessDebugPort=P;class m extends t.AbstractNativeEnvironmentService{constructor(s,b){super(s,{homeDir:(0,o.homedir)(),tmpDir:(0,o.tmpdir)(),userDataDir:(0,L.getUserDataPath)(s,b.nameShort)},b)}}e.NativeEnvironmentService=m;function W(_,s){return(0,t.parseDebugParams)(_["inspect-ptyhost"],_["inspect-brk-ptyhost"],5877,s,_.extensionEnvironment)}function P(_,s){return(0,t.parseDebugParams)(_["inspect-sharedprocess"],_["inspect-brk-sharedprocess"],5879,s,_.extensionEnvironment)}}),define(he[22],fe([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IInstantiationService=e._util=void 0,e.createDecorator=L,e.refineServiceDecorator=m;var o;(function(W){W.serviceIds=new Map,W.DI_TARGET="$di$target",W.DI_DEPENDENCIES="$di$dependencies";function P(_){return _[W.DI_DEPENDENCIES]||[]}W.getServiceDependencies=P})(o||(e._util=o={})),e.IInstantiationService=L("instantiationService");function t(W,P,_){P[o.DI_TARGET]===P?P[o.DI_DEPENDENCIES].push({id:W,index:_}):(P[o.DI_DEPENDENCIES]=[{id:W,index:_}],P[o.DI_TARGET]=P)}function L(W){if(o.serviceIds.has(W))return o.serviceIds.get(W);const P=function(_,s,b){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");t(P,_,b)};return P.toString=()=>W,o.serviceIds.set(W,P),P}function m(W){return W}}),define(he[39],fe([0,1,13,3,11,68,22,8,7]),function(ie,e,o,t,L,m,W,P,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.ContextKeyExpr=e.Parser=e.ContextKeyExprType=void 0,e.setConstant=b,e.validateWhenClauses=f,e.expressionsAreEqualWithConstantSubstitution=R,e.implies=$;const s=new Map;s.set("false",!1),s.set("true",!0),s.set("isMac",t.isMacintosh),s.set("isLinux",t.isLinux),s.set("isWindows",t.isWindows),s.set("isWeb",t.isWeb),s.set("isMacNative",t.isMacintosh&&!t.isWeb),s.set("isEdge",t.isEdge),s.set("isFirefox",t.isFirefox),s.set("isChrome",t.isChrome),s.set("isSafari",t.isSafari);function b(te,c){if(s.get(te)!==void 0)throw(0,_.illegalArgument)("contextkey.setConstant(k, v) invoked with already set constant `k`");s.set(te,c)}const h=Object.prototype.hasOwnProperty;var g;(function(te){te[te.False=0]="False",te[te.True=1]="True",te[te.Defined=2]="Defined",te[te.Not=3]="Not",te[te.Equals=4]="Equals",te[te.NotEquals=5]="NotEquals",te[te.And=6]="And",te[te.Regex=7]="Regex",te[te.NotRegex=8]="NotRegex",te[te.Or=9]="Or",te[te.In=10]="In",te[te.NotIn=11]="NotIn",te[te.Greater=12]="Greater",te[te.GreaterEquals=13]="GreaterEquals",te[te.Smaller=14]="Smaller",te[te.SmallerEquals=15]="SmallerEquals"})(g||(e.ContextKeyExprType=g={}));const l={regexParsingWithErrorRecovery:!0},u=(0,P.localize)(1673,null),a=(0,P.localize)(1674,null),d=(0,P.localize)(1675,null),p=(0,P.localize)(1676,null),r=(0,P.localize)(1677,null),y=(0,P.localize)(1678,null),w=(0,P.localize)(1679,null),C=(0,P.localize)(1680,null);class i{static{this._parseError=new Error}get lexingErrors(){return this._scanner.errors}get parsingErrors(){return this._parsingErrors}constructor(c=l){this._config=c,this._scanner=new m.Scanner,this._tokens=[],this._current=0,this._parsingErrors=[],this._flagsGYRe=/g|y/g}parse(c){if(c===""){this._parsingErrors.push({message:u,offset:0,lexeme:"",additionalInfo:a});return}this._tokens=this._scanner.reset(c).scan(),this._current=0,this._parsingErrors=[];try{const j=this._expr();if(!this._isAtEnd()){const oe=this._peek(),N=oe.type===m.TokenType.Str?y:void 0;throw this._parsingErrors.push({message:r,offset:oe.offset,lexeme:m.Scanner.getLexeme(oe),additionalInfo:N}),i._parseError}return j}catch(j){if(j!==i._parseError)throw j;return}}_expr(){return this._or()}_or(){const c=[this._and()];for(;this._matchOne(m.TokenType.Or);){const j=this._and();c.push(j)}return c.length===1?c[0]:n.or(...c)}_and(){const c=[this._term()];for(;this._matchOne(m.TokenType.And);){const j=this._term();c.push(j)}return c.length===1?c[0]:n.and(...c)}_term(){if(this._matchOne(m.TokenType.Neg)){const c=this._peek();switch(c.type){case m.TokenType.True:return this._advance(),v.INSTANCE;case m.TokenType.False:return this._advance(),S.INSTANCE;case m.TokenType.LParen:{this._advance();const j=this._expr();return this._consume(m.TokenType.RParen,p),j?.negate()}case m.TokenType.Str:return this._advance(),M.create(c.lexeme);default:throw this._errExpectedButGot("KEY | true | false | '(' expression ')'",c)}}return this._primary()}_primary(){const c=this._peek();switch(c.type){case m.TokenType.True:return this._advance(),n.true();case m.TokenType.False:return this._advance(),n.false();case m.TokenType.LParen:{this._advance();const j=this._expr();return this._consume(m.TokenType.RParen,p),j}case m.TokenType.Str:{const j=c.lexeme;if(this._advance(),this._matchOne(m.TokenType.RegexOp)){const N=this._peek();if(!this._config.regexParsingWithErrorRecovery){if(this._advance(),N.type!==m.TokenType.RegexStr)throw this._errExpectedButGot("REGEX",N);const K=N.lexeme,U=K.lastIndexOf("/"),k=U===K.length-1?void 0:this._removeFlagsGY(K.substring(U+1));let H;try{H=new RegExp(K.substring(1,U),k)}catch{throw this._errExpectedButGot("REGEX",N)}return Z.create(j,H)}switch(N.type){case m.TokenType.RegexStr:case m.TokenType.Error:{const K=[N.lexeme];this._advance();let U=this._peek(),k=0;for(let we=0;we<N.lexeme.length;we++)N.lexeme.charCodeAt(we)===o.CharCode.OpenParen?k++:N.lexeme.charCodeAt(we)===o.CharCode.CloseParen&&k--;for(;!this._isAtEnd()&&U.type!==m.TokenType.And&&U.type!==m.TokenType.Or;){switch(U.type){case m.TokenType.LParen:k++;break;case m.TokenType.RParen:k--;break;case m.TokenType.RegexStr:case m.TokenType.QuotedStr:for(let we=0;we<U.lexeme.length;we++)U.lexeme.charCodeAt(we)===o.CharCode.OpenParen?k++:N.lexeme.charCodeAt(we)===o.CharCode.CloseParen&&k--}if(k<0)break;K.push(m.Scanner.getLexeme(U)),this._advance(),U=this._peek()}const H=K.join(""),J=H.lastIndexOf("/"),ne=J===H.length-1?void 0:this._removeFlagsGY(H.substring(J+1));let _e;try{_e=new RegExp(H.substring(1,J),ne)}catch{throw this._errExpectedButGot("REGEX",N)}return n.regex(j,_e)}case m.TokenType.QuotedStr:{const K=N.lexeme;this._advance();let U=null;if(!(0,L.isFalsyOrWhitespace)(K)){const k=K.indexOf("/"),H=K.lastIndexOf("/");if(k!==H&&k>=0){const J=K.slice(k+1,H),ne=K[H+1]==="i"?"i":"";try{U=new RegExp(J,ne)}catch{throw this._errExpectedButGot("REGEX",N)}}}if(U===null)throw this._errExpectedButGot("REGEX",N);return Z.create(j,U)}default:throw this._errExpectedButGot("REGEX",this._peek())}}if(this._matchOne(m.TokenType.Not)){this._consume(m.TokenType.In,d);const N=this._value();return n.notIn(j,N)}switch(this._peek().type){case m.TokenType.Eq:{this._advance();const N=this._value();if(this._previous().type===m.TokenType.QuotedStr)return n.equals(j,N);switch(N){case"true":return n.has(j);case"false":return n.not(j);default:return n.equals(j,N)}}case m.TokenType.NotEq:{this._advance();const N=this._value();if(this._previous().type===m.TokenType.QuotedStr)return n.notEquals(j,N);switch(N){case"true":return n.not(j);case"false":return n.has(j);default:return n.notEquals(j,N)}}case m.TokenType.Lt:return this._advance(),Y.create(j,this._value());case m.TokenType.LtEq:return this._advance(),G.create(j,this._value());case m.TokenType.Gt:return this._advance(),I.create(j,this._value());case m.TokenType.GtEq:return this._advance(),B.create(j,this._value());case m.TokenType.In:return this._advance(),n.in(j,this._value());default:return n.has(j)}}case m.TokenType.EOF:throw this._parsingErrors.push({message:w,offset:c.offset,lexeme:"",additionalInfo:C}),i._parseError;default:throw this._errExpectedButGot(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this._peek())}}_value(){const c=this._peek();switch(c.type){case m.TokenType.Str:case m.TokenType.QuotedStr:return this._advance(),c.lexeme;case m.TokenType.True:return this._advance(),"true";case m.TokenType.False:return this._advance(),"false";case m.TokenType.In:return this._advance(),"in";default:return""}}_removeFlagsGY(c){return c.replaceAll(this._flagsGYRe,"")}_previous(){return this._tokens[this._current-1]}_matchOne(c){return this._check(c)?(this._advance(),!0):!1}_advance(){return this._isAtEnd()||this._current++,this._previous()}_consume(c,j){if(this._check(c))return this._advance();throw this._errExpectedButGot(j,this._peek())}_errExpectedButGot(c,j,oe){const N=(0,P.localize)(1681,null,c,m.Scanner.getLexeme(j)),K=j.offset,U=m.Scanner.getLexeme(j);return this._parsingErrors.push({message:N,offset:K,lexeme:U,additionalInfo:oe}),i._parseError}_check(c){return this._peek().type===c}_peek(){return this._tokens[this._current]}_isAtEnd(){return this._peek().type===m.TokenType.EOF}}e.Parser=i;class n{static false(){return v.INSTANCE}static true(){return S.INSTANCE}static has(c){return T.create(c)}static equals(c,j){return O.create(c,j)}static notEquals(c,j){return E.create(c,j)}static regex(c,j){return Z.create(c,j)}static in(c,j){return F.create(c,j)}static notIn(c,j){return D.create(c,j)}static not(c){return M.create(c)}static and(...c){return V.create(c,null,!0)}static or(...c){return z.create(c,null,!0)}static greater(c,j){return I.create(c,j)}static greaterEquals(c,j){return B.create(c,j)}static smaller(c,j){return Y.create(c,j)}static smallerEquals(c,j){return G.create(c,j)}static{this._parser=new i({regexParsingWithErrorRecovery:!1})}static deserialize(c){return c==null?void 0:this._parser.parse(c)}}e.ContextKeyExpr=n;function f(te){const c=new i({regexParsingWithErrorRecovery:!1});return te.map(j=>(c.parse(j),c.lexingErrors.length>0?c.lexingErrors.map(oe=>({errorMessage:oe.additionalInfo?(0,P.localize)(1682,null,oe.additionalInfo):(0,P.localize)(1683,null),offset:oe.offset,length:oe.lexeme.length})):c.parsingErrors.length>0?c.parsingErrors.map(oe=>({errorMessage:oe.additionalInfo?`${oe.message}. ${oe.additionalInfo}`:oe.message,offset:oe.offset,length:oe.lexeme.length})):[]))}function R(te,c){const j=te?te.substituteConstants():void 0,oe=c?c.substituteConstants():void 0;return!j&&!oe?!0:!j||!oe?!1:j.equals(oe)}function x(te,c){return te.cmp(c)}class v{static{this.INSTANCE=new v}constructor(){this.type=g.False}cmp(c){return this.type-c.type}equals(c){return c.type===this.type}substituteConstants(){return this}evaluate(c){return!1}serialize(){return"false"}keys(){return[]}map(c){return this}negate(){return S.INSTANCE}}e.ContextKeyFalseExpr=v;class S{static{this.INSTANCE=new S}constructor(){this.type=g.True}cmp(c){return this.type-c.type}equals(c){return c.type===this.type}substituteConstants(){return this}evaluate(c){return!0}serialize(){return"true"}keys(){return[]}map(c){return this}negate(){return v.INSTANCE}}e.ContextKeyTrueExpr=S;class T{static create(c,j=null){const oe=s.get(c);return typeof oe=="boolean"?oe?S.INSTANCE:v.INSTANCE:new T(c,j)}constructor(c,j){this.key=c,this.negated=j,this.type=g.Defined}cmp(c){return c.type!==this.type?this.type-c.type:ee(this.key,c.key)}equals(c){return c.type===this.type?this.key===c.key:!1}substituteConstants(){const c=s.get(this.key);return typeof c=="boolean"?c?S.INSTANCE:v.INSTANCE:this}evaluate(c){return!!c.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(c){return c.mapDefined(this.key)}negate(){return this.negated||(this.negated=M.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=T;class O{static create(c,j,oe=null){if(typeof j=="boolean")return j?T.create(c,oe):M.create(c,oe);const N=s.get(c);return typeof N=="boolean"?j===(N?"true":"false")?S.INSTANCE:v.INSTANCE:new O(c,j,oe)}constructor(c,j,oe){this.key=c,this.value=j,this.negated=oe,this.type=g.Equals}cmp(c){return c.type!==this.type?this.type-c.type:ue(this.key,this.value,c.key,c.value)}equals(c){return c.type===this.type?this.key===c.key&&this.value===c.value:!1}substituteConstants(){const c=s.get(this.key);if(typeof c=="boolean"){const j=c?"true":"false";return this.value===j?S.INSTANCE:v.INSTANCE}return this}evaluate(c){return c.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(c){return c.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=E.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=O;class F{static create(c,j){return new F(c,j)}constructor(c,j){this.key=c,this.valueKey=j,this.type=g.In,this.negated=null}cmp(c){return c.type!==this.type?this.type-c.type:ue(this.key,this.valueKey,c.key,c.valueKey)}equals(c){return c.type===this.type?this.key===c.key&&this.valueKey===c.valueKey:!1}substituteConstants(){return this}evaluate(c){const j=c.getValue(this.valueKey),oe=c.getValue(this.key);return Array.isArray(j)?j.includes(oe):typeof oe=="string"&&typeof j=="object"&&j!==null?h.call(j,oe):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(c){return c.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=D.create(this.key,this.valueKey)),this.negated}}e.ContextKeyInExpr=F;class D{static create(c,j){return new D(c,j)}constructor(c,j){this.key=c,this.valueKey=j,this.type=g.NotIn,this._negated=F.create(c,j)}cmp(c){return c.type!==this.type?this.type-c.type:this._negated.cmp(c._negated)}equals(c){return c.type===this.type?this._negated.equals(c._negated):!1}substituteConstants(){return this}evaluate(c){return!this._negated.evaluate(c)}serialize(){return`${this.key} not in '${this.valueKey}'`}keys(){return this._negated.keys()}map(c){return c.mapNotIn(this.key,this.valueKey)}negate(){return this._negated}}e.ContextKeyNotInExpr=D;class E{static create(c,j,oe=null){if(typeof j=="boolean")return j?M.create(c,oe):T.create(c,oe);const N=s.get(c);return typeof N=="boolean"?j===(N?"true":"false")?v.INSTANCE:S.INSTANCE:new E(c,j,oe)}constructor(c,j,oe){this.key=c,this.value=j,this.negated=oe,this.type=g.NotEquals}cmp(c){return c.type!==this.type?this.type-c.type:ue(this.key,this.value,c.key,c.value)}equals(c){return c.type===this.type?this.key===c.key&&this.value===c.value:!1}substituteConstants(){const c=s.get(this.key);if(typeof c=="boolean"){const j=c?"true":"false";return this.value===j?v.INSTANCE:S.INSTANCE}return this}evaluate(c){return c.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(c){return c.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=O.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=E;class M{static create(c,j=null){const oe=s.get(c);return typeof oe=="boolean"?oe?v.INSTANCE:S.INSTANCE:new M(c,j)}constructor(c,j){this.key=c,this.negated=j,this.type=g.Not}cmp(c){return c.type!==this.type?this.type-c.type:ee(this.key,c.key)}equals(c){return c.type===this.type?this.key===c.key:!1}substituteConstants(){const c=s.get(this.key);return typeof c=="boolean"?c?v.INSTANCE:S.INSTANCE:this}evaluate(c){return!c.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(c){return c.mapNot(this.key)}negate(){return this.negated||(this.negated=T.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=M;function A(te,c){if(typeof te=="string"){const j=parseFloat(te);isNaN(j)||(te=j)}return typeof te=="string"||typeof te=="number"?c(te):v.INSTANCE}class I{static create(c,j,oe=null){return A(j,N=>new I(c,N,oe))}constructor(c,j,oe){this.key=c,this.value=j,this.negated=oe,this.type=g.Greater}cmp(c){return c.type!==this.type?this.type-c.type:ue(this.key,this.value,c.key,c.value)}equals(c){return c.type===this.type?this.key===c.key&&this.value===c.value:!1}substituteConstants(){return this}evaluate(c){return typeof this.value=="string"?!1:parseFloat(c.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(c){return c.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=G.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=I;class B{static create(c,j,oe=null){return A(j,N=>new B(c,N,oe))}constructor(c,j,oe){this.key=c,this.value=j,this.negated=oe,this.type=g.GreaterEquals}cmp(c){return c.type!==this.type?this.type-c.type:ue(this.key,this.value,c.key,c.value)}equals(c){return c.type===this.type?this.key===c.key&&this.value===c.value:!1}substituteConstants(){return this}evaluate(c){return typeof this.value=="string"?!1:parseFloat(c.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(c){return c.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=Y.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=B;class Y{static create(c,j,oe=null){return A(j,N=>new Y(c,N,oe))}constructor(c,j,oe){this.key=c,this.value=j,this.negated=oe,this.type=g.Smaller}cmp(c){return c.type!==this.type?this.type-c.type:ue(this.key,this.value,c.key,c.value)}equals(c){return c.type===this.type?this.key===c.key&&this.value===c.value:!1}substituteConstants(){return this}evaluate(c){return typeof this.value=="string"?!1:parseFloat(c.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(c){return c.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=B.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=Y;class G{static create(c,j,oe=null){return A(j,N=>new G(c,N,oe))}constructor(c,j,oe){this.key=c,this.value=j,this.negated=oe,this.type=g.SmallerEquals}cmp(c){return c.type!==this.type?this.type-c.type:ue(this.key,this.value,c.key,c.value)}equals(c){return c.type===this.type?this.key===c.key&&this.value===c.value:!1}substituteConstants(){return this}evaluate(c){return typeof this.value=="string"?!1:parseFloat(c.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(c){return c.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=I.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=G;class Z{static create(c,j){return new Z(c,j)}constructor(c,j){this.key=c,this.regexp=j,this.type=g.Regex,this.negated=null}cmp(c){if(c.type!==this.type)return this.type-c.type;if(this.key<c.key)return-1;if(this.key>c.key)return 1;const j=this.regexp?this.regexp.source:"",oe=c.regexp?c.regexp.source:"";return j<oe?-1:j>oe?1:0}equals(c){if(c.type===this.type){const j=this.regexp?this.regexp.source:"",oe=c.regexp?c.regexp.source:"";return this.key===c.key&&j===oe}return!1}substituteConstants(){return this}evaluate(c){const j=c.getValue(this.key);return this.regexp?this.regexp.test(j):!1}serialize(){const c=this.regexp?`/${this.regexp.source}/${this.regexp.flags}`:"/invalid/";return`${this.key} =~ ${c}`}keys(){return[this.key]}map(c){return c.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=se.create(this)),this.negated}}e.ContextKeyRegexExpr=Z;class se{static create(c){return new se(c)}constructor(c){this._actual=c,this.type=g.NotRegex}cmp(c){return c.type!==this.type?this.type-c.type:this._actual.cmp(c._actual)}equals(c){return c.type===this.type?this._actual.equals(c._actual):!1}substituteConstants(){return this}evaluate(c){return!this._actual.evaluate(c)}serialize(){return`!(${this._actual.serialize()})`}keys(){return this._actual.keys()}map(c){return new se(this._actual.map(c))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=se;function le(te){let c=null;for(let j=0,oe=te.length;j<oe;j++){const N=te[j].substituteConstants();if(te[j]!==N&&c===null){c=[];for(let K=0;K<j;K++)c[K]=te[K]}c!==null&&(c[j]=N)}return c===null?te:c}class V{static create(c,j,oe){return V._normalizeArr(c,j,oe)}constructor(c,j){this.expr=c,this.negated=j,this.type=g.And}cmp(c){if(c.type!==this.type)return this.type-c.type;if(this.expr.length<c.expr.length)return-1;if(this.expr.length>c.expr.length)return 1;for(let j=0,oe=this.expr.length;j<oe;j++){const N=x(this.expr[j],c.expr[j]);if(N!==0)return N}return 0}equals(c){if(c.type===this.type){if(this.expr.length!==c.expr.length)return!1;for(let j=0,oe=this.expr.length;j<oe;j++)if(!this.expr[j].equals(c.expr[j]))return!1;return!0}return!1}substituteConstants(){const c=le(this.expr);return c===this.expr?this:V.create(c,this.negated,!1)}evaluate(c){for(let j=0,oe=this.expr.length;j<oe;j++)if(!this.expr[j].evaluate(c))return!1;return!0}static _normalizeArr(c,j,oe){const N=[];let K=!1;for(const U of c)if(U){if(U.type===g.True){K=!0;continue}if(U.type===g.False)return v.INSTANCE;if(U.type===g.And){N.push(...U.expr);continue}N.push(U)}if(N.length===0&&K)return S.INSTANCE;if(N.length!==0){if(N.length===1)return N[0];N.sort(x);for(let U=1;U<N.length;U++)N[U-1].equals(N[U])&&(N.splice(U,1),U--);if(N.length===1)return N[0];for(;N.length>1;){const U=N[N.length-1];if(U.type!==g.Or)break;N.pop();const k=N.pop(),H=N.length===0,J=z.create(U.expr.map(ne=>V.create([ne,k],null,oe)),null,H);J&&(N.push(J),N.sort(x))}if(N.length===1)return N[0];if(oe){for(let U=0;U<N.length;U++)for(let k=U+1;k<N.length;k++)if(N[U].negate().equals(N[k]))return v.INSTANCE;if(N.length===1)return N[0]}return new V(N,j)}}serialize(){return this.expr.map(c=>c.serialize()).join(" && ")}keys(){const c=[];for(const j of this.expr)c.push(...j.keys());return c}map(c){return new V(this.expr.map(j=>j.map(c)),null)}negate(){if(!this.negated){const c=[];for(const j of this.expr)c.push(j.negate());this.negated=z.create(c,this,!0)}return this.negated}}e.ContextKeyAndExpr=V;class z{static create(c,j,oe){return z._normalizeArr(c,j,oe)}constructor(c,j){this.expr=c,this.negated=j,this.type=g.Or}cmp(c){if(c.type!==this.type)return this.type-c.type;if(this.expr.length<c.expr.length)return-1;if(this.expr.length>c.expr.length)return 1;for(let j=0,oe=this.expr.length;j<oe;j++){const N=x(this.expr[j],c.expr[j]);if(N!==0)return N}return 0}equals(c){if(c.type===this.type){if(this.expr.length!==c.expr.length)return!1;for(let j=0,oe=this.expr.length;j<oe;j++)if(!this.expr[j].equals(c.expr[j]))return!1;return!0}return!1}substituteConstants(){const c=le(this.expr);return c===this.expr?this:z.create(c,this.negated,!1)}evaluate(c){for(let j=0,oe=this.expr.length;j<oe;j++)if(this.expr[j].evaluate(c))return!0;return!1}static _normalizeArr(c,j,oe){let N=[],K=!1;if(c){for(let U=0,k=c.length;U<k;U++){const H=c[U];if(H){if(H.type===g.False){K=!0;continue}if(H.type===g.True)return S.INSTANCE;if(H.type===g.Or){N=N.concat(H.expr);continue}N.push(H)}}if(N.length===0&&K)return v.INSTANCE;N.sort(x)}if(N.length!==0){if(N.length===1)return N[0];for(let U=1;U<N.length;U++)N[U-1].equals(N[U])&&(N.splice(U,1),U--);if(N.length===1)return N[0];if(oe){for(let U=0;U<N.length;U++)for(let k=U+1;k<N.length;k++)if(N[U].negate().equals(N[k]))return S.INSTANCE;if(N.length===1)return N[0]}return new z(N,j)}}serialize(){return this.expr.map(c=>c.serialize()).join(" || ")}keys(){const c=[];for(const j of this.expr)c.push(...j.keys());return c}map(c){return new z(this.expr.map(j=>j.map(c)),null)}negate(){if(!this.negated){const c=[];for(const j of this.expr)c.push(j.negate());for(;c.length>1;){const j=c.shift(),oe=c.shift(),N=[];for(const K of de(j))for(const U of de(oe))N.push(V.create([K,U],null,!1));c.unshift(z.create(N,null,!1))}this.negated=z.create(c,this,!0)}return this.negated}}e.ContextKeyOrExpr=z;class Q extends T{static{this._info=[]}static all(){return Q._info.values()}constructor(c,j,oe){super(c,null),this._defaultValue=j,typeof oe=="object"?Q._info.push({...oe,key:c}):oe!==!0&&Q._info.push({key:c,description:oe,type:j!=null?typeof j:void 0})}bindTo(c){return c.createKey(this.key,this._defaultValue)}getValue(c){return c.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(c){return O.create(this.key,c)}notEqualsTo(c){return E.create(this.key,c)}}e.RawContextKey=Q,e.IContextKeyService=(0,W.createDecorator)("contextKeyService");function ee(te,c){return te<c?-1:te>c?1:0}function ue(te,c,j,oe){return te<j?-1:te>j?1:c<oe?-1:c>oe?1:0}function $(te,c){if(te.type===g.False||c.type===g.True)return!0;if(te.type===g.Or)return c.type===g.Or?ae(te.expr,c.expr):!1;if(c.type===g.Or){for(const j of c.expr)if($(te,j))return!0;return!1}if(te.type===g.And){if(c.type===g.And)return ae(c.expr,te.expr);for(const j of te.expr)if($(j,c))return!0;return!1}return te.equals(c)}function ae(te,c){let j=0,oe=0;for(;j<te.length&&oe<c.length;){const N=te[j].cmp(c[oe]);if(N<0)return!1;N===0&&j++,oe++}return j===te.length}function de(te){return te.type===g.Or?te.expr:[te]}}),define(he[74],fe([0,1,56,5,11,10,6,8,22,3,20,24]),function(ie,e,o,t,L,m,W,P,_,s,b,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ByteSize=e.ETAG_DISABLED=e.FileKind=e.FILES_READONLY_FROM_PERMISSIONS_CONFIG=e.FILES_READONLY_EXCLUDE_CONFIG=e.FILES_READONLY_INCLUDE_CONFIG=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.TooLargeFileOperationError=e.FileOperationError=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FileChangeFilter=e.FilePermission=e.FileType=e.IFileService=void 0,e.isFileOpenForWriteOptions=g,e.isFileSystemWatcher=d,e.hasReadWriteCapability=r,e.hasFileFolderCopyCapability=y,e.hasFileCloneCapability=w,e.hasOpenReadWriteCloseCapability=C,e.hasFileReadStreamCapability=i,e.hasFileAtomicReadCapability=n,e.hasFileAtomicWriteCapability=f,e.hasFileAtomicDeleteCapability=R,e.hasReadonlyCapability=x,e.createFileSystemProviderError=T,e.ensureFileSystemProviderError=O,e.markAsFileSystemProviderError=F,e.toFileSystemProviderErrorCode=D,e.toFileOperationResult=E,e.isParent=Y,e.etag=z,e.whenProviderRegistered=Q,e.getLargeFileConfirmationLimit=ue,e.IFileService=(0,_.createDecorator)("fileService");function g($){return $.create===!0}var l;(function($){$[$.Unknown=0]="Unknown",$[$.File=1]="File",$[$.Directory=2]="Directory",$[$.SymbolicLink=64]="SymbolicLink"})(l||(e.FileType=l={}));var u;(function($){$[$.Readonly=1]="Readonly",$[$.Locked=2]="Locked"})(u||(e.FilePermission=u={}));var a;(function($){$[$.UPDATED=2]="UPDATED",$[$.ADDED=4]="ADDED",$[$.DELETED=8]="DELETED"})(a||(e.FileChangeFilter=a={}));function d($){const ae=$;return!!ae&&typeof ae.onDidChange=="function"}var p;(function($){$[$.None=0]="None",$[$.FileReadWrite=2]="FileReadWrite",$[$.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",$[$.FileReadStream=16]="FileReadStream",$[$.FileFolderCopy=8]="FileFolderCopy",$[$.PathCaseSensitive=1024]="PathCaseSensitive",$[$.Readonly=2048]="Readonly",$[$.Trash=4096]="Trash",$[$.FileWriteUnlock=8192]="FileWriteUnlock",$[$.FileAtomicRead=16384]="FileAtomicRead",$[$.FileAtomicWrite=32768]="FileAtomicWrite",$[$.FileAtomicDelete=65536]="FileAtomicDelete",$[$.FileClone=131072]="FileClone"})(p||(e.FileSystemProviderCapabilities=p={}));function r($){return!!($.capabilities&p.FileReadWrite)}function y($){return!!($.capabilities&p.FileFolderCopy)}function w($){return!!($.capabilities&p.FileClone)}function C($){return!!($.capabilities&p.FileOpenReadWriteClose)}function i($){return!!($.capabilities&p.FileReadStream)}function n($){return r($)?!!($.capabilities&p.FileAtomicRead):!1}function f($){return r($)?!!($.capabilities&p.FileAtomicWrite):!1}function R($){return!!($.capabilities&p.FileAtomicDelete)}function x($){return!!($.capabilities&p.Readonly)}var v;(function($){$.FileExists="EntryExists",$.FileNotFound="EntryNotFound",$.FileNotADirectory="EntryNotADirectory",$.FileIsADirectory="EntryIsADirectory",$.FileExceedsStorageQuota="EntryExceedsStorageQuota",$.FileTooLarge="EntryTooLarge",$.FileWriteLocked="EntryWriteLocked",$.NoPermissions="NoPermissions",$.Unavailable="Unavailable",$.Unknown="Unknown"})(v||(e.FileSystemProviderErrorCode=v={}));class S extends Error{static create(ae,de){const te=new S(ae.toString(),de);return F(te,de),te}constructor(ae,de){super(ae),this.code=de}}e.FileSystemProviderError=S;function T($,ae){return S.create($,ae)}function O($){return $||T((0,P.localize)(1865,null),v.Unknown)}function F($,ae){return $.name=ae?`${ae} (FileSystemError)`:"FileSystemError",$}function D($){if(!$)return v.Unknown;if($ instanceof S)return $.code;const ae=/^(.+) \(FileSystemError\)$/.exec($.name);if(!ae)return v.Unknown;switch(ae[1]){case v.FileExists:return v.FileExists;case v.FileIsADirectory:return v.FileIsADirectory;case v.FileNotADirectory:return v.FileNotADirectory;case v.FileNotFound:return v.FileNotFound;case v.FileTooLarge:return v.FileTooLarge;case v.FileWriteLocked:return v.FileWriteLocked;case v.NoPermissions:return v.NoPermissions;case v.Unavailable:return v.Unavailable}return v.Unknown}function E($){if($ instanceof G)return $.fileOperationResult;switch(D($)){case v.FileNotFound:return le.FILE_NOT_FOUND;case v.FileIsADirectory:return le.FILE_IS_DIRECTORY;case v.FileNotADirectory:return le.FILE_NOT_DIRECTORY;case v.FileWriteLocked:return le.FILE_WRITE_LOCKED;case v.NoPermissions:return le.FILE_PERMISSION_DENIED;case v.FileExists:return le.FILE_MOVE_CONFLICT;case v.FileTooLarge:return le.FILE_TOO_LARGE;default:return le.FILE_OTHER_ERROR}}var M;(function($){$[$.CREATE=0]="CREATE",$[$.DELETE=1]="DELETE",$[$.MOVE=2]="MOVE",$[$.COPY=3]="COPY",$[$.WRITE=4]="WRITE"})(M||(e.FileOperation=M={}));class A{constructor(ae,de,te){this.resource=ae,this.operation=de,this.target=te}isOperation(ae){return this.operation===ae}}e.FileOperationEvent=A;var I;(function($){$[$.UPDATED=0]="UPDATED",$[$.ADDED=1]="ADDED",$[$.DELETED=2]="DELETED"})(I||(e.FileChangeType=I={}));class B{static{this.MIXED_CORRELATION=null}constructor(ae,de){this.ignorePathCasing=de,this.correlationId=void 0,this.added=new h.Lazy(()=>{const te=o.TernarySearchTree.forUris(()=>this.ignorePathCasing);return te.fill(this.rawAdded.map(c=>[c,!0])),te}),this.updated=new h.Lazy(()=>{const te=o.TernarySearchTree.forUris(()=>this.ignorePathCasing);return te.fill(this.rawUpdated.map(c=>[c,!0])),te}),this.deleted=new h.Lazy(()=>{const te=o.TernarySearchTree.forUris(()=>this.ignorePathCasing);return te.fill(this.rawDeleted.map(c=>[c,!0])),te}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const te of ae){switch(te.type){case I.ADDED:this.rawAdded.push(te.resource);break;case I.UPDATED:this.rawUpdated.push(te.resource);break;case I.DELETED:this.rawDeleted.push(te.resource);break}this.correlationId!==B.MIXED_CORRELATION&&(typeof te.cId=="number"?this.correlationId===void 0?this.correlationId=te.cId:this.correlationId!==te.cId&&(this.correlationId=B.MIXED_CORRELATION):this.correlationId!==void 0&&(this.correlationId=B.MIXED_CORRELATION))}}contains(ae,...de){return this.doContains(ae,{includeChildren:!1},...de)}affects(ae,...de){return this.doContains(ae,{includeChildren:!0},...de)}doContains(ae,de,...te){if(!ae)return!1;const c=te.length>0;return!!((!c||te.includes(I.ADDED))&&(this.added.value.get(ae)||de.includeChildren&&this.added.value.findSuperstr(ae))||(!c||te.includes(I.UPDATED))&&(this.updated.value.get(ae)||de.includeChildren&&this.updated.value.findSuperstr(ae))||(!c||te.includes(I.DELETED))&&(this.deleted.value.findSubstr(ae)||de.includeChildren&&this.deleted.value.findSuperstr(ae)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(ae){return this.correlationId===ae}hasCorrelation(){return typeof this.correlationId=="number"}}e.FileChangesEvent=B;function Y($,ae,de){return!$||!ae||$===ae||ae.length>$.length?!1:(ae.charAt(ae.length-1)!==t.sep&&(ae+=t.sep),de?(0,L.startsWithIgnoreCase)($,ae):$.indexOf(ae)===0)}class G extends Error{constructor(ae,de,te){super(ae),this.fileOperationResult=de,this.options=te}}e.FileOperationError=G;class Z extends G{constructor(ae,de,te,c){super(ae,de,c),this.fileOperationResult=de,this.size=te}}e.TooLargeFileOperationError=Z;class se extends G{constructor(ae,de,te){super(ae,le.FILE_NOT_MODIFIED_SINCE,te),this.stat=de}}e.NotModifiedSinceFileOperationError=se;var le;(function($){$[$.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",$[$.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",$[$.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",$[$.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",$[$.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",$[$.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",$[$.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",$[$.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",$[$.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",$[$.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",$[$.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(le||(e.FileOperationResult=le={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude",e.FILES_READONLY_INCLUDE_CONFIG="files.readonlyInclude",e.FILES_READONLY_EXCLUDE_CONFIG="files.readonlyExclude",e.FILES_READONLY_FROM_PERMISSIONS_CONFIG="files.readonlyFromPermissions";var V;(function($){$[$.FILE=0]="FILE",$[$.FOLDER=1]="FOLDER",$[$.ROOT_FOLDER=2]="ROOT_FOLDER"})(V||(e.FileKind=V={})),e.ETAG_DISABLED="";function z($){if(!(typeof $.size!="number"||typeof $.mtime!="number"))return $.mtime.toString(29)+$.size.toString(31)}async function Q($,ae){if(!ae.hasProvider(W.URI.from({scheme:$.scheme})))return new Promise(de=>{const te=ae.onDidChangeFileSystemProviderRegistrations(c=>{c.scheme===$.scheme&&c.added&&(te.dispose(),de())})})}class ee{static{this.KB=1024}static{this.MB=ee.KB*ee.KB}static{this.GB=ee.MB*ee.KB}static{this.TB=ee.GB*ee.KB}static formatSize(ae){return(0,m.isNumber)(ae)||(ae=0),ae<ee.KB?(0,P.localize)(1866,null,ae.toFixed(0)):ae<ee.MB?(0,P.localize)(1867,null,(ae/ee.KB).toFixed(2)):ae<ee.GB?(0,P.localize)(1868,null,(ae/ee.MB).toFixed(2)):ae<ee.TB?(0,P.localize)(1869,null,(ae/ee.GB).toFixed(2)):(0,P.localize)(1870,null,(ae/ee.TB).toFixed(2))}}e.ByteSize=ee;function ue($){const ae=typeof $=="string"||$?.scheme===b.Schemas.vscodeRemote;return typeof $!="string"&&$?.scheme===b.Schemas.file?1024*ee.MB:ae?10*ee.MB:s.isWeb?50*ee.MB:1024*ee.MB}}),define(he[9],fe([0,1,8,59,4,55,2,26,3,25,10,6,39,22]),function(ie,e,o,t,L,m,W,P,_,s,b,h,g,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_LOG_LEVEL=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.MultiplexLogger=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.isLogLevel=a,e.log=p,e.getLogLevel=S,e.LogLevelToString=T,e.LogLevelToLocalizedString=O,e.parseLogLevel=F,o=Pe(o),e.ILogService=(0,l.createDecorator)("logService"),e.ILoggerService=(0,l.createDecorator)("loggerService");function u(){return new Date().toISOString()}function a(D){return(0,b.isNumber)(D)}var d;(function(D){D[D.Off=0]="Off",D[D.Trace=1]="Trace",D[D.Debug=2]="Debug",D[D.Info=3]="Info",D[D.Warning=4]="Warning",D[D.Error=5]="Error"})(d||(e.LogLevel=d={})),e.DEFAULT_LOG_LEVEL=d.Info;function p(D,E,M){switch(E){case d.Trace:D.trace(M);break;case d.Debug:D.debug(M);break;case d.Info:D.info(M);break;case d.Warning:D.warn(M);break;case d.Error:D.error(M);break;case d.Off:break;default:throw new Error(`Invalid log level ${E}`)}}function r(D,E=!1){let M="";for(let A=0;A<D.length;A++){let I=D[A];if(I instanceof Error&&(I=(0,t.toErrorMessage)(I,E)),typeof I=="object")try{I=JSON.stringify(I)}catch{}M+=(A>0?" ":"")+I}return M}class y extends W.Disposable{constructor(){super(...arguments),this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new L.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(E){this.level!==E&&(this.level=E,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}checkLogLevel(E){return this.level!==d.Off&&this.level<=E}}e.AbstractLogger=y;class w extends y{constructor(E){super(),this.logAlways=E}checkLogLevel(E){return this.logAlways||super.checkLogLevel(E)}trace(E,...M){this.checkLogLevel(d.Trace)&&this.log(d.Trace,r([E,...M],!0))}debug(E,...M){this.checkLogLevel(d.Debug)&&this.log(d.Debug,r([E,...M]))}info(E,...M){this.checkLogLevel(d.Info)&&this.log(d.Info,r([E,...M]))}warn(E,...M){this.checkLogLevel(d.Warning)&&this.log(d.Warning,r([E,...M]))}error(E,...M){if(this.checkLogLevel(d.Error))if(E instanceof Error){const A=Array.prototype.slice.call(arguments);A[0]=E.stack,this.log(d.Error,r(A))}else this.log(d.Error,r([E,...M]))}flush(){}}e.AbstractMessageLogger=w;class C extends y{constructor(E=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(E),this.useColors=!_.isWindows}trace(E,...M){this.checkLogLevel(d.Trace)&&(this.useColors?console.log(`\x1B[90m[main ${u()}]\x1B[0m`,E,...M):console.log(`[main ${u()}]`,E,...M))}debug(E,...M){this.checkLogLevel(d.Debug)&&(this.useColors?console.log(`\x1B[90m[main ${u()}]\x1B[0m`,E,...M):console.log(`[main ${u()}]`,E,...M))}info(E,...M){this.checkLogLevel(d.Info)&&(this.useColors?console.log(`\x1B[90m[main ${u()}]\x1B[0m`,E,...M):console.log(`[main ${u()}]`,E,...M))}warn(E,...M){this.checkLogLevel(d.Warning)&&(this.useColors?console.warn(`\x1B[93m[main ${u()}]\x1B[0m`,E,...M):console.warn(`[main ${u()}]`,E,...M))}error(E,...M){this.checkLogLevel(d.Error)&&(this.useColors?console.error(`\x1B[91m[main ${u()}]\x1B[0m`,E,...M):console.error(`[main ${u()}]`,E,...M))}flush(){}}e.ConsoleMainLogger=C;class i extends y{constructor(E=e.DEFAULT_LOG_LEVEL,M=!0){super(),this.useColors=M,this.setLevel(E)}trace(E,...M){this.checkLogLevel(d.Trace)&&(this.useColors?console.log("%cTRACE","color: #888",E,...M):console.log(E,...M))}debug(E,...M){this.checkLogLevel(d.Debug)&&(this.useColors?console.log("%cDEBUG","background: #eee; color: #888",E,...M):console.log(E,...M))}info(E,...M){this.checkLogLevel(d.Info)&&(this.useColors?console.log("%c INFO","color: #33f",E,...M):console.log(E,...M))}warn(E,...M){this.checkLogLevel(d.Warning)&&(this.useColors?console.log("%c WARN","color: #993",E,...M):console.log(E,...M))}error(E,...M){this.checkLogLevel(d.Error)&&(this.useColors?console.log("%c  ERR","color: #f33",E,...M):console.error(E,...M))}flush(){}}e.ConsoleLogger=i;class n extends y{constructor(E,M=e.DEFAULT_LOG_LEVEL){super(),this.adapter=E,this.setLevel(M)}trace(E,...M){this.checkLogLevel(d.Trace)&&this.adapter.log(d.Trace,[this.extractMessage(E),...M])}debug(E,...M){this.checkLogLevel(d.Debug)&&this.adapter.log(d.Debug,[this.extractMessage(E),...M])}info(E,...M){this.checkLogLevel(d.Info)&&this.adapter.log(d.Info,[this.extractMessage(E),...M])}warn(E,...M){this.checkLogLevel(d.Warning)&&this.adapter.log(d.Warning,[this.extractMessage(E),...M])}error(E,...M){this.checkLogLevel(d.Error)&&this.adapter.log(d.Error,[this.extractMessage(E),...M])}extractMessage(E){return typeof E=="string"?E:(0,t.toErrorMessage)(E,this.checkLogLevel(d.Trace))}flush(){}}e.AdapterLogger=n;class f extends y{constructor(E){super(),this.loggers=E,E.length&&this.setLevel(E[0].getLevel())}setLevel(E){for(const M of this.loggers)M.setLevel(E);super.setLevel(E)}trace(E,...M){for(const A of this.loggers)A.trace(E,...M)}debug(E,...M){for(const A of this.loggers)A.debug(E,...M)}info(E,...M){for(const A of this.loggers)A.info(E,...M)}warn(E,...M){for(const A of this.loggers)A.warn(E,...M)}error(E,...M){for(const A of this.loggers)A.error(E,...M)}flush(){for(const E of this.loggers)E.flush()}dispose(){for(const E of this.loggers)E.dispose();super.dispose()}}e.MultiplexLogger=f;class R extends W.Disposable{constructor(E,M,A){if(super(),this.logLevel=E,this.logsHome=M,this._loggers=new P.ResourceMap,this._onDidChangeLoggers=this._register(new L.Emitter),this.onDidChangeLoggers=this._onDidChangeLoggers.event,this._onDidChangeLogLevel=this._register(new L.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event,this._onDidChangeVisibility=this._register(new L.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,A)for(const I of A)this._loggers.set(I.resource,{logger:void 0,info:I})}getLoggerEntry(E){return(0,b.isString)(E)?[...this._loggers.values()].find(M=>M.info.id===E):this._loggers.get(E)}getLogger(E){return this.getLoggerEntry(E)?.logger}createLogger(E,M){const A=this.toResource(E),I=(0,b.isString)(E)?E:M?.id??(0,m.hash)(A.toString()).toString(16);let B=this._loggers.get(A)?.logger;const Y=M?.logLevel==="always"?d.Trace:M?.logLevel;B||(B=this.doCreateLogger(A,Y??this.getLogLevel(A)??this.logLevel,{...M,id:I}));const G={logger:B,info:{resource:A,id:I,logLevel:Y,name:M?.name,hidden:M?.hidden,extensionId:M?.extensionId,when:M?.when}};return this.registerLogger(G.info),this._loggers.set(A,G),B}toResource(E){return(0,b.isString)(E)?(0,s.joinPath)(this.logsHome,`${E}.log`):E}setLogLevel(E,M){if(h.URI.isUri(E)){const A=E,I=M,B=this._loggers.get(A);B&&I!==B.info.logLevel&&(B.info.logLevel=I===this.logLevel?void 0:I,B.logger?.setLevel(I),this._loggers.set(B.info.resource,B),this._onDidChangeLogLevel.fire([A,I]))}else{this.logLevel=E;for(const[A,I]of this._loggers.entries())this._loggers.get(A)?.info.logLevel===void 0&&I.logger?.setLevel(this.logLevel);this._onDidChangeLogLevel.fire(this.logLevel)}}setVisibility(E,M){const A=this.getLoggerEntry(E);A&&M!==!A.info.hidden&&(A.info.hidden=!M,this._loggers.set(A.info.resource,A),this._onDidChangeVisibility.fire([A.info.resource,M]))}getLogLevel(E){let M;return E&&(M=this._loggers.get(E)?.info.logLevel),M??this.logLevel}registerLogger(E){const M=this._loggers.get(E.resource);M?M.info.hidden!==E.hidden&&this.setVisibility(E.resource,!E.hidden):(this._loggers.set(E.resource,{info:E,logger:void 0}),this._onDidChangeLoggers.fire({added:[E],removed:[]}))}deregisterLogger(E){const M=this._loggers.get(E);M&&(M.logger&&M.logger.dispose(),this._loggers.delete(E),this._onDidChangeLoggers.fire({added:[],removed:[M.info]}))}*getRegisteredLoggers(){for(const E of this._loggers.values())yield E.info}getRegisteredLogger(E){return this._loggers.get(E)?.info}dispose(){this._loggers.forEach(E=>E.logger?.dispose()),this._loggers.clear(),super.dispose()}}e.AbstractLoggerService=R;class x{constructor(){this.onDidChangeLogLevel=new L.Emitter().event}setLevel(E){}getLevel(){return d.Info}trace(E,...M){}debug(E,...M){}info(E,...M){}warn(E,...M){}error(E,...M){}critical(E,...M){}dispose(){}flush(){}}e.NullLogger=x;class v extends x{}e.NullLogService=v;function S(D){if(D.verbose)return d.Trace;if(typeof D.logLevel=="string"){const E=F(D.logLevel.toLowerCase());if(E!==void 0)return E}return e.DEFAULT_LOG_LEVEL}function T(D){switch(D){case d.Trace:return"trace";case d.Debug:return"debug";case d.Info:return"info";case d.Warning:return"warn";case d.Error:return"error";case d.Off:return"off"}}function O(D){switch(D){case d.Trace:return{original:"Trace",value:o.localize(1959,null)};case d.Debug:return{original:"Debug",value:o.localize(1960,null)};case d.Info:return{original:"Info",value:o.localize(1961,null)};case d.Warning:return{original:"Warning",value:o.localize(1962,null)};case d.Error:return{original:"Error",value:o.localize(1963,null)};case d.Off:return{original:"Off",value:o.localize(1964,null)}}}function F(D){switch(D){case"trace":return d.Trace;case"debug":return d.Debug;case"info":return d.Info;case"warn":return d.Warning;case"error":return d.Error;case"critical":return d.Error;case"off":return d.Off}}e.CONTEXT_LOG_LEVEL=new g.RawContextKey("logLevel",T(d.Info))}),define(he[75],fe([0,1,6,4,9,2]),function(ie,e,o,t,L,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteLoggerChannelClient=e.LoggerChannel=e.LoggerChannelClient=void 0;class W extends L.AbstractLoggerService{constructor(h,g,l,u,a){super(g,l,u),this.windowId=h,this.channel=a,this._register(a.listen("onDidChangeLogLevel",h)(d=>{(0,L.isLogLevel)(d)?super.setLogLevel(d):super.setLogLevel(o.URI.revive(d[0]),d[1])})),this._register(a.listen("onDidChangeVisibility",h)(([d,p])=>super.setVisibility(o.URI.revive(d),p))),this._register(a.listen("onDidChangeLoggers",h)(({added:d,removed:p})=>{for(const r of d)super.registerLogger({...r,resource:o.URI.revive(r.resource)});for(const r of p)super.deregisterLogger(r.resource)}))}createConsoleMainLogger(){return new L.AdapterLogger({log:(h,g)=>{this.channel.call("consoleLog",[h,g])}})}registerLogger(h){super.registerLogger(h),this.channel.call("registerLogger",[h,this.windowId])}deregisterLogger(h){super.deregisterLogger(h),this.channel.call("deregisterLogger",[h,this.windowId])}setLogLevel(h,g){super.setLogLevel(h,g),this.channel.call("setLogLevel",[h,g])}setVisibility(h,g){super.setVisibility(h,g),this.channel.call("setVisibility",[this.toResource(h),g])}doCreateLogger(h,g,l){return new P(this.channel,h,g,l,this.windowId)}static setLogLevel(h,g,l){return h.call("setLogLevel",[g,l])}}e.LoggerChannelClient=W;class P extends L.AbstractMessageLogger{constructor(h,g,l,u,a){super(u?.logLevel==="always"),this.channel=h,this.file=g,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(l),this.channel.call("createLogger",[g,u,a]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(h,g){const l=[[h,g]];this.isLoggerCreated?this.doLog(l):this.buffer.push(...l)}doLog(h){this.channel.call("log",[this.file,h])}}class _{constructor(h,g){this.loggerService=h,this.getUriTransformer=g}listen(h,g){const l=this.getUriTransformer(h);switch(g){case"onDidChangeLoggers":return t.Event.map(this.loggerService.onDidChangeLoggers,u=>({added:[...u.added].map(a=>this.transformLogger(a,l)),removed:[...u.removed].map(a=>this.transformLogger(a,l))}));case"onDidChangeVisibility":return t.Event.map(this.loggerService.onDidChangeVisibility,u=>[l.transformOutgoingURI(u[0]),u[1]]);case"onDidChangeLogLevel":return t.Event.map(this.loggerService.onDidChangeLogLevel,u=>(0,L.isLogLevel)(u)?u:[l.transformOutgoingURI(u[0]),u[1]])}throw new Error(`Event not found: ${g}`)}async call(h,g,l){const u=this.getUriTransformer(h);switch(g){case"setLogLevel":return(0,L.isLogLevel)(l[0])?this.loggerService.setLogLevel(l[0]):this.loggerService.setLogLevel(o.URI.revive(u.transformIncoming(l[0][0])),l[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.loggerService.getRegisteredLoggers()].map(a=>this.transformLogger(a,u)))}throw new Error(`Call not found: ${g}`)}transformLogger(h,g){return{...h,resource:g.transformOutgoingURI(h.resource)}}}e.LoggerChannel=_;class s extends m.Disposable{constructor(h,g){super(),g.call("setLogLevel",[h.getLogLevel()]),this._register(h.onDidChangeLogLevel(l=>g.call("setLogLevel",[l]))),g.call("getRegisteredLoggers").then(l=>{for(const u of l)h.registerLogger({...u,resource:o.URI.revive(u.resource)})}),this._register(g.listen("onDidChangeVisibility")(([l,u])=>h.setVisibility(o.URI.revive(l),u))),this._register(g.listen("onDidChangeLoggers")(({added:l,removed:u})=>{for(const a of l)h.registerLogger({...a,resource:o.URI.revive(a.resource)});for(const a of u)h.deregisterLogger(a.resource)}))}}e.RemoteLoggerChannelClient=s}),define(he[76],fe([0,1,2,9]),function(ie,e,o,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogService=void 0;class L extends o.Disposable{constructor(W,P=[]){super(),this.logger=new t.MultiplexLogger([W,...P]),this._register(W.onDidChangeLogLevel(_=>this.setLevel(_)))}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(W){this.logger.setLevel(W)}getLevel(){return this.logger.getLevel()}trace(W,...P){this.logger.trace(W,...P)}debug(W,...P){this.logger.debug(W,...P)}info(W,...P){this.logger.info(W,...P)}warn(W,...P){this.logger.warn(W,...P)}error(W,...P){this.logger.error(W,...P)}flush(){this.logger.flush()}}e.LogService=L}),define(he[77],fe([0,1,74,9]),function(ie,e,o,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;var L;(function(s){s[s.Trace=0]="Trace",s[s.Debug=1]="Debug",s[s.Info=2]="Info",s[s.Warning=3]="Warning",s[s.Error=4]="Error",s[s.Critical=5]="Critical",s[s.Off=6]="Off"})(L||(L={}));async function m(s,b,h,g,l){try{const u=await new Promise((d,p)=>{ie(["@vscode/spdlog"],d,p)}).then(Pe);u.setFlushOn(L.Trace);const a=await u.createAsyncRotatingLogger(s,b,h,g);return l?a.clearFormatters():a.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),a}catch(u){console.error(u)}return null}function W(s,b,h){switch(b){case t.LogLevel.Trace:s.trace(h);break;case t.LogLevel.Debug:s.debug(h);break;case t.LogLevel.Info:s.info(h);break;case t.LogLevel.Warning:s.warn(h);break;case t.LogLevel.Error:s.error(h);break;case t.LogLevel.Off:break;default:throw new Error(`Invalid log level ${b}`)}}function P(s,b){switch(b){case t.LogLevel.Trace:s.setLevel(L.Trace);break;case t.LogLevel.Debug:s.setLevel(L.Debug);break;case t.LogLevel.Info:s.setLevel(L.Info);break;case t.LogLevel.Warning:s.setLevel(L.Warning);break;case t.LogLevel.Error:s.setLevel(L.Error);break;case t.LogLevel.Off:s.setLevel(L.Off);break;default:throw new Error(`Invalid log level ${b}`)}}class _ extends t.AbstractMessageLogger{constructor(b,h,g,l,u){super(),this.buffer=[],this.setLevel(u),this._loggerCreationPromise=this._createSpdLogLogger(b,h,g,l),this._register(this.onDidChangeLogLevel(a=>{this._logger&&P(this._logger,a)}))}async _createSpdLogLogger(b,h,g,l){const u=g?6:1,a=30/u*o.ByteSize.MB,d=await m(b,h,a,u,l);if(d){this._logger=d,P(this._logger,this.getLevel());for(const{level:p,message:r}of this.buffer)W(this._logger,p,r);this.buffer=[]}}log(b,h){this._logger?W(this._logger,b,h):this.getLevel()<=b&&this.buffer.push({level:b,message:h})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger()),super.dispose()}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=_}),define(he[78],fe([0,1,57,9,77]),function(ie,e,o,t,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerService=void 0;class m extends t.AbstractLoggerService{doCreateLogger(P,_,s){return new L.SpdLogLogger((0,o.generateUuid)(),P.fsPath,!s?.donotRotate,!!s?.donotUseFormatters,_)}}e.LoggerService=m}),define(he[79],fe([0,1,15]),function(ie,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let t;const L=globalThis.vscode;if(typeof L<"u"&&typeof L.context<"u"){const m=L.context.configuration();if(m)t=m.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){t=globalThis._VSCODE_PRODUCT_JSON;const{serviceUrl:m,searchUrl:W,itemUrl:P,controlUrl:_}=t.extensionsGallery||{};Object.assign(t,{extensionsGallery:{serviceUrl:o.env.VSCODE_GALLERY_SERVICE_URL||m,searchUrl:o.env.VSCODE_GALLERY_SEARCH_URL||W,itemUrl:o.env.VSCODE_GALLERY_ITEM_URL||P,controlUrl:o.env.VSCODE_GALLERY_CONTROL_URL||_}});try{const s=(...h)=>h.reduce((g,l)=>(Object.keys(l).forEach(u=>{Array.isArray(g[u])&&Array.isArray(l[u])?g[u]=l[u]:typeof g[u]=="object"&&typeof l[u]=="object"?g[u]=s(g[u],l[u]):g[u]=l[u]}),g),{}),b=globalThis._VSCODE_USER_PRODUCT_JSON||{};t=s(t,b)}catch{}if(o.env.VSCODE_DEV&&Object.assign(t,{nameShort:`${t.nameShort} Dev`,nameLong:`${t.nameLong} Dev`,dataFolderName:`${t.dataFolderName}-dev`,serverDataFolderName:t.serverDataFolderName?`${t.serverDataFolderName}-dev`:void 0}),!t.version){const s=globalThis._VSCODE_PACKAGE_JSON;Object.assign(t,{version:s.version,release:s.release})}}else t={},Object.keys(t).length===0&&Object.assign(t,{version:"1.91.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=t}),define(he[80],fe([0,1,22]),function(ie,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,o.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(he[81],fe([0,1,46,10]),function(ie,e,o,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0,o=Pe(o),t=Pe(t);class L{constructor(){this.data=new Map}add(W,P){o.ok(t.isString(W)),o.ok(t.isObject(P)),o.ok(!this.data.has(W),"There is already an extension with this id"),this.data.set(W,P)}knows(W){return this.data.has(W)}as(W){return this.data.get(W)||null}}e.Registry=new L}),define(he[23],fe([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CommandInvalidationReason=e.TerminalCapability=void 0;var o;(function(L){L[L.CwdDetection=0]="CwdDetection",L[L.NaiveCwdDetection=1]="NaiveCwdDetection",L[L.CommandDetection=2]="CommandDetection",L[L.PartialCommandDetection=3]="PartialCommandDetection",L[L.BufferMarkDetection=4]="BufferMarkDetection"})(o||(e.TerminalCapability=o={}));var t;(function(L){L.Windows="windows",L.NoProblemsReported="noProblemsReported"})(t||(e.CommandInvalidationReason=t={}))}),define(he[82],fe([0,1,4,2,23]),function(ie,e,o,t,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BufferMarkCapability=void 0;class m extends t.Disposable{constructor(P){super(),this._terminal=P,this.type=L.TerminalCapability.BufferMarkDetection,this._idToMarkerMap=new Map,this._anonymousMarkers=new Map,this._onMarkAdded=this._register(new o.Emitter),this.onMarkAdded=this._onMarkAdded.event}*markers(){for(const P of this._idToMarkerMap.values())yield P;for(const P of this._anonymousMarkers.values())yield P}addMark(P){const _=P?.marker||this._terminal.registerMarker(),s=P?.id;_&&(s?(this._idToMarkerMap.set(s,_),_.onDispose(()=>this._idToMarkerMap.delete(s))):(this._anonymousMarkers.set(_.id,_),_.onDispose(()=>this._anonymousMarkers.delete(_.id))),this._onMarkAdded.fire({marker:_,id:s,hidden:P?.hidden,hoverMessage:P?.hoverMessage}))}getMark(P){return this._idToMarkerMap.get(P)}}e.BufferMarkCapability=m});var We=this&&this.__param||function(ie,e){return function(o,t){e(o,t,ie)}};define(he[83],fe([0,1,4,2,9,14]),function(ie,e,o,t,L,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PromptInputModel=void 0;var W;(function(_){_[_.Unknown=0]="Unknown",_[_.Input=1]="Input",_[_.Execute=2]="Execute"})(W||(W={}));let P=class extends t.Disposable{get value(){return this._value}get prefix(){return this._value.substring(0,this._cursorIndex)}get suffix(){return this._value.substring(this._cursorIndex,this._ghostTextIndex===-1?void 0:this._ghostTextIndex)}get cursorIndex(){return this._cursorIndex}get ghostTextIndex(){return this._ghostTextIndex}constructor(s,b,h,g){super(),this._xterm=s,this._logService=g,this._state=W.Unknown,this._commandStartX=0,this._lastUserInput="",this._value="",this._cursorIndex=0,this._ghostTextIndex=-1,this._onDidStartInput=this._register(new o.Emitter),this.onDidStartInput=this._onDidStartInput.event,this._onDidChangeInput=this._register(new o.Emitter),this.onDidChangeInput=this._onDidChangeInput.event,this._onDidFinishInput=this._register(new o.Emitter),this.onDidFinishInput=this._onDidFinishInput.event,this._onDidInterrupt=this._register(new o.Emitter),this.onDidInterrupt=this._onDidInterrupt.event,this._register(o.Event.any(this._xterm.onCursorMove,this._xterm.onData,this._xterm.onWriteParsed)(()=>this._sync())),this._register(this._xterm.onData(l=>this._handleUserInput(l))),this._register(b(l=>this._handleCommandStart(l))),this._register(h(()=>this._handleCommandExecuted())),this._register(this.onDidStartInput(()=>this._logCombinedStringIfTrace("PromptInputModel#onDidStartInput"))),this._register(this.onDidChangeInput(()=>this._logCombinedStringIfTrace("PromptInputModel#onDidChangeInput"))),this._register(this.onDidFinishInput(()=>this._logCombinedStringIfTrace("PromptInputModel#onDidFinishInput"))),this._register(this.onDidInterrupt(()=>this._logCombinedStringIfTrace("PromptInputModel#onDidInterrupt")))}_logCombinedStringIfTrace(s){this._logService.getLevel()===L.LogLevel.Trace&&this._logService.trace(s,this.getCombinedString())}setContinuationPrompt(s){this._continuationPrompt=s,this._sync()}setLastPromptLine(s){this._lastPromptLine=s,this._sync()}setConfidentCommandLine(s){this._value!==s&&(this._value=s,this._cursorIndex=-1,this._ghostTextIndex=-1,this._onDidChangeInput.fire(this._createStateObject()))}getCombinedString(){const s=this._value.replaceAll(`
`,"\u23CE");if(this._cursorIndex===-1)return s;let b=`${s.substring(0,this.cursorIndex)}|`;return this.ghostTextIndex!==-1?(b+=`${s.substring(this.cursorIndex,this.ghostTextIndex)}[`,b+=`${s.substring(this.ghostTextIndex)}]`):b+=s.substring(this.cursorIndex),b}serialize(){return{modelState:this._createStateObject(),commandStartX:this._commandStartX,lastPromptLine:this._lastPromptLine,continuationPrompt:this._continuationPrompt,lastUserInput:this._lastUserInput}}deserialize(s){this._value=s.modelState.value,this._cursorIndex=s.modelState.cursorIndex,this._ghostTextIndex=s.modelState.ghostTextIndex,this._commandStartX=s.commandStartX,this._lastPromptLine=s.lastPromptLine,this._continuationPrompt=s.continuationPrompt,this._lastUserInput=s.lastUserInput}_handleCommandStart(s){this._state!==W.Input&&(this._state=W.Input,this._commandStartMarker=s.marker,this._commandStartX=this._xterm.buffer.active.cursorX,this._value="",this._cursorIndex=0,this._onDidStartInput.fire(this._createStateObject()),this._onDidChangeInput.fire(this._createStateObject()),this._lastPromptLine&&this._commandStartX!==this._lastPromptLine.length&&this._xterm.buffer.active.getLine(this._commandStartMarker.line)?.translateToString(!0).startsWith(this._lastPromptLine)&&(this._commandStartX=this._lastPromptLine.length,this._sync()))}_handleCommandExecuted(){if(this._state===W.Execute)return;this._cursorIndex=-1,this._ghostTextIndex!==-1&&(this._value=this._value.substring(0,this._ghostTextIndex),this._ghostTextIndex=-1);const s=this._createStateObject();this._lastUserInput===""&&(this._lastUserInput="",this._onDidInterrupt.fire(s)),this._state=W.Execute,this._onDidFinishInput.fire(s),this._onDidChangeInput.fire(s)}_sync(){try{this._doSync()}catch(s){this._logService.error("Error while syncing prompt input model",s)}}_doSync(){if(this._state!==W.Input)return;const s=this._commandStartMarker?.line;if(s===void 0)return;const b=this._xterm.buffer.active;let h=b.getLine(s);const g=h?.translateToString(!0,this._commandStartX);if(!h||g===void 0){this._logService.trace("PromptInputModel#_sync: no line");return}const l=b.baseY+b.cursorY;let u=g,a=-1,d;l===s?d=this._getRelativeCursorIndex(this._commandStartX,b,h):d=g.trimEnd().length,l===s&&b.cursorX>1&&(a=this._scanForGhostText(b,h,d));for(let p=s+1;p<=l;p++){h=b.getLine(p);const r=h?.translateToString(!0);if(r&&h)if(h.isWrapped){u+=r;const y=this._getRelativeCursorIndex(0,b,h);l===p?d+=y:d+=r.length}else if(this._continuationPrompt===void 0||this._lineContainsContinuationPrompt(r)){const y=this._trimContinuationPrompt(r);if(u+=`
${y}`,l===p){const w=this._getContinuationPromptCellWidth(h,r),C=this._getRelativeCursorIndex(w,b,h);d+=C+1}else d+=y.length+1}else break}for(let p=l+1;p<b.baseY+this._xterm.rows;p++){h=b.getLine(p);const r=h?.translateToString(!0);if(r&&h)if(this._continuationPrompt===void 0||this._lineContainsContinuationPrompt(r))u+=`
${this._trimContinuationPrompt(r)}`;else break;else break}this._logService.getLevel()===L.LogLevel.Trace&&this._logService.trace(`PromptInputModel#_sync: ${this.getCombinedString()}`);{let p=this._value.length-this._value.trimEnd().length;this._lastUserInput==="\x7F"&&(this._lastUserInput="",d===this._cursorIndex-1&&(this._value.trimEnd().length>u.trimEnd().length&&u.trimEnd().length<=d?p=Math.max(this._value.length-1-u.trimEnd().length,0):p=Math.max(p-1,0))),this._lastUserInput==="\x1B[3~"&&(this._lastUserInput="",d===this._cursorIndex&&(p=Math.max(p-1,0)));const r=u.split(`
`),y=r.length>1,w=u.trimEnd();if(!y){w.length<u.length&&(this._lastUserInput===" "&&(this._lastUserInput="",d>w.length&&d>this._cursorIndex&&p++),p=Math.max(d-w.length,p,0));const C=d===0?"":u[d-1];p>0&&d===this._cursorIndex+1&&this._lastUserInput!==""&&C!==" "&&(p=this._value.length-this._cursorIndex)}if(y){r[r.length-1]=r.at(-1)?.trimEnd()??"";const C=(r.length-1)*(this._continuationPrompt?.length??0);p=Math.max(0,d-u.length-C)}u=r.map(C=>C.trimEnd()).join(`
`)+" ".repeat(p)}(this._value!==u||this._cursorIndex!==d||this._ghostTextIndex!==a)&&(this._value=u,this._cursorIndex=d,this._ghostTextIndex=a,this._onDidChangeInput.fire(this._createStateObject()))}_handleUserInput(s){this._lastUserInput=s}_scanForGhostText(s,b,h){let g=-1,l=!1,u=s.cursorX;for(;u>0;){const a=b.getCell(--u);if(!a)break;if(a.getChars().trim().length>0){l=!this._isCellStyledLikeGhostText(a);break}}if(l){let a=0,d=s.cursorX;for(;d<b.length;){const p=b.getCell(d++);if(!p||p.getCode()===0)break;if(this._isCellStyledLikeGhostText(p)){g=h+a;break}a+=p.getChars().length}}return g}_trimContinuationPrompt(s){return this._lineContainsContinuationPrompt(s)&&(s=s.substring(this._continuationPrompt.length)),s}_lineContainsContinuationPrompt(s){return!!(this._continuationPrompt&&s.startsWith(this._continuationPrompt))}_getContinuationPromptCellWidth(s,b){if(!this._continuationPrompt||!b.startsWith(this._continuationPrompt))return 0;let h="",g=0;for(;h!==this._continuationPrompt;)h+=s.getCell(g++).getChars();return g}_getRelativeCursorIndex(s,b,h){return h?.translateToString(!0,s,b.cursorX).length??0}_isCellStyledLikeGhostText(s){return!!(s.isItalic()||s.isDim())}_createStateObject(){return Object.freeze({value:this._value,prefix:this.prefix,suffix:this.suffix,cursorIndex:this._cursorIndex,ghostTextIndex:this._ghostTextIndex})}};e.PromptInputModel=P,ge([(0,m.throttle)(0)],P.prototype,"_sync",null),e.PromptInputModel=P=ge([We(3,L.ILogService)],P)}),define(he[84],fe([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PartialTerminalCommand=e.TerminalCommand=void 0;class o{get command(){return this._properties.command}get commandLineConfidence(){return this._properties.commandLineConfidence}get isTrusted(){return this._properties.isTrusted}get timestamp(){return this._properties.timestamp}get duration(){return this._properties.duration}get promptStartMarker(){return this._properties.promptStartMarker}get marker(){return this._properties.marker}get endMarker(){return this._properties.endMarker}set endMarker(b){this._properties.endMarker=b}get executedMarker(){return this._properties.executedMarker}get aliases(){return this._properties.aliases}get wasReplayed(){return this._properties.wasReplayed}get cwd(){return this._properties.cwd}get exitCode(){return this._properties.exitCode}get commandStartLineContent(){return this._properties.commandStartLineContent}get markProperties(){return this._properties.markProperties}get executedX(){return this._properties.executedX}get startX(){return this._properties.startX}constructor(b,h){this._xterm=b,this._properties=h}static deserialize(b,h,g){const l=b.buffer.normal,u=h.startLine!==void 0?b.registerMarker(h.startLine-(l.baseY+l.cursorY)):void 0;if(!u)return;const a=h.promptStartLine!==void 0?b.registerMarker(h.promptStartLine-(l.baseY+l.cursorY)):void 0,d=h.endLine!==void 0?b.registerMarker(h.endLine-(l.baseY+l.cursorY)):void 0,p=h.executedLine!==void 0?b.registerMarker(h.executedLine-(l.baseY+l.cursorY)):void 0;return new o(b,{command:g?"":h.command,commandLineConfidence:h.commandLineConfidence??"low",isTrusted:h.isTrusted,promptStartMarker:a,marker:u,startX:h.startX,endMarker:d,executedMarker:p,executedX:h.executedX,timestamp:h.timestamp,duration:h.duration,cwd:h.cwd,commandStartLineContent:h.commandStartLineContent,exitCode:h.exitCode,markProperties:h.markProperties,aliases:void 0,wasReplayed:!0})}serialize(b){return{promptStartLine:this.promptStartMarker?.line,startLine:this.marker?.line,startX:void 0,endLine:this.endMarker?.line,executedLine:this.executedMarker?.line,executedX:this.executedX,command:b?"":this.command,commandLineConfidence:b?"low":this.commandLineConfidence,isTrusted:this.isTrusted,cwd:this.cwd,exitCode:this.exitCode,commandStartLineContent:this.commandStartLineContent,timestamp:this.timestamp,duration:this.duration,markProperties:this.markProperties}}extractCommandLine(){return L(this._xterm.buffer.active,this._xterm.cols,this.marker,this.startX,this.executedMarker,this.executedX)}getOutput(){if(!this.executedMarker||!this.endMarker)return;const b=this.executedMarker.line,h=this.endMarker.line;if(b===h)return;let g="",l;for(let u=b;u<h;u++)l=this._xterm.buffer.active.getLine(u),l&&(g+=l.translateToString(!l.isWrapped)+(l.isWrapped?"":`
`));return g===""?void 0:g}getOutputMatch(b){if(!this.executedMarker||!this.endMarker)return;const h=this.endMarker.line;if(h===-1)return;const g=this._xterm.buffer.active,l=Math.max(this.executedMarker.line,0),u=b.lineMatcher,a=typeof u=="string"?1:b.length||W(u),d=[];let p;if(b.anchor==="bottom")for(let r=h-(b.offset||0);r>=l;r--){let y=r;const w=r;for(;y>=l&&g.getLine(y)?.isWrapped;)y--;if(r=y,d.unshift(m(g,y,w,this._xterm.cols)),p||(p=d[0].match(u)),d.length>=a)break}else for(let r=l+(b.offset||0);r<h;r++){const y=r;let w=r;for(;w+1<h&&g.getLine(w+1)?.isWrapped;)w++;if(r=w,d.push(m(g,y,w,this._xterm.cols)),p||(p=d[d.length-1].match(u)),d.length>=a)break}return p?{regexMatch:p,outputLines:d}:void 0}hasOutput(){return!this.executedMarker?.isDisposed&&!this.endMarker?.isDisposed&&!!(this.executedMarker&&this.endMarker&&this.executedMarker.line<this.endMarker.line)}getPromptRowCount(){return P(this,this._xterm.buffer.active)}getCommandRowCount(){return _(this)}}e.TerminalCommand=o;class t{constructor(b){this._xterm=b}serialize(b){if(this.commandStartMarker)return{promptStartLine:this.promptStartMarker?.line,startLine:this.commandStartMarker.line,startX:this.commandStartX,endLine:void 0,executedLine:void 0,executedX:void 0,command:"",commandLineConfidence:"low",isTrusted:!0,cwd:b,exitCode:void 0,commandStartLineContent:void 0,timestamp:0,duration:0,markProperties:void 0}}promoteToFullCommand(b,h,g,l){if(h===void 0&&this.command===void 0&&(this.command=""),this.command!==void 0&&!this.command.startsWith("\\")||g)return new o(this._xterm,{command:g?"":this.command||"",commandLineConfidence:g?"low":this.commandLineConfidence||"low",isTrusted:!!this.isTrusted,promptStartMarker:this.promptStartMarker,marker:this.commandStartMarker,startX:this.commandStartX,endMarker:this.commandFinishedMarker,executedMarker:this.commandExecutedMarker,executedX:this.commandExecutedX,timestamp:Date.now(),duration:this.commandDuration||0,cwd:b,exitCode:h,commandStartLineContent:this.commandStartLineContent,markProperties:l})}markExecutedTime(){this.commandExecutedTimestamp===void 0&&(this.commandExecutedTimestamp=Date.now())}markFinishedTime(){this.commandDuration===void 0&&this.commandExecutedTimestamp!==void 0&&(this.commandDuration=Date.now()-this.commandExecutedTimestamp)}extractCommandLine(){return L(this._xterm.buffer.active,this._xterm.cols,this.commandStartMarker,this.commandStartX,this.commandExecutedMarker,this.commandExecutedX)}getPromptRowCount(){return P(this,this._xterm.buffer.active)}getCommandRowCount(){return _(this)}}e.PartialTerminalCommand=t;function L(s,b,h,g,l,u){if(!h||!l||g===void 0||u===void 0)return"";let a="";for(let d=h.line;d<=l.line;d++){const p=s.getLine(d);p&&(a+=p.translateToString(!0,d===h.line?g:0,d===l.line?u:b))}return a}function m(s,b,h,g){const l=Math.max(2048/g*2);h=Math.min(h,b+l);let u="";for(let a=b;a<=h;a++){const d=s.getLine(a);d&&(u+=d.translateToString(!0,0,g))}return u}function W(s){if(!s.multiline)return 1;const b=s.source;let h=1,g=b.indexOf("\\n");for(;g!==-1;)h++,g=b.indexOf("\\n",g+1);return h}function P(s,b){const h="hasOutput"in s?s.marker:s.commandStartMarker;if(!h||!s.promptStartMarker)return 1;let g=1,l=s.promptStartMarker.line;for(;l<h.line&&(b.getLine(l)?.translateToString(!0)??"").length===0;)l++;return g=h.line-l+1,g}function _(s){const b="hasOutput"in s?s.marker:s.commandStartMarker,h="hasOutput"in s?s.executedMarker:s.commandExecutedMarker;if(!b||!h)return 1;let l=Math.max(h.line,b.line)-b.line+1;return("hasOutput"in s?s.executedX:s.commandExecutedX)===0&&l--,l}}),define(he[85],fe([0,1,12,14,4,2,9,23,84,83]),function(ie,e,o,t,L,m,W,P,_,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CommandDetectionCapability=void 0,e.getLinesForCommand=u;let b=class extends m.Disposable{get promptInputModel(){return this._promptInputModel}get commands(){return this._commands}get executingCommand(){return this._currentCommand.command}get executingCommandObject(){if(this._currentCommand.commandStartMarker)return{marker:this._currentCommand.commandStartMarker}}get currentCommand(){return this._currentCommand}get cwd(){return this._cwd}get promptTerminator(){return this._promptTerminator}constructor(r,y){super(),this._terminal=r,this._logService=y,this.type=P.TerminalCapability.CommandDetection,this._commands=[],this._currentCommand=new _.PartialTerminalCommand(this._terminal),this._commandMarkers=[],this.__isCommandStorageDisabled=!1,this._onCommandStarted=this._register(new L.Emitter),this.onCommandStarted=this._onCommandStarted.event,this._onBeforeCommandFinished=this._register(new L.Emitter),this.onBeforeCommandFinished=this._onBeforeCommandFinished.event,this._onCommandFinished=this._register(new L.Emitter),this.onCommandFinished=this._onCommandFinished.event,this._onCommandExecuted=this._register(new L.Emitter),this.onCommandExecuted=this._onCommandExecuted.event,this._onCommandInvalidated=this._register(new L.Emitter),this.onCommandInvalidated=this._onCommandInvalidated.event,this._onCurrentCommandInvalidated=this._register(new L.Emitter),this.onCurrentCommandInvalidated=this._onCurrentCommandInvalidated.event,this._promptInputModel=this._register(new s.PromptInputModel(this._terminal,this.onCommandStarted,this.onCommandExecuted,this._logService)),this._register(this.onCommandExecuted(C=>{if(C.commandLineConfidence!=="high"){const i=C;C.command=i.extractCommandLine(),C.commandLineConfidence="low","getOutput"in i?i.promptStartMarker&&i.marker&&i.executedMarker&&C.command.indexOf(`
`)===-1&&i.startX!==void 0&&i.startX>0&&(C.commandLineConfidence="medium"):i.promptStartMarker&&i.commandStartMarker&&i.commandExecutedMarker&&C.command.indexOf(`
`)===-1&&i.commandStartX!==void 0&&i.commandStartX>0&&(C.commandLineConfidence="medium")}}));const w=this;this._ptyHeuristicsHooks=new class{get onCurrentCommandInvalidatedEmitter(){return w._onCurrentCommandInvalidated}get onCommandStartedEmitter(){return w._onCommandStarted}get onCommandExecutedEmitter(){return w._onCommandExecuted}get dimensions(){return w._dimensions}get isCommandStorageDisabled(){return w.__isCommandStorageDisabled}get commandMarkers(){return w._commandMarkers}set commandMarkers(C){w._commandMarkers=C}get clearCommandsInViewport(){return w._clearCommandsInViewport.bind(w)}commitCommandFinished(){w._commitCommandFinished?.flush(),w._commitCommandFinished=void 0}},this._ptyHeuristics=this._register(new m.MandatoryMutableDisposable(new h(this._terminal,this,this._ptyHeuristicsHooks,this._logService))),this._dimensions={cols:this._terminal.cols,rows:this._terminal.rows},this._register(this._terminal.onResize(C=>this._handleResize(C))),this._register(this._terminal.onCursorMove(()=>this._handleCursorMove()))}_handleResize(r){this._ptyHeuristics.value.preHandleResize?.(r),this._dimensions.cols=r.cols,this._dimensions.rows=r.rows}_handleCursorMove(){this._store.isDisposed||this._terminal.buffer.active===this._terminal.buffer.normal&&this._currentCommand.commandStartMarker&&this._terminal.buffer.active.baseY+this._terminal.buffer.active.cursorY<this._currentCommand.commandStartMarker.line&&(this._clearCommandsInViewport(),this._currentCommand.isInvalid=!0,this._onCurrentCommandInvalidated.fire({reason:P.CommandInvalidationReason.Windows}))}_clearCommandsInViewport(){let r=0;for(let y=this._commands.length-1;y>=0;y--){const w=this._commands[y].marker?.line;if(w&&w<this._terminal.buffer.active.baseY)break;r++}r>0&&this._onCommandInvalidated.fire(this._commands.splice(this._commands.length-r,r))}setContinuationPrompt(r){this._promptInputModel.setContinuationPrompt(r)}setPromptTerminator(r,y){this._logService.debug("CommandDetectionCapability#setPromptTerminator",r),this._promptTerminator=r,this._promptInputModel.setLastPromptLine(y)}setCwd(r){this._cwd=r}setIsWindowsPty(r){if(r&&!(this._ptyHeuristics.value instanceof l)){const y=this;this._ptyHeuristics.value=new l(this._terminal,this,new class{get onCurrentCommandInvalidatedEmitter(){return y._onCurrentCommandInvalidated}get onCommandStartedEmitter(){return y._onCommandStarted}get onCommandExecutedEmitter(){return y._onCommandExecuted}get dimensions(){return y._dimensions}get isCommandStorageDisabled(){return y.__isCommandStorageDisabled}get commandMarkers(){return y._commandMarkers}set commandMarkers(w){y._commandMarkers=w}get clearCommandsInViewport(){return y._clearCommandsInViewport.bind(y)}commitCommandFinished(){y._commitCommandFinished?.flush(),y._commitCommandFinished=void 0}},this._logService)}else!r&&!(this._ptyHeuristics.value instanceof h)&&(this._ptyHeuristics.value=new h(this._terminal,this,this._ptyHeuristicsHooks,this._logService))}setIsCommandStorageDisabled(){this.__isCommandStorageDisabled=!0}getCommandForLine(r){if(this._currentCommand.promptStartMarker&&r>=this._currentCommand.promptStartMarker?.line)return this._currentCommand;if(this._commands.length!==0&&!((this._commands[0].promptStartMarker??this._commands[0].marker).line>r)){for(let y=this.commands.length-1;y>=0;y--)if((this.commands[y].promptStartMarker??this.commands[y].marker).line<=r)return this.commands[y]}}getCwdForLine(r){if(this._currentCommand.promptStartMarker&&r>=this._currentCommand.promptStartMarker?.line)return this._cwd;const y=this.getCommandForLine(r);if(y&&"cwd"in y)return y.cwd}handlePromptStart(r){const y=this.commands.at(-1);y?.endMarker&&y?.executedMarker&&y.endMarker.line===y.executedMarker.line&&(this._logService.debug("CommandDetectionCapability#handlePromptStart adjusted commandFinished",`${y.endMarker.line} -> ${y.executedMarker.line+1}`),y.endMarker=d(this._terminal,y.executedMarker,1)),this._currentCommand.promptStartMarker=r?.marker||(y?.endMarker?d(this._terminal,y.endMarker):this._terminal.registerMarker(0)),this._logService.debug("CommandDetectionCapability#handlePromptStart",this._terminal.buffer.active.cursorX,this._currentCommand.promptStartMarker?.line)}handleContinuationStart(){this._currentCommand.currentContinuationMarker=this._terminal.registerMarker(0),this._logService.debug("CommandDetectionCapability#handleContinuationStart",this._currentCommand.currentContinuationMarker)}handleContinuationEnd(){if(!this._currentCommand.currentContinuationMarker){this._logService.warn("CommandDetectionCapability#handleContinuationEnd Received continuation end without start");return}this._currentCommand.continuations||(this._currentCommand.continuations=[]),this._currentCommand.continuations.push({marker:this._currentCommand.currentContinuationMarker,end:this._terminal.buffer.active.cursorX}),this._currentCommand.currentContinuationMarker=void 0,this._logService.debug("CommandDetectionCapability#handleContinuationEnd",this._currentCommand.continuations[this._currentCommand.continuations.length-1])}handleRightPromptStart(){this._currentCommand.commandRightPromptStartX=this._terminal.buffer.active.cursorX,this._logService.debug("CommandDetectionCapability#handleRightPromptStart",this._currentCommand.commandRightPromptStartX)}handleRightPromptEnd(){this._currentCommand.commandRightPromptEndX=this._terminal.buffer.active.cursorX,this._logService.debug("CommandDetectionCapability#handleRightPromptEnd",this._currentCommand.commandRightPromptEndX)}handleCommandStart(r){if(this._handleCommandStartOptions=r,this._currentCommand.cwd=this._cwd,this._currentCommand.commandStartMarker=r?.marker||this._currentCommand.commandStartMarker,this._currentCommand.commandStartMarker?.line===this._terminal.buffer.active.cursorY){this._currentCommand.commandStartX=this._terminal.buffer.active.cursorX,this._logService.debug("CommandDetectionCapability#handleCommandStart",this._currentCommand.commandStartX,this._currentCommand.commandStartMarker?.line);return}this._ptyHeuristics.value.handleCommandStart(r)}handleGenericCommand(r){r?.markProperties?.disableCommandStorage&&this.setIsCommandStorageDisabled(),this.handlePromptStart(r),this.handleCommandStart(r),this.handleCommandExecuted(r),this.handleCommandFinished(void 0,r)}handleCommandExecuted(r){this._ptyHeuristics.value.handleCommandExecuted(r),this._currentCommand.markExecutedTime()}handleCommandFinished(r,y){if(this._currentCommand.markFinishedTime(),this._ptyHeuristics.value.preHandleCommandFinished?.(),this._logService.debug("CommandDetectionCapability#handleCommandFinished",this._terminal.buffer.active.cursorX,y?.marker?.line,this._currentCommand.command,this._currentCommand),r===void 0){const C=this.commands.length>0?this.commands[this.commands.length-1]:void 0;this._currentCommand.command&&this._currentCommand.command.length>0&&C?.command===this._currentCommand.command&&(r=C.exitCode)}if(this._currentCommand.commandStartMarker===void 0||!this._terminal.buffer.active)return;this._currentCommand.commandFinishedMarker=y?.marker||this._terminal.registerMarker(0),this._ptyHeuristics.value.postHandleCommandFinished?.();const w=this._currentCommand.promoteToFullCommand(this._cwd,r,this._handleCommandStartOptions?.ignoreCommandLine??!1,y?.markProperties);w&&(this._commands.push(w),this._commitCommandFinished=new o.RunOnceScheduler(()=>{this._onBeforeCommandFinished.fire(w),this._currentCommand.isInvalid||(this._logService.debug("CommandDetectionCapability#onCommandFinished",w),this._onCommandFinished.fire(w))},50),this._commitCommandFinished.schedule()),this._currentCommand=new _.PartialTerminalCommand(this._terminal),this._handleCommandStartOptions=void 0}setCommandLine(r,y){this._logService.debug("CommandDetectionCapability#setCommandLine",r,y),this._currentCommand.command=r,this._currentCommand.commandLineConfidence="high",this._currentCommand.isTrusted=y,y&&this._promptInputModel.setConfidentCommandLine(r)}serialize(){const r=this.commands.map(w=>w.serialize(this.__isCommandStorageDisabled)),y=this._currentCommand.serialize(this._cwd);return y&&r.push(y),{isWindowsPty:this._ptyHeuristics.value instanceof l,commands:r,promptInputModel:this._promptInputModel.serialize()}}deserialize(r){r.isWindowsPty&&this.setIsWindowsPty(r.isWindowsPty);const y=this._terminal.buffer.normal;for(const w of r.commands){if(!w.endLine){const i=w.startLine!==void 0?this._terminal.registerMarker(w.startLine-(y.baseY+y.cursorY)):void 0;if(!i)continue;this._currentCommand.commandStartMarker=w.startLine!==void 0?this._terminal.registerMarker(w.startLine-(y.baseY+y.cursorY)):void 0,this._currentCommand.commandStartX=w.startX,this._currentCommand.promptStartMarker=w.promptStartLine!==void 0?this._terminal.registerMarker(w.promptStartLine-(y.baseY+y.cursorY)):void 0,this._cwd=w.cwd,this._onCommandStarted.fire({marker:i});continue}const C=_.TerminalCommand.deserialize(this._terminal,w,this.__isCommandStorageDisabled);C&&(this._commands.push(C),this._logService.debug("CommandDetectionCapability#onCommandFinished",C),this._onCommandFinished.fire(C))}r.promptInputModel&&this._promptInputModel.deserialize(r.promptInputModel)}};e.CommandDetectionCapability=b,ge([(0,t.debounce)(500)],b.prototype,"_handleCursorMove",null),e.CommandDetectionCapability=b=ge([We(1,W.ILogService)],b);class h extends m.Disposable{constructor(r,y,w,C){super(),this._terminal=r,this._capability=y,this._hooks=w,this._logService=C,this._register(r.parser.registerCsiHandler({final:"J"},i=>(i.length>=1&&(i[0]===2||i[0]===3)&&w.clearCommandsInViewport(),!1)))}handleCommandStart(r){this._hooks.commitCommandFinished();const y=this._capability.currentCommand;y.commandStartX=this._terminal.buffer.active.cursorX,y.commandStartMarker=r?.marker||this._terminal.registerMarker(0),y.commandExecutedMarker?.dispose(),y.commandExecutedMarker=void 0,y.commandExecutedX=void 0;for(const w of this._hooks.commandMarkers)w.dispose();this._hooks.commandMarkers.length=0,this._hooks.onCommandStartedEmitter.fire({marker:r?.marker||y.commandStartMarker,markProperties:r?.markProperties}),this._logService.debug("CommandDetectionCapability#handleCommandStart",y.commandStartX,y.commandStartMarker?.line)}handleCommandExecuted(r){const y=this._capability.currentCommand;if(y.commandExecutedMarker=r?.marker||this._terminal.registerMarker(0),y.commandExecutedX=this._terminal.buffer.active.cursorX,this._logService.debug("CommandDetectionCapability#handleCommandExecuted",y.commandExecutedX,y.commandExecutedMarker?.line),!y.commandStartMarker||!y.commandExecutedMarker||y.commandStartX===void 0)return;y.command=this._hooks.isCommandStorageDisabled?"":this._terminal.buffer.active.getLine(y.commandStartMarker.line)?.translateToString(!0,y.commandStartX,y.commandRightPromptStartX).trim();let w=y.commandStartMarker.line+1;const C=y.commandExecutedMarker.line;for(;w<C;w++){const i=this._terminal.buffer.active.getLine(w);if(i){const n=y.continuations?.find(R=>R.marker.line===w);n&&(y.command+=`
`);const f=n?.end??0;y.command+=i.translateToString(!0,f)}}w===C&&(y.command+=this._terminal.buffer.active.getLine(C)?.translateToString(!0,void 0,y.commandExecutedX)||""),this._hooks.onCommandExecutedEmitter.fire(y)}}var g;(function(p){p[p.MaxCheckLineCount=10]="MaxCheckLineCount",p[p.Interval=20]="Interval",p[p.MaximumPollCount=10]="MaximumPollCount"})(g||(g={}));let l=class extends m.Disposable{constructor(r,y,w,C){super(),this._terminal=r,this._capability=y,this._hooks=w,this._logService=C,this._onCursorMoveListener=this._register(new m.MutableDisposable),this._tryAdjustCommandStartMarkerScannedLineCount=0,this._tryAdjustCommandStartMarkerPollCount=0,this._register(r.parser.registerCsiHandler({final:"J"},i=>(i.length>=1&&(i[0]===2||i[0]===3)&&this._hooks.clearCommandsInViewport(),!1))),this._register(this._capability.onBeforeCommandFinished(i=>{(i.command.trim().toLowerCase()==="clear"||i.command.trim().toLowerCase()==="cls")&&(this._tryAdjustCommandStartMarkerScheduler?.cancel(),this._tryAdjustCommandStartMarkerScheduler=void 0,this._hooks.clearCommandsInViewport(),this._capability.currentCommand.isInvalid=!0,this._hooks.onCurrentCommandInvalidatedEmitter.fire({reason:P.CommandInvalidationReason.Windows}))}))}preHandleResize(r){const y=this._terminal.buffer.active.baseY,w=r.rows-this._hooks.dimensions.rows;w>0&&this._waitForCursorMove().then(()=>{const C=Math.min(w,y);for(let i=this._capability.commands.length-1;i>=0;i--){const n=this._capability.commands[i];if(!n.marker||n.marker.line<y||n.commandStartLineContent===void 0)break;const f=this._terminal.buffer.active.getLine(n.marker.line);if(!f||f.translateToString(!0)===n.commandStartLineContent)continue;const R=n.marker.line-C;this._terminal.buffer.active.getLine(R)?.translateToString(!0)===n.commandStartLineContent&&this._terminal._core._bufferService.buffer.lines.onDeleteEmitter.fire({index:this._terminal.buffer.active.baseY,amount:C})}})}handleCommandStart(){this._capability.currentCommand.commandStartX=this._terminal.buffer.active.cursorX,this._hooks.commandMarkers.length=0;const r=this._capability.currentCommand.commandStartMarker=this._capability.currentCommand.promptStartMarker?d(this._terminal,this._capability.currentCommand.promptStartMarker):this._terminal.registerMarker(0);this._capability.currentCommand.commandStartX=0,this._tryAdjustCommandStartMarkerScannedLineCount=0,this._tryAdjustCommandStartMarkerPollCount=0,this._tryAdjustCommandStartMarkerScheduler=new o.RunOnceScheduler(()=>this._tryAdjustCommandStartMarker(r),g.Interval),this._tryAdjustCommandStartMarkerScheduler.schedule()}_tryAdjustCommandStartMarker(r){if(this._store.isDisposed)return;const y=this._terminal.buffer.active;let w=this._tryAdjustCommandStartMarkerScannedLineCount;for(;w<g.MaxCheckLineCount&&r.line+w<y.baseY+this._terminal.rows;){if(this._cursorOnNextLine()){const C=this._getWindowsPrompt(r.line+w);if(C){const i=typeof C=="string"?C:C.prompt;if(this._capability.currentCommand.commandStartMarker=this._terminal.registerMarker(0),typeof C=="object"&&C.likelySingleLine){this._logService.debug("CommandDetectionCapability#_tryAdjustCommandStartMarker adjusted promptStart",`${this._capability.currentCommand.promptStartMarker?.line} -> ${this._capability.currentCommand.commandStartMarker.line}`),this._capability.currentCommand.promptStartMarker?.dispose(),this._capability.currentCommand.promptStartMarker=d(this._terminal,this._capability.currentCommand.commandStartMarker);const n=this._capability.commands.at(-1);n&&this._capability.currentCommand.commandStartMarker.line!==n.endMarker?.line&&(n.endMarker?.dispose(),n.endMarker=d(this._terminal,this._capability.currentCommand.commandStartMarker))}this._capability.currentCommand.commandStartX=i.length,this._logService.debug("CommandDetectionCapability#_tryAdjustCommandStartMarker adjusted commandStart",`${r.line} -> ${this._capability.currentCommand.commandStartMarker.line}:${this._capability.currentCommand.commandStartX}`),this._flushPendingHandleCommandStartTask();return}}w++}w<g.MaxCheckLineCount?(this._tryAdjustCommandStartMarkerScannedLineCount=w,++this._tryAdjustCommandStartMarkerPollCount<g.MaximumPollCount?this._tryAdjustCommandStartMarkerScheduler?.schedule():this._flushPendingHandleCommandStartTask()):this._flushPendingHandleCommandStartTask()}_flushPendingHandleCommandStartTask(){if(this._tryAdjustCommandStartMarkerScheduler&&(this._tryAdjustCommandStartMarkerPollCount=g.MaximumPollCount,this._tryAdjustCommandStartMarkerScheduler.flush(),this._tryAdjustCommandStartMarkerScheduler=void 0),this._hooks.commitCommandFinished(),this._capability.currentCommand.commandExecutedMarker||(this._onCursorMoveListener.value=this._terminal.onCursorMove(()=>{if(this._hooks.commandMarkers.length===0||this._hooks.commandMarkers[this._hooks.commandMarkers.length-1].line!==this._terminal.buffer.active.cursorY){const r=this._terminal.registerMarker(0);r&&this._hooks.commandMarkers.push(r)}})),this._capability.currentCommand.commandStartMarker){const r=this._terminal.buffer.active.getLine(this._capability.currentCommand.commandStartMarker.line);r&&(this._capability.currentCommand.commandStartLineContent=r.translateToString(!0))}this._hooks.onCommandStartedEmitter.fire({marker:this._capability.currentCommand.commandStartMarker}),this._logService.debug("CommandDetectionCapability#_handleCommandStartWindows",this._capability.currentCommand.commandStartX,this._capability.currentCommand.commandStartMarker?.line)}handleCommandExecuted(r){this._tryAdjustCommandStartMarkerScheduler&&this._flushPendingHandleCommandStartTask(),this._onCursorMoveListener.clear(),this._evaluateCommandMarkers(),this._capability.currentCommand.commandExecutedX=this._terminal.buffer.active.cursorX,this._hooks.onCommandExecutedEmitter.fire(this._capability.currentCommand),this._logService.debug("CommandDetectionCapability#handleCommandExecuted",this._capability.currentCommand.commandExecutedX,this._capability.currentCommand.commandExecutedMarker?.line)}preHandleCommandFinished(){this._capability.currentCommand.commandExecutedMarker||(this._hooks.commandMarkers.length===0&&(this._capability.currentCommand.commandStartMarker||(this._capability.currentCommand.commandStartMarker=this._terminal.registerMarker(0)),this._capability.currentCommand.commandStartMarker&&this._hooks.commandMarkers.push(this._capability.currentCommand.commandStartMarker)),this._evaluateCommandMarkers())}postHandleCommandFinished(){const r=this._capability.currentCommand,y=r.command,w=r.commandStartMarker?.line,C=r.commandExecutedMarker?.line;if(!y||y.length===0||w===void 0||w===-1||C===void 0||C===-1)return;let i=0,n=!1;for(let f=w;f<=C;f++){const R=this._terminal.buffer.active.getLine(f);if(!R)break;const x=R.translateToString(!0);for(let v=0;v<x.length;v++){for(;y.length<i&&y[i]===" ";)i++;if(x[v]===y[i]&&i++,i===y.length){const S=v>=this._terminal.cols-1;r.commandExecutedMarker=this._terminal.registerMarker(f-(this._terminal.buffer.active.baseY+this._terminal.buffer.active.cursorY)+(S?1:0)),r.commandExecutedX=S?0:v+1,n=!0;break}}if(n)break}}_evaluateCommandMarkers(){if(this._hooks.commandMarkers.length!==0){if(this._hooks.commandMarkers=this._hooks.commandMarkers.sort((r,y)=>r.line-y.line),this._capability.currentCommand.commandStartMarker=this._hooks.commandMarkers[0],this._capability.currentCommand.commandStartMarker){const r=this._terminal.buffer.active.getLine(this._capability.currentCommand.commandStartMarker.line);r&&(this._capability.currentCommand.commandStartLineContent=r.translateToString(!0))}this._capability.currentCommand.commandExecutedMarker=this._hooks.commandMarkers[this._hooks.commandMarkers.length-1],this._hooks.onCommandExecutedEmitter.fire(this._capability.currentCommand)}}_cursorOnNextLine(){const r=this._capability.commands.at(-1);if(!r)return!0;const y=this._terminal.buffer.active.baseY+this._terminal.buffer.active.cursorY,w=(r.endMarker?r.endMarker.line:r.marker?.line)??-1;return y>w}_waitForCursorMove(){const r=this._terminal.buffer.active.cursorX,y=this._terminal.buffer.active.cursorY;let w=0;return new Promise((C,i)=>{const n=setInterval(()=>{if(r!==this._terminal.buffer.active.cursorX||y!==this._terminal.buffer.active.cursorY){C(),clearInterval(n);return}w+=10,w>1e3&&(clearInterval(n),C())},10)})}_getWindowsPrompt(r=this._terminal.buffer.active.baseY+this._terminal.buffer.active.cursorY){const y=this._terminal.buffer.active.getLine(r);if(!y)return;const w=y.translateToString(!0);if(!w)return;const C=w.match(/(?<prompt>(\(.+\)\s)?(?:PS.+>\s?))/)?.groups?.prompt;if(C){const x=this._adjustPrompt(C,w,">");if(x)return{prompt:x,likelySingleLine:!0}}const i=w.match(/.*\u276f(?=[^\u276f]*$)/g)?.[0];if(i){const x=this._adjustPrompt(i,w,"\u276F");if(x)return x}const n=w.match(/^(?<prompt>\$)/)?.groups?.prompt;if(n){const x=this._adjustPrompt(n,w,"$");if(x)return x}const f=w.match(/^(?<prompt>>>> )/g)?.groups?.prompt;if(f)return{prompt:f,likelySingleLine:!0};if(this._capability.promptTerminator&&w.trim().endsWith(this._capability.promptTerminator)){const x=this._adjustPrompt(w,w,this._capability.promptTerminator);if(x)return x}const R=w.match(/^(?<prompt>(\(.+\)\s)?(?:[A-Z]:\\.*>))/);return R?.groups?.prompt?{prompt:R.groups.prompt,likelySingleLine:!0}:void 0}_adjustPrompt(r,y,w){if(r)return y===r&&r.endsWith(w)&&(r+=" "),r}};l=ge([We(3,W.ILogService)],l);function u(p,r,y,w){if(!w)return;const C=r.executedMarker,i=r.endMarker;if(!C||!i)return;const n=C.line,f=i.line,R=w.length,x=[];if(w.anchor==="bottom")for(let v=f-(w.offset||0);v>=n;v--){let S=v;const T=v;for(;S>=n&&p.getLine(S)?.isWrapped;)S--;v=S,x.unshift(a(p,S,T,y)),x.length>R&&x.pop()}else for(let v=n+(w.offset||0);v<f;v++){const S=v;let T=v;for(;T+1<f&&p.getLine(T+1)?.isWrapped;)T++;v=T,x.push(a(p,S,T,y)),x.length===R&&x.shift()}return x}function a(p,r,y,w){const C=Math.max(2048/w*2);y=Math.min(y,r+C);let i="";for(let n=r;n<=y;n++){const f=p.getLine(n);f&&(i+=f.translateToString(!0,0,w))}return i}function d(p,r,y=0){return p.registerMarker(r.line-(p.buffer.active.baseY+p.buffer.active.cursorY)+y)}}),define(he[86],fe([0,1,4,2,23]),function(ie,e,o,t,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CwdDetectionCapability=void 0;class m extends t.Disposable{constructor(){super(...arguments),this.type=L.TerminalCapability.CwdDetection,this._cwd="",this._cwds=new Map,this._onDidChangeCwd=this._register(new o.Emitter),this.onDidChangeCwd=this._onDidChangeCwd.event}get cwds(){return Array.from(this._cwds.keys())}getCwd(){return this._cwd}updateCwd(P){const _=this._cwd!==P;this._cwd=P;const s=this._cwds.get(this._cwd)||0;this._cwds.delete(this._cwd),this._cwds.set(this._cwd,s+1),_&&this._onDidChangeCwd.fire(P)}}e.CwdDetectionCapability=m}),define(he[87],fe([0,1,4,2,23]),function(ie,e,o,t,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PartialCommandDetectionCapability=void 0;var m;(function(P){P[P.MinimumPromptLength=2]="MinimumPromptLength"})(m||(m={}));class W extends t.DisposableStore{get commands(){return this._commands}constructor(_){super(),this._terminal=_,this.type=L.TerminalCapability.PartialCommandDetection,this._commands=[],this._onCommandFinished=this.add(new o.Emitter),this.onCommandFinished=this._onCommandFinished.event,this.add(this._terminal.onData(s=>this._onData(s))),this.add(this._terminal.parser.registerCsiHandler({final:"J"},s=>(s.length>=1&&(s[0]===2||s[0]===3)&&this._clearCommandsInViewport(),!1)))}_onData(_){_==="\r"&&this._onEnter()}_onEnter(){if(this._terminal&&this._terminal.buffer.active.cursorX>=m.MinimumPromptLength){const _=this._terminal.registerMarker(0);_&&(this._commands.push(_),this._onCommandFinished.fire(_))}}_clearCommandsInViewport(){let _=0;for(let s=this._commands.length-1;s>=0&&!(this._commands[s].line<this._terminal.buffer.active.baseY);s--)_++;this._commands.splice(this._commands.length-_,_)}}e.PartialCommandDetectionCapability=W}),define(he[88],fe([0,1,4,2]),function(ie,e,o,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalCapabilityStoreMultiplexer=e.TerminalCapabilityStore=void 0;class L extends t.Disposable{constructor(){super(...arguments),this._map=new Map,this._onDidRemoveCapabilityType=this._register(new o.Emitter),this.onDidRemoveCapabilityType=this._onDidRemoveCapabilityType.event,this._onDidAddCapabilityType=this._register(new o.Emitter),this.onDidAddCapabilityType=this._onDidAddCapabilityType.event,this._onDidRemoveCapability=this._register(new o.Emitter),this.onDidRemoveCapability=this._onDidRemoveCapability.event,this._onDidAddCapability=this._register(new o.Emitter),this.onDidAddCapability=this._onDidAddCapability.event}get items(){return this._map.keys()}add(P,_){this._map.set(P,_),this._onDidAddCapabilityType.fire(P),this._onDidAddCapability.fire({id:P,capability:_})}get(P){return this._map.get(P)}remove(P){const _=this._map.get(P);_&&(this._map.delete(P),this._onDidRemoveCapabilityType.fire(P),this._onDidAddCapability.fire({id:P,capability:_}))}has(P){return this._map.has(P)}}e.TerminalCapabilityStore=L;class m extends t.Disposable{constructor(){super(...arguments),this._stores=[],this._onDidRemoveCapabilityType=this._register(new o.Emitter),this.onDidRemoveCapabilityType=this._onDidRemoveCapabilityType.event,this._onDidAddCapabilityType=this._register(new o.Emitter),this.onDidAddCapabilityType=this._onDidAddCapabilityType.event,this._onDidRemoveCapability=this._register(new o.Emitter),this.onDidRemoveCapability=this._onDidRemoveCapability.event,this._onDidAddCapability=this._register(new o.Emitter),this.onDidAddCapability=this._onDidAddCapability.event}get items(){return this._items()}*_items(){for(const P of this._stores)for(const _ of P.items)yield _}has(P){for(const _ of this._stores)for(const s of _.items)if(s===P)return!0;return!1}get(P){for(const _ of this._stores){const s=_.get(P);if(s)return s}}add(P){this._stores.push(P);for(const _ of P.items)this._onDidAddCapabilityType.fire(_),this._onDidAddCapability.fire({id:_,capability:P.get(_)});this._register(P.onDidAddCapabilityType(_=>this._onDidAddCapabilityType.fire(_))),this._register(P.onDidAddCapability(_=>this._onDidAddCapability.fire(_))),this._register(P.onDidRemoveCapabilityType(_=>this._onDidRemoveCapabilityType.fire(_))),this._register(P.onDidRemoveCapability(_=>this._onDidRemoveCapability.fire(_)))}}e.TerminalCapabilityStoreMultiplexer=m}),define(he[40],fe([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentVariableMutatorType=void 0;var o;(function(t){t[t.Replace=1]="Replace",t[t.Append=2]="Append",t[t.Prepend=3]="Prepend"})(o||(e.EnvironmentVariableMutatorType=o={}))}),define(he[89],fe([0,1,3,40]),function(ie,e,o,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MergedEnvironmentVariableCollection=void 0;const L=new Map([[t.EnvironmentVariableMutatorType.Append,"APPEND"],[t.EnvironmentVariableMutatorType.Prepend,"PREPEND"],[t.EnvironmentVariableMutatorType.Replace,"REPLACE"]]);class m{constructor(b){this.collections=b,this.map=new Map,this.descriptionMap=new Map,b.forEach((h,g)=>{this.populateDescriptionMap(h,g);const l=h.map.entries();let u=l.next();for(;!u.done;){const a=u.value[1],d=u.value[0];let p=this.map.get(d);if(p||(p=[],this.map.set(d,p)),p.length>0&&p[0].type===t.EnvironmentVariableMutatorType.Replace){u=l.next();continue}const r={extensionIdentifier:g,value:a.value,type:a.type,scope:a.scope,variable:a.variable,options:a.options};r.scope||delete r.scope,p.unshift(r),u=l.next()}})}async applyToProcessEnvironment(b,h,g){let l;o.isWindows&&(l={},Object.keys(b).forEach(u=>l[u.toLowerCase()]=u));for(const[u,a]of this.getVariableMap(h)){const d=o.isWindows&&l[u.toLowerCase()]||u;for(const p of a){const r=g?await g(p.value):p.value;if(p.options?.applyAtProcessCreation??!0)switch(p.type){case t.EnvironmentVariableMutatorType.Append:b[d]=(b[d]||"")+r;break;case t.EnvironmentVariableMutatorType.Prepend:b[d]=r+(b[d]||"");break;case t.EnvironmentVariableMutatorType.Replace:b[d]=r;break}if(p.options?.applyAtShellIntegration??!1){const y=`VSCODE_ENV_${L.get(p.type)}`;b[y]=(b[y]?b[y]+":":"")+u+"="+this._encodeColons(r)}}}}_encodeColons(b){return b.replaceAll(":","\\x3a")}diff(b,h){const g=new Map,l=new Map,u=new Map;if(b.getVariableMap(h).forEach((a,d)=>{const p=this.getVariableMap(h).get(d),r=P(a,p);r&&g.set(d,r)}),this.getVariableMap(h).forEach((a,d)=>{const p=b.getVariableMap(h).get(d),r=P(a,p);r&&u.set(d,r)}),this.getVariableMap(h).forEach((a,d)=>{const p=b.getVariableMap(h).get(d),r=_(a,p);r&&l.set(d,r)}),!(g.size===0&&l.size===0&&u.size===0))return{added:g,changed:l,removed:u}}getVariableMap(b){const h=new Map;for(const g of this.map.values()){const l=g.filter(u=>W(u,b));l.length>0&&h.set(l[0].variable,l)}return h}getDescriptionMap(b){const h=new Map;for(const g of this.descriptionMap.values()){const l=g.filter(u=>W(u,b,!0));for(const u of l)h.set(u.extensionIdentifier,u.description)}return h}populateDescriptionMap(b,h){if(!b.descriptionMap)return;const g=b.descriptionMap.entries();let l=g.next();for(;!l.done;){const u=l.value[1],a=l.value[0];let d=this.descriptionMap.get(a);d||(d=[],this.descriptionMap.set(a,d));const p={extensionIdentifier:h,scope:u.scope,description:u.description};p.scope||delete p.scope,d.push(p),l=g.next()}}}e.MergedEnvironmentVariableCollection=m;function W(s,b,h=!1){return s.scope?!!(s.scope.workspaceFolder&&b?.workspaceFolder&&s.scope.workspaceFolder.index===b.workspaceFolder.index):h?b===s.scope:!0}function P(s,b){if(!b)return s;const h=new Set;b.forEach(l=>h.add(l.extensionIdentifier));const g=[];return s.forEach(l=>{h.has(l.extensionIdentifier)||g.push(l)}),g.length===0?void 0:g}function _(s,b){if(!b)return;const h=new Map;b.forEach(l=>h.set(l.extensionIdentifier,l));const g=[];return s.forEach(l=>{const u=h.get(l.extensionIdentifier);u&&(l.type!==u.type||l.value!==u.value||l.scope?.workspaceFolder?.index!==u.scope?.workspaceFolder?.index)&&g.push(u)}),g.length===0?void 0:g}}),define(he[90],fe([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.serializeEnvironmentVariableCollection=o,e.serializeEnvironmentDescriptionMap=t,e.deserializeEnvironmentVariableCollection=L,e.deserializeEnvironmentDescriptionMap=m,e.serializeEnvironmentVariableCollections=W,e.deserializeEnvironmentVariableCollections=P;function o(_){return[..._.entries()]}function t(_){return _?[..._.entries()]:[]}function L(_){return new Map(_)}function m(_){return new Map(_??[])}function W(_){return Array.from(_.entries()).map(s=>[s[0],o(s[1].map),t(s[1].descriptionMap)])}function P(_){return new Map(_.map(s=>[s[0],{map:L(s[1]),descriptionMap:m(s[2])}]))}}),define(he[91],fe([0,1,12,18,4,2,9]),function(ie,e,o,t,L,m,W){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestStore=void 0;let P=class extends m.Disposable{constructor(s,b){super(),this._logService=b,this._lastRequestId=0,this._pendingRequests=new Map,this._pendingRequestDisposables=new Map,this._onCreateRequest=this._register(new L.Emitter),this.onCreateRequest=this._onCreateRequest.event,this._timeout=s===void 0?15e3:s,this._register((0,m.toDisposable)(()=>{for(const h of this._pendingRequestDisposables.values())(0,m.dispose)(h)}))}createRequest(s){return new Promise((b,h)=>{const g=++this._lastRequestId;this._pendingRequests.set(g,b),this._onCreateRequest.fire({requestId:g,...s});const l=new t.CancellationTokenSource;(0,o.timeout)(this._timeout,l.token).then(()=>h(`Request ${g} timed out (${this._timeout}ms)`)),this._pendingRequestDisposables.set(g,[(0,m.toDisposable)(()=>l.cancel())])})}acceptReply(s,b){const h=this._pendingRequests.get(s);h?(this._pendingRequests.delete(s),(0,m.dispose)(this._pendingRequestDisposables.get(s)||[]),this._pendingRequestDisposables.delete(s),h(b)):this._logService.warn(`RequestStore#acceptReply was called without receiving a matching request ${s}`)}};e.RequestStore=P,e.RequestStore=P=ge([We(1,W.ILogService)],P)}),define(he[16],fe([0,1,22,39,81]),function(ie,e,o,t,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ITerminalLogService=e.ILocalPtyService=e.TerminalExtensions=e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.IPtyService=e.ProcessPropertyType=e.TerminalIpcChannels=e.TitleEventSource=e.GeneralShellType=e.WindowsShellType=e.PosixShellType=e.TerminalSettingId=e.TerminalSettingPrefix=e.terminalTabFocusModeContextKey=void 0,e.terminalTabFocusModeContextKey=new t.RawContextKey("terminalTabFocusMode",!1,!0);var m;(function(i){i.AutomationProfile="terminal.integrated.automationProfile.",i.DefaultProfile="terminal.integrated.defaultProfile.",i.Profiles="terminal.integrated.profiles."})(m||(e.TerminalSettingPrefix=m={}));var W;(function(i){i.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",i.AutomationProfileLinux="terminal.integrated.automationProfile.linux",i.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",i.AutomationProfileWindows="terminal.integrated.automationProfile.windows",i.ProfilesWindows="terminal.integrated.profiles.windows",i.ProfilesMacOs="terminal.integrated.profiles.osx",i.ProfilesLinux="terminal.integrated.profiles.linux",i.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",i.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",i.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",i.UseWslProfiles="terminal.integrated.useWslProfiles",i.TabsDefaultColor="terminal.integrated.tabs.defaultColor",i.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",i.TabsEnabled="terminal.integrated.tabs.enabled",i.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",i.TabsHideCondition="terminal.integrated.tabs.hideCondition",i.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",i.TabsShowActions="terminal.integrated.tabs.showActions",i.TabsLocation="terminal.integrated.tabs.location",i.TabsFocusMode="terminal.integrated.tabs.focusMode",i.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",i.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",i.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",i.CopyOnSelection="terminal.integrated.copyOnSelection",i.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",i.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",i.FontFamily="terminal.integrated.fontFamily",i.FontSize="terminal.integrated.fontSize",i.LetterSpacing="terminal.integrated.letterSpacing",i.LineHeight="terminal.integrated.lineHeight",i.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",i.TabStopWidth="terminal.integrated.tabStopWidth",i.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",i.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",i.BellDuration="terminal.integrated.bellDuration",i.FontWeight="terminal.integrated.fontWeight",i.FontWeightBold="terminal.integrated.fontWeightBold",i.CursorBlinking="terminal.integrated.cursorBlinking",i.CursorStyle="terminal.integrated.cursorStyle",i.CursorStyleInactive="terminal.integrated.cursorStyleInactive",i.CursorWidth="terminal.integrated.cursorWidth",i.Scrollback="terminal.integrated.scrollback",i.DetectLocale="terminal.integrated.detectLocale",i.DefaultLocation="terminal.integrated.defaultLocation",i.GpuAcceleration="terminal.integrated.gpuAcceleration",i.TerminalTitleSeparator="terminal.integrated.tabs.separator",i.TerminalTitle="terminal.integrated.tabs.title",i.TerminalDescription="terminal.integrated.tabs.description",i.RightClickBehavior="terminal.integrated.rightClickBehavior",i.MiddleClickBehavior="terminal.integrated.middleClickBehavior",i.Cwd="terminal.integrated.cwd",i.ConfirmOnExit="terminal.integrated.confirmOnExit",i.ConfirmOnKill="terminal.integrated.confirmOnKill",i.EnableBell="terminal.integrated.enableBell",i.EnableVisualBell="terminal.integrated.enableVisualBell",i.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",i.AllowChords="terminal.integrated.allowChords",i.AllowMnemonics="terminal.integrated.allowMnemonics",i.TabFocusMode="terminal.integrated.tabFocusMode",i.EnvMacOs="terminal.integrated.env.osx",i.EnvLinux="terminal.integrated.env.linux",i.EnvWindows="terminal.integrated.env.windows",i.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",i.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",i.ExperimentalWindowsUseConptyDll="terminal.integrated.experimental.windowsUseConptyDll",i.ShowExitAlert="terminal.integrated.showExitAlert",i.SplitCwd="terminal.integrated.splitCwd",i.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",i.WordSeparators="terminal.integrated.wordSeparators",i.EnableFileLinks="terminal.integrated.enableFileLinks",i.AllowedLinkSchemes="terminal.integrated.allowedLinkSchemes",i.UnicodeVersion="terminal.integrated.unicodeVersion",i.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",i.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",i.HideOnStartup="terminal.integrated.hideOnStartup",i.CustomGlyphs="terminal.integrated.customGlyphs",i.RescaleOverlappingGlyphs="terminal.integrated.rescaleOverlappingGlyphs",i.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",i.InheritEnv="terminal.integrated.inheritEnv",i.ShowLinkHover="terminal.integrated.showLinkHover",i.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",i.AutoReplies="terminal.integrated.autoReplies",i.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",i.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",i.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",i.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",i.EnableImages="terminal.integrated.enableImages",i.SmoothScrolling="terminal.integrated.smoothScrolling",i.IgnoreBracketedPasteMode="terminal.integrated.ignoreBracketedPasteMode",i.FocusAfterRun="terminal.integrated.focusAfterRun",i.DeveloperPtyHostLatency="terminal.integrated.developer.ptyHost.latency",i.DeveloperPtyHostStartupDelay="terminal.integrated.developer.ptyHost.startupDelay",i.DevMode="terminal.integrated.developer.devMode"})(W||(e.TerminalSettingId=W={}));var P;(function(i){i.Bash="bash",i.Fish="fish",i.Sh="sh",i.Csh="csh",i.Ksh="ksh",i.Zsh="zsh"})(P||(e.PosixShellType=P={}));var _;(function(i){i.CommandPrompt="cmd",i.Wsl="wsl",i.GitBash="gitbash"})(_||(e.WindowsShellType=_={}));var s;(function(i){i.PowerShell="pwsh",i.Python="python",i.Julia="julia",i.NuShell="nu"})(s||(e.GeneralShellType=s={}));var b;(function(i){i[i.Api=0]="Api",i[i.Process=1]="Process",i[i.Sequence=2]="Sequence",i[i.Config=3]="Config"})(b||(e.TitleEventSource=b={}));var h;(function(i){i.LocalPty="localPty",i.PtyHost="ptyHost",i.PtyHostWindow="ptyHostWindow",i.Logger="logger",i.Heartbeat="heartbeat"})(h||(e.TerminalIpcChannels=h={}));var g;(function(i){i.Cwd="cwd",i.InitialCwd="initialCwd",i.FixedDimensions="fixedDimensions",i.Title="title",i.ShellType="shellType",i.HasChildProcesses="hasChildProcesses",i.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",i.OverrideDimensions="overrideDimensions",i.FailedShellIntegrationActivation="failedShellIntegrationActivation",i.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(g||(e.ProcessPropertyType=g={})),e.IPtyService=(0,o.createDecorator)("ptyService");var l;(function(i){i[i.BeatInterval=5e3]="BeatInterval",i[i.ConnectingBeatInterval=2e4]="ConnectingBeatInterval",i[i.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",i[i.SecondWaitMultiplier=1]="SecondWaitMultiplier",i[i.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(l||(e.HeartbeatConstants=l={}));var u;(function(i){i[i.Panel=1]="Panel",i[i.Editor=2]="Editor"})(u||(e.TerminalLocation=u={}));var a;(function(i){i.TerminalView="view",i.Editor="editor"})(a||(e.TerminalLocationString=a={}));var d;(function(i){i[i.GraceTime=6e4]="GraceTime",i[i.ShortGraceTime=6e3]="ShortGraceTime"})(d||(e.LocalReconnectConstants=d={}));var p;(function(i){i[i.HighWatermarkChars=1e5]="HighWatermarkChars",i[i.LowWatermarkChars=5e3]="LowWatermarkChars",i[i.CharCountAckSize=5e3]="CharCountAckSize"})(p||(e.FlowControlConstants=p={}));var r;(function(i){i.GitBash="Git Bash",i.Pwsh="PowerShell"})(r||(e.ProfileSource=r={}));var y;(function(i){i[i.Off=0]="Off",i[i.FinalTerm=1]="FinalTerm",i[i.VSCode=2]="VSCode"})(y||(e.ShellIntegrationStatus=y={}));var w;(function(i){i[i.Unknown=0]="Unknown",i[i.Shutdown=1]="Shutdown",i[i.Process=2]="Process",i[i.User=3]="User",i[i.Extension=4]="Extension"})(w||(e.TerminalExitReason=w={})),e.TerminalExtensions={Backend:"workbench.contributions.terminal.processBackend"};class C{constructor(){this._backends=new Map}get backends(){return this._backends}registerTerminalBackend(n){const f=this._sanitizeRemoteAuthority(n.remoteAuthority);if(this._backends.has(f))throw new Error(`A terminal backend with remote authority '${f}' was already registered.`);this._backends.set(f,n)}getTerminalBackend(n){return this._backends.get(this._sanitizeRemoteAuthority(n))}_sanitizeRemoteAuthority(n){return n?.toLowerCase()??""}}L.Registry.add(e.TerminalExtensions.Backend,new C),e.ILocalPtyService=(0,o.createDecorator)("localPtyService"),e.ITerminalLogService=(0,o.createDecorator)("terminalLogService")}),define(he[92],fe([0,1,12,2,3]),function(ie,e,o,t,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalAutoResponder=void 0;class m extends t.Disposable{constructor(P,_,s,b){super(),this._pointer=0,this._paused=!1,this._throttled=!1,this._register(P.onProcessData(h=>{if(this._paused||this._throttled)return;const g=typeof h=="string"?h:h.data;for(let l=0;l<g.length;l++)g[l]===_[this._pointer]?this._pointer++:this._reset(),this._pointer===_.length&&(b.debug(`Auto reply match: "${_}", response: "${s}"`),P.input(s),this._throttled=!0,(0,o.timeout)(1e3).then(()=>this._throttled=!1),this._reset())}))}_reset(){this._pointer=0}handleResize(){L.isWindows&&(this._paused=!0)}handleInput(){this._paused=!1}}e.TerminalAutoResponder=m}),define(he[93],fe([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class o{constructor(L){this._callback=L,this._terminalBufferMap=new Map}dispose(){for(const L of this._terminalBufferMap.values())L.dispose()}startBuffering(L,m,W=5){const P=m(_=>{const s=typeof _=="string"?_:_.data;let b=this._terminalBufferMap.get(L);if(b){b.data.push(s);return}const h=setTimeout(()=>this.flushBuffer(L),W);b={data:[s],timeoutId:h,dispose:()=>{clearTimeout(h),this.flushBuffer(L),P.dispose()}},this._terminalBufferMap.set(L,b)});return P}stopBuffering(L){this._terminalBufferMap.get(L)?.dispose()}flushBuffer(L){const m=this._terminalBufferMap.get(L);m&&(this._terminalBufferMap.delete(L),this._callback(L,m.data.join("")))}}e.TerminalDataBufferer=o}),define(he[41],fe([0,1,3]),function(ie,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.escapeNonWindowsPath=t,e.collapseTildePath=L,e.sanitizeCwd=m,e.shouldUseEnvironmentVariableCollection=W;function t(P){let _=P;_.includes("\\")&&(_=_.replace(/\\/g,"\\\\"));const s=/[\`\$\|\&\>\~\#\!\^\*\;\<\"\']/g;return _=_.replace(s,""),`'${_}'`}function L(P,_,s){if(!P)return"";if(!_)return P;_.match(/[\/\\]$/)&&(_=_.slice(0,_.length-1));const b=P.replace(/\\/g,"/").toLowerCase(),h=_.replace(/\\/g,"/").toLowerCase();return b.includes(h)?`~${s}${P.slice(_.length+1)}`:P}function m(P){return P.match(/^['"].*['"]$/)&&(P=P.substring(1,P.length-1)),o.OS===o.OperatingSystem.Windows&&P&&P[1]===":"?P[0].toUpperCase()+P.substring(1):P}function W(P){return!P.strictEnv}}),define(he[94],fe([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.chunkInput=t;var o;(function(L){L[L.WriteMaxChunkSize=50]="WriteMaxChunkSize"})(o||(o={}));function t(L){const m=[];let W=0;for(let P=0;P<L.length-1;P++)(P-W+1>=o.WriteMaxChunkSize||L[P+1]==="\x1B")&&(m.push(L.substring(W,P+1)),W=P+1,P++);return W!==L.length&&m.push(L.substring(W)),m}}),define(he[95],fe([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.formatMessageForTerminal=o;function o(t,L={}){let m="";return L.excludeLeadingNewLine||(m+=`\r
`),m+="\x1B[0m\x1B[7m * ",L.loudFormatting?m+="\x1B[0;104m":m+="\x1B[0m",m+=` ${t} \x1B[0m
\r`,m}}),define(he[96],fe([0,1,16,2,88,85,86,23,87,4,82,6,41,11]),function(ie,e,o,t,L,m,W,P,_,s,b,h,g,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ShellIntegrationAddon=e.ShellIntegrationOscPs=void 0,e.deserializeMessage=y,e.parseKeyValueAssignment=w,e.parseMarkSequence=C;var u;(function(i){i[i.FinalTerm=133]="FinalTerm",i[i.VSCode=633]="VSCode",i[i.ITerm=1337]="ITerm",i[i.SetCwd=7]="SetCwd",i[i.SetWindowsFriendlyCwd=9]="SetWindowsFriendlyCwd"})(u||(e.ShellIntegrationOscPs=u={}));var a;(function(i){i.PromptStart="A",i.CommandStart="B",i.CommandExecuted="C",i.CommandFinished="D"})(a||(a={}));var d;(function(i){i.PromptStart="A",i.CommandStart="B",i.CommandExecuted="C",i.CommandFinished="D",i.CommandLine="E",i.ContinuationStart="F",i.ContinuationEnd="G",i.RightPromptStart="H",i.RightPromptEnd="I",i.Property="P",i.SetMark="SetMark"})(d||(d={}));var p;(function(i){i.SetMark="SetMark",i.CurrentDir="CurrentDir"})(p||(p={}));class r extends t.Disposable{get status(){return this._status}constructor(n,f,R,x){super(),this._nonce=n,this._disableTelemetry=f,this._telemetryService=R,this._logService=x,this.capabilities=this._register(new L.TerminalCapabilityStore),this._hasUpdatedTelemetry=!1,this._commonProtocolDisposables=[],this._status=o.ShellIntegrationStatus.Off,this._onDidChangeStatus=new s.Emitter,this.onDidChangeStatus=this._onDidChangeStatus.event,this._register((0,t.toDisposable)(()=>{this._clearActivationTimeout(),this._disposeCommonProtocol()}))}_disposeCommonProtocol(){(0,t.dispose)(this._commonProtocolDisposables),this._commonProtocolDisposables.length=0}activate(n){this._terminal=n,this.capabilities.add(P.TerminalCapability.PartialCommandDetection,this._register(new _.PartialCommandDetectionCapability(this._terminal))),this._register(n.parser.registerOscHandler(u.VSCode,f=>this._handleVSCodeSequence(f))),this._register(n.parser.registerOscHandler(u.ITerm,f=>this._doHandleITermSequence(f))),this._commonProtocolDisposables.push(n.parser.registerOscHandler(u.FinalTerm,f=>this._handleFinalTermSequence(f))),this._register(n.parser.registerOscHandler(u.SetCwd,f=>this._doHandleSetCwd(f))),this._register(n.parser.registerOscHandler(u.SetWindowsFriendlyCwd,f=>this._doHandleSetWindowsFriendlyCwd(f))),this._ensureCapabilitiesOrAddFailureTelemetry()}getMarkerId(n,f){this._createOrGetBufferMarkDetection(n).getMark(f)}_handleFinalTermSequence(n){const f=this._doHandleFinalTermSequence(n);return this._status===o.ShellIntegrationStatus.Off&&(this._status=o.ShellIntegrationStatus.FinalTerm,this._onDidChangeStatus.fire(this._status)),f}_doHandleFinalTermSequence(n){if(!this._terminal)return!1;const[f,...R]=n.split(";");switch(f){case a.PromptStart:return this._createOrGetCommandDetection(this._terminal).handlePromptStart(),!0;case a.CommandStart:return this._createOrGetCommandDetection(this._terminal).handleCommandStart({ignoreCommandLine:!0}),!0;case a.CommandExecuted:return this._createOrGetCommandDetection(this._terminal).handleCommandExecuted(),!0;case a.CommandFinished:{const x=R.length===1?parseInt(R[0]):void 0;return this._createOrGetCommandDetection(this._terminal).handleCommandFinished(x),!0}}return!1}_handleVSCodeSequence(n){const f=this._doHandleVSCodeSequence(n);return!this._hasUpdatedTelemetry&&f&&(this._telemetryService?.publicLog2("terminal/shellIntegrationActivationSucceeded"),this._hasUpdatedTelemetry=!0,this._clearActivationTimeout()),this._status!==o.ShellIntegrationStatus.VSCode&&(this._status=o.ShellIntegrationStatus.VSCode,this._onDidChangeStatus.fire(this._status)),f}async _ensureCapabilitiesOrAddFailureTelemetry(){!this._telemetryService||this._disableTelemetry||(this._activationTimeout=setTimeout(()=>{!this.capabilities.get(P.TerminalCapability.CommandDetection)&&!this.capabilities.get(P.TerminalCapability.CwdDetection)&&(this._telemetryService?.publicLog2("terminal/shellIntegrationActivationTimeout"),this._logService.warn("Shell integration failed to add capabilities within 10 seconds")),this._hasUpdatedTelemetry=!0},1e4))}_clearActivationTimeout(){this._activationTimeout!==void 0&&(clearTimeout(this._activationTimeout),this._activationTimeout=void 0)}_doHandleVSCodeSequence(n){if(!this._terminal)return!1;const f=n.indexOf(";"),R=f===-1?n:n.substring(0,f),x=f===-1?[]:n.substring(f+1).split(";");switch(R){case d.PromptStart:return this._createOrGetCommandDetection(this._terminal).handlePromptStart(),!0;case d.CommandStart:return this._createOrGetCommandDetection(this._terminal).handleCommandStart(),!0;case d.CommandExecuted:return this._createOrGetCommandDetection(this._terminal).handleCommandExecuted(),!0;case d.CommandFinished:{const v=x[0],S=v!==void 0?parseInt(v):void 0;return this._createOrGetCommandDetection(this._terminal).handleCommandFinished(S),!0}case d.CommandLine:{const v=x[0],S=x[1];let T;return v!==void 0?T=y(v):T="",this._createOrGetCommandDetection(this._terminal).setCommandLine(T,S===this._nonce),!0}case d.ContinuationStart:return this._createOrGetCommandDetection(this._terminal).handleContinuationStart(),!0;case d.ContinuationEnd:return this._createOrGetCommandDetection(this._terminal).handleContinuationEnd(),!0;case d.RightPromptStart:return this._createOrGetCommandDetection(this._terminal).handleRightPromptStart(),!0;case d.RightPromptEnd:return this._createOrGetCommandDetection(this._terminal).handleRightPromptEnd(),!0;case d.Property:{const v=x[0],S=v!==void 0?y(v):"",{key:T,value:O}=w(S);if(O===void 0)return!0;switch(T){case"ContinuationPrompt":return this._updateContinuationPrompt((0,l.removeAnsiEscapeCodesFromPrompt)(O)),!0;case"Cwd":return this._updateCwd(O),!0;case"IsWindows":return this._createOrGetCommandDetection(this._terminal).setIsWindowsPty(O==="True"),!0;case"Prompt":{const F=O.replace(/\x1b\[[0-9;]*m/g,"");return this._updatePromptTerminator(F),!0}case"Task":return this._createOrGetBufferMarkDetection(this._terminal),this.capabilities.get(P.TerminalCapability.CommandDetection)?.setIsCommandStorageDisabled(),!0}}case d.SetMark:return this._createOrGetBufferMarkDetection(this._terminal).addMark(C(x)),!0}return!1}_updateContinuationPrompt(n){this._terminal&&this._createOrGetCommandDetection(this._terminal).setContinuationPrompt(n)}_updatePromptTerminator(n){if(!this._terminal)return;const f=n.substring(n.lastIndexOf(`
`)+1),R=f.substring(f.lastIndexOf(" "));R&&this._createOrGetCommandDetection(this._terminal).setPromptTerminator(R,f)}_updateCwd(n){n=(0,g.sanitizeCwd)(n),this._createOrGetCwdDetection().updateCwd(n),this.capabilities.get(P.TerminalCapability.CommandDetection)?.setCwd(n)}_doHandleITermSequence(n){if(!this._terminal)return!1;const[f]=n.split(";");switch(f){case p.SetMark:this._createOrGetBufferMarkDetection(this._terminal).addMark();default:{const{key:R,value:x}=w(f);if(x===void 0)return!0;switch(R){case p.CurrentDir:return this._updateCwd(x),!0}}}return!1}_doHandleSetWindowsFriendlyCwd(n){if(!this._terminal)return!1;const[f,...R]=n.split(";");switch(f){case"9":return R.length&&this._updateCwd(R[0]),!0}return!1}_doHandleSetCwd(n){if(!this._terminal)return!1;const[f]=n.split(";");if(f.match(/^file:\/\/.*\//)){const R=h.URI.parse(f);if(R.path&&R.path.length>0)return this._updateCwd(R.path),!0}return!1}serialize(){return!this._terminal||!this.capabilities.has(P.TerminalCapability.CommandDetection)?{isWindowsPty:!1,commands:[],promptInputModel:void 0}:this._createOrGetCommandDetection(this._terminal).serialize()}deserialize(n){if(!this._terminal)throw new Error("Cannot restore commands before addon is activated");this._createOrGetCommandDetection(this._terminal).deserialize(n)}_createOrGetCwdDetection(){let n=this.capabilities.get(P.TerminalCapability.CwdDetection);return n||(n=this._register(new W.CwdDetectionCapability),this.capabilities.add(P.TerminalCapability.CwdDetection,n)),n}_createOrGetCommandDetection(n){let f=this.capabilities.get(P.TerminalCapability.CommandDetection);return f||(f=this._register(new m.CommandDetectionCapability(n,this._logService)),this.capabilities.add(P.TerminalCapability.CommandDetection,f)),f}_createOrGetBufferMarkDetection(n){let f=this.capabilities.get(P.TerminalCapability.BufferMarkDetection);return f||(f=this._register(new b.BufferMarkCapability(n)),this.capabilities.add(P.TerminalCapability.BufferMarkDetection,f)),f}}e.ShellIntegrationAddon=r;function y(i){return i.replaceAll(/\\(\\|x([0-9a-f]{2}))/gi,(n,f,R)=>R?String.fromCharCode(parseInt(R,16)):f)}function w(i){const n=i.indexOf("=");return n===-1?{key:i,value:void 0}:{key:i.substring(0,n),value:i.substring(1+n)}}function C(i){let n,f=!1;for(const R of i)R!==void 0&&(R==="Hidden"&&(f=!0),R.startsWith("Id=")&&(n=R.substring(3)));return{id:n,hidden:f}}}),define(he[42],fe([0,1,5,14,4,2,64,9]),function(ie,e,o,t,L,m,W,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ChildProcessMonitor=e.ignoreProcessNames=void 0;var _;(function(b){b[b.InactiveThrottleDuration=5e3]="InactiveThrottleDuration",b[b.ActiveDebounceDuration=1e3]="ActiveDebounceDuration"})(_||(_={})),e.ignoreProcessNames=[];let s=class extends m.Disposable{set hasChildProcesses(h){this._hasChildProcesses!==h&&(this._hasChildProcesses=h,this._logService.debug("ChildProcessMonitor: Has child processes changed",h),this._onDidChangeHasChildProcesses.fire(h))}get hasChildProcesses(){return this._hasChildProcesses}constructor(h,g){super(),this._pid=h,this._logService=g,this._hasChildProcesses=!1,this._onDidChangeHasChildProcesses=this._register(new L.Emitter),this.onDidChangeHasChildProcesses=this._onDidChangeHasChildProcesses.event}handleInput(){this._refreshActive()}handleOutput(){this._refreshInactive()}async _refreshActive(){if(!this._store.isDisposed)try{const h=await(0,W.listProcesses)(this._pid);this.hasChildProcesses=this._processContainsChildren(h)}catch(h){this._logService.debug("ChildProcessMonitor: Fetching process tree failed",h)}}_refreshInactive(){this._refreshActive()}_processContainsChildren(h){if(!h.children)return!1;if(h.children.length===1){const g=h.children[0];let l;if(g.cmd.startsWith('"'))l=g.cmd.substring(1,g.cmd.indexOf('"',1));else{const u=g.cmd.indexOf(" ");u===-1?l=g.cmd:l=g.cmd.substring(0,u)}return e.ignoreProcessNames.indexOf((0,o.parse)(l).name)===-1}return h.children.length>0}};e.ChildProcessMonitor=s,ge([(0,t.debounce)(_.ActiveDebounceDuration)],s.prototype,"_refreshActive",null),ge([(0,t.throttle)(_.InactiveThrottleDuration)],s.prototype,"_refreshInactive",null),e.ChildProcessMonitor=s=ge([We(1,P.ILogService)],s)}),define(he[97],fe([0,1,4,2,16]),function(ie,e,o,t,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.HeartbeatService=void 0;class m extends t.Disposable{constructor(){super(),this._onBeat=this._register(new o.Emitter),this.onBeat=this._onBeat.event;const P=setInterval(()=>{this._onBeat.fire()},L.HeartbeatConstants.BeatInterval);this._register((0,t.toDisposable)(()=>clearInterval(P)))}}e.HeartbeatService=m}),define(he[43],fe([0,1,21,20,32,5,3,15,11,10,28,40,90,89]),function(ie,e,o,t,L,m,W,P,_,s,b,h,g,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWindowsBuildNumber=u,e.findExecutable=a,e.getShellIntegrationInjection=d,o=Pe(o),m=Pe(m),P=Pe(P),b=Pe(b);function u(){const v=/(\d+)\.(\d+)\.(\d+)/g.exec(o.release());let S=0;return v&&v.length===4&&(S=parseInt(v[3])),S}async function a(v,S,T,O=P.env,F=b.Promises.exists){if(m.isAbsolute(v))return await F(v)?v:void 0;if(S===void 0&&(S=P.cwd()),m.dirname(v)!=="."){const A=m.join(S,v);return await F(A)?A:void 0}const E=(0,L.getCaseInsensitive)(O,"PATH");if(T===void 0&&(0,s.isString)(E)&&(T=E.split(m.delimiter)),T===void 0||T.length===0){const A=m.join(S,v);return await F(A)?A:void 0}for(const A of T){let I;if(m.isAbsolute(A)?I=m.join(A,v):I=m.join(S,A,v),await F(I))return I;if(W.isWindows){let B=I+".com";if(await F(B)||(B=I+".exe",await F(B)))return B}}const M=m.join(S,v);return await F(M)?M:void 0}function d(v,S,T,O,F){const D=W.isWindows&&(!S.windowsEnableConpty||u()<18309);if(!S.shellIntegration.enabled||!v.executable||v.isFeatureTerminal&&!v.forceShellIntegration||v.ignoreShellIntegration||D)return;const E=v.args,M=P.platform==="win32"?m.basename(v.executable).toLowerCase():m.basename(v.executable),A=m.dirname(t.FileAccess.asFileUri("").fsPath);let I;const B={VSCODE_INJECTION:"1"};if(S.shellIntegration.nonce&&(B.VSCODE_NONCE=S.shellIntegration.nonce),W.isWindows){if(M==="pwsh.exe"||M==="powershell.exe")return!E||R(E)?I=y.get(r.WindowsPwsh):f(E)&&(I=y.get(r.WindowsPwshLogin)),I?(I=[...I],I[I.length-1]=(0,_.format)(I[I.length-1],A,""),B.VSCODE_STABLE=F.quality==="stable"?"1":"0",S.shellIntegration.suggestEnabled&&(B.VSCODE_SUGGEST="1"),{newArgs:I,envMixin:B}):void 0;if(M==="bash.exe")return!E||E.length===0?I=y.get(r.Bash):x(E)&&(B.VSCODE_SHELL_LOGIN="1",p(S,B),I=y.get(r.Bash)),I?(I=[...I],I[I.length-1]=(0,_.format)(I[I.length-1],A),B.VSCODE_STABLE=F.quality==="stable"?"1":"0",{newArgs:I,envMixin:B}):void 0;O.warn(`Shell integration cannot be enabled for executable "${v.executable}" and args`,v.args);return}switch(M){case"bash":return!E||E.length===0?I=y.get(r.Bash):x(E)&&(B.VSCODE_SHELL_LOGIN="1",p(S,B),I=y.get(r.Bash)),I?(I=[...I],I[I.length-1]=(0,_.format)(I[I.length-1],A),B.VSCODE_STABLE=F.quality==="stable"?"1":"0",{newArgs:I,envMixin:B}):void 0;case"fish":{const Y=T?.XDG_DATA_DIRS??"/usr/local/share:/usr/share",G=m.join(A,"out/vs/workbench/contrib/terminal/browser/media/fish_xdg_data");return B.XDG_DATA_DIRS=`${Y}:${G}`,p(S,B),{newArgs:void 0,envMixin:B}}case"pwsh":return!E||R(E)?I=y.get(r.Pwsh):f(E)&&(I=y.get(r.PwshLogin)),I?(S.shellIntegration.suggestEnabled&&(B.VSCODE_SUGGEST="1"),I=[...I],I[I.length-1]=(0,_.format)(I[I.length-1],A,""),B.VSCODE_STABLE=F.quality==="stable"?"1":"0",{newArgs:I,envMixin:B}):void 0;case"zsh":{if(!E||E.length===0?I=y.get(r.Zsh):x(E)?(I=y.get(r.ZshLogin),p(S,B)):(E===y.get(r.Zsh)||E===y.get(r.ZshLogin))&&(I=E),!I)return;I=[...I],I[I.length-1]=(0,_.format)(I[I.length-1],A);let Y;try{Y=o.userInfo().username}catch{Y="unknown"}const G=m.join(o.tmpdir(),`${Y}-${F.applicationName}-zsh`);B.ZDOTDIR=G;const Z=T?.ZDOTDIR??o.homedir()??"~";B.USER_ZDOTDIR=Z;const se=[];return se.push({source:m.join(A,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-rc.zsh"),dest:m.join(G,".zshrc")}),se.push({source:m.join(A,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-profile.zsh"),dest:m.join(G,".zprofile")}),se.push({source:m.join(A,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-env.zsh"),dest:m.join(G,".zshenv")}),se.push({source:m.join(A,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-login.zsh"),dest:m.join(G,".zlogin")}),{newArgs:I,envMixin:B,filesToCopy:se}}}O.warn(`Shell integration cannot be enabled for executable "${v.executable}" and args`,v.args)}function p(v,S){if(W.isMacintosh&&v.environmentVariableCollections){const T=(0,g.deserializeEnvironmentVariableCollections)(v.environmentVariableCollections),F=new l.MergedEnvironmentVariableCollection(T).getVariableMap({workspaceFolder:v.workspaceFolder}).get("PATH"),D=[];if(F)for(const E of F)E.type===h.EnvironmentVariableMutatorType.Prepend&&D.push(E.value);D.length>0&&(S.VSCODE_PATH_PREFIX=D.join(""))}}var r;(function(v){v.WindowsPwsh="windows-pwsh",v.WindowsPwshLogin="windows-pwsh-login",v.Pwsh="pwsh",v.PwshLogin="pwsh-login",v.Zsh="zsh",v.ZshLogin="zsh-login",v.Bash="bash"})(r||(r={}));const y=new Map;y.set(r.WindowsPwsh,["-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),y.set(r.WindowsPwshLogin,["-l","-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),y.set(r.Pwsh,["-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"{1}']),y.set(r.PwshLogin,["-l","-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"']),y.set(r.Zsh,["-i"]),y.set(r.ZshLogin,["-il"]),y.set(r.Bash,["--init-file","{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration-bash.sh"]);const w=["-login","-l"],C=["--login","-l"],i=["-i","--interactive"],n=["-nol","-nologo"];function f(v){return typeof v=="string"?w.includes(v.toLowerCase()):v.length===1&&w.includes(v[0].toLowerCase())||v.length===2&&(w.includes(v[0].toLowerCase())||w.includes(v[1].toLowerCase()))&&(n.includes(v[0].toLowerCase())||n.includes(v[1].toLowerCase()))}function R(v){return typeof v=="string"?n.includes(v.toLowerCase()):v.length===0||v?.length===1&&n.includes(v[0].toLowerCase())}function x(v){return typeof v!="string"&&(v=v.filter(S=>!i.includes(S.toLowerCase()))),v==="string"&&C.includes(v.toLowerCase())||typeof v!="string"&&v.length===1&&C.includes(v[0].toLowerCase())}}),define(he[98],fe([0,1,12,14,4,2,3,16]),function(ie,e,o,t,L,m,W,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowsShellHelper=void 0;const _=["cmd.exe","powershell.exe","pwsh.exe","bash.exe","wsl.exe","ubuntu.exe","ubuntu1804.exe","kali.exe","debian.exe","opensuse-42.exe","sles-12.exe"];let s;class b extends m.Disposable{get shellType(){return this._shellType}get shellTitle(){return this._shellTitle}get onShellNameChanged(){return this._onShellNameChanged.event}get onShellTypeChanged(){return this._onShellTypeChanged.event}constructor(g){if(super(),this._rootProcessId=g,this._shellTitle="",this._onShellNameChanged=new L.Emitter,this._onShellTypeChanged=new L.Emitter,!W.isWindows)throw new Error(`WindowsShellHelper cannot be instantiated on ${W.platform}`);this._startMonitoringShell()}async _startMonitoringShell(){this._store.isDisposed||this.checkShell()}async checkShell(){W.isWindows&&(await(0,o.timeout)(300),this.getShellName().then(g=>{const l=this.getShellType(g);l!==this._shellType&&(this._onShellTypeChanged.fire(l),this._onShellNameChanged.fire(g),this._shellType=l,this._shellTitle=g)}))}traverseTree(g){if(!g)return"";if(_.indexOf(g.name)===-1||!g.children||g.children.length===0)return g.name;let l=0;for(;l<g.children.length;l++){const u=g.children[l];if(!u.children||u.children.length===0||u.children[0].name!=="conhost.exe")break}return l>=g.children.length?g.name:this.traverseTree(g.children[l])}async getShellName(){return this._store.isDisposed?Promise.resolve(""):this._currentRequest?this._currentRequest:(s||(s=await new Promise((g,l)=>{ie(["@vscode/windows-process-tree"],g,l)}).then(Pe)),this._currentRequest=new Promise(g=>{s.getProcessTree(this._rootProcessId,l=>{const u=this.traverseTree(l);this._currentRequest=void 0,g(u)})}),this._currentRequest)}getShellType(g){switch(g.toLowerCase()){case"cmd.exe":return P.WindowsShellType.CommandPrompt;case"powershell.exe":case"pwsh.exe":return P.GeneralShellType.PowerShell;case"bash.exe":case"git-cmd.exe":return P.WindowsShellType.GitBash;case"julia.exe:":return P.GeneralShellType.Julia;case"nu.exe":return P.GeneralShellType.NuShell;case"wsl.exe":case"ubuntu.exe":case"ubuntu1804.exe":case"kali.exe":case"debian.exe":case"opensuse-42.exe":case"sles-12.exe":return P.WindowsShellType.Wsl;default:return g.match(/python(\d(\.\d{0,2})?)?\.exe/)?P.GeneralShellType.Python:void 0}}}e.WindowsShellHelper=b,ge([(0,t.debounce)(500)],b.prototype,"checkShell",null)}),define(he[99],fe([0,1,37,29,12,4,2,5,3,6,8,9,80,16,42,43,98,103,94]),function(ie,e,o,t,L,m,W,P,_,s,b,h,g,l,u,a,d,p,r){"use strict";var y;Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalProcess=void 0,o=Pe(o),P=Pe(P);var w;(function(x){x[x.DataFlushTimeout=250]="DataFlushTimeout",x[x.MaximumShutdownTime=5e3]="MaximumShutdownTime"})(w||(w={}));var C;(function(x){x[x.KillSpawnThrottleInterval=250]="KillSpawnThrottleInterval",x[x.KillSpawnSpacingDuration=50]="KillSpawnSpacingDuration",x[x.WriteInterval=5]="WriteInterval"})(C||(C={}));const i=new Map([["bash",l.PosixShellType.Bash],["csh",l.PosixShellType.Csh],["fish",l.PosixShellType.Fish],["ksh",l.PosixShellType.Ksh],["sh",l.PosixShellType.Sh],["zsh",l.PosixShellType.Zsh]]),n=new Map([["pwsh",l.GeneralShellType.PowerShell],["python",l.GeneralShellType.Python],["julia",l.GeneralShellType.Julia],["nu",l.GeneralShellType.NuShell]]);let f=class extends W.Disposable{static{y=this}static{this._lastKillOrStart=0}get exitMessage(){return this._exitMessage}get currentTitle(){return this._windowsShellHelper?.shellTitle||this._currentTitle}get shellType(){return _.isWindows?this._windowsShellHelper?.shellType:i.get(this._currentTitle)||n.get(this._currentTitle)}get hasChildProcesses(){return this._childProcessMonitor?.hasChildProcesses||!1}constructor(v,S,T,O,F,D,E,M,A){super(),this.shellLaunchConfig=v,this._executableEnv=D,this._options=E,this._logService=M,this._productService=A,this.id=0,this.shouldPersist=!1,this._properties={cwd:"",initialCwd:"",fixedDimensions:{cols:void 0,rows:void 0},title:"",shellType:void 0,hasChildProcesses:!0,resolvedShellLaunchConfig:{},overrideDimensions:void 0,failedShellIntegrationActivation:!1,usedShellIntegrationInjection:void 0},this._currentTitle="",this._titleInterval=null,this._writeQueue=[],this._isPtyPaused=!1,this._unacknowledgedCharCount=0,this._onProcessData=this._register(new m.Emitter),this.onProcessData=this._onProcessData.event,this._onProcessReady=this._register(new m.Emitter),this.onProcessReady=this._onProcessReady.event,this._onDidChangeProperty=this._register(new m.Emitter),this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=this._register(new m.Emitter),this.onProcessExit=this._onProcessExit.event;let I;_.isWindows?I=P.basename(this.shellLaunchConfig.executable||""):I="xterm-256color",this._initialCwd=S,this._properties[l.ProcessPropertyType.InitialCwd]=this._initialCwd,this._properties[l.ProcessPropertyType.Cwd]=this._initialCwd;const B=this._options.windowsEnableConpty&&process.platform==="win32"&&(0,a.getWindowsBuildNumber)()>=18309,Y=B&&this._options.windowsUseConptyDll;this._ptyOptions={name:I,cwd:S,env:F,cols:T,rows:O,useConpty:B,useConptyDll:Y,conptyInheritCursor:B&&!!v.initialText},_.isWindows&&(B&&T===0&&O===0&&this.shellLaunchConfig.executable?.endsWith("Git\\bin\\bash.exe")&&(this._delayedResizer=new R,this._register(this._delayedResizer.onTrigger(G=>{this._delayedResizer?.dispose(),this._delayedResizer=void 0,G.cols&&G.rows&&this.resize(G.cols,G.rows)}))),this.onProcessReady(G=>{this._windowsShellHelper=this._register(new d.WindowsShellHelper(G.pid)),this._register(this._windowsShellHelper.onShellTypeChanged(Z=>this._onDidChangeProperty.fire({type:l.ProcessPropertyType.ShellType,value:Z}))),this._register(this._windowsShellHelper.onShellNameChanged(Z=>this._onDidChangeProperty.fire({type:l.ProcessPropertyType.Title,value:Z})))})),this._register((0,W.toDisposable)(()=>{this._titleInterval&&(clearInterval(this._titleInterval),this._titleInterval=null)}))}async start(){const S=(await Promise.all([this._validateCwd(),this._validateExecutable()])).find(O=>O!==void 0);if(S)return S;let T;if(this._options.shellIntegration.enabled)if(T=(0,a.getShellIntegrationInjection)(this.shellLaunchConfig,this._options,this._ptyOptions.env,this._logService,this._productService),T){if(this._onDidChangeProperty.fire({type:l.ProcessPropertyType.UsedShellIntegrationInjection,value:!0}),T.envMixin)for(const[O,F]of Object.entries(T.envMixin))this._ptyOptions.env||={},this._ptyOptions.env[O]=F;if(T.filesToCopy)for(const O of T.filesToCopy)try{await o.promises.mkdir(P.dirname(O.dest),{recursive:!0}),await o.promises.copyFile(O.source,O.dest)}catch{}}else this._onDidChangeProperty.fire({type:l.ProcessPropertyType.FailedShellIntegrationActivation,value:!0});try{return await this.setupPtyProcess(this.shellLaunchConfig,this._ptyOptions,T),T?.newArgs?{injectedArgs:T.newArgs}:void 0}catch(O){return this._logService.trace("node-pty.node-pty.IPty#spawn native exception",O),{message:`A native exception occurred during launch (${O.message})`}}}async _validateCwd(){try{if(!(await o.promises.stat(this._initialCwd)).isDirectory())return{message:(0,b.localize)(2121,null,this._initialCwd.toString())}}catch(v){if(v?.code==="ENOENT")return{message:(0,b.localize)(2122,null,this._initialCwd.toString())}}this._onDidChangeProperty.fire({type:l.ProcessPropertyType.InitialCwd,value:this._initialCwd})}async _validateExecutable(){const v=this.shellLaunchConfig;if(!v.executable)throw new Error("IShellLaunchConfig.executable not set");const S=v.cwd instanceof s.URI?v.cwd.path:v.cwd,T=v.env&&v.env.PATH?v.env.PATH.split(P.delimiter):void 0,O=await(0,a.findExecutable)(v.executable,S,T,this._executableEnv);if(!O)return{message:(0,b.localize)(2123,null,v.executable)};try{const F=await o.promises.stat(O);if(!F.isFile()&&!F.isSymbolicLink())return{message:(0,b.localize)(2124,null,v.executable)};v.executable=O}catch(F){if(F?.code!=="EACCES")throw F}}async setupPtyProcess(v,S,T){const O=T?.newArgs||v.args||[];await this._throttleKillSpawn(),this._logService.trace("node-pty.IPty#spawn",v.executable,O,S);const F=(0,p.spawn)(v.executable,O,S);this._ptyProcess=F,this._childProcessMonitor=this._register(new u.ChildProcessMonitor(F.pid,this._logService)),this._childProcessMonitor.onDidChangeHasChildProcesses(D=>this._onDidChangeProperty.fire({type:l.ProcessPropertyType.HasChildProcesses,value:D})),this._processStartupComplete=new Promise(D=>{this.onProcessReady(()=>D())}),F.onData(D=>{this._unacknowledgedCharCount+=D.length,!this._isPtyPaused&&this._unacknowledgedCharCount>l.FlowControlConstants.HighWatermarkChars&&(this._logService.trace(`Flow control: Pause (${this._unacknowledgedCharCount} > ${l.FlowControlConstants.HighWatermarkChars})`),this._isPtyPaused=!0,F.pause()),this._logService.trace("node-pty.IPty#onData",D),this._onProcessData.fire(D),this._closeTimeout&&this._queueProcessExit(),this._windowsShellHelper?.checkShell(),this._childProcessMonitor?.handleOutput()}),F.onExit(D=>{this._exitCode=D.exitCode,this._queueProcessExit()}),this._sendProcessId(F.pid),this._setupTitlePolling(F)}_setupTitlePolling(v){setTimeout(()=>this._sendProcessTitle(v)),_.isWindows||(this._titleInterval=setInterval(()=>{this._currentTitle!==v.process&&this._sendProcessTitle(v)},200))}_queueProcessExit(){this._logService.getLevel()===h.LogLevel.Trace&&this._logService.trace("TerminalProcess#_queueProcessExit",new Error().stack?.replace(/^Error/,"")),this._closeTimeout&&clearTimeout(this._closeTimeout),this._closeTimeout=setTimeout(()=>{this._closeTimeout=void 0,this._kill()},w.DataFlushTimeout)}async _kill(){if(await this._processStartupComplete,!this._store.isDisposed){try{this._ptyProcess&&(await this._throttleKillSpawn(),this._logService.trace("node-pty.IPty#kill"),this._ptyProcess.kill())}catch{}this._onProcessExit.fire(this._exitCode||0),this.dispose()}}async _throttleKillSpawn(){if(!(!_.isWindows||!("useConpty"in this._ptyOptions)||!this._ptyOptions.useConpty)){for(;Date.now()-y._lastKillOrStart<C.KillSpawnThrottleInterval;)this._logService.trace("Throttling kill/spawn call"),await(0,L.timeout)(C.KillSpawnThrottleInterval-(Date.now()-y._lastKillOrStart)+C.KillSpawnSpacingDuration);y._lastKillOrStart=Date.now()}}_sendProcessId(v){this._onProcessReady.fire({pid:v,cwd:this._initialCwd,windowsPty:this.getWindowsPty()})}_sendProcessTitle(v){if(this._store.isDisposed)return;this._currentTitle=v.process??"",this._onDidChangeProperty.fire({type:l.ProcessPropertyType.Title,value:this._currentTitle});const S=this.currentTitle.replace(/ \(figterm\)$/g,"");if(S.toLowerCase().startsWith("python"))this._onDidChangeProperty.fire({type:l.ProcessPropertyType.ShellType,value:l.GeneralShellType.Python});else if(S.toLowerCase().startsWith("julia"))this._onDidChangeProperty.fire({type:l.ProcessPropertyType.ShellType,value:l.GeneralShellType.Julia});else{const T=i.get(S)||n.get(S);this._onDidChangeProperty.fire({type:l.ProcessPropertyType.ShellType,value:T})}}shutdown(v){this._logService.getLevel()===h.LogLevel.Trace&&this._logService.trace("TerminalProcess#shutdown",new Error().stack?.replace(/^Error/,"")),v&&!_.isWindows?this._kill():!this._closeTimeout&&!this._store.isDisposed&&(this._queueProcessExit(),setTimeout(()=>{this._closeTimeout&&!this._store.isDisposed&&(this._closeTimeout=void 0,this._kill())},w.MaximumShutdownTime))}input(v,S=!1){this._store.isDisposed||!this._ptyProcess||(this._writeQueue.push(...(0,r.chunkInput)(v).map(T=>({isBinary:S,data:T}))),this._startWrite())}async processBinary(v){this.input(v,!0)}async refreshProperty(v){switch(v){case l.ProcessPropertyType.Cwd:{const S=await this.getCwd();return S!==this._properties.cwd&&(this._properties.cwd=S,this._onDidChangeProperty.fire({type:l.ProcessPropertyType.Cwd,value:this._properties.cwd})),S}case l.ProcessPropertyType.InitialCwd:{const S=await this.getInitialCwd();return S!==this._properties.initialCwd&&(this._properties.initialCwd=S,this._onDidChangeProperty.fire({type:l.ProcessPropertyType.InitialCwd,value:this._properties.initialCwd})),S}case l.ProcessPropertyType.Title:return this.currentTitle;default:return this.shellType}}async updateProperty(v,S){v===l.ProcessPropertyType.FixedDimensions&&(this._properties.fixedDimensions=S)}_startWrite(){if(!(this._writeTimeout!==void 0||this._writeQueue.length===0)){if(this._doWrite(),this._writeQueue.length===0){this._writeTimeout=void 0;return}this._writeTimeout=setTimeout(()=>{this._writeTimeout=void 0,this._startWrite()},C.WriteInterval)}}_doWrite(){const v=this._writeQueue.shift();this._logService.trace("node-pty.IPty#write",v.data),v.isBinary?this._ptyProcess.write(Buffer.from(v.data,"binary")):this._ptyProcess.write(v.data),this._childProcessMonitor?.handleInput()}resize(v,S){if(!this._store.isDisposed&&!(typeof v!="number"||typeof S!="number"||isNaN(v)||isNaN(S))&&this._ptyProcess){if(v=Math.max(v,1),S=Math.max(S,1),this._delayedResizer){this._delayedResizer.cols=v,this._delayedResizer.rows=S;return}this._logService.trace("node-pty.IPty#resize",v,S);try{this._ptyProcess.resize(v,S)}catch(T){if(this._logService.trace("node-pty.IPty#resize exception "+T.message),this._exitCode!==void 0&&T.message!=="ioctl(2) failed, EBADF"&&T.message!=="Cannot resize a pty that has already exited")throw T}}}clearBuffer(){this._ptyProcess?.clear()}acknowledgeDataEvent(v){this._unacknowledgedCharCount=Math.max(this._unacknowledgedCharCount-v,0),this._logService.trace(`Flow control: Ack ${v} chars (unacknowledged: ${this._unacknowledgedCharCount})`),this._isPtyPaused&&this._unacknowledgedCharCount<l.FlowControlConstants.LowWatermarkChars&&(this._logService.trace(`Flow control: Resume (${this._unacknowledgedCharCount} < ${l.FlowControlConstants.LowWatermarkChars})`),this._ptyProcess?.resume(),this._isPtyPaused=!1)}clearUnacknowledgedChars(){this._unacknowledgedCharCount=0,this._logService.trace("Flow control: Cleared all unacknowledged chars, forcing resume"),this._isPtyPaused&&(this._ptyProcess?.resume(),this._isPtyPaused=!1)}async setUnicodeVersion(v){}getInitialCwd(){return Promise.resolve(this._initialCwd)}async getCwd(){if(_.isMacintosh)return new Promise(v=>{if(!this._ptyProcess){v(this._initialCwd);return}this._logService.trace("node-pty.IPty#pid"),(0,t.exec)("lsof -OPln -p "+this._ptyProcess.pid+" | grep cwd",{env:{...process.env,LANG:"en_US.UTF-8"}},(S,T,O)=>{!S&&T!==""?v(T.substring(T.indexOf("/"),T.length-1)):(this._logService.error("lsof did not run successfully, it may not be on the $PATH?",S,T,O),v(this._initialCwd))})});if(_.isLinux){if(!this._ptyProcess)return this._initialCwd;this._logService.trace("node-pty.IPty#pid");try{return await o.promises.readlink(`/proc/${this._ptyProcess.pid}/cwd`)}catch{return this._initialCwd}}return this._initialCwd}getWindowsPty(){return _.isWindows?{backend:"useConpty"in this._ptyOptions&&this._ptyOptions.useConpty?"conpty":"winpty",buildNumber:(0,a.getWindowsBuildNumber)()}:void 0}};e.TerminalProcess=f,e.TerminalProcess=f=y=ge([We(7,h.ILogService),We(8,g.IProductService)],f);class R extends W.Disposable{get onTrigger(){return this._onTrigger.event}constructor(){super(),this._onTrigger=this._register(new m.Emitter),this._timeout=setTimeout(()=>{this._onTrigger.fire({rows:this.rows,cols:this.cols})},1e3),this._register((0,W.toDisposable)(()=>clearTimeout(this._timeout)))}}}),define(he[100],fe([0,1,29,12,4,2,3,65,9,91,16,93,41,43,99,8,42,92,7,96,95,72,14,104,105]),function(ie,e,o,t,L,m,W,P,_,s,b,h,g,l,u,a,d,p,r,y,w,C,i,n,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PtyService=void 0,e.traceRpc=R,n=Pe(n);function R(M,A,I){if(typeof I.value!="function")throw new Error("not supported");const B="value",Y=I.value;I[B]=async function(...G){this.traceRpcArgs.logService.getLevel()===_.LogLevel.Trace&&this.traceRpcArgs.logService.trace(`[RPC Request] PtyService#${Y.name}(${G.map(se=>JSON.stringify(se)).join(", ")})`),this.traceRpcArgs.simulatedLatency&&await(0,t.timeout)(this.traceRpcArgs.simulatedLatency);let Z;try{Z=await Y.apply(this,G)}catch(se){throw this.traceRpcArgs.logService.error(`[RPC Response] PtyService#${Y.name}`,se),se}return this.traceRpcArgs.logService.getLevel()===_.LogLevel.Trace&&this.traceRpcArgs.logService.trace(`[RPC Response] PtyService#${Y.name}`,Z),Z}}let x,v;class S extends m.Disposable{_traceEvent(A,I){return I(B=>{this._logService.getLevel()===_.LogLevel.Trace&&this._logService.trace(`[RPC Event] PtyService#${A}.fire(${JSON.stringify(B)})`)}),I}get traceRpcArgs(){return{logService:this._logService,simulatedLatency:this._simulatedLatency}}constructor(A,I,B,Y){super(),this._logService=A,this._productService=I,this._reconnectConstants=B,this._simulatedLatency=Y,this._ptys=new Map,this._workspaceLayoutInfos=new Map,this._revivedPtyIdMap=new Map,this._autoReplies=new Map,this._lastPtyId=0,this._onHeartbeat=this._register(new L.Emitter),this.onHeartbeat=this._traceEvent("_onHeartbeat",this._onHeartbeat.event),this._onProcessData=this._register(new L.Emitter),this.onProcessData=this._traceEvent("_onProcessData",this._onProcessData.event),this._onProcessReplay=this._register(new L.Emitter),this.onProcessReplay=this._traceEvent("_onProcessReplay",this._onProcessReplay.event),this._onProcessReady=this._register(new L.Emitter),this.onProcessReady=this._traceEvent("_onProcessReady",this._onProcessReady.event),this._onProcessExit=this._register(new L.Emitter),this.onProcessExit=this._traceEvent("_onProcessExit",this._onProcessExit.event),this._onProcessOrphanQuestion=this._register(new L.Emitter),this.onProcessOrphanQuestion=this._traceEvent("_onProcessOrphanQuestion",this._onProcessOrphanQuestion.event),this._onDidRequestDetach=this._register(new L.Emitter),this.onDidRequestDetach=this._traceEvent("_onDidRequestDetach",this._onDidRequestDetach.event),this._onDidChangeProperty=this._register(new L.Emitter),this.onDidChangeProperty=this._traceEvent("_onDidChangeProperty",this._onDidChangeProperty.event),this._register((0,m.toDisposable)(()=>{for(const G of this._ptys.values())G.shutdown(!0);this._ptys.clear()})),this._detachInstanceRequestStore=this._register(new s.RequestStore(void 0,this._logService)),this._detachInstanceRequestStore.onCreateRequest(this._onDidRequestDetach.fire,this._onDidRequestDetach)}async refreshIgnoreProcessNames(A){d.ignoreProcessNames.length=0,d.ignoreProcessNames.push(...A)}async requestDetachInstance(A,I){return this._detachInstanceRequestStore.createRequest({workspaceId:A,instanceId:I})}async acceptDetachInstanceReply(A,I){let B;const Y=this._ptys.get(I);Y&&(B=await this._buildProcessDetails(I,Y)),this._detachInstanceRequestStore.acceptReply(A,B)}async freePortKillProcess(A){const B=(await new Promise((Y,G)=>{(0,o.exec)(W.isWindows?`netstat -ano | findstr "${A}"`:`lsof -nP -iTCP -sTCP:LISTEN | grep ${A}`,{},(Z,se)=>{if(Z)return G("Problem occurred when listing active processes");Y(se)})})).split(/\r?\n/).filter(Y=>!!Y.trim());if(B.length>=1){const Y=/\s+(\d+)(?:\s+|$)/,G=B[0].match(Y)?.[1];if(G)try{process.kill(Number.parseInt(G))}catch{}else throw new Error(`Processes for port ${A} were not found`);return{port:A,processId:G}}throw new Error(`Could not kill process with port ${A}`)}async serializeTerminalState(A){const I=[];for(const[Y,G]of this._ptys.entries())G.hasWrittenData&&A.indexOf(Y)!==-1&&I.push(t.Promises.withAsyncBody(async Z=>{Z({id:Y,shellLaunchConfig:G.shellLaunchConfig,processDetails:await this._buildProcessDetails(Y,G),processLaunchConfig:G.processLaunchOptions,unicodeVersion:G.unicodeVersion,replayEvent:await G.serializeNormalBuffer(),timestamp:Date.now()})}));const B={version:1,state:await Promise.all(I)};return JSON.stringify(B)}async reviveTerminalProcesses(A,I,B){const Y=[];for(const G of I)Y.push(this._reviveTerminalProcess(A,G));await Promise.all(Y)}async _reviveTerminalProcess(A,I){const B=(0,a.localize)(2120,null),Y=await this.createProcess({...I.shellLaunchConfig,cwd:I.processDetails.cwd,color:I.processDetails.color,icon:I.processDetails.icon,name:I.processDetails.titleSource===b.TitleEventSource.Api?I.processDetails.title:void 0,initialText:I.replayEvent.events[0].data+(0,w.formatMessageForTerminal)(B,{loudFormatting:!0})},I.processDetails.cwd,I.replayEvent.events[0].cols,I.replayEvent.events[0].rows,I.unicodeVersion,I.processLaunchConfig.env,I.processLaunchConfig.executableEnv,I.processLaunchConfig.options,!0,I.processDetails.workspaceId,I.processDetails.workspaceName,!0,I.replayEvent.events[0].data),G=this._getRevivingProcessId(A,I.id);this._revivedPtyIdMap.set(G,{newId:Y,state:I}),this._logService.info(`Revived process, old id ${G} -> new id ${Y}`)}async shutdownAll(){this.dispose()}async createProcess(A,I,B,Y,G,Z,se,le,V,z,Q,ee,ue){if(A.attachPersistentProcess)throw new Error("Attempt to create a process when attach object was provided");const $=++this._lastPtyId,ae=new u.TerminalProcess(A,I,B,Y,Z,se,le,this._logService,this._productService),de={env:Z,executableEnv:se,options:le},te=new O($,ae,z,Q,V,B,Y,de,G,this._reconnectConstants,this._logService,ee&&typeof A.initialText=="string"?A.initialText:void 0,ue,A.icon,A.color,A.name,A.fixedDimensions);return ae.onProcessExit(c=>{te.dispose(),this._ptys.delete($),this._onProcessExit.fire({id:$,event:c})}),te.onProcessData(c=>this._onProcessData.fire({id:$,event:c})),te.onProcessReplay(c=>this._onProcessReplay.fire({id:$,event:c})),te.onProcessReady(c=>this._onProcessReady.fire({id:$,event:c})),te.onProcessOrphanQuestion(()=>this._onProcessOrphanQuestion.fire({id:$})),te.onDidChangeProperty(c=>this._onDidChangeProperty.fire({id:$,property:c})),te.onPersistentProcessReady(()=>{for(const c of this._autoReplies.entries())te.installAutoReply(c[0],c[1])}),this._ptys.set($,te),$}async attachToProcess(A){try{await this._throwIfNoPty(A).attach(),this._logService.info(`Persistent process reconnection "${A}"`)}catch(I){throw this._logService.warn(`Persistent process reconnection "${A}" failed`,I.message),I}}async updateTitle(A,I,B){this._throwIfNoPty(A).setTitle(I,B)}async updateIcon(A,I,B,Y){this._throwIfNoPty(A).setIcon(I,B,Y)}async clearBuffer(A){this._throwIfNoPty(A).clearBuffer()}async refreshProperty(A,I){return this._throwIfNoPty(A).refreshProperty(I)}async updateProperty(A,I,B){return this._throwIfNoPty(A).updateProperty(I,B)}async detachFromProcess(A,I){return this._throwIfNoPty(A).detach(I)}async reduceConnectionGraceTime(){for(const A of this._ptys.values())A.reduceGraceTime()}async listProcesses(){const A=Array.from(this._ptys.entries()).filter(([Y,G])=>G.shouldPersistTerminal);this._logService.info(`Listing ${A.length} persistent terminals, ${this._ptys.size} total terminals`);const I=A.map(async([Y,G])=>this._buildProcessDetails(Y,G));return(await Promise.all(I)).filter(Y=>Y.isOrphan)}async getPerformanceMarks(){return n.getMarks()}async start(A){const I=this._ptys.get(A);return I?I.start():{message:`Could not find pty with id "${A}"`}}async shutdown(A,I){return this._ptys.get(A)?.shutdown(I)}async input(A,I){return this._throwIfNoPty(A).input(I)}async processBinary(A,I){return this._throwIfNoPty(A).writeBinary(I)}async resize(A,I,B){return this._throwIfNoPty(A).resize(I,B)}async getInitialCwd(A){return this._throwIfNoPty(A).getInitialCwd()}async getCwd(A){return this._throwIfNoPty(A).getCwd()}async acknowledgeDataEvent(A,I){return this._throwIfNoPty(A).acknowledgeDataEvent(I)}async setUnicodeVersion(A,I){return this._throwIfNoPty(A).setUnicodeVersion(I)}async getLatency(){return[]}async orphanQuestionReply(A){return this._throwIfNoPty(A).orphanQuestionReply()}async installAutoReply(A,I){this._autoReplies.set(A,I);for(const B of this._ptys.values())B.installAutoReply(A,I)}async uninstallAllAutoReplies(){for(const A of this._autoReplies.keys())for(const I of this._ptys.values())I.uninstallAutoReply(A)}async uninstallAutoReply(A){for(const I of this._ptys.values())I.uninstallAutoReply(A)}async getDefaultSystemShell(A=W.OS){return(0,P.getSystemShell)(A,process.env)}async getEnvironment(){return{...process.env}}async getWslPath(A,I){if(I==="win-to-unix"){if(!W.isWindows)return A;if((0,l.getWindowsBuildNumber)()<17063)return A.replace(/\\/g,"/");const B=this._getWSLExecutablePath();return B?new Promise(Y=>{(0,o.execFile)(B,["-e","wslpath",A],{},(Z,se,le)=>{Y(Z?A:(0,g.escapeNonWindowsPath)(se.trim()))}).stdin.end()}):A}if(I==="unix-to-win"&&W.isWindows){if((0,l.getWindowsBuildNumber)()<17063)return A;const B=this._getWSLExecutablePath();return B?new Promise(Y=>{(0,o.execFile)(B,["-e","wslpath","-w",A],{},(Z,se,le)=>{Y(Z?A:se.trim())}).stdin.end()}):A}return A}_getWSLExecutablePath(){const A=(0,l.getWindowsBuildNumber)()>=16299,I=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),B=process.env.SystemRoot;if(B)return(0,C.join)(B,I?"Sysnative":"System32",A?"wsl.exe":"bash.exe")}async getRevivedPtyNewId(A,I){try{return this._revivedPtyIdMap.get(this._getRevivingProcessId(A,I))?.newId}catch(B){this._logService.warn(`Couldn't find terminal ID ${A}-${I}`,B.message)}}async setTerminalLayoutInfo(A){this._workspaceLayoutInfos.set(A.workspaceId,A)}async getTerminalLayoutInfo(A){n.mark("code/willGetTerminalLayoutInfo");const I=this._workspaceLayoutInfos.get(A.workspaceId);if(I){const B=new Set,G=(await Promise.all(I.tabs.map(async Z=>this._expandTerminalTab(A.workspaceId,Z,B)))).filter(Z=>Z.terminals.length>0);return n.mark("code/didGetTerminalLayoutInfo"),{tabs:G}}n.mark("code/didGetTerminalLayoutInfo")}async _expandTerminalTab(A,I,B){const G=(await Promise.all(I.terminals.map(Z=>this._expandTerminalInstance(A,Z,B)))).filter(Z=>Z.terminal!==null);return{isActive:I.isActive,activePersistentProcessId:I.activePersistentProcessId,terminals:G}}async _expandTerminalInstance(A,I,B){try{const Y=this._getRevivingProcessId(A,I.terminal),G=this._revivedPtyIdMap.get(Y)?.newId;this._logService.info(`Expanding terminal instance, old id ${Y} -> new id ${G}`),this._revivedPtyIdMap.delete(Y);const Z=G??I.terminal;if(B.has(Z))throw new Error(`Terminal ${Z} has already been expanded`);B.add(Z);const se=this._throwIfNoPty(Z);return{terminal:{...se&&await this._buildProcessDetails(I.terminal,se,G!==void 0),id:Z},relativeSize:I.relativeSize}}catch(Y){return this._logService.warn("Couldn't get layout info, a terminal was probably disconnected",Y.message),this._logService.debug("Reattach to wrong terminal debug info - layout info by id",I),this._logService.debug("Reattach to wrong terminal debug info - _revivePtyIdMap",Array.from(this._revivedPtyIdMap.values())),this._logService.debug("Reattach to wrong terminal debug info - _ptys ids",Array.from(this._ptys.keys())),{terminal:null,relativeSize:I.relativeSize}}}_getRevivingProcessId(A,I){return`${A}-${I}`}async _buildProcessDetails(A,I,B=!1){n.mark(`code/willBuildProcessDetails/${A}`);const[Y,G]=await Promise.all([I.getCwd(),B?!0:I.isOrphaned()]),Z={id:A,title:I.title,titleSource:I.titleSource,pid:I.pid,workspaceId:I.workspaceId,workspaceName:I.workspaceName,cwd:Y,isOrphan:G,icon:I.icon,color:I.color,fixedDimensions:I.fixedDimensions,environmentVariableCollections:I.processLaunchOptions.options.environmentVariableCollections,reconnectionProperties:I.shellLaunchConfig.reconnectionProperties,waitOnExit:I.shellLaunchConfig.waitOnExit,hideFromUser:I.shellLaunchConfig.hideFromUser,isFeatureTerminal:I.shellLaunchConfig.isFeatureTerminal,type:I.shellLaunchConfig.type,hasChildProcesses:I.hasChildProcesses,shellIntegrationNonce:I.processLaunchOptions.options.shellIntegration.nonce};return n.mark(`code/didBuildProcessDetails/${A}`),Z}_throwIfNoPty(A){const I=this._ptys.get(A);if(!I)throw new r.ErrorNoTelemetry("Could not find pty on pty host");return I}}e.PtyService=S,ge([i.memoize],S.prototype,"traceRpcArgs",null),ge([R],S.prototype,"refreshIgnoreProcessNames",null),ge([R],S.prototype,"requestDetachInstance",null),ge([R],S.prototype,"acceptDetachInstanceReply",null),ge([R],S.prototype,"freePortKillProcess",null),ge([R],S.prototype,"serializeTerminalState",null),ge([R],S.prototype,"reviveTerminalProcesses",null),ge([R],S.prototype,"shutdownAll",null),ge([R],S.prototype,"createProcess",null),ge([R],S.prototype,"attachToProcess",null),ge([R],S.prototype,"updateTitle",null),ge([R],S.prototype,"updateIcon",null),ge([R],S.prototype,"clearBuffer",null),ge([R],S.prototype,"refreshProperty",null),ge([R],S.prototype,"updateProperty",null),ge([R],S.prototype,"detachFromProcess",null),ge([R],S.prototype,"reduceConnectionGraceTime",null),ge([R],S.prototype,"listProcesses",null),ge([R],S.prototype,"getPerformanceMarks",null),ge([R],S.prototype,"start",null),ge([R],S.prototype,"shutdown",null),ge([R],S.prototype,"input",null),ge([R],S.prototype,"processBinary",null),ge([R],S.prototype,"resize",null),ge([R],S.prototype,"getInitialCwd",null),ge([R],S.prototype,"getCwd",null),ge([R],S.prototype,"acknowledgeDataEvent",null),ge([R],S.prototype,"setUnicodeVersion",null),ge([R],S.prototype,"getLatency",null),ge([R],S.prototype,"orphanQuestionReply",null),ge([R],S.prototype,"installAutoReply",null),ge([R],S.prototype,"uninstallAllAutoReplies",null),ge([R],S.prototype,"uninstallAutoReply",null),ge([R],S.prototype,"getDefaultSystemShell",null),ge([R],S.prototype,"getEnvironment",null),ge([R],S.prototype,"getWslPath",null),ge([R],S.prototype,"getRevivedPtyNewId",null),ge([R],S.prototype,"setTerminalLayoutInfo",null),ge([R],S.prototype,"getTerminalLayoutInfo",null);var T;(function(M){M.None="None",M.ReplayOnly="ReplayOnly",M.Session="Session"})(T||(T={}));class O extends m.Disposable{get pid(){return this._pid}get shellLaunchConfig(){return this._terminalProcess.shellLaunchConfig}get hasWrittenData(){return this._interactionState.value!==T.None}get title(){return this._title||this._terminalProcess.currentTitle}get titleSource(){return this._titleSource}get icon(){return this._icon}get color(){return this._color}get fixedDimensions(){return this._fixedDimensions}get hasChildProcesses(){return this._terminalProcess.hasChildProcesses}setTitle(A,I){I===b.TitleEventSource.Api&&(this._interactionState.setValue(T.Session,"setTitle"),this._serializer.freeRawReviveBuffer()),this._title=A,this._titleSource=I}setIcon(A,I,B){(!this._icon||"id"in I&&"id"in this._icon&&I.id!==this._icon.id||!this.color||B!==this._color)&&(this._serializer.freeRawReviveBuffer(),A&&this._interactionState.setValue(T.Session,"setIcon")),this._icon=I,this._color=B}_setFixedDimensions(A){this._fixedDimensions=A}constructor(A,I,B,Y,G,Z,se,le,V,z,Q,ee,ue,$,ae,de,te){super(),this._persistentProcessId=A,this._terminalProcess=I,this.workspaceId=B,this.workspaceName=Y,this.shouldPersistTerminal=G,this.processLaunchOptions=le,this.unicodeVersion=V,this._logService=Q,this._icon=$,this._color=ae,this._autoReplies=new Map,this._pendingCommands=new Map,this._isStarted=!1,this._orphanRequestQueue=new t.Queue,this._onProcessReplay=this._register(new L.Emitter),this.onProcessReplay=this._onProcessReplay.event,this._onProcessReady=this._register(new L.Emitter),this.onProcessReady=this._onProcessReady.event,this._onPersistentProcessReady=this._register(new L.Emitter),this.onPersistentProcessReady=this._onPersistentProcessReady.event,this._onProcessData=this._register(new L.Emitter),this.onProcessData=this._onProcessData.event,this._onProcessOrphanQuestion=this._register(new L.Emitter),this.onProcessOrphanQuestion=this._onProcessOrphanQuestion.event,this._onDidChangeProperty=this._register(new L.Emitter),this.onDidChangeProperty=this._onDidChangeProperty.event,this._inReplay=!1,this._pid=-1,this._cwd="",this._titleSource=b.TitleEventSource.Process,this._interactionState=new F(`Persistent process "${this._persistentProcessId}" interaction state`,T.None,this._logService),this._wasRevived=ee!==void 0,this._serializer=new D(Z,se,z.scrollback,V,ee,le.options.shellIntegration.nonce,G?ue:void 0,this._logService),de&&this.setTitle(de,b.TitleEventSource.Api),this._fixedDimensions=te,this._orphanQuestionBarrier=null,this._orphanQuestionReplyTime=0,this._disconnectRunner1=this._register(new t.ProcessTimeRunOnceScheduler(()=>{this._logService.info(`Persistent process "${this._persistentProcessId}": The reconnection grace time of ${E(z.graceTime)} has expired, shutting down pid "${this._pid}"`),this.shutdown(!0)},z.graceTime)),this._disconnectRunner2=this._register(new t.ProcessTimeRunOnceScheduler(()=>{this._logService.info(`Persistent process "${this._persistentProcessId}": The short reconnection grace time of ${E(z.shortGraceTime)} has expired, shutting down pid ${this._pid}`),this.shutdown(!0)},z.shortGraceTime)),this._register(this._terminalProcess.onProcessExit(()=>this._bufferer.stopBuffering(this._persistentProcessId))),this._register(this._terminalProcess.onProcessReady(c=>{this._pid=c.pid,this._cwd=c.cwd,this._onProcessReady.fire(c)})),this._register(this._terminalProcess.onDidChangeProperty(c=>{this._onDidChangeProperty.fire(c)})),this._bufferer=new h.TerminalDataBufferer((c,j)=>this._onProcessData.fire(j)),this._register(this._bufferer.startBuffering(this._persistentProcessId,this._terminalProcess.onProcessData)),this._register(this.onProcessData(c=>this._serializer.handleData(c))),this._register((0,m.toDisposable)(()=>{for(const c of this._autoReplies.values())c.dispose();this._autoReplies.clear()}))}async attach(){!this._disconnectRunner1.isScheduled()&&!this._disconnectRunner2.isScheduled()&&this._logService.warn(`Persistent process "${this._persistentProcessId}": Process had no disconnect runners but was an orphan`),this._disconnectRunner1.cancel(),this._disconnectRunner2.cancel()}async detach(A){this.shouldPersistTerminal&&(this._interactionState.value!==T.None||A)?this._disconnectRunner1.schedule():this.shutdown(!0)}serializeNormalBuffer(){return this._serializer.generateReplayEvent(!0,this._interactionState.value!==T.Session)}async refreshProperty(A){return this._terminalProcess.refreshProperty(A)}async updateProperty(A,I){if(A===b.ProcessPropertyType.FixedDimensions)return this._setFixedDimensions(I)}async start(){if(!this._isStarted){const A=await this._terminalProcess.start();return A&&"message"in A||(this._isStarted=!0,this._wasRevived?this.triggerReplay():this._onPersistentProcessReady.fire()),A}this._onProcessReady.fire({pid:this._pid,cwd:this._cwd,windowsPty:this._terminalProcess.getWindowsPty()}),this._onDidChangeProperty.fire({type:b.ProcessPropertyType.Title,value:this._terminalProcess.currentTitle}),this._onDidChangeProperty.fire({type:b.ProcessPropertyType.ShellType,value:this._terminalProcess.shellType}),this.triggerReplay()}shutdown(A){return this._terminalProcess.shutdown(A)}input(A){if(this._interactionState.setValue(T.Session,"input"),this._serializer.freeRawReviveBuffer(),!this._inReplay){for(const I of this._autoReplies.values())I.handleInput();return this._terminalProcess.input(A)}}writeBinary(A){return this._terminalProcess.processBinary(A)}resize(A,I){if(!this._inReplay){this._serializer.handleResize(A,I),this._bufferer.flushBuffer(this._persistentProcessId);for(const B of this._autoReplies.values())B.handleResize();return this._terminalProcess.resize(A,I)}}async clearBuffer(){this._serializer.clearBuffer(),this._terminalProcess.clearBuffer()}setUnicodeVersion(A){this.unicodeVersion=A,this._serializer.setUnicodeVersion?.(A)}acknowledgeDataEvent(A){if(!this._inReplay)return this._terminalProcess.acknowledgeDataEvent(A)}getInitialCwd(){return this._terminalProcess.getInitialCwd()}getCwd(){return this._terminalProcess.getCwd()}async triggerReplay(){this._interactionState.value===T.None&&this._interactionState.setValue(T.ReplayOnly,"triggerReplay");const A=await this._serializer.generateReplayEvent();let I=0;for(const B of A.events)I+=B.data.length;this._logService.info(`Persistent process "${this._persistentProcessId}": Replaying ${I} chars and ${A.events.length} size events`),this._onProcessReplay.fire(A),this._terminalProcess.clearUnacknowledgedChars(),this._onPersistentProcessReady.fire()}installAutoReply(A,I){this._autoReplies.get(A)?.dispose(),this._autoReplies.set(A,new p.TerminalAutoResponder(this._terminalProcess,A,I,this._logService))}uninstallAutoReply(A){this._autoReplies.get(A)?.dispose(),this._autoReplies.delete(A)}sendCommandResult(A,I,B){this._pendingCommands.get(A)&&this._pendingCommands.delete(A)}orphanQuestionReply(){if(this._orphanQuestionReplyTime=Date.now(),this._orphanQuestionBarrier){const A=this._orphanQuestionBarrier;this._orphanQuestionBarrier=null,A.open()}}reduceGraceTime(){this._disconnectRunner2.isScheduled()||this._disconnectRunner1.isScheduled()&&this._disconnectRunner2.schedule()}async isOrphaned(){return await this._orphanRequestQueue.queue(async()=>this._isOrphaned())}async _isOrphaned(){return this._disconnectRunner1.isScheduled()||this._disconnectRunner2.isScheduled()?!0:(this._orphanQuestionBarrier||(this._orphanQuestionBarrier=new t.AutoOpenBarrier(4e3),this._orphanQuestionReplyTime=0,this._onProcessOrphanQuestion.fire()),await this._orphanQuestionBarrier.wait(),Date.now()-this._orphanQuestionReplyTime>500)}}class F{get value(){return this._value}setValue(A,I){this._value!==A&&(this._value=A,this._log(I))}constructor(A,I,B){this._name=A,this._value=I,this._logService=B,this._log("initialized")}_log(A){this._logService.debug(`MutationLogger "${this._name}" set to "${this._value}", reason: ${A}`)}}class D{constructor(A,I,B,Y,G,Z,se,le){this._rawReviveBuffer=se,this._xterm=new f.Terminal({cols:A,rows:I,scrollback:B,allowProposedApi:!0}),G&&this._xterm.writeln(G),this.setUnicodeVersion(Y),this._shellIntegrationAddon=new y.ShellIntegrationAddon(Z,!0,void 0,le),this._xterm.loadAddon(this._shellIntegrationAddon)}freeRawReviveBuffer(){this._rawReviveBuffer=void 0}handleData(A){this._xterm.write(A)}handleResize(A,I){this._xterm.resize(A,I)}clearBuffer(){this._xterm.clear()}async generateReplayEvent(A,I){const B=new(await this._getSerializeConstructor());this._xterm.loadAddon(B);const Y={scrollback:this._xterm.options.scrollback};A&&(Y.excludeAltBuffer=!0,Y.excludeModes=!0);let G;return I&&this._rawReviveBuffer?G=this._rawReviveBuffer:G=B.serialize(Y),{events:[{cols:this._xterm.cols,rows:this._xterm.rows,data:G}],commands:this._shellIntegrationAddon.serialize()}}async setUnicodeVersion(A){this._xterm.unicode.activeVersion!==A&&(A==="11"?(this._unicodeAddon=new(await this._getUnicode11Constructor()),this._xterm.loadAddon(this._unicodeAddon)):(this._unicodeAddon?.dispose(),this._unicodeAddon=void 0),this._xterm.unicode.activeVersion=A)}async _getUnicode11Constructor(){return v||(v=(await new Promise((A,I)=>{ie(["@xterm/addon-unicode11"],A,I)}).then(Pe)).Unicode11Addon),v}async _getSerializeConstructor(){return x||(x=(await new Promise((A,I)=>{ie(["@xterm/addon-serialize"],A,I)}).then(Pe)).SerializeAddon),x}}function E(M){let A=0,I=0,B=0;M>=1e3&&(B=Math.floor(M/1e3),M-=B*1e3),B>=60&&(I=Math.floor(B/60),B-=I*60),I>=60&&(A=Math.floor(I/60),I-=A*60);const Y=A?`${A}h`:"",G=I?`${I}m`:"",Z=B?`${B}s`:"",se=M?`${M}ms`:"";return`${Y}${G}${Z}${se}`}});var Ke=this&&this.__importDefault||function(ie){return ie&&ie.__esModule?ie:{default:ie}};define(he[106],fe([0,1,62,30,66,67,8,70,73,9,75,76,78,79,16,97,100,33,12,2]),function(ie,e,o,t,L,m,W,P,_,s,b,h,g,l,u,a,d,p,r,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),l=Ke(l),w();async function w(){const C=parseInt(process.env.VSCODE_STARTUP_DELAY??"0"),i=parseInt(process.env.VSCODE_LATENCY??"0"),n={graceTime:parseInt(process.env.VSCODE_RECONNECT_GRACE_TIME||"0"),shortGraceTime:parseInt(process.env.VSCODE_RECONNECT_SHORT_GRACE_TIME||"0"),scrollback:parseInt(process.env.VSCODE_RECONNECT_SCROLLBACK||"100")};delete process.env.VSCODE_RECONNECT_GRACE_TIME,delete process.env.VSCODE_RECONNECT_SHORT_GRACE_TIME,delete process.env.VSCODE_RECONNECT_SCROLLBACK,delete process.env.VSCODE_LATENCY,delete process.env.VSCODE_STARTUP_DELAY,C&&await(0,r.timeout)(C);const f=(0,p.isUtilityProcess)(process);let R;f?R=new m.Server:R=new L.Server(u.TerminalIpcChannels.PtyHost);const x={_serviceBrand:void 0,...l.default},v=new _.NativeEnvironmentService((0,P.parseArgs)(process.argv,P.OPTIONS),x),S=new g.LoggerService((0,s.getLogLevel)(v),v.logsHome);R.registerChannel(u.TerminalIpcChannels.Logger,new b.LoggerChannel(S,()=>o.DefaultURITransformer));const T=S.createLogger("ptyhost",{name:(0,W.localize)(2119,null)}),O=new h.LogService(T);C&&O.warn(`Pty Host startup is delayed ${C}ms`),i&&O.warn(`Pty host is simulating ${i}ms latency`);const F=new y.DisposableStore,D=new a.HeartbeatService;R.registerChannel(u.TerminalIpcChannels.Heartbeat,t.ProxyChannel.fromService(D,F));const E=new d.PtyService(O,x,n,i),M=t.ProxyChannel.fromService(E,F);R.registerChannel(u.TerminalIpcChannels.PtyHost,M),f&&R.registerChannel(u.TerminalIpcChannels.PtyHostWindow,M),process.once("exit",()=>{O.trace("Pty host exiting"),O.dispose(),D.dispose(),E.dispose()})}})}).call(this);

//# sourceMappingURL=https://main.vscode-cdn.net/sourcemaps/532bdf24071d0a26ceea0844dcdf5ee8cfabd562/core/vs/platform/terminal/node/ptyHostMain.js.map
