/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Pe=["exports","require","vs/base/common/uri","vs/base/common/lifecycle","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/nls","vs/base/common/async","vs/workbench/api/common/extHostTypes","vs/base/common/platform","vs/platform/log/common/log","vs/base/common/errors","vs/base/common/strings","vs/base/common/network","vs/workbench/api/common/extHostTypeConverters","vs/base/common/path","vs/base/common/types","vs/base/common/arrays","vs/workbench/api/common/extHostRpcService","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/resources","vs/platform/extensions/common/extensions","vs/base/common/objects","vs/workbench/services/extensions/common/extensions","vs/base/common/charCode","vs/platform/files/common/files","vs/base/common/map","vs/workbench/api/common/extHostInitDataService","vs/editor/common/core/range","vs/base/common/uuid","vs/workbench/services/search/common/search","vs/base/common/extpath","vs/base/node/pfs","vs/workbench/api/common/extHostCommands","vs/platform/contextkey/common/contextkey","vs/platform/registry/common/platform","vs/base/common/marshalling","vs/base/common/glob","vs/base/common/iterator","vs/base/common/marshallingIds","vs/workbench/api/common/extHostConfiguration","vs/base/common/stopwatch","vs/base/common/severity","fs","vs/platform/configuration/common/configuration","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostWorkspace","vs/base/common/lazy","vs/base/common/themables","vs/base/common/errorMessage","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostExtensionService","vs/editor/common/core/position","vs/editor/common/model","vs/base/common/process","child_process","vs/workbench/services/search/common/searchExtTypes","vs/base/common/decorators","vs/base/common/hash","vs/base/common/ternarySearchTree","vs/base/common/performance","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostVariableResolverService","vs/base/common/assert","net","os","vs/base/parts/ipc/common/ipc.net","vs/platform/files/common/watcher","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testId","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostEditorTabs","vs/base/common/collections","vs/base/common/functional","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/codicons","vs/base/common/uint","vs/base/common/htmlContent","vs/base/parts/ipc/common/ipc","vs/editor/common/languages","vs/platform/instantiation/common/extensions","vs/platform/progress/common/progress","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/platform/tunnel/common/tunnel","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostWebview","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/stream","vs/base/common/codiconsUtil","vs/editor/common/encodedTokenAttributes","vs/editor/common/model/textModelSearch","vs/base/common/mime","vs/base/common/processes","vs/base/common/labels","vs/base/node/extpath","vs/base/node/processes","vs/platform/instantiation/common/descriptors","vs/editor/common/config/editorOptions","vs/platform/instantiation/common/serviceCollection","vs/platform/product/common/productService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/sign/common/sign","vs/workbench/api/common/cache","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostLanguageModels","vs/workbench/services/search/common/searchExtConversionTypes","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/parts/ipc/node/ipc.net","vs/base/common/amd","vs/base/common/arraysFind","vs/base/common/idGenerator","vs/base/common/numbers","vs/base/common/filters","vs/base/common/iconLabels","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeBase","vs/nls.messages","vs/base/common/comparers","vs/base/common/fuzzyScorer","vs/amdX","vs/base/common/uriIpc","vs/editor/common/services/semanticTokensDto","vs/platform/extensions/common/extensionsApiProposals","vs/platform/environment/common/environment","vs/platform/markers/common/markers","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/sign/node/signService","vs/platform/telemetry/common/telemetry","vs/platform/uriIdentity/common/uriIdentity","vs/platform/userDataProfile/common/userDataProfile","vs/platform/storage/common/storage","vs/workbench/common/editor","vs/workbench/contrib/chat/common/chatAgents","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/authentication/common/authentication","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTerminalShellIntegration","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostOutput","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/common/equals","vs/base/common/json","vs/base/common/jsonSchema","vs/base/common/marked/marked","vs/base/common/naturalLanguage/korean","vs/base/common/observableInternal/debugName","vs/base/common/observableInternal/logging","vs/base/common/observableInternal/base","vs/base/common/prefixTree","vs/base/common/cache","vs/base/common/scrollable","vs/base/common/symbols","vs/base/common/codiconsLibrary","vs/base/common/dataTransfer","vs/base/node/ports","vs/editor/common/core/eolCounter","vs/editor/common/core/editOperation","vs/editor/common/core/selection","vs/editor/common/core/textModelDefaults","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/languages/languageConfiguration","vs/editor/common/languages/linkComputer","vs/editor/common/model/pieceTreeTextBuffer/rbTreeBase","vs/editor/common/model/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/editor/common/services/treeViewsDnd","vs/editor/common/tokenizationRegistry","vs/base/common/actions","vs/base/common/date","vs/base/common/console","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/editor/common/core/stringBuilder","vs/editor/common/core/textChange","vs/editor/common/languageSelector","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBuffer","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBufferBuilder","vs/platform/contextkey/common/scanner","vs/platform/instantiation/common/graph","vs/platform/accessibility/common/accessibility","vs/platform/dialogs/common/dialogs","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/io","vs/platform/files/node/watcher/baseWatcher","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/notification/common/notification","vs/platform/product/common/product","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/managedSocket","vs/platform/remote/common/remoteAgentConnection","vs/platform/extensions/common/extensionValidator","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/request/common/request","vs/platform/sign/common/abstractSignService","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminal","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/node/proxyResolver","http","vs/workbench/api/node/uriTransformer","vs/workbench/common/views","vs/workbench/contrib/chat/common/chatContextKeys","vs/workbench/contrib/chat/common/chatService","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","vs/workbench/contrib/debug/node/terminals","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/notebook/common/notebookKernelService","vs/workbench/contrib/search/common/cellSearchModel","vs/workbench/contrib/testing/common/constants","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/extensions/common/extensionHostEnv","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/contrib/chat/common/languageModels","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostEmbedding","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostSpeech","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/node/extHostConsoleForwarder","vs/workbench/api/node/extHostLoggerService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/notebook/common/notebookDocumentService","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChatAgents2","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguageModelTools","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostDiskFileSystemProvider","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/services/output/common/output","vs/workbench/common/configuration","vs/workbench/services/editor/common/editorResolverService","vs/workbench/services/path/common/pathService","vs/workbench/services/remote/common/tunnelModel","vs/workbench/contrib/search/common/searchNotebookHelpers","vs/workbench/api/common/extHostNotebook","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/api/node/extHostVariableResolverService","vs/workbench/services/search/common/fileSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/services/search/node/ripgrepFileSearch","@vscode/ripgrep","vs/workbench/services/search/node/fileSearch","string_decoder","vs/workbench/services/textfile/common/encoding","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/platform/tunnel/node/tunnelService","vs/workbench/api/node/extHostCLIServer","vs/workbench/api/node/extHostExtensionService","vs/workbench/api/node/extHostTunnelService","vs/workbench/api/node/extHost.node.services","util","vs/base/common/semver/semver","https","tls","@vscode/proxy-agent","events","vscode-regexpp","crypto","zlib","vs/workbench/api/node/extensionHostProcess","minimist"],ke=function(ge){for(var e=[],s=0,h=ge.length;s<h;s++)e[s]=Pe[ge[s]];return e};define(Pe[132],ke([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoaderStats=e.LoaderEventType=e.canASAR=e.isESM=void 0,e.isESM=!1,e.canASAR=!0;var s;(function(D){D[D.LoaderAvailable=1]="LoaderAvailable",D[D.BeginLoadingScript=10]="BeginLoadingScript",D[D.EndLoadingScriptOK=11]="EndLoadingScriptOK",D[D.EndLoadingScriptError=12]="EndLoadingScriptError",D[D.BeginInvokeFactory=21]="BeginInvokeFactory",D[D.EndInvokeFactory=22]="EndInvokeFactory",D[D.NodeBeginEvaluatingScript=31]="NodeBeginEvaluatingScript",D[D.NodeEndEvaluatingScript=32]="NodeEndEvaluatingScript",D[D.NodeBeginNativeRequire=33]="NodeBeginNativeRequire",D[D.NodeEndNativeRequire=34]="NodeEndNativeRequire",D[D.CachedDataFound=60]="CachedDataFound",D[D.CachedDataMissed=61]="CachedDataMissed",D[D.CachedDataRejected=62]="CachedDataRejected",D[D.CachedDataCreated=63]="CachedDataCreated"})(s||(e.LoaderEventType=s={}));class h{static get(){const A=new Map,L=new Map,R=new Map,v=new Map;function l(S,o){S.has(o.detail)||S.set(o.detail,-o.timestamp)}function C(S,o){const m=S.get(o.detail);m&&(m>=0||S.set(o.detail,m+o.timestamp))}let _=[];typeof ge=="function"&&typeof ge.getStats=="function"&&(_=ge.getStats().slice(0).sort((S,o)=>S.timestamp-o.timestamp));for(const S of _)switch(S.type){case s.BeginLoadingScript:l(A,S);break;case s.EndLoadingScriptOK:case s.EndLoadingScriptError:C(A,S);break;case s.BeginInvokeFactory:l(L,S);break;case s.EndInvokeFactory:C(L,S);break;case s.NodeBeginNativeRequire:l(R,S);break;case s.NodeEndNativeRequire:C(R,S);break;case s.NodeBeginEvaluatingScript:l(v,S);break;case s.NodeEndEvaluatingScript:C(v,S);break}let f=0;R.forEach(S=>f+=S);function T(S){const o=[];return S.forEach((m,p)=>o.push([p,m])),o}return{amdLoad:T(A),amdInvoke:T(L),nodeRequire:T(R),nodeEval:T(v),nodeRequireTotal:f}}static toMarkdownTable(A,L){let R="";const v=[];return A.forEach((l,C)=>{v[C]=l.length}),L.forEach(l=>{l.forEach((C,_)=>{typeof C>"u"&&(C=l[_]="-");const f=C.toString().length;v[_]=Math.max(f,v[_])})}),A.forEach((l,C)=>{R+=`| ${l+" ".repeat(v[C]-l.toString().length)} `}),R+=`|
`,A.forEach((l,C)=>{R+=`| ${"-".repeat(v[C])} `}),R+=`|
`,L.forEach(l=>{l.forEach((C,_)=>{typeof C<"u"&&(R+=`| ${C+" ".repeat(v[_]-C.toString().length)} `)}),R+=`|
`}),R}}e.LoaderStats=h}),define(Pe[133],ke([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MonotonousArray=void 0,e.findLast=s,e.findLastIdx=h,e.findLastMonotonous=D,e.findLastIdxMonotonous=A,e.findFirstMonotonous=L,e.findFirstIdxMonotonousOrArrLen=R,e.findFirstIdxMonotonous=v,e.findFirstMax=C,e.findLastMax=_,e.findFirstMin=f,e.findMaxIdx=T,e.mapFindFirst=S;function s(o,m){const p=h(o,m);if(p!==-1)return o[p]}function h(o,m,p=o.length-1){for(let u=p;u>=0;u--){const i=o[u];if(m(i))return u}return-1}function D(o,m){const p=A(o,m);return p===-1?void 0:o[p]}function A(o,m,p=0,u=o.length){let i=p,a=u;for(;i<a;){const t=Math.floor((i+a)/2);m(o[t])?i=t+1:a=t}return i-1}function L(o,m){const p=R(o,m);return p===o.length?void 0:o[p]}function R(o,m,p=0,u=o.length){let i=p,a=u;for(;i<a;){const t=Math.floor((i+a)/2);m(o[t])?a=t:i=t+1}return i}function v(o,m,p=0,u=o.length){const i=R(o,m,p,u);return i===o.length?-1:i}class l{static{this.assertInvariants=!1}constructor(m){this._array=m,this._findLastMonotonousLastIdx=0}findLastMonotonous(m){if(l.assertInvariants){if(this._prevFindLastPredicate){for(const u of this._array)if(this._prevFindLastPredicate(u)&&!m(u))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this._prevFindLastPredicate=m}const p=A(this._array,m,this._findLastMonotonousLastIdx);return this._findLastMonotonousLastIdx=p+1,p===-1?void 0:this._array[p]}}e.MonotonousArray=l;function C(o,m){if(o.length===0)return;let p=o[0];for(let u=1;u<o.length;u++){const i=o[u];m(i,p)>0&&(p=i)}return p}function _(o,m){if(o.length===0)return;let p=o[0];for(let u=1;u<o.length;u++){const i=o[u];m(i,p)>=0&&(p=i)}return p}function f(o,m){return C(o,(p,u)=>-m(p,u))}function T(o,m){if(o.length===0)return-1;let p=0;for(let u=1;u<o.length;u++){const i=o[u];m(i,o[p])>0&&(p=u)}return p}function S(o,m){for(const p of o){const u=m(p);if(u!==void 0)return u}}}),define(Pe[26],ke([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharCode=void 0;var s;(function(h){h[h.Null=0]="Null",h[h.Backspace=8]="Backspace",h[h.Tab=9]="Tab",h[h.LineFeed=10]="LineFeed",h[h.CarriageReturn=13]="CarriageReturn",h[h.Space=32]="Space",h[h.ExclamationMark=33]="ExclamationMark",h[h.DoubleQuote=34]="DoubleQuote",h[h.Hash=35]="Hash",h[h.DollarSign=36]="DollarSign",h[h.PercentSign=37]="PercentSign",h[h.Ampersand=38]="Ampersand",h[h.SingleQuote=39]="SingleQuote",h[h.OpenParen=40]="OpenParen",h[h.CloseParen=41]="CloseParen",h[h.Asterisk=42]="Asterisk",h[h.Plus=43]="Plus",h[h.Comma=44]="Comma",h[h.Dash=45]="Dash",h[h.Period=46]="Period",h[h.Slash=47]="Slash",h[h.Digit0=48]="Digit0",h[h.Digit1=49]="Digit1",h[h.Digit2=50]="Digit2",h[h.Digit3=51]="Digit3",h[h.Digit4=52]="Digit4",h[h.Digit5=53]="Digit5",h[h.Digit6=54]="Digit6",h[h.Digit7=55]="Digit7",h[h.Digit8=56]="Digit8",h[h.Digit9=57]="Digit9",h[h.Colon=58]="Colon",h[h.Semicolon=59]="Semicolon",h[h.LessThan=60]="LessThan",h[h.Equals=61]="Equals",h[h.GreaterThan=62]="GreaterThan",h[h.QuestionMark=63]="QuestionMark",h[h.AtSign=64]="AtSign",h[h.A=65]="A",h[h.B=66]="B",h[h.C=67]="C",h[h.D=68]="D",h[h.E=69]="E",h[h.F=70]="F",h[h.G=71]="G",h[h.H=72]="H",h[h.I=73]="I",h[h.J=74]="J",h[h.K=75]="K",h[h.L=76]="L",h[h.M=77]="M",h[h.N=78]="N",h[h.O=79]="O",h[h.P=80]="P",h[h.Q=81]="Q",h[h.R=82]="R",h[h.S=83]="S",h[h.T=84]="T",h[h.U=85]="U",h[h.V=86]="V",h[h.W=87]="W",h[h.X=88]="X",h[h.Y=89]="Y",h[h.Z=90]="Z",h[h.OpenSquareBracket=91]="OpenSquareBracket",h[h.Backslash=92]="Backslash",h[h.CloseSquareBracket=93]="CloseSquareBracket",h[h.Caret=94]="Caret",h[h.Underline=95]="Underline",h[h.BackTick=96]="BackTick",h[h.a=97]="a",h[h.b=98]="b",h[h.c=99]="c",h[h.d=100]="d",h[h.e=101]="e",h[h.f=102]="f",h[h.g=103]="g",h[h.h=104]="h",h[h.i=105]="i",h[h.j=106]="j",h[h.k=107]="k",h[h.l=108]="l",h[h.m=109]="m",h[h.n=110]="n",h[h.o=111]="o",h[h.p=112]="p",h[h.q=113]="q",h[h.r=114]="r",h[h.s=115]="s",h[h.t=116]="t",h[h.u=117]="u",h[h.v=118]="v",h[h.w=119]="w",h[h.x=120]="x",h[h.y=121]="y",h[h.z=122]="z",h[h.OpenCurlyBrace=123]="OpenCurlyBrace",h[h.Pipe=124]="Pipe",h[h.CloseCurlyBrace=125]="CloseCurlyBrace",h[h.Tilde=126]="Tilde",h[h.NoBreakSpace=160]="NoBreakSpace",h[h.U_Combining_Grave_Accent=768]="U_Combining_Grave_Accent",h[h.U_Combining_Acute_Accent=769]="U_Combining_Acute_Accent",h[h.U_Combining_Circumflex_Accent=770]="U_Combining_Circumflex_Accent",h[h.U_Combining_Tilde=771]="U_Combining_Tilde",h[h.U_Combining_Macron=772]="U_Combining_Macron",h[h.U_Combining_Overline=773]="U_Combining_Overline",h[h.U_Combining_Breve=774]="U_Combining_Breve",h[h.U_Combining_Dot_Above=775]="U_Combining_Dot_Above",h[h.U_Combining_Diaeresis=776]="U_Combining_Diaeresis",h[h.U_Combining_Hook_Above=777]="U_Combining_Hook_Above",h[h.U_Combining_Ring_Above=778]="U_Combining_Ring_Above",h[h.U_Combining_Double_Acute_Accent=779]="U_Combining_Double_Acute_Accent",h[h.U_Combining_Caron=780]="U_Combining_Caron",h[h.U_Combining_Vertical_Line_Above=781]="U_Combining_Vertical_Line_Above",h[h.U_Combining_Double_Vertical_Line_Above=782]="U_Combining_Double_Vertical_Line_Above",h[h.U_Combining_Double_Grave_Accent=783]="U_Combining_Double_Grave_Accent",h[h.U_Combining_Candrabindu=784]="U_Combining_Candrabindu",h[h.U_Combining_Inverted_Breve=785]="U_Combining_Inverted_Breve",h[h.U_Combining_Turned_Comma_Above=786]="U_Combining_Turned_Comma_Above",h[h.U_Combining_Comma_Above=787]="U_Combining_Comma_Above",h[h.U_Combining_Reversed_Comma_Above=788]="U_Combining_Reversed_Comma_Above",h[h.U_Combining_Comma_Above_Right=789]="U_Combining_Comma_Above_Right",h[h.U_Combining_Grave_Accent_Below=790]="U_Combining_Grave_Accent_Below",h[h.U_Combining_Acute_Accent_Below=791]="U_Combining_Acute_Accent_Below",h[h.U_Combining_Left_Tack_Below=792]="U_Combining_Left_Tack_Below",h[h.U_Combining_Right_Tack_Below=793]="U_Combining_Right_Tack_Below",h[h.U_Combining_Left_Angle_Above=794]="U_Combining_Left_Angle_Above",h[h.U_Combining_Horn=795]="U_Combining_Horn",h[h.U_Combining_Left_Half_Ring_Below=796]="U_Combining_Left_Half_Ring_Below",h[h.U_Combining_Up_Tack_Below=797]="U_Combining_Up_Tack_Below",h[h.U_Combining_Down_Tack_Below=798]="U_Combining_Down_Tack_Below",h[h.U_Combining_Plus_Sign_Below=799]="U_Combining_Plus_Sign_Below",h[h.U_Combining_Minus_Sign_Below=800]="U_Combining_Minus_Sign_Below",h[h.U_Combining_Palatalized_Hook_Below=801]="U_Combining_Palatalized_Hook_Below",h[h.U_Combining_Retroflex_Hook_Below=802]="U_Combining_Retroflex_Hook_Below",h[h.U_Combining_Dot_Below=803]="U_Combining_Dot_Below",h[h.U_Combining_Diaeresis_Below=804]="U_Combining_Diaeresis_Below",h[h.U_Combining_Ring_Below=805]="U_Combining_Ring_Below",h[h.U_Combining_Comma_Below=806]="U_Combining_Comma_Below",h[h.U_Combining_Cedilla=807]="U_Combining_Cedilla",h[h.U_Combining_Ogonek=808]="U_Combining_Ogonek",h[h.U_Combining_Vertical_Line_Below=809]="U_Combining_Vertical_Line_Below",h[h.U_Combining_Bridge_Below=810]="U_Combining_Bridge_Below",h[h.U_Combining_Inverted_Double_Arch_Below=811]="U_Combining_Inverted_Double_Arch_Below",h[h.U_Combining_Caron_Below=812]="U_Combining_Caron_Below",h[h.U_Combining_Circumflex_Accent_Below=813]="U_Combining_Circumflex_Accent_Below",h[h.U_Combining_Breve_Below=814]="U_Combining_Breve_Below",h[h.U_Combining_Inverted_Breve_Below=815]="U_Combining_Inverted_Breve_Below",h[h.U_Combining_Tilde_Below=816]="U_Combining_Tilde_Below",h[h.U_Combining_Macron_Below=817]="U_Combining_Macron_Below",h[h.U_Combining_Low_Line=818]="U_Combining_Low_Line",h[h.U_Combining_Double_Low_Line=819]="U_Combining_Double_Low_Line",h[h.U_Combining_Tilde_Overlay=820]="U_Combining_Tilde_Overlay",h[h.U_Combining_Short_Stroke_Overlay=821]="U_Combining_Short_Stroke_Overlay",h[h.U_Combining_Long_Stroke_Overlay=822]="U_Combining_Long_Stroke_Overlay",h[h.U_Combining_Short_Solidus_Overlay=823]="U_Combining_Short_Solidus_Overlay",h[h.U_Combining_Long_Solidus_Overlay=824]="U_Combining_Long_Solidus_Overlay",h[h.U_Combining_Right_Half_Ring_Below=825]="U_Combining_Right_Half_Ring_Below",h[h.U_Combining_Inverted_Bridge_Below=826]="U_Combining_Inverted_Bridge_Below",h[h.U_Combining_Square_Below=827]="U_Combining_Square_Below",h[h.U_Combining_Seagull_Below=828]="U_Combining_Seagull_Below",h[h.U_Combining_X_Above=829]="U_Combining_X_Above",h[h.U_Combining_Vertical_Tilde=830]="U_Combining_Vertical_Tilde",h[h.U_Combining_Double_Overline=831]="U_Combining_Double_Overline",h[h.U_Combining_Grave_Tone_Mark=832]="U_Combining_Grave_Tone_Mark",h[h.U_Combining_Acute_Tone_Mark=833]="U_Combining_Acute_Tone_Mark",h[h.U_Combining_Greek_Perispomeni=834]="U_Combining_Greek_Perispomeni",h[h.U_Combining_Greek_Koronis=835]="U_Combining_Greek_Koronis",h[h.U_Combining_Greek_Dialytika_Tonos=836]="U_Combining_Greek_Dialytika_Tonos",h[h.U_Combining_Greek_Ypogegrammeni=837]="U_Combining_Greek_Ypogegrammeni",h[h.U_Combining_Bridge_Above=838]="U_Combining_Bridge_Above",h[h.U_Combining_Equals_Sign_Below=839]="U_Combining_Equals_Sign_Below",h[h.U_Combining_Double_Vertical_Line_Below=840]="U_Combining_Double_Vertical_Line_Below",h[h.U_Combining_Left_Angle_Below=841]="U_Combining_Left_Angle_Below",h[h.U_Combining_Not_Tilde_Above=842]="U_Combining_Not_Tilde_Above",h[h.U_Combining_Homothetic_Above=843]="U_Combining_Homothetic_Above",h[h.U_Combining_Almost_Equal_To_Above=844]="U_Combining_Almost_Equal_To_Above",h[h.U_Combining_Left_Right_Arrow_Below=845]="U_Combining_Left_Right_Arrow_Below",h[h.U_Combining_Upwards_Arrow_Below=846]="U_Combining_Upwards_Arrow_Below",h[h.U_Combining_Grapheme_Joiner=847]="U_Combining_Grapheme_Joiner",h[h.U_Combining_Right_Arrowhead_Above=848]="U_Combining_Right_Arrowhead_Above",h[h.U_Combining_Left_Half_Ring_Above=849]="U_Combining_Left_Half_Ring_Above",h[h.U_Combining_Fermata=850]="U_Combining_Fermata",h[h.U_Combining_X_Below=851]="U_Combining_X_Below",h[h.U_Combining_Left_Arrowhead_Below=852]="U_Combining_Left_Arrowhead_Below",h[h.U_Combining_Right_Arrowhead_Below=853]="U_Combining_Right_Arrowhead_Below",h[h.U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below=854]="U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below",h[h.U_Combining_Right_Half_Ring_Above=855]="U_Combining_Right_Half_Ring_Above",h[h.U_Combining_Dot_Above_Right=856]="U_Combining_Dot_Above_Right",h[h.U_Combining_Asterisk_Below=857]="U_Combining_Asterisk_Below",h[h.U_Combining_Double_Ring_Below=858]="U_Combining_Double_Ring_Below",h[h.U_Combining_Zigzag_Above=859]="U_Combining_Zigzag_Above",h[h.U_Combining_Double_Breve_Below=860]="U_Combining_Double_Breve_Below",h[h.U_Combining_Double_Breve=861]="U_Combining_Double_Breve",h[h.U_Combining_Double_Macron=862]="U_Combining_Double_Macron",h[h.U_Combining_Double_Macron_Below=863]="U_Combining_Double_Macron_Below",h[h.U_Combining_Double_Tilde=864]="U_Combining_Double_Tilde",h[h.U_Combining_Double_Inverted_Breve=865]="U_Combining_Double_Inverted_Breve",h[h.U_Combining_Double_Rightwards_Arrow_Below=866]="U_Combining_Double_Rightwards_Arrow_Below",h[h.U_Combining_Latin_Small_Letter_A=867]="U_Combining_Latin_Small_Letter_A",h[h.U_Combining_Latin_Small_Letter_E=868]="U_Combining_Latin_Small_Letter_E",h[h.U_Combining_Latin_Small_Letter_I=869]="U_Combining_Latin_Small_Letter_I",h[h.U_Combining_Latin_Small_Letter_O=870]="U_Combining_Latin_Small_Letter_O",h[h.U_Combining_Latin_Small_Letter_U=871]="U_Combining_Latin_Small_Letter_U",h[h.U_Combining_Latin_Small_Letter_C=872]="U_Combining_Latin_Small_Letter_C",h[h.U_Combining_Latin_Small_Letter_D=873]="U_Combining_Latin_Small_Letter_D",h[h.U_Combining_Latin_Small_Letter_H=874]="U_Combining_Latin_Small_Letter_H",h[h.U_Combining_Latin_Small_Letter_M=875]="U_Combining_Latin_Small_Letter_M",h[h.U_Combining_Latin_Small_Letter_R=876]="U_Combining_Latin_Small_Letter_R",h[h.U_Combining_Latin_Small_Letter_T=877]="U_Combining_Latin_Small_Letter_T",h[h.U_Combining_Latin_Small_Letter_V=878]="U_Combining_Latin_Small_Letter_V",h[h.U_Combining_Latin_Small_Letter_X=879]="U_Combining_Latin_Small_Letter_X",h[h.LINE_SEPARATOR=8232]="LINE_SEPARATOR",h[h.PARAGRAPH_SEPARATOR=8233]="PARAGRAPH_SEPARATOR",h[h.NEXT_LINE=133]="NEXT_LINE",h[h.U_CIRCUMFLEX=94]="U_CIRCUMFLEX",h[h.U_GRAVE_ACCENT=96]="U_GRAVE_ACCENT",h[h.U_DIAERESIS=168]="U_DIAERESIS",h[h.U_MACRON=175]="U_MACRON",h[h.U_ACUTE_ACCENT=180]="U_ACUTE_ACCENT",h[h.U_CEDILLA=184]="U_CEDILLA",h[h.U_MODIFIER_LETTER_LEFT_ARROWHEAD=706]="U_MODIFIER_LETTER_LEFT_ARROWHEAD",h[h.U_MODIFIER_LETTER_RIGHT_ARROWHEAD=707]="U_MODIFIER_LETTER_RIGHT_ARROWHEAD",h[h.U_MODIFIER_LETTER_UP_ARROWHEAD=708]="U_MODIFIER_LETTER_UP_ARROWHEAD",h[h.U_MODIFIER_LETTER_DOWN_ARROWHEAD=709]="U_MODIFIER_LETTER_DOWN_ARROWHEAD",h[h.U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING=722]="U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING",h[h.U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING=723]="U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING",h[h.U_MODIFIER_LETTER_UP_TACK=724]="U_MODIFIER_LETTER_UP_TACK",h[h.U_MODIFIER_LETTER_DOWN_TACK=725]="U_MODIFIER_LETTER_DOWN_TACK",h[h.U_MODIFIER_LETTER_PLUS_SIGN=726]="U_MODIFIER_LETTER_PLUS_SIGN",h[h.U_MODIFIER_LETTER_MINUS_SIGN=727]="U_MODIFIER_LETTER_MINUS_SIGN",h[h.U_BREVE=728]="U_BREVE",h[h.U_DOT_ABOVE=729]="U_DOT_ABOVE",h[h.U_RING_ABOVE=730]="U_RING_ABOVE",h[h.U_OGONEK=731]="U_OGONEK",h[h.U_SMALL_TILDE=732]="U_SMALL_TILDE",h[h.U_DOUBLE_ACUTE_ACCENT=733]="U_DOUBLE_ACUTE_ACCENT",h[h.U_MODIFIER_LETTER_RHOTIC_HOOK=734]="U_MODIFIER_LETTER_RHOTIC_HOOK",h[h.U_MODIFIER_LETTER_CROSS_ACCENT=735]="U_MODIFIER_LETTER_CROSS_ACCENT",h[h.U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR=741]="U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR",h[h.U_MODIFIER_LETTER_HIGH_TONE_BAR=742]="U_MODIFIER_LETTER_HIGH_TONE_BAR",h[h.U_MODIFIER_LETTER_MID_TONE_BAR=743]="U_MODIFIER_LETTER_MID_TONE_BAR",h[h.U_MODIFIER_LETTER_LOW_TONE_BAR=744]="U_MODIFIER_LETTER_LOW_TONE_BAR",h[h.U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR=745]="U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR",h[h.U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK=746]="U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK",h[h.U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK=747]="U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK",h[h.U_MODIFIER_LETTER_UNASPIRATED=749]="U_MODIFIER_LETTER_UNASPIRATED",h[h.U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD=751]="U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD",h[h.U_MODIFIER_LETTER_LOW_UP_ARROWHEAD=752]="U_MODIFIER_LETTER_LOW_UP_ARROWHEAD",h[h.U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD=753]="U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD",h[h.U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD=754]="U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD",h[h.U_MODIFIER_LETTER_LOW_RING=755]="U_MODIFIER_LETTER_LOW_RING",h[h.U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT=756]="U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT",h[h.U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT=757]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT",h[h.U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT=758]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT",h[h.U_MODIFIER_LETTER_LOW_TILDE=759]="U_MODIFIER_LETTER_LOW_TILDE",h[h.U_MODIFIER_LETTER_RAISED_COLON=760]="U_MODIFIER_LETTER_RAISED_COLON",h[h.U_MODIFIER_LETTER_BEGIN_HIGH_TONE=761]="U_MODIFIER_LETTER_BEGIN_HIGH_TONE",h[h.U_MODIFIER_LETTER_END_HIGH_TONE=762]="U_MODIFIER_LETTER_END_HIGH_TONE",h[h.U_MODIFIER_LETTER_BEGIN_LOW_TONE=763]="U_MODIFIER_LETTER_BEGIN_LOW_TONE",h[h.U_MODIFIER_LETTER_END_LOW_TONE=764]="U_MODIFIER_LETTER_END_LOW_TONE",h[h.U_MODIFIER_LETTER_SHELF=765]="U_MODIFIER_LETTER_SHELF",h[h.U_MODIFIER_LETTER_OPEN_SHELF=766]="U_MODIFIER_LETTER_OPEN_SHELF",h[h.U_MODIFIER_LETTER_LOW_LEFT_ARROW=767]="U_MODIFIER_LETTER_LOW_LEFT_ARROW",h[h.U_GREEK_LOWER_NUMERAL_SIGN=885]="U_GREEK_LOWER_NUMERAL_SIGN",h[h.U_GREEK_TONOS=900]="U_GREEK_TONOS",h[h.U_GREEK_DIALYTIKA_TONOS=901]="U_GREEK_DIALYTIKA_TONOS",h[h.U_GREEK_KORONIS=8125]="U_GREEK_KORONIS",h[h.U_GREEK_PSILI=8127]="U_GREEK_PSILI",h[h.U_GREEK_PERISPOMENI=8128]="U_GREEK_PERISPOMENI",h[h.U_GREEK_DIALYTIKA_AND_PERISPOMENI=8129]="U_GREEK_DIALYTIKA_AND_PERISPOMENI",h[h.U_GREEK_PSILI_AND_VARIA=8141]="U_GREEK_PSILI_AND_VARIA",h[h.U_GREEK_PSILI_AND_OXIA=8142]="U_GREEK_PSILI_AND_OXIA",h[h.U_GREEK_PSILI_AND_PERISPOMENI=8143]="U_GREEK_PSILI_AND_PERISPOMENI",h[h.U_GREEK_DASIA_AND_VARIA=8157]="U_GREEK_DASIA_AND_VARIA",h[h.U_GREEK_DASIA_AND_OXIA=8158]="U_GREEK_DASIA_AND_OXIA",h[h.U_GREEK_DASIA_AND_PERISPOMENI=8159]="U_GREEK_DASIA_AND_PERISPOMENI",h[h.U_GREEK_DIALYTIKA_AND_VARIA=8173]="U_GREEK_DIALYTIKA_AND_VARIA",h[h.U_GREEK_DIALYTIKA_AND_OXIA=8174]="U_GREEK_DIALYTIKA_AND_OXIA",h[h.U_GREEK_VARIA=8175]="U_GREEK_VARIA",h[h.U_GREEK_OXIA=8189]="U_GREEK_OXIA",h[h.U_GREEK_DASIA=8190]="U_GREEK_DASIA",h[h.U_IDEOGRAPHIC_FULL_STOP=12290]="U_IDEOGRAPHIC_FULL_STOP",h[h.U_LEFT_CORNER_BRACKET=12300]="U_LEFT_CORNER_BRACKET",h[h.U_RIGHT_CORNER_BRACKET=12301]="U_RIGHT_CORNER_BRACKET",h[h.U_LEFT_BLACK_LENTICULAR_BRACKET=12304]="U_LEFT_BLACK_LENTICULAR_BRACKET",h[h.U_RIGHT_BLACK_LENTICULAR_BRACKET=12305]="U_RIGHT_BLACK_LENTICULAR_BRACKET",h[h.U_OVERLINE=8254]="U_OVERLINE",h[h.UTF8_BOM=65279]="UTF8_BOM",h[h.U_FULLWIDTH_SEMICOLON=65307]="U_FULLWIDTH_SEMICOLON",h[h.U_FULLWIDTH_COMMA=65292]="U_FULLWIDTH_COMMA"})(s||(e.CharCode=s={}))}),define(Pe[80],ke([1,0]),function(ge,e){"use strict";var s;Object.defineProperty(e,"__esModule",{value:!0}),e.SetWithKey=void 0,e.groupBy=h,e.diffSets=D,e.diffMaps=A,e.intersection=L;function h(v,l){const C=Object.create(null);for(const _ of v){const f=l(_);let T=C[f];T||(T=C[f]=[]),T.push(_)}return C}function D(v,l){const C=[],_=[];for(const f of v)l.has(f)||C.push(f);for(const f of l)v.has(f)||_.push(f);return{removed:C,added:_}}function A(v,l){const C=[],_=[];for(const[f,T]of v)l.has(f)||C.push(T);for(const[f,T]of l)v.has(f)||_.push(T);return{removed:C,added:_}}function L(v,l){const C=new Set;for(const _ of l)v.has(_)&&C.add(_);return C}class R{static{s=Symbol.toStringTag}constructor(l,C){this.toKey=C,this._map=new Map,this[s]="SetWithKey";for(const _ of l)this.add(_)}get size(){return this._map.size}add(l){const C=this.toKey(l);return this._map.set(C,l),this}delete(l){return this._map.delete(this.toKey(l))}has(l){return this._map.has(this.toKey(l))}*entries(){for(const l of this._map.values())yield[l,l]}keys(){return this.values()}*values(){for(const l of this._map.values())yield l}clear(){this._map.clear()}forEach(l,C){this._map.forEach(_=>l.call(C,_,_,this))}[Symbol.iterator](){return this.values()}}e.SetWithKey=R}),define(Pe[60],ke([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.memoize=h,e.debounce=D,e.throttle=A;function s(L){return(R,v,l)=>{let C=null,_=null;if(typeof l.value=="function"?(C="value",_=l.value):typeof l.get=="function"&&(C="get",_=l.get),!_)throw new Error("not supported");l[C]=L(_,v)}}function h(L,R,v){let l=null,C=null;if(typeof v.value=="function"?(l="value",C=v.value,C.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof v.get=="function"&&(l="get",C=v.get),!C)throw new Error("not supported");const _=`$memoize$${R}`;v[l]=function(...f){return this.hasOwnProperty(_)||Object.defineProperty(this,_,{configurable:!1,enumerable:!1,writable:!1,value:C.apply(this,f)}),this[_]}}function D(L,R,v){return s((l,C)=>{const _=`$debounce$${C}`,f=`$debounce$result$${C}`;return function(...T){this[f]||(this[f]=v?v():void 0),clearTimeout(this[_]),R&&(this[f]=R(this[f],...T),T=[this[f]]),this[_]=setTimeout(()=>{l.apply(this,T),this[f]=v?v():void 0},L)}})}function A(L,R,v){return s((l,C)=>{const _=`$throttle$timer$${C}`,f=`$throttle$result$${C}`,T=`$throttle$lastRun$${C}`,S=`$throttle$pending$${C}`;return function(...o){if(this[f]||(this[f]=v?v():void 0),(this[T]===null||this[T]===void 0)&&(this[T]=-Number.MAX_VALUE),R&&(this[f]=R(this[f],...o)),this[S])return;const m=this[T]+L;m<=Date.now()?(this[T]=Date.now(),l.apply(this,[this[f]]),this[f]=v?v():void 0):(this[S]=!0,this[_]=setTimeout(()=>{this[S]=!1,this[T]=Date.now(),l.apply(this,[this[f]]),this[f]=v?v():void 0},m-Date.now()))}})}}),define(Pe[12],ke([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.ReadonlyError=e.CancellationError=e.errorHandler=e.ErrorHandler=void 0,e.setUnexpectedErrorHandler=h,e.isSigPipeError=D,e.onUnexpectedError=A,e.onUnexpectedExternalError=L,e.transformErrorForSerialization=R,e.transformErrorFromSerialization=v,e.isCancellationError=C,e.canceled=f,e.illegalArgument=T,e.illegalState=S,e.getErrorMessage=m;class s{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(r){setTimeout(()=>{throw r.stack?a.isErrorNoTelemetry(r)?new a(r.message+`

`+r.stack):new Error(r.message+`

`+r.stack):r},0)}}addListener(r){return this.listeners.push(r),()=>{this._removeListener(r)}}emit(r){this.listeners.forEach(d=>{d(r)})}_removeListener(r){this.listeners.splice(this.listeners.indexOf(r),1)}setUnexpectedErrorHandler(r){this.unexpectedErrorHandler=r}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(r){this.unexpectedErrorHandler(r),this.emit(r)}onUnexpectedExternalError(r){this.unexpectedErrorHandler(r)}}e.ErrorHandler=s,e.errorHandler=new s;function h(n){e.errorHandler.setUnexpectedErrorHandler(n)}function D(n){if(!n||typeof n!="object")return!1;const r=n;return r.code==="EPIPE"&&r.syscall?.toUpperCase()==="WRITE"}function A(n){C(n)||e.errorHandler.onUnexpectedError(n)}function L(n){C(n)||e.errorHandler.onUnexpectedExternalError(n)}function R(n){if(n instanceof Error){const{name:r,message:d}=n,c=n.stacktrace||n.stack;return{$isError:!0,name:r,message:d,stack:c,noTelemetry:a.isErrorNoTelemetry(n)}}return n}function v(n){let r;return n.noTelemetry?r=new a:(r=new Error,r.name=n.name),r.message=n.message,r.stack=n.stack,r}const l="Canceled";function C(n){return n instanceof _?!0:n instanceof Error&&n.name===l&&n.message===l}class _ extends Error{constructor(){super(l),this.name=this.message}}e.CancellationError=_;function f(){const n=new Error(l);return n.name=n.message,n}function T(n){return n?new Error(`Illegal argument: ${n}`):new Error("Illegal argument")}function S(n){return n?new Error(`Illegal state: ${n}`):new Error("Illegal state")}class o extends TypeError{constructor(r){super(r?`${r} is read-only and cannot be changed`:"Cannot change read-only property")}}e.ReadonlyError=o;function m(n){return n?n.message?n.message:n.stack?n.stack.split(`
`)[0]:String(n):"Error"}class p extends Error{constructor(r){super("NotImplemented"),r&&(this.message=r)}}e.NotImplementedError=p;class u extends Error{constructor(r){super("NotSupported"),r&&(this.message=r)}}e.NotSupportedError=u;class i extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.ExpectedError=i;class a extends Error{constructor(r){super(r),this.name="CodeExpectedError"}static fromError(r){if(r instanceof a)return r;const d=new a;return d.message=r.message,d.stack=r.stack,d}static isErrorNoTelemetry(r){return r.name==="CodeExpectedError"}}e.ErrorNoTelemetry=a;class t extends Error{constructor(r){super(r||"An unexpected bug occurred."),Object.setPrototypeOf(this,t.prototype)}}e.BugIndicatingError=t}),define(Pe[18],ke([1,0,12,133]),function(ge,e,s,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Permutation=e.CallbackIterable=e.ArrayQueue=e.booleanComparator=e.numberComparator=e.CompareResult=void 0,e.tail=D,e.tail2=A,e.equals=L,e.removeFastWithoutKeepingOrder=R,e.binarySearch=v,e.binarySearch2=l,e.quickSelect=C,e.groupBy=_,e.groupAdjacentBy=f,e.forEachAdjacent=T,e.forEachWithNeighbors=S,e.sortedDiff=o,e.delta=m,e.top=p,e.topAsync=u,e.coalesce=a,e.coalesceInPlace=t,e.move=n,e.isFalsyOrEmpty=r,e.isNonEmptyArray=d,e.distinct=c,e.uniqueFilter=g,e.firstOrDefault=w,e.lastOrDefault=y,e.commonPrefixLength=I,e.range=P,e.index=k,e.insert=b,e.remove=E,e.arrayInsert=N,e.shuffle=O,e.pushToStart=M,e.pushToEnd=U,e.pushMany=H,e.mapArrayOrNot=F,e.asArray=x,e.getRandomElement=$,e.insertInto=G,e.splice=B,e.compareBy=J,e.tieBreakComparators=oe,e.reverseOrder=le,e.findAsync=Ee;function D(ae,be=0){return ae[ae.length-(1+be)]}function A(ae){if(ae.length===0)throw new Error("Invalid tail call");return[ae.slice(0,ae.length-1),ae[ae.length-1]]}function L(ae,be,pe=(ve,Re)=>ve===Re){if(ae===be)return!0;if(!ae||!be||ae.length!==be.length)return!1;for(let ve=0,Re=ae.length;ve<Re;ve++)if(!pe(ae[ve],be[ve]))return!1;return!0}function R(ae,be){const pe=ae.length-1;be<pe&&(ae[be]=ae[pe]),ae.pop()}function v(ae,be,pe){return l(ae.length,ve=>pe(ae[ve],be))}function l(ae,be){let pe=0,ve=ae-1;for(;pe<=ve;){const Re=(pe+ve)/2|0,Fe=be(Re);if(Fe<0)pe=Re+1;else if(Fe>0)ve=Re-1;else return Re}return-(pe+1)}function C(ae,be,pe){if(ae=ae|0,ae>=be.length)throw new TypeError("invalid index");const ve=be[Math.floor(be.length*Math.random())],Re=[],Fe=[],Ve=[];for(const Ye of be){const Je=pe(Ye,ve);Je<0?Re.push(Ye):Je>0?Fe.push(Ye):Ve.push(Ye)}return ae<Re.length?C(ae,Re,pe):ae<Re.length+Ve.length?Ve[0]:C(ae-(Re.length+Ve.length),Fe,pe)}function _(ae,be){const pe=[];let ve;for(const Re of ae.slice(0).sort(be))!ve||be(ve[0],Re)!==0?(ve=[Re],pe.push(ve)):ve.push(Re);return pe}function*f(ae,be){let pe,ve;for(const Re of ae)ve!==void 0&&be(ve,Re)?pe.push(Re):(pe&&(yield pe),pe=[Re]),ve=Re;pe&&(yield pe)}function T(ae,be){for(let pe=0;pe<=ae.length;pe++)be(pe===0?void 0:ae[pe-1],pe===ae.length?void 0:ae[pe])}function S(ae,be){for(let pe=0;pe<ae.length;pe++)be(pe===0?void 0:ae[pe-1],ae[pe],pe+1===ae.length?void 0:ae[pe+1])}function o(ae,be,pe){const ve=[];function Re(Ye,Je,xe){if(Je===0&&xe.length===0)return;const ze=ve[ve.length-1];ze&&ze.start+ze.deleteCount===Ye?(ze.deleteCount+=Je,ze.toInsert.push(...xe)):ve.push({start:Ye,deleteCount:Je,toInsert:xe})}let Fe=0,Ve=0;for(;;){if(Fe===ae.length){Re(Fe,0,be.slice(Ve));break}if(Ve===be.length){Re(Fe,ae.length-Fe,[]);break}const Ye=ae[Fe],Je=be[Ve],xe=pe(Ye,Je);xe===0?(Fe+=1,Ve+=1):xe<0?(Re(Fe,1,[]),Fe+=1):xe>0&&(Re(Fe,0,[Je]),Ve+=1)}return ve}function m(ae,be,pe){const ve=o(ae,be,pe),Re=[],Fe=[];for(const Ve of ve)Re.push(...ae.slice(Ve.start,Ve.start+Ve.deleteCount)),Fe.push(...Ve.toInsert);return{removed:Re,added:Fe}}function p(ae,be,pe){if(pe===0)return[];const ve=ae.slice(0,pe).sort(be);return i(ae,be,ve,pe,ae.length),ve}function u(ae,be,pe,ve,Re){return pe===0?Promise.resolve([]):new Promise((Fe,Ve)=>{(async()=>{const Ye=ae.length,Je=ae.slice(0,pe).sort(be);for(let xe=pe,ze=Math.min(pe+ve,Ye);xe<Ye;xe=ze,ze=Math.min(ze+ve,Ye)){if(xe>pe&&await new Promise(Ne=>setTimeout(Ne)),Re&&Re.isCancellationRequested)throw new s.CancellationError;i(ae,be,Je,xe,ze)}return Je})().then(Fe,Ve)})}function i(ae,be,pe,ve,Re){for(const Fe=pe.length;ve<Re;ve++){const Ve=ae[ve];if(be(Ve,pe[Fe-1])<0){pe.pop();const Ye=(0,h.findFirstIdxMonotonousOrArrLen)(pe,Je=>be(Ve,Je)<0);pe.splice(Ye,0,Ve)}}}function a(ae){return ae.filter(be=>!!be)}function t(ae){let be=0;for(let pe=0;pe<ae.length;pe++)ae[pe]&&(ae[be]=ae[pe],be+=1);ae.length=be}function n(ae,be,pe){ae.splice(pe,0,ae.splice(be,1)[0])}function r(ae){return!Array.isArray(ae)||ae.length===0}function d(ae){return Array.isArray(ae)&&ae.length>0}function c(ae,be=pe=>pe){const pe=new Set;return ae.filter(ve=>{const Re=be(ve);return pe.has(Re)?!1:(pe.add(Re),!0)})}function g(ae){const be=new Set;return pe=>{const ve=ae(pe);return be.has(ve)?!1:(be.add(ve),!0)}}function w(ae,be){return ae.length>0?ae[0]:be}function y(ae,be){return ae.length>0?ae[ae.length-1]:be}function I(ae,be,pe=(ve,Re)=>ve===Re){let ve=0;for(let Re=0,Fe=Math.min(ae.length,be.length);Re<Fe&&pe(ae[Re],be[Re]);Re++)ve++;return ve}function P(ae,be){let pe=typeof be=="number"?ae:0;typeof be=="number"?pe=ae:(pe=0,be=ae);const ve=[];if(pe<=be)for(let Re=pe;Re<be;Re++)ve.push(Re);else for(let Re=pe;Re>be;Re--)ve.push(Re);return ve}function k(ae,be,pe){return ae.reduce((ve,Re)=>(ve[be(Re)]=pe?pe(Re):Re,ve),Object.create(null))}function b(ae,be){return ae.push(be),()=>E(ae,be)}function E(ae,be){const pe=ae.indexOf(be);if(pe>-1)return ae.splice(pe,1),be}function N(ae,be,pe){const ve=ae.slice(0,be),Re=ae.slice(be);return ve.concat(pe,Re)}function O(ae,be){let pe;if(typeof be=="number"){let ve=be;pe=()=>{const Re=Math.sin(ve++)*179426549;return Re-Math.floor(Re)}}else pe=Math.random;for(let ve=ae.length-1;ve>0;ve-=1){const Re=Math.floor(pe()*(ve+1)),Fe=ae[ve];ae[ve]=ae[Re],ae[Re]=Fe}}function M(ae,be){const pe=ae.indexOf(be);pe>-1&&(ae.splice(pe,1),ae.unshift(be))}function U(ae,be){const pe=ae.indexOf(be);pe>-1&&(ae.splice(pe,1),ae.push(be))}function H(ae,be){for(const pe of be)ae.push(pe)}function F(ae,be){return Array.isArray(ae)?ae.map(be):be(ae)}function x(ae){return Array.isArray(ae)?ae:[ae]}function $(ae){return ae[Math.floor(Math.random()*ae.length)]}function G(ae,be,pe){const ve=W(ae,be),Re=ae.length,Fe=pe.length;ae.length=Re+Fe;for(let Ve=Re-1;Ve>=ve;Ve--)ae[Ve+Fe]=ae[Ve];for(let Ve=0;Ve<Fe;Ve++)ae[Ve+ve]=pe[Ve]}function B(ae,be,pe,ve){const Re=W(ae,be);let Fe=ae.splice(Re,pe);return Fe===void 0&&(Fe=[]),G(ae,Re,ve),Fe}function W(ae,be){return be<0?Math.max(be+ae.length,0):Math.min(be,ae.length)}var Z;(function(ae){function be(Fe){return Fe<0}ae.isLessThan=be;function pe(Fe){return Fe<=0}ae.isLessThanOrEqual=pe;function ve(Fe){return Fe>0}ae.isGreaterThan=ve;function Re(Fe){return Fe===0}ae.isNeitherLessOrGreaterThan=Re,ae.greaterThan=1,ae.lessThan=-1,ae.neitherLessOrGreaterThan=0})(Z||(e.CompareResult=Z={}));function J(ae,be){return(pe,ve)=>be(ae(pe),ae(ve))}function oe(...ae){return(be,pe)=>{for(const ve of ae){const Re=ve(be,pe);if(!Z.isNeitherLessOrGreaterThan(Re))return Re}return Z.neitherLessOrGreaterThan}}const te=(ae,be)=>ae-be;e.numberComparator=te;const me=(ae,be)=>(0,e.numberComparator)(ae?1:0,be?1:0);e.booleanComparator=me;function le(ae){return(be,pe)=>-ae(be,pe)}class Q{constructor(be){this.items=be,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(be){let pe=this.firstIdx;for(;pe<this.items.length&&be(this.items[pe]);)pe++;const ve=pe===this.firstIdx?null:this.items.slice(this.firstIdx,pe);return this.firstIdx=pe,ve}takeFromEndWhile(be){let pe=this.lastIdx;for(;pe>=0&&be(this.items[pe]);)pe--;const ve=pe===this.lastIdx?null:this.items.slice(pe+1,this.lastIdx+1);return this.lastIdx=pe,ve}peek(){if(this.length!==0)return this.items[this.firstIdx]}peekLast(){if(this.length!==0)return this.items[this.lastIdx]}dequeue(){const be=this.items[this.firstIdx];return this.firstIdx++,be}removeLast(){const be=this.items[this.lastIdx];return this.lastIdx--,be}takeCount(be){const pe=this.items.slice(this.firstIdx,this.firstIdx+be);return this.firstIdx+=be,pe}}e.ArrayQueue=Q;class z{static{this.empty=new z(be=>{})}constructor(be){this.iterate=be}forEach(be){this.iterate(pe=>(be(pe),!0))}toArray(){const be=[];return this.iterate(pe=>(be.push(pe),!0)),be}filter(be){return new z(pe=>this.iterate(ve=>be(ve)?pe(ve):!0))}map(be){return new z(pe=>this.iterate(ve=>pe(be(ve))))}some(be){let pe=!1;return this.iterate(ve=>(pe=be(ve),!pe)),pe}findFirst(be){let pe;return this.iterate(ve=>be(ve)?(pe=ve,!1):!0),pe}findLast(be){let pe;return this.iterate(ve=>(be(ve)&&(pe=ve),!0)),pe}findLastMaxBy(be){let pe,ve=!0;return this.iterate(Re=>((ve||Z.isGreaterThan(be(Re,pe)))&&(ve=!1,pe=Re),!0)),pe}}e.CallbackIterable=z;class se{constructor(be){this._indexMap=be}static createSortPermutation(be,pe){const ve=Array.from(be.keys()).sort((Re,Fe)=>pe(be[Re],be[Fe]));return new se(ve)}apply(be){return be.map((pe,ve)=>be[this._indexMap[ve]])}inverse(){const be=this._indexMap.slice();for(let pe=0;pe<this._indexMap.length;pe++)be[this._indexMap[pe]]=pe;return new se(be)}}e.Permutation=se;async function Ee(ae,be){return(await Promise.all(ae.map(async(ve,Re)=>({element:ve,ok:await be(ve,Re)})))).find(ve=>ve.ok)?.element}}),define(Pe[67],ke([1,0,12]),function(ge,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=h,e.assertNever=D,e.assert=A,e.softAssert=L,e.assertFn=R,e.checkAdjacentItems=v;function h(l,C){if(!l)throw new Error(C?`Assertion failed (${C})`:"Assertion Failed")}function D(l,C="Unreachable"){throw new Error(C)}function A(l,C="unexpected state"){if(!l)throw new s.BugIndicatingError(`Assertion Failed: ${C}`)}function L(l){l||(0,s.onUnexpectedError)(new s.BugIndicatingError("Soft Assertion Failed"))}function R(l){if(!l()){debugger;l(),(0,s.onUnexpectedError)(new s.BugIndicatingError("Assertion Failed"))}}function v(l,C){let _=0;for(;_<l.length-1;){const f=l[_],T=l[_+1];if(!C(f,T))return!1;_++}return!0}});var qn=this&&this.__createBinding||(Object.create?function(ge,e,s,h){h===void 0&&(h=s);var D=Object.getOwnPropertyDescriptor(e,s);(!D||("get"in D?!e.__esModule:D.writable||D.configurable))&&(D={enumerable:!0,get:function(){return e[s]}}),Object.defineProperty(ge,h,D)}:function(ge,e,s,h){h===void 0&&(h=s),ge[h]=e[s]}),jn=this&&this.__setModuleDefault||(Object.create?function(ge,e){Object.defineProperty(ge,"default",{enumerable:!0,value:e})}:function(ge,e){ge.default=e}),We=this&&this.__importStar||function(ge){if(ge&&ge.__esModule)return ge;var e={};if(ge!=null)for(var s in ge)s!=="default"&&Object.prototype.hasOwnProperty.call(ge,s)&&qn(e,ge,s);return jn(e,ge),e};define(Pe[179],ke([1,0,18]),function(ge,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.strictEquals=void 0,e.itemsEquals=D,e.jsonStringifyEquals=A,e.itemEquals=L,e.equalsIfDefined=R,e.structuralEquals=v,e.getStructuralKey=l,s=We(s);const h=(T,S)=>T===S;e.strictEquals=h;function D(T=e.strictEquals){return(S,o)=>s.equals(S,o,T)}function A(){return(T,S)=>JSON.stringify(T)===JSON.stringify(S)}function L(){return(T,S)=>T.equals(S)}function R(T,S,o){if(o!==void 0){const m=T;return m==null||S===void 0||S===null?S===m:o(m,S)}else{const m=T;return(p,u)=>p==null||u===void 0||u===null?u===p:m(p,u)}}function v(T,S){if(T===S)return!0;if(Array.isArray(T)&&Array.isArray(S)){if(T.length!==S.length)return!1;for(let o=0;o<T.length;o++)if(!v(T[o],S[o]))return!1;return!0}if(T&&typeof T=="object"&&S&&typeof S=="object"&&Object.getPrototypeOf(T)===Object.prototype&&Object.getPrototypeOf(S)===Object.prototype){const o=T,m=S,p=Object.keys(o),u=Object.keys(m),i=new Set(u);if(p.length!==u.length)return!1;for(const a of p)if(!i.has(a)||!v(o[a],m[a]))return!1;return!0}return!1}function l(T){return JSON.stringify(f(T))}let C=0;const _=new WeakMap;function f(T){if(Array.isArray(T))return T.map(f);if(T&&typeof T=="object")if(Object.getPrototypeOf(T)===Object.prototype){const S=T,o=Object.create(null);for(const m of Object.keys(S).sort())o[m]=f(S[m]);return o}else{let S=_.get(T);return S===void 0&&(S=C++,_.set(T,S)),S+"----2b76a038c20c4bcc"}return T}}),define(Pe[81],ke([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createSingleCallFunction=s;function s(h,D){const A=this;let L=!1,R;return function(){if(L)return R;if(L=!0,D)try{R=h.apply(A,arguments)}finally{D()}else R=h.apply(A,arguments);return R}}}),define(Pe[134],ke([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class s{constructor(D){this._prefix=D,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=s,e.defaultGenerator=new s("id#")}),define(Pe[40],ke([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var s;(function(h){function D(r){return r&&typeof r=="object"&&typeof r[Symbol.iterator]=="function"}h.is=D;const A=Object.freeze([]);function L(){return A}h.empty=L;function*R(r){yield r}h.single=R;function v(r){return D(r)?r:R(r)}h.wrap=v;function l(r){return r||A}h.from=l;function*C(r){for(let d=r.length-1;d>=0;d--)yield r[d]}h.reverse=C;function _(r){return!r||r[Symbol.iterator]().next().done===!0}h.isEmpty=_;function f(r){return r[Symbol.iterator]().next().value}h.first=f;function T(r,d){let c=0;for(const g of r)if(d(g,c++))return!0;return!1}h.some=T;function S(r,d){for(const c of r)if(d(c))return c}h.find=S;function*o(r,d){for(const c of r)d(c)&&(yield c)}h.filter=o;function*m(r,d){let c=0;for(const g of r)yield d(g,c++)}h.map=m;function*p(r,d){let c=0;for(const g of r)yield*d(g,c++)}h.flatMap=p;function*u(...r){for(const d of r)yield*d}h.concat=u;function i(r,d,c){let g=c;for(const w of r)g=d(g,w);return g}h.reduce=i;function*a(r,d,c=r.length){for(d<0&&(d+=r.length),c<0?c+=r.length:c>r.length&&(c=r.length);d<c;d++)yield r[d]}h.slice=a;function t(r,d=Number.POSITIVE_INFINITY){const c=[];if(d===0)return[c,r];const g=r[Symbol.iterator]();for(let w=0;w<d;w++){const y=g.next();if(y.done)return[c,h.empty()];c.push(y.value)}return[c,{[Symbol.iterator](){return g}}]}h.consume=t;async function n(r){const d=[];for await(const c of r)d.push(c);return Promise.resolve(d)}h.asyncToArray=n})(s||(e.Iterable=s={}))}),define(Pe[180],ke([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.createScanner=L,e.getLocation=_,e.parse=f,e.parseTree=T,e.findNodeAtLocation=S,e.getNodePath=o,e.getNodeValue=m,e.contains=p,e.findNodeAtOffset=u,e.visit=i,e.getNodeType=a;var s;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(s||(e.ScanError=s={}));var h;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(h||(e.SyntaxKind=h={}));var D;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(D||(e.ParseErrorCode=D={}));var A;(function(t){t.DEFAULT={allowTrailingComma:!0}})(A||(e.ParseOptions=A={}));function L(t,n=!1){let r=0;const d=t.length;let c="",g=0,w=h.Unknown,y=s.None;function I(M){let U=0,H=0;for(;U<M;){const F=t.charCodeAt(r);if(F>=C._0&&F<=C._9)H=H*16+F-C._0;else if(F>=C.A&&F<=C.F)H=H*16+F-C.A+10;else if(F>=C.a&&F<=C.f)H=H*16+F-C.a+10;else break;r++,U++}return U<M&&(H=-1),H}function P(M){r=M,c="",g=0,w=h.Unknown,y=s.None}function k(){const M=r;if(t.charCodeAt(r)===C._0)r++;else for(r++;r<t.length&&l(t.charCodeAt(r));)r++;if(r<t.length&&t.charCodeAt(r)===C.dot)if(r++,r<t.length&&l(t.charCodeAt(r)))for(r++;r<t.length&&l(t.charCodeAt(r));)r++;else return y=s.UnexpectedEndOfNumber,t.substring(M,r);let U=r;if(r<t.length&&(t.charCodeAt(r)===C.E||t.charCodeAt(r)===C.e))if(r++,(r<t.length&&t.charCodeAt(r)===C.plus||t.charCodeAt(r)===C.minus)&&r++,r<t.length&&l(t.charCodeAt(r))){for(r++;r<t.length&&l(t.charCodeAt(r));)r++;U=r}else y=s.UnexpectedEndOfNumber;return t.substring(M,U)}function b(){let M="",U=r;for(;;){if(r>=d){M+=t.substring(U,r),y=s.UnexpectedEndOfString;break}const H=t.charCodeAt(r);if(H===C.doubleQuote){M+=t.substring(U,r),r++;break}if(H===C.backslash){if(M+=t.substring(U,r),r++,r>=d){y=s.UnexpectedEndOfString;break}switch(t.charCodeAt(r++)){case C.doubleQuote:M+='"';break;case C.backslash:M+="\\";break;case C.slash:M+="/";break;case C.b:M+="\b";break;case C.f:M+="\f";break;case C.n:M+=`
`;break;case C.r:M+="\r";break;case C.t:M+="	";break;case C.u:{const x=I(4);x>=0?M+=String.fromCharCode(x):y=s.InvalidUnicode;break}default:y=s.InvalidEscapeCharacter}U=r;continue}if(H>=0&&H<=31)if(v(H)){M+=t.substring(U,r),y=s.UnexpectedEndOfString;break}else y=s.InvalidCharacter;r++}return M}function E(){if(c="",y=s.None,g=r,r>=d)return g=d,w=h.EOF;let M=t.charCodeAt(r);if(R(M)){do r++,c+=String.fromCharCode(M),M=t.charCodeAt(r);while(R(M));return w=h.Trivia}if(v(M))return r++,c+=String.fromCharCode(M),M===C.carriageReturn&&t.charCodeAt(r)===C.lineFeed&&(r++,c+=`
`),w=h.LineBreakTrivia;switch(M){case C.openBrace:return r++,w=h.OpenBraceToken;case C.closeBrace:return r++,w=h.CloseBraceToken;case C.openBracket:return r++,w=h.OpenBracketToken;case C.closeBracket:return r++,w=h.CloseBracketToken;case C.colon:return r++,w=h.ColonToken;case C.comma:return r++,w=h.CommaToken;case C.doubleQuote:return r++,c=b(),w=h.StringLiteral;case C.slash:{const U=r-1;if(t.charCodeAt(r+1)===C.slash){for(r+=2;r<d&&!v(t.charCodeAt(r));)r++;return c=t.substring(U,r),w=h.LineCommentTrivia}if(t.charCodeAt(r+1)===C.asterisk){r+=2;const H=d-1;let F=!1;for(;r<H;){if(t.charCodeAt(r)===C.asterisk&&t.charCodeAt(r+1)===C.slash){r+=2,F=!0;break}r++}return F||(r++,y=s.UnexpectedEndOfComment),c=t.substring(U,r),w=h.BlockCommentTrivia}return c+=String.fromCharCode(M),r++,w=h.Unknown}case C.minus:if(c+=String.fromCharCode(M),r++,r===d||!l(t.charCodeAt(r)))return w=h.Unknown;case C._0:case C._1:case C._2:case C._3:case C._4:case C._5:case C._6:case C._7:case C._8:case C._9:return c+=k(),w=h.NumericLiteral;default:for(;r<d&&N(M);)r++,M=t.charCodeAt(r);if(g!==r){switch(c=t.substring(g,r),c){case"true":return w=h.TrueKeyword;case"false":return w=h.FalseKeyword;case"null":return w=h.NullKeyword}return w=h.Unknown}return c+=String.fromCharCode(M),r++,w=h.Unknown}}function N(M){if(R(M)||v(M))return!1;switch(M){case C.closeBrace:case C.closeBracket:case C.openBrace:case C.openBracket:case C.doubleQuote:case C.colon:case C.comma:case C.slash:return!1}return!0}function O(){let M;do M=E();while(M>=h.LineCommentTrivia&&M<=h.Trivia);return M}return{setPosition:P,getPosition:()=>r,scan:n?O:E,getToken:()=>w,getTokenValue:()=>c,getTokenOffset:()=>g,getTokenLength:()=>r-g,getTokenError:()=>y}}function R(t){return t===C.space||t===C.tab||t===C.verticalTab||t===C.formFeed||t===C.nonBreakingSpace||t===C.ogham||t>=C.enQuad&&t<=C.zeroWidthSpace||t===C.narrowNoBreakSpace||t===C.mathematicalSpace||t===C.ideographicSpace||t===C.byteOrderMark}function v(t){return t===C.lineFeed||t===C.carriageReturn||t===C.lineSeparator||t===C.paragraphSeparator}function l(t){return t>=C._0&&t<=C._9}var C;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(C||(C={}));function _(t,n){const r=[],d=new Object;let c;const g={value:{},offset:0,length:0,type:"object",parent:void 0};let w=!1;function y(I,P,k,b){g.value=I,g.offset=P,g.length=k,g.type=b,g.colonOffset=void 0,c=g}try{i(t,{onObjectBegin:(I,P)=>{if(n<=I)throw d;c=void 0,w=n>I,r.push("")},onObjectProperty:(I,P,k)=>{if(n<P||(y(I,P,k,"property"),r[r.length-1]=I,n<=P+k))throw d},onObjectEnd:(I,P)=>{if(n<=I)throw d;c=void 0,r.pop()},onArrayBegin:(I,P)=>{if(n<=I)throw d;c=void 0,r.push(0)},onArrayEnd:(I,P)=>{if(n<=I)throw d;c=void 0,r.pop()},onLiteralValue:(I,P,k)=>{if(n<P||(y(I,P,k,a(I)),n<=P+k))throw d},onSeparator:(I,P,k)=>{if(n<=P)throw d;if(I===":"&&c&&c.type==="property")c.colonOffset=P,w=!1,c=void 0;else if(I===","){const b=r[r.length-1];typeof b=="number"?r[r.length-1]=b+1:(w=!0,r[r.length-1]=""),c=void 0}}})}catch(I){if(I!==d)throw I}return{path:r,previousNode:c,isAtPropertyKey:w,matches:I=>{let P=0;for(let k=0;P<I.length&&k<r.length;k++)if(I[P]===r[k]||I[P]==="*")P++;else if(I[P]!=="**")return!1;return P===I.length}}}function f(t,n=[],r=A.DEFAULT){let d=null,c=[];const g=[];function w(I){Array.isArray(c)?c.push(I):d!==null&&(c[d]=I)}return i(t,{onObjectBegin:()=>{const I={};w(I),g.push(c),c=I,d=null},onObjectProperty:I=>{d=I},onObjectEnd:()=>{c=g.pop()},onArrayBegin:()=>{const I=[];w(I),g.push(c),c=I,d=null},onArrayEnd:()=>{c=g.pop()},onLiteralValue:w,onError:(I,P,k)=>{n.push({error:I,offset:P,length:k})}},r),c[0]}function T(t,n=[],r=A.DEFAULT){let d={type:"array",offset:-1,length:-1,children:[],parent:void 0};function c(I){d.type==="property"&&(d.length=I-d.offset,d=d.parent)}function g(I){return d.children.push(I),I}i(t,{onObjectBegin:I=>{d=g({type:"object",offset:I,length:-1,parent:d,children:[]})},onObjectProperty:(I,P,k)=>{d=g({type:"property",offset:P,length:-1,parent:d,children:[]}),d.children.push({type:"string",value:I,offset:P,length:k,parent:d})},onObjectEnd:(I,P)=>{d.length=I+P-d.offset,d=d.parent,c(I+P)},onArrayBegin:(I,P)=>{d=g({type:"array",offset:I,length:-1,parent:d,children:[]})},onArrayEnd:(I,P)=>{d.length=I+P-d.offset,d=d.parent,c(I+P)},onLiteralValue:(I,P,k)=>{g({type:a(I),offset:P,length:k,parent:d,value:I}),c(P+k)},onSeparator:(I,P,k)=>{d.type==="property"&&(I===":"?d.colonOffset=P:I===","&&c(P))},onError:(I,P,k)=>{n.push({error:I,offset:P,length:k})}},r);const y=d.children[0];return y&&delete y.parent,y}function S(t,n){if(!t)return;let r=t;for(const d of n)if(typeof d=="string"){if(r.type!=="object"||!Array.isArray(r.children))return;let c=!1;for(const g of r.children)if(Array.isArray(g.children)&&g.children[0].value===d){r=g.children[1],c=!0;break}if(!c)return}else{const c=d;if(r.type!=="array"||c<0||!Array.isArray(r.children)||c>=r.children.length)return;r=r.children[c]}return r}function o(t){if(!t.parent||!t.parent.children)return[];const n=o(t.parent);if(t.parent.type==="property"){const r=t.parent.children[0].value;n.push(r)}else if(t.parent.type==="array"){const r=t.parent.children.indexOf(t);r!==-1&&n.push(r)}return n}function m(t){switch(t.type){case"array":return t.children.map(m);case"object":{const n=Object.create(null);for(const r of t.children){const d=r.children[1];d&&(n[r.children[0].value]=m(d))}return n}case"null":case"string":case"number":case"boolean":return t.value;default:return}}function p(t,n,r=!1){return n>=t.offset&&n<t.offset+t.length||r&&n===t.offset+t.length}function u(t,n,r=!1){if(p(t,n,r)){const d=t.children;if(Array.isArray(d))for(let c=0;c<d.length&&d[c].offset<=n;c++){const g=u(d[c],n,r);if(g)return g}return t}}function i(t,n,r=A.DEFAULT){const d=L(t,!1);function c(J){return J?()=>J(d.getTokenOffset(),d.getTokenLength()):()=>!0}function g(J){return J?oe=>J(oe,d.getTokenOffset(),d.getTokenLength()):()=>!0}const w=c(n.onObjectBegin),y=g(n.onObjectProperty),I=c(n.onObjectEnd),P=c(n.onArrayBegin),k=c(n.onArrayEnd),b=g(n.onLiteralValue),E=g(n.onSeparator),N=c(n.onComment),O=g(n.onError),M=r&&r.disallowComments,U=r&&r.allowTrailingComma;function H(){for(;;){const J=d.scan();switch(d.getTokenError()){case s.InvalidUnicode:F(D.InvalidUnicode);break;case s.InvalidEscapeCharacter:F(D.InvalidEscapeCharacter);break;case s.UnexpectedEndOfNumber:F(D.UnexpectedEndOfNumber);break;case s.UnexpectedEndOfComment:M||F(D.UnexpectedEndOfComment);break;case s.UnexpectedEndOfString:F(D.UnexpectedEndOfString);break;case s.InvalidCharacter:F(D.InvalidCharacter);break}switch(J){case h.LineCommentTrivia:case h.BlockCommentTrivia:M?F(D.InvalidCommentToken):N();break;case h.Unknown:F(D.InvalidSymbol);break;case h.Trivia:case h.LineBreakTrivia:break;default:return J}}}function F(J,oe=[],te=[]){if(O(J),oe.length+te.length>0){let me=d.getToken();for(;me!==h.EOF;){if(oe.indexOf(me)!==-1){H();break}else if(te.indexOf(me)!==-1)break;me=H()}}}function x(J){const oe=d.getTokenValue();return J?b(oe):y(oe),H(),!0}function $(){switch(d.getToken()){case h.NumericLiteral:{let J=0;try{J=JSON.parse(d.getTokenValue()),typeof J!="number"&&(F(D.InvalidNumberFormat),J=0)}catch{F(D.InvalidNumberFormat)}b(J);break}case h.NullKeyword:b(null);break;case h.TrueKeyword:b(!0);break;case h.FalseKeyword:b(!1);break;default:return!1}return H(),!0}function G(){return d.getToken()!==h.StringLiteral?(F(D.PropertyNameExpected,[],[h.CloseBraceToken,h.CommaToken]),!1):(x(!1),d.getToken()===h.ColonToken?(E(":"),H(),Z()||F(D.ValueExpected,[],[h.CloseBraceToken,h.CommaToken])):F(D.ColonExpected,[],[h.CloseBraceToken,h.CommaToken]),!0)}function B(){w(),H();let J=!1;for(;d.getToken()!==h.CloseBraceToken&&d.getToken()!==h.EOF;){if(d.getToken()===h.CommaToken){if(J||F(D.ValueExpected,[],[]),E(","),H(),d.getToken()===h.CloseBraceToken&&U)break}else J&&F(D.CommaExpected,[],[]);G()||F(D.ValueExpected,[],[h.CloseBraceToken,h.CommaToken]),J=!0}return I(),d.getToken()!==h.CloseBraceToken?F(D.CloseBraceExpected,[h.CloseBraceToken],[]):H(),!0}function W(){P(),H();let J=!1;for(;d.getToken()!==h.CloseBracketToken&&d.getToken()!==h.EOF;){if(d.getToken()===h.CommaToken){if(J||F(D.ValueExpected,[],[]),E(","),H(),d.getToken()===h.CloseBracketToken&&U)break}else J&&F(D.CommaExpected,[],[]);Z()||F(D.ValueExpected,[],[h.CloseBracketToken,h.CommaToken]),J=!0}return k(),d.getToken()!==h.CloseBracketToken?F(D.CloseBracketExpected,[h.CloseBracketToken],[]):H(),!0}function Z(){switch(d.getToken()){case h.OpenBracketToken:return W();case h.OpenBraceToken:return B();case h.StringLiteral:return x(!0);default:return $()}}return H(),d.getToken()===h.EOF?r.allowEmptyContent?!0:(F(D.ValueExpected,[],[]),!1):Z()?(d.getToken()!==h.EOF&&F(D.EndOfFileExpected,[],[]),!0):(F(D.ValueExpected,[],[]),!1)}function a(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}}),define(Pe[181],ke([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getCompressedContent=s;function s(A){let L=!1;const R=new Map,v=new Map;if(D(A,o=>{if(A===o)return!0;const m=JSON.stringify(o);if(m.length<30)return!0;const p=R.get(m);if(!p){const u={schemas:[o]};return R.set(m,u),v.set(o,u),!0}return p.schemas.push(o),v.set(o,p),L=!0,!1}),R.clear(),!L)return JSON.stringify(A);let C="$defs";for(;A.hasOwnProperty(C);)C+="_";const _=[];function f(o){return JSON.stringify(o,(m,p)=>{if(p!==o){const u=v.get(p);if(u&&u.schemas.length>1)return u.id||(u.id=`_${_.length}`,_.push(u.schemas[0])),{$ref:`#/${C}/${u.id}`}}return p})}const T=f(A),S=[];for(let o=0;o<_.length;o++)S.push(`"_${o}":${f(_[o])}`);return S.length?`${T.substring(0,T.length-1)},"${C}":{${S.join(",")}}}`:T}function h(A){return typeof A=="object"&&A!==null}function D(A,L){if(!A||typeof A!="object")return;const R=(...T)=>{for(const S of T)h(S)&&_.push(S)},v=(...T)=>{for(const S of T)if(h(S))for(const o in S){const m=S[o];h(m)&&_.push(m)}},l=(...T)=>{for(const S of T)if(Array.isArray(S))for(const o of S)h(o)&&_.push(o)},C=T=>{if(Array.isArray(T))for(const S of T)h(S)&&_.push(S);else h(T)&&_.push(T)},_=[A];let f=_.pop();for(;f;)L(f)&&(R(f.additionalItems,f.additionalProperties,f.not,f.contains,f.propertyNames,f.if,f.then,f.else,f.unevaluatedItems,f.unevaluatedProperties),v(f.definitions,f.$defs,f.properties,f.patternProperties,f.dependencies,f.dependentSchemas),l(f.anyOf,f.allOf,f.oneOf,f.prefixItems),C(f.items)),f=_.pop()}}),define(Pe[50],ke([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class s{constructor(D){this.executor=D,this._didRun=!1}get hasValue(){return this._didRun}get value(){if(!this._didRun)try{this._value=this.executor()}catch(D){this._error=D}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}}e.Lazy=s}),define(Pe[82],ke([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class s{static{this.Undefined=new s(void 0)}constructor(A){this.element=A,this.next=s.Undefined,this.prev=s.Undefined}}class h{constructor(){this._first=s.Undefined,this._last=s.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===s.Undefined}clear(){let A=this._first;for(;A!==s.Undefined;){const L=A.next;A.prev=s.Undefined,A.next=s.Undefined,A=L}this._first=s.Undefined,this._last=s.Undefined,this._size=0}unshift(A){return this._insert(A,!1)}push(A){return this._insert(A,!0)}_insert(A,L){const R=new s(A);if(this._first===s.Undefined)this._first=R,this._last=R;else if(L){const l=this._last;this._last=R,R.prev=l,l.next=R}else{const l=this._first;this._first=R,R.next=l,l.prev=R}this._size+=1;let v=!1;return()=>{v||(v=!0,this._remove(R))}}shift(){if(this._first!==s.Undefined){const A=this._first.element;return this._remove(this._first),A}}pop(){if(this._last!==s.Undefined){const A=this._last.element;return this._remove(this._last),A}}_remove(A){if(A.prev!==s.Undefined&&A.next!==s.Undefined){const L=A.prev;L.next=A.next,A.next.prev=L}else A.prev===s.Undefined&&A.next===s.Undefined?(this._first=s.Undefined,this._last=s.Undefined):A.next===s.Undefined?(this._last=this._last.prev,this._last.next=s.Undefined):A.prev===s.Undefined&&(this._first=this._first.next,this._first.prev=s.Undefined);this._size-=1}*[Symbol.iterator](){let A=this._first;for(;A!==s.Undefined;)yield A.element,A=A.next}}e.LinkedList=h}),define(Pe[28],ke([1,0]),function(ge,e){"use strict";var s,h,D;Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.BidirectionalMap=e.CounterSet=e.MRUCache=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=void 0,e.getOrSet=A,e.mapToString=L,e.setToString=R,e.mapsStrictEqualIgnoreOrder=a;function A(t,n,r){let d=t.get(n);return d===void 0&&(d=r,t.set(n,d)),d}function L(t){const n=[];return t.forEach((r,d)=>{n.push(`${d} => ${r}`)}),`Map(${t.size}) {${n.join(", ")}}`}function R(t){const n=[];return t.forEach(r=>{n.push(r)}),`Set(${t.size}) {${n.join(", ")}}`}class v{constructor(n,r){this.uri=n,this.value=r}}function l(t){return Array.isArray(t)}class C{static{this.defaultToKey=n=>n.toString()}constructor(n,r){if(this[s]="ResourceMap",n instanceof C)this.map=new Map(n.map),this.toKey=r??C.defaultToKey;else if(l(n)){this.map=new Map,this.toKey=r??C.defaultToKey;for(const[d,c]of n)this.set(d,c)}else this.map=new Map,this.toKey=n??C.defaultToKey}set(n,r){return this.map.set(this.toKey(n),new v(n,r)),this}get(n){return this.map.get(this.toKey(n))?.value}has(n){return this.map.has(this.toKey(n))}get size(){return this.map.size}clear(){this.map.clear()}delete(n){return this.map.delete(this.toKey(n))}forEach(n,r){typeof r<"u"&&(n=n.bind(r));for(const[d,c]of this.map)n(c.value,c.uri,this)}*values(){for(const n of this.map.values())yield n.value}*keys(){for(const n of this.map.values())yield n.uri}*entries(){for(const n of this.map.values())yield[n.uri,n.value]}*[(s=Symbol.toStringTag,Symbol.iterator)](){for(const[,n]of this.map)yield[n.uri,n.value]}}e.ResourceMap=C;class _{constructor(n,r){this[h]="ResourceSet",!n||typeof n=="function"?this._map=new C(n):(this._map=new C(r),n.forEach(this.add,this))}get size(){return this._map.size}add(n){return this._map.set(n,n),this}clear(){this._map.clear()}delete(n){return this._map.delete(n)}forEach(n,r){this._map.forEach((d,c)=>n.call(r,c,c,this))}has(n){return this._map.has(n)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(h=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=_;var f;(function(t){t[t.None=0]="None",t[t.AsOld=1]="AsOld",t[t.AsNew=2]="AsNew"})(f||(e.Touch=f={}));class T{constructor(){this[D]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(n){return this._map.has(n)}get(n,r=f.None){const d=this._map.get(n);if(d)return r!==f.None&&this.touch(d,r),d.value}set(n,r,d=f.None){let c=this._map.get(n);if(c)c.value=r,d!==f.None&&this.touch(c,d);else{switch(c={key:n,value:r,next:void 0,previous:void 0},d){case f.None:this.addItemLast(c);break;case f.AsOld:this.addItemFirst(c);break;case f.AsNew:this.addItemLast(c);break;default:this.addItemLast(c);break}this._map.set(n,c),this._size++}return this}delete(n){return!!this.remove(n)}remove(n){const r=this._map.get(n);if(r)return this._map.delete(n),this.removeItem(r),this._size--,r.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const n=this._head;return this._map.delete(n.key),this.removeItem(n),this._size--,n.value}forEach(n,r){const d=this._state;let c=this._head;for(;c;){if(r?n.bind(r)(c.value,c.key,this):n(c.value,c.key,this),this._state!==d)throw new Error("LinkedMap got modified during iteration.");c=c.next}}keys(){const n=this,r=this._state;let d=this._head;const c={[Symbol.iterator](){return c},next(){if(n._state!==r)throw new Error("LinkedMap got modified during iteration.");if(d){const g={value:d.key,done:!1};return d=d.next,g}else return{value:void 0,done:!0}}};return c}values(){const n=this,r=this._state;let d=this._head;const c={[Symbol.iterator](){return c},next(){if(n._state!==r)throw new Error("LinkedMap got modified during iteration.");if(d){const g={value:d.value,done:!1};return d=d.next,g}else return{value:void 0,done:!0}}};return c}entries(){const n=this,r=this._state;let d=this._head;const c={[Symbol.iterator](){return c},next(){if(n._state!==r)throw new Error("LinkedMap got modified during iteration.");if(d){const g={value:[d.key,d.value],done:!1};return d=d.next,g}else return{value:void 0,done:!0}}};return c}[(D=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(n){if(n>=this.size)return;if(n===0){this.clear();return}let r=this._head,d=this.size;for(;r&&d>n;)this._map.delete(r.key),r=r.next,d--;this._head=r,this._size=d,r&&(r.previous=void 0),this._state++}trimNew(n){if(n>=this.size)return;if(n===0){this.clear();return}let r=this._tail,d=this.size;for(;r&&d>n;)this._map.delete(r.key),r=r.previous,d--;this._tail=r,this._size=d,r&&(r.next=void 0),this._state++}addItemFirst(n){if(!this._head&&!this._tail)this._tail=n;else if(this._head)n.next=this._head,this._head.previous=n;else throw new Error("Invalid list");this._head=n,this._state++}addItemLast(n){if(!this._head&&!this._tail)this._head=n;else if(this._tail)n.previous=this._tail,this._tail.next=n;else throw new Error("Invalid list");this._tail=n,this._state++}removeItem(n){if(n===this._head&&n===this._tail)this._head=void 0,this._tail=void 0;else if(n===this._head){if(!n.next)throw new Error("Invalid list");n.next.previous=void 0,this._head=n.next}else if(n===this._tail){if(!n.previous)throw new Error("Invalid list");n.previous.next=void 0,this._tail=n.previous}else{const r=n.next,d=n.previous;if(!r||!d)throw new Error("Invalid list");r.previous=d,d.next=r}n.next=void 0,n.previous=void 0,this._state++}touch(n,r){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(r!==f.AsOld&&r!==f.AsNew)){if(r===f.AsOld){if(n===this._head)return;const d=n.next,c=n.previous;n===this._tail?(c.next=void 0,this._tail=c):(d.previous=c,c.next=d),n.previous=void 0,n.next=this._head,this._head.previous=n,this._head=n,this._state++}else if(r===f.AsNew){if(n===this._tail)return;const d=n.next,c=n.previous;n===this._head?(d.previous=void 0,this._head=d):(d.previous=c,c.next=d),n.next=void 0,n.previous=this._tail,this._tail.next=n,this._tail=n,this._state++}}}toJSON(){const n=[];return this.forEach((r,d)=>{n.push([d,r])}),n}fromJSON(n){this.clear();for(const[r,d]of n)this.set(r,d)}}e.LinkedMap=T;class S extends T{constructor(n,r=1){super(),this._limit=n,this._ratio=Math.min(Math.max(0,r),1)}get limit(){return this._limit}set limit(n){this._limit=n,this.checkTrim()}get ratio(){return this._ratio}set ratio(n){this._ratio=Math.min(Math.max(0,n),1),this.checkTrim()}get(n,r=f.AsNew){return super.get(n,r)}peek(n){return super.get(n,f.None)}set(n,r){return super.set(n,r,f.AsNew),this}checkTrim(){this.size>this._limit&&this.trim(Math.round(this._limit*this._ratio))}}class o extends S{constructor(n,r=1){super(n,r)}trim(n){this.trimOld(n)}set(n,r){return super.set(n,r),this.checkTrim(),this}}e.LRUCache=o;class m extends S{constructor(n,r=1){super(n,r)}trim(n){this.trimNew(n)}set(n,r){return this._limit<=this.size&&!this.has(n)&&this.trim(Math.round(this._limit*this._ratio)-1),super.set(n,r),this}}e.MRUCache=m;class p{constructor(){this.map=new Map}add(n){return this.map.set(n,(this.map.get(n)||0)+1),this}delete(n){let r=this.map.get(n)||0;return r===0?!1:(r--,r===0?this.map.delete(n):this.map.set(n,r),!0)}has(n){return this.map.has(n)}}e.CounterSet=p;class u{constructor(n){if(this._m1=new Map,this._m2=new Map,n)for(const[r,d]of n)this.set(r,d)}clear(){this._m1.clear(),this._m2.clear()}set(n,r){this._m1.set(n,r),this._m2.set(r,n)}get(n){return this._m1.get(n)}getKey(n){return this._m2.get(n)}delete(n){const r=this._m1.get(n);return r===void 0?!1:(this._m1.delete(n),this._m2.delete(r),!0)}forEach(n,r){this._m1.forEach((d,c)=>{n.call(r,d,c,this)})}keys(){return this._m1.keys()}values(){return this._m1.values()}}e.BidirectionalMap=u;class i{constructor(){this.map=new Map}add(n,r){let d=this.map.get(n);d||(d=new Set,this.map.set(n,d)),d.add(r)}delete(n,r){const d=this.map.get(n);d&&(d.delete(r),d.size===0&&this.map.delete(n))}forEach(n,r){const d=this.map.get(n);d&&d.forEach(r)}get(n){const r=this.map.get(n);return r||new Set}}e.SetMap=i;function a(t,n){if(t===n)return!0;if(t.size!==n.size)return!1;for(const[r,d]of t)if(!n.has(r)||n.get(r)!==d)return!1;for(const[r]of n)if(!t.has(r))return!1;return!0}}),define(Pe[3],ke([1,0,18,80,28,81,40]),function(ge,e,s,h,D,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DisposableMap=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MandatoryMutableDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.DisposableTracker=void 0,e.setDisposableTracker=C,e.trackDisposable=_,e.markAsDisposed=f,e.markAsSingleton=o,e.isDisposable=m,e.dispose=p,e.disposeIfDisposable=u,e.combinedDisposable=i,e.toDisposable=a,e.disposeOnReturn=P;const R=!1;let v=null;class l{constructor(){this.livingDisposables=new Map}static{this.idx=0}getDisposableData(E){let N=this.livingDisposables.get(E);return N||(N={parent:null,source:null,isSingleton:!1,value:E,idx:l.idx++},this.livingDisposables.set(E,N)),N}trackDisposable(E){const N=this.getDisposableData(E);N.source||(N.source=new Error().stack)}setParent(E,N){const O=this.getDisposableData(E);O.parent=N}markAsDisposed(E){this.livingDisposables.delete(E)}markAsSingleton(E){this.getDisposableData(E).isSingleton=!0}getRootParent(E,N){const O=N.get(E);if(O)return O;const M=E.parent?this.getRootParent(this.getDisposableData(E.parent),N):E;return N.set(E,M),M}getTrackedDisposables(){const E=new Map;return[...this.livingDisposables.entries()].filter(([,O])=>O.source!==null&&!this.getRootParent(O,E).isSingleton).flatMap(([O])=>O)}computeLeakingDisposables(E=10,N){let O;if(N)O=N;else{const x=new Map,$=[...this.livingDisposables.values()].filter(B=>B.source!==null&&!this.getRootParent(B,x).isSingleton);if($.length===0)return;const G=new Set($.map(B=>B.value));if(O=$.filter(B=>!(B.parent&&G.has(B.parent))),O.length===0)throw new Error("There are cyclic diposable chains!")}if(!O)return;function M(x){function $(B,W){for(;B.length>0&&W.some(Z=>typeof Z=="string"?Z===B[0]:B[0].match(Z));)B.shift()}const G=x.source.split(`
`).map(B=>B.trim().replace("at ","")).filter(B=>B!=="");return $(G,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),G.reverse()}const U=new D.SetMap;for(const x of O){const $=M(x);for(let G=0;G<=$.length;G++)U.add($.slice(0,G).join(`
`),x)}O.sort((0,s.compareBy)(x=>x.idx,s.numberComparator));let H="",F=0;for(const x of O.slice(0,E)){F++;const $=M(x),G=[];for(let B=0;B<$.length;B++){let W=$[B];W=`(shared with ${U.get($.slice(0,B+1).join(`
`)).size}/${O.length} leaks) at ${W}`;const J=U.get($.slice(0,B).join(`
`)),oe=(0,h.groupBy)([...J].map(te=>M(te)[B]),te=>te);delete oe[$[B]];for(const[te,me]of Object.entries(oe))G.unshift(`    - stacktraces of ${me.length} other leaks continue with ${te}`);G.unshift(W)}H+=`


==================== Leaking disposable ${F}/${O.length}: ${x.value.constructor.name} ====================
${G.join(`
`)}
============================================================

`}return O.length>E&&(H+=`


... and ${O.length-E} more leaking disposables

`),{leaks:O,details:H}}}e.DisposableTracker=l;function C(b){v=b}if(R){const b="__is_disposable_tracked__";C(new class{trackDisposable(E){const N=new Error("Potentially leaked disposable").stack;setTimeout(()=>{E[b]||console.log(N)},3e3)}setParent(E,N){if(E&&E!==n.None)try{E[b]=!0}catch{}}markAsDisposed(E){if(E&&E!==n.None)try{E[b]=!0}catch{}}markAsSingleton(E){}})}function _(b){return v?.trackDisposable(b),b}function f(b){v?.markAsDisposed(b)}function T(b,E){v?.setParent(b,E)}function S(b,E){if(v)for(const N of b)v.setParent(N,E)}function o(b){return v?.markAsSingleton(b),b}function m(b){return typeof b=="object"&&b!==null&&typeof b.dispose=="function"&&b.dispose.length===0}function p(b){if(L.Iterable.is(b)){const E=[];for(const N of b)if(N)try{N.dispose()}catch(O){E.push(O)}if(E.length===1)throw E[0];if(E.length>1)throw new AggregateError(E,"Encountered errors while disposing of store");return Array.isArray(b)?[]:b}else if(b)return b.dispose(),b}function u(b){for(const E of b)m(E)&&E.dispose();return[]}function i(...b){const E=a(()=>p(b));return S(b,E),E}function a(b){const E=_({dispose:(0,A.createSingleCallFunction)(()=>{f(E),b()})});return E}class t{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this._toDispose=new Set,this._isDisposed=!1,_(this)}dispose(){this._isDisposed||(f(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){if(this._toDispose.size!==0)try{p(this._toDispose)}finally{this._toDispose.clear()}}add(E){if(!E)return E;if(E===this)throw new Error("Cannot register a disposable on itself!");return T(E,this),this._isDisposed?t.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(E),E}delete(E){if(E){if(E===this)throw new Error("Cannot dispose a disposable on itself!");this._toDispose.delete(E),E.dispose()}}deleteAndLeak(E){E&&this._toDispose.has(E)&&(this._toDispose.delete(E),T(E,null))}}e.DisposableStore=t;class n{static{this.None=Object.freeze({dispose(){}})}constructor(){this._store=new t,_(this),T(this._store,this)}dispose(){f(this),this._store.dispose()}_register(E){if(E===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(E)}}e.Disposable=n;class r{constructor(){this._isDisposed=!1,_(this)}get value(){return this._isDisposed?void 0:this._value}set value(E){this._isDisposed||E===this._value||(this._value?.dispose(),E&&T(E,this),this._value=E)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,f(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const E=this._value;return this._value=void 0,E&&T(E,null),E}}e.MutableDisposable=r;class d{constructor(E){this._disposable=new r,this._isDisposed=!1,this._disposable.value=E}get value(){return this._disposable.value}set value(E){this._isDisposed||E===this._disposable.value||(this._disposable.value=E)}dispose(){this._isDisposed=!0,this._disposable.dispose()}}e.MandatoryMutableDisposable=d;class c{constructor(E){this._disposable=E,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter===0&&this._disposable.dispose(),this}}e.RefCountedDisposable=c;class g{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,_(this)}set(E){let N=E;return this.unset=()=>N=void 0,this.isset=()=>N!==void 0,this.dispose=()=>{N&&(N(),N=void 0,f(this))},this}}e.SafeDisposable=g;class w{constructor(){this.references=new Map}acquire(E,...N){let O=this.references.get(E);O||(O={counter:0,object:this.createReferencedObject(E,...N)},this.references.set(E,O));const{object:M}=O,U=(0,A.createSingleCallFunction)(()=>{--O.counter===0&&(this.destroyReferencedObject(E,O.object),this.references.delete(E))});return O.counter++,{object:M,dispose:U}}}e.ReferenceCollection=w;class y{constructor(E){this.referenceCollection=E}async acquire(E,...N){const O=this.referenceCollection.acquire(E,...N);try{return{object:await O.object,dispose:()=>O.dispose()}}catch(M){throw O.dispose(),M}}}e.AsyncReferenceCollection=y;class I{constructor(E){this.object=E}dispose(){}}e.ImmortalReference=I;function P(b){const E=new t;try{b(E)}finally{E.dispose()}}class k{constructor(){this._store=new Map,this._isDisposed=!1,_(this)}dispose(){f(this),this._isDisposed=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this._store.size)try{p(this._store.values())}finally{this._store.clear()}}has(E){return this._store.has(E)}get size(){return this._store.size}get(E){return this._store.get(E)}set(E,N,O=!1){this._isDisposed&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),O||this._store.get(E)?.dispose(),this._store.set(E,N)}deleteAndDispose(E){this._store.get(E)?.dispose(),this._store.delete(E)}deleteAndLeak(E){const N=this._store.get(E);return this._store.delete(E),N}keys(){return this._store.keys()}values(){return this._store.values()}[Symbol.iterator](){return this._store[Symbol.iterator]()}}e.DisposableMap=k}),function(ge,e){typeof define=="function"&&define.amd?define(Pe[182],ke([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(ge=typeof globalThis<"u"?globalThis:ge||self,e(ge.marked={}))}(this,function(ge){"use strict";function e(){return{async:!1,breaks:!1,extensions:null,gfm:!0,hooks:null,pedantic:!1,renderer:null,silent:!1,tokenizer:null,walkTokens:null}}ge.defaults=e();function s(it){ge.defaults=it}const h=/[&<>"']/,D=new RegExp(h.source,"g"),A=/[<>"']|&(?!(#\d{1,7}|#[Xx][a-fA-F0-9]{1,6}|\w+);)/,L=new RegExp(A.source,"g"),R={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},v=it=>R[it];function l(it,Ce){if(Ce){if(h.test(it))return it.replace(D,v)}else if(A.test(it))return it.replace(L,v);return it}const C=/(^|[^\[])\^/g;function _(it,Ce){let re=typeof it=="string"?it:it.source;Ce=Ce||"";const ce={replace:(ye,he)=>{let Ie=typeof he=="string"?he:he.source;return Ie=Ie.replace(C,"$1"),re=re.replace(ye,Ie),ce},getRegex:()=>new RegExp(re,Ce)};return ce}function f(it){try{it=encodeURI(it).replace(/%25/g,"%")}catch{return null}return it}const T={exec:()=>null};function S(it,Ce){const re=it.replace(/\|/g,(he,Ie,ne)=>{let X=!1,Te=Ie;for(;--Te>=0&&ne[Te]==="\\";)X=!X;return X?"|":" |"}),ce=re.split(/ \|/);let ye=0;if(ce[0].trim()||ce.shift(),ce.length>0&&!ce[ce.length-1].trim()&&ce.pop(),Ce)if(ce.length>Ce)ce.splice(Ce);else for(;ce.length<Ce;)ce.push("");for(;ye<ce.length;ye++)ce[ye]=ce[ye].trim().replace(/\\\|/g,"|");return ce}function o(it,Ce,re){const ce=it.length;if(ce===0)return"";let ye=0;for(;ye<ce;){const he=it.charAt(ce-ye-1);if(he===Ce&&!re)ye++;else if(he!==Ce&&re)ye++;else break}return it.slice(0,ce-ye)}function m(it,Ce){if(it.indexOf(Ce[1])===-1)return-1;let re=0;for(let ce=0;ce<it.length;ce++)if(it[ce]==="\\")ce++;else if(it[ce]===Ce[0])re++;else if(it[ce]===Ce[1]&&(re--,re<0))return ce;return-1}function p(it,Ce,re,ce){const ye=Ce.href,he=Ce.title?l(Ce.title):null,Ie=it[1].replace(/\\([\[\]])/g,"$1");if(it[0].charAt(0)!=="!"){ce.state.inLink=!0;const ne={type:"link",raw:re,href:ye,title:he,text:Ie,tokens:ce.inlineTokens(Ie)};return ce.state.inLink=!1,ne}return{type:"image",raw:re,href:ye,title:he,text:l(Ie)}}function u(it,Ce){const re=it.match(/^(\s+)(?:```)/);if(re===null)return Ce;const ce=re[1];return Ce.split(`
`).map(ye=>{const he=ye.match(/^\s+/);if(he===null)return ye;const[Ie]=he;return Ie.length>=ce.length?ye.slice(ce.length):ye}).join(`
`)}class i{options;rules;lexer;constructor(Ce){this.options=Ce||ge.defaults}space(Ce){const re=this.rules.block.newline.exec(Ce);if(re&&re[0].length>0)return{type:"space",raw:re[0]}}code(Ce){const re=this.rules.block.code.exec(Ce);if(re){const ce=re[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:re[0],codeBlockStyle:"indented",text:this.options.pedantic?ce:o(ce,`
`)}}}fences(Ce){const re=this.rules.block.fences.exec(Ce);if(re){const ce=re[0],ye=u(ce,re[3]||"");return{type:"code",raw:ce,lang:re[2]?re[2].trim().replace(this.rules.inline.anyPunctuation,"$1"):re[2],text:ye}}}heading(Ce){const re=this.rules.block.heading.exec(Ce);if(re){let ce=re[2].trim();if(/#$/.test(ce)){const ye=o(ce,"#");(this.options.pedantic||!ye||/ $/.test(ye))&&(ce=ye.trim())}return{type:"heading",raw:re[0],depth:re[1].length,text:ce,tokens:this.lexer.inline(ce)}}}hr(Ce){const re=this.rules.block.hr.exec(Ce);if(re)return{type:"hr",raw:o(re[0],`
`)}}blockquote(Ce){const re=this.rules.block.blockquote.exec(Ce);if(re){let ce=o(re[0],`
`).split(`
`),ye="",he="";const Ie=[];for(;ce.length>0;){let ne=!1;const X=[];let Te;for(Te=0;Te<ce.length;Te++)if(/^ {0,3}>/.test(ce[Te]))X.push(ce[Te]),ne=!0;else if(!ne)X.push(ce[Te]);else break;ce=ce.slice(Te);const qe=X.join(`
`),Xe=qe.replace(/\n {0,3}((?:=+|-+) *)(?=\n|$)/g,`
    $1`).replace(/^ {0,3}>[ \t]?/gm,"");ye=ye?`${ye}
${qe}`:qe,he=he?`${he}
${Xe}`:Xe;const st=this.lexer.state.top;if(this.lexer.state.top=!0,this.lexer.blockTokens(Xe,Ie,!0),this.lexer.state.top=st,ce.length===0)break;const ht=Ie[Ie.length-1];if(ht?.type==="code")break;if(ht?.type==="blockquote"){const gt=ht,It=gt.raw+`
`+ce.join(`
`),At=this.blockquote(It);Ie[Ie.length-1]=At,ye=ye.substring(0,ye.length-gt.raw.length)+At.raw,he=he.substring(0,he.length-gt.text.length)+At.text;break}else if(ht?.type==="list"){const gt=ht,It=gt.raw+`
`+ce.join(`
`),At=this.list(It);Ie[Ie.length-1]=At,ye=ye.substring(0,ye.length-ht.raw.length)+At.raw,he=he.substring(0,he.length-gt.raw.length)+At.raw,ce=It.substring(Ie[Ie.length-1].raw.length).split(`
`);continue}}return{type:"blockquote",raw:ye,tokens:Ie,text:he}}}list(Ce){let re=this.rules.block.list.exec(Ce);if(re){let ce=re[1].trim();const ye=ce.length>1,he={type:"list",raw:"",ordered:ye,start:ye?+ce.slice(0,-1):"",loose:!1,items:[]};ce=ye?`\\d{1,9}\\${ce.slice(-1)}`:`\\${ce}`,this.options.pedantic&&(ce=ye?ce:"[*+-]");const Ie=new RegExp(`^( {0,3}${ce})((?:[	 ][^\\n]*)?(?:\\n|$))`);let ne=!1;for(;Ce;){let X=!1,Te="",qe="";if(!(re=Ie.exec(Ce))||this.rules.block.hr.test(Ce))break;Te=re[0],Ce=Ce.substring(Te.length);let Xe=re[2].split(`
`,1)[0].replace(/^\t+/,qt=>" ".repeat(3*qt.length)),st=Ce.split(`
`,1)[0],ht=!Xe.trim(),gt=0;if(this.options.pedantic?(gt=2,qe=Xe.trimStart()):ht?gt=re[1].length+1:(gt=re[2].search(/[^ ]/),gt=gt>4?1:gt,qe=Xe.slice(gt),gt+=re[1].length),ht&&/^ *$/.test(st)&&(Te+=st+`
`,Ce=Ce.substring(st.length+1),X=!0),!X){const qt=new RegExp(`^ {0,${Math.min(3,gt-1)}}(?:[*+-]|\\d{1,9}[.)])((?:[ 	][^\\n]*)?(?:\\n|$))`),ei=new RegExp(`^ {0,${Math.min(3,gt-1)}}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)`),tt=new RegExp(`^ {0,${Math.min(3,gt-1)}}(?:\`\`\`|~~~)`),Lt=new RegExp(`^ {0,${Math.min(3,gt-1)}}#`);for(;Ce;){const Ut=Ce.split(`
`,1)[0];if(st=Ut,this.options.pedantic&&(st=st.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),tt.test(st)||Lt.test(st)||qt.test(st)||ei.test(Ce))break;if(st.search(/[^ ]/)>=gt||!st.trim())qe+=`
`+st.slice(gt);else{if(ht||Xe.search(/[^ ]/)>=4||tt.test(Xe)||Lt.test(Xe)||ei.test(Xe))break;qe+=`
`+st}!ht&&!st.trim()&&(ht=!0),Te+=Ut+`
`,Ce=Ce.substring(Ut.length+1),Xe=st.slice(gt)}}he.loose||(ne?he.loose=!0:/\n *\n *$/.test(Te)&&(ne=!0));let It=null,At;this.options.gfm&&(It=/^\[[ xX]\] /.exec(qe),It&&(At=It[0]!=="[ ] ",qe=qe.replace(/^\[[ xX]\] +/,""))),he.items.push({type:"list_item",raw:Te,task:!!It,checked:At,loose:!1,text:qe,tokens:[]}),he.raw+=Te}he.items[he.items.length-1].raw=he.items[he.items.length-1].raw.trimEnd(),he.items[he.items.length-1].text=he.items[he.items.length-1].text.trimEnd(),he.raw=he.raw.trimEnd();for(let X=0;X<he.items.length;X++)if(this.lexer.state.top=!1,he.items[X].tokens=this.lexer.blockTokens(he.items[X].text,[]),!he.loose){const Te=he.items[X].tokens.filter(Xe=>Xe.type==="space"),qe=Te.length>0&&Te.some(Xe=>/\n.*\n/.test(Xe.raw));he.loose=qe}if(he.loose)for(let X=0;X<he.items.length;X++)he.items[X].loose=!0;return he}}html(Ce){const re=this.rules.block.html.exec(Ce);if(re)return{type:"html",block:!0,raw:re[0],pre:re[1]==="pre"||re[1]==="script"||re[1]==="style",text:re[0]}}def(Ce){const re=this.rules.block.def.exec(Ce);if(re){const ce=re[1].toLowerCase().replace(/\s+/g," "),ye=re[2]?re[2].replace(/^<(.*)>$/,"$1").replace(this.rules.inline.anyPunctuation,"$1"):"",he=re[3]?re[3].substring(1,re[3].length-1).replace(this.rules.inline.anyPunctuation,"$1"):re[3];return{type:"def",tag:ce,raw:re[0],href:ye,title:he}}}table(Ce){const re=this.rules.block.table.exec(Ce);if(!re||!/[:|]/.test(re[2]))return;const ce=S(re[1]),ye=re[2].replace(/^\||\| *$/g,"").split("|"),he=re[3]&&re[3].trim()?re[3].replace(/\n[ \t]*$/,"").split(`
`):[],Ie={type:"table",raw:re[0],header:[],align:[],rows:[]};if(ce.length===ye.length){for(const ne of ye)/^ *-+: *$/.test(ne)?Ie.align.push("right"):/^ *:-+: *$/.test(ne)?Ie.align.push("center"):/^ *:-+ *$/.test(ne)?Ie.align.push("left"):Ie.align.push(null);for(let ne=0;ne<ce.length;ne++)Ie.header.push({text:ce[ne],tokens:this.lexer.inline(ce[ne]),header:!0,align:Ie.align[ne]});for(const ne of he)Ie.rows.push(S(ne,Ie.header.length).map((X,Te)=>({text:X,tokens:this.lexer.inline(X),header:!1,align:Ie.align[Te]})));return Ie}}lheading(Ce){const re=this.rules.block.lheading.exec(Ce);if(re)return{type:"heading",raw:re[0],depth:re[2].charAt(0)==="="?1:2,text:re[1],tokens:this.lexer.inline(re[1])}}paragraph(Ce){const re=this.rules.block.paragraph.exec(Ce);if(re){const ce=re[1].charAt(re[1].length-1)===`
`?re[1].slice(0,-1):re[1];return{type:"paragraph",raw:re[0],text:ce,tokens:this.lexer.inline(ce)}}}text(Ce){const re=this.rules.block.text.exec(Ce);if(re)return{type:"text",raw:re[0],text:re[0],tokens:this.lexer.inline(re[0])}}escape(Ce){const re=this.rules.inline.escape.exec(Ce);if(re)return{type:"escape",raw:re[0],text:l(re[1])}}tag(Ce){const re=this.rules.inline.tag.exec(Ce);if(re)return!this.lexer.state.inLink&&/^<a /i.test(re[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(re[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(re[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(re[0])&&(this.lexer.state.inRawBlock=!1),{type:"html",raw:re[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,block:!1,text:re[0]}}link(Ce){const re=this.rules.inline.link.exec(Ce);if(re){const ce=re[2].trim();if(!this.options.pedantic&&/^</.test(ce)){if(!/>$/.test(ce))return;const Ie=o(ce.slice(0,-1),"\\");if((ce.length-Ie.length)%2===0)return}else{const Ie=m(re[2],"()");if(Ie>-1){const X=(re[0].indexOf("!")===0?5:4)+re[1].length+Ie;re[2]=re[2].substring(0,Ie),re[0]=re[0].substring(0,X).trim(),re[3]=""}}let ye=re[2],he="";if(this.options.pedantic){const Ie=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(ye);Ie&&(ye=Ie[1],he=Ie[3])}else he=re[3]?re[3].slice(1,-1):"";return ye=ye.trim(),/^</.test(ye)&&(this.options.pedantic&&!/>$/.test(ce)?ye=ye.slice(1):ye=ye.slice(1,-1)),p(re,{href:ye&&ye.replace(this.rules.inline.anyPunctuation,"$1"),title:he&&he.replace(this.rules.inline.anyPunctuation,"$1")},re[0],this.lexer)}}reflink(Ce,re){let ce;if((ce=this.rules.inline.reflink.exec(Ce))||(ce=this.rules.inline.nolink.exec(Ce))){const ye=(ce[2]||ce[1]).replace(/\s+/g," "),he=re[ye.toLowerCase()];if(!he){const Ie=ce[0].charAt(0);return{type:"text",raw:Ie,text:Ie}}return p(ce,he,ce[0],this.lexer)}}emStrong(Ce,re,ce=""){let ye=this.rules.inline.emStrongLDelim.exec(Ce);if(!ye||ye[3]&&ce.match(/[\p{L}\p{N}]/u))return;if(!(ye[1]||ye[2]||"")||!ce||this.rules.inline.punctuation.exec(ce)){const Ie=[...ye[0]].length-1;let ne,X,Te=Ie,qe=0;const Xe=ye[0][0]==="*"?this.rules.inline.emStrongRDelimAst:this.rules.inline.emStrongRDelimUnd;for(Xe.lastIndex=0,re=re.slice(-1*Ce.length+Ie);(ye=Xe.exec(re))!=null;){if(ne=ye[1]||ye[2]||ye[3]||ye[4]||ye[5]||ye[6],!ne)continue;if(X=[...ne].length,ye[3]||ye[4]){Te+=X;continue}else if((ye[5]||ye[6])&&Ie%3&&!((Ie+X)%3)){qe+=X;continue}if(Te-=X,Te>0)continue;X=Math.min(X,X+Te+qe);const st=[...ye[0]][0].length,ht=Ce.slice(0,Ie+ye.index+st+X);if(Math.min(Ie,X)%2){const It=ht.slice(1,-1);return{type:"em",raw:ht,text:It,tokens:this.lexer.inlineTokens(It)}}const gt=ht.slice(2,-2);return{type:"strong",raw:ht,text:gt,tokens:this.lexer.inlineTokens(gt)}}}}codespan(Ce){const re=this.rules.inline.code.exec(Ce);if(re){let ce=re[2].replace(/\n/g," ");const ye=/[^ ]/.test(ce),he=/^ /.test(ce)&&/ $/.test(ce);return ye&&he&&(ce=ce.substring(1,ce.length-1)),ce=l(ce,!0),{type:"codespan",raw:re[0],text:ce}}}br(Ce){const re=this.rules.inline.br.exec(Ce);if(re)return{type:"br",raw:re[0]}}del(Ce){const re=this.rules.inline.del.exec(Ce);if(re)return{type:"del",raw:re[0],text:re[2],tokens:this.lexer.inlineTokens(re[2])}}autolink(Ce){const re=this.rules.inline.autolink.exec(Ce);if(re){let ce,ye;return re[2]==="@"?(ce=l(re[1]),ye="mailto:"+ce):(ce=l(re[1]),ye=ce),{type:"link",raw:re[0],text:ce,href:ye,tokens:[{type:"text",raw:ce,text:ce}]}}}url(Ce){let re;if(re=this.rules.inline.url.exec(Ce)){let ce,ye;if(re[2]==="@")ce=l(re[0]),ye="mailto:"+ce;else{let he;do he=re[0],re[0]=this.rules.inline._backpedal.exec(re[0])?.[0]??"";while(he!==re[0]);ce=l(re[0]),re[1]==="www."?ye="http://"+re[0]:ye=re[0]}return{type:"link",raw:re[0],text:ce,href:ye,tokens:[{type:"text",raw:ce,text:ce}]}}}inlineText(Ce){const re=this.rules.inline.text.exec(Ce);if(re){let ce;return this.lexer.state.inRawBlock?ce=re[0]:ce=l(re[0]),{type:"text",raw:re[0],text:ce}}}}const a=/^(?: *(?:\n|$))+/,t=/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,n=/^ {0,3}(`{3,}(?=[^`\n]*(?:\n|$))|~{3,})([^\n]*)(?:\n|$)(?:|([\s\S]*?)(?:\n|$))(?: {0,3}\1[~`]* *(?=\n|$)|$)/,r=/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,d=/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,c=/(?:[*+-]|\d{1,9}[.)])/,g=_(/^(?!bull |blockCode|fences|blockquote|heading|html)((?:.|\n(?!\s*?\n|bull |blockCode|fences|blockquote|heading|html))+?)\n {0,3}(=+|-+) *(?:\n+|$)/).replace(/bull/g,c).replace(/blockCode/g,/ {4}/).replace(/fences/g,/ {0,3}(?:`{3,}|~{3,})/).replace(/blockquote/g,/ {0,3}>/).replace(/heading/g,/ {0,3}#{1,6}/).replace(/html/g,/ {0,3}<[^\n>]+>\n/).getRegex(),w=/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,y=/^[^\n]+/,I=/(?!\s*\])(?:\\.|[^\[\]\\])+/,P=_(/^ {0,3}\[(label)\]: *(?:\n *)?([^<\s][^\s]*|<.*?>)(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/).replace("label",I).replace("title",/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/).getRegex(),k=_(/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/).replace(/bull/g,c).getRegex(),b="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|search|section|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",E=/<!--(?:-?>|[\s\S]*?(?:-->|$))/,N=_("^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))","i").replace("comment",E).replace("tag",b).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),O=_(w).replace("hr",r).replace("heading"," {0,3}#{1,6}(?:\\s|$)").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",b).getRegex(),U={blockquote:_(/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/).replace("paragraph",O).getRegex(),code:t,def:P,fences:n,heading:d,hr:r,html:N,lheading:g,list:k,newline:a,paragraph:O,table:T,text:y},H=_("^ *([^\\n ].*)\\n {0,3}((?:\\| *)?:?-+:? *(?:\\| *:?-+:? *)*(?:\\| *)?)(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)").replace("hr",r).replace("heading"," {0,3}#{1,6}(?:\\s|$)").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",b).getRegex(),F={...U,table:H,paragraph:_(w).replace("hr",r).replace("heading"," {0,3}#{1,6}(?:\\s|$)").replace("|lheading","").replace("table",H).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",b).getRegex()},x={...U,html:_(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",E).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:T,lheading:/^(.+?)\n {0,3}(=+|-+) *(?:\n+|$)/,paragraph:_(w).replace("hr",r).replace("heading",` *#{1,6} *[^
]`).replace("lheading",g).replace("|table","").replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").replace("|tag","").getRegex()},$=/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,G=/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,B=/^( {2,}|\\)\n(?!\s*$)/,W=/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,Z="\\p{P}\\p{S}",J=_(/^((?![*_])[\spunctuation])/,"u").replace(/punctuation/g,Z).getRegex(),oe=/\[[^[\]]*?\]\([^\(\)]*?\)|`[^`]*?`|<[^<>]*?>/g,te=_(/^(?:\*+(?:((?!\*)[punct])|[^\s*]))|^_+(?:((?!_)[punct])|([^\s_]))/,"u").replace(/punct/g,Z).getRegex(),me=_("^[^_*]*?__[^_*]*?\\*[^_*]*?(?=__)|[^*]+(?=[^*])|(?!\\*)[punct](\\*+)(?=[\\s]|$)|[^punct\\s](\\*+)(?!\\*)(?=[punct\\s]|$)|(?!\\*)[punct\\s](\\*+)(?=[^punct\\s])|[\\s](\\*+)(?!\\*)(?=[punct])|(?!\\*)[punct](\\*+)(?!\\*)(?=[punct])|[^punct\\s](\\*+)(?=[^punct\\s])","gu").replace(/punct/g,Z).getRegex(),le=_("^[^_*]*?\\*\\*[^_*]*?_[^_*]*?(?=\\*\\*)|[^_]+(?=[^_])|(?!_)[punct](_+)(?=[\\s]|$)|[^punct\\s](_+)(?!_)(?=[punct\\s]|$)|(?!_)[punct\\s](_+)(?=[^punct\\s])|[\\s](_+)(?!_)(?=[punct])|(?!_)[punct](_+)(?!_)(?=[punct])","gu").replace(/punct/g,Z).getRegex(),Q=_(/\\([punct])/,"gu").replace(/punct/g,Z).getRegex(),z=_(/^<(scheme:[^\s\x00-\x1f<>]*|email)>/).replace("scheme",/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/).replace("email",/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/).getRegex(),se=_(E).replace("(?:-->|$)","-->").getRegex(),Ee=_("^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>").replace("comment",se).replace("attribute",/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/).getRegex(),ae=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,be=_(/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/).replace("label",ae).replace("href",/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/).replace("title",/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/).getRegex(),pe=_(/^!?\[(label)\]\[(ref)\]/).replace("label",ae).replace("ref",I).getRegex(),ve=_(/^!?\[(ref)\](?:\[\])?/).replace("ref",I).getRegex(),Re=_("reflink|nolink(?!\\()","g").replace("reflink",pe).replace("nolink",ve).getRegex(),Fe={_backpedal:T,anyPunctuation:Q,autolink:z,blockSkip:oe,br:B,code:G,del:T,emStrongLDelim:te,emStrongRDelimAst:me,emStrongRDelimUnd:le,escape:$,link:be,nolink:ve,punctuation:J,reflink:pe,reflinkSearch:Re,tag:Ee,text:W,url:T},Ve={...Fe,link:_(/^!?\[(label)\]\((.*?)\)/).replace("label",ae).getRegex(),reflink:_(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",ae).getRegex()},Ye={...Fe,escape:_($).replace("])","~|])").getRegex(),url:_(/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,"i").replace("email",/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/).getRegex(),_backpedal:/(?:[^?!.,:;*_'"~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_'"~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/},Je={...Ye,br:_(B).replace("{2,}","*").getRegex(),text:_(Ye.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()},xe={normal:U,gfm:F,pedantic:x},ze={normal:Fe,gfm:Ye,breaks:Je,pedantic:Ve};class Ne{tokens;options;state;tokenizer;inlineQueue;constructor(Ce){this.tokens=[],this.tokens.links=Object.create(null),this.options=Ce||ge.defaults,this.options.tokenizer=this.options.tokenizer||new i,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};const re={block:xe.normal,inline:ze.normal};this.options.pedantic?(re.block=xe.pedantic,re.inline=ze.pedantic):this.options.gfm&&(re.block=xe.gfm,this.options.breaks?re.inline=ze.breaks:re.inline=ze.gfm),this.tokenizer.rules=re}static get rules(){return{block:xe,inline:ze}}static lex(Ce,re){return new Ne(re).lex(Ce)}static lexInline(Ce,re){return new Ne(re).inlineTokens(Ce)}lex(Ce){Ce=Ce.replace(/\r\n|\r/g,`
`),this.blockTokens(Ce,this.tokens);for(let re=0;re<this.inlineQueue.length;re++){const ce=this.inlineQueue[re];this.inlineTokens(ce.src,ce.tokens)}return this.inlineQueue=[],this.tokens}blockTokens(Ce,re=[],ce=!1){this.options.pedantic?Ce=Ce.replace(/\t/g,"    ").replace(/^ +$/gm,""):Ce=Ce.replace(/^( *)(\t+)/gm,(ne,X,Te)=>X+"    ".repeat(Te.length));let ye,he,Ie;for(;Ce;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(ne=>(ye=ne.call({lexer:this},Ce,re))?(Ce=Ce.substring(ye.raw.length),re.push(ye),!0):!1))){if(ye=this.tokenizer.space(Ce)){Ce=Ce.substring(ye.raw.length),ye.raw.length===1&&re.length>0?re[re.length-1].raw+=`
`:re.push(ye);continue}if(ye=this.tokenizer.code(Ce)){Ce=Ce.substring(ye.raw.length),he=re[re.length-1],he&&(he.type==="paragraph"||he.type==="text")?(he.raw+=`
`+ye.raw,he.text+=`
`+ye.text,this.inlineQueue[this.inlineQueue.length-1].src=he.text):re.push(ye);continue}if(ye=this.tokenizer.fences(Ce)){Ce=Ce.substring(ye.raw.length),re.push(ye);continue}if(ye=this.tokenizer.heading(Ce)){Ce=Ce.substring(ye.raw.length),re.push(ye);continue}if(ye=this.tokenizer.hr(Ce)){Ce=Ce.substring(ye.raw.length),re.push(ye);continue}if(ye=this.tokenizer.blockquote(Ce)){Ce=Ce.substring(ye.raw.length),re.push(ye);continue}if(ye=this.tokenizer.list(Ce)){Ce=Ce.substring(ye.raw.length),re.push(ye);continue}if(ye=this.tokenizer.html(Ce)){Ce=Ce.substring(ye.raw.length),re.push(ye);continue}if(ye=this.tokenizer.def(Ce)){Ce=Ce.substring(ye.raw.length),he=re[re.length-1],he&&(he.type==="paragraph"||he.type==="text")?(he.raw+=`
`+ye.raw,he.text+=`
`+ye.raw,this.inlineQueue[this.inlineQueue.length-1].src=he.text):this.tokens.links[ye.tag]||(this.tokens.links[ye.tag]={href:ye.href,title:ye.title});continue}if(ye=this.tokenizer.table(Ce)){Ce=Ce.substring(ye.raw.length),re.push(ye);continue}if(ye=this.tokenizer.lheading(Ce)){Ce=Ce.substring(ye.raw.length),re.push(ye);continue}if(Ie=Ce,this.options.extensions&&this.options.extensions.startBlock){let ne=1/0;const X=Ce.slice(1);let Te;this.options.extensions.startBlock.forEach(qe=>{Te=qe.call({lexer:this},X),typeof Te=="number"&&Te>=0&&(ne=Math.min(ne,Te))}),ne<1/0&&ne>=0&&(Ie=Ce.substring(0,ne+1))}if(this.state.top&&(ye=this.tokenizer.paragraph(Ie))){he=re[re.length-1],ce&&he?.type==="paragraph"?(he.raw+=`
`+ye.raw,he.text+=`
`+ye.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=he.text):re.push(ye),ce=Ie.length!==Ce.length,Ce=Ce.substring(ye.raw.length);continue}if(ye=this.tokenizer.text(Ce)){Ce=Ce.substring(ye.raw.length),he=re[re.length-1],he&&he.type==="text"?(he.raw+=`
`+ye.raw,he.text+=`
`+ye.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=he.text):re.push(ye);continue}if(Ce){const ne="Infinite loop on byte: "+Ce.charCodeAt(0);if(this.options.silent){console.error(ne);break}else throw new Error(ne)}}return this.state.top=!0,re}inline(Ce,re=[]){return this.inlineQueue.push({src:Ce,tokens:re}),re}inlineTokens(Ce,re=[]){let ce,ye,he,Ie=Ce,ne,X,Te;if(this.tokens.links){const qe=Object.keys(this.tokens.links);if(qe.length>0)for(;(ne=this.tokenizer.rules.inline.reflinkSearch.exec(Ie))!=null;)qe.includes(ne[0].slice(ne[0].lastIndexOf("[")+1,-1))&&(Ie=Ie.slice(0,ne.index)+"["+"a".repeat(ne[0].length-2)+"]"+Ie.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(ne=this.tokenizer.rules.inline.blockSkip.exec(Ie))!=null;)Ie=Ie.slice(0,ne.index)+"["+"a".repeat(ne[0].length-2)+"]"+Ie.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(ne=this.tokenizer.rules.inline.anyPunctuation.exec(Ie))!=null;)Ie=Ie.slice(0,ne.index)+"++"+Ie.slice(this.tokenizer.rules.inline.anyPunctuation.lastIndex);for(;Ce;)if(X||(Te=""),X=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(qe=>(ce=qe.call({lexer:this},Ce,re))?(Ce=Ce.substring(ce.raw.length),re.push(ce),!0):!1))){if(ce=this.tokenizer.escape(Ce)){Ce=Ce.substring(ce.raw.length),re.push(ce);continue}if(ce=this.tokenizer.tag(Ce)){Ce=Ce.substring(ce.raw.length),ye=re[re.length-1],ye&&ce.type==="text"&&ye.type==="text"?(ye.raw+=ce.raw,ye.text+=ce.text):re.push(ce);continue}if(ce=this.tokenizer.link(Ce)){Ce=Ce.substring(ce.raw.length),re.push(ce);continue}if(ce=this.tokenizer.reflink(Ce,this.tokens.links)){Ce=Ce.substring(ce.raw.length),ye=re[re.length-1],ye&&ce.type==="text"&&ye.type==="text"?(ye.raw+=ce.raw,ye.text+=ce.text):re.push(ce);continue}if(ce=this.tokenizer.emStrong(Ce,Ie,Te)){Ce=Ce.substring(ce.raw.length),re.push(ce);continue}if(ce=this.tokenizer.codespan(Ce)){Ce=Ce.substring(ce.raw.length),re.push(ce);continue}if(ce=this.tokenizer.br(Ce)){Ce=Ce.substring(ce.raw.length),re.push(ce);continue}if(ce=this.tokenizer.del(Ce)){Ce=Ce.substring(ce.raw.length),re.push(ce);continue}if(ce=this.tokenizer.autolink(Ce)){Ce=Ce.substring(ce.raw.length),re.push(ce);continue}if(!this.state.inLink&&(ce=this.tokenizer.url(Ce))){Ce=Ce.substring(ce.raw.length),re.push(ce);continue}if(he=Ce,this.options.extensions&&this.options.extensions.startInline){let qe=1/0;const Xe=Ce.slice(1);let st;this.options.extensions.startInline.forEach(ht=>{st=ht.call({lexer:this},Xe),typeof st=="number"&&st>=0&&(qe=Math.min(qe,st))}),qe<1/0&&qe>=0&&(he=Ce.substring(0,qe+1))}if(ce=this.tokenizer.inlineText(he)){Ce=Ce.substring(ce.raw.length),ce.raw.slice(-1)!=="_"&&(Te=ce.raw.slice(-1)),X=!0,ye=re[re.length-1],ye&&ye.type==="text"?(ye.raw+=ce.raw,ye.text+=ce.text):re.push(ce);continue}if(Ce){const qe="Infinite loop on byte: "+Ce.charCodeAt(0);if(this.options.silent){console.error(qe);break}else throw new Error(qe)}}return re}}class V{options;parser;constructor(Ce){this.options=Ce||ge.defaults}space(Ce){return""}code({text:Ce,lang:re,escaped:ce}){const ye=(re||"").match(/^\S*/)?.[0],he=Ce.replace(/\n$/,"")+`
`;return ye?'<pre><code class="language-'+l(ye)+'">'+(ce?he:l(he,!0))+`</code></pre>
`:"<pre><code>"+(ce?he:l(he,!0))+`</code></pre>
`}blockquote({tokens:Ce}){return`<blockquote>
${this.parser.parse(Ce)}</blockquote>
`}html({text:Ce}){return Ce}heading({tokens:Ce,depth:re}){return`<h${re}>${this.parser.parseInline(Ce)}</h${re}>
`}hr(Ce){return`<hr>
`}list(Ce){const re=Ce.ordered,ce=Ce.start;let ye="";for(let ne=0;ne<Ce.items.length;ne++){const X=Ce.items[ne];ye+=this.listitem(X)}const he=re?"ol":"ul",Ie=re&&ce!==1?' start="'+ce+'"':"";return"<"+he+Ie+`>
`+ye+"</"+he+`>
`}listitem(Ce){let re="";if(Ce.task){const ce=this.checkbox({checked:!!Ce.checked});Ce.loose?Ce.tokens.length>0&&Ce.tokens[0].type==="paragraph"?(Ce.tokens[0].text=ce+" "+Ce.tokens[0].text,Ce.tokens[0].tokens&&Ce.tokens[0].tokens.length>0&&Ce.tokens[0].tokens[0].type==="text"&&(Ce.tokens[0].tokens[0].text=ce+" "+Ce.tokens[0].tokens[0].text)):Ce.tokens.unshift({type:"text",raw:ce+" ",text:ce+" "}):re+=ce+" "}return re+=this.parser.parse(Ce.tokens,!!Ce.loose),`<li>${re}</li>
`}checkbox({checked:Ce}){return"<input "+(Ce?'checked="" ':"")+'disabled="" type="checkbox">'}paragraph({tokens:Ce}){return`<p>${this.parser.parseInline(Ce)}</p>
`}table(Ce){let re="",ce="";for(let he=0;he<Ce.header.length;he++)ce+=this.tablecell(Ce.header[he]);re+=this.tablerow({text:ce});let ye="";for(let he=0;he<Ce.rows.length;he++){const Ie=Ce.rows[he];ce="";for(let ne=0;ne<Ie.length;ne++)ce+=this.tablecell(Ie[ne]);ye+=this.tablerow({text:ce})}return ye&&(ye=`<tbody>${ye}</tbody>`),`<table>
<thead>
`+re+`</thead>
`+ye+`</table>
`}tablerow({text:Ce}){return`<tr>
${Ce}</tr>
`}tablecell(Ce){const re=this.parser.parseInline(Ce.tokens),ce=Ce.header?"th":"td";return(Ce.align?`<${ce} align="${Ce.align}">`:`<${ce}>`)+re+`</${ce}>
`}strong({tokens:Ce}){return`<strong>${this.parser.parseInline(Ce)}</strong>`}em({tokens:Ce}){return`<em>${this.parser.parseInline(Ce)}</em>`}codespan({text:Ce}){return`<code>${Ce}</code>`}br(Ce){return"<br>"}del({tokens:Ce}){return`<del>${this.parser.parseInline(Ce)}</del>`}link({href:Ce,title:re,tokens:ce}){const ye=this.parser.parseInline(ce),he=f(Ce);if(he===null)return ye;Ce=he;let Ie='<a href="'+Ce+'"';return re&&(Ie+=' title="'+re+'"'),Ie+=">"+ye+"</a>",Ie}image({href:Ce,title:re,text:ce}){const ye=f(Ce);if(ye===null)return ce;Ce=ye;let he=`<img src="${Ce}" alt="${ce}"`;return re&&(he+=` title="${re}"`),he+=">",he}text(Ce){return"tokens"in Ce&&Ce.tokens?this.parser.parseInline(Ce.tokens):Ce.text}}class j{strong({text:Ce}){return Ce}em({text:Ce}){return Ce}codespan({text:Ce}){return Ce}del({text:Ce}){return Ce}html({text:Ce}){return Ce}text({text:Ce}){return Ce}link({text:Ce}){return""+Ce}image({text:Ce}){return""+Ce}br(){return""}}class Y{options;renderer;textRenderer;constructor(Ce){this.options=Ce||ge.defaults,this.options.renderer=this.options.renderer||new V,this.renderer=this.options.renderer,this.renderer.options=this.options,this.renderer.parser=this,this.textRenderer=new j}static parse(Ce,re){return new Y(re).parse(Ce)}static parseInline(Ce,re){return new Y(re).parseInline(Ce)}parse(Ce,re=!0){let ce="";for(let ye=0;ye<Ce.length;ye++){const he=Ce[ye];if(this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[he.type]){const ne=he,X=this.options.extensions.renderers[ne.type].call({parser:this},ne);if(X!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(ne.type)){ce+=X||"";continue}}const Ie=he;switch(Ie.type){case"space":{ce+=this.renderer.space(Ie);continue}case"hr":{ce+=this.renderer.hr(Ie);continue}case"heading":{ce+=this.renderer.heading(Ie);continue}case"code":{ce+=this.renderer.code(Ie);continue}case"table":{ce+=this.renderer.table(Ie);continue}case"blockquote":{ce+=this.renderer.blockquote(Ie);continue}case"list":{ce+=this.renderer.list(Ie);continue}case"html":{ce+=this.renderer.html(Ie);continue}case"paragraph":{ce+=this.renderer.paragraph(Ie);continue}case"text":{let ne=Ie,X=this.renderer.text(ne);for(;ye+1<Ce.length&&Ce[ye+1].type==="text";)ne=Ce[++ye],X+=`
`+this.renderer.text(ne);re?ce+=this.renderer.paragraph({type:"paragraph",raw:X,text:X,tokens:[{type:"text",raw:X,text:X}]}):ce+=X;continue}default:{const ne='Token with "'+Ie.type+'" type was not found.';if(this.options.silent)return console.error(ne),"";throw new Error(ne)}}}return ce}parseInline(Ce,re){re=re||this.renderer;let ce="";for(let ye=0;ye<Ce.length;ye++){const he=Ce[ye];if(this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[he.type]){const ne=this.options.extensions.renderers[he.type].call({parser:this},he);if(ne!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(he.type)){ce+=ne||"";continue}}const Ie=he;switch(Ie.type){case"escape":{ce+=re.text(Ie);break}case"html":{ce+=re.html(Ie);break}case"link":{ce+=re.link(Ie);break}case"image":{ce+=re.image(Ie);break}case"strong":{ce+=re.strong(Ie);break}case"em":{ce+=re.em(Ie);break}case"codespan":{ce+=re.codespan(Ie);break}case"br":{ce+=re.br(Ie);break}case"del":{ce+=re.del(Ie);break}case"text":{ce+=re.text(Ie);break}default:{const ne='Token with "'+Ie.type+'" type was not found.';if(this.options.silent)return console.error(ne),"";throw new Error(ne)}}}return ce}}class ee{options;constructor(Ce){this.options=Ce||ge.defaults}static passThroughHooks=new Set(["preprocess","postprocess","processAllTokens"]);preprocess(Ce){return Ce}postprocess(Ce){return Ce}processAllTokens(Ce){return Ce}}class ue{defaults=e();options=this.setOptions;parse=this.parseMarkdown(Ne.lex,Y.parse);parseInline=this.parseMarkdown(Ne.lexInline,Y.parseInline);Parser=Y;Renderer=V;TextRenderer=j;Lexer=Ne;Tokenizer=i;Hooks=ee;constructor(...Ce){this.use(...Ce)}walkTokens(Ce,re){let ce=[];for(const ye of Ce)switch(ce=ce.concat(re.call(this,ye)),ye.type){case"table":{const he=ye;for(const Ie of he.header)ce=ce.concat(this.walkTokens(Ie.tokens,re));for(const Ie of he.rows)for(const ne of Ie)ce=ce.concat(this.walkTokens(ne.tokens,re));break}case"list":{const he=ye;ce=ce.concat(this.walkTokens(he.items,re));break}default:{const he=ye;this.defaults.extensions?.childTokens?.[he.type]?this.defaults.extensions.childTokens[he.type].forEach(Ie=>{const ne=he[Ie].flat(1/0);ce=ce.concat(this.walkTokens(ne,re))}):he.tokens&&(ce=ce.concat(this.walkTokens(he.tokens,re)))}}return ce}use(...Ce){const re=this.defaults.extensions||{renderers:{},childTokens:{}};return Ce.forEach(ce=>{const ye={...ce};if(ye.async=this.defaults.async||ye.async||!1,ce.extensions&&(ce.extensions.forEach(he=>{if(!he.name)throw new Error("extension name required");if("renderer"in he){const Ie=re.renderers[he.name];Ie?re.renderers[he.name]=function(...ne){let X=he.renderer.apply(this,ne);return X===!1&&(X=Ie.apply(this,ne)),X}:re.renderers[he.name]=he.renderer}if("tokenizer"in he){if(!he.level||he.level!=="block"&&he.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");const Ie=re[he.level];Ie?Ie.unshift(he.tokenizer):re[he.level]=[he.tokenizer],he.start&&(he.level==="block"?re.startBlock?re.startBlock.push(he.start):re.startBlock=[he.start]:he.level==="inline"&&(re.startInline?re.startInline.push(he.start):re.startInline=[he.start]))}"childTokens"in he&&he.childTokens&&(re.childTokens[he.name]=he.childTokens)}),ye.extensions=re),ce.renderer){const he=this.defaults.renderer||new V(this.defaults);for(const Ie in ce.renderer){if(!(Ie in he))throw new Error(`renderer '${Ie}' does not exist`);if(["options","parser"].includes(Ie))continue;const ne=Ie,X=ce.renderer[ne],Te=he[ne];he[ne]=(...qe)=>{let Xe=X.apply(he,qe);return Xe===!1&&(Xe=Te.apply(he,qe)),Xe||""}}ye.renderer=he}if(ce.tokenizer){const he=this.defaults.tokenizer||new i(this.defaults);for(const Ie in ce.tokenizer){if(!(Ie in he))throw new Error(`tokenizer '${Ie}' does not exist`);if(["options","rules","lexer"].includes(Ie))continue;const ne=Ie,X=ce.tokenizer[ne],Te=he[ne];he[ne]=(...qe)=>{let Xe=X.apply(he,qe);return Xe===!1&&(Xe=Te.apply(he,qe)),Xe}}ye.tokenizer=he}if(ce.hooks){const he=this.defaults.hooks||new ee;for(const Ie in ce.hooks){if(!(Ie in he))throw new Error(`hook '${Ie}' does not exist`);if(Ie==="options")continue;const ne=Ie,X=ce.hooks[ne],Te=he[ne];ee.passThroughHooks.has(Ie)?he[ne]=qe=>{if(this.defaults.async)return Promise.resolve(X.call(he,qe)).then(st=>Te.call(he,st));const Xe=X.call(he,qe);return Te.call(he,Xe)}:he[ne]=(...qe)=>{let Xe=X.apply(he,qe);return Xe===!1&&(Xe=Te.apply(he,qe)),Xe}}ye.hooks=he}if(ce.walkTokens){const he=this.defaults.walkTokens,Ie=ce.walkTokens;ye.walkTokens=function(ne){let X=[];return X.push(Ie.call(this,ne)),he&&(X=X.concat(he.call(this,ne))),X}}this.defaults={...this.defaults,...ye}}),this}setOptions(Ce){return this.defaults={...this.defaults,...Ce},this}lexer(Ce,re){return Ne.lex(Ce,re??this.defaults)}parser(Ce,re){return Y.parse(Ce,re??this.defaults)}parseMarkdown(Ce,re){return(ye,he)=>{const Ie={...he},ne={...this.defaults,...Ie},X=this.onError(!!ne.silent,!!ne.async);if(this.defaults.async===!0&&Ie.async===!1)return X(new Error("marked(): The async option was set to true by an extension. Remove async: false from the parse options object to return a Promise."));if(typeof ye>"u"||ye===null)return X(new Error("marked(): input parameter is undefined or null"));if(typeof ye!="string")return X(new Error("marked(): input parameter is of type "+Object.prototype.toString.call(ye)+", string expected"));if(ne.hooks&&(ne.hooks.options=ne),ne.async)return Promise.resolve(ne.hooks?ne.hooks.preprocess(ye):ye).then(Te=>Ce(Te,ne)).then(Te=>ne.hooks?ne.hooks.processAllTokens(Te):Te).then(Te=>ne.walkTokens?Promise.all(this.walkTokens(Te,ne.walkTokens)).then(()=>Te):Te).then(Te=>re(Te,ne)).then(Te=>ne.hooks?ne.hooks.postprocess(Te):Te).catch(X);try{ne.hooks&&(ye=ne.hooks.preprocess(ye));let Te=Ce(ye,ne);ne.hooks&&(Te=ne.hooks.processAllTokens(Te)),ne.walkTokens&&this.walkTokens(Te,ne.walkTokens);let qe=re(Te,ne);return ne.hooks&&(qe=ne.hooks.postprocess(qe)),qe}catch(Te){return X(Te)}}}onError(Ce,re){return ce=>{if(ce.message+=`
Please report this to https://github.com/markedjs/marked.`,Ce){const ye="<p>An error occurred:</p><pre>"+l(ce.message+"",!0)+"</pre>";return re?Promise.resolve(ye):ye}if(re)return Promise.reject(ce);throw ce}}}const we=new ue;function Ae(it,Ce){return we.parse(it,Ce)}Ae.options=Ae.setOptions=function(it){return we.setOptions(it),Ae.defaults=we.defaults,s(Ae.defaults),Ae},Ae.getDefaults=e,Ae.defaults=ge.defaults,Ae.use=function(...it){return we.use(...it),Ae.defaults=we.defaults,s(Ae.defaults),Ae},Ae.walkTokens=function(it,Ce){return we.walkTokens(it,Ce)},Ae.parseInline=we.parseInline,Ae.Parser=Y,Ae.parser=Y.parse,Ae.Renderer=V,Ae.TextRenderer=j,Ae.Lexer=Ne,Ae.lexer=Ne.lex,Ae.Tokenizer=i,Ae.Hooks=ee,Ae.parse=Ae;const He=Ae.options,Ge=Ae.setOptions,nt=Ae.use,ot=Ae.walkTokens,dt=Ae.parseInline,at=Ae,ct=Y.parse,vt=Ne.lex;ge.Hooks=ee,ge.Lexer=Ne,ge.Marked=ue,ge.Parser=Y,ge.Renderer=V,ge.TextRenderer=j,ge.Tokenizer=i,ge.getDefaults=e,ge.lexer=vt,ge.marked=Ae,ge.options=He,ge.parse=at,ge.parseInline=dt,ge.parser=ct,ge.setOptions=Ge,ge.use=nt,ge.walkTokens=ot}),define(Pe[41],ke([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MarshalledId=void 0;var s;(function(h){h[h.Uri=1]="Uri",h[h.Regexp=2]="Regexp",h[h.ScmResource=3]="ScmResource",h[h.ScmResourceGroup=4]="ScmResourceGroup",h[h.ScmProvider=5]="ScmProvider",h[h.CommentController=6]="CommentController",h[h.CommentThread=7]="CommentThread",h[h.CommentThreadInstance=8]="CommentThreadInstance",h[h.CommentThreadReply=9]="CommentThreadReply",h[h.CommentNode=10]="CommentNode",h[h.CommentThreadNode=11]="CommentThreadNode",h[h.TimelineActionContext=12]="TimelineActionContext",h[h.NotebookCellActionContext=13]="NotebookCellActionContext",h[h.NotebookActionContext=14]="NotebookActionContext",h[h.TerminalContext=15]="TerminalContext",h[h.TestItemContext=16]="TestItemContext",h[h.Date=17]="Date",h[h.TestMessageMenuArgs=18]="TestMessageMenuArgs"})(s||(e.MarshalledId=s={}))}),define(Pe[183],ke([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getKoreanAltChars=s;function s(o){const m=A(o);if(m&&m.length>0)return new Uint32Array(m)}let h=0;const D=new Uint32Array(10);function A(o){if(h=0,L(o,_,v.InitialConsonant),h>0||(L(o,f,v.Vowel),h>0)||(L(o,T,v.FinalConsonant),h>0)||(L(o,S,v.CompatibilityJamo),h))return D.subarray(0,h);if(o>=44032&&o<=55203){const m=o-44032,p=m%588,u=Math.floor(m/588),i=Math.floor(p/28),a=p%28-1;if(u<_.length?L(u,_,0):v.InitialConsonant+u-v.CompatibilityJamo<S.length&&L(v.InitialConsonant+u,S,v.CompatibilityJamo),i<f.length?L(i,f,0):v.Vowel+i-v.CompatibilityJamo<S.length&&L(v.Vowel+i-v.CompatibilityJamo,S,v.CompatibilityJamo),a>=0&&(a<T.length?L(a,T,0):v.FinalConsonant+a-v.CompatibilityJamo<S.length&&L(v.FinalConsonant+a-v.CompatibilityJamo,S,v.CompatibilityJamo)),h>0)return D.subarray(0,h)}}function L(o,m,p){o>=p&&o<p+m.length&&R(m[o-p])}function R(o){o!==l.NUL&&(D[h++]=o&255,o>>8&&(D[h++]=o>>8&255),o>>16&&(D[h++]=o>>16&255))}var v;(function(o){o[o.InitialConsonant=4352]="InitialConsonant",o[o.Vowel=4449]="Vowel",o[o.FinalConsonant=4520]="FinalConsonant",o[o.CompatibilityJamo=12593]="CompatibilityJamo"})(v||(v={}));var l;(function(o){o[o.NUL=0]="NUL",o[o.A=65]="A",o[o.B=66]="B",o[o.C=67]="C",o[o.D=68]="D",o[o.E=69]="E",o[o.F=70]="F",o[o.G=71]="G",o[o.H=72]="H",o[o.I=73]="I",o[o.J=74]="J",o[o.K=75]="K",o[o.L=76]="L",o[o.M=77]="M",o[o.N=78]="N",o[o.O=79]="O",o[o.P=80]="P",o[o.Q=81]="Q",o[o.R=82]="R",o[o.S=83]="S",o[o.T=84]="T",o[o.U=85]="U",o[o.V=86]="V",o[o.W=87]="W",o[o.X=88]="X",o[o.Y=89]="Y",o[o.Z=90]="Z",o[o.a=97]="a",o[o.b=98]="b",o[o.c=99]="c",o[o.d=100]="d",o[o.e=101]="e",o[o.f=102]="f",o[o.g=103]="g",o[o.h=104]="h",o[o.i=105]="i",o[o.j=106]="j",o[o.k=107]="k",o[o.l=108]="l",o[o.m=109]="m",o[o.n=110]="n",o[o.o=111]="o",o[o.p=112]="p",o[o.q=113]="q",o[o.r=114]="r",o[o.s=115]="s",o[o.t=116]="t",o[o.u=117]="u",o[o.v=118]="v",o[o.w=119]="w",o[o.x=120]="x",o[o.y=121]="y",o[o.z=122]="z"})(l||(l={}));var C;(function(o){o[o.fa=24934]="fa",o[o.fg=26470]="fg",o[o.fq=29030]="fq",o[o.fr=29286]="fr",o[o.ft=29798]="ft",o[o.fv=30310]="fv",o[o.fx=30822]="fx",o[o.hk=27496]="hk",o[o.hl=27752]="hl",o[o.ho=28520]="ho",o[o.ml=27757]="ml",o[o.nj=27246]="nj",o[o.nl=27758]="nl",o[o.np=28782]="np",o[o.qt=29809]="qt",o[o.rt=29810]="rt",o[o.sg=26483]="sg",o[o.sw=30579]="sw"})(C||(C={}));const _=new Uint8Array([l.r,l.R,l.s,l.e,l.E,l.f,l.a,l.q,l.Q,l.t,l.T,l.d,l.w,l.W,l.c,l.z,l.x,l.v,l.g]),f=new Uint16Array([l.k,l.o,l.i,l.O,l.j,l.p,l.u,l.P,l.h,C.hk,C.ho,C.hl,l.y,l.n,C.nj,C.np,C.nl,l.b,l.m,C.ml,l.l]),T=new Uint16Array([l.r,l.R,C.rt,l.s,C.sw,C.sg,l.e,l.f,C.fr,C.fa,C.fq,C.ft,C.fx,C.fv,C.fg,l.a,l.q,C.qt,l.t,l.T,l.d,l.w,l.c,l.z,l.x,l.v,l.g]),S=new Uint16Array([l.r,l.R,C.rt,l.s,C.sw,C.sg,l.e,l.E,l.f,C.fr,C.fa,C.fq,C.ft,C.fx,C.fv,C.fg,l.a,l.q,l.Q,C.qt,l.t,l.T,l.d,l.w,l.W,l.c,l.z,l.x,l.v,l.g,l.k,l.o,l.i,l.O,l.j,l.p,l.u,l.P,l.h,C.hk,C.ho,C.hl,l.y,l.n,C.nj,C.np,C.nl,l.b,l.m,C.ml,l.l])}),define(Pe[83],ke([1,0,28]),function(ge,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=void 0,e.normalizeNFC=D,e.normalizeNFD=L;const h=new s.LRUCache(1e4);function D(l){return v(l,"NFC",h)}const A=new s.LRUCache(1e4);function L(l){return v(l,"NFD",A)}const R=/[^\u0000-\u0080]/;function v(l,C,_){if(!l)return l;const f=_.get(l);if(f)return f;let T;return R.test(l)?T=l.normalize(C):T=l,_.set(l,T),T}e.removeAccents=function(){const l=/[\u0300-\u036f]/g;return function(C){return L(C).replace(l,"")}}()}),define(Pe[135],ke([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=void 0,e.clamp=s,e.rot=h,e.isPointWithinTriangle=R;function s(v,l,C){return Math.min(Math.max(v,l),C)}function h(v,l){return(l+v%l)%l}class D{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=D;class A{constructor(){this._n=1,this._val=0}update(l){return this._val=this._val+(l-this._val)/this._n,this._n+=1,this._val}get value(){return this._val}}e.MovingAverage=A;class L{constructor(l){this._n=0,this._val=0,this._values=[],this._index=0,this._sum=0,this._values=new Array(l),this._values.fill(0,0,l)}update(l){const C=this._values[this._index];return this._values[this._index]=l,this._index=(this._index+1)%this._values.length,this._sum-=C,this._sum+=l,this._n<this._values.length&&(this._n+=1),this._val=this._sum/this._n,this._val}get value(){return this._val}}e.SlidingWindowAverage=L;function R(v,l,C,_,f,T,S,o){const m=S-C,p=o-_,u=f-C,i=T-_,a=v-C,t=l-_,n=m*m+p*p,r=m*u+p*i,d=m*a+p*t,c=u*u+i*i,g=u*a+i*t,w=1/(n*c-r*r),y=(c*d-r*g)*w,I=(n*g-r*d)*w;return y>=0&&I>=0&&y+I<1}}),define(Pe[184],ke([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DebugNameData=void 0,e.getDebugName=A,e.getFunctionName=f;class s{constructor(S,o,m){this.owner=S,this.debugNameSource=o,this.referenceFn=m}getDebugName(S){return A(S,this)}}e.DebugNameData=s;const h=new Map,D=new WeakMap;function A(T,S){const o=D.get(T);if(o)return o;const m=L(T,S);if(m){let p=h.get(m)??0;p++,h.set(m,p);const u=p===1?m:`${m}#${p}`;return D.set(T,u),u}}function L(T,S){const o=D.get(T);if(o)return o;const m=S.owner?C(S.owner)+".":"";let p;const u=S.debugNameSource;if(u!==void 0)if(typeof u=="function"){if(p=u(),p!==void 0)return m+p}else return m+u;const i=S.referenceFn;if(i!==void 0&&(p=f(i),p!==void 0))return m+p;if(S.owner!==void 0){const a=R(S.owner,T);if(a!==void 0)return m+a}}function R(T,S){for(const o in T)if(T[o]===S)return o}const v=new Map,l=new WeakMap;function C(T){const S=l.get(T);if(S)return S;const o=_(T);let m=v.get(o)??0;m++,v.set(o,m);const p=m===1?o:`${o}#${m}`;return l.set(T,p),p}function _(T){const S=T.constructor;return S?S.name:"Object"}function f(T){const S=T.toString(),m=/\/\*\*\s*@description\s*([^*]*)\*\//.exec(S);return(m?m[1]:void 0)?.trim()}}),define(Pe[185],ke([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConsoleObservableLogger=void 0,e.setLogger=h,e.getLogger=D;let s;function h(o){s=o}function D(){return s}class A{constructor(){this.indentation=0,this.changedObservablesSets=new WeakMap}textToConsoleArgs(m){return L([R(T("|  ",this.indentation)),m])}formatInfo(m){return m.hadValue?m.didChange?[R(" "),l(C(m.oldValue,70),{color:"red",strikeThrough:!0}),R(" "),l(C(m.newValue,60),{color:"green"})]:[R(" (unchanged)")]:[R(" "),l(C(m.newValue,60),{color:"green"}),R(" (initial)")]}handleObservableChanged(m,p){console.log(...this.textToConsoleArgs([v("observable value changed"),l(m.debugName,{color:"BlueViolet"}),...this.formatInfo(p)]))}formatChanges(m){if(m.size!==0)return l(" (changed deps: "+[...m].map(p=>p.debugName).join(", ")+")",{color:"gray"})}handleDerivedCreated(m){const p=m.handleChange;this.changedObservablesSets.set(m,new Set),m.handleChange=(u,i)=>(this.changedObservablesSets.get(m).add(u),p.apply(m,[u,i]))}handleDerivedRecomputed(m,p){const u=this.changedObservablesSets.get(m);console.log(...this.textToConsoleArgs([v("derived recomputed"),l(m.debugName,{color:"BlueViolet"}),...this.formatInfo(p),this.formatChanges(u),{data:[{fn:m._debugNameData.referenceFn??m._computeFn}]}])),u.clear()}handleFromEventObservableTriggered(m,p){console.log(...this.textToConsoleArgs([v("observable from event triggered"),l(m.debugName,{color:"BlueViolet"}),...this.formatInfo(p),{data:[{fn:m._getValue}]}]))}handleAutorunCreated(m){const p=m.handleChange;this.changedObservablesSets.set(m,new Set),m.handleChange=(u,i)=>(this.changedObservablesSets.get(m).add(u),p.apply(m,[u,i]))}handleAutorunTriggered(m){const p=this.changedObservablesSets.get(m);console.log(...this.textToConsoleArgs([v("autorun"),l(m.debugName,{color:"BlueViolet"}),this.formatChanges(p),{data:[{fn:m._debugNameData.referenceFn??m._runFn}]}])),p.clear(),this.indentation++}handleAutorunFinished(m){this.indentation--}handleBeginTransaction(m){let p=m.getDebugName();p===void 0&&(p=""),console.log(...this.textToConsoleArgs([v("transaction"),l(p,{color:"BlueViolet"}),{data:[{fn:m._fn}]}])),this.indentation++}handleEndTransaction(){this.indentation--}}e.ConsoleObservableLogger=A;function L(o){const m=new Array,p=[];let u="";function i(t){if("length"in t)for(const n of t)n&&i(n);else"text"in t?(u+=`%c${t.text}`,m.push(t.style),t.data&&p.push(...t.data)):"data"in t&&p.push(...t.data)}i(o);const a=[u,...m];return a.push(...p),a}function R(o){return l(o,{color:"black"})}function v(o){return l(S(`${o}: `,10),{color:"black",bold:!0})}function l(o,m={color:"black"}){function p(i){return Object.entries(i).reduce((a,[t,n])=>`${a}${t}:${n};`,"")}const u={color:m.color};return m.strikeThrough&&(u["text-decoration"]="line-through"),m.bold&&(u["font-weight"]="bold"),{text:o,style:p(u)}}function C(o,m){switch(typeof o){case"number":return""+o;case"string":return o.length+2<=m?`"${o}"`:`"${o.substr(0,m-7)}"+...`;case"boolean":return o?"true":"false";case"undefined":return"undefined";case"object":return o===null?"null":Array.isArray(o)?_(o,m):f(o,m);case"symbol":return o.toString();case"function":return`[[Function${o.name?" "+o.name:""}]]`;default:return""+o}}function _(o,m){let p="[ ",u=!0;for(const i of o){if(u||(p+=", "),p.length-5>m){p+="...";break}u=!1,p+=`${C(i,m-p.length)}`}return p+=" ]",p}function f(o,m){let p="{ ",u=!0;for(const[i,a]of Object.entries(o)){if(u||(p+=", "),p.length-5>m){p+="...";break}u=!1,p+=`${i}: ${C(a,m-p.length)}`}return p+=" }",p}function T(o,m){let p="";for(let u=1;u<=m;u++)p+=o;return p}function S(o,m){for(;o.length<m;)o+=" ";return o}}),define(Pe[186],ke([1,0,179,184,185]),function(ge,e,s,h,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DisposableObservableValue=e.ObservableValue=e.TransactionImpl=e.BaseObservable=e.ConvenientObservable=void 0,e._setRecomputeInitiallyAndOnChange=L,e._setKeepObserved=v,e._setDerivedOpts=C,e.transaction=T,e.globalTransaction=o,e.asyncTransaction=m,e.subtransaction=p,e.observableValue=i,e.disposableObservableValue=t;let A;function L(r){A=r}let R;function v(r){R=r}let l;function C(r){l=r}class _{get TChange(){return null}reportChanges(){this.get()}read(d){return d?d.readObservable(this):this.get()}map(d,c){const g=c===void 0?void 0:d,w=c===void 0?d:c;return l({owner:g,debugName:()=>{const y=(0,h.getFunctionName)(w);if(y!==void 0)return y;const P=/^\s*\(?\s*([a-zA-Z_$][a-zA-Z_$0-9]*)\s*\)?\s*=>\s*\1(?:\??)\.([a-zA-Z_$][a-zA-Z_$0-9]*)\s*$/.exec(w.toString());if(P)return`${this.debugName}.${P[2]}`;if(!g)return`${this.debugName} (mapped)`},debugReferenceFn:w},y=>w(this.read(y),y))}flatten(){return l({owner:void 0,debugName:()=>`${this.debugName} (flattened)`},d=>this.read(d).read(d))}recomputeInitiallyAndOnChange(d,c){return d.add(A(this,c)),this}keepObserved(d){return d.add(R(this)),this}get debugValue(){return this.get()}}e.ConvenientObservable=_;class f extends _{constructor(){super(...arguments),this.observers=new Set}addObserver(d){const c=this.observers.size;this.observers.add(d),c===0&&this.onFirstObserverAdded()}removeObserver(d){this.observers.delete(d)&&this.observers.size===0&&this.onLastObserverRemoved()}onFirstObserverAdded(){}onLastObserverRemoved(){}}e.BaseObservable=f;function T(r,d){const c=new u(r,d);try{r(c)}finally{c.finish()}}let S;function o(r){if(S)r(S);else{const d=new u(r,void 0);S=d;try{r(d)}finally{d.finish(),S=void 0}}}async function m(r,d){const c=new u(r,d);try{await r(c)}finally{c.finish()}}function p(r,d,c){r?d(r):T(d,c)}class u{constructor(d,c){this._fn=d,this._getDebugName=c,this.updatingObservers=[],(0,D.getLogger)()?.handleBeginTransaction(this)}getDebugName(){return this._getDebugName?this._getDebugName():(0,h.getFunctionName)(this._fn)}updateObserver(d,c){this.updatingObservers.push({observer:d,observable:c}),d.beginUpdate(c)}finish(){const d=this.updatingObservers;for(let c=0;c<d.length;c++){const{observer:g,observable:w}=d[c];g.endUpdate(w)}this.updatingObservers=null,(0,D.getLogger)()?.handleEndTransaction()}}e.TransactionImpl=u;function i(r,d){let c;return typeof r=="string"?c=new h.DebugNameData(void 0,r,void 0):c=new h.DebugNameData(r,void 0,void 0),new a(c,d,s.strictEquals)}class a extends f{get debugName(){return this._debugNameData.getDebugName(this)??"ObservableValue"}constructor(d,c,g){super(),this._debugNameData=d,this._equalityComparator=g,this._value=c}get(){return this._value}set(d,c,g){if(g===void 0&&this._equalityComparator(this._value,d))return;let w;c||(c=w=new u(()=>{},()=>`Setting ${this.debugName}`));try{const y=this._value;this._setValue(d),(0,D.getLogger)()?.handleObservableChanged(this,{oldValue:y,newValue:d,change:g,didChange:!0,hadValue:!0});for(const I of this.observers)c.updateObserver(I,this),I.handleChange(this,g)}finally{w&&w.finish()}}toString(){return`${this.debugName}: ${this._value}`}_setValue(d){this._value=d}}e.ObservableValue=a;function t(r,d){let c;return typeof r=="string"?c=new h.DebugNameData(void 0,r,void 0):c=new h.DebugNameData(r,void 0,void 0),new n(c,d,s.strictEquals)}class n extends a{_setValue(d){this._value!==d&&(this._value&&this._value.dispose(),this._value=d)}dispose(){this._value?.dispose()}}e.DisposableObservableValue=n}),function(){function ge(D){const A=[];typeof D=="number"&&A.push("code/timeOrigin",D);function L(v){A.push(v,Date.now())}function R(){const v=[];for(let l=0;l<A.length;l+=2)v.push({name:A[l],startTime:A[l+1]});return v}return{mark:L,getMarks:R}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?ge():{mark(D){performance.mark(D)},getMarks(){let D=performance.timeOrigin;typeof D!="number"&&(D=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const A=[{name:"code/timeOrigin",startTime:Math.round(D)}];for(const L of performance.getEntriesByType("mark"))A.push({name:L.name,startTime:Math.round(D+L.startTime)});return A}};if(typeof process=="object"){const D=performance?.timeOrigin;return ge(D)}else return console.trace("perf-util loaded in UNKNOWN environment"),ge()}function s(D){return D.MonacoPerformanceMarks||(D.MonacoPerformanceMarks=e()),D.MonacoPerformanceMarks}var h;typeof global=="object"?h=global:typeof self=="object"?h=self:h={},typeof define=="function"?define("vs/base/common/performance",[],function(){return s(h)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=s(h):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),h.perf=s(h))}(),define(Pe[187],ke([1,0,40]),function(ge,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WellDefinedPrefixTree=void 0;const h=Symbol("unset");class D{constructor(){this.root=new L,this._size=0}get size(){return this._size}get nodes(){return this.root.children?.values()||s.Iterable.empty()}get entries(){return this.root.children?.entries()||s.Iterable.empty()}insert(v,l,C){this.opNode(v,_=>_._value=l,C)}mutate(v,l){this.opNode(v,C=>C._value=l(C._value===h?void 0:C._value))}mutatePath(v,l){this.opNode(v,()=>{},C=>l(C))}delete(v){const l=this.getPathToKey(v);if(!l)return;let C=l.length-1;const _=l[C].node._value;if(_!==h){for(this._size--,l[C].node._value=h;C>0;C--){const{node:f,part:T}=l[C];if(f.children?.size||f._value!==h)break;l[C-1].node.children.delete(T)}return _}}*deleteRecursive(v){const l=this.getPathToKey(v);if(!l)return;const C=l[l.length-1].node;for(let _=l.length-1;_>0;_--){const f=l[_-1];if(f.node.children.delete(l[_].part),f.node.children.size>0||f.node._value!==h)break}for(const _ of A(C))_._value!==h&&(this._size--,yield _._value)}find(v){let l=this.root;for(const C of v){const _=l.children?.get(C);if(!_)return;l=_}return l._value===h?void 0:l._value}hasKeyOrParent(v){let l=this.root;for(const C of v){const _=l.children?.get(C);if(!_)return!1;if(_._value!==h)return!0;l=_}return!1}hasKeyOrChildren(v){let l=this.root;for(const C of v){const _=l.children?.get(C);if(!_)return!1;l=_}return!0}hasKey(v){let l=this.root;for(const C of v){const _=l.children?.get(C);if(!_)return!1;l=_}return l._value!==h}getPathToKey(v){const l=[{part:"",node:this.root}];let C=0;for(const _ of v){const f=l[C].node.children?.get(_);if(!f)return;l.push({part:_,node:f}),C++}return l}opNode(v,l,C){let _=this.root;for(const S of v){if(_.children)if(_.children.has(S))_=_.children.get(S);else{const o=new L;_.children.set(S,o),_=o}else{const o=new L;_.children=new Map([[S,o]]),_=o}C?.(_)}const f=_._value===h?0:1;l(_);const T=_._value===h?0:1;this._size+=T-f}*values(){for(const{_value:v}of A(this.root))v!==h&&(yield v)}}e.WellDefinedPrefixTree=D;function*A(R){const v=[R];for(;v.length>0;){const l=v.pop();if(yield l,l.children)for(const C of l.children.values())v.push(C)}}class L{constructor(){this._value=h}get value(){return this._value===h?void 0:this._value}set value(v){this._value=v===void 0?h:v}}}),function(ge,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var s=e();for(var h in s)(typeof exports=="object"?exports:ge)[h]=s[h]}}(typeof self<"u"?self:this,function(){return function(ge){var e={};function s(h){if(e[h])return e[h].exports;var D=e[h]={i:h,l:!1,exports:{}};return ge[h].call(D.exports,D,D.exports,s),D.l=!0,D.exports}return s.m=ge,s.c=e,s.d=function(h,D,A){s.o(h,D)||Object.defineProperty(h,D,{enumerable:!0,get:A})},s.r=function(h){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(h,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(h,"__esModule",{value:!0})},s.t=function(h,D){if(1&D&&(h=s(h)),8&D||4&D&&typeof h=="object"&&h&&h.__esModule)return h;var A=Object.create(null);if(s.r(A),Object.defineProperty(A,"default",{enumerable:!0,value:h}),2&D&&typeof h!="string")for(var L in h)s.d(A,L,function(R){return h[R]}.bind(null,L));return A},s.n=function(h){var D=h&&h.__esModule?function(){return h.default}:function(){return h};return s.d(D,"a",D),D},s.o=function(h,D){return Object.prototype.hasOwnProperty.call(h,D)},s.p="",s(s.s=0)}([function(ge,e,s){(function(h){var D;e=ge.exports=me,D=typeof h=="object"&&h.env&&h.env.NODE_DEBUG&&/\bsemver\b/i.test(h.env.NODE_DEBUG)?function(){var j=Array.prototype.slice.call(arguments,0);j.unshift("SEMVER"),console.log.apply(console,j)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var A=256,L=Number.MAX_SAFE_INTEGER||9007199254740991,R=e.re=[],v=e.src=[],l=0,C=l++;v[C]="0|[1-9]\\d*";var _=l++;v[_]="[0-9]+";var f=l++;v[f]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var T=l++;v[T]="("+v[C]+")\\.("+v[C]+")\\.("+v[C]+")";var S=l++;v[S]="("+v[_]+")\\.("+v[_]+")\\.("+v[_]+")";var o=l++;v[o]="(?:"+v[C]+"|"+v[f]+")";var m=l++;v[m]="(?:"+v[_]+"|"+v[f]+")";var p=l++;v[p]="(?:-("+v[o]+"(?:\\."+v[o]+")*))";var u=l++;v[u]="(?:-?("+v[m]+"(?:\\."+v[m]+")*))";var i=l++;v[i]="[0-9A-Za-z-]+";var a=l++;v[a]="(?:\\+("+v[i]+"(?:\\."+v[i]+")*))";var t=l++,n="v?"+v[T]+v[p]+"?"+v[a]+"?";v[t]="^"+n+"$";var r="[v=\\s]*"+v[S]+v[u]+"?"+v[a]+"?",d=l++;v[d]="^"+r+"$";var c=l++;v[c]="((?:<|>)?=?)";var g=l++;v[g]=v[_]+"|x|X|\\*";var w=l++;v[w]=v[C]+"|x|X|\\*";var y=l++;v[y]="[v=\\s]*("+v[w]+")(?:\\.("+v[w]+")(?:\\.("+v[w]+")(?:"+v[p]+")?"+v[a]+"?)?)?";var I=l++;v[I]="[v=\\s]*("+v[g]+")(?:\\.("+v[g]+")(?:\\.("+v[g]+")(?:"+v[u]+")?"+v[a]+"?)?)?";var P=l++;v[P]="^"+v[c]+"\\s*"+v[y]+"$";var k=l++;v[k]="^"+v[c]+"\\s*"+v[I]+"$";var b=l++;v[b]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var E=l++;v[E]="(?:~>?)";var N=l++;v[N]="(\\s*)"+v[E]+"\\s+",R[N]=new RegExp(v[N],"g");var O=l++;v[O]="^"+v[E]+v[y]+"$";var M=l++;v[M]="^"+v[E]+v[I]+"$";var U=l++;v[U]="(?:\\^)";var H=l++;v[H]="(\\s*)"+v[U]+"\\s+",R[H]=new RegExp(v[H],"g");var F=l++;v[F]="^"+v[U]+v[y]+"$";var x=l++;v[x]="^"+v[U]+v[I]+"$";var $=l++;v[$]="^"+v[c]+"\\s*("+r+")$|^$";var G=l++;v[G]="^"+v[c]+"\\s*("+n+")$|^$";var B=l++;v[B]="(\\s*)"+v[c]+"\\s*("+r+"|"+v[y]+")",R[B]=new RegExp(v[B],"g");var W=l++;v[W]="^\\s*("+v[y]+")\\s+-\\s+("+v[y]+")\\s*$";var Z=l++;v[Z]="^\\s*("+v[I]+")\\s+-\\s+("+v[I]+")\\s*$";var J=l++;v[J]="(<|>)?=?\\s*\\*";for(var oe=0;oe<35;oe++)D(oe,v[oe]),R[oe]||(R[oe]=new RegExp(v[oe]));function te(j,Y){if(j instanceof me)return j;if(typeof j!="string"||j.length>A||!(Y?R[d]:R[t]).test(j))return null;try{return new me(j,Y)}catch{return null}}function me(j,Y){if(j instanceof me){if(j.loose===Y)return j;j=j.version}else if(typeof j!="string")throw new TypeError("Invalid Version: "+j);if(j.length>A)throw new TypeError("version is longer than "+A+" characters");if(!(this instanceof me))return new me(j,Y);D("SemVer",j,Y),this.loose=Y;var ee=j.trim().match(Y?R[d]:R[t]);if(!ee)throw new TypeError("Invalid Version: "+j);if(this.raw=j,this.major=+ee[1],this.minor=+ee[2],this.patch=+ee[3],this.major>L||this.major<0)throw new TypeError("Invalid major version");if(this.minor>L||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>L||this.patch<0)throw new TypeError("Invalid patch version");ee[4]?this.prerelease=ee[4].split(".").map(function(ue){if(/^[0-9]+$/.test(ue)){var we=+ue;if(we>=0&&we<L)return we}return ue}):this.prerelease=[],this.build=ee[5]?ee[5].split("."):[],this.format()}e.parse=te,e.valid=function(j,Y){var ee=te(j,Y);return ee?ee.version:null},e.clean=function(j,Y){var ee=te(j.trim().replace(/^[=v]+/,""),Y);return ee?ee.version:null},e.SemVer=me,me.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},me.prototype.toString=function(){return this.version},me.prototype.compare=function(j){return D("SemVer.compare",this.version,this.loose,j),j instanceof me||(j=new me(j,this.loose)),this.compareMain(j)||this.comparePre(j)},me.prototype.compareMain=function(j){return j instanceof me||(j=new me(j,this.loose)),Q(this.major,j.major)||Q(this.minor,j.minor)||Q(this.patch,j.patch)},me.prototype.comparePre=function(j){if(j instanceof me||(j=new me(j,this.loose)),this.prerelease.length&&!j.prerelease.length)return-1;if(!this.prerelease.length&&j.prerelease.length)return 1;if(!this.prerelease.length&&!j.prerelease.length)return 0;var Y=0;do{var ee=this.prerelease[Y],ue=j.prerelease[Y];if(D("prerelease compare",Y,ee,ue),ee===void 0&&ue===void 0)return 0;if(ue===void 0)return 1;if(ee===void 0)return-1;if(ee!==ue)return Q(ee,ue)}while(++Y)},me.prototype.inc=function(j,Y){switch(j){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",Y);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",Y);break;case"prepatch":this.prerelease.length=0,this.inc("patch",Y),this.inc("pre",Y);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",Y),this.inc("pre",Y);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ee=this.prerelease.length;--ee>=0;)typeof this.prerelease[ee]=="number"&&(this.prerelease[ee]++,ee=-2);ee===-1&&this.prerelease.push(0)}Y&&(this.prerelease[0]===Y?isNaN(this.prerelease[1])&&(this.prerelease=[Y,0]):this.prerelease=[Y,0]);break;default:throw new Error("invalid increment argument: "+j)}return this.format(),this.raw=this.version,this},e.inc=function(j,Y,ee,ue){typeof ee=="string"&&(ue=ee,ee=void 0);try{return new me(j,ee).inc(Y,ue).version}catch{return null}},e.diff=function(j,Y){if(ae(j,Y))return null;var ee=te(j),ue=te(Y);if(ee.prerelease.length||ue.prerelease.length){for(var we in ee)if((we==="major"||we==="minor"||we==="patch")&&ee[we]!==ue[we])return"pre"+we;return"prerelease"}for(var we in ee)if((we==="major"||we==="minor"||we==="patch")&&ee[we]!==ue[we])return we},e.compareIdentifiers=Q;var le=/^[0-9]+$/;function Q(j,Y){var ee=le.test(j),ue=le.test(Y);return ee&&ue&&(j=+j,Y=+Y),ee&&!ue?-1:ue&&!ee?1:j<Y?-1:j>Y?1:0}function z(j,Y,ee){return new me(j,ee).compare(new me(Y,ee))}function se(j,Y,ee){return z(j,Y,ee)>0}function Ee(j,Y,ee){return z(j,Y,ee)<0}function ae(j,Y,ee){return z(j,Y,ee)===0}function be(j,Y,ee){return z(j,Y,ee)!==0}function pe(j,Y,ee){return z(j,Y,ee)>=0}function ve(j,Y,ee){return z(j,Y,ee)<=0}function Re(j,Y,ee,ue){var we;switch(Y){case"===":typeof j=="object"&&(j=j.version),typeof ee=="object"&&(ee=ee.version),we=j===ee;break;case"!==":typeof j=="object"&&(j=j.version),typeof ee=="object"&&(ee=ee.version),we=j!==ee;break;case"":case"=":case"==":we=ae(j,ee,ue);break;case"!=":we=be(j,ee,ue);break;case">":we=se(j,ee,ue);break;case">=":we=pe(j,ee,ue);break;case"<":we=Ee(j,ee,ue);break;case"<=":we=ve(j,ee,ue);break;default:throw new TypeError("Invalid operator: "+Y)}return we}function Fe(j,Y){if(j instanceof Fe){if(j.loose===Y)return j;j=j.value}if(!(this instanceof Fe))return new Fe(j,Y);D("comparator",j,Y),this.loose=Y,this.parse(j),this.semver===Ve?this.value="":this.value=this.operator+this.semver.version,D("comp",this)}e.rcompareIdentifiers=function(j,Y){return Q(Y,j)},e.major=function(j,Y){return new me(j,Y).major},e.minor=function(j,Y){return new me(j,Y).minor},e.patch=function(j,Y){return new me(j,Y).patch},e.compare=z,e.compareLoose=function(j,Y){return z(j,Y,!0)},e.rcompare=function(j,Y,ee){return z(Y,j,ee)},e.sort=function(j,Y){return j.sort(function(ee,ue){return e.compare(ee,ue,Y)})},e.rsort=function(j,Y){return j.sort(function(ee,ue){return e.rcompare(ee,ue,Y)})},e.gt=se,e.lt=Ee,e.eq=ae,e.neq=be,e.gte=pe,e.lte=ve,e.cmp=Re,e.Comparator=Fe;var Ve={};function Ye(j,Y){if(j instanceof Ye)return j.loose===Y?j:new Ye(j.raw,Y);if(j instanceof Fe)return new Ye(j.value,Y);if(!(this instanceof Ye))return new Ye(j,Y);if(this.loose=Y,this.raw=j,this.set=j.split(/\s*\|\|\s*/).map(function(ee){return this.parseRange(ee.trim())},this).filter(function(ee){return ee.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+j);this.format()}function Je(j){return!j||j.toLowerCase()==="x"||j==="*"}function xe(j,Y,ee,ue,we,Ae,He,Ge,nt,ot,dt,at,ct){return((Y=Je(ee)?"":Je(ue)?">="+ee+".0.0":Je(we)?">="+ee+"."+ue+".0":">="+Y)+" "+(Ge=Je(nt)?"":Je(ot)?"<"+(+nt+1)+".0.0":Je(dt)?"<"+nt+"."+(+ot+1)+".0":at?"<="+nt+"."+ot+"."+dt+"-"+at:"<="+Ge)).trim()}function ze(j,Y){for(var ee=0;ee<j.length;ee++)if(!j[ee].test(Y))return!1;if(Y.prerelease.length){for(ee=0;ee<j.length;ee++)if(D(j[ee].semver),j[ee].semver!==Ve&&j[ee].semver.prerelease.length>0){var ue=j[ee].semver;if(ue.major===Y.major&&ue.minor===Y.minor&&ue.patch===Y.patch)return!0}return!1}return!0}function Ne(j,Y,ee){try{Y=new Ye(Y,ee)}catch{return!1}return Y.test(j)}function V(j,Y,ee,ue){var we,Ae,He,Ge,nt;switch(j=new me(j,ue),Y=new Ye(Y,ue),ee){case">":we=se,Ae=ve,He=Ee,Ge=">",nt=">=";break;case"<":we=Ee,Ae=pe,He=se,Ge="<",nt="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Ne(j,Y,ue))return!1;for(var ot=0;ot<Y.set.length;++ot){var dt=Y.set[ot],at=null,ct=null;if(dt.forEach(function(vt){vt.semver===Ve&&(vt=new Fe(">=0.0.0")),at=at||vt,ct=ct||vt,we(vt.semver,at.semver,ue)?at=vt:He(vt.semver,ct.semver,ue)&&(ct=vt)}),at.operator===Ge||at.operator===nt||(!ct.operator||ct.operator===Ge)&&Ae(j,ct.semver)||ct.operator===nt&&He(j,ct.semver))return!1}return!0}Fe.prototype.parse=function(j){var Y=this.loose?R[$]:R[G],ee=j.match(Y);if(!ee)throw new TypeError("Invalid comparator: "+j);this.operator=ee[1],this.operator==="="&&(this.operator=""),ee[2]?this.semver=new me(ee[2],this.loose):this.semver=Ve},Fe.prototype.toString=function(){return this.value},Fe.prototype.test=function(j){return D("Comparator.test",j,this.loose),this.semver===Ve||(typeof j=="string"&&(j=new me(j,this.loose)),Re(j,this.operator,this.semver,this.loose))},Fe.prototype.intersects=function(j,Y){if(!(j instanceof Fe))throw new TypeError("a Comparator is required");var ee;if(this.operator==="")return ee=new Ye(j.value,Y),Ne(this.value,ee,Y);if(j.operator==="")return ee=new Ye(this.value,Y),Ne(j.semver,ee,Y);var ue=!(this.operator!==">="&&this.operator!==">"||j.operator!==">="&&j.operator!==">"),we=!(this.operator!=="<="&&this.operator!=="<"||j.operator!=="<="&&j.operator!=="<"),Ae=this.semver.version===j.semver.version,He=!(this.operator!==">="&&this.operator!=="<="||j.operator!==">="&&j.operator!=="<="),Ge=Re(this.semver,"<",j.semver,Y)&&(this.operator===">="||this.operator===">")&&(j.operator==="<="||j.operator==="<"),nt=Re(this.semver,">",j.semver,Y)&&(this.operator==="<="||this.operator==="<")&&(j.operator===">="||j.operator===">");return ue||we||Ae&&He||Ge||nt},e.Range=Ye,Ye.prototype.format=function(){return this.range=this.set.map(function(j){return j.join(" ").trim()}).join("||").trim(),this.range},Ye.prototype.toString=function(){return this.range},Ye.prototype.parseRange=function(j){var Y=this.loose;j=j.trim(),D("range",j,Y);var ee=Y?R[Z]:R[W];j=j.replace(ee,xe),D("hyphen replace",j),j=j.replace(R[B],"$1$2$3"),D("comparator trim",j,R[B]),j=(j=(j=j.replace(R[N],"$1~")).replace(R[H],"$1^")).split(/\s+/).join(" ");var ue=Y?R[$]:R[G],we=j.split(" ").map(function(Ae){return function(He,Ge){return D("comp",He),He=function(nt,ot){return nt.trim().split(/\s+/).map(function(dt){return function(at,ct){D("caret",at,ct);var vt=ct?R[x]:R[F];return at.replace(vt,function(it,Ce,re,ce,ye){var he;return D("caret",at,it,Ce,re,ce,ye),Je(Ce)?he="":Je(re)?he=">="+Ce+".0.0 <"+(+Ce+1)+".0.0":Je(ce)?he=Ce==="0"?">="+Ce+"."+re+".0 <"+Ce+"."+(+re+1)+".0":">="+Ce+"."+re+".0 <"+(+Ce+1)+".0.0":ye?(D("replaceCaret pr",ye),ye.charAt(0)!=="-"&&(ye="-"+ye),he=Ce==="0"?re==="0"?">="+Ce+"."+re+"."+ce+ye+" <"+Ce+"."+re+"."+(+ce+1):">="+Ce+"."+re+"."+ce+ye+" <"+Ce+"."+(+re+1)+".0":">="+Ce+"."+re+"."+ce+ye+" <"+(+Ce+1)+".0.0"):(D("no pr"),he=Ce==="0"?re==="0"?">="+Ce+"."+re+"."+ce+" <"+Ce+"."+re+"."+(+ce+1):">="+Ce+"."+re+"."+ce+" <"+Ce+"."+(+re+1)+".0":">="+Ce+"."+re+"."+ce+" <"+(+Ce+1)+".0.0"),D("caret return",he),he})}(dt,ot)}).join(" ")}(He,Ge),D("caret",He),He=function(nt,ot){return nt.trim().split(/\s+/).map(function(dt){return function(at,ct){var vt=ct?R[M]:R[O];return at.replace(vt,function(it,Ce,re,ce,ye){var he;return D("tilde",at,it,Ce,re,ce,ye),Je(Ce)?he="":Je(re)?he=">="+Ce+".0.0 <"+(+Ce+1)+".0.0":Je(ce)?he=">="+Ce+"."+re+".0 <"+Ce+"."+(+re+1)+".0":ye?(D("replaceTilde pr",ye),ye.charAt(0)!=="-"&&(ye="-"+ye),he=">="+Ce+"."+re+"."+ce+ye+" <"+Ce+"."+(+re+1)+".0"):he=">="+Ce+"."+re+"."+ce+" <"+Ce+"."+(+re+1)+".0",D("tilde return",he),he})}(dt,ot)}).join(" ")}(He,Ge),D("tildes",He),He=function(nt,ot){return D("replaceXRanges",nt,ot),nt.split(/\s+/).map(function(dt){return function(at,ct){at=at.trim();var vt=ct?R[k]:R[P];return at.replace(vt,function(it,Ce,re,ce,ye,he){D("xRange",at,it,Ce,re,ce,ye,he);var Ie=Je(re),ne=Ie||Je(ce),X=ne||Je(ye);return Ce==="="&&X&&(Ce=""),Ie?it=Ce===">"||Ce==="<"?"<0.0.0":"*":Ce&&X?(ne&&(ce=0),X&&(ye=0),Ce===">"?(Ce=">=",ne?(re=+re+1,ce=0,ye=0):X&&(ce=+ce+1,ye=0)):Ce==="<="&&(Ce="<",ne?re=+re+1:ce=+ce+1),it=Ce+re+"."+ce+"."+ye):ne?it=">="+re+".0.0 <"+(+re+1)+".0.0":X&&(it=">="+re+"."+ce+".0 <"+re+"."+(+ce+1)+".0"),D("xRange return",it),it})}(dt,ot)}).join(" ")}(He,Ge),D("xrange",He),He=function(nt,ot){return D("replaceStars",nt,ot),nt.trim().replace(R[J],"")}(He,Ge),D("stars",He),He}(Ae,Y)}).join(" ").split(/\s+/);return this.loose&&(we=we.filter(function(Ae){return!!Ae.match(ue)})),we=we.map(function(Ae){return new Fe(Ae,Y)})},Ye.prototype.intersects=function(j,Y){if(!(j instanceof Ye))throw new TypeError("a Range is required");return this.set.some(function(ee){return ee.every(function(ue){return j.set.some(function(we){return we.every(function(Ae){return ue.intersects(Ae,Y)})})})})},e.toComparators=function(j,Y){return new Ye(j,Y).set.map(function(ee){return ee.map(function(ue){return ue.value}).join(" ").trim().split(" ")})},Ye.prototype.test=function(j){if(!j)return!1;typeof j=="string"&&(j=new me(j,this.loose));for(var Y=0;Y<this.set.length;Y++)if(ze(this.set[Y],j))return!0;return!1},e.satisfies=Ne,e.maxSatisfying=function(j,Y,ee){var ue=null,we=null;try{var Ae=new Ye(Y,ee)}catch{return null}return j.forEach(function(He){Ae.test(He)&&(ue&&we.compare(He)!==-1||(we=new me(ue=He,ee)))}),ue},e.minSatisfying=function(j,Y,ee){var ue=null,we=null;try{var Ae=new Ye(Y,ee)}catch{return null}return j.forEach(function(He){Ae.test(He)&&(ue&&we.compare(He)!==1||(we=new me(ue=He,ee)))}),ue},e.validRange=function(j,Y){try{return new Ye(j,Y).range||"*"}catch{return null}},e.ltr=function(j,Y,ee){return V(j,Y,"<",ee)},e.gtr=function(j,Y,ee){return V(j,Y,">",ee)},e.outside=V,e.prerelease=function(j,Y){var ee=te(j,Y);return ee&&ee.prerelease.length?ee.prerelease:null},e.intersects=function(j,Y,ee){return j=new Ye(j,ee),Y=new Ye(Y,ee),j.intersects(Y)},e.coerce=function(j){if(j instanceof me)return j;if(typeof j!="string")return null;var Y=j.match(R[b]);return Y==null?null:te((Y[1]||"0")+"."+(Y[2]||"0")+"."+(Y[3]||"0"))}}).call(this,s(1))},function(ge,e){var s,h,D=ge.exports={};function A(){throw new Error("setTimeout has not been defined")}function L(){throw new Error("clearTimeout has not been defined")}function R(m){if(s===setTimeout)return setTimeout(m,0);if((s===A||!s)&&setTimeout)return s=setTimeout,setTimeout(m,0);try{return s(m,0)}catch{try{return s.call(null,m,0)}catch{return s.call(this,m,0)}}}(function(){try{s=typeof setTimeout=="function"?setTimeout:A}catch{s=A}try{h=typeof clearTimeout=="function"?clearTimeout:L}catch{h=L}})();var v,l=[],C=!1,_=-1;function f(){C&&v&&(C=!1,v.length?l=v.concat(l):_=-1,l.length&&T())}function T(){if(!C){var m=R(f);C=!0;for(var p=l.length;p;){for(v=l,l=[];++_<p;)v&&v[_].run();_=-1,p=l.length}v=null,C=!1,function(u){if(h===clearTimeout)return clearTimeout(u);if((h===L||!h)&&clearTimeout)return h=clearTimeout,clearTimeout(u);try{h(u)}catch{try{return h.call(null,u)}catch{return h.call(this,u)}}}(m)}}function S(m,p){this.fun=m,this.array=p}function o(){}D.nextTick=function(m){var p=new Array(arguments.length-1);if(arguments.length>1)for(var u=1;u<arguments.length;u++)p[u-1]=arguments[u];l.push(new S(m,p)),l.length!==1||C||R(T)},S.prototype.run=function(){this.fun.apply(null,this.array)},D.title="browser",D.browser=!0,D.env={},D.argv=[],D.version="",D.versions={},D.on=o,D.addListener=o,D.once=o,D.off=o,D.removeListener=o,D.removeAllListeners=o,D.emit=o,D.prependListener=o,D.prependOnceListener=o,D.listeners=function(m){return[]},D.binding=function(m){throw new Error("process.binding is not supported")},D.cwd=function(){return"/"},D.chdir=function(m){throw new Error("process.chdir is not supported")},D.umask=function(){return 0}}])}),define(Pe[43],ke([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const s=globalThis.performance&&typeof globalThis.performance.now=="function";class h{static create(A){return new h(A)}constructor(A){this._now=s&&A===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this._startTime=this._now(),this._stopTime=-1}stop(){this._stopTime=this._now()}reset(){this._startTime=this._now(),this._stopTime=-1}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}}e.StopWatch=h}),define(Pe[4],ke([1,0,12,81,3,82,43]),function(ge,e,s,h,D,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ValueWithChangeEvent=e.Relay=e.EventBufferer=e.DynamicListEventMultiplexer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.createEventDeliveryQueue=e.Emitter=e.ListenerRefusalError=e.ListenerLeakError=e.EventProfiling=e.Event=void 0,e.setGlobalLeakWarningThreshold=T;const R=!1,v=!1,l=!1;var C;(function(M){M.None=()=>D.Disposable.None;function U(Ne){if(l){const{onDidAddListener:V}=Ne,j=o.create();let Y=0;Ne.onDidAddListener=()=>{++Y===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),j.print()),V?.()}}}function H(Ne,V){return me(Ne,()=>{},0,void 0,!0,void 0,V)}M.defer=H;function F(Ne){return(V,j=null,Y)=>{let ee=!1,ue;return ue=Ne(we=>{if(!ee)return ue?ue.dispose():ee=!0,V.call(j,we)},null,Y),ee&&ue.dispose(),ue}}M.once=F;function x(Ne,V){return M.once(M.filter(Ne,V))}M.onceIf=x;function $(Ne,V,j){return oe((Y,ee=null,ue)=>Ne(we=>Y.call(ee,V(we)),null,ue),j)}M.map=$;function G(Ne,V,j){return oe((Y,ee=null,ue)=>Ne(we=>{V(we),Y.call(ee,we)},null,ue),j)}M.forEach=G;function B(Ne,V,j){return oe((Y,ee=null,ue)=>Ne(we=>V(we)&&Y.call(ee,we),null,ue),j)}M.filter=B;function W(Ne){return Ne}M.signal=W;function Z(...Ne){return(V,j=null,Y)=>{const ee=(0,D.combinedDisposable)(...Ne.map(ue=>ue(we=>V.call(j,we))));return te(ee,Y)}}M.any=Z;function J(Ne,V,j,Y){let ee=j;return $(Ne,ue=>(ee=V(ee,ue),ee),Y)}M.reduce=J;function oe(Ne,V){let j;const Y={onWillAddFirstListener(){j=Ne(ee.fire,ee)},onDidRemoveLastListener(){j?.dispose()}};V||U(Y);const ee=new r(Y);return V?.add(ee),ee.event}function te(Ne,V){return V instanceof Array?V.push(Ne):V&&V.add(Ne),Ne}function me(Ne,V,j=100,Y=!1,ee=!1,ue,we){let Ae,He,Ge,nt=0,ot;const dt={leakWarningThreshold:ue,onWillAddFirstListener(){Ae=Ne(ct=>{nt++,He=V(He,ct),Y&&!Ge&&(at.fire(He),He=void 0),ot=()=>{const vt=He;He=void 0,Ge=void 0,(!Y||nt>1)&&at.fire(vt),nt=0},typeof j=="number"?(clearTimeout(Ge),Ge=setTimeout(ot,j)):Ge===void 0&&(Ge=0,queueMicrotask(ot))})},onWillRemoveListener(){ee&&nt>0&&ot?.()},onDidRemoveLastListener(){ot=void 0,Ae.dispose()}};we||U(dt);const at=new r(dt);return we?.add(at),at.event}M.debounce=me;function le(Ne,V=0,j){return M.debounce(Ne,(Y,ee)=>Y?(Y.push(ee),Y):[ee],V,void 0,!0,void 0,j)}M.accumulate=le;function Q(Ne,V=(Y,ee)=>Y===ee,j){let Y=!0,ee;return B(Ne,ue=>{const we=Y||!V(ue,ee);return Y=!1,ee=ue,we},j)}M.latch=Q;function z(Ne,V,j){return[M.filter(Ne,V,j),M.filter(Ne,Y=>!V(Y),j)]}M.split=z;function se(Ne,V=!1,j=[],Y){let ee=j.slice(),ue=Ne(He=>{ee?ee.push(He):Ae.fire(He)});Y&&Y.add(ue);const we=()=>{ee?.forEach(He=>Ae.fire(He)),ee=null},Ae=new r({onWillAddFirstListener(){ue||(ue=Ne(He=>Ae.fire(He)),Y&&Y.add(ue))},onDidAddFirstListener(){ee&&(V?setTimeout(we):we())},onDidRemoveLastListener(){ue&&ue.dispose(),ue=null}});return Y&&Y.add(Ae),Ae.event}M.buffer=se;function Ee(Ne,V){return(Y,ee,ue)=>{const we=V(new be);return Ne(function(Ae){const He=we.evaluate(Ae);He!==ae&&Y.call(ee,He)},void 0,ue)}}M.chain=Ee;const ae=Symbol("HaltChainable");class be{constructor(){this.steps=[]}map(V){return this.steps.push(V),this}forEach(V){return this.steps.push(j=>(V(j),j)),this}filter(V){return this.steps.push(j=>V(j)?j:ae),this}reduce(V,j){let Y=j;return this.steps.push(ee=>(Y=V(Y,ee),Y)),this}latch(V=(j,Y)=>j===Y){let j=!0,Y;return this.steps.push(ee=>{const ue=j||!V(ee,Y);return j=!1,Y=ee,ue?ee:ae}),this}evaluate(V){for(const j of this.steps)if(V=j(V),V===ae)break;return V}}function pe(Ne,V,j=Y=>Y){const Y=(...Ae)=>we.fire(j(...Ae)),ee=()=>Ne.on(V,Y),ue=()=>Ne.removeListener(V,Y),we=new r({onWillAddFirstListener:ee,onDidRemoveLastListener:ue});return we.event}M.fromNodeEventEmitter=pe;function ve(Ne,V,j=Y=>Y){const Y=(...Ae)=>we.fire(j(...Ae)),ee=()=>Ne.addEventListener(V,Y),ue=()=>Ne.removeEventListener(V,Y),we=new r({onWillAddFirstListener:ee,onDidRemoveLastListener:ue});return we.event}M.fromDOMEventEmitter=ve;function Re(Ne){return new Promise(V=>F(Ne)(V))}M.toPromise=Re;function Fe(Ne){const V=new r;return Ne.then(j=>{V.fire(j)},()=>{V.fire(void 0)}).finally(()=>{V.dispose()}),V.event}M.fromPromise=Fe;function Ve(Ne,V){return Ne(j=>V.fire(j))}M.forward=Ve;function Ye(Ne,V,j){return V(j),Ne(Y=>V(Y))}M.runAndSubscribe=Ye;class Je{constructor(V,j){this._observable=V,this._counter=0,this._hasChanged=!1;const Y={onWillAddFirstListener:()=>{V.addObserver(this),this._observable.reportChanges()},onDidRemoveLastListener:()=>{V.removeObserver(this)}};j||U(Y),this.emitter=new r(Y),j&&j.add(this.emitter)}beginUpdate(V){this._counter++}handlePossibleChange(V){}handleChange(V,j){this._hasChanged=!0}endUpdate(V){this._counter--,this._counter===0&&(this._observable.reportChanges(),this._hasChanged&&(this._hasChanged=!1,this.emitter.fire(this._observable.get())))}}function xe(Ne,V){return new Je(Ne,V).emitter.event}M.fromObservable=xe;function ze(Ne){return(V,j,Y)=>{let ee=0,ue=!1;const we={beginUpdate(){ee++},endUpdate(){ee--,ee===0&&(Ne.reportChanges(),ue&&(ue=!1,V.call(j)))},handlePossibleChange(){},handleChange(){ue=!0}};Ne.addObserver(we),Ne.reportChanges();const Ae={dispose(){Ne.removeObserver(we)}};return Y instanceof D.DisposableStore?Y.add(Ae):Array.isArray(Y)&&Y.push(Ae),Ae}}M.fromObservableLight=ze})(C||(e.Event=C={}));class _{static{this.all=new Set}static{this._idPool=0}constructor(U){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${U}_${_._idPool++}`,_.all.add(this)}start(U){this._stopWatch=new L.StopWatch,this.listenerCount=U}stop(){if(this._stopWatch){const U=this._stopWatch.elapsed();this.durations.push(U),this.elapsedOverall+=U,this.invocationCount+=1,this._stopWatch=void 0}}}e.EventProfiling=_;let f=-1;function T(M){const U=f;return f=M,{dispose(){f=U}}}class S{static{this._idPool=1}constructor(U,H,F=(S._idPool++).toString(16).padStart(3,"0")){this._errorHandler=U,this.threshold=H,this.name=F,this._warnCountdown=0}dispose(){this._stacks?.clear()}check(U,H){const F=this.threshold;if(F<=0||H<F)return;this._stacks||(this._stacks=new Map);const x=this._stacks.get(U.value)||0;if(this._stacks.set(U.value,x+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=F*.5;const[$,G]=this.getMostFrequentStack(),B=`[${this.name}] potential listener LEAK detected, having ${H} listeners already. MOST frequent listener (${G}):`;console.warn(B),console.warn($);const W=new m(B,$);this._errorHandler(W)}return()=>{const $=this._stacks.get(U.value)||0;this._stacks.set(U.value,$-1)}}getMostFrequentStack(){if(!this._stacks)return;let U,H=0;for(const[F,x]of this._stacks)(!U||H<x)&&(U=[F,x],H=x);return U}}class o{static create(){const U=new Error;return new o(U.stack??"")}constructor(U){this.value=U}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class m extends Error{constructor(U,H){super(U),this.name="ListenerLeakError",this.stack=H}}e.ListenerLeakError=m;class p extends Error{constructor(U,H){super(U),this.name="ListenerRefusalError",this.stack=H}}e.ListenerRefusalError=p;let u=0;class i{constructor(U){this.value=U,this.id=u++}}const a=2,t=(M,U)=>{if(M instanceof i)U(M);else for(let H=0;H<M.length;H++){const F=M[H];F&&U(F)}};let n;if(R){const M=[];setInterval(()=>{M.length!==0&&(console.warn("[LEAKING LISTENERS] GC'ed these listeners that were NOT yet disposed:"),console.warn(M.join(`
`)),M.length=0)},3e3),n=new FinalizationRegistry(U=>{typeof U=="string"&&M.push(U)})}class r{constructor(U){this._size=0,this._options=U,this._leakageMon=f>0||this._options?.leakWarningThreshold?new S(U?.onListenerError??s.onUnexpectedError,this._options?.leakWarningThreshold??f):void 0,this._perfMon=this._options?._profName?new _(this._options._profName):void 0,this._deliveryQueue=this._options?.deliveryQueue}dispose(){if(!this._disposed){if(this._disposed=!0,this._deliveryQueue?.current===this&&this._deliveryQueue.reset(),this._listeners){if(v){const U=this._listeners;queueMicrotask(()=>{t(U,H=>H.stack?.print())})}this._listeners=void 0,this._size=0}this._options?.onDidRemoveLastListener?.(),this._leakageMon?.dispose()}}get event(){return this._event??=(U,H,F)=>{if(this._leakageMon&&this._size>this._leakageMon.threshold**2){const W=`[${this._leakageMon.name}] REFUSES to accept new listeners because it exceeded its threshold by far (${this._size} vs ${this._leakageMon.threshold})`;console.warn(W);const Z=this._leakageMon.getMostFrequentStack()??["UNKNOWN stack",-1],J=new p(`${W}. HINT: Stack shows most frequent listener (${Z[1]}-times)`,Z[0]);return(this._options?.onListenerError||s.onUnexpectedError)(J),D.Disposable.None}if(this._disposed)return D.Disposable.None;H&&(U=U.bind(H));const x=new i(U);let $,G;this._leakageMon&&this._size>=Math.ceil(this._leakageMon.threshold*.2)&&(x.stack=o.create(),$=this._leakageMon.check(x.stack,this._size+1)),v&&(x.stack=G??o.create()),this._listeners?this._listeners instanceof i?(this._deliveryQueue??=new c,this._listeners=[this._listeners,x]):this._listeners.push(x):(this._options?.onWillAddFirstListener?.(this),this._listeners=x,this._options?.onDidAddFirstListener?.(this)),this._size++;const B=(0,D.toDisposable)(()=>{n?.unregister(B),$?.(),this._removeListener(x)});if(F instanceof D.DisposableStore?F.add(B):Array.isArray(F)&&F.push(B),n){const W=new Error().stack.split(`
`).slice(2,3).join(`
`).trim(),Z=/(file:|vscode-file:\/\/vscode-app)?(\/[^:]*:\d+:\d+)/.exec(W);n.register(B,Z?.[2]??W,B)}return B},this._event}_removeListener(U){if(this._options?.onWillRemoveListener?.(this),!this._listeners)return;if(this._size===1){this._listeners=void 0,this._options?.onDidRemoveLastListener?.(this),this._size=0;return}const H=this._listeners,F=H.indexOf(U);if(F===-1)throw console.log("disposed?",this._disposed),console.log("size?",this._size),console.log("arr?",JSON.stringify(this._listeners)),new Error("Attempted to dispose unknown listener");this._size--,H[F]=void 0;const x=this._deliveryQueue.current===this;if(this._size*a<=H.length){let $=0;for(let G=0;G<H.length;G++)H[G]?H[$++]=H[G]:x&&(this._deliveryQueue.end--,$<this._deliveryQueue.i&&this._deliveryQueue.i--);H.length=$}}_deliver(U,H){if(!U)return;const F=this._options?.onListenerError||s.onUnexpectedError;if(!F){U.value(H);return}try{U.value(H)}catch(x){F(x)}}_deliverQueue(U){const H=U.current._listeners;for(;U.i<U.end;)this._deliver(H[U.i++],U.value);U.reset()}fire(U){if(this._deliveryQueue?.current&&(this._deliverQueue(this._deliveryQueue),this._perfMon?.stop()),this._perfMon?.start(this._size),this._listeners)if(this._listeners instanceof i)this._deliver(this._listeners,U);else{const H=this._deliveryQueue;H.enqueue(this,U,this._listeners.length),this._deliverQueue(H)}this._perfMon?.stop()}hasListeners(){return this._size>0}}e.Emitter=r;const d=()=>new c;e.createEventDeliveryQueue=d;class c{constructor(){this.i=-1,this.end=0}enqueue(U,H,F){this.i=0,this.end=F,this.current=U,this.value=H}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class g extends r{async fireAsync(U,H,F){if(this._listeners)for(this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new A.LinkedList),t(this._listeners,x=>this._asyncDeliveryQueue.push([x.value,U]));this._asyncDeliveryQueue.size>0&&!H.isCancellationRequested;){const[x,$]=this._asyncDeliveryQueue.shift(),G=[],B={...$,token:H,waitUntil:W=>{if(Object.isFrozen(G))throw new Error("waitUntil can NOT be called asynchronous");F&&(W=F(W,x)),G.push(W)}};try{x(B)}catch(W){(0,s.onUnexpectedError)(W);continue}Object.freeze(G),await Promise.allSettled(G).then(W=>{for(const Z of W)Z.status==="rejected"&&(0,s.onUnexpectedError)(Z.reason)})}}}e.AsyncEmitter=g;class w extends r{get isPaused(){return this._isPaused!==0}constructor(U){super(U),this._isPaused=0,this._eventQueue=new A.LinkedList,this._mergeFn=U?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused===0)if(this._mergeFn){if(this._eventQueue.size>0){const U=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(U))}}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(U){this._size&&(this._isPaused!==0?this._eventQueue.push(U):super.fire(U))}}e.PauseableEmitter=w;class y extends w{constructor(U){super(U),this._delay=U.delay??100}fire(U){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(U)}}e.DebounceEmitter=y;class I extends r{constructor(U){super(U),this._queuedEvents=[],this._mergeFn=U?.merge}fire(U){this.hasListeners()&&(this._queuedEvents.push(U),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(H=>super.fire(H)),this._queuedEvents=[]}))}}e.MicrotaskEmitter=I;class P{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new r({onWillAddFirstListener:()=>this.onFirstListenerAdd(),onDidRemoveLastListener:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(U){const H={event:U,listener:null};this.events.push(H),this.hasListeners&&this.hook(H);const F=()=>{this.hasListeners&&this.unhook(H);const x=this.events.indexOf(H);this.events.splice(x,1)};return(0,D.toDisposable)((0,h.createSingleCallFunction)(F))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(U=>this.hook(U))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(U=>this.unhook(U))}hook(U){U.listener=U.event(H=>this.emitter.fire(H))}unhook(U){U.listener?.dispose(),U.listener=null}dispose(){this.emitter.dispose();for(const U of this.events)U.listener?.dispose();this.events=[]}}e.EventMultiplexer=P;class k{constructor(U,H,F,x){this._store=new D.DisposableStore;const $=this._store.add(new P),G=this._store.add(new D.DisposableMap);function B(W){G.set(W,$.add(x(W)))}for(const W of U)B(W);this._store.add(H(W=>{B(W)})),this._store.add(F(W=>{G.deleteAndDispose(W)})),this.event=$.event}dispose(){this._store.dispose()}}e.DynamicListEventMultiplexer=k;class b{constructor(){this.data=[]}wrapEvent(U,H,F){return(x,$,G)=>U(B=>{const W=this.data[this.data.length-1];if(!H){W?W.buffers.push(()=>x.call($,B)):x.call($,B);return}const Z=W;if(!Z){x.call($,H(F,B));return}Z.items??=[],Z.items.push(B),Z.buffers.length===0&&W.buffers.push(()=>{Z.reducedResult??=F?Z.items.reduce(H,F):Z.items.reduce(H),x.call($,Z.reducedResult)})},void 0,G)}bufferEvents(U){const H={buffers:new Array};this.data.push(H);const F=U();return this.data.pop(),H.buffers.forEach(x=>x()),F}}e.EventBufferer=b;class E{constructor(){this.listening=!1,this.inputEvent=C.None,this.inputEventListener=D.Disposable.None,this.emitter=new r({onDidAddFirstListener:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onDidRemoveLastListener:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(U){this.inputEvent=U,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=U(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=E;class N{static const(U){return new O(U)}constructor(U){this._value=U,this._onDidChange=new r,this.onDidChange=this._onDidChange.event}get value(){return this._value}set value(U){U!==this._value&&(this._value=U,this._onDidChange.fire(void 0))}}e.ValueWithChangeEvent=N;class O{constructor(U){this.value=U,this.onDidChange=C.None}}}),define(Pe[20],ke([1,0,4]),function(ge,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0,e.cancelOnDispose=R;const h=Object.freeze(function(v,l){const C=setTimeout(v.bind(l),0);return{dispose(){clearTimeout(C)}}});var D;(function(v){function l(C){return C===v.None||C===v.Cancelled||C instanceof A?!0:!C||typeof C!="object"?!1:typeof C.isCancellationRequested=="boolean"&&typeof C.onCancellationRequested=="function"}v.isCancellationToken=l,v.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:s.Event.None}),v.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:h})})(D||(e.CancellationToken=D={}));class A{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?h:(this._emitter||(this._emitter=new s.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class L{constructor(l){this._token=void 0,this._parentListener=void 0,this._parentListener=l&&l.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new A),this._token}cancel(){this._token?this._token instanceof A&&this._token.cancel():this._token=D.Cancelled}dispose(l=!1){l&&this.cancel(),this._parentListener?.dispose(),this._token?this._token instanceof A&&this._token.dispose():this._token=D.None}}e.CancellationTokenSource=L;function R(v){const l=new L;return v.add({dispose(){l.cancel()}}),l.token}}),define(Pe[188],ke([1,0,20]),function(ge,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0,e.identity=D;class h{constructor(v){this.task=v,this.result=null}get(){if(this.result)return this.result;const v=new s.CancellationTokenSource,l=this.task(v.token);return this.result={promise:l,dispose:()=>{this.result=null,v.cancel(),v.dispose()}},this.result}}e.Cache=h;function D(R){return R}class A{constructor(v,l){this.lastCache=void 0,this.lastArgKey=void 0,typeof v=="function"?(this._fn=v,this._computeKey=D):(this._fn=l,this._computeKey=v.getCacheKey)}get(v){const l=this._computeKey(v);return this.lastArgKey!==l&&(this.lastArgKey=l,this.lastCache=this._fn(v)),this.lastCache}}e.LRUCachedFunction=A;class L{get cachedValues(){return this._map}constructor(v,l){this._map=new Map,this._map2=new Map,typeof v=="function"?(this._fn=v,this._computeKey=D):(this._fn=l,this._computeKey=v.getCacheKey)}get(v){const l=this._computeKey(v);if(this._map2.has(l))return this._map2.get(l);const C=this._fn(v);return this._map.set(v,C),this._map2.set(l,C),C}}e.CachedFunction=L}),define(Pe[189],ke([1,0,4,3]),function(ge,e,s,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SmoothScrollingOperation=e.SmoothScrollingUpdate=e.Scrollable=e.ScrollState=e.ScrollbarVisibility=void 0;var D;(function(T){T[T.Auto=1]="Auto",T[T.Hidden=2]="Hidden",T[T.Visible=3]="Visible"})(D||(e.ScrollbarVisibility=D={}));class A{constructor(S,o,m,p,u,i,a){this._forceIntegerValues=S,this._scrollStateBrand=void 0,this._forceIntegerValues&&(o=o|0,m=m|0,p=p|0,u=u|0,i=i|0,a=a|0),this.rawScrollLeft=p,this.rawScrollTop=a,o<0&&(o=0),p+o>m&&(p=m-o),p<0&&(p=0),u<0&&(u=0),a+u>i&&(a=i-u),a<0&&(a=0),this.width=o,this.scrollWidth=m,this.scrollLeft=p,this.height=u,this.scrollHeight=i,this.scrollTop=a}equals(S){return this.rawScrollLeft===S.rawScrollLeft&&this.rawScrollTop===S.rawScrollTop&&this.width===S.width&&this.scrollWidth===S.scrollWidth&&this.scrollLeft===S.scrollLeft&&this.height===S.height&&this.scrollHeight===S.scrollHeight&&this.scrollTop===S.scrollTop}withScrollDimensions(S,o){return new A(this._forceIntegerValues,typeof S.width<"u"?S.width:this.width,typeof S.scrollWidth<"u"?S.scrollWidth:this.scrollWidth,o?this.rawScrollLeft:this.scrollLeft,typeof S.height<"u"?S.height:this.height,typeof S.scrollHeight<"u"?S.scrollHeight:this.scrollHeight,o?this.rawScrollTop:this.scrollTop)}withScrollPosition(S){return new A(this._forceIntegerValues,this.width,this.scrollWidth,typeof S.scrollLeft<"u"?S.scrollLeft:this.rawScrollLeft,this.height,this.scrollHeight,typeof S.scrollTop<"u"?S.scrollTop:this.rawScrollTop)}createScrollEvent(S,o){const m=this.width!==S.width,p=this.scrollWidth!==S.scrollWidth,u=this.scrollLeft!==S.scrollLeft,i=this.height!==S.height,a=this.scrollHeight!==S.scrollHeight,t=this.scrollTop!==S.scrollTop;return{inSmoothScrolling:o,oldWidth:S.width,oldScrollWidth:S.scrollWidth,oldScrollLeft:S.scrollLeft,width:this.width,scrollWidth:this.scrollWidth,scrollLeft:this.scrollLeft,oldHeight:S.height,oldScrollHeight:S.scrollHeight,oldScrollTop:S.scrollTop,height:this.height,scrollHeight:this.scrollHeight,scrollTop:this.scrollTop,widthChanged:m,scrollWidthChanged:p,scrollLeftChanged:u,heightChanged:i,scrollHeightChanged:a,scrollTopChanged:t}}}e.ScrollState=A;class L extends h.Disposable{constructor(S){super(),this._scrollableBrand=void 0,this._onScroll=this._register(new s.Emitter),this.onScroll=this._onScroll.event,this._smoothScrollDuration=S.smoothScrollDuration,this._scheduleAtNextAnimationFrame=S.scheduleAtNextAnimationFrame,this._state=new A(S.forceIntegerValues,0,0,0,0,0,0),this._smoothScrolling=null}dispose(){this._smoothScrolling&&(this._smoothScrolling.dispose(),this._smoothScrolling=null),super.dispose()}setSmoothScrollDuration(S){this._smoothScrollDuration=S}validateScrollPosition(S){return this._state.withScrollPosition(S)}getScrollDimensions(){return this._state}setScrollDimensions(S,o){const m=this._state.withScrollDimensions(S,o);this._setState(m,!!this._smoothScrolling),this._smoothScrolling?.acceptScrollDimensions(this._state)}getFutureScrollPosition(){return this._smoothScrolling?this._smoothScrolling.to:this._state}getCurrentScrollPosition(){return this._state}setScrollPositionNow(S){const o=this._state.withScrollPosition(S);this._smoothScrolling&&(this._smoothScrolling.dispose(),this._smoothScrolling=null),this._setState(o,!1)}setScrollPositionSmooth(S,o){if(this._smoothScrollDuration===0)return this.setScrollPositionNow(S);if(this._smoothScrolling){S={scrollLeft:typeof S.scrollLeft>"u"?this._smoothScrolling.to.scrollLeft:S.scrollLeft,scrollTop:typeof S.scrollTop>"u"?this._smoothScrolling.to.scrollTop:S.scrollTop};const m=this._state.withScrollPosition(S);if(this._smoothScrolling.to.scrollLeft===m.scrollLeft&&this._smoothScrolling.to.scrollTop===m.scrollTop)return;let p;o?p=new C(this._smoothScrolling.from,m,this._smoothScrolling.startTime,this._smoothScrolling.duration):p=this._smoothScrolling.combine(this._state,m,this._smoothScrollDuration),this._smoothScrolling.dispose(),this._smoothScrolling=p}else{const m=this._state.withScrollPosition(S);this._smoothScrolling=C.start(this._state,m,this._smoothScrollDuration)}this._smoothScrolling.animationFrameDisposable=this._scheduleAtNextAnimationFrame(()=>{this._smoothScrolling&&(this._smoothScrolling.animationFrameDisposable=null,this._performSmoothScrolling())})}hasPendingScrollAnimation(){return!!this._smoothScrolling}_performSmoothScrolling(){if(!this._smoothScrolling)return;const S=this._smoothScrolling.tick(),o=this._state.withScrollPosition(S);if(this._setState(o,!0),!!this._smoothScrolling){if(S.isDone){this._smoothScrolling.dispose(),this._smoothScrolling=null;return}this._smoothScrolling.animationFrameDisposable=this._scheduleAtNextAnimationFrame(()=>{this._smoothScrolling&&(this._smoothScrolling.animationFrameDisposable=null,this._performSmoothScrolling())})}}_setState(S,o){const m=this._state;m.equals(S)||(this._state=S,this._onScroll.fire(this._state.createScrollEvent(m,o)))}}e.Scrollable=L;class R{constructor(S,o,m){this.scrollLeft=S,this.scrollTop=o,this.isDone=m}}e.SmoothScrollingUpdate=R;function v(T,S){const o=S-T;return function(m){return T+o*f(m)}}function l(T,S,o){return function(m){return m<o?T(m/o):S((m-o)/(1-o))}}class C{constructor(S,o,m,p){this.from=S,this.to=o,this.duration=p,this.startTime=m,this.animationFrameDisposable=null,this._initAnimations()}_initAnimations(){this.scrollLeft=this._initAnimation(this.from.scrollLeft,this.to.scrollLeft,this.to.width),this.scrollTop=this._initAnimation(this.from.scrollTop,this.to.scrollTop,this.to.height)}_initAnimation(S,o,m){if(Math.abs(S-o)>2.5*m){let u,i;return S<o?(u=S+.75*m,i=o-.75*m):(u=S-.75*m,i=o+.75*m),l(v(S,u),v(i,o),.33)}return v(S,o)}dispose(){this.animationFrameDisposable!==null&&(this.animationFrameDisposable.dispose(),this.animationFrameDisposable=null)}acceptScrollDimensions(S){this.to=S.withScrollPosition(this.to),this._initAnimations()}tick(){return this._tick(Date.now())}_tick(S){const o=(S-this.startTime)/this.duration;if(o<1){const m=this.scrollLeft(o),p=this.scrollTop(o);return new R(m,p,!1)}return new R(this.to.scrollLeft,this.to.scrollTop,!0)}combine(S,o,m){return C.start(S,o,m)}static start(S,o,m){m=m+10;const p=Date.now()-10;return new C(S,o,p,m)}}e.SmoothScrollingOperation=C;function _(T){return Math.pow(T,3)}function f(T){return 1-_(1-T)}}),define(Pe[103],ke([1,0,12,3]),function(ge,e,s,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isReadable=D,e.isReadableStream=A,e.isReadableBufferedStream=L,e.newWriteableStream=R,e.consumeReadable=l,e.peekReadable=C,e.consumeStream=_,e.listenStream=f,e.peekStream=T,e.toStream=S,e.emptyStream=o,e.toReadable=m,e.transform=p,e.prefixedReadable=u,e.prefixedStream=i;function D(a){const t=a;return t?typeof t.read=="function":!1}function A(a){const t=a;return t?[t.on,t.pause,t.resume,t.destroy].every(n=>typeof n=="function"):!1}function L(a){const t=a;return t?A(t.stream)&&Array.isArray(t.buffer)&&typeof t.ended=="boolean":!1}function R(a,t){return new v(a,t)}class v{constructor(t,n){this.reducer=t,this.options=n,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(t){if(!this.state.destroyed){if(this.state.flowing)this.emitData(t);else if(this.buffer.data.push(t),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(n=>this.pendingWritePromises.push(n))}}error(t){this.state.destroyed||(this.state.flowing?this.emitError(t):this.buffer.error.push(t))}end(t){this.state.destroyed||(typeof t<"u"&&this.write(t),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(t){this.listeners.data.slice(0).forEach(n=>n(t))}emitError(t){this.listeners.error.length===0?(0,s.onUnexpectedError)(t):this.listeners.error.slice(0).forEach(n=>n(t))}emitEnd(){this.listeners.end.slice(0).forEach(t=>t())}on(t,n){if(!this.state.destroyed)switch(t){case"data":this.listeners.data.push(n),this.resume();break;case"end":this.listeners.end.push(n),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(n),this.state.flowing&&this.flowErrors();break}}removeListener(t,n){if(this.state.destroyed)return;let r;switch(t){case"data":r=this.listeners.data;break;case"end":r=this.listeners.end;break;case"error":r=this.listeners.error;break}if(r){const d=r.indexOf(n);d>=0&&r.splice(d,1)}}flowData(){if(this.buffer.data.length>0){const t=this.reducer(this.buffer.data);this.emitData(t),this.buffer.data.length=0;const n=[...this.pendingWritePromises];this.pendingWritePromises.length=0,n.forEach(r=>r())}}flowErrors(){if(this.listeners.error.length>0){for(const t of this.buffer.error)this.emitError(t);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function l(a,t){const n=[];let r;for(;(r=a.read())!==null;)n.push(r);return t(n)}function C(a,t,n){const r=[];let d;for(;(d=a.read())!==null&&r.length<n;)r.push(d);return d===null&&r.length>0?t(r):{read:()=>{if(r.length>0)return r.shift();if(typeof d<"u"){const c=d;return d=void 0,c}return a.read()}}}function _(a,t){return new Promise((n,r)=>{const d=[];f(a,{onData:c=>{t&&d.push(c)},onError:c=>{t?r(c):n(void 0)},onEnd:()=>{n(t?t(d):void 0)}})})}function f(a,t,n){a.on("error",r=>{n?.isCancellationRequested||t.onError(r)}),a.on("end",()=>{n?.isCancellationRequested||t.onEnd()}),a.on("data",r=>{n?.isCancellationRequested||t.onData(r)})}function T(a,t){return new Promise((n,r)=>{const d=new h.DisposableStore,c=[],g=I=>{if(c.push(I),c.length>t)return d.dispose(),a.pause(),n({stream:a,buffer:c,ended:!1})},w=I=>(d.dispose(),r(I)),y=()=>(d.dispose(),n({stream:a,buffer:c,ended:!0}));d.add((0,h.toDisposable)(()=>a.removeListener("error",w))),a.on("error",w),d.add((0,h.toDisposable)(()=>a.removeListener("end",y))),a.on("end",y),d.add((0,h.toDisposable)(()=>a.removeListener("data",g))),a.on("data",g)})}function S(a,t){const n=R(t);return n.end(a),n}function o(){const a=R(()=>{throw new Error("not supported")});return a.end(),a}function m(a){let t=!1;return{read:()=>t?null:(t=!0,a)}}function p(a,t,n){const r=R(n);return f(a,{onData:d=>r.write(t.data(d)),onError:d=>r.error(t.error?t.error(d):d),onEnd:()=>r.end()}),r}function u(a,t,n){let r=!1;return{read:()=>{const d=t.read();return r?d:(r=!0,d!==null?n([a,d]):a)}}}function i(a,t,n){let r=!1;const d=R(n);return f(t,{onData:c=>r?d.write(c):(r=!0,d.write(n([a,c]))),onError:c=>d.error(c),onEnd:()=>{r||(r=!0,d.write(a)),d.end()}}),d}}),define(Pe[21],ke([1,0,50,103]),function(ge,e,s,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.VSBuffer=void 0,e.binaryIndexOf=l,e.readUInt16LE=C,e.writeUInt16LE=_,e.readUInt32BE=f,e.writeUInt32BE=T,e.readUInt32LE=S,e.writeUInt32LE=o,e.readUInt8=m,e.writeUInt8=p,e.readableToBuffer=u,e.bufferToReadable=i,e.streamToBuffer=a,e.bufferedStreamToBuffer=t,e.bufferToStream=n,e.streamToBufferReadableStream=r,e.newWriteableBufferStream=d,e.prefixedBufferReadable=c,e.prefixedBufferStream=g,e.decodeBase64=w,e.encodeBase64=P,h=We(h);const D=typeof Buffer<"u",A=new s.Lazy(()=>new Uint8Array(256));let L,R;class v{static alloc(b){return D?new v(Buffer.allocUnsafe(b)):new v(new Uint8Array(b))}static wrap(b){return D&&!Buffer.isBuffer(b)&&(b=Buffer.from(b.buffer,b.byteOffset,b.byteLength)),new v(b)}static fromString(b,E){return!(E?.dontUseNodeBuffer||!1)&&D?new v(Buffer.from(b)):(L||(L=new TextEncoder),new v(L.encode(b)))}static fromByteArray(b){const E=v.alloc(b.length);for(let N=0,O=b.length;N<O;N++)E.buffer[N]=b[N];return E}static concat(b,E){if(typeof E>"u"){E=0;for(let M=0,U=b.length;M<U;M++)E+=b[M].byteLength}const N=v.alloc(E);let O=0;for(let M=0,U=b.length;M<U;M++){const H=b[M];N.set(H,O),O+=H.byteLength}return N}constructor(b){this.buffer=b,this.byteLength=this.buffer.byteLength}clone(){const b=v.alloc(this.byteLength);return b.set(this),b}toString(){return D?this.buffer.toString():(R||(R=new TextDecoder),R.decode(this.buffer))}slice(b,E){return new v(this.buffer.subarray(b,E))}set(b,E){if(b instanceof v)this.buffer.set(b.buffer,E);else if(b instanceof Uint8Array)this.buffer.set(b,E);else if(b instanceof ArrayBuffer)this.buffer.set(new Uint8Array(b),E);else if(ArrayBuffer.isView(b))this.buffer.set(new Uint8Array(b.buffer,b.byteOffset,b.byteLength),E);else throw new Error("Unknown argument 'array'")}readUInt32BE(b){return f(this.buffer,b)}writeUInt32BE(b,E){T(this.buffer,b,E)}readUInt32LE(b){return S(this.buffer,b)}writeUInt32LE(b,E){o(this.buffer,b,E)}readUInt8(b){return m(this.buffer,b)}writeUInt8(b,E){p(this.buffer,b,E)}indexOf(b,E=0){return l(this.buffer,b instanceof v?b.buffer:b,E)}}e.VSBuffer=v;function l(k,b,E=0){const N=b.byteLength,O=k.byteLength;if(N===0)return 0;if(N===1)return k.indexOf(b[0]);if(N>O-E)return-1;const M=A.value;M.fill(b.length);for(let x=0;x<b.length;x++)M[b[x]]=b.length-x-1;let U=E+b.length-1,H=U,F=-1;for(;U<O;)if(k[U]===b[H]){if(H===0){F=U;break}U--,H--}else U+=Math.max(b.length-H,M[k[U]]),H=b.length-1;return F}function C(k,b){return k[b+0]<<0>>>0|k[b+1]<<8>>>0}function _(k,b,E){k[E+0]=b&255,b=b>>>8,k[E+1]=b&255}function f(k,b){return k[b]*2**24+k[b+1]*2**16+k[b+2]*2**8+k[b+3]}function T(k,b,E){k[E+3]=b,b=b>>>8,k[E+2]=b,b=b>>>8,k[E+1]=b,b=b>>>8,k[E]=b}function S(k,b){return k[b+0]<<0>>>0|k[b+1]<<8>>>0|k[b+2]<<16>>>0|k[b+3]<<24>>>0}function o(k,b,E){k[E+0]=b&255,b=b>>>8,k[E+1]=b&255,b=b>>>8,k[E+2]=b&255,b=b>>>8,k[E+3]=b&255}function m(k,b){return k[b]}function p(k,b,E){k[E]=b}function u(k){return h.consumeReadable(k,b=>v.concat(b))}function i(k){return h.toReadable(k)}function a(k){return h.consumeStream(k,b=>v.concat(b))}async function t(k){return k.ended?v.concat(k.buffer):v.concat([...k.buffer,await a(k.stream)])}function n(k){return h.toStream(k,b=>v.concat(b))}function r(k){return h.transform(k,{data:b=>typeof b=="string"?v.fromString(b):v.wrap(b)},b=>v.concat(b))}function d(k){return h.newWriteableStream(b=>v.concat(b),k)}function c(k,b){return h.prefixedReadable(k,b,E=>v.concat(E))}function g(k,b){return h.prefixedStream(k,b,E=>v.concat(E))}function w(k){let b=0,E=0,N=0;const O=new Uint8Array(Math.floor(k.length/4*3)),M=H=>{switch(E){case 3:O[N++]=b|H,E=0;break;case 2:O[N++]=b|H>>>2,b=H<<6,E=3;break;case 1:O[N++]=b|H>>>4,b=H<<4,E=2;break;default:b=H<<2,E=1}};for(let H=0;H<k.length;H++){const F=k.charCodeAt(H);if(F>=65&&F<=90)M(F-65);else if(F>=97&&F<=122)M(F-97+26);else if(F>=48&&F<=57)M(F-48+52);else if(F===43||F===45)M(62);else if(F===47||F===95)M(63);else{if(F===61)break;throw new SyntaxError(`Unexpected base64 character ${k[H]}`)}}const U=N;for(;E>0;)M(0);return v.wrap(O).slice(0,U)}const y="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",I="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function P({buffer:k},b=!0,E=!1){const N=E?I:y;let O="";const M=k.byteLength%3;let U=0;for(;U<k.byteLength-M;U+=3){const H=k[U+0],F=k[U+1],x=k[U+2];O+=N[H>>>2],O+=N[(H<<4|F>>>4)&63],O+=N[(F<<2|x>>>6)&63],O+=N[x&63]}if(M===1){const H=k[U+0];O+=N[H>>>2],O+=N[H<<4&63],b&&(O+="==")}else if(M===2){const H=k[U+0],F=k[U+1];O+=N[H>>>2],O+=N[(H<<4|F>>>4)&63],O+=N[F<<2&63],b&&(O+="=")}return O}}),define(Pe[190],ke([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MicrotaskDelay=void 0,e.MicrotaskDelay=Symbol("MicrotaskDelay")}),define(Pe[17],ke([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isString=s,e.isStringArray=h,e.isObject=D,e.isTypedArray=A,e.isNumber=L,e.isIterable=R,e.isBoolean=v,e.isUndefined=l,e.isDefined=C,e.isUndefinedOrNull=_,e.assertType=f,e.assertIsDefined=T,e.assertAllDefined=S,e.isEmptyObject=m,e.isFunction=p,e.areFunctions=u,e.validateConstraints=i,e.validateConstraint=a,e.upcast=t;function s(n){return typeof n=="string"}function h(n){return Array.isArray(n)&&n.every(r=>s(r))}function D(n){return typeof n=="object"&&n!==null&&!Array.isArray(n)&&!(n instanceof RegExp)&&!(n instanceof Date)}function A(n){const r=Object.getPrototypeOf(Uint8Array);return typeof n=="object"&&n instanceof r}function L(n){return typeof n=="number"&&!isNaN(n)}function R(n){return!!n&&typeof n[Symbol.iterator]=="function"}function v(n){return n===!0||n===!1}function l(n){return typeof n>"u"}function C(n){return!_(n)}function _(n){return l(n)||n===null}function f(n,r){if(!n)throw new Error(r?`Unexpected type, expected '${r}'`:"Unexpected type")}function T(n){if(_(n))throw new Error("Assertion Failed: argument is undefined or null");return n}function S(...n){const r=[];for(let d=0;d<n.length;d++){const c=n[d];if(_(c))throw new Error(`Assertion Failed: argument at index ${d} is undefined or null`);r.push(c)}return r}const o=Object.prototype.hasOwnProperty;function m(n){if(!D(n))return!1;for(const r in n)if(o.call(n,r))return!1;return!0}function p(n){return typeof n=="function"}function u(...n){return n.length>0&&n.every(p)}function i(n,r){const d=Math.min(n.length,r.length);for(let c=0;c<d;c++)a(n[c],r[c])}function a(n,r){if(s(r)){if(typeof n!==r)throw new Error(`argument does not match constraint: typeof ${r}`)}else if(p(r)){try{if(n instanceof r)return}catch{}if(!_(n)&&n.constructor===r||r.length===1&&r.call(void 0,n)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}function t(n){return n}}),define(Pe[104],ke([1,0,17]),function(ge,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.register=D,e.getCodiconFontCharacters=A;const h=Object.create(null);function D(L,R){if((0,s.isString)(R)){const v=h[R];if(v===void 0)throw new Error(`${L} references an unknown codicon: ${R}`);R=v}return h[L]=R,{id:L}}function A(){return h}}),define(Pe[191],ke([1,0,104]),function(ge,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.codiconsLibrary=void 0,e.codiconsLibrary={add:(0,s.register)("add",6e4),plus:(0,s.register)("plus",6e4),gistNew:(0,s.register)("gist-new",6e4),repoCreate:(0,s.register)("repo-create",6e4),lightbulb:(0,s.register)("lightbulb",60001),lightBulb:(0,s.register)("light-bulb",60001),repo:(0,s.register)("repo",60002),repoDelete:(0,s.register)("repo-delete",60002),gistFork:(0,s.register)("gist-fork",60003),repoForked:(0,s.register)("repo-forked",60003),gitPullRequest:(0,s.register)("git-pull-request",60004),gitPullRequestAbandoned:(0,s.register)("git-pull-request-abandoned",60004),recordKeys:(0,s.register)("record-keys",60005),keyboard:(0,s.register)("keyboard",60005),tag:(0,s.register)("tag",60006),gitPullRequestLabel:(0,s.register)("git-pull-request-label",60006),tagAdd:(0,s.register)("tag-add",60006),tagRemove:(0,s.register)("tag-remove",60006),person:(0,s.register)("person",60007),personFollow:(0,s.register)("person-follow",60007),personOutline:(0,s.register)("person-outline",60007),personFilled:(0,s.register)("person-filled",60007),gitBranch:(0,s.register)("git-branch",60008),gitBranchCreate:(0,s.register)("git-branch-create",60008),gitBranchDelete:(0,s.register)("git-branch-delete",60008),sourceControl:(0,s.register)("source-control",60008),mirror:(0,s.register)("mirror",60009),mirrorPublic:(0,s.register)("mirror-public",60009),star:(0,s.register)("star",60010),starAdd:(0,s.register)("star-add",60010),starDelete:(0,s.register)("star-delete",60010),starEmpty:(0,s.register)("star-empty",60010),comment:(0,s.register)("comment",60011),commentAdd:(0,s.register)("comment-add",60011),alert:(0,s.register)("alert",60012),warning:(0,s.register)("warning",60012),search:(0,s.register)("search",60013),searchSave:(0,s.register)("search-save",60013),logOut:(0,s.register)("log-out",60014),signOut:(0,s.register)("sign-out",60014),logIn:(0,s.register)("log-in",60015),signIn:(0,s.register)("sign-in",60015),eye:(0,s.register)("eye",60016),eyeUnwatch:(0,s.register)("eye-unwatch",60016),eyeWatch:(0,s.register)("eye-watch",60016),circleFilled:(0,s.register)("circle-filled",60017),primitiveDot:(0,s.register)("primitive-dot",60017),closeDirty:(0,s.register)("close-dirty",60017),debugBreakpoint:(0,s.register)("debug-breakpoint",60017),debugBreakpointDisabled:(0,s.register)("debug-breakpoint-disabled",60017),debugHint:(0,s.register)("debug-hint",60017),terminalDecorationSuccess:(0,s.register)("terminal-decoration-success",60017),primitiveSquare:(0,s.register)("primitive-square",60018),edit:(0,s.register)("edit",60019),pencil:(0,s.register)("pencil",60019),info:(0,s.register)("info",60020),issueOpened:(0,s.register)("issue-opened",60020),gistPrivate:(0,s.register)("gist-private",60021),gitForkPrivate:(0,s.register)("git-fork-private",60021),lock:(0,s.register)("lock",60021),mirrorPrivate:(0,s.register)("mirror-private",60021),close:(0,s.register)("close",60022),removeClose:(0,s.register)("remove-close",60022),x:(0,s.register)("x",60022),repoSync:(0,s.register)("repo-sync",60023),sync:(0,s.register)("sync",60023),clone:(0,s.register)("clone",60024),desktopDownload:(0,s.register)("desktop-download",60024),beaker:(0,s.register)("beaker",60025),microscope:(0,s.register)("microscope",60025),vm:(0,s.register)("vm",60026),deviceDesktop:(0,s.register)("device-desktop",60026),file:(0,s.register)("file",60027),fileText:(0,s.register)("file-text",60027),more:(0,s.register)("more",60028),ellipsis:(0,s.register)("ellipsis",60028),kebabHorizontal:(0,s.register)("kebab-horizontal",60028),mailReply:(0,s.register)("mail-reply",60029),reply:(0,s.register)("reply",60029),organization:(0,s.register)("organization",60030),organizationFilled:(0,s.register)("organization-filled",60030),organizationOutline:(0,s.register)("organization-outline",60030),newFile:(0,s.register)("new-file",60031),fileAdd:(0,s.register)("file-add",60031),newFolder:(0,s.register)("new-folder",60032),fileDirectoryCreate:(0,s.register)("file-directory-create",60032),trash:(0,s.register)("trash",60033),trashcan:(0,s.register)("trashcan",60033),history:(0,s.register)("history",60034),clock:(0,s.register)("clock",60034),folder:(0,s.register)("folder",60035),fileDirectory:(0,s.register)("file-directory",60035),symbolFolder:(0,s.register)("symbol-folder",60035),logoGithub:(0,s.register)("logo-github",60036),markGithub:(0,s.register)("mark-github",60036),github:(0,s.register)("github",60036),terminal:(0,s.register)("terminal",60037),console:(0,s.register)("console",60037),repl:(0,s.register)("repl",60037),zap:(0,s.register)("zap",60038),symbolEvent:(0,s.register)("symbol-event",60038),error:(0,s.register)("error",60039),stop:(0,s.register)("stop",60039),variable:(0,s.register)("variable",60040),symbolVariable:(0,s.register)("symbol-variable",60040),array:(0,s.register)("array",60042),symbolArray:(0,s.register)("symbol-array",60042),symbolModule:(0,s.register)("symbol-module",60043),symbolPackage:(0,s.register)("symbol-package",60043),symbolNamespace:(0,s.register)("symbol-namespace",60043),symbolObject:(0,s.register)("symbol-object",60043),symbolMethod:(0,s.register)("symbol-method",60044),symbolFunction:(0,s.register)("symbol-function",60044),symbolConstructor:(0,s.register)("symbol-constructor",60044),symbolBoolean:(0,s.register)("symbol-boolean",60047),symbolNull:(0,s.register)("symbol-null",60047),symbolNumeric:(0,s.register)("symbol-numeric",60048),symbolNumber:(0,s.register)("symbol-number",60048),symbolStructure:(0,s.register)("symbol-structure",60049),symbolStruct:(0,s.register)("symbol-struct",60049),symbolParameter:(0,s.register)("symbol-parameter",60050),symbolTypeParameter:(0,s.register)("symbol-type-parameter",60050),symbolKey:(0,s.register)("symbol-key",60051),symbolText:(0,s.register)("symbol-text",60051),symbolReference:(0,s.register)("symbol-reference",60052),goToFile:(0,s.register)("go-to-file",60052),symbolEnum:(0,s.register)("symbol-enum",60053),symbolValue:(0,s.register)("symbol-value",60053),symbolRuler:(0,s.register)("symbol-ruler",60054),symbolUnit:(0,s.register)("symbol-unit",60054),activateBreakpoints:(0,s.register)("activate-breakpoints",60055),archive:(0,s.register)("archive",60056),arrowBoth:(0,s.register)("arrow-both",60057),arrowDown:(0,s.register)("arrow-down",60058),arrowLeft:(0,s.register)("arrow-left",60059),arrowRight:(0,s.register)("arrow-right",60060),arrowSmallDown:(0,s.register)("arrow-small-down",60061),arrowSmallLeft:(0,s.register)("arrow-small-left",60062),arrowSmallRight:(0,s.register)("arrow-small-right",60063),arrowSmallUp:(0,s.register)("arrow-small-up",60064),arrowUp:(0,s.register)("arrow-up",60065),bell:(0,s.register)("bell",60066),bold:(0,s.register)("bold",60067),book:(0,s.register)("book",60068),bookmark:(0,s.register)("bookmark",60069),debugBreakpointConditionalUnverified:(0,s.register)("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:(0,s.register)("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:(0,s.register)("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:(0,s.register)("debug-breakpoint-data-unverified",60072),debugBreakpointData:(0,s.register)("debug-breakpoint-data",60073),debugBreakpointDataDisabled:(0,s.register)("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:(0,s.register)("debug-breakpoint-log-unverified",60074),debugBreakpointLog:(0,s.register)("debug-breakpoint-log",60075),debugBreakpointLogDisabled:(0,s.register)("debug-breakpoint-log-disabled",60075),briefcase:(0,s.register)("briefcase",60076),broadcast:(0,s.register)("broadcast",60077),browser:(0,s.register)("browser",60078),bug:(0,s.register)("bug",60079),calendar:(0,s.register)("calendar",60080),caseSensitive:(0,s.register)("case-sensitive",60081),check:(0,s.register)("check",60082),checklist:(0,s.register)("checklist",60083),chevronDown:(0,s.register)("chevron-down",60084),chevronLeft:(0,s.register)("chevron-left",60085),chevronRight:(0,s.register)("chevron-right",60086),chevronUp:(0,s.register)("chevron-up",60087),chromeClose:(0,s.register)("chrome-close",60088),chromeMaximize:(0,s.register)("chrome-maximize",60089),chromeMinimize:(0,s.register)("chrome-minimize",60090),chromeRestore:(0,s.register)("chrome-restore",60091),circleOutline:(0,s.register)("circle-outline",60092),circle:(0,s.register)("circle",60092),debugBreakpointUnverified:(0,s.register)("debug-breakpoint-unverified",60092),terminalDecorationIncomplete:(0,s.register)("terminal-decoration-incomplete",60092),circleSlash:(0,s.register)("circle-slash",60093),circuitBoard:(0,s.register)("circuit-board",60094),clearAll:(0,s.register)("clear-all",60095),clippy:(0,s.register)("clippy",60096),closeAll:(0,s.register)("close-all",60097),cloudDownload:(0,s.register)("cloud-download",60098),cloudUpload:(0,s.register)("cloud-upload",60099),code:(0,s.register)("code",60100),collapseAll:(0,s.register)("collapse-all",60101),colorMode:(0,s.register)("color-mode",60102),commentDiscussion:(0,s.register)("comment-discussion",60103),creditCard:(0,s.register)("credit-card",60105),dash:(0,s.register)("dash",60108),dashboard:(0,s.register)("dashboard",60109),database:(0,s.register)("database",60110),debugContinue:(0,s.register)("debug-continue",60111),debugDisconnect:(0,s.register)("debug-disconnect",60112),debugPause:(0,s.register)("debug-pause",60113),debugRestart:(0,s.register)("debug-restart",60114),debugStart:(0,s.register)("debug-start",60115),debugStepInto:(0,s.register)("debug-step-into",60116),debugStepOut:(0,s.register)("debug-step-out",60117),debugStepOver:(0,s.register)("debug-step-over",60118),debugStop:(0,s.register)("debug-stop",60119),debug:(0,s.register)("debug",60120),deviceCameraVideo:(0,s.register)("device-camera-video",60121),deviceCamera:(0,s.register)("device-camera",60122),deviceMobile:(0,s.register)("device-mobile",60123),diffAdded:(0,s.register)("diff-added",60124),diffIgnored:(0,s.register)("diff-ignored",60125),diffModified:(0,s.register)("diff-modified",60126),diffRemoved:(0,s.register)("diff-removed",60127),diffRenamed:(0,s.register)("diff-renamed",60128),diff:(0,s.register)("diff",60129),diffSidebyside:(0,s.register)("diff-sidebyside",60129),discard:(0,s.register)("discard",60130),editorLayout:(0,s.register)("editor-layout",60131),emptyWindow:(0,s.register)("empty-window",60132),exclude:(0,s.register)("exclude",60133),extensions:(0,s.register)("extensions",60134),eyeClosed:(0,s.register)("eye-closed",60135),fileBinary:(0,s.register)("file-binary",60136),fileCode:(0,s.register)("file-code",60137),fileMedia:(0,s.register)("file-media",60138),filePdf:(0,s.register)("file-pdf",60139),fileSubmodule:(0,s.register)("file-submodule",60140),fileSymlinkDirectory:(0,s.register)("file-symlink-directory",60141),fileSymlinkFile:(0,s.register)("file-symlink-file",60142),fileZip:(0,s.register)("file-zip",60143),files:(0,s.register)("files",60144),filter:(0,s.register)("filter",60145),flame:(0,s.register)("flame",60146),foldDown:(0,s.register)("fold-down",60147),foldUp:(0,s.register)("fold-up",60148),fold:(0,s.register)("fold",60149),folderActive:(0,s.register)("folder-active",60150),folderOpened:(0,s.register)("folder-opened",60151),gear:(0,s.register)("gear",60152),gift:(0,s.register)("gift",60153),gistSecret:(0,s.register)("gist-secret",60154),gist:(0,s.register)("gist",60155),gitCommit:(0,s.register)("git-commit",60156),gitCompare:(0,s.register)("git-compare",60157),compareChanges:(0,s.register)("compare-changes",60157),gitMerge:(0,s.register)("git-merge",60158),githubAction:(0,s.register)("github-action",60159),githubAlt:(0,s.register)("github-alt",60160),globe:(0,s.register)("globe",60161),grabber:(0,s.register)("grabber",60162),graph:(0,s.register)("graph",60163),gripper:(0,s.register)("gripper",60164),heart:(0,s.register)("heart",60165),home:(0,s.register)("home",60166),horizontalRule:(0,s.register)("horizontal-rule",60167),hubot:(0,s.register)("hubot",60168),inbox:(0,s.register)("inbox",60169),issueReopened:(0,s.register)("issue-reopened",60171),issues:(0,s.register)("issues",60172),italic:(0,s.register)("italic",60173),jersey:(0,s.register)("jersey",60174),json:(0,s.register)("json",60175),kebabVertical:(0,s.register)("kebab-vertical",60176),key:(0,s.register)("key",60177),law:(0,s.register)("law",60178),lightbulbAutofix:(0,s.register)("lightbulb-autofix",60179),linkExternal:(0,s.register)("link-external",60180),link:(0,s.register)("link",60181),listOrdered:(0,s.register)("list-ordered",60182),listUnordered:(0,s.register)("list-unordered",60183),liveShare:(0,s.register)("live-share",60184),loading:(0,s.register)("loading",60185),location:(0,s.register)("location",60186),mailRead:(0,s.register)("mail-read",60187),mail:(0,s.register)("mail",60188),markdown:(0,s.register)("markdown",60189),megaphone:(0,s.register)("megaphone",60190),mention:(0,s.register)("mention",60191),milestone:(0,s.register)("milestone",60192),gitPullRequestMilestone:(0,s.register)("git-pull-request-milestone",60192),mortarBoard:(0,s.register)("mortar-board",60193),move:(0,s.register)("move",60194),multipleWindows:(0,s.register)("multiple-windows",60195),mute:(0,s.register)("mute",60196),noNewline:(0,s.register)("no-newline",60197),note:(0,s.register)("note",60198),octoface:(0,s.register)("octoface",60199),openPreview:(0,s.register)("open-preview",60200),package:(0,s.register)("package",60201),paintcan:(0,s.register)("paintcan",60202),pin:(0,s.register)("pin",60203),play:(0,s.register)("play",60204),run:(0,s.register)("run",60204),plug:(0,s.register)("plug",60205),preserveCase:(0,s.register)("preserve-case",60206),preview:(0,s.register)("preview",60207),project:(0,s.register)("project",60208),pulse:(0,s.register)("pulse",60209),question:(0,s.register)("question",60210),quote:(0,s.register)("quote",60211),radioTower:(0,s.register)("radio-tower",60212),reactions:(0,s.register)("reactions",60213),references:(0,s.register)("references",60214),refresh:(0,s.register)("refresh",60215),regex:(0,s.register)("regex",60216),remoteExplorer:(0,s.register)("remote-explorer",60217),remote:(0,s.register)("remote",60218),remove:(0,s.register)("remove",60219),replaceAll:(0,s.register)("replace-all",60220),replace:(0,s.register)("replace",60221),repoClone:(0,s.register)("repo-clone",60222),repoForcePush:(0,s.register)("repo-force-push",60223),repoPull:(0,s.register)("repo-pull",60224),repoPush:(0,s.register)("repo-push",60225),report:(0,s.register)("report",60226),requestChanges:(0,s.register)("request-changes",60227),rocket:(0,s.register)("rocket",60228),rootFolderOpened:(0,s.register)("root-folder-opened",60229),rootFolder:(0,s.register)("root-folder",60230),rss:(0,s.register)("rss",60231),ruby:(0,s.register)("ruby",60232),saveAll:(0,s.register)("save-all",60233),saveAs:(0,s.register)("save-as",60234),save:(0,s.register)("save",60235),screenFull:(0,s.register)("screen-full",60236),screenNormal:(0,s.register)("screen-normal",60237),searchStop:(0,s.register)("search-stop",60238),server:(0,s.register)("server",60240),settingsGear:(0,s.register)("settings-gear",60241),settings:(0,s.register)("settings",60242),shield:(0,s.register)("shield",60243),smiley:(0,s.register)("smiley",60244),sortPrecedence:(0,s.register)("sort-precedence",60245),splitHorizontal:(0,s.register)("split-horizontal",60246),splitVertical:(0,s.register)("split-vertical",60247),squirrel:(0,s.register)("squirrel",60248),starFull:(0,s.register)("star-full",60249),starHalf:(0,s.register)("star-half",60250),symbolClass:(0,s.register)("symbol-class",60251),symbolColor:(0,s.register)("symbol-color",60252),symbolConstant:(0,s.register)("symbol-constant",60253),symbolEnumMember:(0,s.register)("symbol-enum-member",60254),symbolField:(0,s.register)("symbol-field",60255),symbolFile:(0,s.register)("symbol-file",60256),symbolInterface:(0,s.register)("symbol-interface",60257),symbolKeyword:(0,s.register)("symbol-keyword",60258),symbolMisc:(0,s.register)("symbol-misc",60259),symbolOperator:(0,s.register)("symbol-operator",60260),symbolProperty:(0,s.register)("symbol-property",60261),wrench:(0,s.register)("wrench",60261),wrenchSubaction:(0,s.register)("wrench-subaction",60261),symbolSnippet:(0,s.register)("symbol-snippet",60262),tasklist:(0,s.register)("tasklist",60263),telescope:(0,s.register)("telescope",60264),textSize:(0,s.register)("text-size",60265),threeBars:(0,s.register)("three-bars",60266),thumbsdown:(0,s.register)("thumbsdown",60267),thumbsup:(0,s.register)("thumbsup",60268),tools:(0,s.register)("tools",60269),triangleDown:(0,s.register)("triangle-down",60270),triangleLeft:(0,s.register)("triangle-left",60271),triangleRight:(0,s.register)("triangle-right",60272),triangleUp:(0,s.register)("triangle-up",60273),twitter:(0,s.register)("twitter",60274),unfold:(0,s.register)("unfold",60275),unlock:(0,s.register)("unlock",60276),unmute:(0,s.register)("unmute",60277),unverified:(0,s.register)("unverified",60278),verified:(0,s.register)("verified",60279),versions:(0,s.register)("versions",60280),vmActive:(0,s.register)("vm-active",60281),vmOutline:(0,s.register)("vm-outline",60282),vmRunning:(0,s.register)("vm-running",60283),watch:(0,s.register)("watch",60284),whitespace:(0,s.register)("whitespace",60285),wholeWord:(0,s.register)("whole-word",60286),window:(0,s.register)("window",60287),wordWrap:(0,s.register)("word-wrap",60288),zoomIn:(0,s.register)("zoom-in",60289),zoomOut:(0,s.register)("zoom-out",60290),listFilter:(0,s.register)("list-filter",60291),listFlat:(0,s.register)("list-flat",60292),listSelection:(0,s.register)("list-selection",60293),selection:(0,s.register)("selection",60293),listTree:(0,s.register)("list-tree",60294),debugBreakpointFunctionUnverified:(0,s.register)("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:(0,s.register)("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:(0,s.register)("debug-breakpoint-function-disabled",60296),debugStackframeActive:(0,s.register)("debug-stackframe-active",60297),circleSmallFilled:(0,s.register)("circle-small-filled",60298),debugStackframeDot:(0,s.register)("debug-stackframe-dot",60298),terminalDecorationMark:(0,s.register)("terminal-decoration-mark",60298),debugStackframe:(0,s.register)("debug-stackframe",60299),debugStackframeFocused:(0,s.register)("debug-stackframe-focused",60299),debugBreakpointUnsupported:(0,s.register)("debug-breakpoint-unsupported",60300),symbolString:(0,s.register)("symbol-string",60301),debugReverseContinue:(0,s.register)("debug-reverse-continue",60302),debugStepBack:(0,s.register)("debug-step-back",60303),debugRestartFrame:(0,s.register)("debug-restart-frame",60304),debugAlt:(0,s.register)("debug-alt",60305),callIncoming:(0,s.register)("call-incoming",60306),callOutgoing:(0,s.register)("call-outgoing",60307),menu:(0,s.register)("menu",60308),expandAll:(0,s.register)("expand-all",60309),feedback:(0,s.register)("feedback",60310),gitPullRequestReviewer:(0,s.register)("git-pull-request-reviewer",60310),groupByRefType:(0,s.register)("group-by-ref-type",60311),ungroupByRefType:(0,s.register)("ungroup-by-ref-type",60312),account:(0,s.register)("account",60313),gitPullRequestAssignee:(0,s.register)("git-pull-request-assignee",60313),bellDot:(0,s.register)("bell-dot",60314),debugConsole:(0,s.register)("debug-console",60315),library:(0,s.register)("library",60316),output:(0,s.register)("output",60317),runAll:(0,s.register)("run-all",60318),syncIgnored:(0,s.register)("sync-ignored",60319),pinned:(0,s.register)("pinned",60320),githubInverted:(0,s.register)("github-inverted",60321),serverProcess:(0,s.register)("server-process",60322),serverEnvironment:(0,s.register)("server-environment",60323),pass:(0,s.register)("pass",60324),issueClosed:(0,s.register)("issue-closed",60324),stopCircle:(0,s.register)("stop-circle",60325),playCircle:(0,s.register)("play-circle",60326),record:(0,s.register)("record",60327),debugAltSmall:(0,s.register)("debug-alt-small",60328),vmConnect:(0,s.register)("vm-connect",60329),cloud:(0,s.register)("cloud",60330),merge:(0,s.register)("merge",60331),export:(0,s.register)("export",60332),graphLeft:(0,s.register)("graph-left",60333),magnet:(0,s.register)("magnet",60334),notebook:(0,s.register)("notebook",60335),redo:(0,s.register)("redo",60336),checkAll:(0,s.register)("check-all",60337),pinnedDirty:(0,s.register)("pinned-dirty",60338),passFilled:(0,s.register)("pass-filled",60339),circleLargeFilled:(0,s.register)("circle-large-filled",60340),circleLarge:(0,s.register)("circle-large",60341),circleLargeOutline:(0,s.register)("circle-large-outline",60341),combine:(0,s.register)("combine",60342),gather:(0,s.register)("gather",60342),table:(0,s.register)("table",60343),variableGroup:(0,s.register)("variable-group",60344),typeHierarchy:(0,s.register)("type-hierarchy",60345),typeHierarchySub:(0,s.register)("type-hierarchy-sub",60346),typeHierarchySuper:(0,s.register)("type-hierarchy-super",60347),gitPullRequestCreate:(0,s.register)("git-pull-request-create",60348),runAbove:(0,s.register)("run-above",60349),runBelow:(0,s.register)("run-below",60350),notebookTemplate:(0,s.register)("notebook-template",60351),debugRerun:(0,s.register)("debug-rerun",60352),workspaceTrusted:(0,s.register)("workspace-trusted",60353),workspaceUntrusted:(0,s.register)("workspace-untrusted",60354),workspaceUnknown:(0,s.register)("workspace-unknown",60355),terminalCmd:(0,s.register)("terminal-cmd",60356),terminalDebian:(0,s.register)("terminal-debian",60357),terminalLinux:(0,s.register)("terminal-linux",60358),terminalPowershell:(0,s.register)("terminal-powershell",60359),terminalTmux:(0,s.register)("terminal-tmux",60360),terminalUbuntu:(0,s.register)("terminal-ubuntu",60361),terminalBash:(0,s.register)("terminal-bash",60362),arrowSwap:(0,s.register)("arrow-swap",60363),copy:(0,s.register)("copy",60364),personAdd:(0,s.register)("person-add",60365),filterFilled:(0,s.register)("filter-filled",60366),wand:(0,s.register)("wand",60367),debugLineByLine:(0,s.register)("debug-line-by-line",60368),inspect:(0,s.register)("inspect",60369),layers:(0,s.register)("layers",60370),layersDot:(0,s.register)("layers-dot",60371),layersActive:(0,s.register)("layers-active",60372),compass:(0,s.register)("compass",60373),compassDot:(0,s.register)("compass-dot",60374),compassActive:(0,s.register)("compass-active",60375),azure:(0,s.register)("azure",60376),issueDraft:(0,s.register)("issue-draft",60377),gitPullRequestClosed:(0,s.register)("git-pull-request-closed",60378),gitPullRequestDraft:(0,s.register)("git-pull-request-draft",60379),debugAll:(0,s.register)("debug-all",60380),debugCoverage:(0,s.register)("debug-coverage",60381),runErrors:(0,s.register)("run-errors",60382),folderLibrary:(0,s.register)("folder-library",60383),debugContinueSmall:(0,s.register)("debug-continue-small",60384),beakerStop:(0,s.register)("beaker-stop",60385),graphLine:(0,s.register)("graph-line",60386),graphScatter:(0,s.register)("graph-scatter",60387),pieChart:(0,s.register)("pie-chart",60388),bracket:(0,s.register)("bracket",60175),bracketDot:(0,s.register)("bracket-dot",60389),bracketError:(0,s.register)("bracket-error",60390),lockSmall:(0,s.register)("lock-small",60391),azureDevops:(0,s.register)("azure-devops",60392),verifiedFilled:(0,s.register)("verified-filled",60393),newline:(0,s.register)("newline",60394),layout:(0,s.register)("layout",60395),layoutActivitybarLeft:(0,s.register)("layout-activitybar-left",60396),layoutActivitybarRight:(0,s.register)("layout-activitybar-right",60397),layoutPanelLeft:(0,s.register)("layout-panel-left",60398),layoutPanelCenter:(0,s.register)("layout-panel-center",60399),layoutPanelJustify:(0,s.register)("layout-panel-justify",60400),layoutPanelRight:(0,s.register)("layout-panel-right",60401),layoutPanel:(0,s.register)("layout-panel",60402),layoutSidebarLeft:(0,s.register)("layout-sidebar-left",60403),layoutSidebarRight:(0,s.register)("layout-sidebar-right",60404),layoutStatusbar:(0,s.register)("layout-statusbar",60405),layoutMenubar:(0,s.register)("layout-menubar",60406),layoutCentered:(0,s.register)("layout-centered",60407),target:(0,s.register)("target",60408),indent:(0,s.register)("indent",60409),recordSmall:(0,s.register)("record-small",60410),errorSmall:(0,s.register)("error-small",60411),terminalDecorationError:(0,s.register)("terminal-decoration-error",60411),arrowCircleDown:(0,s.register)("arrow-circle-down",60412),arrowCircleLeft:(0,s.register)("arrow-circle-left",60413),arrowCircleRight:(0,s.register)("arrow-circle-right",60414),arrowCircleUp:(0,s.register)("arrow-circle-up",60415),layoutSidebarRightOff:(0,s.register)("layout-sidebar-right-off",60416),layoutPanelOff:(0,s.register)("layout-panel-off",60417),layoutSidebarLeftOff:(0,s.register)("layout-sidebar-left-off",60418),blank:(0,s.register)("blank",60419),heartFilled:(0,s.register)("heart-filled",60420),map:(0,s.register)("map",60421),mapHorizontal:(0,s.register)("map-horizontal",60421),foldHorizontal:(0,s.register)("fold-horizontal",60421),mapFilled:(0,s.register)("map-filled",60422),mapHorizontalFilled:(0,s.register)("map-horizontal-filled",60422),foldHorizontalFilled:(0,s.register)("fold-horizontal-filled",60422),circleSmall:(0,s.register)("circle-small",60423),bellSlash:(0,s.register)("bell-slash",60424),bellSlashDot:(0,s.register)("bell-slash-dot",60425),commentUnresolved:(0,s.register)("comment-unresolved",60426),gitPullRequestGoToChanges:(0,s.register)("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:(0,s.register)("git-pull-request-new-changes",60428),searchFuzzy:(0,s.register)("search-fuzzy",60429),commentDraft:(0,s.register)("comment-draft",60430),send:(0,s.register)("send",60431),sparkle:(0,s.register)("sparkle",60432),insert:(0,s.register)("insert",60433),mic:(0,s.register)("mic",60434),thumbsdownFilled:(0,s.register)("thumbsdown-filled",60435),thumbsupFilled:(0,s.register)("thumbsup-filled",60436),coffee:(0,s.register)("coffee",60437),snake:(0,s.register)("snake",60438),game:(0,s.register)("game",60439),vr:(0,s.register)("vr",60440),chip:(0,s.register)("chip",60441),piano:(0,s.register)("piano",60442),music:(0,s.register)("music",60443),micFilled:(0,s.register)("mic-filled",60444),repoFetch:(0,s.register)("repo-fetch",60445),copilot:(0,s.register)("copilot",60446),lightbulbSparkle:(0,s.register)("lightbulb-sparkle",60447),robot:(0,s.register)("robot",60448),sparkleFilled:(0,s.register)("sparkle-filled",60449),diffSingle:(0,s.register)("diff-single",60450),diffMultiple:(0,s.register)("diff-multiple",60451),surroundWith:(0,s.register)("surround-with",60452),share:(0,s.register)("share",60453),gitStash:(0,s.register)("git-stash",60454),gitStashApply:(0,s.register)("git-stash-apply",60455),gitStashPop:(0,s.register)("git-stash-pop",60456),vscode:(0,s.register)("vscode",60457),vscodeInsiders:(0,s.register)("vscode-insiders",60458),codeOss:(0,s.register)("code-oss",60459),runCoverage:(0,s.register)("run-coverage",60460),runAllCoverage:(0,s.register)("run-all-coverage",60461),coverage:(0,s.register)("coverage",60462),githubProject:(0,s.register)("github-project",60463),mapVertical:(0,s.register)("map-vertical",60464),foldVertical:(0,s.register)("fold-vertical",60464),mapVerticalFilled:(0,s.register)("map-vertical-filled",60465),foldVerticalFilled:(0,s.register)("fold-vertical-filled",60465),goToSearch:(0,s.register)("go-to-search",60466),percentage:(0,s.register)("percentage",60467),sortPercentage:(0,s.register)("sort-percentage",60467),attach:(0,s.register)("attach",60468)}}),define(Pe[84],ke([1,0,104,191]),function(ge,e,s,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Codicon=e.codiconsDerived=void 0,e.getAllCodicons=D;function D(){return Object.values(e.Codicon)}e.codiconsDerived={dialogError:(0,s.register)("dialog-error","error"),dialogWarning:(0,s.register)("dialog-warning","warning"),dialogInfo:(0,s.register)("dialog-info","info"),dialogClose:(0,s.register)("dialog-close","close"),treeItemExpanded:(0,s.register)("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:(0,s.register)("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:(0,s.register)("tree-filter-on-type-off","list-selection"),treeFilterClear:(0,s.register)("tree-filter-clear","close"),treeItemLoading:(0,s.register)("tree-item-loading","loading"),menuSelection:(0,s.register)("menu-selection","check"),menuSubmenu:(0,s.register)("menu-submenu","chevron-right"),menuBarMore:(0,s.register)("menubar-more","more"),scrollbarButtonLeft:(0,s.register)("scrollbar-button-left","triangle-left"),scrollbarButtonRight:(0,s.register)("scrollbar-button-right","triangle-right"),scrollbarButtonUp:(0,s.register)("scrollbar-button-up","triangle-up"),scrollbarButtonDown:(0,s.register)("scrollbar-button-down","triangle-down"),toolBarMore:(0,s.register)("toolbar-more","more"),quickInputBack:(0,s.register)("quick-input-back","arrow-left"),dropDownButton:(0,s.register)("drop-down-button",60084),symbolCustomColor:(0,s.register)("symbol-customcolor",60252),exportIcon:(0,s.register)("export",60332),workspaceUnspecified:(0,s.register)("workspace-unspecified",60355),newLine:(0,s.register)("newline",60394),thumbsDownFilled:(0,s.register)("thumbsdown-filled",60435),thumbsUpFilled:(0,s.register)("thumbsup-filled",60436),gitFetch:(0,s.register)("git-fetch",60445),lightbulbSparkleAutofix:(0,s.register)("lightbulb-sparkle-autofix",60447),debugBreakpointPending:(0,s.register)("debug-breakpoint-pending",60377)},e.Codicon={...h.codiconsLibrary,...e.codiconsDerived}}),define(Pe[24],ke([1,0,17]),function(ge,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deepClone=h,e.deepFreeze=D,e.cloneAndChange=L,e.mixin=v,e.equals=l,e.safeStringify=C,e.distinct=_,e.getCaseInsensitive=f,e.filter=T,e.getAllPropertyNames=S,e.getAllMethodNames=o,e.createProxyObject=m,e.mapValues=p;function h(u){if(!u||typeof u!="object"||u instanceof RegExp)return u;const i=Array.isArray(u)?[]:{};return Object.entries(u).forEach(([a,t])=>{i[a]=t&&typeof t=="object"?h(t):t}),i}function D(u){if(!u||typeof u!="object")return u;const i=[u];for(;i.length>0;){const a=i.shift();Object.freeze(a);for(const t in a)if(A.call(a,t)){const n=a[t];typeof n=="object"&&!Object.isFrozen(n)&&!(0,s.isTypedArray)(n)&&i.push(n)}}return u}const A=Object.prototype.hasOwnProperty;function L(u,i){return R(u,i,new Set)}function R(u,i,a){if((0,s.isUndefinedOrNull)(u))return u;const t=i(u);if(typeof t<"u")return t;if(Array.isArray(u)){const n=[];for(const r of u)n.push(R(r,i,a));return n}if((0,s.isObject)(u)){if(a.has(u))throw new Error("Cannot clone recursive data-structure");a.add(u);const n={};for(const r in u)A.call(u,r)&&(n[r]=R(u[r],i,a));return a.delete(u),n}return u}function v(u,i,a=!0){return(0,s.isObject)(u)?((0,s.isObject)(i)&&Object.keys(i).forEach(t=>{t in u?a&&((0,s.isObject)(u[t])&&(0,s.isObject)(i[t])?v(u[t],i[t],a):u[t]=i[t]):u[t]=i[t]}),u):i}function l(u,i){if(u===i)return!0;if(u==null||i===null||i===void 0||typeof u!=typeof i||typeof u!="object"||Array.isArray(u)!==Array.isArray(i))return!1;let a,t;if(Array.isArray(u)){if(u.length!==i.length)return!1;for(a=0;a<u.length;a++)if(!l(u[a],i[a]))return!1}else{const n=[];for(t in u)n.push(t);n.sort();const r=[];for(t in i)r.push(t);if(r.sort(),!l(n,r))return!1;for(a=0;a<n.length;a++)if(!l(u[n[a]],i[n[a]]))return!1}return!0}function C(u){const i=new Set;return JSON.stringify(u,(a,t)=>{if((0,s.isObject)(t)||Array.isArray(t)){if(i.has(t))return"[Circular]";i.add(t)}return typeof t=="bigint"?`[BigInt ${t.toString()}]`:t})}function _(u,i){const a=Object.create(null);return!u||!i||Object.keys(i).forEach(n=>{const r=u[n],d=i[n];l(r,d)||(a[n]=d)}),a}function f(u,i){const a=i.toLowerCase(),t=Object.keys(u).find(n=>n.toLowerCase()===a);return t?u[t]:u[i]}function T(u,i){const a=Object.create(null);for(const[t,n]of Object.entries(u))i(t,n)&&(a[t]=n);return a}function S(u){let i=[];for(;Object.prototype!==u;)i=i.concat(Object.getOwnPropertyNames(u)),u=Object.getPrototypeOf(u);return i}function o(u){const i=[];for(const a of S(u))typeof u[a]=="function"&&i.push(a);return i}function m(u,i){const a=n=>function(){const r=Array.prototype.slice.call(arguments,0);return i(n,r)},t={};for(const n of u)t[n]=a(n);return t}function p(u,i){const a={};for(const[t,n]of Object.entries(u))a[t]=i(n,t);return a}}),define(Pe[51],ke([1,0,84]),function(ge,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.ThemeColor=void 0,e.themeColorFromId=D;var h;(function(L){function R(v){return v&&typeof v=="object"&&typeof v.id=="string"}L.isThemeColor=R})(h||(e.ThemeColor=h={}));function D(L){return{id:L}}var A;(function(L){L.iconNameSegment="[A-Za-z0-9]+",L.iconNameExpression="[A-Za-z0-9-]+",L.iconModifierExpression="~[A-Za-z]+",L.iconNameCharacter="[A-Za-z0-9~-]";const R=new RegExp(`^(${L.iconNameExpression})(${L.iconModifierExpression})?$`);function v(u){const i=R.exec(u.id);if(!i)return v(s.Codicon.error);const[,a,t]=i,n=["codicon","codicon-"+a];return t&&n.push("codicon-modifier-"+t.substring(1)),n}L.asClassNameArray=v;function l(u){return v(u).join(" ")}L.asClassName=l;function C(u){return"."+v(u).join(".")}L.asCSSSelector=C;function _(u){return u&&typeof u=="object"&&typeof u.id=="string"&&(typeof u.color>"u"||h.isThemeColor(u.color))}L.isThemeIcon=_;const f=new RegExp(`^\\$\\((${L.iconNameExpression}(?:${L.iconModifierExpression})?)\\)$`);function T(u){const i=f.exec(u);if(!i)return;const[,a]=i;return{id:a}}L.fromString=T;function S(u){return{id:u}}L.fromId=S;function o(u,i){let a=u.id;const t=a.lastIndexOf("~");return t!==-1&&(a=a.substring(0,t)),i&&(a=`${a}~${i}`),{id:a}}L.modify=o;function m(u){const i=u.id.lastIndexOf("~");if(i!==-1)return u.id.substring(i+1)}L.getModifier=m;function p(u,i){return u.id===i.id&&u.color?.id===i.color?.id}L.isEqual=p})(A||(e.ThemeIcon=A={}))}),define(Pe[85],ke([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Constants=void 0,e.toUint8=h,e.toUint32=D;var s;(function(A){A[A.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",A[A.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",A[A.MAX_UINT_8=255]="MAX_UINT_8",A[A.MAX_UINT_16=65535]="MAX_UINT_16",A[A.MAX_UINT_32=4294967295]="MAX_UINT_32",A[A.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(s||(e.Constants=s={}));function h(A){return A<0?0:A>s.MAX_UINT_8?s.MAX_UINT_8:A|0}function D(A){return A<0?0:A>s.MAX_UINT_32?s.MAX_UINT_32:A|0}}),define(Pe[13],ke([1,0,188,26,50,85]),function(ge,e,s,h,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.GraphemeBreakType=e.UTF8_BOM_CHARACTER=e.UNUSUAL_LINE_TERMINATORS=e.GraphemeIterator=e.CodePointIterator=void 0,e.isFalsyOrWhitespace=L,e.format=v,e.format2=C,e.htmlAttributeEncodeValue=_,e.escape=f,e.escapeRegExpCharacters=T,e.count=S,e.truncate=o,e.truncateMiddle=m,e.trim=p,e.ltrim=u,e.rtrim=i,e.convertSimple2RegExpPattern=a,e.stripWildcards=t,e.createRegExp=n,e.regExpLeadsToEndlessLoop=r,e.splitLines=d,e.splitLinesIncludeSeparators=c,e.firstNonWhitespaceIndex=g,e.getLeadingWhitespace=w,e.lastNonWhitespaceIndex=y,e.replaceAsync=I,e.compare=P,e.compareSubstring=k,e.compareIgnoreCase=b,e.compareSubstringIgnoreCase=E,e.isAsciiDigit=N,e.isLowerAsciiLetter=O,e.isUpperAsciiLetter=M,e.equalsIgnoreCase=U,e.startsWithIgnoreCase=H,e.commonPrefixLength=F,e.commonSuffixLength=x,e.isHighSurrogate=$,e.isLowSurrogate=G,e.computeCodePoint=B,e.getNextCodePoint=W,e.nextCharLength=te,e.prevCharLength=me,e.getCharContainingOffset=le,e.charCount=Q,e.containsRTL=Ee,e.isBasicASCII=be,e.containsUnusualLineTerminators=pe,e.isFullWidthCharacter=ve,e.isEmojiImprecise=Re,e.lcut=Fe,e.forAnsiStringParts=Ye,e.removeAnsiEscapeCodes=Je,e.removeAnsiEscapeCodesFromPrompt=ze,e.startsWithUTF8BOM=Ne,e.stripUTF8BOM=V,e.fuzzyContains=j,e.containsUppercaseCharacter=Y,e.uppercaseFirstLetter=ee,e.getNLines=ue,e.singleLetterHash=we,e.getGraphemeBreakType=Ae,e.getLeftDeleteOffset=dt;function L(re){return!re||typeof re!="string"?!0:re.trim().length===0}const R=/{(\d+)}/g;function v(re,...ce){return ce.length===0?re:re.replace(R,function(ye,he){const Ie=parseInt(he,10);return isNaN(Ie)||Ie<0||Ie>=ce.length?ye:ce[Ie]})}const l=/{([^}]+)}/g;function C(re,ce){return Object.keys(ce).length===0?re:re.replace(l,(ye,he)=>ce[he]??ye)}function _(re){return re.replace(/[<>"'&]/g,ce=>{switch(ce){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return ce})}function f(re){return re.replace(/[<>&]/g,function(ce){switch(ce){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ce}})}function T(re){return re.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function S(re,ce){let ye=0,he=re.indexOf(ce);for(;he!==-1;)ye++,he=re.indexOf(ce,he+ce.length);return ye}function o(re,ce,ye="\u2026"){return re.length<=ce?re:`${re.substr(0,ce)}${ye}`}function m(re,ce,ye="\u2026"){if(re.length<=ce)return re;const he=Math.ceil(ce/2)-ye.length/2,Ie=Math.floor(ce/2)-ye.length/2;return`${re.substr(0,he)}${ye}${re.substr(re.length-Ie)}`}function p(re,ce=" "){const ye=u(re,ce);return i(ye,ce)}function u(re,ce){if(!re||!ce)return re;const ye=ce.length;if(ye===0||re.length===0)return re;let he=0;for(;re.indexOf(ce,he)===he;)he=he+ye;return re.substring(he)}function i(re,ce){if(!re||!ce)return re;const ye=ce.length,he=re.length;if(ye===0||he===0)return re;let Ie=he,ne=-1;for(;ne=re.lastIndexOf(ce,Ie-1),!(ne===-1||ne+ye!==Ie);){if(ne===0)return"";Ie=ne}return re.substring(0,Ie)}function a(re){return re.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function t(re){return re.replace(/\*/g,"")}function n(re,ce,ye={}){if(!re)throw new Error("Cannot create regex from empty string");ce||(re=T(re)),ye.wholeWord&&(/\B/.test(re.charAt(0))||(re="\\b"+re),/\B/.test(re.charAt(re.length-1))||(re=re+"\\b"));let he="";return ye.global&&(he+="g"),ye.matchCase||(he+="i"),ye.multiline&&(he+="m"),ye.unicode&&(he+="u"),new RegExp(re,he)}function r(re){return re.source==="^"||re.source==="^$"||re.source==="$"||re.source==="^\\s*$"?!1:!!(re.exec("")&&re.lastIndex===0)}function d(re){return re.split(/\r\n|\r|\n/)}function c(re){const ce=[],ye=re.split(/(\r\n|\r|\n)/);for(let he=0;he<Math.ceil(ye.length/2);he++)ce.push(ye[2*he]+(ye[2*he+1]??""));return ce}function g(re){for(let ce=0,ye=re.length;ce<ye;ce++){const he=re.charCodeAt(ce);if(he!==h.CharCode.Space&&he!==h.CharCode.Tab)return ce}return-1}function w(re,ce=0,ye=re.length){for(let he=ce;he<ye;he++){const Ie=re.charCodeAt(he);if(Ie!==h.CharCode.Space&&Ie!==h.CharCode.Tab)return re.substring(ce,he)}return re.substring(ce,ye)}function y(re,ce=re.length-1){for(let ye=ce;ye>=0;ye--){const he=re.charCodeAt(ye);if(he!==h.CharCode.Space&&he!==h.CharCode.Tab)return ye}return-1}function I(re,ce,ye){const he=[];let Ie=0;for(const ne of re.matchAll(ce)){if(he.push(re.slice(Ie,ne.index)),ne.index===void 0)throw new Error("match.index should be defined");Ie=ne.index+ne[0].length,he.push(ye(ne[0],...ne.slice(1),ne.index,re,ne.groups))}return he.push(re.slice(Ie)),Promise.all(he).then(ne=>ne.join(""))}function P(re,ce){return re<ce?-1:re>ce?1:0}function k(re,ce,ye=0,he=re.length,Ie=0,ne=ce.length){for(;ye<he&&Ie<ne;ye++,Ie++){const qe=re.charCodeAt(ye),Xe=ce.charCodeAt(Ie);if(qe<Xe)return-1;if(qe>Xe)return 1}const X=he-ye,Te=ne-Ie;return X<Te?-1:X>Te?1:0}function b(re,ce){return E(re,ce,0,re.length,0,ce.length)}function E(re,ce,ye=0,he=re.length,Ie=0,ne=ce.length){for(;ye<he&&Ie<ne;ye++,Ie++){let qe=re.charCodeAt(ye),Xe=ce.charCodeAt(Ie);if(qe===Xe)continue;if(qe>=128||Xe>=128)return k(re.toLowerCase(),ce.toLowerCase(),ye,he,Ie,ne);O(qe)&&(qe-=32),O(Xe)&&(Xe-=32);const st=qe-Xe;if(st!==0)return st}const X=he-ye,Te=ne-Ie;return X<Te?-1:X>Te?1:0}function N(re){return re>=h.CharCode.Digit0&&re<=h.CharCode.Digit9}function O(re){return re>=h.CharCode.a&&re<=h.CharCode.z}function M(re){return re>=h.CharCode.A&&re<=h.CharCode.Z}function U(re,ce){return re.length===ce.length&&E(re,ce)===0}function H(re,ce){const ye=ce.length;return ce.length>re.length?!1:E(re,ce,0,ye)===0}function F(re,ce){const ye=Math.min(re.length,ce.length);let he;for(he=0;he<ye;he++)if(re.charCodeAt(he)!==ce.charCodeAt(he))return he;return ye}function x(re,ce){const ye=Math.min(re.length,ce.length);let he;const Ie=re.length-1,ne=ce.length-1;for(he=0;he<ye;he++)if(re.charCodeAt(Ie-he)!==ce.charCodeAt(ne-he))return he;return ye}function $(re){return 55296<=re&&re<=56319}function G(re){return 56320<=re&&re<=57343}function B(re,ce){return(re-55296<<10)+(ce-56320)+65536}function W(re,ce,ye){const he=re.charCodeAt(ye);if($(he)&&ye+1<ce){const Ie=re.charCodeAt(ye+1);if(G(Ie))return B(he,Ie)}return he}function Z(re,ce){const ye=re.charCodeAt(ce-1);if(G(ye)&&ce>1){const he=re.charCodeAt(ce-2);if($(he))return B(he,ye)}return ye}class J{get offset(){return this._offset}constructor(ce,ye=0){this._str=ce,this._len=ce.length,this._offset=ye}setOffset(ce){this._offset=ce}prevCodePoint(){const ce=Z(this._str,this._offset);return this._offset-=ce>=A.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,ce}nextCodePoint(){const ce=W(this._str,this._len,this._offset);return this._offset+=ce>=A.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,ce}eol(){return this._offset>=this._len}}e.CodePointIterator=J;class oe{get offset(){return this._iterator.offset}constructor(ce,ye=0){this._iterator=new J(ce,ye)}nextGraphemeLength(){const ce=nt.getInstance(),ye=this._iterator,he=ye.offset;let Ie=ce.getGraphemeBreakType(ye.nextCodePoint());for(;!ye.eol();){const ne=ye.offset,X=ce.getGraphemeBreakType(ye.nextCodePoint());if(He(Ie,X)){ye.setOffset(ne);break}Ie=X}return ye.offset-he}prevGraphemeLength(){const ce=nt.getInstance(),ye=this._iterator,he=ye.offset;let Ie=ce.getGraphemeBreakType(ye.prevCodePoint());for(;ye.offset>0;){const ne=ye.offset,X=ce.getGraphemeBreakType(ye.prevCodePoint());if(He(X,Ie)){ye.setOffset(ne);break}Ie=X}return he-ye.offset}eol(){return this._iterator.eol()}}e.GraphemeIterator=oe;function te(re,ce){return new oe(re,ce).nextGraphemeLength()}function me(re,ce){return new oe(re,ce).prevGraphemeLength()}function le(re,ce){ce>0&&G(re.charCodeAt(ce))&&ce--;const ye=ce+te(re,ce);return[ye-me(re,ye),ye]}function Q(re){const ce=new oe(re);let ye=0;for(;!ce.eol();)ye++,ce.nextGraphemeLength();return ye}let z;function se(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function Ee(re){return z||(z=se()),z.test(re)}const ae=/^[\t\n\r\x20-\x7E]*$/;function be(re){return ae.test(re)}e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function pe(re){return e.UNUSUAL_LINE_TERMINATORS.test(re)}function ve(re){return re>=11904&&re<=55215||re>=63744&&re<=64255||re>=65281&&re<=65374}function Re(re){return re>=127462&&re<=127487||re===8986||re===8987||re===9200||re===9203||re>=9728&&re<=10175||re===11088||re===11093||re>=127744&&re<=128591||re>=128640&&re<=128764||re>=128992&&re<=129008||re>=129280&&re<=129535||re>=129648&&re<=129782}function Fe(re,ce,ye=""){const he=re.trimStart();if(he.length<ce)return he;const Ie=/\b/g;let ne=0;for(;Ie.test(he)&&!(he.length-Ie.lastIndex<ce);)ne=Ie.lastIndex,Ie.lastIndex+=1;return ne===0?he:ye+he.substring(ne).trimStart()}const Ve=/(?:(?:\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~])|(:?\x1b\].*?\x07)/g;function*Ye(re){let ce=0;for(const ye of re.matchAll(Ve))ce!==ye.index&&(yield{isCode:!1,str:re.substring(ce,ye.index)}),yield{isCode:!0,str:ye[0]},ce=ye.index+ye[0].length;ce!==re.length&&(yield{isCode:!1,str:re.substring(ce)})}function Je(re){return re&&(re=re.replace(Ve,"")),re}const xe=/\\\[.*?\\\]/g;function ze(re){return Je(re).replace(xe,"")}e.UTF8_BOM_CHARACTER=String.fromCharCode(h.CharCode.UTF8_BOM);function Ne(re){return!!(re&&re.length>0&&re.charCodeAt(0)===h.CharCode.UTF8_BOM)}function V(re){return Ne(re)?re.substr(1):re}function j(re,ce){if(!re||!ce||re.length<ce.length)return!1;const ye=ce.length,he=re.toLowerCase();let Ie=0,ne=-1;for(;Ie<ye;){const X=he.indexOf(ce[Ie],ne+1);if(X<0)return!1;ne=X,Ie++}return!0}function Y(re,ce=!1){return re?(ce&&(re=re.replace(/\\./g,"")),re.toLowerCase()!==re):!1}function ee(re){return re.charAt(0).toUpperCase()+re.slice(1)}function ue(re,ce=1){if(ce===0)return"";let ye=-1;do ye=re.indexOf(`
`,ye+1),ce--;while(ce>0&&ye>=0);return ye===-1?re:(re[ye-1]==="\r"&&ye--,re.substr(0,ye))}function we(re){const ce=h.CharCode.Z-h.CharCode.A+1;return re=re%(2*ce),re<ce?String.fromCharCode(h.CharCode.a+re):String.fromCharCode(h.CharCode.A+re-ce)}function Ae(re){return nt.getInstance().getGraphemeBreakType(re)}function He(re,ce){return re===Ge.Other?ce!==Ge.Extend&&ce!==Ge.SpacingMark:re===Ge.CR&&ce===Ge.LF?!1:re===Ge.Control||re===Ge.CR||re===Ge.LF||ce===Ge.Control||ce===Ge.CR||ce===Ge.LF?!0:!(re===Ge.L&&(ce===Ge.L||ce===Ge.V||ce===Ge.LV||ce===Ge.LVT)||(re===Ge.LV||re===Ge.V)&&(ce===Ge.V||ce===Ge.T)||(re===Ge.LVT||re===Ge.T)&&ce===Ge.T||ce===Ge.Extend||ce===Ge.ZWJ||ce===Ge.SpacingMark||re===Ge.Prepend||re===Ge.ZWJ&&ce===Ge.Extended_Pictographic||re===Ge.Regional_Indicator&&ce===Ge.Regional_Indicator)}var Ge;(function(re){re[re.Other=0]="Other",re[re.Prepend=1]="Prepend",re[re.CR=2]="CR",re[re.LF=3]="LF",re[re.Control=4]="Control",re[re.Extend=5]="Extend",re[re.Regional_Indicator=6]="Regional_Indicator",re[re.SpacingMark=7]="SpacingMark",re[re.L=8]="L",re[re.V=9]="V",re[re.T=10]="T",re[re.LV=11]="LV",re[re.LVT=12]="LVT",re[re.ZWJ=13]="ZWJ",re[re.Extended_Pictographic=14]="Extended_Pictographic"})(Ge||(e.GraphemeBreakType=Ge={}));class nt{static{this._INSTANCE=null}static getInstance(){return nt._INSTANCE||(nt._INSTANCE=new nt),nt._INSTANCE}constructor(){this._data=ot()}getGraphemeBreakType(ce){if(ce<32)return ce===h.CharCode.LineFeed?Ge.LF:ce===h.CharCode.CarriageReturn?Ge.CR:Ge.Control;if(ce<127)return Ge.Other;const ye=this._data,he=ye.length/3;let Ie=1;for(;Ie<=he;)if(ce<ye[3*Ie])Ie=2*Ie;else if(ce>ye[3*Ie+1])Ie=2*Ie+1;else return ye[3*Ie+2];return Ge.Other}}function ot(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function dt(re,ce){if(re===0)return 0;const ye=at(re,ce);if(ye!==void 0)return ye;const he=new J(ce,re);return he.prevCodePoint(),he.offset}function at(re,ce){const ye=new J(ce,re);let he=ye.prevCodePoint();for(;ct(he)||he===vt.emojiVariantSelector||he===vt.enclosingKeyCap;){if(ye.offset===0)return;he=ye.prevCodePoint()}if(!Re(he))return;let Ie=ye.offset;return Ie>0&&ye.prevCodePoint()===vt.zwj&&(Ie=ye.offset),Ie}function ct(re){return 127995<=re&&re<=127999}var vt;(function(re){re[re.zwj=8205]="zwj",re[re.emojiVariantSelector=65039]="emojiVariantSelector",re[re.enclosingKeyCap=8419]="enclosingKeyCap"})(vt||(vt={})),e.noBreakWhitespace="\xA0";class it{static{this.ambiguousCharacterData=new D.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.cache=new s.LRUCachedFunction({getCacheKey:JSON.stringify},ce=>{function ye(st){const ht=new Map;for(let gt=0;gt<st.length;gt+=2)ht.set(st[gt],st[gt+1]);return ht}function he(st,ht){const gt=new Map(st);for(const[It,At]of ht)gt.set(It,At);return gt}function Ie(st,ht){if(!st)return ht;const gt=new Map;for(const[It,At]of st)ht.has(It)&&gt.set(It,At);return gt}const ne=this.ambiguousCharacterData.value;let X=ce.filter(st=>!st.startsWith("_")&&st in ne);X.length===0&&(X=["_default"]);let Te;for(const st of X){const ht=ye(ne[st]);Te=Ie(Te,ht)}const qe=ye(ne._common),Xe=he(qe,Te);return new it(Xe)})}static getInstance(ce){return it.cache.get(Array.from(ce))}static{this._locales=new D.Lazy(()=>Object.keys(it.ambiguousCharacterData.value).filter(ce=>!ce.startsWith("_")))}static getLocales(){return it._locales.value}constructor(ce){this.confusableDictionary=ce}isAmbiguous(ce){return this.confusableDictionary.has(ce)}containsAmbiguousCharacter(ce){for(let ye=0;ye<ce.length;ye++){const he=ce.codePointAt(ye);if(typeof he=="number"&&this.isAmbiguous(he))return!0}return!1}getPrimaryConfusable(ce){return this.confusableDictionary.get(ce)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}e.AmbiguousCharacters=it;class Ce{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this._data=void 0}static getData(){return this._data||(this._data=new Set(Ce.getRawData())),this._data}static isInvisibleCharacter(ce){return Ce.getData().has(ce)}static containsInvisibleCharacter(ce){for(let ye=0;ye<ce.length;ye++){const he=ce.codePointAt(ye);if(typeof he=="number"&&Ce.isInvisibleCharacter(he))return!0}return!1}static get codePoints(){return Ce.getData()}}e.InvisibleCharacters=Ce}),define(Pe[136],ke([1,0,26,28,183,13]),function(ge,e,s,h,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FuzzyScoreOptions=e.FuzzyScore=e.matchesPrefix=e.matchesStrictPrefix=void 0,e.or=L,e.matchesContiguousSubString=v,e.matchesSubString=l,e.isUpper=f,e.matchesCamelCase=y,e.matchesWords=I,e.matchesFuzzy=O,e.matchesFuzzy2=M,e.anyScore=U,e.createMatches=H,e.isPatternInWord=se,e.fuzzyScore=pe,e.fuzzyScoreGracefulAggressive=Fe,e.fuzzyScoreGraceful=Ve,A=We(A);function L(...xe){return function(ze,Ne){for(let V=0,j=xe.length;V<j;V++){const Y=xe[V](ze,Ne);if(Y)return Y}return null}}e.matchesStrictPrefix=R.bind(void 0,!1),e.matchesPrefix=R.bind(void 0,!0);function R(xe,ze,Ne){if(!Ne||Ne.length<ze.length)return null;let V;return xe?V=A.startsWithIgnoreCase(Ne,ze):V=Ne.indexOf(ze)===0,V?ze.length>0?[{start:0,end:ze.length}]:[]:null}function v(xe,ze){const Ne=ze.toLowerCase().indexOf(xe.toLowerCase());return Ne===-1?null:[{start:Ne,end:Ne+xe.length}]}function l(xe,ze){return C(xe.toLowerCase(),ze.toLowerCase(),0,0)}function C(xe,ze,Ne,V){if(Ne===xe.length)return[];if(V===ze.length)return null;if(xe[Ne]===ze[V]){let j=null;return(j=C(xe,ze,Ne+1,V+1))?t({start:V,end:V+1},j):null}return C(xe,ze,Ne,V+1)}function _(xe){return s.CharCode.a<=xe&&xe<=s.CharCode.z}function f(xe){return s.CharCode.A<=xe&&xe<=s.CharCode.Z}function T(xe){return s.CharCode.Digit0<=xe&&xe<=s.CharCode.Digit9}function S(xe){return xe===s.CharCode.Space||xe===s.CharCode.Tab||xe===s.CharCode.LineFeed||xe===s.CharCode.CarriageReturn}const o=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(xe=>o.add(xe.charCodeAt(0)));function m(xe){return S(xe)||o.has(xe)}function p(xe,ze){return xe===ze||m(xe)&&m(ze)}const u=new Map;function i(xe){if(u.has(xe))return u.get(xe);let ze;const Ne=(0,D.getKoreanAltChars)(xe);return Ne&&(ze=Ne),u.set(xe,ze),ze}function a(xe){return _(xe)||f(xe)||T(xe)}function t(xe,ze){return ze.length===0?ze=[xe]:xe.end===ze[0].start?ze[0].start=xe.start:ze.unshift(xe),ze}function n(xe,ze){for(let Ne=ze;Ne<xe.length;Ne++){const V=xe.charCodeAt(Ne);if(f(V)||T(V)||Ne>0&&!a(xe.charCodeAt(Ne-1)))return Ne}return xe.length}function r(xe,ze,Ne,V){if(Ne===xe.length)return[];if(V===ze.length)return null;if(xe[Ne]!==ze[V].toLowerCase())return null;{let j=null,Y=V+1;for(j=r(xe,ze,Ne+1,V+1);!j&&(Y=n(ze,Y))<ze.length;)j=r(xe,ze,Ne+1,Y),Y++;return j===null?null:t({start:V,end:V+1},j)}}function d(xe){let ze=0,Ne=0,V=0,j=0,Y=0;for(let He=0;He<xe.length;He++)Y=xe.charCodeAt(He),f(Y)&&ze++,_(Y)&&Ne++,a(Y)&&V++,T(Y)&&j++;const ee=ze/xe.length,ue=Ne/xe.length,we=V/xe.length,Ae=j/xe.length;return{upperPercent:ee,lowerPercent:ue,alphaPercent:we,numericPercent:Ae}}function c(xe){const{upperPercent:ze,lowerPercent:Ne}=xe;return Ne===0&&ze>.6}function g(xe){const{upperPercent:ze,lowerPercent:Ne,alphaPercent:V,numericPercent:j}=xe;return Ne>.2&&ze<.8&&V>.6&&j<.2}function w(xe){let ze=0,Ne=0,V=0,j=0;for(let Y=0;Y<xe.length;Y++)V=xe.charCodeAt(Y),f(V)&&ze++,_(V)&&Ne++,S(V)&&j++;return(ze===0||Ne===0)&&j===0?xe.length<=30:ze<=5}function y(xe,ze){if(!ze||(ze=ze.trim(),ze.length===0)||!w(xe))return null;ze.length>60&&(ze=ze.substring(0,60));const Ne=d(ze);if(!g(Ne)){if(!c(Ne))return null;ze=ze.toLowerCase()}let V=null,j=0;for(xe=xe.toLowerCase();j<ze.length&&(V=r(xe,ze,0,j))===null;)j=n(ze,j+1);return V}function I(xe,ze,Ne=!1){if(!ze||ze.length===0)return null;let V=null,j=0;for(xe=xe.toLowerCase(),ze=ze.toLowerCase();j<ze.length&&(V=P(xe,ze,0,j,Ne),V===null);)j=k(ze,j+1);return V}function P(xe,ze,Ne,V,j){let Y=0;if(Ne===xe.length)return[];if(V===ze.length)return null;if(!p(xe.charCodeAt(Ne),ze.charCodeAt(V))){const we=i(xe.charCodeAt(Ne));if(!we)return null;for(let Ae=0;Ae<we.length;Ae++)if(!p(we[Ae],ze.charCodeAt(V+Ae)))return null;Y+=we.length-1}let ee=null,ue=V+Y+1;if(ee=P(xe,ze,Ne+1,ue,j),!j)for(;!ee&&(ue=k(ze,ue))<ze.length;)ee=P(xe,ze,Ne+1,ue,j),ue++;if(!ee)return null;if(xe.charCodeAt(Ne)!==ze.charCodeAt(V)){const we=i(xe.charCodeAt(Ne));if(!we)return ee;for(let Ae=0;Ae<we.length;Ae++)if(we[Ae]!==ze.charCodeAt(V+Ae))return ee}return t({start:V,end:V+Y+1},ee)}function k(xe,ze){for(let Ne=ze;Ne<xe.length;Ne++)if(m(xe.charCodeAt(Ne))||Ne>0&&m(xe.charCodeAt(Ne-1)))return Ne;return xe.length}const b=L(e.matchesPrefix,y,v),E=L(e.matchesPrefix,y,l),N=new h.LRUCache(1e4);function O(xe,ze,Ne=!1){if(typeof xe!="string"||typeof ze!="string")return null;let V=N.get(xe);V||(V=new RegExp(A.convertSimple2RegExpPattern(xe),"i"),N.set(xe,V));const j=V.exec(ze);return j?[{start:j.index,end:j.index+j[0].length}]:Ne?E(xe,ze):b(xe,ze)}function M(xe,ze){const Ne=pe(xe,xe.toLowerCase(),0,ze,ze.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return Ne?H(Ne):null}function U(xe,ze,Ne,V,j,Y){const ee=Math.min(13,xe.length);for(;Ne<ee;Ne++){const ue=pe(xe,ze,Ne,V,j,Y,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(ue)return ue}return[0,Y]}function H(xe){if(typeof xe>"u")return[];const ze=[],Ne=xe[1];for(let V=xe.length-1;V>1;V--){const j=xe[V]+Ne,Y=ze[ze.length-1];Y&&Y.end===j?Y.end=j+1:ze.push({start:j,end:j+1})}return ze}const F=128;function x(){const xe=[],ze=[];for(let Ne=0;Ne<=F;Ne++)ze[Ne]=0;for(let Ne=0;Ne<=F;Ne++)xe.push(ze.slice(0));return xe}function $(xe){const ze=[];for(let Ne=0;Ne<=xe;Ne++)ze[Ne]=0;return ze}const G=$(2*F),B=$(2*F),W=x(),Z=x(),J=x(),oe=!1;function te(xe,ze,Ne,V,j){function Y(ue,we,Ae=" "){for(;ue.length<we;)ue=Ae+ue;return ue}let ee=` |   |${V.split("").map(ue=>Y(ue,3)).join("|")}
`;for(let ue=0;ue<=Ne;ue++)ue===0?ee+=" |":ee+=`${ze[ue-1]}|`,ee+=xe[ue].slice(0,j+1).map(we=>Y(we.toString(),3)).join("|")+`
`;return ee}function me(xe,ze,Ne,V){xe=xe.substr(ze),Ne=Ne.substr(V),console.log(te(Z,xe,xe.length,Ne,Ne.length)),console.log(te(J,xe,xe.length,Ne,Ne.length)),console.log(te(W,xe,xe.length,Ne,Ne.length))}function le(xe,ze){if(ze<0||ze>=xe.length)return!1;const Ne=xe.codePointAt(ze);switch(Ne){case s.CharCode.Underline:case s.CharCode.Dash:case s.CharCode.Period:case s.CharCode.Space:case s.CharCode.Slash:case s.CharCode.Backslash:case s.CharCode.SingleQuote:case s.CharCode.DoubleQuote:case s.CharCode.Colon:case s.CharCode.DollarSign:case s.CharCode.LessThan:case s.CharCode.GreaterThan:case s.CharCode.OpenParen:case s.CharCode.CloseParen:case s.CharCode.OpenSquareBracket:case s.CharCode.CloseSquareBracket:case s.CharCode.OpenCurlyBrace:case s.CharCode.CloseCurlyBrace:return!0;case void 0:return!1;default:return!!A.isEmojiImprecise(Ne)}}function Q(xe,ze){if(ze<0||ze>=xe.length)return!1;switch(xe.charCodeAt(ze)){case s.CharCode.Space:case s.CharCode.Tab:return!0;default:return!1}}function z(xe,ze,Ne){return ze[xe]!==Ne[xe]}function se(xe,ze,Ne,V,j,Y,ee=!1){for(;ze<Ne&&j<Y;)xe[ze]===V[j]&&(ee&&(G[ze]=j),ze+=1),j+=1;return ze===Ne}var Ee;(function(xe){xe[xe.Diag=1]="Diag",xe[xe.Left=2]="Left",xe[xe.LeftLeft=3]="LeftLeft"})(Ee||(Ee={}));var ae;(function(xe){xe.Default=[-100,0];function ze(Ne){return!Ne||Ne.length===2&&Ne[0]===-100&&Ne[1]===0}xe.isDefault=ze})(ae||(e.FuzzyScore=ae={}));class be{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(ze,Ne){this.firstMatchCanBeWeak=ze,this.boostFullMatch=Ne}}e.FuzzyScoreOptions=be;function pe(xe,ze,Ne,V,j,Y,ee=be.default){const ue=xe.length>F?F:xe.length,we=V.length>F?F:V.length;if(Ne>=ue||Y>=we||ue-Ne>we-Y||!se(ze,Ne,ue,j,Y,we,!0))return;ve(ue,we,Ne,Y,ze,j);let Ae=1,He=1,Ge=Ne,nt=Y;const ot=[!1];for(Ae=1,Ge=Ne;Ge<ue;Ae++,Ge++){const it=G[Ge],Ce=B[Ge],re=Ge+1<ue?B[Ge+1]:we;for(He=it-Y+1,nt=it;nt<re;He++,nt++){let ce=Number.MIN_SAFE_INTEGER,ye=!1;nt<=Ce&&(ce=Re(xe,ze,Ge,Ne,V,j,nt,we,Y,W[Ae-1][He-1]===0,ot));let he=0;ce!==Number.MAX_SAFE_INTEGER&&(ye=!0,he=ce+Z[Ae-1][He-1]);const Ie=nt>it,ne=Ie?Z[Ae][He-1]+(W[Ae][He-1]>0?-5:0):0,X=nt>it+1&&W[Ae][He-1]>0,Te=X?Z[Ae][He-2]+(W[Ae][He-2]>0?-5:0):0;if(X&&(!Ie||Te>=ne)&&(!ye||Te>=he))Z[Ae][He]=Te,J[Ae][He]=Ee.LeftLeft,W[Ae][He]=0;else if(Ie&&(!ye||ne>=he))Z[Ae][He]=ne,J[Ae][He]=Ee.Left,W[Ae][He]=0;else if(ye)Z[Ae][He]=he,J[Ae][He]=Ee.Diag,W[Ae][He]=W[Ae-1][He-1]+1;else throw new Error("not possible")}}if(oe&&me(xe,Ne,V,Y),!ot[0]&&!ee.firstMatchCanBeWeak)return;Ae--,He--;const dt=[Z[Ae][He],Y];let at=0,ct=0;for(;Ae>=1;){let it=He;do{const Ce=J[Ae][it];if(Ce===Ee.LeftLeft)it=it-2;else if(Ce===Ee.Left)it=it-1;else break}while(it>=1);at>1&&ze[Ne+Ae-1]===j[Y+He-1]&&!z(it+Y-1,V,j)&&at+1>W[Ae][it]&&(it=He),it===He?at++:at=1,ct||(ct=it),Ae--,He=it-1,dt.push(He)}we-Y===ue&&ee.boostFullMatch&&(dt[0]+=2);const vt=ct-ue;return dt[0]-=vt,dt}function ve(xe,ze,Ne,V,j,Y){let ee=xe-1,ue=ze-1;for(;ee>=Ne&&ue>=V;)j[ee]===Y[ue]&&(B[ee]=ue,ee--),ue--}function Re(xe,ze,Ne,V,j,Y,ee,ue,we,Ae,He){if(ze[Ne]!==Y[ee])return Number.MIN_SAFE_INTEGER;let Ge=1,nt=!1;return ee===Ne-V?Ge=xe[Ne]===j[ee]?7:5:z(ee,j,Y)&&(ee===0||!z(ee-1,j,Y))?(Ge=xe[Ne]===j[ee]?7:5,nt=!0):le(Y,ee)&&(ee===0||!le(Y,ee-1))?Ge=5:(le(Y,ee-1)||Q(Y,ee-1))&&(Ge=5,nt=!0),Ge>1&&Ne===V&&(He[0]=!0),nt||(nt=z(ee,j,Y)||le(Y,ee-1)||Q(Y,ee-1)),Ne===V?ee>we&&(Ge-=nt?3:5):Ae?Ge+=nt?2:0:Ge+=nt?0:1,ee+1===ue&&(Ge-=nt?3:5),Ge}function Fe(xe,ze,Ne,V,j,Y,ee){return Ye(xe,ze,Ne,V,j,Y,!0,ee)}function Ve(xe,ze,Ne,V,j,Y,ee){return Ye(xe,ze,Ne,V,j,Y,!1,ee)}function Ye(xe,ze,Ne,V,j,Y,ee,ue){let we=pe(xe,ze,Ne,V,j,Y,ue);if(we&&!ee)return we;if(xe.length>=3){const Ae=Math.min(7,xe.length-1);for(let He=Ne+1;He<Ae;He++){const Ge=Je(xe,He);if(Ge){const nt=pe(Ge,Ge.toLowerCase(),Ne,V,j,Y,ue);nt&&(nt[0]-=3,(!we||nt[0]>we[0])&&(we=nt))}}}return we}function Je(xe,ze){if(ze+1>=xe.length)return;const Ne=xe[ze],V=xe[ze+1];if(Ne!==V)return xe.slice(0,ze)+V+Ne+xe.slice(ze+2)}}),define(Pe[61],ke([1,0,13]),function(ge,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.Hasher=void 0,e.hash=h,e.doHash=D,e.numberHash=A,e.stringHash=R,e.toHexString=o,s=We(s);function h(p){return D(p,0)}function D(p,u){switch(typeof p){case"object":return p===null?A(349,u):Array.isArray(p)?v(p,u):l(p,u);case"string":return R(p,u);case"boolean":return L(p,u);case"number":return A(p,u);case"undefined":return A(937,u);default:return A(617,u)}}function A(p,u){return(u<<5)-u+p|0}function L(p,u){return A(p?433:863,u)}function R(p,u){u=A(149417,u);for(let i=0,a=p.length;i<a;i++)u=A(p.charCodeAt(i),u);return u}function v(p,u){return u=A(104579,u),p.reduce((i,a)=>D(a,i),u)}function l(p,u){return u=A(181387,u),Object.keys(p).sort().reduce((i,a)=>(i=R(a,i),D(p[a],i)),u)}class C{constructor(){this._value=0}get value(){return this._value}hash(u){return this._value=D(u,this._value),this._value}}e.Hasher=C;var _;(function(p){p[p.BLOCK_SIZE=64]="BLOCK_SIZE",p[p.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(_||(_={}));function f(p,u,i=32){const a=i-u,t=~((1<<a)-1);return(p<<u|(t&p)>>>a)>>>0}function T(p,u=0,i=p.byteLength,a=0){for(let t=0;t<i;t++)p[u+t]=a}function S(p,u,i="0"){for(;p.length<u;)p=i+p;return p}function o(p,u=32){return p instanceof ArrayBuffer?Array.from(new Uint8Array(p)).map(i=>i.toString(16).padStart(2,"0")).join(""):S((p>>>0).toString(16),u/4)}class m{static{this._bigBlock32=new DataView(new ArrayBuffer(320))}constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(_.BLOCK_SIZE+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(u){const i=u.length;if(i===0)return;const a=this._buff;let t=this._buffLen,n=this._leftoverHighSurrogate,r,d;for(n!==0?(r=n,d=-1,n=0):(r=u.charCodeAt(0),d=0);;){let c=r;if(s.isHighSurrogate(r))if(d+1<i){const g=u.charCodeAt(d+1);s.isLowSurrogate(g)?(d++,c=s.computeCodePoint(r,g)):c=_.UNICODE_REPLACEMENT}else{n=r;break}else s.isLowSurrogate(r)&&(c=_.UNICODE_REPLACEMENT);if(t=this._push(a,t,c),d++,d<i)r=u.charCodeAt(d);else break}this._buffLen=t,this._leftoverHighSurrogate=n}_push(u,i,a){return a<128?u[i++]=a:a<2048?(u[i++]=192|(a&1984)>>>6,u[i++]=128|(a&63)>>>0):a<65536?(u[i++]=224|(a&61440)>>>12,u[i++]=128|(a&4032)>>>6,u[i++]=128|(a&63)>>>0):(u[i++]=240|(a&1835008)>>>18,u[i++]=128|(a&258048)>>>12,u[i++]=128|(a&4032)>>>6,u[i++]=128|(a&63)>>>0),i>=_.BLOCK_SIZE&&(this._step(),i-=_.BLOCK_SIZE,this._totalLen+=_.BLOCK_SIZE,u[0]=u[_.BLOCK_SIZE+0],u[1]=u[_.BLOCK_SIZE+1],u[2]=u[_.BLOCK_SIZE+2]),i}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,_.UNICODE_REPLACEMENT)),this._totalLen+=this._buffLen,this._wrapUp()),o(this._h0)+o(this._h1)+o(this._h2)+o(this._h3)+o(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,T(this._buff,this._buffLen),this._buffLen>56&&(this._step(),T(this._buff));const u=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(u/4294967296),!1),this._buffDV.setUint32(60,u%4294967296,!1),this._step()}_step(){const u=m._bigBlock32,i=this._buffDV;for(let y=0;y<64;y+=4)u.setUint32(y,i.getUint32(y,!1),!1);for(let y=64;y<320;y+=4)u.setUint32(y,f(u.getUint32(y-12,!1)^u.getUint32(y-32,!1)^u.getUint32(y-56,!1)^u.getUint32(y-64,!1),1),!1);let a=this._h0,t=this._h1,n=this._h2,r=this._h3,d=this._h4,c,g,w;for(let y=0;y<80;y++)y<20?(c=t&n|~t&r,g=1518500249):y<40?(c=t^n^r,g=1859775393):y<60?(c=t&n|t&r|n&r,g=2400959708):(c=t^n^r,g=3395469782),w=f(a,5)+c+d+g+u.getUint32(y*4,!1)&4294967295,d=r,r=n,n=f(t,30),t=a,a=w;this._h0=this._h0+a&4294967295,this._h1=this._h1+t&4294967295,this._h2=this._h2+n&4294967295,this._h3=this._h3+r&4294967295,this._h4=this._h4+d&4294967295}}e.StringSHA1=m}),define(Pe[137],ke([1,0,136,13,51]),function(ge,e,s,h,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.escapeIcons=v,e.markdownEscapeEscapedIcons=C,e.stripIcons=f,e.getCodiconAriaLabel=T,e.parseLabelWithIcons=o,e.matchesFuzzyIconAware=m;const A="$(",L=new RegExp(`\\$\\(${D.ThemeIcon.iconNameExpression}(?:${D.ThemeIcon.iconModifierExpression})?\\)`,"g"),R=new RegExp(`(\\\\)?${L.source}`,"g");function v(p){return p.replace(R,(u,i)=>i?u:`\\${u}`)}const l=new RegExp(`\\\\${L.source}`,"g");function C(p){return p.replace(l,u=>`\\${u}`)}const _=new RegExp(`(\\s)?(\\\\)?${L.source}(\\s)?`,"g");function f(p){return p.indexOf(A)===-1?p:p.replace(_,(u,i,a,t)=>a?u:i||t||"")}function T(p){return p?p.replace(/\$\((.*?)\)/g,(u,i)=>` ${i} `).trim():""}const S=new RegExp(`\\$\\(${D.ThemeIcon.iconNameCharacter}+\\)`,"g");function o(p){S.lastIndex=0;let u="";const i=[];let a=0;for(;;){const t=S.lastIndex,n=S.exec(p),r=p.substring(t,n?.index);if(r.length>0){u+=r;for(let d=0;d<r.length;d++)i.push(a)}if(!n)break;a+=n[0].length}return{text:u,iconOffsets:i}}function m(p,u,i=!1){const{text:a,iconOffsets:t}=u;if(!t||t.length===0)return(0,s.matchesFuzzy)(p,a,i);const n=(0,h.ltrim)(a," "),r=a.length-n.length,d=(0,s.matchesFuzzy)(p,n,i);if(d)for(const c of d){const g=t[c.start+r]+r;c.start+=g,c.end+=g}return d}}),define(Pe[44],ke([1,0,13]),function(ge,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),s=We(s);var h;(function(D){D[D.Ignore=0]="Ignore",D[D.Info=1]="Info",D[D.Warning=2]="Warning",D[D.Error=3]="Error"})(h||(h={})),function(D){const A="error",L="warning",R="warn",v="info",l="ignore";function C(f){return f?s.equalsIgnoreCase(A,f)?D.Error:s.equalsIgnoreCase(L,f)||s.equalsIgnoreCase(R,f)?D.Warning:s.equalsIgnoreCase(v,f)?D.Info:D.Ignore:D.Ignore}D.fromValue=C;function _(f){switch(f){case D.Error:return A;case D.Warning:return L;case D.Info:return v;default:return l}}D.toString=_}(h||(h={})),e.default=h}),define(Pe[62],ke([1,0,18,26,13]),function(ge,e,s,h,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class A{constructor(){this._value="",this._pos=0}reset(S){return this._value=S,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(S){const o=S.charCodeAt(0),m=this._value.charCodeAt(this._pos);return o-m}value(){return this._value[this._pos]}}e.StringIterator=A;class L{constructor(S=!0){this._caseSensitive=S}reset(S){return this._value=S,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let S=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===h.CharCode.Period)if(S)this._from++;else break;else S=!1;return this}cmp(S){return this._caseSensitive?(0,D.compareSubstring)(S,this._value,0,S.length,this._from,this._to):(0,D.compareSubstringIgnoreCase)(S,this._value,0,S.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=L;class R{constructor(S=!0,o=!0){this._splitOnBackslash=S,this._caseSensitive=o}reset(S){this._from=0,this._to=0,this._value=S,this._valueLen=S.length;for(let o=S.length-1;o>=0;o--,this._valueLen--){const m=this._value.charCodeAt(o);if(!(m===h.CharCode.Slash||this._splitOnBackslash&&m===h.CharCode.Backslash))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let S=!0;for(;this._to<this._valueLen;this._to++){const o=this._value.charCodeAt(this._to);if(o===h.CharCode.Slash||this._splitOnBackslash&&o===h.CharCode.Backslash)if(S)this._from++;else break;else S=!1}return this}cmp(S){return this._caseSensitive?(0,D.compareSubstring)(S,this._value,0,S.length,this._from,this._to):(0,D.compareSubstringIgnoreCase)(S,this._value,0,S.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=R;var v;(function(T){T[T.Scheme=1]="Scheme",T[T.Authority=2]="Authority",T[T.Path=3]="Path",T[T.Query=4]="Query",T[T.Fragment=5]="Fragment"})(v||(v={}));class l{constructor(S,o){this._ignorePathCasing=S,this._ignoreQueryAndFragment=o,this._states=[],this._stateIdx=0}reset(S){return this._value=S,this._states=[],this._value.scheme&&this._states.push(v.Scheme),this._value.authority&&this._states.push(v.Authority),this._value.path&&(this._pathIterator=new R(!1,!this._ignorePathCasing(S)),this._pathIterator.reset(S.path),this._pathIterator.value()&&this._states.push(v.Path)),this._ignoreQueryAndFragment(S)||(this._value.query&&this._states.push(v.Query),this._value.fragment&&this._states.push(v.Fragment)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===v.Path&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===v.Path&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(S){if(this._states[this._stateIdx]===v.Scheme)return(0,D.compareIgnoreCase)(S,this._value.scheme);if(this._states[this._stateIdx]===v.Authority)return(0,D.compareIgnoreCase)(S,this._value.authority);if(this._states[this._stateIdx]===v.Path)return this._pathIterator.cmp(S);if(this._states[this._stateIdx]===v.Query)return(0,D.compare)(S,this._value.query);if(this._states[this._stateIdx]===v.Fragment)return(0,D.compare)(S,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===v.Scheme)return this._value.scheme;if(this._states[this._stateIdx]===v.Authority)return this._value.authority;if(this._states[this._stateIdx]===v.Path)return this._pathIterator.value();if(this._states[this._stateIdx]===v.Query)return this._value.query;if(this._states[this._stateIdx]===v.Fragment)return this._value.fragment;throw new Error}}e.UriIterator=l;class C{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const S=this.right;return this.right=S.left,S.left=this,this.updateHeight(),S.updateHeight(),S}rotateRight(){const S=this.left;return this.left=S.right,S.right=this,this.updateHeight(),S.updateHeight(),S}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var _;(function(T){T[T.Left=-1]="Left",T[T.Mid=0]="Mid",T[T.Right=1]="Right"})(_||(_={}));class f{static forUris(S=()=>!1,o=()=>!1){return new f(new l(S,o))}static forPaths(S=!1){return new f(new R(void 0,!S))}static forStrings(){return new f(new A)}static forConfigKeys(){return new f(new L)}constructor(S){this._iter=S}clear(){this._root=void 0}fill(S,o){if(o){const m=o.slice(0);(0,s.shuffle)(m);for(const p of m)this.set(p,S)}else{const m=S.slice(0);(0,s.shuffle)(m);for(const p of m)this.set(p[0],p[1])}}set(S,o){const m=this._iter.reset(S);let p;this._root||(this._root=new C,this._root.segment=m.value());const u=[];for(p=this._root;;){const a=m.cmp(p.segment);if(a>0)p.left||(p.left=new C,p.left.segment=m.value()),u.push([_.Left,p]),p=p.left;else if(a<0)p.right||(p.right=new C,p.right.segment=m.value()),u.push([_.Right,p]),p=p.right;else if(m.hasNext())m.next(),p.mid||(p.mid=new C,p.mid.segment=m.value()),u.push([_.Mid,p]),p=p.mid;else break}const i=p.value;p.value=o,p.key=S;for(let a=u.length-1;a>=0;a--){const t=u[a][1];t.updateHeight();const n=t.balanceFactor();if(n<-1||n>1){const r=u[a][0],d=u[a+1][0];if(r===_.Right&&d===_.Right)u[a][1]=t.rotateLeft();else if(r===_.Left&&d===_.Left)u[a][1]=t.rotateRight();else if(r===_.Right&&d===_.Left)t.right=u[a+1][1]=u[a+1][1].rotateRight(),u[a][1]=t.rotateLeft();else if(r===_.Left&&d===_.Right)t.left=u[a+1][1]=u[a+1][1].rotateLeft(),u[a][1]=t.rotateRight();else throw new Error;if(a>0)switch(u[a-1][0]){case _.Left:u[a-1][1].left=u[a][1];break;case _.Right:u[a-1][1].right=u[a][1];break;case _.Mid:u[a-1][1].mid=u[a][1];break}else this._root=u[0][1]}}return i}get(S){return this._getNode(S)?.value}_getNode(S){const o=this._iter.reset(S);let m=this._root;for(;m;){const p=o.cmp(m.segment);if(p>0)m=m.left;else if(p<0)m=m.right;else if(o.hasNext())o.next(),m=m.mid;else break}return m}has(S){const o=this._getNode(S);return!(o?.value===void 0&&o?.mid===void 0)}delete(S){return this._delete(S,!1)}deleteSuperstr(S){return this._delete(S,!0)}_delete(S,o){const m=this._iter.reset(S),p=[];let u=this._root;for(;u;){const i=m.cmp(u.segment);if(i>0)p.push([_.Left,u]),u=u.left;else if(i<0)p.push([_.Right,u]),u=u.right;else if(m.hasNext())m.next(),p.push([_.Mid,u]),u=u.mid;else break}if(u){if(o?(u.left=void 0,u.mid=void 0,u.right=void 0,u.height=1):(u.key=void 0,u.value=void 0),!u.mid&&!u.value)if(u.left&&u.right){const i=this._min(u.right);if(i.key){const{key:a,value:t,segment:n}=i;this._delete(i.key,!1),u.key=a,u.value=t,u.segment=n}}else{const i=u.left??u.right;if(p.length>0){const[a,t]=p[p.length-1];switch(a){case _.Left:t.left=i;break;case _.Mid:t.mid=i;break;case _.Right:t.right=i;break}}else this._root=i}for(let i=p.length-1;i>=0;i--){const a=p[i][1];a.updateHeight();const t=a.balanceFactor();if(t>1?(a.right.balanceFactor()>=0||(a.right=a.right.rotateRight()),p[i][1]=a.rotateLeft()):t<-1&&(a.left.balanceFactor()<=0||(a.left=a.left.rotateLeft()),p[i][1]=a.rotateRight()),i>0)switch(p[i-1][0]){case _.Left:p[i-1][1].left=p[i][1];break;case _.Right:p[i-1][1].right=p[i][1];break;case _.Mid:p[i-1][1].mid=p[i][1];break}else this._root=p[0][1]}}}_min(S){for(;S.left;)S=S.left;return S}findSubstr(S){const o=this._iter.reset(S);let m=this._root,p;for(;m;){const u=o.cmp(m.segment);if(u>0)m=m.left;else if(u<0)m=m.right;else if(o.hasNext())o.next(),p=m.value||p,m=m.mid;else break}return m&&m.value||p}findSuperstr(S){return this._findSuperstrOrElement(S,!1)}_findSuperstrOrElement(S,o){const m=this._iter.reset(S);let p=this._root;for(;p;){const u=m.cmp(p.segment);if(u>0)p=p.left;else if(u<0)p=p.right;else if(m.hasNext())m.next(),p=p.mid;else return p.mid?this._entries(p.mid):o?p.value:void 0}}hasElementOrSubtree(S){return this._findSuperstrOrElement(S,!0)!==void 0}forEach(S){for(const[o,m]of this)S(m,o)}*[Symbol.iterator](){yield*this._entries(this._root)}_entries(S){const o=[];return this._dfsEntries(S,o),o[Symbol.iterator]()}_dfsEntries(S,o){S&&(S.left&&this._dfsEntries(S.left,o),S.value&&o.push([S.key,S.value]),S.mid&&this._dfsEntries(S.mid,o),S.right&&this._dfsEntries(S.right,o))}_isBalanced(){const S=o=>{if(!o)return!0;const m=o.balanceFactor();return m<-1||m>1?!1:S(o.left)&&S(o.right)};return S(this._root)}}e.TernarySearchTree=f}),define(Pe[31],ke([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=void 0,e.isUUID=h;const s=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function h(D){return s.test(D)}e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let D;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?D=crypto.getRandomValues.bind(crypto):D=function(R){for(let v=0;v<R.length;v++)R[v]=Math.floor(Math.random()*256);return R};const A=new Uint8Array(16),L=[];for(let R=0;R<256;R++)L.push(R.toString(16).padStart(2,"0"));return function(){D(A),A[6]=A[6]&15|64,A[8]=A[8]&63|128;let v=0,l="";return l+=L[A[v++]],l+=L[A[v++]],l+=L[A[v++]],l+=L[A[v++]],l+="-",l+=L[A[v++]],l+=L[A[v++]],l+="-",l+=L[A[v++]],l+=L[A[v++]],l+="-",l+=L[A[v++]],l+=L[A[v++]],l+="-",l+=L[A[v++]],l+=L[A[v++]],l+=L[A[v++]],l+=L[A[v++]],l+=L[A[v++]],l+=L[A[v++]],l}}()}),define(Pe[192],ke([1,0,18,40,31]),function(ge,e,s,h,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriList=e.VSDataTransfer=void 0,e.createStringDataTransferItem=A,e.createFileDataTransferItem=L,e.matchesMimeType=l;function A(_){return{asString:async()=>_,asFile:()=>{},value:typeof _=="string"?_:void 0}}function L(_,f,T){const S={id:(0,D.generateUuid)(),name:_,uri:f,data:T};return{asString:async()=>"",asFile:()=>S,value:void 0}}class R{constructor(){this._entries=new Map}get size(){let f=0;for(const T of this._entries)f++;return f}has(f){return this._entries.has(this.toKey(f))}matches(f){const T=[...this._entries.keys()];return h.Iterable.some(this,([S,o])=>o.asFile())&&T.push("files"),C(v(f),T)}get(f){return this._entries.get(this.toKey(f))?.[0]}append(f,T){const S=this._entries.get(f);S?S.push(T):this._entries.set(this.toKey(f),[T])}replace(f,T){this._entries.set(this.toKey(f),[T])}delete(f){this._entries.delete(this.toKey(f))}*[Symbol.iterator](){for(const[f,T]of this._entries)for(const S of T)yield[f,S]}toKey(f){return v(f)}}e.VSDataTransfer=R;function v(_){return _.toLowerCase()}function l(_,f){return C(v(_),f.map(v))}function C(_,f){if(_==="*/*")return f.length>0;if(f.includes(_))return!0;const T=_.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!T)return!1;const[S,o,m]=T;return m==="*"?f.some(p=>p.startsWith(o+"/")):!1}e.UriList=Object.freeze({create:_=>(0,s.distinct)(_.map(f=>f.toString())).join(`\r
`),split:_=>_.split(`\r
`),parse:_=>e.UriList.split(_).filter(f=>!f.startsWith("#"))})}),define(Pe[193],ke([1,0,68]),function(ge,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BROWSER_RESTRICTED_PORTS=void 0,e.findFreePort=h,e.findFreePortFaster=A,s=We(s);function h(R,v,l,C=1){let _=!1;return new Promise(f=>{const T=setTimeout(()=>{if(!_)return _=!0,f(0)},l);D(R,v,C,S=>{if(!_)return _=!0,clearTimeout(T),f(S)})})}function D(R,v,l,C){if(v===0)return C(0);const _=new s.Socket;_.once("connect",()=>(L(_),D(R+l,v-1,l,C))),_.once("data",()=>{}),_.once("error",f=>(L(_),f.code!=="ECONNREFUSED"?D(R+l,v-1,l,C):C(R))),_.connect(R,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function A(R,v,l,C="127.0.0.1"){let _=!1,f,T=1;const S=s.createServer({pauseOnConnect:!0});function o(m,p){_||(_=!0,S.removeAllListeners(),S.close(),f&&clearTimeout(f),p(m))}return new Promise(m=>{f=setTimeout(()=>{o(0,m)},l),S.on("listening",()=>{o(R,m)}),S.on("error",p=>{p&&(p.code==="EADDRINUSE"||p.code==="EACCES")&&T<v?(R++,T++,S.listen(R,C)):o(0,m)}),S.on("close",()=>{o(0,m)}),S.listen(R,C)})}function L(R){try{R.removeAllListeners("connect"),R.removeAllListeners("error"),R.end(),R.destroy(),R.unref()}catch(v){console.error(v)}}}),define(Pe[138],ke([1,0,85]),function(ge,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharacterSet=e.CharacterClassifier=void 0;class h{constructor(R){const v=(0,s.toUint8)(R);this._defaultValue=v,this._asciiMap=h._createAsciiMap(v),this._map=new Map}static _createAsciiMap(R){const v=new Uint8Array(256);return v.fill(R),v}set(R,v){const l=(0,s.toUint8)(v);R>=0&&R<256?this._asciiMap[R]=l:this._map.set(R,l)}get(R){return R>=0&&R<256?this._asciiMap[R]:this._map.get(R)||this._defaultValue}clear(){this._asciiMap.fill(this._defaultValue),this._map.clear()}}e.CharacterClassifier=h;var D;(function(L){L[L.False=0]="False",L[L.True=1]="True"})(D||(D={}));class A{constructor(){this._actual=new h(D.False)}add(R){this._actual.set(R,D.True)}has(R){return this._actual.get(R)===D.True}clear(){return this._actual.clear()}}e.CharacterSet=A}),define(Pe[194],ke([1,0,26]),function(ge,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringEOL=void 0,e.countEOL=D;var h;(function(A){A[A.Unknown=0]="Unknown",A[A.Invalid=3]="Invalid",A[A.LF=1]="LF",A[A.CRLF=2]="CRLF"})(h||(e.StringEOL=h={}));function D(A){let L=0,R=0,v=0,l=h.Unknown;for(let C=0,_=A.length;C<_;C++){const f=A.charCodeAt(C);f===s.CharCode.CarriageReturn?(L===0&&(R=C),L++,C+1<_&&A.charCodeAt(C+1)===s.CharCode.LineFeed?(l|=h.CRLF,C++):l|=h.Invalid,v=C+1):f===s.CharCode.LineFeed&&(l|=h.LF,L===0&&(R=C),L++,v=C+1)}return L===0&&(R=A.length),[L,R,A.length-v,l]}}),define(Pe[55],ke([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class s{constructor(D,A){this.lineNumber=D,this.column=A}with(D=this.lineNumber,A=this.column){return D===this.lineNumber&&A===this.column?this:new s(D,A)}delta(D=0,A=0){return this.with(this.lineNumber+D,this.column+A)}equals(D){return s.equals(this,D)}static equals(D,A){return!D&&!A?!0:!!D&&!!A&&D.lineNumber===A.lineNumber&&D.column===A.column}isBefore(D){return s.isBefore(this,D)}static isBefore(D,A){return D.lineNumber<A.lineNumber?!0:A.lineNumber<D.lineNumber?!1:D.column<A.column}isBeforeOrEqual(D){return s.isBeforeOrEqual(this,D)}static isBeforeOrEqual(D,A){return D.lineNumber<A.lineNumber?!0:A.lineNumber<D.lineNumber?!1:D.column<=A.column}static compare(D,A){const L=D.lineNumber|0,R=A.lineNumber|0;if(L===R){const v=D.column|0,l=A.column|0;return v-l}return L-R}clone(){return new s(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(D){return new s(D.lineNumber,D.column)}static isIPosition(D){return D&&typeof D.lineNumber=="number"&&typeof D.column=="number"}toJSON(){return{lineNumber:this.lineNumber,column:this.column}}}e.Position=s}),define(Pe[30],ke([1,0,55]),function(ge,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class h{constructor(A,L,R,v){A>R||A===R&&L>v?(this.startLineNumber=R,this.startColumn=v,this.endLineNumber=A,this.endColumn=L):(this.startLineNumber=A,this.startColumn=L,this.endLineNumber=R,this.endColumn=v)}isEmpty(){return h.isEmpty(this)}static isEmpty(A){return A.startLineNumber===A.endLineNumber&&A.startColumn===A.endColumn}containsPosition(A){return h.containsPosition(this,A)}static containsPosition(A,L){return!(L.lineNumber<A.startLineNumber||L.lineNumber>A.endLineNumber||L.lineNumber===A.startLineNumber&&L.column<A.startColumn||L.lineNumber===A.endLineNumber&&L.column>A.endColumn)}static strictContainsPosition(A,L){return!(L.lineNumber<A.startLineNumber||L.lineNumber>A.endLineNumber||L.lineNumber===A.startLineNumber&&L.column<=A.startColumn||L.lineNumber===A.endLineNumber&&L.column>=A.endColumn)}containsRange(A){return h.containsRange(this,A)}static containsRange(A,L){return!(L.startLineNumber<A.startLineNumber||L.endLineNumber<A.startLineNumber||L.startLineNumber>A.endLineNumber||L.endLineNumber>A.endLineNumber||L.startLineNumber===A.startLineNumber&&L.startColumn<A.startColumn||L.endLineNumber===A.endLineNumber&&L.endColumn>A.endColumn)}strictContainsRange(A){return h.strictContainsRange(this,A)}static strictContainsRange(A,L){return!(L.startLineNumber<A.startLineNumber||L.endLineNumber<A.startLineNumber||L.startLineNumber>A.endLineNumber||L.endLineNumber>A.endLineNumber||L.startLineNumber===A.startLineNumber&&L.startColumn<=A.startColumn||L.endLineNumber===A.endLineNumber&&L.endColumn>=A.endColumn)}plusRange(A){return h.plusRange(this,A)}static plusRange(A,L){let R,v,l,C;return L.startLineNumber<A.startLineNumber?(R=L.startLineNumber,v=L.startColumn):L.startLineNumber===A.startLineNumber?(R=L.startLineNumber,v=Math.min(L.startColumn,A.startColumn)):(R=A.startLineNumber,v=A.startColumn),L.endLineNumber>A.endLineNumber?(l=L.endLineNumber,C=L.endColumn):L.endLineNumber===A.endLineNumber?(l=L.endLineNumber,C=Math.max(L.endColumn,A.endColumn)):(l=A.endLineNumber,C=A.endColumn),new h(R,v,l,C)}intersectRanges(A){return h.intersectRanges(this,A)}static intersectRanges(A,L){let R=A.startLineNumber,v=A.startColumn,l=A.endLineNumber,C=A.endColumn;const _=L.startLineNumber,f=L.startColumn,T=L.endLineNumber,S=L.endColumn;return R<_?(R=_,v=f):R===_&&(v=Math.max(v,f)),l>T?(l=T,C=S):l===T&&(C=Math.min(C,S)),R>l||R===l&&v>C?null:new h(R,v,l,C)}equalsRange(A){return h.equalsRange(this,A)}static equalsRange(A,L){return!A&&!L?!0:!!A&&!!L&&A.startLineNumber===L.startLineNumber&&A.startColumn===L.startColumn&&A.endLineNumber===L.endLineNumber&&A.endColumn===L.endColumn}getEndPosition(){return h.getEndPosition(this)}static getEndPosition(A){return new s.Position(A.endLineNumber,A.endColumn)}getStartPosition(){return h.getStartPosition(this)}static getStartPosition(A){return new s.Position(A.startLineNumber,A.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(A,L){return new h(this.startLineNumber,this.startColumn,A,L)}setStartPosition(A,L){return new h(A,L,this.endLineNumber,this.endColumn)}collapseToStart(){return h.collapseToStart(this)}static collapseToStart(A){return new h(A.startLineNumber,A.startColumn,A.startLineNumber,A.startColumn)}collapseToEnd(){return h.collapseToEnd(this)}static collapseToEnd(A){return new h(A.endLineNumber,A.endColumn,A.endLineNumber,A.endColumn)}delta(A){return new h(this.startLineNumber+A,this.startColumn,this.endLineNumber+A,this.endColumn)}static fromPositions(A,L=A){return new h(A.lineNumber,A.column,L.lineNumber,L.column)}static lift(A){return A?new h(A.startLineNumber,A.startColumn,A.endLineNumber,A.endColumn):null}static isIRange(A){return A&&typeof A.startLineNumber=="number"&&typeof A.startColumn=="number"&&typeof A.endLineNumber=="number"&&typeof A.endColumn=="number"}static areIntersectingOrTouching(A,L){return!(A.endLineNumber<L.startLineNumber||A.endLineNumber===L.startLineNumber&&A.endColumn<L.startColumn||L.endLineNumber<A.startLineNumber||L.endLineNumber===A.startLineNumber&&L.endColumn<A.startColumn)}static areIntersecting(A,L){return!(A.endLineNumber<L.startLineNumber||A.endLineNumber===L.startLineNumber&&A.endColumn<=L.startColumn||L.endLineNumber<A.startLineNumber||L.endLineNumber===A.startLineNumber&&L.endColumn<=A.startColumn)}static compareRangesUsingStarts(A,L){if(A&&L){const l=A.startLineNumber|0,C=L.startLineNumber|0;if(l===C){const _=A.startColumn|0,f=L.startColumn|0;if(_===f){const T=A.endLineNumber|0,S=L.endLineNumber|0;if(T===S){const o=A.endColumn|0,m=L.endColumn|0;return o-m}return T-S}return _-f}return l-C}return(A?1:0)-(L?1:0)}static compareRangesUsingEnds(A,L){return A.endLineNumber===L.endLineNumber?A.endColumn===L.endColumn?A.startLineNumber===L.startLineNumber?A.startColumn-L.startColumn:A.startLineNumber-L.startLineNumber:A.endColumn-L.endColumn:A.endLineNumber-L.endLineNumber}static spansMultipleLines(A){return A.endLineNumber>A.startLineNumber}toJSON(){return this}}e.Range=h}),define(Pe[195],ke([1,0,30]),function(ge,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditOperation=void 0;class h{static insert(A,L){return{range:new s.Range(A.lineNumber,A.column,A.lineNumber,A.column),text:L,forceMoveMarkers:!0}}static delete(A){return{range:A,text:null}}static replace(A,L){return{range:A,text:L}}static replaceMove(A,L){return{range:A,text:L,forceMoveMarkers:!0}}}e.EditOperation=h}),define(Pe[196],ke([1,0,55,30]),function(ge,e,s,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Selection=e.SelectionDirection=void 0;var D;(function(L){L[L.LTR=0]="LTR",L[L.RTL=1]="RTL"})(D||(e.SelectionDirection=D={}));class A extends h.Range{constructor(R,v,l,C){super(R,v,l,C),this.selectionStartLineNumber=R,this.selectionStartColumn=v,this.positionLineNumber=l,this.positionColumn=C}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(R){return A.selectionsEqual(this,R)}static selectionsEqual(R,v){return R.selectionStartLineNumber===v.selectionStartLineNumber&&R.selectionStartColumn===v.selectionStartColumn&&R.positionLineNumber===v.positionLineNumber&&R.positionColumn===v.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?D.LTR:D.RTL}setEndPosition(R,v){return this.getDirection()===D.LTR?new A(this.startLineNumber,this.startColumn,R,v):new A(R,v,this.startLineNumber,this.startColumn)}getPosition(){return new s.Position(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new s.Position(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(R,v){return this.getDirection()===D.LTR?new A(R,v,this.endLineNumber,this.endColumn):new A(this.endLineNumber,this.endColumn,R,v)}static fromPositions(R,v=R){return new A(R.lineNumber,R.column,v.lineNumber,v.column)}static fromRange(R,v){return v===D.LTR?new A(R.startLineNumber,R.startColumn,R.endLineNumber,R.endColumn):new A(R.endLineNumber,R.endColumn,R.startLineNumber,R.startColumn)}static liftSelection(R){return new A(R.selectionStartLineNumber,R.selectionStartColumn,R.positionLineNumber,R.positionColumn)}static selectionsArrEqual(R,v){if(R&&!v||!R&&v)return!1;if(!R&&!v)return!0;if(R.length!==v.length)return!1;for(let l=0,C=R.length;l<C;l++)if(!this.selectionsEqual(R[l],v[l]))return!1;return!0}static isISelection(R){return R&&typeof R.selectionStartLineNumber=="number"&&typeof R.selectionStartColumn=="number"&&typeof R.positionLineNumber=="number"&&typeof R.positionColumn=="number"}static createWithDirection(R,v,l,C,_){return _===D.LTR?new A(R,v,l,C):new A(l,C,R,v)}}e.Selection=A}),define(Pe[197],ke([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EDITOR_MODEL_DEFAULTS=void 0,e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Pe[198],ke([1,0,26,28,138]),function(ge,e,s,h,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WordCharacterClassifier=e.WordCharacterClass=void 0,e.getMapForWordSeparators=v;var A;(function(l){l[l.Regular=0]="Regular",l[l.Whitespace=1]="Whitespace",l[l.WordSeparator=2]="WordSeparator"})(A||(e.WordCharacterClass=A={}));class L extends D.CharacterClassifier{constructor(C,_){super(A.Regular),this._segmenter=null,this._cachedLine=null,this._cachedSegments=[],this.intlSegmenterLocales=_,this.intlSegmenterLocales.length>0?this._segmenter=new Intl.Segmenter(this.intlSegmenterLocales,{granularity:"word"}):this._segmenter=null;for(let f=0,T=C.length;f<T;f++)this.set(C.charCodeAt(f),A.WordSeparator);this.set(s.CharCode.Space,A.Whitespace),this.set(s.CharCode.Tab,A.Whitespace)}findPrevIntlWordBeforeOrAtOffset(C,_){let f=null;for(const T of this._getIntlSegmenterWordsOnLine(C)){if(T.index>_)break;f=T}return f}findNextIntlWordAtOrAfterOffset(C,_){for(const f of this._getIntlSegmenterWordsOnLine(C))if(!(f.index<_))return f;return null}_getIntlSegmenterWordsOnLine(C){return this._segmenter?this._cachedLine===C?this._cachedSegments:(this._cachedLine=C,this._cachedSegments=this._filterWordSegments(this._segmenter.segment(C)),this._cachedSegments):[]}_filterWordSegments(C){const _=[];for(const f of C)this._isWordLike(f)&&_.push(f);return _}_isWordLike(C){return!!C.isWordLike}}e.WordCharacterClassifier=L;const R=new h.LRUCache(10);function v(l,C){const _=`${l}/${C.join(",")}`;let f=R.get(_);return f||(f=new L(l,C),R.set(_,f)),f}}),define(Pe[139],ke([1,0,40,3,82]),function(ge,e,s,h,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DEFAULT_WORD_REGEXP=e.USUAL_WORD_SEPARATORS=void 0,e.ensureValidWordDefinition=L,e.setDefaultGetWordAtTextConfig=v,e.getWordAtText=l,e.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function A(_=""){let f="(-?\\d*\\.\\d\\w*)|([^";for(const T of e.USUAL_WORD_SEPARATORS)_.indexOf(T)>=0||(f+="\\"+T);return f+="\\s]+)",new RegExp(f,"g")}e.DEFAULT_WORD_REGEXP=A();function L(_){let f=e.DEFAULT_WORD_REGEXP;if(_&&_ instanceof RegExp)if(_.global)f=_;else{let T="g";_.ignoreCase&&(T+="i"),_.multiline&&(T+="m"),_.unicode&&(T+="u"),f=new RegExp(_.source,T)}return f.lastIndex=0,f}const R=new D.LinkedList;R.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function v(_){const f=R.unshift(_);return(0,h.toDisposable)(f)}function l(_,f,T,S,o){if(f=L(f),o||(o=s.Iterable.first(R)),T.length>o.maxLen){let a=_-o.maxLen/2;return a<0?a=0:S+=a,T=T.substring(a,_+o.maxLen/2),l(_,f,T,S,o)}const m=Date.now(),p=_-1-S;let u=-1,i=null;for(let a=1;!(Date.now()-m>=o.timeBudget);a++){const t=p-o.windowSize*a;f.lastIndex=Math.max(0,t);const n=C(f,T,p,u);if(!n&&i||(i=n,t<=0))break;u=t}if(i){const a={word:i[0],startColumn:S+1+i.index,endColumn:S+1+i.index+i[0].length};return f.lastIndex=0,a}return null}function C(_,f,T,S){let o;for(;o=_.exec(f);){const m=o.index||0;if(m<=T&&_.lastIndex>=T)return o;if(S>0&&m>S)return null}return null}}),define(Pe[105],ke([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageId=void 0;var s;(function(v){v[v.Null=0]="Null",v[v.PlainText=1]="PlainText"})(s||(e.LanguageId=s={}));var h;(function(v){v[v.NotSet=-1]="NotSet",v[v.None=0]="None",v[v.Italic=1]="Italic",v[v.Bold=2]="Bold",v[v.Underline=4]="Underline",v[v.Strikethrough=8]="Strikethrough"})(h||(e.FontStyle=h={}));var D;(function(v){v[v.None=0]="None",v[v.DefaultForeground=1]="DefaultForeground",v[v.DefaultBackground=2]="DefaultBackground"})(D||(e.ColorId=D={}));var A;(function(v){v[v.Other=0]="Other",v[v.Comment=1]="Comment",v[v.String=2]="String",v[v.RegEx=3]="RegEx"})(A||(e.StandardTokenType=A={}));var L;(function(v){v[v.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",v[v.TOKEN_TYPE_MASK=768]="TOKEN_TYPE_MASK",v[v.BALANCED_BRACKETS_MASK=1024]="BALANCED_BRACKETS_MASK",v[v.FONT_STYLE_MASK=30720]="FONT_STYLE_MASK",v[v.FOREGROUND_MASK=16744448]="FOREGROUND_MASK",v[v.BACKGROUND_MASK=4278190080]="BACKGROUND_MASK",v[v.ITALIC_MASK=2048]="ITALIC_MASK",v[v.BOLD_MASK=4096]="BOLD_MASK",v[v.UNDERLINE_MASK=8192]="UNDERLINE_MASK",v[v.STRIKETHROUGH_MASK=16384]="STRIKETHROUGH_MASK",v[v.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",v[v.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",v[v.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",v[v.SEMANTIC_USE_STRIKETHROUGH=8]="SEMANTIC_USE_STRIKETHROUGH",v[v.SEMANTIC_USE_FOREGROUND=16]="SEMANTIC_USE_FOREGROUND",v[v.SEMANTIC_USE_BACKGROUND=32]="SEMANTIC_USE_BACKGROUND",v[v.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",v[v.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",v[v.BALANCED_BRACKETS_OFFSET=10]="BALANCED_BRACKETS_OFFSET",v[v.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",v[v.FOREGROUND_OFFSET=15]="FOREGROUND_OFFSET",v[v.BACKGROUND_OFFSET=24]="BACKGROUND_OFFSET"})(L||(e.MetadataConsts=L={}));class R{static getLanguageId(l){return(l&L.LANGUAGEID_MASK)>>>L.LANGUAGEID_OFFSET}static getTokenType(l){return(l&L.TOKEN_TYPE_MASK)>>>L.TOKEN_TYPE_OFFSET}static containsBalancedBrackets(l){return(l&L.BALANCED_BRACKETS_MASK)!==0}static getFontStyle(l){return(l&L.FONT_STYLE_MASK)>>>L.FONT_STYLE_OFFSET}static getForeground(l){return(l&L.FOREGROUND_MASK)>>>L.FOREGROUND_OFFSET}static getBackground(l){return(l&L.BACKGROUND_MASK)>>>L.BACKGROUND_OFFSET}static getClassNameFromMetadata(l){let _="mtk"+this.getForeground(l);const f=this.getFontStyle(l);return f&h.Italic&&(_+=" mtki"),f&h.Bold&&(_+=" mtkb"),f&h.Underline&&(_+=" mtku"),f&h.Strikethrough&&(_+=" mtks"),_}static getInlineStyleFromMetadata(l,C){const _=this.getForeground(l),f=this.getFontStyle(l);let T=`color: ${C[_]};`;f&h.Italic&&(T+="font-style: italic;"),f&h.Bold&&(T+="font-weight: bold;");let S="";return f&h.Underline&&(S+=" underline"),f&h.Strikethrough&&(S+=" line-through"),S&&(T+=`text-decoration:${S};`),T}static getPresentationFromMetadata(l){const C=this.getForeground(l),_=this.getFontStyle(l);return{foreground:C,italic:!!(_&h.Italic),bold:!!(_&h.Bold),underline:!!(_&h.Underline),strikethrough:!!(_&h.Strikethrough)}}}e.TokenMetadata=R}),define(Pe[199],ke([1,0,26,105]),function(ge,e,s,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var D;(function(v){v[v.None=0]="None",v[v.Indent=1]="Indent",v[v.IndentOutdent=2]="IndentOutdent",v[v.Outdent=3]="Outdent"})(D||(e.IndentAction=D={}));class A{constructor(l){if(this._neutralCharacter=null,this._neutralCharacterSearched=!1,this.open=l.open,this.close=l.close,this._inString=!0,this._inComment=!0,this._inRegEx=!0,Array.isArray(l.notIn))for(let C=0,_=l.notIn.length;C<_;C++)switch(l.notIn[C]){case"string":this._inString=!1;break;case"comment":this._inComment=!1;break;case"regex":this._inRegEx=!1;break}}isOK(l){switch(l){case h.StandardTokenType.Other:return!0;case h.StandardTokenType.Comment:return this._inComment;case h.StandardTokenType.String:return this._inString;case h.StandardTokenType.RegEx:return this._inRegEx}}shouldAutoClose(l,C){if(l.getTokenCount()===0)return!0;const _=l.findTokenIndexAtOffset(C-2),f=l.getStandardTokenType(_);return this.isOK(f)}_findNeutralCharacterInRange(l,C){for(let _=l;_<=C;_++){const f=String.fromCharCode(_);if(!this.open.includes(f)&&!this.close.includes(f))return f}return null}findNeutralCharacter(){return this._neutralCharacterSearched||(this._neutralCharacterSearched=!0,this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(s.CharCode.Digit0,s.CharCode.Digit9)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(s.CharCode.a,s.CharCode.z)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(s.CharCode.A,s.CharCode.Z))),this._neutralCharacter}}e.StandardAutoClosingPairConditional=A;class L{constructor(l){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const C of l)R(this.autoClosingPairsOpenByStart,C.open.charAt(0),C),R(this.autoClosingPairsOpenByEnd,C.open.charAt(C.open.length-1),C),R(this.autoClosingPairsCloseByStart,C.close.charAt(0),C),R(this.autoClosingPairsCloseByEnd,C.close.charAt(C.close.length-1),C),C.close.length===1&&C.open.length===1&&R(this.autoClosingPairsCloseSingleChar,C.close,C)}}e.AutoClosingPairs=L;function R(v,l,C){v.has(l)?v.get(l).push(C):v.set(l,[C])}}),define(Pe[200],ke([1,0,26,138]),function(ge,e,s,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkComputer=e.StateMachine=e.State=void 0,e.computeLinks=T;var D;(function(S){S[S.Invalid=0]="Invalid",S[S.Start=1]="Start",S[S.H=2]="H",S[S.HT=3]="HT",S[S.HTT=4]="HTT",S[S.HTTP=5]="HTTP",S[S.F=6]="F",S[S.FI=7]="FI",S[S.FIL=8]="FIL",S[S.BeforeColon=9]="BeforeColon",S[S.AfterColon=10]="AfterColon",S[S.AlmostThere=11]="AlmostThere",S[S.End=12]="End",S[S.Accept=13]="Accept",S[S.LastKnownState=14]="LastKnownState"})(D||(e.State=D={}));class A{constructor(o,m,p){const u=new Uint8Array(o*m);for(let i=0,a=o*m;i<a;i++)u[i]=p;this._data=u,this.rows=o,this.cols=m}get(o,m){return this._data[o*this.cols+m]}set(o,m,p){this._data[o*this.cols+m]=p}}class L{constructor(o){let m=0,p=D.Invalid;for(let i=0,a=o.length;i<a;i++){const[t,n,r]=o[i];n>m&&(m=n),t>p&&(p=t),r>p&&(p=r)}m++,p++;const u=new A(p,m,D.Invalid);for(let i=0,a=o.length;i<a;i++){const[t,n,r]=o[i];u.set(t,n,r)}this._states=u,this._maxCharCode=m}nextState(o,m){return m<0||m>=this._maxCharCode?D.Invalid:this._states.get(o,m)}}e.StateMachine=L;let R=null;function v(){return R===null&&(R=new L([[D.Start,s.CharCode.h,D.H],[D.Start,s.CharCode.H,D.H],[D.Start,s.CharCode.f,D.F],[D.Start,s.CharCode.F,D.F],[D.H,s.CharCode.t,D.HT],[D.H,s.CharCode.T,D.HT],[D.HT,s.CharCode.t,D.HTT],[D.HT,s.CharCode.T,D.HTT],[D.HTT,s.CharCode.p,D.HTTP],[D.HTT,s.CharCode.P,D.HTTP],[D.HTTP,s.CharCode.s,D.BeforeColon],[D.HTTP,s.CharCode.S,D.BeforeColon],[D.HTTP,s.CharCode.Colon,D.AfterColon],[D.F,s.CharCode.i,D.FI],[D.F,s.CharCode.I,D.FI],[D.FI,s.CharCode.l,D.FIL],[D.FI,s.CharCode.L,D.FIL],[D.FIL,s.CharCode.e,D.BeforeColon],[D.FIL,s.CharCode.E,D.BeforeColon],[D.BeforeColon,s.CharCode.Colon,D.AfterColon],[D.AfterColon,s.CharCode.Slash,D.AlmostThere],[D.AlmostThere,s.CharCode.Slash,D.End]])),R}var l;(function(S){S[S.None=0]="None",S[S.ForceTermination=1]="ForceTermination",S[S.CannotEndIn=2]="CannotEndIn"})(l||(l={}));let C=null;function _(){if(C===null){C=new h.CharacterClassifier(l.None);const S=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let m=0;m<S.length;m++)C.set(S.charCodeAt(m),l.ForceTermination);const o=".,;:";for(let m=0;m<o.length;m++)C.set(o.charCodeAt(m),l.CannotEndIn)}return C}class f{static _createLink(o,m,p,u,i){let a=i-1;do{const t=m.charCodeAt(a);if(o.get(t)!==l.CannotEndIn)break;a--}while(a>u);if(u>0){const t=m.charCodeAt(u-1),n=m.charCodeAt(a);(t===s.CharCode.OpenParen&&n===s.CharCode.CloseParen||t===s.CharCode.OpenSquareBracket&&n===s.CharCode.CloseSquareBracket||t===s.CharCode.OpenCurlyBrace&&n===s.CharCode.CloseCurlyBrace)&&a--}return{range:{startLineNumber:p,startColumn:u+1,endLineNumber:p,endColumn:a+2},url:m.substring(u,a+1)}}static computeLinks(o,m=v()){const p=_(),u=[];for(let i=1,a=o.getLineCount();i<=a;i++){const t=o.getLineContent(i),n=t.length;let r=0,d=0,c=0,g=D.Start,w=!1,y=!1,I=!1,P=!1;for(;r<n;){let k=!1;const b=t.charCodeAt(r);if(g===D.Accept){let E;switch(b){case s.CharCode.OpenParen:w=!0,E=l.None;break;case s.CharCode.CloseParen:E=w?l.None:l.ForceTermination;break;case s.CharCode.OpenSquareBracket:I=!0,y=!0,E=l.None;break;case s.CharCode.CloseSquareBracket:I=!1,E=y?l.None:l.ForceTermination;break;case s.CharCode.OpenCurlyBrace:P=!0,E=l.None;break;case s.CharCode.CloseCurlyBrace:E=P?l.None:l.ForceTermination;break;case s.CharCode.SingleQuote:case s.CharCode.DoubleQuote:case s.CharCode.BackTick:c===b?E=l.ForceTermination:c===s.CharCode.SingleQuote||c===s.CharCode.DoubleQuote||c===s.CharCode.BackTick?E=l.None:E=l.ForceTermination;break;case s.CharCode.Asterisk:E=c===s.CharCode.Asterisk?l.ForceTermination:l.None;break;case s.CharCode.Pipe:E=c===s.CharCode.Pipe?l.ForceTermination:l.None;break;case s.CharCode.Space:E=I?l.None:l.ForceTermination;break;default:E=p.get(b)}E===l.ForceTermination&&(u.push(f._createLink(p,t,i,d,r)),k=!0)}else if(g===D.End){let E;b===s.CharCode.OpenSquareBracket?(y=!0,E=l.None):E=p.get(b),E===l.ForceTermination?k=!0:g=D.Accept}else g=m.nextState(g,b),g===D.Invalid&&(k=!0);k&&(g=D.Start,w=!1,y=!1,P=!1,d=r+1,c=b),r++}g===D.Accept&&u.push(f._createLink(p,t,i,d,n))}return u}}e.LinkComputer=f;function T(S){return!S||typeof S.getLineCount!="function"||typeof S.getLineContent!="function"?[]:f.computeLinks(S)}}),define(Pe[56],ke([1,0,24]),function(ge,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplyEditsResult=e.SearchData=e.ValidAnnotatedEditOperation=e.ModelConstants=e.PositionAffinity=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.InjectedTextCursorStops=e.MinimapSectionHeaderStyle=e.MinimapPosition=e.GlyphMarginLane=e.OverviewRulerLane=void 0,e.isITextSnapshot=S,e.shouldSynchronizeModel=a;var h;(function(t){t[t.Left=1]="Left",t[t.Center=2]="Center",t[t.Right=4]="Right",t[t.Full=7]="Full"})(h||(e.OverviewRulerLane=h={}));var D;(function(t){t[t.Left=1]="Left",t[t.Center=2]="Center",t[t.Right=3]="Right"})(D||(e.GlyphMarginLane=D={}));var A;(function(t){t[t.Inline=1]="Inline",t[t.Gutter=2]="Gutter"})(A||(e.MinimapPosition=A={}));var L;(function(t){t[t.Normal=1]="Normal",t[t.Underlined=2]="Underlined"})(L||(e.MinimapSectionHeaderStyle=L={}));var R;(function(t){t[t.Both=0]="Both",t[t.Right=1]="Right",t[t.Left=2]="Left",t[t.None=3]="None"})(R||(e.InjectedTextCursorStops=R={}));var v;(function(t){t[t.TextDefined=0]="TextDefined",t[t.LF=1]="LF",t[t.CRLF=2]="CRLF"})(v||(e.EndOfLinePreference=v={}));var l;(function(t){t[t.LF=1]="LF",t[t.CRLF=2]="CRLF"})(l||(e.DefaultEndOfLine=l={}));var C;(function(t){t[t.LF=0]="LF",t[t.CRLF=1]="CRLF"})(C||(e.EndOfLineSequence=C={}));class _{get originalIndentSize(){return this._indentSizeIsTabSize?"tabSize":this.indentSize}constructor(n){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,n.tabSize|0),n.indentSize==="tabSize"?(this.indentSize=this.tabSize,this._indentSizeIsTabSize=!0):(this.indentSize=Math.max(1,n.indentSize|0),this._indentSizeIsTabSize=!1),this.insertSpaces=!!n.insertSpaces,this.defaultEOL=n.defaultEOL|0,this.trimAutoWhitespace=!!n.trimAutoWhitespace,this.bracketPairColorizationOptions=n.bracketPairColorizationOptions}equals(n){return this.tabSize===n.tabSize&&this._indentSizeIsTabSize===n._indentSizeIsTabSize&&this.indentSize===n.indentSize&&this.insertSpaces===n.insertSpaces&&this.defaultEOL===n.defaultEOL&&this.trimAutoWhitespace===n.trimAutoWhitespace&&(0,s.equals)(this.bracketPairColorizationOptions,n.bracketPairColorizationOptions)}createChangeEvent(n){return{tabSize:this.tabSize!==n.tabSize,indentSize:this.indentSize!==n.indentSize,insertSpaces:this.insertSpaces!==n.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==n.trimAutoWhitespace}}}e.TextModelResolvedOptions=_;class f{constructor(n,r){this._findMatchBrand=void 0,this.range=n,this.matches=r}}e.FindMatch=f;var T;(function(t){t[t.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",t[t.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",t[t.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",t[t.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(T||(e.TrackedRangeStickiness=T={}));function S(t){return t&&typeof t.read=="function"}var o;(function(t){t[t.Left=0]="Left",t[t.Right=1]="Right",t[t.None=2]="None",t[t.LeftOfInjectedText=3]="LeftOfInjectedText",t[t.RightOfInjectedText=4]="RightOfInjectedText"})(o||(e.PositionAffinity=o={}));var m;(function(t){t[t.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(m||(e.ModelConstants=m={}));class p{constructor(n,r,d,c,g,w){this.identifier=n,this.range=r,this.text=d,this.forceMoveMarkers=c,this.isAutoWhitespaceEdit=g,this._isTracked=w}}e.ValidAnnotatedEditOperation=p;class u{constructor(n,r,d){this.regex=n,this.wordSeparators=r,this.simpleSearch=d}}e.SearchData=u;class i{constructor(n,r,d){this.reverseEdits=n,this.changes=r,this.trimAutoWhitespaceLineNumbers=d}}e.ApplyEditsResult=i;function a(t){return!t.isTooLargeForSyncing()&&!t.isForSimpleWidget}}),define(Pe[201],ke([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SENTINEL=e.NodeColor=e.TreeNode=void 0,e.leftest=D,e.righttest=A,e.leftRotate=l,e.rightRotate=C,e.rbDelete=_,e.fixInsert=f,e.updateTreeMetadata=T,e.recomputeTreeMetadata=S;class s{constructor(m,p){this.piece=m,this.color=p,this.size_left=0,this.lf_left=0,this.parent=this,this.left=this,this.right=this}next(){if(this.right!==e.SENTINEL)return D(this.right);let m=this;for(;m.parent!==e.SENTINEL&&m.parent.left!==m;)m=m.parent;return m.parent===e.SENTINEL?e.SENTINEL:m.parent}prev(){if(this.left!==e.SENTINEL)return A(this.left);let m=this;for(;m.parent!==e.SENTINEL&&m.parent.right!==m;)m=m.parent;return m.parent===e.SENTINEL?e.SENTINEL:m.parent}detach(){this.parent=null,this.left=null,this.right=null}}e.TreeNode=s;var h;(function(o){o[o.Black=0]="Black",o[o.Red=1]="Red"})(h||(e.NodeColor=h={})),e.SENTINEL=new s(null,h.Black),e.SENTINEL.parent=e.SENTINEL,e.SENTINEL.left=e.SENTINEL,e.SENTINEL.right=e.SENTINEL,e.SENTINEL.color=h.Black;function D(o){for(;o.left!==e.SENTINEL;)o=o.left;return o}function A(o){for(;o.right!==e.SENTINEL;)o=o.right;return o}function L(o){return o===e.SENTINEL?0:o.size_left+o.piece.length+L(o.right)}function R(o){return o===e.SENTINEL?0:o.lf_left+o.piece.lineFeedCnt+R(o.right)}function v(){e.SENTINEL.parent=e.SENTINEL}function l(o,m){const p=m.right;p.size_left+=m.size_left+(m.piece?m.piece.length:0),p.lf_left+=m.lf_left+(m.piece?m.piece.lineFeedCnt:0),m.right=p.left,p.left!==e.SENTINEL&&(p.left.parent=m),p.parent=m.parent,m.parent===e.SENTINEL?o.root=p:m.parent.left===m?m.parent.left=p:m.parent.right=p,p.left=m,m.parent=p}function C(o,m){const p=m.left;m.left=p.right,p.right!==e.SENTINEL&&(p.right.parent=m),p.parent=m.parent,m.size_left-=p.size_left+(p.piece?p.piece.length:0),m.lf_left-=p.lf_left+(p.piece?p.piece.lineFeedCnt:0),m.parent===e.SENTINEL?o.root=p:m===m.parent.right?m.parent.right=p:m.parent.left=p,p.right=m,m.parent=p}function _(o,m){let p,u;if(m.left===e.SENTINEL?(u=m,p=u.right):m.right===e.SENTINEL?(u=m,p=u.left):(u=D(m.right),p=u.right),u===o.root){o.root=p,p.color=h.Black,m.detach(),v(),o.root.parent=e.SENTINEL;return}const i=u.color===h.Red;if(u===u.parent.left?u.parent.left=p:u.parent.right=p,u===m?(p.parent=u.parent,S(o,p)):(u.parent===m?p.parent=u:p.parent=u.parent,S(o,p),u.left=m.left,u.right=m.right,u.parent=m.parent,u.color=m.color,m===o.root?o.root=u:m===m.parent.left?m.parent.left=u:m.parent.right=u,u.left!==e.SENTINEL&&(u.left.parent=u),u.right!==e.SENTINEL&&(u.right.parent=u),u.size_left=m.size_left,u.lf_left=m.lf_left,S(o,u)),m.detach(),p.parent.left===p){const t=L(p),n=R(p);if(t!==p.parent.size_left||n!==p.parent.lf_left){const r=t-p.parent.size_left,d=n-p.parent.lf_left;p.parent.size_left=t,p.parent.lf_left=n,T(o,p.parent,r,d)}}if(S(o,p.parent),i){v();return}let a;for(;p!==o.root&&p.color===h.Black;)p===p.parent.left?(a=p.parent.right,a.color===h.Red&&(a.color=h.Black,p.parent.color=h.Red,l(o,p.parent),a=p.parent.right),a.left.color===h.Black&&a.right.color===h.Black?(a.color=h.Red,p=p.parent):(a.right.color===h.Black&&(a.left.color=h.Black,a.color=h.Red,C(o,a),a=p.parent.right),a.color=p.parent.color,p.parent.color=h.Black,a.right.color=h.Black,l(o,p.parent),p=o.root)):(a=p.parent.left,a.color===h.Red&&(a.color=h.Black,p.parent.color=h.Red,C(o,p.parent),a=p.parent.left),a.left.color===h.Black&&a.right.color===h.Black?(a.color=h.Red,p=p.parent):(a.left.color===h.Black&&(a.right.color=h.Black,a.color=h.Red,l(o,a),a=p.parent.left),a.color=p.parent.color,p.parent.color=h.Black,a.left.color=h.Black,C(o,p.parent),p=o.root));p.color=h.Black,v()}function f(o,m){for(S(o,m);m!==o.root&&m.parent.color===h.Red;)if(m.parent===m.parent.parent.left){const p=m.parent.parent.right;p.color===h.Red?(m.parent.color=h.Black,p.color=h.Black,m.parent.parent.color=h.Red,m=m.parent.parent):(m===m.parent.right&&(m=m.parent,l(o,m)),m.parent.color=h.Black,m.parent.parent.color=h.Red,C(o,m.parent.parent))}else{const p=m.parent.parent.left;p.color===h.Red?(m.parent.color=h.Black,p.color=h.Black,m.parent.parent.color=h.Red,m=m.parent.parent):(m===m.parent.left&&(m=m.parent,C(o,m)),m.parent.color=h.Black,m.parent.parent.color=h.Red,l(o,m.parent.parent))}o.root.color=h.Black}function T(o,m,p,u){for(;m!==o.root&&m!==e.SENTINEL;)m.parent.left===m&&(m.parent.size_left+=p,m.parent.lf_left+=u),m=m.parent}function S(o,m){let p=0,u=0;if(m!==o.root){for(;m!==o.root&&m===m.parent.right;)m=m.parent;if(m!==o.root)for(m=m.parent,p=L(m.left)-m.size_left,u=R(m.left)-m.lf_left,m.size_left+=p,m.lf_left+=u;m!==o.root&&(p!==0||u!==0);)m.parent.left===m&&(m.parent.size_left+=p,m.parent.lf_left+=u),m=m.parent}}}),define(Pe[202],ke([1,0,18,85]),function(ge,e,s,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PrefixSumIndexOfResult=e.ConstantTimePrefixSumComputer=e.PrefixSumComputer=void 0;class D{constructor(v){this.values=v,this.prefixSum=new Uint32Array(v.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}getCount(){return this.values.length}insertValues(v,l){v=(0,h.toUint32)(v);const C=this.values,_=this.prefixSum,f=l.length;return f===0?!1:(this.values=new Uint32Array(C.length+f),this.values.set(C.subarray(0,v),0),this.values.set(C.subarray(v),v+f),this.values.set(l,v),v-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=v-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(_.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}setValue(v,l){return v=(0,h.toUint32)(v),l=(0,h.toUint32)(l),this.values[v]===l?!1:(this.values[v]=l,v-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=v-1),!0)}removeValues(v,l){v=(0,h.toUint32)(v),l=(0,h.toUint32)(l);const C=this.values,_=this.prefixSum;if(v>=C.length)return!1;const f=C.length-v;return l>=f&&(l=f),l===0?!1:(this.values=new Uint32Array(C.length-l),this.values.set(C.subarray(0,v),0),this.values.set(C.subarray(v+l),v),this.prefixSum=new Uint32Array(this.values.length),v-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=v-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(_.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalSum(){return this.values.length===0?0:this._getPrefixSum(this.values.length-1)}getPrefixSum(v){return v<0?0:(v=(0,h.toUint32)(v),this._getPrefixSum(v))}_getPrefixSum(v){if(v<=this.prefixSumValidIndex[0])return this.prefixSum[v];let l=this.prefixSumValidIndex[0]+1;l===0&&(this.prefixSum[0]=this.values[0],l++),v>=this.values.length&&(v=this.values.length-1);for(let C=l;C<=v;C++)this.prefixSum[C]=this.prefixSum[C-1]+this.values[C];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],v),this.prefixSum[v]}getIndexOf(v){v=Math.floor(v),this.getTotalSum();let l=0,C=this.values.length-1,_=0,f=0,T=0;for(;l<=C;)if(_=l+(C-l)/2|0,f=this.prefixSum[_],T=f-this.values[_],v<T)C=_-1;else if(v>=f)l=_+1;else break;return new L(_,v-T)}}e.PrefixSumComputer=D;class A{constructor(v){this._values=v,this._isValid=!1,this._validEndIndex=-1,this._prefixSum=[],this._indexBySum=[]}getTotalSum(){return this._ensureValid(),this._indexBySum.length}getPrefixSum(v){return this._ensureValid(),v===0?0:this._prefixSum[v-1]}getIndexOf(v){this._ensureValid();const l=this._indexBySum[v],C=l>0?this._prefixSum[l-1]:0;return new L(l,v-C)}removeValues(v,l){this._values.splice(v,l),this._invalidate(v)}insertValues(v,l){this._values=(0,s.arrayInsert)(this._values,v,l),this._invalidate(v)}_invalidate(v){this._isValid=!1,this._validEndIndex=Math.min(this._validEndIndex,v-1)}_ensureValid(){if(!this._isValid){for(let v=this._validEndIndex+1,l=this._values.length;v<l;v++){const C=this._values[v],_=v>0?this._prefixSum[v-1]:0;this._prefixSum[v]=_+C;for(let f=0;f<C;f++)this._indexBySum[_+f]=v}this._prefixSum.length=this._values.length,this._indexBySum.length=this._prefixSum[this._prefixSum.length-1],this._isValid=!0,this._validEndIndex=this._values.length-1}}setValue(v,l){this._values[v]!==l&&(this._values[v]=l,this._invalidate(v))}}e.ConstantTimePrefixSumComputer=A;class L{constructor(v,l){this.index=v,this.remainder=l,this._prefixSumIndexOfResultBrand=void 0,this.index=v,this.remainder=l}}e.PrefixSumIndexOfResult=L}),define(Pe[203],ke([1,0,13,55,202]),function(ge,e,s,h,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirrorTextModel=void 0;class A{constructor(R,v,l,C){this._uri=R,this._lines=v,this._eol=l,this._versionId=C,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(R){R.eol&&R.eol!==this._eol&&(this._eol=R.eol,this._lineStarts=null);const v=R.changes;for(const l of v)this._acceptDeleteRange(l.range),this._acceptInsertText(new h.Position(l.range.startLineNumber,l.range.startColumn),l.text);this._versionId=R.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const R=this._eol.length,v=this._lines.length,l=new Uint32Array(v);for(let C=0;C<v;C++)l[C]=this._lines[C].length+R;this._lineStarts=new D.PrefixSumComputer(l)}}_setLineText(R,v){this._lines[R]=v,this._lineStarts&&this._lineStarts.setValue(R,this._lines[R].length+this._eol.length)}_acceptDeleteRange(R){if(R.startLineNumber===R.endLineNumber){if(R.startColumn===R.endColumn)return;this._setLineText(R.startLineNumber-1,this._lines[R.startLineNumber-1].substring(0,R.startColumn-1)+this._lines[R.startLineNumber-1].substring(R.endColumn-1));return}this._setLineText(R.startLineNumber-1,this._lines[R.startLineNumber-1].substring(0,R.startColumn-1)+this._lines[R.endLineNumber-1].substring(R.endColumn-1)),this._lines.splice(R.startLineNumber,R.endLineNumber-R.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(R.startLineNumber,R.endLineNumber-R.startLineNumber)}_acceptInsertText(R,v){if(v.length===0)return;const l=(0,s.splitLines)(v);if(l.length===1){this._setLineText(R.lineNumber-1,this._lines[R.lineNumber-1].substring(0,R.column-1)+l[0]+this._lines[R.lineNumber-1].substring(R.column-1));return}l[l.length-1]+=this._lines[R.lineNumber-1].substring(R.column-1),this._setLineText(R.lineNumber-1,this._lines[R.lineNumber-1].substring(0,R.column-1)+l[0]);const C=new Uint32Array(l.length-1);for(let _=1;_<l.length;_++)this._lines.splice(R.lineNumber+_-1,0,l[_]),C[_-1]=l[_].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(R.lineNumber,C)}}e.MirrorTextModel=A}),define(Pe[106],ke([1,0,26,13,198,55,30,56]),function(ge,e,s,h,D,A,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.TextModelSearch=e.SearchParams=void 0,e.isMultilineRegexSource=C,e.createFindMatch=_,e.isValidMatch=m,h=We(h);const v=999;class l{constructor(i,a,t,n){this.searchString=i,this.isRegex=a,this.matchCase=t,this.wordSeparators=n}parseSearchRequest(){if(this.searchString==="")return null;let i;this.isRegex?i=C(this.searchString):i=this.searchString.indexOf(`
`)>=0;let a=null;try{a=h.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:i,global:!0,unicode:!0})}catch{return null}if(!a)return null;let t=!this.isRegex&&!i;return t&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(t=this.matchCase),new R.SearchData(a,this.wordSeparators?(0,D.getMapForWordSeparators)(this.wordSeparators,[]):null,t?this.searchString:null)}}e.SearchParams=l;function C(u){if(!u||u.length===0)return!1;for(let i=0,a=u.length;i<a;i++){const t=u.charCodeAt(i);if(t===s.CharCode.LineFeed)return!0;if(t===s.CharCode.Backslash){if(i++,i>=a)break;const n=u.charCodeAt(i);if(n===s.CharCode.n||n===s.CharCode.r||n===s.CharCode.W)return!0}}return!1}function _(u,i,a){if(!a)return new R.FindMatch(u,null);const t=[];for(let n=0,r=i.length;n<r;n++)t[n]=i[n];return new R.FindMatch(u,t)}class f{constructor(i){const a=[];let t=0;for(let n=0,r=i.length;n<r;n++)i.charCodeAt(n)===s.CharCode.LineFeed&&(a[t++]=n);this._lineFeedsOffsets=a}findLineFeedCountBeforeOffset(i){const a=this._lineFeedsOffsets;let t=0,n=a.length-1;if(n===-1||i<=a[0])return 0;for(;t<n;){const r=t+((n-t)/2>>0);a[r]>=i?n=r-1:a[r+1]>=i?(t=r,n=r):t=r+1}return t+1}}class T{static findMatches(i,a,t,n,r){const d=a.parseSearchRequest();return d?d.regex.multiline?this._doFindMatchesMultiline(i,t,new p(d.wordSeparators,d.regex),n,r):this._doFindMatchesLineByLine(i,t,d,n,r):[]}static _getMultilineMatchRange(i,a,t,n,r,d){let c,g=0;n?(g=n.findLineFeedCountBeforeOffset(r),c=a+r+g):c=a+r;let w;if(n){const k=n.findLineFeedCountBeforeOffset(r+d.length)-g;w=c+d.length+k}else w=c+d.length;const y=i.getPositionAt(c),I=i.getPositionAt(w);return new L.Range(y.lineNumber,y.column,I.lineNumber,I.column)}static _doFindMatchesMultiline(i,a,t,n,r){const d=i.getOffsetAt(a.getStartPosition()),c=i.getValueInRange(a,R.EndOfLinePreference.LF),g=i.getEOL()===`\r
`?new f(c):null,w=[];let y=0,I;for(t.reset(0);I=t.next(c);)if(w[y++]=_(this._getMultilineMatchRange(i,d,c,g,I.index,I[0]),I,n),y>=r)return w;return w}static _doFindMatchesLineByLine(i,a,t,n,r){const d=[];let c=0;if(a.startLineNumber===a.endLineNumber){const w=i.getLineContent(a.startLineNumber).substring(a.startColumn-1,a.endColumn-1);return c=this._findMatchesInLine(t,w,a.startLineNumber,a.startColumn-1,c,d,n,r),d}const g=i.getLineContent(a.startLineNumber).substring(a.startColumn-1);c=this._findMatchesInLine(t,g,a.startLineNumber,a.startColumn-1,c,d,n,r);for(let w=a.startLineNumber+1;w<a.endLineNumber&&c<r;w++)c=this._findMatchesInLine(t,i.getLineContent(w),w,0,c,d,n,r);if(c<r){const w=i.getLineContent(a.endLineNumber).substring(0,a.endColumn-1);c=this._findMatchesInLine(t,w,a.endLineNumber,0,c,d,n,r)}return d}static _findMatchesInLine(i,a,t,n,r,d,c,g){const w=i.wordSeparators;if(!c&&i.simpleSearch){const P=i.simpleSearch,k=P.length,b=a.length;let E=-k;for(;(E=a.indexOf(P,E+k))!==-1;)if((!w||m(w,a,b,E,k))&&(d[r++]=new R.FindMatch(new L.Range(t,E+1+n,t,E+1+k+n),null),r>=g))return r;return r}const y=new p(i.wordSeparators,i.regex);let I;y.reset(0);do if(I=y.next(a),I&&(d[r++]=_(new L.Range(t,I.index+1+n,t,I.index+1+I[0].length+n),I,c),r>=g))return r;while(I);return r}static findNextMatch(i,a,t,n){const r=a.parseSearchRequest();if(!r)return null;const d=new p(r.wordSeparators,r.regex);return r.regex.multiline?this._doFindNextMatchMultiline(i,t,d,n):this._doFindNextMatchLineByLine(i,t,d,n)}static _doFindNextMatchMultiline(i,a,t,n){const r=new A.Position(a.lineNumber,1),d=i.getOffsetAt(r),c=i.getLineCount(),g=i.getValueInRange(new L.Range(r.lineNumber,r.column,c,i.getLineMaxColumn(c)),R.EndOfLinePreference.LF),w=i.getEOL()===`\r
`?new f(g):null;t.reset(a.column-1);const y=t.next(g);return y?_(this._getMultilineMatchRange(i,d,g,w,y.index,y[0]),y,n):a.lineNumber!==1||a.column!==1?this._doFindNextMatchMultiline(i,new A.Position(1,1),t,n):null}static _doFindNextMatchLineByLine(i,a,t,n){const r=i.getLineCount(),d=a.lineNumber,c=i.getLineContent(d),g=this._findFirstMatchInLine(t,c,d,a.column,n);if(g)return g;for(let w=1;w<=r;w++){const y=(d+w-1)%r,I=i.getLineContent(y+1),P=this._findFirstMatchInLine(t,I,y+1,1,n);if(P)return P}return null}static _findFirstMatchInLine(i,a,t,n,r){i.reset(n-1);const d=i.next(a);return d?_(new L.Range(t,d.index+1,t,d.index+1+d[0].length),d,r):null}static findPreviousMatch(i,a,t,n){const r=a.parseSearchRequest();if(!r)return null;const d=new p(r.wordSeparators,r.regex);return r.regex.multiline?this._doFindPreviousMatchMultiline(i,t,d,n):this._doFindPreviousMatchLineByLine(i,t,d,n)}static _doFindPreviousMatchMultiline(i,a,t,n){const r=this._doFindMatchesMultiline(i,new L.Range(1,1,a.lineNumber,a.column),t,n,10*v);if(r.length>0)return r[r.length-1];const d=i.getLineCount();return a.lineNumber!==d||a.column!==i.getLineMaxColumn(d)?this._doFindPreviousMatchMultiline(i,new A.Position(d,i.getLineMaxColumn(d)),t,n):null}static _doFindPreviousMatchLineByLine(i,a,t,n){const r=i.getLineCount(),d=a.lineNumber,c=i.getLineContent(d).substring(0,a.column-1),g=this._findLastMatchInLine(t,c,d,n);if(g)return g;for(let w=1;w<=r;w++){const y=(r+d-w-1)%r,I=i.getLineContent(y+1),P=this._findLastMatchInLine(t,I,y+1,n);if(P)return P}return null}static _findLastMatchInLine(i,a,t,n){let r=null,d;for(i.reset(0);d=i.next(a);)r=_(new L.Range(t,d.index+1,t,d.index+1+d[0].length),d,n);return r}}e.TextModelSearch=T;function S(u,i,a,t,n){if(t===0)return!0;const r=i.charCodeAt(t-1);if(u.get(r)!==D.WordCharacterClass.Regular||r===s.CharCode.CarriageReturn||r===s.CharCode.LineFeed)return!0;if(n>0){const d=i.charCodeAt(t);if(u.get(d)!==D.WordCharacterClass.Regular)return!0}return!1}function o(u,i,a,t,n){if(t+n===a)return!0;const r=i.charCodeAt(t+n);if(u.get(r)!==D.WordCharacterClass.Regular||r===s.CharCode.CarriageReturn||r===s.CharCode.LineFeed)return!0;if(n>0){const d=i.charCodeAt(t+n-1);if(u.get(d)!==D.WordCharacterClass.Regular)return!0}return!1}function m(u,i,a,t,n){return S(u,i,a,t,n)&&o(u,i,a,t,n)}class p{constructor(i,a){this._wordSeparators=i,this._searchRegex=a,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(i){this._searchRegex.lastIndex=i,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(i){const a=i.length;let t;do{if(this._prevMatchStartIndex+this._prevMatchLength===a||(t=this._searchRegex.exec(i),!t))return null;const n=t.index,r=t[0].length;if(n===this._prevMatchStartIndex&&r===this._prevMatchLength){if(r===0){h.getNextCodePoint(i,a,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=n,this._prevMatchLength=r,!this._wordSeparators||m(this._wordSeparators,i,a,n,r))return t}while(t);return null}}e.Searcher=p}),define(Pe[140],ke([1,0,26,55,30,56,201,106]),function(ge,e,s,h,D,A,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PieceTreeBase=e.StringBuffer=e.Piece=void 0,e.createLineStartsFast=_,e.createLineStarts=f;const v=65535;function l(u){let i;return u[u.length-1]<65536?i=new Uint16Array(u.length):i=new Uint32Array(u.length),i.set(u,0),i}class C{constructor(i,a,t,n,r){this.lineStarts=i,this.cr=a,this.lf=t,this.crlf=n,this.isBasicASCII=r}}function _(u,i=!0){const a=[0];let t=1;for(let n=0,r=u.length;n<r;n++){const d=u.charCodeAt(n);d===s.CharCode.CarriageReturn?n+1<r&&u.charCodeAt(n+1)===s.CharCode.LineFeed?(a[t++]=n+2,n++):a[t++]=n+1:d===s.CharCode.LineFeed&&(a[t++]=n+1)}return i?l(a):a}function f(u,i){u.length=0,u[0]=0;let a=1,t=0,n=0,r=0,d=!0;for(let g=0,w=i.length;g<w;g++){const y=i.charCodeAt(g);y===s.CharCode.CarriageReturn?g+1<w&&i.charCodeAt(g+1)===s.CharCode.LineFeed?(r++,u[a++]=g+2,g++):(t++,u[a++]=g+1):y===s.CharCode.LineFeed?(n++,u[a++]=g+1):d&&y!==s.CharCode.Tab&&(y<32||y>126)&&(d=!1)}const c=new C(l(u),t,n,r,d);return u.length=0,c}class T{constructor(i,a,t,n,r){this.bufferIndex=i,this.start=a,this.end=t,this.lineFeedCnt=n,this.length=r}}e.Piece=T;class S{constructor(i,a){this.buffer=i,this.lineStarts=a}}e.StringBuffer=S;class o{constructor(i,a){this._pieces=[],this._tree=i,this._BOM=a,this._index=0,i.root!==L.SENTINEL&&i.iterate(i.root,t=>(t!==L.SENTINEL&&this._pieces.push(t.piece),!0))}read(){return this._pieces.length===0?this._index===0?(this._index++,this._BOM):null:this._index>this._pieces.length-1?null:this._index===0?this._BOM+this._tree.getPieceContent(this._pieces[this._index++]):this._tree.getPieceContent(this._pieces[this._index++])}}class m{constructor(i){this._limit=i,this._cache=[]}get(i){for(let a=this._cache.length-1;a>=0;a--){const t=this._cache[a];if(t.nodeStartOffset<=i&&t.nodeStartOffset+t.node.piece.length>=i)return t}return null}get2(i){for(let a=this._cache.length-1;a>=0;a--){const t=this._cache[a];if(t.nodeStartLineNumber&&t.nodeStartLineNumber<i&&t.nodeStartLineNumber+t.node.piece.lineFeedCnt>=i)return t}return null}set(i){this._cache.length>=this._limit&&this._cache.shift(),this._cache.push(i)}validate(i){let a=!1;const t=this._cache;for(let n=0;n<t.length;n++){const r=t[n];if(r.node.parent===null||r.nodeStartOffset>=i){t[n]=null,a=!0;continue}}if(a){const n=[];for(const r of t)r!==null&&n.push(r);this._cache=n}}}class p{constructor(i,a,t){this.create(i,a,t)}create(i,a,t){this._buffers=[new S("",[0])],this._lastChangeBufferPos={line:0,column:0},this.root=L.SENTINEL,this._lineCnt=1,this._length=0,this._EOL=a,this._EOLLength=a.length,this._EOLNormalized=t;let n=null;for(let r=0,d=i.length;r<d;r++)if(i[r].buffer.length>0){i[r].lineStarts||(i[r].lineStarts=_(i[r].buffer));const c=new T(r+1,{line:0,column:0},{line:i[r].lineStarts.length-1,column:i[r].buffer.length-i[r].lineStarts[i[r].lineStarts.length-1]},i[r].lineStarts.length-1,i[r].buffer.length);this._buffers.push(i[r]),n=this.rbInsertRight(n,c)}this._searchCache=new m(1),this._lastVisitedLine={lineNumber:0,value:""},this.computeBufferMetadata()}normalizeEOL(i){const a=v,t=a-Math.floor(a/3),n=t*2;let r="",d=0;const c=[];if(this.iterate(this.root,g=>{const w=this.getNodeContent(g),y=w.length;if(d<=t||d+y<n)return r+=w,d+=y,!0;const I=r.replace(/\r\n|\r|\n/g,i);return c.push(new S(I,_(I))),r=w,d=y,!0}),d>0){const g=r.replace(/\r\n|\r|\n/g,i);c.push(new S(g,_(g)))}this.create(c,i,!0)}getEOL(){return this._EOL}setEOL(i){this._EOL=i,this._EOLLength=this._EOL.length,this.normalizeEOL(i)}createSnapshot(i){return new o(this,i)}equal(i){if(this.getLength()!==i.getLength()||this.getLineCount()!==i.getLineCount())return!1;let a=0;return this.iterate(this.root,n=>{if(n===L.SENTINEL)return!0;const r=this.getNodeContent(n),d=r.length,c=i.nodeAt(a),g=i.nodeAt(a+d),w=i.getValueInRange2(c,g);return a+=d,r===w})}getOffsetAt(i,a){let t=0,n=this.root;for(;n!==L.SENTINEL;)if(n.left!==L.SENTINEL&&n.lf_left+1>=i)n=n.left;else if(n.lf_left+n.piece.lineFeedCnt+1>=i){t+=n.size_left;const r=this.getAccumulatedValue(n,i-n.lf_left-2);return t+=r+a-1}else i-=n.lf_left+n.piece.lineFeedCnt,t+=n.size_left+n.piece.length,n=n.right;return t}getPositionAt(i){i=Math.floor(i),i=Math.max(0,i);let a=this.root,t=0;const n=i;for(;a!==L.SENTINEL;)if(a.size_left!==0&&a.size_left>=i)a=a.left;else if(a.size_left+a.piece.length>=i){const r=this.getIndexOf(a,i-a.size_left);if(t+=a.lf_left+r.index,r.index===0){const d=this.getOffsetAt(t+1,1),c=n-d;return new h.Position(t+1,c+1)}return new h.Position(t+1,r.remainder+1)}else if(i-=a.size_left+a.piece.length,t+=a.lf_left+a.piece.lineFeedCnt,a.right===L.SENTINEL){const r=this.getOffsetAt(t+1,1),d=n-i-r;return new h.Position(t+1,d+1)}else a=a.right;return new h.Position(1,1)}getValueInRange(i,a){if(i.startLineNumber===i.endLineNumber&&i.startColumn===i.endColumn)return"";const t=this.nodeAt2(i.startLineNumber,i.startColumn),n=this.nodeAt2(i.endLineNumber,i.endColumn),r=this.getValueInRange2(t,n);return a?a!==this._EOL||!this._EOLNormalized?r.replace(/\r\n|\r|\n/g,a):a===this.getEOL()&&this._EOLNormalized?r:r.replace(/\r\n|\r|\n/g,a):r}getValueInRange2(i,a){if(i.node===a.node){const c=i.node,g=this._buffers[c.piece.bufferIndex].buffer,w=this.offsetInBuffer(c.piece.bufferIndex,c.piece.start);return g.substring(w+i.remainder,w+a.remainder)}let t=i.node;const n=this._buffers[t.piece.bufferIndex].buffer,r=this.offsetInBuffer(t.piece.bufferIndex,t.piece.start);let d=n.substring(r+i.remainder,r+t.piece.length);for(t=t.next();t!==L.SENTINEL;){const c=this._buffers[t.piece.bufferIndex].buffer,g=this.offsetInBuffer(t.piece.bufferIndex,t.piece.start);if(t===a.node){d+=c.substring(g,g+a.remainder);break}else d+=c.substr(g,t.piece.length);t=t.next()}return d}getLinesContent(){const i=[];let a=0,t="",n=!1;return this.iterate(this.root,r=>{if(r===L.SENTINEL)return!0;const d=r.piece;let c=d.length;if(c===0)return!0;const g=this._buffers[d.bufferIndex].buffer,w=this._buffers[d.bufferIndex].lineStarts,y=d.start.line,I=d.end.line;let P=w[y]+d.start.column;if(n&&(g.charCodeAt(P)===s.CharCode.LineFeed&&(P++,c--),i[a++]=t,t="",n=!1,c===0))return!0;if(y===I)return!this._EOLNormalized&&g.charCodeAt(P+c-1)===s.CharCode.CarriageReturn?(n=!0,t+=g.substr(P,c-1)):t+=g.substr(P,c),!0;t+=this._EOLNormalized?g.substring(P,Math.max(P,w[y+1]-this._EOLLength)):g.substring(P,w[y+1]).replace(/(\r\n|\r|\n)$/,""),i[a++]=t;for(let k=y+1;k<I;k++)t=this._EOLNormalized?g.substring(w[k],w[k+1]-this._EOLLength):g.substring(w[k],w[k+1]).replace(/(\r\n|\r|\n)$/,""),i[a++]=t;return!this._EOLNormalized&&g.charCodeAt(w[I]+d.end.column-1)===s.CharCode.CarriageReturn?(n=!0,d.end.column===0?a--:t=g.substr(w[I],d.end.column-1)):t=g.substr(w[I],d.end.column),!0}),n&&(i[a++]=t,t=""),i[a++]=t,i}getLength(){return this._length}getLineCount(){return this._lineCnt}getLineContent(i){return this._lastVisitedLine.lineNumber===i?this._lastVisitedLine.value:(this._lastVisitedLine.lineNumber=i,i===this._lineCnt?this._lastVisitedLine.value=this.getLineRawContent(i):this._EOLNormalized?this._lastVisitedLine.value=this.getLineRawContent(i,this._EOLLength):this._lastVisitedLine.value=this.getLineRawContent(i).replace(/(\r\n|\r|\n)$/,""),this._lastVisitedLine.value)}_getCharCode(i){if(i.remainder===i.node.piece.length){const a=i.node.next();if(!a)return 0;const t=this._buffers[a.piece.bufferIndex],n=this.offsetInBuffer(a.piece.bufferIndex,a.piece.start);return t.buffer.charCodeAt(n)}else{const a=this._buffers[i.node.piece.bufferIndex],n=this.offsetInBuffer(i.node.piece.bufferIndex,i.node.piece.start)+i.remainder;return a.buffer.charCodeAt(n)}}getLineCharCode(i,a){const t=this.nodeAt2(i,a+1);return this._getCharCode(t)}getLineLength(i){if(i===this.getLineCount()){const a=this.getOffsetAt(i,1);return this.getLength()-a}return this.getOffsetAt(i+1,1)-this.getOffsetAt(i,1)-this._EOLLength}getCharCode(i){const a=this.nodeAt(i);return this._getCharCode(a)}getNearestChunk(i){const a=this.nodeAt(i);if(a.remainder===a.node.piece.length){const t=a.node.next();if(!t||t===L.SENTINEL)return"";const n=this._buffers[t.piece.bufferIndex],r=this.offsetInBuffer(t.piece.bufferIndex,t.piece.start);return n.buffer.substring(r,r+t.piece.length)}else{const t=this._buffers[a.node.piece.bufferIndex],n=this.offsetInBuffer(a.node.piece.bufferIndex,a.node.piece.start),r=n+a.remainder,d=n+a.node.piece.length;return t.buffer.substring(r,d)}}findMatchesInNode(i,a,t,n,r,d,c,g,w,y,I){const P=this._buffers[i.piece.bufferIndex],k=this.offsetInBuffer(i.piece.bufferIndex,i.piece.start),b=this.offsetInBuffer(i.piece.bufferIndex,r),E=this.offsetInBuffer(i.piece.bufferIndex,d);let N;const O={line:0,column:0};let M,U;a._wordSeparators?(M=P.buffer.substring(b,E),U=H=>H+b,a.reset(0)):(M=P.buffer,U=H=>H,a.reset(b));do if(N=a.next(M),N){if(U(N.index)>=E)return y;this.positionInBuffer(i,U(N.index)-k,O);const H=this.getLineFeedCnt(i.piece.bufferIndex,r,O),F=O.line===r.line?O.column-r.column+n:O.column+1,x=F+N[0].length;if(I[y++]=(0,R.createFindMatch)(new D.Range(t+H,F,t+H,x),N,g),U(N.index)+N[0].length>=E||y>=w)return y}while(N);return y}findMatchesLineByLine(i,a,t,n){const r=[];let d=0;const c=new R.Searcher(a.wordSeparators,a.regex);let g=this.nodeAt2(i.startLineNumber,i.startColumn);if(g===null)return[];const w=this.nodeAt2(i.endLineNumber,i.endColumn);if(w===null)return[];let y=this.positionInBuffer(g.node,g.remainder);const I=this.positionInBuffer(w.node,w.remainder);if(g.node===w.node)return this.findMatchesInNode(g.node,c,i.startLineNumber,i.startColumn,y,I,a,t,n,d,r),r;let P=i.startLineNumber,k=g.node;for(;k!==w.node;){const E=this.getLineFeedCnt(k.piece.bufferIndex,y,k.piece.end);if(E>=1){const O=this._buffers[k.piece.bufferIndex].lineStarts,M=this.offsetInBuffer(k.piece.bufferIndex,k.piece.start),U=O[y.line+E],H=P===i.startLineNumber?i.startColumn:1;if(d=this.findMatchesInNode(k,c,P,H,y,this.positionInBuffer(k,U-M),a,t,n,d,r),d>=n)return r;P+=E}const N=P===i.startLineNumber?i.startColumn-1:0;if(P===i.endLineNumber){const O=this.getLineContent(P).substring(N,i.endColumn-1);return d=this._findMatchesInLine(a,c,O,i.endLineNumber,N,d,r,t,n),r}if(d=this._findMatchesInLine(a,c,this.getLineContent(P).substr(N),P,N,d,r,t,n),d>=n)return r;P++,g=this.nodeAt2(P,1),k=g.node,y=this.positionInBuffer(g.node,g.remainder)}if(P===i.endLineNumber){const E=P===i.startLineNumber?i.startColumn-1:0,N=this.getLineContent(P).substring(E,i.endColumn-1);return d=this._findMatchesInLine(a,c,N,i.endLineNumber,E,d,r,t,n),r}const b=P===i.startLineNumber?i.startColumn:1;return d=this.findMatchesInNode(w.node,c,P,b,y,I,a,t,n,d,r),r}_findMatchesInLine(i,a,t,n,r,d,c,g,w){const y=i.wordSeparators;if(!g&&i.simpleSearch){const P=i.simpleSearch,k=P.length,b=t.length;let E=-k;for(;(E=t.indexOf(P,E+k))!==-1;)if((!y||(0,R.isValidMatch)(y,t,b,E,k))&&(c[d++]=new A.FindMatch(new D.Range(n,E+1+r,n,E+1+k+r),null),d>=w))return d;return d}let I;a.reset(0);do if(I=a.next(t),I&&(c[d++]=(0,R.createFindMatch)(new D.Range(n,I.index+1+r,n,I.index+1+I[0].length+r),I,g),d>=w))return d;while(I);return d}insert(i,a,t=!1){if(this._EOLNormalized=this._EOLNormalized&&t,this._lastVisitedLine.lineNumber=0,this._lastVisitedLine.value="",this.root!==L.SENTINEL){const{node:n,remainder:r,nodeStartOffset:d}=this.nodeAt(i),c=n.piece,g=c.bufferIndex,w=this.positionInBuffer(n,r);if(n.piece.bufferIndex===0&&c.end.line===this._lastChangeBufferPos.line&&c.end.column===this._lastChangeBufferPos.column&&d+c.length===i&&a.length<v){this.appendToNode(n,a),this.computeBufferMetadata();return}if(d===i)this.insertContentToNodeLeft(a,n),this._searchCache.validate(i);else if(d+n.piece.length>i){const y=[];let I=new T(c.bufferIndex,w,c.end,this.getLineFeedCnt(c.bufferIndex,w,c.end),this.offsetInBuffer(g,c.end)-this.offsetInBuffer(g,w));if(this.shouldCheckCRLF()&&this.endWithCR(a)&&this.nodeCharCodeAt(n,r)===10){const E={line:I.start.line+1,column:0};I=new T(I.bufferIndex,E,I.end,this.getLineFeedCnt(I.bufferIndex,E,I.end),I.length-1),a+=`
`}if(this.shouldCheckCRLF()&&this.startWithLF(a))if(this.nodeCharCodeAt(n,r-1)===13){const E=this.positionInBuffer(n,r-1);this.deleteNodeTail(n,E),a="\r"+a,n.piece.length===0&&y.push(n)}else this.deleteNodeTail(n,w);else this.deleteNodeTail(n,w);const P=this.createNewPieces(a);I.length>0&&this.rbInsertRight(n,I);let k=n;for(let b=0;b<P.length;b++)k=this.rbInsertRight(k,P[b]);this.deleteNodes(y)}else this.insertContentToNodeRight(a,n)}else{const n=this.createNewPieces(a);let r=this.rbInsertLeft(null,n[0]);for(let d=1;d<n.length;d++)r=this.rbInsertRight(r,n[d])}this.computeBufferMetadata()}delete(i,a){if(this._lastVisitedLine.lineNumber=0,this._lastVisitedLine.value="",a<=0||this.root===L.SENTINEL)return;const t=this.nodeAt(i),n=this.nodeAt(i+a),r=t.node,d=n.node;if(r===d){const P=this.positionInBuffer(r,t.remainder),k=this.positionInBuffer(r,n.remainder);if(t.nodeStartOffset===i){if(a===r.piece.length){const b=r.next();(0,L.rbDelete)(this,r),this.validateCRLFWithPrevNode(b),this.computeBufferMetadata();return}this.deleteNodeHead(r,k),this._searchCache.validate(i),this.validateCRLFWithPrevNode(r),this.computeBufferMetadata();return}if(t.nodeStartOffset+r.piece.length===i+a){this.deleteNodeTail(r,P),this.validateCRLFWithNextNode(r),this.computeBufferMetadata();return}this.shrinkNode(r,P,k),this.computeBufferMetadata();return}const c=[],g=this.positionInBuffer(r,t.remainder);this.deleteNodeTail(r,g),this._searchCache.validate(i),r.piece.length===0&&c.push(r);const w=this.positionInBuffer(d,n.remainder);this.deleteNodeHead(d,w),d.piece.length===0&&c.push(d);const y=r.next();for(let P=y;P!==L.SENTINEL&&P!==d;P=P.next())c.push(P);const I=r.piece.length===0?r.prev():r;this.deleteNodes(c),this.validateCRLFWithNextNode(I),this.computeBufferMetadata()}insertContentToNodeLeft(i,a){const t=[];if(this.shouldCheckCRLF()&&this.endWithCR(i)&&this.startWithLF(a)){const d=a.piece,c={line:d.start.line+1,column:0},g=new T(d.bufferIndex,c,d.end,this.getLineFeedCnt(d.bufferIndex,c,d.end),d.length-1);a.piece=g,i+=`
`,(0,L.updateTreeMetadata)(this,a,-1,-1),a.piece.length===0&&t.push(a)}const n=this.createNewPieces(i);let r=this.rbInsertLeft(a,n[n.length-1]);for(let d=n.length-2;d>=0;d--)r=this.rbInsertLeft(r,n[d]);this.validateCRLFWithPrevNode(r),this.deleteNodes(t)}insertContentToNodeRight(i,a){this.adjustCarriageReturnFromNext(i,a)&&(i+=`
`);const t=this.createNewPieces(i),n=this.rbInsertRight(a,t[0]);let r=n;for(let d=1;d<t.length;d++)r=this.rbInsertRight(r,t[d]);this.validateCRLFWithPrevNode(n)}positionInBuffer(i,a,t){const n=i.piece,r=i.piece.bufferIndex,d=this._buffers[r].lineStarts,g=d[n.start.line]+n.start.column+a;let w=n.start.line,y=n.end.line,I=0,P=0,k=0;for(;w<=y&&(I=w+(y-w)/2|0,k=d[I],I!==y);)if(P=d[I+1],g<k)y=I-1;else if(g>=P)w=I+1;else break;return t?(t.line=I,t.column=g-k,null):{line:I,column:g-k}}getLineFeedCnt(i,a,t){if(t.column===0)return t.line-a.line;const n=this._buffers[i].lineStarts;if(t.line===n.length-1)return t.line-a.line;const r=n[t.line+1],d=n[t.line]+t.column;if(r>d+1)return t.line-a.line;const c=d-1;return this._buffers[i].buffer.charCodeAt(c)===13?t.line-a.line+1:t.line-a.line}offsetInBuffer(i,a){return this._buffers[i].lineStarts[a.line]+a.column}deleteNodes(i){for(let a=0;a<i.length;a++)(0,L.rbDelete)(this,i[a])}createNewPieces(i){if(i.length>v){const y=[];for(;i.length>v;){const P=i.charCodeAt(v-1);let k;P===s.CharCode.CarriageReturn||P>=55296&&P<=56319?(k=i.substring(0,v-1),i=i.substring(v-1)):(k=i.substring(0,v),i=i.substring(v));const b=_(k);y.push(new T(this._buffers.length,{line:0,column:0},{line:b.length-1,column:k.length-b[b.length-1]},b.length-1,k.length)),this._buffers.push(new S(k,b))}const I=_(i);return y.push(new T(this._buffers.length,{line:0,column:0},{line:I.length-1,column:i.length-I[I.length-1]},I.length-1,i.length)),this._buffers.push(new S(i,I)),y}let a=this._buffers[0].buffer.length;const t=_(i,!1);let n=this._lastChangeBufferPos;if(this._buffers[0].lineStarts[this._buffers[0].lineStarts.length-1]===a&&a!==0&&this.startWithLF(i)&&this.endWithCR(this._buffers[0].buffer)){this._lastChangeBufferPos={line:this._lastChangeBufferPos.line,column:this._lastChangeBufferPos.column+1},n=this._lastChangeBufferPos;for(let y=0;y<t.length;y++)t[y]+=a+1;this._buffers[0].lineStarts=this._buffers[0].lineStarts.concat(t.slice(1)),this._buffers[0].buffer+="_"+i,a+=1}else{if(a!==0)for(let y=0;y<t.length;y++)t[y]+=a;this._buffers[0].lineStarts=this._buffers[0].lineStarts.concat(t.slice(1)),this._buffers[0].buffer+=i}const r=this._buffers[0].buffer.length,d=this._buffers[0].lineStarts.length-1,c=r-this._buffers[0].lineStarts[d],g={line:d,column:c},w=new T(0,n,g,this.getLineFeedCnt(0,n,g),r-a);return this._lastChangeBufferPos=g,[w]}getLinesRawContent(){return this.getContentOfSubTree(this.root)}getLineRawContent(i,a=0){let t=this.root,n="";const r=this._searchCache.get2(i);if(r){t=r.node;const d=this.getAccumulatedValue(t,i-r.nodeStartLineNumber-1),c=this._buffers[t.piece.bufferIndex].buffer,g=this.offsetInBuffer(t.piece.bufferIndex,t.piece.start);if(r.nodeStartLineNumber+t.piece.lineFeedCnt===i)n=c.substring(g+d,g+t.piece.length);else{const w=this.getAccumulatedValue(t,i-r.nodeStartLineNumber);return c.substring(g+d,g+w-a)}}else{let d=0;const c=i;for(;t!==L.SENTINEL;)if(t.left!==L.SENTINEL&&t.lf_left>=i-1)t=t.left;else if(t.lf_left+t.piece.lineFeedCnt>i-1){const g=this.getAccumulatedValue(t,i-t.lf_left-2),w=this.getAccumulatedValue(t,i-t.lf_left-1),y=this._buffers[t.piece.bufferIndex].buffer,I=this.offsetInBuffer(t.piece.bufferIndex,t.piece.start);return d+=t.size_left,this._searchCache.set({node:t,nodeStartOffset:d,nodeStartLineNumber:c-(i-1-t.lf_left)}),y.substring(I+g,I+w-a)}else if(t.lf_left+t.piece.lineFeedCnt===i-1){const g=this.getAccumulatedValue(t,i-t.lf_left-2),w=this._buffers[t.piece.bufferIndex].buffer,y=this.offsetInBuffer(t.piece.bufferIndex,t.piece.start);n=w.substring(y+g,y+t.piece.length);break}else i-=t.lf_left+t.piece.lineFeedCnt,d+=t.size_left+t.piece.length,t=t.right}for(t=t.next();t!==L.SENTINEL;){const d=this._buffers[t.piece.bufferIndex].buffer;if(t.piece.lineFeedCnt>0){const c=this.getAccumulatedValue(t,0),g=this.offsetInBuffer(t.piece.bufferIndex,t.piece.start);return n+=d.substring(g,g+c-a),n}else{const c=this.offsetInBuffer(t.piece.bufferIndex,t.piece.start);n+=d.substr(c,t.piece.length)}t=t.next()}return n}computeBufferMetadata(){let i=this.root,a=1,t=0;for(;i!==L.SENTINEL;)a+=i.lf_left+i.piece.lineFeedCnt,t+=i.size_left+i.piece.length,i=i.right;this._lineCnt=a,this._length=t,this._searchCache.validate(this._length)}getIndexOf(i,a){const t=i.piece,n=this.positionInBuffer(i,a),r=n.line-t.start.line;if(this.offsetInBuffer(t.bufferIndex,t.end)-this.offsetInBuffer(t.bufferIndex,t.start)===a){const d=this.getLineFeedCnt(i.piece.bufferIndex,t.start,n);if(d!==r)return{index:d,remainder:0}}return{index:r,remainder:n.column}}getAccumulatedValue(i,a){if(a<0)return 0;const t=i.piece,n=this._buffers[t.bufferIndex].lineStarts,r=t.start.line+a+1;return r>t.end.line?n[t.end.line]+t.end.column-n[t.start.line]-t.start.column:n[r]-n[t.start.line]-t.start.column}deleteNodeTail(i,a){const t=i.piece,n=t.lineFeedCnt,r=this.offsetInBuffer(t.bufferIndex,t.end),d=a,c=this.offsetInBuffer(t.bufferIndex,d),g=this.getLineFeedCnt(t.bufferIndex,t.start,d),w=g-n,y=c-r,I=t.length+y;i.piece=new T(t.bufferIndex,t.start,d,g,I),(0,L.updateTreeMetadata)(this,i,y,w)}deleteNodeHead(i,a){const t=i.piece,n=t.lineFeedCnt,r=this.offsetInBuffer(t.bufferIndex,t.start),d=a,c=this.getLineFeedCnt(t.bufferIndex,d,t.end),g=this.offsetInBuffer(t.bufferIndex,d),w=c-n,y=r-g,I=t.length+y;i.piece=new T(t.bufferIndex,d,t.end,c,I),(0,L.updateTreeMetadata)(this,i,y,w)}shrinkNode(i,a,t){const n=i.piece,r=n.start,d=n.end,c=n.length,g=n.lineFeedCnt,w=a,y=this.getLineFeedCnt(n.bufferIndex,n.start,w),I=this.offsetInBuffer(n.bufferIndex,a)-this.offsetInBuffer(n.bufferIndex,r);i.piece=new T(n.bufferIndex,n.start,w,y,I),(0,L.updateTreeMetadata)(this,i,I-c,y-g);const P=new T(n.bufferIndex,t,d,this.getLineFeedCnt(n.bufferIndex,t,d),this.offsetInBuffer(n.bufferIndex,d)-this.offsetInBuffer(n.bufferIndex,t)),k=this.rbInsertRight(i,P);this.validateCRLFWithPrevNode(k)}appendToNode(i,a){this.adjustCarriageReturnFromNext(a,i)&&(a+=`
`);const t=this.shouldCheckCRLF()&&this.startWithLF(a)&&this.endWithCR(i),n=this._buffers[0].buffer.length;this._buffers[0].buffer+=a;const r=_(a,!1);for(let k=0;k<r.length;k++)r[k]+=n;if(t){const k=this._buffers[0].lineStarts[this._buffers[0].lineStarts.length-2];this._buffers[0].lineStarts.pop(),this._lastChangeBufferPos={line:this._lastChangeBufferPos.line-1,column:n-k}}this._buffers[0].lineStarts=this._buffers[0].lineStarts.concat(r.slice(1));const d=this._buffers[0].lineStarts.length-1,c=this._buffers[0].buffer.length-this._buffers[0].lineStarts[d],g={line:d,column:c},w=i.piece.length+a.length,y=i.piece.lineFeedCnt,I=this.getLineFeedCnt(0,i.piece.start,g),P=I-y;i.piece=new T(i.piece.bufferIndex,i.piece.start,g,I,w),this._lastChangeBufferPos=g,(0,L.updateTreeMetadata)(this,i,a.length,P)}nodeAt(i){let a=this.root;const t=this._searchCache.get(i);if(t)return{node:t.node,nodeStartOffset:t.nodeStartOffset,remainder:i-t.nodeStartOffset};let n=0;for(;a!==L.SENTINEL;)if(a.size_left>i)a=a.left;else if(a.size_left+a.piece.length>=i){n+=a.size_left;const r={node:a,remainder:i-a.size_left,nodeStartOffset:n};return this._searchCache.set(r),r}else i-=a.size_left+a.piece.length,n+=a.size_left+a.piece.length,a=a.right;return null}nodeAt2(i,a){let t=this.root,n=0;for(;t!==L.SENTINEL;)if(t.left!==L.SENTINEL&&t.lf_left>=i-1)t=t.left;else if(t.lf_left+t.piece.lineFeedCnt>i-1){const r=this.getAccumulatedValue(t,i-t.lf_left-2),d=this.getAccumulatedValue(t,i-t.lf_left-1);return n+=t.size_left,{node:t,remainder:Math.min(r+a-1,d),nodeStartOffset:n}}else if(t.lf_left+t.piece.lineFeedCnt===i-1){const r=this.getAccumulatedValue(t,i-t.lf_left-2);if(r+a-1<=t.piece.length)return{node:t,remainder:r+a-1,nodeStartOffset:n};a-=t.piece.length-r;break}else i-=t.lf_left+t.piece.lineFeedCnt,n+=t.size_left+t.piece.length,t=t.right;for(t=t.next();t!==L.SENTINEL;){if(t.piece.lineFeedCnt>0){const r=this.getAccumulatedValue(t,0),d=this.offsetOfNode(t);return{node:t,remainder:Math.min(a-1,r),nodeStartOffset:d}}else if(t.piece.length>=a-1){const r=this.offsetOfNode(t);return{node:t,remainder:a-1,nodeStartOffset:r}}else a-=t.piece.length;t=t.next()}return null}nodeCharCodeAt(i,a){if(i.piece.lineFeedCnt<1)return-1;const t=this._buffers[i.piece.bufferIndex],n=this.offsetInBuffer(i.piece.bufferIndex,i.piece.start)+a;return t.buffer.charCodeAt(n)}offsetOfNode(i){if(!i)return 0;let a=i.size_left;for(;i!==this.root;)i.parent.right===i&&(a+=i.parent.size_left+i.parent.piece.length),i=i.parent;return a}shouldCheckCRLF(){return!(this._EOLNormalized&&this._EOL===`
`)}startWithLF(i){if(typeof i=="string")return i.charCodeAt(0)===10;if(i===L.SENTINEL||i.piece.lineFeedCnt===0)return!1;const a=i.piece,t=this._buffers[a.bufferIndex].lineStarts,n=a.start.line,r=t[n]+a.start.column;return n===t.length-1||t[n+1]>r+1?!1:this._buffers[a.bufferIndex].buffer.charCodeAt(r)===10}endWithCR(i){return typeof i=="string"?i.charCodeAt(i.length-1)===13:i===L.SENTINEL||i.piece.lineFeedCnt===0?!1:this.nodeCharCodeAt(i,i.piece.length-1)===13}validateCRLFWithPrevNode(i){if(this.shouldCheckCRLF()&&this.startWithLF(i)){const a=i.prev();this.endWithCR(a)&&this.fixCRLF(a,i)}}validateCRLFWithNextNode(i){if(this.shouldCheckCRLF()&&this.endWithCR(i)){const a=i.next();this.startWithLF(a)&&this.fixCRLF(i,a)}}fixCRLF(i,a){const t=[],n=this._buffers[i.piece.bufferIndex].lineStarts;let r;i.piece.end.column===0?r={line:i.piece.end.line-1,column:n[i.piece.end.line]-n[i.piece.end.line-1]-1}:r={line:i.piece.end.line,column:i.piece.end.column-1};const d=i.piece.length-1,c=i.piece.lineFeedCnt-1;i.piece=new T(i.piece.bufferIndex,i.piece.start,r,c,d),(0,L.updateTreeMetadata)(this,i,-1,-1),i.piece.length===0&&t.push(i);const g={line:a.piece.start.line+1,column:0},w=a.piece.length-1,y=this.getLineFeedCnt(a.piece.bufferIndex,g,a.piece.end);a.piece=new T(a.piece.bufferIndex,g,a.piece.end,y,w),(0,L.updateTreeMetadata)(this,a,-1,-1),a.piece.length===0&&t.push(a);const I=this.createNewPieces(`\r
`);this.rbInsertRight(i,I[0]);for(let P=0;P<t.length;P++)(0,L.rbDelete)(this,t[P])}adjustCarriageReturnFromNext(i,a){if(this.shouldCheckCRLF()&&this.endWithCR(i)){const t=a.next();if(this.startWithLF(t)){if(i+=`
`,t.piece.length===1)(0,L.rbDelete)(this,t);else{const n=t.piece,r={line:n.start.line+1,column:0},d=n.length-1,c=this.getLineFeedCnt(n.bufferIndex,r,n.end);t.piece=new T(n.bufferIndex,r,n.end,c,d),(0,L.updateTreeMetadata)(this,t,-1,-1)}return!0}}return!1}iterate(i,a){if(i===L.SENTINEL)return a(L.SENTINEL);const t=this.iterate(i.left,a);return t&&a(i)&&this.iterate(i.right,a)}getNodeContent(i){if(i===L.SENTINEL)return"";const a=this._buffers[i.piece.bufferIndex],t=i.piece,n=this.offsetInBuffer(t.bufferIndex,t.start),r=this.offsetInBuffer(t.bufferIndex,t.end);return a.buffer.substring(n,r)}getPieceContent(i){const a=this._buffers[i.bufferIndex],t=this.offsetInBuffer(i.bufferIndex,i.start),n=this.offsetInBuffer(i.bufferIndex,i.end);return a.buffer.substring(t,n)}rbInsertRight(i,a){const t=new L.TreeNode(a,L.NodeColor.Red);if(t.left=L.SENTINEL,t.right=L.SENTINEL,t.parent=L.SENTINEL,t.size_left=0,t.lf_left=0,this.root===L.SENTINEL)this.root=t,t.color=L.NodeColor.Black;else if(i.right===L.SENTINEL)i.right=t,t.parent=i;else{const r=(0,L.leftest)(i.right);r.left=t,t.parent=r}return(0,L.fixInsert)(this,t),t}rbInsertLeft(i,a){const t=new L.TreeNode(a,L.NodeColor.Red);if(t.left=L.SENTINEL,t.right=L.SENTINEL,t.parent=L.SENTINEL,t.size_left=0,t.lf_left=0,this.root===L.SENTINEL)this.root=t,t.color=L.NodeColor.Black;else if(i.left===L.SENTINEL)i.left=t,t.parent=i;else{const n=(0,L.righttest)(i.left);n.right=t,t.parent=n}return(0,L.fixInsert)(this,t),t}getContentOfSubTree(i){let a="";return this.iterate(i,t=>(a+=this.getNodeContent(t),!0)),a}}e.PieceTreeBase=p}),define(Pe[204],ke([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DraggedTreeItemsIdentifier=e.TreeViewsDnDService=void 0;class s{constructor(){this._dragOperations=new Map}removeDragOperationTransfer(A){if(A&&this._dragOperations.has(A)){const L=this._dragOperations.get(A);return this._dragOperations.delete(A),L}}addDragOperationTransfer(A,L){this._dragOperations.set(A,L)}}e.TreeViewsDnDService=s;class h{constructor(A){this.identifier=A}}e.DraggedTreeItemsIdentifier=h}),define(Pe[205],ke([1,0,4,3,105]),function(ge,e,s,h,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistry=void 0;class A{constructor(){this._tokenizationSupports=new Map,this._factories=new Map,this._onDidChange=new s.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}handleChange(v){this._onDidChange.fire({changedLanguages:v,changedColorMap:!1})}register(v,l){return this._tokenizationSupports.set(v,l),this.handleChange([v]),(0,h.toDisposable)(()=>{this._tokenizationSupports.get(v)===l&&(this._tokenizationSupports.delete(v),this.handleChange([v]))})}get(v){return this._tokenizationSupports.get(v)||null}registerFactory(v,l){this._factories.get(v)?.dispose();const C=new L(this,v,l);return this._factories.set(v,C),(0,h.toDisposable)(()=>{const _=this._factories.get(v);!_||_!==C||(this._factories.delete(v),_.dispose())})}async getOrCreate(v){const l=this.get(v);if(l)return l;const C=this._factories.get(v);return!C||C.isResolved?null:(await C.resolve(),this.get(v))}isResolved(v){if(this.get(v))return!0;const C=this._factories.get(v);return!!(!C||C.isResolved)}setColorMap(v){this._colorMap=v,this._onDidChange.fire({changedLanguages:Array.from(this._tokenizationSupports.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>D.ColorId.DefaultBackground?this._colorMap[D.ColorId.DefaultBackground]:null}}e.TokenizationRegistry=A;class L extends h.Disposable{get isResolved(){return this._isResolved}constructor(v,l,C){super(),this._registry=v,this._languageId=l,this._factory=C,this._isDisposed=!1,this._resolvePromise=null,this._isResolved=!1}dispose(){this._isDisposed=!0,super.dispose()}async resolve(){return this._resolvePromise||(this._resolvePromise=this._create()),this._resolvePromise}async _create(){const v=await this._factory.tokenizationSupport;this._isResolved=!0,v&&!this._isDisposed&&this._register(this._registry.register(this._languageId,v))}}}),define(Pe[141],ke([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNLSMessages=s,e.getNLSLanguage=h;function s(){return globalThis._VSCODE_NLS_MESSAGES}function h(){return globalThis._VSCODE_NLS_LANGUAGE}}),define(Pe[7],ke([1,0,141,141]),function(ge,e,s,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNLSMessages=e.getNLSLanguage=void 0,e.localize=L,e.localize2=v,Object.defineProperty(e,"getNLSLanguage",{enumerable:!0,get:function(){return h.getNLSLanguage}}),Object.defineProperty(e,"getNLSMessages",{enumerable:!0,get:function(){return h.getNLSMessages}});const D=(0,s.getNLSLanguage)()==="pseudo"||typeof document<"u"&&document.location&&document.location.hash.indexOf("pseudo=true")>=0;function A(l,C){let _;return C.length===0?_=l:_=l.replace(/\{(\d+)\}/g,(f,T)=>{const S=T[0],o=C[S];let m=f;return typeof o=="string"?m=o:(typeof o=="number"||typeof o=="boolean"||o===void 0||o===null)&&(m=String(o)),m}),D&&(_="\uFF3B"+_.replace(/[aouei]/g,"$&$&")+"\uFF3D"),_}function L(l,C,..._){return A(typeof l=="number"?R(l,C):C,_)}function R(l,C){const _=(0,s.getNLSMessages)()?.[l];if(typeof _!="string"){if(typeof C=="string")return C;throw new Error(`!!! NLS MISSING: ${l} !!!`)}return _}function v(l,C,..._){let f;typeof l=="number"?f=R(l,C):f=C;const T=A(f,_);return{value:T,original:C===f?T:A(C,_)}}}),define(Pe[206],ke([1,0,4,3,7]),function(ge,e,s,h,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EmptySubmenuAction=e.SubmenuAction=e.Separator=e.ActionRunner=e.Action=void 0,e.toAction=C,D=We(D);class A extends h.Disposable{constructor(f,T="",S="",o=!0,m){super(),this._onDidChange=this._register(new s.Emitter),this.onDidChange=this._onDidChange.event,this._enabled=!0,this._id=f,this._label=T,this._cssClass=S,this._enabled=o,this._actionCallback=m}get id(){return this._id}get label(){return this._label}set label(f){this._setLabel(f)}_setLabel(f){this._label!==f&&(this._label=f,this._onDidChange.fire({label:f}))}get tooltip(){return this._tooltip||""}set tooltip(f){this._setTooltip(f)}_setTooltip(f){this._tooltip!==f&&(this._tooltip=f,this._onDidChange.fire({tooltip:f}))}get class(){return this._cssClass}set class(f){this._setClass(f)}_setClass(f){this._cssClass!==f&&(this._cssClass=f,this._onDidChange.fire({class:f}))}get enabled(){return this._enabled}set enabled(f){this._setEnabled(f)}_setEnabled(f){this._enabled!==f&&(this._enabled=f,this._onDidChange.fire({enabled:f}))}get checked(){return this._checked}set checked(f){this._setChecked(f)}_setChecked(f){this._checked!==f&&(this._checked=f,this._onDidChange.fire({checked:f}))}async run(f,T){this._actionCallback&&await this._actionCallback(f)}}e.Action=A;class L extends h.Disposable{constructor(){super(...arguments),this._onWillRun=this._register(new s.Emitter),this.onWillRun=this._onWillRun.event,this._onDidRun=this._register(new s.Emitter),this.onDidRun=this._onDidRun.event}async run(f,T){if(!f.enabled)return;this._onWillRun.fire({action:f});let S;try{await this.runAction(f,T)}catch(o){S=o}this._onDidRun.fire({action:f,error:S})}async runAction(f,T){await f.run(T)}}e.ActionRunner=L;class R{constructor(){this.id=R.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...f){let T=[];for(const S of f)S.length&&(T.length?T=[...T,new R,...S]:T=S);return T}static{this.ID="vs.actions.separator"}async run(){}}e.Separator=R;class v{get actions(){return this._actions}constructor(f,T,S,o){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=f,this.label=T,this.class=o,this._actions=S}async run(){}}e.SubmenuAction=v;class l extends A{static{this.ID="vs.actions.empty"}constructor(){super(l.ID,D.localize(41,null),void 0,!1)}}e.EmptySubmenuAction=l;function C(_){return{id:_.id,label:_.label,tooltip:_.tooltip??_.label,class:_.class,enabled:_.enabled??!0,checked:_.checked,run:async(...f)=>_.run(...f)}}}),define(Pe[207],ke([1,0,7]),function(ge,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fromNow=l,e.fromNowByDay=C,e.getDurationString=_,e.toLocalISOString=f;const h=60,D=h*60,A=D*24,L=A*7,R=A*30,v=A*365;function l(T,S,o,m){typeof T!="number"&&(T=T.getTime());const p=Math.round((new Date().getTime()-T)/1e3);if(p<-30)return(0,s.localize)(42,null,l(new Date().getTime()+p*1e3,!1));if(!m&&p<30)return(0,s.localize)(43,null);let u;return p<h?(u=p,S?u===1?o?(0,s.localize)(44,null,u):(0,s.localize)(45,null,u):o?(0,s.localize)(46,null,u):(0,s.localize)(47,null,u):u===1?o?(0,s.localize)(48,null,u):(0,s.localize)(49,null,u):o?(0,s.localize)(50,null,u):(0,s.localize)(51,null,u)):p<D?(u=Math.floor(p/h),S?u===1?o?(0,s.localize)(52,null,u):(0,s.localize)(53,null,u):o?(0,s.localize)(54,null,u):(0,s.localize)(55,null,u):u===1?o?(0,s.localize)(56,null,u):(0,s.localize)(57,null,u):o?(0,s.localize)(58,null,u):(0,s.localize)(59,null,u)):p<A?(u=Math.floor(p/D),S?u===1?o?(0,s.localize)(60,null,u):(0,s.localize)(61,null,u):o?(0,s.localize)(62,null,u):(0,s.localize)(63,null,u):u===1?o?(0,s.localize)(64,null,u):(0,s.localize)(65,null,u):o?(0,s.localize)(66,null,u):(0,s.localize)(67,null,u)):p<L?(u=Math.floor(p/A),S?u===1?(0,s.localize)(68,null,u):(0,s.localize)(69,null,u):u===1?(0,s.localize)(70,null,u):(0,s.localize)(71,null,u)):p<R?(u=Math.floor(p/L),S?u===1?o?(0,s.localize)(72,null,u):(0,s.localize)(73,null,u):o?(0,s.localize)(74,null,u):(0,s.localize)(75,null,u):u===1?o?(0,s.localize)(76,null,u):(0,s.localize)(77,null,u):o?(0,s.localize)(78,null,u):(0,s.localize)(79,null,u)):p<v?(u=Math.floor(p/R),S?u===1?o?(0,s.localize)(80,null,u):(0,s.localize)(81,null,u):o?(0,s.localize)(82,null,u):(0,s.localize)(83,null,u):u===1?o?(0,s.localize)(84,null,u):(0,s.localize)(85,null,u):o?(0,s.localize)(86,null,u):(0,s.localize)(87,null,u)):(u=Math.floor(p/v),S?u===1?o?(0,s.localize)(88,null,u):(0,s.localize)(89,null,u):o?(0,s.localize)(90,null,u):(0,s.localize)(91,null,u):u===1?o?(0,s.localize)(92,null,u):(0,s.localize)(93,null,u):o?(0,s.localize)(94,null,u):(0,s.localize)(95,null,u))}function C(T,S,o){typeof T!="number"&&(T=T.getTime());const m=new Date;m.setHours(0,0,0,0);const p=new Date(m.getTime());return p.setDate(p.getDate()-1),T>m.getTime()?(0,s.localize)(96,null):T>p.getTime()?(0,s.localize)(97,null):l(T,S,o)}function _(T,S){const o=Math.abs(T/1e3);return o<1?S?(0,s.localize)(98,null,T):(0,s.localize)(99,null,T):o<h?S?(0,s.localize)(100,null,Math.round(T)/1e3):(0,s.localize)(101,null,Math.round(T)/1e3):o<D?S?(0,s.localize)(102,null,Math.round(T/(1e3*h))):(0,s.localize)(103,null,Math.round(T/(1e3*h))):o<A?S?(0,s.localize)(104,null,Math.round(T/(1e3*D))):(0,s.localize)(105,null,Math.round(T/(1e3*D))):(0,s.localize)(106,null,Math.round(T/(1e3*A)))}function f(T){return T.getFullYear()+"-"+String(T.getMonth()+1).padStart(2,"0")+"-"+String(T.getDate()).padStart(2,"0")+"T"+String(T.getHours()).padStart(2,"0")+":"+String(T.getMinutes()).padStart(2,"0")+":"+String(T.getSeconds()).padStart(2,"0")+"."+(T.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(Pe[52],ke([1,0,18,17,7]),function(ge,e,s,h,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=v,e.isErrorWithActions=l,e.createErrorWithActions=C,s=We(s),h=We(h),D=We(D);function A(_,f){return f&&(_.stack||_.stacktrace)?D.localize(107,null,R(_),L(_.stack)||L(_.stacktrace)):R(_)}function L(_){return Array.isArray(_)?_.join(`
`):_}function R(_){return _.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${_.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof _.code=="string"&&typeof _.errno=="number"&&typeof _.syscall=="string"?D.localize(108,null,_.message):_.message||D.localize(109,null)}function v(_=null,f=!1){if(!_)return D.localize(110,null);if(Array.isArray(_)){const T=s.coalesce(_),S=v(T[0],f);return T.length>1?D.localize(111,null,S,T.length):S}if(h.isString(_))return _;if(_.detail){const T=_.detail;if(T.error)return A(T.error,f);if(T.exception)return A(T.exception,f)}return _.stack?A(_,f):_.message?_.message:D.localize(112,null)}function l(_){const f=_;return f instanceof Error&&Array.isArray(f.actions)}function C(_,f){let T;return typeof _=="string"?T=new Error(_):T=_,T.actions=f,T}}),define(Pe[10],ke([1,0,7]),function(ge,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.platformLocale=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isMobile=e.isIOS=e.webWorkerOrigin=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.Platform=e.LANGUAGE_DEFAULT=void 0,e.PlatformToString=r,e.isLittleEndian=I,e.isBigSurOrNewer=P,s=We(s),e.LANGUAGE_DEFAULT="en";let h=!1,D=!1,A=!1,L=!1,R=!1,v=!1,l=!1,C=!1,_=!1,f=!1,T,S=e.LANGUAGE_DEFAULT,o=e.LANGUAGE_DEFAULT,m,p;const u=globalThis;let i;typeof u.vscode<"u"&&typeof u.vscode.process<"u"?i=u.vscode.process:typeof process<"u"&&typeof process?.versions?.node=="string"&&(i=process);const a=typeof i?.versions?.electron=="string",t=a&&i?.type==="renderer";if(typeof i=="object"){h=i.platform==="win32",D=i.platform==="darwin",A=i.platform==="linux",L=A&&!!i.env.SNAP&&!!i.env.SNAP_REVISION,l=a,_=!!i.env.CI||!!i.env.BUILD_ARTIFACTSTAGINGDIRECTORY,T=e.LANGUAGE_DEFAULT,S=e.LANGUAGE_DEFAULT;const k=i.env.VSCODE_NLS_CONFIG;if(k)try{const b=JSON.parse(k);T=b.userLocale,o=b.osLocale,S=b.resolvedLanguage||e.LANGUAGE_DEFAULT,m=b.languagePack?.translationsConfigFile}catch{}R=!0}else typeof navigator=="object"&&!t?(p=navigator.userAgent,h=p.indexOf("Windows")>=0,D=p.indexOf("Macintosh")>=0,C=(p.indexOf("Macintosh")>=0||p.indexOf("iPad")>=0||p.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,A=p.indexOf("Linux")>=0,f=p?.indexOf("Mobi")>=0,v=!0,S=s.getNLSLanguage()||e.LANGUAGE_DEFAULT,T=navigator.language.toLowerCase(),o=T):console.error("Unable to resolve platform.");var n;(function(k){k[k.Web=0]="Web",k[k.Mac=1]="Mac",k[k.Linux=2]="Linux",k[k.Windows=3]="Windows"})(n||(e.Platform=n={}));function r(k){switch(k){case n.Web:return"Web";case n.Mac:return"Mac";case n.Linux:return"Linux";case n.Windows:return"Windows"}}let d=n.Web;D?d=n.Mac:h?d=n.Windows:A&&(d=n.Linux),e.isWindows=h,e.isMacintosh=D,e.isLinux=A,e.isLinuxSnap=L,e.isNative=R,e.isElectron=l,e.isWeb=v,e.isWebWorker=v&&typeof u.importScripts=="function",e.webWorkerOrigin=e.isWebWorker?u.origin:void 0,e.isIOS=C,e.isMobile=f,e.isCI=_,e.platform=d,e.userAgent=p,e.language=S;var c;(function(k){function b(){return e.language}k.value=b;function E(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}k.isDefaultVariant=E;function N(){return e.language==="en"}k.isDefault=N})(c||(e.Language=c={})),e.locale=T,e.platformLocale=o,e.translationsConfigFile=m,e.setTimeout0IsFaster=typeof u.postMessage=="function"&&!u.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const k=[];u.addEventListener("message",E=>{if(E.data&&E.data.vscodeScheduleAsyncWork)for(let N=0,O=k.length;N<O;N++){const M=k[N];if(M.id===E.data.vscodeScheduleAsyncWork){k.splice(N,1),M.callback();return}}});let b=0;return E=>{const N=++b;k.push({id:N,callback:E}),u.postMessage({vscodeScheduleAsyncWork:N},"*")}}return k=>setTimeout(k)})();var g;(function(k){k[k.Windows=1]="Windows",k[k.Macintosh=2]="Macintosh",k[k.Linux=3]="Linux"})(g||(e.OperatingSystem=g={})),e.OS=D||C?g.Macintosh:h?g.Windows:g.Linux;let w=!0,y=!1;function I(){if(!y){y=!0;const k=new Uint8Array(2);k[0]=1,k[1]=2,w=new Uint16Array(k.buffer)[0]===513}return w}e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0);function P(k){return parseFloat(k)>=20}}),define(Pe[57],ke([1,0,10]),function(ge,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let h;const D=globalThis.vscode;if(typeof D<"u"&&typeof D.process<"u"){const A=D.process;h={get platform(){return A.platform},get arch(){return A.arch},get env(){return A.env},cwd(){return A.cwd()}}}else typeof process<"u"&&typeof process?.versions?.node=="string"?h={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:h={get platform(){return s.isWindows?"win32":s.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=h.cwd,e.env=h.env,e.platform=h.platform,e.arch=h.arch}),define(Pe[16],ke([1,0,57]),function(ge,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0,s=We(s);const h=65,D=97,A=90,L=122,R=46,v=47,l=92,C=58,_=63;class f extends Error{constructor(d,c,g){let w;typeof c=="string"&&c.indexOf("not ")===0?(w="must not be",c=c.replace(/^not /,"")):w="must be";const y=d.indexOf(".")!==-1?"property":"argument";let I=`The "${d}" ${y} ${w} of type ${c}`;I+=`. Received type ${typeof g}`,super(I),this.code="ERR_INVALID_ARG_TYPE"}}function T(r,d){if(r===null||typeof r!="object")throw new f(d,"Object",r)}function S(r,d){if(typeof r!="string")throw new f(d,"string",r)}const o=s.platform==="win32";function m(r){return r===v||r===l}function p(r){return r===v}function u(r){return r>=h&&r<=A||r>=D&&r<=L}function i(r,d,c,g){let w="",y=0,I=-1,P=0,k=0;for(let b=0;b<=r.length;++b){if(b<r.length)k=r.charCodeAt(b);else{if(g(k))break;k=v}if(g(k)){if(!(I===b-1||P===1))if(P===2){if(w.length<2||y!==2||w.charCodeAt(w.length-1)!==R||w.charCodeAt(w.length-2)!==R){if(w.length>2){const E=w.lastIndexOf(c);E===-1?(w="",y=0):(w=w.slice(0,E),y=w.length-1-w.lastIndexOf(c)),I=b,P=0;continue}else if(w.length!==0){w="",y=0,I=b,P=0;continue}}d&&(w+=w.length>0?`${c}..`:"..",y=2)}else w.length>0?w+=`${c}${r.slice(I+1,b)}`:w=r.slice(I+1,b),y=b-I-1;I=b,P=0}else k===R&&P!==-1?++P:P=-1}return w}function a(r){return r?`${r[0]==="."?"":"."}${r}`:""}function t(r,d){T(d,"pathObject");const c=d.dir||d.root,g=d.base||`${d.name||""}${a(d.ext)}`;return c?c===d.root?`${c}${g}`:`${c}${r}${g}`:g}e.win32={resolve(...r){let d="",c="",g=!1;for(let w=r.length-1;w>=-1;w--){let y;if(w>=0){if(y=r[w],S(y,`paths[${w}]`),y.length===0)continue}else d.length===0?y=s.cwd():(y=s.env[`=${d}`]||s.cwd(),(y===void 0||y.slice(0,2).toLowerCase()!==d.toLowerCase()&&y.charCodeAt(2)===l)&&(y=`${d}\\`));const I=y.length;let P=0,k="",b=!1;const E=y.charCodeAt(0);if(I===1)m(E)&&(P=1,b=!0);else if(m(E))if(b=!0,m(y.charCodeAt(1))){let N=2,O=N;for(;N<I&&!m(y.charCodeAt(N));)N++;if(N<I&&N!==O){const M=y.slice(O,N);for(O=N;N<I&&m(y.charCodeAt(N));)N++;if(N<I&&N!==O){for(O=N;N<I&&!m(y.charCodeAt(N));)N++;(N===I||N!==O)&&(k=`\\\\${M}\\${y.slice(O,N)}`,P=N)}}}else P=1;else u(E)&&y.charCodeAt(1)===C&&(k=y.slice(0,2),P=2,I>2&&m(y.charCodeAt(2))&&(b=!0,P=3));if(k.length>0)if(d.length>0){if(k.toLowerCase()!==d.toLowerCase())continue}else d=k;if(g){if(d.length>0)break}else if(c=`${y.slice(P)}\\${c}`,g=b,b&&d.length>0)break}return c=i(c,!g,"\\",m),g?`${d}\\${c}`:`${d}${c}`||"."},normalize(r){S(r,"path");const d=r.length;if(d===0)return".";let c=0,g,w=!1;const y=r.charCodeAt(0);if(d===1)return p(y)?"\\":r;if(m(y))if(w=!0,m(r.charCodeAt(1))){let P=2,k=P;for(;P<d&&!m(r.charCodeAt(P));)P++;if(P<d&&P!==k){const b=r.slice(k,P);for(k=P;P<d&&m(r.charCodeAt(P));)P++;if(P<d&&P!==k){for(k=P;P<d&&!m(r.charCodeAt(P));)P++;if(P===d)return`\\\\${b}\\${r.slice(k)}\\`;P!==k&&(g=`\\\\${b}\\${r.slice(k,P)}`,c=P)}}}else c=1;else u(y)&&r.charCodeAt(1)===C&&(g=r.slice(0,2),c=2,d>2&&m(r.charCodeAt(2))&&(w=!0,c=3));let I=c<d?i(r.slice(c),!w,"\\",m):"";return I.length===0&&!w&&(I="."),I.length>0&&m(r.charCodeAt(d-1))&&(I+="\\"),g===void 0?w?`\\${I}`:I:w?`${g}\\${I}`:`${g}${I}`},isAbsolute(r){S(r,"path");const d=r.length;if(d===0)return!1;const c=r.charCodeAt(0);return m(c)||d>2&&u(c)&&r.charCodeAt(1)===C&&m(r.charCodeAt(2))},join(...r){if(r.length===0)return".";let d,c;for(let y=0;y<r.length;++y){const I=r[y];S(I,"path"),I.length>0&&(d===void 0?d=c=I:d+=`\\${I}`)}if(d===void 0)return".";let g=!0,w=0;if(typeof c=="string"&&m(c.charCodeAt(0))){++w;const y=c.length;y>1&&m(c.charCodeAt(1))&&(++w,y>2&&(m(c.charCodeAt(2))?++w:g=!1))}if(g){for(;w<d.length&&m(d.charCodeAt(w));)w++;w>=2&&(d=`\\${d.slice(w)}`)}return e.win32.normalize(d)},relative(r,d){if(S(r,"from"),S(d,"to"),r===d)return"";const c=e.win32.resolve(r),g=e.win32.resolve(d);if(c===g||(r=c.toLowerCase(),d=g.toLowerCase(),r===d))return"";let w=0;for(;w<r.length&&r.charCodeAt(w)===l;)w++;let y=r.length;for(;y-1>w&&r.charCodeAt(y-1)===l;)y--;const I=y-w;let P=0;for(;P<d.length&&d.charCodeAt(P)===l;)P++;let k=d.length;for(;k-1>P&&d.charCodeAt(k-1)===l;)k--;const b=k-P,E=I<b?I:b;let N=-1,O=0;for(;O<E;O++){const U=r.charCodeAt(w+O);if(U!==d.charCodeAt(P+O))break;U===l&&(N=O)}if(O!==E){if(N===-1)return g}else{if(b>E){if(d.charCodeAt(P+O)===l)return g.slice(P+O+1);if(O===2)return g.slice(P+O)}I>E&&(r.charCodeAt(w+O)===l?N=O:O===2&&(N=3)),N===-1&&(N=0)}let M="";for(O=w+N+1;O<=y;++O)(O===y||r.charCodeAt(O)===l)&&(M+=M.length===0?"..":"\\..");return P+=N,M.length>0?`${M}${g.slice(P,k)}`:(g.charCodeAt(P)===l&&++P,g.slice(P,k))},toNamespacedPath(r){if(typeof r!="string"||r.length===0)return r;const d=e.win32.resolve(r);if(d.length<=2)return r;if(d.charCodeAt(0)===l){if(d.charCodeAt(1)===l){const c=d.charCodeAt(2);if(c!==_&&c!==R)return`\\\\?\\UNC\\${d.slice(2)}`}}else if(u(d.charCodeAt(0))&&d.charCodeAt(1)===C&&d.charCodeAt(2)===l)return`\\\\?\\${d}`;return r},dirname(r){S(r,"path");const d=r.length;if(d===0)return".";let c=-1,g=0;const w=r.charCodeAt(0);if(d===1)return m(w)?r:".";if(m(w)){if(c=g=1,m(r.charCodeAt(1))){let P=2,k=P;for(;P<d&&!m(r.charCodeAt(P));)P++;if(P<d&&P!==k){for(k=P;P<d&&m(r.charCodeAt(P));)P++;if(P<d&&P!==k){for(k=P;P<d&&!m(r.charCodeAt(P));)P++;if(P===d)return r;P!==k&&(c=g=P+1)}}}}else u(w)&&r.charCodeAt(1)===C&&(c=d>2&&m(r.charCodeAt(2))?3:2,g=c);let y=-1,I=!0;for(let P=d-1;P>=g;--P)if(m(r.charCodeAt(P))){if(!I){y=P;break}}else I=!1;if(y===-1){if(c===-1)return".";y=c}return r.slice(0,y)},basename(r,d){d!==void 0&&S(d,"suffix"),S(r,"path");let c=0,g=-1,w=!0,y;if(r.length>=2&&u(r.charCodeAt(0))&&r.charCodeAt(1)===C&&(c=2),d!==void 0&&d.length>0&&d.length<=r.length){if(d===r)return"";let I=d.length-1,P=-1;for(y=r.length-1;y>=c;--y){const k=r.charCodeAt(y);if(m(k)){if(!w){c=y+1;break}}else P===-1&&(w=!1,P=y+1),I>=0&&(k===d.charCodeAt(I)?--I===-1&&(g=y):(I=-1,g=P))}return c===g?g=P:g===-1&&(g=r.length),r.slice(c,g)}for(y=r.length-1;y>=c;--y)if(m(r.charCodeAt(y))){if(!w){c=y+1;break}}else g===-1&&(w=!1,g=y+1);return g===-1?"":r.slice(c,g)},extname(r){S(r,"path");let d=0,c=-1,g=0,w=-1,y=!0,I=0;r.length>=2&&r.charCodeAt(1)===C&&u(r.charCodeAt(0))&&(d=g=2);for(let P=r.length-1;P>=d;--P){const k=r.charCodeAt(P);if(m(k)){if(!y){g=P+1;break}continue}w===-1&&(y=!1,w=P+1),k===R?c===-1?c=P:I!==1&&(I=1):c!==-1&&(I=-1)}return c===-1||w===-1||I===0||I===1&&c===w-1&&c===g+1?"":r.slice(c,w)},format:t.bind(null,"\\"),parse(r){S(r,"path");const d={root:"",dir:"",base:"",ext:"",name:""};if(r.length===0)return d;const c=r.length;let g=0,w=r.charCodeAt(0);if(c===1)return m(w)?(d.root=d.dir=r,d):(d.base=d.name=r,d);if(m(w)){if(g=1,m(r.charCodeAt(1))){let N=2,O=N;for(;N<c&&!m(r.charCodeAt(N));)N++;if(N<c&&N!==O){for(O=N;N<c&&m(r.charCodeAt(N));)N++;if(N<c&&N!==O){for(O=N;N<c&&!m(r.charCodeAt(N));)N++;N===c?g=N:N!==O&&(g=N+1)}}}}else if(u(w)&&r.charCodeAt(1)===C){if(c<=2)return d.root=d.dir=r,d;if(g=2,m(r.charCodeAt(2))){if(c===3)return d.root=d.dir=r,d;g=3}}g>0&&(d.root=r.slice(0,g));let y=-1,I=g,P=-1,k=!0,b=r.length-1,E=0;for(;b>=g;--b){if(w=r.charCodeAt(b),m(w)){if(!k){I=b+1;break}continue}P===-1&&(k=!1,P=b+1),w===R?y===-1?y=b:E!==1&&(E=1):y!==-1&&(E=-1)}return P!==-1&&(y===-1||E===0||E===1&&y===P-1&&y===I+1?d.base=d.name=r.slice(I,P):(d.name=r.slice(I,y),d.base=r.slice(I,P),d.ext=r.slice(y,P))),I>0&&I!==g?d.dir=r.slice(0,I-1):d.dir=d.root,d},sep:"\\",delimiter:";",win32:null,posix:null};const n=(()=>{if(o){const r=/\\/g;return()=>{const d=s.cwd().replace(r,"/");return d.slice(d.indexOf("/"))}}return()=>s.cwd()})();e.posix={resolve(...r){let d="",c=!1;for(let g=r.length-1;g>=-1&&!c;g--){const w=g>=0?r[g]:n();S(w,`paths[${g}]`),w.length!==0&&(d=`${w}/${d}`,c=w.charCodeAt(0)===v)}return d=i(d,!c,"/",p),c?`/${d}`:d.length>0?d:"."},normalize(r){if(S(r,"path"),r.length===0)return".";const d=r.charCodeAt(0)===v,c=r.charCodeAt(r.length-1)===v;return r=i(r,!d,"/",p),r.length===0?d?"/":c?"./":".":(c&&(r+="/"),d?`/${r}`:r)},isAbsolute(r){return S(r,"path"),r.length>0&&r.charCodeAt(0)===v},join(...r){if(r.length===0)return".";let d;for(let c=0;c<r.length;++c){const g=r[c];S(g,"path"),g.length>0&&(d===void 0?d=g:d+=`/${g}`)}return d===void 0?".":e.posix.normalize(d)},relative(r,d){if(S(r,"from"),S(d,"to"),r===d||(r=e.posix.resolve(r),d=e.posix.resolve(d),r===d))return"";const c=1,g=r.length,w=g-c,y=1,I=d.length-y,P=w<I?w:I;let k=-1,b=0;for(;b<P;b++){const N=r.charCodeAt(c+b);if(N!==d.charCodeAt(y+b))break;N===v&&(k=b)}if(b===P)if(I>P){if(d.charCodeAt(y+b)===v)return d.slice(y+b+1);if(b===0)return d.slice(y+b)}else w>P&&(r.charCodeAt(c+b)===v?k=b:b===0&&(k=0));let E="";for(b=c+k+1;b<=g;++b)(b===g||r.charCodeAt(b)===v)&&(E+=E.length===0?"..":"/..");return`${E}${d.slice(y+k)}`},toNamespacedPath(r){return r},dirname(r){if(S(r,"path"),r.length===0)return".";const d=r.charCodeAt(0)===v;let c=-1,g=!0;for(let w=r.length-1;w>=1;--w)if(r.charCodeAt(w)===v){if(!g){c=w;break}}else g=!1;return c===-1?d?"/":".":d&&c===1?"//":r.slice(0,c)},basename(r,d){d!==void 0&&S(d,"ext"),S(r,"path");let c=0,g=-1,w=!0,y;if(d!==void 0&&d.length>0&&d.length<=r.length){if(d===r)return"";let I=d.length-1,P=-1;for(y=r.length-1;y>=0;--y){const k=r.charCodeAt(y);if(k===v){if(!w){c=y+1;break}}else P===-1&&(w=!1,P=y+1),I>=0&&(k===d.charCodeAt(I)?--I===-1&&(g=y):(I=-1,g=P))}return c===g?g=P:g===-1&&(g=r.length),r.slice(c,g)}for(y=r.length-1;y>=0;--y)if(r.charCodeAt(y)===v){if(!w){c=y+1;break}}else g===-1&&(w=!1,g=y+1);return g===-1?"":r.slice(c,g)},extname(r){S(r,"path");let d=-1,c=0,g=-1,w=!0,y=0;for(let I=r.length-1;I>=0;--I){const P=r.charCodeAt(I);if(P===v){if(!w){c=I+1;break}continue}g===-1&&(w=!1,g=I+1),P===R?d===-1?d=I:y!==1&&(y=1):d!==-1&&(y=-1)}return d===-1||g===-1||y===0||y===1&&d===g-1&&d===c+1?"":r.slice(d,g)},format:t.bind(null,"/"),parse(r){S(r,"path");const d={root:"",dir:"",base:"",ext:"",name:""};if(r.length===0)return d;const c=r.charCodeAt(0)===v;let g;c?(d.root="/",g=1):g=0;let w=-1,y=0,I=-1,P=!0,k=r.length-1,b=0;for(;k>=g;--k){const E=r.charCodeAt(k);if(E===v){if(!P){y=k+1;break}continue}I===-1&&(P=!1,I=k+1),E===R?w===-1?w=k:b!==1&&(b=1):w!==-1&&(b=-1)}if(I!==-1){const E=y===0&&c?1:y;w===-1||b===0||b===1&&w===I-1&&w===y+1?d.base=d.name=r.slice(E,I):(d.name=r.slice(E,w),d.base=r.slice(E,I),d.ext=r.slice(w,I))}return y>0?d.dir=r.slice(0,y-1):c&&(d.dir="/"),d},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=o?e.win32.normalize:e.posix.normalize,e.isAbsolute=o?e.win32.isAbsolute:e.posix.isAbsolute,e.join=o?e.win32.join:e.posix.join,e.resolve=o?e.win32.resolve:e.posix.resolve,e.relative=o?e.win32.relative:e.posix.relative,e.dirname=o?e.win32.dirname:e.posix.dirname,e.basename=o?e.win32.basename:e.posix.basename,e.extname=o?e.win32.extname:e.posix.extname,e.format=o?e.win32.format:e.posix.format,e.parse=o?e.win32.parse:e.posix.parse,e.toNamespacedPath=o?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=o?e.win32.sep:e.posix.sep,e.delimiter=o?e.win32.delimiter:e.posix.delimiter}),define(Pe[142],ke([1,0,50,16]),function(ge,e,s,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareFileNames=R,e.compareFileNamesDefault=v,e.compareFileNamesUpper=l,e.compareFileNamesLower=C,e.compareFileNamesUnicode=_,e.compareFileExtensions=f,e.compareFileExtensionsDefault=T,e.compareFileExtensionsUpper=S,e.compareFileExtensionsLower=o,e.compareFileExtensionsUnicode=m,e.comparePaths=g,e.compareAnything=w,e.compareByPrefix=y;const D=new s.Lazy(()=>{const I=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:I,collatorIsNumeric:I.resolvedOptions().numeric}}),A=new s.Lazy(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),L=new s.Lazy(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function R(I,P,k=!1){const b=I||"",E=P||"",N=D.value.collator.compare(b,E);return D.value.collatorIsNumeric&&N===0&&b!==E?b<E?-1:1:N}function v(I,P){const k=A.value.collator;return I=I||"",P=P||"",a(k,I,P)}function l(I,P){const k=A.value.collator;return I=I||"",P=P||"",d(I,P)||a(k,I,P)}function C(I,P){const k=A.value.collator;return I=I||"",P=P||"",r(I,P)||a(k,I,P)}function _(I,P){return I=I||"",P=P||"",I===P?0:I<P?-1:1}function f(I,P){const[k,b]=u(I),[E,N]=u(P);let O=D.value.collator.compare(b,N);if(O===0){if(D.value.collatorIsNumeric&&b!==N)return b<N?-1:1;if(O=D.value.collator.compare(k,E),D.value.collatorIsNumeric&&O===0&&k!==E)return k<E?-1:1}return O}function T(I,P){I=I||"",P=P||"";const k=i(I),b=i(P),E=A.value.collator,N=L.value.collator;return a(N,k,b)||a(E,I,P)}function S(I,P){I=I||"",P=P||"";const k=i(I),b=i(P),E=A.value.collator,N=L.value.collator;return a(N,k,b)||d(I,P)||a(E,I,P)}function o(I,P){I=I||"",P=P||"";const k=i(I),b=i(P),E=A.value.collator,N=L.value.collator;return a(N,k,b)||r(I,P)||a(E,I,P)}function m(I,P){I=I||"",P=P||"";const k=i(I).toLowerCase(),b=i(P).toLowerCase();return k!==b?k<b?-1:1:I!==P?I<P?-1:1:0}const p=/^(.*?)(\.([^.]*))?$/;function u(I,P=!1){const k=I?p.exec(I):[];let b=[k&&k[1]||"",k&&k[3]||""];return P&&(!b[0]&&b[1]||b[0]&&b[0].charAt(0)===".")&&(b=[b[0]+"."+b[1],""]),b}function i(I){const P=I?p.exec(I):[];return P&&P[1]&&P[1].charAt(0)!=="."&&P[3]||""}function a(I,P,k){const b=I.compare(P,k);return b!==0?b:P.length!==k.length?P.length<k.length?-1:1:0}function t(I){const P=I.charAt(0);return P.toLocaleUpperCase()!==P}function n(I){const P=I.charAt(0);return P.toLocaleLowerCase()!==P}function r(I,P){return t(I)&&n(P)?-1:n(I)&&t(P)?1:0}function d(I,P){return n(I)&&t(P)?-1:t(I)&&n(P)?1:0}function c(I,P,k=!1){return k||(I=I&&I.toLowerCase(),P=P&&P.toLowerCase()),I===P?0:I<P?-1:1}function g(I,P,k=!1){const b=I.split(h.sep),E=P.split(h.sep),N=b.length-1,O=E.length-1;let M,U;for(let H=0;;H++){if(M=N===H,U=O===H,M&&U)return R(b[H],E[H],k);if(M)return-1;if(U)return 1;const F=c(b[H],E[H],k);if(F!==0)return F}}function w(I,P,k){const b=I.toLowerCase(),E=P.toLowerCase(),N=y(I,P,k);if(N)return N;const O=b.endsWith(k),M=E.endsWith(k);if(O!==M)return O?-1:1;const U=R(b,E);return U!==0?U:b.localeCompare(E)}function y(I,P,k){const b=I.toLowerCase(),E=P.toLowerCase(),N=b.startsWith(k),O=E.startsWith(k);if(N!==O)return N?-1:1;if(N&&O){if(b.length<E.length)return-1;if(b.length>E.length)return 1}return 0}}),define(Pe[33],ke([1,0,26,16,10,13,17]),function(ge,e,s,h,D,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPathSeparator=R,e.toSlashes=v,e.toPosixPath=l,e.getRoot=C,e.isUNC=_,e.isValidBasename=o,e.isEqual=m,e.isEqualOrParent=p,e.isWindowsDriveLetter=u,e.sanitizeFilePath=i,e.removeTrailingPathSeparator=a,e.isRootOrDriveLetter=t,e.hasDriveLetter=n,e.getDriveLetter=r,e.indexOfPath=d,e.parseLineAndColumnAware=c,e.randomPath=y;function R(I){return I===s.CharCode.Slash||I===s.CharCode.Backslash}function v(I){return I.replace(/[\\/]/g,h.posix.sep)}function l(I){return I.indexOf("/")===-1&&(I=v(I)),/^[a-zA-Z]:(\/|$)/.test(I)&&(I="/"+I),I}function C(I,P=h.posix.sep){if(!I)return"";const k=I.length,b=I.charCodeAt(0);if(R(b)){if(R(I.charCodeAt(1))&&!R(I.charCodeAt(2))){let N=3;const O=N;for(;N<k&&!R(I.charCodeAt(N));N++);if(O!==N&&!R(I.charCodeAt(N+1))){for(N+=1;N<k;N++)if(R(I.charCodeAt(N)))return I.slice(0,N+1).replace(/[\\/]/g,P)}}return P}else if(u(b)&&I.charCodeAt(1)===s.CharCode.Colon)return R(I.charCodeAt(2))?I.slice(0,2)+P:I.slice(0,2);let E=I.indexOf("://");if(E!==-1){for(E+=3;E<k;E++)if(R(I.charCodeAt(E)))return I.slice(0,E+1)}return""}function _(I){if(!D.isWindows||!I||I.length<5)return!1;let P=I.charCodeAt(0);if(P!==s.CharCode.Backslash||(P=I.charCodeAt(1),P!==s.CharCode.Backslash))return!1;let k=2;const b=k;for(;k<I.length&&(P=I.charCodeAt(k),P!==s.CharCode.Backslash);k++);return!(b===k||(P=I.charCodeAt(k+1),isNaN(P)||P===s.CharCode.Backslash))}const f=/[\\/:\*\?"<>\|]/g,T=/[/]/g,S=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function o(I,P=D.isWindows){const k=P?f:T;return!(!I||I.length===0||/^\s+$/.test(I)||(k.lastIndex=0,k.test(I))||P&&S.test(I)||I==="."||I===".."||P&&I[I.length-1]==="."||P&&I.length!==I.trim().length||I.length>255)}function m(I,P,k){const b=I===P;return!k||b?b:!I||!P?!1:(0,A.equalsIgnoreCase)(I,P)}function p(I,P,k,b=h.sep){if(I===P)return!0;if(!I||!P||P.length>I.length)return!1;if(k){if(!(0,A.startsWithIgnoreCase)(I,P))return!1;if(P.length===I.length)return!0;let N=P.length;return P.charAt(P.length-1)===b&&N--,I.charAt(N)===b}return P.charAt(P.length-1)!==b&&(P+=b),I.indexOf(P)===0}function u(I){return I>=s.CharCode.A&&I<=s.CharCode.Z||I>=s.CharCode.a&&I<=s.CharCode.z}function i(I,P){return D.isWindows&&I.endsWith(":")&&(I+=h.sep),(0,h.isAbsolute)(I)||(I=(0,h.join)(P,I)),I=(0,h.normalize)(I),a(I)}function a(I){return D.isWindows?(I=(0,A.rtrim)(I,h.sep),I.endsWith(":")&&(I+=h.sep)):(I=(0,A.rtrim)(I,h.sep),I||(I=h.sep)),I}function t(I){const P=(0,h.normalize)(I);return D.isWindows?I.length>3?!1:n(P)&&(I.length===2||P.charCodeAt(2)===s.CharCode.Backslash):P===h.posix.sep}function n(I,P=D.isWindows){return P?u(I.charCodeAt(0))&&I.charCodeAt(1)===s.CharCode.Colon:!1}function r(I,P=D.isWindows){return n(I,P)?I[0]:void 0}function d(I,P,k){return P.length>I.length?-1:I===P?0:(k&&(I=I.toLowerCase(),P=P.toLowerCase()),I.indexOf(P))}function c(I){const P=I.split(":");let k,b,E;for(const N of P){const O=Number(N);(0,L.isNumber)(O)?b===void 0?b=O:E===void 0&&(E=O):k=k?[k,N].join(":"):N}if(!k)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:k,line:b!==void 0?b:void 0,column:E!==void 0?E:b!==void 0?1:void 0}}const g="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",w="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function y(I,P,k=8){let b="";for(let N=0;N<k;N++){let O;N===0&&D.isWindows&&!P&&(k===3||k===4)?O=w:O=g,b+=O.charAt(Math.floor(Math.random()*O.length))}let E;return P?E=`${P}-${b}`:E=b,I?(0,h.join)(I,E):E}}),define(Pe[143],ke([1,0,26,142,136,61,16,10,13]),function(ge,e,s,h,D,A,L,R,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.scoreFuzzy=_,e.scoreFuzzy2=p,e.scoreItemFuzzy=c,e.compareItemsByFuzzyScore=b,e.prepareQuery=H,e.pieceToQuery=x;const l=0,C=[l,[]];function _($,G,B,W){if(!$||!G)return C;const Z=$.length,J=G.length;if(Z<J)return C;const oe=$.toLowerCase();return f(G,B,J,$,oe,Z,W)}function f($,G,B,W,Z,J,oe){const te=[],me=[];for(let se=0;se<B;se++){const Ee=se*J,ae=Ee-J,be=se>0,pe=$[se],ve=G[se];for(let Re=0;Re<J;Re++){const Fe=Re>0,Ve=Ee+Re,Ye=Ve-1,Je=ae+Re-1,xe=Fe?te[Ye]:0,ze=be&&Fe?te[Je]:0,Ne=be&&Fe?me[Je]:0;let V;!ze&&be?V=0:V=T(pe,ve,W,Z,Re,Ne),V&&ze+V>=xe&&(oe||be||Z.startsWith(G,Re))?(me[Ve]=Ne+1,te[Ve]=ze+V):(me[Ve]=l,te[Ve]=xe)}}const le=[];let Q=B-1,z=J-1;for(;Q>=0&&z>=0;){const se=Q*J+z;me[se]===l||(le.push(z),Q--),z--}return[te[B*J-1],le.reverse()]}function T($,G,B,W,Z,J){let oe=0;if(!S(G,W[Z]))return oe;if(oe+=1,J>0&&(oe+=J*5),$===B[Z]&&(oe+=1),Z===0)oe+=8;else{const te=o(B.charCodeAt(Z-1));te?oe+=te:(0,D.isUpper)(B.charCodeAt(Z))&&J===0&&(oe+=2)}return oe}function S($,G){return $===G?!0:$==="/"||$==="\\"?G==="/"||G==="\\":!1}function o($){switch($){case s.CharCode.Slash:case s.CharCode.Backslash:return 5;case s.CharCode.Underline:case s.CharCode.Dash:case s.CharCode.Period:case s.CharCode.Space:case s.CharCode.SingleQuote:case s.CharCode.DoubleQuote:case s.CharCode.Colon:return 4;default:return 0}}const m=[void 0,[]];function p($,G,B=0,W=0){const Z=G;return Z.values&&Z.values.length>1?u($,Z.values,B,W):i($,G,B,W)}function u($,G,B,W){let Z=0;const J=[];for(const oe of G){const[te,me]=i($,oe,B,W);if(typeof te!="number")return m;Z+=te,J.push(...me)}return[Z,P(J)]}function i($,G,B,W){const Z=(0,D.fuzzyScore)(G.original,G.originalLowercase,B,$,$.toLowerCase(),W,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return Z?[Z[0],(0,D.createMatches)(Z)]:m}const a=Object.freeze({score:0}),t=1<<18,n=1<<17,r=65536;function d($,G,B,W){const Z=W.values?W.values:[W];return(0,A.hash)({[W.normalized]:{values:Z.map(oe=>({value:oe.normalized,expectContiguousMatch:oe.expectContiguousMatch})),label:$,description:G,allowNonContiguousMatches:B}})}function c($,G,B,W,Z){if(!$||!G.normalized)return a;const J=W.getItemLabel($);if(!J)return a;const oe=W.getItemDescription($),te=d(J,oe,B,G),me=Z[te];if(me)return me;const le=g(J,oe,W.getItemPath($),G,B);return Z[te]=le,le}function g($,G,B,W,Z){const J=!B||!W.containsPathSeparator;return B&&(R.isLinux?W.pathNormalized===B:(0,v.equalsIgnoreCase)(W.pathNormalized,B))?{score:t,labelMatch:[{start:0,end:$.length}],descriptionMatch:G?[{start:0,end:G.length}]:void 0}:W.values&&W.values.length>1?w($,G,B,W.values,J,Z):y($,G,B,W,J,Z)}function w($,G,B,W,Z,J){let oe=0;const te=[],me=[];for(const le of W){const{score:Q,labelMatch:z,descriptionMatch:se}=y($,G,B,le,Z,J);if(Q===l)return a;oe+=Q,z&&te.push(...z),se&&me.push(...se)}return{score:oe,labelMatch:P(te),descriptionMatch:P(me)}}function y($,G,B,W,Z,J){if(Z||!G){const[oe,te]=_($,W.normalized,W.normalizedLowercase,J&&!W.expectContiguousMatch);if(oe){const me=(0,D.matchesPrefix)(W.normalized,$);let le;if(me){le=n;const Q=Math.round(W.normalized.length/$.length*100);le+=Q}else le=r;return{score:le+oe,labelMatch:me||I(te)}}}if(G){let oe=G;B&&(oe=`${G}${L.sep}`);const te=oe.length,me=`${oe}${$}`,[le,Q]=_(me,W.normalized,W.normalizedLowercase,J&&!W.expectContiguousMatch);if(le){const z=I(Q),se=[],Ee=[];return z.forEach(ae=>{ae.start<te&&ae.end>te?(se.push({start:0,end:ae.end-te}),Ee.push({start:ae.start,end:te})):ae.start>=te?se.push({start:ae.start-te,end:ae.end-te}):Ee.push(ae)}),{score:le,labelMatch:se,descriptionMatch:Ee}}}return a}function I($){const G=[];if(!$)return G;let B;for(const W of $)B&&B.end===W?B.end+=1:(B={start:W,end:W+1},G.push(B));return G}function P($){const G=$.sort((Z,J)=>Z.start-J.start),B=[];let W;for(const Z of G)!W||!k(W,Z)?(W=Z,B.push(Z)):(W.start=Math.min(W.start,Z.start),W.end=Math.max(W.end,Z.end));return B}function k($,G){return!($.end<G.start||G.end<$.start)}function b($,G,B,W,Z,J){const oe=c($,B,W,Z,J),te=c(G,B,W,Z,J),me=oe.score,le=te.score;if((me===t||le===t)&&me!==le)return me===t?-1:1;if(me>r||le>r){if(me!==le)return me>le?-1:1;if(me<n&&le<n){const pe=N(oe.labelMatch,te.labelMatch);if(pe!==0)return pe}const ae=Z.getItemLabel($)||"",be=Z.getItemLabel(G)||"";if(ae.length!==be.length)return ae.length-be.length}if(me!==le)return me>le?-1:1;const Q=Array.isArray(oe.labelMatch)&&oe.labelMatch.length>0,z=Array.isArray(te.labelMatch)&&te.labelMatch.length>0;if(Q&&!z)return-1;if(z&&!Q)return 1;const se=E($,oe,Z),Ee=E(G,te,Z);return se&&Ee&&se!==Ee?Ee>se?-1:1:O($,G,B,Z)}function E($,G,B){let W=-1,Z=-1;if(G.descriptionMatch&&G.descriptionMatch.length?W=G.descriptionMatch[0].start:G.labelMatch&&G.labelMatch.length&&(W=G.labelMatch[0].start),G.labelMatch&&G.labelMatch.length){if(Z=G.labelMatch[G.labelMatch.length-1].end,G.descriptionMatch&&G.descriptionMatch.length){const J=B.getItemDescription($);J&&(Z+=J.length)}}else G.descriptionMatch&&G.descriptionMatch.length&&(Z=G.descriptionMatch[G.descriptionMatch.length-1].end);return Z-W}function N($,G){if(!$&&!G||(!$||!$.length)&&(!G||!G.length))return 0;if(!G||!G.length)return-1;if(!$||!$.length)return 1;const B=$[0].start,Z=$[$.length-1].end-B,J=G[0].start,te=G[G.length-1].end-J;return Z===te?0:te<Z?1:-1}function O($,G,B,W){const Z=W.getItemLabel($)||"",J=W.getItemLabel(G)||"",oe=W.getItemDescription($),te=W.getItemDescription(G),me=Z.length+(oe?oe.length:0),le=J.length+(te?te.length:0);if(me!==le)return me-le;const Q=W.getItemPath($),z=W.getItemPath(G);return Q&&z&&Q.length!==z.length?Q.length-z.length:Z!==J?(0,h.compareAnything)(Z,J,B.normalized):oe&&te&&oe!==te?(0,h.compareAnything)(oe,te,B.normalized):Q&&z&&Q!==z?(0,h.compareAnything)(Q,z,B.normalized):0}function M($){return $.startsWith('"')&&$.endsWith('"')}const U=" ";function H($){typeof $!="string"&&($="");const G=$.toLowerCase(),{pathNormalized:B,normalized:W,normalizedLowercase:Z}=F($),J=B.indexOf(L.sep)>=0,oe=M($);let te;const me=$.split(U);if(me.length>1)for(const le of me){const Q=M(le),{pathNormalized:z,normalized:se,normalizedLowercase:Ee}=F(le);se&&(te||(te=[]),te.push({original:le,originalLowercase:le.toLowerCase(),pathNormalized:z,normalized:se,normalizedLowercase:Ee,expectContiguousMatch:Q}))}return{original:$,originalLowercase:G,pathNormalized:B,normalized:W,normalizedLowercase:Z,values:te,containsPathSeparator:J,expectContiguousMatch:oe}}function F($){let G;R.isWindows?G=$.replace(/\//g,L.sep):G=$.replace(/\\/g,L.sep);const B=(0,v.stripWildcards)(G).replace(/\s|"/g,"");return{pathNormalized:G,normalized:B,normalizedLowercase:B.toLowerCase()}}function x($){return Array.isArray($)?H($.map(G=>G.original).join(U)):H($.original)}}),define(Pe[107],ke([1,0,16]),function(ge,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Mimes=void 0,e.getMediaOrTextMime=A,e.getMediaMime=L,e.getExtensionForMimeType=R,e.normalizeMimeType=l,e.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const h={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},D={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function A(C){const _=(0,s.extname)(C),f=h[_.toLowerCase()];return f!==void 0?f:L(C)}function L(C){const _=(0,s.extname)(C);return D[_.toLowerCase()]}function R(C){for(const _ in D)if(D[_]===C)return _}const v=/^(.+)\/(.+?)(;.+)?$/;function l(C,_){const f=v.exec(C);return f?`${f[1].toLowerCase()}/${f[2].toLowerCase()}${f[3]??""}`:_?void 0:C}}),define(Pe[108],ke([1,0,10]),function(ge,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminateResponseCode=e.Source=void 0,e.sanitizeProcessEnvironment=A,e.removeDangerousEnvVariables=L;var h;(function(R){R[R.stdout=0]="stdout",R[R.stderr=1]="stderr"})(h||(e.Source=h={}));var D;(function(R){R[R.Success=0]="Success",R[R.Unknown=1]="Unknown",R[R.AccessDenied=2]="AccessDenied",R[R.ProcessNotFound=3]="ProcessNotFound"})(D||(e.TerminateResponseCode=D={}));function A(R,...v){const l=v.reduce((f,T)=>(f[T]=!0,f),{}),C=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(R).filter(f=>!l[f]).forEach(f=>{for(let T=0;T<C.length;T++)if(f.search(C[T])!==-1){delete R[f];break}})}function L(R){R&&(delete R.DEBUG,s.isLinux&&delete R.LD_PRELOAD)}}),define(Pe[2],ke([1,0,26,41,16,10]),function(ge,e,s,h,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URI=void 0,e.isUriComponents=m,e.uriToFsPath=n,D=We(D);const L=/^\w[\w\d+.-]*$/,R=/^\//,v=/^\/\//;function l(w,y){if(!w.scheme&&y)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${w.authority}", path: "${w.path}", query: "${w.query}", fragment: "${w.fragment}"}`);if(w.scheme&&!L.test(w.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(w.path){if(w.authority){if(!R.test(w.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(v.test(w.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function C(w,y){return!w&&!y?"file":w}function _(w,y){switch(w){case"https":case"http":case"file":y?y[0]!==T&&(y=T+y):y=T;break}return y}const f="",T="/",S=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class o{static isUri(y){return y instanceof o?!0:y?typeof y.authority=="string"&&typeof y.fragment=="string"&&typeof y.path=="string"&&typeof y.query=="string"&&typeof y.scheme=="string"&&typeof y.fsPath=="string"&&typeof y.with=="function"&&typeof y.toString=="function":!1}constructor(y,I,P,k,b,E=!1){typeof y=="object"?(this.scheme=y.scheme||f,this.authority=y.authority||f,this.path=y.path||f,this.query=y.query||f,this.fragment=y.fragment||f):(this.scheme=C(y,E),this.authority=I||f,this.path=_(this.scheme,P||f),this.query=k||f,this.fragment=b||f,l(this,E))}get fsPath(){return n(this,!1)}with(y){if(!y)return this;let{scheme:I,authority:P,path:k,query:b,fragment:E}=y;return I===void 0?I=this.scheme:I===null&&(I=f),P===void 0?P=this.authority:P===null&&(P=f),k===void 0?k=this.path:k===null&&(k=f),b===void 0?b=this.query:b===null&&(b=f),E===void 0?E=this.fragment:E===null&&(E=f),I===this.scheme&&P===this.authority&&k===this.path&&b===this.query&&E===this.fragment?this:new u(I,P,k,b,E)}static parse(y,I=!1){const P=S.exec(y);return P?new u(P[2]||f,g(P[4]||f),g(P[5]||f),g(P[7]||f),g(P[9]||f),I):new u(f,f,f,f,f)}static file(y){let I=f;if(A.isWindows&&(y=y.replace(/\\/g,T)),y[0]===T&&y[1]===T){const P=y.indexOf(T,2);P===-1?(I=y.substring(2),y=T):(I=y.substring(2,P),y=y.substring(P)||T)}return new u("file",I,y,f,f)}static from(y,I){return new u(y.scheme,y.authority,y.path,y.query,y.fragment,I)}static joinPath(y,...I){if(!y.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let P;return A.isWindows&&y.scheme==="file"?P=o.file(D.win32.join(n(y,!0),...I)).path:P=D.posix.join(y.path,...I),y.with({path:P})}toString(y=!1){return r(this,y)}toJSON(){return this}static revive(y){if(y){if(y instanceof o)return y;{const I=new u(y);return I._formatted=y.external??null,I._fsPath=y._sep===p?y.fsPath??null:null,I}}else return y}[Symbol.for("debug.description")](){return`URI(${this.toString()})`}}e.URI=o;function m(w){return!w||typeof w!="object"?!1:typeof w.scheme=="string"&&(typeof w.authority=="string"||typeof w.authority>"u")&&(typeof w.path=="string"||typeof w.path>"u")&&(typeof w.query=="string"||typeof w.query>"u")&&(typeof w.fragment=="string"||typeof w.fragment>"u")}const p=A.isWindows?1:void 0;class u extends o{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=n(this,!1)),this._fsPath}toString(y=!1){return y?r(this,!0):(this._formatted||(this._formatted=r(this,!1)),this._formatted)}toJSON(){const y={$mid:h.MarshalledId.Uri};return this._fsPath&&(y.fsPath=this._fsPath,y._sep=p),this._formatted&&(y.external=this._formatted),this.path&&(y.path=this.path),this.scheme&&(y.scheme=this.scheme),this.authority&&(y.authority=this.authority),this.query&&(y.query=this.query),this.fragment&&(y.fragment=this.fragment),y}}const i={[s.CharCode.Colon]:"%3A",[s.CharCode.Slash]:"%2F",[s.CharCode.QuestionMark]:"%3F",[s.CharCode.Hash]:"%23",[s.CharCode.OpenSquareBracket]:"%5B",[s.CharCode.CloseSquareBracket]:"%5D",[s.CharCode.AtSign]:"%40",[s.CharCode.ExclamationMark]:"%21",[s.CharCode.DollarSign]:"%24",[s.CharCode.Ampersand]:"%26",[s.CharCode.SingleQuote]:"%27",[s.CharCode.OpenParen]:"%28",[s.CharCode.CloseParen]:"%29",[s.CharCode.Asterisk]:"%2A",[s.CharCode.Plus]:"%2B",[s.CharCode.Comma]:"%2C",[s.CharCode.Semicolon]:"%3B",[s.CharCode.Equals]:"%3D",[s.CharCode.Space]:"%20"};function a(w,y,I){let P,k=-1;for(let b=0;b<w.length;b++){const E=w.charCodeAt(b);if(E>=s.CharCode.a&&E<=s.CharCode.z||E>=s.CharCode.A&&E<=s.CharCode.Z||E>=s.CharCode.Digit0&&E<=s.CharCode.Digit9||E===s.CharCode.Dash||E===s.CharCode.Period||E===s.CharCode.Underline||E===s.CharCode.Tilde||y&&E===s.CharCode.Slash||I&&E===s.CharCode.OpenSquareBracket||I&&E===s.CharCode.CloseSquareBracket||I&&E===s.CharCode.Colon)k!==-1&&(P+=encodeURIComponent(w.substring(k,b)),k=-1),P!==void 0&&(P+=w.charAt(b));else{P===void 0&&(P=w.substr(0,b));const N=i[E];N!==void 0?(k!==-1&&(P+=encodeURIComponent(w.substring(k,b)),k=-1),P+=N):k===-1&&(k=b)}}return k!==-1&&(P+=encodeURIComponent(w.substring(k))),P!==void 0?P:w}function t(w){let y;for(let I=0;I<w.length;I++){const P=w.charCodeAt(I);P===s.CharCode.Hash||P===s.CharCode.QuestionMark?(y===void 0&&(y=w.substr(0,I)),y+=i[P]):y!==void 0&&(y+=w[I])}return y!==void 0?y:w}function n(w,y){let I;return w.authority&&w.path.length>1&&w.scheme==="file"?I=`//${w.authority}${w.path}`:w.path.charCodeAt(0)===s.CharCode.Slash&&(w.path.charCodeAt(1)>=s.CharCode.A&&w.path.charCodeAt(1)<=s.CharCode.Z||w.path.charCodeAt(1)>=s.CharCode.a&&w.path.charCodeAt(1)<=s.CharCode.z)&&w.path.charCodeAt(2)===s.CharCode.Colon?y?I=w.path.substr(1):I=w.path[1].toLowerCase()+w.path.substr(2):I=w.path,A.isWindows&&(I=I.replace(/\//g,"\\")),I}function r(w,y){const I=y?t:a;let P="",{scheme:k,authority:b,path:E,query:N,fragment:O}=w;if(k&&(P+=k,P+=":"),(b||k==="file")&&(P+=T,P+=T),b){let M=b.indexOf("@");if(M!==-1){const U=b.substr(0,M);b=b.substr(M+1),M=U.lastIndexOf(":"),M===-1?P+=I(U,!1,!1):(P+=I(U.substr(0,M),!1,!1),P+=":",P+=I(U.substr(M+1),!1,!0)),P+="@"}b=b.toLowerCase(),M=b.lastIndexOf(":"),M===-1?P+=I(b,!1,!0):(P+=I(b.substr(0,M),!1,!0),P+=b.substr(M))}if(E){if(E.length>=3&&E.charCodeAt(0)===s.CharCode.Slash&&E.charCodeAt(2)===s.CharCode.Colon){const M=E.charCodeAt(1);M>=s.CharCode.A&&M<=s.CharCode.Z&&(E=`/${String.fromCharCode(M+32)}:${E.substr(3)}`)}else if(E.length>=2&&E.charCodeAt(1)===s.CharCode.Colon){const M=E.charCodeAt(0);M>=s.CharCode.A&&M<=s.CharCode.Z&&(E=`${String.fromCharCode(M+32)}:${E.substr(2)}`)}P+=I(E,!0,!1)}return N&&(P+="?",P+=I(N,!1,!1)),O&&(P+="#",P+=y?O:a(O,!1,!1)),P}function d(w){try{return decodeURIComponent(w)}catch{return w.length>3?w.substr(0,3)+d(w.substr(3)):w}}const c=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function g(w){return w.match(c)?w.replace(c,y=>d(y)):w}}),define(Pe[208],ke([1,0,2]),function(ge,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isRemoteConsoleLog=h,e.parse=D,e.getFirstFrame=A,e.log=R;function h(l){const C=l;return C&&typeof C.type=="string"&&typeof C.severity=="string"}function D(l){const C=[];let _;try{const f=JSON.parse(l.arguments),T=f[f.length-1];T&&T.__$stack&&(f.pop(),_=T.__$stack),C.push(...f)}catch{C.push("Unable to log remote console arguments",l.arguments)}return{args:C,stack:_}}function A(l){if(typeof l!="string")return A(D(l).stack);const C=l;if(C){const _=L(C),f=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(_||"");if(f&&f.length===4)return{uri:s.URI.file(f[1]),line:Number(f[2]),column:Number(f[3])}}}function L(l){if(!l)return l;const C=l.indexOf(`
`);return C===-1?l:l.substring(0,C)}function R(l,C){const{args:_,stack:f}=D(l),T=typeof _[0]=="string"&&_.length===1;let S=L(f);S&&(S=`(${S.trim()})`);let o=[];if(typeof _[0]=="string"?S&&T?o=[`%c[${C}] %c${_[0]} %c${S}`,v("blue"),v(""),v("grey")]:o=[`%c[${C}] %c${_[0]}`,v("blue"),v(""),..._.slice(1)]:o=[`%c[${C}]%`,v("blue"),..._],S&&!T&&o.push(S),typeof console[l.severity]!="function")throw new Error("Unknown console method");console[l.severity].apply(console,o)}function v(l){return`color: ${l}`}}),define(Pe[38],ke([1,0,21,2,41]),function(ge,e,s,h,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.stringify=A,e.parse=L,e.revive=v;function A(l){return JSON.stringify(l,R)}function L(l){let C=JSON.parse(l);return C=v(C),C}function R(l,C){return C instanceof RegExp?{$mid:D.MarshalledId.Regexp,source:C.source,flags:C.flags}:C}function v(l,C=0){if(!l||C>200)return l;if(typeof l=="object"){switch(l.$mid){case D.MarshalledId.Uri:return h.URI.revive(l);case D.MarshalledId.Regexp:return new RegExp(l.source,l.flags);case D.MarshalledId.Date:return new Date(l.source)}if(l instanceof s.VSBuffer||l instanceof Uint8Array)return l;if(Array.isArray(l))for(let _=0;_<l.length;++_)l[_]=v(l[_],C+1);else for(const _ in l)Object.hasOwnProperty.call(l,_)&&(l[_]=v(l[_],C+1))}return l}}),define(Pe[14],ke([1,0,12,10,13,2,16]),function(ge,e,s,h,D,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.VSCODE_AUTHORITY=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0,e.matchesScheme=v,e.matchesSomeScheme=l,e.getServerRootPath=_,s=We(s),h=We(h),L=We(L);var R;(function(S){S.inMemory="inmemory",S.vscode="vscode",S.internal="private",S.walkThrough="walkThrough",S.walkThroughSnippet="walkThroughSnippet",S.http="http",S.https="https",S.file="file",S.mailto="mailto",S.untitled="untitled",S.data="data",S.command="command",S.vscodeRemote="vscode-remote",S.vscodeRemoteResource="vscode-remote-resource",S.vscodeManagedRemoteResource="vscode-managed-remote-resource",S.vscodeUserData="vscode-userdata",S.vscodeCustomEditor="vscode-custom-editor",S.vscodeNotebookCell="vscode-notebook-cell",S.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",S.vscodeNotebookCellMetadataDiff="vscode-notebook-cell-metadata-diff",S.vscodeNotebookCellOutput="vscode-notebook-cell-output",S.vscodeNotebookCellOutputDiff="vscode-notebook-cell-output-diff",S.vscodeNotebookMetadata="vscode-notebook-metadata",S.vscodeInteractiveInput="vscode-interactive-input",S.vscodeSettings="vscode-settings",S.vscodeWorkspaceTrust="vscode-workspace-trust",S.vscodeTerminal="vscode-terminal",S.vscodeChatCodeBlock="vscode-chat-code-block",S.vscodeChatCodeCompareBlock="vscode-chat-code-compare-block",S.vscodeChatSesssion="vscode-chat-editor",S.webviewPanel="webview-panel",S.vscodeWebview="vscode-webview",S.extension="extension",S.vscodeFileResource="vscode-file",S.tmp="tmp",S.vsls="vsls",S.vscodeSourceControl="vscode-scm",S.commentsInput="comment",S.codeSetting="code-setting",S.outputChannel="output"})(R||(e.Schemas=R={}));function v(S,o){return A.URI.isUri(S)?(0,D.equalsIgnoreCase)(S.scheme,o):(0,D.startsWithIgnoreCase)(S,o+":")}function l(S,...o){return o.some(m=>v(S,m))}e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class C{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._serverRootPath="/"}setPreferredWebSchema(o){this._preferredWebSchema=o}setDelegate(o){this._delegate=o}setServerRootPath(o,m){this._serverRootPath=_(o,m)}getServerRootPath(){return this._serverRootPath}get _remoteResourcesPath(){return L.posix.join(this._serverRootPath,R.vscodeRemoteResource)}set(o,m,p){this._hosts[o]=m,this._ports[o]=p}setConnectionToken(o,m){this._connectionTokens[o]=m}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(o){if(this._delegate)try{return this._delegate(o)}catch(t){return s.onUnexpectedError(t),o}const m=o.authority;let p=this._hosts[m];p&&p.indexOf(":")!==-1&&p.indexOf("[")===-1&&(p=`[${p}]`);const u=this._ports[m],i=this._connectionTokens[m];let a=`path=${encodeURIComponent(o.path)}`;return typeof i=="string"&&(a+=`&${e.connectionTokenQueryName}=${encodeURIComponent(i)}`),A.URI.from({scheme:h.isWeb?this._preferredWebSchema:R.vscodeRemoteResource,authority:`${p}:${u}`,path:this._remoteResourcesPath,query:a})}}e.RemoteAuthorities=new C;function _(S,o){return L.posix.join(o??"/",`${S.quality??"oss"}-${S.commit??"dev"}`)}e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked",e.VSCODE_AUTHORITY="vscode-app";class f{static{this.FALLBACK_AUTHORITY=e.VSCODE_AUTHORITY}asBrowserUri(o){const m=this.toUri(o,ge);return this.uriToBrowserUri(m)}uriToBrowserUri(o){return o.scheme===R.vscodeRemote?e.RemoteAuthorities.rewrite(o):o.scheme===R.file&&(h.isNative||h.webWorkerOrigin===`${R.vscodeFileResource}://${f.FALLBACK_AUTHORITY}`)?o.with({scheme:R.vscodeFileResource,authority:o.authority||f.FALLBACK_AUTHORITY,query:null,fragment:null}):o}asFileUri(o){const m=this.toUri(o,ge);return this.uriToFileUri(m)}uriToFileUri(o){return o.scheme===R.vscodeFileResource?o.with({scheme:R.file,authority:o.authority!==f.FALLBACK_AUTHORITY?o.authority:null,query:null,fragment:null}):o}toUri(o,m){if(A.URI.isUri(o))return o;if(globalThis._VSCODE_FILE_ROOT){const p=globalThis._VSCODE_FILE_ROOT;if(/^\w[\w\d+.-]*:\/\//.test(p))return A.URI.joinPath(A.URI.parse(p,!0),o);const u=L.join(p,o);return A.URI.file(u)}return A.URI.parse(m.toUrl(o))}}e.FileAccess=new f;var T;(function(S){const o=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);S.CoopAndCoep=Object.freeze(o.get("3"));const m="vscode-coi";function p(i){let a;typeof i=="string"?a=new URL(i).searchParams:i instanceof URL?a=i.searchParams:A.URI.isUri(i)&&(a=new URL(i.toString(!0)).searchParams);const t=a?.get(m);if(t)return o.get(t)}S.getHeadersFromQuery=p;function u(i,a,t){if(!globalThis.crossOriginIsolated)return;const n=a&&t?"3":t?"2":"1";i instanceof URLSearchParams?i.set(m,n):i[m]=n}S.addSearchParam=u})(T||(e.COI=T={}))}),define(Pe[144],ke([1,0,132,14,10,17,2]),function(ge,e,s,h,D,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.importAMDNodeModule=C,e.resolveAmdNodeModulePath=_,D=We(D);class R{constructor(T,S,o){this.id=T,this.dependencies=S,this.callback=o}}class v{static{this.INSTANCE=new v}constructor(){this._isWebWorker=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this._isRenderer=typeof document=="object",this._defineCalls=[],this._initialized=!1}_initialize(){this._initialized||(this._initialized=!0,globalThis.define=(T,S,o)=>{typeof T!="string"&&(o=S,S=T,T=null),(typeof S!="object"||!Array.isArray(S))&&(o=S,S=null),this._defineCalls.push(new R(T,S,o))},globalThis.define.amd=!0,this._isRenderer?this._amdPolicy=globalThis._VSCODE_WEB_PACKAGE_TTP??window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(T){if(T.startsWith(window.location.origin)||T.startsWith(`${h.Schemas.vscodeFileResource}://${h.VSCODE_AUTHORITY}`))return T;throw new Error(`[trusted_script_src] Invalid script url: ${T}`)}}):this._isWebWorker&&(this._amdPolicy=globalThis._VSCODE_WEB_PACKAGE_TTP??globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(T){return T}})))}async load(T){this._initialize();const S=await(this._isWebWorker?this._workerLoadScript(T):this._isRenderer?this._rendererLoadScript(T):this._nodeJSLoadScript(T));if(!S){console.warn(`Did not receive a define call from script ${T}`);return}const o={},m=[],p=[];if(Array.isArray(S.dependencies))for(const u of S.dependencies)u==="exports"?m.push(o):p.push(u);if(p.length>0)throw new Error(`Cannot resolve dependencies for script ${T}. The dependencies are: ${p.join(", ")}`);return typeof S.callback=="function"?S.callback(...m)??o:S.callback}_rendererLoadScript(T){return new Promise((S,o)=>{const m=document.createElement("script");m.setAttribute("async","async"),m.setAttribute("type","text/javascript");const p=()=>{m.removeEventListener("load",u),m.removeEventListener("error",i)},u=a=>{p(),S(this._defineCalls.pop())},i=a=>{p(),o(a)};m.addEventListener("load",u),m.addEventListener("error",i),this._amdPolicy&&(T=this._amdPolicy.createScriptURL(T)),m.setAttribute("src",T),window.document.getElementsByTagName("head")[0].appendChild(m)})}async _workerLoadScript(T){return this._amdPolicy&&(T=this._amdPolicy.createScriptURL(T)),s.isESM?await new Promise((S,o)=>{ge([T],S,o)}).then(We):importScripts(T),this._defineCalls.pop()}async _nodeJSLoadScript(T){try{const S=globalThis._VSCODE_NODE_MODULES.fs,o=globalThis._VSCODE_NODE_MODULES.vm,m=globalThis._VSCODE_NODE_MODULES.module,p=L.URI.parse(T).fsPath,u=S.readFileSync(p).toString(),i=m.wrap(u.replace(/^#!.*/,""));return new o.Script(i).runInThisContext().apply(),this._defineCalls.pop()}catch(S){throw S}}}const l=new Map;async function C(f,T,S){if(s.isESM){S===void 0&&(S=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit);const o=T?`${f}/${T}`:f;if(l.has(o))return l.get(o);let m;if(/^\w[\w\d+.-]*:\/\//.test(o))m=o;else{const a=`${s.canASAR&&S&&!D.isWeb?h.nodeModulesAsarPath:h.nodeModulesPath}/${o}`;m=h.FileAccess.asBrowserUri(a).toString(!0)}const p=v.INSTANCE.load(m);return l.set(o,p),p}else return await new Promise((o,m)=>{ge([f],o,m)}).then(We)}function _(f,T){(0,A.assertType)(s.isESM);const o=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit,m=s.canASAR&&o&&!D.isWeb,p=`${f}/${T}`,i=`${m?h.nodeModulesAsarPath:h.nodeModulesPath}/${p}`;return h.FileAccess.asBrowserUri(i).toString(!0)}}),define(Pe[22],ke([1,0,26,33,14,16,10,13,2]),function(ge,e,s,h,D,A,L,R,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=void 0,e.originalFSPath=l,e.distinctParents=_,e.toLocalResource=T,h=We(h),A=We(A);function l(S){return(0,v.uriToFsPath)(S,!0)}class C{constructor(o){this._ignorePathCasing=o}compare(o,m,p=!1){return o===m?0:(0,R.compare)(this.getComparisonKey(o,p),this.getComparisonKey(m,p))}isEqual(o,m,p=!1){return o===m?!0:!o||!m?!1:this.getComparisonKey(o,p)===this.getComparisonKey(m,p)}getComparisonKey(o,m=!1){return o.with({path:this._ignorePathCasing(o)?o.path.toLowerCase():void 0,fragment:m?null:void 0}).toString()}ignorePathCasing(o){return this._ignorePathCasing(o)}isEqualOrParent(o,m,p=!1){if(o.scheme===m.scheme){if(o.scheme===D.Schemas.file)return h.isEqualOrParent(l(o),l(m),this._ignorePathCasing(o))&&o.query===m.query&&(p||o.fragment===m.fragment);if((0,e.isEqualAuthority)(o.authority,m.authority))return h.isEqualOrParent(o.path,m.path,this._ignorePathCasing(o),"/")&&o.query===m.query&&(p||o.fragment===m.fragment)}return!1}joinPath(o,...m){return v.URI.joinPath(o,...m)}basenameOrAuthority(o){return(0,e.basename)(o)||o.authority}basename(o){return A.posix.basename(o.path)}extname(o){return A.posix.extname(o.path)}dirname(o){if(o.path.length===0)return o;let m;return o.scheme===D.Schemas.file?m=v.URI.file(A.dirname(l(o))).path:(m=A.posix.dirname(o.path),o.authority&&m.length&&m.charCodeAt(0)!==s.CharCode.Slash&&(console.error(`dirname("${o.toString})) resulted in a relative path`),m="/")),o.with({path:m})}normalizePath(o){if(!o.path.length)return o;let m;return o.scheme===D.Schemas.file?m=v.URI.file(A.normalize(l(o))).path:m=A.posix.normalize(o.path),o.with({path:m})}relativePath(o,m){if(o.scheme!==m.scheme||!(0,e.isEqualAuthority)(o.authority,m.authority))return;if(o.scheme===D.Schemas.file){const i=A.relative(l(o),l(m));return L.isWindows?h.toSlashes(i):i}let p=o.path||"/";const u=m.path||"/";if(this._ignorePathCasing(o)){let i=0;for(const a=Math.min(p.length,u.length);i<a&&!(p.charCodeAt(i)!==u.charCodeAt(i)&&p.charAt(i).toLowerCase()!==u.charAt(i).toLowerCase());i++);p=u.substr(0,i)+p.substr(i)}return A.posix.relative(p,u)}resolvePath(o,m){if(o.scheme===D.Schemas.file){const p=v.URI.file(A.resolve(l(o),m));return o.with({authority:p.authority,path:p.path})}return m=h.toPosixPath(m),o.with({path:A.posix.resolve(o.path,m)})}isAbsolutePath(o){return!!o.path&&o.path[0]==="/"}isEqualAuthority(o,m){return o===m||o!==void 0&&m!==void 0&&(0,R.equalsIgnoreCase)(o,m)}hasTrailingPathSeparator(o,m=A.sep){if(o.scheme===D.Schemas.file){const p=l(o);return p.length>h.getRoot(p).length&&p[p.length-1]===m}else{const p=o.path;return p.length>1&&p.charCodeAt(p.length-1)===s.CharCode.Slash&&!/^[a-zA-Z]:(\/$|\\$)/.test(o.fsPath)}}removeTrailingPathSeparator(o,m=A.sep){return(0,e.hasTrailingPathSeparator)(o,m)?o.with({path:o.path.substr(0,o.path.length-1)}):o}addTrailingPathSeparator(o,m=A.sep){let p=!1;if(o.scheme===D.Schemas.file){const u=l(o);p=u!==void 0&&u.length===h.getRoot(u).length&&u[u.length-1]===m}else{m="/";const u=o.path;p=u.length===1&&u.charCodeAt(u.length-1)===s.CharCode.Slash}return!p&&!(0,e.hasTrailingPathSeparator)(o,m)?o.with({path:o.path+"/"}):o}}e.ExtUri=C,e.extUri=new C(()=>!1),e.extUriBiasedIgnorePathCase=new C(S=>S.scheme===D.Schemas.file?!L.isLinux:!0),e.extUriIgnorePathCase=new C(S=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function _(S,o){const m=[];for(let p=0;p<S.length;p++){const u=o(S[p]);S.some((i,a)=>a===p?!1:(0,e.isEqualOrParent)(u,o(i)))||m.push(S[p])}return m}var f;(function(S){S.META_DATA_LABEL="label",S.META_DATA_DESCRIPTION="description",S.META_DATA_SIZE="size",S.META_DATA_MIME="mime";function o(m){const p=new Map;m.path.substring(m.path.indexOf(";")+1,m.path.lastIndexOf(";")).split(";").forEach(a=>{const[t,n]=a.split(":");t&&n&&p.set(t,n)});const i=m.path.substring(0,m.path.indexOf(";"));return i&&p.set(S.META_DATA_MIME,i),p}S.parseMetaData=o})(f||(e.DataUri=f={}));function T(S,o,m){if(o){let p=S.path;return p&&p[0]!==A.posix.sep&&(p=A.posix.sep+p),S.with({scheme:m,authority:o,path:p})}return S.with({scheme:m})}}),define(Pe[8],ke([1,0,20,12,4,3,22,10,190,50]),function(ge,e,s,h,D,A,L,R,v,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AsyncIterableSource=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.LazyStatefulPromise=e.StatefulPromise=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.GlobalIdleValue=e.AbstractIdleValue=e._runWhenIdle=e.runWhenGlobalIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.LimitedQueue=e.Queue=e.Limiter=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=void 0,e.isThenable=C,e.createCancelablePromise=_,e.raceCancellation=f,e.raceCancellationError=T,e.raceCancellablePromises=S,e.raceTimeout=o,e.asPromise=m,e.promiseWithResolvers=p,e.timeout=w,e.disposableTimeout=y,e.sequence=I,e.first=P,e.firstParallel=k,e.retry=W,e.createCancelableAsyncIterable=ae;function C(pe){return!!pe&&typeof pe.then=="function"}function _(pe){const ve=new s.CancellationTokenSource,Re=pe(ve.token),Fe=new Promise((Ve,Ye)=>{const Je=ve.token.onCancellationRequested(()=>{Je.dispose(),Ye(new h.CancellationError)});Promise.resolve(Re).then(xe=>{Je.dispose(),ve.dispose(),Ve(xe)},xe=>{Je.dispose(),ve.dispose(),Ye(xe)})});return new class{cancel(){ve.cancel(),ve.dispose()}then(Ve,Ye){return Fe.then(Ve,Ye)}catch(Ve){return this.then(void 0,Ve)}finally(Ve){return Fe.finally(Ve)}}}function f(pe,ve,Re){return new Promise((Fe,Ve)=>{const Ye=ve.onCancellationRequested(()=>{Ye.dispose(),Fe(Re)});pe.then(Fe,Ve).finally(()=>Ye.dispose())})}function T(pe,ve){return new Promise((Re,Fe)=>{const Ve=ve.onCancellationRequested(()=>{Ve.dispose(),Fe(new h.CancellationError)});pe.then(Re,Fe).finally(()=>Ve.dispose())})}async function S(pe){let ve=-1;const Re=pe.map((Fe,Ve)=>Fe.then(Ye=>(ve=Ve,Ye)));try{return await Promise.race(Re)}finally{pe.forEach((Fe,Ve)=>{Ve!==ve&&Fe.cancel()})}}function o(pe,ve,Re){let Fe;const Ve=setTimeout(()=>{Fe?.(void 0),Re?.()},ve);return Promise.race([pe.finally(()=>clearTimeout(Ve)),new Promise(Ye=>Fe=Ye)])}function m(pe){return new Promise((ve,Re)=>{const Fe=pe();C(Fe)?Fe.then(ve,Re):ve(Fe)})}function p(){let pe,ve;return{promise:new Promise((Fe,Ve)=>{pe=Fe,ve=Ve}),resolve:pe,reject:ve}}class u{constructor(){this.isDisposed=!1,this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(ve){if(this.isDisposed)return Promise.reject(new Error("Throttler is disposed"));if(this.activePromise){if(this.queuedPromiseFactory=ve,!this.queuedPromise){const Re=()=>{if(this.queuedPromise=null,this.isDisposed)return;const Fe=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,Fe};this.queuedPromise=new Promise(Fe=>{this.activePromise.then(Re,Re).then(Fe)})}return new Promise((Re,Fe)=>{this.queuedPromise.then(Re,Fe)})}return this.activePromise=ve(),new Promise((Re,Fe)=>{this.activePromise.then(Ve=>{this.activePromise=null,Re(Ve)},Ve=>{this.activePromise=null,Fe(Ve)})})}dispose(){this.isDisposed=!0}}e.Throttler=u;class i{constructor(){this.current=Promise.resolve(null)}queue(ve){return this.current=this.current.then(()=>ve(),()=>ve())}}e.Sequencer=i;class a{constructor(){this.promiseMap=new Map}queue(ve,Re){const Ve=(this.promiseMap.get(ve)??Promise.resolve()).catch(()=>{}).then(Re).finally(()=>{this.promiseMap.get(ve)===Ve&&this.promiseMap.delete(ve)});return this.promiseMap.set(ve,Ve),Ve}}e.SequencerByKey=a;const t=(pe,ve)=>{let Re=!0;const Fe=setTimeout(()=>{Re=!1,ve()},pe);return{isTriggered:()=>Re,dispose:()=>{clearTimeout(Fe),Re=!1}}},n=pe=>{let ve=!0;return queueMicrotask(()=>{ve&&(ve=!1,pe())}),{isTriggered:()=>ve,dispose:()=>{ve=!1}}};class r{constructor(ve){this.defaultDelay=ve,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(ve,Re=this.defaultDelay){this.task=ve,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((Ve,Ye)=>{this.doResolve=Ve,this.doReject=Ye}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const Ve=this.task;return this.task=null,Ve()}}));const Fe=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=Re===v.MicrotaskDelay?n(Fe):t(Re,Fe),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new h.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=r;class d{constructor(ve){this.delayer=new r(ve),this.throttler=new u}trigger(ve,Re){return this.delayer.trigger(()=>this.throttler.queue(ve),Re)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose(),this.throttler.dispose()}}e.ThrottledDelayer=d;class c{constructor(){this._isOpen=!1,this._promise=new Promise((ve,Re)=>{this._completePromise=ve})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=c;class g extends c{constructor(ve){super(),this._timeout=setTimeout(()=>this.open(),ve)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=g;function w(pe,ve){return ve?new Promise((Re,Fe)=>{const Ve=setTimeout(()=>{Ye.dispose(),Re()},pe),Ye=ve.onCancellationRequested(()=>{clearTimeout(Ve),Ye.dispose(),Fe(new h.CancellationError)})}):_(Re=>w(pe,Re))}function y(pe,ve=0,Re){const Fe=setTimeout(()=>{pe(),Re&&Ve.dispose()},ve),Ve=(0,A.toDisposable)(()=>{clearTimeout(Fe),Re?.deleteAndLeak(Ve)});return Re?.add(Ve),Ve}function I(pe){const ve=[];let Re=0;const Fe=pe.length;function Ve(){return Re<Fe?pe[Re++]():null}function Ye(Je){Je!=null&&ve.push(Je);const xe=Ve();return xe?xe.then(Ye):Promise.resolve(ve)}return Promise.resolve(null).then(Ye)}function P(pe,ve=Fe=>!!Fe,Re=null){let Fe=0;const Ve=pe.length,Ye=()=>{if(Fe>=Ve)return Promise.resolve(Re);const Je=pe[Fe++];return Promise.resolve(Je()).then(ze=>ve(ze)?Promise.resolve(ze):Ye())};return Ye()}function k(pe,ve=Fe=>!!Fe,Re=null){if(pe.length===0)return Promise.resolve(Re);let Fe=pe.length;const Ve=()=>{Fe=-1;for(const Ye of pe)Ye.cancel?.()};return new Promise((Ye,Je)=>{for(const xe of pe)xe.then(ze=>{--Fe>=0&&ve(ze)?(Ve(),Ye(ze)):Fe===0&&Ye(Re)}).catch(ze=>{--Fe>=0&&(Ve(),Je(ze))})})}class b{constructor(ve){this._size=0,this._isDisposed=!1,this.maxDegreeOfParalellism=ve,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new D.Emitter}whenIdle(){return this.size>0?D.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(ve){if(this._isDisposed)throw new Error("Object has been disposed");return this._size++,new Promise((Re,Fe)=>{this.outstandingPromises.push({factory:ve,c:Re,e:Fe}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const ve=this.outstandingPromises.shift();this.runningPromises++;const Re=ve.factory();Re.then(ve.c,ve.e),Re.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._isDisposed||(this.runningPromises--,--this._size===0&&this._onDrained.fire(),this.outstandingPromises.length>0&&this.consume())}clear(){if(this._isDisposed)throw new Error("Object has been disposed");this.outstandingPromises.length=0,this._size=this.runningPromises}dispose(){this._isDisposed=!0,this.outstandingPromises.length=0,this._size=0,this._onDrained.dispose()}}e.Limiter=b;class E extends b{constructor(){super(1)}}e.Queue=E;class N{constructor(){this.sequentializer=new Z,this.tasks=0}queue(ve){return this.sequentializer.isRunning()?this.sequentializer.queue(()=>this.sequentializer.run(this.tasks++,ve())):this.sequentializer.run(this.tasks++,ve())}}e.LimitedQueue=N;class O{constructor(){this.queues=new Map,this.drainers=new Set,this.drainListeners=void 0,this.drainListenerCount=0}async whenDrained(){if(this.isDrained())return;const ve=new te;return this.drainers.add(ve),ve.p}isDrained(){for(const[,ve]of this.queues)if(ve.size>0)return!1;return!0}queueSize(ve,Re=L.extUri){const Fe=Re.getComparisonKey(ve);return this.queues.get(Fe)?.size??0}queueFor(ve,Re,Fe=L.extUri){const Ve=Fe.getComparisonKey(ve);let Ye=this.queues.get(Ve);if(!Ye){Ye=new E;const Je=this.drainListenerCount++,xe=D.Event.once(Ye.onDrained)(()=>{Ye?.dispose(),this.queues.delete(Ve),this.onDidQueueDrain(),this.drainListeners?.deleteAndDispose(Je),this.drainListeners?.size===0&&(this.drainListeners.dispose(),this.drainListeners=void 0)});this.drainListeners||(this.drainListeners=new A.DisposableMap),this.drainListeners.set(Je,xe),this.queues.set(Ve,Ye)}return Ye.queue(Re)}onDidQueueDrain(){this.isDrained()&&this.releaseDrainers()}releaseDrainers(){for(const ve of this.drainers)ve.complete();this.drainers.clear()}dispose(){for(const[,ve]of this.queues)ve.dispose();this.queues.clear(),this.releaseDrainers(),this.drainListeners?.dispose()}}e.ResourceQueue=O;class M{constructor(ve,Re){this._isDisposed=!1,this._token=-1,typeof ve=="function"&&typeof Re=="number"&&this.setIfNotSet(ve,Re)}dispose(){this.cancel(),this._isDisposed=!0}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(ve,Re){if(this._isDisposed)throw new h.BugIndicatingError("Calling 'cancelAndSet' on a disposed TimeoutTimer");this.cancel(),this._token=setTimeout(()=>{this._token=-1,ve()},Re)}setIfNotSet(ve,Re){if(this._isDisposed)throw new h.BugIndicatingError("Calling 'setIfNotSet' on a disposed TimeoutTimer");this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,ve()},Re))}}e.TimeoutTimer=M;class U{constructor(){this.disposable=void 0,this.isDisposed=!1}cancel(){this.disposable?.dispose(),this.disposable=void 0}cancelAndSet(ve,Re,Fe=globalThis){if(this.isDisposed)throw new h.BugIndicatingError("Calling 'cancelAndSet' on a disposed IntervalTimer");this.cancel();const Ve=Fe.setInterval(()=>{ve()},Re);this.disposable=(0,A.toDisposable)(()=>{Fe.clearInterval(Ve),this.disposable=void 0})}dispose(){this.cancel(),this.isDisposed=!0}}e.IntervalTimer=U;class H{constructor(ve,Re){this.timeoutToken=-1,this.runner=ve,this.timeout=Re,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(ve=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,ve)}get delay(){return this.timeout}set delay(ve){this.timeout=ve}isScheduled(){return this.timeoutToken!==-1}flush(){this.isScheduled()&&(this.cancel(),this.doRun())}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}e.RunOnceScheduler=H;class F{constructor(ve,Re){Re%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${Re}ms is not a multiple of 1000ms.`),this.runner=ve,this.timeout=Re,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(ve=this.timeout){ve%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${ve}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(ve/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}e.ProcessTimeRunOnceScheduler=F;class x extends H{constructor(ve,Re){super(ve,Re),this.units=[]}work(ve){this.units.push(ve),this.isScheduled()||this.schedule()}doRun(){const ve=this.units;this.units=[],this.runner?.(ve)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=x;class $ extends A.Disposable{constructor(ve,Re){super(),this.options=ve,this.handler=Re,this.pendingWork=[],this.throttler=this._register(new A.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(ve){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+ve.length>this.options.maxBufferedWork)return!1}else if(this.pending+ve.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}for(const Re of ve)this.pendingWork.push(Re);return this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new H(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=$,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e._runWhenIdle=(pe,ve)=>{(0,R.setTimeout0)(()=>{if(Re)return;const Fe=Date.now()+15;ve(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,Fe-Date.now())}}))});let Re=!1;return{dispose(){Re||(Re=!0)}}}:e._runWhenIdle=(pe,ve,Re)=>{const Fe=pe.requestIdleCallback(ve,typeof Re=="number"?{timeout:Re}:void 0);let Ve=!1;return{dispose(){Ve||(Ve=!0,pe.cancelIdleCallback(Fe))}}},e.runWhenGlobalIdle=pe=>(0,e._runWhenIdle)(globalThis,pe)}();class G{constructor(ve,Re){this._didRun=!1,this._executor=()=>{try{this._value=Re()}catch(Fe){this._error=Fe}finally{this._didRun=!0}},this._handle=(0,e._runWhenIdle)(ve,()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.AbstractIdleValue=G;class B extends G{constructor(ve){super(globalThis,ve)}}e.GlobalIdleValue=B;async function W(pe,ve,Re){let Fe;for(let Ve=0;Ve<Re;Ve++)try{return await pe()}catch(Ye){Fe=Ye,await w(ve)}throw Fe}class Z{isRunning(ve){return typeof ve=="number"?this._running?.taskId===ve:!!this._running}get running(){return this._running?.promise}cancelRunning(){this._running?.cancel()}run(ve,Re,Fe){return this._running={taskId:ve,cancel:()=>Fe?.(),promise:Re},Re.then(()=>this.doneRunning(ve),()=>this.doneRunning(ve)),Re}doneRunning(ve){this._running&&ve===this._running.taskId&&(this._running=void 0,this.runQueued())}runQueued(){if(this._queued){const ve=this._queued;this._queued=void 0,ve.run().then(ve.promiseResolve,ve.promiseReject)}}queue(ve){if(this._queued)this._queued.run=ve;else{const{promise:Re,resolve:Fe,reject:Ve}=p();this._queued={run:ve,promise:Re,promiseResolve:Fe,promiseReject:Ve}}return this._queued.promise}hasQueued(){return!!this._queued}async join(){return this._queued?.promise??this._running?.promise}}e.TaskSequentializer=Z;class J{constructor(ve,Re=()=>Date.now()){this.interval=ve,this.nowFn=Re,this.lastIncrementTime=0,this.value=0}increment(){const ve=this.nowFn();return ve-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=ve,this.value=0),this.value++,this.value}}e.IntervalCounter=J;var oe;(function(pe){pe[pe.Resolved=0]="Resolved",pe[pe.Rejected=1]="Rejected"})(oe||(oe={}));class te{get isRejected(){return this.outcome?.outcome===oe.Rejected}get isResolved(){return this.outcome?.outcome===oe.Resolved}get isSettled(){return!!this.outcome}get value(){return this.outcome?.outcome===oe.Resolved?this.outcome?.value:void 0}constructor(){this.p=new Promise((ve,Re)=>{this.completeCallback=ve,this.errorCallback=Re})}complete(ve){return new Promise(Re=>{this.completeCallback(ve),this.outcome={outcome:oe.Resolved,value:ve},Re()})}error(ve){return new Promise(Re=>{this.errorCallback(ve),this.outcome={outcome:oe.Rejected,value:ve},Re()})}cancel(){return this.error(new h.CancellationError)}}e.DeferredPromise=te;var me;(function(pe){async function ve(Fe){let Ve;const Ye=await Promise.all(Fe.map(Je=>Je.then(xe=>xe,xe=>{Ve||(Ve=xe)})));if(typeof Ve<"u")throw Ve;return Ye}pe.settled=ve;function Re(Fe){return new Promise(async(Ve,Ye)=>{try{await Fe(Ve,Ye)}catch(Je){Ye(Je)}})}pe.withAsyncBody=Re})(me||(e.Promises=me={}));class le{get value(){return this._value}get error(){return this._error}get isResolved(){return this._isResolved}constructor(ve){this._value=void 0,this._error=void 0,this._isResolved=!1,this.promise=ve.then(Re=>(this._value=Re,this._isResolved=!0,Re),Re=>{throw this._error=Re,this._isResolved=!0,Re})}requireValue(){if(!this._isResolved)throw new h.BugIndicatingError("Promise is not resolved yet");if(this._error)throw this._error;return this._value}}e.StatefulPromise=le;class Q{constructor(ve){this._compute=ve,this._promise=new l.Lazy(()=>new le(this._compute()))}requireValue(){return this._promise.value.requireValue()}getPromise(){return this._promise.value.promise}get currentValue(){return this._promise.rawValue?.value}}e.LazyStatefulPromise=Q;var z;(function(pe){pe[pe.Initial=0]="Initial",pe[pe.DoneOK=1]="DoneOK",pe[pe.DoneError=2]="DoneError"})(z||(z={}));class se{static fromArray(ve){return new se(Re=>{Re.emitMany(ve)})}static fromPromise(ve){return new se(async Re=>{Re.emitMany(await ve)})}static fromPromises(ve){return new se(async Re=>{await Promise.all(ve.map(async Fe=>Re.emitOne(await Fe)))})}static merge(ve){return new se(async Re=>{await Promise.all(ve.map(async Fe=>{for await(const Ve of Fe)Re.emitOne(Ve)}))})}static{this.EMPTY=se.fromArray([])}constructor(ve,Re){this._state=z.Initial,this._results=[],this._error=null,this._onReturn=Re,this._onStateChanged=new D.Emitter,queueMicrotask(async()=>{const Fe={emitOne:Ve=>this.emitOne(Ve),emitMany:Ve=>this.emitMany(Ve),reject:Ve=>this.reject(Ve)};try{await Promise.resolve(ve(Fe)),this.resolve()}catch(Ve){this.reject(Ve)}finally{Fe.emitOne=void 0,Fe.emitMany=void 0,Fe.reject=void 0}})}[Symbol.asyncIterator](){let ve=0;return{next:async()=>{do{if(this._state===z.DoneError)throw this._error;if(ve<this._results.length)return{done:!1,value:this._results[ve++]};if(this._state===z.DoneOK)return{done:!0,value:void 0};await D.Event.toPromise(this._onStateChanged.event)}while(!0)},return:async()=>(this._onReturn?.(),{done:!0,value:void 0})}}static map(ve,Re){return new se(async Fe=>{for await(const Ve of ve)Fe.emitOne(Re(Ve))})}map(ve){return se.map(this,ve)}static filter(ve,Re){return new se(async Fe=>{for await(const Ve of ve)Re(Ve)&&Fe.emitOne(Ve)})}filter(ve){return se.filter(this,ve)}static coalesce(ve){return se.filter(ve,Re=>!!Re)}coalesce(){return se.coalesce(this)}static async toPromise(ve){const Re=[];for await(const Fe of ve)Re.push(Fe);return Re}toPromise(){return se.toPromise(this)}emitOne(ve){this._state===z.Initial&&(this._results.push(ve),this._onStateChanged.fire())}emitMany(ve){this._state===z.Initial&&(this._results=this._results.concat(ve),this._onStateChanged.fire())}resolve(){this._state===z.Initial&&(this._state=z.DoneOK,this._onStateChanged.fire())}reject(ve){this._state===z.Initial&&(this._state=z.DoneError,this._error=ve,this._onStateChanged.fire())}}e.AsyncIterableObject=se;class Ee extends se{constructor(ve,Re){super(Re),this._source=ve}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=Ee;function ae(pe){const ve=new s.CancellationTokenSource,Re=pe(ve.token);return new Ee(ve,async Fe=>{const Ve=ve.token.onCancellationRequested(()=>{Ve.dispose(),ve.dispose(),Fe.reject(new h.CancellationError)});try{for await(const Ye of Re){if(ve.token.isCancellationRequested)return;Fe.emitOne(Ye)}Ve.dispose(),ve.dispose()}catch(Ye){Ve.dispose(),ve.dispose(),Fe.reject(Ye)}})}class be{constructor(ve){this._deferred=new te,this._asyncIterable=new se(Ve=>{if(Re){Ve.reject(Re);return}return Fe&&Ve.emitMany(Fe),this._errorFn=Ye=>Ve.reject(Ye),this._emitFn=Ye=>Ve.emitOne(Ye),this._deferred.p},ve);let Re,Fe;this._emitFn=Ve=>{Fe||(Fe=[]),Fe.push(Ve)},this._errorFn=Ve=>{Re||(Re=Ve)}}get asyncIterable(){return this._asyncIterable}resolve(){this._deferred.complete()}reject(ve){this._errorFn(ve),this._deferred.complete()}emitOne(ve){this._emitFn(ve)}}e.AsyncIterableSource=be}),define(Pe[39],ke([1,0,18,8,26,33,28,16,10,13]),function(ge,e,s,h,D,A,L,R,v,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.GLOB_SPLIT=e.GLOBSTAR=void 0,e.getEmptyExpression=C,e.splitGlobAware=o,e.match=N,e.parse=O,e.isRelativePattern=M,e.getBasenameTerms=U,e.getPathTerms=H,e.patternsEquals=G;function C(){return Object.create(null)}e.GLOBSTAR="**",e.GLOB_SPLIT="/";const _="[/\\\\]",f="[^/\\\\]",T=/\//g;function S(B,W){switch(B){case 0:return"";case 1:return`${f}*?`;default:return`(?:${_}|${f}+${_}${W?`|${_}${f}+`:""})*?`}}function o(B,W){if(!B)return[];const Z=[];let J=!1,oe=!1,te="";for(const me of B){switch(me){case W:if(!J&&!oe){Z.push(te),te="";continue}break;case"{":J=!0;break;case"}":J=!1;break;case"[":oe=!0;break;case"]":oe=!1;break}te+=me}return te&&Z.push(te),Z}function m(B){if(!B)return"";let W="";const Z=o(B,e.GLOB_SPLIT);if(Z.every(J=>J===e.GLOBSTAR))W=".*";else{let J=!1;Z.forEach((oe,te)=>{if(oe===e.GLOBSTAR){if(J)return;W+=S(2,te===Z.length-1)}else{let me=!1,le="",Q=!1,z="";for(const se of oe){if(se!=="}"&&me){le+=se;continue}if(Q&&(se!=="]"||!z)){let Ee;se==="-"?Ee=se:(se==="^"||se==="!")&&!z?Ee="^":se===e.GLOB_SPLIT?Ee="":Ee=(0,l.escapeRegExpCharacters)(se),z+=Ee;continue}switch(se){case"{":me=!0;continue;case"[":Q=!0;continue;case"}":{const ae=`(?:${o(le,",").map(be=>m(be)).join("|")})`;W+=ae,me=!1,le="";break}case"]":{W+="["+z+"]",Q=!1,z="";break}case"?":W+=f;continue;case"*":W+=S(1);continue;default:W+=(0,l.escapeRegExpCharacters)(se)}}te<Z.length-1&&(Z[te+1]!==e.GLOBSTAR||te+2<Z.length)&&(W+=_)}J=oe===e.GLOBSTAR})}return W}const p=/^\*\*\/\*\.[\w\.-]+$/,u=/^\*\*\/([\w\.-]+)\/?$/,i=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,a=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,t=/^\*\*((\/[\w\.-]+)+)\/?$/,n=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,r=new L.LRUCache(1e4),d=function(){return!1},c=function(){return null};function g(B,W){if(!B)return c;let Z;typeof B!="string"?Z=B.pattern:Z=B,Z=Z.trim();const J=`${Z}_${!!W.trimForExclusions}`;let oe=r.get(J);if(oe)return w(oe,B);let te;return p.test(Z)?oe=I(Z.substr(4),Z):(te=u.exec(y(Z,W)))?oe=P(te[1],Z):(W.trimForExclusions?a:i).test(Z)?oe=k(Z,W):(te=t.exec(y(Z,W)))?oe=b(te[1].substr(1),Z,!0):(te=n.exec(y(Z,W)))?oe=b(te[1],Z,!1):oe=E(Z),r.set(J,oe),w(oe,B)}function w(B,W){if(typeof W=="string")return B;const Z=function(J,oe){return(0,A.isEqualOrParent)(J,W.base,!v.isLinux)?B((0,l.ltrim)(J.substr(W.base.length),R.sep),oe):null};return Z.allBasenames=B.allBasenames,Z.allPaths=B.allPaths,Z.basenames=B.basenames,Z.patterns=B.patterns,Z}function y(B,W){return W.trimForExclusions&&B.endsWith("/**")?B.substr(0,B.length-2):B}function I(B,W){return function(Z,J){return typeof Z=="string"&&Z.endsWith(B)?W:null}}function P(B,W){const Z=`/${B}`,J=`\\${B}`,oe=function(me,le){return typeof me!="string"?null:le?le===B?W:null:me===B||me.endsWith(Z)||me.endsWith(J)?W:null},te=[B];return oe.basenames=te,oe.patterns=[W],oe.allBasenames=te,oe}function k(B,W){const Z=$(B.slice(1,-1).split(",").map(le=>g(le,W)).filter(le=>le!==c),B),J=Z.length;if(!J)return c;if(J===1)return Z[0];const oe=function(le,Q){for(let z=0,se=Z.length;z<se;z++)if(Z[z](le,Q))return B;return null},te=Z.find(le=>!!le.allBasenames);te&&(oe.allBasenames=te.allBasenames);const me=Z.reduce((le,Q)=>Q.allPaths?le.concat(Q.allPaths):le,[]);return me.length&&(oe.allPaths=me),oe}function b(B,W,Z){const J=R.sep===R.posix.sep,oe=J?B:B.replace(T,R.sep),te=R.sep+oe,me=R.posix.sep+B;let le;return Z?le=function(Q,z){return typeof Q=="string"&&(Q===oe||Q.endsWith(te)||!J&&(Q===B||Q.endsWith(me)))?W:null}:le=function(Q,z){return typeof Q=="string"&&(Q===oe||!J&&Q===B)?W:null},le.allPaths=[(Z?"*/":"./")+B],le}function E(B){try{const W=new RegExp(`^${m(B)}$`);return function(Z){return W.lastIndex=0,typeof Z=="string"&&W.test(Z)?B:null}}catch{return c}}function N(B,W,Z){return!B||typeof W!="string"?!1:O(B)(W,void 0,Z)}function O(B,W={}){if(!B)return d;if(typeof B=="string"||M(B)){const Z=g(B,W);if(Z===c)return d;const J=function(oe,te){return!!Z(oe,te)};return Z.allBasenames&&(J.allBasenames=Z.allBasenames),Z.allPaths&&(J.allPaths=Z.allPaths),J}return F(B,W)}function M(B){const W=B;return W?typeof W.base=="string"&&typeof W.pattern=="string":!1}function U(B){return B.allBasenames||[]}function H(B){return B.allPaths||[]}function F(B,W){const Z=$(Object.getOwnPropertyNames(B).map(le=>x(le,B[le],W)).filter(le=>le!==c)),J=Z.length;if(!J)return c;if(!Z.some(le=>!!le.requiresSiblings)){if(J===1)return Z[0];const le=function(se,Ee){let ae;for(let be=0,pe=Z.length;be<pe;be++){const ve=Z[be](se,Ee);if(typeof ve=="string")return ve;(0,h.isThenable)(ve)&&(ae||(ae=[]),ae.push(ve))}return ae?(async()=>{for(const be of ae){const pe=await be;if(typeof pe=="string")return pe}return null})():null},Q=Z.find(se=>!!se.allBasenames);Q&&(le.allBasenames=Q.allBasenames);const z=Z.reduce((se,Ee)=>Ee.allPaths?se.concat(Ee.allPaths):se,[]);return z.length&&(le.allPaths=z),le}const oe=function(le,Q,z){let se,Ee;for(let ae=0,be=Z.length;ae<be;ae++){const pe=Z[ae];pe.requiresSiblings&&z&&(Q||(Q=(0,R.basename)(le)),se||(se=Q.substr(0,Q.length-(0,R.extname)(le).length)));const ve=pe(le,Q,se,z);if(typeof ve=="string")return ve;(0,h.isThenable)(ve)&&(Ee||(Ee=[]),Ee.push(ve))}return Ee?(async()=>{for(const ae of Ee){const be=await ae;if(typeof be=="string")return be}return null})():null},te=Z.find(le=>!!le.allBasenames);te&&(oe.allBasenames=te.allBasenames);const me=Z.reduce((le,Q)=>Q.allPaths?le.concat(Q.allPaths):le,[]);return me.length&&(oe.allPaths=me),oe}function x(B,W,Z){if(W===!1)return c;const J=g(B,Z);if(J===c)return c;if(typeof W=="boolean")return J;if(W){const oe=W.when;if(typeof oe=="string"){const te=(me,le,Q,z)=>{if(!z||!J(me,le))return null;const se=oe.replace("$(basename)",()=>Q),Ee=z(se);return(0,h.isThenable)(Ee)?Ee.then(ae=>ae?B:null):Ee?B:null};return te.requiresSiblings=!0,te}}return J}function $(B,W){const Z=B.filter(le=>!!le.basenames);if(Z.length<2)return B;const J=Z.reduce((le,Q)=>{const z=Q.basenames;return z?le.concat(z):le},[]);let oe;if(W){oe=[];for(let le=0,Q=J.length;le<Q;le++)oe.push(W)}else oe=Z.reduce((le,Q)=>{const z=Q.patterns;return z?le.concat(z):le},[]);const te=function(le,Q){if(typeof le!="string")return null;if(!Q){let se;for(se=le.length;se>0;se--){const Ee=le.charCodeAt(se-1);if(Ee===D.CharCode.Slash||Ee===D.CharCode.Backslash)break}Q=le.substr(se)}const z=J.indexOf(Q);return z!==-1?oe[z]:null};te.basenames=J,te.patterns=oe,te.allBasenames=J;const me=B.filter(le=>!le.basenames);return me.push(te),me}function G(B,W){return(0,s.equals)(B,W,(Z,J)=>typeof Z=="string"&&typeof J=="string"?Z===J:typeof Z!="string"&&typeof J!="string"?Z.base===J.base&&Z.pattern===J.pattern:!1)}}),define(Pe[86],ke([1,0,12,137,22,13,2]),function(ge,e,s,h,D,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0,e.isEmptyMarkdownString=l,e.isMarkdownString=C,e.markdownStringEqual=_,e.escapeMarkdownSyntaxTokens=f,e.appendEscapedMarkdownCodeBlockFence=T,e.escapeDoubleQuotes=S,e.removeMarkdownEscapes=o,e.parseHrefAndDimensions=m;var R;(function(p){p[p.Paragraph=0]="Paragraph",p[p.Break=1]="Break"})(R||(e.MarkdownStringTextNewlineStyle=R={}));class v{constructor(u="",i=!1){if(this.value=u,typeof this.value!="string")throw(0,s.illegalArgument)("value");typeof i=="boolean"?(this.isTrusted=i,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=i.isTrusted??void 0,this.supportThemeIcons=i.supportThemeIcons??!1,this.supportHtml=i.supportHtml??!1)}appendText(u,i=R.Paragraph){return this.value+=f(this.supportThemeIcons?(0,h.escapeIcons)(u):u).replace(/([ \t]+)/g,(a,t)=>"&nbsp;".repeat(t.length)).replace(/\>/gm,"\\>").replace(/\n/g,i===R.Break?`\\
`:`

`),this}appendMarkdown(u){return this.value+=u,this}appendCodeblock(u,i){return this.value+=`
${T(i,u)}
`,this}appendLink(u,i,a){return this.value+="[",this.value+=this._escape(i,"]"),this.value+="](",this.value+=this._escape(String(u),")"),a&&(this.value+=` "${this._escape(this._escape(a,'"'),")")}"`),this.value+=")",this}_escape(u,i){const a=new RegExp((0,A.escapeRegExpCharacters)(i),"g");return u.replace(a,(t,n)=>u.charAt(n-1)!=="\\"?`\\${t}`:t)}}e.MarkdownString=v;function l(p){return C(p)?!p.value:Array.isArray(p)?p.every(l):!0}function C(p){return p instanceof v?!0:p&&typeof p=="object"?typeof p.value=="string"&&(typeof p.isTrusted=="boolean"||typeof p.isTrusted=="object"||p.isTrusted===void 0)&&(typeof p.supportThemeIcons=="boolean"||p.supportThemeIcons===void 0):!1}function _(p,u){return p===u?!0:!p||!u?!1:p.value===u.value&&p.isTrusted===u.isTrusted&&p.supportThemeIcons===u.supportThemeIcons&&p.supportHtml===u.supportHtml&&(p.baseUri===u.baseUri||!!p.baseUri&&!!u.baseUri&&(0,D.isEqual)(L.URI.from(p.baseUri),L.URI.from(u.baseUri)))}function f(p){return p.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}function T(p,u){const i=p.match(/^`+/gm)?.reduce((t,n)=>t.length>n.length?t:n).length??0,a=i>=3?i+1:3;return[`${"`".repeat(a)}${u}`,p,`${"`".repeat(a)}`].join(`
`)}function S(p){return p.replace(/"/g,"&quot;")}function o(p){return p&&p.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}function m(p){const u=[],i=p.split("|").map(t=>t.trim());p=i[0];const a=i[1];if(a){const t=/height=(\d+)/.exec(a),n=/width=(\d+)/.exec(a),r=t?t[1]:"",d=n?n[1]:"",c=isFinite(parseInt(d)),g=isFinite(parseInt(r));c&&u.push(`width="${d}"`),g&&u.push(`height="${r}"`)}return{href:p,dimensions:u}}}),define(Pe[109],ke([1,0,18,33,16,10,22,13]),function(ge,e,s,h,D,A,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathLabel=v,e.normalizeDriveLetter=C,e.tildify=f,e.untildify=T,e.shorten=p,e.template=i,e.mnemonicMenuLabel=a,e.mnemonicButtonLabel=t,e.unmnemonicLabel=n,e.splitRecentLabel=r;function v(c,g){const{os:w,tildify:y,relative:I}=g;if(I){const b=l(c,I,w);if(typeof b=="string")return b}let P=c.fsPath;if(w===A.OperatingSystem.Windows&&!A.isWindows?P=P.replace(/\//g,"\\"):w!==A.OperatingSystem.Windows&&A.isWindows&&(P=P.replace(/\\/g,"/")),w!==A.OperatingSystem.Windows&&y?.userHome){const b=y.userHome.fsPath;let E;c.scheme!==y.userHome.scheme&&c.path[0]===D.posix.sep&&c.path[1]!==D.posix.sep?E=y.userHome.with({path:c.path}).fsPath:E=P,P=f(E,b,w)}return(w===A.OperatingSystem.Windows?D.win32:D.posix).normalize(C(P,w===A.OperatingSystem.Windows))}function l(c,g,w){const y=w===A.OperatingSystem.Windows?D.win32:D.posix,I=w===A.OperatingSystem.Linux?L.extUri:L.extUriIgnorePathCase,P=g.getWorkspace(),k=(0,s.firstOrDefault)(P.folders);if(!k)return;c.scheme!==k.uri.scheme&&c.path[0]===D.posix.sep&&c.path[1]!==D.posix.sep&&(c=k.uri.with({path:c.path}));const b=g.getWorkspaceFolder(c);if(!b)return;let E;if(I.isEqual(b.uri,c)?E="":E=I.relativePath(b.uri,c)??"",E&&(E=y.normalize(E)),P.folders.length>1&&!g.noPrefix){const N=b.name?b.name:I.basenameOrAuthority(b.uri);E=E?`${N} \u2022 ${E}`:N}return E}function C(c,g=A.isWindows){return(0,h.hasDriveLetter)(c,g)?c.charAt(0).toUpperCase()+c.slice(1):c}let _=Object.create(null);function f(c,g,w=A.OS){if(w===A.OperatingSystem.Windows||!c||!g)return c;let y=_.original===g?_.normalized:void 0;y||(y=g,A.isWindows&&(y=(0,h.toSlashes)(y)),y=`${(0,R.rtrim)(y,D.posix.sep)}${D.posix.sep}`,_={original:g,normalized:y});let I=c;return A.isWindows&&(I=(0,h.toSlashes)(I)),(w===A.OperatingSystem.Linux?I.startsWith(y):(0,R.startsWithIgnoreCase)(I,y))?`~/${I.substr(y.length)}`:c}function T(c,g){return c.replace(/^~($|\/|\\)/,`${g}$1`)}const S="\u2026",o="\\\\",m="~";function p(c,g=D.sep){const w=new Array(c.length);let y=!1;for(let I=0;I<c.length;I++){const P=c[I];if(P===""){w[I]=`.${g}`;continue}if(!P){w[I]=P;continue}y=!0;let k="",b=P;b.indexOf(o)===0?(k=b.substr(0,b.indexOf(o)+o.length),b=b.substr(b.indexOf(o)+o.length)):b.indexOf(g)===0?(k=b.substr(0,b.indexOf(g)+g.length),b=b.substr(b.indexOf(g)+g.length)):b.indexOf(m)===0&&(k=b.substr(0,b.indexOf(m)+m.length),b=b.substr(b.indexOf(m)+m.length));const E=b.split(g);for(let N=1;y&&N<=E.length;N++)for(let O=E.length-N;y&&O>=0;O--){y=!1;let M=E.slice(O,O+N).join(g);for(let U=0;!y&&U<c.length;U++)if(U!==I&&c[U]&&c[U].indexOf(M)>-1){const H=O+N===E.length,F=O>0&&c[U].indexOf(g)>-1?g+M:M,x=c[U].endsWith(F);y=!H||x}if(!y){let U="";(E[0].endsWith(":")||k!=="")&&(O===1&&(O=0,N++,M=E[0]+g+M),O>0&&(U=E[0]+g),U=k+U),O>0&&(U=U+S+g),U=U+M,O+N<E.length&&(U=U+g+S),w[I]=U}}y&&(w[I]=P)}return w}var u;(function(c){c[c.TEXT=0]="TEXT",c[c.VARIABLE=1]="VARIABLE",c[c.SEPARATOR=2]="SEPARATOR"})(u||(u={}));function i(c,g=Object.create(null)){const w=[];let y=!1,I="";for(const P of c)if(P==="$"||y&&P==="{")I&&w.push({value:I,type:u.TEXT}),I="",y=!0;else if(P==="}"&&y){const k=g[I];if(typeof k=="string")k.length&&w.push({value:k,type:u.VARIABLE});else if(k){const b=w[w.length-1];(!b||b.type!==u.SEPARATOR)&&w.push({value:k.label,type:u.SEPARATOR})}I="",y=!1}else I+=P;return I&&!y&&w.push({value:I,type:u.TEXT}),w.filter((P,k)=>{if(P.type===u.SEPARATOR){const b=w[k-1],E=w[k+1];return[b,E].every(N=>N&&(N.type===u.VARIABLE||N.type===u.TEXT)&&N.value.length>0)}return!0}).map(P=>P.value).join("")}function a(c,g){return A.isMacintosh||g?c.replace(/\(&&\w\)|&&/g,"").replace(/&/g,A.isMacintosh?"&":"&&"):c.replace(/&&|&/g,w=>w==="&"?"&&":"&")}function t(c,g){return A.isMacintosh||g?c.replace(/\(&&\w\)|&&/g,""):A.isWindows?c.replace(/&&|&/g,w=>w==="&"?"&&":"&"):c.replace(/&&/g,"_")}function n(c){return c.replace(/&/g,"&&")}function r(c){if(c.endsWith("]")){const g=c.lastIndexOf(" [",c.length-2);if(g!==-1){const w=d(c.substring(0,g)),y=c.substring(g);return{name:w.name+y,parentPath:w.parentPath}}}return d(c)}function d(c){const g=c.indexOf("/")!==-1?D.posix:D.win32,w=g.basename(c),y=g.dirname(c);return w.length?{name:w,parentPath:y}:{name:y,parentPath:""}}}),define(Pe[145],ke([1,0,21,41,2]),function(ge,e,s,h,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DefaultURITransformer=e.URITransformer=void 0,e.transformOutgoingURIs=v,e.transformIncomingURIs=C,e.transformAndReviveIncomingURIs=_;function A(f){return f.toJSON()}class L{constructor(T){this._uriTransformer=T}transformIncoming(T){const S=this._uriTransformer.transformIncoming(T);return S===T?T:A(D.URI.from(S))}transformOutgoing(T){const S=this._uriTransformer.transformOutgoing(T);return S===T?T:A(D.URI.from(S))}transformOutgoingURI(T){const S=this._uriTransformer.transformOutgoing(T);return S===T?T:D.URI.from(S)}transformOutgoingScheme(T){return this._uriTransformer.transformOutgoingScheme(T)}}e.URITransformer=L,e.DefaultURITransformer=new class{transformIncoming(f){return f}transformOutgoing(f){return f}transformOutgoingURI(f){return f}transformOutgoingScheme(f){return f}};function R(f,T,S){if(!f||S>200)return null;if(typeof f=="object"){if(f instanceof D.URI)return T.transformOutgoing(f);for(const o in f)if(Object.hasOwnProperty.call(f,o)){const m=R(f[o],T,S+1);m!==null&&(f[o]=m)}}return null}function v(f,T){const S=R(f,T,0);return S===null?f:S}function l(f,T,S,o){if(!f||o>200)return null;if(typeof f=="object"){if(f.$mid===h.MarshalledId.Uri)return S?D.URI.revive(T.transformIncoming(f)):T.transformIncoming(f);if(f instanceof s.VSBuffer)return null;for(const m in f)if(Object.hasOwnProperty.call(f,m)){const p=l(f[m],T,S,o+1);p!==null&&(f[m]=p)}}return null}function C(f,T){const S=l(f,T,!1,0);return S===null?f:S}function _(f,T){const S=l(f,T,!0,0);return S===null?f:S}}),define(Pe[34],ke([1,0,45,69,362,8,33,83,16,10,22,2]),function(ge,e,s,h,D,A,L,R,v,l,C,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.SymlinkSupport=e.RimRafMode=void 0,e.rimrafSync=m,e.readdirSync=i,e.whenDeleted=n,e.configureFlushOnWrite=w,e.writeFileSync=I,s=We(s);var f;(function(F){F[F.UNLINK=0]="UNLINK",F[F.MOVE=1]="MOVE"})(f||(e.RimRafMode=f={}));async function T(F,x=f.UNLINK,$){if((0,L.isRootOrDriveLetter)(F))throw new Error("rimraf - will refuse to recursively delete root");return x===f.UNLINK?o(F):S(F,$)}async function S(F,x=(0,L.randomPath)((0,h.tmpdir)())){try{try{await s.promises.rename(F,x)}catch($){return $.code==="ENOENT"?void 0:o(F)}o(x).catch($=>{})}catch($){if($.code!=="ENOENT")throw $}}async function o(F){return s.promises.rm(F,{recursive:!0,force:!0,maxRetries:3})}function m(F){if((0,L.isRootOrDriveLetter)(F))throw new Error("rimraf - will refuse to recursively delete root");s.rmSync(F,{recursive:!0,force:!0,maxRetries:3})}async function p(F,x){return a(await(x?u(F):s.promises.readdir(F)))}async function u(F){try{return await s.promises.readdir(F,{withFileTypes:!0})}catch(G){console.warn("[node.js fs] readdir with filetypes failed with error: ",G)}const x=[],$=await p(F);for(const G of $){let B=!1,W=!1,Z=!1;try{const J=await s.promises.lstat((0,v.join)(F,G));B=J.isFile(),W=J.isDirectory(),Z=J.isSymbolicLink()}catch(J){console.warn("[node.js fs] unexpected error from lstat after readdir: ",J)}x.push({name:G,isFile:()=>B,isDirectory:()=>W,isSymbolicLink:()=>Z})}return x}function i(F){return a(s.readdirSync(F))}function a(F){return F.map(x=>typeof x=="string"?l.isMacintosh?(0,R.normalizeNFC)(x):x:(x.name=l.isMacintosh?(0,R.normalizeNFC)(x.name):x.name,x))}async function t(F){const x=await p(F),$=[];for(const G of x)await r.existsDirectory((0,v.join)(F,G))&&$.push(G);return $}function n(F,x=1e3){return new Promise($=>{let G=!1;const B=setInterval(()=>{G||(G=!0,s.access(F,W=>{G=!1,W&&(clearInterval(B),$(void 0))}))},x)})}var r;(function(F){async function x(B){let W;try{if(W=await s.promises.lstat(B),!W.isSymbolicLink())return{stat:W}}catch{}try{return{stat:await s.promises.stat(B),symbolicLink:W?.isSymbolicLink()?{dangling:!1}:void 0}}catch(Z){if(Z.code==="ENOENT"&&W)return{stat:W,symbolicLink:{dangling:!0}};if(l.isWindows&&Z.code==="EACCES")try{return{stat:await s.promises.stat(await s.promises.readlink(B)),symbolicLink:{dangling:!1}}}catch(J){if(J.code==="ENOENT"&&W)return{stat:W,symbolicLink:{dangling:!0}};throw J}throw Z}}F.stat=x;async function $(B){try{const{stat:W,symbolicLink:Z}=await F.stat(B);return W.isFile()&&Z?.dangling!==!0}catch{}return!1}F.existsFile=$;async function G(B){try{const{stat:W,symbolicLink:Z}=await F.stat(B);return W.isDirectory()&&Z?.dangling!==!0}catch{}return!1}F.existsDirectory=G})(r||(e.SymlinkSupport=r={}));const d=new A.ResourceQueue;function c(F,x,$){return d.queueFor(_.URI.file(F),()=>{const G=P($);return new Promise((B,W)=>y(F,x,G,Z=>Z?W(Z):B()))},C.extUriBiasedIgnorePathCase)}let g=!0;function w(F){g=F}function y(F,x,$,G){if(!g)return s.writeFile(F,x,{mode:$.mode,flag:$.flag},G);s.open(F,$.flag,$.mode,(B,W)=>{if(B)return G(B);s.writeFile(W,x,Z=>{if(Z)return s.close(W,()=>G(Z));s.fdatasync(W,J=>(J&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",J),w(!1)),s.close(W,oe=>G(oe))))})})}function I(F,x,$){const G=P($);if(!g)return s.writeFileSync(F,x,{mode:G.mode,flag:G.flag});const B=s.openSync(F,G.flag,G.mode);try{s.writeFileSync(B,x);try{s.fdatasyncSync(B)}catch(W){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",W),w(!1)}}finally{s.closeSync(B)}}function P(F){return F?{mode:typeof F.mode=="number"?F.mode:438,flag:typeof F.flag=="string"?F.flag:"w"}:{mode:438,flag:"w"}}async function k(F,x,$=6e4){if(F!==x)try{l.isWindows&&typeof $=="number"?await b(F,x,Date.now(),$):await s.promises.rename(F,x)}catch(G){if(F.toLowerCase()!==x.toLowerCase()&&G.code==="EXDEV"||F.endsWith("."))await E(F,x,{preserveSymlinks:!1}),await T(F,f.MOVE);else throw G}}async function b(F,x,$,G,B=0){try{return await s.promises.rename(F,x)}catch(W){if(W.code!=="EACCES"&&W.code!=="EPERM"&&W.code!=="EBUSY")throw W;if(Date.now()-$>=G)throw console.error(`[node.js fs] rename failed after ${B} retries with error: ${W}`),W;if(B===0){let Z=!1;try{const{stat:J}=await r.stat(x);J.isFile()||(Z=!0)}catch{}if(Z)throw W}return await(0,A.timeout)(Math.min(100,B*10)),b(F,x,$,G,B+1)}}async function E(F,x,$){return O(F,x,{root:{source:F,target:x},options:$,handledSourcePaths:new Set})}const N=511;async function O(F,x,$){if($.handledSourcePaths.has(F))return;$.handledSourcePaths.add(F);const{stat:G,symbolicLink:B}=await r.stat(F);if(B){if($.options.preserveSymlinks)try{return await H(F,x,$)}catch{}if(B.dangling)return}return G.isDirectory()?M(F,x,G.mode&N,$):U(F,x,G.mode&N)}async function M(F,x,$,G){await s.promises.mkdir(x,{recursive:!0,mode:$});const B=await p(F);for(const W of B)await O((0,v.join)(F,W),(0,v.join)(x,W),G)}async function U(F,x,$){await s.promises.copyFile(F,x),await s.promises.chmod(x,$)}async function H(F,x,$){let G=await s.promises.readlink(F);(0,L.isEqualOrParent)(G,$.root.source,!l.isLinux)&&(G=(0,v.join)($.root.target,G.substr($.root.source.length+1))),await s.promises.symlink(G,x)}e.Promises=new class{get read(){return(F,x,$,G,B)=>new Promise((W,Z)=>{s.read(F,x,$,G,B,(J,oe,te)=>J?Z(J):W({bytesRead:oe,buffer:te}))})}get write(){return(F,x,$,G,B)=>new Promise((W,Z)=>{s.write(F,x,$,G,B,(J,oe,te)=>J?Z(J):W({bytesWritten:oe,buffer:te}))})}get fdatasync(){return(0,D.promisify)(s.fdatasync)}get open(){return(0,D.promisify)(s.open)}get close(){return(0,D.promisify)(s.close)}get realpath(){return(0,D.promisify)(s.realpath)}async exists(F){try{return await s.promises.access(F),!0}catch{return!1}}get readdir(){return p}get readDirsInDir(){return t}get writeFile(){return c}get rm(){return T}get rename(){return k}get copy(){return E}}}),define(Pe[110],ke([1,0,45,16,10,13,34]),function(ge,e,s,h,D,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realcaseSync=R,e.realcase=v,e.realpath=l,e.realpathSync=C,s=We(s);function R(f){if(D.isLinux)return f;const T=(0,h.dirname)(f);if(f===T)return f;const S=((0,h.basename)(f)||f).toLowerCase();try{const m=(0,L.readdirSync)(T).filter(p=>p.toLowerCase()===S);if(m.length===1){const p=R(T);if(p)return(0,h.join)(p,m[0])}else if(m.length>1){const p=m.indexOf(S);if(p>=0){const u=R(T);if(u)return(0,h.join)(u,m[p])}}}catch{}return null}async function v(f,T){if(D.isLinux)return f;const S=(0,h.dirname)(f);if(f===S)return f;const o=((0,h.basename)(f)||f).toLowerCase();try{if(T?.isCancellationRequested)return null;const p=(await L.Promises.readdir(S)).filter(u=>u.toLowerCase()===o);if(p.length===1){const u=await v(S,T);if(u)return(0,h.join)(u,p[0])}else if(p.length>1){const u=p.indexOf(o);if(u>=0){const i=await v(S,T);if(i)return(0,h.join)(i,p[u])}}}catch{}return null}async function l(f){try{return await L.Promises.realpath(f)}catch{const S=_(f);return await s.promises.access(S,s.constants.R_OK),S}}function C(f){try{return s.realpathSync(f)}catch{const S=_(f);return s.accessSync(S,s.constants.R_OK),S}}function _(f){return(0,A.rtrim)((0,h.normalize)(f),h.sep)}}),define(Pe[111],ke([1,0,45,16,10,57,108,17,34]),function(ge,e,s,h,D,A,L,R,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.TerminateResponseCode=e.Source=void 0,e.getWindowsShell=l,e.createQueuedSender=C,h=We(h),D=We(D),A=We(A),R=We(R),v=We(v),Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return L.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return L.TerminateResponseCode}});function l(f=A.env){return f.comspec||"cmd.exe"}function C(f){let T=[],S=!1;const o=function(m){if(S){T.push(m);return}(!f.send(m,u=>{if(u&&console.error(u),S=!1,T.length>0){const i=T.slice(0);T=[],i.forEach(a=>o(a))}})||D.isWindows)&&(S=!0)};return{send:o}}var _;(function(f){async function T(S,o,m){if(h.isAbsolute(S))return S;if(o===void 0&&(o=A.cwd()),h.dirname(S)!=="."||(m===void 0&&R.isString(A.env.PATH)&&(m=A.env.PATH.split(h.delimiter)),m===void 0||m.length===0))return h.join(o,S);async function u(i){if(await v.Promises.exists(i)){let a;try{a=await s.promises.stat(i)}catch(t){t.message.startsWith("EACCES")&&(a=await s.promises.lstat(i))}return a?!a.isDirectory():!1}return!1}for(const i of m){let a;if(h.isAbsolute(i)?a=h.join(i,S):a=h.join(o,i,S),await u(a))return a;let t=a+".com";if(await u(t)||(t=a+".exe",await u(t)))return t}return h.join(o,S)}f.findExecutable=T})(_||(e.win32=_={}))});var Qe=this&&this.__decorate||function(ge,e,s,h){var D=arguments.length,A=D<3?e:h===null?h=Object.getOwnPropertyDescriptor(e,s):h,L;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")A=Reflect.decorate(ge,e,s,h);else for(var R=ge.length-1;R>=0;R--)(L=ge[R])&&(A=(D<3?L(A):D>3?L(e,s,A):L(e,s))||A);return D>3&&A&&Object.defineProperty(e,s,A),A};define(Pe[87],ke([1,0,18,8,21,20,60,12,4,3,38,13,17]),function(ge,e,s,h,D,A,L,R,v,l,C,_,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.ProxyChannel=e.StaticRouter=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.BufferWriter=e.BufferReader=void 0,e.serialize=w,e.deserialize=y,e.getDelayedChannel=N,e.getNextTickChannel=O,_=We(_);var T;(function(B){B[B.Promise=100]="Promise",B[B.PromiseCancel=101]="PromiseCancel",B[B.EventListen=102]="EventListen",B[B.EventDispose=103]="EventDispose"})(T||(T={}));function S(B){switch(B){case T.Promise:return"req";case T.PromiseCancel:return"cancel";case T.EventListen:return"subscribe";case T.EventDispose:return"unsubscribe"}}var o;(function(B){B[B.Initialize=200]="Initialize",B[B.PromiseSuccess=201]="PromiseSuccess",B[B.PromiseError=202]="PromiseError",B[B.PromiseErrorObj=203]="PromiseErrorObj",B[B.EventFire=204]="EventFire"})(o||(o={}));function m(B){switch(B){case o.Initialize:return"init";case o.PromiseSuccess:return"reply:";case o.PromiseError:case o.PromiseErrorObj:return"replyErr:";case o.EventFire:return"event:"}}var p;(function(B){B[B.Uninitialized=0]="Uninitialized",B[B.Idle=1]="Idle"})(p||(p={}));function u(B){let W=0;for(let Z=0;;Z+=7){const J=B.read(1);if(W|=(J.buffer[0]&127)<<Z,!(J.buffer[0]&128))return W}}const i=d(0);function a(B,W){if(W===0){B.write(i);return}let Z=0;for(let oe=W;oe!==0;oe=oe>>>7)Z++;const J=D.VSBuffer.alloc(Z);for(let oe=0;W!==0;oe++)J.buffer[oe]=W&127,W=W>>>7,W>0&&(J.buffer[oe]|=128);B.write(J)}class t{constructor(W){this.buffer=W,this.pos=0}read(W){const Z=this.buffer.slice(this.pos,this.pos+W);return this.pos+=Z.byteLength,Z}}e.BufferReader=t;class n{constructor(){this.buffers=[]}get buffer(){return D.VSBuffer.concat(this.buffers)}write(W){this.buffers.push(W)}}e.BufferWriter=n;var r;(function(B){B[B.Undefined=0]="Undefined",B[B.String=1]="String",B[B.Buffer=2]="Buffer",B[B.VSBuffer=3]="VSBuffer",B[B.Array=4]="Array",B[B.Object=5]="Object",B[B.Int=6]="Int"})(r||(r={}));function d(B){const W=D.VSBuffer.alloc(1);return W.writeUInt8(B,0),W}const c={Undefined:d(r.Undefined),String:d(r.String),Buffer:d(r.Buffer),VSBuffer:d(r.VSBuffer),Array:d(r.Array),Object:d(r.Object),Uint:d(r.Int)},g=typeof Buffer<"u";function w(B,W){if(typeof W>"u")B.write(c.Undefined);else if(typeof W=="string"){const Z=D.VSBuffer.fromString(W);B.write(c.String),a(B,Z.byteLength),B.write(Z)}else if(g&&Buffer.isBuffer(W)){const Z=D.VSBuffer.wrap(W);B.write(c.Buffer),a(B,Z.byteLength),B.write(Z)}else if(W instanceof D.VSBuffer)B.write(c.VSBuffer),a(B,W.byteLength),B.write(W);else if(Array.isArray(W)){B.write(c.Array),a(B,W.length);for(const Z of W)w(B,Z)}else if(typeof W=="number"&&(W|0)===W)B.write(c.Uint),a(B,W);else{const Z=D.VSBuffer.fromString(JSON.stringify(W));B.write(c.Object),a(B,Z.byteLength),B.write(Z)}}function y(B){switch(B.read(1).readUInt8(0)){case r.Undefined:return;case r.String:return B.read(u(B)).toString();case r.Buffer:return B.read(u(B)).buffer;case r.VSBuffer:return B.read(u(B));case r.Array:{const Z=u(B),J=[];for(let oe=0;oe<Z;oe++)J.push(y(B));return J}case r.Object:return JSON.parse(B.read(u(B)).toString());case r.Int:return u(B)}}class I{constructor(W,Z,J=null,oe=1e3){this.protocol=W,this.ctx=Z,this.logger=J,this.timeoutDelay=oe,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(te=>this.onRawMessage(te)),this.sendResponse({type:o.Initialize})}registerChannel(W,Z){this.channels.set(W,Z),setTimeout(()=>this.flushPendingRequests(W),0)}sendResponse(W){switch(W.type){case o.Initialize:{const Z=this.send([W.type]);this.logger?.logOutgoing(Z,0,P.OtherSide,m(W.type));return}case o.PromiseSuccess:case o.PromiseError:case o.EventFire:case o.PromiseErrorObj:{const Z=this.send([W.type,W.id],W.data);this.logger?.logOutgoing(Z,W.id,P.OtherSide,m(W.type),W.data);return}}}send(W,Z=void 0){const J=new n;return w(J,W),w(J,Z),this.sendBuffer(J.buffer)}sendBuffer(W){try{return this.protocol.send(W),W.byteLength}catch{return 0}}onRawMessage(W){const Z=new t(W),J=y(Z),oe=y(Z),te=J[0];switch(te){case T.Promise:return this.logger?.logIncoming(W.byteLength,J[1],P.OtherSide,`${S(te)}: ${J[2]}.${J[3]}`,oe),this.onPromise({type:te,id:J[1],channelName:J[2],name:J[3],arg:oe});case T.EventListen:return this.logger?.logIncoming(W.byteLength,J[1],P.OtherSide,`${S(te)}: ${J[2]}.${J[3]}`,oe),this.onEventListen({type:te,id:J[1],channelName:J[2],name:J[3],arg:oe});case T.PromiseCancel:return this.logger?.logIncoming(W.byteLength,J[1],P.OtherSide,`${S(te)}`),this.disposeActiveRequest({type:te,id:J[1]});case T.EventDispose:return this.logger?.logIncoming(W.byteLength,J[1],P.OtherSide,`${S(te)}`),this.disposeActiveRequest({type:te,id:J[1]})}}onPromise(W){const Z=this.channels.get(W.channelName);if(!Z){this.collectPendingRequest(W);return}const J=new A.CancellationTokenSource;let oe;try{oe=Z.call(this.ctx,W.name,W.arg,J.token)}catch(le){oe=Promise.reject(le)}const te=W.id;oe.then(le=>{this.sendResponse({id:te,data:le,type:o.PromiseSuccess})},le=>{le instanceof Error?this.sendResponse({id:te,data:{message:le.message,name:le.name,stack:le.stack?le.stack.split(`
`):void 0},type:o.PromiseError}):this.sendResponse({id:te,data:le,type:o.PromiseErrorObj})}).finally(()=>{me.dispose(),this.activeRequests.delete(W.id)});const me=(0,l.toDisposable)(()=>J.cancel());this.activeRequests.set(W.id,me)}onEventListen(W){const Z=this.channels.get(W.channelName);if(!Z){this.collectPendingRequest(W);return}const J=W.id,te=Z.listen(this.ctx,W.name,W.arg)(me=>this.sendResponse({id:J,data:me,type:o.EventFire}));this.activeRequests.set(W.id,te)}disposeActiveRequest(W){const Z=this.activeRequests.get(W.id);Z&&(Z.dispose(),this.activeRequests.delete(W.id))}collectPendingRequest(W){let Z=this.pendingRequests.get(W.channelName);Z||(Z=[],this.pendingRequests.set(W.channelName,Z));const J=setTimeout(()=>{console.error(`Unknown channel: ${W.channelName}`),W.type===T.Promise&&this.sendResponse({id:W.id,data:{name:"Unknown channel",message:`Channel name '${W.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:o.PromiseError})},this.timeoutDelay);Z.push({request:W,timeoutTimer:J})}flushPendingRequests(W){const Z=this.pendingRequests.get(W);if(Z){for(const J of Z)switch(clearTimeout(J.timeoutTimer),J.request.type){case T.Promise:this.onPromise(J.request);break;case T.EventListen:this.onEventListen(J.request);break}this.pendingRequests.delete(W)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,l.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelServer=I;var P;(function(B){B[B.LocalSide=0]="LocalSide",B[B.OtherSide=1]="OtherSide"})(P||(e.RequestInitiator=P={}));class k{constructor(W,Z=null){this.protocol=W,this.isDisposed=!1,this.state=p.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new v.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(J=>this.onBuffer(J)),this.logger=Z}getChannel(W){const Z=this;return{call(J,oe,te){return Z.isDisposed?Promise.reject(new R.CancellationError):Z.requestPromise(W,J,oe,te)},listen(J,oe){return Z.isDisposed?v.Event.None:Z.requestEvent(W,J,oe)}}}requestPromise(W,Z,J,oe=A.CancellationToken.None){const te=this.lastRequestId++,me=T.Promise,le={id:te,type:me,channelName:W,name:Z,arg:J};if(oe.isCancellationRequested)return Promise.reject(new R.CancellationError);let Q;return new Promise((se,Ee)=>{if(oe.isCancellationRequested)return Ee(new R.CancellationError);const ae=()=>{const Re=Fe=>{switch(Fe.type){case o.PromiseSuccess:this.handlers.delete(te),se(Fe.data);break;case o.PromiseError:{this.handlers.delete(te);const Ve=new Error(Fe.data.message);Ve.stack=Array.isArray(Fe.data.stack)?Fe.data.stack.join(`
`):Fe.data.stack,Ve.name=Fe.data.name,Ee(Ve);break}case o.PromiseErrorObj:this.handlers.delete(te),Ee(Fe.data);break}};this.handlers.set(te,Re),this.sendRequest(le)};let be=null;this.state===p.Idle?ae():(be=(0,h.createCancelablePromise)(Re=>this.whenInitialized()),be.then(()=>{be=null,ae()}));const pe=()=>{be?(be.cancel(),be=null):this.sendRequest({id:te,type:T.PromiseCancel}),Ee(new R.CancellationError)},ve=oe.onCancellationRequested(pe);Q=(0,l.combinedDisposable)((0,l.toDisposable)(pe),ve),this.activeRequests.add(Q)}).finally(()=>{Q.dispose(),this.activeRequests.delete(Q)})}requestEvent(W,Z,J){const oe=this.lastRequestId++,te=T.EventListen,me={id:oe,type:te,channelName:W,name:Z,arg:J};let le=null;const Q=new v.Emitter({onWillAddFirstListener:()=>{le=(0,h.createCancelablePromise)(se=>this.whenInitialized()),le.then(()=>{le=null,this.activeRequests.add(Q),this.sendRequest(me)})},onDidRemoveLastListener:()=>{le?(le.cancel(),le=null):(this.activeRequests.delete(Q),this.sendRequest({id:oe,type:T.EventDispose}))}}),z=se=>Q.fire(se.data);return this.handlers.set(oe,z),Q.event}sendRequest(W){switch(W.type){case T.Promise:case T.EventListen:{const Z=this.send([W.type,W.id,W.channelName,W.name],W.arg);this.logger?.logOutgoing(Z,W.id,P.LocalSide,`${S(W.type)}: ${W.channelName}.${W.name}`,W.arg);return}case T.PromiseCancel:case T.EventDispose:{const Z=this.send([W.type,W.id]);this.logger?.logOutgoing(Z,W.id,P.LocalSide,S(W.type));return}}}send(W,Z=void 0){const J=new n;return w(J,W),w(J,Z),this.sendBuffer(J.buffer)}sendBuffer(W){try{return this.protocol.send(W),W.byteLength}catch{return 0}}onBuffer(W){const Z=new t(W),J=y(Z),oe=y(Z),te=J[0];switch(te){case o.Initialize:return this.logger?.logIncoming(W.byteLength,0,P.LocalSide,m(te)),this.onResponse({type:J[0]});case o.PromiseSuccess:case o.PromiseError:case o.EventFire:case o.PromiseErrorObj:return this.logger?.logIncoming(W.byteLength,J[1],P.LocalSide,m(te),oe),this.onResponse({type:J[0],id:J[1],data:oe})}}onResponse(W){if(W.type===o.Initialize){this.state=p.Idle,this._onDidInitialize.fire();return}this.handlers.get(W.id)?.(W)}get onDidInitializePromise(){return v.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===p.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,l.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelClient=k,Qe([L.memoize],k.prototype,"onDidInitializePromise",null);class b{get connections(){const W=[];return this._connections.forEach(Z=>W.push(Z)),W}constructor(W,Z,J){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new v.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new v.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,this.disposables=new l.DisposableStore,this.disposables.add(W(({protocol:oe,onDidClientDisconnect:te})=>{const me=v.Event.once(oe.onMessage);this.disposables.add(me(le=>{const Q=new t(le),z=y(Q),se=new I(oe,z,Z,J),Ee=new k(oe,Z);this.channels.forEach((be,pe)=>se.registerChannel(pe,be));const ae={channelServer:se,channelClient:Ee,ctx:z};this._connections.add(ae),this._onDidAddConnection.fire(ae),this.disposables.add(te(()=>{se.dispose(),Ee.dispose(),this._connections.delete(ae),this._onDidRemoveConnection.fire(ae)}))}))}))}getChannel(W,Z){const J=this;return{call(oe,te,me){let le;if((0,f.isFunction)(Z)){const z=(0,s.getRandomElement)(J.connections.filter(Z));le=z?Promise.resolve(z):v.Event.toPromise(v.Event.filter(J.onDidAddConnection,Z))}else le=Z.routeCall(J,oe,te);const Q=le.then(z=>z.channelClient.getChannel(W));return N(Q).call(oe,te,me)},listen(oe,te){if((0,f.isFunction)(Z))return J.getMulticastEvent(W,Z,oe,te);const me=Z.routeEvent(J,oe,te).then(le=>le.channelClient.getChannel(W));return N(me).listen(oe,te)}}}getMulticastEvent(W,Z,J,oe){const te=this;let me;const le=new v.Emitter({onWillAddFirstListener:()=>{me=new l.DisposableStore;const Q=new v.EventMultiplexer,z=new Map,se=ae=>{const pe=ae.channelClient.getChannel(W).listen(J,oe),ve=Q.add(pe);z.set(ae,ve)},Ee=ae=>{const be=z.get(ae);be&&(be.dispose(),z.delete(ae))};te.connections.filter(Z).forEach(se),v.Event.filter(te.onDidAddConnection,Z)(se,void 0,me),te.onDidRemoveConnection(Ee,void 0,me),Q.event(le.fire,le,me),me.add(Q)},onDidRemoveLastListener:()=>{me?.dispose(),me=void 0}});return le.event}registerChannel(W,Z){this.channels.set(W,Z);for(const J of this._connections)J.channelServer.registerChannel(W,Z)}dispose(){this.disposables.dispose();for(const W of this._connections)W.channelClient.dispose(),W.channelServer.dispose();this._connections.clear(),this.channels.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=b;class E{constructor(W,Z,J=null){const oe=new n;w(oe,Z),W.send(oe.buffer),this.channelClient=new k(W,J),this.channelServer=new I(W,Z,J)}getChannel(W){return this.channelClient.getChannel(W)}registerChannel(W,Z){this.channelServer.registerChannel(W,Z)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=E;function N(B){return{call(W,Z,J){return B.then(oe=>oe.call(W,Z,J))},listen(W,Z){const J=new v.Relay;return B.then(oe=>J.input=oe.listen(W,Z)),J.event}}}function O(B){let W=!1;return{call(Z,J,oe){return W?B.call(Z,J,oe):(0,h.timeout)(0).then(()=>W=!0).then(()=>B.call(Z,J,oe))},listen(Z,J){if(W)return B.listen(Z,J);const oe=new v.Relay;return(0,h.timeout)(0).then(()=>W=!0).then(()=>oe.input=B.listen(Z,J)),oe.event}}}class M{constructor(W){this.fn=W}routeCall(W){return this.route(W)}routeEvent(W){return this.route(W)}async route(W){for(const Z of W.connections)if(await Promise.resolve(this.fn(Z.ctx)))return Promise.resolve(Z);return await v.Event.toPromise(W.onDidAddConnection),await this.route(W)}}e.StaticRouter=M;var U;(function(B){function W(te,me,le){const Q=te,z=le&&le.disableMarshalling,se=new Map;for(const Ee in Q)J(Ee)&&se.set(Ee,v.Event.buffer(Q[Ee],!0,void 0,me));return new class{listen(Ee,ae,be){const pe=se.get(ae);if(pe)return pe;const ve=Q[ae];if(typeof ve=="function"){if(oe(ae))return ve.call(Q,be);if(J(ae))return se.set(ae,v.Event.buffer(Q[ae],!0,void 0,me)),se.get(ae)}throw new R.ErrorNoTelemetry(`Event not found: ${ae}`)}call(Ee,ae,be){const pe=Q[ae];if(typeof pe=="function"){if(!z&&Array.isArray(be))for(let Re=0;Re<be.length;Re++)be[Re]=(0,C.revive)(be[Re]);let ve=pe.apply(Q,be);return ve instanceof Promise||(ve=Promise.resolve(ve)),ve}throw new R.ErrorNoTelemetry(`Method not found: ${ae}`)}}}B.fromService=W;function Z(te,me){const le=me&&me.disableMarshalling;return new Proxy({},{get(Q,z){if(typeof z=="string")return me?.properties?.has(z)?me.properties.get(z):oe(z)?function(se){return te.listen(z,se)}:J(z)?te.listen(z):async function(...se){let Ee;me&&!(0,f.isUndefinedOrNull)(me.context)?Ee=[me.context,...se]:Ee=se;const ae=await te.call(z,Ee);return le?ae:(0,C.revive)(ae)};throw new R.ErrorNoTelemetry(`Property not found: ${String(z)}`)}})}B.toService=Z;function J(te){return te[0]==="o"&&te[1]==="n"&&_.isUpperAsciiLetter(te.charCodeAt(2))}function oe(te){return/^onDynamic/.test(te)&&_.isUpperAsciiLetter(te.charCodeAt(9))}})(U||(e.ProxyChannel=U={}));const H=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function F(B){if(Array.isArray(B))return B;if(B&&typeof B=="object"&&typeof B.toString=="function"){const W=B.toString();if(W!=="[object Object]")return W}return B}function x(B){return Array.isArray(B)?B.map(F):F(B)}function $(B,W,Z,J,oe,te,me){me=x(me);const le=H[oe],Q=le[J%le.length];let z=[`%c[${B}]%c[${String(W).padStart(7," ")}]%c[len: ${String(Z).padStart(5," ")}]%c${String(J).padStart(5," ")} - ${te}`,"color: darkgreen","color: grey","color: grey",`color: ${Q}`];/\($/.test(te)?(z=z.concat(me),z.push(")")):z.push(me),console.log.apply(console,z)}class G{constructor(W,Z){this._outgoingPrefix=W,this._incomingPrefix=Z,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(W,Z,J,oe,te){this._totalOutgoing+=W,$(this._outgoingPrefix,this._totalOutgoing,W,Z,J,oe,te)}logIncoming(W,Z,J,oe,te){this._totalIncoming+=W,$(this._incomingPrefix,this._totalIncoming,W,Z,J,oe,te)}}e.IPCLogger=G}),define(Pe[70],ke([1,0,21,4,3,87]),function(ge,e,s,h,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var L;(function(c){c.Created="created",c.Read="read",c.Write="write",c.Open="open",c.Error="error",c.Close="close",c.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",c.NodeEndReceived="nodeEndReceived",c.NodeEndSent="nodeEndSent",c.NodeDrainBegin="nodeDrainBegin",c.NodeDrainEnd="nodeDrainEnd",c.zlibInflateError="zlibInflateError",c.zlibInflateData="zlibInflateData",c.zlibInflateInitialWrite="zlibInflateInitialWrite",c.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",c.zlibInflateWrite="zlibInflateWrite",c.zlibInflateFlushFired="zlibInflateFlushFired",c.zlibDeflateError="zlibDeflateError",c.zlibDeflateData="zlibDeflateData",c.zlibDeflateWrite="zlibDeflateWrite",c.zlibDeflateFlushFired="zlibDeflateFlushFired",c.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",c.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",c.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",c.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",c.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",c.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",c.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",c.ProtocolHeaderRead="protocolHeaderRead",c.ProtocolMessageRead="protocolMessageRead",c.ProtocolHeaderWrite="protocolHeaderWrite",c.ProtocolMessageWrite="protocolMessageWrite",c.ProtocolWrite="protocolWrite"})(L||(e.SocketDiagnosticsEventType=L={}));var R;(function(c){c.enableDiagnostics=!1,c.records=[];const g=new WeakMap;let w=0;function y(P,k){if(!g.has(P)){const b=String(++w);g.set(P,b)}return g.get(P)}function I(P,k,b,E){if(!c.enableDiagnostics)return;const N=y(P,k);if(E instanceof s.VSBuffer||E instanceof Uint8Array||E instanceof ArrayBuffer||ArrayBuffer.isView(E)){const O=s.VSBuffer.alloc(E.byteLength);O.set(E),c.records.push({timestamp:Date.now(),id:N,label:k,type:b,buff:O})}else c.records.push({timestamp:Date.now(),id:N,label:k,type:b,data:E})}c.traceSocketEvent=I})(R||(e.SocketDiagnostics=R={}));var v;(function(c){c[c.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",c[c.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(v||(e.SocketCloseEventType=v={}));let l=null;function C(){return l||(l=s.VSBuffer.alloc(0)),l}class _{get byteLength(){return this._totalLength}constructor(){this._chunks=[],this._totalLength=0}acceptChunk(g){this._chunks.push(g),this._totalLength+=g.byteLength}read(g){return this._read(g,!0)}peek(g){return this._read(g,!1)}_read(g,w){if(g===0)return C();if(g>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===g){const k=this._chunks[0];return w&&(this._chunks.shift(),this._totalLength-=g),k}if(this._chunks[0].byteLength>g){const k=this._chunks[0].slice(0,g);return w&&(this._chunks[0]=this._chunks[0].slice(g),this._totalLength-=g),k}const y=s.VSBuffer.alloc(g);let I=0,P=0;for(;g>0;){const k=this._chunks[P];if(k.byteLength>g){const b=k.slice(0,g);y.set(b,I),I+=g,w&&(this._chunks[P]=k.slice(g),this._totalLength-=g),g-=g}else y.set(k,I),I+=k.byteLength,w?(this._chunks.shift(),this._totalLength-=k.byteLength):P++,g-=k.byteLength}return y}}e.ChunkStream=_;var f;(function(c){c[c.None=0]="None",c[c.Regular=1]="Regular",c[c.Control=2]="Control",c[c.Ack=3]="Ack",c[c.Disconnect=5]="Disconnect",c[c.ReplayRequest=6]="ReplayRequest",c[c.Pause=7]="Pause",c[c.Resume=8]="Resume",c[c.KeepAlive=9]="KeepAlive"})(f||(f={}));function T(c){switch(c){case f.None:return"None";case f.Regular:return"Regular";case f.Control:return"Control";case f.Ack:return"Ack";case f.Disconnect:return"Disconnect";case f.ReplayRequest:return"ReplayRequest";case f.Pause:return"PauseWriting";case f.Resume:return"ResumeWriting";case f.KeepAlive:return"KeepAlive"}}var S;(function(c){c[c.HeaderLength=13]="HeaderLength",c[c.AcknowledgeTime=2e3]="AcknowledgeTime",c[c.TimeoutTime=2e4]="TimeoutTime",c[c.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",c[c.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",c[c.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(S||(e.ProtocolConstants=S={}));class o{constructor(g,w,y,I){this.type=g,this.id=w,this.ack=y,this.data=I,this.writtenTime=0}get size(){return this.data.byteLength}}class m extends D.Disposable{constructor(g){super(),this._onMessage=this._register(new h.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:S.HeaderLength,messageType:f.None,id:0,ack:0},this._socket=g,this._isDisposed=!1,this._incomingData=new _,this._register(this._socket.onData(w=>this.acceptChunk(w))),this.lastReadTime=Date.now()}acceptChunk(g){if(!(!g||g.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(g);this._incomingData.byteLength>=this._state.readLen;){const w=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=w.readUInt32BE(9),this._state.messageType=w.readUInt8(0),this._state.id=w.readUInt32BE(1),this._state.ack=w.readUInt32BE(5),this._socket.traceSocketEvent(L.ProtocolHeaderRead,{messageType:T(this._state.messageType),id:this._state.id,ack:this._state.ack,messageSize:this._state.readLen});else{const y=this._state.messageType,I=this._state.id,P=this._state.ack;if(this._state.readHead=!0,this._state.readLen=S.HeaderLength,this._state.messageType=f.None,this._state.id=0,this._state.ack=0,this._socket.traceSocketEvent(L.ProtocolMessageRead,w),this._onMessage.fire(new o(y,I,P,w)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class p{constructor(g){this._writeNowTimeout=null,this._isDisposed=!1,this._isPaused=!1,this._socket=g,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}pause(){this._isPaused=!0}resume(){this._isPaused=!1,this._scheduleWriting()}write(g){if(this._isDisposed)return;g.writtenTime=Date.now(),this.lastWriteTime=Date.now();const w=s.VSBuffer.alloc(S.HeaderLength);w.writeUInt8(g.type,0),w.writeUInt32BE(g.id,1),w.writeUInt32BE(g.ack,5),w.writeUInt32BE(g.data.byteLength,9),this._socket.traceSocketEvent(L.ProtocolHeaderWrite,{messageType:T(g.type),id:g.id,ack:g.ack,messageSize:g.data.byteLength}),this._socket.traceSocketEvent(L.ProtocolMessageWrite,g.data),this._writeSoon(w,g.data)}_bufferAdd(g,w){const y=this._totalLength===0;return this._data.push(g,w),this._totalLength+=g.byteLength+w.byteLength,y}_bufferTake(){const g=s.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,g}_writeSoon(g,w){this._bufferAdd(g,w)&&this._scheduleWriting()}_scheduleWriting(){this._writeNowTimeout||(this._writeNowTimeout=setTimeout(()=>{this._writeNowTimeout=null,this._writeNow()}))}_writeNow(){if(this._totalLength===0||this._isPaused)return;const g=this._bufferTake();this._socket.traceSocketEvent(L.ProtocolWrite,{byteLength:g.byteLength}),this._socket.write(g)}}class u extends D.Disposable{constructor(g){super(),this._onMessage=new h.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new h.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=g,this._socketWriter=this._register(new p(this._socket)),this._socketReader=this._register(new m(this._socket)),this._register(this._socketReader.onMessage(w=>{w.type===f.Regular&&this._onMessage.fire(w.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(g){this._socketWriter.write(new o(f.Regular,0,0,g))}}e.Protocol=u;class i extends A.IPCClient{static fromSocket(g,w){return new i(new u(g),w)}get onDidDispose(){return this.protocol.onDidDispose}constructor(g,w,y=null){super(g,w,y),this.protocol=g}dispose(){super.dispose();const g=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),g.end()}}e.Client=i;class a{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new h.Emitter({onWillAddFirstListener:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onDidRemoveLastListener:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(g){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(g):this._emitter.fire(g):this._bufferedMessages.push(g)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=a;class t{constructor(g){this.data=g,this.next=null}}class n{constructor(){this._first=null,this._last=null}length(){let g=0,w=this._first;for(;w;)w=w.next,g++;return g}peek(){return this._first?this._first.data:null}toArray(){const g=[];let w=0,y=this._first;for(;y;)g[w++]=y.data,y=y.next;return g}pop(){if(this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(g){const w=new t(g);if(!this._first){this._first=w,this._last=w;return}this._last.next=w,this._last=w}}class r{static{this._HISTORY_LENGTH=10}static{this._INSTANCE=null}static getInstance(){return r._INSTANCE||(r._INSTANCE=new r),r._INSTANCE}constructor(){this.lastRuns=[];const g=Date.now();for(let w=0;w<r._HISTORY_LENGTH;w++)this.lastRuns[w]=g-1e3*w;setInterval(()=>{for(let w=r._HISTORY_LENGTH;w>=1;w--)this.lastRuns[w]=this.lastRuns[w-1];this.lastRuns[0]=Date.now()},1e3)}load(){const g=Date.now(),w=(1+r._HISTORY_LENGTH)*1e3;let y=0;for(let I=0;I<r._HISTORY_LENGTH;I++)g-this.lastRuns[I]<=w&&y++;return 1-y/r._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}class d{get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}constructor(g){this._onControlMessage=new a,this.onControlMessage=this._onControlMessage.event,this._onMessage=new a,this.onMessage=this._onMessage.event,this._onDidDispose=new a,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new a,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new a,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=g.loadEstimator??r.getInstance(),this._shouldSendKeepAlive=g.sendKeepAlive??!0,this._isReconnecting=!1,this._outgoingUnackMsg=new n,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socketDisposables=new D.DisposableStore,this._socket=g.socket,this._socketWriter=this._socketDisposables.add(new p(this._socket)),this._socketReader=this._socketDisposables.add(new m(this._socket)),this._socketDisposables.add(this._socketReader.onMessage(w=>this._receiveMessage(w))),this._socketDisposables.add(this._socket.onClose(w=>this._onSocketClose.fire(w))),g.initialChunk&&this._socketReader.acceptChunk(g.initialChunk),this._shouldSendKeepAlive?this._keepAliveInterval=setInterval(()=>{this._sendKeepAlive()},S.KeepAliveSendTime):this._keepAliveInterval=null}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._keepAliveInterval&&(clearInterval(this._keepAliveInterval),this._keepAliveInterval=null),this._socketDisposables.dispose()}drain(){return this._socketWriter.drain()}sendDisconnect(){if(!this._didSendDisconnect){this._didSendDisconnect=!0;const g=new o(f.Disconnect,0,0,C());this._socketWriter.write(g),this._socketWriter.flush()}}sendPause(){const g=new o(f.Pause,0,0,C());this._socketWriter.write(g)}sendResume(){const g=new o(f.Resume,0,0,C());this._socketWriter.write(g)}pauseSocketWriting(){this._socketWriter.pause()}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(g,w){this._isReconnecting=!0,this._socketDisposables.dispose(),this._socketDisposables=new D.DisposableStore,this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socket=g,this._socketWriter=this._socketDisposables.add(new p(this._socket)),this._socketReader=this._socketDisposables.add(new m(this._socket)),this._socketDisposables.add(this._socketReader.onMessage(y=>this._receiveMessage(y))),this._socketDisposables.add(this._socket.onClose(y=>this._onSocketClose.fire(y))),this._socketReader.acceptChunk(w)}endAcceptReconnection(){this._isReconnecting=!1,this._incomingAckId=this._incomingMsgId;const g=new o(f.Ack,0,this._incomingAckId,C());this._socketWriter.write(g);const w=this._outgoingUnackMsg.toArray();for(let y=0,I=w.length;y<I;y++)this._socketWriter.write(w[y]);this._recvAckCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(g){if(g.ack>this._outgoingAckId){this._outgoingAckId=g.ack;do{const w=this._outgoingUnackMsg.peek();if(w&&w.id<=g.ack)this._outgoingUnackMsg.pop();else break}while(!0)}switch(g.type){case f.None:break;case f.Regular:{if(g.id>this._incomingMsgId)if(g.id!==this._incomingMsgId+1){const w=Date.now();w-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=w,this._socketWriter.write(new o(f.ReplayRequest,0,0,C())))}else this._incomingMsgId=g.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(g.data);break}case f.Control:{this._onControlMessage.fire(g.data);break}case f.Ack:break;case f.Disconnect:{this._onDidDispose.fire();break}case f.ReplayRequest:{const w=this._outgoingUnackMsg.toArray();for(let y=0,I=w.length;y<I;y++)this._socketWriter.write(w[y]);this._recvAckCheck();break}case f.Pause:{this._socketWriter.pause();break}case f.Resume:{this._socketWriter.resume();break}case f.KeepAlive:break}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(g){const w=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const y=new o(f.Regular,w,this._incomingAckId,g);this._outgoingUnackMsg.push(y),this._isReconnecting||(this._socketWriter.write(y),this._recvAckCheck())}sendControl(g){const w=new o(f.Control,0,0,g);this._socketWriter.write(w)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const g=Date.now()-this._incomingMsgLastTime;if(g>=S.AcknowledgeTime){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},S.AcknowledgeTime-g+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const g=this._outgoingUnackMsg.peek(),w=Date.now()-g.writtenTime,y=Date.now()-this._socketReader.lastReadTime,I=Date.now()-this._lastSocketTimeoutTime;if(w>=S.TimeoutTime&&y>=S.TimeoutTime&&I>=S.TimeoutTime&&!this._loadEstimator.hasHighLoad()){this._lastSocketTimeoutTime=Date.now(),this._onSocketTimeout.fire({unacknowledgedMsgCount:this._outgoingUnackMsg.length(),timeSinceOldestUnacknowledgedMsg:w,timeSinceLastReceivedSomeData:y});return}const P=Math.max(S.TimeoutTime-w,S.TimeoutTime-y,S.TimeoutTime-I,500);this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},P)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const g=new o(f.Ack,0,this._incomingAckId,C());this._socketWriter.write(g)}_sendKeepAlive(){this._incomingAckId=this._incomingMsgId;const g=new o(f.KeepAlive,0,this._incomingAckId,C());this._socketWriter.write(g)}}e.PersistentProtocol=d}),define(Pe[209],ke([1,0,58,8,21,20,208,12,4,3,24,111,108,87]),function(ge,e,s,h,D,A,L,R,v,l,C,_,f,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0,R=We(R);class S extends T.ChannelServer{constructor(p){super({send:u=>{try{process.send?.(u.buffer.toString("base64"))}catch{}},onMessage:v.Event.fromNodeEventEmitter(process,"message",u=>D.VSBuffer.wrap(Buffer.from(u,"base64")))},p),process.once("disconnect",()=>this.dispose())}}e.Server=S;class o{constructor(p,u){this.modulePath=p,this.options=u,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new v.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const i=u&&u.timeout?u.timeout:6e4;this.disposeDelayer=new h.Delayer(i),this.child=null,this._client=null}getChannel(p){const u=this;return{call(i,a,t){return u.requestPromise(p,i,a,t)},listen(i,a){return u.requestEvent(p,i,a)}}}requestPromise(p,u,i,a=A.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(a.isCancellationRequested)return Promise.reject(R.canceled());this.disposeDelayer.cancel();const t=this.getCachedChannel(p),n=(0,h.createCancelablePromise)(c=>t.call(u,i,c)),r=a.onCancellationRequested(()=>n.cancel()),d=(0,l.toDisposable)(()=>n.cancel());return this.activeRequests.add(d),n.finally(()=>{r.dispose(),this.activeRequests.delete(d),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),n}requestEvent(p,u,i){if(!this.disposeDelayer)return v.Event.None;this.disposeDelayer.cancel();let a;const t=new v.Emitter({onWillAddFirstListener:()=>{a=this.getCachedChannel(p).listen(u,i)(t.fire,t),this.activeRequests.add(a)},onDidRemoveLastListener:()=>{this.activeRequests.delete(a),a.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return t.event}get client(){if(!this._client){const p=this.options&&this.options.args?this.options.args:[],u=Object.create(null);u.env={...(0,C.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(u.env={...u.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(u.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(u.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(u.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),u.execArgv===void 0&&(u.execArgv=process.execArgv.filter(w=>!/^--inspect(-brk)?=/.test(w)).filter(w=>!w.startsWith("--vscode-"))),(0,f.removeDangerousEnvVariables)(u.env),this.child=(0,s.fork)(this.modulePath,p,u);const i=new v.Emitter,t=v.Event.fromNodeEventEmitter(this.child,"message",w=>w)(w=>{if((0,L.isRemoteConsoleLog)(w)){(0,L.log)(w,`IPC Library: ${this.options.serverName}`);return}i.fire(D.VSBuffer.wrap(Buffer.from(w,"base64")))}),n=this.options.useQueue?(0,_.createQueuedSender)(this.child):this.child,r=w=>this.child&&this.child.connected&&n.send(w.buffer.toString("base64")),d=i.event,c={send:r,onMessage:d};this._client=new T.ChannelClient(c);const g=()=>this.disposeClient();process.once("exit",g),this.child.on("error",w=>console.warn('IPC "'+this.options.serverName+'" errored with '+w)),this.child.on("exit",(w,y)=>{process.removeListener("exit",g),t.dispose(),this.activeRequests.forEach(I=>(0,l.dispose)(I)),this.activeRequests.clear(),w!==0&&y!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+w+" and signal "+y),this.disposeDelayer?.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:w,signal:y})})}return this._client}getCachedChannel(p){let u=this.channels.get(p);return u||(u=this.client.getChannel(p),this.channels.set(p,u)),u}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer?.cancel(),this.disposeDelayer=void 0,this.disposeClient(),this.activeRequests.clear()}}e.Client=o}),define(Pe[210],ke([1,0,8,4,3,38,17]),function(ge,e,s,h,D,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.StorageHint=void 0,e.isStorageItemsChangeEvent=v;var R;(function(f){f[f.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",f[f.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(R||(e.StorageHint=R={}));function v(f){const T=f;return T?.changed instanceof Map||T?.deleted instanceof Set}var l;(function(f){f[f.None=0]="None",f[f.Initialized=1]="Initialized",f[f.Closed=2]="Closed"})(l||(e.StorageState=l={}));class C extends D.Disposable{static{this.DEFAULT_FLUSH_DELAY=100}constructor(T,S=Object.create(null)){super(),this.database=T,this.options=S,this._onDidChangeStorage=this._register(new h.PauseableEmitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=l.None,this.cache=new Map,this.flushDelayer=this._register(new s.ThrottledDelayer(C.DEFAULT_FLUSH_DELAY)),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(T=>this.onDidChangeItemsExternal(T)))}onDidChangeItemsExternal(T){this._onDidChangeStorage.pause();try{T.changed?.forEach((S,o)=>this.acceptExternal(o,S)),T.deleted?.forEach(S=>this.acceptExternal(S,void 0))}finally{this._onDidChangeStorage.resume()}}acceptExternal(T,S){if(this.state===l.Closed)return;let o=!1;(0,L.isUndefinedOrNull)(S)?o=this.cache.delete(T):this.cache.get(T)!==S&&(this.cache.set(T,S),o=!0),o&&this._onDidChangeStorage.fire({key:T,external:!0})}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===l.None&&(this.state=l.Initialized,this.options.hint!==R.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(T,S){const o=this.cache.get(T);return(0,L.isUndefinedOrNull)(o)?S:o}getBoolean(T,S){const o=this.get(T);return(0,L.isUndefinedOrNull)(o)?S:o==="true"}getNumber(T,S){const o=this.get(T);return(0,L.isUndefinedOrNull)(o)?S:parseInt(o,10)}getObject(T,S){const o=this.get(T);return(0,L.isUndefinedOrNull)(o)?S:(0,A.parse)(o)}async set(T,S,o=!1){if(this.state===l.Closed)return;if((0,L.isUndefinedOrNull)(S))return this.delete(T,o);const m=(0,L.isObject)(S)||Array.isArray(S)?(0,A.stringify)(S):String(S);if(this.cache.get(T)!==m)return this.cache.set(T,m),this.pendingInserts.set(T,m),this.pendingDeletes.delete(T),this._onDidChangeStorage.fire({key:T,external:o}),this.doFlush()}async delete(T,S=!1){if(!(this.state===l.Closed||!this.cache.delete(T)))return this.pendingDeletes.has(T)||this.pendingDeletes.add(T),this.pendingInserts.delete(T),this._onDidChangeStorage.fire({key:T,external:S}),this.doFlush()}async optimize(){if(this.state!==l.Closed)return await this.flush(0),this.database.optimize()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=l.Closed;try{await this.doFlush(0)}catch{}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const T={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(T).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(T){if(!(this.state===l.Closed||this.pendingClose))return this.doFlush(T)}async doFlush(T){return this.options.hint===R.STORAGE_IN_MEMORY?this.flushPending():this.flushDelayer.trigger(()=>this.flushPending(),T)}async whenFlushed(){if(this.hasPending)return new Promise(T=>this.whenFlushedCallbacks.push(T))}isInMemory(){return this.options.hint===R.STORAGE_IN_MEMORY}}e.Storage=C;class _{constructor(){this.onDidChangeItemsExternal=h.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(T){T.insert?.forEach((S,o)=>this.items.set(o,S)),T.delete?.forEach(S=>this.items.delete(S))}async optimize(){}async close(){}}e.InMemoryStorageDatabase=_}),define(Pe[211],ke([1,0,13,10,21]),function(ge,e,s,h,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringBuilder=void 0,e.getPlatformTextDecoder=C,e.decodeUTF16LE=_,s=We(s),h=We(h),D=We(D);let A;function L(){return A||(A=new TextDecoder("UTF-16LE")),A}let R;function v(){return R||(R=new TextDecoder("UTF-16BE")),R}let l;function C(){return l||(l=h.isLittleEndian()?L():v()),l}function _(S,o,m){const p=new Uint16Array(S.buffer,o,m);return m>0&&(p[0]===65279||p[0]===65534)?f(S,o,m):L().decode(p)}function f(S,o,m){const p=[];let u=0;for(let i=0;i<m;i++){const a=D.readUInt16LE(S,o);o+=2,p[u++]=String.fromCharCode(a)}return p.join("")}class T{constructor(o){this._capacity=o|0,this._buffer=new Uint16Array(this._capacity),this._completedStrings=null,this._bufferLength=0}reset(){this._completedStrings=null,this._bufferLength=0}build(){return this._completedStrings!==null?(this._flushBuffer(),this._completedStrings.join("")):this._buildBuffer()}_buildBuffer(){if(this._bufferLength===0)return"";const o=new Uint16Array(this._buffer.buffer,0,this._bufferLength);return C().decode(o)}_flushBuffer(){const o=this._buildBuffer();this._bufferLength=0,this._completedStrings===null?this._completedStrings=[o]:this._completedStrings[this._completedStrings.length]=o}appendCharCode(o){const m=this._capacity-this._bufferLength;m<=1&&(m===0||s.isHighSurrogate(o))&&this._flushBuffer(),this._buffer[this._bufferLength++]=o}appendASCIICharCode(o){this._bufferLength===this._capacity&&this._flushBuffer(),this._buffer[this._bufferLength++]=o}appendString(o){const m=o.length;if(this._bufferLength+m>=this._capacity){this._flushBuffer(),this._completedStrings[this._completedStrings.length]=o;return}for(let p=0;p<m;p++)this._buffer[this._bufferLength++]=o.charCodeAt(p)}}e.StringBuilder=T}),define(Pe[212],ke([1,0,21,211]),function(ge,e,s,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextChange=void 0,e.compressConsecutiveTextChanges=L,s=We(s);function D(v){return v.replace(/\n/g,"\\n").replace(/\r/g,"\\r")}class A{get oldLength(){return this.oldText.length}get oldEnd(){return this.oldPosition+this.oldText.length}get newLength(){return this.newText.length}get newEnd(){return this.newPosition+this.newText.length}constructor(l,C,_,f){this.oldPosition=l,this.oldText=C,this.newPosition=_,this.newText=f}toString(){return this.oldText.length===0?`(insert@${this.oldPosition} "${D(this.newText)}")`:this.newText.length===0?`(delete@${this.oldPosition} "${D(this.oldText)}")`:`(replace@${this.oldPosition} "${D(this.oldText)}" with "${D(this.newText)}")`}static _writeStringSize(l){return 4+2*l.length}static _writeString(l,C,_){const f=C.length;s.writeUInt32BE(l,f,_),_+=4;for(let T=0;T<f;T++)s.writeUInt16LE(l,C.charCodeAt(T),_),_+=2;return _}static _readString(l,C){const _=s.readUInt32BE(l,C);return C+=4,(0,h.decodeUTF16LE)(l,C,_)}writeSize(){return 8+A._writeStringSize(this.oldText)+A._writeStringSize(this.newText)}write(l,C){return s.writeUInt32BE(l,this.oldPosition,C),C+=4,s.writeUInt32BE(l,this.newPosition,C),C+=4,C=A._writeString(l,this.oldText,C),C=A._writeString(l,this.newText,C),C}static read(l,C,_){const f=s.readUInt32BE(l,C);C+=4;const T=s.readUInt32BE(l,C);C+=4;const S=A._readString(l,C);C+=A._writeStringSize(S);const o=A._readString(l,C);return C+=A._writeStringSize(o),_.push(new A(f,S,T,o)),C}}e.TextChange=A;function L(v,l){return v===null||v.length===0?l:new R(v,l).compress()}class R{constructor(l,C){this._prevEdits=l,this._currEdits=C,this._result=[],this._resultLen=0,this._prevLen=this._prevEdits.length,this._prevDeltaOffset=0,this._currLen=this._currEdits.length,this._currDeltaOffset=0}compress(){let l=0,C=0,_=this._getPrev(l),f=this._getCurr(C);for(;l<this._prevLen||C<this._currLen;){if(_===null){this._acceptCurr(f),f=this._getCurr(++C);continue}if(f===null){this._acceptPrev(_),_=this._getPrev(++l);continue}if(f.oldEnd<=_.newPosition){this._acceptCurr(f),f=this._getCurr(++C);continue}if(_.newEnd<=f.oldPosition){this._acceptPrev(_),_=this._getPrev(++l);continue}if(f.oldPosition<_.newPosition){const[p,u]=R._splitCurr(f,_.newPosition-f.oldPosition);this._acceptCurr(p),f=u;continue}if(_.newPosition<f.oldPosition){const[p,u]=R._splitPrev(_,f.oldPosition-_.newPosition);this._acceptPrev(p),_=u;continue}let o,m;if(f.oldEnd===_.newEnd)o=_,m=f,_=this._getPrev(++l),f=this._getCurr(++C);else if(f.oldEnd<_.newEnd){const[p,u]=R._splitPrev(_,f.oldLength);o=p,m=f,_=u,f=this._getCurr(++C)}else{const[p,u]=R._splitCurr(f,_.newLength);o=_,m=p,_=this._getPrev(++l),f=u}this._result[this._resultLen++]=new A(o.oldPosition,o.oldText,m.newPosition,m.newText),this._prevDeltaOffset+=o.newLength-o.oldLength,this._currDeltaOffset+=m.newLength-m.oldLength}const T=R._merge(this._result);return R._removeNoOps(T)}_acceptCurr(l){this._result[this._resultLen++]=R._rebaseCurr(this._prevDeltaOffset,l),this._currDeltaOffset+=l.newLength-l.oldLength}_getCurr(l){return l<this._currLen?this._currEdits[l]:null}_acceptPrev(l){this._result[this._resultLen++]=R._rebasePrev(this._currDeltaOffset,l),this._prevDeltaOffset+=l.newLength-l.oldLength}_getPrev(l){return l<this._prevLen?this._prevEdits[l]:null}static _rebaseCurr(l,C){return new A(C.oldPosition-l,C.oldText,C.newPosition,C.newText)}static _rebasePrev(l,C){return new A(C.oldPosition,C.oldText,C.newPosition+l,C.newText)}static _splitPrev(l,C){const _=l.newText.substr(0,C),f=l.newText.substr(C);return[new A(l.oldPosition,l.oldText,l.newPosition,_),new A(l.oldEnd,"",l.newPosition+C,f)]}static _splitCurr(l,C){const _=l.oldText.substr(0,C),f=l.oldText.substr(C);return[new A(l.oldPosition,_,l.newPosition,l.newText),new A(l.oldPosition+C,f,l.newEnd,"")]}static _merge(l){if(l.length===0)return l;const C=[];let _=0,f=l[0];for(let T=1;T<l.length;T++){const S=l[T];f.oldEnd===S.oldPosition?f=new A(f.oldPosition,f.oldText+S.oldText,f.newPosition,f.newText+S.newText):(C[_++]=f,f=S)}return C[_++]=f,C}static _removeNoOps(l){if(l.length===0)return l;const C=[];let _=0;for(let f=0;f<l.length;f++){const T=l[f];T.oldText!==T.newText&&(C[_++]=T)}return C}}}),define(Pe[213],ke([1,0,39,16]),function(ge,e,s,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=D,e.targetsNotebooks=A;function D(L,R,v,l,C,_){if(Array.isArray(L)){let f=0;for(const T of L){const S=D(T,R,v,l,C,_);if(S===10)return S;S>f&&(f=S)}return f}else{if(typeof L=="string")return l?L==="*"?5:L===v?10:0:0;if(L){const{language:f,pattern:T,scheme:S,hasAccessToAllModels:o,notebookType:m}=L;if(!l&&!o)return 0;m&&C&&(R=C);let p=0;if(S)if(S===R.scheme)p=10;else if(S==="*")p=5;else return 0;if(f)if(f===v)p=10;else if(f==="*")p=Math.max(p,5);else return 0;if(m)if(m===_)p=10;else if(m==="*"&&_!==void 0)p=Math.max(p,5);else return 0;if(T){let u;if(typeof T=="string"?u=T:u={...T,base:(0,h.normalize)(T.base)},u===R.fsPath||(0,s.match)(u,R.fsPath))p=10;else return 0}return p}else return 0}}function A(L){return typeof L=="string"?!1:Array.isArray(L)?L.some(A):!!L.notebookType}}),define(Pe[88],ke([1,0,84,2,195,30,205,7]),function(ge,e,s,h,D,A,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InlineEditTriggerKind=e.ExternalUriOpenerPriority=e.TreeSitterTokenizationRegistry=e.TokenizationRegistry=e.LazyTokenizationSupport=e.InlayHintKind=e.CommentState=e.CommentMode=e.CommentThreadApplicability=e.CommentThreadState=e.CommentThreadCollapsibleState=e.Command=e.NewSymbolNameTriggerKind=e.NewSymbolNameTag=e.FoldingRangeKind=e.TextEdit=e.SymbolKinds=e.SymbolTag=e.symbolKindNames=e.SymbolKind=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.DocumentPasteTriggerKind=e.CodeActionTriggerType=e.SelectedSuggestionInfo=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.PartialAcceptTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.HoverVerbosityAction=e.EncodedTokenizationResult=e.TokenizationResult=e.Token=void 0,e.isLocationLink=d,e.getAriaLabelForSymbol=g;class v{constructor(W,Z,J){this.offset=W,this.type=Z,this.language=J,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}e.Token=v;class l{constructor(W,Z){this.tokens=W,this.endState=Z,this._tokenizationResultBrand=void 0}}e.TokenizationResult=l;class C{constructor(W,Z){this.tokens=W,this.endState=Z,this._encodedTokenizationResultBrand=void 0}}e.EncodedTokenizationResult=C;var _;(function(B){B[B.Increase=0]="Increase",B[B.Decrease=1]="Decrease"})(_||(e.HoverVerbosityAction=_={}));var f;(function(B){B[B.Method=0]="Method",B[B.Function=1]="Function",B[B.Constructor=2]="Constructor",B[B.Field=3]="Field",B[B.Variable=4]="Variable",B[B.Class=5]="Class",B[B.Struct=6]="Struct",B[B.Interface=7]="Interface",B[B.Module=8]="Module",B[B.Property=9]="Property",B[B.Event=10]="Event",B[B.Operator=11]="Operator",B[B.Unit=12]="Unit",B[B.Value=13]="Value",B[B.Constant=14]="Constant",B[B.Enum=15]="Enum",B[B.EnumMember=16]="EnumMember",B[B.Keyword=17]="Keyword",B[B.Text=18]="Text",B[B.Color=19]="Color",B[B.File=20]="File",B[B.Reference=21]="Reference",B[B.Customcolor=22]="Customcolor",B[B.Folder=23]="Folder",B[B.TypeParameter=24]="TypeParameter",B[B.User=25]="User",B[B.Issue=26]="Issue",B[B.Snippet=27]="Snippet"})(f||(e.CompletionItemKind=f={}));var T;(function(B){const W=new Map;W.set(f.Method,s.Codicon.symbolMethod),W.set(f.Function,s.Codicon.symbolFunction),W.set(f.Constructor,s.Codicon.symbolConstructor),W.set(f.Field,s.Codicon.symbolField),W.set(f.Variable,s.Codicon.symbolVariable),W.set(f.Class,s.Codicon.symbolClass),W.set(f.Struct,s.Codicon.symbolStruct),W.set(f.Interface,s.Codicon.symbolInterface),W.set(f.Module,s.Codicon.symbolModule),W.set(f.Property,s.Codicon.symbolProperty),W.set(f.Event,s.Codicon.symbolEvent),W.set(f.Operator,s.Codicon.symbolOperator),W.set(f.Unit,s.Codicon.symbolUnit),W.set(f.Value,s.Codicon.symbolValue),W.set(f.Enum,s.Codicon.symbolEnum),W.set(f.Constant,s.Codicon.symbolConstant),W.set(f.Enum,s.Codicon.symbolEnum),W.set(f.EnumMember,s.Codicon.symbolEnumMember),W.set(f.Keyword,s.Codicon.symbolKeyword),W.set(f.Snippet,s.Codicon.symbolSnippet),W.set(f.Text,s.Codicon.symbolText),W.set(f.Color,s.Codicon.symbolColor),W.set(f.File,s.Codicon.symbolFile),W.set(f.Reference,s.Codicon.symbolReference),W.set(f.Customcolor,s.Codicon.symbolCustomColor),W.set(f.Folder,s.Codicon.symbolFolder),W.set(f.TypeParameter,s.Codicon.symbolTypeParameter),W.set(f.User,s.Codicon.account),W.set(f.Issue,s.Codicon.issues);function Z(te){let me=W.get(te);return me||(console.info("No codicon found for CompletionItemKind "+te),me=s.Codicon.symbolProperty),me}B.toIcon=Z;const J=new Map;J.set("method",f.Method),J.set("function",f.Function),J.set("constructor",f.Constructor),J.set("field",f.Field),J.set("variable",f.Variable),J.set("class",f.Class),J.set("struct",f.Struct),J.set("interface",f.Interface),J.set("module",f.Module),J.set("property",f.Property),J.set("event",f.Event),J.set("operator",f.Operator),J.set("unit",f.Unit),J.set("value",f.Value),J.set("constant",f.Constant),J.set("enum",f.Enum),J.set("enum-member",f.EnumMember),J.set("enumMember",f.EnumMember),J.set("keyword",f.Keyword),J.set("snippet",f.Snippet),J.set("text",f.Text),J.set("color",f.Color),J.set("file",f.File),J.set("reference",f.Reference),J.set("customcolor",f.Customcolor),J.set("folder",f.Folder),J.set("type-parameter",f.TypeParameter),J.set("typeParameter",f.TypeParameter),J.set("account",f.User),J.set("issue",f.Issue);function oe(te,me){let le=J.get(te);return typeof le>"u"&&!me&&(le=f.Property),le}B.fromString=oe})(T||(e.CompletionItemKinds=T={}));var S;(function(B){B[B.Deprecated=1]="Deprecated"})(S||(e.CompletionItemTag=S={}));var o;(function(B){B[B.None=0]="None",B[B.KeepWhitespace=1]="KeepWhitespace",B[B.InsertAsSnippet=4]="InsertAsSnippet"})(o||(e.CompletionItemInsertTextRule=o={}));var m;(function(B){B[B.Word=0]="Word",B[B.Line=1]="Line",B[B.Suggest=2]="Suggest"})(m||(e.PartialAcceptTriggerKind=m={}));var p;(function(B){B[B.Invoke=0]="Invoke",B[B.TriggerCharacter=1]="TriggerCharacter",B[B.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(p||(e.CompletionTriggerKind=p={}));var u;(function(B){B[B.Automatic=0]="Automatic",B[B.Explicit=1]="Explicit"})(u||(e.InlineCompletionTriggerKind=u={}));class i{constructor(W,Z,J,oe){this.range=W,this.text=Z,this.completionKind=J,this.isSnippetText=oe}equals(W){return A.Range.lift(this.range).equalsRange(W.range)&&this.text===W.text&&this.completionKind===W.completionKind&&this.isSnippetText===W.isSnippetText}}e.SelectedSuggestionInfo=i;var a;(function(B){B[B.Invoke=1]="Invoke",B[B.Auto=2]="Auto"})(a||(e.CodeActionTriggerType=a={}));var t;(function(B){B[B.Automatic=0]="Automatic",B[B.PasteAs=1]="PasteAs"})(t||(e.DocumentPasteTriggerKind=t={}));var n;(function(B){B[B.Invoke=1]="Invoke",B[B.TriggerCharacter=2]="TriggerCharacter",B[B.ContentChange=3]="ContentChange"})(n||(e.SignatureHelpTriggerKind=n={}));var r;(function(B){B[B.Text=0]="Text",B[B.Read=1]="Read",B[B.Write=2]="Write"})(r||(e.DocumentHighlightKind=r={}));function d(B){return B&&h.URI.isUri(B.uri)&&A.Range.isIRange(B.range)&&(A.Range.isIRange(B.originSelectionRange)||A.Range.isIRange(B.targetSelectionRange))}var c;(function(B){B[B.File=0]="File",B[B.Module=1]="Module",B[B.Namespace=2]="Namespace",B[B.Package=3]="Package",B[B.Class=4]="Class",B[B.Method=5]="Method",B[B.Property=6]="Property",B[B.Field=7]="Field",B[B.Constructor=8]="Constructor",B[B.Enum=9]="Enum",B[B.Interface=10]="Interface",B[B.Function=11]="Function",B[B.Variable=12]="Variable",B[B.Constant=13]="Constant",B[B.String=14]="String",B[B.Number=15]="Number",B[B.Boolean=16]="Boolean",B[B.Array=17]="Array",B[B.Object=18]="Object",B[B.Key=19]="Key",B[B.Null=20]="Null",B[B.EnumMember=21]="EnumMember",B[B.Struct=22]="Struct",B[B.Event=23]="Event",B[B.Operator=24]="Operator",B[B.TypeParameter=25]="TypeParameter"})(c||(e.SymbolKind=c={})),e.symbolKindNames={[c.Array]:(0,R.localize)(788,null),[c.Boolean]:(0,R.localize)(789,null),[c.Class]:(0,R.localize)(790,null),[c.Constant]:(0,R.localize)(791,null),[c.Constructor]:(0,R.localize)(792,null),[c.Enum]:(0,R.localize)(793,null),[c.EnumMember]:(0,R.localize)(794,null),[c.Event]:(0,R.localize)(795,null),[c.Field]:(0,R.localize)(796,null),[c.File]:(0,R.localize)(797,null),[c.Function]:(0,R.localize)(798,null),[c.Interface]:(0,R.localize)(799,null),[c.Key]:(0,R.localize)(800,null),[c.Method]:(0,R.localize)(801,null),[c.Module]:(0,R.localize)(802,null),[c.Namespace]:(0,R.localize)(803,null),[c.Null]:(0,R.localize)(804,null),[c.Number]:(0,R.localize)(805,null),[c.Object]:(0,R.localize)(806,null),[c.Operator]:(0,R.localize)(807,null),[c.Package]:(0,R.localize)(808,null),[c.Property]:(0,R.localize)(809,null),[c.String]:(0,R.localize)(810,null),[c.Struct]:(0,R.localize)(811,null),[c.TypeParameter]:(0,R.localize)(812,null),[c.Variable]:(0,R.localize)(813,null)};function g(B,W){return(0,R.localize)(814,null,B,e.symbolKindNames[W])}var w;(function(B){B[B.Deprecated=1]="Deprecated"})(w||(e.SymbolTag=w={}));var y;(function(B){const W=new Map;W.set(c.File,s.Codicon.symbolFile),W.set(c.Module,s.Codicon.symbolModule),W.set(c.Namespace,s.Codicon.symbolNamespace),W.set(c.Package,s.Codicon.symbolPackage),W.set(c.Class,s.Codicon.symbolClass),W.set(c.Method,s.Codicon.symbolMethod),W.set(c.Property,s.Codicon.symbolProperty),W.set(c.Field,s.Codicon.symbolField),W.set(c.Constructor,s.Codicon.symbolConstructor),W.set(c.Enum,s.Codicon.symbolEnum),W.set(c.Interface,s.Codicon.symbolInterface),W.set(c.Function,s.Codicon.symbolFunction),W.set(c.Variable,s.Codicon.symbolVariable),W.set(c.Constant,s.Codicon.symbolConstant),W.set(c.String,s.Codicon.symbolString),W.set(c.Number,s.Codicon.symbolNumber),W.set(c.Boolean,s.Codicon.symbolBoolean),W.set(c.Array,s.Codicon.symbolArray),W.set(c.Object,s.Codicon.symbolObject),W.set(c.Key,s.Codicon.symbolKey),W.set(c.Null,s.Codicon.symbolNull),W.set(c.EnumMember,s.Codicon.symbolEnumMember),W.set(c.Struct,s.Codicon.symbolStruct),W.set(c.Event,s.Codicon.symbolEvent),W.set(c.Operator,s.Codicon.symbolOperator),W.set(c.TypeParameter,s.Codicon.symbolTypeParameter);function Z(J){let oe=W.get(J);return oe||(console.info("No codicon found for SymbolKind "+J),oe=s.Codicon.symbolProperty),oe}B.toIcon=Z})(y||(e.SymbolKinds=y={}));class I{static asEditOperation(W){return D.EditOperation.replace(A.Range.lift(W.range),W.text)}}e.TextEdit=I;class P{static{this.Comment=new P("comment")}static{this.Imports=new P("imports")}static{this.Region=new P("region")}static fromValue(W){switch(W){case"comment":return P.Comment;case"imports":return P.Imports;case"region":return P.Region}return new P(W)}constructor(W){this.value=W}}e.FoldingRangeKind=P;var k;(function(B){B[B.AIGenerated=1]="AIGenerated"})(k||(e.NewSymbolNameTag=k={}));var b;(function(B){B[B.Invoke=0]="Invoke",B[B.Automatic=1]="Automatic"})(b||(e.NewSymbolNameTriggerKind=b={}));var E;(function(B){function W(Z){return!Z||typeof Z!="object"?!1:typeof Z.id=="string"&&typeof Z.title=="string"}B.is=W})(E||(e.Command=E={}));var N;(function(B){B[B.Collapsed=0]="Collapsed",B[B.Expanded=1]="Expanded"})(N||(e.CommentThreadCollapsibleState=N={}));var O;(function(B){B[B.Unresolved=0]="Unresolved",B[B.Resolved=1]="Resolved"})(O||(e.CommentThreadState=O={}));var M;(function(B){B[B.Current=0]="Current",B[B.Outdated=1]="Outdated"})(M||(e.CommentThreadApplicability=M={}));var U;(function(B){B[B.Editing=0]="Editing",B[B.Preview=1]="Preview"})(U||(e.CommentMode=U={}));var H;(function(B){B[B.Published=0]="Published",B[B.Draft=1]="Draft"})(H||(e.CommentState=H={}));var F;(function(B){B[B.Type=1]="Type",B[B.Parameter=2]="Parameter"})(F||(e.InlayHintKind=F={}));class x{constructor(W){this.createSupport=W,this._tokenizationSupport=null}dispose(){this._tokenizationSupport&&this._tokenizationSupport.then(W=>{W&&W.dispose()})}get tokenizationSupport(){return this._tokenizationSupport||(this._tokenizationSupport=this.createSupport()),this._tokenizationSupport}}e.LazyTokenizationSupport=x,e.TokenizationRegistry=new L.TokenizationRegistry,e.TreeSitterTokenizationRegistry=new L.TokenizationRegistry;var $;(function(B){B[B.None=0]="None",B[B.Option=1]="Option",B[B.Default=2]="Default",B[B.Preferred=3]="Preferred"})($||(e.ExternalUriOpenerPriority=$={}));var G;(function(B){B[B.Invoke=0]="Invoke",B[B.Automatic=1]="Automatic"})(G||(e.InlineEditTriggerKind=G={}))}),define(Pe[214],ke([1,0,4,13,30,56,140,194,212,3]),function(ge,e,s,h,D,A,L,R,v,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PieceTreeTextBuffer=void 0,h=We(h);class C extends l.Disposable{constructor(f,T,S,o,m,p,u){super(),this._onDidChangeContent=this._register(new s.Emitter),this.onDidChangeContent=this._onDidChangeContent.event,this._BOM=T,this._mightContainNonBasicASCII=!p,this._mightContainRTL=o,this._mightContainUnusualLineTerminators=m,this._pieceTree=new L.PieceTreeBase(f,S,u)}equals(f){return!(f instanceof C)||this._BOM!==f._BOM||this.getEOL()!==f.getEOL()?!1:this._pieceTree.equal(f._pieceTree)}mightContainRTL(){return this._mightContainRTL}mightContainUnusualLineTerminators(){return this._mightContainUnusualLineTerminators}resetMightContainUnusualLineTerminators(){this._mightContainUnusualLineTerminators=!1}mightContainNonBasicASCII(){return this._mightContainNonBasicASCII}getBOM(){return this._BOM}getEOL(){return this._pieceTree.getEOL()}createSnapshot(f){return this._pieceTree.createSnapshot(f?this._BOM:"")}getOffsetAt(f,T){return this._pieceTree.getOffsetAt(f,T)}getPositionAt(f){return this._pieceTree.getPositionAt(f)}getRangeAt(f,T){const S=f+T,o=this.getPositionAt(f),m=this.getPositionAt(S);return new D.Range(o.lineNumber,o.column,m.lineNumber,m.column)}getValueInRange(f,T=A.EndOfLinePreference.TextDefined){if(f.isEmpty())return"";const S=this._getEndOfLine(T);return this._pieceTree.getValueInRange(f,S)}getValueLengthInRange(f,T=A.EndOfLinePreference.TextDefined){if(f.isEmpty())return 0;if(f.startLineNumber===f.endLineNumber)return f.endColumn-f.startColumn;const S=this.getOffsetAt(f.startLineNumber,f.startColumn),o=this.getOffsetAt(f.endLineNumber,f.endColumn);let m=0;const p=this._getEndOfLine(T),u=this.getEOL();if(p.length!==u.length){const i=p.length-u.length,a=f.endLineNumber-f.startLineNumber;m=i*a}return o-S+m}getCharacterCountInRange(f,T=A.EndOfLinePreference.TextDefined){if(this._mightContainNonBasicASCII){let S=0;const o=f.startLineNumber,m=f.endLineNumber;for(let p=o;p<=m;p++){const u=this.getLineContent(p),i=p===o?f.startColumn-1:0,a=p===m?f.endColumn-1:u.length;for(let t=i;t<a;t++)h.isHighSurrogate(u.charCodeAt(t))?(S=S+1,t=t+1):S=S+1}return S+=this._getEndOfLine(T).length*(m-o),S}return this.getValueLengthInRange(f,T)}getNearestChunk(f){return this._pieceTree.getNearestChunk(f)}getLength(){return this._pieceTree.getLength()}getLineCount(){return this._pieceTree.getLineCount()}getLinesContent(){return this._pieceTree.getLinesContent()}getLineContent(f){return this._pieceTree.getLineContent(f)}getLineCharCode(f,T){return this._pieceTree.getLineCharCode(f,T)}getCharCode(f){return this._pieceTree.getCharCode(f)}getLineLength(f){return this._pieceTree.getLineLength(f)}getLineMinColumn(f){return 1}getLineMaxColumn(f){return this.getLineLength(f)+1}getLineFirstNonWhitespaceColumn(f){const T=h.firstNonWhitespaceIndex(this.getLineContent(f));return T===-1?0:T+1}getLineLastNonWhitespaceColumn(f){const T=h.lastNonWhitespaceIndex(this.getLineContent(f));return T===-1?0:T+2}_getEndOfLine(f){switch(f){case A.EndOfLinePreference.LF:return`
`;case A.EndOfLinePreference.CRLF:return`\r
`;case A.EndOfLinePreference.TextDefined:return this.getEOL();default:throw new Error("Unknown EOL preference")}}setEOL(f){this._pieceTree.setEOL(f)}applyEdits(f,T,S){let o=this._mightContainRTL,m=this._mightContainUnusualLineTerminators,p=this._mightContainNonBasicASCII,u=!0,i=[];for(let g=0;g<f.length;g++){const w=f[g];u&&w._isTracked&&(u=!1);const y=w.range;if(w.text){let E=!0;p||(E=!h.isBasicASCII(w.text),p=E),!o&&E&&(o=h.containsRTL(w.text)),!m&&E&&(m=h.containsUnusualLineTerminators(w.text))}let I="",P=0,k=0,b=0;if(w.text){let E;[P,k,b,E]=(0,R.countEOL)(w.text);const N=this.getEOL(),O=N===`\r
`?R.StringEOL.CRLF:R.StringEOL.LF;E===R.StringEOL.Unknown||E===O?I=w.text:I=w.text.replace(/\r\n|\r|\n/g,N)}i[g]={sortIndex:g,identifier:w.identifier||null,range:y,rangeOffset:this.getOffsetAt(y.startLineNumber,y.startColumn),rangeLength:this.getValueLengthInRange(y),text:I,eolCount:P,firstLineLength:k,lastLineLength:b,forceMoveMarkers:!!w.forceMoveMarkers,isAutoWhitespaceEdit:w.isAutoWhitespaceEdit||!1}}i.sort(C._sortOpsAscending);let a=!1;for(let g=0,w=i.length-1;g<w;g++){const y=i[g].range.getEndPosition(),I=i[g+1].range.getStartPosition();if(I.isBeforeOrEqual(y)){if(I.isBefore(y))throw new Error("Overlapping ranges are not allowed!");a=!0}}u&&(i=this._reduceOperations(i));const t=S||T?C._getInverseEditRanges(i):[],n=[];if(T)for(let g=0;g<i.length;g++){const w=i[g],y=t[g];if(w.isAutoWhitespaceEdit&&w.range.isEmpty())for(let I=y.startLineNumber;I<=y.endLineNumber;I++){let P="";I===y.startLineNumber&&(P=this.getLineContent(w.range.startLineNumber),h.firstNonWhitespaceIndex(P)!==-1)||n.push({lineNumber:I,oldContent:P})}}let r=null;if(S){let g=0;r=[];for(let w=0;w<i.length;w++){const y=i[w],I=t[w],P=this.getValueInRange(y.range),k=y.rangeOffset+g;g+=y.text.length-P.length,r[w]={sortIndex:y.sortIndex,identifier:y.identifier,range:I,text:P,textChange:new v.TextChange(y.rangeOffset,P,k,y.text)}}a||r.sort((w,y)=>w.sortIndex-y.sortIndex)}this._mightContainRTL=o,this._mightContainUnusualLineTerminators=m,this._mightContainNonBasicASCII=p;const d=this._doApplyEdits(i);let c=null;if(T&&n.length>0){n.sort((g,w)=>w.lineNumber-g.lineNumber),c=[];for(let g=0,w=n.length;g<w;g++){const y=n[g].lineNumber;if(g>0&&n[g-1].lineNumber===y)continue;const I=n[g].oldContent,P=this.getLineContent(y);P.length===0||P===I||h.firstNonWhitespaceIndex(P)!==-1||c.push(y)}}return this._onDidChangeContent.fire(),new A.ApplyEditsResult(r,d,c)}_reduceOperations(f){return f.length<1e3?f:[this._toSingleEditOperation(f)]}_toSingleEditOperation(f){let T=!1;const S=f[0].range,o=f[f.length-1].range,m=new D.Range(S.startLineNumber,S.startColumn,o.endLineNumber,o.endColumn);let p=S.startLineNumber,u=S.startColumn;const i=[];for(let d=0,c=f.length;d<c;d++){const g=f[d],w=g.range;T=T||g.forceMoveMarkers,i.push(this.getValueInRange(new D.Range(p,u,w.startLineNumber,w.startColumn))),g.text.length>0&&i.push(g.text),p=w.endLineNumber,u=w.endColumn}const a=i.join(""),[t,n,r]=(0,R.countEOL)(a);return{sortIndex:0,identifier:f[0].identifier,range:m,rangeOffset:this.getOffsetAt(m.startLineNumber,m.startColumn),rangeLength:this.getValueLengthInRange(m,A.EndOfLinePreference.TextDefined),text:a,eolCount:t,firstLineLength:n,lastLineLength:r,forceMoveMarkers:T,isAutoWhitespaceEdit:!1}}_doApplyEdits(f){f.sort(C._sortOpsDescending);const T=[];for(let S=0;S<f.length;S++){const o=f[S],m=o.range.startLineNumber,p=o.range.startColumn,u=o.range.endLineNumber,i=o.range.endColumn;if(m===u&&p===i&&o.text.length===0)continue;o.text?(this._pieceTree.delete(o.rangeOffset,o.rangeLength),this._pieceTree.insert(o.rangeOffset,o.text,!0)):this._pieceTree.delete(o.rangeOffset,o.rangeLength);const a=new D.Range(m,p,u,i);T.push({range:a,rangeLength:o.rangeLength,text:o.text,rangeOffset:o.rangeOffset,forceMoveMarkers:o.forceMoveMarkers})}return T}findMatchesLineByLine(f,T,S,o){return this._pieceTree.findMatchesLineByLine(f,T,S,o)}getPieceTree(){return this._pieceTree}static _getInverseEditRange(f,T){const S=f.startLineNumber,o=f.startColumn,[m,p,u]=(0,R.countEOL)(T);let i;if(T.length>0){const a=m+1;a===1?i=new D.Range(S,o,S,o+p):i=new D.Range(S,o,S+a-1,u+1)}else i=new D.Range(S,o,S,o);return i}static _getInverseEditRanges(f){const T=[];let S=0,o=0,m=null;for(let p=0,u=f.length;p<u;p++){const i=f[p];let a,t;m?m.range.endLineNumber===i.range.startLineNumber?(a=S,t=o+(i.range.startColumn-m.range.endColumn)):(a=S+(i.range.startLineNumber-m.range.endLineNumber),t=i.range.startColumn):(a=i.range.startLineNumber,t=i.range.startColumn);let n;if(i.text.length>0){const r=i.eolCount+1;r===1?n=new D.Range(a,t,a,t+i.firstLineLength):n=new D.Range(a,t,a+r-1,i.lastLineLength+1)}else n=new D.Range(a,t,a,t);S=n.endLineNumber,o=n.endColumn,T.push(n),m=i}return T}static _sortOpsAscending(f,T){const S=D.Range.compareRangesUsingEnds(f.range,T.range);return S===0?f.sortIndex-T.sortIndex:S}static _sortOpsDescending(f,T){const S=D.Range.compareRangesUsingEnds(f.range,T.range);return S===0?T.sortIndex-f.sortIndex:-S}}e.PieceTreeTextBuffer=C}),define(Pe[215],ke([1,0,26,13,56,140,214]),function(ge,e,s,h,D,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PieceTreeTextBufferBuilder=void 0,h=We(h);class R{constructor(C,_,f,T,S,o,m,p,u){this._chunks=C,this._bom=_,this._cr=f,this._lf=T,this._crlf=S,this._containsRTL=o,this._containsUnusualLineTerminators=m,this._isBasicASCII=p,this._normalizeEOL=u}_getEOL(C){const _=this._cr+this._lf+this._crlf,f=this._cr+this._crlf;return _===0?C===D.DefaultEndOfLine.LF?`
`:`\r
`:f>_/2?`\r
`:`
`}create(C){const _=this._getEOL(C),f=this._chunks;if(this._normalizeEOL&&(_===`\r
`&&(this._cr>0||this._lf>0)||_===`
`&&(this._cr>0||this._crlf>0)))for(let S=0,o=f.length;S<o;S++){const m=f[S].buffer.replace(/\r\n|\r|\n/g,_),p=(0,A.createLineStartsFast)(m);f[S]=new A.StringBuffer(m,p)}const T=new L.PieceTreeTextBuffer(f,this._bom,_,this._containsRTL,this._containsUnusualLineTerminators,this._isBasicASCII,this._normalizeEOL);return{textBuffer:T,disposable:T}}getFirstLineText(C){return this._chunks[0].buffer.substr(0,C).split(/\r\n|\r|\n/)[0]}}class v{constructor(){this.chunks=[],this.BOM="",this._hasPreviousChar=!1,this._previousChar=0,this._tmpLineStarts=[],this.cr=0,this.lf=0,this.crlf=0,this.containsRTL=!1,this.containsUnusualLineTerminators=!1,this.isBasicASCII=!0}acceptChunk(C){if(C.length===0)return;this.chunks.length===0&&h.startsWithUTF8BOM(C)&&(this.BOM=h.UTF8_BOM_CHARACTER,C=C.substr(1));const _=C.charCodeAt(C.length-1);_===s.CharCode.CarriageReturn||_>=55296&&_<=56319?(this._acceptChunk1(C.substr(0,C.length-1),!1),this._hasPreviousChar=!0,this._previousChar=_):(this._acceptChunk1(C,!1),this._hasPreviousChar=!1,this._previousChar=_)}_acceptChunk1(C,_){!_&&C.length===0||(this._hasPreviousChar?this._acceptChunk2(String.fromCharCode(this._previousChar)+C):this._acceptChunk2(C))}_acceptChunk2(C){const _=(0,A.createLineStarts)(this._tmpLineStarts,C);this.chunks.push(new A.StringBuffer(C,_.lineStarts)),this.cr+=_.cr,this.lf+=_.lf,this.crlf+=_.crlf,_.isBasicASCII||(this.isBasicASCII=!1,this.containsRTL||(this.containsRTL=h.containsRTL(C)),this.containsUnusualLineTerminators||(this.containsUnusualLineTerminators=h.containsUnusualLineTerminators(C)))}finish(C=!0){return this._finish(),new R(this.chunks,this.BOM,this.cr,this.lf,this.crlf,this.containsRTL,this.containsUnusualLineTerminators,this.isBasicASCII,C)}_finish(){if(this.chunks.length===0&&this._acceptChunk1("",!0),this._hasPreviousChar){this._hasPreviousChar=!1;const C=this.chunks[this.chunks.length-1];C.buffer+=String.fromCharCode(this._previousChar);const _=(0,A.createLineStartsFast)(C.buffer);C.lineStarts=_,this._previousChar===s.CharCode.CarriageReturn&&this.cr++}}}e.PieceTreeTextBufferBuilder=v}),define(Pe[146],ke([1,0,21,10]),function(ge,e,s,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeSemanticTokensDto=v,e.decodeSemanticTokensDto=C,h=We(h);var D;(function(_){_[_.Full=1]="Full",_[_.Delta=2]="Delta"})(D||(D={}));function A(_){for(let f=0,T=_.length;f<T;f+=4){const S=_[f+0],o=_[f+1],m=_[f+2],p=_[f+3];_[f+0]=p,_[f+1]=m,_[f+2]=o,_[f+3]=S}}function L(_){const f=new Uint8Array(_.buffer,_.byteOffset,_.length*4);return h.isLittleEndian()||A(f),s.VSBuffer.wrap(f)}function R(_){const f=_.buffer;if(h.isLittleEndian()||A(f),f.byteOffset%4===0)return new Uint32Array(f.buffer,f.byteOffset,f.length/4);{const T=new Uint8Array(f.byteLength);return T.set(f),new Uint32Array(T.buffer,T.byteOffset,T.length/4)}}function v(_){const f=new Uint32Array(l(_));let T=0;if(f[T++]=_.id,_.type==="full")f[T++]=D.Full,f[T++]=_.data.length,f.set(_.data,T),T+=_.data.length;else{f[T++]=D.Delta,f[T++]=_.deltas.length;for(const S of _.deltas)f[T++]=S.start,f[T++]=S.deleteCount,S.data?(f[T++]=S.data.length,f.set(S.data,T),T+=S.data.length):f[T++]=0}return L(f)}function l(_){let f=0;if(f+=2,_.type==="full")f+=1+_.data.length;else{f+=1,f+=3*_.deltas.length;for(const T of _.deltas)T.data&&(f+=T.data.length)}return f}function C(_){const f=R(_);let T=0;const S=f[T++];if(f[T++]===D.Full){const u=f[T++],i=f.subarray(T,T+u);return T+=u,{id:S,type:"full",data:i}}const m=f[T++],p=[];for(let u=0;u<m;u++){const i=f[T++],a=f[T++],t=f[T++];let n;t>0&&(n=f.subarray(T,T+t),T+=t),p[u]={start:i,deleteCount:a,data:n}}return{id:S,type:"delta",deltas:p}}}),define(Pe[216],ke([1,0,26,12,7]),function(ge,e,s,h,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Scanner=e.TokenType=void 0;var A;(function(C){C[C.LParen=0]="LParen",C[C.RParen=1]="RParen",C[C.Neg=2]="Neg",C[C.Eq=3]="Eq",C[C.NotEq=4]="NotEq",C[C.Lt=5]="Lt",C[C.LtEq=6]="LtEq",C[C.Gt=7]="Gt",C[C.GtEq=8]="GtEq",C[C.RegexOp=9]="RegexOp",C[C.RegexStr=10]="RegexStr",C[C.True=11]="True",C[C.False=12]="False",C[C.In=13]="In",C[C.Not=14]="Not",C[C.And=15]="And",C[C.Or=16]="Or",C[C.Str=17]="Str",C[C.QuotedStr=18]="QuotedStr",C[C.Error=19]="Error",C[C.EOF=20]="EOF"})(A||(e.TokenType=A={}));function L(...C){switch(C.length){case 1:return(0,D.localize)(1693,null,C[0]);case 2:return(0,D.localize)(1694,null,C[0],C[1]);case 3:return(0,D.localize)(1695,null,C[0],C[1],C[2]);default:return}}const R=(0,D.localize)(1696,null),v=(0,D.localize)(1697,null);class l{constructor(){this._input="",this._start=0,this._current=0,this._tokens=[],this._errors=[],this.stringRe=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(_){switch(_.type){case A.LParen:return"(";case A.RParen:return")";case A.Neg:return"!";case A.Eq:return _.isTripleEq?"===":"==";case A.NotEq:return _.isTripleEq?"!==":"!=";case A.Lt:return"<";case A.LtEq:return"<=";case A.Gt:return">=";case A.GtEq:return">=";case A.RegexOp:return"=~";case A.RegexStr:return _.lexeme;case A.True:return"true";case A.False:return"false";case A.In:return"in";case A.Not:return"not";case A.And:return"&&";case A.Or:return"||";case A.Str:return _.lexeme;case A.QuotedStr:return _.lexeme;case A.Error:return _.lexeme;case A.EOF:return"EOF";default:throw(0,h.illegalState)(`unhandled token type: ${JSON.stringify(_)}; have you forgotten to add a case?`)}}static{this._regexFlags=new Set(["i","g","s","m","y","u"].map(_=>_.charCodeAt(0)))}static{this._keywords=new Map([["not",A.Not],["in",A.In],["false",A.False],["true",A.True]])}get errors(){return this._errors}reset(_){return this._input=_,this._start=0,this._current=0,this._tokens=[],this._errors=[],this}scan(){for(;!this._isAtEnd();)switch(this._start=this._current,this._advance()){case s.CharCode.OpenParen:this._addToken(A.LParen);break;case s.CharCode.CloseParen:this._addToken(A.RParen);break;case s.CharCode.ExclamationMark:if(this._match(s.CharCode.Equals)){const f=this._match(s.CharCode.Equals);this._tokens.push({type:A.NotEq,offset:this._start,isTripleEq:f})}else this._addToken(A.Neg);break;case s.CharCode.SingleQuote:this._quotedString();break;case s.CharCode.Slash:this._regex();break;case s.CharCode.Equals:if(this._match(s.CharCode.Equals)){const f=this._match(s.CharCode.Equals);this._tokens.push({type:A.Eq,offset:this._start,isTripleEq:f})}else this._match(s.CharCode.Tilde)?this._addToken(A.RegexOp):this._error(L("==","=~"));break;case s.CharCode.LessThan:this._addToken(this._match(s.CharCode.Equals)?A.LtEq:A.Lt);break;case s.CharCode.GreaterThan:this._addToken(this._match(s.CharCode.Equals)?A.GtEq:A.Gt);break;case s.CharCode.Ampersand:this._match(s.CharCode.Ampersand)?this._addToken(A.And):this._error(L("&&"));break;case s.CharCode.Pipe:this._match(s.CharCode.Pipe)?this._addToken(A.Or):this._error(L("||"));break;case s.CharCode.Space:case s.CharCode.CarriageReturn:case s.CharCode.Tab:case s.CharCode.LineFeed:case s.CharCode.NoBreakSpace:break;default:this._string()}return this._start=this._current,this._addToken(A.EOF),Array.from(this._tokens)}_match(_){return this._isAtEnd()||this._input.charCodeAt(this._current)!==_?!1:(this._current++,!0)}_advance(){return this._input.charCodeAt(this._current++)}_peek(){return this._isAtEnd()?s.CharCode.Null:this._input.charCodeAt(this._current)}_addToken(_){this._tokens.push({type:_,offset:this._start})}_error(_){const f=this._start,T=this._input.substring(this._start,this._current),S={type:A.Error,offset:this._start,lexeme:T};this._errors.push({offset:f,lexeme:T,additionalInfo:_}),this._tokens.push(S)}_string(){this.stringRe.lastIndex=this._start;const _=this.stringRe.exec(this._input);if(_){this._current=this._start+_[0].length;const f=this._input.substring(this._start,this._current),T=l._keywords.get(f);T?this._addToken(T):this._tokens.push({type:A.Str,lexeme:f,offset:this._start})}}_quotedString(){for(;this._peek()!==s.CharCode.SingleQuote&&!this._isAtEnd();)this._advance();if(this._isAtEnd()){this._error(R);return}this._advance(),this._tokens.push({type:A.QuotedStr,lexeme:this._input.substring(this._start+1,this._current-1),offset:this._start+1})}_regex(){let _=this._current,f=!1,T=!1;for(;;){if(_>=this._input.length){this._current=_,this._error(v);return}const o=this._input.charCodeAt(_);if(f)f=!1;else if(o===s.CharCode.Slash&&!T){_++;break}else o===s.CharCode.OpenSquareBracket?T=!0:o===s.CharCode.Backslash?f=!0:o===s.CharCode.CloseSquareBracket&&(T=!1);_++}for(;_<this._input.length&&l._regexFlags.has(this._input.charCodeAt(_));)_++;this._current=_;const S=this._input.substring(this._start,this._current);this._tokens.push({type:A.RegexStr,lexeme:S,offset:this._start})}_isAtEnd(){return this._current>=this._input.length}}e.Scanner=l}),define(Pe[147],ke([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0;const s={activeComment:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.activeComment.d.ts"},aiRelatedInformation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts"},aiTextSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiTextSearchProvider.d.ts"},aiTextSearchProviderNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiTextSearchProviderNew.d.ts"},attributableCoverage:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.attributableCoverage.d.ts"},authLearnMore:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authLearnMore.d.ts"},authSession:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts"},canonicalUriProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts"},chatParticipantAdditions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantAdditions.d.ts"},chatParticipantPrivate:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantPrivate.d.ts",version:2},chatProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts"},chatTab:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts"},chatVariableResolver:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariableResolver.d.ts"},codeActionAI:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts"},codeActionRanges:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionRanges.d.ts"},codiconDecoration:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts"},commentReactor:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReactor.d.ts"},commentReveal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReveal.d.ts"},commentThreadApplicability:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentThreadApplicability.d.ts"},commentingRangeHint:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentingRangeHint.d.ts"},commentsDraftState:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts"},contribAccessibilityHelpContent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribAccessibilityHelpContent.d.ts"},contribCommentEditorActionsMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts"},contribCommentPeekContext:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts"},contribCommentThreadAdditionalMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts"},contribCommentsViewThreadMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentsViewThreadMenus.d.ts"},contribDebugCreateConfiguration:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribDebugCreateConfiguration.d.ts"},contribDiffEditorGutterToolBarMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribDiffEditorGutterToolBarMenus.d.ts"},contribEditSessions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts"},contribEditorContentMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts"},contribIssueReporter:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribIssueReporter.d.ts"},contribLabelFormatterWorkspaceTooltip:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts"},contribMenuBarHome:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts"},contribMergeEditorMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts"},contribMultiDiffEditorMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMultiDiffEditorMenus.d.ts"},contribNotebookStaticPreloads:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts"},contribRemoteHelp:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts"},contribShareMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts"},contribSourceControlHistoryItemChangesMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemChangesMenu.d.ts"},contribSourceControlHistoryItemGroupMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemGroupMenu.d.ts"},contribSourceControlHistoryItemMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemMenu.d.ts"},contribSourceControlHistoryTitleMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryTitleMenu.d.ts"},contribSourceControlInputBoxMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts"},contribSourceControlTitleMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlTitleMenu.d.ts"},contribStatusBarItems:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts"},contribViewContainerTitle:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewContainerTitle.d.ts"},contribViewsRemote:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts"},contribViewsWelcome:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts"},createFileSystemWatcher:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts"},customEditorMove:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts"},debugVisualization:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugVisualization.d.ts"},defaultChatParticipant:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatParticipant.d.ts"},diffCommand:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts"},diffContentOptions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts"},documentFiltersExclusive:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts"},documentPaste:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts"},editSessionIdentityProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts"},editorHoverVerbosityLevel:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorHoverVerbosityLevel.d.ts"},editorInsets:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts"},embeddings:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.embeddings.d.ts"},extensionRuntime:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts"},extensionsAny:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts"},externalUriOpener:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts"},fileComments:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts"},fileSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts"},fileSearchProviderNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProviderNew.d.ts"},findFiles2:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2.d.ts"},findFiles2New:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2New.d.ts"},findTextInFiles:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts"},findTextInFilesNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFilesNew.d.ts"},fsChunks:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts"},idToken:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts"},inlineCompletionsAdditions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts"},inlineEdit:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineEdit.d.ts"},interactive:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts"},interactiveWindow:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts"},ipc:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts"},languageModelSystem:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageModelSystem.d.ts"},languageStatusText:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts"},lmTools:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.lmTools.d.ts",version:6},mappedEditsProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts"},multiDocumentHighlightProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.multiDocumentHighlightProvider.d.ts"},newSymbolNamesProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.newSymbolNamesProvider.d.ts"},notebookCellExecution:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecution.d.ts"},notebookCellExecutionState:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts"},notebookControllerAffinityHidden:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts"},notebookDeprecated:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts"},notebookExecution:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts"},notebookKernelSource:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts"},notebookLiveShare:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts"},notebookMessaging:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts"},notebookMime:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts"},notebookReplDocument:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookReplDocument.d.ts"},notebookVariableProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts"},portsAttributes:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts"},profileContentHandlers:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts"},quickDiffProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts"},quickInputButtonLocation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickInputButtonLocation.d.ts"},quickPickItemTooltip:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts"},quickPickSortByLabel:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts"},resolvers:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts"},scmActionButton:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts"},scmHistoryProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts"},scmMultiDiffEditor:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmMultiDiffEditor.d.ts"},scmSelectedProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts"},scmTextDocument:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts"},scmValidation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts"},shareProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts"},showLocal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts"},speech:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts"},tabInputMultiDiff:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputMultiDiff.d.ts"},tabInputTextMerge:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts"},taskPresentationGroup:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts"},telemetry:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts"},terminalDataWriteEvent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts"},terminalDimensions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts"},terminalExecuteCommandEvent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts"},terminalQuickFixProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts"},terminalSelection:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts"},testObserver:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts"},testRelatedCode:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testRelatedCode.d.ts"},textSearchCompleteNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchCompleteNew.d.ts"},textSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts"},textSearchProviderNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProviderNew.d.ts"},timeline:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts"},tokenInformation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts"},treeViewActiveItem:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts"},treeViewMarkdownMessage:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts"},treeViewReveal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts"},tunnelFactory:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts"},tunnels:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts"},workspaceTrust:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"}};e.allApiProposals=Object.freeze(s)}),define(Pe[112],ke([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class s{constructor(D,A=[],L=!1){this.ctor=D,this.staticArguments=A,this.supportsDelayedInstantiation=L}}e.SyncDescriptor=s}),define(Pe[89],ke([1,0,112]),function(ge,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.registerSingleton=A,e.getSingletonServiceDescriptors=L;const h=[];var D;(function(R){R[R.Eager=0]="Eager",R[R.Delayed=1]="Delayed"})(D||(e.InstantiationType=D={}));function A(R,v,l){v instanceof s.SyncDescriptor||(v=new s.SyncDescriptor(v,[],!!l)),h.push([R,v])}function L(){return h}}),define(Pe[217],ke([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class s{constructor(A,L){this.key=A,this.data=L,this.incoming=new Map,this.outgoing=new Map}}e.Node=s;class h{constructor(A){this._hashFn=A,this._nodes=new Map}roots(){const A=[];for(const L of this._nodes.values())L.outgoing.size===0&&A.push(L);return A}insertEdge(A,L){const R=this.lookupOrInsertNode(A),v=this.lookupOrInsertNode(L);R.outgoing.set(v.key,v),v.incoming.set(R.key,R)}removeNode(A){const L=this._hashFn(A);this._nodes.delete(L);for(const R of this._nodes.values())R.outgoing.delete(L),R.incoming.delete(L)}lookupOrInsertNode(A){const L=this._hashFn(A);let R=this._nodes.get(L);return R||(R=new s(L,A),this._nodes.set(L,R)),R}lookup(A){return this._nodes.get(this._hashFn(A))}isEmpty(){return this._nodes.size===0}toString(){const A=[];for(const[L,R]of this._nodes)A.push(`${L}
	(-> incoming)[${[...R.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...R.outgoing.keys()].join(",")}]
`);return A.join(`
`)}findCycleSlow(){for(const[A,L]of this._nodes){const R=new Set([A]),v=this._findCycle(L,R);if(v)return v}}_findCycle(A,L){for(const[R,v]of A.outgoing){if(L.has(R))return[...L,R].join(" -> ");L.add(R);const l=this._findCycle(v,L);if(l)return l;L.delete(R)}}}e.Graph=h}),define(Pe[5],ke([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IInstantiationService=e._util=void 0,e.createDecorator=D,e.refineServiceDecorator=A;var s;(function(L){L.serviceIds=new Map,L.DI_TARGET="$di$target",L.DI_DEPENDENCIES="$di$dependencies";function R(v){return v[L.DI_DEPENDENCIES]||[]}L.getServiceDependencies=R})(s||(e._util=s={})),e.IInstantiationService=D("instantiationService");function h(L,R,v){R[s.DI_TARGET]===R?R[s.DI_DEPENDENCIES].push({id:L,index:v}):(R[s.DI_DEPENDENCIES]=[{id:L,index:v}],R[s.DI_TARGET]=R)}function D(L){if(s.serviceIds.has(L))return s.serviceIds.get(L);const R=function(v,l,C){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");h(R,v,C)};return R.toString=()=>L,s.serviceIds.set(L,R),R}function A(L){return L}}),define(Pe[46],ke([1,0,17,2,5]),function(ge,e,s,h,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.IConfigurationService=void 0,e.isConfigurationOverrides=A,e.isConfigurationUpdateOverrides=L,e.ConfigurationTargetToString=v,e.isConfigured=l,e.toValuesTree=C,e.addToValueTree=_,e.removeFromValueTree=f,e.getConfigurationValue=S,e.merge=o,e.getLanguageTagSettingPlainKey=m,s=We(s),e.IConfigurationService=(0,D.createDecorator)("configurationService");function A(p){return p&&typeof p=="object"&&(!p.overrideIdentifier||typeof p.overrideIdentifier=="string")&&(!p.resource||p.resource instanceof h.URI)}function L(p){return p&&typeof p=="object"&&(!p.overrideIdentifiers||Array.isArray(p.overrideIdentifiers))&&!p.overrideIdentifier&&(!p.resource||p.resource instanceof h.URI)}var R;(function(p){p[p.APPLICATION=1]="APPLICATION",p[p.USER=2]="USER",p[p.USER_LOCAL=3]="USER_LOCAL",p[p.USER_REMOTE=4]="USER_REMOTE",p[p.WORKSPACE=5]="WORKSPACE",p[p.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",p[p.DEFAULT=7]="DEFAULT",p[p.MEMORY=8]="MEMORY"})(R||(e.ConfigurationTarget=R={}));function v(p){switch(p){case R.APPLICATION:return"APPLICATION";case R.USER:return"USER";case R.USER_LOCAL:return"USER_LOCAL";case R.USER_REMOTE:return"USER_REMOTE";case R.WORKSPACE:return"WORKSPACE";case R.WORKSPACE_FOLDER:return"WORKSPACE_FOLDER";case R.DEFAULT:return"DEFAULT";case R.MEMORY:return"MEMORY"}}function l(p){return p.applicationValue!==void 0||p.userValue!==void 0||p.userLocalValue!==void 0||p.userRemoteValue!==void 0||p.workspaceValue!==void 0||p.workspaceFolderValue!==void 0}function C(p,u){const i=Object.create(null);for(const a in p)_(i,a,p[a],u);return i}function _(p,u,i,a){const t=u.split("."),n=t.pop();let r=p;for(let d=0;d<t.length;d++){const c=t[d];let g=r[c];switch(typeof g){case"undefined":g=r[c]=Object.create(null);break;case"object":if(g===null){a(`Ignoring ${u} as ${t.slice(0,d+1).join(".")} is null`);return}break;default:a(`Ignoring ${u} as ${t.slice(0,d+1).join(".")} is ${JSON.stringify(g)}`);return}r=g}if(typeof r=="object"&&r!==null)try{r[n]=i}catch{a(`Ignoring ${u} as ${t.join(".")} is ${JSON.stringify(r)}`)}else a(`Ignoring ${u} as ${t.join(".")} is ${JSON.stringify(r)}`)}function f(p,u){const i=u.split(".");T(p,i)}function T(p,u){const i=u.shift();if(u.length===0){delete p[i];return}if(Object.keys(p).indexOf(i)!==-1){const a=p[i];typeof a=="object"&&!Array.isArray(a)&&(T(a,u),Object.keys(a).length===0&&delete p[i])}}function S(p,u,i){function a(r,d){let c=r;for(const g of d){if(typeof c!="object"||c===null)return;c=c[g]}return c}const t=u.split("."),n=a(p,t);return typeof n>"u"?i:n}function o(p,u,i){Object.keys(u).forEach(a=>{a!=="__proto__"&&(a in p?s.isObject(p[a])&&s.isObject(u[a])?o(p[a],u[a],i):i&&(p[a]=u[a]):p[a]=u[a])})}function m(p){return p.replace(/[\[\]]/g,"")}}),define(Pe[36],ke([1,0,26,10,13,216,5,7,12]),function(ge,e,s,h,D,A,L,R,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.ContextKeyExpr=e.Parser=e.ContextKeyExprType=void 0,e.setConstant=C,e.validateWhenClauses=d,e.expressionsAreEqualWithConstantSubstitution=c,e.implies=te;const l=new Map;l.set("false",!1),l.set("true",!0),l.set("isMac",h.isMacintosh),l.set("isLinux",h.isLinux),l.set("isWindows",h.isWindows),l.set("isWeb",h.isWeb),l.set("isMacNative",h.isMacintosh&&!h.isWeb),l.set("isEdge",h.isEdge),l.set("isFirefox",h.isFirefox),l.set("isChrome",h.isChrome),l.set("isSafari",h.isSafari);function C(Q,z){if(l.get(Q)!==void 0)throw(0,v.illegalArgument)("contextkey.setConstant(k, v) invoked with already set constant `k`");l.set(Q,z)}const _=Object.prototype.hasOwnProperty;var f;(function(Q){Q[Q.False=0]="False",Q[Q.True=1]="True",Q[Q.Defined=2]="Defined",Q[Q.Not=3]="Not",Q[Q.Equals=4]="Equals",Q[Q.NotEquals=5]="NotEquals",Q[Q.And=6]="And",Q[Q.Regex=7]="Regex",Q[Q.NotRegex=8]="NotRegex",Q[Q.Or=9]="Or",Q[Q.In=10]="In",Q[Q.NotIn=11]="NotIn",Q[Q.Greater=12]="Greater",Q[Q.GreaterEquals=13]="GreaterEquals",Q[Q.Smaller=14]="Smaller",Q[Q.SmallerEquals=15]="SmallerEquals"})(f||(e.ContextKeyExprType=f={}));const T={regexParsingWithErrorRecovery:!0},S=(0,R.localize)(1673,null),o=(0,R.localize)(1674,null),m=(0,R.localize)(1675,null),p=(0,R.localize)(1676,null),u=(0,R.localize)(1677,null),i=(0,R.localize)(1678,null),a=(0,R.localize)(1679,null),t=(0,R.localize)(1680,null);class n{static{this._parseError=new Error}get lexingErrors(){return this._scanner.errors}get parsingErrors(){return this._parsingErrors}constructor(z=T){this._config=z,this._scanner=new A.Scanner,this._tokens=[],this._current=0,this._parsingErrors=[],this._flagsGYRe=/g|y/g}parse(z){if(z===""){this._parsingErrors.push({message:S,offset:0,lexeme:"",additionalInfo:o});return}this._tokens=this._scanner.reset(z).scan(),this._current=0,this._parsingErrors=[];try{const se=this._expr();if(!this._isAtEnd()){const Ee=this._peek(),ae=Ee.type===A.TokenType.Str?i:void 0;throw this._parsingErrors.push({message:u,offset:Ee.offset,lexeme:A.Scanner.getLexeme(Ee),additionalInfo:ae}),n._parseError}return se}catch(se){if(se!==n._parseError)throw se;return}}_expr(){return this._or()}_or(){const z=[this._and()];for(;this._matchOne(A.TokenType.Or);){const se=this._and();z.push(se)}return z.length===1?z[0]:r.or(...z)}_and(){const z=[this._term()];for(;this._matchOne(A.TokenType.And);){const se=this._term();z.push(se)}return z.length===1?z[0]:r.and(...z)}_term(){if(this._matchOne(A.TokenType.Neg)){const z=this._peek();switch(z.type){case A.TokenType.True:return this._advance(),w.INSTANCE;case A.TokenType.False:return this._advance(),y.INSTANCE;case A.TokenType.LParen:{this._advance();const se=this._expr();return this._consume(A.TokenType.RParen,p),se?.negate()}case A.TokenType.Str:return this._advance(),N.create(z.lexeme);default:throw this._errExpectedButGot("KEY | true | false | '(' expression ')'",z)}}return this._primary()}_primary(){const z=this._peek();switch(z.type){case A.TokenType.True:return this._advance(),r.true();case A.TokenType.False:return this._advance(),r.false();case A.TokenType.LParen:{this._advance();const se=this._expr();return this._consume(A.TokenType.RParen,p),se}case A.TokenType.Str:{const se=z.lexeme;if(this._advance(),this._matchOne(A.TokenType.RegexOp)){const ae=this._peek();if(!this._config.regexParsingWithErrorRecovery){if(this._advance(),ae.type!==A.TokenType.RegexStr)throw this._errExpectedButGot("REGEX",ae);const be=ae.lexeme,pe=be.lastIndexOf("/"),ve=pe===be.length-1?void 0:this._removeFlagsGY(be.substring(pe+1));let Re;try{Re=new RegExp(be.substring(1,pe),ve)}catch{throw this._errExpectedButGot("REGEX",ae)}return x.create(se,Re)}switch(ae.type){case A.TokenType.RegexStr:case A.TokenType.Error:{const be=[ae.lexeme];this._advance();let pe=this._peek(),ve=0;for(let Je=0;Je<ae.lexeme.length;Je++)ae.lexeme.charCodeAt(Je)===s.CharCode.OpenParen?ve++:ae.lexeme.charCodeAt(Je)===s.CharCode.CloseParen&&ve--;for(;!this._isAtEnd()&&pe.type!==A.TokenType.And&&pe.type!==A.TokenType.Or;){switch(pe.type){case A.TokenType.LParen:ve++;break;case A.TokenType.RParen:ve--;break;case A.TokenType.RegexStr:case A.TokenType.QuotedStr:for(let Je=0;Je<pe.lexeme.length;Je++)pe.lexeme.charCodeAt(Je)===s.CharCode.OpenParen?ve++:ae.lexeme.charCodeAt(Je)===s.CharCode.CloseParen&&ve--}if(ve<0)break;be.push(A.Scanner.getLexeme(pe)),this._advance(),pe=this._peek()}const Re=be.join(""),Fe=Re.lastIndexOf("/"),Ve=Fe===Re.length-1?void 0:this._removeFlagsGY(Re.substring(Fe+1));let Ye;try{Ye=new RegExp(Re.substring(1,Fe),Ve)}catch{throw this._errExpectedButGot("REGEX",ae)}return r.regex(se,Ye)}case A.TokenType.QuotedStr:{const be=ae.lexeme;this._advance();let pe=null;if(!(0,D.isFalsyOrWhitespace)(be)){const ve=be.indexOf("/"),Re=be.lastIndexOf("/");if(ve!==Re&&ve>=0){const Fe=be.slice(ve+1,Re),Ve=be[Re+1]==="i"?"i":"";try{pe=new RegExp(Fe,Ve)}catch{throw this._errExpectedButGot("REGEX",ae)}}}if(pe===null)throw this._errExpectedButGot("REGEX",ae);return x.create(se,pe)}default:throw this._errExpectedButGot("REGEX",this._peek())}}if(this._matchOne(A.TokenType.Not)){this._consume(A.TokenType.In,m);const ae=this._value();return r.notIn(se,ae)}switch(this._peek().type){case A.TokenType.Eq:{this._advance();const ae=this._value();if(this._previous().type===A.TokenType.QuotedStr)return r.equals(se,ae);switch(ae){case"true":return r.has(se);case"false":return r.not(se);default:return r.equals(se,ae)}}case A.TokenType.NotEq:{this._advance();const ae=this._value();if(this._previous().type===A.TokenType.QuotedStr)return r.notEquals(se,ae);switch(ae){case"true":return r.not(se);case"false":return r.has(se);default:return r.notEquals(se,ae)}}case A.TokenType.Lt:return this._advance(),H.create(se,this._value());case A.TokenType.LtEq:return this._advance(),F.create(se,this._value());case A.TokenType.Gt:return this._advance(),M.create(se,this._value());case A.TokenType.GtEq:return this._advance(),U.create(se,this._value());case A.TokenType.In:return this._advance(),r.in(se,this._value());default:return r.has(se)}}case A.TokenType.EOF:throw this._parsingErrors.push({message:a,offset:z.offset,lexeme:"",additionalInfo:t}),n._parseError;default:throw this._errExpectedButGot(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this._peek())}}_value(){const z=this._peek();switch(z.type){case A.TokenType.Str:case A.TokenType.QuotedStr:return this._advance(),z.lexeme;case A.TokenType.True:return this._advance(),"true";case A.TokenType.False:return this._advance(),"false";case A.TokenType.In:return this._advance(),"in";default:return""}}_removeFlagsGY(z){return z.replaceAll(this._flagsGYRe,"")}_previous(){return this._tokens[this._current-1]}_matchOne(z){return this._check(z)?(this._advance(),!0):!1}_advance(){return this._isAtEnd()||this._current++,this._previous()}_consume(z,se){if(this._check(z))return this._advance();throw this._errExpectedButGot(se,this._peek())}_errExpectedButGot(z,se,Ee){const ae=(0,R.localize)(1681,null,z,A.Scanner.getLexeme(se)),be=se.offset,pe=A.Scanner.getLexeme(se);return this._parsingErrors.push({message:ae,offset:be,lexeme:pe,additionalInfo:Ee}),n._parseError}_check(z){return this._peek().type===z}_peek(){return this._tokens[this._current]}_isAtEnd(){return this._peek().type===A.TokenType.EOF}}e.Parser=n;class r{static false(){return w.INSTANCE}static true(){return y.INSTANCE}static has(z){return I.create(z)}static equals(z,se){return P.create(z,se)}static notEquals(z,se){return E.create(z,se)}static regex(z,se){return x.create(z,se)}static in(z,se){return k.create(z,se)}static notIn(z,se){return b.create(z,se)}static not(z){return N.create(z)}static and(...z){return B.create(z,null,!0)}static or(...z){return W.create(z,null,!0)}static greater(z,se){return M.create(z,se)}static greaterEquals(z,se){return U.create(z,se)}static smaller(z,se){return H.create(z,se)}static smallerEquals(z,se){return F.create(z,se)}static{this._parser=new n({regexParsingWithErrorRecovery:!1})}static deserialize(z){return z==null?void 0:this._parser.parse(z)}}e.ContextKeyExpr=r;function d(Q){const z=new n({regexParsingWithErrorRecovery:!1});return Q.map(se=>(z.parse(se),z.lexingErrors.length>0?z.lexingErrors.map(Ee=>({errorMessage:Ee.additionalInfo?(0,R.localize)(1682,null,Ee.additionalInfo):(0,R.localize)(1683,null),offset:Ee.offset,length:Ee.lexeme.length})):z.parsingErrors.length>0?z.parsingErrors.map(Ee=>({errorMessage:Ee.additionalInfo?`${Ee.message}. ${Ee.additionalInfo}`:Ee.message,offset:Ee.offset,length:Ee.lexeme.length})):[]))}function c(Q,z){const se=Q?Q.substituteConstants():void 0,Ee=z?z.substituteConstants():void 0;return!se&&!Ee?!0:!se||!Ee?!1:se.equals(Ee)}function g(Q,z){return Q.cmp(z)}class w{static{this.INSTANCE=new w}constructor(){this.type=f.False}cmp(z){return this.type-z.type}equals(z){return z.type===this.type}substituteConstants(){return this}evaluate(z){return!1}serialize(){return"false"}keys(){return[]}map(z){return this}negate(){return y.INSTANCE}}e.ContextKeyFalseExpr=w;class y{static{this.INSTANCE=new y}constructor(){this.type=f.True}cmp(z){return this.type-z.type}equals(z){return z.type===this.type}substituteConstants(){return this}evaluate(z){return!0}serialize(){return"true"}keys(){return[]}map(z){return this}negate(){return w.INSTANCE}}e.ContextKeyTrueExpr=y;class I{static create(z,se=null){const Ee=l.get(z);return typeof Ee=="boolean"?Ee?y.INSTANCE:w.INSTANCE:new I(z,se)}constructor(z,se){this.key=z,this.negated=se,this.type=f.Defined}cmp(z){return z.type!==this.type?this.type-z.type:J(this.key,z.key)}equals(z){return z.type===this.type?this.key===z.key:!1}substituteConstants(){const z=l.get(this.key);return typeof z=="boolean"?z?y.INSTANCE:w.INSTANCE:this}evaluate(z){return!!z.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(z){return z.mapDefined(this.key)}negate(){return this.negated||(this.negated=N.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=I;class P{static create(z,se,Ee=null){if(typeof se=="boolean")return se?I.create(z,Ee):N.create(z,Ee);const ae=l.get(z);return typeof ae=="boolean"?se===(ae?"true":"false")?y.INSTANCE:w.INSTANCE:new P(z,se,Ee)}constructor(z,se,Ee){this.key=z,this.value=se,this.negated=Ee,this.type=f.Equals}cmp(z){return z.type!==this.type?this.type-z.type:oe(this.key,this.value,z.key,z.value)}equals(z){return z.type===this.type?this.key===z.key&&this.value===z.value:!1}substituteConstants(){const z=l.get(this.key);if(typeof z=="boolean"){const se=z?"true":"false";return this.value===se?y.INSTANCE:w.INSTANCE}return this}evaluate(z){return z.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(z){return z.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=E.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=P;class k{static create(z,se){return new k(z,se)}constructor(z,se){this.key=z,this.valueKey=se,this.type=f.In,this.negated=null}cmp(z){return z.type!==this.type?this.type-z.type:oe(this.key,this.valueKey,z.key,z.valueKey)}equals(z){return z.type===this.type?this.key===z.key&&this.valueKey===z.valueKey:!1}substituteConstants(){return this}evaluate(z){const se=z.getValue(this.valueKey),Ee=z.getValue(this.key);return Array.isArray(se)?se.includes(Ee):typeof Ee=="string"&&typeof se=="object"&&se!==null?_.call(se,Ee):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(z){return z.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=b.create(this.key,this.valueKey)),this.negated}}e.ContextKeyInExpr=k;class b{static create(z,se){return new b(z,se)}constructor(z,se){this.key=z,this.valueKey=se,this.type=f.NotIn,this._negated=k.create(z,se)}cmp(z){return z.type!==this.type?this.type-z.type:this._negated.cmp(z._negated)}equals(z){return z.type===this.type?this._negated.equals(z._negated):!1}substituteConstants(){return this}evaluate(z){return!this._negated.evaluate(z)}serialize(){return`${this.key} not in '${this.valueKey}'`}keys(){return this._negated.keys()}map(z){return z.mapNotIn(this.key,this.valueKey)}negate(){return this._negated}}e.ContextKeyNotInExpr=b;class E{static create(z,se,Ee=null){if(typeof se=="boolean")return se?N.create(z,Ee):I.create(z,Ee);const ae=l.get(z);return typeof ae=="boolean"?se===(ae?"true":"false")?w.INSTANCE:y.INSTANCE:new E(z,se,Ee)}constructor(z,se,Ee){this.key=z,this.value=se,this.negated=Ee,this.type=f.NotEquals}cmp(z){return z.type!==this.type?this.type-z.type:oe(this.key,this.value,z.key,z.value)}equals(z){return z.type===this.type?this.key===z.key&&this.value===z.value:!1}substituteConstants(){const z=l.get(this.key);if(typeof z=="boolean"){const se=z?"true":"false";return this.value===se?w.INSTANCE:y.INSTANCE}return this}evaluate(z){return z.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(z){return z.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=P.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=E;class N{static create(z,se=null){const Ee=l.get(z);return typeof Ee=="boolean"?Ee?w.INSTANCE:y.INSTANCE:new N(z,se)}constructor(z,se){this.key=z,this.negated=se,this.type=f.Not}cmp(z){return z.type!==this.type?this.type-z.type:J(this.key,z.key)}equals(z){return z.type===this.type?this.key===z.key:!1}substituteConstants(){const z=l.get(this.key);return typeof z=="boolean"?z?w.INSTANCE:y.INSTANCE:this}evaluate(z){return!z.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(z){return z.mapNot(this.key)}negate(){return this.negated||(this.negated=I.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=N;function O(Q,z){if(typeof Q=="string"){const se=parseFloat(Q);isNaN(se)||(Q=se)}return typeof Q=="string"||typeof Q=="number"?z(Q):w.INSTANCE}class M{static create(z,se,Ee=null){return O(se,ae=>new M(z,ae,Ee))}constructor(z,se,Ee){this.key=z,this.value=se,this.negated=Ee,this.type=f.Greater}cmp(z){return z.type!==this.type?this.type-z.type:oe(this.key,this.value,z.key,z.value)}equals(z){return z.type===this.type?this.key===z.key&&this.value===z.value:!1}substituteConstants(){return this}evaluate(z){return typeof this.value=="string"?!1:parseFloat(z.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(z){return z.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=F.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=M;class U{static create(z,se,Ee=null){return O(se,ae=>new U(z,ae,Ee))}constructor(z,se,Ee){this.key=z,this.value=se,this.negated=Ee,this.type=f.GreaterEquals}cmp(z){return z.type!==this.type?this.type-z.type:oe(this.key,this.value,z.key,z.value)}equals(z){return z.type===this.type?this.key===z.key&&this.value===z.value:!1}substituteConstants(){return this}evaluate(z){return typeof this.value=="string"?!1:parseFloat(z.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(z){return z.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=H.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=U;class H{static create(z,se,Ee=null){return O(se,ae=>new H(z,ae,Ee))}constructor(z,se,Ee){this.key=z,this.value=se,this.negated=Ee,this.type=f.Smaller}cmp(z){return z.type!==this.type?this.type-z.type:oe(this.key,this.value,z.key,z.value)}equals(z){return z.type===this.type?this.key===z.key&&this.value===z.value:!1}substituteConstants(){return this}evaluate(z){return typeof this.value=="string"?!1:parseFloat(z.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(z){return z.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=U.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=H;class F{static create(z,se,Ee=null){return O(se,ae=>new F(z,ae,Ee))}constructor(z,se,Ee){this.key=z,this.value=se,this.negated=Ee,this.type=f.SmallerEquals}cmp(z){return z.type!==this.type?this.type-z.type:oe(this.key,this.value,z.key,z.value)}equals(z){return z.type===this.type?this.key===z.key&&this.value===z.value:!1}substituteConstants(){return this}evaluate(z){return typeof this.value=="string"?!1:parseFloat(z.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(z){return z.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=M.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=F;class x{static create(z,se){return new x(z,se)}constructor(z,se){this.key=z,this.regexp=se,this.type=f.Regex,this.negated=null}cmp(z){if(z.type!==this.type)return this.type-z.type;if(this.key<z.key)return-1;if(this.key>z.key)return 1;const se=this.regexp?this.regexp.source:"",Ee=z.regexp?z.regexp.source:"";return se<Ee?-1:se>Ee?1:0}equals(z){if(z.type===this.type){const se=this.regexp?this.regexp.source:"",Ee=z.regexp?z.regexp.source:"";return this.key===z.key&&se===Ee}return!1}substituteConstants(){return this}evaluate(z){const se=z.getValue(this.key);return this.regexp?this.regexp.test(se):!1}serialize(){const z=this.regexp?`/${this.regexp.source}/${this.regexp.flags}`:"/invalid/";return`${this.key} =~ ${z}`}keys(){return[this.key]}map(z){return z.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=$.create(this)),this.negated}}e.ContextKeyRegexExpr=x;class ${static create(z){return new $(z)}constructor(z){this._actual=z,this.type=f.NotRegex}cmp(z){return z.type!==this.type?this.type-z.type:this._actual.cmp(z._actual)}equals(z){return z.type===this.type?this._actual.equals(z._actual):!1}substituteConstants(){return this}evaluate(z){return!this._actual.evaluate(z)}serialize(){return`!(${this._actual.serialize()})`}keys(){return this._actual.keys()}map(z){return new $(this._actual.map(z))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=$;function G(Q){let z=null;for(let se=0,Ee=Q.length;se<Ee;se++){const ae=Q[se].substituteConstants();if(Q[se]!==ae&&z===null){z=[];for(let be=0;be<se;be++)z[be]=Q[be]}z!==null&&(z[se]=ae)}return z===null?Q:z}class B{static create(z,se,Ee){return B._normalizeArr(z,se,Ee)}constructor(z,se){this.expr=z,this.negated=se,this.type=f.And}cmp(z){if(z.type!==this.type)return this.type-z.type;if(this.expr.length<z.expr.length)return-1;if(this.expr.length>z.expr.length)return 1;for(let se=0,Ee=this.expr.length;se<Ee;se++){const ae=g(this.expr[se],z.expr[se]);if(ae!==0)return ae}return 0}equals(z){if(z.type===this.type){if(this.expr.length!==z.expr.length)return!1;for(let se=0,Ee=this.expr.length;se<Ee;se++)if(!this.expr[se].equals(z.expr[se]))return!1;return!0}return!1}substituteConstants(){const z=G(this.expr);return z===this.expr?this:B.create(z,this.negated,!1)}evaluate(z){for(let se=0,Ee=this.expr.length;se<Ee;se++)if(!this.expr[se].evaluate(z))return!1;return!0}static _normalizeArr(z,se,Ee){const ae=[];let be=!1;for(const pe of z)if(pe){if(pe.type===f.True){be=!0;continue}if(pe.type===f.False)return w.INSTANCE;if(pe.type===f.And){ae.push(...pe.expr);continue}ae.push(pe)}if(ae.length===0&&be)return y.INSTANCE;if(ae.length!==0){if(ae.length===1)return ae[0];ae.sort(g);for(let pe=1;pe<ae.length;pe++)ae[pe-1].equals(ae[pe])&&(ae.splice(pe,1),pe--);if(ae.length===1)return ae[0];for(;ae.length>1;){const pe=ae[ae.length-1];if(pe.type!==f.Or)break;ae.pop();const ve=ae.pop(),Re=ae.length===0,Fe=W.create(pe.expr.map(Ve=>B.create([Ve,ve],null,Ee)),null,Re);Fe&&(ae.push(Fe),ae.sort(g))}if(ae.length===1)return ae[0];if(Ee){for(let pe=0;pe<ae.length;pe++)for(let ve=pe+1;ve<ae.length;ve++)if(ae[pe].negate().equals(ae[ve]))return w.INSTANCE;if(ae.length===1)return ae[0]}return new B(ae,se)}}serialize(){return this.expr.map(z=>z.serialize()).join(" && ")}keys(){const z=[];for(const se of this.expr)z.push(...se.keys());return z}map(z){return new B(this.expr.map(se=>se.map(z)),null)}negate(){if(!this.negated){const z=[];for(const se of this.expr)z.push(se.negate());this.negated=W.create(z,this,!0)}return this.negated}}e.ContextKeyAndExpr=B;class W{static create(z,se,Ee){return W._normalizeArr(z,se,Ee)}constructor(z,se){this.expr=z,this.negated=se,this.type=f.Or}cmp(z){if(z.type!==this.type)return this.type-z.type;if(this.expr.length<z.expr.length)return-1;if(this.expr.length>z.expr.length)return 1;for(let se=0,Ee=this.expr.length;se<Ee;se++){const ae=g(this.expr[se],z.expr[se]);if(ae!==0)return ae}return 0}equals(z){if(z.type===this.type){if(this.expr.length!==z.expr.length)return!1;for(let se=0,Ee=this.expr.length;se<Ee;se++)if(!this.expr[se].equals(z.expr[se]))return!1;return!0}return!1}substituteConstants(){const z=G(this.expr);return z===this.expr?this:W.create(z,this.negated,!1)}evaluate(z){for(let se=0,Ee=this.expr.length;se<Ee;se++)if(this.expr[se].evaluate(z))return!0;return!1}static _normalizeArr(z,se,Ee){let ae=[],be=!1;if(z){for(let pe=0,ve=z.length;pe<ve;pe++){const Re=z[pe];if(Re){if(Re.type===f.False){be=!0;continue}if(Re.type===f.True)return y.INSTANCE;if(Re.type===f.Or){ae=ae.concat(Re.expr);continue}ae.push(Re)}}if(ae.length===0&&be)return w.INSTANCE;ae.sort(g)}if(ae.length!==0){if(ae.length===1)return ae[0];for(let pe=1;pe<ae.length;pe++)ae[pe-1].equals(ae[pe])&&(ae.splice(pe,1),pe--);if(ae.length===1)return ae[0];if(Ee){for(let pe=0;pe<ae.length;pe++)for(let ve=pe+1;ve<ae.length;ve++)if(ae[pe].negate().equals(ae[ve]))return y.INSTANCE;if(ae.length===1)return ae[0]}return new W(ae,se)}}serialize(){return this.expr.map(z=>z.serialize()).join(" || ")}keys(){const z=[];for(const se of this.expr)z.push(...se.keys());return z}map(z){return new W(this.expr.map(se=>se.map(z)),null)}negate(){if(!this.negated){const z=[];for(const se of this.expr)z.push(se.negate());for(;z.length>1;){const se=z.shift(),Ee=z.shift(),ae=[];for(const be of le(se))for(const pe of le(Ee))ae.push(B.create([be,pe],null,!1));z.unshift(W.create(ae,null,!1))}this.negated=W.create(z,this,!0)}return this.negated}}e.ContextKeyOrExpr=W;class Z extends I{static{this._info=[]}static all(){return Z._info.values()}constructor(z,se,Ee){super(z,null),this._defaultValue=se,typeof Ee=="object"?Z._info.push({...Ee,key:z}):Ee!==!0&&Z._info.push({key:z,description:Ee,type:se!=null?typeof se:void 0})}bindTo(z){return z.createKey(this.key,this._defaultValue)}getValue(z){return z.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(z){return P.create(this.key,z)}notEqualsTo(z){return E.create(this.key,z)}}e.RawContextKey=Z,e.IContextKeyService=(0,L.createDecorator)("contextKeyService");function J(Q,z){return Q<z?-1:Q>z?1:0}function oe(Q,z,se,Ee){return Q<se?-1:Q>se?1:z<Ee?-1:z>Ee?1:0}function te(Q,z){if(Q.type===f.False||z.type===f.True)return!0;if(Q.type===f.Or)return z.type===f.Or?me(Q.expr,z.expr):!1;if(z.type===f.Or){for(const se of z.expr)if(te(Q,se))return!0;return!1}if(Q.type===f.And){if(z.type===f.And)return me(z.expr,Q.expr);for(const se of Q.expr)if(te(se,z))return!0;return!1}return Q.equals(z)}function me(Q,z){let se=0,Ee=0;for(;se<Q.length&&Ee<z.length;){const ae=Q[se].cmp(z[Ee]);if(ae<0)return!1;ae===0&&se++,Ee++}return se===Q.length}function le(Q){return Q.type===f.Or?Q.expr:[Q]}}),define(Pe[218],ke([1,0,36,5]),function(ge,e,s,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ACCESSIBLE_VIEW_SHOWN_STORAGE_PREFIX=e.CONTEXT_ACCESSIBILITY_MODE_ENABLED=e.AccessibilitySupport=e.IAccessibilityService=void 0,e.isAccessibilityInformation=A,e.IAccessibilityService=(0,h.createDecorator)("accessibilityService");var D;(function(L){L[L.Unknown=0]="Unknown",L[L.Disabled=1]="Disabled",L[L.Enabled=2]="Enabled"})(D||(e.AccessibilitySupport=D={})),e.CONTEXT_ACCESSIBILITY_MODE_ENABLED=new s.RawContextKey("accessibilityModeEnabled",!1);function A(L){return L&&typeof L=="object"&&typeof L.label=="string"&&(typeof L.role>"u"||typeof L.role=="string")}e.ACCESSIBLE_VIEW_SHOWN_STORAGE_PREFIX="ACCESSIBLE_VIEW_SHOWN_"}),define(Pe[113],ke([1,0,18,24,10,189,85,197,139,7,218]),function(ge,e,s,h,D,A,L,R,v,l,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.RenderLineNumbersType=e.ShowLightbulbIconMode=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0,e.boolean=i,e.clampedInt=t,e.clampedFloat=r,e.stringSet=g,e.cursorStyleToString=O,e.filterValidationDecorations=ze,s=We(s),h=We(h),D=We(D),l=We(l);var _;(function(ne){ne[ne.None=0]="None",ne[ne.Keep=1]="Keep",ne[ne.Brackets=2]="Brackets",ne[ne.Advanced=3]="Advanced",ne[ne.Full=4]="Full"})(_||(e.EditorAutoIndentStrategy=_={})),e.MINIMAP_GUTTER_WIDTH=8;class f{constructor(X){this._values=X}hasChanged(X){return this._values[X]}}e.ConfigurationChangedEvent=f;class T{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=T;class S{constructor(X,Te,qe,Xe){this.id=X,this.name=Te,this.defaultValue=qe,this.schema=Xe}applyUpdate(X,Te){return m(X,Te)}compute(X,Te,qe){return qe}}class o{constructor(X,Te){this.newValue=X,this.didChange=Te}}e.ApplyUpdateResult=o;function m(ne,X){if(typeof ne!="object"||typeof X!="object"||!ne||!X)return new o(X,ne!==X);if(Array.isArray(ne)||Array.isArray(X)){const qe=Array.isArray(ne)&&Array.isArray(X)&&s.equals(ne,X);return new o(X,!qe)}let Te=!1;for(const qe in X)if(X.hasOwnProperty(qe)){const Xe=m(ne[qe],X[qe]);Xe.didChange&&(ne[qe]=Xe.newValue,Te=!0)}return new o(ne,Te)}class p{constructor(X){this.schema=void 0,this.id=X,this.name="_never_",this.defaultValue=void 0}applyUpdate(X,Te){return m(X,Te)}validate(X){return this.defaultValue}}class u{constructor(X,Te,qe,Xe){this.id=X,this.name=Te,this.defaultValue=qe,this.schema=Xe}applyUpdate(X,Te){return m(X,Te)}validate(X){return typeof X>"u"?this.defaultValue:X}compute(X,Te,qe){return qe}}function i(ne,X){return typeof ne>"u"?X:ne==="false"?!1:!!ne}class a extends u{constructor(X,Te,qe,Xe=void 0){typeof Xe<"u"&&(Xe.type="boolean",Xe.default=qe),super(X,Te,qe,Xe)}validate(X){return i(X,this.defaultValue)}}function t(ne,X,Te,qe){if(typeof ne>"u")return X;let Xe=parseInt(ne,10);return isNaN(Xe)?X:(Xe=Math.max(Te,Xe),Xe=Math.min(qe,Xe),Xe|0)}class n extends u{static clampedInt(X,Te,qe,Xe){return t(X,Te,qe,Xe)}constructor(X,Te,qe,Xe,st,ht=void 0){typeof ht<"u"&&(ht.type="integer",ht.default=qe,ht.minimum=Xe,ht.maximum=st),super(X,Te,qe,ht),this.minimum=Xe,this.maximum=st}validate(X){return n.clampedInt(X,this.defaultValue,this.minimum,this.maximum)}}function r(ne,X,Te,qe){if(typeof ne>"u")return X;const Xe=d.float(ne,X);return d.clamp(Xe,Te,qe)}class d extends u{static clamp(X,Te,qe){return X<Te?Te:X>qe?qe:X}static float(X,Te){if(typeof X=="number")return X;if(typeof X>"u")return Te;const qe=parseFloat(X);return isNaN(qe)?Te:qe}constructor(X,Te,qe,Xe,st){typeof st<"u"&&(st.type="number",st.default=qe),super(X,Te,qe,st),this.validationFn=Xe}validate(X){return this.validationFn(d.float(X,this.defaultValue))}}class c extends u{static string(X,Te){return typeof X!="string"?Te:X}constructor(X,Te,qe,Xe=void 0){typeof Xe<"u"&&(Xe.type="string",Xe.default=qe),super(X,Te,qe,Xe)}validate(X){return c.string(X,this.defaultValue)}}function g(ne,X,Te,qe){return typeof ne!="string"?X:qe&&ne in qe?qe[ne]:Te.indexOf(ne)===-1?X:ne}class w extends u{constructor(X,Te,qe,Xe,st=void 0){typeof st<"u"&&(st.type="string",st.enum=Xe,st.default=qe),super(X,Te,qe,st),this._allowedValues=Xe}validate(X){return g(X,this.defaultValue,this._allowedValues)}}class y extends S{constructor(X,Te,qe,Xe,st,ht,gt=void 0){typeof gt<"u"&&(gt.type="string",gt.enum=st,gt.default=Xe),super(X,Te,qe,gt),this._allowedValues=st,this._convert=ht}validate(X){return typeof X!="string"?this.defaultValue:this._allowedValues.indexOf(X)===-1?this.defaultValue:this._convert(X)}}function I(ne){switch(ne){case"none":return _.None;case"keep":return _.Keep;case"brackets":return _.Brackets;case"advanced":return _.Advanced;case"full":return _.Full}}class P extends S{constructor(){super(Ie.accessibilitySupport,"accessibilitySupport",C.AccessibilitySupport.Unknown,{type:"string",enum:["auto","on","off"],enumDescriptions:[l.localize(302,null),l.localize(303,null),l.localize(304,null)],default:"auto",tags:["accessibility"],description:l.localize(305,null)})}validate(X){switch(X){case"auto":return C.AccessibilitySupport.Unknown;case"off":return C.AccessibilitySupport.Disabled;case"on":return C.AccessibilitySupport.Enabled}return this.defaultValue}compute(X,Te,qe){return qe===C.AccessibilitySupport.Unknown?X.accessibilitySupport:qe}}class k extends S{constructor(){const X={insertSpace:!0,ignoreEmptyLines:!0};super(Ie.comments,"comments",X,{"editor.comments.insertSpace":{type:"boolean",default:X.insertSpace,description:l.localize(306,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:X.ignoreEmptyLines,description:l.localize(307,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const Te=X;return{insertSpace:i(Te.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:i(Te.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var b;(function(ne){ne[ne.Hidden=0]="Hidden",ne[ne.Blink=1]="Blink",ne[ne.Smooth=2]="Smooth",ne[ne.Phase=3]="Phase",ne[ne.Expand=4]="Expand",ne[ne.Solid=5]="Solid"})(b||(e.TextEditorCursorBlinkingStyle=b={}));function E(ne){switch(ne){case"blink":return b.Blink;case"smooth":return b.Smooth;case"phase":return b.Phase;case"expand":return b.Expand;case"solid":return b.Solid}}var N;(function(ne){ne[ne.Line=1]="Line",ne[ne.Block=2]="Block",ne[ne.Underline=3]="Underline",ne[ne.LineThin=4]="LineThin",ne[ne.BlockOutline=5]="BlockOutline",ne[ne.UnderlineThin=6]="UnderlineThin"})(N||(e.TextEditorCursorStyle=N={}));function O(ne){switch(ne){case N.Line:return"line";case N.Block:return"block";case N.Underline:return"underline";case N.LineThin:return"line-thin";case N.BlockOutline:return"block-outline";case N.UnderlineThin:return"underline-thin"}}function M(ne){switch(ne){case"line":return N.Line;case"block":return N.Block;case"underline":return N.Underline;case"line-thin":return N.LineThin;case"block-outline":return N.BlockOutline;case"underline-thin":return N.UnderlineThin}}class U extends p{constructor(){super(Ie.editorClassName)}compute(X,Te,qe){const Xe=["monaco-editor"];return Te.get(Ie.extraEditorClassName)&&Xe.push(Te.get(Ie.extraEditorClassName)),X.extraEditorClassName&&Xe.push(X.extraEditorClassName),Te.get(Ie.mouseStyle)==="default"?Xe.push("mouse-default"):Te.get(Ie.mouseStyle)==="copy"&&Xe.push("mouse-copy"),Te.get(Ie.showUnused)&&Xe.push("showUnused"),Te.get(Ie.showDeprecated)&&Xe.push("showDeprecated"),Xe.join(" ")}}class H extends a{constructor(){super(Ie.emptySelectionClipboard,"emptySelectionClipboard",!0,{description:l.localize(308,null)})}compute(X,Te,qe){return qe&&X.emptySelectionClipboard}}class F extends S{constructor(){const X={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(Ie.find,"find",X,{"editor.find.cursorMoveOnType":{type:"boolean",default:X.cursorMoveOnType,description:l.localize(309,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:X.seedSearchStringFromSelection,enumDescriptions:[l.localize(310,null),l.localize(311,null),l.localize(312,null)],description:l.localize(313,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:X.autoFindInSelection,enumDescriptions:[l.localize(314,null),l.localize(315,null),l.localize(316,null)],description:l.localize(317,null)},"editor.find.globalFindClipboard":{type:"boolean",default:X.globalFindClipboard,description:l.localize(318,null),included:D.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:X.addExtraSpaceOnTop,description:l.localize(319,null)},"editor.find.loop":{type:"boolean",default:X.loop,description:l.localize(320,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const Te=X;return{cursorMoveOnType:i(Te.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof X.seedSearchStringFromSelection=="boolean"?X.seedSearchStringFromSelection?"always":"never":g(Te.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof X.autoFindInSelection=="boolean"?X.autoFindInSelection?"always":"never":g(Te.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:i(Te.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:i(Te.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:i(Te.loop,this.defaultValue.loop)}}}class x extends S{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(Ie.fontLigatures,"fontLigatures",x.OFF,{anyOf:[{type:"boolean",description:l.localize(321,null)},{type:"string",description:l.localize(322,null)}],description:l.localize(323,null),default:!1})}validate(X){return typeof X>"u"?this.defaultValue:typeof X=="string"?X==="false"||X.length===0?x.OFF:X==="true"?x.ON:X:X?x.ON:x.OFF}}e.EditorFontLigatures=x;class $ extends S{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(Ie.fontVariations,"fontVariations",$.OFF,{anyOf:[{type:"boolean",description:l.localize(324,null)},{type:"string",description:l.localize(325,null)}],description:l.localize(326,null),default:!1})}validate(X){return typeof X>"u"?this.defaultValue:typeof X=="string"?X==="false"?$.OFF:X==="true"?$.TRANSLATE:X:X?$.TRANSLATE:$.OFF}compute(X,Te,qe){return X.fontInfo.fontVariationSettings}}e.EditorFontVariations=$;class G extends p{constructor(){super(Ie.fontInfo)}compute(X,Te,qe){return X.fontInfo}}class B extends u{constructor(){super(Ie.fontSize,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:l.localize(327,null)})}validate(X){const Te=d.float(X,this.defaultValue);return Te===0?e.EDITOR_FONT_DEFAULTS.fontSize:d.clamp(Te,6,100)}compute(X,Te,qe){return X.fontInfo.fontSize}}class W extends S{static{this.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.MINIMUM_VALUE=1}static{this.MAXIMUM_VALUE=1e3}constructor(){super(Ie.fontWeight,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:W.MINIMUM_VALUE,maximum:W.MAXIMUM_VALUE,errorMessage:l.localize(328,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:W.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:l.localize(329,null)})}validate(X){return X==="normal"||X==="bold"?X:String(n.clampedInt(X,e.EDITOR_FONT_DEFAULTS.fontWeight,W.MINIMUM_VALUE,W.MAXIMUM_VALUE))}}class Z extends S{constructor(){const X={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",multipleTests:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:"",alternativeTestsCommand:""},Te={type:"string",enum:["peek","gotoAndPeek","goto"],default:X.multiple,enumDescriptions:[l.localize(330,null),l.localize(331,null),l.localize(332,null)]},qe=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(Ie.gotoLocation,"gotoLocation",X,{"editor.gotoLocation.multiple":{deprecationMessage:l.localize(333,null)},"editor.gotoLocation.multipleDefinitions":{description:l.localize(334,null),...Te},"editor.gotoLocation.multipleTypeDefinitions":{description:l.localize(335,null),...Te},"editor.gotoLocation.multipleDeclarations":{description:l.localize(336,null),...Te},"editor.gotoLocation.multipleImplementations":{description:l.localize(337,null),...Te},"editor.gotoLocation.multipleReferences":{description:l.localize(338,null),...Te},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:X.alternativeDefinitionCommand,enum:qe,description:l.localize(339,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:X.alternativeTypeDefinitionCommand,enum:qe,description:l.localize(340,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:X.alternativeDeclarationCommand,enum:qe,description:l.localize(341,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:X.alternativeImplementationCommand,enum:qe,description:l.localize(342,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:X.alternativeReferenceCommand,enum:qe,description:l.localize(343,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const Te=X;return{multiple:g(Te.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:Te.multipleDefinitions??g(Te.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:Te.multipleTypeDefinitions??g(Te.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:Te.multipleDeclarations??g(Te.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:Te.multipleImplementations??g(Te.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:Te.multipleReferences??g(Te.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),multipleTests:Te.multipleTests??g(Te.multipleTests,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:c.string(Te.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:c.string(Te.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:c.string(Te.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:c.string(Te.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:c.string(Te.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand),alternativeTestsCommand:c.string(Te.alternativeTestsCommand,this.defaultValue.alternativeTestsCommand)}}}class J extends S{constructor(){const X={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(Ie.hover,"hover",X,{"editor.hover.enabled":{type:"boolean",default:X.enabled,description:l.localize(344,null)},"editor.hover.delay":{type:"number",default:X.delay,minimum:0,maximum:1e4,description:l.localize(345,null)},"editor.hover.sticky":{type:"boolean",default:X.sticky,description:l.localize(346,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:X.hidingDelay,description:l.localize(347,null)},"editor.hover.above":{type:"boolean",default:X.above,description:l.localize(348,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const Te=X;return{enabled:i(Te.enabled,this.defaultValue.enabled),delay:n.clampedInt(Te.delay,this.defaultValue.delay,0,1e4),sticky:i(Te.sticky,this.defaultValue.sticky),hidingDelay:n.clampedInt(Te.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:i(Te.above,this.defaultValue.above)}}}var oe;(function(ne){ne[ne.None=0]="None",ne[ne.Text=1]="Text",ne[ne.Blocks=2]="Blocks"})(oe||(e.RenderMinimap=oe={}));class te extends p{constructor(){super(Ie.layoutInfo)}compute(X,Te,qe){return te.computeLayout(Te,{memory:X.memory,outerWidth:X.outerWidth,outerHeight:X.outerHeight,isDominatedByLongLines:X.isDominatedByLongLines,lineHeight:X.fontInfo.lineHeight,viewLineCount:X.viewLineCount,lineNumbersDigitCount:X.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:X.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:X.fontInfo.maxDigitWidth,pixelRatio:X.pixelRatio,glyphMarginDecorationLaneCount:X.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(X){const Te=X.height/X.lineHeight,qe=Math.floor(X.paddingTop/X.lineHeight);let Xe=Math.floor(X.paddingBottom/X.lineHeight);X.scrollBeyondLastLine&&(Xe=Math.max(Xe,Te-1));const st=(qe+X.viewLineCount+Xe)/(X.pixelRatio*X.height),ht=Math.floor(X.viewLineCount/st);return{typicalViewportLineCount:Te,extraLinesBeforeFirstLine:qe,extraLinesBeyondLastLine:Xe,desiredRatio:st,minimapLineCount:ht}}static _computeMinimapLayout(X,Te){const qe=X.outerWidth,Xe=X.outerHeight,st=X.pixelRatio;if(!X.minimap.enabled)return{renderMinimap:oe.None,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(st*Xe),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Xe};const ht=Te.stableMinimapLayoutInput,gt=ht&&X.outerHeight===ht.outerHeight&&X.lineHeight===ht.lineHeight&&X.typicalHalfwidthCharacterWidth===ht.typicalHalfwidthCharacterWidth&&X.pixelRatio===ht.pixelRatio&&X.scrollBeyondLastLine===ht.scrollBeyondLastLine&&X.paddingTop===ht.paddingTop&&X.paddingBottom===ht.paddingBottom&&X.minimap.enabled===ht.minimap.enabled&&X.minimap.side===ht.minimap.side&&X.minimap.size===ht.minimap.size&&X.minimap.showSlider===ht.minimap.showSlider&&X.minimap.renderCharacters===ht.minimap.renderCharacters&&X.minimap.maxColumn===ht.minimap.maxColumn&&X.minimap.scale===ht.minimap.scale&&X.verticalScrollbarWidth===ht.verticalScrollbarWidth&&X.isViewportWrapping===ht.isViewportWrapping,It=X.lineHeight,At=X.typicalHalfwidthCharacterWidth,qt=X.scrollBeyondLastLine,ei=X.minimap.renderCharacters;let tt=st>=2?Math.round(X.minimap.scale*2):X.minimap.scale;const Lt=X.minimap.maxColumn,Ut=X.minimap.size,bt=X.minimap.side,Pt=X.verticalScrollbarWidth,ti=X.viewLineCount,ii=X.remainingWidth,Kt=X.isViewportWrapping,St=ei?2:3;let Ot=Math.floor(st*Xe);const li=Ot/st;let Yt=!1,et=!1,ni=St*tt,ci=tt/st,di=1;if(Ut==="fill"||Ut==="fit"){const{typicalViewportLineCount:si,extraLinesBeforeFirstLine:Gt,extraLinesBeyondLastLine:Xt,desiredRatio:ui,minimapLineCount:Mt}=te.computeContainedMinimapLineCount({viewLineCount:ti,scrollBeyondLastLine:qt,paddingTop:X.paddingTop,paddingBottom:X.paddingBottom,height:Xe,lineHeight:It,pixelRatio:st});if(ti/Mt>1)Yt=!0,et=!0,tt=1,ni=1,ci=tt/st;else{let wt=!1,Qt=tt+1;if(Ut==="fit"){const yt=Math.ceil((Gt+ti+Xt)*ni);Kt&&gt&&ii<=Te.stableFitRemainingWidth?(wt=!0,Qt=Te.stableFitMaxMinimapScale):wt=yt>Ot}if(Ut==="fill"||wt){Yt=!0;const yt=tt;ni=Math.min(It*st,Math.max(1,Math.floor(1/ui))),Kt&&gt&&ii<=Te.stableFitRemainingWidth&&(Qt=Te.stableFitMaxMinimapScale),tt=Math.min(Qt,Math.max(1,Math.floor(ni/St))),tt>yt&&(di=Math.min(2,tt/yt)),ci=tt/st/di,Ot=Math.ceil(Math.max(si,Gt+ti+Xt)*ni),Kt?(Te.stableMinimapLayoutInput=X,Te.stableFitRemainingWidth=ii,Te.stableFitMaxMinimapScale=tt):(Te.stableMinimapLayoutInput=null,Te.stableFitRemainingWidth=0)}}}const Ct=Math.floor(Lt*ci),Wt=Math.min(Ct,Math.max(0,Math.floor((ii-Pt-2)*ci/(At+ci)))+e.MINIMAP_GUTTER_WIDTH);let Nt=Math.floor(st*Wt);const Bt=Nt/st;Nt=Math.floor(Nt*di);const ai=ei?oe.Text:oe.Blocks,ri=bt==="left"?0:qe-Wt-Pt;return{renderMinimap:ai,minimapLeft:ri,minimapWidth:Wt,minimapHeightIsEditorHeight:Yt,minimapIsSampling:et,minimapScale:tt,minimapLineHeight:ni,minimapCanvasInnerWidth:Nt,minimapCanvasInnerHeight:Ot,minimapCanvasOuterWidth:Bt,minimapCanvasOuterHeight:li}}static computeLayout(X,Te){const qe=Te.outerWidth|0,Xe=Te.outerHeight|0,st=Te.lineHeight|0,ht=Te.lineNumbersDigitCount|0,gt=Te.typicalHalfwidthCharacterWidth,It=Te.maxDigitWidth,At=Te.pixelRatio,qt=Te.viewLineCount,ei=X.get(Ie.wordWrapOverride2),tt=ei==="inherit"?X.get(Ie.wordWrapOverride1):ei,Lt=tt==="inherit"?X.get(Ie.wordWrap):tt,Ut=X.get(Ie.wordWrapColumn),bt=Te.isDominatedByLongLines,Pt=X.get(Ie.glyphMargin),ti=X.get(Ie.lineNumbers).renderType!==Je.Off,ii=X.get(Ie.lineNumbersMinChars),Kt=X.get(Ie.scrollBeyondLastLine),St=X.get(Ie.padding),Ot=X.get(Ie.minimap),li=X.get(Ie.scrollbar),Yt=li.verticalScrollbarSize,et=li.verticalHasArrows,ni=li.arrowSize,ci=li.horizontalScrollbarSize,di=X.get(Ie.folding),Ct=X.get(Ie.showFoldingControls)!=="never";let Wt=X.get(Ie.lineDecorationsWidth);di&&Ct&&(Wt+=16);let Nt=0;if(ti){const Jt=Math.max(ht,ii);Nt=Math.round(Jt*It)}let Bt=0;Pt&&(Bt=st*Te.glyphMarginDecorationLaneCount);let ai=0,ri=ai+Bt,si=ri+Nt,Gt=si+Wt;const Xt=qe-Bt-Nt-Wt;let ui=!1,Mt=!1,kt=-1;tt==="inherit"&&bt?(ui=!0,Mt=!0):Lt==="on"||Lt==="bounded"?Mt=!0:Lt==="wordWrapColumn"&&(kt=Ut);const wt=te._computeMinimapLayout({outerWidth:qe,outerHeight:Xe,lineHeight:st,typicalHalfwidthCharacterWidth:gt,pixelRatio:At,scrollBeyondLastLine:Kt,paddingTop:St.top,paddingBottom:St.bottom,minimap:Ot,verticalScrollbarWidth:Yt,viewLineCount:qt,remainingWidth:Xt,isViewportWrapping:Mt},Te.memory||new T);wt.renderMinimap!==oe.None&&wt.minimapLeft===0&&(ai+=wt.minimapWidth,ri+=wt.minimapWidth,si+=wt.minimapWidth,Gt+=wt.minimapWidth);const Qt=Xt-wt.minimapWidth,yt=Math.max(1,Math.floor((Qt-Yt-2)/gt)),oi=et?ni:0;return Mt&&(kt=Math.max(1,yt),Lt==="bounded"&&(kt=Math.min(kt,Ut))),{width:qe,height:Xe,glyphMarginLeft:ai,glyphMarginWidth:Bt,glyphMarginDecorationLaneCount:Te.glyphMarginDecorationLaneCount,lineNumbersLeft:ri,lineNumbersWidth:Nt,decorationsLeft:si,decorationsWidth:Wt,contentLeft:Gt,contentWidth:Qt,minimap:wt,viewportColumn:yt,isWordWrapMinified:ui,isViewportWrapping:Mt,wrappingColumn:kt,verticalScrollbarWidth:Yt,horizontalScrollbarHeight:ci,overviewRuler:{top:oi,width:Yt,height:Xe-2*oi,right:0}}}}e.EditorLayoutInfoComputer=te;class me extends S{constructor(){super(Ie.wrappingStrategy,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[l.localize(349,null),l.localize(350,null)],type:"string",enum:["simple","advanced"],default:"simple",description:l.localize(351,null)}})}validate(X){return g(X,"simple",["simple","advanced"])}compute(X,Te,qe){return Te.get(Ie.accessibilitySupport)===C.AccessibilitySupport.Enabled?"advanced":qe}}var le;(function(ne){ne.Off="off",ne.OnCode="onCode",ne.On="on"})(le||(e.ShowLightbulbIconMode=le={}));class Q extends S{constructor(){const X={enabled:le.OnCode};super(Ie.lightbulb,"lightbulb",X,{"editor.lightbulb.enabled":{type:"string",tags:["experimental"],enum:[le.Off,le.OnCode,le.On],default:X.enabled,enumDescriptions:[l.localize(352,null),l.localize(353,null),l.localize(354,null)],description:l.localize(355,null)}})}validate(X){return!X||typeof X!="object"?this.defaultValue:{enabled:g(X.enabled,this.defaultValue.enabled,[le.Off,le.OnCode,le.On])}}}class z extends S{constructor(){const X={enabled:!0,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(Ie.stickyScroll,"stickyScroll",X,{"editor.stickyScroll.enabled":{type:"boolean",default:X.enabled,description:l.localize(356,null),tags:["experimental"]},"editor.stickyScroll.maxLineCount":{type:"number",default:X.maxLineCount,minimum:1,maximum:20,description:l.localize(357,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:X.defaultModel,description:l.localize(358,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:X.scrollWithEditor,description:l.localize(359,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const Te=X;return{enabled:i(Te.enabled,this.defaultValue.enabled),maxLineCount:n.clampedInt(Te.maxLineCount,this.defaultValue.maxLineCount,1,20),defaultModel:g(Te.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:i(Te.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class se extends S{constructor(){const X={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(Ie.inlayHints,"inlayHints",X,{"editor.inlayHints.enabled":{type:"string",default:X.enabled,description:l.localize(360,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[l.localize(361,null),l.localize(362,null,D.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),l.localize(363,null,D.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),l.localize(364,null)]},"editor.inlayHints.fontSize":{type:"number",default:X.fontSize,markdownDescription:l.localize(365,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:X.fontFamily,markdownDescription:l.localize(366,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:X.padding,description:l.localize(367,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const Te=X;return typeof Te.enabled=="boolean"&&(Te.enabled=Te.enabled?"on":"off"),{enabled:g(Te.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:n.clampedInt(Te.fontSize,this.defaultValue.fontSize,0,100),fontFamily:c.string(Te.fontFamily,this.defaultValue.fontFamily),padding:i(Te.padding,this.defaultValue.padding)}}}class Ee extends S{constructor(){super(Ie.lineDecorationsWidth,"lineDecorationsWidth",10)}validate(X){return typeof X=="string"&&/^\d+(\.\d+)?ch$/.test(X)?-parseFloat(X.substring(0,X.length-2)):n.clampedInt(X,this.defaultValue,0,1e3)}compute(X,Te,qe){return qe<0?n.clampedInt(-qe*X.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):qe}}class ae extends d{constructor(){super(Ie.lineHeight,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,X=>d.clamp(X,0,150),{markdownDescription:l.localize(368,null)})}compute(X,Te,qe){return X.fontInfo.lineHeight}}class be extends S{constructor(){const X={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1,showRegionSectionHeaders:!0,showMarkSectionHeaders:!0,sectionHeaderFontSize:9,sectionHeaderLetterSpacing:1};super(Ie.minimap,"minimap",X,{"editor.minimap.enabled":{type:"boolean",default:X.enabled,description:l.localize(369,null)},"editor.minimap.autohide":{type:"boolean",default:X.autohide,description:l.localize(370,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[l.localize(371,null),l.localize(372,null),l.localize(373,null)],default:X.size,description:l.localize(374,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:X.side,description:l.localize(375,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:X.showSlider,description:l.localize(376,null)},"editor.minimap.scale":{type:"number",default:X.scale,minimum:1,maximum:3,enum:[1,2,3],description:l.localize(377,null)},"editor.minimap.renderCharacters":{type:"boolean",default:X.renderCharacters,description:l.localize(378,null)},"editor.minimap.maxColumn":{type:"number",default:X.maxColumn,description:l.localize(379,null)},"editor.minimap.showRegionSectionHeaders":{type:"boolean",default:X.showRegionSectionHeaders,description:l.localize(380,null)},"editor.minimap.showMarkSectionHeaders":{type:"boolean",default:X.showMarkSectionHeaders,description:l.localize(381,null)},"editor.minimap.sectionHeaderFontSize":{type:"number",default:X.sectionHeaderFontSize,description:l.localize(382,null)},"editor.minimap.sectionHeaderLetterSpacing":{type:"number",default:X.sectionHeaderLetterSpacing,description:l.localize(383,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const Te=X;return{enabled:i(Te.enabled,this.defaultValue.enabled),autohide:i(Te.autohide,this.defaultValue.autohide),size:g(Te.size,this.defaultValue.size,["proportional","fill","fit"]),side:g(Te.side,this.defaultValue.side,["right","left"]),showSlider:g(Te.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:i(Te.renderCharacters,this.defaultValue.renderCharacters),scale:n.clampedInt(Te.scale,1,1,3),maxColumn:n.clampedInt(Te.maxColumn,this.defaultValue.maxColumn,1,1e4),showRegionSectionHeaders:i(Te.showRegionSectionHeaders,this.defaultValue.showRegionSectionHeaders),showMarkSectionHeaders:i(Te.showMarkSectionHeaders,this.defaultValue.showMarkSectionHeaders),sectionHeaderFontSize:d.clamp(Te.sectionHeaderFontSize??this.defaultValue.sectionHeaderFontSize,4,32),sectionHeaderLetterSpacing:d.clamp(Te.sectionHeaderLetterSpacing??this.defaultValue.sectionHeaderLetterSpacing,0,5)}}}function pe(ne){return ne==="ctrlCmd"?D.isMacintosh?"metaKey":"ctrlKey":"altKey"}class ve extends S{constructor(){super(Ie.padding,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:l.localize(384,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:l.localize(385,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const Te=X;return{top:n.clampedInt(Te.top,0,0,1e3),bottom:n.clampedInt(Te.bottom,0,0,1e3)}}}class Re extends S{constructor(){const X={enabled:!0,cycle:!0};super(Ie.parameterHints,"parameterHints",X,{"editor.parameterHints.enabled":{type:"boolean",default:X.enabled,description:l.localize(386,null)},"editor.parameterHints.cycle":{type:"boolean",default:X.cycle,description:l.localize(387,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const Te=X;return{enabled:i(Te.enabled,this.defaultValue.enabled),cycle:i(Te.cycle,this.defaultValue.cycle)}}}class Fe extends p{constructor(){super(Ie.pixelRatio)}compute(X,Te,qe){return X.pixelRatio}}class Ve extends S{constructor(){super(Ie.placeholder,"placeholder",void 0)}validate(X){return typeof X>"u"?this.defaultValue:typeof X=="string"?X:this.defaultValue}}class Ye extends S{constructor(){const X={other:"on",comments:"off",strings:"off"},Te=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[l.localize(388,null),l.localize(389,null),l.localize(390,null)]}];super(Ie.quickSuggestions,"quickSuggestions",X,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:Te,default:X.strings,description:l.localize(391,null)},comments:{anyOf:Te,default:X.comments,description:l.localize(392,null)},other:{anyOf:Te,default:X.other,description:l.localize(393,null)}},default:X,markdownDescription:l.localize(394,null,"`#editor.suggestOnTriggerCharacters#`")}),this.defaultValue=X}validate(X){if(typeof X=="boolean"){const At=X?"on":"off";return{comments:At,strings:At,other:At}}if(!X||typeof X!="object")return this.defaultValue;const{other:Te,comments:qe,strings:Xe}=X,st=["on","inline","off"];let ht,gt,It;return typeof Te=="boolean"?ht=Te?"on":"off":ht=g(Te,this.defaultValue.other,st),typeof qe=="boolean"?gt=qe?"on":"off":gt=g(qe,this.defaultValue.comments,st),typeof Xe=="boolean"?It=Xe?"on":"off":It=g(Xe,this.defaultValue.strings,st),{other:ht,comments:gt,strings:It}}}var Je;(function(ne){ne[ne.Off=0]="Off",ne[ne.On=1]="On",ne[ne.Relative=2]="Relative",ne[ne.Interval=3]="Interval",ne[ne.Custom=4]="Custom"})(Je||(e.RenderLineNumbersType=Je={}));class xe extends S{constructor(){super(Ie.lineNumbers,"lineNumbers",{renderType:Je.On,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[l.localize(395,null),l.localize(396,null),l.localize(397,null),l.localize(398,null)],default:"on",description:l.localize(399,null)})}validate(X){let Te=this.defaultValue.renderType,qe=this.defaultValue.renderFn;return typeof X<"u"&&(typeof X=="function"?(Te=Je.Custom,qe=X):X==="interval"?Te=Je.Interval:X==="relative"?Te=Je.Relative:X==="on"?Te=Je.On:Te=Je.Off),{renderType:Te,renderFn:qe}}}function ze(ne){const X=ne.get(Ie.renderValidationDecorations);return X==="editable"?ne.get(Ie.readOnly):X!=="on"}class Ne extends S{constructor(){const X=[],Te={type:"number",description:l.localize(400,null)};super(Ie.rulers,"rulers",X,{type:"array",items:{anyOf:[Te,{type:["object"],properties:{column:Te,color:{type:"string",description:l.localize(401,null),format:"color-hex"}}}]},default:X,description:l.localize(402,null)})}validate(X){if(Array.isArray(X)){const Te=[];for(const qe of X)if(typeof qe=="number")Te.push({column:n.clampedInt(qe,0,0,1e4),color:null});else if(qe&&typeof qe=="object"){const Xe=qe;Te.push({column:n.clampedInt(Xe.column,0,0,1e4),color:Xe.color})}return Te.sort((qe,Xe)=>qe.column-Xe.column),Te}return this.defaultValue}}class V extends S{constructor(){super(Ie.readOnlyMessage,"readOnlyMessage",void 0)}validate(X){return!X||typeof X!="object"?this.defaultValue:X}}function j(ne,X){if(typeof ne!="string")return X;switch(ne){case"hidden":return A.ScrollbarVisibility.Hidden;case"visible":return A.ScrollbarVisibility.Visible;default:return A.ScrollbarVisibility.Auto}}class Y extends S{constructor(){const X={vertical:A.ScrollbarVisibility.Auto,horizontal:A.ScrollbarVisibility.Auto,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1,ignoreHorizontalScrollbarInContentHeight:!1};super(Ie.scrollbar,"scrollbar",X,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[l.localize(403,null),l.localize(404,null),l.localize(405,null)],default:"auto",description:l.localize(406,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[l.localize(407,null),l.localize(408,null),l.localize(409,null)],default:"auto",description:l.localize(410,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:X.verticalScrollbarSize,description:l.localize(411,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:X.horizontalScrollbarSize,description:l.localize(412,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:X.scrollByPage,description:l.localize(413,null)},"editor.scrollbar.ignoreHorizontalScrollbarInContentHeight":{type:"boolean",default:X.ignoreHorizontalScrollbarInContentHeight,description:l.localize(414,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const Te=X,qe=n.clampedInt(Te.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Xe=n.clampedInt(Te.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:n.clampedInt(Te.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:j(Te.vertical,this.defaultValue.vertical),horizontal:j(Te.horizontal,this.defaultValue.horizontal),useShadows:i(Te.useShadows,this.defaultValue.useShadows),verticalHasArrows:i(Te.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:i(Te.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:i(Te.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:i(Te.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:qe,horizontalSliderSize:n.clampedInt(Te.horizontalSliderSize,qe,0,1e3),verticalScrollbarSize:Xe,verticalSliderSize:n.clampedInt(Te.verticalSliderSize,Xe,0,1e3),scrollByPage:i(Te.scrollByPage,this.defaultValue.scrollByPage),ignoreHorizontalScrollbarInContentHeight:i(Te.ignoreHorizontalScrollbarInContentHeight,this.defaultValue.ignoreHorizontalScrollbarInContentHeight)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class ee extends S{constructor(){const X={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(Ie.unicodeHighlighting,"unicodeHighlight",X,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:X.nonBasicASCII,description:l.localize(415,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:X.invisibleCharacters,description:l.localize(416,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:X.ambiguousCharacters,description:l.localize(417,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:X.includeComments,description:l.localize(418,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:X.includeStrings,description:l.localize(419,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:X.allowedCharacters,description:l.localize(420,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:X.allowedLocales,description:l.localize(421,null)}})}applyUpdate(X,Te){let qe=!1;Te.allowedCharacters&&X&&(h.equals(X.allowedCharacters,Te.allowedCharacters)||(X={...X,allowedCharacters:Te.allowedCharacters},qe=!0)),Te.allowedLocales&&X&&(h.equals(X.allowedLocales,Te.allowedLocales)||(X={...X,allowedLocales:Te.allowedLocales},qe=!0));const Xe=super.applyUpdate(X,Te);return qe?new o(Xe.newValue,!0):Xe}validate(X){if(!X||typeof X!="object")return this.defaultValue;const Te=X;return{nonBasicASCII:Ge(Te.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:i(Te.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:i(Te.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:Ge(Te.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:Ge(Te.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.validateBooleanMap(X.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.validateBooleanMap(X.allowedLocales,this.defaultValue.allowedLocales)}}validateBooleanMap(X,Te){if(typeof X!="object"||!X)return Te;const qe={};for(const[Xe,st]of Object.entries(X))st===!0&&(qe[Xe]=!0);return qe}}class ue extends S{constructor(){const X={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1,fontFamily:"default"};super(Ie.inlineSuggest,"inlineSuggest",X,{"editor.inlineSuggest.enabled":{type:"boolean",default:X.enabled,description:l.localize(422,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:X.showToolbar,enum:["always","onHover","never"],enumDescriptions:[l.localize(423,null),l.localize(424,null),l.localize(425,null)],description:l.localize(426,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:X.suppressSuggestions,description:l.localize(427,null)},"editor.inlineSuggest.fontFamily":{type:"string",default:X.fontFamily,description:l.localize(428,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const Te=X;return{enabled:i(Te.enabled,this.defaultValue.enabled),mode:g(Te.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:g(Te.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),suppressSuggestions:i(Te.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:i(Te.keepOnBlur,this.defaultValue.keepOnBlur),fontFamily:c.string(Te.fontFamily,this.defaultValue.fontFamily)}}}class we extends S{constructor(){const X={enabled:!1,showToolbar:"onHover",fontFamily:"default",keepOnBlur:!1};super(Ie.inlineEdit,"experimentalInlineEdit",X,{"editor.experimentalInlineEdit.enabled":{type:"boolean",default:X.enabled,description:l.localize(429,null)},"editor.experimentalInlineEdit.showToolbar":{type:"string",default:X.showToolbar,enum:["always","onHover","never"],enumDescriptions:[l.localize(430,null),l.localize(431,null),l.localize(432,null)],description:l.localize(433,null)},"editor.experimentalInlineEdit.fontFamily":{type:"string",default:X.fontFamily,description:l.localize(434,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const Te=X;return{enabled:i(Te.enabled,this.defaultValue.enabled),showToolbar:g(Te.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),fontFamily:c.string(Te.fontFamily,this.defaultValue.fontFamily),keepOnBlur:i(Te.keepOnBlur,this.defaultValue.keepOnBlur)}}}class Ae extends S{constructor(){const X={enabled:R.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:R.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(Ie.bracketPairColorization,"bracketPairColorization",X,{"editor.bracketPairColorization.enabled":{type:"boolean",default:X.enabled,markdownDescription:l.localize(435,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:X.independentColorPoolPerBracketType,description:l.localize(436,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const Te=X;return{enabled:i(Te.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:i(Te.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class He extends S{constructor(){const X={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(Ie.guides,"guides",X,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[l.localize(437,null),l.localize(438,null),l.localize(439,null)],default:X.bracketPairs,description:l.localize(440,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[l.localize(441,null),l.localize(442,null),l.localize(443,null)],default:X.bracketPairsHorizontal,description:l.localize(444,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:X.highlightActiveBracketPair,description:l.localize(445,null)},"editor.guides.indentation":{type:"boolean",default:X.indentation,description:l.localize(446,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[l.localize(447,null),l.localize(448,null),l.localize(449,null)],default:X.highlightActiveIndentation,description:l.localize(450,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const Te=X;return{bracketPairs:Ge(Te.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:Ge(Te.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:i(Te.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:i(Te.indentation,this.defaultValue.indentation),highlightActiveIndentation:Ge(Te.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function Ge(ne,X,Te){const qe=Te.indexOf(ne);return qe===-1?X:Te[qe]}class nt extends S{constructor(){const X={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(Ie.suggest,"suggest",X,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[l.localize(451,null),l.localize(452,null)],default:X.insertMode,description:l.localize(453,null)},"editor.suggest.filterGraceful":{type:"boolean",default:X.filterGraceful,description:l.localize(454,null)},"editor.suggest.localityBonus":{type:"boolean",default:X.localityBonus,description:l.localize(455,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:X.shareSuggestSelections,markdownDescription:l.localize(456,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[l.localize(457,null),l.localize(458,null),l.localize(459,null),l.localize(460,null)],default:X.selectionMode,markdownDescription:l.localize(461,null,"`#editor.quickSuggestions#`","`#editor.suggestOnTriggerCharacters#`")},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:X.snippetsPreventQuickSuggestions,description:l.localize(462,null)},"editor.suggest.showIcons":{type:"boolean",default:X.showIcons,description:l.localize(463,null)},"editor.suggest.showStatusBar":{type:"boolean",default:X.showStatusBar,description:l.localize(464,null)},"editor.suggest.preview":{type:"boolean",default:X.preview,description:l.localize(465,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:X.showInlineDetails,description:l.localize(466,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:l.localize(467,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:l.localize(468,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:l.localize(469,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:l.localize(470,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:l.localize(471,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:l.localize(472,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:l.localize(473,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:l.localize(474,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:l.localize(475,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:l.localize(476,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:l.localize(477,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:l.localize(478,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:l.localize(479,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:l.localize(480,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:l.localize(481,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:l.localize(482,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:l.localize(483,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:l.localize(484,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:l.localize(485,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:l.localize(486,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:l.localize(487,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:l.localize(488,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:l.localize(489,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:l.localize(490,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:l.localize(491,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:l.localize(492,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:l.localize(493,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:l.localize(494,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:l.localize(495,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:l.localize(496,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:l.localize(497,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:l.localize(498,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const Te=X;return{insertMode:g(Te.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:i(Te.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:i(Te.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:i(Te.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:i(Te.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:g(Te.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:i(Te.showIcons,this.defaultValue.showIcons),showStatusBar:i(Te.showStatusBar,this.defaultValue.showStatusBar),preview:i(Te.preview,this.defaultValue.preview),previewMode:g(Te.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:i(Te.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:i(Te.showMethods,this.defaultValue.showMethods),showFunctions:i(Te.showFunctions,this.defaultValue.showFunctions),showConstructors:i(Te.showConstructors,this.defaultValue.showConstructors),showDeprecated:i(Te.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:i(Te.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:i(Te.showFields,this.defaultValue.showFields),showVariables:i(Te.showVariables,this.defaultValue.showVariables),showClasses:i(Te.showClasses,this.defaultValue.showClasses),showStructs:i(Te.showStructs,this.defaultValue.showStructs),showInterfaces:i(Te.showInterfaces,this.defaultValue.showInterfaces),showModules:i(Te.showModules,this.defaultValue.showModules),showProperties:i(Te.showProperties,this.defaultValue.showProperties),showEvents:i(Te.showEvents,this.defaultValue.showEvents),showOperators:i(Te.showOperators,this.defaultValue.showOperators),showUnits:i(Te.showUnits,this.defaultValue.showUnits),showValues:i(Te.showValues,this.defaultValue.showValues),showConstants:i(Te.showConstants,this.defaultValue.showConstants),showEnums:i(Te.showEnums,this.defaultValue.showEnums),showEnumMembers:i(Te.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:i(Te.showKeywords,this.defaultValue.showKeywords),showWords:i(Te.showWords,this.defaultValue.showWords),showColors:i(Te.showColors,this.defaultValue.showColors),showFiles:i(Te.showFiles,this.defaultValue.showFiles),showReferences:i(Te.showReferences,this.defaultValue.showReferences),showFolders:i(Te.showFolders,this.defaultValue.showFolders),showTypeParameters:i(Te.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:i(Te.showSnippets,this.defaultValue.showSnippets),showUsers:i(Te.showUsers,this.defaultValue.showUsers),showIssues:i(Te.showIssues,this.defaultValue.showIssues)}}}class ot extends S{constructor(){super(Ie.smartSelect,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:l.localize(499,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:l.localize(500,null),default:!0,type:"boolean"}})}validate(X){return!X||typeof X!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:i(X.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:i(X.selectSubwords,this.defaultValue.selectSubwords)}}}class dt extends S{constructor(){const X=[];super(Ie.wordSegmenterLocales,"wordSegmenterLocales",X,{anyOf:[{description:l.localize(501,null),type:"string"},{description:l.localize(502,null),type:"array",items:{type:"string"}}]})}validate(X){if(typeof X=="string"&&(X=[X]),Array.isArray(X)){const Te=[];for(const qe of X)if(typeof qe=="string")try{Intl.Segmenter.supportedLocalesOf(qe).length>0&&Te.push(qe)}catch{}return Te}return this.defaultValue}}var at;(function(ne){ne[ne.None=0]="None",ne[ne.Same=1]="Same",ne[ne.Indent=2]="Indent",ne[ne.DeepIndent=3]="DeepIndent"})(at||(e.WrappingIndent=at={}));class ct extends S{constructor(){super(Ie.wrappingIndent,"wrappingIndent",at.Same,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[l.localize(503,null),l.localize(504,null),l.localize(505,null),l.localize(506,null)],description:l.localize(507,null),default:"same"}})}validate(X){switch(X){case"none":return at.None;case"same":return at.Same;case"indent":return at.Indent;case"deepIndent":return at.DeepIndent}return at.Same}compute(X,Te,qe){return Te.get(Ie.accessibilitySupport)===C.AccessibilitySupport.Enabled?at.None:qe}}class vt extends p{constructor(){super(Ie.wrappingInfo)}compute(X,Te,qe){const Xe=Te.get(Ie.layoutInfo);return{isDominatedByLongLines:X.isDominatedByLongLines,isWordWrapMinified:Xe.isWordWrapMinified,isViewportWrapping:Xe.isViewportWrapping,wrappingColumn:Xe.wrappingColumn}}}class it extends S{constructor(){const X={enabled:!0,showDropSelector:"afterDrop"};super(Ie.dropIntoEditor,"dropIntoEditor",X,{"editor.dropIntoEditor.enabled":{type:"boolean",default:X.enabled,markdownDescription:l.localize(508,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:l.localize(509,null),enum:["afterDrop","never"],enumDescriptions:[l.localize(510,null),l.localize(511,null)],default:"afterDrop"}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const Te=X;return{enabled:i(Te.enabled,this.defaultValue.enabled),showDropSelector:g(Te.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class Ce extends S{constructor(){const X={enabled:!0,showPasteSelector:"afterPaste"};super(Ie.pasteAs,"pasteAs",X,{"editor.pasteAs.enabled":{type:"boolean",default:X.enabled,markdownDescription:l.localize(512,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:l.localize(513,null),enum:["afterPaste","never"],enumDescriptions:[l.localize(514,null),l.localize(515,null)],default:"afterPaste"}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const Te=X;return{enabled:i(Te.enabled,this.defaultValue.enabled),showPasteSelector:g(Te.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const re="Consolas, 'Courier New', monospace",ce="Menlo, Monaco, 'Courier New', monospace",ye="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:D.isMacintosh?ce:D.isLinux?ye:re,fontWeight:"normal",fontSize:D.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function he(ne){return e.editorOptionsRegistry[ne.id]=ne,ne}var Ie;(function(ne){ne[ne.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",ne[ne.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",ne[ne.accessibilitySupport=2]="accessibilitySupport",ne[ne.accessibilityPageSize=3]="accessibilityPageSize",ne[ne.ariaLabel=4]="ariaLabel",ne[ne.ariaRequired=5]="ariaRequired",ne[ne.autoClosingBrackets=6]="autoClosingBrackets",ne[ne.autoClosingComments=7]="autoClosingComments",ne[ne.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",ne[ne.autoClosingDelete=9]="autoClosingDelete",ne[ne.autoClosingOvertype=10]="autoClosingOvertype",ne[ne.autoClosingQuotes=11]="autoClosingQuotes",ne[ne.autoIndent=12]="autoIndent",ne[ne.automaticLayout=13]="automaticLayout",ne[ne.autoSurround=14]="autoSurround",ne[ne.bracketPairColorization=15]="bracketPairColorization",ne[ne.guides=16]="guides",ne[ne.codeLens=17]="codeLens",ne[ne.codeLensFontFamily=18]="codeLensFontFamily",ne[ne.codeLensFontSize=19]="codeLensFontSize",ne[ne.colorDecorators=20]="colorDecorators",ne[ne.colorDecoratorsLimit=21]="colorDecoratorsLimit",ne[ne.columnSelection=22]="columnSelection",ne[ne.comments=23]="comments",ne[ne.contextmenu=24]="contextmenu",ne[ne.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",ne[ne.cursorBlinking=26]="cursorBlinking",ne[ne.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",ne[ne.cursorStyle=28]="cursorStyle",ne[ne.cursorSurroundingLines=29]="cursorSurroundingLines",ne[ne.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",ne[ne.cursorWidth=31]="cursorWidth",ne[ne.disableLayerHinting=32]="disableLayerHinting",ne[ne.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",ne[ne.domReadOnly=34]="domReadOnly",ne[ne.dragAndDrop=35]="dragAndDrop",ne[ne.dropIntoEditor=36]="dropIntoEditor",ne[ne.emptySelectionClipboard=37]="emptySelectionClipboard",ne[ne.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",ne[ne.extraEditorClassName=39]="extraEditorClassName",ne[ne.fastScrollSensitivity=40]="fastScrollSensitivity",ne[ne.find=41]="find",ne[ne.fixedOverflowWidgets=42]="fixedOverflowWidgets",ne[ne.folding=43]="folding",ne[ne.foldingStrategy=44]="foldingStrategy",ne[ne.foldingHighlight=45]="foldingHighlight",ne[ne.foldingImportsByDefault=46]="foldingImportsByDefault",ne[ne.foldingMaximumRegions=47]="foldingMaximumRegions",ne[ne.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",ne[ne.fontFamily=49]="fontFamily",ne[ne.fontInfo=50]="fontInfo",ne[ne.fontLigatures=51]="fontLigatures",ne[ne.fontSize=52]="fontSize",ne[ne.fontWeight=53]="fontWeight",ne[ne.fontVariations=54]="fontVariations",ne[ne.formatOnPaste=55]="formatOnPaste",ne[ne.formatOnType=56]="formatOnType",ne[ne.glyphMargin=57]="glyphMargin",ne[ne.gotoLocation=58]="gotoLocation",ne[ne.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",ne[ne.hover=60]="hover",ne[ne.inDiffEditor=61]="inDiffEditor",ne[ne.inlineSuggest=62]="inlineSuggest",ne[ne.inlineEdit=63]="inlineEdit",ne[ne.letterSpacing=64]="letterSpacing",ne[ne.lightbulb=65]="lightbulb",ne[ne.lineDecorationsWidth=66]="lineDecorationsWidth",ne[ne.lineHeight=67]="lineHeight",ne[ne.lineNumbers=68]="lineNumbers",ne[ne.lineNumbersMinChars=69]="lineNumbersMinChars",ne[ne.linkedEditing=70]="linkedEditing",ne[ne.links=71]="links",ne[ne.matchBrackets=72]="matchBrackets",ne[ne.minimap=73]="minimap",ne[ne.mouseStyle=74]="mouseStyle",ne[ne.mouseWheelScrollSensitivity=75]="mouseWheelScrollSensitivity",ne[ne.mouseWheelZoom=76]="mouseWheelZoom",ne[ne.multiCursorMergeOverlapping=77]="multiCursorMergeOverlapping",ne[ne.multiCursorModifier=78]="multiCursorModifier",ne[ne.multiCursorPaste=79]="multiCursorPaste",ne[ne.multiCursorLimit=80]="multiCursorLimit",ne[ne.occurrencesHighlight=81]="occurrencesHighlight",ne[ne.overviewRulerBorder=82]="overviewRulerBorder",ne[ne.overviewRulerLanes=83]="overviewRulerLanes",ne[ne.padding=84]="padding",ne[ne.pasteAs=85]="pasteAs",ne[ne.parameterHints=86]="parameterHints",ne[ne.peekWidgetDefaultFocus=87]="peekWidgetDefaultFocus",ne[ne.placeholder=88]="placeholder",ne[ne.definitionLinkOpensInPeek=89]="definitionLinkOpensInPeek",ne[ne.quickSuggestions=90]="quickSuggestions",ne[ne.quickSuggestionsDelay=91]="quickSuggestionsDelay",ne[ne.readOnly=92]="readOnly",ne[ne.readOnlyMessage=93]="readOnlyMessage",ne[ne.renameOnType=94]="renameOnType",ne[ne.renderControlCharacters=95]="renderControlCharacters",ne[ne.renderFinalNewline=96]="renderFinalNewline",ne[ne.renderLineHighlight=97]="renderLineHighlight",ne[ne.renderLineHighlightOnlyWhenFocus=98]="renderLineHighlightOnlyWhenFocus",ne[ne.renderValidationDecorations=99]="renderValidationDecorations",ne[ne.renderWhitespace=100]="renderWhitespace",ne[ne.revealHorizontalRightPadding=101]="revealHorizontalRightPadding",ne[ne.roundedSelection=102]="roundedSelection",ne[ne.rulers=103]="rulers",ne[ne.scrollbar=104]="scrollbar",ne[ne.scrollBeyondLastColumn=105]="scrollBeyondLastColumn",ne[ne.scrollBeyondLastLine=106]="scrollBeyondLastLine",ne[ne.scrollPredominantAxis=107]="scrollPredominantAxis",ne[ne.selectionClipboard=108]="selectionClipboard",ne[ne.selectionHighlight=109]="selectionHighlight",ne[ne.selectOnLineNumbers=110]="selectOnLineNumbers",ne[ne.showFoldingControls=111]="showFoldingControls",ne[ne.showUnused=112]="showUnused",ne[ne.snippetSuggestions=113]="snippetSuggestions",ne[ne.smartSelect=114]="smartSelect",ne[ne.smoothScrolling=115]="smoothScrolling",ne[ne.stickyScroll=116]="stickyScroll",ne[ne.stickyTabStops=117]="stickyTabStops",ne[ne.stopRenderingLineAfter=118]="stopRenderingLineAfter",ne[ne.suggest=119]="suggest",ne[ne.suggestFontSize=120]="suggestFontSize",ne[ne.suggestLineHeight=121]="suggestLineHeight",ne[ne.suggestOnTriggerCharacters=122]="suggestOnTriggerCharacters",ne[ne.suggestSelection=123]="suggestSelection",ne[ne.tabCompletion=124]="tabCompletion",ne[ne.tabIndex=125]="tabIndex",ne[ne.unicodeHighlighting=126]="unicodeHighlighting",ne[ne.unusualLineTerminators=127]="unusualLineTerminators",ne[ne.useShadowDOM=128]="useShadowDOM",ne[ne.useTabStops=129]="useTabStops",ne[ne.wordBreak=130]="wordBreak",ne[ne.wordSegmenterLocales=131]="wordSegmenterLocales",ne[ne.wordSeparators=132]="wordSeparators",ne[ne.wordWrap=133]="wordWrap",ne[ne.wordWrapBreakAfterCharacters=134]="wordWrapBreakAfterCharacters",ne[ne.wordWrapBreakBeforeCharacters=135]="wordWrapBreakBeforeCharacters",ne[ne.wordWrapColumn=136]="wordWrapColumn",ne[ne.wordWrapOverride1=137]="wordWrapOverride1",ne[ne.wordWrapOverride2=138]="wordWrapOverride2",ne[ne.wrappingIndent=139]="wrappingIndent",ne[ne.wrappingStrategy=140]="wrappingStrategy",ne[ne.showDeprecated=141]="showDeprecated",ne[ne.inlayHints=142]="inlayHints",ne[ne.editorClassName=143]="editorClassName",ne[ne.pixelRatio=144]="pixelRatio",ne[ne.tabFocusMode=145]="tabFocusMode",ne[ne.layoutInfo=146]="layoutInfo",ne[ne.wrappingInfo=147]="wrappingInfo",ne[ne.defaultColorDecorators=148]="defaultColorDecorators",ne[ne.colorDecoratorsActivatedOn=149]="colorDecoratorsActivatedOn",ne[ne.inlineCompletionsAccessibilityVerbose=150]="inlineCompletionsAccessibilityVerbose"})(Ie||(e.EditorOption=Ie={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:he(new a(Ie.acceptSuggestionOnCommitCharacter,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:l.localize(516,null)})),acceptSuggestionOnEnter:he(new w(Ie.acceptSuggestionOnEnter,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",l.localize(517,null),""],markdownDescription:l.localize(518,null)})),accessibilitySupport:he(new P),accessibilityPageSize:he(new n(Ie.accessibilityPageSize,"accessibilityPageSize",10,1,L.Constants.MAX_SAFE_SMALL_INTEGER,{description:l.localize(519,null),tags:["accessibility"]})),ariaLabel:he(new c(Ie.ariaLabel,"ariaLabel",l.localize(520,null))),ariaRequired:he(new a(Ie.ariaRequired,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:he(new a(Ie.screenReaderAnnounceInlineSuggestion,"screenReaderAnnounceInlineSuggestion",!0,{description:l.localize(521,null),tags:["accessibility"]})),autoClosingBrackets:he(new w(Ie.autoClosingBrackets,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",l.localize(522,null),l.localize(523,null),""],description:l.localize(524,null)})),autoClosingComments:he(new w(Ie.autoClosingComments,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",l.localize(525,null),l.localize(526,null),""],description:l.localize(527,null)})),autoClosingDelete:he(new w(Ie.autoClosingDelete,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",l.localize(528,null),""],description:l.localize(529,null)})),autoClosingOvertype:he(new w(Ie.autoClosingOvertype,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",l.localize(530,null),""],description:l.localize(531,null)})),autoClosingQuotes:he(new w(Ie.autoClosingQuotes,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",l.localize(532,null),l.localize(533,null),""],description:l.localize(534,null)})),autoIndent:he(new y(Ie.autoIndent,"autoIndent",_.Full,"full",["none","keep","brackets","advanced","full"],I,{enumDescriptions:[l.localize(535,null),l.localize(536,null),l.localize(537,null),l.localize(538,null),l.localize(539,null)],description:l.localize(540,null)})),automaticLayout:he(new a(Ie.automaticLayout,"automaticLayout",!1)),autoSurround:he(new w(Ie.autoSurround,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[l.localize(541,null),l.localize(542,null),l.localize(543,null),""],description:l.localize(544,null)})),bracketPairColorization:he(new Ae),bracketPairGuides:he(new He),stickyTabStops:he(new a(Ie.stickyTabStops,"stickyTabStops",!1,{description:l.localize(545,null)})),codeLens:he(new a(Ie.codeLens,"codeLens",!0,{description:l.localize(546,null)})),codeLensFontFamily:he(new c(Ie.codeLensFontFamily,"codeLensFontFamily","",{description:l.localize(547,null)})),codeLensFontSize:he(new n(Ie.codeLensFontSize,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:l.localize(548,null)})),colorDecorators:he(new a(Ie.colorDecorators,"colorDecorators",!0,{description:l.localize(549,null)})),colorDecoratorActivatedOn:he(new w(Ie.colorDecoratorsActivatedOn,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[l.localize(550,null),l.localize(551,null),l.localize(552,null)],description:l.localize(553,null)})),colorDecoratorsLimit:he(new n(Ie.colorDecoratorsLimit,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:l.localize(554,null)})),columnSelection:he(new a(Ie.columnSelection,"columnSelection",!1,{description:l.localize(555,null)})),comments:he(new k),contextmenu:he(new a(Ie.contextmenu,"contextmenu",!0)),copyWithSyntaxHighlighting:he(new a(Ie.copyWithSyntaxHighlighting,"copyWithSyntaxHighlighting",!0,{description:l.localize(556,null)})),cursorBlinking:he(new y(Ie.cursorBlinking,"cursorBlinking",b.Blink,"blink",["blink","smooth","phase","expand","solid"],E,{description:l.localize(557,null)})),cursorSmoothCaretAnimation:he(new w(Ie.cursorSmoothCaretAnimation,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[l.localize(558,null),l.localize(559,null),l.localize(560,null)],description:l.localize(561,null)})),cursorStyle:he(new y(Ie.cursorStyle,"cursorStyle",N.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],M,{description:l.localize(562,null)})),cursorSurroundingLines:he(new n(Ie.cursorSurroundingLines,"cursorSurroundingLines",0,0,L.Constants.MAX_SAFE_SMALL_INTEGER,{description:l.localize(563,null)})),cursorSurroundingLinesStyle:he(new w(Ie.cursorSurroundingLinesStyle,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[l.localize(564,null),l.localize(565,null)],markdownDescription:l.localize(566,null)})),cursorWidth:he(new n(Ie.cursorWidth,"cursorWidth",0,0,L.Constants.MAX_SAFE_SMALL_INTEGER,{markdownDescription:l.localize(567,null)})),disableLayerHinting:he(new a(Ie.disableLayerHinting,"disableLayerHinting",!1)),disableMonospaceOptimizations:he(new a(Ie.disableMonospaceOptimizations,"disableMonospaceOptimizations",!1)),domReadOnly:he(new a(Ie.domReadOnly,"domReadOnly",!1)),dragAndDrop:he(new a(Ie.dragAndDrop,"dragAndDrop",!0,{description:l.localize(568,null)})),emptySelectionClipboard:he(new H),dropIntoEditor:he(new it),stickyScroll:he(new z),experimentalWhitespaceRendering:he(new w(Ie.experimentalWhitespaceRendering,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[l.localize(569,null),l.localize(570,null),l.localize(571,null)],description:l.localize(572,null)})),extraEditorClassName:he(new c(Ie.extraEditorClassName,"extraEditorClassName","")),fastScrollSensitivity:he(new d(Ie.fastScrollSensitivity,"fastScrollSensitivity",5,ne=>ne<=0?5:ne,{markdownDescription:l.localize(573,null)})),find:he(new F),fixedOverflowWidgets:he(new a(Ie.fixedOverflowWidgets,"fixedOverflowWidgets",!1)),folding:he(new a(Ie.folding,"folding",!0,{description:l.localize(574,null)})),foldingStrategy:he(new w(Ie.foldingStrategy,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[l.localize(575,null),l.localize(576,null)],description:l.localize(577,null)})),foldingHighlight:he(new a(Ie.foldingHighlight,"foldingHighlight",!0,{description:l.localize(578,null)})),foldingImportsByDefault:he(new a(Ie.foldingImportsByDefault,"foldingImportsByDefault",!1,{description:l.localize(579,null)})),foldingMaximumRegions:he(new n(Ie.foldingMaximumRegions,"foldingMaximumRegions",5e3,10,65e3,{description:l.localize(580,null)})),unfoldOnClickAfterEndOfLine:he(new a(Ie.unfoldOnClickAfterEndOfLine,"unfoldOnClickAfterEndOfLine",!1,{description:l.localize(581,null)})),fontFamily:he(new c(Ie.fontFamily,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:l.localize(582,null)})),fontInfo:he(new G),fontLigatures2:he(new x),fontSize:he(new B),fontWeight:he(new W),fontVariations:he(new $),formatOnPaste:he(new a(Ie.formatOnPaste,"formatOnPaste",!1,{description:l.localize(583,null)})),formatOnType:he(new a(Ie.formatOnType,"formatOnType",!1,{description:l.localize(584,null)})),glyphMargin:he(new a(Ie.glyphMargin,"glyphMargin",!0,{description:l.localize(585,null)})),gotoLocation:he(new Z),hideCursorInOverviewRuler:he(new a(Ie.hideCursorInOverviewRuler,"hideCursorInOverviewRuler",!1,{description:l.localize(586,null)})),hover:he(new J),inDiffEditor:he(new a(Ie.inDiffEditor,"inDiffEditor",!1)),letterSpacing:he(new d(Ie.letterSpacing,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,ne=>d.clamp(ne,-5,20),{description:l.localize(587,null)})),lightbulb:he(new Q),lineDecorationsWidth:he(new Ee),lineHeight:he(new ae),lineNumbers:he(new xe),lineNumbersMinChars:he(new n(Ie.lineNumbersMinChars,"lineNumbersMinChars",5,1,300)),linkedEditing:he(new a(Ie.linkedEditing,"linkedEditing",!1,{description:l.localize(588,null)})),links:he(new a(Ie.links,"links",!0,{description:l.localize(589,null)})),matchBrackets:he(new w(Ie.matchBrackets,"matchBrackets","always",["always","near","never"],{description:l.localize(590,null)})),minimap:he(new be),mouseStyle:he(new w(Ie.mouseStyle,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:he(new d(Ie.mouseWheelScrollSensitivity,"mouseWheelScrollSensitivity",1,ne=>ne===0?1:ne,{markdownDescription:l.localize(591,null)})),mouseWheelZoom:he(new a(Ie.mouseWheelZoom,"mouseWheelZoom",!1,{markdownDescription:D.isMacintosh?l.localize(592,null):l.localize(593,null)})),multiCursorMergeOverlapping:he(new a(Ie.multiCursorMergeOverlapping,"multiCursorMergeOverlapping",!0,{description:l.localize(594,null)})),multiCursorModifier:he(new y(Ie.multiCursorModifier,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],pe,{markdownEnumDescriptions:[l.localize(595,null),l.localize(596,null)],markdownDescription:l.localize(597,null)})),multiCursorPaste:he(new w(Ie.multiCursorPaste,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[l.localize(598,null),l.localize(599,null)],markdownDescription:l.localize(600,null)})),multiCursorLimit:he(new n(Ie.multiCursorLimit,"multiCursorLimit",1e4,1,1e5,{markdownDescription:l.localize(601,null)})),occurrencesHighlight:he(new w(Ie.occurrencesHighlight,"occurrencesHighlight","singleFile",["off","singleFile","multiFile"],{markdownEnumDescriptions:[l.localize(602,null),l.localize(603,null),l.localize(604,null)],markdownDescription:l.localize(605,null)})),overviewRulerBorder:he(new a(Ie.overviewRulerBorder,"overviewRulerBorder",!0,{description:l.localize(606,null)})),overviewRulerLanes:he(new n(Ie.overviewRulerLanes,"overviewRulerLanes",3,0,3)),padding:he(new ve),pasteAs:he(new Ce),parameterHints:he(new Re),peekWidgetDefaultFocus:he(new w(Ie.peekWidgetDefaultFocus,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[l.localize(607,null),l.localize(608,null)],description:l.localize(609,null)})),placeholder:he(new Ve),definitionLinkOpensInPeek:he(new a(Ie.definitionLinkOpensInPeek,"definitionLinkOpensInPeek",!1,{description:l.localize(610,null)})),quickSuggestions:he(new Ye),quickSuggestionsDelay:he(new n(Ie.quickSuggestionsDelay,"quickSuggestionsDelay",10,0,L.Constants.MAX_SAFE_SMALL_INTEGER,{description:l.localize(611,null)})),readOnly:he(new a(Ie.readOnly,"readOnly",!1)),readOnlyMessage:he(new V),renameOnType:he(new a(Ie.renameOnType,"renameOnType",!1,{description:l.localize(612,null),markdownDeprecationMessage:l.localize(613,null)})),renderControlCharacters:he(new a(Ie.renderControlCharacters,"renderControlCharacters",!0,{description:l.localize(614,null),restricted:!0})),renderFinalNewline:he(new w(Ie.renderFinalNewline,"renderFinalNewline",D.isLinux?"dimmed":"on",["off","on","dimmed"],{description:l.localize(615,null)})),renderLineHighlight:he(new w(Ie.renderLineHighlight,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",l.localize(616,null)],description:l.localize(617,null)})),renderLineHighlightOnlyWhenFocus:he(new a(Ie.renderLineHighlightOnlyWhenFocus,"renderLineHighlightOnlyWhenFocus",!1,{description:l.localize(618,null)})),renderValidationDecorations:he(new w(Ie.renderValidationDecorations,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:he(new w(Ie.renderWhitespace,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",l.localize(619,null),l.localize(620,null),l.localize(621,null),""],description:l.localize(622,null)})),revealHorizontalRightPadding:he(new n(Ie.revealHorizontalRightPadding,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:he(new a(Ie.roundedSelection,"roundedSelection",!0,{description:l.localize(623,null)})),rulers:he(new Ne),scrollbar:he(new Y),scrollBeyondLastColumn:he(new n(Ie.scrollBeyondLastColumn,"scrollBeyondLastColumn",4,0,L.Constants.MAX_SAFE_SMALL_INTEGER,{description:l.localize(624,null)})),scrollBeyondLastLine:he(new a(Ie.scrollBeyondLastLine,"scrollBeyondLastLine",!0,{description:l.localize(625,null)})),scrollPredominantAxis:he(new a(Ie.scrollPredominantAxis,"scrollPredominantAxis",!0,{description:l.localize(626,null)})),selectionClipboard:he(new a(Ie.selectionClipboard,"selectionClipboard",!0,{description:l.localize(627,null),included:D.isLinux})),selectionHighlight:he(new a(Ie.selectionHighlight,"selectionHighlight",!0,{description:l.localize(628,null)})),selectOnLineNumbers:he(new a(Ie.selectOnLineNumbers,"selectOnLineNumbers",!0)),showFoldingControls:he(new w(Ie.showFoldingControls,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[l.localize(629,null),l.localize(630,null),l.localize(631,null)],description:l.localize(632,null)})),showUnused:he(new a(Ie.showUnused,"showUnused",!0,{description:l.localize(633,null)})),showDeprecated:he(new a(Ie.showDeprecated,"showDeprecated",!0,{description:l.localize(634,null)})),inlayHints:he(new se),snippetSuggestions:he(new w(Ie.snippetSuggestions,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[l.localize(635,null),l.localize(636,null),l.localize(637,null),l.localize(638,null)],description:l.localize(639,null)})),smartSelect:he(new ot),smoothScrolling:he(new a(Ie.smoothScrolling,"smoothScrolling",!1,{description:l.localize(640,null)})),stopRenderingLineAfter:he(new n(Ie.stopRenderingLineAfter,"stopRenderingLineAfter",1e4,-1,L.Constants.MAX_SAFE_SMALL_INTEGER)),suggest:he(new nt),inlineSuggest:he(new ue),inlineEdit:he(new we),inlineCompletionsAccessibilityVerbose:he(new a(Ie.inlineCompletionsAccessibilityVerbose,"inlineCompletionsAccessibilityVerbose",!1,{description:l.localize(641,null)})),suggestFontSize:he(new n(Ie.suggestFontSize,"suggestFontSize",0,0,1e3,{markdownDescription:l.localize(642,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:he(new n(Ie.suggestLineHeight,"suggestLineHeight",0,0,1e3,{markdownDescription:l.localize(643,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:he(new a(Ie.suggestOnTriggerCharacters,"suggestOnTriggerCharacters",!0,{description:l.localize(644,null)})),suggestSelection:he(new w(Ie.suggestSelection,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[l.localize(645,null),l.localize(646,null),l.localize(647,null)],description:l.localize(648,null)})),tabCompletion:he(new w(Ie.tabCompletion,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[l.localize(649,null),l.localize(650,null),l.localize(651,null)],description:l.localize(652,null)})),tabIndex:he(new n(Ie.tabIndex,"tabIndex",0,-1,L.Constants.MAX_SAFE_SMALL_INTEGER)),unicodeHighlight:he(new ee),unusualLineTerminators:he(new w(Ie.unusualLineTerminators,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[l.localize(653,null),l.localize(654,null),l.localize(655,null)],description:l.localize(656,null)})),useShadowDOM:he(new a(Ie.useShadowDOM,"useShadowDOM",!0)),useTabStops:he(new a(Ie.useTabStops,"useTabStops",!0,{description:l.localize(657,null)})),wordBreak:he(new w(Ie.wordBreak,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[l.localize(658,null),l.localize(659,null)],description:l.localize(660,null)})),wordSegmenterLocales:he(new dt),wordSeparators:he(new c(Ie.wordSeparators,"wordSeparators",v.USUAL_WORD_SEPARATORS,{description:l.localize(661,null)})),wordWrap:he(new w(Ie.wordWrap,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[l.localize(662,null),l.localize(663,null),l.localize(664,null),l.localize(665,null)],description:l.localize(666,null)})),wordWrapBreakAfterCharacters:he(new c(Ie.wordWrapBreakAfterCharacters,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:he(new c(Ie.wordWrapBreakBeforeCharacters,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:he(new n(Ie.wordWrapColumn,"wordWrapColumn",80,1,L.Constants.MAX_SAFE_SMALL_INTEGER,{markdownDescription:l.localize(667,null)})),wordWrapOverride1:he(new w(Ie.wordWrapOverride1,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:he(new w(Ie.wordWrapOverride2,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:he(new U),defaultColorDecorators:he(new a(Ie.defaultColorDecorators,"defaultColorDecorators",!1,{markdownDescription:l.localize(668,null)})),pixelRatio:he(new Fe),tabFocusMode:he(new a(Ie.tabFocusMode,"tabFocusMode",!1,{markdownDescription:l.localize(669,null)})),layoutInfo:he(new te),wrappingInfo:he(new vt),wrappingIndent:he(new ct),wrappingStrategy:he(new me)}});var Vt=this&&this.__importDefault||function(ge){return ge&&ge.__esModule?ge:{default:ge}};define(Pe[219],ke([1,0,22,44,7,5,109,10,24]),function(ge,e,s,h,D,A,L,R,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfirmResult=e.IFileDialogService=e.AbstractDialogHandler=e.IDialogService=void 0,e.getFileNamesMessage=T,e.massageMessageBoxOptions=S,h=Vt(h),e.IDialogService=(0,A.createDecorator)("dialogService");var l;(function(o){o[o.Confirmation=1]="Confirmation",o[o.Prompt=2]="Prompt",o[o.Input=3]="Input"})(l||(l={}));class C{getConfirmationButtons(m){return this.getButtons(m,l.Confirmation)}getPromptButtons(m){return this.getButtons(m,l.Prompt)}getInputButtons(m){return this.getButtons(m,l.Input)}getButtons(m,p){const u=[];switch(p){case l.Confirmation:{const i=m;i.primaryButton?u.push(i.primaryButton):u.push((0,D.localize)(1698,null)),i.cancelButton?u.push(i.cancelButton):u.push((0,D.localize)(1699,null));break}case l.Prompt:{const i=m;Array.isArray(i.buttons)&&i.buttons.length>0&&u.push(...i.buttons.map(a=>a.label)),i.cancelButton&&(i.cancelButton===!0?u.push((0,D.localize)(1700,null)):typeof i.cancelButton=="string"?u.push(i.cancelButton):i.cancelButton.label?u.push(i.cancelButton.label):u.push((0,D.localize)(1701,null))),u.length===0&&u.push((0,D.localize)(1702,null));break}case l.Input:{const i=m;i.primaryButton?u.push(i.primaryButton):u.push((0,D.localize)(1703,null)),i.cancelButton?u.push(i.cancelButton):u.push((0,D.localize)(1704,null));break}}return u}getDialogType(m){if(typeof m=="string")return m;if(typeof m=="number")return m===h.default.Info?"info":m===h.default.Error?"error":m===h.default.Warning?"warning":"none"}getPromptResult(m,p,u){const i=[...m.buttons??[]];m.cancelButton&&typeof m.cancelButton!="string"&&typeof m.cancelButton!="boolean"&&i.push(m.cancelButton);let a=i[p]?.run({checkboxChecked:u});return a instanceof Promise||(a=Promise.resolve(a)),{result:a,checkboxChecked:u}}}e.AbstractDialogHandler=C,e.IFileDialogService=(0,A.createDecorator)("fileDialogService");var _;(function(o){o[o.SAVE=0]="SAVE",o[o.DONT_SAVE=1]="DONT_SAVE",o[o.CANCEL=2]="CANCEL"})(_||(e.ConfirmResult=_={}));const f=10;function T(o){const m=[];return m.push(...o.slice(0,f).map(p=>typeof p=="string"?p:(0,s.basename)(p))),o.length>f&&(o.length-f===1?m.push((0,D.localize)(1705,null)):m.push((0,D.localize)(1706,null,o.length-f))),m.push(""),m.join(`
`)}function S(o,m){const p=(0,v.deepClone)(o);let u=(p.buttons??[]).map(n=>(0,L.mnemonicButtonLabel)(n)),i=(o.buttons||[]).map((n,r)=>r),a=0,t=p.cancelId??u.length-1;if(u.length>1){const n=typeof t=="number"?u[t]:void 0;if(R.isLinux||R.isMacintosh){if(typeof n=="string"&&u.length>1&&t!==1){u.splice(t,1),u.splice(1,0,n);const r=i[t];i.splice(t,1),i.splice(1,0,r),t=1}R.isLinux&&u.length>1&&(u=u.reverse(),i=i.reverse(),a=u.length-1,typeof n=="string"&&(t=a-1))}else if(R.isWindows&&typeof n=="string"&&u.length>1&&t!==u.length-1){u.splice(t,1),u.push(n);const r=i[t];i.splice(t,1),i.push(r),t=u.length-1}}return p.buttons=u,p.defaultId=a,p.cancelId=t,p.noLink=!0,p.title=p.title||m.nameLong,{options:p,buttonIndeces:i}}}),define(Pe[148],ke([1,0,5]),function(ge,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,s.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,s.refineServiceDecorator)(e.IEnvironmentService)}),define(Pe[220],ke([1,0,5]),function(ge,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,s.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app"}),define(Pe[221],ke([1,0,58,60,14,16,10,108,34,111,7,220]),function(ge,e,s,h,D,A,L,R,v,l,C,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0,s=We(s),A=We(A),L=We(L),v=We(v),l=We(l),C=We(C);const f=C.localize(1851,null);class T{async getDefaultTerminalForPlatforms(){return{windows:S.getDefaultTerminalWindows(),linux:await m.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class S extends T{static{this.CMD="cmd.exe"}openTerminal(t,n){return this.spawnTerminal(s,t,l.getWindowsShell(),n)}spawnTerminal(t,n,r,d){const c=n.windowsExec||S.getDefaultTerminalWindows();d&&d[1]===":"&&(d=d[0].toUpperCase()+d.substr(1));const g=A.basename(c,".exe").toLowerCase();if(g==="cmder")return t.spawn(c,d?[d]:void 0),Promise.resolve(void 0);const w=["/c","start","/wait"];return c.indexOf(" ")>=0&&w.push(c),w.push(c),g==="wt"&&w.push("-d ."),new Promise((y,I)=>{const P=p(process),k=t.spawn(r,w,{cwd:d,env:P,detached:!0});k.on("error",I),k.on("exit",()=>y())})}async runInTerminal(t,n,r,d,c){const g="windowsExec"in c&&c.windowsExec?c.windowsExec:S.getDefaultTerminalWindows(),w=await S.getWtExePath();return new Promise((y,I)=>{const P=`"${n} - ${f}"`,k=`"${r.join('" "')}" & pause`,b=Object.assign({},p(process),d);Object.keys(b).filter(U=>b[U]===null).forEach(U=>delete b[U]);const E={cwd:n,env:b,windowsVerbatimArguments:!0};let N,O;A.basename(g,".exe")==="wt"?(N=g,O=["-d",".",S.CMD,"/c",k]):w?(N=w,O=["-d",".",g,"/c",k]):(N=S.CMD,O=["/c","start",P,"/wait",g,"/c",`"${k}"`]),s.spawn(N,O,E).on("error",U=>{I(u(U))}),y(void 0)})}static getDefaultTerminalWindows(){if(!S._DEFAULT_TERMINAL_WINDOWS){const t=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");S._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${t?"Sysnative":"System32"}\\cmd.exe`}return S._DEFAULT_TERMINAL_WINDOWS}static async getWtExePath(){try{const t=await l.win32.findExecutable("wt");return await v.Promises.exists(t)?t:void 0}catch{return}}}e.WindowsExternalTerminalService=S,Qe([h.memoize],S,"getWtExePath",null);class o extends T{static{this.OSASCRIPT="/usr/bin/osascript"}openTerminal(t,n){return this.spawnTerminal(s,t,n)}runInTerminal(t,n,r,d,c){const g=c.osxExec||_.DEFAULT_TERMINAL_OSX;return new Promise((w,y)=>{if(g===_.DEFAULT_TERMINAL_OSX||g==="iTerm.app"){const I=g===_.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",k=[D.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${I}.scpt`).fsPath,"-t",t||f,"-w",n];for(const N of r)k.push("-a"),k.push(N);if(d){const N=Object.assign({},p(process),d);for(const O in N){const M=N[O];M===null?(k.push("-u"),k.push(O)):(k.push("-e"),k.push(`${O}=${M}`))}}let b="";const E=s.spawn(o.OSASCRIPT,k);E.on("error",N=>{y(u(N))}),E.stderr.on("data",N=>{b+=N.toString()}),E.on("exit",N=>{if(N===0)w(void 0);else if(b){const O=b.split(`
`,1);y(new Error(O[0]))}else y(new Error(C.localize(1852,null,I,N)))})}else y(new Error(C.localize(1853,null,g)))})}spawnTerminal(t,n,r){const d=n.osxExec||_.DEFAULT_TERMINAL_OSX;return new Promise((c,g)=>{const w=["-a",d];r&&w.push(r);const y=p(process),I=t.spawn("/usr/bin/open",w,{cwd:r,env:y});I.on("error",g),I.on("exit",()=>c())})}}e.MacExternalTerminalService=o;class m extends T{static{this.WAIT_MESSAGE=C.localize(1854,null)}openTerminal(t,n){return this.spawnTerminal(s,t,n)}runInTerminal(t,n,r,d,c){const g=c.linuxExec?Promise.resolve(c.linuxExec):m.getDefaultTerminalLinuxReady();return new Promise((w,y)=>{const I=[];g.then(P=>{P.indexOf("gnome-terminal")>=0?I.push("-x"):I.push("-e"),I.push("bash"),I.push("-c");const k=`${i(r)}; echo; read -p "${m.WAIT_MESSAGE}" -n1;`;I.push(`''${k}''`);const b=Object.assign({},p(process),d);Object.keys(b).filter(M=>b[M]===null).forEach(M=>delete b[M]);const E={cwd:n,env:b};let N="";const O=s.spawn(P,I,E);O.on("error",M=>{y(u(M))}),O.stderr.on("data",M=>{N+=M.toString()}),O.on("exit",M=>{if(M===0)w(void 0);else if(N){const U=N.split(`
`,1);y(new Error(U[0]))}else y(new Error(C.localize(1855,null,P,M)))})})})}static async getDefaultTerminalLinuxReady(){if(!m._DEFAULT_TERMINAL_LINUX_READY)if(!L.isLinux)m._DEFAULT_TERMINAL_LINUX_READY=Promise.resolve("xterm");else{const t=await v.Promises.exists("/etc/debian_version");m._DEFAULT_TERMINAL_LINUX_READY=new Promise(n=>{t?n("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?n("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?n("konsole"):process.env.COLORTERM?n(process.env.COLORTERM):process.env.TERM?n(process.env.TERM):n("xterm")})}return m._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(t,n,r){const d=n.linuxExec?Promise.resolve(n.linuxExec):m.getDefaultTerminalLinuxReady();return new Promise((c,g)=>{d.then(w=>{const y=p(process),I=t.spawn(w,[],{cwd:r,env:y});I.on("error",g),I.on("exit",()=>c())})})}}e.LinuxExternalTerminalService=m;function p(a){const t={...a.env};return(0,R.sanitizeProcessEnvironment)(t),t}function u(a){return"errno"in a&&a.errno==="ENOENT"&&"path"in a&&typeof a.path=="string"?new Error(C.localize(1856,null,a.path)):a}function i(a){let t="";for(const n of a)n.indexOf(" ")>=0?t+='"'+n+'"':t+=n,t+=" ";return t}}),define(Pe[27],ke([1,0,62,16,13,17,2,7,5,10,14,50]),function(ge,e,s,h,D,A,L,R,v,l,C,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ByteSize=e.ETAG_DISABLED=e.FileKind=e.FILES_READONLY_FROM_PERMISSIONS_CONFIG=e.FILES_READONLY_EXCLUDE_CONFIG=e.FILES_READONLY_INCLUDE_CONFIG=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.TooLargeFileOperationError=e.FileOperationError=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FileChangeFilter=e.FilePermission=e.FileType=e.IFileService=void 0,e.isFileOpenForWriteOptions=f,e.isFileSystemWatcher=m,e.hasReadWriteCapability=u,e.hasFileFolderCopyCapability=i,e.hasFileCloneCapability=a,e.hasOpenReadWriteCloseCapability=t,e.hasFileReadStreamCapability=n,e.hasFileAtomicReadCapability=r,e.hasFileAtomicWriteCapability=d,e.hasFileAtomicDeleteCapability=c,e.hasReadonlyCapability=g,e.createFileSystemProviderError=I,e.ensureFileSystemProviderError=P,e.markAsFileSystemProviderError=k,e.toFileSystemProviderErrorCode=b,e.toFileOperationResult=E,e.isParent=H,e.etag=W,e.whenProviderRegistered=Z,e.getLargeFileConfirmationLimit=oe,e.IFileService=(0,v.createDecorator)("fileService");function f(te){return te.create===!0}var T;(function(te){te[te.Unknown=0]="Unknown",te[te.File=1]="File",te[te.Directory=2]="Directory",te[te.SymbolicLink=64]="SymbolicLink"})(T||(e.FileType=T={}));var S;(function(te){te[te.Readonly=1]="Readonly",te[te.Locked=2]="Locked"})(S||(e.FilePermission=S={}));var o;(function(te){te[te.UPDATED=2]="UPDATED",te[te.ADDED=4]="ADDED",te[te.DELETED=8]="DELETED"})(o||(e.FileChangeFilter=o={}));function m(te){const me=te;return!!me&&typeof me.onDidChange=="function"}var p;(function(te){te[te.None=0]="None",te[te.FileReadWrite=2]="FileReadWrite",te[te.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",te[te.FileReadStream=16]="FileReadStream",te[te.FileFolderCopy=8]="FileFolderCopy",te[te.PathCaseSensitive=1024]="PathCaseSensitive",te[te.Readonly=2048]="Readonly",te[te.Trash=4096]="Trash",te[te.FileWriteUnlock=8192]="FileWriteUnlock",te[te.FileAtomicRead=16384]="FileAtomicRead",te[te.FileAtomicWrite=32768]="FileAtomicWrite",te[te.FileAtomicDelete=65536]="FileAtomicDelete",te[te.FileClone=131072]="FileClone"})(p||(e.FileSystemProviderCapabilities=p={}));function u(te){return!!(te.capabilities&p.FileReadWrite)}function i(te){return!!(te.capabilities&p.FileFolderCopy)}function a(te){return!!(te.capabilities&p.FileClone)}function t(te){return!!(te.capabilities&p.FileOpenReadWriteClose)}function n(te){return!!(te.capabilities&p.FileReadStream)}function r(te){return u(te)?!!(te.capabilities&p.FileAtomicRead):!1}function d(te){return u(te)?!!(te.capabilities&p.FileAtomicWrite):!1}function c(te){return!!(te.capabilities&p.FileAtomicDelete)}function g(te){return!!(te.capabilities&p.Readonly)}var w;(function(te){te.FileExists="EntryExists",te.FileNotFound="EntryNotFound",te.FileNotADirectory="EntryNotADirectory",te.FileIsADirectory="EntryIsADirectory",te.FileExceedsStorageQuota="EntryExceedsStorageQuota",te.FileTooLarge="EntryTooLarge",te.FileWriteLocked="EntryWriteLocked",te.NoPermissions="NoPermissions",te.Unavailable="Unavailable",te.Unknown="Unknown"})(w||(e.FileSystemProviderErrorCode=w={}));class y extends Error{static create(me,le){const Q=new y(me.toString(),le);return k(Q,le),Q}constructor(me,le){super(me),this.code=le}}e.FileSystemProviderError=y;function I(te,me){return y.create(te,me)}function P(te){return te||I((0,R.localize)(1865,null),w.Unknown)}function k(te,me){return te.name=me?`${me} (FileSystemError)`:"FileSystemError",te}function b(te){if(!te)return w.Unknown;if(te instanceof y)return te.code;const me=/^(.+) \(FileSystemError\)$/.exec(te.name);if(!me)return w.Unknown;switch(me[1]){case w.FileExists:return w.FileExists;case w.FileIsADirectory:return w.FileIsADirectory;case w.FileNotADirectory:return w.FileNotADirectory;case w.FileNotFound:return w.FileNotFound;case w.FileTooLarge:return w.FileTooLarge;case w.FileWriteLocked:return w.FileWriteLocked;case w.NoPermissions:return w.NoPermissions;case w.Unavailable:return w.Unavailable}return w.Unknown}function E(te){if(te instanceof F)return te.fileOperationResult;switch(b(te)){case w.FileNotFound:return G.FILE_NOT_FOUND;case w.FileIsADirectory:return G.FILE_IS_DIRECTORY;case w.FileNotADirectory:return G.FILE_NOT_DIRECTORY;case w.FileWriteLocked:return G.FILE_WRITE_LOCKED;case w.NoPermissions:return G.FILE_PERMISSION_DENIED;case w.FileExists:return G.FILE_MOVE_CONFLICT;case w.FileTooLarge:return G.FILE_TOO_LARGE;default:return G.FILE_OTHER_ERROR}}var N;(function(te){te[te.CREATE=0]="CREATE",te[te.DELETE=1]="DELETE",te[te.MOVE=2]="MOVE",te[te.COPY=3]="COPY",te[te.WRITE=4]="WRITE"})(N||(e.FileOperation=N={}));class O{constructor(me,le,Q){this.resource=me,this.operation=le,this.target=Q}isOperation(me){return this.operation===me}}e.FileOperationEvent=O;var M;(function(te){te[te.UPDATED=0]="UPDATED",te[te.ADDED=1]="ADDED",te[te.DELETED=2]="DELETED"})(M||(e.FileChangeType=M={}));class U{static{this.MIXED_CORRELATION=null}constructor(me,le){this.ignorePathCasing=le,this.correlationId=void 0,this.added=new _.Lazy(()=>{const Q=s.TernarySearchTree.forUris(()=>this.ignorePathCasing);return Q.fill(this.rawAdded.map(z=>[z,!0])),Q}),this.updated=new _.Lazy(()=>{const Q=s.TernarySearchTree.forUris(()=>this.ignorePathCasing);return Q.fill(this.rawUpdated.map(z=>[z,!0])),Q}),this.deleted=new _.Lazy(()=>{const Q=s.TernarySearchTree.forUris(()=>this.ignorePathCasing);return Q.fill(this.rawDeleted.map(z=>[z,!0])),Q}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const Q of me){switch(Q.type){case M.ADDED:this.rawAdded.push(Q.resource);break;case M.UPDATED:this.rawUpdated.push(Q.resource);break;case M.DELETED:this.rawDeleted.push(Q.resource);break}this.correlationId!==U.MIXED_CORRELATION&&(typeof Q.cId=="number"?this.correlationId===void 0?this.correlationId=Q.cId:this.correlationId!==Q.cId&&(this.correlationId=U.MIXED_CORRELATION):this.correlationId!==void 0&&(this.correlationId=U.MIXED_CORRELATION))}}contains(me,...le){return this.doContains(me,{includeChildren:!1},...le)}affects(me,...le){return this.doContains(me,{includeChildren:!0},...le)}doContains(me,le,...Q){if(!me)return!1;const z=Q.length>0;return!!((!z||Q.includes(M.ADDED))&&(this.added.value.get(me)||le.includeChildren&&this.added.value.findSuperstr(me))||(!z||Q.includes(M.UPDATED))&&(this.updated.value.get(me)||le.includeChildren&&this.updated.value.findSuperstr(me))||(!z||Q.includes(M.DELETED))&&(this.deleted.value.findSubstr(me)||le.includeChildren&&this.deleted.value.findSuperstr(me)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(me){return this.correlationId===me}hasCorrelation(){return typeof this.correlationId=="number"}}e.FileChangesEvent=U;function H(te,me,le){return!te||!me||te===me||me.length>te.length?!1:(me.charAt(me.length-1)!==h.sep&&(me+=h.sep),le?(0,D.startsWithIgnoreCase)(te,me):te.indexOf(me)===0)}class F extends Error{constructor(me,le,Q){super(me),this.fileOperationResult=le,this.options=Q}}e.FileOperationError=F;class x extends F{constructor(me,le,Q,z){super(me,le,z),this.fileOperationResult=le,this.size=Q}}e.TooLargeFileOperationError=x;class $ extends F{constructor(me,le,Q){super(me,G.FILE_NOT_MODIFIED_SINCE,Q),this.stat=le}}e.NotModifiedSinceFileOperationError=$;var G;(function(te){te[te.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",te[te.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",te[te.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",te[te.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",te[te.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",te[te.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",te[te.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",te[te.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",te[te.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",te[te.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",te[te.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(G||(e.FileOperationResult=G={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude",e.FILES_READONLY_INCLUDE_CONFIG="files.readonlyInclude",e.FILES_READONLY_EXCLUDE_CONFIG="files.readonlyExclude",e.FILES_READONLY_FROM_PERMISSIONS_CONFIG="files.readonlyFromPermissions";var B;(function(te){te[te.FILE=0]="FILE",te[te.FOLDER=1]="FOLDER",te[te.ROOT_FOLDER=2]="ROOT_FOLDER"})(B||(e.FileKind=B={})),e.ETAG_DISABLED="";function W(te){if(!(typeof te.size!="number"||typeof te.mtime!="number"))return te.mtime.toString(29)+te.size.toString(31)}async function Z(te,me){if(!me.hasProvider(L.URI.from({scheme:te.scheme})))return new Promise(le=>{const Q=me.onDidChangeFileSystemProviderRegistrations(z=>{z.scheme===te.scheme&&z.added&&(Q.dispose(),le())})})}class J{static{this.KB=1024}static{this.MB=J.KB*J.KB}static{this.GB=J.MB*J.KB}static{this.TB=J.GB*J.KB}static formatSize(me){return(0,A.isNumber)(me)||(me=0),me<J.KB?(0,R.localize)(1866,null,me.toFixed(0)):me<J.MB?(0,R.localize)(1867,null,(me/J.KB).toFixed(2)):me<J.GB?(0,R.localize)(1868,null,(me/J.MB).toFixed(2)):me<J.TB?(0,R.localize)(1869,null,(me/J.GB).toFixed(2)):(0,R.localize)(1870,null,(me/J.TB).toFixed(2))}}e.ByteSize=J;function oe(te){const me=typeof te=="string"||te?.scheme===C.Schemas.vscodeRemote;return typeof te!="string"&&te?.scheme===C.Schemas.file?1024*J.MB:me?10*J.MB:l.isWeb?50*J.MB:1024*J.MB}}),define(Pe[222],ke([1,0,21,12,7,27]),function(ge,e,s,h,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=L;async function L(C,_,f,T,S,o){let m;try{await R(C,_,f,T,S,o)}catch(p){m=p}finally{m&&S.errorTransformer&&(m=S.errorTransformer(m)),typeof m<"u"&&f.error(m),f.end()}}async function R(C,_,f,T,S,o){v(o);const m=await C.open(_,{create:!1});try{v(o);let p=0,u=0,i=S&&typeof S.length=="number"?S.length:void 0,a=s.VSBuffer.alloc(Math.min(S.bufferSize,typeof i=="number"?i:S.bufferSize)),t=S&&typeof S.position=="number"?S.position:0,n=0;do u=await C.read(m,t,a.buffer,n,a.byteLength-n),t+=u,n+=u,p+=u,typeof i=="number"&&(i-=u),n===a.byteLength&&(await f.write(T(a)),a=s.VSBuffer.alloc(Math.min(S.bufferSize,typeof i=="number"?i:S.bufferSize)),n=0);while(u>0&&(typeof i!="number"||i>0)&&v(o)&&l(p,S));if(n>0){let r=n;typeof i=="number"&&(r=Math.min(n,i)),f.write(T(a.slice(0,r)))}}catch(p){throw(0,A.ensureFileSystemProviderError)(p)}finally{await C.close(m)}}function v(C){if(C.isCancellationRequested)throw(0,h.canceled)();return!0}function l(C,_){if(typeof _?.limits?.size=="number"&&C>_.limits.size)throw(0,A.createFileSystemProviderError)((0,D.localize)(1898,null),A.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(Pe[71],ke([1,0,39,3,16,10,2,27]),function(ge,e,s,h,D,A,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractUniversalWatcherClient=e.AbstractNonRecursiveWatcherClient=e.AbstractWatcherClient=void 0,e.isWatchRequestWithCorrelation=v,e.isRecursiveWatchRequest=l,e.reviveFileChanges=T,e.coalesceEvents=S,e.normalizeWatcherPattern=o,e.parseWatcherPatterns=m,e.isFiltered=u,e.requestFilterToString=i;function v(a){return typeof a.correlationId=="number"}function l(a){return a.recursive===!0}class C extends h.Disposable{static{this.MAX_RESTARTS=5}constructor(t,n,r,d){super(),this.onFileChanges=t,this.onLogMessage=n,this.verboseLogging=r,this.options=d,this.watcherDisposables=this._register(new h.MutableDisposable),this.requests=void 0,this.restartCounter=0}init(){const t=new h.DisposableStore;this.watcherDisposables.value=t,this.watcher=this.createWatcher(t),this.watcher.setVerboseLogging(this.verboseLogging),t.add(this.watcher.onDidChangeFile(n=>this.onFileChanges(n))),t.add(this.watcher.onDidLogMessage(n=>this.onLogMessage(n))),t.add(this.watcher.onDidError(n=>this.onError(n.error,n.request)))}onError(t,n){this.canRestart(t,n)?this.restartCounter<C.MAX_RESTARTS&&this.requests?(this.error(`restarting watcher after unexpected error: ${t}`),this.restart(this.requests)):this.error(`gave up attempting to restart watcher after unexpected error: ${t}`):this.error(t)}canRestart(t,n){return!(!this.options.restartOnError||n||t.indexOf("No space left on device")!==-1||t.indexOf("EMFILE")!==-1)}restart(t){this.restartCounter++,this.init(),this.watch(t)}async watch(t){this.requests=t,await this.watcher?.watch(t)}async setVerboseLogging(t){this.verboseLogging=t,await this.watcher?.setVerboseLogging(t)}error(t){this.onLogMessage({type:"error",message:`[File Watcher (${this.options.type})] ${t}`})}trace(t){this.onLogMessage({type:"trace",message:`[File Watcher (${this.options.type})] ${t}`})}dispose(){return this.watcher=void 0,super.dispose()}}e.AbstractWatcherClient=C;class _ extends C{constructor(t,n,r){super(t,n,r,{type:"node.js",restartOnError:!1})}}e.AbstractNonRecursiveWatcherClient=_;class f extends C{constructor(t,n,r){super(t,n,r,{type:"universal",restartOnError:!0})}}e.AbstractUniversalWatcherClient=f;function T(a){return a.map(t=>({type:t.type,resource:L.URI.revive(t.resource),cId:t.cId}))}function S(a){const t=new p;for(const n of a)t.processEvent(n);return t.coalesce()}function o(a,t){return typeof t=="string"&&!t.startsWith(s.GLOBSTAR)&&!(0,D.isAbsolute)(t)?{base:a,pattern:t}:t}function m(a,t){const n=[];for(const r of t)n.push((0,s.parse)(o(a,r)));return n}class p{constructor(){this.coalesced=new Set,this.mapPathToChange=new Map}toKey(t){return A.isLinux?t.resource.fsPath:t.resource.fsPath.toLowerCase()}processEvent(t){const n=this.mapPathToChange.get(this.toKey(t));let r=!1;if(n){const d=n.type,c=t.type;n.resource.fsPath!==t.resource.fsPath&&(t.type===R.FileChangeType.DELETED||t.type===R.FileChangeType.ADDED)?r=!0:d===R.FileChangeType.ADDED&&c===R.FileChangeType.DELETED?(this.mapPathToChange.delete(this.toKey(t)),this.coalesced.delete(n)):d===R.FileChangeType.DELETED&&c===R.FileChangeType.ADDED?n.type=R.FileChangeType.UPDATED:d===R.FileChangeType.ADDED&&c===R.FileChangeType.UPDATED||(n.type=c)}else r=!0;r&&(this.coalesced.add(t),this.mapPathToChange.set(this.toKey(t),t))}coalesce(){const t=[],n=[];return Array.from(this.coalesced).filter(r=>r.type!==R.FileChangeType.DELETED?(t.push(r),!1):!0).sort((r,d)=>r.resource.fsPath.length-d.resource.fsPath.length).filter(r=>n.some(d=>(0,R.isParent)(r.resource.fsPath,d,!A.isLinux))?!1:(n.push(r.resource.fsPath),!0)).concat(t)}}function u(a,t){if(typeof t=="number")switch(a.type){case R.FileChangeType.ADDED:return(t&R.FileChangeFilter.ADDED)===0;case R.FileChangeType.DELETED:return(t&R.FileChangeFilter.DELETED)===0;case R.FileChangeType.UPDATED:return(t&R.FileChangeFilter.UPDATED)===0}return!1}function i(a){if(typeof a=="number"){const t=[];return a&R.FileChangeFilter.ADDED&&t.push("Added"),a&R.FileChangeFilter.DELETED&&t.push("Deleted"),a&R.FileChangeFilter.UPDATED&&t.push("Updated"),t.length===0?"<all>":`[${t.join(", ")}]`}return"<none>"}}),define(Pe[223],ke([1,0,45,3,71,4,27,2,8]),function(ge,e,s,h,D,A,L,R,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BaseWatcher=void 0;class l extends h.Disposable{constructor(){super(),this._onDidChangeFile=this._register(new A.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidLogMessage=this._register(new A.Emitter),this.onDidLogMessage=this._onDidLogMessage.event,this._onDidWatchFail=this._register(new A.Emitter),this.onDidWatchFail=this._onDidWatchFail.event,this.allNonCorrelatedWatchRequests=new Set,this.allCorrelatedWatchRequests=new Map,this.suspendedWatchRequests=this._register(new h.DisposableMap),this.suspendedWatchRequestsWithPolling=new Set,this.updateWatchersDelayer=this._register(new v.ThrottledDelayer(this.getUpdateWatchersDelay())),this.suspendedWatchRequestPollingInterval=5007,this.joinWatch=new v.DeferredPromise,this.verboseLogging=!1,this._register(this.onDidWatchFail(_=>this.handleDidWatchFail(_)))}handleDidWatchFail(_){this.isCorrelated(_)&&this.suspendWatchRequest(_)}isCorrelated(_){return(0,D.isWatchRequestWithCorrelation)(_)}async watch(_){this.joinWatch.isSettled||this.joinWatch.complete(),this.joinWatch=new v.DeferredPromise;try{this.allCorrelatedWatchRequests.clear(),this.allNonCorrelatedWatchRequests.clear();for(const f of _)this.isCorrelated(f)?this.allCorrelatedWatchRequests.set(f.correlationId,f):this.allNonCorrelatedWatchRequests.add(f);for(const[f]of this.suspendedWatchRequests)this.allCorrelatedWatchRequests.has(f)||(this.suspendedWatchRequests.deleteAndDispose(f),this.suspendedWatchRequestsWithPolling.delete(f));return await this.updateWatchers(!1)}finally{this.joinWatch.complete()}}updateWatchers(_){return this.updateWatchersDelayer.trigger(()=>this.doWatch([...this.allNonCorrelatedWatchRequests,...Array.from(this.allCorrelatedWatchRequests.values()).filter(f=>!this.suspendedWatchRequests.has(f.correlationId))]),_?this.getUpdateWatchersDelay():0)}getUpdateWatchersDelay(){return 800}isSuspended(_){return typeof _.correlationId!="number"?!1:this.suspendedWatchRequestsWithPolling.has(_.correlationId)?"polling":this.suspendedWatchRequests.has(_.correlationId)}async suspendWatchRequest(_){if(this.suspendedWatchRequests.has(_.correlationId))return;const f=new h.DisposableStore;this.suspendedWatchRequests.set(_.correlationId,f),await this.joinWatch.p,!f.isDisposed&&(this.monitorSuspendedWatchRequest(_,f),this.updateWatchers(!0))}resumeWatchRequest(_){this.suspendedWatchRequests.deleteAndDispose(_.correlationId),this.suspendedWatchRequestsWithPolling.delete(_.correlationId),this.updateWatchers(!1)}monitorSuspendedWatchRequest(_,f){this.doMonitorWithExistingWatcher(_,f)?(this.trace(`reusing an existing recursive watcher to monitor ${_.path}`),this.suspendedWatchRequestsWithPolling.delete(_.correlationId)):(this.doMonitorWithNodeJS(_,f),this.suspendedWatchRequestsWithPolling.add(_.correlationId))}doMonitorWithExistingWatcher(_,f){const T=this.recursiveWatcher?.subscribe(_.path,(S,o)=>{f.isDisposed||(S?this.monitorSuspendedWatchRequest(_,f):o?.type===L.FileChangeType.ADDED&&this.onMonitoredPathAdded(_))});return T?(f.add(T),!0):!1}doMonitorWithNodeJS(_,f){let T=!1;const S=(o,m)=>{if(f.isDisposed)return;const p=this.isPathNotFound(o),u=this.isPathNotFound(m),i=T;T=p,!p&&(u||i)&&this.onMonitoredPathAdded(_)};this.trace(`starting fs.watchFile() on ${_.path} (correlationId: ${_.correlationId})`);try{(0,s.watchFile)(_.path,{persistent:!1,interval:this.suspendedWatchRequestPollingInterval},S)}catch(o){this.warn(`fs.watchFile() failed with error ${o} on path ${_.path} (correlationId: ${_.correlationId})`)}f.add((0,h.toDisposable)(()=>{this.trace(`stopping fs.watchFile() on ${_.path} (correlationId: ${_.correlationId})`);try{(0,s.unwatchFile)(_.path,S)}catch(o){this.warn(`fs.unwatchFile() failed with error ${o} on path ${_.path} (correlationId: ${_.correlationId})`)}}))}onMonitoredPathAdded(_){this.trace(`detected ${_.path} exists again, resuming watcher (correlationId: ${_.correlationId})`);const f={resource:R.URI.file(_.path),type:L.FileChangeType.ADDED,cId:_.correlationId};this._onDidChangeFile.fire([f]),this.traceEvent(f,_),this.resumeWatchRequest(_)}isPathNotFound(_){return _.ctimeMs===0&&_.ino===0}async stop(){this.suspendedWatchRequests.clearAndDisposeAll(),this.suspendedWatchRequestsWithPolling.clear()}traceEvent(_,f){if(this.verboseLogging){const T=` >> normalized ${_.type===L.FileChangeType.ADDED?"[ADDED]":_.type===L.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${_.resource.fsPath}`;this.traceWithCorrelation(T,f)}}traceWithCorrelation(_,f){this.verboseLogging&&this.trace(`${_}${typeof f.correlationId=="number"?` <${f.correlationId}> `:""}`)}requestToString(_){return`${_.path} (excludes: ${_.excludes.length>0?_.excludes:"<none>"}, includes: ${_.includes&&_.includes.length>0?JSON.stringify(_.includes):"<all>"}, filter: ${(0,D.requestFilterToString)(_.filter)}, correlationId: ${typeof _.correlationId=="number"?_.correlationId:"<none>"})`}async setVerboseLogging(_){this.verboseLogging=_}}e.BaseWatcher=l}),define(Pe[224],ke([1,0,45,8,20,33,3,83,16,10,22,2,110,34,27,71]),function(ge,e,s,h,D,A,L,R,v,l,C,_,f,T,S,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSFileWatcherLibrary=void 0,e.watchFileContents=p;class m extends L.Disposable{static{this.FILE_DELETE_HANDLER_DELAY=100}static{this.FILE_CHANGES_HANDLER_DELAY=75}get isReusingRecursiveWatcher(){return this._isReusingRecursiveWatcher}get failed(){return this.didFail}constructor(i,a,t,n,r,d){super(),this.request=i,this.recursiveWatcher=a,this.onDidFilesChange=t,this.onDidWatchFail=n,this.onLogMessage=r,this.verboseLogging=d,this.throttledFileChangesEmitter=this._register(new h.ThrottledWorker({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},c=>this.onDidFilesChange(c))),this.fileChangesAggregator=this._register(new h.RunOnceWorker(c=>this.handleFileChanges(c),m.FILE_CHANGES_HANDLER_DELAY)),this.excludes=(0,o.parseWatcherPatterns)(this.request.path,this.request.excludes),this.includes=this.request.includes?(0,o.parseWatcherPatterns)(this.request.path,this.request.includes):void 0,this.filter=(0,o.isWatchRequestWithCorrelation)(this.request)?this.request.filter:void 0,this.cts=new D.CancellationTokenSource,this.ready=this.watch(),this._isReusingRecursiveWatcher=!1,this.didFail=!1}async watch(){try{const i=await this.normalizePath(this.request);if(this.cts.token.isCancellationRequested)return;const a=await s.promises.stat(i);if(this.cts.token.isCancellationRequested)return;this._register(await this.doWatch(i,a.isDirectory()))}catch(i){i.code!=="ENOENT"?this.error(i):this.trace(`ignoring a path for watching who's stat info failed to resolve: ${this.request.path} (error: ${i})`),this.notifyWatchFailed()}}notifyWatchFailed(){this.didFail=!0,this.onDidWatchFail?.()}async normalizePath(i){let a=i.path;try{a=await T.Promises.realpath(i.path),i.path===a&&(a=await(0,f.realcase)(i.path,this.cts.token)??i.path),i.path!==a&&this.trace(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${i.path}, real: ${a})`)}catch{}return a}async doWatch(i,a){const t=new L.DisposableStore;return this.doWatchWithExistingWatcher(i,a,t)?(this.trace(`reusing an existing recursive watcher for ${this.request.path}`),this._isReusingRecursiveWatcher=!0):(this._isReusingRecursiveWatcher=!1,await this.doWatchWithNodeJS(i,a,t)),t}doWatchWithExistingWatcher(i,a,t){if(a)return!1;const n=_.URI.file(this.request.path),r=this.recursiveWatcher?.subscribe(this.request.path,async(d,c)=>{if(!t.isDisposed)if(d){const g=await this.doWatch(i,a);t.isDisposed?g.dispose():t.add(g)}else c&&(typeof c.cId=="number"||typeof this.request.correlationId=="number")&&this.onFileChange({resource:n,type:c.type,cId:this.request.correlationId},!0)});return r?(t.add(r),!0):!1}async doWatchWithNodeJS(i,a,t){if(l.isMacintosh&&(0,A.isEqualOrParent)(i,"/Volumes/",!0)){this.error(`Refusing to watch ${i} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`);return}const n=new D.CancellationTokenSource(this.cts.token);t.add((0,L.toDisposable)(()=>n.dispose(!0)));const r=new L.DisposableStore;t.add(r);try{const d=_.URI.file(this.request.path),c=(0,v.basename)(i),g=(0,s.watch)(i);r.add((0,L.toDisposable)(()=>{g.removeAllListeners(),g.close()})),this.trace(`Started watching: '${i}'`);const w=new Set;if(a)try{for(const I of await T.Promises.readdir(i))w.add(I)}catch(I){this.error(I)}if(n.token.isCancellationRequested)return;const y=new Map;r.add((0,L.toDisposable)(()=>{for(const[,I]of y)I.dispose();y.clear()})),g.on("error",(I,P)=>{n.token.isCancellationRequested||(this.error(`Failed to watch ${i} for changes using fs.watch() (${I}, ${P})`),this.notifyWatchFailed())}),g.on("change",(I,P)=>{if(n.token.isCancellationRequested)return;this.verboseLogging&&this.traceWithCorrelation(`[raw] ["${I}"] ${P}`);let k="";if(P&&(k=P.toString(),l.isMacintosh&&(k=(0,R.normalizeNFC)(k))),!(!k||I!=="change"&&I!=="rename"))if(a)if(I==="rename"){y.get(k)?.dispose();const b=setTimeout(async()=>{if(y.delete(k),k===c&&!await T.Promises.exists(i)){this.onWatchedPathDeleted(d);return}if(n.token.isCancellationRequested)return;const E=await this.existsChildStrictCase((0,v.join)(i,k));if(n.token.isCancellationRequested)return;let N;E?w.has(k)?N=S.FileChangeType.UPDATED:(N=S.FileChangeType.ADDED,w.add(k)):(w.delete(k),N=S.FileChangeType.DELETED),this.onFileChange({resource:(0,C.joinPath)(d,k),type:N,cId:this.request.correlationId})},m.FILE_DELETE_HANDLER_DELAY);y.set(k,(0,L.toDisposable)(()=>clearTimeout(b)))}else{let b;w.has(k)?b=S.FileChangeType.UPDATED:(b=S.FileChangeType.ADDED,w.add(k)),this.onFileChange({resource:(0,C.joinPath)(d,k),type:b,cId:this.request.correlationId})}else if(I==="rename"||k!==c){const b=setTimeout(async()=>{const E=await T.Promises.exists(i);n.token.isCancellationRequested||(E?(this.onFileChange({resource:d,type:S.FileChangeType.UPDATED,cId:this.request.correlationId},!0),r.add(await this.doWatch(i,!1))):this.onWatchedPathDeleted(d))},m.FILE_DELETE_HANDLER_DELAY);r.clear(),r.add((0,L.toDisposable)(()=>clearTimeout(b)))}else this.onFileChange({resource:d,type:S.FileChangeType.UPDATED,cId:this.request.correlationId},!0)})}catch(d){n.token.isCancellationRequested||this.error(`Failed to watch ${i} for changes using fs.watch() (${d.toString()})`),this.notifyWatchFailed()}}onWatchedPathDeleted(i){this.warn("Watcher shutdown because watched path got deleted"),this.onFileChange({resource:i,type:S.FileChangeType.DELETED,cId:this.request.correlationId},!0),this.fileChangesAggregator.flush(),this.notifyWatchFailed()}onFileChange(i,a=!1){this.cts.token.isCancellationRequested||(this.verboseLogging&&this.traceWithCorrelation(`${i.type===S.FileChangeType.ADDED?"[ADDED]":i.type===S.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${i.resource.fsPath}`),!a&&this.excludes.some(t=>t(i.resource.fsPath))?this.verboseLogging&&this.traceWithCorrelation(` >> ignored (excluded) ${i.resource.fsPath}`):!a&&this.includes&&this.includes.length>0&&!this.includes.some(t=>t(i.resource.fsPath))?this.verboseLogging&&this.traceWithCorrelation(` >> ignored (not included) ${i.resource.fsPath}`):this.fileChangesAggregator.work(i))}handleFileChanges(i){const a=(0,o.coalesceEvents)(i),t=[];for(const r of a){if((0,o.isFiltered)(r,this.filter)){this.verboseLogging&&this.traceWithCorrelation(` >> ignored (filtered) ${r.resource.fsPath}`);continue}t.push(r)}if(t.length===0)return;if(this.verboseLogging)for(const r of t)this.traceWithCorrelation(` >> normalized ${r.type===S.FileChangeType.ADDED?"[ADDED]":r.type===S.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${r.resource.fsPath}`);this.throttledFileChangesEmitter.work(t)?this.throttledFileChangesEmitter.pending>0&&this.trace(`started throttling events due to large amount of file change events at once (pending: ${this.throttledFileChangesEmitter.pending}, most recent change: ${t[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.warn(`started ignoring events due to too many file change events at once (incoming: ${t.length}, most recent change: ${t[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}async existsChildStrictCase(i){if(l.isLinux)return T.Promises.exists(i);try{const a=(0,v.basename)(i);return(await T.Promises.readdir((0,v.dirname)(i))).some(n=>n===a)}catch(a){return this.trace(a),!1}}setVerboseLogging(i){this.verboseLogging=i}error(i){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"error",message:`[File Watcher (node.js)] ${i}`})}warn(i){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"warn",message:`[File Watcher (node.js)] ${i}`})}trace(i){!this.cts.token.isCancellationRequested&&this.verboseLogging&&this.onLogMessage?.({type:"trace",message:`[File Watcher (node.js)] ${i}`})}traceWithCorrelation(i){!this.cts.token.isCancellationRequested&&this.verboseLogging&&this.trace(`${i}${typeof this.request.correlationId=="number"?` <${this.request.correlationId}> `:""}`)}dispose(){this.cts.dispose(!0),super.dispose()}}e.NodeJSFileWatcherLibrary=m;async function p(u,i,a,t,n=512){const r=await T.Promises.open(u,"r"),d=Buffer.allocUnsafe(n),c=new D.CancellationTokenSource(t);let g,w=!1;const y={path:u,excludes:[],recursive:!1},I=new m(y,void 0,P=>{(async()=>{for(const{type:k}of P)if(k===S.FileChangeType.UPDATED){if(w)return;w=!0;try{for(;!c.token.isCancellationRequested;){const{bytesRead:b}=await T.Promises.read(r,d,0,n,null);if(!b||c.token.isCancellationRequested)break;i(d.slice(0,b))}}catch(b){g=new Error(b),c.dispose(!0)}finally{w=!1}}})()});return await I.ready,a(),new Promise((P,k)=>{c.token.onCancellationRequested(async()=>{I.dispose();try{await T.Promises.close(r)}catch(b){g=new Error(b)}g?k(g):P()})})}}),define(Pe[225],ke([1,0,4,39,223,10,224,33]),function(ge,e,s,h,D,A,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class v extends D.BaseWatcher{constructor(C){super(),this.recursiveWatcher=C,this.onDidError=s.Event.None,this.watchers=new Set}async doWatch(C){C=this.removeDuplicateRequests(C);const _=[],f=new Set(Array.from(this.watchers));for(const T of C){const S=this.findWatcher(T);S&&(0,h.patternsEquals)(S.request.excludes,T.excludes)&&(0,h.patternsEquals)(S.request.includes,T.includes)?f.delete(S):_.push(T)}_.length&&this.trace(`Request to start watching: ${_.map(T=>this.requestToString(T)).join(",")}`),f.size&&this.trace(`Request to stop watching: ${Array.from(f).map(T=>this.requestToString(T.request)).join(",")}`);for(const T of f)this.stopWatching(T);for(const T of _)this.startWatching(T)}findWatcher(C){for(const _ of this.watchers)if(typeof C.correlationId=="number"||typeof _.request.correlationId=="number"){if(_.request.correlationId===C.correlationId)return _}else if((0,R.isEqual)(_.request.path,C.path,!A.isLinux))return _}startWatching(C){const _=new L.NodeJSFileWatcherLibrary(C,this.recursiveWatcher,T=>this._onDidChangeFile.fire(T),()=>this._onDidWatchFail.fire(C),T=>this._onDidLogMessage.fire(T),this.verboseLogging),f={request:C,instance:_};this.watchers.add(f)}async stop(){await super.stop();for(const C of this.watchers)this.stopWatching(C)}stopWatching(C){this.trace("stopping file watcher",C),this.watchers.delete(C),C.instance.dispose()}removeDuplicateRequests(C){const _=new Map;for(const f of C){const T=A.isLinux?f.path:f.path.toLowerCase();let S=_.get(f.correlationId);S||(S=new Map,_.set(f.correlationId,S)),S.has(T)&&this.trace(`ignoring a request for watching who's path is already watched: ${this.requestToString(f)}`),S.set(T,f)}return Array.from(_.values()).map(f=>Array.from(f.values())).flat()}async setVerboseLogging(C){super.setVerboseLogging(C);for(const _ of this.watchers)_.instance.setVerboseLogging(C)}trace(C,_){this.verboseLogging&&this._onDidLogMessage.fire({type:"trace",message:this.toMessage(C,_)})}warn(C){this._onDidLogMessage.fire({type:"warn",message:this.toMessage(C)})}toMessage(C,_){return _?`[File Watcher (node.js)] ${C} (${this.requestToString(_.request)})`:`[File Watcher (node.js)] ${C}`}}e.NodeJSWatcher=v}),define(Pe[226],ke([1,0,71,225]),function(ge,e,s,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class D extends s.AbstractNonRecursiveWatcherClient{constructor(L,R,v){super(L,R,v),this.init()}createWatcher(L){return L.add(new h.NodeJSWatcher(void 0))}}e.NodeJSWatcherClient=D}),define(Pe[227],ke([1,0,14,87,209,71]),function(ge,e,s,h,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class L extends A.AbstractUniversalWatcherClient{constructor(v,l,C){super(v,l,C),this.init()}createWatcher(v){const l=v.add(new D.Client(s.FileAccess.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return v.add(l.onDidProcessExit(({code:C,signal:_})=>this.onError(`terminated by itself with code ${C}, signal: ${_} (ETERM)`))),h.ProxyChannel.toService((0,h.getNextTickChannel)(l.getChannel("watcher")))}}e.UniversalWatcherClient=L}),define(Pe[114],ke([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class s{constructor(...D){this._entries=new Map;for(const[A,L]of D)this.set(A,L)}set(D,A){const L=this._entries.get(D);return this._entries.set(D,A),L}has(D){return this._entries.has(D)}get(D){return this._entries.get(D)}}e.ServiceCollection=s}),define(Pe[228],ke([1,0,8,12,3,112,217,5,114,82]),function(ge,e,s,h,D,A,L,R,v,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const C=!1;class _ extends Error{constructor(m){super("cyclic dependency between services"),this.message=m.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${m.toString()}`}}class f{constructor(m=new v.ServiceCollection,p=!1,u,i=C){this._services=m,this._strict=p,this._parent=u,this._enableTracing=i,this._isDisposed=!1,this._servicesToMaybeDispose=new Set,this._children=new Set,this._activeInstantiations=new Set,this._services.set(R.IInstantiationService,this),this._globalGraph=i?u?._globalGraph??new L.Graph(a=>a):void 0}dispose(){if(!this._isDisposed){this._isDisposed=!0,(0,D.dispose)(this._children),this._children.clear();for(const m of this._servicesToMaybeDispose)(0,D.isDisposable)(m)&&m.dispose();this._servicesToMaybeDispose.clear()}}_throwIfDisposed(){if(this._isDisposed)throw new Error("InstantiationService has been disposed")}createChild(m,p){this._throwIfDisposed();const u=this,i=new class extends f{dispose(){u._children.delete(i),super.dispose()}}(m,this._strict,this,this._enableTracing);return this._children.add(i),p?.add(i),i}invokeFunction(m,...p){this._throwIfDisposed();const u=S.traceInvocation(this._enableTracing,m);let i=!1;try{return m({get:t=>{if(i)throw(0,h.illegalState)("service accessor is only valid during the invocation of its target method");const n=this._getOrCreateServiceInstance(t,u);if(!n)throw new Error(`[invokeFunction] unknown service '${t}'`);return n}},...p)}finally{i=!0,u.stop()}}createInstance(m,...p){this._throwIfDisposed();let u,i;return m instanceof A.SyncDescriptor?(u=S.traceCreation(this._enableTracing,m.ctor),i=this._createInstance(m.ctor,m.staticArguments.concat(p),u)):(u=S.traceCreation(this._enableTracing,m),i=this._createInstance(m,p,u)),u.stop(),i}_createInstance(m,p=[],u){const i=R._util.getServiceDependencies(m).sort((n,r)=>n.index-r.index),a=[];for(const n of i){const r=this._getOrCreateServiceInstance(n.id,u);r||this._throwIfStrict(`[createInstance] ${m.name} depends on UNKNOWN service ${n.id}.`,!1),a.push(r)}const t=i.length>0?i[0].index:p.length;if(p.length!==t){console.trace(`[createInstance] First service dependency of ${m.name} at position ${t+1} conflicts with ${p.length} static arguments`);const n=t-p.length;n>0?p=p.concat(new Array(n)):p=p.slice(0,t)}return Reflect.construct(m,p.concat(a))}_setCreatedServiceInstance(m,p){if(this._services.get(m)instanceof A.SyncDescriptor)this._services.set(m,p);else if(this._parent)this._parent._setCreatedServiceInstance(m,p);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(m){const p=this._services.get(m);return!p&&this._parent?this._parent._getServiceInstanceOrDescriptor(m):p}_getOrCreateServiceInstance(m,p){this._globalGraph&&this._globalGraphImplicitDependency&&this._globalGraph.insertEdge(this._globalGraphImplicitDependency,String(m));const u=this._getServiceInstanceOrDescriptor(m);return u instanceof A.SyncDescriptor?this._safeCreateAndCacheServiceInstance(m,u,p.branch(m,!0)):(p.branch(m,!1),u)}_safeCreateAndCacheServiceInstance(m,p,u){if(this._activeInstantiations.has(m))throw new Error(`illegal state - RECURSIVELY instantiating service '${m}'`);this._activeInstantiations.add(m);try{return this._createAndCacheServiceInstance(m,p,u)}finally{this._activeInstantiations.delete(m)}}_createAndCacheServiceInstance(m,p,u){const i=new L.Graph(r=>r.id.toString());let a=0;const t=[{id:m,desc:p,_trace:u}],n=new Set;for(;t.length;){const r=t.pop();if(!n.has(String(r.id))){if(n.add(String(r.id)),i.lookupOrInsertNode(r),a++>1e3)throw new _(i);for(const d of R._util.getServiceDependencies(r.desc.ctor)){const c=this._getServiceInstanceOrDescriptor(d.id);if(c||this._throwIfStrict(`[createInstance] ${m} depends on ${d.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(r.id),String(d.id)),c instanceof A.SyncDescriptor){const g={id:d.id,desc:c,_trace:r._trace.branch(d.id,!0)};i.insertEdge(r,g),t.push(g)}}}}for(;;){const r=i.roots();if(r.length===0){if(!i.isEmpty())throw new _(i);break}for(const{data:d}of r){if(this._getServiceInstanceOrDescriptor(d.id)instanceof A.SyncDescriptor){const g=this._createServiceInstanceWithOwner(d.id,d.desc.ctor,d.desc.staticArguments,d.desc.supportsDelayedInstantiation,d._trace);this._setCreatedServiceInstance(d.id,g)}i.removeNode(d)}}return this._getServiceInstanceOrDescriptor(m)}_createServiceInstanceWithOwner(m,p,u=[],i,a){if(this._services.get(m)instanceof A.SyncDescriptor)return this._createServiceInstance(m,p,u,i,a,this._servicesToMaybeDispose);if(this._parent)return this._parent._createServiceInstanceWithOwner(m,p,u,i,a);throw new Error(`illegalState - creating UNKNOWN service instance ${p.name}`)}_createServiceInstance(m,p,u=[],i,a,t){if(i){const n=new f(void 0,this._strict,this,this._enableTracing);n._globalGraphImplicitDependency=String(m);const r=new Map,d=new s.GlobalIdleValue(()=>{const c=n._createInstance(p,u,a);for(const[g,w]of r){const y=c[g];if(typeof y=="function")for(const I of w)I.disposable=y.apply(c,I.listener)}return r.clear(),t.add(c),c});return new Proxy(Object.create(null),{get(c,g){if(!d.isInitialized&&typeof g=="string"&&(g.startsWith("onDid")||g.startsWith("onWill"))){let I=r.get(g);return I||(I=new l.LinkedList,r.set(g,I)),(k,b,E)=>{if(d.isInitialized)return d.value[g](k,b,E);{const N={listener:[k,b,E],disposable:void 0},O=I.push(N);return(0,D.toDisposable)(()=>{O(),N.disposable?.dispose()})}}}if(g in c)return c[g];const w=d.value;let y=w[g];return typeof y!="function"||(y=y.bind(w),c[g]=y),y},set(c,g,w){return d.value[g]=w,!0},getPrototypeOf(c){return p.prototype}})}else{const n=this._createInstance(p,u,a);return t.add(n),n}}_throwIfStrict(m,p){if(p&&console.warn(m),this._strict)throw new Error(m)}}e.InstantiationService=f;var T;(function(o){o[o.None=0]="None",o[o.Creation=1]="Creation",o[o.Invocation=2]="Invocation",o[o.Branch=3]="Branch"})(T||(T={}));class S{static{this.all=new Set}static{this._None=new class extends S{constructor(){super(T.None,null)}stop(){}branch(){return this}}}static traceInvocation(m,p){return m?new S(T.Invocation,p.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):S._None}static traceCreation(m,p){return m?new S(T.Creation,p.name):S._None}static{this._totals=0}constructor(m,p){this.type=m,this.name=p,this._start=Date.now(),this._dep=[]}branch(m,p){const u=new S(T.Branch,m.toString());return this._dep.push([m,p,u]),u}stop(){const m=Date.now()-this._start;S._totals+=m;let p=!1;function u(a,t){const n=[],r=new Array(a+1).join("	");for(const[d,c,g]of t._dep)if(c&&g){p=!0,n.push(`${r}CREATES -> ${d}`);const w=u(a+1,g);w&&n.push(w)}else n.push(`${r}uses -> ${d}`);return n.join(`
`)}const i=[`${this.type===T.Creation?"CREATE":"CALL"} ${this.name}`,`${u(1,this)}`,`DONE, took ${m.toFixed(2)}ms (grand total ${S._totals.toFixed(2)}ms)`];(m>2||p)&&S.all.add(i.join(`
`))}}e.Trace=S}),define(Pe[11],ke([1,0,7,52,4,61,3,28,10,22,17,2,36,5]),function(ge,e,s,h,D,A,L,R,v,l,C,_,f,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_LOG_LEVEL=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.MultiplexLogger=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.isLogLevel=o,e.log=p,e.getLogLevel=y,e.LogLevelToString=I,e.LogLevelToLocalizedString=P,e.parseLogLevel=k,s=We(s),e.ILogService=(0,T.createDecorator)("logService"),e.ILoggerService=(0,T.createDecorator)("loggerService");function S(){return new Date().toISOString()}function o(b){return(0,C.isNumber)(b)}var m;(function(b){b[b.Off=0]="Off",b[b.Trace=1]="Trace",b[b.Debug=2]="Debug",b[b.Info=3]="Info",b[b.Warning=4]="Warning",b[b.Error=5]="Error"})(m||(e.LogLevel=m={})),e.DEFAULT_LOG_LEVEL=m.Info;function p(b,E,N){switch(E){case m.Trace:b.trace(N);break;case m.Debug:b.debug(N);break;case m.Info:b.info(N);break;case m.Warning:b.warn(N);break;case m.Error:b.error(N);break;case m.Off:break;default:throw new Error(`Invalid log level ${E}`)}}function u(b,E=!1){let N="";for(let O=0;O<b.length;O++){let M=b[O];if(M instanceof Error&&(M=(0,h.toErrorMessage)(M,E)),typeof M=="object")try{M=JSON.stringify(M)}catch{}N+=(O>0?" ":"")+M}return N}class i extends L.Disposable{constructor(){super(...arguments),this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new D.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(E){this.level!==E&&(this.level=E,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}checkLogLevel(E){return this.level!==m.Off&&this.level<=E}}e.AbstractLogger=i;class a extends i{constructor(E){super(),this.logAlways=E}checkLogLevel(E){return this.logAlways||super.checkLogLevel(E)}trace(E,...N){this.checkLogLevel(m.Trace)&&this.log(m.Trace,u([E,...N],!0))}debug(E,...N){this.checkLogLevel(m.Debug)&&this.log(m.Debug,u([E,...N]))}info(E,...N){this.checkLogLevel(m.Info)&&this.log(m.Info,u([E,...N]))}warn(E,...N){this.checkLogLevel(m.Warning)&&this.log(m.Warning,u([E,...N]))}error(E,...N){if(this.checkLogLevel(m.Error))if(E instanceof Error){const O=Array.prototype.slice.call(arguments);O[0]=E.stack,this.log(m.Error,u(O))}else this.log(m.Error,u([E,...N]))}flush(){}}e.AbstractMessageLogger=a;class t extends i{constructor(E=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(E),this.useColors=!v.isWindows}trace(E,...N){this.checkLogLevel(m.Trace)&&(this.useColors?console.log(`\x1B[90m[main ${S()}]\x1B[0m`,E,...N):console.log(`[main ${S()}]`,E,...N))}debug(E,...N){this.checkLogLevel(m.Debug)&&(this.useColors?console.log(`\x1B[90m[main ${S()}]\x1B[0m`,E,...N):console.log(`[main ${S()}]`,E,...N))}info(E,...N){this.checkLogLevel(m.Info)&&(this.useColors?console.log(`\x1B[90m[main ${S()}]\x1B[0m`,E,...N):console.log(`[main ${S()}]`,E,...N))}warn(E,...N){this.checkLogLevel(m.Warning)&&(this.useColors?console.warn(`\x1B[93m[main ${S()}]\x1B[0m`,E,...N):console.warn(`[main ${S()}]`,E,...N))}error(E,...N){this.checkLogLevel(m.Error)&&(this.useColors?console.error(`\x1B[91m[main ${S()}]\x1B[0m`,E,...N):console.error(`[main ${S()}]`,E,...N))}flush(){}}e.ConsoleMainLogger=t;class n extends i{constructor(E=e.DEFAULT_LOG_LEVEL,N=!0){super(),this.useColors=N,this.setLevel(E)}trace(E,...N){this.checkLogLevel(m.Trace)&&(this.useColors?console.log("%cTRACE","color: #888",E,...N):console.log(E,...N))}debug(E,...N){this.checkLogLevel(m.Debug)&&(this.useColors?console.log("%cDEBUG","background: #eee; color: #888",E,...N):console.log(E,...N))}info(E,...N){this.checkLogLevel(m.Info)&&(this.useColors?console.log("%c INFO","color: #33f",E,...N):console.log(E,...N))}warn(E,...N){this.checkLogLevel(m.Warning)&&(this.useColors?console.log("%c WARN","color: #993",E,...N):console.log(E,...N))}error(E,...N){this.checkLogLevel(m.Error)&&(this.useColors?console.log("%c  ERR","color: #f33",E,...N):console.error(E,...N))}flush(){}}e.ConsoleLogger=n;class r extends i{constructor(E,N=e.DEFAULT_LOG_LEVEL){super(),this.adapter=E,this.setLevel(N)}trace(E,...N){this.checkLogLevel(m.Trace)&&this.adapter.log(m.Trace,[this.extractMessage(E),...N])}debug(E,...N){this.checkLogLevel(m.Debug)&&this.adapter.log(m.Debug,[this.extractMessage(E),...N])}info(E,...N){this.checkLogLevel(m.Info)&&this.adapter.log(m.Info,[this.extractMessage(E),...N])}warn(E,...N){this.checkLogLevel(m.Warning)&&this.adapter.log(m.Warning,[this.extractMessage(E),...N])}error(E,...N){this.checkLogLevel(m.Error)&&this.adapter.log(m.Error,[this.extractMessage(E),...N])}extractMessage(E){return typeof E=="string"?E:(0,h.toErrorMessage)(E,this.checkLogLevel(m.Trace))}flush(){}}e.AdapterLogger=r;class d extends i{constructor(E){super(),this.loggers=E,E.length&&this.setLevel(E[0].getLevel())}setLevel(E){for(const N of this.loggers)N.setLevel(E);super.setLevel(E)}trace(E,...N){for(const O of this.loggers)O.trace(E,...N)}debug(E,...N){for(const O of this.loggers)O.debug(E,...N)}info(E,...N){for(const O of this.loggers)O.info(E,...N)}warn(E,...N){for(const O of this.loggers)O.warn(E,...N)}error(E,...N){for(const O of this.loggers)O.error(E,...N)}flush(){for(const E of this.loggers)E.flush()}dispose(){for(const E of this.loggers)E.dispose();super.dispose()}}e.MultiplexLogger=d;class c extends L.Disposable{constructor(E,N,O){if(super(),this.logLevel=E,this.logsHome=N,this._loggers=new R.ResourceMap,this._onDidChangeLoggers=this._register(new D.Emitter),this.onDidChangeLoggers=this._onDidChangeLoggers.event,this._onDidChangeLogLevel=this._register(new D.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event,this._onDidChangeVisibility=this._register(new D.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,O)for(const M of O)this._loggers.set(M.resource,{logger:void 0,info:M})}getLoggerEntry(E){return(0,C.isString)(E)?[...this._loggers.values()].find(N=>N.info.id===E):this._loggers.get(E)}getLogger(E){return this.getLoggerEntry(E)?.logger}createLogger(E,N){const O=this.toResource(E),M=(0,C.isString)(E)?E:N?.id??(0,A.hash)(O.toString()).toString(16);let U=this._loggers.get(O)?.logger;const H=N?.logLevel==="always"?m.Trace:N?.logLevel;U||(U=this.doCreateLogger(O,H??this.getLogLevel(O)??this.logLevel,{...N,id:M}));const F={logger:U,info:{resource:O,id:M,logLevel:H,name:N?.name,hidden:N?.hidden,extensionId:N?.extensionId,when:N?.when}};return this.registerLogger(F.info),this._loggers.set(O,F),U}toResource(E){return(0,C.isString)(E)?(0,l.joinPath)(this.logsHome,`${E}.log`):E}setLogLevel(E,N){if(_.URI.isUri(E)){const O=E,M=N,U=this._loggers.get(O);U&&M!==U.info.logLevel&&(U.info.logLevel=M===this.logLevel?void 0:M,U.logger?.setLevel(M),this._loggers.set(U.info.resource,U),this._onDidChangeLogLevel.fire([O,M]))}else{this.logLevel=E;for(const[O,M]of this._loggers.entries())this._loggers.get(O)?.info.logLevel===void 0&&M.logger?.setLevel(this.logLevel);this._onDidChangeLogLevel.fire(this.logLevel)}}setVisibility(E,N){const O=this.getLoggerEntry(E);O&&N!==!O.info.hidden&&(O.info.hidden=!N,this._loggers.set(O.info.resource,O),this._onDidChangeVisibility.fire([O.info.resource,N]))}getLogLevel(E){let N;return E&&(N=this._loggers.get(E)?.info.logLevel),N??this.logLevel}registerLogger(E){const N=this._loggers.get(E.resource);N?N.info.hidden!==E.hidden&&this.setVisibility(E.resource,!E.hidden):(this._loggers.set(E.resource,{info:E,logger:void 0}),this._onDidChangeLoggers.fire({added:[E],removed:[]}))}deregisterLogger(E){const N=this._loggers.get(E);N&&(N.logger&&N.logger.dispose(),this._loggers.delete(E),this._onDidChangeLoggers.fire({added:[],removed:[N.info]}))}*getRegisteredLoggers(){for(const E of this._loggers.values())yield E.info}getRegisteredLogger(E){return this._loggers.get(E)?.info}dispose(){this._loggers.forEach(E=>E.logger?.dispose()),this._loggers.clear(),super.dispose()}}e.AbstractLoggerService=c;class g{constructor(){this.onDidChangeLogLevel=new D.Emitter().event}setLevel(E){}getLevel(){return m.Info}trace(E,...N){}debug(E,...N){}info(E,...N){}warn(E,...N){}error(E,...N){}critical(E,...N){}dispose(){}flush(){}}e.NullLogger=g;class w extends g{}e.NullLogService=w;function y(b){if(b.verbose)return m.Trace;if(typeof b.logLevel=="string"){const E=k(b.logLevel.toLowerCase());if(E!==void 0)return E}return e.DEFAULT_LOG_LEVEL}function I(b){switch(b){case m.Trace:return"trace";case m.Debug:return"debug";case m.Info:return"info";case m.Warning:return"warn";case m.Error:return"error";case m.Off:return"off"}}function P(b){switch(b){case m.Trace:return{original:"Trace",value:s.localize(1959,null)};case m.Debug:return{original:"Debug",value:s.localize(1960,null)};case m.Info:return{original:"Info",value:s.localize(1961,null)};case m.Warning:return{original:"Warning",value:s.localize(1962,null)};case m.Error:return{original:"Error",value:s.localize(1963,null)};case m.Off:return{original:"Off",value:s.localize(1964,null)}}}function k(b){switch(b){case"trace":return m.Trace;case"debug":return m.Debug;case"info":return m.Info;case"warn":return m.Warning;case"error":return m.Error;case"critical":return m.Error;case"off":return m.Off}}e.CONTEXT_LOG_LEVEL=new f.RawContextKey("logLevel",I(m.Info))}),define(Pe[229],ke([1,0,18,8,12,4,33,3,16,71,11]),function(ge,e,s,h,D,A,L,R,v,l,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class _ extends R.Disposable{constructor(T,S){super(),this.logService=T,this.options=S,this._onDidChangeFile=this._register(new A.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidWatchError=this._register(new A.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.universalWatchRequests=[],this.universalWatchRequestDelayer=this._register(new h.ThrottledDelayer(0)),this.nonRecursiveWatchRequests=[],this.nonRecursiveWatchRequestDelayer=this._register(new h.ThrottledDelayer(0))}watch(T,S){return S.recursive||this.options?.watcher?.forceUniversal?this.watchUniversal(T,S):this.watchNonRecursive(T,S)}watchUniversal(T,S){const o={path:this.toWatchPath(T),excludes:S.excludes,includes:S.includes,recursive:S.recursive,filter:S.filter,correlationId:S.correlationId},m=(0,s.insert)(this.universalWatchRequests,o);return this.refreshUniversalWatchers(),(0,R.toDisposable)(()=>{m(),this.refreshUniversalWatchers()})}refreshUniversalWatchers(){this.universalWatchRequestDelayer.trigger(()=>this.doRefreshUniversalWatchers()).catch(T=>(0,D.onUnexpectedError)(T))}doRefreshUniversalWatchers(){this.universalWatcher||(this.universalWatcher=this._register(this.createUniversalWatcher(S=>this._onDidChangeFile.fire((0,l.reviveFileChanges)(S)),S=>this.onWatcherLogMessage(S),this.logService.getLevel()===C.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.universalWatcher?.setVerboseLogging(this.logService.getLevel()===C.LogLevel.Trace)})));const T=this.options?.watcher?.recursive?.usePolling;if(T===!0)for(const S of this.universalWatchRequests)(0,l.isRecursiveWatchRequest)(S)&&(S.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(T))for(const S of this.universalWatchRequests)(0,l.isRecursiveWatchRequest)(S)&&T.includes(S.path)&&(S.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);return this.universalWatcher.watch(this.universalWatchRequests)}watchNonRecursive(T,S){const o={path:this.toWatchPath(T),excludes:S.excludes,includes:S.includes,recursive:!1,filter:S.filter,correlationId:S.correlationId},m=(0,s.insert)(this.nonRecursiveWatchRequests,o);return this.refreshNonRecursiveWatchers(),(0,R.toDisposable)(()=>{m(),this.refreshNonRecursiveWatchers()})}refreshNonRecursiveWatchers(){this.nonRecursiveWatchRequestDelayer.trigger(()=>this.doRefreshNonRecursiveWatchers()).catch(T=>(0,D.onUnexpectedError)(T))}doRefreshNonRecursiveWatchers(){return this.nonRecursiveWatcher||(this.nonRecursiveWatcher=this._register(this.createNonRecursiveWatcher(T=>this._onDidChangeFile.fire((0,l.reviveFileChanges)(T)),T=>this.onWatcherLogMessage(T),this.logService.getLevel()===C.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.nonRecursiveWatcher?.setVerboseLogging(this.logService.getLevel()===C.LogLevel.Trace)}))),this.nonRecursiveWatcher.watch(this.nonRecursiveWatchRequests)}onWatcherLogMessage(T){T.type==="error"&&this._onDidWatchError.fire(T.message),this.logWatcherMessage(T)}logWatcherMessage(T){this.logService[T.type](T.message)}toFilePath(T){return(0,v.normalize)(T.fsPath)}toWatchPath(T){const S=this.toFilePath(T);return(0,L.removeTrailingPathSeparator)(S)}}e.AbstractDiskFileSystemProvider=_}),define(Pe[230],ke([1,0,45,8,28,21,4,33,3,16,10,22,103,34,7,27,222,229,227,226]),function(ge,e,s,h,D,A,L,R,v,l,C,_,f,T,S,o,m,p,u,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0;class a extends p.AbstractDiskFileSystemProvider{static{this.TRACE_LOG_RESOURCE_LOCKS=!1}constructor(n,r){super(n,r),this.onDidChangeCapabilities=L.Event.None,this.resourceLocks=new D.ResourceMap(d=>_.extUriBiasedIgnorePathCase.getComparisonKey(d)),this.mapHandleToPos=new Map,this.mapHandleToLock=new Map,this.writeHandles=new Map}get capabilities(){return this._capabilities||(this._capabilities=o.FileSystemProviderCapabilities.FileReadWrite|o.FileSystemProviderCapabilities.FileOpenReadWriteClose|o.FileSystemProviderCapabilities.FileReadStream|o.FileSystemProviderCapabilities.FileFolderCopy|o.FileSystemProviderCapabilities.FileWriteUnlock|o.FileSystemProviderCapabilities.FileAtomicRead|o.FileSystemProviderCapabilities.FileAtomicWrite|o.FileSystemProviderCapabilities.FileAtomicDelete|o.FileSystemProviderCapabilities.FileClone,C.isLinux&&(this._capabilities|=o.FileSystemProviderCapabilities.PathCaseSensitive)),this._capabilities}async stat(n){try{const{stat:r,symbolicLink:d}=await T.SymlinkSupport.stat(this.toFilePath(n));return{type:this.toType(r,d),ctime:r.birthtime.getTime(),mtime:r.mtime.getTime(),size:r.size,permissions:r.mode&128?void 0:o.FilePermission.Locked}}catch(r){throw this.toFileSystemProviderError(r)}}async statIgnoreError(n){try{return await this.stat(n)}catch{return}}async readdir(n){try{const r=await T.Promises.readdir(this.toFilePath(n),{withFileTypes:!0}),d=[];return await Promise.all(r.map(async c=>{try{let g;c.isSymbolicLink()?g=(await this.stat((0,_.joinPath)(n,c.name))).type:g=this.toType(c),d.push([c.name,g])}catch(g){this.logService.trace(g)}})),d}catch(r){throw this.toFileSystemProviderError(r)}}toType(n,r){let d;return r?.dangling?d=o.FileType.Unknown:n.isFile()?d=o.FileType.File:n.isDirectory()?d=o.FileType.Directory:d=o.FileType.Unknown,r&&(d|=o.FileType.SymbolicLink),d}async createResourceLock(n){const r=this.toFilePath(n);this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${r})`);let d;for(;d=this.resourceLocks.get(n);)this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${r})`),await d.wait();const c=new h.Barrier;return this.resourceLocks.set(n,c),this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${r})`),(0,v.toDisposable)(()=>{this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${r})`),this.resourceLocks.get(n)===c&&(this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${r})`),this.resourceLocks.delete(n)),this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${r})`),c.open()})}async readFile(n,r){let d;try{r?.atomic&&(this.traceLock(`[Disk FileSystemProvider]: atomic read operation started (${this.toFilePath(n)})`),d=await this.createResourceLock(n));const c=this.toFilePath(n);return await s.promises.readFile(c)}catch(c){throw this.toFileSystemProviderError(c)}finally{d?.dispose()}}traceLock(n){a.TRACE_LOG_RESOURCE_LOCKS&&this.logService.trace(n)}readFileStream(n,r,d){const c=(0,f.newWriteableStream)(g=>A.VSBuffer.concat(g.map(w=>A.VSBuffer.wrap(w))).buffer);return(0,m.readFileIntoStream)(this,n,c,g=>g.buffer,{...r,bufferSize:256*1024},d),c}async writeFile(n,r,d){return d?.atomic!==!1&&d?.atomic?.postfix&&await this.canWriteFileAtomic(n)?this.doWriteFileAtomic(n,(0,_.joinPath)((0,_.dirname)(n),`${(0,_.basename)(n)}${d.atomic.postfix}`),r,d):this.doWriteFile(n,r,d)}async canWriteFileAtomic(n){try{const r=this.toFilePath(n),{symbolicLink:d}=await T.SymlinkSupport.stat(r);if(d)return!1}catch{}return!0}async doWriteFileAtomic(n,r,d,c){const g=new v.DisposableStore;try{g.add(await this.createResourceLock(n)),g.add(await this.createResourceLock(r)),await this.doWriteFile(r,d,c,!0);try{await this.rename(r,n,{overwrite:!0})}catch(w){try{await this.delete(r,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw w}}finally{g.dispose()}}async doWriteFile(n,r,d,c){let g;try{const w=this.toFilePath(n);if(!d.create||!d.overwrite){if(await T.Promises.exists(w)){if(!d.overwrite)throw(0,o.createFileSystemProviderError)((0,S.localize)(1901,null),o.FileSystemProviderErrorCode.FileExists)}else if(!d.create)throw(0,o.createFileSystemProviderError)((0,S.localize)(1902,null),o.FileSystemProviderErrorCode.FileNotFound)}g=await this.open(n,{create:!0,unlock:d.unlock},c),await this.write(g,0,r,0,r.byteLength)}catch(w){throw await this.toFileSystemProviderWriteError(n,w)}finally{typeof g=="number"&&await this.close(g)}}static{this.canFlush=!0}static configureFlushOnWrite(n){a.canFlush=n}async open(n,r,d){const c=this.toFilePath(n);let g;(0,o.isFileOpenForWriteOptions)(r)&&!d&&(g=await this.createResourceLock(n));let w;try{if((0,o.isFileOpenForWriteOptions)(r)&&r.unlock)try{const{stat:I}=await T.SymlinkSupport.stat(c);I.mode&128||await s.promises.chmod(c,I.mode|128)}catch(I){I.code!=="ENOENT"&&this.logService.trace(I)}let y;if((0,o.isFileOpenForWriteOptions)(r)){if(C.isWindows)try{await s.promises.truncate(c,0),y="r+"}catch(I){I.code!=="ENOENT"&&this.logService.trace(I)}y||(y="w")}else y="r";w=await T.Promises.open(c,y)}catch(y){throw g?.dispose(),(0,o.isFileOpenForWriteOptions)(r)?await this.toFileSystemProviderWriteError(n,y):this.toFileSystemProviderError(y)}if(this.mapHandleToPos.set(w,0),(0,o.isFileOpenForWriteOptions)(r)&&this.writeHandles.set(w,n),g){const y=this.mapHandleToLock.get(w);this.traceLock(`[Disk FileSystemProvider]: open() - storing lock for handle ${w} (${c})`),this.mapHandleToLock.set(w,g),y&&(this.traceLock(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${w} (${c})`),y.dispose())}return w}async close(n){const r=this.mapHandleToLock.get(n);try{if(this.mapHandleToPos.delete(n),this.writeHandles.delete(n)&&a.canFlush)try{await T.Promises.fdatasync(n)}catch(d){a.configureFlushOnWrite(!1),this.logService.error(d)}return await T.Promises.close(n)}catch(d){throw this.toFileSystemProviderError(d)}finally{r&&(this.mapHandleToLock.get(n)===r&&(this.traceLock(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${n}`),this.mapHandleToLock.delete(n)),this.traceLock(`[Disk FileSystemProvider]: close() - disposing lock for handle ${n}`),r.dispose())}}async read(n,r,d,c,g){const w=this.normalizePos(n,r);let y=null;try{y=(await T.Promises.read(n,d,c,g,w)).bytesRead}catch(I){throw this.toFileSystemProviderError(I)}finally{this.updatePos(n,w,y)}return y}normalizePos(n,r){return r===this.mapHandleToPos.get(n)?null:r}updatePos(n,r,d){const c=this.mapHandleToPos.get(n);typeof c=="number"&&(typeof r=="number"||(typeof d=="number"?this.mapHandleToPos.set(n,c+d):this.mapHandleToPos.delete(n)))}async write(n,r,d,c,g){return(0,h.retry)(()=>this.doWrite(n,r,d,c,g),100,3)}async doWrite(n,r,d,c,g){const w=this.normalizePos(n,r);let y=null;try{y=(await T.Promises.write(n,d,c,g,w)).bytesWritten}catch(I){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(n),I)}finally{this.updatePos(n,w,y)}return y}async mkdir(n){try{await s.promises.mkdir(this.toFilePath(n))}catch(r){throw this.toFileSystemProviderError(r)}}async delete(n,r){try{const d=this.toFilePath(n);if(r.recursive){let c;r?.atomic!==!1&&r.atomic.postfix&&(c=(0,l.join)((0,l.dirname)(d),`${(0,l.basename)(d)}${r.atomic.postfix}`)),await T.Promises.rm(d,T.RimRafMode.MOVE,c)}else try{await s.promises.unlink(d)}catch(c){if(c.code==="EPERM"||c.code==="EISDIR"){let g=!1;try{const{stat:w,symbolicLink:y}=await T.SymlinkSupport.stat(d);g=w.isDirectory()&&!y}catch{}if(g)await s.promises.rmdir(d);else throw c}else throw c}}catch(d){throw this.toFileSystemProviderError(d)}}async rename(n,r,d){const c=this.toFilePath(n),g=this.toFilePath(r);if(c!==g)try{await this.validateMoveCopy(n,r,"move",d.overwrite),await T.Promises.rename(c,g)}catch(w){throw(w.code==="EINVAL"||w.code==="EBUSY"||w.code==="ENAMETOOLONG")&&(w=new Error((0,S.localize)(1903,null,(0,l.basename)(c),(0,l.basename)((0,l.dirname)(g)),w.toString()))),this.toFileSystemProviderError(w)}}async copy(n,r,d){const c=this.toFilePath(n),g=this.toFilePath(r);if(c!==g)try{await this.validateMoveCopy(n,r,"copy",d.overwrite),await T.Promises.copy(c,g,{preserveSymlinks:!0})}catch(w){throw(w.code==="EINVAL"||w.code==="EBUSY"||w.code==="ENAMETOOLONG")&&(w=new Error((0,S.localize)(1904,null,(0,l.basename)(c),(0,l.basename)((0,l.dirname)(g)),w.toString()))),this.toFileSystemProviderError(w)}}async validateMoveCopy(n,r,d,c){const g=this.toFilePath(n),w=this.toFilePath(r);let y=!1;if(!!(this.capabilities&o.FileSystemProviderCapabilities.PathCaseSensitive)||(y=(0,R.isEqual)(g,w,!0)),y){if(d==="copy")throw(0,o.createFileSystemProviderError)((0,S.localize)(1905,null),o.FileSystemProviderErrorCode.FileExists);if(d==="move")return}const P=await this.statIgnoreError(n);if(!P)throw(0,o.createFileSystemProviderError)((0,S.localize)(1906,null),o.FileSystemProviderErrorCode.FileNotFound);const k=await this.statIgnoreError(r);if(k){if(!c)throw(0,o.createFileSystemProviderError)((0,S.localize)(1907,null),o.FileSystemProviderErrorCode.FileExists);P.type&o.FileType.File&&k.type&o.FileType.File||await this.delete(r,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(n,r){return this.doCloneFile(n,r,!1)}async doCloneFile(n,r,d){const c=this.toFilePath(n),g=this.toFilePath(r),w=!!(this.capabilities&o.FileSystemProviderCapabilities.PathCaseSensitive);if((0,R.isEqual)(c,g,!w))return;const y=new v.DisposableStore;try{y.add(await this.createResourceLock(n)),y.add(await this.createResourceLock(r)),d&&await s.promises.mkdir((0,l.dirname)(g),{recursive:!0}),await s.promises.copyFile(c,g)}catch(I){if(I.code==="ENOENT"&&!d)return this.doCloneFile(n,r,!0);throw this.toFileSystemProviderError(I)}finally{y.dispose()}}createUniversalWatcher(n,r,d){return new u.UniversalWatcherClient(c=>n(c),c=>r(c),d)}createNonRecursiveWatcher(n,r,d){return new i.NodeJSWatcherClient(c=>n(c),c=>r(c),d)}toFileSystemProviderError(n){if(n instanceof o.FileSystemProviderError)return n;let r=n,d;switch(n.code){case"ENOENT":d=o.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":d=o.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":d=o.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":d=o.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":d=o.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":r=`${n.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,d=o.FileSystemProviderErrorCode.Unknown;break;default:d=o.FileSystemProviderErrorCode.Unknown}return(0,o.createFileSystemProviderError)(r,d)}async toFileSystemProviderWriteError(n,r){let d=this.toFileSystemProviderError(r);if(n&&d.code===o.FileSystemProviderErrorCode.NoPermissions)try{const{stat:c}=await T.SymlinkSupport.stat(this.toFilePath(n));c.mode&128||(d=(0,o.createFileSystemProviderError)(r,o.FileSystemProviderErrorCode.FileWriteLocked))}catch(c){this.logService.trace(c)}return d}}e.DiskFileSystemProvider=a}),define(Pe[231],ke([1,0,3,11]),function(ge,e,s,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogService=void 0;class D extends s.Disposable{constructor(L,R=[]){super(),this.logger=new h.MultiplexLogger([L,...R]),this._register(L.onDidChangeLogLevel(v=>this.setLevel(v)))}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(L){this.logger.setLevel(L)}getLevel(){return this.logger.getLevel()}trace(L,...R){this.logger.trace(L,...R)}debug(L,...R){this.logger.debug(L,...R)}info(L,...R){this.logger.info(L,...R)}warn(L,...R){this.logger.warn(L,...R)}error(L,...R){this.logger.error(L,...R)}flush(){this.logger.flush()}}e.LogService=D}),define(Pe[232],ke([1,0,27,11]),function(ge,e,s,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;var D;(function(l){l[l.Trace=0]="Trace",l[l.Debug=1]="Debug",l[l.Info=2]="Info",l[l.Warning=3]="Warning",l[l.Error=4]="Error",l[l.Critical=5]="Critical",l[l.Off=6]="Off"})(D||(D={}));async function A(l,C,_,f,T){try{const S=await new Promise((m,p)=>{ge(["@vscode/spdlog"],m,p)}).then(We);S.setFlushOn(D.Trace);const o=await S.createAsyncRotatingLogger(l,C,_,f);return T?o.clearFormatters():o.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),o}catch(S){console.error(S)}return null}function L(l,C,_){switch(C){case h.LogLevel.Trace:l.trace(_);break;case h.LogLevel.Debug:l.debug(_);break;case h.LogLevel.Info:l.info(_);break;case h.LogLevel.Warning:l.warn(_);break;case h.LogLevel.Error:l.error(_);break;case h.LogLevel.Off:break;default:throw new Error(`Invalid log level ${C}`)}}function R(l,C){switch(C){case h.LogLevel.Trace:l.setLevel(D.Trace);break;case h.LogLevel.Debug:l.setLevel(D.Debug);break;case h.LogLevel.Info:l.setLevel(D.Info);break;case h.LogLevel.Warning:l.setLevel(D.Warning);break;case h.LogLevel.Error:l.setLevel(D.Error);break;case h.LogLevel.Off:l.setLevel(D.Off);break;default:throw new Error(`Invalid log level ${C}`)}}class v extends h.AbstractMessageLogger{constructor(C,_,f,T,S){super(),this.buffer=[],this.setLevel(S),this._loggerCreationPromise=this._createSpdLogLogger(C,_,f,T),this._register(this.onDidChangeLogLevel(o=>{this._logger&&R(this._logger,o)}))}async _createSpdLogLogger(C,_,f,T){const S=f?6:1,o=30/S*s.ByteSize.MB,m=await A(C,_,o,S,T);if(m){this._logger=m,R(this._logger,this.getLevel());for(const{level:p,message:u}of this.buffer)L(this._logger,p,u);this.buffer=[]}}log(C,_){this._logger?L(this._logger,C,_):this.getLevel()<=C&&this.buffer.push({level:C,message:_})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger()),super.dispose()}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=v});var Vt=this&&this.__importDefault||function(ge){return ge&&ge.__esModule?ge:{default:ge}};define(Pe[149],ke([1,0,44,7,5]),function(ge,e,s,h,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0,s=Vt(s);var A;(function(v){v[v.Unnecessary=1]="Unnecessary",v[v.Deprecated=2]="Deprecated"})(A||(e.MarkerTag=A={}));var L;(function(v){v[v.Hint=1]="Hint",v[v.Info=2]="Info",v[v.Warning=4]="Warning",v[v.Error=8]="Error"})(L||(e.MarkerSeverity=L={})),function(v){function l(S,o){return o-S}v.compare=l;const C=Object.create(null);C[v.Error]=(0,h.localize)(1965,null),C[v.Warning]=(0,h.localize)(1966,null),C[v.Info]=(0,h.localize)(1967,null);function _(S){return C[S]||""}v.toString=_;function f(S){switch(S){case s.default.Error:return v.Error;case s.default.Warning:return v.Warning;case s.default.Info:return v.Info;case s.default.Ignore:return v.Hint}}v.fromSeverity=f;function T(S){switch(S){case v.Error:return s.default.Error;case v.Warning:return s.default.Warning;case v.Info:return s.default.Info;case v.Hint:return s.default.Ignore}}v.toSeverity=T}(L||(e.MarkerSeverity=L={}));var R;(function(v){const l="";function C(f){return _(f,!0)}v.makeKey=C;function _(f,T){const S=[l];return f.source?S.push(f.source.replace("\xA6","\\\xA6")):S.push(l),f.code?typeof f.code=="string"?S.push(f.code.replace("\xA6","\\\xA6")):S.push(f.code.value.replace("\xA6","\\\xA6")):S.push(l),f.severity!==void 0&&f.severity!==null?S.push(L.toString(f.severity)):S.push(l),f.message&&T?S.push(f.message.replace("\xA6","\\\xA6")):S.push(l),f.startLineNumber!==void 0&&f.startLineNumber!==null?S.push(f.startLineNumber.toString()):S.push(l),f.startColumn!==void 0&&f.startColumn!==null?S.push(f.startColumn.toString()):S.push(l),f.endLineNumber!==void 0&&f.endLineNumber!==null?S.push(f.endLineNumber.toString()):S.push(l),f.endColumn!==void 0&&f.endColumn!==null?S.push(f.endColumn.toString()):S.push(l),S.push(l),S.join("\xA6")}v.makeKeyOptionalMessage=_})(R||(e.IMarkerData=R={})),e.IMarkerService=(0,D.createDecorator)("markerService")});var Vt=this&&this.__importDefault||function(ge){return ge&&ge.__esModule?ge:{default:ge}};define(Pe[233],ke([1,0,4,44,5]),function(ge,e,s,h,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.INotificationService=e.Severity=void 0,e.isNotificationSource=R,h=Vt(h),e.Severity=h.default,e.INotificationService=(0,D.createDecorator)("notificationService");var A;(function(_){_[_.DEFAULT=0]="DEFAULT",_[_.SILENT=1]="SILENT",_[_.URGENT=2]="URGENT"})(A||(e.NotificationPriority=A={}));var L;(function(_){_[_.WORKSPACE=0]="WORKSPACE",_[_.PROFILE=1]="PROFILE",_[_.APPLICATION=2]="APPLICATION"})(L||(e.NeverShowAgainScope=L={}));function R(_){if(_){const f=_;return typeof f.id=="string"&&typeof f.label=="string"}return!1}var v;(function(_){_[_.OFF=0]="OFF",_[_.ERROR=1]="ERROR"})(v||(e.NotificationsFilter=v={}));class l{constructor(){this.progress=new C,this.onDidClose=s.Event.None,this.onDidChangeVisibility=s.Event.None}updateSeverity(f){}updateMessage(f){}updateActions(f){}close(){}}e.NoOpNotification=l;class C{infinite(){}done(){}total(f){}worked(f){}}e.NoOpProgress=C}),define(Pe[234],ke([1,0,57]),function(ge,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let h;const D=globalThis.vscode;if(typeof D<"u"&&typeof D.context<"u"){const A=D.context.configuration();if(A)h=A.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){h=globalThis._VSCODE_PRODUCT_JSON;const{serviceUrl:A,searchUrl:L,itemUrl:R,controlUrl:v}=h.extensionsGallery||{};Object.assign(h,{extensionsGallery:{serviceUrl:s.env.VSCODE_GALLERY_SERVICE_URL||A,searchUrl:s.env.VSCODE_GALLERY_SEARCH_URL||L,itemUrl:s.env.VSCODE_GALLERY_ITEM_URL||R,controlUrl:s.env.VSCODE_GALLERY_CONTROL_URL||v}});try{const l=(..._)=>_.reduce((f,T)=>(Object.keys(T).forEach(S=>{Array.isArray(f[S])&&Array.isArray(T[S])?f[S]=T[S]:typeof f[S]=="object"&&typeof T[S]=="object"?f[S]=l(f[S],T[S]):f[S]=T[S]}),f),{}),C=globalThis._VSCODE_USER_PRODUCT_JSON||{};h=l(h,C)}catch{}if(s.env.VSCODE_DEV&&Object.assign(h,{nameShort:`${h.nameShort} Dev`,nameLong:`${h.nameLong} Dev`,dataFolderName:`${h.dataFolderName}-dev`,serverDataFolderName:h.serverDataFolderName?`${h.serverDataFolderName}-dev`:void 0}),!h.version){const l=globalThis._VSCODE_PACKAGE_JSON;Object.assign(h,{version:l.version,release:l.release})}}else h={},Object.keys(h).length===0&&Object.assign(h,{version:"1.91.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=h}),define(Pe[115],ke([1,0,5]),function(ge,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,s.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"});var $e=this&&this.__param||function(ge,e){return function(s,h){e(s,h,ge)}};define(Pe[90],ke([1,0,8,20,3,5]),function(ge,e,s,h,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.AsyncProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,A.createDecorator)("progressService");var L;(function(_){_[_.Explorer=1]="Explorer",_[_.Scm=3]="Scm",_[_.Extensions=5]="Extensions",_[_.Window=10]="Window",_[_.Notification=15]="Notification",_[_.Dialog=20]="Dialog"})(L||(e.ProgressLocation=L={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class R{static{this.None=Object.freeze({report(){}})}get value(){return this._value}constructor(f){this.callback=f}report(f){this._value=f,this.callback(this._value)}}e.Progress=R;class v{get value(){return this._value}constructor(f){this.callback=f}report(f){this._asyncQueue?this._asyncQueue.push(f):this._asyncQueue=[f],this._processAsyncQueue()}async _processAsyncQueue(){if(!this._processingAsyncQueue)try{for(this._processingAsyncQueue=!0;this._asyncQueue&&this._asyncQueue.length;){const f=this._asyncQueue.shift();this._value=f,await this.callback(this._value)}}finally{this._processingAsyncQueue=!1;const f=this._drainListener;this._drainListener=void 0,f?.()}}drain(){return this._processingAsyncQueue?new Promise(f=>{const T=this._drainListener;this._drainListener=()=>{T?.(),f()}}):Promise.resolve()}}e.AsyncProgress=v;let l=class extends D.Disposable{constructor(f,T){super(),this.deferred=new s.DeferredPromise,T.withProgress(f,S=>(this.reporter=S,this.lastStep&&S.report(this.lastStep),this.deferred.p)),this._register((0,D.toDisposable)(()=>this.deferred.complete()))}report(f){this.reporter?this.reporter.report(f):this.lastStep=f}};e.UnmanagedProgress=l,e.UnmanagedProgress=l=Qe([$e(1,e.IProgressService)],l);class C extends D.Disposable{constructor(f){super(),this.progressIndicator=f,this.currentOperationId=0,this.currentOperationDisposables=this._register(new D.DisposableStore)}start(f){this.stop();const T=++this.currentOperationId,S=new h.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{T===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},f),this.currentOperationDisposables.add((0,D.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,D.toDisposable)(()=>S.cancel())),this.currentOperationDisposables.add((0,D.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:T,token:S.token,stop:()=>this.doStop(T),isCurrent:()=>this.currentOperationId===T}}stop(){this.doStop(this.currentOperationId)}doStop(f){this.currentOperationId===f&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=C,e.IEditorProgressService=(0,A.createDecorator)("editorProgressService")}),define(Pe[37],ke([1,0,67,17]),function(ge,e,s,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0,s=We(s),h=We(h);class D{constructor(){this.data=new Map}add(L,R){s.ok(h.isString(L)),s.ok(h.isObject(R)),s.ok(!this.data.has(L),"There is already an extension with this id"),this.data.set(L,R)}knows(L){return this.data.has(L)}as(L){return this.data.get(L)||null}}e.Registry=new D}),define(Pe[116],ke([1,0,4,181,37]),function(ge,e,s,h,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,D=We(D),e.Extensions={JSONContribution:"base.contributions.json"};function A(v){return v.length>0&&v.charAt(v.length-1)==="#"?v.substring(0,v.length-1):v}class L{constructor(){this._onDidChangeSchema=new s.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(l,C){this.schemasById[A(l)]=C,this._onDidChangeSchema.fire(l)}notifySchemaChanged(l){this._onDidChangeSchema.fire(l)}getSchemaContributions(){return{schemas:this.schemasById}}getSchemaContent(l){const C=this.schemasById[l];return C?(0,h.getCompressedContent)(C):void 0}hasSchemaContent(l){return!!this.schemasById[l]}}const R=new L;D.Registry.add(e.Extensions.JSONContribution,R)}),define(Pe[72],ke([1,0,18,4,17,7,46,116,37]),function(ge,e,s,h,D,A,L,R,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0,e.overrideIdentifiersFromKey=o,e.keyFromOverrideIdentifiers=m,e.getDefaultValue=p,e.validateProperty=i,e.getScopes=a,e.getAllConfigurationProperties=t,e.parseScope=n,D=We(D),A=We(A);var l;(function(r){r.Multiline="multilineText",r.Singleline="singlelineText"})(l||(e.EditPresentationTypes=l={})),e.Extensions={Configuration:"base.contributions.configuration"};var C;(function(r){r[r.APPLICATION=1]="APPLICATION",r[r.MACHINE=2]="MACHINE",r[r.WINDOW=3]="WINDOW",r[r.RESOURCE=4]="RESOURCE",r[r.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",r[r.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(C||(e.ConfigurationScope=C={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const _=v.Registry.as(R.Extensions.JSONContribution);class f{constructor(){this.registeredConfigurationDefaults=[],this.overrideIdentifiers=new Set,this._onDidSchemaChange=new h.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new h.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:A.localize(1662,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.policyConfigurations=new Map,this.excludedConfigurationProperties={},_.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(d,c=!0){this.registerConfigurations([d],c)}registerConfigurations(d,c=!0){const g=new Set;this.doRegisterConfigurations(d,c,g),_.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:g})}deregisterConfigurations(d){const c=new Set;this.doDeregisterConfigurations(d,c),_.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:c})}updateConfigurations({add:d,remove:c}){const g=new Set;this.doDeregisterConfigurations(c,g),this.doRegisterConfigurations(d,!1,g),_.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:g})}registerDefaultConfigurations(d){const c=new Set;this.doRegisterDefaultConfigurations(d,c),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:c,defaultsOverrides:!0})}doRegisterDefaultConfigurations(d,c){this.registeredConfigurationDefaults.push(...d);const g=[];for(const{overrides:w,source:y}of d)for(const I in w){c.add(I);const P=this.configurationDefaultsOverrides.get(I)??this.configurationDefaultsOverrides.set(I,{configurationDefaultOverrides:[]}).get(I),k=w[I];if(P.configurationDefaultOverrides.push({value:k,source:y}),e.OVERRIDE_PROPERTY_REGEX.test(I)){const b=this.mergeDefaultConfigurationsForOverrideIdentifier(I,k,y,P.configurationDefaultOverrideValue);if(!b)continue;P.configurationDefaultOverrideValue=b,this.updateDefaultOverrideProperty(I,b,y),g.push(...o(I))}else{const b=this.mergeDefaultConfigurationsForConfigurationProperty(I,k,y,P.configurationDefaultOverrideValue);if(!b)continue;P.configurationDefaultOverrideValue=b;const E=this.configurationProperties[I];E&&(this.updatePropertyDefaultValue(I,E),this.updateSchema(I,E))}}this.doRegisterOverrideIdentifiers(g)}deregisterDefaultConfigurations(d){const c=new Set;this.doDeregisterDefaultConfigurations(d,c),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:c,defaultsOverrides:!0})}doDeregisterDefaultConfigurations(d,c){for(const g of d){const w=this.registeredConfigurationDefaults.indexOf(g);w!==-1&&this.registeredConfigurationDefaults.splice(w,1)}for(const{overrides:g,source:w}of d)for(const y in g){const I=this.configurationDefaultsOverrides.get(y);if(!I)continue;const P=I.configurationDefaultOverrides.findIndex(k=>w?k.source?.id===w.id:k.value===g[y]);if(P!==-1){if(I.configurationDefaultOverrides.splice(P,1),I.configurationDefaultOverrides.length===0&&this.configurationDefaultsOverrides.delete(y),e.OVERRIDE_PROPERTY_REGEX.test(y)){let k;for(const b of I.configurationDefaultOverrides)k=this.mergeDefaultConfigurationsForOverrideIdentifier(y,b.value,b.source,k);k&&!D.isEmptyObject(k.value)?(I.configurationDefaultOverrideValue=k,this.updateDefaultOverrideProperty(y,k,w)):(this.configurationDefaultsOverrides.delete(y),delete this.configurationProperties[y],delete this.defaultLanguageConfigurationOverridesNode.properties[y])}else{let k;for(const E of I.configurationDefaultOverrides)k=this.mergeDefaultConfigurationsForConfigurationProperty(y,E.value,E.source,k);I.configurationDefaultOverrideValue=k;const b=this.configurationProperties[y];b&&(this.updatePropertyDefaultValue(y,b),this.updateSchema(y,b))}c.add(y)}}this.updateOverridePropertyPatternKey()}updateDefaultOverrideProperty(d,c,g){const w={type:"object",default:c.value,description:A.localize(1663,null,(0,L.getLanguageTagSettingPlainKey)(d)),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:c.value,source:g,defaultValueSource:g};this.configurationProperties[d]=w,this.defaultLanguageConfigurationOverridesNode.properties[d]=w}mergeDefaultConfigurationsForOverrideIdentifier(d,c,g,w){const y=w?.value||{},I=w?.source??new Map;if(!(I instanceof Map)){console.error("objectConfigurationSources is not a Map");return}for(const P of Object.keys(c)){const k=c[P];if(D.isObject(k)&&(D.isUndefined(y[P])||D.isObject(y[P]))){if(y[P]={...y[P]??{},...k},g)for(const E in k)I.set(`${P}.${E}`,g)}else y[P]=k,g?I.set(P,g):I.delete(P)}return{value:y,source:I}}mergeDefaultConfigurationsForConfigurationProperty(d,c,g,w){const y=this.configurationProperties[d],I=w?.value??y?.defaultDefaultValue;let P=g;if(D.isObject(c)&&(y!==void 0&&y.type==="object"||y===void 0&&(D.isUndefined(I)||D.isObject(I)))){if(P=w?.source??new Map,!(P instanceof Map)){console.error("defaultValueSource is not a Map");return}for(const b in c)g&&P.set(`${d}.${b}`,g);c={...D.isObject(I)?I:{},...c}}return{value:c,source:P}}deltaConfiguration(d){let c=!1;const g=new Set;d.removedDefaults&&(this.doDeregisterDefaultConfigurations(d.removedDefaults,g),c=!0),d.addedDefaults&&(this.doRegisterDefaultConfigurations(d.addedDefaults,g),c=!0),d.removedConfigurations&&this.doDeregisterConfigurations(d.removedConfigurations,g),d.addedConfigurations&&this.doRegisterConfigurations(d.addedConfigurations,!1,g),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:g,defaultsOverrides:c})}notifyConfigurationSchemaUpdated(...d){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(d){this.doRegisterOverrideIdentifiers(d),this._onDidSchemaChange.fire()}doRegisterOverrideIdentifiers(d){for(const c of d)this.overrideIdentifiers.add(c);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(d,c,g){d.forEach(w=>{this.validateAndRegisterProperties(w,c,w.extensionInfo,w.restrictedProperties,void 0,g),this.configurationContributors.push(w),this.registerJSONConfiguration(w)})}doDeregisterConfigurations(d,c){const g=w=>{if(w.properties)for(const y in w.properties){c.add(y);const I=this.configurationProperties[y];I?.policy?.name&&this.policyConfigurations.delete(I.policy.name),delete this.configurationProperties[y],this.removeFromSchema(y,w.properties[y])}w.allOf?.forEach(y=>g(y))};for(const w of d){g(w);const y=this.configurationContributors.indexOf(w);y!==-1&&this.configurationContributors.splice(y,1)}}validateAndRegisterProperties(d,c=!0,g,w,y=C.WINDOW,I){y=D.isUndefinedOrNull(d.scope)?y:d.scope;const P=d.properties;if(P)for(const b in P){const E=P[b];if(c&&i(b,E)){delete P[b];continue}if(E.source=g,E.defaultDefaultValue=P[b].default,this.updatePropertyDefaultValue(b,E),e.OVERRIDE_PROPERTY_REGEX.test(b)?E.scope=void 0:(E.scope=D.isUndefinedOrNull(E.scope)?y:E.scope,E.restricted=D.isUndefinedOrNull(E.restricted)?!!w?.includes(b):E.restricted),P[b].hasOwnProperty("included")&&!P[b].included){this.excludedConfigurationProperties[b]=P[b],delete P[b];continue}else this.configurationProperties[b]=P[b],P[b].policy?.name&&this.policyConfigurations.set(P[b].policy.name,b);!P[b].deprecationMessage&&P[b].markdownDeprecationMessage&&(P[b].deprecationMessage=P[b].markdownDeprecationMessage),I.add(b)}const k=d.allOf;if(k)for(const b of k)this.validateAndRegisterProperties(b,c,g,w,y,I)}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getPolicyConfigurations(){return this.policyConfigurations}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getRegisteredDefaultConfigurations(){return[...this.registeredConfigurationDefaults]}getConfigurationDefaultsOverrides(){const d=new Map;for(const[c,g]of this.configurationDefaultsOverrides)g.configurationDefaultOverrideValue&&d.set(c,g.configurationDefaultOverrideValue);return d}registerJSONConfiguration(d){const c=g=>{const w=g.properties;if(w)for(const I in w)this.updateSchema(I,w[I]);g.allOf?.forEach(c)};c(d)}updateSchema(d,c){switch(e.allSettings.properties[d]=c,c.scope){case C.APPLICATION:e.applicationSettings.properties[d]=c;break;case C.MACHINE:e.machineSettings.properties[d]=c;break;case C.MACHINE_OVERRIDABLE:e.machineOverridableSettings.properties[d]=c;break;case C.WINDOW:e.windowSettings.properties[d]=c;break;case C.RESOURCE:e.resourceSettings.properties[d]=c;break;case C.LANGUAGE_OVERRIDABLE:e.resourceSettings.properties[d]=c,this.resourceLanguageSettingsSchema.properties[d]=c;break}}removeFromSchema(d,c){switch(delete e.allSettings.properties[d],c.scope){case C.APPLICATION:delete e.applicationSettings.properties[d];break;case C.MACHINE:delete e.machineSettings.properties[d];break;case C.MACHINE_OVERRIDABLE:delete e.machineOverridableSettings.properties[d];break;case C.WINDOW:delete e.windowSettings.properties[d];break;case C.RESOURCE:case C.LANGUAGE_OVERRIDABLE:delete e.resourceSettings.properties[d],delete this.resourceLanguageSettingsSchema.properties[d];break}}updateOverridePropertyPatternKey(){for(const d of this.overrideIdentifiers.values()){const c=`[${d}]`,g={type:"object",description:A.localize(1664,null),errorMessage:A.localize(1665,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(c,g),e.allSettings.properties[c]=g,e.applicationSettings.properties[c]=g,e.machineSettings.properties[c]=g,e.machineOverridableSettings.properties[c]=g,e.windowSettings.properties[c]=g,e.resourceSettings.properties[c]=g}}registerOverridePropertyPatternKey(){const d={type:"object",description:A.localize(1666,null),errorMessage:A.localize(1667,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=d,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=d,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=d,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=d,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=d,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=d,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(d,c){const g=this.configurationDefaultsOverrides.get(d)?.configurationDefaultOverrideValue;let w,y;g&&(!c.disallowConfigurationDefault||!g.source)&&(w=g.value,y=g.source),D.isUndefined(w)&&(w=c.defaultDefaultValue,y=void 0),D.isUndefined(w)&&(w=p(c.type)),c.default=w,c.defaultValueSource=y}}const T="\\[([^\\]]+)\\]",S=new RegExp(T,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${T})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function o(r){const d=[];if(e.OVERRIDE_PROPERTY_REGEX.test(r)){let c=S.exec(r);for(;c?.length;){const g=c[1].trim();g&&d.push(g),c=S.exec(r)}}return(0,s.distinct)(d)}function m(r){return r.reduce((d,c)=>`${d}[${c}]`,"")}function p(r){switch(Array.isArray(r)?r[0]:r){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const u=new f;v.Registry.add(e.Extensions.Configuration,u);function i(r,d){return r.trim()?e.OVERRIDE_PROPERTY_REGEX.test(r)?A.localize(1669,null,r):u.getConfigurationProperties()[r]!==void 0?A.localize(1670,null,r):d.policy?.name&&u.getPolicyConfigurations().get(d.policy?.name)!==void 0?A.localize(1671,null,r,d.policy?.name,u.getPolicyConfigurations().get(d.policy?.name)):null:A.localize(1668,null)}function a(){const r=[],d=u.getConfigurationProperties();for(const c of Object.keys(d))r.push([c,d[c].scope]);return r.push(["launch",C.RESOURCE]),r.push(["task",C.RESOURCE]),r}function t(r){const d={};for(const c of r){const g=c.properties;if(D.isObject(g))for(const w in g)d[w]=g[w];c.allOf&&Object.assign(d,t(c.allOf))}return d}function n(r){switch(r){case"application":return C.APPLICATION;case"machine":return C.MACHINE;case"resource":return C.RESOURCE;case"machine-overridable":return C.MACHINE_OVERRIDABLE;case"language-overridable":return C.LANGUAGE_OVERRIDABLE;default:return C.WINDOW}}}),define(Pe[235],ke([1,0,18,4,180,3,28,24,17,2,46,72,27,37]),function(ge,e,s,h,D,A,L,R,v,l,C,_,f,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0,e.mergeChanges=a,s=We(s),D=We(D),R=We(R),v=We(v);function S(d){return Object.isFrozen(d)?d:R.deepFreeze(d)}class o{static createEmptyModel(c){return new o({},[],[],void 0,c)}constructor(c,g,w,y,I){this._contents=c,this._keys=g,this._overrides=w,this.raw=y,this.logService=I,this.overrideConfigurations=new Map}get rawConfiguration(){if(!this._rawConfiguration)if(this.raw?.length){const c=this.raw.map(g=>{if(g instanceof o)return g;const w=new m("",this.logService);return w.parseRaw(g),w.configurationModel});this._rawConfiguration=c.reduce((g,w)=>w===g?w:g.merge(w),c[0])}else this._rawConfiguration=this;return this._rawConfiguration}get contents(){return this._contents}get overrides(){return this._overrides}get keys(){return this._keys}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(c){return c?(0,C.getConfigurationValue)(this.contents,c):this.contents}inspect(c,g){const w=this;return{get value(){return S(w.rawConfiguration.getValue(c))},get override(){return g?S(w.rawConfiguration.getOverrideValue(c,g)):void 0},get merged(){return S(g?w.rawConfiguration.override(g).getValue(c):w.rawConfiguration.getValue(c))},get overrides(){const y=[];for(const{contents:I,identifiers:P,keys:k}of w.rawConfiguration.overrides){const b=new o(I,k,[],void 0,w.logService).getValue(c);b!==void 0&&y.push({identifiers:P,value:b})}return y.length?S(y):void 0}}}getOverrideValue(c,g){const w=this.getContentsForOverrideIdentifer(g);return w?c?(0,C.getConfigurationValue)(w,c):w:void 0}getKeysForOverrideIdentifier(c){const g=[];for(const w of this.overrides)w.identifiers.includes(c)&&g.push(...w.keys);return s.distinct(g)}getAllOverrideIdentifiers(){const c=[];for(const g of this.overrides)c.push(...g.identifiers);return s.distinct(c)}override(c){let g=this.overrideConfigurations.get(c);return g||(g=this.createOverrideConfigurationModel(c),this.overrideConfigurations.set(c,g)),g}merge(...c){const g=R.deepClone(this.contents),w=R.deepClone(this.overrides),y=[...this.keys],I=this.raw?.length?[...this.raw]:[this];for(const P of c)if(I.push(...P.raw?.length?P.raw:[P]),!P.isEmpty()){this.mergeContents(g,P.contents);for(const k of P.overrides){const[b]=w.filter(E=>s.equals(E.identifiers,k.identifiers));b?(this.mergeContents(b.contents,k.contents),b.keys.push(...k.keys),b.keys=s.distinct(b.keys)):w.push(R.deepClone(k))}for(const k of P.keys)y.indexOf(k)===-1&&y.push(k)}return new o(g,y,w,I.every(P=>P instanceof o)?void 0:I,this.logService)}createOverrideConfigurationModel(c){const g=this.getContentsForOverrideIdentifer(c);if(!g||typeof g!="object"||!Object.keys(g).length)return this;const w={};for(const y of s.distinct([...Object.keys(this.contents),...Object.keys(g)])){let I=this.contents[y];const P=g[y];P&&(typeof I=="object"&&typeof P=="object"?(I=R.deepClone(I),this.mergeContents(I,P)):I=P),w[y]=I}return new o(w,this.keys,this.overrides,void 0,this.logService)}mergeContents(c,g){for(const w of Object.keys(g)){if(w in c&&v.isObject(c[w])&&v.isObject(g[w])){this.mergeContents(c[w],g[w]);continue}c[w]=R.deepClone(g[w])}}getContentsForOverrideIdentifer(c){let g=null,w=null;const y=I=>{I&&(w?this.mergeContents(w,I):w=R.deepClone(I))};for(const I of this.overrides)I.identifiers.length===1&&I.identifiers[0]===c?g=I.contents:I.identifiers.includes(c)&&y(I.contents);return y(g),w}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(c,g){this.updateValue(c,g,!0)}setValue(c,g){this.updateValue(c,g,!1)}removeValue(c){const g=this.keys.indexOf(c);g!==-1&&(this.keys.splice(g,1),(0,C.removeFromValueTree)(this.contents,c),_.OVERRIDE_PROPERTY_REGEX.test(c)&&this.overrides.splice(this.overrides.findIndex(w=>s.equals(w.identifiers,(0,_.overrideIdentifiersFromKey)(c))),1))}updateValue(c,g,w){if((0,C.addToValueTree)(this.contents,c,g,y=>this.logService.error(y)),w=w||this.keys.indexOf(c)===-1,w&&this.keys.push(c),_.OVERRIDE_PROPERTY_REGEX.test(c)){const y=(0,_.overrideIdentifiersFromKey)(c),I={identifiers:y,keys:Object.keys(this.contents[c]),contents:(0,C.toValuesTree)(this.contents[c],k=>this.logService.error(k))},P=this.overrides.findIndex(k=>s.equals(k.identifiers,y));P!==-1?this.overrides[P]=I:this.overrides.push(I)}}}e.ConfigurationModel=o;class m{constructor(c,g){this._name=c,this.logService=g,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||o.createEmptyModel(this.logService)}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(c,g){if(!v.isUndefinedOrNull(c)){const w=this.doParseContent(c);this.parseRaw(w,g)}}reparse(c){this._raw&&this.parseRaw(this._raw,c)}parseRaw(c,g){this._raw=c;const{contents:w,keys:y,overrides:I,restricted:P,hasExcludedProperties:k}=this.doParseRaw(c,g);this._configurationModel=new o(w,y,I,k?[c]:void 0,this.logService),this._restrictedConfigurations=P||[]}doParseContent(c){let g={},w=null,y=[];const I=[],P=[];function k(E){Array.isArray(y)?y.push(E):w!==null&&(y[w]=E)}const b={onObjectBegin:()=>{const E={};k(E),I.push(y),y=E,w=null},onObjectProperty:E=>{w=E},onObjectEnd:()=>{y=I.pop()},onArrayBegin:()=>{const E=[];k(E),I.push(y),y=E,w=null},onArrayEnd:()=>{y=I.pop()},onLiteralValue:k,onError:(E,N,O)=>{P.push({error:E,offset:N,length:O})}};if(c)try{D.visit(c,b),g=y[0]||{}}catch(E){this.logService.error(`Error while parsing settings file ${this._name}: ${E}`),this._parseErrors=[E]}return g}doParseRaw(c,g){const w=T.Registry.as(_.Extensions.Configuration).getConfigurationProperties(),y=this.filter(c,w,!0,g);c=y.raw;const I=(0,C.toValuesTree)(c,b=>this.logService.error(`Conflict in settings file ${this._name}: ${b}`)),P=Object.keys(c),k=this.toOverrides(c,b=>this.logService.error(`Conflict in settings file ${this._name}: ${b}`));return{contents:I,keys:P,overrides:k,restricted:y.restricted,hasExcludedProperties:y.hasExcludedProperties}}filter(c,g,w,y){let I=!1;if(!y?.scopes&&!y?.skipRestricted&&!y?.exclude?.length)return{raw:c,restricted:[],hasExcludedProperties:I};const P={},k=[];for(const b in c)if(_.OVERRIDE_PROPERTY_REGEX.test(b)&&w){const E=this.filter(c[b],g,!1,y);P[b]=E.raw,I=I||E.hasExcludedProperties,k.push(...E.restricted)}else{const E=g[b],N=E?typeof E.scope<"u"?E.scope:_.ConfigurationScope.WINDOW:void 0;E?.restricted&&k.push(b),!y.exclude?.includes(b)&&(y.include?.includes(b)||(N===void 0||y.scopes===void 0||y.scopes.includes(N))&&!(y.skipRestricted&&E?.restricted))?P[b]=c[b]:I=!0}return{raw:P,restricted:k,hasExcludedProperties:I}}toOverrides(c,g){const w=[];for(const y of Object.keys(c))if(_.OVERRIDE_PROPERTY_REGEX.test(y)){const I={};for(const P in c[y])I[P]=c[y][P];w.push({identifiers:(0,_.overrideIdentifiersFromKey)(y),keys:Object.keys(I),contents:(0,C.toValuesTree)(I,g)})}return w}}e.ConfigurationModelParser=m;class p extends A.Disposable{constructor(c,g,w,y,I){super(),this.userSettingsResource=c,this.parseOptions=g,this.fileService=y,this.logService=I,this._onDidChange=this._register(new h.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new m(this.userSettingsResource.toString(),I),this._register(this.fileService.watch(w.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(h.Event.any(h.Event.filter(this.fileService.onDidFilesChange,P=>P.contains(this.userSettingsResource)),h.Event.filter(this.fileService.onDidRunOperation,P=>(P.isOperation(f.FileOperation.CREATE)||P.isOperation(f.FileOperation.COPY)||P.isOperation(f.FileOperation.DELETE)||P.isOperation(f.FileOperation.WRITE))&&w.isEqual(P.resource,c)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const c=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(c.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return o.createEmptyModel(this.logService)}}reparse(c){return c&&(this.parseOptions=c),this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=p;class u{constructor(c,g,w,y,I,P,k,b,E,N,O,M,U){this.key=c,this.overrides=g,this._value=w,this.overrideIdentifiers=y,this.defaultConfiguration=I,this.policyConfiguration=P,this.applicationConfiguration=k,this.userConfiguration=b,this.localUserConfiguration=E,this.remoteUserConfiguration=N,this.workspaceConfiguration=O,this.folderConfigurationModel=M,this.memoryConfigurationModel=U}get value(){return S(this._value)}toInspectValue(c){return c?.value!==void 0||c?.override!==void 0||c?.overrides!==void 0?c:void 0}get defaultInspectValue(){return this._defaultInspectValue||(this._defaultInspectValue=this.defaultConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._defaultInspectValue}get defaultValue(){return this.defaultInspectValue.merged}get default(){return this.toInspectValue(this.defaultInspectValue)}get policyInspectValue(){return this._policyInspectValue===void 0&&(this._policyInspectValue=this.policyConfiguration?this.policyConfiguration.inspect(this.key):null),this._policyInspectValue}get policyValue(){return this.policyInspectValue?.merged}get policy(){return this.policyInspectValue?.value!==void 0?{value:this.policyInspectValue.value}:void 0}get applicationInspectValue(){return this._applicationInspectValue===void 0&&(this._applicationInspectValue=this.applicationConfiguration?this.applicationConfiguration.inspect(this.key):null),this._applicationInspectValue}get applicationValue(){return this.applicationInspectValue?.merged}get application(){return this.toInspectValue(this.applicationInspectValue)}get userInspectValue(){return this._userInspectValue||(this._userInspectValue=this.userConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._userInspectValue}get userValue(){return this.userInspectValue.merged}get user(){return this.toInspectValue(this.userInspectValue)}get userLocalInspectValue(){return this._userLocalInspectValue||(this._userLocalInspectValue=this.localUserConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._userLocalInspectValue}get userLocalValue(){return this.userLocalInspectValue.merged}get userLocal(){return this.toInspectValue(this.userLocalInspectValue)}get userRemoteInspectValue(){return this._userRemoteInspectValue||(this._userRemoteInspectValue=this.remoteUserConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._userRemoteInspectValue}get userRemoteValue(){return this.userRemoteInspectValue.merged}get userRemote(){return this.toInspectValue(this.userRemoteInspectValue)}get workspaceInspectValue(){return this._workspaceInspectValue===void 0&&(this._workspaceInspectValue=this.workspaceConfiguration?this.workspaceConfiguration.inspect(this.key,this.overrides.overrideIdentifier):null),this._workspaceInspectValue}get workspaceValue(){return this.workspaceInspectValue?.merged}get workspace(){return this.toInspectValue(this.workspaceInspectValue)}get workspaceFolderInspectValue(){return this._workspaceFolderInspectValue===void 0&&(this._workspaceFolderInspectValue=this.folderConfigurationModel?this.folderConfigurationModel.inspect(this.key,this.overrides.overrideIdentifier):null),this._workspaceFolderInspectValue}get workspaceFolderValue(){return this.workspaceFolderInspectValue?.merged}get workspaceFolder(){return this.toInspectValue(this.workspaceFolderInspectValue)}get memoryInspectValue(){return this._memoryInspectValue===void 0&&(this._memoryInspectValue=this.memoryConfigurationModel.inspect(this.key,this.overrides.overrideIdentifier)),this._memoryInspectValue}get memoryValue(){return this.memoryInspectValue.merged}get memory(){return this.toInspectValue(this.memoryInspectValue)}}class i{constructor(c,g,w,y,I,P,k,b,E,N){this._defaultConfiguration=c,this._policyConfiguration=g,this._applicationConfiguration=w,this._localUserConfiguration=y,this._remoteUserConfiguration=I,this._workspaceConfiguration=P,this._folderConfigurations=k,this._memoryConfiguration=b,this._memoryConfigurationByResource=E,this.logService=N,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new L.ResourceMap,this._userConfiguration=null}getValue(c,g,w){return this.getConsolidatedConfigurationModel(c,g,w).getValue(c)}updateValue(c,g,w={}){let y;w.resource?(y=this._memoryConfigurationByResource.get(w.resource),y||(y=o.createEmptyModel(this.logService),this._memoryConfigurationByResource.set(w.resource,y))):y=this._memoryConfiguration,g===void 0?y.removeValue(c):y.setValue(c,g),w.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(c,g,w){const y=this.getConsolidatedConfigurationModel(c,g,w),I=this.getFolderConfigurationModelForResource(g.resource,w),P=g.resource?this._memoryConfigurationByResource.get(g.resource)||this._memoryConfiguration:this._memoryConfiguration,k=new Set;for(const b of y.overrides)for(const E of b.identifiers)y.getOverrideValue(c,E)!==void 0&&k.add(E);return new u(c,g,y.getValue(c),k.size?[...k]:void 0,this._defaultConfiguration,this._policyConfiguration.isEmpty()?void 0:this._policyConfiguration,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,w?this._workspaceConfiguration:void 0,I||void 0,P)}keys(c){const g=this.getFolderConfigurationModelForResource(void 0,c);return{default:this._defaultConfiguration.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this._workspaceConfiguration.keys.slice(0),workspaceFolder:g?g.keys.slice(0):[]}}updateDefaultConfiguration(c){this._defaultConfiguration=c,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updatePolicyConfiguration(c){this._policyConfiguration=c}updateApplicationConfiguration(c){this._applicationConfiguration=c,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(c){this._localUserConfiguration=c,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(c){this._remoteUserConfiguration=c,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(c){this._workspaceConfiguration=c,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(c,g){this._folderConfigurations.set(c,g),this._foldersConsolidatedConfigurations.delete(c)}deleteFolderConfiguration(c){this.folderConfigurations.delete(c),this._foldersConsolidatedConfigurations.delete(c)}compareAndUpdateDefaultConfiguration(c,g){const w=[];if(!g){const{added:y,updated:I,removed:P}=n(this._defaultConfiguration,c);g=[...y,...I,...P]}for(const y of g)for(const I of(0,_.overrideIdentifiersFromKey)(y)){const P=this._defaultConfiguration.getKeysForOverrideIdentifier(I),k=c.getKeysForOverrideIdentifier(I),b=[...k.filter(E=>P.indexOf(E)===-1),...P.filter(E=>k.indexOf(E)===-1),...P.filter(E=>!R.equals(this._defaultConfiguration.override(I).getValue(E),c.override(I).getValue(E)))];w.push([I,b])}return this.updateDefaultConfiguration(c),{keys:g,overrides:w}}compareAndUpdatePolicyConfiguration(c){const{added:g,updated:w,removed:y}=n(this._policyConfiguration,c),I=[...g,...w,...y];return I.length&&this.updatePolicyConfiguration(c),{keys:I,overrides:[]}}compareAndUpdateApplicationConfiguration(c){const{added:g,updated:w,removed:y,overrides:I}=n(this.applicationConfiguration,c),P=[...g,...w,...y];return P.length&&this.updateApplicationConfiguration(c),{keys:P,overrides:I}}compareAndUpdateLocalUserConfiguration(c){const{added:g,updated:w,removed:y,overrides:I}=n(this.localUserConfiguration,c),P=[...g,...w,...y];return P.length&&this.updateLocalUserConfiguration(c),{keys:P,overrides:I}}compareAndUpdateRemoteUserConfiguration(c){const{added:g,updated:w,removed:y,overrides:I}=n(this.remoteUserConfiguration,c),P=[...g,...w,...y];return P.length&&this.updateRemoteUserConfiguration(c),{keys:P,overrides:I}}compareAndUpdateWorkspaceConfiguration(c){const{added:g,updated:w,removed:y,overrides:I}=n(this.workspaceConfiguration,c),P=[...g,...w,...y];return P.length&&this.updateWorkspaceConfiguration(c),{keys:P,overrides:I}}compareAndUpdateFolderConfiguration(c,g){const w=this.folderConfigurations.get(c),{added:y,updated:I,removed:P,overrides:k}=n(w,g),b=[...y,...I,...P];return(b.length||!w)&&this.updateFolderConfiguration(c,g),{keys:b,overrides:k}}compareAndDeleteFolderConfiguration(c){const g=this.folderConfigurations.get(c);if(!g)throw new Error("Unknown folder");this.deleteFolderConfiguration(c);const{added:w,updated:y,removed:I,overrides:P}=n(g,void 0);return{keys:[...w,...y,...I],overrides:P}}get defaults(){return this._defaultConfiguration}get applicationConfiguration(){return this._applicationConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration)),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidatedConfigurationModel(c,g,w){let y=this.getConsolidatedConfigurationModelForResource(g,w);return g.overrideIdentifier&&(y=y.override(g.overrideIdentifier)),!this._policyConfiguration.isEmpty()&&this._policyConfiguration.getValue(c)!==void 0&&(y=y.merge(this._policyConfiguration)),y}getConsolidatedConfigurationModelForResource({resource:c},g){let w=this.getWorkspaceConsolidatedConfiguration();if(g&&c){const y=g.getFolder(c);y&&(w=this.getFolderConsolidatedConfiguration(y.uri)||w);const I=this._memoryConfigurationByResource.get(c);I&&(w=w.merge(I))}return w}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.applicationConfiguration,this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration)),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(c){let g=this._foldersConsolidatedConfigurations.get(c);if(!g){const w=this.getWorkspaceConsolidatedConfiguration(),y=this._folderConfigurations.get(c);y?(g=w.merge(y),this._foldersConsolidatedConfigurations.set(c,g)):g=w}return g}getFolderConfigurationModelForResource(c,g){if(g&&c){const w=g.getFolder(c);if(w)return this._folderConfigurations.get(w.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},policy:{contents:this._policyConfiguration.contents,overrides:this._policyConfiguration.overrides,keys:this._policyConfiguration.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((c,g)=>{const{contents:w,overrides:y,keys:I}=this._folderConfigurations.get(g);return c.push([g,{contents:w,overrides:y,keys:I}]),c},[])}}allKeys(){const c=new Set;return this._defaultConfiguration.keys.forEach(g=>c.add(g)),this.userConfiguration.keys.forEach(g=>c.add(g)),this._workspaceConfiguration.keys.forEach(g=>c.add(g)),this._folderConfigurations.forEach(g=>g.keys.forEach(w=>c.add(w))),[...c.values()]}allOverrideIdentifiers(){const c=new Set;return this._defaultConfiguration.getAllOverrideIdentifiers().forEach(g=>c.add(g)),this.userConfiguration.getAllOverrideIdentifiers().forEach(g=>c.add(g)),this._workspaceConfiguration.getAllOverrideIdentifiers().forEach(g=>c.add(g)),this._folderConfigurations.forEach(g=>g.getAllOverrideIdentifiers().forEach(w=>c.add(w))),[...c.values()]}getAllKeysForOverrideIdentifier(c){const g=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(c).forEach(w=>g.add(w)),this.userConfiguration.getKeysForOverrideIdentifier(c).forEach(w=>g.add(w)),this._workspaceConfiguration.getKeysForOverrideIdentifier(c).forEach(w=>g.add(w)),this._folderConfigurations.forEach(w=>w.getKeysForOverrideIdentifier(c).forEach(y=>g.add(y))),[...g.values()]}static parse(c,g){const w=this.parseConfigurationModel(c.defaults,g),y=this.parseConfigurationModel(c.policy,g),I=this.parseConfigurationModel(c.application,g),P=this.parseConfigurationModel(c.user,g),k=this.parseConfigurationModel(c.workspace,g),b=c.folders.reduce((E,N)=>(E.set(l.URI.revive(N[0]),this.parseConfigurationModel(N[1],g)),E),new L.ResourceMap);return new i(w,y,I,P,o.createEmptyModel(g),k,b,o.createEmptyModel(g),new L.ResourceMap,g)}static parseConfigurationModel(c,g){return new o(c.contents,c.keys,c.overrides,void 0,g)}}e.Configuration=i;function a(...d){if(d.length===0)return{keys:[],overrides:[]};if(d.length===1)return d[0];const c=new Set,g=new Map;for(const y of d)y.keys.forEach(I=>c.add(I)),y.overrides.forEach(([I,P])=>{const k=(0,L.getOrSet)(g,I,new Set);P.forEach(b=>k.add(b))});const w=[];return g.forEach((y,I)=>w.push([I,[...y.values()]])),{keys:[...c.values()],overrides:w}}class t{constructor(c,g,w,y,I){this.change=c,this.previous=g,this.currentConfiguraiton=w,this.currentWorkspace=y,this.logService=I,this._marker=`
`,this._markerCode1=this._marker.charCodeAt(0),this._markerCode2=46,this.affectedKeys=new Set,this._previousConfiguration=void 0;for(const P of c.keys)this.affectedKeys.add(P);for(const[,P]of c.overrides)for(const k of P)this.affectedKeys.add(k);this._affectsConfigStr=this._marker;for(const P of this.affectedKeys)this._affectsConfigStr+=P+this._marker}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=i.parse(this.previous.data,this.logService)),this._previousConfiguration}affectsConfiguration(c,g){const w=this._marker+c,y=this._affectsConfigStr.indexOf(w);if(y<0)return!1;const I=y+w.length;if(I>=this._affectsConfigStr.length)return!1;const P=this._affectsConfigStr.charCodeAt(I);if(P!==this._markerCode1&&P!==this._markerCode2)return!1;if(g){const k=this.previousConfiguration?this.previousConfiguration.getValue(c,g,this.previous?.workspace):void 0,b=this.currentConfiguraiton.getValue(c,g,this.currentWorkspace);return!R.equals(k,b)}return!0}}e.ConfigurationChangeEvent=t;function n(d,c){const{added:g,removed:w,updated:y}=r(c?.rawConfiguration,d?.rawConfiguration),I=[],P=d?.getAllOverrideIdentifiers()||[],k=c?.getAllOverrideIdentifiers()||[];if(c){const b=k.filter(E=>!P.includes(E));for(const E of b)I.push([E,c.getKeysForOverrideIdentifier(E)])}if(d){const b=P.filter(E=>!k.includes(E));for(const E of b)I.push([E,d.getKeysForOverrideIdentifier(E)])}if(c&&d){for(const b of P)if(k.includes(b)){const E=r({contents:d.getOverrideValue(void 0,b)||{},keys:d.getKeysForOverrideIdentifier(b)},{contents:c.getOverrideValue(void 0,b)||{},keys:c.getKeysForOverrideIdentifier(b)});I.push([b,[...E.added,...E.removed,...E.updated]])}}return{added:g,removed:w,updated:y,overrides:I}}function r(d,c){const g=d?c?d.keys.filter(I=>c.keys.indexOf(I)===-1):[...d.keys]:[],w=c?d?c.keys.filter(I=>d.keys.indexOf(I)===-1):[...c.keys]:[],y=[];if(d&&c){for(const I of c.keys)if(d.keys.indexOf(I)!==-1){const P=(0,C.getConfigurationValue)(c.contents,I),k=(0,C.getConfigurationValue)(d.contents,I);R.equals(P,k)||y.push(I)}}return{added:g,removed:w,updated:y}}}),define(Pe[236],ke([1,0,21,4,3,70]),function(ge,e,s,h,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ManagedSocket=e.socketRawEndHeaderSequence=e.makeRawSocketHeaders=void 0,e.connectManagedSocket=R;const L=(l,C,_)=>{const f=new Uint8Array(16);for(let o=0;o<16;o++)f[o]=Math.round(Math.random()*256);const T=(0,s.encodeBase64)(s.VSBuffer.wrap(f));return[`GET ws://localhost${l}?${C}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${T}`].join(`\r
`)+`\r
\r
`};e.makeRawSocketHeaders=L,e.socketRawEndHeaderSequence=s.VSBuffer.fromString(`\r
\r
`);async function R(l,C,_,f,T){l.write(s.VSBuffer.fromString((0,e.makeRawSocketHeaders)(C,_,f)));const S=new D.DisposableStore;try{return await new Promise((o,m)=>{let p;S.add(l.onData(u=>{p?p=s.VSBuffer.concat([p,u],p.byteLength+u.byteLength):p=u;const i=p.indexOf(e.socketRawEndHeaderSequence);if(i===-1)return;o(l),l.pauseData();const a=p.slice(i+e.socketRawEndHeaderSequence.byteLength);a.byteLength&&T.onData.fire(a)})),S.add(l.onClose(u=>m(u??new Error("socket closed")))),S.add(l.onEnd(()=>m(new Error("socket ended"))))})}catch(o){throw l.dispose(),o}finally{S.dispose()}}class v extends D.Disposable{constructor(C,_){super(),this.debugLabel=C,this.pausableDataEmitter=this._register(new h.PauseableEmitter),this.onData=(...f)=>(this.pausableDataEmitter.isPaused&&queueMicrotask(()=>this.pausableDataEmitter.resume()),this.pausableDataEmitter.event(...f)),this.didDisposeEmitter=this._register(new h.Emitter),this.onDidDispose=this.didDisposeEmitter.event,this.ended=!1,this._register(_.onData),this._register(_.onData.event(f=>this.pausableDataEmitter.fire(f))),this.onClose=this._register(_.onClose).event,this.onEnd=this._register(_.onEnd).event}pauseData(){this.pausableDataEmitter.pause()}drain(){return Promise.resolve()}end(){this.ended=!0,this.closeRemote()}traceSocketEvent(C,_){A.SocketDiagnostics.traceSocketEvent(this,this.debugLabel,C,_)}dispose(){this.ended||this.closeRemote(),this.didDisposeEmitter.fire(),super.dispose()}}e.ManagedSocket=v}),define(Pe[73],ke([1,0,12,5]),function(ge,e,s,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.WebSocketRemoteConnection=e.ManagedRemoteConnection=e.RemoteConnectionType=e.IRemoteAuthorityResolverService=void 0,e.getRemoteAuthorityPrefix=l,e.IRemoteAuthorityResolverService=(0,h.createDecorator)("remoteAuthorityResolverService");var D;(function(C){C[C.WebSocket=0]="WebSocket",C[C.Managed=1]="Managed"})(D||(e.RemoteConnectionType=D={}));class A{constructor(_){this.id=_,this.type=D.Managed}toString(){return`Managed(${this.id})`}}e.ManagedRemoteConnection=A;class L{constructor(_,f){this.host=_,this.port=f,this.type=D.WebSocket}toString(){return`WebSocket(${this.host}:${this.port})`}}e.WebSocketRemoteConnection=L;var R;(function(C){C.Unknown="Unknown",C.NotAvailable="NotAvailable",C.TemporarilyNotAvailable="TemporarilyNotAvailable",C.NoResolverFound="NoResolverFound",C.InvalidAuthority="InvalidAuthority"})(R||(e.RemoteAuthorityResolverErrorCode=R={}));class v extends s.ErrorNoTelemetry{static isNotAvailable(_){return _ instanceof v&&_._code===R.NotAvailable}static isTemporarilyNotAvailable(_){return _ instanceof v&&_._code===R.TemporarilyNotAvailable}static isNoResolverFound(_){return _ instanceof v&&_._code===R.NoResolverFound}static isInvalidAuthority(_){return _ instanceof v&&_._code===R.InvalidAuthority}static isHandled(_){return _ instanceof v&&_.isHandled}constructor(_,f=R.Unknown,T){super(_),this._message=_,this._code=f,this._detail=T,this.isHandled=f===R.NotAvailable&&T===!0,Object.setPrototypeOf(this,v.prototype)}}e.RemoteAuthorityResolverError=v;function l(C){const _=C.indexOf("+");return _===-1?C:C.substring(0,_)}}),define(Pe[237],ke([1,0,8,21,20,12,4,3,14,63,43,31,70,73]),function(ge,e,s,h,D,A,L,R,v,l,C,_,f,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.PersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.ConnectionType=void 0,e.connectRemoteAgentManagement=I,e.connectRemoteAgentExtensionHost=P,e.connectRemoteAgentTunnel=b,l=We(l);const S=30*1e3;var o;(function(le){le[le.Management=1]="Management",le[le.ExtensionHost=2]="ExtensionHost",le[le.Tunnel=3]="Tunnel"})(o||(e.ConnectionType=o={}));function m(le){switch(le){case o.Management:return"Management";case o.ExtensionHost:return"ExtensionHost";case o.Tunnel:return"Tunnel"}}function p(le){const Q=new D.CancellationTokenSource;return setTimeout(()=>Q.cancel(),le),Q.token}function u(le,Q){if(le.isCancellationRequested||Q.isCancellationRequested)return D.CancellationToken.Cancelled;const z=new D.CancellationTokenSource;return le.onCancellationRequested(()=>z.cancel()),Q.onCancellationRequested(()=>z.cancel()),z.token}class i{get didTimeout(){return this._state==="timedout"}constructor(Q){this._state="pending",this._disposables=new R.DisposableStore,{promise:this.promise,resolve:this._resolvePromise,reject:this._rejectPromise}=(0,s.promiseWithResolvers)(),Q.isCancellationRequested?this._timeout():this._disposables.add(Q.onCancellationRequested(()=>this._timeout()))}registerDisposable(Q){this._state==="pending"?this._disposables.add(Q):Q.dispose()}_timeout(){this._state==="pending"&&(this._disposables.dispose(),this._state="timedout",this._rejectPromise(this._createTimeoutError()))}_createTimeoutError(){const Q=new Error("Time limit reached");return Q.code="ETIMEDOUT",Q.syscall="connect",Q}resolve(Q){this._state==="pending"&&(this._disposables.dispose(),this._state="resolved",this._resolvePromise(Q))}reject(Q){this._state==="pending"&&(this._disposables.dispose(),this._state="rejected",this._rejectPromise(Q))}}function a(le,Q){const z=new i(Q);return z.registerDisposable(le.onControlMessage(se=>{const Ee=JSON.parse(se.toString()),ae=W(Ee);ae?z.reject(ae):z.resolve(Ee)})),z.promise}function t(le,Q,z,se,Ee,ae,be,pe){const ve=new i(pe),Re=C.StopWatch.create(!1);return le.info(`Creating a socket (${be})...`),l.mark(`code/willCreateSocket/${ae}`),Q.connect(z,se,Ee,be).then(Fe=>{ve.didTimeout?(l.mark(`code/didCreateSocketError/${ae}`),le.info(`Creating a socket (${be}) finished after ${Re.elapsed()} ms, but this is too late and has timed out already.`),Fe?.dispose()):(l.mark(`code/didCreateSocketOK/${ae}`),le.info(`Creating a socket (${be}) was successful after ${Re.elapsed()} ms.`),ve.resolve(Fe))},Fe=>{l.mark(`code/didCreateSocketError/${ae}`),le.info(`Creating a socket (${be}) returned an error after ${Re.elapsed()} ms.`),le.error(Fe),ve.reject(Fe)}),ve.promise}function n(le,Q){const z=new i(Q);return le.then(se=>{z.didTimeout||z.resolve(se)},se=>{z.didTimeout||z.reject(se)}),z.promise}async function r(le,Q,z,se){const Ee=te(le,Q);le.logService.trace(`${Ee} 1/6. invoking socketFactory.connect().`);let ae;try{ae=await t(le.logService,le.remoteSocketFactoryService,le.connectTo,v.RemoteAuthorities.getServerRootPath(),`reconnectionToken=${le.reconnectionToken}&reconnection=${le.reconnectionProtocol?"true":"false"}`,m(Q),`renderer-${m(Q)}-${le.reconnectionToken}`,se)}catch(Fe){throw le.logService.error(`${Ee} socketFactory.connect() failed or timed out. Error:`),le.logService.error(Fe),Fe}le.logService.trace(`${Ee} 2/6. socketFactory.connect() was successful.`);let be,pe;le.reconnectionProtocol?(le.reconnectionProtocol.beginAcceptReconnection(ae,null),be=le.reconnectionProtocol,pe=!1):(be=new f.PersistentProtocol({socket:ae}),pe=!0),le.logService.trace(`${Ee} 3/6. sending AuthRequest control message.`);const ve=await n(le.signService.createNewMessage((0,_.generateUuid)()),se),Re={type:"auth",auth:le.connectionToken||"00000000000000000000",data:ve.data};be.sendControl(h.VSBuffer.fromString(JSON.stringify(Re)));try{const Fe=await a(be,u(se,p(1e4)));if(Fe.type!=="sign"||typeof Fe.data!="string"){const xe=new Error("Unexpected handshake message");throw xe.code="VSCODE_CONNECTION_ERROR",xe}if(le.logService.trace(`${Ee} 4/6. received SignRequest control message.`),!await n(le.signService.validate(ve,Fe.signedData),se)){const xe=new Error("Refused to connect to unsupported server");throw xe.code="VSCODE_CONNECTION_ERROR",xe}const Ye=await n(le.signService.sign(Fe.data),se),Je={type:"connectionType",commit:le.commit,signedData:Ye,desiredConnectionType:Q};return z&&(Je.args=z),le.logService.trace(`${Ee} 5/6. sending ConnectionTypeRequest control message.`),be.sendControl(h.VSBuffer.fromString(JSON.stringify(Je))),{protocol:be,ownsProtocol:pe}}catch(Fe){throw Fe&&Fe.code==="ETIMEDOUT"&&(le.logService.error(`${Ee} the handshake timed out. Error:`),le.logService.error(Fe)),Fe&&Fe.code==="VSCODE_CONNECTION_ERROR"&&(le.logService.error(`${Ee} received error control message when negotiating connection. Error:`),le.logService.error(Fe)),pe&&B(be),Fe}}async function d(le,Q,z,se){const Ee=Date.now(),ae=te(le,Q),{protocol:be,ownsProtocol:pe}=await r(le,Q,z,se),ve=new i(se);return ve.registerDisposable(be.onControlMessage(Re=>{const Fe=JSON.parse(Re.toString()),Ve=W(Fe);Ve?(le.logService.error(`${ae} received error control message when negotiating connection. Error:`),le.logService.error(Ve),pe&&B(be),ve.reject(Ve)):(le.reconnectionProtocol?.endAcceptReconnection(),le.logService.trace(`${ae} 6/6. handshake finished, connection is up and running after ${me(Ee)}!`),ve.resolve({protocol:be,firstMessage:Fe}))})),ve.promise}async function c(le,Q){const{protocol:z}=await d(le,o.Management,void 0,Q);return{protocol:z}}async function g(le,Q,z){const{protocol:se,firstMessage:Ee}=await d(le,o.ExtensionHost,Q,z),ae=Ee&&Ee.debugPort;return{protocol:se,debugPort:ae}}async function w(le,Q,z){const se=Date.now(),Ee=te(le,o.Tunnel),{protocol:ae}=await r(le,o.Tunnel,Q,z);return le.logService.trace(`${Ee} 6/6. handshake finished, connection is up and running after ${me(se)}!`),ae}async function y(le,Q,z){const{connectTo:se,connectionToken:Ee}=await le.addressProvider.getAddress();return{commit:le.commit,quality:le.quality,connectTo:se,connectionToken:Ee,reconnectionToken:Q,reconnectionProtocol:z,remoteSocketFactoryService:le.remoteSocketFactoryService,signService:le.signService,logService:le.logService}}async function I(le,Q,z){return k(le,async se=>{const{protocol:Ee}=await c(se,D.CancellationToken.None);return new $(le,Q,z,se.reconnectionToken,Ee)})}async function P(le,Q){return k(le,async z=>{const{protocol:se,debugPort:Ee}=await g(z,Q,D.CancellationToken.None);return new G(le,Q,z.reconnectionToken,se,Ee)})}async function k(le,Q){for(let se=1;;se++)try{const Ee=(0,_.generateUuid)(),ae=await y(le,Ee,null);return await Q(ae)}catch(Ee){if(se<5)le.logService.error(`[remote-connection][attempt ${se}] An error occurred in initial connection! Will retry... Error:`),le.logService.error(Ee);else throw le.logService.error(`[remote-connection][attempt ${se}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),le.logService.error(Ee),x.triggerPermanentFailure(0,0,T.RemoteAuthorityResolverError.isHandled(Ee)),Ee}}async function b(le,Q,z){const se=await y(le,(0,_.generateUuid)(),null);return await w(se,{host:Q,port:z},D.CancellationToken.None)}function E(le){return(0,s.createCancelablePromise)(Q=>new Promise((z,se)=>{const Ee=setTimeout(z,le*1e3);Q.onCancellationRequested(()=>{clearTimeout(Ee),z()})}))}var N;(function(le){le[le.ConnectionLost=0]="ConnectionLost",le[le.ReconnectionWait=1]="ReconnectionWait",le[le.ReconnectionRunning=2]="ReconnectionRunning",le[le.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",le[le.ConnectionGain=4]="ConnectionGain"})(N||(e.PersistentConnectionEventType=N={}));class O{constructor(Q,z){this.reconnectionToken=Q,this.millisSinceLastIncomingData=z,this.type=N.ConnectionLost}}e.ConnectionLostEvent=O;class M{constructor(Q,z,se,Ee){this.reconnectionToken=Q,this.millisSinceLastIncomingData=z,this.durationSeconds=se,this.cancellableTimer=Ee,this.type=N.ReconnectionWait}skipWait(){this.cancellableTimer.cancel()}}e.ReconnectionWaitEvent=M;class U{constructor(Q,z,se){this.reconnectionToken=Q,this.millisSinceLastIncomingData=z,this.attempt=se,this.type=N.ReconnectionRunning}}e.ReconnectionRunningEvent=U;class H{constructor(Q,z,se){this.reconnectionToken=Q,this.millisSinceLastIncomingData=z,this.attempt=se,this.type=N.ConnectionGain}}e.ConnectionGainEvent=H;class F{constructor(Q,z,se,Ee){this.reconnectionToken=Q,this.millisSinceLastIncomingData=z,this.attempt=se,this.handled=Ee,this.type=N.ReconnectionPermanentFailure}}e.ReconnectionPermanentFailureEvent=F;class x extends R.Disposable{static triggerPermanentFailure(Q,z,se){this._permanentFailure=!0,this._permanentFailureMillisSinceLastIncomingData=Q,this._permanentFailureAttempt=z,this._permanentFailureHandled=se,this._instances.forEach(Ee=>Ee._gotoPermanentFailure(this._permanentFailureMillisSinceLastIncomingData,this._permanentFailureAttempt,this._permanentFailureHandled))}static debugTriggerReconnection(){this._instances.forEach(Q=>Q._beginReconnecting())}static debugPauseSocketWriting(){this._instances.forEach(Q=>Q._pauseSocketWriting())}static{this._permanentFailure=!1}static{this._permanentFailureMillisSinceLastIncomingData=0}static{this._permanentFailureAttempt=0}static{this._permanentFailureHandled=!1}static{this._instances=[]}get _isPermanentFailure(){return this._permanentFailure||x._permanentFailure}constructor(Q,z,se,Ee,ae){super(),this._connectionType=Q,this._options=z,this.reconnectionToken=se,this.protocol=Ee,this._reconnectionFailureIsFatal=ae,this._onDidStateChange=this._register(new L.Emitter),this.onDidStateChange=this._onDidStateChange.event,this._permanentFailure=!1,this._isReconnecting=!1,this._isDisposed=!1,this._onDidStateChange.fire(new H(this.reconnectionToken,0,0)),this._register(Ee.onSocketClose(be=>{const pe=oe(this._connectionType,this.reconnectionToken,!0);be?be.type===f.SocketCloseEventType.NodeSocketCloseEvent?(this._options.logService.info(`${pe} received socket close event (hadError: ${be.hadError}).`),be.error&&this._options.logService.error(be.error)):(this._options.logService.info(`${pe} received socket close event (wasClean: ${be.wasClean}, code: ${be.code}, reason: ${be.reason}).`),be.event&&this._options.logService.error(be.event)):this._options.logService.info(`${pe} received socket close event.`),this._beginReconnecting()})),this._register(Ee.onSocketTimeout(be=>{const pe=oe(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${pe} received socket timeout event (unacknowledgedMsgCount: ${be.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${be.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${be.timeSinceLastReceivedSomeData}).`),this._beginReconnecting()})),x._instances.push(this),this._register((0,R.toDisposable)(()=>{const be=x._instances.indexOf(this);be>=0&&x._instances.splice(be,1)})),this._isPermanentFailure&&this._gotoPermanentFailure(x._permanentFailureMillisSinceLastIncomingData,x._permanentFailureAttempt,x._permanentFailureHandled)}dispose(){super.dispose(),this._isDisposed=!0}async _beginReconnecting(){if(!this._isReconnecting)try{this._isReconnecting=!0,await this._runReconnectingLoop()}finally{this._isReconnecting=!1}}async _runReconnectingLoop(){if(this._isPermanentFailure||this._isDisposed)return;const Q=oe(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${Q} starting reconnecting loop. You can get more information with the trace log level.`),this._onDidStateChange.fire(new O(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const z=[0,5,5,10,10,10,10,10,30];let se=-1;do{se++;const Ee=se<z.length?z[se]:z[z.length-1];try{if(Ee>0){const be=E(Ee);this._onDidStateChange.fire(new M(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),Ee,be)),this._options.logService.info(`${Q} waiting for ${Ee} seconds before reconnecting...`);try{await be}catch{}}if(this._isPermanentFailure){this._options.logService.error(`${Q} permanent failure occurred while running the reconnecting loop.`);break}this._onDidStateChange.fire(new U(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),se+1)),this._options.logService.info(`${Q} resolving connection...`);const ae=await y(this._options,this.reconnectionToken,this.protocol);this._options.logService.info(`${Q} connecting to ${ae.connectTo}...`),await this._reconnect(ae,p(S)),this._options.logService.info(`${Q} reconnected!`),this._onDidStateChange.fire(new H(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),se+1));break}catch(ae){if(ae.code==="VSCODE_CONNECTION_ERROR"){this._options.logService.error(`${Q} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this._options.logService.error(ae),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),se+1,!1);break}if(se>360){this._options.logService.error(`${Q} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this._options.logService.error(ae),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),se+1,!1);break}if(T.RemoteAuthorityResolverError.isTemporarilyNotAvailable(ae)){this._options.logService.info(`${Q} A temporarily not available error occurred while trying to reconnect, will try again...`),this._options.logService.trace(ae);continue}if((ae.code==="ETIMEDOUT"||ae.code==="ENETUNREACH"||ae.code==="ECONNREFUSED"||ae.code==="ECONNRESET")&&ae.syscall==="connect"){this._options.logService.info(`${Q} A network error occurred while trying to reconnect, will try again...`),this._options.logService.trace(ae);continue}if((0,A.isCancellationError)(ae)){this._options.logService.info(`${Q} A promise cancelation error occurred while trying to reconnect, will try again...`),this._options.logService.trace(ae);continue}if(ae instanceof T.RemoteAuthorityResolverError){this._options.logService.error(`${Q} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this._options.logService.error(ae),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),se+1,T.RemoteAuthorityResolverError.isHandled(ae));break}this._options.logService.error(`${Q} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this._options.logService.error(ae),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),se+1,!1);break}}while(!this._isPermanentFailure&&!this._isDisposed)}_onReconnectionPermanentFailure(Q,z,se){this._reconnectionFailureIsFatal?x.triggerPermanentFailure(Q,z,se):this._gotoPermanentFailure(Q,z,se)}_gotoPermanentFailure(Q,z,se){this._onDidStateChange.fire(new F(this.reconnectionToken,Q,z,se)),B(this.protocol)}_pauseSocketWriting(){this.protocol.pauseSocketWriting()}}e.PersistentConnection=x;class $ extends x{constructor(Q,z,se,Ee,ae){super(o.Management,Q,Ee,ae,!0),this.client=this._register(new f.Client(ae,{remoteAuthority:z,clientId:se},Q.ipcLogger))}async _reconnect(Q,z){await c(Q,z)}}e.ManagementPersistentConnection=$;class G extends x{constructor(Q,z,se,Ee,ae){super(o.ExtensionHost,Q,se,Ee,!1),this._startArguments=z,this.debugPort=ae}async _reconnect(Q,z){await g(Q,this._startArguments,z)}}e.ExtensionHostPersistentConnection=G;function B(le){try{le.acceptDisconnect();const Q=le.getSocket();le.dispose(),Q.dispose()}catch(Q){(0,A.onUnexpectedError)(Q)}}function W(le){if(le&&le.type==="error"){const Q=new Error(`Connection error: ${le.reason}`);return Q.code="VSCODE_CONNECTION_ERROR",Q}return null}function Z(le,Q){for(;le.length<Q;)le+=" ";return le}function J(le,Q){return`[remote-connection][${Z(m(le),13)}][${Q.substr(0,5)}\u2026]`}function oe(le,Q,z){return`${J(le,Q)}[${z?"reconnect":"initial"}]`}function te(le,Q){return`${oe(Q,le.reconnectionToken,!!le.reconnectionProtocol)}[${le.connectTo}]`}function me(le){return`${Date.now()-le} ms`}}),define(Pe[91],ke([1,0,14]),function(ge,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteAuthority=h,e.getRemoteName=D,e.parseAuthorityWithPort=A,e.parseAuthorityWithOptionalPort=L;function h(v){return v.scheme===s.Schemas.vscodeRemote?v.authority:void 0}function D(v){if(!v)return;const l=v.indexOf("+");return l<0?v:v.substr(0,l)}function A(v){const{host:l,port:C}=R(v);if(typeof C>"u")throw new Error(`Invalid remote authority: ${v}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:l,port:C}}function L(v,l){let{host:C,port:_}=R(v);return typeof _>"u"&&(_=l),{host:C,port:_}}function R(v){const l=v.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(l)return{host:l[1],port:parseInt(l[2],10)};const C=v.match(/^(\[[0-9a-z:]+\])$/);if(C)return{host:C[1],port:void 0};const _=v.match(/(.*):(\d+)$/);return _?{host:_[1],port:parseInt(_[2],10)}:{host:v,port:void 0}}}),define(Pe[23],ke([1,0,13,5,91]),function(ge,e,s,h,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.ExtensionIdentifierMap=e.ExtensionIdentifierSet=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=void 0,e.getWorkspaceSupportTypeMessage=A,e.isApplicationScopedExtension=_,e.isLanguagePackExtension=f,e.isAuthenticationProviderExtension=T,e.isResolverExtension=S,e.parseApiProposals=o,e.parseEnabledApiProposalNames=m,s=We(s),e.USER_MANIFEST_CACHE_FILE="extensions.user.cache",e.BUILTIN_MANIFEST_CACHE_FILE="extensions.builtin.cache",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function A(p){if(typeof p=="object"&&p!==null&&p.supported!==!0)return p.description}e.EXTENSION_CATEGORIES=["AI","Azure","Chat","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var L;(function(p){p[p.System=0]="System",p[p.User=1]="User"})(L||(e.ExtensionType=L={}));var R;(function(p){p.WIN32_X64="win32-x64",p.WIN32_ARM64="win32-arm64",p.LINUX_X64="linux-x64",p.LINUX_ARM64="linux-arm64",p.LINUX_ARMHF="linux-armhf",p.LINUX_PPC64LE="linux-ppc64le",p.LINUX_RISCV64="linux-riscv64",p.ALPINE_X64="alpine-x64",p.ALPINE_ARM64="alpine-arm64",p.DARWIN_X64="darwin-x64",p.DARWIN_ARM64="darwin-arm64",p.WEB="web",p.UNIVERSAL="universal",p.UNKNOWN="unknown",p.UNDEFINED="undefined"})(R||(e.TargetPlatform=R={}));class v{constructor(u){this.value=u,this._lower=u.toLowerCase()}static equals(u,i){if(typeof u>"u"||u===null)return typeof i>"u"||i===null;if(typeof i>"u"||i===null)return!1;if(typeof u=="string"||typeof i=="string"){const a=typeof u=="string"?u:u.value,t=typeof i=="string"?i:i.value;return s.equalsIgnoreCase(a,t)}return u._lower===i._lower}static toKey(u){return typeof u=="string"?u.toLowerCase():u._lower}}e.ExtensionIdentifier=v;class l{get size(){return this._set.size}constructor(u){if(this._set=new Set,u)for(const i of u)this.add(i)}add(u){this._set.add(v.toKey(u))}delete(u){return this._set.delete(v.toKey(u))}has(u){return this._set.has(v.toKey(u))}}e.ExtensionIdentifierSet=l;class C{constructor(){this._map=new Map}clear(){this._map.clear()}delete(u){this._map.delete(v.toKey(u))}get(u){return this._map.get(v.toKey(u))}has(u){return this._map.has(v.toKey(u))}set(u,i){this._map.set(v.toKey(u),i)}values(){return this._map.values()}forEach(u){this._map.forEach(u)}[Symbol.iterator](){return this._map[Symbol.iterator]()}}e.ExtensionIdentifierMap=C;function _(p){return f(p)}function f(p){return p.contributes&&p.contributes.localizations?p.contributes.localizations.length>0:!1}function T(p){return p.contributes&&p.contributes.authentication?p.contributes.authentication.length>0:!1}function S(p,u){if(u){const i=`onResolveRemoteAuthority:${(0,D.getRemoteName)(u)}`;return!!p.activationEvents?.includes(i)}return!1}function o(p){return p.map(u=>{const[i,a]=u.split("@");return{proposalName:i,version:a?parseInt(a):void 0}})}function m(p){return p.map(u=>u.split("@")[0])}e.IBuiltinExtensionsScannerService=(0,h.createDecorator)("IBuiltinExtensionsScannerService")}),define(Pe[150],ke([1,0,10,7,23,5]),function(ge,e,s,h,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.ExtensionsLocalizedLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.ExtensionGalleryError=e.ExtensionGalleryErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.ExtensionInstallSource=e.EXTENSION_INSTALL_CLIENT_TARGET_PLATFORM_CONTEXT=e.EXTENSION_INSTALL_DEP_PACK_CONTEXT=e.EXTENSION_INSTALL_SOURCE_CONTEXT=e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.TargetPlatformToString=R,e.toTargetPlatform=v,e.getTargetPlatform=l,e.isNotWebExtensionInWebTargetPlatform=C,e.isTargetPlatformCompatible=_,e.isIExtensionIdentifier=f,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension",e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT="skipWalkthrough",e.EXTENSION_INSTALL_SOURCE_CONTEXT="extensionInstallSource",e.EXTENSION_INSTALL_DEP_PACK_CONTEXT="dependecyOrPackExtensionInstall",e.EXTENSION_INSTALL_CLIENT_TARGET_PLATFORM_CONTEXT="clientTargetPlatform";var L;(function(t){t.COMMAND="command",t.SETTINGS_SYNC="settingsSync"})(L||(e.ExtensionInstallSource=L={}));function R(t){switch(t){case D.TargetPlatform.WIN32_X64:return"Windows 64 bit";case D.TargetPlatform.WIN32_ARM64:return"Windows ARM";case D.TargetPlatform.LINUX_X64:return"Linux 64 bit";case D.TargetPlatform.LINUX_ARM64:return"Linux ARM 64";case D.TargetPlatform.LINUX_ARMHF:return"Linux ARM";case D.TargetPlatform.LINUX_PPC64LE:return"Linux PowerPC64";case D.TargetPlatform.LINUX_RISCV64:return"Linux RISC-V 64";case D.TargetPlatform.ALPINE_X64:return"Alpine Linux 64 bit";case D.TargetPlatform.ALPINE_ARM64:return"Alpine ARM 64";case D.TargetPlatform.DARWIN_X64:return"Mac";case D.TargetPlatform.DARWIN_ARM64:return"Mac Silicon";case D.TargetPlatform.WEB:return"Web";case D.TargetPlatform.UNIVERSAL:return D.TargetPlatform.UNIVERSAL;case D.TargetPlatform.UNKNOWN:return D.TargetPlatform.UNKNOWN;case D.TargetPlatform.UNDEFINED:return D.TargetPlatform.UNDEFINED}}function v(t){switch(t){case D.TargetPlatform.WIN32_X64:return D.TargetPlatform.WIN32_X64;case D.TargetPlatform.WIN32_ARM64:return D.TargetPlatform.WIN32_ARM64;case D.TargetPlatform.LINUX_X64:return D.TargetPlatform.LINUX_X64;case D.TargetPlatform.LINUX_ARM64:return D.TargetPlatform.LINUX_ARM64;case D.TargetPlatform.LINUX_ARMHF:return D.TargetPlatform.LINUX_ARMHF;case D.TargetPlatform.LINUX_PPC64LE:return D.TargetPlatform.LINUX_PPC64LE;case D.TargetPlatform.LINUX_RISCV64:return D.TargetPlatform.LINUX_RISCV64;case D.TargetPlatform.ALPINE_X64:return D.TargetPlatform.ALPINE_X64;case D.TargetPlatform.ALPINE_ARM64:return D.TargetPlatform.ALPINE_ARM64;case D.TargetPlatform.DARWIN_X64:return D.TargetPlatform.DARWIN_X64;case D.TargetPlatform.DARWIN_ARM64:return D.TargetPlatform.DARWIN_ARM64;case D.TargetPlatform.WEB:return D.TargetPlatform.WEB;case D.TargetPlatform.UNIVERSAL:return D.TargetPlatform.UNIVERSAL;default:return D.TargetPlatform.UNKNOWN}}function l(t,n){switch(t){case s.Platform.Windows:return n==="x64"?D.TargetPlatform.WIN32_X64:n==="arm64"?D.TargetPlatform.WIN32_ARM64:D.TargetPlatform.UNKNOWN;case s.Platform.Linux:return n==="x64"?D.TargetPlatform.LINUX_X64:n==="arm64"?D.TargetPlatform.LINUX_ARM64:n==="arm"?D.TargetPlatform.LINUX_ARMHF:n==="ppc64le"?D.TargetPlatform.LINUX_PPC64LE:n==="riscv64"?D.TargetPlatform.LINUX_RISCV64:D.TargetPlatform.UNKNOWN;case"alpine":return n==="x64"?D.TargetPlatform.ALPINE_X64:n==="arm64"?D.TargetPlatform.ALPINE_ARM64:D.TargetPlatform.UNKNOWN;case s.Platform.Mac:return n==="x64"?D.TargetPlatform.DARWIN_X64:n==="arm64"?D.TargetPlatform.DARWIN_ARM64:D.TargetPlatform.UNKNOWN;case s.Platform.Web:return D.TargetPlatform.WEB}}function C(t,n){return n===D.TargetPlatform.WEB&&!t.includes(D.TargetPlatform.WEB)}function _(t,n,r){return C(n,r)?!1:t===D.TargetPlatform.UNDEFINED||t===D.TargetPlatform.UNIVERSAL?!0:t===D.TargetPlatform.UNKNOWN?!1:t===r}function f(t){return t&&typeof t=="object"&&typeof t.id=="string"&&(!t.uuid||typeof t.uuid=="string")}var T;(function(t){t[t.NoneOrRelevance=0]="NoneOrRelevance",t[t.LastUpdatedDate=1]="LastUpdatedDate",t[t.Title=2]="Title",t[t.PublisherName=3]="PublisherName",t[t.InstallCount=4]="InstallCount",t[t.PublishedDate=10]="PublishedDate",t[t.AverageRating=6]="AverageRating",t[t.WeightedRating=12]="WeightedRating"})(T||(e.SortBy=T={}));var S;(function(t){t[t.Default=0]="Default",t[t.Ascending=1]="Ascending",t[t.Descending=2]="Descending"})(S||(e.SortOrder=S={}));var o;(function(t){t.Install="install",t.Uninstall="uninstall"})(o||(e.StatisticType=o={}));var m;(function(t){t[t.None=1]="None",t[t.Install=2]="Install",t[t.Update=3]="Update",t[t.Migrate=4]="Migrate"})(m||(e.InstallOperation=m={})),e.IExtensionGalleryService=(0,A.createDecorator)("extensionGalleryService");var p;(function(t){t.Timeout="Timeout",t.Cancelled="Cancelled",t.Failed="Failed",t.DownloadFailedWriting="DownloadFailedWriting",t.Offline="Offline"})(p||(e.ExtensionGalleryErrorCode=p={}));class u extends Error{constructor(n,r){super(n),this.code=r,this.name=r}}e.ExtensionGalleryError=u;var i;(function(t){t.Unsupported="Unsupported",t.Deprecated="Deprecated",t.Malicious="Malicious",t.Incompatible="Incompatible",t.IncompatibleApi="IncompatibleApi",t.IncompatibleTargetPlatform="IncompatibleTargetPlatform",t.ReleaseVersionNotFound="ReleaseVersionNotFound",t.Invalid="Invalid",t.Download="Download",t.DownloadSignature="DownloadSignature",t.DownloadFailedWriting="DownloadFailedWriting",t.UpdateMetadata="UpdateMetadata",t.Extract="Extract",t.Scanning="Scanning",t.ScanningExtension="ScanningExtension",t.ReadUninstalled="ReadUninstalled",t.UnsetUninstalled="UnsetUninstalled",t.Delete="Delete",t.Rename="Rename",t.IntializeDefaultProfile="IntializeDefaultProfile",t.AddToProfile="AddToProfile",t.InstalledExtensionNotFound="InstalledExtensionNotFound",t.PostInstall="PostInstall",t.CorruptZip="CorruptZip",t.IncompleteZip="IncompleteZip",t.Signature="Signature",t.NotAllowed="NotAllowed",t.Gallery="Gallery",t.Cancelled="Cancelled",t.Unknown="Unknown",t.Internal="Internal"})(i||(e.ExtensionManagementErrorCode=i={}));class a extends Error{constructor(n,r){super(n),this.code=r,this.name=r}}e.ExtensionManagementError=a,e.IExtensionManagementService=(0,A.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,A.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,A.createDecorator)("IExtensionTipsService"),e.ExtensionsLocalizedLabel=(0,h.localize2)(1780,"Extensions"),e.PreferencesLocalizedLabel=(0,h.localize2)(1781,"Preferences")}),define(Pe[151],ke([1,0,12,23]),function(ge,e,s,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImplicitActivationEvents=e.ImplicitActivationEventsImpl=void 0;class D{constructor(){this._generators=new Map,this._cache=new WeakMap}register(L,R){this._generators.set(L,R)}readActivationEvents(L){return this._cache.has(L)||this._cache.set(L,this._readActivationEvents(L)),this._cache.get(L)}createActivationEventsMap(L){const R=Object.create(null);for(const v of L){const l=this.readActivationEvents(v);l.length>0&&(R[h.ExtensionIdentifier.toKey(v.identifier)]=l)}return R}_readActivationEvents(L){if(typeof L.main>"u"&&typeof L.browser>"u")return[];const R=Array.isArray(L.activationEvents)?L.activationEvents.slice(0):[];for(let v=0;v<R.length;v++)R[v]==="onUri"&&(R[v]=`onUri:${h.ExtensionIdentifier.toKey(L.identifier)}`);if(!L.contributes)return R;for(const v in L.contributes){const l=this._generators.get(v);if(!l)continue;const C=L.contributes[v],_=Array.isArray(C)?C:[C];try{l(_,R)}catch(f){(0,s.onUnexpectedError)(f)}}return R}}e.ImplicitActivationEventsImpl=D,e.ImplicitActivationEvents=new D});var Vt=this&&this.__importDefault||function(ge){return ge&&ge.__esModule?ge:{default:ge}};define(Pe[238],ke([1,0,22,44,7,363,23,147]),function(ge,e,s,h,D,A,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isValidVersionStr=C,e.parseVersion=_,e.normalizeVersion=f,e.isValidVersion=T,e.validateExtensionManifest=S,e.isValidExtensionVersion=o,e.isEngineValid=m,e.areApiProposalsCompatible=p,h=Vt(h),D=We(D),A=We(A);const v=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,l=/^-(\d{4})(\d{2})(\d{2})$/;function C(a){return a=a.trim(),a==="*"||v.test(a)}function _(a){if(!C(a))return null;if(a=a.trim(),a==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const t=a.match(v);return t?{hasCaret:t[1]==="^",hasGreaterEquals:t[1]===">=",majorBase:t[2]==="x"?0:parseInt(t[2],10),majorMustEqual:t[2]!=="x",minorBase:t[4]==="x"?0:parseInt(t[4],10),minorMustEqual:t[4]!=="x",patchBase:t[6]==="x"?0:parseInt(t[6],10),patchMustEqual:t[6]!=="x",preRelease:t[8]||null}:null}function f(a){if(!a)return null;const t=a.majorBase,n=a.majorMustEqual,r=a.minorBase;let d=a.minorMustEqual;const c=a.patchBase;let g=a.patchMustEqual;a.hasCaret&&(t===0||(d=!1),g=!1);let w=0;if(a.preRelease){const y=l.exec(a.preRelease);if(y){const[,I,P,k]=y;w=Date.UTC(Number(I),Number(P)-1,Number(k))}}return{majorBase:t,majorMustEqual:n,minorBase:r,minorMustEqual:d,patchBase:c,patchMustEqual:g,isMinimum:a.hasGreaterEquals,notBefore:w}}function T(a,t,n){let r;typeof a=="string"?r=f(_(a)):r=a;let d;t instanceof Date?d=t.getTime():typeof t=="string"&&(d=new Date(t).getTime());let c;if(typeof n=="string"?c=f(_(n)):c=n,!r||!c)return!1;const g=r.majorBase,w=r.minorBase,y=r.patchBase;let I=c.majorBase,P=c.minorBase,k=c.patchBase;const b=c.notBefore;let E=c.majorMustEqual,N=c.minorMustEqual,O=c.patchMustEqual;return c.isMinimum?g>I?!0:g<I?!1:w>P?!0:w<P||d&&d<b?!1:y>=k:(g===1&&I===0&&(!E||!N||!O)&&(I=1,P=0,k=0,E=!0,N=!1,O=!1),g<I?!1:g>I?!E:w<P?!1:w>P?!N:y<k?!1:y>k?!O:!(d&&d<b))}function S(a,t,n,r,d,c){const g=[];if(typeof r.publisher<"u"&&typeof r.publisher!="string")return g.push([h.default.Error,D.localize(1832,null)]),g;if(typeof r.name!="string")return g.push([h.default.Error,D.localize(1833,null,"name")]),g;if(typeof r.version!="string")return g.push([h.default.Error,D.localize(1834,null,"version")]),g;if(!r.engines)return g.push([h.default.Error,D.localize(1835,null,"engines")]),g;if(typeof r.engines.vscode!="string")return g.push([h.default.Error,D.localize(1836,null,"engines.vscode")]),g;if(typeof r.extensionDependencies<"u"&&!i(r.extensionDependencies))return g.push([h.default.Error,D.localize(1837,null,"extensionDependencies")]),g;if(typeof r.activationEvents<"u"){if(!i(r.activationEvents))return g.push([h.default.Error,D.localize(1838,null,"activationEvents")]),g;if(typeof r.main>"u"&&typeof r.browser>"u")return g.push([h.default.Error,D.localize(1839,null,"activationEvents","main","browser")]),g}if(typeof r.extensionKind<"u"&&typeof r.main>"u"&&g.push([h.default.Warning,D.localize(1840,null,"extensionKind")]),typeof r.main<"u"){if(typeof r.main!="string")return g.push([h.default.Error,D.localize(1841,null,"main")]),g;{const I=(0,s.joinPath)(n,r.main);(0,s.isEqualOrParent)(I,n)||g.push([h.default.Warning,D.localize(1842,null,I.path,n.path)])}}if(typeof r.browser<"u"){if(typeof r.browser!="string")return g.push([h.default.Error,D.localize(1843,null,"browser")]),g;{const I=(0,s.joinPath)(n,r.browser);(0,s.isEqualOrParent)(I,n)||g.push([h.default.Warning,D.localize(1844,null,I.path,n.path)])}}if(!A.valid(r.version))return g.push([h.default.Error,D.localize(1845,null)]),g;const w=[];if(!o(a,t,r,d,w))for(const I of w)g.push([h.default.Error,I]);if(c&&r.enabledApiProposals?.length){const I=[];if(!p([...r.enabledApiProposals],I))for(const P of I)g.push([h.default.Error,P])}return g}function o(a,t,n,r,d){return r||typeof n.main>"u"&&typeof n.browser>"u"?!0:u(a,t,n.engines.vscode,d)}function m(a,t,n){return a==="*"||u(t,n,a)}function p(a,t){if(a.length===0)return!0;const n=Array.isArray(t)?t:void 0,r=(n?void 0:t)??R.allApiProposals,d=[],c=(0,L.parseApiProposals)(a);for(const{proposalName:g,version:w}of c){const y=r[g];y&&w&&y.version!==w&&d.push(D.localize(1846,null,g))}return n?.push(...d),d.length===0}function u(a,t,n,r=[]){const d=f(_(n));if(!d)return r.push(D.localize(1847,null,n)),!1;if(d.majorBase===0){if(!d.majorMustEqual||!d.minorMustEqual)return r.push(D.localize(1848,null,n)),!1}else if(!d.majorMustEqual)return r.push(D.localize(1849,null,n)),!1;return T(a,t,d)?!0:(r.push(D.localize(1850,null,a,n)),!1)}function i(a){if(!Array.isArray(a))return!1;for(let t=0,n=a.length;t<n;t++)if(typeof a[t]!="string")return!1;return!0}}),define(Pe[239],ke([1,0,3,5]),function(ge,e,s,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteSocketFactoryService=e.IRemoteSocketFactoryService=void 0,e.IRemoteSocketFactoryService=(0,h.createDecorator)("remoteSocketFactoryService");class D{constructor(){this.factories={}}register(L,R){return this.factories[L]??=[],this.factories[L].push(R),(0,s.toDisposable)(()=>{const v=this.factories[L]?.indexOf(R);typeof v=="number"&&v>=0&&this.factories[L]?.splice(v,1)})}getSocketFactory(L){return(this.factories[L.type]||[]).find(v=>v.supports(L))}connect(L,R,v,l){const C=this.getSocketFactory(L);if(!C)throw new Error(`No socket factory found for ${L}`);return C.connect(L,R,v,l)}}e.RemoteSocketFactoryService=D}),define(Pe[240],ke([1,0,21,12,3,7,72,5,11,37]),function(ge,e,s,h,D,A,L,R,v,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractRequestService=e.IRequestService=void 0,e.isSuccess=f,e.hasNoContent=T,e.asText=S,e.asTextOrError=o,e.asJson=m,e.updateProxyConfigurationsScope=p,e.IRequestService=(0,R.createDecorator)("requestService");class C{constructor(t){this.original=t}toJSON(){if(!this.headers){const t=Object.create(null);for(const n in this.original)n.toLowerCase()==="authorization"||n.toLowerCase()==="proxy-authorization"?t[n]="*****":t[n]=this.original[n];this.headers=t}return this.headers}}class _ extends D.Disposable{constructor(t){super(),this.counter=0,this.logger=t.createLogger("network",{name:(0,A.localize)(2050,null),when:v.CONTEXT_LOG_LEVEL.isEqualTo((0,v.LogLevelToString)(v.LogLevel.Trace)).serialize()})}async logAndRequest(t,n,r){const d=`${t} #${++this.counter}: ${n.url}`;this.logger.trace(`${d} - begin`,n.type,new C(n.headers??{}));try{const c=await r();return this.logger.trace(`${d} - end`,n.type,c.res.statusCode,c.res.headers),c}catch(c){throw this.logger.error(`${d} - error`,n.type,(0,h.getErrorMessage)(c)),c}}}e.AbstractRequestService=_;function f(a){return a.res.statusCode&&a.res.statusCode>=200&&a.res.statusCode<300||a.res.statusCode===1223}function T(a){return a.res.statusCode===204}async function S(a){return T(a)?null:(await(0,s.streamToBuffer)(a.stream)).toString()}async function o(a){if(!f(a))throw new Error("Server returned "+a.res.statusCode);return S(a)}async function m(a){if(!f(a))throw new Error("Server returned "+a.res.statusCode);if(T(a))return null;const n=(await(0,s.streamToBuffer)(a.stream)).toString();try{return JSON.parse(n)}catch(r){throw r.message+=`:
`+n,r}}function p(a){i(a)}let u;function i(a){const t=l.Registry.as(L.Extensions.Configuration),n=u;u={id:"http",order:15,title:(0,A.localize)(2051,null),type:"object",scope:a,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,A.localize)(2052,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,A.localize)(2053,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,A.localize)(2054,null),restricted:!0},"http.noProxy":{type:"array",items:{type:"string"},markdownDescription:(0,A.localize)(2055,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,A.localize)(2056,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,A.localize)(2057,null),(0,A.localize)(2058,null),(0,A.localize)(2059,null),(0,A.localize)(2060,null)],default:"override",description:(0,A.localize)(2061,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,A.localize)(2062,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,A.localize)(2063,null),restricted:!0}}},t.updateConfigurations({add:[u],remove:n?[n]:[]})}i(L.ConfigurationScope.APPLICATION)}),define(Pe[241],ke([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractSignService=void 0;class s{constructor(){this.validators=new Map}static{this._nextId=1}async createNewMessage(D){try{const A=await this.getValidator();if(A){const L=String(s._nextId++);return this.validators.set(L,A),{id:L,data:A.createNewMessage(D)}}}catch{}return{id:"",data:D}}async validate(D,A){if(!D.id)return!0;const L=this.validators.get(D.id);if(!L)return!1;this.validators.delete(D.id);try{return L.validate(A)==="ok"}catch{return!1}finally{L.dispose?.()}}async sign(D){try{return await this.signValue(D)}catch{}return D}}e.AbstractSignService=s}),define(Pe[117],ke([1,0,5]),function(ge,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,s.createDecorator)(e.SIGN_SERVICE_ID)}),define(Pe[152],ke([1,0,144,241]),function(ge,e,s,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class D extends h.AbstractSignService{getValidator(){return this.vsda().then(L=>new L.validator)}signValue(L){return this.vsda().then(R=>new R.signer().sign(L))}async vsda(){return(0,s.importAMDNodeModule)("vsda","index.js")}}e.SignService=D}),define(Pe[242],ke([1,0,10,57,31]),function(ge,e,s,h,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveCommonProperties=L,e.verifyMicrosoftInternalDomain=R;function A(v){if(s.platform===s.Platform.Linux&&/^penguin(\.|$)/i.test(v))return"chromebook"}function L(v,l,C,_,f,T,S,o,m,p){const u=Object.create(null);u["common.machineId"]=T,u["common.sqmId"]=S,u["common.devDeviceId"]=o,u.sessionID=(0,D.generateUuid)()+Date.now(),u.commitHash=_,u.version=f,u["common.platformVersion"]=(v||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),u["common.platform"]=(0,s.PlatformToString)(s.platform),u["common.nodePlatform"]=h.platform,u["common.nodeArch"]=C,u["common.product"]=p||"desktop",m&&(u["common.msftInternal"]=m);let i=0;const a=Date.now();Object.defineProperties(u,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-a,enumerable:!0},"common.sequence":{get:()=>i++,enumerable:!0}}),s.isLinuxSnap&&(u["common.snap"]="true");const t=A(l);return t&&(u["common.platformDetail"]=t),u}function R(v){const l=h.env.USERDNSDOMAIN;if(!l)return!1;const C=l.toLowerCase();return v.some(_=>C===_)}}),define(Pe[153],ke([1,0,5]),function(ge,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_CRASH_REPORTER_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.devDeviceIdKey=e.sqmIdKey=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,s.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,s.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.sqmIdKey="telemetry.sqmId",e.devDeviceIdKey="telemetry.devDeviceId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_CRASH_REPORTER_SETTING_ID="telemetry.enableCrashReporter",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var h;(function(A){A[A.NONE=0]="NONE",A[A.CRASH=1]="CRASH",A[A.ERROR=2]="ERROR",A[A.USAGE=3]="USAGE"})(h||(e.TelemetryLevel=h={}));var D;(function(A){A.OFF="off",A.CRASH="crash",A.ERROR="error",A.ON="all"})(D||(e.TelemetryConfiguration=D={}))}),define(Pe[92],ke([1,0,24,17,91,242,153]),function(ge,e,s,h,D,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullAppender=e.extensionTelemetryLogChannelId=e.telemetryLogId=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TelemetryTrustedValue=void 0,e.supportsTelemetry=C,e.isLoggingOnly=_,e.getTelemetryLevel=f,e.validateTelemetryData=T,e.cleanRemoteAuthority=o,e.isInternalTelemetry=p,e.getPiiPathsFromEnvironment=u,e.cleanData=t;class R{constructor(r){this.value=r,this.isTrustedTelemetryValue=!0}}e.TelemetryTrustedValue=R;class v{constructor(){this.telemetryLevel=L.TelemetryLevel.NONE,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.devDeviceId="someValue.devDeviceId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.NullTelemetryServiceShape=v,e.NullTelemetryService=new v;class l{async publicLog(r,d,c){}async publicLogError(r,d,c){}}e.NullEndpointTelemetryService=l,e.telemetryLogId="telemetry",e.extensionTelemetryLogChannelId="extensionTelemetryLog",e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function C(n,r){return!r.isBuilt&&!r.disableTelemetry?!0:!(r.disableTelemetry||!n.enableTelemetry)}function _(n,r){return r.extensionTestsLocationURI?!0:!(r.isBuilt||r.disableTelemetry||n.enableTelemetry&&n.aiConfig?.ariaKey)}function f(n){const r=n.getValue(L.TELEMETRY_SETTING_ID),d=n.getValue(L.TELEMETRY_CRASH_REPORTER_SETTING_ID);if(n.getValue(L.TELEMETRY_OLD_SETTING_ID)===!1||d===!1)return L.TelemetryLevel.NONE;switch(r??L.TelemetryConfiguration.ON){case L.TelemetryConfiguration.ON:return L.TelemetryLevel.USAGE;case L.TelemetryConfiguration.ERROR:return L.TelemetryLevel.ERROR;case L.TelemetryConfiguration.CRASH:return L.TelemetryLevel.CRASH;case L.TelemetryConfiguration.OFF:return L.TelemetryLevel.NONE}}function T(n){const r={},d={},c={};m(n,c);for(let g in c){g=g.length>150?g.substr(g.length-149):g;const w=c[g];typeof w=="number"?d[g]=w:typeof w=="boolean"?d[g]=w?1:0:typeof w=="string"?(w.length>8192&&console.warn(`Telemetry property: ${g} has been trimmed to 8192, the original length is ${w.length}`),r[g]=w.substring(0,8191)):typeof w<"u"&&w!==null&&(r[g]=w)}return{properties:r,measurements:d}}const S=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function o(n){if(!n)return"none";const r=(0,D.getRemoteName)(n);return S.has(r)?r:"other"}function m(n,r,d=0,c){if(n)for(const g of Object.getOwnPropertyNames(n)){const w=n[g],y=c?c+g:g;Array.isArray(w)?r[y]=(0,s.safeStringify)(w):w instanceof Date?r[y]=w.toISOString():(0,h.isObject)(w)?d<2?m(w,r,d+1,y+"."):r[y]=(0,s.safeStringify)(w):r[y]=w}}function p(n,r){const d=n.msftInternalDomains||[],c=r.getValue("telemetry.internalTesting");return(0,A.verifyMicrosoftInternalDomain)(d)||c}function u(n){return[n.appRoot,n.extensionsPath,n.userHome.fsPath,n.tmpDir.fsPath,n.userDataPath]}function i(n,r){if(!n||!n.includes("/")&&!n.includes("\\"))return n;let d=n;const c=[];for(const I of r)for(;;){const P=I.exec(n);if(!P)break;c.push([P.index,I.lastIndex])}const g=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,w=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let y=0;for(d="";;){const I=w.exec(n);if(!I)break;const P=c.some(([k,b])=>I.index<b&&k<w.lastIndex);!g.test(I[0])&&!P&&(d+=n.substring(y,I.index)+"<REDACTED: user-file-path>",y=w.lastIndex)}return y<n.length&&(d+=n.substr(y)),d}function a(n){if(!n)return n;const r=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"CLI Credentials",regex:/((login|psexec|(certutil|psexec)\.exe).{1,50}(\s-u(ser(name)?)?\s+.{3,100})?\s-(admin|user|vm|root)?p(ass(word)?)?\s+["']?[^$\-\/\s]|(^|[\s\r\n\\])net(\.exe)?.{1,5}(user\s+|share\s+\/user:| user -? secrets ? set) \s + [^ $\s \/])/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const d of r)if(d.regex.test(n))return`<REDACTED: ${d.label}>`;return n}function t(n,r){return(0,s.cloneAndChange)(n,d=>{if(d instanceof R||Object.hasOwnProperty.call(d,"isTrustedTelemetryValue"))return d.value;if(typeof d=="string"){let c=d.replaceAll("%20"," ");c=i(c,r);for(const g of r)c=c.replace(g,"");return c=a(c),c}})}}),define(Pe[243],ke([1,0,13,150,23,10,2,12,57,92]),function(ge,e,s,h,D,A,L,R,v,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BetterMergeId=e.ExtensionKey=void 0,e.areSameExtensions=C,e.getIdAndVersion=S,e.getExtensionId=o,e.adoptToGalleryExtensionId=m,e.getGalleryExtensionId=p,e.groupByExtension=u,e.getLocalExtensionTelemetryData=i,e.getGalleryExtensionTelemetryData=a,e.getExtensionDependencies=t,e.computeTargetPlatform=r;function C(d,c){return d.uuid&&c.uuid?d.uuid===c.uuid:d.id===c.id?!0:(0,s.compareIgnoreCase)(d.id,c.id)===0}const _=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class f{static create(c){const g=c.manifest?c.manifest.version:c.version,w=c.manifest?c.targetPlatform:c.properties.targetPlatform;return new f(c.identifier,g,w)}static parse(c){const g=_.exec(c);return g&&g[1]&&g[2]?new f({id:g[1]},g[2],g[4]||void 0):null}constructor(c,g,w=D.TargetPlatform.UNDEFINED){this.identifier=c,this.version=g,this.targetPlatform=w,this.id=c.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!==D.TargetPlatform.UNDEFINED?`-${this.targetPlatform}`:""}`}equals(c){return c instanceof f?C(this,c)&&this.version===c.version&&this.targetPlatform===c.targetPlatform:!1}}e.ExtensionKey=f;const T=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function S(d){const c=T.exec(d);return c&&c[1]?[m(c[1]),c[2]]:[m(d),void 0]}function o(d,c){return`${d}.${c}`}function m(d){return d.toLowerCase()}function p(d,c){return m(o(d??D.UNDEFINED_PUBLISHER,c))}function u(d,c){const g=[],w=y=>{for(const I of g)if(I.some(P=>C(c(P),c(y))))return I;return null};for(const y of d){const I=w(y);I?I.push(y):g.push([y])}return g}function i(d){return{id:d.identifier.id,name:d.manifest.name,galleryId:null,publisherId:d.publisherId,publisherName:d.manifest.publisher,publisherDisplayName:d.publisherDisplayName,dependencies:d.manifest.extensionDependencies&&d.manifest.extensionDependencies.length>0}}function a(d){return{id:new l.TelemetryTrustedValue(d.identifier.id),name:new l.TelemetryTrustedValue(d.name),version:d.version,galleryId:d.identifier.uuid,publisherId:d.publisherId,publisherName:d.publisher,publisherDisplayName:d.publisherDisplayName,isPreReleaseVersion:d.properties.isPreReleaseVersion,dependencies:!!(d.properties.dependencies&&d.properties.dependencies.length>0),isSigned:d.isSigned,...d.telemetryData}}e.BetterMergeId=new D.ExtensionIdentifier("pprice.better-merge");function t(d,c){const g=[],w=c.manifest.extensionDependencies?.slice(0)??[];for(;w.length;){const y=w.shift();if(y&&g.every(I=>!C(I.identifier,{id:y}))){const I=d.filter(P=>C(P.identifier,{id:y}));I.length===1&&(g.push(I[0]),w.push(...I[0].manifest.extensionDependencies?.slice(0)??[]))}}return g}async function n(d,c){if(!A.isLinux)return!1;let g;try{g=(await d.readFile(L.URI.file("/etc/os-release"))).value.toString()}catch{try{g=(await d.readFile(L.URI.file("/usr/lib/os-release"))).value.toString()}catch(y){c.debug("Error while getting the os-release file.",(0,R.getErrorMessage)(y))}}return!!g&&(g.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function r(d,c){const g=await n(d,c),w=(0,h.getTargetPlatform)(g?"alpine":A.platform,v.arch);return c.debug("ComputeTargetPlatform:",w),w}}),define(Pe[244],ke([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.serializeEnvironmentVariableCollection=s,e.serializeEnvironmentDescriptionMap=h,e.deserializeEnvironmentVariableCollection=D,e.deserializeEnvironmentDescriptionMap=A,e.serializeEnvironmentVariableCollections=L,e.deserializeEnvironmentVariableCollections=R;function s(v){return[...v.entries()]}function h(v){return v?[...v.entries()]:[]}function D(v){return new Map(v)}function A(v){return new Map(v??[])}function L(v){return Array.from(v.entries()).map(l=>[l[0],s(l[1].map),h(l[1].descriptionMap)])}function R(v){return new Map(v.map(l=>[l[0],{map:D(l[1]),descriptionMap:A(l[2])}]))}}),define(Pe[245],ke([1,0,5,36,37]),function(ge,e,s,h,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ITerminalLogService=e.ILocalPtyService=e.TerminalExtensions=e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.IPtyService=e.ProcessPropertyType=e.TerminalIpcChannels=e.TitleEventSource=e.GeneralShellType=e.WindowsShellType=e.PosixShellType=e.TerminalSettingId=e.TerminalSettingPrefix=e.terminalTabFocusModeContextKey=void 0,e.terminalTabFocusModeContextKey=new h.RawContextKey("terminalTabFocusMode",!1,!0);var A;(function(n){n.AutomationProfile="terminal.integrated.automationProfile.",n.DefaultProfile="terminal.integrated.defaultProfile.",n.Profiles="terminal.integrated.profiles."})(A||(e.TerminalSettingPrefix=A={}));var L;(function(n){n.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",n.AutomationProfileLinux="terminal.integrated.automationProfile.linux",n.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",n.AutomationProfileWindows="terminal.integrated.automationProfile.windows",n.ProfilesWindows="terminal.integrated.profiles.windows",n.ProfilesMacOs="terminal.integrated.profiles.osx",n.ProfilesLinux="terminal.integrated.profiles.linux",n.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",n.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",n.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",n.UseWslProfiles="terminal.integrated.useWslProfiles",n.TabsDefaultColor="terminal.integrated.tabs.defaultColor",n.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",n.TabsEnabled="terminal.integrated.tabs.enabled",n.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",n.TabsHideCondition="terminal.integrated.tabs.hideCondition",n.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",n.TabsShowActions="terminal.integrated.tabs.showActions",n.TabsLocation="terminal.integrated.tabs.location",n.TabsFocusMode="terminal.integrated.tabs.focusMode",n.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",n.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",n.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",n.CopyOnSelection="terminal.integrated.copyOnSelection",n.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",n.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",n.FontFamily="terminal.integrated.fontFamily",n.FontSize="terminal.integrated.fontSize",n.LetterSpacing="terminal.integrated.letterSpacing",n.LineHeight="terminal.integrated.lineHeight",n.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",n.TabStopWidth="terminal.integrated.tabStopWidth",n.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",n.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",n.BellDuration="terminal.integrated.bellDuration",n.FontWeight="terminal.integrated.fontWeight",n.FontWeightBold="terminal.integrated.fontWeightBold",n.CursorBlinking="terminal.integrated.cursorBlinking",n.CursorStyle="terminal.integrated.cursorStyle",n.CursorStyleInactive="terminal.integrated.cursorStyleInactive",n.CursorWidth="terminal.integrated.cursorWidth",n.Scrollback="terminal.integrated.scrollback",n.DetectLocale="terminal.integrated.detectLocale",n.DefaultLocation="terminal.integrated.defaultLocation",n.GpuAcceleration="terminal.integrated.gpuAcceleration",n.TerminalTitleSeparator="terminal.integrated.tabs.separator",n.TerminalTitle="terminal.integrated.tabs.title",n.TerminalDescription="terminal.integrated.tabs.description",n.RightClickBehavior="terminal.integrated.rightClickBehavior",n.MiddleClickBehavior="terminal.integrated.middleClickBehavior",n.Cwd="terminal.integrated.cwd",n.ConfirmOnExit="terminal.integrated.confirmOnExit",n.ConfirmOnKill="terminal.integrated.confirmOnKill",n.EnableBell="terminal.integrated.enableBell",n.EnableVisualBell="terminal.integrated.enableVisualBell",n.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",n.AllowChords="terminal.integrated.allowChords",n.AllowMnemonics="terminal.integrated.allowMnemonics",n.TabFocusMode="terminal.integrated.tabFocusMode",n.EnvMacOs="terminal.integrated.env.osx",n.EnvLinux="terminal.integrated.env.linux",n.EnvWindows="terminal.integrated.env.windows",n.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",n.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",n.ExperimentalWindowsUseConptyDll="terminal.integrated.experimental.windowsUseConptyDll",n.ShowExitAlert="terminal.integrated.showExitAlert",n.SplitCwd="terminal.integrated.splitCwd",n.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",n.WordSeparators="terminal.integrated.wordSeparators",n.EnableFileLinks="terminal.integrated.enableFileLinks",n.AllowedLinkSchemes="terminal.integrated.allowedLinkSchemes",n.UnicodeVersion="terminal.integrated.unicodeVersion",n.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",n.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",n.HideOnStartup="terminal.integrated.hideOnStartup",n.CustomGlyphs="terminal.integrated.customGlyphs",n.RescaleOverlappingGlyphs="terminal.integrated.rescaleOverlappingGlyphs",n.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",n.InheritEnv="terminal.integrated.inheritEnv",n.ShowLinkHover="terminal.integrated.showLinkHover",n.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",n.AutoReplies="terminal.integrated.autoReplies",n.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",n.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",n.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",n.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",n.EnableImages="terminal.integrated.enableImages",n.SmoothScrolling="terminal.integrated.smoothScrolling",n.IgnoreBracketedPasteMode="terminal.integrated.ignoreBracketedPasteMode",n.FocusAfterRun="terminal.integrated.focusAfterRun",n.DeveloperPtyHostLatency="terminal.integrated.developer.ptyHost.latency",n.DeveloperPtyHostStartupDelay="terminal.integrated.developer.ptyHost.startupDelay",n.DevMode="terminal.integrated.developer.devMode"})(L||(e.TerminalSettingId=L={}));var R;(function(n){n.Bash="bash",n.Fish="fish",n.Sh="sh",n.Csh="csh",n.Ksh="ksh",n.Zsh="zsh"})(R||(e.PosixShellType=R={}));var v;(function(n){n.CommandPrompt="cmd",n.Wsl="wsl",n.GitBash="gitbash"})(v||(e.WindowsShellType=v={}));var l;(function(n){n.PowerShell="pwsh",n.Python="python",n.Julia="julia",n.NuShell="nu"})(l||(e.GeneralShellType=l={}));var C;(function(n){n[n.Api=0]="Api",n[n.Process=1]="Process",n[n.Sequence=2]="Sequence",n[n.Config=3]="Config"})(C||(e.TitleEventSource=C={}));var _;(function(n){n.LocalPty="localPty",n.PtyHost="ptyHost",n.PtyHostWindow="ptyHostWindow",n.Logger="logger",n.Heartbeat="heartbeat"})(_||(e.TerminalIpcChannels=_={}));var f;(function(n){n.Cwd="cwd",n.InitialCwd="initialCwd",n.FixedDimensions="fixedDimensions",n.Title="title",n.ShellType="shellType",n.HasChildProcesses="hasChildProcesses",n.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",n.OverrideDimensions="overrideDimensions",n.FailedShellIntegrationActivation="failedShellIntegrationActivation",n.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(f||(e.ProcessPropertyType=f={})),e.IPtyService=(0,s.createDecorator)("ptyService");var T;(function(n){n[n.BeatInterval=5e3]="BeatInterval",n[n.ConnectingBeatInterval=2e4]="ConnectingBeatInterval",n[n.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",n[n.SecondWaitMultiplier=1]="SecondWaitMultiplier",n[n.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(T||(e.HeartbeatConstants=T={}));var S;(function(n){n[n.Panel=1]="Panel",n[n.Editor=2]="Editor"})(S||(e.TerminalLocation=S={}));var o;(function(n){n.TerminalView="view",n.Editor="editor"})(o||(e.TerminalLocationString=o={}));var m;(function(n){n[n.GraceTime=6e4]="GraceTime",n[n.ShortGraceTime=6e3]="ShortGraceTime"})(m||(e.LocalReconnectConstants=m={}));var p;(function(n){n[n.HighWatermarkChars=1e5]="HighWatermarkChars",n[n.LowWatermarkChars=5e3]="LowWatermarkChars",n[n.CharCountAckSize=5e3]="CharCountAckSize"})(p||(e.FlowControlConstants=p={}));var u;(function(n){n.GitBash="Git Bash",n.Pwsh="PowerShell"})(u||(e.ProfileSource=u={}));var i;(function(n){n[n.Off=0]="Off",n[n.FinalTerm=1]="FinalTerm",n[n.VSCode=2]="VSCode"})(i||(e.ShellIntegrationStatus=i={}));var a;(function(n){n[n.Unknown=0]="Unknown",n[n.Shutdown=1]="Shutdown",n[n.Process=2]="Process",n[n.User=3]="User",n[n.Extension=4]="Extension"})(a||(e.TerminalExitReason=a={})),e.TerminalExtensions={Backend:"workbench.contributions.terminal.processBackend"};class t{constructor(){this._backends=new Map}get backends(){return this._backends}registerTerminalBackend(r){const d=this._sanitizeRemoteAuthority(r.remoteAuthority);if(this._backends.has(d))throw new Error(`A terminal backend with remote authority '${d}' was already registered.`);this._backends.set(d,r)}getTerminalBackend(r){return this._backends.get(this._sanitizeRemoteAuthority(r))}_sanitizeRemoteAuthority(r){return r?.toLowerCase()??""}}D.Registry.add(e.TerminalExtensions.Backend,new t),e.ILocalPtyService=(0,s.createDecorator)("localPtyService"),e.ITerminalLogService=(0,s.createDecorator)("terminalLogService")}),define(Pe[246],ke([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class s{constructor(D){this._callback=D,this._terminalBufferMap=new Map}dispose(){for(const D of this._terminalBufferMap.values())D.dispose()}startBuffering(D,A,L=5){const R=A(v=>{const l=typeof v=="string"?v:v.data;let C=this._terminalBufferMap.get(D);if(C){C.data.push(l);return}const _=setTimeout(()=>this.flushBuffer(D),L);C={data:[l],timeoutId:_,dispose:()=>{clearTimeout(_),this.flushBuffer(D),R.dispose()}},this._terminalBufferMap.set(D,C)});return R}stopBuffering(D){this._terminalBufferMap.get(D)?.dispose()}flushBuffer(D){const A=this._terminalBufferMap.get(D);A&&(this._terminalBufferMap.delete(D),this._callback(D,A.data.join("")))}}e.TerminalDataBufferer=s}),define(Pe[247],ke([1,0,8,84,104,51,4,17,2,7,116,37]),function(ge,e,s,h,D,A,L,R,v,l,C,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.spinningLoading=e.syncing=e.gotoNextLocation=e.gotoPreviousLocation=e.widgetClose=e.iconsSchemaId=e.IconFontDefinition=e.IconContribution=e.Extensions=void 0,e.registerIcon=m,e.getIconRegistry=p,_=We(_),e.Extensions={IconContribution:"base.contributions.icons"};var f;(function(t){function n(r,d){let c=r.defaults;for(;A.ThemeIcon.isThemeIcon(c);){const g=o.getIcon(c.id);if(!g)return;c=g.defaults}return c}t.getDefinition=n})(f||(e.IconContribution=f={}));var T;(function(t){function n(d){return{weight:d.weight,style:d.style,src:d.src.map(c=>({format:c.format,location:c.location.toString()}))}}t.toJSONObject=n;function r(d){const c=g=>(0,R.isString)(g)?g:void 0;if(d&&Array.isArray(d.src)&&d.src.every(g=>(0,R.isString)(g.format)&&(0,R.isString)(g.location)))return{weight:c(d.weight),style:c(d.style),src:d.src.map(g=>({format:g.format,location:v.URI.parse(g.location)}))}}t.fromJSONObject=r})(T||(e.IconFontDefinition=T={}));class S{constructor(){this._onDidChange=new L.Emitter,this.onDidChange=this._onDidChange.event,this.iconSchema={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,l.localize)(2364,null)},fontCharacter:{type:"string",description:(0,l.localize)(2365,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.iconReferenceSchema={type:"string",pattern:`^${A.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.iconsById={},this.iconFontsById={}}registerIcon(n,r,d,c){const g=this.iconsById[n];if(g){if(d&&!g.description){g.description=d,this.iconSchema.properties[n].markdownDescription=`${d} $(${n})`;const I=this.iconReferenceSchema.enum.indexOf(n);I!==-1&&(this.iconReferenceSchema.enumDescriptions[I]=d),this._onDidChange.fire()}return g}const w={id:n,description:d,defaults:r,deprecationMessage:c};this.iconsById[n]=w;const y={$ref:"#/definitions/icons"};return c&&(y.deprecationMessage=c),d&&(y.markdownDescription=`${d}: $(${n})`),this.iconSchema.properties[n]=y,this.iconReferenceSchema.enum.push(n),this.iconReferenceSchema.enumDescriptions.push(d||""),this._onDidChange.fire(),{id:n}}deregisterIcon(n){delete this.iconsById[n],delete this.iconSchema.properties[n];const r=this.iconReferenceSchema.enum.indexOf(n);r!==-1&&(this.iconReferenceSchema.enum.splice(r,1),this.iconReferenceSchema.enumDescriptions.splice(r,1)),this._onDidChange.fire()}getIcons(){return Object.keys(this.iconsById).map(n=>this.iconsById[n])}getIcon(n){return this.iconsById[n]}getIconSchema(){return this.iconSchema}getIconReferenceSchema(){return this.iconReferenceSchema}registerIconFont(n,r){const d=this.iconFontsById[n];return d||(this.iconFontsById[n]=r,this._onDidChange.fire(),r)}deregisterIconFont(n){delete this.iconFontsById[n]}getIconFont(n){return this.iconFontsById[n]}toString(){const n=(g,w)=>g.id.localeCompare(w.id),r=g=>{for(;A.ThemeIcon.isThemeIcon(g.defaults);)g=this.iconsById[g.defaults.id];return`codicon codicon-${g?g.id:""}`},d=[];d.push("| preview     | identifier                        | default codicon ID                | description"),d.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const c=Object.keys(this.iconsById).map(g=>this.iconsById[g]);for(const g of c.filter(w=>!!w.description).sort(n))d.push(`|<i class="${r(g)}"></i>|${g.id}|${A.ThemeIcon.isThemeIcon(g.defaults)?g.defaults.id:g.id}|${g.description||""}|`);d.push("| preview     | identifier                        "),d.push("| ----------- | --------------------------------- |");for(const g of c.filter(w=>!A.ThemeIcon.isThemeIcon(w.defaults)).sort(n))d.push(`|<i class="${r(g)}"></i>|${g.id}|`);return d.join(`
`)}}const o=new S;_.Registry.add(e.Extensions.IconContribution,o);function m(t,n,r,d){return o.registerIcon(t,n,r,d)}function p(){return o}function u(){const t=(0,D.getCodiconFontCharacters)();for(const n in t){const r="\\"+t[n].toString(16);o.registerIcon(n,{fontCharacter:r})}}u(),e.iconsSchemaId="vscode://schemas/icons";const i=_.Registry.as(C.Extensions.JSONContribution);i.registerSchema(e.iconsSchemaId,o.getIconSchema());const a=new s.RunOnceScheduler(()=>i.notifySchemaChanged(e.iconsSchemaId),200);o.onDidChange(()=>{a.isScheduled()||a.schedule()}),e.widgetClose=m("widget-close",h.Codicon.close,(0,l.localize)(2366,null)),e.gotoPreviousLocation=m("goto-previous-location",h.Codicon.arrowUp,(0,l.localize)(2367,null)),e.gotoNextLocation=m("goto-next-location",h.Codicon.arrowDown,(0,l.localize)(2368,null)),e.syncing=A.ThemeIcon.modify(h.Codicon.sync,"spin"),e.spinningLoading=A.ThemeIcon.modify(h.Codicon.loading,"spin")}),define(Pe[93],ke([1,0,4,3,10,2,46,5,11]),function(ge,e,s,h,D,A,L,R,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.ALL_INTERFACES_ADDRESSES=e.LOCALHOST_ADDRESSES=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.isTunnelProvider=_,e.extractLocalHostUriMetaDataForPortMapping=T,e.extractQueryLocalHostUriMetaDataForPortMapping=S,e.isLocalhost=o,e.isAllInterfaces=m,e.isPortPrivileged=p,e.ITunnelService=(0,R.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,R.createDecorator)("sharedTunnelsService");var l;(function(a){a.Http="http",a.Https="https"})(l||(e.TunnelProtocol=l={}));var C;(function(a){a.ConstantPrivate="constantPrivate",a.Private="private",a.Public="public"})(C||(e.TunnelPrivacyId=C={}));function _(a){return!!a.forwardPort}var f;(function(a){a[a.Notify=1]="Notify",a[a.OpenBrowser=2]="OpenBrowser",a[a.OpenPreview=3]="OpenPreview",a[a.Silent=4]="Silent",a[a.Ignore=5]="Ignore",a[a.OpenBrowserOnce=6]="OpenBrowserOnce"})(f||(e.ProvidedOnAutoForward=f={}));function T(a){if(a.scheme!=="http"&&a.scheme!=="https")return;const t=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(a.authority);if(t)return{address:t[1],port:+t[2]}}function S(a){if(a.scheme!=="http"&&a.scheme!=="https"||!a.query)return;const t=a.query.split("&");for(const n of t){const r=n.split("=")[1];if(/^https?:/.exec(r)){const d=T(A.URI.parse(r));if(d)return d}}}e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function o(a){return e.LOCALHOST_ADDRESSES.indexOf(a)>=0}e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function m(a){return e.ALL_INTERFACES_ADDRESSES.indexOf(a)>=0}function p(a,t,n,r){if(n===D.OperatingSystem.Windows)return!1;if(n===D.OperatingSystem.Macintosh&&m(t)){const d=/(\d+)\.(\d+)\.(\d+)/g.exec(r);if(d?.length===4&&parseInt(d[1])>=18)return!1}return a<1024}class u{constructor(t,n,r){this.remoteAddress=t,this.localAddress=n,this._dispose=r,this._onDispose=new s.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}e.DisposableTunnel=u;let i=class extends h.Disposable{constructor(t,n){super(),this.logService=t,this.configurationService=n,this._onTunnelOpened=new s.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new s.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new s.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._canChangeProtocol=!0,this._privacyOptions=[],this._factoryInProgress=new Set}get hasTunnelProvider(){return!!this._tunnelProvider}get defaultTunnelHost(){const t=this.configurationService.getValue("remote.localPortHost");return!t||t==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(t){return this._tunnelProvider=t,t?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(t){this._canElevate=t.elevation,this._privacyOptions=t.privacyOptions,this._canChangeProtocol=t.protocol}get canChangeProtocol(){return this._canChangeProtocol}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const t=[],n=Array.from(this._tunnels.values());for(const r of n){const d=Array.from(r.values());for(const c of d){const g=await c.value;g&&typeof g!="string"&&t.push(g)}}return t}async dispose(){super.dispose();for(const t of this._tunnels.values()){for(const{value:n}of t.values())await n.then(r=>typeof r!="string"?r?.dispose():void 0);t.clear()}this._tunnels.clear()}setEnvironmentTunnel(t,n,r,d,c){this.addTunnelToMap(t,n,Promise.resolve({tunnelRemoteHost:t,tunnelRemotePort:n,localAddress:r,privacy:d,protocol:c,dispose:()=>Promise.resolve()}))}async getExistingTunnel(t,n){(m(t)||o(t))&&(t=e.LOCALHOST_ADDRESSES[0]);const r=this.getTunnelFromMap(t,n);if(r)return++r.refcount,r.value}openTunnel(t,n,r,d,c,g=!1,w,y){this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${n}:${r} on local port ${c}.`);const I=this._tunnelProvider??t;if(!I)return;if(n||(n="localhost"),d||(d=this.defaultTunnelHost),this._tunnelProvider&&this._factoryInProgress.has(r)){this.logService.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const P=this.retainOrCreateTunnel(I,n,r,d,c,g,w,y);return P?P.then(k=>{if(k){if(typeof k=="string")return this.logService.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.removeEmptyOrErrorTunnelFromMap(n,r),k}else{this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyOrErrorTunnelFromMap(n,r);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const b=this.makeTunnel(k);return(k.tunnelRemoteHost!==n||k.tunnelRemotePort!==r)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),w&&k.privacy!==w&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this._onTunnelOpened.fire(b),b}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),P)}makeTunnel(t){return{tunnelRemotePort:t.tunnelRemotePort,tunnelRemoteHost:t.tunnelRemoteHost,tunnelLocalPort:t.tunnelLocalPort,localAddress:t.localAddress,privacy:t.privacy,protocol:t.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${t.tunnelRemoteHost}:${t.tunnelRemotePort} `);const n=this._tunnels.get(t.tunnelRemoteHost);if(n){const r=n.get(t.tunnelRemotePort);r&&(r.refcount--,await this.tryDisposeTunnel(t.tunnelRemoteHost,t.tunnelRemotePort,r))}}}}async tryDisposeTunnel(t,n,r){if(r.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${t}:${n}.`);const d=r.value.then(async c=>{c&&typeof c!="string"&&(await c.dispose(!0),this._onTunnelClosed.fire({host:c.tunnelRemoteHost,port:c.tunnelRemotePort}))});return this._tunnels.has(t)&&this._tunnels.get(t).delete(n),d}}async closeTunnel(t,n){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${t}:${n} `);const r=this._tunnels.get(t);if(r&&r.has(n)){const d=r.get(n);d.refcount=0,await this.tryDisposeTunnel(t,n,d)}}addTunnelToMap(t,n,r){this._tunnels.has(t)||this._tunnels.set(t,new Map),this._tunnels.get(t).set(n,{refcount:1,value:r})}async removeEmptyOrErrorTunnelFromMap(t,n){const r=this._tunnels.get(t);if(r){const d=r.get(n),c=d?await d.value:void 0;(!c||typeof c=="string")&&r.delete(n),r.size===0&&this._tunnels.delete(t)}}getTunnelFromMap(t,n){const r=[t];o(t)?(r.push(...e.LOCALHOST_ADDRESSES),r.push(...e.ALL_INTERFACES_ADDRESSES)):m(t)&&r.push(...e.ALL_INTERFACES_ADDRESSES);const d=r.map(c=>this._tunnels.get(c));for(const c of d){const g=c?.get(n);if(g)return g}}canTunnel(t){return!!T(t)}createWithProvider(t,n,r,d,c,g,w){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${n}:${r} on local port ${d}.`);const y=r;this._factoryInProgress.add(y);const I=d===void 0?r:d,P={elevationRequired:c?this.isPortPrivileged(I):!1},k={remoteAddress:{host:n,port:r},localAddressPort:d,privacy:g,public:g?g!==C.Private:void 0,protocol:w},b=t.forwardPort(k,P);return b?(this.addTunnelToMap(n,r,b),b.finally(()=>{this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this._factoryInProgress.delete(y)})):this._factoryInProgress.delete(y),b}};e.AbstractTunnelService=i,e.AbstractTunnelService=i=Qe([$e(0,v.ILogService),$e(1,L.IConfigurationService)],i)}),define(Pe[154],ke([1,0,5]),function(ge,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,s.createDecorator)("IUriIdentityService")}),define(Pe[248],ke([1,0,5]),function(ge,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.IEditSessionIdentityService=void 0,e.IEditSessionIdentityService=(0,s.createDecorator)("editSessionIdentityService");var h;(function(D){D[D.Complete=100]="Complete",D[D.Partial=50]="Partial",D[D.None=0]="None"})(h||(e.EditSessionIdentityMatch=h={}))}),define(Pe[249],ke([1,0,14]),function(ge,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualResource=h,e.getVirtualWorkspaceLocation=D,e.getVirtualWorkspaceScheme=A,e.getVirtualWorkspaceAuthority=L,e.isVirtualWorkspace=R;function h(v){return v.scheme!==s.Schemas.file&&v.scheme!==s.Schemas.vscodeRemote}function D(v){if(v.folders.length)return v.folders.every(l=>h(l.uri))?v.folders[0].uri:void 0;if(v.configuration&&h(v.configuration))return v.configuration}function A(v){return D(v)?.scheme}function L(v){return D(v)?.authority}function R(v){return D(v)!==void 0}}),define(Pe[47],ke([1,0,7,16,62,22,2,5,14]),function(ge,e,s,h,D,A,L,R,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.STANDALONE_EDITOR_WORKSPACE_ID=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.WorkspaceFolder=e.Workspace=e.WorkbenchState=e.UNKNOWN_EMPTY_WINDOW_WORKSPACE=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.IWorkspaceContextService=void 0,e.isSingleFolderWorkspaceIdentifier=l,e.isEmptyWorkspaceIdentifier=C,e.toWorkspaceIdentifier=_,e.isWorkspaceIdentifier=f,e.reviveIdentifier=T,e.isWorkspace=o,e.isWorkspaceFolder=m,e.toWorkspaceFolder=i,e.isUntitledWorkspace=a,e.isTemporaryWorkspace=t,e.isStandaloneEditorWorkspace=n,e.isSavedWorkspace=r,e.hasWorkspaceFileExtension=d,e.IWorkspaceContextService=(0,R.createDecorator)("contextService");function l(c){const g=c;return typeof g?.id=="string"&&L.URI.isUri(g.uri)}function C(c){return typeof c?.id=="string"&&!l(c)&&!f(c)}e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"},e.UNKNOWN_EMPTY_WINDOW_WORKSPACE={id:"empty-window"};function _(c,g){if(typeof c=="string"||typeof c>"u")return typeof c=="string"?{id:(0,h.basename)(c)}:g?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:e.UNKNOWN_EMPTY_WINDOW_WORKSPACE;const w=c;return w.configuration?{id:w.id,configPath:w.configuration}:w.folders.length===1?{id:w.id,uri:w.folders[0].uri}:{id:w.id}}function f(c){const g=c;return typeof g?.id=="string"&&L.URI.isUri(g.configPath)}function T(c){const g=c;if(g?.uri)return{id:g.id,uri:L.URI.revive(g.uri)};const w=c;if(w?.configPath)return{id:w.id,configPath:L.URI.revive(w.configPath)};if(c?.id)return{id:c.id}}var S;(function(c){c[c.EMPTY=1]="EMPTY",c[c.FOLDER=2]="FOLDER",c[c.WORKSPACE=3]="WORKSPACE"})(S||(e.WorkbenchState=S={}));function o(c){const g=c;return!!(g&&typeof g=="object"&&typeof g.id=="string"&&Array.isArray(g.folders))}function m(c){const g=c;return!!(g&&typeof g=="object"&&L.URI.isUri(g.uri)&&typeof g.name=="string"&&typeof g.toResource=="function")}class p{constructor(g,w,y,I,P){this._id=g,this._transient=y,this._configuration=I,this._ignorePathCasing=P,this._foldersMap=D.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0),this.folders=w}update(g){this._id=g.id,this._configuration=g.configuration,this._transient=g.transient,this._ignorePathCasing=g._ignorePathCasing,this.folders=g.folders}get folders(){return this._folders}set folders(g){this._folders=g,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(g){this._configuration=g}getFolder(g){return g&&this._foldersMap.findSubstr(g)||null}updateFoldersMap(){this._foldersMap=D.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0);for(const g of this.folders)this._foldersMap.set(g.uri,g)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=p;class u{constructor(g,w){this.raw=w,this.uri=g.uri,this.index=g.index,this.name=g.name}toResource(g){return(0,A.joinPath)(this.uri,g)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=u;function i(c){return new u({uri:c,index:0,name:(0,A.basenameOrAuthority)(c)},{uri:c.toString()})}e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,s.localize)(2489,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function a(c,g){return A.extUriBiasedIgnorePathCase.isEqualOrParent(c,g.untitledWorkspacesHome)}function t(c){let g;return L.URI.isUri(c)?g=c:g=c.configuration,g?.scheme===v.Schemas.tmp}e.STANDALONE_EDITOR_WORKSPACE_ID="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function n(c){return c.id===e.STANDALONE_EDITOR_WORKSPACE_ID}function r(c,g){return!a(c,g)&&!t(c)}function d(c){return(typeof c=="string"?(0,h.extname)(c):(0,A.extname)(c))===e.WORKSPACE_SUFFIX}}),define(Pe[155],ke([1,0,61,4,3,22,2,7,148,27,5,11,47,28,154,8,31,13,17]),function(ge,e,s,h,D,A,L,R,v,l,C,_,f,T,S,o,m,p,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryUserDataProfilesService=e.UserDataProfilesService=e.IUserDataProfilesService=e.ProfileResourceType=void 0,e.isUserDataProfile=a,e.reviveProfile=t,e.toUserDataProfile=n;var i;(function(c){c.Settings="settings",c.Keybindings="keybindings",c.Snippets="snippets",c.Tasks="tasks",c.Extensions="extensions",c.GlobalState="globalState"})(i||(e.ProfileResourceType=i={}));function a(c){const g=c;return!!(g&&typeof g=="object"&&typeof g.id=="string"&&typeof g.isDefault=="boolean"&&typeof g.name=="string"&&L.URI.isUri(g.location)&&L.URI.isUri(g.globalStorageHome)&&L.URI.isUri(g.settingsResource)&&L.URI.isUri(g.keybindingsResource)&&L.URI.isUri(g.tasksResource)&&L.URI.isUri(g.snippetsHome)&&L.URI.isUri(g.extensionsResource))}e.IUserDataProfilesService=(0,C.createDecorator)("IUserDataProfilesService");function t(c,g){return{id:c.id,isDefault:c.isDefault,name:c.name,shortName:c.shortName,icon:c.icon,location:L.URI.revive(c.location).with({scheme:g}),globalStorageHome:L.URI.revive(c.globalStorageHome).with({scheme:g}),settingsResource:L.URI.revive(c.settingsResource).with({scheme:g}),keybindingsResource:L.URI.revive(c.keybindingsResource).with({scheme:g}),tasksResource:L.URI.revive(c.tasksResource).with({scheme:g}),snippetsHome:L.URI.revive(c.snippetsHome).with({scheme:g}),extensionsResource:L.URI.revive(c.extensionsResource).with({scheme:g}),cacheHome:L.URI.revive(c.cacheHome).with({scheme:g}),useDefaultFlags:c.useDefaultFlags,isTransient:c.isTransient}}function n(c,g,w,y,I,P){return{id:c,name:g,location:w,isDefault:!1,shortName:I?.shortName,icon:I?.icon,globalStorageHome:P&&I?.useDefaultFlags?.globalState?P.globalStorageHome:(0,A.joinPath)(w,"globalStorage"),settingsResource:P&&I?.useDefaultFlags?.settings?P.settingsResource:(0,A.joinPath)(w,"settings.json"),keybindingsResource:P&&I?.useDefaultFlags?.keybindings?P.keybindingsResource:(0,A.joinPath)(w,"keybindings.json"),tasksResource:P&&I?.useDefaultFlags?.tasks?P.tasksResource:(0,A.joinPath)(w,"tasks.json"),snippetsHome:P&&I?.useDefaultFlags?.snippets?P.snippetsHome:(0,A.joinPath)(w,"snippets"),extensionsResource:P&&I?.useDefaultFlags?.extensions?P.extensionsResource:(0,A.joinPath)(w,"extensions.json"),cacheHome:(0,A.joinPath)(y,c),useDefaultFlags:I?.useDefaultFlags,isTransient:I?.transient}}let r=class extends D.Disposable{static{this.PROFILES_KEY="userDataProfiles"}static{this.PROFILE_ASSOCIATIONS_KEY="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.profilesObject.profiles,...this.transientProfilesObject.profiles]}constructor(g,w,y,I){super(),this.environmentService=g,this.fileService=w,this.uriIdentityService=y,this.logService=I,this.enabled=!0,this._onDidChangeProfiles=this._register(new h.Emitter),this.onDidChangeProfiles=this._onDidChangeProfiles.event,this._onWillCreateProfile=this._register(new h.Emitter),this.onWillCreateProfile=this._onWillCreateProfile.event,this._onWillRemoveProfile=this._register(new h.Emitter),this.onWillRemoveProfile=this._onWillRemoveProfile.event,this._onDidResetWorkspaces=this._register(new h.Emitter),this.onDidResetWorkspaces=this._onDidResetWorkspaces.event,this.profileCreationPromises=new Map,this.transientProfilesObject={profiles:[],folders:new T.ResourceMap,workspaces:new T.ResourceMap,emptyWindows:new Map},this.profilesHome=(0,A.joinPath)(this.environmentService.userRoamingDataHome,"profiles"),this.profilesCacheHome=(0,A.joinPath)(this.environmentService.cacheHome,"CachedProfilesData")}init(){this._profilesObject=void 0}setEnablement(g){this.enabled!==g&&(this._profilesObject=void 0,this.enabled=g)}isEnabled(){return this.enabled}get profilesObject(){if(!this._profilesObject){const g=this.createDefaultProfile(),w=[g];if(this.enabled)try{for(const P of this.getStoredProfiles()){if(!P.name||!(0,u.isString)(P.name)||!P.location){this.logService.warn("Skipping the invalid stored profile",P.location||P.name);continue}w.push(n((0,A.basename)(P.location),P.name,P.location,this.profilesCacheHome,{shortName:P.shortName,icon:P.icon,useDefaultFlags:P.useDefaultFlags},g))}}catch(P){this.logService.error(P)}const y=new T.ResourceMap,I=new Map;if(w.length)try{const P=this.getStoredProfileAssociations();if(P.workspaces)for(const[k,b]of Object.entries(P.workspaces)){const E=L.URI.parse(k),N=w.find(O=>O.id===b);N&&y.set(E,N)}if(P.emptyWindows)for(const[k,b]of Object.entries(P.emptyWindows)){const E=w.find(N=>N.id===b);E&&I.set(k,E)}}catch(P){this.logService.error(P)}this._profilesObject={profiles:w,workspaces:y,emptyWindows:I}}return this._profilesObject}createDefaultProfile(){const g=n("__default__profile__",(0,R.localize)(2442,null),this.environmentService.userRoamingDataHome,this.profilesCacheHome);return{...g,extensionsResource:this.getDefaultProfileExtensionsLocation()??g.extensionsResource,isDefault:!0}}async createTransientProfile(g){const w="Temp",y=new RegExp(`${(0,p.escapeRegExpCharacters)(w)}\\s(\\d+)`);let I=0;for(const k of this.profiles){const b=y.exec(k.name),E=b?parseInt(b[1]):0;I=E>I?E:I}const P=`${w} ${I+1}`;return this.createProfile((0,s.hash)((0,m.generateUuid)()).toString(16),P,{transient:!0},g)}async createNamedProfile(g,w,y){return this.createProfile((0,s.hash)((0,m.generateUuid)()).toString(16),g,w,y)}async createProfile(g,w,y,I){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");const P=await this.doCreateProfile(g,w,y);return I&&await this.setProfileForWorkspace(I,P),P}async doCreateProfile(g,w,y){if(!(0,u.isString)(w)||!w)throw new Error("Name of the profile is mandatory and must be of type `string`");let I=this.profileCreationPromises.get(w);return I||(I=(async()=>{try{if(this.profiles.find(E=>E.name===w||E.id===g))throw new Error(`Profile with ${w} name already exists`);const k=n(g,w,(0,A.joinPath)(this.profilesHome,g),this.profilesCacheHome,y,this.defaultProfile);await this.fileService.createFolder(k.location);const b=[];return this._onWillCreateProfile.fire({profile:k,join(E){b.push(E)}}),await o.Promises.settled(b),this.updateProfiles([k],[],[]),k}finally{this.profileCreationPromises.delete(w)}})(),this.profileCreationPromises.set(w,I)),I}async updateProfile(g,w){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");let y=this.profiles.find(I=>I.id===g.id);if(!y)throw new Error(`Profile '${g.name}' does not exist`);return y=n(y.id,w.name??y.name,y.location,this.profilesCacheHome,{shortName:w.shortName??y.shortName,icon:w.icon===null?void 0:w.icon??y.icon,transient:w.transient??y.isTransient,useDefaultFlags:w.useDefaultFlags??y.useDefaultFlags},this.defaultProfile),this.updateProfiles([],[],[y]),y}async removeProfile(g){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");if(g.isDefault)throw new Error("Cannot remove default profile");const w=this.profiles.find(I=>I.id===g.id);if(!w)throw new Error(`Profile '${g.name}' does not exist`);const y=[];this._onWillRemoveProfile.fire({profile:w,join(I){y.push(I)}});try{await Promise.allSettled(y)}catch(I){this.logService.error(I)}for(const I of[...this.profilesObject.emptyWindows.keys()])w.id===this.profilesObject.emptyWindows.get(I)?.id&&this.profilesObject.emptyWindows.delete(I);for(const I of[...this.profilesObject.workspaces.keys()])w.id===this.profilesObject.workspaces.get(I)?.id&&this.profilesObject.workspaces.delete(I);this.updateStoredProfileAssociations(),this.updateProfiles([],[w],[]);try{await this.fileService.del(w.cacheHome,{recursive:!0})}catch(I){(0,l.toFileOperationResult)(I)!==l.FileOperationResult.FILE_NOT_FOUND&&this.logService.error(I)}}async setProfileForWorkspace(g,w){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");const y=this.profiles.find(I=>I.id===w.id);if(!y)throw new Error(`Profile '${w.name}' does not exist`);this.updateWorkspaceAssociation(g,y)}unsetWorkspace(g,w){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");this.updateWorkspaceAssociation(g,void 0,w)}async resetWorkspaces(){this.transientProfilesObject.folders.clear(),this.transientProfilesObject.workspaces.clear(),this.transientProfilesObject.emptyWindows.clear(),this.profilesObject.workspaces.clear(),this.profilesObject.emptyWindows.clear(),this.updateStoredProfileAssociations(),this._onDidResetWorkspaces.fire()}async cleanUp(){if(this.enabled&&await this.fileService.exists(this.profilesHome)){const g=await this.fileService.resolve(this.profilesHome);await Promise.all((g.children||[]).filter(w=>w.isDirectory&&this.profiles.every(y=>!this.uriIdentityService.extUri.isEqual(y.location,w.resource))).map(w=>this.fileService.del(w.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.enabled)return;const g=this.transientProfilesObject.profiles.filter(w=>!this.isProfileAssociatedToWorkspace(w));await Promise.allSettled(g.map(w=>this.removeProfile(w)))}getProfileForWorkspace(g){const w=this.getWorkspace(g),y=L.URI.isUri(w)?this.profilesObject.workspaces.get(w):this.profilesObject.emptyWindows.get(w);return y||((0,f.isSingleFolderWorkspaceIdentifier)(g)?this.transientProfilesObject.folders.get(g.uri):(0,f.isWorkspaceIdentifier)(g)?this.transientProfilesObject.workspaces.get(g.configPath):this.transientProfilesObject.emptyWindows.get(g.id))}getWorkspace(g){return(0,f.isSingleFolderWorkspaceIdentifier)(g)?g.uri:(0,f.isWorkspaceIdentifier)(g)?g.configPath:g.id}isProfileAssociatedToWorkspace(g){return!!([...this.profilesObject.emptyWindows.values()].some(w=>this.uriIdentityService.extUri.isEqual(w.location,g.location))||[...this.profilesObject.workspaces.values()].some(w=>this.uriIdentityService.extUri.isEqual(w.location,g.location))||[...this.transientProfilesObject.emptyWindows.values()].some(w=>this.uriIdentityService.extUri.isEqual(w.location,g.location))||[...this.transientProfilesObject.workspaces.values()].some(w=>this.uriIdentityService.extUri.isEqual(w.location,g.location))||[...this.transientProfilesObject.folders.values()].some(w=>this.uriIdentityService.extUri.isEqual(w.location,g.location)))}updateProfiles(g,w,y){const I=[...this.profiles,...g],P=[],k=this.transientProfilesObject.profiles;this.transientProfilesObject.profiles=[];for(let b of I){if(b.isDefault||w.some(N=>b.id===N.id))continue;b=y.find(N=>b.id===N.id)??b;const E=k.find(N=>b.id===N.id);if(b.isTransient)this.transientProfilesObject.profiles.push(b);else{if(E){for(const[N,O]of this.transientProfilesObject.emptyWindows.entries())if(b.id===O.id){this.updateWorkspaceAssociation({id:N},b);break}for(const[N,O]of this.transientProfilesObject.workspaces.entries())if(b.id===O.id){this.updateWorkspaceAssociation({id:"",configPath:N},b);break}for(const[N,O]of this.transientProfilesObject.folders.entries())if(b.id===O.id){this.updateWorkspaceAssociation({id:"",uri:N},b);break}}P.push({location:b.location,name:b.name,shortName:b.shortName,icon:b.icon,useDefaultFlags:b.useDefaultFlags})}}this.saveStoredProfiles(P),this._profilesObject=void 0,this.triggerProfilesChanges(g,w,y)}triggerProfilesChanges(g,w,y){this._onDidChangeProfiles.fire({added:g,removed:w,updated:y,all:this.profiles})}updateWorkspaceAssociation(g,w,y){if(y=w?.isTransient?!0:y,y)(0,f.isSingleFolderWorkspaceIdentifier)(g)?(this.transientProfilesObject.folders.delete(g.uri),w&&this.transientProfilesObject.folders.set(g.uri,w)):(0,f.isWorkspaceIdentifier)(g)?(this.transientProfilesObject.workspaces.delete(g.configPath),w&&this.transientProfilesObject.workspaces.set(g.configPath,w)):(this.transientProfilesObject.emptyWindows.delete(g.id),w&&this.transientProfilesObject.emptyWindows.set(g.id,w));else{this.updateWorkspaceAssociation(g,void 0,!0);const I=this.getWorkspace(g);L.URI.isUri(I)?(this.profilesObject.workspaces.delete(I),w&&this.profilesObject.workspaces.set(I,w)):(this.profilesObject.emptyWindows.delete(I),w&&this.profilesObject.emptyWindows.set(I,w)),this.updateStoredProfileAssociations()}}updateStoredProfileAssociations(){const g={};for(const[y,I]of this.profilesObject.workspaces.entries())g[y.toString()]=I.id;const w={};for(const[y,I]of this.profilesObject.emptyWindows.entries())w[y.toString()]=I.id;this.saveStoredProfileAssociations({workspaces:g,emptyWindows:w}),this._profilesObject=void 0}migrateStoredProfileAssociations(g){const w={},y=this.createDefaultProfile();if(g.workspaces)for(const[P,k]of Object.entries(g.workspaces)){const b=L.URI.parse(k);w[P]=this.uriIdentityService.extUri.isEqual(b,y.location)?y.id:this.uriIdentityService.extUri.basename(b)}const I={};if(g.emptyWindows)for(const[P,k]of Object.entries(g.emptyWindows)){const b=L.URI.parse(k);I[P]=this.uriIdentityService.extUri.isEqual(b,y.location)?y.id:this.uriIdentityService.extUri.basename(b)}return{workspaces:w,emptyWindows:I}}getStoredProfiles(){return[]}saveStoredProfiles(g){throw new Error("not implemented")}getStoredProfileAssociations(){return{}}saveStoredProfileAssociations(g){throw new Error("not implemented")}getDefaultProfileExtensionsLocation(){}};e.UserDataProfilesService=r,e.UserDataProfilesService=r=Qe([$e(0,v.IEnvironmentService),$e(1,l.IFileService),$e(2,S.IUriIdentityService),$e(3,_.ILogService)],r);class d extends r{constructor(){super(...arguments),this.storedProfiles=[],this.storedProfileAssociations={}}getStoredProfiles(){return this.storedProfiles}saveStoredProfiles(g){this.storedProfiles=g}getStoredProfileAssociations(){return this.storedProfileAssociations}saveStoredProfileAssociations(g){this.storedProfileAssociations=g}}e.InMemoryUserDataProfilesService=d}),define(Pe[156],ke([1,0,8,4,3,63,17,210,5,155]),function(ge,e,s,h,D,A,L,R,v,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageService=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.TARGET_KEY=e.IS_NEW_KEY=void 0,e.loadKeyTargets=T,e.isProfileUsingDefaultStorage=o,e.logStorage=p,e.IS_NEW_KEY="__$__isNewStorageMarker",e.TARGET_KEY="__$__targetStorageMarker",e.IStorageService=(0,v.createDecorator)("storageService");var C;(function(u){u[u.NONE=0]="NONE",u[u.SHUTDOWN=1]="SHUTDOWN"})(C||(e.WillSaveStateReason=C={}));var _;(function(u){u[u.APPLICATION=-1]="APPLICATION",u[u.PROFILE=0]="PROFILE",u[u.WORKSPACE=1]="WORKSPACE"})(_||(e.StorageScope=_={}));var f;(function(u){u[u.USER=0]="USER",u[u.MACHINE=1]="MACHINE"})(f||(e.StorageTarget=f={}));function T(u){const i=u.get(e.TARGET_KEY);if(i)try{return JSON.parse(i)}catch{}return Object.create(null)}class S extends D.Disposable{static{this.DEFAULT_FLUSH_INTERVAL=60*1e3}constructor(i={flushInterval:S.DEFAULT_FLUSH_INTERVAL}){super(),this.options=i,this._onDidChangeValue=this._register(new h.PauseableEmitter),this._onDidChangeTarget=this._register(new h.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new h.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new s.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new D.MutableDisposable),this._workspaceKeyTargets=void 0,this._profileKeyTargets=void 0,this._applicationKeyTargets=void 0}onDidChangeValue(i,a,t){return h.Event.filter(this._onDidChangeValue.event,n=>n.scope===i&&(a===void 0||n.key===a),t)}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,s.runWhenGlobalIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,D.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,A.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,A.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(i,a){const{key:t,external:n}=a;if(t===e.TARGET_KEY){switch(i){case _.APPLICATION:this._applicationKeyTargets=void 0;break;case _.PROFILE:this._profileKeyTargets=void 0;break;case _.WORKSPACE:this._workspaceKeyTargets=void 0;break}this._onDidChangeTarget.fire({scope:i})}else this._onDidChangeValue.fire({scope:i,key:t,target:this.getKeyTargets(i)[t],external:n})}emitWillSaveState(i){this._onWillSaveState.fire({reason:i})}get(i,a,t){return this.getStorage(a)?.get(i,t)}getBoolean(i,a,t){return this.getStorage(a)?.getBoolean(i,t)}getNumber(i,a,t){return this.getStorage(a)?.getNumber(i,t)}getObject(i,a,t){return this.getStorage(a)?.getObject(i,t)}storeAll(i,a){this.withPausedEmitters(()=>{for(const t of i)this.store(t.key,t.value,t.scope,t.target,a)})}store(i,a,t,n,r=!1){if((0,L.isUndefinedOrNull)(a)){this.remove(i,t,r);return}this.withPausedEmitters(()=>{this.updateKeyTarget(i,t,n),this.getStorage(t)?.set(i,a,r)})}remove(i,a,t=!1){this.withPausedEmitters(()=>{this.updateKeyTarget(i,a,void 0),this.getStorage(a)?.delete(i,t)})}withPausedEmitters(i){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{i()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(i,a){const t=[],n=this.getKeyTargets(i);for(const r of Object.keys(n))n[r]===a&&t.push(r);return t}updateKeyTarget(i,a,t,n=!1){const r=this.getKeyTargets(a);typeof t=="number"?r[i]!==t&&(r[i]=t,this.getStorage(a)?.set(e.TARGET_KEY,JSON.stringify(r),n)):typeof r[i]=="number"&&(delete r[i],this.getStorage(a)?.set(e.TARGET_KEY,JSON.stringify(r),n))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(_.WORKSPACE)),this._workspaceKeyTargets}get profileKeyTargets(){return this._profileKeyTargets||(this._profileKeyTargets=this.loadKeyTargets(_.PROFILE)),this._profileKeyTargets}get applicationKeyTargets(){return this._applicationKeyTargets||(this._applicationKeyTargets=this.loadKeyTargets(_.APPLICATION)),this._applicationKeyTargets}getKeyTargets(i){switch(i){case _.APPLICATION:return this.applicationKeyTargets;case _.PROFILE:return this.profileKeyTargets;default:return this.workspaceKeyTargets}}loadKeyTargets(i){const a=this.getStorage(i);return a?T(a):Object.create(null)}isNew(i){return this.getBoolean(e.IS_NEW_KEY,i)===!0}async flush(i=C.NONE){this._onWillSaveState.fire({reason:i});const a=this.getStorage(_.APPLICATION),t=this.getStorage(_.PROFILE),n=this.getStorage(_.WORKSPACE);switch(i){case C.NONE:await s.Promises.settled([a?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve(),n?.whenFlushed()??Promise.resolve()]);break;case C.SHUTDOWN:await s.Promises.settled([a?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve(),n?.flush(0)??Promise.resolve()]);break}}async log(){const i=this.getStorage(_.APPLICATION)?.items??new Map,a=this.getStorage(_.PROFILE)?.items??new Map,t=this.getStorage(_.WORKSPACE)?.items??new Map;return p(i,a,t,this.getLogDetails(_.APPLICATION)??"",this.getLogDetails(_.PROFILE)??"",this.getLogDetails(_.WORKSPACE)??"")}async optimize(i){return await this.flush(),this.getStorage(i)?.optimize()}async switch(i,a){return this.emitWillSaveState(C.NONE),(0,l.isUserDataProfile)(i)?this.switchToProfile(i,a):this.switchToWorkspace(i,a)}canSwitchProfile(i,a){return!(i.id===a.id||o(a)&&o(i))}switchData(i,a,t){this.withPausedEmitters(()=>{const n=new Set;for(const[r,d]of i)n.add(r),a.get(r)!==d&&this.emitDidChangeValue(t,{key:r,external:!0});for(const[r]of a.items)n.has(r)||this.emitDidChangeValue(t,{key:r,external:!0})})}}e.AbstractStorageService=S;function o(u){return u.isDefault||!!u.useDefaultFlags?.globalState}class m extends S{constructor(){super(),this.applicationStorage=this._register(new R.Storage(new R.InMemoryStorageDatabase,{hint:R.StorageHint.STORAGE_IN_MEMORY})),this.profileStorage=this._register(new R.Storage(new R.InMemoryStorageDatabase,{hint:R.StorageHint.STORAGE_IN_MEMORY})),this.workspaceStorage=this._register(new R.Storage(new R.InMemoryStorageDatabase,{hint:R.StorageHint.STORAGE_IN_MEMORY})),this._register(this.workspaceStorage.onDidChangeStorage(i=>this.emitDidChangeValue(_.WORKSPACE,i))),this._register(this.profileStorage.onDidChangeStorage(i=>this.emitDidChangeValue(_.PROFILE,i))),this._register(this.applicationStorage.onDidChangeStorage(i=>this.emitDidChangeValue(_.APPLICATION,i)))}getStorage(i){switch(i){case _.APPLICATION:return this.applicationStorage;case _.PROFILE:return this.profileStorage;default:return this.workspaceStorage}}getLogDetails(i){switch(i){case _.APPLICATION:return"inMemory (application)";case _.PROFILE:return"inMemory (profile)";default:return"inMemory (workspace)"}}async doInitialize(){}async switchToProfile(){}async switchToWorkspace(){}shouldFlushWhenIdle(){return!1}hasScope(i){return!1}}e.InMemoryStorageService=m;async function p(u,i,a,t,n,r){const d=E=>{try{return JSON.parse(E)}catch{return E}},c=new Map,g=new Map;u.forEach((E,N)=>{c.set(N,E),g.set(N,d(E))});const w=new Map,y=new Map;i.forEach((E,N)=>{w.set(N,E),y.set(N,d(E))});const I=new Map,P=new Map;a.forEach((E,N)=>{I.set(N,E),P.set(N,d(E))}),console.group(t!==n?`Storage: Application (path: ${t})`:`Storage: Application & Profile (path: ${t}, default profile)`);const k=[];if(c.forEach((E,N)=>{k.push({key:N,value:E})}),console.table(k),console.groupEnd(),console.log(g),t!==n){console.group(`Storage: Profile (path: ${n}, profile specific)`);const E=[];w.forEach((N,O)=>{E.push({key:O,value:N})}),console.table(E),console.groupEnd(),console.log(y)}console.group(`Storage: Workspace (path: ${r})`);const b=[];I.forEach((E,N)=>{b.push({key:N,value:E})}),console.table(b),console.groupEnd(),console.log(P)}}),define(Pe[118],ke([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class s{static{this.enableDebugLogging=!1}constructor(D){this.id=D,this._data=new Map,this._idPool=1}add(D){const A=this._idPool++;return this._data.set(A,D),this.logDebugInfo(),A}get(D,A){return this._data.has(D)?this._data.get(D)[A]:void 0}delete(D){this._data.delete(D),this.logDebugInfo()}logDebugInfo(){s.enableDebugLogging&&console.log(`${this.id} cache size - ${this._data.size}`)}}e.Cache=s}),define(Pe[64],ke([1,0,14,22,27,5]),function(ge,e,s,h,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class L{constructor(){this._systemSchemes=new Set(Object.keys(s.Schemas)),this._providerInfo=new Map,this.extUri=new h.ExtUri(v=>{const l=this._providerInfo.get(v.scheme);return!(l===void 0||l&D.FileSystemProviderCapabilities.PathCaseSensitive)})}$acceptProviderInfos(v,l){l===null?this._providerInfo.delete(v.scheme):this._providerInfo.set(v.scheme,l)}isFreeScheme(v){return!this._providerInfo.has(v)&&!this._systemSchemes.has(v)}getCapabilities(v){return this._providerInfo.get(v)}}e.ExtHostFileSystemInfo=L,e.IExtHostFileSystemInfo=(0,A.createDecorator)("IExtHostFileSystemInfo")}),define(Pe[29],ke([1,0,5]),function(ge,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,s.createDecorator)("IExtHostInitDataService")}),define(Pe[250],ke([1,0,7,11,231,29]),function(ge,e,s,h,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let L=class extends D.LogService{constructor(v,l,C){const _=C.remote.isRemote?"remoteexthost":v?"workerexthost":"exthost",f=C.remote.isRemote?(0,s.localize)(2706,null):v?(0,s.localize)(2707,null):(0,s.localize)(2708,null);super(l.createLogger(_,{name:f}))}};e.ExtHostLogService=L,e.ExtHostLogService=L=Qe([$e(1,h.ILoggerService),$e(2,A.IExtHostInitDataService)],L)}),define(Pe[251],ke([1,0,8]),function(ge,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class h{constructor(L,R,v){this._deferredPromises=new Map,this._id=L,this._shared=R,this._storage=v,this._init=this._storage.initializeExtensionStorage(this._shared,this._id,Object.create(null)).then(l=>(this._value=l,this)),this._storageListener=this._storage.onDidChangeStorage(l=>{l.shared===this._shared&&l.key===this._id&&(this._value=l.value)}),this._scheduler=new s.RunOnceScheduler(()=>{const l=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const C of l.values())C.complete()}catch(C){for(const _ of l.values())_.error(C)}})()},0)}keys(){return Object.entries(this._value??{}).filter(([,L])=>L!==void 0).map(([L])=>L)}get whenReady(){return this._init}get(L,R){let v=this._value[L];return typeof v>"u"&&(v=R),v}update(L,R){this._value[L]=R;const v=this._deferredPromises.get(L);if(v!==void 0)return v.p;const l=new s.DeferredPromise;return this._deferredPromises.set(L,l),this._scheduler.isScheduled()||this._scheduler.schedule(),l.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=h;class D extends h{setKeysForSync(L){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},L)}constructor(L,R){super(L.identifier.value,!0,R),this._extension=L}}e.ExtensionGlobalMemento=D}),define(Pe[252],ke([1,0,4,2]),function(ge,e,s,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;class D{constructor(L){this._notebooksAndEditors=L,this._onDidSaveNotebookDocument=new s.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event,this._onDidChangeNotebookDocument=new s.Emitter,this.onDidChangeNotebookDocument=this._onDidChangeNotebookDocument.event}$acceptModelChanged(L,R,v,l){const _=this._notebooksAndEditors.getNotebookDocument(h.URI.revive(L)).acceptModelChanged(R.value,v,l);this._onDidChangeNotebookDocument.fire(_)}$acceptDirtyStateChanged(L,R){this._notebooksAndEditors.getNotebookDocument(h.URI.revive(L)).acceptDirty(R)}$acceptModelSaved(L){const R=this._notebooksAndEditors.getNotebookDocument(h.URI.revive(L));this._onDidSaveNotebookDocument.fire(R.apiNotebook)}}e.ExtHostNotebookDocuments=D}),define(Pe[19],ke([1,0,5]),function(ge,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,s.createDecorator)("IExtHostRpcService");class h{constructor(A){this.getProxy=A.getProxy.bind(A),this.set=A.set.bind(A),this.dispose=A.dispose.bind(A),this.assertRegistered=A.assertRegistered.bind(A),this.drain=A.drain.bind(A)}}e.ExtHostRpcService=h}),define(Pe[253],ke([1,0,23,4,3]),function(ge,e,s,h,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class A{#e;constructor(R,v){this.disposables=new D.DisposableStore,this._id=s.ExtensionIdentifier.toKey(R.identifier),this.#e=v,this.onDidChange=h.Event.map(h.Event.filter(this.#e.onDidChangePassword,l=>l.extensionId===this._id),l=>({key:l.key}),this.disposables)}dispose(){this.disposables.dispose()}get(R){return this.#e.get(this._id,R)}store(R,v){return this.#e.store(this._id,R,v)}delete(R){return this.#e.delete(this._id,R)}}e.ExtensionSecrets=A}),define(Pe[74],ke([1,0,5]),function(ge,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,s.createDecorator)("IURITransformerService");class h{constructor(A){A?(this.transformIncoming=A.transformIncoming.bind(A),this.transformOutgoing=A.transformOutgoing.bind(A),this.transformOutgoingURI=A.transformOutgoingURI.bind(A),this.transformOutgoingScheme=A.transformOutgoingScheme.bind(A)):(this.transformIncoming=L=>L,this.transformOutgoing=L=>L,this.transformOutgoingURI=L=>L,this.transformOutgoingScheme=L=>L)}}e.URITransformerService=h}),define(Pe[254],ke([1,0,255,364,365,68,2,11,366]),function(ge,e,s,h,D,A,L,R,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connectProxyResolver=C,s=We(s),h=We(h),D=We(D),A=We(A);const l=!1;function C(i,a,t,n,r,d){const c=d.environment.useHostProxy,g=typeof c=="boolean"?c:!d.remote.isRemote,w={resolveProxy:P=>i.resolveProxy(P),lookupProxyAuthorization:m.bind(void 0,i,n,r,a,{},{},d.remote.isRemote,g),getProxyURL:()=>a.getConfiguration("http").get("proxy"),getProxySupport:()=>a.getConfiguration("http").get("proxySupport")||"off",getNoProxyConfig:()=>a.getConfiguration("http").get("noProxy")||[],addCertificatesV1:()=>f(a),addCertificatesV2:()=>T(a),log:n,getLogLevel:()=>{const P=n.getLevel();switch(P){case R.LogLevel.Trace:return v.LogLevel.Trace;case R.LogLevel.Debug:return v.LogLevel.Debug;case R.LogLevel.Info:return v.LogLevel.Info;case R.LogLevel.Warning:return v.LogLevel.Warning;case R.LogLevel.Error:return v.LogLevel.Error;case R.LogLevel.Off:return v.LogLevel.Off;default:return k(P)}function k(b){return n.error("Unknown log level",b),v.LogLevel.Debug}},proxyResolveTelemetry:()=>{},useHostProxy:g,loadAdditionalCertificates:async()=>{const P=[];if(d.remote.isRemote&&P.push((0,v.loadSystemCertificates)({log:n})),g){n.trace("ProxyResolver#loadAdditionalCertificates: Loading certificates from main process");const k=i.loadCertificates();k.then(b=>n.trace("ProxyResolver#loadAdditionalCertificates: Loaded certificates from main process",b.length)),P.push(k)}return d.environment.extensionTestsLocationURI&&h.globalAgent.testCertificates?.length&&(n.trace("ProxyResolver#loadAdditionalCertificates: Loading test certificates"),P.push(Promise.resolve(h.globalAgent.testCertificates))),(await Promise.all(P)).flat()},env:process.env},y=(0,v.createProxyResolver)(w),I=_(w,y);return o(t,I)}function _(i,a){function t(n,r){return Object.assign(n.default||n,r)}return{http:t(s,(0,v.createHttpPatch)(i,s,a)),https:t(h,(0,v.createHttpPatch)(i,h,a)),net:t(A,(0,v.createNetPatch)(i,A)),tls:t(D,(0,v.createTlsPatch)(i,D))}}function f(i){const a=i.getConfiguration("http");return!a.get("experimental.systemCertificatesV2",l)&&!!a.get("systemCertificates")}function T(i){const a=i.getConfiguration("http");return!!a.get("experimental.systemCertificatesV2",l)&&!!a.get("systemCertificates")}const S=new Map;function o(i,a){return i.getExtensionPathIndex().then(t=>{const n=globalThis._VSCODE_NODE_MODULES.module,r=n._load;n._load=function(c,g,w){if(c==="net")return a.net;if(c==="tls")return a.tls;if(c!=="http"&&c!=="https")return r.apply(this,arguments);const y=t.findSubstr(L.URI.file(g.filename));let I=S.get(y);if(I||S.set(y,I={}),!I[c]){const P=a[c];I[c]={...P}}return I[c]}})}async function m(i,a,t,n,r,d,c,g,w,y,I){const P=r[w];y&&(r[w]=y),a.trace("ProxyResolver#lookupProxyAuthorization callback",`proxyURL:${w}`,`proxyAuthenticate:${y}`,`proxyAuthenticateCache:${P}`);const k=y||P,b=Array.isArray(k)?k:typeof k=="string"?[k]:[];if(u(t,b,c),b.some(N=>/^(Negotiate|Kerberos)( |$)/i.test(N))&&!I.kerberosRequested){I.kerberosRequested=!0;try{const N=await new Promise((F,x)=>{ge(["kerberos"],F,x)}).then(We),O=new URL(w),M=n.getConfiguration("http").get("proxyKerberosServicePrincipal")||(process.platform==="win32"?`HTTP/${O.hostname}`:`HTTP@${O.hostname}`);return a.debug("ProxyResolver#lookupProxyAuthorization Kerberos authentication lookup",`proxyURL:${w}`,`spn:${M}`),"Negotiate "+await(await N.initializeClient(M)).step("")}catch(N){a.debug("ProxyResolver#lookupProxyAuthorization Kerberos authentication failed",N)}if(c&&g){a.debug("ProxyResolver#lookupProxyAuthorization Kerberos authentication lookup on host",`proxyURL:${w}`);const N=await i.lookupKerberosAuthorization(w);if(N)return"Negotiate "+N}}const E=b.find(N=>/^Basic( |$)/i.test(N));if(E)try{const N=d[w];if(N)if(I.basicAuthCacheUsed)a.debug("ProxyResolver#lookupProxyAuthorization Basic authentication deleting cached credentials",`proxyURL:${w}`),delete d[w];else return a.debug("ProxyResolver#lookupProxyAuthorization Basic authentication using cached credentials",`proxyURL:${w}`),I.basicAuthCacheUsed=!0,N;I.basicAuthAttempt=(I.basicAuthAttempt||0)+1;const O=/ realm="([^"]+)"/i.exec(E)?.[1];a.debug("ProxyResolver#lookupProxyAuthorization Basic authentication lookup",`proxyURL:${w}`,`realm:${O}`);const M=new URL(w),U={scheme:"basic",host:M.hostname,port:Number(M.port),realm:O||"",isProxy:!0,attempt:I.basicAuthAttempt},H=await i.lookupAuthorization(U);if(H){a.debug("ProxyResolver#lookupProxyAuthorization Basic authentication received credentials",`proxyURL:${w}`,`realm:${O}`);const F="Basic "+Buffer.from(`${H.username}:${H.password}`).toString("base64");return d[w]=F,F}else a.debug("ProxyResolver#lookupProxyAuthorization Basic authentication received no credentials",`proxyURL:${w}`,`realm:${O}`)}catch(N){a.error("ProxyResolver#lookupProxyAuthorization Basic authentication failed",N)}}let p=!1;function u(i,a,t){p||!a.length||(p=!0,i.$publicLog2("proxyAuthenticationRequest",{authenticationType:a.map(n=>n.split(" ")[0]).join(","),extensionHostType:t?"remote":"local"}))}}),define(Pe[256],ke([1,0,145]),function(ge,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createURITransformer=D;function h(A){return{transformIncoming:L=>L.scheme==="vscode-remote"?{scheme:"file",path:L.path,query:L.query,fragment:L.fragment}:L.scheme==="file"?{scheme:"vscode-local",path:L.path,query:L.query,fragment:L.fragment}:L,transformOutgoing:L=>L.scheme==="file"?{scheme:"vscode-remote",authority:A,path:L.path,query:L.query,fragment:L.fragment}:L.scheme==="vscode-local"?{scheme:"file",path:L.path,query:L.query,fragment:L.fragment}:L,transformOutgoingScheme:L=>L==="file"?"vscode-remote":L==="vscode-local"?"file":L}}function D(A){return new s.URITransformer(h(A))}});var Vt=this&&this.__importDefault||function(ge){return ge&&ge.__esModule?ge:{default:ge}};define(Pe[157],ke([1,0,7,17,2,3,5,37,27,14,52,206,44]),function(ge,e,s,h,D,A,L,R,v,l,C,_,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.CloseDirection=e.EditorResourceAccessor=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveSourceRegistry=e.SaveReason=e.Verbosity=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.isEditorPaneWithSelection=o,e.isEditorPaneWithScrolling=m,e.findViewStateForEditor=p,e.isResourceEditorInput=u,e.isResourceDiffEditorInput=i,e.isResourceMultiDiffEditorInput=a,e.isResourceSideBySideEditorInput=t,e.isUntitledResourceEditorInput=n,e.isResourceMergeEditorInput=r,e.isEditorInput=I,e.isSideBySideEditorInput=k,e.isDiffEditorInput=b,e.createTooLargeFileError=E,e.isEditorInputWithOptions=N,e.isEditorInputWithOptionsAndGroup=O,e.isEditorIdentifier=M,e.isEditorCommandsContext=U,e.preventEditorClose=B,e.pathsToEditors=J,e.isTextEditorViewState=te,e.isEditorOpenError=me,e.createEditorOpenError=le,f=Vt(f),e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,s.localize)(4055,null),providerDisplayName:(0,s.localize)(4056,null)},e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";var T;(function(Q){Q[Q.PROGRAMMATIC=1]="PROGRAMMATIC",Q[Q.USER=2]="USER",Q[Q.EDIT=3]="EDIT",Q[Q.NAVIGATION=4]="NAVIGATION",Q[Q.JUMP=5]="JUMP"})(T||(e.EditorPaneSelectionChangeReason=T={}));var S;(function(Q){Q[Q.IDENTICAL=1]="IDENTICAL",Q[Q.SIMILAR=2]="SIMILAR",Q[Q.DIFFERENT=3]="DIFFERENT"})(S||(e.EditorPaneSelectionCompareResult=S={}));function o(Q){const z=Q;return!!z&&typeof z.getSelection=="function"&&!!z.onDidChangeSelection}function m(Q){const z=Q;return!!z&&typeof z.getScrollPosition=="function"&&typeof z.setScrollPosition=="function"&&!!z.onDidChangeScroll}function p(Q,z,se){for(const Ee of se.visibleEditorPanes)if(Ee.group.id===z&&Q.matches(Ee.input))return Ee.getViewState()}function u(Q){if(I(Q))return!1;const z=Q;return D.URI.isUri(z?.resource)}function i(Q){if(I(Q))return!1;const z=Q;return z?.original!==void 0&&z.modified!==void 0}function a(Q){if(I(Q))return!1;const z=Q;return!z||z.resources&&!Array.isArray(z.resources)?!1:!!z.resources||!!z.multiDiffSource}function t(Q){if(I(Q)||i(Q))return!1;const z=Q;return z?.primary!==void 0&&z.secondary!==void 0}function n(Q){if(I(Q))return!1;const z=Q;return z?z.resource===void 0||z.resource.scheme===l.Schemas.untitled||z.forceUntitled===!0:!1}function r(Q){if(I(Q))return!1;const z=Q;return D.URI.isUri(z?.base?.resource)&&D.URI.isUri(z?.input1?.resource)&&D.URI.isUri(z?.input2?.resource)&&D.URI.isUri(z?.result?.resource)}var d;(function(Q){Q[Q.SHORT=0]="SHORT",Q[Q.MEDIUM=1]="MEDIUM",Q[Q.LONG=2]="LONG"})(d||(e.Verbosity=d={}));var c;(function(Q){Q[Q.EXPLICIT=1]="EXPLICIT",Q[Q.AUTO=2]="AUTO",Q[Q.FOCUS_CHANGE=3]="FOCUS_CHANGE",Q[Q.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(c||(e.SaveReason=c={}));class g{constructor(){this.mapIdToSaveSource=new Map}registerSource(z,se){let Ee=this.mapIdToSaveSource.get(z);return Ee||(Ee={source:z,label:se},this.mapIdToSaveSource.set(z,Ee)),Ee.source}getSourceLabel(z){return this.mapIdToSaveSource.get(z)?.label??z}}e.SaveSourceRegistry=new g;var w;(function(Q){Q[Q.None=0]="None",Q[Q.Readonly=2]="Readonly",Q[Q.Untitled=4]="Untitled",Q[Q.Singleton=8]="Singleton",Q[Q.RequiresTrust=16]="RequiresTrust",Q[Q.CanSplitInGroup=32]="CanSplitInGroup",Q[Q.ForceDescription=64]="ForceDescription",Q[Q.CanDropIntoEditor=128]="CanDropIntoEditor",Q[Q.MultipleEditors=256]="MultipleEditors",Q[Q.Scratchpad=512]="Scratchpad"})(w||(e.EditorInputCapabilities=w={}));class y extends A.Disposable{}e.AbstractEditorInput=y;function I(Q){return Q instanceof y}function P(Q){const z=Q;return D.URI.isUri(z?.preferredResource)}function k(Q){const z=Q;return I(z?.primary)&&I(z?.secondary)}function b(Q){const z=Q;return I(z?.modified)&&I(z?.original)}function E(Q,z,se,Ee,ae){return le(Ee,[(0,_.toAction)({id:"workbench.action.openLargeFile",label:(0,s.localize)(4057,null),run:()=>{const be={...se,limits:{size:Number.MAX_VALUE}};Q.openEditor(z,be)}}),(0,_.toAction)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,s.localize)(4058,null),run:()=>ae.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:f.default.Warning})}function N(Q){return I(Q?.editor)}function O(Q){const z=Q;return N(Q)&&z?.group!==void 0}function M(Q){const z=Q;return typeof z?.groupId=="number"&&I(z.editor)}function U(Q){return typeof Q?.groupId=="number"}var H;(function(Q){Q[Q.UNKNOWN=0]="UNKNOWN",Q[Q.REPLACE=1]="REPLACE",Q[Q.MOVE=2]="MOVE",Q[Q.UNPIN=3]="UNPIN"})(H||(e.EditorCloseContext=H={}));var F;(function(Q){Q[Q.GROUP_ACTIVE=0]="GROUP_ACTIVE",Q[Q.GROUP_INDEX=1]="GROUP_INDEX",Q[Q.GROUP_LABEL=2]="GROUP_LABEL",Q[Q.GROUP_LOCKED=3]="GROUP_LOCKED",Q[Q.EDITORS_SELECTION=4]="EDITORS_SELECTION",Q[Q.EDITOR_OPEN=5]="EDITOR_OPEN",Q[Q.EDITOR_CLOSE=6]="EDITOR_CLOSE",Q[Q.EDITOR_MOVE=7]="EDITOR_MOVE",Q[Q.EDITOR_ACTIVE=8]="EDITOR_ACTIVE",Q[Q.EDITOR_LABEL=9]="EDITOR_LABEL",Q[Q.EDITOR_CAPABILITIES=10]="EDITOR_CAPABILITIES",Q[Q.EDITOR_PIN=11]="EDITOR_PIN",Q[Q.EDITOR_TRANSIENT=12]="EDITOR_TRANSIENT",Q[Q.EDITOR_STICKY=13]="EDITOR_STICKY",Q[Q.EDITOR_DIRTY=14]="EDITOR_DIRTY",Q[Q.EDITOR_WILL_DISPOSE=15]="EDITOR_WILL_DISPOSE"})(F||(e.GroupModelChangeKind=F={}));var x;(function(Q){Q[Q.PRIMARY=1]="PRIMARY",Q[Q.SECONDARY=2]="SECONDARY",Q[Q.BOTH=3]="BOTH",Q[Q.ANY=4]="ANY"})(x||(e.SideBySideEditor=x={}));class ${getOriginalUri(z,se){if(!z)return;if(r(z))return e.EditorResourceAccessor.getOriginalUri(z.result,se);if(se?.supportSideBySide){const{primary:ae,secondary:be}=this.getSideEditors(z);if(ae&&be){if(se?.supportSideBySide===x.BOTH)return{primary:this.getOriginalUri(ae,{filterByScheme:se.filterByScheme}),secondary:this.getOriginalUri(be,{filterByScheme:se.filterByScheme})};if(se?.supportSideBySide===x.ANY)return this.getOriginalUri(ae,{filterByScheme:se.filterByScheme})??this.getOriginalUri(be,{filterByScheme:se.filterByScheme});z=se.supportSideBySide===x.PRIMARY?ae:be}}if(i(z)||a(z)||t(z)||r(z))return;const Ee=P(z)?z.preferredResource:z.resource;return!Ee||!se||!se.filterByScheme?Ee:this.filterUri(Ee,se.filterByScheme)}getSideEditors(z){return k(z)||t(z)?{primary:z.primary,secondary:z.secondary}:b(z)||i(z)?{primary:z.modified,secondary:z.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(z,se){if(!z)return;if(r(z))return e.EditorResourceAccessor.getCanonicalUri(z.result,se);if(se?.supportSideBySide){const{primary:ae,secondary:be}=this.getSideEditors(z);if(ae&&be){if(se?.supportSideBySide===x.BOTH)return{primary:this.getCanonicalUri(ae,{filterByScheme:se.filterByScheme}),secondary:this.getCanonicalUri(be,{filterByScheme:se.filterByScheme})};if(se?.supportSideBySide===x.ANY)return this.getCanonicalUri(ae,{filterByScheme:se.filterByScheme})??this.getCanonicalUri(be,{filterByScheme:se.filterByScheme});z=se.supportSideBySide===x.PRIMARY?ae:be}}if(i(z)||a(z)||t(z)||r(z))return;const Ee=z.resource;return!Ee||!se||!se.filterByScheme?Ee:this.filterUri(Ee,se.filterByScheme)}filterUri(z,se){if(Array.isArray(se)){if(se.some(Ee=>z.scheme===Ee))return z}else if(se===z.scheme)return z}}var G;(function(Q){Q[Q.UNKNOWN=0]="UNKNOWN",Q[Q.KEYBOARD=1]="KEYBOARD",Q[Q.MOUSE=2]="MOUSE"})(G||(e.EditorCloseMethod=G={}));function B(Q,z,se,Ee){if(!Q.isSticky(z))return!1;switch(Ee.preventPinnedEditorClose){case"keyboardAndMouse":return se===G.MOUSE||se===G.KEYBOARD;case"mouse":return se===G.MOUSE;case"keyboard":return se===G.KEYBOARD}return!1}e.EditorResourceAccessor=new $;var W;(function(Q){Q[Q.LEFT=0]="LEFT",Q[Q.RIGHT=1]="RIGHT"})(W||(e.CloseDirection=W={}));class Z{constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start(z){const se=this.instantiationService=z.get(L.IInstantiationService);for(const[Ee,ae]of this.editorSerializerConstructors)this.createEditorSerializer(Ee,ae,se);this.editorSerializerConstructors.clear()}createEditorSerializer(z,se,Ee){const ae=Ee.createInstance(se);this.editorSerializerInstances.set(z,ae)}registerFileEditorFactory(z){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=z}getFileEditorFactory(){return(0,h.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer(z,se){if(this.editorSerializerConstructors.has(z)||this.editorSerializerInstances.has(z))throw new Error(`A editor serializer with type ID '${z}' was already registered.`);return this.instantiationService?this.createEditorSerializer(z,se,this.instantiationService):this.editorSerializerConstructors.set(z,se),(0,A.toDisposable)(()=>{this.editorSerializerConstructors.delete(z),this.editorSerializerInstances.delete(z)})}getEditorSerializer(z){return this.editorSerializerInstances.get(typeof z=="string"?z:z.typeId)}}R.Registry.add(e.EditorExtensions.EditorFactory,new Z);async function J(Q,z,se){return!Q||!Q.length?[]:await Promise.all(Q.map(async Ee=>{const ae=D.URI.revive(Ee.fileUri);if(!ae){se.info("Cannot resolve the path because it is not valid.",Ee);return}if(!await z.canHandleResource(ae)){se.info("Cannot resolve the path because it cannot be handled",Ee);return}let pe=Ee.exists,ve=Ee.type;if(typeof pe!="boolean"||typeof ve!="number")try{ve=(await z.stat(ae)).isDirectory?v.FileType.Directory:v.FileType.Unknown,pe=!0}catch(Fe){se.error(Fe),pe=!1}if(!pe&&Ee.openOnlyIfExists){se.info("Cannot resolve the path because it does not exist",Ee);return}if(ve===v.FileType.Directory){se.info("Cannot resolve the path because it is a directory",Ee);return}const Re={...Ee.options,pinned:!0};return pe?{resource:ae,options:Re}:{resource:ae,options:Re,forceUntitled:!0}}))}var oe;(function(Q){Q[Q.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",Q[Q.SEQUENTIAL=1]="SEQUENTIAL"})(oe||(e.EditorsOrder=oe={}));function te(Q){const z=Q;if(!z)return!1;const se=z;if(se.modified)return te(se.modified);const Ee=z;return!!(Ee.contributionsState&&Ee.viewState&&Array.isArray(Ee.cursorState))}function me(Q){return(0,C.isErrorWithActions)(Q)}function le(Q,z,se){const Ee=(0,C.createErrorWithActions)(Q,z);return Ee.forceMessage=se?.forceMessage,Ee.forceSeverity=se?.forceSeverity,Ee.allowDialog=se?.allowDialog,Ee}}),define(Pe[257],ke([1,0,4,7,5,3,28,37,24,84,247]),function(ge,e,s,h,D,A,L,R,v,l,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoTreeViewError=e.ResolvableTreeItem=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.IViewDescriptorService=e.ViewContentGroups=e.ViewContainerLocations=e.ViewContainerLocation=e.Extensions=e.defaultViewIcon=e.VIEWS_LOG_NAME=e.VIEWS_LOG_ID=void 0,e.ViewContainerLocationToString=T,e.VIEWS_LOG_ID="views",e.VIEWS_LOG_NAME=(0,h.localize)(4218,null),e.defaultViewIcon=(0,C.registerIcon)("default-view-icon",l.Codicon.window,(0,h.localize)(4219,null));var _;(function(n){n.ViewContainersRegistry="workbench.registry.view.containers",n.ViewsRegistry="workbench.registry.view"})(_||(e.Extensions=_={}));var f;(function(n){n[n.Sidebar=0]="Sidebar",n[n.Panel=1]="Panel",n[n.AuxiliaryBar=2]="AuxiliaryBar"})(f||(e.ViewContainerLocation=f={})),e.ViewContainerLocations=[f.Sidebar,f.Panel,f.AuxiliaryBar];function T(n){switch(n){case f.Sidebar:return"sidebar";case f.Panel:return"panel";case f.AuxiliaryBar:return"auxiliarybar"}}class S extends A.Disposable{constructor(){super(...arguments),this._onDidRegister=this._register(new s.Emitter),this.onDidRegister=this._onDidRegister.event,this._onDidDeregister=this._register(new s.Emitter),this.onDidDeregister=this._onDidDeregister.event,this.viewContainers=new Map,this.defaultViewContainers=[]}get all(){return[...this.viewContainers.values()].flat()}registerViewContainer(r,d,c){const g=this.get(r.id);if(g)return g;const w=r;return w.openCommandActionDescriptor=c?.doNotRegisterOpenCommand?void 0:w.openCommandActionDescriptor??{id:w.id},(0,L.getOrSet)(this.viewContainers,d,[]).push(w),c?.isDefault&&this.defaultViewContainers.push(w),this._onDidRegister.fire({viewContainer:w,viewContainerLocation:d}),w}deregisterViewContainer(r){for(const d of this.viewContainers.keys()){const c=this.viewContainers.get(d),g=c?.indexOf(r);if(g!==-1){c?.splice(g,1),c.length===0&&this.viewContainers.delete(d),this._onDidDeregister.fire({viewContainer:r,viewContainerLocation:d});return}}}get(r){return this.all.filter(d=>d.id===r)[0]}getViewContainers(r){return[...this.viewContainers.get(r)||[]]}getViewContainerLocation(r){return[...this.viewContainers.keys()].filter(d=>this.getViewContainers(d).filter(c=>c?.id===r.id).length>0)[0]}getDefaultViewContainer(r){return this.defaultViewContainers.find(d=>this.getViewContainerLocation(d)===r)}}R.Registry.add(_.ViewContainersRegistry,new S);var o;(function(n){n.Open="2_open",n.Debug="4_debug",n.SCM="5_scm",n.More="9_more"})(o||(e.ViewContentGroups=o={}));function m(n,r){const d=n.group??o.More,c=r.group??o.More;return d!==c?d.localeCompare(c):(n.order??5)-(r.order??5)}class p extends A.Disposable{constructor(){super(...arguments),this._onViewsRegistered=this._register(new s.Emitter),this.onViewsRegistered=this._onViewsRegistered.event,this._onViewsDeregistered=this._register(new s.Emitter),this.onViewsDeregistered=this._onViewsDeregistered.event,this._onDidChangeContainer=this._register(new s.Emitter),this.onDidChangeContainer=this._onDidChangeContainer.event,this._onDidChangeViewWelcomeContent=this._register(new s.Emitter),this.onDidChangeViewWelcomeContent=this._onDidChangeViewWelcomeContent.event,this._viewContainers=[],this._views=new Map,this._viewWelcomeContents=new L.SetMap}registerViews(r,d){this.registerViews2([{views:r,viewContainer:d}])}registerViews2(r){r.forEach(({views:d,viewContainer:c})=>this.addViews(d,c)),this._onViewsRegistered.fire(r)}deregisterViews(r,d){const c=this.removeViews(r,d);c.length&&this._onViewsDeregistered.fire({views:c,viewContainer:d})}moveViews(r,d){for(const c of this._views.keys())if(c!==d){const g=this.removeViews(r,c);g.length&&(this.addViews(g,d),this._onDidChangeContainer.fire({views:g,from:c,to:d}))}}getViews(r){return this._views.get(r)||[]}getView(r){for(const d of this._viewContainers){const c=(this._views.get(d)||[]).filter(g=>g.id===r)[0];if(c)return c}return null}getViewContainer(r){for(const d of this._viewContainers)if((this._views.get(d)||[]).filter(g=>g.id===r)[0])return d;return null}registerViewWelcomeContent(r,d){return this._viewWelcomeContents.add(r,d),this._onDidChangeViewWelcomeContent.fire(r),(0,A.toDisposable)(()=>{this._viewWelcomeContents.delete(r,d),this._onDidChangeViewWelcomeContent.fire(r)})}registerViewWelcomeContent2(r,d){const c=new Map;for(const[g,w]of d)this._viewWelcomeContents.add(r,w),c.set(g,(0,A.toDisposable)(()=>{this._viewWelcomeContents.delete(r,w),this._onDidChangeViewWelcomeContent.fire(r)}));return this._onDidChangeViewWelcomeContent.fire(r),c}getViewWelcomeContent(r){const d=[];return this._viewWelcomeContents.forEach(r,c=>d.push(c)),d.sort(m)}addViews(r,d){let c=this._views.get(d);c||(c=[],this._views.set(d,c),this._viewContainers.push(d));for(const g of r){if(this.getView(g.id)!==null)throw new Error((0,h.localize)(4220,null,g.id));c.push(g)}}removeViews(r,d){const c=this._views.get(d);if(!c)return[];const g=[],w=[];for(const y of c)r.includes(y)?g.push(y):w.push(y);return g.length&&(w.length?this._views.set(d,w):(this._views.delete(d),this._viewContainers.splice(this._viewContainers.indexOf(d),1))),g}}R.Registry.add(_.ViewsRegistry,new p),e.IViewDescriptorService=(0,D.createDecorator)("viewDescriptorService");var u;(function(n){n[n.Default=0]="Default",n[n.Expand=1]="Expand"})(u||(e.ViewVisibilityState=u={}));var i;(function(n){n[n.None=0]="None",n[n.Collapsed=1]="Collapsed",n[n.Expanded=2]="Expanded"})(i||(e.TreeItemCollapsibleState=i={}));class a{constructor(r,d){this.resolved=!1,this._hasResolve=!1,(0,v.mixin)(this,r),this._hasResolve=!!d,this.resolve=async c=>{if(d&&!this.resolved){const g=await d(c);g&&(this.tooltip=this.tooltip??g.tooltip,this.command=this.command??g.command)}c.isCancellationRequested||(this.resolved=!0)}}get hasResolve(){return this._hasResolve}resetResolve(){this.resolved=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.ResolvableTreeItem=a;class t extends Error{constructor(r){super((0,h.localize)(4221,null,r)),this.name="NoTreeViewError"}static is(r){return!!r&&r.name==="NoTreeViewError"}}e.NoTreeViewError=t}),define(Pe[258],ke([1,0,7,36]),function(ge,e,s,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_IN_QUICK_CHAT=e.CONTEXT_CHAT_LOCATION=e.CONTEXT_CHAT_INPUT_HAS_AGENT=e.CONTEXT_CHAT_INPUT_CURSOR_AT_TOP=e.CONTEXT_CHAT_EXTENSION_INVALID=e.CONTEXT_CHAT_PANEL_PARTICIPANT_REGISTERED=e.CONTEXT_CHAT_ENABLED=e.CONTEXT_IN_CHAT_SESSION=e.CONTEXT_IN_CHAT_INPUT=e.CONTEXT_CHAT_INPUT_HAS_FOCUS=e.CONTEXT_CHAT_INPUT_HAS_TEXT=e.CONTEXT_CHAT_EDIT_APPLIED=e.CONTEXT_REQUEST=e.CONTEXT_RESPONSE=e.CONTEXT_CHAT_REQUEST_IN_PROGRESS=e.CONTEXT_RESPONSE_ERROR=e.CONTEXT_RESPONSE_FILTERED=e.CONTEXT_CHAT_RESPONSE_SUPPORT_ISSUE_REPORTING=e.CONTEXT_RESPONSE_DETECTED_AGENT_COMMAND=e.CONTEXT_VOTE_UP_ENABLED=e.CONTEXT_RESPONSE_VOTE=void 0,e.CONTEXT_RESPONSE_VOTE=new h.RawContextKey("chatSessionResponseVote","",{type:"string",description:(0,s.localize)(4716,null)}),e.CONTEXT_VOTE_UP_ENABLED=new h.RawContextKey("chatVoteUpEnabled",!1,{type:"boolean",description:(0,s.localize)(4717,null)}),e.CONTEXT_RESPONSE_DETECTED_AGENT_COMMAND=new h.RawContextKey("chatSessionResponseDetectedAgentOrCommand",!1,{type:"boolean",description:(0,s.localize)(4718,null)}),e.CONTEXT_CHAT_RESPONSE_SUPPORT_ISSUE_REPORTING=new h.RawContextKey("chatResponseSupportsIssueReporting",!1,{type:"boolean",description:(0,s.localize)(4719,null)}),e.CONTEXT_RESPONSE_FILTERED=new h.RawContextKey("chatSessionResponseFiltered",!1,{type:"boolean",description:(0,s.localize)(4720,null)}),e.CONTEXT_RESPONSE_ERROR=new h.RawContextKey("chatSessionResponseError",!1,{type:"boolean",description:(0,s.localize)(4721,null)}),e.CONTEXT_CHAT_REQUEST_IN_PROGRESS=new h.RawContextKey("chatSessionRequestInProgress",!1,{type:"boolean",description:(0,s.localize)(4722,null)}),e.CONTEXT_RESPONSE=new h.RawContextKey("chatResponse",!1,{type:"boolean",description:(0,s.localize)(4723,null)}),e.CONTEXT_REQUEST=new h.RawContextKey("chatRequest",!1,{type:"boolean",description:(0,s.localize)(4724,null)}),e.CONTEXT_CHAT_EDIT_APPLIED=new h.RawContextKey("chatEditApplied",!1,{type:"boolean",description:(0,s.localize)(4725,null)}),e.CONTEXT_CHAT_INPUT_HAS_TEXT=new h.RawContextKey("chatInputHasText",!1,{type:"boolean",description:(0,s.localize)(4726,null)}),e.CONTEXT_CHAT_INPUT_HAS_FOCUS=new h.RawContextKey("chatInputHasFocus",!1,{type:"boolean",description:(0,s.localize)(4727,null)}),e.CONTEXT_IN_CHAT_INPUT=new h.RawContextKey("inChatInput",!1,{type:"boolean",description:(0,s.localize)(4728,null)}),e.CONTEXT_IN_CHAT_SESSION=new h.RawContextKey("inChat",!1,{type:"boolean",description:(0,s.localize)(4729,null)}),e.CONTEXT_CHAT_ENABLED=new h.RawContextKey("chatIsEnabled",!1,{type:"boolean",description:(0,s.localize)(4730,null)}),e.CONTEXT_CHAT_PANEL_PARTICIPANT_REGISTERED=new h.RawContextKey("chatPanelParticipantRegistered",!1,{type:"boolean",description:(0,s.localize)(4731,null)}),e.CONTEXT_CHAT_EXTENSION_INVALID=new h.RawContextKey("chatExtensionInvalid",!1,{type:"boolean",description:(0,s.localize)(4732,null)}),e.CONTEXT_CHAT_INPUT_CURSOR_AT_TOP=new h.RawContextKey("chatCursorAtTop",!1),e.CONTEXT_CHAT_INPUT_HAS_AGENT=new h.RawContextKey("chatInputHasAgent",!1),e.CONTEXT_CHAT_LOCATION=new h.RawContextKey("chatLocation",void 0),e.CONTEXT_IN_QUICK_CHAT=new h.RawContextKey("quickChatHasFocus",!1,{type:"boolean",description:(0,s.localize)(4733,null)})}),define(Pe[158],ke([1,0,133,8,20,4,40,3,38,186,13,36,23,5,11,115,240,156,258]),function(ge,e,s,h,D,A,L,R,v,l,C,_,f,T,S,o,m,p,u){"use strict";var i;Object.defineProperty(e,"__esModule",{value:!0}),e.ChatAgentNameService=e.IChatAgentNameService=e.MergedChatAgent=e.ChatAgentService=e.IChatAgentService=e.ChatAgentLocation=void 0,e.getFullyQualifiedId=d,e.reviveSerializedAgent=c;var a;(function(g){g.Panel="panel",g.Terminal="terminal",g.Notebook="notebook",g.Editor="editor"})(a||(e.ChatAgentLocation=a={})),function(g){function w(y){switch(y){case"panel":return g.Panel;case"terminal":return g.Terminal;case"notebook":return g.Notebook;case"editor":return g.Editor}return g.Panel}g.fromRaw=w}(a||(e.ChatAgentLocation=a={})),e.IChatAgentService=(0,T.createDecorator)("chatAgentService");let t=class{static{this.AGENT_LEADER="@"}constructor(w){this.contextKeyService=w,this._agents=new Map,this._onDidChangeAgents=new A.Emitter,this.onDidChangeAgents=this._onDidChangeAgents.event,this._agentCompletionProviders=new Map,this._chatParticipantDetectionProviders=new Map,this._hasDefaultAgent=u.CONTEXT_CHAT_ENABLED.bindTo(this.contextKeyService),this._defaultAgentRegistered=u.CONTEXT_CHAT_PANEL_PARTICIPANT_REGISTERED.bindTo(this.contextKeyService)}registerAgent(w,y){if(this.getAgent(w))throw new Error(`Agent already registered: ${JSON.stringify(w)}`);y.isDefault&&this._defaultAgentRegistered.set(!0);const P=this,k=y.slashCommands;y={...y,get slashCommands(){return k.filter(E=>!E.when||P.contextKeyService.contextMatchesRules(_.ContextKeyExpr.deserialize(E.when)))}};const b={data:y};return this._agents.set(w,b),this._onDidChangeAgents.fire(void 0),(0,R.toDisposable)(()=>{this._agents.delete(w),y.isDefault&&this._defaultAgentRegistered.set(!1),this._onDidChangeAgents.fire(void 0)})}registerAgentImplementation(w,y){const I=this._agents.get(w);if(!I)throw new Error(`Unknown agent: ${JSON.stringify(w)}`);if(I.impl)throw new Error(`Agent already has implementation: ${JSON.stringify(w)}`);return I.data.isDefault&&this._hasDefaultAgent.set(!0),I.impl=y,this._onDidChangeAgents.fire(new n(I.data,y)),(0,R.toDisposable)(()=>{I.impl=void 0,this._onDidChangeAgents.fire(void 0),I.data.isDefault&&this._hasDefaultAgent.set(!1)})}registerDynamicAgent(w,y){w.isDynamic=!0;const I={data:w,impl:y};return this._agents.set(w.id,I),this._onDidChangeAgents.fire(new n(w,y)),(0,R.toDisposable)(()=>{this._agents.delete(w.id),this._onDidChangeAgents.fire(void 0)})}registerAgentCompletionProvider(w,y){return this._agentCompletionProviders.set(w,y),{dispose:()=>{this._agentCompletionProviders.delete(w)}}}async getAgentCompletionItems(w,y,I){return await this._agentCompletionProviders.get(w)?.(y,I)??[]}updateAgent(w,y){const I=this._agents.get(w);if(!I?.impl)throw new Error(`No activated agent with id ${JSON.stringify(w)} registered`);I.data.metadata={...I.data.metadata,...y},this._onDidChangeAgents.fire(new n(I.data,I.impl))}getDefaultAgent(w){return(0,s.findLast)(this.getActivatedAgents(),y=>!!y.isDefault&&y.locations.includes(w))}getContributedDefaultAgent(w){return this.getAgents().find(y=>!!y.isDefault&&y.locations.includes(w))}getSecondaryAgent(){return L.Iterable.find(this._agents.values(),w=>!!w.data.metadata.isSecondary)?.data}getAgent(w){if(this._agentIsEnabled(w))return this._agents.get(w)?.data}_agentIsEnabled(w){const y=this._agents.get(w);return!y?.data.when||this.contextKeyService.contextMatchesRules(_.ContextKeyExpr.deserialize(y.data.when))}getAgentByFullyQualifiedId(w){const y=L.Iterable.find(this._agents.values(),I=>d(I.data)===w)?.data;if(!(y&&!this._agentIsEnabled(y.id)))return y}getAgents(){return Array.from(this._agents.values()).map(w=>w.data).filter(w=>this._agentIsEnabled(w.id))}getActivatedAgents(){return Array.from(this._agents.values()).filter(w=>!!w.impl).filter(w=>this._agentIsEnabled(w.data.id)).map(w=>new n(w.data,w.impl))}getAgentsByName(w){return this.getAgents().filter(y=>y.name===w)}agentHasDupeName(w){const y=this.getAgent(w);return y?this.getAgentsByName(y.name).filter(I=>I.extensionId.value!==y.extensionId.value).length>0:!1}async invokeAgent(w,y,I,P,k){const b=this._agents.get(w);if(!b?.impl)throw new Error(`No activated agent with id "${w}"`);return await b.impl.invoke(y,I,P,k)}async getFollowups(w,y,I,P,k){const b=this._agents.get(w);if(!b?.impl)throw new Error(`No activated agent with id "${w}"`);return b.impl?.provideFollowups?b.impl.provideFollowups(y,I,P,k):[]}async getChatTitle(w,y,I){const P=this._agents.get(w);if(!P?.impl)throw new Error(`No activated agent with id "${w}"`);if(P.impl?.provideChatTitle)return P.impl.provideChatTitle(y,I)}registerChatParticipantDetectionProvider(w,y){return this._chatParticipantDetectionProviders.set(w,y),(0,R.toDisposable)(()=>{this._chatParticipantDetectionProviders.delete(w)})}hasChatParticipantDetectionProviders(){return this._chatParticipantDetectionProviders.size>0}async detectAgentOrCommand(w,y,I,P){const k=L.Iterable.first(this._chatParticipantDetectionProviders.values());if(!k)return;const b=this.getAgents().reduce((M,U)=>{M.push({participant:U.id,disambiguation:U.disambiguation??[]});for(const H of U.slashCommands)M.push({participant:U.id,command:H.name,disambiguation:H.disambiguation??[]});return M},[]),E=await k.provideParticipantDetection(w,y,{...I,participants:b},P);if(!E)return;const N=this.getAgent(E.participant);if(!N)return;if(!E.command)return{agent:N};const O=N?.slashCommands.find(M=>M.name===E.command);if(O)return{agent:N,command:O}}};e.ChatAgentService=t,e.ChatAgentService=t=Qe([$e(0,_.IContextKeyService)],t);class n{constructor(w,y){this.data=w,this.impl=y}get id(){return this.data.id}get name(){return this.data.name??""}get fullName(){return this.data.fullName??""}get description(){return this.data.description??""}get extensionId(){return this.data.extensionId}get extensionPublisherId(){return this.data.extensionPublisherId}get extensionPublisherDisplayName(){return this.data.publisherDisplayName}get extensionDisplayName(){return this.data.extensionDisplayName}get isDefault(){return this.data.isDefault}get metadata(){return this.data.metadata}get slashCommands(){return this.data.slashCommands}get locations(){return this.data.locations}get disambiguation(){return this.data.disambiguation}async invoke(w,y,I,P){return this.impl.invoke(w,y,I,P)}async provideFollowups(w,y,I,P){return this.impl.provideFollowups?this.impl.provideFollowups(w,y,I,P):[]}provideWelcomeMessage(w,y){if(this.impl.provideWelcomeMessage)return this.impl.provideWelcomeMessage(w,y)}provideSampleQuestions(w,y){if(this.impl.provideSampleQuestions)return this.impl.provideSampleQuestions(w,y)}toJSON(){return this.data}}e.MergedChatAgent=n,e.IChatAgentNameService=(0,T.createDecorator)("chatAgentNameService");let r=class{static{i=this}static{this.StorageKey="chat.participantNameRegistry"}constructor(w,y,I,P){if(this.requestService=y,this.logService=I,this.storageService=P,this.registry=(0,l.observableValue)(this,Object.create(null)),this.disposed=!1,!w.chatParticipantRegistry)return;this.url=w.chatParticipantRegistry;const k=P.get(i.StorageKey,p.StorageScope.APPLICATION);try{this.registry.set(JSON.parse(k??"{}"),void 0)}catch{P.remove(i.StorageKey,p.StorageScope.APPLICATION)}this.refresh()}refresh(){this.disposed||this.update().catch(w=>this.logService.warn("Failed to fetch chat participant registry",w)).then(()=>(0,h.timeout)(5*60*1e3)).then(()=>this.refresh())}async update(){const w=await this.requestService.request({type:"GET",url:this.url},D.CancellationToken.None);if(w.res.statusCode!==200)throw new Error("Could not get extensions report.");const y=await(0,m.asJson)(w);if(!y||y.version!==1)throw new Error("Unexpected chat participant registry response.");const I=y.restrictedChatParticipants;this.registry.set(I,void 0),this.storageService.store(i.StorageKey,JSON.stringify(I),p.StorageScope.APPLICATION,p.StorageTarget.MACHINE)}getAgentNameRestriction(w){const y=this.checkAgentNameRestriction(w.name,w).get(),I=!w.fullName||this.checkAgentNameRestriction(w.fullName.replace(/\s/g,""),w).get();return y&&I}checkAgentNameRestriction(w,y){return this.registry.map(P=>P[w.toLowerCase()]).map(P=>P?P.some(k=>(0,C.equalsIgnoreCase)(k,k.includes(".")?y.extensionId.value:y.extensionPublisherId)):!0)}dispose(){this.disposed=!0}};e.ChatAgentNameService=r,e.ChatAgentNameService=r=i=Qe([$e(0,o.IProductService),$e(1,m.IRequestService),$e(2,S.ILogService),$e(3,p.IStorageService)],r);function d(g){return`${g.extensionId.value}.${g.id}`}function c(g){const w="name"in g?g:{...g,name:g.id};return"extensionPublisherId"in w||(w.extensionPublisherId=w.extensionPublisher??""),"extensionDisplayName"in w||(w.extensionDisplayName=""),"extensionId"in w||(w.extensionId=new f.ExtensionIdentifier("")),(0,v.revive)(w)}}),define(Pe[259],ke([1,0,2,30,5]),function(ge,e,s,h,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KEYWORD_ACTIVIATION_SETTING_ID=e.IChatService=e.ChatCopyKind=e.ChatAgentVoteDownReason=e.ChatAgentVoteDirection=e.ChatResponseReferencePartStatusKind=void 0,e.isIDocumentContext=A,e.isIUsedContext=L;function A(_){return!!_&&typeof _=="object"&&"uri"in _&&_.uri instanceof s.URI&&"version"in _&&typeof _.version=="number"&&"ranges"in _&&Array.isArray(_.ranges)&&_.ranges.every(h.Range.isIRange)}function L(_){return!!_&&typeof _=="object"&&"documents"in _&&Array.isArray(_.documents)&&_.documents.every(A)}var R;(function(_){_[_.Complete=1]="Complete",_[_.Partial=2]="Partial",_[_.Omitted=3]="Omitted"})(R||(e.ChatResponseReferencePartStatusKind=R={}));var v;(function(_){_[_.Down=0]="Down",_[_.Up=1]="Up"})(v||(e.ChatAgentVoteDirection=v={}));var l;(function(_){_.IncorrectCode="incorrectCode",_.DidNotFollowInstructions="didNotFollowInstructions",_.IncompleteCode="incompleteCode",_.MissingContext="missingContext",_.PoorlyWrittenOrFormatted="poorlyWrittenOrFormatted",_.RefusedAValidRequest="refusedAValidRequest",_.OffensiveOrUnsafe="offensiveOrUnsafe",_.Other="other",_.WillReportIssue="willReportIssue"})(l||(e.ChatAgentVoteDownReason=l={}));var C;(function(_){_[_.Action=1]="Action",_[_.Toolbar=2]="Toolbar"})(C||(e.ChatCopyKind=C={})),e.IChatService=(0,D.createDecorator)("IChatService"),e.KEYWORD_ACTIVIATION_SETTING_ID="accessibility.voice.keywordActivation"}),define(Pe[159],ke([1,0,4,8,7]),function(ge,e,s,h,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class A{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new s.Emitter,this._onExit=new s.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(R){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=R}onEvent(R){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=R}onRequest(R){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=R}sendResponse(R){R.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${R.command}`)):this.internalSend("response",R)}sendRequest(R,v,l,C){const _={command:R};if(v&&Object.keys(v).length>0&&(_.arguments=v),this.internalSend("request",_),typeof C=="number"){const f=setTimeout(()=>{clearTimeout(f);const T=this.pendingRequests.get(_.seq);if(T){this.pendingRequests.delete(_.seq);const S={type:"response",seq:0,request_seq:_.seq,success:!1,command:R,message:(0,D.localize)(5733,null,C,R)};T(S)}},C)}return l&&this.pendingRequests.set(_.seq,l),_.seq}acceptMessage(R){this.messageCallback?this.messageCallback(R):(this.queue.push(R),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(R,v){return R.type!=="event"||v.type!=="event"}async processQueue(){let R;for(;this.queue.length;){if((!R||this.needsTaskBoundaryBetween(this.queue[0],R))&&await(0,h.timeout)(0),R=this.queue.shift(),!R)return;switch(R.type){case"event":this.eventCallback?.(R);break;case"request":this.requestCallback?.(R);break;case"response":{const v=R,l=this.pendingRequests.get(v.request_seq);l&&(this.pendingRequests.delete(v.request_seq),l(v));break}}}}internalSend(R,v){v.type=R,v.seq=this.sequence++,this.sendMessage(v)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const R=new Map;this.pendingRequests.forEach((v,l)=>R.set(l,v)),await(0,h.timeout)(500),R.forEach((v,l)=>{v({type:"response",seq:0,request_seq:l,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(l)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=A}),define(Pe[119],ke([1,0,2,7,36,5]),function(ge,e,s,h,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDebugVisualization=e.IDebugVisualizationTreeItem=e.DebugTreeItemCollapsibleState=e.DebugVisualizationType=e.BreakpointWidgetContext=e.IDebugService=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DataBreakpointSetType=e.DEBUG_MEMORY_SCHEME=e.MemoryRangeType=e.State=e.INTERNAL_CONSOLE_OPTIONS_SCHEMA=e.DEBUG_SCHEME=e.BREAKPOINT_EDITOR_CONTRIBUTION_ID=e.EDITOR_CONTRIBUTION_ID=e.debuggerDisabledMessage=e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=e.CONTEXT_MULTI_SESSION_DEBUG=e.CONTEXT_MULTI_SESSION_REPL=e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=e.CONTEXT_VARIABLE_EXTENSIONID=e.CONTEXT_VARIABLE_LANGUAGE=e.CONTEXT_VARIABLE_NAME=e.CONTEXT_VARIABLE_INTERFACES=e.CONTEXT_VARIABLE_TYPE=e.CONTEXT_VARIABLE_VALUE=e.CONTEXT_VARIABLE_IS_READONLY=e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=e.CONTEXT_SET_EXPRESSION_SUPPORTED=e.CONTEXT_SET_DATA_BREAKPOINT_BYTES_SUPPORTED=e.CONTEXT_SET_VARIABLE_SUPPORTED=e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=e.CONTEXT_DEBUGGERS_AVAILABLE=e.CONTEXT_BREAKPOINTS_EXIST=e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=e.CONTEXT_RESTART_FRAME_SUPPORTED=e.CONTEXT_STEP_BACK_SUPPORTED=e.CONTEXT_FOCUSED_SESSION_IS_NO_DEBUG=e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=e.CONTEXT_BREAKPOINT_HAS_MODES=e.CONTEXT_BREAKPOINT_ITEM_IS_DATA_BYTES=e.CONTEXT_BREAKPOINT_ITEM_TYPE=e.CONTEXT_CAN_VIEW_MEMORY=e.CONTEXT_WATCH_ITEM_TYPE=e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=e.CONTEXT_CALLSTACK_ITEM_STOPPED=e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=e.CONTEXT_CALLSTACK_ITEM_TYPE=e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=e.CONTEXT_EXPRESSION_SELECTED=e.CONTEXT_VARIABLES_FOCUSED=e.CONTEXT_WATCH_EXPRESSIONS_EXIST=e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=e.CONTEXT_BREAKPOINTS_FOCUSED=e.CONTEXT_IN_BREAKPOINT_WIDGET=e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=e.CONTEXT_IN_DEBUG_REPL=e.CONTEXT_IN_DEBUG_MODE=e.CONTEXT_HAS_DEBUGGED=e.CONTEXT_DEBUG_UX=e.CONTEXT_DEBUG_UX_KEY=e.CONTEXT_DEBUG_STATE=e.CONTEXT_DEBUG_CONFIGURATION_TYPE=e.CONTEXT_DEBUG_TYPE=e.REPL_VIEW_ID=e.DEBUG_PANEL_ID=e.DISASSEMBLY_VIEW_ID=e.BREAKPOINTS_VIEW_ID=e.LOADED_SCRIPTS_VIEW_ID=e.CALLSTACK_VIEW_ID=e.WATCH_VIEW_ID=e.VARIABLES_VIEW_ID=e.VIEWLET_ID=void 0,e.getStateLabel=v,e.isFrameDeemphasized=C,h=We(h),e.VIEWLET_ID="workbench.view.debug",e.VARIABLES_VIEW_ID="workbench.debug.variablesView",e.WATCH_VIEW_ID="workbench.debug.watchExpressionsView",e.CALLSTACK_VIEW_ID="workbench.debug.callStackView",e.LOADED_SCRIPTS_VIEW_ID="workbench.debug.loadedScriptsView",e.BREAKPOINTS_VIEW_ID="workbench.debug.breakPointsView",e.DISASSEMBLY_VIEW_ID="workbench.debug.disassemblyView",e.DEBUG_PANEL_ID="workbench.panel.repl",e.REPL_VIEW_ID="workbench.panel.repl.view",e.CONTEXT_DEBUG_TYPE=new D.RawContextKey("debugType",void 0,{type:"string",description:h.localize(5734,null)}),e.CONTEXT_DEBUG_CONFIGURATION_TYPE=new D.RawContextKey("debugConfigurationType",void 0,{type:"string",description:h.localize(5735,null)}),e.CONTEXT_DEBUG_STATE=new D.RawContextKey("debugState","inactive",{type:"string",description:h.localize(5736,null)}),e.CONTEXT_DEBUG_UX_KEY="debugUx",e.CONTEXT_DEBUG_UX=new D.RawContextKey(e.CONTEXT_DEBUG_UX_KEY,"default",{type:"string",description:h.localize(5737,null)}),e.CONTEXT_HAS_DEBUGGED=new D.RawContextKey("hasDebugged",!1,{type:"boolean",description:h.localize(5738,null)}),e.CONTEXT_IN_DEBUG_MODE=new D.RawContextKey("inDebugMode",!1,{type:"boolean",description:h.localize(5739,null)}),e.CONTEXT_IN_DEBUG_REPL=new D.RawContextKey("inDebugRepl",!1,{type:"boolean",description:h.localize(5740,null)}),e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=new D.RawContextKey("breakpointWidgetVisible",!1,{type:"boolean",description:h.localize(5741,null)}),e.CONTEXT_IN_BREAKPOINT_WIDGET=new D.RawContextKey("inBreakpointWidget",!1,{type:"boolean",description:h.localize(5742,null)}),e.CONTEXT_BREAKPOINTS_FOCUSED=new D.RawContextKey("breakpointsFocused",!0,{type:"boolean",description:h.localize(5743,null)}),e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=new D.RawContextKey("watchExpressionsFocused",!0,{type:"boolean",description:h.localize(5744,null)}),e.CONTEXT_WATCH_EXPRESSIONS_EXIST=new D.RawContextKey("watchExpressionsExist",!1,{type:"boolean",description:h.localize(5745,null)}),e.CONTEXT_VARIABLES_FOCUSED=new D.RawContextKey("variablesFocused",!0,{type:"boolean",description:h.localize(5746,null)}),e.CONTEXT_EXPRESSION_SELECTED=new D.RawContextKey("expressionSelected",!1,{type:"boolean",description:h.localize(5747,null)}),e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=new D.RawContextKey("breakpointInputFocused",!1,{type:"boolean",description:h.localize(5748,null)}),e.CONTEXT_CALLSTACK_ITEM_TYPE=new D.RawContextKey("callStackItemType",void 0,{type:"string",description:h.localize(5749,null)}),e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=new D.RawContextKey("callStackSessionIsAttach",!1,{type:"boolean",description:h.localize(5750,null)}),e.CONTEXT_CALLSTACK_ITEM_STOPPED=new D.RawContextKey("callStackItemStopped",!1,{type:"boolean",description:h.localize(5751,null)}),e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=new D.RawContextKey("callStackSessionHasOneThread",!1,{type:"boolean",description:h.localize(5752,null)}),e.CONTEXT_WATCH_ITEM_TYPE=new D.RawContextKey("watchItemType",void 0,{type:"string",description:h.localize(5753,null)}),e.CONTEXT_CAN_VIEW_MEMORY=new D.RawContextKey("canViewMemory",void 0,{type:"boolean",description:h.localize(5754,null)}),e.CONTEXT_BREAKPOINT_ITEM_TYPE=new D.RawContextKey("breakpointItemType",void 0,{type:"string",description:h.localize(5755,null)}),e.CONTEXT_BREAKPOINT_ITEM_IS_DATA_BYTES=new D.RawContextKey("breakpointItemBytes",void 0,{type:"boolean",description:h.localize(5756,null)}),e.CONTEXT_BREAKPOINT_HAS_MODES=new D.RawContextKey("breakpointHasModes",!1,{type:"boolean",description:h.localize(5757,null)}),e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=new D.RawContextKey("breakpointSupportsCondition",!1,{type:"boolean",description:h.localize(5758,null)}),e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=new D.RawContextKey("loadedScriptsSupported",!1,{type:"boolean",description:h.localize(5759,null)}),e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=new D.RawContextKey("loadedScriptsItemType",void 0,{type:"string",description:h.localize(5760,null)}),e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=new D.RawContextKey("focusedSessionIsAttach",!1,{type:"boolean",description:h.localize(5761,null)}),e.CONTEXT_FOCUSED_SESSION_IS_NO_DEBUG=new D.RawContextKey("focusedSessionIsNoDebug",!1,{type:"boolean",description:h.localize(5762,null)}),e.CONTEXT_STEP_BACK_SUPPORTED=new D.RawContextKey("stepBackSupported",!1,{type:"boolean",description:h.localize(5763,null)}),e.CONTEXT_RESTART_FRAME_SUPPORTED=new D.RawContextKey("restartFrameSupported",!1,{type:"boolean",description:h.localize(5764,null)}),e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=new D.RawContextKey("stackFrameSupportsRestart",!1,{type:"boolean",description:h.localize(5765,null)}),e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=new D.RawContextKey("jumpToCursorSupported",!1,{type:"boolean",description:h.localize(5766,null)}),e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=new D.RawContextKey("stepIntoTargetsSupported",!1,{type:"boolean",description:h.localize(5767,null)}),e.CONTEXT_BREAKPOINTS_EXIST=new D.RawContextKey("breakpointsExist",!1,{type:"boolean",description:h.localize(5768,null)}),e.CONTEXT_DEBUGGERS_AVAILABLE=new D.RawContextKey("debuggersAvailable",!1,{type:"boolean",description:h.localize(5769,null)}),e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=new D.RawContextKey("debugExtensionAvailable",!0,{type:"boolean",description:h.localize(5770,null)}),e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=new D.RawContextKey("debugProtocolVariableMenuContext",void 0,{type:"string",description:h.localize(5771,null)}),e.CONTEXT_SET_VARIABLE_SUPPORTED=new D.RawContextKey("debugSetVariableSupported",!1,{type:"boolean",description:h.localize(5772,null)}),e.CONTEXT_SET_DATA_BREAKPOINT_BYTES_SUPPORTED=new D.RawContextKey("debugSetDataBreakpointAddressSupported",!1,{type:"boolean",description:h.localize(5773,null)}),e.CONTEXT_SET_EXPRESSION_SUPPORTED=new D.RawContextKey("debugSetExpressionSupported",!1,{type:"boolean",description:h.localize(5774,null)}),e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=new D.RawContextKey("breakWhenValueChangesSupported",!1,{type:"boolean",description:h.localize(5775,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=new D.RawContextKey("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:h.localize(5776,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=new D.RawContextKey("breakWhenValueIsReadSupported",!1,{type:"boolean",description:h.localize(5777,null)}),e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=new D.RawContextKey("terminateDebuggeeSupported",!1,{type:"boolean",description:h.localize(5778,null)}),e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=new D.RawContextKey("suspendDebuggeeSupported",!1,{type:"boolean",description:h.localize(5779,null)}),e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=new D.RawContextKey("variableEvaluateNamePresent",!1,{type:"boolean",description:h.localize(5780,null)}),e.CONTEXT_VARIABLE_IS_READONLY=new D.RawContextKey("variableIsReadonly",!1,{type:"boolean",description:h.localize(5781,null)}),e.CONTEXT_VARIABLE_VALUE=new D.RawContextKey("variableValue",!1,{type:"string",description:h.localize(5782,null)}),e.CONTEXT_VARIABLE_TYPE=new D.RawContextKey("variableType",!1,{type:"string",description:h.localize(5783,null)}),e.CONTEXT_VARIABLE_INTERFACES=new D.RawContextKey("variableInterfaces",!1,{type:"array",description:h.localize(5784,null)}),e.CONTEXT_VARIABLE_NAME=new D.RawContextKey("variableName",!1,{type:"string",description:h.localize(5785,null)}),e.CONTEXT_VARIABLE_LANGUAGE=new D.RawContextKey("variableLanguage",!1,{type:"string",description:h.localize(5786,null)}),e.CONTEXT_VARIABLE_EXTENSIONID=new D.RawContextKey("variableExtensionId",!1,{type:"string",description:h.localize(5787,null)}),e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=new D.RawContextKey("exceptionWidgetVisible",!1,{type:"boolean",description:h.localize(5788,null)}),e.CONTEXT_MULTI_SESSION_REPL=new D.RawContextKey("multiSessionRepl",!1,{type:"boolean",description:h.localize(5789,null)}),e.CONTEXT_MULTI_SESSION_DEBUG=new D.RawContextKey("multiSessionDebug",!1,{type:"boolean",description:h.localize(5790,null)}),e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=new D.RawContextKey("disassembleRequestSupported",!1,{type:"boolean",description:h.localize(5791,null)}),e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=new D.RawContextKey("disassemblyViewFocus",!1,{type:"boolean",description:h.localize(5792,null)}),e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=new D.RawContextKey("languageSupportsDisassembleRequest",!1,{type:"boolean",description:h.localize(5793,null)}),e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=new D.RawContextKey("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:h.localize(5794,null)});const L=i=>h.localize(5795,null,i);e.debuggerDisabledMessage=L,e.EDITOR_CONTRIBUTION_ID="editor.contrib.debug",e.BREAKPOINT_EDITOR_CONTRIBUTION_ID="editor.contrib.breakpoint",e.DEBUG_SCHEME="debug",e.INTERNAL_CONSOLE_OPTIONS_SCHEMA={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:h.localize(5796,null)};var R;(function(i){i[i.Inactive=0]="Inactive",i[i.Initializing=1]="Initializing",i[i.Stopped=2]="Stopped",i[i.Running=3]="Running"})(R||(e.State=R={}));function v(i){switch(i){case R.Initializing:return"initializing";case R.Stopped:return"stopped";case R.Running:return"running";default:return"inactive"}}var l;(function(i){i[i.Valid=0]="Valid",i[i.Unreadable=1]="Unreadable",i[i.Error=2]="Error"})(l||(e.MemoryRangeType=l={})),e.DEBUG_MEMORY_SCHEME="vscode-debug-memory";function C(i){const a=i.presentationHint??i.source.presentationHint;return a==="deemphasize"||a==="subtle"}var _;(function(i){i[i.Variable=0]="Variable",i[i.Address=1]="Address"})(_||(e.DataBreakpointSetType=_={}));var f;(function(i){i[i.Initial=1]="Initial",i[i.Dynamic=2]="Dynamic"})(f||(e.DebugConfigurationProviderTriggerKind=f={}));var T;(function(i){i.UnverifiedBreakpoints="unverifiedBreakpoints"})(T||(e.DebuggerString=T={})),e.IDebugService=(0,A.createDecorator)("debugService");var S;(function(i){i[i.CONDITION=0]="CONDITION",i[i.HIT_COUNT=1]="HIT_COUNT",i[i.LOG_MESSAGE=2]="LOG_MESSAGE",i[i.TRIGGER_POINT=3]="TRIGGER_POINT"})(S||(e.BreakpointWidgetContext=S={}));var o;(function(i){i[i.Command=0]="Command",i[i.Tree=1]="Tree"})(o||(e.DebugVisualizationType=o={}));var m;(function(i){i[i.None=0]="None",i[i.Collapsed=1]="Collapsed",i[i.Expanded=2]="Expanded"})(m||(e.DebugTreeItemCollapsibleState=m={}));var p;(function(i){i.deserialize=a=>a,i.serialize=a=>a})(p||(e.IDebugVisualizationTreeItem=p={}));var u;(function(i){i.deserialize=a=>({id:a.id,name:a.name,iconPath:a.iconPath&&{light:s.URI.revive(a.iconPath.light),dark:s.URI.revive(a.iconPath.dark)},iconClass:a.iconClass,visualization:a.visualization}),i.serialize=a=>a})(u||(e.IDebugVisualization=u={}))}),define(Pe[260],ke([1,0,13,2,16,24,14,30,20,18]),function(ge,e,s,h,D,A,L,R,v,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sourcesEqual=void 0,e.formatPII=_,e.filterExceptionsFromTelemetry=f,e.isSessionAttach=T,e.getExtensionHostDebugSession=S,e.isDebuggerMainContribution=o,e.getExactExpressionStartAndEnd=m,e.getEvaluatableExpressionAtPosition=p,e.isUri=i,e.convertToDAPaths=n,e.convertToVSCPaths=r,e.getVisibleAndSorted=c,e.saveAllBeforeDebugStart=w;const C=/{([^}]+)}/g;function _(I,P,k){return I.replace(C,function(b,E){return P&&E.length>0&&E[0]!=="_"?b:k&&k.hasOwnProperty(E)?k[E]:b})}function f(I){const P={};for(const k of Object.keys(I))k.startsWith("!")||(P[k]=I[k]);return P}function T(I){return I.configuration.request==="attach"&&!S(I)&&(!I.parentSession||T(I.parentSession))}function S(I){let P=I.configuration.type;if(P)return P==="vslsShare"&&(P=I.configuration.adapterProxy.configuration.type),(0,s.equalsIgnoreCase)(P,"extensionhost")||(0,s.equalsIgnoreCase)(P,"pwa-extensionhost")?I:I.parentSession?S(I.parentSession):void 0}function o(I){return I.type&&(I.label||I.program||I.runtime)}function m(I,P,k){let b,E=0;const N=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let O=null;for(;O=N.exec(I);){const M=O.index+1,U=M+O[0].length;if(M<=P&&U>=k){b=O[0],E=M;break}}if(b){const M=/(\w|\p{L})+/gu;let U=null;for(;(U=M.exec(b))&&!(U.index+1+E+U[0].length>=k););U&&(b=b.substring(0,M.lastIndex))}return b?{start:E,end:E+b.length-1}:{start:0,end:0}}async function p(I,P,k,b){if(I.evaluatableExpressionProvider.has(P)){const E=I.evaluatableExpressionProvider.ordered(P),N=(0,l.coalesce)(await Promise.all(E.map(async O=>{try{return await O.provideEvaluatableExpression(P,k,b??v.CancellationToken.None)}catch{return}})));if(N.length>0){let O=N[0].expression;const M=N[0].range;return O||(O=P.getLineContent(k.lineNumber).substring(M.startColumn-1,M.endColumn-1)),{range:M,matchingExpression:O}}}else{const E=P.getLineContent(k.lineNumber),{start:N,end:O}=m(E,k.column,k.column),M=E.substring(N-1,O);return{matchingExpression:M,range:new R.Range(k.lineNumber,N,k.lineNumber,N+M.length)}}return null}const u=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function i(I){return!!(I&&I.match(u))}function a(I){if(typeof I.path=="string"&&!(typeof I.sourceReference=="number"&&I.sourceReference>0)){if(i(I.path))return h.URI.parse(I.path);if((0,D.isAbsolute)(I.path))return h.URI.file(I.path)}return I.path}function t(I){if(typeof I.path=="object"){const P=h.URI.revive(I.path);if(P)return P.scheme===L.Schemas.file?P.fsPath:P.toString()}return I.path}function n(I,P){const k=P?a:t,b=(0,A.deepClone)(I);return d(b,(E,N)=>{E&&N&&(N.path=k(N))}),b}function r(I,P){const k=P?a:t,b=(0,A.deepClone)(I);return d(b,(E,N)=>{!E&&N&&(N.path=k(N))}),b}function d(I,P){switch(I.type){case"event":{const k=I;switch(k.event){case"output":P(!1,k.body.source);break;case"loadedSource":P(!1,k.body.source);break;case"breakpoint":P(!1,k.body.breakpoint.source);break;default:break}break}case"request":{const k=I;switch(k.command){case"setBreakpoints":P(!0,k.arguments.source);break;case"breakpointLocations":P(!0,k.arguments.source);break;case"source":P(!0,k.arguments.source);break;case"gotoTargets":P(!0,k.arguments.source);break;case"launchVSCode":k.arguments.args.forEach(b=>P(!1,b));break;default:break}break}case"response":{const k=I;if(k.success&&k.body)switch(k.command){case"stackTrace":k.body.stackFrames.forEach(b=>P(!1,b.source));break;case"loadedSources":k.body.sources.forEach(b=>P(!1,b));break;case"scopes":k.body.scopes.forEach(b=>P(!1,b.source));break;case"setFunctionBreakpoints":k.body.breakpoints.forEach(b=>P(!1,b.source));break;case"setBreakpoints":k.body.breakpoints.forEach(b=>P(!1,b.source));break;case"disassemble":k.body?.instructions.forEach(E=>P(!1,E.location));break;case"locations":P(!1,k.body?.source);break;default:break}break}}}function c(I){return I.filter(P=>!P.presentation?.hidden).sort((P,k)=>P.presentation?k.presentation?P.presentation.group?k.presentation.group?P.presentation.group!==k.presentation.group?P.presentation.group.localeCompare(k.presentation.group):g(P.presentation.order,k.presentation.order):-1:k.presentation.group?1:g(P.presentation.order,k.presentation.order):-1:k.presentation?1:0)}function g(I,P){return typeof I!="number"?typeof P!="number"?0:1:typeof P!="number"?-1:I-P}async function w(I,P){const k=I.getValue("debug.saveBeforeStart",{overrideIdentifier:P.activeTextEditorLanguageId});if(k!=="none"&&(await P.saveAll(),k==="allEditorsInActiveGroup")){const b=P.activeEditorPane;b&&b.input.resource?.scheme===L.Schemas.untitled&&await P.save({editor:b.input,groupId:b.group.id})}await I.reloadConfiguration()}const y=(I,P)=>!I||!P?I===P:I.name===P.name&&I.path===P.path&&I.sourceReference===P.sourceReference;e.sourcesEqual=y}),define(Pe[261],ke([1,0,58,68,24,16,10,13,34,7,159]),function(ge,e,s,h,D,A,L,R,v,l,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExecutableDebugAdapter=e.NamedPipeDebugAdapter=e.SocketDebugAdapter=e.NetworkDebugAdapter=e.StreamDebugAdapter=void 0,s=We(s),h=We(h),D=We(D),A=We(A),L=We(L),R=We(R),l=We(l);class _ extends C.AbstractDebugAdapter{static{this.TWO_CRLF=`\r
\r
`}static{this.HEADER_LINESEPARATOR=/\r?\n/}static{this.HEADER_FIELDSEPARATOR=/: */}constructor(){super(),this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1}connect(p,u){this.outputStream=u,this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1,p.on("data",i=>this.handleData(i))}sendMessage(p){if(this.outputStream){const u=JSON.stringify(p);this.outputStream.write(`Content-Length: ${Buffer.byteLength(u,"utf8")}${_.TWO_CRLF}${u}`,"utf8")}}handleData(p){for(this.rawData=Buffer.concat([this.rawData,p]);;){if(this.contentLength>=0){if(this.rawData.length>=this.contentLength){const u=this.rawData.toString("utf8",0,this.contentLength);if(this.rawData=this.rawData.slice(this.contentLength),this.contentLength=-1,u.length>0)try{this.acceptMessage(JSON.parse(u))}catch(i){this._onError.fire(new Error((i.message||i)+`
`+u))}continue}}else{const u=this.rawData.indexOf(_.TWO_CRLF);if(u!==-1){const a=this.rawData.toString("utf8",0,u).split(_.HEADER_LINESEPARATOR);for(const t of a){const n=t.split(_.HEADER_FIELDSEPARATOR);n[0]==="Content-Length"&&(this.contentLength=Number(n[1]))}this.rawData=this.rawData.slice(u+_.TWO_CRLF.length);continue}}break}}}e.StreamDebugAdapter=_;class f extends _{startSession(){return new Promise((p,u)=>{let i=!1;this.socket=this.createConnection(()=>{this.connect(this.socket,this.socket),p(),i=!0}),this.socket.on("close",()=>{i?this._onError.fire(new Error("connection closed")):u(new Error("connection closed"))}),this.socket.on("error",a=>{i?this._onError.fire(a):u(a)})})}async stopSession(){await this.cancelPendingRequests(),this.socket&&(this.socket.end(),this.socket=void 0)}}e.NetworkDebugAdapter=f;class T extends f{constructor(p){super(),this.adapterServer=p}createConnection(p){return h.createConnection(this.adapterServer.port,this.adapterServer.host||"127.0.0.1",p)}}e.SocketDebugAdapter=T;class S extends f{constructor(p){super(),this.adapterServer=p}createConnection(p){return h.createConnection(this.adapterServer.path,p)}}e.NamedPipeDebugAdapter=S;class o extends _{constructor(p,u){super(),this.adapterExecutable=p,this.debugType=u}async startSession(){const p=this.adapterExecutable.command,u=this.adapterExecutable.args,i=this.adapterExecutable.options||{};try{if(p)if(A.isAbsolute(p)){if(!await v.Promises.exists(p))throw new Error(l.localize(5870,null,p))}else p.indexOf("/")<0&&p.indexOf("\\")<0;else throw new Error(l.localize(5871,null,this.debugType));let a=process.env;if(i.env&&Object.keys(i.env).length>0&&(a=D.mixin(D.deepClone(process.env),i.env)),p==="node")if(Array.isArray(u)&&u.length>0){const t=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,n={env:a,execArgv:t?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};i.cwd&&(n.cwd=i.cwd);const r=s.fork(u[0],u.slice(1),n);if(!r.pid)throw new Error(l.localize(5872,null,u[0]));this.serverProcess=r}else throw new Error(l.localize(5873,null));else{let t=p,n=u;const r={env:a};i.cwd&&(r.cwd=i.cwd),L.isWindows&&(p.endsWith(".bat")||p.endsWith(".cmd"))&&(r.shell=!0,t=`"${p}"`,n=u.map(d=>(d=d.replace(/"/g,'\\"'),`"${d}"`))),this.serverProcess=s.spawn(t,n,r)}this.serverProcess.on("error",t=>{this._onError.fire(t)}),this.serverProcess.on("exit",(t,n)=>{this._onExit.fire(t)}),this.serverProcess.stdout.on("close",()=>{this._onError.fire(new Error("read error"))}),this.serverProcess.stdout.on("error",t=>{this._onError.fire(t)}),this.serverProcess.stdin.on("error",t=>{this._onError.fire(t)}),this.serverProcess.stderr.resume(),this.connect(this.serverProcess.stdout,this.serverProcess.stdin)}catch(a){this._onError.fire(a)}}async stopSession(){return this.serverProcess?(await this.cancelPendingRequests(),L.isWindows?new Promise((p,u)=>{const i=s.exec(`taskkill /F /T /PID ${this.serverProcess.pid}`,function(a,t,n){if(a)return u(a)});i.on("exit",p),i.on("error",u)}):(this.serverProcess.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static extract(p,u){if(!p)return;const i=Object.create(null);p.runtime&&(p.runtime.indexOf("./")===0?i.runtime=A.join(u,p.runtime):i.runtime=p.runtime),p.runtimeArgs&&(i.runtimeArgs=p.runtimeArgs),p.program&&(A.isAbsolute(p.program)?i.program=p.program:i.program=A.join(u,p.program)),p.args&&(i.args=p.args);const a=p;return a.win&&(i.win=o.extract(a.win,u)),a.winx86&&(i.winx86=o.extract(a.winx86,u)),a.windows&&(i.windows=o.extract(a.windows,u)),a.osx&&(i.osx=o.extract(a.osx,u)),a.linux&&(i.linux=o.extract(a.linux,u)),i}static platformAdapterExecutable(p,u){let i=Object.create(null);u=u.toLowerCase();for(const c of p)if(c.contributes){const g=c.contributes.debuggers;g&&g.length>0&&g.filter(w=>typeof w.type=="string"&&R.equalsIgnoreCase(w.type,u)).forEach(w=>{const y=o.extract(w,c.extensionLocation.fsPath);i=D.mixin(i,y,c.isBuiltin)})}let a;L.isWindows&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?a=i.winx86||i.win||i.windows:L.isWindows?a=i.win||i.windows:L.isMacintosh?a=i.osx:L.isLinux&&(a=i.linux),a=a||i;const t=a.program||i.program,n=a.args||i.args,r=a.runtime||i.runtime,d=a.runtimeArgs||i.runtimeArgs;if(r)return{type:"executable",command:r,args:(d||[]).concat(typeof t=="string"?[t]:[]).concat(n||[])};if(t)return{type:"executable",command:t,args:n||[]}}}e.ExecutableDebugAdapter=o}),define(Pe[262],ke([1,0,58,33,10]),function(ge,e,s,h,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasChildProcesses=L,e.prepareCommand=v,s=We(s),D=We(D);function A(l,C){return new Promise((_,f)=>{let T="";const S=s.spawn(l,C);S.pid&&S.stdout.on("data",o=>{T+=o.toString()}),S.on("error",o=>{f(o)}),S.on("close",o=>{_(T)})})}async function L(l){if(l)if(D.isWindows){const C=await new Promise((_,f)=>{ge(["@vscode/windows-process-tree"],_,f)}).then(We);return new Promise(_=>{C.getProcessTree(l,f=>{_(!!f&&f.children.length>0)})})}else return A("/usr/bin/pgrep",["-lP",String(l)]).then(C=>{const _=C.trim();return!(_.length===0||_.indexOf(" tmux")>=0)},C=>!0);return Promise.resolve(!0)}var R;(function(l){l[l.cmd=0]="cmd",l[l.powershell=1]="powershell",l[l.bash=2]="bash"})(R||(R={}));function v(l,C,_,f,T){l=l.trim().toLowerCase();let S;l.indexOf("powershell")>=0||l.indexOf("pwsh")>=0?S=R.powershell:l.indexOf("cmd.exe")>=0?S=R.cmd:l.indexOf("bash")>=0?S=R.bash:D.isWindows?S=R.cmd:S=R.bash;let o,m=" ";switch(S){case R.powershell:if(o=p=>(p=p.replace(/\'/g,"''"),p.length>0&&p.charAt(p.length-1)==="\\"?`'${p}\\'`:`'${p}'`),f){const p=(0,h.getDriveLetter)(f);p&&(m+=`${p}:; `),m+=`cd ${o(f)}; `}if(T)for(const p in T){const u=T[p];u===null?m+=`Remove-Item env:${p}; `:m+=`\${env:${p}}='${u}'; `}if(C.length>0){const p=C.shift(),u=_?p:o(p);m+=u[0]==="'"?`& ${u} `:`${u} `;for(const i of C)m+=i==="<"||i===">"||_?i:o(i),m+=" "}break;case R.cmd:if(o=p=>(p=p.replace(/\"/g,'""'),p=p.replace(/([><!^&|])/g,"^$1"),' "'.split("").some(u=>p.includes(u))||p.length===0?`"${p}"`:p),f){const p=(0,h.getDriveLetter)(f);p&&(m+=`${p}: && `),m+=`cd ${o(f)} && `}if(T){m+='cmd /C "';for(const p in T){let u=T[p];u===null?m+=`set "${p}=" && `:(u=u.replace(/[&^|<>]/g,i=>`^${i}`),m+=`set "${p}=${u}" && `)}}for(const p of C)m+=p==="<"||p===">"||_?p:o(p),m+=" ";T&&(m+='"');break;case R.bash:{o=u=>(u=u.replace(/(["'\\\$!><#()\[\]*&^| ;{}?`])/g,"\\$1"),u.length===0?'""':u);const p=u=>/[^\w@%\/+=,.:^-]/.test(u)?`'${u.replace(/'/g,"'\\''")}'`:u;if(f&&(m+=`cd ${o(f)} ; `),T){m+="/usr/bin/env";for(const u in T){const i=T[u];i===null?m+=` -u ${p(u)}`:m+=` ${p(`${u}=${i}`)}`}m+=" "}for(const u of C)m+=u==="<"||u===">"||_?u:o(u),m+=" ";break}}return m}}),define(Pe[263],ke([1,0,5]),function(ge,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var h;(function(D){D[D.Output=1]="Output",D[D.OutputItems=2]="OutputItems",D[D.ExecutionState=3]="ExecutionState"})(h||(e.CellExecutionUpdateType=h={})),e.INotebookExecutionService=(0,s.createDecorator)("INotebookExecutionService")}),define(Pe[264],ke([1,0,5]),function(ge,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookKernelHistoryService=e.INotebookKernelService=e.ProxyKernelState=e.variablePageSize=void 0,e.variablePageSize=100;var h;(function(D){D[D.Disconnected=1]="Disconnected",D[D.Connected=2]="Connected",D[D.Initializing=3]="Initializing"})(h||(e.ProxyKernelState=h={})),e.INotebookKernelService=(0,s.createDecorator)("INotebookKernelService"),e.INotebookKernelHistoryService=(0,s.createDecorator)("INotebookKernelHistoryService")}),define(Pe[265],ke([1,0,3,30,56,215,106]),function(ge,e,s,h,D,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CellSearchModel=void 0;class R extends s.Disposable{constructor(l,C,_){super(),this._source=l,this._inputTextBuffer=C,this._outputs=_,this._outputTextBuffers=void 0}_getFullModelRange(l){const C=l.getLineCount();return new h.Range(1,1,C,this._getLineMaxColumn(l,C))}_getLineMaxColumn(l,C){if(C<1||C>l.getLineCount())throw new Error("Illegal value for lineNumber");return l.getLineLength(C)+1}get inputTextBuffer(){if(!this._inputTextBuffer){const l=new A.PieceTreeTextBufferBuilder;l.acceptChunk(this._source);const C=l.finish(!0),{textBuffer:_,disposable:f}=C.create(D.DefaultEndOfLine.LF);this._inputTextBuffer=_,this._register(f)}return this._inputTextBuffer}get outputTextBuffers(){return this._outputTextBuffers||(this._outputTextBuffers=this._outputs.map(l=>{const C=new A.PieceTreeTextBufferBuilder;C.acceptChunk(l);const _=C.finish(!0),{textBuffer:f,disposable:T}=_.create(D.DefaultEndOfLine.LF);return this._register(T),f})),this._outputTextBuffers}findInInputs(l){const _=new L.SearchParams(l,!1,!1,null).parseSearchRequest();if(!_)return[];const f=this._getFullModelRange(this.inputTextBuffer);return this.inputTextBuffer.findMatchesLineByLine(f,_,!0,5e3)}findInOutputs(l){const _=new L.SearchParams(l,!1,!1,null).parseSearchRequest();return _?this.outputTextBuffers.map(f=>{const T=f.findMatchesLineByLine(this._getFullModelRange(f),_,!0,5e3);if(T.length!==0)return{textBuffer:f,matches:T}}).filter(f=>!!f):[]}}e.CellSearchModel=R}),define(Pe[75],ke([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var s;(function(A){A.Delimiter="\0"})(s||(e.TestIdPathParts=s={}));var h;(function(A){A[A.IsSame=0]="IsSame",A[A.Disconnected=1]="Disconnected",A[A.IsChild=2]="IsChild",A[A.IsParent=3]="IsParent"})(h||(e.TestPosition=h={}));class D{static fromExtHostTestItem(L,R,v=L.parent){if(L._isRoot)return new D([R]);const l=[L.id];for(let C=v;C&&C.id!==R;C=C.parent)l.push(C.id);return l.push(R),new D(l.reverse())}static isRoot(L){return!L.includes(s.Delimiter)}static root(L){const R=L.indexOf(s.Delimiter);return R===-1?L:L.slice(0,R)}static fromString(L){return new D(L.split(s.Delimiter))}static join(L,R){return new D([...L.path,R])}static joinToString(L,R){return L.toString()+s.Delimiter+R}static parentId(L){const R=L.lastIndexOf(s.Delimiter);return R===-1?void 0:L.slice(0,R)}static localId(L){const R=L.lastIndexOf(s.Delimiter);return R===-1?L:L.slice(R+s.Delimiter.length)}static isChild(L,R){return R[L.length]===s.Delimiter&&R.startsWith(L)}static compare(L,R){return L===R?h.IsSame:D.isChild(L,R)?h.IsChild:D.isChild(R,L)?h.IsParent:h.Disconnected}static getLengthOfCommonPrefix(L,R){if(L===0)return 0;let v=0;for(;v<L-1;){for(let l=1;l<L;l++){const C=R(l-1),_=R(l);if(C.path[v]!==_.path[v])return v}v++}return v}constructor(L,R=L.length){if(this.path=L,this.viewEnd=R,L.length===0||R<1)throw new Error("cannot create test with empty path")}get rootId(){return new D(this.path,1)}get parentId(){return this.viewEnd>1?new D(this.path,this.viewEnd-1):void 0}get localId(){return this.path[this.viewEnd-1]}get controllerId(){return this.path[0]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){for(let L=1;L<=this.viewEnd;L++)yield new D(this.path,L)}*idsToRoot(){for(let L=this.viewEnd;L>0;L--)yield new D(this.path,L)}compare(L){if(typeof L=="string")return D.compare(this.toString(),L);for(let R=0;R<L.viewEnd&&R<this.viewEnd;R++)if(L.path[R]!==this.path[R])return h.Disconnected;return L.viewEnd>this.viewEnd?h.IsChild:L.viewEnd<this.viewEnd?h.IsParent:h.IsSame}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let L=1;L<this.viewEnd;L++)this.stringifed+=s.Delimiter,this.stringifed+=this.path[L]}return this.stringifed}}e.TestId=D}),define(Pe[76],ke([1,0,2,55,30,75]),function(ge,e,s,h,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.TestsDiffOp=e.TestDiffOpType=e.IStatementCoverage=e.IDeclarationCoverage=e.IBranchCoverage=e.CoverageDetails=e.DetailType=e.KEEP_N_LAST_COVERAGE_REPORTS=e.IFileCoverage=e.ICoverageCount=e.TestResultItem=e.applyTestItemUpdate=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.denamespaceTestTag=e.namespaceTestTag=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.getMarkId=e.ITestErrorMessage=e.ITestMessageStackFrame=e.TestMessageType=e.IRichLocation=e.isStartControllerTests=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestControllerCapability=e.ExtTestRunProfileKind=e.testResultStateToContextValues=e.TestResultState=void 0;var L;(function(x){x[x.Unset=0]="Unset",x[x.Queued=1]="Queued",x[x.Running=2]="Running",x[x.Passed=3]="Passed",x[x.Failed=4]="Failed",x[x.Skipped=5]="Skipped",x[x.Errored=6]="Errored"})(L||(e.TestResultState=L={})),e.testResultStateToContextValues={[L.Unset]:"unset",[L.Queued]:"queued",[L.Running]:"running",[L.Passed]:"passed",[L.Failed]:"failed",[L.Skipped]:"skipped",[L.Errored]:"errored"};var R;(function(x){x[x.Run=1]="Run",x[x.Debug=2]="Debug",x[x.Coverage=3]="Coverage"})(R||(e.ExtTestRunProfileKind=R={}));var v;(function(x){x[x.Refresh=2]="Refresh",x[x.CodeRelatedToTest=4]="CodeRelatedToTest",x[x.TestRelatedToCode=8]="TestRelatedToCode"})(v||(e.TestControllerCapability=v={}));var l;(function(x){x[x.Run=2]="Run",x[x.Debug=4]="Debug",x[x.Coverage=8]="Coverage",x[x.HasNonDefaultProfile=16]="HasNonDefaultProfile",x[x.HasConfigurable=32]="HasConfigurable",x[x.SupportsContinuousRun=64]="SupportsContinuousRun"})(l||(e.TestRunProfileBitset=l={})),e.testRunProfileBitsetList=[l.Run,l.Debug,l.Coverage,l.HasNonDefaultProfile,l.HasConfigurable,l.SupportsContinuousRun];const C=x=>"runId"in x;e.isStartControllerTests=C;var _;(function(x){x.serialize=$=>({range:$.range.toJSON(),uri:$.uri.toJSON()}),x.deserialize=($,G)=>({range:D.Range.lift(G.range),uri:$.asCanonicalUri(s.URI.revive(G.uri))})})(_||(e.IRichLocation=_={}));var f;(function(x){x[x.Error=0]="Error",x[x.Output=1]="Output"})(f||(e.TestMessageType=f={}));var T;(function(x){x.serialize=$=>({label:$.label,uri:$.uri?.toJSON(),position:$.position?.toJSON()}),x.deserialize=($,G)=>({label:G.label,uri:G.uri?$.asCanonicalUri(s.URI.revive(G.uri)):void 0,position:G.position?h.Position.lift(G.position):void 0})})(T||(e.ITestMessageStackFrame=T={}));var S;(function(x){x.serialize=$=>({message:$.message,type:f.Error,expected:$.expected,actual:$.actual,contextValue:$.contextValue,location:$.location&&_.serialize($.location),stackTrace:$.stackTrace?.map(T.serialize)}),x.deserialize=($,G)=>({message:G.message,type:f.Error,expected:G.expected,actual:G.actual,contextValue:G.contextValue,location:G.location&&_.deserialize($,G.location),stackTrace:G.stackTrace&&G.stackTrace.map(B=>T.deserialize($,B))})})(S||(e.ITestErrorMessage=S={}));const o=(x,$)=>`${$?"s":"e"}${x}`;e.getMarkId=o;var m;(function(x){x.serialize=$=>({message:$.message,type:f.Output,offset:$.offset,length:$.length,location:$.location&&_.serialize($.location)}),x.deserialize=($,G)=>({message:G.message,type:f.Output,offset:G.offset,length:G.length,location:G.location&&_.deserialize($,G.location)})})(m||(e.ITestOutputMessage=m={}));var p;(function(x){x.serialize=$=>$.type===f.Error?S.serialize($):m.serialize($),x.deserialize=($,G)=>G.type===f.Error?S.deserialize($,G):m.deserialize($,G),x.isDiffable=$=>$.type===f.Error&&$.actual!==void 0&&$.expected!==void 0})(p||(e.ITestMessage=p={}));var u;(function(x){x.serializeWithoutMessages=$=>({state:$.state,duration:$.duration,messages:[]}),x.serialize=$=>({state:$.state,duration:$.duration,messages:$.messages.map(p.serialize)}),x.deserialize=($,G)=>({state:G.state,duration:G.duration,messages:G.messages.map(B=>p.deserialize($,B))})})(u||(e.ITestTaskState=u={}));const i="\0",a=(x,$)=>x+i+$;e.namespaceTestTag=a;const t=x=>{const $=x.indexOf(i);return{ctrlId:x.slice(0,$),tagId:x.slice($+1)}};e.denamespaceTestTag=t;var n;(function(x){x.serialize=$=>({extId:$.extId,label:$.label,tags:$.tags,busy:$.busy,children:void 0,uri:$.uri?.toJSON(),range:$.range?.toJSON()||null,description:$.description,error:$.error,sortText:$.sortText}),x.deserialize=($,G)=>({extId:G.extId,label:G.label,tags:G.tags,busy:G.busy,children:void 0,uri:G.uri?$.asCanonicalUri(s.URI.revive(G.uri)):void 0,range:G.range?D.Range.lift(G.range):null,description:G.description,error:G.error,sortText:G.sortText})})(n||(e.ITestItem=n={}));var r;(function(x){x[x.NotExpandable=0]="NotExpandable",x[x.Expandable=1]="Expandable",x[x.BusyExpanding=2]="BusyExpanding",x[x.Expanded=3]="Expanded"})(r||(e.TestItemExpandState=r={}));var d;(function(x){x.serialize=$=>({expand:$.expand,item:n.serialize($.item)}),x.deserialize=($,G)=>({controllerId:A.TestId.root(G.item.extId),expand:G.expand,item:n.deserialize($,G.item)})})(d||(e.InternalTestItem=d={}));var c;(function(x){x.serialize=$=>{let G;return $.item&&(G={},$.item.label!==void 0&&(G.label=$.item.label),$.item.tags!==void 0&&(G.tags=$.item.tags),$.item.busy!==void 0&&(G.busy=$.item.busy),$.item.uri!==void 0&&(G.uri=$.item.uri?.toJSON()),$.item.range!==void 0&&(G.range=$.item.range?.toJSON()),$.item.description!==void 0&&(G.description=$.item.description),$.item.error!==void 0&&(G.error=$.item.error),$.item.sortText!==void 0&&(G.sortText=$.item.sortText)),{extId:$.extId,expand:$.expand,item:G}},x.deserialize=$=>{let G;return $.item&&(G={},$.item.label!==void 0&&(G.label=$.item.label),$.item.tags!==void 0&&(G.tags=$.item.tags),$.item.busy!==void 0&&(G.busy=$.item.busy),$.item.range!==void 0&&(G.range=$.item.range?D.Range.lift($.item.range):null),$.item.description!==void 0&&(G.description=$.item.description),$.item.error!==void 0&&(G.error=$.item.error),$.item.sortText!==void 0&&(G.sortText=$.item.sortText)),{extId:$.extId,expand:$.expand,item:G}}})(c||(e.ITestItemUpdate=c={}));const g=(x,$)=>{$.expand!==void 0&&(x.expand=$.expand),$.item!==void 0&&(x.item=x.item?Object.assign(x.item,$.item):$.item)};e.applyTestItemUpdate=g;var w;(function(x){x.serializeWithoutMessages=$=>({...d.serialize($),ownComputedState:$.ownComputedState,computedState:$.computedState,tasks:$.tasks.map(u.serializeWithoutMessages)}),x.serialize=$=>({...d.serialize($),ownComputedState:$.ownComputedState,computedState:$.computedState,tasks:$.tasks.map(u.serialize)}),x.deserialize=($,G)=>({...d.deserialize($,G),ownComputedState:G.ownComputedState,computedState:G.computedState,tasks:G.tasks.map(B=>u.deserialize($,B)),retired:!0})})(w||(e.TestResultItem=w={}));var y;(function(x){x.empty=()=>({covered:0,total:0}),x.sum=($,G)=>{$.covered+=G.covered,$.total+=G.total}})(y||(e.ICoverageCount=y={}));var I;(function(x){x.serialize=$=>({id:$.id,statement:$.statement,branch:$.branch,declaration:$.declaration,testIds:$.testIds,uri:$.uri.toJSON()}),x.deserialize=($,G)=>({id:G.id,statement:G.statement,branch:G.branch,declaration:G.declaration,testIds:G.testIds,uri:$.asCanonicalUri(s.URI.revive(G.uri))}),x.empty=($,G)=>({id:$,uri:G,statement:y.empty()})})(I||(e.IFileCoverage=I={}));function P(x){return{...x,location:x.location?.toJSON()}}function k(x){return x.location=x.location?h.Position.isIPosition(x.location)?h.Position.lift(x.location):D.Range.lift(x.location):void 0,x}e.KEEP_N_LAST_COVERAGE_REPORTS=3;var b;(function(x){x[x.Declaration=0]="Declaration",x[x.Statement=1]="Statement",x[x.Branch=2]="Branch"})(b||(e.DetailType=b={}));var E;(function(x){x.serialize=$=>$.type===b.Declaration?O.serialize($):M.serialize($),x.deserialize=$=>$.type===b.Declaration?O.deserialize($):M.deserialize($)})(E||(e.CoverageDetails=E={}));var N;(function(x){x.serialize=P,x.deserialize=k})(N||(e.IBranchCoverage=N={}));var O;(function(x){x.serialize=P,x.deserialize=k})(O||(e.IDeclarationCoverage=O={}));var M;(function(x){x.serialize=$=>({...P($),branches:$.branches?.map(N.serialize)}),x.deserialize=$=>({...k($),branches:$.branches?.map(N.deserialize)})})(M||(e.IStatementCoverage=M={}));var U;(function(x){x[x.Add=0]="Add",x[x.Update=1]="Update",x[x.DocumentSynced=2]="DocumentSynced",x[x.Remove=3]="Remove",x[x.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",x[x.Retire=5]="Retire",x[x.AddTag=6]="AddTag",x[x.RemoveTag=7]="RemoveTag"})(U||(e.TestDiffOpType=U={}));var H;(function(x){x.deserialize=($,G)=>G.op===U.Add?{op:G.op,item:d.deserialize($,G.item)}:G.op===U.Update?{op:G.op,item:c.deserialize(G.item)}:G.op===U.DocumentSynced?{op:G.op,uri:$.asCanonicalUri(s.URI.revive(G.uri)),docv:G.docv}:G,x.serialize=$=>$.op===U.Add?{op:$.op,item:d.serialize($.item)}:$.op===U.Update?{op:$.op,item:c.serialize($.item)}:$})(H||(e.TestsDiffOp=H={}));class F{constructor($){this.uriIdentity=$,this._tags=new Map,this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0,this.tags=this._tags}apply($){const G=this.createChangeCollector();for(const B of $)switch(B.op){case U.Add:this.add(d.deserialize(this.uriIdentity,B.item),G);break;case U.Update:this.update(c.deserialize(B.item),G);break;case U.Remove:this.remove(B.itemId,G);break;case U.Retire:this.retireTest(B.itemId);break;case U.IncrementPendingExtHosts:this.updatePendingRoots(B.amount);break;case U.AddTag:this._tags.set(B.tag.id,B.tag);break;case U.RemoveTag:this._tags.delete(B.id);break}G.complete?.()}add($,G){const B=A.TestId.parentId($.item.extId)?.toString();let W;if(!B)W=this.createItem($),this.roots.add(W),this.items.set($.item.extId,W);else if(this.items.has(B)){const Z=this.items.get(B);Z.children.add($.item.extId),W=this.createItem($,Z),this.items.set($.item.extId,W)}else{console.error(`Test with unknown parent ID: ${JSON.stringify($)}`);return}return G.add?.(W),$.expand===r.BusyExpanding&&this.busyControllerCount++,W}update($,G){const B=this.items.get($.extId);if(B)return $.expand!==void 0&&(B.expand===r.BusyExpanding&&this.busyControllerCount--,$.expand===r.BusyExpanding&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(B,$),G.update?.(B),B}remove($,G){const B=this.items.get($);if(!B)return;const W=A.TestId.parentId(B.item.extId)?.toString();W?this.items.get(W).children.delete(B.item.extId):this.roots.delete(B);const Z=[[$]];for(;Z.length;)for(const J of Z.pop()){const oe=this.items.get(J);oe&&(Z.push(oe.children),this.items.delete(J),G.remove?.(oe,oe!==B),oe.expand===r.BusyExpanding&&this.busyControllerCount--)}}retireTest($){}updatePendingRoots($){this.pendingRootCount+=$}createChangeCollector(){return{}}}e.AbstractIncrementalTestCollection=F}),define(Pe[266],ke([1,0,137,7,76]),function(ge,e,s,h,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestCommandId=e.testConfigurationGroupNames=e.labelForTestInState=e.TestExplorerViewSorting=e.TestExplorerViewMode=e.Testing=void 0;var A;(function(_){_.ViewletId="workbench.view.extension.test",_.ExplorerViewId="workbench.view.testing",_.OutputPeekContributionId="editor.contrib.testingOutputPeek",_.DecorationsContributionId="editor.contrib.testingDecorations",_.CoverageDecorationsContributionId="editor.contrib.coverageDecorations",_.CoverageViewId="workbench.view.testCoverage",_.ResultsPanelId="workbench.panel.testResults",_.ResultsViewId="workbench.panel.testResults.view",_.MessageLanguageId="vscodeInternalTestMessage"})(A||(e.Testing=A={}));var L;(function(_){_.List="list",_.Tree="true"})(L||(e.TestExplorerViewMode=L={}));var R;(function(_){_.ByLocation="location",_.ByStatus="status",_.ByDuration="duration"})(R||(e.TestExplorerViewSorting=R={}));const v={[D.TestResultState.Errored]:(0,h.localize)(10839,null),[D.TestResultState.Failed]:(0,h.localize)(10840,null),[D.TestResultState.Passed]:(0,h.localize)(10841,null),[D.TestResultState.Queued]:(0,h.localize)(10842,null),[D.TestResultState.Running]:(0,h.localize)(10843,null),[D.TestResultState.Skipped]:(0,h.localize)(10844,null),[D.TestResultState.Unset]:(0,h.localize)(10845,null)},l=(_,f)=>(0,h.localize)(10846,null,(0,s.stripIcons)(_),v[f]);e.labelForTestInState=l,e.testConfigurationGroupNames={[D.TestRunProfileBitset.Debug]:(0,h.localize)(10847,null),[D.TestRunProfileBitset.Run]:(0,h.localize)(10848,null),[D.TestRunProfileBitset.Coverage]:(0,h.localize)(10849,null)};var C;(function(_){_.CancelTestRefreshAction="testing.cancelTestRefresh",_.CancelTestRunAction="testing.cancelRun",_.ClearTestResultsAction="testing.clearTestResults",_.CollapseAllAction="testing.collapseAll",_.ConfigureTestProfilesAction="testing.configureProfile",_.ContinousRunUsingForTest="testing.continuousRunUsingForTest",_.CoverageAtCursor="testing.coverageAtCursor",_.CoverageByUri="testing.coverage.uri",_.CoverageClear="testing.coverage.close",_.CoverageCurrentFile="testing.coverageCurrentFile",_.CoverageFilterToTest="testing.coverageFilterToTest",_.CoverageFilterToTestInEditor="testing.coverageFilterToTestInEditor",_.CoverageLastRun="testing.coverageLastRun",_.CoverageSelectedAction="testing.coverageSelected",_.CoverageToggleToolbar="testing.coverageToggleToolbar",_.CoverageViewChangeSorting="testing.coverageViewChangeSorting",_.DebugAction="testing.debug",_.DebugAllAction="testing.debugAll",_.DebugAtCursor="testing.debugAtCursor",_.DebugByUri="testing.debug.uri",_.DebugCurrentFile="testing.debugCurrentFile",_.DebugFailedTests="testing.debugFailTests",_.DebugLastRun="testing.debugLastRun",_.DebugSelectedAction="testing.debugSelected",_.FilterAction="workbench.actions.treeView.testExplorer.filter",_.GetExplorerSelection="_testing.getExplorerSelection",_.GetSelectedProfiles="testing.getSelectedProfiles",_.GoToTest="testing.editFocusedTest",_.GoToRelatedTest="testing.goToRelatedTest",_.PeekRelatedTest="testing.peekRelatedTest",_.GoToRelatedCode="testing.goToRelatedCode",_.PeekRelatedCode="testing.peekRelatedCode",_.HideTestAction="testing.hideTest",_.OpenCoverage="testing.openCoverage",_.OpenOutputPeek="testing.openOutputPeek",_.RefreshTestsAction="testing.refreshTests",_.ReRunFailedTests="testing.reRunFailTests",_.ReRunLastRun="testing.reRunLastRun",_.RunAction="testing.run",_.RunAllAction="testing.runAll",_.RunAllWithCoverageAction="testing.coverageAll",_.RunAtCursor="testing.runAtCursor",_.RunByUri="testing.run.uri",_.RunCurrentFile="testing.runCurrentFile",_.RunSelectedAction="testing.runSelected",_.RunUsingProfileAction="testing.runUsing",_.RunWithCoverageAction="testing.coverage",_.SearchForTestExtension="testing.searchForTestExtension",_.SelectDefaultTestProfiles="testing.selectDefaultTestProfiles",_.ShowMostRecentOutputAction="testing.showMostRecentOutput",_.StartContinousRun="testing.startContinuousRun",_.StopContinousRun="testing.stopContinuousRun",_.TestingSortByDurationAction="testing.sortByDuration",_.TestingSortByLocationAction="testing.sortByLocation",_.TestingSortByStatusAction="testing.sortByStatus",_.TestingViewAsListAction="testing.viewAsList",_.TestingViewAsTreeAction="testing.viewAsTree",_.ToggleContinousRunForTest="testing.toggleContinuousRunForTest",_.ToggleInlineTestOutput="testing.toggleInlineTestOutput",_.UnhideAllTestsAction="testing.unhideAllTests",_.UnhideTestAction="testing.unhideTest"})(C||(e.TestCommandId=C={}))}),define(Pe[120],ke([1,0,8,4,3,67,76,75]),function(ge,e,s,h,D,A,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createTestItemChildren=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.TestItemCollection=e.TestItemEventOp=void 0;var v;(function(u){u[u.Upsert=0]="Upsert",u[u.SetTags=1]="SetTags",u[u.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",u[u.RemoveChild=3]="RemoveChild",u[u.SetProp=4]="SetProp",u[u.Bulk=5]="Bulk",u[u.DocumentSynced=6]="DocumentSynced"})(v||(e.TestItemEventOp=v={}));const l=(u,i)=>u===i,_=Object.entries({range:(u,i)=>u===i?!0:!u||!i?!1:u.equalsRange(i),busy:l,label:l,description:l,error:l,sortText:l,tags:(u,i)=>!(u.length!==i.length||u.some(a=>!i.includes(a)))}),f=(u,i)=>{let a;for(const[t,n]of _)n(u[t],i[t])||(a?a[t]=i[t]:a={[t]:i[t]});return a};class T extends D.Disposable{get root(){return this.options.root}constructor(i){super(),this.options=i,this.debounceSendDiff=this._register(new s.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new h.Emitter),this.tree=new Map,this.tags=new Map,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.root.canResolveChildren=!0,this.upsertItem(this.root,void 0)}set resolveHandler(i){this._resolveHandler=i;for(const a of this.tree.values())this.updateExpandability(a)}get resolveHandler(){return this._resolveHandler}collectDiff(){const i=this.diff;return this.diff=[],i}pushDiff(i){switch(i.op){case L.TestDiffOpType.DocumentSynced:{for(const a of this.diff)if(a.op===L.TestDiffOpType.DocumentSynced&&a.uri===i.uri){a.docv=i.docv;return}break}case L.TestDiffOpType.Update:{const a=this.diff[this.diff.length-1];if(a){if(a.op===L.TestDiffOpType.Update&&a.item.extId===i.item.extId){(0,L.applyTestItemUpdate)(a.item,i.item);return}if(a.op===L.TestDiffOpType.Add&&a.item.item.extId===i.item.extId){(0,L.applyTestItemUpdate)(a.item,i.item);return}}break}}this.diff.push(i),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(i,a){const t=this.tree.get(i);if(t){if((t.expandLevels===void 0||a>t.expandLevels)&&(t.expandLevels=a),t.expand===L.TestItemExpandState.Expandable){const n=this.resolveChildren(t);return n.isOpen()?this.expandChildren(t,a-1):n.wait().then(()=>this.expandChildren(t,a-1))}else if(t.expand===L.TestItemExpandState.Expanded)return t.resolveBarrier?.isOpen()===!1?t.resolveBarrier.wait().then(()=>this.expandChildren(t,a-1)):this.expandChildren(t,a-1)}}dispose(){for(const i of this.tree.values())this.options.getApiFor(i.actual).listener=void 0;this.tree.clear(),this.diff=[],super.dispose()}onTestItemEvent(i,a){switch(a.op){case v.RemoveChild:this.removeItem(R.TestId.joinToString(i.fullId,a.id));break;case v.Upsert:this.upsertItem(a.item,i);break;case v.Bulk:for(const t of a.ops)this.onTestItemEvent(i,t);break;case v.SetTags:this.diffTagRefs(a.new,a.old,i.fullId.toString());break;case v.UpdateCanResolveChildren:this.updateExpandability(i);break;case v.SetProp:this.pushDiff({op:L.TestDiffOpType.Update,item:{extId:i.fullId.toString(),item:a.update}});break;case v.DocumentSynced:this.documentSynced(i.actual.uri);break;default:(0,A.assertNever)(a)}}documentSynced(i){i&&this.pushDiff({op:L.TestDiffOpType.DocumentSynced,uri:i,docv:this.options.getDocumentVersion(i)})}upsertItem(i,a){const t=R.TestId.fromExtHostTestItem(i,this.root.id,a?.actual),n=this.options.getApiFor(i);n.parent&&n.parent!==a?.actual&&this.options.getChildren(n.parent).delete(i.id);let r=this.tree.get(t.toString());if(!r){r={fullId:t,actual:i,expandLevels:a?.expandLevels?a.expandLevels-1:void 0,expand:L.TestItemExpandState.NotExpandable},i.tags.forEach(this.incrementTagRefs,this),this.tree.set(r.fullId.toString(),r),this.setItemParent(i,a),this.pushDiff({op:L.TestDiffOpType.Add,item:{controllerId:this.options.controllerId,expand:r.expand,item:this.options.toITestItem(i)}}),this.connectItemAndChildren(i,r,a);return}if(r.actual===i){this.connectItem(i,r,a);return}if(r.actual.uri?.toString()!==i.uri?.toString())return this.removeItem(t.toString()),this.upsertItem(i,a);const d=this.options.getChildren(r.actual),c=r.actual,g=f(this.options.toITestItem(c),this.options.toITestItem(i));this.options.getApiFor(c).listener=void 0,r.actual=i,r.resolveBarrier=void 0,r.expand=L.TestItemExpandState.NotExpandable,g&&(g.hasOwnProperty("tags")&&(this.diffTagRefs(i.tags,c.tags,t.toString()),delete g.tags),this.onTestItemEvent(r,{op:v.SetProp,update:g})),this.connectItemAndChildren(i,r,a);for(const[y,I]of d)this.options.getChildren(i).get(I.id)||this.removeItem(R.TestId.joinToString(t,I.id));const w=r.expandLevels;w!==void 0&&queueMicrotask(()=>{r.expand===L.TestItemExpandState.Expandable&&(r.expandLevels=void 0,this.expand(t.toString(),w))}),this.documentSynced(r.actual.uri)}diffTagRefs(i,a,t){const n=new Set(a.map(r=>r.id));for(const r of i)n.delete(r.id)||this.incrementTagRefs(r);this.pushDiff({op:L.TestDiffOpType.Update,item:{extId:t,item:{tags:i.map(r=>(0,L.namespaceTestTag)(this.options.controllerId,r.id))}}}),n.forEach(this.decrementTagRefs,this)}incrementTagRefs(i){const a=this.tags.get(i.id);a?a.refCount++:(this.tags.set(i.id,{refCount:1}),this.pushDiff({op:L.TestDiffOpType.AddTag,tag:{id:(0,L.namespaceTestTag)(this.options.controllerId,i.id)}}))}decrementTagRefs(i){const a=this.tags.get(i);a&&!--a.refCount&&(this.tags.delete(i),this.pushDiff({op:L.TestDiffOpType.RemoveTag,id:(0,L.namespaceTestTag)(this.options.controllerId,i)}))}setItemParent(i,a){this.options.getApiFor(i).parent=a&&a.actual!==this.root?a.actual:void 0}connectItem(i,a,t){this.setItemParent(i,t);const n=this.options.getApiFor(i);n.parent=t?.actual,n.listener=r=>this.onTestItemEvent(a,r),this.updateExpandability(a)}connectItemAndChildren(i,a,t){this.connectItem(i,a,t);for(const[n,r]of this.options.getChildren(i))this.upsertItem(r,a)}updateExpandability(i){let a;this._resolveHandler?i.resolveBarrier?a=i.resolveBarrier.isOpen()?L.TestItemExpandState.Expanded:L.TestItemExpandState.BusyExpanding:a=i.actual.canResolveChildren?L.TestItemExpandState.Expandable:L.TestItemExpandState.NotExpandable:a=L.TestItemExpandState.NotExpandable,a!==i.expand&&(i.expand=a,this.pushDiff({op:L.TestDiffOpType.Update,item:{extId:i.fullId.toString(),expand:a}}),a===L.TestItemExpandState.Expandable&&i.expandLevels!==void 0&&this.resolveChildren(i))}expandChildren(i,a){if(a<0)return;const t=[];for(const[n,r]of this.options.getChildren(i.actual)){const d=this.expand(R.TestId.joinToString(i.fullId,r.id),a);(0,s.isThenable)(d)&&t.push(d)}if(t.length)return Promise.all(t).then(()=>{})}resolveChildren(i){if(i.resolveBarrier)return i.resolveBarrier;if(!this._resolveHandler){const r=new s.Barrier;return r.open(),r}i.expand=L.TestItemExpandState.BusyExpanding,this.pushExpandStateUpdate(i);const a=i.resolveBarrier=new s.Barrier,t=r=>{console.error(`Unhandled error in resolveHandler of test controller "${this.options.controllerId}"`,r)};let n;try{n=this._resolveHandler(i.actual===this.root?void 0:i.actual)}catch(r){t(r)}return(0,s.isThenable)(n)?n.catch(t).then(()=>{a.open(),this.updateExpandability(i)}):(a.open(),this.updateExpandability(i)),i.resolveBarrier}pushExpandStateUpdate(i){this.pushDiff({op:L.TestDiffOpType.Update,item:{extId:i.fullId.toString(),expand:i.expand}})}removeItem(i){const a=this.tree.get(i);if(!a)throw new Error("attempting to remove non-existent child");this.pushDiff({op:L.TestDiffOpType.Remove,itemId:i});const t=[a];for(;t.length;){const n=t.pop();if(n){this.options.getApiFor(n.actual).listener=void 0;for(const r of n.actual.tags)this.decrementTagRefs(r.id);this.tree.delete(n.fullId.toString());for(const[r,d]of this.options.getChildren(n.actual))t.push(this.tree.get(R.TestId.joinToString(n.fullId,d.id)))}}}flushDiff(){const i=this.collectDiff();i.length&&this.diffOpEmitter.fire(i)}}e.TestItemCollection=T;class S extends Error{constructor(i){super(`Attempted to insert a duplicate test item ID ${i}`)}}e.DuplicateTestItemError=S;class o extends Error{constructor(i){super(`TestItem with ID "${i}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=o;class m extends Error{constructor(i,a,t){super(`TestItem with ID "${i}" is from controller "${a}" and cannot be added as a child of an item from controller "${t}".`)}}e.MixedTestItemController=m;const p=(u,i,a)=>{let t=new Map;return{get size(){return t.size},forEach(n,r){for(const d of t.values())n.call(r,d,this)},[Symbol.iterator](){return t.entries()},replace(n){const r=new Map,d=new Set(t.keys()),c={op:v.Bulk,ops:[]};for(const g of n){if(!(g instanceof a))throw new o(g.id);const w=i(g).controllerId;if(w!==u.controllerId)throw new m(g.id,w,u.controllerId);if(r.has(g.id))throw new S(g.id);r.set(g.id,g),d.delete(g.id),c.ops.push({op:v.Upsert,item:g})}for(const g of d.keys())c.ops.push({op:v.RemoveChild,id:g});u.listener?.(c),t=r},add(n){if(!(n instanceof a))throw new o(n.id);t.set(n.id,n),u.listener?.({op:v.Upsert,item:n})},delete(n){t.delete(n)&&u.listener?.({op:v.RemoveChild,id:n})},get(n){return t.get(n)},toJSON(){return Array.from(t.values())}}};e.createTestItemChildren=p}),define(Pe[160],ke([1,0,120]),function(ge,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPrivateApiFor=e.createPrivateApiFor=void 0;const h=new WeakMap,D=(L,R)=>{const v={controllerId:R};return h.set(L,v),v};e.createPrivateApiFor=D;const A=L=>{const R=h.get(L);if(!R)throw new s.InvalidTestItemError(L?.id||"<unknown>");return R};e.getPrivateApiFor=A}),define(Pe[121],ke([1,0,26,14,2]),function(ge,e,s,h,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.asWebviewUri=A,e.decodeAuthority=R,e.webviewResourceBaseHost="vscode-cdn.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`'self' https://*.${e.webviewResourceBaseHost}`;function A(v,l){return v.scheme===h.Schemas.http||v.scheme===h.Schemas.https?v:(l&&l.authority&&l.isRemote&&v.scheme===h.Schemas.file&&(v=D.URI.from({scheme:h.Schemas.vscodeRemote,authority:l.authority,path:v.path})),D.URI.from({scheme:h.Schemas.https,authority:`${v.scheme}+${L(v.authority)}.${e.webviewRootResourceAuthority}`,path:v.path,fragment:v.fragment,query:v.query}))}function L(v){return v.replace(/./g,l=>{const C=l.charCodeAt(0);return C>=s.CharCode.a&&C<=s.CharCode.z||C>=s.CharCode.A&&C<=s.CharCode.Z||C>=s.CharCode.Digit0&&C<=s.CharCode.Digit9?l:"-"+C.toString(16).padStart(4,"0")})}function R(v){return v.replace(/-([0-9a-f]{4})/g,(l,C)=>String.fromCharCode(parseInt(C,16)))}}),define(Pe[267],ke([1,0,4,3,121]),function(ge,e,s,h,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class A{constructor(R,v,l){this._proxy=R,this._editors=v,this._remoteInfo=l,this._handlePool=0,this._disposables=new h.DisposableStore,this._insets=new Map,this._disposables.add(v.onDidChangeVisibleTextEditors(()=>{const C=v.getVisibleTextEditors();for(const _ of this._insets.values())C.indexOf(_.editor)<0&&_.inset.dispose()}))}dispose(){this._insets.forEach(R=>R.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(R,v,l,C,_){let f;for(const i of this._editors.getVisibleTextEditors(!0))if(i.value===R){f=i;break}if(!f)throw new Error("not a visible editor");const T=this,S=this._handlePool++,o=new s.Emitter,m=new s.Emitter,p=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(i){return(0,D.asWebviewUri)(i,T._remoteInfo)}get cspSource(){return D.webviewGenericCspSource}set options(i){this._options=i,T._proxy.$setOptions(S,i)}get options(){return this._options}set html(i){this._html=i,T._proxy.$setHtml(S,i)}get html(){return this._html}get onDidReceiveMessage(){return o.event}postMessage(i){return T._proxy.$postMessage(S,i)}},u=new class{constructor(){this.editor=R,this.line=v,this.height=l,this.webview=p,this.onDidDispose=m.event}dispose(){T._insets.has(S)&&(T._insets.delete(S),T._proxy.$disposeEditorInset(S),m.fire(),m.dispose(),o.dispose())}};return this._proxy.$createEditorInset(S,f.id,f.value.document.uri,v+1,l,C||{},_.identifier,_.extensionLocation),this._insets.set(S,{editor:R,inset:u,onDidReceiveMessage:o}),u}$onDidDispose(R){const v=this._insets.get(R);v&&v.inset.dispose()}$onDidReceiveMessage(R,v){this._insets.get(R)?.onDidReceiveMessage.fire(v)}}e.ExtHostEditorInsets=A}),define(Pe[161],ke([1,0,5]),function(ge,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IAuthenticationExtensionsService=e.IAuthenticationService=e.INTERNAL_AUTH_PROVIDER_PREFIX=void 0,e.INTERNAL_AUTH_PROVIDER_PREFIX="__",e.IAuthenticationService=(0,s.createDecorator)("IAuthenticationService"),e.IAuthenticationExtensionsService=(0,s.createDecorator)("IAuthenticationExtensionsService")}),define(Pe[268],ke([1,0,5,12]),function(ge,e,s,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.VariableError=e.VariableKind=e.IConfigurationResolverService=void 0,e.IConfigurationResolverService=(0,s.createDecorator)("configurationResolverService");var D;(function(L){L.Unknown="unknown",L.Env="env",L.Config="config",L.Command="command",L.Input="input",L.ExtensionInstallFolder="extensionInstallFolder",L.WorkspaceFolder="workspaceFolder",L.Cwd="cwd",L.WorkspaceFolderBasename="workspaceFolderBasename",L.UserHome="userHome",L.LineNumber="lineNumber",L.SelectedText="selectedText",L.File="file",L.FileWorkspaceFolder="fileWorkspaceFolder",L.FileWorkspaceFolderBasename="fileWorkspaceFolderBasename",L.RelativeFile="relativeFile",L.RelativeFileDirname="relativeFileDirname",L.FileDirname="fileDirname",L.FileExtname="fileExtname",L.FileBasename="fileBasename",L.FileBasenameNoExtension="fileBasenameNoExtension",L.FileDirnameBasename="fileDirnameBasename",L.ExecPath="execPath",L.ExecInstallFolder="execInstallFolder",L.PathSeparator="pathSeparator",L.PathSeparatorAlias="/"})(D||(e.VariableKind=D={}));class A extends h.ErrorNoTelemetry{constructor(R,v){super(v),this.variable=R}}e.VariableError=A}),define(Pe[269],ke([1,0,16,57,17,24,10,109,7,268,13]),function(ge,e,s,h,D,A,L,R,v,l,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0,s=We(s),h=We(h),D=We(D),A=We(A);class _{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(T,S,o,m){this._contributedVariables=new Map,this._context=T,this._labelService=S,this._userHomePromise=o,m&&(this._envVariablesPromise=m.then(p=>this.prepareEnv(p)))}prepareEnv(T){if(L.isWindows){const S=Object.create(null);return Object.keys(T).forEach(o=>{S[o.toLowerCase()]=T[o]}),S}return T}resolveWithEnvironment(T,S,o){return this.recursiveResolve({env:this.prepareEnv(T),userHome:void 0},S?S.uri:void 0,o)}async resolveAsync(T,S){const o={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(o,T?T.uri:void 0,S)}async resolveAnyBase(T,S,o,m){const p=A.deepClone(S);L.isWindows&&p.windows?Object.keys(p.windows).forEach(i=>p[i]=p.windows[i]):L.isMacintosh&&p.osx?Object.keys(p.osx).forEach(i=>p[i]=p.osx[i]):L.isLinux&&p.linux&&Object.keys(p.linux).forEach(i=>p[i]=p.linux[i]),delete p.windows,delete p.osx,delete p.linux;const u={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(u,T?T.uri:void 0,p,o,m)}async resolveAnyAsync(T,S,o){return this.resolveAnyBase(T,S,o)}async resolveAnyMap(T,S,o){const m=new Map;return{newConfig:await this.resolveAnyBase(T,S,o,m),resolvedVariables:m}}resolveWithInteractionReplace(T,S,o,m){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(T,S,o,m){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(T,S){if(this._contributedVariables.has(T))throw new Error("Variable "+T+" is contributed twice.");this._contributedVariables.set(T,S)}async recursiveResolve(T,S,o,m,p){if(D.isString(o))return this.resolveString(T,S,o,m,p);if(Array.isArray(o))return Promise.all(o.map(u=>this.recursiveResolve(T,S,u,m,p)));if(D.isObject(o)){const u=Object.create(null),i=await Promise.all(Object.keys(o).map(async a=>[await this.resolveString(T,S,a,m,p),await this.recursiveResolve(T,S,o[a],m,p)]));for(const[a,t]of i)u[a]=t;return u}return o}resolveString(T,S,o,m,p){return(0,C.replaceAsync)(o,_.VARIABLE_REGEXP,async(u,i)=>{if(i.includes(_.VARIABLE_LHS))return u;let a=await this.evaluateSingleVariable(T,u,i,S,m);return p?.set(i,a),a!==u&&D.isString(a)&&a.match(_.VARIABLE_REGEXP)&&(a=await this.resolveString(T,S,a,m,p)),a})}fsPath(T){return this._labelService?this._labelService.getUriLabel(T,{noPrefix:!0}):T.fsPath}async evaluateSingleVariable(T,S,o,m,p){let u;const i=o.split(":");i.length>1&&(o=i[0],u=i[1]);const a=r=>{const d=this._context.getFilePath();if(d)return(0,R.normalizeDriveLetter)(d);throw new l.VariableError(r,(0,v.localize)(12109,null,S))},t=r=>{const d=a(r);if(this._context.getWorkspaceFolderPathForFile){const c=this._context.getWorkspaceFolderPathForFile();if(c)return(0,R.normalizeDriveLetter)(c)}throw new l.VariableError(r,(0,v.localize)(12110,null,S,s.basename(d)))},n=r=>{if(u){const d=this._context.getFolderUri(u);if(d)return d;throw new l.VariableError(r,(0,v.localize)(12111,null,S,u))}if(m)return m;throw this._context.getWorkspaceFolderCount()>1?new l.VariableError(r,(0,v.localize)(12112,null,S)):new l.VariableError(r,(0,v.localize)(12113,null,S))};switch(o){case"env":if(u){if(T.env){const r=T.env[L.isWindows?u.toLowerCase():u];if(D.isString(r))return r}return""}throw new l.VariableError(l.VariableKind.Env,(0,v.localize)(12114,null,S));case"config":if(u){const r=this._context.getConfigurationValue(m,u);if(D.isUndefinedOrNull(r))throw new l.VariableError(l.VariableKind.Config,(0,v.localize)(12115,null,S,u));if(D.isObject(r))throw new l.VariableError(l.VariableKind.Config,(0,v.localize)(12116,null,S,u));return r}throw new l.VariableError(l.VariableKind.Config,(0,v.localize)(12117,null,S));case"command":return this.resolveFromMap(l.VariableKind.Command,S,u,p,"command");case"input":return this.resolveFromMap(l.VariableKind.Input,S,u,p,"input");case"extensionInstallFolder":if(u){const r=await this._context.getExtension(u);if(!r)throw new l.VariableError(l.VariableKind.ExtensionInstallFolder,(0,v.localize)(12118,null,S,u));return this.fsPath(r.extensionLocation)}throw new l.VariableError(l.VariableKind.ExtensionInstallFolder,(0,v.localize)(12119,null,S));default:switch(o){case"workspaceRoot":case"workspaceFolder":return(0,R.normalizeDriveLetter)(this.fsPath(n(l.VariableKind.WorkspaceFolder)));case"cwd":return m||u?(0,R.normalizeDriveLetter)(this.fsPath(n(l.VariableKind.Cwd))):h.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,R.normalizeDriveLetter)(s.basename(this.fsPath(n(l.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(T.userHome)return T.userHome;throw new l.VariableError(l.VariableKind.UserHome,(0,v.localize)(12120,null,S))}case"lineNumber":{const r=this._context.getLineNumber();if(r)return r;throw new l.VariableError(l.VariableKind.LineNumber,(0,v.localize)(12121,null,S))}case"selectedText":{const r=this._context.getSelectedText();if(r)return r;throw new l.VariableError(l.VariableKind.SelectedText,(0,v.localize)(12122,null,S))}case"file":return a(l.VariableKind.File);case"fileWorkspaceFolder":return t(l.VariableKind.FileWorkspaceFolder);case"fileWorkspaceFolderBasename":return s.basename(t(l.VariableKind.FileWorkspaceFolderBasename));case"relativeFile":return m||u?s.relative(this.fsPath(n(l.VariableKind.RelativeFile)),a(l.VariableKind.RelativeFile)):a(l.VariableKind.RelativeFile);case"relativeFileDirname":{const r=s.dirname(a(l.VariableKind.RelativeFileDirname));if(m||u){const d=s.relative(this.fsPath(n(l.VariableKind.RelativeFileDirname)),r);return d.length===0?".":d}return r}case"fileDirname":return s.dirname(a(l.VariableKind.FileDirname));case"fileExtname":return s.extname(a(l.VariableKind.FileExtname));case"fileBasename":return s.basename(a(l.VariableKind.FileBasename));case"fileBasenameNoExtension":{const r=s.basename(a(l.VariableKind.FileBasenameNoExtension));return r.slice(0,r.length-s.extname(r).length)}case"fileDirnameBasename":return s.basename(s.dirname(a(l.VariableKind.FileDirnameBasename)));case"execPath":{const r=this._context.getExecPath();return r||S}case"execInstallFolder":{const r=this._context.getAppRoot();return r||S}case"pathSeparator":case"/":return s.sep;default:try{const r=u?`${o}:${u}`:o;return this.resolveFromMap(l.VariableKind.Unknown,S,r,p,void 0)}catch{return S}}}}resolveFromMap(T,S,o,m,p){if(o&&m){const u=p===void 0?m[o]:m[p+":"+o];if(typeof u=="string")return u;throw new l.VariableError(T,(0,v.localize)(12123,null,S))}return S}}e.AbstractVariableResolverService=_}),define(Pe[162],ke([1,0,5,157]),function(ge,e,s,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OpenEditorContext=e.GroupsOrder=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.isEditorReplacement=l,e.isEditorGroup=f,e.preferredSideBySideGroupDirection=T,e.IEditorGroupsService=(0,s.createDecorator)("editorGroupsService");var D;(function(S){S[S.UP=0]="UP",S[S.DOWN=1]="DOWN",S[S.LEFT=2]="LEFT",S[S.RIGHT=3]="RIGHT"})(D||(e.GroupDirection=D={}));var A;(function(S){S[S.HORIZONTAL=0]="HORIZONTAL",S[S.VERTICAL=1]="VERTICAL"})(A||(e.GroupOrientation=A={}));var L;(function(S){S[S.FIRST=0]="FIRST",S[S.LAST=1]="LAST",S[S.NEXT=2]="NEXT",S[S.PREVIOUS=3]="PREVIOUS"})(L||(e.GroupLocation=L={}));var R;(function(S){S[S.MAXIMIZE=0]="MAXIMIZE",S[S.EXPAND=1]="EXPAND",S[S.EVEN=2]="EVEN"})(R||(e.GroupsArrangement=R={}));var v;(function(S){S[S.COPY_EDITORS=0]="COPY_EDITORS",S[S.MOVE_EDITORS=1]="MOVE_EDITORS"})(v||(e.MergeGroupMode=v={}));function l(S){const o=S;return(0,h.isEditorInput)(o?.editor)&&(0,h.isEditorInput)(o?.replacement)}var C;(function(S){S[S.CREATION_TIME=0]="CREATION_TIME",S[S.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",S[S.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(C||(e.GroupsOrder=C={}));var _;(function(S){S[S.NEW_EDITOR=1]="NEW_EDITOR",S[S.MOVE_EDITOR=2]="MOVE_EDITOR",S[S.COPY_EDITOR=3]="COPY_EDITOR"})(_||(e.OpenEditorContext=_={}));function f(S){const o=S;return!!o&&typeof o.id=="number"&&Array.isArray(o.editors)}function T(S){return S.getValue("workbench.editor.openSideBySideDirection")==="down"?D.DOWN:D.RIGHT}}),define(Pe[270],ke([1,0,5,162]),function(ge,e,s,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AUX_WINDOW_GROUP=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.isPreferredGroup=D,e.IEditorService=(0,s.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2,e.AUX_WINDOW_GROUP=-3;function D(A){const L=A;return typeof A=="number"||(0,h.isEditorGroup)(L)}}),define(Pe[163],ke([1,0,5,148]),function(ge,e,s,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,s.refineServiceDecorator)(h.IEnvironmentService)}),define(Pe[164],ke([1,0,23,4,16,3,8]),function(ge,e,s,h,D,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistryLock=e.LockableExtensionDescriptionRegistry=e.ExtensionDescriptionRegistrySnapshot=e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0,D=We(D);class R{constructor(u,i){this.versionId=u,this.removedDueToLooping=i}}e.DeltaExtensionsResult=R;class v{static isHostExtension(u,i,a){if(i.getExtensionDescription(u))return!1;const t=a.getExtensionDescription(u);return t?!!((t.main||t.browser)&&t.api==="none"):!1}constructor(u,i){this._activationEventsReader=u,this._onDidChange=new h.Emitter,this.onDidChange=this._onDidChange.event,this._versionId=0,this._extensionDescriptions=i,this._initialize()}_initialize(){this._extensionDescriptions.sort(o),this._extensionsMap=new s.ExtensionIdentifierMap,this._extensionsArr=[],this._activationMap=new Map;for(const u of this._extensionDescriptions){if(this._extensionsMap.has(u.identifier)){console.error("Extension `"+u.identifier.value+"` is already registered");continue}this._extensionsMap.set(u.identifier,u),this._extensionsArr.push(u);const i=this._activationEventsReader.readActivationEvents(u);for(const a of i)this._activationMap.has(a)||this._activationMap.set(a,[]),this._activationMap.get(a).push(u)}}set(u){return this._extensionDescriptions=u,this._initialize(),this._versionId++,this._onDidChange.fire(void 0),{versionId:this._versionId}}deltaExtensions(u,i){this._extensionDescriptions=m(this._extensionDescriptions,i),this._extensionDescriptions=this._extensionDescriptions.concat(u);const a=v._findLoopingExtensions(this._extensionDescriptions);return this._extensionDescriptions=m(this._extensionDescriptions,a.map(t=>t.identifier)),this._initialize(),this._versionId++,this._onDidChange.fire(void 0),new R(this._versionId,a)}static _findLoopingExtensions(u){const i=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(d){this._nodesSet.has(d)||(this._nodesSet.add(d),this._nodesArr.push(d))}addArc(d,c){this.addNode(d),this.addNode(c),this._arcs.has(d)?this._arcs.get(d).push(c):this._arcs.set(d,[c])}getArcs(d){return this._arcs.has(d)?this._arcs.get(d):[]}hasOnlyGoodArcs(d,c){const g=i.getArcs(d);for(let w=0;w<g.length;w++)if(!c.has(g[w]))return!1;return!0}getNodes(){return this._nodesArr}},a=new s.ExtensionIdentifierMap;for(const d of u)if(a.set(d.identifier,d),d.extensionDependencies)for(const c of d.extensionDependencies)i.addArc(s.ExtensionIdentifier.toKey(d.identifier),s.ExtensionIdentifier.toKey(c));const t=new Set;i.getNodes().filter(d=>i.getArcs(d).length===0).forEach(d=>t.add(d));const n=i.getNodes().filter(d=>!t.has(d));let r;do{r=!1;for(let d=0;d<n.length;d++){const c=n[d];i.hasOnlyGoodArcs(c,t)&&(n.splice(d,1),d--,t.add(c),r=!0)}}while(r);return n.map(d=>a.get(d))}containsActivationEvent(u){return this._activationMap.has(u)}containsExtension(u){return this._extensionsMap.has(u)}getExtensionDescriptionsForActivationEvent(u){const i=this._activationMap.get(u);return i?i.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getSnapshot(){return new l(this._versionId,this.getAllExtensionDescriptions())}getExtensionDescription(u){const i=this._extensionsMap.get(u);return i||void 0}getExtensionDescriptionByUUID(u){for(const i of this._extensionsArr)if(i.uuid===u)return i}getExtensionDescriptionByIdOrUUID(u,i){return this.getExtensionDescription(u)??(i?this.getExtensionDescriptionByUUID(i):void 0)}}e.ExtensionDescriptionRegistry=v;class l{constructor(u,i){this.versionId=u,this.extensions=i}}e.ExtensionDescriptionRegistrySnapshot=l;class C{constructor(u){this._lock=new T,this._actual=new v(u,[])}async acquireLock(u){const i=await this._lock.acquire(u);return new _(this,i)}deltaExtensions(u,i,a){if(!u.isAcquiredFor(this))throw new Error("Lock is not held");return this._actual.deltaExtensions(i,a)}containsActivationEvent(u){return this._actual.containsActivationEvent(u)}containsExtension(u){return this._actual.containsExtension(u)}getExtensionDescriptionsForActivationEvent(u){return this._actual.getExtensionDescriptionsForActivationEvent(u)}getAllExtensionDescriptions(){return this._actual.getAllExtensionDescriptions()}getSnapshot(){return this._actual.getSnapshot()}getExtensionDescription(u){return this._actual.getExtensionDescription(u)}getExtensionDescriptionByUUID(u){return this._actual.getExtensionDescriptionByUUID(u)}getExtensionDescriptionByIdOrUUID(u,i){return this._actual.getExtensionDescriptionByIdOrUUID(u,i)}}e.LockableExtensionDescriptionRegistry=C;class _ extends A.Disposable{constructor(u,i){super(),this._registry=u,this._isDisposed=!1,this._register(i)}isAcquiredFor(u){return!this._isDisposed&&this._registry===u}}e.ExtensionDescriptionRegistryLock=_;class f{constructor(u){this.name=u;const i=(0,L.promiseWithResolvers)();this.promise=i.promise,this._resolve=i.resolve}resolve(u){this._resolve(u)}}class T{constructor(){this._pendingCustomers=[],this._isLocked=!1}async acquire(u){const i=new f(u);return this._pendingCustomers.push(i),this._advance(),i.promise}_advance(){if(this._isLocked||this._pendingCustomers.length===0)return;const u=this._pendingCustomers.shift();this._isLocked=!0;let i=!0;const a=setTimeout(()=>{i&&console.warn(`The customer named ${u.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),t=()=>{i&&(clearTimeout(a),i=!1,this._isLocked=!1,this._advance())};u.resolve((0,A.toDisposable)(t))}}var S;(function(p){p[p.Builtin=0]="Builtin",p[p.User=1]="User",p[p.Dev=2]="Dev"})(S||(S={}));function o(p,u){const i=p.isBuiltin?S.Builtin:p.isUnderDevelopment?S.Dev:S.User,a=u.isBuiltin?S.Builtin:u.isUnderDevelopment?S.Dev:S.User;if(i!==a)return i-a;const t=D.posix.basename(p.extensionLocation.path),n=D.posix.basename(u.extensionLocation.path);return t<n?-1:t>n?1:0}function m(p,u){const i=new s.ExtensionIdentifierSet(u);return p.filter(a=>!i.has(a.identifier))}}),define(Pe[271],ke([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MessagePortExtHostConnection=e.SocketExtHostConnection=e.IPCExtHostConnection=e.ExtHostConnectionType=void 0,e.writeExtHostConnection=R,e.readExtHostConnection=v;var s;(function(C){C[C.IPC=1]="IPC",C[C.Socket=2]="Socket",C[C.MessagePort=3]="MessagePort"})(s||(e.ExtHostConnectionType=s={}));class h{static{this.ENV_KEY="VSCODE_EXTHOST_IPC_HOOK"}constructor(_){this.pipeName=_,this.type=s.IPC}serialize(_){_[h.ENV_KEY]=this.pipeName}}e.IPCExtHostConnection=h;class D{constructor(){this.type=s.Socket}static{this.ENV_KEY="VSCODE_EXTHOST_WILL_SEND_SOCKET"}serialize(_){_[D.ENV_KEY]="1"}}e.SocketExtHostConnection=D;class A{constructor(){this.type=s.MessagePort}static{this.ENV_KEY="VSCODE_WILL_SEND_MESSAGE_PORT"}serialize(_){_[A.ENV_KEY]="1"}}e.MessagePortExtHostConnection=A;function L(C){delete C[h.ENV_KEY],delete C[D.ENV_KEY],delete C[A.ENV_KEY]}function R(C,_){L(_),C.serialize(_)}function v(C){if(C[h.ENV_KEY])return l(C,new h(C[h.ENV_KEY]));if(C[D.ENV_KEY])return l(C,new D);if(C[A.ENV_KEY])return l(C,new A);throw new Error("No connection information defined in environment!")}function l(C,_){return L(C),_}}),define(Pe[94],ke([1,0,21]),function(ge,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0,e.createMessageOfType=L,e.isMessageOfType=R;var h;(function(l){l[l.Desktop=1]="Desktop",l[l.Web=2]="Web"})(h||(e.UIKind=h={}));var D;(function(l){l[l.VersionMismatch=55]="VersionMismatch",l[l.UnexpectedError=81]="UnexpectedError"})(D||(e.ExtensionHostExitCode=D={}));var A;(function(l){l[l.Initialized=0]="Initialized",l[l.Ready=1]="Ready",l[l.Terminate=2]="Terminate"})(A||(e.MessageType=A={}));function L(l){const C=s.VSBuffer.alloc(1);switch(l){case A.Initialized:C.writeUInt8(1,0);break;case A.Ready:C.writeUInt8(2,0);break;case A.Terminate:C.writeUInt8(3,0);break}return C}function R(l,C){if(l.byteLength!==1)return!1;switch(l.readUInt8(0)){case 1:return C===A.Initialized;case 2:return C===A.Ready;case 3:return C===A.Terminate;default:return!1}}var v;(function(l){l.Start="START_NATIVE_LOG",l.End="END_NATIVE_LOG"})(v||(e.NativeLogMarkers=v={}))}),define(Pe[95],ke([1,0,5,4,153,11,29,94,91,92,24,2,3,7]),function(ge,e,s,h,D,A,L,R,v,l,C,_,f,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetryLogger=e.ExtHostTelemetry=void 0,e.isNewAppInstall=m;let S=class extends f.Disposable{constructor(u,i){super(),this.initData=u,this.loggerService=i,this._onDidChangeTelemetryEnabled=this._register(new h.Emitter),this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._onDidChangeTelemetryConfiguration=this._register(new h.Emitter),this.onDidChangeTelemetryConfiguration=this._onDidChangeTelemetryConfiguration.event,this._productConfig={usage:!0,error:!0},this._level=D.TelemetryLevel.NONE,this._telemetryIsSupported=!1,this._inLoggingOnlyMode=!1,this._telemetryLoggers=new Map,this.extHostTelemetryLogFile=_.URI.revive(this.initData.environment.extensionTelemetryLogResource),this._inLoggingOnlyMode=this.initData.environment.isExtensionTelemetryLoggingOnly,this._outputLogger=i.createLogger(this.extHostTelemetryLogFile,{id:l.extensionTelemetryLogChannelId,name:(0,T.localize)(2713,null,this._inLoggingOnlyMode?" (Not Sent)":""),hidden:!0}),this._register(this._outputLogger),this._register(i.onDidChangeLogLevel(a=>{(0,A.isLogLevel)(a)&&this.updateLoggerVisibility()})),this._outputLogger.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this._outputLogger.info("===========================================================")}updateLoggerVisibility(){this.loggerService.setVisibility(this.extHostTelemetryLogFile,this._telemetryIsSupported&&this.loggerService.getLogLevel()===A.LogLevel.Trace)}getTelemetryConfiguration(){return this._level===D.TelemetryLevel.USAGE}getTelemetryDetails(){return{isCrashEnabled:this._level>=D.TelemetryLevel.CRASH,isErrorsEnabled:this._productConfig.error?this._level>=D.TelemetryLevel.ERROR:!1,isUsageEnabled:this._productConfig.usage?this._level>=D.TelemetryLevel.USAGE:!1}}instantiateLogger(u,i,a){const t=this.getTelemetryDetails(),n=new o(i,a,u,this._outputLogger,this._inLoggingOnlyMode,this.getBuiltInCommonProperties(u),{isUsageEnabled:t.isUsageEnabled,isErrorsEnabled:t.isErrorsEnabled}),r=this._telemetryLoggers.get(u.identifier.value)??[];return this._telemetryLoggers.set(u.identifier.value,[...r,n]),n.apiTelemetryLogger}$initializeTelemetryLevel(u,i,a){this._level=u,this._telemetryIsSupported=i,this._productConfig=a??{usage:!0,error:!0},this.updateLoggerVisibility()}getBuiltInCommonProperties(u){const i=Object.create(null);switch(i["common.extname"]=`${u.publisher}.${u.name}`,i["common.extversion"]=u.version,i["common.vscodemachineid"]=this.initData.telemetryInfo.machineId,i["common.vscodesessionid"]=this.initData.telemetryInfo.sessionId,i["common.sqmid"]=this.initData.telemetryInfo.sqmId,i["common.devDeviceId"]=this.initData.telemetryInfo.devDeviceId,i["common.vscodeversion"]=this.initData.version,i["common.isnewappinstall"]=m(this.initData.telemetryInfo.firstSessionDate),i["common.product"]=this.initData.environment.appHost,this.initData.uiKind){case R.UIKind.Web:i["common.uikind"]="web";break;case R.UIKind.Desktop:i["common.uikind"]="desktop";break;default:i["common.uikind"]="unknown"}return i["common.remotename"]=(0,v.getRemoteName)((0,l.cleanRemoteAuthority)(this.initData.remote.authority)),i}$onDidChangeTelemetryLevel(u){this._oldTelemetryEnablement=this.getTelemetryConfiguration(),this._level=u;const i=this.getTelemetryDetails();this._telemetryLoggers.forEach((a,t)=>{const n=a.filter(r=>!r.isDisposed);n.length===0?this._telemetryLoggers.delete(t):this._telemetryLoggers.set(t,n)}),this._telemetryLoggers.forEach(a=>{for(const t of a)t.updateTelemetryEnablements(i.isUsageEnabled,i.isErrorsEnabled)}),this._oldTelemetryEnablement!==this.getTelemetryConfiguration()&&this._onDidChangeTelemetryEnabled.fire(this.getTelemetryConfiguration()),this._onDidChangeTelemetryConfiguration.fire(this.getTelemetryDetails()),this.updateLoggerVisibility()}onExtensionError(u,i){const t=this._telemetryLoggers.get(u.value)?.filter(r=>!r.isDisposed);if(!t)return this._telemetryLoggers.delete(u.value),!1;let n=!1;for(const r of t)r.ignoreUnhandledExtHostErrors||(r.logError(i),n=!0);return n}};e.ExtHostTelemetry=S,e.ExtHostTelemetry=S=Qe([$e(0,L.IExtHostInitDataService),$e(1,A.ILoggerService)],S);class o{static validateSender(u){if(typeof u!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof u.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof u.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof u.flush<"u"&&typeof u.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(u,i,a,t,n,r,d){this._extension=a,this._logger=t,this._inLoggingOnlyMode=n,this._commonProperties=r,this._onDidChangeEnableStates=new h.Emitter,this.ignoreUnhandledExtHostErrors=i?.ignoreUnhandledErrors??!1,this._ignoreBuiltinCommonProperties=i?.ignoreBuiltInCommonProperties??!1,this._additionalCommonProperties=i?.additionalCommonProperties,this._sender=u,this._telemetryEnablements={isUsageEnabled:d.isUsageEnabled,isErrorsEnabled:d.isErrorsEnabled}}updateTelemetryEnablements(u,i){this._apiObject&&(this._telemetryEnablements={isUsageEnabled:u,isErrorsEnabled:i},this._onDidChangeEnableStates.fire(this._apiObject))}mixInCommonPropsAndCleanData(u){let i="properties"in u?u.properties??{}:u;return i=(0,l.cleanData)(i,[]),this._additionalCommonProperties&&(i=(0,C.mixin)(i,this._additionalCommonProperties)),this._ignoreBuiltinCommonProperties||(i=(0,C.mixin)(i,this._commonProperties)),"properties"in u?u.properties=i:u=i,u}logEvent(u,i){this._sender&&(this._extension.publisher==="vscode"?u=this._extension.name+"/"+u:u=this._extension.identifier.value+"/"+u,i=this.mixInCommonPropsAndCleanData(i||{}),this._inLoggingOnlyMode||this._sender?.sendEventData(u,i),this._logger.trace(u,i))}logUsage(u,i){this._telemetryEnablements.isUsageEnabled&&this.logEvent(u,i)}logError(u,i){if(!(!this._telemetryEnablements.isErrorsEnabled||!this._sender))if(typeof u=="string")this.logEvent(u,i);else{const a={name:u.name,message:u.message,stack:u.stack,cause:u.cause},t=(0,l.cleanData)(a,[]),n=new Error(t.message,{cause:t.cause});n.stack=t.stack,n.name=t.name,i=this.mixInCommonPropsAndCleanData(i||{}),this._inLoggingOnlyMode||this._sender.sendErrorData(n,i),this._logger.trace("exception",i)}}get apiTelemetryLogger(){if(!this._apiObject){const u=this,i={logUsage:u.logUsage.bind(u),get isUsageEnabled(){return u._telemetryEnablements.isUsageEnabled},get isErrorsEnabled(){return u._telemetryEnablements.isErrorsEnabled},logError:u.logError.bind(u),dispose:u.dispose.bind(u),onDidChangeEnableStates:u._onDidChangeEnableStates.event.bind(u)};this._apiObject=Object.freeze(i)}return this._apiObject}get isDisposed(){return!this._sender}dispose(){if(this._sender?.flush){let u=this._sender;this._sender=void 0,Promise.resolve(u.flush()).then(u=void 0),this._apiObject=void 0}else this._sender=void 0}}e.ExtHostTelemetryLogger=o;function m(p){const u=Date.now()-new Date(p).getTime();return isNaN(u)?!1:u<1e3*60*60*24}e.IExtHostTelemetry=(0,s.createDecorator)("IExtHostTelemetry")}),define(Pe[25],ke([1,0,4,2,243,151,23,5]),function(ge,e,s,h,D,A,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.ActivationKind=e.ExtensionPointContribution=e.ActivationTimes=e.ExtensionHostExtensions=e.ExtensionHostStartup=e.MissingExtensionDependency=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.isProposedApiEnabled=f,e.checkProposedApiEnabled=T,e.toExtension=p,e.toExtensionDescription=u,e.nullExtensionDescription=Object.freeze({identifier:new L.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:h.URI.parse("void:location"),isBuiltin:!1,targetPlatform:L.TargetPlatform.UNDEFINED,isUserBuiltin:!1,isUnderDevelopment:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,R.createDecorator)("extensionService");class v{constructor(t){this.dependency=t}}e.MissingExtensionDependency=v;var l;(function(a){a[a.EagerAutoStart=1]="EagerAutoStart",a[a.EagerManualStart=2]="EagerManualStart",a[a.Lazy=3]="Lazy"})(l||(e.ExtensionHostStartup=l={}));class C{get versionId(){return this._versionId}get allExtensions(){return this._allExtensions}get myExtensions(){return this._myExtensions}constructor(t,n,r){this._versionId=t,this._allExtensions=n.slice(0),this._myExtensions=r.slice(0),this._myActivationEvents=null}toSnapshot(){return{versionId:this._versionId,allExtensions:this._allExtensions,myExtensions:this._myExtensions,activationEvents:A.ImplicitActivationEvents.createActivationEventsMap(this._allExtensions)}}set(t,n,r){if(this._versionId>t)throw new Error(`ExtensionHostExtensions: invalid versionId ${t} (current: ${this._versionId})`);const d=[],c=[],g=[],w=[],y=_(this._allExtensions),I=_(n),P=(O,M)=>O.extensionLocation.toString()===M.extensionLocation.toString()||O.isBuiltin===M.isBuiltin||O.isUserBuiltin===M.isUserBuiltin||O.isUnderDevelopment===M.isUnderDevelopment;for(const O of this._allExtensions){const M=I.get(O.identifier);if(!M){d.push(O.identifier),y.delete(O.identifier);continue}if(!P(O,M)){d.push(O.identifier),y.delete(O.identifier);continue}}for(const O of n){const M=y.get(O.identifier);if(!M){c.push(O);continue}if(!P(M,O)){d.push(M.identifier),y.delete(M.identifier);continue}}const k=new L.ExtensionIdentifierSet(this._myExtensions),b=new L.ExtensionIdentifierSet(r);for(const O of this._myExtensions)b.has(O)||g.push(O);for(const O of r)k.has(O)||w.push(O);const E=A.ImplicitActivationEvents.createActivationEventsMap(c),N={versionId:t,toRemove:d,toAdd:c,addActivationEvents:E,myToRemove:g,myToAdd:w};return this.delta(N),N}delta(t){if(this._versionId>=t.versionId)return null;const{toRemove:n,toAdd:r,myToRemove:d,myToAdd:c}=t,g=new L.ExtensionIdentifierSet(n),w=new L.ExtensionIdentifierSet(d);for(let y=0;y<this._allExtensions.length;y++)g.has(this._allExtensions[y].identifier)&&(this._allExtensions.splice(y,1),y--);for(let y=0;y<this._myExtensions.length;y++)w.has(this._myExtensions[y])&&(this._myExtensions.splice(y,1),y--);for(const y of r)this._allExtensions.push(y);for(const y of c)this._myExtensions.push(y);return this._myActivationEvents=null,t}containsExtension(t){for(const n of this._myExtensions)if(L.ExtensionIdentifier.equals(n,t))return!0;return!1}containsActivationEvent(t){return this._myActivationEvents||(this._myActivationEvents=this._readMyActivationEvents()),this._myActivationEvents.has(t)}_readMyActivationEvents(){const t=new Set;for(const n of this._allExtensions){if(!this.containsExtension(n.identifier))continue;const r=A.ImplicitActivationEvents.readActivationEvents(n);for(const d of r)t.add(d)}return t}}e.ExtensionHostExtensions=C;function _(a){const t=new L.ExtensionIdentifierMap;for(const n of a)t.set(n.identifier,n);return t}function f(a,t){return a.enabledApiProposals?a.enabledApiProposals.includes(t):!1}function T(a,t){if(!f(a,t))throw new Error(`Extension '${a.identifier.value}' CANNOT use API proposal: ${t}.
Its package.json#enabledApiProposals-property declares: ${a.enabledApiProposals?.join(", ")??"[]"} but NOT ${t}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${a.identifier.value}`)}class S{constructor(t,n,r,d){this.codeLoadingTime=t,this.activateCallTime=n,this.activateResolvedTime=r,this.activationReason=d}}e.ActivationTimes=S;class o{constructor(t,n){this.description=t,this.value=n}}e.ExtensionPointContribution=o;var m;(function(a){a[a.Normal=0]="Normal",a[a.Immediate=1]="Immediate"})(m||(e.ActivationKind=m={}));function p(a){return{type:a.isBuiltin?L.ExtensionType.System:L.ExtensionType.User,isBuiltin:a.isBuiltin||a.isUserBuiltin,identifier:{id:(0,D.getGalleryExtensionId)(a.publisher,a.name),uuid:a.uuid},manifest:a,location:a.extensionLocation,targetPlatform:a.targetPlatform,validations:[],isValid:!0}}function u(a,t){const n=(0,D.getExtensionId)(a.manifest.publisher,a.manifest.name);return{id:n,identifier:new L.ExtensionIdentifier(n),isBuiltin:a.type===L.ExtensionType.System,isUserBuiltin:a.type===L.ExtensionType.User&&a.isBuiltin,isUnderDevelopment:!!t,extensionLocation:a.location,uuid:a.identifier.uuid,targetPlatform:a.targetPlatform,publisherDisplayName:a.publisherDisplayName,...a.manifest}}class i{constructor(){this.onDidRegisterExtensions=s.Event.None,this.onDidChangeExtensionsStatus=s.Event.None,this.onDidChangeExtensions=s.Event.None,this.onWillActivateByEvent=s.Event.None,this.onDidChangeResponsiveChange=s.Event.None,this.onWillStop=s.Event.None,this.extensions=[]}activateByEvent(t){return Promise.resolve(void 0)}activateById(t,n){return Promise.resolve(void 0)}activationEventIsDone(t){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(t){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(t,n){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(t){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.NullExtensionService=i}),define(Pe[272],ke([1,0,12,3,164,23,25,11,8]),function(ge,e,s,h,D,A,L,R,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0,s=We(s);class l{static{this.NONE=new l(!1,-1,-1,-1)}constructor(u,i,a,t){this.startup=u,this.codeLoadingTime=i,this.activateCallTime=a,this.activateResolvedTime=t}}e.ExtensionActivationTimes=l;class C{constructor(u){this._startup=u,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(u,i){return u===-1||i===-1?-1:i-u}build(){return new l(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=C;class _{constructor(u,i,a,t,n,r){this.activationFailed=u,this.activationFailedError=i,this.activationTimes=a,this.module=t,this.exports=n,this.disposable=r}}e.ActivatedExtension=_;class f extends _{constructor(u){super(!1,null,u,{activate:void 0,deactivate:void 0},void 0,h.Disposable.None)}}e.EmptyExtension=f;class T extends _{constructor(){super(!1,null,l.NONE,{activate:void 0,deactivate:void 0},void 0,h.Disposable.None)}}e.HostExtension=T;class S extends _{constructor(u){super(!0,u,l.NONE,{activate:void 0,deactivate:void 0},void 0,h.Disposable.None)}}let o=class{constructor(u,i,a,t){this._logService=t,this._registry=u,this._globalRegistry=i,this._host=a,this._operations=new A.ExtensionIdentifierMap,this._alreadyActivatedEvents=Object.create(null)}dispose(){for(const[u,i]of this._operations)i.dispose()}async waitForActivatingExtensions(){const u=[];for(const[i,a]of this._operations)u.push(a.wait());await Promise.all(u)}isActivated(u){const i=this._operations.get(u);return!!(i&&i.value)}getActivatedExtension(u){const i=this._operations.get(u);if(!i||!i.value)throw new Error(`Extension '${u.value}' is not known or not activated`);return i.value}async activateByEvent(u,i){if(this._alreadyActivatedEvents[u])return;const a=this._registry.getExtensionDescriptionsForActivationEvent(u);await this._activateExtensions(a.map(t=>({id:t.identifier,reason:{startup:i,extensionId:t.identifier,activationEvent:u}}))),this._alreadyActivatedEvents[u]=!0}activateById(u,i){const a=this._registry.getExtensionDescription(u);if(!a)throw new Error(`Extension '${u.value}' is not known`);return this._activateExtensions([{id:a.identifier,reason:i}])}async _activateExtensions(u){const i=u.filter(a=>!this.isActivated(a.id)).map(a=>this._handleActivationRequest(a));await Promise.all(i.map(a=>a.wait()))}_handleActivationRequest(u){if(this._operations.has(u.id))return this._operations.get(u.id);if(this._isHostExtension(u.id))return this._createAndSaveOperation(u,null,[],null);const i=this._registry.getExtensionDescription(u.id);if(!i){const n=new Error(`Cannot activate unknown extension '${u.id.value}'`),r=this._createAndSaveOperation(u,null,[],new S(n));return this._host.onExtensionActivationError(u.id,n,new L.MissingExtensionDependency(u.id.value)),r}const a=[],t=typeof i.extensionDependencies>"u"?[]:i.extensionDependencies;for(const n of t){if(this._isResolvedExtension(n))continue;const r=this._operations.get(n);if(r){a.push(r);continue}if(this._isHostExtension(n)){a.push(this._handleActivationRequest({id:this._globalRegistry.getExtensionDescription(n).identifier,reason:u.reason}));continue}const d=this._registry.getExtensionDescription(n);if(d){if(!d.main&&!d.browser)continue;a.push(this._handleActivationRequest({id:d.identifier,reason:u.reason}));continue}const c=i.displayName||i.identifier.value,g=new Error(`Cannot activate the '${c}' extension because it depends on unknown extension '${n}'`),w=this._createAndSaveOperation(u,i.displayName,[],new S(g));return this._host.onExtensionActivationError(i.identifier,g,new L.MissingExtensionDependency(n)),w}return this._createAndSaveOperation(u,i.displayName,a,null)}_createAndSaveOperation(u,i,a,t){const n=new m(u.id,i,u.reason,a,t,this._host,this._logService);return this._operations.set(u.id,n),n}_isHostExtension(u){return D.ExtensionDescriptionRegistry.isHostExtension(u,this._registry,this._globalRegistry)}_isResolvedExtension(u){const i=this._globalRegistry.getExtensionDescription(u);return i?!i.main&&!i.browser:!1}};e.ExtensionsActivator=o,e.ExtensionsActivator=o=Qe([$e(3,R.ILogService)],o);let m=class{get value(){return this._value}get friendlyName(){return this._displayName||this._id.value}constructor(u,i,a,t,n,r,d){this._id=u,this._displayName=i,this._reason=a,this._deps=t,this._value=n,this._host=r,this._logService=d,this._barrier=new v.Barrier,this._isDisposed=!1,this._initialize()}dispose(){this._isDisposed=!0}wait(){return this._barrier.wait()}async _initialize(){await this._waitForDepsThenActivate(),this._barrier.open()}async _waitForDepsThenActivate(){if(!this._value){for(;this._deps.length>0;){for(let u=0;u<this._deps.length;u++){const i=this._deps[u];if(i.value&&!i.value.activationFailed){this._deps.splice(u,1),u--;continue}if(i.value&&i.value.activationFailed){const a=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${i.friendlyName}' failed to activate`);a.detail=i.value.activationFailedError,this._value=new S(a),this._host.onExtensionActivationError(this._id,a,null);return}}this._deps.length>0&&await Promise.race(this._deps.map(u=>u.wait()))}await this._activate()}}async _activate(){try{this._value=await this._host.actualActivateExtension(this._id,this._reason)}catch(u){const i=new Error;if(u&&u.name&&(i.name=u.name),u&&u.message?i.message=`Activating extension '${this._id.value}' failed: ${u.message}.`:i.message=`Activating extension '${this._id.value}' failed: ${u}.`,u&&u.stack&&(i.stack=u.stack),this._value=new S(i),this._isDisposed&&s.isCancellationError(u))return;this._host.onExtensionActivationError(this._id,i,null),this._logService.error(`Activating extension ${this._id.value} failed due to an error:`),this._logService.error(u)}}};m=Qe([$e(6,R.ILogService)],m)});var Vt=this&&this.__importDefault||function(ge){return ge&&ge.__esModule?ge:{default:ge}};define(Pe[165],ke([1,0,7,12,44,150,116,37,23,115,151,147]),function(ge,e,s,h,D,A,L,R,v,l,C,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsRegistry=e.ExtensionsRegistryImpl=e.schema=e.ExtensionPoint=e.ExtensionPointUserDelta=e.ExtensionMessageCollector=void 0,s=We(s),D=Vt(D);const f=R.Registry.as(L.Extensions.JSONContribution);class T{constructor(t,n,r){this._messageHandler=t,this._extension=n,this._extensionPointId=r}_msg(t,n){this._messageHandler({type:t,message:n,extensionId:this._extension.identifier,extensionPointId:this._extensionPointId})}error(t){this._msg(D.default.Error,t)}warn(t){this._msg(D.default.Warning,t)}info(t){this._msg(D.default.Info,t)}}e.ExtensionMessageCollector=T;class S{static _toSet(t){const n=new v.ExtensionIdentifierSet;for(let r=0,d=t.length;r<d;r++)n.add(t[r].description.identifier);return n}static compute(t,n){if(!t||!t.length)return new S(n,[]);if(!n||!n.length)return new S([],t);const r=this._toSet(t),d=this._toSet(n),c=n.filter(w=>!r.has(w.description.identifier)),g=t.filter(w=>!d.has(w.description.identifier));return new S(c,g)}constructor(t,n){this.added=t,this.removed=n}}e.ExtensionPointUserDelta=S;class o{constructor(t,n){this.name=t,this.defaultExtensionKind=n,this._handler=null,this._users=null,this._delta=null}setHandler(t){if(this._handler!==null)throw new Error("Handler already set!");return this._handler=t,this._handle(),{dispose:()=>{this._handler=null}}}acceptUsers(t){this._delta=S.compute(this._users,t),this._users=t,this._handle()}_handle(){if(!(this._handler===null||this._users===null||this._delta===null))try{this._handler(this._users,this._delta)}catch(t){(0,h.onUnexpectedError)(t)}}}e.ExtensionPoint=o;const m={type:"string",enum:["ui","workspace"],enumDescriptions:[s.localize(12278,null),s.localize(12279,null)]},p="vscode://schemas/vscode-extensions";e.schema={properties:{engines:{type:"object",description:s.localize(12280,null),properties:{vscode:{type:"string",description:s.localize(12281,null),default:"^1.22.0"}}},publisher:{description:s.localize(12282,null),type:"string"},displayName:{description:s.localize(12283,null),type:"string"},categories:{description:s.localize(12284,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:v.EXTENSION_CATEGORIES},{type:"string",const:"Languages",deprecationMessage:s.localize(12285,null)}]}},galleryBanner:{type:"object",description:s.localize(12286,null),properties:{color:{description:s.localize(12287,null),type:"string"},theme:{description:s.localize(12288,null),type:"string",enum:["dark","light"]}}},contributes:{description:s.localize(12289,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:s.localize(12290,null)},enableProposedApi:{type:"boolean",deprecationMessage:s.localize(12291,null)},enabledApiProposals:{markdownDescription:s.localize(12292,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(_.allApiProposals).map(a=>a),markdownEnumDescriptions:Object.values(_.allApiProposals).map(a=>a.proposal)}},api:{markdownDescription:s.localize(12293,null),type:"string",enum:["none"],enumDescriptions:[s.localize(12294,null)]},activationEvents:{description:s.localize(12295,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:s.localize(12296,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:s.localize(12297,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:s.localize(12298,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:s.localize(12299,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:s.localize(12300,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:s.localize(12301,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:s.localize(12302,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:s.localize(12303,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:s.localize(12304,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:s.localize(12305,null),body:"onStartupFinished"},{label:"onTaskType",description:s.localize(12306,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:s.localize(12307,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:s.localize(12308,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:s.localize(12309,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:s.localize(12310,null)},{label:"onUri",body:"onUri",description:s.localize(12311,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:s.localize(12312,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:s.localize(12313,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:s.localize(12314,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:s.localize(12315,null)},{label:"onRenderer",description:s.localize(12316,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:s.localize(12317,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:s.localize(12318,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:s.localize(12319,null)},{label:"onIssueReporterOpened",body:"onIssueReporterOpened",description:s.localize(12320,null)},{label:"onChatParticipant",body:"onChatParticipant:${1:participantId}",description:s.localize(12321,null)},{label:"onLanguageModelTool",body:"onLanguageModelTool:${1:toolId}",description:s.localize(12322,null)},{label:"*",description:s.localize(12323,null),body:"*"}]}},badges:{type:"array",description:s.localize(12324,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:s.localize(12325,null)},href:{type:"string",description:s.localize(12326,null)},description:{type:"string",description:s.localize(12327,null)}}}},markdown:{type:"string",description:s.localize(12328,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:s.localize(12329,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:s.localize(12330,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:A.EXTENSION_IDENTIFIER_PATTERN}},extensionPack:{description:s.localize(12331,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:A.EXTENSION_IDENTIFIER_PATTERN}},extensionKind:{description:s.localize(12332,null),type:"array",items:m,default:["workspace"],defaultSnippets:[{body:["ui"],description:s.localize(12333,null)},{body:["workspace"],description:s.localize(12334,null)},{body:["ui","workspace"],description:s.localize(12335,null)},{body:["workspace","ui"],description:s.localize(12336,null)},{body:[],description:s.localize(12337,null)}]},capabilities:{description:s.localize(12338,null),type:"object",properties:{virtualWorkspaces:{description:s.localize(12339,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:s.localize(12340,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[s.localize(12341,null),s.localize(12342,null),s.localize(12343,null)]},description:{type:"string",markdownDescription:s.localize(12344,null)}}},untrustedWorkspaces:{description:s.localize(12345,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:s.localize(12346,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[s.localize(12347,null),s.localize(12348,null),s.localize(12349,null)]},restrictedConfigurations:{description:s.localize(12350,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:s.localize(12351,null)}}}}},sponsor:{description:s.localize(12352,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:s.localize(12353,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:s.localize(12354,null),type:"string"},"vscode:uninstall":{description:s.localize(12355,null),type:"string"}}},icon:{type:"string",description:s.localize(12356,null)},l10n:{type:"string",description:s.localize(12357,null)},pricing:{type:"string",markdownDescription:s.localize(12358,null),enum:["Free","Trial"],default:"Free"}}};class u{constructor(){this._extensionPoints=new Map}registerExtensionPoint(t){if(this._extensionPoints.has(t.extensionPoint))throw new Error("Duplicate extension point: "+t.extensionPoint);const n=new o(t.extensionPoint,t.defaultExtensionKind);return this._extensionPoints.set(t.extensionPoint,n),t.activationEventsGenerator&&C.ImplicitActivationEvents.register(t.extensionPoint,t.activationEventsGenerator),e.schema.properties.contributes.properties[t.extensionPoint]=t.jsonSchema,f.registerSchema(p,e.schema),n}getExtensionPoints(){return Array.from(this._extensionPoints.values())}}e.ExtensionsRegistryImpl=u;const i={ExtensionsRegistry:"ExtensionsRegistry"};R.Registry.add(i.ExtensionsRegistry,new u),e.ExtensionsRegistry=R.Registry.as(i.ExtensionsRegistry),f.registerSchema(p,e.schema),f.registerSchema(l.productSchemaId,{properties:{extensionEnabledApiProposals:{description:s.localize(12359,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(_.allApiProposals),markdownEnumDescriptions:Object.values(_.allApiProposals).map(a=>a.proposal)}}]}}}})}),define(Pe[273],ke([1,0,4,40,3,13,7,23,5,11,25,165]),function(ge,e,s,h,D,A,L,R,v,l,C,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageModelsService=e.languageModelExtensionPoint=e.ILanguageModelsService=e.ChatMessageRole=void 0;var f;(function(o){o[o.System=0]="System",o[o.User=1]="User",o[o.Assistant=2]="Assistant"})(f||(e.ChatMessageRole=f={})),e.ILanguageModelsService=(0,v.createDecorator)("ILanguageModelsService");const T={type:"object",properties:{vendor:{type:"string",description:(0,L.localize)(4739,null)}}};e.languageModelExtensionPoint=_.ExtensionsRegistry.registerExtensionPoint({extensionPoint:"languageModels",jsonSchema:{description:(0,L.localize)(4740,null),oneOf:[T,{type:"array",items:T}]},activationEventsGenerator:(o,m)=>{for(const p of o)m.push(`onLanguageModelChat:${p.vendor}`)}});let S=class{constructor(m,p){this._extensionService=m,this._logService=p,this._store=new D.DisposableStore,this._providers=new Map,this._vendors=new Set,this._onDidChangeProviders=this._store.add(new s.Emitter),this.onDidChangeLanguageModels=this._onDidChangeProviders.event,this._store.add(e.languageModelExtensionPoint.setHandler(u=>{this._vendors.clear();for(const a of u){if(!(0,C.isProposedApiEnabled)(a.description,"chatProvider")){a.collector.error((0,L.localize)(4741,null));continue}for(const t of h.Iterable.wrap(a.value)){if(this._vendors.has(t.vendor)){a.collector.error((0,L.localize)(4742,null,t.vendor));continue}if((0,A.isFalsyOrWhitespace)(t.vendor)){a.collector.error((0,L.localize)(4743,null));continue}if(t.vendor.trim()!==t.vendor){a.collector.error((0,L.localize)(4744,null));continue}this._vendors.add(t.vendor)}}const i=[];for(const[a,t]of this._providers)this._vendors.has(t.metadata.vendor)||(this._providers.delete(a),i.push(a));i.length>0&&this._onDidChangeProviders.fire({removed:i})}))}dispose(){this._store.dispose(),this._providers.clear()}getLanguageModelIds(){return Array.from(this._providers.keys())}lookupLanguageModel(m){return this._providers.get(m)?.metadata}async selectLanguageModels(m){if(m.vendor)await this._extensionService.activateByEvent(`onLanguageModelChat:${m.vendor}}`);else{const u=Array.from(this._vendors).map(i=>this._extensionService.activateByEvent(`onLanguageModelChat:${i}`));await Promise.all(u)}const p=[];for(const[u,i]of this._providers)(m.vendor===void 0||i.metadata.vendor===m.vendor)&&(m.family===void 0||i.metadata.family===m.family)&&(m.version===void 0||i.metadata.version===m.version)&&(m.identifier===void 0||i.metadata.id===m.identifier)&&(!i.metadata.targetExtensions||i.metadata.targetExtensions.some(a=>R.ExtensionIdentifier.equals(a,m.extension)))&&p.push(u);return this._logService.trace("[LM] selected language models",m,p),p}registerLanguageModelChat(m,p){if(this._logService.trace("[LM] registering language model chat",m,p.metadata),!this._vendors.has(p.metadata.vendor))throw new Error(`Chat response provider uses UNKNOWN vendor ${p.metadata.vendor}.`);if(this._providers.has(m))throw new Error(`Chat response provider with identifier ${m} is already registered.`);return this._providers.set(m,p),this._onDidChangeProviders.fire({added:[{identifier:m,metadata:p.metadata}]}),(0,D.toDisposable)(()=>{this._providers.delete(m)&&(this._onDidChangeProviders.fire({removed:[m]}),this._logService.trace("[LM] UNregistered language model chat",m,p.metadata))})}async sendChatRequest(m,p,u,i,a){const t=this._providers.get(m);if(!t)throw new Error(`Chat response provider with identifier ${m} is not registered.`);return t.sendChatRequest(u,p,i,a)}computeTokenLength(m,p,u){const i=this._providers.get(m);if(!i)throw new Error(`Chat response provider with identifier ${m} is not registered.`);return i.provideTokenCount(p,u)}};e.LanguageModelsService=S,e.LanguageModelsService=S=Qe([$e(0,C.IExtensionService),$e(1,l.ILogService)],S)}),define(Pe[274],ke([1,0,7,17,24,165,36,4]),function(ge,e,s,h,D,A,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinitionRegistry=void 0,s=We(s),h=We(h),D=We(D);const v={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:s.localize(9876,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:s.localize(9877,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:s.localize(9878,null),default:""}}};var l;(function(f){function T(S,o,m){if(!S)return;const p=h.isString(S.type)?S.type:void 0;if(!p||p.length===0){m.error(s.localize(9879,null));return}const u=[];if(Array.isArray(S.required))for(const i of S.required)h.isString(i)&&u.push(i);return{extensionId:o.value,taskType:p,required:u,properties:S.properties?D.deepClone(S.properties):{},when:S.when?L.ContextKeyExpr.deserialize(S.when):void 0}}f.from=T})(l||(l={}));const C=A.ExtensionsRegistry.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(f,T)=>{for(const S of f)S.type&&T.push(`onTaskType:${S.type}`)},jsonSchema:{description:s.localize(9880,null),type:"array",items:v}});class _{constructor(){this._onDefinitionsChanged=new R.Emitter,this.onDefinitionsChanged=this._onDefinitionsChanged.event,this.taskTypes=Object.create(null),this.readyPromise=new Promise((T,S)=>{C.setHandler((o,m)=>{this._schema=void 0;try{for(const p of m.removed){const u=p.value;for(const i of u)this.taskTypes&&i.type&&this.taskTypes[i.type]&&delete this.taskTypes[i.type]}for(const p of m.added){const u=p.value;for(const i of u){const a=l.from(i,p.description.identifier,p.collector);a&&(this.taskTypes[a.taskType]=a)}}(m.removed.length>0||m.added.length>0)&&this._onDefinitionsChanged.fire()}catch{}T(void 0)})})}onReady(){return this.readyPromise}get(T){return this.taskTypes[T]}all(){return Object.keys(this.taskTypes).map(T=>this.taskTypes[T])}getJsonSchema(){if(this._schema===void 0){const T=[];for(const S of this.all()){const o={type:"object",additionalProperties:!1};S.required.length>0&&(o.required=S.required.slice(0)),S.properties!==void 0?o.properties=D.deepClone(S.properties):o.properties=Object.create(null),o.properties.type={type:"string",enum:[S.taskType]},T.push(o)}this._schema={oneOf:T}}return this._schema}}e.TaskDefinitionRegistry=new _}),define(Pe[275],ke([1,0,7,17,22,24,36,274,46]),function(ge,e,s,h,D,A,L,R,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.TaskSorter=e.JsonSchemaVersion=e.ExecutionEngine=e.InMemoryTask=e.ContributedTask=e.ConfiguringTask=e.CustomTask=e.CommonTask=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.CUSTOMIZED_TASK_TYPE=e.ShellQuoting=e.TASKS_CATEGORY=e.TASK_RUNNING_STATE=e.USER_TASKS_GROUP_KEY=void 0,s=We(s),h=We(h),D=We(D),A=We(A),e.USER_TASKS_GROUP_KEY="settings",e.TASK_RUNNING_STATE=new L.RawContextKey("taskRunning",!1,s.localize(9881,null)),e.TASKS_CATEGORY=s.localize2(9883,"Tasks");var l;(function(F){F[F.Escape=1]="Escape",F[F.Strong=2]="Strong",F[F.Weak=3]="Weak"})(l||(e.ShellQuoting=l={})),e.CUSTOMIZED_TASK_TYPE="$customized",function(F){function x($){if(!$)return F.Strong;switch($.toLowerCase()){case"escape":return F.Escape;case"strong":return F.Strong;case"weak":return F.Weak;default:return F.Strong}}F.from=x}(l||(e.ShellQuoting=l={}));var C;(function(F){F.defaults={cwd:"${workspaceFolder}"}})(C||(e.CommandOptions=C={}));var _;(function(F){F[F.Always=1]="Always",F[F.Silent=2]="Silent",F[F.Never=3]="Never"})(_||(e.RevealKind=_={})),function(F){function x($){switch($.toLowerCase()){case"always":return F.Always;case"silent":return F.Silent;case"never":return F.Never;default:return F.Always}}F.fromString=x}(_||(e.RevealKind=_={}));var f;(function(F){F[F.Never=1]="Never",F[F.OnProblem=2]="OnProblem",F[F.Always=3]="Always"})(f||(e.RevealProblemKind=f={})),function(F){function x($){switch($.toLowerCase()){case"always":return F.Always;case"never":return F.Never;case"onproblem":return F.OnProblem;default:return F.OnProblem}}F.fromString=x}(f||(e.RevealProblemKind=f={}));var T;(function(F){F[F.Shared=1]="Shared",F[F.Dedicated=2]="Dedicated",F[F.New=3]="New"})(T||(e.PanelKind=T={})),function(F){function x($){switch($.toLowerCase()){case"shared":return F.Shared;case"dedicated":return F.Dedicated;case"new":return F.New;default:return F.Shared}}F.fromString=x}(T||(e.PanelKind=T={}));var S;(function(F){F.defaults={echo:!0,reveal:_.Always,revealProblems:f.Never,focus:!1,panel:T.Shared,showReuseMessage:!0,clear:!1}})(S||(e.PresentationOptions=S={}));var o;(function(F){F[F.Shell=1]="Shell",F[F.Process=2]="Process",F[F.CustomExecution=3]="CustomExecution"})(o||(e.RuntimeType=o={})),function(F){function x(G){switch(G.toLowerCase()){case"shell":return F.Shell;case"process":return F.Process;case"customExecution":return F.CustomExecution;default:return F.Process}}F.fromString=x;function $(G){switch(G){case F.Shell:return"shell";case F.Process:return"process";case F.CustomExecution:return"customExecution";default:return"process"}}F.toString=$}(o||(e.RuntimeType=o={}));var m;(function(F){function x($){return h.isString($)?$:$.value}F.value=x})(m||(e.CommandString=m={}));var p;(function(F){F.Clean={_id:"clean",isDefault:!1},F.Build={_id:"build",isDefault:!1},F.Rebuild={_id:"rebuild",isDefault:!1},F.Test={_id:"test",isDefault:!1};function x(G){return G===F.Clean._id||G===F.Build._id||G===F.Rebuild._id||G===F.Test._id}F.is=x;function $(G){if(G!==void 0)return h.isString(G)?x(G)?{_id:G,isDefault:!1}:void 0:G}F.from=$})(p||(e.TaskGroup=p={}));var u;(function(F){F[F.Global=1]="Global",F[F.Workspace=2]="Workspace",F[F.Folder=3]="Folder"})(u||(e.TaskScope=u={}));var i;(function(F){F.Workspace="workspace",F.Extension="extension",F.InMemory="inMemory",F.WorkspaceFile="workspaceFile",F.User="user";function x($){switch($){case F.User:return v.ConfigurationTarget.USER;case F.WorkspaceFile:return v.ConfigurationTarget.WORKSPACE;default:return v.ConfigurationTarget.WORKSPACE_FOLDER}}F.toConfigurationTarget=x})(i||(e.TaskSourceKind=i={}));var a;(function(F){F.parallel="parallel",F.sequence="sequence"})(a||(e.DependsOrder=a={}));var t;(function(F){F[F.default=1]="default",F[F.folderOpen=2]="folderOpen"})(t||(e.RunOnOptions=t={}));var n;(function(F){F.defaults={reevaluateOnRerun:!0,runOn:t.default,instanceLimit:1}})(n||(e.RunOptions=n={}));class r{constructor(x,$,G,B,W,Z){this._label="",this._id=x,$&&(this._label=$),G&&(this.type=G),this.runOptions=B,this.configurationProperties=W,this._source=Z}getDefinition(x){}getMapKey(){return this._id}getKey(){}getCommonTaskId(){const x={folder:this.getFolderId(),id:this._id};return JSON.stringify(x)}clone(){return this.fromObject(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(x,$=!1){if(x===void 0)return!1;if(h.isString(x))return x===this._label||x===this.configurationProperties.identifier||$&&x===this._id;const G=this.getDefinition(!0);return G!==void 0&&G._key===x._key}getQualifiedLabel(){const x=this.getWorkspaceFolder();return x?`${this._label} (${x.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(x){this._taskLoadMessages===void 0&&(this._taskLoadMessages=[]),x&&(this._taskLoadMessages=this._taskLoadMessages.concat(x))}get taskLoadMessages(){return this._taskLoadMessages}}e.CommonTask=r;class d extends r{constructor(x,$,G,B,W,Z,J,oe){super(x,G,void 0,J,oe,$),this.command={},this._source=$,this.hasDefinedMatchers=Z,W&&(this.command=W)}clone(){return new d(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(x=!1){if(x&&this._source.customizes!==void 0)return this._source.customizes;{let $;switch(this.command?this.command.runtime:void 0){case o.Shell:$="shell";break;case o.Process:$="process";break;case o.CustomExecution:$="customExecution";break;case void 0:$="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:$,_key:this._id,id:this._id}}}static is(x){return x instanceof d}getMapKey(){const x=this._source.config.workspaceFolder;return x?`${x.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}getFolderId(){return this._source.kind===i.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getKey()??super.getCommonTaskId()}getKey(){const x=this.getFolderId();if(!x)return;let $=this.configurationProperties.identifier;this._source.kind!==i.Workspace&&($+=this._source.kind);const G={type:e.CUSTOMIZED_TASK_TYPE,folder:x,id:$};return JSON.stringify(G)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?D.basename(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}fromObject(x){return new d(x._id,x._source,x._label,x.type,x.command,x.hasDefinedMatchers,x.runOptions,x.configurationProperties)}}e.CustomTask=d;class c extends r{constructor(x,$,G,B,W,Z,J){super(x,G,B,Z,J,$),this._source=$,this.configures=W}static is(x){return x instanceof c}fromObject(x){return x}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?D.basename(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}getFolderId(){return this._source.kind===i.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getKey(){const x=this.getFolderId();if(!x)return;let $=this.configurationProperties.identifier;this._source.kind!==i.Workspace&&($+=this._source.kind);const G={type:e.CUSTOMIZED_TASK_TYPE,folder:x,id:$};return JSON.stringify(G)}}e.ConfiguringTask=c;class g extends r{constructor(x,$,G,B,W,Z,J,oe,te){super(x,G,B,oe,te,$),this.defines=W,this.hasDefinedMatchers=J,this.command=Z,this.icon=te.icon,this.hide=te.hide}clone(){return new g(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(x){return x instanceof g}getMapKey(){const x=this._source.workspaceFolder;return x?`${this._source.scope.toString()}|${x.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}getFolderId(){if(this._source.scope===u.Folder&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getKey(){const x={type:"contributed",scope:this._source.scope,id:this._id};return x.folder=this.getFolderId(),JSON.stringify(x)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}fromObject(x){return new g(x._id,x._source,x._label,x.type,x.defines,x.command,x.hasDefinedMatchers,x.runOptions,x.configurationProperties)}}e.ContributedTask=g;class w extends r{constructor(x,$,G,B,W,Z){super(x,G,B,W,Z,$),this._source=$}clone(){return new w(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(x){return x instanceof w}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}getFolderId(){}fromObject(x){return new w(x._id,x._source,x._label,x.type,x.runOptions,x.configurationProperties)}}e.InMemoryTask=w;var y;(function(F){F[F.Process=1]="Process",F[F.Terminal=2]="Terminal"})(y||(e.ExecutionEngine=y={})),function(F){F._default=F.Terminal}(y||(e.ExecutionEngine=y={}));var I;(function(F){F[F.V0_1_0=1]="V0_1_0",F[F.V2_0_0=2]="V2_0_0"})(I||(e.JsonSchemaVersion=I={}));class P{constructor(x){this._order=new Map;for(let $=0;$<x.length;$++)this._order.set(x[$].uri.toString(),$)}compare(x,$){const G=x.getWorkspaceFolder(),B=$.getWorkspaceFolder();if(G&&B){let W=this._order.get(G.uri.toString());W=W===void 0?0:W+1;let Z=this._order.get(B.uri.toString());return Z=Z===void 0?0:Z+1,W===Z?x._label.localeCompare($._label):W-Z}else return!G&&B?-1:G&&!B?1:0}}e.TaskSorter=P;var k;(function(F){F.DependsOnStarted="dependsOnStarted",F.AcquiredInput="acquiredInput",F.Start="start",F.ProcessStarted="processStarted",F.Active="active",F.Inactive="inactive",F.Changed="changed",F.Terminated="terminated",F.ProcessEnded="processEnded",F.End="end"})(k||(e.TaskEventKind=k={}));var b;(function(F){F.SingleRun="singleRun",F.Background="background"})(b||(e.TaskRunType=b={}));var E;(function(F){F[F.System=0]="System",F[F.User=1]="User",F[F.FolderOpen=2]="FolderOpen",F[F.ConfigurationChange=3]="ConfigurationChange",F[F.Reconnect=4]="Reconnect"})(E||(e.TaskRunSource=E={}));var N;(function(F){function x(oe){return{taskId:oe._id,taskName:oe.configurationProperties.name,runType:oe.configurationProperties.isBackground?b.Background:b.SingleRun,group:oe.configurationProperties.group,__task:oe}}function $(oe,te,me){return{...x(oe),kind:k.Start,terminalId:te,resolvedVariables:me}}F.start=$;function G(oe,te,me){return{...x(oe),kind:k.ProcessStarted,terminalId:te,processId:me}}F.processStarted=G;function B(oe,te,me){return{...x(oe),kind:k.ProcessEnded,terminalId:te,exitCode:me}}F.processEnded=B;function W(oe,te,me){return{...x(oe),kind:k.Terminated,exitReason:me,terminalId:te}}F.terminated=W;function Z(oe,te,me){return{...x(te),kind:oe,terminalId:me}}F.general=Z;function J(){return{kind:k.Changed}}F.changed=J})(N||(e.TaskEvent=N={}));var O;(function(F){function x(G){const B=Object.keys(G).sort();let W="";for(const Z of B){let J=G[Z];J instanceof Object?J=x(J):typeof J=="string"&&(J=J.replace(/,/g,",,")),W+=Z+","+J+","}return W}function $(G){const W={_key:x(G),type:G.taskType};return Object.assign(W,G),W}F.create=$})(O||(e.KeyedTaskIdentifier=O={}));var M;(function(F){F.AutoDetect="task.autoDetect",F.SaveBeforeRun="task.saveBeforeRun",F.ShowDecorations="task.showDecorations",F.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",F.SlowProviderWarning="task.slowProviderWarning",F.QuickOpenHistory="task.quickOpen.history",F.QuickOpenDetail="task.quickOpen.detail",F.QuickOpenSkip="task.quickOpen.skip",F.QuickOpenShowAll="task.quickOpen.showAll",F.AllowAutomaticTasks="task.allowAutomaticTasks",F.Reconnection="task.reconnection",F.VerboseLogging="task.verboseLogging"})(M||(e.TaskSettingId=M={}));var U;(function(F){F.Tasks="tasks",F.SuppressTaskName="tasks.suppressTaskName",F.Windows="tasks.windows",F.Osx="tasks.osx",F.Linux="tasks.linux",F.ShowOutput="tasks.showOutput",F.IsShellCommand="tasks.isShellCommand",F.ServiceTestSetting="tasks.service.testSetting"})(U||(e.TasksSchemaProperties=U={}));var H;(function(F){function x($,G){const B=R.TaskDefinitionRegistry.get($.type);if(B===void 0){const oe=A.deepClone($);return delete oe._key,O.create(oe)}const W=Object.create(null);W.type=B.taskType;const Z=new Set;B.required.forEach(oe=>Z.add(oe));const J=B.properties;for(const oe of Object.keys(J)){const te=$[oe];if(te!=null)W[oe]=te;else if(Z.has(oe)){const me=J[oe];if(me.default!==void 0)W[oe]=A.deepClone(me.default);else switch(me.type){case"boolean":W[oe]=!1;break;case"number":case"integer":W[oe]=0;break;case"string":W[oe]="";break;default:G.error(s.localize(9882,null,JSON.stringify($,void 0,0),oe));return}}}return O.create(W)}F.createTaskIdentifier=x})(H||(e.TaskDefinition=H={}))}),define(Pe[276],ke([1,0,12]),function(ge,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CanceledLazyPromise=e.LazyPromise=void 0;class h{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((L,R)=>{this._actualOk=L,this._actualErr=R,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(L){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=L,this._actual&&this._actualOk(L))}resolveErr(L){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=L,this._actual?this._actualErr(L):(0,s.onUnexpectedError)(L))}then(L,R){return this._ensureActual().then(L,R)}catch(L){return this._ensureActual().then(void 0,L)}finally(L){return this._ensureActual().finally(L)}}e.LazyPromise=h;class D extends h{constructor(){super(),this._hasErr=!0,this._err=new s.CancellationError}}e.CanceledLazyPromise=D}),define(Pe[53],ke([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.ProxyIdentifier=void 0,e.createProxyIdentifier=D,e.getStringIdentifierForProxy=A;class s{static{this.count=0}constructor(v){this._proxyIdentifierBrand=void 0,this.sid=v,this.nid=++s.count}}e.ProxyIdentifier=s;const h=[];function D(R){const v=new s(R);return h[v.nid]=v,v}function A(R){return h[R].sid}class L{constructor(v){this.value=v}}e.SerializableObjectWithBuffers=L}),define(Pe[6],ke([1,0,53]),function(ge,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var h;(function(o){o[o.Default=0]="Default",o[o.InCenter=1]="InCenter",o[o.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",o[o.AtTop=3]="AtTop"})(h||(e.TextEditorRevealType=h={}));var D;(function(o){o[o.UnknownInput=0]="UnknownInput",o[o.TextInput=1]="TextInput",o[o.TextDiffInput=2]="TextDiffInput",o[o.TextMergeInput=3]="TextMergeInput",o[o.NotebookInput=4]="NotebookInput",o[o.NotebookDiffInput=5]="NotebookDiffInput",o[o.CustomEditorInput=6]="CustomEditorInput",o[o.WebviewEditorInput=7]="WebviewEditorInput",o[o.TerminalEditorInput=8]="TerminalEditorInput",o[o.InteractiveEditorInput=9]="InteractiveEditorInput",o[o.ChatEditorInput=10]="ChatEditorInput",o[o.MultiDiffEditorInput=11]="MultiDiffEditorInput"})(D||(e.TabInputKind=D={}));var A;(function(o){o[o.TAB_OPEN=0]="TAB_OPEN",o[o.TAB_CLOSE=1]="TAB_CLOSE",o[o.TAB_UPDATE=2]="TAB_UPDATE",o[o.TAB_MOVE=3]="TAB_MOVE"})(A||(e.TabModelOperationKind=A={}));var L;(function(o){o[o.Editable=0]="Editable",o[o.SupportsHotExit=1]="SupportsHotExit"})(L||(e.WebviewEditorCapabilities=L={}));var R;(function(o){o[o.Int8Array=1]="Int8Array",o[o.Uint8Array=2]="Uint8Array",o[o.Uint8ClampedArray=3]="Uint8ClampedArray",o[o.Int16Array=4]="Int16Array",o[o.Uint16Array=5]="Uint16Array",o[o.Int32Array=6]="Int32Array",o[o.Uint32Array=7]="Uint32Array",o[o.Float32Array=8]="Float32Array",o[o.Float64Array=9]="Float64Array",o[o.BigInt64Array=10]="BigInt64Array",o[o.BigUint64Array=11]="BigUint64Array"})(R||(e.WebviewMessageArrayBufferViewType=R={}));var v;(function(o){o[o.Text=1]="Text",o[o.Error=2]="Error",o[o.Rich=3]="Rich"})(v||(e.CellOutputKind=v={}));var l;(function(o){o[o.Default=0]="Default",o[o.InCenter=1]="InCenter",o[o.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",o[o.AtTop=3]="AtTop"})(l||(e.NotebookEditorRevealType=l={}));var C;(function(o){o[o.None=0]="None",o[o.Process=1]="Process",o[o.Output=2]="Output",o[o.Hybrid=3]="Hybrid"})(C||(e.CandidatePortSource=C={}));class _{static{this._n=0}static mixin(m){return m._id=_._n++,m}}e.IdObject=_;var f;(function(o){o.label="a",o.kind="b",o.detail="c",o.documentation="d",o.sortText="e",o.filterText="f",o.preselect="g",o.insertText="h",o.insertTextRules="i",o.range="j",o.commitCharacters="k",o.additionalTextEdits="l",o.kindModifier="m",o.commandIdent="n",o.commandId="o",o.commandArguments="p"})(f||(e.ISuggestDataDtoField=f={}));var T;(function(o){o.defaultRanges="a",o.completions="b",o.isIncomplete="c",o.duration="d"})(T||(e.ISuggestResultDtoField=T={}));var S;(function(o){o[o.Workspace=0]="Workspace",o[o.TextDocument=1]="TextDocument"})(S||(e.ExtHostTestingResource=S={})),e.MainContext={MainThreadAuthentication:(0,s.createProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,s.createProxyIdentifier)("MainThreadBulkEdits"),MainThreadLanguageModels:(0,s.createProxyIdentifier)("MainThreadLanguageModels"),MainThreadEmbeddings:(0,s.createProxyIdentifier)("MainThreadEmbeddings"),MainThreadChatAgents2:(0,s.createProxyIdentifier)("MainThreadChatAgents2"),MainThreadChatVariables:(0,s.createProxyIdentifier)("MainThreadChatVariables"),MainThreadLanguageModelTools:(0,s.createProxyIdentifier)("MainThreadChatSkills"),MainThreadClipboard:(0,s.createProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,s.createProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,s.createProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,s.createProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,s.createProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,s.createProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,s.createProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,s.createProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,s.createProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,s.createProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,s.createProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,s.createProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,s.createProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,s.createProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,s.createProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,s.createProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,s.createProxyIdentifier)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,s.createProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,s.createProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,s.createProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,s.createProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,s.createProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,s.createProxyIdentifier)("MainThreadProgress"),MainThreadQuickDiff:(0,s.createProxyIdentifier)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,s.createProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,s.createProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,s.createProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,s.createProxyIdentifier)("MainThreadStorage"),MainThreadSpeech:(0,s.createProxyIdentifier)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,s.createProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,s.createProxyIdentifier)("MainThreadTerminalService"),MainThreadTerminalShellIntegration:(0,s.createProxyIdentifier)("MainThreadTerminalShellIntegration"),MainThreadWebviews:(0,s.createProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,s.createProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,s.createProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,s.createProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,s.createProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,s.createProxyIdentifier)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,s.createProxyIdentifier)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,s.createProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,s.createProxyIdentifier)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,s.createProxyIdentifier)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,s.createProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,s.createProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,s.createProxyIdentifier)("MainThreadSearch"),MainThreadShare:(0,s.createProxyIdentifier)("MainThreadShare"),MainThreadTask:(0,s.createProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,s.createProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,s.createProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,s.createProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,s.createProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,s.createProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,s.createProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,s.createProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,s.createProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,s.createProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,s.createProxyIdentifier)("MainThreadTunnelService"),MainThreadManagedSockets:(0,s.createProxyIdentifier)("MainThreadManagedSockets"),MainThreadTimeline:(0,s.createProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,s.createProxyIdentifier)("MainThreadTesting"),MainThreadLocalization:(0,s.createProxyIdentifier)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,s.createProxyIdentifier)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,s.createProxyIdentifier)("MainThreadAiEmbeddingVector")},e.ExtHostContext={ExtHostCommands:(0,s.createProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,s.createProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,s.createProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,s.createProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,s.createProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,s.createProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,s.createProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,s.createProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,s.createProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,s.createProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,s.createProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,s.createProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,s.createProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,s.createProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,s.createProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,s.createProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,s.createProxyIdentifier)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,s.createProxyIdentifier)("ExtHostQuickDiff"),ExtHostStatusBar:(0,s.createProxyIdentifier)("ExtHostStatusBar"),ExtHostShare:(0,s.createProxyIdentifier)("ExtHostShare"),ExtHostExtensionService:(0,s.createProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,s.createProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,s.createProxyIdentifier)("ExtHostTerminalService"),ExtHostTerminalShellIntegration:(0,s.createProxyIdentifier)("ExtHostTerminalShellIntegration"),ExtHostSCM:(0,s.createProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,s.createProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,s.createProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,s.createProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,s.createProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,s.createProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,s.createProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,s.createProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,s.createProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,s.createProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,s.createProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,s.createProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,s.createProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,s.createProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,s.createProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,s.createProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,s.createProxyIdentifier)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,s.createProxyIdentifier)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,s.createProxyIdentifier)("ExtHostOutputService"),ExtHostLabelService:(0,s.createProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,s.createProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,s.createProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,s.createProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,s.createProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,s.createProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,s.createProxyIdentifier)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,s.createProxyIdentifier)("ExtHostInteractive"),ExtHostChatAgents2:(0,s.createProxyIdentifier)("ExtHostChatAgents"),ExtHostChatVariables:(0,s.createProxyIdentifier)("ExtHostChatVariables"),ExtHostLanguageModelTools:(0,s.createProxyIdentifier)("ExtHostChatSkills"),ExtHostChatProvider:(0,s.createProxyIdentifier)("ExtHostChatProvider"),ExtHostSpeech:(0,s.createProxyIdentifier)("ExtHostSpeech"),ExtHostEmbeddings:(0,s.createProxyIdentifier)("ExtHostEmbeddings"),ExtHostAiRelatedInformation:(0,s.createProxyIdentifier)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,s.createProxyIdentifier)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,s.createProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,s.createProxyIdentifier)("ExtHostTunnelService"),ExtHostManagedSockets:(0,s.createProxyIdentifier)("ExtHostManagedSockets"),ExtHostAuthentication:(0,s.createProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,s.createProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,s.createProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,s.createProxyIdentifier)("ExtHostTelemetry"),ExtHostLocalization:(0,s.createProxyIdentifier)("ExtHostLocalization")}}),define(Pe[96],ke([1,0,5,11,6,19]),function(ge,e,s,h,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,D=We(D),e.IExtHostApiDeprecationService=(0,s.createDecorator)("IExtHostApiDeprecationService");let L=class{constructor(v,l){this._extHostLogService=l,this._reportedUsages=new Set,this._telemetryShape=v.getProxy(D.MainContext.MainThreadTelemetry)}report(v,l,C){const _=this.getUsageKey(v,l);this._reportedUsages.has(_)||(this._reportedUsages.add(_),l.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${v}' is deprecated. ${C}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:l.identifier.value,apiId:v}))}getUsageKey(v,l){return`${v}-${l.identifier.value}`}};e.ExtHostApiDeprecationService=L,e.ExtHostApiDeprecationService=L=Qe([$e(0,A.IExtHostRpcService),$e(1,h.ILogService)],L),e.NullApiDeprecationService=Object.freeze(new class{report(R,v,l){}})}),define(Pe[277],ke([1,0,6]),function(ge,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class h{constructor(A){const L=A.getProxy(s.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return L.$readText()},writeText(R){return L.$writeText(R)}})}}e.ExtHostClipboard=h}),define(Pe[278],ke([1,0,24,6,29,19]),function(ge,e,s,h,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtHostConsoleForwarder=void 0;let L=class{constructor(C,_){this._mainThreadConsole=C.getProxy(h.MainContext.MainThreadConsole),this._includeStack=_.consoleForward.includeStack,this._logNative=_.consoleForward.logNative,this._wrapConsoleMethod("info","log"),this._wrapConsoleMethod("log","log"),this._wrapConsoleMethod("warn","warn"),this._wrapConsoleMethod("debug","debug"),this._wrapConsoleMethod("error","error")}_wrapConsoleMethod(C,_){const f=this,T=console[C];Object.defineProperty(console,C,{set:()=>{},get:()=>function(){f._handleConsoleCall(C,_,T,arguments)}})}_handleConsoleCall(C,_,f,T){this._mainThreadConsole.$logExtensionHostMessage({type:"__$console",severity:_,arguments:v(T,this._includeStack)}),this._logNative&&this._nativeConsoleLogMessage(C,f,T)}};e.AbstractExtHostConsoleForwarder=L,e.AbstractExtHostConsoleForwarder=L=Qe([$e(0,A.IExtHostRpcService),$e(1,D.IExtHostInitDataService)],L);const R=1e5;function v(l,C){const _=[];if(l.length)for(let f=0;f<l.length;f++){let T=l[f];if(typeof T>"u")T="undefined";else if(T instanceof Error){const S=T;S.stack?T=S.stack:T=S.toString()}_.push(T)}if(C){const f=new Error().stack;f&&_.push({__$stack:f.split(`
`).slice(3).join(`
`)})}try{const f=(0,s.safeStringify)(_);return f.length>R?"Output omitted for a large object that exceeds the limits":f}catch(f){return`Output omitted for an object that cannot be inspected ('${f.toString()}')`}}}),define(Pe[279],ke([1,0,2,6,25]),function(ge,e,s,h,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class A{constructor(R){this._proxy=R.getProxy(h.MainContext.MainThreadDialogs)}showOpenDialog(R,v){return v?.allowUIResources&&(0,D.checkProposedApiEnabled)(R,"showLocal"),this._proxy.$showOpenDialog(v).then(l=>l?l.map(C=>s.URI.revive(C)):void 0)}showSaveDialog(R){return this._proxy.$showSaveDialog(R).then(v=>v?s.URI.revive(v):void 0)}}e.ExtHostDialogs=A}),define(Pe[280],ke([1,0,20,4,3,6]),function(ge,e,s,h,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEmbeddings=void 0;class L{constructor(v){this._provider=new Map,this._onDidChange=new h.Emitter,this.onDidChange=this._onDidChange.event,this._allKnownModels=new Set,this._handlePool=0,this._proxy=v.getProxy(A.MainContext.MainThreadEmbeddings)}registerEmbeddingsProvider(v,l,C){if(this._allKnownModels.has(l))throw new Error("An embeddings provider for this model is already registered");const _=this._handlePool++;return this._proxy.$registerEmbeddingProvider(_,l),this._provider.set(_,{id:l,provider:C}),(0,D.toDisposable)(()=>{this._allKnownModels.delete(l),this._proxy.$unregisterEmbeddingProvider(_),this._provider.delete(_)})}async computeEmbeddings(v,l,C){C??=s.CancellationToken.None;let _=!1;typeof l=="string"&&(l=[l],_=!0);const f=await this._proxy.$computeEmbeddings(v,l,C);if(f.length!==l.length)throw new Error;if(_){if(f.length!==1)throw new Error;return f[0]}return f}async $provideEmbeddings(v,l,C){const _=this._provider.get(v);if(!_)return[];const f=await _.provider.provideEmbeddings(l,C);return f||[]}get embeddingsModels(){return Array.from(this._allKnownModels)}$acceptEmbeddingModels(v){this._allKnownModels=new Set(v),this._onDidChange.fire()}}e.ExtHostEmbeddings=L}),define(Pe[281],ke([1,0,3,6]),function(ge,e,s,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class D{constructor(L){this._handlePool=0,this._proxy=L.getProxy(h.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(L){const R=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(R,L),(0,s.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(R)})}}e.ExtHostLabelService=D}),define(Pe[122],ke([1,0,10,13,2,5,11,6,29,19]),function(ge,e,s,h,D,A,L,R,v,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostLocalizationService=e.ExtHostLocalizationService=void 0;let C=class{constructor(f,T,S){this.logService=S,this.bundleCache=new Map,this._proxy=T.getProxy(R.MainContext.MainThreadLocalization),this.currentLanguage=f.environment.appLanguage,this.isDefaultLanguage=this.currentLanguage===s.LANGUAGE_DEFAULT}getMessage(f,T){const{message:S,args:o,comment:m}=T;if(this.isDefaultLanguage)return(0,h.format2)(S,o??{});let p=S;m&&m.length>0&&(p+=`/${Array.isArray(m)?m.join(""):m}`);const u=this.bundleCache.get(f)?.contents[p];return u||this.logService.warn(`Using default string since no string found in i18n bundle that has the key: ${p}`),(0,h.format2)(u??S,o??{})}getBundle(f){return this.bundleCache.get(f)?.contents}getBundleUri(f){return this.bundleCache.get(f)?.uri}async initializeLocalizedMessages(f){if(this.isDefaultLanguage||!f.l10n&&!f.isBuiltin||this.bundleCache.has(f.identifier.value))return;let T;const S=await this.getBundleLocation(f);if(!S){this.logService.error(`No bundle location found for extension ${f.identifier.value}`);return}try{const o=await this._proxy.$fetchBundleContents(S),m=JSON.parse(o);T=f.isBuiltin?m.contents?.bundle:m}catch(o){this.logService.error(`Failed to load translations for ${f.identifier.value} from ${S}: ${o.message}`);return}T&&this.bundleCache.set(f.identifier.value,{contents:T,uri:S})}async getBundleLocation(f){if(f.isBuiltin){const T=await this._proxy.$fetchBuiltInBundleUri(f.identifier.value,this.currentLanguage);return D.URI.revive(T)}return f.l10n?D.URI.joinPath(f.extensionLocation,f.l10n,`bundle.l10n.${this.currentLanguage}.json`):void 0}};e.ExtHostLocalizationService=C,e.ExtHostLocalizationService=C=Qe([$e(0,v.IExtHostInitDataService),$e(1,l.IExtHostRpcService),$e(2,L.ILogService)],C),e.IExtHostLocalizationService=(0,A.createDecorator)("IExtHostLocalizationService")}),define(Pe[166],ke([1,0,11,6,29,19,2,38]),function(ge,e,s,h,D,A,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;let v=class extends s.AbstractLoggerService{constructor(_,f){super(f.logLevel,f.logsLocation,f.loggers.map(T=>(0,R.revive)(T))),this._proxy=_.getProxy(h.MainContext.MainThreadLogger)}$setLogLevel(_,f){f?this.setLogLevel(L.URI.revive(f),_):this.setLogLevel(_)}setVisibility(_,f){super.setVisibility(_,f),this._proxy.$setVisibility(_,f)}doCreateLogger(_,f,T){return new l(this._proxy,_,f,T)}};e.ExtHostLoggerService=v,e.ExtHostLoggerService=v=Qe([$e(0,A.IExtHostRpcService),$e(1,D.IExtHostInitDataService)],v);class l extends s.AbstractMessageLogger{constructor(_,f,T,S){super(S?.logLevel==="always"),this.proxy=_,this.file=f,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(T),this.proxy.$createLogger(f,S).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(_,f){const T=[[_,f]];this.isLoggerCreated?this.doLog(T):this.buffer.push(...T)}doLog(_){this.proxy.$log(this.file,_)}flush(){this.proxy.$flush(this.file)}}}),define(Pe[123],ke([1,0,6,5,3,19,21]),function(ge,e,s,h,D,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostManagedSockets=e.IExtHostManagedSockets=void 0,e.IExtHostManagedSockets=(0,h.createDecorator)("IExtHostManagedSockets");let R=class{constructor(_){this._remoteSocketIdCounter=0,this._factory=null,this._managedRemoteSockets=new Map,this._proxy=_.getProxy(s.MainContext.MainThreadManagedSockets)}setFactory(_,f){for(const T of this._managedRemoteSockets.values())T.dispose();this._factory&&this._proxy.$unregisterSocketFactory(this._factory.socketFactoryId),this._factory=new v(_,f),this._proxy.$registerSocketFactory(this._factory.socketFactoryId)}async $openRemoteSocket(_){if(!this._factory||this._factory.socketFactoryId!==_)throw new Error(`No socket factory with id ${_}`);const f=++this._remoteSocketIdCounter,T=await this._factory.makeConnection(),S=new D.DisposableStore;return this._managedRemoteSockets.set(f,new l(f,T,S)),S.add((0,D.toDisposable)(()=>this._managedRemoteSockets.delete(f))),S.add(T.onDidEnd(()=>{this._proxy.$onDidManagedSocketEnd(f),S.dispose()})),S.add(T.onDidClose(o=>{this._proxy.$onDidManagedSocketClose(f,o?.stack??o?.message),S.dispose()})),S.add(T.onDidReceiveMessage(o=>this._proxy.$onDidManagedSocketHaveData(f,L.VSBuffer.wrap(o)))),f}$remoteSocketWrite(_,f){this._managedRemoteSockets.get(_)?.actual.send(f.buffer)}$remoteSocketEnd(_){const f=this._managedRemoteSockets.get(_);f&&(f.actual.end(),f.dispose())}async $remoteSocketDrain(_){await this._managedRemoteSockets.get(_)?.actual.drain?.()}};e.ExtHostManagedSockets=R,e.ExtHostManagedSockets=R=Qe([$e(0,A.IExtHostRpcService)],R);class v{constructor(_,f){this.socketFactoryId=_,this.makeConnection=f}}class l extends D.Disposable{constructor(_,f,T){super(),this.socketId=_,this.actual=f,this._register(T)}}}),define(Pe[282],ke([1,0,6,11,25]),function(ge,e,s,h,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function A(R){return R&&R.title}let L=class{constructor(v,l){this._logService=l,this._proxy=v.getProxy(s.MainContext.MainThreadMessageService)}showMessage(v,l,C,_,f){const T={source:{identifier:v.identifier,label:v.displayName||v.name}};let S;typeof _=="string"||A(_)?S=[_,...f]:(T.modal=_?.modal,T.useCustom=_?.useCustom,T.detail=_?.detail,S=f),T.useCustom&&(0,D.checkProposedApiEnabled)(v,"resolvers");const o=[];let m=!1;for(let p=0;p<S.length;p++){const u=S[p];if(typeof u=="string")o.push({title:u,handle:p,isCloseAffordance:!1});else if(typeof u=="object"){const{title:i,isCloseAffordance:a}=u;o.push({title:i,isCloseAffordance:!!a,handle:p}),a&&(m?this._logService.warn(`[${v.identifier}] Only one message item can have 'isCloseAffordance':`,u):m=!0)}else this._logService.warn(`[${v.identifier}] Invalid message item:`,u)}return this._proxy.$showMessage(l,C,T,o).then(p=>{if(typeof p=="number")return S[p]})}};e.ExtHostMessageService=L,e.ExtHostMessageService=L=Qe([$e(1,h.ILogService)],L)}),define(Pe[283],ke([1,0,3,17,2,25,6]),function(ge,e,s,h,D,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProfileContentHandlers=void 0;class R{constructor(l){this.handlers=new Map,this.proxy=l.getProxy(L.MainContext.MainThreadProfileContentHandlers)}registerProfileContentHandler(l,C,_){if((0,A.checkProposedApiEnabled)(l,"profileContentHandlers"),this.handlers.has(C))throw new Error(`Handler with id '${C}' already registered`);return this.handlers.set(C,_),this.proxy.$registerProfileContentHandler(C,_.name,_.description,l.identifier.value),(0,s.toDisposable)(()=>{this.handlers.delete(C),this.proxy.$unregisterProfileContentHandler(C)})}async $saveProfile(l,C,_,f){const T=this.handlers.get(l);if(!T)throw new Error(`Unknown handler with id: ${l}`);return T.saveProfile(C,_,f)}async $readProfile(l,C,_){const f=this.handlers.get(l);if(!f)throw new Error(`Unknown handler with id: ${l}`);return f.readProfile((0,h.isString)(C)?C:D.URI.revive(C),_)}}e.ExtHostProfileContentHandlers=R}),define(Pe[124],ke([1,0,6,4,5]),function(ge,e,s,h,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class A{constructor(R){this._onDidChangePassword=new h.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=R.getProxy(s.MainContext.MainThreadSecretState)}async $onDidChangePassword(R){this._onDidChangePassword.fire(R)}get(R,v){return this._proxy.$getPassword(R,v)}store(R,v,l){return this._proxy.$setPassword(R,v,l)}delete(R,v){return this._proxy.$deletePassword(R,v)}}e.ExtHostSecretState=A,e.IExtHostSecretState=(0,D.createDecorator)("IExtHostSecretState")}),define(Pe[284],ke([1,0,20,3,6]),function(ge,e,s,h,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSpeech=void 0;class A{static{this.ID_POOL=1}constructor(R){this.providers=new Map,this.sessions=new Map,this.synthesizers=new Map,this.proxy=R.getProxy(D.MainContext.MainThreadSpeech)}async $createSpeechToTextSession(R,v,l){const C=this.providers.get(R);if(!C)return;const _=new h.DisposableStore,f=new s.CancellationTokenSource;this.sessions.set(v,f);const T=await C.provideSpeechToTextSession(f.token,l?{language:l}:void 0);T&&(_.add(T.onDidChange(S=>{f.token.isCancellationRequested||this.proxy.$emitSpeechToTextEvent(v,S)})),_.add(f.token.onCancellationRequested(()=>_.dispose())))}async $cancelSpeechToTextSession(R){this.sessions.get(R)?.dispose(!0),this.sessions.delete(R)}async $createTextToSpeechSession(R,v,l){const C=this.providers.get(R);if(!C)return;const _=new h.DisposableStore,f=new s.CancellationTokenSource;this.sessions.set(v,f);const T=await C.provideTextToSpeechSession(f.token,l?{language:l}:void 0);T&&(this.synthesizers.set(v,T),_.add(T.onDidChange(S=>{f.token.isCancellationRequested||this.proxy.$emitTextToSpeechEvent(v,S)})),_.add(f.token.onCancellationRequested(()=>_.dispose())))}async $synthesizeSpeech(R,v){this.synthesizers.get(R)?.synthesize(v)}async $cancelTextToSpeechSession(R){this.sessions.get(R)?.dispose(!0),this.sessions.delete(R),this.synthesizers.delete(R)}async $createKeywordRecognitionSession(R,v){const l=this.providers.get(R);if(!l)return;const C=new h.DisposableStore,_=new s.CancellationTokenSource;this.sessions.set(v,_);const f=await l.provideKeywordRecognitionSession(_.token);f&&(C.add(f.onDidChange(T=>{_.token.isCancellationRequested||this.proxy.$emitKeywordRecognitionEvent(v,T)})),C.add(_.token.onCancellationRequested(()=>C.dispose())))}async $cancelKeywordRecognitionSession(R){this.sessions.get(R)?.dispose(!0),this.sessions.delete(R)}registerProvider(R,v,l){const C=A.ID_POOL++;return this.providers.set(C,l),this.proxy.$registerProvider(C,v,{extension:R,displayName:R.value}),(0,h.toDisposable)(()=>{this.proxy.$unregisterProvider(C),this.providers.delete(C)})}}e.ExtHostSpeech=A}),define(Pe[125],ke([1,0,6,4,5]),function(ge,e,s,h,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class A{constructor(R,v){this._logService=v,this._onDidChangeStorage=new h.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=R.getProxy(s.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(R,v){this._proxy.$registerExtensionStorageKeysToSync(R,v)}async initializeExtensionStorage(R,v,l){const C=await this._proxy.$initializeExtensionStorage(R,v);let _;return C&&(_=this.safeParseValue(R,v,C)),_||l}setValue(R,v,l){return this._proxy.$setValue(R,v,l)}$acceptValue(R,v,l){const C=this.safeParseValue(R,v,l);C&&this._onDidChangeStorage.fire({shared:R,key:v,value:C})}safeParseValue(R,v,l){try{return JSON.parse(l)}catch(C){this._logService.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${v}, global: ${R}): ${C}`)}}}e.ExtHostStorage=A,e.IExtHostStorage=(0,D.createDecorator)("IExtHostStorage")}),define(Pe[285],ke([1,0,3,14,2,6]),function(ge,e,s,h,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class L{static{this.supportedSchemes=new Set([h.Schemas.http,h.Schemas.https])}constructor(v){this._openers=new Map,this._proxy=v.getProxy(A.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(v,l,C,_){if(this._openers.has(l))throw new Error(`Opener with id '${l}' already registered`);const f=_.schemes.find(T=>!L.supportedSchemes.has(T));if(f)throw new Error(`Scheme '${f}' is not supported. Only http and https are currently supported.`);return this._openers.set(l,C),this._proxy.$registerUriOpener(l,_.schemes,v,_.label),(0,s.toDisposable)(()=>{this._openers.delete(l),this._proxy.$unregisterUriOpener(l)})}async $canOpenUri(v,l,C){const _=this._openers.get(v);if(!_)throw new Error(`Unknown opener with id: ${v}`);const f=D.URI.revive(l);return _.canOpenExternalUri(f,C)}async $openUri(v,l,C){const _=this._openers.get(v);if(!_)throw new Error(`Unknown opener id: '${v}'`);return _.openExternalUri(D.URI.revive(l.resolvedUri),{sourceUri:D.URI.revive(l.sourceUri)},C)}}e.ExtHostUriOpeners=L}),define(Pe[286],ke([1,0,6,2,3,12,23]),function(ge,e,s,h,D,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class R{static{this.HandlePool=0}constructor(l){this.handles=new L.ExtensionIdentifierSet,this.handlers=new Map,this._proxy=l.getProxy(s.MainContext.MainThreadUrls)}registerUriHandler(l,C){const _=l.identifier;if(this.handles.has(_))throw new Error(`Protocol handler already registered for extension ${_}`);const f=R.HandlePool++;return this.handles.add(_),this.handlers.set(f,C),this._proxy.$registerUriHandler(f,_,l.displayName||l.name),(0,D.toDisposable)(()=>{this.handles.delete(_),this.handlers.delete(f),this._proxy.$unregisterUriHandler(f)})}$handleExternalUri(l,C){const _=this.handlers.get(l);if(!_)return Promise.resolve(void 0);try{_.handleUri(h.URI.revive(C))}catch(f){(0,A.onUnexpectedError)(f)}return Promise.resolve(void 0)}async createAppUri(l){return h.URI.revive(await this._proxy.$createAppUri(l))}}e.ExtHostUrls=R}),define(Pe[287],ke([1,0,21,6]),function(ge,e,s,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.serializeWebviewMessage=A,e.deserializeWebviewMessage=R,h=We(h);class D{constructor(){this.buffers=[]}add(l){let C=this.buffers.indexOf(l);return C<0&&(C=this.buffers.length,this.buffers.push(l)),C}}function A(v,l){if(l.serializeBuffersForPostMessage){const C=new D,f=JSON.stringify(v,(S,o)=>{if(o instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:C.add(o)};if(ArrayBuffer.isView(o)){const m=L(o);if(m)return{$$vscode_array_buffer_reference$$:!0,index:C.add(o.buffer),view:{type:m,byteLength:o.byteLength,byteOffset:o.byteOffset}}}return o}),T=C.buffers.map(S=>{const o=new Uint8Array(S);return s.VSBuffer.wrap(o)});return{message:f,buffers:T}}else return{message:JSON.stringify(v),buffers:[]}}function L(v){switch(v.constructor.name){case"Int8Array":return h.WebviewMessageArrayBufferViewType.Int8Array;case"Uint8Array":return h.WebviewMessageArrayBufferViewType.Uint8Array;case"Uint8ClampedArray":return h.WebviewMessageArrayBufferViewType.Uint8ClampedArray;case"Int16Array":return h.WebviewMessageArrayBufferViewType.Int16Array;case"Uint16Array":return h.WebviewMessageArrayBufferViewType.Uint16Array;case"Int32Array":return h.WebviewMessageArrayBufferViewType.Int32Array;case"Uint32Array":return h.WebviewMessageArrayBufferViewType.Uint32Array;case"Float32Array":return h.WebviewMessageArrayBufferViewType.Float32Array;case"Float64Array":return h.WebviewMessageArrayBufferViewType.Float64Array;case"BigInt64Array":return h.WebviewMessageArrayBufferViewType.BigInt64Array;case"BigUint64Array":return h.WebviewMessageArrayBufferViewType.BigUint64Array}}function R(v,l){const C=l.map(T=>{const S=new ArrayBuffer(T.byteLength);return new Uint8Array(S).set(T.buffer),S}),_=l.length?(T,S)=>{if(S&&typeof S=="object"&&S.$$vscode_array_buffer_reference$$){const o=S,{index:m}=o,p=C[m];if(o.view)switch(o.view.type){case h.WebviewMessageArrayBufferViewType.Int8Array:return new Int8Array(p,o.view.byteOffset,o.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case h.WebviewMessageArrayBufferViewType.Uint8Array:return new Uint8Array(p,o.view.byteOffset,o.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case h.WebviewMessageArrayBufferViewType.Uint8ClampedArray:return new Uint8ClampedArray(p,o.view.byteOffset,o.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case h.WebviewMessageArrayBufferViewType.Int16Array:return new Int16Array(p,o.view.byteOffset,o.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case h.WebviewMessageArrayBufferViewType.Uint16Array:return new Uint16Array(p,o.view.byteOffset,o.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case h.WebviewMessageArrayBufferViewType.Int32Array:return new Int32Array(p,o.view.byteOffset,o.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case h.WebviewMessageArrayBufferViewType.Uint32Array:return new Uint32Array(p,o.view.byteOffset,o.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case h.WebviewMessageArrayBufferViewType.Float32Array:return new Float32Array(p,o.view.byteOffset,o.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case h.WebviewMessageArrayBufferViewType.Float64Array:return new Float64Array(p,o.view.byteOffset,o.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case h.WebviewMessageArrayBufferViewType.BigInt64Array:return new BigInt64Array(p,o.view.byteOffset,o.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case h.WebviewMessageArrayBufferViewType.BigUint64Array:return new BigUint64Array(p,o.view.byteOffset,o.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return p}return S}:void 0;return{message:JSON.parse(v,_),arrayBuffers:C}}}),define(Pe[97],ke([1,0,4,3,14,24,2,238,287,121,6]),function(ge,e,s,h,D,A,L,R,v,l,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviews=e.ExtHostWebview=void 0,e.shouldSerializeBuffersForPostMessage=f,e.toExtensionData=o,e.serializeWebviewOptions=m,A=We(A),C=We(C);class _{#e;#t;#i;#n;#s;#r;#a;#o;#l;#c;#u;#h;constructor(a,t,n,r,d,c,g){this.#a="",this.#l=!1,this.#c=!1,this._onMessageEmitter=new s.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#d=new s.Emitter,this._onDidDispose=this.#d.event,this.#e=a,this.#t=t,this.#o=n,this.#n=r,this.#s=d,this.#r=c,this.#u=f(c),this.#h=T(c),this.#i=g}#d;dispose(){this.#l=!0,this.#d.fire(),this.#d.dispose(),this._onMessageEmitter.dispose()}asWebviewUri(a){return this.#c=!0,(0,l.asWebviewUri)(a,this.#n)}get cspSource(){const a=this.#r.extensionLocation;if(a.scheme===D.Schemas.https||a.scheme===D.Schemas.http){let t=a.toString();return t.endsWith("/")||(t+="/"),t+" "+l.webviewGenericCspSource}return l.webviewGenericCspSource}get html(){return this.assertNotDisposed(),this.#a}set html(a){this.assertNotDisposed(),this.#a!==a&&(this.#a=a,this.#h&&!this.#c&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(a)&&(this.#c=!0,this.#i.report("Webview vscode-resource: uris",this.#r,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.rewriteOldResourceUrlsIfNeeded(a)))}get options(){return this.assertNotDisposed(),this.#o}set options(a){this.assertNotDisposed(),A.equals(this.#o,a)||this.#t.$setOptions(this.#e,m(this.#r,this.#s,a)),this.#o=a}async postMessage(a){if(this.#l)return!1;const t=(0,v.serializeWebviewMessage)(a,{serializeBuffersForPostMessage:this.#u});return this.#t.$postMessage(this.#e,t.message,...t.buffers)}assertNotDisposed(){if(this.#l)throw new Error("Webview is disposed")}rewriteOldResourceUrlsIfNeeded(a){if(!this.#h)return a;const t=this.#r.extensionLocation?.scheme===D.Schemas.vscodeRemote,n=this.#r.extensionLocation.scheme===D.Schemas.vscodeRemote?this.#r.extensionLocation.authority:void 0;return a.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(r,d,c,g,w,y)=>{const I=L.URI.from({scheme:g||"file",path:decodeURIComponent(w)}),P=(0,l.asWebviewUri)(I,{isRemote:t,authority:n}).toString();return`${d}${P}${y}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(r,d,c,g,w,y)=>{const I=L.URI.from({scheme:g||"file",path:decodeURIComponent(w)}),P=(0,l.asWebviewUri)(I,{isRemote:t,authority:n}).toString();return`${d}${P}${y}`})}}e.ExtHostWebview=_;function f(i){try{const a=(0,R.normalizeVersion)((0,R.parseVersion)(i.engines.vscode));return!!a&&a.majorBase>=1&&a.minorBase>=57}catch{return!1}}function T(i){try{const a=(0,R.normalizeVersion)((0,R.parseVersion)(i.engines.vscode));return a?a.majorBase<1||a.majorBase===1&&a.minorBase<60:!1}catch{return!1}}class S extends h.Disposable{constructor(a,t,n,r,d){super(),this.remoteInfo=t,this.workspace=n,this._logService=r,this._deprecationService=d,this._webviews=new Map,this._webviewProxy=a.getProxy(C.MainContext.MainThreadWebviews)}dispose(){super.dispose();for(const a of this._webviews.values())a.dispose();this._webviews.clear()}$onMessage(a,t,n){const r=this.getWebview(a);if(r){const{message:d}=(0,v.deserializeWebviewMessage)(t,n.value);r._onMessageEmitter.fire(d)}}$onMissingCsp(a,t){this._logService.warn(`${t} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(a,t,n){const r=new _(a,this._webviewProxy,p(t),this.remoteInfo,this.workspace,n,this._deprecationService);this._webviews.set(a,r);const d=r._onDidDispose(()=>{d.dispose(),this.deleteWebview(a)});return r}deleteWebview(a){this._webviews.delete(a)}getWebview(a){return this._webviews.get(a)}}e.ExtHostWebviews=S;function o(i){return{id:i.identifier,location:i.extensionLocation}}function m(i,a,t){return{enableCommandUris:t.enableCommandUris,enableScripts:t.enableScripts,enableForms:t.enableForms,portMapping:t.portMapping,localResourceRoots:t.localResourceRoots||u(i,a)}}function p(i){return{enableCommandUris:i.enableCommandUris,enableScripts:i.enableScripts,enableForms:i.enableForms,portMapping:i.portMapping,localResourceRoots:i.localResourceRoots?.map(a=>L.URI.from(a))}}function u(i,a){return[...(a?.getWorkspaceFolders()||[]).map(t=>t.uri),i.extensionLocation]}}),define(Pe[167],ke([1,0,4,14,13,2,5,19,6]),function(ge,e,s,h,D,A,L,R,v){"use strict";var l;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let C=class{static{l=this}static{this.InitialState={focused:!0,active:!0}}getState(){const f=this._state;return{get focused(){return f.focused},get active(){return f.active}}}constructor(f){this._onDidChangeWindowState=new s.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=l.InitialState,this._proxy=f.getProxy(v.MainContext.MainThreadWindow),this._proxy.$getInitialState().then(({isFocused:T,isActive:S})=>{this.onDidChangeWindowProperty("focused",T),this.onDidChangeWindowProperty("active",S)})}$onDidChangeWindowFocus(f){this.onDidChangeWindowProperty("focused",f)}$onDidChangeWindowActive(f){this.onDidChangeWindowProperty("active",f)}onDidChangeWindowProperty(f,T){T!==this._state[f]&&(this._state={...this._state,[f]:T},this._onDidChangeWindowState.fire(this._state))}openUri(f,T){let S;if(typeof f=="string"){S=f;try{f=A.URI.parse(f)}catch{return Promise.reject(`Invalid uri - '${f}'`)}}return(0,D.isFalsyOrWhitespace)(f.scheme)?Promise.reject("Invalid scheme - cannot be empty"):f.scheme===h.Schemas.command?Promise.reject(`Invalid scheme '${f.scheme}'`):this._proxy.$openUri(f,S,T)}async asExternalUri(f,T){if((0,D.isFalsyOrWhitespace)(f.scheme))return Promise.reject("Invalid scheme - cannot be empty");const S=await this._proxy.$asExternalUri(f,T);return A.URI.from(S)}};e.ExtHostWindow=C,e.ExtHostWindow=C=l=Qe([$e(0,R.IExtHostRpcService)],C),e.IExtHostWindow=(0,L.createDecorator)("IExtHostWindow")}),define(Pe[288],ke([1,0,278,29,19,94]),function(ge,e,s,h,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostConsoleForwarder=void 0;const L=1024*1024;let R=class extends s.AbstractExtHostConsoleForwarder{constructor(l,C){super(l,C),this._isMakingConsoleCall=!1,this._wrapStream("stderr","error"),this._wrapStream("stdout","log")}_nativeConsoleLogMessage(l,C,_){const f=l==="error"||l==="warn"?process.stderr:process.stdout;this._isMakingConsoleCall=!0,f.write(`
${A.NativeLogMarkers.Start}
`),C.apply(console,_),f.write(`
${A.NativeLogMarkers.End}
`),this._isMakingConsoleCall=!1}_wrapStream(l,C){const _=process[l],f=_.write;let T="";Object.defineProperty(_,"write",{set:()=>{},get:()=>(S,o,m)=>{if(!this._isMakingConsoleCall){T+=S.toString(o);const p=T.length>L?T.length:T.lastIndexOf(`
`);p!==-1&&(console[C](T.slice(0,p)),T=T.slice(p+1))}f.call(_,S,o,m)}})}};e.ExtHostConsoleForwarder=R,e.ExtHostConsoleForwarder=R=Qe([$e(0,D.IExtHostRpcService),$e(1,h.IExtHostInitDataService)],R)}),define(Pe[289],ke([1,0,166,14,232,31]),function(ge,e,s,h,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;class L extends s.ExtHostLoggerService{doCreateLogger(v,l,C){return v.scheme===h.Schemas.file?new D.SpdLogLogger(C?.name||(0,A.generateUuid)(),v.fsPath,!C?.donotRotate,!!C?.donotUseFormatters,l):super.doCreateLogger(v,l,C)}registerLogger(v){super.registerLogger(v),this._proxy.$registerLogger(v)}deregisterLogger(v){super.deregisterLogger(v),this._proxy.$deregisterLogger(v)}}e.ExtHostLoggerService=L}),define(Pe[290],ke([1,0,8,21,20,26,12,4,3,41,145,276,53]),function(ge,e,s,h,D,A,L,R,v,l,C,_,f){"use strict";var T;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=void 0,e.stringifyJsonWithBufferRefs=u,e.parseJsonAndRestoreBufferRefs=i,L=We(L);function S(N,O){try{return JSON.stringify(N,O)}catch{return"null"}}const o="$$ref$$",m={[o]:-1};class p{constructor(O,M){this.jsonString=O,this.referencedBuffers=M}}function u(N,O=null,M=!1){const U=[];return{jsonString:(M?S:JSON.stringify)(N,(F,x)=>{if(typeof x>"u")return m;if(typeof x=="object"){if(x instanceof h.VSBuffer){const $=U.push(x)-1;return{[o]:$}}if(O)return O(F,x)}return x}),referencedBuffers:U}}function i(N,O,M){return JSON.parse(N,(U,H)=>{if(H){const F=H[o];if(typeof F=="number")return O[F];if(M&&H.$mid===l.MarshalledId.Uri)return M.transformIncoming(H)}return H})}function a(N,O){return JSON.stringify(N,O)}function t(N){return N?(O,M)=>M&&M.$mid===l.MarshalledId.Uri?N.transformOutgoing(M):M:null}var n;(function(N){N[N.LocalSide=0]="LocalSide",N[N.OtherSide=1]="OtherSide"})(n||(e.RequestInitiator=n={}));var r;(function(N){N[N.Responsive=0]="Responsive",N[N.Unresponsive=1]="Unresponsive"})(r||(e.ResponsiveState=r={}));const d=()=>{},c=Symbol.for("rpcProtocol"),g=Symbol.for("rpcProxy");class w extends v.Disposable{static{T=c}static{this.UNRESPONSIVE_TIME=3*1e3}constructor(O,M=null,U=null){super(),this[T]=!0,this._onDidChangeResponsiveState=this._register(new R.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=O,this._logger=M,this._uriTransformer=U,this._uriReplacer=t(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let H=0,F=f.ProxyIdentifier.count;H<F;H++)this._locals[H]=null,this._proxies[H]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=r.Responsive,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new s.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._register(this._protocol.onMessage(H=>this._receiveOneMessage(H)))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(O=>{const M=this._pendingRPCReplies[O];delete this._pendingRPCReplies[O],M.resolveErr(L.canceled())}),super.dispose()}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(O){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+w.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(O){this._unresponsiveTime=Date.now()+w.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(r.Responsive)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(r.Unresponsive):this._asyncCheckUresponsive.schedule())}_setResponsiveState(O){this._responsiveState!==O&&(this._responsiveState=O,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(O){return this._uriTransformer?(0,C.transformIncomingURIs)(O,this._uriTransformer):O}getProxy(O){const{nid:M,sid:U}=O;return this._proxies[M]||(this._proxies[M]=this._createProxy(M,U)),this._proxies[M]}_createProxy(O,M){const U={get:(H,F)=>(typeof F=="string"&&!H[F]&&F.charCodeAt(0)===A.CharCode.DollarSign&&(H[F]=(...x)=>this._remoteCall(O,F,x)),F===g?M:H[F])};return new Proxy(Object.create(null),U)}set(O,M){return this._locals[O.nid]=M,M}assertRegistered(O){for(let M=0,U=O.length;M<U;M++){const H=O[M];if(!this._locals[H.nid])throw new Error(`Missing proxy instance ${H.sid}`)}}_receiveOneMessage(O){if(this._isDisposed)return;const M=O.byteLength,U=I.read(O,0),H=U.readUInt8(),F=U.readUInt32();switch(H){case b.RequestJSONArgs:case b.RequestJSONArgsWithCancellation:{let{rpcId:x,method:$,args:G}=k.deserializeRequestJSONArgs(U);this._uriTransformer&&(G=(0,C.transformIncomingURIs)(G,this._uriTransformer)),this._receiveRequest(M,F,x,$,G,H===b.RequestJSONArgsWithCancellation);break}case b.RequestMixedArgs:case b.RequestMixedArgsWithCancellation:{let{rpcId:x,method:$,args:G}=k.deserializeRequestMixedArgs(U);this._uriTransformer&&(G=(0,C.transformIncomingURIs)(G,this._uriTransformer)),this._receiveRequest(M,F,x,$,G,H===b.RequestMixedArgsWithCancellation);break}case b.Acknowledged:{this._logger?.logIncoming(M,F,n.LocalSide,"ack"),this._onDidReceiveAcknowledge(F);break}case b.Cancel:{this._receiveCancel(M,F);break}case b.ReplyOKEmpty:{this._receiveReply(M,F,void 0);break}case b.ReplyOKJSON:{let x=k.deserializeReplyOKJSON(U);this._uriTransformer&&(x=(0,C.transformIncomingURIs)(x,this._uriTransformer)),this._receiveReply(M,F,x);break}case b.ReplyOKJSONWithBuffers:{const x=k.deserializeReplyOKJSONWithBuffers(U,this._uriTransformer);this._receiveReply(M,F,x);break}case b.ReplyOKVSBuffer:{const x=k.deserializeReplyOKVSBuffer(U);this._receiveReply(M,F,x);break}case b.ReplyErrError:{let x=k.deserializeReplyErrError(U);this._uriTransformer&&(x=(0,C.transformIncomingURIs)(x,this._uriTransformer)),this._receiveReplyErr(M,F,x);break}case b.ReplyErrEmpty:{this._receiveReplyErr(M,F,void 0);break}default:console.error("received unexpected message"),console.error(O)}}_receiveRequest(O,M,U,H,F,x){this._logger?.logIncoming(O,M,n.OtherSide,`receiveRequest ${(0,f.getStringIdentifierForProxy)(U)}.${H}(`,F);const $=String(M);let G,B;if(x){const Z=new D.CancellationTokenSource;F.push(Z.token),G=this._invokeHandler(U,H,F),B=()=>Z.cancel()}else G=this._invokeHandler(U,H,F),B=d;this._cancelInvokedHandlers[$]=B;const W=k.serializeAcknowledged(M);this._logger?.logOutgoing(W.byteLength,M,n.OtherSide,"ack"),this._protocol.send(W),G.then(Z=>{delete this._cancelInvokedHandlers[$];const J=k.serializeReplyOK(M,Z,this._uriReplacer);this._logger?.logOutgoing(J.byteLength,M,n.OtherSide,"reply:",Z),this._protocol.send(J)},Z=>{delete this._cancelInvokedHandlers[$];const J=k.serializeReplyErr(M,Z);this._logger?.logOutgoing(J.byteLength,M,n.OtherSide,"replyErr:",Z),this._protocol.send(J)})}_receiveCancel(O,M){this._logger?.logIncoming(O,M,n.OtherSide,"receiveCancel");const U=String(M);this._cancelInvokedHandlers[U]?.()}_receiveReply(O,M,U){this._logger?.logIncoming(O,M,n.LocalSide,"receiveReply:",U);const H=String(M);if(!this._pendingRPCReplies.hasOwnProperty(H))return;const F=this._pendingRPCReplies[H];delete this._pendingRPCReplies[H],F.resolveOk(U)}_receiveReplyErr(O,M,U){this._logger?.logIncoming(O,M,n.LocalSide,"receiveReplyErr:",U);const H=String(M);if(!this._pendingRPCReplies.hasOwnProperty(H))return;const F=this._pendingRPCReplies[H];delete this._pendingRPCReplies[H];let x;U&&(U.$isError?(x=new Error,x.name=U.name,x.message=U.message,x.stack=U.stack):x=U),F.resolveErr(x)}_invokeHandler(O,M,U){try{return Promise.resolve(this._doInvokeHandler(O,M,U))}catch(H){return Promise.reject(H)}}_doInvokeHandler(O,M,U){const H=this._locals[O];if(!H)throw new Error("Unknown actor "+(0,f.getStringIdentifierForProxy)(O));const F=H[M];if(typeof F!="function")throw new Error("Unknown method "+M+" on actor "+(0,f.getStringIdentifierForProxy)(O));return F.apply(H,U)}_remoteCall(O,M,U){if(this._isDisposed)return new _.CanceledLazyPromise;let H=null;if(U.length>0&&D.CancellationToken.isCancellationToken(U[U.length-1])&&(H=U.pop()),H&&H.isCancellationRequested)return Promise.reject(L.canceled());const F=k.serializeRequestArguments(U,this._uriReplacer),x=++this._lastMessageId,$=String(x),G=new _.LazyPromise,B=new v.DisposableStore;H&&B.add(H.onCancellationRequested(()=>{const Z=k.serializeCancel(x);this._logger?.logOutgoing(Z.byteLength,x,n.LocalSide,"cancel"),this._protocol.send(k.serializeCancel(x))})),this._pendingRPCReplies[$]=new y(G,B),this._onWillSendRequest(x);const W=k.serializeRequest(x,O,M,F,!!H);return this._logger?.logOutgoing(W.byteLength,x,n.LocalSide,`request: ${(0,f.getStringIdentifierForProxy)(O)}.${M}(`,U),this._protocol.send(W),G}}e.RPCProtocol=w;class y{constructor(O,M){this._promise=O,this._disposable=M}resolveOk(O){this._promise.resolveOk(O),this._disposable.dispose()}resolveErr(O){this._promise.resolveErr(O),this._disposable.dispose()}}class I{static alloc(O,M,U){const H=new I(h.VSBuffer.alloc(U+1+4),0);return H.writeUInt8(O),H.writeUInt32(M),H}static read(O,M){return new I(O,M)}get buffer(){return this._buff}constructor(O,M){this._buff=O,this._offset=M}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(O){this._buff.writeUInt8(O,this._offset),this._offset+=1}readUInt8(){const O=this._buff.readUInt8(this._offset);return this._offset+=1,O}writeUInt32(O){this._buff.writeUInt32BE(O,this._offset),this._offset+=4}readUInt32(){const O=this._buff.readUInt32BE(this._offset);return this._offset+=4,O}static sizeShortString(O){return 1+O.byteLength}writeShortString(O){this._buff.writeUInt8(O.byteLength,this._offset),this._offset+=1,this._buff.set(O,this._offset),this._offset+=O.byteLength}readShortString(){const O=this._buff.readUInt8(this._offset);this._offset+=1;const U=this._buff.slice(this._offset,this._offset+O).toString();return this._offset+=O,U}static sizeLongString(O){return 4+O.byteLength}writeLongString(O){this._buff.writeUInt32BE(O.byteLength,this._offset),this._offset+=4,this._buff.set(O,this._offset),this._offset+=O.byteLength}readLongString(){const O=this._buff.readUInt32BE(this._offset);this._offset+=4;const U=this._buff.slice(this._offset,this._offset+O).toString();return this._offset+=O,U}writeBuffer(O){this._buff.writeUInt32BE(O.byteLength,this._offset),this._offset+=4,this._buff.set(O,this._offset),this._offset+=O.byteLength}static sizeVSBuffer(O){return 4+O.byteLength}writeVSBuffer(O){this._buff.writeUInt32BE(O.byteLength,this._offset),this._offset+=4,this._buff.set(O,this._offset),this._offset+=O.byteLength}readVSBuffer(){const O=this._buff.readUInt32BE(this._offset);this._offset+=4;const M=this._buff.slice(this._offset,this._offset+O);return this._offset+=O,M}static sizeMixedArray(O){let M=0;M+=1;for(let U=0,H=O.length;U<H;U++){const F=O[U];switch(M+=1,F.type){case E.String:M+=this.sizeLongString(F.value);break;case E.VSBuffer:M+=this.sizeVSBuffer(F.value);break;case E.SerializedObjectWithBuffers:M+=this.sizeUInt32,M+=this.sizeLongString(F.value);for(let x=0;x<F.buffers.length;++x)M+=this.sizeVSBuffer(F.buffers[x]);break;case E.Undefined:break}}return M}writeMixedArray(O){this._buff.writeUInt8(O.length,this._offset),this._offset+=1;for(let M=0,U=O.length;M<U;M++){const H=O[M];switch(H.type){case E.String:this.writeUInt8(E.String),this.writeLongString(H.value);break;case E.VSBuffer:this.writeUInt8(E.VSBuffer),this.writeVSBuffer(H.value);break;case E.SerializedObjectWithBuffers:this.writeUInt8(E.SerializedObjectWithBuffers),this.writeUInt32(H.buffers.length),this.writeLongString(H.value);for(let F=0;F<H.buffers.length;++F)this.writeBuffer(H.buffers[F]);break;case E.Undefined:this.writeUInt8(E.Undefined);break}}}readMixedArray(){const O=this._buff.readUInt8(this._offset);this._offset+=1;const M=new Array(O);for(let U=0;U<O;U++)switch(this.readUInt8()){case E.String:M[U]=this.readLongString();break;case E.VSBuffer:M[U]=this.readVSBuffer();break;case E.SerializedObjectWithBuffers:{const F=this.readUInt32(),x=this.readLongString(),$=[];for(let G=0;G<F;++G)$.push(this.readVSBuffer());M[U]=new f.SerializableObjectWithBuffers(i(x,$,null));break}case E.Undefined:M[U]=void 0;break}return M}}var P;(function(N){N[N.Simple=0]="Simple",N[N.Mixed=1]="Mixed"})(P||(P={}));class k{static _useMixedArgSerialization(O){for(let M=0,U=O.length;M<U;M++)if(O[M]instanceof h.VSBuffer||O[M]instanceof f.SerializableObjectWithBuffers||typeof O[M]>"u")return!0;return!1}static serializeRequestArguments(O,M){if(this._useMixedArgSerialization(O)){const U=[];for(let H=0,F=O.length;H<F;H++){const x=O[H];if(x instanceof h.VSBuffer)U[H]={type:E.VSBuffer,value:x};else if(typeof x>"u")U[H]={type:E.Undefined};else if(x instanceof f.SerializableObjectWithBuffers){const{jsonString:$,referencedBuffers:G}=u(x.value,M);U[H]={type:E.SerializedObjectWithBuffers,value:h.VSBuffer.fromString($),buffers:G}}else U[H]={type:E.String,value:h.VSBuffer.fromString(a(x,M))}}return{type:P.Mixed,args:U}}return{type:P.Simple,args:a(O,M)}}static serializeRequest(O,M,U,H,F){switch(H.type){case P.Simple:return this._requestJSONArgs(O,M,U,H.args,F);case P.Mixed:return this._requestMixedArgs(O,M,U,H.args,F)}}static _requestJSONArgs(O,M,U,H,F){const x=h.VSBuffer.fromString(U),$=h.VSBuffer.fromString(H);let G=0;G+=I.sizeUInt8(),G+=I.sizeShortString(x),G+=I.sizeLongString($);const B=I.alloc(F?b.RequestJSONArgsWithCancellation:b.RequestJSONArgs,O,G);return B.writeUInt8(M),B.writeShortString(x),B.writeLongString($),B.buffer}static deserializeRequestJSONArgs(O){const M=O.readUInt8(),U=O.readShortString(),H=O.readLongString();return{rpcId:M,method:U,args:JSON.parse(H)}}static _requestMixedArgs(O,M,U,H,F){const x=h.VSBuffer.fromString(U);let $=0;$+=I.sizeUInt8(),$+=I.sizeShortString(x),$+=I.sizeMixedArray(H);const G=I.alloc(F?b.RequestMixedArgsWithCancellation:b.RequestMixedArgs,O,$);return G.writeUInt8(M),G.writeShortString(x),G.writeMixedArray(H),G.buffer}static deserializeRequestMixedArgs(O){const M=O.readUInt8(),U=O.readShortString(),H=O.readMixedArray(),F=new Array(H.length);for(let x=0,$=H.length;x<$;x++){const G=H[x];typeof G=="string"?F[x]=JSON.parse(G):F[x]=G}return{rpcId:M,method:U,args:F}}static serializeAcknowledged(O){return I.alloc(b.Acknowledged,O,0).buffer}static serializeCancel(O){return I.alloc(b.Cancel,O,0).buffer}static serializeReplyOK(O,M,U){if(typeof M>"u")return this._serializeReplyOKEmpty(O);if(M instanceof h.VSBuffer)return this._serializeReplyOKVSBuffer(O,M);if(M instanceof f.SerializableObjectWithBuffers){const{jsonString:H,referencedBuffers:F}=u(M.value,U,!0);return this._serializeReplyOKJSONWithBuffers(O,H,F)}else return this._serializeReplyOKJSON(O,S(M,U))}static _serializeReplyOKEmpty(O){return I.alloc(b.ReplyOKEmpty,O,0).buffer}static _serializeReplyOKVSBuffer(O,M){let U=0;U+=I.sizeVSBuffer(M);const H=I.alloc(b.ReplyOKVSBuffer,O,U);return H.writeVSBuffer(M),H.buffer}static deserializeReplyOKVSBuffer(O){return O.readVSBuffer()}static _serializeReplyOKJSON(O,M){const U=h.VSBuffer.fromString(M);let H=0;H+=I.sizeLongString(U);const F=I.alloc(b.ReplyOKJSON,O,H);return F.writeLongString(U),F.buffer}static _serializeReplyOKJSONWithBuffers(O,M,U){const H=h.VSBuffer.fromString(M);let F=0;F+=I.sizeUInt32,F+=I.sizeLongString(H);for(const $ of U)F+=I.sizeVSBuffer($);const x=I.alloc(b.ReplyOKJSONWithBuffers,O,F);x.writeUInt32(U.length),x.writeLongString(H);for(const $ of U)x.writeBuffer($);return x.buffer}static deserializeReplyOKJSON(O){const M=O.readLongString();return JSON.parse(M)}static deserializeReplyOKJSONWithBuffers(O,M){const U=O.readUInt32(),H=O.readLongString(),F=[];for(let x=0;x<U;++x)F.push(O.readVSBuffer());return new f.SerializableObjectWithBuffers(i(H,F,M))}static serializeReplyErr(O,M){const U=M?S(L.transformErrorForSerialization(M),null):void 0;if(typeof U!="string")return this._serializeReplyErrEmpty(O);const H=h.VSBuffer.fromString(U);let F=0;F+=I.sizeLongString(H);const x=I.alloc(b.ReplyErrError,O,F);return x.writeLongString(H),x.buffer}static deserializeReplyErrError(O){const M=O.readLongString();return JSON.parse(M)}static _serializeReplyErrEmpty(O){return I.alloc(b.ReplyErrEmpty,O,0).buffer}}var b;(function(N){N[N.RequestJSONArgs=1]="RequestJSONArgs",N[N.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",N[N.RequestMixedArgs=3]="RequestMixedArgs",N[N.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",N[N.Acknowledged=5]="Acknowledged",N[N.Cancel=6]="Cancel",N[N.ReplyOKEmpty=7]="ReplyOKEmpty",N[N.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",N[N.ReplyOKJSON=9]="ReplyOKJSON",N[N.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",N[N.ReplyErrError=11]="ReplyErrError",N[N.ReplyErrEmpty=12]="ReplyErrEmpty"})(b||(b={}));var E;(function(N){N[N.String=1]="String",N[N.VSBuffer=2]="VSBuffer",N[N.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",N[N.Undefined=4]="Undefined"})(E||(E={}))}),define(Pe[291],ke([1,0,21,28,14,89,5]),function(ge,e,s,h,D,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookDocumentWorkbenchService=e.INotebookDocumentService=void 0,e.parse=C,e.generate=_,e.parseMetadataUri=f,e.generateMetadataUri=T,e.INotebookDocumentService=(0,L.createDecorator)("notebookDocumentService");const R=["W","X","Y","Z","a","b","c","d","e","f"],v=new RegExp(`^[${R.join("")}]+`),l=7;function C(o){if(o.scheme!==D.Schemas.vscodeNotebookCell)return;const m=o.fragment.indexOf("s");if(m<0)return;const p=parseInt(o.fragment.substring(0,m).replace(v,""),l),u=(0,s.decodeBase64)(o.fragment.substring(m+1)).toString();if(!isNaN(p))return{handle:p,notebook:o.with({scheme:u,fragment:null})}}function _(o,m){const p=m.toString(l),i=`${p.length<R.length?R[p.length-1]:"z"}${p}s${(0,s.encodeBase64)(s.VSBuffer.fromString(o.scheme),!0,!0)}`;return o.with({scheme:D.Schemas.vscodeNotebookCell,fragment:i})}function f(o){if(o.scheme!==D.Schemas.vscodeNotebookMetadata)return;const m=(0,s.decodeBase64)(o.fragment).toString();return o.with({scheme:m,fragment:null})}function T(o){const m=`${(0,s.encodeBase64)(s.VSBuffer.fromString(o.scheme),!0,!0)}`;return o.with({scheme:D.Schemas.vscodeNotebookMetadata,fragment:m})}class S{constructor(){this._documents=new h.ResourceMap}getNotebook(m){if(m.scheme===D.Schemas.vscodeNotebookCell){const p=C(m);if(p){const u=this._documents.get(p.notebook);if(u)return u}}return this._documents.get(m)}addNotebookDocument(m){this._documents.set(m.uri,m)}removeNotebookDocument(m){this._documents.delete(m.uri)}}e.NotebookDocumentWorkbenchService=S,(0,A.registerSingleton)(e.INotebookDocumentService,S,A.InstantiationType.Delayed)}),define(Pe[126],ke([1,0,21,39,40,107,14,16,10,36,291]),function(ge,e,s,h,D,A,L,R,v,l,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MOVE_CURSOR_1_LINE_COMMAND=e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.NotebookFindScopeType=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_LINE_BOUNDARY=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.MimeTypeDisplayOrder=e.CellUri=e.NotebookUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=e.EXECUTE_REPL_COMMAND_ID=e.REPL_EDITOR_ID=e.INTERACTIVE_WINDOW_EDITOR_ID=e.NOTEBOOK_MULTI_DIFF_EDITOR_ID=e.NOTEBOOK_DIFF_EDITOR_ID=e.NOTEBOOK_EDITOR_ID=void 0,e.diff=d,e.isDocumentExcludePattern=w,e.notebookDocumentFilterMatch=y,e.isTextStreamMime=k,e.compressOutputItemStreams=E,h=We(h),e.NOTEBOOK_EDITOR_ID="workbench.editor.notebook",e.NOTEBOOK_DIFF_EDITOR_ID="workbench.editor.notebookTextDiffEditor",e.NOTEBOOK_MULTI_DIFF_EDITOR_ID="workbench.editor.notebookMultiTextDiffEditor",e.INTERACTIVE_WINDOW_EDITOR_ID="workbench.editor.interactive",e.REPL_EDITOR_ID="workbench.editor.repl",e.EXECUTE_REPL_COMMAND_ID="replNotebook.input.execute";var _;(function(G){G[G.Markup=1]="Markup",G[G.Code=2]="Code"})(_||(e.CellKind=_={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",A.Mimes.latex,A.Mimes.markdown,"image/png","image/jpeg",A.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[A.Mimes.latex,A.Mimes.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",A.Mimes.text],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.RENDERER_NOT_AVAILABLE="_notAvailable";var f;(function(G){G[G.Running=1]="Running",G[G.Idle=2]="Idle"})(f||(e.NotebookRunState=f={}));var T;(function(G){G[G.Unconfirmed=1]="Unconfirmed",G[G.Pending=2]="Pending",G[G.Executing=3]="Executing"})(T||(e.NotebookCellExecutionState=T={}));var S;(function(G){G[G.Unconfirmed=1]="Unconfirmed",G[G.Pending=2]="Pending",G[G.Executing=3]="Executing"})(S||(e.NotebookExecutionState=S={}));var o;(function(G){G[G.WithHardKernelDependency=0]="WithHardKernelDependency",G[G.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",G[G.Pure=2]="Pure",G[G.Never=3]="Never"})(o||(e.NotebookRendererMatch=o={}));var m;(function(G){G.Always="always",G.Never="never",G.Optional="optional"})(m||(e.RendererMessagingSpec=m={}));var p;(function(G){G[G.ModelChange=1]="ModelChange",G[G.Move=2]="Move",G[G.ChangeCellLanguage=5]="ChangeCellLanguage",G[G.Initialize=6]="Initialize",G[G.ChangeCellMetadata=7]="ChangeCellMetadata",G[G.Output=8]="Output",G[G.OutputItem=9]="OutputItem",G[G.ChangeCellContent=10]="ChangeCellContent",G[G.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",G[G.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",G[G.ChangeCellMime=13]="ChangeCellMime",G[G.Unknown=100]="Unknown"})(p||(e.NotebookCellsChangeType=p={}));var u;(function(G){G[G.Handle=0]="Handle",G[G.Index=1]="Index"})(u||(e.SelectionStateType=u={}));var i;(function(G){G[G.Replace=1]="Replace",G[G.Output=2]="Output",G[G.Metadata=3]="Metadata",G[G.CellLanguage=4]="CellLanguage",G[G.DocumentMetadata=5]="DocumentMetadata",G[G.Move=6]="Move",G[G.OutputItems=7]="OutputItems",G[G.PartialMetadata=8]="PartialMetadata",G[G.PartialInternalMetadata=9]="PartialInternalMetadata"})(i||(e.CellEditType=i={}));var a;(function(G){G.scheme=L.Schemas.vscodeNotebookMetadata;function B(Z){return(0,C.generateMetadataUri)(Z)}G.generate=B;function W(Z){return(0,C.parseMetadataUri)(Z)}G.parse=W})(a||(e.NotebookUri=a={}));var t;(function(G){G.scheme=L.Schemas.vscodeNotebookCell;function B(me,le){return(0,C.generate)(me,le)}G.generate=B;function W(me){return(0,C.parse)(me)}G.parse=W;function Z(me,le){return me.with({scheme:L.Schemas.vscodeNotebookCellOutput,fragment:`op${le??""},${me.scheme!==L.Schemas.file?me.scheme:""}`})}G.generateCellOutputUri=Z;function J(me){if(me.scheme!==L.Schemas.vscodeNotebookCellOutput)return;const le=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(me.fragment);if(!le)return;const Q=le[1]&&le[1]!==""?le[1]:void 0,z=le[2];return{outputId:Q,notebook:me.with({scheme:z||L.Schemas.file,fragment:null})}}G.parseCellOutputUri=J;function oe(me,le,Q){return G.generate(me,le).with({scheme:Q})}G.generateCellPropertyUri=oe;function te(me,le){if(me.scheme===le)return G.parse(me.with({scheme:G.scheme}))}G.parseCellPropertyUri=te})(t||(e.CellUri=t={}));const n=G=>v.isWindows?G.replace(/\//g,"\\"):G;class r{constructor(B=[],W=e.NOTEBOOK_DISPLAY_ORDER){this.defaultOrder=W,this.order=[...new Set(B)].map(Z=>({pattern:Z,matches:h.parse(n(Z))}))}sort(B){const W=new Map(D.Iterable.map(B,J=>[J,n(J)]));let Z=[];for(const{matches:J}of this.order)for(const[oe,te]of W)if(J(te)){Z.push(oe),W.delete(oe);break}return W.size&&(Z=Z.concat([...W.keys()].sort((J,oe)=>this.defaultOrder.indexOf(J)-this.defaultOrder.indexOf(oe)))),Z}prioritize(B,W){const Z=this.findIndex(B);if(Z===-1){this.order.unshift({pattern:B,matches:h.parse(n(B))});return}const J=new Set(W.map(te=>this.findIndex(te,Z)));J.delete(-1);const oe=Array.from(J).sort();this.order.splice(Z+1,0,...oe.map(te=>this.order[te]));for(let te=oe.length-1;te>=0;te--)this.order.splice(oe[te],1)}toArray(){return this.order.map(B=>B.pattern)}findIndex(B,W=this.order.length){const Z=n(B);for(let J=0;J<W;J++)if(this.order[J].matches(Z))return J;return-1}}e.MimeTypeDisplayOrder=r;function d(G,B,W,Z=(J,oe)=>J===oe){const J=[];function oe(le,Q,z){if(Q===0&&z.length===0)return;const se=J[J.length-1];se&&se.start+se.deleteCount===le?(se.deleteCount+=Q,se.toInsert.push(...z)):J.push({start:le,deleteCount:Q,toInsert:z})}let te=0,me=0;for(;;){if(te===G.length){oe(te,0,B.slice(me));break}if(me===B.length){oe(te,G.length-te,[]);break}const le=G[te],Q=B[me];if(Z(le,Q)){te+=1,me+=1;continue}W(Q)?(oe(te,1,[]),te+=1):(oe(te,0,[Q]),me+=1)}return J}e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new l.RawContextKey("notebookEditorCursorAtBoundary","none"),e.NOTEBOOK_EDITOR_CURSOR_LINE_BOUNDARY=new l.RawContextKey("notebookEditorCursorAtLineBoundary","none");var c;(function(G){G.default="default",G.option="option"})(c||(e.NotebookEditorPriority=c={}));var g;(function(G){G.Cells="cells",G.Text="text",G.None="none"})(g||(e.NotebookFindScopeType=g={}));function w(G){const B=G;return!!((typeof B.include=="string"||h.isRelativePattern(B.include))&&(typeof B.exclude=="string"||h.isRelativePattern(B.exclude)))}function y(G,B,W){if(Array.isArray(G.viewType)&&G.viewType.indexOf(B)>=0||G.viewType===B)return!0;if(G.filenamePattern){const Z=w(G.filenamePattern)?G.filenamePattern.include:G.filenamePattern,J=w(G.filenamePattern)?G.filenamePattern.exclude:void 0;if(h.match(Z,(0,R.basename)(W.fsPath).toLowerCase()))return!(J&&h.match(J,(0,R.basename)(W.fsPath).toLowerCase()))}return!1}e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScrollEnabled:"notebook.stickyScroll.enabled",stickyScrollMode:"notebook.stickyScroll.mode",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",markdownLineHeight:"notebook.markdown.lineHeight",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",LinkifyOutputFilePaths:"notebook.output.linkifyFilePaths",minimalErrorRendering:"notebook.output.minimalErrorRendering",formatOnSave:"notebook.formatOnSave.enabled",insertFinalNewline:"notebook.insertFinalNewline",defaultFormatter:"notebook.defaultFormatter",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findFilters:"notebook.find.filters",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",outlineShowMarkdownHeadersOnly:"notebook.outline.showMarkdownHeadersOnly",outlineShowCodeCells:"notebook.outline.showCodeCells",outlineShowCodeCellSymbols:"notebook.outline.showCodeCellSymbols",breadcrumbsShowCodeCells:"notebook.breadcrumbs.showCodeCells",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",cellChat:"notebook.experimental.cellChat",cellGenerate:"notebook.experimental.generate",notebookVariablesView:"notebook.experimental.variablesView",InteractiveWindowPromptToSave:"interactiveWindow.promptToSaveOnClose",cellFailureDiagnostics:"notebook.cellFailureDiagnostics",outputBackupSizeLimit:"notebook.backup.sizeLimit"};var I;(function(G){G[G.Left=1]="Left",G[G.Right=2]="Right"})(I||(e.CellStatusbarAlignment=I={}));class P{static{this._prefix="notebook/"}static create(B){return`${P._prefix}${B}`}static parse(B){if(B.startsWith(P._prefix))return B.substring(P._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=P;function k(G){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(G)}const b=new TextDecoder;function E(G){const B=[];let W=!1;for(const te of G)(B.length===0||W)&&(B.push(te),W=!0);let Z=M(B);const J=s.VSBuffer.concat(B.map(te=>s.VSBuffer.wrap(te))),oe=$(J);return Z=Z||oe.byteLength!==J.byteLength,{data:oe,didCompression:Z}}e.MOVE_CURSOR_1_LINE_COMMAND="\x1B[A";const N=e.MOVE_CURSOR_1_LINE_COMMAND.split("").map(G=>G.charCodeAt(0)),O=10;function M(G){let B=!1;return G.forEach((W,Z)=>{if(Z===0||W.length<e.MOVE_CURSOR_1_LINE_COMMAND.length)return;const J=G[Z-1],oe=W.subarray(0,e.MOVE_CURSOR_1_LINE_COMMAND.length);if(oe[0]===N[0]&&oe[1]===N[1]&&oe[2]===N[2]){const te=J.lastIndexOf(O);if(te===-1)return;B=!0,G[Z-1]=J.subarray(0,te),G[Z]=W.subarray(e.MOVE_CURSOR_1_LINE_COMMAND.length)}}),B}function U(G){let B=G;do G=B,B=G.replace(/[^\n]\x08/gm,"");while(B.length<G.length);return G}function H(G){for(G=G.replace(/\r+\n/gm,`
`);G.search(/\r[^$]/g)>-1;){const B=G.match(/^(.*)\r+/m)[1];let W=G.match(/\r+(.*)$/m)[1];W=W+B.slice(W.length,B.length),G=G.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,W)}return G}const F=8,x=13;function $(G){return!G.buffer.includes(F)&&!G.buffer.includes(x)?G:s.VSBuffer.fromString(H(U(b.decode(G.buffer))))}}),define(Pe[9],ke([1,0,18,12,86,28,107,13,17,2,31,23,27,73,126]),function(ge,e,s,h,D,A,L,R,v,l,C,_,f,T,S){"use strict";var o,m,p,u,i,a,t,n,r,d,c,g,w,y,I,P,k;Object.defineProperty(e,"__esModule",{value:!0}),e.InlineEditTriggerKind=e.InlineEdit=e.KeywordRecognitionStatus=e.TextToSpeechStatus=e.SpeechToTextStatus=e.RelatedInformationType=e.LanguageModelError=e.LanguageModelChatAssistantMessage=e.LanguageModelChatUserMessage=e.LanguageModelChatSystemMessage=e.LanguageModelTextPart=e.LanguageModelToolCallPart=e.LanguageModelChatMessage=e.LanguageModelToolResultPart=e.LanguageModelChatMessageRole=e.ChatRequestNotebookData=e.ChatRequestEditorData=e.ChatResponseReferencePartStatusKind=e.ChatLocation=e.ChatResponseTurn=e.ChatRequestTurn=e.ChatResponseTextEditPart=e.ChatResponseMovePart=e.ChatResponseCodeCitationPart=e.ChatResponseReferencePart=e.ChatResponseCommandButtonPart=e.ChatResponseWarningPart=e.ChatResponseProgressPart2=e.ChatResponseProgressPart=e.ChatResponseAnchorPart=e.ChatResponseFileTreePart=e.ChatResponseConfirmationPart=e.ChatResponseDetectedParticipantPart=e.ChatResponseMarkdownWithVulnerabilitiesPart=e.ChatResponseMarkdownPart=e.ChatResultFeedbackKind=e.InteractiveEditorResponseFeedbackKind=e.ChatCompletionItem=e.ChatVariableLevel=e.ChatCopyKind=e.InteractiveSessionVoteDirection=e.TextMultiDiffTabInput=e.ChatEditorTabInput=e.InteractiveWindowInput=e.TerminalEditorTabInput=e.NotebookDiffEditorTabInput=e.NotebookEditorTabInput=e.WebviewEditorTabInput=e.CustomEditorTabInput=e.TextMergeTabInput=e.TextDiffTabInput=e.TextTabInput=e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.DeclarationCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.TestCoverageCount=e.TestMessageStackFrame=e.TestTag=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookVariablesRequestKind=e.NotebookKernelSourceAction=e.NotebookRendererScript=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.QuickInputButtons=e.QuickInputButtonLocation=e.DebugVisualization=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentThreadFocus=e.CommentThreadApplicability=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.NewSymbolName=e.NewSymbolNameTriggerKind=e.NewSymbolNameTag=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugThread=e.DebugStackFrame=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.DocumentPasteEdit=e.DocumentDropOrPasteEditKind=e.DocumentPasteTriggerKind=e.DocumentDropEdit=e.DataTransfer=e.DataTransferFile=e.InternalFileDataTransferItem=e.InternalDataTransferItem=e.DataTransferItem=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.TreeItem=e.ViewBadge=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalQuickFixCommand=e.TerminalQuickFixOpener=e.TerminalLink=e.TerminalShellExecutionCommandLineConfidence=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.PartialAcceptTriggerKind=e.InlineSuggestionList=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintLabelPart=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.MultiDocumentHighlight=e.DocumentHighlight=e.DocumentHighlightKind=e.HoverVerbosityAction=e.VerboseHover=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.SnippetTextEdit=e.NotebookEdit=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ManagedResolvedAuthority=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0,e.getDebugDescriptionOfRange=F,e.getDebugDescriptionOfSelection=x,e.asStatusBarItemIdentifier=ht,e.setBreakpointId=Wi,e.validateTestCoverageCount=Pn;function b(K){return Object.assign(K,{apply:function(...fe){if(fe.length===0)return Reflect.construct(K,[]);{const Le=fe.length===1?[]:fe[1];return Reflect.construct(K,Le,fe[0].constructor)}},call:function(...fe){if(fe.length===0)return Reflect.construct(K,[]);{const[Le,...Ze]=fe;return Reflect.construct(K,Ze,Le.constructor)}}})}var E;(function(K){K[K.Top=0]="Top",K[K.Bottom=1]="Bottom"})(E||(e.TerminalOutputAnchor=E={}));var N;(function(K){K[K.TerminalCommand=0]="TerminalCommand",K[K.Opener=1]="Opener",K[K.Command=3]="Command"})(N||(e.TerminalQuickFixType=N={}));let O=o=class{static from(...q){let fe=q;return new o(function(){if(fe){for(const Le of fe)Le&&typeof Le.dispose=="function"&&Le.dispose();fe=void 0}})}#e;constructor(q){this.#e=q}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.Disposable=O,e.Disposable=O=o=Qe([b],O);let M=m=class{static Min(...q){if(q.length===0)throw new TypeError;let fe=q[0];for(let Le=1;Le<q.length;Le++){const Ze=q[Le];Ze.isBefore(fe)&&(fe=Ze)}return fe}static Max(...q){if(q.length===0)throw new TypeError;let fe=q[0];for(let Le=1;Le<q.length;Le++){const Ze=q[Le];Ze.isAfter(fe)&&(fe=Ze)}return fe}static isPosition(q){if(!q)return!1;if(q instanceof m)return!0;const{line:fe,character:Le}=q;return typeof fe=="number"&&typeof Le=="number"}static of(q){if(q instanceof m)return q;if(this.isPosition(q))return new m(q.line,q.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this._line}get character(){return this._character}constructor(q,fe){if(q<0)throw(0,h.illegalArgument)("line must be non-negative");if(fe<0)throw(0,h.illegalArgument)("character must be non-negative");this._line=q,this._character=fe}isBefore(q){return this._line<q._line?!0:q._line<this._line?!1:this._character<q._character}isBeforeOrEqual(q){return this._line<q._line?!0:q._line<this._line?!1:this._character<=q._character}isAfter(q){return!this.isBeforeOrEqual(q)}isAfterOrEqual(q){return!this.isBefore(q)}isEqual(q){return this._line===q._line&&this._character===q._character}compareTo(q){return this._line<q._line?-1:this._line>q.line?1:this._character<q._character?-1:this._character>q._character?1:0}translate(q,fe=0){if(q===null||fe===null)throw(0,h.illegalArgument)();let Le;return typeof q>"u"?Le=0:typeof q=="number"?Le=q:(Le=typeof q.lineDelta=="number"?q.lineDelta:0,fe=typeof q.characterDelta=="number"?q.characterDelta:0),Le===0&&fe===0?this:new m(this.line+Le,this.character+fe)}with(q,fe=this.character){if(q===null||fe===null)throw(0,h.illegalArgument)();let Le;return typeof q>"u"?Le=this.line:typeof q=="number"?Le=q:(Le=typeof q.line=="number"?q.line:this.line,fe=typeof q.character=="number"?q.character:this.character),Le===this.line&&fe===this.character?this:new m(Le,fe)}toJSON(){return{line:this.line,character:this.character}}[Symbol.for("debug.description")](){return`(${this.line}:${this.character})`}};e.Position=M,e.Position=M=m=Qe([b],M);let U=p=class{static isRange(q){return q instanceof p?!0:q?M.isPosition(q.start)&&M.isPosition(q.end):!1}static of(q){if(q instanceof p)return q;if(this.isRange(q))return new p(q.start,q.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this._start}get end(){return this._end}constructor(q,fe,Le,Ze){let lt,Et;if(typeof q=="number"&&typeof fe=="number"&&typeof Le=="number"&&typeof Ze=="number"?(lt=new M(q,fe),Et=new M(Le,Ze)):M.isPosition(q)&&M.isPosition(fe)&&(lt=M.of(q),Et=M.of(fe)),!lt||!Et)throw new Error("Invalid arguments");lt.isBefore(Et)?(this._start=lt,this._end=Et):(this._start=Et,this._end=lt)}contains(q){return p.isRange(q)?this.contains(q.start)&&this.contains(q.end):M.isPosition(q)?!(M.of(q).isBefore(this._start)||this._end.isBefore(q)):!1}isEqual(q){return this._start.isEqual(q._start)&&this._end.isEqual(q._end)}intersection(q){const fe=M.Max(q.start,this._start),Le=M.Min(q.end,this._end);if(!fe.isAfter(Le))return new p(fe,Le)}union(q){if(this.contains(q))return this;if(q.contains(this))return q;const fe=M.Min(q.start,this._start),Le=M.Max(q.end,this.end);return new p(fe,Le)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(q,fe=this.end){if(q===null||fe===null)throw(0,h.illegalArgument)();let Le;return q?M.isPosition(q)?Le=q:(Le=q.start||this.start,fe=q.end||this.end):Le=this.start,Le.isEqual(this._start)&&fe.isEqual(this.end)?this:new p(Le,fe)}toJSON(){return[this.start,this.end]}[Symbol.for("debug.description")](){return F(this)}};e.Range=U,e.Range=U=p=Qe([b],U);let H=u=class extends U{static isSelection(q){return q instanceof u?!0:q?U.isRange(q)&&M.isPosition(q.anchor)&&M.isPosition(q.active)&&typeof q.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}constructor(q,fe,Le,Ze){let lt,Et;if(typeof q=="number"&&typeof fe=="number"&&typeof Le=="number"&&typeof Ze=="number"?(lt=new M(q,fe),Et=new M(Le,Ze)):M.isPosition(q)&&M.isPosition(fe)&&(lt=M.of(q),Et=M.of(fe)),!lt||!Et)throw new Error("Invalid arguments");super(lt,Et),this._anchor=lt,this._active=Et}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}[Symbol.for("debug.description")](){return x(this)}};e.Selection=H,e.Selection=H=u=Qe([b],H);function F(K){return K.isEmpty?`[${K.start.line}:${K.start.character})`:`[${K.start.line}:${K.start.character} -> ${K.end.line}:${K.end.character})`}function x(K){let q=F(K);return K.isEmpty||(K.active.isEqual(K.start)?q=`|${q}`:q=`${q}|`),q}const $=K=>{if(typeof K!="string"||K.length===0||!/^[0-9A-Za-z_\-]+$/.test(K))throw(0,h.illegalArgument)("connectionToken")};class G{static isResolvedAuthority(q){return q&&typeof q=="object"&&typeof q.host=="string"&&typeof q.port=="number"&&(q.connectionToken===void 0||typeof q.connectionToken=="string")}constructor(q,fe,Le){if(typeof q!="string"||q.length===0)throw(0,h.illegalArgument)("host");if(typeof fe!="number"||fe===0||Math.round(fe)!==fe)throw(0,h.illegalArgument)("port");typeof Le<"u"&&$(Le),this.host=q,this.port=Math.round(fe),this.connectionToken=Le}}e.ResolvedAuthority=G;class B{static isManagedResolvedAuthority(q){return q&&typeof q=="object"&&typeof q.makeConnection=="function"&&(q.connectionToken===void 0||typeof q.connectionToken=="string")}constructor(q,fe){this.makeConnection=q,this.connectionToken=fe,typeof fe<"u"&&$(fe)}}e.ManagedResolvedAuthority=B;class W extends Error{static NotAvailable(q,fe){return new W(q,T.RemoteAuthorityResolverErrorCode.NotAvailable,fe)}static TemporarilyNotAvailable(q){return new W(q,T.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(q,fe=T.RemoteAuthorityResolverErrorCode.Unknown,Le){super(q),this._message=q,this._code=fe,this._detail=Le,Object.setPrototypeOf(this,W.prototype)}}e.RemoteAuthorityResolverError=W;var Z;(function(K){K[K.LF=1]="LF",K[K.CRLF=2]="CRLF"})(Z||(e.EndOfLine=Z={}));var J;(function(K){K[K.Replace=1]="Replace",K[K.Append=2]="Append",K[K.Prepend=3]="Prepend"})(J||(e.EnvironmentVariableMutatorType=J={}));let oe=i=class{static isTextEdit(q){return q instanceof i?!0:q?U.isRange(q)&&typeof q.newText=="string":!1}static replace(q,fe){return new i(q,fe)}static insert(q,fe){return i.replace(new U(q,q),fe)}static delete(q){return i.replace(q,"")}static setEndOfLine(q){const fe=new i(new U(new M(0,0),new M(0,0)),"");return fe.newEol=q,fe}get range(){return this._range}set range(q){if(q&&!U.isRange(q))throw(0,h.illegalArgument)("range");this._range=q}get newText(){return this._newText||""}set newText(q){if(q&&typeof q!="string")throw(0,h.illegalArgument)("newText");this._newText=q}get newEol(){return this._newEol}set newEol(q){if(q&&typeof q!="number")throw(0,h.illegalArgument)("newEol");this._newEol=q}constructor(q,fe){this._range=q,this._newText=fe}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};e.TextEdit=oe,e.TextEdit=oe=i=Qe([b],oe);let te=a=class{static isNotebookCellEdit(q){return q instanceof a?!0:q?Ii.isNotebookRange(q)&&Array.isArray(q.newCells):!1}static replaceCells(q,fe){return new a(q,fe)}static insertCells(q,fe){return new a(new Ii(q,q),fe)}static deleteCells(q){return new a(q,[])}static updateCellMetadata(q,fe){const Le=new a(new Ii(q,q),[]);return Le.newCellMetadata=fe,Le}static updateNotebookMetadata(q){const fe=new a(new Ii(0,0),[]);return fe.newNotebookMetadata=q,fe}constructor(q,fe){this.range=q,this.newCells=fe}};e.NotebookEdit=te,e.NotebookEdit=te=a=Qe([b],te);class me{static isSnippetTextEdit(q){return q instanceof me?!0:q?U.isRange(q.range)&&z.isSnippetString(q.snippet):!1}static replace(q,fe){return new me(q,fe)}static insert(q,fe){return me.replace(new U(q,q),fe)}constructor(q,fe){this.range=q,this.snippet=fe}}e.SnippetTextEdit=me;var le;(function(K){K[K.File=1]="File",K[K.Text=2]="Text",K[K.Cell=3]="Cell",K[K.CellReplace=5]="CellReplace",K[K.Snippet=6]="Snippet"})(le||(e.FileEditType=le={}));let Q=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(q,fe,Le,Ze){this._edits.push({_type:le.File,from:q,to:fe,options:Le,metadata:Ze})}createFile(q,fe,Le){this._edits.push({_type:le.File,from:void 0,to:q,options:fe,metadata:Le})}deleteFile(q,fe,Le){this._edits.push({_type:le.File,from:q,to:void 0,options:fe,metadata:Le})}replaceNotebookMetadata(q,fe,Le){this._edits.push({_type:le.Cell,metadata:Le,uri:q,edit:{editType:S.CellEditType.DocumentMetadata,metadata:fe},notebookMetadata:fe})}replaceNotebookCells(q,fe,Le,Ze){const lt=fe.start,Et=fe.end;(lt!==Et||Le.length>0)&&this._edits.push({_type:le.CellReplace,uri:q,index:lt,count:Et-lt,cells:Le,metadata:Ze})}replaceNotebookCellMetadata(q,fe,Le,Ze){this._edits.push({_type:le.Cell,metadata:Ze,uri:q,edit:{editType:S.CellEditType.Metadata,index:fe,metadata:Le}})}replace(q,fe,Le,Ze){this._edits.push({_type:le.Text,uri:q,edit:new oe(fe,Le),metadata:Ze})}insert(q,fe,Le,Ze){this.replace(q,new U(fe,fe),Le,Ze)}delete(q,fe,Le){this.replace(q,fe,"",Le)}has(q){return this._edits.some(fe=>fe._type===le.Text&&fe.uri.toString()===q.toString())}set(q,fe){if(fe)for(const Le of fe){if(!Le)continue;let Ze,lt;Array.isArray(Le)?(Ze=Le[0],lt=Le[1]):Ze=Le,te.isNotebookCellEdit(Ze)?Ze.newCellMetadata?this.replaceNotebookCellMetadata(q,Ze.range.start,Ze.newCellMetadata,lt):Ze.newNotebookMetadata?this.replaceNotebookMetadata(q,Ze.newNotebookMetadata,lt):this.replaceNotebookCells(q,Ze.range,Ze.newCells,lt):me.isSnippetTextEdit(Ze)?this._edits.push({_type:le.Snippet,uri:q,range:Ze.range,edit:Ze.snippet,metadata:lt}):this._edits.push({_type:le.Text,uri:q,edit:Ze,metadata:lt})}else{for(let Le=0;Le<this._edits.length;Le++){const Ze=this._edits[Le];switch(Ze._type){case le.Text:case le.Snippet:case le.Cell:case le.CellReplace:Ze.uri.toString()===q.toString()&&(this._edits[Le]=void 0);break}}(0,s.coalesceInPlace)(this._edits)}}get(q){const fe=[];for(const Le of this._edits)Le._type===le.Text&&Le.uri.toString()===q.toString()&&fe.push(Le.edit);return fe}entries(){const q=new A.ResourceMap;for(const fe of this._edits)if(fe._type===le.Text){let Le=q.get(fe.uri);Le||(Le=[fe.uri,[]],q.set(fe.uri,Le)),Le[1].push(fe.edit)}return[...q.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.WorkspaceEdit=Q,e.WorkspaceEdit=Q=Qe([b],Q);let z=t=class{static isSnippetString(q){return q instanceof t?!0:q?typeof q.value=="string":!1}static _escape(q){return q.replace(/\$|}|\\/g,"\\$&")}constructor(q){this._tabstop=1,this.value=q||""}appendText(q){return this.value+=t._escape(q),this}appendTabstop(q=this._tabstop++){return this.value+="$",this.value+=q,this}appendPlaceholder(q,fe=this._tabstop++){if(typeof q=="function"){const Le=new t;Le._tabstop=this._tabstop,q(Le),this._tabstop=Le._tabstop,q=Le.value}else q=t._escape(q);return this.value+="${",this.value+=fe,this.value+=":",this.value+=q,this.value+="}",this}appendChoice(q,fe=this._tabstop++){const Le=q.map(Ze=>Ze.replaceAll(/[|\\,]/g,"\\$&")).join(",");return this.value+="${",this.value+=fe,this.value+="|",this.value+=Le,this.value+="|}",this}appendVariable(q,fe){if(typeof fe=="function"){const Le=new t;Le._tabstop=this._tabstop,fe(Le),this._tabstop=Le._tabstop,fe=Le.value}else typeof fe=="string"&&(fe=fe.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=q,fe&&(this.value+=":",this.value+=fe),this.value+="}",this}};e.SnippetString=z,e.SnippetString=z=t=Qe([b],z);var se;(function(K){K[K.Unnecessary=1]="Unnecessary",K[K.Deprecated=2]="Deprecated"})(se||(e.DiagnosticTag=se={}));var Ee;(function(K){K[K.Hint=3]="Hint",K[K.Information=2]="Information",K[K.Warning=1]="Warning",K[K.Error=0]="Error"})(Ee||(e.DiagnosticSeverity=Ee={}));let ae=n=class{static isLocation(q){return q instanceof n?!0:q?U.isRange(q.range)&&l.URI.isUri(q.uri):!1}constructor(q,fe){if(this.uri=q,fe)if(U.isRange(fe))this.range=U.of(fe);else if(M.isPosition(fe))this.range=new U(fe,fe);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.Location=ae,e.Location=ae=n=Qe([b],ae);let be=class{static is(q){return q?typeof q.message=="string"&&q.location&&U.isRange(q.location.range)&&l.URI.isUri(q.location.uri):!1}constructor(q,fe){this.location=q,this.message=fe}static isEqual(q,fe){return q===fe?!0:!q||!fe?!1:q.message===fe.message&&q.location.range.isEqual(fe.location.range)&&q.location.uri.toString()===fe.location.uri.toString()}};e.DiagnosticRelatedInformation=be,e.DiagnosticRelatedInformation=be=Qe([b],be);let pe=class{constructor(q,fe,Le=Ee.Error){if(!U.isRange(q))throw new TypeError("range must be set");if(!fe)throw new TypeError("message must be set");this.range=q,this.message=fe,this.severity=Le}toJSON(){return{severity:Ee[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(q,fe){return q===fe?!0:!q||!fe?!1:q.message===fe.message&&q.severity===fe.severity&&q.code===fe.code&&q.severity===fe.severity&&q.source===fe.source&&q.range.isEqual(fe.range)&&(0,s.equals)(q.tags,fe.tags)&&(0,s.equals)(q.relatedInformation,fe.relatedInformation,be.isEqual)}};e.Diagnostic=pe,e.Diagnostic=pe=Qe([b],pe);let ve=class{constructor(q,fe){if(!q)throw new Error("Illegal argument, contents must be defined");Array.isArray(q)?this.contents=q:this.contents=[q],this.range=fe}};e.Hover=ve,e.Hover=ve=Qe([b],ve);let Re=class extends ve{constructor(q,fe,Le,Ze){super(q,fe),this.canIncreaseVerbosity=Le,this.canDecreaseVerbosity=Ze}};e.VerboseHover=Re,e.VerboseHover=Re=Qe([b],Re);var Fe;(function(K){K[K.Increase=0]="Increase",K[K.Decrease=1]="Decrease"})(Fe||(e.HoverVerbosityAction=Fe={}));var Ve;(function(K){K[K.Text=0]="Text",K[K.Read=1]="Read",K[K.Write=2]="Write"})(Ve||(e.DocumentHighlightKind=Ve={}));let Ye=class{constructor(q,fe=Ve.Text){this.range=q,this.kind=fe}toJSON(){return{range:this.range,kind:Ve[this.kind]}}};e.DocumentHighlight=Ye,e.DocumentHighlight=Ye=Qe([b],Ye);let Je=class{constructor(q,fe){this.uri=q,this.highlights=fe}toJSON(){return{uri:this.uri,highlights:this.highlights.map(q=>q.toJSON())}}};e.MultiDocumentHighlight=Je,e.MultiDocumentHighlight=Je=Qe([b],Je);var xe;(function(K){K[K.File=0]="File",K[K.Module=1]="Module",K[K.Namespace=2]="Namespace",K[K.Package=3]="Package",K[K.Class=4]="Class",K[K.Method=5]="Method",K[K.Property=6]="Property",K[K.Field=7]="Field",K[K.Constructor=8]="Constructor",K[K.Enum=9]="Enum",K[K.Interface=10]="Interface",K[K.Function=11]="Function",K[K.Variable=12]="Variable",K[K.Constant=13]="Constant",K[K.String=14]="String",K[K.Number=15]="Number",K[K.Boolean=16]="Boolean",K[K.Array=17]="Array",K[K.Object=18]="Object",K[K.Key=19]="Key",K[K.Null=20]="Null",K[K.EnumMember=21]="EnumMember",K[K.Struct=22]="Struct",K[K.Event=23]="Event",K[K.Operator=24]="Operator",K[K.TypeParameter=25]="TypeParameter"})(xe||(e.SymbolKind=xe={}));var ze;(function(K){K[K.Deprecated=1]="Deprecated"})(ze||(e.SymbolTag=ze={}));let Ne=r=class{static validate(q){if(!q.name)throw new Error("name must not be falsy")}constructor(q,fe,Le,Ze,lt){this.name=q,this.kind=fe,this.containerName=lt,typeof Le=="string"&&(this.containerName=Le),Ze instanceof ae?this.location=Ze:Le instanceof U&&(this.location=new ae(Ze,Le)),r.validate(this)}toJSON(){return{name:this.name,kind:xe[this.kind],location:this.location,containerName:this.containerName}}};e.SymbolInformation=Ne,e.SymbolInformation=Ne=r=Qe([b],Ne);let V=d=class{static validate(q){if(!q.name)throw new Error("name must not be falsy");if(!q.range.contains(q.selectionRange))throw new Error("selectionRange must be contained in fullRange");q.children?.forEach(d.validate)}constructor(q,fe,Le,Ze,lt){this.name=q,this.detail=fe,this.kind=Le,this.range=Ze,this.selectionRange=lt,this.children=[],d.validate(this)}};e.DocumentSymbol=V,e.DocumentSymbol=V=d=Qe([b],V);var j;(function(K){K[K.Invoke=1]="Invoke",K[K.Automatic=2]="Automatic"})(j||(e.CodeActionTriggerKind=j={}));let Y=class{constructor(q,fe){this.title=q,this.kind=fe}};e.CodeAction=Y,e.CodeAction=Y=Qe([b],Y);let ee=class{static{c=this}static{this.sep="."}constructor(q){this.value=q}append(q){return new c(this.value?this.value+c.sep+q:q)}intersects(q){return this.contains(q)||q.contains(this)}contains(q){return this.value===q.value||q.value.startsWith(this.value+c.sep)}};e.CodeActionKind=ee,e.CodeActionKind=ee=c=Qe([b],ee),ee.Empty=new ee(""),ee.QuickFix=ee.Empty.append("quickfix"),ee.Refactor=ee.Empty.append("refactor"),ee.RefactorExtract=ee.Refactor.append("extract"),ee.RefactorInline=ee.Refactor.append("inline"),ee.RefactorMove=ee.Refactor.append("move"),ee.RefactorRewrite=ee.Refactor.append("rewrite"),ee.Source=ee.Empty.append("source"),ee.SourceOrganizeImports=ee.Source.append("organizeImports"),ee.SourceFixAll=ee.Source.append("fixAll"),ee.Notebook=ee.Empty.append("notebook");let ue=class{constructor(q,fe){if(this.range=q,this.parent=fe,fe&&!fe.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.SelectionRange=ue,e.SelectionRange=ue=Qe([b],ue);class we{constructor(q,fe,Le,Ze,lt,Et){this.kind=q,this.name=fe,this.detail=Le,this.uri=Ze,this.range=lt,this.selectionRange=Et}}e.CallHierarchyItem=we;class Ae{constructor(q,fe){this.fromRanges=fe,this.from=q}}e.CallHierarchyIncomingCall=Ae;class He{constructor(q,fe){this.fromRanges=fe,this.to=q}}e.CallHierarchyOutgoingCall=He;var Ge;(function(K){K[K.Information=0]="Information",K[K.Warning=1]="Warning",K[K.Error=2]="Error"})(Ge||(e.LanguageStatusSeverity=Ge={}));let nt=class{constructor(q,fe){this.range=q,this.command=fe}get isResolved(){return!!this.command}};e.CodeLens=nt,e.CodeLens=nt=Qe([b],nt);let ot=g=class{#e;static isMarkdownString(q){return q instanceof g?!0:q&&q.appendCodeblock&&q.appendMarkdown&&q.appendText&&q.value!==void 0}constructor(q,fe=!1){this.#e=new D.MarkdownString(q,{supportThemeIcons:fe})}get value(){return this.#e.value}set value(q){this.#e.value=q}get isTrusted(){return this.#e.isTrusted}set isTrusted(q){this.#e.isTrusted=q}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(q){this.#e.supportThemeIcons=q}get supportHtml(){return this.#e.supportHtml}set supportHtml(q){this.#e.supportHtml=q}get baseUri(){return this.#e.baseUri}set baseUri(q){this.#e.baseUri=q}appendText(q){return this.#e.appendText(q),this}appendMarkdown(q){return this.#e.appendMarkdown(q),this}appendCodeblock(q,fe){return this.#e.appendCodeblock(fe??"",q),this}};e.MarkdownString=ot,e.MarkdownString=ot=g=Qe([b],ot);let dt=class{constructor(q,fe){this.label=q,this.documentation=fe}};e.ParameterInformation=dt,e.ParameterInformation=dt=Qe([b],dt);let at=class{constructor(q,fe){this.label=q,this.documentation=fe,this.parameters=[]}};e.SignatureInformation=at,e.SignatureInformation=at=Qe([b],at);let ct=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.SignatureHelp=ct,e.SignatureHelp=ct=Qe([b],ct);var vt;(function(K){K[K.Invoke=1]="Invoke",K[K.TriggerCharacter=2]="TriggerCharacter",K[K.ContentChange=3]="ContentChange"})(vt||(e.SignatureHelpTriggerKind=vt={}));var it;(function(K){K[K.Type=1]="Type",K[K.Parameter=2]="Parameter"})(it||(e.InlayHintKind=it={}));let Ce=class{constructor(q){this.value=q}};e.InlayHintLabelPart=Ce,e.InlayHintLabelPart=Ce=Qe([b],Ce);let re=class{constructor(q,fe,Le){this.position=q,this.label=fe,this.kind=Le}};e.InlayHint=re,e.InlayHint=re=Qe([b],re);var ce;(function(K){K[K.Invoke=0]="Invoke",K[K.TriggerCharacter=1]="TriggerCharacter",K[K.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(ce||(e.CompletionTriggerKind=ce={}));var ye;(function(K){K[K.Text=0]="Text",K[K.Method=1]="Method",K[K.Function=2]="Function",K[K.Constructor=3]="Constructor",K[K.Field=4]="Field",K[K.Variable=5]="Variable",K[K.Class=6]="Class",K[K.Interface=7]="Interface",K[K.Module=8]="Module",K[K.Property=9]="Property",K[K.Unit=10]="Unit",K[K.Value=11]="Value",K[K.Enum=12]="Enum",K[K.Keyword=13]="Keyword",K[K.Snippet=14]="Snippet",K[K.Color=15]="Color",K[K.File=16]="File",K[K.Reference=17]="Reference",K[K.Folder=18]="Folder",K[K.EnumMember=19]="EnumMember",K[K.Constant=20]="Constant",K[K.Struct=21]="Struct",K[K.Event=22]="Event",K[K.Operator=23]="Operator",K[K.TypeParameter=24]="TypeParameter",K[K.User=25]="User",K[K.Issue=26]="Issue"})(ye||(e.CompletionItemKind=ye={}));var he;(function(K){K[K.Deprecated=1]="Deprecated"})(he||(e.CompletionItemTag=he={}));let Ie=class{constructor(q,fe){this.label=q,this.kind=fe}toJSON(){return{label:this.label,kind:this.kind&&ye[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.CompletionItem=Ie,e.CompletionItem=Ie=Qe([b],Ie);let ne=class{constructor(q=[],fe=!1){this.items=q,this.isIncomplete=fe}};e.CompletionList=ne,e.CompletionList=ne=Qe([b],ne);let X=class{constructor(q,fe,Le){this.insertText=q,this.range=fe,this.command=Le}};e.InlineSuggestion=X,e.InlineSuggestion=X=Qe([b],X);let Te=class{constructor(q){this.commands=void 0,this.suppressSuggestions=void 0,this.items=q}};e.InlineSuggestionList=Te,e.InlineSuggestionList=Te=Qe([b],Te);var qe;(function(K){K[K.Unknown=0]="Unknown",K[K.Word=1]="Word",K[K.Line=2]="Line",K[K.Suggest=3]="Suggest"})(qe||(e.PartialAcceptTriggerKind=qe={}));var Xe;(function(K){K[K.Active=-1]="Active",K[K.Beside=-2]="Beside",K[K.One=1]="One",K[K.Two=2]="Two",K[K.Three=3]="Three",K[K.Four=4]="Four",K[K.Five=5]="Five",K[K.Six=6]="Six",K[K.Seven=7]="Seven",K[K.Eight=8]="Eight",K[K.Nine=9]="Nine"})(Xe||(e.ViewColumn=Xe={}));var st;(function(K){K[K.Left=1]="Left",K[K.Right=2]="Right"})(st||(e.StatusBarAlignment=st={}));function ht(K,q){return`${_.ExtensionIdentifier.toKey(K)}.${q}`}var gt;(function(K){K[K.Off=0]="Off",K[K.On=1]="On",K[K.Relative=2]="Relative",K[K.Interval=3]="Interval"})(gt||(e.TextEditorLineNumbersStyle=gt={}));var It;(function(K){K[K.Manual=1]="Manual",K[K.AfterDelay=2]="AfterDelay",K[K.FocusOut=3]="FocusOut"})(It||(e.TextDocumentSaveReason=It={}));var At;(function(K){K[K.Default=0]="Default",K[K.InCenter=1]="InCenter",K[K.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",K[K.AtTop=3]="AtTop"})(At||(e.TextEditorRevealType=At={}));var qt;(function(K){K[K.Keyboard=1]="Keyboard",K[K.Mouse=2]="Mouse",K[K.Command=3]="Command"})(qt||(e.TextEditorSelectionChangeKind=qt={}));var ei;(function(K){K[K.Undo=1]="Undo",K[K.Redo=2]="Redo"})(ei||(e.TextDocumentChangeReason=ei={}));var tt;(function(K){K[K.OpenOpen=0]="OpenOpen",K[K.ClosedClosed=1]="ClosedClosed",K[K.OpenClosed=2]="OpenClosed",K[K.ClosedOpen=3]="ClosedOpen"})(tt||(e.DecorationRangeBehavior=tt={})),function(K){function q(fe){switch(fe){case"keyboard":return K.Keyboard;case"mouse":return K.Mouse;case"api":return K.Command}}K.fromValue=q}(qt||(e.TextEditorSelectionChangeKind=qt={}));var Lt;(function(K){K[K.Other=0]="Other",K[K.Comment=1]="Comment",K[K.String=2]="String",K[K.RegEx=3]="RegEx"})(Lt||(e.SyntaxTokenType=Lt={})),function(K){function q(fe){switch(fe){case K.Other:return"other";case K.Comment:return"comment";case K.String:return"string";case K.RegEx:return"regex"}return"other"}K.toString=q}(Lt||(e.SyntaxTokenType=Lt={}));let Ut=class{constructor(q,fe){if(fe&&!l.URI.isUri(fe))throw(0,h.illegalArgument)("target");if(!U.isRange(q)||q.isEmpty)throw(0,h.illegalArgument)("range");this.range=q,this.target=fe}};e.DocumentLink=Ut,e.DocumentLink=Ut=Qe([b],Ut);let bt=class{constructor(q,fe,Le,Ze){this.red=q,this.green=fe,this.blue=Le,this.alpha=Ze}};e.Color=bt,e.Color=bt=Qe([b],bt);let Pt=class{constructor(q,fe){if(fe&&!(fe instanceof bt))throw(0,h.illegalArgument)("color");if(!U.isRange(q)||q.isEmpty)throw(0,h.illegalArgument)("range");this.range=q,this.color=fe}};e.ColorInformation=Pt,e.ColorInformation=Pt=Qe([b],Pt);let ti=class{constructor(q){if(!q||typeof q!="string")throw(0,h.illegalArgument)("label");this.label=q}};e.ColorPresentation=ti,e.ColorPresentation=ti=Qe([b],ti);var ii;(function(K){K[K.RGB=0]="RGB",K[K.HEX=1]="HEX",K[K.HSL=2]="HSL"})(ii||(e.ColorFormat=ii={}));var Kt;(function(K){K[K.Error=0]="Error",K[K.Warning=1]="Warning",K[K.Information=2]="Information"})(Kt||(e.SourceControlInputBoxValidationType=Kt={}));var St;(function(K){K[K.Unknown=0]="Unknown",K[K.Shutdown=1]="Shutdown",K[K.Process=2]="Process",K[K.User=3]="User",K[K.Extension=4]="Extension"})(St||(e.TerminalExitReason=St={}));var Ot;(function(K){K[K.Low=0]="Low",K[K.Medium=1]="Medium",K[K.High=2]="High"})(Ot||(e.TerminalShellExecutionCommandLineConfidence=Ot={}));class li{constructor(q,fe,Le){if(this.startIndex=q,this.length=fe,this.tooltip=Le,typeof q!="number"||q<0)throw(0,h.illegalArgument)("startIndex");if(typeof fe!="number"||fe<1)throw(0,h.illegalArgument)("length");if(Le!==void 0&&typeof Le!="string")throw(0,h.illegalArgument)("tooltip")}}e.TerminalLink=li;class Yt{constructor(q){this.uri=q}}e.TerminalQuickFixOpener=Yt;class et{constructor(q){this.terminalCommand=q}}e.TerminalQuickFixCommand=et;var ni;(function(K){K[K.Panel=1]="Panel",K[K.Editor=2]="Editor"})(ni||(e.TerminalLocation=ni={}));class ci{constructor(q){if(this.options=q,typeof q!="object")throw(0,h.illegalArgument)("options")}}e.TerminalProfile=ci;var di;(function(K){K[K.Always=1]="Always",K[K.Silent=2]="Silent",K[K.Never=3]="Never"})(di||(e.TaskRevealKind=di={}));var Ct;(function(K){K[K.Shared=1]="Shared",K[K.Dedicated=2]="Dedicated",K[K.New=3]="New"})(Ct||(e.TaskPanelKind=Ct={}));let Wt=class{static{w=this}static{this.Clean=new w("clean","Clean")}static{this.Build=new w("build","Build")}static{this.Rebuild=new w("rebuild","Rebuild")}static{this.Test=new w("test","Test")}static from(q){switch(q){case"clean":return w.Clean;case"build":return w.Build;case"rebuild":return w.Rebuild;case"test":return w.Test;default:return}}constructor(q,fe){if(this.label=fe,typeof q!="string"||typeof fe!="string")throw(0,h.illegalArgument)("name");this._id=q}get id(){return this._id}};e.TaskGroup=Wt,e.TaskGroup=Wt=w=Qe([b],Wt);function Nt(K){let q="";for(let fe=0;fe<K.length;fe++)q+=K[fe].replace(/,/g,",,")+",";return q}let Bt=class{constructor(q,fe,Le){if(typeof q!="string")throw(0,h.illegalArgument)("process");this._args=[],this._process=q,fe!==void 0&&(Array.isArray(fe)?(this._args=fe,this._options=Le):this._options=fe)}get process(){return this._process}set process(q){if(typeof q!="string")throw(0,h.illegalArgument)("process");this._process=q}get args(){return this._args}set args(q){Array.isArray(q)||(q=[]),this._args=q}get options(){return this._options}set options(q){this._options=q}computeId(){const q=[];if(q.push("process"),this._process!==void 0&&q.push(this._process),this._args&&this._args.length>0)for(const fe of this._args)q.push(fe);return Nt(q)}};e.ProcessExecution=Bt,e.ProcessExecution=Bt=Qe([b],Bt);let ai=class{constructor(q,fe,Le){if(this._args=[],Array.isArray(fe)){if(!q)throw(0,h.illegalArgument)("command can't be undefined or null");if(typeof q!="string"&&typeof q.value!="string")throw(0,h.illegalArgument)("command");this._command=q,this._args=fe,this._options=Le}else{if(typeof q!="string")throw(0,h.illegalArgument)("commandLine");this._commandLine=q,this._options=fe}}get commandLine(){return this._commandLine}set commandLine(q){if(typeof q!="string")throw(0,h.illegalArgument)("commandLine");this._commandLine=q}get command(){return this._command?this._command:""}set command(q){if(typeof q!="string"&&typeof q.value!="string")throw(0,h.illegalArgument)("command");this._command=q}get args(){return this._args}set args(q){this._args=q||[]}get options(){return this._options}set options(q){this._options=q}computeId(){const q=[];if(q.push("shell"),this._commandLine!==void 0&&q.push(this._commandLine),this._command!==void 0&&q.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(const fe of this._args)q.push(typeof fe=="string"?fe:fe.value);return Nt(q)}};e.ShellExecution=ai,e.ShellExecution=ai=Qe([b],ai);var ri;(function(K){K[K.Escape=1]="Escape",K[K.Strong=2]="Strong",K[K.Weak=3]="Weak"})(ri||(e.ShellQuoting=ri={}));var si;(function(K){K[K.Global=1]="Global",K[K.Workspace=2]="Workspace"})(si||(e.TaskScope=si={}));class Gt{constructor(q){this._callback=q}computeId(){return"customExecution"+(0,C.generateUuid)()}set callback(q){this._callback=q}get callback(){return this._callback}}e.CustomExecution=Gt;let Xt=class{static{y=this}static{this.ExtensionCallbackType="customExecution"}static{this.ProcessType="process"}static{this.ShellType="shell"}static{this.EmptyType="$empty"}constructor(q,fe,Le,Ze,lt,Et){this.__deprecated=!1,this._definition=this.definition=q;let _t;typeof fe=="string"?(this._name=this.name=fe,this._source=this.source=Le,this.execution=Ze,_t=lt,this.__deprecated=!0):fe===si.Global||fe===si.Workspace?(this.target=fe,this._name=this.name=Le,this._source=this.source=Ze,this.execution=lt,_t=Et):(this.target=fe,this._name=this.name=Le,this._source=this.source=Ze,this.execution=lt,_t=Et),typeof _t=="string"?(this._problemMatchers=[_t],this._hasDefinedMatchers=!0):Array.isArray(_t)?(this._problemMatchers=_t,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(q){this.__id=q}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof Bt?this._definition={type:y.ProcessType,id:this._execution.computeId()}:this._execution instanceof ai?this._definition={type:y.ShellType,id:this._execution.computeId()}:this._execution instanceof Gt?this._definition={type:y.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:y.EmptyType,id:(0,C.generateUuid)()}}get definition(){return this._definition}set definition(q){if(q==null)throw(0,h.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=q}get scope(){return this._scope}set target(q){this.clear(),this._scope=q}get name(){return this._name}set name(q){if(typeof q!="string")throw(0,h.illegalArgument)("name");this.clear(),this._name=q}get execution(){return this._execution}set execution(q){q===null&&(q=void 0),this.clear(),this._execution=q;const fe=this._definition.type;(y.EmptyType===fe||y.ProcessType===fe||y.ShellType===fe||y.ExtensionCallbackType===fe)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(q){if(Array.isArray(q))this.clear(),this._problemMatchers=q,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(q){q!==!0&&q!==!1&&(q=!1),this.clear(),this._isBackground=q}get source(){return this._source}set source(q){if(typeof q!="string"||q.length===0)throw(0,h.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=q}get group(){return this._group}set group(q){q===null&&(q=void 0),this.clear(),this._group=q}get detail(){return this._detail}set detail(q){q===null&&(q=void 0),this._detail=q}get presentationOptions(){return this._presentationOptions}set presentationOptions(q){q==null&&(q=Object.create(null)),this.clear(),this._presentationOptions=q}get runOptions(){return this._runOptions}set runOptions(q){q==null&&(q=Object.create(null)),this.clear(),this._runOptions=q}};e.Task=Xt,e.Task=Xt=y=Qe([b],Xt);var ui;(function(K){K[K.SourceControl=1]="SourceControl",K[K.Window=10]="Window",K[K.Notification=15]="Notification"})(ui||(e.ProgressLocation=ui={}));var Mt;(function(K){function q(fe){const Le=fe;return(0,v.isNumber)(Le.value)?Le.tooltip&&!(0,v.isString)(Le.tooltip)?(console.log("INVALID view badge, invalid tooltip",Le.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Le.value),!1)}K.isViewBadge=q})(Mt||(e.ViewBadge=Mt={}));let kt=I=class{static isTreeItem(q,fe){const Le=q;if(Le.checkboxState!==void 0){const Ze=(0,v.isNumber)(Le.checkboxState)?Le.checkboxState:(0,v.isObject)(Le.checkboxState)&&(0,v.isNumber)(Le.checkboxState.state)?Le.checkboxState.state:void 0,lt=!(0,v.isNumber)(Le.checkboxState)&&(0,v.isObject)(Le.checkboxState)?Le.checkboxState.tooltip:void 0;if(Ze===void 0||Ze!==Qt.Checked&&Ze!==Qt.Unchecked||lt!==void 0&&!(0,v.isString)(lt))return console.log("INVALID tree item, invalid checkboxState",Le.checkboxState),!1}if(q instanceof I)return!0;if(Le.label!==void 0&&!(0,v.isString)(Le.label)&&!Le.label?.label)return console.log("INVALID tree item, invalid label",Le.label),!1;if(Le.id!==void 0&&!(0,v.isString)(Le.id))return console.log("INVALID tree item, invalid id",Le.id),!1;if(Le.iconPath!==void 0&&!(0,v.isString)(Le.iconPath)&&!l.URI.isUri(Le.iconPath)&&(!Le.iconPath||!(0,v.isString)(Le.iconPath.id))){const Ze=Le.iconPath;if(!Ze||!(0,v.isString)(Ze.light)&&!l.URI.isUri(Ze.light)&&!(0,v.isString)(Ze.dark)&&!l.URI.isUri(Ze.dark))return console.log("INVALID tree item, invalid iconPath",Le.iconPath),!1}return Le.description!==void 0&&!(0,v.isString)(Le.description)&&typeof Le.description!="boolean"?(console.log("INVALID tree item, invalid description",Le.description),!1):Le.resourceUri!==void 0&&!l.URI.isUri(Le.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",Le.resourceUri),!1):Le.tooltip!==void 0&&!(0,v.isString)(Le.tooltip)&&!(Le.tooltip instanceof ot)?(console.log("INVALID tree item, invalid tooltip",Le.tooltip),!1):Le.command!==void 0&&!Le.command.command?(console.log("INVALID tree item, invalid command",Le.command),!1):Le.collapsibleState!==void 0&&Le.collapsibleState<wt.None&&Le.collapsibleState>wt.Expanded?(console.log("INVALID tree item, invalid collapsibleState",Le.collapsibleState),!1):Le.contextValue!==void 0&&!(0,v.isString)(Le.contextValue)?(console.log("INVALID tree item, invalid contextValue",Le.contextValue),!1):Le.accessibilityInformation!==void 0&&!Le.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",Le.accessibilityInformation),!1):!0}constructor(q,fe=wt.None){this.collapsibleState=fe,l.URI.isUri(q)?this.resourceUri=q:this.label=q}};e.TreeItem=kt,e.TreeItem=kt=I=Qe([b],kt);var wt;(function(K){K[K.None=0]="None",K[K.Collapsed=1]="Collapsed",K[K.Expanded=2]="Expanded"})(wt||(e.TreeItemCollapsibleState=wt={}));var Qt;(function(K){K[K.Unchecked=0]="Unchecked",K[K.Checked=1]="Checked"})(Qt||(e.TreeItemCheckboxState=Qt={}));let yt=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(q){this.value=q}};e.DataTransferItem=yt,e.DataTransferItem=yt=Qe([b],yt);class oi extends yt{}e.InternalDataTransferItem=oi;class Jt extends oi{#e;constructor(q){super(""),this.#e=q}asFile(){return this.#e}}e.InternalFileDataTransferItem=Jt;class Mi{constructor(q,fe,Le,Ze){this.name=q,this.uri=fe,this._itemId=Le,this._getData=Ze}data(){return this._getData()}}e.DataTransferFile=Mi;let hi=class{#e=new Map;constructor(q){for(const[fe,Le]of q??[]){const Ze=this.#e.get(this.#t(fe));Ze?Ze.push(Le):this.#e.set(this.#t(fe),[Le])}}get(q){return this.#e.get(this.#t(q))?.[0]}set(q,fe){this.#e.set(this.#t(q),[fe])}forEach(q,fe){for(const[Le,Ze]of this.#e)for(const lt of Ze)q.call(fe,lt,Le,this)}*[Symbol.iterator](){for(const[q,fe]of this.#e)for(const Le of fe)yield[q,Le]}#t(q){return q.toLowerCase()}};e.DataTransfer=hi,e.DataTransfer=hi=Qe([b],hi);let wi=class{constructor(q,fe,Le){this.insertText=q,this.title=fe,this.kind=Le}};e.DocumentDropEdit=wi,e.DocumentDropEdit=wi=Qe([b],wi);var $t;(function(K){K[K.Automatic=0]="Automatic",K[K.PasteAs=1]="PasteAs"})($t||(e.DocumentPasteTriggerKind=$t={}));class fi{static{this.sep="."}constructor(q){this.value=q}append(...q){return new fi((this.value?[this.value,...q]:q).join(fi.sep))}intersects(q){return this.contains(q)||q.contains(this)}contains(q){return this.value===q.value||q.value.startsWith(this.value+fi.sep)}}e.DocumentDropOrPasteEditKind=fi,fi.Empty=new fi("");class Fi{constructor(q,fe,Le){this.title=fe,this.insertText=q,this.kind=Le}}e.DocumentPasteEdit=Fi;let Rt=class{constructor(q,fe){this.id=q,this.color=fe}static isThemeIcon(q){return typeof q.id!="string"?(console.log("INVALID ThemeIcon, invalid id",q.id),!1):!0}};e.ThemeIcon=Rt,e.ThemeIcon=Rt=Qe([b],Rt),Rt.File=new Rt("file"),Rt.Folder=new Rt("folder");let _i=class{constructor(q){this.id=q}};e.ThemeColor=_i,e.ThemeColor=_i=Qe([b],_i);var Li;(function(K){K[K.Global=1]="Global",K[K.Workspace=2]="Workspace",K[K.WorkspaceFolder=3]="WorkspaceFolder"})(Li||(e.ConfigurationTarget=Li={}));let gi=class{get base(){return this._base}set base(q){this._base=q,this._baseUri=l.URI.file(q)}get baseUri(){return this._baseUri}set baseUri(q){this._baseUri=q,this._base=q.fsPath}constructor(q,fe){if(typeof q!="string"&&(!q||!l.URI.isUri(q)&&!l.URI.isUri(q.uri)))throw(0,h.illegalArgument)("base");if(typeof fe!="string")throw(0,h.illegalArgument)("pattern");typeof q=="string"?this.baseUri=l.URI.file(q):l.URI.isUri(q)?this.baseUri=q:this.baseUri=q.uri,this.pattern=fe}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.RelativePattern=gi,e.RelativePattern=gi=Qe([b],gi);const xi=new WeakMap;function Wi(K,q){xi.set(K,q)}let xt=class{constructor(q,fe,Le,Ze,lt){this.enabled=typeof q=="boolean"?q:!0,typeof fe=="string"&&(this.condition=fe),typeof Le=="string"&&(this.hitCondition=Le),typeof Ze=="string"&&(this.logMessage=Ze),typeof lt=="string"&&(this.mode=lt)}get id(){return this._id||(this._id=xi.get(this)??(0,C.generateUuid)()),this._id}};e.Breakpoint=xt,e.Breakpoint=xt=Qe([b],xt);let Ti=class extends xt{constructor(q,fe,Le,Ze,lt,Et){if(super(fe,Le,Ze,lt,Et),q===null)throw(0,h.illegalArgument)("location");this.location=q}};e.SourceBreakpoint=Ti,e.SourceBreakpoint=Ti=Qe([b],Ti);let Di=class extends xt{constructor(q,fe,Le,Ze,lt,Et){super(fe,Le,Ze,lt,Et),this.functionName=q}};e.FunctionBreakpoint=Di,e.FunctionBreakpoint=Di=Qe([b],Di);let Ei=class extends xt{constructor(q,fe,Le,Ze,lt,Et,_t,Zt){if(super(Ze,lt,Et,_t,Zt),!fe)throw(0,h.illegalArgument)("dataId");this.label=q,this.dataId=fe,this.canPersist=Le}};e.DataBreakpoint=Ei,e.DataBreakpoint=Ei=Qe([b],Ei);let bi=class{constructor(q,fe,Le){this.command=q,this.args=fe||[],this.options=Le}};e.DebugAdapterExecutable=bi,e.DebugAdapterExecutable=bi=Qe([b],bi);let De=class{constructor(q,fe){this.port=q,this.host=fe}};e.DebugAdapterServer=De,e.DebugAdapterServer=De=Qe([b],De);let Me=class{constructor(q){this.path=q}};e.DebugAdapterNamedPipeServer=Me,e.DebugAdapterNamedPipeServer=Me=Qe([b],Me);let Se=class{constructor(q){this.implementation=q}};e.DebugAdapterInlineImplementation=Se,e.DebugAdapterInlineImplementation=Se=Qe([b],Se);class ie{constructor(q,fe,Le){this.session=q,this.threadId=fe,this.frameId=Le}}e.DebugStackFrame=ie;class Oe{constructor(q,fe){this.session=q,this.threadId=fe}}e.DebugThread=Oe;let Ke=class{constructor(q,fe){this.range=q,this.expression=fe}};e.EvaluatableExpression=Ke,e.EvaluatableExpression=Ke=Qe([b],Ke);var rt;(function(K){K[K.Invoke=0]="Invoke",K[K.Automatic=1]="Automatic"})(rt||(e.InlineCompletionTriggerKind=rt={}));let je=class{constructor(q,fe){this.range=q,this.text=fe}};e.InlineValueText=je,e.InlineValueText=je=Qe([b],je);let ut=class{constructor(q,fe,Le=!0){this.range=q,this.variableName=fe,this.caseSensitiveLookup=Le}};e.InlineValueVariableLookup=ut,e.InlineValueVariableLookup=ut=Qe([b],ut);let pt=class{constructor(q,fe){this.range=q,this.expression=fe}};e.InlineValueEvaluatableExpression=pt,e.InlineValueEvaluatableExpression=pt=Qe([b],pt);let jt=class{constructor(q,fe){this.frameId=q,this.stoppedLocation=fe}};e.InlineValueContext=jt,e.InlineValueContext=jt=Qe([b],jt);var Ht;(function(K){K[K.AIGenerated=1]="AIGenerated"})(Ht||(e.NewSymbolNameTag=Ht={}));var zt;(function(K){K[K.Invoke=0]="Invoke",K[K.Automatic=1]="Automatic"})(zt||(e.NewSymbolNameTriggerKind=zt={}));class Oi{constructor(q,fe){this.newSymbolName=q,this.tags=fe}}e.NewSymbolName=Oi;var en;(function(K){K[K.Changed=1]="Changed",K[K.Created=2]="Created",K[K.Deleted=3]="Deleted"})(en||(e.FileChangeType=en={}));let Hi=P=class extends Error{static FileExists(q){return new P(q,f.FileSystemProviderErrorCode.FileExists,P.FileExists)}static FileNotFound(q){return new P(q,f.FileSystemProviderErrorCode.FileNotFound,P.FileNotFound)}static FileNotADirectory(q){return new P(q,f.FileSystemProviderErrorCode.FileNotADirectory,P.FileNotADirectory)}static FileIsADirectory(q){return new P(q,f.FileSystemProviderErrorCode.FileIsADirectory,P.FileIsADirectory)}static NoPermissions(q){return new P(q,f.FileSystemProviderErrorCode.NoPermissions,P.NoPermissions)}static Unavailable(q){return new P(q,f.FileSystemProviderErrorCode.Unavailable,P.Unavailable)}constructor(q,fe=f.FileSystemProviderErrorCode.Unknown,Le){super(l.URI.isUri(q)?q.toString(!0):q),this.code=Le?.name??"Unknown",(0,f.markAsFileSystemProviderError)(this,fe),Object.setPrototypeOf(this,P.prototype),typeof Error.captureStackTrace=="function"&&typeof Le=="function"&&Error.captureStackTrace(this,Le)}};e.FileSystemError=Hi,e.FileSystemError=Hi=P=Qe([b],Hi);let yi=class{constructor(q,fe,Le){this.start=q,this.end=fe,this.kind=Le}};e.FoldingRange=yi,e.FoldingRange=yi=Qe([b],yi);var tn;(function(K){K[K.Comment=1]="Comment",K[K.Imports=2]="Imports",K[K.Region=3]="Region"})(tn||(e.FoldingRangeKind=tn={}));var nn;(function(K){K[K.Collapsed=0]="Collapsed",K[K.Expanded=1]="Expanded"})(nn||(e.CommentThreadCollapsibleState=nn={}));var Ui;(function(K){K[K.Editing=0]="Editing",K[K.Preview=1]="Preview"})(Ui||(e.CommentMode=Ui={}));var rn;(function(K){K[K.Published=0]="Published",K[K.Draft=1]="Draft"})(rn||(e.CommentState=rn={}));var Bi;(function(K){K[K.Unresolved=0]="Unresolved",K[K.Resolved=1]="Resolved"})(Bi||(e.CommentThreadState=Bi={}));var Vi;(function(K){K[K.Current=0]="Current",K[K.Outdated=1]="Outdated"})(Vi||(e.CommentThreadApplicability=Vi={}));var sn;(function(K){K[K.Reply=1]="Reply",K[K.Comment=2]="Comment"})(sn||(e.CommentThreadFocus=sn={}));class on{constructor(q,fe=[]){this.tokenTypes=q,this.tokenModifiers=fe}}e.SemanticTokensLegend=on;function En(K){return typeof K>"u"||(0,v.isStringArray)(K)}class Pi{constructor(q){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,q){this._hasLegend=!0;for(let fe=0,Le=q.tokenTypes.length;fe<Le;fe++)this._tokenTypeStrToInt.set(q.tokenTypes[fe],fe);for(let fe=0,Le=q.tokenModifiers.length;fe<Le;fe++)this._tokenModifierStrToInt.set(q.tokenModifiers[fe],fe)}}push(q,fe,Le,Ze,lt){if(typeof q=="number"&&typeof fe=="number"&&typeof Le=="number"&&typeof Ze=="number"&&(typeof lt=="number"||typeof lt>"u"))return typeof lt>"u"&&(lt=0),this._pushEncoded(q,fe,Le,Ze,lt);if(U.isRange(q)&&typeof fe=="string"&&En(Le))return this._push(q,fe,Le);throw(0,h.illegalArgument)()}_push(q,fe,Le){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(q.start.line!==q.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(fe))throw new Error("`tokenType` is not in the provided legend");const Ze=q.start.line,lt=q.start.character,Et=q.end.character-q.start.character,_t=this._tokenTypeStrToInt.get(fe);let Zt=0;if(Le)for(const vi of Le){if(!this._tokenModifierStrToInt.has(vi))throw new Error("`tokenModifier` is not in the provided legend");const Si=this._tokenModifierStrToInt.get(vi);Zt|=1<<Si>>>0}this._pushEncoded(Ze,lt,Et,_t,Zt)}_pushEncoded(q,fe,Le,Ze,lt){if(this._dataIsSortedAndDeltaEncoded&&(q<this._prevLine||q===this._prevLine&&fe<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const Zt=this._data.length/5|0;let vi=0,Si=0;for(let Ci=0;Ci<Zt;Ci++){let Ai=this._data[5*Ci],Ji=this._data[5*Ci+1];Ai===0?(Ai=vi,Ji+=Si):Ai+=vi,this._data[5*Ci]=Ai,this._data[5*Ci+1]=Ji,vi=Ai,Si=Ji}}let Et=q,_t=fe;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(Et-=this._prevLine,Et===0&&(_t-=this._prevChar)),this._data[this._dataLen++]=Et,this._data[this._dataLen++]=_t,this._data[this._dataLen++]=Le,this._data[this._dataLen++]=Ze,this._data[this._dataLen++]=lt,this._prevLine=q,this._prevChar=fe}static _sortAndDeltaEncode(q){const fe=[],Le=q.length/5|0;for(let _t=0;_t<Le;_t++)fe[_t]=_t;fe.sort((_t,Zt)=>{const vi=q[5*_t],Si=q[5*Zt];if(vi===Si){const Ci=q[5*_t+1],Ai=q[5*Zt+1];return Ci-Ai}return vi-Si});const Ze=new Uint32Array(q.length);let lt=0,Et=0;for(let _t=0;_t<Le;_t++){const Zt=5*fe[_t],vi=q[Zt+0],Si=q[Zt+1],Ci=q[Zt+2],Ai=q[Zt+3],Ji=q[Zt+4],Vn=vi-lt,Mr=Vn===0?Si-Et:Si,Zi=5*_t;Ze[Zi+0]=Vn,Ze[Zi+1]=Mr,Ze[Zi+2]=Ci,Ze[Zi+3]=Ai,Ze[Zi+4]=Ji,lt=vi,Et=Si}return Ze}build(q){return this._dataIsSortedAndDeltaEncoded?new qi(new Uint32Array(this._data),q):new qi(Pi._sortAndDeltaEncode(this._data),q)}}e.SemanticTokensBuilder=Pi;class qi{constructor(q,fe){this.resultId=fe,this.data=q}}e.SemanticTokens=qi;class bn{constructor(q,fe,Le){this.start=q,this.deleteCount=fe,this.data=Le}}e.SemanticTokensEdit=bn;class Sn{constructor(q,fe){this.resultId=fe,this.edits=q}}e.SemanticTokensEdits=Sn;var zi;(function(K){K[K.Separate=0]="Separate",K[K.MergeWithParent=1]="MergeWithParent"})(zi||(e.DebugConsoleMode=zi={}));class an{constructor(q){this.name=q}}e.DebugVisualization=an;var Be;(function(K){K[K.Title=1]="Title",K[K.Inline=2]="Inline"})(Be||(e.QuickInputButtonLocation=Be={}));let mi=class{static{this.Back={iconPath:new Rt("arrow-left")}}constructor(){}};e.QuickInputButtons=mi,e.QuickInputButtons=mi=Qe([b],mi);var ji;(function(K){K[K.Separator=-1]="Separator",K[K.Default=0]="Default"})(ji||(e.QuickPickItemKind=ji={}));var ft;(function(K){K[K.Info=1]="Info",K[K.Warning=2]="Warning",K[K.Error=3]="Error"})(ft||(e.InputBoxValidationSeverity=ft={}));var Tt;(function(K){K[K.UI=1]="UI",K[K.Workspace=2]="Workspace"})(Tt||(e.ExtensionKind=Tt={}));class wn{static validate(q){if(typeof q.badge=="string"){let fe=(0,R.nextCharLength)(q.badge,0);if(fe<q.badge.length&&(fe+=(0,R.nextCharLength)(q.badge,fe)),q.badge.length>fe)throw new Error("The 'badge'-property must be undefined or a short character")}else if(q.badge&&!Rt.isThemeIcon(q.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!q.color&&!q.badge&&!q.tooltip)throw new Error("The decoration is empty");return!0}constructor(q,fe,Le){this.badge=q,this.tooltip=fe,this.color=Le}}e.FileDecoration=wn;let Ki=class{constructor(q){this.kind=q}};e.ColorTheme=Ki,e.ColorTheme=Ki=Qe([b],Ki);var Gi;(function(K){K[K.Light=1]="Light",K[K.Dark=2]="Dark",K[K.HighContrast=3]="HighContrast",K[K.HighContrastLight=4]="HighContrastLight"})(Gi||(e.ColorThemeKind=Gi={}));class Ii{static isNotebookRange(q){return q instanceof Ii?!0:q?typeof q.start=="number"&&typeof q.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}constructor(q,fe){if(q<0)throw(0,h.illegalArgument)("start must be positive");if(fe<0)throw(0,h.illegalArgument)("end must be positive");q<=fe?(this._start=q,this._end=fe):(this._start=fe,this._end=q)}with(q){let fe=this._start,Le=this._end;return q.start!==void 0&&(fe=q.start),q.end!==void 0&&(Le=q.end),fe===this._start&&Le===this._end?this:new Ii(fe,Le)}}e.NotebookRange=Ii;class ki{static validate(q){if(typeof q.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof q.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof q.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(q){return Array.isArray(q)&&q.every(fe=>ki.isNotebookCellData(fe))}static isNotebookCellData(q){return!0}constructor(q,fe,Le,Ze,lt,Et,_t){this.kind=q,this.value=fe,this.languageId=Le,this.mime=Ze,this.outputs=lt??[],this.metadata=Et,this.executionSummary=_t,ki.validate(this)}}e.NotebookCellData=ki;class _n{constructor(q){this.cells=q}}e.NotebookData=_n;class pi{static isNotebookCellOutputItem(q){return q instanceof pi?!0:q?typeof q.mime=="string"&&q.data instanceof Uint8Array:!1}static error(q){const fe={name:q.name,message:q.message,stack:q.stack};return pi.json(fe,"application/vnd.code.notebook.error")}static stdout(q){return pi.text(q,"application/vnd.code.notebook.stdout")}static stderr(q){return pi.text(q,"application/vnd.code.notebook.stderr")}static bytes(q,fe="application/octet-stream"){return new pi(q,fe)}static#e=new TextEncoder;static text(q,fe=L.Mimes.text){const Le=pi.#e.encode(String(q));return new pi(Le,fe)}static json(q,fe="text/x-json"){const Le=JSON.stringify(q,void 0,"	");return pi.text(Le,fe)}constructor(q,fe){this.data=q,this.mime=fe;const Le=(0,L.normalizeMimeType)(fe,!0);if(!Le)throw new Error(`INVALID mime type: ${fe}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Le}}e.NotebookCellOutputItem=pi;class $i{static isNotebookCellOutput(q){return q instanceof $i?!0:!q||typeof q!="object"?!1:typeof q.id=="string"&&Array.isArray(q.items)}static ensureUniqueMimeTypes(q,fe=!1){const Le=new Set,Ze=new Set;for(let lt=0;lt<q.length;lt++){const Et=q[lt],_t=(0,L.normalizeMimeType)(Et.mime);if(!Le.has(_t)||(0,S.isTextStreamMime)(_t)){Le.add(_t);continue}Ze.add(lt),fe&&console.warn(`DUPLICATED mime type '${Et.mime}' will be dropped`)}return Ze.size===0?q:q.filter((lt,Et)=>!Ze.has(Et))}constructor(q,fe,Le){this.items=$i.ensureUniqueMimeTypes(q,!0),typeof fe=="string"?(this.id=fe,this.metadata=Le):(this.id=(0,C.generateUuid)(),this.metadata=fe??Le)}}e.NotebookCellOutput=$i;var Xi;(function(K){K[K.Markup=1]="Markup",K[K.Code=2]="Code"})(Xi||(e.NotebookCellKind=Xi={}));var ln;(function(K){K[K.Idle=1]="Idle",K[K.Pending=2]="Pending",K[K.Executing=3]="Executing"})(ln||(e.NotebookCellExecutionState=ln={}));var cn;(function(K){K[K.Left=1]="Left",K[K.Right=2]="Right"})(cn||(e.NotebookCellStatusBarAlignment=cn={}));var un;(function(K){K[K.Default=0]="Default",K[K.InCenter=1]="InCenter",K[K.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",K[K.AtTop=3]="AtTop"})(un||(e.NotebookEditorRevealType=un={}));class yn{constructor(q,fe){this.text=q,this.alignment=fe}}e.NotebookCellStatusBarItem=yn;var dn;(function(K){K[K.Default=1]="Default",K[K.Preferred=2]="Preferred"})(dn||(e.NotebookControllerAffinity=dn={}));var hn;(function(K){K[K.Default=1]="Default",K[K.Preferred=2]="Preferred",K[K.Hidden=-1]="Hidden"})(hn||(e.NotebookControllerAffinity2=hn={}));class In{constructor(q,fe=[]){this.uri=q,this.provides=(0,s.asArray)(fe)}}e.NotebookRendererScript=In;class Cn{constructor(q){this.label=q}}e.NotebookKernelSourceAction=Cn;var fn;(function(K){K[K.Named=1]="Named",K[K.Indexed=2]="Indexed"})(fn||(e.NotebookVariablesRequestKind=fn={}));let Qi=class{constructor(q,fe){this.label=q,this.timestamp=fe}};e.TimelineItem=Qi,e.TimelineItem=Qi=Qe([b],Qi);var gn;(function(K){K[K.Production=1]="Production",K[K.Development=2]="Development",K[K.Test=3]="Test"})(gn||(e.ExtensionMode=gn={}));var de;(function(K){K[K.Node=1]="Node",K[K.Webworker=2]="Webworker"})(de||(e.ExtensionRuntime=de={}));var _e;(function(K){K[K.Other=0]="Other",K[K.Comment=1]="Comment",K[K.String=2]="String",K[K.RegEx=3]="RegEx"})(_e||(e.StandardTokenType=_e={}));class Ue{constructor(q,fe){this.ranges=q,this.wordPattern=fe}}e.LinkedEditingRanges=Ue;class mt{constructor(q){this._autoForwardAction=q}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=mt;var Dt;(function(K){K[K.Queued=1]="Queued",K[K.Running=2]="Running",K[K.Passed=3]="Passed",K[K.Failed=4]="Failed",K[K.Skipped=5]="Skipped",K[K.Errored=6]="Errored"})(Dt||(e.TestResultState=Dt={}));var Ft;(function(K){K[K.Run=1]="Run",K[K.Debug=2]="Debug",K[K.Coverage=3]="Coverage"})(Ft||(e.TestRunProfileKind=Ft={}));let Ri=class{constructor(q=void 0,fe=void 0,Le=void 0,Ze=!1,lt=!0){this.include=q,this.exclude=fe,this.profile=Le,this.continuous=Ze,this.preserveFocus=lt}};e.TestRunRequest=Ri,e.TestRunRequest=Ri=Qe([b],Ri);let Yi=k=class{static diff(q,fe,Le){const Ze=new k(q);return Ze.expectedOutput=fe,Ze.actualOutput=Le,Ze}constructor(q){this.message=q}};e.TestMessage=Yi,e.TestMessage=Yi=k=Qe([b],Yi);let Tn=class{constructor(q){this.id=q}};e.TestTag=Tn,e.TestTag=Tn=Qe([b],Tn);class Kn{constructor(q,fe,Le){this.label=q,this.uri=fe,this.position=Le}}e.TestMessageStackFrame=Kn;class mn{constructor(q,fe){this.covered=q,this.total=fe,Pn(this)}}e.TestCoverageCount=mn;function Pn(K){if(K){if(K.covered>K.total)throw new Error(`The total number of covered items (${K.covered}) cannot be greater than the total (${K.total})`);if(K.total<0)throw new Error(`The number of covered items (${K.total}) cannot be negative`)}}class Dn{static fromDetails(q,fe){const Le=new mn(0,0),Ze=new mn(0,0),lt=new mn(0,0);for(const _t of fe)if("branches"in _t){Le.total+=1,Le.covered+=_t.executed?1:0;for(const Zt of _t.branches)Ze.total+=1,Ze.covered+=Zt.executed?1:0}else lt.total+=1,lt.covered+=_t.executed?1:0;const Et=new Dn(q,Le,Ze.total>0?Ze:void 0,lt.total>0?lt:void 0);return Et.detailedCoverage=fe,Et}constructor(q,fe,Le,Ze,lt=[]){this.uri=q,this.statementCoverage=fe,this.branchCoverage=Le,this.declarationCoverage=Ze,this.fromTests=lt}}e.FileCoverage=Dn;class Gn{get executionCount(){return+this.executed}set executionCount(q){this.executed=q}constructor(q,fe,Le=[]){this.executed=q,this.location=fe,this.branches=Le}}e.StatementCoverage=Gn;class Xn{get executionCount(){return+this.executed}set executionCount(q){this.executed=q}constructor(q,fe,Le){this.executed=q,this.location=fe,this.label=Le}}e.BranchCoverage=Xn;class Qn{get executionCount(){return+this.executed}set executionCount(q){this.executed=q}constructor(q,fe,Le){this.name=q,this.executed=fe,this.location=Le}}e.DeclarationCoverage=Qn;var kn;(function(K){K[K.None=0]="None",K[K.Option=1]="Option",K[K.Default=2]="Default",K[K.Preferred=3]="Preferred"})(kn||(e.ExternalUriOpenerPriority=kn={}));var Rn;(function(K){K[K.Untrusted=0]="Untrusted",K[K.Trusted=1]="Trusted",K[K.Unspecified=2]="Unspecified"})(Rn||(e.WorkspaceTrustState=Rn={}));var An;(function(K){K[K.Notify=1]="Notify",K[K.OpenBrowser=2]="OpenBrowser",K[K.OpenPreview=3]="OpenPreview",K[K.Silent=4]="Silent",K[K.Ignore=5]="Ignore",K[K.OpenBrowserOnce=6]="OpenBrowserOnce"})(An||(e.PortAutoForwardAction=An={}));class Yn{constructor(q,fe,Le,Ze,lt,Et){this.kind=q,this.name=fe,this.detail=Le,this.uri=Ze,this.range=lt,this.selectionRange=Et}}e.TypeHierarchyItem=Yn;class Jn{constructor(q){this.uri=q}}e.TextTabInput=Jn;class Zn{constructor(q,fe){this.original=q,this.modified=fe}}e.TextDiffTabInput=Zn;class er{constructor(q,fe,Le,Ze){this.base=q,this.input1=fe,this.input2=Le,this.result=Ze}}e.TextMergeTabInput=er;class tr{constructor(q,fe){this.uri=q,this.viewType=fe}}e.CustomEditorTabInput=tr;class ir{constructor(q){this.viewType=q}}e.WebviewEditorTabInput=ir;class nr{constructor(q,fe){this.uri=q,this.notebookType=fe}}e.NotebookEditorTabInput=nr;class rr{constructor(q,fe,Le){this.original=q,this.modified=fe,this.notebookType=Le}}e.NotebookDiffEditorTabInput=rr;class sr{constructor(){}}e.TerminalEditorTabInput=sr;class or{constructor(q,fe){this.uri=q,this.inputBoxUri=fe}}e.InteractiveWindowInput=or;class ar{constructor(){}}e.ChatEditorTabInput=ar;class lr{constructor(q){this.textDiffs=q}}e.TextMultiDiffTabInput=lr;var Ln;(function(K){K[K.Down=0]="Down",K[K.Up=1]="Up"})(Ln||(e.InteractiveSessionVoteDirection=Ln={}));var On;(function(K){K[K.Action=1]="Action",K[K.Toolbar=2]="Toolbar"})(On||(e.ChatCopyKind=On={}));var Nn;(function(K){K[K.Short=1]="Short",K[K.Medium=2]="Medium",K[K.Full=3]="Full"})(Nn||(e.ChatVariableLevel=Nn={}));class cr{constructor(q,fe,Le){this.id=q,this.label=fe,this.values=Le}}e.ChatCompletionItem=cr;var Mn;(function(K){K[K.Unhelpful=0]="Unhelpful",K[K.Helpful=1]="Helpful",K[K.Undone=2]="Undone",K[K.Accepted=3]="Accepted",K[K.Bug=4]="Bug"})(Mn||(e.InteractiveEditorResponseFeedbackKind=Mn={}));var Fn;(function(K){K[K.Unhelpful=0]="Unhelpful",K[K.Helpful=1]="Helpful"})(Fn||(e.ChatResultFeedbackKind=Fn={}));class ur{constructor(q){if(typeof q!="string"&&q.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof q=="string"?new ot(q):q}}e.ChatResponseMarkdownPart=ur;class dr{constructor(q,fe){if(typeof q!="string"&&q.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof q=="string"?new ot(q):q,this.vulnerabilities=fe}}e.ChatResponseMarkdownWithVulnerabilitiesPart=dr;class hr{constructor(q,fe){this.participant=q,this.command=fe}}e.ChatResponseDetectedParticipantPart=hr;class fr{constructor(q,fe,Le,Ze){this.title=q,this.message=fe,this.data=Le,this.buttons=Ze}}e.ChatResponseConfirmationPart=fr;class gr{constructor(q,fe){this.value=q,this.baseUri=fe}}e.ChatResponseFileTreePart=gr;class mr{constructor(q,fe){this.value=q,this.title=fe}}e.ChatResponseAnchorPart=mr;class pr{constructor(q){this.value=q}}e.ChatResponseProgressPart=pr;class vr{constructor(q,fe){this.value=q,this.task=fe}}e.ChatResponseProgressPart2=vr;class Er{constructor(q){if(typeof q!="string"&&q.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof q=="string"?new ot(q):q}}e.ChatResponseWarningPart=Er;class br{constructor(q){this.value=q}}e.ChatResponseCommandButtonPart=br;class Sr{constructor(q,fe,Le){this.value=q,this.iconPath=fe,this.options=Le}}e.ChatResponseReferencePart=Sr;class wr{constructor(q,fe,Le){this.value=q,this.license=fe,this.snippet=Le}}e.ChatResponseCodeCitationPart=wr;class _r{constructor(q,fe){this.uri=q,this.range=fe}}e.ChatResponseMovePart=_r;class yr{constructor(q,fe){this.uri=q,this.edits=Array.isArray(fe)?fe:[fe]}}e.ChatResponseTextEditPart=yr;class Ir{constructor(q,fe,Le,Ze){this.prompt=q,this.command=fe,this.references=Le,this.participant=Ze}}e.ChatRequestTurn=Ir;class Cr{constructor(q,fe,Le,Ze){this.response=q,this.result=fe,this.participant=Le,this.command=Ze}}e.ChatResponseTurn=Cr;var xn;(function(K){K[K.Panel=1]="Panel",K[K.Terminal=2]="Terminal",K[K.Notebook=3]="Notebook",K[K.Editor=4]="Editor"})(xn||(e.ChatLocation=xn={}));var Un;(function(K){K[K.Complete=1]="Complete",K[K.Partial=2]="Partial",K[K.Omitted=3]="Omitted"})(Un||(e.ChatResponseReferencePartStatusKind=Un={}));class Tr{constructor(q,fe,Le){this.document=q,this.selection=fe,this.wholeRange=Le}}e.ChatRequestEditorData=Tr;class Dr{constructor(q){this.cell=q}}e.ChatRequestNotebookData=Dr;var pn;(function(K){K[K.User=1]="User",K[K.Assistant=2]="Assistant",K[K.System=3]="System"})(pn||(e.LanguageModelChatMessageRole=pn={}));class Pr{constructor(q,fe,Le){this.toolCallId=q,this.content=fe,this.isError=Le??!1}}e.LanguageModelToolResultPart=Pr;class vn{static User(q,fe){const Le=new vn(pn.User,typeof q=="string"?q:"",fe);return Le.content2=[q],Le}static Assistant(q,fe){return new vn(pn.Assistant,q,fe)}constructor(q,fe,Le){this.role=q,this.content=fe,this.content2=[fe],this.name=Le}}e.LanguageModelChatMessage=vn;class kr{constructor(q,fe,Le){this.name=q,this.toolCallId=fe,this.parameters=Le}}e.LanguageModelToolCallPart=kr;class Rr{constructor(q){this.value=q}}e.LanguageModelTextPart=Rr;class Ar{constructor(q){this.content=q}}e.LanguageModelChatSystemMessage=Ar;class Lr{constructor(q,fe){this.content=q,this.name=fe}}e.LanguageModelChatUserMessage=Lr;class Or{constructor(q,fe){this.content=q,this.name=fe}}e.LanguageModelChatAssistantMessage=Or;class Ni extends Error{static NotFound(q){return new Ni(q,Ni.NotFound.name)}static NoPermissions(q){return new Ni(q,Ni.NoPermissions.name)}static Blocked(q){return new Ni(q,Ni.Blocked.name)}constructor(q,fe,Le){super(q,{cause:Le}),this.name="LanguageModelError",this.code=fe??""}}e.LanguageModelError=Ni;var Wn;(function(K){K[K.SymbolInformation=1]="SymbolInformation",K[K.CommandInformation=2]="CommandInformation",K[K.SearchInformation=3]="SearchInformation",K[K.SettingInformation=4]="SettingInformation"})(Wn||(e.RelatedInformationType=Wn={}));var Bn;(function(K){K[K.Started=1]="Started",K[K.Recognizing=2]="Recognizing",K[K.Recognized=3]="Recognized",K[K.Stopped=4]="Stopped",K[K.Error=5]="Error"})(Bn||(e.SpeechToTextStatus=Bn={}));var zn;(function(K){K[K.Started=1]="Started",K[K.Stopped=2]="Stopped",K[K.Error=3]="Error"})(zn||(e.TextToSpeechStatus=zn={}));var $n;(function(K){K[K.Recognized=1]="Recognized",K[K.Stopped=2]="Stopped"})($n||(e.KeywordRecognitionStatus=$n={}));class Nr{constructor(q,fe){this.text=q,this.range=fe}}e.InlineEdit=Nr;var Hn;(function(K){K[K.Invoke=0]="Invoke",K[K.Automatic=1]="Automatic"})(Hn||(e.InlineEditTriggerKind=Hn={}))}),define(Pe[292],ke([1,0,6,9]),function(ge,e,s,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRelatedInformation=void 0;class D{constructor(L){this._relatedInformationProviders=new Map,this._nextHandle=0,this._proxy=L.getProxy(s.MainContext.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(L,R,v){if(this._relatedInformationProviders.size===0)throw new Error("No related information providers registered");const l=this._relatedInformationProviders.get(L);if(!l)throw new Error("related information provider not found");return await l.provideRelatedInformation(R,v)??[]}getRelatedInformation(L,R,v){return this._proxy.$getAiRelatedInformation(R,v)}registerRelatedInformationProvider(L,R,v){const l=this._nextHandle;return this._nextHandle++,this._relatedInformationProviders.set(l,v),this._proxy.$registerAiRelatedInformationProvider(l,R),new h.Disposable(()=>{this._proxy.$unregisterAiRelatedInformationProvider(l),this._relatedInformationProviders.delete(l)})}}e.ExtHostRelatedInformation=D}),define(Pe[127],ke([1,0,4,6,9,23,161,5,19]),function(ge,e,s,h,D,A,L,R,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=e.IExtHostAuthentication=void 0,e.IExtHostAuthentication=(0,R.createDecorator)("IExtHostAuthentication");let l=class{constructor(f){this._authenticationProviders=new Map,this._onDidChangeSessions=new s.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._getSessionTaskSingler=new C,this._proxy=f.getProxy(h.MainContext.MainThreadAuthentication)}async getSession(f,T,S,o={}){const m=A.ExtensionIdentifier.toKey(f.identifier),p=[...S].sort().join(" ");return await this._getSessionTaskSingler.getOrCreate(`${m} ${T} ${p}`,async()=>{await this._proxy.$ensureProvider(T);const u=f.displayName||f.name;return this._proxy.$getSession(T,S,m,u,o)})}async getAccounts(f){return await this._proxy.$ensureProvider(f),await this._proxy.$getAccounts(f)}async removeSession(f,T){const S=this._authenticationProviders.get(f);return S?S.provider.removeSession(T):this._proxy.$removeSession(f,T)}registerAuthenticationProvider(f,T,S,o){if(this._authenticationProviders.get(f))throw new Error(`An authentication provider with id '${f}' is already registered.`);this._authenticationProviders.set(f,{label:T,provider:S,options:o??{supportsMultipleAccounts:!1}});const m=S.onDidChangeSessions(p=>this._proxy.$sendDidChangeSessions(f,p));return this._proxy.$registerAuthenticationProvider(f,T,o?.supportsMultipleAccounts??!1),new D.Disposable(()=>{m.dispose(),this._authenticationProviders.delete(f),this._proxy.$unregisterAuthenticationProvider(f)})}async $createSession(f,T,S){const o=this._authenticationProviders.get(f);if(o)return await o.provider.createSession(T,S);throw new Error(`Unable to find authentication provider with handle: ${f}`)}async $removeSession(f,T){const S=this._authenticationProviders.get(f);if(S)return await S.provider.removeSession(T);throw new Error(`Unable to find authentication provider with handle: ${f}`)}async $getSessions(f,T,S){const o=this._authenticationProviders.get(f);if(o)return await o.provider.getSessions(T,S);throw new Error(`Unable to find authentication provider with handle: ${f}`)}$onDidChangeAuthenticationSessions(f,T){return f.startsWith(L.INTERNAL_AUTH_PROVIDER_PREFIX)||this._onDidChangeSessions.fire({provider:{id:f,label:T}}),Promise.resolve()}};e.ExtHostAuthentication=l,e.ExtHostAuthentication=l=Qe([$e(0,v.IExtHostRpcService)],l);class C{constructor(){this._inFlightPromises=new Map}getOrCreate(f,T){const S=this._inFlightPromises.get(f);if(S)return S;const o=T().finally(()=>this._inFlightPromises.delete(f));return this._inFlightPromises.set(f,o),o}}}),define(Pe[168],ke([1,0,2,6,9,5,19,11,18,13,16,25]),function(ge,e,s,h,D,A,L,R,v,l,C,_){"use strict";var f;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let T=class{static{f=this}static{this._handlePool=0}static{this._maxEventSize=250}constructor(o,m){this._logService=m,this._provider=new Map,this._proxy=o.getProxy(h.MainContext.MainThreadDecorations)}registerFileDecorationProvider(o,m){const p=f._handlePool++;this._provider.set(p,{provider:o,extensionDescription:m}),this._proxy.$registerDecorationProvider(p,m.identifier.value);const u=o.onDidChangeFileDecorations&&o.onDidChangeFileDecorations(i=>{if(!i){this._proxy.$onDidChange(p,null);return}const a=(0,v.asArray)(i);if(a.length<=f._maxEventSize){this._proxy.$onDidChange(p,a);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",m.identifier.value,a.length);const t=a.map(d=>({uri:d,rank:(0,l.count)(d.path,"/")})),n=(0,v.groupBy)(t,(d,c)=>d.rank-c.rank||(0,l.compare)(d.uri.path,c.uri.path)),r=[];e:for(const d of n){let c;for(const g of d){const w=(0,C.dirname)(g.uri.path);if(c!==w&&(c=w,r.push(g.uri)>=f._maxEventSize))break e}}this._proxy.$onDidChange(p,r)});return new D.Disposable(()=>{u?.dispose(),this._proxy.$unregisterDecorationProvider(p),this._provider.delete(p)})}async $provideDecorations(o,m,p){if(!this._provider.has(o))return Object.create(null);const u=Object.create(null),{provider:i,extensionDescription:a}=this._provider.get(o);return await Promise.all(m.map(async t=>{try{const{uri:n,id:r}=t,d=await Promise.resolve(i.provideFileDecoration(s.URI.revive(n),p));if(!d)return;try{D.FileDecoration.validate(d),d.badge&&typeof d.badge!="string"&&(0,_.checkProposedApiEnabled)(a,"codiconDecoration"),u[r]=[d.propagate,d.tooltip,d.badge,d.color]}catch(c){this._logService.warn(`INVALID decoration from extension '${a.identifier.value}': ${c}`)}}catch(n){this._logService.error(n)}})),u}};e.ExtHostDecorations=T,e.ExtHostDecorations=T=f=Qe([$e(0,L.IExtHostRpcService),$e(1,R.ILogService)],T),e.IExtHostDecorations=(0,A.createDecorator)("IExtHostDecorations")}),define(Pe[293],ke([1,0,12,2,9,6,14,20,13]),function(ge,e,s,h,D,A,L,R,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class l{static{this._handlePool=0}constructor(_,f,T){this._documentsAndEditors=f,this._logService=T,this._documentContentProviders=new Map,this._proxy=_.getProxy(A.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(_,f){if(Object.keys(L.Schemas).indexOf(_)>=0)throw new Error(`scheme '${_}' already registered`);const T=l._handlePool++;this._documentContentProviders.set(T,f),this._proxy.$registerTextContentProvider(T,_);let S;if(typeof f.onDidChange=="function"){let o;S=f.onDidChange(async m=>{if(m.scheme!==_){this._logService.warn(`Provider for scheme '${_}' is firing event for schema '${m.scheme}' which will be IGNORED`);return}if(!this._documentsAndEditors.getDocument(m))return;o&&await o;const p=this.$provideTextDocumentContent(T,m).then(async u=>{if(!u&&typeof u!="string")return;const i=this._documentsAndEditors.getDocument(m);if(!i)return;const a=(0,v.splitLines)(u);if(!i.equalLines(a))return this._proxy.$onVirtualDocumentChange(m,u)}).catch(s.onUnexpectedError).finally(()=>{o===p&&(o=void 0)});o=p})}return new D.Disposable(()=>{this._documentContentProviders.delete(T)&&this._proxy.$unregisterTextContentProvider(T),S&&(S.dispose(),S=void 0)})}$provideTextDocumentContent(_,f){const T=this._documentContentProviders.get(_);return T?Promise.resolve(T.provideTextDocumentContent(h.URI.revive(f),R.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${f.scheme}`))}}e.ExtHostDocumentContentProvider=l}),define(Pe[169],ke([1,0,67,14,13,203,139,9,18]),function(ge,e,s,h,D,A,L,R,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=void 0,e.setWordDefinitionFor=C;const l=new Map;function C(S,o){o?l.set(S,o):l.delete(S)}function _(S){return l.get(S)}class f extends A.MirrorTextModel{constructor(o,m,p,u,i,a,t){super(m,p,u,i),this._proxy=o,this._languageId=a,this._isDirty=t,this._isDisposed=!1}dispose(){(0,s.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(o){return(0,v.equals)(this._lines,o)}get document(){if(!this._document){const o=this;this._document={get uri(){return o._uri},get fileName(){return o._uri.fsPath},get isUntitled(){return o._uri.scheme===h.Schemas.untitled},get languageId(){return o._languageId},get version(){return o._versionId},get isClosed(){return o._isDisposed},get isDirty(){return o._isDirty},save(){return o._save()},getText(m){return m?o._getTextInRange(m):o.getText()},get eol(){return o._eol===`
`?R.EndOfLine.LF:R.EndOfLine.CRLF},get lineCount(){return o._lines.length},lineAt(m){return o._lineAt(m)},offsetAt(m){return o._offsetAt(m)},positionAt(m){return o._positionAt(m)},validateRange(m){return o._validateRange(m)},validatePosition(m){return o._validatePosition(m)},getWordRangeAtPosition(m,p){return o._getWordRangeAtPosition(m,p)},[Symbol.for("debug.description")](){return`TextDocument(${o._uri.toString()})`}}}return Object.freeze(this._document)}_acceptLanguageId(o){(0,s.ok)(!this._isDisposed),this._languageId=o}_acceptIsDirty(o){(0,s.ok)(!this._isDisposed),this._isDirty=o}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(o){const m=this._validateRange(o);if(m.isEmpty)return"";if(m.isSingleLine)return this._lines[m.start.line].substring(m.start.character,m.end.character);const p=this._eol,u=m.start.line,i=m.end.line,a=[];a.push(this._lines[u].substring(m.start.character));for(let t=u+1;t<i;t++)a.push(this._lines[t]);return a.push(this._lines[i].substring(0,m.end.character)),a.join(p)}_lineAt(o){let m;if(o instanceof R.Position?m=o.line:typeof o=="number"&&(m=o),typeof m!="number"||m<0||m>=this._lines.length||Math.floor(m)!==m)throw new Error("Illegal value for `line`");return new T(m,this._lines[m],m===this._lines.length-1)}_offsetAt(o){return o=this._validatePosition(o),this._ensureLineStarts(),this._lineStarts.getPrefixSum(o.line-1)+o.character}_positionAt(o){o=Math.floor(o),o=Math.max(0,o),this._ensureLineStarts();const m=this._lineStarts.getIndexOf(o),p=this._lines[m.index].length;return new R.Position(m.index,Math.min(m.remainder,p))}_validateRange(o){if(!(o instanceof R.Range))throw new Error("Invalid argument");const m=this._validatePosition(o.start),p=this._validatePosition(o.end);return m===o.start&&p===o.end?o:new R.Range(m.line,m.character,p.line,p.character)}_validatePosition(o){if(!(o instanceof R.Position))throw new Error("Invalid argument");if(this._lines.length===0)return o.with(0,0);let{line:m,character:p}=o,u=!1;if(m<0)m=0,p=0,u=!0;else if(m>=this._lines.length)m=this._lines.length-1,p=this._lines[m].length,u=!0;else{const i=this._lines[m].length;p<0?(p=0,u=!0):p>i&&(p=i,u=!0)}return u?new R.Position(m,p):o}_getWordRangeAtPosition(o,m){const p=this._validatePosition(o);if(!m)m=_(this._languageId);else if((0,D.regExpLeadsToEndlessLoop)(m))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${m.source}' because it matches the empty string.`);const u=(0,L.getWordAtText)(p.character+1,(0,L.ensureValidWordDefinition)(m),this._lines[p.line],0);if(u)return new R.Range(p.line,u.startColumn-1,p.line,u.endColumn-1)}}e.ExtHostDocumentData=f;class T{constructor(o,m,p){this._line=o,this._text=m,this._isLastLine=p}get lineNumber(){return this._line}get text(){return this._text}get range(){return new R.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new R.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=T}),define(Pe[294],ke([1,0,6,9]),function(ge,e,s,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAiEmbeddingVector=void 0;class D{constructor(L){this._AiEmbeddingVectorProviders=new Map,this._nextHandle=0,this._proxy=L.getProxy(s.MainContext.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(L,R,v){if(this._AiEmbeddingVectorProviders.size===0)throw new Error("No embedding vector providers registered");const l=this._AiEmbeddingVectorProviders.get(L);if(!l)throw new Error("Embedding vector provider not found");const C=await l.provideEmbeddingVector(R,v);if(!C)throw new Error("Embedding vector provider returned undefined");return C}registerEmbeddingVectorProvider(L,R,v){const l=this._nextHandle;return this._nextHandle++,this._AiEmbeddingVectorProviders.set(l,v),this._proxy.$registerAiEmbeddingVectorProvider(R,l),new h.Disposable(()=>{this._proxy.$unregisterAiEmbeddingVectorProvider(l),this._AiEmbeddingVectorProviders.delete(l)})}}e.ExtHostAiEmbeddingVector=D}),define(Pe[77],ke([1,0,6,27,9,21,5,19,64,3,8,22,14]),function(ge,e,s,h,D,A,L,R,v,l,C,_,f){"use strict";var T;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0,h=We(h);let S=T=class{constructor(m,p){this._fileSystemProvider=new Map,this._writeQueue=new C.ResourceQueue,this._proxy=m.getProxy(s.MainContext.MainThreadFileSystem);const u=this;this.value=Object.freeze({async stat(i){try{let a;const t=u._fileSystemProvider.get(i.scheme);return t?(await u._proxy.$ensureActivation(i.scheme),a=await t.impl.stat(i)):a=await u._proxy.$stat(i),{type:a.type,ctime:a.ctime,mtime:a.mtime,size:a.size,permissions:a.permissions===h.FilePermission.Readonly?1:void 0}}catch(a){T._handleError(a)}},async readDirectory(i){try{const a=u._fileSystemProvider.get(i.scheme);return a?(await u._proxy.$ensureActivation(i.scheme),(await a.impl.readDirectory(i)).slice()):await u._proxy.$readdir(i)}catch(a){return T._handleError(a)}},async createDirectory(i){try{const a=u._fileSystemProvider.get(i.scheme);return a&&!a.isReadonly?(await u._proxy.$ensureActivation(i.scheme),await u.mkdirp(a.impl,a.extUri,i)):await u._proxy.$mkdir(i)}catch(a){return T._handleError(a)}},async readFile(i){try{const a=u._fileSystemProvider.get(i.scheme);return a?(await u._proxy.$ensureActivation(i.scheme),(await a.impl.readFile(i)).slice()):(await u._proxy.$readFile(i)).buffer}catch(a){return T._handleError(a)}},async writeFile(i,a){try{const t=u._fileSystemProvider.get(i.scheme);return t&&!t.isReadonly?(await u._proxy.$ensureActivation(i.scheme),await u.mkdirp(t.impl,t.extUri,t.extUri.dirname(i)),await u._writeQueue.queueFor(i,()=>Promise.resolve(t.impl.writeFile(i,a,{create:!0,overwrite:!0})))):await u._proxy.$writeFile(i,A.VSBuffer.wrap(a))}catch(t){return T._handleError(t)}},async delete(i,a){try{const t=u._fileSystemProvider.get(i.scheme);return t&&!t.isReadonly&&!a?.useTrash?(await u._proxy.$ensureActivation(i.scheme),await t.impl.delete(i,{recursive:!1,...a})):await u._proxy.$delete(i,{recursive:!1,useTrash:!1,atomic:!1,...a})}catch(t){return T._handleError(t)}},async rename(i,a,t){try{return await u._proxy.$rename(i,a,{overwrite:!1,...t})}catch(n){return T._handleError(n)}},async copy(i,a,t){try{return await u._proxy.$copy(i,a,{overwrite:!1,...t})}catch(n){return T._handleError(n)}},isWritableFileSystem(i){const a=p.getCapabilities(i);if(typeof a=="number")return!(a&h.FileSystemProviderCapabilities.Readonly)}})}async mkdirp(m,p,u){const i=[];for(;!p.isEqual(u,p.dirname(u));)try{if(!((await m.stat(u)).type&h.FileType.Directory))throw D.FileSystemError.FileExists(`Unable to create folder '${u.scheme===f.Schemas.file?u.fsPath:u.toString(!0)}' that already exists but is not a directory`);break}catch(a){if(h.toFileSystemProviderErrorCode(a)!==h.FileSystemProviderErrorCode.FileNotFound)throw a;i.push(p.basename(u)),u=p.dirname(u)}for(let a=i.length-1;a>=0;a--){u=p.joinPath(u,i[a]);try{await m.createDirectory(u)}catch(t){if(h.toFileSystemProviderErrorCode(t)!==h.FileSystemProviderErrorCode.FileExists)throw t}}}static _handleError(m){if(m instanceof D.FileSystemError)throw m;if(m instanceof h.FileSystemProviderError)switch(m.code){case h.FileSystemProviderErrorCode.FileExists:throw D.FileSystemError.FileExists(m.message);case h.FileSystemProviderErrorCode.FileNotFound:throw D.FileSystemError.FileNotFound(m.message);case h.FileSystemProviderErrorCode.FileNotADirectory:throw D.FileSystemError.FileNotADirectory(m.message);case h.FileSystemProviderErrorCode.FileIsADirectory:throw D.FileSystemError.FileIsADirectory(m.message);case h.FileSystemProviderErrorCode.NoPermissions:throw D.FileSystemError.NoPermissions(m.message);case h.FileSystemProviderErrorCode.Unavailable:throw D.FileSystemError.Unavailable(m.message);default:throw new D.FileSystemError(m.message,m.name)}if(!(m instanceof Error))throw new D.FileSystemError(String(m));if(m.name==="ENOPRO"||m.message.includes("ENOPRO"))throw D.FileSystemError.Unavailable(m.message);switch(m.name){case h.FileSystemProviderErrorCode.FileExists:throw D.FileSystemError.FileExists(m.message);case h.FileSystemProviderErrorCode.FileNotFound:throw D.FileSystemError.FileNotFound(m.message);case h.FileSystemProviderErrorCode.FileNotADirectory:throw D.FileSystemError.FileNotADirectory(m.message);case h.FileSystemProviderErrorCode.FileIsADirectory:throw D.FileSystemError.FileIsADirectory(m.message);case h.FileSystemProviderErrorCode.NoPermissions:throw D.FileSystemError.NoPermissions(m.message);case h.FileSystemProviderErrorCode.Unavailable:throw D.FileSystemError.Unavailable(m.message);default:throw new D.FileSystemError(m.message,m.name)}}addFileSystemProvider(m,p,u){return this._fileSystemProvider.set(m,{impl:p,extUri:u?.isCaseSensitive?_.extUri:_.extUriIgnorePathCase,isReadonly:!!u?.isReadonly}),(0,l.toDisposable)(()=>this._fileSystemProvider.delete(m))}getFileSystemProviderExtUri(m){return this._fileSystemProvider.get(m)?.extUri??_.extUri}};e.ExtHostConsumerFileSystem=S,e.ExtHostConsumerFileSystem=S=T=Qe([$e(0,R.IExtHostRpcService),$e(1,v.IExtHostFileSystemInfo)],S),e.IExtHostConsumerFileSystem=(0,L.createDecorator)("IExtHostConsumerFileSystem")}),define(Pe[98],ke([1,0,5,29,11,77,2]),function(ge,e,s,h,D,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,s.createDecorator)("IExtensionStoragePaths");let R=class{constructor(l,C,_){this._logService=C,this._extHostFileSystem=_,this._workspace=l.workspace??void 0,this._environment=l.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(f=>this._value=f)}async _getWorkspaceStorageURI(l){return L.URI.joinPath(this._environment.workspaceStorageHome,l)}async _getOrCreateWorkspaceStoragePath(){if(!this._workspace)return Promise.resolve(void 0);const l=this._workspace.id,C=await this._getWorkspaceStorageURI(l);try{return await this._extHostFileSystem.value.stat(C),this._logService.trace("[ExtHostStorage] storage dir already exists",C),C}catch{}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",C),await this._extHostFileSystem.value.createDirectory(C),await this._extHostFileSystem.value.writeFile(L.URI.joinPath(C,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:L.URI.revive(this._workspace.configuration)?.toString(),name:this._workspace.name},void 0,2))),C}catch(_){this._logService.error("[ExtHostStorage]",_);return}}workspaceValue(l){if(this._value)return L.URI.joinPath(this._value,l.identifier.value)}globalValue(l){return L.URI.joinPath(this._environment.globalStorageHome,l.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.ExtensionStoragePaths=R,e.ExtensionStoragePaths=R=Qe([$e(0,h.IExtHostInitDataService),$e(1,D.ILogService),$e(2,A.IExtHostConsumerFileSystem)],R)}),define(Pe[295],ke([1,0,9,19,4]),function(ge,e,s,h,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let A=class{constructor(R){this._actual=new s.ColorTheme(s.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new D.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(R){let v;switch(R){case"light":v=s.ColorThemeKind.Light;break;case"hcDark":v=s.ColorThemeKind.HighContrast;break;case"hcLight":v=s.ColorThemeKind.HighContrastLight;break;default:v=s.ColorThemeKind.Dark}this._actual=new s.ColorTheme(v),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};e.ExtHostTheming=A,e.ExtHostTheming=A=Qe([$e(0,h.IExtHostRpcService)],A)}),define(Pe[78],ke([1,0,20,4,3,7,5,11,93,6,29,19,9]),function(ge,e,s,h,D,A,L,R,v,l,C,_,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDtoConverter=void 0,A=We(A),f=We(f);class T extends v.DisposableTunnel{}var S;(function(m){function p(i){return{remoteAddress:i.remoteAddress,localAddress:i.localAddress,public:!!i.public,privacy:i.privacy??(i.public?v.TunnelPrivacyId.Public:v.TunnelPrivacyId.Private),protocol:i.protocol}}m.fromApiTunnel=p;function u(i){return{remoteAddress:{host:i.tunnelRemoteHost,port:i.tunnelRemotePort},localAddress:i.localAddress,public:i.privacy!==v.TunnelPrivacyId.ConstantPrivate&&i.privacy!==v.TunnelPrivacyId.ConstantPrivate,privacy:i.privacy,protocol:i.protocol}}m.fromServiceTunnel=u})(S||(e.TunnelDtoConverter=S={})),e.IExtHostTunnelService=(0,L.createDecorator)("IExtHostTunnelService");let o=class extends D.Disposable{constructor(p,u,i){super(),this.logService=i,this._showCandidatePort=()=>Promise.resolve(!0),this._extensionTunnels=new Map,this._onDidChangeTunnels=new h.Emitter,this.onDidChangeTunnels=this._onDidChangeTunnels.event,this._providerHandleCounter=0,this._portAttributesProviders=new Map,this._proxy=p.getProxy(l.MainContext.MainThreadTunnelService)}async openTunnel(p,u){this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) ${p.identifier.value} called openTunnel API for ${u.remoteAddress.host}:${u.remoteAddress.port}.`);const i=await this._proxy.$openTunnel(u,p.displayName);if(i){const a=new T(i.remoteAddress,i.localAddress,()=>this._proxy.$closeTunnel(i.remoteAddress));return this._register(a),a}}async getTunnels(){return this._proxy.$getTunnels()}nextPortAttributesProviderHandle(){return this._providerHandleCounter++}registerPortsAttributesProvider(p,u){p.portRange===void 0&&p.commandPattern===void 0&&this.logService.error("PortAttributesProvider must specify either a portRange or a commandPattern");const i=this.nextPortAttributesProviderHandle();return this._portAttributesProviders.set(i,{selector:p,provider:u}),this._proxy.$registerPortsAttributesProvider(p,i),new f.Disposable(()=>{this._portAttributesProviders.delete(i),this._proxy.$unregisterPortsAttributesProvider(i)})}async $providePortAttributes(p,u,i,a,t){const n=[];for(const d of p){const c=this._portAttributesProviders.get(d);if(!c)return[];n.push(...await Promise.all(u.map(async g=>{let w;try{w=await c.provider.providePortAttributes({port:g,pid:i,commandLine:a},t)}catch{w=await c.provider.providePortAttributes(g,i,a,t)}return{providedAttributes:w,port:g}})))}const r=n.filter(d=>!!d.providedAttributes);return r.length>0?r.map(d=>({autoForwardAction:d.providedAttributes.autoForwardAction,port:d.port})):[]}async $registerCandidateFinder(p){}registerTunnelProvider(p,u){if(this._forwardPortProvider)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this._forwardPortProvider=async(a,t)=>await p.provideTunnel(a,t,s.CancellationToken.None)??void 0;const i=u.tunnelFeatures?{elevation:!!u.tunnelFeatures?.elevation,privacyOptions:u.tunnelFeatures?.privacyOptions,protocol:u.tunnelFeatures.protocol===void 0?!0:u.tunnelFeatures.protocol}:void 0;return this._proxy.$setTunnelProvider(i),Promise.resolve((0,D.toDisposable)(()=>{this._forwardPortProvider=void 0,this._proxy.$setTunnelProvider(void 0)}))}async setTunnelFactory(p,u){if(p){p.candidatePortSource!==void 0&&this._proxy.$setCandidatePortSource(p.candidatePortSource),p.showCandidatePort&&(this._showCandidatePort=p.showCandidatePort,this._proxy.$setCandidateFilter());const i=p.tunnelFactory??(u?this.makeManagedTunnelFactory(u):void 0);if(i){this._forwardPortProvider=i;let a=p.tunnelFeatures?.privacyOptions??[];p.tunnelFeatures?.public&&a.length===0&&(a=[{id:"private",label:A.localize(2716,null),themeIcon:"lock"},{id:"public",label:A.localize(2717,null),themeIcon:"eye"}]);const t=p.tunnelFeatures?{elevation:!!p.tunnelFeatures?.elevation,public:!!p.tunnelFeatures?.public,privacyOptions:a,protocol:!0}:void 0;this._proxy.$setTunnelProvider(t)}}else this._forwardPortProvider=void 0;return(0,D.toDisposable)(()=>{this._forwardPortProvider=void 0})}makeManagedTunnelFactory(p){}async $closeTunnel(p,u){if(this._extensionTunnels.has(p.host)){const i=this._extensionTunnels.get(p.host);i.has(p.port)&&(u&&i.get(p.port).disposeListener.dispose(),await i.get(p.port).tunnel.dispose(),i.delete(p.port))}}async $onDidTunnelsChange(){this._onDidChangeTunnels.fire()}async $forwardPort(p,u){if(this._forwardPortProvider)try{this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const i=this._forwardPortProvider(p,u);if(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),i!==void 0){const a=await i;if(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),a===void 0){this.logService.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this._extensionTunnels.has(p.remoteAddress.host)||this._extensionTunnels.set(p.remoteAddress.host,new Map);const t=this._register(a.onDidDispose(()=>(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this._proxy.$closeTunnel(a.remoteAddress))));return this._extensionTunnels.get(p.remoteAddress.host).set(p.remoteAddress.port,{tunnel:a,disposeListener:t}),S.fromApiTunnel(a)}else this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(i){if(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),i instanceof Error)return i.message}}async $applyCandidateFilter(p){const u=await Promise.all(p.map(a=>this._showCandidatePort(a.host,a.port,a.detail??""))),i=p.filter((a,t)=>u[t]);return this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${p.map(a=>a.port).join(", ")} to ${i.map(a=>a.port).join(", ")}`),i}};e.ExtHostTunnelService=o,e.ExtHostTunnelService=o=Qe([$e(0,_.IExtHostRpcService),$e(1,C.IExtHostInitDataService),$e(2,R.ILogService)],o)}),define(Pe[15],ke([1,0,18,21,192,81,86,28,182,38,107,24,187,22,51,17,2,113,30,105,88,56,149,90,160,157,158,273,119,126,75,76,270,9]),function(ge,e,s,h,D,A,L,R,v,l,C,_,f,T,S,o,m,p,u,i,a,t,n,r,d,c,g,w,y,I,P,k,b,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageModelToolDescription=e.DebugTreeItem=e.PartialAcceptTriggerKind=e.PartialAcceptInfo=e.TerminalQuickFix=e.LanguageModelToolResult=e.ChatAgentUserActionEvent=e.ChatAgentResult=e.ChatAgentCompletionItem=e.ChatLanguageModelToolReference=e.ChatPromptReference=e.ChatLocation=e.ChatAgentRequest=e.ChatResponsePart=e.ChatResponseCodeCitationPart=e.ChatResponseReferencePart=e.ChatResponseTextEditPart=e.ChatResponseCommandButtonPart=e.ChatTaskResult=e.ChatTask=e.ChatResponseMovePart=e.ChatResponseWarningPart=e.ChatResponseProgressPart=e.ChatResponseAnchorPart=e.ChatResponseFilesPart=e.ChatResponseConfirmationPart=e.ChatResponseDetectedParticipantPart=e.ChatResponseMarkdownWithVulnerabilitiesPart=e.ChatResponseMarkdownPart=e.LanguageModelChatMessage=e.LanguageModelChatMessageRole=e.ChatFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.MultiDocumentHighlight=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.MarkdownString=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Location=e.Range=e.Selection=void 0,e.isDecorationOptionsArr=J,e.fromRangeOrRangeWithMessage=te,e.pathOrURIToURI=me,L=We(L),v=We(v),u=We(u),i=We(i),a=We(a),w=We(w),I=We(I),E=We(E);var N;(function(De){function Me(ie){const{selectionStartLineNumber:Oe,selectionStartColumn:Ke,positionLineNumber:rt,positionColumn:je}=ie,ut=new E.Position(Oe-1,Ke-1),pt=new E.Position(rt-1,je-1);return new E.Selection(ut,pt)}De.to=Me;function Se(ie){const{anchor:Oe,active:Ke}=ie;return{selectionStartLineNumber:Oe.line+1,selectionStartColumn:Oe.character+1,positionLineNumber:Ke.line+1,positionColumn:Ke.character+1}}De.from=Se})(N||(e.Selection=N={}));var O;(function(De){function Me(ie){if(!ie)return;const{start:Oe,end:Ke}=ie;return{startLineNumber:Oe.line+1,startColumn:Oe.character+1,endLineNumber:Ke.line+1,endColumn:Ke.character+1}}De.from=Me;function Se(ie){if(!ie)return;const{startLineNumber:Oe,startColumn:Ke,endLineNumber:rt,endColumn:je}=ie;return new E.Range(Oe-1,Ke-1,rt-1,je-1)}De.to=Se})(O||(e.Range=O={}));var M;(function(De){function Me(ie){return{uri:ie.uri,range:O.from(ie.range)}}De.from=Me;function Se(ie){return new E.Location(m.URI.revive(ie.uri),O.to(ie.range))}De.to=Se})(M||(e.Location=M={}));var U;(function(De){function Me(Se){switch(Se){case i.StandardTokenType.Comment:return E.StandardTokenType.Comment;case i.StandardTokenType.Other:return E.StandardTokenType.Other;case i.StandardTokenType.RegEx:return E.StandardTokenType.RegEx;case i.StandardTokenType.String:return E.StandardTokenType.String}}De.to=Me})(U||(e.TokenType=U={}));var H;(function(De){function Me(ie){return new E.Position(ie.lineNumber-1,ie.column-1)}De.to=Me;function Se(ie){return{lineNumber:ie.line+1,column:ie.character+1}}De.from=Se})(H||(e.Position=H={}));var F;(function(De){function Me(Oe,Ke,rt){return(0,s.coalesce)((0,s.asArray)(Oe).map(je=>Se(je,Ke,rt)))}De.from=Me;function Se(Oe,Ke,rt){if(typeof Oe=="string")return{$serialized:!0,language:Oe,isBuiltin:rt?.isBuiltin};if(Oe)return{$serialized:!0,language:Oe.language,scheme:ie(Oe.scheme,Ke),pattern:Xe.from(Oe.pattern)??void 0,exclusive:Oe.exclusive,notebookType:Oe.notebookType,isBuiltin:rt?.isBuiltin}}function ie(Oe,Ke){return Ke&&typeof Oe=="string"?Ke.transformOutgoingScheme(Oe):Oe}})(F||(e.DocumentSelector=F={}));var x;(function(De){function Me(ie){switch(ie){case E.DiagnosticTag.Unnecessary:return n.MarkerTag.Unnecessary;case E.DiagnosticTag.Deprecated:return n.MarkerTag.Deprecated}}De.from=Me;function Se(ie){switch(ie){case n.MarkerTag.Unnecessary:return E.DiagnosticTag.Unnecessary;case n.MarkerTag.Deprecated:return E.DiagnosticTag.Deprecated;default:return}}De.to=Se})(x||(e.DiagnosticTag=x={}));var $;(function(De){function Me(ie){let Oe;return ie.code&&((0,o.isString)(ie.code)||(0,o.isNumber)(ie.code)?Oe=String(ie.code):Oe={value:String(ie.code.value),target:ie.code.target}),{...O.from(ie.range),message:ie.message,source:ie.source,code:Oe,severity:B.from(ie.severity),relatedInformation:ie.relatedInformation&&ie.relatedInformation.map(G.from),tags:Array.isArray(ie.tags)?(0,s.coalesce)(ie.tags.map(x.from)):void 0}}De.from=Me;function Se(ie){const Oe=new E.Diagnostic(O.to(ie),ie.message,B.to(ie.severity));return Oe.source=ie.source,Oe.code=(0,o.isString)(ie.code)?ie.code:ie.code?.value,Oe.relatedInformation=ie.relatedInformation&&ie.relatedInformation.map(G.to),Oe.tags=ie.tags&&(0,s.coalesce)(ie.tags.map(x.to)),Oe}De.to=Se})($||(e.Diagnostic=$={}));var G;(function(De){function Me(ie){return{...O.from(ie.location.range),message:ie.message,resource:ie.location.uri}}De.from=Me;function Se(ie){return new E.DiagnosticRelatedInformation(new E.Location(ie.resource,O.to(ie)),ie.message)}De.to=Se})(G||(e.DiagnosticRelatedInformation=G={}));var B;(function(De){function Me(ie){switch(ie){case E.DiagnosticSeverity.Error:return n.MarkerSeverity.Error;case E.DiagnosticSeverity.Warning:return n.MarkerSeverity.Warning;case E.DiagnosticSeverity.Information:return n.MarkerSeverity.Info;case E.DiagnosticSeverity.Hint:return n.MarkerSeverity.Hint}return n.MarkerSeverity.Error}De.from=Me;function Se(ie){switch(ie){case n.MarkerSeverity.Info:return E.DiagnosticSeverity.Information;case n.MarkerSeverity.Warning:return E.DiagnosticSeverity.Warning;case n.MarkerSeverity.Error:return E.DiagnosticSeverity.Error;case n.MarkerSeverity.Hint:return E.DiagnosticSeverity.Hint;default:return E.DiagnosticSeverity.Error}}De.to=Se})(B||(e.DiagnosticSeverity=B={}));var W;(function(De){function Me(ie){return typeof ie=="number"&&ie>=E.ViewColumn.One?ie-1:ie===E.ViewColumn.Beside?b.SIDE_GROUP:b.ACTIVE_GROUP}De.from=Me;function Se(ie){if(typeof ie=="number"&&ie>=0)return ie+1;throw new Error("invalid 'EditorGroupColumn'")}De.to=Se})(W||(e.ViewColumn=W={}));function Z(De){return typeof De.range<"u"}function J(De){return De.length===0?!0:!!Z(De[0])}var oe;(function(De){function Me(je){return je.map(De.from)}De.fromMany=Me;function Se(je){return je&&typeof je=="object"&&typeof je.language=="string"&&typeof je.value=="string"}function ie(je){let ut;if(Se(je)){const{language:Ht,value:zt}=je;ut={value:"```"+Ht+`
`+zt+"\n```\n"}}else E.MarkdownString.isMarkdownString(je)?ut={value:je.value,isTrusted:je.isTrusted,supportThemeIcons:je.supportThemeIcons,supportHtml:je.supportHtml,baseUri:je.baseUri}:typeof je=="string"?ut={value:je}:ut={value:""};const pt=Object.create(null);ut.uris=pt;const jt=({href:Ht})=>{try{let zt=m.URI.parse(Ht,!0);zt=zt.with({query:Oe(zt.query,pt)}),pt[Ht]=zt}catch{}return""};return v.marked.walkTokens(v.marked.lexer(ut.value),Ht=>{Ht.type==="link"?jt({href:Ht.href}):Ht.type==="image"&&typeof Ht.href=="string"&&jt(L.parseHrefAndDimensions(Ht.href))}),ut}De.from=ie;function Oe(je,ut){if(!je)return je;let pt;try{pt=(0,l.parse)(je)}catch{}if(!pt)return je;let jt=!1;return pt=(0,_.cloneAndChange)(pt,Ht=>{if(m.URI.isUri(Ht)){const zt=`__uri_${Math.random().toString(16).slice(2,8)}`;return ut[zt]=Ht,jt=!0,zt}else return}),jt?JSON.stringify(pt):je}function Ke(je){const ut=new E.MarkdownString(je.value,je.supportThemeIcons);return ut.isTrusted=je.isTrusted,ut.supportHtml=je.supportHtml,ut.baseUri=je.baseUri?m.URI.from(je.baseUri):void 0,ut}De.to=Ke;function rt(je){if(je)return typeof je=="string"?je:De.from(je)}De.fromStrict=rt})(oe||(e.MarkdownString=oe={}));function te(De){return J(De)?De.map(Me=>({range:O.from(Me.range),hoverMessage:Array.isArray(Me.hoverMessage)?oe.fromMany(Me.hoverMessage):Me.hoverMessage?oe.from(Me.hoverMessage):void 0,renderOptions:Me.renderOptions})):De.map(Me=>({range:O.from(Me)}))}function me(De){return typeof De>"u"?De:typeof De=="string"?m.URI.file(De):De}var le;(function(De){function Me(Se){return typeof Se>"u"?Se:{contentText:Se.contentText,contentIconPath:Se.contentIconPath?me(Se.contentIconPath):void 0,border:Se.border,borderColor:Se.borderColor,fontStyle:Se.fontStyle,fontWeight:Se.fontWeight,textDecoration:Se.textDecoration,color:Se.color,backgroundColor:Se.backgroundColor,margin:Se.margin,width:Se.width,height:Se.height}}De.from=Me})(le||(e.ThemableDecorationAttachmentRenderOptions=le={}));var Q;(function(De){function Me(Se){return typeof Se>"u"?Se:{backgroundColor:Se.backgroundColor,outline:Se.outline,outlineColor:Se.outlineColor,outlineStyle:Se.outlineStyle,outlineWidth:Se.outlineWidth,border:Se.border,borderColor:Se.borderColor,borderRadius:Se.borderRadius,borderSpacing:Se.borderSpacing,borderStyle:Se.borderStyle,borderWidth:Se.borderWidth,fontStyle:Se.fontStyle,fontWeight:Se.fontWeight,textDecoration:Se.textDecoration,cursor:Se.cursor,color:Se.color,opacity:Se.opacity,letterSpacing:Se.letterSpacing,gutterIconPath:Se.gutterIconPath?me(Se.gutterIconPath):void 0,gutterIconSize:Se.gutterIconSize,overviewRulerColor:Se.overviewRulerColor,before:Se.before?le.from(Se.before):void 0,after:Se.after?le.from(Se.after):void 0}}De.from=Me})(Q||(e.ThemableDecorationRenderOptions=Q={}));var z;(function(De){function Me(Se){if(typeof Se>"u")return Se;switch(Se){case E.DecorationRangeBehavior.OpenOpen:return t.TrackedRangeStickiness.AlwaysGrowsWhenTypingAtEdges;case E.DecorationRangeBehavior.ClosedClosed:return t.TrackedRangeStickiness.NeverGrowsWhenTypingAtEdges;case E.DecorationRangeBehavior.OpenClosed:return t.TrackedRangeStickiness.GrowsOnlyWhenTypingBefore;case E.DecorationRangeBehavior.ClosedOpen:return t.TrackedRangeStickiness.GrowsOnlyWhenTypingAfter}}De.from=Me})(z||(e.DecorationRangeBehavior=z={}));var se;(function(De){function Me(Se){return{isWholeLine:Se.isWholeLine,rangeBehavior:Se.rangeBehavior?z.from(Se.rangeBehavior):void 0,overviewRulerLane:Se.overviewRulerLane,light:Se.light?Q.from(Se.light):void 0,dark:Se.dark?Q.from(Se.dark):void 0,backgroundColor:Se.backgroundColor,outline:Se.outline,outlineColor:Se.outlineColor,outlineStyle:Se.outlineStyle,outlineWidth:Se.outlineWidth,border:Se.border,borderColor:Se.borderColor,borderRadius:Se.borderRadius,borderSpacing:Se.borderSpacing,borderStyle:Se.borderStyle,borderWidth:Se.borderWidth,fontStyle:Se.fontStyle,fontWeight:Se.fontWeight,textDecoration:Se.textDecoration,cursor:Se.cursor,color:Se.color,opacity:Se.opacity,letterSpacing:Se.letterSpacing,gutterIconPath:Se.gutterIconPath?me(Se.gutterIconPath):void 0,gutterIconSize:Se.gutterIconSize,overviewRulerColor:Se.overviewRulerColor,before:Se.before?le.from(Se.before):void 0,after:Se.after?le.from(Se.after):void 0}}De.from=Me})(se||(e.DecorationRenderOptions=se={}));var Ee;(function(De){function Me(ie){return{text:ie.newText,eol:ie.newEol&&Ie.from(ie.newEol),range:O.from(ie.range)}}De.from=Me;function Se(ie){const Oe=new E.TextEdit(O.to(ie.range),ie.text);return Oe.newEol=typeof ie.eol>"u"?void 0:Ie.to(ie.eol),Oe}De.to=Se})(Ee||(e.TextEdit=Ee={}));var ae;(function(De){function Me(ie,Oe){const Ke={edits:[]};if(ie instanceof E.WorkspaceEdit){const rt=new R.ResourceSet;for(const je of ie._allEntries())je._type===E.FileEditType.File&&m.URI.isUri(je.to)&&je.from===void 0&&rt.add(je.to);for(const je of ie._allEntries())if(je._type===E.FileEditType.File){let ut;je.options?.contents&&(ArrayBuffer.isView(je.options.contents)?ut={type:"base64",value:(0,h.encodeBase64)(h.VSBuffer.wrap(je.options.contents))}:ut={type:"dataTransferItem",id:je.options.contents._itemId}),Ke.edits.push({oldResource:je.from,newResource:je.to,options:{...je.options,contents:ut},metadata:je.metadata})}else je._type===E.FileEditType.Text?Ke.edits.push({resource:je.uri,textEdit:Ee.from(je.edit),versionId:rt.has(je.uri)?void 0:Oe?.getTextDocumentVersion(je.uri),metadata:je.metadata}):je._type===E.FileEditType.Snippet?Ke.edits.push({resource:je.uri,textEdit:{range:O.from(je.range),text:je.edit.value,insertAsSnippet:!0},versionId:rt.has(je.uri)?void 0:Oe?.getTextDocumentVersion(je.uri),metadata:je.metadata}):je._type===E.FileEditType.Cell?Ke.edits.push({metadata:je.metadata,resource:je.uri,cellEdit:je.edit,notebookMetadata:je.notebookMetadata,notebookVersionId:Oe?.getNotebookDocumentVersion(je.uri)}):je._type===E.FileEditType.CellReplace&&Ke.edits.push({metadata:je.metadata,resource:je.uri,notebookVersionId:Oe?.getNotebookDocumentVersion(je.uri),cellEdit:{editType:I.CellEditType.Replace,index:je.index,count:je.count,cells:je.cells.map(tt.from)}})}return Ke}De.from=Me;function Se(ie){const Oe=new E.WorkspaceEdit,Ke=new R.ResourceMap;for(const rt of ie.edits)if(rt.textEdit){const je=rt,ut=m.URI.revive(je.resource),pt=O.to(je.textEdit.range),jt=je.textEdit.text,Ht=je.textEdit.insertAsSnippet;let zt;Ht?zt=E.SnippetTextEdit.replace(pt,new E.SnippetString(jt)):zt=E.TextEdit.replace(pt,jt);const Oi=Ke.get(ut);Oi?Oi.push(zt):Ke.set(ut,[zt])}else Oe.renameFile(m.URI.revive(rt.oldResource),m.URI.revive(rt.newResource),rt.options);for(const[rt,je]of Ke)Oe.set(rt,je);return Oe}De.to=Se})(ae||(e.WorkspaceEdit=ae={}));var be;(function(De){const Me=Object.create(null);Me[E.SymbolKind.File]=a.SymbolKind.File,Me[E.SymbolKind.Module]=a.SymbolKind.Module,Me[E.SymbolKind.Namespace]=a.SymbolKind.Namespace,Me[E.SymbolKind.Package]=a.SymbolKind.Package,Me[E.SymbolKind.Class]=a.SymbolKind.Class,Me[E.SymbolKind.Method]=a.SymbolKind.Method,Me[E.SymbolKind.Property]=a.SymbolKind.Property,Me[E.SymbolKind.Field]=a.SymbolKind.Field,Me[E.SymbolKind.Constructor]=a.SymbolKind.Constructor,Me[E.SymbolKind.Enum]=a.SymbolKind.Enum,Me[E.SymbolKind.Interface]=a.SymbolKind.Interface,Me[E.SymbolKind.Function]=a.SymbolKind.Function,Me[E.SymbolKind.Variable]=a.SymbolKind.Variable,Me[E.SymbolKind.Constant]=a.SymbolKind.Constant,Me[E.SymbolKind.String]=a.SymbolKind.String,Me[E.SymbolKind.Number]=a.SymbolKind.Number,Me[E.SymbolKind.Boolean]=a.SymbolKind.Boolean,Me[E.SymbolKind.Array]=a.SymbolKind.Array,Me[E.SymbolKind.Object]=a.SymbolKind.Object,Me[E.SymbolKind.Key]=a.SymbolKind.Key,Me[E.SymbolKind.Null]=a.SymbolKind.Null,Me[E.SymbolKind.EnumMember]=a.SymbolKind.EnumMember,Me[E.SymbolKind.Struct]=a.SymbolKind.Struct,Me[E.SymbolKind.Event]=a.SymbolKind.Event,Me[E.SymbolKind.Operator]=a.SymbolKind.Operator,Me[E.SymbolKind.TypeParameter]=a.SymbolKind.TypeParameter;function Se(Oe){return typeof Me[Oe]=="number"?Me[Oe]:a.SymbolKind.Property}De.from=Se;function ie(Oe){for(const Ke in Me)if(Me[Ke]===Oe)return Number(Ke);return E.SymbolKind.Property}De.to=ie})(be||(e.SymbolKind=be={}));var pe;(function(De){function Me(ie){switch(ie){case E.SymbolTag.Deprecated:return a.SymbolTag.Deprecated}}De.from=Me;function Se(ie){switch(ie){case a.SymbolTag.Deprecated:return E.SymbolTag.Deprecated}}De.to=Se})(pe||(e.SymbolTag=pe={}));var ve;(function(De){function Me(ie){return{name:ie.name,kind:be.from(ie.kind),tags:ie.tags&&ie.tags.map(pe.from),containerName:ie.containerName,location:Je.from(ie.location)}}De.from=Me;function Se(ie){const Oe=new E.SymbolInformation(ie.name,be.to(ie.kind),ie.containerName,Je.to(ie.location));return Oe.tags=ie.tags&&ie.tags.map(pe.to),Oe}De.to=Se})(ve||(e.WorkspaceSymbol=ve={}));var Re;(function(De){function Me(ie){const Oe={name:ie.name||"!!MISSING: name!!",detail:ie.detail,range:O.from(ie.range),selectionRange:O.from(ie.selectionRange),kind:be.from(ie.kind),tags:ie.tags?.map(pe.from)??[]};return ie.children&&(Oe.children=ie.children.map(Me)),Oe}De.from=Me;function Se(ie){const Oe=new E.DocumentSymbol(ie.name,ie.detail,be.to(ie.kind),O.to(ie.range),O.to(ie.selectionRange));return(0,s.isNonEmptyArray)(ie.tags)&&(Oe.tags=ie.tags.map(pe.to)),ie.children&&(Oe.children=ie.children.map(Se)),Oe}De.to=Se})(Re||(e.DocumentSymbol=Re={}));var Fe;(function(De){function Me(ie){const Oe=new E.CallHierarchyItem(be.to(ie.kind),ie.name,ie.detail||"",m.URI.revive(ie.uri),O.to(ie.range),O.to(ie.selectionRange));return Oe._sessionId=ie._sessionId,Oe._itemId=ie._itemId,Oe}De.to=Me;function Se(ie,Oe,Ke){if(Oe=Oe??ie._sessionId,Ke=Ke??ie._itemId,Oe===void 0||Ke===void 0)throw new Error("invalid item");return{_sessionId:Oe,_itemId:Ke,name:ie.name,detail:ie.detail,kind:be.from(ie.kind),uri:ie.uri,range:O.from(ie.range),selectionRange:O.from(ie.selectionRange),tags:ie.tags?.map(pe.from)}}De.from=Se})(Fe||(e.CallHierarchyItem=Fe={}));var Ve;(function(De){function Me(Se){return new E.CallHierarchyIncomingCall(Fe.to(Se.from),Se.fromRanges.map(ie=>O.to(ie)))}De.to=Me})(Ve||(e.CallHierarchyIncomingCall=Ve={}));var Ye;(function(De){function Me(Se){return new E.CallHierarchyOutgoingCall(Fe.to(Se.to),Se.fromRanges.map(ie=>O.to(ie)))}De.to=Me})(Ye||(e.CallHierarchyOutgoingCall=Ye={}));var Je;(function(De){function Me(ie){return{range:ie.range&&O.from(ie.range),uri:ie.uri}}De.from=Me;function Se(ie){return new E.Location(m.URI.revive(ie.uri),O.to(ie.range))}De.to=Se})(Je||(e.location=Je={}));var xe;(function(De){function Me(ie){const Oe=ie,Ke=ie;return{originSelectionRange:Oe.originSelectionRange?O.from(Oe.originSelectionRange):void 0,uri:Oe.targetUri?Oe.targetUri:Ke.uri,range:O.from(Oe.targetRange?Oe.targetRange:Ke.range),targetSelectionRange:Oe.targetSelectionRange?O.from(Oe.targetSelectionRange):void 0}}De.from=Me;function Se(ie){return{targetUri:m.URI.revive(ie.uri),targetRange:O.to(ie.range),targetSelectionRange:ie.targetSelectionRange?O.to(ie.targetSelectionRange):void 0,originSelectionRange:ie.originSelectionRange?O.to(ie.originSelectionRange):void 0}}De.to=Se})(xe||(e.DefinitionLink=xe={}));var ze;(function(De){function Me(ie){return{range:O.from(ie.range),contents:oe.fromMany(ie.contents),canIncreaseVerbosity:ie.canIncreaseVerbosity,canDecreaseVerbosity:ie.canDecreaseVerbosity}}De.from=Me;function Se(ie){const Oe=ie.contents.map(oe.to),Ke=O.to(ie.range),rt=ie.canIncreaseVerbosity,je=ie.canDecreaseVerbosity;return new E.VerboseHover(Oe,Ke,rt,je)}De.to=Se})(ze||(e.Hover=ze={}));var Ne;(function(De){function Me(ie){return{range:O.from(ie.range),expression:ie.expression}}De.from=Me;function Se(ie){return new E.EvaluatableExpression(O.to(ie.range),ie.expression)}De.to=Se})(Ne||(e.EvaluatableExpression=Ne={}));var V;(function(De){function Me(ie){if(ie instanceof E.InlineValueText)return{type:"text",range:O.from(ie.range),text:ie.text};if(ie instanceof E.InlineValueVariableLookup)return{type:"variable",range:O.from(ie.range),variableName:ie.variableName,caseSensitiveLookup:ie.caseSensitiveLookup};if(ie instanceof E.InlineValueEvaluatableExpression)return{type:"expression",range:O.from(ie.range),expression:ie.expression};throw new Error("Unknown 'InlineValue' type")}De.from=Me;function Se(ie){switch(ie.type){case"text":return{range:O.to(ie.range),text:ie.text};case"variable":return{range:O.to(ie.range),variableName:ie.variableName,caseSensitiveLookup:ie.caseSensitiveLookup};case"expression":return{range:O.to(ie.range),expression:ie.expression}}}De.to=Se})(V||(e.InlineValue=V={}));var j;(function(De){function Me(ie){return{frameId:ie.frameId,stoppedLocation:O.from(ie.stoppedLocation)}}De.from=Me;function Se(ie){return new E.InlineValueContext(ie.frameId,O.to(ie.stoppedLocation))}De.to=Se})(j||(e.InlineValueContext=j={}));var Y;(function(De){function Me(ie){return{range:O.from(ie.range),kind:ie.kind}}De.from=Me;function Se(ie){return new E.DocumentHighlight(O.to(ie.range),ie.kind)}De.to=Se})(Y||(e.DocumentHighlight=Y={}));var ee;(function(De){function Me(ie){return{uri:ie.uri,highlights:ie.highlights.map(Y.from)}}De.from=Me;function Se(ie){return new E.MultiDocumentHighlight(m.URI.revive(ie.uri),ie.highlights.map(Y.to))}De.to=Se})(ee||(e.MultiDocumentHighlight=ee={}));var ue;(function(De){function Me(Se){switch(Se){case a.CompletionTriggerKind.TriggerCharacter:return E.CompletionTriggerKind.TriggerCharacter;case a.CompletionTriggerKind.TriggerForIncompleteCompletions:return E.CompletionTriggerKind.TriggerForIncompleteCompletions;case a.CompletionTriggerKind.Invoke:default:return E.CompletionTriggerKind.Invoke}}De.to=Me})(ue||(e.CompletionTriggerKind=ue={}));var we;(function(De){function Me(Se){return{triggerKind:ue.to(Se.triggerKind),triggerCharacter:Se.triggerCharacter}}De.to=Me})(we||(e.CompletionContext=we={}));var Ae;(function(De){function Me(ie){switch(ie){case E.CompletionItemTag.Deprecated:return a.CompletionItemTag.Deprecated}}De.from=Me;function Se(ie){switch(ie){case a.CompletionItemTag.Deprecated:return E.CompletionItemTag.Deprecated}}De.to=Se})(Ae||(e.CompletionItemTag=Ae={}));var He;(function(De){const Me=new Map([[E.CompletionItemKind.Method,a.CompletionItemKind.Method],[E.CompletionItemKind.Function,a.CompletionItemKind.Function],[E.CompletionItemKind.Constructor,a.CompletionItemKind.Constructor],[E.CompletionItemKind.Field,a.CompletionItemKind.Field],[E.CompletionItemKind.Variable,a.CompletionItemKind.Variable],[E.CompletionItemKind.Class,a.CompletionItemKind.Class],[E.CompletionItemKind.Interface,a.CompletionItemKind.Interface],[E.CompletionItemKind.Struct,a.CompletionItemKind.Struct],[E.CompletionItemKind.Module,a.CompletionItemKind.Module],[E.CompletionItemKind.Property,a.CompletionItemKind.Property],[E.CompletionItemKind.Unit,a.CompletionItemKind.Unit],[E.CompletionItemKind.Value,a.CompletionItemKind.Value],[E.CompletionItemKind.Constant,a.CompletionItemKind.Constant],[E.CompletionItemKind.Enum,a.CompletionItemKind.Enum],[E.CompletionItemKind.EnumMember,a.CompletionItemKind.EnumMember],[E.CompletionItemKind.Keyword,a.CompletionItemKind.Keyword],[E.CompletionItemKind.Snippet,a.CompletionItemKind.Snippet],[E.CompletionItemKind.Text,a.CompletionItemKind.Text],[E.CompletionItemKind.Color,a.CompletionItemKind.Color],[E.CompletionItemKind.File,a.CompletionItemKind.File],[E.CompletionItemKind.Reference,a.CompletionItemKind.Reference],[E.CompletionItemKind.Folder,a.CompletionItemKind.Folder],[E.CompletionItemKind.Event,a.CompletionItemKind.Event],[E.CompletionItemKind.Operator,a.CompletionItemKind.Operator],[E.CompletionItemKind.TypeParameter,a.CompletionItemKind.TypeParameter],[E.CompletionItemKind.Issue,a.CompletionItemKind.Issue],[E.CompletionItemKind.User,a.CompletionItemKind.User]]);function Se(Ke){return Me.get(Ke)??a.CompletionItemKind.Property}De.from=Se;const ie=new Map([[a.CompletionItemKind.Method,E.CompletionItemKind.Method],[a.CompletionItemKind.Function,E.CompletionItemKind.Function],[a.CompletionItemKind.Constructor,E.CompletionItemKind.Constructor],[a.CompletionItemKind.Field,E.CompletionItemKind.Field],[a.CompletionItemKind.Variable,E.CompletionItemKind.Variable],[a.CompletionItemKind.Class,E.CompletionItemKind.Class],[a.CompletionItemKind.Interface,E.CompletionItemKind.Interface],[a.CompletionItemKind.Struct,E.CompletionItemKind.Struct],[a.CompletionItemKind.Module,E.CompletionItemKind.Module],[a.CompletionItemKind.Property,E.CompletionItemKind.Property],[a.CompletionItemKind.Unit,E.CompletionItemKind.Unit],[a.CompletionItemKind.Value,E.CompletionItemKind.Value],[a.CompletionItemKind.Constant,E.CompletionItemKind.Constant],[a.CompletionItemKind.Enum,E.CompletionItemKind.Enum],[a.CompletionItemKind.EnumMember,E.CompletionItemKind.EnumMember],[a.CompletionItemKind.Keyword,E.CompletionItemKind.Keyword],[a.CompletionItemKind.Snippet,E.CompletionItemKind.Snippet],[a.CompletionItemKind.Text,E.CompletionItemKind.Text],[a.CompletionItemKind.Color,E.CompletionItemKind.Color],[a.CompletionItemKind.File,E.CompletionItemKind.File],[a.CompletionItemKind.Reference,E.CompletionItemKind.Reference],[a.CompletionItemKind.Folder,E.CompletionItemKind.Folder],[a.CompletionItemKind.Event,E.CompletionItemKind.Event],[a.CompletionItemKind.Operator,E.CompletionItemKind.Operator],[a.CompletionItemKind.TypeParameter,E.CompletionItemKind.TypeParameter],[a.CompletionItemKind.User,E.CompletionItemKind.User],[a.CompletionItemKind.Issue,E.CompletionItemKind.Issue]]);function Oe(Ke){return ie.get(Ke)??E.CompletionItemKind.Property}De.to=Oe})(He||(e.CompletionItemKind=He={}));var Ge;(function(De){function Me(Se,ie){const Oe=new E.CompletionItem(Se.label);return Oe.insertText=Se.insertText,Oe.kind=He.to(Se.kind),Oe.tags=Se.tags?.map(Ae.to),Oe.detail=Se.detail,Oe.documentation=L.isMarkdownString(Se.documentation)?oe.to(Se.documentation):Se.documentation,Oe.sortText=Se.sortText,Oe.filterText=Se.filterText,Oe.preselect=Se.preselect,Oe.commitCharacters=Se.commitCharacters,u.Range.isIRange(Se.range)?Oe.range=O.to(Se.range):typeof Se.range=="object"&&(Oe.range={inserting:O.to(Se.range.insert),replacing:O.to(Se.range.replace)}),Oe.keepWhitespace=typeof Se.insertTextRules>"u"?!1:!!(Se.insertTextRules&a.CompletionItemInsertTextRule.KeepWhitespace),typeof Se.insertTextRules<"u"&&Se.insertTextRules&a.CompletionItemInsertTextRule.InsertAsSnippet?Oe.insertText=new E.SnippetString(Se.insertText):(Oe.insertText=Se.insertText,Oe.textEdit=Oe.range instanceof E.Range?new E.TextEdit(Oe.range,Oe.insertText):void 0),Se.additionalTextEdits&&Se.additionalTextEdits.length>0&&(Oe.additionalTextEdits=Se.additionalTextEdits.map(Ke=>Ee.to(Ke))),Oe.command=ie&&Se.command?ie.fromInternal(Se.command):void 0,Oe}De.to=Me})(Ge||(e.CompletionItem=Ge={}));var nt;(function(De){function Me(ie){if(typeof ie.label!="string"&&!Array.isArray(ie.label))throw new TypeError("Invalid label");return{label:ie.label,documentation:oe.fromStrict(ie.documentation)}}De.from=Me;function Se(ie){return{label:ie.label,documentation:L.isMarkdownString(ie.documentation)?oe.to(ie.documentation):ie.documentation}}De.to=Se})(nt||(e.ParameterInformation=nt={}));var ot;(function(De){function Me(ie){return{label:ie.label,documentation:oe.fromStrict(ie.documentation),parameters:Array.isArray(ie.parameters)?ie.parameters.map(nt.from):[],activeParameter:ie.activeParameter}}De.from=Me;function Se(ie){return{label:ie.label,documentation:L.isMarkdownString(ie.documentation)?oe.to(ie.documentation):ie.documentation,parameters:Array.isArray(ie.parameters)?ie.parameters.map(nt.to):[],activeParameter:ie.activeParameter}}De.to=Se})(ot||(e.SignatureInformation=ot={}));var dt;(function(De){function Me(ie){return{activeSignature:ie.activeSignature,activeParameter:ie.activeParameter,signatures:Array.isArray(ie.signatures)?ie.signatures.map(ot.from):[]}}De.from=Me;function Se(ie){return{activeSignature:ie.activeSignature,activeParameter:ie.activeParameter,signatures:Array.isArray(ie.signatures)?ie.signatures.map(ot.to):[]}}De.to=Se})(dt||(e.SignatureHelp=dt={}));var at;(function(De){function Me(Se,ie){const Oe=new E.InlayHint(H.to(ie.position),typeof ie.label=="string"?ie.label:ie.label.map(ct.to.bind(void 0,Se)),ie.kind&&vt.to(ie.kind));return Oe.textEdits=ie.textEdits&&ie.textEdits.map(Ee.to),Oe.tooltip=L.isMarkdownString(ie.tooltip)?oe.to(ie.tooltip):ie.tooltip,Oe.paddingLeft=ie.paddingLeft,Oe.paddingRight=ie.paddingRight,Oe}De.to=Me})(at||(e.InlayHint=at={}));var ct;(function(De){function Me(Se,ie){const Oe=new E.InlayHintLabelPart(ie.label);return Oe.tooltip=L.isMarkdownString(ie.tooltip)?oe.to(ie.tooltip):ie.tooltip,a.Command.is(ie.command)&&(Oe.command=Se.fromInternal(ie.command)),ie.location&&(Oe.location=Je.to(ie.location)),Oe}De.to=Me})(ct||(e.InlayHintLabelPart=ct={}));var vt;(function(De){function Me(ie){return ie}De.from=Me;function Se(ie){return ie}De.to=Se})(vt||(e.InlayHintKind=vt={}));var it;(function(De){function Me(ie){return{range:O.from(ie.range),url:ie.target,tooltip:ie.tooltip}}De.from=Me;function Se(ie){let Oe;if(ie.url)try{Oe=typeof ie.url=="string"?m.URI.parse(ie.url,!0):m.URI.revive(ie.url)}catch{}const Ke=new E.DocumentLink(O.to(ie.range),Oe);return Ke.tooltip=ie.tooltip,Ke}De.to=Se})(it||(e.DocumentLink=it={}));var Ce;(function(De){function Me(ie){const Oe=new E.ColorPresentation(ie.label);return ie.textEdit&&(Oe.textEdit=Ee.to(ie.textEdit)),ie.additionalTextEdits&&(Oe.additionalTextEdits=ie.additionalTextEdits.map(Ke=>Ee.to(Ke))),Oe}De.to=Me;function Se(ie){return{label:ie.label,textEdit:ie.textEdit?Ee.from(ie.textEdit):void 0,additionalTextEdits:ie.additionalTextEdits?ie.additionalTextEdits.map(Oe=>Ee.from(Oe)):void 0}}De.from=Se})(Ce||(e.ColorPresentation=Ce={}));var re;(function(De){function Me(ie){return new E.Color(ie[0],ie[1],ie[2],ie[3])}De.to=Me;function Se(ie){return[ie.red,ie.green,ie.blue,ie.alpha]}De.from=Se})(re||(e.Color=re={}));var ce;(function(De){function Me(ie){return{range:O.from(ie.range)}}De.from=Me;function Se(ie){return new E.SelectionRange(O.to(ie.range))}De.to=Se})(ce||(e.SelectionRange=ce={}));var ye;(function(De){function Me(Se){switch(Se){case c.SaveReason.AUTO:return E.TextDocumentSaveReason.AfterDelay;case c.SaveReason.EXPLICIT:return E.TextDocumentSaveReason.Manual;case c.SaveReason.FOCUS_CHANGE:case c.SaveReason.WINDOW_CHANGE:return E.TextDocumentSaveReason.FocusOut}}De.to=Me})(ye||(e.TextDocumentSaveReason=ye={}));var he;(function(De){function Me(ie){switch(ie){case E.TextEditorLineNumbersStyle.Off:return p.RenderLineNumbersType.Off;case E.TextEditorLineNumbersStyle.Relative:return p.RenderLineNumbersType.Relative;case E.TextEditorLineNumbersStyle.Interval:return p.RenderLineNumbersType.Interval;case E.TextEditorLineNumbersStyle.On:default:return p.RenderLineNumbersType.On}}De.from=Me;function Se(ie){switch(ie){case p.RenderLineNumbersType.Off:return E.TextEditorLineNumbersStyle.Off;case p.RenderLineNumbersType.Relative:return E.TextEditorLineNumbersStyle.Relative;case p.RenderLineNumbersType.Interval:return E.TextEditorLineNumbersStyle.Interval;case p.RenderLineNumbersType.On:default:return E.TextEditorLineNumbersStyle.On}}De.to=Se})(he||(e.TextEditorLineNumbersStyle=he={}));var Ie;(function(De){function Me(ie){if(ie===E.EndOfLine.CRLF)return t.EndOfLineSequence.CRLF;if(ie===E.EndOfLine.LF)return t.EndOfLineSequence.LF}De.from=Me;function Se(ie){if(ie===t.EndOfLineSequence.CRLF)return E.EndOfLine.CRLF;if(ie===t.EndOfLineSequence.LF)return E.EndOfLine.LF}De.to=Se})(Ie||(e.EndOfLine=Ie={}));var ne;(function(De){function Me(Se){if(typeof Se=="object")return Se.viewId;switch(Se){case E.ProgressLocation.SourceControl:return r.ProgressLocation.Scm;case E.ProgressLocation.Window:return r.ProgressLocation.Window;case E.ProgressLocation.Notification:return r.ProgressLocation.Notification}throw new Error("Unknown 'ProgressLocation'")}De.from=Me})(ne||(e.ProgressLocation=ne={}));var X;(function(De){function Me(ie){const Oe={start:ie.start+1,end:ie.end+1};return ie.kind&&(Oe.kind=Te.from(ie.kind)),Oe}De.from=Me;function Se(ie){const Oe={start:ie.start-1,end:ie.end-1};return ie.kind&&(Oe.kind=Te.to(ie.kind)),Oe}De.to=Se})(X||(e.FoldingRange=X={}));var Te;(function(De){function Me(ie){if(ie)switch(ie){case E.FoldingRangeKind.Comment:return a.FoldingRangeKind.Comment;case E.FoldingRangeKind.Imports:return a.FoldingRangeKind.Imports;case E.FoldingRangeKind.Region:return a.FoldingRangeKind.Region}}De.from=Me;function Se(ie){if(ie)switch(ie.value){case a.FoldingRangeKind.Comment.value:return E.FoldingRangeKind.Comment;case a.FoldingRangeKind.Imports.value:return E.FoldingRangeKind.Imports;case a.FoldingRangeKind.Region.value:return E.FoldingRangeKind.Region}}De.to=Se})(Te||(e.FoldingRangeKind=Te={}));var qe;(function(De){function Me(Se){if(Se)return{pinned:typeof Se.preview=="boolean"?!Se.preview:void 0,inactive:Se.background,preserveFocus:Se.preserveFocus,selection:typeof Se.selection=="object"?O.from(Se.selection):void 0,override:typeof Se.override=="boolean"?c.DEFAULT_EDITOR_ASSOCIATION.id:void 0}}De.from=Me})(qe||(e.TextEditorOpenOptions=qe={}));var Xe;(function(De){function Me(Ke){return Ke instanceof E.RelativePattern?Ke.toJSON():typeof Ke=="string"?Ke:Se(Ke)||ie(Ke)?new E.RelativePattern(Ke.baseUri??Ke.base,Ke.pattern).toJSON():Ke}De.from=Me;function Se(Ke){const rt=Ke;return rt?m.URI.isUri(rt.baseUri)&&typeof rt.pattern=="string":!1}function ie(Ke){const rt=Ke;return rt?typeof rt.base=="string"&&typeof rt.pattern=="string":!1}function Oe(Ke){return typeof Ke=="string"?Ke:new E.RelativePattern(m.URI.revive(Ke.baseUri),Ke.pattern)}De.to=Oe})(Xe||(e.GlobPattern=Xe={}));var st;(function(De){function Me(Se){if(Se){if(Array.isArray(Se))return Se.map(Me);if(typeof Se=="string")return Se;{const ie=Se;return{language:ie.language,scheme:ie.scheme,pattern:Xe.from(ie.pattern),exclusive:ie.exclusive,notebookType:ie.notebookType}}}else return}De.from=Me})(st||(e.LanguageSelector=st={}));var ht;(function(De){function Me(ie){return!!ie&&typeof ie=="object"&&"documents"in ie&&Array.isArray(ie.documents)&&ie.documents.every(Oe=>Array.isArray(Oe)&&Oe.every(Ke=>Ke&&typeof Ke=="object"&&"uri"in Ke&&m.URI.isUri(Ke.uri)&&"version"in Ke&&typeof Ke.version=="number"&&"ranges"in Ke&&Array.isArray(Ke.ranges)&&Ke.ranges.every(rt=>rt instanceof E.Range)))}De.is=Me;function Se(ie){return{documents:ie.documents.map(Oe=>Oe.map(Ke=>({uri:m.URI.from(Ke.uri),version:Ke.version,ranges:Ke.ranges.map(rt=>O.from(rt))})))}}De.from=Se})(ht||(e.MappedEditsContext=ht={}));var gt;(function(De){function Me(ie){return{start:ie.start,end:ie.end}}De.from=Me;function Se(ie){return new E.NotebookRange(ie.start,ie.end)}De.to=Se})(gt||(e.NotebookRange=gt={}));var It;(function(De){function Me(ie){return{timing:typeof ie.runStartTime=="number"&&typeof ie.runEndTime=="number"?{startTime:ie.runStartTime,endTime:ie.runEndTime}:void 0,executionOrder:ie.executionOrder,success:ie.lastRunSuccess}}De.to=Me;function Se(ie){return{lastRunSuccess:ie.success,runStartTime:ie.timing?.startTime,runEndTime:ie.timing?.endTime,executionOrder:ie.executionOrder}}De.from=Se})(It||(e.NotebookCellExecutionSummary=It={}));var At;(function(De){function Me(Se){if(Se===I.NotebookCellExecutionState.Unconfirmed)return E.NotebookCellExecutionState.Pending;if(Se===I.NotebookCellExecutionState.Pending)return;if(Se===I.NotebookCellExecutionState.Executing)return E.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${Se}`)}De.to=Me})(At||(e.NotebookCellExecutionState=At={}));var qt;(function(De){function Me(ie){switch(ie){case E.NotebookCellKind.Markup:return I.CellKind.Markup;case E.NotebookCellKind.Code:default:return I.CellKind.Code}}De.from=Me;function Se(ie){switch(ie){case I.CellKind.Markup:return E.NotebookCellKind.Markup;case I.CellKind.Code:default:return E.NotebookCellKind.Code}}De.to=Se})(qt||(e.NotebookCellKind=qt={}));var ei;(function(De){function Me(ie){const Oe={metadata:ie.metadata??Object.create(null),cells:[]};for(const Ke of ie.cells)E.NotebookCellData.validate(Ke),Oe.cells.push(tt.from(Ke));return Oe}De.from=Me;function Se(ie){const Oe=new E.NotebookData(ie.cells.map(tt.to));return(0,o.isEmptyObject)(ie.metadata)||(Oe.metadata=ie.metadata),Oe}De.to=Se})(ei||(e.NotebookData=ei={}));var tt;(function(De){function Me(ie){return{cellKind:qt.from(ie.kind),language:ie.languageId,mime:ie.mime,source:ie.value,metadata:ie.metadata,internalMetadata:It.from(ie.executionSummary??{}),outputs:ie.outputs?ie.outputs.map(Ut.from):[]}}De.from=Me;function Se(ie){return new E.NotebookCellData(qt.to(ie.cellKind),ie.source,ie.language,ie.mime,ie.outputs?ie.outputs.map(Ut.to):void 0,ie.metadata,ie.internalMetadata?It.to(ie.internalMetadata):void 0)}De.to=Se})(tt||(e.NotebookCellData=tt={}));var Lt;(function(De){function Me(ie){return{mime:ie.mime,valueBytes:h.VSBuffer.wrap(ie.data)}}De.from=Me;function Se(ie){return new E.NotebookCellOutputItem(ie.valueBytes.buffer,ie.mime)}De.to=Se})(Lt||(e.NotebookCellOutputItem=Lt={}));var Ut;(function(De){function Me(ie){return{outputId:ie.id,items:ie.items.map(Lt.from),metadata:ie.metadata}}De.from=Me;function Se(ie){const Oe=ie.items.map(Lt.to);return new E.NotebookCellOutput(Oe,ie.outputId,ie.metadata)}De.to=Se})(Ut||(e.NotebookCellOutput=Ut={}));var bt;(function(De){function Me(Oe){return ie(Oe)?{include:Xe.from(Oe.include)??void 0,exclude:Xe.from(Oe.exclude)??void 0}:Xe.from(Oe)??void 0}De.from=Me;function Se(Oe){return ie(Oe)?{include:Xe.to(Oe.include),exclude:Xe.to(Oe.exclude)}:Xe.to(Oe)}De.to=Se;function ie(Oe){const Ke=Oe;return Ke?!(0,o.isUndefinedOrNull)(Ke.include)&&!(0,o.isUndefinedOrNull)(Ke.exclude):!1}})(bt||(e.NotebookExclusiveDocumentPattern=bt={}));var Pt;(function(De){function Me(Se,ie,Oe){const Ke=typeof Se.command=="string"?{title:"",command:Se.command}:Se.command;return{alignment:Se.alignment===E.NotebookCellStatusBarAlignment.Left?I.CellStatusbarAlignment.Left:I.CellStatusbarAlignment.Right,command:ie.toInternal(Ke,Oe),text:Se.text,tooltip:Se.tooltip,accessibilityInformation:Se.accessibilityInformation,priority:Se.priority}}De.from=Me})(Pt||(e.NotebookStatusBarItem=Pt={}));var ti;(function(De){function Me(Se,ie,Oe){const Ke=typeof Se.command=="string"?{title:"",command:Se.command}:Se.command;return{command:ie.toInternal(Ke,Oe),label:Se.label,description:Se.description,detail:Se.detail,documentation:Se.documentation}}De.from=Me})(ti||(e.NotebookKernelSourceAction=ti={}));var ii;(function(De){function Me(Se){return{transientOutputs:Se?.transientOutputs??!1,transientCellMetadata:Se?.transientCellMetadata??{},transientDocumentMetadata:Se?.transientDocumentMetadata??{},cellContentMetadata:Se?.cellContentMetadata??{}}}De.from=Me})(ii||(e.NotebookDocumentContentOptions=ii={}));var Kt;(function(De){function Me(ie){return{uri:ie.uri,provides:ie.provides}}De.from=Me;function Se(ie){return new E.NotebookRendererScript(m.URI.revive(ie.uri),ie.provides)}De.to=Se})(Kt||(e.NotebookRendererScript=Kt={}));var St;(function(De){function Me(ie){return{message:oe.fromStrict(ie.message)||"",type:k.TestMessageType.Error,expected:ie.expectedOutput,actual:ie.actualOutput,contextValue:ie.contextValue,location:ie.location&&{range:O.from(ie.location.range),uri:ie.location.uri},stackTrace:ie.stackTrace?.map(Oe=>({label:Oe.label,position:Oe.position&&H.from(Oe.position),uri:Oe.uri&&m.URI.revive(Oe.uri).toJSON()}))}}De.from=Me;function Se(ie){const Oe=new E.TestMessage(typeof ie.message=="string"?ie.message:oe.to(ie.message));return Oe.actualOutput=ie.actual,Oe.expectedOutput=ie.expected,Oe.contextValue=ie.contextValue,Oe.location=ie.location?Je.to(ie.location):void 0,Oe}De.to=Se})(St||(e.TestMessage=St={}));var Ot;(function(De){De.namespace=k.namespaceTestTag,De.denamespace=k.denamespaceTestTag})(Ot||(e.TestTag=Ot={}));var li;(function(De){function Me(ie){const Oe=(0,d.getPrivateApiFor)(ie).controllerId;return{extId:P.TestId.fromExtHostTestItem(ie,Oe).toString(),label:ie.label,uri:m.URI.revive(ie.uri),busy:ie.busy,tags:ie.tags.map(Ke=>Ot.namespace(Oe,Ke.id)),range:u.Range.lift(O.from(ie.range)),description:ie.description||null,sortText:ie.sortText||null,error:ie.error&&oe.fromStrict(ie.error)||null}}De.from=Me;function Se(ie){return{parent:void 0,error:void 0,id:P.TestId.fromString(ie.extId).localId,label:ie.label,uri:m.URI.revive(ie.uri),tags:(ie.tags||[]).map(Oe=>{const{tagId:Ke}=Ot.denamespace(Oe);return new E.TestTag(Ke)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:O.to(ie.range||void 0),canResolveChildren:!1,busy:ie.busy,description:ie.description||void 0,sortText:ie.sortText||void 0}}De.toPlain=Se})(li||(e.TestItem=li={})),function(De){function Me(ie){return{id:ie.id}}De.from=Me;function Se(ie){return new E.TestTag(ie.id)}De.to=Se}(Ot||(e.TestTag=Ot={}));var Yt;(function(De){const Me=(ie,Oe)=>{const Ke=ie.value;if(!Ke)return;const rt={...li.toPlain(Ke.item),parent:Oe,taskStates:Ke.tasks.map(je=>({state:je.state,duration:je.duration,messages:je.messages.filter(ut=>ut.type===k.TestMessageType.Error).map(St.to)})),children:[]};if(ie.children)for(const je of ie.children.values()){const ut=Me(je,rt);ut&&rt.children.push(ut)}return rt};function Se(ie){const Oe=new f.WellDefinedPrefixTree;for(const je of ie.items)Oe.insert(P.TestId.fromString(je.item.extId).path,je);const Ke=[Oe.nodes],rt=[];for(;Ke.length;)for(const je of Ke.pop())je.value?rt.push(je):je.children&&Ke.push(je.children.values());return{completedAt:ie.completedAt,results:rt.map(je=>Me(je)).filter(o.isDefined)}}De.to=Se})(Yt||(e.TestResults=Yt={}));var et;(function(De){function Me(je){return{covered:je.covered,total:je.total}}function Se(je){return"line"in je?H.from(je):O.from(je)}function ie(je){if(je)return"endLineNumber"in je?O.to(je):H.to(je)}function Oe(je){if(je.type===k.DetailType.Statement){const ut=[];if(je.branches)for(const pt of je.branches)ut.push({executed:pt.count,location:ie(pt.location),label:pt.label});return new E.StatementCoverage(je.count,ie(je.location),je.branches?.map(pt=>new E.BranchCoverage(pt.count,ie(pt.location),pt.label)))}else return new E.DeclarationCoverage(je.name,je.count,ie(je.location))}De.to=Oe;function Ke(je){if(typeof je.executed=="number"&&je.executed<0)throw new Error(`Invalid coverage count ${je.executed}`);return"branches"in je?{count:je.executed,location:Se(je.location),type:k.DetailType.Statement,branches:je.branches.length?je.branches.map(ut=>({count:ut.executed,location:ut.location&&Se(ut.location),label:ut.label})):void 0}:{type:k.DetailType.Declaration,name:je.name,count:je.executed,location:Se(je.location)}}De.fromDetails=Ke;function rt(je,ut,pt){return E.validateTestCoverageCount(pt.statementCoverage),E.validateTestCoverageCount(pt.branchCoverage),E.validateTestCoverageCount(pt.declarationCoverage),{id:ut,uri:pt.uri,statement:Me(pt.statementCoverage),branch:pt.branchCoverage&&Me(pt.branchCoverage),declaration:pt.declarationCoverage&&Me(pt.declarationCoverage),testIds:pt instanceof E.FileCoverage&&pt.fromTests.length?pt.fromTests.map(jt=>P.TestId.fromExtHostTestItem(jt,je).toString()):void 0}}De.fromFile=rt})(et||(e.TestCoverage=et={}));var ni;(function(De){function Me(Se){switch(Se){case a.CodeActionTriggerType.Invoke:return E.CodeActionTriggerKind.Invoke;case a.CodeActionTriggerType.Auto:return E.CodeActionTriggerKind.Automatic}}De.to=Me})(ni||(e.CodeActionTriggerKind=ni={}));var ci;(function(De){function Me(ie){const Oe=new E.TypeHierarchyItem(be.to(ie.kind),ie.name,ie.detail||"",m.URI.revive(ie.uri),O.to(ie.range),O.to(ie.selectionRange));return Oe._sessionId=ie._sessionId,Oe._itemId=ie._itemId,Oe}De.to=Me;function Se(ie,Oe,Ke){if(Oe=Oe??ie._sessionId,Ke=Ke??ie._itemId,Oe===void 0||Ke===void 0)throw new Error("invalid item");return{_sessionId:Oe,_itemId:Ke,kind:be.from(ie.kind),name:ie.name,detail:ie.detail??"",uri:ie.uri,range:O.from(ie.range),selectionRange:O.from(ie.selectionRange),tags:ie.tags?.map(pe.from)}}De.from=Se})(ci||(e.TypeHierarchyItem=ci={}));var di;(function(De){function Me(Se){if(Se)return{value:Se.value,tooltip:Se.tooltip}}De.from=Me})(di||(e.ViewBadge=di={}));var Ct;(function(De){function Me(Ke,rt,je){const ut=rt.fileData;return ut?new E.InternalFileDataTransferItem(new E.DataTransferFile(ut.name,m.URI.revive(ut.uri),ut.id,(0,A.createSingleCallFunction)(()=>je(ut.id)))):Ke===C.Mimes.uriList&&rt.uriListData?new E.InternalDataTransferItem(Oe(rt.uriListData)):new E.InternalDataTransferItem(rt.asString)}De.to=Me;async function Se(Ke,rt){const je=await rt.asString();if(Ke===C.Mimes.uriList)return{asString:je,fileData:void 0,uriListData:ie(je)};const ut=rt.asFile();return{asString:je,fileData:ut?{name:ut.name,uri:ut.uri,id:ut._itemId??ut.id}:void 0}}De.from=Se;function ie(Ke){return D.UriList.split(Ke).map(rt=>{if(rt.startsWith("#"))return rt;try{return m.URI.parse(rt)}catch{}return rt})}function Oe(Ke){return D.UriList.create(Ke.map(rt=>typeof rt=="string"?rt:m.URI.revive(rt)))}})(Ct||(e.DataTransferItem=Ct={}));var Wt;(function(De){function Me(ie,Oe){const Ke=ie.items.map(([rt,je])=>[rt,Ct.to(rt,je,Oe)]);return new E.DataTransfer(Ke)}De.toDataTransfer=Me;async function Se(ie){const Oe={items:[]},Ke=[];for(const[rt,je]of ie)Ke.push((async()=>{Oe.items.push([rt,await Ct.from(rt,je)])})());return await Promise.all(Ke),Oe}De.from=Se})(Wt||(e.DataTransfer=Wt={}));var Nt;(function(De){function Me(ie,Oe){return{kind:"reply",agentId:ie.participant??Oe?.agentId??"",subCommand:ie.command??Oe?.command,message:ie.prompt,title:ie.label}}De.from=Me;function Se(ie){return{prompt:ie.message,label:ie.title,participant:ie.agentId,command:ie.subCommand}}De.to=Se})(Nt||(e.ChatFollowup=Nt={}));var Bt;(function(De){function Me(ie){switch(ie){case w.ChatMessageRole.System:return E.LanguageModelChatMessageRole.System;case w.ChatMessageRole.User:return E.LanguageModelChatMessageRole.User;case w.ChatMessageRole.Assistant:return E.LanguageModelChatMessageRole.Assistant}}De.to=Me;function Se(ie){switch(ie){case E.LanguageModelChatMessageRole.System:return w.ChatMessageRole.System;case E.LanguageModelChatMessageRole.User:return w.ChatMessageRole.User;case E.LanguageModelChatMessageRole.Assistant:return w.ChatMessageRole.Assistant}return w.ChatMessageRole.User}De.from=Se})(Bt||(e.LanguageModelChatMessageRole=Bt={}));var ai;(function(De){function Me(ie){const Oe=ie.content.map(ut=>ut.type==="text"?ut.value:ut.type==="tool_result"?new E.LanguageModelToolResultPart(ut.toolCallId,ut.value,ut.isError):new E.LanguageModelToolCallPart(ut.name,ut.toolCallId,ut.parameters)),Ke=Oe.find(ut=>typeof ut=="string")??"",rt=Bt.to(ie.role),je=new E.LanguageModelChatMessage(rt,Ke,ie.name);return je.content2=Oe,je}De.to=Me;function Se(ie){const Oe=Bt.from(ie.role),Ke=ie.name,rt=ie.content2.map(je=>{if(je instanceof E.LanguageModelToolResultPart)return{type:"tool_result",toolCallId:je.toolCallId,value:je.content,isError:je.isError};if(je instanceof E.LanguageModelToolCallPart)return{type:"tool_use",toolCallId:je.toolCallId,name:je.name,parameters:je.parameters};if(typeof je!="string")throw new Error("Unexpected chat message content type");return{type:"text",value:je}});return{role:Oe,name:Ke,content:rt}}De.from=Se})(ai||(e.LanguageModelChatMessage=ai={}));var ri;(function(De){function Me(ie){return{kind:"markdownContent",content:oe.from(ie.value)}}De.from=Me;function Se(ie){return new E.ChatResponseMarkdownPart(oe.to(ie.content))}De.to=Se})(ri||(e.ChatResponseMarkdownPart=ri={}));var si;(function(De){function Me(ie){return{kind:"markdownVuln",content:oe.from(ie.value),vulnerabilities:ie.vulnerabilities}}De.from=Me;function Se(ie){return new E.ChatResponseMarkdownWithVulnerabilitiesPart(oe.to(ie.content),ie.vulnerabilities)}De.to=Se})(si||(e.ChatResponseMarkdownWithVulnerabilitiesPart=si={}));var Gt;(function(De){function Me(ie){return{kind:"agentDetection",agentId:ie.participant,command:ie.command}}De.from=Me;function Se(ie){return new E.ChatResponseDetectedParticipantPart(ie.agentId,ie.command)}De.to=Se})(Gt||(e.ChatResponseDetectedParticipantPart=Gt={}));var Xt;(function(De){function Me(Se){return{kind:"confirmation",title:Se.title,message:Se.message,data:Se.data,buttons:Se.buttons}}De.from=Me})(Xt||(e.ChatResponseConfirmationPart=Xt={}));var ui;(function(De){function Me(ie){const{value:Oe,baseUri:Ke}=ie;function rt(je,ut){return je.map(pt=>{const jt=m.URI.joinPath(ut,pt.name);return{label:pt.name,uri:jt,children:pt.children&&rt(pt.children,jt)}})}return{kind:"treeData",treeData:{label:(0,T.basename)(Ke),uri:Ke,children:rt(Oe,Ke)}}}De.from=Me;function Se(ie){const Oe=(0,l.revive)(ie.treeData);function Ke(ut){return ut.map(pt=>({name:pt.label,children:pt.children&&Ke(pt.children)}))}const rt=Oe.uri,je=Oe.children?Ke(Oe.children):[];return new E.ChatResponseFileTreePart(je,rt)}De.to=Se})(ui||(e.ChatResponseFilesPart=ui={}));var Mt;(function(De){function Me(ie){const Oe=Ke=>m.URI.isUri(Ke);return{kind:"inlineReference",name:ie.title,inlineReference:Oe(ie.value)?ie.value:M.from(ie.value)}}De.from=Me;function Se(ie){const Oe=(0,l.revive)(ie);return new E.ChatResponseAnchorPart(m.URI.isUri(Oe.inlineReference)?Oe.inlineReference:M.to(Oe.inlineReference),ie.name)}De.to=Se})(Mt||(e.ChatResponseAnchorPart=Mt={}));var kt;(function(De){function Me(ie){return{kind:"progressMessage",content:oe.from(ie.value)}}De.from=Me;function Se(ie){return new E.ChatResponseProgressPart(ie.content.value)}De.to=Se})(kt||(e.ChatResponseProgressPart=kt={}));var wt;(function(De){function Me(ie){return{kind:"warning",content:oe.from(ie.value)}}De.from=Me;function Se(ie){return new E.ChatResponseWarningPart(ie.content.value)}De.to=Se})(wt||(e.ChatResponseWarningPart=wt={}));var Qt;(function(De){function Me(ie){return{kind:"move",uri:ie.uri,range:O.from(ie.range)}}De.from=Me;function Se(ie){return new E.ChatResponseMovePart(m.URI.revive(ie.uri),O.to(ie.range))}De.to=Se})(Qt||(e.ChatResponseMovePart=Qt={}));var yt;(function(De){function Me(Se){return{kind:"progressTask",content:oe.from(Se.value)}}De.from=Me})(yt||(e.ChatTask=yt={}));var oi;(function(De){function Me(Se){return{kind:"progressTaskResult",content:typeof Se=="string"?oe.from(Se):void 0}}De.from=Me})(oi||(e.ChatTaskResult=oi={}));var Jt;(function(De){function Me(ie,Oe,Ke){return{kind:"command",command:Oe.toInternal(ie.value,Ke)??{command:ie.value.command,title:ie.value.title}}}De.from=Me;function Se(ie,Oe){return new E.ChatResponseCommandButtonPart(Oe.fromInternal(ie.command)??{command:ie.command.id,title:ie.command.title})}De.to=Se})(Jt||(e.ChatResponseCommandButtonPart=Jt={}));var Mi;(function(De){function Me(ie){return{kind:"textEdit",uri:ie.uri,edits:ie.edits.map(Oe=>Ee.from(Oe))}}De.from=Me;function Se(ie){return new E.ChatResponseTextEditPart(m.URI.revive(ie.uri),ie.edits.map(Oe=>Ee.to(Oe)))}De.to=Se})(Mi||(e.ChatResponseTextEditPart=Mi={}));var hi;(function(De){function Me(ie){const Oe=S.ThemeIcon.isThemeIcon(ie.iconPath)?ie.iconPath:m.URI.isUri(ie.iconPath)?{light:m.URI.revive(ie.iconPath)}:ie.iconPath&&"light"in ie.iconPath&&"dark"in ie.iconPath&&m.URI.isUri(ie.iconPath.light)&&m.URI.isUri(ie.iconPath.dark)?{light:m.URI.revive(ie.iconPath.light),dark:m.URI.revive(ie.iconPath.dark)}:void 0;return typeof ie.value=="object"&&"variableName"in ie.value?{kind:"reference",reference:{variableName:ie.value.variableName,value:m.URI.isUri(ie.value.value)||!ie.value.value?ie.value.value:M.from(ie.value.value)},iconPath:Oe,options:ie.options}:{kind:"reference",reference:m.URI.isUri(ie.value)||typeof ie.value=="string"?ie.value:M.from(ie.value),iconPath:Oe,options:ie.options}}De.from=Me;function Se(ie){const Oe=(0,l.revive)(ie),Ke=rt=>m.URI.isUri(rt)?rt:M.to(rt);return new E.ChatResponseReferencePart(typeof Oe.reference=="string"?Oe.reference:"variableName"in Oe.reference?{variableName:Oe.reference.variableName,value:Oe.reference.value&&Ke(Oe.reference.value)}:Ke(Oe.reference))}De.to=Se})(hi||(e.ChatResponseReferencePart=hi={}));var wi;(function(De){function Me(Se){return{kind:"codeCitation",value:Se.value,license:Se.license,snippet:Se.snippet}}De.from=Me})(wi||(e.ChatResponseCodeCitationPart=wi={}));var $t;(function(De){function Me(Oe,Ke,rt){return Oe instanceof E.ChatResponseMarkdownPart?ri.from(Oe):Oe instanceof E.ChatResponseAnchorPart?Mt.from(Oe):Oe instanceof E.ChatResponseReferencePart?hi.from(Oe):Oe instanceof E.ChatResponseProgressPart?kt.from(Oe):Oe instanceof E.ChatResponseFileTreePart?ui.from(Oe):Oe instanceof E.ChatResponseCommandButtonPart?Jt.from(Oe,Ke,rt):Oe instanceof E.ChatResponseTextEditPart?Mi.from(Oe):Oe instanceof E.ChatResponseMarkdownWithVulnerabilitiesPart?si.from(Oe):Oe instanceof E.ChatResponseDetectedParticipantPart?Gt.from(Oe):Oe instanceof E.ChatResponseWarningPart?wt.from(Oe):Oe instanceof E.ChatResponseConfirmationPart?Xt.from(Oe):Oe instanceof E.ChatResponseCodeCitationPart?wi.from(Oe):Oe instanceof E.ChatResponseMovePart?Qt.from(Oe):{kind:"markdownContent",content:oe.from("")}}De.from=Me;function Se(Oe,Ke){switch(Oe.kind){case"reference":return hi.to(Oe);case"markdownContent":case"inlineReference":case"progressMessage":case"treeData":case"command":return ie(Oe,Ke)}}De.to=Se;function ie(Oe,Ke){switch(Oe.kind){case"markdownContent":return ri.to(Oe);case"inlineReference":return Mt.to(Oe);case"progressMessage":return;case"treeData":return ui.to(Oe);case"command":return Jt.to(Oe,Ke)}}De.toContent=ie})($t||(e.ChatResponsePart=$t={}));var fi;(function(De){function Me(Se,ie){const Oe=Se.variables.variables.filter(rt=>rt.isTool),Ke=Se.variables.variables.filter(rt=>!rt.isTool);return{prompt:Se.message,command:Se.command,attempt:Se.attempt??0,enableCommandDetection:Se.enableCommandDetection??!0,isParticipantDetected:Se.isParticipantDetected??!1,references:Ke.map(Rt.to),toolReferences:Oe.map(_i.to),location:Fi.to(Se.location),acceptedConfirmationData:Se.acceptedConfirmationData,rejectedConfirmationData:Se.rejectedConfirmationData,location2:ie}}De.to=Me})(fi||(e.ChatAgentRequest=fi={}));var Fi;(function(De){function Me(ie){switch(ie){case g.ChatAgentLocation.Notebook:return E.ChatLocation.Notebook;case g.ChatAgentLocation.Terminal:return E.ChatLocation.Terminal;case g.ChatAgentLocation.Panel:return E.ChatLocation.Panel;case g.ChatAgentLocation.Editor:return E.ChatLocation.Editor}}De.to=Me;function Se(ie){switch(ie){case E.ChatLocation.Notebook:return g.ChatAgentLocation.Notebook;case E.ChatLocation.Terminal:return g.ChatAgentLocation.Terminal;case E.ChatLocation.Panel:return g.ChatAgentLocation.Panel;case E.ChatLocation.Editor:return g.ChatAgentLocation.Editor}}De.from=Se})(Fi||(e.ChatLocation=Fi={}));var Rt;(function(De){function Me(Se){const ie=Se.value;if(!ie)throw new Error("Invalid value reference");return{id:Se.id,name:Se.name,range:Se.range&&[Se.range.start,Se.range.endExclusive],value:(0,m.isUriComponents)(ie)?m.URI.revive(ie):ie&&typeof ie=="object"&&"uri"in ie&&"range"in ie&&(0,m.isUriComponents)(ie.uri)?M.to((0,l.revive)(ie)):ie,modelDescription:Se.modelDescription}}De.to=Me})(Rt||(e.ChatPromptReference=Rt={}));var _i;(function(De){function Me(Se){if(Se.value)throw new Error("Invalid tool reference");return{id:Se.id,range:Se.range&&[Se.range.start,Se.range.endExclusive]}}De.to=Me})(_i||(e.ChatLanguageModelToolReference=_i={}));var Li;(function(De){function Me(Se,ie,Oe){return{id:Se.id,label:Se.label,fullName:Se.fullName,icon:Se.icon?.id,value:Se.values[0].value,insertText:Se.insertText,detail:Se.detail,documentation:Se.documentation,command:ie.toInternal(Se.command,Oe)}}De.from=Me})(Li||(e.ChatAgentCompletionItem=Li={}));var gi;(function(De){function Me(Se){return{errorDetails:Se.errorDetails,metadata:Se.metadata,nextQuestion:Se.nextQuestion}}De.to=Me})(gi||(e.ChatAgentResult=gi={}));var xi;(function(De){function Me(Se,ie,Oe){if(ie.action.kind==="vote")return;const Ke=gi.to(Se);if(ie.action.kind==="command"){const rt=ie.action.commandButton.command;return{action:{kind:"command",commandButton:{command:Oe.fromInternal(rt)??{command:rt.id,title:rt.title}}},result:Ke}}else return ie.action.kind==="followUp"?{action:{kind:"followUp",followup:Nt.to(ie.action.followup)},result:Ke}:ie.action.kind==="inlineChat"?{action:{kind:"editor",accepted:ie.action.action==="accepted"},result:Ke}:{action:ie.action,result:Ke}}De.to=Me})(xi||(e.ChatAgentUserActionEvent=xi={}));var Wi;(function(De){function Me(ie){return{...ie,string:ie.toString()}}De.from=Me;function Se(ie){const Oe={...ie,toString:()=>ie.string};return delete Oe.string,Oe}De.to=Se})(Wi||(e.LanguageModelToolResult=Wi={}));var xt;(function(De){function Me(Se,ie,Oe){return"terminalCommand"in Se?{terminalCommand:Se.terminalCommand,shouldExecute:Se.shouldExecute}:"uri"in Se?{uri:Se.uri}:ie.toInternal(Se,Oe)}De.from=Me})(xt||(e.TerminalQuickFix=xt={}));var Ti;(function(De){function Me(Se){return{kind:Di.to(Se.kind)}}De.to=Me})(Ti||(e.PartialAcceptInfo=Ti={}));var Di;(function(De){function Me(Se){switch(Se){case a.PartialAcceptTriggerKind.Word:return E.PartialAcceptTriggerKind.Word;case a.PartialAcceptTriggerKind.Line:return E.PartialAcceptTriggerKind.Line;case a.PartialAcceptTriggerKind.Suggest:return E.PartialAcceptTriggerKind.Suggest;default:return E.PartialAcceptTriggerKind.Unknown}}De.to=Me})(Di||(e.PartialAcceptTriggerKind=Di={}));var Ei;(function(De){function Me(Se,ie){return{id:ie,label:Se.label,description:Se.description,canEdit:Se.canEdit,collapsibleState:Se.collapsibleState||y.DebugTreeItemCollapsibleState.None,contextValue:Se.contextValue}}De.from=Me})(Ei||(e.DebugTreeItem=Ei={}));var bi;(function(De){function Me(Se){return{id:Se.id,modelDescription:Se.modelDescription,parametersSchema:Se.parametersSchema,displayName:Se.displayName}}De.to=Me})(bi||(e.LanguageModelToolDescription=bi={}))}),define(Pe[296],ke([1,0,6,19,15,53]),function(ge,e,s,h,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let L=class{constructor(v,l){this._proxy=v.getProxy(s.MainContext.MainThreadBulkEdits),this._versionInformationProvider={getTextDocumentVersion:C=>l.getDocument(C)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(v,l,C){const _=new A.SerializableObjectWithBuffers(D.WorkspaceEdit.from(v,this._versionInformationProvider));return this._proxy.$tryApplyWorkspaceEdit(_,void 0,C?.isRefactoring??!1)}};e.ExtHostBulkEdits=L,e.ExtHostBulkEdits=L=Qe([$e(0,h.IExtHostRpcService)],L)}),define(Pe[297],ke([1,0,18,8,52,4,40,3,38,43,17,2,23,6,15,9,158,259,25]),function(ge,e,s,h,D,A,L,R,v,l,C,_,f,T,S,o,m,p,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostChatAgents2=void 0,S=We(S),o=We(o);class i{constructor(r,d,c,g,w){this._extension=r,this._request=d,this._proxy=c,this._commandsConverter=g,this._sessionDisposables=w,this._stopWatch=l.StopWatch.create(!1),this._isClosed=!1}close(){this._isClosed=!0}get timings(){return{firstProgress:this._firstProgress,totalElapsed:this._stopWatch.elapsed()}}get apiObject(){if(!this._apiObject){let d=function(g){if(r._isClosed){const w=new Error("Response stream has been closed");throw Error.captureStackTrace(w,g),w}};const r=this;this._stopWatch.reset();const c=(g,w)=>{if(typeof this._firstProgress>"u"&&(g.kind==="markdownContent"||g.kind==="markdownVuln")&&(this._firstProgress=this._stopWatch.elapsed()),w){const y=this._proxy.$handleProgressChunk(this._request.requestId,g),I={report:P=>{y?.then(k=>{k&&(o.MarkdownString.isMarkdownString(P.value)?this._proxy.$handleProgressChunk(this._request.requestId,S.ChatResponseWarningPart.from(P),k):this._proxy.$handleProgressChunk(this._request.requestId,S.ChatResponseReferencePart.from(P),k))})}};Promise.all([y,w?.(I)]).then(([P,k])=>{P!==void 0&&this._proxy.$handleProgressChunk(this._request.requestId,S.ChatTaskResult.from(k),P)})}else this._proxy.$handleProgressChunk(this._request.requestId,g)};this._apiObject={markdown(g){d(this.markdown);const w=new o.ChatResponseMarkdownPart(g),y=S.ChatResponseMarkdownPart.from(w);return c(y),this},markdownWithVulnerabilities(g,w){d(this.markdown),w&&(0,u.checkProposedApiEnabled)(r._extension,"chatParticipantAdditions");const y=new o.ChatResponseMarkdownWithVulnerabilitiesPart(g,w),I=S.ChatResponseMarkdownWithVulnerabilitiesPart.from(y);return c(I),this},filetree(g,w){d(this.filetree);const y=new o.ChatResponseFileTreePart(g,w),I=S.ChatResponseFilesPart.from(y);return c(I),this},anchor(g,w){d(this.anchor);const y=new o.ChatResponseAnchorPart(g,w),I=S.ChatResponseAnchorPart.from(y);return c(I),this},button(g){d(this.anchor);const w=new o.ChatResponseCommandButtonPart(g),y=S.ChatResponseCommandButtonPart.from(w,r._commandsConverter,r._sessionDisposables);return c(y),this},progress(g,w){d(this.progress);const y=new o.ChatResponseProgressPart2(g,w),I=w?S.ChatTask.from(y):S.ChatResponseProgressPart.from(y);return c(I,w),this},warning(g){d(this.progress),(0,u.checkProposedApiEnabled)(r._extension,"chatParticipantAdditions");const w=new o.ChatResponseWarningPart(g),y=S.ChatResponseWarningPart.from(w);return c(y),this},reference(g,w){return this.reference2(g,w)},reference2(g,w,y){if(d(this.reference),typeof g=="object"&&"variableName"in g&&(0,u.checkProposedApiEnabled)(r._extension,"chatParticipantAdditions"),typeof g=="object"&&"variableName"in g&&!g.value){const I=r._request.variables.variables.find(P=>P.name===g.variableName);if(I){let P;if(I.references?.length)P=I.references.map(k=>({kind:"reference",reference:{variableName:g.variableName,value:k.reference}}));else{const k=new o.ChatResponseReferencePart(g,w,y);P=[S.ChatResponseReferencePart.from(k)]}return P.forEach(k=>c(k)),this}}else{const I=new o.ChatResponseReferencePart(g,w,y),P=S.ChatResponseReferencePart.from(I);c(P)}return this},codeCitation(g,w,y){d(this.codeCitation),(0,u.checkProposedApiEnabled)(r._extension,"chatParticipantAdditions");const I=new o.ChatResponseCodeCitationPart(g,w,y),P=S.ChatResponseCodeCitationPart.from(I);c(P)},textEdit(g,w){d(this.textEdit),(0,u.checkProposedApiEnabled)(r._extension,"chatParticipantAdditions");const y=new o.ChatResponseTextEditPart(g,w),I=S.ChatResponseTextEditPart.from(y);return c(I),this},detectedParticipant(g,w){d(this.detectedParticipant),(0,u.checkProposedApiEnabled)(r._extension,"chatParticipantAdditions");const y=new o.ChatResponseDetectedParticipantPart(g,w),I=S.ChatResponseDetectedParticipantPart.from(y);return c(I),this},confirmation(g,w,y,I){d(this.confirmation),(0,u.checkProposedApiEnabled)(r._extension,"chatParticipantAdditions");const P=new o.ChatResponseConfirmationPart(g,w,y,I),k=S.ChatResponseConfirmationPart.from(P);return c(k),this},push(g){if(d(this.push),(g instanceof o.ChatResponseTextEditPart||g instanceof o.ChatResponseMarkdownWithVulnerabilitiesPart||g instanceof o.ChatResponseDetectedParticipantPart||g instanceof o.ChatResponseWarningPart||g instanceof o.ChatResponseConfirmationPart||g instanceof o.ChatResponseCodeCitationPart||g instanceof o.ChatResponseMovePart)&&(0,u.checkProposedApiEnabled)(r._extension,"chatParticipantAdditions"),g instanceof o.ChatResponseReferencePart)this.reference2(g.value,g.iconPath,g.options);else{const w=S.ChatResponsePart.from(g,r._commandsConverter,r._sessionDisposables);c(w)}return this}}}return this._apiObject}}class a extends R.Disposable{static{this._idPool=0}static{this._participantDetectionProviderIdPool=0}constructor(r,d,c,g){super(),this._logService=d,this._commands=c,this._documents=g,this._agents=new Map,this._participantDetectionProviders=new Map,this._sessionDisposables=this._register(new R.DisposableMap),this._completionDisposables=this._register(new R.DisposableMap),this._proxy=r.getProxy(T.MainContext.MainThreadChatAgents2)}transferActiveChat(r){this._proxy.$transferActiveChatSession(r)}createChatAgent(r,d,c){const g=a._idPool++,w=new t(r,d,this._proxy,g,c);return this._agents.set(g,w),this._proxy.$registerAgent(g,r.identifier,d,{},void 0),w.apiAgent}createDynamicChatAgent(r,d,c,g){const w=a._idPool++,y=new t(r,d,this._proxy,w,g);return this._agents.set(w,y),this._proxy.$registerAgent(w,r.identifier,d,{isSticky:!0},c),y.apiAgent}registerChatParticipantDetectionProvider(r){const d=a._participantDetectionProviderIdPool++;return this._participantDetectionProviders.set(d,r),this._proxy.$registerChatParticipantDetectionProvider(d),(0,R.toDisposable)(()=>{this._participantDetectionProviders.delete(d),this._proxy.$unregisterChatParticipantDetectionProvider(d)})}async $detectChatParticipant(r,d,c,g,w){const{request:y,location:I,history:P}=await this._createRequest(d,c),k=this._participantDetectionProviders.get(r);if(k)return k.provideParticipantDetection(S.ChatAgentRequest.to(y,I),{history:P},{participants:g.participants,location:S.ChatLocation.to(g.location)},w)}async _createRequest(r,d){const c=(0,v.revive)(r),g=await this.prepareHistoryTurns(c.agentId,d);let w;if(c.locationData?.type===m.ChatAgentLocation.Editor){const y=this._documents.getDocument(c.locationData.document);w=new o.ChatRequestEditorData(y,S.Selection.to(c.locationData.selection),S.Range.to(c.locationData.wholeRange))}else if(c.locationData?.type===m.ChatAgentLocation.Notebook){const y=this._documents.getDocument(c.locationData.sessionInputUri);w=new o.ChatRequestNotebookData(y)}else c.locationData?.type,m.ChatAgentLocation.Terminal;return{request:c,location:w,history:g}}async $invokeAgent(r,d,c,g){const w=this._agents.get(r);if(!w)throw new Error(`[CHAT](${r}) CANNOT invoke agent because the agent is not registered`);let y;try{const{request:I,location:P,history:k}=await this._createRequest(d,c);let b=this._sessionDisposables.get(I.sessionId);b||(b=new R.DisposableStore,this._sessionDisposables.set(I.sessionId,b)),y=new i(w.extension,I,this._proxy,this._commands.converter,b);const E=w.invoke(S.ChatAgentRequest.to(I,P),{history:k},y.apiObject,g);return await(0,h.raceCancellation)(Promise.resolve(E).then(N=>{if(N?.metadata)try{JSON.stringify(N.metadata)}catch(M){const U=`result.metadata MUST be JSON.stringify-able. Got error: ${M.message}`;return this._logService.error(`[${w.extension.identifier.value}] [@${w.id}] ${U}`,w.extension),{errorDetails:{message:U},timings:y?.timings,nextQuestion:N.nextQuestion}}let O;return N?.errorDetails&&(O={...N.errorDetails,responseIsIncomplete:!0}),O?.responseIsRedacted&&(0,u.checkProposedApiEnabled)(w.extension,"chatParticipantPrivate"),{errorDetails:O,timings:y?.timings,metadata:N?.metadata,nextQuestion:N?.nextQuestion}}),g)}catch(I){return this._logService.error(I,w.extension),I instanceof o.LanguageModelError&&I.cause&&(I=I.cause),{errorDetails:{message:(0,D.toErrorMessage)(I),responseIsIncomplete:!0}}}finally{y?.close()}}async prepareHistoryTurns(r,d){const c=[];for(const g of d.history){const w=S.ChatAgentResult.to(g.result),y=r===g.request.agentId?w:{...w,metadata:void 0},I=g.request.variables.variables.filter(E=>!E.isTool).map(S.ChatPromptReference.to),P=g.request.variables.variables.filter(E=>E.isTool).map(S.ChatLanguageModelToolReference.to),k=new o.ChatRequestTurn(g.request.message,g.request.command,I,g.request.agentId);k.toolReferences=P,c.push(k);const b=(0,s.coalesce)(g.response.map(E=>S.ChatResponsePart.toContent(E,this._commands.converter)));c.push(new o.ChatResponseTurn(b,y,g.request.agentId,g.request.command))}return c}$releaseSession(r){this._sessionDisposables.deleteAndDispose(r)}async $provideFollowups(r,d,c,g,w){const y=this._agents.get(d);if(!y)return Promise.resolve([]);const I=(0,v.revive)(r),P=await this.prepareHistoryTurns(y.id,g),k=S.ChatAgentResult.to(c);return(await y.provideFollowups(k,{history:P},w)).filter(b=>{const E=!b.participant||L.Iterable.some(this._agents.values(),N=>N.id===b.participant&&f.ExtensionIdentifier.equals(N.extension.identifier,y.extension.identifier));return E||this._logService.warn(`[@${y.id}] ChatFollowup refers to an unknown participant: ${b.participant}`),E}).map(b=>S.ChatFollowup.from(b,I))}$acceptFeedback(r,d,c){const g=this._agents.get(r);if(!g)return;const w=S.ChatAgentResult.to(d);let y;switch(c.direction){case p.ChatAgentVoteDirection.Down:y=o.ChatResultFeedbackKind.Unhelpful;break;case p.ChatAgentVoteDirection.Up:y=o.ChatResultFeedbackKind.Helpful;break}const I={result:w,kind:y,unhelpfulReason:(0,u.isProposedApiEnabled)(g.extension,"chatParticipantAdditions")?c.reason:void 0};g.acceptFeedback(Object.freeze(I))}$acceptAction(r,d,c){const g=this._agents.get(r);if(!g||c.action.kind==="vote")return;const w=S.ChatAgentUserActionEvent.to(d,c,this._commands.converter);w&&g.acceptAction(Object.freeze(w))}async $invokeCompletionProvider(r,d,c){const g=this._agents.get(r);if(!g)return[];let w=this._completionDisposables.get(r);return w?w.clear():(w=new R.DisposableStore,this._completionDisposables.set(r,w)),(await g.invokeCompletionProvider(d,c)).map(I=>S.ChatAgentCompletionItem.from(I,this._commands.converter,w))}async $provideWelcomeMessage(r,d,c){const g=this._agents.get(r);if(g)return await g.provideWelcomeMessage(S.ChatLocation.to(d),c)}async $provideChatTitle(r,d,c){const g=this._agents.get(r);if(!g)return;const w=await this.prepareHistoryTurns(g.id,{history:d});return await g.provideTitle({history:w},c)}async $provideSampleQuestions(r,d,c){const g=this._agents.get(r);if(g)return(await g.provideSampleQuestions(S.ChatLocation.to(d),c)).map(w=>S.ChatFollowup.from(w,void 0))}}e.ExtHostChatAgents2=a;class t{constructor(r,d,c,g,w){this.extension=r,this.id=d,this._proxy=c,this._handle=g,this._requestHandler=w,this._onDidReceiveFeedback=new A.Emitter,this._onDidPerformAction=new A.Emitter}acceptFeedback(r){this._onDidReceiveFeedback.fire(r)}acceptAction(r){this._onDidPerformAction.fire(r)}async invokeCompletionProvider(r,d){return this._agentVariableProvider?await this._agentVariableProvider.provider.provideCompletionItems(r,d)??[]:[]}async provideFollowups(r,d,c){if(!this._followupProvider)return[];const g=await this._followupProvider.provideFollowups(r,d,c);return g?g.filter(w=>!(w&&"commandId"in w)).filter(w=>!(w&&"message"in w)):[]}async provideWelcomeMessage(r,d){if(!this._welcomeMessageProvider)return[];const c=await this._welcomeMessageProvider.provideWelcomeMessage(r,d);return c?c.map(g=>typeof g=="string"?g:S.MarkdownString.from(g)):[]}async provideTitle(r,d){if(this._titleProvider)return await this._titleProvider.provideChatTitle(r,d)??void 0}async provideSampleQuestions(r,d){if(!this._welcomeMessageProvider||!this._welcomeMessageProvider.provideSampleQuestions)return[];const c=await this._welcomeMessageProvider.provideSampleQuestions(r,d);return c||[]}get apiAgent(){let r=!1,d=!1;const c=()=>{r||d||(d=!0,queueMicrotask(()=>{this._proxy.$updateAgent(this._handle,{icon:this._iconPath?this._iconPath instanceof _.URI?this._iconPath:"light"in this._iconPath?this._iconPath.light:void 0:void 0,iconDark:this._iconPath&&"dark"in this._iconPath?this._iconPath.dark:void 0,themeIcon:this._iconPath instanceof o.ThemeIcon?this._iconPath:void 0,hasFollowups:this._followupProvider!==void 0,isSecondary:this._isSecondary,helpTextPrefix:!this._helpTextPrefix||typeof this._helpTextPrefix=="string"?this._helpTextPrefix:S.MarkdownString.from(this._helpTextPrefix),helpTextVariablesPrefix:!this._helpTextVariablesPrefix||typeof this._helpTextVariablesPrefix=="string"?this._helpTextVariablesPrefix:S.MarkdownString.from(this._helpTextVariablesPrefix),helpTextPostfix:!this._helpTextPostfix||typeof this._helpTextPostfix=="string"?this._helpTextPostfix:S.MarkdownString.from(this._helpTextPostfix),supportIssueReporting:this._supportIssueReporting,requester:this._requester,supportsSlowVariables:this._supportsSlowReferences}),d=!1}))},g=this;return{get id(){return g.id},get iconPath(){return g._iconPath},set iconPath(w){g._iconPath=w,c()},get requestHandler(){return g._requestHandler},set requestHandler(w){(0,C.assertType)(typeof w=="function","Invalid request handler"),g._requestHandler=w},get followupProvider(){return g._followupProvider},set followupProvider(w){g._followupProvider=w,c()},get helpTextPrefix(){return(0,u.checkProposedApiEnabled)(g.extension,"defaultChatParticipant"),g._helpTextPrefix},set helpTextPrefix(w){(0,u.checkProposedApiEnabled)(g.extension,"defaultChatParticipant"),g._helpTextPrefix=w,c()},get helpTextVariablesPrefix(){return(0,u.checkProposedApiEnabled)(g.extension,"defaultChatParticipant"),g._helpTextVariablesPrefix},set helpTextVariablesPrefix(w){(0,u.checkProposedApiEnabled)(g.extension,"defaultChatParticipant"),g._helpTextVariablesPrefix=w,c()},get helpTextPostfix(){return(0,u.checkProposedApiEnabled)(g.extension,"defaultChatParticipant"),g._helpTextPostfix},set helpTextPostfix(w){(0,u.checkProposedApiEnabled)(g.extension,"defaultChatParticipant"),g._helpTextPostfix=w,c()},get isSecondary(){return(0,u.checkProposedApiEnabled)(g.extension,"defaultChatParticipant"),g._isSecondary},set isSecondary(w){(0,u.checkProposedApiEnabled)(g.extension,"defaultChatParticipant"),g._isSecondary=w,c()},get supportIssueReporting(){return(0,u.checkProposedApiEnabled)(g.extension,"chatParticipantPrivate"),g._supportIssueReporting},set supportIssueReporting(w){(0,u.checkProposedApiEnabled)(g.extension,"chatParticipantPrivate"),g._supportIssueReporting=w,c()},get onDidReceiveFeedback(){return g._onDidReceiveFeedback.event},set participantVariableProvider(w){if((0,u.checkProposedApiEnabled)(g.extension,"chatParticipantAdditions"),g._agentVariableProvider=w,w){if(!w.triggerCharacters.length)throw new Error("triggerCharacters are required");g._proxy.$registerAgentCompletionsProvider(g._handle,g.id,w.triggerCharacters)}else g._proxy.$unregisterAgentCompletionsProvider(g._handle,g.id)},get participantVariableProvider(){return(0,u.checkProposedApiEnabled)(g.extension,"chatParticipantAdditions"),g._agentVariableProvider},set welcomeMessageProvider(w){(0,u.checkProposedApiEnabled)(g.extension,"defaultChatParticipant"),g._welcomeMessageProvider=w,c()},get welcomeMessageProvider(){return(0,u.checkProposedApiEnabled)(g.extension,"defaultChatParticipant"),g._welcomeMessageProvider},set titleProvider(w){(0,u.checkProposedApiEnabled)(g.extension,"defaultChatParticipant"),g._titleProvider=w,c()},get titleProvider(){return(0,u.checkProposedApiEnabled)(g.extension,"defaultChatParticipant"),g._titleProvider},onDidPerformAction:(0,u.isProposedApiEnabled)(this.extension,"chatParticipantAdditions")?this._onDidPerformAction.event:void 0,set requester(w){g._requester=w,c()},get requester(){return g._requester},set supportsSlowReferences(w){(0,u.checkProposedApiEnabled)(g.extension,"chatParticipantPrivate"),g._supportsSlowReferences=w,c()},get supportsSlowReferences(){return(0,u.checkProposedApiEnabled)(g.extension,"chatParticipantPrivate"),g._supportsSlowReferences},dispose(){r=!0,g._followupProvider=void 0,g._onDidReceiveFeedback.dispose(),g._proxy.$unregisterAgent(g._handle)}}}invoke(r,d,c,g){return this._requestHandler(r,d,c,g)}}}),define(Pe[298],ke([1,0,12,3,51,6,15,9,25]),function(ge,e,s,h,D,A,L,R,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostChatVariables=void 0,L=We(L),R=We(R);class l{static{this._idPool=0}constructor(f){this._resolver=new Map,this._proxy=f.getProxy(A.MainContext.MainThreadChatVariables)}async $resolveVariable(f,T,S,o){const m=this._resolver.get(f);if(m)try{if(m.resolver.resolve2){(0,v.checkProposedApiEnabled)(m.extension,"chatParticipantAdditions");const p=new C(T,this._proxy),u=await m.resolver.resolve2(m.data.name,{prompt:S},p.apiObject,o);if(u&&u[0])return u[0].value}else{const p=await m.resolver.resolve(m.data.name,{prompt:S},o);if(p&&p[0])return p[0].value}}catch(p){(0,s.onUnexpectedExternalError)(p)}}registerVariableResolver(f,T,S,o,m,p,u,i,a){const t=l._idPool++,n=a?D.ThemeIcon.fromId(a):void 0;return this._resolver.set(t,{extension:f,data:{id:T,name:S,description:o,modelDescription:m,icon:n},resolver:u}),this._proxy.$registerVariable(t,{id:T,name:S,description:o,modelDescription:m,isSlow:p,fullName:i,icon:n}),(0,h.toDisposable)(()=>{this._resolver.delete(t),this._proxy.$unregisterVariable(t)})}}e.ExtHostChatVariables=l;class C{constructor(f,T){this._requestId=f,this._proxy=T,this._isClosed=!1}close(){this._isClosed=!0}get apiObject(){if(!this._apiObject){let T=function(o){if(f._isClosed){const m=new Error("Response stream has been closed");throw Error.captureStackTrace(m,o),m}};const f=this,S=o=>{this._proxy.$handleProgressChunk(this._requestId,o)};this._apiObject={progress(o){T(this.progress);const m=new R.ChatResponseProgressPart(o),p=L.ChatResponseProgressPart.from(m);return S(p),this},reference(o){T(this.reference);const m=new R.ChatResponseReferencePart(o),p=L.ChatResponseReferencePart.from(m);return S(p),this},push(o){return T(this.push),o instanceof R.ChatResponseReferencePart?S(L.ChatResponseReferencePart.from(o)):o instanceof R.ChatResponseProgressPart&&S(L.ChatResponseProgressPart.from(o)),this}}}return this._apiObject}}}),define(Pe[299],ke([1,0,8,60,4,3,41,2,88,23,15,9,6,25]),function(ge,e,s,h,D,A,L,R,v,l,C,_,f,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=S,v=We(v),C=We(C),_=We(_);function S(o,m,p){const u=o.getProxy(f.MainContext.MainThreadComments);class i{static{this.handlePool=0}constructor(){this._commentControllers=new Map,this._commentControllersByExtension=new l.ExtensionIdentifierMap,m.registerArgumentProcessor({processArgument:I=>{if(I&&I.$mid===L.MarshalledId.CommentController){const P=this._commentControllers.get(I.handle);return P?P.value:I}else if(I&&I.$mid===L.MarshalledId.CommentThread){const P=I,k=this._commentControllers.get(P.commentControlHandle);if(!k)return P;const b=k.getCommentThread(P.commentThreadHandle);return b?b.value:P}else if(I&&(I.$mid===L.MarshalledId.CommentThreadReply||I.$mid===L.MarshalledId.CommentThreadInstance)){const P=this._commentControllers.get(I.thread.commentControlHandle);if(!P)return I;const k=P.getCommentThread(I.thread.commentThreadHandle);return k?I.$mid===L.MarshalledId.CommentThreadInstance?k.value:{thread:k.value,text:I.text}:I}else if(I&&I.$mid===L.MarshalledId.CommentNode){const P=this._commentControllers.get(I.thread.commentControlHandle);if(!P)return I;const k=P.getCommentThread(I.thread.commentThreadHandle);if(!k)return I;const b=I.commentUniqueId,E=k.getCommentByUniqueId(b);return E||I}else if(I&&I.$mid===L.MarshalledId.CommentThreadNode){const P=this._commentControllers.get(I.thread.commentControlHandle);if(!P)return I;const k=P.getCommentThread(I.thread.commentThreadHandle);if(!k)return I;const b=I.text,E=I.commentUniqueId,N=k.getCommentByUniqueId(E);return N?(typeof N.body=="string"?N.body=b:N.body=new _.MarkdownString(b),N):I}return I}})}createCommentController(I,P,k){const b=i.handlePool++,E=new t(I,b,P,k);this._commentControllers.set(E.handle,E);const N=this._commentControllersByExtension.get(I.identifier)||[];return N.push(E),this._commentControllersByExtension.set(I.identifier,N),E.value}async $createCommentThreadTemplate(I,P,k,b){const E=this._commentControllers.get(I);E&&E.$createCommentThreadTemplate(P,k,b)}async $setActiveComment(I,P){const k=this._commentControllers.get(I);k&&k.$setActiveComment(P??void 0)}async $updateCommentThreadTemplate(I,P,k){const b=this._commentControllers.get(I);b&&b.$updateCommentThreadTemplate(P,k)}$deleteCommentThread(I,P){this._commentControllers.get(I)?.$deleteCommentThread(P)}async $provideCommentingRanges(I,P,k){const b=this._commentControllers.get(I);if(!b||!b.commentingRangeProvider)return Promise.resolve(void 0);const E=await p.ensureDocumentData(R.URI.revive(P));return(0,s.asPromise)(async()=>{const N=await b.commentingRangeProvider.provideCommentingRanges(E.document,k);let O;return Array.isArray(N)?O={ranges:N,fileComments:!1}:N?O={ranges:N.ranges||[],fileComments:N.enableFileComments||!1}:O=N??void 0,O}).then(N=>{let O;return N&&(O={ranges:N.ranges.map(M=>C.Range.from(M)),fileComments:N.fileComments}),O})}$toggleReaction(I,P,k,b,E){const N=this._commentControllers.get(I);return!N||!N.reactionHandler?Promise.resolve(void 0):(0,s.asPromise)(()=>{const O=N.getCommentThread(P);if(O){const M=O.getCommentByUniqueId(b.uniqueIdInThread);if(N!==void 0&&M&&N.reactionHandler)return N.reactionHandler(M,d(E))}return Promise.resolve(void 0)})}}class a{static{this._handlePool=0}set threadId(I){this._id=I}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(I){(I===void 0!=(this._range===void 0)||!I||!this._range||!I.isEqual(this._range))&&(this._range=I,this.modifications.range=I,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(I){this._canReply!==I&&(this._canReply=I,this.modifications.canReply=I,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(I){this._label=I,this.modifications.label=I,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(I){this._contextValue=I,this.modifications.contextValue=I,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(I){this._comments=I,this.modifications.comments=I,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(I){this._collapseState=I,this.modifications.collapsibleState=I,this._onDidUpdateCommentThread.fire()}get state(){return this._state}set state(I){this._state=I,typeof I=="object"?((0,T.checkProposedApiEnabled)(this.extensionDescription,"commentThreadApplicability"),this.modifications.state=I.resolved,this.modifications.applicability=I.applicability):this.modifications.state=I,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}constructor(I,P,k,b,E,N,O,M,U){this._commentControllerHandle=P,this._id=k,this._uri=b,this._range=E,this._comments=N,this.extensionDescription=O,this._isTemplate=M,this.handle=a._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new D.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new A.MutableDisposable,this._acceptInputDisposables.value=new A.DisposableStore,this._id===void 0&&(this._id=`${I}.${this.handle}`),u.$createCommentThread(P,this.handle,this._id,this._uri,C.Range.from(this._range),this._comments.map(F=>n(this,F,this._commentsMap,this.extensionDescription)),O.identifier,this._isTemplate,U),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this._localDisposables.push({dispose:()=>{u.$deleteCommentThread(P,this.handle)}});const H=this;this.value={get uri(){return H.uri},get range(){return H.range},set range(F){H.range=F},get comments(){return H.comments},set comments(F){H.comments=F},get collapsibleState(){return H.collapsibleState},set collapsibleState(F){H.collapsibleState=F},get canReply(){return H.canReply},set canReply(F){H.canReply=F},get contextValue(){return H.contextValue},set contextValue(F){H.contextValue=F},get label(){return H.label},set label(F){H.label=F},get state(){return H.state},set state(F){H.state=F},reveal:(F,x)=>H.reveal(F,x),hide:()=>H.hide(),dispose:()=>{H.dispose()}}}updateIsTemplate(){this._isTemplate&&(this._isTemplate=!1,this.modifications.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this.updateIsTemplate(),this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new A.DisposableStore);const I=k=>Object.prototype.hasOwnProperty.call(this.modifications,k),P={};I("range")&&(P.range=C.Range.from(this._range)),I("label")&&(P.label=this.label),I("contextValue")&&(P.contextValue=this.contextValue??null),I("comments")&&(P.comments=this._comments.map(k=>n(this,k,this._commentsMap,this.extensionDescription))),I("collapsibleState")&&(P.collapseState=c(this._collapseState)),I("canReply")&&(P.canReply=this.canReply),I("state")&&(P.state=g(this._state)),I("applicability")&&(P.applicability=w(this._state)),I("isTemplate")&&(P.isTemplate=this._isTemplate),this.modifications={},u.$updateCommentThread(this._commentControllerHandle,this.handle,this._id,this._uri,P)}getCommentByUniqueId(I){for(const P of this._commentsMap){const k=P[0],b=P[1];if(I===b)return k}}async reveal(I,P){(0,T.checkProposedApiEnabled)(this.extensionDescription,"commentReveal");let k;I&&I.body!==void 0?k=I:P=P??I;let b=k?this._commentsMap.get(k):void 0;b??=this._commentsMap.get(this._comments[0]);let E=!0,N=!1;return P?.focus===_.CommentThreadFocus.Reply?(N=!0,E=!1):P?.focus===_.CommentThreadFocus.Comment&&(E=!1),u.$revealCommentThread(this._commentControllerHandle,this.handle,b,{preserveFocus:E,focusReply:N})}async hide(){return u.$hideCommentThread(this._commentControllerHandle,this.handle)}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(I=>I.dispose())}}Qe([(0,h.debounce)(100)],a.prototype,"eventuallyUpdateCommentThread",null);class t{get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get commentingRangeProvider(){return this._commentingRangeProvider}set commentingRangeProvider(I){this._commentingRangeProvider=I,I?.resourceHints&&(0,T.checkProposedApiEnabled)(this._extension,"commentingRangeHint"),u.$updateCommentingRanges(this.handle,I?.resourceHints)}get reactionHandler(){return this._reactionHandler}set reactionHandler(I){this._reactionHandler=I,u.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!I})}get options(){return this._options}set options(I){this._options=I,u.$updateCommentControllerFeatures(this.handle,{options:this._options})}get activeComment(){return(0,T.checkProposedApiEnabled)(this._extension,"activeComment"),this._activeComment}get activeCommentThread(){return(0,T.checkProposedApiEnabled)(this._extension,"activeComment"),this._activeThread?.value}constructor(I,P,k,b){this._extension=I,this._handle=P,this._id=k,this._label=b,this._threads=new Map,u.$registerCommentController(this.handle,k,b,this._extension.identifier.value);const E=this;this.value=Object.freeze({id:E.id,label:E.label,get options(){return E.options},set options(N){E.options=N},get commentingRangeProvider(){return E.commentingRangeProvider},set commentingRangeProvider(N){E.commentingRangeProvider=N},get reactionHandler(){return E.reactionHandler},set reactionHandler(N){E.reactionHandler=N},get activeCommentThread(){return E.activeCommentThread},createCommentThread(N,O,M){return E.createCommentThread(N,O,M).value},dispose:()=>{E.dispose()}}),this._localDisposables=[],this._localDisposables.push({dispose:()=>{u.$unregisterCommentController(this.handle)}})}createCommentThread(I,P,k){P===void 0&&(0,T.checkProposedApiEnabled)(this._extension,"fileComments");const b=new a(this.id,this.handle,void 0,I,P,k,this._extension,!1);return this._threads.set(b.handle,b),b}$setActiveComment(I){if(!I){this._activeComment=void 0,this._activeThread=void 0;return}const P=this._threads.get(I.commentThreadHandle);P&&(this._activeComment=I.uniqueIdInThread?P.getCommentByUniqueId(I.uniqueIdInThread):void 0,this._activeThread=P)}$createCommentThreadTemplate(I,P,k){const b=new a(this.id,this.handle,void 0,R.URI.revive(I),C.Range.to(P),[],this._extension,!0,k);return b.collapsibleState=v.CommentThreadCollapsibleState.Expanded,this._threads.set(b.handle,b),b}$updateCommentThreadTemplate(I,P){const k=this._threads.get(I);k&&(k.range=C.Range.to(P))}$deleteCommentThread(I){this._threads.get(I)?.dispose(),this._threads.delete(I)}getCommentThread(I){return this._threads.get(I)}dispose(){this._threads.forEach(I=>{I.dispose()}),this._localDisposables.forEach(I=>I.dispose())}}function n(y,I,P,k){let b=P.get(I);return b||(b=++y.commentHandle,P.set(I,b)),I.state!==void 0&&(0,T.checkProposedApiEnabled)(k,"commentsDraftState"),I.reactions?.some(E=>E.reactors!==void 0)&&(0,T.checkProposedApiEnabled)(k,"commentReactor"),{mode:I.mode,contextValue:I.contextValue,uniqueIdInThread:b,body:typeof I.body=="string"?I.body:C.MarkdownString.from(I.body),userName:I.author.name,userIconPath:I.author.iconPath,label:I.label,commentReactions:I.reactions?I.reactions.map(E=>r(E)):void 0,state:I.state,timestamp:I.timestamp?.toJSON()}}function r(y){return{label:y.label,iconPath:y.iconPath?C.pathOrURIToURI(y.iconPath):void 0,count:y.count,hasReacted:y.authorHasReacted,reactors:y.reactors&&y.reactors.length>0&&typeof y.reactors[0]!="string"?y.reactors.map(I=>I.name):y.reactors}}function d(y){return{label:y.label||"",count:y.count||0,iconPath:y.iconPath?R.URI.revive(y.iconPath):"",authorHasReacted:y.hasReacted||!1,reactors:y.reactors?.map(I=>({name:I}))}}function c(y){if(y!==void 0)switch(y){case _.CommentThreadCollapsibleState.Expanded:return v.CommentThreadCollapsibleState.Expanded;case _.CommentThreadCollapsibleState.Collapsed:return v.CommentThreadCollapsibleState.Collapsed}return v.CommentThreadCollapsibleState.Collapsed}function g(y){let I;if(typeof y=="object"?I=y.resolved:I=y,I!==void 0)switch(I){case _.CommentThreadState.Unresolved:return v.CommentThreadState.Unresolved;case _.CommentThreadState.Resolved:return v.CommentThreadState.Resolved}return v.CommentThreadState.Unresolved}function w(y){let I;if(typeof y=="object"&&(I=y.applicability),I!==void 0)switch(I){case _.CommentThreadApplicability.Current:return v.CommentThreadApplicability.Current;case _.CommentThreadApplicability.Outdated:return v.CommentThreadApplicability.Outdated}return v.CommentThreadApplicability.Current}return new i}}),define(Pe[300],ke([1,0,20,61,3,14,22,2,15,97,118,6,9]),function(ge,e,s,h,D,A,L,R,v,l,C,_,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0,v=We(v),_=We(_),f=We(f);class T{constructor(r,d){this.document=r,this._storagePath=d,this._backupCounter=1,this._edits=new C.Cache("custom documents")}addEdit(r){return this._edits.add([r])}async undo(r,d){await this.getEdit(r).undo(),d||this.disposeBackup()}async redo(r,d){await this.getEdit(r).redo(),d||this.disposeBackup()}disposeEdits(r){for(const d of r)this._edits.delete(d)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const r=t(this.document.uri)+this._backupCounter++;return(0,L.joinPath)(this._storagePath,r)}updateBackup(r){this._backup?.delete(),this._backup=r}disposeBackup(){this._backup?.delete(),this._backup=void 0}getEdit(r){const d=this._edits.get(r,0);if(!d)throw new Error("No edit found");return d}}class S{constructor(){this._documents=new Map}get(r,d){return this._documents.get(this.key(r,d))}add(r,d,c){const g=this.key(r,d.uri);if(this._documents.has(g))throw new Error(`Document already exists for viewType:${r} resource:${d.uri}`);const w=new T(d,c);return this._documents.set(g,w),w}delete(r,d){const c=this.key(r,d.uri);this._documents.delete(c)}key(r,d){return`${r}@@@${d}`}}var o;(function(n){n[n.Text=0]="Text",n[n.Custom=1]="Custom"})(o||(o={}));class m{constructor(){this._providers=new Map}addTextProvider(r,d,c){return this.add(r,{type:o.Text,extension:d,provider:c})}addCustomProvider(r,d,c){return this.add(r,{type:o.Custom,extension:d,provider:c})}get(r){return this._providers.get(r)}add(r,d){if(this._providers.has(r))throw new Error(`Provider for viewType:${r} already registered`);return this._providers.set(r,d),new f.Disposable(()=>this._providers.delete(r))}}class p{constructor(r,d,c,g,w){this._extHostDocuments=d,this._extensionStoragePaths=c,this._extHostWebview=g,this._extHostWebviewPanels=w,this._editorProviders=new m,this._documents=new S,this._proxy=r.getProxy(_.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(r,d,c,g){const w=new D.DisposableStore;return i(c)?(w.add(this._editorProviders.addTextProvider(d,r,c)),this._proxy.$registerTextEditorProvider((0,l.toExtensionData)(r),d,g.webviewOptions||{},{supportsMove:!!c.moveCustomTextEditor},(0,l.shouldSerializeBuffersForPostMessage)(r))):(w.add(this._editorProviders.addCustomProvider(d,r,c)),u(c)&&w.add(c.onDidChangeCustomDocument(y=>{const I=this.getCustomDocumentEntry(d,y.document.uri);if(a(y)){const P=I.addEdit(y);this._proxy.$onDidEdit(y.document.uri,d,P,y.label)}else this._proxy.$onContentChange(y.document.uri,d)})),this._proxy.$registerCustomEditorProvider((0,l.toExtensionData)(r),d,g.webviewOptions||{},!!g.supportsMultipleEditorsPerDocument,(0,l.shouldSerializeBuffersForPostMessage)(r))),f.Disposable.from(w,new f.Disposable(()=>{this._proxy.$unregisterEditorProvider(d)}))}async $createCustomDocument(r,d,c,g,w){const y=this._editorProviders.get(d);if(!y)throw new Error(`No provider found for '${d}'`);if(y.type!==o.Custom)throw new Error(`Invalid provide type for '${d}'`);const I=R.URI.revive(r),P=await y.provider.openCustomDocument(I,{backupId:c,untitledDocumentData:g?.buffer},w);let k;return u(y.provider)&&this._extensionStoragePaths&&(k=this._extensionStoragePaths.workspaceValue(y.extension)??this._extensionStoragePaths.globalValue(y.extension)),this._documents.add(d,P,k),{editable:u(y.provider)}}async $disposeCustomDocument(r,d){const c=this._editorProviders.get(d);if(!c)throw new Error(`No provider found for '${d}'`);if(c.type!==o.Custom)throw new Error(`Invalid provider type for '${d}'`);const g=R.URI.revive(r),{document:w}=this.getCustomDocumentEntry(d,g);this._documents.delete(d,w),w.dispose()}async $resolveCustomEditor(r,d,c,g,w,y){const I=this._editorProviders.get(c);if(!I)throw new Error(`No provider found for '${c}'`);const P=v.ViewColumn.to(w),k=this._extHostWebview.createNewWebview(d,g.contentOptions,I.extension),b=this._extHostWebviewPanels.createNewWebviewPanel(d,c,g.title,P,g.options,k,g.active),E=R.URI.revive(r);switch(I.type){case o.Custom:{const{document:N}=this.getCustomDocumentEntry(c,E);return I.provider.resolveCustomEditor(N,b,y)}case o.Text:{const N=this._extHostDocuments.getDocument(E);return I.provider.resolveCustomTextEditor(N,b,y)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(r,d,c){this.getCustomDocumentEntry(d,r).disposeEdits(c)}async $onMoveCustomEditor(r,d,c){const g=this._editorProviders.get(c);if(!g)throw new Error(`No provider found for '${c}'`);if(!g.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${c}'`);const w=this._extHostWebviewPanels.getWebviewPanel(r);if(!w)throw new Error("No webview found");const y=R.URI.revive(d),I=this._extHostDocuments.getDocument(y);await g.provider.moveCustomTextEditor(I,w,s.CancellationToken.None)}async $undo(r,d,c,g){return this.getCustomDocumentEntry(d,r).undo(c,g)}async $redo(r,d,c,g){return this.getCustomDocumentEntry(d,r).redo(c,g)}async $revert(r,d,c){const g=this.getCustomDocumentEntry(d,r);await this.getCustomEditorProvider(d).revertCustomDocument(g.document,c),g.disposeBackup()}async $onSave(r,d,c){const g=this.getCustomDocumentEntry(d,r);await this.getCustomEditorProvider(d).saveCustomDocument(g.document,c),g.disposeBackup()}async $onSaveAs(r,d,c,g){const w=this.getCustomDocumentEntry(d,r);return this.getCustomEditorProvider(d).saveCustomDocumentAs(w.document,R.URI.revive(c),g)}async $backup(r,d,c){const g=this.getCustomDocumentEntry(d,r),y=await this.getCustomEditorProvider(d).backupCustomDocument(g.document,{destination:g.getNewBackupUri()},c);return g.updateBackup(y),y.id}getCustomDocumentEntry(r,d){const c=this._documents.get(r,R.URI.revive(d));if(!c)throw new Error("No custom document found");return c}getCustomEditorProvider(r){const c=this._editorProviders.get(r)?.provider;if(!c||!u(c))throw new Error("Custom document is not editable");return c}}e.ExtHostCustomEditors=p;function u(n){return!!n.onDidChangeCustomDocument}function i(n){return typeof n.resolveCustomTextEditor=="function"}function a(n){return typeof n.undo=="function"&&typeof n.redo=="function"}function t(n){const r=n.scheme===A.Schemas.file||n.scheme===A.Schemas.untitled?n.fsPath:n.toString();return(0,h.hash)(r)+""}}),define(Pe[301],ke([1,0,7,149,2,6,9,15,4,11,28,64]),function(ge,e,s,h,D,A,L,R,v,l,C,_){"use strict";var f;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0,R=We(R);class T{#e;#t;#i;constructor(m,p,u,i,a,t,n,r){this._name=m,this._owner=p,this._maxDiagnosticsTotal=u,this._maxDiagnosticsPerFile=i,this._modelVersionIdProvider=a,this._isDisposed=!1,this._maxDiagnosticsTotal=Math.max(i,u),this.#i=new C.ResourceMap(d=>t.getComparisonKey(d)),this.#e=n,this.#t=r}dispose(){this._isDisposed||(this.#t.fire([...this.#i.keys()]),this.#e?.$clear(this._owner),this.#i.clear(),this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(m,p){if(!m){this.clear();return}this._checkDisposed();let u=[];if(D.URI.isUri(m)){if(!p){this.delete(m);return}this.#i.set(m,p.slice()),u=[m]}else if(Array.isArray(m)){u=[];let t;m=[...m].sort(T._compareIndexedTuplesByUri);for(const n of m){const[r,d]=n;if((!t||r.toString()!==t.toString())&&(t&&this.#i.get(t).length===0&&this.#i.delete(t),t=r,u.push(r),this.#i.set(r,[])),d)this.#i.get(r)?.push(...d);else{const c=this.#i.get(r);c&&(c.length=0)}}}if(this.#t.fire(u),!this.#e)return;const i=[];let a=0;for(const t of u){let n=[];const r=this.#i.get(t);if(r)if(r.length>this._maxDiagnosticsPerFile){n=[];const d=[L.DiagnosticSeverity.Error,L.DiagnosticSeverity.Warning,L.DiagnosticSeverity.Information,L.DiagnosticSeverity.Hint];e:for(let c=0;c<4;c++)for(const g of r)if(g.severity===d[c]&&n.push({...R.Diagnostic.from(g),modelVersionId:this._modelVersionIdProvider(t)})===this._maxDiagnosticsPerFile)break e;n.push({severity:h.MarkerSeverity.Info,message:(0,s.localize)(2700,null,r.length-this._maxDiagnosticsPerFile),startLineNumber:n[n.length-1].startLineNumber,startColumn:n[n.length-1].startColumn,endLineNumber:n[n.length-1].endLineNumber,endColumn:n[n.length-1].endColumn})}else n=r.map(d=>({...R.Diagnostic.from(d),modelVersionId:this._modelVersionIdProvider(t)}));if(i.push([t,n]),a+=n.length,a>this._maxDiagnosticsTotal)break}this.#e.$changeMany(this._owner,i)}delete(m){this._checkDisposed(),this.#t.fire([m]),this.#i.delete(m),this.#e?.$changeMany(this._owner,[[m,void 0]])}clear(){this._checkDisposed(),this.#t.fire([...this.#i.keys()]),this.#i.clear(),this.#e?.$clear(this._owner)}forEach(m,p){this._checkDisposed();for(const[u,i]of this)m.call(p,u,i,this)}*[Symbol.iterator](){this._checkDisposed();for(const m of this.#i.keys())yield[m,this.get(m)]}get(m){this._checkDisposed();const p=this.#i.get(m);return Array.isArray(p)?Object.freeze(p.slice(0)):[]}has(m){return this._checkDisposed(),Array.isArray(this.#i.get(m))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(m,p){return m[0].toString()<p[0].toString()?-1:m[0].toString()>p[0].toString()?1:0}}e.DiagnosticCollection=T;let S=class{static{f=this}static{this._idPool=0}static{this._maxDiagnosticsPerFile=1e3}static{this._maxDiagnosticsTotal=1.1*this._maxDiagnosticsPerFile}static _mapper(m){const p=new C.ResourceMap;for(const u of m)p.set(u,u);return{uris:Object.freeze(Array.from(p.values()))}}constructor(m,p,u,i){this._logService=p,this._fileSystemInfoService=u,this._extHostDocumentsAndEditors=i,this._collections=new Map,this._onDidChangeDiagnostics=new v.DebounceEmitter({merge:a=>a.flat(),delay:50}),this.onDidChangeDiagnostics=v.Event.map(this._onDidChangeDiagnostics.event,f._mapper),this._proxy=m.getProxy(A.MainContext.MainThreadDiagnostics)}createDiagnosticCollection(m,p){const{_collections:u,_proxy:i,_onDidChangeDiagnostics:a,_logService:t,_fileSystemInfoService:n,_extHostDocumentsAndEditors:r}=this,d=new class{$changeMany(w,y){i.$changeMany(w,y),t.trace("[DiagnosticCollection] change many (extension, owner, uris)",m.value,w,y.length===0?"CLEARING":y)}$clear(w){i.$clear(w),t.trace("[DiagnosticCollection] remove all (extension, owner)",m.value,w)}dispose(){i.dispose()}};let c;if(!p)p="_generated_diagnostic_collection_name_#"+f._idPool++,c=p;else if(!u.has(p))c=p;else{this._logService.warn(`DiagnosticCollection with name '${p}' does already exist.`);do c=p+f._idPool++;while(u.has(c))}return new class extends T{constructor(){super(p,c,f._maxDiagnosticsTotal,f._maxDiagnosticsPerFile,w=>r.getDocument(w)?.version,n.extUri,d,a),u.set(c,this)}dispose(){super.dispose(),u.delete(c)}}}getDiagnostics(m){if(m)return this._getDiagnostics(m);{const p=new Map,u=[];for(const i of this._collections.values())i.forEach((a,t)=>{let n=p.get(a.toString());typeof n>"u"&&(n=u.length,p.set(a.toString(),n),u.push([a,[]])),u[n][1]=u[n][1].concat(...t)});return u}}_getDiagnostics(m){let p=[];for(const u of this._collections.values())u.has(m)&&(p=p.concat(u.get(m)));return p}$acceptMarkersChange(m){if(!this._mirrorCollection){const p="_generated_mirror",u=new T(p,p,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,i=>{},this._fileSystemInfoService.extUri,void 0,this._onDidChangeDiagnostics);this._collections.set(p,u),this._mirrorCollection=u}for(const[p,u]of m)this._mirrorCollection.set(D.URI.revive(p),u.map(R.Diagnostic.to))}};e.ExtHostDiagnostics=S,e.ExtHostDiagnostics=S=f=Qe([$e(1,l.ILogService),$e(2,_.IExtHostFileSystemInfo)],S)}),define(Pe[302],ke([1,0,2,12,9,15,82,53]),function(ge,e,s,h,D,A,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class v{constructor(C,_,f,T={timeout:1500,errors:3}){this._logService=C,this._documents=_,this._mainThreadBulkEdits=f,this._thresholds=T,this._callbacks=new L.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(C){return(_,f,T)=>{const o={dispose:this._callbacks.push([_,f,C])};return Array.isArray(T)&&T.push(o),o}}async $participateInSave(C,_){const f=s.URI.revive(C);let T=!1;const S=setTimeout(()=>T=!0,this._thresholds.timeout),o=[];try{for(const m of[...this._callbacks]){if(T)break;const p=this._documents.getDocument(f),u=await this._deliverEventAsyncAndBlameBadListeners(m,{document:p,reason:A.TextDocumentSaveReason.to(_)});o.push(u)}}finally{clearTimeout(S)}return o}_deliverEventAsyncAndBlameBadListeners([C,_,f],T){const S=this._badListeners.get(C);return typeof S=="number"&&S>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(f,C,_,T).then(()=>!0,o=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${f.identifier.value}' threw ERROR`),this._logService.error(o),!(o instanceof Error)||o.message!=="concurrent_edits"){const m=this._badListeners.get(C);this._badListeners.set(C,m?m+1:1),typeof m=="number"&&m>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${f.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(C,_,f,T){const S=[],o=Date.now(),{document:m,reason:p}=T,{version:u}=m,i=Object.freeze({document:m,reason:p,waitUntil(a){if(Object.isFrozen(S))throw(0,h.illegalState)("waitUntil can not be called async");S.push(Promise.resolve(a))}});try{_.apply(f,[i])}catch(a){return Promise.reject(a)}return Object.freeze(S),new Promise((a,t)=>{const n=setTimeout(()=>t(new Error("timeout")),this._thresholds.timeout);return Promise.all(S).then(r=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${C.identifier.value}' finished after ${Date.now()-o}ms`),clearTimeout(n),a(r)}).catch(r=>{clearTimeout(n),t(r)})}).then(a=>{const t={edits:[]};for(const n of a)if(Array.isArray(n)&&n.every(r=>r instanceof D.TextEdit))for(const{newText:r,newEol:d,range:c}of n)t.edits.push({resource:m.uri,versionId:void 0,textEdit:{range:c&&A.Range.from(c),text:r,eol:d&&A.EndOfLine.from(d)}});if(t.edits.length!==0)return u===m.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(new R.SerializableObjectWithBuffers(t)):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=v}),define(Pe[303],ke([1,0,4,3,2,6,169,15,17,24,9]),function(ge,e,s,h,D,A,L,R,v,l,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0,R=We(R);class _{constructor(T,S){this._onDidAddDocument=new s.Emitter,this._onDidRemoveDocument=new s.Emitter,this._onDidChangeDocument=new s.Emitter,this._onDidSaveDocument=new s.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new h.DisposableStore,this._documentLoader=new Map,this._proxy=T.getProxy(A.MainContext.MainThreadDocuments),this._documentsAndEditors=S,this._documentsAndEditors.onDidRemoveDocuments(o=>{for(const m of o)this._onDidRemoveDocument.fire(m.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(o=>{for(const m of o)this._onDidAddDocument.fire(m.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(T){if(!T)return;const S=this._documentsAndEditors.getDocument(T);if(S)return S}getDocument(T){const S=this.getDocumentData(T);if(!S?.document)throw new Error(`Unable to retrieve document from URI '${T}'`);return S.document}ensureDocumentData(T){const S=this._documentsAndEditors.getDocument(T);if(S)return Promise.resolve(S);let o=this._documentLoader.get(T.toString());return o||(o=this._proxy.$tryOpenDocument(T).then(m=>{this._documentLoader.delete(T.toString());const p=D.URI.revive(m);return(0,v.assertIsDefined)(this._documentsAndEditors.getDocument(p))},m=>(this._documentLoader.delete(T.toString()),Promise.reject(m))),this._documentLoader.set(T.toString(),o)),o}createDocumentData(T){return this._proxy.$tryCreateDocument(T).then(S=>D.URI.revive(S))}$acceptModelLanguageChanged(T,S){const o=D.URI.revive(T),m=this._documentsAndEditors.getDocument(o);if(!m)throw new Error("unknown document");this._onDidRemoveDocument.fire(m.document),m._acceptLanguageId(S),this._onDidAddDocument.fire(m.document)}$acceptModelSaved(T){const S=D.URI.revive(T),o=this._documentsAndEditors.getDocument(S);if(!o)throw new Error("unknown document");this.$acceptDirtyStateChanged(T,!1),this._onDidSaveDocument.fire(o.document)}$acceptDirtyStateChanged(T,S){const o=D.URI.revive(T),m=this._documentsAndEditors.getDocument(o);if(!m)throw new Error("unknown document");m._acceptIsDirty(S),this._onDidChangeDocument.fire({document:m.document,contentChanges:[],reason:void 0})}$acceptModelChanged(T,S,o){const m=D.URI.revive(T),p=this._documentsAndEditors.getDocument(m);if(!p)throw new Error("unknown document");p._acceptIsDirty(o),p.onEvents(S);let u;S.isUndoing?u=C.TextDocumentChangeReason.Undo:S.isRedoing&&(u=C.TextDocumentChangeReason.Redo),this._onDidChangeDocument.fire((0,l.deepFreeze)({document:p.document,contentChanges:S.changes.map(i=>({range:R.Range.to(i.range),rangeOffset:i.rangeOffset,rangeLength:i.rangeLength,text:i.text})),reason:u}))}setWordDefinitionFor(T,S){(0,L.setWordDefinitionFor)(T,S)}}e.ExtHostDocuments=_}),define(Pe[79],ke([1,0,80,4,17,2,5,6,19,15,9]),function(ge,e,s,h,D,A,L,R,v,l,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,l=We(l),e.IExtHostEditorTabs=(0,L.createDecorator)("IExtHostEditorTabs");class _{constructor(m,p,u){this._activeTabIdGetter=u,this._parentGroup=p,this.acceptDtoUpdate(m)}get apiObject(){if(!this._apiObject){const m=this,p={get isActive(){return m._dto.id===m._activeTabIdGetter()},get label(){return m._dto.label},get input(){return m._input},get isDirty(){return m._dto.isDirty},get isPinned(){return m._dto.isPinned},get isPreview(){return m._dto.isPreview},get group(){return m._parentGroup.apiObject}};this._apiObject=Object.freeze(p)}return this._apiObject}get tabId(){return this._dto.id}acceptDtoUpdate(m){this._dto=m,this._input=this._initInput()}_initInput(){switch(this._dto.input.kind){case R.TabInputKind.TextInput:return new C.TextTabInput(A.URI.revive(this._dto.input.uri));case R.TabInputKind.TextDiffInput:return new C.TextDiffTabInput(A.URI.revive(this._dto.input.original),A.URI.revive(this._dto.input.modified));case R.TabInputKind.TextMergeInput:return new C.TextMergeTabInput(A.URI.revive(this._dto.input.base),A.URI.revive(this._dto.input.input1),A.URI.revive(this._dto.input.input2),A.URI.revive(this._dto.input.result));case R.TabInputKind.CustomEditorInput:return new C.CustomEditorTabInput(A.URI.revive(this._dto.input.uri),this._dto.input.viewType);case R.TabInputKind.WebviewEditorInput:return new C.WebviewEditorTabInput(this._dto.input.viewType);case R.TabInputKind.NotebookInput:return new C.NotebookEditorTabInput(A.URI.revive(this._dto.input.uri),this._dto.input.notebookType);case R.TabInputKind.NotebookDiffInput:return new C.NotebookDiffEditorTabInput(A.URI.revive(this._dto.input.original),A.URI.revive(this._dto.input.modified),this._dto.input.notebookType);case R.TabInputKind.TerminalEditorInput:return new C.TerminalEditorTabInput;case R.TabInputKind.InteractiveEditorInput:return new C.InteractiveWindowInput(A.URI.revive(this._dto.input.uri),A.URI.revive(this._dto.input.inputBoxUri));case R.TabInputKind.ChatEditorInput:return new C.ChatEditorTabInput;case R.TabInputKind.MultiDiffEditorInput:return new C.TextMultiDiffTabInput(this._dto.input.diffEditors.map(m=>new C.TextDiffTabInput(A.URI.revive(m.original),A.URI.revive(m.modified))));default:return}}}class f{constructor(m,p){this._tabs=[],this._activeTabId="",this._dto=m,this._activeGroupIdGetter=p;for(const u of m.tabs)u.isActive&&(this._activeTabId=u.id),this._tabs.push(new _(u,this,()=>this.activeTabId()))}get apiObject(){if(!this._apiObject){const m=this,p={get isActive(){return m._dto.groupId===m._activeGroupIdGetter()},get viewColumn(){return l.ViewColumn.to(m._dto.viewColumn)},get activeTab(){return m._tabs.find(u=>u.tabId===m._activeTabId)?.apiObject},get tabs(){return Object.freeze(m._tabs.map(u=>u.apiObject))}};this._apiObject=Object.freeze(p)}return this._apiObject}get groupId(){return this._dto.groupId}get tabs(){return this._tabs}acceptGroupDtoUpdate(m){this._dto=m}acceptTabOperation(m){if(m.kind===R.TabModelOperationKind.TAB_OPEN){const u=new _(m.tabDto,this,()=>this.activeTabId());return this._tabs.splice(m.index,0,u),m.tabDto.isActive&&(this._activeTabId=u.tabId),u}else if(m.kind===R.TabModelOperationKind.TAB_CLOSE){const u=this._tabs.splice(m.index,1)[0];if(!u)throw new Error(`Tab close updated received for index ${m.index} which does not exist`);return u.tabId===this._activeTabId&&(this._activeTabId=""),u}else if(m.kind===R.TabModelOperationKind.TAB_MOVE){if(m.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const u=this._tabs.splice(m.oldIndex,1)[0];if(!u)throw new Error(`Tab move updated received for index ${m.oldIndex} which does not exist`);return this._tabs.splice(m.index,0,u),u}const p=this._tabs.find(u=>u.tabId===m.tabDto.id);if(!p)throw new Error("INVALID tab");return m.tabDto.isActive?this._activeTabId=m.tabDto.id:this._activeTabId===m.tabDto.id&&!m.tabDto.isActive&&(this._activeTabId=""),p.acceptDtoUpdate(m.tabDto),p}activeTabId(){return this._activeTabId}}let T=class{constructor(m){this._onDidChangeTabs=new h.Emitter,this._onDidChangeTabGroups=new h.Emitter,this._extHostTabGroups=[],this._proxy=m.getProxy(R.MainContext.MainThreadEditorTabs)}get tabGroups(){if(!this._apiObject){const m=this,p={onDidChangeTabGroups:m._onDidChangeTabGroups.event,onDidChangeTabs:m._onDidChangeTabs.event,get all(){return Object.freeze(m._extHostTabGroups.map(u=>u.apiObject))},get activeTabGroup(){const u=m._activeGroupId;return(0,D.assertIsDefined)(m._extHostTabGroups.find(a=>a.groupId===u)?.apiObject)},close:async(u,i)=>{const a=Array.isArray(u)?u:[u];return a.length?S(a[0])?this._closeGroups(a,i):this._closeTabs(a,i):!0}};this._apiObject=Object.freeze(p)}return this._apiObject}$acceptEditorTabModel(m){const p=new Set(this._extHostTabGroups.map(d=>d.groupId)),u=new Set(m.map(d=>d.groupId)),i=(0,s.diffSets)(p,u),a=this._extHostTabGroups.filter(d=>i.removed.includes(d.groupId)).map(d=>d.apiObject),t=[],n=[];this._extHostTabGroups=m.map(d=>{const c=new f(d,()=>this._activeGroupId);return i.added.includes(c.groupId)?t.push(c.apiObject):n.push(c.apiObject),c});const r=(0,D.assertIsDefined)(m.find(d=>d.isActive===!0)?.groupId);r!==void 0&&this._activeGroupId!==r&&(this._activeGroupId=r),this._onDidChangeTabGroups.fire(Object.freeze({opened:t,closed:a,changed:n}))}$acceptTabGroupUpdate(m){const p=this._extHostTabGroups.find(u=>u.groupId===m.groupId);if(!p)throw new Error("Update Group IPC call received before group creation.");p.acceptGroupDtoUpdate(m),m.isActive&&(this._activeGroupId=m.groupId),this._onDidChangeTabGroups.fire(Object.freeze({changed:[p.apiObject],opened:[],closed:[]}))}$acceptTabOperation(m){const p=this._extHostTabGroups.find(i=>i.groupId===m.groupId);if(!p)throw new Error("Update Tabs IPC call received before group creation.");const u=p.acceptTabOperation(m);switch(m.kind){case R.TabModelOperationKind.TAB_OPEN:this._onDidChangeTabs.fire(Object.freeze({opened:[u.apiObject],closed:[],changed:[]}));return;case R.TabModelOperationKind.TAB_CLOSE:this._onDidChangeTabs.fire(Object.freeze({opened:[],closed:[u.apiObject],changed:[]}));return;case R.TabModelOperationKind.TAB_MOVE:case R.TabModelOperationKind.TAB_UPDATE:this._onDidChangeTabs.fire(Object.freeze({opened:[],closed:[],changed:[u.apiObject]}));return}}_findExtHostTabFromApi(m){for(const p of this._extHostTabGroups)for(const u of p.tabs)if(u.apiObject===m)return u}_findExtHostTabGroupFromApi(m){return this._extHostTabGroups.find(p=>p.apiObject===m)}async _closeTabs(m,p){const u=[];for(const i of m){const a=this._findExtHostTabFromApi(i);if(!a)throw new Error("Tab close: Invalid tab not found!");u.push(a.tabId)}return this._proxy.$closeTab(u,p)}async _closeGroups(m,p){const u=[];for(const i of m){const a=this._findExtHostTabGroupFromApi(i);if(!a)throw new Error("Group close: Invalid group not found!");u.push(a.groupId)}return this._proxy.$closeGroup(u,p)}};e.ExtHostEditorTabs=T,e.ExtHostEditorTabs=T=Qe([$e(0,v.IExtHostRpcService)],T);function S(o){return o.tabs!==void 0}}),define(Pe[304],ke([1,0,2,6,27,3,9,15,200,13,26,21,25,86]),function(ge,e,s,h,D,A,L,R,v,l,C,_,f,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0,D=We(D),R=We(R);class S{constructor(){this._schemes=[]}add(p){this._stateMachine=void 0,this._schemes.push(p)}delete(p){const u=this._schemes.indexOf(p);u>=0&&(this._schemes.splice(u,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const p=this._schemes.sort(),u=[];let i,a,t=v.State.LastKnownState,n=v.State.LastKnownState;for(const r of p){let d=i?(0,l.commonPrefixLength)(i,r):0;for(d===0?a=v.State.Start:a=n;d<r.length;d++)d+1===r.length?(t=n,n=v.State.BeforeColon):n+=1,u.push([a,r.toUpperCase().charCodeAt(d),n]),u.push([a,r.toLowerCase().charCodeAt(d),n]),a=n;i=r,n=t}u.push([v.State.BeforeColon,C.CharCode.Colon,v.State.AfterColon]),u.push([v.State.AfterColon,C.CharCode.Slash,v.State.End]),this._stateMachine=new v.StateMachine(u)}}provideDocumentLinks(p){this._initStateMachine();const u=[],i=v.LinkComputer.computeLinks({getLineContent(a){return p.lineAt(a-1).text},getLineCount(){return p.lineCount}},this._stateMachine);for(const a of i){const t=R.DocumentLink.to(a);t.target&&u.push(t)}return u}}class o{constructor(p,u){this._extHostLanguageFeatures=u,this._linkProvider=new S,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=p.getProxy(h.MainContext.MainThreadFileSystem)}dispose(){this._linkProviderRegistration?.dispose()}registerFileSystemProvider(p,u,i,a={}){if(o._validateFileSystemProvider(i),this._registeredSchemes.has(u))throw new Error(`a provider for the scheme '${u}' is already registered`);this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(p,"*",this._linkProvider));const t=this._handlePool++;this._linkProvider.add(u),this._registeredSchemes.add(u),this._fsProvider.set(t,i);let n=D.FileSystemProviderCapabilities.FileReadWrite;a.isCaseSensitive&&(n+=D.FileSystemProviderCapabilities.PathCaseSensitive),a.isReadonly&&(n+=D.FileSystemProviderCapabilities.Readonly),typeof i.copy=="function"&&(n+=D.FileSystemProviderCapabilities.FileFolderCopy),typeof i.open=="function"&&typeof i.close=="function"&&typeof i.read=="function"&&typeof i.write=="function"&&((0,f.checkProposedApiEnabled)(p,"fsChunks"),n+=D.FileSystemProviderCapabilities.FileOpenReadWriteClose);let r;a.isReadonly&&(0,T.isMarkdownString)(a.isReadonly)&&a.isReadonly.value!==""&&(r={value:a.isReadonly.value,isTrusted:a.isReadonly.isTrusted,supportThemeIcons:a.isReadonly.supportThemeIcons,supportHtml:a.isReadonly.supportHtml,baseUri:a.isReadonly.baseUri,uris:a.isReadonly.uris}),this._proxy.$registerFileSystemProvider(t,u,n,r).catch(c=>{console.error(`FAILED to register filesystem provider of ${p.identifier.value}-extension for the scheme ${u}`),console.error(c)});const d=i.onDidChangeFile(c=>{const g=[];for(const w of c){const{uri:y,type:I}=w;if(y.scheme!==u)continue;let P;switch(I){case L.FileChangeType.Changed:P=D.FileChangeType.UPDATED;break;case L.FileChangeType.Created:P=D.FileChangeType.ADDED;break;case L.FileChangeType.Deleted:P=D.FileChangeType.DELETED;break;default:throw new Error("Unknown FileChangeType")}g.push({resource:y,type:P})}this._proxy.$onFileSystemChange(t,g)});return(0,A.toDisposable)(()=>{d.dispose(),this._linkProvider.delete(u),this._registeredSchemes.delete(u),this._fsProvider.delete(t),this._proxy.$unregisterProvider(t)})}static _validateFileSystemProvider(p){if(!p)throw new Error("MISSING provider");if(typeof p.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof p.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof p.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof p.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof p.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof p.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof p.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof p.rename!="function")throw new Error("Provider does NOT implement rename")}static _asIStat(p){const{type:u,ctime:i,mtime:a,size:t,permissions:n}=p;return{type:u,ctime:i,mtime:a,size:t,permissions:n}}$stat(p,u){return Promise.resolve(this._getFsProvider(p).stat(s.URI.revive(u))).then(i=>o._asIStat(i))}$readdir(p,u){return Promise.resolve(this._getFsProvider(p).readDirectory(s.URI.revive(u)))}$readFile(p,u){return Promise.resolve(this._getFsProvider(p).readFile(s.URI.revive(u))).then(i=>_.VSBuffer.wrap(i))}$writeFile(p,u,i,a){return Promise.resolve(this._getFsProvider(p).writeFile(s.URI.revive(u),i.buffer,a))}$delete(p,u,i){return Promise.resolve(this._getFsProvider(p).delete(s.URI.revive(u),i))}$rename(p,u,i,a){return Promise.resolve(this._getFsProvider(p).rename(s.URI.revive(u),s.URI.revive(i),a))}$copy(p,u,i,a){const t=this._getFsProvider(p);if(!t.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(t.copy(s.URI.revive(u),s.URI.revive(i),a))}$mkdir(p,u){return Promise.resolve(this._getFsProvider(p).createDirectory(s.URI.revive(u)))}$watch(p,u,i,a){const t=this._getFsProvider(p).watch(s.URI.revive(i),a);this._watches.set(u,t)}$unwatch(p,u){const i=this._watches.get(u);i&&(i.dispose(),this._watches.delete(u))}$open(p,u,i){const a=this._getFsProvider(p);if(!a.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(a.open(s.URI.revive(u),i))}$close(p,u){const i=this._getFsProvider(p);if(!i.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(i.close(u))}$read(p,u,i,a){const t=this._getFsProvider(p);if(!t.read)throw new Error('FileSystemProvider does not implement "read"');const n=_.VSBuffer.alloc(a);return Promise.resolve(t.read(u,i,n.buffer,0,a)).then(r=>n.slice(0,r))}$write(p,u,i,a){const t=this._getFsProvider(p);if(!t.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(t.write(u,i,a.buffer,0,a.byteLength))}_getFsProvider(p){const u=this._fsProvider.get(p);if(!u){const i=new Error;throw i.name="ENOPRO",i.message="no provider",i}return u}}e.ExtHostFileSystem=o}),define(Pe[305],ke([1,0,4,39,2,6,15,9,27,50]),function(ge,e,s,h,D,A,L,R,v,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0,L=We(L);class C{get ignoreCreateEvents(){return!!(this._config&1)}get ignoreChangeEvents(){return!!(this._config&2)}get ignoreDeleteEvents(){return!!(this._config&4)}constructor(S,o,m,p,u,i){this.session=Math.random(),this._onDidCreate=new s.Emitter,this._onDidChange=new s.Emitter,this._onDidDelete=new s.Emitter,this._config=0,i?.ignoreCreateEvents&&(this._config+=1),i?.ignoreChangeEvents&&(this._config+=2),i?.ignoreDeleteEvents&&(this._config+=4);const a=(0,h.parse)(u),t=typeof u=="string",n=i?.correlate,r=p(d=>{if(!(typeof d.session=="number"&&d.session!==this.session)&&!(n&&typeof d.session>"u")){if(!i?.ignoreCreateEvents)for(const c of d.created){const g=D.URI.revive(c);a(g.fsPath)&&(!t||o.getWorkspaceFolder(g))&&this._onDidCreate.fire(g)}if(!i?.ignoreChangeEvents)for(const c of d.changed){const g=D.URI.revive(c);a(g.fsPath)&&(!t||o.getWorkspaceFolder(g))&&this._onDidChange.fire(g)}if(!i?.ignoreDeleteEvents)for(const c of d.deleted){const g=D.URI.revive(c);a(g.fsPath)&&(!t||o.getWorkspaceFolder(g))&&this._onDidDelete.fire(g)}}});this._disposable=R.Disposable.from(this.ensureWatching(S,m,u,i,i?.correlate),this._onDidCreate,this._onDidChange,this._onDidDelete,r)}ensureWatching(S,o,m,p,u){const i=R.Disposable.from();if(typeof m=="string"||p?.ignoreChangeEvents&&p?.ignoreCreateEvents&&p?.ignoreDeleteEvents)return i;const a=S.getProxy(A.MainContext.MainThreadFileSystemEventService);let t=!1;(m.pattern.includes(h.GLOBSTAR)||m.pattern.includes(h.GLOB_SPLIT))&&(t=!0);let n;return u&&(p?.ignoreChangeEvents||p?.ignoreCreateEvents||p?.ignoreDeleteEvents)&&(n=v.FileChangeFilter.UPDATED|v.FileChangeFilter.ADDED|v.FileChangeFilter.DELETED,p?.ignoreChangeEvents&&(n&=~v.FileChangeFilter.UPDATED),p?.ignoreCreateEvents&&(n&=~v.FileChangeFilter.ADDED),p?.ignoreDeleteEvents&&(n&=~v.FileChangeFilter.DELETED)),a.$watch(o.identifier.value,this.session,m.baseUri,{recursive:t,excludes:p?.excludes??[],filter:n},!!u),R.Disposable.from({dispose:()=>a.$unwatch(this.session)})}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class _{constructor(S){this._events=S,this.session=this._events.session,this._created=new l.Lazy(()=>this._events.created.map(D.URI.revive)),this._changed=new l.Lazy(()=>this._events.changed.map(D.URI.revive)),this._deleted=new l.Lazy(()=>this._events.deleted.map(D.URI.revive))}get created(){return this._created.value}get changed(){return this._changed.value}get deleted(){return this._deleted.value}}class f{constructor(S,o,m){this._mainContext=S,this._logService=o,this._extHostDocumentsAndEditors=m,this._onFileSystemEvent=new s.Emitter,this._onDidRenameFile=new s.Emitter,this._onDidCreateFile=new s.Emitter,this._onDidDeleteFile=new s.Emitter,this._onWillRenameFile=new s.AsyncEmitter,this._onWillCreateFile=new s.AsyncEmitter,this._onWillDeleteFile=new s.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(S,o,m,p){return new C(this._mainContext,S,o,this._onFileSystemEvent.event,L.GlobPattern.from(m),p)}$onFileEvent(S){this._onFileSystemEvent.fire(new _(S))}$onDidRunFileOperation(S,o){switch(S){case v.FileOperation.MOVE:this._onDidRenameFile.fire(Object.freeze({files:o.map(m=>({oldUri:D.URI.revive(m.source),newUri:D.URI.revive(m.target)}))}));break;case v.FileOperation.DELETE:this._onDidDeleteFile.fire(Object.freeze({files:o.map(m=>D.URI.revive(m.target))}));break;case v.FileOperation.CREATE:case v.FileOperation.COPY:this._onDidCreateFile.fire(Object.freeze({files:o.map(m=>D.URI.revive(m.target))}));break;default:}}getOnWillRenameFileEvent(S){return this._createWillExecuteEvent(S,this._onWillRenameFile)}getOnWillCreateFileEvent(S){return this._createWillExecuteEvent(S,this._onWillCreateFile)}getOnWillDeleteFileEvent(S){return this._createWillExecuteEvent(S,this._onWillDeleteFile)}_createWillExecuteEvent(S,o){return(m,p,u)=>{const i=function(t){m.call(p,t)};return i.extension=S,o.event(i,void 0,u)}}async $onWillRunFileOperation(S,o,m,p){switch(S){case v.FileOperation.MOVE:return await this._fireWillEvent(this._onWillRenameFile,{files:o.map(u=>({oldUri:D.URI.revive(u.source),newUri:D.URI.revive(u.target)}))},m,p);case v.FileOperation.DELETE:return await this._fireWillEvent(this._onWillDeleteFile,{files:o.map(u=>D.URI.revive(u.target))},m,p);case v.FileOperation.CREATE:case v.FileOperation.COPY:return await this._fireWillEvent(this._onWillCreateFile,{files:o.map(u=>D.URI.revive(u.target))},m,p)}}async _fireWillEvent(S,o,m,p){const u=new Set,i=[];if(await S.fireAsync(o,p,async(t,n)=>{const r=Date.now(),d=await Promise.resolve(t);d instanceof R.WorkspaceEdit&&(i.push([n.extension,d]),u.add(n.extension.displayName??n.extension.identifier.value)),Date.now()-r>m&&this._logService.warn("SLOW file-participant",n.extension.identifier)}),p.isCancellationRequested||i.length===0)return;const a={edits:[]};for(const[,t]of i){const{edits:n}=L.WorkspaceEdit.from(t,{getTextDocumentVersion:r=>this._extHostDocumentsAndEditors.getDocument(r)?.version,getNotebookDocumentVersion:()=>{}});a.edits=a.edits.concat(n)}return{edit:a,extensionNames:Array.from(u)}}}e.ExtHostFileSystemEventService=f}),define(Pe[306],ke([1,0,18,8,20,12,134,3,24,43,13,17,2,30,196,88,146,7,23,15,9,25,118,6]),function(ge,e,s,h,D,A,L,R,v,l,C,_,f,T,S,o,m,p,u,i,a,t,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=void 0,o=We(o),i=We(i),r=We(r);class d{constructor(V,j){this._documents=V,this._provider=j}async provideDocumentSymbols(V,j){const Y=this._documents.getDocument(V),ee=await this._provider.provideDocumentSymbols(Y,j);if(!(0,s.isFalsyOrEmpty)(ee))return ee[0]instanceof a.DocumentSymbol?ee.map(i.DocumentSymbol.from):d._asDocumentSymbolTree(ee)}static _asDocumentSymbolTree(V){V=V.slice(0).sort((ee,ue)=>{let we=ee.location.range.start.compareTo(ue.location.range.start);return we===0&&(we=ue.location.range.end.compareTo(ee.location.range.end)),we});const j=[],Y=[];for(const ee of V){const ue={name:ee.name||"!!MISSING: name!!",kind:i.SymbolKind.from(ee.kind),tags:ee.tags?.map(i.SymbolTag.from)||[],detail:"",containerName:ee.containerName,range:i.Range.from(ee.location.range),selectionRange:i.Range.from(ee.location.range),children:[]};for(;;){if(Y.length===0){Y.push(ue),j.push(ue);break}const we=Y[Y.length-1];if(T.Range.containsRange(we.range,ue.range)&&!T.Range.equalsRange(we.range,ue.range)){we.children?.push(ue),Y.push(ue);break}Y.pop()}}return j}}class c{constructor(V,j,Y,ee,ue,we){this._documents=V,this._commands=j,this._provider=Y,this._extension=ee,this._extTelemetry=ue,this._logService=we,this._cache=new n.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(V,j){const Y=this._documents.getDocument(V),ee=await this._provider.provideCodeLenses(Y,j);if(!ee||j.isCancellationRequested)return;const ue=this._cache.add(ee),we=new R.DisposableStore;this._disposables.set(ue,we);const Ae={cacheId:ue,lenses:[]};for(let He=0;He<ee.length;He++)Ae.lenses.push({cacheId:[ue,He],range:i.Range.from(ee[He].range),command:this._commands.toInternal(ee[He].command,we)});return Ae}async resolveCodeLens(V,j){const Y=V.cacheId&&this._cache.get(...V.cacheId);if(!Y)return;let ee;if(typeof this._provider.resolveCodeLens!="function"||Y.isResolved?ee=Y:ee=await this._provider.resolveCodeLens(Y,j),ee||(ee=Y),j.isCancellationRequested)return;const ue=V.cacheId&&this._disposables.get(V.cacheId[0]);if(ue){if(!ee.command){const we=new Error("INVALID code lens resolved, lacks command: "+this._extension.identifier.value);this._extTelemetry.onExtensionError(this._extension.identifier,we),this._logService.error(we);return}return V.command=this._commands.toInternal(ee.command,ue),V}}releaseCodeLenses(V){this._disposables.get(V)?.dispose(),this._disposables.delete(V),this._cache.delete(V)}}function g(Ne){return Array.isArray(Ne)?Ne.map(i.DefinitionLink.from):Ne?[i.DefinitionLink.from(Ne)]:[]}class w{constructor(V,j){this._documents=V,this._provider=j}async provideDefinition(V,j,Y){const ee=this._documents.getDocument(V),ue=i.Position.to(j),we=await this._provider.provideDefinition(ee,ue,Y);return g(we)}}class y{constructor(V,j){this._documents=V,this._provider=j}async provideDeclaration(V,j,Y){const ee=this._documents.getDocument(V),ue=i.Position.to(j),we=await this._provider.provideDeclaration(ee,ue,Y);return g(we)}}class I{constructor(V,j){this._documents=V,this._provider=j}async provideImplementation(V,j,Y){const ee=this._documents.getDocument(V),ue=i.Position.to(j),we=await this._provider.provideImplementation(ee,ue,Y);return g(we)}}class P{constructor(V,j){this._documents=V,this._provider=j}async provideTypeDefinition(V,j,Y){const ee=this._documents.getDocument(V),ue=i.Position.to(j),we=await this._provider.provideTypeDefinition(ee,ue,Y);return g(we)}}class k{static{this.HOVER_MAP_MAX_SIZE=10}constructor(V,j){this._documents=V,this._provider=j,this._hoverCounter=0,this._hoverMap=new Map}async provideHover(V,j,Y,ee){const ue=this._documents.getDocument(V),we=i.Position.to(j);let Ae;if(Y&&Y.verbosityRequest){const ot=Y.verbosityRequest.previousHover.id,dt=this._hoverMap.get(ot);if(!dt)throw new Error(`Hover with id ${ot} not found`);const at={verbosityDelta:Y.verbosityRequest.verbosityDelta,previousHover:dt};Ae=await this._provider.provideHover(ue,we,ee,at)}else Ae=await this._provider.provideHover(ue,we,ee);if(!Ae||(0,s.isFalsyOrEmpty)(Ae.contents))return;Ae.range||(Ae.range=ue.getWordRangeAtPosition(we)),Ae.range||(Ae.range=new a.Range(we,we));const He=i.Hover.from(Ae),Ge=this._hoverCounter;if(this._hoverMap.size===k.HOVER_MAP_MAX_SIZE){const ot=Math.min(...this._hoverMap.keys());this._hoverMap.delete(ot)}return this._hoverMap.set(Ge,Ae),this._hoverCounter+=1,{...He,id:Ge}}releaseHover(V){this._hoverMap.delete(V)}}class b{constructor(V,j){this._documents=V,this._provider=j}async provideEvaluatableExpression(V,j,Y){const ee=this._documents.getDocument(V),ue=i.Position.to(j),we=await this._provider.provideEvaluatableExpression(ee,ue,Y);if(we)return i.EvaluatableExpression.from(we)}}class E{constructor(V,j){this._documents=V,this._provider=j}async provideInlineValues(V,j,Y,ee){const ue=this._documents.getDocument(V),we=await this._provider.provideInlineValues(ue,i.Range.to(j),i.InlineValueContext.to(Y),ee);if(Array.isArray(we))return we.map(Ae=>i.InlineValue.from(Ae))}}class N{constructor(V,j){this._documents=V,this._provider=j}async provideDocumentHighlights(V,j,Y){const ee=this._documents.getDocument(V),ue=i.Position.to(j),we=await this._provider.provideDocumentHighlights(ee,ue,Y);if(Array.isArray(we))return we.map(i.DocumentHighlight.from)}}class O{constructor(V,j){this._documents=V,this._provider=j}async provideMultiDocumentHighlights(V,j,Y,ee){const ue=this._documents.getDocument(V),we=Y.map(Ge=>this._documents.getDocument(Ge)),Ae=i.Position.to(j),He=await this._provider.provideMultiDocumentHighlights(ue,Ae,we,ee);if(Array.isArray(He))return He.map(i.MultiDocumentHighlight.from)}}class M{constructor(V,j){this._documents=V,this._provider=j}async provideLinkedEditingRanges(V,j,Y){const ee=this._documents.getDocument(V),ue=i.Position.to(j),we=await this._provider.provideLinkedEditingRanges(ee,ue,Y);if(we&&Array.isArray(we.ranges))return{ranges:(0,s.coalesce)(we.ranges.map(i.Range.from)),wordPattern:we.wordPattern}}}class U{constructor(V,j){this._documents=V,this._provider=j}async provideReferences(V,j,Y,ee){const ue=this._documents.getDocument(V),we=i.Position.to(j),Ae=await this._provider.provideReferences(ue,we,Y,ee);if(Array.isArray(Ae))return Ae.map(i.location.from)}}class H{static{this._maxCodeActionsPerFile=1e3}constructor(V,j,Y,ee,ue,we,Ae){this._documents=V,this._commands=j,this._diagnostics=Y,this._provider=ee,this._logService=ue,this._extension=we,this._apiDeprecation=Ae,this._cache=new n.Cache("CodeAction"),this._disposables=new Map}async provideCodeActions(V,j,Y,ee){const ue=this._documents.getDocument(V),we=S.Selection.isISelection(j)?i.Selection.to(j):i.Range.to(j),Ae=[];for(const at of this._diagnostics.getDiagnostics(V))if(we.intersection(at.range)&&Ae.push(at)>H._maxCodeActionsPerFile)break;const He={diagnostics:Ae,only:Y.only?new a.CodeActionKind(Y.only):void 0,triggerKind:i.CodeActionTriggerKind.to(Y.trigger)},Ge=await this._provider.provideCodeActions(ue,we,He,ee);if(!(0,s.isNonEmptyArray)(Ge)||ee.isCancellationRequested)return;const nt=this._cache.add(Ge),ot=new R.DisposableStore;this._disposables.set(nt,ot);const dt=[];for(let at=0;at<Ge.length;at++){const ct=Ge[at];if(ct)if(H._isCommand(ct))this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),dt.push({_isSynthetic:!0,title:ct.title,command:this._commands.toInternal(ct,ot)});else{He.only&&(ct.kind?He.only.contains(ct.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${He.only.value}' requested but returned code action is of kind '${ct.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${He.only.value}' requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`));const vt=ct.ranges??[];dt.push({cacheId:[nt,at],title:ct.title,command:ct.command&&this._commands.toInternal(ct.command,ot),diagnostics:ct.diagnostics&&ct.diagnostics.map(i.Diagnostic.from),edit:ct.edit&&i.WorkspaceEdit.from(ct.edit,void 0),kind:ct.kind&&ct.kind.value,isPreferred:ct.isPreferred,isAI:(0,t.isProposedApiEnabled)(this._extension,"codeActionAI")?ct.isAI:!1,ranges:(0,t.isProposedApiEnabled)(this._extension,"codeActionRanges")?(0,s.coalesce)(vt.map(i.Range.from)):void 0,disabled:ct.disabled?.reason})}}return{cacheId:nt,actions:dt}}async resolveCodeAction(V,j){const[Y,ee]=V,ue=this._cache.get(Y,ee);if(!ue||H._isCommand(ue))return{};if(!this._provider.resolveCodeAction)return{};const we=await this._provider.resolveCodeAction(ue,j)??ue;let Ae;we.edit&&(Ae=i.WorkspaceEdit.from(we.edit,void 0));let He;if(we.command){const Ge=this._disposables.get(Y);Ge&&(He=this._commands.toInternal(we.command,Ge))}return{edit:Ae,command:He}}releaseCodeActions(V){this._disposables.get(V)?.dispose(),this._disposables.delete(V),this._cache.delete(V)}static _isCommand(V){return typeof V.command=="string"&&typeof V.title=="string"}}class F{constructor(V,j,Y,ee,ue){this._proxy=V,this._documents=j,this._provider=Y,this._handle=ee,this._extension=ue,this._cache=new n.Cache("DocumentPasteEdit")}async prepareDocumentPaste(V,j,Y,ee){if(!this._provider.prepareDocumentPaste)return;const ue=this._documents.getDocument(V),we=j.map(Ge=>i.Range.to(Ge)),Ae=i.DataTransfer.toDataTransfer(Y,()=>{throw new A.NotImplementedError});if(await this._provider.prepareDocumentPaste(ue,we,Ae,ee),ee.isCancellationRequested)return;const He=Array.from(Ae).filter(([,Ge])=>!(Ge instanceof a.InternalDataTransferItem));return i.DataTransfer.from(He)}async providePasteEdits(V,j,Y,ee,ue,we){if(!this._provider.provideDocumentPasteEdits)return[];const Ae=this._documents.getDocument(j),He=Y.map(dt=>i.Range.to(dt)),Ge=i.DataTransfer.toDataTransfer(ee,async dt=>(await this._proxy.$resolvePasteFileData(this._handle,V,dt)).buffer),nt=await this._provider.provideDocumentPasteEdits(Ae,He,Ge,{only:ue.only?new a.DocumentDropOrPasteEditKind(ue.only):void 0,triggerKind:ue.triggerKind},we);if(!nt||we.isCancellationRequested)return[];const ot=this._cache.add(nt);return nt.map((dt,at)=>({_cacheId:[ot,at],title:dt.title??(0,p.localize)(2703,null,this._extension.displayName||this._extension.name),kind:dt.kind,yieldTo:dt.yieldTo?.map(ct=>ct.value),insertText:typeof dt.insertText=="string"?dt.insertText:{snippet:dt.insertText.value},additionalEdit:dt.additionalEdit?i.WorkspaceEdit.from(dt.additionalEdit,void 0):void 0}))}async resolvePasteEdit(V,j){const[Y,ee]=V,ue=this._cache.get(Y,ee);if(!ue||!this._provider.resolveDocumentPasteEdit)return{};const we=await this._provider.resolveDocumentPasteEdit(ue,j)??ue;return{additionalEdit:we.additionalEdit?i.WorkspaceEdit.from(we.additionalEdit,void 0):void 0}}releasePasteEdits(V){this._cache.delete(V)}}class x{constructor(V,j){this._documents=V,this._provider=j}async provideDocumentFormattingEdits(V,j,Y){const ee=this._documents.getDocument(V),ue=await this._provider.provideDocumentFormattingEdits(ee,j,Y);if(Array.isArray(ue))return ue.map(i.TextEdit.from)}}class ${constructor(V,j){this._documents=V,this._provider=j}async provideDocumentRangeFormattingEdits(V,j,Y,ee){const ue=this._documents.getDocument(V),we=i.Range.to(j),Ae=await this._provider.provideDocumentRangeFormattingEdits(ue,we,Y,ee);if(Array.isArray(Ae))return Ae.map(i.TextEdit.from)}async provideDocumentRangesFormattingEdits(V,j,Y,ee){(0,_.assertType)(typeof this._provider.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const ue=this._documents.getDocument(V),we=j.map(i.Range.to),Ae=await this._provider.provideDocumentRangesFormattingEdits(ue,we,Y,ee);if(Array.isArray(Ae))return Ae.map(i.TextEdit.from)}}class G{constructor(V,j){this._documents=V,this._provider=j,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(V,j,Y,ee,ue){const we=this._documents.getDocument(V),Ae=i.Position.to(j),He=await this._provider.provideOnTypeFormattingEdits(we,Ae,Y,ee,ue);if(Array.isArray(He))return He.map(i.TextEdit.from)}}class B{constructor(V,j){this._provider=V,this._logService=j,this._cache=new n.Cache("WorkspaceSymbols")}async provideWorkspaceSymbols(V,j){const Y=await this._provider.provideWorkspaceSymbols(V,j);if(!(0,s.isNonEmptyArray)(Y))return{symbols:[]};const ee=this._cache.add(Y),ue={cacheId:ee,symbols:[]};for(let we=0;we<Y.length;we++){const Ae=Y[we];if(!Ae||!Ae.name){this._logService.warn("INVALID SymbolInformation",Ae);continue}ue.symbols.push({...i.WorkspaceSymbol.from(Ae),cacheId:[ee,we]})}return ue}async resolveWorkspaceSymbol(V,j){if(typeof this._provider.resolveWorkspaceSymbol!="function"||!V.cacheId)return V;const Y=this._cache.get(...V.cacheId);if(Y){const ee=await this._provider.resolveWorkspaceSymbol(Y,j);return ee&&(0,v.mixin)(V,i.WorkspaceSymbol.from(ee),!0)}}releaseWorkspaceSymbols(V){this._cache.delete(V)}}class W{static supportsResolving(V){return typeof V.prepareRename=="function"}constructor(V,j,Y){this._documents=V,this._provider=j,this._logService=Y}async provideRenameEdits(V,j,Y,ee){const ue=this._documents.getDocument(V),we=i.Position.to(j);try{const Ae=await this._provider.provideRenameEdits(ue,we,Y,ee);return Ae?i.WorkspaceEdit.from(Ae):void 0}catch(Ae){const He=W._asMessage(Ae);return He?{rejectReason:He,edits:void 0}:Promise.reject(Ae)}}async resolveRenameLocation(V,j,Y){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const ee=this._documents.getDocument(V),ue=i.Position.to(j);try{const we=await this._provider.prepareRename(ee,ue,Y);let Ae,He;if(a.Range.isRange(we)?(Ae=we,He=ee.getText(we)):(0,_.isObject)(we)&&(Ae=we.range,He=we.placeholder),!Ae||!He)return;if(Ae.start.line>ue.line||Ae.end.line<ue.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:i.Range.from(Ae),text:He}}catch(we){const Ae=W._asMessage(we);return Ae?{rejectReason:Ae,range:void 0,text:void 0}:Promise.reject(we)}}static _asMessage(V){return typeof V=="string"?V:V instanceof Error&&typeof V.message=="string"?V.message:void 0}}class Z{static{this.languageTriggerKindToVSCodeTriggerKind={[o.NewSymbolNameTriggerKind.Invoke]:a.NewSymbolNameTriggerKind.Invoke,[o.NewSymbolNameTriggerKind.Automatic]:a.NewSymbolNameTriggerKind.Automatic}}constructor(V,j,Y){this._documents=V,this._provider=j,this._logService=Y}async supportsAutomaticNewSymbolNamesTriggerKind(){return this._provider.supportsAutomaticTriggerKind}async provideNewSymbolNames(V,j,Y,ee){const ue=this._documents.getDocument(V),we=i.Range.to(j);try{const Ae=Z.languageTriggerKindToVSCodeTriggerKind[Y],He=await this._provider.provideNewSymbolNames(ue,we,Ae,ee);return He?He.map(Ge=>typeof Ge=="string"?{newSymbolName:Ge}:{newSymbolName:Ge.newSymbolName,tags:Ge.tags}):void 0}catch(Ae){this._logService.error(Z._asMessage(Ae)??JSON.stringify(Ae,null,"	"));return}}static _asMessage(V){return typeof V=="string"?V:V instanceof Error&&typeof V.message=="string"?V.message:void 0}}class J{constructor(V,j){this.resultId=V,this.tokens=j}}class oe{constructor(V,j){this._documents=V,this._provider=j,this._nextResultId=1,this._previousResults=new Map}async provideDocumentSemanticTokens(V,j,Y){const ee=this._documents.getDocument(V),ue=j!==0?this._previousResults.get(j):null;let we=typeof ue?.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?await this._provider.provideDocumentSemanticTokensEdits(ee,ue.resultId,Y):await this._provider.provideDocumentSemanticTokens(ee,Y);return ue&&this._previousResults.delete(j),we?(we=oe._fixProvidedSemanticTokens(we),this._send(oe._convertToEdits(ue,we),we)):null}async releaseDocumentSemanticColoring(V){this._previousResults.delete(V)}static _fixProvidedSemanticTokens(V){return oe._isSemanticTokens(V)?oe._isCorrectSemanticTokens(V)?V:new a.SemanticTokens(new Uint32Array(V.data),V.resultId):oe._isSemanticTokensEdits(V)?oe._isCorrectSemanticTokensEdits(V)?V:new a.SemanticTokensEdits(V.edits.map(j=>new a.SemanticTokensEdit(j.start,j.deleteCount,j.data?new Uint32Array(j.data):j.data)),V.resultId):V}static _isSemanticTokens(V){return V&&!!V.data}static _isCorrectSemanticTokens(V){return V.data instanceof Uint32Array}static _isSemanticTokensEdits(V){return V&&Array.isArray(V.edits)}static _isCorrectSemanticTokensEdits(V){for(const j of V.edits)if(!(j.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(V,j){if(!oe._isSemanticTokens(j)||!V||!V.tokens)return j;const Y=V.tokens,ee=Y.length,ue=j.data,we=ue.length;let Ae=0;const He=Math.min(ee,we);for(;Ae<He&&Y[Ae]===ue[Ae];)Ae++;if(Ae===ee&&Ae===we)return new a.SemanticTokensEdits([],j.resultId);let Ge=0;const nt=He-Ae;for(;Ge<nt&&Y[ee-Ge-1]===ue[we-Ge-1];)Ge++;return new a.SemanticTokensEdits([{start:Ae,deleteCount:ee-Ae-Ge,data:ue.subarray(Ae,we-Ge)}],j.resultId)}_send(V,j){if(oe._isSemanticTokens(V)){const Y=this._nextResultId++;return this._previousResults.set(Y,new J(V.resultId,V.data)),(0,m.encodeSemanticTokensDto)({id:Y,type:"full",data:V.data})}if(oe._isSemanticTokensEdits(V)){const Y=this._nextResultId++;return oe._isSemanticTokens(j)?this._previousResults.set(Y,new J(j.resultId,j.data)):this._previousResults.set(Y,new J(V.resultId)),(0,m.encodeSemanticTokensDto)({id:Y,type:"delta",deltas:(V.edits||[]).map(ee=>({start:ee.start,deleteCount:ee.deleteCount,data:ee.data}))})}return null}}class te{constructor(V,j){this._documents=V,this._provider=j}async provideDocumentRangeSemanticTokens(V,j,Y){const ee=this._documents.getDocument(V),ue=await this._provider.provideDocumentRangeSemanticTokens(ee,i.Range.to(j),Y);return ue?this._send(ue):null}_send(V){return(0,m.encodeSemanticTokensDto)({id:0,type:"full",data:V.data})}}class me{static supportsResolving(V){return typeof V.resolveCompletionItem=="function"}constructor(V,j,Y,ee,ue){this._documents=V,this._commands=j,this._provider=Y,this._apiDeprecation=ee,this._extension=ue,this._cache=new n.Cache("CompletionItem"),this._disposables=new Map}async provideCompletionItems(V,j,Y,ee){const ue=this._documents.getDocument(V),we=i.Position.to(j),Ae=ue.getWordRangeAtPosition(we)||new a.Range(we,we),He=Ae.with({end:we}),Ge=new l.StopWatch,nt=await this._provider.provideCompletionItems(ue,we,ee,i.CompletionContext.to(Y));if(!nt||ee.isCancellationRequested)return;const ot=Array.isArray(nt)?new a.CompletionList(nt):nt,dt=me.supportsResolving(this._provider)?this._cache.add(ot.items):this._cache.add([]),at=new R.DisposableStore;this._disposables.set(dt,at);const ct=[],vt={x:dt,[r.ISuggestResultDtoField.completions]:ct,[r.ISuggestResultDtoField.defaultRanges]:{replace:i.Range.from(Ae),insert:i.Range.from(He)},[r.ISuggestResultDtoField.isIncomplete]:ot.isIncomplete||void 0,[r.ISuggestResultDtoField.duration]:Ge.elapsed()};for(let it=0;it<ot.items.length;it++){const Ce=ot.items[it],re=this._convertCompletionItem(Ce,[dt,it],He,Ae);ct.push(re)}return vt}async resolveCompletionItem(V,j){if(typeof this._provider.resolveCompletionItem!="function")return;const Y=this._cache.get(...V);if(!Y)return;const ee=this._convertCompletionItem(Y,V),ue=await this._provider.resolveCompletionItem(Y,j);if(!ue)return;const we=this._convertCompletionItem(ue,V);return(ee[r.ISuggestDataDtoField.insertText]!==we[r.ISuggestDataDtoField.insertText]||ee[r.ISuggestDataDtoField.insertTextRules]!==we[r.ISuggestDataDtoField.insertTextRules])&&this._apiDeprecation.report("CompletionItem.insertText",this._extension,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(ee[r.ISuggestDataDtoField.commandIdent]!==we[r.ISuggestDataDtoField.commandIdent]||ee[r.ISuggestDataDtoField.commandId]!==we[r.ISuggestDataDtoField.commandId]||!(0,v.equals)(ee[r.ISuggestDataDtoField.commandArguments],we[r.ISuggestDataDtoField.commandArguments]))&&this._apiDeprecation.report("CompletionItem.command",this._extension,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...ee,[r.ISuggestDataDtoField.documentation]:we[r.ISuggestDataDtoField.documentation],[r.ISuggestDataDtoField.detail]:we[r.ISuggestDataDtoField.detail],[r.ISuggestDataDtoField.additionalTextEdits]:we[r.ISuggestDataDtoField.additionalTextEdits],[r.ISuggestDataDtoField.insertText]:we[r.ISuggestDataDtoField.insertText],[r.ISuggestDataDtoField.insertTextRules]:we[r.ISuggestDataDtoField.insertTextRules],[r.ISuggestDataDtoField.commandIdent]:we[r.ISuggestDataDtoField.commandIdent],[r.ISuggestDataDtoField.commandId]:we[r.ISuggestDataDtoField.commandId],[r.ISuggestDataDtoField.commandArguments]:we[r.ISuggestDataDtoField.commandArguments]}}releaseCompletionItems(V){this._disposables.get(V)?.dispose(),this._disposables.delete(V),this._cache.delete(V)}_convertCompletionItem(V,j,Y,ee){const ue=this._disposables.get(j[0]);if(!ue)throw Error("DisposableStore is missing...");const we=this._commands.toInternal(V.command,ue),Ae={x:j,[r.ISuggestDataDtoField.label]:V.label,[r.ISuggestDataDtoField.kind]:V.kind!==void 0?i.CompletionItemKind.from(V.kind):void 0,[r.ISuggestDataDtoField.kindModifier]:V.tags&&V.tags.map(i.CompletionItemTag.from),[r.ISuggestDataDtoField.detail]:V.detail,[r.ISuggestDataDtoField.documentation]:typeof V.documentation>"u"?void 0:i.MarkdownString.fromStrict(V.documentation),[r.ISuggestDataDtoField.sortText]:V.sortText!==V.label?V.sortText:void 0,[r.ISuggestDataDtoField.filterText]:V.filterText!==V.label?V.filterText:void 0,[r.ISuggestDataDtoField.preselect]:V.preselect||void 0,[r.ISuggestDataDtoField.insertTextRules]:V.keepWhitespace?o.CompletionItemInsertTextRule.KeepWhitespace:o.CompletionItemInsertTextRule.None,[r.ISuggestDataDtoField.commitCharacters]:V.commitCharacters?.join(""),[r.ISuggestDataDtoField.additionalTextEdits]:V.additionalTextEdits&&V.additionalTextEdits.map(i.TextEdit.from),[r.ISuggestDataDtoField.commandIdent]:we?.$ident,[r.ISuggestDataDtoField.commandId]:we?.id,[r.ISuggestDataDtoField.commandArguments]:we?.$ident?void 0:we?.arguments};V.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Ae[r.ISuggestDataDtoField.insertText]=V.textEdit.newText):typeof V.insertText=="string"?Ae[r.ISuggestDataDtoField.insertText]=V.insertText:V.insertText instanceof a.SnippetString&&(Ae[r.ISuggestDataDtoField.insertText]=V.insertText.value,Ae[r.ISuggestDataDtoField.insertTextRules]|=o.CompletionItemInsertTextRule.InsertAsSnippet);let He;return V.textEdit?He=V.textEdit.range:V.range&&(He=V.range),a.Range.isRange(He)?Ae[r.ISuggestDataDtoField.range]=i.Range.from(He):He&&(!Y?.isEqual(He.inserting)||!ee?.isEqual(He.replacing))&&(Ae[r.ISuggestDataDtoField.range]={insert:i.Range.from(He.inserting),replace:i.Range.from(He.replacing)}),Ae}}class le{async provideInlineCompletions(V,j,Y,ee){}async provideInlineEdits(V,j,Y,ee){}disposeCompletions(V){}handleDidShowCompletionItem(V,j,Y){}handlePartialAccept(V,j,Y,ee){}}class Q extends le{constructor(V,j,Y,ee){super(),this._extension=V,this._documents=j,this._provider=Y,this._commands=ee,this._references=new se,this._isAdditionsProposedApiEnabled=(0,t.isProposedApiEnabled)(this._extension,"inlineCompletionsAdditions"),this.languageTriggerKindToVSCodeTriggerKind={[o.InlineCompletionTriggerKind.Automatic]:a.InlineCompletionTriggerKind.Automatic,[o.InlineCompletionTriggerKind.Explicit]:a.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,t.isProposedApiEnabled)(this._extension,"inlineCompletionsAdditions")&&(typeof this._provider.handleDidShowCompletionItem=="function"||typeof this._provider.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(V,j,Y,ee){const ue=this._documents.getDocument(V),we=i.Position.to(j),Ae=await this._provider.provideInlineCompletionItems(ue,we,{selectedCompletionInfo:Y.selectedSuggestionInfo?{range:i.Range.to(Y.selectedSuggestionInfo.range),text:Y.selectedSuggestionInfo.text}:void 0,triggerKind:this.languageTriggerKindToVSCodeTriggerKind[Y.triggerKind]},ee);if(!Ae||ee.isCancellationRequested)return;const He=Array.isArray(Ae)?Ae:Ae.items,Ge=this._isAdditionsProposedApiEnabled?Array.isArray(Ae)?[]:Ae.commands||[]:[],nt=this._isAdditionsProposedApiEnabled&&!Array.isArray(Ae)?Ae.enableForwardStability:void 0;let ot;return{pid:this._references.createReferenceId({dispose(){ot?.dispose()},items:He}),items:He.map((at,ct)=>{let vt;at.command&&(ot||(ot=new R.DisposableStore),vt=this._commands.toInternal(at.command,ot));const it=at.insertText;return{insertText:typeof it=="string"?it:{snippet:it.value},filterText:at.filterText,range:at.range?i.Range.from(at.range):void 0,command:vt,idx:ct,completeBracketPairs:this._isAdditionsProposedApiEnabled?at.completeBracketPairs:!1}}),commands:Ge.map(at=>(ot||(ot=new R.DisposableStore),this._commands.toInternal(at,ot))),suppressSuggestions:!1,enableForwardStability:nt}}async provideInlineEdits(V,j,Y,ee){if(!this._provider.provideInlineEdits)return;(0,t.checkProposedApiEnabled)(this._extension,"inlineCompletionsAdditions");const ue=this._documents.getDocument(V),we=i.Range.to(j),Ae=await this._provider.provideInlineEdits(ue,we,{selectedCompletionInfo:Y.selectedSuggestionInfo?{range:i.Range.to(Y.selectedSuggestionInfo.range),text:Y.selectedSuggestionInfo.text}:void 0,triggerKind:this.languageTriggerKindToVSCodeTriggerKind[Y.triggerKind],userPrompt:Y.userPrompt},ee);if(!Ae||ee.isCancellationRequested)return;const He=Array.isArray(Ae)?Ae:Ae.items,Ge=this._isAdditionsProposedApiEnabled?Array.isArray(Ae)?[]:Ae.commands||[]:[],nt=this._isAdditionsProposedApiEnabled&&!Array.isArray(Ae)?Ae.enableForwardStability:void 0;let ot;return{pid:this._references.createReferenceId({dispose(){ot?.dispose()},items:He}),items:He.map((at,ct)=>{let vt;at.command&&(ot||(ot=new R.DisposableStore),vt=this._commands.toInternal(at.command,ot));const it=at.insertText;return{insertText:typeof it=="string"?it:{snippet:it.value},filterText:at.filterText,range:at.range?i.Range.from(at.range):void 0,command:vt,idx:ct,completeBracketPairs:this._isAdditionsProposedApiEnabled?at.completeBracketPairs:!1}}),commands:Ge.map(at=>(ot||(ot=new R.DisposableStore),this._commands.toInternal(at,ot))),suppressSuggestions:!1,enableForwardStability:nt}}disposeCompletions(V){this._references.disposeReferenceId(V)?.dispose()}handleDidShowCompletionItem(V,j,Y){const ee=this._references.get(V)?.items[j];ee&&this._provider.handleDidShowCompletionItem&&this._isAdditionsProposedApiEnabled&&this._provider.handleDidShowCompletionItem(ee,Y)}handlePartialAccept(V,j,Y,ee){const ue=this._references.get(V)?.items[j];ue&&this._provider.handleDidPartiallyAcceptCompletionItem&&this._isAdditionsProposedApiEnabled&&(this._provider.handleDidPartiallyAcceptCompletionItem(ue,Y),this._provider.handleDidPartiallyAcceptCompletionItem(ue,i.PartialAcceptInfo.to(ee)))}}class z{async provideInlineEdits(V,j,Y){const ee=this._documents.getDocument(V),ue=await this._provider.provideInlineEdit(ee,{triggerKind:this.languageTriggerKindToVSCodeTriggerKind[j.triggerKind]},Y);if(!ue||Y.isCancellationRequested)return;let we;const Ae=this._references.createReferenceId({dispose(){we?.dispose()},item:ue});let He;ue.accepted&&(we||(we=new R.DisposableStore),He=this._commands.toInternal(ue.accepted,we));let Ge;return ue.rejected&&(we||(we=new R.DisposableStore),Ge=this._commands.toInternal(ue.rejected,we)),{pid:Ae,text:ue.text,range:i.Range.from(ue.range),accepted:He,rejected:Ge}}disposeEdit(V){this._references.disposeReferenceId(V)?.dispose()}constructor(V,j,Y,ee){this._documents=j,this._provider=Y,this._commands=ee,this._references=new se,this.languageTriggerKindToVSCodeTriggerKind={[o.InlineEditTriggerKind.Automatic]:a.InlineEditTriggerKind.Automatic,[o.InlineEditTriggerKind.Invoke]:a.InlineEditTriggerKind.Invoke}}}class se{constructor(){this._references=new Map,this._idPool=1}createReferenceId(V){const j=this._idPool++;return this._references.set(j,V),j}disposeReferenceId(V){const j=this._references.get(V);return this._references.delete(V),j}get(V){return this._references.get(V)}}class Ee{constructor(V,j){this._documents=V,this._provider=j,this._cache=new n.Cache("SignatureHelp")}async provideSignatureHelp(V,j,Y,ee){const ue=this._documents.getDocument(V),we=i.Position.to(j),Ae=this.reviveContext(Y),He=await this._provider.provideSignatureHelp(ue,we,ee,Ae);if(He){const Ge=this._cache.add([He]);return{...i.SignatureHelp.from(He),id:Ge}}}reviveContext(V){let j;if(V.activeSignatureHelp){const Y=i.SignatureHelp.to(V.activeSignatureHelp),ee=this._cache.get(V.activeSignatureHelp.id,0);ee?(j=ee,j.activeSignature=Y.activeSignature,j.activeParameter=Y.activeParameter):j=Y}return{...V,activeSignatureHelp:j}}releaseSignatureHelp(V){this._cache.delete(V)}}class ae{constructor(V,j,Y,ee,ue){this._documents=V,this._commands=j,this._provider=Y,this._logService=ee,this._extension=ue,this._cache=new n.Cache("InlayHints"),this._disposables=new Map}async provideInlayHints(V,j,Y){const ee=this._documents.getDocument(V),ue=i.Range.to(j),we=await this._provider.provideInlayHints(ee,ue,Y);if(!Array.isArray(we)||we.length===0){this._logService.trace(`[InlayHints] NO inlay hints from '${this._extension.identifier.value}' for range ${JSON.stringify(j)}`);return}if(Y.isCancellationRequested)return;const Ae=this._cache.add(we);this._disposables.set(Ae,new R.DisposableStore);const He={hints:[],cacheId:Ae};for(let Ge=0;Ge<we.length;Ge++)this._isValidInlayHint(we[Ge],ue)&&He.hints.push(this._convertInlayHint(we[Ge],[Ae,Ge]));return this._logService.trace(`[InlayHints] ${He.hints.length} inlay hints from '${this._extension.identifier.value}' for range ${JSON.stringify(j)}`),He}async resolveInlayHint(V,j){if(typeof this._provider.resolveInlayHint!="function")return;const Y=this._cache.get(...V);if(!Y)return;const ee=await this._provider.resolveInlayHint(Y,j);if(ee&&this._isValidInlayHint(ee))return this._convertInlayHint(ee,V)}releaseHints(V){this._disposables.get(V)?.dispose(),this._disposables.delete(V),this._cache.delete(V)}_isValidInlayHint(V,j){return V.label.length===0||Array.isArray(V.label)&&V.label.every(Y=>Y.value.length===0)?(console.log("INVALID inlay hint, empty label",V),!1):!(j&&!j.contains(V.position))}_convertInlayHint(V,j){const Y=this._disposables.get(j[0]);if(!Y)throw Error("DisposableStore is missing...");const ee={label:"",cacheId:j,tooltip:i.MarkdownString.fromStrict(V.tooltip),position:i.Position.from(V.position),textEdits:V.textEdits&&V.textEdits.map(i.TextEdit.from),kind:V.kind&&i.InlayHintKind.from(V.kind),paddingLeft:V.paddingLeft,paddingRight:V.paddingRight};if(typeof V.label=="string")ee.label=V.label;else{const ue=[];ee.label=ue;for(const we of V.label){if(!we.value){console.warn("INVALID inlay hint, empty label part",this._extension.identifier.value);continue}const Ae={label:we.value,tooltip:i.MarkdownString.fromStrict(we.tooltip)};a.Location.isLocation(we.location)&&(Ae.location=i.location.from(we.location)),we.command&&(Ae.command=this._commands.toInternal(we.command,Y)),ue.push(Ae)}}return ee}}class be{constructor(V,j){this._documents=V,this._provider=j,this._cache=new n.Cache("DocumentLink")}async provideLinks(V,j){const Y=this._documents.getDocument(V),ee=await this._provider.provideDocumentLinks(Y,j);if(!(!Array.isArray(ee)||ee.length===0)&&!j.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:ee.filter(be._validateLink).map(i.DocumentLink.from)};{const ue=this._cache.add(ee),we={links:[],cacheId:ue};for(let Ae=0;Ae<ee.length;Ae++){if(!be._validateLink(ee[Ae]))continue;const He=i.DocumentLink.from(ee[Ae]);He.cacheId=[ue,Ae],we.links.push(He)}return we}}}static _validateLink(V){return V.target&&V.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(V,j){if(typeof this._provider.resolveDocumentLink!="function")return;const Y=this._cache.get(...V);if(!Y)return;const ee=await this._provider.resolveDocumentLink(Y,j);if(!(!ee||!be._validateLink(ee)))return i.DocumentLink.from(ee)}releaseLinks(V){this._cache.delete(V)}}class pe{constructor(V,j){this._documents=V,this._provider=j}async provideColors(V,j){const Y=this._documents.getDocument(V),ee=await this._provider.provideDocumentColors(Y,j);return Array.isArray(ee)?ee.map(we=>({color:i.Color.from(we.color),range:i.Range.from(we.range)})):[]}async provideColorPresentations(V,j,Y){const ee=this._documents.getDocument(V),ue=i.Range.to(j.range),we=i.Color.to(j.color),Ae=await this._provider.provideColorPresentations(we,{document:ee,range:ue},Y);if(Array.isArray(Ae))return Ae.map(i.ColorPresentation.from)}}class ve{constructor(V,j){this._documents=V,this._provider=j}async provideFoldingRanges(V,j,Y){const ee=this._documents.getDocument(V),ue=await this._provider.provideFoldingRanges(ee,j,Y);if(Array.isArray(ue))return ue.map(i.FoldingRange.from)}}class Re{constructor(V,j,Y){this._documents=V,this._provider=j,this._logService=Y}async provideSelectionRanges(V,j,Y){const ee=this._documents.getDocument(V),ue=j.map(i.Position.to),we=await this._provider.provideSelectionRanges(ee,ue,Y);if(!(0,s.isNonEmptyArray)(we))return[];if(we.length!==ue.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const Ae=[];for(let He=0;He<ue.length;He++){const Ge=[];Ae.push(Ge);let nt=ue[He],ot=we[He];for(;;){if(!ot.range.contains(nt))throw new Error("INVALID selection range, must contain the previous range");if(Ge.push(i.SelectionRange.from(ot)),!ot.parent)break;nt=ot.range,ot=ot.parent}}return Ae}}class Fe{constructor(V,j){this._documents=V,this._provider=j,this._idPool=new L.IdGenerator(""),this._cache=new Map}async prepareSession(V,j,Y){const ee=this._documents.getDocument(V),ue=i.Position.to(j),we=await this._provider.prepareCallHierarchy(ee,ue,Y);if(!we)return;const Ae=this._idPool.nextId();return this._cache.set(Ae,new Map),Array.isArray(we)?we.map(He=>this._cacheAndConvertItem(Ae,He)):[this._cacheAndConvertItem(Ae,we)]}async provideCallsTo(V,j,Y){const ee=this._itemFromCache(V,j);if(!ee)throw new Error("missing call hierarchy item");const ue=await this._provider.provideCallHierarchyIncomingCalls(ee,Y);if(ue)return ue.map(we=>({from:this._cacheAndConvertItem(V,we.from),fromRanges:we.fromRanges.map(Ae=>i.Range.from(Ae))}))}async provideCallsFrom(V,j,Y){const ee=this._itemFromCache(V,j);if(!ee)throw new Error("missing call hierarchy item");const ue=await this._provider.provideCallHierarchyOutgoingCalls(ee,Y);if(ue)return ue.map(we=>({to:this._cacheAndConvertItem(V,we.to),fromRanges:we.fromRanges.map(Ae=>i.Range.from(Ae))}))}releaseSession(V){this._cache.delete(V)}_cacheAndConvertItem(V,j){const Y=this._cache.get(V),ee=i.CallHierarchyItem.from(j,V,Y.size.toString(36));return Y.set(ee._itemId,j),ee}_itemFromCache(V,j){return this._cache.get(V)?.get(j)}}class Ve{constructor(V,j){this._documents=V,this._provider=j,this._idPool=new L.IdGenerator(""),this._cache=new Map}async prepareSession(V,j,Y){const ee=this._documents.getDocument(V),ue=i.Position.to(j),we=await this._provider.prepareTypeHierarchy(ee,ue,Y);if(!we)return;const Ae=this._idPool.nextId();return this._cache.set(Ae,new Map),Array.isArray(we)?we.map(He=>this._cacheAndConvertItem(Ae,He)):[this._cacheAndConvertItem(Ae,we)]}async provideSupertypes(V,j,Y){const ee=this._itemFromCache(V,j);if(!ee)throw new Error("missing type hierarchy item");const ue=await this._provider.provideTypeHierarchySupertypes(ee,Y);if(ue)return ue.map(we=>this._cacheAndConvertItem(V,we))}async provideSubtypes(V,j,Y){const ee=this._itemFromCache(V,j);if(!ee)throw new Error("missing type hierarchy item");const ue=await this._provider.provideTypeHierarchySubtypes(ee,Y);if(ue)return ue.map(we=>this._cacheAndConvertItem(V,we))}releaseSession(V){this._cache.delete(V)}_cacheAndConvertItem(V,j){const Y=this._cache.get(V),ee=i.TypeHierarchyItem.from(j,V,Y.size.toString(36));return Y.set(ee._itemId,j),ee}_itemFromCache(V,j){return this._cache.get(V)?.get(j)}}class Ye{constructor(V,j,Y,ee,ue){this._proxy=V,this._documents=j,this._provider=Y,this._handle=ee,this._extension=ue,this._cache=new n.Cache("DocumentDropEdit")}async provideDocumentOnDropEdits(V,j,Y,ee,ue){const we=this._documents.getDocument(j),Ae=i.Position.to(Y),He=i.DataTransfer.toDataTransfer(ee,async dt=>(await this._proxy.$resolveDocumentOnDropFileData(this._handle,V,dt)).buffer),Ge=await this._provider.provideDocumentDropEdits(we,Ae,He,ue);if(!Ge)return;const nt=(0,s.asArray)(Ge),ot=this._cache.add(nt);return nt.map((dt,at)=>({_cacheId:[ot,at],title:dt.title??(0,p.localize)(2704,null,this._extension.displayName||this._extension.name),kind:dt.kind?.value,yieldTo:dt.yieldTo?.map(ct=>ct.value),insertText:typeof dt.insertText=="string"?dt.insertText:{snippet:dt.insertText.value},additionalEdit:dt.additionalEdit?i.WorkspaceEdit.from(dt.additionalEdit,void 0):void 0}))}async resolveDropEdit(V,j){const[Y,ee]=V,ue=this._cache.get(Y,ee);if(!ue||!this._provider.resolveDocumentDropEdit)return{};const we=await this._provider.resolveDocumentDropEdit(ue,j)??ue;return{additionalEdit:we.additionalEdit?i.WorkspaceEdit.from(we.additionalEdit,void 0):void 0}}releaseDropEdits(V){this._cache.delete(V)}}class Je{constructor(V,j){this._documents=V,this._provider=j}async provideMappedEdits(V,j,Y,ee){const ue=f.URI.revive(V),we=this._documents.getDocument(ue),Ae=Y.documents.map(nt=>nt.map(ot=>({uri:f.URI.revive(ot.uri),version:ot.version,ranges:ot.ranges.map(dt=>i.Range.to(dt))}))),He={documents:Ae,selections:Ae[0]?.[0]?.ranges??[]},Ge=await this._provider.provideMappedEdits(we,j,He,ee);return Ge?i.WorkspaceEdit.from(Ge):null}}class xe{constructor(V,j){this.adapter=V,this.extension=j}}class ze{static{this._handlePool=0}constructor(V,j,Y,ee,ue,we,Ae,He){this._uriTransformer=j,this._documents=Y,this._commands=ee,this._diagnostics=ue,this._logService=we,this._apiDeprecation=Ae,this._extensionTelemetry=He,this._adapter=new Map,this._proxy=V.getProxy(r.MainContext.MainThreadLanguageFeatures)}_transformDocumentSelector(V,j){return i.DocumentSelector.from(V,this._uriTransformer,j)}_createDisposable(V){return new a.Disposable(()=>{this._adapter.delete(V),this._proxy.$unregister(V)})}_nextHandle(){return ze._handlePool++}async _withAdapter(V,j,Y,ee,ue,we=!1){const Ae=this._adapter.get(V);if(!Ae||!(Ae.adapter instanceof j))return ee;const He=Date.now();we||this._logService.trace(`[${Ae.extension.identifier.value}] INVOKE provider '${Y.toString().replace(/[\r\n]/g,"")}'`);const Ge=Y(Ae.adapter,Ae.extension);return Promise.resolve(Ge).catch(nt=>{(0,A.isCancellationError)(nt)||(this._logService.error(`[${Ae.extension.identifier.value}] provider FAILED`),this._logService.error(nt),this._extensionTelemetry.onExtensionError(Ae.extension.identifier,nt))}).finally(()=>{we||this._logService.trace(`[${Ae.extension.identifier.value}] provider DONE after ${Date.now()-He}ms`)}),D.CancellationToken.isCancellationToken(ue)?(0,h.raceCancellationError)(Ge,ue):Ge}_addNewAdapter(V,j){const Y=this._nextHandle();return this._adapter.set(Y,new xe(V,j)),Y}static _extLabel(V){return V.displayName||V.name}static _extId(V){return V.identifier.value}registerDocumentSymbolProvider(V,j,Y,ee){const ue=this._addNewAdapter(new d(this._documents,Y),V),we=ee&&ee.label||ze._extLabel(V);return this._proxy.$registerDocumentSymbolProvider(ue,this._transformDocumentSelector(j,V),we),this._createDisposable(ue)}$provideDocumentSymbols(V,j,Y){return this._withAdapter(V,d,ee=>ee.provideDocumentSymbols(f.URI.revive(j),Y),void 0,Y)}registerCodeLensProvider(V,j,Y){const ee=this._nextHandle(),ue=typeof Y.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(ee,new xe(new c(this._documents,this._commands.converter,Y,V,this._extensionTelemetry,this._logService),V)),this._proxy.$registerCodeLensSupport(ee,this._transformDocumentSelector(j,V),ue);let we=this._createDisposable(ee);if(ue!==void 0){const Ae=Y.onDidChangeCodeLenses(He=>this._proxy.$emitCodeLensEvent(ue));we=a.Disposable.from(we,Ae)}return we}$provideCodeLenses(V,j,Y){return this._withAdapter(V,c,ee=>ee.provideCodeLenses(f.URI.revive(j),Y),void 0,Y,j.scheme==="output")}$resolveCodeLens(V,j,Y){return this._withAdapter(V,c,ee=>ee.resolveCodeLens(j,Y),void 0,void 0,!0)}$releaseCodeLenses(V,j){this._withAdapter(V,c,Y=>Promise.resolve(Y.releaseCodeLenses(j)),void 0,void 0,!0)}registerDefinitionProvider(V,j,Y){const ee=this._addNewAdapter(new w(this._documents,Y),V);return this._proxy.$registerDefinitionSupport(ee,this._transformDocumentSelector(j,V)),this._createDisposable(ee)}$provideDefinition(V,j,Y,ee){return this._withAdapter(V,w,ue=>ue.provideDefinition(f.URI.revive(j),Y,ee),[],ee)}registerDeclarationProvider(V,j,Y){const ee=this._addNewAdapter(new y(this._documents,Y),V);return this._proxy.$registerDeclarationSupport(ee,this._transformDocumentSelector(j,V)),this._createDisposable(ee)}$provideDeclaration(V,j,Y,ee){return this._withAdapter(V,y,ue=>ue.provideDeclaration(f.URI.revive(j),Y,ee),[],ee)}registerImplementationProvider(V,j,Y){const ee=this._addNewAdapter(new I(this._documents,Y),V);return this._proxy.$registerImplementationSupport(ee,this._transformDocumentSelector(j,V)),this._createDisposable(ee)}$provideImplementation(V,j,Y,ee){return this._withAdapter(V,I,ue=>ue.provideImplementation(f.URI.revive(j),Y,ee),[],ee)}registerTypeDefinitionProvider(V,j,Y){const ee=this._addNewAdapter(new P(this._documents,Y),V);return this._proxy.$registerTypeDefinitionSupport(ee,this._transformDocumentSelector(j,V)),this._createDisposable(ee)}$provideTypeDefinition(V,j,Y,ee){return this._withAdapter(V,P,ue=>ue.provideTypeDefinition(f.URI.revive(j),Y,ee),[],ee)}registerHoverProvider(V,j,Y,ee){const ue=this._addNewAdapter(new k(this._documents,Y),V);return this._proxy.$registerHoverProvider(ue,this._transformDocumentSelector(j,V)),this._createDisposable(ue)}$provideHover(V,j,Y,ee,ue){return this._withAdapter(V,k,we=>we.provideHover(f.URI.revive(j),Y,ee,ue),void 0,ue)}$releaseHover(V,j){this._withAdapter(V,k,Y=>Promise.resolve(Y.releaseHover(j)),void 0,void 0)}registerEvaluatableExpressionProvider(V,j,Y,ee){const ue=this._addNewAdapter(new b(this._documents,Y),V);return this._proxy.$registerEvaluatableExpressionProvider(ue,this._transformDocumentSelector(j,V)),this._createDisposable(ue)}$provideEvaluatableExpression(V,j,Y,ee){return this._withAdapter(V,b,ue=>ue.provideEvaluatableExpression(f.URI.revive(j),Y,ee),void 0,ee)}registerInlineValuesProvider(V,j,Y,ee){const ue=typeof Y.onDidChangeInlineValues=="function"?this._nextHandle():void 0,we=this._addNewAdapter(new E(this._documents,Y),V);this._proxy.$registerInlineValuesProvider(we,this._transformDocumentSelector(j,V),ue);let Ae=this._createDisposable(we);if(ue!==void 0){const He=Y.onDidChangeInlineValues(Ge=>this._proxy.$emitInlineValuesEvent(ue));Ae=a.Disposable.from(Ae,He)}return Ae}$provideInlineValues(V,j,Y,ee,ue){return this._withAdapter(V,E,we=>we.provideInlineValues(f.URI.revive(j),Y,ee,ue),void 0,ue)}registerDocumentHighlightProvider(V,j,Y){const ee=this._addNewAdapter(new N(this._documents,Y),V);return this._proxy.$registerDocumentHighlightProvider(ee,this._transformDocumentSelector(j,V)),this._createDisposable(ee)}registerMultiDocumentHighlightProvider(V,j,Y){const ee=this._addNewAdapter(new O(this._documents,Y),V);return this._proxy.$registerMultiDocumentHighlightProvider(ee,this._transformDocumentSelector(j,V)),this._createDisposable(ee)}$provideDocumentHighlights(V,j,Y,ee){return this._withAdapter(V,N,ue=>ue.provideDocumentHighlights(f.URI.revive(j),Y,ee),void 0,ee)}$provideMultiDocumentHighlights(V,j,Y,ee,ue){return this._withAdapter(V,O,we=>we.provideMultiDocumentHighlights(f.URI.revive(j),Y,ee.map(Ae=>f.URI.revive(Ae)),ue),void 0,ue)}registerLinkedEditingRangeProvider(V,j,Y){const ee=this._addNewAdapter(new M(this._documents,Y),V);return this._proxy.$registerLinkedEditingRangeProvider(ee,this._transformDocumentSelector(j,V)),this._createDisposable(ee)}$provideLinkedEditingRanges(V,j,Y,ee){return this._withAdapter(V,M,async ue=>{const we=await ue.provideLinkedEditingRanges(f.URI.revive(j),Y,ee);if(we)return{ranges:we.ranges,wordPattern:we.wordPattern?ze._serializeRegExp(we.wordPattern):void 0}},void 0,ee)}registerReferenceProvider(V,j,Y){const ee=this._addNewAdapter(new U(this._documents,Y),V);return this._proxy.$registerReferenceSupport(ee,this._transformDocumentSelector(j,V)),this._createDisposable(ee)}$provideReferences(V,j,Y,ee,ue){return this._withAdapter(V,U,we=>we.provideReferences(f.URI.revive(j),Y,ee,ue),void 0,ue)}registerCodeActionProvider(V,j,Y,ee){const ue=new R.DisposableStore,we=this._addNewAdapter(new H(this._documents,this._commands.converter,this._diagnostics,Y,this._logService,V,this._apiDeprecation),V);return this._proxy.$registerCodeActionSupport(we,this._transformDocumentSelector(j,V),{providedKinds:ee?.providedCodeActionKinds?.map(Ae=>Ae.value),documentation:ee?.documentation?.map(Ae=>({kind:Ae.kind.value,command:this._commands.converter.toInternal(Ae.command,ue)}))},ze._extLabel(V),ze._extId(V),!!Y.resolveCodeAction),ue.add(this._createDisposable(we)),ue}$provideCodeActions(V,j,Y,ee,ue){return this._withAdapter(V,H,we=>we.provideCodeActions(f.URI.revive(j),Y,ee,ue),void 0,ue)}$resolveCodeAction(V,j,Y){return this._withAdapter(V,H,ee=>ee.resolveCodeAction(j,Y),{},void 0)}$releaseCodeActions(V,j){this._withAdapter(V,H,Y=>Promise.resolve(Y.releaseCodeActions(j)),void 0,void 0)}registerDocumentFormattingEditProvider(V,j,Y){const ee=this._addNewAdapter(new x(this._documents,Y),V);return this._proxy.$registerDocumentFormattingSupport(ee,this._transformDocumentSelector(j,V),V.identifier,V.displayName||V.name),this._createDisposable(ee)}$provideDocumentFormattingEdits(V,j,Y,ee){return this._withAdapter(V,x,ue=>ue.provideDocumentFormattingEdits(f.URI.revive(j),Y,ee),void 0,ee)}registerDocumentRangeFormattingEditProvider(V,j,Y){const ee=typeof Y.provideDocumentRangesFormattingEdits=="function",ue=this._addNewAdapter(new $(this._documents,Y),V);return this._proxy.$registerRangeFormattingSupport(ue,this._transformDocumentSelector(j,V),V.identifier,V.displayName||V.name,ee),this._createDisposable(ue)}$provideDocumentRangeFormattingEdits(V,j,Y,ee,ue){return this._withAdapter(V,$,we=>we.provideDocumentRangeFormattingEdits(f.URI.revive(j),Y,ee,ue),void 0,ue)}$provideDocumentRangesFormattingEdits(V,j,Y,ee,ue){return this._withAdapter(V,$,we=>we.provideDocumentRangesFormattingEdits(f.URI.revive(j),Y,ee,ue),void 0,ue)}registerOnTypeFormattingEditProvider(V,j,Y,ee){const ue=this._addNewAdapter(new G(this._documents,Y),V);return this._proxy.$registerOnTypeFormattingSupport(ue,this._transformDocumentSelector(j,V),ee,V.identifier),this._createDisposable(ue)}$provideOnTypeFormattingEdits(V,j,Y,ee,ue,we){return this._withAdapter(V,G,Ae=>Ae.provideOnTypeFormattingEdits(f.URI.revive(j),Y,ee,ue,we),void 0,we)}registerWorkspaceSymbolProvider(V,j){const Y=this._addNewAdapter(new B(j,this._logService),V);return this._proxy.$registerNavigateTypeSupport(Y,typeof j.resolveWorkspaceSymbol=="function"),this._createDisposable(Y)}$provideWorkspaceSymbols(V,j,Y){return this._withAdapter(V,B,ee=>ee.provideWorkspaceSymbols(j,Y),{symbols:[]},Y)}$resolveWorkspaceSymbol(V,j,Y){return this._withAdapter(V,B,ee=>ee.resolveWorkspaceSymbol(j,Y),void 0,void 0)}$releaseWorkspaceSymbols(V,j){this._withAdapter(V,B,Y=>Y.releaseWorkspaceSymbols(j),void 0,void 0)}registerRenameProvider(V,j,Y){const ee=this._addNewAdapter(new W(this._documents,Y,this._logService),V);return this._proxy.$registerRenameSupport(ee,this._transformDocumentSelector(j,V),W.supportsResolving(Y)),this._createDisposable(ee)}$provideRenameEdits(V,j,Y,ee,ue){return this._withAdapter(V,W,we=>we.provideRenameEdits(f.URI.revive(j),Y,ee,ue),void 0,ue)}$resolveRenameLocation(V,j,Y,ee){return this._withAdapter(V,W,ue=>ue.resolveRenameLocation(f.URI.revive(j),Y,ee),void 0,ee)}registerNewSymbolNamesProvider(V,j,Y){const ee=this._addNewAdapter(new Z(this._documents,Y,this._logService),V);return this._proxy.$registerNewSymbolNamesProvider(ee,this._transformDocumentSelector(j,V)),this._createDisposable(ee)}$supportsAutomaticNewSymbolNamesTriggerKind(V){return this._withAdapter(V,Z,j=>j.supportsAutomaticNewSymbolNamesTriggerKind(),!1,void 0)}$provideNewSymbolNames(V,j,Y,ee,ue){return this._withAdapter(V,Z,we=>we.provideNewSymbolNames(f.URI.revive(j),Y,ee,ue),void 0,ue)}registerDocumentSemanticTokensProvider(V,j,Y,ee){const ue=this._addNewAdapter(new oe(this._documents,Y),V),we=typeof Y.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._proxy.$registerDocumentSemanticTokensProvider(ue,this._transformDocumentSelector(j,V),ee,we);let Ae=this._createDisposable(ue);if(we){const He=Y.onDidChangeSemanticTokens(Ge=>this._proxy.$emitDocumentSemanticTokensEvent(we));Ae=a.Disposable.from(Ae,He)}return Ae}$provideDocumentSemanticTokens(V,j,Y,ee){return this._withAdapter(V,oe,ue=>ue.provideDocumentSemanticTokens(f.URI.revive(j),Y,ee),null,ee)}$releaseDocumentSemanticTokens(V,j){this._withAdapter(V,oe,Y=>Y.releaseDocumentSemanticColoring(j),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(V,j,Y,ee){const ue=this._addNewAdapter(new te(this._documents,Y),V);return this._proxy.$registerDocumentRangeSemanticTokensProvider(ue,this._transformDocumentSelector(j,V),ee),this._createDisposable(ue)}$provideDocumentRangeSemanticTokens(V,j,Y,ee){return this._withAdapter(V,te,ue=>ue.provideDocumentRangeSemanticTokens(f.URI.revive(j),Y,ee),null,ee)}registerCompletionItemProvider(V,j,Y,ee){const ue=this._addNewAdapter(new me(this._documents,this._commands.converter,Y,this._apiDeprecation,V),V);return this._proxy.$registerCompletionsProvider(ue,this._transformDocumentSelector(j,V),ee,me.supportsResolving(Y),V.identifier),this._createDisposable(ue)}$provideCompletionItems(V,j,Y,ee,ue){return this._withAdapter(V,me,we=>we.provideCompletionItems(f.URI.revive(j),Y,ee,ue),void 0,ue)}$resolveCompletionItem(V,j,Y){return this._withAdapter(V,me,ee=>ee.resolveCompletionItem(j,Y),void 0,Y)}$releaseCompletionItems(V,j){this._withAdapter(V,me,Y=>Y.releaseCompletionItems(j),void 0,void 0)}registerInlineCompletionsProvider(V,j,Y,ee){const ue=new Q(V,this._documents,Y,this._commands.converter),we=this._addNewAdapter(ue,V);return this._proxy.$registerInlineCompletionsSupport(we,this._transformDocumentSelector(j,V),ue.supportsHandleEvents,u.ExtensionIdentifier.toKey(V.identifier.value),ee?.yieldTo?.map(Ae=>u.ExtensionIdentifier.toKey(Ae))||[]),this._createDisposable(we)}$provideInlineCompletions(V,j,Y,ee,ue){return this._withAdapter(V,le,we=>we.provideInlineCompletions(f.URI.revive(j),Y,ee,ue),void 0,ue)}$provideInlineEdits(V,j,Y,ee,ue){return this._withAdapter(V,le,we=>we.provideInlineEdits(f.URI.revive(j),Y,ee,ue),void 0,ue)}$handleInlineCompletionDidShow(V,j,Y,ee){this._withAdapter(V,le,async ue=>{ue.handleDidShowCompletionItem(j,Y,ee)},void 0,void 0)}$handleInlineCompletionPartialAccept(V,j,Y,ee,ue){this._withAdapter(V,le,async we=>{we.handlePartialAccept(j,Y,ee,ue)},void 0,void 0)}$freeInlineCompletionsList(V,j){this._withAdapter(V,le,async Y=>{Y.disposeCompletions(j)},void 0,void 0)}registerInlineEditProvider(V,j,Y){const ee=new z(V,this._documents,Y,this._commands.converter),ue=this._addNewAdapter(ee,V);return this._proxy.$registerInlineEditProvider(ue,this._transformDocumentSelector(j,V),V.identifier),this._createDisposable(ue)}$provideInlineEdit(V,j,Y,ee){return this._withAdapter(V,z,ue=>ue.provideInlineEdits(f.URI.revive(j),Y,ee),void 0,ee)}$freeInlineEdit(V,j){this._withAdapter(V,z,async Y=>{Y.disposeEdit(j)},void 0,void 0)}registerSignatureHelpProvider(V,j,Y,ee){const ue=Array.isArray(ee)?{triggerCharacters:ee,retriggerCharacters:[]}:ee,we=this._addNewAdapter(new Ee(this._documents,Y),V);return this._proxy.$registerSignatureHelpProvider(we,this._transformDocumentSelector(j,V),ue),this._createDisposable(we)}$provideSignatureHelp(V,j,Y,ee,ue){return this._withAdapter(V,Ee,we=>we.provideSignatureHelp(f.URI.revive(j),Y,ee,ue),void 0,ue)}$releaseSignatureHelp(V,j){this._withAdapter(V,Ee,Y=>Y.releaseSignatureHelp(j),void 0,void 0)}registerInlayHintsProvider(V,j,Y){const ee=typeof Y.onDidChangeInlayHints=="function"?this._nextHandle():void 0,ue=this._addNewAdapter(new ae(this._documents,this._commands.converter,Y,this._logService,V),V);this._proxy.$registerInlayHintsProvider(ue,this._transformDocumentSelector(j,V),typeof Y.resolveInlayHint=="function",ee,ze._extLabel(V));let we=this._createDisposable(ue);if(ee!==void 0){const Ae=Y.onDidChangeInlayHints(He=>this._proxy.$emitInlayHintsEvent(ee));we=a.Disposable.from(we,Ae)}return we}$provideInlayHints(V,j,Y,ee){return this._withAdapter(V,ae,ue=>ue.provideInlayHints(f.URI.revive(j),Y,ee),void 0,ee)}$resolveInlayHint(V,j,Y){return this._withAdapter(V,ae,ee=>ee.resolveInlayHint(j,Y),void 0,Y)}$releaseInlayHints(V,j){this._withAdapter(V,ae,Y=>Y.releaseHints(j),void 0,void 0)}registerDocumentLinkProvider(V,j,Y){const ee=this._addNewAdapter(new be(this._documents,Y),V);return this._proxy.$registerDocumentLinkProvider(ee,this._transformDocumentSelector(j,V),typeof Y.resolveDocumentLink=="function"),this._createDisposable(ee)}$provideDocumentLinks(V,j,Y){return this._withAdapter(V,be,ee=>ee.provideLinks(f.URI.revive(j),Y),void 0,Y,j.scheme==="output")}$resolveDocumentLink(V,j,Y){return this._withAdapter(V,be,ee=>ee.resolveLink(j,Y),void 0,void 0,!0)}$releaseDocumentLinks(V,j){this._withAdapter(V,be,Y=>Y.releaseLinks(j),void 0,void 0,!0)}registerColorProvider(V,j,Y){const ee=this._addNewAdapter(new pe(this._documents,Y),V);return this._proxy.$registerDocumentColorProvider(ee,this._transformDocumentSelector(j,V)),this._createDisposable(ee)}$provideDocumentColors(V,j,Y){return this._withAdapter(V,pe,ee=>ee.provideColors(f.URI.revive(j),Y),[],Y)}$provideColorPresentations(V,j,Y,ee){return this._withAdapter(V,pe,ue=>ue.provideColorPresentations(f.URI.revive(j),Y,ee),void 0,ee)}registerFoldingRangeProvider(V,j,Y){const ee=this._nextHandle(),ue=typeof Y.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(ee,new xe(new ve(this._documents,Y),V)),this._proxy.$registerFoldingRangeProvider(ee,this._transformDocumentSelector(j,V),V.identifier,ue);let we=this._createDisposable(ee);if(ue!==void 0){const Ae=Y.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(ue));we=a.Disposable.from(we,Ae)}return we}$provideFoldingRanges(V,j,Y,ee){return this._withAdapter(V,ve,ue=>ue.provideFoldingRanges(f.URI.revive(j),Y,ee),void 0,ee)}registerSelectionRangeProvider(V,j,Y){const ee=this._addNewAdapter(new Re(this._documents,Y,this._logService),V);return this._proxy.$registerSelectionRangeProvider(ee,this._transformDocumentSelector(j,V)),this._createDisposable(ee)}$provideSelectionRanges(V,j,Y,ee){return this._withAdapter(V,Re,ue=>ue.provideSelectionRanges(f.URI.revive(j),Y,ee),[],ee)}registerCallHierarchyProvider(V,j,Y){const ee=this._addNewAdapter(new Fe(this._documents,Y),V);return this._proxy.$registerCallHierarchyProvider(ee,this._transformDocumentSelector(j,V)),this._createDisposable(ee)}$prepareCallHierarchy(V,j,Y,ee){return this._withAdapter(V,Fe,ue=>Promise.resolve(ue.prepareSession(f.URI.revive(j),Y,ee)),void 0,ee)}$provideCallHierarchyIncomingCalls(V,j,Y,ee){return this._withAdapter(V,Fe,ue=>ue.provideCallsTo(j,Y,ee),void 0,ee)}$provideCallHierarchyOutgoingCalls(V,j,Y,ee){return this._withAdapter(V,Fe,ue=>ue.provideCallsFrom(j,Y,ee),void 0,ee)}$releaseCallHierarchy(V,j){this._withAdapter(V,Fe,Y=>Promise.resolve(Y.releaseSession(j)),void 0,void 0)}registerTypeHierarchyProvider(V,j,Y){const ee=this._addNewAdapter(new Ve(this._documents,Y),V);return this._proxy.$registerTypeHierarchyProvider(ee,this._transformDocumentSelector(j,V)),this._createDisposable(ee)}$prepareTypeHierarchy(V,j,Y,ee){return this._withAdapter(V,Ve,ue=>Promise.resolve(ue.prepareSession(f.URI.revive(j),Y,ee)),void 0,ee)}$provideTypeHierarchySupertypes(V,j,Y,ee){return this._withAdapter(V,Ve,ue=>ue.provideSupertypes(j,Y,ee),void 0,ee)}$provideTypeHierarchySubtypes(V,j,Y,ee){return this._withAdapter(V,Ve,ue=>ue.provideSubtypes(j,Y,ee),void 0,ee)}$releaseTypeHierarchy(V,j){this._withAdapter(V,Ve,Y=>Promise.resolve(Y.releaseSession(j)),void 0,void 0)}registerDocumentOnDropEditProvider(V,j,Y,ee){const ue=this._nextHandle();return this._adapter.set(ue,new xe(new Ye(this._proxy,this._documents,Y,ue,V),V)),this._proxy.$registerDocumentOnDropEditProvider(ue,this._transformDocumentSelector(j,V),(0,t.isProposedApiEnabled)(V,"documentPaste")&&ee?{supportsResolve:!!Y.resolveDocumentDropEdit,dropMimeTypes:ee.dropMimeTypes}:void 0),this._createDisposable(ue)}$provideDocumentOnDropEdits(V,j,Y,ee,ue,we){return this._withAdapter(V,Ye,Ae=>Promise.resolve(Ae.provideDocumentOnDropEdits(j,f.URI.revive(Y),ee,ue,we)),void 0,void 0)}$resolveDropEdit(V,j,Y){return this._withAdapter(V,Ye,ee=>ee.resolveDropEdit(j,Y),{},void 0)}$releaseDocumentOnDropEdits(V,j){this._withAdapter(V,Ye,Y=>Promise.resolve(Y.releaseDropEdits(j)),void 0,void 0)}registerMappedEditsProvider(V,j,Y){const ee=this._addNewAdapter(new Je(this._documents,Y),V);return this._proxy.$registerMappedEditsProvider(ee,this._transformDocumentSelector(j,V),V.displayName??V.name),this._createDisposable(ee)}$provideMappedEdits(V,j,Y,ee,ue){return this._withAdapter(V,Je,we=>Promise.resolve(we.provideMappedEdits(j,Y,ee,ue)),null,ue)}registerDocumentPasteEditProvider(V,j,Y,ee){const ue=this._nextHandle();return this._adapter.set(ue,new xe(new F(this._proxy,this._documents,Y,ue,V),V)),this._proxy.$registerPasteEditProvider(ue,this._transformDocumentSelector(j,V),{supportsCopy:!!Y.prepareDocumentPaste,supportsPaste:!!Y.provideDocumentPasteEdits,supportsResolve:!!Y.resolveDocumentPasteEdit,providedPasteEditKinds:ee.providedPasteEditKinds?.map(we=>we.value),copyMimeTypes:ee.copyMimeTypes,pasteMimeTypes:ee.pasteMimeTypes}),this._createDisposable(ue)}$prepareDocumentPaste(V,j,Y,ee,ue){return this._withAdapter(V,F,we=>we.prepareDocumentPaste(f.URI.revive(j),Y,ee,ue),void 0,ue)}$providePasteEdits(V,j,Y,ee,ue,we,Ae){return this._withAdapter(V,F,He=>He.providePasteEdits(j,f.URI.revive(Y),ee,ue,we,Ae),void 0,Ae)}$resolvePasteEdit(V,j,Y){return this._withAdapter(V,F,ee=>ee.resolvePasteEdit(j,Y),{},void 0)}$releasePasteEdits(V,j){this._withAdapter(V,F,Y=>Promise.resolve(Y.releasePasteEdits(j)),void 0,void 0)}static _serializeRegExp(V){return{pattern:V.source,flags:V.flags}}static _serializeIndentationRule(V){return{decreaseIndentPattern:ze._serializeRegExp(V.decreaseIndentPattern),increaseIndentPattern:ze._serializeRegExp(V.increaseIndentPattern),indentNextLinePattern:V.indentNextLinePattern?ze._serializeRegExp(V.indentNextLinePattern):void 0,unIndentedLinePattern:V.unIndentedLinePattern?ze._serializeRegExp(V.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(V){return{beforeText:ze._serializeRegExp(V.beforeText),afterText:V.afterText?ze._serializeRegExp(V.afterText):void 0,previousLineText:V.previousLineText?ze._serializeRegExp(V.previousLineText):void 0,action:V.action}}static _serializeOnEnterRules(V){return V.map(ze._serializeOnEnterRule)}static _serializeAutoClosingPair(V){return{open:V.open,close:V.close,notIn:V.notIn?V.notIn.map(j=>a.SyntaxTokenType.toString(j)):void 0}}static _serializeAutoClosingPairs(V){return V.map(ze._serializeAutoClosingPair)}setLanguageConfiguration(V,j,Y){const{wordPattern:ee}=Y;if(ee&&(0,C.regExpLeadsToEndlessLoop)(ee))throw new Error(`Invalid language configuration: wordPattern '${ee}' is not allowed to match the empty string.`);ee?this._documents.setWordDefinitionFor(j,ee):this._documents.setWordDefinitionFor(j,void 0),Y.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",V,"Do not use."),Y.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",V,"Do not use.");const ue=this._nextHandle(),we={comments:Y.comments,brackets:Y.brackets,wordPattern:Y.wordPattern?ze._serializeRegExp(Y.wordPattern):void 0,indentationRules:Y.indentationRules?ze._serializeIndentationRule(Y.indentationRules):void 0,onEnterRules:Y.onEnterRules?ze._serializeOnEnterRules(Y.onEnterRules):void 0,__electricCharacterSupport:Y.__electricCharacterSupport,__characterPairSupport:Y.__characterPairSupport,autoClosingPairs:Y.autoClosingPairs?ze._serializeAutoClosingPairs(Y.autoClosingPairs):void 0};return this._proxy.$setLanguageConfiguration(ue,j,we),this._createDisposable(ue)}$setWordDefinitions(V){for(const j of V)this._documents.setWordDefinitionFor(j.languageId,new RegExp(j.regexSource,j.regexFlags))}}e.ExtHostLanguageFeatures=ze}),define(Pe[307],ke([1,0,8,20,12,3,38,31,6,15]),function(ge,e,s,h,D,A,L,R,v,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageModelTools=void 0,l=We(l);class C{constructor(f){this._registeredTools=new Map,this._tokenCountFuncs=new Map,this._allTools=new Map,this._proxy=f.getProxy(v.MainContext.MainThreadLanguageModelTools),this._proxy.$getTools().then(T=>{for(const S of T)this._allTools.set(S.id,(0,L.revive)(S))})}async $countTokensForInvocation(f,T,S){const o=this._tokenCountFuncs.get(f);if(!o)throw new Error(`Tool invocation call ${f} not found`);return await o(T,S)}async invokeTool(f,T,S){const o=(0,R.generateUuid)();T.tokenOptions&&this._tokenCountFuncs.set(o,T.tokenOptions.countTokens);try{const m=await this._proxy.$invokeTool({toolId:f,callId:o,parameters:T.parameters,tokenBudget:T.tokenOptions?.tokenBudget},S);return l.LanguageModelToolResult.to(m)}finally{this._tokenCountFuncs.delete(o)}}$onDidChangeTools(f){this._allTools.clear();for(const T of f)this._allTools.set(T.id,T)}get tools(){return Array.from(this._allTools.values()).map(f=>l.LanguageModelToolDescription.to(f))}async $invokeTool(f,T){const S=this._registeredTools.get(f.toolId);if(!S)throw new Error(`Unknown tool ${f.toolId}`);const o={parameters:f.parameters};f.tokenBudget!==void 0&&(o.tokenOptions={tokenBudget:f.tokenBudget,countTokens:this._tokenCountFuncs.get(f.callId)||((p,u=h.CancellationToken.None)=>this._proxy.$countTokensForInvocation(f.callId,p,u))});const m=await(0,s.raceCancellation)(Promise.resolve(S.tool.invoke(o,T)),T);if(!m)throw new D.CancellationError;for(const p of Object.keys(m))if(m[p]instanceof Promise)throw new Error(`Tool result for '${p}' cannot be a Promise`);return l.LanguageModelToolResult.from(m)}registerTool(f,T,S){return this._registeredTools.set(T,{extension:f,tool:S}),this._proxy.$registerTool(T),(0,A.toDisposable)(()=>{this._registeredTools.delete(T),this._proxy.$unregisterTool(T)})}}e.ExtHostLanguageModelTools=C}),define(Pe[128],ke([1,0,8,20,52,12,4,40,3,7,23,5,11,90,6,127,19,15,9,161,25]),function(ge,e,s,h,D,A,L,R,v,l,C,_,f,T,S,o,m,p,u,i,a){"use strict";var t;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageModels=e.IExtHostLanguageModels=void 0,p=We(p),u=We(u),e.IExtHostLanguageModels=(0,_.createDecorator)("IExtHostLanguageModels");class n{constructor(g,w){this.option=g,this.stream=new s.AsyncIterableSource,this.stream=w??new s.AsyncIterableSource}}class r{constructor(){this._responseStreams=new Map,this._defaultStream=new s.AsyncIterableSource,this._isDone=!1;const g=this;this.apiObject={get stream(){return g._defaultStream.asyncIterable},get text(){return s.AsyncIterableObject.map(g._defaultStream.asyncIterable,w=>{if(w instanceof u.LanguageModelTextPart)return w.value}).coalesce()}}}*_streams(){if(this._responseStreams.size>0)for(const[,g]of this._responseStreams)yield g.stream;else yield this._defaultStream}handleFragment(g){if(this._isDone)return;let w=this._responseStreams.get(g.index);w||(this._responseStreams.size===0?w=new n(g.index,this._defaultStream):w=new n(g.index),this._responseStreams.set(g.index,w));let y;g.part.type==="text"?y=new u.LanguageModelTextPart(g.part.value):y=new u.LanguageModelToolCallPart(g.part.name,g.part.toolCallId,g.part.parameters),w.stream.emitOne(y)}reject(g){this._isDone=!0;for(const w of this._streams())w.reject(g)}resolve(){this._isDone=!0;for(const g of this._streams())g.resolve()}}let d=class{static{t=this}static{this._idPool=1}constructor(g,w,y){this._logService=w,this._extHostAuthentication=y,this._onDidChangeModelAccess=new L.Emitter,this._onDidChangeProviders=new L.Emitter,this.onDidChangeProviders=this._onDidChangeProviders.event,this._languageModels=new Map,this._allLanguageModelData=new Map,this._modelAccessList=new C.ExtensionIdentifierMap,this._pendingRequest=new Map,this._languageAccessInformationExtensions=new Set,this._proxy=g.getProxy(S.MainContext.MainThreadLanguageModels)}dispose(){this._onDidChangeModelAccess.dispose(),this._onDidChangeProviders.dispose()}registerLanguageModel(g,w,y,I){const P=t._idPool++;this._languageModels.set(P,{extension:g.identifier,provider:y,languageModelId:w});let k;I.auth&&(k={providerLabel:g.displayName||g.name,accountLabel:typeof I.auth=="object"?I.auth.label:void 0}),this._proxy.$registerLanguageModelProvider(P,`${C.ExtensionIdentifier.toKey(g.identifier)}/${P}/${w}`,{extension:g.identifier,id:w,vendor:I.vendor??C.ExtensionIdentifier.toKey(g.identifier),name:I.name??"",family:I.family??"",version:I.version,maxInputTokens:I.maxInputTokens,maxOutputTokens:I.maxOutputTokens,auth:k,targetExtensions:I.extensions});const b=y.onDidReceiveLanguageModelResponse2?.(({extensionId:E,participant:N,tokenCount:O})=>{this._proxy.$whenLanguageModelChatRequestMade(w,new C.ExtensionIdentifier(E),N,O)});return(0,v.toDisposable)(()=>{this._languageModels.delete(P),this._proxy.$unregisterProvider(P),b?.dispose()})}async $startChatRequest(g,w,y,I,P,k){const b=this._languageModels.get(g);if(!b)throw new Error("Provider not found");const E=new T.Progress(async O=>{if(k.isCancellationRequested){this._logService.warn(`[CHAT](${b.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}let M;if(O.part instanceof u.LanguageModelToolCallPart?M={type:"tool_use",name:O.part.name,parameters:O.part.parameters,toolCallId:O.part.toolCallId}:O.part instanceof u.LanguageModelTextPart&&(M={type:"text",value:O.part.value}),!M){this._logService.warn(`[CHAT](${b.extension.value}) UNKNOWN part ${JSON.stringify(O)}`);return}this._proxy.$reportResponsePart(w,{index:O.index,part:M})});let N;if(b.provider.provideLanguageModelResponse2)N=Promise.resolve(b.provider.provideLanguageModelResponse2(I.map(p.LanguageModelChatMessage.to),P,C.ExtensionIdentifier.toKey(y),E,k));else{const O=new T.Progress(async M=>{E.report({index:M.index,part:new u.LanguageModelTextPart(M.part)})});N=Promise.resolve(b.provider.provideLanguageModelResponse(I.map(p.LanguageModelChatMessage.to),P?.modelOptions??{},C.ExtensionIdentifier.toKey(y),O,k))}N.then(()=>{this._proxy.$reportResponseDone(w,void 0)},O=>{this._proxy.$reportResponseDone(w,(0,A.transformErrorForSerialization)(O))})}$provideTokenLength(g,w,y){const I=this._languageModels.get(g);return I?Promise.resolve(I.provider.provideTokenCount(w,y)):Promise.resolve(0)}$acceptChatModelMetadata(g){if(g.added)for(const{identifier:w,metadata:y}of g.added)this._allLanguageModelData.set(w,{metadata:y,apiObjects:new C.ExtensionIdentifierMap});if(g.removed)for(const w of g.removed){this._allLanguageModelData.delete(w);for(const[y,I]of this._pendingRequest)I.languageModelId===w&&(I.res.reject(new A.CancellationError),this._pendingRequest.delete(y))}g.added?.forEach(w=>this._fakeAuthPopulate(w.metadata)),this._onDidChangeProviders.fire(void 0)}async selectLanguageModels(g,w){const y=await this._proxy.$selectChatModels({...w,extension:g.identifier}),I=[],P=this;for(const k of y){const b=this._allLanguageModelData.get(k);if(!b)continue;this._isUsingAuth(g.identifier,b.metadata)&&await this._fakeAuthPopulate(b.metadata);let E=b.apiObjects.get(g.identifier);E||(E={id:k,vendor:b.metadata.vendor,family:b.metadata.family,version:b.metadata.version,name:b.metadata.name,maxInputTokens:b.metadata.maxInputTokens,countTokens(N,O){if(!P._allLanguageModelData.has(k))throw u.LanguageModelError.NotFound(k);return P._computeTokenLength(k,N,O??h.CancellationToken.None)},sendRequest(N,O,M){if(!P._allLanguageModelData.has(k))throw u.LanguageModelError.NotFound(k);return P._sendChatRequest(g,k,N,O??{},M??h.CancellationToken.None)}},Object.freeze(E),b.apiObjects.set(g.identifier,E)),I.push(E)}return I}async _sendChatRequest(g,w,y,I,P){const k=this._convertMessages(g,y),b=g.identifier,E=this._allLanguageModelData.get(w)?.metadata;if(!E||!this._allLanguageModelData.has(w))throw u.LanguageModelError.NotFound(`Language model '${w}' is unknown.`);if(this._isUsingAuth(b,E)&&(!await this._getAuthAccess(g,{identifier:E.extension,displayName:E.auth.providerLabel},I.justification,!1)||!this._modelAccessList.get(b)?.has(E.extension)))throw u.LanguageModelError.NoPermissions(`Language model '${w}' cannot be used by '${b.value}'.`);try{const N=Math.random()*1e6|0,O=new r;this._pendingRequest.set(N,{languageModelId:w,res:O});try{await this._proxy.$tryStartChatRequest(b,w,N,k,I,P)}catch(M){throw this._pendingRequest.delete(N),M}return O.apiObject}catch(N){throw N.name===u.LanguageModelError.name?N:new u.LanguageModelError(`Language model '${w}' errored: ${(0,D.toErrorMessage)(N)}`,"Unknown",N)}}_convertMessages(g,w){const y=[];for(const I of w)I.role===u.LanguageModelChatMessageRole.System&&(0,a.checkProposedApiEnabled)(g,"languageModelSystem"),I.content2.some(P=>P instanceof u.LanguageModelToolResultPart)&&(0,a.checkProposedApiEnabled)(g,"lmTools"),y.push(p.LanguageModelChatMessage.from(I));return y}async $acceptResponsePart(g,w){const y=this._pendingRequest.get(g);y&&y.res.handleFragment(w)}async $acceptResponseDone(g,w){const y=this._pendingRequest.get(g);y&&(this._pendingRequest.delete(g),w?y.res.reject((0,A.transformErrorFromSerialization)(w)):y.res.resolve())}async _getAuthAccess(g,w,y,I){const P=i.INTERNAL_AUTH_PROVIDER_PREFIX+w.identifier.value;if(await this._extHostAuthentication.getSession(g,P,[],{silent:!0}))return this.$updateModelAccesslist([{from:g.identifier,to:w.identifier,enabled:!0}]),!0;if(I)return!1;try{const b=y?(0,l.localize)(2705,null,w.displayName,y):void 0;return await this._extHostAuthentication.getSession(g,P,[],{forceNewSession:{detail:b}}),this.$updateModelAccesslist([{from:g.identifier,to:w.identifier,enabled:!0}]),!0}catch{return!1}}_isUsingAuth(g,w){return!!w.auth&&!C.ExtensionIdentifier.equals(w.extension,g)}async _fakeAuthPopulate(g){if(g.auth)for(const w of this._languageAccessInformationExtensions)try{await this._getAuthAccess(w,{identifier:g.extension,displayName:""},void 0,!0)}catch(y){this._logService.error("Fake Auth request failed"),this._logService.error(y)}}async _computeTokenLength(g,w,y){if(!this._allLanguageModelData.get(g))throw u.LanguageModelError.NotFound(`Language model '${g}' is unknown.`);const P=R.Iterable.find(this._languageModels.values(),k=>k.languageModelId===g);return P?P.provider.provideTokenCount(w,y):this._proxy.$countTokens(g,typeof w=="string"?w:p.LanguageModelChatMessage.from(w),y)}$updateModelAccesslist(g){const w=new Array;for(const{from:y,to:I,enabled:P}of g){const k=this._modelAccessList.get(y)??new C.ExtensionIdentifierSet;if(k.has(I)!==P){P?k.add(I):k.delete(I),this._modelAccessList.set(y,k);const E={from:y,to:I};w.push(E),this._onDidChangeModelAccess.fire(E)}}}createLanguageModelAccessInformation(g){this._languageAccessInformationExtensions.add(g);const w=this,y=L.Event.signal(L.Event.filter(this._onDidChangeModelAccess.event,P=>C.ExtensionIdentifier.equals(P.from,g.identifier))),I=L.Event.signal(this._onDidChangeProviders.event);return{get onDidChange(){return L.Event.any(y,I)},canSendRequest(P){let k;e:for(const[E,N]of w._allLanguageModelData)for(const O of N.apiObjects.values())if(O===P){k=N.metadata;break e}if(!k)return;if(!w._isUsingAuth(g.identifier,k))return!0;const b=w._modelAccessList.get(g.identifier);if(b)return b.has(k.extension)}}}};e.ExtHostLanguageModels=d,e.ExtHostLanguageModels=d=t=Qe([$e(0,m.IExtHostRpcService),$e(1,f.ILogService),$e(2,o.IExtHostAuthentication)],d)});var Vt=this&&this.__importDefault||function(ge){return ge&&ge.__esModule?ge:{default:ge}};define(Pe[308],ke([1,0,6,15,9,44,8,3,25]),function(ge,e,s,h,D,A,L,R,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0,h=We(h),A=Vt(A);class l{constructor(_,f,T,S){this._documents=f,this._commands=T,this._uriTransformer=S,this._languageIds=[],this._handlePool=0,this._ids=new Set,this._proxy=_.getProxy(s.MainContext.MainThreadLanguages)}$acceptLanguageIds(_){this._languageIds=_}async getLanguages(){return this._languageIds.slice(0)}async changeLanguage(_,f){await this._proxy.$changeLanguage(_,f);const T=this._documents.getDocumentData(_);if(!T)throw new Error(`document '${_.toString()}' NOT found`);return T.document}async tokenAtPosition(_,f){const T=_.version,S=h.Position.from(f),o=await this._proxy.$tokensAtPosition(_.uri,S),m={type:D.StandardTokenType.Other,range:_.getWordRangeAtPosition(f)??new D.Range(f.line,f.character,f.line,f.character)};if(!o)return m;const p={range:h.Range.to(o.range),type:h.TokenType.to(o.type)};return!p.range.contains(f)||T!==_.version?m:p}createLanguageStatusItem(_,f,T){const S=this._handlePool++,o=this._proxy,m=this._ids,p=`${_.identifier.value}/${f}`;if(m.has(p))throw new Error(`LanguageStatusItem with id '${f}' ALREADY exists`);m.add(p);const u={selector:T,id:f,name:_.displayName??_.name,severity:D.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let i;const a=new R.DisposableStore,t=()=>{if(i?.dispose(),!m.has(p)){console.warn(`LanguageStatusItem (${f}) from ${_.identifier.value} has been disposed and CANNOT be updated anymore`);return}i=(0,L.disposableTimeout)(()=>{a.clear(),this._proxy.$setLanguageStatus(S,{id:p,name:u.name??_.displayName??_.name,source:_.displayName??_.name,selector:h.DocumentSelector.from(u.selector,this._uriTransformer),label:u.text,detail:u.detail??"",severity:u.severity===D.LanguageStatusSeverity.Error?A.default.Error:u.severity===D.LanguageStatusSeverity.Warning?A.default.Warning:A.default.Info,command:u.command&&this._commands.toInternal(u.command,a),accessibilityInfo:u.accessibilityInformation,busy:u.busy})},0)},n={dispose(){a.dispose(),i?.dispose(),o.$removeLanguageStatus(S),m.delete(p)},get id(){return u.id},get name(){return u.name},set name(r){u.name=r,t()},get selector(){return u.selector},set selector(r){u.selector=r,t()},get text(){return u.text},set text(r){u.text=r,t()},set text2(r){(0,v.checkProposedApiEnabled)(_,"languageStatusText"),u.text=r,t()},get text2(){return(0,v.checkProposedApiEnabled)(_,"languageStatusText"),u.text},get detail(){return u.detail},set detail(r){u.detail=r,t()},get severity(){return u.severity},set severity(r){u.severity=r,t()},get accessibilityInformation(){return u.accessibilityInformation},set accessibilityInformation(r){u.accessibilityInformation=r,t()},get command(){return u.command},set command(r){u.command=r,t()},get busy(){return u.busy},set busy(r){u.busy=r,t()}};return t(),n}}e.ExtHostLanguages=l}),define(Pe[309],ke([1,0,14,2,15,9,126]),function(ge,e,s,h,D,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0,D=We(D),L=We(L);class R{constructor(_,f,T,S){this.start=_,this.deletedCount=f,this.deletedItems=T,this.items=S}asApiEvent(){return{range:new A.NotebookRange(this.start,this.start+this.deletedCount),addedCells:this.items.map(_=>_.apiCell),removedCells:this.deletedItems}}}class v{static asModelAddData(_){return{EOL:_.eol,lines:_.source,languageId:_.language,uri:_.uri,isDirty:!1,versionId:1}}constructor(_,f,T){this.notebook=_,this._extHostDocument=f,this._cellData=T,this.handle=T.handle,this.uri=h.URI.revive(T.uri),this.cellKind=T.cellKind,this._outputs=T.outputs.map(D.NotebookCellOutput.to),this._internalMetadata=T.internalMetadata??{},this._metadata=Object.freeze(T.metadata??{}),this._previousResult=Object.freeze(D.NotebookCellExecutionSummary.to(T.internalMetadata??{}))}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const _=this,f=this._extHostDocument.getDocument(this.uri);if(!f)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const T={get index(){return _.notebook.getCellIndex(_)},notebook:_.notebook.apiNotebook,kind:D.NotebookCellKind.to(this._cellData.cellKind),document:f.document,get mime(){return _._mime},set mime(S){_._mime=S},get outputs(){return _._outputs.slice(0)},get metadata(){return _._metadata},get executionSummary(){return _._previousResult}};this._apiCell=Object.freeze(T)}return this._apiCell}setOutputs(_){this._outputs=_.map(D.NotebookCellOutput.to)}setOutputItems(_,f,T){const S=T.map(D.NotebookCellOutputItem.to),o=this._outputs.find(m=>m.id===_);if(o&&(f||(o.items.length=0),o.items.push(...S),o.items.length>1&&o.items.every(m=>L.isTextStreamMime(m.mime)))){const m=new Map,p=[];o.items.forEach(u=>{let i;m.has(u.mime)?i=m.get(u.mime):(i=[],m.set(u.mime,i),p.push(u.mime)),i.push(u.data)}),o.items.length=0,p.forEach(u=>{const i=L.compressOutputItemStreams(m.get(u));o.items.push({mime:u,data:i.data.buffer})})}}setMetadata(_){this._metadata=Object.freeze(_)}setInternalMetadata(_){this._internalMetadata=_,this._previousResult=Object.freeze(D.NotebookCellExecutionSummary.to(_))}setMime(_){}}e.ExtHostCell=v;class l{static{this._handlePool=0}constructor(_,f,T,S,o){this._proxy=_,this._textDocumentsAndEditors=f,this._textDocuments=T,this.uri=S,this.handle=l._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1,this._notebookType=o.viewType,this._metadata=Object.freeze(o.metadata??Object.create(null)),this._spliceNotebookCells([[0,0,o.cells]],!0,void 0),this._versionId=o.versionId}dispose(){this._disposed=!0}get versionId(){return this._versionId}get apiNotebook(){if(!this._notebook){const _=this,f={get uri(){return _.uri},get version(){return _._versionId},get notebookType(){return _._notebookType},get isDirty(){return _._isDirty},get isUntitled(){return _.uri.scheme===s.Schemas.untitled},get isClosed(){return _._disposed},get metadata(){return _._metadata},get cellCount(){return _._cells.length},cellAt(T){return T=_._validateIndex(T),_._cells[T].apiCell},getCells(T){return(T?_._getCells(T):_._cells).map(o=>o.apiCell)},save(){return _._save()},[Symbol.for("debug.description")](){return`NotebookDocument(${this.uri.toString()})`}};this._notebook=Object.freeze(f)}return this._notebook}acceptDocumentPropertiesChanged(_){_.metadata&&(this._metadata=Object.freeze({...this._metadata,..._.metadata}))}acceptDirty(_){this._isDirty=_}acceptModelChanged(_,f,T){this._versionId=_.versionId,this._isDirty=f,this.acceptDocumentPropertiesChanged({metadata:T});const S={notebook:this.apiNotebook,metadata:T,cellChanges:[],contentChanges:[]},o=[];for(const p of _.rawEvents)p.kind===L.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(p.changes,!1,S.contentChanges):p.kind===L.NotebookCellsChangeType.Move?this._moveCells(p.index,p.length,p.newIdx,S.contentChanges):p.kind===L.NotebookCellsChangeType.Output?(this._setCellOutputs(p.index,p.outputs),o.push({cell:this._cells[p.index].apiCell,outputs:this._cells[p.index].apiCell.outputs})):p.kind===L.NotebookCellsChangeType.OutputItem?(this._setCellOutputItems(p.index,p.outputId,p.append,p.outputItems),o.push({cell:this._cells[p.index].apiCell,outputs:this._cells[p.index].apiCell.outputs})):p.kind===L.NotebookCellsChangeType.ChangeCellLanguage?(this._changeCellLanguage(p.index,p.language),o.push({cell:this._cells[p.index].apiCell,document:this._cells[p.index].apiCell.document})):p.kind===L.NotebookCellsChangeType.ChangeCellContent?o.push({cell:this._cells[p.index].apiCell,document:this._cells[p.index].apiCell.document}):p.kind===L.NotebookCellsChangeType.ChangeCellMime?this._changeCellMime(p.index,p.mime):p.kind===L.NotebookCellsChangeType.ChangeCellMetadata?(this._changeCellMetadata(p.index,p.metadata),o.push({cell:this._cells[p.index].apiCell,metadata:this._cells[p.index].apiCell.metadata})):p.kind===L.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this._changeCellInternalMetadata(p.index,p.internalMetadata),o.push({cell:this._cells[p.index].apiCell,executionSummary:this._cells[p.index].apiCell.executionSummary}));const m=new Map;for(let p=0;p<o.length;p++){const u=o[p],i=m.get(u.cell);if(i===void 0){const a=S.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...u});m.set(u.cell,a-1)}else S.cellChanges[i]={...S.cellChanges[i],...u}}return Object.freeze(S),Object.freeze(S.cellChanges),Object.freeze(S.contentChanges),S}_validateIndex(_){return _=_|0,_<0?0:_>=this._cells.length?this._cells.length-1:_}_validateRange(_){let f=_.start|0,T=_.end|0;return f<0&&(f=0),T>this._cells.length&&(T=this._cells.length),_.with({start:f,end:T})}_getCells(_){_=this._validateRange(_);const f=[];for(let T=_.start;T<_.end;T++)f.push(this._cells[T]);return f}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(_,f,T){if(this._disposed)return;const S=[],o=[],m=[];if(_.reverse().forEach(p=>{const i=p[2].map(n=>{const r=new v(this,this._textDocumentsAndEditors,n);return f||o.push(v.asModelAddData(n)),r}),a=new R(p[0],p[1],[],i),t=this._cells.splice(p[0],p[1],...i);for(const n of t)m.push(n.uri),a.deletedItems.push(n.apiCell);S.push(a)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:o,removedDocuments:m}),T)for(const p of S)T.push(p.asApiEvent())}_moveCells(_,f,T,S){const o=this._cells.splice(_,f);this._cells.splice(T,0,...o);const m=[new R(_,f,o.map(p=>p.apiCell),[]),new R(T,0,[],o)];for(const p of m)S.push(p.asApiEvent())}_setCellOutputs(_,f){this._cells[_].setOutputs(f)}_setCellOutputItems(_,f,T,S){this._cells[_].setOutputItems(f,T,S)}_changeCellLanguage(_,f){const T=this._cells[_];T.apiCell.document.languageId!==f&&this._textDocuments.$acceptModelLanguageChanged(T.uri,f)}_changeCellMime(_,f){const T=this._cells[_];T.apiCell.mime=f}_changeCellMetadata(_,f){this._cells[_].setMetadata(f)}_changeCellInternalMetadata(_,f){this._cells[_].setInternalMetadata(f)}getCellFromApiCell(_){return this._cells.find(f=>f.apiCell===_)}getCellFromIndex(_){return this._cells[_]}getCell(_){return this._cells.find(f=>f.handle===_)}getCellIndex(_){return this._cells.indexOf(_)}}e.ExtHostNotebookDocument=l}),define(Pe[310],ke([1,0,4,2,15,9,53]),function(ge,e,s,h,D,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocumentSaveParticipant=void 0;class R{constructor(l,C,_,f={timeout:1500,errors:3}){this._logService=l,this._notebooksAndEditors=C,this._mainThreadBulkEdits=_,this._thresholds=f,this._onWillSaveNotebookDocumentEvent=new s.AsyncEmitter}dispose(){}getOnWillSaveNotebookDocumentEvent(l){return(C,_,f)=>{const T=function(o){C.call(_,o)};return T.extension=l,this._onWillSaveNotebookDocumentEvent.event(T,void 0,f)}}async $participateInSave(l,C,_){const f=h.URI.revive(l),T=this._notebooksAndEditors.getNotebookDocument(f);if(!T)throw new Error("Unable to resolve notebook document");const S=[];if(await this._onWillSaveNotebookDocumentEvent.fireAsync({notebook:T.apiNotebook,reason:D.TextDocumentSaveReason.to(C)},_,async(m,p)=>{const u=Date.now(),i=await await Promise.resolve(m);Date.now()-u>this._thresholds.timeout&&this._logService.warn("onWillSaveNotebookDocument-listener from extension",p.extension.identifier),!_.isCancellationRequested&&i&&(i instanceof A.WorkspaceEdit?S.push(i):this._logService.warn("onWillSaveNotebookDocument-listener from extension",p.extension.identifier,"ignored due to invalid data"))}),_.isCancellationRequested)return!1;if(S.length===0)return!0;const o={edits:[]};for(const m of S){const{edits:p}=D.WorkspaceEdit.from(m);o.edits=o.edits.concat(p)}return this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(new L.SerializableObjectWithBuffers(o))}}e.ExtHostNotebookDocumentSaveParticipant=R}),define(Pe[170],ke([1,0,12,15,9]),function(ge,e,s,h,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0,h=We(h),D=We(D);class A{static{this.apiEditorsToExtHost=new WeakMap}constructor(R,v,l,C,_,f){this.id=R,this._proxy=v,this.notebookData=l,this._selections=[],this._visibleRanges=[],this._visible=!1,this._selections=_,this._visibleRanges=C,this._viewColumn=f}get apiEditor(){if(!this._editor){const R=this;this._editor={get notebook(){return R.notebookData.apiNotebook},get selection(){return R._selections[0]},set selection(v){this.selections=[v]},get selections(){return R._selections},set selections(v){if(!Array.isArray(v)||!v.every(D.NotebookRange.isNotebookRange))throw(0,s.illegalArgument)("selections");R._selections=v,R._trySetSelections(v)},get visibleRanges(){return R._visibleRanges},revealRange(v,l){R._proxy.$tryRevealRange(R.id,h.NotebookRange.from(v),l??D.NotebookEditorRevealType.Default)},get viewColumn(){return R._viewColumn},[Symbol.for("debug.description")](){return`NotebookEditor(${this.notebook.uri.toString()})`}},A.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(R){this._visible=R}_acceptVisibleRanges(R){this._visibleRanges=R}_acceptSelections(R){this._selections=R}_trySetSelections(R){this._proxy.$trySetSelections(this.id,R.map(h.NotebookRange.from))}_acceptViewColumn(R){this._viewColumn=R}}e.ExtHostNotebookEditor=A}),define(Pe[311],ke([1,0,4,11,15]),function(ge,e,s,h,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0,D=We(D);let A=class{constructor(R,v){this._logService=R,this._notebooksAndEditors=v,this._onDidChangeNotebookEditorSelection=new s.Emitter,this._onDidChangeNotebookEditorVisibleRanges=new s.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event}$acceptEditorPropertiesChanged(R,v){this._logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",R,v);const l=this._notebooksAndEditors.getEditorById(R);v.visibleRanges&&l._acceptVisibleRanges(v.visibleRanges.ranges.map(D.NotebookRange.to)),v.selections&&l._acceptSelections(v.selections.selections.map(D.NotebookRange.to)),v.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:l.apiEditor,visibleRanges:l.apiEditor.visibleRanges}),v.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:l.apiEditor,selections:l.apiEditor.selections}))}$acceptEditorViewColumns(R){for(const v in R)this._notebooksAndEditors.getEditorById(v)._acceptViewColumn(D.ViewColumn.to(R[v]))}};e.ExtHostNotebookEditors=A,e.ExtHostNotebookEditors=A=Qe([$e(0,h.ILogService)],A)}),define(Pe[312],ke([1,0,4,6,170]),function(ge,e,s,h,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class A{constructor(R,v){this._extHostNotebook=v,this._rendererMessageEmitters=new Map,this.proxy=R.getProxy(h.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(R,v,l){const C=this._extHostNotebook.getEditorById(R);this._rendererMessageEmitters.get(v)?.fire({editor:C.apiEditor,message:l})}createRendererMessaging(R,v){if(!R.contributes?.notebookRenderer?.some(C=>C.id===v))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${v})`);return{onDidReceiveMessage:(C,_,f)=>this.getOrCreateEmitterFor(v).event(C,_,f),postMessage:(C,_)=>{D.ExtHostNotebookEditor.apiEditorsToExtHost.has(C)&&([C,_]=[_,C]);const f=_&&D.ExtHostNotebookEditor.apiEditorsToExtHost.get(_);return this.proxy.$postMessage(f?.id,v,C)}}}getOrCreateEmitterFor(R){let v=this._rendererMessageEmitters.get(R);return v||(v=new s.Emitter({onDidRemoveLastListener:()=>{v?.dispose(),this._rendererMessageEmitters.delete(R)}}),this._rendererMessageEmitters.set(R,v),v)}}e.ExtHostNotebookRenderers=A}),define(Pe[313],ke([1,0,15,90,20,60,12]),function(ge,e,s,h,D,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class R{constructor(_){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=_}async withProgress(_,f,T){const S=this._handles++,{title:o,location:m,cancellable:p}=f,u={label:_.displayName||_.name,id:_.identifier.value};return this._proxy.$startProgress(S,{location:s.ProgressLocation.from(m),title:o,source:u,cancellable:p},_.isUnderDevelopment?void 0:_.identifier.value).catch(L.onUnexpectedExternalError),this._withProgress(S,T,!!p)}_withProgress(_,f,T){let S;T&&(S=new D.CancellationTokenSource,this._mapHandleToCancellationSource.set(_,S));const o=p=>{this._proxy.$progressEnd(p),this._mapHandleToCancellationSource.delete(p),S?.dispose()};let m;try{m=f(new l(this._proxy,_),T&&S?S.token:D.CancellationToken.None)}catch(p){throw o(_),p}return m.then(p=>o(_),p=>o(_)),m}$acceptProgressCanceled(_){const f=this._mapHandleToCancellationSource.get(_);f&&(f.cancel(),this._mapHandleToCancellationSource.delete(_))}}e.ExtHostProgress=R;function v(C,_){return C.message=_.message,typeof _.increment=="number"&&(typeof C.increment=="number"?C.increment+=_.increment:C.increment=_.increment),C}class l extends h.Progress{constructor(_,f){super(T=>this.throttledReport(T)),this._proxy=_,this._handle=f}throttledReport(_){this._proxy.$progressReport(this._handle,_)}}Qe([(0,A.throttle)(100,(C,_)=>v(C,_),()=>Object.create(null))],l.prototype,"throttledReport",null)}),define(Pe[314],ke([1,0,2,6,8,15]),function(ge,e,s,h,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostQuickDiff=void 0;class L{static{this.handlePool=0}constructor(v,l){this.uriTransformer=l,this.providers=new Map,this.proxy=v.getProxy(h.MainContext.MainThreadQuickDiff)}$provideOriginalResource(v,l,C){const _=s.URI.revive(l),f=this.providers.get(v);return f?(0,D.asPromise)(()=>f.provideOriginalResource(_,C)).then(T=>T||null):Promise.resolve(null)}registerQuickDiffProvider(v,l,C,_){const f=L.handlePool++;return this.providers.set(f,l),this.proxy.$registerQuickDiffProvider(f,A.DocumentSelector.from(v,this.uriTransformer),C,_),{dispose:()=>{this.proxy.$unregisterQuickDiffProvider(f),this.providers.delete(f)}}}}e.ExtHostQuickDiff=L});var Vt=this&&this.__importDefault||function(ge){return ge&&ge.__esModule?ge:{default:ge}};define(Pe[315],ke([1,0,20,4,3,6,2,9,12,18,44,51,25,15]),function(ge,e,s,h,D,A,L,R,v,l,C,_,f,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=S,C=Vt(C);function S(o,m,p){const u=o.getProxy(A.MainContext.MainThreadQuickOpen);class i{constructor(y,I){this._sessions=new Map,this._instances=0,this._workspace=y,this._commands=I}showQuickPick(y,I,P,k=s.CancellationToken.None){this._onDidSelectItem=void 0;const b=Promise.resolve(I),E=++this._instances,N=u.$show(E,{title:P?.title,placeHolder:P?.placeHolder,matchOnDescription:P?.matchOnDescription,matchOnDetail:P?.matchOnDetail,ignoreFocusLost:P?.ignoreFocusOut,canPickMany:P?.canPickMany},k),O={},M=N.then(()=>O);return Promise.race([M,b]).then(U=>{if(U===O)return;const H=(0,f.isProposedApiEnabled)(y,"quickPickItemTooltip");return b.then(F=>{const x=[];for(let $=0;$<F.length;$++){const G=F[$];if(typeof G=="string")x.push({label:G,handle:$});else if(G.kind===R.QuickPickItemKind.Separator)x.push({type:"separator",label:G.label});else{G.tooltip&&!H&&console.warn(`Extension '${y.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${y.identifier.value}`);const B=G.iconPath?d(G.iconPath):void 0;x.push({label:G.label,iconPath:B?.iconPath,iconClass:B?.iconClass,description:G.description,detail:G.detail,picked:G.picked,alwaysShow:G.alwaysShow,tooltip:H?T.MarkdownString.fromStrict(G.tooltip):void 0,handle:$})}}return P&&typeof P.onDidSelectItem=="function"&&(this._onDidSelectItem=$=>{P.onDidSelectItem(F[$])}),u.$setItems(E,x),N.then($=>{if(typeof $=="number")return F[$];if(Array.isArray($))return $.map(G=>F[G])})})}).then(void 0,U=>{if(!(0,v.isCancellationError)(U))return u.$setError(E,U),Promise.reject(U)})}$onItemSelected(y){this._onDidSelectItem?.(y)}showInput(y,I=s.CancellationToken.None){return this._validateInput=y?.validateInput,u.$input(y,typeof this._validateInput=="function",I).then(void 0,P=>{if(!(0,v.isCancellationError)(P))return Promise.reject(P)})}async $validateInput(y){if(!this._validateInput)return;const I=await this._validateInput(y);if(!I||typeof I=="string")return I;let P;switch(I.severity){case R.InputBoxValidationSeverity.Info:P=C.default.Info;break;case R.InputBoxValidationSeverity.Warning:P=C.default.Warning;break;case R.InputBoxValidationSeverity.Error:P=C.default.Error;break;default:P=I.message?C.default.Error:C.default.Ignore;break}return{content:I.message,severity:P}}async showWorkspaceFolderPick(y,I=s.CancellationToken.None){const P=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[y]);if(!P)return;const k=await this._workspace.getWorkspaceFolders2();if(k)return k.find(b=>b.uri.toString()===P.uri.toString())}createQuickPick(y){const I=new c(y,()=>this._sessions.delete(I._id));return this._sessions.set(I._id,I),I}createInputBox(y){const I=new g(y,()=>this._sessions.delete(I._id));return this._sessions.set(I._id,I),I}$onDidChangeValue(y,I){this._sessions.get(y)?._fireDidChangeValue(I)}$onDidAccept(y){this._sessions.get(y)?._fireDidAccept()}$onDidChangeActive(y,I){const P=this._sessions.get(y);P instanceof c&&P._fireDidChangeActive(I)}$onDidChangeSelection(y,I){const P=this._sessions.get(y);P instanceof c&&P._fireDidChangeSelection(I)}$onDidTriggerButton(y,I){this._sessions.get(y)?._fireDidTriggerButton(I)}$onDidTriggerItemButton(y,I,P){const k=this._sessions.get(y);k instanceof c&&k._fireDidTriggerItemButton(I,P)}$onDidHide(y){this._sessions.get(y)?._fireDidHide()}}class a{static{this._nextId=1}constructor(y,I){this._extension=y,this._onDidDispose=I,this._id=c._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new h.Emitter,this._onDidChangeValueEmitter=new h.Emitter,this._onDidTriggerButtonEmitter=new h.Emitter,this._onDidHideEmitter=new h.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(y){this._title=y,this.update({title:y})}get step(){return this._steps}set step(y){this._steps=y,this.update({step:y})}get totalSteps(){return this._totalSteps}set totalSteps(y){this._totalSteps=y,this.update({totalSteps:y})}get enabled(){return this._enabled}set enabled(y){this._enabled=y,this.update({enabled:y})}get busy(){return this._busy}set busy(y){this._busy=y,this.update({busy:y})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(y){this._ignoreFocusOut=y,this.update({ignoreFocusOut:y})}get value(){return this._value}set value(y){this._value=y,this.update({value:y})}get placeholder(){return this._placeholder}set placeholder(y){this._placeholder=y,this.update({placeholder:y})}get buttons(){return this._buttons}set buttons(y){const I=(0,f.isProposedApiEnabled)(this._extension,"quickInputButtonLocation");!I&&y.some(P=>P.location)&&console.warn(`Extension '${this._extension.identifier.value}' uses a button location which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this._extension.identifier.value}`),this._buttons=y.slice(),this._handlesToButtons.clear(),y.forEach((P,k)=>{const b=P===R.QuickInputButtons.Back?-1:k;this._handlesToButtons.set(b,P)}),this.update({buttons:y.map((P,k)=>({...d(P.iconPath),tooltip:P.tooltip,handle:P===R.QuickInputButtons.Back?-1:k,location:I?P.location:void 0}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(y){this._value=y,this._onDidChangeValueEmitter.fire(y)}_fireDidTriggerButton(y){const I=this._handlesToButtons.get(y);I&&this._onDidTriggerButtonEmitter.fire(I)}_fireDidHide(){this._expectingHide&&(this._expectingHide=this._visible,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,D.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),u.$dispose(this._id))}update(y){if(!this._disposed){for(const I of Object.keys(y)){const P=y[I];this._pendingUpdate[I]=P===void 0?null:P}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){u.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}function t(w){if(w instanceof R.ThemeIcon)return{id:w.id};const y=r(w),I=n(w);return{dark:typeof y=="string"?L.URI.file(y):y,light:typeof I=="string"?L.URI.file(I):I}}function n(w){return typeof w=="object"&&"light"in w?w.light:w}function r(w){return typeof w=="object"&&"dark"in w?w.dark:w}function d(w){const y=t(w);let I,P;return"id"in y?P=_.ThemeIcon.asClassName(y):I=y,{iconPath:I,iconClass:P}}class c extends a{constructor(y,I){super(y,I),this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._keepScrollPosition=!1,this._activeItems=[],this._onDidChangeActiveEmitter=new h.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new h.Emitter,this._onDidTriggerItemButtonEmitter=new h.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this.onDidTriggerItemButton=this._onDidTriggerItemButtonEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter,this._onDidTriggerItemButtonEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(y){this._items=y.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),y.forEach((k,b)=>{this._handlesToItems.set(b,k),this._itemsToHandles.set(k,b)});const I=(0,f.isProposedApiEnabled)(this._extension,"quickPickItemTooltip"),P=[];for(let k=0;k<y.length;k++){const b=y[k];if(b.kind===R.QuickPickItemKind.Separator)P.push({type:"separator",label:b.label});else{b.tooltip&&!I&&console.warn(`Extension '${this._extension.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this._extension.identifier.value}`);const E=b.iconPath?d(b.iconPath):void 0;P.push({handle:k,label:b.label,iconPath:E?.iconPath,iconClass:E?.iconClass,description:b.description,detail:b.detail,picked:b.picked,alwaysShow:b.alwaysShow,tooltip:I?T.MarkdownString.fromStrict(b.tooltip):void 0,buttons:b.buttons?.map((N,O)=>({...d(N.iconPath),tooltip:N.tooltip,handle:O}))})}}this.update({items:P})}get canSelectMany(){return this._canSelectMany}set canSelectMany(y){this._canSelectMany=y,this.update({canSelectMany:y})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(y){this._matchOnDescription=y,this.update({matchOnDescription:y})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(y){this._matchOnDetail=y,this.update({matchOnDetail:y})}get sortByLabel(){return this._sortByLabel}set sortByLabel(y){this._sortByLabel=y,this.update({sortByLabel:y})}get keepScrollPosition(){return this._keepScrollPosition}set keepScrollPosition(y){this._keepScrollPosition=y,this.update({keepScrollPosition:y})}get activeItems(){return this._activeItems}set activeItems(y){this._activeItems=y.filter(I=>this._itemsToHandles.has(I)),this.update({activeItems:this._activeItems.map(I=>this._itemsToHandles.get(I))})}get selectedItems(){return this._selectedItems}set selectedItems(y){this._selectedItems=y.filter(I=>this._itemsToHandles.has(I)),this.update({selectedItems:this._selectedItems.map(I=>this._itemsToHandles.get(I))})}_fireDidChangeActive(y){const I=(0,l.coalesce)(y.map(P=>this._handlesToItems.get(P)));this._activeItems=I,this._onDidChangeActiveEmitter.fire(I)}_fireDidChangeSelection(y){const I=(0,l.coalesce)(y.map(P=>this._handlesToItems.get(P)));this._selectedItems=I,this._onDidChangeSelectionEmitter.fire(I)}_fireDidTriggerItemButton(y,I){const P=this._handlesToItems.get(y);if(!P||!P.buttons||!P.buttons.length)return;const k=P.buttons[I];k&&this._onDidTriggerItemButtonEmitter.fire({button:k,item:P})}}class g extends a{constructor(y,I){super(y,I),this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(y){this._password=y,this.update({password:y})}get prompt(){return this._prompt}set prompt(y){this._prompt=y,this.update({prompt:y})}get valueSelection(){return this._valueSelection}set valueSelection(y){this._valueSelection=y,this.update({valueSelection:y})}get validationMessage(){return this._validationMessage}set validationMessage(y){this._validationMessage=y,y?typeof y=="string"?this.update({validationMessage:y,severity:C.default.Error}):this.update({validationMessage:y.message,severity:y.severity??C.default.Error}):this.update({validationMessage:void 0,severity:C.default.Ignore})}}return new i(m,p)}}),define(Pe[316],ke([1,0,2,4,60,3,8,6,18,142,11,23,41,51,15,25,14,10]),function(ge,e,s,h,D,A,L,R,v,l,C,_,f,T,S,o,m,p){"use strict";var u;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function i(O){return O instanceof s.URI}function a(O,M){return O.scheme===m.Schemas.file&&M.scheme===m.Schemas.file&&p.isLinux?O.toString()===M.toString():O.toString().toLowerCase()===M.toString().toLowerCase()}function t(O){if(O)return typeof O.iconPath=="string"?s.URI.file(O.iconPath):s.URI.isUri(O.iconPath)||T.ThemeIcon.isThemeIcon(O.iconPath)?O.iconPath:void 0}function n(O){if(O){if(s.URI.isUri(O))return O;if(T.ThemeIcon.isThemeIcon(O))return O;{const M=O;return{light:M.light,dark:M.dark}}}else return}function r(O){const M=n(O.icon),U=O.labels?.map(H=>({title:H.title,icon:n(H.icon)}));return{...O,icon:M,labels:U}}function d(O,M){if(!O.iconPath&&!M.iconPath)return 0;if(O.iconPath){if(!M.iconPath)return 1}else return-1;const U=typeof O.iconPath=="string"?O.iconPath:s.URI.isUri(O.iconPath)?O.iconPath.fsPath:O.iconPath.id,H=typeof M.iconPath=="string"?M.iconPath:s.URI.isUri(M.iconPath)?M.iconPath.fsPath:M.iconPath.id;return(0,l.comparePaths)(U,H)}function c(O,M){let U=0;if(O.strikeThrough!==M.strikeThrough)return O.strikeThrough?1:-1;if(O.faded!==M.faded)return O.faded?1:-1;if(O.tooltip!==M.tooltip)return(O.tooltip||"").localeCompare(M.tooltip||"");if(U=d(O,M),U!==0)return U;if(O.light&&M.light)U=d(O.light,M.light);else{if(O.light)return 1;if(M.light)return-1}if(U!==0)return U;if(O.dark&&M.dark)U=d(O.dark,M.dark);else{if(O.dark)return 1;if(M.dark)return-1}return U}function g(O,M){if(O.command!==M.command)return O.command<M.command?-1:1;if(O.title!==M.title)return O.title<M.title?-1:1;if(O.tooltip!==M.tooltip){if(O.tooltip!==void 0&&M.tooltip!==void 0)return O.tooltip<M.tooltip?-1:1;if(O.tooltip!==void 0)return 1;if(M.tooltip!==void 0)return-1}if(O.arguments===M.arguments)return 0;if(O.arguments)if(M.arguments){if(O.arguments.length!==M.arguments.length)return O.arguments.length-M.arguments.length}else return 1;else return-1;for(let U=0;U<O.arguments.length;U++){const H=O.arguments[U],F=M.arguments[U];if(H!==F&&!(i(H)&&i(F)&&a(H,F)))return H<F?-1:1}return 0}function w(O,M){let U=(0,l.comparePaths)(O.resourceUri.fsPath,M.resourceUri.fsPath,!0);if(U!==0)return U;if(O.command&&M.command)U=g(O.command,M.command);else{if(O.command)return 1;if(M.command)return-1}if(U!==0)return U;if(O.decorations&&M.decorations)U=c(O.decorations,M.decorations);else{if(O.decorations)return 1;if(M.decorations)return-1}if(O.multiFileDiffEditorModifiedUri&&M.multiFileDiffEditorModifiedUri)U=(0,l.comparePaths)(O.multiFileDiffEditorModifiedUri.fsPath,M.multiFileDiffEditorModifiedUri.fsPath,!0);else{if(O.multiFileDiffEditorModifiedUri)return 1;if(M.multiFileDiffEditorModifiedUri)return-1}if(O.multiDiffEditorOriginalUri&&M.multiDiffEditorOriginalUri)U=(0,l.comparePaths)(O.multiDiffEditorOriginalUri.fsPath,M.multiDiffEditorOriginalUri.fsPath,!0);else{if(O.multiDiffEditorOriginalUri)return 1;if(M.multiDiffEditorOriginalUri)return-1}return U}function y(O,M){for(let U=0;U<O.length;U++)if(O[U]!==M[U])return!1;return!0}function I(O,M){return O.command===M.command&&O.title===M.title&&O.tooltip===M.tooltip&&(O.arguments&&M.arguments?y(O.arguments,M.arguments):O.arguments===M.arguments)}function P(O,M){return(0,v.equals)(O,M,I)}class k{#e;#t;get value(){return this._value}set value(M){M=M??"",this.#e.$setInputBoxValue(this._sourceControlHandle,M),this.updateValue(M)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(M){this.#e.$setInputBoxPlaceholder(this._sourceControlHandle,M),this._placeholder=M}get validateInput(){return(0,o.checkProposedApiEnabled)(this._extension,"scmValidation"),this._validateInput}set validateInput(M){if((0,o.checkProposedApiEnabled)(this._extension,"scmValidation"),M&&typeof M!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=M,this.#e.$setValidationProviderIsEnabled(this._sourceControlHandle,!!M)}get enabled(){return this._enabled}set enabled(M){M=!!M,this._enabled!==M&&(this._enabled=M,this.#e.$setInputBoxEnablement(this._sourceControlHandle,M))}get visible(){return this._visible}set visible(M){M=!!M,this._visible!==M&&(this._visible=M,this.#e.$setInputBoxVisibility(this._sourceControlHandle,M))}get document(){return(0,o.checkProposedApiEnabled)(this._extension,"scmTextDocument"),this.#t.getDocument(this._documentUri)}constructor(M,U,H,F,x){this._extension=M,this._sourceControlHandle=F,this._documentUri=x,this._value="",this._onDidChange=new h.Emitter,this._placeholder="",this._enabled=!0,this._visible=!0,this.#t=U,this.#e=H}showValidationMessage(M,U){(0,o.checkProposedApiEnabled)(this._extension,"scmValidation"),this.#e.$showValidationMessage(this._sourceControlHandle,M,U)}$onInputBoxValueChange(M){this.updateValue(M)}updateValue(M){this._value=M,this._onDidChange.fire(M)}}e.ExtHostSCMInputBox=k;class b{static{this._handlePool=0}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(M){this._label=M,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,M)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(M){this._hideWhenEmpty=M,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(M){this._resourceStates=[...M],this._onDidUpdateResourceStates.fire()}constructor(M,U,H,F,x,$,G){this._proxy=M,this._commands=U,this._sourceControlHandle=H,this._id=F,this._label=x,this.multiDiffEditorEnableViewChanges=$,this._extension=G,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new h.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new h.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=b._handlePool++}getResourceState(M){return this._resourceStatesMap.get(M)}$executeResourceCommand(M,U){const H=this._resourceStatesCommandsMap.get(M);return H?(0,L.asPromise)(()=>this._commands.executeCommand(H.command,...H.arguments||[],U)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const M=[...this._resourceStates].sort(w),H=(0,v.sortedDiff)(this._resourceSnapshot,M,w).map($=>{const G=$.toInsert.map(B=>{const W=this._resourceHandlePool++;this._resourceStatesMap.set(W,B);const Z=B.resourceUri;let J;if(B.command)if(B.command.command==="vscode.open"||B.command.command==="vscode.diff"||B.command.command==="vscode.changes"){const Re=new A.DisposableStore;J=this._commands.converter.toInternal(B.command,Re),this._resourceStatesDisposablesMap.set(W,Re)}else this._resourceStatesCommandsMap.set(W,B.command);const oe=(0,o.isProposedApiEnabled)(this._extension,"scmMultiDiffEditor"),te=oe?B.multiDiffEditorOriginalUri:void 0,me=oe?B.multiFileDiffEditorModifiedUri:void 0,le=t(B.decorations),Q=B.decorations&&t(B.decorations.light)||le,z=B.decorations&&t(B.decorations.dark)||le,se=[Q,z],Ee=B.decorations&&B.decorations.tooltip||"",ae=B.decorations&&!!B.decorations.strikeThrough,be=B.decorations&&!!B.decorations.faded,pe=B.contextValue||"";return{rawResource:[W,Z,se,Ee,ae,be,pe,J,te,me],handle:W}});return{start:$.start,deleteCount:$.deleteCount,toInsert:G}}),F=H.map(({start:$,deleteCount:G,toInsert:B})=>[$,G,B.map(W=>W.rawResource)]),x=H.reverse();for(const{start:$,deleteCount:G,toInsert:B}of x){const W=B.map(J=>J.handle),Z=this._handlesSnapshot.splice($,G,...W);for(const J of Z)this._resourceStatesMap.delete(J),this._resourceStatesCommandsMap.delete(J),this._resourceStatesDisposablesMap.get(J)?.dispose(),this._resourceStatesDisposablesMap.delete(J)}return this._resourceSnapshot=M,F}dispose(){this._disposed=!0,this._onDidDispose.fire()}}class E{static{this._handlePool=0}#e;get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(M){this._count!==M&&(this._count=M,this.#e.$updateSourceControl(this.handle,{count:M}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(M){this._quickDiffProvider=M;let U;(0,o.isProposedApiEnabled)(this._extension,"quickDiffProvider")&&(U=M?.label),this.#e.$updateSourceControl(this.handle,{hasQuickDiffProvider:!!M,quickDiffLabel:U})}get historyProvider(){return(0,o.checkProposedApiEnabled)(this._extension,"scmHistoryProvider"),this._historyProvider}set historyProvider(M){(0,o.checkProposedApiEnabled)(this._extension,"scmHistoryProvider"),this._historyProvider=M,this._historyProviderDisposable.value=new A.DisposableStore,this.#e.$updateSourceControl(this.handle,{hasHistoryProvider:!!M}),M&&this._historyProviderDisposable.value.add(M.onDidChangeCurrentHistoryItemGroup(()=>{this._historyProviderCurrentHistoryItemGroup=M?.currentHistoryItemGroup,this.#e.$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.handle,this._historyProviderCurrentHistoryItemGroup)}))}get commitTemplate(){return this._commitTemplate}set commitTemplate(M){M!==this._commitTemplate&&(this._commitTemplate=M,this.#e.$updateSourceControl(this.handle,{commitTemplate:M}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(M){this._acceptInputDisposables.value=new A.DisposableStore,this._acceptInputCommand=M;const U=this._commands.converter.toInternal(M,this._acceptInputDisposables.value);this.#e.$updateSourceControl(this.handle,{acceptInputCommand:U})}get actionButton(){return(0,o.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButton}set actionButton(M){(0,o.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButtonDisposables.value=new A.DisposableStore,this._actionButton=M;const U=M!==void 0?{command:this._commands.converter.toInternal(M.command,this._actionButtonDisposables.value),secondaryCommands:M.secondaryCommands?.map(H=>H.map(F=>this._commands.converter.toInternal(F,this._actionButtonDisposables.value))),description:M.description,enabled:M.enabled}:void 0;this.#e.$updateSourceControl(this.handle,{actionButton:U??null})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(M){if(this._statusBarCommands&&M&&P(this._statusBarCommands,M))return;this._statusBarDisposables.value=new A.DisposableStore,this._statusBarCommands=M;const U=(M||[]).map(H=>this._commands.converter.toInternal(H,this._statusBarDisposables.value));this.#e.$updateSourceControl(this.handle,{statusBarCommands:U})}get selected(){return this._selected}constructor(M,U,H,F,x,$,G){this._extension=M,this._commands=F,this._id=x,this._label=$,this._rootUri=G,this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._historyProviderDisposable=new A.MutableDisposable,this._commitTemplate=void 0,this._acceptInputDisposables=new A.MutableDisposable,this._acceptInputCommand=void 0,this._actionButtonDisposables=new A.MutableDisposable,this._statusBarDisposables=new A.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new h.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=E._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,this.#e=H;const B=s.URI.from({scheme:m.Schemas.vscodeSourceControl,path:`${x}/scm${this.handle}/input`,query:G?`rootUri=${encodeURIComponent(G.toString())}`:void 0});this._inputBox=new k(M,U,this.#e,this.handle,B),this.#e.$registerSourceControl(this.handle,x,$,G,B)}createResourceGroup(M,U,H){const F=(0,o.isProposedApiEnabled)(this._extension,"scmMultiDiffEditor")&&H?.multiDiffEditorEnableViewChanges===!0,x=new b(this.#e,this._commands,this.handle,M,U,F,this._extension),$=h.Event.once(x.onDidDispose)(()=>this.createdResourceGroups.delete(x));return this.createdResourceGroups.set(x,$),this.eventuallyAddResourceGroups(),x}eventuallyAddResourceGroups(){const M=[],U=[];for(const[H,F]of this.createdResourceGroups){F.dispose();const x=H.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(H),this.eventuallyUpdateResourceStates()});h.Event.once(H.onDidDispose)(()=>{this.updatedResourceGroups.delete(H),x.dispose(),this._groups.delete(H.handle),this.#e.$unregisterGroup(this.handle,H.handle)}),M.push([H.handle,H.id,H.label,H.features,H.multiDiffEditorEnableViewChanges]);const $=H._takeResourceStateSnapshot();$.length>0&&U.push([H.handle,$]),this._groups.set(H.handle,H)}this.#e.$registerGroups(this.handle,M,U),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const M=[];this.updatedResourceGroups.forEach(U=>{const H=U._takeResourceStateSnapshot();H.length!==0&&M.push([U.handle,H])}),M.length>0&&this.#e.$spliceResourceStates(this.handle,M),this.updatedResourceGroups.clear()}getResourceGroup(M){return this._groups.get(M)}setSelectionState(M){this._selected=M,this._onDidChangeSelection.fire(M)}dispose(){this._acceptInputDisposables.dispose(),this._actionButtonDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(M=>M.dispose()),this.#e.$unregisterSourceControl(this.handle)}}Qe([(0,D.debounce)(100)],E.prototype,"eventuallyAddResourceGroups",null),Qe([(0,D.debounce)(100)],E.prototype,"eventuallyUpdateResourceStates",null);let N=class{static{u=this}static{this._handlePool=0}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}constructor(M,U,H,F){this._commands=U,this._extHostDocuments=H,this.logService=F,this._sourceControls=new Map,this._sourceControlsByExtension=new _.ExtensionIdentifierMap,this._onDidChangeActiveProvider=new h.Emitter,this._proxy=M.getProxy(R.MainContext.MainThreadSCM),this._telemetry=M.getProxy(R.MainContext.MainThreadTelemetry),U.registerArgumentProcessor({processArgument:x=>{if(x&&x.$mid===f.MarshalledId.ScmResource){const $=this._sourceControls.get(x.sourceControlHandle);if(!$)return x;const G=$.getResourceGroup(x.groupHandle);return G?G.getResourceState(x.handle):x}else if(x&&x.$mid===f.MarshalledId.ScmResourceGroup){const $=this._sourceControls.get(x.sourceControlHandle);return $?$.getResourceGroup(x.groupHandle):x}else if(x&&x.$mid===f.MarshalledId.ScmProvider){const $=this._sourceControls.get(x.handle);return $||x}return x}})}createSourceControl(M,U,H,F){this.logService.trace("ExtHostSCM#createSourceControl",M.identifier.value,U,H,F),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:M.identifier.value});const x=u._handlePool++,$=new E(M,this._extHostDocuments,this._proxy,this._commands,U,H,F);this._sourceControls.set(x,$);const G=this._sourceControlsByExtension.get(M.identifier)||[];return G.push($),this._sourceControlsByExtension.set(M.identifier,G),$}getLastInputBox(M){this.logService.trace("ExtHostSCM#getLastInputBox",M.identifier.value);const U=this._sourceControlsByExtension.get(M.identifier),H=U&&U[U.length-1];return H&&H.inputBox}$provideOriginalResource(M,U,H){const F=s.URI.revive(U);this.logService.trace("ExtHostSCM#$provideOriginalResource",M,F.toString());const x=this._sourceControls.get(M);return!x||!x.quickDiffProvider||!x.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,L.asPromise)(()=>x.quickDiffProvider.provideOriginalResource(F,H)).then($=>$||null)}$onInputBoxValueChange(M,U){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",M);const H=this._sourceControls.get(M);return H&&H.inputBox.$onInputBoxValueChange(U),Promise.resolve(void 0)}$executeResourceCommand(M,U,H,F){this.logService.trace("ExtHostSCM#$executeResourceCommand",M,U,H);const x=this._sourceControls.get(M);if(!x)return Promise.resolve(void 0);const $=x.getResourceGroup(U);return $?$.$executeResourceCommand(H,F):Promise.resolve(void 0)}$validateInput(M,U,H){this.logService.trace("ExtHostSCM#$validateInput",M);const F=this._sourceControls.get(M);return!F||!F.inputBox.validateInput?Promise.resolve(void 0):(0,L.asPromise)(()=>F.inputBox.validateInput(U,H)).then(x=>{if(!x)return Promise.resolve(void 0);const $=S.MarkdownString.fromStrict(x.message);return $?Promise.resolve([$,x.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(M){return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",M),M!==void 0&&this._sourceControls.get(M)?.setSelectionState(!0),this._selectedSourceControlHandle!==void 0&&this._sourceControls.get(this._selectedSourceControlHandle)?.setSelectionState(!1),this._selectedSourceControlHandle=M,Promise.resolve(void 0)}async $resolveHistoryItemGroupCommonAncestor(M,U,H,F){return await this._sourceControls.get(M)?.historyProvider?.resolveHistoryItemGroupCommonAncestor(U,H,F)??void 0}async $resolveHistoryItemGroupCommonAncestor2(M,U,H){return await this._sourceControls.get(M)?.historyProvider?.resolveHistoryItemGroupCommonAncestor2(U,H)??void 0}async $provideHistoryItems(M,U,H,F){return(await this._sourceControls.get(M)?.historyProvider?.provideHistoryItems(U,H,F))?.map(G=>r(G))??void 0}async $provideHistoryItems2(M,U,H){return(await this._sourceControls.get(M)?.historyProvider?.provideHistoryItems2(U,H))?.map($=>r($))??void 0}async $provideHistoryItemSummary(M,U,H,F){const x=this._sourceControls.get(M)?.historyProvider;if(typeof x?.provideHistoryItemSummary!="function")return;const $=await x.provideHistoryItemSummary(U,H,F);return $?r($):void 0}async $provideHistoryItemChanges(M,U,H,F){return await this._sourceControls.get(M)?.historyProvider?.provideHistoryItemChanges(U,H,F)??void 0}};e.ExtHostSCM=N,e.ExtHostSCM=N=u=Qe([$e(3,C.ILogService)],N)}),define(Pe[317],ke([1,0,6,15,2]),function(ge,e,s,h,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostShare=void 0;class A{static{this.handlePool=0}constructor(R,v){this.uriTransformer=v,this.providers=new Map,this.proxy=R.getProxy(s.MainContext.MainThreadShare)}async $provideShare(R,v,l){return await this.providers.get(R)?.provideShare({selection:h.Range.to(v.selection),resourceUri:D.URI.revive(v.resourceUri)},l)??void 0}registerShareProvider(R,v){const l=A.handlePool++;return this.providers.set(l,v),this.proxy.$registerShareProvider(l,h.DocumentSelector.from(R,this.uriTransformer),v.id,v.label,v.priority),{dispose:()=>{this.proxy.$unregisterShareProvider(l),this.providers.delete(l)}}}}e.ExtHostShare=A}),define(Pe[318],ke([1,0,9,6,7,3,15,17]),function(ge,e,s,h,D,A,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class v{static{this.ID_GEN=0}static{this.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new s.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new s.ThemeColor("statusBarItem.warningForeground")]])}#e;#t;constructor(f,T,S,o,m,p=s.StatusBarAlignment.Left,u){if(this._disposed=!1,this._text="",this._staleCommandRegistrations=new A.DisposableStore,this.#e=f,this.#t=T,m&&o){this._entryId=(0,s.asStatusBarItemIdentifier)(o.identifier,m);const i=S.get(this._entryId);i&&(p=i.alignLeft?s.StatusBarAlignment.Left:s.StatusBarAlignment.Right,u=i.priority,this._visible=!0,this.name=i.name,this.text=i.text,this.tooltip=i.tooltip,this.command=i.command,this.accessibilityInformation=i.accessibilityInformation)}else this._entryId=String(v.ID_GEN++);this._extension=o,this._id=m,this._alignment=p,this._priority=this.validatePriority(u)}validatePriority(f){if((0,R.isNumber)(f))return f===Number.POSITIVE_INFINITY?Number.MAX_VALUE:f===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:f}get id(){return this._id??this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){return this._command?.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(f){this._text=f,this.update()}set name(f){this._name=f,this.update()}set tooltip(f){this._tooltip=f,this.update()}set color(f){this._color=f,this.update()}set backgroundColor(f){f&&!v.ALLOWED_BACKGROUND_COLORS.has(f.id)&&(f=void 0),this._backgroundColor=f,this.update()}set command(f){this._command?.fromApi!==f&&(this._latestCommandRegistration&&this._staleCommandRegistrations.add(this._latestCommandRegistration),this._latestCommandRegistration=new A.DisposableStore,typeof f=="string"?this._command={fromApi:f,internal:this.#t.toInternal({title:"",command:f},this._latestCommandRegistration)}:f?this._command={fromApi:f,internal:this.#t.toInternal(f,this._latestCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(f){this._accessibilityInformation=f,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,this.#e.$disposeEntry(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{this._timeoutHandle=void 0;let f;this._extension?this._id?f=`${this._extension.identifier.value}.${this._id}`:f=this._extension.identifier.value:f=this._id;let T;this._name?T=this._name:T=(0,D.localize)(2711,null,this._extension.displayName||this._extension.name);let S=this._color;this._backgroundColor&&(S=v.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id));const o=L.MarkdownString.fromStrict(this._tooltip);this.#e.$setEntry(this._entryId,f,this._extension?.identifier.value,T,this._text,o,this._command?.internal,S,this._backgroundColor,this._alignment===s.StatusBarAlignment.Left,this._priority,this._accessibilityInformation),this._staleCommandRegistrations.clear()},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=v;class l{constructor(f){this._messages=[],this._item=f.createStatusBarEntry(void 0,"status.extensionMessage",s.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=(0,D.localize)(2712,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(f){const T={message:f};return this._messages.unshift(T),this._update(),new s.Disposable(()=>{const S=this._messages.indexOf(T);S>=0&&(this._messages.splice(S,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class C{constructor(f,T){this._existingItems=new Map,this._proxy=f.getProxy(h.MainContext.MainThreadStatusBar),this._commands=T,this._statusMessage=new l(this)}$acceptStaticEntries(f){for(const T of f)this._existingItems.set(T.entryId,T)}createStatusBarEntry(f,T,S,o){return new v(this._proxy,this._commands,this._existingItems,f,T,S,o)}setStatusBarMessage(f,T){const S=this._statusMessage.setMessage(f);let o;return typeof T=="number"?o=setTimeout(()=>S.dispose(),T):typeof T<"u"&&T.then(()=>S.dispose(),()=>S.dispose()),new s.Disposable(()=>{S.dispose(),clearTimeout(o)})}}e.ExtHostStatusBar=C}),define(Pe[171],ke([1,0,30,160,75,120,76,15,2]),function(ge,e,s,h,D,A,L,R,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTestItemCollection=e.TestItemRootImpl=e.TestItemImpl=e.toItemFromContext=void 0,s=We(s),R=We(R);const l=(i,a,t,n)=>{let r=a;return{enumerable:!0,configurable:!1,get(){return r},set(d){if(!t(r,d)){const c=r;r=d,i.listener?.(n(d,c))}}}},C=(i,a)=>i===a,_={range:(i,a)=>i===a?!0:!i||!a?!1:i.isEqual(a),label:C,description:C,sortText:C,busy:C,error:C,canResolveChildren:C,tags:(i,a)=>!(i.length!==a.length||i.some(t=>!a.find(n=>t.id===n.id)))},f=i=>a=>({op:A.TestItemEventOp.SetProp,update:i(a)}),T=(i,a)=>({range:(()=>{let t;const n=f(r=>({range:s.Range.lift(R.Range.from(r))}));return{enumerable:!0,configurable:!1,get(){return t},set(r){i.listener?.({op:A.TestItemEventOp.DocumentSynced}),_.range(t,r)||(t=r,i.listener?.(n(r)))}}})(),label:l(i,a,_.label,f(t=>({label:t}))),description:l(i,void 0,_.description,f(t=>({description:t}))),sortText:l(i,void 0,_.sortText,f(t=>({sortText:t}))),canResolveChildren:l(i,!1,_.canResolveChildren,t=>({op:A.TestItemEventOp.UpdateCanResolveChildren,state:t})),busy:l(i,!1,_.busy,f(t=>({busy:t}))),error:l(i,void 0,_.error,f(t=>({error:R.MarkdownString.fromStrict(t)||null}))),tags:l(i,[],_.tags,(t,n)=>({op:A.TestItemEventOp.SetTags,new:t.map(R.TestTag.from),old:n.map(R.TestTag.from)}))}),S=i=>{const a=D.TestId.fromString(i.extId),t=new m(a.controllerId,a.localId,i.label,v.URI.revive(i.uri)||void 0);return t.range=R.Range.to(i.range||void 0),t.description=i.description||void 0,t.sortText=i.sortText||void 0,t.tags=i.tags.map(n=>R.TestTag.to({id:(0,L.denamespaceTestTag)(n).tagId})),t},o=i=>{let a;for(const t of i.tests){const n=S(t.item);(0,h.getPrivateApiFor)(n).parent=a,a=n}return a};e.toItemFromContext=o;class m{constructor(a,t,n,r){if(t.includes(D.TestIdPathParts.Delimiter))throw new Error(`Test IDs may not include the ${JSON.stringify(t)} symbol`);const d=(0,h.createPrivateApiFor)(this,a);Object.defineProperties(this,{id:{value:t,enumerable:!0,writable:!1},uri:{value:r,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return d.parent instanceof p?void 0:d.parent}},children:{value:(0,A.createTestItemChildren)(d,h.getPrivateApiFor,m),enumerable:!0,writable:!1},...T(d,n)})}}e.TestItemImpl=m;class p extends m{constructor(a,t){super(a,a,t,void 0),this._isRoot=!0}}e.TestItemRootImpl=p;class u extends A.TestItemCollection{constructor(a,t,n){super({controllerId:a,getDocumentVersion:r=>r&&n.getDocument(r)?.version,getApiFor:h.getPrivateApiFor,getChildren:r=>r.children,root:new p(a,t),toITestItem:R.TestItem.from})}}e.ExtHostTestItemCollection=u}),define(Pe[35],ke([1,0,17,9,15,24,6,18,11,38,30,55,2,3,5,19,171,21,53,52,43,92,95,31]),function(ge,e,s,h,D,A,L,R,v,l,C,_,f,T,S,o,m,p,u,i,a,t,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0,h=We(h),D=We(D);let d=class{#e;#t;#i;constructor(P,k,b){this._commands=new Map,this._apiCommands=new Map,this.#e=P.getProxy(L.MainContext.MainThreadCommands),this._logService=k,this.#i=b,this.#t=P.getProxy(L.MainContext.MainThreadTelemetry),this.converter=new c(this,E=>{const N=this._apiCommands.get(E);return N?.result===w.Void?N:void 0},k),this._argumentProcessors=[{processArgument(E){return(0,l.revive)(E)}},{processArgument(E){return(0,A.cloneAndChange)(E,function(N){if(C.Range.isIRange(N))return D.Range.to(N);if(_.Position.isIPosition(N))return D.Position.to(N);if(C.Range.isIRange(N.range)&&f.URI.isUri(N.uri))return D.location.to(N);if(N instanceof p.VSBuffer)return N.buffer.buffer;if(!Array.isArray(N))return N})}}]}registerArgumentProcessor(P){this._argumentProcessors.push(P)}registerApiCommand(P){const k=this.registerCommand(!1,P.id,async(...b)=>{const E=P.args.map((O,M)=>{if(!O.validate(b[M]))throw new Error(`Invalid argument '${O.name}' when running '${P.id}', received: ${typeof b[M]=="object"?JSON.stringify(b[M],null,"	"):b[M]} `);return O.convert(b[M])}),N=await this.executeCommand(P.internalId,...E);return P.result.convert(N,b,this.converter)},void 0,{description:P.description,args:P.args,returns:P.result.description});return this._apiCommands.set(P.id,P),new h.Disposable(()=>{k.dispose(),this._apiCommands.delete(P.id)})}registerCommand(P,k,b,E,N,O){if(this._logService.trace("ExtHostCommands#registerCommand",k),!k.trim().length)throw new Error("invalid id");if(this._commands.has(k))throw new Error(`command '${k}' already exists`);return this._commands.set(k,{callback:b,thisArg:E,metadata:N,extension:O}),P&&this.#e.$registerCommand(k),new h.Disposable(()=>{this._commands.delete(k)&&P&&this.#e.$unregisterCommand(k)})}executeCommand(P,...k){return this._logService.trace("ExtHostCommands#executeCommand",P),this._doExecuteCommand(P,k,!0)}async _doExecuteCommand(P,k,b){if(this._commands.has(P))return this.#e.$fireCommandActivationEvent(P),this._executeContributedCommand(P,k,!1);{let E=!1;const N=(0,A.cloneAndChange)(k,function(O){if(O instanceof h.Position)return D.Position.from(O);if(O instanceof h.Range)return D.Range.from(O);if(O instanceof h.Location)return D.location.from(O);if(h.NotebookRange.isNotebookRange(O))return D.NotebookRange.from(O);if(O instanceof ArrayBuffer)return E=!0,p.VSBuffer.wrap(new Uint8Array(O));if(O instanceof Uint8Array)return E=!0,p.VSBuffer.wrap(O);if(O instanceof p.VSBuffer)return E=!0,O;if(!Array.isArray(O))return O});try{const O=await this.#e.$executeCommand(P,E?new u.SerializableObjectWithBuffers(N):N,b);return(0,l.revive)(O)}catch(O){if(O instanceof Error&&O.message==="$executeCommand:retry")return this._doExecuteCommand(P,k,!1);throw O}}}async _executeContributedCommand(P,k,b){const E=this._commands.get(P);if(!E)throw new Error("Unknown command");const{callback:N,thisArg:O,metadata:M}=E;if(M?.args)for(let H=0;H<M.args.length;H++)try{(0,s.validateConstraint)(k[H],M.args[H].constraint)}catch{throw new Error(`Running the contributed command: '${P}' failed. Illegal argument '${M.args[H].name}' - ${M.args[H].description}`)}const U=a.StopWatch.create();try{return await N.apply(O,k)}catch(H){if(P===this.converter.delegatingCommandId){const F=this.converter.getActualCommand(...k);F&&(P=F.command)}if(this._logService.error(H,P,E.extension?.identifier),!b)throw H;if(E.extension?.identifier){const F=this.#i.onExtensionError(E.extension.identifier,H);this._logService.trace("forwarded error to extension?",F,E.extension?.identifier)}throw new class extends Error{constructor(){super((0,i.toErrorMessage)(H)),this.id=P,this.source=E.extension?.displayName??E.extension?.name}}}finally{this._reportTelemetry(E,P,U.elapsed())}}_reportTelemetry(P,k,b){P.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:P.extension.identifier.value,id:new t.TelemetryTrustedValue(k),duration:b})}$executeContributedCommand(P,...k){this._logService.trace("ExtHostCommands#$executeContributedCommand",P);const b=this._commands.get(P);return b?(k=k.map(E=>this._argumentProcessors.reduce((N,O)=>O.processArgument(N,b.extension?.identifier),E)),this._executeContributedCommand(P,k,!0)):Promise.reject(new Error(`Contributed command '${P}' does not exist.`))}getCommands(P=!1){return this._logService.trace("ExtHostCommands#getCommands",P),this.#e.$getCommands().then(k=>(P&&(k=k.filter(b=>b[0]!=="_")),k))}$getContributedCommandMetadata(){const P=Object.create(null);for(const[k,b]of this._commands){const{metadata:E}=b;E&&(P[k]=E)}return Promise.resolve(P)}};e.ExtHostCommands=d,e.ExtHostCommands=d=Qe([$e(0,o.IExtHostRpcService),$e(1,v.ILogService),$e(2,n.IExtHostTelemetry)],d),e.IExtHostCommands=(0,S.createDecorator)("IExtHostCommands");class c{constructor(P,k,b){this._commands=P,this._lookupApiCommand=k,this._logService=b,this.delegatingCommandId=`__vsc${(0,r.generateUuid)()}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(P,k){if(!P)return;const b={$ident:void 0,id:P.command,title:P.title,tooltip:P.tooltip};if(!P.command)return b;const E=this._lookupApiCommand(P.command);if(E)b.id=E.internalId,b.arguments=E.args.map((N,O)=>N.convert(P.arguments&&P.arguments[O]));else if((0,R.isNonEmptyArray)(P.arguments)){const N=`${P.command} /${++this._cachIdPool}`;this._cache.set(N,P),k.add((0,T.toDisposable)(()=>{this._cache.delete(N),this._logService.trace("CommandsConverter#DISPOSE",N)})),b.$ident=N,b.id=this.delegatingCommandId,b.arguments=[N],this._logService.trace("CommandsConverter#CREATE",P.command,N)}return b}fromInternal(P){return typeof P.$ident=="string"?this._cache.get(P.$ident):{command:P.id,title:P.title,arguments:P.arguments}}getActualCommand(...P){return this._cache.get(P[0])}_executeConvertedCommand(...P){const k=this.getActualCommand(...P);return this._logService.trace("CommandsConverter#EXECUTE",P[0],k?k.command:"MISSING"),k?this._commands.executeCommand(k.command,...k.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${P[0]}`)}}e.CommandsConverter=c;class g{static{this.Uri=new g("uri","Uri of a text document",P=>f.URI.isUri(P),P=>P)}static{this.Position=new g("position","A position in a text document",P=>h.Position.isPosition(P),D.Position.from)}static{this.Range=new g("range","A range in a text document",P=>h.Range.isRange(P),D.Range.from)}static{this.Selection=new g("selection","A selection in a text document",P=>h.Selection.isSelection(P),D.Selection.from)}static{this.Number=new g("number","",P=>typeof P=="number",P=>P)}static{this.String=new g("string","",P=>typeof P=="string",P=>P)}static{this.StringArray=g.Arr(g.String)}static Arr(P){return new g(`${P.name}_array`,`Array of ${P.name}, ${P.description}`,k=>Array.isArray(k)&&k.every(b=>P.validate(b)),k=>k.map(b=>P.convert(b)))}static{this.CallHierarchyItem=new g("item","A call hierarchy item",P=>P instanceof h.CallHierarchyItem,D.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new g("item","A type hierarchy item",P=>P instanceof h.TypeHierarchyItem,D.TypeHierarchyItem.from)}static{this.TestItem=new g("testItem","A VSCodium TestItem",P=>P instanceof m.TestItemImpl,D.TestItem.from)}constructor(P,k,b,E){this.name=P,this.description=k,this.validate=b,this.convert=E}optional(){return new g(this.name,`(optional) ${this.description}`,P=>P==null||this.validate(P),P=>P===void 0?void 0:P===null?null:this.convert(P))}with(P,k){return new g(P??this.name,k??this.description,this.validate,this.convert)}}e.ApiCommandArgument=g;class w{static{this.Void=new w("no result",P=>P)}constructor(P,k){this.description=P,this.convert=k}}e.ApiCommandResult=w;class y{constructor(P,k,b,E,N){this.id=P,this.internalId=k,this.description=b,this.args=E,this.result=N}}e.ApiCommand=y}),define(Pe[319],ke([1,0,18,14,2,88,146,36,35,15,9]),function(ge,e,s,h,D,A,L,R,v,l,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0,A=We(A),l=We(l),C=We(C);const _=[new v.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Position],new v.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",T(l.DocumentHighlight.to))),new v.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[v.ApiCommandArgument.Uri],new v.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(o,m)=>{if((0,s.isFalsyOrEmpty)(o))return;class p extends C.SymbolInformation{static to(i){const a=new p(i.name,l.SymbolKind.to(i.kind),i.containerName||"",new C.Location(m[0],l.Range.to(i.range)));return a.detail=i.detail,a.range=a.location.range,a.selectionRange=l.Range.to(i.selectionRange),a.children=i.children?i.children.map(p.to):[],a}}return o.map(p.to)})),new v.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[v.ApiCommandArgument.Uri,new v.ApiCommandArgument("options","Formatting options",o=>!0,o=>o)],new v.ApiCommandResult("A promise that resolves to an array of TextEdits.",T(l.TextEdit.to))),new v.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Range,new v.ApiCommandArgument("options","Formatting options",o=>!0,o=>o)],new v.ApiCommandResult("A promise that resolves to an array of TextEdits.",T(l.TextEdit.to))),new v.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Position,new v.ApiCommandArgument("ch","Trigger character",o=>typeof o=="string",o=>o),new v.ApiCommandArgument("options","Formatting options",o=>!0,o=>o)],new v.ApiCommandResult("A promise that resolves to an array of TextEdits.",T(l.TextEdit.to))),new v.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Position],new v.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",S)),new v.ApiCommand("vscode.experimental.executeDefinitionProvider_recursive","_executeDefinitionProvider_recursive","Execute all definition providers.",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Position],new v.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",S)),new v.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Position],new v.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",S)),new v.ApiCommand("vscode.experimental.executeTypeDefinitionProvider_recursive","_executeTypeDefinitionProvider_recursive","Execute all type definition providers.",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Position],new v.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",S)),new v.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Position],new v.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",S)),new v.ApiCommand("vscode.experimental.executeDeclarationProvider_recursive","_executeDeclarationProvider_recursive","Execute all declaration providers.",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Position],new v.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",S)),new v.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Position],new v.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",S)),new v.ApiCommand("vscode.experimental.executeImplementationProvider_recursive","_executeImplementationProvider_recursive","Execute all implementation providers.",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Position],new v.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",S)),new v.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Position],new v.ApiCommandResult("A promise that resolves to an array of Location-instances.",T(l.location.to))),new v.ApiCommand("vscode.experimental.executeReferenceProvider","_executeReferenceProvider_recursive","Execute all reference providers.",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Position],new v.ApiCommandResult("A promise that resolves to an array of Location-instances.",T(l.location.to))),new v.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Position],new v.ApiCommandResult("A promise that resolves to an array of Hover-instances.",T(l.Hover.to))),new v.ApiCommand("vscode.experimental.executeHoverProvider_recursive","_executeHoverProvider_recursive","Execute all hover providers.",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Position],new v.ApiCommandResult("A promise that resolves to an array of Hover-instances.",T(l.Hover.to))),new v.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[v.ApiCommandArgument.Uri,new v.ApiCommandArgument("position","A position in a text document",o=>Array.isArray(o)&&o.every(m=>C.Position.isPosition(m)),o=>o.map(l.Position.from))],new v.ApiCommandResult("A promise that resolves to an array of ranges.",o=>o.map(m=>{let p;for(const u of m.reverse())p=new C.SelectionRange(l.Range.to(u),p);return p}))),new v.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[v.ApiCommandArgument.String.with("query","Search string")],new v.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",o=>o.map(l.WorkspaceSymbol.to))),new v.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Position],new v.ApiCommandResult("A promise that resolves to an array of CallHierarchyItem-instances",o=>o.map(l.CallHierarchyItem.to))),new v.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[v.ApiCommandArgument.CallHierarchyItem],new v.ApiCommandResult("A promise that resolves to an array of CallHierarchyIncomingCall-instances",o=>o.map(l.CallHierarchyIncomingCall.to))),new v.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[v.ApiCommandArgument.CallHierarchyItem],new v.ApiCommandResult("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",o=>o.map(l.CallHierarchyOutgoingCall.to))),new v.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Position],new v.ApiCommandResult("A promise that resolves to a range and placeholder text.",o=>{if(o)return{range:l.Range.to(o.range),placeholder:o.text}})),new v.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Position,v.ApiCommandArgument.String.with("newName","The new symbol name")],new v.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",o=>{if(o){if(o.rejectReason)throw new Error(o.rejectReason);return l.WorkspaceEdit.to(o)}})),new v.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new v.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",o=>o.map(l.DocumentLink.to))),new v.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[v.ApiCommandArgument.Uri],new v.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",o=>{if(o)return new C.SemanticTokensLegend(o.tokenTypes,o.tokenModifiers)})),new v.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[v.ApiCommandArgument.Uri],new v.ApiCommandResult("A promise that resolves to SemanticTokens.",o=>{if(!o)return;const m=(0,L.decodeSemanticTokensDto)(o);if(m.type==="full")return new C.SemanticTokens(m.data,void 0)})),new v.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Range.optional()],new v.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",o=>{if(o)return new C.SemanticTokensLegend(o.tokenTypes,o.tokenModifiers)})),new v.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Range],new v.ApiCommandResult("A promise that resolves to SemanticTokens.",o=>{if(!o)return;const m=(0,L.decodeSemanticTokensDto)(o);if(m.type==="full")return new C.SemanticTokens(m.data,void 0)})),new v.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Position,v.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),v.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new v.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(o,m,p)=>{if(!o)return new C.CompletionList([]);const u=o.suggestions.map(i=>l.CompletionItem.to(i,p));return new C.CompletionList(u,o.incomplete)})),new v.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Position,v.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new v.ApiCommandResult("A promise that resolves to SignatureHelp.",o=>{if(o)return l.SignatureHelp.to(o)})),new v.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new v.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(o,m,p)=>T(u=>new C.CodeLens(l.Range.to(u.range),u.command&&p.fromInternal(u.command)))(o))),new v.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[v.ApiCommandArgument.Uri,new v.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",o=>C.Range.isRange(o),o=>C.Selection.isSelection(o)?l.Selection.from(o):l.Range.from(o)),v.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),v.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new v.ApiCommandResult("A promise that resolves to an array of Command-instances.",(o,m,p)=>T(u=>{if(u._isSynthetic){if(!u.command)throw new Error("Synthetic code actions must have a command");return p.fromInternal(u.command)}else{const i=new C.CodeAction(u.title,u.kind?new C.CodeActionKind(u.kind):void 0);return u.edit&&(i.edit=l.WorkspaceEdit.to(u.edit)),u.command&&(i.command=p.fromInternal(u.command)),i.isPreferred=u.isPreferred,i}})(o))),new v.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[v.ApiCommandArgument.Uri],new v.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",o=>o?o.map(m=>new C.ColorInformation(l.Range.to(m.range),l.Color.to(m.color))):[])),new v.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new v.ApiCommandArgument("color","The color to show and insert",o=>o instanceof C.Color,l.Color.from),new v.ApiCommandArgument("context","Context object with uri and range",o=>!0,o=>({uri:o.uri,range:l.Range.from(o.range)}))],new v.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",o=>o?o.map(l.ColorPresentation.to):[])),new v.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Range],new v.ApiCommandResult("A promise that resolves to an array of Inlay objects",(o,m,p)=>o.map(l.InlayHint.to.bind(void 0,p)))),new v.ApiCommand("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[v.ApiCommandArgument.Uri],new v.ApiCommandResult("A promise that resolves to an array of FoldingRange objects",(o,m)=>{if(o)return o.map(l.FoldingRange.to)})),new v.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new v.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",T(o=>({viewType:o.viewType,displayName:o.displayName,options:{transientOutputs:o.options.transientOutputs,transientCellMetadata:o.options.transientCellMetadata,transientDocumentMetadata:o.options.transientDocumentMetadata},filenamePattern:o.filenamePattern.map(m=>l.NotebookExclusiveDocumentPattern.to(m))})))),new v.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Range,new v.ApiCommandArgument("context","An InlineValueContext",o=>o&&typeof o.frameId=="number"&&o.stoppedLocation instanceof C.Range,o=>l.InlineValueContext.from(o))],new v.ApiCommandResult("A promise that resolves to an array of InlineValue objects",o=>o.map(l.InlineValue.to))),new v.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new v.ApiCommandArgument("uriOrString","Uri-instance or string (only http/https)",o=>D.URI.isUri(o)||typeof o=="string"&&(0,h.matchesSomeScheme)(o,h.Schemas.http,h.Schemas.https),o=>o),new v.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",o=>o===void 0||typeof o=="number"||typeof o=="object",o=>o&&(typeof o=="number"?[l.ViewColumn.from(o),void 0]:[l.ViewColumn.from(o.viewColumn),l.TextEditorOpenOptions.from(o)])).optional(),v.ApiCommandArgument.String.with("label","").optional()],v.ApiCommandResult.Void),new v.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[v.ApiCommandArgument.Uri.with("resource","Resource to open"),v.ApiCommandArgument.String.with("viewId","Custom editor view id. This should be the viewType string for custom editors or the notebookType string for notebooks. Use 'default' to use VSCodium's default text editor"),new v.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",o=>o===void 0||typeof o=="number"||typeof o=="object",o=>o&&(typeof o=="number"?[l.ViewColumn.from(o),void 0]:[l.ViewColumn.from(o.viewColumn),l.TextEditorOpenOptions.from(o)])).optional()],v.ApiCommandResult.Void),new v.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[v.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),v.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),v.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new v.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",o=>o===void 0||typeof o=="object",o=>o&&[l.ViewColumn.from(o.viewColumn),l.TextEditorOpenOptions.from(o)]).optional()],v.ApiCommandResult.Void),new v.ApiCommand("vscode.changes","_workbench.changes","Opens a list of resources in the changes editor to compare their contents.",[v.ApiCommandArgument.String.with("title","Human readable title for the changes editor"),new v.ApiCommandArgument("resourceList","List of resources to compare",o=>{for(const m of o){if(m.length!==3)return!1;const[p,u,i]=m;if(!D.URI.isUri(p)||!D.URI.isUri(u)&&u!==void 0&&u!==null||!D.URI.isUri(i)&&i!==void 0&&i!==null)return!1}return!0},o=>o)],v.ApiCommandResult.Void),new v.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Position],new v.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",o=>o.map(l.TypeHierarchyItem.to))),new v.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[v.ApiCommandArgument.TypeHierarchyItem],new v.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",o=>o.map(l.TypeHierarchyItem.to))),new v.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[v.ApiCommandArgument.TypeHierarchyItem],new v.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",o=>o.map(l.TypeHierarchyItem.to))),new v.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[v.ApiCommandArgument.TestItem],v.ApiCommandResult.Void),new v.ApiCommand("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[v.ApiCommandArgument.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],v.ApiCommandResult.Void),new v.ApiCommand("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[v.ApiCommandArgument.String.with("name","The context key name"),new v.ApiCommandArgument("value","The context key value",()=>!0,o=>o)],v.ApiCommandResult.Void),new v.ApiCommand("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.StringArray,new v.ApiCommandArgument("MappedEditsContext","Mapped Edits Context",o=>l.MappedEditsContext.is(o),o=>l.MappedEditsContext.from(o))],new v.ApiCommandResult("A promise that resolves to a workspace edit or null",o=>o?l.WorkspaceEdit.to(o):null)),new v.ApiCommand("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new v.ApiCommandArgument("Run arguments","",o=>!0,o=>{if(o)return{initialRange:o.initialRange?l.Range.from(o.initialRange):void 0,initialSelection:C.Selection.isSelection(o.initialSelection)?l.Selection.from(o.initialSelection):void 0,message:o.message,autoSend:o.autoSend,position:o.position?l.Position.from(o.position):void 0}})],v.ApiCommandResult.Void)];class f{static register(m){_.forEach(m.registerApiCommand,m),this._registerValidateWhenClausesCommand(m)}static _registerValidateWhenClausesCommand(m){m.registerCommand(!1,"_validateWhenClauses",R.validateWhenClauses)}}e.ExtHostApiCommands=f;function T(o){return m=>{if(Array.isArray(m))return m.map(o)}}function S(o){if(!Array.isArray(o))return;const m=[];for(const p of o)A.isLocationLink(p)?m.push(l.DefinitionLink.to(p)):m.push(l.location.to(p));return m}}),define(Pe[320],ke([1,0,2,35]),function(ge,e,s,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class D{constructor(L,R,v,l,C){this._extHostNotebooks=R,this._textDocumentsAndEditors=v,this._commands=l;const _=new h.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new h.ApiCommandArgument("showOptions","Show Options",f=>!0,f=>f),new h.ApiCommandArgument("resource","Interactive resource Uri",f=>!0,f=>f),new h.ApiCommandArgument("controllerId","Notebook controller Id",f=>!0,f=>f),new h.ApiCommandArgument("title","Interactive editor title",f=>!0,f=>f)],new h.ApiCommandResult("Notebook and input URI",f=>{if(C.debug("[ExtHostInteractive] open iw with notebook editor id",f.notebookEditorId),f.notebookEditorId!==void 0){const T=this._extHostNotebooks.getEditorById(f.notebookEditorId);return C.debug("[ExtHostInteractive] notebook editor found",T.id),{notebookUri:s.URI.revive(f.notebookUri),inputUri:s.URI.revive(f.inputUri),notebookEditor:T.apiEditor}}return C.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",f.notebookUri,f.inputUri),{notebookUri:s.URI.revive(f.notebookUri),inputUri:s.URI.revive(f.inputUri)}}));this._commands.registerApiCommand(_)}$willAddInteractiveDocument(L,R,v,l){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:R,lines:[""],languageId:v,uri:L,isDirty:!1,versionId:1}]})}$willRemoveInteractiveDocument(L,R){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({removedDocuments:[L]})}}e.ExtHostInteractive=D}),define(Pe[321],ke([1,0,18,8,20,4,3,28,2,23,11,6,35,15,9,121,263,25,53,264]),function(ge,e,s,h,D,A,L,R,v,l,C,_,f,T,S,o,m,p,u,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookKernels=void 0,e.createKernelId=g,T=We(T);let a=class{constructor(y,I,P,k,b){this._initData=I,this._extHostNotebook=P,this._commands=k,this._logService=b,this._activeExecutions=new R.ResourceMap,this._activeNotebookExecutions=new R.ResourceMap,this._kernelDetectionTask=new Map,this._kernelDetectionTaskHandlePool=0,this._kernelSourceActionProviders=new Map,this._kernelSourceActionProviderHandlePool=0,this._kernelData=new Map,this._handlePool=0,this._onDidChangeCellExecutionState=new A.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this.id=0,this.variableStore={},this._proxy=y.getProxy(_.MainContext.MainThreadNotebookKernels);const E=new f.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new f.ApiCommandArgument("options","Select kernel options",O=>!0,O=>{if(O&&"notebookEditor"in O&&"id"in O){const M=this._extHostNotebook.getIdByEditor(O.notebookEditor);return{id:O.id,extension:O.extension,notebookEditorId:M}}else if(O&&"notebookEditor"in O){const M=this._extHostNotebook.getIdByEditor(O.notebookEditor);if(M===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${O.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:M}}return O})],f.ApiCommandResult.Void),N=new f.ApiCommand("vscode.executeNotebookVariableProvider","_executeNotebookVariableProvider","Execute notebook variable provider",[f.ApiCommandArgument.Uri],new f.ApiCommandResult("A promise that resolves to an array of variables",(O,M)=>O.map(U=>({variable:{name:U.name,value:U.value,expression:U.expression,type:U.type,language:U.language},hasNamedChildren:U.hasNamedChildren,indexedChildrenCount:U.indexedChildrenCount}))));this._commands.registerApiCommand(E),this._commands.registerApiCommand(N)}createNotebookController(y,I,P,k,b,E){for(const te of this._kernelData.values())if(te.controller.id===I&&l.ExtensionIdentifier.equals(y.identifier,te.extensionId))throw new Error(`notebook controller with id '${I}' ALREADY exist`);const N=this._handlePool++,O=this;this._logService.trace(`NotebookController[${N}], CREATED by ${y.identifier.value}, ${I}`);const M=()=>console.warn(`NO execute handler from notebook controller '${x.id}' of extension: '${y.identifier}'`);let U=!1;const H=new A.Emitter,F=new A.Emitter,x={id:g(y.identifier,I),notebookType:P,extensionId:y.identifier,extensionLocation:y.extensionLocation,label:k||y.identifier.value,preloads:E?E.map(T.NotebookRendererScript.from):[]};let $=b??M,G,B;this._proxy.$addKernel(N,x).catch(te=>{console.log(te),U=!0});let W=0;const Z=()=>{if(U)return;const te=++W;Promise.resolve().then(()=>{te===W&&this._proxy.$updateKernel(N,x)})},J=new R.ResourceMap,oe={get id(){return I},get notebookType(){return x.notebookType},onDidChangeSelectedNotebooks:H.event,get label(){return x.label},set label(te){x.label=te??y.displayName??y.name,Z()},get detail(){return x.detail??""},set detail(te){x.detail=te,Z()},get description(){return x.description??""},set description(te){x.description=te,Z()},get supportedLanguages(){return x.supportedLanguages},set supportedLanguages(te){x.supportedLanguages=te,Z()},get supportsExecutionOrder(){return x.supportsExecutionOrder??!1},set supportsExecutionOrder(te){x.supportsExecutionOrder=te,Z()},get rendererScripts(){return x.preloads?x.preloads.map(T.NotebookRendererScript.to):[]},get executeHandler(){return $},set executeHandler(te){$=te??M},get interruptHandler(){return G},set interruptHandler(te){G=te,x.supportsInterrupt=!!te,Z()},set variableProvider(te){(0,p.checkProposedApiEnabled)(y,"notebookVariableProvider"),B=te,x.hasVariableProvider=!!te,te?.onDidChangeVariables(me=>O._proxy.$variablesUpdated(me.uri)),Z()},get variableProvider(){return B},createNotebookCellExecution(te){if(U)throw new Error("notebook controller is DISPOSED");if(!J.has(te.notebook.uri))throw O._logService.trace(`NotebookController[${N}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(J.keys()).map(me=>me.toString())),new Error(`notebook controller is NOT associated to notebook: ${te.notebook.uri.toString()}`);return O._createNotebookCellExecution(te,g(y.identifier,this.id))},createNotebookExecution(te){if((0,p.checkProposedApiEnabled)(y,"notebookExecution"),U)throw new Error("notebook controller is DISPOSED");if(!J.has(te.uri))throw O._logService.trace(`NotebookController[${N}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(J.keys()).map(me=>me.toString())),new Error(`notebook controller is NOT associated to notebook: ${te.uri.toString()}`);return O._createNotebookExecution(te,g(y.identifier,this.id))},dispose:()=>{U||(this._logService.trace(`NotebookController[${N}], DISPOSED`),U=!0,this._kernelData.delete(N),H.dispose(),F.dispose(),this._proxy.$removeKernel(N))},updateNotebookAffinity(te,me){me===S.NotebookControllerAffinity2.Hidden&&(0,p.checkProposedApiEnabled)(y,"notebookControllerAffinityHidden"),O._proxy.$updateNotebookPriority(N,te.uri,me)},onDidReceiveMessage:F.event,postMessage(te,me){return(0,p.checkProposedApiEnabled)(y,"notebookMessaging"),O._proxy.$postMessage(N,me&&O._extHostNotebook.getIdByEditor(me),te)},asWebviewUri(te){return(0,p.checkProposedApiEnabled)(y,"notebookMessaging"),(0,o.asWebviewUri)(te,O._initData.remote)}};return this._kernelData.set(N,{extensionId:y.identifier,controller:oe,onDidReceiveMessage:F,onDidChangeSelection:H,associatedNotebooks:J}),oe}getIdByController(y){for(const[I,P]of this._kernelData)if(P.controller===y)return g(P.extensionId,y.id);return null}createNotebookControllerDetectionTask(y,I){const P=this._kernelDetectionTaskHandlePool++,k=this;this._logService.trace(`NotebookControllerDetectionTask[${P}], CREATED by ${y.identifier.value}`),this._proxy.$addKernelDetectionTask(P,I);const b={dispose:()=>{this._kernelDetectionTask.delete(P),k._proxy.$removeKernelDetectionTask(P)}};return this._kernelDetectionTask.set(P,b),b}registerKernelSourceActionProvider(y,I,P){const k=this._kernelSourceActionProviderHandlePool++,b=typeof P.onDidChangeNotebookKernelSourceActions=="function"?k:void 0,E=this;this._kernelSourceActionProviders.set(k,P),this._logService.trace(`NotebookKernelSourceActionProvider[${k}], CREATED by ${y.identifier.value}`),this._proxy.$addKernelSourceActionProvider(k,k,I);let N;return b!==void 0&&(N=P.onDidChangeNotebookKernelSourceActions(O=>this._proxy.$emitNotebookKernelSourceActionsChangeEvent(b))),{dispose:()=>{this._kernelSourceActionProviders.delete(k),E._proxy.$removeKernelSourceActionProvider(k,k),N?.dispose()}}}async $provideKernelSourceActions(y,I){const P=this._kernelSourceActionProviders.get(y);if(P){const k=new L.DisposableStore;return(await P.provideNotebookKernelSourceActions(I)??[]).map(E=>T.NotebookKernelSourceAction.from(E,this._commands.converter,k))}return[]}$acceptNotebookAssociation(y,I,P){const k=this._kernelData.get(y);if(k){const b=this._extHostNotebook.getNotebookDocument(v.URI.revive(I));P?k.associatedNotebooks.set(b.uri,!0):k.associatedNotebooks.delete(b.uri),this._logService.trace(`NotebookController[${y}] ASSOCIATE notebook`,b.uri.toString(),P),k.onDidChangeSelection.fire({selected:P,notebook:b.apiNotebook})}}async $executeCells(y,I,P){const k=this._kernelData.get(y);if(!k)return;const b=this._extHostNotebook.getNotebookDocument(v.URI.revive(I)),E=[];for(const N of P){const O=b.getCell(N);O&&E.push(O.apiCell)}try{this._logService.trace(`NotebookController[${y}] EXECUTE cells`,b.uri.toString(),E.length),await k.controller.executeHandler.call(k.controller,E,b.apiNotebook,k.controller)}catch(N){this._logService.error(`NotebookController[${y}] execute cells FAILED`,N),console.error(N)}}async $cancelCells(y,I,P){const k=this._kernelData.get(y);if(!k)return;const b=this._extHostNotebook.getNotebookDocument(v.URI.revive(I));if(k.controller.interruptHandler)await k.controller.interruptHandler.call(k.controller,b.apiNotebook);else for(const E of P){const N=b.getCell(E);N&&this._activeExecutions.get(N.uri)?.cancel()}if(k.controller.interruptHandler){const E=this._activeNotebookExecutions.get(b.uri);this._activeNotebookExecutions.delete(b.uri),P.length&&Array.isArray(E)&&E.length&&E.forEach(N=>N.dispose())}}async $provideVariables(y,I,P,k,b,E,N){const O=this._kernelData.get(y);if(!O)return;const M=this._extHostNotebook.getNotebookDocument(v.URI.revive(P)),U=O.controller.variableProvider;if(!U)return;let H;if(k!==void 0){if(H=this.variableStore[k],!H)return}else this.variableStore={};const F=b==="named"?S.NotebookVariablesRequestKind.Named:S.NotebookVariablesRequestKind.Indexed,x=U.provideVariables(M.apiNotebook,H,F,E,N);let $=0;for await(const G of x){if(N.isCancellationRequested)return;const B={id:this.id++,name:G.variable.name,value:G.variable.value,type:G.variable.type,interfaces:G.variable.interfaces,language:G.variable.language,expression:G.variable.expression,hasNamedChildren:G.hasNamedChildren,indexedChildrenCount:G.indexedChildrenCount,extensionId:O.extensionId.value};if(this.variableStore[B.id]=G.variable,this._proxy.$receiveVariable(I,B),$++>=i.variablePageSize)return}}$acceptKernelMessageFromRenderer(y,I,P){const k=this._kernelData.get(y);if(!k)return;const b=this._extHostNotebook.getEditorById(I);k.onDidReceiveMessage.fire(Object.freeze({editor:b.apiEditor,message:P}))}$cellExecutionChanged(y,I,P){const b=this._extHostNotebook.getNotebookDocument(v.URI.revive(y)).getCell(I);if(b){const E=P?T.NotebookCellExecutionState.to(P):S.NotebookCellExecutionState.Idle;E!==void 0&&this._onDidChangeCellExecutionState.fire({cell:b.apiCell,state:E})}}_createNotebookCellExecution(y,I){if(y.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const k=this._extHostNotebook.getNotebookDocument(y.notebook.uri).getCellFromApiCell(y);if(!k)throw new Error("invalid cell");if(this._activeExecutions.has(k.uri))throw new Error(`duplicate execution for ${k.uri}`);const b=new n(I,k,this._proxy);this._activeExecutions.set(k.uri,b);const E=b.onDidChangeState(()=>{b.state===t.Resolved&&(b.dispose(),E.dispose(),this._activeExecutions.delete(k.uri))});return b.asApiObject()}_createNotebookExecution(y,I){const P=this._extHostNotebook.getNotebookDocument(y.uri),k=y.getCells().find(N=>{const O=P.getCellFromApiCell(N);return O&&this._activeExecutions.has(O.uri)});if(k)throw new Error(`duplicate cell execution for ${k.document.uri}`);if(this._activeNotebookExecutions.has(P.uri))throw new Error(`duplicate notebook execution for ${P.uri}`);const b=new d(I,P,this._proxy),E=b.onDidChangeState(()=>{b.state===r.Resolved&&(b.dispose(),E.dispose(),this._activeNotebookExecutions.delete(P.uri))});return this._activeNotebookExecutions.set(P.uri,[b,E]),b.asApiObject()}};e.ExtHostNotebookKernels=a,e.ExtHostNotebookKernels=a=Qe([$e(4,C.ILogService)],a);var t;(function(w){w[w.Init=0]="Init",w[w.Started=1]="Started",w[w.Resolved=2]="Resolved"})(t||(t={}));class n extends L.Disposable{static{this.HANDLE=0}get state(){return this._state}constructor(y,I,P){super(),this._cell=I,this._proxy=P,this._handle=n.HANDLE++,this._onDidChangeState=new A.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=t.Init,this._tokenSource=this._register(new D.CancellationTokenSource),this._collector=new c(10,k=>this.update(k)),this._executionOrder=I.internalMetadata.executionOrder,this._proxy.$createExecution(this._handle,y,this._cell.notebook.uri,this._cell.handle)}cancel(){this._tokenSource.cancel()}async updateSoon(y){await this._collector.addItem(y)}async update(y){const I=Array.isArray(y)?y:[y];return this._proxy.$updateExecution(this._handle,new u.SerializableObjectWithBuffers(I))}verifyStateForOutput(){if(this._state===t.Init)throw new Error("Must call start before modifying cell output");if(this._state===t.Resolved)throw new Error("Cannot modify cell output after calling resolve")}cellIndexToHandle(y){let I=this._cell;if(y&&(I=this._cell.notebook.getCellFromApiCell(y)),!I)throw new Error("INVALID cell");return I.handle}validateAndConvertOutputs(y){return y.map(I=>{const P=S.NotebookCellOutput.ensureUniqueMimeTypes(I.items,!0);return P===I.items?T.NotebookCellOutput.from(I):T.NotebookCellOutput.from({items:P,id:I.id,metadata:I.metadata})})}async updateOutputs(y,I,P){const k=this.cellIndexToHandle(I),b=this.validateAndConvertOutputs((0,s.asArray)(y));return this.updateSoon({editType:m.CellExecutionUpdateType.Output,cellHandle:k,append:P,outputs:b})}async updateOutputItems(y,I,P){return y=S.NotebookCellOutput.ensureUniqueMimeTypes((0,s.asArray)(y),!0),this.updateSoon({editType:m.CellExecutionUpdateType.OutputItems,items:y.map(T.NotebookCellOutputItem.from),outputId:I.id,append:P})}asApiObject(){const y=this;return Object.freeze({get token(){return y._tokenSource.token},get cell(){return y._cell.apiCell},get executionOrder(){return y._executionOrder},set executionOrder(P){y._executionOrder=P,y.update([{editType:m.CellExecutionUpdateType.ExecutionState,executionOrder:y._executionOrder}])},start(P){if(y._state===t.Resolved||y._state===t.Started)throw new Error("Cannot call start again");y._state=t.Started,y._onDidChangeState.fire(),y.update({editType:m.CellExecutionUpdateType.ExecutionState,runStartTime:P})},end(P,k,b){if(y._state===t.Resolved)throw new Error("Cannot call resolve twice");y._state=t.Resolved,y._onDidChangeState.fire(),y._collector.flush();const E=b?{message:b.message,stack:b.stack,location:b?.location?{startLineNumber:b.location.start.line,startColumn:b.location.start.character,endLineNumber:b.location.end.line,endColumn:b.location.end.character}:void 0,uri:b.uri}:void 0;y._proxy.$completeExecution(y._handle,new u.SerializableObjectWithBuffers({runEndTime:k,lastRunSuccess:P,error:E}))},clearOutput(P){return y.verifyStateForOutput(),y.updateOutputs([],P,!1)},appendOutput(P,k){return y.verifyStateForOutput(),y.updateOutputs(P,k,!0)},replaceOutput(P,k){return y.verifyStateForOutput(),y.updateOutputs(P,k,!1)},appendOutputItems(P,k){return y.verifyStateForOutput(),y.updateOutputItems(P,k,!0)},replaceOutputItems(P,k){return y.verifyStateForOutput(),y.updateOutputItems(P,k,!1)}})}}var r;(function(w){w[w.Init=0]="Init",w[w.Started=1]="Started",w[w.Resolved=2]="Resolved"})(r||(r={}));class d extends L.Disposable{static{this.HANDLE=0}get state(){return this._state}constructor(y,I,P){super(),this._notebook=I,this._proxy=P,this._handle=d.HANDLE++,this._onDidChangeState=new A.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=r.Init,this._tokenSource=this._register(new D.CancellationTokenSource),this._proxy.$createNotebookExecution(this._handle,y,this._notebook.uri)}cancel(){this._tokenSource.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this._state===r.Resolved||this._state===r.Started)throw new Error("Cannot call start again");this._state=r.Started,this._onDidChangeState.fire(),this._proxy.$beginNotebookExecution(this._handle)},end:()=>{if(this._state===r.Resolved)throw new Error("Cannot call resolve twice");this._state=r.Resolved,this._onDidChangeState.fire(),this._proxy.$completeNotebookExecution(this._handle)}})}}class c{constructor(y,I){this.delay=y,this.callback=I,this.batch=[],this.startedTimer=Date.now()}addItem(y){return this.batch.push(y),this.currentDeferred||(this.currentDeferred=new h.DeferredPromise,this.startedTimer=Date.now(),(0,h.timeout)(this.delay).then(()=>this.flush())),Date.now()-this.startedTimer>this.delay?this.flush():this.currentDeferred.p}flush(){if(this.batch.length===0||!this.currentDeferred)return Promise.resolve();const y=this.currentDeferred;this.currentDeferred=void 0;const I=this.batch;return this.batch=[],this.callback(I).finally(()=>y.complete())}}function g(w,y){return`${w.value}/${y}`}}),define(Pe[48],ke([1,0,4,6,5,2,19,3,9,7,12,244,20,31,245,246,51,8,15,35,41]),function(ge,e,s,h,D,A,L,R,v,l,C,_,f,T,S,o,m,p,u,i,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.BaseExtHostTerminalService=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,D.createDecorator)("IExtHostTerminalService");class t extends R.Disposable{constructor(b,E,N,O){super(),this._proxy=b,this._id=E,this._creationOptions=N,this._name=O,this._disposed=!1,this._state={isInteractedWith:!1},this.isOpen=!1,this._onWillDispose=this._register(new s.Emitter),this.onWillDispose=this._onWillDispose.event,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(U=>this._pidPromiseComplete=U);const M=this;this.value={get name(){return M._name||""},get processId(){return M._pidPromise},get creationOptions(){return M._creationOptions},get exitStatus(){return M._exitStatus},get state(){return M._state},get selection(){return M._selection},get shellIntegration(){return M.shellIntegration},sendText(U,H=!0){M._checkDisposed(),M._proxy.$sendText(M._id,U,H)},show(U){M._checkDisposed(),M._proxy.$show(M._id,U)},hide(){M._checkDisposed(),M._proxy.$hide(M._id)},dispose(){M._disposed||(M._disposed=!0,M._proxy.$dispose(M._id))},get dimensions(){if(!(M._cols===void 0||M._rows===void 0))return{columns:M._cols,rows:M._rows}}}}dispose(){this._onWillDispose.fire(),super.dispose()}async create(b,E){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:b.name,shellPath:b.shellPath??void 0,shellArgs:b.shellArgs??void 0,cwd:b.cwd??E?.cwd??void 0,env:b.env??void 0,icon:y(b.iconPath)??void 0,color:m.ThemeColor.isThemeColor(b.color)?b.color.id:void 0,initialText:b.message??void 0,strictEnv:b.strictEnv??void 0,hideFromUser:b.hideFromUser??void 0,forceShellIntegration:E?.forceShellIntegration??void 0,isFeatureTerminal:E?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:E?.useShellEnvironment??void 0,location:E?.location||this._serializeParentTerminal(b.location,E?.resolvedExtHostIdentifier),isTransient:b.isTransient??void 0})}async createExtensionTerminal(b,E,N,O,M){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:O,color:m.ThemeColor.isThemeColor(M)?M.id:void 0,location:E?.location||this._serializeParentTerminal(b,N),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_serializeParentTerminal(b,E){return typeof b=="object"?"parentTerminal"in b&&b.parentTerminal&&E?{parentTerminal:E}:"viewColumn"in b?{viewColumn:u.ViewColumn.from(b.viewColumn),preserveFocus:b.preserveFocus}:void 0:b}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(b){this._name=b}setExitStatus(b,E){this._exitStatus=Object.freeze({code:b,reason:E})}setDimensions(b,E){return b===this._cols&&E===this._rows||b===0||E===0?!1:(this._cols=b,this._rows=E,!0)}setInteractedWith(){return this._state.isInteractedWith?!1:(this._state={isInteractedWith:!0},!0)}setSelection(b){this._selection=b}_setProcessId(b){this._pidPromiseComplete?(this._pidPromiseComplete(b),this._pidPromiseComplete=void 0):this._pidPromise.then(E=>{E!==b&&(this._pidPromise=Promise.resolve(b))})}}e.ExtHostTerminal=t;class n{get onProcessReady(){return this._onProcessReady.event}constructor(b){this._pty=b,this.id=0,this.shouldPersist=!1,this._onProcessData=new s.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessReady=new s.Emitter,this._onDidChangeProperty=new s.Emitter,this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=new s.Emitter,this.onProcessExit=this._onProcessExit.event}refreshProperty(b){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${b}`)}updateProperty(b,E){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${b}, value: ${E}`)}async start(){}shutdown(){this._pty.close()}input(b){this._pty.handleInput?.(b)}resize(b,E){this._pty.setDimensions?.({columns:b,rows:E})}clearBuffer(){}async processBinary(b){}acknowledgeDataEvent(b){}async setUnicodeVersion(b){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(b){this._pty.onDidWrite(E=>this._onProcessData.fire(E)),this._pty.onDidClose?.((E=void 0)=>{this._onProcessExit.fire(E===void 0?void 0:E)}),this._pty.onDidOverrideDimensions?.(E=>{E&&this._onDidChangeProperty.fire({type:S.ProcessPropertyType.OverrideDimensions,value:{cols:E.columns,rows:E.rows}})}),this._pty.onDidChangeName?.(E=>{this._onDidChangeProperty.fire({type:S.ProcessPropertyType.Title,value:E})}),this._pty.open(b||void 0),b&&this._pty.setDimensions?.(b),this._onProcessReady.fire({pid:-1,cwd:"",windowsPty:void 0})}}let r=1,d=class extends R.Disposable{get activeTerminal(){return this._activeTerminal?.value}get terminals(){return this._terminals.map(b=>b.value)}constructor(b,E,N){super(),this._extHostCommands=E,this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._lastQuickFixCommands=this._register(new R.MutableDisposable),this._linkProviders=new Set,this._profileProviders=new Map,this._quickFixProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new s.Emitter,this.onDidCloseTerminal=this._onDidCloseTerminal.event,this._onDidOpenTerminal=new s.Emitter,this.onDidOpenTerminal=this._onDidOpenTerminal.event,this._onDidChangeActiveTerminal=new s.Emitter,this.onDidChangeActiveTerminal=this._onDidChangeActiveTerminal.event,this._onDidChangeTerminalDimensions=new s.Emitter,this.onDidChangeTerminalDimensions=this._onDidChangeTerminalDimensions.event,this._onDidChangeTerminalState=new s.Emitter,this.onDidChangeTerminalState=this._onDidChangeTerminalState.event,this._onDidChangeShell=new s.Emitter,this.onDidChangeShell=this._onDidChangeShell.event,this._onDidWriteTerminalData=new s.Emitter({onWillAddFirstListener:()=>this._proxy.$startSendingDataEvents(),onDidRemoveLastListener:()=>this._proxy.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this._onDidWriteTerminalData.event,this._onDidExecuteCommand=new s.Emitter({onWillAddFirstListener:()=>this._proxy.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this._proxy.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this._onDidExecuteCommand.event,this._proxy=N.getProxy(h.MainContext.MainThreadTerminalService),this._bufferer=new o.TerminalDataBufferer(this._proxy.$sendProcessData),this._proxy.$registerProcessSupport(b),this._extHostCommands.registerArgumentProcessor({processArgument:O=>{const M=U=>{const H=U;return this.getTerminalById(H.instanceId)?.value};switch(O?.$mid){case a.MarshalledId.TerminalContext:return M(O);default:{if(Array.isArray(O))for(let U=0;U<O.length&&O[U].$mid===a.MarshalledId.TerminalContext;U++)O[U]=M(O[U]);return O}}}}),this._register({dispose:()=>{for(const[O,M]of this._terminalProcesses)M.shutdown(!0)}})}getDefaultShell(b){return(b?this._defaultAutomationProfile:this._defaultProfile)?.path||""}getDefaultShellArgs(b){return(b?this._defaultAutomationProfile:this._defaultProfile)?.args||[]}createExtensionTerminal(b,E){const N=new t(this._proxy,(0,T.generateUuid)(),b,b.name),O=new n(b.pty);return N.createExtensionTerminal(b.location,E,this._serializeParentTerminal(b,E).resolvedExtHostIdentifier,y(b.iconPath),I(b.color)).then(M=>{const U=this._setupExtHostProcessListeners(M,O);this._terminalProcessDisposables[M]=U}),this._terminals.push(N),N.value}_serializeParentTerminal(b,E){if(E=E||{},b.location&&typeof b.location=="object"&&"parentTerminal"in b.location){const N=b.location.parentTerminal;if(N){const O=this._terminals.find(M=>M.value===N);O&&(E.resolvedExtHostIdentifier=O._id)}}else b.location&&typeof b.location!="object"?E.location=b.location:E.location&&typeof E.location=="object"&&"splitActiveTerminal"in E.location&&(E.location={splitActiveTerminal:!0});return E}attachPtyToTerminal(b,E){if(!this.getTerminalById(b))throw new Error(`Cannot resolve terminal with id ${b} for virtual process`);const O=new n(E),M=this._setupExtHostProcessListeners(b,O);this._terminalProcessDisposables[b]=M}async $acceptActiveTerminalChanged(b){const E=this._activeTerminal;if(b===null){this._activeTerminal=void 0,E!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const N=this.getTerminalById(b);N&&(this._activeTerminal=N,E!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(b,E){const N=this.getTerminalById(b);N&&this._onDidWriteTerminalData.fire({terminal:N.value,data:E})}async $acceptTerminalDimensions(b,E,N){const O=this.getTerminalById(b);O&&O.setDimensions(E,N)&&this._onDidChangeTerminalDimensions.fire({terminal:O.value,dimensions:O.value.dimensions})}async $acceptDidExecuteCommand(b,E){const N=this.getTerminalById(b);N&&this._onDidExecuteCommand.fire({terminal:N.value,...E})}async $acceptTerminalMaximumDimensions(b,E,N){this._terminalProcesses.get(b)?.resize(E,N)}async $acceptTerminalTitleChange(b,E){const N=this.getTerminalById(b);N&&(N.name=E)}async $acceptTerminalClosed(b,E,N){const O=this._getTerminalObjectIndexById(this._terminals,b);if(O!==null){const M=this._terminals.splice(O,1)[0];M.setExitStatus(E,N),this._onDidCloseTerminal.fire(M.value)}}$acceptTerminalOpened(b,E,N,O){if(E){const H=this._getTerminalObjectIndexById(this._terminals,E);if(H!==null){this._terminals[H]._id=b,this._onDidOpenTerminal.fire(this.terminals[H]),this._terminals[H].isOpen=!0;return}}const M={name:O.name,shellPath:O.executable,shellArgs:O.args,cwd:typeof O.cwd=="string"?O.cwd:A.URI.revive(O.cwd),env:O.env,hideFromUser:O.hideFromUser},U=new t(this._proxy,b,M,N);this._terminals.push(U),this._onDidOpenTerminal.fire(U.value),U.isOpen=!0}async $acceptTerminalProcessId(b,E){this.getTerminalById(b)?._setProcessId(E)}async $startExtensionTerminal(b,E){const N=this.getTerminalById(b);if(!N)return{message:(0,l.localize)(2714,null,b)};N.isOpen||await new Promise(M=>{const U=this.onDidOpenTerminal(async H=>{H===N.value&&(U.dispose(),M())})});const O=this._terminalProcesses.get(b);O?O.startSendingEvents(E):this._extensionTerminalAwaitingStart[b]={initialDimensions:E}}_setupExtHostProcessListeners(b,E){const N=new R.DisposableStore;N.add(E.onProcessReady(M=>this._proxy.$sendProcessReady(b,M.pid,M.cwd,M.windowsPty))),N.add(E.onDidChangeProperty(M=>this._proxy.$sendProcessProperty(b,M))),this._bufferer.startBuffering(b,E.onProcessData),N.add(E.onProcessExit(M=>this._onProcessExit(b,M))),this._terminalProcesses.set(b,E);const O=this._extensionTerminalAwaitingStart[b];return O&&E instanceof n&&(E.startSendingEvents(O.initialDimensions),delete this._extensionTerminalAwaitingStart[b]),N}$acceptProcessAckDataEvent(b,E){this._terminalProcesses.get(b)?.acknowledgeDataEvent(E)}$acceptProcessInput(b,E){this._terminalProcesses.get(b)?.input(E)}$acceptTerminalInteraction(b){const E=this.getTerminalById(b);E?.setInteractedWith()&&this._onDidChangeTerminalState.fire(E.value)}$acceptTerminalSelection(b,E){this.getTerminalById(b)?.setSelection(E)}$acceptProcessResize(b,E,N){try{this._terminalProcesses.get(b)?.resize(E,N)}catch(O){if(O.code!=="EPIPE"&&O.code!=="ERR_IPC_CHANNEL_CLOSED")throw O}}$acceptProcessShutdown(b,E){this._terminalProcesses.get(b)?.shutdown(E)}$acceptProcessRequestInitialCwd(b){this._terminalProcesses.get(b)?.getInitialCwd().then(E=>this._proxy.$sendProcessProperty(b,{type:S.ProcessPropertyType.InitialCwd,value:E}))}$acceptProcessRequestCwd(b){this._terminalProcesses.get(b)?.getCwd().then(E=>this._proxy.$sendProcessProperty(b,{type:S.ProcessPropertyType.Cwd,value:E}))}$acceptProcessRequestLatency(b){return Promise.resolve(b)}registerLinkProvider(b){return this._linkProviders.add(b),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new v.Disposable(()=>{this._linkProviders.delete(b),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(b,E,N){if(this._profileProviders.has(E))throw new Error(`Terminal profile provider "${E}" already registered`);return this._profileProviders.set(E,N),this._proxy.$registerProfileProvider(E,b.identifier.value),new v.Disposable(()=>{this._profileProviders.delete(E),this._proxy.$unregisterProfileProvider(E)})}registerTerminalQuickFixProvider(b,E,N){if(this._quickFixProviders.has(b))throw new Error(`Terminal quick fix provider "${b}" is already registered`);return this._quickFixProviders.set(b,N),this._proxy.$registerQuickFixProvider(b,E),new v.Disposable(()=>{this._quickFixProviders.delete(b),this._proxy.$unregisterQuickFixProvider(b)})}async $provideTerminalQuickFixes(b,E){const N=new f.CancellationTokenSource().token;if(N.isCancellationRequested)return;const O=this._quickFixProviders.get(b);if(!O)return;const M=await O.provideTerminalQuickFixes(E,N);if(M===null||Array.isArray(M)&&M.length===0)return;const U=new R.DisposableStore;if(this._lastQuickFixCommands.value=U,!Array.isArray(M))return M?u.TerminalQuickFix.from(M,this._extHostCommands.converter,U):void 0;const H=[];for(const F of M){const x=u.TerminalQuickFix.from(F,this._extHostCommands.converter,U);x&&H.push(x)}return H}async $createContributedProfileTerminal(b,E){const N=new f.CancellationTokenSource().token;let O=await this._profileProviders.get(b)?.provideTerminalProfile(N);if(!N.isCancellationRequested){if(O&&!("options"in O)&&(O={options:O}),!O||!("options"in O))throw new Error(`No terminal profile options provided for id "${b}"`);if("pty"in O.options){this.createExtensionTerminal(O.options,E);return}this.createTerminalFromOptions(O.options,E)}}async $provideLinks(b,E){const N=this.getTerminalById(b);if(!N)return[];this._terminalLinkCache.delete(b),this._terminalLinkCancellationSource.get(b)?.dispose(!0);const M=new f.CancellationTokenSource;this._terminalLinkCancellationSource.set(b,M);const U=[],H={terminal:N.value,line:E},F=[];for(const G of this._linkProviders)F.push(p.Promises.withAsyncBody(async B=>{M.token.onCancellationRequested(()=>B({provider:G,links:[]}));const W=await G.provideTerminalLinks(H,M.token)||[];M.token.isCancellationRequested||B({provider:G,links:W})}));const x=await Promise.all(F);if(M.token.isCancellationRequested)return[];const $=new Map;for(const G of x)G&&G.links.length>0&&U.push(...G.links.map(B=>{const W={id:r++,startIndex:B.startIndex,length:B.length,label:B.tooltip};return $.set(W.id,{provider:G.provider,link:B}),W}));return this._terminalLinkCache.set(b,$),U}$activateLink(b,E){const N=this._terminalLinkCache.get(b)?.get(E);N&&N.provider.handleTerminalLink(N.link)}_onProcessExit(b,E){this._bufferer.stopBuffering(b),this._terminalProcesses.delete(b),delete this._extensionTerminalAwaitingStart[b];const N=this._terminalProcessDisposables[b];N&&(N.dispose(),delete this._terminalProcessDisposables[b]),this._proxy.$sendProcessExit(b,E)}getTerminalById(b){return this._getTerminalObjectById(this._terminals,b)}getTerminalIdByApiObject(b){const E=this._terminals.findIndex(N=>N.value===b);return E>=0?E:null}_getTerminalObjectById(b,E){const N=this._getTerminalObjectIndexById(b,E);return N!==null?b[N]:null}_getTerminalObjectIndexById(b,E){const N=b.findIndex(O=>O._id===E);return N>=0?N:null}getEnvironmentVariableCollection(b){let E=this._environmentVariableCollections.get(b.identifier.value);return E||(E=this._register(new c),this._setEnvironmentVariableCollection(b.identifier.value,E)),E.getScopedEnvironmentVariableCollection(void 0)}_syncEnvironmentVariableCollection(b,E){const N=(0,_.serializeEnvironmentVariableCollection)(E.map),O=(0,_.serializeEnvironmentDescriptionMap)(E.descriptionMap);this._proxy.$setEnvironmentVariableCollection(b,E.persistent,N.length===0?void 0:N,O)}$initEnvironmentVariableCollections(b){b.forEach(E=>{const N=E[0],O=this._register(new c(E[1]));this._setEnvironmentVariableCollection(N,O)})}$acceptDefaultProfile(b,E){const N=this._defaultProfile;this._defaultProfile=b,this._defaultAutomationProfile=E,N?.path!==b.path&&this._onDidChangeShell.fire(b.path)}_setEnvironmentVariableCollection(b,E){this._environmentVariableCollections.set(b,E),this._register(E.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(b,E)}))}};e.BaseExtHostTerminalService=d,e.BaseExtHostTerminalService=d=Qe([$e(1,i.IExtHostCommands),$e(2,L.IExtHostRpcService)],d);class c extends R.Disposable{get persistent(){return this._persistent}set persistent(b){this._persistent=b,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}constructor(b){super(),this.map=new Map,this.scopedCollections=new Map,this.descriptionMap=new Map,this._persistent=!0,this._onDidChangeCollection=new s.Emitter,this.map=new Map(b)}getScopedEnvironmentVariableCollection(b){const E=this.getScopeKey(b);let N=this.scopedCollections.get(E);return N||(N=new g(this,b),this.scopedCollections.set(E,N),this._register(N.onDidChangeCollection(()=>this._onDidChangeCollection.fire()))),N}replace(b,E,N,O){this._setIfDiffers(b,{value:E,type:v.EnvironmentVariableMutatorType.Replace,options:N??{applyAtProcessCreation:!0},scope:O})}append(b,E,N,O){this._setIfDiffers(b,{value:E,type:v.EnvironmentVariableMutatorType.Append,options:N??{applyAtProcessCreation:!0},scope:O})}prepend(b,E,N,O){this._setIfDiffers(b,{value:E,type:v.EnvironmentVariableMutatorType.Prepend,options:N??{applyAtProcessCreation:!0},scope:O})}_setIfDiffers(b,E){if(E.options&&E.options.applyAtProcessCreation===!1&&!E.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const N=this.getKey(b,E.scope),O=this.map.get(N),M=E.options?{applyAtProcessCreation:E.options.applyAtProcessCreation??!1,applyAtShellIntegration:E.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!O||O.value!==E.value||O.type!==E.type||O.options?.applyAtProcessCreation!==M.applyAtProcessCreation||O.options?.applyAtShellIntegration!==M.applyAtShellIntegration||O.scope?.workspaceFolder?.index!==E.scope?.workspaceFolder?.index){const U=this.getKey(b,E.scope),H={variable:b,...E,options:M};this.map.set(U,H),this._onDidChangeCollection.fire()}}get(b,E){const N=this.getKey(b,E),O=this.map.get(N);return O?P(O):void 0}getKey(b,E){const N=this.getScopeKey(E);return N.length?`${b}:::${N}`:b}getScopeKey(b){return this.getWorkspaceKey(b?.workspaceFolder)??""}getWorkspaceKey(b){return b?b.uri.toString():void 0}getVariableMap(b){const E=new Map;for(const[N,O]of this.map)this.getScopeKey(O.scope)===this.getScopeKey(b)&&E.set(O.variable,P(O));return E}delete(b,E){const N=this.getKey(b,E);this.map.delete(N),this._onDidChangeCollection.fire()}clear(b){if(b?.workspaceFolder){for(const[E,N]of this.map)N.scope?.workspaceFolder?.index===b.workspaceFolder.index&&this.map.delete(E);this.clearDescription(b)}else this.map.clear(),this.descriptionMap.clear();this._onDidChangeCollection.fire()}setDescription(b,E){const N=this.getScopeKey(E),O=this.descriptionMap.get(N);if(!O||O.description!==b){let M;typeof b=="string"?M=b:M=b?.value.split(`

`)[0];const U={description:M,scope:E};this.descriptionMap.set(N,U),this._onDidChangeCollection.fire()}}getDescription(b){const E=this.getScopeKey(b);return this.descriptionMap.get(E)?.description}clearDescription(b){const E=this.getScopeKey(b);this.descriptionMap.delete(E)}}class g{get persistent(){return this.collection.persistent}set persistent(b){this.collection.persistent=b}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}constructor(b,E){this.collection=b,this.scope=E,this._onDidChangeCollection=new s.Emitter}getScoped(b){return this.collection.getScopedEnvironmentVariableCollection(b)}replace(b,E,N){this.collection.replace(b,E,N,this.scope)}append(b,E,N){this.collection.append(b,E,N,this.scope)}prepend(b,E,N){this.collection.prepend(b,E,N,this.scope)}get(b){return this.collection.get(b,this.scope)}forEach(b,E){this.collection.getVariableMap(this.scope).forEach((N,O)=>b.call(E,O,N,this),this.scope)}[Symbol.iterator](){return this.collection.getVariableMap(this.scope).entries()}delete(b){this.collection.delete(b,this.scope),this._onDidChangeCollection.fire(void 0)}clear(){this.collection.clear(this.scope)}set description(b){this.collection.setDescription(b,this.scope)}get description(){return this.collection.getDescription(this.scope)}}let w=class extends d{constructor(b,E){super(!1,b,E)}createTerminal(b,E,N){throw new C.NotSupportedError}createTerminalFromOptions(b,E){throw new C.NotSupportedError}};e.WorkerExtHostTerminalService=w,e.WorkerExtHostTerminalService=w=Qe([$e(0,i.IExtHostCommands),$e(1,L.IExtHostRpcService)],w);function y(k){if(!(!k||typeof k=="string"))return"id"in k?{id:k.id,color:k.color}:k}function I(k){return m.ThemeColor.isThemeColor(k)?k:void 0}function P(k){const b={...k};return delete b.scope,b.options=b.options??void 0,delete b.variable,b}}),define(Pe[172],ke([1,0,9,3,5,6,19,48,4,2,8]),function(ge,e,s,h,D,A,L,R,v,l,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTerminalShellIntegration=e.IExtHostTerminalShellIntegration=void 0,e.IExtHostTerminalShellIntegration=(0,D.createDecorator)("IExtHostTerminalShellIntegration");let _=class extends h.Disposable{constructor(m,p){super(),this._extHostTerminalService=p,this._activeShellIntegrations=new Map,this._onDidChangeTerminalShellIntegration=new v.Emitter,this.onDidChangeTerminalShellIntegration=this._onDidChangeTerminalShellIntegration.event,this._onDidStartTerminalShellExecution=new v.Emitter,this.onDidStartTerminalShellExecution=this._onDidStartTerminalShellExecution.event,this._onDidEndTerminalShellExecution=new v.Emitter,this.onDidEndTerminalShellExecution=this._onDidEndTerminalShellExecution.event,this._proxy=m.getProxy(A.MainContext.MainThreadTerminalShellIntegration),this._register((0,h.toDisposable)(()=>{for(const[u,i]of this._activeShellIntegrations)i.dispose();this._activeShellIntegrations.clear()}))}$shellIntegrationChange(m){const p=this._extHostTerminalService.getTerminalById(m);if(!p)return;const u=p.value;let i=this._activeShellIntegrations.get(m);i||(i=new f(p.value,this._onDidStartTerminalShellExecution),this._activeShellIntegrations.set(m,i),i.store.add(p.onWillDispose(()=>this._activeShellIntegrations.get(m)?.dispose())),i.store.add(i.onDidRequestShellExecution(a=>this._proxy.$executeCommand(m,a))),i.store.add(i.onDidRequestEndExecution(a=>this._onDidEndTerminalShellExecution.fire(a))),i.store.add(i.onDidRequestChangeShellIntegration(a=>this._onDidChangeTerminalShellIntegration.fire(a))),p.shellIntegration=i.value),this._onDidChangeTerminalShellIntegration.fire({terminal:u,shellIntegration:i.value})}$shellExecutionStart(m,p,u,i,a){this._activeShellIntegrations.has(m)||this.$shellIntegrationChange(m);const t={value:p,confidence:u,isTrusted:i};this._activeShellIntegrations.get(m)?.startShellExecution(t,l.URI.revive(a))}$shellExecutionEnd(m,p,u,i,a){const t={value:p,confidence:u,isTrusted:i};this._activeShellIntegrations.get(m)?.endShellExecution(t,a)}$shellExecutionData(m,p){this._activeShellIntegrations.get(m)?.emitData(p)}$cwdChange(m,p){this._activeShellIntegrations.get(m)?.setCwd(l.URI.revive(p))}$closeTerminal(m){this._activeShellIntegrations.get(m)?.dispose(),this._activeShellIntegrations.delete(m)}};e.ExtHostTerminalShellIntegration=_,e.ExtHostTerminalShellIntegration=_=Qe([$e(0,L.IExtHostRpcService),$e(1,R.IExtHostTerminalService)],_);class f extends h.Disposable{get currentExecution(){return this._currentExecution}constructor(m,p){super(),this._terminal=m,this._onDidStartTerminalShellExecution=p,this._ignoreNextExecution=!1,this.store=this._register(new h.DisposableStore),this._onDidRequestChangeShellIntegration=this._register(new v.Emitter),this.onDidRequestChangeShellIntegration=this._onDidRequestChangeShellIntegration.event,this._onDidRequestShellExecution=this._register(new v.Emitter),this.onDidRequestShellExecution=this._onDidRequestShellExecution.event,this._onDidRequestEndExecution=this._register(new v.Emitter),this.onDidRequestEndExecution=this._onDidRequestEndExecution.event;const u=this;this.value={get cwd(){return u._cwd},executeCommand(i,a){let t=i;a&&(t+=` "${a.map(d=>`${d.replaceAll('"','\\"')}`).join('" "')}"`),u._onDidRequestShellExecution.fire(t);const n={value:t,confidence:s.TerminalShellExecutionCommandLineConfidence.High,isTrusted:!0},r=u.startShellExecution(n,u._cwd,!0).value;return u._ignoreNextExecution=!0,r}}}startShellExecution(m,p,u){if(this._ignoreNextExecution&&this._currentExecution)this._ignoreNextExecution=!1;else{this._currentExecution&&(this._currentExecution.endExecution(void 0),this._onDidRequestEndExecution.fire({terminal:this._terminal,shellIntegration:this.value,execution:this._currentExecution.value,exitCode:void 0}));const i=this._currentExecution=new T(m,p??this._cwd);u?queueMicrotask(()=>this._onDidStartTerminalShellExecution.fire({terminal:this._terminal,shellIntegration:this.value,execution:i.value})):this._onDidStartTerminalShellExecution.fire({terminal:this._terminal,shellIntegration:this.value,execution:this._currentExecution.value})}return this._currentExecution}emitData(m){this.currentExecution?.emitData(m)}endShellExecution(m,p){this._currentExecution&&(this._currentExecution.endExecution(m),this._onDidRequestEndExecution.fire({terminal:this._terminal,shellIntegration:this.value,execution:this._currentExecution.value,exitCode:p}),this._currentExecution=void 0)}setCwd(m){let p=!1;l.URI.isUri(this._cwd)?p=!l.URI.isUri(m)||this._cwd.toString()!==m.toString():this._cwd!==m&&(p=!0),p&&(this._cwd=m,this._onDidRequestChangeShellIntegration.fire({terminal:this._terminal,shellIntegration:this.value}))}}class T{constructor(m,p){this._commandLine=m,this.cwd=p,this._ended=!1;const u=this;this.value={get commandLine(){return u._commandLine},get cwd(){return u.cwd},read(){return u._createDataStream()}}}_createDataStream(){if(!this._dataStream){if(this._ended)return C.AsyncIterableObject.EMPTY;this._dataStream=new S}return this._dataStream.createIterable()}emitData(m){this._dataStream?.emitData(m)}endExecution(m){m&&(this._commandLine=m),this._dataStream?.endExecution(),this._dataStream=void 0,this._ended=!0}}class S extends h.Disposable{constructor(){super(...arguments),this._emitters=[]}createIterable(){this._barrier||(this._barrier=new C.Barrier);const m=this._barrier;return new C.AsyncIterableObject(async u=>{this._emitters.push(u),await m.wait()})}emitData(m){for(const p of this._emitters)p.emitOne(m)}endExecution(){this._barrier?.open(),this._barrier=void 0}}}),define(Pe[173],ke([1,0,67,12,134,15,9]),function(ge,e,s,h,D,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorDecorationType=void 0,A=We(A);class R{static{this._Keys=new D.IdGenerator("TextEditorDecorationType")}constructor(f,T,S){const o=R._Keys.nextId();f.$registerTextEditorDecorationType(T.identifier,o,A.DecorationRenderOptions.from(S)),this.value=Object.freeze({key:o,dispose(){f.$removeTextEditorDecorationType(o)}})}}e.TextEditorDecorationType=R;class v{constructor(f,T){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=f,this._documentVersionId=f.version,this._undoStopBefore=T.undoStopBefore,this._undoStopAfter=T.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(f,T){this._throwIfFinalized();let S=null;if(f instanceof L.Position)S=new L.Range(f,f);else if(f instanceof L.Range)S=f;else throw new Error("Unrecognized location");this._pushEdit(S,T,!1)}insert(f,T){this._throwIfFinalized(),this._pushEdit(new L.Range(f,f),T,!0)}delete(f){this._throwIfFinalized();let T=null;if(f instanceof L.Range)T=f;else throw new Error("Unrecognized location");this._pushEdit(T,null,!0)}_pushEdit(f,T,S){const o=this._document.validateRange(f);this._collectedEdits.push({range:o,text:T,forceMoveMarkers:S})}setEndOfLine(f){if(this._throwIfFinalized(),f!==L.EndOfLine.LF&&f!==L.EndOfLine.CRLF)throw(0,h.illegalArgument)("endOfLine");this._setEndOfLine=f}}class l{constructor(f,T,S,o){this._proxy=f,this._id=T,this._accept(S),this._logService=o;const m=this;this.value={get tabSize(){return m._tabSize},set tabSize(p){m._setTabSize(p)},get indentSize(){return m._indentSize},set indentSize(p){m._setIndentSize(p)},get insertSpaces(){return m._insertSpaces},set insertSpaces(p){m._setInsertSpaces(p)},get cursorStyle(){return m._cursorStyle},set cursorStyle(p){m._setCursorStyle(p)},get lineNumbers(){return m._lineNumbers},set lineNumbers(p){m._setLineNumbers(p)}}}_accept(f){this._tabSize=f.tabSize,this._indentSize=f.indentSize,this._originalIndentSize=f.originalIndentSize,this._insertSpaces=f.insertSpaces,this._cursorStyle=f.cursorStyle,this._lineNumbers=A.TextEditorLineNumbersStyle.to(f.lineNumbers)}_validateTabSize(f){if(f==="auto")return"auto";if(typeof f=="number"){const T=Math.floor(f);return T>0?T:null}if(typeof f=="string"){const T=parseInt(f,10);return isNaN(T)?null:T>0?T:null}return null}_setTabSize(f){const T=this._validateTabSize(f);if(T!==null){if(typeof T=="number"){if(this._tabSize===T)return;this._tabSize=T}this._warnOnError("setTabSize",this._proxy.$trySetOptions(this._id,{tabSize:T}))}}_validateIndentSize(f){if(f==="tabSize")return"tabSize";if(typeof f=="number"){const T=Math.floor(f);return T>0?T:null}if(typeof f=="string"){const T=parseInt(f,10);return isNaN(T)?null:T>0?T:null}return null}_setIndentSize(f){const T=this._validateIndentSize(f);if(T!==null){if(typeof T=="number"){if(this._originalIndentSize===T)return;this._indentSize=T,this._originalIndentSize=T}this._warnOnError("setIndentSize",this._proxy.$trySetOptions(this._id,{indentSize:T}))}}_validateInsertSpaces(f){return f==="auto"?"auto":f==="false"?!1:!!f}_setInsertSpaces(f){const T=this._validateInsertSpaces(f);if(typeof T=="boolean"){if(this._insertSpaces===T)return;this._insertSpaces=T}this._warnOnError("setInsertSpaces",this._proxy.$trySetOptions(this._id,{insertSpaces:T}))}_setCursorStyle(f){this._cursorStyle!==f&&(this._cursorStyle=f,this._warnOnError("setCursorStyle",this._proxy.$trySetOptions(this._id,{cursorStyle:f})))}_setLineNumbers(f){this._lineNumbers!==f&&(this._lineNumbers=f,this._warnOnError("setLineNumbers",this._proxy.$trySetOptions(this._id,{lineNumbers:A.TextEditorLineNumbersStyle.from(f)})))}assign(f){const T={};let S=!1;if(typeof f.tabSize<"u"){const o=this._validateTabSize(f.tabSize);o==="auto"?(S=!0,T.tabSize=o):typeof o=="number"&&this._tabSize!==o&&(this._tabSize=o,S=!0,T.tabSize=o)}if(typeof f.indentSize<"u"){const o=this._validateIndentSize(f.indentSize);o==="tabSize"?(S=!0,T.indentSize=o):typeof o=="number"&&this._originalIndentSize!==o&&(this._indentSize=o,this._originalIndentSize=o,S=!0,T.indentSize=o)}if(typeof f.insertSpaces<"u"){const o=this._validateInsertSpaces(f.insertSpaces);o==="auto"?(S=!0,T.insertSpaces=o):this._insertSpaces!==o&&(this._insertSpaces=o,S=!0,T.insertSpaces=o)}typeof f.cursorStyle<"u"&&this._cursorStyle!==f.cursorStyle&&(this._cursorStyle=f.cursorStyle,S=!0,T.cursorStyle=f.cursorStyle),typeof f.lineNumbers<"u"&&this._lineNumbers!==f.lineNumbers&&(this._lineNumbers=f.lineNumbers,S=!0,T.lineNumbers=A.TextEditorLineNumbersStyle.from(f.lineNumbers)),S&&this._warnOnError("setOptions",this._proxy.$trySetOptions(this._id,T))}_warnOnError(f,T){T.catch(S=>{this._logService.warn(`ExtHostTextEditorOptions '${f}' failed:'`),this._logService.warn(S)})}}e.ExtHostTextEditorOptions=l;class C{constructor(f,T,S,o,m,p,u,i){this.id=f,this._proxy=T,this._logService=S,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=m,this._options=new l(this._proxy,this.id,p,S),this._visibleRanges=u,this._viewColumn=i;const a=this;this.value=Object.freeze({get document(){return o.value},set document(t){throw new h.ReadonlyError("document")},get selection(){return a._selections&&a._selections[0]},set selection(t){if(!(t instanceof L.Selection))throw(0,h.illegalArgument)("selection");a._selections=[t],a._trySetSelection()},get selections(){return a._selections},set selections(t){if(!Array.isArray(t)||t.some(n=>!(n instanceof L.Selection)))throw(0,h.illegalArgument)("selections");a._selections=t,a._trySetSelection()},get visibleRanges(){return a._visibleRanges},set visibleRanges(t){throw new h.ReadonlyError("visibleRanges")},get options(){return a._options.value},set options(t){a._disposed||a._options.assign(t)},get viewColumn(){return a._viewColumn},set viewColumn(t){throw new h.ReadonlyError("viewColumn")},edit(t,n={undoStopBefore:!0,undoStopAfter:!0}){if(a._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const r=new v(o.value,n);return t(r),a._applyEdit(r)},insertSnippet(t,n,r={undoStopBefore:!0,undoStopAfter:!0}){if(a._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let d;if(!n||Array.isArray(n)&&n.length===0)d=a._selections.map(c=>A.Range.from(c));else if(n instanceof L.Position){const{lineNumber:c,column:g}=A.Position.from(n);d=[{startLineNumber:c,startColumn:g,endLineNumber:c,endColumn:g}]}else if(n instanceof L.Range)d=[A.Range.from(n)];else{d=[];for(const c of n)if(c instanceof L.Range)d.push(A.Range.from(c));else{const{lineNumber:g,column:w}=A.Position.from(c);d.push({startLineNumber:g,startColumn:w,endLineNumber:g,endColumn:w})}}return T.$tryInsertSnippet(f,o.value.version,t.value,d,r)},setDecorations(t,n){const r=n.length===0;r&&!a._hasDecorationsForKey.has(t.key)||(r?a._hasDecorationsForKey.delete(t.key):a._hasDecorationsForKey.add(t.key),a._runOnProxy(()=>{if(A.isDecorationOptionsArr(n))return T.$trySetDecorations(f,t.key,A.fromRangeOrRangeWithMessage(n));{const d=new Array(4*n.length);for(let c=0,g=n.length;c<g;c++){const w=n[c];d[4*c]=w.start.line+1,d[4*c+1]=w.start.character+1,d[4*c+2]=w.end.line+1,d[4*c+3]=w.end.character+1}return T.$trySetDecorationsFast(f,t.key,d)}}))},revealRange(t,n){a._runOnProxy(()=>T.$tryRevealRange(f,A.Range.from(t),n||L.TextEditorRevealType.Default))},show(t){T.$tryShowEditor(f,A.ViewColumn.from(t))},hide(){T.$tryHideEditor(f)},[Symbol.for("debug.description")](){return`TextEditor(${this.document.uri.toString()})`}})}dispose(){(0,s.ok)(!this._disposed),this._disposed=!0}_acceptOptions(f){(0,s.ok)(!this._disposed),this._options._accept(f)}_acceptVisibleRanges(f){(0,s.ok)(!this._disposed),this._visibleRanges=f}_acceptViewColumn(f){(0,s.ok)(!this._disposed),this._viewColumn=f}_acceptSelections(f){(0,s.ok)(!this._disposed),this._selections=f}async _trySetSelection(){const f=this._selections.map(A.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,f)),this.value}_applyEdit(f){const T=f.finalize();if(T.edits.length===0&&!T.setEndOfLine)return Promise.resolve(!0);const S=T.edits.map(m=>m.range);S.sort((m,p)=>m.end.line===p.end.line?m.end.character===p.end.character?m.start.line===p.start.line?m.start.character-p.start.character:m.start.line-p.start.line:m.end.character-p.end.character:m.end.line-p.end.line);for(let m=0,p=S.length-1;m<p;m++){const u=S[m].end;if(S[m+1].start.isBefore(u))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const o=T.edits.map(m=>({range:A.Range.from(m.range),text:m.text,forceMoveMarkers:m.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,T.documentVersionId,o,{setEndOfLine:typeof T.setEndOfLine=="number"?A.EndOfLine.from(T.setEndOfLine):void 0,undoStopBefore:T.undoStopBefore,undoStopAfter:T.undoStopAfter})}_runOnProxy(f){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):f().then(()=>this,T=>(T instanceof Error&&T.name==="DISPOSED"||this._logService.warn(T),null))}}e.ExtHostTextEditor=C}),define(Pe[65],ke([1,0,67,4,3,2,5,6,169,19,173,15,11,28,14,40,50]),function(ge,e,s,h,D,A,L,R,v,l,C,_,f,T,S,o,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0,s=We(s),_=We(_);class p{constructor(a){this.value=a,this._count=0}ref(){this._count++}unref(){return--this._count===0}}let u=class{constructor(a,t){this._extHostRpc=a,this._logService=t,this._activeEditorId=null,this._editors=new Map,this._documents=new T.ResourceMap,this._onDidAddDocuments=new h.Emitter,this._onDidRemoveDocuments=new h.Emitter,this._onDidChangeVisibleTextEditors=new h.Emitter,this._onDidChangeActiveTextEditor=new h.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(a){this.acceptDocumentsAndEditorsDelta(a)}acceptDocumentsAndEditorsDelta(a){const t=[],n=[],r=[];if(a.removedDocuments)for(const d of a.removedDocuments){const c=A.URI.revive(d),g=this._documents.get(c);g?.unref()&&(this._documents.delete(c),t.push(g.value))}if(a.addedDocuments)for(const d of a.addedDocuments){const c=A.URI.revive(d.uri);let g=this._documents.get(c);if(g&&c.scheme!==S.Schemas.vscodeNotebookCell&&c.scheme!==S.Schemas.vscodeInteractiveInput)throw new Error(`document '${c} already exists!'`);g||(g=new p(new v.ExtHostDocumentData(this._extHostRpc.getProxy(R.MainContext.MainThreadDocuments),c,d.lines,d.EOL,d.versionId,d.languageId,d.isDirty)),this._documents.set(c,g),n.push(g.value)),g.ref()}if(a.removedEditors)for(const d of a.removedEditors){const c=this._editors.get(d);this._editors.delete(d),c&&r.push(c)}if(a.addedEditors)for(const d of a.addedEditors){const c=A.URI.revive(d.documentUri);s.ok(this._documents.has(c),`document '${c}' does not exist`),s.ok(!this._editors.has(d.id),`editor '${d.id}' already exists!`);const g=this._documents.get(c).value,w=new C.ExtHostTextEditor(d.id,this._extHostRpc.getProxy(R.MainContext.MainThreadTextEditors),this._logService,new m.Lazy(()=>g.document),d.selections.map(_.Selection.to),d.options,d.visibleRanges.map(y=>_.Range.to(y)),typeof d.editorPosition=="number"?_.ViewColumn.to(d.editorPosition):void 0);this._editors.set(d.id,w)}a.newActiveEditor!==void 0&&(s.ok(a.newActiveEditor===null||this._editors.has(a.newActiveEditor),`active editor '${a.newActiveEditor}' does not exist`),this._activeEditorId=a.newActiveEditor),(0,D.dispose)(t),(0,D.dispose)(r),a.removedDocuments&&this._onDidRemoveDocuments.fire(t),a.addedDocuments&&this._onDidAddDocuments.fire(n),(a.removedEditors||a.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(d=>d.value)),a.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(a){return this._documents.get(a)?.value}allDocuments(){return o.Iterable.map(this._documents.values(),a=>a.value)}getEditor(a){return this._editors.get(a)}activeEditor(a){if(!this._activeEditorId)return;const t=this._editors.get(this._activeEditorId);return a?t:t?.value}allEditors(){return[...this._editors.values()]}};e.ExtHostDocumentsAndEditors=u,e.ExtHostDocumentsAndEditors=u=Qe([$e(0,l.IExtHostRpcService),$e(1,f.ILogService)],u),e.IExtHostDocumentsAndEditors=(0,L.createDecorator)("IExtHostDocumentsAndEditors")}),define(Pe[99],ke([1,0,8,21,20,4,81,61,3,41,17,2,31,5,11,6,35,65,19,171,15,9,266,75,120,76,25]),function(ge,e,s,h,D,A,L,R,v,l,C,_,f,T,S,o,m,p,u,i,a,t,n,r,d,c,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=e.IExtHostTesting=void 0,a=We(a);let w=0;const y=new WeakMap;e.IExtHostTesting=(0,T.createDecorator)("IExtHostTesting");let I=class extends v.Disposable{constructor(W,Z,J,oe){super(),this.logService=Z,this.commands=J,this.editors=oe,this.resultsChangedEmitter=this._register(new A.Emitter),this.controllers=new Map,this.defaultProfilesChangedEmitter=this._register(new A.Emitter),this.followupProviders=new Set,this.testFollowups=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=W.getProxy(o.MainContext.MainThreadTesting),this.observer=new H(this.proxy),this.runTracker=new E(this.proxy,Z),J.registerArgumentProcessor({processArgument:te=>{switch(te?.$mid){case l.MarshalledId.TestItemContext:{const me=te,le=me.tests[me.tests.length-1].item.extId;return this.controllers.get(r.TestId.root(le))?.collection.tree.get(le)?.actual??(0,i.toItemFromContext)(te)}case l.MarshalledId.TestMessageMenuArgs:{const{test:me,message:le}=te,Q=me.item.extId;return{test:this.controllers.get(r.TestId.root(Q))?.collection.tree.get(Q)?.actual??(0,i.toItemFromContext)({$mid:l.MarshalledId.TestItemContext,tests:[me]}),message:a.TestMessage.to(le)}}default:return te}}}),J.registerCommand(!1,"testing.getExplorerSelection",async()=>{const te=await J.executeCommand(n.TestCommandId.GetExplorerSelection),me=le=>{const Q=this.controllers.get(r.TestId.root(le));if(Q)return r.TestId.isRoot(le)?Q.controller:Q.collection.tree.get(le)?.actual};return{include:te?.include.map(me).filter(C.isDefined)||[],exclude:te?.exclude.map(me).filter(C.isDefined)||[]}})}createTestController(W,Z,J,oe){if(this.controllers.has(Z))throw new Error(`Attempt to insert a duplicate controller with ID "${Z}"`);const te=new v.DisposableStore,me=te.add(new i.ExtHostTestItemCollection(Z,J,this.editors));me.root.label=J;const le=new Map,Q=new Set,z=this.proxy,se=()=>{let be=0;oe&&(be|=c.TestControllerCapability.Refresh);const pe=ae.relatedCodeProvider;return pe&&(pe?.provideRelatedTests&&(be|=c.TestControllerCapability.TestRelatedToCode),pe?.provideRelatedCode&&(be|=c.TestControllerCapability.CodeRelatedToTest)),be},Ee={items:me.root.children,get label(){return J},set label(be){J=be,me.root.label=be,z.$updateController(Z,{label:J})},get refreshHandler(){return oe},set refreshHandler(be){oe=be,z.$updateController(Z,{capabilities:se()})},get id(){return Z},get relatedCodeProvider(){return ae.relatedCodeProvider},set relatedCodeProvider(be){(0,g.checkProposedApiEnabled)(W,"testRelatedCode"),ae.relatedCodeProvider=be,z.$updateController(Z,{capabilities:se()})},createRunProfile:(be,pe,ve,Re,Fe,Ve)=>{let Ye=(0,R.hash)(be);for(;le.has(Ye);)Ye++;return new x(this.proxy,le,Q,this.defaultProfilesChangedEmitter.event,Z,Ye,be,pe,ve,Re,Fe,Ve)},createTestItem(be,pe,ve){return new i.TestItemImpl(Z,be,pe,ve)},createTestRun:(be,pe,ve=!0)=>this.runTracker.createTestRun(W,Z,me,be,pe,ve),invalidateTestResults:be=>{if(be===void 0)this.proxy.$markTestRetired(void 0);else{const pe=be instanceof Array?be:[be];this.proxy.$markTestRetired(pe.map(ve=>r.TestId.fromExtHostTestItem(ve,Z).toString()))}},set resolveHandler(be){me.resolveHandler=be},get resolveHandler(){return me.resolveHandler},dispose:()=>{te.dispose()}},ae={controller:Ee,collection:me,profiles:le,extension:W,activeProfiles:Q};return z.$registerTestController(Z,J,se()),te.add((0,v.toDisposable)(()=>z.$unregisterTestController(Z))),this.controllers.set(Z,ae),te.add((0,v.toDisposable)(()=>this.controllers.delete(Z))),te.add(me.onDidGenerateDiff(be=>z.$publishDiff(Z,be.map(c.TestsDiffOp.serialize)))),Ee}createTestObserver(){return this.observer.checkout()}async runTests(W,Z=D.CancellationToken.None){const J=N(W);if(!J)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const oe=this.controllers.get(J.controllerId);if(!oe)throw new Error("Controller not found");await this.proxy.$runTests({preserveFocus:W.preserveFocus??!0,group:$[J.kind],targets:[{testIds:W.include?.map(te=>r.TestId.fromExtHostTestItem(te,oe.collection.root.id).toString())??[oe.collection.root.id],profileId:J.profileId,controllerId:J.controllerId}],exclude:W.exclude?.map(te=>te.id)},Z)}registerTestFollowupProvider(W){return this.followupProviders.add(W),{dispose:()=>{this.followupProviders.delete(W)}}}async $getTestsRelatedToCode(W,Z,J){const oe=this.editors.getDocument(_.URI.revive(W));if(!oe)return[];const te=a.Position.to(Z),me=[];return await Promise.all([...this.controllers.values()].map(async le=>{let Q;try{Q=await le.relatedCodeProvider?.provideRelatedTests?.(oe.document,te,J)}catch(z){J.isCancellationRequested||this.logService.warn(`Error thrown while providing related tests for ${le.controller.label}`,z)}if(Q){for(const z of Q)me.push(r.TestId.fromExtHostTestItem(z,le.controller.id).toString());le.collection.flushDiff()}})),me}async $getCodeRelatedToTest(W,Z){const J=this.controllers.get(r.TestId.root(W));if(!J)return[];const oe=J.collection.tree.get(W);return oe?(await J.relatedCodeProvider?.provideRelatedCode?.(oe.actual,Z))?.map(a.location.from)??[]:[]}$syncTests(){for(const{collection:W}of this.controllers.values())W.flushDiff();return Promise.resolve()}async $getCoverageDetails(W,Z,J){return(await this.runTracker.getCoverageDetails(W,Z,J))?.map(a.TestCoverage.fromDetails)}async $disposeRun(W){this.runTracker.disposeTestRun(W)}$configureRunProfile(W,Z){this.controllers.get(W)?.profiles.get(Z)?.configureHandler?.()}$setDefaultRunProfiles(W){const Z=new Map;for(const[J,oe]of Object.entries(W)){const te=this.controllers.get(J);if(!te)continue;const me=new Map,le=oe.filter(z=>!te.activeProfiles.has(z)),Q=[...te.activeProfiles].filter(z=>!oe.includes(z));for(const z of le)me.set(z,!0),te.activeProfiles.add(z);for(const z of Q)me.set(z,!1),te.activeProfiles.delete(z);me.size&&Z.set(J,me)}this.defaultProfilesChangedEmitter.fire(Z)}async $refreshTests(W,Z){await this.controllers.get(W)?.controller.refreshHandler?.(Z)}$publishTestResults(W){this.results=Object.freeze(W.map(Z=>{const J=a.TestResults.to(Z),oe=Z.tasks.findIndex(te=>te.hasCoverage);return oe!==-1&&(J.getDetailedCoverage=(te,me=D.CancellationToken.None)=>this.proxy.$getCoverageDetails(Z.id,oe,te,me).then(le=>le.map(a.TestCoverage.to))),y.set(J,Z.id),J}).concat(this.results).sort((Z,J)=>J.completedAt-Z.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $expandTest(W,Z){const J=this.controllers.get(r.TestId.fromString(W).controllerId)?.collection;J&&(await J.expand(W,Z<0?1/0:Z),J.flushDiff())}$acceptDiff(W){this.observer.applyDiff(W.map(Z=>c.TestsDiffOp.deserialize({asCanonicalUri:J=>J},Z)))}async $runControllerTests(W,Z){return Promise.all(W.map(J=>this.runControllerTestRequest(J,!1,Z)))}async $startContinuousRun(W,Z){const J=new D.CancellationTokenSource(Z),oe=await Promise.all(W.map(te=>this.runControllerTestRequest(te,!0,J.token)));return!Z.isCancellationRequested&&!oe.some(te=>te.error)&&await new Promise(te=>Z.onCancellationRequested(te)),J.dispose(!0),oe}async $provideTestFollowups(W,Z){const J=this.results.find(me=>y.get(me)===W.resultId),oe=J&&G(r.TestId.fromString(W.extId),J?.results);if(!oe)return[];let te=[];return await Promise.all([...this.followupProviders].map(async me=>{try{const le=await me.provideFollowup(J,oe,W.taskIndex,W.messageIndex,Z);le&&(te=te.concat(le))}catch(le){this.logService.error("Error thrown while providing followup for test message",le)}})),Z.isCancellationRequested?[]:te.map(me=>{const le=w++;return this.testFollowups.set(le,me),{title:me.title,id:le}})}$disposeTestFollowups(W){for(const Z of W)this.testFollowups.delete(Z)}$executeTestFollowup(W){const Z=this.testFollowups.get(W);return Z?this.commands.executeCommand(Z.command,...Z.arguments||[]):Promise.resolve()}$cancelExtensionTestRun(W,Z){W===void 0?this.runTracker.cancelAllRuns():this.runTracker.cancelRunById(W,Z)}getMetadataForRun(W){for(const Z of this.runTracker.trackers){const J=Z.getTaskIdForRun(W);if(J)return{taskId:J,runId:Z.id}}}async runControllerTestRequest(W,Z,J){const oe=this.controllers.get(W.controllerId);if(!oe)return{};const{collection:te,profiles:me,extension:le}=oe,Q=me.get(W.profileId);if(!Q)return{};const z=W.testIds.map(be=>te.tree.get(be)).filter(C.isDefined),se=W.excludeExtIds.map(be=>oe.collection.tree.get(be)).filter(C.isDefined).filter(be=>z.some(pe=>pe.fullId.compare(be.fullId)===r.TestPosition.IsChild));if(!z.length)return{};const Ee=new t.TestRunRequest(z.some(be=>be.actual instanceof i.TestItemRootImpl)?void 0:z.map(be=>be.actual),se.map(be=>be.actual),Q,Z),ae=(0,c.isStartControllerTests)(W)&&this.runTracker.prepareForMainThreadTestRun(le,Ee,O.fromInternal(W,oe.collection),Q,J);try{return await Q.runHandler(Ee,J),{}}catch(be){return{error:String(be)}}finally{ae&&ae.hasRunningTasks&&!J.isCancellationRequested&&await A.Event.toPromise(ae.onEnd)}}};e.ExtHostTesting=I,e.ExtHostTesting=I=Qe([$e(0,u.IExtHostRpcService),$e(1,S.ILogService),$e(2,m.IExtHostCommands),$e(3,p.IExtHostDocumentsAndEditors)],I);const P=1e4;var k;(function(B){B[B.Running=0]="Running",B[B.Cancelling=1]="Cancelling",B[B.Ended=2]="Ended"})(k||(k={}));class b extends v.Disposable{get hasRunningTasks(){return this.running>0}get id(){return this.dto.id}constructor(W,Z,J,oe,te,me){super(),this.dto=W,this.proxy=Z,this.logService=J,this.profile=oe,this.extension=te,this.state=k.Running,this.running=0,this.tasks=new Map,this.sharedTestIds=new Set,this.endEmitter=this._register(new A.Emitter),this.publishedCoverage=new Map,this.onEnd=this.endEmitter.event,this.cts=this._register(new D.CancellationTokenSource(me));const le=this._register(new s.RunOnceScheduler(()=>this.forciblyEndTasks(),P));this._register(this.cts.token.onCancellationRequested(()=>le.schedule()));const Q=new A.Emitter;this.onDidDispose=Q.event,this._register((0,v.toDisposable)(()=>{Q.fire(),Q.dispose()}))}getTaskIdForRun(W){for(const[Z,{run:J}]of this.tasks)if(J===W)return Z}cancel(W){W?this.tasks.get(W)?.cts.cancel():this.state===k.Running?(this.cts.cancel(),this.state=k.Cancelling):this.state===k.Cancelling&&this.forciblyEndTasks()}async getCoverageDetails(W,Z,J){const[,oe]=r.TestId.fromString(W).path,te=this.publishedCoverage.get(W);if(!te)return[];const{report:me,extIds:le}=te,Q=this.tasks.get(oe);if(!Q)throw new Error("unreachable: run task was not found");let z;if(Z&&me instanceof t.FileCoverage){const Ee=le.indexOf(Z);if(Ee===-1)return[];z=me.fromTests[Ee]}return await(z?this.profile?.loadDetailedCoverageForTest?.(Q.run,me,z,J):this.profile?.loadDetailedCoverage?.(Q.run,me,J))??[]}createRun(W){const Z=this.dto.id,J=this.dto.controllerId,oe=(0,f.generateUuid)(),te=se=>(Ee,...ae)=>{if(le){this.logService.warn(`Setting the state of test "${Ee.id}" is a no-op after the run ends.`);return}this.ensureTestIsKnown(Ee),se(Ee,...ae)},me=(se,Ee)=>{const ae=Ee instanceof Array?Ee.map(a.TestMessage.from):[a.TestMessage.from(Ee)];if(se.uri&&se.range){const be={range:a.Range.from(se.range),uri:se.uri};for(const pe of ae)pe.location=pe.location||be}this.proxy.$appendTestMessagesInRun(Z,oe,r.TestId.fromExtHostTestItem(se,J).toString(),ae)};let le=!1;const Q=this._register(new D.CancellationTokenSource(this.cts.token)),z={isPersisted:this.dto.isPersisted,token:Q.token,name:W,onDidDispose:this.onDidDispose,addCoverage:se=>{if(le)return;const Ee=se instanceof t.FileCoverage?se.fromTests:[];if(Ee.length){(0,g.checkProposedApiEnabled)(this.extension,"attributableCoverage");for(const pe of Ee)this.ensureTestIsKnown(pe)}const ae=se.uri.toString(),be=new r.TestId([Z,oe,ae]).toString();this.publishedCoverage.set(be,{report:se,extIds:Ee.map(pe=>r.TestId.fromExtHostTestItem(pe,J).toString())}),this.proxy.$appendCoverage(Z,oe,a.TestCoverage.fromFile(J,be,se))},enqueued:te(se=>{this.proxy.$updateTestStateInRun(Z,oe,r.TestId.fromExtHostTestItem(se,J).toString(),c.TestResultState.Queued)}),skipped:te(se=>{this.proxy.$updateTestStateInRun(Z,oe,r.TestId.fromExtHostTestItem(se,J).toString(),c.TestResultState.Skipped)}),started:te(se=>{this.proxy.$updateTestStateInRun(Z,oe,r.TestId.fromExtHostTestItem(se,J).toString(),c.TestResultState.Running)}),errored:te((se,Ee,ae)=>{me(se,Ee),this.proxy.$updateTestStateInRun(Z,oe,r.TestId.fromExtHostTestItem(se,J).toString(),c.TestResultState.Errored,ae)}),failed:te((se,Ee,ae)=>{me(se,Ee),this.proxy.$updateTestStateInRun(Z,oe,r.TestId.fromExtHostTestItem(se,J).toString(),c.TestResultState.Failed,ae)}),passed:te((se,Ee)=>{this.proxy.$updateTestStateInRun(Z,oe,r.TestId.fromExtHostTestItem(se,this.dto.controllerId).toString(),c.TestResultState.Passed,Ee)}),appendOutput:(se,Ee,ae)=>{le||(ae&&this.ensureTestIsKnown(ae),this.proxy.$appendOutputToRun(Z,oe,h.VSBuffer.fromString(se),Ee&&a.location.from(Ee),ae&&r.TestId.fromExtHostTestItem(ae,J).toString()))},end:()=>{le||(le=!0,this.proxy.$finishedTestRunTask(Z,oe),--this.running||this.markEnded())}};return this.running++,this.tasks.set(oe,{run:z,cts:Q}),this.proxy.$startedTestRunTask(Z,{id:oe,ctrlId:this.dto.controllerId,name:W||this.extension.displayName||this.extension.identifier.value,running:!0}),z}forciblyEndTasks(){for(const{run:W}of this.tasks.values())W.end()}markEnded(){this.state!==k.Ended&&(this.state=k.Ended,this.endEmitter.fire())}ensureTestIsKnown(W){if(!(W instanceof i.TestItemImpl))throw new d.InvalidTestItemError(W.id);if(this.sharedTestIds.has(r.TestId.fromExtHostTestItem(W,this.dto.controllerId).toString()))return;const Z=[],J=this.dto.colllection.root;for(;;){const oe=a.TestItem.from(W);if(Z.unshift(oe),this.sharedTestIds.has(oe.extId)||(this.sharedTestIds.add(oe.extId),W===J))break;W=W.parent||J}this.proxy.$addTestsToRun(this.dto.controllerId,this.dto.id,Z)}dispose(){this.markEnded(),super.dispose()}}class E{get trackers(){return this.tracked.values()}constructor(W,Z){this.proxy=W,this.logService=Z,this.tracked=new Map,this.trackedById=new Map}getCoverageDetails(W,Z,J){const oe=r.TestId.root(W);return this.trackedById.get(oe)?.getCoverageDetails(W,Z,J)||[]}disposeTestRun(W){this.trackedById.get(W)?.dispose(),this.trackedById.delete(W);for(const[Z,{id:J}]of this.tracked)J===W&&this.tracked.delete(Z)}prepareForMainThreadTestRun(W,Z,J,oe,te){return this.getTracker(Z,J,oe,W,te)}cancelRunById(W,Z){this.trackedById.get(W)?.cancel(Z)}cancelAllRuns(){for(const W of this.tracked.values())W.cancel()}createTestRun(W,Z,J,oe,te,me){const le=this.tracked.get(oe);if(le)return le.createRun(te);const Q=O.fromPublic(Z,J,oe,me),z=N(oe);this.proxy.$startedExtensionTestRun({controllerId:Z,continuous:!!oe.continuous,profile:z&&{group:$[z.kind],id:z.profileId},exclude:oe.exclude?.map(Ee=>r.TestId.fromExtHostTestItem(Ee,J.root.id).toString())??[],id:Q.id,include:oe.include?.map(Ee=>r.TestId.fromExtHostTestItem(Ee,J.root.id).toString())??[J.root.id],preserveFocus:oe.preserveFocus??!0,persist:me});const se=this.getTracker(oe,Q,oe.profile,W);return A.Event.once(se.onEnd)(()=>{this.proxy.$finishedExtensionTestRun(Q.id)}),se.createRun(te)}getTracker(W,Z,J,oe,te){const me=new b(Z,this.proxy,this.logService,J,oe,te);return this.tracked.set(W,me),this.trackedById.set(me.id,me),me}}e.TestRunCoordinator=E;const N=B=>{if(B.profile){if(!(B.profile instanceof x))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return B.profile}};class O{static fromPublic(W,Z,J,oe){return new O(W,(0,f.generateUuid)(),oe,Z)}static fromInternal(W,Z){return new O(W.controllerId,W.runId,!0,Z)}constructor(W,Z,J,oe){this.controllerId=W,this.id=Z,this.isPersisted=J,this.colllection=oe}}e.TestRunDto=O;class M{get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}constructor(W){this.emitter=W,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}add(W){this.added.add(W)}update(W){Object.assign(W.revived,a.TestItem.toPlain(W.item)),this.added.has(W)||this.updated.add(W)}remove(W){if(this.added.has(W)){this.added.delete(W);return}this.updated.delete(W);const Z=r.TestId.parentId(W.item.extId);if(Z&&this.alreadyRemoved.has(Z.toString())){this.alreadyRemoved.add(W.item.extId);return}this.removed.add(W)}getChangeEvent(){const{added:W,updated:Z,removed:J}=this;return{get added(){return[...W].map(oe=>oe.revived)},get updated(){return[...Z].map(oe=>oe.revived)},get removed(){return[...J].map(oe=>oe.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class U extends c.AbstractIncrementalTestCollection{constructor(){super(...arguments),this.changeEmitter=new A.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTests(){return this.roots}getMirroredTestDataById(W){return this.items.get(W)}getMirroredTestDataByReference(W){return this.items.get(W.id)}createItem(W,Z){return{...W,revived:a.TestItem.toPlain(W.item),depth:Z?Z.depth+1:0,children:new Set}}createChangeCollector(){return new M(this.changeEmitter)}}class H{constructor(W){this.proxy=W}checkout(){this.current||(this.current=this.createObserverData());const W=this.current;return W.observers++,{onDidChangeTest:W.tests.onDidChangeTests,get tests(){return[...W.tests.rootTests].map(Z=>Z.revived)},dispose:(0,L.createSingleCallFunction)(()=>{--W.observers===0&&(this.proxy.$unsubscribeFromDiffs(),this.current=void 0)})}}getMirroredTestDataByReference(W){return this.current?.tests.getMirroredTestDataByReference(W)}applyDiff(W){this.current?.tests.apply(W)}createObserverData(){const W=new U({asCanonicalUri:Z=>Z});return this.proxy.$subscribeToDiffs(),{observers:0,tests:W}}}const F=(B,W,Z,J)=>{Z?Object.assign(Z,J):W.$updateTestRunConfig(B.controllerId,B.profileId,J)};class x{#e;#t;#i;#n;#s;get label(){return this._label}set label(W){W!==this._label&&(this._label=W,F(this,this.#e,this.#n,{label:W}))}get supportsContinuousRun(){return this._supportsContinuousRun}set supportsContinuousRun(W){W!==this._supportsContinuousRun&&(this._supportsContinuousRun=W,F(this,this.#e,this.#n,{supportsContinuousRun:W}))}get isDefault(){return this.#t.has(this.profileId)}set isDefault(W){W!==this.isDefault&&(W?this.#t.add(this.profileId):this.#t.delete(this.profileId),F(this,this.#e,this.#n,{isDefault:W}))}get tag(){return this._tag}set tag(W){W?.id!==this._tag?.id&&(this._tag=W,F(this,this.#e,this.#n,{tag:W?a.TestTag.namespace(this.controllerId,W.id):null}))}get configureHandler(){return this._configureHandler}set configureHandler(W){W!==this._configureHandler&&(this._configureHandler=W,F(this,this.#e,this.#n,{hasConfigurationHandler:!!W}))}get onDidChangeDefault(){return A.Event.chain(this.#i,W=>W.map(Z=>Z.get(this.controllerId)?.get(this.profileId)).filter(C.isDefined))}constructor(W,Z,J,oe,te,me,le,Q,z,se=!1,Ee=void 0,ae=!1){this.controllerId=te,this.profileId=me,this._label=le,this.kind=Q,this.runHandler=z,this._tag=Ee,this._supportsContinuousRun=ae,this.#e=W,this.#s=Z,this.#t=J,this.#i=oe,Z.set(me,this);const be=$[Q];if(typeof be!="number")throw new Error(`Unknown TestRunProfile.group ${Q}`);se&&J.add(me),this.#n={profileId:me,controllerId:te,tag:Ee?a.TestTag.namespace(this.controllerId,Ee.id):null,label:le,group:be,isDefault:se,hasConfigurationHandler:!1,supportsContinuousRun:ae},queueMicrotask(()=>{this.#n&&(this.#e.$publishTestRunProfile(this.#n),this.#n=void 0)})}dispose(){this.#s?.delete(this.profileId)&&(this.#s=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId)),this.#n=void 0}}e.TestRunProfileImpl=x;const $={[t.TestRunProfileKind.Coverage]:c.TestRunProfileBitset.Coverage,[t.TestRunProfileKind.Debug]:c.TestRunProfileBitset.Debug,[t.TestRunProfileKind.Run]:c.TestRunProfileBitset.Run};function G(B,W){for(let Z=0;Z<B.path.length;Z++){const J=W.find(oe=>oe.id===B.path[Z]);if(!J)return;if(Z===B.path.length-1)return J;W=J.children}}}),define(Pe[322],ke([1,0,18,4,3,6,173,15,9]),function(ge,e,s,h,D,A,L,R,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0,s=We(s),R=We(R);class l extends D.Disposable{constructor(_,f){super(),this._extHostDocumentsAndEditors=f,this._onDidChangeTextEditorSelection=new h.Emitter,this._onDidChangeTextEditorOptions=new h.Emitter,this._onDidChangeTextEditorVisibleRanges=new h.Emitter,this._onDidChangeTextEditorViewColumn=new h.Emitter,this._onDidChangeActiveTextEditor=new h.Emitter,this._onDidChangeVisibleTextEditors=new h.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=_.getProxy(A.MainContext.MainThreadTextEditors),this._register(this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(T=>this._onDidChangeVisibleTextEditors.fire(T))),this._register(this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(T=>this._onDidChangeActiveTextEditor.fire(T)))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(_){const f=this._extHostDocumentsAndEditors.allEditors();return _?f:f.map(T=>T.value)}async showTextDocument(_,f,T){let S;typeof f=="number"?S={position:R.ViewColumn.from(f),preserveFocus:T}:typeof f=="object"?S={position:R.ViewColumn.from(f.viewColumn),preserveFocus:f.preserveFocus,selection:typeof f.selection=="object"?R.Range.from(f.selection):void 0,pinned:typeof f.preview=="boolean"?!f.preview:void 0}:S={preserveFocus:!1};const o=await this._proxy.$tryShowTextDocument(_.uri,S),m=o&&this._extHostDocumentsAndEditors.getEditor(o);if(m)return m.value;throw o?new Error(`Could NOT open editor for "${_.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${_.uri.toString()}".`)}createTextEditorDecorationType(_,f){return new L.TextEditorDecorationType(this._proxy,_,f).value}$acceptEditorPropertiesChanged(_,f){const T=this._extHostDocumentsAndEditors.getEditor(_);if(!T)throw new Error("unknown text editor");if(f.options&&T._acceptOptions(f.options),f.selections){const S=f.selections.selections.map(R.Selection.to);T._acceptSelections(S)}if(f.visibleRanges){const S=s.coalesce(f.visibleRanges.map(R.Range.to));T._acceptVisibleRanges(S)}if(f.options&&this._onDidChangeTextEditorOptions.fire({textEditor:T.value,options:{...f.options,lineNumbers:R.TextEditorLineNumbersStyle.to(f.options.lineNumbers)}}),f.selections){const S=v.TextEditorSelectionChangeKind.fromValue(f.selections.source),o=f.selections.selections.map(R.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:T.value,selections:o,kind:S})}if(f.visibleRanges){const S=s.coalesce(f.visibleRanges.map(R.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:T.value,visibleRanges:S})}}$acceptEditorPositionData(_){for(const f in _){const T=this._extHostDocumentsAndEditors.getEditor(f);if(!T)throw new Error("Unknown text editor");const S=R.ViewColumn.to(_[f]);T.value.viewColumn!==S&&(T._acceptViewColumn(S),this._onDidChangeTextEditorViewColumn.fire({textEditor:T.value,viewColumn:S}))}}getDiffInformation(_){return Promise.resolve(this._proxy.$getDiffInformation(_))}}e.ExtHostEditors=l}),define(Pe[323],ke([1,0,2,5,6,3,9,15,23,41,17]),function(ge,e,s,h,D,A,L,R,v,l,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,h.createDecorator)("IExtHostTimeline");class _{constructor(S,o){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=S.getProxy(D.MainContext.MainThreadTimeline),o.registerArgumentProcessor({processArgument:(m,p)=>{if(m&&m.$mid===l.MarshalledId.TimelineActionContext)if(this._providers.get(m.source)&&v.ExtensionIdentifier.equals(p,this._providers.get(m.source)?.extension)){const u=m.uri===void 0?void 0:s.URI.revive(m.uri);return this._itemsBySourceAndUriMap.get(m.source)?.get(f(u))?.get(m.handle)}else return;return m}})}async $getTimeline(S,o,m,p){return this._providers.get(S)?.provider.provideTimeline(s.URI.revive(o),m,p)}registerTimelineProvider(S,o,m,p){const u=new A.DisposableStore,i=this.convertTimelineItem(o.id,p,u).bind(this);let a;o.onDidChange&&(a=o.onDidChange(n=>this._proxy.$emitTimelineChangeEvent({uri:void 0,reset:!0,...n,id:o.id}),this));const t=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore({...o,scheme:S,onDidChange:void 0,async provideTimeline(n,r,d){r?.resetCache&&(u.clear(),t.get(o.id)?.clear());const c=await o.provideTimeline(n,r,d);if(c==null)return;const g=i(n,r);return{...c,source:o.id,items:c.items.map(g)}},dispose(){for(const n of t.values())n.get(o.id)?.clear();a?.dispose(),u.dispose()}},m)}convertTimelineItem(S,o,m){return(p,u)=>{let i;if(u?.cacheResults){let a=this._itemsBySourceAndUriMap.get(S);a===void 0&&(a=new Map,this._itemsBySourceAndUriMap.set(S,a));const t=f(p);i=a.get(t),i===void 0&&(i=new Map,a.set(t,i))}return a=>{const{iconPath:t,...n}=a,r=`${S}|${a.id??a.timestamp}`;i?.set(r,a);let d,c,g;a.iconPath&&(t instanceof L.ThemeIcon?g={id:t.id,color:t.color}:s.URI.isUri(t)?(d=t,c=t):{light:d,dark:c}=t);let w;return L.MarkdownString.isMarkdownString(n.tooltip)?w=R.MarkdownString.from(n.tooltip):(0,C.isString)(n.tooltip)?w=n.tooltip:L.MarkdownString.isMarkdownString(n.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),w=R.MarkdownString.from(n.detail)):(0,C.isString)(n.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),w=n.detail),{...n,id:n.id??void 0,handle:r,source:S,command:a.command?o.toInternal(a.command,m):void 0,icon:d,iconDark:c,themeIcon:g,tooltip:w,accessibilityInformation:a.accessibilityInformation}}}}registerTimelineProviderCore(S,o){if(this._providers.get(S.id))throw new Error(`Timeline Provider ${S.id} already exists.`);return this._proxy.$registerTimelineProvider({id:S.id,label:S.label,scheme:S.scheme}),this._providers.set(S.id,{provider:S,extension:o}),(0,A.toDisposable)(()=>{for(const p of this._itemsBySourceAndUriMap.values())p.get(S.id)?.clear();this._providers.delete(S.id),this._proxy.$unregisterTimelineProvider(S.id),S.dispose()})}}e.ExtHostTimeline=_;function f(T){return T?.toString()}}),define(Pe[324],ke([1,0,7,22,2,4,3,257,8,9,17,18,15,86,20,204,25]),function(ge,e,s,h,D,A,L,R,v,l,C,_,f,T,S,o,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0,l=We(l);function p(a,t){if((0,C.isString)(a))return{label:a};if(a&&typeof a=="object"&&typeof a.label=="string"){let n;return Array.isArray(a.highlights)&&(n=a.highlights.filter(r=>r.length===2&&typeof r[0]=="number"&&typeof r[1]=="number"),n=n.length?n:void 0),{label:a.label,highlights:n}}}class u extends L.Disposable{constructor(t,n,r){super(),this._proxy=t,this.commands=n,this.logService=r,this.treeViews=new Map,this.treeDragAndDropService=new o.TreeViewsDnDService;function d(c){return c&&c.$treeViewId&&(c.$treeItemHandle||c.$selectedTreeItems||c.$focusedTreeItem)}n.registerArgumentProcessor({processArgument:c=>d(c)?this.convertArgument(c):Array.isArray(c)&&c.length>0?c.map(g=>d(g)?this.convertArgument(g):g):c})}registerTreeDataProvider(t,n,r){const d=this.createTreeView(t,{treeDataProvider:n},r);return{dispose:()=>d.dispose()}}createTreeView(t,n,r){if(!n||!n.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const d=n.dragAndDropController?.dropMimeTypes??[],c=n.dragAndDropController?.dragMimeTypes??[],g=!!n.dragAndDropController?.handleDrag,w=!!n.dragAndDropController?.handleDrop,y=this.createExtHostTreeView(t,n,r),I={showCollapseAll:!!n.showCollapseAll,canSelectMany:!!n.canSelectMany,dropMimeTypes:d,dragMimeTypes:c,hasHandleDrag:g,hasHandleDrop:w,manuallyManageCheckboxes:!!n.manageCheckboxStateManually},P=this._proxy.$registerTreeViewDataProvider(t,I),k={get onDidCollapseElement(){return y.onDidCollapseElement},get onDidExpandElement(){return y.onDidExpandElement},get selection(){return y.selectedElements},get onDidChangeSelection(){return y.onDidChangeSelection},get activeItem(){return(0,m.checkProposedApiEnabled)(r,"treeViewActiveItem"),y.focusedElement},get onDidChangeActiveItem(){return(0,m.checkProposedApiEnabled)(r,"treeViewActiveItem"),y.onDidChangeActiveItem},get visible(){return y.visible},get onDidChangeVisibility(){return y.onDidChangeVisibility},get onDidChangeCheckboxState(){return y.onDidChangeCheckboxState},get message(){return y.message},set message(b){(0,T.isMarkdownString)(b)&&(0,m.checkProposedApiEnabled)(r,"treeViewMarkdownMessage"),y.message=b},get title(){return y.title},set title(b){y.title=b},get description(){return y.description},set description(b){y.description=b},get badge(){return y.badge},set badge(b){b!==void 0&&l.ViewBadge.isViewBadge(b)?y.badge={value:Math.floor(Math.abs(b.value)),tooltip:b.tooltip}:b===void 0&&(y.badge=void 0)},reveal:(b,E)=>y.reveal(b,E),dispose:async()=>{await P,this.treeViews.delete(t),y.dispose()}};return this._register(k),k}$getChildren(t,n){const r=this.treeViews.get(t);return r?r.getChildren(n):Promise.reject(new R.NoTreeViewError(t))}async $handleDrop(t,n,r,d,c,g,w,y){const I=this.treeViews.get(t);if(!I)return Promise.reject(new R.NoTreeViewError(t));const P=f.DataTransfer.toDataTransfer(r,async k=>(await this._proxy.$resolveDropFileData(t,n,k)).buffer);return w===t&&y&&await this.addAdditionalTransferItems(P,I,y,c,g),I.onDrop(P,d,c)}async addAdditionalTransferItems(t,n,r,d,c){const g=this.treeDragAndDropService.removeDragOperationTransfer(c);if(g)(await g)?.forEach((w,y)=>{w&&t.set(y,w)});else if(c&&n.handleDrag){const w=n.handleDrag(r,t,d);this.treeDragAndDropService.addDragOperationTransfer(c,w),await w}return t}async $handleDrag(t,n,r,d){const c=this.treeViews.get(t);if(!c)return Promise.reject(new R.NoTreeViewError(t));const g=await this.addAdditionalTransferItems(new l.DataTransfer,c,n,d,r);if(!(!g||d.isCancellationRequested))return f.DataTransfer.from(g)}async $hasResolve(t){const n=this.treeViews.get(t);if(!n)throw new R.NoTreeViewError(t);return n.hasResolve}$resolve(t,n,r){const d=this.treeViews.get(t);if(!d)throw new R.NoTreeViewError(t);return d.resolveTreeItem(n,r)}$setExpanded(t,n,r){const d=this.treeViews.get(t);if(!d)throw new R.NoTreeViewError(t);d.setExpanded(n,r)}$setSelectionAndFocus(t,n,r){const d=this.treeViews.get(t);if(!d)throw new R.NoTreeViewError(t);d.setSelectionAndFocus(n,r)}$setVisible(t,n){const r=this.treeViews.get(t);if(!r){if(!n)return;throw new R.NoTreeViewError(t)}r.setVisible(n)}$changeCheckboxState(t,n){const r=this.treeViews.get(t);if(!r)throw new R.NoTreeViewError(t);r.setCheckboxState(n)}createExtHostTreeView(t,n,r){const d=this._register(new i(t,n,this._proxy,this.commands.converter,this.logService,r));return this.treeViews.set(t,d),d}convertArgument(t){const n=this.treeViews.get(t.$treeViewId);return n&&"$treeItemHandle"in t?n.getExtensionElement(t.$treeItemHandle):n&&"$focusedTreeItem"in t&&t.$focusedTreeItem?n.focusedElement:null}}e.ExtHostTreeViews=u;class i extends L.Disposable{static{this.LABEL_HANDLE_PREFIX="0"}static{this.ID_HANDLE_PREFIX="1"}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(t=>this.getExtensionElement(t)).filter(t=>!(0,C.isUndefinedOrNull)(t))}get focusedElement(){return this._focusedHandle?this.getExtensionElement(this._focusedHandle):void 0}constructor(t,n,r,d,c,g){if(super(),this.viewId=t,this.proxy=r,this.commands=d,this.logService=c,this.extension=g,this.roots=void 0,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._focusedHandle=void 0,this._onDidExpandElement=this._register(new A.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new A.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new A.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeActiveItem=this._register(new A.Emitter),this.onDidChangeActiveItem=this._onDidChangeActiveItem.event,this._onDidChangeVisibility=this._register(new A.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeCheckboxState=this._register(new A.Emitter),this.onDidChangeCheckboxState=this._onDidChangeCheckboxState.event,this._onDidChangeData=this._register(new A.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new S.CancellationTokenSource,g.contributes&&g.contributes.views)for(const P in g.contributes.views)for(const k of g.contributes.views[P])k.id===t&&(this._title=k.name);this.dataProvider=n.treeDataProvider,this.dndController=n.dragAndDropController,this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(P=>{Array.isArray(P)&&P.length===0||this._onDidChangeData.fire({message:!1,element:P})}));let w,y;const I=A.Event.debounce(this._onDidChangeData.event,(P,k)=>(P||(P={message:!1,elements:[]}),k.element!==!1&&(w||(w=new Promise(b=>y=b),this.refreshPromise=this.refreshPromise.then(()=>w)),Array.isArray(k.element)?P.elements.push(...k.element):P.elements.push(k.element)),k.message&&(P.message=!0),P),200,!0);this._register(I(({message:P,elements:k})=>{k.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const b=y;return w=null,this.refresh(k).then(()=>b())})),P&&this.proxy.$setMessage(this.viewId,f.MarkdownString.fromStrict(this._message)??"")}))}async getChildren(t){const n=t?this.getExtensionElement(t):void 0;if(t&&!n)return this.logService.error(`No tree item with id '${t}' found.`),Promise.resolve([]);let r=this.getChildrenNodes(t);return r||(r=await this.fetchChildrenNodes(n)),r?r.map(d=>d.item):void 0}getExtensionElement(t){return this.elements.get(t)}reveal(t,n){n=n||{select:!0,focus:!1};const r=(0,C.isUndefinedOrNull)(n.select)?!0:n.select,d=(0,C.isUndefinedOrNull)(n.focus)?!1:n.focus,c=(0,C.isUndefinedOrNull)(n.expand)?!1:n.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):t?this.refreshPromise.then(()=>this.resolveUnknownParentChain(t)).then(g=>this.resolveTreeNode(t,g[g.length-1]).then(w=>this.proxy.$reveal(this.viewId,{item:w.item,parentChain:g.map(y=>y.item)},{select:r,focus:d,expand:c})),g=>this.logService.error(g)):this.proxy.$reveal(this.viewId,void 0,{select:r,focus:d,expand:c})}get message(){return this._message}set message(t){this._message=t,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(t){this._title=t,this.proxy.$setTitle(this.viewId,t,this._description)}get description(){return this._description}set description(t){this._description=t,this.proxy.$setTitle(this.viewId,this._title,t)}get badge(){return this._badge}set badge(t){this._badge?.value===t?.value&&this._badge?.tooltip===t?.tooltip||(this._badge=f.ViewBadge.from(t),this.proxy.$setBadge(this.viewId,t))}setExpanded(t,n){const r=this.getExtensionElement(t);r&&(n?this._onDidExpandElement.fire(Object.freeze({element:r})):this._onDidCollapseElement.fire(Object.freeze({element:r})))}setSelectionAndFocus(t,n){const r=!(0,_.equals)(this._selectedHandles,t);this._selectedHandles=t;const d=this._focusedHandle!==n;this._focusedHandle=n,r&&this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})),d&&this._onDidChangeActiveItem.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(t){t!==this._visible&&(this._visible=t,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}async setCheckboxState(t){const n=(await Promise.all(t.map(async r=>{const d=this.getExtensionElement(r.treeItemHandle);return d?{extensionItem:d,treeItem:await this.dataProvider.getTreeItem(d),newState:r.newState?l.TreeItemCheckboxState.Checked:l.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(r=>r!==void 0);n.forEach(r=>{r.treeItem.checkboxState=r.newState?l.TreeItemCheckboxState.Checked:l.TreeItemCheckboxState.Unchecked}),this._onDidChangeCheckboxState.fire({items:n.map(r=>[r.extensionItem,r.newState])})}async handleDrag(t,n,r){const d=[];for(const c of t){const g=this.getExtensionElement(c);g&&d.push(g)}if(!(!this.dndController?.handleDrag||d.length===0))return await this.dndController.handleDrag(d,n,r),n}get hasHandleDrag(){return!!this.dndController?.handleDrag}async onDrop(t,n,r){const d=n?this.getExtensionElement(n):void 0;if(!(!d&&n||!this.dndController?.handleDrop))return(0,v.asPromise)(()=>this.dndController?.handleDrop?this.dndController.handleDrop(d,t,r):void 0)}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(t,n){if(!this.dataProvider.resolveTreeItem)return;const r=this.elements.get(t);if(r){const d=this.nodes.get(r);if(d){const c=await this.dataProvider.resolveTreeItem(d.extensionItem,r,n)??d.extensionItem;return this.validateTreeItem(c),d.item.tooltip=this.getTooltip(c.tooltip),d.item.command=this.getCommand(d.disposableStore,c.command),d.item}}}resolveUnknownParentChain(t){return this.resolveParent(t).then(n=>n?this.resolveUnknownParentChain(n).then(r=>this.resolveTreeNode(n,r[r.length-1]).then(d=>(r.push(d),r))):Promise.resolve([]))}resolveParent(t){const n=this.nodes.get(t);return n?Promise.resolve(n.parent?this.elements.get(n.parent.item.handle):void 0):(0,v.asPromise)(()=>this.dataProvider.getParent(t))}resolveTreeNode(t,n){const r=this.nodes.get(t);return r?Promise.resolve(r):(0,v.asPromise)(()=>this.dataProvider.getTreeItem(t)).then(d=>this.createHandle(t,d,n,!0)).then(d=>this.getChildren(n?n.item.handle:void 0).then(()=>{const c=this.getExtensionElement(d);if(c){const g=this.nodes.get(c);if(g)return Promise.resolve(g)}throw new Error(`Cannot resolve tree item for element ${d} from extension ${this.extension.identifier.value}`)}))}getChildrenNodes(t){if(t){let n;if(typeof t=="string"){const r=this.getExtensionElement(t);n=r?this.nodes.get(r):void 0}else n=t;return n&&n.children||void 0}return this.roots}async fetchChildrenNodes(t){this.clearChildren(t);const n=new S.CancellationTokenSource(this._refreshCancellationSource.token);try{const r=t?this.nodes.get(t):void 0,d=await this.dataProvider.getChildren(t);if(n.token.isCancellationRequested)return;const c=(0,_.coalesce)(d||[]),g=await Promise.all((0,_.coalesce)(c).map(y=>this.dataProvider.getTreeItem(y)));if(n.token.isCancellationRequested)return;const w=g.map((y,I)=>y?this.createAndRegisterTreeNode(c[I],y,r):null);return(0,_.coalesce)(w)}finally{n.dispose()}}refresh(t){if(t.some(r=>!r))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new S.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const r=this.getHandlesToRefresh(t);if(r.length)return this.refreshHandles(r)}return Promise.resolve(void 0)}getHandlesToRefresh(t){const n=new Set,r=t.map(c=>this.nodes.get(c));for(const c of r)if(c&&!n.has(c.item.handle)){let g=c;for(;g&&g.parent&&r.findIndex(w=>g&&g.parent&&w&&w.item.handle===g.parent.item.handle)===-1;){const w=this.elements.get(g.parent.item.handle);g=w?this.nodes.get(w):void 0}g&&!g.parent&&n.add(c.item.handle)}const d=[];return n.forEach(c=>{const g=this.elements.get(c);if(g){const w=this.nodes.get(g);w&&(!w.parent||!n.has(w.parent.item.handle))&&d.push(c)}}),d}refreshHandles(t){const n={};return Promise.all(t.map(r=>this.refreshNode(r).then(d=>{d&&(n[r]=d.item)}))).then(()=>Object.keys(n).length?this.proxy.$refresh(this.viewId,n):void 0)}refreshNode(t){const n=this.getExtensionElement(t);if(n){const r=this.nodes.get(n);if(r)return this.clearChildren(n),(0,v.asPromise)(()=>this.dataProvider.getTreeItem(n)).then(d=>{if(d){const c=this.createTreeNode(n,d,r.parent);return this.updateNodeCache(n,c,r,r.parent),r.dispose(),c}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(t,n,r){const d=this.createTreeNode(t,n,r);if(n.id&&this.elements.has(d.item.handle))throw new Error((0,s.localize)(2715,null,n.id));return this.addNodeToCache(t,d),this.addNodeToParentCache(d,r),d}getTooltip(t){return l.MarkdownString.isMarkdownString(t)?f.MarkdownString.from(t):t}getCommand(t,n){return n?{...this.commands.toInternal(n,t),originalId:n.command}:void 0}getCheckbox(t){if(t.checkboxState===void 0)return;let n,r,d;return typeof t.checkboxState=="number"?n=t.checkboxState:(n=t.checkboxState.state,r=t.checkboxState.tooltip,d=t.checkboxState.accessibilityInformation),{isChecked:n===l.TreeItemCheckboxState.Checked,tooltip:r,accessibilityInformation:d}}validateTreeItem(t){if(!l.TreeItem.isTreeItem(t,this.extension))throw new Error(`Extension ${this.extension.identifier.value} has provided an invalid tree item.`)}createTreeNode(t,n,r){this.validateTreeItem(n);const d=this._register(new L.DisposableStore),c=this.createHandle(t,n,r),g=this.getLightIconPath(n);return{item:{handle:c,parentHandle:r?r.item.handle:void 0,label:p(n.label,this.extension),description:n.description,resourceUri:n.resourceUri,tooltip:this.getTooltip(n.tooltip),command:this.getCommand(d,n.command),contextValue:n.contextValue,icon:g,iconDark:this.getDarkIconPath(n)||g,themeIcon:this.getThemeIcon(n),collapsibleState:(0,C.isUndefinedOrNull)(n.collapsibleState)?l.TreeItemCollapsibleState.None:n.collapsibleState,accessibilityInformation:n.accessibilityInformation,checkbox:this.getCheckbox(n)},extensionItem:n,parent:r,children:void 0,disposableStore:d,dispose(){d.dispose()}}}getThemeIcon(t){return t.iconPath instanceof l.ThemeIcon?t.iconPath:void 0}createHandle(t,{id:n,label:r,resourceUri:d},c,g){if(n)return`${i.ID_HANDLE_PREFIX}/${n}`;const w=p(r,this.extension),y=c?c.item.handle:i.LABEL_HANDLE_PREFIX;let I=w?w.label:d?(0,h.basename)(d):"";I=I.indexOf("/")!==-1?I.replace("/","//"):I;const P=this.nodes.has(t)?this.nodes.get(t).item.handle:void 0,k=this.getChildrenNodes(c)||[];let b,E=0;do{if(b=`${y}/${E}:${I}`,g||!this.elements.has(b)||P===b)break;E++}while(E<=k.length);return b}getLightIconPath(t){if(t.iconPath&&!(t.iconPath instanceof l.ThemeIcon))return typeof t.iconPath=="string"||D.URI.isUri(t.iconPath)?this.getIconPath(t.iconPath):this.getIconPath(t.iconPath.light)}getDarkIconPath(t){if(t.iconPath&&!(t.iconPath instanceof l.ThemeIcon)&&t.iconPath.dark)return this.getIconPath(t.iconPath.dark)}getIconPath(t){return D.URI.isUri(t)?t:D.URI.file(t)}addNodeToCache(t,n){this.elements.set(n.item.handle,t),this.nodes.set(t,n)}updateNodeCache(t,n,r,d){this.elements.delete(n.item.handle),this.nodes.delete(t),n.item.handle!==r.item.handle&&this.elements.delete(r.item.handle),this.addNodeToCache(t,n);const c=this.getChildrenNodes(d)||[],g=c.filter(w=>w.item.handle===r.item.handle)[0];g&&c.splice(c.indexOf(g),1,n)}addNodeToParentCache(t,n){n?(n.children||(n.children=[]),n.children.push(t)):(this.roots||(this.roots=[]),this.roots.push(t))}clearChildren(t){if(t){const n=this.nodes.get(t);if(n){if(n.children)for(const r of n.children){const d=this.elements.get(r.item.handle);d&&this.clear(d)}n.children=void 0}}else this.clearAll()}clear(t){const n=this.nodes.get(t);if(n){if(n.children)for(const r of n.children){const d=this.elements.get(r.item.handle);d&&this.clear(d)}this.nodes.delete(t),this.elements.delete(n.item.handle),n.dispose()}}clearAll(){this.roots=void 0,this.elements.clear(),this.nodes.forEach(t=>t.dispose()),this.nodes.clear()}dispose(){super.dispose(),this._refreshCancellationSource.dispose(),this.clearAll(),this.proxy.$disposeTree(this.viewId)}}}),define(Pe[325],ke([1,0,4,3,2,31,15,97,6,9]),function(ge,e,s,h,D,A,L,R,v,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0,L=We(L),v=We(v),l=We(l);class C extends h.Disposable{#e;#t;#i;#n;#s;#r;#a;#o;#l;#c;#u;#h;#d;constructor(S,o,m,p){super(),this.#o=void 0,this.#l=!0,this.#u=!1,this.#h=this._register(new s.Emitter),this.onDidDispose=this.#h.event,this.#d=this._register(new s.Emitter),this.onDidChangeViewState=this.#d.event,this.#e=S,this.#t=o,this.#n=m,this.#i=p.viewType,this.#s=p.panelOptions,this.#o=p.viewColumn,this.#r=p.title,this.#c=p.active}dispose(){this.#u||(this.#u=!0,this.#h.fire(),this.#t.$disposeWebview(this.#e),this.#n.dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),this.#n}get viewType(){return this.assertNotDisposed(),this.#i}get title(){return this.assertNotDisposed(),this.#r}set title(S){this.assertNotDisposed(),this.#r!==S&&(this.#r=S,this.#t.$setTitle(this.#e,S))}get iconPath(){return this.assertNotDisposed(),this.#a}set iconPath(S){this.assertNotDisposed(),this.#a!==S&&(this.#a=S,this.#t.$setIconPath(this.#e,D.URI.isUri(S)?{light:S,dark:S}:S))}get options(){return this.#s}get viewColumn(){if(this.assertNotDisposed(),!(typeof this.#o=="number"&&this.#o<0))return this.#o}get active(){return this.assertNotDisposed(),this.#c}get visible(){return this.assertNotDisposed(),this.#l}_updateViewState(S){this.#u||(this.active!==S.active||this.visible!==S.visible||this.viewColumn!==S.viewColumn)&&(this.#c=S.active,this.#l=S.visible,this.#o=S.viewColumn,this.#d.fire({webviewPanel:this}))}reveal(S,o){this.assertNotDisposed(),this.#t.$reveal(this.#e,{viewColumn:typeof S>"u"?void 0:L.ViewColumn.from(S),preserveFocus:!!o})}assertNotDisposed(){if(this.#u)throw new Error("Webview is disposed")}}class _ extends h.Disposable{static newHandle(){return(0,A.generateUuid)()}constructor(S,o,m){super(),this.webviews=o,this.workspace=m,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=S.getProxy(v.MainContext.MainThreadWebviewPanels)}dispose(){super.dispose(),this._webviewPanels.forEach(S=>S.dispose()),this._webviewPanels.clear()}createWebviewPanel(S,o,m,p,u={}){const i=typeof p=="object"?p.viewColumn:p,a={viewColumn:L.ViewColumn.from(i),preserveFocus:typeof p=="object"&&!!p.preserveFocus},t=(0,R.shouldSerializeBuffersForPostMessage)(S),n=_.newHandle();this._proxy.$createWebviewPanel((0,R.toExtensionData)(S),n,o,{title:m,panelOptions:f(u),webviewOptions:(0,R.serializeWebviewOptions)(S,this.workspace,u),serializeBuffersForPostMessage:t},a);const r=this.webviews.createNewWebview(n,u,S);return this.createNewWebviewPanel(n,o,m,i,u,r,!0)}$onDidChangeWebviewPanelViewStates(S){const o=Object.keys(S);o.sort((m,p)=>{const u=S[m],i=S[p];return u.active?1:i.active?-1:+u.visible-+i.visible});for(const m of o){const p=this.getWebviewPanel(m);if(!p)continue;const u=S[m];p._updateViewState({active:u.active,visible:u.visible,viewColumn:L.ViewColumn.to(u.position)})}}async $onDidDisposeWebviewPanel(S){this.getWebviewPanel(S)?.dispose(),this._webviewPanels.delete(S),this.webviews.deleteWebview(S)}registerWebviewPanelSerializer(S,o,m){if(this._serializers.has(o))throw new Error(`Serializer for '${o}' already registered`);return this._serializers.set(o,{serializer:m,extension:S}),this._proxy.$registerSerializer(o,{serializeBuffersForPostMessage:(0,R.shouldSerializeBuffersForPostMessage)(S)}),new l.Disposable(()=>{this._serializers.delete(o),this._proxy.$unregisterSerializer(o)})}async $deserializeWebviewPanel(S,o,m,p){const u=this._serializers.get(o);if(!u)throw new Error(`No serializer found for '${o}'`);const{serializer:i,extension:a}=u,t=this.webviews.createNewWebview(S,m.webviewOptions,a),n=this.createNewWebviewPanel(S,o,m.title,p,m.panelOptions,t,m.active);await i.deserializeWebviewPanel(n,m.state)}createNewWebviewPanel(S,o,m,p,u,i,a){const t=new C(S,this._proxy,i,{viewType:o,title:m,viewColumn:p,panelOptions:u,active:a});return this._webviewPanels.set(S,t),t}getWebviewPanel(S){return this._webviewPanels.get(S)}}e.ExtHostWebviewPanels=_;function f(T){return{enableFindWidget:T.enableFindWidget,retainContextWhenHidden:T.retainContextWhenHidden}}}),define(Pe[326],ke([1,0,4,3,97,15,6,9]),function(ge,e,s,h,D,A,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0,L=We(L),R=We(R);class v extends h.Disposable{#e;#t;#i;#n;#s;#r;#a;#o;#l;constructor(_,f,T,S,o,m){super(),this.#s=!1,this.#c=this._register(new s.Emitter),this.onDidChangeVisibility=this.#c.event,this.#u=this._register(new s.Emitter),this.onDidDispose=this.#u.event,this.#i=T,this.#a=S,this.#e=_,this.#t=f,this.#n=o,this.#r=m}dispose(){this.#s||(this.#s=!0,this.#u.fire(),this.#n.dispose(),super.dispose())}#c;#u;get title(){return this.assertNotDisposed(),this.#a}set title(_){this.assertNotDisposed(),this.#a!==_&&(this.#a=_,this.#t.$setWebviewViewTitle(this.#e,_))}get description(){return this.assertNotDisposed(),this.#o}set description(_){this.assertNotDisposed(),this.#o!==_&&(this.#o=_,this.#t.$setWebviewViewDescription(this.#e,_))}get visible(){return this.#r}get webview(){return this.#n}get viewType(){return this.#i}_setVisible(_){_===this.#r||this.#s||(this.#r=_,this.#c.fire())}get badge(){return this.assertNotDisposed(),this.#l}set badge(_){this.assertNotDisposed(),!(_?.value===this.#l?.value&&_?.tooltip===this.#l?.tooltip)&&(this.#l=A.ViewBadge.from(_),this.#t.$setWebviewViewBadge(this.#e,_))}show(_){this.assertNotDisposed(),this.#t.$show(this.#e,!!_)}assertNotDisposed(){if(this.#s)throw new Error("Webview is disposed")}}class l{constructor(_,f){this._extHostWebview=f,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=_.getProxy(L.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(_,f,T,S){if(this._viewProviders.has(f))throw new Error(`View provider for '${f}' already registered`);return this._viewProviders.set(f,{provider:T,extension:_}),this._proxy.$registerWebviewViewProvider((0,D.toExtensionData)(_),f,{retainContextWhenHidden:S?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,D.shouldSerializeBuffersForPostMessage)(_)}),new R.Disposable(()=>{this._viewProviders.delete(f),this._proxy.$unregisterWebviewViewProvider(f)})}async $resolveWebviewView(_,f,T,S,o){const m=this._viewProviders.get(f);if(!m)throw new Error(`No view provider found for '${f}'`);const{provider:p,extension:u}=m,i=this._extHostWebview.createNewWebview(_,{},u),a=new v(_,this._proxy,f,T,i,!0);this._webviewViews.set(_,a),await p.resolveWebviewView(a,{state:S},o)}async $onDidChangeWebviewViewVisibility(_,f){this.getWebviewView(_)._setVisible(f)}async $disposeWebviewView(_){const f=this.getWebviewView(_);this._webviewViews.delete(_),f.dispose(),this._extHostWebview.deleteWebview(_)}getWebviewView(_){const f=this._webviewViews.get(_);if(!f)throw new Error("No webview found");return f}}e.ExtHostWebviewViews=l}),define(Pe[327],ke([1,0,77,14,11,230,27,10]),function(ge,e,s,h,D,A,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiskFileSystemProvider=void 0;let v=class{constructor(_,f){_.addFileSystemProvider(h.Schemas.file,new l(f),{isCaseSensitive:R.isLinux})}};e.ExtHostDiskFileSystemProvider=v,e.ExtHostDiskFileSystemProvider=v=Qe([$e(0,s.IExtHostConsumerFileSystem),$e(1,D.ILogService)],v);class l{constructor(_){this.logService=_,this.impl=new A.DiskFileSystemProvider(this.logService)}async stat(_){const f=await this.impl.stat(_);return{type:f.type,ctime:f.ctime,mtime:f.mtime,size:f.size,permissions:f.permissions===L.FilePermission.Readonly?1:void 0}}readDirectory(_){return this.impl.readdir(_)}createDirectory(_){return this.impl.mkdir(_)}readFile(_){return this.impl.readFile(_)}writeFile(_,f,T){return this.impl.writeFile(_,f,{...T,unlock:!1,atomic:!1})}delete(_,f){return this.impl.delete(_,{...f,useTrash:!1,atomic:!1})}rename(_,f,T){return this.impl.rename(_,f,T)}copy(_,f,T){return this.impl.copy(_,f,T)}get onDidChangeFile(){throw new Error("Method not implemented.")}watch(_,f){throw new Error("Method not implemented.")}}}),define(Pe[328],ke([1,0,16,69,31,35,3,6,2,19]),function(ge,e,s,h,D,A,L,R,v,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDownloadService=void 0;let C=class extends L.Disposable{constructor(f,T){super();const S=f.getProxy(R.MainContext.MainThreadDownloadService);T.registerCommand(!1,"_workbench.downloadResource",async o=>{const m=v.URI.file((0,s.join)((0,h.tmpdir)(),(0,D.generateUuid)()));return await S.$download(o,m),m})}};e.ExtHostDownloadService=C,e.ExtHostDownloadService=C=Qe([$e(0,l.IExtHostRpcService),$e(1,A.IExtHostCommands)],C)}),define(Pe[329],ke([1,0,45,16,2,98,3,14,8,34]),function(ge,e,s,h,D,A,L,R,v,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=void 0,s=We(s),h=We(h);class C extends A.ExtensionStoragePaths{constructor(){super(...arguments),this._workspaceStorageLock=null}async _getWorkspaceStorageURI(n){const r=await super._getWorkspaceStorageURI(n);if(r.scheme!==R.Schemas.file)return r;if(this._environment.skipWorkspaceStorageLock)return this._logService.info(`Skipping acquiring lock for ${r.fsPath}.`),r;const d=r.fsPath;let c=0;do{let g;c===0?g=d:g=/[/\\]$/.test(d)?`${d.substr(0,d.length-1)}-${c}`:`${d}-${c}`,await _(g);const w=h.join(g,"vscode.lock"),y=await o(this._logService,w,!1);if(y)return this._workspaceStorageLock=y,process.on("exit",()=>{y.dispose()}),D.URI.file(g);c++}while(c<10);return r}onWillDeactivateAll(){this._workspaceStorageLock?.setWillRelease(6e3)}}e.ExtensionStoragePaths=C;async function _(t){try{await s.promises.stat(t);return}catch{}try{await s.promises.mkdir(t,{recursive:!0})}catch{}}const f=1e3,T=10*60*1e3;class S extends L.Disposable{constructor(n,r){super(),this.logService=n,this.filename=r,this._timer=this._register(new v.IntervalTimer),this._timer.cancelAndSet(async()=>{const d=await m(n,r);(!d||d.pid!==process.pid)&&(n.info(`Lock '${r}': The lock was lost unexpectedly.`),this._timer.cancel());try{await s.promises.utimes(r,new Date,new Date)}catch(c){n.error(c),n.info(`Lock '${r}': Could not update mtime.`)}},f)}dispose(){super.dispose();try{s.unlinkSync(this.filename)}catch{}}async setWillRelease(n){this.logService.info(`Lock '${this.filename}': Marking the lockfile as scheduled to be released in ${n} ms.`);try{const r={pid:process.pid,willReleaseAt:Date.now()+n};await l.Promises.writeFile(this.filename,JSON.stringify(r),{flag:"w"})}catch(r){this.logService.error(r)}}}async function o(t,n,r){try{const c={pid:process.pid,willReleaseAt:0};await l.Promises.writeFile(n,JSON.stringify(c),{flag:"wx"})}catch(c){t.error(c)}const d=await m(t,n);return!d||d.pid!==process.pid?r?(t.info(`Lock '${n}': Could not acquire lock, giving up.`),null):(t.info(`Lock '${n}': Could not acquire lock, checking if the file is stale.`),i(t,n)):(t.info(`Lock '${n}': Lock acquired.`),new S(t,n))}async function m(t,n){let r;try{r=await s.promises.readFile(n)}catch(d){return t.error(d),null}try{return JSON.parse(String(r))}catch(d){return t.error(d),null}}async function p(t,n){let r;try{r=await s.promises.stat(n)}catch(d){return t.error(d),0}return r.mtime.getTime()}function u(t){try{return process.kill(t,0),!0}catch{return!1}}async function i(t,n){const r=await m(t,n);if(!r)return t.info(`Lock '${n}': Could not read pid of lock holder.`),a(t,n);if(r.willReleaseAt){let y=r.willReleaseAt-Date.now();if(y<5e3){for(y>0?t.info(`Lock '${n}': The lockfile is scheduled to be released in ${y} ms.`):t.info(`Lock '${n}': The lockfile is scheduled to have been released.`);y>0;){if(await(0,v.timeout)(Math.min(100,y)),await p(t,n)===0)return a(t,n);y=r.willReleaseAt-Date.now()}return a(t,n)}}if(!u(r.pid))return t.info(`Lock '${n}': The pid ${r.pid} appears to be gone.`),a(t,n);const d=await p(t,n),c=Date.now()-d;if(c<=T)return t.info(`Lock '${n}': The lock does not look stale, elapsed: ${c} ms, giving up.`),null;t.info(`Lock '${n}': The lock looks stale, waiting for 2s.`),await(0,v.timeout)(2e3);const g=await p(t,n),w=Date.now()-g;return w<=T?(t.info(`Lock '${n}': The lock does not look stale, elapsed: ${w} ms, giving up.`),null):(t.info(`Lock '${n}': The lock looks stale even after waiting for 2s.`),a(t,n))}async function a(t,n){t.info(`Lock '${n}': Deleting a stale lock.`);try{await s.promises.unlink(n)}catch{}return o(t,n,!0)}}),define(Pe[330],ke([1,0,31,19,48,35]),function(ge,e,s,h,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTerminalService=void 0;let L=class extends D.BaseExtHostTerminalService{constructor(v,l){super(!0,v,l)}createTerminal(v,l,C){return this.createTerminalFromOptions({name:v,shellPath:l,shellArgs:C})}createTerminalFromOptions(v,l){const C=new D.ExtHostTerminal(this._proxy,(0,s.generateUuid)(),v,v.name);return this._terminals.push(C),C.create(v,this._serializeParentTerminal(v,l)),C.value}};e.ExtHostTerminalService=L,e.ExtHostTerminalService=L=Qe([$e(0,A.IExtHostCommands),$e(1,h.IExtHostRpcService)],L)}),define(Pe[331],ke([1,0,4,37,36,5]),function(ge,e,s,h,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=e.Extensions=e.OutputChannelUpdateMode=e.IOutputService=e.CONTEXT_OUTPUT_SCROLL_LOCK=e.CONTEXT_ACTIVE_OUTPUT_LEVEL_IS_DEFAULT=e.CONTEXT_ACTIVE_OUTPUT_LEVEL=e.CONTEXT_ACTIVE_OUTPUT_LEVEL_SETTABLE=e.CONTEXT_ACTIVE_FILE_OUTPUT=e.CONTEXT_IN_OUTPUT=e.OUTPUT_VIEW_ID=e.LOG_MODE_ID=e.LOG_MIME=e.OUTPUT_MODE_ID=e.OUTPUT_MIME=void 0,e.OUTPUT_MIME="text/x-code-output",e.OUTPUT_MODE_ID="Log",e.LOG_MIME="text/x-code-log-output",e.LOG_MODE_ID="log",e.OUTPUT_VIEW_ID="workbench.panel.output",e.CONTEXT_IN_OUTPUT=new D.RawContextKey("inOutput",!1),e.CONTEXT_ACTIVE_FILE_OUTPUT=new D.RawContextKey("activeLogOutput",!1),e.CONTEXT_ACTIVE_OUTPUT_LEVEL_SETTABLE=new D.RawContextKey("activeLogOutput.levelSettable",!1),e.CONTEXT_ACTIVE_OUTPUT_LEVEL=new D.RawContextKey("activeLogOutput.level",""),e.CONTEXT_ACTIVE_OUTPUT_LEVEL_IS_DEFAULT=new D.RawContextKey("activeLogOutput.levelIsDefault",!1),e.CONTEXT_OUTPUT_SCROLL_LOCK=new D.RawContextKey("outputView.scrollLock",!1),e.IOutputService=(0,A.createDecorator)("outputService");var L;(function(v){v[v.Append=1]="Append",v[v.Replace=2]="Replace",v[v.Clear=3]="Clear"})(L||(e.OutputChannelUpdateMode=L={})),e.Extensions={OutputChannels:"workbench.contributions.outputChannels"};class R{constructor(){this.channels=new Map,this._onDidRegisterChannel=new s.Emitter,this.onDidRegisterChannel=this._onDidRegisterChannel.event,this._onDidRemoveChannel=new s.Emitter,this.onDidRemoveChannel=this._onDidRemoveChannel.event}registerChannel(l){this.channels.has(l.id)||(this.channels.set(l.id,l),this._onDidRegisterChannel.fire(l.id))}getChannels(){const l=[];return this.channels.forEach(C=>l.push(C)),l}getChannel(l){return this.channels.get(l)}removeChannel(l){this.channels.delete(l),this._onDidRemoveChannel.fire(l)}}h.Registry.add(e.Extensions.OutputChannels,new R),e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=new D.RawContextKey("activeOutputChannel","")}),define(Pe[174],ke([1,0,6,5,19,23,11,331,77,29,64,207,21,17,27,4,3]),function(ge,e,s,h,D,A,L,R,v,l,C,_,f,T,S,o,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=void 0;class p extends L.AbstractMessageLogger{get disposed(){return this._disposed}constructor(t,n,r,d,c){super(),this.id=t,this.name=n,this.logger=r,this.proxy=d,this.extension=c,this.offset=0,this._disposed=!1,this.visible=!1,this.setLevel(r.getLevel()),this._register(r.onDidChangeLogLevel(g=>this.setLevel(g)))}get logLevel(){return this.getLevel()}appendLine(t){this.append(t+`
`)}append(t){this.info(t)}clear(){const t=this.offset;this.logger.flush(),this.proxy.$update(this.id,R.OutputChannelUpdateMode.Clear,t)}replace(t){const n=this.offset;this.info(t),this.proxy.$update(this.id,R.OutputChannelUpdateMode.Replace,n),this.visible&&this.logger.flush()}show(t,n){this.logger.flush(),this.proxy.$reveal(this.id,!!(typeof t=="boolean"?t:n))}hide(){this.proxy.$close(this.id)}log(t,n){this.offset+=f.VSBuffer.fromString(n).byteLength,(0,L.log)(this.logger,t,n),this.visible&&(this.logger.flush(),this.proxy.$update(this.id,R.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this._disposed||(this.proxy.$dispose(this.id),this._disposed=!0)}}class u extends p{appendLine(t){this.append(t)}}let i=class{constructor(t,n,r,d,c,g){this.initData=n,this.extHostFileSystem=r,this.extHostFileSystemInfo=d,this.loggerService=c,this.logService=g,this.extensionLogDirectoryPromise=new Map,this.namePool=1,this.channels=new Map,this.visibleChannelId=null,this.proxy=t.getProxy(s.MainContext.MainThreadOutputService),this.outputsLocation=this.extHostFileSystemInfo.extUri.joinPath(n.logsLocation,`output_logging_${(0,_.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(t){this.visibleChannelId=t;for(const[n,r]of this.channels)r.visible=n===this.visibleChannelId}createOutputChannel(t,n,r){if(t=t.trim(),!t)throw new Error("illegal argument `name`. must not be falsy");const d=typeof n=="object"&&n.log,c=(0,T.isString)(n)?n:void 0;if((0,T.isString)(c)&&!c.trim())throw new Error("illegal argument `languageId`. must not be empty");let g;const w=this.initData.environment.extensionLogLevel?.find(([I])=>A.ExtensionIdentifier.equals(r.identifier,I))?.[1];w&&(g=(0,L.parseLogLevel)(w));const y=d?this.doCreateLogOutputChannel(t,g,r):this.doCreateOutputChannel(t,c,r);return y.then(I=>{this.channels.set(I.id,I),I.visible=I.id===this.visibleChannelId}),d?this.createExtHostLogOutputChannel(t,g??this.logService.getLevel(),y):this.createExtHostOutputChannel(t,y)}async doCreateOutputChannel(t,n,r){this.outputDirectoryPromise||(this.outputDirectoryPromise=this.extHostFileSystem.value.createDirectory(this.outputsLocation).then(()=>this.outputsLocation));const d=await this.outputDirectoryPromise,c=this.extHostFileSystemInfo.extUri.joinPath(d,`${this.namePool++}-${t.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),g=this.loggerService.createLogger(c,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),w=await this.proxy.$register(t,c,n,r.identifier.value);return new p(w,t,g,this.proxy,r)}async doCreateLogOutputChannel(t,n,r){const d=await this.createExtensionLogDirectory(r),c=t.replace(/[\\/:\*\?"<>\|]/g,""),g=this.extHostFileSystemInfo.extUri.joinPath(d,`${c}.log`),w=`${r.identifier.value}.${c}`,y=this.loggerService.createLogger(g,{id:w,name:t,logLevel:n,extensionId:r.identifier.value});return new u(w,t,y,this.proxy,r)}createExtensionLogDirectory(t){let n=this.extensionLogDirectoryPromise.get(t.identifier.value);if(!n){const r=this.extHostFileSystemInfo.extUri.joinPath(this.initData.logsLocation,t.identifier.value);this.extensionLogDirectoryPromise.set(t.identifier.value,n=(async()=>{try{await this.extHostFileSystem.value.createDirectory(r)}catch(d){if((0,S.toFileSystemProviderErrorCode)(d)!==S.FileSystemProviderErrorCode.FileExists)throw d}return r})())}return n}createExtHostOutputChannel(t,n){let r=!1;const d=()=>{if(r)throw new Error("Channel has been closed")};return{get name(){return t},append(c){d(),n.then(g=>g.append(c))},appendLine(c){d(),n.then(g=>g.appendLine(c))},clear(){d(),n.then(c=>c.clear())},replace(c){d(),n.then(g=>g.replace(c))},show(c,g){d(),n.then(w=>w.show(c,g))},hide(){d(),n.then(c=>c.hide())},dispose(){r=!0,n.then(c=>c.dispose())}}}createExtHostLogOutputChannel(t,n,r){const d=new m.DisposableStore,c=()=>{if(d.isDisposed)throw new Error("Channel has been closed")},g=d.add(new o.Emitter);function w(y){n=y,g.fire(y)}return r.then(y=>{d.add(y),y.logLevel!==n&&w(y.logLevel),d.add(y.onDidChangeLogLevel(I=>w(I)))}),{...this.createExtHostOutputChannel(t,r),get logLevel(){return n},onDidChangeLogLevel:g.event,trace(y,...I){c(),r.then(P=>P.trace(y,...I))},debug(y,...I){c(),r.then(P=>P.debug(y,...I))},info(y,...I){c(),r.then(P=>P.info(y,...I))},warn(y,...I){c(),r.then(P=>P.warn(y,...I))},error(y,...I){c(),r.then(P=>P.error(y,...I))},dispose(){d.dispose()}}}};e.ExtHostOutputService=i,e.ExtHostOutputService=i=Qe([$e(0,D.IExtHostRpcService),$e(1,l.IExtHostInitDataService),$e(2,v.IExtHostConsumerFileSystem),$e(3,C.IExtHostFileSystemInfo),$e(4,L.ILoggerService),$e(5,L.ILogService)],i),e.IExtHostOutputService=(0,h.createDecorator)("IExtHostOutputService")}),define(Pe[175],ke([1,0,5,8]),function(ge,e,s,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.remoteConnectionLatencyMeasurer=e.IRemoteAgentService=void 0,e.IRemoteAgentService=(0,s.createDecorator)("remoteAgentService"),e.remoteConnectionLatencyMeasurer=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(D){let A=1/0;for(let R=0;R<this.maxSampleCount;R++){const v=await D.getRoundTripTime();if(v===void 0)return;A=Math.min(A,v/2),await(0,h.timeout)(this.sampleDelay)}this.average.push(A),this.average.length>this.maxAverageCount&&this.average.shift();let L;return this.initial.length<this.maxInitialCount?this.initial.push(A):L=this.initial.reduce((R,v)=>R+v,0)/this.initial.length,this.lastMeasurement={initial:L,current:A,average:this.average.reduce((R,v)=>R+v,0)/this.average.length,high:typeof L>"u"?!1:A>this.highLatencyMaxThreshold||A>this.highLatencyMinThreshold&&A>L*this.highLatencyMultiple},this.lastMeasurement}}}),define(Pe[332],ke([1,0,7,72,37,47,46,3,4,175,10,24,8,155]),function(ge,e,s,h,D,A,L,R,v,l,C,_,f,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DynamicWindowConfiguration=e.CONFIG_NEW_WINDOW_PROFILE=e.DynamicWorkbenchSecurityConfiguration=e.ConfigurationMigrationWorkbenchContribution=e.Extensions=e.windowConfigurationNodeBase=e.problemsConfigurationNodeBase=e.securityConfigurationNodeBase=e.workbenchConfigurationNodeBase=e.applicationConfigurationNodeBase=void 0,e.applicationConfigurationNodeBase=Object.freeze({id:"application",order:100,title:(0,s.localize)(3975,null),type:"object"}),e.workbenchConfigurationNodeBase=Object.freeze({id:"workbench",order:7,title:(0,s.localize)(3976,null),type:"object"}),e.securityConfigurationNodeBase=Object.freeze({id:"security",scope:h.ConfigurationScope.APPLICATION,title:(0,s.localize)(3977,null),type:"object",order:7}),e.problemsConfigurationNodeBase=Object.freeze({id:"problems",title:(0,s.localize)(3978,null),type:"object",order:101}),e.windowConfigurationNodeBase=Object.freeze({id:"window",order:8,title:(0,s.localize)(3979,null),type:"object"}),e.Extensions={ConfigurationMigration:"base.contributions.configuration.migration"};class S{constructor(){this.migrations=[],this._onDidRegisterConfigurationMigrations=new v.Emitter,this.onDidRegisterConfigurationMigration=this._onDidRegisterConfigurationMigrations.event}registerConfigurationMigrations(a){this.migrations.push(...a)}}const o=new S;D.Registry.add(e.Extensions.ConfigurationMigration,o);let m=class extends R.Disposable{static{this.ID="workbench.contrib.configurationMigration"}constructor(a,t){super(),this.configurationService=a,this.workspaceService=t,this._register(this.workspaceService.onDidChangeWorkspaceFolders(async n=>{for(const r of n.added)await this.migrateConfigurationsForFolder(r,o.migrations)})),this.migrateConfigurations(o.migrations),this._register(o.onDidRegisterConfigurationMigration(n=>this.migrateConfigurations(n)))}async migrateConfigurations(a){await this.migrateConfigurationsForFolder(void 0,a);for(const t of this.workspaceService.getWorkspace().folders)await this.migrateConfigurationsForFolder(t,a)}async migrateConfigurationsForFolder(a,t){await Promise.all([t.map(n=>this.migrateConfigurationsForFolderAndOverride(n,a?.uri))])}async migrateConfigurationsForFolderAndOverride(a,t){const n=this.configurationService.inspect(a.key,{resource:t}),r=this.workspaceService.getWorkbenchState()===A.WorkbenchState.WORKSPACE?[["user",L.ConfigurationTarget.USER],["userLocal",L.ConfigurationTarget.USER_LOCAL],["userRemote",L.ConfigurationTarget.USER_REMOTE],["workspace",L.ConfigurationTarget.WORKSPACE],["workspaceFolder",L.ConfigurationTarget.WORKSPACE_FOLDER]]:[["user",L.ConfigurationTarget.USER],["userLocal",L.ConfigurationTarget.USER_LOCAL],["userRemote",L.ConfigurationTarget.USER_REMOTE],["workspace",L.ConfigurationTarget.WORKSPACE]];for(const[d,c]of r){const g=n[d];if(!g)continue;const w=[];if(g.value!==void 0){const y=await this.runMigration(a,d,g.value,t,void 0);for(const I of y??[])w.push([I,[]])}for(const{identifiers:y,value:I}of g.overrides??[])if(I!==void 0){const P=await this.runMigration(a,d,I,t,y);for(const k of P??[])w.push([k,y])}w.length&&await Promise.allSettled(w.map(async([[y,I],P])=>this.configurationService.updateValue(y,I.value,{resource:t,overrideIdentifiers:P},c)))}}async runMigration(a,t,n,r,d){const c=w=>{const I=this.configurationService.inspect(w,{resource:r})[t];if(I)return d?I.overrides?.find(({identifiers:P})=>(0,_.equals)(P,d))?.value:I.value},g=await a.migrateFn(n,c);return Array.isArray(g)?g:[[a.key,g]]}};e.ConfigurationMigrationWorkbenchContribution=m,e.ConfigurationMigrationWorkbenchContribution=m=Qe([$e(0,L.IConfigurationService),$e(1,A.IWorkspaceContextService)],m);let p=class extends R.Disposable{static{this.ID="workbench.contrib.dynamicWorkbenchSecurityConfiguration"}constructor(a){super(),this.remoteAgentService=a,this._ready=new f.DeferredPromise,this.ready=this._ready.p,this.create()}async create(){try{await this.doCreate()}finally{this._ready.complete()}}async doCreate(){if(!C.isWindows&&(await this.remoteAgentService.getEnvironment())?.os!==C.OperatingSystem.Windows)return;D.Registry.as(h.Extensions.Configuration).registerConfiguration({...e.securityConfigurationNodeBase,properties:{"security.allowedUNCHosts":{type:"array",items:{type:"string",pattern:"^[^\\\\]+$",patternErrorMessage:(0,s.localize)(3980,null)},default:[],markdownDescription:(0,s.localize)(3981,null),scope:h.ConfigurationScope.MACHINE},"security.restrictUNCAccess":{type:"boolean",default:!0,markdownDescription:(0,s.localize)(3982,null),scope:h.ConfigurationScope.MACHINE}}})}};e.DynamicWorkbenchSecurityConfiguration=p,e.DynamicWorkbenchSecurityConfiguration=p=Qe([$e(0,l.IRemoteAgentService)],p),e.CONFIG_NEW_WINDOW_PROFILE="window.newWindowProfile";let u=class extends R.Disposable{static{this.ID="workbench.contrib.dynamicWindowConfiguration"}constructor(a,t){super(),this.userDataProfilesService=a,this.configurationService=t,this.registerNewWindowProfileConfiguration(),this._register(this.userDataProfilesService.onDidChangeProfiles(n=>this.registerNewWindowProfileConfiguration())),this.setNewWindowProfile(),this.checkAndResetNewWindowProfileConfig(),this._register(t.onDidChangeConfiguration(n=>{n.source!==L.ConfigurationTarget.DEFAULT&&n.affectsConfiguration(e.CONFIG_NEW_WINDOW_PROFILE)&&this.setNewWindowProfile()})),this._register(this.userDataProfilesService.onDidChangeProfiles(()=>this.checkAndResetNewWindowProfileConfig()))}registerNewWindowProfileConfiguration(){const a=D.Registry.as(h.Extensions.Configuration),t={...e.windowConfigurationNodeBase,properties:{[e.CONFIG_NEW_WINDOW_PROFILE]:{type:["string","null"],default:null,enum:[...this.userDataProfilesService.profiles.map(n=>n.name),null],enumItemLabels:[...this.userDataProfilesService.profiles.map(n=>""),(0,s.localize)(3983,null)],description:(0,s.localize)(3984,null),scope:h.ConfigurationScope.APPLICATION}}};this.configurationNode?a.updateConfigurations({add:[t],remove:[this.configurationNode]}):a.registerConfiguration(t),this.configurationNode=t}setNewWindowProfile(){const a=this.configurationService.getValue(e.CONFIG_NEW_WINDOW_PROFILE);this.newWindowProfile=a?this.userDataProfilesService.profiles.find(t=>t.name===a):void 0}checkAndResetNewWindowProfileConfig(){const a=this.configurationService.getValue(e.CONFIG_NEW_WINDOW_PROFILE);if(!a)return;const t=this.newWindowProfile?this.userDataProfilesService.profiles.find(n=>n.id===this.newWindowProfile.id):void 0;a!==t?.name&&this.configurationService.updateValue(e.CONFIG_NEW_WINDOW_PROFILE,t?.name)}};e.DynamicWindowConfiguration=u,e.DynamicWindowConfiguration=u=Qe([$e(0,T.IUserDataProfilesService),$e(1,L.IConfigurationService)],u)}),define(Pe[333],ke([1,0,39,14,16,22,7,332,72,5,37]),function(ge,e,s,h,D,A,L,R,v,l,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvedStatus=e.RegisteredEditorPriority=e.editorsAssociationsSettingId=e.IEditorResolverService=void 0,e.priorityToRank=o,e.globMatchesResource=m,s=We(s),e.IEditorResolverService=(0,l.createDecorator)("editorResolverService"),e.editorsAssociationsSettingId="workbench.editorAssociations";const _=C.Registry.as(v.Extensions.Configuration),f={...R.workbenchConfigurationNodeBase,properties:{"workbench.editorAssociations":{type:"object",markdownDescription:(0,L.localize)(12176,null),additionalProperties:{type:"string"}}}};_.registerConfiguration(f);var T;(function(p){p.builtin="builtin",p.option="option",p.exclusive="exclusive",p.default="default"})(T||(e.RegisteredEditorPriority=T={}));var S;(function(p){p[p.ABORT=1]="ABORT",p[p.NONE=2]="NONE"})(S||(e.ResolvedStatus=S={}));function o(p){switch(p){case T.exclusive:return 5;case T.default:return 4;case T.builtin:return 3;case T.option:default:return 1}}function m(p,u){if(new Set([h.Schemas.extension,h.Schemas.webviewPanel,h.Schemas.vscodeWorkspaceTrust,h.Schemas.vscodeSettings]).has(u.scheme))return!1;const t=typeof p=="string"&&p.indexOf(D.posix.sep)>=0?`${u.scheme}:${u.path}`:(0,A.basename)(u);return s.match(typeof p=="string"?p.toLowerCase():p,t.toLowerCase())}}),define(Pe[334],ke([1,0,33,14,16,10,22,2,5,249,47,163,175]),function(ge,e,s,h,D,A,L,R,v,l,C,_,f){"use strict";var T;Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,v.createDecorator)("pathService");let S=T=class{constructor(m,p,u,i){this.localUserHome=m,this.remoteAgentService=p,this.environmentService=u,this.contextService=i,this.resolveOS=(async()=>(await this.remoteAgentService.getEnvironment())?.os||A.OS)(),this.resolveUserHome=(async()=>{const a=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=a?.userHome??m})()}hasValidBasename(m,p,u){return typeof p=="string"||typeof p>"u"?this.resolveOS.then(i=>this.doHasValidBasename(m,i,p)):this.doHasValidBasename(m,p,u)}doHasValidBasename(m,p,u){return m.scheme===h.Schemas.file||m.scheme===h.Schemas.vscodeRemote?(0,s.isValidBasename)(u??(0,L.basename)(m),p===A.OperatingSystem.Windows):!0}get defaultUriScheme(){return T.findDefaultUriScheme(this.environmentService,this.contextService)}static findDefaultUriScheme(m,p){if(m.remoteAuthority)return h.Schemas.vscodeRemote;const u=(0,l.getVirtualWorkspaceScheme)(p.getWorkspace());if(u)return u;const i=p.getWorkspace().folders[0];if(i)return i.uri.scheme;const a=p.getWorkspace().configuration;return a?a.scheme:h.Schemas.file}userHome(m){return m?.preferLocal?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(m=>m===A.OperatingSystem.Windows?D.win32:D.posix)}async fileURI(m){let p="";if(await this.resolveOS===A.OperatingSystem.Windows&&(m=m.replace(/\\/g,"/")),m[0]==="/"&&m[1]==="/"){const i=m.indexOf("/",2);i===-1?(p=m.substring(2),m="/"):(p=m.substring(2,i),m=m.substring(i)||"/")}return R.URI.from({scheme:h.Schemas.file,authority:p,path:m,query:"",fragment:""})}};e.AbstractPathService=S,e.AbstractPathService=S=T=Qe([$e(1,f.IRemoteAgentService),$e(2,_.IWorkbenchEnvironmentService),$e(3,C.IWorkspaceContextService)],S)}),define(Pe[335],ke([1,0,7,60,4,61,3,2,46,219,11,73,156,93,47,163,25,20,17,24,36]),function(ge,e,s,h,D,A,L,R,v,l,C,_,f,T,S,o,m,p,u,i,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TunnelModel=e.PortsAttributes=e.OnPortForward=e.AutoTunnelSource=e.UserTunnelSource=e.TunnelSource=e.TunnelCloseReason=e.forwardedPortsViewEnabled=e.ACTIVATION_EVENT=void 0,e.parseAddress=c,e.mapHasAddress=y,e.mapHasAddressLocalhostOrAllInterfaces=I,e.makeAddress=P,e.isCandidatePort=b,s=We(s);const t=10*1e3,n="remote.tunnels.toRestore",r="remote.tunnels.toRestoreExpiration",d=1e3*60*60*24*14;e.ACTIVATION_EVENT="onTunnel",e.forwardedPortsViewEnabled=new a.RawContextKey("forwardedPortsViewEnabled",!1,s.localize(12559,null));function c(O){const M=O.match(/^([a-zA-Z0-9_-]+(?:\.[a-zA-Z0-9_-]+)*:)?([0-9]+)$/);if(M)return{host:M[1]?.substring(0,M[1].length-1)||"localhost",port:Number(M[2])}}var g;(function(O){O.Other="Other",O.User="User",O.AutoForwardEnd="AutoForwardEnd"})(g||(e.TunnelCloseReason=g={}));var w;(function(O){O[O.User=0]="User",O[O.Auto=1]="Auto",O[O.Extension=2]="Extension"})(w||(e.TunnelSource=w={})),e.UserTunnelSource={source:w.User,description:s.localize(12560,null)},e.AutoTunnelSource={source:w.Auto,description:s.localize(12561,null)};function y(O,M,U){const H=O.get(P(M,U));if(H)return H;if((0,T.isLocalhost)(M))for(const F of T.LOCALHOST_ADDRESSES){const x=P(F,U);if(O.has(x))return O.get(x)}else if((0,T.isAllInterfaces)(M))for(const F of T.ALL_INTERFACES_ADDRESSES){const x=P(F,U);if(O.has(x))return O.get(x)}}function I(O,M,U){const H=y(O,M,U);if(H)return H;const F=(0,T.isAllInterfaces)(M)?"localhost":(0,T.isLocalhost)(M)?"0.0.0.0":void 0;if(F)return y(O,F,U)}function P(O,M){return O+":"+M}var k;(function(O){O.Notify="notify",O.OpenBrowser="openBrowser",O.OpenBrowserOnce="openBrowserOnce",O.OpenPreview="openPreview",O.Silent="silent",O.Ignore="ignore"})(k||(e.OnPortForward=k={}));function b(O){return O&&"host"in O&&typeof O.host=="string"&&"port"in O&&typeof O.port=="number"&&(!("detail"in O)||typeof O.detail=="string")&&(!("pid"in O)||typeof O.pid=="string")}class E extends L.Disposable{static{this.SETTING="remote.portsAttributes"}static{this.DEFAULTS="remote.otherPortsAttributes"}static{this.RANGE=/^(\d+)\-(\d+)$/}static{this.HOST_AND_PORT=/^([a-z0-9\-]+):(\d{1,5})$/}constructor(M){super(),this.configurationService=M,this.portsAttributes=[],this._onDidChangeAttributes=new D.Emitter,this.onDidChangeAttributes=this._onDidChangeAttributes.event,this._register(M.onDidChangeConfiguration(U=>{(U.affectsConfiguration(E.SETTING)||U.affectsConfiguration(E.DEFAULTS))&&this.updateAttributes()})),this.updateAttributes()}updateAttributes(){this.portsAttributes=this.readSetting(),this._onDidChangeAttributes.fire()}getAttributes(M,U,H){let F=this.findNextIndex(M,U,H,this.portsAttributes,0);const x={label:void 0,onAutoForward:void 0,elevateIfNeeded:void 0,requireLocalPort:void 0,protocol:void 0};for(;F>=0;){const $=this.portsAttributes[F];$.key===M?(x.onAutoForward=$.onAutoForward??x.onAutoForward,x.elevateIfNeeded=$.elevateIfNeeded!==void 0?$.elevateIfNeeded:x.elevateIfNeeded,x.label=$.label??x.label,x.requireLocalPort=$.requireLocalPort,x.protocol=$.protocol):(x.onAutoForward=x.onAutoForward??$.onAutoForward,x.elevateIfNeeded=x.elevateIfNeeded!==void 0?x.elevateIfNeeded:$.elevateIfNeeded,x.label=x.label??$.label,x.requireLocalPort=x.requireLocalPort!==void 0?x.requireLocalPort:void 0,x.protocol=x.protocol??$.protocol),F=this.findNextIndex(M,U,H,this.portsAttributes,F+1)}return x.onAutoForward!==void 0||x.elevateIfNeeded!==void 0||x.label!==void 0||x.requireLocalPort!==void 0||x.protocol!==void 0?x:this.getOtherAttributes()}hasStartEnd(M){return M.start!==void 0&&M.end!==void 0}hasHostAndPort(M){return M.host!==void 0&&M.port!==void 0&&(0,u.isString)(M.host)&&(0,u.isNumber)(M.port)}findNextIndex(M,U,H,F,x){if(x>=F.length)return-1;const $=!(0,T.isLocalhost)(U)&&!(0,T.isAllInterfaces)(U),B=F.slice(x).findIndex(W=>(0,u.isNumber)(W.key)?$?!1:W.key===M:this.hasStartEnd(W.key)?$?!1:M>=W.key.start&&M<=W.key.end:this.hasHostAndPort(W.key)?M===W.key.port&&U===W.key.host:H?W.key.test(H):!1);return B>=0?B+x:-1}readSetting(){const M=this.configurationService.getValue(E.SETTING);if(!M||!(0,u.isObject)(M))return[];const U=[];for(const F in M){if(F===void 0)continue;const x=M[F];let $;if(Number(F))$=Number(F);else if((0,u.isString)(F))if(E.RANGE.test(F)){const G=F.match(E.RANGE);$={start:Number(G[1]),end:Number(G[2])}}else if(E.HOST_AND_PORT.test(F)){const G=F.match(E.HOST_AND_PORT);$={host:G[1],port:Number(G[2])}}else{let G;try{G=RegExp(F)}catch{}G&&($=G)}$&&U.push({key:$,elevateIfNeeded:x.elevateIfNeeded,onAutoForward:x.onAutoForward,label:x.label,requireLocalPort:x.requireLocalPort,protocol:x.protocol})}const H=this.configurationService.getValue(E.DEFAULTS);return H&&(this.defaultPortAttributes={elevateIfNeeded:H.elevateIfNeeded,label:H.label,onAutoForward:H.onAutoForward,requireLocalPort:H.requireLocalPort,protocol:H.protocol}),this.sortAttributes(U)}sortAttributes(M){function U(H,F){return(0,u.isNumber)(H.key)?H.key:F.hasStartEnd(H.key)?H.key.start:F.hasHostAndPort(H.key)?H.key.port:Number.MAX_VALUE}return M.sort((H,F)=>U(H,this)-U(F,this))}getOtherAttributes(){return this.defaultPortAttributes}static providedActionToAction(M){switch(M){case T.ProvidedOnAutoForward.Notify:return k.Notify;case T.ProvidedOnAutoForward.OpenBrowser:return k.OpenBrowser;case T.ProvidedOnAutoForward.OpenBrowserOnce:return k.OpenBrowserOnce;case T.ProvidedOnAutoForward.OpenPreview:return k.OpenPreview;case T.ProvidedOnAutoForward.Silent:return k.Silent;case T.ProvidedOnAutoForward.Ignore:return k.Ignore;default:return}}async addAttributes(M,U,H){const x=this.configurationService.inspect(E.SETTING).userRemoteValue;let $;!x||!(0,u.isObject)(x)?$={}:$=(0,i.deepClone)(x),$[`${M}`]||($[`${M}`]={});for(const G in U)$[`${M}`][G]=U[G];return this.configurationService.updateValue(E.SETTING,$,H)}}e.PortsAttributes=E;let N=class extends L.Disposable{constructor(M,U,H,F,x,$,G,B,W,Z){super(),this.tunnelService=M,this.storageService=U,this.configurationService=H,this.environmentService=F,this.remoteAuthorityResolverService=x,this.workspaceContextService=$,this.logService=G,this.dialogService=B,this.extensionService=W,this.contextKeyService=Z,this.inProgress=new Map,this._onForwardPort=new D.Emitter,this.onForwardPort=this._onForwardPort.event,this._onClosePort=new D.Emitter,this.onClosePort=this._onClosePort.event,this._onPortName=new D.Emitter,this.onPortName=this._onPortName.event,this._onCandidatesChanged=new D.Emitter,this.onCandidatesChanged=this._onCandidatesChanged.event,this._onEnvironmentTunnelsSet=new D.Emitter,this.onEnvironmentTunnelsSet=this._onEnvironmentTunnelsSet.event,this._environmentTunnelsSet=!1,this.restoreListener=void 0,this.restoreComplete=!1,this.onRestoreComplete=new D.Emitter,this.unrestoredExtensionTunnels=new Map,this.sessionCachedProperties=new Map,this.portAttributesProviders=[],this.mismatchCooldown=new Date,this.configPortsAttributes=new E(H),this.tunnelRestoreValue=this.getTunnelRestoreValue(),this._register(this.configPortsAttributes.onDidChangeAttributes(this.updateAttributes,this)),this.forwarded=new Map,this.remoteTunnels=new Map,this.tunnelService.tunnels.then(async J=>{const oe=await this.getAttributes(J.map(te=>({port:te.tunnelRemotePort,host:te.tunnelRemoteHost})));for(const te of J)if(te.localAddress){const me=P(te.tunnelRemoteHost,te.tunnelRemotePort),le=I(this._candidates??new Map,te.tunnelRemoteHost,te.tunnelRemotePort);this.forwarded.set(me,{remotePort:te.tunnelRemotePort,remoteHost:te.tunnelRemoteHost,localAddress:te.localAddress,protocol:oe?.get(te.tunnelRemotePort)?.protocol??T.TunnelProtocol.Http,localUri:await this.makeLocalUri(te.localAddress,oe?.get(te.tunnelRemotePort)),localPort:te.tunnelLocalPort,name:oe?.get(te.tunnelRemotePort)?.label,runningProcess:le?.detail,hasRunningProcess:!!le,pid:le?.pid,privacy:te.privacy,source:e.UserTunnelSource}),this.remoteTunnels.set(me,te)}}),this.detected=new Map,this._register(this.tunnelService.onTunnelOpened(async J=>{const oe=P(J.tunnelRemoteHost,J.tunnelRemotePort);if(!I(this.forwarded,J.tunnelRemoteHost,J.tunnelRemotePort)&&!I(this.detected,J.tunnelRemoteHost,J.tunnelRemotePort)&&!I(this.inProgress,J.tunnelRemoteHost,J.tunnelRemotePort)&&J.localAddress){const te=I(this._candidates??new Map,J.tunnelRemoteHost,J.tunnelRemotePort),me=(await this.getAttributes([{port:J.tunnelRemotePort,host:J.tunnelRemoteHost}]))?.get(J.tunnelRemotePort);this.forwarded.set(oe,{remoteHost:J.tunnelRemoteHost,remotePort:J.tunnelRemotePort,localAddress:J.localAddress,protocol:me?.protocol??T.TunnelProtocol.Http,localUri:await this.makeLocalUri(J.localAddress,me),localPort:J.tunnelLocalPort,name:me?.label,closeable:!0,runningProcess:te?.detail,hasRunningProcess:!!te,pid:te?.pid,privacy:J.privacy,source:e.UserTunnelSource})}await this.storeForwarded(),this.remoteTunnels.set(oe,J),this._onForwardPort.fire(this.forwarded.get(oe))})),this._register(this.tunnelService.onTunnelClosed(J=>this.onTunnelClosed(J,g.Other))),this.checkExtensionActivationEvents()}extensionHasActivationEvent(){return this.extensionService.extensions.find(M=>M.activationEvents?.includes(e.ACTIVATION_EVENT))?(this.contextKeyService.createKey(e.forwardedPortsViewEnabled.key,!0),!0):!1}checkExtensionActivationEvents(){if(this.extensionHasActivationEvent())return;const M=this._register(this.extensionService.onDidRegisterExtensions(()=>{this.extensionHasActivationEvent()&&M.dispose()}))}async onTunnelClosed(M,U){const H=P(M.host,M.port);this.forwarded.has(H)&&(this.forwarded.delete(H),await this.storeForwarded(),this._onClosePort.fire(M))}makeLocalUri(M,U){if(M.startsWith("http"))return R.URI.parse(M);const H=U?.protocol??"http";return R.URI.parse(`${H}://${M}`)}async addStorageKeyPostfix(M){const U=this.workspaceContextService.getWorkspace(),H=U.configuration?(0,A.hash)(U.configuration.path):U.folders.length>0?(0,A.hash)(U.folders[0].uri.path):void 0;if(H===void 0){this.logService.debug("Could not get workspace hash for forwarded ports storage key.");return}return`${M}.${this.environmentService.remoteAuthority}.${H}`}async getTunnelRestoreStorageKey(){return this.addStorageKeyPostfix(n)}async getRestoreExpirationStorageKey(){return this.addStorageKeyPostfix(r)}async getTunnelRestoreValue(){const M=this.storageService.get(n,f.StorageScope.WORKSPACE);if(M)return this.storageService.remove(n,f.StorageScope.WORKSPACE),await this.storeForwarded(),M;const U=await this.getTunnelRestoreStorageKey();if(U)return this.storageService.get(U,f.StorageScope.PROFILE)}async restoreForwarded(){if(this.cleanupExpiredTunnelsForRestore(),this.configurationService.getValue("remote.restoreForwardedPorts")){const M=await this.tunnelRestoreValue;if(M&&M!==this.knownPortsRestoreValue){const U=JSON.parse(M)??[];this.logService.trace(`ForwardedPorts: (TunnelModel) restoring ports ${U.map(H=>H.remotePort).join(", ")}`);for(const H of U){const F=I(this.detected,H.remoteHost,H.remotePort);H.source.source!==w.Extension&&!F||H.source.source===w.Extension&&F?await this.doForward({remote:{host:H.remoteHost,port:H.remotePort},local:H.localPort,name:H.name,elevateIfNeeded:!0,source:H.source}):H.source.source===w.Extension&&!F&&this.unrestoredExtensionTunnels.set(P(H.remoteHost,H.remotePort),H)}}}if(this.restoreComplete=!0,this.onRestoreComplete.fire(),!this.restoreListener){const M=await this.getTunnelRestoreStorageKey();this.restoreListener=this._register(new L.DisposableStore),this.restoreListener.add(this.storageService.onDidChangeValue(f.StorageScope.PROFILE,void 0,this.restoreListener)(async U=>{U.key===M&&(this.tunnelRestoreValue=Promise.resolve(this.storageService.get(M,f.StorageScope.PROFILE)),await this.restoreForwarded())}))}}cleanupExpiredTunnelsForRestore(){const M=this.storageService.keys(f.StorageScope.PROFILE,f.StorageTarget.USER).filter(U=>U.startsWith(r));for(const U of M){const H=this.storageService.getNumber(U,f.StorageScope.PROFILE);if(H&&H<Date.now()){this.tunnelRestoreValue=Promise.resolve(void 0);const F=U.replace(r,n);this.storageService.remove(U,f.StorageScope.PROFILE),this.storageService.remove(F,f.StorageScope.PROFILE)}}}async storeForwarded(){if(this.configurationService.getValue("remote.restoreForwardedPorts")){const M=Array.from(this.forwarded.values()),U=M.map($=>({remoteHost:$.remoteHost,remotePort:$.remotePort,localPort:$.localPort,name:$.name,localAddress:$.localAddress,localUri:$.localUri,protocol:$.protocol,source:$.source}));let H;M.length>0&&(H=JSON.stringify(U));const F=await this.getTunnelRestoreStorageKey(),x=await this.getRestoreExpirationStorageKey();!H&&F&&x?(this.storageService.remove(F,f.StorageScope.PROFILE),this.storageService.remove(x,f.StorageScope.PROFILE)):H!==this.knownPortsRestoreValue&&F&&x&&(this.storageService.store(F,H,f.StorageScope.PROFILE,f.StorageTarget.USER),this.storageService.store(x,Date.now()+d,f.StorageScope.PROFILE,f.StorageTarget.USER)),this.knownPortsRestoreValue=H}}async showPortMismatchModalIfNeeded(M,U,H){if(!M.tunnelLocalPort||!H?.requireLocalPort||M.tunnelLocalPort===U)return;const F=new Date;if(this.mismatchCooldown.getTime()+t>F.getTime())return;this.mismatchCooldown=F;const x=s.localize(12562,null,U,M.tunnelRemotePort,M.tunnelLocalPort);return this.dialogService.info(x)}async forward(M,U){return!this.restoreComplete&&this.environmentService.remoteAuthority&&await D.Event.toPromise(this.onRestoreComplete.event),this.doForward(M,U)}async doForward(M,U){await this.extensionService.activateByEvent(e.ACTIVATION_EVENT);const H=I(this.forwarded,M.remote.host,M.remote.port);U=U??(U!==null?(await this.getAttributes([M.remote]))?.get(M.remote.port):void 0);const F=M.local!==void 0?M.local:M.remote.port;let x;if(H)return this.mergeAttributesIntoExistingTunnel(H,M,U);{const $=this.environmentService.remoteAuthority,G=$?{getAddress:async()=>(await this.remoteAuthorityResolverService.resolveAuthority($)).authority}:void 0,B=P(M.remote.host,M.remote.port);this.inProgress.set(B,!0),M=this.mergeCachedAndUnrestoredProperties(B,M);const W=await this.tunnelService.openTunnel(G,M.remote.host,M.remote.port,void 0,F,M.elevateIfNeeded?M.elevateIfNeeded:U?.elevateIfNeeded,M.privacy,U?.protocol);if(typeof W=="string")x=W;else if(W&&W.localAddress){const Z=I(this._candidates??new Map,M.remote.host,M.remote.port),J=W.protocol?W.protocol===T.TunnelProtocol.Https?T.TunnelProtocol.Https:T.TunnelProtocol.Http:U?.protocol??T.TunnelProtocol.Http,oe={remoteHost:W.tunnelRemoteHost,remotePort:W.tunnelRemotePort,localPort:W.tunnelLocalPort,name:U?.label??M.name,closeable:!0,localAddress:W.localAddress,protocol:J,localUri:await this.makeLocalUri(W.localAddress,U),runningProcess:Z?.detail,hasRunningProcess:!!Z,pid:Z?.pid,source:M.source??e.UserTunnelSource,privacy:W.privacy};return this.forwarded.set(B,oe),this.remoteTunnels.set(B,W),this.inProgress.delete(B),await this.storeForwarded(),await this.showPortMismatchModalIfNeeded(W,F,U),this._onForwardPort.fire(oe),W}this.inProgress.delete(B)}return x}mergeCachedAndUnrestoredProperties(M,U){const H=this.unrestoredExtensionTunnels.has(M)?this.unrestoredExtensionTunnels:this.sessionCachedProperties.has(M)?this.sessionCachedProperties:void 0;if(H){const F=H.get(M);H.delete(M),F&&(U.name=F.name??U.name,U.local=("local"in F?F.local:"localPort"in F?F.localPort:void 0)??U.local,U.privacy=U.privacy)}return U}async mergeAttributesIntoExistingTunnel(M,U,H){const F=H?.label??U.name;let x;(function(G){G[G.None=0]="None",G[G.Fire=1]="Fire",G[G.Reopen=2]="Reopen"})(x||(x={}));let $=x.None;switch(F!==M.name&&(M.name=F,$=x.Fire),(H?.protocol||M.protocol!==T.TunnelProtocol.Http)&&H?.protocol!==M.protocol&&(U.source=M.source,$=x.Reopen),U.privacy&&M.privacy!==U.privacy&&($=x.Reopen),$){case x.Fire:{this._onForwardPort.fire();break}case x.Reopen:await this.close(M.remoteHost,M.remotePort,g.User),await this.doForward(U,H)}return I(this.remoteTunnels,U.remote.host,U.remote.port)}async name(M,U,H){const F=I(this.forwarded,M,U),x=P(M,U);if(F){F.name=H,await this.storeForwarded(),this._onPortName.fire({host:M,port:U});return}else this.detected.has(x)&&(this.detected.get(x).name=H,this._onPortName.fire({host:M,port:U}))}async close(M,U,H){const F=P(M,U),x=this.forwarded.get(F);return H===g.AutoForwardEnd&&x&&x.source.source===w.Auto&&this.sessionCachedProperties.set(F,{local:x.localPort,name:x.name,privacy:x.privacy}),await this.tunnelService.closeTunnel(M,U),this.onTunnelClosed({host:M,port:U},H)}address(M,U){const H=P(M,U);return(this.forwarded.get(H)||this.detected.get(H))?.localAddress}get environmentTunnelsSet(){return this._environmentTunnelsSet}addEnvironmentTunnels(M){if(M)for(const U of M){const H=I(this._candidates??new Map,U.remoteAddress.host,U.remoteAddress.port),F=typeof U.localAddress=="string"?U.localAddress:P(U.localAddress.host,U.localAddress.port);this.detected.set(P(U.remoteAddress.host,U.remoteAddress.port),{remoteHost:U.remoteAddress.host,remotePort:U.remoteAddress.port,localAddress:F,protocol:T.TunnelProtocol.Http,localUri:this.makeLocalUri(F),closeable:!1,runningProcess:H?.detail,hasRunningProcess:!!H,pid:H?.pid,privacy:T.TunnelPrivacyId.ConstantPrivate,source:{source:w.Extension,description:s.localize(12563,null)}}),this.tunnelService.setEnvironmentTunnel(U.remoteAddress.host,U.remoteAddress.port,F,T.TunnelPrivacyId.ConstantPrivate,T.TunnelProtocol.Http)}this._environmentTunnelsSet=!0,this._onEnvironmentTunnelsSet.fire(),this._onForwardPort.fire()}setCandidateFilter(M){this._candidateFilter=M}async setCandidates(M){let U=M;this._candidateFilter&&(U=await this._candidateFilter(M));const H=this.updateInResponseToCandidates(U);this.logService.trace(`ForwardedPorts: (TunnelModel) removed candidates ${Array.from(H.values()).map(F=>F.port).join(", ")}`),this._onCandidatesChanged.fire(H)}updateInResponseToCandidates(M){const U=this._candidates??new Map,H=new Map;return this._candidates=H,M.forEach(F=>{const x=P(F.host,F.port);H.set(x,{host:F.host,port:F.port,detail:F.detail,pid:F.pid}),U.has(x)&&U.delete(x);const $=I(this.forwarded,F.host,F.port);$&&($.runningProcess=F.detail,$.hasRunningProcess=!0,$.pid=F.pid)}),U.forEach((F,x)=>{const $=c(x);if(!$)return;const G=I(this.forwarded,$.host,$.port);G&&(G.runningProcess=void 0,G.hasRunningProcess=!1,G.pid=void 0);const B=I(this.detected,$.host,$.port);B&&(B.runningProcess=void 0,B.hasRunningProcess=!1,B.pid=void 0)}),U}get candidates(){return this._candidates?Array.from(this._candidates.values()):[]}get candidatesOrUndefined(){return this._candidates?this.candidates:void 0}async updateAttributes(){const M=Array.from(this.forwarded.values()),U=await this.getAttributes(M.map(H=>({port:H.remotePort,host:H.remoteHost})),!1);if(U)for(const H of M){const F=U.get(H.remotePort);(F?.protocol||H.protocol!==T.TunnelProtocol.Http)&&F?.protocol!==H.protocol&&await this.doForward({remote:{host:H.remoteHost,port:H.remotePort},local:H.localPort,name:H.name,source:H.source},F),F&&F.label&&F.label!==H.name&&await this.name(H.remoteHost,H.remotePort,F.label)}}async getAttributes(M,U=!0){const H=new Map,F=new Map;M.forEach(W=>{const Z=I(this._candidates??new Map,T.LOCALHOST_ADDRESSES[0],W.port)??W;if(Z){H.set(W.port,Z);const J=b(Z)?Z.pid:void 0;F.has(J)||F.set(J,[]),F.get(J)?.push(W.port)}});const x=new Map;if(M.forEach(W=>{const Z=this.configPortsAttributes.getAttributes(W.port,W.host,H.get(W.port)?.detail);Z&&x.set(W.port,Z)}),this.portAttributesProviders.length===0||!U)return x.size>0?x:void 0;const $=await Promise.all(this.portAttributesProviders.flatMap(W=>Array.from(F.entries()).map(Z=>{const J=Z[1],oe=H.get(J[0]);return W.providePortAttributes(J,oe?.pid,oe?.detail,p.CancellationToken.None)}))),G=new Map;if($.forEach(W=>W.forEach(Z=>{Z&&G.set(Z.port,Z)})),!x&&!G)return;const B=new Map;return M.forEach(W=>{const Z=x.get(W.port),J=G.get(W.port);B.set(W.port,{elevateIfNeeded:Z?.elevateIfNeeded,label:Z?.label,onAutoForward:Z?.onAutoForward??E.providedActionToAction(J?.autoForwardAction),requireLocalPort:Z?.requireLocalPort,protocol:Z?.protocol})}),B}addAttributesProvider(M){this.portAttributesProviders.push(M)}};e.TunnelModel=N,Qe([(0,h.debounce)(1e3)],N.prototype,"storeForwarded",null),e.TunnelModel=N=Qe([$e(0,T.ITunnelService),$e(1,f.IStorageService),$e(2,v.IConfigurationService),$e(3,o.IWorkbenchEnvironmentService),$e(4,_.IRemoteAuthorityResolverService),$e(5,S.IWorkspaceContextService),$e(6,C.ILogService),$e(7,l.IDialogService),$e(8,m.IExtensionService),$e(9,a.IContextKeyService)],N)}),define(Pe[59],ke([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.ExcludeSettingOptions=e.TextSearchContextNew=e.TextSearchMatchNew=e.Range=e.Position=void 0;class s{constructor(l,C){this.line=l,this.character=C}isBefore(l){return!1}isBeforeOrEqual(l){return!1}isAfter(l){return!1}isAfterOrEqual(l){return!1}isEqual(l){return!1}compareTo(l){return 0}translate(l,C){return new s(0,0)}with(l){return new s(0,0)}}e.Position=s;class h{constructor(l,C,_,f){this.isEmpty=!1,this.isSingleLine=!1,this.start=new s(l,C),this.end=new s(_,f)}contains(l){return!1}isEqual(l){return!1}intersection(l){}union(l){return new h(0,0,0,0)}with(l){return new h(0,0,0,0)}}e.Range=h;class D{constructor(l,C,_){this.uri=l,this.ranges=C,this.previewText=_}}e.TextSearchMatchNew=D;class A{constructor(l,C,_){this.uri=l,this.text=C,this.lineNumber=_}}e.TextSearchContextNew=A;var L;(function(v){v[v.None=1]="None",v[v.FilesExclude=2]="FilesExclude",v[v.SearchAndFilesExclude=3]="SearchAndFilesExclude"})(L||(e.ExcludeSettingOptions=L={}));var R;(function(v){v[v.Information=1]="Information",v[v.Warning=2]="Warning"})(R||(e.TextSearchCompleteMessageType=R={}))}),define(Pe[32],ke([1,0,18,39,24,33,13,5,16,12,59,8]),function(ge,e,s,h,D,A,L,R,v,l,C,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DEFAULT_TEXT_SEARCH_PREVIEW_OPTIONS=e.QueryGlobTester=e.SerializableFileMatch=e.SearchError=e.SearchErrorCode=e.SearchSortOrder=e.ViewMode=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.QueryType=e.SearchProviderType=e.ISearchService=e.DEFAULT_MAX_SEARCH_RESULTS=e.SEARCH_EXCLUDE_CONFIG=e.SEARCH_RESULT_LANGUAGE_ID=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,e.resultIsMatch=p,e.isFileMatch=u,e.isProgressMessage=i,e.getExcludes=y,e.pathIncludedInQuery=I,e.deserializeSearchError=b,e.serializeSearchError=E,e.isSerializedSearchComplete=N,e.isSerializedSearchSuccess=O,e.isSerializedFileMatch=M,e.isFilePatternMatch=U,e.resolvePatternsForProvider=F,e.hasSiblingPromiseFn=G,e.hasSiblingFn=B,e.excludeToGlobPattern=Z,h=We(h),D=We(D),A=We(A),v=We(v),Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return C.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_RESULT_LANGUAGE_ID="search-result",e.SEARCH_EXCLUDE_CONFIG="search.exclude",e.DEFAULT_MAX_SEARCH_RESULTS=2e4;const f="\u27EA ",T=" characters skipped \u27EB",S=(f.length+T.length+5)*2;e.ISearchService=(0,R.createDecorator)("searchService");var o;(function(J){J[J.file=0]="file",J[J.text=1]="text",J[J.aiText=2]="aiText"})(o||(e.SearchProviderType=o={}));var m;(function(J){J[J.File=1]="File",J[J.Text=2]="Text",J[J.aiText=3]="aiText"})(m||(e.QueryType=m={}));function p(J){return!!J.rangeLocations&&!!J.previewText}function u(J){return!!J.resource}function i(J){return!!J.message}var a;(function(J){J[J.Normal=0]="Normal",J[J.NewSearchStarted=1]="NewSearchStarted"})(a||(e.SearchCompletionExitCode=a={}));class t{constructor(oe){this.resource=oe,this.results=[]}}e.FileMatch=t;class n{constructor(oe,te,me,le){this.rangeLocations=[],this.webviewIndex=le;const Q=Array.isArray(te)?te:[te];if(me&&me.matchLines===1&&r(Q)){oe=(0,L.getNLines)(oe,me.matchLines);let z="",se=0,Ee=0;const ae=Math.floor(me.charsPerLine/5);for(const be of Q){const pe=Math.max(be.startColumn-ae,0),ve=be.startColumn+me.charsPerLine;if(pe>Ee+ae+S){const Re=f+(pe-Ee)+T;z+=Re+oe.slice(pe,ve),se+=pe-(Ee+Re.length)}else z+=oe.slice(Ee,ve);Ee=ve,this.rangeLocations.push({source:be,preview:new c(0,be.startColumn-se,be.endColumn-se)})}this.previewText=z}else{const z=Array.isArray(te)?te[0].startLineNumber:te.startLineNumber,se=(0,s.mapArrayOrNot)(te,Ee=>({preview:new d(Ee.startLineNumber-z,Ee.startColumn,Ee.endLineNumber-z,Ee.endColumn),source:Ee}));this.rangeLocations=Array.isArray(se)?se:[se],this.previewText=oe}}}e.TextSearchMatch=n;function r(J){const oe=J[0].startLineNumber;for(const te of J)if(te.startLineNumber!==oe||te.endLineNumber!==oe)return!1;return!0}class d{constructor(oe,te,me,le){this.startLineNumber=oe,this.startColumn=te,this.endLineNumber=me,this.endColumn=le}}e.SearchRange=d;class c extends d{constructor(oe,te,me){super(oe,te,oe,me)}}e.OneLineRange=c;var g;(function(J){J.List="list",J.Tree="tree"})(g||(e.ViewMode=g={}));var w;(function(J){J.Default="default",J.FileNames="fileNames",J.Type="type",J.Modified="modified",J.CountDescending="countDescending",J.CountAscending="countAscending"})(w||(e.SearchSortOrder=w={}));function y(J,oe=!0){const te=J&&J.files&&J.files.exclude,me=oe&&J&&J.search&&J.search.exclude;if(!te&&!me)return;if(!te||!me)return te||me||void 0;let le=Object.create(null);return le=D.mixin(le,D.deepClone(te)),le=D.mixin(le,D.deepClone(me),!0),le}function I(J,oe){return J.excludePattern&&h.match(J.excludePattern,oe)?!1:J.includePattern||J.usingSearchPaths?J.includePattern&&h.match(J.includePattern,oe)?!0:J.usingSearchPaths?!!J.folderQueries&&J.folderQueries.some(te=>{const me=te.folder.fsPath;if(A.isEqualOrParent(oe,me)){const le=v.relative(me,oe);return!te.includePattern||!!h.match(te.includePattern,le)}else return!1}):!1:!0}var P;(function(J){J[J.unknownEncoding=1]="unknownEncoding",J[J.regexParseError=2]="regexParseError",J[J.globParseError=3]="globParseError",J[J.invalidLiteral=4]="invalidLiteral",J[J.rgProcessError=5]="rgProcessError",J[J.other=6]="other",J[J.canceled=7]="canceled"})(P||(e.SearchErrorCode=P={}));class k extends Error{constructor(oe,te){super(oe),this.code=te}}e.SearchError=k;function b(J){const oe=J.message;if((0,l.isCancellationError)(J))return new k(oe,P.canceled);try{const te=JSON.parse(oe);return new k(te.message,te.code)}catch{return new k(oe,P.other)}}function E(J){const oe={message:J.message,code:J.code};return new Error(JSON.stringify(oe))}function N(J){return J.type==="error"?!0:J.type==="success"}function O(J){return J.type==="success"}function M(J){return!!J.path}function U(J,oe,te=!0){const me=J.searchPath?J.searchPath:J.relativePath;return te?(0,L.fuzzyContains)(me,oe):h.match(oe,me)}class H{constructor(oe){this.path=oe,this.results=[]}addMatch(oe){this.results.push(oe)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=H;function F(J,oe){const te={...J||{},...oe||{}};return Object.keys(te).filter(me=>{const le=te[me];return typeof le=="boolean"&&le})}class x{constructor(oe,te){this._parsedIncludeExpression=null,this._excludeExpression=te.excludePattern?.map(le=>({...oe.excludePattern||{},...le.pattern||{}}))??[],this._excludeExpression.length===0&&(this._excludeExpression=[oe.excludePattern||{}]),this._parsedExcludeExpression=this._excludeExpression.map(le=>h.parse(le));let me=oe.includePattern;te.includePattern&&(me?me={...me,...te.includePattern}:me=te.includePattern),me&&(this._parsedIncludeExpression=h.parse(me))}_evalParsedExcludeExpression(oe,te,me){let le=null;for(const Q of this._parsedExcludeExpression){const z=Q(oe,te,me);if(typeof z=="string"){le=z;break}}return le}matchesExcludesSync(oe,te,me){return!!(this._parsedExcludeExpression&&this._evalParsedExcludeExpression(oe,te,me))}includedInQuerySync(oe,te,me){return!(this._parsedExcludeExpression&&this._evalParsedExcludeExpression(oe,te,me)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(oe,te,me))}includedInQuery(oe,te,me){const le=()=>this._parsedIncludeExpression?!!this._parsedIncludeExpression(oe,te,me):!0;return Promise.all(this._parsedExcludeExpression.map(Q=>{const z=Q(oe,te,me);return(0,_.isThenable)(z)?z.then(se=>se?!1:le()):le()})).then(Q=>Q.some(z=>!!z))}hasSiblingExcludeClauses(){return this._excludeExpression.reduce((oe,te)=>$(te)||oe,!1)}}e.QueryGlobTester=x;function $(J){for(const oe in J)if(typeof J[oe]!="boolean")return!0;return!1}function G(J){if(!J)return;let oe;return te=>(oe||(oe=(J()||Promise.resolve([])).then(me=>me?W(me):{})),oe.then(me=>!!me[te]))}function B(J){if(!J)return;let oe;return te=>{if(!oe){const me=J();oe=me?W(me):{}}return!!oe[te]}}function W(J){const oe={};for(const te of J)oe[te]=!0;return oe}function Z(J){return J.flatMap(oe=>oe.patterns.map(te=>oe.baseUri?{baseUri:oe.baseUri,pattern:te}:te))}e.DEFAULT_TEXT_SEARCH_PREVIEW_OPTIONS={matchLines:100,charsPerLine:1e4}}),define(Pe[49],ke([1,0,18,8,20,4,3,62,14,135,22,13,2,7,27,5,11,233,47,64,29,19,15,9,74,32,6,38,59]),function(ge,e,s,h,D,A,L,R,v,l,C,_,f,T,S,o,m,p,u,i,a,t,n,r,d,c,g,w,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function I(H,F,x){return new C.ExtUri($=>E($,x)).isEqual(H,F)}function P(H,F,x){return I(H.uri,F.uri,x)?0:(0,_.compare)(H.uri.toString(),F.uri.toString())}function k(H,F,x){return H.index!==F.index?H.index<F.index?-1:1:I(H.uri,F.uri,x)?(0,_.compare)(H.name,F.name):(0,_.compare)(H.uri.toString(),F.uri.toString())}function b(H,F,x,$){const G=H.slice(0).sort((W,Z)=>x(W,Z,$)),B=F.slice(0).sort((W,Z)=>x(W,Z,$));return(0,s.delta)(G,B,(W,Z)=>x(W,Z,$))}function E(H,F){const x=F.getCapabilities(H.scheme);return!(x&&x&S.FileSystemProviderCapabilities.PathCaseSensitive)}class N extends u.Workspace{static toExtHostWorkspace(F,x,$,G){if(!F)return{workspace:null,added:[],removed:[]};const{id:B,name:W,folders:Z,configuration:J,transient:oe,isUntitled:te}=F,me=[],le=x;x?Z.forEach((Ee,ae)=>{const be=f.URI.revive(Ee.uri),pe=N._findFolder($||x,be,G);pe?(pe.name=Ee.name,pe.index=Ee.index,me.push(pe)):me.push({uri:be,name:Ee.name,index:ae})}):me.push(...Z.map(({uri:Ee,name:ae,index:be})=>({uri:f.URI.revive(Ee),name:ae,index:be}))),me.sort((Ee,ae)=>Ee.index<ae.index?-1:1);const Q=new N(B,W,me,!!oe,J?f.URI.revive(J):null,!!te,Ee=>E(Ee,G)),{added:z,removed:se}=b(le?le.workspaceFolders:[],Q.workspaceFolders,P,G);return{workspace:Q,added:z,removed:se}}static _findFolder(F,x,$){for(let G=0;G<F.folders.length;G++){const B=F.workspaceFolders[G];if(I(B.uri,x,$))return B}}constructor(F,x,$,G,B,W,Z){super(F,$.map(J=>new u.WorkspaceFolder(J)),G,B,Z),this._name=x,this._isUntitled=W,this._workspaceFolders=[],this._structure=R.TernarySearchTree.forUris(Z,()=>!0),$.forEach(J=>{this._workspaceFolders.push(J),this._structure.set(J.uri,J)})}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(F,x){return x&&this._structure.get(F)&&(F=(0,C.dirname)(F)),this._structure.findSubstr(F)}resolveWorkspaceFolder(F){return this._structure.get(F)}}let O=class{constructor(F,x,$,G,B){this._onDidChangeWorkspace=new A.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new A.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._editSessionIdentityProviders=new Map,this._providerHandlePool=0,this._onWillCreateEditSessionIdentityEvent=new A.AsyncEmitter,this._canonicalUriProviders=new Map,this._logService=G,this._extHostFileSystemInfo=$,this._uriTransformerService=B,this._requestIdProvider=new l.Counter,this._barrier=new h.Barrier,this._proxy=F.getProxy(g.MainContext.MainThreadWorkspace),this._messageService=F.getProxy(g.MainContext.MainThreadMessageService);const W=x.workspace;this._confirmedWorkspace=W?new N(W.id,W.name,[],!!W.transient,W.configuration?f.URI.revive(W.configuration):null,!!W.isUntitled,Z=>E(Z,$)):void 0}$initializeWorkspace(F,x){this._trusted=x,this.$acceptWorkspaceData(F),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?f.URI.from({scheme:v.Schemas.untitled,path:(0,C.basename)((0,C.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(F,x,$,...G){const B=[];if(Array.isArray(G)&&G.forEach(te=>{f.URI.isUri(te.uri)&&!B.some(me=>I(me.uri,te.uri,this._extHostFileSystemInfo))&&B.push({uri:te.uri,name:te.name||(0,C.basenameOrAuthority)(te.uri)})}),this._unconfirmedWorkspace||[x,$].some(te=>typeof te!="number"||te<0)||$===0&&B.length===0)return!1;const W=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(x+$>W.length)return!1;const Z=W.slice(0);Z.splice(x,$,...B.map(te=>({uri:te.uri,name:te.name||(0,C.basenameOrAuthority)(te.uri),index:void 0})));for(let te=0;te<Z.length;te++){const me=Z[te];if(Z.some((le,Q)=>Q!==te&&I(me.uri,le.uri,this._extHostFileSystemInfo)))return!1}Z.forEach((te,me)=>te.index=me);const{added:J,removed:oe}=b(W,Z,k,this._extHostFileSystemInfo);if(J.length===0&&oe.length===0)return!1;if(this._proxy){const te=F.displayName||F.name;this._proxy.$updateWorkspaceFolders(te,x,$,B).then(void 0,me=>{this._unconfirmedWorkspace=void 0;const le={source:{identifier:F.identifier,label:F.displayName||F.name}};this._messageService.$showMessage(p.Severity.Error,(0,T.localize)(2718,null,te,me.toString()),le,[])})}return this.trySetWorkspaceFolders(Z),!0}getWorkspaceFolder(F,x){if(this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(F,x)}async getWorkspaceFolder2(F,x){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(F,x)}async resolveWorkspaceFolder(F){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(F)}getPath(){if(!this._actualWorkspace)return;const{folders:F}=this._actualWorkspace;if(F.length!==0)return F[0].uri.fsPath}getRelativePath(F,x){let $,G="";if(typeof F=="string"?($=f.URI.file(F),G=F):typeof F<"u"&&($=F,G=F.fsPath),!$)return G;const B=this.getWorkspaceFolder($,!0);if(!B)return G;typeof x>"u"&&this._actualWorkspace&&(x=this._actualWorkspace.folders.length>1);let W=(0,C.relativePath)(B.uri,$);return x&&B.name&&(W=`${B.name}/${W}`),W}trySetWorkspaceFolders(F){this._actualWorkspace&&(this._unconfirmedWorkspace=N.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:F,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(F){const{workspace:x,added:$,removed:G}=N.toExtHostWorkspace(F,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=x||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:$,removed:G}))}findFiles(F,x,$,G,B=D.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${G.value}, entryPoint: findFiles`);let W="",Z=!0;return x===null?Z=!1:x!==void 0&&(typeof x=="string"?W=x:W=x.pattern),this._findFilesImpl(F,void 0,{exclude:[W],maxResults:$,useExcludeSettings:Z?y.ExcludeSettingOptions.FilesExclude:y.ExcludeSettingOptions.None,useIgnoreFiles:{local:!1}},B)}findFiles2(F,x={},$,G=D.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles2: fileSearch, extension: ${$.value}, entryPoint: findFiles2`);const B=x.useDefaultExcludes??!0,W=x.useDefaultSearchExcludes??!0,Z=B?W?y.ExcludeSettingOptions.SearchAndFilesExclude:y.ExcludeSettingOptions.FilesExclude:y.ExcludeSettingOptions.None,J={exclude:x.exclude?[x.exclude]:void 0,useIgnoreFiles:{local:x.useIgnoreFiles,global:x.useGlobalIgnoreFiles,parent:x.useParentIgnoreFiles},useExcludeSettings:Z,followSymlinks:x.followSymlinks,maxResults:x.maxResults};return this._findFilesImpl(void 0,F!==void 0?[F]:[],J,G)}findFiles2New(F,x={},$,G=D.CancellationToken.None){return this._logService.trace(`extHostWorkspace#findFiles2New: fileSearch, extension: ${$.value}, entryPoint: findFiles2New`),this._findFilesImpl(void 0,F,x,G)}async _findFilesImpl(F,x,$,G=D.CancellationToken.None){if(G&&G.isCancellationRequested)return Promise.resolve([]);const W=(F!==void 0?[F]:x)?.map(Z=>{const J=U($.exclude),oe={ignoreSymlinks:typeof $.followSymlinks=="boolean"?!$.followSymlinks:void 0,disregardIgnoreFiles:typeof $.useIgnoreFiles?.local=="boolean"?!$.useIgnoreFiles.local:void 0,disregardGlobalIgnoreFiles:typeof $.useIgnoreFiles?.global=="boolean"?!$.useIgnoreFiles.global:void 0,disregardParentIgnoreFiles:typeof $.useIgnoreFiles?.parent=="boolean"?!$.useIgnoreFiles.parent:void 0,disregardExcludeSettings:$.useExcludeSettings!==void 0&&$.useExcludeSettings===y.ExcludeSettingOptions.None,disregardSearchExcludeSettings:$.useExcludeSettings!==void 0&&$.useExcludeSettings!==y.ExcludeSettingOptions.SearchAndFilesExclude,maxResults:$.maxResults,excludePattern:J.length>0?J:void 0,_reason:"startFileSearch",shouldGlobSearch:F?void 0:!0},te=M(n.GlobPattern.from(Z)),me=te?.folder;return F?oe.includePattern=te?.pattern:oe.filePattern=te?.pattern,{folder:me,options:oe}})??[];return this._findFilesBase(W,G)}async _findFilesBase(F,x){return(await Promise.all(F?.map(G=>this._proxy.$startFileSearch(G.folder??null,G.options,x).then(B=>Array.isArray(B)?B.map(W=>f.URI.revive(W)):[]))??[])).flat()}findTextInFilesNew(F,x,$,G){this._logService.trace(`extHostWorkspace#findTextInFilesNew: textSearch, extension: ${x.value}, entryPoint: findTextInFilesNew`);const B=te=>{if(!$)return{folder:void 0,options:{}};const me=te?M(n.GlobPattern.from(te)):void 0,le=U($.exclude);return{options:{ignoreSymlinks:typeof $.followSymlinks=="boolean"?!$.followSymlinks:void 0,disregardIgnoreFiles:typeof $.useIgnoreFiles=="boolean"?!$.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof $.useIgnoreFiles?.global=="boolean"?!$.useIgnoreFiles?.global:void 0,disregardParentIgnoreFiles:typeof $.useIgnoreFiles?.parent=="boolean"?!$.useIgnoreFiles?.parent:void 0,disregardExcludeSettings:$.useExcludeSettings!==void 0&&$.useExcludeSettings===y.ExcludeSettingOptions.None,disregardSearchExcludeSettings:$.useExcludeSettings!==void 0&&$.useExcludeSettings!==y.ExcludeSettingOptions.SearchAndFilesExclude,fileEncoding:$.encoding,maxResults:$.maxResults,previewOptions:$.previewOptions?{matchLines:$.previewOptions?.numMatchLines??100,charsPerLine:$.previewOptions?.charsPerLine??1e4}:void 0,surroundingContext:$.surroundingContext,includePattern:me?.pattern,excludePattern:le},folder:me?.folder}},Z=($?.include?.map(te=>B(te))??[B(void 0)]).filter(te=>!!te),J=Promise.resolve(void 0);return{results:new h.AsyncIterableObject(async te=>{const me=(le,Q)=>((0,c.resultIsMatch)(le)?te.emitOne(new y.TextSearchMatchNew(Q,le.rangeLocations.map(z=>({previewRange:new r.Range(z.preview.startLineNumber,z.preview.startColumn,z.preview.endLineNumber,z.preview.endColumn),sourceRange:new r.Range(z.source.startLineNumber,z.source.startColumn,z.source.endLineNumber,z.source.endColumn)})),le.previewText)):te.emitOne(new y.TextSearchContextNew(Q,le.text,le.lineNumber)),le);await J.then(le=>this.findTextInFilesBase(F,Z,me,G))}),complete:J.then(te=>({limitHit:te?.limitHit??!1}))}}async findTextInFilesBase(F,x,$,G=D.CancellationToken.None){const B=this._requestIdProvider.getNext();let W=!1;if(G.onCancellationRequested(Z=>{W=!0}),this._activeSearchCallbacks[B]=Z=>{if(W)return;const J=f.URI.revive(Z.resource);Z.results.forEach(oe=>{const te=(0,w.revive)(oe);$(te,J)})},G.isCancellationRequested)return{};try{const Z=await Promise.all(x?.map(J=>this._proxy.$startTextSearch(F,J.folder??null,J.options,B,G)||{})??[]);return delete this._activeSearchCallbacks[B],Z.reduce((J,oe)=>({limitHit:J?.limitHit||(oe?.limitHit??!1),message:[J?.message??[],oe?.message??[]].flat()}),{})??{limitHit:!1}}catch(Z){throw delete this._activeSearchCallbacks[B],Z}}async findTextInFiles(F,x,$,G,B=D.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${G.value}, entryPoint: findTextInFiles`);const W=typeof x.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:x.previewOptions,Z=M(n.GlobPattern.from(x.include)),J=typeof x.exclude=="string"?x.exclude:x.exclude?x.exclude.pattern:void 0,oe={ignoreSymlinks:typeof x.followSymlinks=="boolean"?!x.followSymlinks:void 0,disregardIgnoreFiles:typeof x.useIgnoreFiles=="boolean"?!x.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof x.useGlobalIgnoreFiles=="boolean"?!x.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof x.useParentIgnoreFiles=="boolean"?!x.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof x.useDefaultExcludes=="boolean"?!x.useDefaultExcludes:!0,disregardSearchExcludeSettings:typeof x.useSearchExclude=="boolean"?!x.useSearchExclude:!0,fileEncoding:x.encoding,maxResults:x.maxResults,previewOptions:W,surroundingContext:x.afterContext,includePattern:Z?.pattern,excludePattern:J?[{pattern:J}]:void 0},te=(me,le)=>{(0,c.resultIsMatch)(me)?$({uri:le,preview:{text:me.previewText,matches:(0,s.mapArrayOrNot)(me.rangeLocations,Q=>new r.Range(Q.preview.startLineNumber,Q.preview.startColumn,Q.preview.endLineNumber,Q.preview.endColumn))},ranges:(0,s.mapArrayOrNot)(me.rangeLocations,Q=>new r.Range(Q.source.startLineNumber,Q.source.startColumn,Q.source.endLineNumber,Q.source.endColumn))}):$({uri:le,text:me.text,lineNumber:me.lineNumber})};return this.findTextInFilesBase(F,[{options:oe,folder:Z?.folder}],te,B)}$handleTextSearchResult(F,x){this._activeSearchCallbacks[x]?.(F)}async save(F){const x=await this._proxy.$save(F,{saveAs:!1});return f.URI.revive(x)}async saveAs(F){const x=await this._proxy.$save(F,{saveAs:!0});return f.URI.revive(x)}saveAll(F){return this._proxy.$saveAll(F)}resolveProxy(F){return this._proxy.$resolveProxy(F)}lookupAuthorization(F){return this._proxy.$lookupAuthorization(F)}lookupKerberosAuthorization(F){return this._proxy.$lookupKerberosAuthorization(F)}loadCertificates(){return this._proxy.$loadCertificates()}get trusted(){return this._trusted}requestWorkspaceTrust(F){return this._proxy.$requestWorkspaceTrust(F)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}registerEditSessionIdentityProvider(F,x){if(this._editSessionIdentityProviders.has(F))throw new Error(`A provider has already been registered for scheme ${F}`);this._editSessionIdentityProviders.set(F,x);const $=this._uriTransformerService.transformOutgoingScheme(F),G=this._providerHandlePool++;return this._proxy.$registerEditSessionIdentityProvider(G,$),(0,L.toDisposable)(()=>{this._editSessionIdentityProviders.delete(F),this._proxy.$unregisterEditSessionIdentityProvider(G)})}async $getEditSessionIdentifier(F,x){this._logService.info("Getting edit session identifier for workspaceFolder",F);const $=await this.resolveWorkspaceFolder(f.URI.revive(F));if(!$){this._logService.warn("Unable to resolve workspace folder");return}this._logService.info("Invoking #provideEditSessionIdentity for workspaceFolder",$);const G=this._editSessionIdentityProviders.get($.uri.scheme);if(this._logService.info(`Provider for scheme ${$.uri.scheme} is defined: `,!!G),!G)return;const B=await G.provideEditSessionIdentity($,x);if(this._logService.info("Provider returned edit session identifier: ",B),!!B)return B}async $provideEditSessionIdentityMatch(F,x,$,G){this._logService.info("Getting edit session identifier for workspaceFolder",F);const B=await this.resolveWorkspaceFolder(f.URI.revive(F));if(!B){this._logService.warn("Unable to resolve workspace folder");return}this._logService.info("Invoking #provideEditSessionIdentity for workspaceFolder",B);const W=this._editSessionIdentityProviders.get(B.uri.scheme);if(this._logService.info(`Provider for scheme ${B.uri.scheme} is defined: `,!!W),!W)return;const Z=await W.provideEditSessionIdentityMatch?.(x,$,G);if(this._logService.info("Provider returned edit session identifier match result: ",Z),!!Z)return Z}getOnWillCreateEditSessionIdentityEvent(F){return(x,$,G)=>{const B=function(Z){x.call($,Z)};return B.extension=F,this._onWillCreateEditSessionIdentityEvent.event(B,void 0,G)}}async $onWillCreateEditSessionIdentity(F,x,$){const G=await this.resolveWorkspaceFolder(f.URI.revive(F));if(G===void 0)throw new Error("Unable to resolve workspace folder");await this._onWillCreateEditSessionIdentityEvent.fireAsync({workspaceFolder:G},x,async(B,W)=>{const Z=Date.now();await Promise.resolve(B),Date.now()-Z>$&&this._logService.warn("SLOW edit session create-participant",W.extension.identifier)}),x.isCancellationRequested}registerCanonicalUriProvider(F,x){if(this._canonicalUriProviders.has(F))throw new Error(`A provider has already been registered for scheme ${F}`);this._canonicalUriProviders.set(F,x);const $=this._uriTransformerService.transformOutgoingScheme(F),G=this._providerHandlePool++;return this._proxy.$registerCanonicalUriProvider(G,$),(0,L.toDisposable)(()=>{this._canonicalUriProviders.delete(F),this._proxy.$unregisterCanonicalUriProvider(G)})}async provideCanonicalUri(F,x,$){const G=this._canonicalUriProviders.get(F.scheme);if(!G)return;const B=await G.provideCanonicalUri?.(f.URI.revive(F),x,$);if(B)return B}async $provideCanonicalUri(F,x,$){return this.provideCanonicalUri(f.URI.revive(F),{targetScheme:x},$)}};e.ExtHostWorkspace=O,e.ExtHostWorkspace=O=Qe([$e(0,t.IExtHostRpcService),$e(1,a.IExtHostInitDataService),$e(2,i.IExtHostFileSystemInfo),$e(3,m.ILogService),$e(4,d.IURITransformerService)],O),e.IExtHostWorkspace=(0,o.createDecorator)("IExtHostWorkspace");function M(H){let F,x;if(H)return typeof H=="string"?F=H:(F=H.pattern,x=f.URI.revive(H.baseUri)),{pattern:F,folder:x}}function U(H){return(H?.map(F=>{if(typeof F=="string")return F===""?void 0:{pattern:F,uri:void 0};{const x=M(F);return x?{pattern:x.pattern,uri:x.folder}:void 0}})??[]).filter(F=>!!F)}}),define(Pe[42],ke([1,0,24,4,49,6,9,46,235,72,17,8,5,19,11,2]),function(ge,e,s,h,D,A,L,R,v,l,C,_,f,T,S,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function m(d,c){if(c){const g=c.split(".");let w=d;for(let y=0;w&&y<g.length;y++)w=w[g[y]];return w}}function p(d){return d instanceof o.URI}function u(d){return d&&d.uri instanceof o.URI&&d.languageId&&typeof d.languageId=="string"}function i(d){return d&&!d.uri&&d.languageId&&typeof d.languageId=="string"}function a(d){return d&&d.uri instanceof o.URI&&(!d.name||typeof d.name=="string")&&(!d.index||typeof d.index=="number")}function t(d){if(p(d))return{resource:d};if(u(d))return{resource:d.uri,overrideIdentifier:d.languageId};if(i(d))return{overrideIdentifier:d.languageId};if(a(d))return{resource:d.uri};if(d===null)return{resource:null}}let n=class{constructor(c,g,w){this._proxy=c.getProxy(A.MainContext.MainThreadConfiguration),this._extHostWorkspace=g,this._logService=w,this._barrier=new _.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(c=>this._actual)}$initializeConfiguration(c){this._actual=new r(this._proxy,this._extHostWorkspace,c,this._logService),this._barrier.open()}$acceptConfigurationChanged(c,g){this.getConfigProvider().then(w=>w.$acceptConfigurationChanged(c,g))}};e.ExtHostConfiguration=n,e.ExtHostConfiguration=n=Qe([$e(0,T.IExtHostRpcService),$e(1,D.IExtHostWorkspace),$e(2,S.ILogService)],n);class r{constructor(c,g,w,y){this._onDidChangeConfiguration=new h.Emitter,this._proxy=c,this._logService=y,this._extHostWorkspace=g,this._configuration=v.Configuration.parse(w,y),this._configurationScopes=this._toMap(w.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(c,g){const w={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=v.Configuration.parse(c,this._logService),this._configurationScopes=this._toMap(c.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(g,w))}getConfiguration(c,g,w){const y=t(g)||{},I=this._toReadonlyValue(c?m(this._configuration.getValue(void 0,y,this._extHostWorkspace.workspace),c):this._configuration.getValue(void 0,y,this._extHostWorkspace.workspace));c&&this._validateConfigurationAccess(c,y,w?.identifier);function P(b){if(b==null)return null;if(typeof b=="boolean")return b?R.ConfigurationTarget.USER:R.ConfigurationTarget.WORKSPACE;switch(b){case L.ConfigurationTarget.Global:return R.ConfigurationTarget.USER;case L.ConfigurationTarget.Workspace:return R.ConfigurationTarget.WORKSPACE;case L.ConfigurationTarget.WorkspaceFolder:return R.ConfigurationTarget.WORKSPACE_FOLDER}}const k={has(b){return typeof m(I,b)<"u"},get:(b,E)=>{this._validateConfigurationAccess(c?`${c}.${b}`:b,y,w?.identifier);let N=m(I,b);if(typeof N>"u")N=E;else{let O;const M=(U,H)=>{if((0,C.isObject)(U)){let F;const x=()=>{O=O||(0,s.deepClone)(I),F=F||m(O,H)};return new Proxy(U,{get:($,G)=>{if(typeof G=="string"&&G.toLowerCase()==="tojson")return x(),()=>F;if(O)return F=F||m(O,H),F[G];const B=$[G];return typeof G=="string"?M(B,`${H}.${G}`):B},set:($,G,B)=>(x(),F&&(F[G]=B),!0),deleteProperty:($,G)=>(x(),F&&delete F[G],!0),defineProperty:($,G,B)=>(x(),F&&Object.defineProperty(F,G,B),!0)})}return Array.isArray(U)?(0,s.deepClone)(U):U};N=M(N,b)}return N},update:(b,E,N,O)=>{b=c?`${c}.${b}`:b;const M=P(N);return E!==void 0?this._proxy.$updateConfigurationOption(M,b,E,y,O):this._proxy.$removeConfigurationOption(M,b,y,O)},inspect:b=>{b=c?`${c}.${b}`:b;const E=this._configuration.inspect(b,y,this._extHostWorkspace.workspace);if(E)return{key:b,defaultValue:(0,s.deepClone)(E.policy?.value??E.default?.value),globalValue:(0,s.deepClone)(E.user?.value??E.application?.value),workspaceValue:(0,s.deepClone)(E.workspace?.value),workspaceFolderValue:(0,s.deepClone)(E.workspaceFolder?.value),defaultLanguageValue:(0,s.deepClone)(E.default?.override),globalLanguageValue:(0,s.deepClone)(E.user?.override??E.application?.override),workspaceLanguageValue:(0,s.deepClone)(E.workspace?.override),workspaceFolderLanguageValue:(0,s.deepClone)(E.workspaceFolder?.override),languageIds:(0,s.deepClone)(E.overrideIdentifiers)}}};return typeof I=="object"&&(0,s.mixin)(k,I,!1),Object.freeze(k)}_toReadonlyValue(c){const g=w=>(0,C.isObject)(w)?new Proxy(w,{get:(y,I)=>g(y[I]),set:(y,I,P)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(I)}' of object`)},deleteProperty:(y,I)=>{throw new Error(`TypeError: Cannot delete read only property '${String(I)}' of object`)},defineProperty:(y,I)=>{throw new Error(`TypeError: Cannot define property '${String(I)}' for a readonly object`)},setPrototypeOf:y=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):w;return g(c)}_validateConfigurationAccess(c,g,w){const y=l.OVERRIDE_PROPERTY_REGEX.test(c)?l.ConfigurationScope.RESOURCE:this._configurationScopes.get(c),I=w?`[${w.value}] `:"";if(l.ConfigurationScope.RESOURCE===y){typeof g?.resource>"u"&&this._logService.warn(`${I}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${c}', provide the URI of a resource or 'null' for any resource.`);return}if(l.ConfigurationScope.WINDOW===y){g?.resource&&this._logService.warn(`${I}Accessing a window scoped configuration for a resource is not expected. To associate '${c}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(c,g){const w=new v.ConfigurationChangeEvent(c,g,this._configuration,this._extHostWorkspace.workspace,this._logService);return Object.freeze({affectsConfiguration:(y,I)=>w.affectsConfiguration(y,t(I))})}_toMap(c){return c.reduce((g,w)=>(g.set(w[0],w[1]),g),new Map)}}e.ExtHostConfigProvider=r,e.IExtHostConfiguration=(0,f.createDecorator)("IExtHostConfiguration")}),define(Pe[100],ke([1,0,2,8,4,6,9,49,65,42,20,48,19,29,5,14,10,11,96,275,12,18]),function(ge,e,s,h,D,A,L,R,v,l,C,_,f,T,S,o,m,p,u,i,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0,L=We(L),m=We(m);var n;(function(M){function U(F){if(F!=null)return F}M.from=U;function H(F){if(F!=null)return F}M.to=H})(n||(n={}));var r;(function(M){function U(F){if(F!=null)return F}M.from=U;function H(F){if(F!=null)return F}M.to=H})(r||(r={}));var d;(function(M){function U(F){if(F!=null)return F}M.from=U;function H(F){if(F!=null)return F}M.to=H})(d||(d={}));var c;(function(M){function U(x){if(x){const $=x;return $&&!!$.process}else return!1}M.is=U;function H(x){if(x==null)return;const $={process:x.process,args:x.args};return x.options&&($.options=d.from(x.options)),$}M.from=H;function F(x){if(x!=null)return new L.ProcessExecution(x.process,x.args,x.options)}M.to=F})(c||(c={}));var g;(function(M){function U(F){if(F!=null)return F}M.from=U;function H(F){if(F!=null)return F}M.to=H})(g||(g={}));var w;(function(M){function U(x){if(x){const $=x;return $&&(!!$.commandLine||!!$.command)}else return!1}M.is=U;function H(x){if(x==null)return;const $={};return x.commandLine!==void 0?$.commandLine=x.commandLine:($.command=x.command,$.args=x.args),x.options&&($.options=g.from(x.options)),$}M.from=H;function F(x){if(!(x==null||x.command===void 0&&x.commandLine===void 0))return x.commandLine?new L.ShellExecution(x.commandLine,x.options):new L.ShellExecution(x.command,x.args?x.args:[],x.options)}M.to=F})(w||(w={}));var y;(function(M){function U(x){if(x){const $=x;return $&&$.customExecution==="customExecution"}else return!1}M.is=U;function H(x){return{customExecution:"customExecution"}}M.from=H;function F(x,$){return $.get(x)}M.to=F})(y||(e.CustomExecutionDTO=y={}));var I;(function(M){function U(H,F){let x;return H.scope!==void 0&&typeof H.scope!="number"?x=H.scope.uri:H.scope!==void 0&&typeof H.scope=="number"&&(H.scope===L.TaskScope.Workspace&&F&&F.workspaceFile?x=F.workspaceFile:x=i.USER_TASKS_GROUP_KEY),{id:H._id,workspaceFolder:x}}M.from=U})(I||(e.TaskHandleDTO=I={}));var P;(function(M){function U(H){if(H!=null)return{_id:H.id,isDefault:H.isDefault}}M.from=U})(P||(P={}));var k;(function(M){function U(x,$){if(x==null)return[];const G=[];for(const B of x){const W=H(B,$);W&&G.push(W)}return G}M.fromMany=U;function H(x,$){if(x==null)return;let G;x.execution instanceof L.ProcessExecution?G=c.from(x.execution):x.execution instanceof L.ShellExecution?G=w.from(x.execution):x.execution&&x.execution instanceof L.CustomExecution&&(G=y.from(x.execution));const B=n.from(x.definition);let W;return x.scope?typeof x.scope=="number"?W=x.scope:W=x.scope.uri:W=L.TaskScope.Workspace,!B||!W?void 0:{_id:x._id,definition:B,name:x.name,source:{extensionId:$.identifier.value,label:x.source,scope:W},execution:G,isBackground:x.isBackground,group:P.from(x.group),presentationOptions:r.from(x.presentationOptions),problemMatchers:(0,t.asArray)(x.problemMatchers),hasDefinedMatchers:x.hasDefinedMatchers,runOptions:x.runOptions?x.runOptions:{reevaluateOnRerun:!0},detail:x.detail}}M.from=H;async function F(x,$,G){if(x==null)return;let B;c.is(x.execution)?B=c.to(x.execution):w.is(x.execution)?B=w.to(x.execution):y.is(x.execution)&&(B=y.to(x._id,G));const W=n.to(x.definition);let Z;if(x.source&&(x.source.scope!==void 0?typeof x.source.scope=="number"?Z=x.source.scope:Z=await $.resolveWorkspaceFolder(s.URI.revive(x.source.scope)):Z=L.TaskScope.Workspace),!W||!Z)return;const J=new L.Task(W,Z,x.name,x.source.label,B,x.problemMatchers);return x.isBackground!==void 0&&(J.isBackground=x.isBackground),x.group!==void 0&&(J.group=L.TaskGroup.from(x.group._id),J.group&&x.group.isDefault&&(J.group=new L.TaskGroup(J.group.id,J.group.label),x.group.isDefault===!0&&(J.group.isDefault=x.group.isDefault))),x.presentationOptions&&(J.presentationOptions=r.to(x.presentationOptions)),x._id&&(J._id=x._id),x.detail&&(J.detail=x.detail),J}M.to=F})(k||(e.TaskDTO=k={}));var b;(function(M){function U(F){return F}M.from=U;function H(F){if(F)return Object.assign(Object.create(null),F)}M.to=H})(b||(b={}));class E{#e;constructor(U,H,F){this._id=H,this._task=F,this.#e=U}get task(){return this._task}terminate(){this.#e.terminateTask(this)}fireDidStartProcess(U){}fireDidEndProcess(U){}}let N=class{constructor(U,H,F,x,$,G,B,W){this._onDidExecuteTask=new D.Emitter,this._onDidTerminateTask=new D.Emitter,this._onDidTaskProcessStarted=new D.Emitter,this._onDidTaskProcessEnded=new D.Emitter,this._proxy=U.getProxy(A.MainContext.MainThreadTask),this._workspaceProvider=F,this._editorService=x,this._configurationService=$,this._terminalService=G,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=B,this._deprecationService=W,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(U,H,F){if(!F)return new L.Disposable(()=>{});const x=this.nextHandle();return this._handlers.set(x,{type:H,provider:F,extension:U}),this._proxy.$registerTaskProvider(x,H),new L.Disposable(()=>{this._handlers.delete(x),this._proxy.$unregisterTaskProvider(x)})}registerTaskSystem(U,H){this._proxy.$registerTaskSystem(U,H)}fetchTasks(U){return this._proxy.$fetchTasks(b.from(U)).then(async H=>{const F=[];for(const x of H){const $=await k.to(x,this._workspaceProvider,this._providedCustomExecutions2);$&&F.push($)}return F})}get taskExecutions(){const U=[];return this._taskExecutions.forEach(H=>U.push(H)),U}terminateTask(U){if(!(U instanceof E))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(U._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(U,H,F){const x=this._providedCustomExecutions2.get(U.id);x&&(this._activeCustomExecutions2.set(U.id,x),this._terminalService.attachPtyToTerminal(H,await x.callback(F))),this._lastStartedTask=U.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(U)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(U){if(!this._taskExecutionPromises.has(U.id))return;const H=await this.getTaskExecution(U);this._taskExecutionPromises.delete(U.id),this._taskExecutions.delete(U.id),this.customExecutionComplete(U),this._onDidTerminateTask.fire({execution:H})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(U){const H=await this.getTaskExecution(U.id);this._onDidTaskProcessStarted.fire({execution:H,processId:U.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(U){const H=await this.getTaskExecution(U.id);this._onDidTaskProcessEnded.fire({execution:H,exitCode:U.exitCode})}$provideTasks(U,H){const F=this._handlers.get(U);if(!F)return Promise.reject(new Error("no handler found"));const x=[],$=(0,h.asPromise)(()=>F.provider.provideTasks(C.CancellationToken.None)).then(G=>this.provideTasksInternal(H,x,F,G));return new Promise(G=>{$.then(B=>{Promise.all(x).then(()=>{G(B)})})})}async $resolveTask(U,H){const F=this._handlers.get(U);if(!F)return Promise.reject(new Error("no handler found"));if(H.definition.type!==F.type)throw new Error(`Unexpected: Task of type [${H.definition.type}] cannot be resolved by provider of type [${F.type}].`);const x=await k.to(H,this._workspaceProvider,this._providedCustomExecutions2);if(!x)throw new Error("Unexpected: Task cannot be resolved.");const $=await F.provider.resolveTask(x,C.CancellationToken.None);if(!$)return;this.checkDeprecation($,F);const G=k.from($,F.extension);if(!G)throw new Error("Unexpected: Task cannot be resolved.");if($.definition!==x.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return y.is(G.execution)&&await this.addCustomExecution(G,$,!0),await this.resolveTaskInternal(G)}nextHandle(){return this._handleCounter++}async addCustomExecution(U,H,F){const x=await this._proxy.$createTaskId(U);!F&&!this._providedCustomExecutions2.has(x)&&(this._notProvidedCustomExecutions.add(x),this._activeCustomExecutions2.set(x,H.execution)),this._providedCustomExecutions2.set(x,H.execution)}async getTaskExecution(U,H){if(typeof U=="string"){const $=this._taskExecutionPromises.get(U);if(!$)throw new a.ErrorNoTelemetry("Unexpected: The specified task is missing an execution");return $}const F=this._taskExecutionPromises.get(U.id);if(F)return F;let x;return H?x=Promise.resolve(new E(this,U.id,H)):x=k.to(U.task,this._workspaceProvider,this._providedCustomExecutions2).then($=>{if(!$)throw new a.ErrorNoTelemetry("Unexpected: Task does not exist.");return new E(this,U.id,$)}),this._taskExecutionPromises.set(U.id,x),x.then($=>(this._taskExecutions.set(U.id,$),$))}checkDeprecation(U,H){U._deprecated&&this._deprecationService.report("Task.constructor",H.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(U){this._activeCustomExecutions2.get(U.id)&&this._activeCustomExecutions2.delete(U.id),this._notProvidedCustomExecutions.has(U.id)&&this._lastStartedTask!==U.id&&(this._providedCustomExecutions2.delete(U.id),this._notProvidedCustomExecutions.delete(U.id));const F=this._notProvidedCustomExecutions.values();let x=F.next();for(;!x.done;)!this._activeCustomExecutions2.has(x.value)&&this._lastStartedTask!==x.value&&(this._providedCustomExecutions2.delete(x.value),this._notProvidedCustomExecutions.delete(x.value)),x=F.next()}};e.ExtHostTaskBase=N,e.ExtHostTaskBase=N=Qe([$e(0,f.IExtHostRpcService),$e(1,T.IExtHostInitDataService),$e(2,R.IExtHostWorkspace),$e(3,v.IExtHostDocumentsAndEditors),$e(4,l.IExtHostConfiguration),$e(5,_.IExtHostTerminalService),$e(6,p.ILogService),$e(7,u.IExtHostApiDeprecationService)],N);let O=class extends N{constructor(U,H,F,x,$,G,B,W){super(U,H,F,x,$,G,B,W),this.registerTaskSystem(o.Schemas.vscodeRemote,{scheme:o.Schemas.vscodeRemote,authority:"",platform:m.PlatformToString(m.Platform.Web)})}async executeTask(U,H){if(!H.execution)throw new Error("Tasks to execute must include an execution");const F=k.from(H,U);if(F===void 0)throw new Error("Task is not valid");if(y.is(F.execution))await this.addCustomExecution(F,H,!1);else throw new a.NotSupportedError;const x=await this.getTaskExecution(await this._proxy.$getTaskExecution(F),H);return this._proxy.$executeTask(F).catch($=>{throw new Error($)}),x}provideTasksInternal(U,H,F,x){const $=[];if(x)for(const G of x){if(this.checkDeprecation(G,F),!G.definition||!U[G.definition.type]){const W=G.source?G.source:"No task source";this._logService.warn(`The task [${W}, ${G.name}] uses an undefined task type. The task will be ignored in the future.`)}const B=k.from(G,F.extension);B&&y.is(B.execution)?($.push(B),H.push(this.addCustomExecution(B,G,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:$,extension:F.extension}}async resolveTaskInternal(U){if(y.is(U.execution))return U;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(U,H){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(U,H,F){}};e.WorkerExtHostTask=O,e.WorkerExtHostTask=O=Qe([$e(0,f.IExtHostRpcService),$e(1,T.IExtHostInitDataService),$e(2,R.IExtHostWorkspace),$e(3,v.IExtHostDocumentsAndEditors),$e(4,l.IExtHostConfiguration),$e(5,_.IExtHostTerminalService),$e(6,p.ILogService),$e(7,u.IExtHostApiDeprecationService)],O),e.IExtHostTask=(0,S.createDecorator)("IExtHostTask")}),define(Pe[336],ke([1,0,32,30]),function(ge,e,s,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.rawCellPrefix=void 0,e.isINotebookFileMatchNoModel=D,e.genericCellMatchesToTextSearchMatches=A;function D(L){return"cellResults"in L}e.rawCellPrefix="rawCell#";function A(L,R){let v=-1;const l=[];let C=[];return L.forEach(f=>{f.range.startLineNumber!==v&&C.length>0&&(l.push([...C]),C=[]),C.push(f),v=f.range.endLineNumber}),C.length>0&&l.push([...C]),l.map(f=>{const T=[],S=f[0].range.startLineNumber,o=f[f.length-1].range.endLineNumber;for(let m=S;m<=o;m++)T.push(R.getLineContent(m));return new s.TextSearchMatch(T.join(`
`)+`
`,f.map(m=>new h.Range(m.range.startLineNumber-1,m.range.startColumn-1,m.range.endLineNumber-1,m.range.endColumn-1)))})}}),define(Pe[337],ke([1,0,7,21,4,3,28,41,13,17,2,27,118,6,35,15,9,53,309,170,24,14,32,265,336,333]),function(ge,e,s,h,D,A,L,R,v,l,C,_,f,T,S,o,m,p,u,i,a,t,n,r,d,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0,_=We(_),o=We(o),m=We(m);class g{static{this._notebookStatusBarItemProviderHandlePool=0}get activeNotebookEditor(){return this._activeNotebookEditor?.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(y=>y.apiEditor)}constructor(y,I,P,k,b,E,N){this._textDocumentsAndEditors=P,this._textDocuments=k,this._extHostFileSystem=b,this._extHostSearch=E,this._logService=N,this._notebookStatusBarItemProviders=new Map,this._documents=new L.ResourceMap,this._editors=new Map,this._onDidChangeActiveNotebookEditor=new D.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new D.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new D.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new D.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new f.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._notebookProxy=y.getProxy(T.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=y.getProxy(T.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=y.getProxy(T.MainContext.MainThreadNotebookEditors),this._commandsConverter=I.converter,I.registerArgumentProcessor({processArgument:O=>{if(O&&O.$mid===R.MarshalledId.NotebookCellActionContext){const M=O.notebookEditor?.notebookUri,U=O.cell.handle,F=this._documents.get(M)?.getCell(U);if(F)return F.apiCell}if(O&&O.$mid===R.MarshalledId.NotebookActionContext){const M=O.uri,U=this._documents.get(M);if(U)return U.apiNotebook}return O}}),g._registerApiCommands(I)}getEditorById(y){const I=this._editors.get(y);if(!I)throw new Error(`unknown text editor: ${y}. known editors: ${[...this._editors.keys()]} `);return I}getIdByEditor(y){for(const[I,P]of this._editors)if(P.apiEditor===y)return I}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(y,I){const P=this._documents.get(y);if(!P&&!I)throw new Error(`NO notebook document for '${y}'`);return P}static _convertNotebookRegistrationData(y,I){if(!I)return;const P=I.filenamePattern.map(k=>o.NotebookExclusiveDocumentPattern.from(k)).filter(k=>k!==void 0);if(I.filenamePattern&&!P){console.warn(`Notebook content provider view options file name pattern is invalid ${I.filenamePattern}`);return}return{extension:y.identifier,providerDisplayName:y.displayName||y.name,displayName:I.displayName,filenamePattern:P,priority:I.exclusive?c.RegisteredEditorPriority.exclusive:void 0}}registerNotebookCellStatusBarItemProvider(y,I,P){const k=g._notebookStatusBarItemProviderHandlePool++,b=typeof P.onDidChangeCellStatusBarItems=="function"?g._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(k,P),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(k,b,I);let E;return b!==void 0&&(E=P.onDidChangeCellStatusBarItems(N=>this._notebookProxy.$emitCellStatusBarEvent(b))),new m.Disposable(()=>{this._notebookStatusBarItemProviders.delete(k),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(k,b),E?.dispose()})}async createNotebookDocument(y){const I=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:y.viewType,content:y.content&&o.NotebookData.from(y.content)});return C.URI.revive(I)}async openNotebookDocument(y){const I=this._documents.get(y);if(I)return I.apiNotebook;const P=await this._notebookDocumentsProxy.$tryOpenNotebook(y),k=this._documents.get(C.URI.revive(P));return(0,l.assertIsDefined)(k?.apiNotebook)}async showNotebookDocument(y,I){let P;typeof I=="object"?P={position:o.ViewColumn.from(I.viewColumn),preserveFocus:I.preserveFocus,selections:I.selections&&I.selections.map(o.NotebookRange.from),pinned:typeof I.preview=="boolean"?!I.preview:void 0,label:I?.label}:P={preserveFocus:!1,pinned:!0};const k=I?.asRepl?"repl":y.notebookType,b=await this._notebookEditorsProxy.$tryShowNotebookDocument(y.uri,k,P),E=b&&this._editors.get(b)?.apiEditor;if(E)return E;throw b?new Error(`Could NOT open editor for "${y.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${y.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(y,I,P,k){const b=this._notebookStatusBarItemProviders.get(y),E=C.URI.revive(I),N=this._documents.get(E);if(!N||!b)return;const O=N.getCellFromIndex(P);if(!O)return;const M=await b.provideCellStatusBarItems(O.apiCell,k);if(!M)return;const U=new A.DisposableStore,H=this._statusBarCache.add([U]),x=(Array.isArray(M)?M:[M]).map($=>o.NotebookStatusBarItem.from($,this._commandsConverter,U));return{cacheId:H,items:x}}$releaseNotebookCellStatusBarItems(y){this._statusBarCache.delete(y)}registerNotebookSerializer(y,I,P,k,b){if((0,v.isFalsyOrWhitespace)(I))throw new Error("viewType cannot be empty or just whitespace");const E=this._handlePool++;return this._notebookSerializer.set(E,{viewType:I,serializer:P,options:k}),this._notebookProxy.$registerNotebookSerializer(E,{id:y.identifier,location:y.extensionLocation},I,o.NotebookDocumentContentOptions.from(k),g._convertNotebookRegistrationData(y,b)),(0,A.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(E)})}async $dataToNotebook(y,I,P){const k=this._notebookSerializer.get(y);if(!k)throw new Error("NO serializer found");const b=await k.serializer.deserializeNotebook(I.buffer,P);return new p.SerializableObjectWithBuffers(o.NotebookData.from(b))}async $notebookToData(y,I,P){const k=this._notebookSerializer.get(y);if(!k)throw new Error("NO serializer found");const b=await k.serializer.serializeNotebook(o.NotebookData.to(I.value),P);return h.VSBuffer.wrap(b)}async $saveNotebook(y,I,P,k,b){const E=C.URI.revive(I),N=this._notebookSerializer.get(y);if(this.trace(`enter saveNotebook(versionId: ${P}, ${E.toString()})`),!N)throw new Error("NO serializer found");const O=this._documents.get(E);if(!O)throw new Error("Document NOT found");if(O.versionId!==P)throw new Error("Document version mismatch");if(!this._extHostFileSystem.value.isWritableFileSystem(E.scheme))throw new _.FileOperationError((0,s.localize)(2709,null,this._resourceForError(E)),_.FileOperationResult.FILE_PERMISSION_DENIED);const M={metadata:(0,a.filter)(O.apiNotebook.metadata,$=>!(N.options?.transientDocumentMetadata??{})[$]),cells:[]};for(const $ of O.apiNotebook.getCells()){const G=new m.NotebookCellData($.kind,$.document.getText(),$.document.languageId,$.mime,N.options?.transientOutputs?[]:[...$.outputs],$.metadata,$.executionSummary);G.metadata=(0,a.filter)($.metadata,B=>!(N.options?.transientCellMetadata??{})[B]),M.cells.push(G)}if(await this._validateWriteFile(E,k),b.isCancellationRequested)throw new Error("canceled");const U=await N.serializer.serializeNotebook(M,b);if(b.isCancellationRequested)throw new Error("canceled");this.trace(`serialized versionId: ${P} ${E.toString()}`),await this._extHostFileSystem.value.writeFile(E,U),this.trace(`Finished write versionId: ${P} ${E.toString()}`);const H=this._extHostFileSystem.getFileSystemProviderExtUri(E.scheme),F=await this._extHostFileSystem.value.stat(E),x={name:H.basename(E),isFile:(F.type&_.FileType.File)!==0,isDirectory:(F.type&_.FileType.Directory)!==0,isSymbolicLink:(F.type&_.FileType.SymbolicLink)!==0,mtime:F.mtime,ctime:F.ctime,size:F.size,readonly:!!((F.permissions??0)&_.FilePermission.Readonly)||!this._extHostFileSystem.value.isWritableFileSystem(E.scheme),locked:!!((F.permissions??0)&_.FilePermission.Locked),etag:_.etag({mtime:F.mtime,size:F.size}),children:void 0};return this.trace(`exit saveNotebook(versionId: ${P}, ${E.toString()})`),x}async $searchInNotebooks(y,I,P,k,b){const E=this._notebookSerializer.get(y)?.serializer;if(!E)return{limitHit:!1,results:[]};const N=new L.ResourceSet;await(async(F,x,$)=>{await Promise.all(F.map(async G=>await Promise.all(G.filenamePatterns.map(B=>{const W={_reason:$._reason,folderQueries:$.folderQueries,includePattern:$.includePattern,excludePattern:$.excludePattern,maxResults:$.maxResults,type:n.QueryType.File,filePattern:B};return this._extHostSearch.doInternalFileSearchWithCustomCallback(W,x,Z=>{Z.forEach(J=>{N.has(J)||k.some(te=>G.isFromSettings&&!te.isFromSettings?!1:te.filenamePatterns.some(me=>(0,c.globMatchesResource)(me,J)))||N.add(J)})}).catch(Z=>{if(Z.code==="ENOENT")return console.warn("Could not find notebook search results, ignoring notebook results."),{limitHit:!1,messages:[]};throw Z})}))))})(P,b,I);const M=new L.ResourceMap;let U=!1;const H=Array.from(N).map(async F=>{const x=[];try{if(b.isCancellationRequested)return;if(I.maxResults&&[...M.values()].reduce((W,Z)=>W+Z.cellResults.length,0)>I.maxResults){U=!0;return}const $=[],G=this._documents.get(F);if(G)G.apiNotebook.getCells().forEach(Z=>$.push({input:Z.document.getText(),outputs:Z.outputs.flatMap(J=>J.items.map(oe=>oe.data.toString()))}));else{const W=await this._extHostFileSystem.value.readFile(F),Z=h.VSBuffer.fromString(W.toString()),J=await E.deserializeNotebook(Z.buffer,b);if(b.isCancellationRequested)return;o.NotebookData.from(J).cells.forEach(te=>$.push({input:te.source,outputs:te.outputs.flatMap(me=>me.items.map(le=>le.valueBytes.toString()))}))}if(b.isCancellationRequested)return;$.forEach((W,Z)=>{const J=I.contentPattern.pattern,oe=new r.CellSearchModel(W.input,void 0,W.outputs),te=oe.findInInputs(J),me=oe.findInOutputs(J),le=me.flatMap(Q=>(0,d.genericCellMatchesToTextSearchMatches)(Q.matches,Q.textBuffer)).map((Q,z)=>(Q.webviewIndex=z,Q));if(te.length>0||me.length>0){const Q={index:Z,contentResults:(0,d.genericCellMatchesToTextSearchMatches)(te,oe.inputTextBuffer),webviewResults:le};x.push(Q)}});const B={resource:F,cellResults:x};M.set(F,B);return}catch{return}});return await Promise.all(H),{limitHit:U,results:[...M.values()]}}async _validateWriteFile(y,I){const P=await this._extHostFileSystem.value.stat(y);if(typeof I?.mtime=="number"&&typeof I.etag=="string"&&I.etag!==_.ETAG_DISABLED&&typeof P.mtime=="number"&&typeof P.size=="number"&&I.mtime<P.mtime&&I.etag!==_.etag({mtime:I.mtime,size:P.size}))throw new _.FileOperationError((0,s.localize)(2710,null),_.FileOperationResult.FILE_MODIFIED_SINCE,I)}_resourceForError(y){return y.scheme===t.Schemas.file?y.fsPath:y.toString()}_createExtHostEditor(y,I,P){if(this._editors.has(I))throw new Error(`editor with id ALREADY EXSIST: ${I}`);const k=new i.ExtHostNotebookEditor(I,this._notebookEditorsProxy,y,P.visibleRanges.map(o.NotebookRange.to),P.selections.map(o.NotebookRange.to),typeof P.viewColumn=="number"?o.ViewColumn.to(P.viewColumn):void 0);this._editors.set(I,k)}$acceptDocumentAndEditorsDelta(y){if(y.value.removedDocuments)for(const P of y.value.removedDocuments){const k=C.URI.revive(P),b=this._documents.get(k);b&&(b.dispose(),this._documents.delete(k),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:b.apiNotebook.getCells().map(E=>E.document.uri)}),this._onDidCloseNotebookDocument.fire(b.apiNotebook));for(const E of this._editors.values())E.notebookData.uri.toString()===k.toString()&&this._editors.delete(E.id)}if(y.value.addedDocuments){const P=[];for(const k of y.value.addedDocuments){const b=C.URI.revive(k.uri);if(this._documents.has(b))throw new Error(`adding EXISTING notebook ${b} `);const E=new u.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,b,k);P.push(...k.cells.map(N=>u.ExtHostCell.asModelAddData(N))),this._documents.get(b)?.dispose(),this._documents.set(b,E),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:P}),this._onDidOpenNotebookDocument.fire(E.apiNotebook)}}if(y.value.addedEditors)for(const P of y.value.addedEditors){if(this._editors.has(P.id))return;const k=C.URI.revive(P.documentUri),b=this._documents.get(k);b&&this._createExtHostEditor(b,P.id,P)}const I=[];if(y.value.removedEditors)for(const P of y.value.removedEditors){const k=this._editors.get(P);k&&(this._editors.delete(P),this._activeNotebookEditor?.id===k.id&&(this._activeNotebookEditor=void 0),I.push(k))}if(y.value.visibleEditors){this._visibleNotebookEditors=y.value.visibleEditors.map(k=>this._editors.get(k)).filter(k=>!!k);const P=new Set;this._visibleNotebookEditors.forEach(k=>P.add(k.id));for(const k of this._editors.values()){const b=P.has(k.id);k._acceptVisibility(b)}this._visibleNotebookEditors=[...this._editors.values()].map(k=>k).filter(k=>k.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}y.value.newActiveEditor===null?this._activeNotebookEditor=void 0:y.value.newActiveEditor&&(this._editors.get(y.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${y.value.newActiveEditor}`),this._activeNotebookEditor=this._editors.get(y.value.newActiveEditor)),y.value.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire(this._activeNotebookEditor?.apiEditor)}static _registerApiCommands(y){const I=S.ApiCommandArgument.String.with("notebookType","A notebook type"),P=new S.ApiCommand("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[I,new S.ApiCommandArgument("data","Bytes to convert to data",b=>b instanceof Uint8Array,b=>h.VSBuffer.wrap(b))],new S.ApiCommandResult("Notebook Data",b=>o.NotebookData.to(b.value))),k=new S.ApiCommand("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[I,new S.ApiCommandArgument("NotebookData","Notebook data to convert to bytes",b=>!0,b=>new p.SerializableObjectWithBuffers(o.NotebookData.from(b)))],new S.ApiCommandResult("Bytes",b=>b.buffer));y.registerApiCommand(P),y.registerApiCommand(k)}trace(y){this._logService.trace(`[Extension Host Notebook] ${y}`)}}e.ExtHostNotebookController=g}),define(Pe[338],ke([1,0,18,80,39,109,28,14,16,22,13,17,2,106,7,46,11,154,47,162,334,32]),function(ge,e,s,h,D,A,L,R,v,l,C,_,f,T,S,o,m,p,u,i,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.QueryBuilder=void 0,e.isISearchPatternBuilder=n,e.globPatternToISearchPatternBuilder=r,e.resolveResourcesForSearchIncludes=b,s=We(s),h=We(h),D=We(D),v=We(v),C=We(C),S=We(S);function n(E){return typeof E=="object"&&"uri"in E&&"pattern"in E}function r(E){return typeof E=="string"?{pattern:E}:{pattern:E.pattern,uri:E.baseUri}}let d=class{constructor(N,O,M,U,H,F){this.configurationService=N,this.workspaceContextService=O,this.editorGroupsService=M,this.logService=U,this.pathService=H,this.uriIdentityService=F}text(N,O,M={}){N=this.getContentPattern(N,M);const U=this.configurationService.getValue(),H=O&&O.some(x=>!this.configurationService.getValue({resource:x}).search.useRipgrep);return{...this.commonQuery(O?.map(u.toWorkspaceFolder),M),type:t.QueryType.Text,contentPattern:N,previewOptions:M.previewOptions,maxFileSize:M.maxFileSize,usePCRE2:U.search.usePCRE2||H||!1,surroundingContext:M.surroundingContext,userDisabledExcludesAndIgnoreFiles:M.disregardExcludeSettings&&M.disregardIgnoreFiles}}getContentPattern(N,O){const M=this.configurationService.getValue();N.isRegExp&&(N.pattern=N.pattern.replace(/\r?\n/g,"\\n"));const U={...N,wordSeparators:M.editor.wordSeparators};return this.isCaseSensitive(N,O)&&(U.isCaseSensitive=!0),this.isMultiline(N)&&(U.isMultiline=!0),O.notebookSearchConfig?.includeMarkupInput&&(U.notebookInfo||(U.notebookInfo={}),U.notebookInfo.isInNotebookMarkdownInput=O.notebookSearchConfig.includeMarkupInput),O.notebookSearchConfig?.includeMarkupPreview&&(U.notebookInfo||(U.notebookInfo={}),U.notebookInfo.isInNotebookMarkdownPreview=O.notebookSearchConfig.includeMarkupPreview),O.notebookSearchConfig?.includeCodeInput&&(U.notebookInfo||(U.notebookInfo={}),U.notebookInfo.isInNotebookCellInput=O.notebookSearchConfig.includeCodeInput),O.notebookSearchConfig?.includeOutput&&(U.notebookInfo||(U.notebookInfo={}),U.notebookInfo.isInNotebookCellOutput=O.notebookSearchConfig.includeOutput),U}file(N,O={}){return{...this.commonQuery(N,O),type:t.QueryType.File,filePattern:O.filePattern?O.filePattern.trim():O.filePattern,exists:O.exists,sortByScore:O.sortByScore,cacheKey:O.cacheKey,shouldGlobMatchFilePattern:O.shouldGlobSearch}}handleIncludeExclude(N,O){if(!N)return{};if(Array.isArray(N)){if(N=N.filter(M=>M.length>0).map(I),!N.length)return{}}else N=I(N);return O?this.parseSearchPaths(N):{pattern:g(...Array.isArray(N)?N:[N])}}commonQuery(N=[],O={}){let M=Array.isArray(O.excludePattern)?O.excludePattern.map(B=>B.pattern).flat():O.excludePattern;M=M?.length===1?M[0]:M;const U=this.handleIncludeExclude(O.includePattern,O.expandPatterns),H=this.handleIncludeExclude(M,O.expandPatterns),F=N.length>1,x=(U.searchPaths&&U.searchPaths.length?U.searchPaths.map(B=>this.getFolderQueryForSearchPath(B,O,H)):N.map(B=>this.getFolderQueryForRoot(B,O,H,F))).filter(B=>!!B),$={_reason:O._reason,folderQueries:x,usingSearchPaths:!!(U.searchPaths&&U.searchPaths.length),extraFileResources:O.extraFileResources,excludePattern:H.pattern,includePattern:U.pattern,onlyOpenEditors:O.onlyOpenEditors,maxResults:O.maxResults,onlyFileScheme:O.onlyFileScheme};if(O.onlyOpenEditors){const B=s.coalesce(this.editorGroupsService.groups.flatMap(J=>J.editors.map(oe=>oe.resource)));this.logService.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(B));const W=B.filter(J=>(0,t.pathIncludedInQuery)($,J.fsPath)),Z=this.commonQueryFromFileList(W);return this.logService.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(Z)),{...$,...Z}}const G=O.extraFileResources&&O.extraFileResources.filter(B=>(0,t.pathIncludedInQuery)($,B.fsPath));return $.extraFileResources=G&&G.length?G:void 0,$}commonQueryFromFileList(N){const O=[],M=new L.ResourceMap,U={};let H=!1;return N.forEach(F=>{if(F.scheme===R.Schemas.walkThrough)return;if((0,l.isAbsolutePath)(F)){const $=this.workspaceContextService.getWorkspaceFolder(F)?.uri??this.uriIdentityService.extUri.dirname(F);let G=M.get($);G||(H=!0,G={folder:$,includePattern:{}},O.push(G),M.set($,G));const B=v.relative($.fsPath,F.fsPath);(0,_.assertIsDefined)(G.includePattern)[B.replace(/\\/g,"/")]=!0}else F.fsPath&&(H=!0,U[F.fsPath]=!0)}),{folderQueries:O,includePattern:U,usingSearchPaths:!0,excludePattern:H?void 0:{"**/*":!0}}}isCaseSensitive(N,O){if(O.isSmartCase){if(N.isRegExp){if(C.containsUppercaseCharacter(N.pattern,!0))return!0}else if(C.containsUppercaseCharacter(N.pattern))return!0}return!!N.isCaseSensitive}isMultiline(N){return N.isMultiline||N.isRegExp&&(0,T.isMultilineRegexSource)(N.pattern)||N.pattern.indexOf(`
`)>=0?!0:!!N.isMultiline}parseSearchPaths(N){const O=W=>v.isAbsolute(W)||/^\.\.?([\/\\]|$)/.test(W),U=(Array.isArray(N)?N:w(N)).map(W=>{const Z=this.pathService.resolvedUserHome;return Z?(0,A.untildify)(W,Z.scheme===R.Schemas.file?Z.fsPath:Z.path):W}),H=h.groupBy(U,W=>O(W)?"searchPaths":"exprSegments"),F=(H.exprSegments||[]).map(W=>C.rtrim(W,"/")).map(W=>C.rtrim(W,"\\")).map(W=>(W[0]==="."&&(W="*"+W),y(W))),x={},$=this.expandSearchPathPatterns(H.searchPaths||[]);$&&$.length&&(x.searchPaths=$);const G=F.flat(),B=g(...G);return B&&(x.pattern=B),x}getExcludesForFolder(N,O){return O.disregardExcludeSettings?void 0:(0,t.getExcludes)(N,!O.disregardSearchExcludeSettings)}expandSearchPathPatterns(N){if(!N||!N.length)return[];const O=N.flatMap(U=>{let{pathPortion:H,globPortion:F}=c(U);return F&&(F=P(F)),this.expandOneSearchPath(H).flatMap($=>this.resolveOneSearchPathPattern($,F))}),M=new Map;return O.forEach(U=>{const H=U.searchPath.toString(),F=M.get(H);F?U.pattern&&(F.pattern=F.pattern||{},F.pattern[U.pattern]=!0):M.set(H,{searchPath:U.searchPath,pattern:U.pattern?g(U.pattern):void 0})}),Array.from(M.values())}expandOneSearchPath(N){if(v.isAbsolute(N)){const O=this.workspaceContextService.getWorkspace().folders;return O[0]&&O[0].uri.scheme!==R.Schemas.file?[{searchPath:O[0].uri.with({path:N})}]:[{searchPath:f.URI.file(v.normalize(N))}]}if(this.workspaceContextService.getWorkbenchState()===u.WorkbenchState.FOLDER){const O=this.workspaceContextService.getWorkspace().folders[0].uri;if(N=I(N),N.startsWith("../")||N===".."){const U=v.posix.resolve(O.path,N);return[{searchPath:O.with({path:U})}]}const M=P(N);return[{searchPath:O,pattern:M}]}else{if(N==="./"||N===".\\")return[];{const O=N.replace(/^\.[\/\\]/,""),U=this.workspaceContextService.getWorkspace().folders.map(H=>{const F=O.match(new RegExp(`^${C.escapeRegExpCharacters(H.name)}(?:/(.*)|$)`));return F?{match:F,folder:H}:null}).filter(_.isDefined);if(U.length)return U.map(H=>{const F=H.match[1];return{searchPath:H.folder.uri,pattern:F&&P(F)}});{const H=N.match(/\.[\/\\](.+)[\/\\]?/),F=H?H[1]:N,x=S.localize(12569,null,F);throw new Error(x)}}}}resolveOneSearchPathPattern(N,O){const M=N.pattern&&O?`${N.pattern}/${O}`:N.pattern||O,U=[{searchPath:N.searchPath,pattern:M}];return M&&!M.endsWith("**")&&U.push({searchPath:N.searchPath,pattern:M+"/**"}),U}getFolderQueryForSearchPath(N,O,M){const U=this.getFolderQueryForRoot((0,u.toWorkspaceFolder)(N.searchPath),O,M,!1);return U?{...U,includePattern:N.pattern}:null}getFolderQueryForRoot(N,O,M,U){let H;const F=f.URI.isUri(N)?N:N.uri;let x=O.excludePattern?.map(J=>{const oe=O.excludePattern&&n(J)?J.uri:void 0;return!oe||!(f.URI.isUri(N)&&this.uriIdentityService.extUri.isEqual(N,oe))?oe:void 0});if(x?.length||(x=[void 0]),M.searchPaths){const J=M.searchPaths.filter(oe=>(0,l.isEqual)(oe.searchPath,F))[0];if(J&&!J.pattern)return null;J&&(H=J.pattern)}const $=this.configurationService.getValue({resource:F}),B={...this.getExcludesForFolder($,O)||{},...H||{}},W=f.URI.isUri(N)?(0,l.basename)(N):N.name,Z=x.map(J=>Object.keys(B).length>0?{folder:J,pattern:B}:void 0).filter(J=>J);return{folder:F,folderName:U?W:void 0,excludePattern:Z,fileEncoding:$.files&&$.files.encoding,disregardIgnoreFiles:typeof O.disregardIgnoreFiles=="boolean"?O.disregardIgnoreFiles:!$.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof O.disregardGlobalIgnoreFiles=="boolean"?O.disregardGlobalIgnoreFiles:!$.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof O.disregardParentIgnoreFiles=="boolean"?O.disregardParentIgnoreFiles:!$.search.useParentIgnoreFiles,ignoreSymlinks:typeof O.ignoreSymlinks=="boolean"?O.ignoreSymlinks:!$.search.followSymlinks}}};e.QueryBuilder=d,e.QueryBuilder=d=Qe([$e(0,o.IConfigurationService),$e(1,u.IWorkspaceContextService),$e(2,i.IEditorGroupsService),$e(3,m.ILogService),$e(4,a.IPathService),$e(5,p.IUriIdentityService)],d);function c(E){const N=E.match(/[\*\{\}\(\)\[\]\?]/);if(N){const O=N.index,M=E.substr(0,O).match(/[/|\\][^/\\]*$/);if(M){let U=E.substr(0,M.index);return U.match(/[/\\]/)||(U+="/"),{pathPortion:U,globPortion:E.substr((M.index||0)+1)}}}return{pathPortion:E}}function g(...E){return E.length?E.reduce((N,O)=>(N[O]=!0,N),Object.create(null)):void 0}function w(E){return D.splitGlobAware(E,",").map(N=>N.trim()).filter(N=>!!N.length)}function y(E){return[`**/${E}/**`,`**/${E}`].map(O=>O.replace(/\*\*\/\*\*/g,"**"))}function I(E){return E.replace(/\\/g,"/")}function P(E){return I(E).replace(/^\.\//,"").replace(/\/+$/g,"")}function k(E){return E.replace(/([?*[\]])/g,"[$1]")}function b(E,N){E=s.distinct(E,U=>U.toString());const O=[],M=N.getWorkspace();return E&&E.forEach(U=>{let H;if(N.getWorkbenchState()===u.WorkbenchState.FOLDER)H=(0,l.relativePath)(M.folders[0].uri,U),H&&H!=="."&&(H="./"+H);else{const F=N.getWorkspaceFolder(U);if(F){const x=F.name;if(M.folders.filter(G=>G.name===x).length===1){const G=(0,l.relativePath)(F.uri,U);G===""?H=`./${F.name}`:H=`./${F.name}/${G}`}else H=U.fsPath}}H&&O.push(k(H))}),O}}),define(Pe[339],ke([1,0,22,2,20,12,5,338,32,47,8]),function(ge,e,s,h,D,A,L,R,v,l,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkActivateWorkspaceContainsExtension=f,e.checkGlobFileExists=o,s=We(s),A=We(A);const _=7e3;function f(m,p){const u=p.activationEvents;if(!u)return Promise.resolve(void 0);const i=[],a=[];for(const g of u)if(/^workspaceContains:/.test(g)){const w=g.substr(18);w.indexOf("*")>=0||w.indexOf("?")>=0||m.forceUsingSearch?a.push(w):i.push(w)}if(i.length===0&&a.length===0)return Promise.resolve(void 0);const{promise:t,resolve:n}=(0,C.promiseWithResolvers)(),r=g=>n({activationEvent:g}),d=Promise.all(i.map(g=>T(m,g,r))).then(()=>{}),c=S(m,p.identifier,a,r);return Promise.all([d,c]).then(()=>{n(void 0)}),t}async function T(m,p,u){for(const i of m.folders)if(await m.exists(s.joinPath(h.URI.revive(i),p))){u(`workspaceContains:${p}`);return}}async function S(m,p,u,i){if(u.length===0)return Promise.resolve(void 0);const a=new D.CancellationTokenSource,t=m.checkExists(m.folders,u,a.token),n=setTimeout(async()=>{a.cancel(),m.logService.info(`Not activating extension '${p.value}': Timed out while searching for 'workspaceContains' pattern ${u.join(",")}`)},_);let r=!1;try{r=await t}catch(d){A.isCancellationError(d)||A.onUnexpectedError(d)}a.dispose(),clearTimeout(n),r&&i(`workspaceContains:${u.join(",")}`)}function o(m,p,u,i){const a=m.get(L.IInstantiationService),t=m.get(v.ISearchService),r=a.createInstance(R.QueryBuilder).file(p.map(d=>(0,l.toWorkspaceFolder)(h.URI.revive(d))),{_reason:"checkExists",includePattern:u,exists:!0});return t.fileSearch(r,i).then(d=>!!d.limitHit,d=>A.isCancellationError(d)?!1:Promise.reject(d))}}),define(Pe[54],ke([1,0,7,16,63,22,8,3,62,2,11,6,42,272,125,49,25,164,12,23,21,251,9,73,5,29,98,19,114,78,48,128,4,339,124,253,14,122,43,10,123]),function(ge,e,s,h,D,A,L,R,v,l,C,_,f,T,S,o,m,p,u,i,a,t,n,r,d,c,g,w,y,I,P,k,b,E,N,O,M,U,H,F,x){"use strict";var $;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionPaths=e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,s=We(s),h=We(h),D=We(D),u=We(u),e.IHostUtils=(0,d.createDecorator)("IHostUtils");let G=$=class extends R.Disposable{constructor(Q,z,se,Ee,ae,be,pe,ve,Re,Fe,Ve,Ye,Je){super(),this._extHostManagedSockets=Ye,this._extHostLanguageModels=Je,this._onDidChangeRemoteConnectionData=this._register(new b.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._realPathCache=new Map,this._isTerminating=!1,this._hostUtils=z,this._extHostContext=se,this._initData=pe,this._extHostWorkspace=Ee,this._extHostConfiguration=ae,this._logService=be,this._extHostTunnelService=Re,this._extHostTerminalService=Fe,this._extHostLocalizationService=Ve,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(_.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(_.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(_.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new L.Barrier,this._readyToStartExtensionHost=new L.Barrier,this._readyToRunExtensions=new L.Barrier,this._eagerExtensionsActivated=new L.Barrier,this._activationEventsReader=new me(this._initData.extensions.activationEvents),this._globalRegistry=new p.ExtensionDescriptionRegistry(this._activationEventsReader,this._initData.extensions.allExtensions);const xe=new i.ExtensionIdentifierSet(this._initData.extensions.myExtensions);this._myRegistry=new p.ExtensionDescriptionRegistry(this._activationEventsReader,oe(this._globalRegistry,xe)),F.isCI&&(this._logService.info(`Creating extension host with the following global extensions: ${Z(this._globalRegistry)}`),this._logService.info(`Creating extension host with the following local extensions: ${Z(this._myRegistry)}`)),this._storage=new S.ExtHostStorage(this._extHostContext,this._logService),this._secretState=new N.ExtHostSecretState(this._extHostContext),this._storagePath=ve,this._instaService=this._store.add(Q.createChild(new y.ServiceCollection([S.IExtHostStorage,this._storage],[N.IExtHostSecretState,this._secretState]))),this._activator=this._register(new T.ExtensionsActivator(this._myRegistry,this._globalRegistry,{onExtensionActivationError:(ze,Ne,V)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(ze,u.transformErrorForSerialization(Ne),V)},actualActivateExtension:async(ze,Ne)=>{if(p.ExtensionDescriptionRegistry.isHostExtension(ze,this._myRegistry,this._globalRegistry))return await this._mainThreadExtensionsProxy.$activateExtension(ze,Ne),new T.HostExtension;const V=this._myRegistry.getExtensionDescription(ze);return this._activateExtension(V,Ne)}},this._logService)),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),D.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(Q){u.onUnexpectedError(Q)}}async _deactivateAll(){this._storagePath.onWillDeactivateAll();let Q=[];try{Q=this._myRegistry.getAllExtensionDescriptions().map(ae=>ae.identifier).filter(ae=>this.isActivated(ae)).map(ae=>this._deactivate(ae))}catch{}await Promise.all(Q)}terminate(Q,z=0){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`Extension host terminating: ${Q}`),this._logService.flush(),this._extHostTerminalService.dispose(),this._activator.dispose(),u.setUnexpectedErrorHandler(Ee=>{this._logService.error(Ee)}),this._extHostContext.dispose();const se=this._deactivateAll();Promise.race([(0,L.timeout)(5e3),se]).finally(()=>{this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code ${z}`):this._logService.info(`Extension host exiting with code ${z}`),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(z)})}isActivated(Q){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(Q):!1}async getExtension(Q){const z=await this._mainThreadExtensionsProxy.$getExtension(Q);return z&&{...z,identifier:new i.ExtensionIdentifier(z.identifier.value),extensionLocation:l.URI.revive(z.extensionLocation)}}_activateByEvent(Q,z){return this._activator.activateByEvent(Q,z)}_activateById(Q,z){return this._activator.activateById(Q,z)}activateByIdWithErrors(Q,z){return this._activateById(Q,z).then(()=>{const se=this._activator.getActivatedExtension(Q);if(se.activationFailed)return Promise.reject(se.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(Q=>this._myRegistry)}getExtensionExports(Q){if(this._readyToRunExtensions.isOpen())return this._activator.getActivatedExtension(Q).exports;try{return this._activator.getActivatedExtension(Q).exports}catch{return null}}async _realPathExtensionUri(Q){if(Q.scheme===M.Schemas.file&&this._hostUtils.fsRealpath){const z=Q.fsPath;this._realPathCache.has(z)||this._realPathCache.set(z,this._hostUtils.fsRealpath(z));const se=await this._realPathCache.get(z);return l.URI.file(se)}return Q}async getExtensionPathIndex(){return this._extensionPathIndex||(this._extensionPathIndex=this._createExtensionPathIndex(this._myRegistry.getAllExtensionDescriptions()).then(Q=>new te(Q))),this._extensionPathIndex}async _createExtensionPathIndex(Q){const z=v.TernarySearchTree.forUris(se=>A.extUriBiasedIgnorePathCase.ignorePathCasing(se));return await Promise.all(Q.map(async se=>{if(this._getEntryPoint(se)){const Ee=await this._realPathExtensionUri(se.extensionLocation);z.set(Ee,se)}})),z}_deactivate(Q){let z=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(Q))return z;const se=this._activator.getActivatedExtension(Q);if(!se)return z;try{typeof se.module.deactivate=="function"&&(z=Promise.resolve(se.module.deactivate()).then(void 0,Ee=>(this._logService.error(Ee),Promise.resolve(void 0))))}catch(Ee){this._logService.error(`An error occurred when deactivating the extension '${Q.value}':`),this._logService.error(Ee)}try{se.disposable.dispose()}catch(Ee){this._logService.error(`An error occurred when disposing the subscriptions for extension '${Q.value}':`),this._logService.error(Ee)}return z}async _activateExtension(Q,z){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(Q.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(Q.identifier),this._doActivateExtension(Q,z).then(se=>{const Ee=se.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(Q.identifier,Ee.codeLoadingTime,Ee.activateCallTime,Ee.activateResolvedTime,z),this._logExtensionActivationTimes(Q,z,"success",Ee),se},se=>{throw this._logExtensionActivationTimes(Q,z,"failure"),se})}_logExtensionActivationTimes(Q,z,se,Ee){const ae=W(Q,z);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",{...ae,...Ee||{},outcome:se})}_doActivateExtension(Q,z){const se=W(Q,z);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",se);const Ee=this._getEntryPoint(Q);if(!Ee)return Promise.resolve(new T.EmptyExtension(T.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${Q.identifier.value}, startup: ${z.startup}, activationEvent: '${z.activationEvent}'${Q.identifier.value!==z.extensionId.value?`, root cause: ${z.extensionId.value}`:""}`),this._logService.flush();const ae=new R.DisposableStore,be=new T.ExtensionActivationTimesBuilder(z.startup);return Promise.all([this._loadCommonJSModule(Q,(0,A.joinPath)(Q.extensionLocation,Ee),be),this._loadExtensionContext(Q,ae)]).then(pe=>(D.mark(`code/extHost/willActivateExtension/${Q.identifier.value}`),$._callActivate(this._logService,Q.identifier,pe[0],pe[1],ae,be))).then(pe=>(D.mark(`code/extHost/didActivateExtension/${Q.identifier.value}`),pe))}_loadExtensionContext(Q,z){const se=this._extHostLanguageModels.createLanguageModelAccessInformation(Q),Ee=z.add(new t.ExtensionGlobalMemento(Q,this._storage)),ae=z.add(new t.ExtensionMemento(Q.identifier.value,!1,this._storage)),be=z.add(new O.ExtensionSecrets(Q,this._secretState)),pe=Q.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?n.ExtensionMode.Test:n.ExtensionMode.Development:n.ExtensionMode.Production,ve=this._initData.remote.isRemote?n.ExtensionKind.Workspace:n.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${Q.identifier.value}`),Promise.all([Ee.whenReady,ae.whenReady,this._storagePath.whenReady]).then(()=>{const Re=this;let Fe,Ve;const Ye=(0,m.isProposedApiEnabled)(Q,"ipc")?this._initData.messagePorts?.get(i.ExtensionIdentifier.toKey(Q.identifier)):void 0;return Object.freeze({globalState:Ee,workspaceState:ae,secrets:be,subscriptions:[],get languageModelAccessInformation(){return se},get extensionUri(){return Q.extensionLocation},get extensionPath(){return Q.extensionLocation.fsPath},asAbsolutePath(Je){return h.join(Q.extensionLocation.fsPath,Je)},get storagePath(){return Re._storagePath.workspaceValue(Q)?.fsPath},get globalStoragePath(){return Re._storagePath.globalValue(Q).fsPath},get logPath(){return h.join(Re._initData.logsLocation.fsPath,Q.identifier.value)},get logUri(){return l.URI.joinPath(Re._initData.logsLocation,Q.identifier.value)},get storageUri(){return Re._storagePath.workspaceValue(Q)},get globalStorageUri(){return Re._storagePath.globalValue(Q)},get extensionMode(){return pe},get extension(){return Fe===void 0&&(Fe=new J(Re,Q.identifier,Q,ve,!1)),Fe},get extensionRuntime(){return(0,m.checkProposedApiEnabled)(Q,"extensionRuntime"),Re.extensionRuntime},get environmentVariableCollection(){return Re._extHostTerminalService.getEnvironmentVariableCollection(Q)},get messagePassingProtocol(){if(!Ve){if(!Ye)return;const Je=b.Event.buffer(b.Event.fromDOMEventEmitter(Ye,"message",xe=>xe.data));Ye.start(),Ve={onDidReceiveMessage:Je,postMessage:Ye.postMessage.bind(Ye)}}return Ve}})})}static _callActivate(Q,z,se,Ee,ae,be){return se=se||{activate:void 0,deactivate:void 0},this._callActivateOptional(Q,z,se,Ee,be).then(pe=>new T.ActivatedExtension(!1,null,be.build(),se,pe,(0,R.toDisposable)(()=>{ae.dispose(),(0,R.dispose)(Ee.subscriptions)})))}static _callActivateOptional(Q,z,se,Ee,ae){if(typeof se.activate=="function")try{ae.activateCallStart(),Q.trace(`ExtensionService#_callActivateOptional ${z.value}`);const be=typeof global=="object"?global:self,pe=se.activate.apply(be,[Ee]);return ae.activateCallStop(),ae.activateResolveStart(),Promise.resolve(pe).then(ve=>(ae.activateResolveStop(),ve))}catch(be){return Promise.reject(be)}else return Promise.resolve(se)}_activateOneStartupFinished(Q,z){this._activateById(Q.identifier,{startup:!1,extensionId:Q.identifier,activationEvent:z}).then(void 0,se=>{this._logService.error(se)})}_activateAllStartupFinishedDeferred(Q,z=0){const Ee=Date.now();(0,F.setTimeout0)(()=>{for(let ae=z;ae<Q.length;ae+=1){const be=Q[ae];for(const pe of be.activationEvents??[])if(pe==="onStartupFinished")if(Date.now()-Ee>50){this._activateAllStartupFinishedDeferred(Q,ae);break}else this._activateOneStartupFinished(be,pe)}})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(D.getMarks()),this._extHostConfiguration.getConfigProvider().then(Q=>{const z=Q.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),se=this._myRegistry.getAllExtensionDescriptions();if(z)this._activateAllStartupFinishedDeferred(se);else for(const Ee of se)if(Ee.activationEvents)for(const ae of Ee.activationEvents)ae==="onStartupFinished"&&this._activateOneStartupFinished(Ee,ae)})}_handleEagerExtensions(){const Q=this._activateByEvent("*",!0).then(void 0,be=>{this._logService.error(be)});this._register(this._extHostWorkspace.onDidChangeWorkspace(be=>this._handleWorkspaceContainsEagerExtensions(be.added)));const z=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],se=this._handleWorkspaceContainsEagerExtensions(z),Ee=this._handleRemoteResolverEagerExtensions(),ae=Promise.all([Ee,Q,se]).then(()=>{});return Promise.race([ae,(0,L.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),ae}_handleWorkspaceContainsEagerExtensions(Q){return Q.length===0?Promise.resolve(void 0):Promise.all(this._myRegistry.getAllExtensionDescriptions().map(z=>this._handleWorkspaceContainsEagerExtension(Q,z))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(Q,z){if(this.isActivated(z.identifier))return;const se=!this._initData.remote.isRemote&&!!this._initData.remote.authority,Ee={logService:this._logService,folders:Q.map(be=>be.uri),forceUsingSearch:se||!this._hostUtils.fsExists,exists:be=>this._hostUtils.fsExists(be.fsPath),checkExists:(be,pe,ve)=>this._mainThreadWorkspaceProxy.$checkExists(be,pe,ve)},ae=await(0,E.checkActivateWorkspaceContainsExtension)(Ee,z);if(ae)return this._activateById(z.identifier,{startup:!0,extensionId:z.identifier,activationEvent:ae.activationEvent}).then(void 0,be=>this._logService.error(be))}async _handleRemoteResolverEagerExtensions(){if(this._initData.remote.authority)return this._activateByEvent(`onResolveRemoteAuthority:${this._initData.remote.authority}`,!1)}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return await this._doHandleExtensionTests()}catch(Q){throw console.error(Q),Q}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:Q,extensionTestsLocationURI:z}=this._initData.environment;if(!Q||!z)throw new Error(s.localize(2701,null));const se=await this._loadCommonJSModule(null,z,new T.ExtensionActivationTimesBuilder(!1));if(!se||typeof se.run!="function")throw new Error(s.localize(2702,null,z.toString()));return new Promise((Ee,ae)=>{const be=(Re,Fe)=>{Re?(F.isCI&&this._logService.error("Test runner called back with error",Re),ae(Re)):(F.isCI&&(Fe?this._logService.info(`Test runner called back with ${Fe} failures.`):this._logService.info("Test runner called back with successful outcome.")),Ee(typeof Fe=="number"&&Fe>0?1:0))},pe=(0,A.originalFSPath)(z),ve=se.run(pe,be);ve&&ve.then&&ve.then(()=>{F.isCI&&this._logService.info("Test runner finished successfully."),Ee(0)}).catch(Re=>{F.isCI&&this._logService.error("Test runner finished with error",Re),ae(Re instanceof Error&&Re.stack?Re.stack:String(Re))})})}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>Promise.race([this._activator.waitForActivatingExtensions(),(0,L.timeout)(1e3)])).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("Eager extensions activated")})}registerRemoteAuthorityResolver(Q,z){return this._resolvers[Q]=z,(0,R.toDisposable)(()=>{delete this._resolvers[Q]})}async getRemoteExecServer(Q){const{resolver:z}=await this._activateAndGetResolver(Q);return z?.resolveExecServer?.(Q,{resolveAttempt:0})}async _activateAndGetResolver(Q){const z=Q.indexOf("+");if(z===-1)throw new n.RemoteAuthorityResolverError("Not an authority that can be resolved!",r.RemoteAuthorityResolverErrorCode.InvalidAuthority);const se=Q.substr(0,z);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${se}`,!1),{authorityPrefix:se,resolver:this._resolvers[se]}}async $resolveAuthority(Q,z){const se=H.StopWatch.create(!1),Ee=()=>`[resolveAuthority(${(0,r.getRemoteAuthorityPrefix)(Q)},${z})][${se.elapsed()}ms] `,ae=j=>this._logService.info(`${Ee()}${j}`),be=j=>this._logService.warn(`${Ee()}${j}`),pe=(j,Y=void 0)=>this._logService.error(`${Ee()}${j}`,Y),ve=j=>{if(j instanceof n.RemoteAuthorityResolverError)return{type:"error",error:{code:j._code,message:j._message,detail:j._detail}};throw j},Re=async j=>{ae(`activating resolver for ${j}...`);const{resolver:Y,authorityPrefix:ee}=await this._activateAndGetResolver(j);if(!Y)throw pe(`no resolver for ${ee}`),new n.RemoteAuthorityResolverError(`No remote extension installed to resolve ${ee}.`,r.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:Y,authorityPrefix:ee,remoteAuthority:j}},Fe=Q.split(/@|%40/g).reverse();ae(`activating remote resolvers ${Fe.join(" -> ")}`);let Ve;try{Ve=await Promise.all(Fe.map(Re)).catch(async j=>{if(!(j instanceof n.RemoteAuthorityResolverError)||j._code!==r.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw j;return be(`resolving nested authorities failed: ${j.message}`),[await Re(Q)]})}catch(j){return ve(j)}const Ye=new L.IntervalTimer;Ye.cancelAndSet(()=>ae("waiting..."),1e3);let Je,xe;for(const[j,{authorityPrefix:Y,resolver:ee,remoteAuthority:ue}]of Ve.entries())try{if(j===Ve.length-1)ae("invoking final resolve()..."),D.mark(`code/extHost/willResolveAuthority/${Y}`),Je=await ee.resolve(ue,{resolveAttempt:z,execServer:xe}),D.mark(`code/extHost/didResolveAuthorityOK/${Y}`),ae("setting tunnel factory..."),this._register(await this._extHostTunnelService.setTunnelFactory(ee,n.ManagedResolvedAuthority.isManagedResolvedAuthority(Je)?Je:void 0));else{if(ae(`invoking resolveExecServer() for ${ue}`),D.mark(`code/extHost/willResolveExecServer/${Y}`),xe=await ee.resolveExecServer?.(ue,{resolveAttempt:z,execServer:xe}),!xe)throw new n.RemoteAuthorityResolverError(`Exec server was not available for ${ue}`,r.RemoteAuthorityResolverErrorCode.NoResolverFound);D.mark(`code/extHost/didResolveExecServerOK/${Y}`)}}catch(we){return D.mark(`code/extHost/didResolveAuthorityError/${Y}`),pe("returned an error",we),Ye.dispose(),ve(we)}Ye.dispose();const ze={environmentTunnels:Je.environmentTunnels,features:Je.tunnelFeatures?{elevation:Je.tunnelFeatures.elevation,privacyOptions:Je.tunnelFeatures.privacyOptions,protocol:Je.tunnelFeatures.protocol===void 0?!0:Je.tunnelFeatures.protocol}:void 0},Ne={extensionHostEnv:Je.extensionHostEnv,isTrusted:Je.isTrusted,authenticationSession:Je.authenticationSessionForInitializingExtensions?{id:Je.authenticationSessionForInitializingExtensions.id,providerId:Je.authenticationSessionForInitializingExtensions.providerId}:void 0};ae(`returned ${n.ManagedResolvedAuthority.isManagedResolvedAuthority(Je)?"managed authority":`${Je.host}:${Je.port}`}`);let V;if(n.ManagedResolvedAuthority.isManagedResolvedAuthority(Je)){const j=z;this._extHostManagedSockets.setFactory(j,Je.makeConnection),V={authority:Q,connectTo:new r.ManagedRemoteConnection(j),connectionToken:Je.connectionToken}}else V={authority:Q,connectTo:new r.WebSocketRemoteConnection(Je.host,Je.port),connectionToken:Je.connectionToken};return{type:"ok",value:{authority:V,options:Ne,tunnelInformation:ze}}}async $getCanonicalURI(Q,z){this._logService.info(`$getCanonicalURI invoked for authority (${(0,r.getRemoteAuthorityPrefix)(Q)})`);const{resolver:se}=await this._activateAndGetResolver(Q);if(!se)return null;const Ee=l.URI.revive(z);if(typeof se.getCanonicalURI>"u")return Ee;const ae=await(0,L.asPromise)(()=>se.getCanonicalURI(Ee));return ae||Ee}async $startExtensionHost(Q){Q.toAdd.forEach(be=>be.extensionLocation=l.URI.revive(be.extensionLocation));const{globalRegistry:z,myExtensions:se}=B(this._activationEventsReader,this._globalRegistry,this._myRegistry,Q),Ee=await this._createExtensionPathIndex(se);return(await this.getExtensionPathIndex()).setSearchTree(Ee),this._globalRegistry.set(z.getAllExtensionDescriptions()),this._myRegistry.set(se),F.isCI&&(this._logService.info(`$startExtensionHost: global extensions: ${Z(this._globalRegistry)}`),this._logService.info(`$startExtensionHost: local extensions: ${Z(this._myRegistry)}`)),this._startExtensionHost()}$activateByEvent(Q,z){return z===m.ActivationKind.Immediate?this._almostReadyToRunExtensions.wait().then(se=>this._activateByEvent(Q,!1)):this._readyToRunExtensions.wait().then(se=>this._activateByEvent(Q,!1))}async $activate(Q,z){return await this._readyToRunExtensions.wait(),this._myRegistry.getExtensionDescription(Q)?(await this._activateById(Q,z),!0):!1}async $deltaExtensions(Q){Q.toAdd.forEach(be=>be.extensionLocation=l.URI.revive(be.extensionLocation));const{globalRegistry:z,myExtensions:se}=B(this._activationEventsReader,this._globalRegistry,this._myRegistry,Q),Ee=await this._createExtensionPathIndex(se);return(await this.getExtensionPathIndex()).setSearchTree(Ee),this._globalRegistry.set(z.getAllExtensionDescriptions()),this._myRegistry.set(se),F.isCI&&(this._logService.info(`$deltaExtensions: global extensions: ${Z(this._globalRegistry)}`),this._logService.info(`$deltaExtensions: local extensions: ${Z(this._myRegistry)}`)),Promise.resolve(void 0)}async $test_latency(Q){return Q}async $test_up(Q){return Q.byteLength}async $test_down(Q){const z=a.VSBuffer.alloc(Q),se=Math.random()%256;for(let Ee=0;Ee<Q;Ee++)z.writeUInt8(se,Ee);return z}async $updateRemoteConnectionData(Q){this._remoteConnectionData=Q,this._onDidChangeRemoteConnectionData.fire()}};e.AbstractExtHostExtensionService=G,e.AbstractExtHostExtensionService=G=$=Qe([$e(0,d.IInstantiationService),$e(1,e.IHostUtils),$e(2,w.IExtHostRpcService),$e(3,o.IExtHostWorkspace),$e(4,f.IExtHostConfiguration),$e(5,C.ILogService),$e(6,c.IExtHostInitDataService),$e(7,g.IExtensionStoragePaths),$e(8,I.IExtHostTunnelService),$e(9,P.IExtHostTerminalService),$e(10,U.IExtHostLocalizationService),$e(11,x.IExtHostManagedSockets),$e(12,k.IExtHostLanguageModels)],G);function B(le,Q,z,se){le.addActivationEvents(se.addActivationEvents);const Ee=new p.ExtensionDescriptionRegistry(le,Q.getAllExtensionDescriptions());Ee.deltaExtensions(se.toAdd,se.toRemove);const ae=new i.ExtensionIdentifierSet(z.getAllExtensionDescriptions().map(pe=>pe.identifier));for(const pe of se.myToRemove)ae.delete(pe);for(const pe of se.myToAdd)ae.add(pe);const be=oe(Ee,ae);return{globalRegistry:Ee,myExtensions:be}}function W(le,Q){return{id:le.identifier.value,name:le.name,extensionVersion:le.version,publisherDisplayName:le.publisher,activationEvents:le.activationEvents?le.activationEvents.join(","):null,isBuiltin:le.isBuiltin,reason:Q.activationEvent,reasonId:Q.extensionId.value}}function Z(le){return le.getAllExtensionDescriptions().map(Q=>Q.identifier.value).join(",")}e.IExtHostExtensionService=(0,d.createDecorator)("IExtHostExtensionService");class J{#e;#t;#i;constructor(Q,z,se,Ee,ae){this.#e=Q,this.#t=z,this.#i=se.identifier,this.id=se.identifier.value,this.extensionUri=se.extensionLocation,this.extensionPath=h.normalize((0,A.originalFSPath)(se.extensionLocation)),this.packageJSON=se,this.extensionKind=Ee,this.isFromDifferentExtensionHost=ae}get isActive(){return this.#e.isActivated(this.#i)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#i)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#i,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.Extension=J;function oe(le,Q){return le.getAllExtensionDescriptions().filter(z=>Q.has(z.identifier))}class te{constructor(Q){this._searchTree=Q}setSearchTree(Q){this._searchTree=Q}findSubstr(Q){return this._searchTree.findSubstr(Q)}forEach(Q){return this._searchTree.forEach(Q)}}e.ExtensionPaths=te;class me{constructor(Q){this._map=new i.ExtensionIdentifierMap,this.addActivationEvents(Q)}readActivationEvents(Q){return this._map.get(Q.identifier)??[]}addActivationEvents(Q){for(const z of Object.keys(Q))this._map.set(z,Q[z])}}}),define(Pe[340],ke([1,0,63,2,6,42,25,23,19,29,5,54,11,13]),function(ge,e,s,h,D,A,L,R,v,l,C,_,f,T){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0,s=We(s);let o=class{constructor(a,t,n,r,d,c,g){this._apiFactory=a,this._extensionRegistry=t,this._instaService=n,this._extHostConfiguration=r,this._extHostExtensionService=d,this._initData=c,this._logService=g,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),s.mark("code/extHost/willWaitForConfig");const a=await this._extHostConfiguration.getConfigProvider();s.mark("code/extHost/didWaitForConfig");const t=await this._extHostExtensionService.getExtensionPathIndex();this.register(new p(this._apiFactory,t,this._extensionRegistry,a,this._logService)),this.register(this._instaService.createInstance(m)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(u,t,this._initData.environment.appUriScheme))}register(a){if("nodeModuleName"in a)if(Array.isArray(a.nodeModuleName))for(const t of a.nodeModuleName)this._factories.set(t,a);else this._factories.set(a.nodeModuleName,a);typeof a.alternativeModuleName=="function"&&this._alternatives.push(t=>a.alternativeModuleName(t))}};e.RequireInterceptor=o,e.RequireInterceptor=o=Qe([$e(2,C.IInstantiationService),$e(3,A.IExtHostConfiguration),$e(4,_.IExtHostExtensionService),$e(5,l.IExtHostInitDataService),$e(6,f.ILogService)],o);let m=class{static{S=this}static{this.aliased=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor(a){if(a.environment.appRoot&&S.aliased.size){const t=(0,T.escapeRegExpCharacters)(this.forceForwardSlashes(a.environment.appRoot.fsPath)),n="[a-z0-9_.-]",r=`@${n}+\\/${n}+|${n}+`,d="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.re=new RegExp(`^(${t}/${d}\\/)(${r})(.*)$`,"i")}}alternativeModuleName(a){if(!this.re)return;const t=this.re.exec(this.forceForwardSlashes(a));if(!t)return;const[,n,r,d]=t,c=S.aliased.get(r);if(c!==void 0)return console.warn(`${r} as been renamed to ${c}, please update your imports`),n+c+d}forceForwardSlashes(a){return a.replace(/\\/g,"/")}};m=S=Qe([$e(0,l.IExtHostInitDataService)],m);class p{constructor(a,t,n,r,d){this._apiFactory=a,this._extensionPaths=t,this._extensionRegistry=n,this._configProvider=r,this._logService=d,this.nodeModuleName="vscode",this._extApiImpl=new R.ExtensionIdentifierMap}load(a,t){const n=this._extensionPaths.findSubstr(t);if(n){let r=this._extApiImpl.get(n.identifier);return r||(r=this._apiFactory(n,this._extensionRegistry,this._configProvider),this._extApiImpl.set(n.identifier,r)),r}if(!this._defaultApiImpl){let r="";this._extensionPaths.forEach((d,c)=>r+=`	${c} -> ${d.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${t}. These are the extension path mappings: 
${r}`),this._defaultApiImpl=this._apiFactory(L.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let u=class{constructor(a,t,n){this._extensionPaths=a,this._appUriScheme=t,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=n.getProxy(D.MainContext.MainThreadTelemetry);const r=n.getProxy(D.MainContext.MainThreadWindow);this._impl=(d,c)=>{const g=h.URI.parse(d);return c?this.callOriginal(d,c):g.scheme==="http"||g.scheme==="https"?r.$openUri(g,d,{allowTunneling:!0}):g.scheme==="mailto"||g.scheme===this._appUriScheme?r.$openUri(g,d,{}):this.callOriginal(d,c)}}load(a,t,n){const r=this._extensionPaths.findSubstr(t);return r&&(this._extensionId=r.identifier.value,this.sendShimmingTelemetry()),this._original=n(a),this._impl}callOriginal(a,t){return this.sendNoForwardTelemetry(),this._original(a,t)}sendShimmingTelemetry(){this._extensionId&&this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){this._extensionId&&this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};u=Qe([$e(2,v.IExtHostRpcService)],u)}),define(Pe[66],ke([1,0,50,3,16,57,5,65,79,54,9,49,269,42]),function(ge,e,s,h,D,A,L,R,v,l,C,_,f,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostVariableResolverProviderService=e.IExtHostVariableResolverProvider=void 0,D=We(D),A=We(A),e.IExtHostVariableResolverProvider=(0,L.createDecorator)("IExtHostVariableResolverProvider");class S extends f.AbstractVariableResolverService{constructor(p,u,i,a,t,n,r){function d(){if(i){const c=i.activeEditor();if(c)return c.document.uri;const g=a.tabGroups.all.find(w=>w.isActive)?.activeTab;if(g!==void 0){if(g.input instanceof C.TextDiffTabInput||g.input instanceof C.NotebookDiffEditorTabInput)return g.input.modified;if(g.input instanceof C.TextTabInput||g.input instanceof C.NotebookEditorTabInput||g.input instanceof C.CustomEditorTabInput)return g.input.uri}}}super({getFolderUri:c=>{const g=n.folders.filter(w=>w.name===c);if(g&&g.length>0)return g[0].uri},getWorkspaceFolderCount:()=>n.folders.length,getConfigurationValue:(c,g)=>t.getConfiguration(void 0,c).get(g),getAppRoot:()=>A.cwd(),getExecPath:()=>A.env.VSCODE_EXEC_PATH,getFilePath:()=>{const c=d();if(c)return D.normalize(c.fsPath)},getWorkspaceFolderPathForFile:()=>{if(u){const c=d();if(c){const g=u.getWorkspaceFolder(c);if(g)return D.normalize(g.uri.fsPath)}}},getSelectedText:()=>{if(i){const c=i.activeEditor();if(c&&!c.selection.isEmpty)return c.document.getText(c.selection)}},getLineNumber:()=>{if(i){const c=i.activeEditor();if(c)return String(c.selection.end.line+1)}},getExtension:c=>p.getExtension(c)},void 0,r?Promise.resolve(r):void 0,Promise.resolve(A.env))}}let o=class extends h.Disposable{constructor(p,u,i,a,t){super(),this.extensionService=p,this.workspaceService=u,this.editorService=i,this.configurationService=a,this.editorTabs=t,this._resolver=new s.Lazy(async()=>{const n=await this.configurationService.getConfigProvider(),d={folders:await this.workspaceService.getWorkspaceFolders2()||[]};return this._register(this.workspaceService.onDidChangeWorkspace(async c=>{d.folders=await this.workspaceService.getWorkspaceFolders2()||[]})),new S(this.extensionService,this.workspaceService,this.editorService,this.editorTabs,n,d,this.homeDir())})}getResolver(){return this._resolver.value}homeDir(){}};e.ExtHostVariableResolverProviderService=o,e.ExtHostVariableResolverProviderService=o=Qe([$e(0,l.IExtHostExtensionService),$e(1,_.IExtHostWorkspace),$e(2,R.IExtHostDocumentsAndEditors),$e(3,T.IExtHostConfiguration),$e(4,v.IExtHostEditorTabs)],o)}),define(Pe[101],ke([1,0,8,4,2,3,23,5,6,79,54,19,9,49,159,119,260,42,66,51,35,15,18,99]),function(ge,e,s,h,D,A,L,R,v,l,C,_,f,T,S,o,m,p,u,i,a,t,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,t=We(t),e.IExtHostDebugService=(0,R.createDecorator)("IExtHostDebugService");let d=class extends A.Disposable{get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession?.api}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}constructor(k,b,E,N,O,M,U,H){super(),this._workspaceService=b,this._extensionService=E,this._configurationService=N,this._editorTabs=O,this._variableResolver=M,this._commands=U,this._testing=H,this._debugSessions=new Map,this._debugVisualizationTreeItemIdsCounter=0,this._debugVisualizationProviders=new Map,this._debugVisualizationTrees=new Map,this._debugVisualizationTreeItemIds=new WeakMap,this._debugVisualizationElements=new Map,this._visualizers=new Map,this._visualizerIdCounter=0,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=this._register(new h.Emitter),this._onDidTerminateDebugSession=this._register(new h.Emitter),this._onDidChangeActiveDebugSession=this._register(new h.Emitter),this._onDidReceiveDebugSessionCustomEvent=this._register(new h.Emitter),this._debugServiceProxy=k.getProxy(v.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=this._register(new h.Emitter),this._onDidChangeActiveStackItem=this._register(new h.Emitter),this._activeDebugConsole=new g(this._debugServiceProxy),this._breakpoints=new Map,this._extensionService.getExtensionRegistry().then(F=>{this._register(F.onDidChange(x=>{this.registerAllDebugTypes(F)})),this.registerAllDebugTypes(F)})}async $getVisualizerTreeItem(k,b){const E=this.hydrateVisualizationContext(b);if(!E)return;const N=await this._debugVisualizationTrees.get(k)?.getTreeItem?.(E);return N?this.convertVisualizerTreeItem(k,N):void 0}registerDebugVisualizationTree(k,b,E){const N=L.ExtensionIdentifier.toKey(k.identifier),O=this.extensionVisKey(N,b);if(this._debugVisualizationProviders.has(O))throw new Error(`A debug visualization provider with id '${b}' is already registered`);return this._debugVisualizationTrees.set(O,E),this._debugServiceProxy.$registerDebugVisualizerTree(O,!!E.editItem),(0,A.toDisposable)(()=>{this._debugServiceProxy.$unregisterDebugVisualizerTree(O),this._debugVisualizationTrees.delete(b)})}async $getVisualizerTreeItemChildren(k,b){const E=this._debugVisualizationElements.get(b)?.item;return E?(await this._debugVisualizationTrees.get(k)?.getChildren?.(E))?.map(O=>this.convertVisualizerTreeItem(k,O))||[]:[]}async $editVisualizerTreeItem(k,b){const E=this._debugVisualizationElements.get(k);if(!E)return;const N=await this._debugVisualizationTrees.get(E.provider)?.editItem?.(E.item,b);return this.convertVisualizerTreeItem(E.provider,N||E.item)}$disposeVisualizedTree(k){const b=this._debugVisualizationElements.get(k);if(!b)return;const E=[b.children];for(const N of E)if(N)for(const O of N)E.push(this._debugVisualizationElements.get(O)?.children),this._debugVisualizationElements.delete(O)}convertVisualizerTreeItem(k,b){let E=this._debugVisualizationTreeItemIds.get(b);return E||(E=this._debugVisualizationTreeItemIdsCounter++,this._debugVisualizationTreeItemIds.set(b,E),this._debugVisualizationElements.set(E,{provider:k,item:b})),t.DebugTreeItem.from(b,E)}asDebugSourceUri(k,b){const E=k;if(typeof E.sourceReference=="number"&&E.sourceReference>0){let N=`debug:${encodeURIComponent(E.path||"")}`,O="?";return b&&(N+=`${O}session=${encodeURIComponent(b.id)}`,O="&"),N+=`${O}ref=${E.sourceReference}`,D.URI.parse(N)}else{if(E.path)return D.URI.file(E.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(k){const b=[];for(const E of k.getAllExtensionDescriptions())if(E.contributes){const N=E.contributes.debuggers;if(N&&N.length>0)for(const O of N)(0,m.isDebuggerMainContribution)(O)&&b.push(O.type)}this._debugServiceProxy.$registerDebugTypes(b)}get activeStackItem(){return this._activeStackItem}get onDidChangeActiveStackItem(){return this._onDidChangeActiveStackItem.event}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){const k=[];return this._breakpoints.forEach(b=>k.push(b)),k}async $resolveDebugVisualizer(k,b){const E=this._visualizers.get(k);if(!E)throw new Error(`No debug visualizer found with id '${k}'`);let{v:N,provider:O,extensionId:M}=E;if(N.visualization||(N=await O.resolveDebugVisualization?.(N,b)||N,E.v=N),!N.visualization)throw new Error(`No visualization returned from resolveDebugVisualization in '${O}'`);return this.serializeVisualization(M,N.visualization)}async $executeDebugVisualizerCommand(k){const b=this._visualizers.get(k);if(!b)throw new Error(`No debug visualizer found with id '${k}'`);const E=b.v.visualization;E&&"command"in E&&this._commands.executeCommand(E.command,...E.arguments||[])}hydrateVisualizationContext(k){const b=this._debugSessions.get(k.sessionId);return b&&{session:b.api,variable:k.variable,containerId:k.containerId,frameId:k.frameId,threadId:k.threadId}}async $provideDebugVisualizers(k,b,E,N){const O=this.hydrateVisualizationContext(E),M=this.extensionVisKey(k,b),U=this._debugVisualizationProviders.get(M);if(!O||!U)return[];const H=await U.provideDebugVisualization(O,N);return H?H.map(F=>{const x=++this._visualizerIdCounter;this._visualizers.set(x,{v:F,provider:U,extensionId:k});const $=F.iconPath?this.getIconPathOrClass(F.iconPath):void 0;return{id:x,name:F.name,iconClass:$?.iconClass,iconPath:$?.iconPath,visualization:this.serializeVisualization(k,F.visualization)}}):[]}$disposeDebugVisualizers(k){for(const b of k)this._visualizers.delete(b)}registerDebugVisualizationProvider(k,b,E){if(!k.contributes?.debugVisualizers?.some(M=>M.id===b))throw new Error(`Extensions may only call registerDebugVisualizationProvider() for renderers they contribute (got ${b})`);const N=L.ExtensionIdentifier.toKey(k.identifier),O=this.extensionVisKey(N,b);if(this._debugVisualizationProviders.has(O))throw new Error(`A debug visualization provider with id '${b}' is already registered`);return this._debugVisualizationProviders.set(O,E),this._debugServiceProxy.$registerDebugVisualizer(N,b),(0,A.toDisposable)(()=>{this._debugServiceProxy.$unregisterDebugVisualizer(N,b),this._debugVisualizationProviders.delete(b)})}addBreakpoints(k){const b=k.filter(O=>{const M=O.id;return this._breakpoints.has(M)?!1:(this._breakpoints.set(M,O),!0)});this.fireBreakpointChanges(b,[],[]);const E=[],N=new Map;for(const O of b)if(O instanceof f.SourceBreakpoint){let M=N.get(O.location.uri.toString());M||(M={type:"sourceMulti",uri:O.location.uri,lines:[]},N.set(O.location.uri.toString(),M),E.push(M)),M.lines.push({id:O.id,enabled:O.enabled,condition:O.condition,hitCondition:O.hitCondition,logMessage:O.logMessage,line:O.location.range.start.line,character:O.location.range.start.character,mode:O.mode})}else O instanceof f.FunctionBreakpoint&&E.push({type:"function",id:O.id,enabled:O.enabled,hitCondition:O.hitCondition,logMessage:O.logMessage,condition:O.condition,functionName:O.functionName,mode:O.mode});return this._debugServiceProxy.$registerBreakpoints(E)}removeBreakpoints(k){const b=k.filter(M=>this._breakpoints.delete(M.id));this.fireBreakpointChanges([],b,[]);const E=b.filter(M=>M instanceof f.SourceBreakpoint).map(M=>M.id),N=b.filter(M=>M instanceof f.FunctionBreakpoint).map(M=>M.id),O=b.filter(M=>M instanceof f.DataBreakpoint).map(M=>M.id);return this._debugServiceProxy.$unregisterBreakpoints(E,N,O)}startDebugging(k,b,E){const N=E.testRun&&this._testing.getMetadataForRun(E.testRun);return this._debugServiceProxy.$startDebugging(k?k.uri:void 0,b,{parentSessionID:E.parentSession?E.parentSession.id:void 0,lifecycleManagedByParent:E.lifecycleManagedByParent,repl:E.consoleMode===f.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:E.noDebug,compact:E.compact,suppressSaveBeforeStart:E.suppressSaveBeforeStart,testRun:N&&{runId:N.runId,taskId:N.taskId},suppressDebugStatusbar:E.suppressDebugStatusbar??E.debugUI?.simple,suppressDebugToolbar:E.suppressDebugToolbar??E.debugUI?.simple,suppressDebugView:E.suppressDebugView??E.debugUI?.simple})}stopDebugging(k){return this._debugServiceProxy.$stopDebugging(k?k.id:void 0)}registerDebugConfigurationProvider(k,b,E){if(!b)return new f.Disposable(()=>{});const N=this._configProviderHandleCounter++;return this._configProviders.push({type:k,handle:N,provider:b}),this._debugServiceProxy.$registerDebugConfigurationProvider(k,E,!!b.provideDebugConfigurations,!!b.resolveDebugConfiguration,!!b.resolveDebugConfigurationWithSubstitutedVariables,N),new f.Disposable(()=>{this._configProviders=this._configProviders.filter(O=>O.provider!==b),this._debugServiceProxy.$unregisterDebugConfigurationProvider(N)})}registerDebugAdapterDescriptorFactory(k,b,E){if(!E)return new f.Disposable(()=>{});if(!this.definesDebugType(k,b))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${b}' debugger.`);if(this.getAdapterDescriptorFactoryByType(b))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const N=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:b,handle:N,factory:E}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(b,N),new f.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(O=>O.factory!==E),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(N)})}registerDebugAdapterTrackerFactory(k,b){if(!b)return new f.Disposable(()=>{});const E=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:k,handle:E,factory:b}),new f.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(N=>N.factory!==b)})}async $runInTerminal(k,b){return Promise.resolve(void 0)}async $substituteVariables(k,b){let E;const N=await this.getFolder(k);return N&&(E={uri:N.uri,name:N.name,index:N.index,toResource:()=>{throw new Error("Not implemented")}}),(await this._variableResolver.getResolver()).resolveAnyAsync(E,b)}createDebugAdapter(k,b){if(k.type==="implementation")return new y(k.implementation)}createSignService(){}async $startDASession(k,b){const E=this,N=await this.getSession(b);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(N.type),N).then(O=>{if(!O)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${N.type}' (extension might have failed to activate)`);const M=this.convertToDto(O),U=this.createDebugAdapter(M,N);if(!U)throw new Error(`Couldn't create a debug adapter for type '${N.type}'.`);const H=U;return this._debugAdapters.set(k,H),this.getDebugAdapterTrackers(N).then(F=>(F&&this._debugAdaptersTrackers.set(k,F),H.onMessage(async x=>{if(x.type==="request"&&x.command==="handshake"){const $=x,G={type:"response",seq:0,command:$.command,request_seq:$.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const B=await this._signService.sign($.arguments.value);G.body={signature:B},H.sendResponse(G)}else throw new Error("no signer")}catch(B){G.success=!1,G.message=B.message,H.sendResponse(G)}}else F&&F.onDidSendMessage&&F.onDidSendMessage(x),x=(0,m.convertToVSCPaths)(x,!0),E._debugServiceProxy.$acceptDAMessage(k,x)}),H.onError(x=>{F&&F.onError&&F.onError(x),this._debugServiceProxy.$acceptDAError(k,x.name,x.message,x.stack)}),H.onExit(x=>{F&&F.onExit&&F.onExit(x??void 0,void 0),this._debugServiceProxy.$acceptDAExit(k,x??void 0,void 0)}),F&&F.onWillStartSession&&F.onWillStartSession(),H.startSession()))})}$sendDAMessage(k,b){b=(0,m.convertToDAPaths)(b,!1);const E=this._debugAdaptersTrackers.get(k);E&&E.onWillReceiveMessage&&E.onWillReceiveMessage(b),this._debugAdapters.get(k)?.sendMessage(b)}$stopDASession(k){const b=this._debugAdaptersTrackers.get(k);this._debugAdaptersTrackers.delete(k),b&&b.onWillStopSession&&b.onWillStopSession();const E=this._debugAdapters.get(k);return this._debugAdapters.delete(k),E?E.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(k){const b=[],E=[],N=[];if(k.added)for(const O of k.added){const M=O.id;if(M&&!this._breakpoints.has(M)){let U;if(O.type==="function")U=new f.FunctionBreakpoint(O.functionName,O.enabled,O.condition,O.hitCondition,O.logMessage,O.mode);else if(O.type==="data")U=new f.DataBreakpoint(O.label,O.dataId,O.canPersist,O.enabled,O.hitCondition,O.condition,O.logMessage,O.mode);else{const H=D.URI.revive(O.uri);U=new f.SourceBreakpoint(new f.Location(H,new f.Position(O.line,O.character)),O.enabled,O.condition,O.hitCondition,O.logMessage,O.mode)}(0,f.setBreakpointId)(U,M),this._breakpoints.set(M,U),b.push(U)}}if(k.removed)for(const O of k.removed){const M=this._breakpoints.get(O);M&&(this._breakpoints.delete(O),E.push(M))}if(k.changed){for(const O of k.changed)if(O.id){const M=this._breakpoints.get(O.id);if(M){if(M instanceof f.FunctionBreakpoint&&O.type==="function"){const U=M;U.enabled=O.enabled,U.condition=O.condition,U.hitCondition=O.hitCondition,U.logMessage=O.logMessage,U.functionName=O.functionName}else if(M instanceof f.SourceBreakpoint&&O.type==="source"){const U=M;U.enabled=O.enabled,U.condition=O.condition,U.hitCondition=O.hitCondition,U.logMessage=O.logMessage,U.location=new f.Location(D.URI.revive(O.uri),new f.Position(O.line,O.character))}N.push(M)}}}this.fireBreakpointChanges(b,E,N)}async $acceptStackFrameFocus(k){let b;if(k){const E=await this.getSession(k.sessionId);k.kind==="thread"?b=new f.DebugThread(E.api,k.threadId):b=new f.DebugStackFrame(E.api,k.threadId,k.frameId)}this._activeStackItem=b,this._onDidChangeActiveStackItem.fire(this._activeStackItem)}$provideDebugConfigurations(k,b,E){return(0,s.asPromise)(async()=>{const N=this.getConfigProviderByHandle(k);if(!N)throw new Error("no DebugConfigurationProvider found");if(!N.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const O=await this.getFolder(b);return N.provideDebugConfigurations(O,E)}).then(N=>{if(!N)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return N})}$resolveDebugConfiguration(k,b,E,N){return(0,s.asPromise)(async()=>{const O=this.getConfigProviderByHandle(k);if(!O)throw new Error("no DebugConfigurationProvider found");if(!O.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const M=await this.getFolder(b);return O.resolveDebugConfiguration(M,E,N)})}$resolveDebugConfigurationWithSubstitutedVariables(k,b,E,N){return(0,s.asPromise)(async()=>{const O=this.getConfigProviderByHandle(k);if(!O)throw new Error("no DebugConfigurationProvider found");if(!O.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const M=await this.getFolder(b);return O.resolveDebugConfigurationWithSubstitutedVariables(M,E,N)})}async $provideDebugAdapter(k,b){const E=this.getAdapterDescriptorFactoryByHandle(k);if(!E)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const N=await this.getSession(b);return this.getAdapterDescriptor(E,N).then(O=>{if(!O)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${N.type}'`);return this.convertToDto(O)})}async $acceptDebugSessionStarted(k){const b=await this.getSession(k);this._onDidStartDebugSession.fire(b.api)}async $acceptDebugSessionTerminated(k){const b=await this.getSession(k);b&&(this._onDidTerminateDebugSession.fire(b.api),this._debugSessions.delete(b.id))}async $acceptDebugSessionActiveChanged(k){this._activeDebugSession=k?await this.getSession(k):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession?.api)}async $acceptDebugSessionNameChanged(k,b){(await this.getSession(k))?._acceptNameChanged(b)}async $acceptDebugSessionCustomEvent(k,b){const N={session:(await this.getSession(k)).api,event:b.event,body:b.body};this._onDidReceiveDebugSessionCustomEvent.fire(N)}convertToDto(k){if(k instanceof f.DebugAdapterExecutable)return{type:"executable",command:k.command,args:k.args,options:k.options};if(k instanceof f.DebugAdapterServer)return{type:"server",port:k.port,host:k.host};if(k instanceof f.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:k.path};if(k instanceof f.DebugAdapterInlineImplementation)return{type:"implementation",implementation:k.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(k){const b=this._adapterFactories.filter(E=>E.type===k);if(b.length>0)return b[0].factory}getAdapterDescriptorFactoryByHandle(k){const b=this._adapterFactories.filter(E=>E.handle===k);if(b.length>0)return b[0].factory}getConfigProviderByHandle(k){const b=this._configProviders.filter(E=>E.handle===k);if(b.length>0)return b[0].provider}definesDebugType(k,b){if(k.contributes){const E=k.contributes.debuggers;if(E&&E.length>0){for(const N of E)if(N.label&&N.type&&N.type===b)return!0}}return!1}getDebugAdapterTrackers(k){const E=k.configuration.type,N=this._trackerFactories.filter(O=>O.type===E||O.type==="*").map(O=>(0,s.asPromise)(()=>O.factory.createDebugAdapterTracker(k.api)).then(M=>M,M=>null));return Promise.race([Promise.all(N).then(O=>{const M=(0,n.coalesce)(O);if(M.length>0)return new w(M)}),new Promise(O=>setTimeout(()=>O(void 0),1e3))]).catch(O=>{})}async getAdapterDescriptor(k,b){const E=b.configuration.debugServer;if(typeof E=="number")return Promise.resolve(new f.DebugAdapterServer(E));if(k){const O=await this._extensionService.getExtensionRegistry();return(0,s.asPromise)(()=>k.createDebugAdapterDescriptor(b.api,this.daExecutableFromPackage(b,O))).then(M=>{if(M)return M})}const N=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(b,N))}daExecutableFromPackage(k,b){}fireBreakpointChanges(k,b,E){(k.length>0||b.length>0||E.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:k,removed:b,changed:E}))}async getSession(k){if(k)if(typeof k=="string"){const b=this._debugSessions.get(k);if(b)return b}else{let b=this._debugSessions.get(k.id);if(!b){const E=await this.getFolder(k.folderUri),N=k.parent?this._debugSessions.get(k.parent):void 0;b=new c(this._debugServiceProxy,k.id,k.type,k.name,E,k.configuration,N?.api),this._debugSessions.set(b.id,b),this._debugServiceProxy.$sessionCached(b.id)}return b}throw new Error("cannot find session")}getFolder(k){if(k){const b=D.URI.revive(k);return this._workspaceService.resolveWorkspaceFolder(b)}return Promise.resolve(void 0)}extensionVisKey(k,b){return`${k}\0${b}`}serializeVisualization(k,b){if(b){if("title"in b&&"command"in b)return{type:o.DebugVisualizationType.Command};if("treeId"in b)return{type:o.DebugVisualizationType.Tree,id:`${k}\0${b.treeId}`};throw new Error("Unsupported debug visualization type")}}getIconPathOrClass(k){const b=this.getIconUris(k);let E,N;return"id"in b?N=i.ThemeIcon.asClassName(b):E=b,{iconPath:E,iconClass:N}}getIconUris(k){if(k instanceof f.ThemeIcon)return{id:k.id};const b=typeof k=="object"&&"dark"in k?k.dark:k,E=typeof k=="object"&&"light"in k?k.light:k;return{dark:typeof b=="string"?D.URI.file(b):b,light:typeof E=="string"?D.URI.file(E):E}}};e.ExtHostDebugServiceBase=d,e.ExtHostDebugServiceBase=d=Qe([$e(0,_.IExtHostRpcService),$e(1,T.IExtHostWorkspace),$e(2,C.IExtHostExtensionService),$e(3,p.IExtHostConfiguration),$e(4,l.IExtHostEditorTabs),$e(5,u.IExtHostVariableResolverProvider),$e(6,a.IExtHostCommands),$e(7,r.IExtHostTesting)],d);class c{constructor(k,b,E,N,O,M,U){this._debugServiceProxy=k,this._id=b,this._type=E,this._name=N,this._workspaceFolder=O,this._configuration=M,this._parentSession=U}get api(){const k=this;return this.apiSession??=Object.freeze({id:k._id,type:k._type,get name(){return k._name},set name(b){k._name=b,k._debugServiceProxy.$setDebugSessionName(k._id,b)},parentSession:k._parentSession,workspaceFolder:k._workspaceFolder,configuration:k._configuration,customRequest(b,E){return k._debugServiceProxy.$customDebugAdapterRequest(k._id,b,E)},getDebugProtocolBreakpoint(b){return k._debugServiceProxy.$getDebugProtocolBreakpoint(k._id,b.id)}})}get id(){return this._id}get type(){return this._type}_acceptNameChanged(k){this._name=k}get configuration(){return this._configuration}}e.ExtHostDebugSession=c;class g{constructor(k){this.value=Object.freeze({append(b){k.$appendDebugConsole(b)},appendLine(b){this.append(b+`
`)}})}}e.ExtHostDebugConsole=g;class w{constructor(k){this.trackers=k}onWillStartSession(){this.trackers.forEach(k=>k.onWillStartSession?k.onWillStartSession():void 0)}onWillReceiveMessage(k){this.trackers.forEach(b=>b.onWillReceiveMessage?b.onWillReceiveMessage(k):void 0)}onDidSendMessage(k){this.trackers.forEach(b=>b.onDidSendMessage?b.onDidSendMessage(k):void 0)}onWillStopSession(){this.trackers.forEach(k=>k.onWillStopSession?k.onWillStopSession():void 0)}onError(k){this.trackers.forEach(b=>b.onError?b.onError(k):void 0)}onExit(k,b){this.trackers.forEach(E=>E.onExit?E.onExit(k,b):void 0)}}class y extends S.AbstractDebugAdapter{constructor(k){super(),this.implementation=k,k.onDidSendMessage(b=>{this.acceptMessage(b)})}startSession(){return Promise.resolve(void 0)}sendMessage(k){this.implementation.handleMessage(k)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let I=class extends d{constructor(k,b,E,N,O,M,U,H){super(k,b,E,N,O,M,U,H)}};e.WorkerExtHostDebugService=I,e.WorkerExtHostDebugService=I=Qe([$e(0,_.IExtHostRpcService),$e(1,T.IExtHostWorkspace),$e(2,C.IExtHostExtensionService),$e(3,p.IExtHostConfiguration),$e(4,l.IExtHostEditorTabs),$e(5,u.IExtHostVariableResolverProvider),$e(6,a.IExtHostCommands),$e(7,r.IExtHostTesting)],I)}),define(Pe[341],ke([1,0,12,63,2,6,290,11,89,114,29,228,19,74,54,95]),function(ge,e,s,h,D,A,L,R,v,l,C,_,f,T,S,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=e.ErrorHandler=void 0,s=We(s),h=We(h);class m{static async installEarlyHandler(i){Error.stackTraceLimit=100;const a=i.get(R.ILogService),n=i.get(f.IExtHostRpcService).getProxy(A.MainContext.MainThreadErrors);s.setUnexpectedErrorHandler(r=>{a.error(r);const d=s.transformErrorForSerialization(r);n.$onUnexpectedError(d)})}static async installFullHandler(i){const a=i.get(R.ILogService),t=i.get(f.IExtHostRpcService),n=i.get(S.IExtHostExtensionService),r=i.get(o.IExtHostTelemetry),d=t.getProxy(A.MainContext.MainThreadExtensionService),c=t.getProxy(A.MainContext.MainThreadErrors),g=await n.getExtensionPathIndex(),w=new WeakMap;function y(k,b){if(w.has(k))return w.get(k).stack;let E="",N,O;for(const U of b)E+=`
	at ${U.toString()}`,O=U.getFileName(),!N&&O&&(N=g.findSubstr(D.URI.file(O)));const M=`${k.name||"Error"}: ${k.message||""}${E}`;return w.set(k,{extensionIdentifier:N?.identifier,stack:M}),M}const I=Symbol("prepareStackTrace wrapped");let P=y;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return P},set(k){if(k===y||!k||k[I]){P=k||y;return}P=function(b,E){return y(b,E),k.call(Error,b,E)},Object.assign(P,{[I]:!0})}}),s.setUnexpectedErrorHandler(k=>{a.error(k);const b=s.transformErrorForSerialization(k),E=w.get(k);if(!E?.extensionIdentifier){c.$onUnexpectedError(b);return}d.$onExtensionRuntimeError(E.extensionIdentifier,b);const N=r.onExtensionError(E.extensionIdentifier,k);a.trace("forwarded error to extension?",N,E)})}}e.ErrorHandler=m;class p{constructor(i,a,t,n,r){this._hostUtils=t,this._rpcProtocol=new L.RPCProtocol(i,null,n),a=p._transform(a,this._rpcProtocol);const d=new l.ServiceCollection(...(0,v.getSingletonServiceDescriptors)());d.set(C.IExtHostInitDataService,{_serviceBrand:void 0,...a,messagePorts:r}),d.set(f.IExtHostRpcService,new f.ExtHostRpcService(this._rpcProtocol)),d.set(T.IURITransformerService,new T.URITransformerService(n)),d.set(S.IHostUtils,t);const c=new _.InstantiationService(d,!0);c.invokeFunction(m.installEarlyHandler),this._logService=c.invokeFunction(g=>g.get(R.ILogService)),h.mark("code/extHost/didCreateServices"),this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} started`):this._logService.info("Extension host started"),this._logService.trace("initData",a),this._extensionService=c.invokeFunction(g=>g.get(S.IExtHostExtensionService)),this._extensionService.initialize(),c.invokeFunction(m.installFullHandler)}async asBrowserUri(i){const a=this._rpcProtocol.getProxy(A.MainContext.MainThreadExtensionService);return D.URI.revive(await a.$asBrowserUri(i))}terminate(i){this._extensionService.terminate(i)}static _transform(i,a){i.extensions.allExtensions.forEach(n=>{n.extensionLocation=D.URI.revive(a.transformIncomingURIs(n.extensionLocation))}),i.environment.appRoot=D.URI.revive(a.transformIncomingURIs(i.environment.appRoot));const t=i.environment.extensionDevelopmentLocationURI;return t&&(i.environment.extensionDevelopmentLocationURI=t.map(n=>D.URI.revive(a.transformIncomingURIs(n)))),i.environment.extensionTestsLocationURI=D.URI.revive(a.transformIncomingURIs(i.environment.extensionTestsLocationURI)),i.environment.globalStorageHome=D.URI.revive(a.transformIncomingURIs(i.environment.globalStorageHome)),i.environment.workspaceStorageHome=D.URI.revive(a.transformIncomingURIs(i.environment.workspaceStorageHome)),i.environment.extensionTelemetryLogResource=D.URI.revive(a.transformIncomingURIs(i.environment.extensionTelemetryLogResource)),i.nlsBaseUrl=D.URI.revive(a.transformIncomingURIs(i.nlsBaseUrl)),i.logsLocation=D.URI.revive(a.transformIncomingURIs(i.logsLocation)),i.workspace=a.transformIncomingURIs(i.workspace),i}}e.ExtensionHostMain=p}),define(Pe[342],ke([1,0,8,10,7,221,152,101,79,54,19,48,9,66,49,261,262,42,35,99]),function(ge,e,s,h,D,A,L,R,v,l,C,_,f,T,S,o,m,p,u,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDebugService=void 0,h=We(h),D=We(D);let a=class extends R.ExtHostDebugServiceBase{constructor(c,g,w,y,I,P,k,b,E){super(c,g,w,y,P,k,b,E),this._terminalService=I,this._integratedTerminalInstances=new r}createDebugAdapter(c,g){switch(c.type){case"server":return new o.SocketDebugAdapter(c);case"pipeServer":return new o.NamedPipeDebugAdapter(c);case"executable":return new o.ExecutableDebugAdapter(c,g.type)}return super.createDebugAdapter(c,g)}daExecutableFromPackage(c,g){const w=o.ExecutableDebugAdapter.platformAdapterExecutable(g.getAllExtensionDescriptions(),c.type);if(w)return new f.DebugAdapterExecutable(w.command,w.args,w.options)}createSignService(){return new L.SignService}async $runInTerminal(c,g){if(c.kind==="integrated"){this._terminalDisposedListener||(this._terminalDisposedListener=this._register(this._terminalService.onDidCloseTerminal(H=>{this._integratedTerminalInstances.onTerminalClosed(H)})));const w=await this._configurationService.getConfigProvider(),y=this._terminalService.getDefaultShell(!0),I=this._terminalService.getDefaultShellArgs(!0),P=c.title||D.localize(2731,null),k=JSON.stringify({shell:y,shellArgs:I});let b=await this._integratedTerminalInstances.checkout(k,P),E,N=!1;if(b)E=c.cwd;else{const H={shellPath:y,shellArgs:I,cwd:c.cwd,name:P,iconPath:new f.ThemeIcon("debug")};N=!0,b=this._terminalService.createTerminalFromOptions(H,{isFeatureTerminal:!0,forceShellIntegration:!0,useShellEnvironment:!0}),this._integratedTerminalInstances.insert(b,k)}b.show(!0);const O=await b.processId;N?await new Promise(H=>setTimeout(H,1e3)):(b.state.isInteractedWith&&(b.sendText(""),await(0,s.timeout)(200)),w.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(y.indexOf("powershell")>=0||y.indexOf("pwsh")>=0||y.indexOf("cmd.exe")>=0?b.sendText("cls"):y.indexOf("bash")>=0?b.sendText("clear"):h.isWindows?b.sendText("cls"):b.sendText("clear")));const M=(0,m.prepareCommand)(y,c.args,!!c.argsCanBeInterpretedByShell,E,c.env);b.sendText(M);const U=this.onDidTerminateDebugSession(H=>{H.id===g&&(this._integratedTerminalInstances.free(b),U.dispose())});return O}else if(c.kind==="external")return n(c,await this._configurationService.getConfigProvider());return super.$runInTerminal(c,g)}};e.ExtHostDebugService=a,e.ExtHostDebugService=a=Qe([$e(0,C.IExtHostRpcService),$e(1,S.IExtHostWorkspace),$e(2,l.IExtHostExtensionService),$e(3,p.IExtHostConfiguration),$e(4,_.IExtHostTerminalService),$e(5,v.IExtHostEditorTabs),$e(6,T.IExtHostVariableResolverProvider),$e(7,u.IExtHostCommands),$e(8,i.IExtHostTesting)],a);let t;function n(d,c){if(!t)if(h.isWindows)t=new A.WindowsExternalTerminalService;else if(h.isMacintosh)t=new A.MacExternalTerminalService;else if(h.isLinux)t=new A.LinuxExternalTerminalService;else throw new Error("external terminals not supported on this platform");const g=c.getConfiguration("terminal");return t.runInTerminal(d.title,d.cwd,d.args,d.env||{},g.external||{})}class r{constructor(){this._terminalInstances=new Map}static{this.minUseDelay=1e3}async checkout(c,g,w=!1){const I=[...this._terminalInstances.entries()].map(([P,k])=>(0,s.createCancelablePromise)(async b=>{if(P.name!==g||k.lastUsedAt!==-1&&await(0,m.hasChildProcesses)(await P.processId))return null;const E=Date.now();return k.lastUsedAt+r.minUseDelay>E||b.isCancellationRequested?null:k.config!==c?(w&&P.dispose(),null):(k.lastUsedAt=E,P)}));return await(0,s.firstParallel)(I,P=>!!P)}insert(c,g){this._terminalInstances.set(c,{lastUsedAt:Date.now(),config:g})}free(c){const g=this._terminalInstances.get(c);g&&(g.lastUsedAt=-1)}onTerminalClosed(c){this._terminalInstances.delete(c)}}}),define(Pe[343],ke([1,0,16,2,111,49,65,42,47,48,19,29,100,14,11,96,22,69,66]),function(ge,e,s,h,D,A,L,R,v,l,C,_,f,T,S,o,m,p,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTask=void 0,s=We(s),m=We(m);let i=class extends f.ExtHostTaskBase{constructor(t,n,r,d,c,g,w,y,I){super(t,n,r,d,c,g,w,y),this.workspaceService=r,this.variableResolver=I,n.remote.isRemote&&n.remote.authority?this.registerTaskSystem(T.Schemas.vscodeRemote,{scheme:T.Schemas.vscodeRemote,authority:n.remote.authority,platform:process.platform}):this.registerTaskSystem(T.Schemas.file,{scheme:T.Schemas.file,authority:"",platform:process.platform}),this._proxy.$registerSupportedExecutions(!0,!0,!0)}async executeTask(t,n){const r=n;if(!n.execution&&r._id===void 0)throw new Error("Tasks to execute must include an execution");if(r._id!==void 0){const d=f.TaskHandleDTO.from(r,this.workspaceService),c=await this._proxy.$getTaskExecution(d);if(c.task===void 0)throw new Error("Task from execution DTO is undefined");const g=await this.getTaskExecution(c,n);return this._proxy.$executeTask(d).catch(()=>{}),g}else{const d=f.TaskDTO.from(n,t);if(d===void 0)return Promise.reject(new Error("Task is not valid"));f.CustomExecutionDTO.is(d.execution)&&await this.addCustomExecution(d,n,!1);const c=await this.getTaskExecution(await this._proxy.$getTaskExecution(d),n);return this._proxy.$executeTask(d).catch(()=>{}),c}}provideTasksInternal(t,n,r,d){const c=[];if(d)for(const g of d){this.checkDeprecation(g,r),(!g.definition||!t[g.definition.type])&&this._logService.warn(`The task [${g.source}, ${g.name}] uses an undefined task type. The task will be ignored in the future.`);const w=f.TaskDTO.from(g,r.extension);w&&(c.push(w),f.CustomExecutionDTO.is(w.execution)&&n.push(this.addCustomExecution(w,g,!0)))}return{tasks:c,extension:r.extension}}async resolveTaskInternal(t){return t}async getAFolder(t){let n=t&&t.length>0?t[0]:void 0;if(!n){const r=h.URI.file((0,p.homedir)());n=new v.WorkspaceFolder({uri:r,name:m.basename(r),index:0})}return{uri:n.uri,name:n.name,index:n.index,toResource:()=>{throw new Error("Not implemented")}}}async $resolveVariables(t,n){const r=h.URI.revive(t),d={process:void 0,variables:Object.create(null)},c=await this._workspaceProvider.resolveWorkspaceFolder(r),g=await this._workspaceProvider.getWorkspaceFolders2()??[],w=await this.variableResolver.getResolver(),y=c?{uri:c.uri,name:c.name,index:c.index,toResource:()=>{throw new Error("Not implemented")}}:await this.getAFolder(g);for(const I of n.variables)d.variables[I]=await w.resolveAsync(y,I);if(n.process!==void 0){let I;if(n.process.path!==void 0){I=n.process.path.split(s.delimiter);for(let P=0;P<I.length;P++)I[P]=await w.resolveAsync(y,I[P])}d.process=await D.win32.findExecutable(await w.resolveAsync(y,n.process.name),n.process.cwd!==void 0?await w.resolveAsync(y,n.process.cwd):void 0,I)}return d}async $jsonTasksSupported(){return!0}async $findExecutable(t,n,r){return D.win32.findExecutable(t,n,r)}};e.ExtHostTask=i,e.ExtHostTask=i=Qe([$e(0,C.IExtHostRpcService),$e(1,_.IExtHostInitDataService),$e(2,A.IExtHostWorkspace),$e(3,L.IExtHostDocumentsAndEditors),$e(4,R.IExtHostConfiguration),$e(5,l.IExtHostTerminalService),$e(6,S.ILogService),$e(7,o.IExtHostApiDeprecationService),$e(8,u.IExtHostVariableResolverProvider)],i)}),define(Pe[344],ke([1,0,69,66]),function(ge,e,s,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeExtHostVariableResolverProviderService=void 0;class D extends h.ExtHostVariableResolverProviderService{homeDir(){return(0,s.homedir)()}}e.NodeExtHostVariableResolverProviderService=D}),define(Pe[129],ke([1,0,18,32,59]),function(ge,e,s,h,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OldAITextSearchProviderConverter=e.OldTextSearchProviderConverter=e.OldFileSearchProviderConverter=void 0,e.newToOldPreviewOptions=l,e.oldToNewTextSearchResult=C,e.extensionResultIsMatch=S;function A(o){return"uri"in o&&"ranges"in o&&"preview"in o}function L(o){return o.folderOptions.map(m=>({folder:m.folder,excludes:m.excludes.map(p=>typeof p=="string"?p:p.pattern),includes:m.includes,useGlobalIgnoreFiles:m.useIgnoreFiles.global,useIgnoreFiles:m.useIgnoreFiles.local,useParentIgnoreFiles:m.useIgnoreFiles.parent,followSymlinks:m.followSymlinks,maxResults:o.maxResults,session:o.session}))}class R{constructor(m){this.provider=m}provideFileSearchResults(m,p,u){return(async()=>{const a=L(p);return Promise.all(a.map(t=>this.provider.provideFileSearchResults({pattern:m},t,u)))})().then(a=>(0,s.coalesce)(a).flat())}}e.OldFileSearchProviderConverter=R;function v(o){return o.folderOptions.map(m=>({folder:m.folder,excludes:m.excludes.map(p=>typeof p=="string"?p:p.pattern),includes:m.includes,useGlobalIgnoreFiles:m.useIgnoreFiles.global,useIgnoreFiles:m.useIgnoreFiles.local,useParentIgnoreFiles:m.useIgnoreFiles.parent,followSymlinks:m.followSymlinks,maxResults:o.maxResults,previewOptions:l(o.previewOptions),maxFileSize:o.maxFileSize,encoding:m.encoding,afterContext:o.surroundingContext,beforeContext:o.surroundingContext}))}function l(o){return{matchLines:o?.matchLines??h.DEFAULT_TEXT_SEARCH_PREVIEW_OPTIONS.matchLines,charsPerLine:o?.charsPerLine??h.DEFAULT_TEXT_SEARCH_PREVIEW_OPTIONS.charsPerLine}}function C(o){if(A(o)){const m=(0,s.asArray)(o.ranges).map((p,u)=>{const a=(0,s.asArray)(o.preview.matches)[u];return{sourceRange:p,previewRange:a}});return new D.TextSearchMatchNew(o.uri,m,o.preview.text)}else return new D.TextSearchContextNew(o.uri,o.text,o.lineNumber)}class _{constructor(m){this.provider=m}provideTextSearchResults(m,p,u,i){const a=r=>{T(r)&&u.report(C(r))};return(async()=>(0,s.coalesce)(await Promise.all(v(p).map(r=>this.provider.provideTextSearchResults(m,r,{report:d=>a(d)},i)))).reduce((r,d)=>({limitHit:r.limitHit||d.limitHit}),{limitHit:!1}))().then(r=>({limitHit:r.limitHit,message:(0,s.coalesce)((0,s.asArray)(r.message))}))}}e.OldTextSearchProviderConverter=_;class f{constructor(m){this.provider=m}provideAITextSearchResults(m,p,u,i){const a=r=>{T(r)&&u.report(C(r))};return(async()=>(0,s.coalesce)(await Promise.all(v(p).map(r=>this.provider.provideAITextSearchResults(m,r,{report:d=>a(d)},i)))).reduce((r,d)=>({limitHit:r.limitHit||d.limitHit}),{limitHit:!1}))().then(r=>({limitHit:r.limitHit,message:(0,s.coalesce)((0,s.asArray)(r.message))}))}}e.OldAITextSearchProviderConverter=f;function T(o){if(S(o)){if(Array.isArray(o.ranges)){if(!Array.isArray(o.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(o.preview.matches.length!==o.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(o.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}function S(o){return!!o.preview}}),define(Pe[345],ke([1,0,16,20,52,39,22,43,32,62,3,129]),function(ge,e,s,h,D,A,L,R,v,l,C,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0,s=We(s),A=We(A),L=We(L);class f{constructor(m,p,u){this.config=m,this.provider=p,this.sessionLifecycle=u,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=m.filePattern,this.includePattern=m.includePattern&&A.parse(m.includePattern),this.maxResults=m.maxResults||void 0,this.exists=m.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=m.excludePattern&&A.parse(m.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(m=>m.cancel()),this.activeCancellationTokens=new Set}search(m){const p=this.config.folderQueries||[];return new Promise((u,i)=>{const a=t=>{this.resultCount++,m(t)};if(this.isCanceled)return u({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(t=>{const n=t.toString(),r=s.basename(n);this.globalExcludePattern&&this.globalExcludePattern(n,r)||this.matchFile(a,{base:t,basename:r})}),this.doSearch(p,a).then(t=>{u({limitHit:this.isLimitHit,stats:t||void 0})},t=>{i(new Error((0,D.toErrorMessage)(t)))})})}async doSearch(m,p){const u=new h.CancellationTokenSource,i=m.map(d=>this.getSearchOptionsForFolder(d)),a=this.provider instanceof _.OldFileSearchProviderConverter?this.sessionLifecycle?.tokenSource.token:this.sessionLifecycle?.obj,t={folderOptions:i,maxResults:this.config.maxResults??v.DEFAULT_MAX_SEARCH_RESULTS,session:a},n=l.TernarySearchTree.forUris();m.forEach(d=>{const c=new v.QueryGlobTester(this.config,d),g=!c.hasSiblingExcludeClauses();n.set(d.folder,{queryTester:c,noSiblingsClauses:g,folder:d.folder,tree:this.initDirectoryTree()})});let r;try{this.activeCancellationTokens.add(u),r=R.StopWatch.create();const d=await this.provider.provideFileSearchResults(this.config.filePattern||"",t,u.token),c=r.elapsed(),g=R.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(d&&d.forEach(w=>{const y=n.findSubstr(w),I=s.posix.relative(y.folder.path,w.path);if(y.noSiblingsClauses){const P=s.basename(w.path);this.matchFile(p,{base:y.folder,relativePath:I,basename:P});return}this.addDirectoryEntries(y.tree,y.folder,I,p)}),this.isCanceled&&!this.isLimitHit)?null:(n.forEach(w=>{this.matchDirectoryTree(w.tree,w.queryTester,p)}),{providerTime:c,postProcessTime:g.elapsed()})}finally{u.dispose(),this.activeCancellationTokens.delete(u)}}getSearchOptionsForFolder(m){const p=(0,v.resolvePatternsForProvider)(this.config.includePattern,m.includePattern);let u=m.excludePattern?.map(a=>({folder:a.folder,patterns:(0,v.resolvePatternsForProvider)(this.config.excludePattern,a.pattern)}));u?.length||(u=[{folder:void 0,patterns:(0,v.resolvePatternsForProvider)(this.config.excludePattern,void 0)}]);const i=(0,v.excludeToGlobPattern)(u);return{folder:m.folder,excludes:i,includes:p,useIgnoreFiles:{local:!m.disregardIgnoreFiles,parent:!m.disregardParentIgnoreFiles,global:!m.disregardGlobalIgnoreFiles},followSymlinks:!m.ignoreSymlinks}}initDirectoryTree(){const m={rootEntries:[],pathToEntries:Object.create(null)};return m.pathToEntries["."]=m.rootEntries,m}addDirectoryEntries({pathToEntries:m},p,u,i){if(u===this.filePattern){const t=s.basename(this.filePattern);this.matchFile(i,{base:p,relativePath:this.filePattern,basename:t})}function a(t){const n=s.basename(t),r=s.dirname(t);let d=m[r];d||(d=m[r]=[],a(r)),d.push({base:p,relativePath:t,basename:n})}a(u)}matchDirectoryTree({rootEntries:m,pathToEntries:p},u,i){const a=this,t=this.filePattern;function n(r){const d=(0,v.hasSiblingFn)(()=>r.map(c=>c.basename));for(let c=0,g=r.length;c<g;c++){const w=r[c],{relativePath:y,basename:I}=w;if(u.matchesExcludesSync(y,I,t!==I?d:void 0))continue;const P=p[y];if(P)n(P);else{if(y===t)continue;a.matchFile(i,w)}if(a.isLimitHit)break}}n(m)}matchFile(m,p){(!this.includePattern||p.relativePath&&this.includePattern(p.relativePath,p.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||m(p))}}class T extends C.Disposable{constructor(){super(),this.obj=new Object,this.tokenSource=new h.CancellationTokenSource}dispose(){this.tokenSource.cancel(),super.dispose()}}class S{constructor(){this.sessions=new Map}static{this.BATCH_SIZE=512}fileSearch(m,p,u,i){const a=this.getSessionTokenSource(m.cacheKey),t=new f(m,p,a);let n=0;const r=d=>{n+=d.length,u(d.map(c=>this.rawMatchToSearchItem(c)))};return this.doSearch(t,S.BATCH_SIZE,r,i).then(d=>({limitHit:d.limitHit,stats:d.stats?{fromCache:!1,type:"fileSearchProvider",resultCount:n,detailStats:d.stats}:void 0,messages:[]}))}clearCache(m){this.sessions.get(m)?.dispose(),this.sessions.delete(m)}getSessionTokenSource(m){if(m)return this.sessions.has(m)||this.sessions.set(m,new T),this.sessions.get(m)}rawMatchToSearchItem(m){return m.relativePath?{resource:L.joinPath(m.base,m.relativePath)}:{resource:m.base}}doSearch(m,p,u,i){const a=i.onCancellationRequested(()=>{m.cancel()}),t=r=>{r&&(n.push(r),p>0&&n.length>=p&&(u(n),n=[]))};let n=[];return m.search(t).then(r=>(n.length&&u(n),a.dispose(),r),r=>(n.length&&u(n),a.dispose(),Promise.reject(r)))}}e.FileSearchManager=S}),define(Pe[176],ke([1,0,8,20,52,14,16,22,62,2,32,59]),function(ge,e,s,h,D,A,L,R,v,l,C,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.TextSearchResultsCollector=e.TextSearchManager=void 0,L=We(L),R=We(R);class f{constructor(u,i,a){this.queryProviderPair=u,this.fileUtils=i,this.processType=a,this.collector=null,this.isLimitHit=!1,this.resultCount=0}get query(){return this.queryProviderPair.query}search(u,i){const a=this.query.folderQueries||[],t=new h.CancellationTokenSource(i);return new Promise((n,r)=>{this.collector=new S(u);let d=!1;const c=(g,w)=>{if(!d&&!this.isLimitHit){const y=this.resultSize(g);g instanceof _.TextSearchMatchNew&&typeof this.query.maxResults=="number"&&this.resultCount+y>this.query.maxResults&&(this.isLimitHit=!0,d=!0,t.cancel(),g=this.trimResultToSize(g,this.query.maxResults-this.resultCount));const I=this.resultSize(g);this.resultCount+=I;const P=g instanceof _.TextSearchMatchNew;(I>0||!P)&&this.collector.add(g,w)}};this.doSearch(a,c,t.token).then(g=>{t.dispose(),this.collector.flush(),n({limitHit:this.isLimitHit||g?.limitHit,messages:this.getMessagesFromResults(g),stats:{type:this.processType}})},g=>{t.dispose();const w=(0,D.toErrorMessage)(g);r(new Error(w))})})}getMessagesFromResults(u){return u?.message?Array.isArray(u.message)?u.message:[u.message]:[]}resultSize(u){return u instanceof _.TextSearchMatchNew?Array.isArray(u.ranges)?u.ranges.length:1:0}trimResultToSize(u,i){return new _.TextSearchMatchNew(u.uri,u.ranges.slice(0,i),u.previewText)}async doSearch(u,i,a){const t=v.TernarySearchTree.forUris();u.forEach((w,y)=>{const I=new C.QueryGlobTester(this.query,w);t.set(w.folder,{queryTester:I,folder:w.folder,folderIdx:y})});const n=[],r={report:w=>{if(w.uri===void 0)throw Error("Text search result URI is undefined. Please check provider implementation.");const y=t.findSubstr(w.uri),I=y.folder.scheme===A.Schemas.file?(0,C.hasSiblingPromiseFn)(()=>this.fileUtils.readdir(R.dirname(w.uri))):void 0,P=R.relativePath(y.folder,w.uri);if(P){const k=y.queryTester.includedInQuery(P,L.basename(P),I);(0,s.isThenable)(k)?n.push(k.then(b=>{b&&i(w,y.folderIdx)})):k&&i(w,y.folderIdx)}}},c={folderOptions:u.map(w=>this.getSearchOptionsForFolder(w)),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults??C.DEFAULT_MAX_SEARCH_RESULTS,previewOptions:this.query.previewOptions??C.DEFAULT_TEXT_SEARCH_PREVIEW_OPTIONS,surroundingContext:this.query.surroundingContext??0};"usePCRE2"in this.query&&(c.usePCRE2=this.query.usePCRE2);let g;return this.queryProviderPair.query.type===C.QueryType.aiText?g=await this.queryProviderPair.provider.provideAITextSearchResults(this.queryProviderPair.query.contentPattern,c,r,a):g=await this.queryProviderPair.provider.provideTextSearchResults(T(this.queryProviderPair.query.contentPattern),c,r,a),n.length&&await Promise.all(n),g}getSearchOptionsForFolder(u){const i=(0,C.resolvePatternsForProvider)(this.query.includePattern,u.includePattern);let a=u.excludePattern?.map(r=>({folder:r.folder,patterns:(0,C.resolvePatternsForProvider)(this.query.excludePattern,r.pattern)}));(!a||a.length===0)&&(a=[{folder:void 0,patterns:(0,C.resolvePatternsForProvider)(this.query.excludePattern,void 0)}]);const t=(0,C.excludeToGlobPattern)(a);return{folder:l.URI.from(u.folder),excludes:t,includes:i,useIgnoreFiles:{local:!u.disregardIgnoreFiles,parent:!u.disregardParentIgnoreFiles,global:!u.disregardGlobalIgnoreFiles},followSymlinks:!u.ignoreSymlinks,encoding:(u.fileEncoding&&this.fileUtils.toCanonicalName(u.fileEncoding))??""}}}e.TextSearchManager=f;function T(p){return{isCaseSensitive:p.isCaseSensitive||!1,isRegExp:p.isRegExp||!1,isWordMatch:p.isWordMatch||!1,isMultiline:p.isMultiline||!1,pattern:p.pattern}}class S{constructor(u){this._onResult=u,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new m(512,i=>this.sendItems(i))}add(u,i){this._currentFileMatch&&(this._currentFolderIdx!==i||!R.isEqual(this._currentUri,u.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=i,this._currentFileMatch={resource:u.uri,results:[]}),this._currentFileMatch.results.push(o(u))}pushToCollector(){const u=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,u)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(u){this._onResult(u)}}e.TextSearchResultsCollector=S;function o(p){return p instanceof _.TextSearchMatchNew?{previewText:p.previewText,rangeLocations:p.ranges.map(u=>({preview:{startLineNumber:u.previewRange.start.line,startColumn:u.previewRange.start.character,endLineNumber:u.previewRange.end.line,endColumn:u.previewRange.end.character},source:{startLineNumber:u.sourceRange.start.line,startColumn:u.sourceRange.start.character,endLineNumber:u.sourceRange.end.line,endColumn:u.sourceRange.end.character}}))}:{text:p.text,lineNumber:p.lineNumber}}class m{static{this.TIMEOUT=4e3}static{this.START_BATCH_AFTER_COUNT=50}constructor(u,i){this.maxBatchSize=u,this.cb=i,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(u,i){u&&this.addItemToBatch(u,i)}addItems(u,i){u&&this.addItemsToBatch(u,i)}addItemToBatch(u,i){this.batch.push(u),this.batchSize+=i,this.onUpdate()}addItemsToBatch(u,i){this.batch=this.batch.concat(u),this.batchSize+=i,this.onUpdate()}onUpdate(){this.totalNumberCompleted<m.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},m.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=m}),define(Pe[102],ke([1,0,3,6,5,345,19,74,11,2,176,38,129]),function(ge,e,s,h,D,A,L,R,v,l,C,_,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSearch=e.IExtHostSearch=void 0,e.reviveQuery=S,e.IExtHostSearch=(0,D.createDecorator)("IExtHostSearch");let T=class{constructor(p,u,i){this.extHostRpc=p,this._uriTransformer=u,this._logService=i,this._proxy=this.extHostRpc.getProxy(h.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._aiTextSearchProvider=new Map,this._aiTextSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new A.FileSearchManager}_transformScheme(p){return this._uriTransformer.transformOutgoingScheme(p)}registerTextSearchProviderOld(p,u){if(this._textSearchUsedSchemes.has(p))throw new Error(`a text search provider for the scheme '${p}' is already registered`);this._textSearchUsedSchemes.add(p);const i=this._handlePool++;return this._textSearchProvider.set(i,new f.OldTextSearchProviderConverter(u)),this._proxy.$registerTextSearchProvider(i,this._transformScheme(p)),(0,s.toDisposable)(()=>{this._textSearchUsedSchemes.delete(p),this._textSearchProvider.delete(i),this._proxy.$unregisterProvider(i)})}registerTextSearchProvider(p,u){if(this._textSearchUsedSchemes.has(p))throw new Error(`a text search provider for the scheme '${p}' is already registered`);this._textSearchUsedSchemes.add(p);const i=this._handlePool++;return this._textSearchProvider.set(i,u),this._proxy.$registerTextSearchProvider(i,this._transformScheme(p)),(0,s.toDisposable)(()=>{this._textSearchUsedSchemes.delete(p),this._textSearchProvider.delete(i),this._proxy.$unregisterProvider(i)})}registerAITextSearchProviderOld(p,u){if(this._aiTextSearchUsedSchemes.has(p))throw new Error(`an AI text search provider for the scheme '${p}'is already registered`);this._aiTextSearchUsedSchemes.add(p);const i=this._handlePool++;return this._aiTextSearchProvider.set(i,new f.OldAITextSearchProviderConverter(u)),this._proxy.$registerAITextSearchProvider(i,this._transformScheme(p)),(0,s.toDisposable)(()=>{this._aiTextSearchUsedSchemes.delete(p),this._aiTextSearchProvider.delete(i),this._proxy.$unregisterProvider(i)})}registerAITextSearchProvider(p,u){if(this._aiTextSearchUsedSchemes.has(p))throw new Error(`an AI text search provider for the scheme '${p}'is already registered`);this._aiTextSearchUsedSchemes.add(p);const i=this._handlePool++;return this._aiTextSearchProvider.set(i,u),this._proxy.$registerAITextSearchProvider(i,this._transformScheme(p)),(0,s.toDisposable)(()=>{this._aiTextSearchUsedSchemes.delete(p),this._aiTextSearchProvider.delete(i),this._proxy.$unregisterProvider(i)})}registerFileSearchProviderOld(p,u){if(this._fileSearchUsedSchemes.has(p))throw new Error(`a file search provider for the scheme '${p}' is already registered`);this._fileSearchUsedSchemes.add(p);const i=this._handlePool++;return this._fileSearchProvider.set(i,new f.OldFileSearchProviderConverter(u)),this._proxy.$registerFileSearchProvider(i,this._transformScheme(p)),(0,s.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(p),this._fileSearchProvider.delete(i),this._proxy.$unregisterProvider(i)})}registerFileSearchProvider(p,u){if(this._fileSearchUsedSchemes.has(p))throw new Error(`a file search provider for the scheme '${p}' is already registered`);this._fileSearchUsedSchemes.add(p);const i=this._handlePool++;return this._fileSearchProvider.set(i,u),this._proxy.$registerFileSearchProvider(i,this._transformScheme(p)),(0,s.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(p),this._fileSearchProvider.delete(i),this._proxy.$unregisterProvider(i)})}$provideFileSearchResults(p,u,i,a){const t=S(i),n=this._fileSearchProvider.get(p);if(n)return this._fileSearchManager.fileSearch(t,n,r=>{this._proxy.$handleFileMatch(p,u,r.map(d=>d.resource))},a);throw new Error("unknown provider: "+p)}async doInternalFileSearchWithCustomCallback(p,u,i){return{messages:[]}}$clearCache(p){return this._fileSearchManager.clearCache(p),Promise.resolve(void 0)}$provideTextSearchResults(p,u,i,a){const t=this._textSearchProvider.get(p);if(!t||!t.provideTextSearchResults)throw new Error(`Unknown Text Search Provider ${p}`);const n=S(i);return this.createTextSearchManager(n,t).search(d=>this._proxy.$handleTextMatch(p,u,d),a)}$provideAITextSearchResults(p,u,i,a){const t=this._aiTextSearchProvider.get(p);if(!t||!t.provideAITextSearchResults)throw new Error(`Unknown AI Text Search Provider ${p}`);const n=S(i);return this.createAITextSearchManager(n,t).search(d=>this._proxy.$handleTextMatch(p,u,d),a)}$enableExtensionHostSearch(){}createTextSearchManager(p,u){return new C.TextSearchManager({query:p,provider:u},{readdir:i=>Promise.resolve([]),toCanonicalName:i=>i},"textSearchProvider")}createAITextSearchManager(p,u){return new C.TextSearchManager({query:p,provider:u},{readdir:i=>Promise.resolve([]),toCanonicalName:i=>i},"aiTextSearchProvider")}};e.ExtHostSearch=T,e.ExtHostSearch=T=Qe([$e(0,L.IExtHostRpcService),$e(1,R.IURITransformerService),$e(2,v.ILogService)],T);function S(m){return{...m,folderQueries:m.folderQueries&&m.folderQueries.map(o),extraFileResources:m.extraFileResources&&m.extraFileResources.map(p=>l.URI.revive(p))}}function o(m){return(0,_.revive)(m)}});var Vt=this&&this.__importDefault||function(ge){return ge&&ge.__esModule?ge:{default:ge}};define(Pe[346],ke([1,0,20,12,4,3,14,44,2,113,213,199,56,23,27,11,91,92,248,6,292,319,96,127,296,297,298,277,267,35,299,42,300,101,168,301,279,293,302,303,65,79,280,294,54,304,77,305,64,29,320,281,306,307,128,308,122,123,282,337,310,252,311,321,312,174,283,313,314,315,19,316,102,124,317,284,318,125,98,100,95,48,172,99,322,295,323,324,78,15,9,285,74,286,97,325,326,167,49,119,94,25,59]),function(ge,e,s,h,D,A,L,R,v,l,C,_,f,T,S,o,m,p,u,i,a,t,n,r,d,c,g,w,y,I,P,k,b,E,N,O,M,U,H,F,x,$,G,B,W,Z,J,oe,te,me,le,Q,z,se,Ee,ae,be,pe,ve,Re,Fe,Ve,Ye,Je,xe,ze,Ne,V,j,Y,ee,ue,we,Ae,He,Ge,nt,ot,dt,at,ct,vt,it,Ce,re,ce,ye,he,Ie,ne,X,Te,qe,Xe,st,ht,gt,It,At,qt,ei,tt,Lt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=Ut,h=We(h),R=Vt(R),_=We(_),S=We(S),ne=We(ne),X=We(X);function Ut(bt){const Pt=bt.get(me.IExtHostInitDataService),ti=bt.get(te.IExtHostFileSystemInfo),ii=bt.get(J.IExtHostConsumerFileSystem),Kt=bt.get(W.IExtHostExtensionService),St=bt.get(At.IExtHostWorkspace),Ot=bt.get(ct.IExtHostTelemetry),li=bt.get(k.IExtHostConfiguration),Yt=bt.get(qe.IURITransformerService),et=bt.get(ee.IExtHostRpcService),ni=bt.get(ot.IExtHostStorage),ci=bt.get(dt.IExtensionStoragePaths),di=bt.get(o.ILoggerService),Ct=bt.get(o.ILogService),Wt=bt.get(Ie.IExtHostTunnelService),Nt=bt.get(n.IExtHostApiDeprecationService),Bt=bt.get(It.IExtHostWindow),ai=bt.get(Ae.IExtHostSecretState),ri=bt.get($.IExtHostEditorTabs),si=bt.get(pe.IExtHostManagedSockets),Gt=bt.get(r.IExtHostAuthentication),Xt=bt.get(Ee.IExtHostLanguageModels);et.set(i.ExtHostContext.ExtHostFileSystemInfo,ti),et.set(i.ExtHostContext.ExtHostLogLevelServiceShape,di),et.set(i.ExtHostContext.ExtHostWorkspace,St),et.set(i.ExtHostContext.ExtHostConfiguration,li),et.set(i.ExtHostContext.ExtHostExtensionService,Kt),et.set(i.ExtHostContext.ExtHostStorage,ni),et.set(i.ExtHostContext.ExtHostTunnelService,Wt),et.set(i.ExtHostContext.ExtHostWindow,Bt),et.set(i.ExtHostContext.ExtHostSecretState,ai),et.set(i.ExtHostContext.ExtHostTelemetry,Ot),et.set(i.ExtHostContext.ExtHostEditorTabs,ri),et.set(i.ExtHostContext.ExtHostManagedSockets,si),et.set(i.ExtHostContext.ExtHostAuthentication,Gt),et.set(i.ExtHostContext.ExtHostChatProvider,Xt);const ui=et.set(i.ExtHostContext.ExtHostDecorations,bt.get(N.IExtHostDecorations)),Mt=et.set(i.ExtHostContext.ExtHostDocumentsAndEditors,bt.get(x.IExtHostDocumentsAndEditors)),kt=et.set(i.ExtHostContext.ExtHostCommands,bt.get(I.IExtHostCommands)),wt=et.set(i.ExtHostContext.ExtHostTerminalService,bt.get(vt.IExtHostTerminalService)),Qt=et.set(i.ExtHostContext.ExtHostTerminalShellIntegration,bt.get(it.IExtHostTerminalShellIntegration)),yt=et.set(i.ExtHostContext.ExtHostDebugService,bt.get(E.IExtHostDebugService)),oi=et.set(i.ExtHostContext.ExtHostSearch,bt.get(we.IExtHostSearch)),Jt=et.set(i.ExtHostContext.ExtHostTask,bt.get(at.IExtHostTask)),Mi=et.set(i.ExtHostContext.ExtHostOutputService,bt.get(ze.IExtHostOutputService)),hi=et.set(i.ExtHostContext.ExtHostLocalization,bt.get(be.IExtHostLocalizationService)),wi=et.set(i.ExtHostContext.ExtHostUrls,new Xe.ExtHostUrls(et)),$t=et.set(i.ExtHostContext.ExtHostDocuments,new F.ExtHostDocuments(et,Mt)),fi=et.set(i.ExtHostContext.ExtHostDocumentContentProviders,new U.ExtHostDocumentContentProvider(et,Mt,Ct)),Fi=et.set(i.ExtHostContext.ExtHostDocumentSaveParticipant,new H.ExtHostDocumentSaveParticipant(Ct,$t,et.getProxy(i.MainContext.MainThreadBulkEdits))),Rt=et.set(i.ExtHostContext.ExtHostNotebook,new Re.ExtHostNotebookController(et,kt,Mt,$t,ii,oi,Ct)),_i=et.set(i.ExtHostContext.ExtHostNotebookDocuments,new Ve.ExtHostNotebookDocuments(Rt)),Li=et.set(i.ExtHostContext.ExtHostNotebookEditors,new Ye.ExtHostNotebookEditors(Ct,Rt)),gi=et.set(i.ExtHostContext.ExtHostNotebookKernels,new Je.ExtHostNotebookKernels(et,Pt,Rt,kt,Ct)),xi=et.set(i.ExtHostContext.ExtHostNotebookRenderers,new xe.ExtHostNotebookRenderers(et,Rt)),Wi=et.set(i.ExtHostContext.ExtHostNotebookDocumentSaveParticipant,new Fe.ExtHostNotebookDocumentSaveParticipant(Ct,Rt,et.getProxy(i.MainContext.MainThreadBulkEdits))),xt=et.set(i.ExtHostContext.ExtHostEditors,new re.ExtHostEditors(et,Mt)),Ti=et.set(i.ExtHostContext.ExtHostTreeViews,new he.ExtHostTreeViews(et.getProxy(i.MainContext.MainThreadTreeViews),kt,Ct)),Di=et.set(i.ExtHostContext.ExtHostEditorInsets,new y.ExtHostEditorInsets(et.getProxy(i.MainContext.MainThreadEditorInsets),xt,Pt.remote)),Ei=et.set(i.ExtHostContext.ExtHostDiagnostics,new O.ExtHostDiagnostics(et,Ct,ti,Mt)),bi=et.set(i.ExtHostContext.ExtHostLanguages,new ae.ExtHostLanguages(et,$t,kt.converter,Yt)),De=et.set(i.ExtHostContext.ExtHostLanguageFeatures,new z.ExtHostLanguageFeatures(et,Yt,$t,kt,Ei,Ct,Nt,Ot)),Me=et.set(i.ExtHostContext.ExtHostFileSystem,new Z.ExtHostFileSystem(et,De)),Se=et.set(i.ExtHostContext.ExtHostFileSystemEventService,new oe.ExtHostFileSystemEventService(et,Ct,Mt)),ie=et.set(i.ExtHostContext.ExtHostQuickOpen,(0,Y.createExtHostQuickOpen)(et,St,kt)),Oe=et.set(i.ExtHostContext.ExtHostSCM,new ue.ExtHostSCM(et,kt,$t,Ct)),Ke=et.set(i.ExtHostContext.ExtHostQuickDiff,new j.ExtHostQuickDiff(et,Yt)),rt=et.set(i.ExtHostContext.ExtHostShare,new He.ExtHostShare(et,Yt)),je=et.set(i.ExtHostContext.ExtHostComments,(0,P.createExtHostComments)(et,kt,$t)),ut=et.set(i.ExtHostContext.ExtHostProgress,new V.ExtHostProgress(et.getProxy(i.MainContext.MainThreadProgress))),pt=et.set(i.ExtHostContext.ExtHostLabelService,new Q.ExtHostLabelService(et)),jt=et.set(i.ExtHostContext.ExtHostTheming,new ce.ExtHostTheming(et)),Ht=et.set(i.ExtHostContext.ExtHostTimeline,new ye.ExtHostTimeline(et,kt)),zt=et.set(i.ExtHostContext.ExtHostWebviews,new st.ExtHostWebviews(et,Pt.remote,St,Ct,Nt)),Oi=et.set(i.ExtHostContext.ExtHostWebviewPanels,new ht.ExtHostWebviewPanels(et,zt,St)),en=et.set(i.ExtHostContext.ExtHostCustomEditors,new b.ExtHostCustomEditors(et,$t,ci,zt,Oi)),Hi=et.set(i.ExtHostContext.ExtHostWebviewViews,new gt.ExtHostWebviewViews(et,zt)),yi=et.set(i.ExtHostContext.ExtHostTesting,bt.get(Ce.IExtHostTesting)),tn=et.set(i.ExtHostContext.ExtHostUriOpeners,new Te.ExtHostUriOpeners(et)),nn=et.set(i.ExtHostContext.ExtHostProfileContentHandlers,new Ne.ExtHostProfileContentHandlers(et));et.set(i.ExtHostContext.ExtHostInteractive,new le.ExtHostInteractive(et,Rt,Mt,kt,Ct));const Ui=et.set(i.ExtHostContext.ExtHostChatAgents2,new c.ExtHostChatAgents2(et,Ct,kt,$t)),rn=et.set(i.ExtHostContext.ExtHostChatVariables,new g.ExtHostChatVariables(et)),Bi=et.set(i.ExtHostContext.ExtHostLanguageModelTools,new se.ExtHostLanguageModelTools(et)),Vi=et.set(i.ExtHostContext.ExtHostAiRelatedInformation,new a.ExtHostRelatedInformation(et)),sn=et.set(i.ExtHostContext.ExtHostAiEmbeddingVector,new B.ExtHostAiEmbeddingVector(et)),on=et.set(i.ExtHostContext.ExtHostStatusBar,new nt.ExtHostStatusBar(et,kt.converter)),En=et.set(i.ExtHostContext.ExtHostSpeech,new Ge.ExtHostSpeech(et)),Pi=et.set(i.ExtHostContext.ExtHostEmbeddings,new G.ExtHostEmbeddings(et)),qi=Object.values(i.ExtHostContext);et.assertRegistered(qi);const bn=new d.ExtHostBulkEdits(et,Mt),Sn=new w.ExtHostClipboard(et),zi=new ve.ExtHostMessageService(et,Ct),an=new M.ExtHostDialogs(et);return t.ExtHostApiCommands.register(kt),function(Be,mi,ji){function ft(de){return(_e,Ue,mt)=>{const Dt=de(Ft=>{try{_e.call(Ue,Ft)}catch(Ri){h.onUnexpectedExternalError(new Error(`[ExtensionListenerError] Extension '${Be.identifier.value}' FAILED to handle event: ${Ri.toString()}`,{cause:Ri})),Ot.onExtensionError(Be.identifier,Ri)}});return mt?.push(Dt),Dt}}const Tt=function(){let de=!Be.isUnderDevelopment;function _e(){de||(Ct.info(`Extension '${Be.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),de=!0)}return function Ue(mt){if(Array.isArray(mt))mt.forEach(Ue);else if(typeof mt=="string")_e();else{const Dt=mt;typeof Dt.scheme>"u"&&_e(),typeof Dt.exclusive=="boolean"&&(0,tt.checkProposedApiEnabled)(Be,"documentFiltersExclusive")}return mt}}(),wn={getSession(de,_e,Ue){return typeof Ue?.forceNewSession=="object"&&Ue.forceNewSession.learnMore&&(0,tt.checkProposedApiEnabled)(Be,"authLearnMore"),Gt.getSession(Be,de,_e,Ue)},getAccounts(de){return Gt.getAccounts(de)},async hasSession(de,_e){return(0,tt.checkProposedApiEnabled)(Be,"authSession"),!!await Gt.getSession(Be,de,_e,{silent:!0})},get onDidChangeSessions(){return ft(Gt.onDidChangeSessions)},registerAuthenticationProvider(de,_e,Ue,mt){return Gt.registerAuthenticationProvider(de,_e,Ue,mt)}},Ki={registerCommand(de,_e,Ue){return kt.registerCommand(!0,de,_e,Ue,void 0,Be)},registerTextEditorCommand(de,_e,Ue){return kt.registerCommand(!0,de,(...mt)=>{const Dt=xt.getActiveTextEditor();if(!Dt){Ct.warn("Cannot execute "+de+" because there is no active text editor.");return}return Dt.edit(Ft=>{_e.apply(Ue,[Dt,Ft,...mt])}).then(Ft=>{Ft||Ct.warn("Edits from command "+de+" were not applied.")},Ft=>{Ct.warn("An error occurred while running command "+de,Ft)})},void 0,void 0,Be)},registerDiffInformationCommand:(de,_e,Ue)=>((0,tt.checkProposedApiEnabled)(Be,"diffCommand"),kt.registerCommand(!0,de,async(...mt)=>{const Dt=Mt.activeEditor(!0);if(!Dt){Ct.warn("Cannot execute "+de+" because there is no active text editor.");return}const Ft=await xt.getDiffInformation(Dt.id);_e.apply(Ue,[Ft,...mt])},void 0,void 0,Be)),executeCommand(de,..._e){return kt.executeCommand(de,..._e)},getCommands(de=!1){return kt.getCommands(de)}},Gi={get machineId(){return Pt.telemetryInfo.machineId},get sessionId(){return Pt.telemetryInfo.sessionId},get language(){return Pt.environment.appLanguage},get appName(){return Pt.environment.appName},get appRoot(){return Pt.environment.appRoot?.fsPath??""},get appHost(){return Pt.environment.appHost},get uriScheme(){return Pt.environment.appUriScheme},get clipboard(){return Sn.value},get shell(){return wt.getDefaultShell(!1)},get onDidChangeShell(){return ft(wt.onDidChangeShell)},get isTelemetryEnabled(){return Ot.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return ft(Ot.onDidChangeTelemetryEnabled)},get telemetryConfiguration(){return(0,tt.checkProposedApiEnabled)(Be,"telemetry"),Ot.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,tt.checkProposedApiEnabled)(Be,"telemetry"),ft(Ot.onDidChangeTelemetryConfiguration)},get isNewAppInstall(){return(0,ct.isNewAppInstall)(Pt.telemetryInfo.firstSessionDate)},createTelemetryLogger(de,_e){return ct.ExtHostTelemetryLogger.validateSender(de),Ot.instantiateLogger(Be,de,_e)},openExternal(de,_e){return Bt.openUri(de,{allowTunneling:!!Pt.remote.authority,allowContributedOpeners:_e?.allowContributedOpeners})},async asExternalUri(de){if(de.scheme===Pt.environment.appUriScheme)return wi.createAppUri(de);try{return await Bt.asExternalUri(de,{allowTunneling:!!Pt.remote.authority})}catch(_e){if((0,L.matchesScheme)(de,L.Schemas.http)||(0,L.matchesScheme)(de,L.Schemas.https))return de;throw _e}},get remoteName(){return(0,m.getRemoteName)(Pt.remote.authority)},get remoteAuthority(){return(0,tt.checkProposedApiEnabled)(Be,"resolvers"),Pt.remote.authority},get uiKind(){return Pt.uiKind},get logLevel(){return Ct.getLevel()},get onDidChangeLogLevel(){return ft(Ct.onDidChangeLogLevel)},get appQuality(){return(0,tt.checkProposedApiEnabled)(Be,"resolvers"),Pt.quality},get appCommit(){return(0,tt.checkProposedApiEnabled)(Be,"resolvers"),Pt.commit}};Pt.environment.extensionTestsLocationURI||Object.freeze(Gi);const Ii={createTestController(de,_e,Ue){return yi.createTestController(Be,de,_e,Ue)},createTestObserver(){return(0,tt.checkProposedApiEnabled)(Be,"testObserver"),yi.createTestObserver()},runTests(de){return(0,tt.checkProposedApiEnabled)(Be,"testObserver"),yi.runTests(de)},registerTestFollowupProvider(de){return(0,tt.checkProposedApiEnabled)(Be,"testObserver"),yi.registerTestFollowupProvider(de)},get onDidChangeTestResults(){return(0,tt.checkProposedApiEnabled)(Be,"testObserver"),ft(yi.onResultsChanged)},get testResults(){return(0,tt.checkProposedApiEnabled)(Be,"testObserver"),yi.results}},ki=Pt.remote.isRemote?X.ExtensionKind.Workspace:X.ExtensionKind.UI,_n={getExtension(de,_e){(0,tt.isProposedApiEnabled)(Be,"extensionsAny")||(_e=!1);const Ue=mi.mine.getExtensionDescription(de);if(Ue)return new W.Extension(Kt,Be.identifier,Ue,ki,!1);if(_e){const mt=mi.all.getExtensionDescription(de);if(mt)return new W.Extension(Kt,Be.identifier,mt,ki,!0)}},get all(){const de=[];for(const _e of mi.mine.getAllExtensionDescriptions())de.push(new W.Extension(Kt,Be.identifier,_e,ki,!1));return de},get allAcrossExtensionHosts(){(0,tt.checkProposedApiEnabled)(Be,"extensionsAny");const de=new T.ExtensionIdentifierSet(mi.mine.getAllExtensionDescriptions().map(Ue=>Ue.identifier)),_e=[];for(const Ue of mi.all.getAllExtensionDescriptions()){const mt=!de.has(Ue.identifier);_e.push(new W.Extension(Kt,Be.identifier,Ue,ki,mt))}return _e},get onDidChange(){return(0,tt.isProposedApiEnabled)(Be,"extensionsAny")?ft(D.Event.any(mi.mine.onDidChange,mi.all.onDidChange)):ft(mi.mine.onDidChange)}},pi={createDiagnosticCollection(de){return Ei.createDiagnosticCollection(Be.identifier,de)},get onDidChangeDiagnostics(){return ft(Ei.onDidChangeDiagnostics)},getDiagnostics:de=>Ei.getDiagnostics(de),getLanguages(){return bi.getLanguages()},setTextDocumentLanguage(de,_e){return bi.changeLanguage(de.uri,_e)},match(de,_e){const Ue=ne.LanguageSelector.from(de);let mt;return(0,C.targetsNotebooks)(Ue)&&(mt=Rt.notebookDocuments.find(Dt=>Dt.apiNotebook.getCells().find(Ft=>Ft.document===_e))?.apiNotebook),(0,C.score)(Ue,_e.uri,_e.languageId,!0,mt?.uri,mt?.notebookType)},registerCodeActionsProvider(de,_e,Ue){return De.registerCodeActionProvider(Be,Tt(de),_e,Ue)},registerDocumentPasteEditProvider(de,_e,Ue){return(0,tt.checkProposedApiEnabled)(Be,"documentPaste"),De.registerDocumentPasteEditProvider(Be,Tt(de),_e,Ue)},registerCodeLensProvider(de,_e){return De.registerCodeLensProvider(Be,Tt(de),_e)},registerDefinitionProvider(de,_e){return De.registerDefinitionProvider(Be,Tt(de),_e)},registerDeclarationProvider(de,_e){return De.registerDeclarationProvider(Be,Tt(de),_e)},registerImplementationProvider(de,_e){return De.registerImplementationProvider(Be,Tt(de),_e)},registerTypeDefinitionProvider(de,_e){return De.registerTypeDefinitionProvider(Be,Tt(de),_e)},registerHoverProvider(de,_e){return De.registerHoverProvider(Be,Tt(de),_e,Be.identifier)},registerEvaluatableExpressionProvider(de,_e){return De.registerEvaluatableExpressionProvider(Be,Tt(de),_e,Be.identifier)},registerInlineValuesProvider(de,_e){return De.registerInlineValuesProvider(Be,Tt(de),_e,Be.identifier)},registerDocumentHighlightProvider(de,_e){return De.registerDocumentHighlightProvider(Be,Tt(de),_e)},registerMultiDocumentHighlightProvider(de,_e){return De.registerMultiDocumentHighlightProvider(Be,Tt(de),_e)},registerLinkedEditingRangeProvider(de,_e){return De.registerLinkedEditingRangeProvider(Be,Tt(de),_e)},registerReferenceProvider(de,_e){return De.registerReferenceProvider(Be,Tt(de),_e)},registerRenameProvider(de,_e){return De.registerRenameProvider(Be,Tt(de),_e)},registerNewSymbolNamesProvider(de,_e){return(0,tt.checkProposedApiEnabled)(Be,"newSymbolNamesProvider"),De.registerNewSymbolNamesProvider(Be,Tt(de),_e)},registerDocumentSymbolProvider(de,_e,Ue){return De.registerDocumentSymbolProvider(Be,Tt(de),_e,Ue)},registerWorkspaceSymbolProvider(de){return De.registerWorkspaceSymbolProvider(Be,de)},registerDocumentFormattingEditProvider(de,_e){return De.registerDocumentFormattingEditProvider(Be,Tt(de),_e)},registerDocumentRangeFormattingEditProvider(de,_e){return De.registerDocumentRangeFormattingEditProvider(Be,Tt(de),_e)},registerOnTypeFormattingEditProvider(de,_e,Ue,...mt){return De.registerOnTypeFormattingEditProvider(Be,Tt(de),_e,[Ue].concat(mt))},registerDocumentSemanticTokensProvider(de,_e,Ue){return De.registerDocumentSemanticTokensProvider(Be,Tt(de),_e,Ue)},registerDocumentRangeSemanticTokensProvider(de,_e,Ue){return De.registerDocumentRangeSemanticTokensProvider(Be,Tt(de),_e,Ue)},registerSignatureHelpProvider(de,_e,Ue,...mt){return typeof Ue=="object"?De.registerSignatureHelpProvider(Be,Tt(de),_e,Ue):De.registerSignatureHelpProvider(Be,Tt(de),_e,typeof Ue>"u"?[]:[Ue,...mt])},registerCompletionItemProvider(de,_e,...Ue){return De.registerCompletionItemProvider(Be,Tt(de),_e,Ue)},registerInlineCompletionItemProvider(de,_e,Ue){return _e.handleDidShowCompletionItem&&(0,tt.checkProposedApiEnabled)(Be,"inlineCompletionsAdditions"),_e.handleDidPartiallyAcceptCompletionItem&&(0,tt.checkProposedApiEnabled)(Be,"inlineCompletionsAdditions"),Ue&&(0,tt.checkProposedApiEnabled)(Be,"inlineCompletionsAdditions"),De.registerInlineCompletionsProvider(Be,Tt(de),_e,Ue)},registerInlineEditProvider(de,_e){return(0,tt.checkProposedApiEnabled)(Be,"inlineEdit"),De.registerInlineEditProvider(Be,Tt(de),_e)},registerDocumentLinkProvider(de,_e){return De.registerDocumentLinkProvider(Be,Tt(de),_e)},registerColorProvider(de,_e){return De.registerColorProvider(Be,Tt(de),_e)},registerFoldingRangeProvider(de,_e){return De.registerFoldingRangeProvider(Be,Tt(de),_e)},registerSelectionRangeProvider(de,_e){return De.registerSelectionRangeProvider(Be,de,_e)},registerCallHierarchyProvider(de,_e){return De.registerCallHierarchyProvider(Be,de,_e)},registerTypeHierarchyProvider(de,_e){return De.registerTypeHierarchyProvider(Be,de,_e)},setLanguageConfiguration:(de,_e)=>De.setLanguageConfiguration(Be,de,_e),getTokenInformationAtPosition(de,_e){return(0,tt.checkProposedApiEnabled)(Be,"tokenInformation"),bi.tokenAtPosition(de,_e)},registerInlayHintsProvider(de,_e){return De.registerInlayHintsProvider(Be,de,_e)},createLanguageStatusItem(de,_e){return bi.createLanguageStatusItem(Be,de,_e)},registerDocumentDropEditProvider(de,_e,Ue){return De.registerDocumentOnDropEditProvider(Be,de,_e,(0,tt.isProposedApiEnabled)(Be,"documentPaste")?Ue:void 0)}},$i={get activeTextEditor(){return xt.getActiveTextEditor()},get visibleTextEditors(){return xt.getVisibleTextEditors()},get activeTerminal(){return wt.activeTerminal},get terminals(){return wt.terminals},async showTextDocument(de,_e,Ue){v.URI.isUri(de)&&de.scheme===L.Schemas.vscodeRemote&&!de.authority&&Nt.report("workspace.showTextDocument",Be,"A URI of 'vscode-remote' scheme requires an authority.");const mt=await(v.URI.isUri(de)?Promise.resolve(Xi.openTextDocument(de)):Promise.resolve(de));return xt.showTextDocument(mt,_e,Ue)},createTextEditorDecorationType(de){return xt.createTextEditorDecorationType(Be,de)},onDidChangeActiveTextEditor(de,_e,Ue){return ft(xt.onDidChangeActiveTextEditor)(de,_e,Ue)},onDidChangeVisibleTextEditors(de,_e,Ue){return ft(xt.onDidChangeVisibleTextEditors)(de,_e,Ue)},onDidChangeTextEditorSelection(de,_e,Ue){return ft(xt.onDidChangeTextEditorSelection)(de,_e,Ue)},onDidChangeTextEditorOptions(de,_e,Ue){return ft(xt.onDidChangeTextEditorOptions)(de,_e,Ue)},onDidChangeTextEditorVisibleRanges(de,_e,Ue){return ft(xt.onDidChangeTextEditorVisibleRanges)(de,_e,Ue)},onDidChangeTextEditorViewColumn(de,_e,Ue){return ft(xt.onDidChangeTextEditorViewColumn)(de,_e,Ue)},onDidCloseTerminal(de,_e,Ue){return ft(wt.onDidCloseTerminal)(de,_e,Ue)},onDidOpenTerminal(de,_e,Ue){return ft(wt.onDidOpenTerminal)(de,_e,Ue)},onDidChangeActiveTerminal(de,_e,Ue){return ft(wt.onDidChangeActiveTerminal)(de,_e,Ue)},onDidChangeTerminalDimensions(de,_e,Ue){return(0,tt.checkProposedApiEnabled)(Be,"terminalDimensions"),ft(wt.onDidChangeTerminalDimensions)(de,_e,Ue)},onDidChangeTerminalState(de,_e,Ue){return ft(wt.onDidChangeTerminalState)(de,_e,Ue)},onDidWriteTerminalData(de,_e,Ue){return(0,tt.checkProposedApiEnabled)(Be,"terminalDataWriteEvent"),ft(wt.onDidWriteTerminalData)(de,_e,Ue)},onDidExecuteTerminalCommand(de,_e,Ue){return(0,tt.checkProposedApiEnabled)(Be,"terminalExecuteCommandEvent"),ft(wt.onDidExecuteTerminalCommand)(de,_e,Ue)},onDidChangeTerminalShellIntegration(de,_e,Ue){return ft(Qt.onDidChangeTerminalShellIntegration)(de,_e,Ue)},onDidStartTerminalShellExecution(de,_e,Ue){return ft(Qt.onDidStartTerminalShellExecution)(de,_e,Ue)},onDidEndTerminalShellExecution(de,_e,Ue){return ft(Qt.onDidEndTerminalShellExecution)(de,_e,Ue)},get state(){return Bt.getState()},onDidChangeWindowState(de,_e,Ue){return ft(Bt.onDidChangeWindowState)(de,_e,Ue)},showInformationMessage(de,..._e){return zi.showMessage(Be,R.default.Info,de,_e[0],_e.slice(1))},showWarningMessage(de,..._e){return zi.showMessage(Be,R.default.Warning,de,_e[0],_e.slice(1))},showErrorMessage(de,..._e){return zi.showMessage(Be,R.default.Error,de,_e[0],_e.slice(1))},showQuickPick(de,_e,Ue){return ie.showQuickPick(Be,de,_e,Ue)},showWorkspaceFolderPick(de){return ie.showWorkspaceFolderPick(de)},showInputBox(de,_e){return ie.showInput(de,_e)},showOpenDialog(de){return an.showOpenDialog(Be,de)},showSaveDialog(de){return an.showSaveDialog(de)},createStatusBarItem(de,_e,Ue){let mt,Dt,Ft;return typeof de=="string"?(mt=de,Dt=_e,Ft=Ue):(Dt=de,Ft=_e),on.createStatusBarEntry(Be,mt,Dt,Ft)},setStatusBarMessage(de,_e){return on.setStatusBarMessage(de,_e)},withScmProgress(de){return Nt.report("window.withScmProgress",Be,"Use 'withProgress' instead."),ut.withProgress(Be,{location:X.ProgressLocation.SourceControl},(_e,Ue)=>de({report(mt){}}))},withProgress(de,_e){return ut.withProgress(Be,de,_e)},createOutputChannel(de,_e){return Mi.createOutputChannel(de,_e,Be)},createWebviewPanel(de,_e,Ue,mt){return Oi.createWebviewPanel(Be,de,_e,Ue,mt)},createWebviewTextEditorInset(de,_e,Ue,mt){return(0,tt.checkProposedApiEnabled)(Be,"editorInsets"),Di.createWebviewEditorInset(de,_e,Ue,mt,Be)},createTerminal(de,_e,Ue){return typeof de=="object"?"pty"in de?wt.createExtensionTerminal(de):wt.createTerminalFromOptions(de):wt.createTerminal(de,_e,Ue)},registerTerminalLinkProvider(de){return wt.registerLinkProvider(de)},registerTerminalProfileProvider(de,_e){return wt.registerProfileProvider(Be,de,_e)},registerTerminalQuickFixProvider(de,_e){return(0,tt.checkProposedApiEnabled)(Be,"terminalQuickFixProvider"),wt.registerTerminalQuickFixProvider(de,Be.identifier.value,_e)},registerTreeDataProvider(de,_e){return Ti.registerTreeDataProvider(de,_e,Be)},createTreeView(de,_e){return Ti.createTreeView(de,_e,Be)},registerWebviewPanelSerializer:(de,_e)=>Oi.registerWebviewPanelSerializer(Be,de,_e),registerCustomEditorProvider:(de,_e,Ue={})=>en.registerCustomEditorProvider(Be,de,_e,Ue),registerFileDecorationProvider(de){return ui.registerFileDecorationProvider(de,Be)},registerUriHandler(de){return wi.registerUriHandler(Be,de)},createQuickPick(){return ie.createQuickPick(Be)},createInputBox(){return ie.createInputBox(Be)},get activeColorTheme(){return jt.activeColorTheme},onDidChangeActiveColorTheme(de,_e,Ue){return ft(jt.onDidChangeActiveColorTheme)(de,_e,Ue)},registerWebviewViewProvider(de,_e,Ue){return Hi.registerWebviewViewProvider(Be,de,_e,Ue?.webviewOptions)},get activeNotebookEditor(){return Rt.activeNotebookEditor},onDidChangeActiveNotebookEditor(de,_e,Ue){return ft(Rt.onDidChangeActiveNotebookEditor)(de,_e,Ue)},get visibleNotebookEditors(){return Rt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return ft(Rt.onDidChangeVisibleNotebookEditors)},onDidChangeNotebookEditorSelection(de,_e,Ue){return ft(Li.onDidChangeNotebookEditorSelection)(de,_e,Ue)},onDidChangeNotebookEditorVisibleRanges(de,_e,Ue){return ft(Li.onDidChangeNotebookEditorVisibleRanges)(de,_e,Ue)},showNotebookDocument(de,_e){return Rt.showNotebookDocument(de,_e)},registerExternalUriOpener(de,_e,Ue){return(0,tt.checkProposedApiEnabled)(Be,"externalUriOpener"),tn.registerExternalUriOpener(Be.identifier,de,_e,Ue)},registerProfileContentHandler(de,_e){return(0,tt.checkProposedApiEnabled)(Be,"profileContentHandlers"),nn.registerProfileContentHandler(Be,de,_e)},registerQuickDiffProvider(de,_e,Ue,mt){return(0,tt.checkProposedApiEnabled)(Be,"quickDiffProvider"),Ke.registerQuickDiffProvider(Tt(de),_e,Ue,mt)},get tabGroups(){return ri.tabGroups},registerShareProvider(de,_e){return(0,tt.checkProposedApiEnabled)(Be,"shareProvider"),rt.registerShareProvider(Tt(de),_e)}},Xi={get rootPath(){return Nt.report("workspace.rootPath",Be,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),St.getPath()},set rootPath(de){throw new h.ReadonlyError("rootPath")},getWorkspaceFolder(de){return St.getWorkspaceFolder(de)},get workspaceFolders(){return St.getWorkspaceFolders()},get name(){return St.name},set name(de){throw new h.ReadonlyError("name")},get workspaceFile(){return St.workspaceFile},set workspaceFile(de){throw new h.ReadonlyError("workspaceFile")},updateWorkspaceFolders:(de,_e,...Ue)=>St.updateWorkspaceFolders(Be,de,_e||0,...Ue),onDidChangeWorkspaceFolders:function(de,_e,Ue){return ft(St.onDidChangeWorkspace)(de,_e,Ue)},asRelativePath:(de,_e)=>St.getRelativePath(de,_e),findFiles:(de,_e,Ue,mt)=>St.findFiles(de,_e,Ue,Be.identifier,mt),findFiles2:(de,_e,Ue)=>((0,tt.checkProposedApiEnabled)(Be,"findFiles2"),St.findFiles2(de,_e,Be.identifier,Ue)),findFiles2New:(de,_e,Ue)=>((0,tt.checkProposedApiEnabled)(Be,"findFiles2New"),St.findFiles2New(de,_e,Be.identifier,Ue)),findTextInFiles:(de,_e,Ue,mt)=>{(0,tt.checkProposedApiEnabled)(Be,"findTextInFiles");let Dt,Ft;return typeof _e=="object"?(Dt=_e,Ft=Ue):(Dt={},Ft=_e,mt=Ue),St.findTextInFiles(de,Dt||{},Ft,Be.identifier,mt)},findTextInFilesNew:(de,_e,Ue)=>((0,tt.checkProposedApiEnabled)(Be,"findTextInFilesNew"),(0,tt.checkProposedApiEnabled)(Be,"textSearchProviderNew"),St.findTextInFilesNew(de,Be.identifier,_e||{},Ue)),save:de=>St.save(de),saveAs:de=>St.saveAs(de),saveAll:de=>St.saveAll(de),applyEdit(de,_e){return bn.applyWorkspaceEdit(de,Be,_e)},createFileSystemWatcher:(de,_e,Ue,mt)=>{let Dt;return typeof _e=="boolean"?Dt={ignoreCreateEvents:!!_e,ignoreChangeEvents:!!Ue,ignoreDeleteEvents:!!mt,correlate:!1}:_e&&((0,tt.checkProposedApiEnabled)(Be,"createFileSystemWatcher"),Dt={..._e,correlate:!0}),Se.createFileSystemWatcher(St,Be,de,Dt)},get textDocuments(){return $t.getAllDocumentData().map(de=>de.document)},set textDocuments(de){throw new h.ReadonlyError("textDocuments")},openTextDocument(de){let _e;const Ue=de;if(typeof de=="string")_e=Promise.resolve(v.URI.file(de));else if(v.URI.isUri(de))_e=Promise.resolve(de);else if(!Ue||typeof Ue=="object")_e=$t.createDocumentData(Ue);else throw new Error("illegal argument - uriOrFileNameOrOptions");return _e.then(mt=>(Ct.trace(`openTextDocument from ${Be.identifier}`),mt.scheme===L.Schemas.vscodeRemote&&!mt.authority&&Nt.report("workspace.openTextDocument",Be,"A URI of 'vscode-remote' scheme requires an authority."),$t.ensureDocumentData(mt).then(Dt=>Dt.document)))},onDidOpenTextDocument:(de,_e,Ue)=>ft($t.onDidAddDocument)(de,_e,Ue),onDidCloseTextDocument:(de,_e,Ue)=>ft($t.onDidRemoveDocument)(de,_e,Ue),onDidChangeTextDocument:(de,_e,Ue)=>ft($t.onDidChangeDocument)(de,_e,Ue),onDidSaveTextDocument:(de,_e,Ue)=>ft($t.onDidSaveDocument)(de,_e,Ue),onWillSaveTextDocument:(de,_e,Ue)=>ft(Fi.getOnWillSaveTextDocumentEvent(Be))(de,_e,Ue),get notebookDocuments(){return Rt.notebookDocuments.map(de=>de.apiNotebook)},async openNotebookDocument(de,_e){let Ue;if(v.URI.isUri(de))Ue=de,await Rt.openNotebookDocument(de);else if(typeof de=="string")Ue=v.URI.revive(await Rt.createNotebookDocument({viewType:de,content:_e}));else throw new Error("Invalid arguments");return Rt.getNotebookDocument(Ue).apiNotebook},onDidSaveNotebookDocument(de,_e,Ue){return ft(_i.onDidSaveNotebookDocument)(de,_e,Ue)},onDidChangeNotebookDocument(de,_e,Ue){return ft(_i.onDidChangeNotebookDocument)(de,_e,Ue)},onWillSaveNotebookDocument(de,_e,Ue){return ft(Wi.getOnWillSaveNotebookDocumentEvent(Be))(de,_e,Ue)},get onDidOpenNotebookDocument(){return ft(Rt.onDidOpenNotebookDocument)},get onDidCloseNotebookDocument(){return ft(Rt.onDidCloseNotebookDocument)},registerNotebookSerializer(de,_e,Ue,mt){return Rt.registerNotebookSerializer(Be,de,_e,Ue,(0,tt.isProposedApiEnabled)(Be,"notebookLiveShare")?mt:void 0)},onDidChangeConfiguration:(de,_e,Ue)=>ft(ji.onDidChangeConfiguration)(de,_e,Ue),getConfiguration(de,_e){return _e=arguments.length===1?void 0:_e,ji.getConfiguration(de,_e,Be)},registerTextDocumentContentProvider(de,_e){return fi.registerTextDocumentContentProvider(de,_e)},registerTaskProvider:(de,_e)=>(Nt.report("window.registerTaskProvider",Be,"Use the corresponding function on the 'tasks' namespace instead"),Jt.registerTaskProvider(Be,de,_e)),registerFileSystemProvider(de,_e,Ue){return(0,A.combinedDisposable)(Me.registerFileSystemProvider(Be,de,_e,Ue),ii.addFileSystemProvider(de,_e,Ue))},get fs(){return ii.value},registerFileSearchProvider:(de,_e)=>((0,tt.checkProposedApiEnabled)(Be,"fileSearchProvider"),oi.registerFileSearchProviderOld(de,_e)),registerTextSearchProvider:(de,_e)=>((0,tt.checkProposedApiEnabled)(Be,"textSearchProvider"),oi.registerTextSearchProviderOld(de,_e)),registerAITextSearchProvider:(de,_e)=>((0,tt.checkProposedApiEnabled)(Be,"aiTextSearchProvider"),(0,tt.checkProposedApiEnabled)(Be,"textSearchProvider"),oi.registerAITextSearchProviderOld(de,_e)),registerFileSearchProviderNew:(de,_e)=>((0,tt.checkProposedApiEnabled)(Be,"fileSearchProviderNew"),oi.registerFileSearchProvider(de,_e)),registerTextSearchProviderNew:(de,_e)=>((0,tt.checkProposedApiEnabled)(Be,"textSearchProviderNew"),oi.registerTextSearchProvider(de,_e)),registerAITextSearchProviderNew:(de,_e)=>((0,tt.checkProposedApiEnabled)(Be,"aiTextSearchProviderNew"),(0,tt.checkProposedApiEnabled)(Be,"textSearchProviderNew"),oi.registerAITextSearchProvider(de,_e)),registerRemoteAuthorityResolver:(de,_e)=>((0,tt.checkProposedApiEnabled)(Be,"resolvers"),Kt.registerRemoteAuthorityResolver(de,_e)),registerResourceLabelFormatter:de=>((0,tt.checkProposedApiEnabled)(Be,"resolvers"),pt.$registerResourceLabelFormatter(de)),getRemoteExecServer:de=>((0,tt.checkProposedApiEnabled)(Be,"resolvers"),Kt.getRemoteExecServer(de)),onDidCreateFiles:(de,_e,Ue)=>ft(Se.onDidCreateFile)(de,_e,Ue),onDidDeleteFiles:(de,_e,Ue)=>ft(Se.onDidDeleteFile)(de,_e,Ue),onDidRenameFiles:(de,_e,Ue)=>ft(Se.onDidRenameFile)(de,_e,Ue),onWillCreateFiles:(de,_e,Ue)=>ft(Se.getOnWillCreateFileEvent(Be))(de,_e,Ue),onWillDeleteFiles:(de,_e,Ue)=>ft(Se.getOnWillDeleteFileEvent(Be))(de,_e,Ue),onWillRenameFiles:(de,_e,Ue)=>ft(Se.getOnWillRenameFileEvent(Be))(de,_e,Ue),openTunnel:de=>((0,tt.checkProposedApiEnabled)(Be,"tunnels"),Wt.openTunnel(Be,de).then(_e=>{if(!_e)throw new Error("cannot open tunnel");return _e})),get tunnels(){return(0,tt.checkProposedApiEnabled)(Be,"tunnels"),Wt.getTunnels()},onDidChangeTunnels:(de,_e,Ue)=>((0,tt.checkProposedApiEnabled)(Be,"tunnels"),ft(Wt.onDidChangeTunnels)(de,_e,Ue)),registerPortAttributesProvider:(de,_e)=>((0,tt.checkProposedApiEnabled)(Be,"portsAttributes"),Wt.registerPortsAttributesProvider(de,_e)),registerTunnelProvider:(de,_e)=>((0,tt.checkProposedApiEnabled)(Be,"tunnelFactory"),Wt.registerTunnelProvider(de,_e)),registerTimelineProvider:(de,_e)=>((0,tt.checkProposedApiEnabled)(Be,"timeline"),Ht.registerTimelineProvider(de,_e,Be.identifier,kt.converter)),get isTrusted(){return St.trusted},requestWorkspaceTrust:de=>((0,tt.checkProposedApiEnabled)(Be,"workspaceTrust"),St.requestWorkspaceTrust(de)),onDidGrantWorkspaceTrust:(de,_e,Ue)=>ft(St.onDidGrantWorkspaceTrust)(de,_e,Ue),registerEditSessionIdentityProvider:(de,_e)=>((0,tt.checkProposedApiEnabled)(Be,"editSessionIdentityProvider"),St.registerEditSessionIdentityProvider(de,_e)),onWillCreateEditSessionIdentity:(de,_e,Ue)=>((0,tt.checkProposedApiEnabled)(Be,"editSessionIdentityProvider"),ft(St.getOnWillCreateEditSessionIdentityEvent(Be))(de,_e,Ue)),registerCanonicalUriProvider:(de,_e)=>((0,tt.checkProposedApiEnabled)(Be,"canonicalUriProvider"),St.registerCanonicalUriProvider(de,_e)),getCanonicalUri:(de,_e,Ue)=>((0,tt.checkProposedApiEnabled)(Be,"canonicalUriProvider"),St.provideCanonicalUri(de,_e,Ue))},ln={get inputBox(){return Nt.report("scm.inputBox",Be,"Use 'SourceControl.inputBox' instead"),Oe.getLastInputBox(Be)},createSourceControl(de,_e,Ue){return Oe.createSourceControl(Be,de,_e,Ue)}},cn={createCommentController(de,_e){return je.createCommentController(Be,de,_e)}},un={get activeDebugSession(){return yt.activeDebugSession},get activeDebugConsole(){return yt.activeDebugConsole},get breakpoints(){return yt.breakpoints},get activeStackItem(){return yt.activeStackItem},registerDebugVisualizationProvider(de,_e){return(0,tt.checkProposedApiEnabled)(Be,"debugVisualization"),yt.registerDebugVisualizationProvider(Be,de,_e)},registerDebugVisualizationTreeProvider(de,_e){return(0,tt.checkProposedApiEnabled)(Be,"debugVisualization"),yt.registerDebugVisualizationTree(Be,de,_e)},onDidStartDebugSession(de,_e,Ue){return ft(yt.onDidStartDebugSession)(de,_e,Ue)},onDidTerminateDebugSession(de,_e,Ue){return ft(yt.onDidTerminateDebugSession)(de,_e,Ue)},onDidChangeActiveDebugSession(de,_e,Ue){return ft(yt.onDidChangeActiveDebugSession)(de,_e,Ue)},onDidReceiveDebugSessionCustomEvent(de,_e,Ue){return ft(yt.onDidReceiveDebugSessionCustomEvent)(de,_e,Ue)},onDidChangeBreakpoints(de,_e,Ue){return ft(yt.onDidChangeBreakpoints)(de,_e,Ue)},onDidChangeActiveStackItem(de,_e,Ue){return ft(yt.onDidChangeActiveStackItem)(de,_e,Ue)},registerDebugConfigurationProvider(de,_e,Ue){return yt.registerDebugConfigurationProvider(de,_e,Ue||qt.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(de,_e){return yt.registerDebugAdapterDescriptorFactory(Be,de,_e)},registerDebugAdapterTrackerFactory(de,_e){return yt.registerDebugAdapterTrackerFactory(de,_e)},startDebugging(de,_e,Ue){return!Ue||typeof Ue=="object"&&"configuration"in Ue?yt.startDebugging(de,_e,{parentSession:Ue}):yt.startDebugging(de,_e,Ue||{})},stopDebugging(de){return yt.stopDebugging(de)},addBreakpoints(de){return yt.addBreakpoints(de)},removeBreakpoints(de){return yt.removeBreakpoints(de)},asDebugSourceUri(de,_e){return yt.asDebugSourceUri(de,_e)}},yn={registerTaskProvider:(de,_e)=>Jt.registerTaskProvider(Be,de,_e),fetchTasks:de=>Jt.fetchTasks(de),executeTask:de=>Jt.executeTask(Be,de),get taskExecutions(){return Jt.taskExecutions},onDidStartTask:(de,_e,Ue)=>ft(Jt.onDidStartTask)(de,_e,Ue),onDidEndTask:(de,_e,Ue)=>ft(Jt.onDidEndTask)(de,_e,Ue),onDidStartTaskProcess:(de,_e,Ue)=>ft(Jt.onDidStartTaskProcess)(de,_e,Ue),onDidEndTaskProcess:(de,_e,Ue)=>ft(Jt.onDidEndTaskProcess)(de,_e,Ue)},dn={createNotebookController(de,_e,Ue,mt,Dt){return gi.createNotebookController(Be,de,_e,Ue,mt,(0,tt.isProposedApiEnabled)(Be,"notebookMessaging")?Dt:void 0)},registerNotebookCellStatusBarItemProvider:(de,_e)=>Rt.registerNotebookCellStatusBarItemProvider(Be,de,_e),createRendererMessaging(de){return xi.createRendererMessaging(Be,de)},createNotebookControllerDetectionTask(de){return(0,tt.checkProposedApiEnabled)(Be,"notebookKernelSource"),gi.createNotebookControllerDetectionTask(Be,de)},registerKernelSourceActionProvider(de,_e){return(0,tt.checkProposedApiEnabled)(Be,"notebookKernelSource"),gi.registerKernelSourceActionProvider(Be,de,_e)},onDidChangeNotebookCellExecutionState(de,_e,Ue){return(0,tt.checkProposedApiEnabled)(Be,"notebookCellExecutionState"),ft(gi.onDidChangeNotebookCellExecutionState)(de,_e,Ue)}},hn={t(...de){if(typeof de[0]=="string"){const _e=de.shift(),Ue=!de||typeof de[0]!="object"?de:de[0];return hi.getMessage(Be.identifier.value,{message:_e,args:Ue})}return hi.getMessage(Be.identifier.value,de[0])},get bundle(){return hi.getBundle(Be.identifier.value)},get uri(){return hi.getBundleUri(Be.identifier.value)}},In={transferActiveChat(de){return(0,tt.checkProposedApiEnabled)(Be,"interactive"),Ui.transferActiveChat(de)}},Cn={getRelatedInformation(de,_e){return(0,tt.checkProposedApiEnabled)(Be,"aiRelatedInformation"),Vi.getRelatedInformation(Be,de,_e)},registerRelatedInformationProvider(de,_e){return(0,tt.checkProposedApiEnabled)(Be,"aiRelatedInformation"),Vi.registerRelatedInformationProvider(Be,de,_e)},registerEmbeddingVectorProvider(de,_e){return(0,tt.checkProposedApiEnabled)(Be,"aiRelatedInformation"),sn.registerEmbeddingVectorProvider(Be,de,_e)}},fn={registerChatResponseProvider(de,_e,Ue){return(0,tt.checkProposedApiEnabled)(Be,"chatProvider"),Xt.registerLanguageModel(Be,de,_e,Ue)},registerChatVariableResolver(de,_e,Ue,mt,Dt,Ft,Ri,Yi){return(0,tt.checkProposedApiEnabled)(Be,"chatVariableResolver"),rn.registerVariableResolver(Be,de,_e,Ue,mt,Dt,Ft,Ri,Yi?.id)},registerMappedEditsProvider(de,_e){return(0,tt.checkProposedApiEnabled)(Be,"mappedEditsProvider"),De.registerMappedEditsProvider(Be,de,_e)},createChatParticipant(de,_e){return Ui.createChatAgent(Be,de,_e)},createDynamicChatParticipant(de,_e,Ue){return(0,tt.checkProposedApiEnabled)(Be,"chatParticipantPrivate"),Ui.createDynamicChatAgent(Be,de,_e,Ue)},registerChatParticipantDetectionProvider(de){return(0,tt.checkProposedApiEnabled)(Be,"chatParticipantAdditions"),Ui.registerChatParticipantDetectionProvider(de)}},Qi={selectChatModels:de=>Xt.selectLanguageModels(Be,de??{}),onDidChangeChatModels:(de,_e,Ue)=>Xt.onDidChangeProviders(de,_e,Ue),registerChatModelProvider:(de,_e,Ue)=>((0,tt.checkProposedApiEnabled)(Be,"chatProvider"),Xt.registerLanguageModel(Be,de,_e,Ue)),get embeddingModels(){return(0,tt.checkProposedApiEnabled)(Be,"embeddings"),Pi.embeddingsModels},onDidChangeEmbeddingModels:(de,_e,Ue)=>((0,tt.checkProposedApiEnabled)(Be,"embeddings"),Pi.onDidChange(de,_e,Ue)),registerEmbeddingsProvider(de,_e){return(0,tt.checkProposedApiEnabled)(Be,"embeddings"),Pi.registerEmbeddingsProvider(Be,de,_e)},async computeEmbeddings(de,_e,Ue){return(0,tt.checkProposedApiEnabled)(Be,"embeddings"),Pi.computeEmbeddings(de,_e,Ue)},registerTool(de,_e){return(0,tt.checkProposedApiEnabled)(Be,"lmTools"),Bi.registerTool(Be,de,_e)},invokeTool(de,_e,Ue){return(0,tt.checkProposedApiEnabled)(Be,"lmTools"),Bi.invokeTool(de,_e,Ue)},get tools(){return(0,tt.checkProposedApiEnabled)(Be,"lmTools"),Bi.tools}},gn={registerSpeechProvider(de,_e){return(0,tt.checkProposedApiEnabled)(Be,"speech"),En.registerProvider(Be.identifier,de,_e)}};return{version:Pt.version,ai:Cn,authentication:wn,commands:Ki,comments:cn,chat:fn,debug:un,env:Gi,extensions:_n,interactive:In,l10n:hn,languages:pi,lm:Qi,notebooks:dn,scm:ln,speech:gn,tasks:yn,tests:Ii,window:$i,workspace:Xi,Breakpoint:X.Breakpoint,TerminalOutputAnchor:X.TerminalOutputAnchor,ChatResultFeedbackKind:X.ChatResultFeedbackKind,ChatVariableLevel:X.ChatVariableLevel,ChatCompletionItem:X.ChatCompletionItem,CallHierarchyIncomingCall:X.CallHierarchyIncomingCall,CallHierarchyItem:X.CallHierarchyItem,CallHierarchyOutgoingCall:X.CallHierarchyOutgoingCall,CancellationError:h.CancellationError,CancellationTokenSource:s.CancellationTokenSource,CandidatePortSource:i.CandidatePortSource,CodeAction:X.CodeAction,CodeActionKind:X.CodeActionKind,CodeActionTriggerKind:X.CodeActionTriggerKind,CodeLens:X.CodeLens,Color:X.Color,ColorInformation:X.ColorInformation,ColorPresentation:X.ColorPresentation,ColorThemeKind:X.ColorThemeKind,CommentMode:X.CommentMode,CommentState:X.CommentState,CommentThreadCollapsibleState:X.CommentThreadCollapsibleState,CommentThreadState:X.CommentThreadState,CommentThreadApplicability:X.CommentThreadApplicability,CommentThreadFocus:X.CommentThreadFocus,CompletionItem:X.CompletionItem,CompletionItemKind:X.CompletionItemKind,CompletionItemTag:X.CompletionItemTag,CompletionList:X.CompletionList,CompletionTriggerKind:X.CompletionTriggerKind,ConfigurationTarget:X.ConfigurationTarget,CustomExecution:X.CustomExecution,DebugAdapterExecutable:X.DebugAdapterExecutable,DebugAdapterInlineImplementation:X.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:X.DebugAdapterNamedPipeServer,DebugAdapterServer:X.DebugAdapterServer,DebugConfigurationProviderTriggerKind:qt.DebugConfigurationProviderTriggerKind,DebugConsoleMode:X.DebugConsoleMode,DebugVisualization:X.DebugVisualization,DecorationRangeBehavior:X.DecorationRangeBehavior,Diagnostic:X.Diagnostic,DiagnosticRelatedInformation:X.DiagnosticRelatedInformation,DiagnosticSeverity:X.DiagnosticSeverity,DiagnosticTag:X.DiagnosticTag,Disposable:X.Disposable,DocumentHighlight:X.DocumentHighlight,DocumentHighlightKind:X.DocumentHighlightKind,MultiDocumentHighlight:X.MultiDocumentHighlight,DocumentLink:X.DocumentLink,DocumentSymbol:X.DocumentSymbol,EndOfLine:X.EndOfLine,EnvironmentVariableMutatorType:X.EnvironmentVariableMutatorType,EvaluatableExpression:X.EvaluatableExpression,InlineValueText:X.InlineValueText,InlineValueVariableLookup:X.InlineValueVariableLookup,InlineValueEvaluatableExpression:X.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:X.InlineCompletionTriggerKind,EventEmitter:D.Emitter,ExtensionKind:X.ExtensionKind,ExtensionMode:X.ExtensionMode,ExternalUriOpenerPriority:X.ExternalUriOpenerPriority,FileChangeType:X.FileChangeType,FileDecoration:X.FileDecoration,FileDecoration2:X.FileDecoration,FileSystemError:X.FileSystemError,FileType:S.FileType,FilePermission:S.FilePermission,FoldingRange:X.FoldingRange,FoldingRangeKind:X.FoldingRangeKind,FunctionBreakpoint:X.FunctionBreakpoint,InlineCompletionItem:X.InlineSuggestion,InlineCompletionList:X.InlineSuggestionList,Hover:X.Hover,VerboseHover:X.VerboseHover,HoverVerbosityAction:X.HoverVerbosityAction,IndentAction:_.IndentAction,Location:X.Location,MarkdownString:X.MarkdownString,OverviewRulerLane:f.OverviewRulerLane,ParameterInformation:X.ParameterInformation,PortAutoForwardAction:X.PortAutoForwardAction,Position:X.Position,ProcessExecution:X.ProcessExecution,ProgressLocation:X.ProgressLocation,QuickInputButtonLocation:X.QuickInputButtonLocation,QuickInputButtons:X.QuickInputButtons,Range:X.Range,RelativePattern:X.RelativePattern,Selection:X.Selection,SelectionRange:X.SelectionRange,SemanticTokens:X.SemanticTokens,SemanticTokensBuilder:X.SemanticTokensBuilder,SemanticTokensEdit:X.SemanticTokensEdit,SemanticTokensEdits:X.SemanticTokensEdits,SemanticTokensLegend:X.SemanticTokensLegend,ShellExecution:X.ShellExecution,ShellQuoting:X.ShellQuoting,SignatureHelp:X.SignatureHelp,SignatureHelpTriggerKind:X.SignatureHelpTriggerKind,SignatureInformation:X.SignatureInformation,SnippetString:X.SnippetString,SourceBreakpoint:X.SourceBreakpoint,StandardTokenType:X.StandardTokenType,StatusBarAlignment:X.StatusBarAlignment,SymbolInformation:X.SymbolInformation,SymbolKind:X.SymbolKind,SymbolTag:X.SymbolTag,Task:X.Task,TaskGroup:X.TaskGroup,TaskPanelKind:X.TaskPanelKind,TaskRevealKind:X.TaskRevealKind,TaskScope:X.TaskScope,TerminalLink:X.TerminalLink,TerminalQuickFixTerminalCommand:X.TerminalQuickFixCommand,TerminalQuickFixOpener:X.TerminalQuickFixOpener,TerminalLocation:X.TerminalLocation,TerminalProfile:X.TerminalProfile,TerminalExitReason:X.TerminalExitReason,TerminalShellExecutionCommandLineConfidence:X.TerminalShellExecutionCommandLineConfidence,TextDocumentSaveReason:X.TextDocumentSaveReason,TextEdit:X.TextEdit,SnippetTextEdit:X.SnippetTextEdit,TextEditorCursorStyle:l.TextEditorCursorStyle,TextEditorLineNumbersStyle:X.TextEditorLineNumbersStyle,TextEditorRevealType:X.TextEditorRevealType,TextEditorSelectionChangeKind:X.TextEditorSelectionChangeKind,SyntaxTokenType:X.SyntaxTokenType,TextDocumentChangeReason:X.TextDocumentChangeReason,ThemeColor:X.ThemeColor,ThemeIcon:X.ThemeIcon,TreeItem:X.TreeItem,TreeItemCheckboxState:X.TreeItemCheckboxState,TreeItemCollapsibleState:X.TreeItemCollapsibleState,TypeHierarchyItem:X.TypeHierarchyItem,UIKind:ei.UIKind,Uri:v.URI,ViewColumn:X.ViewColumn,WorkspaceEdit:X.WorkspaceEdit,DocumentPasteTriggerKind:X.DocumentPasteTriggerKind,DocumentDropEdit:X.DocumentDropEdit,DocumentDropOrPasteEditKind:X.DocumentDropOrPasteEditKind,DocumentPasteEdit:X.DocumentPasteEdit,InlayHint:X.InlayHint,InlayHintLabelPart:X.InlayHintLabelPart,InlayHintKind:X.InlayHintKind,RemoteAuthorityResolverError:X.RemoteAuthorityResolverError,ResolvedAuthority:X.ResolvedAuthority,ManagedResolvedAuthority:X.ManagedResolvedAuthority,SourceControlInputBoxValidationType:X.SourceControlInputBoxValidationType,ExtensionRuntime:X.ExtensionRuntime,TimelineItem:X.TimelineItem,NotebookRange:X.NotebookRange,NotebookCellKind:X.NotebookCellKind,NotebookCellExecutionState:X.NotebookCellExecutionState,NotebookCellData:X.NotebookCellData,NotebookData:X.NotebookData,NotebookRendererScript:X.NotebookRendererScript,NotebookCellStatusBarAlignment:X.NotebookCellStatusBarAlignment,NotebookEditorRevealType:X.NotebookEditorRevealType,NotebookCellOutput:X.NotebookCellOutput,NotebookCellOutputItem:X.NotebookCellOutputItem,NotebookCellStatusBarItem:X.NotebookCellStatusBarItem,NotebookControllerAffinity:X.NotebookControllerAffinity,NotebookControllerAffinity2:X.NotebookControllerAffinity2,NotebookEdit:X.NotebookEdit,NotebookKernelSourceAction:X.NotebookKernelSourceAction,NotebookVariablesRequestKind:X.NotebookVariablesRequestKind,PortAttributes:X.PortAttributes,LinkedEditingRanges:X.LinkedEditingRanges,TestResultState:X.TestResultState,TestRunRequest:X.TestRunRequest,TestMessage:X.TestMessage,TestMessageStackFrame:X.TestMessageStackFrame,TestTag:X.TestTag,TestRunProfileKind:X.TestRunProfileKind,TextSearchCompleteMessageType:Lt.TextSearchCompleteMessageType,DataTransfer:X.DataTransfer,DataTransferItem:X.DataTransferItem,TestCoverageCount:X.TestCoverageCount,FileCoverage:X.FileCoverage,FileCoverage2:X.FileCoverage,StatementCoverage:X.StatementCoverage,BranchCoverage:X.BranchCoverage,DeclarationCoverage:X.DeclarationCoverage,WorkspaceTrustState:X.WorkspaceTrustState,LanguageStatusSeverity:X.LanguageStatusSeverity,QuickPickItemKind:X.QuickPickItemKind,InputBoxValidationSeverity:X.InputBoxValidationSeverity,TabInputText:X.TextTabInput,TabInputTextDiff:X.TextDiffTabInput,TabInputTextMerge:X.TextMergeTabInput,TabInputCustom:X.CustomEditorTabInput,TabInputNotebook:X.NotebookEditorTabInput,TabInputNotebookDiff:X.NotebookDiffEditorTabInput,TabInputWebview:X.WebviewEditorTabInput,TabInputTerminal:X.TerminalEditorTabInput,TabInputInteractiveWindow:X.InteractiveWindowInput,TabInputChat:X.ChatEditorTabInput,TabInputTextMultiDiff:X.TextMultiDiffTabInput,TelemetryTrustedValue:p.TelemetryTrustedValue,LogLevel:o.LogLevel,EditSessionIdentityMatch:u.EditSessionIdentityMatch,InteractiveSessionVoteDirection:X.InteractiveSessionVoteDirection,ChatCopyKind:X.ChatCopyKind,InteractiveEditorResponseFeedbackKind:X.InteractiveEditorResponseFeedbackKind,DebugStackFrame:X.DebugStackFrame,DebugThread:X.DebugThread,RelatedInformationType:X.RelatedInformationType,SpeechToTextStatus:X.SpeechToTextStatus,TextToSpeechStatus:X.TextToSpeechStatus,PartialAcceptTriggerKind:X.PartialAcceptTriggerKind,KeywordRecognitionStatus:X.KeywordRecognitionStatus,ChatResponseMarkdownPart:X.ChatResponseMarkdownPart,ChatResponseFileTreePart:X.ChatResponseFileTreePart,ChatResponseAnchorPart:X.ChatResponseAnchorPart,ChatResponseProgressPart:X.ChatResponseProgressPart,ChatResponseProgressPart2:X.ChatResponseProgressPart2,ChatResponseReferencePart:X.ChatResponseReferencePart,ChatResponseReferencePart2:X.ChatResponseReferencePart,ChatResponseCodeCitationPart:X.ChatResponseCodeCitationPart,ChatResponseWarningPart:X.ChatResponseWarningPart,ChatResponseTextEditPart:X.ChatResponseTextEditPart,ChatResponseMarkdownWithVulnerabilitiesPart:X.ChatResponseMarkdownWithVulnerabilitiesPart,ChatResponseCommandButtonPart:X.ChatResponseCommandButtonPart,ChatResponseDetectedParticipantPart:X.ChatResponseDetectedParticipantPart,ChatResponseConfirmationPart:X.ChatResponseConfirmationPart,ChatResponseMovePart:X.ChatResponseMovePart,ChatResponseReferencePartStatusKind:X.ChatResponseReferencePartStatusKind,ChatRequestTurn:X.ChatRequestTurn,ChatResponseTurn:X.ChatResponseTurn,ChatLocation:X.ChatLocation,ChatRequestEditorData:X.ChatRequestEditorData,ChatRequestNotebookData:X.ChatRequestNotebookData,LanguageModelChatMessageRole:X.LanguageModelChatMessageRole,LanguageModelChatMessage:X.LanguageModelChatMessage,LanguageModelChatMessageToolResultPart:X.LanguageModelToolResultPart,LanguageModelChatResponseTextPart:X.LanguageModelTextPart,LanguageModelChatResponseToolCallPart:X.LanguageModelToolCallPart,LanguageModelError:X.LanguageModelError,NewSymbolName:X.NewSymbolName,NewSymbolNameTag:X.NewSymbolNameTag,NewSymbolNameTriggerKind:X.NewSymbolNameTriggerKind,InlineEdit:X.InlineEdit,InlineEditTriggerKind:X.InlineEditTriggerKind,ExcludeSettingOptions:Lt.ExcludeSettingOptions,TextSearchContextNew:Lt.TextSearchContextNew,TextSearchMatchNew:Lt.TextSearchMatchNew,TextSearchCompleteMessageTypeNew:Lt.TextSearchCompleteMessageType}}}}),define(Pe[347],ke([1,0,89,174,49,168,42,35,65,48,100,101,102,125,78,96,167,77,64,124,95,79,166,11,66,122,123,127,128,172,99]),function(ge,e,s,h,D,A,L,R,v,l,C,_,f,T,S,o,m,p,u,i,a,t,n,r,d,c,g,w,y,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,s.registerSingleton)(c.IExtHostLocalizationService,c.ExtHostLocalizationService,s.InstantiationType.Delayed),(0,s.registerSingleton)(r.ILoggerService,n.ExtHostLoggerService,s.InstantiationType.Delayed),(0,s.registerSingleton)(o.IExtHostApiDeprecationService,o.ExtHostApiDeprecationService,s.InstantiationType.Delayed),(0,s.registerSingleton)(R.IExtHostCommands,R.ExtHostCommands,s.InstantiationType.Eager),(0,s.registerSingleton)(w.IExtHostAuthentication,w.ExtHostAuthentication,s.InstantiationType.Eager),(0,s.registerSingleton)(y.IExtHostLanguageModels,y.ExtHostLanguageModels,s.InstantiationType.Eager),(0,s.registerSingleton)(L.IExtHostConfiguration,L.ExtHostConfiguration,s.InstantiationType.Eager),(0,s.registerSingleton)(p.IExtHostConsumerFileSystem,p.ExtHostConsumerFileSystem,s.InstantiationType.Eager),(0,s.registerSingleton)(P.IExtHostTesting,P.ExtHostTesting,s.InstantiationType.Eager),(0,s.registerSingleton)(_.IExtHostDebugService,_.WorkerExtHostDebugService,s.InstantiationType.Eager),(0,s.registerSingleton)(A.IExtHostDecorations,A.ExtHostDecorations,s.InstantiationType.Eager),(0,s.registerSingleton)(v.IExtHostDocumentsAndEditors,v.ExtHostDocumentsAndEditors,s.InstantiationType.Eager),(0,s.registerSingleton)(g.IExtHostManagedSockets,g.ExtHostManagedSockets,s.InstantiationType.Eager),(0,s.registerSingleton)(u.IExtHostFileSystemInfo,u.ExtHostFileSystemInfo,s.InstantiationType.Eager),(0,s.registerSingleton)(h.IExtHostOutputService,h.ExtHostOutputService,s.InstantiationType.Delayed),(0,s.registerSingleton)(f.IExtHostSearch,f.ExtHostSearch,s.InstantiationType.Eager),(0,s.registerSingleton)(T.IExtHostStorage,T.ExtHostStorage,s.InstantiationType.Eager),(0,s.registerSingleton)(C.IExtHostTask,C.WorkerExtHostTask,s.InstantiationType.Eager),(0,s.registerSingleton)(l.IExtHostTerminalService,l.WorkerExtHostTerminalService,s.InstantiationType.Eager),(0,s.registerSingleton)(I.IExtHostTerminalShellIntegration,I.ExtHostTerminalShellIntegration,s.InstantiationType.Eager),(0,s.registerSingleton)(S.IExtHostTunnelService,S.ExtHostTunnelService,s.InstantiationType.Eager),(0,s.registerSingleton)(m.IExtHostWindow,m.ExtHostWindow,s.InstantiationType.Eager),(0,s.registerSingleton)(D.IExtHostWorkspace,D.ExtHostWorkspace,s.InstantiationType.Eager),(0,s.registerSingleton)(i.IExtHostSecretState,i.ExtHostSecretState,s.InstantiationType.Eager),(0,s.registerSingleton)(a.IExtHostTelemetry,a.ExtHostTelemetry,s.InstantiationType.Eager),(0,s.registerSingleton)(t.IExtHostEditorTabs,t.ExtHostEditorTabs,s.InstantiationType.Eager),(0,s.registerSingleton)(d.IExtHostVariableResolverProvider,d.ExtHostVariableResolverProviderService,s.InstantiationType.Eager)}),define(Pe[130],ke([1,0,11,32,59]),function(ge,e,s,h,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannel=void 0,e.anchorGlob=A,e.rangeToSearchRange=L,e.searchRangeToRange=R,D=We(D);function A(l){return l.startsWith("**")||l.startsWith("/")?l:`/${l}`}function L(l){return new h.SearchRange(l.start.line,l.start.character,l.end.line,l.end.character)}function R(l){return new D.Range(l.startLineNumber,l.startColumn,l.endLineNumber,l.endColumn)}let v=class{constructor(C,_){this.prefix=C,this.logService=_}appendLine(C){this.logService.debug(`${this.prefix}#search`,C)}};e.OutputChannel=v,e.OutputChannel=v=Qe([$e(1,s.ILogService)],v)}),define(Pe[348],ke([1,0,58,16,83,33,10,13,130,349]),function(ge,e,s,h,D,A,L,R,v,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.spawnRipgrepCmd=_,e.getAbsoluteGlob=m,e.fixDriveC=u,s=We(s),h=We(h),A=We(A),R=We(R);const C=l.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function _(i,a,t,n,r){const d=f(i,a,t,n,r),c=a.folder.fsPath;return{cmd:s.spawn(C,d.args,{cwd:c}),rgDiskPath:C,siblingClauses:d.siblingClauses,rgArgs:d,cwd:c}}function f(i,a,t,n,r){const d=["--files","--hidden","--case-sensitive","--no-require-git"];S([a],t,!1).forEach(g=>{const w=(0,v.anchorGlob)(g);if(d.push("-g",w),L.isMacintosh){const y=(0,D.normalizeNFD)(w);y!==w&&d.push("-g",y)}});const c=T([a],n,void 0,!1);return c.globArgs.forEach(g=>{const w=`!${(0,v.anchorGlob)(g)}`;if(d.push("-g",w),L.isMacintosh){const y=(0,D.normalizeNFD)(w);y!==w&&d.push("-g",y)}}),a.disregardIgnoreFiles!==!1?d.push("--no-ignore"):a.disregardParentIgnoreFiles!==!1&&d.push("--no-ignore-parent"),a.ignoreSymlinks||d.push("--follow"),i.exists&&d.push("--quiet"),r&&d.push("--threads",`${r}`),d.push("--no-config"),a.disregardGlobalIgnoreFiles&&d.push("--no-ignore-global"),{args:d,siblingClauses:c.siblingClauses}}function T(i,a,t,n=!0){const r=[];let d={};return i.forEach(c=>{const g=Object.assign({},c.excludePattern||{},a||{}),w=o(g,n?c.folder.fsPath:void 0,t);r.push(...w.globArgs),w.siblingClauses&&(d=Object.assign(d,w.siblingClauses))}),{globArgs:r,siblingClauses:d}}function S(i,a,t=!0){const n=[];return i.forEach(r=>{const d=Object.assign({},a||{},r.includePattern||{}),c=o(d,t?r.folder.fsPath:void 0);n.push(...c.globArgs)}),n}function o(i,a,t){const n=[],r={};return Object.keys(i).forEach(d=>{if(t&&t.has(d)||!d)return;const c=i[d];d=p(a?m(a,d):d),d.startsWith("\\\\")?d="\\\\"+d.substr(2).replace(/\\/g,"/"):d=d.replace(/\\/g,"/"),typeof c=="boolean"&&c?(d.startsWith("\\\\")&&(d+="**"),n.push(u(d))):c&&c.when&&(r[d]=c)}),{globArgs:n,siblingClauses:r}}function m(i,a){return h.isAbsolute(a)?a:h.join(i,a)}function p(i){return i=R.rtrim(i,"\\"),R.rtrim(i,"/")}function u(i){return A.getRoot(i).toLowerCase()==="c:/"?i.replace(/^c:[/\\]/i,"/"):i}}),define(Pe[350],ke([1,0,58,45,16,351,18,52,39,83,33,10,43,13,17,34,32,348,143]),function(ge,e,s,h,D,A,L,R,v,l,C,_,f,T,S,o,m,p,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Engine=e.FileWalker=void 0,s=We(s),h=We(h),D=We(D),L=We(L),v=We(v),l=We(l),_=We(_),T=We(T),S=We(S);const i=new Set;process.on("exit",()=>{i.forEach(d=>d())});class a{constructor(c){this.normalizedFilePatternLowercase=null,this.maxFilesize=null,this.isCanceled=!1,this.fileWalkSW=null,this.cmdSW=null,this.cmdResultCount=0,this.config=c,this.filePattern=c.filePattern||"",this.includePattern=c.includePattern&&v.parse(c.includePattern),this.maxResults=c.maxResults||null,this.exists=!!c.exists,this.walkedPaths=Object.create(null),this.resultCount=0,this.isLimitHit=!1,this.directoriesWalked=0,this.filesWalked=0,this.errors=[],this.filePattern&&(this.normalizedFilePatternLowercase=c.shouldGlobMatchFilePattern?null:(0,u.prepareQuery)(this.filePattern).normalizedLowercase),this.globalExcludePattern=c.excludePattern&&v.parse(c.excludePattern),this.folderExcludePatterns=new Map,c.folderQueries.forEach(g=>{const w={};g.excludePattern?.forEach(I=>{Object.assign(w,I.pattern||{},this.config.excludePattern||{})}),g.excludePattern?.length||Object.assign(w,this.config.excludePattern||{});const y=g.folder.fsPath;c.folderQueries.map(I=>I.folder.fsPath).filter(I=>I!==y).forEach(I=>{(0,C.isEqualOrParent)(I,y)&&(w[D.relative(y,I)]=!0)}),this.folderExcludePatterns.set(y,new n(w,y))})}cancel(){this.isCanceled=!0,i.forEach(c=>c())}walk(c,g,w,y,I,P){if(this.fileWalkSW=f.StopWatch.create(!1),this.isCanceled)return P(null,this.isLimitHit);g.forEach(k=>{const b=D.basename(k.fsPath);this.globalExcludePattern&&this.globalExcludePattern(k.fsPath,b)||this.matchFile(y,{relativePath:k.fsPath,searchPath:void 0})}),this.cmdSW=f.StopWatch.create(!1),this.parallel(c,(k,b)=>{this.call(this.cmdTraversal,this,k,w,y,I,E=>{if(E){const N=(0,R.toErrorMessage)(E);console.error(N),this.errors.push(N),b(E,void 0)}else b(null,void 0)})},(k,b)=>{this.fileWalkSW.stop();const E=k?L.coalesce(k)[0]:null;P(E,this.isLimitHit)})}parallel(c,g,w){const y=new Array(c.length),I=new Array(c.length);let P=!1,k=0;if(c.length===0)return w(null,[]);c.forEach((b,E)=>{g(b,(N,O)=>{if(N?(P=!0,y[E]=null,I[E]=N):(y[E]=O,I[E]=null),++k===c.length)return w(P?I:null,y)})})}call(c,g,...w){try{c.apply(g,w)}catch(y){w[w.length-1](y)}}cmdTraversal(c,g,w,y,I){const P=c.folder.fsPath,k=_.isMacintosh,b=()=>U&&U.kill();i.add(b);let E=$=>{i.delete(b),E=()=>{},I($)},N="";const O=this.initDirectoryTree(),M=(0,p.spawnRipgrepCmd)(this.config,c,this.config.includePattern,this.folderExcludePatterns.get(c.folder.fsPath).expression,g),U=M.cmd,H=!Object.keys(M.siblingClauses).length,F=M.rgArgs.args.map($=>$.match(/^-/)?$:`'${$}'`).join(" ");let x=`${M.rgDiskPath} ${F}
 - cwd: ${M.cwd}`;M.rgArgs.siblingClauses&&(x+=`
 - Sibling clauses: ${JSON.stringify(M.rgArgs.siblingClauses)}`),y({message:x}),this.cmdResultCount=0,this.collectStdout(U,"utf8",y,($,G,B)=>{if($){E($);return}if(this.isLimitHit){E();return}const Z=(N+(k?l.normalizeNFC(G||""):G)).split(`
`);if(B){const J=Z.length;Z[J-1]=Z[J-1].trim(),Z[J-1]||Z.pop()}else N=Z.pop()||"";if(Z.length&&Z[0].indexOf(`
`)!==-1){E(new Error("Splitting up files failed"));return}if(this.cmdResultCount+=Z.length,H){for(const J of Z)if(this.matchFile(w,{base:P,relativePath:J,searchPath:this.getSearchPath(c,J)}),this.isLimitHit){b();break}(B||this.isLimitHit)&&E();return}this.addDirectoryEntries(c,O,P,Z,w),B&&(this.matchDirectoryTree(O,P,w),E())})}spawnFindCmd(c){const g=this.folderExcludePatterns.get(c.folder.fsPath),w=g.getBasenameTerms(),y=g.getPathTerms(),I=["-L","."];if(w.length||y.length){I.push("-not","(","(");for(const P of w)I.push("-name",P),I.push("-o");for(const P of y)I.push("-path",P),I.push("-o");I.pop(),I.push(")","-prune",")")}return I.push("-type","f"),s.spawn("find",I,{cwd:c.folder.fsPath})}readStdout(c,g,w){let y="";this.collectStdout(c,g,()=>{},(I,P,k)=>{if(I){w(I);return}y+=P,k&&w(null,y)})}collectStdout(c,g,w,y){let I=(b,E,N)=>{(b||N)&&(I=()=>{},this.cmdSW?.stop()),y(b,E,N)},P=!1;c.stdout?(this.forwardData(c.stdout,g,I),c.stdout.once("data",()=>P=!0)):w({message:"stdout is null"});let k;c.stderr?k=this.collectData(c.stderr):w({message:"stderr is null"}),c.on("error",b=>{I(b)}),c.on("close",b=>{let E;!P&&(E=this.decodeData(k,g))&&r(E)?I(new Error(`command failed with error code ${b}: ${this.decodeData(k,g)}`)):(this.exists&&b===0&&(this.isLimitHit=!0),I(null,"",!0))})}forwardData(c,g,w){const y=new A.StringDecoder(g);return c.on("data",I=>{w(null,y.write(I))}),y}collectData(c){const g=[];return c.on("data",w=>{g.push(w)}),g}decodeData(c,g){const w=new A.StringDecoder(g);return c.map(y=>w.write(y)).join("")}initDirectoryTree(){const c={rootEntries:[],pathToEntries:Object.create(null)};return c.pathToEntries["."]=c.rootEntries,c}addDirectoryEntries(c,{pathToEntries:g},w,y,I){y.indexOf(this.filePattern)!==-1&&this.matchFile(I,{base:w,relativePath:this.filePattern,searchPath:this.getSearchPath(c,this.filePattern)});const P=k=>{const b=D.basename(k),E=D.dirname(k);let N=g[E];N||(N=g[E]=[],P(E)),N.push({base:w,relativePath:k,basename:b,searchPath:this.getSearchPath(c,k)})};y.forEach(P)}matchDirectoryTree({rootEntries:c,pathToEntries:g},w,y){const I=this,P=this.folderExcludePatterns.get(w),k=this.filePattern;function b(E){I.directoriesWalked++;const N=(0,m.hasSiblingFn)(()=>E.map(O=>O.basename));for(let O=0,M=E.length;O<M;O++){const U=E[O],{relativePath:H,basename:F}=U;if(P.test(H,F,k!==F?N:void 0))continue;const x=g[H];if(x)b(x);else{if(I.filesWalked++,H===k)continue;I.matchFile(y,U)}if(I.isLimitHit)break}}b(c)}getStats(){return{cmdTime:this.cmdSW.elapsed(),fileWalkTime:this.fileWalkSW.elapsed(),directoriesWalked:this.directoriesWalked,filesWalked:this.filesWalked,cmdResultCount:this.cmdResultCount}}doWalk(c,g,w,y,I){const P=c.folder,k=(0,m.hasSiblingFn)(()=>w);this.parallel(w,(b,E)=>{if(this.isCanceled||this.isLimitHit)return E(null);const N=g?[g,b].join(D.sep):b;if(this.folderExcludePatterns.get(c.folder.fsPath).test(N,b,this.config.filePattern!==b?k:void 0))return E(null);const O=[P.fsPath,N].join(D.sep);h.lstat(O,(M,U)=>{if(M||this.isCanceled||this.isLimitHit)return E(null);this.statLinkIfNeeded(O,U,(H,F)=>H||this.isCanceled||this.isLimitHit?E(null):F.isDirectory()?(this.directoriesWalked++,this.realPathIfNeeded(O,U,(x,$)=>x||this.isCanceled||this.isLimitHit||($=$||"",this.walkedPaths[$])?E(null):(this.walkedPaths[$]=!0,o.Promises.readdir(O).then(G=>{if(this.isCanceled||this.isLimitHit)return E(null);this.doWalk(c,N,G,y,B=>E(B||null))},G=>{E(null)})))):(this.filesWalked++,N===this.filePattern||this.maxFilesize&&S.isNumber(F.size)&&F.size>this.maxFilesize||this.matchFile(y,{base:P.fsPath,relativePath:N,searchPath:this.getSearchPath(c,N)}),E(null,void 0)))})},b=>{const E=b&&L.coalesce(b);return I(E&&E.length>0?E[0]:void 0)})}matchFile(c,g){this.isFileMatch(g)&&(!this.includePattern||this.includePattern(g.relativePath,D.basename(g.relativePath)))&&(this.resultCount++,(this.exists||this.maxResults&&this.resultCount>this.maxResults)&&(this.isLimitHit=!0),this.isLimitHit||c(g))}isFileMatch(c){if(this.filePattern){if(this.filePattern==="*")return!0;if(this.normalizedFilePatternLowercase)return(0,m.isFilePatternMatch)(c,this.normalizedFilePatternLowercase);if(this.filePattern)return(0,m.isFilePatternMatch)(c,this.filePattern,!1)}return!0}statLinkIfNeeded(c,g,w){return g.isSymbolicLink()?h.stat(c,w):w(null,g)}realPathIfNeeded(c,g,w){return g.isSymbolicLink()?h.realpath(c,(y,I)=>y?w(y):w(null,I)):w(null,c)}getSearchPath(c,g){return c.folderName?D.join(c.folderName,g):g}}e.FileWalker=a;class t{constructor(c,g){this.folderQueries=c.folderQueries,this.extraFiles=c.extraFileResources||[],this.numThreads=g,this.walker=new a(c)}search(c,g,w){this.walker.walk(this.folderQueries,this.extraFiles,this.numThreads,c,g,(y,I)=>{w(y,{limitHit:I,stats:this.walker.getStats(),messages:[]})})}cancel(){this.walker.cancel()}}e.Engine=t;class n{constructor(c,g){this.expression=c,this.root=g,this.init(c)}init(c){let g,w;Object.keys(c).filter(y=>c[y]).forEach(y=>{D.isAbsolute(y)?(g=g||v.getEmptyExpression(),g[y]=c[y]):(w=w||v.getEmptyExpression(),w[y]=c[y])}),this.absoluteParsedExpr=g&&v.parse(g,{trimForExclusions:!0}),this.relativeParsedExpr=w&&v.parse(w,{trimForExclusions:!0})}test(c,g,w){return this.relativeParsedExpr&&this.relativeParsedExpr(c,g,w)||this.absoluteParsedExpr&&this.absoluteParsedExpr(D.join(this.root,c),g,w)}getBasenameTerms(){const c=[];return this.absoluteParsedExpr&&c.push(...v.getBasenameTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&c.push(...v.getBasenameTerms(this.relativeParsedExpr)),c}getPathTerms(){const c=[];return this.absoluteParsedExpr&&c.push(...v.getPathTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&c.push(...v.getPathTerms(this.relativeParsedExpr)),c}}function r(d){const c=d.trim().split(`
`),g=c[0].trim();if(g.startsWith("Error parsing regex"))return g;if(g.startsWith("regex parse error"))return T.uppercaseFirstLetter(c[c.length-1].trim());if(g.startsWith("error parsing glob")||g.startsWith("unsupported encoding"))return g.charAt(0).toUpperCase()+g.substr(1);if(g==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(g.startsWith("Literal "))return g}}),define(Pe[352],ke([1,0,103,21,144,20,18,132]),function(ge,e,s,h,D,A,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.GUESSABLE_ENCODINGS=e.SUPPORTED_ENCODINGS=e.DecodeStreamError=e.DecodeStreamErrorKind=e.UTF8_BOM=e.UTF16le_BOM=e.UTF16be_BOM=e.UTF16le=e.UTF16be=e.UTF8_with_bom=e.UTF8=void 0,e.isUTFEncoding=v,e.toDecodeStream=m,e.toEncodeReadable=p,e.encodingExists=u,e.toNodeEncoding=i,e.detectEncodingByBOMFromBuffer=a,e.toCanonicalName=y,e.detectEncodingFromBuffer=I,e.UTF8="utf8",e.UTF8_with_bom="utf8bom",e.UTF16be="utf16be",e.UTF16le="utf16le";function v(P){return[e.UTF8,e.UTF8_with_bom,e.UTF16be,e.UTF16le].some(k=>k===P)}e.UTF16be_BOM=[254,255],e.UTF16le_BOM=[255,254],e.UTF8_BOM=[239,187,191];const l=512,C=512,_=512*8,f=512*128;var T;(function(P){P[P.STREAM_IS_BINARY=1]="STREAM_IS_BINARY"})(T||(e.DecodeStreamErrorKind=T={}));class S extends Error{constructor(k,b){super(k),this.decodeStreamErrorKind=b}}e.DecodeStreamError=S;class o{static async create(k){let b;if(k!==e.UTF8)b=(await(0,D.importAMDNodeModule)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).getDecoder(i(k));else{const E=new TextDecoder;b={write(N){return E.decode(N,{stream:!0})},end(){return E.decode()}}}return new o(b)}constructor(k){this.iconvLiteDecoder=k}write(k){return this.iconvLiteDecoder.write(k)}end(){return this.iconvLiteDecoder.end()}}function m(P,k){const b=k.minBytesRequiredForDetection??k.guessEncoding?_:C;return new Promise((E,N)=>{const O=(0,s.newWriteableStream)($=>$.join("")),M=[];let U=0,H;const F=new A.CancellationTokenSource,x=async()=>{try{const $=await I({buffer:h.VSBuffer.concat(M),bytesRead:U},k.guessEncoding,k.candidateGuessEncodings);if($.seemsBinary&&k.acceptTextOnly)throw new S("Stream is binary but only text is accepted for decoding",T.STREAM_IS_BINARY);$.encoding=await k.overwriteEncoding($.encoding),H=await o.create($.encoding);const G=H.write(h.VSBuffer.concat(M).buffer);O.write(G),M.length=0,U=0,E({stream:O,detected:$})}catch($){F.cancel(),O.destroy(),N($)}};(0,s.listenStream)(P,{onData:async $=>{H?O.write(H.write($.buffer)):(M.push($),U+=$.byteLength,U>=b&&(P.pause(),await x(),setTimeout(()=>P.resume())))},onError:$=>O.error($),onEnd:async()=>{H||await x(),O.end(H?.end())}},F.token)})}async function p(P,k,b){const N=(await(0,D.importAMDNodeModule)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).getEncoder(i(k),b);let O=!1,M=!1;return{read(){if(M)return null;const U=P.read();if(typeof U!="string"){if(M=!0,!O&&b?.addBOM)switch(k){case e.UTF8:case e.UTF8_with_bom:return h.VSBuffer.wrap(Uint8Array.from(e.UTF8_BOM));case e.UTF16be:return h.VSBuffer.wrap(Uint8Array.from(e.UTF16be_BOM));case e.UTF16le:return h.VSBuffer.wrap(Uint8Array.from(e.UTF16le_BOM))}const H=N.end();return H&&H.length>0?(O=!0,h.VSBuffer.wrap(H)):null}return O=!0,h.VSBuffer.wrap(N.write(U))}}}async function u(P){return(await(0,D.importAMDNodeModule)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).encodingExists(i(P))}function i(P){return P===e.UTF8_with_bom||P===null?e.UTF8:P}function a(P,k){if(!P||k<e.UTF16be_BOM.length)return null;const b=P.readUInt8(0),E=P.readUInt8(1);if(b===e.UTF16be_BOM[0]&&E===e.UTF16be_BOM[1])return e.UTF16be;if(b===e.UTF16le_BOM[0]&&E===e.UTF16le_BOM[1])return e.UTF16le;if(k<e.UTF8_BOM.length)return null;const N=P.readUInt8(2);return b===e.UTF8_BOM[0]&&E===e.UTF8_BOM[1]&&N===e.UTF8_BOM[2]?e.UTF8_with_bom:null}const t=["ascii","utf-16","utf-32"];async function n(P,k){const b=await(0,D.importAMDNodeModule)("jschardet",R.isESM?"dist/jschardet.js":"dist/jschardet.min.js"),E=P.slice(0,f),N=w(E.buffer);k&&(k=(0,L.coalesce)(k.map(U=>g(U))),k.length===0&&(k=void 0));const O=b.detect(N,k?{detectEncodings:k}:void 0);if(!O||!O.encoding)return null;const M=O.encoding.toLowerCase();return 0<=t.indexOf(M)?null:c(O.encoding)}const r={ibm866:"cp866",big5:"cp950"};function d(P){return P.replace(/[^a-zA-Z0-9]/g,"").toLowerCase()}function c(P){const k=d(P);return r[k]||k}function g(P){const k=d(P);return e.GUESSABLE_ENCODINGS[k].guessableName}function w(P){let k="";for(let b=0;b<P.length;b++)k+=String.fromCharCode(P[b]);return k}function y(P){switch(P){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:{const k=P.match(/windows(\d+)/);return k?"windows-"+k[1]:P}}}function I({buffer:P,bytesRead:k},b,E){let N=a(P,k),O=!1;if(N!==e.UTF16be&&N!==e.UTF16le&&P){let M=!0,U=!0,H=!1;for(let F=0;F<k&&F<l;F++){const x=F%2===1,$=P.readUInt8(F)===0;if($&&(H=!0),M&&(x&&!$||!x&&$)&&(M=!1),U&&(x&&$||!x&&!$)&&(U=!1),$&&!M&&!U)break}H&&(M?N=e.UTF16le:U?N=e.UTF16be:O=!0)}return b&&!O&&!N&&P?n(P.slice(0,k),E).then(M=>({seemsBinary:!1,encoding:M})):{seemsBinary:O,encoding:N}}e.SUPPORTED_ENCODINGS={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom",guessableName:"UTF-8"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3,guessableName:"UTF-16LE"},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4,guessableName:"UTF-16BE"},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5,guessableName:"windows-1252"},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16,guessableName:"windows-1250"},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17,guessableName:"ISO-8859-2"},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19,guessableName:"windows-1251"},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20,guessableName:"IBM866"},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21,guessableName:"ISO-8859-5"},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22,guessableName:"KOI8-R"},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25,guessableName:"windows-1253"},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26,guessableName:"ISO-8859-7"},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27,guessableName:"windows-1255"},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28,guessableName:"ISO-8859-8"},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36,guessableName:"Big5"},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38,guessableName:"SHIFT_JIS"},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39,guessableName:"EUC-JP"},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40,guessableName:"EUC-KR"},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45,guessableName:"GB2312"},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}},e.GUESSABLE_ENCODINGS=(()=>{const P={};for(const k in e.SUPPORTED_ENCODINGS)e.SUPPORTED_ENCODINGS[k].guessableName&&(P[k]=e.SUPPORTED_ENCODINGS[k]);return P})()}),define(Pe[177],ke([1,0,352,34,176]),function(ge,e,s,h,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeTextSearchManager=void 0,h=We(h);class A extends D.TextSearchManager{constructor(R,v,l=h,C="searchProcess"){super({query:R,provider:v},{readdir:_=>l.Promises.readdir(_.fsPath),toCanonicalName:_=>(0,s.toCanonicalName)(_)},C)}}e.NativeTextSearchManager=A}),define(Pe[178],ke([1,0,58,367,351,18,80,39,13,2,32,59,368,349,130,129]),function(ge,e,s,h,D,A,L,R,v,l,C,_,f,T,S,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RipgrepParser=e.RipgrepTextSearchEngine=void 0,e.getRgArgs=r,e.unicodeEscapesToPCRE2=c,e.fixRegexNewline=w,e.fixNewline=y,e.performBraceExpansionForRipgrep=P,s=We(s);const m=T.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class p{constructor(b,E){this.outputChannel=b,this._numThreads=E}provideTextSearchResults(b,E,N,O){return Promise.all(E.folderOptions.map(M=>{const U={folderOptions:M,numThreads:this._numThreads,maxResults:E.maxResults,previewOptions:E.previewOptions,maxFileSize:E.maxFileSize,surroundingContext:E.surroundingContext};return this.provideTextSearchResultsWithRgOptions(b,U,N,O)})).then(M=>({limitHit:M.some(H=>!!H&&H.limitHit)}))}provideTextSearchResultsWithRgOptions(b,E,N,O){return this.outputChannel.appendLine(`provideTextSearchResults ${b.pattern}, ${JSON.stringify({...E,folder:E.folderOptions.folder.toString()})}`),new Promise((M,U)=>{O.onCancellationRequested(()=>J());const H={...E,numThreads:this._numThreads},F=r(b,H),x=E.folderOptions.folder.fsPath,$=F.map(Q=>Q.match(/^-/)?Q:`'${Q}'`).join(" ");this.outputChannel.appendLine(`${m} ${$}
 - cwd: ${x}`);let G=s.spawn(m,F,{cwd:x});G.on("error",Q=>{console.error(Q),this.outputChannel.appendLine("Error: "+(Q&&Q.message)),U((0,C.serializeSearchError)(new C.SearchError(Q&&Q.message,C.SearchErrorCode.rgProcessError)))});let B=!1;const W=new a(E.maxResults??C.DEFAULT_MAX_SEARCH_RESULTS,E.folderOptions.folder,(0,o.newToOldPreviewOptions)(E.previewOptions));W.on("result",Q=>{B=!0,te="",N.report(Q)});let Z=!1;const J=()=>{Z=!0,G?.kill(),W?.cancel()};let oe=!1;W.on("hitLimit",()=>{oe=!0,J()});let te="";G.stdout.on("data",Q=>{W.handleData(Q),B||(te+=Q)});let me=!1;G.stdout.once("data",()=>me=!0);let le="";G.stderr.on("data",Q=>{const z=Q.toString();this.outputChannel.appendLine(z),le.length+z.length<1e6&&(le+=z)}),G.on("close",()=>{if(this.outputChannel.appendLine(me?"Got data from stdout":"No data from stdout"),this.outputChannel.appendLine(B?"Got result from parser":"No result from parser"),te&&this.outputChannel.appendLine(`Got data without result: ${te}`),this.outputChannel.appendLine(""),Z)M({limitHit:oe});else{W.flush(),G=null;let Q;le&&!me&&(Q=u(le))?U((0,C.serializeSearchError)(new C.SearchError(Q.message,Q.code))):M({limitHit:oe})}})})}}e.RipgrepTextSearchEngine=p;function u(k){const b=k.split(`
`),E=b[0].trim();if(b.some(O=>O.startsWith("regex parse error")))return new C.SearchError(i(b),C.SearchErrorCode.regexParseError);const N=E.match(/grep config error: unknown encoding: (.*)/);if(N)return new C.SearchError(`Unknown encoding: ${N[1]}`,C.SearchErrorCode.unknownEncoding);if(E.startsWith("error parsing glob"))return new C.SearchError(E.charAt(0).toUpperCase()+E.substr(1),C.SearchErrorCode.globParseError);if(E.startsWith("the literal"))return new C.SearchError(E.charAt(0).toUpperCase()+E.substr(1),C.SearchErrorCode.invalidLiteral);if(E.startsWith("PCRE2: error compiling pattern"))return new C.SearchError(E,C.SearchErrorCode.regexParseError)}function i(k){const b=["Regex parse error"],E=k.filter(N=>N.startsWith("PCRE2:"));if(E.length>=1){const N=E[0].replace("PCRE2:","");if(N.indexOf(":")!==-1&&N.split(":").length>=2){const O=N.split(":")[1];b.push(":"+O)}}return b.join("")}class a extends h.EventEmitter{constructor(b,E,N){super(),this.maxResults=b,this.root=E,this.previewOptions=N,this.remainder="",this.isDone=!1,this.hitLimit=!1,this.numResults=0,this.stringDecoder=new D.StringDecoder}cancel(){this.isDone=!0}flush(){this.handleDecodedData(this.stringDecoder.end())}on(b,E){return super.on(b,E),this}handleData(b){if(this.isDone)return;const E=typeof b=="string"?b:this.stringDecoder.write(b);this.handleDecodedData(E)}handleDecodedData(b){let E=b.indexOf(`
`);const N=this.remainder+b;if(E>=0)E+=this.remainder.length;else{this.remainder=N;return}let O=0;for(;E>=0;)this.handleLine(N.substring(O,E).trim()),O=E+1,E=N.indexOf(`
`,O);this.remainder=N.substring(O)}handleLine(b){if(this.isDone||!b)return;let E;try{E=JSON.parse(b)}catch{throw new Error(`malformed line from rg: ${b}`)}if(E.type==="match"){const N=t(E.data.path),O=l.URI.joinPath(this.root,N),M=this.createTextSearchMatch(E.data,O);this.onResult(M),this.hitLimit&&(this.cancel(),this.emit("hitLimit"))}else if(E.type==="context"){const N=t(E.data.path),O=l.URI.joinPath(this.root,N);this.createTextSearchContexts(E.data,O).forEach(U=>this.onResult(U))}}createTextSearchMatch(b,E){const N=b.line_number-1,O=t(b.lines),M=Buffer.from(O);let U=0,H=0,F=N;b.submatches.length===0&&b.submatches.push(O.length?{start:0,end:1,match:{text:O[0]}}:{start:0,end:0,match:{text:""}});const x=(0,A.coalesce)(b.submatches.map((B,W)=>{if(this.hitLimit)return null;this.numResults++,this.numResults>=this.maxResults&&(this.hitLimit=!0);const Z=t(B.match),J=M.slice(U,B.start).toString(),oe=n(J),te=oe.numLines>0?oe.lastLineLength:oe.lastLineLength+H,me=n(Z),le=oe.numLines+F,Q=me.numLines+le,z=me.numLines>0?me.lastLineLength:me.lastLineLength+te;return U=B.end,H=z,F=Q,new _.Range(le,te,Q,z)})),$=(0,A.mapArrayOrNot)(x,S.rangeToSearchRange),G=new C.TextSearchMatch(O,$,this.previewOptions);return new _.TextSearchMatchNew(E,G.rangeLocations.map(B=>({sourceRange:(0,S.searchRangeToRange)(B.source),previewRange:(0,S.searchRangeToRange)(B.preview)})),G.previewText)}createTextSearchContexts(b,E){const N=t(b.lines),O=b.line_number;return N.replace(/\r?\n$/,"").split(`
`).map((M,U)=>new _.TextSearchContextNew(E,M,O+U))}onResult(b){this.emit("result",b)}}e.RipgrepParser=a;function t(k){return k.bytes?Buffer.from(k.bytes,"base64").toString():k.text}function n(k){const b=/\n/g;let E=0,N=-1,O;for(;O=b.exec(k);)E++,N=O.index;const M=N>=0?k.length-N-1:k.length;return{numLines:E,lastLineLength:M}}function r(k,b){const E=["--hidden","--no-require-git"];E.push(k.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:N,otherIncludes:O}=(0,L.groupBy)(b.folderOptions.includes,U=>U.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(O&&O.length){const U=new Set;O.forEach(H=>{U.add(H)}),E.push("-g","!*"),U.forEach(H=>{d(H).map(S.anchorGlob).forEach(F=>{E.push("-g",F)})})}N&&N.length&&N.forEach(U=>{E.push("-g",U)}),b.folderOptions.excludes.map(U=>typeof U=="string"?U:U.pattern).map(S.anchorGlob).forEach(U=>E.push("-g",`!${U}`)),b.maxFileSize&&E.push("--max-filesize",b.maxFileSize+""),b.folderOptions.useIgnoreFiles.local?b.folderOptions.useIgnoreFiles.parent||E.push("--no-ignore-parent"):E.push("--no-ignore"),b.folderOptions.followSymlinks&&E.push("--follow"),b.folderOptions.encoding&&b.folderOptions.encoding!=="utf8"&&E.push("--encoding",b.folderOptions.encoding),b.numThreads&&E.push("--threads",`${b.numThreads}`),k.pattern==="--"&&(k.isRegExp=!0,k.pattern="\\-\\-"),k.isMultiline&&!k.isRegExp&&(k.pattern=(0,v.escapeRegExpCharacters)(k.pattern),k.isRegExp=!0),b.usePCRE2&&E.push("--pcre2"),E.push("--crlf"),k.isRegExp&&(k.pattern=c(k.pattern),E.push("--engine","auto"));let M;if(k.isWordMatch){const H=(0,v.createRegExp)(k.pattern,!!k.isRegExp,{wholeWord:k.isWordMatch}).source.replace(/\\\//g,"/");E.push("--regexp",H)}else if(k.isRegExp){let U=w(k.pattern);U=y(U),E.push("--regexp",U)}else M=k.pattern,E.push("--fixed-strings");return E.push("--no-config"),b.folderOptions.useIgnoreFiles.global||E.push("--no-ignore-global"),E.push("--json"),k.isMultiline&&E.push("--multiline"),b.surroundingContext&&(E.push("--before-context",b.surroundingContext+""),E.push("--after-context",b.surroundingContext+"")),E.push("--"),M&&E.push(M),E.push("."),E}function d(k){return P(k).flatMap(E=>{const N=(0,R.splitGlobAware)(E,"/");return N.map((O,M)=>N.slice(0,M+1).join("/"))})}function c(k){const b=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;k.match(b);)k=k.replace(b,"$1\\x{$2}");const E=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;k.match(E);)k=k.replace(E,"$1\\x{$2}");return k}const g=k=>k.type==="Assertion"&&k.kind==="lookbehind";function w(k){let b;try{b=new f.RegExpParser().parsePattern(k)}catch{return k}let E="",N=0;const O=(H,F,x)=>{E+=k.slice(N,H)+x,N=F},M=[];return new f.RegExpVisitor({onCharacterEnter(H){if(H.raw!=="\\n")return;const F=M[0];if(!F)O(H.start,H.end,"\\r?\\n");else if(!M.some(g))if(F.type==="CharacterClass")if(F.negate){const x=k.slice(F.start+2,H.start)+k.slice(H.end,F.end-1);F.parent?.type==="Quantifier"?O(F.start,F.end,x?`[^${x}]`:"."):O(F.start,F.end,"(?!\\r?\\n"+(x?`|[${x}]`:"")+")")}else{const x=k.slice(F.start+1,H.start)+k.slice(H.end,F.end-1);O(F.start,F.end,x===""?"\\r?\\n":`(?:[${x}]|\\r?\\n)`)}else F.type==="Quantifier"&&O(H.start,H.end,"(?:\\r?\\n)")},onQuantifierEnter(H){M.unshift(H)},onQuantifierLeave(){M.shift()},onCharacterClassRangeEnter(H){M.unshift(H)},onCharacterClassRangeLeave(){M.shift()},onCharacterClassEnter(H){M.unshift(H)},onCharacterClassLeave(){M.shift()},onAssertionEnter(H){g(H)&&M.push(H)},onAssertionLeave(H){M[0]===H&&M.shift()}}).visit(b),E+=k.slice(N),E}function y(k){return k.replace(/\n/g,"\\r?\\n")}function I(k){let b=!1,E=!1,N="",O="";for(let M=0;M<k.length;M++){const U=k[M];switch(U){case"\\":E?(b?O+="\\"+U:N+="\\"+U,E=!1):E=!0;break;case"{":if(E)b?O+=U:N+=U,E=!1;else{if(b)return{strInBraces:N+"{"+O+"{"+k.substring(M+1)};b=!0}break;case"}":if(E)b?O+=U:N+=U,E=!1;else{if(b)return{fixedStart:N,strInBraces:O,fixedEnd:k.substring(M+1)};N+=U}break;default:b?O+=(E?"\\":"")+U:N+=(E?"\\":"")+U,E=!1;break}}return{strInBraces:N+(b?"{"+O:"")}}function P(k){const{fixedStart:b,strInBraces:E,fixedEnd:N}=I(k);if(b===void 0||N===void 0)return[E];let O=(0,R.splitGlobAware)(E,",");O.length||(O=[""]);const M=P(N);return O.flatMap(U=>{const H=b+U;return M.map(F=>H+F)})}}),define(Pe[353],ke([1,0,20,178,90,14]),function(ge,e,s,h,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RipgrepSearchProvider=void 0;class L{constructor(l,C){this.outputChannel=l,this.getNumThreads=C,this.inProgress=new Set,process.once("exit",()=>this.dispose())}async provideTextSearchResults(l,C,_,f){const T=await this.getNumThreads(),S=new h.RipgrepTextSearchEngine(this.outputChannel,T);return Promise.all(C.folderOptions.map(o=>{const m={folderOptions:o,numThreads:T,maxResults:C.maxResults,previewOptions:C.previewOptions,maxFileSize:C.maxFileSize,surroundingContext:C.surroundingContext};if(o.folder.scheme===A.Schemas.vscodeUserData){const p={...m,folder:o.folder.with({scheme:A.Schemas.file})},u=new D.Progress(i=>_.report({...i,uri:i.uri.with({scheme:o.folder.scheme})}));return this.withToken(f,i=>S.provideTextSearchResultsWithRgOptions(l,p,u,i))}else return this.withToken(f,p=>S.provideTextSearchResultsWithRgOptions(l,m,_,p))})).then(o=>({limitHit:o.some(p=>!!p&&p.limitHit)}))}async withToken(l,C){const _=R(l);this.inProgress.add(_);const f=await C(_.token);return this.inProgress.delete(_),f}dispose(){this.inProgress.forEach(l=>l.cancel())}}e.RipgrepSearchProvider=L;function R(v){const l=new s.CancellationTokenSource;return v.onCancellationRequested(()=>l.cancel()),l}}),define(Pe[354],ke([1,0,34,32,178,177]),function(ge,e,s,h,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchEngineAdapter=void 0,s=We(s);class L{constructor(l,C){this.query=l,this.numThreads=C}search(l,C,_){if((!this.query.folderQueries||!this.query.folderQueries.length)&&(!this.query.extraFileResources||!this.query.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"},messages:[]});const f={appendLine(S){_({message:S})}},T=new A.NativeTextSearchManager(this.query,new D.RipgrepTextSearchEngine(f,this.numThreads),s);return new Promise((S,o)=>T.search(m=>{C(m.map(R))},l).then(m=>S({limitHit:m.limitHit??!1,type:"success",stats:m.stats,messages:[]}),o))}}e.TextSearchEngineAdapter=L;function R(v){return{path:v.resource&&v.resource.fsPath,results:v.results,numMatches:(v.results||[]).reduce((l,C)=>(0,h.resultIsMatch)(C)?l+C.rangeLocations.length:l+1,0)}}}),define(Pe[355],ke([1,0,18,8,12,4,143,38,16,43,2,27,32,350,354]),function(ge,e,s,h,D,A,L,R,v,l,C,_,f,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SearchService=void 0,s=We(s);class o{static{this.BATCH_SIZE=512}constructor(t="searchProcess",n){this.processType=t,this.getNumThreads=n,this.caches=Object.create(null)}fileSearch(t){let n;const r=u(t),d=new A.Emitter({onDidAddFirstListener:()=>{n=(0,h.createCancelablePromise)(async c=>{const g=await this.getNumThreads?.();return this.doFileSearchWithEngine(T.Engine,r,w=>d.fire(w),c,o.BATCH_SIZE,g)}),n.then(c=>d.fire(c),c=>d.fire({type:"error",error:{message:c.message,stack:c.stack}}))},onDidRemoveLastListener:()=>{n.cancel()}});return d.event}textSearch(t){let n;const r=u(t),d=new A.Emitter({onDidAddFirstListener:()=>{n=(0,h.createCancelablePromise)(c=>this.ripgrepTextSearch(r,g=>d.fire(g),c)),n.then(c=>d.fire(c),c=>d.fire({type:"error",error:{message:c.message,stack:c.stack}}))},onDidRemoveLastListener:()=>{n.cancel()}});return d.event}async ripgrepTextSearch(t,n,r){t.maxFileSize=this.getPlatformFileLimits().maxFileSize;const d=await this.getNumThreads?.();return new S.TextSearchEngineAdapter(t,d).search(r,n,n)}getPlatformFileLimits(){return{maxFileSize:16*_.ByteSize.GB}}doFileSearch(t,n,r,d){return this.doFileSearchWithEngine(T.Engine,t,r,d,o.BATCH_SIZE,n)}doFileSearchWithEngine(t,n,r,d,c=o.BATCH_SIZE,g){let w=0;const y=P=>{Array.isArray(P)?(w+=P.length,r(P.map(k=>this.rawMatchToSearchItem(k)))):P.relativePath?(w++,r(this.rawMatchToSearchItem(P))):r(P)};if(n.sortByScore){let P=this.trySortedSearchFromCache(n,y,d);if(!P){const k=n.maxResults?Object.assign({},n,{maxResults:null}):n,b=new t(k,g);P=this.doSortedSearch(b,n,r,y,d)}return new Promise((k,b)=>{P.then(([E,N])=>{const O=N.map(M=>this.rawMatchToSearchItem(M));this.sendProgress(O,r,c),k(E)},b)})}const I=new t(n,g);return this.doSearch(I,y,c,d).then(P=>({limitHit:P.limitHit,type:"success",stats:{detailStats:P.stats,type:this.processType,fromCache:!1,resultCount:w,sortingTime:void 0},messages:[]}))}rawMatchToSearchItem(t){return{path:t.base?(0,v.join)(t.base,t.relativePath):t.relativePath}}doSortedSearch(t,n,r,d,c){const g=new A.Emitter;let w=(0,h.createCancelablePromise)(I=>{let P=[];const k=b=>{Array.isArray(b)?P=b:(d(b),g.fire(b))};return this.doSearch(t,k,-1,I).then(b=>[b,P])}),y;if(n.cacheKey){y=this.getOrCreateCache(n.cacheKey);const I={promise:w,event:g.event,resolved:!1};y.resultsToSearchCache[n.filePattern||""]=I,w.then(()=>{I.resolved=!0},P=>{delete y.resultsToSearchCache[n.filePattern||""]}),w=this.preventCancellation(w)}return w.then(([I,P])=>{const k=y?y.scorerCache:Object.create(null),b=(typeof n.maxResults!="number"||n.maxResults>0)&&l.StopWatch.create(!1);return this.sortResults(n,P,k,c).then(E=>{const N=b?b.elapsed():-1;return[{type:"success",stats:{detailStats:I.stats,sortingTime:N,fromCache:!1,type:this.processType,resultCount:E.length},messages:I.messages,limitHit:I.limitHit||typeof n.maxResults=="number"&&P.length>n.maxResults},E]})})}getOrCreateCache(t){const n=this.caches[t];return n||(this.caches[t]=new m)}trySortedSearchFromCache(t,n,r){const d=t.cacheKey&&this.caches[t.cacheKey];if(!d)return;const c=this.getResultsFromCache(d,t.filePattern||"",n,r);if(c)return c.then(([g,w,y])=>{const I=l.StopWatch.create(!1);return this.sortResults(t,w,d.scorerCache,r).then(P=>{const k=I.elapsed(),b={fromCache:!0,detailStats:y,type:this.processType,resultCount:w.length,sortingTime:k};return[{type:"success",limitHit:g.limitHit||typeof t.maxResults=="number"&&w.length>t.maxResults,stats:b,messages:[]},P]})})}sortResults(t,n,r,d){const c=(0,L.prepareQuery)(t.filePattern||""),g=(y,I)=>(0,L.compareItemsByFuzzyScore)(y,I,c,!0,p,r),w=typeof t.maxResults=="number"?t.maxResults:f.DEFAULT_MAX_SEARCH_RESULTS;return s.topAsync(n,g,w,1e4,d)}sendProgress(t,n,r){if(r&&r>0)for(let d=0;d<t.length;d+=r)n(t.slice(d,d+r));else n(t)}getResultsFromCache(t,n,r,d){const c=l.StopWatch.create(!1),g=n.indexOf(v.sep)>=0;let w;for(const k in t.resultsToSearchCache)if(n.startsWith(k)){if(g&&k.indexOf(v.sep)<0&&k!=="")continue;const b=t.resultsToSearchCache[k];w={promise:this.preventCancellation(b.promise),event:b.event,resolved:b.resolved};break}if(!w)return null;const y=c.elapsed(),I=l.StopWatch.create(!1),P=w.event(r);return d&&d.onCancellationRequested(()=>{P.dispose()}),w.promise.then(([k,b])=>{if(d&&d.isCancellationRequested)throw(0,D.canceled)();const E=[],N=(0,L.prepareQuery)(n).normalizedLowercase;for(const O of b)(0,f.isFilePatternMatch)(O,N)&&E.push(O);return[k,E,{cacheWasResolved:w.resolved,cacheLookupTime:y,cacheFilterTime:I.elapsed(),cacheEntryCount:b.length}]})}doSearch(t,n,r,d){return new Promise((c,g)=>{let w=[];d?.onCancellationRequested(()=>t.cancel()),t.search(y=>{y&&(r?(w.push(y),r>0&&w.length>=r&&(n(w),w=[])):n(y))},y=>{n(y)},(y,I)=>{w.length&&n(w),y?(n({message:"Search finished. Error: "+y.message}),g(y)):(n({message:"Search finished. Stats: "+JSON.stringify(I.stats)}),c(I))})})}clearCache(t){return delete this.caches[t],Promise.resolve(void 0)}preventCancellation(t){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(n,r){return t.then(n,r)}catch(n){return this.then(void 0,n)}finally(n){return t.finally(n)}}}}e.SearchService=o;class m{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const p=new class{getItemLabel(a){return(0,v.basename)(a.relativePath)}getItemDescription(a){return(0,v.dirname)(a.relativePath)}getItemPath(a){return a.relativePath}};function u(a){return{...a,folderQueries:a.folderQueries&&a.folderQueries.map(i),extraFileResources:a.extraFileResources&&a.extraFileResources.map(t=>C.URI.revive(t))}}function i(a){return(0,R.revive)(a)}}),define(Pe[356],ke([1,0,3,14,2,34,11,42,29,19,102,74,32,355,353,130,177]),function(ge,e,s,h,D,A,L,R,v,l,C,_,f,T,S,o,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtHostSearch=void 0,A=We(A);let p=class extends C.ExtHostSearch{constructor(i,a,t,n,r){super(i,t,r),this.configurationService=n,this._pfs=A,this._internalFileSearchHandle=-1,this._internalFileSearchProvider=null,this._registeredEHSearchProvider=!1,this._disposables=new s.DisposableStore,this.isDisposed=!1,this.getNumThreads=this.getNumThreads.bind(this),this.getNumThreadsCached=this.getNumThreadsCached.bind(this),this.handleConfigurationChanged=this.handleConfigurationChanged.bind(this);const d=new o.OutputChannel("RipgrepSearchUD",this._logService);this._disposables.add(this.registerTextSearchProvider(h.Schemas.vscodeUserData,new S.RipgrepSearchProvider(d,this.getNumThreadsCached))),a.remote.isRemote&&a.remote.authority&&this._registerEHSearchProviders(),n.getConfigProvider().then(c=>{this.isDisposed||this._disposables.add(c.onDidChangeConfiguration(this.handleConfigurationChanged))})}handleConfigurationChanged(i){i.affectsConfiguration("search")&&(this._numThreadsPromise=void 0)}async getNumThreads(){return(await this.configurationService.getConfigProvider()).getConfiguration("search").get("ripgrep.maxThreads")}async getNumThreadsCached(){return this._numThreadsPromise||(this._numThreadsPromise=this.getNumThreads()),this._numThreadsPromise}dispose(){this.isDisposed=!0,this._disposables.dispose()}$enableExtensionHostSearch(){this._registerEHSearchProviders()}_registerEHSearchProviders(){if(this._registeredEHSearchProvider)return;this._registeredEHSearchProvider=!0;const i=new o.OutputChannel("RipgrepSearchEH",this._logService);this._disposables.add(this.registerTextSearchProvider(h.Schemas.file,new S.RipgrepSearchProvider(i,this.getNumThreadsCached))),this._disposables.add(this.registerInternalFileSearchProvider(h.Schemas.file,new T.SearchService("fileSearchProvider",this.getNumThreadsCached)))}registerInternalFileSearchProvider(i,a){const t=this._handlePool++;return this._internalFileSearchProvider=a,this._internalFileSearchHandle=t,this._proxy.$registerFileSearchProvider(t,this._transformScheme(i)),(0,s.toDisposable)(()=>{this._internalFileSearchProvider=null,this._proxy.$unregisterProvider(t)})}$provideFileSearchResults(i,a,t,n){const r=(0,C.reviveQuery)(t);if(i===this._internalFileSearchHandle){const d=Date.now();return this.doInternalFileSearch(i,a,r,n).then(c=>{const g=Date.now()-d;return this._logService.debug(`Ext host file search time: ${g}ms`),c})}return super.$provideFileSearchResults(i,a,t,n)}async doInternalFileSearchWithCustomCallback(i,a,t){const n=d=>{if((0,f.isSerializedFileMatch)(d)&&(d=[d]),Array.isArray(d)){t(d.map(c=>D.URI.file(c.path)));return}d.message&&this._logService.debug("ExtHostSearch",d.message)};if(!this._internalFileSearchProvider)throw new Error("No internal file search handler");const r=await this.getNumThreadsCached();return this._internalFileSearchProvider.doFileSearch(i,r,n,a)}async doInternalFileSearch(i,a,t,n){return this.doInternalFileSearchWithCustomCallback(t,n,r=>{this._proxy.$handleFileMatch(i,a,r)})}$clearCache(i){return this._internalFileSearchProvider?.clearCache(i),super.$clearCache(i)}createTextSearchManager(i,a){return new m.NativeTextSearchManager(i,a,void 0,"textSearchProvider")}};e.NativeExtHostSearch=p,e.NativeExtHostSearch=p=Qe([$e(0,l.IExtHostRpcService),$e(1,v.IExtHostInitDataService),$e(2,_.IURITransformerService),$e(3,R.IExtHostConfiguration),$e(4,L.ILogService)],p)}),define(Pe[131],ke([1,0,369,68,69,370,21,12,4,3,16,10,31,87,70]),function(ge,e,s,h,D,A,L,R,v,l,C,_,f,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0,e.createRandomIPCHandle=c,e.createStaticIPCHandle=g,e.serve=I,e.connect=P;const o=3e4;class m{traceSocketEvent(b,E){S.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,b,E)}constructor(b,E=""){this._canWrite=!0,this.debugLabel=E,this.socket=b,this.traceSocketEvent(S.SocketDiagnosticsEventType.Created,{type:"NodeSocket"}),this._errorListener=O=>{if(this.traceSocketEvent(S.SocketDiagnosticsEventType.Error,{code:O?.code,message:O?.message}),O){if(O.code==="EPIPE")return;(0,R.onUnexpectedError)(O)}},this.socket.on("error",this._errorListener);let N;this._closeListener=O=>{this.traceSocketEvent(S.SocketDiagnosticsEventType.Close,{hadError:O}),this._canWrite=!1,N&&clearTimeout(N)},this.socket.on("close",this._closeListener),this._endListener=()=>{this.traceSocketEvent(S.SocketDiagnosticsEventType.NodeEndReceived),this._canWrite=!1,N=setTimeout(()=>b.destroy(),o)},this.socket.on("end",this._endListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.off("close",this._closeListener),this.socket.off("end",this._endListener),this.socket.destroy()}onData(b){const E=N=>{this.traceSocketEvent(S.SocketDiagnosticsEventType.Read,N),b(L.VSBuffer.wrap(N))};return this.socket.on("data",E),{dispose:()=>this.socket.off("data",E)}}onClose(b){const E=N=>{b({type:S.SocketCloseEventType.NodeSocketCloseEvent,hadError:N,error:void 0})};return this.socket.on("close",E),{dispose:()=>this.socket.off("close",E)}}onEnd(b){const E=()=>{b()};return this.socket.on("end",E),{dispose:()=>this.socket.off("end",E)}}write(b){if(!(this.socket.destroyed||!this._canWrite))try{this.traceSocketEvent(S.SocketDiagnosticsEventType.Write,b),this.socket.write(b.buffer,E=>{if(E){if(E.code==="EPIPE")return;(0,R.onUnexpectedError)(E)}})}catch(E){if(E.code==="EPIPE")return;(0,R.onUnexpectedError)(E)}}end(){this.traceSocketEvent(S.SocketDiagnosticsEventType.NodeEndSent),this.socket.end()}drain(){return this.traceSocketEvent(S.SocketDiagnosticsEventType.NodeDrainBegin),new Promise((b,E)=>{if(this.socket.bufferSize===0){this.traceSocketEvent(S.SocketDiagnosticsEventType.NodeDrainEnd),b();return}const N=()=>{this.socket.off("close",N),this.socket.off("end",N),this.socket.off("error",N),this.socket.off("timeout",N),this.socket.off("drain",N),this.traceSocketEvent(S.SocketDiagnosticsEventType.NodeDrainEnd),b()};this.socket.on("close",N),this.socket.on("end",N),this.socket.on("error",N),this.socket.on("timeout",N),this.socket.on("drain",N)})}}e.NodeSocket=m;var p;(function(k){k[k.MinHeaderByteSize=2]="MinHeaderByteSize",k[k.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(p||(p={}));var u;(function(k){k[k.PeekHeader=1]="PeekHeader",k[k.ReadHeader=2]="ReadHeader",k[k.ReadBody=3]="ReadBody",k[k.Fin=4]="Fin"})(u||(u={}));class i extends l.Disposable{get permessageDeflate(){return this._flowManager.permessageDeflate}get recordedInflateBytes(){return this._flowManager.recordedInflateBytes}traceSocketEvent(b,E){this.socket.traceSocketEvent(b,E)}constructor(b,E,N,O){super(),this._onData=this._register(new v.Emitter),this._onClose=this._register(new v.Emitter),this._isEnded=!1,this._state={state:u.PeekHeader,readLen:p.MinHeaderByteSize,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=b,this.traceSocketEvent(S.SocketDiagnosticsEventType.Created,{type:"WebSocketNodeSocket",permessageDeflate:E,inflateBytesLength:N?.byteLength||0,recordInflateBytes:O}),this._flowManager=this._register(new a(this,E,N,O,this._onData,(M,U)=>this._write(M,U))),this._register(this._flowManager.onError(M=>{console.error(M),(0,R.onUnexpectedError)(M),this._onClose.fire({type:S.SocketCloseEventType.NodeSocketCloseEvent,hadError:!0,error:M})})),this._incomingData=new S.ChunkStream,this._register(this.socket.onData(M=>this._acceptChunk(M))),this._register(this.socket.onClose(async M=>{this._flowManager.isProcessingReadQueue()&&await v.Event.toPromise(this._flowManager.onDidFinishProcessingReadQueue),this._onClose.fire(M)}))}dispose(){this._flowManager.isProcessingWriteQueue()?this._register(this._flowManager.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(b){return this._onData.event(b)}onClose(b){return this._onClose.event(b)}onEnd(b){return this.socket.onEnd(b)}write(b){let E=0;for(;E<b.byteLength;)this._flowManager.writeMessage(b.slice(E,Math.min(E+p.MaxWebSocketMessageLength,b.byteLength)),{compressed:!0,opcode:2}),E+=p.MaxWebSocketMessageLength}_write(b,{compressed:E,opcode:N}){if(this._isEnded)return;this.traceSocketEvent(S.SocketDiagnosticsEventType.WebSocketNodeSocketWrite,b);let O=p.MinHeaderByteSize;b.byteLength<126?O+=0:b.byteLength<2**16?O+=2:O+=8;const M=L.VSBuffer.alloc(O),U=E?64:0,H=N&15;if(M.writeUInt8(128|U|H,0),b.byteLength<126)M.writeUInt8(b.byteLength,1);else if(b.byteLength<2**16){M.writeUInt8(126,1);let F=1;M.writeUInt8(b.byteLength>>>8&255,++F),M.writeUInt8(b.byteLength>>>0&255,++F)}else{M.writeUInt8(127,1);let F=1;M.writeUInt8(0,++F),M.writeUInt8(0,++F),M.writeUInt8(0,++F),M.writeUInt8(0,++F),M.writeUInt8(b.byteLength>>>24&255,++F),M.writeUInt8(b.byteLength>>>16&255,++F),M.writeUInt8(b.byteLength>>>8&255,++F),M.writeUInt8(b.byteLength>>>0&255,++F)}this.socket.write(L.VSBuffer.concat([M,b]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(b){if(b.byteLength!==0){for(this._incomingData.acceptChunk(b);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===u.PeekHeader){const E=this._incomingData.peek(this._state.readLen),N=E.readUInt8(0),O=(N&128)>>>7,M=(N&64)>>>6,U=N&15,H=E.readUInt8(1),F=(H&128)>>>7,x=H&127;this._state.state=u.ReadHeader,this._state.readLen=p.MinHeaderByteSize+(F?4:0)+(x===126?2:0)+(x===127?8:0),this._state.fin=O,this._state.firstFrameOfMessage&&(this._state.compressed=!!M),this._state.firstFrameOfMessage=!!O,this._state.mask=0,this._state.opcode=U,this.traceSocketEvent(S.SocketDiagnosticsEventType.WebSocketNodeSocketPeekedHeader,{headerSize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,opcode:this._state.opcode})}else if(this._state.state===u.ReadHeader){const E=this._incomingData.read(this._state.readLen),N=E.readUInt8(1),O=(N&128)>>>7;let M=N&127,U=1;M===126?M=E.readUInt8(++U)*2**8+E.readUInt8(++U):M===127&&(M=E.readUInt8(++U)*0+E.readUInt8(++U)*0+E.readUInt8(++U)*0+E.readUInt8(++U)*0+E.readUInt8(++U)*2**24+E.readUInt8(++U)*2**16+E.readUInt8(++U)*2**8+E.readUInt8(++U));let H=0;O&&(H=E.readUInt8(++U)*2**24+E.readUInt8(++U)*2**16+E.readUInt8(++U)*2**8+E.readUInt8(++U)),this._state.state=u.ReadBody,this._state.readLen=M,this._state.mask=H,this.traceSocketEvent(S.SocketDiagnosticsEventType.WebSocketNodeSocketPeekedHeader,{bodySize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,mask:this._state.mask,opcode:this._state.opcode})}else if(this._state.state===u.ReadBody){const E=this._incomingData.read(this._state.readLen);this.traceSocketEvent(S.SocketDiagnosticsEventType.WebSocketNodeSocketReadData,E),r(E,this._state.mask),this.traceSocketEvent(S.SocketDiagnosticsEventType.WebSocketNodeSocketUnmaskedData,E),this._state.state=u.PeekHeader,this._state.readLen=p.MinHeaderByteSize,this._state.mask=0,this._state.opcode<=2?this._flowManager.acceptFrame(E,this._state.compressed,!!this._state.fin):this._state.opcode===9&&this._flowManager.writeMessage(E,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent(S.SocketDiagnosticsEventType.WebSocketNodeSocketDrainBegin),this._flowManager.isProcessingWriteQueue()&&await v.Event.toPromise(this._flowManager.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent(S.SocketDiagnosticsEventType.WebSocketNodeSocketDrainEnd)}}e.WebSocketNodeSocket=i;class a extends l.Disposable{get permessageDeflate(){return!!(this._zlibInflateStream&&this._zlibDeflateStream)}get recordedInflateBytes(){return this._zlibInflateStream?this._zlibInflateStream.recordedInflateBytes:L.VSBuffer.alloc(0)}constructor(b,E,N,O,M,U){super(),this._tracer=b,this._onData=M,this._writeFn=U,this._onError=this._register(new v.Emitter),this.onError=this._onError.event,this._writeQueue=[],this._readQueue=[],this._onDidFinishProcessingReadQueue=this._register(new v.Emitter),this.onDidFinishProcessingReadQueue=this._onDidFinishProcessingReadQueue.event,this._onDidFinishProcessingWriteQueue=this._register(new v.Emitter),this.onDidFinishProcessingWriteQueue=this._onDidFinishProcessingWriteQueue.event,this._isProcessingWriteQueue=!1,this._isProcessingReadQueue=!1,E?(this._zlibInflateStream=this._register(new t(this._tracer,O,N,{windowBits:15})),this._zlibDeflateStream=this._register(new n(this._tracer,{windowBits:15})),this._register(this._zlibInflateStream.onError(H=>this._onError.fire(H))),this._register(this._zlibDeflateStream.onError(H=>this._onError.fire(H)))):(this._zlibInflateStream=null,this._zlibDeflateStream=null)}writeMessage(b,E){this._writeQueue.push({data:b,options:E}),this._processWriteQueue()}async _processWriteQueue(){if(!this._isProcessingWriteQueue){for(this._isProcessingWriteQueue=!0;this._writeQueue.length>0;){const{data:b,options:E}=this._writeQueue.shift();if(this._zlibDeflateStream&&E.compressed){const N=await this._deflateMessage(this._zlibDeflateStream,b);this._writeFn(N,E)}else this._writeFn(b,{...E,compressed:!1})}this._isProcessingWriteQueue=!1,this._onDidFinishProcessingWriteQueue.fire()}}isProcessingWriteQueue(){return this._isProcessingWriteQueue}_deflateMessage(b,E){return new Promise((N,O)=>{b.write(E),b.flush(M=>N(M))})}acceptFrame(b,E,N){this._readQueue.push({data:b,isCompressed:E,isLastFrameOfMessage:N}),this._processReadQueue()}async _processReadQueue(){if(!this._isProcessingReadQueue){for(this._isProcessingReadQueue=!0;this._readQueue.length>0;){const b=this._readQueue.shift();if(this._zlibInflateStream&&b.isCompressed){const E=await this._inflateFrame(this._zlibInflateStream,b.data,b.isLastFrameOfMessage);this._onData.fire(E)}else this._onData.fire(b.data)}this._isProcessingReadQueue=!1,this._onDidFinishProcessingReadQueue.fire()}}isProcessingReadQueue(){return this._isProcessingReadQueue}_inflateFrame(b,E,N){return new Promise((O,M)=>{b.write(E),N&&b.write(L.VSBuffer.fromByteArray([0,0,255,255])),b.flush(U=>O(U))})}}class t extends l.Disposable{get recordedInflateBytes(){return this._recordInflateBytes?L.VSBuffer.concat(this._recordedInflateBytes):L.VSBuffer.alloc(0)}constructor(b,E,N,O){super(),this._tracer=b,this._recordInflateBytes=E,this._onError=this._register(new v.Emitter),this.onError=this._onError.event,this._recordedInflateBytes=[],this._pendingInflateData=[],this._zlibInflate=(0,A.createInflateRaw)(O),this._zlibInflate.on("error",M=>{this._tracer.traceSocketEvent(S.SocketDiagnosticsEventType.zlibInflateError,{message:M?.message,code:M?.code}),this._onError.fire(M)}),this._zlibInflate.on("data",M=>{this._tracer.traceSocketEvent(S.SocketDiagnosticsEventType.zlibInflateData,M),this._pendingInflateData.push(L.VSBuffer.wrap(M))}),N&&(this._tracer.traceSocketEvent(S.SocketDiagnosticsEventType.zlibInflateInitialWrite,N.buffer),this._zlibInflate.write(N.buffer),this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent(S.SocketDiagnosticsEventType.zlibInflateInitialFlushFired),this._pendingInflateData.length=0}))}write(b){this._recordInflateBytes&&this._recordedInflateBytes.push(b.clone()),this._tracer.traceSocketEvent(S.SocketDiagnosticsEventType.zlibInflateWrite,b),this._zlibInflate.write(b.buffer)}flush(b){this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent(S.SocketDiagnosticsEventType.zlibInflateFlushFired);const E=L.VSBuffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,b(E)})}}class n extends l.Disposable{constructor(b,E){super(),this._tracer=b,this._onError=this._register(new v.Emitter),this.onError=this._onError.event,this._pendingDeflateData=[],this._zlibDeflate=(0,A.createDeflateRaw)({windowBits:15}),this._zlibDeflate.on("error",N=>{this._tracer.traceSocketEvent(S.SocketDiagnosticsEventType.zlibDeflateError,{message:N?.message,code:N?.code}),this._onError.fire(N)}),this._zlibDeflate.on("data",N=>{this._tracer.traceSocketEvent(S.SocketDiagnosticsEventType.zlibDeflateData,N),this._pendingDeflateData.push(L.VSBuffer.wrap(N))})}write(b){this._tracer.traceSocketEvent(S.SocketDiagnosticsEventType.zlibDeflateWrite,b.buffer),this._zlibDeflate.write(b.buffer)}flush(b){this._zlibDeflate.flush(2,()=>{this._tracer.traceSocketEvent(S.SocketDiagnosticsEventType.zlibDeflateFlushFired);let E=L.VSBuffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,E=E.slice(0,E.byteLength-4),b(E)})}}function r(k,b){if(b===0)return;const E=k.byteLength>>>2;for(let F=0;F<E;F++){const x=k.readUInt32BE(F*4);k.writeUInt32BE(x^b,F*4)}const N=E*4,O=k.byteLength-N,M=b>>>24&255,U=b>>>16&255,H=b>>>8&255;O>=1&&k.writeUInt8(k.readUInt8(N)^M,N),O>=2&&k.writeUInt8(k.readUInt8(N+1)^U,N+1),O>=3&&k.writeUInt8(k.readUInt8(N+2)^H,N+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const d={[_.Platform.Linux]:107,[_.Platform.Mac]:103};function c(){const k=(0,f.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${k}-sock`;const b=process.platform!=="darwin"&&e.XDG_RUNTIME_DIR?e.XDG_RUNTIME_DIR:(0,D.tmpdir)(),E=(0,C.join)(b,`vscode-ipc-${k}.sock`);return w(E),E}function g(k,b,E){const O=(0,s.createHash)("sha256").update(k).digest("hex").substr(0,8);if(process.platform==="win32")return`\\\\.\\pipe\\${O}-${E}-${b}-sock`;const M=E.substr(0,4),U=b.substr(0,6);let H;return process.platform!=="darwin"&&e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?H=(0,C.join)(e.XDG_RUNTIME_DIR,`vscode-${O}-${M}-${U}.sock`):H=(0,C.join)(k,`${M}-${U}.sock`),w(H),H}function w(k){const b=d[_.platform];typeof b=="number"&&k.length>=b&&console.warn(`WARNING: IPC handle "${k}" is longer than ${b} chars, try a shorter --user-data-dir`)}class y extends T.IPCServer{static toClientConnectionEvent(b){const E=v.Event.fromNodeEventEmitter(b,"connection");return v.Event.map(E,N=>({protocol:new S.Protocol(new m(N,"ipc-server-connection")),onDidClientDisconnect:v.Event.once(v.Event.fromNodeEventEmitter(N,"close"))}))}constructor(b){super(y.toClientConnectionEvent(b)),this.server=b}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=y;function I(k){return new Promise((b,E)=>{const N=(0,h.createServer)();N.on("error",E),N.listen(k,()=>{N.removeListener("error",E),b(new y(N))})})}function P(k,b){return new Promise((E,N)=>{const O=(0,h.createConnection)(k,()=>{O.removeListener("error",N),E(S.Client.fromSocket(new m(O,`ipc-client${b}`),b))});O.once("error",N)})}}),define(Pe[357],ke([1,0,68,69,193,131,8,3,10,46,11,115,237,239,117,93,21]),function(ge,e,s,h,D,A,L,R,v,l,C,_,f,T,S,o,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedTunnelsService=e.TunnelService=e.BaseTunnelService=e.NodeRemoteTunnel=void 0,s=We(s),h=We(h);async function p(n,r,d,c,g){let w;for(let y=3;y&&(w?.dispose(),w=await new u(n,r,d,c,g).waitForReady(),!(g&&D.BROWSER_RESTRICTED_PORTS[g]||!D.BROWSER_RESTRICTED_PORTS[w.tunnelLocalPort]));y--);return w}class u extends R.Disposable{constructor(r,d,c,g,w){super(),this.defaultTunnelHost=d,this.suggestedLocalPort=w,this.privacy=o.TunnelPrivacyId.Private,this._socketsDispose=new Map,this._options=r,this._server=s.createServer(),this._barrier=new L.Barrier,this._listeningListener=()=>this._barrier.open(),this._server.on("listening",this._listeningListener),this._connectionListener=y=>this._onConnection(y),this._server.on("connection",this._connectionListener),this._errorListener=()=>{},this._server.on("error",this._errorListener),this.tunnelRemotePort=g,this.tunnelRemoteHost=c}async dispose(){super.dispose(),this._server.removeListener("listening",this._listeningListener),this._server.removeListener("connection",this._connectionListener),this._server.removeListener("error",this._errorListener),this._server.close(),Array.from(this._socketsDispose.values()).forEach(d=>{d()})}async waitForReady(){const r=this.suggestedLocalPort??this.tunnelRemotePort,d=(0,o.isAllInterfaces)(this.defaultTunnelHost)?"0.0.0.0":"127.0.0.1";let c=await(0,D.findFreePortFaster)(r,2,1e3,d),g=null;return this._server.listen(c,this.defaultTunnelHost),await this._barrier.wait(),g=this._server.address(),g||(c=0,this._server.listen(c,this.defaultTunnelHost),await this._barrier.wait(),g=this._server.address()),this.tunnelLocalPort=g.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${g.port}`,this}async _onConnection(r){r.pause();const d=(0,o.isLocalhost)(this.tunnelRemoteHost)||(0,o.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,c=await(0,f.connectRemoteAgentTunnel)(this._options,d,this.tunnelRemotePort),g=c.getSocket(),w=c.readEntireBuffer();c.dispose(),w.byteLength>0&&r.write(w.buffer),r.on("end",()=>{r.localAddress&&this._socketsDispose.delete(r.localAddress),g.end()}),r.on("close",()=>g.end()),r.on("error",()=>{r.localAddress&&this._socketsDispose.delete(r.localAddress),g instanceof A.NodeSocket?g.socket.destroy():g.end()}),g instanceof A.NodeSocket?this._mirrorNodeSocket(r,g):this._mirrorGenericSocket(r,g),r.localAddress&&this._socketsDispose.set(r.localAddress,()=>{r.end(),g.end()})}_mirrorGenericSocket(r,d){d.onClose(()=>r.destroy()),d.onEnd(()=>r.end()),d.onData(c=>r.write(c.buffer)),r.on("data",c=>d.write(m.VSBuffer.wrap(c))),r.resume()}_mirrorNodeSocket(r,d){const c=d.socket;c.on("end",()=>r.end()),c.on("close",()=>r.end()),c.on("error",()=>{r.destroy()}),c.pipe(r),r.pipe(c)}}e.NodeRemoteTunnel=u;let i=class extends o.AbstractTunnelService{constructor(r,d,c,g,w){super(d,w),this.remoteSocketFactoryService=r,this.signService=c,this.productService=g}isPortPrivileged(r){return(0,o.isPortPrivileged)(r,this.defaultTunnelHost,v.OS,h.release())}retainOrCreateTunnel(r,d,c,g,w,y,I,P){const k=this.getTunnelFromMap(d,c);if(k)return++k.refcount,k.value;if((0,o.isTunnelProvider)(r))return this.createWithProvider(r,d,c,w,y,I,P);{this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${d}:${c} on local port ${w}.`);const b={commit:this.productService.commit,quality:this.productService.quality,addressProvider:r,remoteSocketFactoryService:this.remoteSocketFactoryService,signService:this.signService,logService:this.logService,ipcLogger:null},E=p(b,g,d,c,w);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.addTunnelToMap(d,c,E),E}}};e.BaseTunnelService=i,e.BaseTunnelService=i=Qe([$e(0,T.IRemoteSocketFactoryService),$e(1,C.ILogService),$e(2,S.ISignService),$e(3,_.IProductService),$e(4,l.IConfigurationService)],i);let a=class extends i{constructor(r,d,c,g,w){super(r,d,c,g,w)}};e.TunnelService=a,e.TunnelService=a=Qe([$e(0,T.IRemoteSocketFactoryService),$e(1,C.ILogService),$e(2,S.ISignService),$e(3,_.IProductService),$e(4,l.IConfigurationService)],a);let t=class extends R.Disposable{constructor(r,d,c,g,w){super(),this.remoteSocketFactoryService=r,this.logService=d,this.productService=c,this.signService=g,this.configurationService=w,this._tunnelServices=new Map}async openTunnel(r,d,c,g,w,y,I,P,k){if(this.logService.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${c}:${g} on local port ${y}.`),!this._tunnelServices.has(r)){const b=new a(this.remoteSocketFactoryService,this.logService,this.signService,this.productService,this.configurationService);this._register(b),this._tunnelServices.set(r,b),b.onTunnelClosed(async()=>{(await b.tunnels).length===0&&(b.dispose(),this._tunnelServices.delete(r))})}return this._tunnelServices.get(r).openTunnel(d,c,g,w,y,I,P,k)}};e.SharedTunnelsService=t,e.SharedTunnelsService=t=Qe([$e(0,T.IRemoteSocketFactoryService),$e(1,C.ILogService),$e(2,_.IProductService),$e(3,S.ISignService),$e(4,l.IConfigurationService)],t)}),define(Pe[358],ke([1,0,131,255,45,35,2,11,47]),function(ge,e,s,h,D,A,L,R,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CLIServer=e.CLIServerBase=void 0,h=We(h),D=We(D);class l{constructor(f,T,S){this._commands=f,this.logService=T,this._ipcHandlePath=S,this._server=h.createServer((o,m)=>this.onRequest(o,m)),this.setup().catch(o=>(T.error(o),""))}get ipcHandlePath(){return this._ipcHandlePath}async setup(){try{this._server.listen(this.ipcHandlePath),this._server.on("error",f=>this.logService.error(f))}catch{this.logService.error("Could not start open from terminal server.")}return this._ipcHandlePath}onRequest(f,T){const S=(m,p)=>{T.writeHead(m,{"content-type":"application/json"}),T.end(JSON.stringify(p||null),u=>u&&this.logService.error(u))},o=[];f.setEncoding("utf8"),f.on("data",m=>o.push(m)),f.on("end",async()=>{try{const m=JSON.parse(o.join(""));let p;switch(m.type){case"open":p=await this.open(m);break;case"openExternal":p=await this.openExternal(m);break;case"status":p=await this.getStatus(m);break;case"extensionManagement":p=await this.manageExtensions(m);break;default:S(404,`Unknown message type: ${m.type}`);break}S(200,p)}catch(m){const p=m instanceof Error?m.message:JSON.stringify(m);S(500,p),this.logService.error("Error while processing pipe request",m)}})}async open(f){const{fileURIs:T,folderURIs:S,forceNewWindow:o,diffMode:m,mergeMode:p,addMode:u,forceReuseWindow:i,gotoLineMode:a,waitMarkerFilePath:t,remoteAuthority:n}=f,r=[];if(Array.isArray(S))for(const w of S)try{r.push({folderUri:L.URI.parse(w)})}catch{}if(Array.isArray(T))for(const w of T)try{(0,v.hasWorkspaceFileExtension)(w)?r.push({workspaceUri:L.URI.parse(w)}):r.push({fileUri:L.URI.parse(w)})}catch{}const d=t?L.URI.file(t):void 0,g={forceNewWindow:o,diffMode:m,mergeMode:p,addMode:u,gotoLineMode:a,forceReuseWindow:i,preferNewWindow:!i&&!d&&!u,waitMarkerFileURI:d,remoteAuthority:n};this._commands.executeCommand("_remoteCLI.windowOpen",r,g)}async openExternal(f){for(const T of f.uris){const S=L.URI.parse(T),o=S.scheme==="file"?S:T;await this._commands.executeCommand("_remoteCLI.openExternal",o)}}async manageExtensions(f){const T=o=>o?.map(m=>/\.vsix$/i.test(m)?L.URI.parse(m):m),S={list:f.list,install:T(f.install),uninstall:T(f.uninstall),force:f.force};return await this._commands.executeCommand("_remoteCLI.manageExtensions",S)}async getStatus(f){return await this._commands.executeCommand("_remoteCLI.getSystemStatus")}dispose(){this._server.close(),this._ipcHandlePath&&process.platform!=="win32"&&D.existsSync(this._ipcHandlePath)&&D.unlinkSync(this._ipcHandlePath)}}e.CLIServerBase=l;let C=class extends l{constructor(f,T){super(f,T,(0,s.createRandomIPCHandle)())}};e.CLIServer=C,e.CLIServer=C=Qe([$e(0,A.IExtHostCommands),$e(1,R.ILogService)],C)}),define(Pe[359],ke([1,0,63,346,340,254,54,328,2,14,9,358,110,288,327]),function(ge,e,s,h,D,A,L,R,v,l,C,_,f,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0,s=We(s);class o extends D.RequireInterceptor{_installInterceptor(){const u=this,i=globalThis._VSCODE_NODE_MODULES.module,a=i._load;i._load=function(d,c,g){return d=n(d),u._factories.has(d)?u._factories.get(d).load(d,v.URI.file((0,f.realpathSync)(c.filename)),w=>a.apply(this,[w,c,g])):a.apply(this,arguments)};const t=i._resolveLookupPaths;i._resolveLookupPaths=(r,d)=>t.call(this,n(r),d);const n=r=>{for(const d of u._alternatives){const c=d(r);if(c){r=c;break}}return r}}}class m extends L.AbstractExtHostExtensionService{constructor(){super(...arguments),this.extensionRuntime=C.ExtensionRuntime.Node}async _beforeAlmostReadyToRunExtensions(){this._instaService.createInstance(T.ExtHostConsoleForwarder);const u=this._instaService.invokeFunction(h.createApiFactoryAndRegisterActors);if(this._instaService.createInstance(R.ExtHostDownloadService),this._initData.remote.isRemote&&this._initData.remote.authority){const t=this._instaService.createInstance(_.CLIServer);process.env.VSCODE_IPC_HOOK_CLI=t.ipcHandlePath}this._instaService.createInstance(S.ExtHostDiskFileSystemProvider),await this._instaService.createInstance(o,u,{mine:this._myRegistry,all:this._globalRegistry}).install(),s.mark("code/extHost/didInitAPI");const a=await this._extHostConfiguration.getConfigProvider();await(0,A.connectProxyResolver)(this._extHostWorkspace,a,this,this._logService,this._mainThreadTelemetryProxy,this._initData),s.mark("code/extHost/didInitProxyResolver")}_getEntryPoint(u){return u.main}async _loadCommonJSModule(u,i,a){if(i.scheme!==l.Schemas.file)throw new Error(`Cannot load URI: '${i}', must be of file-scheme`);let t=null;a.codeLoadingStart(),this._logService.trace(`ExtensionService#loadCommonJSModule ${i.toString(!0)}`),this._logService.flush();const n=u?.identifier.value;u&&await this._extHostLocalizationService.initializeLocalizedMessages(u);try{n&&s.mark(`code/extHost/willLoadExtensionCode/${n}`),t=(ge.__$__nodeRequire??ge)(i.fsPath)}finally{n&&s.mark(`code/extHost/didLoadExtensionCode/${n}`),a.codeLoadingStop()}return t}async $setRemoteEnvironment(u){if(this._initData.remote.isRemote)for(const i in u){const a=u[i];a===null?delete process.env[i]:process.env[i]=a}}}e.ExtHostExtensionService=m}),define(Pe[360],ke([1,0,45,58,21,4,3,135,10,22,2,34,70,11,236,73,117,93,357,29,19,78,335]),function(ge,e,s,h,D,A,L,R,v,l,C,_,f,T,S,o,m,p,u,i,a,t,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeExtHostTunnelService=void 0,e.getSockets=r,e.loadListeningPorts=d,e.parseIpAddress=c,e.loadConnectionTable=g,e.getRootProcesses=y,e.findPorts=I,e.tryFindRootPorts=P,s=We(s),l=We(l),_=We(_);function r(E){const N=E.trim().split(`
`),O=[];return N.forEach(U=>{const H=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(U);H&&H.length>=3&&O.push({pid:parseInt(H[1],10),socket:parseInt(H[2],10)})}),O.reduce((U,H)=>(U[H.socket]=H,U),{})}function d(...E){const N=[].concat(...E.map(g));return[...new Map(N.filter(O=>O.st==="0A").map(O=>{const M=O.local_address.split(":");return{socket:parseInt(O.inode,10),ip:c(M[0]),port:parseInt(M[1],16)}}).map(O=>[O.ip+":"+O.port,O])).values()]}function c(E){let N="";if(E.length===8)for(let O=E.length-2;O>=0;O-=2)N+=parseInt(E.substr(O,2),16),O!==0&&(N+=".");else for(let O=0;O<E.length;O+=8){const M=E.substring(O,O+8);let U="";for(let H=8;H>=2;H-=2)U+=M.substring(H-2,H),(H===6||H===2)&&(U=parseInt(U,16).toString(16),N+=`${U}`,U="",O+H!==E.length-6&&(N+=":"))}return N}function g(E){const N=E.trim().split(`
`),O=N.shift().trim().split(/\s+/).filter(U=>U!=="rx_queue"&&U!=="tm->when");return N.map(U=>U.trim().split(/\s+/).reduce((H,F,x)=>(H[O[x]||x]=F,H),{}))}function w(E){return!!E.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||E.indexOf("out/server-main.js")!==-1||E.indexOf("_productName=VSCode")!==-1}function y(E){const N=E.trim().split(`
`),O=[];return N.forEach(M=>{const U=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(M);U&&U.length>=4&&O.push({pid:parseInt(U[1],10),ppid:parseInt(U[2]),cmd:U[3]})}),O}async function I(E,N,O){const M=O.reduce((H,F)=>(H[F.pid]=F,H),{}),U=[];return E.forEach(({socket:H,ip:F,port:x})=>{const $=N[H]?N[H].pid:void 0,G=$?M[$]?.cmd:void 0;$&&G&&!w(G)&&U.push({host:F,port:x,detail:G,pid:$})}),U}function P(E,N,O){const M=new Map,U=y(N);for(const H of E){const F=O.get(H.port);if(F){M.set(H.port,F);continue}const x=U.find($=>$.cmd.includes(`${H.port}`));if(x){let $=x,G;do G=U.find(B=>B.ppid===$.pid),G&&($=G);while(G);M.set(H.port,{host:H.ip,port:H.port,pid:$.pid,detail:$.cmd,ppid:$.ppid})}else M.set(H.port,{host:H.ip,port:H.port,ppid:Number.MAX_VALUE})}return M}let k=class extends t.ExtHostTunnelService{constructor(N,O,M,U){super(N,O,M),this.initData=O,this.signService=U,this._initialCandidates=void 0,this._foundRootPorts=new Map,this._candidateFindingEnabled=!1,v.isLinux&&O.remote.isRemote&&O.remote.authority&&(this._proxy.$setRemoteTunnelService(process.pid),this.setInitialCandidates())}async $registerCandidateFinder(N){if(N&&this._candidateFindingEnabled)return;this._candidateFindingEnabled=N;let O;this._initialCandidates&&(O=this._initialCandidates,await this._proxy.$onFoundNewCandidates(this._initialCandidates));const M=new R.MovingAverage;let U=0;for(;this._candidateFindingEnabled;){const H=new Date().getTime(),F=(await this.findCandidatePorts()).filter(G=>(0,p.isLocalhost)(G.host)||(0,p.isAllInterfaces)(G.host));this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${F.map(G=>G.port).join(", ")}`);const x=new Date().getTime()-H;this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) candidate port scan took ${x} ms.`),U++>3&&M.update(x),(!O||JSON.stringify(O)!==JSON.stringify(F))&&(O=F,await this._proxy.$onFoundNewCandidates(O));const $=this.calculateDelay(M.value);this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) next candidate port scan in ${$} ms.`),await new Promise(G=>setTimeout(()=>G(),$))}}calculateDelay(N){return Math.max(N*20,2e3)}async setInitialCandidates(){this._initialCandidates=await this.findCandidatePorts(),this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) Initial candidates found: ${this._initialCandidates.map(N=>N.port).join(", ")}`)}async findCandidatePorts(){let N="",O="";try{N=await s.promises.readFile("/proc/net/tcp","utf8"),O=await s.promises.readFile("/proc/net/tcp6","utf8")}catch{}const M=d(N,O),U=await new Promise(Z=>{(0,h.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(J,oe,te)=>{Z(oe)})}),H=r(U),F=await _.Promises.readdir("/proc"),x=[];for(const Z of F)try{const J=Number(Z),oe=l.joinPath(C.URI.file("/proc"),Z);if((await s.promises.stat(oe.fsPath)).isDirectory()&&!isNaN(J)){const me=await s.promises.readlink(l.joinPath(oe,"cwd").fsPath),le=await s.promises.readFile(l.joinPath(oe,"cmdline").fsPath,"utf8");x.push({pid:J,cwd:me,cmd:le})}}catch{}const $=[],G=M.filter(Z=>{const J=H[Z.socket];return J||$.push(Z),J}),B=I(G,H,x);let W;if(this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${$.length}`),$.length>0){const Z=await new Promise(J=>{(0,h.exec)("ps -F -A -l | grep root",(oe,te,me)=>{J(te)})});this._foundRootPorts=P($,Z,this._foundRootPorts),W=Array.from(this._foundRootPorts.values()),this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${W.map(J=>J.port).join(", ")}`)}return B.then(Z=>W?Z.concat(W):Z)}makeManagedTunnelFactory(N){return async O=>{const M=new u.NodeRemoteTunnel({commit:this.initData.commit,quality:this.initData.quality,logService:this.logService,ipcLogger:null,remoteSocketFactoryService:{_serviceBrand:void 0,async connect(H,F,x,$){const G=await N.makeConnection();return b.connect(G,F,x,$)},register(){throw new Error("not implemented")}},addressProvider:{getAddress(){return Promise.resolve({connectTo:new o.ManagedRemoteConnection(0),connectionToken:N.connectionToken})}},signService:this.signService},"localhost",O.remoteAddress.host||"localhost",O.remoteAddress.port,O.localAddressPort);await M.waitForReady();const U=new A.Emitter;return{localAddress:(0,n.parseAddress)(M.localAddress)??M.localAddress,remoteAddress:{port:M.tunnelRemotePort,host:M.tunnelRemoteHost},onDidDispose:U.event,dispose:()=>{M.dispose(),U.fire(),U.dispose()}}}}};e.NodeExtHostTunnelService=k,e.NodeExtHostTunnelService=k=Qe([$e(0,a.IExtHostRpcService),$e(1,i.IExtHostInitDataService),$e(2,T.ILogService),$e(3,m.ISignService)],k);class b extends S.ManagedSocket{static connect(N,O,M,U){const H=new L.DisposableStore,F={onClose:H.add(new A.Emitter),onData:H.add(new A.Emitter),onEnd:H.add(new A.Emitter)};H.add(N.onDidReceiveMessage($=>F.onData.fire(D.VSBuffer.wrap($)))),H.add(N.onDidEnd(()=>F.onEnd.fire())),H.add(N.onDidClose($=>F.onClose.fire({type:f.SocketCloseEventType.NodeSocketCloseEvent,error:$,hadError:!!$})));const x=new b(N,U,F);return x._register(H),(0,S.connectManagedSocket)(x,O,M,U,F)}constructor(N,O,M){super(O,M),this.passing=N}write(N){this.passing.send(N.buffer)}closeRemote(){this.passing.end()}async drain(){await this.passing.drain?.()}}}),define(Pe[361],ke([1,0,89,330,343,342,356,359,360,101,54,102,100,48,78,98,329,289,11,344,66,250,112,117,152]),function(ge,e,s,h,D,A,L,R,v,l,C,_,f,T,S,o,m,p,u,i,a,t,n,r,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,s.registerSingleton)(C.IExtHostExtensionService,R.ExtHostExtensionService,s.InstantiationType.Eager),(0,s.registerSingleton)(u.ILoggerService,p.ExtHostLoggerService,s.InstantiationType.Delayed),(0,s.registerSingleton)(u.ILogService,new n.SyncDescriptor(t.ExtHostLogService,[!1],!0)),(0,s.registerSingleton)(r.ISignService,d.SignService,s.InstantiationType.Delayed),(0,s.registerSingleton)(o.IExtensionStoragePaths,m.ExtensionStoragePaths,s.InstantiationType.Eager),(0,s.registerSingleton)(l.IExtHostDebugService,A.ExtHostDebugService,s.InstantiationType.Eager),(0,s.registerSingleton)(_.IExtHostSearch,L.NativeExtHostSearch,s.InstantiationType.Eager),(0,s.registerSingleton)(f.IExtHostTask,D.ExtHostTask,s.InstantiationType.Eager),(0,s.registerSingleton)(T.IExtHostTerminalService,h.ExtHostTerminalService,s.InstantiationType.Eager),(0,s.registerSingleton)(S.IExtHostTunnelService,v.NodeExtHostTunnelService,s.InstantiationType.Eager),(0,s.registerSingleton)(a.IExtHostVariableResolverProvider,i.NodeExtHostVariableResolverProviderService,s.InstantiationType.Eager)});var Vt=this&&this.__importDefault||function(ge){return ge&&ge.__esModule?ge:{default:ge}};define(Pe[371],ke([1,0,372,68,8,21,12,63,110,34,70,131,113,234,341,256,271,94,347,361]),function(ge,e,s,h,D,A,L,R,v,l,C,_,f,T,S,o,m,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),s=Vt(s),h=We(h),R=We(R),T=Vt(T),function(){for(let y=0;y<process.execArgv.length;y++)process.execArgv[y]==="--inspect-port=0"&&(process.execArgv.splice(y,1),y--)}();const u=(0,s.default)(process.argv.slice(2),{boolean:["transformURIs","skipWorkspaceStorageLock"],string:["useHostProxy"]});(function(){const w=globalThis._VSCODE_NODE_MODULES.module,y=w._load;w._load=function(I){if(I==="natives")throw new Error('Either the extension or an NPM dependency is using the [unsupported "natives" node module](https://go.microsoft.com/fwlink/?linkid=871887).');return y.apply(this,arguments)}})();const i=process.exit.bind(process),a=process.on.bind(process);function t(w){process.exit=function(y){if(w)i(y);else{const I=new Error("An extension called process.exit() and this was prevented.");console.warn(I.stack)}},process.crash=function(){const y=new Error("An extension called process.crash() and this was prevented.");console.warn(y.stack)},process.env.ELECTRON_RUN_AS_NODE="1",process.on=function(y,I){y==="uncaughtException"&&(I=function(){try{return I.call(void 0,arguments)}catch{}}),a(y,I)}}let n=function(w){i()};function r(){const w=(0,m.readExtHostConnection)(process.env);if(w.type===m.ExtHostConnectionType.MessagePort)return new Promise((y,I)=>{const P=k=>{const b=k[0],E=new C.BufferedEmitter;b.on("message",N=>E.fire(A.VSBuffer.wrap(N.data))),b.on("close",()=>{n("renderer closed the MessagePort")}),b.start(),y({onMessage:E.event,send:N=>b.postMessage(N.buffer)})};process.parentPort.on("message",k=>P(k.ports))});if(w.type===m.ExtHostConnectionType.Socket)return new Promise((y,I)=>{let P=null;const k=setTimeout(()=>{n("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4),b=C.ProtocolConstants.ReconnectionGraceTime,E=C.ProtocolConstants.ReconnectionShortGraceTime,N=new D.ProcessTimeRunOnceScheduler(()=>n("renderer disconnected for too long (1)"),b),O=new D.ProcessTimeRunOnceScheduler(()=>n("renderer disconnected for too long (2)"),E);process.on("message",(U,H)=>{if(U&&U.type==="VSCODE_EXTHOST_IPC_SOCKET"){H.setNoDelay(!0);const F=A.VSBuffer.wrap(Buffer.from(U.initialDataChunk,"base64"));let x;if(U.skipWebSocketFrames)x=new _.NodeSocket(H,"extHost-socket");else{const $=A.VSBuffer.wrap(Buffer.from(U.inflateBytes,"base64"));x=new _.WebSocketNodeSocket(new _.NodeSocket(H,"extHost-socket"),U.permessageDeflate,$,!1)}P?(N.cancel(),O.cancel(),P.beginAcceptReconnection(x,F),P.endAcceptReconnection(),P.sendResume()):(clearTimeout(k),P=new C.PersistentProtocol({socket:x,initialChunk:F}),P.sendResume(),P.onDidDispose(()=>n("renderer disconnected")),y(P),P.onSocketClose(()=>{N.schedule()}))}if(U&&U.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(O.isScheduled())return;N.isScheduled()&&O.schedule()}});const M={type:"VSCODE_EXTHOST_IPC_READY"};process.send?.(M)});{const y=w.pipeName;return new Promise((I,P)=>{const k=h.createConnection(y,()=>{k.removeListener("error",P);const b=new C.PersistentProtocol({socket:new _.NodeSocket(k,"extHost-renderer")});b.sendResume(),I(b)});k.once("error",P),k.on("close",()=>{n("renderer closed the socket")})})}}async function d(){const w=await r();return new class{constructor(){this._onMessage=new C.BufferedEmitter,this.onMessage=this._onMessage.event,this._terminating=!1,this._protocolListener=w.onMessage(y=>{(0,p.isMessageOfType)(y,p.MessageType.Terminate)?(this._terminating=!0,this._protocolListener.dispose(),n("received terminate message from renderer")):this._onMessage.fire(y)})}send(y){this._terminating||w.send(y)}async drain(){if(w.drain)return w.drain()}}}function c(w){return new Promise(y=>{const I=w.onMessage(P=>{I.dispose();const k=JSON.parse(P.toString()),b=k.commit,E=T.default.commit;if(b&&E&&b!==E&&i(p.ExtensionHostExitCode.VersionMismatch),k.parentPid){let N=0;setInterval(function(){try{process.kill(k.parentPid,0),N=0}catch(M){M&&M.code==="EPERM"?(N++,N>=3&&n(`parent process ${k.parentPid} does not exist anymore (3 x EPERM): ${M.message} (code: ${M.code}) (errno: ${M.errno})`)):n(`parent process ${k.parentPid} does not exist anymore: ${M.message} (code: ${M.code}) (errno: ${M.errno})`)}},1e3);let O;try{O=globalThis._VSCODE_NODE_MODULES["native-watchdog"],O.start(k.parentPid)}catch(M){(0,L.onUnexpectedError)(M)}}w.send((0,p.createMessageOfType)(p.MessageType.Initialized)),y({protocol:w,initData:k})});w.send((0,p.createMessageOfType)(p.MessageType.Ready))})}async function g(){const w=[];process.on("unhandledRejection",(N,O)=>{w.push(O),setTimeout(()=>{const M=w.indexOf(O);M>=0&&O.catch(U=>{w.splice(M,1),(0,L.isCancellationError)(U)||(console.warn(`rejected promise not handled within 1 second: ${U}`),U&&U.stack&&console.warn(`stack trace: ${U.stack}`),N&&(0,L.onUnexpectedError)(N))})},1e3)}),process.on("rejectionHandled",N=>{const O=w.indexOf(N);O>=0&&w.splice(O,1)}),process.on("uncaughtException",function(N){(0,L.isSigPipeError)(N)||(0,L.onUnexpectedError)(N)}),R.mark("code/extHost/willConnectToRenderer");const y=await d();R.mark("code/extHost/didConnectToRenderer");const I=await c(y);R.mark("code/extHost/didWaitForInitData");const{initData:P}=I;t(!!P.environment.extensionTestsLocationURI),P.environment.useHostProxy=u.useHostProxy!==void 0?u.useHostProxy!=="false":void 0,P.environment.skipWorkspaceStorageLock=(0,f.boolean)(u.skipWorkspaceStorageLock,!1);const k=new class{constructor(){this.pid=process.pid}exit(O){i(O)}fsExists(O){return l.Promises.exists(O)}fsRealpath(O){return(0,v.realpath)(O)}};let b=null;P.remote.authority&&u.transformURIs&&(b=(0,o.createURITransformer)(P.remote.authority));const E=new S.ExtensionHostMain(I.protocol,P,k,b);n=N=>E.terminate(N)}g().catch(w=>console.log(w))})}).call(this);

//# sourceMappingURL=https://main.vscode-cdn.net/sourcemaps/532bdf24071d0a26ceea0844dcdf5ee8cfabd562/core/vs/workbench/api/node/extensionHostProcess.js.map
