/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ke=["exports","require","vs/base/common/uri","vs/platform/instantiation/common/instantiation","vs/base/common/lifecycle","vs/workbench/api/common/extHost.protocol","vs/base/common/event","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/nls","vs/base/common/async","vs/platform/log/common/log","vs/base/common/errors","vs/base/common/strings","vs/base/common/types","vs/base/common/network","vs/workbench/api/common/extHostRpcService","vs/base/common/arrays","vs/platform/extensions/common/extensions","vs/base/common/cancellation","vs/base/common/buffer","vs/workbench/services/extensions/common/extensions","vs/base/common/path","vs/base/common/platform","vs/base/common/resources","vs/base/common/objects","vs/workbench/api/common/extHostInitDataService","vs/base/common/map","vs/platform/files/common/files","vs/platform/registry/common/platform","vs/base/common/charCode","vs/platform/contextkey/common/contextkey","vs/editor/common/core/range","vs/base/common/uuid","vs/base/common/marshalling","vs/workbench/api/common/extHostCommands","vs/base/common/themables","vs/base/common/severity","vs/base/common/marshallingIds","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/services/search/common/search","vs/base/common/iterator","vs/base/common/errorMessage","vs/base/common/glob","vs/platform/configuration/common/configuration","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/ternarySearchTree","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostFileSystemInfo","vs/base/common/lazy","vs/editor/common/model","vs/platform/configuration/common/configurationRegistry","vs/workbench/contrib/testing/common/testId","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/services/search/common/searchExtTypes","vs/base/common/htmlContent","vs/platform/instantiation/common/extensions","vs/base/common/assert","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/base/common/performance","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostWebview","vs/workbench/api/common/extHostFileSystemConsumer","vs/base/common/stopwatch","vs/workbench/api/common/extHostEditorTabs","vs/base/common/decorators","vs/base/common/mime","vs/base/common/extpath","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/serviceCollection","vs/base/common/hash","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/base/common/process","vs/workbench/api/common/cache","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostTunnelService","vs/editor/common/languages","vs/workbench/api/common/extHostLanguageModels","vs/workbench/api/common/extHostTesting","vs/base/common/idGenerator","vs/base/common/codicons","vs/base/common/iconLabels","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeBase","vs/editor/common/core/position","vs/editor/common/model/textModelSearch","vs/base/common/labels","vs/editor/common/services/semanticTokensDto","vs/platform/extensions/common/extensionsApiProposals","vs/editor/common/config/editorOptions","vs/platform/environment/common/environment","vs/platform/markers/common/markers","vs/platform/product/common/productService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/telemetry/common/telemetry","vs/platform/uriIdentity/common/uriIdentity","vs/platform/userDataProfile/common/userDataProfile","vs/workbench/common/editor","vs/workbench/contrib/chat/common/chatAgents","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/authentication/common/authentication","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTerminalShellIntegration","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostOutput","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostVariableResolverService","vs/workbench/api/common/extHostDebugService","vs/workbench/services/search/common/searchExtConversionTypes","vs/workbench/api/common/extHostSearch","vs/base/common/equals","vs/base/common/json","vs/base/common/jsonSchema","vs/base/common/marked/marked","vs/base/common/naturalLanguage/korean","vs/base/common/numbers","vs/base/common/observableInternal/debugName","vs/base/common/observableInternal/logging","vs/base/common/observableInternal/base","vs/base/common/prefixTree","vs/base/common/scrollable","vs/base/common/stream","vs/base/common/filters","vs/base/common/dataTransfer","vs/editor/common/core/eolCounter","vs/editor/common/core/textModelDefaults","vs/editor/common/languages/languageConfiguration","vs/editor/common/encodedTokenAttributes","vs/editor/common/model/pieceTreeTextBuffer/rbTreeBase","vs/editor/common/services/treeViewsDnd","vs/base/common/actions","vs/base/common/date","vs/base/common/comparers","vs/base/common/uriIpc","vs/base/parts/storage/common/storage","vs/editor/common/core/stringBuilder","vs/editor/common/core/textChange","vs/editor/common/languageSelector","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBuffer","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBufferBuilder","vs/platform/contextkey/common/scanner","vs/platform/instantiation/common/graph","vs/platform/accessibility/common/accessibility","vs/editor/common/core/wordHelper","vs/platform/instantiation/common/instantiationService","vs/base/common/linkedList","vs/platform/log/common/logService","vs/platform/notification/common/notification","vs/platform/configuration/common/configurationModels","vs/platform/extensions/common/extensionValidator","vs/platform/request/common/request","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminal","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/tunnel/common/tunnel","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/platform/storage/common/storage","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/common/views","vs/workbench/contrib/chat/common/chatContextKeys","vs/workbench/contrib/chat/common/chatService","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/notebook/common/notebookKernelService","vs/workbench/contrib/search/common/cellSearchModel","vs/workbench/contrib/testing/common/constants","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/environment/common/environmentService","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/contrib/chat/common/languageModels","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostEmbedding","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostSpeech","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/worker/extHostConsoleForwarder","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/notebook/common/notebookDocumentService","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostTheming","vs/base/common/functional","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChatAgents2","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostDocuments","vs/base/common/collections","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguageModelTools","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/services/output/common/output","vs/workbench/common/configuration","vs/workbench/services/editor/common/editorResolverService","vs/workbench/services/path/common/pathService","vs/workbench/contrib/search/common/searchNotebookHelpers","vs/workbench/api/common/extHostNotebook","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/uint","vs/base/common/semver/semver","vs/base/common/codiconsUtil","vs/base/common/arraysFind","vs/editor/common/model/mirrorTextModel","vs/editor/common/languages/linkComputer","vs/editor/common/core/selection","vs/workbench/api/worker/extensionHostWorker"],Re=function(Ee){for(var e=[],S=0,T=Ee.length;S<T;S++)e[S]=ke[Ee[S]];return e};define(ke[71],Re([1,0]),function(Ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.memoize=T,e.debounce=D,e.throttle=O;function S(k){return(A,m,s)=>{let I=null,E=null;if(typeof s.value=="function"?(I="value",E=s.value):typeof s.get=="function"&&(I="get",E=s.get),!E)throw new Error("not supported");s[I]=k(E,m)}}function T(k,A,m){let s=null,I=null;if(typeof m.value=="function"?(s="value",I=m.value,I.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof m.get=="function"&&(s="get",I=m.get),!I)throw new Error("not supported");const E=`$memoize$${A}`;m[s]=function(...u){return this.hasOwnProperty(E)||Object.defineProperty(this,E,{configurable:!1,enumerable:!1,writable:!1,value:I.apply(this,u)}),this[E]}}function D(k,A,m){return S((s,I)=>{const E=`$debounce$${I}`,u=`$debounce$result$${I}`;return function(...C){this[u]||(this[u]=m?m():void 0),clearTimeout(this[E]),A&&(this[u]=A(this[u],...C),C=[this[u]]),this[E]=setTimeout(()=>{s.apply(this,C),this[u]=m?m():void 0},k)}})}function O(k,A,m){return S((s,I)=>{const E=`$throttle$timer$${I}`,u=`$throttle$result$${I}`,C=`$throttle$lastRun$${I}`,v=`$throttle$pending$${I}`;return function(...r){if(this[u]||(this[u]=m?m():void 0),(this[C]===null||this[C]===void 0)&&(this[C]=-Number.MAX_VALUE),A&&(this[u]=A(this[u],...r)),this[v])return;const a=this[C]+k;a<=Date.now()?(this[C]=Date.now(),s.apply(this,[this[u]]),this[u]=m?m():void 0):(this[v]=!0,this[E]=setTimeout(()=>{this[v]=!1,this[C]=Date.now(),s.apply(this,[this[u]]),this[u]=m?m():void 0},a-Date.now()))}})}});var jn=this&&this.__createBinding||(Object.create?function(Ee,e,S,T){T===void 0&&(T=S);var D=Object.getOwnPropertyDescriptor(e,S);(!D||("get"in D?!e.__esModule:D.writable||D.configurable))&&(D={enumerable:!0,get:function(){return e[S]}}),Object.defineProperty(Ee,T,D)}:function(Ee,e,S,T){T===void 0&&(T=S),Ee[T]=e[S]}),qn=this&&this.__setModuleDefault||(Object.create?function(Ee,e){Object.defineProperty(Ee,"default",{enumerable:!0,value:e})}:function(Ee,e){Ee.default=e}),Ve=this&&this.__importStar||function(Ee){if(Ee&&Ee.__esModule)return Ee;var e={};if(Ee!=null)for(var S in Ee)S!=="default"&&Object.prototype.hasOwnProperty.call(Ee,S)&&jn(e,Ee,S);return qn(e,Ee),e};define(ke[137],Re([1,0,17]),function(Ee,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.strictEquals=void 0,e.itemsEquals=D,e.jsonStringifyEquals=O,e.itemEquals=k,e.equalsIfDefined=A,e.structuralEquals=m,e.getStructuralKey=s,S=Ve(S);const T=(C,v)=>C===v;e.strictEquals=T;function D(C=e.strictEquals){return(v,r)=>S.equals(v,r,C)}function O(){return(C,v)=>JSON.stringify(C)===JSON.stringify(v)}function k(){return(C,v)=>C.equals(v)}function A(C,v,r){if(r!==void 0){const a=C;return a==null||v===void 0||v===null?v===a:r(a,v)}else{const a=C;return(d,l)=>d==null||l===void 0||l===null?l===d:a(d,l)}}function m(C,v){if(C===v)return!0;if(Array.isArray(C)&&Array.isArray(v)){if(C.length!==v.length)return!1;for(let r=0;r<C.length;r++)if(!m(C[r],v[r]))return!1;return!0}if(C&&typeof C=="object"&&v&&typeof v=="object"&&Object.getPrototypeOf(C)===Object.prototype&&Object.getPrototypeOf(v)===Object.prototype){const r=C,a=v,d=Object.keys(r),l=Object.keys(a),i=new Set(l);if(d.length!==l.length)return!1;for(const n of d)if(!i.has(n)||!m(r[n],a[n]))return!1;return!0}return!1}function s(C){return JSON.stringify(u(C))}let I=0;const E=new WeakMap;function u(C){if(Array.isArray(C))return C.map(u);if(C&&typeof C=="object")if(Object.getPrototypeOf(C)===Object.prototype){const v=C,r=Object.create(null);for(const a of Object.keys(v).sort())r[a]=u(v[a]);return r}else{let v=E.get(C);return v===void 0&&(v=I++,E.set(C,v)),v+"----2b76a038c20c4bcc"}return C}}),define(ke[97],Re([1,0]),function(Ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class S{constructor(D){this._prefix=D,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=S,e.defaultGenerator=new S("id#")}),define(ke[138],Re([1,0]),function(Ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.createScanner=k,e.getLocation=E,e.parse=u,e.parseTree=C,e.findNodeAtLocation=v,e.getNodePath=r,e.getNodeValue=a,e.contains=d,e.findNodeAtOffset=l,e.visit=i,e.getNodeType=n;var S;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(S||(e.ScanError=S={}));var T;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(T||(e.SyntaxKind=T={}));var D;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(D||(e.ParseErrorCode=D={}));var O;(function(t){t.DEFAULT={allowTrailingComma:!0}})(O||(e.ParseOptions=O={}));function k(t,o=!1){let c=0;const g=t.length;let f="",h=0,_=T.Unknown,y=S.None;function w(F){let K=0,J=0;for(;K<F;){const $=t.charCodeAt(c);if($>=I._0&&$<=I._9)J=J*16+$-I._0;else if($>=I.A&&$<=I.F)J=J*16+$-I.A+10;else if($>=I.a&&$<=I.f)J=J*16+$-I.a+10;else break;c++,K++}return K<F&&(J=-1),J}function P(F){c=F,f="",h=0,_=T.Unknown,y=S.None}function R(){const F=c;if(t.charCodeAt(c)===I._0)c++;else for(c++;c<t.length&&s(t.charCodeAt(c));)c++;if(c<t.length&&t.charCodeAt(c)===I.dot)if(c++,c<t.length&&s(t.charCodeAt(c)))for(c++;c<t.length&&s(t.charCodeAt(c));)c++;else return y=S.UnexpectedEndOfNumber,t.substring(F,c);let K=c;if(c<t.length&&(t.charCodeAt(c)===I.E||t.charCodeAt(c)===I.e))if(c++,(c<t.length&&t.charCodeAt(c)===I.plus||t.charCodeAt(c)===I.minus)&&c++,c<t.length&&s(t.charCodeAt(c))){for(c++;c<t.length&&s(t.charCodeAt(c));)c++;K=c}else y=S.UnexpectedEndOfNumber;return t.substring(F,K)}function p(){let F="",K=c;for(;;){if(c>=g){F+=t.substring(K,c),y=S.UnexpectedEndOfString;break}const J=t.charCodeAt(c);if(J===I.doubleQuote){F+=t.substring(K,c),c++;break}if(J===I.backslash){if(F+=t.substring(K,c),c++,c>=g){y=S.UnexpectedEndOfString;break}switch(t.charCodeAt(c++)){case I.doubleQuote:F+='"';break;case I.backslash:F+="\\";break;case I.slash:F+="/";break;case I.b:F+="\b";break;case I.f:F+="\f";break;case I.n:F+=`
`;break;case I.r:F+="\r";break;case I.t:F+="	";break;case I.u:{const x=w(4);x>=0?F+=String.fromCharCode(x):y=S.InvalidUnicode;break}default:y=S.InvalidEscapeCharacter}K=c;continue}if(J>=0&&J<=31)if(m(J)){F+=t.substring(K,c),y=S.UnexpectedEndOfString;break}else y=S.InvalidCharacter;c++}return F}function b(){if(f="",y=S.None,h=c,c>=g)return h=g,_=T.EOF;let F=t.charCodeAt(c);if(A(F)){do c++,f+=String.fromCharCode(F),F=t.charCodeAt(c);while(A(F));return _=T.Trivia}if(m(F))return c++,f+=String.fromCharCode(F),F===I.carriageReturn&&t.charCodeAt(c)===I.lineFeed&&(c++,f+=`
`),_=T.LineBreakTrivia;switch(F){case I.openBrace:return c++,_=T.OpenBraceToken;case I.closeBrace:return c++,_=T.CloseBraceToken;case I.openBracket:return c++,_=T.OpenBracketToken;case I.closeBracket:return c++,_=T.CloseBracketToken;case I.colon:return c++,_=T.ColonToken;case I.comma:return c++,_=T.CommaToken;case I.doubleQuote:return c++,f=p(),_=T.StringLiteral;case I.slash:{const K=c-1;if(t.charCodeAt(c+1)===I.slash){for(c+=2;c<g&&!m(t.charCodeAt(c));)c++;return f=t.substring(K,c),_=T.LineCommentTrivia}if(t.charCodeAt(c+1)===I.asterisk){c+=2;const J=g-1;let $=!1;for(;c<J;){if(t.charCodeAt(c)===I.asterisk&&t.charCodeAt(c+1)===I.slash){c+=2,$=!0;break}c++}return $||(c++,y=S.UnexpectedEndOfComment),f=t.substring(K,c),_=T.BlockCommentTrivia}return f+=String.fromCharCode(F),c++,_=T.Unknown}case I.minus:if(f+=String.fromCharCode(F),c++,c===g||!s(t.charCodeAt(c)))return _=T.Unknown;case I._0:case I._1:case I._2:case I._3:case I._4:case I._5:case I._6:case I._7:case I._8:case I._9:return f+=R(),_=T.NumericLiteral;default:for(;c<g&&N(F);)c++,F=t.charCodeAt(c);if(h!==c){switch(f=t.substring(h,c),f){case"true":return _=T.TrueKeyword;case"false":return _=T.FalseKeyword;case"null":return _=T.NullKeyword}return _=T.Unknown}return f+=String.fromCharCode(F),c++,_=T.Unknown}}function N(F){if(A(F)||m(F))return!1;switch(F){case I.closeBrace:case I.closeBracket:case I.openBrace:case I.openBracket:case I.doubleQuote:case I.colon:case I.comma:case I.slash:return!1}return!0}function L(){let F;do F=b();while(F>=T.LineCommentTrivia&&F<=T.Trivia);return F}return{setPosition:P,getPosition:()=>c,scan:o?L:b,getToken:()=>_,getTokenValue:()=>f,getTokenOffset:()=>h,getTokenLength:()=>c-h,getTokenError:()=>y}}function A(t){return t===I.space||t===I.tab||t===I.verticalTab||t===I.formFeed||t===I.nonBreakingSpace||t===I.ogham||t>=I.enQuad&&t<=I.zeroWidthSpace||t===I.narrowNoBreakSpace||t===I.mathematicalSpace||t===I.ideographicSpace||t===I.byteOrderMark}function m(t){return t===I.lineFeed||t===I.carriageReturn||t===I.lineSeparator||t===I.paragraphSeparator}function s(t){return t>=I._0&&t<=I._9}var I;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(I||(I={}));function E(t,o){const c=[],g=new Object;let f;const h={value:{},offset:0,length:0,type:"object",parent:void 0};let _=!1;function y(w,P,R,p){h.value=w,h.offset=P,h.length=R,h.type=p,h.colonOffset=void 0,f=h}try{i(t,{onObjectBegin:(w,P)=>{if(o<=w)throw g;f=void 0,_=o>w,c.push("")},onObjectProperty:(w,P,R)=>{if(o<P||(y(w,P,R,"property"),c[c.length-1]=w,o<=P+R))throw g},onObjectEnd:(w,P)=>{if(o<=w)throw g;f=void 0,c.pop()},onArrayBegin:(w,P)=>{if(o<=w)throw g;f=void 0,c.push(0)},onArrayEnd:(w,P)=>{if(o<=w)throw g;f=void 0,c.pop()},onLiteralValue:(w,P,R)=>{if(o<P||(y(w,P,R,n(w)),o<=P+R))throw g},onSeparator:(w,P,R)=>{if(o<=P)throw g;if(w===":"&&f&&f.type==="property")f.colonOffset=P,_=!1,f=void 0;else if(w===","){const p=c[c.length-1];typeof p=="number"?c[c.length-1]=p+1:(_=!0,c[c.length-1]=""),f=void 0}}})}catch(w){if(w!==g)throw w}return{path:c,previousNode:f,isAtPropertyKey:_,matches:w=>{let P=0;for(let R=0;P<w.length&&R<c.length;R++)if(w[P]===c[R]||w[P]==="*")P++;else if(w[P]!=="**")return!1;return P===w.length}}}function u(t,o=[],c=O.DEFAULT){let g=null,f=[];const h=[];function _(w){Array.isArray(f)?f.push(w):g!==null&&(f[g]=w)}return i(t,{onObjectBegin:()=>{const w={};_(w),h.push(f),f=w,g=null},onObjectProperty:w=>{g=w},onObjectEnd:()=>{f=h.pop()},onArrayBegin:()=>{const w=[];_(w),h.push(f),f=w,g=null},onArrayEnd:()=>{f=h.pop()},onLiteralValue:_,onError:(w,P,R)=>{o.push({error:w,offset:P,length:R})}},c),f[0]}function C(t,o=[],c=O.DEFAULT){let g={type:"array",offset:-1,length:-1,children:[],parent:void 0};function f(w){g.type==="property"&&(g.length=w-g.offset,g=g.parent)}function h(w){return g.children.push(w),w}i(t,{onObjectBegin:w=>{g=h({type:"object",offset:w,length:-1,parent:g,children:[]})},onObjectProperty:(w,P,R)=>{g=h({type:"property",offset:P,length:-1,parent:g,children:[]}),g.children.push({type:"string",value:w,offset:P,length:R,parent:g})},onObjectEnd:(w,P)=>{g.length=w+P-g.offset,g=g.parent,f(w+P)},onArrayBegin:(w,P)=>{g=h({type:"array",offset:w,length:-1,parent:g,children:[]})},onArrayEnd:(w,P)=>{g.length=w+P-g.offset,g=g.parent,f(w+P)},onLiteralValue:(w,P,R)=>{h({type:n(w),offset:P,length:R,parent:g,value:w}),f(P+R)},onSeparator:(w,P,R)=>{g.type==="property"&&(w===":"?g.colonOffset=P:w===","&&f(P))},onError:(w,P,R)=>{o.push({error:w,offset:P,length:R})}},c);const y=g.children[0];return y&&delete y.parent,y}function v(t,o){if(!t)return;let c=t;for(const g of o)if(typeof g=="string"){if(c.type!=="object"||!Array.isArray(c.children))return;let f=!1;for(const h of c.children)if(Array.isArray(h.children)&&h.children[0].value===g){c=h.children[1],f=!0;break}if(!f)return}else{const f=g;if(c.type!=="array"||f<0||!Array.isArray(c.children)||f>=c.children.length)return;c=c.children[f]}return c}function r(t){if(!t.parent||!t.parent.children)return[];const o=r(t.parent);if(t.parent.type==="property"){const c=t.parent.children[0].value;o.push(c)}else if(t.parent.type==="array"){const c=t.parent.children.indexOf(t);c!==-1&&o.push(c)}return o}function a(t){switch(t.type){case"array":return t.children.map(a);case"object":{const o=Object.create(null);for(const c of t.children){const g=c.children[1];g&&(o[c.children[0].value]=a(g))}return o}case"null":case"string":case"number":case"boolean":return t.value;default:return}}function d(t,o,c=!1){return o>=t.offset&&o<t.offset+t.length||c&&o===t.offset+t.length}function l(t,o,c=!1){if(d(t,o,c)){const g=t.children;if(Array.isArray(g))for(let f=0;f<g.length&&g[f].offset<=o;f++){const h=l(g[f],o,c);if(h)return h}return t}}function i(t,o,c=O.DEFAULT){const g=k(t,!1);function f(ie){return ie?()=>ie(g.getTokenOffset(),g.getTokenLength()):()=>!0}function h(ie){return ie?ue=>ie(ue,g.getTokenOffset(),g.getTokenLength()):()=>!0}const _=f(o.onObjectBegin),y=h(o.onObjectProperty),w=f(o.onObjectEnd),P=f(o.onArrayBegin),R=f(o.onArrayEnd),p=h(o.onLiteralValue),b=h(o.onSeparator),N=f(o.onComment),L=h(o.onError),F=c&&c.disallowComments,K=c&&c.allowTrailingComma;function J(){for(;;){const ie=g.scan();switch(g.getTokenError()){case S.InvalidUnicode:$(D.InvalidUnicode);break;case S.InvalidEscapeCharacter:$(D.InvalidEscapeCharacter);break;case S.UnexpectedEndOfNumber:$(D.UnexpectedEndOfNumber);break;case S.UnexpectedEndOfComment:F||$(D.UnexpectedEndOfComment);break;case S.UnexpectedEndOfString:$(D.UnexpectedEndOfString);break;case S.InvalidCharacter:$(D.InvalidCharacter);break}switch(ie){case T.LineCommentTrivia:case T.BlockCommentTrivia:F?$(D.InvalidCommentToken):N();break;case T.Unknown:$(D.InvalidSymbol);break;case T.Trivia:case T.LineBreakTrivia:break;default:return ie}}}function $(ie,ue=[],Z=[]){if(L(ie),ue.length+Z.length>0){let ve=g.getToken();for(;ve!==T.EOF;){if(ue.indexOf(ve)!==-1){J();break}else if(Z.indexOf(ve)!==-1)break;ve=J()}}}function x(ie){const ue=g.getTokenValue();return ie?p(ue):y(ue),J(),!0}function G(){switch(g.getToken()){case T.NumericLiteral:{let ie=0;try{ie=JSON.parse(g.getTokenValue()),typeof ie!="number"&&($(D.InvalidNumberFormat),ie=0)}catch{$(D.InvalidNumberFormat)}p(ie);break}case T.NullKeyword:p(null);break;case T.TrueKeyword:p(!0);break;case T.FalseKeyword:p(!1);break;default:return!1}return J(),!0}function Y(){return g.getToken()!==T.StringLiteral?($(D.PropertyNameExpected,[],[T.CloseBraceToken,T.CommaToken]),!1):(x(!1),g.getToken()===T.ColonToken?(b(":"),J(),oe()||$(D.ValueExpected,[],[T.CloseBraceToken,T.CommaToken])):$(D.ColonExpected,[],[T.CloseBraceToken,T.CommaToken]),!0)}function ae(){_(),J();let ie=!1;for(;g.getToken()!==T.CloseBraceToken&&g.getToken()!==T.EOF;){if(g.getToken()===T.CommaToken){if(ie||$(D.ValueExpected,[],[]),b(","),J(),g.getToken()===T.CloseBraceToken&&K)break}else ie&&$(D.CommaExpected,[],[]);Y()||$(D.ValueExpected,[],[T.CloseBraceToken,T.CommaToken]),ie=!0}return w(),g.getToken()!==T.CloseBraceToken?$(D.CloseBraceExpected,[T.CloseBraceToken],[]):J(),!0}function ee(){P(),J();let ie=!1;for(;g.getToken()!==T.CloseBracketToken&&g.getToken()!==T.EOF;){if(g.getToken()===T.CommaToken){if(ie||$(D.ValueExpected,[],[]),b(","),J(),g.getToken()===T.CloseBracketToken&&K)break}else ie&&$(D.CommaExpected,[],[]);oe()||$(D.ValueExpected,[],[T.CloseBracketToken,T.CommaToken]),ie=!0}return R(),g.getToken()!==T.CloseBracketToken?$(D.CloseBracketExpected,[T.CloseBracketToken],[]):J(),!0}function oe(){switch(g.getToken()){case T.OpenBracketToken:return ee();case T.OpenBraceToken:return ae();case T.StringLiteral:return x(!0);default:return G()}}return J(),g.getToken()===T.EOF?c.allowEmptyContent?!0:($(D.ValueExpected,[],[]),!1):oe()?(g.getToken()!==T.EOF&&$(D.EndOfFileExpected,[],[]),!0):($(D.ValueExpected,[],[]),!1)}function n(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}}),define(ke[139],Re([1,0]),function(Ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getCompressedContent=S;function S(O){let k=!1;const A=new Map,m=new Map;if(D(O,r=>{if(O===r)return!0;const a=JSON.stringify(r);if(a.length<30)return!0;const d=A.get(a);if(!d){const l={schemas:[r]};return A.set(a,l),m.set(r,l),!0}return d.schemas.push(r),m.set(r,d),k=!0,!1}),A.clear(),!k)return JSON.stringify(O);let I="$defs";for(;O.hasOwnProperty(I);)I+="_";const E=[];function u(r){return JSON.stringify(r,(a,d)=>{if(d!==r){const l=m.get(d);if(l&&l.schemas.length>1)return l.id||(l.id=`_${E.length}`,E.push(l.schemas[0])),{$ref:`#/${I}/${l.id}`}}return d})}const C=u(O),v=[];for(let r=0;r<E.length;r++)v.push(`"_${r}":${u(E[r])}`);return v.length?`${C.substring(0,C.length-1)},"${I}":{${v.join(",")}}}`:C}function T(O){return typeof O=="object"&&O!==null}function D(O,k){if(!O||typeof O!="object")return;const A=(...C)=>{for(const v of C)T(v)&&E.push(v)},m=(...C)=>{for(const v of C)if(T(v))for(const r in v){const a=v[r];T(a)&&E.push(a)}},s=(...C)=>{for(const v of C)if(Array.isArray(v))for(const r of v)T(r)&&E.push(r)},I=C=>{if(Array.isArray(C))for(const v of C)T(v)&&E.push(v);else T(C)&&E.push(C)},E=[O];let u=E.pop();for(;u;)k(u)&&(A(u.additionalItems,u.additionalProperties,u.not,u.contains,u.propertyNames,u.if,u.then,u.else,u.unevaluatedItems,u.unevaluatedProperties),m(u.definitions,u.$defs,u.properties,u.patternProperties,u.dependencies,u.dependentSchemas),s(u.anyOf,u.allOf,u.oneOf,u.prefixItems),I(u.items)),u=E.pop()}}),function(Ee,e){typeof define=="function"&&define.amd?define(ke[140],Re([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(Ee=typeof globalThis<"u"?globalThis:Ee||self,e(Ee.marked={}))}(this,function(Ee){"use strict";function e(){return{async:!1,breaks:!1,extensions:null,gfm:!0,hooks:null,pedantic:!1,renderer:null,silent:!1,tokenizer:null,walkTokens:null}}Ee.defaults=e();function S(Qe){Ee.defaults=Qe}const T=/[&<>"']/,D=new RegExp(T.source,"g"),O=/[<>"']|&(?!(#\d{1,7}|#[Xx][a-fA-F0-9]{1,6}|\w+);)/,k=new RegExp(O.source,"g"),A={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},m=Qe=>A[Qe];function s(Qe,de){if(de){if(T.test(Qe))return Qe.replace(D,m)}else if(O.test(Qe))return Qe.replace(k,m);return Qe}const I=/(^|[^\[])\^/g;function E(Qe,de){let pe=typeof Qe=="string"?Qe:Qe.source;de=de||"";const we={replace:(Pe,fe)=>{let Se=typeof fe=="string"?fe:fe.source;return Se=Se.replace(I,"$1"),pe=pe.replace(Pe,Se),we},getRegex:()=>new RegExp(pe,de)};return we}function u(Qe){try{Qe=encodeURI(Qe).replace(/%25/g,"%")}catch{return null}return Qe}const C={exec:()=>null};function v(Qe,de){const pe=Qe.replace(/\|/g,(fe,Se,Q)=>{let W=!1,he=Se;for(;--he>=0&&Q[he]==="\\";)W=!W;return W?"|":" |"}),we=pe.split(/ \|/);let Pe=0;if(we[0].trim()||we.shift(),we.length>0&&!we[we.length-1].trim()&&we.pop(),de)if(we.length>de)we.splice(de);else for(;we.length<de;)we.push("");for(;Pe<we.length;Pe++)we[Pe]=we[Pe].trim().replace(/\\\|/g,"|");return we}function r(Qe,de,pe){const we=Qe.length;if(we===0)return"";let Pe=0;for(;Pe<we;){const fe=Qe.charAt(we-Pe-1);if(fe===de&&!pe)Pe++;else if(fe!==de&&pe)Pe++;else break}return Qe.slice(0,we-Pe)}function a(Qe,de){if(Qe.indexOf(de[1])===-1)return-1;let pe=0;for(let we=0;we<Qe.length;we++)if(Qe[we]==="\\")we++;else if(Qe[we]===de[0])pe++;else if(Qe[we]===de[1]&&(pe--,pe<0))return we;return-1}function d(Qe,de,pe,we){const Pe=de.href,fe=de.title?s(de.title):null,Se=Qe[1].replace(/\\([\[\]])/g,"$1");if(Qe[0].charAt(0)!=="!"){we.state.inLink=!0;const Q={type:"link",raw:pe,href:Pe,title:fe,text:Se,tokens:we.inlineTokens(Se)};return we.state.inLink=!1,Q}return{type:"image",raw:pe,href:Pe,title:fe,text:s(Se)}}function l(Qe,de){const pe=Qe.match(/^(\s+)(?:```)/);if(pe===null)return de;const we=pe[1];return de.split(`
`).map(Pe=>{const fe=Pe.match(/^\s+/);if(fe===null)return Pe;const[Se]=fe;return Se.length>=we.length?Pe.slice(we.length):Pe}).join(`
`)}class i{options;rules;lexer;constructor(de){this.options=de||Ee.defaults}space(de){const pe=this.rules.block.newline.exec(de);if(pe&&pe[0].length>0)return{type:"space",raw:pe[0]}}code(de){const pe=this.rules.block.code.exec(de);if(pe){const we=pe[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:pe[0],codeBlockStyle:"indented",text:this.options.pedantic?we:r(we,`
`)}}}fences(de){const pe=this.rules.block.fences.exec(de);if(pe){const we=pe[0],Pe=l(we,pe[3]||"");return{type:"code",raw:we,lang:pe[2]?pe[2].trim().replace(this.rules.inline.anyPunctuation,"$1"):pe[2],text:Pe}}}heading(de){const pe=this.rules.block.heading.exec(de);if(pe){let we=pe[2].trim();if(/#$/.test(we)){const Pe=r(we,"#");(this.options.pedantic||!Pe||/ $/.test(Pe))&&(we=Pe.trim())}return{type:"heading",raw:pe[0],depth:pe[1].length,text:we,tokens:this.lexer.inline(we)}}}hr(de){const pe=this.rules.block.hr.exec(de);if(pe)return{type:"hr",raw:r(pe[0],`
`)}}blockquote(de){const pe=this.rules.block.blockquote.exec(de);if(pe){let we=r(pe[0],`
`).split(`
`),Pe="",fe="";const Se=[];for(;we.length>0;){let Q=!1;const W=[];let he;for(he=0;he<we.length;he++)if(/^ {0,3}>/.test(we[he]))W.push(we[he]),Q=!0;else if(!Q)W.push(we[he]);else break;we=we.slice(he);const $e=W.join(`
`),He=$e.replace(/\n {0,3}((?:=+|-+) *)(?=\n|$)/g,`
    $1`).replace(/^ {0,3}>[ \t]?/gm,"");Pe=Pe?`${Pe}
${$e}`:$e,fe=fe?`${fe}
${He}`:He;const st=this.lexer.state.top;if(this.lexer.state.top=!0,this.lexer.blockTokens(He,Se,!0),this.lexer.state.top=st,we.length===0)break;const ht=Se[Se.length-1];if(ht?.type==="code")break;if(ht?.type==="blockquote"){const mt=ht,Rt=mt.raw+`
`+we.join(`
`),At=this.blockquote(Rt);Se[Se.length-1]=At,Pe=Pe.substring(0,Pe.length-mt.raw.length)+At.raw,fe=fe.substring(0,fe.length-mt.text.length)+At.text;break}else if(ht?.type==="list"){const mt=ht,Rt=mt.raw+`
`+we.join(`
`),At=this.list(Rt);Se[Se.length-1]=At,Pe=Pe.substring(0,Pe.length-ht.raw.length)+At.raw,fe=fe.substring(0,fe.length-mt.raw.length)+At.raw,we=Rt.substring(Se[Se.length-1].raw.length).split(`
`);continue}}return{type:"blockquote",raw:Pe,tokens:Se,text:fe}}}list(de){let pe=this.rules.block.list.exec(de);if(pe){let we=pe[1].trim();const Pe=we.length>1,fe={type:"list",raw:"",ordered:Pe,start:Pe?+we.slice(0,-1):"",loose:!1,items:[]};we=Pe?`\\d{1,9}\\${we.slice(-1)}`:`\\${we}`,this.options.pedantic&&(we=Pe?we:"[*+-]");const Se=new RegExp(`^( {0,3}${we})((?:[	 ][^\\n]*)?(?:\\n|$))`);let Q=!1;for(;de;){let W=!1,he="",$e="";if(!(pe=Se.exec(de))||this.rules.block.hr.test(de))break;he=pe[0],de=de.substring(he.length);let He=pe[2].split(`
`,1)[0].replace(/^\t+/,Ht=>" ".repeat(3*Ht.length)),st=de.split(`
`,1)[0],ht=!He.trim(),mt=0;if(this.options.pedantic?(mt=2,$e=He.trimStart()):ht?mt=pe[1].length+1:(mt=pe[2].search(/[^ ]/),mt=mt>4?1:mt,$e=He.slice(mt),mt+=pe[1].length),ht&&/^ *$/.test(st)&&(he+=st+`
`,de=de.substring(st.length+1),W=!0),!W){const Ht=new RegExp(`^ {0,${Math.min(3,mt-1)}}(?:[*+-]|\\d{1,9}[.)])((?:[ 	][^\\n]*)?(?:\\n|$))`),Zt=new RegExp(`^ {0,${Math.min(3,mt-1)}}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)`),Xe=new RegExp(`^ {0,${Math.min(3,mt-1)}}(?:\`\`\`|~~~)`),Lt=new RegExp(`^ {0,${Math.min(3,mt-1)}}#`);for(;de;){const xt=de.split(`
`,1)[0];if(st=xt,this.options.pedantic&&(st=st.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),Xe.test(st)||Lt.test(st)||Ht.test(st)||Zt.test(de))break;if(st.search(/[^ ]/)>=mt||!st.trim())$e+=`
`+st.slice(mt);else{if(ht||He.search(/[^ ]/)>=4||Xe.test(He)||Lt.test(He)||Zt.test(He))break;$e+=`
`+st}!ht&&!st.trim()&&(ht=!0),he+=xt+`
`,de=de.substring(xt.length+1),He=st.slice(mt)}}fe.loose||(Q?fe.loose=!0:/\n *\n *$/.test(he)&&(Q=!0));let Rt=null,At;this.options.gfm&&(Rt=/^\[[ xX]\] /.exec($e),Rt&&(At=Rt[0]!=="[ ] ",$e=$e.replace(/^\[[ xX]\] +/,""))),fe.items.push({type:"list_item",raw:he,task:!!Rt,checked:At,loose:!1,text:$e,tokens:[]}),fe.raw+=he}fe.items[fe.items.length-1].raw=fe.items[fe.items.length-1].raw.trimEnd(),fe.items[fe.items.length-1].text=fe.items[fe.items.length-1].text.trimEnd(),fe.raw=fe.raw.trimEnd();for(let W=0;W<fe.items.length;W++)if(this.lexer.state.top=!1,fe.items[W].tokens=this.lexer.blockTokens(fe.items[W].text,[]),!fe.loose){const he=fe.items[W].tokens.filter(He=>He.type==="space"),$e=he.length>0&&he.some(He=>/\n.*\n/.test(He.raw));fe.loose=$e}if(fe.loose)for(let W=0;W<fe.items.length;W++)fe.items[W].loose=!0;return fe}}html(de){const pe=this.rules.block.html.exec(de);if(pe)return{type:"html",block:!0,raw:pe[0],pre:pe[1]==="pre"||pe[1]==="script"||pe[1]==="style",text:pe[0]}}def(de){const pe=this.rules.block.def.exec(de);if(pe){const we=pe[1].toLowerCase().replace(/\s+/g," "),Pe=pe[2]?pe[2].replace(/^<(.*)>$/,"$1").replace(this.rules.inline.anyPunctuation,"$1"):"",fe=pe[3]?pe[3].substring(1,pe[3].length-1).replace(this.rules.inline.anyPunctuation,"$1"):pe[3];return{type:"def",tag:we,raw:pe[0],href:Pe,title:fe}}}table(de){const pe=this.rules.block.table.exec(de);if(!pe||!/[:|]/.test(pe[2]))return;const we=v(pe[1]),Pe=pe[2].replace(/^\||\| *$/g,"").split("|"),fe=pe[3]&&pe[3].trim()?pe[3].replace(/\n[ \t]*$/,"").split(`
`):[],Se={type:"table",raw:pe[0],header:[],align:[],rows:[]};if(we.length===Pe.length){for(const Q of Pe)/^ *-+: *$/.test(Q)?Se.align.push("right"):/^ *:-+: *$/.test(Q)?Se.align.push("center"):/^ *:-+ *$/.test(Q)?Se.align.push("left"):Se.align.push(null);for(let Q=0;Q<we.length;Q++)Se.header.push({text:we[Q],tokens:this.lexer.inline(we[Q]),header:!0,align:Se.align[Q]});for(const Q of fe)Se.rows.push(v(Q,Se.header.length).map((W,he)=>({text:W,tokens:this.lexer.inline(W),header:!1,align:Se.align[he]})));return Se}}lheading(de){const pe=this.rules.block.lheading.exec(de);if(pe)return{type:"heading",raw:pe[0],depth:pe[2].charAt(0)==="="?1:2,text:pe[1],tokens:this.lexer.inline(pe[1])}}paragraph(de){const pe=this.rules.block.paragraph.exec(de);if(pe){const we=pe[1].charAt(pe[1].length-1)===`
`?pe[1].slice(0,-1):pe[1];return{type:"paragraph",raw:pe[0],text:we,tokens:this.lexer.inline(we)}}}text(de){const pe=this.rules.block.text.exec(de);if(pe)return{type:"text",raw:pe[0],text:pe[0],tokens:this.lexer.inline(pe[0])}}escape(de){const pe=this.rules.inline.escape.exec(de);if(pe)return{type:"escape",raw:pe[0],text:s(pe[1])}}tag(de){const pe=this.rules.inline.tag.exec(de);if(pe)return!this.lexer.state.inLink&&/^<a /i.test(pe[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(pe[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(pe[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(pe[0])&&(this.lexer.state.inRawBlock=!1),{type:"html",raw:pe[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,block:!1,text:pe[0]}}link(de){const pe=this.rules.inline.link.exec(de);if(pe){const we=pe[2].trim();if(!this.options.pedantic&&/^</.test(we)){if(!/>$/.test(we))return;const Se=r(we.slice(0,-1),"\\");if((we.length-Se.length)%2===0)return}else{const Se=a(pe[2],"()");if(Se>-1){const W=(pe[0].indexOf("!")===0?5:4)+pe[1].length+Se;pe[2]=pe[2].substring(0,Se),pe[0]=pe[0].substring(0,W).trim(),pe[3]=""}}let Pe=pe[2],fe="";if(this.options.pedantic){const Se=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Pe);Se&&(Pe=Se[1],fe=Se[3])}else fe=pe[3]?pe[3].slice(1,-1):"";return Pe=Pe.trim(),/^</.test(Pe)&&(this.options.pedantic&&!/>$/.test(we)?Pe=Pe.slice(1):Pe=Pe.slice(1,-1)),d(pe,{href:Pe&&Pe.replace(this.rules.inline.anyPunctuation,"$1"),title:fe&&fe.replace(this.rules.inline.anyPunctuation,"$1")},pe[0],this.lexer)}}reflink(de,pe){let we;if((we=this.rules.inline.reflink.exec(de))||(we=this.rules.inline.nolink.exec(de))){const Pe=(we[2]||we[1]).replace(/\s+/g," "),fe=pe[Pe.toLowerCase()];if(!fe){const Se=we[0].charAt(0);return{type:"text",raw:Se,text:Se}}return d(we,fe,we[0],this.lexer)}}emStrong(de,pe,we=""){let Pe=this.rules.inline.emStrongLDelim.exec(de);if(!Pe||Pe[3]&&we.match(/[\p{L}\p{N}]/u))return;if(!(Pe[1]||Pe[2]||"")||!we||this.rules.inline.punctuation.exec(we)){const Se=[...Pe[0]].length-1;let Q,W,he=Se,$e=0;const He=Pe[0][0]==="*"?this.rules.inline.emStrongRDelimAst:this.rules.inline.emStrongRDelimUnd;for(He.lastIndex=0,pe=pe.slice(-1*de.length+Se);(Pe=He.exec(pe))!=null;){if(Q=Pe[1]||Pe[2]||Pe[3]||Pe[4]||Pe[5]||Pe[6],!Q)continue;if(W=[...Q].length,Pe[3]||Pe[4]){he+=W;continue}else if((Pe[5]||Pe[6])&&Se%3&&!((Se+W)%3)){$e+=W;continue}if(he-=W,he>0)continue;W=Math.min(W,W+he+$e);const st=[...Pe[0]][0].length,ht=de.slice(0,Se+Pe.index+st+W);if(Math.min(Se,W)%2){const Rt=ht.slice(1,-1);return{type:"em",raw:ht,text:Rt,tokens:this.lexer.inlineTokens(Rt)}}const mt=ht.slice(2,-2);return{type:"strong",raw:ht,text:mt,tokens:this.lexer.inlineTokens(mt)}}}}codespan(de){const pe=this.rules.inline.code.exec(de);if(pe){let we=pe[2].replace(/\n/g," ");const Pe=/[^ ]/.test(we),fe=/^ /.test(we)&&/ $/.test(we);return Pe&&fe&&(we=we.substring(1,we.length-1)),we=s(we,!0),{type:"codespan",raw:pe[0],text:we}}}br(de){const pe=this.rules.inline.br.exec(de);if(pe)return{type:"br",raw:pe[0]}}del(de){const pe=this.rules.inline.del.exec(de);if(pe)return{type:"del",raw:pe[0],text:pe[2],tokens:this.lexer.inlineTokens(pe[2])}}autolink(de){const pe=this.rules.inline.autolink.exec(de);if(pe){let we,Pe;return pe[2]==="@"?(we=s(pe[1]),Pe="mailto:"+we):(we=s(pe[1]),Pe=we),{type:"link",raw:pe[0],text:we,href:Pe,tokens:[{type:"text",raw:we,text:we}]}}}url(de){let pe;if(pe=this.rules.inline.url.exec(de)){let we,Pe;if(pe[2]==="@")we=s(pe[0]),Pe="mailto:"+we;else{let fe;do fe=pe[0],pe[0]=this.rules.inline._backpedal.exec(pe[0])?.[0]??"";while(fe!==pe[0]);we=s(pe[0]),pe[1]==="www."?Pe="http://"+pe[0]:Pe=pe[0]}return{type:"link",raw:pe[0],text:we,href:Pe,tokens:[{type:"text",raw:we,text:we}]}}}inlineText(de){const pe=this.rules.inline.text.exec(de);if(pe){let we;return this.lexer.state.inRawBlock?we=pe[0]:we=s(pe[0]),{type:"text",raw:pe[0],text:we}}}}const n=/^(?: *(?:\n|$))+/,t=/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,o=/^ {0,3}(`{3,}(?=[^`\n]*(?:\n|$))|~{3,})([^\n]*)(?:\n|$)(?:|([\s\S]*?)(?:\n|$))(?: {0,3}\1[~`]* *(?=\n|$)|$)/,c=/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,g=/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,f=/(?:[*+-]|\d{1,9}[.)])/,h=E(/^(?!bull |blockCode|fences|blockquote|heading|html)((?:.|\n(?!\s*?\n|bull |blockCode|fences|blockquote|heading|html))+?)\n {0,3}(=+|-+) *(?:\n+|$)/).replace(/bull/g,f).replace(/blockCode/g,/ {4}/).replace(/fences/g,/ {0,3}(?:`{3,}|~{3,})/).replace(/blockquote/g,/ {0,3}>/).replace(/heading/g,/ {0,3}#{1,6}/).replace(/html/g,/ {0,3}<[^\n>]+>\n/).getRegex(),_=/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,y=/^[^\n]+/,w=/(?!\s*\])(?:\\.|[^\[\]\\])+/,P=E(/^ {0,3}\[(label)\]: *(?:\n *)?([^<\s][^\s]*|<.*?>)(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/).replace("label",w).replace("title",/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/).getRegex(),R=E(/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/).replace(/bull/g,f).getRegex(),p="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|search|section|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",b=/<!--(?:-?>|[\s\S]*?(?:-->|$))/,N=E("^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))","i").replace("comment",b).replace("tag",p).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),L=E(_).replace("hr",c).replace("heading"," {0,3}#{1,6}(?:\\s|$)").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",p).getRegex(),K={blockquote:E(/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/).replace("paragraph",L).getRegex(),code:t,def:P,fences:o,heading:g,hr:c,html:N,lheading:h,list:R,newline:n,paragraph:L,table:C,text:y},J=E("^ *([^\\n ].*)\\n {0,3}((?:\\| *)?:?-+:? *(?:\\| *:?-+:? *)*(?:\\| *)?)(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)").replace("hr",c).replace("heading"," {0,3}#{1,6}(?:\\s|$)").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",p).getRegex(),$={...K,table:J,paragraph:E(_).replace("hr",c).replace("heading"," {0,3}#{1,6}(?:\\s|$)").replace("|lheading","").replace("table",J).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",p).getRegex()},x={...K,html:E(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",b).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:C,lheading:/^(.+?)\n {0,3}(=+|-+) *(?:\n+|$)/,paragraph:E(_).replace("hr",c).replace("heading",` *#{1,6} *[^
]`).replace("lheading",h).replace("|table","").replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").replace("|tag","").getRegex()},G=/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,Y=/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,ae=/^( {2,}|\\)\n(?!\s*$)/,ee=/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,oe="\\p{P}\\p{S}",ie=E(/^((?![*_])[\spunctuation])/,"u").replace(/punctuation/g,oe).getRegex(),ue=/\[[^[\]]*?\]\([^\(\)]*?\)|`[^`]*?`|<[^<>]*?>/g,Z=E(/^(?:\*+(?:((?!\*)[punct])|[^\s*]))|^_+(?:((?!_)[punct])|([^\s_]))/,"u").replace(/punct/g,oe).getRegex(),ve=E("^[^_*]*?__[^_*]*?\\*[^_*]*?(?=__)|[^*]+(?=[^*])|(?!\\*)[punct](\\*+)(?=[\\s]|$)|[^punct\\s](\\*+)(?!\\*)(?=[punct\\s]|$)|(?!\\*)[punct\\s](\\*+)(?=[^punct\\s])|[\\s](\\*+)(?!\\*)(?=[punct])|(?!\\*)[punct](\\*+)(?!\\*)(?=[punct])|[^punct\\s](\\*+)(?=[^punct\\s])","gu").replace(/punct/g,oe).getRegex(),Ie=E("^[^_*]*?\\*\\*[^_*]*?_[^_*]*?(?=\\*\\*)|[^_]+(?=[^_])|(?!_)[punct](_+)(?=[\\s]|$)|[^punct\\s](_+)(?!_)(?=[punct\\s]|$)|(?!_)[punct\\s](_+)(?=[^punct\\s])|[\\s](_+)(?!_)(?=[punct])|(?!_)[punct](_+)(?!_)(?=[punct])","gu").replace(/punct/g,oe).getRegex(),X=E(/\\([punct])/,"gu").replace(/punct/g,oe).getRegex(),V=E(/^<(scheme:[^\s\x00-\x1f<>]*|email)>/).replace("scheme",/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/).replace("email",/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/).getRegex(),re=E(b).replace("(?:-->|$)","-->").getRegex(),be=E("^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>").replace("comment",re).replace("attribute",/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/).getRegex(),De=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,Fe=E(/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/).replace("label",De).replace("href",/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/).replace("title",/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/).getRegex(),ze=E(/^!?\[(label)\]\[(ref)\]/).replace("label",De).replace("ref",w).getRegex(),Je=E(/^!?\[(ref)\](?:\[\])?/).replace("ref",w).getRegex(),nt=E("reflink|nolink(?!\\()","g").replace("reflink",ze).replace("nolink",Je).getRegex(),dt={_backpedal:C,anyPunctuation:X,autolink:V,blockSkip:ue,br:ae,code:Y,del:C,emStrongLDelim:Z,emStrongRDelimAst:ve,emStrongRDelimUnd:Ie,escape:G,link:Fe,nolink:Je,punctuation:ie,reflink:ze,reflinkSearch:nt,tag:be,text:ee,url:C},vt={...dt,link:E(/^!?\[(label)\]\((.*?)\)/).replace("label",De).getRegex(),reflink:E(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",De).getRegex()},ut={...dt,escape:E(G).replace("])","~|])").getRegex(),url:E(/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,"i").replace("email",/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/).getRegex(),_backpedal:/(?:[^?!.,:;*_'"~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_'"~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/},et={...ut,br:E(ae).replace("{2,}","*").getRegex(),text:E(ut.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()},Oe={normal:K,gfm:$,pedantic:x},Me={normal:dt,gfm:ut,breaks:et,pedantic:vt};class Ne{tokens;options;state;tokenizer;inlineQueue;constructor(de){this.tokens=[],this.tokens.links=Object.create(null),this.options=de||Ee.defaults,this.options.tokenizer=this.options.tokenizer||new i,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};const pe={block:Oe.normal,inline:Me.normal};this.options.pedantic?(pe.block=Oe.pedantic,pe.inline=Me.pedantic):this.options.gfm&&(pe.block=Oe.gfm,this.options.breaks?pe.inline=Me.breaks:pe.inline=Me.gfm),this.tokenizer.rules=pe}static get rules(){return{block:Oe,inline:Me}}static lex(de,pe){return new Ne(pe).lex(de)}static lexInline(de,pe){return new Ne(pe).inlineTokens(de)}lex(de){de=de.replace(/\r\n|\r/g,`
`),this.blockTokens(de,this.tokens);for(let pe=0;pe<this.inlineQueue.length;pe++){const we=this.inlineQueue[pe];this.inlineTokens(we.src,we.tokens)}return this.inlineQueue=[],this.tokens}blockTokens(de,pe=[],we=!1){this.options.pedantic?de=de.replace(/\t/g,"    ").replace(/^ +$/gm,""):de=de.replace(/^( *)(\t+)/gm,(Q,W,he)=>W+"    ".repeat(he.length));let Pe,fe,Se;for(;de;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(Q=>(Pe=Q.call({lexer:this},de,pe))?(de=de.substring(Pe.raw.length),pe.push(Pe),!0):!1))){if(Pe=this.tokenizer.space(de)){de=de.substring(Pe.raw.length),Pe.raw.length===1&&pe.length>0?pe[pe.length-1].raw+=`
`:pe.push(Pe);continue}if(Pe=this.tokenizer.code(de)){de=de.substring(Pe.raw.length),fe=pe[pe.length-1],fe&&(fe.type==="paragraph"||fe.type==="text")?(fe.raw+=`
`+Pe.raw,fe.text+=`
`+Pe.text,this.inlineQueue[this.inlineQueue.length-1].src=fe.text):pe.push(Pe);continue}if(Pe=this.tokenizer.fences(de)){de=de.substring(Pe.raw.length),pe.push(Pe);continue}if(Pe=this.tokenizer.heading(de)){de=de.substring(Pe.raw.length),pe.push(Pe);continue}if(Pe=this.tokenizer.hr(de)){de=de.substring(Pe.raw.length),pe.push(Pe);continue}if(Pe=this.tokenizer.blockquote(de)){de=de.substring(Pe.raw.length),pe.push(Pe);continue}if(Pe=this.tokenizer.list(de)){de=de.substring(Pe.raw.length),pe.push(Pe);continue}if(Pe=this.tokenizer.html(de)){de=de.substring(Pe.raw.length),pe.push(Pe);continue}if(Pe=this.tokenizer.def(de)){de=de.substring(Pe.raw.length),fe=pe[pe.length-1],fe&&(fe.type==="paragraph"||fe.type==="text")?(fe.raw+=`
`+Pe.raw,fe.text+=`
`+Pe.raw,this.inlineQueue[this.inlineQueue.length-1].src=fe.text):this.tokens.links[Pe.tag]||(this.tokens.links[Pe.tag]={href:Pe.href,title:Pe.title});continue}if(Pe=this.tokenizer.table(de)){de=de.substring(Pe.raw.length),pe.push(Pe);continue}if(Pe=this.tokenizer.lheading(de)){de=de.substring(Pe.raw.length),pe.push(Pe);continue}if(Se=de,this.options.extensions&&this.options.extensions.startBlock){let Q=1/0;const W=de.slice(1);let he;this.options.extensions.startBlock.forEach($e=>{he=$e.call({lexer:this},W),typeof he=="number"&&he>=0&&(Q=Math.min(Q,he))}),Q<1/0&&Q>=0&&(Se=de.substring(0,Q+1))}if(this.state.top&&(Pe=this.tokenizer.paragraph(Se))){fe=pe[pe.length-1],we&&fe?.type==="paragraph"?(fe.raw+=`
`+Pe.raw,fe.text+=`
`+Pe.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=fe.text):pe.push(Pe),we=Se.length!==de.length,de=de.substring(Pe.raw.length);continue}if(Pe=this.tokenizer.text(de)){de=de.substring(Pe.raw.length),fe=pe[pe.length-1],fe&&fe.type==="text"?(fe.raw+=`
`+Pe.raw,fe.text+=`
`+Pe.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=fe.text):pe.push(Pe);continue}if(de){const Q="Infinite loop on byte: "+de.charCodeAt(0);if(this.options.silent){console.error(Q);break}else throw new Error(Q)}}return this.state.top=!0,pe}inline(de,pe=[]){return this.inlineQueue.push({src:de,tokens:pe}),pe}inlineTokens(de,pe=[]){let we,Pe,fe,Se=de,Q,W,he;if(this.tokens.links){const $e=Object.keys(this.tokens.links);if($e.length>0)for(;(Q=this.tokenizer.rules.inline.reflinkSearch.exec(Se))!=null;)$e.includes(Q[0].slice(Q[0].lastIndexOf("[")+1,-1))&&(Se=Se.slice(0,Q.index)+"["+"a".repeat(Q[0].length-2)+"]"+Se.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Q=this.tokenizer.rules.inline.blockSkip.exec(Se))!=null;)Se=Se.slice(0,Q.index)+"["+"a".repeat(Q[0].length-2)+"]"+Se.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Q=this.tokenizer.rules.inline.anyPunctuation.exec(Se))!=null;)Se=Se.slice(0,Q.index)+"++"+Se.slice(this.tokenizer.rules.inline.anyPunctuation.lastIndex);for(;de;)if(W||(he=""),W=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some($e=>(we=$e.call({lexer:this},de,pe))?(de=de.substring(we.raw.length),pe.push(we),!0):!1))){if(we=this.tokenizer.escape(de)){de=de.substring(we.raw.length),pe.push(we);continue}if(we=this.tokenizer.tag(de)){de=de.substring(we.raw.length),Pe=pe[pe.length-1],Pe&&we.type==="text"&&Pe.type==="text"?(Pe.raw+=we.raw,Pe.text+=we.text):pe.push(we);continue}if(we=this.tokenizer.link(de)){de=de.substring(we.raw.length),pe.push(we);continue}if(we=this.tokenizer.reflink(de,this.tokens.links)){de=de.substring(we.raw.length),Pe=pe[pe.length-1],Pe&&we.type==="text"&&Pe.type==="text"?(Pe.raw+=we.raw,Pe.text+=we.text):pe.push(we);continue}if(we=this.tokenizer.emStrong(de,Se,he)){de=de.substring(we.raw.length),pe.push(we);continue}if(we=this.tokenizer.codespan(de)){de=de.substring(we.raw.length),pe.push(we);continue}if(we=this.tokenizer.br(de)){de=de.substring(we.raw.length),pe.push(we);continue}if(we=this.tokenizer.del(de)){de=de.substring(we.raw.length),pe.push(we);continue}if(we=this.tokenizer.autolink(de)){de=de.substring(we.raw.length),pe.push(we);continue}if(!this.state.inLink&&(we=this.tokenizer.url(de))){de=de.substring(we.raw.length),pe.push(we);continue}if(fe=de,this.options.extensions&&this.options.extensions.startInline){let $e=1/0;const He=de.slice(1);let st;this.options.extensions.startInline.forEach(ht=>{st=ht.call({lexer:this},He),typeof st=="number"&&st>=0&&($e=Math.min($e,st))}),$e<1/0&&$e>=0&&(fe=de.substring(0,$e+1))}if(we=this.tokenizer.inlineText(fe)){de=de.substring(we.raw.length),we.raw.slice(-1)!=="_"&&(he=we.raw.slice(-1)),W=!0,Pe=pe[pe.length-1],Pe&&Pe.type==="text"?(Pe.raw+=we.raw,Pe.text+=we.text):pe.push(we);continue}if(de){const $e="Infinite loop on byte: "+de.charCodeAt(0);if(this.options.silent){console.error($e);break}else throw new Error($e)}}return pe}}class B{options;parser;constructor(de){this.options=de||Ee.defaults}space(de){return""}code({text:de,lang:pe,escaped:we}){const Pe=(pe||"").match(/^\S*/)?.[0],fe=de.replace(/\n$/,"")+`
`;return Pe?'<pre><code class="language-'+s(Pe)+'">'+(we?fe:s(fe,!0))+`</code></pre>
`:"<pre><code>"+(we?fe:s(fe,!0))+`</code></pre>
`}blockquote({tokens:de}){return`<blockquote>
${this.parser.parse(de)}</blockquote>
`}html({text:de}){return de}heading({tokens:de,depth:pe}){return`<h${pe}>${this.parser.parseInline(de)}</h${pe}>
`}hr(de){return`<hr>
`}list(de){const pe=de.ordered,we=de.start;let Pe="";for(let Q=0;Q<de.items.length;Q++){const W=de.items[Q];Pe+=this.listitem(W)}const fe=pe?"ol":"ul",Se=pe&&we!==1?' start="'+we+'"':"";return"<"+fe+Se+`>
`+Pe+"</"+fe+`>
`}listitem(de){let pe="";if(de.task){const we=this.checkbox({checked:!!de.checked});de.loose?de.tokens.length>0&&de.tokens[0].type==="paragraph"?(de.tokens[0].text=we+" "+de.tokens[0].text,de.tokens[0].tokens&&de.tokens[0].tokens.length>0&&de.tokens[0].tokens[0].type==="text"&&(de.tokens[0].tokens[0].text=we+" "+de.tokens[0].tokens[0].text)):de.tokens.unshift({type:"text",raw:we+" ",text:we+" "}):pe+=we+" "}return pe+=this.parser.parse(de.tokens,!!de.loose),`<li>${pe}</li>
`}checkbox({checked:de}){return"<input "+(de?'checked="" ':"")+'disabled="" type="checkbox">'}paragraph({tokens:de}){return`<p>${this.parser.parseInline(de)}</p>
`}table(de){let pe="",we="";for(let fe=0;fe<de.header.length;fe++)we+=this.tablecell(de.header[fe]);pe+=this.tablerow({text:we});let Pe="";for(let fe=0;fe<de.rows.length;fe++){const Se=de.rows[fe];we="";for(let Q=0;Q<Se.length;Q++)we+=this.tablecell(Se[Q]);Pe+=this.tablerow({text:we})}return Pe&&(Pe=`<tbody>${Pe}</tbody>`),`<table>
<thead>
`+pe+`</thead>
`+Pe+`</table>
`}tablerow({text:de}){return`<tr>
${de}</tr>
`}tablecell(de){const pe=this.parser.parseInline(de.tokens),we=de.header?"th":"td";return(de.align?`<${we} align="${de.align}">`:`<${we}>`)+pe+`</${we}>
`}strong({tokens:de}){return`<strong>${this.parser.parseInline(de)}</strong>`}em({tokens:de}){return`<em>${this.parser.parseInline(de)}</em>`}codespan({text:de}){return`<code>${de}</code>`}br(de){return"<br>"}del({tokens:de}){return`<del>${this.parser.parseInline(de)}</del>`}link({href:de,title:pe,tokens:we}){const Pe=this.parser.parseInline(we),fe=u(de);if(fe===null)return Pe;de=fe;let Se='<a href="'+de+'"';return pe&&(Se+=' title="'+pe+'"'),Se+=">"+Pe+"</a>",Se}image({href:de,title:pe,text:we}){const Pe=u(de);if(Pe===null)return we;de=Pe;let fe=`<img src="${de}" alt="${we}"`;return pe&&(fe+=` title="${pe}"`),fe+=">",fe}text(de){return"tokens"in de&&de.tokens?this.parser.parseInline(de.tokens):de.text}}class z{strong({text:de}){return de}em({text:de}){return de}codespan({text:de}){return de}del({text:de}){return de}html({text:de}){return de}text({text:de}){return de}link({text:de}){return""+de}image({text:de}){return""+de}br(){return""}}class H{options;renderer;textRenderer;constructor(de){this.options=de||Ee.defaults,this.options.renderer=this.options.renderer||new B,this.renderer=this.options.renderer,this.renderer.options=this.options,this.renderer.parser=this,this.textRenderer=new z}static parse(de,pe){return new H(pe).parse(de)}static parseInline(de,pe){return new H(pe).parseInline(de)}parse(de,pe=!0){let we="";for(let Pe=0;Pe<de.length;Pe++){const fe=de[Pe];if(this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[fe.type]){const Q=fe,W=this.options.extensions.renderers[Q.type].call({parser:this},Q);if(W!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(Q.type)){we+=W||"";continue}}const Se=fe;switch(Se.type){case"space":{we+=this.renderer.space(Se);continue}case"hr":{we+=this.renderer.hr(Se);continue}case"heading":{we+=this.renderer.heading(Se);continue}case"code":{we+=this.renderer.code(Se);continue}case"table":{we+=this.renderer.table(Se);continue}case"blockquote":{we+=this.renderer.blockquote(Se);continue}case"list":{we+=this.renderer.list(Se);continue}case"html":{we+=this.renderer.html(Se);continue}case"paragraph":{we+=this.renderer.paragraph(Se);continue}case"text":{let Q=Se,W=this.renderer.text(Q);for(;Pe+1<de.length&&de[Pe+1].type==="text";)Q=de[++Pe],W+=`
`+this.renderer.text(Q);pe?we+=this.renderer.paragraph({type:"paragraph",raw:W,text:W,tokens:[{type:"text",raw:W,text:W}]}):we+=W;continue}default:{const Q='Token with "'+Se.type+'" type was not found.';if(this.options.silent)return console.error(Q),"";throw new Error(Q)}}}return we}parseInline(de,pe){pe=pe||this.renderer;let we="";for(let Pe=0;Pe<de.length;Pe++){const fe=de[Pe];if(this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[fe.type]){const Q=this.options.extensions.renderers[fe.type].call({parser:this},fe);if(Q!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(fe.type)){we+=Q||"";continue}}const Se=fe;switch(Se.type){case"escape":{we+=pe.text(Se);break}case"html":{we+=pe.html(Se);break}case"link":{we+=pe.link(Se);break}case"image":{we+=pe.image(Se);break}case"strong":{we+=pe.strong(Se);break}case"em":{we+=pe.em(Se);break}case"codespan":{we+=pe.codespan(Se);break}case"br":{we+=pe.br(Se);break}case"del":{we+=pe.del(Se);break}case"text":{we+=pe.text(Se);break}default:{const Q='Token with "'+Se.type+'" type was not found.';if(this.options.silent)return console.error(Q),"";throw new Error(Q)}}}return we}}class q{options;constructor(de){this.options=de||Ee.defaults}static passThroughHooks=new Set(["preprocess","postprocess","processAllTokens"]);preprocess(de){return de}postprocess(de){return de}processAllTokens(de){return de}}class se{defaults=e();options=this.setOptions;parse=this.parseMarkdown(Ne.lex,H.parse);parseInline=this.parseMarkdown(Ne.lexInline,H.parseInline);Parser=H;Renderer=B;TextRenderer=z;Lexer=Ne;Tokenizer=i;Hooks=q;constructor(...de){this.use(...de)}walkTokens(de,pe){let we=[];for(const Pe of de)switch(we=we.concat(pe.call(this,Pe)),Pe.type){case"table":{const fe=Pe;for(const Se of fe.header)we=we.concat(this.walkTokens(Se.tokens,pe));for(const Se of fe.rows)for(const Q of Se)we=we.concat(this.walkTokens(Q.tokens,pe));break}case"list":{const fe=Pe;we=we.concat(this.walkTokens(fe.items,pe));break}default:{const fe=Pe;this.defaults.extensions?.childTokens?.[fe.type]?this.defaults.extensions.childTokens[fe.type].forEach(Se=>{const Q=fe[Se].flat(1/0);we=we.concat(this.walkTokens(Q,pe))}):fe.tokens&&(we=we.concat(this.walkTokens(fe.tokens,pe)))}}return we}use(...de){const pe=this.defaults.extensions||{renderers:{},childTokens:{}};return de.forEach(we=>{const Pe={...we};if(Pe.async=this.defaults.async||Pe.async||!1,we.extensions&&(we.extensions.forEach(fe=>{if(!fe.name)throw new Error("extension name required");if("renderer"in fe){const Se=pe.renderers[fe.name];Se?pe.renderers[fe.name]=function(...Q){let W=fe.renderer.apply(this,Q);return W===!1&&(W=Se.apply(this,Q)),W}:pe.renderers[fe.name]=fe.renderer}if("tokenizer"in fe){if(!fe.level||fe.level!=="block"&&fe.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");const Se=pe[fe.level];Se?Se.unshift(fe.tokenizer):pe[fe.level]=[fe.tokenizer],fe.start&&(fe.level==="block"?pe.startBlock?pe.startBlock.push(fe.start):pe.startBlock=[fe.start]:fe.level==="inline"&&(pe.startInline?pe.startInline.push(fe.start):pe.startInline=[fe.start]))}"childTokens"in fe&&fe.childTokens&&(pe.childTokens[fe.name]=fe.childTokens)}),Pe.extensions=pe),we.renderer){const fe=this.defaults.renderer||new B(this.defaults);for(const Se in we.renderer){if(!(Se in fe))throw new Error(`renderer '${Se}' does not exist`);if(["options","parser"].includes(Se))continue;const Q=Se,W=we.renderer[Q],he=fe[Q];fe[Q]=(...$e)=>{let He=W.apply(fe,$e);return He===!1&&(He=he.apply(fe,$e)),He||""}}Pe.renderer=fe}if(we.tokenizer){const fe=this.defaults.tokenizer||new i(this.defaults);for(const Se in we.tokenizer){if(!(Se in fe))throw new Error(`tokenizer '${Se}' does not exist`);if(["options","rules","lexer"].includes(Se))continue;const Q=Se,W=we.tokenizer[Q],he=fe[Q];fe[Q]=(...$e)=>{let He=W.apply(fe,$e);return He===!1&&(He=he.apply(fe,$e)),He}}Pe.tokenizer=fe}if(we.hooks){const fe=this.defaults.hooks||new q;for(const Se in we.hooks){if(!(Se in fe))throw new Error(`hook '${Se}' does not exist`);if(Se==="options")continue;const Q=Se,W=we.hooks[Q],he=fe[Q];q.passThroughHooks.has(Se)?fe[Q]=$e=>{if(this.defaults.async)return Promise.resolve(W.call(fe,$e)).then(st=>he.call(fe,st));const He=W.call(fe,$e);return he.call(fe,He)}:fe[Q]=(...$e)=>{let He=W.apply(fe,$e);return He===!1&&(He=he.apply(fe,$e)),He}}Pe.hooks=fe}if(we.walkTokens){const fe=this.defaults.walkTokens,Se=we.walkTokens;Pe.walkTokens=function(Q){let W=[];return W.push(Se.call(this,Q)),fe&&(W=W.concat(fe.call(this,Q))),W}}this.defaults={...this.defaults,...Pe}}),this}setOptions(de){return this.defaults={...this.defaults,...de},this}lexer(de,pe){return Ne.lex(de,pe??this.defaults)}parser(de,pe){return H.parse(de,pe??this.defaults)}parseMarkdown(de,pe){return(Pe,fe)=>{const Se={...fe},Q={...this.defaults,...Se},W=this.onError(!!Q.silent,!!Q.async);if(this.defaults.async===!0&&Se.async===!1)return W(new Error("marked(): The async option was set to true by an extension. Remove async: false from the parse options object to return a Promise."));if(typeof Pe>"u"||Pe===null)return W(new Error("marked(): input parameter is undefined or null"));if(typeof Pe!="string")return W(new Error("marked(): input parameter is of type "+Object.prototype.toString.call(Pe)+", string expected"));if(Q.hooks&&(Q.hooks.options=Q),Q.async)return Promise.resolve(Q.hooks?Q.hooks.preprocess(Pe):Pe).then(he=>de(he,Q)).then(he=>Q.hooks?Q.hooks.processAllTokens(he):he).then(he=>Q.walkTokens?Promise.all(this.walkTokens(he,Q.walkTokens)).then(()=>he):he).then(he=>pe(he,Q)).then(he=>Q.hooks?Q.hooks.postprocess(he):he).catch(W);try{Q.hooks&&(Pe=Q.hooks.preprocess(Pe));let he=de(Pe,Q);Q.hooks&&(he=Q.hooks.processAllTokens(he)),Q.walkTokens&&this.walkTokens(he,Q.walkTokens);let $e=pe(he,Q);return Q.hooks&&($e=Q.hooks.postprocess($e)),$e}catch(he){return W(he)}}}onError(de,pe){return we=>{if(we.message+=`
Please report this to https://github.com/markedjs/marked.`,de){const Pe="<p>An error occurred:</p><pre>"+s(we.message+"",!0)+"</pre>";return pe?Promise.resolve(Pe):Pe}if(pe)return Promise.reject(we);throw we}}}const ge=new se;function ye(Qe,de){return ge.parse(Qe,de)}ye.options=ye.setOptions=function(Qe){return ge.setOptions(Qe),ye.defaults=ge.defaults,S(ye.defaults),ye},ye.getDefaults=e,ye.defaults=Ee.defaults,ye.use=function(...Qe){return ge.use(...Qe),ye.defaults=ge.defaults,S(ye.defaults),ye},ye.walkTokens=function(Qe,de){return ge.walkTokens(Qe,de)},ye.parseInline=ge.parseInline,ye.Parser=H,ye.parser=H.parse,ye.Renderer=B,ye.TextRenderer=z,ye.Lexer=Ne,ye.lexer=Ne.lex,ye.Tokenizer=i,ye.Hooks=q,ye.parse=ye;const Ue=ye.options,Ge=ye.setOptions,Ze=ye.use,tt=ye.walkTokens,lt=ye.parseInline,it=ye,at=H.parse,wt=Ne.lex;Ee.Hooks=q,Ee.Lexer=Ne,Ee.Marked=se,Ee.Parser=H,Ee.Renderer=B,Ee.TextRenderer=z,Ee.Tokenizer=i,Ee.getDefaults=e,Ee.lexer=wt,Ee.marked=ye,Ee.options=Ue,Ee.parse=it,Ee.parseInline=lt,Ee.parser=at,Ee.setOptions=Ge,Ee.use=Ze,Ee.walkTokens=tt}),define(ke[141],Re([1,0]),function(Ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getKoreanAltChars=S;function S(r){const a=O(r);if(a&&a.length>0)return new Uint32Array(a)}let T=0;const D=new Uint32Array(10);function O(r){if(T=0,k(r,E,m.InitialConsonant),T>0||(k(r,u,m.Vowel),T>0)||(k(r,C,m.FinalConsonant),T>0)||(k(r,v,m.CompatibilityJamo),T))return D.subarray(0,T);if(r>=44032&&r<=55203){const a=r-44032,d=a%588,l=Math.floor(a/588),i=Math.floor(d/28),n=d%28-1;if(l<E.length?k(l,E,0):m.InitialConsonant+l-m.CompatibilityJamo<v.length&&k(m.InitialConsonant+l,v,m.CompatibilityJamo),i<u.length?k(i,u,0):m.Vowel+i-m.CompatibilityJamo<v.length&&k(m.Vowel+i-m.CompatibilityJamo,v,m.CompatibilityJamo),n>=0&&(n<C.length?k(n,C,0):m.FinalConsonant+n-m.CompatibilityJamo<v.length&&k(m.FinalConsonant+n-m.CompatibilityJamo,v,m.CompatibilityJamo)),T>0)return D.subarray(0,T)}}function k(r,a,d){r>=d&&r<d+a.length&&A(a[r-d])}function A(r){r!==s.NUL&&(D[T++]=r&255,r>>8&&(D[T++]=r>>8&255),r>>16&&(D[T++]=r>>16&255))}var m;(function(r){r[r.InitialConsonant=4352]="InitialConsonant",r[r.Vowel=4449]="Vowel",r[r.FinalConsonant=4520]="FinalConsonant",r[r.CompatibilityJamo=12593]="CompatibilityJamo"})(m||(m={}));var s;(function(r){r[r.NUL=0]="NUL",r[r.A=65]="A",r[r.B=66]="B",r[r.C=67]="C",r[r.D=68]="D",r[r.E=69]="E",r[r.F=70]="F",r[r.G=71]="G",r[r.H=72]="H",r[r.I=73]="I",r[r.J=74]="J",r[r.K=75]="K",r[r.L=76]="L",r[r.M=77]="M",r[r.N=78]="N",r[r.O=79]="O",r[r.P=80]="P",r[r.Q=81]="Q",r[r.R=82]="R",r[r.S=83]="S",r[r.T=84]="T",r[r.U=85]="U",r[r.V=86]="V",r[r.W=87]="W",r[r.X=88]="X",r[r.Y=89]="Y",r[r.Z=90]="Z",r[r.a=97]="a",r[r.b=98]="b",r[r.c=99]="c",r[r.d=100]="d",r[r.e=101]="e",r[r.f=102]="f",r[r.g=103]="g",r[r.h=104]="h",r[r.i=105]="i",r[r.j=106]="j",r[r.k=107]="k",r[r.l=108]="l",r[r.m=109]="m",r[r.n=110]="n",r[r.o=111]="o",r[r.p=112]="p",r[r.q=113]="q",r[r.r=114]="r",r[r.s=115]="s",r[r.t=116]="t",r[r.u=117]="u",r[r.v=118]="v",r[r.w=119]="w",r[r.x=120]="x",r[r.y=121]="y",r[r.z=122]="z"})(s||(s={}));var I;(function(r){r[r.fa=24934]="fa",r[r.fg=26470]="fg",r[r.fq=29030]="fq",r[r.fr=29286]="fr",r[r.ft=29798]="ft",r[r.fv=30310]="fv",r[r.fx=30822]="fx",r[r.hk=27496]="hk",r[r.hl=27752]="hl",r[r.ho=28520]="ho",r[r.ml=27757]="ml",r[r.nj=27246]="nj",r[r.nl=27758]="nl",r[r.np=28782]="np",r[r.qt=29809]="qt",r[r.rt=29810]="rt",r[r.sg=26483]="sg",r[r.sw=30579]="sw"})(I||(I={}));const E=new Uint8Array([s.r,s.R,s.s,s.e,s.E,s.f,s.a,s.q,s.Q,s.t,s.T,s.d,s.w,s.W,s.c,s.z,s.x,s.v,s.g]),u=new Uint16Array([s.k,s.o,s.i,s.O,s.j,s.p,s.u,s.P,s.h,I.hk,I.ho,I.hl,s.y,s.n,I.nj,I.np,I.nl,s.b,s.m,I.ml,s.l]),C=new Uint16Array([s.r,s.R,I.rt,s.s,I.sw,I.sg,s.e,s.f,I.fr,I.fa,I.fq,I.ft,I.fx,I.fv,I.fg,s.a,s.q,I.qt,s.t,s.T,s.d,s.w,s.c,s.z,s.x,s.v,s.g]),v=new Uint16Array([s.r,s.R,I.rt,s.s,I.sw,I.sg,s.e,s.E,s.f,I.fr,I.fa,I.fq,I.ft,I.fx,I.fv,I.fg,s.a,s.q,s.Q,I.qt,s.t,s.T,s.d,s.w,s.W,s.c,s.z,s.x,s.v,s.g,s.k,s.o,s.i,s.O,s.j,s.p,s.u,s.P,s.h,I.hk,I.ho,I.hl,s.y,s.n,I.nj,I.np,I.nl,s.b,s.m,I.ml,s.l])}),define(ke[142],Re([1,0]),function(Ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=void 0,e.clamp=S,e.rot=T,e.isPointWithinTriangle=A;function S(m,s,I){return Math.min(Math.max(m,s),I)}function T(m,s){return(s+m%s)%s}class D{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=D;class O{constructor(){this._n=1,this._val=0}update(s){return this._val=this._val+(s-this._val)/this._n,this._n+=1,this._val}get value(){return this._val}}e.MovingAverage=O;class k{constructor(s){this._n=0,this._val=0,this._values=[],this._index=0,this._sum=0,this._values=new Array(s),this._values.fill(0,0,s)}update(s){const I=this._values[this._index];return this._values[this._index]=s,this._index=(this._index+1)%this._values.length,this._sum-=I,this._sum+=s,this._n<this._values.length&&(this._n+=1),this._val=this._sum/this._n,this._val}get value(){return this._val}}e.SlidingWindowAverage=k;function A(m,s,I,E,u,C,v,r){const a=v-I,d=r-E,l=u-I,i=C-E,n=m-I,t=s-E,o=a*a+d*d,c=a*l+d*i,g=a*n+d*t,f=l*l+i*i,h=l*n+i*t,_=1/(o*f-c*c),y=(f*g-c*h)*_,w=(o*h-c*g)*_;return y>=0&&w>=0&&y+w<1}}),define(ke[143],Re([1,0]),function(Ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DebugNameData=void 0,e.getDebugName=O,e.getFunctionName=u;class S{constructor(v,r,a){this.owner=v,this.debugNameSource=r,this.referenceFn=a}getDebugName(v){return O(v,this)}}e.DebugNameData=S;const T=new Map,D=new WeakMap;function O(C,v){const r=D.get(C);if(r)return r;const a=k(C,v);if(a){let d=T.get(a)??0;d++,T.set(a,d);const l=d===1?a:`${a}#${d}`;return D.set(C,l),l}}function k(C,v){const r=D.get(C);if(r)return r;const a=v.owner?I(v.owner)+".":"";let d;const l=v.debugNameSource;if(l!==void 0)if(typeof l=="function"){if(d=l(),d!==void 0)return a+d}else return a+l;const i=v.referenceFn;if(i!==void 0&&(d=u(i),d!==void 0))return a+d;if(v.owner!==void 0){const n=A(v.owner,C);if(n!==void 0)return a+n}}function A(C,v){for(const r in C)if(C[r]===v)return r}const m=new Map,s=new WeakMap;function I(C){const v=s.get(C);if(v)return v;const r=E(C);let a=m.get(r)??0;a++,m.set(r,a);const d=a===1?r:`${r}#${a}`;return s.set(C,d),d}function E(C){const v=C.constructor;return v?v.name:"Object"}function u(C){const v=C.toString(),a=/\/\*\*\s*@description\s*([^*]*)\*\//.exec(v);return(a?a[1]:void 0)?.trim()}}),define(ke[144],Re([1,0]),function(Ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConsoleObservableLogger=void 0,e.setLogger=T,e.getLogger=D;let S;function T(r){S=r}function D(){return S}class O{constructor(){this.indentation=0,this.changedObservablesSets=new WeakMap}textToConsoleArgs(a){return k([A(C("|  ",this.indentation)),a])}formatInfo(a){return a.hadValue?a.didChange?[A(" "),s(I(a.oldValue,70),{color:"red",strikeThrough:!0}),A(" "),s(I(a.newValue,60),{color:"green"})]:[A(" (unchanged)")]:[A(" "),s(I(a.newValue,60),{color:"green"}),A(" (initial)")]}handleObservableChanged(a,d){console.log(...this.textToConsoleArgs([m("observable value changed"),s(a.debugName,{color:"BlueViolet"}),...this.formatInfo(d)]))}formatChanges(a){if(a.size!==0)return s(" (changed deps: "+[...a].map(d=>d.debugName).join(", ")+")",{color:"gray"})}handleDerivedCreated(a){const d=a.handleChange;this.changedObservablesSets.set(a,new Set),a.handleChange=(l,i)=>(this.changedObservablesSets.get(a).add(l),d.apply(a,[l,i]))}handleDerivedRecomputed(a,d){const l=this.changedObservablesSets.get(a);console.log(...this.textToConsoleArgs([m("derived recomputed"),s(a.debugName,{color:"BlueViolet"}),...this.formatInfo(d),this.formatChanges(l),{data:[{fn:a._debugNameData.referenceFn??a._computeFn}]}])),l.clear()}handleFromEventObservableTriggered(a,d){console.log(...this.textToConsoleArgs([m("observable from event triggered"),s(a.debugName,{color:"BlueViolet"}),...this.formatInfo(d),{data:[{fn:a._getValue}]}]))}handleAutorunCreated(a){const d=a.handleChange;this.changedObservablesSets.set(a,new Set),a.handleChange=(l,i)=>(this.changedObservablesSets.get(a).add(l),d.apply(a,[l,i]))}handleAutorunTriggered(a){const d=this.changedObservablesSets.get(a);console.log(...this.textToConsoleArgs([m("autorun"),s(a.debugName,{color:"BlueViolet"}),this.formatChanges(d),{data:[{fn:a._debugNameData.referenceFn??a._runFn}]}])),d.clear(),this.indentation++}handleAutorunFinished(a){this.indentation--}handleBeginTransaction(a){let d=a.getDebugName();d===void 0&&(d=""),console.log(...this.textToConsoleArgs([m("transaction"),s(d,{color:"BlueViolet"}),{data:[{fn:a._fn}]}])),this.indentation++}handleEndTransaction(){this.indentation--}}e.ConsoleObservableLogger=O;function k(r){const a=new Array,d=[];let l="";function i(t){if("length"in t)for(const o of t)o&&i(o);else"text"in t?(l+=`%c${t.text}`,a.push(t.style),t.data&&d.push(...t.data)):"data"in t&&d.push(...t.data)}i(r);const n=[l,...a];return n.push(...d),n}function A(r){return s(r,{color:"black"})}function m(r){return s(v(`${r}: `,10),{color:"black",bold:!0})}function s(r,a={color:"black"}){function d(i){return Object.entries(i).reduce((n,[t,o])=>`${n}${t}:${o};`,"")}const l={color:a.color};return a.strikeThrough&&(l["text-decoration"]="line-through"),a.bold&&(l["font-weight"]="bold"),{text:r,style:d(l)}}function I(r,a){switch(typeof r){case"number":return""+r;case"string":return r.length+2<=a?`"${r}"`:`"${r.substr(0,a-7)}"+...`;case"boolean":return r?"true":"false";case"undefined":return"undefined";case"object":return r===null?"null":Array.isArray(r)?E(r,a):u(r,a);case"symbol":return r.toString();case"function":return`[[Function${r.name?" "+r.name:""}]]`;default:return""+r}}function E(r,a){let d="[ ",l=!0;for(const i of r){if(l||(d+=", "),d.length-5>a){d+="...";break}l=!1,d+=`${I(i,a-d.length)}`}return d+=" ]",d}function u(r,a){let d="{ ",l=!0;for(const[i,n]of Object.entries(r)){if(l||(d+=", "),d.length-5>a){d+="...";break}l=!1,d+=`${i}: ${I(n,a-d.length)}`}return d+=" }",d}function C(r,a){let d="";for(let l=1;l<=a;l++)d+=r;return d}function v(r,a){for(;r.length<a;)r+=" ";return r}}),define(ke[145],Re([1,0,137,143,144]),function(Ee,e,S,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DisposableObservableValue=e.ObservableValue=e.TransactionImpl=e.BaseObservable=e.ConvenientObservable=void 0,e._setRecomputeInitiallyAndOnChange=k,e._setKeepObserved=m,e._setDerivedOpts=I,e.transaction=C,e.globalTransaction=r,e.asyncTransaction=a,e.subtransaction=d,e.observableValue=i,e.disposableObservableValue=t;let O;function k(c){O=c}let A;function m(c){A=c}let s;function I(c){s=c}class E{get TChange(){return null}reportChanges(){this.get()}read(g){return g?g.readObservable(this):this.get()}map(g,f){const h=f===void 0?void 0:g,_=f===void 0?g:f;return s({owner:h,debugName:()=>{const y=(0,T.getFunctionName)(_);if(y!==void 0)return y;const P=/^\s*\(?\s*([a-zA-Z_$][a-zA-Z_$0-9]*)\s*\)?\s*=>\s*\1(?:\??)\.([a-zA-Z_$][a-zA-Z_$0-9]*)\s*$/.exec(_.toString());if(P)return`${this.debugName}.${P[2]}`;if(!h)return`${this.debugName} (mapped)`},debugReferenceFn:_},y=>_(this.read(y),y))}flatten(){return s({owner:void 0,debugName:()=>`${this.debugName} (flattened)`},g=>this.read(g).read(g))}recomputeInitiallyAndOnChange(g,f){return g.add(O(this,f)),this}keepObserved(g){return g.add(A(this)),this}get debugValue(){return this.get()}}e.ConvenientObservable=E;class u extends E{constructor(){super(...arguments),this.observers=new Set}addObserver(g){const f=this.observers.size;this.observers.add(g),f===0&&this.onFirstObserverAdded()}removeObserver(g){this.observers.delete(g)&&this.observers.size===0&&this.onLastObserverRemoved()}onFirstObserverAdded(){}onLastObserverRemoved(){}}e.BaseObservable=u;function C(c,g){const f=new l(c,g);try{c(f)}finally{f.finish()}}let v;function r(c){if(v)c(v);else{const g=new l(c,void 0);v=g;try{c(g)}finally{g.finish(),v=void 0}}}async function a(c,g){const f=new l(c,g);try{await c(f)}finally{f.finish()}}function d(c,g,f){c?g(c):C(g,f)}class l{constructor(g,f){this._fn=g,this._getDebugName=f,this.updatingObservers=[],(0,D.getLogger)()?.handleBeginTransaction(this)}getDebugName(){return this._getDebugName?this._getDebugName():(0,T.getFunctionName)(this._fn)}updateObserver(g,f){this.updatingObservers.push({observer:g,observable:f}),g.beginUpdate(f)}finish(){const g=this.updatingObservers;for(let f=0;f<g.length;f++){const{observer:h,observable:_}=g[f];h.endUpdate(_)}this.updatingObservers=null,(0,D.getLogger)()?.handleEndTransaction()}}e.TransactionImpl=l;function i(c,g){let f;return typeof c=="string"?f=new T.DebugNameData(void 0,c,void 0):f=new T.DebugNameData(c,void 0,void 0),new n(f,g,S.strictEquals)}class n extends u{get debugName(){return this._debugNameData.getDebugName(this)??"ObservableValue"}constructor(g,f,h){super(),this._debugNameData=g,this._equalityComparator=h,this._value=f}get(){return this._value}set(g,f,h){if(h===void 0&&this._equalityComparator(this._value,g))return;let _;f||(f=_=new l(()=>{},()=>`Setting ${this.debugName}`));try{const y=this._value;this._setValue(g),(0,D.getLogger)()?.handleObservableChanged(this,{oldValue:y,newValue:g,change:h,didChange:!0,hadValue:!0});for(const w of this.observers)f.updateObserver(w,this),w.handleChange(this,h)}finally{_&&_.finish()}}toString(){return`${this.debugName}: ${this._value}`}_setValue(g){this._value=g}}e.ObservableValue=n;function t(c,g){let f;return typeof c=="string"?f=new T.DebugNameData(void 0,c,void 0):f=new T.DebugNameData(c,void 0,void 0),new o(f,g,S.strictEquals)}class o extends n{_setValue(g){this._value!==g&&(this._value&&this._value.dispose(),this._value=g)}dispose(){this._value?.dispose()}}e.DisposableObservableValue=o}),function(){function Ee(D){const O=[];typeof D=="number"&&O.push("code/timeOrigin",D);function k(m){O.push(m,Date.now())}function A(){const m=[];for(let s=0;s<O.length;s+=2)m.push({name:O[s],startTime:O[s+1]});return m}return{mark:k,getMarks:A}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?Ee():{mark(D){performance.mark(D)},getMarks(){let D=performance.timeOrigin;typeof D!="number"&&(D=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const O=[{name:"code/timeOrigin",startTime:Math.round(D)}];for(const k of performance.getEntriesByType("mark"))O.push({name:k.name,startTime:Math.round(D+k.startTime)});return O}};if(typeof process=="object"){const D=performance?.timeOrigin;return Ee(D)}else return console.trace("perf-util loaded in UNKNOWN environment"),Ee()}function S(D){return D.MonacoPerformanceMarks||(D.MonacoPerformanceMarks=e()),D.MonacoPerformanceMarks}var T;typeof global=="object"?T=global:typeof self=="object"?T=self:T={},typeof define=="function"?define("vs/base/common/performance",[],function(){return S(T)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=S(T):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),T.perf=S(T))}(),define(ke[146],Re([1,0,41]),function(Ee,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WellDefinedPrefixTree=void 0;const T=Symbol("unset");class D{constructor(){this.root=new k,this._size=0}get size(){return this._size}get nodes(){return this.root.children?.values()||S.Iterable.empty()}get entries(){return this.root.children?.entries()||S.Iterable.empty()}insert(m,s,I){this.opNode(m,E=>E._value=s,I)}mutate(m,s){this.opNode(m,I=>I._value=s(I._value===T?void 0:I._value))}mutatePath(m,s){this.opNode(m,()=>{},I=>s(I))}delete(m){const s=this.getPathToKey(m);if(!s)return;let I=s.length-1;const E=s[I].node._value;if(E!==T){for(this._size--,s[I].node._value=T;I>0;I--){const{node:u,part:C}=s[I];if(u.children?.size||u._value!==T)break;s[I-1].node.children.delete(C)}return E}}*deleteRecursive(m){const s=this.getPathToKey(m);if(!s)return;const I=s[s.length-1].node;for(let E=s.length-1;E>0;E--){const u=s[E-1];if(u.node.children.delete(s[E].part),u.node.children.size>0||u.node._value!==T)break}for(const E of O(I))E._value!==T&&(this._size--,yield E._value)}find(m){let s=this.root;for(const I of m){const E=s.children?.get(I);if(!E)return;s=E}return s._value===T?void 0:s._value}hasKeyOrParent(m){let s=this.root;for(const I of m){const E=s.children?.get(I);if(!E)return!1;if(E._value!==T)return!0;s=E}return!1}hasKeyOrChildren(m){let s=this.root;for(const I of m){const E=s.children?.get(I);if(!E)return!1;s=E}return!0}hasKey(m){let s=this.root;for(const I of m){const E=s.children?.get(I);if(!E)return!1;s=E}return s._value!==T}getPathToKey(m){const s=[{part:"",node:this.root}];let I=0;for(const E of m){const u=s[I].node.children?.get(E);if(!u)return;s.push({part:E,node:u}),I++}return s}opNode(m,s,I){let E=this.root;for(const v of m){if(E.children)if(E.children.has(v))E=E.children.get(v);else{const r=new k;E.children.set(v,r),E=r}else{const r=new k;E.children=new Map([[v,r]]),E=r}I?.(E)}const u=E._value===T?0:1;s(E);const C=E._value===T?0:1;this._size+=C-u}*values(){for(const{_value:m}of O(this.root))m!==T&&(yield m)}}e.WellDefinedPrefixTree=D;function*O(A){const m=[A];for(;m.length>0;){const s=m.pop();if(yield s,s.children)for(const I of s.children.values())m.push(I)}}class k{constructor(){this._value=T}get value(){return this._value===T?void 0:this._value}set value(m){this._value=m===void 0?T:m}}}),function(Ee,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var S=e();for(var T in S)(typeof exports=="object"?exports:Ee)[T]=S[T]}}(typeof self<"u"?self:this,function(){return function(Ee){var e={};function S(T){if(e[T])return e[T].exports;var D=e[T]={i:T,l:!1,exports:{}};return Ee[T].call(D.exports,D,D.exports,S),D.l=!0,D.exports}return S.m=Ee,S.c=e,S.d=function(T,D,O){S.o(T,D)||Object.defineProperty(T,D,{enumerable:!0,get:O})},S.r=function(T){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(T,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(T,"__esModule",{value:!0})},S.t=function(T,D){if(1&D&&(T=S(T)),8&D||4&D&&typeof T=="object"&&T&&T.__esModule)return T;var O=Object.create(null);if(S.r(O),Object.defineProperty(O,"default",{enumerable:!0,value:T}),2&D&&typeof T!="string")for(var k in T)S.d(O,k,function(A){return T[A]}.bind(null,k));return O},S.n=function(T){var D=T&&T.__esModule?function(){return T.default}:function(){return T};return S.d(D,"a",D),D},S.o=function(T,D){return Object.prototype.hasOwnProperty.call(T,D)},S.p="",S(S.s=0)}([function(Ee,e,S){(function(T){var D;e=Ee.exports=ve,D=typeof T=="object"&&T.env&&T.env.NODE_DEBUG&&/\bsemver\b/i.test(T.env.NODE_DEBUG)?function(){var z=Array.prototype.slice.call(arguments,0);z.unshift("SEMVER"),console.log.apply(console,z)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var O=256,k=Number.MAX_SAFE_INTEGER||9007199254740991,A=e.re=[],m=e.src=[],s=0,I=s++;m[I]="0|[1-9]\\d*";var E=s++;m[E]="[0-9]+";var u=s++;m[u]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var C=s++;m[C]="("+m[I]+")\\.("+m[I]+")\\.("+m[I]+")";var v=s++;m[v]="("+m[E]+")\\.("+m[E]+")\\.("+m[E]+")";var r=s++;m[r]="(?:"+m[I]+"|"+m[u]+")";var a=s++;m[a]="(?:"+m[E]+"|"+m[u]+")";var d=s++;m[d]="(?:-("+m[r]+"(?:\\."+m[r]+")*))";var l=s++;m[l]="(?:-?("+m[a]+"(?:\\."+m[a]+")*))";var i=s++;m[i]="[0-9A-Za-z-]+";var n=s++;m[n]="(?:\\+("+m[i]+"(?:\\."+m[i]+")*))";var t=s++,o="v?"+m[C]+m[d]+"?"+m[n]+"?";m[t]="^"+o+"$";var c="[v=\\s]*"+m[v]+m[l]+"?"+m[n]+"?",g=s++;m[g]="^"+c+"$";var f=s++;m[f]="((?:<|>)?=?)";var h=s++;m[h]=m[E]+"|x|X|\\*";var _=s++;m[_]=m[I]+"|x|X|\\*";var y=s++;m[y]="[v=\\s]*("+m[_]+")(?:\\.("+m[_]+")(?:\\.("+m[_]+")(?:"+m[d]+")?"+m[n]+"?)?)?";var w=s++;m[w]="[v=\\s]*("+m[h]+")(?:\\.("+m[h]+")(?:\\.("+m[h]+")(?:"+m[l]+")?"+m[n]+"?)?)?";var P=s++;m[P]="^"+m[f]+"\\s*"+m[y]+"$";var R=s++;m[R]="^"+m[f]+"\\s*"+m[w]+"$";var p=s++;m[p]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var b=s++;m[b]="(?:~>?)";var N=s++;m[N]="(\\s*)"+m[b]+"\\s+",A[N]=new RegExp(m[N],"g");var L=s++;m[L]="^"+m[b]+m[y]+"$";var F=s++;m[F]="^"+m[b]+m[w]+"$";var K=s++;m[K]="(?:\\^)";var J=s++;m[J]="(\\s*)"+m[K]+"\\s+",A[J]=new RegExp(m[J],"g");var $=s++;m[$]="^"+m[K]+m[y]+"$";var x=s++;m[x]="^"+m[K]+m[w]+"$";var G=s++;m[G]="^"+m[f]+"\\s*("+c+")$|^$";var Y=s++;m[Y]="^"+m[f]+"\\s*("+o+")$|^$";var ae=s++;m[ae]="(\\s*)"+m[f]+"\\s*("+c+"|"+m[y]+")",A[ae]=new RegExp(m[ae],"g");var ee=s++;m[ee]="^\\s*("+m[y]+")\\s+-\\s+("+m[y]+")\\s*$";var oe=s++;m[oe]="^\\s*("+m[w]+")\\s+-\\s+("+m[w]+")\\s*$";var ie=s++;m[ie]="(<|>)?=?\\s*\\*";for(var ue=0;ue<35;ue++)D(ue,m[ue]),A[ue]||(A[ue]=new RegExp(m[ue]));function Z(z,H){if(z instanceof ve)return z;if(typeof z!="string"||z.length>O||!(H?A[g]:A[t]).test(z))return null;try{return new ve(z,H)}catch{return null}}function ve(z,H){if(z instanceof ve){if(z.loose===H)return z;z=z.version}else if(typeof z!="string")throw new TypeError("Invalid Version: "+z);if(z.length>O)throw new TypeError("version is longer than "+O+" characters");if(!(this instanceof ve))return new ve(z,H);D("SemVer",z,H),this.loose=H;var q=z.trim().match(H?A[g]:A[t]);if(!q)throw new TypeError("Invalid Version: "+z);if(this.raw=z,this.major=+q[1],this.minor=+q[2],this.patch=+q[3],this.major>k||this.major<0)throw new TypeError("Invalid major version");if(this.minor>k||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>k||this.patch<0)throw new TypeError("Invalid patch version");q[4]?this.prerelease=q[4].split(".").map(function(se){if(/^[0-9]+$/.test(se)){var ge=+se;if(ge>=0&&ge<k)return ge}return se}):this.prerelease=[],this.build=q[5]?q[5].split("."):[],this.format()}e.parse=Z,e.valid=function(z,H){var q=Z(z,H);return q?q.version:null},e.clean=function(z,H){var q=Z(z.trim().replace(/^[=v]+/,""),H);return q?q.version:null},e.SemVer=ve,ve.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},ve.prototype.toString=function(){return this.version},ve.prototype.compare=function(z){return D("SemVer.compare",this.version,this.loose,z),z instanceof ve||(z=new ve(z,this.loose)),this.compareMain(z)||this.comparePre(z)},ve.prototype.compareMain=function(z){return z instanceof ve||(z=new ve(z,this.loose)),X(this.major,z.major)||X(this.minor,z.minor)||X(this.patch,z.patch)},ve.prototype.comparePre=function(z){if(z instanceof ve||(z=new ve(z,this.loose)),this.prerelease.length&&!z.prerelease.length)return-1;if(!this.prerelease.length&&z.prerelease.length)return 1;if(!this.prerelease.length&&!z.prerelease.length)return 0;var H=0;do{var q=this.prerelease[H],se=z.prerelease[H];if(D("prerelease compare",H,q,se),q===void 0&&se===void 0)return 0;if(se===void 0)return 1;if(q===void 0)return-1;if(q!==se)return X(q,se)}while(++H)},ve.prototype.inc=function(z,H){switch(z){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",H);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",H);break;case"prepatch":this.prerelease.length=0,this.inc("patch",H),this.inc("pre",H);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",H),this.inc("pre",H);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var q=this.prerelease.length;--q>=0;)typeof this.prerelease[q]=="number"&&(this.prerelease[q]++,q=-2);q===-1&&this.prerelease.push(0)}H&&(this.prerelease[0]===H?isNaN(this.prerelease[1])&&(this.prerelease=[H,0]):this.prerelease=[H,0]);break;default:throw new Error("invalid increment argument: "+z)}return this.format(),this.raw=this.version,this},e.inc=function(z,H,q,se){typeof q=="string"&&(se=q,q=void 0);try{return new ve(z,q).inc(H,se).version}catch{return null}},e.diff=function(z,H){if(De(z,H))return null;var q=Z(z),se=Z(H);if(q.prerelease.length||se.prerelease.length){for(var ge in q)if((ge==="major"||ge==="minor"||ge==="patch")&&q[ge]!==se[ge])return"pre"+ge;return"prerelease"}for(var ge in q)if((ge==="major"||ge==="minor"||ge==="patch")&&q[ge]!==se[ge])return ge},e.compareIdentifiers=X;var Ie=/^[0-9]+$/;function X(z,H){var q=Ie.test(z),se=Ie.test(H);return q&&se&&(z=+z,H=+H),q&&!se?-1:se&&!q?1:z<H?-1:z>H?1:0}function V(z,H,q){return new ve(z,q).compare(new ve(H,q))}function re(z,H,q){return V(z,H,q)>0}function be(z,H,q){return V(z,H,q)<0}function De(z,H,q){return V(z,H,q)===0}function Fe(z,H,q){return V(z,H,q)!==0}function ze(z,H,q){return V(z,H,q)>=0}function Je(z,H,q){return V(z,H,q)<=0}function nt(z,H,q,se){var ge;switch(H){case"===":typeof z=="object"&&(z=z.version),typeof q=="object"&&(q=q.version),ge=z===q;break;case"!==":typeof z=="object"&&(z=z.version),typeof q=="object"&&(q=q.version),ge=z!==q;break;case"":case"=":case"==":ge=De(z,q,se);break;case"!=":ge=Fe(z,q,se);break;case">":ge=re(z,q,se);break;case">=":ge=ze(z,q,se);break;case"<":ge=be(z,q,se);break;case"<=":ge=Je(z,q,se);break;default:throw new TypeError("Invalid operator: "+H)}return ge}function dt(z,H){if(z instanceof dt){if(z.loose===H)return z;z=z.value}if(!(this instanceof dt))return new dt(z,H);D("comparator",z,H),this.loose=H,this.parse(z),this.semver===vt?this.value="":this.value=this.operator+this.semver.version,D("comp",this)}e.rcompareIdentifiers=function(z,H){return X(H,z)},e.major=function(z,H){return new ve(z,H).major},e.minor=function(z,H){return new ve(z,H).minor},e.patch=function(z,H){return new ve(z,H).patch},e.compare=V,e.compareLoose=function(z,H){return V(z,H,!0)},e.rcompare=function(z,H,q){return V(H,z,q)},e.sort=function(z,H){return z.sort(function(q,se){return e.compare(q,se,H)})},e.rsort=function(z,H){return z.sort(function(q,se){return e.rcompare(q,se,H)})},e.gt=re,e.lt=be,e.eq=De,e.neq=Fe,e.gte=ze,e.lte=Je,e.cmp=nt,e.Comparator=dt;var vt={};function ut(z,H){if(z instanceof ut)return z.loose===H?z:new ut(z.raw,H);if(z instanceof dt)return new ut(z.value,H);if(!(this instanceof ut))return new ut(z,H);if(this.loose=H,this.raw=z,this.set=z.split(/\s*\|\|\s*/).map(function(q){return this.parseRange(q.trim())},this).filter(function(q){return q.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+z);this.format()}function et(z){return!z||z.toLowerCase()==="x"||z==="*"}function Oe(z,H,q,se,ge,ye,Ue,Ge,Ze,tt,lt,it,at){return((H=et(q)?"":et(se)?">="+q+".0.0":et(ge)?">="+q+"."+se+".0":">="+H)+" "+(Ge=et(Ze)?"":et(tt)?"<"+(+Ze+1)+".0.0":et(lt)?"<"+Ze+"."+(+tt+1)+".0":it?"<="+Ze+"."+tt+"."+lt+"-"+it:"<="+Ge)).trim()}function Me(z,H){for(var q=0;q<z.length;q++)if(!z[q].test(H))return!1;if(H.prerelease.length){for(q=0;q<z.length;q++)if(D(z[q].semver),z[q].semver!==vt&&z[q].semver.prerelease.length>0){var se=z[q].semver;if(se.major===H.major&&se.minor===H.minor&&se.patch===H.patch)return!0}return!1}return!0}function Ne(z,H,q){try{H=new ut(H,q)}catch{return!1}return H.test(z)}function B(z,H,q,se){var ge,ye,Ue,Ge,Ze;switch(z=new ve(z,se),H=new ut(H,se),q){case">":ge=re,ye=Je,Ue=be,Ge=">",Ze=">=";break;case"<":ge=be,ye=ze,Ue=re,Ge="<",Ze="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Ne(z,H,se))return!1;for(var tt=0;tt<H.set.length;++tt){var lt=H.set[tt],it=null,at=null;if(lt.forEach(function(wt){wt.semver===vt&&(wt=new dt(">=0.0.0")),it=it||wt,at=at||wt,ge(wt.semver,it.semver,se)?it=wt:Ue(wt.semver,at.semver,se)&&(at=wt)}),it.operator===Ge||it.operator===Ze||(!at.operator||at.operator===Ge)&&ye(z,at.semver)||at.operator===Ze&&Ue(z,at.semver))return!1}return!0}dt.prototype.parse=function(z){var H=this.loose?A[G]:A[Y],q=z.match(H);if(!q)throw new TypeError("Invalid comparator: "+z);this.operator=q[1],this.operator==="="&&(this.operator=""),q[2]?this.semver=new ve(q[2],this.loose):this.semver=vt},dt.prototype.toString=function(){return this.value},dt.prototype.test=function(z){return D("Comparator.test",z,this.loose),this.semver===vt||(typeof z=="string"&&(z=new ve(z,this.loose)),nt(z,this.operator,this.semver,this.loose))},dt.prototype.intersects=function(z,H){if(!(z instanceof dt))throw new TypeError("a Comparator is required");var q;if(this.operator==="")return q=new ut(z.value,H),Ne(this.value,q,H);if(z.operator==="")return q=new ut(this.value,H),Ne(z.semver,q,H);var se=!(this.operator!==">="&&this.operator!==">"||z.operator!==">="&&z.operator!==">"),ge=!(this.operator!=="<="&&this.operator!=="<"||z.operator!=="<="&&z.operator!=="<"),ye=this.semver.version===z.semver.version,Ue=!(this.operator!==">="&&this.operator!=="<="||z.operator!==">="&&z.operator!=="<="),Ge=nt(this.semver,"<",z.semver,H)&&(this.operator===">="||this.operator===">")&&(z.operator==="<="||z.operator==="<"),Ze=nt(this.semver,">",z.semver,H)&&(this.operator==="<="||this.operator==="<")&&(z.operator===">="||z.operator===">");return se||ge||ye&&Ue||Ge||Ze},e.Range=ut,ut.prototype.format=function(){return this.range=this.set.map(function(z){return z.join(" ").trim()}).join("||").trim(),this.range},ut.prototype.toString=function(){return this.range},ut.prototype.parseRange=function(z){var H=this.loose;z=z.trim(),D("range",z,H);var q=H?A[oe]:A[ee];z=z.replace(q,Oe),D("hyphen replace",z),z=z.replace(A[ae],"$1$2$3"),D("comparator trim",z,A[ae]),z=(z=(z=z.replace(A[N],"$1~")).replace(A[J],"$1^")).split(/\s+/).join(" ");var se=H?A[G]:A[Y],ge=z.split(" ").map(function(ye){return function(Ue,Ge){return D("comp",Ue),Ue=function(Ze,tt){return Ze.trim().split(/\s+/).map(function(lt){return function(it,at){D("caret",it,at);var wt=at?A[x]:A[$];return it.replace(wt,function(Qe,de,pe,we,Pe){var fe;return D("caret",it,Qe,de,pe,we,Pe),et(de)?fe="":et(pe)?fe=">="+de+".0.0 <"+(+de+1)+".0.0":et(we)?fe=de==="0"?">="+de+"."+pe+".0 <"+de+"."+(+pe+1)+".0":">="+de+"."+pe+".0 <"+(+de+1)+".0.0":Pe?(D("replaceCaret pr",Pe),Pe.charAt(0)!=="-"&&(Pe="-"+Pe),fe=de==="0"?pe==="0"?">="+de+"."+pe+"."+we+Pe+" <"+de+"."+pe+"."+(+we+1):">="+de+"."+pe+"."+we+Pe+" <"+de+"."+(+pe+1)+".0":">="+de+"."+pe+"."+we+Pe+" <"+(+de+1)+".0.0"):(D("no pr"),fe=de==="0"?pe==="0"?">="+de+"."+pe+"."+we+" <"+de+"."+pe+"."+(+we+1):">="+de+"."+pe+"."+we+" <"+de+"."+(+pe+1)+".0":">="+de+"."+pe+"."+we+" <"+(+de+1)+".0.0"),D("caret return",fe),fe})}(lt,tt)}).join(" ")}(Ue,Ge),D("caret",Ue),Ue=function(Ze,tt){return Ze.trim().split(/\s+/).map(function(lt){return function(it,at){var wt=at?A[F]:A[L];return it.replace(wt,function(Qe,de,pe,we,Pe){var fe;return D("tilde",it,Qe,de,pe,we,Pe),et(de)?fe="":et(pe)?fe=">="+de+".0.0 <"+(+de+1)+".0.0":et(we)?fe=">="+de+"."+pe+".0 <"+de+"."+(+pe+1)+".0":Pe?(D("replaceTilde pr",Pe),Pe.charAt(0)!=="-"&&(Pe="-"+Pe),fe=">="+de+"."+pe+"."+we+Pe+" <"+de+"."+(+pe+1)+".0"):fe=">="+de+"."+pe+"."+we+" <"+de+"."+(+pe+1)+".0",D("tilde return",fe),fe})}(lt,tt)}).join(" ")}(Ue,Ge),D("tildes",Ue),Ue=function(Ze,tt){return D("replaceXRanges",Ze,tt),Ze.split(/\s+/).map(function(lt){return function(it,at){it=it.trim();var wt=at?A[R]:A[P];return it.replace(wt,function(Qe,de,pe,we,Pe,fe){D("xRange",it,Qe,de,pe,we,Pe,fe);var Se=et(pe),Q=Se||et(we),W=Q||et(Pe);return de==="="&&W&&(de=""),Se?Qe=de===">"||de==="<"?"<0.0.0":"*":de&&W?(Q&&(we=0),W&&(Pe=0),de===">"?(de=">=",Q?(pe=+pe+1,we=0,Pe=0):W&&(we=+we+1,Pe=0)):de==="<="&&(de="<",Q?pe=+pe+1:we=+we+1),Qe=de+pe+"."+we+"."+Pe):Q?Qe=">="+pe+".0.0 <"+(+pe+1)+".0.0":W&&(Qe=">="+pe+"."+we+".0 <"+pe+"."+(+we+1)+".0"),D("xRange return",Qe),Qe})}(lt,tt)}).join(" ")}(Ue,Ge),D("xrange",Ue),Ue=function(Ze,tt){return D("replaceStars",Ze,tt),Ze.trim().replace(A[ie],"")}(Ue,Ge),D("stars",Ue),Ue}(ye,H)}).join(" ").split(/\s+/);return this.loose&&(ge=ge.filter(function(ye){return!!ye.match(se)})),ge=ge.map(function(ye){return new dt(ye,H)})},ut.prototype.intersects=function(z,H){if(!(z instanceof ut))throw new TypeError("a Range is required");return this.set.some(function(q){return q.every(function(se){return z.set.some(function(ge){return ge.every(function(ye){return se.intersects(ye,H)})})})})},e.toComparators=function(z,H){return new ut(z,H).set.map(function(q){return q.map(function(se){return se.value}).join(" ").trim().split(" ")})},ut.prototype.test=function(z){if(!z)return!1;typeof z=="string"&&(z=new ve(z,this.loose));for(var H=0;H<this.set.length;H++)if(Me(this.set[H],z))return!0;return!1},e.satisfies=Ne,e.maxSatisfying=function(z,H,q){var se=null,ge=null;try{var ye=new ut(H,q)}catch{return null}return z.forEach(function(Ue){ye.test(Ue)&&(se&&ge.compare(Ue)!==-1||(ge=new ve(se=Ue,q)))}),se},e.minSatisfying=function(z,H,q){var se=null,ge=null;try{var ye=new ut(H,q)}catch{return null}return z.forEach(function(Ue){ye.test(Ue)&&(se&&ge.compare(Ue)!==1||(ge=new ve(se=Ue,q)))}),se},e.validRange=function(z,H){try{return new ut(z,H).range||"*"}catch{return null}},e.ltr=function(z,H,q){return B(z,H,"<",q)},e.gtr=function(z,H,q){return B(z,H,">",q)},e.outside=B,e.prerelease=function(z,H){var q=Z(z,H);return q&&q.prerelease.length?q.prerelease:null},e.intersects=function(z,H,q){return z=new ut(z,q),H=new ut(H,q),z.intersects(H)},e.coerce=function(z){if(z instanceof ve)return z;if(typeof z!="string")return null;var H=z.match(A[p]);return H==null?null:Z((H[1]||"0")+"."+(H[2]||"0")+"."+(H[3]||"0"))}}).call(this,S(1))},function(Ee,e){var S,T,D=Ee.exports={};function O(){throw new Error("setTimeout has not been defined")}function k(){throw new Error("clearTimeout has not been defined")}function A(a){if(S===setTimeout)return setTimeout(a,0);if((S===O||!S)&&setTimeout)return S=setTimeout,setTimeout(a,0);try{return S(a,0)}catch{try{return S.call(null,a,0)}catch{return S.call(this,a,0)}}}(function(){try{S=typeof setTimeout=="function"?setTimeout:O}catch{S=O}try{T=typeof clearTimeout=="function"?clearTimeout:k}catch{T=k}})();var m,s=[],I=!1,E=-1;function u(){I&&m&&(I=!1,m.length?s=m.concat(s):E=-1,s.length&&C())}function C(){if(!I){var a=A(u);I=!0;for(var d=s.length;d;){for(m=s,s=[];++E<d;)m&&m[E].run();E=-1,d=s.length}m=null,I=!1,function(l){if(T===clearTimeout)return clearTimeout(l);if((T===k||!T)&&clearTimeout)return T=clearTimeout,clearTimeout(l);try{T(l)}catch{try{return T.call(null,l)}catch{return T.call(this,l)}}}(a)}}function v(a,d){this.fun=a,this.array=d}function r(){}D.nextTick=function(a){var d=new Array(arguments.length-1);if(arguments.length>1)for(var l=1;l<arguments.length;l++)d[l-1]=arguments[l];s.push(new v(a,d)),s.length!==1||I||A(C)},v.prototype.run=function(){this.fun.apply(null,this.array)},D.title="browser",D.browser=!0,D.env={},D.argv=[],D.version="",D.versions={},D.on=r,D.addListener=r,D.once=r,D.off=r,D.removeListener=r,D.removeAllListeners=r,D.emit=r,D.prependListener=r,D.prependOnceListener=r,D.listeners=function(a){return[]},D.binding=function(a){throw new Error("process.binding is not supported")},D.cwd=function(){return"/"},D.chdir=function(a){throw new Error("process.chdir is not supported")},D.umask=function(){return 0}}])}),define(ke[147],Re([1,0,6,4]),function(Ee,e,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SmoothScrollingOperation=e.SmoothScrollingUpdate=e.Scrollable=e.ScrollState=e.ScrollbarVisibility=void 0;var D;(function(C){C[C.Auto=1]="Auto",C[C.Hidden=2]="Hidden",C[C.Visible=3]="Visible"})(D||(e.ScrollbarVisibility=D={}));class O{constructor(v,r,a,d,l,i,n){this._forceIntegerValues=v,this._scrollStateBrand=void 0,this._forceIntegerValues&&(r=r|0,a=a|0,d=d|0,l=l|0,i=i|0,n=n|0),this.rawScrollLeft=d,this.rawScrollTop=n,r<0&&(r=0),d+r>a&&(d=a-r),d<0&&(d=0),l<0&&(l=0),n+l>i&&(n=i-l),n<0&&(n=0),this.width=r,this.scrollWidth=a,this.scrollLeft=d,this.height=l,this.scrollHeight=i,this.scrollTop=n}equals(v){return this.rawScrollLeft===v.rawScrollLeft&&this.rawScrollTop===v.rawScrollTop&&this.width===v.width&&this.scrollWidth===v.scrollWidth&&this.scrollLeft===v.scrollLeft&&this.height===v.height&&this.scrollHeight===v.scrollHeight&&this.scrollTop===v.scrollTop}withScrollDimensions(v,r){return new O(this._forceIntegerValues,typeof v.width<"u"?v.width:this.width,typeof v.scrollWidth<"u"?v.scrollWidth:this.scrollWidth,r?this.rawScrollLeft:this.scrollLeft,typeof v.height<"u"?v.height:this.height,typeof v.scrollHeight<"u"?v.scrollHeight:this.scrollHeight,r?this.rawScrollTop:this.scrollTop)}withScrollPosition(v){return new O(this._forceIntegerValues,this.width,this.scrollWidth,typeof v.scrollLeft<"u"?v.scrollLeft:this.rawScrollLeft,this.height,this.scrollHeight,typeof v.scrollTop<"u"?v.scrollTop:this.rawScrollTop)}createScrollEvent(v,r){const a=this.width!==v.width,d=this.scrollWidth!==v.scrollWidth,l=this.scrollLeft!==v.scrollLeft,i=this.height!==v.height,n=this.scrollHeight!==v.scrollHeight,t=this.scrollTop!==v.scrollTop;return{inSmoothScrolling:r,oldWidth:v.width,oldScrollWidth:v.scrollWidth,oldScrollLeft:v.scrollLeft,width:this.width,scrollWidth:this.scrollWidth,scrollLeft:this.scrollLeft,oldHeight:v.height,oldScrollHeight:v.scrollHeight,oldScrollTop:v.scrollTop,height:this.height,scrollHeight:this.scrollHeight,scrollTop:this.scrollTop,widthChanged:a,scrollWidthChanged:d,scrollLeftChanged:l,heightChanged:i,scrollHeightChanged:n,scrollTopChanged:t}}}e.ScrollState=O;class k extends T.Disposable{constructor(v){super(),this._scrollableBrand=void 0,this._onScroll=this._register(new S.Emitter),this.onScroll=this._onScroll.event,this._smoothScrollDuration=v.smoothScrollDuration,this._scheduleAtNextAnimationFrame=v.scheduleAtNextAnimationFrame,this._state=new O(v.forceIntegerValues,0,0,0,0,0,0),this._smoothScrolling=null}dispose(){this._smoothScrolling&&(this._smoothScrolling.dispose(),this._smoothScrolling=null),super.dispose()}setSmoothScrollDuration(v){this._smoothScrollDuration=v}validateScrollPosition(v){return this._state.withScrollPosition(v)}getScrollDimensions(){return this._state}setScrollDimensions(v,r){const a=this._state.withScrollDimensions(v,r);this._setState(a,!!this._smoothScrolling),this._smoothScrolling?.acceptScrollDimensions(this._state)}getFutureScrollPosition(){return this._smoothScrolling?this._smoothScrolling.to:this._state}getCurrentScrollPosition(){return this._state}setScrollPositionNow(v){const r=this._state.withScrollPosition(v);this._smoothScrolling&&(this._smoothScrolling.dispose(),this._smoothScrolling=null),this._setState(r,!1)}setScrollPositionSmooth(v,r){if(this._smoothScrollDuration===0)return this.setScrollPositionNow(v);if(this._smoothScrolling){v={scrollLeft:typeof v.scrollLeft>"u"?this._smoothScrolling.to.scrollLeft:v.scrollLeft,scrollTop:typeof v.scrollTop>"u"?this._smoothScrolling.to.scrollTop:v.scrollTop};const a=this._state.withScrollPosition(v);if(this._smoothScrolling.to.scrollLeft===a.scrollLeft&&this._smoothScrolling.to.scrollTop===a.scrollTop)return;let d;r?d=new I(this._smoothScrolling.from,a,this._smoothScrolling.startTime,this._smoothScrolling.duration):d=this._smoothScrolling.combine(this._state,a,this._smoothScrollDuration),this._smoothScrolling.dispose(),this._smoothScrolling=d}else{const a=this._state.withScrollPosition(v);this._smoothScrolling=I.start(this._state,a,this._smoothScrollDuration)}this._smoothScrolling.animationFrameDisposable=this._scheduleAtNextAnimationFrame(()=>{this._smoothScrolling&&(this._smoothScrolling.animationFrameDisposable=null,this._performSmoothScrolling())})}hasPendingScrollAnimation(){return!!this._smoothScrolling}_performSmoothScrolling(){if(!this._smoothScrolling)return;const v=this._smoothScrolling.tick(),r=this._state.withScrollPosition(v);if(this._setState(r,!0),!!this._smoothScrolling){if(v.isDone){this._smoothScrolling.dispose(),this._smoothScrolling=null;return}this._smoothScrolling.animationFrameDisposable=this._scheduleAtNextAnimationFrame(()=>{this._smoothScrolling&&(this._smoothScrolling.animationFrameDisposable=null,this._performSmoothScrolling())})}}_setState(v,r){const a=this._state;a.equals(v)||(this._state=v,this._onScroll.fire(this._state.createScrollEvent(a,r)))}}e.Scrollable=k;class A{constructor(v,r,a){this.scrollLeft=v,this.scrollTop=r,this.isDone=a}}e.SmoothScrollingUpdate=A;function m(C,v){const r=v-C;return function(a){return C+r*u(a)}}function s(C,v,r){return function(a){return a<r?C(a/r):v((a-r)/(1-r))}}class I{constructor(v,r,a,d){this.from=v,this.to=r,this.duration=d,this.startTime=a,this.animationFrameDisposable=null,this._initAnimations()}_initAnimations(){this.scrollLeft=this._initAnimation(this.from.scrollLeft,this.to.scrollLeft,this.to.width),this.scrollTop=this._initAnimation(this.from.scrollTop,this.to.scrollTop,this.to.height)}_initAnimation(v,r,a){if(Math.abs(v-r)>2.5*a){let l,i;return v<r?(l=v+.75*a,i=r-.75*a):(l=v-.75*a,i=r+.75*a),s(m(v,l),m(i,r),.33)}return m(v,r)}dispose(){this.animationFrameDisposable!==null&&(this.animationFrameDisposable.dispose(),this.animationFrameDisposable=null)}acceptScrollDimensions(v){this.to=v.withScrollPosition(this.to),this._initAnimations()}tick(){return this._tick(Date.now())}_tick(v){const r=(v-this.startTime)/this.duration;if(r<1){const a=this.scrollLeft(r),d=this.scrollTop(r);return new A(a,d,!1)}return new A(this.to.scrollLeft,this.to.scrollTop,!0)}combine(v,r,a){return I.start(v,r,a)}static start(v,r,a){a=a+10;const d=Date.now()-10;return new I(v,r,d,a)}}e.SmoothScrollingOperation=I;function E(C){return Math.pow(C,3)}function u(C){return 1-E(1-C)}}),define(ke[148],Re([1,0,12,4]),function(Ee,e,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isReadable=D,e.isReadableStream=O,e.isReadableBufferedStream=k,e.newWriteableStream=A,e.consumeReadable=s,e.peekReadable=I,e.consumeStream=E,e.listenStream=u,e.peekStream=C,e.toStream=v,e.emptyStream=r,e.toReadable=a,e.transform=d,e.prefixedReadable=l,e.prefixedStream=i;function D(n){const t=n;return t?typeof t.read=="function":!1}function O(n){const t=n;return t?[t.on,t.pause,t.resume,t.destroy].every(o=>typeof o=="function"):!1}function k(n){const t=n;return t?O(t.stream)&&Array.isArray(t.buffer)&&typeof t.ended=="boolean":!1}function A(n,t){return new m(n,t)}class m{constructor(t,o){this.reducer=t,this.options=o,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(t){if(!this.state.destroyed){if(this.state.flowing)this.emitData(t);else if(this.buffer.data.push(t),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(o=>this.pendingWritePromises.push(o))}}error(t){this.state.destroyed||(this.state.flowing?this.emitError(t):this.buffer.error.push(t))}end(t){this.state.destroyed||(typeof t<"u"&&this.write(t),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(t){this.listeners.data.slice(0).forEach(o=>o(t))}emitError(t){this.listeners.error.length===0?(0,S.onUnexpectedError)(t):this.listeners.error.slice(0).forEach(o=>o(t))}emitEnd(){this.listeners.end.slice(0).forEach(t=>t())}on(t,o){if(!this.state.destroyed)switch(t){case"data":this.listeners.data.push(o),this.resume();break;case"end":this.listeners.end.push(o),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(o),this.state.flowing&&this.flowErrors();break}}removeListener(t,o){if(this.state.destroyed)return;let c;switch(t){case"data":c=this.listeners.data;break;case"end":c=this.listeners.end;break;case"error":c=this.listeners.error;break}if(c){const g=c.indexOf(o);g>=0&&c.splice(g,1)}}flowData(){if(this.buffer.data.length>0){const t=this.reducer(this.buffer.data);this.emitData(t),this.buffer.data.length=0;const o=[...this.pendingWritePromises];this.pendingWritePromises.length=0,o.forEach(c=>c())}}flowErrors(){if(this.listeners.error.length>0){for(const t of this.buffer.error)this.emitError(t);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function s(n,t){const o=[];let c;for(;(c=n.read())!==null;)o.push(c);return t(o)}function I(n,t,o){const c=[];let g;for(;(g=n.read())!==null&&c.length<o;)c.push(g);return g===null&&c.length>0?t(c):{read:()=>{if(c.length>0)return c.shift();if(typeof g<"u"){const f=g;return g=void 0,f}return n.read()}}}function E(n,t){return new Promise((o,c)=>{const g=[];u(n,{onData:f=>{t&&g.push(f)},onError:f=>{t?c(f):o(void 0)},onEnd:()=>{o(t?t(g):void 0)}})})}function u(n,t,o){n.on("error",c=>{o?.isCancellationRequested||t.onError(c)}),n.on("end",()=>{o?.isCancellationRequested||t.onEnd()}),n.on("data",c=>{o?.isCancellationRequested||t.onData(c)})}function C(n,t){return new Promise((o,c)=>{const g=new T.DisposableStore,f=[],h=w=>{if(f.push(w),f.length>t)return g.dispose(),n.pause(),o({stream:n,buffer:f,ended:!1})},_=w=>(g.dispose(),c(w)),y=()=>(g.dispose(),o({stream:n,buffer:f,ended:!0}));g.add((0,T.toDisposable)(()=>n.removeListener("error",_))),n.on("error",_),g.add((0,T.toDisposable)(()=>n.removeListener("end",y))),n.on("end",y),g.add((0,T.toDisposable)(()=>n.removeListener("data",h))),n.on("data",h)})}function v(n,t){const o=A(t);return o.end(n),o}function r(){const n=A(()=>{throw new Error("not supported")});return n.end(),n}function a(n){let t=!1;return{read:()=>t?null:(t=!0,n)}}function d(n,t,o){const c=A(o);return u(n,{onData:g=>c.write(t.data(g)),onError:g=>c.error(t.error?t.error(g):g),onEnd:()=>c.end()}),c}function l(n,t,o){let c=!1;return{read:()=>{const g=t.read();return c?g:(c=!0,g!==null?o([n,g]):n)}}}function i(n,t,o){let c=!1;const g=A(o);return u(t,{onData:f=>c?g.write(f):(c=!0,g.write(o([n,f]))),onError:f=>g.error(f),onEnd:()=>{c||(c=!0,g.write(n)),g.end()}}),g}}),define(ke[20],Re([1,0,51,148]),function(Ee,e,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.VSBuffer=void 0,e.binaryIndexOf=s,e.readUInt16LE=I,e.writeUInt16LE=E,e.readUInt32BE=u,e.writeUInt32BE=C,e.readUInt32LE=v,e.writeUInt32LE=r,e.readUInt8=a,e.writeUInt8=d,e.readableToBuffer=l,e.bufferToReadable=i,e.streamToBuffer=n,e.bufferedStreamToBuffer=t,e.bufferToStream=o,e.streamToBufferReadableStream=c,e.newWriteableBufferStream=g,e.prefixedBufferReadable=f,e.prefixedBufferStream=h,e.decodeBase64=_,e.encodeBase64=P,T=Ve(T);const D=typeof Buffer<"u",O=new S.Lazy(()=>new Uint8Array(256));let k,A;class m{static alloc(p){return D?new m(Buffer.allocUnsafe(p)):new m(new Uint8Array(p))}static wrap(p){return D&&!Buffer.isBuffer(p)&&(p=Buffer.from(p.buffer,p.byteOffset,p.byteLength)),new m(p)}static fromString(p,b){return!(b?.dontUseNodeBuffer||!1)&&D?new m(Buffer.from(p)):(k||(k=new TextEncoder),new m(k.encode(p)))}static fromByteArray(p){const b=m.alloc(p.length);for(let N=0,L=p.length;N<L;N++)b.buffer[N]=p[N];return b}static concat(p,b){if(typeof b>"u"){b=0;for(let F=0,K=p.length;F<K;F++)b+=p[F].byteLength}const N=m.alloc(b);let L=0;for(let F=0,K=p.length;F<K;F++){const J=p[F];N.set(J,L),L+=J.byteLength}return N}constructor(p){this.buffer=p,this.byteLength=this.buffer.byteLength}clone(){const p=m.alloc(this.byteLength);return p.set(this),p}toString(){return D?this.buffer.toString():(A||(A=new TextDecoder),A.decode(this.buffer))}slice(p,b){return new m(this.buffer.subarray(p,b))}set(p,b){if(p instanceof m)this.buffer.set(p.buffer,b);else if(p instanceof Uint8Array)this.buffer.set(p,b);else if(p instanceof ArrayBuffer)this.buffer.set(new Uint8Array(p),b);else if(ArrayBuffer.isView(p))this.buffer.set(new Uint8Array(p.buffer,p.byteOffset,p.byteLength),b);else throw new Error("Unknown argument 'array'")}readUInt32BE(p){return u(this.buffer,p)}writeUInt32BE(p,b){C(this.buffer,p,b)}readUInt32LE(p){return v(this.buffer,p)}writeUInt32LE(p,b){r(this.buffer,p,b)}readUInt8(p){return a(this.buffer,p)}writeUInt8(p,b){d(this.buffer,p,b)}indexOf(p,b=0){return s(this.buffer,p instanceof m?p.buffer:p,b)}}e.VSBuffer=m;function s(R,p,b=0){const N=p.byteLength,L=R.byteLength;if(N===0)return 0;if(N===1)return R.indexOf(p[0]);if(N>L-b)return-1;const F=O.value;F.fill(p.length);for(let x=0;x<p.length;x++)F[p[x]]=p.length-x-1;let K=b+p.length-1,J=K,$=-1;for(;K<L;)if(R[K]===p[J]){if(J===0){$=K;break}K--,J--}else K+=Math.max(p.length-J,F[R[K]]),J=p.length-1;return $}function I(R,p){return R[p+0]<<0>>>0|R[p+1]<<8>>>0}function E(R,p,b){R[b+0]=p&255,p=p>>>8,R[b+1]=p&255}function u(R,p){return R[p]*2**24+R[p+1]*2**16+R[p+2]*2**8+R[p+3]}function C(R,p,b){R[b+3]=p,p=p>>>8,R[b+2]=p,p=p>>>8,R[b+1]=p,p=p>>>8,R[b]=p}function v(R,p){return R[p+0]<<0>>>0|R[p+1]<<8>>>0|R[p+2]<<16>>>0|R[p+3]<<24>>>0}function r(R,p,b){R[b+0]=p&255,p=p>>>8,R[b+1]=p&255,p=p>>>8,R[b+2]=p&255,p=p>>>8,R[b+3]=p&255}function a(R,p){return R[p]}function d(R,p,b){R[b]=p}function l(R){return T.consumeReadable(R,p=>m.concat(p))}function i(R){return T.toReadable(R)}function n(R){return T.consumeStream(R,p=>m.concat(p))}async function t(R){return R.ended?m.concat(R.buffer):m.concat([...R.buffer,await n(R.stream)])}function o(R){return T.toStream(R,p=>m.concat(p))}function c(R){return T.transform(R,{data:p=>typeof p=="string"?m.fromString(p):m.wrap(p)},p=>m.concat(p))}function g(R){return T.newWriteableStream(p=>m.concat(p),R)}function f(R,p){return T.prefixedReadable(R,p,b=>m.concat(b))}function h(R,p){return T.prefixedStream(R,p,b=>m.concat(b))}function _(R){let p=0,b=0,N=0;const L=new Uint8Array(Math.floor(R.length/4*3)),F=J=>{switch(b){case 3:L[N++]=p|J,b=0;break;case 2:L[N++]=p|J>>>2,p=J<<6,b=3;break;case 1:L[N++]=p|J>>>4,p=J<<4,b=2;break;default:p=J<<2,b=1}};for(let J=0;J<R.length;J++){const $=R.charCodeAt(J);if($>=65&&$<=90)F($-65);else if($>=97&&$<=122)F($-97+26);else if($>=48&&$<=57)F($-48+52);else if($===43||$===45)F(62);else if($===47||$===95)F(63);else{if($===61)break;throw new SyntaxError(`Unexpected base64 character ${R[J]}`)}}const K=N;for(;b>0;)F(0);return m.wrap(L).slice(0,K)}const y="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",w="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function P({buffer:R},p=!0,b=!1){const N=b?w:y;let L="";const F=R.byteLength%3;let K=0;for(;K<R.byteLength-F;K+=3){const J=R[K+0],$=R[K+1],x=R[K+2];L+=N[J>>>2],L+=N[(J<<4|$>>>4)&63],L+=N[($<<2|x>>>6)&63],L+=N[x&63]}if(F===1){const J=R[K+0];L+=N[J>>>2],L+=N[J<<4&63],p&&(L+="==")}else if(F===2){const J=R[K+0],$=R[K+1];L+=N[J>>>2],L+=N[(J<<4|$>>>4)&63],L+=N[$<<2&63],p&&(L+="=")}return L}}),define(ke[36],Re([1,0,98]),function(Ee,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.ThemeColor=void 0,e.themeColorFromId=D;var T;(function(k){function A(m){return m&&typeof m=="object"&&typeof m.id=="string"}k.isThemeColor=A})(T||(e.ThemeColor=T={}));function D(k){return{id:k}}var O;(function(k){k.iconNameSegment="[A-Za-z0-9]+",k.iconNameExpression="[A-Za-z0-9-]+",k.iconModifierExpression="~[A-Za-z]+",k.iconNameCharacter="[A-Za-z0-9~-]";const A=new RegExp(`^(${k.iconNameExpression})(${k.iconModifierExpression})?$`);function m(l){const i=A.exec(l.id);if(!i)return m(S.Codicon.error);const[,n,t]=i,o=["codicon","codicon-"+n];return t&&o.push("codicon-modifier-"+t.substring(1)),o}k.asClassNameArray=m;function s(l){return m(l).join(" ")}k.asClassName=s;function I(l){return"."+m(l).join(".")}k.asCSSSelector=I;function E(l){return l&&typeof l=="object"&&typeof l.id=="string"&&(typeof l.color>"u"||T.isThemeColor(l.color))}k.isThemeIcon=E;const u=new RegExp(`^\\$\\((${k.iconNameExpression}(?:${k.iconModifierExpression})?)\\)$`);function C(l){const i=u.exec(l);if(!i)return;const[,n]=i;return{id:n}}k.fromString=C;function v(l){return{id:l}}k.fromId=v;function r(l,i){let n=l.id;const t=n.lastIndexOf("~");return t!==-1&&(n=n.substring(0,t)),i&&(n=`${n}~${i}`),{id:n}}k.modify=r;function a(l){const i=l.id.lastIndexOf("~");if(i!==-1)return l.id.substring(i+1)}k.getModifier=a;function d(l,i){return l.id===i.id&&l.color?.id===i.color?.id}k.isEqual=d})(O||(e.ThemeIcon=O={}))}),define(ke[149],Re([1,0,30,27,141,13]),function(Ee,e,S,T,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FuzzyScoreOptions=e.FuzzyScore=e.matchesPrefix=e.matchesStrictPrefix=void 0,e.or=k,e.matchesContiguousSubString=m,e.matchesSubString=s,e.isUpper=u,e.matchesCamelCase=y,e.matchesWords=w,e.matchesFuzzy=L,e.matchesFuzzy2=F,e.anyScore=K,e.createMatches=J,e.isPatternInWord=re,e.fuzzyScore=ze,e.fuzzyScoreGracefulAggressive=dt,e.fuzzyScoreGraceful=vt,O=Ve(O);function k(...Oe){return function(Me,Ne){for(let B=0,z=Oe.length;B<z;B++){const H=Oe[B](Me,Ne);if(H)return H}return null}}e.matchesStrictPrefix=A.bind(void 0,!1),e.matchesPrefix=A.bind(void 0,!0);function A(Oe,Me,Ne){if(!Ne||Ne.length<Me.length)return null;let B;return Oe?B=O.startsWithIgnoreCase(Ne,Me):B=Ne.indexOf(Me)===0,B?Me.length>0?[{start:0,end:Me.length}]:[]:null}function m(Oe,Me){const Ne=Me.toLowerCase().indexOf(Oe.toLowerCase());return Ne===-1?null:[{start:Ne,end:Ne+Oe.length}]}function s(Oe,Me){return I(Oe.toLowerCase(),Me.toLowerCase(),0,0)}function I(Oe,Me,Ne,B){if(Ne===Oe.length)return[];if(B===Me.length)return null;if(Oe[Ne]===Me[B]){let z=null;return(z=I(Oe,Me,Ne+1,B+1))?t({start:B,end:B+1},z):null}return I(Oe,Me,Ne,B+1)}function E(Oe){return S.CharCode.a<=Oe&&Oe<=S.CharCode.z}function u(Oe){return S.CharCode.A<=Oe&&Oe<=S.CharCode.Z}function C(Oe){return S.CharCode.Digit0<=Oe&&Oe<=S.CharCode.Digit9}function v(Oe){return Oe===S.CharCode.Space||Oe===S.CharCode.Tab||Oe===S.CharCode.LineFeed||Oe===S.CharCode.CarriageReturn}const r=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(Oe=>r.add(Oe.charCodeAt(0)));function a(Oe){return v(Oe)||r.has(Oe)}function d(Oe,Me){return Oe===Me||a(Oe)&&a(Me)}const l=new Map;function i(Oe){if(l.has(Oe))return l.get(Oe);let Me;const Ne=(0,D.getKoreanAltChars)(Oe);return Ne&&(Me=Ne),l.set(Oe,Me),Me}function n(Oe){return E(Oe)||u(Oe)||C(Oe)}function t(Oe,Me){return Me.length===0?Me=[Oe]:Oe.end===Me[0].start?Me[0].start=Oe.start:Me.unshift(Oe),Me}function o(Oe,Me){for(let Ne=Me;Ne<Oe.length;Ne++){const B=Oe.charCodeAt(Ne);if(u(B)||C(B)||Ne>0&&!n(Oe.charCodeAt(Ne-1)))return Ne}return Oe.length}function c(Oe,Me,Ne,B){if(Ne===Oe.length)return[];if(B===Me.length)return null;if(Oe[Ne]!==Me[B].toLowerCase())return null;{let z=null,H=B+1;for(z=c(Oe,Me,Ne+1,B+1);!z&&(H=o(Me,H))<Me.length;)z=c(Oe,Me,Ne+1,H),H++;return z===null?null:t({start:B,end:B+1},z)}}function g(Oe){let Me=0,Ne=0,B=0,z=0,H=0;for(let Ue=0;Ue<Oe.length;Ue++)H=Oe.charCodeAt(Ue),u(H)&&Me++,E(H)&&Ne++,n(H)&&B++,C(H)&&z++;const q=Me/Oe.length,se=Ne/Oe.length,ge=B/Oe.length,ye=z/Oe.length;return{upperPercent:q,lowerPercent:se,alphaPercent:ge,numericPercent:ye}}function f(Oe){const{upperPercent:Me,lowerPercent:Ne}=Oe;return Ne===0&&Me>.6}function h(Oe){const{upperPercent:Me,lowerPercent:Ne,alphaPercent:B,numericPercent:z}=Oe;return Ne>.2&&Me<.8&&B>.6&&z<.2}function _(Oe){let Me=0,Ne=0,B=0,z=0;for(let H=0;H<Oe.length;H++)B=Oe.charCodeAt(H),u(B)&&Me++,E(B)&&Ne++,v(B)&&z++;return(Me===0||Ne===0)&&z===0?Oe.length<=30:Me<=5}function y(Oe,Me){if(!Me||(Me=Me.trim(),Me.length===0)||!_(Oe))return null;Me.length>60&&(Me=Me.substring(0,60));const Ne=g(Me);if(!h(Ne)){if(!f(Ne))return null;Me=Me.toLowerCase()}let B=null,z=0;for(Oe=Oe.toLowerCase();z<Me.length&&(B=c(Oe,Me,0,z))===null;)z=o(Me,z+1);return B}function w(Oe,Me,Ne=!1){if(!Me||Me.length===0)return null;let B=null,z=0;for(Oe=Oe.toLowerCase(),Me=Me.toLowerCase();z<Me.length&&(B=P(Oe,Me,0,z,Ne),B===null);)z=R(Me,z+1);return B}function P(Oe,Me,Ne,B,z){let H=0;if(Ne===Oe.length)return[];if(B===Me.length)return null;if(!d(Oe.charCodeAt(Ne),Me.charCodeAt(B))){const ge=i(Oe.charCodeAt(Ne));if(!ge)return null;for(let ye=0;ye<ge.length;ye++)if(!d(ge[ye],Me.charCodeAt(B+ye)))return null;H+=ge.length-1}let q=null,se=B+H+1;if(q=P(Oe,Me,Ne+1,se,z),!z)for(;!q&&(se=R(Me,se))<Me.length;)q=P(Oe,Me,Ne+1,se,z),se++;if(!q)return null;if(Oe.charCodeAt(Ne)!==Me.charCodeAt(B)){const ge=i(Oe.charCodeAt(Ne));if(!ge)return q;for(let ye=0;ye<ge.length;ye++)if(ge[ye]!==Me.charCodeAt(B+ye))return q}return t({start:B,end:B+H+1},q)}function R(Oe,Me){for(let Ne=Me;Ne<Oe.length;Ne++)if(a(Oe.charCodeAt(Ne))||Ne>0&&a(Oe.charCodeAt(Ne-1)))return Ne;return Oe.length}const p=k(e.matchesPrefix,y,m),b=k(e.matchesPrefix,y,s),N=new T.LRUCache(1e4);function L(Oe,Me,Ne=!1){if(typeof Oe!="string"||typeof Me!="string")return null;let B=N.get(Oe);B||(B=new RegExp(O.convertSimple2RegExpPattern(Oe),"i"),N.set(Oe,B));const z=B.exec(Me);return z?[{start:z.index,end:z.index+z[0].length}]:Ne?b(Oe,Me):p(Oe,Me)}function F(Oe,Me){const Ne=ze(Oe,Oe.toLowerCase(),0,Me,Me.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return Ne?J(Ne):null}function K(Oe,Me,Ne,B,z,H){const q=Math.min(13,Oe.length);for(;Ne<q;Ne++){const se=ze(Oe,Me,Ne,B,z,H,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(se)return se}return[0,H]}function J(Oe){if(typeof Oe>"u")return[];const Me=[],Ne=Oe[1];for(let B=Oe.length-1;B>1;B--){const z=Oe[B]+Ne,H=Me[Me.length-1];H&&H.end===z?H.end=z+1:Me.push({start:z,end:z+1})}return Me}const $=128;function x(){const Oe=[],Me=[];for(let Ne=0;Ne<=$;Ne++)Me[Ne]=0;for(let Ne=0;Ne<=$;Ne++)Oe.push(Me.slice(0));return Oe}function G(Oe){const Me=[];for(let Ne=0;Ne<=Oe;Ne++)Me[Ne]=0;return Me}const Y=G(2*$),ae=G(2*$),ee=x(),oe=x(),ie=x(),ue=!1;function Z(Oe,Me,Ne,B,z){function H(se,ge,ye=" "){for(;se.length<ge;)se=ye+se;return se}let q=` |   |${B.split("").map(se=>H(se,3)).join("|")}
`;for(let se=0;se<=Ne;se++)se===0?q+=" |":q+=`${Me[se-1]}|`,q+=Oe[se].slice(0,z+1).map(ge=>H(ge.toString(),3)).join("|")+`
`;return q}function ve(Oe,Me,Ne,B){Oe=Oe.substr(Me),Ne=Ne.substr(B),console.log(Z(oe,Oe,Oe.length,Ne,Ne.length)),console.log(Z(ie,Oe,Oe.length,Ne,Ne.length)),console.log(Z(ee,Oe,Oe.length,Ne,Ne.length))}function Ie(Oe,Me){if(Me<0||Me>=Oe.length)return!1;const Ne=Oe.codePointAt(Me);switch(Ne){case S.CharCode.Underline:case S.CharCode.Dash:case S.CharCode.Period:case S.CharCode.Space:case S.CharCode.Slash:case S.CharCode.Backslash:case S.CharCode.SingleQuote:case S.CharCode.DoubleQuote:case S.CharCode.Colon:case S.CharCode.DollarSign:case S.CharCode.LessThan:case S.CharCode.GreaterThan:case S.CharCode.OpenParen:case S.CharCode.CloseParen:case S.CharCode.OpenSquareBracket:case S.CharCode.CloseSquareBracket:case S.CharCode.OpenCurlyBrace:case S.CharCode.CloseCurlyBrace:return!0;case void 0:return!1;default:return!!O.isEmojiImprecise(Ne)}}function X(Oe,Me){if(Me<0||Me>=Oe.length)return!1;switch(Oe.charCodeAt(Me)){case S.CharCode.Space:case S.CharCode.Tab:return!0;default:return!1}}function V(Oe,Me,Ne){return Me[Oe]!==Ne[Oe]}function re(Oe,Me,Ne,B,z,H,q=!1){for(;Me<Ne&&z<H;)Oe[Me]===B[z]&&(q&&(Y[Me]=z),Me+=1),z+=1;return Me===Ne}var be;(function(Oe){Oe[Oe.Diag=1]="Diag",Oe[Oe.Left=2]="Left",Oe[Oe.LeftLeft=3]="LeftLeft"})(be||(be={}));var De;(function(Oe){Oe.Default=[-100,0];function Me(Ne){return!Ne||Ne.length===2&&Ne[0]===-100&&Ne[1]===0}Oe.isDefault=Me})(De||(e.FuzzyScore=De={}));class Fe{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(Me,Ne){this.firstMatchCanBeWeak=Me,this.boostFullMatch=Ne}}e.FuzzyScoreOptions=Fe;function ze(Oe,Me,Ne,B,z,H,q=Fe.default){const se=Oe.length>$?$:Oe.length,ge=B.length>$?$:B.length;if(Ne>=se||H>=ge||se-Ne>ge-H||!re(Me,Ne,se,z,H,ge,!0))return;Je(se,ge,Ne,H,Me,z);let ye=1,Ue=1,Ge=Ne,Ze=H;const tt=[!1];for(ye=1,Ge=Ne;Ge<se;ye++,Ge++){const Qe=Y[Ge],de=ae[Ge],pe=Ge+1<se?ae[Ge+1]:ge;for(Ue=Qe-H+1,Ze=Qe;Ze<pe;Ue++,Ze++){let we=Number.MIN_SAFE_INTEGER,Pe=!1;Ze<=de&&(we=nt(Oe,Me,Ge,Ne,B,z,Ze,ge,H,ee[ye-1][Ue-1]===0,tt));let fe=0;we!==Number.MAX_SAFE_INTEGER&&(Pe=!0,fe=we+oe[ye-1][Ue-1]);const Se=Ze>Qe,Q=Se?oe[ye][Ue-1]+(ee[ye][Ue-1]>0?-5:0):0,W=Ze>Qe+1&&ee[ye][Ue-1]>0,he=W?oe[ye][Ue-2]+(ee[ye][Ue-2]>0?-5:0):0;if(W&&(!Se||he>=Q)&&(!Pe||he>=fe))oe[ye][Ue]=he,ie[ye][Ue]=be.LeftLeft,ee[ye][Ue]=0;else if(Se&&(!Pe||Q>=fe))oe[ye][Ue]=Q,ie[ye][Ue]=be.Left,ee[ye][Ue]=0;else if(Pe)oe[ye][Ue]=fe,ie[ye][Ue]=be.Diag,ee[ye][Ue]=ee[ye-1][Ue-1]+1;else throw new Error("not possible")}}if(ue&&ve(Oe,Ne,B,H),!tt[0]&&!q.firstMatchCanBeWeak)return;ye--,Ue--;const lt=[oe[ye][Ue],H];let it=0,at=0;for(;ye>=1;){let Qe=Ue;do{const de=ie[ye][Qe];if(de===be.LeftLeft)Qe=Qe-2;else if(de===be.Left)Qe=Qe-1;else break}while(Qe>=1);it>1&&Me[Ne+ye-1]===z[H+Ue-1]&&!V(Qe+H-1,B,z)&&it+1>ee[ye][Qe]&&(Qe=Ue),Qe===Ue?it++:it=1,at||(at=Qe),ye--,Ue=Qe-1,lt.push(Ue)}ge-H===se&&q.boostFullMatch&&(lt[0]+=2);const wt=at-se;return lt[0]-=wt,lt}function Je(Oe,Me,Ne,B,z,H){let q=Oe-1,se=Me-1;for(;q>=Ne&&se>=B;)z[q]===H[se]&&(ae[q]=se,q--),se--}function nt(Oe,Me,Ne,B,z,H,q,se,ge,ye,Ue){if(Me[Ne]!==H[q])return Number.MIN_SAFE_INTEGER;let Ge=1,Ze=!1;return q===Ne-B?Ge=Oe[Ne]===z[q]?7:5:V(q,z,H)&&(q===0||!V(q-1,z,H))?(Ge=Oe[Ne]===z[q]?7:5,Ze=!0):Ie(H,q)&&(q===0||!Ie(H,q-1))?Ge=5:(Ie(H,q-1)||X(H,q-1))&&(Ge=5,Ze=!0),Ge>1&&Ne===B&&(Ue[0]=!0),Ze||(Ze=V(q,z,H)||Ie(H,q-1)||X(H,q-1)),Ne===B?q>ge&&(Ge-=Ze?3:5):ye?Ge+=Ze?2:0:Ge+=Ze?0:1,q+1===se&&(Ge-=Ze?3:5),Ge}function dt(Oe,Me,Ne,B,z,H,q){return ut(Oe,Me,Ne,B,z,H,!0,q)}function vt(Oe,Me,Ne,B,z,H,q){return ut(Oe,Me,Ne,B,z,H,!1,q)}function ut(Oe,Me,Ne,B,z,H,q,se){let ge=ze(Oe,Me,Ne,B,z,H,se);if(ge&&!q)return ge;if(Oe.length>=3){const ye=Math.min(7,Oe.length-1);for(let Ue=Ne+1;Ue<ye;Ue++){const Ge=et(Oe,Ue);if(Ge){const Ze=ze(Ge,Ge.toLowerCase(),Ne,B,z,H,se);Ze&&(Ze[0]-=3,(!ge||Ze[0]>ge[0])&&(ge=Ze))}}}return ge}function et(Oe,Me){if(Me+1>=Oe.length)return;const Ne=Oe[Me],B=Oe[Me+1];if(Ne!==B)return Oe.slice(0,Me)+B+Ne+Oe.slice(Me+2)}}),define(ke[99],Re([1,0,149,13,36]),function(Ee,e,S,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.escapeIcons=m,e.markdownEscapeEscapedIcons=I,e.stripIcons=u,e.getCodiconAriaLabel=C,e.parseLabelWithIcons=r,e.matchesFuzzyIconAware=a;const O="$(",k=new RegExp(`\\$\\(${D.ThemeIcon.iconNameExpression}(?:${D.ThemeIcon.iconModifierExpression})?\\)`,"g"),A=new RegExp(`(\\\\)?${k.source}`,"g");function m(d){return d.replace(A,(l,i)=>i?l:`\\${l}`)}const s=new RegExp(`\\\\${k.source}`,"g");function I(d){return d.replace(s,l=>`\\${l}`)}const E=new RegExp(`(\\s)?(\\\\)?${k.source}(\\s)?`,"g");function u(d){return d.indexOf(O)===-1?d:d.replace(E,(l,i,n,t)=>n?l:i||t||"")}function C(d){return d?d.replace(/\$\((.*?)\)/g,(l,i)=>` ${i} `).trim():""}const v=new RegExp(`\\$\\(${D.ThemeIcon.iconNameCharacter}+\\)`,"g");function r(d){v.lastIndex=0;let l="";const i=[];let n=0;for(;;){const t=v.lastIndex,o=v.exec(d),c=d.substring(t,o?.index);if(c.length>0){l+=c;for(let g=0;g<c.length;g++)i.push(n)}if(!o)break;n+=o[0].length}return{text:l,iconOffsets:i}}function a(d,l,i=!1){const{text:n,iconOffsets:t}=l;if(!t||t.length===0)return(0,S.matchesFuzzy)(d,n,i);const o=(0,T.ltrim)(n," "),c=n.length-o.length,g=(0,S.matchesFuzzy)(d,o,i);if(g)for(const f of g){const h=t[f.start+c]+c;f.start+=h,f.end+=h}return g}}),define(ke[37],Re([1,0,13]),function(Ee,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),S=Ve(S);var T;(function(D){D[D.Ignore=0]="Ignore",D[D.Info=1]="Info",D[D.Warning=2]="Warning",D[D.Error=3]="Error"})(T||(T={})),function(D){const O="error",k="warning",A="warn",m="info",s="ignore";function I(u){return u?S.equalsIgnoreCase(O,u)?D.Error:S.equalsIgnoreCase(k,u)||S.equalsIgnoreCase(A,u)?D.Warning:S.equalsIgnoreCase(m,u)?D.Info:D.Ignore:D.Ignore}D.fromValue=I;function E(u){switch(u){case D.Error:return O;case D.Warning:return k;case D.Info:return m;default:return s}}D.toString=E}(T||(T={})),e.default=T}),define(ke[48],Re([1,0,17,30,13]),function(Ee,e,S,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class O{constructor(){this._value="",this._pos=0}reset(v){return this._value=v,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(v){const r=v.charCodeAt(0),a=this._value.charCodeAt(this._pos);return r-a}value(){return this._value[this._pos]}}e.StringIterator=O;class k{constructor(v=!0){this._caseSensitive=v}reset(v){return this._value=v,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let v=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===T.CharCode.Period)if(v)this._from++;else break;else v=!1;return this}cmp(v){return this._caseSensitive?(0,D.compareSubstring)(v,this._value,0,v.length,this._from,this._to):(0,D.compareSubstringIgnoreCase)(v,this._value,0,v.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=k;class A{constructor(v=!0,r=!0){this._splitOnBackslash=v,this._caseSensitive=r}reset(v){this._from=0,this._to=0,this._value=v,this._valueLen=v.length;for(let r=v.length-1;r>=0;r--,this._valueLen--){const a=this._value.charCodeAt(r);if(!(a===T.CharCode.Slash||this._splitOnBackslash&&a===T.CharCode.Backslash))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let v=!0;for(;this._to<this._valueLen;this._to++){const r=this._value.charCodeAt(this._to);if(r===T.CharCode.Slash||this._splitOnBackslash&&r===T.CharCode.Backslash)if(v)this._from++;else break;else v=!1}return this}cmp(v){return this._caseSensitive?(0,D.compareSubstring)(v,this._value,0,v.length,this._from,this._to):(0,D.compareSubstringIgnoreCase)(v,this._value,0,v.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=A;var m;(function(C){C[C.Scheme=1]="Scheme",C[C.Authority=2]="Authority",C[C.Path=3]="Path",C[C.Query=4]="Query",C[C.Fragment=5]="Fragment"})(m||(m={}));class s{constructor(v,r){this._ignorePathCasing=v,this._ignoreQueryAndFragment=r,this._states=[],this._stateIdx=0}reset(v){return this._value=v,this._states=[],this._value.scheme&&this._states.push(m.Scheme),this._value.authority&&this._states.push(m.Authority),this._value.path&&(this._pathIterator=new A(!1,!this._ignorePathCasing(v)),this._pathIterator.reset(v.path),this._pathIterator.value()&&this._states.push(m.Path)),this._ignoreQueryAndFragment(v)||(this._value.query&&this._states.push(m.Query),this._value.fragment&&this._states.push(m.Fragment)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===m.Path&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===m.Path&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(v){if(this._states[this._stateIdx]===m.Scheme)return(0,D.compareIgnoreCase)(v,this._value.scheme);if(this._states[this._stateIdx]===m.Authority)return(0,D.compareIgnoreCase)(v,this._value.authority);if(this._states[this._stateIdx]===m.Path)return this._pathIterator.cmp(v);if(this._states[this._stateIdx]===m.Query)return(0,D.compare)(v,this._value.query);if(this._states[this._stateIdx]===m.Fragment)return(0,D.compare)(v,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===m.Scheme)return this._value.scheme;if(this._states[this._stateIdx]===m.Authority)return this._value.authority;if(this._states[this._stateIdx]===m.Path)return this._pathIterator.value();if(this._states[this._stateIdx]===m.Query)return this._value.query;if(this._states[this._stateIdx]===m.Fragment)return this._value.fragment;throw new Error}}e.UriIterator=s;class I{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const v=this.right;return this.right=v.left,v.left=this,this.updateHeight(),v.updateHeight(),v}rotateRight(){const v=this.left;return this.left=v.right,v.right=this,this.updateHeight(),v.updateHeight(),v}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var E;(function(C){C[C.Left=-1]="Left",C[C.Mid=0]="Mid",C[C.Right=1]="Right"})(E||(E={}));class u{static forUris(v=()=>!1,r=()=>!1){return new u(new s(v,r))}static forPaths(v=!1){return new u(new A(void 0,!v))}static forStrings(){return new u(new O)}static forConfigKeys(){return new u(new k)}constructor(v){this._iter=v}clear(){this._root=void 0}fill(v,r){if(r){const a=r.slice(0);(0,S.shuffle)(a);for(const d of a)this.set(d,v)}else{const a=v.slice(0);(0,S.shuffle)(a);for(const d of a)this.set(d[0],d[1])}}set(v,r){const a=this._iter.reset(v);let d;this._root||(this._root=new I,this._root.segment=a.value());const l=[];for(d=this._root;;){const n=a.cmp(d.segment);if(n>0)d.left||(d.left=new I,d.left.segment=a.value()),l.push([E.Left,d]),d=d.left;else if(n<0)d.right||(d.right=new I,d.right.segment=a.value()),l.push([E.Right,d]),d=d.right;else if(a.hasNext())a.next(),d.mid||(d.mid=new I,d.mid.segment=a.value()),l.push([E.Mid,d]),d=d.mid;else break}const i=d.value;d.value=r,d.key=v;for(let n=l.length-1;n>=0;n--){const t=l[n][1];t.updateHeight();const o=t.balanceFactor();if(o<-1||o>1){const c=l[n][0],g=l[n+1][0];if(c===E.Right&&g===E.Right)l[n][1]=t.rotateLeft();else if(c===E.Left&&g===E.Left)l[n][1]=t.rotateRight();else if(c===E.Right&&g===E.Left)t.right=l[n+1][1]=l[n+1][1].rotateRight(),l[n][1]=t.rotateLeft();else if(c===E.Left&&g===E.Right)t.left=l[n+1][1]=l[n+1][1].rotateLeft(),l[n][1]=t.rotateRight();else throw new Error;if(n>0)switch(l[n-1][0]){case E.Left:l[n-1][1].left=l[n][1];break;case E.Right:l[n-1][1].right=l[n][1];break;case E.Mid:l[n-1][1].mid=l[n][1];break}else this._root=l[0][1]}}return i}get(v){return this._getNode(v)?.value}_getNode(v){const r=this._iter.reset(v);let a=this._root;for(;a;){const d=r.cmp(a.segment);if(d>0)a=a.left;else if(d<0)a=a.right;else if(r.hasNext())r.next(),a=a.mid;else break}return a}has(v){const r=this._getNode(v);return!(r?.value===void 0&&r?.mid===void 0)}delete(v){return this._delete(v,!1)}deleteSuperstr(v){return this._delete(v,!0)}_delete(v,r){const a=this._iter.reset(v),d=[];let l=this._root;for(;l;){const i=a.cmp(l.segment);if(i>0)d.push([E.Left,l]),l=l.left;else if(i<0)d.push([E.Right,l]),l=l.right;else if(a.hasNext())a.next(),d.push([E.Mid,l]),l=l.mid;else break}if(l){if(r?(l.left=void 0,l.mid=void 0,l.right=void 0,l.height=1):(l.key=void 0,l.value=void 0),!l.mid&&!l.value)if(l.left&&l.right){const i=this._min(l.right);if(i.key){const{key:n,value:t,segment:o}=i;this._delete(i.key,!1),l.key=n,l.value=t,l.segment=o}}else{const i=l.left??l.right;if(d.length>0){const[n,t]=d[d.length-1];switch(n){case E.Left:t.left=i;break;case E.Mid:t.mid=i;break;case E.Right:t.right=i;break}}else this._root=i}for(let i=d.length-1;i>=0;i--){const n=d[i][1];n.updateHeight();const t=n.balanceFactor();if(t>1?(n.right.balanceFactor()>=0||(n.right=n.right.rotateRight()),d[i][1]=n.rotateLeft()):t<-1&&(n.left.balanceFactor()<=0||(n.left=n.left.rotateLeft()),d[i][1]=n.rotateRight()),i>0)switch(d[i-1][0]){case E.Left:d[i-1][1].left=d[i][1];break;case E.Right:d[i-1][1].right=d[i][1];break;case E.Mid:d[i-1][1].mid=d[i][1];break}else this._root=d[0][1]}}}_min(v){for(;v.left;)v=v.left;return v}findSubstr(v){const r=this._iter.reset(v);let a=this._root,d;for(;a;){const l=r.cmp(a.segment);if(l>0)a=a.left;else if(l<0)a=a.right;else if(r.hasNext())r.next(),d=a.value||d,a=a.mid;else break}return a&&a.value||d}findSuperstr(v){return this._findSuperstrOrElement(v,!1)}_findSuperstrOrElement(v,r){const a=this._iter.reset(v);let d=this._root;for(;d;){const l=a.cmp(d.segment);if(l>0)d=d.left;else if(l<0)d=d.right;else if(a.hasNext())a.next(),d=d.mid;else return d.mid?this._entries(d.mid):r?d.value:void 0}}hasElementOrSubtree(v){return this._findSuperstrOrElement(v,!0)!==void 0}forEach(v){for(const[r,a]of this)v(a,r)}*[Symbol.iterator](){yield*this._entries(this._root)}_entries(v){const r=[];return this._dfsEntries(v,r),r[Symbol.iterator]()}_dfsEntries(v,r){v&&(v.left&&this._dfsEntries(v.left,r),v.value&&r.push([v.key,v.value]),v.mid&&this._dfsEntries(v.mid,r),v.right&&this._dfsEntries(v.right,r))}_isBalanced(){const v=r=>{if(!r)return!0;const a=r.balanceFactor();return a<-1||a>1?!1:v(r.left)&&v(r.right)};return v(this._root)}}e.TernarySearchTree=u}),define(ke[33],Re([1,0]),function(Ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=void 0,e.isUUID=T;const S=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function T(D){return S.test(D)}e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let D;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?D=crypto.getRandomValues.bind(crypto):D=function(A){for(let m=0;m<A.length;m++)A[m]=Math.floor(Math.random()*256);return A};const O=new Uint8Array(16),k=[];for(let A=0;A<256;A++)k.push(A.toString(16).padStart(2,"0"));return function(){D(O),O[6]=O[6]&15|64,O[8]=O[8]&63|128;let m=0,s="";return s+=k[O[m++]],s+=k[O[m++]],s+=k[O[m++]],s+=k[O[m++]],s+="-",s+=k[O[m++]],s+=k[O[m++]],s+="-",s+=k[O[m++]],s+=k[O[m++]],s+="-",s+=k[O[m++]],s+=k[O[m++]],s+="-",s+=k[O[m++]],s+=k[O[m++]],s+=k[O[m++]],s+=k[O[m++]],s+=k[O[m++]],s+=k[O[m++]],s}}()}),define(ke[150],Re([1,0,17,41,33]),function(Ee,e,S,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriList=e.VSDataTransfer=void 0,e.createStringDataTransferItem=O,e.createFileDataTransferItem=k,e.matchesMimeType=s;function O(E){return{asString:async()=>E,asFile:()=>{},value:typeof E=="string"?E:void 0}}function k(E,u,C){const v={id:(0,D.generateUuid)(),name:E,uri:u,data:C};return{asString:async()=>"",asFile:()=>v,value:void 0}}class A{constructor(){this._entries=new Map}get size(){let u=0;for(const C of this._entries)u++;return u}has(u){return this._entries.has(this.toKey(u))}matches(u){const C=[...this._entries.keys()];return T.Iterable.some(this,([v,r])=>r.asFile())&&C.push("files"),I(m(u),C)}get(u){return this._entries.get(this.toKey(u))?.[0]}append(u,C){const v=this._entries.get(u);v?v.push(C):this._entries.set(this.toKey(u),[C])}replace(u,C){this._entries.set(this.toKey(u),[C])}delete(u){this._entries.delete(this.toKey(u))}*[Symbol.iterator](){for(const[u,C]of this._entries)for(const v of C)yield[u,v]}toKey(u){return m(u)}}e.VSDataTransfer=A;function m(E){return E.toLowerCase()}function s(E,u){return I(m(E),u.map(m))}function I(E,u){if(E==="*/*")return u.length>0;if(u.includes(E))return!0;const C=E.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!C)return!1;const[v,r,a]=C;return a==="*"?u.some(d=>d.startsWith(r+"/")):!1}e.UriList=Object.freeze({create:E=>(0,S.distinct)(E.map(u=>u.toString())).join(`\r
`),split:E=>E.split(`\r
`),parse:E=>e.UriList.split(E).filter(u=>!u.startsWith("#"))})}),define(ke[151],Re([1,0,30]),function(Ee,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringEOL=void 0,e.countEOL=D;var T;(function(O){O[O.Unknown=0]="Unknown",O[O.Invalid=3]="Invalid",O[O.LF=1]="LF",O[O.CRLF=2]="CRLF"})(T||(e.StringEOL=T={}));function D(O){let k=0,A=0,m=0,s=T.Unknown;for(let I=0,E=O.length;I<E;I++){const u=O.charCodeAt(I);u===S.CharCode.CarriageReturn?(k===0&&(A=I),k++,I+1<E&&O.charCodeAt(I+1)===S.CharCode.LineFeed?(s|=T.CRLF,I++):s|=T.Invalid,m=I+1):u===S.CharCode.LineFeed&&(s|=T.LF,k===0&&(A=I),k++,m=I+1)}return k===0&&(A=O.length),[k,A,O.length-m,s]}}),define(ke[152],Re([1,0]),function(Ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EDITOR_MODEL_DEFAULTS=void 0,e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(ke[153],Re([1,0,30,154]),function(Ee,e,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var D;(function(m){m[m.None=0]="None",m[m.Indent=1]="Indent",m[m.IndentOutdent=2]="IndentOutdent",m[m.Outdent=3]="Outdent"})(D||(e.IndentAction=D={}));class O{constructor(s){if(this._neutralCharacter=null,this._neutralCharacterSearched=!1,this.open=s.open,this.close=s.close,this._inString=!0,this._inComment=!0,this._inRegEx=!0,Array.isArray(s.notIn))for(let I=0,E=s.notIn.length;I<E;I++)switch(s.notIn[I]){case"string":this._inString=!1;break;case"comment":this._inComment=!1;break;case"regex":this._inRegEx=!1;break}}isOK(s){switch(s){case T.StandardTokenType.Other:return!0;case T.StandardTokenType.Comment:return this._inComment;case T.StandardTokenType.String:return this._inString;case T.StandardTokenType.RegEx:return this._inRegEx}}shouldAutoClose(s,I){if(s.getTokenCount()===0)return!0;const E=s.findTokenIndexAtOffset(I-2),u=s.getStandardTokenType(E);return this.isOK(u)}_findNeutralCharacterInRange(s,I){for(let E=s;E<=I;E++){const u=String.fromCharCode(E);if(!this.open.includes(u)&&!this.close.includes(u))return u}return null}findNeutralCharacter(){return this._neutralCharacterSearched||(this._neutralCharacterSearched=!0,this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(S.CharCode.Digit0,S.CharCode.Digit9)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(S.CharCode.a,S.CharCode.z)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(S.CharCode.A,S.CharCode.Z))),this._neutralCharacter}}e.StandardAutoClosingPairConditional=O;class k{constructor(s){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const I of s)A(this.autoClosingPairsOpenByStart,I.open.charAt(0),I),A(this.autoClosingPairsOpenByEnd,I.open.charAt(I.open.length-1),I),A(this.autoClosingPairsCloseByStart,I.close.charAt(0),I),A(this.autoClosingPairsCloseByEnd,I.close.charAt(I.close.length-1),I),I.close.length===1&&I.open.length===1&&A(this.autoClosingPairsCloseSingleChar,I.close,I)}}e.AutoClosingPairs=k;function A(m,s,I){m.has(s)?m.get(s).push(I):m.set(s,[I])}}),define(ke[155],Re([1,0]),function(Ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SENTINEL=e.NodeColor=e.TreeNode=void 0,e.leftest=D,e.righttest=O,e.leftRotate=s,e.rightRotate=I,e.rbDelete=E,e.fixInsert=u,e.updateTreeMetadata=C,e.recomputeTreeMetadata=v;class S{constructor(a,d){this.piece=a,this.color=d,this.size_left=0,this.lf_left=0,this.parent=this,this.left=this,this.right=this}next(){if(this.right!==e.SENTINEL)return D(this.right);let a=this;for(;a.parent!==e.SENTINEL&&a.parent.left!==a;)a=a.parent;return a.parent===e.SENTINEL?e.SENTINEL:a.parent}prev(){if(this.left!==e.SENTINEL)return O(this.left);let a=this;for(;a.parent!==e.SENTINEL&&a.parent.right!==a;)a=a.parent;return a.parent===e.SENTINEL?e.SENTINEL:a.parent}detach(){this.parent=null,this.left=null,this.right=null}}e.TreeNode=S;var T;(function(r){r[r.Black=0]="Black",r[r.Red=1]="Red"})(T||(e.NodeColor=T={})),e.SENTINEL=new S(null,T.Black),e.SENTINEL.parent=e.SENTINEL,e.SENTINEL.left=e.SENTINEL,e.SENTINEL.right=e.SENTINEL,e.SENTINEL.color=T.Black;function D(r){for(;r.left!==e.SENTINEL;)r=r.left;return r}function O(r){for(;r.right!==e.SENTINEL;)r=r.right;return r}function k(r){return r===e.SENTINEL?0:r.size_left+r.piece.length+k(r.right)}function A(r){return r===e.SENTINEL?0:r.lf_left+r.piece.lineFeedCnt+A(r.right)}function m(){e.SENTINEL.parent=e.SENTINEL}function s(r,a){const d=a.right;d.size_left+=a.size_left+(a.piece?a.piece.length:0),d.lf_left+=a.lf_left+(a.piece?a.piece.lineFeedCnt:0),a.right=d.left,d.left!==e.SENTINEL&&(d.left.parent=a),d.parent=a.parent,a.parent===e.SENTINEL?r.root=d:a.parent.left===a?a.parent.left=d:a.parent.right=d,d.left=a,a.parent=d}function I(r,a){const d=a.left;a.left=d.right,d.right!==e.SENTINEL&&(d.right.parent=a),d.parent=a.parent,a.size_left-=d.size_left+(d.piece?d.piece.length:0),a.lf_left-=d.lf_left+(d.piece?d.piece.lineFeedCnt:0),a.parent===e.SENTINEL?r.root=d:a===a.parent.right?a.parent.right=d:a.parent.left=d,d.right=a,a.parent=d}function E(r,a){let d,l;if(a.left===e.SENTINEL?(l=a,d=l.right):a.right===e.SENTINEL?(l=a,d=l.left):(l=D(a.right),d=l.right),l===r.root){r.root=d,d.color=T.Black,a.detach(),m(),r.root.parent=e.SENTINEL;return}const i=l.color===T.Red;if(l===l.parent.left?l.parent.left=d:l.parent.right=d,l===a?(d.parent=l.parent,v(r,d)):(l.parent===a?d.parent=l:d.parent=l.parent,v(r,d),l.left=a.left,l.right=a.right,l.parent=a.parent,l.color=a.color,a===r.root?r.root=l:a===a.parent.left?a.parent.left=l:a.parent.right=l,l.left!==e.SENTINEL&&(l.left.parent=l),l.right!==e.SENTINEL&&(l.right.parent=l),l.size_left=a.size_left,l.lf_left=a.lf_left,v(r,l)),a.detach(),d.parent.left===d){const t=k(d),o=A(d);if(t!==d.parent.size_left||o!==d.parent.lf_left){const c=t-d.parent.size_left,g=o-d.parent.lf_left;d.parent.size_left=t,d.parent.lf_left=o,C(r,d.parent,c,g)}}if(v(r,d.parent),i){m();return}let n;for(;d!==r.root&&d.color===T.Black;)d===d.parent.left?(n=d.parent.right,n.color===T.Red&&(n.color=T.Black,d.parent.color=T.Red,s(r,d.parent),n=d.parent.right),n.left.color===T.Black&&n.right.color===T.Black?(n.color=T.Red,d=d.parent):(n.right.color===T.Black&&(n.left.color=T.Black,n.color=T.Red,I(r,n),n=d.parent.right),n.color=d.parent.color,d.parent.color=T.Black,n.right.color=T.Black,s(r,d.parent),d=r.root)):(n=d.parent.left,n.color===T.Red&&(n.color=T.Black,d.parent.color=T.Red,I(r,d.parent),n=d.parent.left),n.left.color===T.Black&&n.right.color===T.Black?(n.color=T.Red,d=d.parent):(n.left.color===T.Black&&(n.right.color=T.Black,n.color=T.Red,s(r,n),n=d.parent.left),n.color=d.parent.color,d.parent.color=T.Black,n.left.color=T.Black,I(r,d.parent),d=r.root));d.color=T.Black,m()}function u(r,a){for(v(r,a);a!==r.root&&a.parent.color===T.Red;)if(a.parent===a.parent.parent.left){const d=a.parent.parent.right;d.color===T.Red?(a.parent.color=T.Black,d.color=T.Black,a.parent.parent.color=T.Red,a=a.parent.parent):(a===a.parent.right&&(a=a.parent,s(r,a)),a.parent.color=T.Black,a.parent.parent.color=T.Red,I(r,a.parent.parent))}else{const d=a.parent.parent.left;d.color===T.Red?(a.parent.color=T.Black,d.color=T.Black,a.parent.parent.color=T.Red,a=a.parent.parent):(a===a.parent.left&&(a=a.parent,I(r,a)),a.parent.color=T.Black,a.parent.parent.color=T.Red,s(r,a.parent.parent))}r.root.color=T.Black}function C(r,a,d,l){for(;a!==r.root&&a!==e.SENTINEL;)a.parent.left===a&&(a.parent.size_left+=d,a.parent.lf_left+=l),a=a.parent}function v(r,a){let d=0,l=0;if(a!==r.root){for(;a!==r.root&&a===a.parent.right;)a=a.parent;if(a!==r.root)for(a=a.parent,d=k(a.left)-a.size_left,l=A(a.left)-a.lf_left,a.size_left+=d,a.lf_left+=l;a!==r.root&&(d!==0||l!==0);)a.parent.left===a&&(a.parent.size_left+=d,a.parent.lf_left+=l),a=a.parent}}}),define(ke[100],Re([1,0,30,101,32,52,155,102]),function(Ee,e,S,T,D,O,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PieceTreeBase=e.StringBuffer=e.Piece=void 0,e.createLineStartsFast=E,e.createLineStarts=u;const m=65535;function s(l){let i;return l[l.length-1]<65536?i=new Uint16Array(l.length):i=new Uint32Array(l.length),i.set(l,0),i}class I{constructor(i,n,t,o,c){this.lineStarts=i,this.cr=n,this.lf=t,this.crlf=o,this.isBasicASCII=c}}function E(l,i=!0){const n=[0];let t=1;for(let o=0,c=l.length;o<c;o++){const g=l.charCodeAt(o);g===S.CharCode.CarriageReturn?o+1<c&&l.charCodeAt(o+1)===S.CharCode.LineFeed?(n[t++]=o+2,o++):n[t++]=o+1:g===S.CharCode.LineFeed&&(n[t++]=o+1)}return i?s(n):n}function u(l,i){l.length=0,l[0]=0;let n=1,t=0,o=0,c=0,g=!0;for(let h=0,_=i.length;h<_;h++){const y=i.charCodeAt(h);y===S.CharCode.CarriageReturn?h+1<_&&i.charCodeAt(h+1)===S.CharCode.LineFeed?(c++,l[n++]=h+2,h++):(t++,l[n++]=h+1):y===S.CharCode.LineFeed?(o++,l[n++]=h+1):g&&y!==S.CharCode.Tab&&(y<32||y>126)&&(g=!1)}const f=new I(s(l),t,o,c,g);return l.length=0,f}class C{constructor(i,n,t,o,c){this.bufferIndex=i,this.start=n,this.end=t,this.lineFeedCnt=o,this.length=c}}e.Piece=C;class v{constructor(i,n){this.buffer=i,this.lineStarts=n}}e.StringBuffer=v;class r{constructor(i,n){this._pieces=[],this._tree=i,this._BOM=n,this._index=0,i.root!==k.SENTINEL&&i.iterate(i.root,t=>(t!==k.SENTINEL&&this._pieces.push(t.piece),!0))}read(){return this._pieces.length===0?this._index===0?(this._index++,this._BOM):null:this._index>this._pieces.length-1?null:this._index===0?this._BOM+this._tree.getPieceContent(this._pieces[this._index++]):this._tree.getPieceContent(this._pieces[this._index++])}}class a{constructor(i){this._limit=i,this._cache=[]}get(i){for(let n=this._cache.length-1;n>=0;n--){const t=this._cache[n];if(t.nodeStartOffset<=i&&t.nodeStartOffset+t.node.piece.length>=i)return t}return null}get2(i){for(let n=this._cache.length-1;n>=0;n--){const t=this._cache[n];if(t.nodeStartLineNumber&&t.nodeStartLineNumber<i&&t.nodeStartLineNumber+t.node.piece.lineFeedCnt>=i)return t}return null}set(i){this._cache.length>=this._limit&&this._cache.shift(),this._cache.push(i)}validate(i){let n=!1;const t=this._cache;for(let o=0;o<t.length;o++){const c=t[o];if(c.node.parent===null||c.nodeStartOffset>=i){t[o]=null,n=!0;continue}}if(n){const o=[];for(const c of t)c!==null&&o.push(c);this._cache=o}}}class d{constructor(i,n,t){this.create(i,n,t)}create(i,n,t){this._buffers=[new v("",[0])],this._lastChangeBufferPos={line:0,column:0},this.root=k.SENTINEL,this._lineCnt=1,this._length=0,this._EOL=n,this._EOLLength=n.length,this._EOLNormalized=t;let o=null;for(let c=0,g=i.length;c<g;c++)if(i[c].buffer.length>0){i[c].lineStarts||(i[c].lineStarts=E(i[c].buffer));const f=new C(c+1,{line:0,column:0},{line:i[c].lineStarts.length-1,column:i[c].buffer.length-i[c].lineStarts[i[c].lineStarts.length-1]},i[c].lineStarts.length-1,i[c].buffer.length);this._buffers.push(i[c]),o=this.rbInsertRight(o,f)}this._searchCache=new a(1),this._lastVisitedLine={lineNumber:0,value:""},this.computeBufferMetadata()}normalizeEOL(i){const n=m,t=n-Math.floor(n/3),o=t*2;let c="",g=0;const f=[];if(this.iterate(this.root,h=>{const _=this.getNodeContent(h),y=_.length;if(g<=t||g+y<o)return c+=_,g+=y,!0;const w=c.replace(/\r\n|\r|\n/g,i);return f.push(new v(w,E(w))),c=_,g=y,!0}),g>0){const h=c.replace(/\r\n|\r|\n/g,i);f.push(new v(h,E(h)))}this.create(f,i,!0)}getEOL(){return this._EOL}setEOL(i){this._EOL=i,this._EOLLength=this._EOL.length,this.normalizeEOL(i)}createSnapshot(i){return new r(this,i)}equal(i){if(this.getLength()!==i.getLength()||this.getLineCount()!==i.getLineCount())return!1;let n=0;return this.iterate(this.root,o=>{if(o===k.SENTINEL)return!0;const c=this.getNodeContent(o),g=c.length,f=i.nodeAt(n),h=i.nodeAt(n+g),_=i.getValueInRange2(f,h);return n+=g,c===_})}getOffsetAt(i,n){let t=0,o=this.root;for(;o!==k.SENTINEL;)if(o.left!==k.SENTINEL&&o.lf_left+1>=i)o=o.left;else if(o.lf_left+o.piece.lineFeedCnt+1>=i){t+=o.size_left;const c=this.getAccumulatedValue(o,i-o.lf_left-2);return t+=c+n-1}else i-=o.lf_left+o.piece.lineFeedCnt,t+=o.size_left+o.piece.length,o=o.right;return t}getPositionAt(i){i=Math.floor(i),i=Math.max(0,i);let n=this.root,t=0;const o=i;for(;n!==k.SENTINEL;)if(n.size_left!==0&&n.size_left>=i)n=n.left;else if(n.size_left+n.piece.length>=i){const c=this.getIndexOf(n,i-n.size_left);if(t+=n.lf_left+c.index,c.index===0){const g=this.getOffsetAt(t+1,1),f=o-g;return new T.Position(t+1,f+1)}return new T.Position(t+1,c.remainder+1)}else if(i-=n.size_left+n.piece.length,t+=n.lf_left+n.piece.lineFeedCnt,n.right===k.SENTINEL){const c=this.getOffsetAt(t+1,1),g=o-i-c;return new T.Position(t+1,g+1)}else n=n.right;return new T.Position(1,1)}getValueInRange(i,n){if(i.startLineNumber===i.endLineNumber&&i.startColumn===i.endColumn)return"";const t=this.nodeAt2(i.startLineNumber,i.startColumn),o=this.nodeAt2(i.endLineNumber,i.endColumn),c=this.getValueInRange2(t,o);return n?n!==this._EOL||!this._EOLNormalized?c.replace(/\r\n|\r|\n/g,n):n===this.getEOL()&&this._EOLNormalized?c:c.replace(/\r\n|\r|\n/g,n):c}getValueInRange2(i,n){if(i.node===n.node){const f=i.node,h=this._buffers[f.piece.bufferIndex].buffer,_=this.offsetInBuffer(f.piece.bufferIndex,f.piece.start);return h.substring(_+i.remainder,_+n.remainder)}let t=i.node;const o=this._buffers[t.piece.bufferIndex].buffer,c=this.offsetInBuffer(t.piece.bufferIndex,t.piece.start);let g=o.substring(c+i.remainder,c+t.piece.length);for(t=t.next();t!==k.SENTINEL;){const f=this._buffers[t.piece.bufferIndex].buffer,h=this.offsetInBuffer(t.piece.bufferIndex,t.piece.start);if(t===n.node){g+=f.substring(h,h+n.remainder);break}else g+=f.substr(h,t.piece.length);t=t.next()}return g}getLinesContent(){const i=[];let n=0,t="",o=!1;return this.iterate(this.root,c=>{if(c===k.SENTINEL)return!0;const g=c.piece;let f=g.length;if(f===0)return!0;const h=this._buffers[g.bufferIndex].buffer,_=this._buffers[g.bufferIndex].lineStarts,y=g.start.line,w=g.end.line;let P=_[y]+g.start.column;if(o&&(h.charCodeAt(P)===S.CharCode.LineFeed&&(P++,f--),i[n++]=t,t="",o=!1,f===0))return!0;if(y===w)return!this._EOLNormalized&&h.charCodeAt(P+f-1)===S.CharCode.CarriageReturn?(o=!0,t+=h.substr(P,f-1)):t+=h.substr(P,f),!0;t+=this._EOLNormalized?h.substring(P,Math.max(P,_[y+1]-this._EOLLength)):h.substring(P,_[y+1]).replace(/(\r\n|\r|\n)$/,""),i[n++]=t;for(let R=y+1;R<w;R++)t=this._EOLNormalized?h.substring(_[R],_[R+1]-this._EOLLength):h.substring(_[R],_[R+1]).replace(/(\r\n|\r|\n)$/,""),i[n++]=t;return!this._EOLNormalized&&h.charCodeAt(_[w]+g.end.column-1)===S.CharCode.CarriageReturn?(o=!0,g.end.column===0?n--:t=h.substr(_[w],g.end.column-1)):t=h.substr(_[w],g.end.column),!0}),o&&(i[n++]=t,t=""),i[n++]=t,i}getLength(){return this._length}getLineCount(){return this._lineCnt}getLineContent(i){return this._lastVisitedLine.lineNumber===i?this._lastVisitedLine.value:(this._lastVisitedLine.lineNumber=i,i===this._lineCnt?this._lastVisitedLine.value=this.getLineRawContent(i):this._EOLNormalized?this._lastVisitedLine.value=this.getLineRawContent(i,this._EOLLength):this._lastVisitedLine.value=this.getLineRawContent(i).replace(/(\r\n|\r|\n)$/,""),this._lastVisitedLine.value)}_getCharCode(i){if(i.remainder===i.node.piece.length){const n=i.node.next();if(!n)return 0;const t=this._buffers[n.piece.bufferIndex],o=this.offsetInBuffer(n.piece.bufferIndex,n.piece.start);return t.buffer.charCodeAt(o)}else{const n=this._buffers[i.node.piece.bufferIndex],o=this.offsetInBuffer(i.node.piece.bufferIndex,i.node.piece.start)+i.remainder;return n.buffer.charCodeAt(o)}}getLineCharCode(i,n){const t=this.nodeAt2(i,n+1);return this._getCharCode(t)}getLineLength(i){if(i===this.getLineCount()){const n=this.getOffsetAt(i,1);return this.getLength()-n}return this.getOffsetAt(i+1,1)-this.getOffsetAt(i,1)-this._EOLLength}getCharCode(i){const n=this.nodeAt(i);return this._getCharCode(n)}getNearestChunk(i){const n=this.nodeAt(i);if(n.remainder===n.node.piece.length){const t=n.node.next();if(!t||t===k.SENTINEL)return"";const o=this._buffers[t.piece.bufferIndex],c=this.offsetInBuffer(t.piece.bufferIndex,t.piece.start);return o.buffer.substring(c,c+t.piece.length)}else{const t=this._buffers[n.node.piece.bufferIndex],o=this.offsetInBuffer(n.node.piece.bufferIndex,n.node.piece.start),c=o+n.remainder,g=o+n.node.piece.length;return t.buffer.substring(c,g)}}findMatchesInNode(i,n,t,o,c,g,f,h,_,y,w){const P=this._buffers[i.piece.bufferIndex],R=this.offsetInBuffer(i.piece.bufferIndex,i.piece.start),p=this.offsetInBuffer(i.piece.bufferIndex,c),b=this.offsetInBuffer(i.piece.bufferIndex,g);let N;const L={line:0,column:0};let F,K;n._wordSeparators?(F=P.buffer.substring(p,b),K=J=>J+p,n.reset(0)):(F=P.buffer,K=J=>J,n.reset(p));do if(N=n.next(F),N){if(K(N.index)>=b)return y;this.positionInBuffer(i,K(N.index)-R,L);const J=this.getLineFeedCnt(i.piece.bufferIndex,c,L),$=L.line===c.line?L.column-c.column+o:L.column+1,x=$+N[0].length;if(w[y++]=(0,A.createFindMatch)(new D.Range(t+J,$,t+J,x),N,h),K(N.index)+N[0].length>=b||y>=_)return y}while(N);return y}findMatchesLineByLine(i,n,t,o){const c=[];let g=0;const f=new A.Searcher(n.wordSeparators,n.regex);let h=this.nodeAt2(i.startLineNumber,i.startColumn);if(h===null)return[];const _=this.nodeAt2(i.endLineNumber,i.endColumn);if(_===null)return[];let y=this.positionInBuffer(h.node,h.remainder);const w=this.positionInBuffer(_.node,_.remainder);if(h.node===_.node)return this.findMatchesInNode(h.node,f,i.startLineNumber,i.startColumn,y,w,n,t,o,g,c),c;let P=i.startLineNumber,R=h.node;for(;R!==_.node;){const b=this.getLineFeedCnt(R.piece.bufferIndex,y,R.piece.end);if(b>=1){const L=this._buffers[R.piece.bufferIndex].lineStarts,F=this.offsetInBuffer(R.piece.bufferIndex,R.piece.start),K=L[y.line+b],J=P===i.startLineNumber?i.startColumn:1;if(g=this.findMatchesInNode(R,f,P,J,y,this.positionInBuffer(R,K-F),n,t,o,g,c),g>=o)return c;P+=b}const N=P===i.startLineNumber?i.startColumn-1:0;if(P===i.endLineNumber){const L=this.getLineContent(P).substring(N,i.endColumn-1);return g=this._findMatchesInLine(n,f,L,i.endLineNumber,N,g,c,t,o),c}if(g=this._findMatchesInLine(n,f,this.getLineContent(P).substr(N),P,N,g,c,t,o),g>=o)return c;P++,h=this.nodeAt2(P,1),R=h.node,y=this.positionInBuffer(h.node,h.remainder)}if(P===i.endLineNumber){const b=P===i.startLineNumber?i.startColumn-1:0,N=this.getLineContent(P).substring(b,i.endColumn-1);return g=this._findMatchesInLine(n,f,N,i.endLineNumber,b,g,c,t,o),c}const p=P===i.startLineNumber?i.startColumn:1;return g=this.findMatchesInNode(_.node,f,P,p,y,w,n,t,o,g,c),c}_findMatchesInLine(i,n,t,o,c,g,f,h,_){const y=i.wordSeparators;if(!h&&i.simpleSearch){const P=i.simpleSearch,R=P.length,p=t.length;let b=-R;for(;(b=t.indexOf(P,b+R))!==-1;)if((!y||(0,A.isValidMatch)(y,t,p,b,R))&&(f[g++]=new O.FindMatch(new D.Range(o,b+1+c,o,b+1+R+c),null),g>=_))return g;return g}let w;n.reset(0);do if(w=n.next(t),w&&(f[g++]=(0,A.createFindMatch)(new D.Range(o,w.index+1+c,o,w.index+1+w[0].length+c),w,h),g>=_))return g;while(w);return g}insert(i,n,t=!1){if(this._EOLNormalized=this._EOLNormalized&&t,this._lastVisitedLine.lineNumber=0,this._lastVisitedLine.value="",this.root!==k.SENTINEL){const{node:o,remainder:c,nodeStartOffset:g}=this.nodeAt(i),f=o.piece,h=f.bufferIndex,_=this.positionInBuffer(o,c);if(o.piece.bufferIndex===0&&f.end.line===this._lastChangeBufferPos.line&&f.end.column===this._lastChangeBufferPos.column&&g+f.length===i&&n.length<m){this.appendToNode(o,n),this.computeBufferMetadata();return}if(g===i)this.insertContentToNodeLeft(n,o),this._searchCache.validate(i);else if(g+o.piece.length>i){const y=[];let w=new C(f.bufferIndex,_,f.end,this.getLineFeedCnt(f.bufferIndex,_,f.end),this.offsetInBuffer(h,f.end)-this.offsetInBuffer(h,_));if(this.shouldCheckCRLF()&&this.endWithCR(n)&&this.nodeCharCodeAt(o,c)===10){const b={line:w.start.line+1,column:0};w=new C(w.bufferIndex,b,w.end,this.getLineFeedCnt(w.bufferIndex,b,w.end),w.length-1),n+=`
`}if(this.shouldCheckCRLF()&&this.startWithLF(n))if(this.nodeCharCodeAt(o,c-1)===13){const b=this.positionInBuffer(o,c-1);this.deleteNodeTail(o,b),n="\r"+n,o.piece.length===0&&y.push(o)}else this.deleteNodeTail(o,_);else this.deleteNodeTail(o,_);const P=this.createNewPieces(n);w.length>0&&this.rbInsertRight(o,w);let R=o;for(let p=0;p<P.length;p++)R=this.rbInsertRight(R,P[p]);this.deleteNodes(y)}else this.insertContentToNodeRight(n,o)}else{const o=this.createNewPieces(n);let c=this.rbInsertLeft(null,o[0]);for(let g=1;g<o.length;g++)c=this.rbInsertRight(c,o[g])}this.computeBufferMetadata()}delete(i,n){if(this._lastVisitedLine.lineNumber=0,this._lastVisitedLine.value="",n<=0||this.root===k.SENTINEL)return;const t=this.nodeAt(i),o=this.nodeAt(i+n),c=t.node,g=o.node;if(c===g){const P=this.positionInBuffer(c,t.remainder),R=this.positionInBuffer(c,o.remainder);if(t.nodeStartOffset===i){if(n===c.piece.length){const p=c.next();(0,k.rbDelete)(this,c),this.validateCRLFWithPrevNode(p),this.computeBufferMetadata();return}this.deleteNodeHead(c,R),this._searchCache.validate(i),this.validateCRLFWithPrevNode(c),this.computeBufferMetadata();return}if(t.nodeStartOffset+c.piece.length===i+n){this.deleteNodeTail(c,P),this.validateCRLFWithNextNode(c),this.computeBufferMetadata();return}this.shrinkNode(c,P,R),this.computeBufferMetadata();return}const f=[],h=this.positionInBuffer(c,t.remainder);this.deleteNodeTail(c,h),this._searchCache.validate(i),c.piece.length===0&&f.push(c);const _=this.positionInBuffer(g,o.remainder);this.deleteNodeHead(g,_),g.piece.length===0&&f.push(g);const y=c.next();for(let P=y;P!==k.SENTINEL&&P!==g;P=P.next())f.push(P);const w=c.piece.length===0?c.prev():c;this.deleteNodes(f),this.validateCRLFWithNextNode(w),this.computeBufferMetadata()}insertContentToNodeLeft(i,n){const t=[];if(this.shouldCheckCRLF()&&this.endWithCR(i)&&this.startWithLF(n)){const g=n.piece,f={line:g.start.line+1,column:0},h=new C(g.bufferIndex,f,g.end,this.getLineFeedCnt(g.bufferIndex,f,g.end),g.length-1);n.piece=h,i+=`
`,(0,k.updateTreeMetadata)(this,n,-1,-1),n.piece.length===0&&t.push(n)}const o=this.createNewPieces(i);let c=this.rbInsertLeft(n,o[o.length-1]);for(let g=o.length-2;g>=0;g--)c=this.rbInsertLeft(c,o[g]);this.validateCRLFWithPrevNode(c),this.deleteNodes(t)}insertContentToNodeRight(i,n){this.adjustCarriageReturnFromNext(i,n)&&(i+=`
`);const t=this.createNewPieces(i),o=this.rbInsertRight(n,t[0]);let c=o;for(let g=1;g<t.length;g++)c=this.rbInsertRight(c,t[g]);this.validateCRLFWithPrevNode(o)}positionInBuffer(i,n,t){const o=i.piece,c=i.piece.bufferIndex,g=this._buffers[c].lineStarts,h=g[o.start.line]+o.start.column+n;let _=o.start.line,y=o.end.line,w=0,P=0,R=0;for(;_<=y&&(w=_+(y-_)/2|0,R=g[w],w!==y);)if(P=g[w+1],h<R)y=w-1;else if(h>=P)_=w+1;else break;return t?(t.line=w,t.column=h-R,null):{line:w,column:h-R}}getLineFeedCnt(i,n,t){if(t.column===0)return t.line-n.line;const o=this._buffers[i].lineStarts;if(t.line===o.length-1)return t.line-n.line;const c=o[t.line+1],g=o[t.line]+t.column;if(c>g+1)return t.line-n.line;const f=g-1;return this._buffers[i].buffer.charCodeAt(f)===13?t.line-n.line+1:t.line-n.line}offsetInBuffer(i,n){return this._buffers[i].lineStarts[n.line]+n.column}deleteNodes(i){for(let n=0;n<i.length;n++)(0,k.rbDelete)(this,i[n])}createNewPieces(i){if(i.length>m){const y=[];for(;i.length>m;){const P=i.charCodeAt(m-1);let R;P===S.CharCode.CarriageReturn||P>=55296&&P<=56319?(R=i.substring(0,m-1),i=i.substring(m-1)):(R=i.substring(0,m),i=i.substring(m));const p=E(R);y.push(new C(this._buffers.length,{line:0,column:0},{line:p.length-1,column:R.length-p[p.length-1]},p.length-1,R.length)),this._buffers.push(new v(R,p))}const w=E(i);return y.push(new C(this._buffers.length,{line:0,column:0},{line:w.length-1,column:i.length-w[w.length-1]},w.length-1,i.length)),this._buffers.push(new v(i,w)),y}let n=this._buffers[0].buffer.length;const t=E(i,!1);let o=this._lastChangeBufferPos;if(this._buffers[0].lineStarts[this._buffers[0].lineStarts.length-1]===n&&n!==0&&this.startWithLF(i)&&this.endWithCR(this._buffers[0].buffer)){this._lastChangeBufferPos={line:this._lastChangeBufferPos.line,column:this._lastChangeBufferPos.column+1},o=this._lastChangeBufferPos;for(let y=0;y<t.length;y++)t[y]+=n+1;this._buffers[0].lineStarts=this._buffers[0].lineStarts.concat(t.slice(1)),this._buffers[0].buffer+="_"+i,n+=1}else{if(n!==0)for(let y=0;y<t.length;y++)t[y]+=n;this._buffers[0].lineStarts=this._buffers[0].lineStarts.concat(t.slice(1)),this._buffers[0].buffer+=i}const c=this._buffers[0].buffer.length,g=this._buffers[0].lineStarts.length-1,f=c-this._buffers[0].lineStarts[g],h={line:g,column:f},_=new C(0,o,h,this.getLineFeedCnt(0,o,h),c-n);return this._lastChangeBufferPos=h,[_]}getLinesRawContent(){return this.getContentOfSubTree(this.root)}getLineRawContent(i,n=0){let t=this.root,o="";const c=this._searchCache.get2(i);if(c){t=c.node;const g=this.getAccumulatedValue(t,i-c.nodeStartLineNumber-1),f=this._buffers[t.piece.bufferIndex].buffer,h=this.offsetInBuffer(t.piece.bufferIndex,t.piece.start);if(c.nodeStartLineNumber+t.piece.lineFeedCnt===i)o=f.substring(h+g,h+t.piece.length);else{const _=this.getAccumulatedValue(t,i-c.nodeStartLineNumber);return f.substring(h+g,h+_-n)}}else{let g=0;const f=i;for(;t!==k.SENTINEL;)if(t.left!==k.SENTINEL&&t.lf_left>=i-1)t=t.left;else if(t.lf_left+t.piece.lineFeedCnt>i-1){const h=this.getAccumulatedValue(t,i-t.lf_left-2),_=this.getAccumulatedValue(t,i-t.lf_left-1),y=this._buffers[t.piece.bufferIndex].buffer,w=this.offsetInBuffer(t.piece.bufferIndex,t.piece.start);return g+=t.size_left,this._searchCache.set({node:t,nodeStartOffset:g,nodeStartLineNumber:f-(i-1-t.lf_left)}),y.substring(w+h,w+_-n)}else if(t.lf_left+t.piece.lineFeedCnt===i-1){const h=this.getAccumulatedValue(t,i-t.lf_left-2),_=this._buffers[t.piece.bufferIndex].buffer,y=this.offsetInBuffer(t.piece.bufferIndex,t.piece.start);o=_.substring(y+h,y+t.piece.length);break}else i-=t.lf_left+t.piece.lineFeedCnt,g+=t.size_left+t.piece.length,t=t.right}for(t=t.next();t!==k.SENTINEL;){const g=this._buffers[t.piece.bufferIndex].buffer;if(t.piece.lineFeedCnt>0){const f=this.getAccumulatedValue(t,0),h=this.offsetInBuffer(t.piece.bufferIndex,t.piece.start);return o+=g.substring(h,h+f-n),o}else{const f=this.offsetInBuffer(t.piece.bufferIndex,t.piece.start);o+=g.substr(f,t.piece.length)}t=t.next()}return o}computeBufferMetadata(){let i=this.root,n=1,t=0;for(;i!==k.SENTINEL;)n+=i.lf_left+i.piece.lineFeedCnt,t+=i.size_left+i.piece.length,i=i.right;this._lineCnt=n,this._length=t,this._searchCache.validate(this._length)}getIndexOf(i,n){const t=i.piece,o=this.positionInBuffer(i,n),c=o.line-t.start.line;if(this.offsetInBuffer(t.bufferIndex,t.end)-this.offsetInBuffer(t.bufferIndex,t.start)===n){const g=this.getLineFeedCnt(i.piece.bufferIndex,t.start,o);if(g!==c)return{index:g,remainder:0}}return{index:c,remainder:o.column}}getAccumulatedValue(i,n){if(n<0)return 0;const t=i.piece,o=this._buffers[t.bufferIndex].lineStarts,c=t.start.line+n+1;return c>t.end.line?o[t.end.line]+t.end.column-o[t.start.line]-t.start.column:o[c]-o[t.start.line]-t.start.column}deleteNodeTail(i,n){const t=i.piece,o=t.lineFeedCnt,c=this.offsetInBuffer(t.bufferIndex,t.end),g=n,f=this.offsetInBuffer(t.bufferIndex,g),h=this.getLineFeedCnt(t.bufferIndex,t.start,g),_=h-o,y=f-c,w=t.length+y;i.piece=new C(t.bufferIndex,t.start,g,h,w),(0,k.updateTreeMetadata)(this,i,y,_)}deleteNodeHead(i,n){const t=i.piece,o=t.lineFeedCnt,c=this.offsetInBuffer(t.bufferIndex,t.start),g=n,f=this.getLineFeedCnt(t.bufferIndex,g,t.end),h=this.offsetInBuffer(t.bufferIndex,g),_=f-o,y=c-h,w=t.length+y;i.piece=new C(t.bufferIndex,g,t.end,f,w),(0,k.updateTreeMetadata)(this,i,y,_)}shrinkNode(i,n,t){const o=i.piece,c=o.start,g=o.end,f=o.length,h=o.lineFeedCnt,_=n,y=this.getLineFeedCnt(o.bufferIndex,o.start,_),w=this.offsetInBuffer(o.bufferIndex,n)-this.offsetInBuffer(o.bufferIndex,c);i.piece=new C(o.bufferIndex,o.start,_,y,w),(0,k.updateTreeMetadata)(this,i,w-f,y-h);const P=new C(o.bufferIndex,t,g,this.getLineFeedCnt(o.bufferIndex,t,g),this.offsetInBuffer(o.bufferIndex,g)-this.offsetInBuffer(o.bufferIndex,t)),R=this.rbInsertRight(i,P);this.validateCRLFWithPrevNode(R)}appendToNode(i,n){this.adjustCarriageReturnFromNext(n,i)&&(n+=`
`);const t=this.shouldCheckCRLF()&&this.startWithLF(n)&&this.endWithCR(i),o=this._buffers[0].buffer.length;this._buffers[0].buffer+=n;const c=E(n,!1);for(let R=0;R<c.length;R++)c[R]+=o;if(t){const R=this._buffers[0].lineStarts[this._buffers[0].lineStarts.length-2];this._buffers[0].lineStarts.pop(),this._lastChangeBufferPos={line:this._lastChangeBufferPos.line-1,column:o-R}}this._buffers[0].lineStarts=this._buffers[0].lineStarts.concat(c.slice(1));const g=this._buffers[0].lineStarts.length-1,f=this._buffers[0].buffer.length-this._buffers[0].lineStarts[g],h={line:g,column:f},_=i.piece.length+n.length,y=i.piece.lineFeedCnt,w=this.getLineFeedCnt(0,i.piece.start,h),P=w-y;i.piece=new C(i.piece.bufferIndex,i.piece.start,h,w,_),this._lastChangeBufferPos=h,(0,k.updateTreeMetadata)(this,i,n.length,P)}nodeAt(i){let n=this.root;const t=this._searchCache.get(i);if(t)return{node:t.node,nodeStartOffset:t.nodeStartOffset,remainder:i-t.nodeStartOffset};let o=0;for(;n!==k.SENTINEL;)if(n.size_left>i)n=n.left;else if(n.size_left+n.piece.length>=i){o+=n.size_left;const c={node:n,remainder:i-n.size_left,nodeStartOffset:o};return this._searchCache.set(c),c}else i-=n.size_left+n.piece.length,o+=n.size_left+n.piece.length,n=n.right;return null}nodeAt2(i,n){let t=this.root,o=0;for(;t!==k.SENTINEL;)if(t.left!==k.SENTINEL&&t.lf_left>=i-1)t=t.left;else if(t.lf_left+t.piece.lineFeedCnt>i-1){const c=this.getAccumulatedValue(t,i-t.lf_left-2),g=this.getAccumulatedValue(t,i-t.lf_left-1);return o+=t.size_left,{node:t,remainder:Math.min(c+n-1,g),nodeStartOffset:o}}else if(t.lf_left+t.piece.lineFeedCnt===i-1){const c=this.getAccumulatedValue(t,i-t.lf_left-2);if(c+n-1<=t.piece.length)return{node:t,remainder:c+n-1,nodeStartOffset:o};n-=t.piece.length-c;break}else i-=t.lf_left+t.piece.lineFeedCnt,o+=t.size_left+t.piece.length,t=t.right;for(t=t.next();t!==k.SENTINEL;){if(t.piece.lineFeedCnt>0){const c=this.getAccumulatedValue(t,0),g=this.offsetOfNode(t);return{node:t,remainder:Math.min(n-1,c),nodeStartOffset:g}}else if(t.piece.length>=n-1){const c=this.offsetOfNode(t);return{node:t,remainder:n-1,nodeStartOffset:c}}else n-=t.piece.length;t=t.next()}return null}nodeCharCodeAt(i,n){if(i.piece.lineFeedCnt<1)return-1;const t=this._buffers[i.piece.bufferIndex],o=this.offsetInBuffer(i.piece.bufferIndex,i.piece.start)+n;return t.buffer.charCodeAt(o)}offsetOfNode(i){if(!i)return 0;let n=i.size_left;for(;i!==this.root;)i.parent.right===i&&(n+=i.parent.size_left+i.parent.piece.length),i=i.parent;return n}shouldCheckCRLF(){return!(this._EOLNormalized&&this._EOL===`
`)}startWithLF(i){if(typeof i=="string")return i.charCodeAt(0)===10;if(i===k.SENTINEL||i.piece.lineFeedCnt===0)return!1;const n=i.piece,t=this._buffers[n.bufferIndex].lineStarts,o=n.start.line,c=t[o]+n.start.column;return o===t.length-1||t[o+1]>c+1?!1:this._buffers[n.bufferIndex].buffer.charCodeAt(c)===10}endWithCR(i){return typeof i=="string"?i.charCodeAt(i.length-1)===13:i===k.SENTINEL||i.piece.lineFeedCnt===0?!1:this.nodeCharCodeAt(i,i.piece.length-1)===13}validateCRLFWithPrevNode(i){if(this.shouldCheckCRLF()&&this.startWithLF(i)){const n=i.prev();this.endWithCR(n)&&this.fixCRLF(n,i)}}validateCRLFWithNextNode(i){if(this.shouldCheckCRLF()&&this.endWithCR(i)){const n=i.next();this.startWithLF(n)&&this.fixCRLF(i,n)}}fixCRLF(i,n){const t=[],o=this._buffers[i.piece.bufferIndex].lineStarts;let c;i.piece.end.column===0?c={line:i.piece.end.line-1,column:o[i.piece.end.line]-o[i.piece.end.line-1]-1}:c={line:i.piece.end.line,column:i.piece.end.column-1};const g=i.piece.length-1,f=i.piece.lineFeedCnt-1;i.piece=new C(i.piece.bufferIndex,i.piece.start,c,f,g),(0,k.updateTreeMetadata)(this,i,-1,-1),i.piece.length===0&&t.push(i);const h={line:n.piece.start.line+1,column:0},_=n.piece.length-1,y=this.getLineFeedCnt(n.piece.bufferIndex,h,n.piece.end);n.piece=new C(n.piece.bufferIndex,h,n.piece.end,y,_),(0,k.updateTreeMetadata)(this,n,-1,-1),n.piece.length===0&&t.push(n);const w=this.createNewPieces(`\r
`);this.rbInsertRight(i,w[0]);for(let P=0;P<t.length;P++)(0,k.rbDelete)(this,t[P])}adjustCarriageReturnFromNext(i,n){if(this.shouldCheckCRLF()&&this.endWithCR(i)){const t=n.next();if(this.startWithLF(t)){if(i+=`
`,t.piece.length===1)(0,k.rbDelete)(this,t);else{const o=t.piece,c={line:o.start.line+1,column:0},g=o.length-1,f=this.getLineFeedCnt(o.bufferIndex,c,o.end);t.piece=new C(o.bufferIndex,c,o.end,f,g),(0,k.updateTreeMetadata)(this,t,-1,-1)}return!0}}return!1}iterate(i,n){if(i===k.SENTINEL)return n(k.SENTINEL);const t=this.iterate(i.left,n);return t&&n(i)&&this.iterate(i.right,n)}getNodeContent(i){if(i===k.SENTINEL)return"";const n=this._buffers[i.piece.bufferIndex],t=i.piece,o=this.offsetInBuffer(t.bufferIndex,t.start),c=this.offsetInBuffer(t.bufferIndex,t.end);return n.buffer.substring(o,c)}getPieceContent(i){const n=this._buffers[i.bufferIndex],t=this.offsetInBuffer(i.bufferIndex,i.start),o=this.offsetInBuffer(i.bufferIndex,i.end);return n.buffer.substring(t,o)}rbInsertRight(i,n){const t=new k.TreeNode(n,k.NodeColor.Red);if(t.left=k.SENTINEL,t.right=k.SENTINEL,t.parent=k.SENTINEL,t.size_left=0,t.lf_left=0,this.root===k.SENTINEL)this.root=t,t.color=k.NodeColor.Black;else if(i.right===k.SENTINEL)i.right=t,t.parent=i;else{const c=(0,k.leftest)(i.right);c.left=t,t.parent=c}return(0,k.fixInsert)(this,t),t}rbInsertLeft(i,n){const t=new k.TreeNode(n,k.NodeColor.Red);if(t.left=k.SENTINEL,t.right=k.SENTINEL,t.parent=k.SENTINEL,t.size_left=0,t.lf_left=0,this.root===k.SENTINEL)this.root=t,t.color=k.NodeColor.Black;else if(i.left===k.SENTINEL)i.left=t,t.parent=i;else{const o=(0,k.righttest)(i.left);o.right=t,t.parent=o}return(0,k.fixInsert)(this,t),t}getContentOfSubTree(i){let n="";return this.iterate(i,t=>(n+=this.getNodeContent(t),!0)),n}}e.PieceTreeBase=d}),define(ke[156],Re([1,0]),function(Ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DraggedTreeItemsIdentifier=e.TreeViewsDnDService=void 0;class S{constructor(){this._dragOperations=new Map}removeDragOperationTransfer(O){if(O&&this._dragOperations.has(O)){const k=this._dragOperations.get(O);return this._dragOperations.delete(O),k}}addDragOperationTransfer(O,k){this._dragOperations.set(O,k)}}e.TreeViewsDnDService=S;class T{constructor(O){this.identifier=O}}e.DraggedTreeItemsIdentifier=T}),define(ke[157],Re([1,0,6,4,9]),function(Ee,e,S,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EmptySubmenuAction=e.SubmenuAction=e.Separator=e.ActionRunner=e.Action=void 0,e.toAction=I,D=Ve(D);class O extends T.Disposable{constructor(u,C="",v="",r=!0,a){super(),this._onDidChange=this._register(new S.Emitter),this.onDidChange=this._onDidChange.event,this._enabled=!0,this._id=u,this._label=C,this._cssClass=v,this._enabled=r,this._actionCallback=a}get id(){return this._id}get label(){return this._label}set label(u){this._setLabel(u)}_setLabel(u){this._label!==u&&(this._label=u,this._onDidChange.fire({label:u}))}get tooltip(){return this._tooltip||""}set tooltip(u){this._setTooltip(u)}_setTooltip(u){this._tooltip!==u&&(this._tooltip=u,this._onDidChange.fire({tooltip:u}))}get class(){return this._cssClass}set class(u){this._setClass(u)}_setClass(u){this._cssClass!==u&&(this._cssClass=u,this._onDidChange.fire({class:u}))}get enabled(){return this._enabled}set enabled(u){this._setEnabled(u)}_setEnabled(u){this._enabled!==u&&(this._enabled=u,this._onDidChange.fire({enabled:u}))}get checked(){return this._checked}set checked(u){this._setChecked(u)}_setChecked(u){this._checked!==u&&(this._checked=u,this._onDidChange.fire({checked:u}))}async run(u,C){this._actionCallback&&await this._actionCallback(u)}}e.Action=O;class k extends T.Disposable{constructor(){super(...arguments),this._onWillRun=this._register(new S.Emitter),this.onWillRun=this._onWillRun.event,this._onDidRun=this._register(new S.Emitter),this.onDidRun=this._onDidRun.event}async run(u,C){if(!u.enabled)return;this._onWillRun.fire({action:u});let v;try{await this.runAction(u,C)}catch(r){v=r}this._onDidRun.fire({action:u,error:v})}async runAction(u,C){await u.run(C)}}e.ActionRunner=k;class A{constructor(){this.id=A.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...u){let C=[];for(const v of u)v.length&&(C.length?C=[...C,new A,...v]:C=v);return C}static{this.ID="vs.actions.separator"}async run(){}}e.Separator=A;class m{get actions(){return this._actions}constructor(u,C,v,r){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=u,this.label=C,this.class=r,this._actions=v}async run(){}}e.SubmenuAction=m;class s extends O{static{this.ID="vs.actions.empty"}constructor(){super(s.ID,D.localize(41,null),void 0,!1)}}e.EmptySubmenuAction=s;function I(E){return{id:E.id,label:E.label,tooltip:E.tooltip??E.label,class:E.class,enabled:E.enabled??!0,checked:E.checked,run:async(...u)=>E.run(...u)}}}),define(ke[158],Re([1,0,9]),function(Ee,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fromNow=s,e.fromNowByDay=I,e.getDurationString=E,e.toLocalISOString=u;const T=60,D=T*60,O=D*24,k=O*7,A=O*30,m=O*365;function s(C,v,r,a){typeof C!="number"&&(C=C.getTime());const d=Math.round((new Date().getTime()-C)/1e3);if(d<-30)return(0,S.localize)(42,null,s(new Date().getTime()+d*1e3,!1));if(!a&&d<30)return(0,S.localize)(43,null);let l;return d<T?(l=d,v?l===1?r?(0,S.localize)(44,null,l):(0,S.localize)(45,null,l):r?(0,S.localize)(46,null,l):(0,S.localize)(47,null,l):l===1?r?(0,S.localize)(48,null,l):(0,S.localize)(49,null,l):r?(0,S.localize)(50,null,l):(0,S.localize)(51,null,l)):d<D?(l=Math.floor(d/T),v?l===1?r?(0,S.localize)(52,null,l):(0,S.localize)(53,null,l):r?(0,S.localize)(54,null,l):(0,S.localize)(55,null,l):l===1?r?(0,S.localize)(56,null,l):(0,S.localize)(57,null,l):r?(0,S.localize)(58,null,l):(0,S.localize)(59,null,l)):d<O?(l=Math.floor(d/D),v?l===1?r?(0,S.localize)(60,null,l):(0,S.localize)(61,null,l):r?(0,S.localize)(62,null,l):(0,S.localize)(63,null,l):l===1?r?(0,S.localize)(64,null,l):(0,S.localize)(65,null,l):r?(0,S.localize)(66,null,l):(0,S.localize)(67,null,l)):d<k?(l=Math.floor(d/O),v?l===1?(0,S.localize)(68,null,l):(0,S.localize)(69,null,l):l===1?(0,S.localize)(70,null,l):(0,S.localize)(71,null,l)):d<A?(l=Math.floor(d/k),v?l===1?r?(0,S.localize)(72,null,l):(0,S.localize)(73,null,l):r?(0,S.localize)(74,null,l):(0,S.localize)(75,null,l):l===1?r?(0,S.localize)(76,null,l):(0,S.localize)(77,null,l):r?(0,S.localize)(78,null,l):(0,S.localize)(79,null,l)):d<m?(l=Math.floor(d/A),v?l===1?r?(0,S.localize)(80,null,l):(0,S.localize)(81,null,l):r?(0,S.localize)(82,null,l):(0,S.localize)(83,null,l):l===1?r?(0,S.localize)(84,null,l):(0,S.localize)(85,null,l):r?(0,S.localize)(86,null,l):(0,S.localize)(87,null,l)):(l=Math.floor(d/m),v?l===1?r?(0,S.localize)(88,null,l):(0,S.localize)(89,null,l):r?(0,S.localize)(90,null,l):(0,S.localize)(91,null,l):l===1?r?(0,S.localize)(92,null,l):(0,S.localize)(93,null,l):r?(0,S.localize)(94,null,l):(0,S.localize)(95,null,l))}function I(C,v,r){typeof C!="number"&&(C=C.getTime());const a=new Date;a.setHours(0,0,0,0);const d=new Date(a.getTime());return d.setDate(d.getDate()-1),C>a.getTime()?(0,S.localize)(96,null):C>d.getTime()?(0,S.localize)(97,null):s(C,v,r)}function E(C,v){const r=Math.abs(C/1e3);return r<1?v?(0,S.localize)(98,null,C):(0,S.localize)(99,null,C):r<T?v?(0,S.localize)(100,null,Math.round(C)/1e3):(0,S.localize)(101,null,Math.round(C)/1e3):r<D?v?(0,S.localize)(102,null,Math.round(C/(1e3*T))):(0,S.localize)(103,null,Math.round(C/(1e3*T))):r<O?v?(0,S.localize)(104,null,Math.round(C/(1e3*D))):(0,S.localize)(105,null,Math.round(C/(1e3*D))):(0,S.localize)(106,null,Math.round(C/(1e3*O)))}function u(C){return C.getFullYear()+"-"+String(C.getMonth()+1).padStart(2,"0")+"-"+String(C.getDate()).padStart(2,"0")+"T"+String(C.getHours()).padStart(2,"0")+":"+String(C.getMinutes()).padStart(2,"0")+":"+String(C.getSeconds()).padStart(2,"0")+"."+(C.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(ke[42],Re([1,0,17,14,9]),function(Ee,e,S,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=m,e.isErrorWithActions=s,e.createErrorWithActions=I,S=Ve(S),T=Ve(T),D=Ve(D);function O(E,u){return u&&(E.stack||E.stacktrace)?D.localize(107,null,A(E),k(E.stack)||k(E.stacktrace)):A(E)}function k(E){return Array.isArray(E)?E.join(`
`):E}function A(E){return E.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${E.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof E.code=="string"&&typeof E.errno=="number"&&typeof E.syscall=="string"?D.localize(108,null,E.message):E.message||D.localize(109,null)}function m(E=null,u=!1){if(!E)return D.localize(110,null);if(Array.isArray(E)){const C=S.coalesce(E),v=m(C[0],u);return C.length>1?D.localize(111,null,v,C.length):v}if(T.isString(E))return E;if(E.detail){const C=E.detail;if(C.error)return O(C.error,u);if(C.exception)return O(C.exception,u)}return E.stack?O(E,u):E.message?E.message:D.localize(112,null)}function s(E){const u=E;return u instanceof Error&&Array.isArray(u.actions)}function I(E,u){let C;return typeof E=="string"?C=new Error(E):C=E,C.actions=u,C}}),define(ke[159],Re([1,0,51,22]),function(Ee,e,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareFileNames=A,e.compareFileNamesDefault=m,e.compareFileNamesUpper=s,e.compareFileNamesLower=I,e.compareFileNamesUnicode=E,e.compareFileExtensions=u,e.compareFileExtensionsDefault=C,e.compareFileExtensionsUpper=v,e.compareFileExtensionsLower=r,e.compareFileExtensionsUnicode=a,e.comparePaths=h,e.compareAnything=_,e.compareByPrefix=y;const D=new S.Lazy(()=>{const w=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:w,collatorIsNumeric:w.resolvedOptions().numeric}}),O=new S.Lazy(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),k=new S.Lazy(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function A(w,P,R=!1){const p=w||"",b=P||"",N=D.value.collator.compare(p,b);return D.value.collatorIsNumeric&&N===0&&p!==b?p<b?-1:1:N}function m(w,P){const R=O.value.collator;return w=w||"",P=P||"",n(R,w,P)}function s(w,P){const R=O.value.collator;return w=w||"",P=P||"",g(w,P)||n(R,w,P)}function I(w,P){const R=O.value.collator;return w=w||"",P=P||"",c(w,P)||n(R,w,P)}function E(w,P){return w=w||"",P=P||"",w===P?0:w<P?-1:1}function u(w,P){const[R,p]=l(w),[b,N]=l(P);let L=D.value.collator.compare(p,N);if(L===0){if(D.value.collatorIsNumeric&&p!==N)return p<N?-1:1;if(L=D.value.collator.compare(R,b),D.value.collatorIsNumeric&&L===0&&R!==b)return R<b?-1:1}return L}function C(w,P){w=w||"",P=P||"";const R=i(w),p=i(P),b=O.value.collator,N=k.value.collator;return n(N,R,p)||n(b,w,P)}function v(w,P){w=w||"",P=P||"";const R=i(w),p=i(P),b=O.value.collator,N=k.value.collator;return n(N,R,p)||g(w,P)||n(b,w,P)}function r(w,P){w=w||"",P=P||"";const R=i(w),p=i(P),b=O.value.collator,N=k.value.collator;return n(N,R,p)||c(w,P)||n(b,w,P)}function a(w,P){w=w||"",P=P||"";const R=i(w).toLowerCase(),p=i(P).toLowerCase();return R!==p?R<p?-1:1:w!==P?w<P?-1:1:0}const d=/^(.*?)(\.([^.]*))?$/;function l(w,P=!1){const R=w?d.exec(w):[];let p=[R&&R[1]||"",R&&R[3]||""];return P&&(!p[0]&&p[1]||p[0]&&p[0].charAt(0)===".")&&(p=[p[0]+"."+p[1],""]),p}function i(w){const P=w?d.exec(w):[];return P&&P[1]&&P[1].charAt(0)!=="."&&P[3]||""}function n(w,P,R){const p=w.compare(P,R);return p!==0?p:P.length!==R.length?P.length<R.length?-1:1:0}function t(w){const P=w.charAt(0);return P.toLocaleUpperCase()!==P}function o(w){const P=w.charAt(0);return P.toLocaleLowerCase()!==P}function c(w,P){return t(w)&&o(P)?-1:o(w)&&t(P)?1:0}function g(w,P){return o(w)&&t(P)?-1:t(w)&&o(P)?1:0}function f(w,P,R=!1){return R||(w=w&&w.toLowerCase(),P=P&&P.toLowerCase()),w===P?0:w<P?-1:1}function h(w,P,R=!1){const p=w.split(T.sep),b=P.split(T.sep),N=p.length-1,L=b.length-1;let F,K;for(let J=0;;J++){if(F=N===J,K=L===J,F&&K)return A(p[J],b[J],R);if(F)return-1;if(K)return 1;const $=f(p[J],b[J],R);if($!==0)return $}}function _(w,P,R){const p=w.toLowerCase(),b=P.toLowerCase(),N=y(w,P,R);if(N)return N;const L=p.endsWith(R),F=b.endsWith(R);if(L!==F)return L?-1:1;const K=A(p,b);return K!==0?K:p.localeCompare(b)}function y(w,P,R){const p=w.toLowerCase(),b=P.toLowerCase(),N=p.startsWith(R),L=b.startsWith(R);if(N!==L)return N?-1:1;if(N&&L){if(p.length<b.length)return-1;if(p.length>b.length)return 1}return 0}}),define(ke[72],Re([1,0,22]),function(Ee,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Mimes=void 0,e.getMediaOrTextMime=O,e.getMediaMime=k,e.getExtensionForMimeType=A,e.normalizeMimeType=s,e.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const T={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},D={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function O(I){const E=(0,S.extname)(I),u=T[E.toLowerCase()];return u!==void 0?u:k(I)}function k(I){const E=(0,S.extname)(I);return D[E.toLowerCase()]}function A(I){for(const E in D)if(D[E]===I)return E}const m=/^(.+)\/(.+?)(;.+)?$/;function s(I,E){const u=m.exec(I);return u?`${u[1].toLowerCase()}/${u[2].toLowerCase()}${u[3]??""}`:E?void 0:I}}),define(ke[34],Re([1,0,20,2,38]),function(Ee,e,S,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.stringify=O,e.parse=k,e.revive=m;function O(s){return JSON.stringify(s,A)}function k(s){let I=JSON.parse(s);return I=m(I),I}function A(s,I){return I instanceof RegExp?{$mid:D.MarshalledId.Regexp,source:I.source,flags:I.flags}:I}function m(s,I=0){if(!s||I>200)return s;if(typeof s=="object"){switch(s.$mid){case D.MarshalledId.Uri:return T.URI.revive(s);case D.MarshalledId.Regexp:return new RegExp(s.source,s.flags);case D.MarshalledId.Date:return new Date(s.source)}if(s instanceof S.VSBuffer||s instanceof Uint8Array)return s;if(Array.isArray(s))for(let E=0;E<s.length;++E)s[E]=m(s[E],I+1);else for(const E in s)Object.hasOwnProperty.call(s,E)&&(s[E]=m(s[E],I+1))}return s}}),define(ke[43],Re([1,0,17,10,30,73,27,22,23,13]),function(Ee,e,S,T,D,O,k,A,m,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.GLOB_SPLIT=e.GLOBSTAR=void 0,e.getEmptyExpression=I,e.splitGlobAware=r,e.match=N,e.parse=L,e.isRelativePattern=F,e.getBasenameTerms=K,e.getPathTerms=J,e.patternsEquals=Y;function I(){return Object.create(null)}e.GLOBSTAR="**",e.GLOB_SPLIT="/";const E="[/\\\\]",u="[^/\\\\]",C=/\//g;function v(ae,ee){switch(ae){case 0:return"";case 1:return`${u}*?`;default:return`(?:${E}|${u}+${E}${ee?`|${E}${u}+`:""})*?`}}function r(ae,ee){if(!ae)return[];const oe=[];let ie=!1,ue=!1,Z="";for(const ve of ae){switch(ve){case ee:if(!ie&&!ue){oe.push(Z),Z="";continue}break;case"{":ie=!0;break;case"}":ie=!1;break;case"[":ue=!0;break;case"]":ue=!1;break}Z+=ve}return Z&&oe.push(Z),oe}function a(ae){if(!ae)return"";let ee="";const oe=r(ae,e.GLOB_SPLIT);if(oe.every(ie=>ie===e.GLOBSTAR))ee=".*";else{let ie=!1;oe.forEach((ue,Z)=>{if(ue===e.GLOBSTAR){if(ie)return;ee+=v(2,Z===oe.length-1)}else{let ve=!1,Ie="",X=!1,V="";for(const re of ue){if(re!=="}"&&ve){Ie+=re;continue}if(X&&(re!=="]"||!V)){let be;re==="-"?be=re:(re==="^"||re==="!")&&!V?be="^":re===e.GLOB_SPLIT?be="":be=(0,s.escapeRegExpCharacters)(re),V+=be;continue}switch(re){case"{":ve=!0;continue;case"[":X=!0;continue;case"}":{const De=`(?:${r(Ie,",").map(Fe=>a(Fe)).join("|")})`;ee+=De,ve=!1,Ie="";break}case"]":{ee+="["+V+"]",X=!1,V="";break}case"?":ee+=u;continue;case"*":ee+=v(1);continue;default:ee+=(0,s.escapeRegExpCharacters)(re)}}Z<oe.length-1&&(oe[Z+1]!==e.GLOBSTAR||Z+2<oe.length)&&(ee+=E)}ie=ue===e.GLOBSTAR})}return ee}const d=/^\*\*\/\*\.[\w\.-]+$/,l=/^\*\*\/([\w\.-]+)\/?$/,i=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,n=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,t=/^\*\*((\/[\w\.-]+)+)\/?$/,o=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,c=new k.LRUCache(1e4),g=function(){return!1},f=function(){return null};function h(ae,ee){if(!ae)return f;let oe;typeof ae!="string"?oe=ae.pattern:oe=ae,oe=oe.trim();const ie=`${oe}_${!!ee.trimForExclusions}`;let ue=c.get(ie);if(ue)return _(ue,ae);let Z;return d.test(oe)?ue=w(oe.substr(4),oe):(Z=l.exec(y(oe,ee)))?ue=P(Z[1],oe):(ee.trimForExclusions?n:i).test(oe)?ue=R(oe,ee):(Z=t.exec(y(oe,ee)))?ue=p(Z[1].substr(1),oe,!0):(Z=o.exec(y(oe,ee)))?ue=p(Z[1],oe,!1):ue=b(oe),c.set(ie,ue),_(ue,ae)}function _(ae,ee){if(typeof ee=="string")return ae;const oe=function(ie,ue){return(0,O.isEqualOrParent)(ie,ee.base,!m.isLinux)?ae((0,s.ltrim)(ie.substr(ee.base.length),A.sep),ue):null};return oe.allBasenames=ae.allBasenames,oe.allPaths=ae.allPaths,oe.basenames=ae.basenames,oe.patterns=ae.patterns,oe}function y(ae,ee){return ee.trimForExclusions&&ae.endsWith("/**")?ae.substr(0,ae.length-2):ae}function w(ae,ee){return function(oe,ie){return typeof oe=="string"&&oe.endsWith(ae)?ee:null}}function P(ae,ee){const oe=`/${ae}`,ie=`\\${ae}`,ue=function(ve,Ie){return typeof ve!="string"?null:Ie?Ie===ae?ee:null:ve===ae||ve.endsWith(oe)||ve.endsWith(ie)?ee:null},Z=[ae];return ue.basenames=Z,ue.patterns=[ee],ue.allBasenames=Z,ue}function R(ae,ee){const oe=G(ae.slice(1,-1).split(",").map(Ie=>h(Ie,ee)).filter(Ie=>Ie!==f),ae),ie=oe.length;if(!ie)return f;if(ie===1)return oe[0];const ue=function(Ie,X){for(let V=0,re=oe.length;V<re;V++)if(oe[V](Ie,X))return ae;return null},Z=oe.find(Ie=>!!Ie.allBasenames);Z&&(ue.allBasenames=Z.allBasenames);const ve=oe.reduce((Ie,X)=>X.allPaths?Ie.concat(X.allPaths):Ie,[]);return ve.length&&(ue.allPaths=ve),ue}function p(ae,ee,oe){const ie=A.sep===A.posix.sep,ue=ie?ae:ae.replace(C,A.sep),Z=A.sep+ue,ve=A.posix.sep+ae;let Ie;return oe?Ie=function(X,V){return typeof X=="string"&&(X===ue||X.endsWith(Z)||!ie&&(X===ae||X.endsWith(ve)))?ee:null}:Ie=function(X,V){return typeof X=="string"&&(X===ue||!ie&&X===ae)?ee:null},Ie.allPaths=[(oe?"*/":"./")+ae],Ie}function b(ae){try{const ee=new RegExp(`^${a(ae)}$`);return function(oe){return ee.lastIndex=0,typeof oe=="string"&&ee.test(oe)?ae:null}}catch{return f}}function N(ae,ee,oe){return!ae||typeof ee!="string"?!1:L(ae)(ee,void 0,oe)}function L(ae,ee={}){if(!ae)return g;if(typeof ae=="string"||F(ae)){const oe=h(ae,ee);if(oe===f)return g;const ie=function(ue,Z){return!!oe(ue,Z)};return oe.allBasenames&&(ie.allBasenames=oe.allBasenames),oe.allPaths&&(ie.allPaths=oe.allPaths),ie}return $(ae,ee)}function F(ae){const ee=ae;return ee?typeof ee.base=="string"&&typeof ee.pattern=="string":!1}function K(ae){return ae.allBasenames||[]}function J(ae){return ae.allPaths||[]}function $(ae,ee){const oe=G(Object.getOwnPropertyNames(ae).map(Ie=>x(Ie,ae[Ie],ee)).filter(Ie=>Ie!==f)),ie=oe.length;if(!ie)return f;if(!oe.some(Ie=>!!Ie.requiresSiblings)){if(ie===1)return oe[0];const Ie=function(re,be){let De;for(let Fe=0,ze=oe.length;Fe<ze;Fe++){const Je=oe[Fe](re,be);if(typeof Je=="string")return Je;(0,T.isThenable)(Je)&&(De||(De=[]),De.push(Je))}return De?(async()=>{for(const Fe of De){const ze=await Fe;if(typeof ze=="string")return ze}return null})():null},X=oe.find(re=>!!re.allBasenames);X&&(Ie.allBasenames=X.allBasenames);const V=oe.reduce((re,be)=>be.allPaths?re.concat(be.allPaths):re,[]);return V.length&&(Ie.allPaths=V),Ie}const ue=function(Ie,X,V){let re,be;for(let De=0,Fe=oe.length;De<Fe;De++){const ze=oe[De];ze.requiresSiblings&&V&&(X||(X=(0,A.basename)(Ie)),re||(re=X.substr(0,X.length-(0,A.extname)(Ie).length)));const Je=ze(Ie,X,re,V);if(typeof Je=="string")return Je;(0,T.isThenable)(Je)&&(be||(be=[]),be.push(Je))}return be?(async()=>{for(const De of be){const Fe=await De;if(typeof Fe=="string")return Fe}return null})():null},Z=oe.find(Ie=>!!Ie.allBasenames);Z&&(ue.allBasenames=Z.allBasenames);const ve=oe.reduce((Ie,X)=>X.allPaths?Ie.concat(X.allPaths):Ie,[]);return ve.length&&(ue.allPaths=ve),ue}function x(ae,ee,oe){if(ee===!1)return f;const ie=h(ae,oe);if(ie===f)return f;if(typeof ee=="boolean")return ie;if(ee){const ue=ee.when;if(typeof ue=="string"){const Z=(ve,Ie,X,V)=>{if(!V||!ie(ve,Ie))return null;const re=ue.replace("$(basename)",()=>X),be=V(re);return(0,T.isThenable)(be)?be.then(De=>De?ae:null):be?ae:null};return Z.requiresSiblings=!0,Z}}return ie}function G(ae,ee){const oe=ae.filter(Ie=>!!Ie.basenames);if(oe.length<2)return ae;const ie=oe.reduce((Ie,X)=>{const V=X.basenames;return V?Ie.concat(V):Ie},[]);let ue;if(ee){ue=[];for(let Ie=0,X=ie.length;Ie<X;Ie++)ue.push(ee)}else ue=oe.reduce((Ie,X)=>{const V=X.patterns;return V?Ie.concat(V):Ie},[]);const Z=function(Ie,X){if(typeof Ie!="string")return null;if(!X){let re;for(re=Ie.length;re>0;re--){const be=Ie.charCodeAt(re-1);if(be===D.CharCode.Slash||be===D.CharCode.Backslash)break}X=Ie.substr(re)}const V=ie.indexOf(X);return V!==-1?ue[V]:null};Z.basenames=ie,Z.patterns=ue,Z.allBasenames=ie;const ve=ae.filter(Ie=>!Ie.basenames);return ve.push(Z),ve}function Y(ae,ee){return(0,S.equals)(ae,ee,(oe,ie)=>typeof oe=="string"&&typeof ie=="string"?oe===ie:typeof oe!="string"&&typeof ie!="string"?oe.base===ie.base&&oe.pattern===ie.pattern:!1)}}),define(ke[59],Re([1,0,12,99,24,13,2]),function(Ee,e,S,T,D,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0,e.isEmptyMarkdownString=s,e.isMarkdownString=I,e.markdownStringEqual=E,e.escapeMarkdownSyntaxTokens=u,e.appendEscapedMarkdownCodeBlockFence=C,e.escapeDoubleQuotes=v,e.removeMarkdownEscapes=r,e.parseHrefAndDimensions=a;var A;(function(d){d[d.Paragraph=0]="Paragraph",d[d.Break=1]="Break"})(A||(e.MarkdownStringTextNewlineStyle=A={}));class m{constructor(l="",i=!1){if(this.value=l,typeof this.value!="string")throw(0,S.illegalArgument)("value");typeof i=="boolean"?(this.isTrusted=i,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=i.isTrusted??void 0,this.supportThemeIcons=i.supportThemeIcons??!1,this.supportHtml=i.supportHtml??!1)}appendText(l,i=A.Paragraph){return this.value+=u(this.supportThemeIcons?(0,T.escapeIcons)(l):l).replace(/([ \t]+)/g,(n,t)=>"&nbsp;".repeat(t.length)).replace(/\>/gm,"\\>").replace(/\n/g,i===A.Break?`\\
`:`

`),this}appendMarkdown(l){return this.value+=l,this}appendCodeblock(l,i){return this.value+=`
${C(i,l)}
`,this}appendLink(l,i,n){return this.value+="[",this.value+=this._escape(i,"]"),this.value+="](",this.value+=this._escape(String(l),")"),n&&(this.value+=` "${this._escape(this._escape(n,'"'),")")}"`),this.value+=")",this}_escape(l,i){const n=new RegExp((0,O.escapeRegExpCharacters)(i),"g");return l.replace(n,(t,o)=>l.charAt(o-1)!=="\\"?`\\${t}`:t)}}e.MarkdownString=m;function s(d){return I(d)?!d.value:Array.isArray(d)?d.every(s):!0}function I(d){return d instanceof m?!0:d&&typeof d=="object"?typeof d.value=="string"&&(typeof d.isTrusted=="boolean"||typeof d.isTrusted=="object"||d.isTrusted===void 0)&&(typeof d.supportThemeIcons=="boolean"||d.supportThemeIcons===void 0):!1}function E(d,l){return d===l?!0:!d||!l?!1:d.value===l.value&&d.isTrusted===l.isTrusted&&d.supportThemeIcons===l.supportThemeIcons&&d.supportHtml===l.supportHtml&&(d.baseUri===l.baseUri||!!d.baseUri&&!!l.baseUri&&(0,D.isEqual)(k.URI.from(d.baseUri),k.URI.from(l.baseUri)))}function u(d){return d.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}function C(d,l){const i=d.match(/^`+/gm)?.reduce((t,o)=>t.length>o.length?t:o).length??0,n=i>=3?i+1:3;return[`${"`".repeat(n)}${l}`,d,`${"`".repeat(n)}`].join(`
`)}function v(d){return d.replace(/"/g,"&quot;")}function r(d){return d&&d.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}function a(d){const l=[],i=d.split("|").map(t=>t.trim());d=i[0];const n=i[1];if(n){const t=/height=(\d+)/.exec(n),o=/width=(\d+)/.exec(n),c=t?t[1]:"",g=o?o[1]:"",f=isFinite(parseInt(g)),h=isFinite(parseInt(c));f&&l.push(`width="${g}"`),h&&l.push(`height="${c}"`)}return{href:d,dimensions:l}}}),define(ke[103],Re([1,0,17,73,22,23,24,13]),function(Ee,e,S,T,D,O,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathLabel=m,e.normalizeDriveLetter=I,e.tildify=u,e.untildify=C,e.shorten=d,e.template=i,e.mnemonicMenuLabel=n,e.mnemonicButtonLabel=t,e.unmnemonicLabel=o,e.splitRecentLabel=c;function m(f,h){const{os:_,tildify:y,relative:w}=h;if(w){const p=s(f,w,_);if(typeof p=="string")return p}let P=f.fsPath;if(_===O.OperatingSystem.Windows&&!O.isWindows?P=P.replace(/\//g,"\\"):_!==O.OperatingSystem.Windows&&O.isWindows&&(P=P.replace(/\\/g,"/")),_!==O.OperatingSystem.Windows&&y?.userHome){const p=y.userHome.fsPath;let b;f.scheme!==y.userHome.scheme&&f.path[0]===D.posix.sep&&f.path[1]!==D.posix.sep?b=y.userHome.with({path:f.path}).fsPath:b=P,P=u(b,p,_)}return(_===O.OperatingSystem.Windows?D.win32:D.posix).normalize(I(P,_===O.OperatingSystem.Windows))}function s(f,h,_){const y=_===O.OperatingSystem.Windows?D.win32:D.posix,w=_===O.OperatingSystem.Linux?k.extUri:k.extUriIgnorePathCase,P=h.getWorkspace(),R=(0,S.firstOrDefault)(P.folders);if(!R)return;f.scheme!==R.uri.scheme&&f.path[0]===D.posix.sep&&f.path[1]!==D.posix.sep&&(f=R.uri.with({path:f.path}));const p=h.getWorkspaceFolder(f);if(!p)return;let b;if(w.isEqual(p.uri,f)?b="":b=w.relativePath(p.uri,f)??"",b&&(b=y.normalize(b)),P.folders.length>1&&!h.noPrefix){const N=p.name?p.name:w.basenameOrAuthority(p.uri);b=b?`${N} \u2022 ${b}`:N}return b}function I(f,h=O.isWindows){return(0,T.hasDriveLetter)(f,h)?f.charAt(0).toUpperCase()+f.slice(1):f}let E=Object.create(null);function u(f,h,_=O.OS){if(_===O.OperatingSystem.Windows||!f||!h)return f;let y=E.original===h?E.normalized:void 0;y||(y=h,O.isWindows&&(y=(0,T.toSlashes)(y)),y=`${(0,A.rtrim)(y,D.posix.sep)}${D.posix.sep}`,E={original:h,normalized:y});let w=f;return O.isWindows&&(w=(0,T.toSlashes)(w)),(_===O.OperatingSystem.Linux?w.startsWith(y):(0,A.startsWithIgnoreCase)(w,y))?`~/${w.substr(y.length)}`:f}function C(f,h){return f.replace(/^~($|\/|\\)/,`${h}$1`)}const v="\u2026",r="\\\\",a="~";function d(f,h=D.sep){const _=new Array(f.length);let y=!1;for(let w=0;w<f.length;w++){const P=f[w];if(P===""){_[w]=`.${h}`;continue}if(!P){_[w]=P;continue}y=!0;let R="",p=P;p.indexOf(r)===0?(R=p.substr(0,p.indexOf(r)+r.length),p=p.substr(p.indexOf(r)+r.length)):p.indexOf(h)===0?(R=p.substr(0,p.indexOf(h)+h.length),p=p.substr(p.indexOf(h)+h.length)):p.indexOf(a)===0&&(R=p.substr(0,p.indexOf(a)+a.length),p=p.substr(p.indexOf(a)+a.length));const b=p.split(h);for(let N=1;y&&N<=b.length;N++)for(let L=b.length-N;y&&L>=0;L--){y=!1;let F=b.slice(L,L+N).join(h);for(let K=0;!y&&K<f.length;K++)if(K!==w&&f[K]&&f[K].indexOf(F)>-1){const J=L+N===b.length,$=L>0&&f[K].indexOf(h)>-1?h+F:F,x=f[K].endsWith($);y=!J||x}if(!y){let K="";(b[0].endsWith(":")||R!=="")&&(L===1&&(L=0,N++,F=b[0]+h+F),L>0&&(K=b[0]+h),K=R+K),L>0&&(K=K+v+h),K=K+F,L+N<b.length&&(K=K+h+v),_[w]=K}}y&&(_[w]=P)}return _}var l;(function(f){f[f.TEXT=0]="TEXT",f[f.VARIABLE=1]="VARIABLE",f[f.SEPARATOR=2]="SEPARATOR"})(l||(l={}));function i(f,h=Object.create(null)){const _=[];let y=!1,w="";for(const P of f)if(P==="$"||y&&P==="{")w&&_.push({value:w,type:l.TEXT}),w="",y=!0;else if(P==="}"&&y){const R=h[w];if(typeof R=="string")R.length&&_.push({value:R,type:l.VARIABLE});else if(R){const p=_[_.length-1];(!p||p.type!==l.SEPARATOR)&&_.push({value:R.label,type:l.SEPARATOR})}w="",y=!1}else w+=P;return w&&!y&&_.push({value:w,type:l.TEXT}),_.filter((P,R)=>{if(P.type===l.SEPARATOR){const p=_[R-1],b=_[R+1];return[p,b].every(N=>N&&(N.type===l.VARIABLE||N.type===l.TEXT)&&N.value.length>0)}return!0}).map(P=>P.value).join("")}function n(f,h){return O.isMacintosh||h?f.replace(/\(&&\w\)|&&/g,"").replace(/&/g,O.isMacintosh?"&":"&&"):f.replace(/&&|&/g,_=>_==="&"?"&&":"&")}function t(f,h){return O.isMacintosh||h?f.replace(/\(&&\w\)|&&/g,""):O.isWindows?f.replace(/&&|&/g,_=>_==="&"?"&&":"&"):f.replace(/&&/g,"_")}function o(f){return f.replace(/&/g,"&&")}function c(f){if(f.endsWith("]")){const h=f.lastIndexOf(" [",f.length-2);if(h!==-1){const _=g(f.substring(0,h)),y=f.substring(h);return{name:_.name+y,parentPath:_.parentPath}}}return g(f)}function g(f){const h=f.indexOf("/")!==-1?D.posix:D.win32,_=h.basename(f),y=h.dirname(f);return _.length?{name:_,parentPath:y}:{name:y,parentPath:""}}}),define(ke[160],Re([1,0,20,38,2]),function(Ee,e,S,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DefaultURITransformer=e.URITransformer=void 0,e.transformOutgoingURIs=m,e.transformIncomingURIs=I,e.transformAndReviveIncomingURIs=E;function O(u){return u.toJSON()}class k{constructor(C){this._uriTransformer=C}transformIncoming(C){const v=this._uriTransformer.transformIncoming(C);return v===C?C:O(D.URI.from(v))}transformOutgoing(C){const v=this._uriTransformer.transformOutgoing(C);return v===C?C:O(D.URI.from(v))}transformOutgoingURI(C){const v=this._uriTransformer.transformOutgoing(C);return v===C?C:D.URI.from(v)}transformOutgoingScheme(C){return this._uriTransformer.transformOutgoingScheme(C)}}e.URITransformer=k,e.DefaultURITransformer=new class{transformIncoming(u){return u}transformOutgoing(u){return u}transformOutgoingURI(u){return u}transformOutgoingScheme(u){return u}};function A(u,C,v){if(!u||v>200)return null;if(typeof u=="object"){if(u instanceof D.URI)return C.transformOutgoing(u);for(const r in u)if(Object.hasOwnProperty.call(u,r)){const a=A(u[r],C,v+1);a!==null&&(u[r]=a)}}return null}function m(u,C){const v=A(u,C,0);return v===null?u:v}function s(u,C,v,r){if(!u||r>200)return null;if(typeof u=="object"){if(u.$mid===T.MarshalledId.Uri)return v?D.URI.revive(C.transformIncoming(u)):C.transformIncoming(u);if(u instanceof S.VSBuffer)return null;for(const a in u)if(Object.hasOwnProperty.call(u,a)){const d=s(u[a],C,v,r+1);d!==null&&(u[a]=d)}}return null}function I(u,C){const v=s(u,C,!1,0);return v===null?u:v}function E(u,C){const v=s(u,C,!0,0);return v===null?u:v}}),define(ke[161],Re([1,0,10,6,4,34,14]),function(Ee,e,S,T,D,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.StorageHint=void 0,e.isStorageItemsChangeEvent=m;var A;(function(u){u[u.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",u[u.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(A||(e.StorageHint=A={}));function m(u){const C=u;return C?.changed instanceof Map||C?.deleted instanceof Set}var s;(function(u){u[u.None=0]="None",u[u.Initialized=1]="Initialized",u[u.Closed=2]="Closed"})(s||(e.StorageState=s={}));class I extends D.Disposable{static{this.DEFAULT_FLUSH_DELAY=100}constructor(C,v=Object.create(null)){super(),this.database=C,this.options=v,this._onDidChangeStorage=this._register(new T.PauseableEmitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=s.None,this.cache=new Map,this.flushDelayer=this._register(new S.ThrottledDelayer(I.DEFAULT_FLUSH_DELAY)),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(C=>this.onDidChangeItemsExternal(C)))}onDidChangeItemsExternal(C){this._onDidChangeStorage.pause();try{C.changed?.forEach((v,r)=>this.acceptExternal(r,v)),C.deleted?.forEach(v=>this.acceptExternal(v,void 0))}finally{this._onDidChangeStorage.resume()}}acceptExternal(C,v){if(this.state===s.Closed)return;let r=!1;(0,k.isUndefinedOrNull)(v)?r=this.cache.delete(C):this.cache.get(C)!==v&&(this.cache.set(C,v),r=!0),r&&this._onDidChangeStorage.fire({key:C,external:!0})}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===s.None&&(this.state=s.Initialized,this.options.hint!==A.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(C,v){const r=this.cache.get(C);return(0,k.isUndefinedOrNull)(r)?v:r}getBoolean(C,v){const r=this.get(C);return(0,k.isUndefinedOrNull)(r)?v:r==="true"}getNumber(C,v){const r=this.get(C);return(0,k.isUndefinedOrNull)(r)?v:parseInt(r,10)}getObject(C,v){const r=this.get(C);return(0,k.isUndefinedOrNull)(r)?v:(0,O.parse)(r)}async set(C,v,r=!1){if(this.state===s.Closed)return;if((0,k.isUndefinedOrNull)(v))return this.delete(C,r);const a=(0,k.isObject)(v)||Array.isArray(v)?(0,O.stringify)(v):String(v);if(this.cache.get(C)!==a)return this.cache.set(C,a),this.pendingInserts.set(C,a),this.pendingDeletes.delete(C),this._onDidChangeStorage.fire({key:C,external:r}),this.doFlush()}async delete(C,v=!1){if(!(this.state===s.Closed||!this.cache.delete(C)))return this.pendingDeletes.has(C)||this.pendingDeletes.add(C),this.pendingInserts.delete(C),this._onDidChangeStorage.fire({key:C,external:v}),this.doFlush()}async optimize(){if(this.state!==s.Closed)return await this.flush(0),this.database.optimize()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=s.Closed;try{await this.doFlush(0)}catch{}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const C={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(C).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(C){if(!(this.state===s.Closed||this.pendingClose))return this.doFlush(C)}async doFlush(C){return this.options.hint===A.STORAGE_IN_MEMORY?this.flushPending():this.flushDelayer.trigger(()=>this.flushPending(),C)}async whenFlushed(){if(this.hasPending)return new Promise(C=>this.whenFlushedCallbacks.push(C))}isInMemory(){return this.options.hint===A.STORAGE_IN_MEMORY}}e.Storage=I;class E{constructor(){this.onDidChangeItemsExternal=T.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(C){C.insert?.forEach((v,r)=>this.items.set(r,v)),C.delete?.forEach(v=>this.items.delete(v))}async optimize(){}async close(){}}e.InMemoryStorageDatabase=E}),define(ke[162],Re([1,0,13,23,20]),function(Ee,e,S,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringBuilder=void 0,e.getPlatformTextDecoder=I,e.decodeUTF16LE=E,S=Ve(S),T=Ve(T),D=Ve(D);let O;function k(){return O||(O=new TextDecoder("UTF-16LE")),O}let A;function m(){return A||(A=new TextDecoder("UTF-16BE")),A}let s;function I(){return s||(s=T.isLittleEndian()?k():m()),s}function E(v,r,a){const d=new Uint16Array(v.buffer,r,a);return a>0&&(d[0]===65279||d[0]===65534)?u(v,r,a):k().decode(d)}function u(v,r,a){const d=[];let l=0;for(let i=0;i<a;i++){const n=D.readUInt16LE(v,r);r+=2,d[l++]=String.fromCharCode(n)}return d.join("")}class C{constructor(r){this._capacity=r|0,this._buffer=new Uint16Array(this._capacity),this._completedStrings=null,this._bufferLength=0}reset(){this._completedStrings=null,this._bufferLength=0}build(){return this._completedStrings!==null?(this._flushBuffer(),this._completedStrings.join("")):this._buildBuffer()}_buildBuffer(){if(this._bufferLength===0)return"";const r=new Uint16Array(this._buffer.buffer,0,this._bufferLength);return I().decode(r)}_flushBuffer(){const r=this._buildBuffer();this._bufferLength=0,this._completedStrings===null?this._completedStrings=[r]:this._completedStrings[this._completedStrings.length]=r}appendCharCode(r){const a=this._capacity-this._bufferLength;a<=1&&(a===0||S.isHighSurrogate(r))&&this._flushBuffer(),this._buffer[this._bufferLength++]=r}appendASCIICharCode(r){this._bufferLength===this._capacity&&this._flushBuffer(),this._buffer[this._bufferLength++]=r}appendString(r){const a=r.length;if(this._bufferLength+a>=this._capacity){this._flushBuffer(),this._completedStrings[this._completedStrings.length]=r;return}for(let d=0;d<a;d++)this._buffer[this._bufferLength++]=r.charCodeAt(d)}}e.StringBuilder=C}),define(ke[163],Re([1,0,20,162]),function(Ee,e,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextChange=void 0,e.compressConsecutiveTextChanges=k,S=Ve(S);function D(m){return m.replace(/\n/g,"\\n").replace(/\r/g,"\\r")}class O{get oldLength(){return this.oldText.length}get oldEnd(){return this.oldPosition+this.oldText.length}get newLength(){return this.newText.length}get newEnd(){return this.newPosition+this.newText.length}constructor(s,I,E,u){this.oldPosition=s,this.oldText=I,this.newPosition=E,this.newText=u}toString(){return this.oldText.length===0?`(insert@${this.oldPosition} "${D(this.newText)}")`:this.newText.length===0?`(delete@${this.oldPosition} "${D(this.oldText)}")`:`(replace@${this.oldPosition} "${D(this.oldText)}" with "${D(this.newText)}")`}static _writeStringSize(s){return 4+2*s.length}static _writeString(s,I,E){const u=I.length;S.writeUInt32BE(s,u,E),E+=4;for(let C=0;C<u;C++)S.writeUInt16LE(s,I.charCodeAt(C),E),E+=2;return E}static _readString(s,I){const E=S.readUInt32BE(s,I);return I+=4,(0,T.decodeUTF16LE)(s,I,E)}writeSize(){return 8+O._writeStringSize(this.oldText)+O._writeStringSize(this.newText)}write(s,I){return S.writeUInt32BE(s,this.oldPosition,I),I+=4,S.writeUInt32BE(s,this.newPosition,I),I+=4,I=O._writeString(s,this.oldText,I),I=O._writeString(s,this.newText,I),I}static read(s,I,E){const u=S.readUInt32BE(s,I);I+=4;const C=S.readUInt32BE(s,I);I+=4;const v=O._readString(s,I);I+=O._writeStringSize(v);const r=O._readString(s,I);return I+=O._writeStringSize(r),E.push(new O(u,v,C,r)),I}}e.TextChange=O;function k(m,s){return m===null||m.length===0?s:new A(m,s).compress()}class A{constructor(s,I){this._prevEdits=s,this._currEdits=I,this._result=[],this._resultLen=0,this._prevLen=this._prevEdits.length,this._prevDeltaOffset=0,this._currLen=this._currEdits.length,this._currDeltaOffset=0}compress(){let s=0,I=0,E=this._getPrev(s),u=this._getCurr(I);for(;s<this._prevLen||I<this._currLen;){if(E===null){this._acceptCurr(u),u=this._getCurr(++I);continue}if(u===null){this._acceptPrev(E),E=this._getPrev(++s);continue}if(u.oldEnd<=E.newPosition){this._acceptCurr(u),u=this._getCurr(++I);continue}if(E.newEnd<=u.oldPosition){this._acceptPrev(E),E=this._getPrev(++s);continue}if(u.oldPosition<E.newPosition){const[d,l]=A._splitCurr(u,E.newPosition-u.oldPosition);this._acceptCurr(d),u=l;continue}if(E.newPosition<u.oldPosition){const[d,l]=A._splitPrev(E,u.oldPosition-E.newPosition);this._acceptPrev(d),E=l;continue}let r,a;if(u.oldEnd===E.newEnd)r=E,a=u,E=this._getPrev(++s),u=this._getCurr(++I);else if(u.oldEnd<E.newEnd){const[d,l]=A._splitPrev(E,u.oldLength);r=d,a=u,E=l,u=this._getCurr(++I)}else{const[d,l]=A._splitCurr(u,E.newLength);r=E,a=d,E=this._getPrev(++s),u=l}this._result[this._resultLen++]=new O(r.oldPosition,r.oldText,a.newPosition,a.newText),this._prevDeltaOffset+=r.newLength-r.oldLength,this._currDeltaOffset+=a.newLength-a.oldLength}const C=A._merge(this._result);return A._removeNoOps(C)}_acceptCurr(s){this._result[this._resultLen++]=A._rebaseCurr(this._prevDeltaOffset,s),this._currDeltaOffset+=s.newLength-s.oldLength}_getCurr(s){return s<this._currLen?this._currEdits[s]:null}_acceptPrev(s){this._result[this._resultLen++]=A._rebasePrev(this._currDeltaOffset,s),this._prevDeltaOffset+=s.newLength-s.oldLength}_getPrev(s){return s<this._prevLen?this._prevEdits[s]:null}static _rebaseCurr(s,I){return new O(I.oldPosition-s,I.oldText,I.newPosition,I.newText)}static _rebasePrev(s,I){return new O(I.oldPosition,I.oldText,I.newPosition+s,I.newText)}static _splitPrev(s,I){const E=s.newText.substr(0,I),u=s.newText.substr(I);return[new O(s.oldPosition,s.oldText,s.newPosition,E),new O(s.oldEnd,"",s.newPosition+I,u)]}static _splitCurr(s,I){const E=s.oldText.substr(0,I),u=s.oldText.substr(I);return[new O(s.oldPosition,E,s.newPosition,s.newText),new O(s.oldPosition+I,u,s.newEnd,"")]}static _merge(s){if(s.length===0)return s;const I=[];let E=0,u=s[0];for(let C=1;C<s.length;C++){const v=s[C];u.oldEnd===v.oldPosition?u=new O(u.oldPosition,u.oldText+v.oldText,u.newPosition,u.newText+v.newText):(I[E++]=u,u=v)}return I[E++]=u,I}static _removeNoOps(s){if(s.length===0)return s;const I=[];let E=0;for(let u=0;u<s.length;u++){const C=s[u];C.oldText!==C.newText&&(I[E++]=C)}return I}}}),define(ke[164],Re([1,0,43,22]),function(Ee,e,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=D,e.targetsNotebooks=O;function D(k,A,m,s,I,E){if(Array.isArray(k)){let u=0;for(const C of k){const v=D(C,A,m,s,I,E);if(v===10)return v;v>u&&(u=v)}return u}else{if(typeof k=="string")return s?k==="*"?5:k===m?10:0:0;if(k){const{language:u,pattern:C,scheme:v,hasAccessToAllModels:r,notebookType:a}=k;if(!s&&!r)return 0;a&&I&&(A=I);let d=0;if(v)if(v===A.scheme)d=10;else if(v==="*")d=5;else return 0;if(u)if(u===m)d=10;else if(u==="*")d=Math.max(d,5);else return 0;if(a)if(a===E)d=10;else if(a==="*"&&E!==void 0)d=Math.max(d,5);else return 0;if(C){let l;if(typeof C=="string"?l=C:l={...C,base:(0,T.normalize)(C.base)},l===A.fsPath||(0,S.match)(l,A.fsPath))d=10;else return 0}return d}else return 0}}function O(k){return typeof k=="string"?!1:Array.isArray(k)?k.some(O):!!k.notebookType}}),define(ke[165],Re([1,0,6,13,32,52,100,151,163,4]),function(Ee,e,S,T,D,O,k,A,m,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PieceTreeTextBuffer=void 0,T=Ve(T);class I extends s.Disposable{constructor(u,C,v,r,a,d,l){super(),this._onDidChangeContent=this._register(new S.Emitter),this.onDidChangeContent=this._onDidChangeContent.event,this._BOM=C,this._mightContainNonBasicASCII=!d,this._mightContainRTL=r,this._mightContainUnusualLineTerminators=a,this._pieceTree=new k.PieceTreeBase(u,v,l)}equals(u){return!(u instanceof I)||this._BOM!==u._BOM||this.getEOL()!==u.getEOL()?!1:this._pieceTree.equal(u._pieceTree)}mightContainRTL(){return this._mightContainRTL}mightContainUnusualLineTerminators(){return this._mightContainUnusualLineTerminators}resetMightContainUnusualLineTerminators(){this._mightContainUnusualLineTerminators=!1}mightContainNonBasicASCII(){return this._mightContainNonBasicASCII}getBOM(){return this._BOM}getEOL(){return this._pieceTree.getEOL()}createSnapshot(u){return this._pieceTree.createSnapshot(u?this._BOM:"")}getOffsetAt(u,C){return this._pieceTree.getOffsetAt(u,C)}getPositionAt(u){return this._pieceTree.getPositionAt(u)}getRangeAt(u,C){const v=u+C,r=this.getPositionAt(u),a=this.getPositionAt(v);return new D.Range(r.lineNumber,r.column,a.lineNumber,a.column)}getValueInRange(u,C=O.EndOfLinePreference.TextDefined){if(u.isEmpty())return"";const v=this._getEndOfLine(C);return this._pieceTree.getValueInRange(u,v)}getValueLengthInRange(u,C=O.EndOfLinePreference.TextDefined){if(u.isEmpty())return 0;if(u.startLineNumber===u.endLineNumber)return u.endColumn-u.startColumn;const v=this.getOffsetAt(u.startLineNumber,u.startColumn),r=this.getOffsetAt(u.endLineNumber,u.endColumn);let a=0;const d=this._getEndOfLine(C),l=this.getEOL();if(d.length!==l.length){const i=d.length-l.length,n=u.endLineNumber-u.startLineNumber;a=i*n}return r-v+a}getCharacterCountInRange(u,C=O.EndOfLinePreference.TextDefined){if(this._mightContainNonBasicASCII){let v=0;const r=u.startLineNumber,a=u.endLineNumber;for(let d=r;d<=a;d++){const l=this.getLineContent(d),i=d===r?u.startColumn-1:0,n=d===a?u.endColumn-1:l.length;for(let t=i;t<n;t++)T.isHighSurrogate(l.charCodeAt(t))?(v=v+1,t=t+1):v=v+1}return v+=this._getEndOfLine(C).length*(a-r),v}return this.getValueLengthInRange(u,C)}getNearestChunk(u){return this._pieceTree.getNearestChunk(u)}getLength(){return this._pieceTree.getLength()}getLineCount(){return this._pieceTree.getLineCount()}getLinesContent(){return this._pieceTree.getLinesContent()}getLineContent(u){return this._pieceTree.getLineContent(u)}getLineCharCode(u,C){return this._pieceTree.getLineCharCode(u,C)}getCharCode(u){return this._pieceTree.getCharCode(u)}getLineLength(u){return this._pieceTree.getLineLength(u)}getLineMinColumn(u){return 1}getLineMaxColumn(u){return this.getLineLength(u)+1}getLineFirstNonWhitespaceColumn(u){const C=T.firstNonWhitespaceIndex(this.getLineContent(u));return C===-1?0:C+1}getLineLastNonWhitespaceColumn(u){const C=T.lastNonWhitespaceIndex(this.getLineContent(u));return C===-1?0:C+2}_getEndOfLine(u){switch(u){case O.EndOfLinePreference.LF:return`
`;case O.EndOfLinePreference.CRLF:return`\r
`;case O.EndOfLinePreference.TextDefined:return this.getEOL();default:throw new Error("Unknown EOL preference")}}setEOL(u){this._pieceTree.setEOL(u)}applyEdits(u,C,v){let r=this._mightContainRTL,a=this._mightContainUnusualLineTerminators,d=this._mightContainNonBasicASCII,l=!0,i=[];for(let h=0;h<u.length;h++){const _=u[h];l&&_._isTracked&&(l=!1);const y=_.range;if(_.text){let b=!0;d||(b=!T.isBasicASCII(_.text),d=b),!r&&b&&(r=T.containsRTL(_.text)),!a&&b&&(a=T.containsUnusualLineTerminators(_.text))}let w="",P=0,R=0,p=0;if(_.text){let b;[P,R,p,b]=(0,A.countEOL)(_.text);const N=this.getEOL(),L=N===`\r
`?A.StringEOL.CRLF:A.StringEOL.LF;b===A.StringEOL.Unknown||b===L?w=_.text:w=_.text.replace(/\r\n|\r|\n/g,N)}i[h]={sortIndex:h,identifier:_.identifier||null,range:y,rangeOffset:this.getOffsetAt(y.startLineNumber,y.startColumn),rangeLength:this.getValueLengthInRange(y),text:w,eolCount:P,firstLineLength:R,lastLineLength:p,forceMoveMarkers:!!_.forceMoveMarkers,isAutoWhitespaceEdit:_.isAutoWhitespaceEdit||!1}}i.sort(I._sortOpsAscending);let n=!1;for(let h=0,_=i.length-1;h<_;h++){const y=i[h].range.getEndPosition(),w=i[h+1].range.getStartPosition();if(w.isBeforeOrEqual(y)){if(w.isBefore(y))throw new Error("Overlapping ranges are not allowed!");n=!0}}l&&(i=this._reduceOperations(i));const t=v||C?I._getInverseEditRanges(i):[],o=[];if(C)for(let h=0;h<i.length;h++){const _=i[h],y=t[h];if(_.isAutoWhitespaceEdit&&_.range.isEmpty())for(let w=y.startLineNumber;w<=y.endLineNumber;w++){let P="";w===y.startLineNumber&&(P=this.getLineContent(_.range.startLineNumber),T.firstNonWhitespaceIndex(P)!==-1)||o.push({lineNumber:w,oldContent:P})}}let c=null;if(v){let h=0;c=[];for(let _=0;_<i.length;_++){const y=i[_],w=t[_],P=this.getValueInRange(y.range),R=y.rangeOffset+h;h+=y.text.length-P.length,c[_]={sortIndex:y.sortIndex,identifier:y.identifier,range:w,text:P,textChange:new m.TextChange(y.rangeOffset,P,R,y.text)}}n||c.sort((_,y)=>_.sortIndex-y.sortIndex)}this._mightContainRTL=r,this._mightContainUnusualLineTerminators=a,this._mightContainNonBasicASCII=d;const g=this._doApplyEdits(i);let f=null;if(C&&o.length>0){o.sort((h,_)=>_.lineNumber-h.lineNumber),f=[];for(let h=0,_=o.length;h<_;h++){const y=o[h].lineNumber;if(h>0&&o[h-1].lineNumber===y)continue;const w=o[h].oldContent,P=this.getLineContent(y);P.length===0||P===w||T.firstNonWhitespaceIndex(P)!==-1||f.push(y)}}return this._onDidChangeContent.fire(),new O.ApplyEditsResult(c,g,f)}_reduceOperations(u){return u.length<1e3?u:[this._toSingleEditOperation(u)]}_toSingleEditOperation(u){let C=!1;const v=u[0].range,r=u[u.length-1].range,a=new D.Range(v.startLineNumber,v.startColumn,r.endLineNumber,r.endColumn);let d=v.startLineNumber,l=v.startColumn;const i=[];for(let g=0,f=u.length;g<f;g++){const h=u[g],_=h.range;C=C||h.forceMoveMarkers,i.push(this.getValueInRange(new D.Range(d,l,_.startLineNumber,_.startColumn))),h.text.length>0&&i.push(h.text),d=_.endLineNumber,l=_.endColumn}const n=i.join(""),[t,o,c]=(0,A.countEOL)(n);return{sortIndex:0,identifier:u[0].identifier,range:a,rangeOffset:this.getOffsetAt(a.startLineNumber,a.startColumn),rangeLength:this.getValueLengthInRange(a,O.EndOfLinePreference.TextDefined),text:n,eolCount:t,firstLineLength:o,lastLineLength:c,forceMoveMarkers:C,isAutoWhitespaceEdit:!1}}_doApplyEdits(u){u.sort(I._sortOpsDescending);const C=[];for(let v=0;v<u.length;v++){const r=u[v],a=r.range.startLineNumber,d=r.range.startColumn,l=r.range.endLineNumber,i=r.range.endColumn;if(a===l&&d===i&&r.text.length===0)continue;r.text?(this._pieceTree.delete(r.rangeOffset,r.rangeLength),this._pieceTree.insert(r.rangeOffset,r.text,!0)):this._pieceTree.delete(r.rangeOffset,r.rangeLength);const n=new D.Range(a,d,l,i);C.push({range:n,rangeLength:r.rangeLength,text:r.text,rangeOffset:r.rangeOffset,forceMoveMarkers:r.forceMoveMarkers})}return C}findMatchesLineByLine(u,C,v,r){return this._pieceTree.findMatchesLineByLine(u,C,v,r)}getPieceTree(){return this._pieceTree}static _getInverseEditRange(u,C){const v=u.startLineNumber,r=u.startColumn,[a,d,l]=(0,A.countEOL)(C);let i;if(C.length>0){const n=a+1;n===1?i=new D.Range(v,r,v,r+d):i=new D.Range(v,r,v+n-1,l+1)}else i=new D.Range(v,r,v,r);return i}static _getInverseEditRanges(u){const C=[];let v=0,r=0,a=null;for(let d=0,l=u.length;d<l;d++){const i=u[d];let n,t;a?a.range.endLineNumber===i.range.startLineNumber?(n=v,t=r+(i.range.startColumn-a.range.endColumn)):(n=v+(i.range.startLineNumber-a.range.endLineNumber),t=i.range.startColumn):(n=i.range.startLineNumber,t=i.range.startColumn);let o;if(i.text.length>0){const c=i.eolCount+1;c===1?o=new D.Range(n,t,n,t+i.firstLineLength):o=new D.Range(n,t,n+c-1,i.lastLineLength+1)}else o=new D.Range(n,t,n,t);v=o.endLineNumber,r=o.endColumn,C.push(o),a=i}return C}static _sortOpsAscending(u,C){const v=D.Range.compareRangesUsingEnds(u.range,C.range);return v===0?u.sortIndex-C.sortIndex:v}static _sortOpsDescending(u,C){const v=D.Range.compareRangesUsingEnds(u.range,C.range);return v===0?C.sortIndex-u.sortIndex:-v}}e.PieceTreeTextBuffer=I}),define(ke[166],Re([1,0,30,13,52,100,165]),function(Ee,e,S,T,D,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PieceTreeTextBufferBuilder=void 0,T=Ve(T);class A{constructor(I,E,u,C,v,r,a,d,l){this._chunks=I,this._bom=E,this._cr=u,this._lf=C,this._crlf=v,this._containsRTL=r,this._containsUnusualLineTerminators=a,this._isBasicASCII=d,this._normalizeEOL=l}_getEOL(I){const E=this._cr+this._lf+this._crlf,u=this._cr+this._crlf;return E===0?I===D.DefaultEndOfLine.LF?`
`:`\r
`:u>E/2?`\r
`:`
`}create(I){const E=this._getEOL(I),u=this._chunks;if(this._normalizeEOL&&(E===`\r
`&&(this._cr>0||this._lf>0)||E===`
`&&(this._cr>0||this._crlf>0)))for(let v=0,r=u.length;v<r;v++){const a=u[v].buffer.replace(/\r\n|\r|\n/g,E),d=(0,O.createLineStartsFast)(a);u[v]=new O.StringBuffer(a,d)}const C=new k.PieceTreeTextBuffer(u,this._bom,E,this._containsRTL,this._containsUnusualLineTerminators,this._isBasicASCII,this._normalizeEOL);return{textBuffer:C,disposable:C}}getFirstLineText(I){return this._chunks[0].buffer.substr(0,I).split(/\r\n|\r|\n/)[0]}}class m{constructor(){this.chunks=[],this.BOM="",this._hasPreviousChar=!1,this._previousChar=0,this._tmpLineStarts=[],this.cr=0,this.lf=0,this.crlf=0,this.containsRTL=!1,this.containsUnusualLineTerminators=!1,this.isBasicASCII=!0}acceptChunk(I){if(I.length===0)return;this.chunks.length===0&&T.startsWithUTF8BOM(I)&&(this.BOM=T.UTF8_BOM_CHARACTER,I=I.substr(1));const E=I.charCodeAt(I.length-1);E===S.CharCode.CarriageReturn||E>=55296&&E<=56319?(this._acceptChunk1(I.substr(0,I.length-1),!1),this._hasPreviousChar=!0,this._previousChar=E):(this._acceptChunk1(I,!1),this._hasPreviousChar=!1,this._previousChar=E)}_acceptChunk1(I,E){!E&&I.length===0||(this._hasPreviousChar?this._acceptChunk2(String.fromCharCode(this._previousChar)+I):this._acceptChunk2(I))}_acceptChunk2(I){const E=(0,O.createLineStarts)(this._tmpLineStarts,I);this.chunks.push(new O.StringBuffer(I,E.lineStarts)),this.cr+=E.cr,this.lf+=E.lf,this.crlf+=E.crlf,E.isBasicASCII||(this.isBasicASCII=!1,this.containsRTL||(this.containsRTL=T.containsRTL(I)),this.containsUnusualLineTerminators||(this.containsUnusualLineTerminators=T.containsUnusualLineTerminators(I)))}finish(I=!0){return this._finish(),new A(this.chunks,this.BOM,this.cr,this.lf,this.crlf,this.containsRTL,this.containsUnusualLineTerminators,this.isBasicASCII,I)}_finish(){if(this.chunks.length===0&&this._acceptChunk1("",!0),this._hasPreviousChar){this._hasPreviousChar=!1;const I=this.chunks[this.chunks.length-1];I.buffer+=String.fromCharCode(this._previousChar);const E=(0,O.createLineStartsFast)(I.buffer);I.lineStarts=E,this._previousChar===S.CharCode.CarriageReturn&&this.cr++}}}e.PieceTreeTextBufferBuilder=m}),define(ke[104],Re([1,0,20,23]),function(Ee,e,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeSemanticTokensDto=m,e.decodeSemanticTokensDto=I,T=Ve(T);var D;(function(E){E[E.Full=1]="Full",E[E.Delta=2]="Delta"})(D||(D={}));function O(E){for(let u=0,C=E.length;u<C;u+=4){const v=E[u+0],r=E[u+1],a=E[u+2],d=E[u+3];E[u+0]=d,E[u+1]=a,E[u+2]=r,E[u+3]=v}}function k(E){const u=new Uint8Array(E.buffer,E.byteOffset,E.length*4);return T.isLittleEndian()||O(u),S.VSBuffer.wrap(u)}function A(E){const u=E.buffer;if(T.isLittleEndian()||O(u),u.byteOffset%4===0)return new Uint32Array(u.buffer,u.byteOffset,u.length/4);{const C=new Uint8Array(u.byteLength);return C.set(u),new Uint32Array(C.buffer,C.byteOffset,C.length/4)}}function m(E){const u=new Uint32Array(s(E));let C=0;if(u[C++]=E.id,E.type==="full")u[C++]=D.Full,u[C++]=E.data.length,u.set(E.data,C),C+=E.data.length;else{u[C++]=D.Delta,u[C++]=E.deltas.length;for(const v of E.deltas)u[C++]=v.start,u[C++]=v.deleteCount,v.data?(u[C++]=v.data.length,u.set(v.data,C),C+=v.data.length):u[C++]=0}return k(u)}function s(E){let u=0;if(u+=2,E.type==="full")u+=1+E.data.length;else{u+=1,u+=3*E.deltas.length;for(const C of E.deltas)C.data&&(u+=C.data.length)}return u}function I(E){const u=A(E);let C=0;const v=u[C++];if(u[C++]===D.Full){const l=u[C++],i=u.subarray(C,C+l);return C+=l,{id:v,type:"full",data:i}}const a=u[C++],d=[];for(let l=0;l<a;l++){const i=u[C++],n=u[C++],t=u[C++];let o;t>0&&(o=u.subarray(C,C+t),C+=t),d[l]={start:i,deleteCount:n,data:o}}return{id:v,type:"delta",deltas:d}}}),define(ke[167],Re([1,0,30,12,9]),function(Ee,e,S,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Scanner=e.TokenType=void 0;var O;(function(I){I[I.LParen=0]="LParen",I[I.RParen=1]="RParen",I[I.Neg=2]="Neg",I[I.Eq=3]="Eq",I[I.NotEq=4]="NotEq",I[I.Lt=5]="Lt",I[I.LtEq=6]="LtEq",I[I.Gt=7]="Gt",I[I.GtEq=8]="GtEq",I[I.RegexOp=9]="RegexOp",I[I.RegexStr=10]="RegexStr",I[I.True=11]="True",I[I.False=12]="False",I[I.In=13]="In",I[I.Not=14]="Not",I[I.And=15]="And",I[I.Or=16]="Or",I[I.Str=17]="Str",I[I.QuotedStr=18]="QuotedStr",I[I.Error=19]="Error",I[I.EOF=20]="EOF"})(O||(e.TokenType=O={}));function k(...I){switch(I.length){case 1:return(0,D.localize)(1693,null,I[0]);case 2:return(0,D.localize)(1694,null,I[0],I[1]);case 3:return(0,D.localize)(1695,null,I[0],I[1],I[2]);default:return}}const A=(0,D.localize)(1696,null),m=(0,D.localize)(1697,null);class s{constructor(){this._input="",this._start=0,this._current=0,this._tokens=[],this._errors=[],this.stringRe=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(E){switch(E.type){case O.LParen:return"(";case O.RParen:return")";case O.Neg:return"!";case O.Eq:return E.isTripleEq?"===":"==";case O.NotEq:return E.isTripleEq?"!==":"!=";case O.Lt:return"<";case O.LtEq:return"<=";case O.Gt:return">=";case O.GtEq:return">=";case O.RegexOp:return"=~";case O.RegexStr:return E.lexeme;case O.True:return"true";case O.False:return"false";case O.In:return"in";case O.Not:return"not";case O.And:return"&&";case O.Or:return"||";case O.Str:return E.lexeme;case O.QuotedStr:return E.lexeme;case O.Error:return E.lexeme;case O.EOF:return"EOF";default:throw(0,T.illegalState)(`unhandled token type: ${JSON.stringify(E)}; have you forgotten to add a case?`)}}static{this._regexFlags=new Set(["i","g","s","m","y","u"].map(E=>E.charCodeAt(0)))}static{this._keywords=new Map([["not",O.Not],["in",O.In],["false",O.False],["true",O.True]])}get errors(){return this._errors}reset(E){return this._input=E,this._start=0,this._current=0,this._tokens=[],this._errors=[],this}scan(){for(;!this._isAtEnd();)switch(this._start=this._current,this._advance()){case S.CharCode.OpenParen:this._addToken(O.LParen);break;case S.CharCode.CloseParen:this._addToken(O.RParen);break;case S.CharCode.ExclamationMark:if(this._match(S.CharCode.Equals)){const u=this._match(S.CharCode.Equals);this._tokens.push({type:O.NotEq,offset:this._start,isTripleEq:u})}else this._addToken(O.Neg);break;case S.CharCode.SingleQuote:this._quotedString();break;case S.CharCode.Slash:this._regex();break;case S.CharCode.Equals:if(this._match(S.CharCode.Equals)){const u=this._match(S.CharCode.Equals);this._tokens.push({type:O.Eq,offset:this._start,isTripleEq:u})}else this._match(S.CharCode.Tilde)?this._addToken(O.RegexOp):this._error(k("==","=~"));break;case S.CharCode.LessThan:this._addToken(this._match(S.CharCode.Equals)?O.LtEq:O.Lt);break;case S.CharCode.GreaterThan:this._addToken(this._match(S.CharCode.Equals)?O.GtEq:O.Gt);break;case S.CharCode.Ampersand:this._match(S.CharCode.Ampersand)?this._addToken(O.And):this._error(k("&&"));break;case S.CharCode.Pipe:this._match(S.CharCode.Pipe)?this._addToken(O.Or):this._error(k("||"));break;case S.CharCode.Space:case S.CharCode.CarriageReturn:case S.CharCode.Tab:case S.CharCode.LineFeed:case S.CharCode.NoBreakSpace:break;default:this._string()}return this._start=this._current,this._addToken(O.EOF),Array.from(this._tokens)}_match(E){return this._isAtEnd()||this._input.charCodeAt(this._current)!==E?!1:(this._current++,!0)}_advance(){return this._input.charCodeAt(this._current++)}_peek(){return this._isAtEnd()?S.CharCode.Null:this._input.charCodeAt(this._current)}_addToken(E){this._tokens.push({type:E,offset:this._start})}_error(E){const u=this._start,C=this._input.substring(this._start,this._current),v={type:O.Error,offset:this._start,lexeme:C};this._errors.push({offset:u,lexeme:C,additionalInfo:E}),this._tokens.push(v)}_string(){this.stringRe.lastIndex=this._start;const E=this.stringRe.exec(this._input);if(E){this._current=this._start+E[0].length;const u=this._input.substring(this._start,this._current),C=s._keywords.get(u);C?this._addToken(C):this._tokens.push({type:O.Str,lexeme:u,offset:this._start})}}_quotedString(){for(;this._peek()!==S.CharCode.SingleQuote&&!this._isAtEnd();)this._advance();if(this._isAtEnd()){this._error(A);return}this._advance(),this._tokens.push({type:O.QuotedStr,lexeme:this._input.substring(this._start+1,this._current-1),offset:this._start+1})}_regex(){let E=this._current,u=!1,C=!1;for(;;){if(E>=this._input.length){this._current=E,this._error(m);return}const r=this._input.charCodeAt(E);if(u)u=!1;else if(r===S.CharCode.Slash&&!C){E++;break}else r===S.CharCode.OpenSquareBracket?C=!0:r===S.CharCode.Backslash?u=!0:r===S.CharCode.CloseSquareBracket&&(C=!1);E++}for(;E<this._input.length&&s._regexFlags.has(this._input.charCodeAt(E));)E++;this._current=E;const v=this._input.substring(this._start,this._current);this._tokens.push({type:O.RegexStr,lexeme:v,offset:this._start})}_isAtEnd(){return this._current>=this._input.length}}e.Scanner=s}),define(ke[105],Re([1,0]),function(Ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0;const S={activeComment:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.activeComment.d.ts"},aiRelatedInformation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts"},aiTextSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiTextSearchProvider.d.ts"},aiTextSearchProviderNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiTextSearchProviderNew.d.ts"},attributableCoverage:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.attributableCoverage.d.ts"},authLearnMore:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authLearnMore.d.ts"},authSession:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts"},canonicalUriProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts"},chatParticipantAdditions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantAdditions.d.ts"},chatParticipantPrivate:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantPrivate.d.ts",version:2},chatProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts"},chatTab:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts"},chatVariableResolver:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariableResolver.d.ts"},codeActionAI:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts"},codeActionRanges:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionRanges.d.ts"},codiconDecoration:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts"},commentReactor:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReactor.d.ts"},commentReveal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReveal.d.ts"},commentThreadApplicability:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentThreadApplicability.d.ts"},commentingRangeHint:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentingRangeHint.d.ts"},commentsDraftState:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts"},contribAccessibilityHelpContent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribAccessibilityHelpContent.d.ts"},contribCommentEditorActionsMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts"},contribCommentPeekContext:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts"},contribCommentThreadAdditionalMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts"},contribCommentsViewThreadMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentsViewThreadMenus.d.ts"},contribDebugCreateConfiguration:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribDebugCreateConfiguration.d.ts"},contribDiffEditorGutterToolBarMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribDiffEditorGutterToolBarMenus.d.ts"},contribEditSessions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts"},contribEditorContentMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts"},contribIssueReporter:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribIssueReporter.d.ts"},contribLabelFormatterWorkspaceTooltip:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts"},contribMenuBarHome:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts"},contribMergeEditorMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts"},contribMultiDiffEditorMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMultiDiffEditorMenus.d.ts"},contribNotebookStaticPreloads:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts"},contribRemoteHelp:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts"},contribShareMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts"},contribSourceControlHistoryItemChangesMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemChangesMenu.d.ts"},contribSourceControlHistoryItemGroupMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemGroupMenu.d.ts"},contribSourceControlHistoryItemMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemMenu.d.ts"},contribSourceControlHistoryTitleMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryTitleMenu.d.ts"},contribSourceControlInputBoxMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts"},contribSourceControlTitleMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlTitleMenu.d.ts"},contribStatusBarItems:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts"},contribViewContainerTitle:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewContainerTitle.d.ts"},contribViewsRemote:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts"},contribViewsWelcome:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts"},createFileSystemWatcher:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts"},customEditorMove:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts"},debugVisualization:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugVisualization.d.ts"},defaultChatParticipant:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatParticipant.d.ts"},diffCommand:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts"},diffContentOptions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts"},documentFiltersExclusive:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts"},documentPaste:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts"},editSessionIdentityProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts"},editorHoverVerbosityLevel:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorHoverVerbosityLevel.d.ts"},editorInsets:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts"},embeddings:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.embeddings.d.ts"},extensionRuntime:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts"},extensionsAny:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts"},externalUriOpener:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts"},fileComments:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts"},fileSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts"},fileSearchProviderNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProviderNew.d.ts"},findFiles2:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2.d.ts"},findFiles2New:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2New.d.ts"},findTextInFiles:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts"},findTextInFilesNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFilesNew.d.ts"},fsChunks:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts"},idToken:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts"},inlineCompletionsAdditions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts"},inlineEdit:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineEdit.d.ts"},interactive:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts"},interactiveWindow:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts"},ipc:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts"},languageModelSystem:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageModelSystem.d.ts"},languageStatusText:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts"},lmTools:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.lmTools.d.ts",version:6},mappedEditsProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts"},multiDocumentHighlightProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.multiDocumentHighlightProvider.d.ts"},newSymbolNamesProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.newSymbolNamesProvider.d.ts"},notebookCellExecution:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecution.d.ts"},notebookCellExecutionState:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts"},notebookControllerAffinityHidden:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts"},notebookDeprecated:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts"},notebookExecution:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts"},notebookKernelSource:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts"},notebookLiveShare:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts"},notebookMessaging:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts"},notebookMime:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts"},notebookReplDocument:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookReplDocument.d.ts"},notebookVariableProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts"},portsAttributes:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts"},profileContentHandlers:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts"},quickDiffProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts"},quickInputButtonLocation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickInputButtonLocation.d.ts"},quickPickItemTooltip:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts"},quickPickSortByLabel:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts"},resolvers:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts"},scmActionButton:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts"},scmHistoryProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts"},scmMultiDiffEditor:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmMultiDiffEditor.d.ts"},scmSelectedProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts"},scmTextDocument:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts"},scmValidation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts"},shareProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts"},showLocal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts"},speech:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts"},tabInputMultiDiff:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputMultiDiff.d.ts"},tabInputTextMerge:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts"},taskPresentationGroup:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts"},telemetry:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts"},terminalDataWriteEvent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts"},terminalDimensions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts"},terminalExecuteCommandEvent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts"},terminalQuickFixProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts"},terminalSelection:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts"},testObserver:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts"},testRelatedCode:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testRelatedCode.d.ts"},textSearchCompleteNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchCompleteNew.d.ts"},textSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts"},textSearchProviderNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProviderNew.d.ts"},timeline:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts"},tokenInformation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts"},treeViewActiveItem:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts"},treeViewMarkdownMessage:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts"},treeViewReveal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts"},tunnelFactory:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts"},tunnels:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts"},workspaceTrust:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"}};e.allApiProposals=Object.freeze(S)}),define(ke[74],Re([1,0]),function(Ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class S{constructor(D,O=[],k=!1){this.ctor=D,this.staticArguments=O,this.supportsDelayedInstantiation=k}}e.SyncDescriptor=S}),define(ke[60],Re([1,0,74]),function(Ee,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.registerSingleton=O,e.getSingletonServiceDescriptors=k;const T=[];var D;(function(A){A[A.Eager=0]="Eager",A[A.Delayed=1]="Delayed"})(D||(e.InstantiationType=D={}));function O(A,m,s){m instanceof S.SyncDescriptor||(m=new S.SyncDescriptor(m,[],!!s)),T.push([A,m])}function k(){return T}}),define(ke[168],Re([1,0]),function(Ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class S{constructor(O,k){this.key=O,this.data=k,this.incoming=new Map,this.outgoing=new Map}}e.Node=S;class T{constructor(O){this._hashFn=O,this._nodes=new Map}roots(){const O=[];for(const k of this._nodes.values())k.outgoing.size===0&&O.push(k);return O}insertEdge(O,k){const A=this.lookupOrInsertNode(O),m=this.lookupOrInsertNode(k);A.outgoing.set(m.key,m),m.incoming.set(A.key,A)}removeNode(O){const k=this._hashFn(O);this._nodes.delete(k);for(const A of this._nodes.values())A.outgoing.delete(k),A.incoming.delete(k)}lookupOrInsertNode(O){const k=this._hashFn(O);let A=this._nodes.get(k);return A||(A=new S(k,O),this._nodes.set(k,A)),A}lookup(O){return this._nodes.get(this._hashFn(O))}isEmpty(){return this._nodes.size===0}toString(){const O=[];for(const[k,A]of this._nodes)O.push(`${k}
	(-> incoming)[${[...A.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...A.outgoing.keys()].join(",")}]
`);return O.join(`
`)}findCycleSlow(){for(const[O,k]of this._nodes){const A=new Set([O]),m=this._findCycle(k,A);if(m)return m}}_findCycle(O,k){for(const[A,m]of O.outgoing){if(k.has(A))return[...k,A].join(" -> ");k.add(A);const s=this._findCycle(m,k);if(s)return s;k.delete(A)}}}e.Graph=T}),define(ke[3],Re([1,0]),function(Ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IInstantiationService=e._util=void 0,e.createDecorator=D,e.refineServiceDecorator=O;var S;(function(k){k.serviceIds=new Map,k.DI_TARGET="$di$target",k.DI_DEPENDENCIES="$di$dependencies";function A(m){return m[k.DI_DEPENDENCIES]||[]}k.getServiceDependencies=A})(S||(e._util=S={})),e.IInstantiationService=D("instantiationService");function T(k,A,m){A[S.DI_TARGET]===A?A[S.DI_DEPENDENCIES].push({id:k,index:m}):(A[S.DI_DEPENDENCIES]=[{id:k,index:m}],A[S.DI_TARGET]=A)}function D(k){if(S.serviceIds.has(k))return S.serviceIds.get(k);const A=function(m,s,I){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");T(A,m,I)};return A.toString=()=>k,S.serviceIds.set(k,A),A}function O(k){return k}}),define(ke[44],Re([1,0,14,2,3]),function(Ee,e,S,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.IConfigurationService=void 0,e.isConfigurationOverrides=O,e.isConfigurationUpdateOverrides=k,e.ConfigurationTargetToString=m,e.isConfigured=s,e.toValuesTree=I,e.addToValueTree=E,e.removeFromValueTree=u,e.getConfigurationValue=v,e.merge=r,e.getLanguageTagSettingPlainKey=a,S=Ve(S),e.IConfigurationService=(0,D.createDecorator)("configurationService");function O(d){return d&&typeof d=="object"&&(!d.overrideIdentifier||typeof d.overrideIdentifier=="string")&&(!d.resource||d.resource instanceof T.URI)}function k(d){return d&&typeof d=="object"&&(!d.overrideIdentifiers||Array.isArray(d.overrideIdentifiers))&&!d.overrideIdentifier&&(!d.resource||d.resource instanceof T.URI)}var A;(function(d){d[d.APPLICATION=1]="APPLICATION",d[d.USER=2]="USER",d[d.USER_LOCAL=3]="USER_LOCAL",d[d.USER_REMOTE=4]="USER_REMOTE",d[d.WORKSPACE=5]="WORKSPACE",d[d.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",d[d.DEFAULT=7]="DEFAULT",d[d.MEMORY=8]="MEMORY"})(A||(e.ConfigurationTarget=A={}));function m(d){switch(d){case A.APPLICATION:return"APPLICATION";case A.USER:return"USER";case A.USER_LOCAL:return"USER_LOCAL";case A.USER_REMOTE:return"USER_REMOTE";case A.WORKSPACE:return"WORKSPACE";case A.WORKSPACE_FOLDER:return"WORKSPACE_FOLDER";case A.DEFAULT:return"DEFAULT";case A.MEMORY:return"MEMORY"}}function s(d){return d.applicationValue!==void 0||d.userValue!==void 0||d.userLocalValue!==void 0||d.userRemoteValue!==void 0||d.workspaceValue!==void 0||d.workspaceFolderValue!==void 0}function I(d,l){const i=Object.create(null);for(const n in d)E(i,n,d[n],l);return i}function E(d,l,i,n){const t=l.split("."),o=t.pop();let c=d;for(let g=0;g<t.length;g++){const f=t[g];let h=c[f];switch(typeof h){case"undefined":h=c[f]=Object.create(null);break;case"object":if(h===null){n(`Ignoring ${l} as ${t.slice(0,g+1).join(".")} is null`);return}break;default:n(`Ignoring ${l} as ${t.slice(0,g+1).join(".")} is ${JSON.stringify(h)}`);return}c=h}if(typeof c=="object"&&c!==null)try{c[o]=i}catch{n(`Ignoring ${l} as ${t.join(".")} is ${JSON.stringify(c)}`)}else n(`Ignoring ${l} as ${t.join(".")} is ${JSON.stringify(c)}`)}function u(d,l){const i=l.split(".");C(d,i)}function C(d,l){const i=l.shift();if(l.length===0){delete d[i];return}if(Object.keys(d).indexOf(i)!==-1){const n=d[i];typeof n=="object"&&!Array.isArray(n)&&(C(n,l),Object.keys(n).length===0&&delete d[i])}}function v(d,l,i){function n(c,g){let f=c;for(const h of g){if(typeof f!="object"||f===null)return;f=f[h]}return f}const t=l.split("."),o=n(d,t);return typeof o>"u"?i:o}function r(d,l,i){Object.keys(l).forEach(n=>{n!=="__proto__"&&(n in d?S.isObject(d[n])&&S.isObject(l[n])?r(d[n],l[n],i):i&&(d[n]=l[n]):d[n]=l[n])})}function a(d){return d.replace(/[\[\]]/g,"")}}),define(ke[31],Re([1,0,30,23,13,167,3,9,12]),function(Ee,e,S,T,D,O,k,A,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.ContextKeyExpr=e.Parser=e.ContextKeyExprType=void 0,e.setConstant=I,e.validateWhenClauses=g,e.expressionsAreEqualWithConstantSubstitution=f,e.implies=Z;const s=new Map;s.set("false",!1),s.set("true",!0),s.set("isMac",T.isMacintosh),s.set("isLinux",T.isLinux),s.set("isWindows",T.isWindows),s.set("isWeb",T.isWeb),s.set("isMacNative",T.isMacintosh&&!T.isWeb),s.set("isEdge",T.isEdge),s.set("isFirefox",T.isFirefox),s.set("isChrome",T.isChrome),s.set("isSafari",T.isSafari);function I(X,V){if(s.get(X)!==void 0)throw(0,m.illegalArgument)("contextkey.setConstant(k, v) invoked with already set constant `k`");s.set(X,V)}const E=Object.prototype.hasOwnProperty;var u;(function(X){X[X.False=0]="False",X[X.True=1]="True",X[X.Defined=2]="Defined",X[X.Not=3]="Not",X[X.Equals=4]="Equals",X[X.NotEquals=5]="NotEquals",X[X.And=6]="And",X[X.Regex=7]="Regex",X[X.NotRegex=8]="NotRegex",X[X.Or=9]="Or",X[X.In=10]="In",X[X.NotIn=11]="NotIn",X[X.Greater=12]="Greater",X[X.GreaterEquals=13]="GreaterEquals",X[X.Smaller=14]="Smaller",X[X.SmallerEquals=15]="SmallerEquals"})(u||(e.ContextKeyExprType=u={}));const C={regexParsingWithErrorRecovery:!0},v=(0,A.localize)(1673,null),r=(0,A.localize)(1674,null),a=(0,A.localize)(1675,null),d=(0,A.localize)(1676,null),l=(0,A.localize)(1677,null),i=(0,A.localize)(1678,null),n=(0,A.localize)(1679,null),t=(0,A.localize)(1680,null);class o{static{this._parseError=new Error}get lexingErrors(){return this._scanner.errors}get parsingErrors(){return this._parsingErrors}constructor(V=C){this._config=V,this._scanner=new O.Scanner,this._tokens=[],this._current=0,this._parsingErrors=[],this._flagsGYRe=/g|y/g}parse(V){if(V===""){this._parsingErrors.push({message:v,offset:0,lexeme:"",additionalInfo:r});return}this._tokens=this._scanner.reset(V).scan(),this._current=0,this._parsingErrors=[];try{const re=this._expr();if(!this._isAtEnd()){const be=this._peek(),De=be.type===O.TokenType.Str?i:void 0;throw this._parsingErrors.push({message:l,offset:be.offset,lexeme:O.Scanner.getLexeme(be),additionalInfo:De}),o._parseError}return re}catch(re){if(re!==o._parseError)throw re;return}}_expr(){return this._or()}_or(){const V=[this._and()];for(;this._matchOne(O.TokenType.Or);){const re=this._and();V.push(re)}return V.length===1?V[0]:c.or(...V)}_and(){const V=[this._term()];for(;this._matchOne(O.TokenType.And);){const re=this._term();V.push(re)}return V.length===1?V[0]:c.and(...V)}_term(){if(this._matchOne(O.TokenType.Neg)){const V=this._peek();switch(V.type){case O.TokenType.True:return this._advance(),_.INSTANCE;case O.TokenType.False:return this._advance(),y.INSTANCE;case O.TokenType.LParen:{this._advance();const re=this._expr();return this._consume(O.TokenType.RParen,d),re?.negate()}case O.TokenType.Str:return this._advance(),N.create(V.lexeme);default:throw this._errExpectedButGot("KEY | true | false | '(' expression ')'",V)}}return this._primary()}_primary(){const V=this._peek();switch(V.type){case O.TokenType.True:return this._advance(),c.true();case O.TokenType.False:return this._advance(),c.false();case O.TokenType.LParen:{this._advance();const re=this._expr();return this._consume(O.TokenType.RParen,d),re}case O.TokenType.Str:{const re=V.lexeme;if(this._advance(),this._matchOne(O.TokenType.RegexOp)){const De=this._peek();if(!this._config.regexParsingWithErrorRecovery){if(this._advance(),De.type!==O.TokenType.RegexStr)throw this._errExpectedButGot("REGEX",De);const Fe=De.lexeme,ze=Fe.lastIndexOf("/"),Je=ze===Fe.length-1?void 0:this._removeFlagsGY(Fe.substring(ze+1));let nt;try{nt=new RegExp(Fe.substring(1,ze),Je)}catch{throw this._errExpectedButGot("REGEX",De)}return x.create(re,nt)}switch(De.type){case O.TokenType.RegexStr:case O.TokenType.Error:{const Fe=[De.lexeme];this._advance();let ze=this._peek(),Je=0;for(let et=0;et<De.lexeme.length;et++)De.lexeme.charCodeAt(et)===S.CharCode.OpenParen?Je++:De.lexeme.charCodeAt(et)===S.CharCode.CloseParen&&Je--;for(;!this._isAtEnd()&&ze.type!==O.TokenType.And&&ze.type!==O.TokenType.Or;){switch(ze.type){case O.TokenType.LParen:Je++;break;case O.TokenType.RParen:Je--;break;case O.TokenType.RegexStr:case O.TokenType.QuotedStr:for(let et=0;et<ze.lexeme.length;et++)ze.lexeme.charCodeAt(et)===S.CharCode.OpenParen?Je++:De.lexeme.charCodeAt(et)===S.CharCode.CloseParen&&Je--}if(Je<0)break;Fe.push(O.Scanner.getLexeme(ze)),this._advance(),ze=this._peek()}const nt=Fe.join(""),dt=nt.lastIndexOf("/"),vt=dt===nt.length-1?void 0:this._removeFlagsGY(nt.substring(dt+1));let ut;try{ut=new RegExp(nt.substring(1,dt),vt)}catch{throw this._errExpectedButGot("REGEX",De)}return c.regex(re,ut)}case O.TokenType.QuotedStr:{const Fe=De.lexeme;this._advance();let ze=null;if(!(0,D.isFalsyOrWhitespace)(Fe)){const Je=Fe.indexOf("/"),nt=Fe.lastIndexOf("/");if(Je!==nt&&Je>=0){const dt=Fe.slice(Je+1,nt),vt=Fe[nt+1]==="i"?"i":"";try{ze=new RegExp(dt,vt)}catch{throw this._errExpectedButGot("REGEX",De)}}}if(ze===null)throw this._errExpectedButGot("REGEX",De);return x.create(re,ze)}default:throw this._errExpectedButGot("REGEX",this._peek())}}if(this._matchOne(O.TokenType.Not)){this._consume(O.TokenType.In,a);const De=this._value();return c.notIn(re,De)}switch(this._peek().type){case O.TokenType.Eq:{this._advance();const De=this._value();if(this._previous().type===O.TokenType.QuotedStr)return c.equals(re,De);switch(De){case"true":return c.has(re);case"false":return c.not(re);default:return c.equals(re,De)}}case O.TokenType.NotEq:{this._advance();const De=this._value();if(this._previous().type===O.TokenType.QuotedStr)return c.notEquals(re,De);switch(De){case"true":return c.not(re);case"false":return c.has(re);default:return c.notEquals(re,De)}}case O.TokenType.Lt:return this._advance(),J.create(re,this._value());case O.TokenType.LtEq:return this._advance(),$.create(re,this._value());case O.TokenType.Gt:return this._advance(),F.create(re,this._value());case O.TokenType.GtEq:return this._advance(),K.create(re,this._value());case O.TokenType.In:return this._advance(),c.in(re,this._value());default:return c.has(re)}}case O.TokenType.EOF:throw this._parsingErrors.push({message:n,offset:V.offset,lexeme:"",additionalInfo:t}),o._parseError;default:throw this._errExpectedButGot(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this._peek())}}_value(){const V=this._peek();switch(V.type){case O.TokenType.Str:case O.TokenType.QuotedStr:return this._advance(),V.lexeme;case O.TokenType.True:return this._advance(),"true";case O.TokenType.False:return this._advance(),"false";case O.TokenType.In:return this._advance(),"in";default:return""}}_removeFlagsGY(V){return V.replaceAll(this._flagsGYRe,"")}_previous(){return this._tokens[this._current-1]}_matchOne(V){return this._check(V)?(this._advance(),!0):!1}_advance(){return this._isAtEnd()||this._current++,this._previous()}_consume(V,re){if(this._check(V))return this._advance();throw this._errExpectedButGot(re,this._peek())}_errExpectedButGot(V,re,be){const De=(0,A.localize)(1681,null,V,O.Scanner.getLexeme(re)),Fe=re.offset,ze=O.Scanner.getLexeme(re);return this._parsingErrors.push({message:De,offset:Fe,lexeme:ze,additionalInfo:be}),o._parseError}_check(V){return this._peek().type===V}_peek(){return this._tokens[this._current]}_isAtEnd(){return this._peek().type===O.TokenType.EOF}}e.Parser=o;class c{static false(){return _.INSTANCE}static true(){return y.INSTANCE}static has(V){return w.create(V)}static equals(V,re){return P.create(V,re)}static notEquals(V,re){return b.create(V,re)}static regex(V,re){return x.create(V,re)}static in(V,re){return R.create(V,re)}static notIn(V,re){return p.create(V,re)}static not(V){return N.create(V)}static and(...V){return ae.create(V,null,!0)}static or(...V){return ee.create(V,null,!0)}static greater(V,re){return F.create(V,re)}static greaterEquals(V,re){return K.create(V,re)}static smaller(V,re){return J.create(V,re)}static smallerEquals(V,re){return $.create(V,re)}static{this._parser=new o({regexParsingWithErrorRecovery:!1})}static deserialize(V){return V==null?void 0:this._parser.parse(V)}}e.ContextKeyExpr=c;function g(X){const V=new o({regexParsingWithErrorRecovery:!1});return X.map(re=>(V.parse(re),V.lexingErrors.length>0?V.lexingErrors.map(be=>({errorMessage:be.additionalInfo?(0,A.localize)(1682,null,be.additionalInfo):(0,A.localize)(1683,null),offset:be.offset,length:be.lexeme.length})):V.parsingErrors.length>0?V.parsingErrors.map(be=>({errorMessage:be.additionalInfo?`${be.message}. ${be.additionalInfo}`:be.message,offset:be.offset,length:be.lexeme.length})):[]))}function f(X,V){const re=X?X.substituteConstants():void 0,be=V?V.substituteConstants():void 0;return!re&&!be?!0:!re||!be?!1:re.equals(be)}function h(X,V){return X.cmp(V)}class _{static{this.INSTANCE=new _}constructor(){this.type=u.False}cmp(V){return this.type-V.type}equals(V){return V.type===this.type}substituteConstants(){return this}evaluate(V){return!1}serialize(){return"false"}keys(){return[]}map(V){return this}negate(){return y.INSTANCE}}e.ContextKeyFalseExpr=_;class y{static{this.INSTANCE=new y}constructor(){this.type=u.True}cmp(V){return this.type-V.type}equals(V){return V.type===this.type}substituteConstants(){return this}evaluate(V){return!0}serialize(){return"true"}keys(){return[]}map(V){return this}negate(){return _.INSTANCE}}e.ContextKeyTrueExpr=y;class w{static create(V,re=null){const be=s.get(V);return typeof be=="boolean"?be?y.INSTANCE:_.INSTANCE:new w(V,re)}constructor(V,re){this.key=V,this.negated=re,this.type=u.Defined}cmp(V){return V.type!==this.type?this.type-V.type:ie(this.key,V.key)}equals(V){return V.type===this.type?this.key===V.key:!1}substituteConstants(){const V=s.get(this.key);return typeof V=="boolean"?V?y.INSTANCE:_.INSTANCE:this}evaluate(V){return!!V.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(V){return V.mapDefined(this.key)}negate(){return this.negated||(this.negated=N.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=w;class P{static create(V,re,be=null){if(typeof re=="boolean")return re?w.create(V,be):N.create(V,be);const De=s.get(V);return typeof De=="boolean"?re===(De?"true":"false")?y.INSTANCE:_.INSTANCE:new P(V,re,be)}constructor(V,re,be){this.key=V,this.value=re,this.negated=be,this.type=u.Equals}cmp(V){return V.type!==this.type?this.type-V.type:ue(this.key,this.value,V.key,V.value)}equals(V){return V.type===this.type?this.key===V.key&&this.value===V.value:!1}substituteConstants(){const V=s.get(this.key);if(typeof V=="boolean"){const re=V?"true":"false";return this.value===re?y.INSTANCE:_.INSTANCE}return this}evaluate(V){return V.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(V){return V.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=b.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=P;class R{static create(V,re){return new R(V,re)}constructor(V,re){this.key=V,this.valueKey=re,this.type=u.In,this.negated=null}cmp(V){return V.type!==this.type?this.type-V.type:ue(this.key,this.valueKey,V.key,V.valueKey)}equals(V){return V.type===this.type?this.key===V.key&&this.valueKey===V.valueKey:!1}substituteConstants(){return this}evaluate(V){const re=V.getValue(this.valueKey),be=V.getValue(this.key);return Array.isArray(re)?re.includes(be):typeof be=="string"&&typeof re=="object"&&re!==null?E.call(re,be):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(V){return V.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=p.create(this.key,this.valueKey)),this.negated}}e.ContextKeyInExpr=R;class p{static create(V,re){return new p(V,re)}constructor(V,re){this.key=V,this.valueKey=re,this.type=u.NotIn,this._negated=R.create(V,re)}cmp(V){return V.type!==this.type?this.type-V.type:this._negated.cmp(V._negated)}equals(V){return V.type===this.type?this._negated.equals(V._negated):!1}substituteConstants(){return this}evaluate(V){return!this._negated.evaluate(V)}serialize(){return`${this.key} not in '${this.valueKey}'`}keys(){return this._negated.keys()}map(V){return V.mapNotIn(this.key,this.valueKey)}negate(){return this._negated}}e.ContextKeyNotInExpr=p;class b{static create(V,re,be=null){if(typeof re=="boolean")return re?N.create(V,be):w.create(V,be);const De=s.get(V);return typeof De=="boolean"?re===(De?"true":"false")?_.INSTANCE:y.INSTANCE:new b(V,re,be)}constructor(V,re,be){this.key=V,this.value=re,this.negated=be,this.type=u.NotEquals}cmp(V){return V.type!==this.type?this.type-V.type:ue(this.key,this.value,V.key,V.value)}equals(V){return V.type===this.type?this.key===V.key&&this.value===V.value:!1}substituteConstants(){const V=s.get(this.key);if(typeof V=="boolean"){const re=V?"true":"false";return this.value===re?_.INSTANCE:y.INSTANCE}return this}evaluate(V){return V.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(V){return V.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=P.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=b;class N{static create(V,re=null){const be=s.get(V);return typeof be=="boolean"?be?_.INSTANCE:y.INSTANCE:new N(V,re)}constructor(V,re){this.key=V,this.negated=re,this.type=u.Not}cmp(V){return V.type!==this.type?this.type-V.type:ie(this.key,V.key)}equals(V){return V.type===this.type?this.key===V.key:!1}substituteConstants(){const V=s.get(this.key);return typeof V=="boolean"?V?_.INSTANCE:y.INSTANCE:this}evaluate(V){return!V.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(V){return V.mapNot(this.key)}negate(){return this.negated||(this.negated=w.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=N;function L(X,V){if(typeof X=="string"){const re=parseFloat(X);isNaN(re)||(X=re)}return typeof X=="string"||typeof X=="number"?V(X):_.INSTANCE}class F{static create(V,re,be=null){return L(re,De=>new F(V,De,be))}constructor(V,re,be){this.key=V,this.value=re,this.negated=be,this.type=u.Greater}cmp(V){return V.type!==this.type?this.type-V.type:ue(this.key,this.value,V.key,V.value)}equals(V){return V.type===this.type?this.key===V.key&&this.value===V.value:!1}substituteConstants(){return this}evaluate(V){return typeof this.value=="string"?!1:parseFloat(V.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(V){return V.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=$.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=F;class K{static create(V,re,be=null){return L(re,De=>new K(V,De,be))}constructor(V,re,be){this.key=V,this.value=re,this.negated=be,this.type=u.GreaterEquals}cmp(V){return V.type!==this.type?this.type-V.type:ue(this.key,this.value,V.key,V.value)}equals(V){return V.type===this.type?this.key===V.key&&this.value===V.value:!1}substituteConstants(){return this}evaluate(V){return typeof this.value=="string"?!1:parseFloat(V.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(V){return V.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=J.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=K;class J{static create(V,re,be=null){return L(re,De=>new J(V,De,be))}constructor(V,re,be){this.key=V,this.value=re,this.negated=be,this.type=u.Smaller}cmp(V){return V.type!==this.type?this.type-V.type:ue(this.key,this.value,V.key,V.value)}equals(V){return V.type===this.type?this.key===V.key&&this.value===V.value:!1}substituteConstants(){return this}evaluate(V){return typeof this.value=="string"?!1:parseFloat(V.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(V){return V.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=K.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=J;class ${static create(V,re,be=null){return L(re,De=>new $(V,De,be))}constructor(V,re,be){this.key=V,this.value=re,this.negated=be,this.type=u.SmallerEquals}cmp(V){return V.type!==this.type?this.type-V.type:ue(this.key,this.value,V.key,V.value)}equals(V){return V.type===this.type?this.key===V.key&&this.value===V.value:!1}substituteConstants(){return this}evaluate(V){return typeof this.value=="string"?!1:parseFloat(V.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(V){return V.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=F.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=$;class x{static create(V,re){return new x(V,re)}constructor(V,re){this.key=V,this.regexp=re,this.type=u.Regex,this.negated=null}cmp(V){if(V.type!==this.type)return this.type-V.type;if(this.key<V.key)return-1;if(this.key>V.key)return 1;const re=this.regexp?this.regexp.source:"",be=V.regexp?V.regexp.source:"";return re<be?-1:re>be?1:0}equals(V){if(V.type===this.type){const re=this.regexp?this.regexp.source:"",be=V.regexp?V.regexp.source:"";return this.key===V.key&&re===be}return!1}substituteConstants(){return this}evaluate(V){const re=V.getValue(this.key);return this.regexp?this.regexp.test(re):!1}serialize(){const V=this.regexp?`/${this.regexp.source}/${this.regexp.flags}`:"/invalid/";return`${this.key} =~ ${V}`}keys(){return[this.key]}map(V){return V.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=G.create(this)),this.negated}}e.ContextKeyRegexExpr=x;class G{static create(V){return new G(V)}constructor(V){this._actual=V,this.type=u.NotRegex}cmp(V){return V.type!==this.type?this.type-V.type:this._actual.cmp(V._actual)}equals(V){return V.type===this.type?this._actual.equals(V._actual):!1}substituteConstants(){return this}evaluate(V){return!this._actual.evaluate(V)}serialize(){return`!(${this._actual.serialize()})`}keys(){return this._actual.keys()}map(V){return new G(this._actual.map(V))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=G;function Y(X){let V=null;for(let re=0,be=X.length;re<be;re++){const De=X[re].substituteConstants();if(X[re]!==De&&V===null){V=[];for(let Fe=0;Fe<re;Fe++)V[Fe]=X[Fe]}V!==null&&(V[re]=De)}return V===null?X:V}class ae{static create(V,re,be){return ae._normalizeArr(V,re,be)}constructor(V,re){this.expr=V,this.negated=re,this.type=u.And}cmp(V){if(V.type!==this.type)return this.type-V.type;if(this.expr.length<V.expr.length)return-1;if(this.expr.length>V.expr.length)return 1;for(let re=0,be=this.expr.length;re<be;re++){const De=h(this.expr[re],V.expr[re]);if(De!==0)return De}return 0}equals(V){if(V.type===this.type){if(this.expr.length!==V.expr.length)return!1;for(let re=0,be=this.expr.length;re<be;re++)if(!this.expr[re].equals(V.expr[re]))return!1;return!0}return!1}substituteConstants(){const V=Y(this.expr);return V===this.expr?this:ae.create(V,this.negated,!1)}evaluate(V){for(let re=0,be=this.expr.length;re<be;re++)if(!this.expr[re].evaluate(V))return!1;return!0}static _normalizeArr(V,re,be){const De=[];let Fe=!1;for(const ze of V)if(ze){if(ze.type===u.True){Fe=!0;continue}if(ze.type===u.False)return _.INSTANCE;if(ze.type===u.And){De.push(...ze.expr);continue}De.push(ze)}if(De.length===0&&Fe)return y.INSTANCE;if(De.length!==0){if(De.length===1)return De[0];De.sort(h);for(let ze=1;ze<De.length;ze++)De[ze-1].equals(De[ze])&&(De.splice(ze,1),ze--);if(De.length===1)return De[0];for(;De.length>1;){const ze=De[De.length-1];if(ze.type!==u.Or)break;De.pop();const Je=De.pop(),nt=De.length===0,dt=ee.create(ze.expr.map(vt=>ae.create([vt,Je],null,be)),null,nt);dt&&(De.push(dt),De.sort(h))}if(De.length===1)return De[0];if(be){for(let ze=0;ze<De.length;ze++)for(let Je=ze+1;Je<De.length;Je++)if(De[ze].negate().equals(De[Je]))return _.INSTANCE;if(De.length===1)return De[0]}return new ae(De,re)}}serialize(){return this.expr.map(V=>V.serialize()).join(" && ")}keys(){const V=[];for(const re of this.expr)V.push(...re.keys());return V}map(V){return new ae(this.expr.map(re=>re.map(V)),null)}negate(){if(!this.negated){const V=[];for(const re of this.expr)V.push(re.negate());this.negated=ee.create(V,this,!0)}return this.negated}}e.ContextKeyAndExpr=ae;class ee{static create(V,re,be){return ee._normalizeArr(V,re,be)}constructor(V,re){this.expr=V,this.negated=re,this.type=u.Or}cmp(V){if(V.type!==this.type)return this.type-V.type;if(this.expr.length<V.expr.length)return-1;if(this.expr.length>V.expr.length)return 1;for(let re=0,be=this.expr.length;re<be;re++){const De=h(this.expr[re],V.expr[re]);if(De!==0)return De}return 0}equals(V){if(V.type===this.type){if(this.expr.length!==V.expr.length)return!1;for(let re=0,be=this.expr.length;re<be;re++)if(!this.expr[re].equals(V.expr[re]))return!1;return!0}return!1}substituteConstants(){const V=Y(this.expr);return V===this.expr?this:ee.create(V,this.negated,!1)}evaluate(V){for(let re=0,be=this.expr.length;re<be;re++)if(this.expr[re].evaluate(V))return!0;return!1}static _normalizeArr(V,re,be){let De=[],Fe=!1;if(V){for(let ze=0,Je=V.length;ze<Je;ze++){const nt=V[ze];if(nt){if(nt.type===u.False){Fe=!0;continue}if(nt.type===u.True)return y.INSTANCE;if(nt.type===u.Or){De=De.concat(nt.expr);continue}De.push(nt)}}if(De.length===0&&Fe)return _.INSTANCE;De.sort(h)}if(De.length!==0){if(De.length===1)return De[0];for(let ze=1;ze<De.length;ze++)De[ze-1].equals(De[ze])&&(De.splice(ze,1),ze--);if(De.length===1)return De[0];if(be){for(let ze=0;ze<De.length;ze++)for(let Je=ze+1;Je<De.length;Je++)if(De[ze].negate().equals(De[Je]))return y.INSTANCE;if(De.length===1)return De[0]}return new ee(De,re)}}serialize(){return this.expr.map(V=>V.serialize()).join(" || ")}keys(){const V=[];for(const re of this.expr)V.push(...re.keys());return V}map(V){return new ee(this.expr.map(re=>re.map(V)),null)}negate(){if(!this.negated){const V=[];for(const re of this.expr)V.push(re.negate());for(;V.length>1;){const re=V.shift(),be=V.shift(),De=[];for(const Fe of Ie(re))for(const ze of Ie(be))De.push(ae.create([Fe,ze],null,!1));V.unshift(ee.create(De,null,!1))}this.negated=ee.create(V,this,!0)}return this.negated}}e.ContextKeyOrExpr=ee;class oe extends w{static{this._info=[]}static all(){return oe._info.values()}constructor(V,re,be){super(V,null),this._defaultValue=re,typeof be=="object"?oe._info.push({...be,key:V}):be!==!0&&oe._info.push({key:V,description:be,type:re!=null?typeof re:void 0})}bindTo(V){return V.createKey(this.key,this._defaultValue)}getValue(V){return V.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(V){return P.create(this.key,V)}notEqualsTo(V){return b.create(this.key,V)}}e.RawContextKey=oe,e.IContextKeyService=(0,k.createDecorator)("contextKeyService");function ie(X,V){return X<V?-1:X>V?1:0}function ue(X,V,re,be){return X<re?-1:X>re?1:V<be?-1:V>be?1:0}function Z(X,V){if(X.type===u.False||V.type===u.True)return!0;if(X.type===u.Or)return V.type===u.Or?ve(X.expr,V.expr):!1;if(V.type===u.Or){for(const re of V.expr)if(Z(X,re))return!0;return!1}if(X.type===u.And){if(V.type===u.And)return ve(V.expr,X.expr);for(const re of X.expr)if(Z(re,V))return!0;return!1}return X.equals(V)}function ve(X,V){let re=0,be=0;for(;re<X.length&&be<V.length;){const De=X[re].cmp(V[be]);if(De<0)return!1;De===0&&re++,be++}return re===X.length}function Ie(X){return X.type===u.Or?X.expr:[X]}}),define(ke[169],Re([1,0,31,3]),function(Ee,e,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ACCESSIBLE_VIEW_SHOWN_STORAGE_PREFIX=e.CONTEXT_ACCESSIBILITY_MODE_ENABLED=e.AccessibilitySupport=e.IAccessibilityService=void 0,e.isAccessibilityInformation=O,e.IAccessibilityService=(0,T.createDecorator)("accessibilityService");var D;(function(k){k[k.Unknown=0]="Unknown",k[k.Disabled=1]="Disabled",k[k.Enabled=2]="Enabled"})(D||(e.AccessibilitySupport=D={})),e.CONTEXT_ACCESSIBILITY_MODE_ENABLED=new S.RawContextKey("accessibilityModeEnabled",!1);function O(k){return k&&typeof k=="object"&&typeof k.label=="string"&&(typeof k.role>"u"||typeof k.role=="string")}e.ACCESSIBLE_VIEW_SHOWN_STORAGE_PREFIX="ACCESSIBLE_VIEW_SHOWN_"}),define(ke[106],Re([1,0,17,25,23,147,280,152,170,9,169]),function(Ee,e,S,T,D,O,k,A,m,s,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.RenderLineNumbersType=e.ShowLightbulbIconMode=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0,e.boolean=i,e.clampedInt=t,e.clampedFloat=c,e.stringSet=h,e.cursorStyleToString=L,e.filterValidationDecorations=Me,S=Ve(S),T=Ve(T),D=Ve(D),s=Ve(s);var E;(function(Q){Q[Q.None=0]="None",Q[Q.Keep=1]="Keep",Q[Q.Brackets=2]="Brackets",Q[Q.Advanced=3]="Advanced",Q[Q.Full=4]="Full"})(E||(e.EditorAutoIndentStrategy=E={})),e.MINIMAP_GUTTER_WIDTH=8;class u{constructor(W){this._values=W}hasChanged(W){return this._values[W]}}e.ConfigurationChangedEvent=u;class C{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=C;class v{constructor(W,he,$e,He){this.id=W,this.name=he,this.defaultValue=$e,this.schema=He}applyUpdate(W,he){return a(W,he)}compute(W,he,$e){return $e}}class r{constructor(W,he){this.newValue=W,this.didChange=he}}e.ApplyUpdateResult=r;function a(Q,W){if(typeof Q!="object"||typeof W!="object"||!Q||!W)return new r(W,Q!==W);if(Array.isArray(Q)||Array.isArray(W)){const $e=Array.isArray(Q)&&Array.isArray(W)&&S.equals(Q,W);return new r(W,!$e)}let he=!1;for(const $e in W)if(W.hasOwnProperty($e)){const He=a(Q[$e],W[$e]);He.didChange&&(Q[$e]=He.newValue,he=!0)}return new r(Q,he)}class d{constructor(W){this.schema=void 0,this.id=W,this.name="_never_",this.defaultValue=void 0}applyUpdate(W,he){return a(W,he)}validate(W){return this.defaultValue}}class l{constructor(W,he,$e,He){this.id=W,this.name=he,this.defaultValue=$e,this.schema=He}applyUpdate(W,he){return a(W,he)}validate(W){return typeof W>"u"?this.defaultValue:W}compute(W,he,$e){return $e}}function i(Q,W){return typeof Q>"u"?W:Q==="false"?!1:!!Q}class n extends l{constructor(W,he,$e,He=void 0){typeof He<"u"&&(He.type="boolean",He.default=$e),super(W,he,$e,He)}validate(W){return i(W,this.defaultValue)}}function t(Q,W,he,$e){if(typeof Q>"u")return W;let He=parseInt(Q,10);return isNaN(He)?W:(He=Math.max(he,He),He=Math.min($e,He),He|0)}class o extends l{static clampedInt(W,he,$e,He){return t(W,he,$e,He)}constructor(W,he,$e,He,st,ht=void 0){typeof ht<"u"&&(ht.type="integer",ht.default=$e,ht.minimum=He,ht.maximum=st),super(W,he,$e,ht),this.minimum=He,this.maximum=st}validate(W){return o.clampedInt(W,this.defaultValue,this.minimum,this.maximum)}}function c(Q,W,he,$e){if(typeof Q>"u")return W;const He=g.float(Q,W);return g.clamp(He,he,$e)}class g extends l{static clamp(W,he,$e){return W<he?he:W>$e?$e:W}static float(W,he){if(typeof W=="number")return W;if(typeof W>"u")return he;const $e=parseFloat(W);return isNaN($e)?he:$e}constructor(W,he,$e,He,st){typeof st<"u"&&(st.type="number",st.default=$e),super(W,he,$e,st),this.validationFn=He}validate(W){return this.validationFn(g.float(W,this.defaultValue))}}class f extends l{static string(W,he){return typeof W!="string"?he:W}constructor(W,he,$e,He=void 0){typeof He<"u"&&(He.type="string",He.default=$e),super(W,he,$e,He)}validate(W){return f.string(W,this.defaultValue)}}function h(Q,W,he,$e){return typeof Q!="string"?W:$e&&Q in $e?$e[Q]:he.indexOf(Q)===-1?W:Q}class _ extends l{constructor(W,he,$e,He,st=void 0){typeof st<"u"&&(st.type="string",st.enum=He,st.default=$e),super(W,he,$e,st),this._allowedValues=He}validate(W){return h(W,this.defaultValue,this._allowedValues)}}class y extends v{constructor(W,he,$e,He,st,ht,mt=void 0){typeof mt<"u"&&(mt.type="string",mt.enum=st,mt.default=He),super(W,he,$e,mt),this._allowedValues=st,this._convert=ht}validate(W){return typeof W!="string"?this.defaultValue:this._allowedValues.indexOf(W)===-1?this.defaultValue:this._convert(W)}}function w(Q){switch(Q){case"none":return E.None;case"keep":return E.Keep;case"brackets":return E.Brackets;case"advanced":return E.Advanced;case"full":return E.Full}}class P extends v{constructor(){super(Se.accessibilitySupport,"accessibilitySupport",I.AccessibilitySupport.Unknown,{type:"string",enum:["auto","on","off"],enumDescriptions:[s.localize(302,null),s.localize(303,null),s.localize(304,null)],default:"auto",tags:["accessibility"],description:s.localize(305,null)})}validate(W){switch(W){case"auto":return I.AccessibilitySupport.Unknown;case"off":return I.AccessibilitySupport.Disabled;case"on":return I.AccessibilitySupport.Enabled}return this.defaultValue}compute(W,he,$e){return $e===I.AccessibilitySupport.Unknown?W.accessibilitySupport:$e}}class R extends v{constructor(){const W={insertSpace:!0,ignoreEmptyLines:!0};super(Se.comments,"comments",W,{"editor.comments.insertSpace":{type:"boolean",default:W.insertSpace,description:s.localize(306,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:W.ignoreEmptyLines,description:s.localize(307,null)}})}validate(W){if(!W||typeof W!="object")return this.defaultValue;const he=W;return{insertSpace:i(he.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:i(he.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var p;(function(Q){Q[Q.Hidden=0]="Hidden",Q[Q.Blink=1]="Blink",Q[Q.Smooth=2]="Smooth",Q[Q.Phase=3]="Phase",Q[Q.Expand=4]="Expand",Q[Q.Solid=5]="Solid"})(p||(e.TextEditorCursorBlinkingStyle=p={}));function b(Q){switch(Q){case"blink":return p.Blink;case"smooth":return p.Smooth;case"phase":return p.Phase;case"expand":return p.Expand;case"solid":return p.Solid}}var N;(function(Q){Q[Q.Line=1]="Line",Q[Q.Block=2]="Block",Q[Q.Underline=3]="Underline",Q[Q.LineThin=4]="LineThin",Q[Q.BlockOutline=5]="BlockOutline",Q[Q.UnderlineThin=6]="UnderlineThin"})(N||(e.TextEditorCursorStyle=N={}));function L(Q){switch(Q){case N.Line:return"line";case N.Block:return"block";case N.Underline:return"underline";case N.LineThin:return"line-thin";case N.BlockOutline:return"block-outline";case N.UnderlineThin:return"underline-thin"}}function F(Q){switch(Q){case"line":return N.Line;case"block":return N.Block;case"underline":return N.Underline;case"line-thin":return N.LineThin;case"block-outline":return N.BlockOutline;case"underline-thin":return N.UnderlineThin}}class K extends d{constructor(){super(Se.editorClassName)}compute(W,he,$e){const He=["monaco-editor"];return he.get(Se.extraEditorClassName)&&He.push(he.get(Se.extraEditorClassName)),W.extraEditorClassName&&He.push(W.extraEditorClassName),he.get(Se.mouseStyle)==="default"?He.push("mouse-default"):he.get(Se.mouseStyle)==="copy"&&He.push("mouse-copy"),he.get(Se.showUnused)&&He.push("showUnused"),he.get(Se.showDeprecated)&&He.push("showDeprecated"),He.join(" ")}}class J extends n{constructor(){super(Se.emptySelectionClipboard,"emptySelectionClipboard",!0,{description:s.localize(308,null)})}compute(W,he,$e){return $e&&W.emptySelectionClipboard}}class $ extends v{constructor(){const W={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(Se.find,"find",W,{"editor.find.cursorMoveOnType":{type:"boolean",default:W.cursorMoveOnType,description:s.localize(309,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:W.seedSearchStringFromSelection,enumDescriptions:[s.localize(310,null),s.localize(311,null),s.localize(312,null)],description:s.localize(313,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:W.autoFindInSelection,enumDescriptions:[s.localize(314,null),s.localize(315,null),s.localize(316,null)],description:s.localize(317,null)},"editor.find.globalFindClipboard":{type:"boolean",default:W.globalFindClipboard,description:s.localize(318,null),included:D.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:W.addExtraSpaceOnTop,description:s.localize(319,null)},"editor.find.loop":{type:"boolean",default:W.loop,description:s.localize(320,null)}})}validate(W){if(!W||typeof W!="object")return this.defaultValue;const he=W;return{cursorMoveOnType:i(he.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof W.seedSearchStringFromSelection=="boolean"?W.seedSearchStringFromSelection?"always":"never":h(he.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof W.autoFindInSelection=="boolean"?W.autoFindInSelection?"always":"never":h(he.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:i(he.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:i(he.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:i(he.loop,this.defaultValue.loop)}}}class x extends v{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(Se.fontLigatures,"fontLigatures",x.OFF,{anyOf:[{type:"boolean",description:s.localize(321,null)},{type:"string",description:s.localize(322,null)}],description:s.localize(323,null),default:!1})}validate(W){return typeof W>"u"?this.defaultValue:typeof W=="string"?W==="false"||W.length===0?x.OFF:W==="true"?x.ON:W:W?x.ON:x.OFF}}e.EditorFontLigatures=x;class G extends v{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(Se.fontVariations,"fontVariations",G.OFF,{anyOf:[{type:"boolean",description:s.localize(324,null)},{type:"string",description:s.localize(325,null)}],description:s.localize(326,null),default:!1})}validate(W){return typeof W>"u"?this.defaultValue:typeof W=="string"?W==="false"?G.OFF:W==="true"?G.TRANSLATE:W:W?G.TRANSLATE:G.OFF}compute(W,he,$e){return W.fontInfo.fontVariationSettings}}e.EditorFontVariations=G;class Y extends d{constructor(){super(Se.fontInfo)}compute(W,he,$e){return W.fontInfo}}class ae extends l{constructor(){super(Se.fontSize,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:s.localize(327,null)})}validate(W){const he=g.float(W,this.defaultValue);return he===0?e.EDITOR_FONT_DEFAULTS.fontSize:g.clamp(he,6,100)}compute(W,he,$e){return W.fontInfo.fontSize}}class ee extends v{static{this.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.MINIMUM_VALUE=1}static{this.MAXIMUM_VALUE=1e3}constructor(){super(Se.fontWeight,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:ee.MINIMUM_VALUE,maximum:ee.MAXIMUM_VALUE,errorMessage:s.localize(328,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:ee.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:s.localize(329,null)})}validate(W){return W==="normal"||W==="bold"?W:String(o.clampedInt(W,e.EDITOR_FONT_DEFAULTS.fontWeight,ee.MINIMUM_VALUE,ee.MAXIMUM_VALUE))}}class oe extends v{constructor(){const W={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",multipleTests:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:"",alternativeTestsCommand:""},he={type:"string",enum:["peek","gotoAndPeek","goto"],default:W.multiple,enumDescriptions:[s.localize(330,null),s.localize(331,null),s.localize(332,null)]},$e=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(Se.gotoLocation,"gotoLocation",W,{"editor.gotoLocation.multiple":{deprecationMessage:s.localize(333,null)},"editor.gotoLocation.multipleDefinitions":{description:s.localize(334,null),...he},"editor.gotoLocation.multipleTypeDefinitions":{description:s.localize(335,null),...he},"editor.gotoLocation.multipleDeclarations":{description:s.localize(336,null),...he},"editor.gotoLocation.multipleImplementations":{description:s.localize(337,null),...he},"editor.gotoLocation.multipleReferences":{description:s.localize(338,null),...he},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:W.alternativeDefinitionCommand,enum:$e,description:s.localize(339,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:W.alternativeTypeDefinitionCommand,enum:$e,description:s.localize(340,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:W.alternativeDeclarationCommand,enum:$e,description:s.localize(341,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:W.alternativeImplementationCommand,enum:$e,description:s.localize(342,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:W.alternativeReferenceCommand,enum:$e,description:s.localize(343,null)}})}validate(W){if(!W||typeof W!="object")return this.defaultValue;const he=W;return{multiple:h(he.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:he.multipleDefinitions??h(he.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:he.multipleTypeDefinitions??h(he.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:he.multipleDeclarations??h(he.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:he.multipleImplementations??h(he.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:he.multipleReferences??h(he.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),multipleTests:he.multipleTests??h(he.multipleTests,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:f.string(he.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:f.string(he.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:f.string(he.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:f.string(he.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:f.string(he.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand),alternativeTestsCommand:f.string(he.alternativeTestsCommand,this.defaultValue.alternativeTestsCommand)}}}class ie extends v{constructor(){const W={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(Se.hover,"hover",W,{"editor.hover.enabled":{type:"boolean",default:W.enabled,description:s.localize(344,null)},"editor.hover.delay":{type:"number",default:W.delay,minimum:0,maximum:1e4,description:s.localize(345,null)},"editor.hover.sticky":{type:"boolean",default:W.sticky,description:s.localize(346,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:W.hidingDelay,description:s.localize(347,null)},"editor.hover.above":{type:"boolean",default:W.above,description:s.localize(348,null)}})}validate(W){if(!W||typeof W!="object")return this.defaultValue;const he=W;return{enabled:i(he.enabled,this.defaultValue.enabled),delay:o.clampedInt(he.delay,this.defaultValue.delay,0,1e4),sticky:i(he.sticky,this.defaultValue.sticky),hidingDelay:o.clampedInt(he.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:i(he.above,this.defaultValue.above)}}}var ue;(function(Q){Q[Q.None=0]="None",Q[Q.Text=1]="Text",Q[Q.Blocks=2]="Blocks"})(ue||(e.RenderMinimap=ue={}));class Z extends d{constructor(){super(Se.layoutInfo)}compute(W,he,$e){return Z.computeLayout(he,{memory:W.memory,outerWidth:W.outerWidth,outerHeight:W.outerHeight,isDominatedByLongLines:W.isDominatedByLongLines,lineHeight:W.fontInfo.lineHeight,viewLineCount:W.viewLineCount,lineNumbersDigitCount:W.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:W.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:W.fontInfo.maxDigitWidth,pixelRatio:W.pixelRatio,glyphMarginDecorationLaneCount:W.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(W){const he=W.height/W.lineHeight,$e=Math.floor(W.paddingTop/W.lineHeight);let He=Math.floor(W.paddingBottom/W.lineHeight);W.scrollBeyondLastLine&&(He=Math.max(He,he-1));const st=($e+W.viewLineCount+He)/(W.pixelRatio*W.height),ht=Math.floor(W.viewLineCount/st);return{typicalViewportLineCount:he,extraLinesBeforeFirstLine:$e,extraLinesBeyondLastLine:He,desiredRatio:st,minimapLineCount:ht}}static _computeMinimapLayout(W,he){const $e=W.outerWidth,He=W.outerHeight,st=W.pixelRatio;if(!W.minimap.enabled)return{renderMinimap:ue.None,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(st*He),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:He};const ht=he.stableMinimapLayoutInput,mt=ht&&W.outerHeight===ht.outerHeight&&W.lineHeight===ht.lineHeight&&W.typicalHalfwidthCharacterWidth===ht.typicalHalfwidthCharacterWidth&&W.pixelRatio===ht.pixelRatio&&W.scrollBeyondLastLine===ht.scrollBeyondLastLine&&W.paddingTop===ht.paddingTop&&W.paddingBottom===ht.paddingBottom&&W.minimap.enabled===ht.minimap.enabled&&W.minimap.side===ht.minimap.side&&W.minimap.size===ht.minimap.size&&W.minimap.showSlider===ht.minimap.showSlider&&W.minimap.renderCharacters===ht.minimap.renderCharacters&&W.minimap.maxColumn===ht.minimap.maxColumn&&W.minimap.scale===ht.minimap.scale&&W.verticalScrollbarWidth===ht.verticalScrollbarWidth&&W.isViewportWrapping===ht.isViewportWrapping,Rt=W.lineHeight,At=W.typicalHalfwidthCharacterWidth,Ht=W.scrollBeyondLastLine,Zt=W.minimap.renderCharacters;let Xe=st>=2?Math.round(W.minimap.scale*2):W.minimap.scale;const Lt=W.minimap.maxColumn,xt=W.minimap.size,Et=W.minimap.side,Tt=W.verticalScrollbarWidth,ei=W.viewLineCount,ti=W.remainingWidth,qt=W.isViewportWrapping,bt=Zt?2:3;let Ot=Math.floor(st*He);const li=Ot/st;let Qt=!1,Ke=!1,ii=bt*Xe,ci=Xe/st,di=1;if(xt==="fill"||xt==="fit"){const{typicalViewportLineCount:ri,extraLinesBeforeFirstLine:Kt,extraLinesBeyondLastLine:Gt,desiredRatio:ui,minimapLineCount:Mt}=Z.computeContainedMinimapLineCount({viewLineCount:ei,scrollBeyondLastLine:Ht,paddingTop:W.paddingTop,paddingBottom:W.paddingBottom,height:He,lineHeight:Rt,pixelRatio:st});if(ei/Mt>1)Qt=!0,Ke=!0,Xe=1,ii=1,ci=Xe/st;else{let St=!1,Xt=Xe+1;if(xt==="fit"){const yt=Math.ceil((Kt+ei+Gt)*ii);qt&&mt&&ti<=he.stableFitRemainingWidth?(St=!0,Xt=he.stableFitMaxMinimapScale):St=yt>Ot}if(xt==="fill"||St){Qt=!0;const yt=Xe;ii=Math.min(Rt*st,Math.max(1,Math.floor(1/ui))),qt&&mt&&ti<=he.stableFitRemainingWidth&&(Xt=he.stableFitMaxMinimapScale),Xe=Math.min(Xt,Math.max(1,Math.floor(ii/bt))),Xe>yt&&(di=Math.min(2,Xe/yt)),ci=Xe/st/di,Ot=Math.ceil(Math.max(ri,Kt+ei+Gt)*ii),qt?(he.stableMinimapLayoutInput=W,he.stableFitRemainingWidth=ti,he.stableFitMaxMinimapScale=Xe):(he.stableMinimapLayoutInput=null,he.stableFitRemainingWidth=0)}}}const Ct=Math.floor(Lt*ci),$t=Math.min(Ct,Math.max(0,Math.floor((ti-Tt-2)*ci/(At+ci)))+e.MINIMAP_GUTTER_WIDTH);let Nt=Math.floor(st*$t);const zt=Nt/st;Nt=Math.floor(Nt*di);const ai=Zt?ue.Text:ue.Blocks,ni=Et==="left"?0:$e-$t-Tt;return{renderMinimap:ai,minimapLeft:ni,minimapWidth:$t,minimapHeightIsEditorHeight:Qt,minimapIsSampling:Ke,minimapScale:Xe,minimapLineHeight:ii,minimapCanvasInnerWidth:Nt,minimapCanvasInnerHeight:Ot,minimapCanvasOuterWidth:zt,minimapCanvasOuterHeight:li}}static computeLayout(W,he){const $e=he.outerWidth|0,He=he.outerHeight|0,st=he.lineHeight|0,ht=he.lineNumbersDigitCount|0,mt=he.typicalHalfwidthCharacterWidth,Rt=he.maxDigitWidth,At=he.pixelRatio,Ht=he.viewLineCount,Zt=W.get(Se.wordWrapOverride2),Xe=Zt==="inherit"?W.get(Se.wordWrapOverride1):Zt,Lt=Xe==="inherit"?W.get(Se.wordWrap):Xe,xt=W.get(Se.wordWrapColumn),Et=he.isDominatedByLongLines,Tt=W.get(Se.glyphMargin),ei=W.get(Se.lineNumbers).renderType!==et.Off,ti=W.get(Se.lineNumbersMinChars),qt=W.get(Se.scrollBeyondLastLine),bt=W.get(Se.padding),Ot=W.get(Se.minimap),li=W.get(Se.scrollbar),Qt=li.verticalScrollbarSize,Ke=li.verticalHasArrows,ii=li.arrowSize,ci=li.horizontalScrollbarSize,di=W.get(Se.folding),Ct=W.get(Se.showFoldingControls)!=="never";let $t=W.get(Se.lineDecorationsWidth);di&&Ct&&($t+=16);let Nt=0;if(ei){const Yt=Math.max(ht,ti);Nt=Math.round(Yt*Rt)}let zt=0;Tt&&(zt=st*he.glyphMarginDecorationLaneCount);let ai=0,ni=ai+zt,ri=ni+Nt,Kt=ri+$t;const Gt=$e-zt-Nt-$t;let ui=!1,Mt=!1,Pt=-1;Xe==="inherit"&&Et?(ui=!0,Mt=!0):Lt==="on"||Lt==="bounded"?Mt=!0:Lt==="wordWrapColumn"&&(Pt=xt);const St=Z._computeMinimapLayout({outerWidth:$e,outerHeight:He,lineHeight:st,typicalHalfwidthCharacterWidth:mt,pixelRatio:At,scrollBeyondLastLine:qt,paddingTop:bt.top,paddingBottom:bt.bottom,minimap:Ot,verticalScrollbarWidth:Qt,viewLineCount:Ht,remainingWidth:Gt,isViewportWrapping:Mt},he.memory||new C);St.renderMinimap!==ue.None&&St.minimapLeft===0&&(ai+=St.minimapWidth,ni+=St.minimapWidth,ri+=St.minimapWidth,Kt+=St.minimapWidth);const Xt=Gt-St.minimapWidth,yt=Math.max(1,Math.floor((Xt-Qt-2)/mt)),si=Ke?ii:0;return Mt&&(Pt=Math.max(1,yt),Lt==="bounded"&&(Pt=Math.min(Pt,xt))),{width:$e,height:He,glyphMarginLeft:ai,glyphMarginWidth:zt,glyphMarginDecorationLaneCount:he.glyphMarginDecorationLaneCount,lineNumbersLeft:ni,lineNumbersWidth:Nt,decorationsLeft:ri,decorationsWidth:$t,contentLeft:Kt,contentWidth:Xt,minimap:St,viewportColumn:yt,isWordWrapMinified:ui,isViewportWrapping:Mt,wrappingColumn:Pt,verticalScrollbarWidth:Qt,horizontalScrollbarHeight:ci,overviewRuler:{top:si,width:Qt,height:He-2*si,right:0}}}}e.EditorLayoutInfoComputer=Z;class ve extends v{constructor(){super(Se.wrappingStrategy,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[s.localize(349,null),s.localize(350,null)],type:"string",enum:["simple","advanced"],default:"simple",description:s.localize(351,null)}})}validate(W){return h(W,"simple",["simple","advanced"])}compute(W,he,$e){return he.get(Se.accessibilitySupport)===I.AccessibilitySupport.Enabled?"advanced":$e}}var Ie;(function(Q){Q.Off="off",Q.OnCode="onCode",Q.On="on"})(Ie||(e.ShowLightbulbIconMode=Ie={}));class X extends v{constructor(){const W={enabled:Ie.OnCode};super(Se.lightbulb,"lightbulb",W,{"editor.lightbulb.enabled":{type:"string",tags:["experimental"],enum:[Ie.Off,Ie.OnCode,Ie.On],default:W.enabled,enumDescriptions:[s.localize(352,null),s.localize(353,null),s.localize(354,null)],description:s.localize(355,null)}})}validate(W){return!W||typeof W!="object"?this.defaultValue:{enabled:h(W.enabled,this.defaultValue.enabled,[Ie.Off,Ie.OnCode,Ie.On])}}}class V extends v{constructor(){const W={enabled:!0,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(Se.stickyScroll,"stickyScroll",W,{"editor.stickyScroll.enabled":{type:"boolean",default:W.enabled,description:s.localize(356,null),tags:["experimental"]},"editor.stickyScroll.maxLineCount":{type:"number",default:W.maxLineCount,minimum:1,maximum:20,description:s.localize(357,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:W.defaultModel,description:s.localize(358,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:W.scrollWithEditor,description:s.localize(359,null)}})}validate(W){if(!W||typeof W!="object")return this.defaultValue;const he=W;return{enabled:i(he.enabled,this.defaultValue.enabled),maxLineCount:o.clampedInt(he.maxLineCount,this.defaultValue.maxLineCount,1,20),defaultModel:h(he.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:i(he.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class re extends v{constructor(){const W={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(Se.inlayHints,"inlayHints",W,{"editor.inlayHints.enabled":{type:"string",default:W.enabled,description:s.localize(360,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[s.localize(361,null),s.localize(362,null,D.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),s.localize(363,null,D.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),s.localize(364,null)]},"editor.inlayHints.fontSize":{type:"number",default:W.fontSize,markdownDescription:s.localize(365,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:W.fontFamily,markdownDescription:s.localize(366,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:W.padding,description:s.localize(367,null)}})}validate(W){if(!W||typeof W!="object")return this.defaultValue;const he=W;return typeof he.enabled=="boolean"&&(he.enabled=he.enabled?"on":"off"),{enabled:h(he.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:o.clampedInt(he.fontSize,this.defaultValue.fontSize,0,100),fontFamily:f.string(he.fontFamily,this.defaultValue.fontFamily),padding:i(he.padding,this.defaultValue.padding)}}}class be extends v{constructor(){super(Se.lineDecorationsWidth,"lineDecorationsWidth",10)}validate(W){return typeof W=="string"&&/^\d+(\.\d+)?ch$/.test(W)?-parseFloat(W.substring(0,W.length-2)):o.clampedInt(W,this.defaultValue,0,1e3)}compute(W,he,$e){return $e<0?o.clampedInt(-$e*W.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):$e}}class De extends g{constructor(){super(Se.lineHeight,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,W=>g.clamp(W,0,150),{markdownDescription:s.localize(368,null)})}compute(W,he,$e){return W.fontInfo.lineHeight}}class Fe extends v{constructor(){const W={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1,showRegionSectionHeaders:!0,showMarkSectionHeaders:!0,sectionHeaderFontSize:9,sectionHeaderLetterSpacing:1};super(Se.minimap,"minimap",W,{"editor.minimap.enabled":{type:"boolean",default:W.enabled,description:s.localize(369,null)},"editor.minimap.autohide":{type:"boolean",default:W.autohide,description:s.localize(370,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[s.localize(371,null),s.localize(372,null),s.localize(373,null)],default:W.size,description:s.localize(374,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:W.side,description:s.localize(375,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:W.showSlider,description:s.localize(376,null)},"editor.minimap.scale":{type:"number",default:W.scale,minimum:1,maximum:3,enum:[1,2,3],description:s.localize(377,null)},"editor.minimap.renderCharacters":{type:"boolean",default:W.renderCharacters,description:s.localize(378,null)},"editor.minimap.maxColumn":{type:"number",default:W.maxColumn,description:s.localize(379,null)},"editor.minimap.showRegionSectionHeaders":{type:"boolean",default:W.showRegionSectionHeaders,description:s.localize(380,null)},"editor.minimap.showMarkSectionHeaders":{type:"boolean",default:W.showMarkSectionHeaders,description:s.localize(381,null)},"editor.minimap.sectionHeaderFontSize":{type:"number",default:W.sectionHeaderFontSize,description:s.localize(382,null)},"editor.minimap.sectionHeaderLetterSpacing":{type:"number",default:W.sectionHeaderLetterSpacing,description:s.localize(383,null)}})}validate(W){if(!W||typeof W!="object")return this.defaultValue;const he=W;return{enabled:i(he.enabled,this.defaultValue.enabled),autohide:i(he.autohide,this.defaultValue.autohide),size:h(he.size,this.defaultValue.size,["proportional","fill","fit"]),side:h(he.side,this.defaultValue.side,["right","left"]),showSlider:h(he.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:i(he.renderCharacters,this.defaultValue.renderCharacters),scale:o.clampedInt(he.scale,1,1,3),maxColumn:o.clampedInt(he.maxColumn,this.defaultValue.maxColumn,1,1e4),showRegionSectionHeaders:i(he.showRegionSectionHeaders,this.defaultValue.showRegionSectionHeaders),showMarkSectionHeaders:i(he.showMarkSectionHeaders,this.defaultValue.showMarkSectionHeaders),sectionHeaderFontSize:g.clamp(he.sectionHeaderFontSize??this.defaultValue.sectionHeaderFontSize,4,32),sectionHeaderLetterSpacing:g.clamp(he.sectionHeaderLetterSpacing??this.defaultValue.sectionHeaderLetterSpacing,0,5)}}}function ze(Q){return Q==="ctrlCmd"?D.isMacintosh?"metaKey":"ctrlKey":"altKey"}class Je extends v{constructor(){super(Se.padding,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:s.localize(384,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:s.localize(385,null)}})}validate(W){if(!W||typeof W!="object")return this.defaultValue;const he=W;return{top:o.clampedInt(he.top,0,0,1e3),bottom:o.clampedInt(he.bottom,0,0,1e3)}}}class nt extends v{constructor(){const W={enabled:!0,cycle:!0};super(Se.parameterHints,"parameterHints",W,{"editor.parameterHints.enabled":{type:"boolean",default:W.enabled,description:s.localize(386,null)},"editor.parameterHints.cycle":{type:"boolean",default:W.cycle,description:s.localize(387,null)}})}validate(W){if(!W||typeof W!="object")return this.defaultValue;const he=W;return{enabled:i(he.enabled,this.defaultValue.enabled),cycle:i(he.cycle,this.defaultValue.cycle)}}}class dt extends d{constructor(){super(Se.pixelRatio)}compute(W,he,$e){return W.pixelRatio}}class vt extends v{constructor(){super(Se.placeholder,"placeholder",void 0)}validate(W){return typeof W>"u"?this.defaultValue:typeof W=="string"?W:this.defaultValue}}class ut extends v{constructor(){const W={other:"on",comments:"off",strings:"off"},he=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[s.localize(388,null),s.localize(389,null),s.localize(390,null)]}];super(Se.quickSuggestions,"quickSuggestions",W,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:he,default:W.strings,description:s.localize(391,null)},comments:{anyOf:he,default:W.comments,description:s.localize(392,null)},other:{anyOf:he,default:W.other,description:s.localize(393,null)}},default:W,markdownDescription:s.localize(394,null,"`#editor.suggestOnTriggerCharacters#`")}),this.defaultValue=W}validate(W){if(typeof W=="boolean"){const At=W?"on":"off";return{comments:At,strings:At,other:At}}if(!W||typeof W!="object")return this.defaultValue;const{other:he,comments:$e,strings:He}=W,st=["on","inline","off"];let ht,mt,Rt;return typeof he=="boolean"?ht=he?"on":"off":ht=h(he,this.defaultValue.other,st),typeof $e=="boolean"?mt=$e?"on":"off":mt=h($e,this.defaultValue.comments,st),typeof He=="boolean"?Rt=He?"on":"off":Rt=h(He,this.defaultValue.strings,st),{other:ht,comments:mt,strings:Rt}}}var et;(function(Q){Q[Q.Off=0]="Off",Q[Q.On=1]="On",Q[Q.Relative=2]="Relative",Q[Q.Interval=3]="Interval",Q[Q.Custom=4]="Custom"})(et||(e.RenderLineNumbersType=et={}));class Oe extends v{constructor(){super(Se.lineNumbers,"lineNumbers",{renderType:et.On,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[s.localize(395,null),s.localize(396,null),s.localize(397,null),s.localize(398,null)],default:"on",description:s.localize(399,null)})}validate(W){let he=this.defaultValue.renderType,$e=this.defaultValue.renderFn;return typeof W<"u"&&(typeof W=="function"?(he=et.Custom,$e=W):W==="interval"?he=et.Interval:W==="relative"?he=et.Relative:W==="on"?he=et.On:he=et.Off),{renderType:he,renderFn:$e}}}function Me(Q){const W=Q.get(Se.renderValidationDecorations);return W==="editable"?Q.get(Se.readOnly):W!=="on"}class Ne extends v{constructor(){const W=[],he={type:"number",description:s.localize(400,null)};super(Se.rulers,"rulers",W,{type:"array",items:{anyOf:[he,{type:["object"],properties:{column:he,color:{type:"string",description:s.localize(401,null),format:"color-hex"}}}]},default:W,description:s.localize(402,null)})}validate(W){if(Array.isArray(W)){const he=[];for(const $e of W)if(typeof $e=="number")he.push({column:o.clampedInt($e,0,0,1e4),color:null});else if($e&&typeof $e=="object"){const He=$e;he.push({column:o.clampedInt(He.column,0,0,1e4),color:He.color})}return he.sort(($e,He)=>$e.column-He.column),he}return this.defaultValue}}class B extends v{constructor(){super(Se.readOnlyMessage,"readOnlyMessage",void 0)}validate(W){return!W||typeof W!="object"?this.defaultValue:W}}function z(Q,W){if(typeof Q!="string")return W;switch(Q){case"hidden":return O.ScrollbarVisibility.Hidden;case"visible":return O.ScrollbarVisibility.Visible;default:return O.ScrollbarVisibility.Auto}}class H extends v{constructor(){const W={vertical:O.ScrollbarVisibility.Auto,horizontal:O.ScrollbarVisibility.Auto,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1,ignoreHorizontalScrollbarInContentHeight:!1};super(Se.scrollbar,"scrollbar",W,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[s.localize(403,null),s.localize(404,null),s.localize(405,null)],default:"auto",description:s.localize(406,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[s.localize(407,null),s.localize(408,null),s.localize(409,null)],default:"auto",description:s.localize(410,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:W.verticalScrollbarSize,description:s.localize(411,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:W.horizontalScrollbarSize,description:s.localize(412,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:W.scrollByPage,description:s.localize(413,null)},"editor.scrollbar.ignoreHorizontalScrollbarInContentHeight":{type:"boolean",default:W.ignoreHorizontalScrollbarInContentHeight,description:s.localize(414,null)}})}validate(W){if(!W||typeof W!="object")return this.defaultValue;const he=W,$e=o.clampedInt(he.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),He=o.clampedInt(he.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:o.clampedInt(he.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:z(he.vertical,this.defaultValue.vertical),horizontal:z(he.horizontal,this.defaultValue.horizontal),useShadows:i(he.useShadows,this.defaultValue.useShadows),verticalHasArrows:i(he.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:i(he.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:i(he.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:i(he.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:$e,horizontalSliderSize:o.clampedInt(he.horizontalSliderSize,$e,0,1e3),verticalScrollbarSize:He,verticalSliderSize:o.clampedInt(he.verticalSliderSize,He,0,1e3),scrollByPage:i(he.scrollByPage,this.defaultValue.scrollByPage),ignoreHorizontalScrollbarInContentHeight:i(he.ignoreHorizontalScrollbarInContentHeight,this.defaultValue.ignoreHorizontalScrollbarInContentHeight)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class q extends v{constructor(){const W={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(Se.unicodeHighlighting,"unicodeHighlight",W,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:W.nonBasicASCII,description:s.localize(415,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:W.invisibleCharacters,description:s.localize(416,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:W.ambiguousCharacters,description:s.localize(417,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:W.includeComments,description:s.localize(418,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:W.includeStrings,description:s.localize(419,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:W.allowedCharacters,description:s.localize(420,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:W.allowedLocales,description:s.localize(421,null)}})}applyUpdate(W,he){let $e=!1;he.allowedCharacters&&W&&(T.equals(W.allowedCharacters,he.allowedCharacters)||(W={...W,allowedCharacters:he.allowedCharacters},$e=!0)),he.allowedLocales&&W&&(T.equals(W.allowedLocales,he.allowedLocales)||(W={...W,allowedLocales:he.allowedLocales},$e=!0));const He=super.applyUpdate(W,he);return $e?new r(He.newValue,!0):He}validate(W){if(!W||typeof W!="object")return this.defaultValue;const he=W;return{nonBasicASCII:Ge(he.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:i(he.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:i(he.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:Ge(he.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:Ge(he.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.validateBooleanMap(W.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.validateBooleanMap(W.allowedLocales,this.defaultValue.allowedLocales)}}validateBooleanMap(W,he){if(typeof W!="object"||!W)return he;const $e={};for(const[He,st]of Object.entries(W))st===!0&&($e[He]=!0);return $e}}class se extends v{constructor(){const W={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1,fontFamily:"default"};super(Se.inlineSuggest,"inlineSuggest",W,{"editor.inlineSuggest.enabled":{type:"boolean",default:W.enabled,description:s.localize(422,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:W.showToolbar,enum:["always","onHover","never"],enumDescriptions:[s.localize(423,null),s.localize(424,null),s.localize(425,null)],description:s.localize(426,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:W.suppressSuggestions,description:s.localize(427,null)},"editor.inlineSuggest.fontFamily":{type:"string",default:W.fontFamily,description:s.localize(428,null)}})}validate(W){if(!W||typeof W!="object")return this.defaultValue;const he=W;return{enabled:i(he.enabled,this.defaultValue.enabled),mode:h(he.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:h(he.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),suppressSuggestions:i(he.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:i(he.keepOnBlur,this.defaultValue.keepOnBlur),fontFamily:f.string(he.fontFamily,this.defaultValue.fontFamily)}}}class ge extends v{constructor(){const W={enabled:!1,showToolbar:"onHover",fontFamily:"default",keepOnBlur:!1};super(Se.inlineEdit,"experimentalInlineEdit",W,{"editor.experimentalInlineEdit.enabled":{type:"boolean",default:W.enabled,description:s.localize(429,null)},"editor.experimentalInlineEdit.showToolbar":{type:"string",default:W.showToolbar,enum:["always","onHover","never"],enumDescriptions:[s.localize(430,null),s.localize(431,null),s.localize(432,null)],description:s.localize(433,null)},"editor.experimentalInlineEdit.fontFamily":{type:"string",default:W.fontFamily,description:s.localize(434,null)}})}validate(W){if(!W||typeof W!="object")return this.defaultValue;const he=W;return{enabled:i(he.enabled,this.defaultValue.enabled),showToolbar:h(he.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),fontFamily:f.string(he.fontFamily,this.defaultValue.fontFamily),keepOnBlur:i(he.keepOnBlur,this.defaultValue.keepOnBlur)}}}class ye extends v{constructor(){const W={enabled:A.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:A.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(Se.bracketPairColorization,"bracketPairColorization",W,{"editor.bracketPairColorization.enabled":{type:"boolean",default:W.enabled,markdownDescription:s.localize(435,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:W.independentColorPoolPerBracketType,description:s.localize(436,null)}})}validate(W){if(!W||typeof W!="object")return this.defaultValue;const he=W;return{enabled:i(he.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:i(he.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class Ue extends v{constructor(){const W={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(Se.guides,"guides",W,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[s.localize(437,null),s.localize(438,null),s.localize(439,null)],default:W.bracketPairs,description:s.localize(440,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[s.localize(441,null),s.localize(442,null),s.localize(443,null)],default:W.bracketPairsHorizontal,description:s.localize(444,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:W.highlightActiveBracketPair,description:s.localize(445,null)},"editor.guides.indentation":{type:"boolean",default:W.indentation,description:s.localize(446,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[s.localize(447,null),s.localize(448,null),s.localize(449,null)],default:W.highlightActiveIndentation,description:s.localize(450,null)}})}validate(W){if(!W||typeof W!="object")return this.defaultValue;const he=W;return{bracketPairs:Ge(he.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:Ge(he.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:i(he.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:i(he.indentation,this.defaultValue.indentation),highlightActiveIndentation:Ge(he.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function Ge(Q,W,he){const $e=he.indexOf(Q);return $e===-1?W:he[$e]}class Ze extends v{constructor(){const W={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(Se.suggest,"suggest",W,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[s.localize(451,null),s.localize(452,null)],default:W.insertMode,description:s.localize(453,null)},"editor.suggest.filterGraceful":{type:"boolean",default:W.filterGraceful,description:s.localize(454,null)},"editor.suggest.localityBonus":{type:"boolean",default:W.localityBonus,description:s.localize(455,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:W.shareSuggestSelections,markdownDescription:s.localize(456,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[s.localize(457,null),s.localize(458,null),s.localize(459,null),s.localize(460,null)],default:W.selectionMode,markdownDescription:s.localize(461,null,"`#editor.quickSuggestions#`","`#editor.suggestOnTriggerCharacters#`")},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:W.snippetsPreventQuickSuggestions,description:s.localize(462,null)},"editor.suggest.showIcons":{type:"boolean",default:W.showIcons,description:s.localize(463,null)},"editor.suggest.showStatusBar":{type:"boolean",default:W.showStatusBar,description:s.localize(464,null)},"editor.suggest.preview":{type:"boolean",default:W.preview,description:s.localize(465,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:W.showInlineDetails,description:s.localize(466,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:s.localize(467,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:s.localize(468,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:s.localize(469,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:s.localize(470,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:s.localize(471,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:s.localize(472,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:s.localize(473,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:s.localize(474,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:s.localize(475,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:s.localize(476,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:s.localize(477,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:s.localize(478,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:s.localize(479,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:s.localize(480,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:s.localize(481,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:s.localize(482,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:s.localize(483,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:s.localize(484,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:s.localize(485,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:s.localize(486,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:s.localize(487,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:s.localize(488,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:s.localize(489,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:s.localize(490,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:s.localize(491,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:s.localize(492,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:s.localize(493,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:s.localize(494,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:s.localize(495,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:s.localize(496,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:s.localize(497,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:s.localize(498,null)}})}validate(W){if(!W||typeof W!="object")return this.defaultValue;const he=W;return{insertMode:h(he.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:i(he.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:i(he.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:i(he.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:i(he.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:h(he.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:i(he.showIcons,this.defaultValue.showIcons),showStatusBar:i(he.showStatusBar,this.defaultValue.showStatusBar),preview:i(he.preview,this.defaultValue.preview),previewMode:h(he.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:i(he.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:i(he.showMethods,this.defaultValue.showMethods),showFunctions:i(he.showFunctions,this.defaultValue.showFunctions),showConstructors:i(he.showConstructors,this.defaultValue.showConstructors),showDeprecated:i(he.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:i(he.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:i(he.showFields,this.defaultValue.showFields),showVariables:i(he.showVariables,this.defaultValue.showVariables),showClasses:i(he.showClasses,this.defaultValue.showClasses),showStructs:i(he.showStructs,this.defaultValue.showStructs),showInterfaces:i(he.showInterfaces,this.defaultValue.showInterfaces),showModules:i(he.showModules,this.defaultValue.showModules),showProperties:i(he.showProperties,this.defaultValue.showProperties),showEvents:i(he.showEvents,this.defaultValue.showEvents),showOperators:i(he.showOperators,this.defaultValue.showOperators),showUnits:i(he.showUnits,this.defaultValue.showUnits),showValues:i(he.showValues,this.defaultValue.showValues),showConstants:i(he.showConstants,this.defaultValue.showConstants),showEnums:i(he.showEnums,this.defaultValue.showEnums),showEnumMembers:i(he.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:i(he.showKeywords,this.defaultValue.showKeywords),showWords:i(he.showWords,this.defaultValue.showWords),showColors:i(he.showColors,this.defaultValue.showColors),showFiles:i(he.showFiles,this.defaultValue.showFiles),showReferences:i(he.showReferences,this.defaultValue.showReferences),showFolders:i(he.showFolders,this.defaultValue.showFolders),showTypeParameters:i(he.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:i(he.showSnippets,this.defaultValue.showSnippets),showUsers:i(he.showUsers,this.defaultValue.showUsers),showIssues:i(he.showIssues,this.defaultValue.showIssues)}}}class tt extends v{constructor(){super(Se.smartSelect,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:s.localize(499,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:s.localize(500,null),default:!0,type:"boolean"}})}validate(W){return!W||typeof W!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:i(W.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:i(W.selectSubwords,this.defaultValue.selectSubwords)}}}class lt extends v{constructor(){const W=[];super(Se.wordSegmenterLocales,"wordSegmenterLocales",W,{anyOf:[{description:s.localize(501,null),type:"string"},{description:s.localize(502,null),type:"array",items:{type:"string"}}]})}validate(W){if(typeof W=="string"&&(W=[W]),Array.isArray(W)){const he=[];for(const $e of W)if(typeof $e=="string")try{Intl.Segmenter.supportedLocalesOf($e).length>0&&he.push($e)}catch{}return he}return this.defaultValue}}var it;(function(Q){Q[Q.None=0]="None",Q[Q.Same=1]="Same",Q[Q.Indent=2]="Indent",Q[Q.DeepIndent=3]="DeepIndent"})(it||(e.WrappingIndent=it={}));class at extends v{constructor(){super(Se.wrappingIndent,"wrappingIndent",it.Same,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[s.localize(503,null),s.localize(504,null),s.localize(505,null),s.localize(506,null)],description:s.localize(507,null),default:"same"}})}validate(W){switch(W){case"none":return it.None;case"same":return it.Same;case"indent":return it.Indent;case"deepIndent":return it.DeepIndent}return it.Same}compute(W,he,$e){return he.get(Se.accessibilitySupport)===I.AccessibilitySupport.Enabled?it.None:$e}}class wt extends d{constructor(){super(Se.wrappingInfo)}compute(W,he,$e){const He=he.get(Se.layoutInfo);return{isDominatedByLongLines:W.isDominatedByLongLines,isWordWrapMinified:He.isWordWrapMinified,isViewportWrapping:He.isViewportWrapping,wrappingColumn:He.wrappingColumn}}}class Qe extends v{constructor(){const W={enabled:!0,showDropSelector:"afterDrop"};super(Se.dropIntoEditor,"dropIntoEditor",W,{"editor.dropIntoEditor.enabled":{type:"boolean",default:W.enabled,markdownDescription:s.localize(508,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:s.localize(509,null),enum:["afterDrop","never"],enumDescriptions:[s.localize(510,null),s.localize(511,null)],default:"afterDrop"}})}validate(W){if(!W||typeof W!="object")return this.defaultValue;const he=W;return{enabled:i(he.enabled,this.defaultValue.enabled),showDropSelector:h(he.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class de extends v{constructor(){const W={enabled:!0,showPasteSelector:"afterPaste"};super(Se.pasteAs,"pasteAs",W,{"editor.pasteAs.enabled":{type:"boolean",default:W.enabled,markdownDescription:s.localize(512,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:s.localize(513,null),enum:["afterPaste","never"],enumDescriptions:[s.localize(514,null),s.localize(515,null)],default:"afterPaste"}})}validate(W){if(!W||typeof W!="object")return this.defaultValue;const he=W;return{enabled:i(he.enabled,this.defaultValue.enabled),showPasteSelector:h(he.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const pe="Consolas, 'Courier New', monospace",we="Menlo, Monaco, 'Courier New', monospace",Pe="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:D.isMacintosh?we:D.isLinux?Pe:pe,fontWeight:"normal",fontSize:D.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function fe(Q){return e.editorOptionsRegistry[Q.id]=Q,Q}var Se;(function(Q){Q[Q.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",Q[Q.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",Q[Q.accessibilitySupport=2]="accessibilitySupport",Q[Q.accessibilityPageSize=3]="accessibilityPageSize",Q[Q.ariaLabel=4]="ariaLabel",Q[Q.ariaRequired=5]="ariaRequired",Q[Q.autoClosingBrackets=6]="autoClosingBrackets",Q[Q.autoClosingComments=7]="autoClosingComments",Q[Q.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",Q[Q.autoClosingDelete=9]="autoClosingDelete",Q[Q.autoClosingOvertype=10]="autoClosingOvertype",Q[Q.autoClosingQuotes=11]="autoClosingQuotes",Q[Q.autoIndent=12]="autoIndent",Q[Q.automaticLayout=13]="automaticLayout",Q[Q.autoSurround=14]="autoSurround",Q[Q.bracketPairColorization=15]="bracketPairColorization",Q[Q.guides=16]="guides",Q[Q.codeLens=17]="codeLens",Q[Q.codeLensFontFamily=18]="codeLensFontFamily",Q[Q.codeLensFontSize=19]="codeLensFontSize",Q[Q.colorDecorators=20]="colorDecorators",Q[Q.colorDecoratorsLimit=21]="colorDecoratorsLimit",Q[Q.columnSelection=22]="columnSelection",Q[Q.comments=23]="comments",Q[Q.contextmenu=24]="contextmenu",Q[Q.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",Q[Q.cursorBlinking=26]="cursorBlinking",Q[Q.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",Q[Q.cursorStyle=28]="cursorStyle",Q[Q.cursorSurroundingLines=29]="cursorSurroundingLines",Q[Q.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",Q[Q.cursorWidth=31]="cursorWidth",Q[Q.disableLayerHinting=32]="disableLayerHinting",Q[Q.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",Q[Q.domReadOnly=34]="domReadOnly",Q[Q.dragAndDrop=35]="dragAndDrop",Q[Q.dropIntoEditor=36]="dropIntoEditor",Q[Q.emptySelectionClipboard=37]="emptySelectionClipboard",Q[Q.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",Q[Q.extraEditorClassName=39]="extraEditorClassName",Q[Q.fastScrollSensitivity=40]="fastScrollSensitivity",Q[Q.find=41]="find",Q[Q.fixedOverflowWidgets=42]="fixedOverflowWidgets",Q[Q.folding=43]="folding",Q[Q.foldingStrategy=44]="foldingStrategy",Q[Q.foldingHighlight=45]="foldingHighlight",Q[Q.foldingImportsByDefault=46]="foldingImportsByDefault",Q[Q.foldingMaximumRegions=47]="foldingMaximumRegions",Q[Q.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",Q[Q.fontFamily=49]="fontFamily",Q[Q.fontInfo=50]="fontInfo",Q[Q.fontLigatures=51]="fontLigatures",Q[Q.fontSize=52]="fontSize",Q[Q.fontWeight=53]="fontWeight",Q[Q.fontVariations=54]="fontVariations",Q[Q.formatOnPaste=55]="formatOnPaste",Q[Q.formatOnType=56]="formatOnType",Q[Q.glyphMargin=57]="glyphMargin",Q[Q.gotoLocation=58]="gotoLocation",Q[Q.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",Q[Q.hover=60]="hover",Q[Q.inDiffEditor=61]="inDiffEditor",Q[Q.inlineSuggest=62]="inlineSuggest",Q[Q.inlineEdit=63]="inlineEdit",Q[Q.letterSpacing=64]="letterSpacing",Q[Q.lightbulb=65]="lightbulb",Q[Q.lineDecorationsWidth=66]="lineDecorationsWidth",Q[Q.lineHeight=67]="lineHeight",Q[Q.lineNumbers=68]="lineNumbers",Q[Q.lineNumbersMinChars=69]="lineNumbersMinChars",Q[Q.linkedEditing=70]="linkedEditing",Q[Q.links=71]="links",Q[Q.matchBrackets=72]="matchBrackets",Q[Q.minimap=73]="minimap",Q[Q.mouseStyle=74]="mouseStyle",Q[Q.mouseWheelScrollSensitivity=75]="mouseWheelScrollSensitivity",Q[Q.mouseWheelZoom=76]="mouseWheelZoom",Q[Q.multiCursorMergeOverlapping=77]="multiCursorMergeOverlapping",Q[Q.multiCursorModifier=78]="multiCursorModifier",Q[Q.multiCursorPaste=79]="multiCursorPaste",Q[Q.multiCursorLimit=80]="multiCursorLimit",Q[Q.occurrencesHighlight=81]="occurrencesHighlight",Q[Q.overviewRulerBorder=82]="overviewRulerBorder",Q[Q.overviewRulerLanes=83]="overviewRulerLanes",Q[Q.padding=84]="padding",Q[Q.pasteAs=85]="pasteAs",Q[Q.parameterHints=86]="parameterHints",Q[Q.peekWidgetDefaultFocus=87]="peekWidgetDefaultFocus",Q[Q.placeholder=88]="placeholder",Q[Q.definitionLinkOpensInPeek=89]="definitionLinkOpensInPeek",Q[Q.quickSuggestions=90]="quickSuggestions",Q[Q.quickSuggestionsDelay=91]="quickSuggestionsDelay",Q[Q.readOnly=92]="readOnly",Q[Q.readOnlyMessage=93]="readOnlyMessage",Q[Q.renameOnType=94]="renameOnType",Q[Q.renderControlCharacters=95]="renderControlCharacters",Q[Q.renderFinalNewline=96]="renderFinalNewline",Q[Q.renderLineHighlight=97]="renderLineHighlight",Q[Q.renderLineHighlightOnlyWhenFocus=98]="renderLineHighlightOnlyWhenFocus",Q[Q.renderValidationDecorations=99]="renderValidationDecorations",Q[Q.renderWhitespace=100]="renderWhitespace",Q[Q.revealHorizontalRightPadding=101]="revealHorizontalRightPadding",Q[Q.roundedSelection=102]="roundedSelection",Q[Q.rulers=103]="rulers",Q[Q.scrollbar=104]="scrollbar",Q[Q.scrollBeyondLastColumn=105]="scrollBeyondLastColumn",Q[Q.scrollBeyondLastLine=106]="scrollBeyondLastLine",Q[Q.scrollPredominantAxis=107]="scrollPredominantAxis",Q[Q.selectionClipboard=108]="selectionClipboard",Q[Q.selectionHighlight=109]="selectionHighlight",Q[Q.selectOnLineNumbers=110]="selectOnLineNumbers",Q[Q.showFoldingControls=111]="showFoldingControls",Q[Q.showUnused=112]="showUnused",Q[Q.snippetSuggestions=113]="snippetSuggestions",Q[Q.smartSelect=114]="smartSelect",Q[Q.smoothScrolling=115]="smoothScrolling",Q[Q.stickyScroll=116]="stickyScroll",Q[Q.stickyTabStops=117]="stickyTabStops",Q[Q.stopRenderingLineAfter=118]="stopRenderingLineAfter",Q[Q.suggest=119]="suggest",Q[Q.suggestFontSize=120]="suggestFontSize",Q[Q.suggestLineHeight=121]="suggestLineHeight",Q[Q.suggestOnTriggerCharacters=122]="suggestOnTriggerCharacters",Q[Q.suggestSelection=123]="suggestSelection",Q[Q.tabCompletion=124]="tabCompletion",Q[Q.tabIndex=125]="tabIndex",Q[Q.unicodeHighlighting=126]="unicodeHighlighting",Q[Q.unusualLineTerminators=127]="unusualLineTerminators",Q[Q.useShadowDOM=128]="useShadowDOM",Q[Q.useTabStops=129]="useTabStops",Q[Q.wordBreak=130]="wordBreak",Q[Q.wordSegmenterLocales=131]="wordSegmenterLocales",Q[Q.wordSeparators=132]="wordSeparators",Q[Q.wordWrap=133]="wordWrap",Q[Q.wordWrapBreakAfterCharacters=134]="wordWrapBreakAfterCharacters",Q[Q.wordWrapBreakBeforeCharacters=135]="wordWrapBreakBeforeCharacters",Q[Q.wordWrapColumn=136]="wordWrapColumn",Q[Q.wordWrapOverride1=137]="wordWrapOverride1",Q[Q.wordWrapOverride2=138]="wordWrapOverride2",Q[Q.wrappingIndent=139]="wrappingIndent",Q[Q.wrappingStrategy=140]="wrappingStrategy",Q[Q.showDeprecated=141]="showDeprecated",Q[Q.inlayHints=142]="inlayHints",Q[Q.editorClassName=143]="editorClassName",Q[Q.pixelRatio=144]="pixelRatio",Q[Q.tabFocusMode=145]="tabFocusMode",Q[Q.layoutInfo=146]="layoutInfo",Q[Q.wrappingInfo=147]="wrappingInfo",Q[Q.defaultColorDecorators=148]="defaultColorDecorators",Q[Q.colorDecoratorsActivatedOn=149]="colorDecoratorsActivatedOn",Q[Q.inlineCompletionsAccessibilityVerbose=150]="inlineCompletionsAccessibilityVerbose"})(Se||(e.EditorOption=Se={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:fe(new n(Se.acceptSuggestionOnCommitCharacter,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:s.localize(516,null)})),acceptSuggestionOnEnter:fe(new _(Se.acceptSuggestionOnEnter,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",s.localize(517,null),""],markdownDescription:s.localize(518,null)})),accessibilitySupport:fe(new P),accessibilityPageSize:fe(new o(Se.accessibilityPageSize,"accessibilityPageSize",10,1,k.Constants.MAX_SAFE_SMALL_INTEGER,{description:s.localize(519,null),tags:["accessibility"]})),ariaLabel:fe(new f(Se.ariaLabel,"ariaLabel",s.localize(520,null))),ariaRequired:fe(new n(Se.ariaRequired,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:fe(new n(Se.screenReaderAnnounceInlineSuggestion,"screenReaderAnnounceInlineSuggestion",!0,{description:s.localize(521,null),tags:["accessibility"]})),autoClosingBrackets:fe(new _(Se.autoClosingBrackets,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",s.localize(522,null),s.localize(523,null),""],description:s.localize(524,null)})),autoClosingComments:fe(new _(Se.autoClosingComments,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",s.localize(525,null),s.localize(526,null),""],description:s.localize(527,null)})),autoClosingDelete:fe(new _(Se.autoClosingDelete,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",s.localize(528,null),""],description:s.localize(529,null)})),autoClosingOvertype:fe(new _(Se.autoClosingOvertype,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",s.localize(530,null),""],description:s.localize(531,null)})),autoClosingQuotes:fe(new _(Se.autoClosingQuotes,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",s.localize(532,null),s.localize(533,null),""],description:s.localize(534,null)})),autoIndent:fe(new y(Se.autoIndent,"autoIndent",E.Full,"full",["none","keep","brackets","advanced","full"],w,{enumDescriptions:[s.localize(535,null),s.localize(536,null),s.localize(537,null),s.localize(538,null),s.localize(539,null)],description:s.localize(540,null)})),automaticLayout:fe(new n(Se.automaticLayout,"automaticLayout",!1)),autoSurround:fe(new _(Se.autoSurround,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[s.localize(541,null),s.localize(542,null),s.localize(543,null),""],description:s.localize(544,null)})),bracketPairColorization:fe(new ye),bracketPairGuides:fe(new Ue),stickyTabStops:fe(new n(Se.stickyTabStops,"stickyTabStops",!1,{description:s.localize(545,null)})),codeLens:fe(new n(Se.codeLens,"codeLens",!0,{description:s.localize(546,null)})),codeLensFontFamily:fe(new f(Se.codeLensFontFamily,"codeLensFontFamily","",{description:s.localize(547,null)})),codeLensFontSize:fe(new o(Se.codeLensFontSize,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:s.localize(548,null)})),colorDecorators:fe(new n(Se.colorDecorators,"colorDecorators",!0,{description:s.localize(549,null)})),colorDecoratorActivatedOn:fe(new _(Se.colorDecoratorsActivatedOn,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[s.localize(550,null),s.localize(551,null),s.localize(552,null)],description:s.localize(553,null)})),colorDecoratorsLimit:fe(new o(Se.colorDecoratorsLimit,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:s.localize(554,null)})),columnSelection:fe(new n(Se.columnSelection,"columnSelection",!1,{description:s.localize(555,null)})),comments:fe(new R),contextmenu:fe(new n(Se.contextmenu,"contextmenu",!0)),copyWithSyntaxHighlighting:fe(new n(Se.copyWithSyntaxHighlighting,"copyWithSyntaxHighlighting",!0,{description:s.localize(556,null)})),cursorBlinking:fe(new y(Se.cursorBlinking,"cursorBlinking",p.Blink,"blink",["blink","smooth","phase","expand","solid"],b,{description:s.localize(557,null)})),cursorSmoothCaretAnimation:fe(new _(Se.cursorSmoothCaretAnimation,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[s.localize(558,null),s.localize(559,null),s.localize(560,null)],description:s.localize(561,null)})),cursorStyle:fe(new y(Se.cursorStyle,"cursorStyle",N.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],F,{description:s.localize(562,null)})),cursorSurroundingLines:fe(new o(Se.cursorSurroundingLines,"cursorSurroundingLines",0,0,k.Constants.MAX_SAFE_SMALL_INTEGER,{description:s.localize(563,null)})),cursorSurroundingLinesStyle:fe(new _(Se.cursorSurroundingLinesStyle,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[s.localize(564,null),s.localize(565,null)],markdownDescription:s.localize(566,null)})),cursorWidth:fe(new o(Se.cursorWidth,"cursorWidth",0,0,k.Constants.MAX_SAFE_SMALL_INTEGER,{markdownDescription:s.localize(567,null)})),disableLayerHinting:fe(new n(Se.disableLayerHinting,"disableLayerHinting",!1)),disableMonospaceOptimizations:fe(new n(Se.disableMonospaceOptimizations,"disableMonospaceOptimizations",!1)),domReadOnly:fe(new n(Se.domReadOnly,"domReadOnly",!1)),dragAndDrop:fe(new n(Se.dragAndDrop,"dragAndDrop",!0,{description:s.localize(568,null)})),emptySelectionClipboard:fe(new J),dropIntoEditor:fe(new Qe),stickyScroll:fe(new V),experimentalWhitespaceRendering:fe(new _(Se.experimentalWhitespaceRendering,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[s.localize(569,null),s.localize(570,null),s.localize(571,null)],description:s.localize(572,null)})),extraEditorClassName:fe(new f(Se.extraEditorClassName,"extraEditorClassName","")),fastScrollSensitivity:fe(new g(Se.fastScrollSensitivity,"fastScrollSensitivity",5,Q=>Q<=0?5:Q,{markdownDescription:s.localize(573,null)})),find:fe(new $),fixedOverflowWidgets:fe(new n(Se.fixedOverflowWidgets,"fixedOverflowWidgets",!1)),folding:fe(new n(Se.folding,"folding",!0,{description:s.localize(574,null)})),foldingStrategy:fe(new _(Se.foldingStrategy,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[s.localize(575,null),s.localize(576,null)],description:s.localize(577,null)})),foldingHighlight:fe(new n(Se.foldingHighlight,"foldingHighlight",!0,{description:s.localize(578,null)})),foldingImportsByDefault:fe(new n(Se.foldingImportsByDefault,"foldingImportsByDefault",!1,{description:s.localize(579,null)})),foldingMaximumRegions:fe(new o(Se.foldingMaximumRegions,"foldingMaximumRegions",5e3,10,65e3,{description:s.localize(580,null)})),unfoldOnClickAfterEndOfLine:fe(new n(Se.unfoldOnClickAfterEndOfLine,"unfoldOnClickAfterEndOfLine",!1,{description:s.localize(581,null)})),fontFamily:fe(new f(Se.fontFamily,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:s.localize(582,null)})),fontInfo:fe(new Y),fontLigatures2:fe(new x),fontSize:fe(new ae),fontWeight:fe(new ee),fontVariations:fe(new G),formatOnPaste:fe(new n(Se.formatOnPaste,"formatOnPaste",!1,{description:s.localize(583,null)})),formatOnType:fe(new n(Se.formatOnType,"formatOnType",!1,{description:s.localize(584,null)})),glyphMargin:fe(new n(Se.glyphMargin,"glyphMargin",!0,{description:s.localize(585,null)})),gotoLocation:fe(new oe),hideCursorInOverviewRuler:fe(new n(Se.hideCursorInOverviewRuler,"hideCursorInOverviewRuler",!1,{description:s.localize(586,null)})),hover:fe(new ie),inDiffEditor:fe(new n(Se.inDiffEditor,"inDiffEditor",!1)),letterSpacing:fe(new g(Se.letterSpacing,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,Q=>g.clamp(Q,-5,20),{description:s.localize(587,null)})),lightbulb:fe(new X),lineDecorationsWidth:fe(new be),lineHeight:fe(new De),lineNumbers:fe(new Oe),lineNumbersMinChars:fe(new o(Se.lineNumbersMinChars,"lineNumbersMinChars",5,1,300)),linkedEditing:fe(new n(Se.linkedEditing,"linkedEditing",!1,{description:s.localize(588,null)})),links:fe(new n(Se.links,"links",!0,{description:s.localize(589,null)})),matchBrackets:fe(new _(Se.matchBrackets,"matchBrackets","always",["always","near","never"],{description:s.localize(590,null)})),minimap:fe(new Fe),mouseStyle:fe(new _(Se.mouseStyle,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:fe(new g(Se.mouseWheelScrollSensitivity,"mouseWheelScrollSensitivity",1,Q=>Q===0?1:Q,{markdownDescription:s.localize(591,null)})),mouseWheelZoom:fe(new n(Se.mouseWheelZoom,"mouseWheelZoom",!1,{markdownDescription:D.isMacintosh?s.localize(592,null):s.localize(593,null)})),multiCursorMergeOverlapping:fe(new n(Se.multiCursorMergeOverlapping,"multiCursorMergeOverlapping",!0,{description:s.localize(594,null)})),multiCursorModifier:fe(new y(Se.multiCursorModifier,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],ze,{markdownEnumDescriptions:[s.localize(595,null),s.localize(596,null)],markdownDescription:s.localize(597,null)})),multiCursorPaste:fe(new _(Se.multiCursorPaste,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[s.localize(598,null),s.localize(599,null)],markdownDescription:s.localize(600,null)})),multiCursorLimit:fe(new o(Se.multiCursorLimit,"multiCursorLimit",1e4,1,1e5,{markdownDescription:s.localize(601,null)})),occurrencesHighlight:fe(new _(Se.occurrencesHighlight,"occurrencesHighlight","singleFile",["off","singleFile","multiFile"],{markdownEnumDescriptions:[s.localize(602,null),s.localize(603,null),s.localize(604,null)],markdownDescription:s.localize(605,null)})),overviewRulerBorder:fe(new n(Se.overviewRulerBorder,"overviewRulerBorder",!0,{description:s.localize(606,null)})),overviewRulerLanes:fe(new o(Se.overviewRulerLanes,"overviewRulerLanes",3,0,3)),padding:fe(new Je),pasteAs:fe(new de),parameterHints:fe(new nt),peekWidgetDefaultFocus:fe(new _(Se.peekWidgetDefaultFocus,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[s.localize(607,null),s.localize(608,null)],description:s.localize(609,null)})),placeholder:fe(new vt),definitionLinkOpensInPeek:fe(new n(Se.definitionLinkOpensInPeek,"definitionLinkOpensInPeek",!1,{description:s.localize(610,null)})),quickSuggestions:fe(new ut),quickSuggestionsDelay:fe(new o(Se.quickSuggestionsDelay,"quickSuggestionsDelay",10,0,k.Constants.MAX_SAFE_SMALL_INTEGER,{description:s.localize(611,null)})),readOnly:fe(new n(Se.readOnly,"readOnly",!1)),readOnlyMessage:fe(new B),renameOnType:fe(new n(Se.renameOnType,"renameOnType",!1,{description:s.localize(612,null),markdownDeprecationMessage:s.localize(613,null)})),renderControlCharacters:fe(new n(Se.renderControlCharacters,"renderControlCharacters",!0,{description:s.localize(614,null),restricted:!0})),renderFinalNewline:fe(new _(Se.renderFinalNewline,"renderFinalNewline",D.isLinux?"dimmed":"on",["off","on","dimmed"],{description:s.localize(615,null)})),renderLineHighlight:fe(new _(Se.renderLineHighlight,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",s.localize(616,null)],description:s.localize(617,null)})),renderLineHighlightOnlyWhenFocus:fe(new n(Se.renderLineHighlightOnlyWhenFocus,"renderLineHighlightOnlyWhenFocus",!1,{description:s.localize(618,null)})),renderValidationDecorations:fe(new _(Se.renderValidationDecorations,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:fe(new _(Se.renderWhitespace,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",s.localize(619,null),s.localize(620,null),s.localize(621,null),""],description:s.localize(622,null)})),revealHorizontalRightPadding:fe(new o(Se.revealHorizontalRightPadding,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:fe(new n(Se.roundedSelection,"roundedSelection",!0,{description:s.localize(623,null)})),rulers:fe(new Ne),scrollbar:fe(new H),scrollBeyondLastColumn:fe(new o(Se.scrollBeyondLastColumn,"scrollBeyondLastColumn",4,0,k.Constants.MAX_SAFE_SMALL_INTEGER,{description:s.localize(624,null)})),scrollBeyondLastLine:fe(new n(Se.scrollBeyondLastLine,"scrollBeyondLastLine",!0,{description:s.localize(625,null)})),scrollPredominantAxis:fe(new n(Se.scrollPredominantAxis,"scrollPredominantAxis",!0,{description:s.localize(626,null)})),selectionClipboard:fe(new n(Se.selectionClipboard,"selectionClipboard",!0,{description:s.localize(627,null),included:D.isLinux})),selectionHighlight:fe(new n(Se.selectionHighlight,"selectionHighlight",!0,{description:s.localize(628,null)})),selectOnLineNumbers:fe(new n(Se.selectOnLineNumbers,"selectOnLineNumbers",!0)),showFoldingControls:fe(new _(Se.showFoldingControls,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[s.localize(629,null),s.localize(630,null),s.localize(631,null)],description:s.localize(632,null)})),showUnused:fe(new n(Se.showUnused,"showUnused",!0,{description:s.localize(633,null)})),showDeprecated:fe(new n(Se.showDeprecated,"showDeprecated",!0,{description:s.localize(634,null)})),inlayHints:fe(new re),snippetSuggestions:fe(new _(Se.snippetSuggestions,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[s.localize(635,null),s.localize(636,null),s.localize(637,null),s.localize(638,null)],description:s.localize(639,null)})),smartSelect:fe(new tt),smoothScrolling:fe(new n(Se.smoothScrolling,"smoothScrolling",!1,{description:s.localize(640,null)})),stopRenderingLineAfter:fe(new o(Se.stopRenderingLineAfter,"stopRenderingLineAfter",1e4,-1,k.Constants.MAX_SAFE_SMALL_INTEGER)),suggest:fe(new Ze),inlineSuggest:fe(new se),inlineEdit:fe(new ge),inlineCompletionsAccessibilityVerbose:fe(new n(Se.inlineCompletionsAccessibilityVerbose,"inlineCompletionsAccessibilityVerbose",!1,{description:s.localize(641,null)})),suggestFontSize:fe(new o(Se.suggestFontSize,"suggestFontSize",0,0,1e3,{markdownDescription:s.localize(642,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:fe(new o(Se.suggestLineHeight,"suggestLineHeight",0,0,1e3,{markdownDescription:s.localize(643,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:fe(new n(Se.suggestOnTriggerCharacters,"suggestOnTriggerCharacters",!0,{description:s.localize(644,null)})),suggestSelection:fe(new _(Se.suggestSelection,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[s.localize(645,null),s.localize(646,null),s.localize(647,null)],description:s.localize(648,null)})),tabCompletion:fe(new _(Se.tabCompletion,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[s.localize(649,null),s.localize(650,null),s.localize(651,null)],description:s.localize(652,null)})),tabIndex:fe(new o(Se.tabIndex,"tabIndex",0,-1,k.Constants.MAX_SAFE_SMALL_INTEGER)),unicodeHighlight:fe(new q),unusualLineTerminators:fe(new _(Se.unusualLineTerminators,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[s.localize(653,null),s.localize(654,null),s.localize(655,null)],description:s.localize(656,null)})),useShadowDOM:fe(new n(Se.useShadowDOM,"useShadowDOM",!0)),useTabStops:fe(new n(Se.useTabStops,"useTabStops",!0,{description:s.localize(657,null)})),wordBreak:fe(new _(Se.wordBreak,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[s.localize(658,null),s.localize(659,null)],description:s.localize(660,null)})),wordSegmenterLocales:fe(new lt),wordSeparators:fe(new f(Se.wordSeparators,"wordSeparators",m.USUAL_WORD_SEPARATORS,{description:s.localize(661,null)})),wordWrap:fe(new _(Se.wordWrap,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[s.localize(662,null),s.localize(663,null),s.localize(664,null),s.localize(665,null)],description:s.localize(666,null)})),wordWrapBreakAfterCharacters:fe(new f(Se.wordWrapBreakAfterCharacters,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:fe(new f(Se.wordWrapBreakBeforeCharacters,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:fe(new o(Se.wordWrapColumn,"wordWrapColumn",80,1,k.Constants.MAX_SAFE_SMALL_INTEGER,{markdownDescription:s.localize(667,null)})),wordWrapOverride1:fe(new _(Se.wordWrapOverride1,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:fe(new _(Se.wordWrapOverride2,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:fe(new K),defaultColorDecorators:fe(new n(Se.defaultColorDecorators,"defaultColorDecorators",!1,{markdownDescription:s.localize(668,null)})),pixelRatio:fe(new dt),tabFocusMode:fe(new n(Se.tabFocusMode,"tabFocusMode",!1,{markdownDescription:s.localize(669,null)})),layoutInfo:fe(new Z),wrappingInfo:fe(new wt),wrappingIndent:fe(new at),wrappingStrategy:fe(new ve)}}),define(ke[107],Re([1,0,3]),function(Ee,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,S.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,S.refineServiceDecorator)(e.IEnvironmentService)}),define(ke[28],Re([1,0,48,22,13,14,2,9,3,23,15,51]),function(Ee,e,S,T,D,O,k,A,m,s,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ByteSize=e.ETAG_DISABLED=e.FileKind=e.FILES_READONLY_FROM_PERMISSIONS_CONFIG=e.FILES_READONLY_EXCLUDE_CONFIG=e.FILES_READONLY_INCLUDE_CONFIG=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.TooLargeFileOperationError=e.FileOperationError=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FileChangeFilter=e.FilePermission=e.FileType=e.IFileService=void 0,e.isFileOpenForWriteOptions=u,e.isFileSystemWatcher=a,e.hasReadWriteCapability=l,e.hasFileFolderCopyCapability=i,e.hasFileCloneCapability=n,e.hasOpenReadWriteCloseCapability=t,e.hasFileReadStreamCapability=o,e.hasFileAtomicReadCapability=c,e.hasFileAtomicWriteCapability=g,e.hasFileAtomicDeleteCapability=f,e.hasReadonlyCapability=h,e.createFileSystemProviderError=w,e.ensureFileSystemProviderError=P,e.markAsFileSystemProviderError=R,e.toFileSystemProviderErrorCode=p,e.toFileOperationResult=b,e.isParent=J,e.etag=ee,e.whenProviderRegistered=oe,e.getLargeFileConfirmationLimit=ue,e.IFileService=(0,m.createDecorator)("fileService");function u(Z){return Z.create===!0}var C;(function(Z){Z[Z.Unknown=0]="Unknown",Z[Z.File=1]="File",Z[Z.Directory=2]="Directory",Z[Z.SymbolicLink=64]="SymbolicLink"})(C||(e.FileType=C={}));var v;(function(Z){Z[Z.Readonly=1]="Readonly",Z[Z.Locked=2]="Locked"})(v||(e.FilePermission=v={}));var r;(function(Z){Z[Z.UPDATED=2]="UPDATED",Z[Z.ADDED=4]="ADDED",Z[Z.DELETED=8]="DELETED"})(r||(e.FileChangeFilter=r={}));function a(Z){const ve=Z;return!!ve&&typeof ve.onDidChange=="function"}var d;(function(Z){Z[Z.None=0]="None",Z[Z.FileReadWrite=2]="FileReadWrite",Z[Z.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",Z[Z.FileReadStream=16]="FileReadStream",Z[Z.FileFolderCopy=8]="FileFolderCopy",Z[Z.PathCaseSensitive=1024]="PathCaseSensitive",Z[Z.Readonly=2048]="Readonly",Z[Z.Trash=4096]="Trash",Z[Z.FileWriteUnlock=8192]="FileWriteUnlock",Z[Z.FileAtomicRead=16384]="FileAtomicRead",Z[Z.FileAtomicWrite=32768]="FileAtomicWrite",Z[Z.FileAtomicDelete=65536]="FileAtomicDelete",Z[Z.FileClone=131072]="FileClone"})(d||(e.FileSystemProviderCapabilities=d={}));function l(Z){return!!(Z.capabilities&d.FileReadWrite)}function i(Z){return!!(Z.capabilities&d.FileFolderCopy)}function n(Z){return!!(Z.capabilities&d.FileClone)}function t(Z){return!!(Z.capabilities&d.FileOpenReadWriteClose)}function o(Z){return!!(Z.capabilities&d.FileReadStream)}function c(Z){return l(Z)?!!(Z.capabilities&d.FileAtomicRead):!1}function g(Z){return l(Z)?!!(Z.capabilities&d.FileAtomicWrite):!1}function f(Z){return!!(Z.capabilities&d.FileAtomicDelete)}function h(Z){return!!(Z.capabilities&d.Readonly)}var _;(function(Z){Z.FileExists="EntryExists",Z.FileNotFound="EntryNotFound",Z.FileNotADirectory="EntryNotADirectory",Z.FileIsADirectory="EntryIsADirectory",Z.FileExceedsStorageQuota="EntryExceedsStorageQuota",Z.FileTooLarge="EntryTooLarge",Z.FileWriteLocked="EntryWriteLocked",Z.NoPermissions="NoPermissions",Z.Unavailable="Unavailable",Z.Unknown="Unknown"})(_||(e.FileSystemProviderErrorCode=_={}));class y extends Error{static create(ve,Ie){const X=new y(ve.toString(),Ie);return R(X,Ie),X}constructor(ve,Ie){super(ve),this.code=Ie}}e.FileSystemProviderError=y;function w(Z,ve){return y.create(Z,ve)}function P(Z){return Z||w((0,A.localize)(1865,null),_.Unknown)}function R(Z,ve){return Z.name=ve?`${ve} (FileSystemError)`:"FileSystemError",Z}function p(Z){if(!Z)return _.Unknown;if(Z instanceof y)return Z.code;const ve=/^(.+) \(FileSystemError\)$/.exec(Z.name);if(!ve)return _.Unknown;switch(ve[1]){case _.FileExists:return _.FileExists;case _.FileIsADirectory:return _.FileIsADirectory;case _.FileNotADirectory:return _.FileNotADirectory;case _.FileNotFound:return _.FileNotFound;case _.FileTooLarge:return _.FileTooLarge;case _.FileWriteLocked:return _.FileWriteLocked;case _.NoPermissions:return _.NoPermissions;case _.Unavailable:return _.Unavailable}return _.Unknown}function b(Z){if(Z instanceof $)return Z.fileOperationResult;switch(p(Z)){case _.FileNotFound:return Y.FILE_NOT_FOUND;case _.FileIsADirectory:return Y.FILE_IS_DIRECTORY;case _.FileNotADirectory:return Y.FILE_NOT_DIRECTORY;case _.FileWriteLocked:return Y.FILE_WRITE_LOCKED;case _.NoPermissions:return Y.FILE_PERMISSION_DENIED;case _.FileExists:return Y.FILE_MOVE_CONFLICT;case _.FileTooLarge:return Y.FILE_TOO_LARGE;default:return Y.FILE_OTHER_ERROR}}var N;(function(Z){Z[Z.CREATE=0]="CREATE",Z[Z.DELETE=1]="DELETE",Z[Z.MOVE=2]="MOVE",Z[Z.COPY=3]="COPY",Z[Z.WRITE=4]="WRITE"})(N||(e.FileOperation=N={}));class L{constructor(ve,Ie,X){this.resource=ve,this.operation=Ie,this.target=X}isOperation(ve){return this.operation===ve}}e.FileOperationEvent=L;var F;(function(Z){Z[Z.UPDATED=0]="UPDATED",Z[Z.ADDED=1]="ADDED",Z[Z.DELETED=2]="DELETED"})(F||(e.FileChangeType=F={}));class K{static{this.MIXED_CORRELATION=null}constructor(ve,Ie){this.ignorePathCasing=Ie,this.correlationId=void 0,this.added=new E.Lazy(()=>{const X=S.TernarySearchTree.forUris(()=>this.ignorePathCasing);return X.fill(this.rawAdded.map(V=>[V,!0])),X}),this.updated=new E.Lazy(()=>{const X=S.TernarySearchTree.forUris(()=>this.ignorePathCasing);return X.fill(this.rawUpdated.map(V=>[V,!0])),X}),this.deleted=new E.Lazy(()=>{const X=S.TernarySearchTree.forUris(()=>this.ignorePathCasing);return X.fill(this.rawDeleted.map(V=>[V,!0])),X}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const X of ve){switch(X.type){case F.ADDED:this.rawAdded.push(X.resource);break;case F.UPDATED:this.rawUpdated.push(X.resource);break;case F.DELETED:this.rawDeleted.push(X.resource);break}this.correlationId!==K.MIXED_CORRELATION&&(typeof X.cId=="number"?this.correlationId===void 0?this.correlationId=X.cId:this.correlationId!==X.cId&&(this.correlationId=K.MIXED_CORRELATION):this.correlationId!==void 0&&(this.correlationId=K.MIXED_CORRELATION))}}contains(ve,...Ie){return this.doContains(ve,{includeChildren:!1},...Ie)}affects(ve,...Ie){return this.doContains(ve,{includeChildren:!0},...Ie)}doContains(ve,Ie,...X){if(!ve)return!1;const V=X.length>0;return!!((!V||X.includes(F.ADDED))&&(this.added.value.get(ve)||Ie.includeChildren&&this.added.value.findSuperstr(ve))||(!V||X.includes(F.UPDATED))&&(this.updated.value.get(ve)||Ie.includeChildren&&this.updated.value.findSuperstr(ve))||(!V||X.includes(F.DELETED))&&(this.deleted.value.findSubstr(ve)||Ie.includeChildren&&this.deleted.value.findSuperstr(ve)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(ve){return this.correlationId===ve}hasCorrelation(){return typeof this.correlationId=="number"}}e.FileChangesEvent=K;function J(Z,ve,Ie){return!Z||!ve||Z===ve||ve.length>Z.length?!1:(ve.charAt(ve.length-1)!==T.sep&&(ve+=T.sep),Ie?(0,D.startsWithIgnoreCase)(Z,ve):Z.indexOf(ve)===0)}class $ extends Error{constructor(ve,Ie,X){super(ve),this.fileOperationResult=Ie,this.options=X}}e.FileOperationError=$;class x extends ${constructor(ve,Ie,X,V){super(ve,Ie,V),this.fileOperationResult=Ie,this.size=X}}e.TooLargeFileOperationError=x;class G extends ${constructor(ve,Ie,X){super(ve,Y.FILE_NOT_MODIFIED_SINCE,X),this.stat=Ie}}e.NotModifiedSinceFileOperationError=G;var Y;(function(Z){Z[Z.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",Z[Z.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",Z[Z.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",Z[Z.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",Z[Z.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",Z[Z.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",Z[Z.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",Z[Z.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",Z[Z.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",Z[Z.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",Z[Z.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(Y||(e.FileOperationResult=Y={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude",e.FILES_READONLY_INCLUDE_CONFIG="files.readonlyInclude",e.FILES_READONLY_EXCLUDE_CONFIG="files.readonlyExclude",e.FILES_READONLY_FROM_PERMISSIONS_CONFIG="files.readonlyFromPermissions";var ae;(function(Z){Z[Z.FILE=0]="FILE",Z[Z.FOLDER=1]="FOLDER",Z[Z.ROOT_FOLDER=2]="ROOT_FOLDER"})(ae||(e.FileKind=ae={})),e.ETAG_DISABLED="";function ee(Z){if(!(typeof Z.size!="number"||typeof Z.mtime!="number"))return Z.mtime.toString(29)+Z.size.toString(31)}async function oe(Z,ve){if(!ve.hasProvider(k.URI.from({scheme:Z.scheme})))return new Promise(Ie=>{const X=ve.onDidChangeFileSystemProviderRegistrations(V=>{V.scheme===Z.scheme&&V.added&&(X.dispose(),Ie())})})}class ie{static{this.KB=1024}static{this.MB=ie.KB*ie.KB}static{this.GB=ie.MB*ie.KB}static{this.TB=ie.GB*ie.KB}static formatSize(ve){return(0,O.isNumber)(ve)||(ve=0),ve<ie.KB?(0,A.localize)(1866,null,ve.toFixed(0)):ve<ie.MB?(0,A.localize)(1867,null,(ve/ie.KB).toFixed(2)):ve<ie.GB?(0,A.localize)(1868,null,(ve/ie.MB).toFixed(2)):ve<ie.TB?(0,A.localize)(1869,null,(ve/ie.GB).toFixed(2)):(0,A.localize)(1870,null,(ve/ie.TB).toFixed(2))}}e.ByteSize=ie;function ue(Z){const ve=typeof Z=="string"||Z?.scheme===I.Schemas.vscodeRemote;return typeof Z!="string"&&Z?.scheme===I.Schemas.file?1024*ie.MB:ve?10*ie.MB:s.isWeb?50*ie.MB:1024*ie.MB}}),define(ke[75],Re([1,0]),function(Ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class S{constructor(...D){this._entries=new Map;for(const[O,k]of D)this.set(O,k)}set(D,O){const k=this._entries.get(D);return this._entries.set(D,O),k}has(D){return this._entries.has(D)}get(D){return this._entries.get(D)}}e.ServiceCollection=S}),define(ke[171],Re([1,0,10,12,4,74,168,3,75,172]),function(Ee,e,S,T,D,O,k,A,m,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const I=!1;class E extends Error{constructor(a){super("cyclic dependency between services"),this.message=a.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${a.toString()}`}}class u{constructor(a=new m.ServiceCollection,d=!1,l,i=I){this._services=a,this._strict=d,this._parent=l,this._enableTracing=i,this._isDisposed=!1,this._servicesToMaybeDispose=new Set,this._children=new Set,this._activeInstantiations=new Set,this._services.set(A.IInstantiationService,this),this._globalGraph=i?l?._globalGraph??new k.Graph(n=>n):void 0}dispose(){if(!this._isDisposed){this._isDisposed=!0,(0,D.dispose)(this._children),this._children.clear();for(const a of this._servicesToMaybeDispose)(0,D.isDisposable)(a)&&a.dispose();this._servicesToMaybeDispose.clear()}}_throwIfDisposed(){if(this._isDisposed)throw new Error("InstantiationService has been disposed")}createChild(a,d){this._throwIfDisposed();const l=this,i=new class extends u{dispose(){l._children.delete(i),super.dispose()}}(a,this._strict,this,this._enableTracing);return this._children.add(i),d?.add(i),i}invokeFunction(a,...d){this._throwIfDisposed();const l=v.traceInvocation(this._enableTracing,a);let i=!1;try{return a({get:t=>{if(i)throw(0,T.illegalState)("service accessor is only valid during the invocation of its target method");const o=this._getOrCreateServiceInstance(t,l);if(!o)throw new Error(`[invokeFunction] unknown service '${t}'`);return o}},...d)}finally{i=!0,l.stop()}}createInstance(a,...d){this._throwIfDisposed();let l,i;return a instanceof O.SyncDescriptor?(l=v.traceCreation(this._enableTracing,a.ctor),i=this._createInstance(a.ctor,a.staticArguments.concat(d),l)):(l=v.traceCreation(this._enableTracing,a),i=this._createInstance(a,d,l)),l.stop(),i}_createInstance(a,d=[],l){const i=A._util.getServiceDependencies(a).sort((o,c)=>o.index-c.index),n=[];for(const o of i){const c=this._getOrCreateServiceInstance(o.id,l);c||this._throwIfStrict(`[createInstance] ${a.name} depends on UNKNOWN service ${o.id}.`,!1),n.push(c)}const t=i.length>0?i[0].index:d.length;if(d.length!==t){console.trace(`[createInstance] First service dependency of ${a.name} at position ${t+1} conflicts with ${d.length} static arguments`);const o=t-d.length;o>0?d=d.concat(new Array(o)):d=d.slice(0,t)}return Reflect.construct(a,d.concat(n))}_setCreatedServiceInstance(a,d){if(this._services.get(a)instanceof O.SyncDescriptor)this._services.set(a,d);else if(this._parent)this._parent._setCreatedServiceInstance(a,d);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(a){const d=this._services.get(a);return!d&&this._parent?this._parent._getServiceInstanceOrDescriptor(a):d}_getOrCreateServiceInstance(a,d){this._globalGraph&&this._globalGraphImplicitDependency&&this._globalGraph.insertEdge(this._globalGraphImplicitDependency,String(a));const l=this._getServiceInstanceOrDescriptor(a);return l instanceof O.SyncDescriptor?this._safeCreateAndCacheServiceInstance(a,l,d.branch(a,!0)):(d.branch(a,!1),l)}_safeCreateAndCacheServiceInstance(a,d,l){if(this._activeInstantiations.has(a))throw new Error(`illegal state - RECURSIVELY instantiating service '${a}'`);this._activeInstantiations.add(a);try{return this._createAndCacheServiceInstance(a,d,l)}finally{this._activeInstantiations.delete(a)}}_createAndCacheServiceInstance(a,d,l){const i=new k.Graph(c=>c.id.toString());let n=0;const t=[{id:a,desc:d,_trace:l}],o=new Set;for(;t.length;){const c=t.pop();if(!o.has(String(c.id))){if(o.add(String(c.id)),i.lookupOrInsertNode(c),n++>1e3)throw new E(i);for(const g of A._util.getServiceDependencies(c.desc.ctor)){const f=this._getServiceInstanceOrDescriptor(g.id);if(f||this._throwIfStrict(`[createInstance] ${a} depends on ${g.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(c.id),String(g.id)),f instanceof O.SyncDescriptor){const h={id:g.id,desc:f,_trace:c._trace.branch(g.id,!0)};i.insertEdge(c,h),t.push(h)}}}}for(;;){const c=i.roots();if(c.length===0){if(!i.isEmpty())throw new E(i);break}for(const{data:g}of c){if(this._getServiceInstanceOrDescriptor(g.id)instanceof O.SyncDescriptor){const h=this._createServiceInstanceWithOwner(g.id,g.desc.ctor,g.desc.staticArguments,g.desc.supportsDelayedInstantiation,g._trace);this._setCreatedServiceInstance(g.id,h)}i.removeNode(g)}}return this._getServiceInstanceOrDescriptor(a)}_createServiceInstanceWithOwner(a,d,l=[],i,n){if(this._services.get(a)instanceof O.SyncDescriptor)return this._createServiceInstance(a,d,l,i,n,this._servicesToMaybeDispose);if(this._parent)return this._parent._createServiceInstanceWithOwner(a,d,l,i,n);throw new Error(`illegalState - creating UNKNOWN service instance ${d.name}`)}_createServiceInstance(a,d,l=[],i,n,t){if(i){const o=new u(void 0,this._strict,this,this._enableTracing);o._globalGraphImplicitDependency=String(a);const c=new Map,g=new S.GlobalIdleValue(()=>{const f=o._createInstance(d,l,n);for(const[h,_]of c){const y=f[h];if(typeof y=="function")for(const w of _)w.disposable=y.apply(f,w.listener)}return c.clear(),t.add(f),f});return new Proxy(Object.create(null),{get(f,h){if(!g.isInitialized&&typeof h=="string"&&(h.startsWith("onDid")||h.startsWith("onWill"))){let w=c.get(h);return w||(w=new s.LinkedList,c.set(h,w)),(R,p,b)=>{if(g.isInitialized)return g.value[h](R,p,b);{const N={listener:[R,p,b],disposable:void 0},L=w.push(N);return(0,D.toDisposable)(()=>{L(),N.disposable?.dispose()})}}}if(h in f)return f[h];const _=g.value;let y=_[h];return typeof y!="function"||(y=y.bind(_),f[h]=y),y},set(f,h,_){return g.value[h]=_,!0},getPrototypeOf(f){return d.prototype}})}else{const o=this._createInstance(d,l,n);return t.add(o),o}}_throwIfStrict(a,d){if(d&&console.warn(a),this._strict)throw new Error(a)}}e.InstantiationService=u;var C;(function(r){r[r.None=0]="None",r[r.Creation=1]="Creation",r[r.Invocation=2]="Invocation",r[r.Branch=3]="Branch"})(C||(C={}));class v{static{this.all=new Set}static{this._None=new class extends v{constructor(){super(C.None,null)}stop(){}branch(){return this}}}static traceInvocation(a,d){return a?new v(C.Invocation,d.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):v._None}static traceCreation(a,d){return a?new v(C.Creation,d.name):v._None}static{this._totals=0}constructor(a,d){this.type=a,this.name=d,this._start=Date.now(),this._dep=[]}branch(a,d){const l=new v(C.Branch,a.toString());return this._dep.push([a,d,l]),l}stop(){const a=Date.now()-this._start;v._totals+=a;let d=!1;function l(n,t){const o=[],c=new Array(n+1).join("	");for(const[g,f,h]of t._dep)if(f&&h){d=!0,o.push(`${c}CREATES -> ${g}`);const _=l(n+1,h);_&&o.push(_)}else o.push(`${c}uses -> ${g}`);return o.join(`
`)}const i=[`${this.type===C.Creation?"CREATE":"CALL"} ${this.name}`,`${l(1,this)}`,`DONE, took ${a.toFixed(2)}ms (grand total ${v._totals.toFixed(2)}ms)`];(a>2||d)&&v.all.add(i.join(`
`))}}e.Trace=v}),define(ke[11],Re([1,0,9,42,6,76,4,27,23,24,14,2,31,3]),function(Ee,e,S,T,D,O,k,A,m,s,I,E,u,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_LOG_LEVEL=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.MultiplexLogger=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.isLogLevel=r,e.log=d,e.getLogLevel=y,e.LogLevelToString=w,e.LogLevelToLocalizedString=P,e.parseLogLevel=R,S=Ve(S),e.ILogService=(0,C.createDecorator)("logService"),e.ILoggerService=(0,C.createDecorator)("loggerService");function v(){return new Date().toISOString()}function r(p){return(0,I.isNumber)(p)}var a;(function(p){p[p.Off=0]="Off",p[p.Trace=1]="Trace",p[p.Debug=2]="Debug",p[p.Info=3]="Info",p[p.Warning=4]="Warning",p[p.Error=5]="Error"})(a||(e.LogLevel=a={})),e.DEFAULT_LOG_LEVEL=a.Info;function d(p,b,N){switch(b){case a.Trace:p.trace(N);break;case a.Debug:p.debug(N);break;case a.Info:p.info(N);break;case a.Warning:p.warn(N);break;case a.Error:p.error(N);break;case a.Off:break;default:throw new Error(`Invalid log level ${b}`)}}function l(p,b=!1){let N="";for(let L=0;L<p.length;L++){let F=p[L];if(F instanceof Error&&(F=(0,T.toErrorMessage)(F,b)),typeof F=="object")try{F=JSON.stringify(F)}catch{}N+=(L>0?" ":"")+F}return N}class i extends k.Disposable{constructor(){super(...arguments),this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new D.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(b){this.level!==b&&(this.level=b,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}checkLogLevel(b){return this.level!==a.Off&&this.level<=b}}e.AbstractLogger=i;class n extends i{constructor(b){super(),this.logAlways=b}checkLogLevel(b){return this.logAlways||super.checkLogLevel(b)}trace(b,...N){this.checkLogLevel(a.Trace)&&this.log(a.Trace,l([b,...N],!0))}debug(b,...N){this.checkLogLevel(a.Debug)&&this.log(a.Debug,l([b,...N]))}info(b,...N){this.checkLogLevel(a.Info)&&this.log(a.Info,l([b,...N]))}warn(b,...N){this.checkLogLevel(a.Warning)&&this.log(a.Warning,l([b,...N]))}error(b,...N){if(this.checkLogLevel(a.Error))if(b instanceof Error){const L=Array.prototype.slice.call(arguments);L[0]=b.stack,this.log(a.Error,l(L))}else this.log(a.Error,l([b,...N]))}flush(){}}e.AbstractMessageLogger=n;class t extends i{constructor(b=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(b),this.useColors=!m.isWindows}trace(b,...N){this.checkLogLevel(a.Trace)&&(this.useColors?console.log(`\x1B[90m[main ${v()}]\x1B[0m`,b,...N):console.log(`[main ${v()}]`,b,...N))}debug(b,...N){this.checkLogLevel(a.Debug)&&(this.useColors?console.log(`\x1B[90m[main ${v()}]\x1B[0m`,b,...N):console.log(`[main ${v()}]`,b,...N))}info(b,...N){this.checkLogLevel(a.Info)&&(this.useColors?console.log(`\x1B[90m[main ${v()}]\x1B[0m`,b,...N):console.log(`[main ${v()}]`,b,...N))}warn(b,...N){this.checkLogLevel(a.Warning)&&(this.useColors?console.warn(`\x1B[93m[main ${v()}]\x1B[0m`,b,...N):console.warn(`[main ${v()}]`,b,...N))}error(b,...N){this.checkLogLevel(a.Error)&&(this.useColors?console.error(`\x1B[91m[main ${v()}]\x1B[0m`,b,...N):console.error(`[main ${v()}]`,b,...N))}flush(){}}e.ConsoleMainLogger=t;class o extends i{constructor(b=e.DEFAULT_LOG_LEVEL,N=!0){super(),this.useColors=N,this.setLevel(b)}trace(b,...N){this.checkLogLevel(a.Trace)&&(this.useColors?console.log("%cTRACE","color: #888",b,...N):console.log(b,...N))}debug(b,...N){this.checkLogLevel(a.Debug)&&(this.useColors?console.log("%cDEBUG","background: #eee; color: #888",b,...N):console.log(b,...N))}info(b,...N){this.checkLogLevel(a.Info)&&(this.useColors?console.log("%c INFO","color: #33f",b,...N):console.log(b,...N))}warn(b,...N){this.checkLogLevel(a.Warning)&&(this.useColors?console.log("%c WARN","color: #993",b,...N):console.log(b,...N))}error(b,...N){this.checkLogLevel(a.Error)&&(this.useColors?console.log("%c  ERR","color: #f33",b,...N):console.error(b,...N))}flush(){}}e.ConsoleLogger=o;class c extends i{constructor(b,N=e.DEFAULT_LOG_LEVEL){super(),this.adapter=b,this.setLevel(N)}trace(b,...N){this.checkLogLevel(a.Trace)&&this.adapter.log(a.Trace,[this.extractMessage(b),...N])}debug(b,...N){this.checkLogLevel(a.Debug)&&this.adapter.log(a.Debug,[this.extractMessage(b),...N])}info(b,...N){this.checkLogLevel(a.Info)&&this.adapter.log(a.Info,[this.extractMessage(b),...N])}warn(b,...N){this.checkLogLevel(a.Warning)&&this.adapter.log(a.Warning,[this.extractMessage(b),...N])}error(b,...N){this.checkLogLevel(a.Error)&&this.adapter.log(a.Error,[this.extractMessage(b),...N])}extractMessage(b){return typeof b=="string"?b:(0,T.toErrorMessage)(b,this.checkLogLevel(a.Trace))}flush(){}}e.AdapterLogger=c;class g extends i{constructor(b){super(),this.loggers=b,b.length&&this.setLevel(b[0].getLevel())}setLevel(b){for(const N of this.loggers)N.setLevel(b);super.setLevel(b)}trace(b,...N){for(const L of this.loggers)L.trace(b,...N)}debug(b,...N){for(const L of this.loggers)L.debug(b,...N)}info(b,...N){for(const L of this.loggers)L.info(b,...N)}warn(b,...N){for(const L of this.loggers)L.warn(b,...N)}error(b,...N){for(const L of this.loggers)L.error(b,...N)}flush(){for(const b of this.loggers)b.flush()}dispose(){for(const b of this.loggers)b.dispose();super.dispose()}}e.MultiplexLogger=g;class f extends k.Disposable{constructor(b,N,L){if(super(),this.logLevel=b,this.logsHome=N,this._loggers=new A.ResourceMap,this._onDidChangeLoggers=this._register(new D.Emitter),this.onDidChangeLoggers=this._onDidChangeLoggers.event,this._onDidChangeLogLevel=this._register(new D.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event,this._onDidChangeVisibility=this._register(new D.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,L)for(const F of L)this._loggers.set(F.resource,{logger:void 0,info:F})}getLoggerEntry(b){return(0,I.isString)(b)?[...this._loggers.values()].find(N=>N.info.id===b):this._loggers.get(b)}getLogger(b){return this.getLoggerEntry(b)?.logger}createLogger(b,N){const L=this.toResource(b),F=(0,I.isString)(b)?b:N?.id??(0,O.hash)(L.toString()).toString(16);let K=this._loggers.get(L)?.logger;const J=N?.logLevel==="always"?a.Trace:N?.logLevel;K||(K=this.doCreateLogger(L,J??this.getLogLevel(L)??this.logLevel,{...N,id:F}));const $={logger:K,info:{resource:L,id:F,logLevel:J,name:N?.name,hidden:N?.hidden,extensionId:N?.extensionId,when:N?.when}};return this.registerLogger($.info),this._loggers.set(L,$),K}toResource(b){return(0,I.isString)(b)?(0,s.joinPath)(this.logsHome,`${b}.log`):b}setLogLevel(b,N){if(E.URI.isUri(b)){const L=b,F=N,K=this._loggers.get(L);K&&F!==K.info.logLevel&&(K.info.logLevel=F===this.logLevel?void 0:F,K.logger?.setLevel(F),this._loggers.set(K.info.resource,K),this._onDidChangeLogLevel.fire([L,F]))}else{this.logLevel=b;for(const[L,F]of this._loggers.entries())this._loggers.get(L)?.info.logLevel===void 0&&F.logger?.setLevel(this.logLevel);this._onDidChangeLogLevel.fire(this.logLevel)}}setVisibility(b,N){const L=this.getLoggerEntry(b);L&&N!==!L.info.hidden&&(L.info.hidden=!N,this._loggers.set(L.info.resource,L),this._onDidChangeVisibility.fire([L.info.resource,N]))}getLogLevel(b){let N;return b&&(N=this._loggers.get(b)?.info.logLevel),N??this.logLevel}registerLogger(b){const N=this._loggers.get(b.resource);N?N.info.hidden!==b.hidden&&this.setVisibility(b.resource,!b.hidden):(this._loggers.set(b.resource,{info:b,logger:void 0}),this._onDidChangeLoggers.fire({added:[b],removed:[]}))}deregisterLogger(b){const N=this._loggers.get(b);N&&(N.logger&&N.logger.dispose(),this._loggers.delete(b),this._onDidChangeLoggers.fire({added:[],removed:[N.info]}))}*getRegisteredLoggers(){for(const b of this._loggers.values())yield b.info}getRegisteredLogger(b){return this._loggers.get(b)?.info}dispose(){this._loggers.forEach(b=>b.logger?.dispose()),this._loggers.clear(),super.dispose()}}e.AbstractLoggerService=f;class h{constructor(){this.onDidChangeLogLevel=new D.Emitter().event}setLevel(b){}getLevel(){return a.Info}trace(b,...N){}debug(b,...N){}info(b,...N){}warn(b,...N){}error(b,...N){}critical(b,...N){}dispose(){}flush(){}}e.NullLogger=h;class _ extends h{}e.NullLogService=_;function y(p){if(p.verbose)return a.Trace;if(typeof p.logLevel=="string"){const b=R(p.logLevel.toLowerCase());if(b!==void 0)return b}return e.DEFAULT_LOG_LEVEL}function w(p){switch(p){case a.Trace:return"trace";case a.Debug:return"debug";case a.Info:return"info";case a.Warning:return"warn";case a.Error:return"error";case a.Off:return"off"}}function P(p){switch(p){case a.Trace:return{original:"Trace",value:S.localize(1959,null)};case a.Debug:return{original:"Debug",value:S.localize(1960,null)};case a.Info:return{original:"Info",value:S.localize(1961,null)};case a.Warning:return{original:"Warning",value:S.localize(1962,null)};case a.Error:return{original:"Error",value:S.localize(1963,null)};case a.Off:return{original:"Off",value:S.localize(1964,null)}}}function R(p){switch(p){case"trace":return a.Trace;case"debug":return a.Debug;case"info":return a.Info;case"warn":return a.Warning;case"error":return a.Error;case"critical":return a.Error;case"off":return a.Off}}e.CONTEXT_LOG_LEVEL=new u.RawContextKey("logLevel",w(a.Info))}),define(ke[173],Re([1,0,4,11]),function(Ee,e,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogService=void 0;class D extends S.Disposable{constructor(k,A=[]){super(),this.logger=new T.MultiplexLogger([k,...A]),this._register(k.onDidChangeLogLevel(m=>this.setLevel(m)))}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(k){this.logger.setLevel(k)}getLevel(){return this.logger.getLevel()}trace(k,...A){this.logger.trace(k,...A)}debug(k,...A){this.logger.debug(k,...A)}info(k,...A){this.logger.info(k,...A)}warn(k,...A){this.logger.warn(k,...A)}error(k,...A){this.logger.error(k,...A)}flush(){this.logger.flush()}}e.LogService=D});var oi=this&&this.__importDefault||function(Ee){return Ee&&Ee.__esModule?Ee:{default:Ee}};define(ke[108],Re([1,0,37,9,3]),function(Ee,e,S,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0,S=oi(S);var O;(function(m){m[m.Unnecessary=1]="Unnecessary",m[m.Deprecated=2]="Deprecated"})(O||(e.MarkerTag=O={}));var k;(function(m){m[m.Hint=1]="Hint",m[m.Info=2]="Info",m[m.Warning=4]="Warning",m[m.Error=8]="Error"})(k||(e.MarkerSeverity=k={})),function(m){function s(v,r){return r-v}m.compare=s;const I=Object.create(null);I[m.Error]=(0,T.localize)(1965,null),I[m.Warning]=(0,T.localize)(1966,null),I[m.Info]=(0,T.localize)(1967,null);function E(v){return I[v]||""}m.toString=E;function u(v){switch(v){case S.default.Error:return m.Error;case S.default.Warning:return m.Warning;case S.default.Info:return m.Info;case S.default.Ignore:return m.Hint}}m.fromSeverity=u;function C(v){switch(v){case m.Error:return S.default.Error;case m.Warning:return S.default.Warning;case m.Info:return S.default.Info;case m.Hint:return S.default.Ignore}}m.toSeverity=C}(k||(e.MarkerSeverity=k={}));var A;(function(m){const s="";function I(u){return E(u,!0)}m.makeKey=I;function E(u,C){const v=[s];return u.source?v.push(u.source.replace("\xA6","\\\xA6")):v.push(s),u.code?typeof u.code=="string"?v.push(u.code.replace("\xA6","\\\xA6")):v.push(u.code.value.replace("\xA6","\\\xA6")):v.push(s),u.severity!==void 0&&u.severity!==null?v.push(k.toString(u.severity)):v.push(s),u.message&&C?v.push(u.message.replace("\xA6","\\\xA6")):v.push(s),u.startLineNumber!==void 0&&u.startLineNumber!==null?v.push(u.startLineNumber.toString()):v.push(s),u.startColumn!==void 0&&u.startColumn!==null?v.push(u.startColumn.toString()):v.push(s),u.endLineNumber!==void 0&&u.endLineNumber!==null?v.push(u.endLineNumber.toString()):v.push(s),u.endColumn!==void 0&&u.endColumn!==null?v.push(u.endColumn.toString()):v.push(s),v.push(s),v.join("\xA6")}m.makeKeyOptionalMessage=E})(A||(e.IMarkerData=A={})),e.IMarkerService=(0,D.createDecorator)("markerService")});var oi=this&&this.__importDefault||function(Ee){return Ee&&Ee.__esModule?Ee:{default:Ee}};define(ke[174],Re([1,0,6,37,3]),function(Ee,e,S,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.INotificationService=e.Severity=void 0,e.isNotificationSource=A,T=oi(T),e.Severity=T.default,e.INotificationService=(0,D.createDecorator)("notificationService");var O;(function(E){E[E.DEFAULT=0]="DEFAULT",E[E.SILENT=1]="SILENT",E[E.URGENT=2]="URGENT"})(O||(e.NotificationPriority=O={}));var k;(function(E){E[E.WORKSPACE=0]="WORKSPACE",E[E.PROFILE=1]="PROFILE",E[E.APPLICATION=2]="APPLICATION"})(k||(e.NeverShowAgainScope=k={}));function A(E){if(E){const u=E;return typeof u.id=="string"&&typeof u.label=="string"}return!1}var m;(function(E){E[E.OFF=0]="OFF",E[E.ERROR=1]="ERROR"})(m||(e.NotificationsFilter=m={}));class s{constructor(){this.progress=new I,this.onDidClose=S.Event.None,this.onDidChangeVisibility=S.Event.None}updateSeverity(u){}updateMessage(u){}updateActions(u){}close(){}}e.NoOpNotification=s;class I{infinite(){}done(){}total(u){}worked(u){}}e.NoOpProgress=I}),define(ke[109],Re([1,0,3]),function(Ee,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,S.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"});var qe=this&&this.__decorate||function(Ee,e,S,T){var D=arguments.length,O=D<3?e:T===null?T=Object.getOwnPropertyDescriptor(e,S):T,k;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")O=Reflect.decorate(Ee,e,S,T);else for(var A=Ee.length-1;A>=0;A--)(k=Ee[A])&&(O=(D<3?k(O):D>3?k(e,S,O):k(e,S))||O);return D>3&&O&&Object.defineProperty(e,S,O),O},We=this&&this.__param||function(Ee,e){return function(S,T){e(S,T,Ee)}};define(ke[77],Re([1,0,10,19,4,3]),function(Ee,e,S,T,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.AsyncProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,O.createDecorator)("progressService");var k;(function(E){E[E.Explorer=1]="Explorer",E[E.Scm=3]="Scm",E[E.Extensions=5]="Extensions",E[E.Window=10]="Window",E[E.Notification=15]="Notification",E[E.Dialog=20]="Dialog"})(k||(e.ProgressLocation=k={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class A{static{this.None=Object.freeze({report(){}})}get value(){return this._value}constructor(u){this.callback=u}report(u){this._value=u,this.callback(this._value)}}e.Progress=A;class m{get value(){return this._value}constructor(u){this.callback=u}report(u){this._asyncQueue?this._asyncQueue.push(u):this._asyncQueue=[u],this._processAsyncQueue()}async _processAsyncQueue(){if(!this._processingAsyncQueue)try{for(this._processingAsyncQueue=!0;this._asyncQueue&&this._asyncQueue.length;){const u=this._asyncQueue.shift();this._value=u,await this.callback(this._value)}}finally{this._processingAsyncQueue=!1;const u=this._drainListener;this._drainListener=void 0,u?.()}}drain(){return this._processingAsyncQueue?new Promise(u=>{const C=this._drainListener;this._drainListener=()=>{C?.(),u()}}):Promise.resolve()}}e.AsyncProgress=m;let s=class extends D.Disposable{constructor(u,C){super(),this.deferred=new S.DeferredPromise,C.withProgress(u,v=>(this.reporter=v,this.lastStep&&v.report(this.lastStep),this.deferred.p)),this._register((0,D.toDisposable)(()=>this.deferred.complete()))}report(u){this.reporter?this.reporter.report(u):this.lastStep=u}};e.UnmanagedProgress=s,e.UnmanagedProgress=s=qe([We(1,e.IProgressService)],s);class I extends D.Disposable{constructor(u){super(),this.progressIndicator=u,this.currentOperationId=0,this.currentOperationDisposables=this._register(new D.DisposableStore)}start(u){this.stop();const C=++this.currentOperationId,v=new T.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{C===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},u),this.currentOperationDisposables.add((0,D.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,D.toDisposable)(()=>v.cancel())),this.currentOperationDisposables.add((0,D.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:C,token:v.token,stop:()=>this.doStop(C),isCurrent:()=>this.currentOperationId===C}}stop(){this.doStop(this.currentOperationId)}doStop(u){this.currentOperationId===u&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=I,e.IEditorProgressService=(0,O.createDecorator)("editorProgressService")}),define(ke[29],Re([1,0,61,14]),function(Ee,e,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0,S=Ve(S),T=Ve(T);class D{constructor(){this.data=new Map}add(k,A){S.ok(T.isString(k)),S.ok(T.isObject(A)),S.ok(!this.data.has(k),"There is already an extension with this id"),this.data.set(k,A)}knows(k){return this.data.has(k)}as(k){return this.data.get(k)||null}}e.Registry=new D}),define(ke[78],Re([1,0,6,139,29]),function(Ee,e,S,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,D=Ve(D),e.Extensions={JSONContribution:"base.contributions.json"};function O(m){return m.length>0&&m.charAt(m.length-1)==="#"?m.substring(0,m.length-1):m}class k{constructor(){this._onDidChangeSchema=new S.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(s,I){this.schemasById[O(s)]=I,this._onDidChangeSchema.fire(s)}notifySchemaChanged(s){this._onDidChangeSchema.fire(s)}getSchemaContributions(){return{schemas:this.schemasById}}getSchemaContent(s){const I=this.schemasById[s];return I?(0,T.getCompressedContent)(I):void 0}hasSchemaContent(s){return!!this.schemasById[s]}}const A=new k;D.Registry.add(e.Extensions.JSONContribution,A)}),define(ke[53],Re([1,0,17,6,14,9,44,78,29]),function(Ee,e,S,T,D,O,k,A,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0,e.overrideIdentifiersFromKey=r,e.keyFromOverrideIdentifiers=a,e.getDefaultValue=d,e.validateProperty=i,e.getScopes=n,e.getAllConfigurationProperties=t,e.parseScope=o,D=Ve(D),O=Ve(O);var s;(function(c){c.Multiline="multilineText",c.Singleline="singlelineText"})(s||(e.EditPresentationTypes=s={})),e.Extensions={Configuration:"base.contributions.configuration"};var I;(function(c){c[c.APPLICATION=1]="APPLICATION",c[c.MACHINE=2]="MACHINE",c[c.WINDOW=3]="WINDOW",c[c.RESOURCE=4]="RESOURCE",c[c.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",c[c.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(I||(e.ConfigurationScope=I={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const E=m.Registry.as(A.Extensions.JSONContribution);class u{constructor(){this.registeredConfigurationDefaults=[],this.overrideIdentifiers=new Set,this._onDidSchemaChange=new T.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new T.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:O.localize(1662,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.policyConfigurations=new Map,this.excludedConfigurationProperties={},E.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(g,f=!0){this.registerConfigurations([g],f)}registerConfigurations(g,f=!0){const h=new Set;this.doRegisterConfigurations(g,f,h),E.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:h})}deregisterConfigurations(g){const f=new Set;this.doDeregisterConfigurations(g,f),E.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:f})}updateConfigurations({add:g,remove:f}){const h=new Set;this.doDeregisterConfigurations(f,h),this.doRegisterConfigurations(g,!1,h),E.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:h})}registerDefaultConfigurations(g){const f=new Set;this.doRegisterDefaultConfigurations(g,f),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:f,defaultsOverrides:!0})}doRegisterDefaultConfigurations(g,f){this.registeredConfigurationDefaults.push(...g);const h=[];for(const{overrides:_,source:y}of g)for(const w in _){f.add(w);const P=this.configurationDefaultsOverrides.get(w)??this.configurationDefaultsOverrides.set(w,{configurationDefaultOverrides:[]}).get(w),R=_[w];if(P.configurationDefaultOverrides.push({value:R,source:y}),e.OVERRIDE_PROPERTY_REGEX.test(w)){const p=this.mergeDefaultConfigurationsForOverrideIdentifier(w,R,y,P.configurationDefaultOverrideValue);if(!p)continue;P.configurationDefaultOverrideValue=p,this.updateDefaultOverrideProperty(w,p,y),h.push(...r(w))}else{const p=this.mergeDefaultConfigurationsForConfigurationProperty(w,R,y,P.configurationDefaultOverrideValue);if(!p)continue;P.configurationDefaultOverrideValue=p;const b=this.configurationProperties[w];b&&(this.updatePropertyDefaultValue(w,b),this.updateSchema(w,b))}}this.doRegisterOverrideIdentifiers(h)}deregisterDefaultConfigurations(g){const f=new Set;this.doDeregisterDefaultConfigurations(g,f),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:f,defaultsOverrides:!0})}doDeregisterDefaultConfigurations(g,f){for(const h of g){const _=this.registeredConfigurationDefaults.indexOf(h);_!==-1&&this.registeredConfigurationDefaults.splice(_,1)}for(const{overrides:h,source:_}of g)for(const y in h){const w=this.configurationDefaultsOverrides.get(y);if(!w)continue;const P=w.configurationDefaultOverrides.findIndex(R=>_?R.source?.id===_.id:R.value===h[y]);if(P!==-1){if(w.configurationDefaultOverrides.splice(P,1),w.configurationDefaultOverrides.length===0&&this.configurationDefaultsOverrides.delete(y),e.OVERRIDE_PROPERTY_REGEX.test(y)){let R;for(const p of w.configurationDefaultOverrides)R=this.mergeDefaultConfigurationsForOverrideIdentifier(y,p.value,p.source,R);R&&!D.isEmptyObject(R.value)?(w.configurationDefaultOverrideValue=R,this.updateDefaultOverrideProperty(y,R,_)):(this.configurationDefaultsOverrides.delete(y),delete this.configurationProperties[y],delete this.defaultLanguageConfigurationOverridesNode.properties[y])}else{let R;for(const b of w.configurationDefaultOverrides)R=this.mergeDefaultConfigurationsForConfigurationProperty(y,b.value,b.source,R);w.configurationDefaultOverrideValue=R;const p=this.configurationProperties[y];p&&(this.updatePropertyDefaultValue(y,p),this.updateSchema(y,p))}f.add(y)}}this.updateOverridePropertyPatternKey()}updateDefaultOverrideProperty(g,f,h){const _={type:"object",default:f.value,description:O.localize(1663,null,(0,k.getLanguageTagSettingPlainKey)(g)),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:f.value,source:h,defaultValueSource:h};this.configurationProperties[g]=_,this.defaultLanguageConfigurationOverridesNode.properties[g]=_}mergeDefaultConfigurationsForOverrideIdentifier(g,f,h,_){const y=_?.value||{},w=_?.source??new Map;if(!(w instanceof Map)){console.error("objectConfigurationSources is not a Map");return}for(const P of Object.keys(f)){const R=f[P];if(D.isObject(R)&&(D.isUndefined(y[P])||D.isObject(y[P]))){if(y[P]={...y[P]??{},...R},h)for(const b in R)w.set(`${P}.${b}`,h)}else y[P]=R,h?w.set(P,h):w.delete(P)}return{value:y,source:w}}mergeDefaultConfigurationsForConfigurationProperty(g,f,h,_){const y=this.configurationProperties[g],w=_?.value??y?.defaultDefaultValue;let P=h;if(D.isObject(f)&&(y!==void 0&&y.type==="object"||y===void 0&&(D.isUndefined(w)||D.isObject(w)))){if(P=_?.source??new Map,!(P instanceof Map)){console.error("defaultValueSource is not a Map");return}for(const p in f)h&&P.set(`${g}.${p}`,h);f={...D.isObject(w)?w:{},...f}}return{value:f,source:P}}deltaConfiguration(g){let f=!1;const h=new Set;g.removedDefaults&&(this.doDeregisterDefaultConfigurations(g.removedDefaults,h),f=!0),g.addedDefaults&&(this.doRegisterDefaultConfigurations(g.addedDefaults,h),f=!0),g.removedConfigurations&&this.doDeregisterConfigurations(g.removedConfigurations,h),g.addedConfigurations&&this.doRegisterConfigurations(g.addedConfigurations,!1,h),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:h,defaultsOverrides:f})}notifyConfigurationSchemaUpdated(...g){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(g){this.doRegisterOverrideIdentifiers(g),this._onDidSchemaChange.fire()}doRegisterOverrideIdentifiers(g){for(const f of g)this.overrideIdentifiers.add(f);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(g,f,h){g.forEach(_=>{this.validateAndRegisterProperties(_,f,_.extensionInfo,_.restrictedProperties,void 0,h),this.configurationContributors.push(_),this.registerJSONConfiguration(_)})}doDeregisterConfigurations(g,f){const h=_=>{if(_.properties)for(const y in _.properties){f.add(y);const w=this.configurationProperties[y];w?.policy?.name&&this.policyConfigurations.delete(w.policy.name),delete this.configurationProperties[y],this.removeFromSchema(y,_.properties[y])}_.allOf?.forEach(y=>h(y))};for(const _ of g){h(_);const y=this.configurationContributors.indexOf(_);y!==-1&&this.configurationContributors.splice(y,1)}}validateAndRegisterProperties(g,f=!0,h,_,y=I.WINDOW,w){y=D.isUndefinedOrNull(g.scope)?y:g.scope;const P=g.properties;if(P)for(const p in P){const b=P[p];if(f&&i(p,b)){delete P[p];continue}if(b.source=h,b.defaultDefaultValue=P[p].default,this.updatePropertyDefaultValue(p,b),e.OVERRIDE_PROPERTY_REGEX.test(p)?b.scope=void 0:(b.scope=D.isUndefinedOrNull(b.scope)?y:b.scope,b.restricted=D.isUndefinedOrNull(b.restricted)?!!_?.includes(p):b.restricted),P[p].hasOwnProperty("included")&&!P[p].included){this.excludedConfigurationProperties[p]=P[p],delete P[p];continue}else this.configurationProperties[p]=P[p],P[p].policy?.name&&this.policyConfigurations.set(P[p].policy.name,p);!P[p].deprecationMessage&&P[p].markdownDeprecationMessage&&(P[p].deprecationMessage=P[p].markdownDeprecationMessage),w.add(p)}const R=g.allOf;if(R)for(const p of R)this.validateAndRegisterProperties(p,f,h,_,y,w)}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getPolicyConfigurations(){return this.policyConfigurations}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getRegisteredDefaultConfigurations(){return[...this.registeredConfigurationDefaults]}getConfigurationDefaultsOverrides(){const g=new Map;for(const[f,h]of this.configurationDefaultsOverrides)h.configurationDefaultOverrideValue&&g.set(f,h.configurationDefaultOverrideValue);return g}registerJSONConfiguration(g){const f=h=>{const _=h.properties;if(_)for(const w in _)this.updateSchema(w,_[w]);h.allOf?.forEach(f)};f(g)}updateSchema(g,f){switch(e.allSettings.properties[g]=f,f.scope){case I.APPLICATION:e.applicationSettings.properties[g]=f;break;case I.MACHINE:e.machineSettings.properties[g]=f;break;case I.MACHINE_OVERRIDABLE:e.machineOverridableSettings.properties[g]=f;break;case I.WINDOW:e.windowSettings.properties[g]=f;break;case I.RESOURCE:e.resourceSettings.properties[g]=f;break;case I.LANGUAGE_OVERRIDABLE:e.resourceSettings.properties[g]=f,this.resourceLanguageSettingsSchema.properties[g]=f;break}}removeFromSchema(g,f){switch(delete e.allSettings.properties[g],f.scope){case I.APPLICATION:delete e.applicationSettings.properties[g];break;case I.MACHINE:delete e.machineSettings.properties[g];break;case I.MACHINE_OVERRIDABLE:delete e.machineOverridableSettings.properties[g];break;case I.WINDOW:delete e.windowSettings.properties[g];break;case I.RESOURCE:case I.LANGUAGE_OVERRIDABLE:delete e.resourceSettings.properties[g],delete this.resourceLanguageSettingsSchema.properties[g];break}}updateOverridePropertyPatternKey(){for(const g of this.overrideIdentifiers.values()){const f=`[${g}]`,h={type:"object",description:O.localize(1664,null),errorMessage:O.localize(1665,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(f,h),e.allSettings.properties[f]=h,e.applicationSettings.properties[f]=h,e.machineSettings.properties[f]=h,e.machineOverridableSettings.properties[f]=h,e.windowSettings.properties[f]=h,e.resourceSettings.properties[f]=h}}registerOverridePropertyPatternKey(){const g={type:"object",description:O.localize(1666,null),errorMessage:O.localize(1667,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=g,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=g,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=g,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=g,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=g,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=g,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(g,f){const h=this.configurationDefaultsOverrides.get(g)?.configurationDefaultOverrideValue;let _,y;h&&(!f.disallowConfigurationDefault||!h.source)&&(_=h.value,y=h.source),D.isUndefined(_)&&(_=f.defaultDefaultValue,y=void 0),D.isUndefined(_)&&(_=d(f.type)),f.default=_,f.defaultValueSource=y}}const C="\\[([^\\]]+)\\]",v=new RegExp(C,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${C})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function r(c){const g=[];if(e.OVERRIDE_PROPERTY_REGEX.test(c)){let f=v.exec(c);for(;f?.length;){const h=f[1].trim();h&&g.push(h),f=v.exec(c)}}return(0,S.distinct)(g)}function a(c){return c.reduce((g,f)=>`${g}[${f}]`,"")}function d(c){switch(Array.isArray(c)?c[0]:c){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const l=new u;m.Registry.add(e.Extensions.Configuration,l);function i(c,g){return c.trim()?e.OVERRIDE_PROPERTY_REGEX.test(c)?O.localize(1669,null,c):l.getConfigurationProperties()[c]!==void 0?O.localize(1670,null,c):g.policy?.name&&l.getPolicyConfigurations().get(g.policy?.name)!==void 0?O.localize(1671,null,c,g.policy?.name,l.getPolicyConfigurations().get(g.policy?.name)):null:O.localize(1668,null)}function n(){const c=[],g=l.getConfigurationProperties();for(const f of Object.keys(g))c.push([f,g[f].scope]);return c.push(["launch",I.RESOURCE]),c.push(["task",I.RESOURCE]),c}function t(c){const g={};for(const f of c){const h=f.properties;if(D.isObject(h))for(const _ in h)g[_]=h[_];f.allOf&&Object.assign(g,t(f.allOf))}return g}function o(c){switch(c){case"application":return I.APPLICATION;case"machine":return I.MACHINE;case"resource":return I.RESOURCE;case"machine-overridable":return I.MACHINE_OVERRIDABLE;case"language-overridable":return I.LANGUAGE_OVERRIDABLE;default:return I.WINDOW}}}),define(ke[175],Re([1,0,17,6,138,4,27,25,14,2,44,53,28,29]),function(Ee,e,S,T,D,O,k,A,m,s,I,E,u,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0,e.mergeChanges=n,S=Ve(S),D=Ve(D),A=Ve(A),m=Ve(m);function v(g){return Object.isFrozen(g)?g:A.deepFreeze(g)}class r{static createEmptyModel(f){return new r({},[],[],void 0,f)}constructor(f,h,_,y,w){this._contents=f,this._keys=h,this._overrides=_,this.raw=y,this.logService=w,this.overrideConfigurations=new Map}get rawConfiguration(){if(!this._rawConfiguration)if(this.raw?.length){const f=this.raw.map(h=>{if(h instanceof r)return h;const _=new a("",this.logService);return _.parseRaw(h),_.configurationModel});this._rawConfiguration=f.reduce((h,_)=>_===h?_:h.merge(_),f[0])}else this._rawConfiguration=this;return this._rawConfiguration}get contents(){return this._contents}get overrides(){return this._overrides}get keys(){return this._keys}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(f){return f?(0,I.getConfigurationValue)(this.contents,f):this.contents}inspect(f,h){const _=this;return{get value(){return v(_.rawConfiguration.getValue(f))},get override(){return h?v(_.rawConfiguration.getOverrideValue(f,h)):void 0},get merged(){return v(h?_.rawConfiguration.override(h).getValue(f):_.rawConfiguration.getValue(f))},get overrides(){const y=[];for(const{contents:w,identifiers:P,keys:R}of _.rawConfiguration.overrides){const p=new r(w,R,[],void 0,_.logService).getValue(f);p!==void 0&&y.push({identifiers:P,value:p})}return y.length?v(y):void 0}}}getOverrideValue(f,h){const _=this.getContentsForOverrideIdentifer(h);return _?f?(0,I.getConfigurationValue)(_,f):_:void 0}getKeysForOverrideIdentifier(f){const h=[];for(const _ of this.overrides)_.identifiers.includes(f)&&h.push(..._.keys);return S.distinct(h)}getAllOverrideIdentifiers(){const f=[];for(const h of this.overrides)f.push(...h.identifiers);return S.distinct(f)}override(f){let h=this.overrideConfigurations.get(f);return h||(h=this.createOverrideConfigurationModel(f),this.overrideConfigurations.set(f,h)),h}merge(...f){const h=A.deepClone(this.contents),_=A.deepClone(this.overrides),y=[...this.keys],w=this.raw?.length?[...this.raw]:[this];for(const P of f)if(w.push(...P.raw?.length?P.raw:[P]),!P.isEmpty()){this.mergeContents(h,P.contents);for(const R of P.overrides){const[p]=_.filter(b=>S.equals(b.identifiers,R.identifiers));p?(this.mergeContents(p.contents,R.contents),p.keys.push(...R.keys),p.keys=S.distinct(p.keys)):_.push(A.deepClone(R))}for(const R of P.keys)y.indexOf(R)===-1&&y.push(R)}return new r(h,y,_,w.every(P=>P instanceof r)?void 0:w,this.logService)}createOverrideConfigurationModel(f){const h=this.getContentsForOverrideIdentifer(f);if(!h||typeof h!="object"||!Object.keys(h).length)return this;const _={};for(const y of S.distinct([...Object.keys(this.contents),...Object.keys(h)])){let w=this.contents[y];const P=h[y];P&&(typeof w=="object"&&typeof P=="object"?(w=A.deepClone(w),this.mergeContents(w,P)):w=P),_[y]=w}return new r(_,this.keys,this.overrides,void 0,this.logService)}mergeContents(f,h){for(const _ of Object.keys(h)){if(_ in f&&m.isObject(f[_])&&m.isObject(h[_])){this.mergeContents(f[_],h[_]);continue}f[_]=A.deepClone(h[_])}}getContentsForOverrideIdentifer(f){let h=null,_=null;const y=w=>{w&&(_?this.mergeContents(_,w):_=A.deepClone(w))};for(const w of this.overrides)w.identifiers.length===1&&w.identifiers[0]===f?h=w.contents:w.identifiers.includes(f)&&y(w.contents);return y(h),_}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(f,h){this.updateValue(f,h,!0)}setValue(f,h){this.updateValue(f,h,!1)}removeValue(f){const h=this.keys.indexOf(f);h!==-1&&(this.keys.splice(h,1),(0,I.removeFromValueTree)(this.contents,f),E.OVERRIDE_PROPERTY_REGEX.test(f)&&this.overrides.splice(this.overrides.findIndex(_=>S.equals(_.identifiers,(0,E.overrideIdentifiersFromKey)(f))),1))}updateValue(f,h,_){if((0,I.addToValueTree)(this.contents,f,h,y=>this.logService.error(y)),_=_||this.keys.indexOf(f)===-1,_&&this.keys.push(f),E.OVERRIDE_PROPERTY_REGEX.test(f)){const y=(0,E.overrideIdentifiersFromKey)(f),w={identifiers:y,keys:Object.keys(this.contents[f]),contents:(0,I.toValuesTree)(this.contents[f],R=>this.logService.error(R))},P=this.overrides.findIndex(R=>S.equals(R.identifiers,y));P!==-1?this.overrides[P]=w:this.overrides.push(w)}}}e.ConfigurationModel=r;class a{constructor(f,h){this._name=f,this.logService=h,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||r.createEmptyModel(this.logService)}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(f,h){if(!m.isUndefinedOrNull(f)){const _=this.doParseContent(f);this.parseRaw(_,h)}}reparse(f){this._raw&&this.parseRaw(this._raw,f)}parseRaw(f,h){this._raw=f;const{contents:_,keys:y,overrides:w,restricted:P,hasExcludedProperties:R}=this.doParseRaw(f,h);this._configurationModel=new r(_,y,w,R?[f]:void 0,this.logService),this._restrictedConfigurations=P||[]}doParseContent(f){let h={},_=null,y=[];const w=[],P=[];function R(b){Array.isArray(y)?y.push(b):_!==null&&(y[_]=b)}const p={onObjectBegin:()=>{const b={};R(b),w.push(y),y=b,_=null},onObjectProperty:b=>{_=b},onObjectEnd:()=>{y=w.pop()},onArrayBegin:()=>{const b=[];R(b),w.push(y),y=b,_=null},onArrayEnd:()=>{y=w.pop()},onLiteralValue:R,onError:(b,N,L)=>{P.push({error:b,offset:N,length:L})}};if(f)try{D.visit(f,p),h=y[0]||{}}catch(b){this.logService.error(`Error while parsing settings file ${this._name}: ${b}`),this._parseErrors=[b]}return h}doParseRaw(f,h){const _=C.Registry.as(E.Extensions.Configuration).getConfigurationProperties(),y=this.filter(f,_,!0,h);f=y.raw;const w=(0,I.toValuesTree)(f,p=>this.logService.error(`Conflict in settings file ${this._name}: ${p}`)),P=Object.keys(f),R=this.toOverrides(f,p=>this.logService.error(`Conflict in settings file ${this._name}: ${p}`));return{contents:w,keys:P,overrides:R,restricted:y.restricted,hasExcludedProperties:y.hasExcludedProperties}}filter(f,h,_,y){let w=!1;if(!y?.scopes&&!y?.skipRestricted&&!y?.exclude?.length)return{raw:f,restricted:[],hasExcludedProperties:w};const P={},R=[];for(const p in f)if(E.OVERRIDE_PROPERTY_REGEX.test(p)&&_){const b=this.filter(f[p],h,!1,y);P[p]=b.raw,w=w||b.hasExcludedProperties,R.push(...b.restricted)}else{const b=h[p],N=b?typeof b.scope<"u"?b.scope:E.ConfigurationScope.WINDOW:void 0;b?.restricted&&R.push(p),!y.exclude?.includes(p)&&(y.include?.includes(p)||(N===void 0||y.scopes===void 0||y.scopes.includes(N))&&!(y.skipRestricted&&b?.restricted))?P[p]=f[p]:w=!0}return{raw:P,restricted:R,hasExcludedProperties:w}}toOverrides(f,h){const _=[];for(const y of Object.keys(f))if(E.OVERRIDE_PROPERTY_REGEX.test(y)){const w={};for(const P in f[y])w[P]=f[y][P];_.push({identifiers:(0,E.overrideIdentifiersFromKey)(y),keys:Object.keys(w),contents:(0,I.toValuesTree)(w,h)})}return _}}e.ConfigurationModelParser=a;class d extends O.Disposable{constructor(f,h,_,y,w){super(),this.userSettingsResource=f,this.parseOptions=h,this.fileService=y,this.logService=w,this._onDidChange=this._register(new T.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new a(this.userSettingsResource.toString(),w),this._register(this.fileService.watch(_.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(T.Event.any(T.Event.filter(this.fileService.onDidFilesChange,P=>P.contains(this.userSettingsResource)),T.Event.filter(this.fileService.onDidRunOperation,P=>(P.isOperation(u.FileOperation.CREATE)||P.isOperation(u.FileOperation.COPY)||P.isOperation(u.FileOperation.DELETE)||P.isOperation(u.FileOperation.WRITE))&&_.isEqual(P.resource,f)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const f=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(f.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return r.createEmptyModel(this.logService)}}reparse(f){return f&&(this.parseOptions=f),this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=d;class l{constructor(f,h,_,y,w,P,R,p,b,N,L,F,K){this.key=f,this.overrides=h,this._value=_,this.overrideIdentifiers=y,this.defaultConfiguration=w,this.policyConfiguration=P,this.applicationConfiguration=R,this.userConfiguration=p,this.localUserConfiguration=b,this.remoteUserConfiguration=N,this.workspaceConfiguration=L,this.folderConfigurationModel=F,this.memoryConfigurationModel=K}get value(){return v(this._value)}toInspectValue(f){return f?.value!==void 0||f?.override!==void 0||f?.overrides!==void 0?f:void 0}get defaultInspectValue(){return this._defaultInspectValue||(this._defaultInspectValue=this.defaultConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._defaultInspectValue}get defaultValue(){return this.defaultInspectValue.merged}get default(){return this.toInspectValue(this.defaultInspectValue)}get policyInspectValue(){return this._policyInspectValue===void 0&&(this._policyInspectValue=this.policyConfiguration?this.policyConfiguration.inspect(this.key):null),this._policyInspectValue}get policyValue(){return this.policyInspectValue?.merged}get policy(){return this.policyInspectValue?.value!==void 0?{value:this.policyInspectValue.value}:void 0}get applicationInspectValue(){return this._applicationInspectValue===void 0&&(this._applicationInspectValue=this.applicationConfiguration?this.applicationConfiguration.inspect(this.key):null),this._applicationInspectValue}get applicationValue(){return this.applicationInspectValue?.merged}get application(){return this.toInspectValue(this.applicationInspectValue)}get userInspectValue(){return this._userInspectValue||(this._userInspectValue=this.userConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._userInspectValue}get userValue(){return this.userInspectValue.merged}get user(){return this.toInspectValue(this.userInspectValue)}get userLocalInspectValue(){return this._userLocalInspectValue||(this._userLocalInspectValue=this.localUserConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._userLocalInspectValue}get userLocalValue(){return this.userLocalInspectValue.merged}get userLocal(){return this.toInspectValue(this.userLocalInspectValue)}get userRemoteInspectValue(){return this._userRemoteInspectValue||(this._userRemoteInspectValue=this.remoteUserConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._userRemoteInspectValue}get userRemoteValue(){return this.userRemoteInspectValue.merged}get userRemote(){return this.toInspectValue(this.userRemoteInspectValue)}get workspaceInspectValue(){return this._workspaceInspectValue===void 0&&(this._workspaceInspectValue=this.workspaceConfiguration?this.workspaceConfiguration.inspect(this.key,this.overrides.overrideIdentifier):null),this._workspaceInspectValue}get workspaceValue(){return this.workspaceInspectValue?.merged}get workspace(){return this.toInspectValue(this.workspaceInspectValue)}get workspaceFolderInspectValue(){return this._workspaceFolderInspectValue===void 0&&(this._workspaceFolderInspectValue=this.folderConfigurationModel?this.folderConfigurationModel.inspect(this.key,this.overrides.overrideIdentifier):null),this._workspaceFolderInspectValue}get workspaceFolderValue(){return this.workspaceFolderInspectValue?.merged}get workspaceFolder(){return this.toInspectValue(this.workspaceFolderInspectValue)}get memoryInspectValue(){return this._memoryInspectValue===void 0&&(this._memoryInspectValue=this.memoryConfigurationModel.inspect(this.key,this.overrides.overrideIdentifier)),this._memoryInspectValue}get memoryValue(){return this.memoryInspectValue.merged}get memory(){return this.toInspectValue(this.memoryInspectValue)}}class i{constructor(f,h,_,y,w,P,R,p,b,N){this._defaultConfiguration=f,this._policyConfiguration=h,this._applicationConfiguration=_,this._localUserConfiguration=y,this._remoteUserConfiguration=w,this._workspaceConfiguration=P,this._folderConfigurations=R,this._memoryConfiguration=p,this._memoryConfigurationByResource=b,this.logService=N,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new k.ResourceMap,this._userConfiguration=null}getValue(f,h,_){return this.getConsolidatedConfigurationModel(f,h,_).getValue(f)}updateValue(f,h,_={}){let y;_.resource?(y=this._memoryConfigurationByResource.get(_.resource),y||(y=r.createEmptyModel(this.logService),this._memoryConfigurationByResource.set(_.resource,y))):y=this._memoryConfiguration,h===void 0?y.removeValue(f):y.setValue(f,h),_.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(f,h,_){const y=this.getConsolidatedConfigurationModel(f,h,_),w=this.getFolderConfigurationModelForResource(h.resource,_),P=h.resource?this._memoryConfigurationByResource.get(h.resource)||this._memoryConfiguration:this._memoryConfiguration,R=new Set;for(const p of y.overrides)for(const b of p.identifiers)y.getOverrideValue(f,b)!==void 0&&R.add(b);return new l(f,h,y.getValue(f),R.size?[...R]:void 0,this._defaultConfiguration,this._policyConfiguration.isEmpty()?void 0:this._policyConfiguration,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,_?this._workspaceConfiguration:void 0,w||void 0,P)}keys(f){const h=this.getFolderConfigurationModelForResource(void 0,f);return{default:this._defaultConfiguration.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this._workspaceConfiguration.keys.slice(0),workspaceFolder:h?h.keys.slice(0):[]}}updateDefaultConfiguration(f){this._defaultConfiguration=f,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updatePolicyConfiguration(f){this._policyConfiguration=f}updateApplicationConfiguration(f){this._applicationConfiguration=f,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(f){this._localUserConfiguration=f,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(f){this._remoteUserConfiguration=f,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(f){this._workspaceConfiguration=f,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(f,h){this._folderConfigurations.set(f,h),this._foldersConsolidatedConfigurations.delete(f)}deleteFolderConfiguration(f){this.folderConfigurations.delete(f),this._foldersConsolidatedConfigurations.delete(f)}compareAndUpdateDefaultConfiguration(f,h){const _=[];if(!h){const{added:y,updated:w,removed:P}=o(this._defaultConfiguration,f);h=[...y,...w,...P]}for(const y of h)for(const w of(0,E.overrideIdentifiersFromKey)(y)){const P=this._defaultConfiguration.getKeysForOverrideIdentifier(w),R=f.getKeysForOverrideIdentifier(w),p=[...R.filter(b=>P.indexOf(b)===-1),...P.filter(b=>R.indexOf(b)===-1),...P.filter(b=>!A.equals(this._defaultConfiguration.override(w).getValue(b),f.override(w).getValue(b)))];_.push([w,p])}return this.updateDefaultConfiguration(f),{keys:h,overrides:_}}compareAndUpdatePolicyConfiguration(f){const{added:h,updated:_,removed:y}=o(this._policyConfiguration,f),w=[...h,..._,...y];return w.length&&this.updatePolicyConfiguration(f),{keys:w,overrides:[]}}compareAndUpdateApplicationConfiguration(f){const{added:h,updated:_,removed:y,overrides:w}=o(this.applicationConfiguration,f),P=[...h,..._,...y];return P.length&&this.updateApplicationConfiguration(f),{keys:P,overrides:w}}compareAndUpdateLocalUserConfiguration(f){const{added:h,updated:_,removed:y,overrides:w}=o(this.localUserConfiguration,f),P=[...h,..._,...y];return P.length&&this.updateLocalUserConfiguration(f),{keys:P,overrides:w}}compareAndUpdateRemoteUserConfiguration(f){const{added:h,updated:_,removed:y,overrides:w}=o(this.remoteUserConfiguration,f),P=[...h,..._,...y];return P.length&&this.updateRemoteUserConfiguration(f),{keys:P,overrides:w}}compareAndUpdateWorkspaceConfiguration(f){const{added:h,updated:_,removed:y,overrides:w}=o(this.workspaceConfiguration,f),P=[...h,..._,...y];return P.length&&this.updateWorkspaceConfiguration(f),{keys:P,overrides:w}}compareAndUpdateFolderConfiguration(f,h){const _=this.folderConfigurations.get(f),{added:y,updated:w,removed:P,overrides:R}=o(_,h),p=[...y,...w,...P];return(p.length||!_)&&this.updateFolderConfiguration(f,h),{keys:p,overrides:R}}compareAndDeleteFolderConfiguration(f){const h=this.folderConfigurations.get(f);if(!h)throw new Error("Unknown folder");this.deleteFolderConfiguration(f);const{added:_,updated:y,removed:w,overrides:P}=o(h,void 0);return{keys:[..._,...y,...w],overrides:P}}get defaults(){return this._defaultConfiguration}get applicationConfiguration(){return this._applicationConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration)),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidatedConfigurationModel(f,h,_){let y=this.getConsolidatedConfigurationModelForResource(h,_);return h.overrideIdentifier&&(y=y.override(h.overrideIdentifier)),!this._policyConfiguration.isEmpty()&&this._policyConfiguration.getValue(f)!==void 0&&(y=y.merge(this._policyConfiguration)),y}getConsolidatedConfigurationModelForResource({resource:f},h){let _=this.getWorkspaceConsolidatedConfiguration();if(h&&f){const y=h.getFolder(f);y&&(_=this.getFolderConsolidatedConfiguration(y.uri)||_);const w=this._memoryConfigurationByResource.get(f);w&&(_=_.merge(w))}return _}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.applicationConfiguration,this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration)),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(f){let h=this._foldersConsolidatedConfigurations.get(f);if(!h){const _=this.getWorkspaceConsolidatedConfiguration(),y=this._folderConfigurations.get(f);y?(h=_.merge(y),this._foldersConsolidatedConfigurations.set(f,h)):h=_}return h}getFolderConfigurationModelForResource(f,h){if(h&&f){const _=h.getFolder(f);if(_)return this._folderConfigurations.get(_.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},policy:{contents:this._policyConfiguration.contents,overrides:this._policyConfiguration.overrides,keys:this._policyConfiguration.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((f,h)=>{const{contents:_,overrides:y,keys:w}=this._folderConfigurations.get(h);return f.push([h,{contents:_,overrides:y,keys:w}]),f},[])}}allKeys(){const f=new Set;return this._defaultConfiguration.keys.forEach(h=>f.add(h)),this.userConfiguration.keys.forEach(h=>f.add(h)),this._workspaceConfiguration.keys.forEach(h=>f.add(h)),this._folderConfigurations.forEach(h=>h.keys.forEach(_=>f.add(_))),[...f.values()]}allOverrideIdentifiers(){const f=new Set;return this._defaultConfiguration.getAllOverrideIdentifiers().forEach(h=>f.add(h)),this.userConfiguration.getAllOverrideIdentifiers().forEach(h=>f.add(h)),this._workspaceConfiguration.getAllOverrideIdentifiers().forEach(h=>f.add(h)),this._folderConfigurations.forEach(h=>h.getAllOverrideIdentifiers().forEach(_=>f.add(_))),[...f.values()]}getAllKeysForOverrideIdentifier(f){const h=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(f).forEach(_=>h.add(_)),this.userConfiguration.getKeysForOverrideIdentifier(f).forEach(_=>h.add(_)),this._workspaceConfiguration.getKeysForOverrideIdentifier(f).forEach(_=>h.add(_)),this._folderConfigurations.forEach(_=>_.getKeysForOverrideIdentifier(f).forEach(y=>h.add(y))),[...h.values()]}static parse(f,h){const _=this.parseConfigurationModel(f.defaults,h),y=this.parseConfigurationModel(f.policy,h),w=this.parseConfigurationModel(f.application,h),P=this.parseConfigurationModel(f.user,h),R=this.parseConfigurationModel(f.workspace,h),p=f.folders.reduce((b,N)=>(b.set(s.URI.revive(N[0]),this.parseConfigurationModel(N[1],h)),b),new k.ResourceMap);return new i(_,y,w,P,r.createEmptyModel(h),R,p,r.createEmptyModel(h),new k.ResourceMap,h)}static parseConfigurationModel(f,h){return new r(f.contents,f.keys,f.overrides,void 0,h)}}e.Configuration=i;function n(...g){if(g.length===0)return{keys:[],overrides:[]};if(g.length===1)return g[0];const f=new Set,h=new Map;for(const y of g)y.keys.forEach(w=>f.add(w)),y.overrides.forEach(([w,P])=>{const R=(0,k.getOrSet)(h,w,new Set);P.forEach(p=>R.add(p))});const _=[];return h.forEach((y,w)=>_.push([w,[...y.values()]])),{keys:[...f.values()],overrides:_}}class t{constructor(f,h,_,y,w){this.change=f,this.previous=h,this.currentConfiguraiton=_,this.currentWorkspace=y,this.logService=w,this._marker=`
`,this._markerCode1=this._marker.charCodeAt(0),this._markerCode2=46,this.affectedKeys=new Set,this._previousConfiguration=void 0;for(const P of f.keys)this.affectedKeys.add(P);for(const[,P]of f.overrides)for(const R of P)this.affectedKeys.add(R);this._affectsConfigStr=this._marker;for(const P of this.affectedKeys)this._affectsConfigStr+=P+this._marker}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=i.parse(this.previous.data,this.logService)),this._previousConfiguration}affectsConfiguration(f,h){const _=this._marker+f,y=this._affectsConfigStr.indexOf(_);if(y<0)return!1;const w=y+_.length;if(w>=this._affectsConfigStr.length)return!1;const P=this._affectsConfigStr.charCodeAt(w);if(P!==this._markerCode1&&P!==this._markerCode2)return!1;if(h){const R=this.previousConfiguration?this.previousConfiguration.getValue(f,h,this.previous?.workspace):void 0,p=this.currentConfiguraiton.getValue(f,h,this.currentWorkspace);return!A.equals(R,p)}return!0}}e.ConfigurationChangeEvent=t;function o(g,f){const{added:h,removed:_,updated:y}=c(f?.rawConfiguration,g?.rawConfiguration),w=[],P=g?.getAllOverrideIdentifiers()||[],R=f?.getAllOverrideIdentifiers()||[];if(f){const p=R.filter(b=>!P.includes(b));for(const b of p)w.push([b,f.getKeysForOverrideIdentifier(b)])}if(g){const p=P.filter(b=>!R.includes(b));for(const b of p)w.push([b,g.getKeysForOverrideIdentifier(b)])}if(f&&g){for(const p of P)if(R.includes(p)){const b=c({contents:g.getOverrideValue(void 0,p)||{},keys:g.getKeysForOverrideIdentifier(p)},{contents:f.getOverrideValue(void 0,p)||{},keys:f.getKeysForOverrideIdentifier(p)});w.push([p,[...b.added,...b.removed,...b.updated]])}}return{added:h,removed:_,updated:y,overrides:w}}function c(g,f){const h=g?f?g.keys.filter(w=>f.keys.indexOf(w)===-1):[...g.keys]:[],_=f?g?f.keys.filter(w=>g.keys.indexOf(w)===-1):[...f.keys]:[],y=[];if(g&&f){for(const w of f.keys)if(g.keys.indexOf(w)!==-1){const P=(0,I.getConfigurationValue)(f.contents,w),R=(0,I.getConfigurationValue)(g.contents,w);A.equals(P,R)||y.push(w)}}return{added:h,removed:_,updated:y}}}),define(ke[110],Re([1,0,12,3]),function(Ee,e,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.WebSocketRemoteConnection=e.ManagedRemoteConnection=e.RemoteConnectionType=e.IRemoteAuthorityResolverService=void 0,e.getRemoteAuthorityPrefix=s,e.IRemoteAuthorityResolverService=(0,T.createDecorator)("remoteAuthorityResolverService");var D;(function(I){I[I.WebSocket=0]="WebSocket",I[I.Managed=1]="Managed"})(D||(e.RemoteConnectionType=D={}));class O{constructor(E){this.id=E,this.type=D.Managed}toString(){return`Managed(${this.id})`}}e.ManagedRemoteConnection=O;class k{constructor(E,u){this.host=E,this.port=u,this.type=D.WebSocket}toString(){return`WebSocket(${this.host}:${this.port})`}}e.WebSocketRemoteConnection=k;var A;(function(I){I.Unknown="Unknown",I.NotAvailable="NotAvailable",I.TemporarilyNotAvailable="TemporarilyNotAvailable",I.NoResolverFound="NoResolverFound",I.InvalidAuthority="InvalidAuthority"})(A||(e.RemoteAuthorityResolverErrorCode=A={}));class m extends S.ErrorNoTelemetry{static isNotAvailable(E){return E instanceof m&&E._code===A.NotAvailable}static isTemporarilyNotAvailable(E){return E instanceof m&&E._code===A.TemporarilyNotAvailable}static isNoResolverFound(E){return E instanceof m&&E._code===A.NoResolverFound}static isInvalidAuthority(E){return E instanceof m&&E._code===A.InvalidAuthority}static isHandled(E){return E instanceof m&&E.isHandled}constructor(E,u=A.Unknown,C){super(E),this._message=E,this._code=u,this._detail=C,this.isHandled=u===A.NotAvailable&&C===!0,Object.setPrototypeOf(this,m.prototype)}}e.RemoteAuthorityResolverError=m;function s(I){const E=I.indexOf("+");return E===-1?I:I.substring(0,E)}}),define(ke[62],Re([1,0,15]),function(Ee,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteAuthority=T,e.getRemoteName=D,e.parseAuthorityWithPort=O,e.parseAuthorityWithOptionalPort=k;function T(m){return m.scheme===S.Schemas.vscodeRemote?m.authority:void 0}function D(m){if(!m)return;const s=m.indexOf("+");return s<0?m:m.substr(0,s)}function O(m){const{host:s,port:I}=A(m);if(typeof I>"u")throw new Error(`Invalid remote authority: ${m}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:s,port:I}}function k(m,s){let{host:I,port:E}=A(m);return typeof E>"u"&&(E=s),{host:I,port:E}}function A(m){const s=m.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(s)return{host:s[1],port:parseInt(s[2],10)};const I=m.match(/^(\[[0-9a-z:]+\])$/);if(I)return{host:I[1],port:void 0};const E=m.match(/(.*):(\d+)$/);return E?{host:E[1],port:parseInt(E[2],10)}:{host:m,port:void 0}}}),define(ke[18],Re([1,0,13,3,62]),function(Ee,e,S,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.ExtensionIdentifierMap=e.ExtensionIdentifierSet=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=void 0,e.getWorkspaceSupportTypeMessage=O,e.isApplicationScopedExtension=E,e.isLanguagePackExtension=u,e.isAuthenticationProviderExtension=C,e.isResolverExtension=v,e.parseApiProposals=r,e.parseEnabledApiProposalNames=a,S=Ve(S),e.USER_MANIFEST_CACHE_FILE="extensions.user.cache",e.BUILTIN_MANIFEST_CACHE_FILE="extensions.builtin.cache",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function O(d){if(typeof d=="object"&&d!==null&&d.supported!==!0)return d.description}e.EXTENSION_CATEGORIES=["AI","Azure","Chat","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var k;(function(d){d[d.System=0]="System",d[d.User=1]="User"})(k||(e.ExtensionType=k={}));var A;(function(d){d.WIN32_X64="win32-x64",d.WIN32_ARM64="win32-arm64",d.LINUX_X64="linux-x64",d.LINUX_ARM64="linux-arm64",d.LINUX_ARMHF="linux-armhf",d.LINUX_PPC64LE="linux-ppc64le",d.LINUX_RISCV64="linux-riscv64",d.ALPINE_X64="alpine-x64",d.ALPINE_ARM64="alpine-arm64",d.DARWIN_X64="darwin-x64",d.DARWIN_ARM64="darwin-arm64",d.WEB="web",d.UNIVERSAL="universal",d.UNKNOWN="unknown",d.UNDEFINED="undefined"})(A||(e.TargetPlatform=A={}));class m{constructor(l){this.value=l,this._lower=l.toLowerCase()}static equals(l,i){if(typeof l>"u"||l===null)return typeof i>"u"||i===null;if(typeof i>"u"||i===null)return!1;if(typeof l=="string"||typeof i=="string"){const n=typeof l=="string"?l:l.value,t=typeof i=="string"?i:i.value;return S.equalsIgnoreCase(n,t)}return l._lower===i._lower}static toKey(l){return typeof l=="string"?l.toLowerCase():l._lower}}e.ExtensionIdentifier=m;class s{get size(){return this._set.size}constructor(l){if(this._set=new Set,l)for(const i of l)this.add(i)}add(l){this._set.add(m.toKey(l))}delete(l){return this._set.delete(m.toKey(l))}has(l){return this._set.has(m.toKey(l))}}e.ExtensionIdentifierSet=s;class I{constructor(){this._map=new Map}clear(){this._map.clear()}delete(l){this._map.delete(m.toKey(l))}get(l){return this._map.get(m.toKey(l))}has(l){return this._map.has(m.toKey(l))}set(l,i){this._map.set(m.toKey(l),i)}values(){return this._map.values()}forEach(l){this._map.forEach(l)}[Symbol.iterator](){return this._map[Symbol.iterator]()}}e.ExtensionIdentifierMap=I;function E(d){return u(d)}function u(d){return d.contributes&&d.contributes.localizations?d.contributes.localizations.length>0:!1}function C(d){return d.contributes&&d.contributes.authentication?d.contributes.authentication.length>0:!1}function v(d,l){if(l){const i=`onResolveRemoteAuthority:${(0,D.getRemoteName)(l)}`;return!!d.activationEvents?.includes(i)}return!1}function r(d){return d.map(l=>{const[i,n]=l.split("@");return{proposalName:i,version:n?parseInt(n):void 0}})}function a(d){return d.map(l=>l.split("@")[0])}e.IBuiltinExtensionsScannerService=(0,T.createDecorator)("IBuiltinExtensionsScannerService")}),define(ke[111],Re([1,0,23,9,18,3]),function(Ee,e,S,T,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.ExtensionsLocalizedLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.ExtensionGalleryError=e.ExtensionGalleryErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.ExtensionInstallSource=e.EXTENSION_INSTALL_CLIENT_TARGET_PLATFORM_CONTEXT=e.EXTENSION_INSTALL_DEP_PACK_CONTEXT=e.EXTENSION_INSTALL_SOURCE_CONTEXT=e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.TargetPlatformToString=A,e.toTargetPlatform=m,e.getTargetPlatform=s,e.isNotWebExtensionInWebTargetPlatform=I,e.isTargetPlatformCompatible=E,e.isIExtensionIdentifier=u,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension",e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT="skipWalkthrough",e.EXTENSION_INSTALL_SOURCE_CONTEXT="extensionInstallSource",e.EXTENSION_INSTALL_DEP_PACK_CONTEXT="dependecyOrPackExtensionInstall",e.EXTENSION_INSTALL_CLIENT_TARGET_PLATFORM_CONTEXT="clientTargetPlatform";var k;(function(t){t.COMMAND="command",t.SETTINGS_SYNC="settingsSync"})(k||(e.ExtensionInstallSource=k={}));function A(t){switch(t){case D.TargetPlatform.WIN32_X64:return"Windows 64 bit";case D.TargetPlatform.WIN32_ARM64:return"Windows ARM";case D.TargetPlatform.LINUX_X64:return"Linux 64 bit";case D.TargetPlatform.LINUX_ARM64:return"Linux ARM 64";case D.TargetPlatform.LINUX_ARMHF:return"Linux ARM";case D.TargetPlatform.LINUX_PPC64LE:return"Linux PowerPC64";case D.TargetPlatform.LINUX_RISCV64:return"Linux RISC-V 64";case D.TargetPlatform.ALPINE_X64:return"Alpine Linux 64 bit";case D.TargetPlatform.ALPINE_ARM64:return"Alpine ARM 64";case D.TargetPlatform.DARWIN_X64:return"Mac";case D.TargetPlatform.DARWIN_ARM64:return"Mac Silicon";case D.TargetPlatform.WEB:return"Web";case D.TargetPlatform.UNIVERSAL:return D.TargetPlatform.UNIVERSAL;case D.TargetPlatform.UNKNOWN:return D.TargetPlatform.UNKNOWN;case D.TargetPlatform.UNDEFINED:return D.TargetPlatform.UNDEFINED}}function m(t){switch(t){case D.TargetPlatform.WIN32_X64:return D.TargetPlatform.WIN32_X64;case D.TargetPlatform.WIN32_ARM64:return D.TargetPlatform.WIN32_ARM64;case D.TargetPlatform.LINUX_X64:return D.TargetPlatform.LINUX_X64;case D.TargetPlatform.LINUX_ARM64:return D.TargetPlatform.LINUX_ARM64;case D.TargetPlatform.LINUX_ARMHF:return D.TargetPlatform.LINUX_ARMHF;case D.TargetPlatform.LINUX_PPC64LE:return D.TargetPlatform.LINUX_PPC64LE;case D.TargetPlatform.LINUX_RISCV64:return D.TargetPlatform.LINUX_RISCV64;case D.TargetPlatform.ALPINE_X64:return D.TargetPlatform.ALPINE_X64;case D.TargetPlatform.ALPINE_ARM64:return D.TargetPlatform.ALPINE_ARM64;case D.TargetPlatform.DARWIN_X64:return D.TargetPlatform.DARWIN_X64;case D.TargetPlatform.DARWIN_ARM64:return D.TargetPlatform.DARWIN_ARM64;case D.TargetPlatform.WEB:return D.TargetPlatform.WEB;case D.TargetPlatform.UNIVERSAL:return D.TargetPlatform.UNIVERSAL;default:return D.TargetPlatform.UNKNOWN}}function s(t,o){switch(t){case S.Platform.Windows:return o==="x64"?D.TargetPlatform.WIN32_X64:o==="arm64"?D.TargetPlatform.WIN32_ARM64:D.TargetPlatform.UNKNOWN;case S.Platform.Linux:return o==="x64"?D.TargetPlatform.LINUX_X64:o==="arm64"?D.TargetPlatform.LINUX_ARM64:o==="arm"?D.TargetPlatform.LINUX_ARMHF:o==="ppc64le"?D.TargetPlatform.LINUX_PPC64LE:o==="riscv64"?D.TargetPlatform.LINUX_RISCV64:D.TargetPlatform.UNKNOWN;case"alpine":return o==="x64"?D.TargetPlatform.ALPINE_X64:o==="arm64"?D.TargetPlatform.ALPINE_ARM64:D.TargetPlatform.UNKNOWN;case S.Platform.Mac:return o==="x64"?D.TargetPlatform.DARWIN_X64:o==="arm64"?D.TargetPlatform.DARWIN_ARM64:D.TargetPlatform.UNKNOWN;case S.Platform.Web:return D.TargetPlatform.WEB}}function I(t,o){return o===D.TargetPlatform.WEB&&!t.includes(D.TargetPlatform.WEB)}function E(t,o,c){return I(o,c)?!1:t===D.TargetPlatform.UNDEFINED||t===D.TargetPlatform.UNIVERSAL?!0:t===D.TargetPlatform.UNKNOWN?!1:t===c}function u(t){return t&&typeof t=="object"&&typeof t.id=="string"&&(!t.uuid||typeof t.uuid=="string")}var C;(function(t){t[t.NoneOrRelevance=0]="NoneOrRelevance",t[t.LastUpdatedDate=1]="LastUpdatedDate",t[t.Title=2]="Title",t[t.PublisherName=3]="PublisherName",t[t.InstallCount=4]="InstallCount",t[t.PublishedDate=10]="PublishedDate",t[t.AverageRating=6]="AverageRating",t[t.WeightedRating=12]="WeightedRating"})(C||(e.SortBy=C={}));var v;(function(t){t[t.Default=0]="Default",t[t.Ascending=1]="Ascending",t[t.Descending=2]="Descending"})(v||(e.SortOrder=v={}));var r;(function(t){t.Install="install",t.Uninstall="uninstall"})(r||(e.StatisticType=r={}));var a;(function(t){t[t.None=1]="None",t[t.Install=2]="Install",t[t.Update=3]="Update",t[t.Migrate=4]="Migrate"})(a||(e.InstallOperation=a={})),e.IExtensionGalleryService=(0,O.createDecorator)("extensionGalleryService");var d;(function(t){t.Timeout="Timeout",t.Cancelled="Cancelled",t.Failed="Failed",t.DownloadFailedWriting="DownloadFailedWriting",t.Offline="Offline"})(d||(e.ExtensionGalleryErrorCode=d={}));class l extends Error{constructor(o,c){super(o),this.code=c,this.name=c}}e.ExtensionGalleryError=l;var i;(function(t){t.Unsupported="Unsupported",t.Deprecated="Deprecated",t.Malicious="Malicious",t.Incompatible="Incompatible",t.IncompatibleApi="IncompatibleApi",t.IncompatibleTargetPlatform="IncompatibleTargetPlatform",t.ReleaseVersionNotFound="ReleaseVersionNotFound",t.Invalid="Invalid",t.Download="Download",t.DownloadSignature="DownloadSignature",t.DownloadFailedWriting="DownloadFailedWriting",t.UpdateMetadata="UpdateMetadata",t.Extract="Extract",t.Scanning="Scanning",t.ScanningExtension="ScanningExtension",t.ReadUninstalled="ReadUninstalled",t.UnsetUninstalled="UnsetUninstalled",t.Delete="Delete",t.Rename="Rename",t.IntializeDefaultProfile="IntializeDefaultProfile",t.AddToProfile="AddToProfile",t.InstalledExtensionNotFound="InstalledExtensionNotFound",t.PostInstall="PostInstall",t.CorruptZip="CorruptZip",t.IncompleteZip="IncompleteZip",t.Signature="Signature",t.NotAllowed="NotAllowed",t.Gallery="Gallery",t.Cancelled="Cancelled",t.Unknown="Unknown",t.Internal="Internal"})(i||(e.ExtensionManagementErrorCode=i={}));class n extends Error{constructor(o,c){super(o),this.code=c,this.name=c}}e.ExtensionManagementError=n,e.IExtensionManagementService=(0,O.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,O.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,O.createDecorator)("IExtensionTipsService"),e.ExtensionsLocalizedLabel=(0,T.localize2)(1780,"Extensions"),e.PreferencesLocalizedLabel=(0,T.localize2)(1781,"Preferences")}),define(ke[112],Re([1,0,12,18]),function(Ee,e,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImplicitActivationEvents=e.ImplicitActivationEventsImpl=void 0;class D{constructor(){this._generators=new Map,this._cache=new WeakMap}register(k,A){this._generators.set(k,A)}readActivationEvents(k){return this._cache.has(k)||this._cache.set(k,this._readActivationEvents(k)),this._cache.get(k)}createActivationEventsMap(k){const A=Object.create(null);for(const m of k){const s=this.readActivationEvents(m);s.length>0&&(A[T.ExtensionIdentifier.toKey(m.identifier)]=s)}return A}_readActivationEvents(k){if(typeof k.main>"u"&&typeof k.browser>"u")return[];const A=Array.isArray(k.activationEvents)?k.activationEvents.slice(0):[];for(let m=0;m<A.length;m++)A[m]==="onUri"&&(A[m]=`onUri:${T.ExtensionIdentifier.toKey(k.identifier)}`);if(!k.contributes)return A;for(const m in k.contributes){const s=this._generators.get(m);if(!s)continue;const I=k.contributes[m],E=Array.isArray(I)?I:[I];try{s(E,A)}catch(u){(0,S.onUnexpectedError)(u)}}return A}}e.ImplicitActivationEventsImpl=D,e.ImplicitActivationEvents=new D});var oi=this&&this.__importDefault||function(Ee){return Ee&&Ee.__esModule?Ee:{default:Ee}};define(ke[176],Re([1,0,24,37,9,281,18,105]),function(Ee,e,S,T,D,O,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isValidVersionStr=I,e.parseVersion=E,e.normalizeVersion=u,e.isValidVersion=C,e.validateExtensionManifest=v,e.isValidExtensionVersion=r,e.isEngineValid=a,e.areApiProposalsCompatible=d,T=oi(T),D=Ve(D),O=Ve(O);const m=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,s=/^-(\d{4})(\d{2})(\d{2})$/;function I(n){return n=n.trim(),n==="*"||m.test(n)}function E(n){if(!I(n))return null;if(n=n.trim(),n==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const t=n.match(m);return t?{hasCaret:t[1]==="^",hasGreaterEquals:t[1]===">=",majorBase:t[2]==="x"?0:parseInt(t[2],10),majorMustEqual:t[2]!=="x",minorBase:t[4]==="x"?0:parseInt(t[4],10),minorMustEqual:t[4]!=="x",patchBase:t[6]==="x"?0:parseInt(t[6],10),patchMustEqual:t[6]!=="x",preRelease:t[8]||null}:null}function u(n){if(!n)return null;const t=n.majorBase,o=n.majorMustEqual,c=n.minorBase;let g=n.minorMustEqual;const f=n.patchBase;let h=n.patchMustEqual;n.hasCaret&&(t===0||(g=!1),h=!1);let _=0;if(n.preRelease){const y=s.exec(n.preRelease);if(y){const[,w,P,R]=y;_=Date.UTC(Number(w),Number(P)-1,Number(R))}}return{majorBase:t,majorMustEqual:o,minorBase:c,minorMustEqual:g,patchBase:f,patchMustEqual:h,isMinimum:n.hasGreaterEquals,notBefore:_}}function C(n,t,o){let c;typeof n=="string"?c=u(E(n)):c=n;let g;t instanceof Date?g=t.getTime():typeof t=="string"&&(g=new Date(t).getTime());let f;if(typeof o=="string"?f=u(E(o)):f=o,!c||!f)return!1;const h=c.majorBase,_=c.minorBase,y=c.patchBase;let w=f.majorBase,P=f.minorBase,R=f.patchBase;const p=f.notBefore;let b=f.majorMustEqual,N=f.minorMustEqual,L=f.patchMustEqual;return f.isMinimum?h>w?!0:h<w?!1:_>P?!0:_<P||g&&g<p?!1:y>=R:(h===1&&w===0&&(!b||!N||!L)&&(w=1,P=0,R=0,b=!0,N=!1,L=!1),h<w?!1:h>w?!b:_<P?!1:_>P?!N:y<R?!1:y>R?!L:!(g&&g<p))}function v(n,t,o,c,g,f){const h=[];if(typeof c.publisher<"u"&&typeof c.publisher!="string")return h.push([T.default.Error,D.localize(1832,null)]),h;if(typeof c.name!="string")return h.push([T.default.Error,D.localize(1833,null,"name")]),h;if(typeof c.version!="string")return h.push([T.default.Error,D.localize(1834,null,"version")]),h;if(!c.engines)return h.push([T.default.Error,D.localize(1835,null,"engines")]),h;if(typeof c.engines.vscode!="string")return h.push([T.default.Error,D.localize(1836,null,"engines.vscode")]),h;if(typeof c.extensionDependencies<"u"&&!i(c.extensionDependencies))return h.push([T.default.Error,D.localize(1837,null,"extensionDependencies")]),h;if(typeof c.activationEvents<"u"){if(!i(c.activationEvents))return h.push([T.default.Error,D.localize(1838,null,"activationEvents")]),h;if(typeof c.main>"u"&&typeof c.browser>"u")return h.push([T.default.Error,D.localize(1839,null,"activationEvents","main","browser")]),h}if(typeof c.extensionKind<"u"&&typeof c.main>"u"&&h.push([T.default.Warning,D.localize(1840,null,"extensionKind")]),typeof c.main<"u"){if(typeof c.main!="string")return h.push([T.default.Error,D.localize(1841,null,"main")]),h;{const w=(0,S.joinPath)(o,c.main);(0,S.isEqualOrParent)(w,o)||h.push([T.default.Warning,D.localize(1842,null,w.path,o.path)])}}if(typeof c.browser<"u"){if(typeof c.browser!="string")return h.push([T.default.Error,D.localize(1843,null,"browser")]),h;{const w=(0,S.joinPath)(o,c.browser);(0,S.isEqualOrParent)(w,o)||h.push([T.default.Warning,D.localize(1844,null,w.path,o.path)])}}if(!O.valid(c.version))return h.push([T.default.Error,D.localize(1845,null)]),h;const _=[];if(!r(n,t,c,g,_))for(const w of _)h.push([T.default.Error,w]);if(f&&c.enabledApiProposals?.length){const w=[];if(!d([...c.enabledApiProposals],w))for(const P of w)h.push([T.default.Error,P])}return h}function r(n,t,o,c,g){return c||typeof o.main>"u"&&typeof o.browser>"u"?!0:l(n,t,o.engines.vscode,g)}function a(n,t,o){return n==="*"||l(t,o,n)}function d(n,t){if(n.length===0)return!0;const o=Array.isArray(t)?t:void 0,c=(o?void 0:t)??A.allApiProposals,g=[],f=(0,k.parseApiProposals)(n);for(const{proposalName:h,version:_}of f){const y=c[h];y&&_&&y.version!==_&&g.push(D.localize(1846,null,h))}return o?.push(...g),g.length===0}function l(n,t,o,c=[]){const g=u(E(o));if(!g)return c.push(D.localize(1847,null,o)),!1;if(g.majorBase===0){if(!g.majorMustEqual||!g.minorMustEqual)return c.push(D.localize(1848,null,o)),!1}else if(!g.majorMustEqual)return c.push(D.localize(1849,null,o)),!1;return C(n,t,g)?!0:(c.push(D.localize(1850,null,n,o)),!1)}function i(n){if(!Array.isArray(n))return!1;for(let t=0,o=n.length;t<o;t++)if(typeof n[t]!="string")return!1;return!0}}),define(ke[177],Re([1,0,20,12,4,9,53,3,11,29]),function(Ee,e,S,T,D,O,k,A,m,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractRequestService=e.IRequestService=void 0,e.isSuccess=u,e.hasNoContent=C,e.asText=v,e.asTextOrError=r,e.asJson=a,e.updateProxyConfigurationsScope=d,e.IRequestService=(0,A.createDecorator)("requestService");class I{constructor(t){this.original=t}toJSON(){if(!this.headers){const t=Object.create(null);for(const o in this.original)o.toLowerCase()==="authorization"||o.toLowerCase()==="proxy-authorization"?t[o]="*****":t[o]=this.original[o];this.headers=t}return this.headers}}class E extends D.Disposable{constructor(t){super(),this.counter=0,this.logger=t.createLogger("network",{name:(0,O.localize)(2050,null),when:m.CONTEXT_LOG_LEVEL.isEqualTo((0,m.LogLevelToString)(m.LogLevel.Trace)).serialize()})}async logAndRequest(t,o,c){const g=`${t} #${++this.counter}: ${o.url}`;this.logger.trace(`${g} - begin`,o.type,new I(o.headers??{}));try{const f=await c();return this.logger.trace(`${g} - end`,o.type,f.res.statusCode,f.res.headers),f}catch(f){throw this.logger.error(`${g} - error`,o.type,(0,T.getErrorMessage)(f)),f}}}e.AbstractRequestService=E;function u(n){return n.res.statusCode&&n.res.statusCode>=200&&n.res.statusCode<300||n.res.statusCode===1223}function C(n){return n.res.statusCode===204}async function v(n){return C(n)?null:(await(0,S.streamToBuffer)(n.stream)).toString()}async function r(n){if(!u(n))throw new Error("Server returned "+n.res.statusCode);return v(n)}async function a(n){if(!u(n))throw new Error("Server returned "+n.res.statusCode);if(C(n))return null;const o=(await(0,S.streamToBuffer)(n.stream)).toString();try{return JSON.parse(o)}catch(c){throw c.message+=`:
`+o,c}}function d(n){i(n)}let l;function i(n){const t=s.Registry.as(k.Extensions.Configuration),o=l;l={id:"http",order:15,title:(0,O.localize)(2051,null),type:"object",scope:n,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,O.localize)(2052,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,O.localize)(2053,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,O.localize)(2054,null),restricted:!0},"http.noProxy":{type:"array",items:{type:"string"},markdownDescription:(0,O.localize)(2055,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,O.localize)(2056,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,O.localize)(2057,null),(0,O.localize)(2058,null),(0,O.localize)(2059,null),(0,O.localize)(2060,null)],default:"override",description:(0,O.localize)(2061,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,O.localize)(2062,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,O.localize)(2063,null),restricted:!0}}},t.updateConfigurations({add:[l],remove:o?[o]:[]})}i(k.ConfigurationScope.APPLICATION)}),define(ke[178],Re([1,0,23,79,33]),function(Ee,e,S,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveCommonProperties=k,e.verifyMicrosoftInternalDomain=A;function O(m){if(S.platform===S.Platform.Linux&&/^penguin(\.|$)/i.test(m))return"chromebook"}function k(m,s,I,E,u,C,v,r,a,d){const l=Object.create(null);l["common.machineId"]=C,l["common.sqmId"]=v,l["common.devDeviceId"]=r,l.sessionID=(0,D.generateUuid)()+Date.now(),l.commitHash=E,l.version=u,l["common.platformVersion"]=(m||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),l["common.platform"]=(0,S.PlatformToString)(S.platform),l["common.nodePlatform"]=T.platform,l["common.nodeArch"]=I,l["common.product"]=d||"desktop",a&&(l["common.msftInternal"]=a);let i=0;const n=Date.now();Object.defineProperties(l,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-n,enumerable:!0},"common.sequence":{get:()=>i++,enumerable:!0}}),S.isLinuxSnap&&(l["common.snap"]="true");const t=O(s);return t&&(l["common.platformDetail"]=t),l}function A(m){const s=T.env.USERDNSDOMAIN;if(!s)return!1;const I=s.toLowerCase();return m.some(E=>I===E)}}),define(ke[113],Re([1,0,3]),function(Ee,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_CRASH_REPORTER_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.devDeviceIdKey=e.sqmIdKey=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,S.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,S.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.sqmIdKey="telemetry.sqmId",e.devDeviceIdKey="telemetry.devDeviceId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_CRASH_REPORTER_SETTING_ID="telemetry.enableCrashReporter",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var T;(function(O){O[O.NONE=0]="NONE",O[O.CRASH=1]="CRASH",O[O.ERROR=2]="ERROR",O[O.USAGE=3]="USAGE"})(T||(e.TelemetryLevel=T={}));var D;(function(O){O.OFF="off",O.CRASH="crash",O.ERROR="error",O.ON="all"})(D||(e.TelemetryConfiguration=D={}))}),define(ke[63],Re([1,0,25,14,62,178,113]),function(Ee,e,S,T,D,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullAppender=e.extensionTelemetryLogChannelId=e.telemetryLogId=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TelemetryTrustedValue=void 0,e.supportsTelemetry=I,e.isLoggingOnly=E,e.getTelemetryLevel=u,e.validateTelemetryData=C,e.cleanRemoteAuthority=r,e.isInternalTelemetry=d,e.getPiiPathsFromEnvironment=l,e.cleanData=t;class A{constructor(c){this.value=c,this.isTrustedTelemetryValue=!0}}e.TelemetryTrustedValue=A;class m{constructor(){this.telemetryLevel=k.TelemetryLevel.NONE,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.devDeviceId="someValue.devDeviceId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.NullTelemetryServiceShape=m,e.NullTelemetryService=new m;class s{async publicLog(c,g,f){}async publicLogError(c,g,f){}}e.NullEndpointTelemetryService=s,e.telemetryLogId="telemetry",e.extensionTelemetryLogChannelId="extensionTelemetryLog",e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function I(o,c){return!c.isBuilt&&!c.disableTelemetry?!0:!(c.disableTelemetry||!o.enableTelemetry)}function E(o,c){return c.extensionTestsLocationURI?!0:!(c.isBuilt||c.disableTelemetry||o.enableTelemetry&&o.aiConfig?.ariaKey)}function u(o){const c=o.getValue(k.TELEMETRY_SETTING_ID),g=o.getValue(k.TELEMETRY_CRASH_REPORTER_SETTING_ID);if(o.getValue(k.TELEMETRY_OLD_SETTING_ID)===!1||g===!1)return k.TelemetryLevel.NONE;switch(c??k.TelemetryConfiguration.ON){case k.TelemetryConfiguration.ON:return k.TelemetryLevel.USAGE;case k.TelemetryConfiguration.ERROR:return k.TelemetryLevel.ERROR;case k.TelemetryConfiguration.CRASH:return k.TelemetryLevel.CRASH;case k.TelemetryConfiguration.OFF:return k.TelemetryLevel.NONE}}function C(o){const c={},g={},f={};a(o,f);for(let h in f){h=h.length>150?h.substr(h.length-149):h;const _=f[h];typeof _=="number"?g[h]=_:typeof _=="boolean"?g[h]=_?1:0:typeof _=="string"?(_.length>8192&&console.warn(`Telemetry property: ${h} has been trimmed to 8192, the original length is ${_.length}`),c[h]=_.substring(0,8191)):typeof _<"u"&&_!==null&&(c[h]=_)}return{properties:c,measurements:g}}const v=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function r(o){if(!o)return"none";const c=(0,D.getRemoteName)(o);return v.has(c)?c:"other"}function a(o,c,g=0,f){if(o)for(const h of Object.getOwnPropertyNames(o)){const _=o[h],y=f?f+h:h;Array.isArray(_)?c[y]=(0,S.safeStringify)(_):_ instanceof Date?c[y]=_.toISOString():(0,T.isObject)(_)?g<2?a(_,c,g+1,y+"."):c[y]=(0,S.safeStringify)(_):c[y]=_}}function d(o,c){const g=o.msftInternalDomains||[],f=c.getValue("telemetry.internalTesting");return(0,O.verifyMicrosoftInternalDomain)(g)||f}function l(o){return[o.appRoot,o.extensionsPath,o.userHome.fsPath,o.tmpDir.fsPath,o.userDataPath]}function i(o,c){if(!o||!o.includes("/")&&!o.includes("\\"))return o;let g=o;const f=[];for(const w of c)for(;;){const P=w.exec(o);if(!P)break;f.push([P.index,w.lastIndex])}const h=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,_=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let y=0;for(g="";;){const w=_.exec(o);if(!w)break;const P=f.some(([R,p])=>w.index<p&&R<_.lastIndex);!h.test(w[0])&&!P&&(g+=o.substring(y,w.index)+"<REDACTED: user-file-path>",y=_.lastIndex)}return y<o.length&&(g+=o.substr(y)),g}function n(o){if(!o)return o;const c=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"CLI Credentials",regex:/((login|psexec|(certutil|psexec)\.exe).{1,50}(\s-u(ser(name)?)?\s+.{3,100})?\s-(admin|user|vm|root)?p(ass(word)?)?\s+["']?[^$\-\/\s]|(^|[\s\r\n\\])net(\.exe)?.{1,5}(user\s+|share\s+\/user:| user -? secrets ? set) \s + [^ $\s \/])/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const g of c)if(g.regex.test(o))return`<REDACTED: ${g.label}>`;return o}function t(o,c){return(0,S.cloneAndChange)(o,g=>{if(g instanceof A||Object.hasOwnProperty.call(g,"isTrustedTelemetryValue"))return g.value;if(typeof g=="string"){let f=g.replaceAll("%20"," ");f=i(f,c);for(const h of c)f=f.replace(h,"");return f=n(f),f}})}}),define(ke[179],Re([1,0,13,111,18,23,2,12,79,63]),function(Ee,e,S,T,D,O,k,A,m,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BetterMergeId=e.ExtensionKey=void 0,e.areSameExtensions=I,e.getIdAndVersion=v,e.getExtensionId=r,e.adoptToGalleryExtensionId=a,e.getGalleryExtensionId=d,e.groupByExtension=l,e.getLocalExtensionTelemetryData=i,e.getGalleryExtensionTelemetryData=n,e.getExtensionDependencies=t,e.computeTargetPlatform=c;function I(g,f){return g.uuid&&f.uuid?g.uuid===f.uuid:g.id===f.id?!0:(0,S.compareIgnoreCase)(g.id,f.id)===0}const E=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class u{static create(f){const h=f.manifest?f.manifest.version:f.version,_=f.manifest?f.targetPlatform:f.properties.targetPlatform;return new u(f.identifier,h,_)}static parse(f){const h=E.exec(f);return h&&h[1]&&h[2]?new u({id:h[1]},h[2],h[4]||void 0):null}constructor(f,h,_=D.TargetPlatform.UNDEFINED){this.identifier=f,this.version=h,this.targetPlatform=_,this.id=f.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!==D.TargetPlatform.UNDEFINED?`-${this.targetPlatform}`:""}`}equals(f){return f instanceof u?I(this,f)&&this.version===f.version&&this.targetPlatform===f.targetPlatform:!1}}e.ExtensionKey=u;const C=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function v(g){const f=C.exec(g);return f&&f[1]?[a(f[1]),f[2]]:[a(g),void 0]}function r(g,f){return`${g}.${f}`}function a(g){return g.toLowerCase()}function d(g,f){return a(r(g??D.UNDEFINED_PUBLISHER,f))}function l(g,f){const h=[],_=y=>{for(const w of h)if(w.some(P=>I(f(P),f(y))))return w;return null};for(const y of g){const w=_(y);w?w.push(y):h.push([y])}return h}function i(g){return{id:g.identifier.id,name:g.manifest.name,galleryId:null,publisherId:g.publisherId,publisherName:g.manifest.publisher,publisherDisplayName:g.publisherDisplayName,dependencies:g.manifest.extensionDependencies&&g.manifest.extensionDependencies.length>0}}function n(g){return{id:new s.TelemetryTrustedValue(g.identifier.id),name:new s.TelemetryTrustedValue(g.name),version:g.version,galleryId:g.identifier.uuid,publisherId:g.publisherId,publisherName:g.publisher,publisherDisplayName:g.publisherDisplayName,isPreReleaseVersion:g.properties.isPreReleaseVersion,dependencies:!!(g.properties.dependencies&&g.properties.dependencies.length>0),isSigned:g.isSigned,...g.telemetryData}}e.BetterMergeId=new D.ExtensionIdentifier("pprice.better-merge");function t(g,f){const h=[],_=f.manifest.extensionDependencies?.slice(0)??[];for(;_.length;){const y=_.shift();if(y&&h.every(w=>!I(w.identifier,{id:y}))){const w=g.filter(P=>I(P.identifier,{id:y}));w.length===1&&(h.push(w[0]),_.push(...w[0].manifest.extensionDependencies?.slice(0)??[]))}}return h}async function o(g,f){if(!O.isLinux)return!1;let h;try{h=(await g.readFile(k.URI.file("/etc/os-release"))).value.toString()}catch{try{h=(await g.readFile(k.URI.file("/usr/lib/os-release"))).value.toString()}catch(y){f.debug("Error while getting the os-release file.",(0,A.getErrorMessage)(y))}}return!!h&&(h.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function c(g,f){const h=await o(g,f),_=(0,T.getTargetPlatform)(h?"alpine":O.platform,m.arch);return f.debug("ComputeTargetPlatform:",_),_}}),define(ke[180],Re([1,0]),function(Ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.serializeEnvironmentVariableCollection=S,e.serializeEnvironmentDescriptionMap=T,e.deserializeEnvironmentVariableCollection=D,e.deserializeEnvironmentDescriptionMap=O,e.serializeEnvironmentVariableCollections=k,e.deserializeEnvironmentVariableCollections=A;function S(m){return[...m.entries()]}function T(m){return m?[...m.entries()]:[]}function D(m){return new Map(m)}function O(m){return new Map(m??[])}function k(m){return Array.from(m.entries()).map(s=>[s[0],S(s[1].map),T(s[1].descriptionMap)])}function A(m){return new Map(m.map(s=>[s[0],{map:D(s[1]),descriptionMap:O(s[2])}]))}}),define(ke[181],Re([1,0,3,31,29]),function(Ee,e,S,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ITerminalLogService=e.ILocalPtyService=e.TerminalExtensions=e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.IPtyService=e.ProcessPropertyType=e.TerminalIpcChannels=e.TitleEventSource=e.GeneralShellType=e.WindowsShellType=e.PosixShellType=e.TerminalSettingId=e.TerminalSettingPrefix=e.terminalTabFocusModeContextKey=void 0,e.terminalTabFocusModeContextKey=new T.RawContextKey("terminalTabFocusMode",!1,!0);var O;(function(o){o.AutomationProfile="terminal.integrated.automationProfile.",o.DefaultProfile="terminal.integrated.defaultProfile.",o.Profiles="terminal.integrated.profiles."})(O||(e.TerminalSettingPrefix=O={}));var k;(function(o){o.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",o.AutomationProfileLinux="terminal.integrated.automationProfile.linux",o.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",o.AutomationProfileWindows="terminal.integrated.automationProfile.windows",o.ProfilesWindows="terminal.integrated.profiles.windows",o.ProfilesMacOs="terminal.integrated.profiles.osx",o.ProfilesLinux="terminal.integrated.profiles.linux",o.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",o.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",o.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",o.UseWslProfiles="terminal.integrated.useWslProfiles",o.TabsDefaultColor="terminal.integrated.tabs.defaultColor",o.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",o.TabsEnabled="terminal.integrated.tabs.enabled",o.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",o.TabsHideCondition="terminal.integrated.tabs.hideCondition",o.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",o.TabsShowActions="terminal.integrated.tabs.showActions",o.TabsLocation="terminal.integrated.tabs.location",o.TabsFocusMode="terminal.integrated.tabs.focusMode",o.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",o.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",o.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",o.CopyOnSelection="terminal.integrated.copyOnSelection",o.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",o.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",o.FontFamily="terminal.integrated.fontFamily",o.FontSize="terminal.integrated.fontSize",o.LetterSpacing="terminal.integrated.letterSpacing",o.LineHeight="terminal.integrated.lineHeight",o.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",o.TabStopWidth="terminal.integrated.tabStopWidth",o.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",o.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",o.BellDuration="terminal.integrated.bellDuration",o.FontWeight="terminal.integrated.fontWeight",o.FontWeightBold="terminal.integrated.fontWeightBold",o.CursorBlinking="terminal.integrated.cursorBlinking",o.CursorStyle="terminal.integrated.cursorStyle",o.CursorStyleInactive="terminal.integrated.cursorStyleInactive",o.CursorWidth="terminal.integrated.cursorWidth",o.Scrollback="terminal.integrated.scrollback",o.DetectLocale="terminal.integrated.detectLocale",o.DefaultLocation="terminal.integrated.defaultLocation",o.GpuAcceleration="terminal.integrated.gpuAcceleration",o.TerminalTitleSeparator="terminal.integrated.tabs.separator",o.TerminalTitle="terminal.integrated.tabs.title",o.TerminalDescription="terminal.integrated.tabs.description",o.RightClickBehavior="terminal.integrated.rightClickBehavior",o.MiddleClickBehavior="terminal.integrated.middleClickBehavior",o.Cwd="terminal.integrated.cwd",o.ConfirmOnExit="terminal.integrated.confirmOnExit",o.ConfirmOnKill="terminal.integrated.confirmOnKill",o.EnableBell="terminal.integrated.enableBell",o.EnableVisualBell="terminal.integrated.enableVisualBell",o.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",o.AllowChords="terminal.integrated.allowChords",o.AllowMnemonics="terminal.integrated.allowMnemonics",o.TabFocusMode="terminal.integrated.tabFocusMode",o.EnvMacOs="terminal.integrated.env.osx",o.EnvLinux="terminal.integrated.env.linux",o.EnvWindows="terminal.integrated.env.windows",o.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",o.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",o.ExperimentalWindowsUseConptyDll="terminal.integrated.experimental.windowsUseConptyDll",o.ShowExitAlert="terminal.integrated.showExitAlert",o.SplitCwd="terminal.integrated.splitCwd",o.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",o.WordSeparators="terminal.integrated.wordSeparators",o.EnableFileLinks="terminal.integrated.enableFileLinks",o.AllowedLinkSchemes="terminal.integrated.allowedLinkSchemes",o.UnicodeVersion="terminal.integrated.unicodeVersion",o.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",o.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",o.HideOnStartup="terminal.integrated.hideOnStartup",o.CustomGlyphs="terminal.integrated.customGlyphs",o.RescaleOverlappingGlyphs="terminal.integrated.rescaleOverlappingGlyphs",o.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",o.InheritEnv="terminal.integrated.inheritEnv",o.ShowLinkHover="terminal.integrated.showLinkHover",o.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",o.AutoReplies="terminal.integrated.autoReplies",o.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",o.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",o.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",o.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",o.EnableImages="terminal.integrated.enableImages",o.SmoothScrolling="terminal.integrated.smoothScrolling",o.IgnoreBracketedPasteMode="terminal.integrated.ignoreBracketedPasteMode",o.FocusAfterRun="terminal.integrated.focusAfterRun",o.DeveloperPtyHostLatency="terminal.integrated.developer.ptyHost.latency",o.DeveloperPtyHostStartupDelay="terminal.integrated.developer.ptyHost.startupDelay",o.DevMode="terminal.integrated.developer.devMode"})(k||(e.TerminalSettingId=k={}));var A;(function(o){o.Bash="bash",o.Fish="fish",o.Sh="sh",o.Csh="csh",o.Ksh="ksh",o.Zsh="zsh"})(A||(e.PosixShellType=A={}));var m;(function(o){o.CommandPrompt="cmd",o.Wsl="wsl",o.GitBash="gitbash"})(m||(e.WindowsShellType=m={}));var s;(function(o){o.PowerShell="pwsh",o.Python="python",o.Julia="julia",o.NuShell="nu"})(s||(e.GeneralShellType=s={}));var I;(function(o){o[o.Api=0]="Api",o[o.Process=1]="Process",o[o.Sequence=2]="Sequence",o[o.Config=3]="Config"})(I||(e.TitleEventSource=I={}));var E;(function(o){o.LocalPty="localPty",o.PtyHost="ptyHost",o.PtyHostWindow="ptyHostWindow",o.Logger="logger",o.Heartbeat="heartbeat"})(E||(e.TerminalIpcChannels=E={}));var u;(function(o){o.Cwd="cwd",o.InitialCwd="initialCwd",o.FixedDimensions="fixedDimensions",o.Title="title",o.ShellType="shellType",o.HasChildProcesses="hasChildProcesses",o.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",o.OverrideDimensions="overrideDimensions",o.FailedShellIntegrationActivation="failedShellIntegrationActivation",o.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(u||(e.ProcessPropertyType=u={})),e.IPtyService=(0,S.createDecorator)("ptyService");var C;(function(o){o[o.BeatInterval=5e3]="BeatInterval",o[o.ConnectingBeatInterval=2e4]="ConnectingBeatInterval",o[o.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",o[o.SecondWaitMultiplier=1]="SecondWaitMultiplier",o[o.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(C||(e.HeartbeatConstants=C={}));var v;(function(o){o[o.Panel=1]="Panel",o[o.Editor=2]="Editor"})(v||(e.TerminalLocation=v={}));var r;(function(o){o.TerminalView="view",o.Editor="editor"})(r||(e.TerminalLocationString=r={}));var a;(function(o){o[o.GraceTime=6e4]="GraceTime",o[o.ShortGraceTime=6e3]="ShortGraceTime"})(a||(e.LocalReconnectConstants=a={}));var d;(function(o){o[o.HighWatermarkChars=1e5]="HighWatermarkChars",o[o.LowWatermarkChars=5e3]="LowWatermarkChars",o[o.CharCountAckSize=5e3]="CharCountAckSize"})(d||(e.FlowControlConstants=d={}));var l;(function(o){o.GitBash="Git Bash",o.Pwsh="PowerShell"})(l||(e.ProfileSource=l={}));var i;(function(o){o[o.Off=0]="Off",o[o.FinalTerm=1]="FinalTerm",o[o.VSCode=2]="VSCode"})(i||(e.ShellIntegrationStatus=i={}));var n;(function(o){o[o.Unknown=0]="Unknown",o[o.Shutdown=1]="Shutdown",o[o.Process=2]="Process",o[o.User=3]="User",o[o.Extension=4]="Extension"})(n||(e.TerminalExitReason=n={})),e.TerminalExtensions={Backend:"workbench.contributions.terminal.processBackend"};class t{constructor(){this._backends=new Map}get backends(){return this._backends}registerTerminalBackend(c){const g=this._sanitizeRemoteAuthority(c.remoteAuthority);if(this._backends.has(g))throw new Error(`A terminal backend with remote authority '${g}' was already registered.`);this._backends.set(g,c)}getTerminalBackend(c){return this._backends.get(this._sanitizeRemoteAuthority(c))}_sanitizeRemoteAuthority(c){return c?.toLowerCase()??""}}D.Registry.add(e.TerminalExtensions.Backend,new t),e.ILocalPtyService=(0,S.createDecorator)("localPtyService"),e.ITerminalLogService=(0,S.createDecorator)("terminalLogService")}),define(ke[182],Re([1,0]),function(Ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class S{constructor(D){this._callback=D,this._terminalBufferMap=new Map}dispose(){for(const D of this._terminalBufferMap.values())D.dispose()}startBuffering(D,O,k=5){const A=O(m=>{const s=typeof m=="string"?m:m.data;let I=this._terminalBufferMap.get(D);if(I){I.data.push(s);return}const E=setTimeout(()=>this.flushBuffer(D),k);I={data:[s],timeoutId:E,dispose:()=>{clearTimeout(E),this.flushBuffer(D),A.dispose()}},this._terminalBufferMap.set(D,I)});return A}stopBuffering(D){this._terminalBufferMap.get(D)?.dispose()}flushBuffer(D){const O=this._terminalBufferMap.get(D);O&&(this._terminalBufferMap.delete(D),this._callback(D,O.data.join("")))}}e.TerminalDataBufferer=S}),define(ke[183],Re([1,0,10,98,282,36,6,14,2,9,78,29]),function(Ee,e,S,T,D,O,k,A,m,s,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.spinningLoading=e.syncing=e.gotoNextLocation=e.gotoPreviousLocation=e.widgetClose=e.iconsSchemaId=e.IconFontDefinition=e.IconContribution=e.Extensions=void 0,e.registerIcon=a,e.getIconRegistry=d,E=Ve(E),e.Extensions={IconContribution:"base.contributions.icons"};var u;(function(t){function o(c,g){let f=c.defaults;for(;O.ThemeIcon.isThemeIcon(f);){const h=r.getIcon(f.id);if(!h)return;f=h.defaults}return f}t.getDefinition=o})(u||(e.IconContribution=u={}));var C;(function(t){function o(g){return{weight:g.weight,style:g.style,src:g.src.map(f=>({format:f.format,location:f.location.toString()}))}}t.toJSONObject=o;function c(g){const f=h=>(0,A.isString)(h)?h:void 0;if(g&&Array.isArray(g.src)&&g.src.every(h=>(0,A.isString)(h.format)&&(0,A.isString)(h.location)))return{weight:f(g.weight),style:f(g.style),src:g.src.map(h=>({format:h.format,location:m.URI.parse(h.location)}))}}t.fromJSONObject=c})(C||(e.IconFontDefinition=C={}));class v{constructor(){this._onDidChange=new k.Emitter,this.onDidChange=this._onDidChange.event,this.iconSchema={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,s.localize)(2364,null)},fontCharacter:{type:"string",description:(0,s.localize)(2365,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.iconReferenceSchema={type:"string",pattern:`^${O.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.iconsById={},this.iconFontsById={}}registerIcon(o,c,g,f){const h=this.iconsById[o];if(h){if(g&&!h.description){h.description=g,this.iconSchema.properties[o].markdownDescription=`${g} $(${o})`;const w=this.iconReferenceSchema.enum.indexOf(o);w!==-1&&(this.iconReferenceSchema.enumDescriptions[w]=g),this._onDidChange.fire()}return h}const _={id:o,description:g,defaults:c,deprecationMessage:f};this.iconsById[o]=_;const y={$ref:"#/definitions/icons"};return f&&(y.deprecationMessage=f),g&&(y.markdownDescription=`${g}: $(${o})`),this.iconSchema.properties[o]=y,this.iconReferenceSchema.enum.push(o),this.iconReferenceSchema.enumDescriptions.push(g||""),this._onDidChange.fire(),{id:o}}deregisterIcon(o){delete this.iconsById[o],delete this.iconSchema.properties[o];const c=this.iconReferenceSchema.enum.indexOf(o);c!==-1&&(this.iconReferenceSchema.enum.splice(c,1),this.iconReferenceSchema.enumDescriptions.splice(c,1)),this._onDidChange.fire()}getIcons(){return Object.keys(this.iconsById).map(o=>this.iconsById[o])}getIcon(o){return this.iconsById[o]}getIconSchema(){return this.iconSchema}getIconReferenceSchema(){return this.iconReferenceSchema}registerIconFont(o,c){const g=this.iconFontsById[o];return g||(this.iconFontsById[o]=c,this._onDidChange.fire(),c)}deregisterIconFont(o){delete this.iconFontsById[o]}getIconFont(o){return this.iconFontsById[o]}toString(){const o=(h,_)=>h.id.localeCompare(_.id),c=h=>{for(;O.ThemeIcon.isThemeIcon(h.defaults);)h=this.iconsById[h.defaults.id];return`codicon codicon-${h?h.id:""}`},g=[];g.push("| preview     | identifier                        | default codicon ID                | description"),g.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const f=Object.keys(this.iconsById).map(h=>this.iconsById[h]);for(const h of f.filter(_=>!!_.description).sort(o))g.push(`|<i class="${c(h)}"></i>|${h.id}|${O.ThemeIcon.isThemeIcon(h.defaults)?h.defaults.id:h.id}|${h.description||""}|`);g.push("| preview     | identifier                        "),g.push("| ----------- | --------------------------------- |");for(const h of f.filter(_=>!O.ThemeIcon.isThemeIcon(_.defaults)).sort(o))g.push(`|<i class="${c(h)}"></i>|${h.id}|`);return g.join(`
`)}}const r=new v;E.Registry.add(e.Extensions.IconContribution,r);function a(t,o,c,g){return r.registerIcon(t,o,c,g)}function d(){return r}function l(){const t=(0,D.getCodiconFontCharacters)();for(const o in t){const c="\\"+t[o].toString(16);r.registerIcon(o,{fontCharacter:c})}}l(),e.iconsSchemaId="vscode://schemas/icons";const i=E.Registry.as(I.Extensions.JSONContribution);i.registerSchema(e.iconsSchemaId,r.getIconSchema());const n=new S.RunOnceScheduler(()=>i.notifySchemaChanged(e.iconsSchemaId),200);r.onDidChange(()=>{n.isScheduled()||n.schedule()}),e.widgetClose=a("widget-close",T.Codicon.close,(0,s.localize)(2366,null)),e.gotoPreviousLocation=a("goto-previous-location",T.Codicon.arrowUp,(0,s.localize)(2367,null)),e.gotoNextLocation=a("goto-next-location",T.Codicon.arrowDown,(0,s.localize)(2368,null)),e.syncing=O.ThemeIcon.modify(T.Codicon.sync,"spin"),e.spinningLoading=O.ThemeIcon.modify(T.Codicon.loading,"spin")}),define(ke[184],Re([1,0,6,4,23,2,44,3,11]),function(Ee,e,S,T,D,O,k,A,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.ALL_INTERFACES_ADDRESSES=e.LOCALHOST_ADDRESSES=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.isTunnelProvider=E,e.extractLocalHostUriMetaDataForPortMapping=C,e.extractQueryLocalHostUriMetaDataForPortMapping=v,e.isLocalhost=r,e.isAllInterfaces=a,e.isPortPrivileged=d,e.ITunnelService=(0,A.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,A.createDecorator)("sharedTunnelsService");var s;(function(n){n.Http="http",n.Https="https"})(s||(e.TunnelProtocol=s={}));var I;(function(n){n.ConstantPrivate="constantPrivate",n.Private="private",n.Public="public"})(I||(e.TunnelPrivacyId=I={}));function E(n){return!!n.forwardPort}var u;(function(n){n[n.Notify=1]="Notify",n[n.OpenBrowser=2]="OpenBrowser",n[n.OpenPreview=3]="OpenPreview",n[n.Silent=4]="Silent",n[n.Ignore=5]="Ignore",n[n.OpenBrowserOnce=6]="OpenBrowserOnce"})(u||(e.ProvidedOnAutoForward=u={}));function C(n){if(n.scheme!=="http"&&n.scheme!=="https")return;const t=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(n.authority);if(t)return{address:t[1],port:+t[2]}}function v(n){if(n.scheme!=="http"&&n.scheme!=="https"||!n.query)return;const t=n.query.split("&");for(const o of t){const c=o.split("=")[1];if(/^https?:/.exec(c)){const g=C(O.URI.parse(c));if(g)return g}}}e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function r(n){return e.LOCALHOST_ADDRESSES.indexOf(n)>=0}e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function a(n){return e.ALL_INTERFACES_ADDRESSES.indexOf(n)>=0}function d(n,t,o,c){if(o===D.OperatingSystem.Windows)return!1;if(o===D.OperatingSystem.Macintosh&&a(t)){const g=/(\d+)\.(\d+)\.(\d+)/g.exec(c);if(g?.length===4&&parseInt(g[1])>=18)return!1}return n<1024}class l{constructor(t,o,c){this.remoteAddress=t,this.localAddress=o,this._dispose=c,this._onDispose=new S.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}e.DisposableTunnel=l;let i=class extends T.Disposable{constructor(t,o){super(),this.logService=t,this.configurationService=o,this._onTunnelOpened=new S.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new S.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new S.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._canChangeProtocol=!0,this._privacyOptions=[],this._factoryInProgress=new Set}get hasTunnelProvider(){return!!this._tunnelProvider}get defaultTunnelHost(){const t=this.configurationService.getValue("remote.localPortHost");return!t||t==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(t){return this._tunnelProvider=t,t?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(t){this._canElevate=t.elevation,this._privacyOptions=t.privacyOptions,this._canChangeProtocol=t.protocol}get canChangeProtocol(){return this._canChangeProtocol}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const t=[],o=Array.from(this._tunnels.values());for(const c of o){const g=Array.from(c.values());for(const f of g){const h=await f.value;h&&typeof h!="string"&&t.push(h)}}return t}async dispose(){super.dispose();for(const t of this._tunnels.values()){for(const{value:o}of t.values())await o.then(c=>typeof c!="string"?c?.dispose():void 0);t.clear()}this._tunnels.clear()}setEnvironmentTunnel(t,o,c,g,f){this.addTunnelToMap(t,o,Promise.resolve({tunnelRemoteHost:t,tunnelRemotePort:o,localAddress:c,privacy:g,protocol:f,dispose:()=>Promise.resolve()}))}async getExistingTunnel(t,o){(a(t)||r(t))&&(t=e.LOCALHOST_ADDRESSES[0]);const c=this.getTunnelFromMap(t,o);if(c)return++c.refcount,c.value}openTunnel(t,o,c,g,f,h=!1,_,y){this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${o}:${c} on local port ${f}.`);const w=this._tunnelProvider??t;if(!w)return;if(o||(o="localhost"),g||(g=this.defaultTunnelHost),this._tunnelProvider&&this._factoryInProgress.has(c)){this.logService.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const P=this.retainOrCreateTunnel(w,o,c,g,f,h,_,y);return P?P.then(R=>{if(R){if(typeof R=="string")return this.logService.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.removeEmptyOrErrorTunnelFromMap(o,c),R}else{this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyOrErrorTunnelFromMap(o,c);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const p=this.makeTunnel(R);return(R.tunnelRemoteHost!==o||R.tunnelRemotePort!==c)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),_&&R.privacy!==_&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this._onTunnelOpened.fire(p),p}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),P)}makeTunnel(t){return{tunnelRemotePort:t.tunnelRemotePort,tunnelRemoteHost:t.tunnelRemoteHost,tunnelLocalPort:t.tunnelLocalPort,localAddress:t.localAddress,privacy:t.privacy,protocol:t.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${t.tunnelRemoteHost}:${t.tunnelRemotePort} `);const o=this._tunnels.get(t.tunnelRemoteHost);if(o){const c=o.get(t.tunnelRemotePort);c&&(c.refcount--,await this.tryDisposeTunnel(t.tunnelRemoteHost,t.tunnelRemotePort,c))}}}}async tryDisposeTunnel(t,o,c){if(c.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${t}:${o}.`);const g=c.value.then(async f=>{f&&typeof f!="string"&&(await f.dispose(!0),this._onTunnelClosed.fire({host:f.tunnelRemoteHost,port:f.tunnelRemotePort}))});return this._tunnels.has(t)&&this._tunnels.get(t).delete(o),g}}async closeTunnel(t,o){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${t}:${o} `);const c=this._tunnels.get(t);if(c&&c.has(o)){const g=c.get(o);g.refcount=0,await this.tryDisposeTunnel(t,o,g)}}addTunnelToMap(t,o,c){this._tunnels.has(t)||this._tunnels.set(t,new Map),this._tunnels.get(t).set(o,{refcount:1,value:c})}async removeEmptyOrErrorTunnelFromMap(t,o){const c=this._tunnels.get(t);if(c){const g=c.get(o),f=g?await g.value:void 0;(!f||typeof f=="string")&&c.delete(o),c.size===0&&this._tunnels.delete(t)}}getTunnelFromMap(t,o){const c=[t];r(t)?(c.push(...e.LOCALHOST_ADDRESSES),c.push(...e.ALL_INTERFACES_ADDRESSES)):a(t)&&c.push(...e.ALL_INTERFACES_ADDRESSES);const g=c.map(f=>this._tunnels.get(f));for(const f of g){const h=f?.get(o);if(h)return h}}canTunnel(t){return!!C(t)}createWithProvider(t,o,c,g,f,h,_){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${o}:${c} on local port ${g}.`);const y=c;this._factoryInProgress.add(y);const w=g===void 0?c:g,P={elevationRequired:f?this.isPortPrivileged(w):!1},R={remoteAddress:{host:o,port:c},localAddressPort:g,privacy:h,public:h?h!==I.Private:void 0,protocol:_},p=t.forwardPort(R,P);return p?(this.addTunnelToMap(o,c,p),p.finally(()=>{this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this._factoryInProgress.delete(y)})):this._factoryInProgress.delete(y),p}};e.AbstractTunnelService=i,e.AbstractTunnelService=i=qe([We(0,m.ILogService),We(1,k.IConfigurationService)],i)}),define(ke[114],Re([1,0,3]),function(Ee,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,S.createDecorator)("IUriIdentityService")}),define(ke[185],Re([1,0,3]),function(Ee,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.IEditSessionIdentityService=void 0,e.IEditSessionIdentityService=(0,S.createDecorator)("editSessionIdentityService");var T;(function(D){D[D.Complete=100]="Complete",D[D.Partial=50]="Partial",D[D.None=0]="None"})(T||(e.EditSessionIdentityMatch=T={}))}),define(ke[186],Re([1,0,15]),function(Ee,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualResource=T,e.getVirtualWorkspaceLocation=D,e.getVirtualWorkspaceScheme=O,e.getVirtualWorkspaceAuthority=k,e.isVirtualWorkspace=A;function T(m){return m.scheme!==S.Schemas.file&&m.scheme!==S.Schemas.vscodeRemote}function D(m){if(m.folders.length)return m.folders.every(s=>T(s.uri))?m.folders[0].uri:void 0;if(m.configuration&&T(m.configuration))return m.configuration}function O(m){return D(m)?.scheme}function k(m){return D(m)?.authority}function A(m){return D(m)!==void 0}}),define(ke[49],Re([1,0,9,22,48,24,2,3,15]),function(Ee,e,S,T,D,O,k,A,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.STANDALONE_EDITOR_WORKSPACE_ID=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.WorkspaceFolder=e.Workspace=e.WorkbenchState=e.UNKNOWN_EMPTY_WINDOW_WORKSPACE=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.IWorkspaceContextService=void 0,e.isSingleFolderWorkspaceIdentifier=s,e.isEmptyWorkspaceIdentifier=I,e.toWorkspaceIdentifier=E,e.isWorkspaceIdentifier=u,e.reviveIdentifier=C,e.isWorkspace=r,e.isWorkspaceFolder=a,e.toWorkspaceFolder=i,e.isUntitledWorkspace=n,e.isTemporaryWorkspace=t,e.isStandaloneEditorWorkspace=o,e.isSavedWorkspace=c,e.hasWorkspaceFileExtension=g,e.IWorkspaceContextService=(0,A.createDecorator)("contextService");function s(f){const h=f;return typeof h?.id=="string"&&k.URI.isUri(h.uri)}function I(f){return typeof f?.id=="string"&&!s(f)&&!u(f)}e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"},e.UNKNOWN_EMPTY_WINDOW_WORKSPACE={id:"empty-window"};function E(f,h){if(typeof f=="string"||typeof f>"u")return typeof f=="string"?{id:(0,T.basename)(f)}:h?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:e.UNKNOWN_EMPTY_WINDOW_WORKSPACE;const _=f;return _.configuration?{id:_.id,configPath:_.configuration}:_.folders.length===1?{id:_.id,uri:_.folders[0].uri}:{id:_.id}}function u(f){const h=f;return typeof h?.id=="string"&&k.URI.isUri(h.configPath)}function C(f){const h=f;if(h?.uri)return{id:h.id,uri:k.URI.revive(h.uri)};const _=f;if(_?.configPath)return{id:_.id,configPath:k.URI.revive(_.configPath)};if(f?.id)return{id:f.id}}var v;(function(f){f[f.EMPTY=1]="EMPTY",f[f.FOLDER=2]="FOLDER",f[f.WORKSPACE=3]="WORKSPACE"})(v||(e.WorkbenchState=v={}));function r(f){const h=f;return!!(h&&typeof h=="object"&&typeof h.id=="string"&&Array.isArray(h.folders))}function a(f){const h=f;return!!(h&&typeof h=="object"&&k.URI.isUri(h.uri)&&typeof h.name=="string"&&typeof h.toResource=="function")}class d{constructor(h,_,y,w,P){this._id=h,this._transient=y,this._configuration=w,this._ignorePathCasing=P,this._foldersMap=D.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0),this.folders=_}update(h){this._id=h.id,this._configuration=h.configuration,this._transient=h.transient,this._ignorePathCasing=h._ignorePathCasing,this.folders=h.folders}get folders(){return this._folders}set folders(h){this._folders=h,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(h){this._configuration=h}getFolder(h){return h&&this._foldersMap.findSubstr(h)||null}updateFoldersMap(){this._foldersMap=D.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0);for(const h of this.folders)this._foldersMap.set(h.uri,h)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=d;class l{constructor(h,_){this.raw=_,this.uri=h.uri,this.index=h.index,this.name=h.name}toResource(h){return(0,O.joinPath)(this.uri,h)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=l;function i(f){return new l({uri:f,index:0,name:(0,O.basenameOrAuthority)(f)},{uri:f.toString()})}e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,S.localize)(2489,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function n(f,h){return O.extUriBiasedIgnorePathCase.isEqualOrParent(f,h.untitledWorkspacesHome)}function t(f){let h;return k.URI.isUri(f)?h=f:h=f.configuration,h?.scheme===m.Schemas.tmp}e.STANDALONE_EDITOR_WORKSPACE_ID="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function o(f){return f.id===e.STANDALONE_EDITOR_WORKSPACE_ID}function c(f,h){return!n(f,h)&&!t(f)}function g(f){return(typeof f=="string"?(0,T.extname)(f):(0,O.extname)(f))===e.WORKSPACE_SUFFIX}}),define(ke[115],Re([1,0,76,6,4,24,2,9,107,28,3,11,49,27,114,10,33,13,14]),function(Ee,e,S,T,D,O,k,A,m,s,I,E,u,C,v,r,a,d,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryUserDataProfilesService=e.UserDataProfilesService=e.IUserDataProfilesService=e.ProfileResourceType=void 0,e.isUserDataProfile=n,e.reviveProfile=t,e.toUserDataProfile=o;var i;(function(f){f.Settings="settings",f.Keybindings="keybindings",f.Snippets="snippets",f.Tasks="tasks",f.Extensions="extensions",f.GlobalState="globalState"})(i||(e.ProfileResourceType=i={}));function n(f){const h=f;return!!(h&&typeof h=="object"&&typeof h.id=="string"&&typeof h.isDefault=="boolean"&&typeof h.name=="string"&&k.URI.isUri(h.location)&&k.URI.isUri(h.globalStorageHome)&&k.URI.isUri(h.settingsResource)&&k.URI.isUri(h.keybindingsResource)&&k.URI.isUri(h.tasksResource)&&k.URI.isUri(h.snippetsHome)&&k.URI.isUri(h.extensionsResource))}e.IUserDataProfilesService=(0,I.createDecorator)("IUserDataProfilesService");function t(f,h){return{id:f.id,isDefault:f.isDefault,name:f.name,shortName:f.shortName,icon:f.icon,location:k.URI.revive(f.location).with({scheme:h}),globalStorageHome:k.URI.revive(f.globalStorageHome).with({scheme:h}),settingsResource:k.URI.revive(f.settingsResource).with({scheme:h}),keybindingsResource:k.URI.revive(f.keybindingsResource).with({scheme:h}),tasksResource:k.URI.revive(f.tasksResource).with({scheme:h}),snippetsHome:k.URI.revive(f.snippetsHome).with({scheme:h}),extensionsResource:k.URI.revive(f.extensionsResource).with({scheme:h}),cacheHome:k.URI.revive(f.cacheHome).with({scheme:h}),useDefaultFlags:f.useDefaultFlags,isTransient:f.isTransient}}function o(f,h,_,y,w,P){return{id:f,name:h,location:_,isDefault:!1,shortName:w?.shortName,icon:w?.icon,globalStorageHome:P&&w?.useDefaultFlags?.globalState?P.globalStorageHome:(0,O.joinPath)(_,"globalStorage"),settingsResource:P&&w?.useDefaultFlags?.settings?P.settingsResource:(0,O.joinPath)(_,"settings.json"),keybindingsResource:P&&w?.useDefaultFlags?.keybindings?P.keybindingsResource:(0,O.joinPath)(_,"keybindings.json"),tasksResource:P&&w?.useDefaultFlags?.tasks?P.tasksResource:(0,O.joinPath)(_,"tasks.json"),snippetsHome:P&&w?.useDefaultFlags?.snippets?P.snippetsHome:(0,O.joinPath)(_,"snippets"),extensionsResource:P&&w?.useDefaultFlags?.extensions?P.extensionsResource:(0,O.joinPath)(_,"extensions.json"),cacheHome:(0,O.joinPath)(y,f),useDefaultFlags:w?.useDefaultFlags,isTransient:w?.transient}}let c=class extends D.Disposable{static{this.PROFILES_KEY="userDataProfiles"}static{this.PROFILE_ASSOCIATIONS_KEY="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.profilesObject.profiles,...this.transientProfilesObject.profiles]}constructor(h,_,y,w){super(),this.environmentService=h,this.fileService=_,this.uriIdentityService=y,this.logService=w,this.enabled=!0,this._onDidChangeProfiles=this._register(new T.Emitter),this.onDidChangeProfiles=this._onDidChangeProfiles.event,this._onWillCreateProfile=this._register(new T.Emitter),this.onWillCreateProfile=this._onWillCreateProfile.event,this._onWillRemoveProfile=this._register(new T.Emitter),this.onWillRemoveProfile=this._onWillRemoveProfile.event,this._onDidResetWorkspaces=this._register(new T.Emitter),this.onDidResetWorkspaces=this._onDidResetWorkspaces.event,this.profileCreationPromises=new Map,this.transientProfilesObject={profiles:[],folders:new C.ResourceMap,workspaces:new C.ResourceMap,emptyWindows:new Map},this.profilesHome=(0,O.joinPath)(this.environmentService.userRoamingDataHome,"profiles"),this.profilesCacheHome=(0,O.joinPath)(this.environmentService.cacheHome,"CachedProfilesData")}init(){this._profilesObject=void 0}setEnablement(h){this.enabled!==h&&(this._profilesObject=void 0,this.enabled=h)}isEnabled(){return this.enabled}get profilesObject(){if(!this._profilesObject){const h=this.createDefaultProfile(),_=[h];if(this.enabled)try{for(const P of this.getStoredProfiles()){if(!P.name||!(0,l.isString)(P.name)||!P.location){this.logService.warn("Skipping the invalid stored profile",P.location||P.name);continue}_.push(o((0,O.basename)(P.location),P.name,P.location,this.profilesCacheHome,{shortName:P.shortName,icon:P.icon,useDefaultFlags:P.useDefaultFlags},h))}}catch(P){this.logService.error(P)}const y=new C.ResourceMap,w=new Map;if(_.length)try{const P=this.getStoredProfileAssociations();if(P.workspaces)for(const[R,p]of Object.entries(P.workspaces)){const b=k.URI.parse(R),N=_.find(L=>L.id===p);N&&y.set(b,N)}if(P.emptyWindows)for(const[R,p]of Object.entries(P.emptyWindows)){const b=_.find(N=>N.id===p);b&&w.set(R,b)}}catch(P){this.logService.error(P)}this._profilesObject={profiles:_,workspaces:y,emptyWindows:w}}return this._profilesObject}createDefaultProfile(){const h=o("__default__profile__",(0,A.localize)(2442,null),this.environmentService.userRoamingDataHome,this.profilesCacheHome);return{...h,extensionsResource:this.getDefaultProfileExtensionsLocation()??h.extensionsResource,isDefault:!0}}async createTransientProfile(h){const _="Temp",y=new RegExp(`${(0,d.escapeRegExpCharacters)(_)}\\s(\\d+)`);let w=0;for(const R of this.profiles){const p=y.exec(R.name),b=p?parseInt(p[1]):0;w=b>w?b:w}const P=`${_} ${w+1}`;return this.createProfile((0,S.hash)((0,a.generateUuid)()).toString(16),P,{transient:!0},h)}async createNamedProfile(h,_,y){return this.createProfile((0,S.hash)((0,a.generateUuid)()).toString(16),h,_,y)}async createProfile(h,_,y,w){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");const P=await this.doCreateProfile(h,_,y);return w&&await this.setProfileForWorkspace(w,P),P}async doCreateProfile(h,_,y){if(!(0,l.isString)(_)||!_)throw new Error("Name of the profile is mandatory and must be of type `string`");let w=this.profileCreationPromises.get(_);return w||(w=(async()=>{try{if(this.profiles.find(b=>b.name===_||b.id===h))throw new Error(`Profile with ${_} name already exists`);const R=o(h,_,(0,O.joinPath)(this.profilesHome,h),this.profilesCacheHome,y,this.defaultProfile);await this.fileService.createFolder(R.location);const p=[];return this._onWillCreateProfile.fire({profile:R,join(b){p.push(b)}}),await r.Promises.settled(p),this.updateProfiles([R],[],[]),R}finally{this.profileCreationPromises.delete(_)}})(),this.profileCreationPromises.set(_,w)),w}async updateProfile(h,_){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");let y=this.profiles.find(w=>w.id===h.id);if(!y)throw new Error(`Profile '${h.name}' does not exist`);return y=o(y.id,_.name??y.name,y.location,this.profilesCacheHome,{shortName:_.shortName??y.shortName,icon:_.icon===null?void 0:_.icon??y.icon,transient:_.transient??y.isTransient,useDefaultFlags:_.useDefaultFlags??y.useDefaultFlags},this.defaultProfile),this.updateProfiles([],[],[y]),y}async removeProfile(h){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");if(h.isDefault)throw new Error("Cannot remove default profile");const _=this.profiles.find(w=>w.id===h.id);if(!_)throw new Error(`Profile '${h.name}' does not exist`);const y=[];this._onWillRemoveProfile.fire({profile:_,join(w){y.push(w)}});try{await Promise.allSettled(y)}catch(w){this.logService.error(w)}for(const w of[...this.profilesObject.emptyWindows.keys()])_.id===this.profilesObject.emptyWindows.get(w)?.id&&this.profilesObject.emptyWindows.delete(w);for(const w of[...this.profilesObject.workspaces.keys()])_.id===this.profilesObject.workspaces.get(w)?.id&&this.profilesObject.workspaces.delete(w);this.updateStoredProfileAssociations(),this.updateProfiles([],[_],[]);try{await this.fileService.del(_.cacheHome,{recursive:!0})}catch(w){(0,s.toFileOperationResult)(w)!==s.FileOperationResult.FILE_NOT_FOUND&&this.logService.error(w)}}async setProfileForWorkspace(h,_){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");const y=this.profiles.find(w=>w.id===_.id);if(!y)throw new Error(`Profile '${_.name}' does not exist`);this.updateWorkspaceAssociation(h,y)}unsetWorkspace(h,_){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");this.updateWorkspaceAssociation(h,void 0,_)}async resetWorkspaces(){this.transientProfilesObject.folders.clear(),this.transientProfilesObject.workspaces.clear(),this.transientProfilesObject.emptyWindows.clear(),this.profilesObject.workspaces.clear(),this.profilesObject.emptyWindows.clear(),this.updateStoredProfileAssociations(),this._onDidResetWorkspaces.fire()}async cleanUp(){if(this.enabled&&await this.fileService.exists(this.profilesHome)){const h=await this.fileService.resolve(this.profilesHome);await Promise.all((h.children||[]).filter(_=>_.isDirectory&&this.profiles.every(y=>!this.uriIdentityService.extUri.isEqual(y.location,_.resource))).map(_=>this.fileService.del(_.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.enabled)return;const h=this.transientProfilesObject.profiles.filter(_=>!this.isProfileAssociatedToWorkspace(_));await Promise.allSettled(h.map(_=>this.removeProfile(_)))}getProfileForWorkspace(h){const _=this.getWorkspace(h),y=k.URI.isUri(_)?this.profilesObject.workspaces.get(_):this.profilesObject.emptyWindows.get(_);return y||((0,u.isSingleFolderWorkspaceIdentifier)(h)?this.transientProfilesObject.folders.get(h.uri):(0,u.isWorkspaceIdentifier)(h)?this.transientProfilesObject.workspaces.get(h.configPath):this.transientProfilesObject.emptyWindows.get(h.id))}getWorkspace(h){return(0,u.isSingleFolderWorkspaceIdentifier)(h)?h.uri:(0,u.isWorkspaceIdentifier)(h)?h.configPath:h.id}isProfileAssociatedToWorkspace(h){return!!([...this.profilesObject.emptyWindows.values()].some(_=>this.uriIdentityService.extUri.isEqual(_.location,h.location))||[...this.profilesObject.workspaces.values()].some(_=>this.uriIdentityService.extUri.isEqual(_.location,h.location))||[...this.transientProfilesObject.emptyWindows.values()].some(_=>this.uriIdentityService.extUri.isEqual(_.location,h.location))||[...this.transientProfilesObject.workspaces.values()].some(_=>this.uriIdentityService.extUri.isEqual(_.location,h.location))||[...this.transientProfilesObject.folders.values()].some(_=>this.uriIdentityService.extUri.isEqual(_.location,h.location)))}updateProfiles(h,_,y){const w=[...this.profiles,...h],P=[],R=this.transientProfilesObject.profiles;this.transientProfilesObject.profiles=[];for(let p of w){if(p.isDefault||_.some(N=>p.id===N.id))continue;p=y.find(N=>p.id===N.id)??p;const b=R.find(N=>p.id===N.id);if(p.isTransient)this.transientProfilesObject.profiles.push(p);else{if(b){for(const[N,L]of this.transientProfilesObject.emptyWindows.entries())if(p.id===L.id){this.updateWorkspaceAssociation({id:N},p);break}for(const[N,L]of this.transientProfilesObject.workspaces.entries())if(p.id===L.id){this.updateWorkspaceAssociation({id:"",configPath:N},p);break}for(const[N,L]of this.transientProfilesObject.folders.entries())if(p.id===L.id){this.updateWorkspaceAssociation({id:"",uri:N},p);break}}P.push({location:p.location,name:p.name,shortName:p.shortName,icon:p.icon,useDefaultFlags:p.useDefaultFlags})}}this.saveStoredProfiles(P),this._profilesObject=void 0,this.triggerProfilesChanges(h,_,y)}triggerProfilesChanges(h,_,y){this._onDidChangeProfiles.fire({added:h,removed:_,updated:y,all:this.profiles})}updateWorkspaceAssociation(h,_,y){if(y=_?.isTransient?!0:y,y)(0,u.isSingleFolderWorkspaceIdentifier)(h)?(this.transientProfilesObject.folders.delete(h.uri),_&&this.transientProfilesObject.folders.set(h.uri,_)):(0,u.isWorkspaceIdentifier)(h)?(this.transientProfilesObject.workspaces.delete(h.configPath),_&&this.transientProfilesObject.workspaces.set(h.configPath,_)):(this.transientProfilesObject.emptyWindows.delete(h.id),_&&this.transientProfilesObject.emptyWindows.set(h.id,_));else{this.updateWorkspaceAssociation(h,void 0,!0);const w=this.getWorkspace(h);k.URI.isUri(w)?(this.profilesObject.workspaces.delete(w),_&&this.profilesObject.workspaces.set(w,_)):(this.profilesObject.emptyWindows.delete(w),_&&this.profilesObject.emptyWindows.set(w,_)),this.updateStoredProfileAssociations()}}updateStoredProfileAssociations(){const h={};for(const[y,w]of this.profilesObject.workspaces.entries())h[y.toString()]=w.id;const _={};for(const[y,w]of this.profilesObject.emptyWindows.entries())_[y.toString()]=w.id;this.saveStoredProfileAssociations({workspaces:h,emptyWindows:_}),this._profilesObject=void 0}migrateStoredProfileAssociations(h){const _={},y=this.createDefaultProfile();if(h.workspaces)for(const[P,R]of Object.entries(h.workspaces)){const p=k.URI.parse(R);_[P]=this.uriIdentityService.extUri.isEqual(p,y.location)?y.id:this.uriIdentityService.extUri.basename(p)}const w={};if(h.emptyWindows)for(const[P,R]of Object.entries(h.emptyWindows)){const p=k.URI.parse(R);w[P]=this.uriIdentityService.extUri.isEqual(p,y.location)?y.id:this.uriIdentityService.extUri.basename(p)}return{workspaces:_,emptyWindows:w}}getStoredProfiles(){return[]}saveStoredProfiles(h){throw new Error("not implemented")}getStoredProfileAssociations(){return{}}saveStoredProfileAssociations(h){throw new Error("not implemented")}getDefaultProfileExtensionsLocation(){}};e.UserDataProfilesService=c,e.UserDataProfilesService=c=qe([We(0,m.IEnvironmentService),We(1,s.IFileService),We(2,v.IUriIdentityService),We(3,E.ILogService)],c);class g extends c{constructor(){super(...arguments),this.storedProfiles=[],this.storedProfileAssociations={}}getStoredProfiles(){return this.storedProfiles}saveStoredProfiles(h){this.storedProfiles=h}getStoredProfileAssociations(){return this.storedProfileAssociations}saveStoredProfileAssociations(h){this.storedProfileAssociations=h}}e.InMemoryUserDataProfilesService=g}),define(ke[187],Re([1,0,10,6,4,64,14,161,3,115]),function(Ee,e,S,T,D,O,k,A,m,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageService=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.TARGET_KEY=e.IS_NEW_KEY=void 0,e.loadKeyTargets=C,e.isProfileUsingDefaultStorage=r,e.logStorage=d,e.IS_NEW_KEY="__$__isNewStorageMarker",e.TARGET_KEY="__$__targetStorageMarker",e.IStorageService=(0,m.createDecorator)("storageService");var I;(function(l){l[l.NONE=0]="NONE",l[l.SHUTDOWN=1]="SHUTDOWN"})(I||(e.WillSaveStateReason=I={}));var E;(function(l){l[l.APPLICATION=-1]="APPLICATION",l[l.PROFILE=0]="PROFILE",l[l.WORKSPACE=1]="WORKSPACE"})(E||(e.StorageScope=E={}));var u;(function(l){l[l.USER=0]="USER",l[l.MACHINE=1]="MACHINE"})(u||(e.StorageTarget=u={}));function C(l){const i=l.get(e.TARGET_KEY);if(i)try{return JSON.parse(i)}catch{}return Object.create(null)}class v extends D.Disposable{static{this.DEFAULT_FLUSH_INTERVAL=60*1e3}constructor(i={flushInterval:v.DEFAULT_FLUSH_INTERVAL}){super(),this.options=i,this._onDidChangeValue=this._register(new T.PauseableEmitter),this._onDidChangeTarget=this._register(new T.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new T.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new S.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new D.MutableDisposable),this._workspaceKeyTargets=void 0,this._profileKeyTargets=void 0,this._applicationKeyTargets=void 0}onDidChangeValue(i,n,t){return T.Event.filter(this._onDidChangeValue.event,o=>o.scope===i&&(n===void 0||o.key===n),t)}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,S.runWhenGlobalIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,D.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,O.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,O.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(i,n){const{key:t,external:o}=n;if(t===e.TARGET_KEY){switch(i){case E.APPLICATION:this._applicationKeyTargets=void 0;break;case E.PROFILE:this._profileKeyTargets=void 0;break;case E.WORKSPACE:this._workspaceKeyTargets=void 0;break}this._onDidChangeTarget.fire({scope:i})}else this._onDidChangeValue.fire({scope:i,key:t,target:this.getKeyTargets(i)[t],external:o})}emitWillSaveState(i){this._onWillSaveState.fire({reason:i})}get(i,n,t){return this.getStorage(n)?.get(i,t)}getBoolean(i,n,t){return this.getStorage(n)?.getBoolean(i,t)}getNumber(i,n,t){return this.getStorage(n)?.getNumber(i,t)}getObject(i,n,t){return this.getStorage(n)?.getObject(i,t)}storeAll(i,n){this.withPausedEmitters(()=>{for(const t of i)this.store(t.key,t.value,t.scope,t.target,n)})}store(i,n,t,o,c=!1){if((0,k.isUndefinedOrNull)(n)){this.remove(i,t,c);return}this.withPausedEmitters(()=>{this.updateKeyTarget(i,t,o),this.getStorage(t)?.set(i,n,c)})}remove(i,n,t=!1){this.withPausedEmitters(()=>{this.updateKeyTarget(i,n,void 0),this.getStorage(n)?.delete(i,t)})}withPausedEmitters(i){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{i()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(i,n){const t=[],o=this.getKeyTargets(i);for(const c of Object.keys(o))o[c]===n&&t.push(c);return t}updateKeyTarget(i,n,t,o=!1){const c=this.getKeyTargets(n);typeof t=="number"?c[i]!==t&&(c[i]=t,this.getStorage(n)?.set(e.TARGET_KEY,JSON.stringify(c),o)):typeof c[i]=="number"&&(delete c[i],this.getStorage(n)?.set(e.TARGET_KEY,JSON.stringify(c),o))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(E.WORKSPACE)),this._workspaceKeyTargets}get profileKeyTargets(){return this._profileKeyTargets||(this._profileKeyTargets=this.loadKeyTargets(E.PROFILE)),this._profileKeyTargets}get applicationKeyTargets(){return this._applicationKeyTargets||(this._applicationKeyTargets=this.loadKeyTargets(E.APPLICATION)),this._applicationKeyTargets}getKeyTargets(i){switch(i){case E.APPLICATION:return this.applicationKeyTargets;case E.PROFILE:return this.profileKeyTargets;default:return this.workspaceKeyTargets}}loadKeyTargets(i){const n=this.getStorage(i);return n?C(n):Object.create(null)}isNew(i){return this.getBoolean(e.IS_NEW_KEY,i)===!0}async flush(i=I.NONE){this._onWillSaveState.fire({reason:i});const n=this.getStorage(E.APPLICATION),t=this.getStorage(E.PROFILE),o=this.getStorage(E.WORKSPACE);switch(i){case I.NONE:await S.Promises.settled([n?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve(),o?.whenFlushed()??Promise.resolve()]);break;case I.SHUTDOWN:await S.Promises.settled([n?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve(),o?.flush(0)??Promise.resolve()]);break}}async log(){const i=this.getStorage(E.APPLICATION)?.items??new Map,n=this.getStorage(E.PROFILE)?.items??new Map,t=this.getStorage(E.WORKSPACE)?.items??new Map;return d(i,n,t,this.getLogDetails(E.APPLICATION)??"",this.getLogDetails(E.PROFILE)??"",this.getLogDetails(E.WORKSPACE)??"")}async optimize(i){return await this.flush(),this.getStorage(i)?.optimize()}async switch(i,n){return this.emitWillSaveState(I.NONE),(0,s.isUserDataProfile)(i)?this.switchToProfile(i,n):this.switchToWorkspace(i,n)}canSwitchProfile(i,n){return!(i.id===n.id||r(n)&&r(i))}switchData(i,n,t){this.withPausedEmitters(()=>{const o=new Set;for(const[c,g]of i)o.add(c),n.get(c)!==g&&this.emitDidChangeValue(t,{key:c,external:!0});for(const[c]of n.items)o.has(c)||this.emitDidChangeValue(t,{key:c,external:!0})})}}e.AbstractStorageService=v;function r(l){return l.isDefault||!!l.useDefaultFlags?.globalState}class a extends v{constructor(){super(),this.applicationStorage=this._register(new A.Storage(new A.InMemoryStorageDatabase,{hint:A.StorageHint.STORAGE_IN_MEMORY})),this.profileStorage=this._register(new A.Storage(new A.InMemoryStorageDatabase,{hint:A.StorageHint.STORAGE_IN_MEMORY})),this.workspaceStorage=this._register(new A.Storage(new A.InMemoryStorageDatabase,{hint:A.StorageHint.STORAGE_IN_MEMORY})),this._register(this.workspaceStorage.onDidChangeStorage(i=>this.emitDidChangeValue(E.WORKSPACE,i))),this._register(this.profileStorage.onDidChangeStorage(i=>this.emitDidChangeValue(E.PROFILE,i))),this._register(this.applicationStorage.onDidChangeStorage(i=>this.emitDidChangeValue(E.APPLICATION,i)))}getStorage(i){switch(i){case E.APPLICATION:return this.applicationStorage;case E.PROFILE:return this.profileStorage;default:return this.workspaceStorage}}getLogDetails(i){switch(i){case E.APPLICATION:return"inMemory (application)";case E.PROFILE:return"inMemory (profile)";default:return"inMemory (workspace)"}}async doInitialize(){}async switchToProfile(){}async switchToWorkspace(){}shouldFlushWhenIdle(){return!1}hasScope(i){return!1}}e.InMemoryStorageService=a;async function d(l,i,n,t,o,c){const g=b=>{try{return JSON.parse(b)}catch{return b}},f=new Map,h=new Map;l.forEach((b,N)=>{f.set(N,b),h.set(N,g(b))});const _=new Map,y=new Map;i.forEach((b,N)=>{_.set(N,b),y.set(N,g(b))});const w=new Map,P=new Map;n.forEach((b,N)=>{w.set(N,b),P.set(N,g(b))}),console.group(t!==o?`Storage: Application (path: ${t})`:`Storage: Application & Profile (path: ${t}, default profile)`);const R=[];if(f.forEach((b,N)=>{R.push({key:N,value:b})}),console.table(R),console.groupEnd(),console.log(h),t!==o){console.group(`Storage: Profile (path: ${o}, profile specific)`);const b=[];_.forEach((N,L)=>{b.push({key:L,value:N})}),console.table(b),console.groupEnd(),console.log(y)}console.group(`Storage: Workspace (path: ${c})`);const p=[];w.forEach((b,N)=>{p.push({key:N,value:b})}),console.table(p),console.groupEnd(),console.log(P)}}),define(ke[80],Re([1,0]),function(Ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class S{static{this.enableDebugLogging=!1}constructor(D){this.id=D,this._data=new Map,this._idPool=1}add(D){const O=this._idPool++;return this._data.set(O,D),this.logDebugInfo(),O}get(D,O){return this._data.has(D)?this._data.get(D)[O]:void 0}delete(D){this._data.delete(D),this.logDebugInfo()}logDebugInfo(){S.enableDebugLogging&&console.log(`${this.id} cache size - ${this._data.size}`)}}e.Cache=S}),define(ke[50],Re([1,0,15,24,28,3]),function(Ee,e,S,T,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class k{constructor(){this._systemSchemes=new Set(Object.keys(S.Schemas)),this._providerInfo=new Map,this.extUri=new T.ExtUri(m=>{const s=this._providerInfo.get(m.scheme);return!(s===void 0||s&D.FileSystemProviderCapabilities.PathCaseSensitive)})}$acceptProviderInfos(m,s){s===null?this._providerInfo.delete(m.scheme):this._providerInfo.set(m.scheme,s)}isFreeScheme(m){return!this._providerInfo.has(m)&&!this._systemSchemes.has(m)}getCapabilities(m){return this._providerInfo.get(m)}}e.ExtHostFileSystemInfo=k,e.IExtHostFileSystemInfo=(0,O.createDecorator)("IExtHostFileSystemInfo")}),define(ke[26],Re([1,0,3]),function(Ee,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,S.createDecorator)("IExtHostInitDataService")}),define(ke[188],Re([1,0,9,11,173,26]),function(Ee,e,S,T,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let k=class extends D.LogService{constructor(m,s,I){const E=I.remote.isRemote?"remoteexthost":m?"workerexthost":"exthost",u=I.remote.isRemote?(0,S.localize)(2706,null):m?(0,S.localize)(2707,null):(0,S.localize)(2708,null);super(s.createLogger(E,{name:u}))}};e.ExtHostLogService=k,e.ExtHostLogService=k=qe([We(1,T.ILoggerService),We(2,O.IExtHostInitDataService)],k)}),define(ke[189],Re([1,0,10]),function(Ee,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class T{constructor(k,A,m){this._deferredPromises=new Map,this._id=k,this._shared=A,this._storage=m,this._init=this._storage.initializeExtensionStorage(this._shared,this._id,Object.create(null)).then(s=>(this._value=s,this)),this._storageListener=this._storage.onDidChangeStorage(s=>{s.shared===this._shared&&s.key===this._id&&(this._value=s.value)}),this._scheduler=new S.RunOnceScheduler(()=>{const s=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const I of s.values())I.complete()}catch(I){for(const E of s.values())E.error(I)}})()},0)}keys(){return Object.entries(this._value??{}).filter(([,k])=>k!==void 0).map(([k])=>k)}get whenReady(){return this._init}get(k,A){let m=this._value[k];return typeof m>"u"&&(m=A),m}update(k,A){this._value[k]=A;const m=this._deferredPromises.get(k);if(m!==void 0)return m.p;const s=new S.DeferredPromise;return this._deferredPromises.set(k,s),this._scheduler.isScheduled()||this._scheduler.schedule(),s.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=T;class D extends T{setKeysForSync(k){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},k)}constructor(k,A){super(k.identifier.value,!0,A),this._extension=k}}e.ExtensionGlobalMemento=D}),define(ke[190],Re([1,0,6,2]),function(Ee,e,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;class D{constructor(k){this._notebooksAndEditors=k,this._onDidSaveNotebookDocument=new S.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event,this._onDidChangeNotebookDocument=new S.Emitter,this.onDidChangeNotebookDocument=this._onDidChangeNotebookDocument.event}$acceptModelChanged(k,A,m,s){const E=this._notebooksAndEditors.getNotebookDocument(T.URI.revive(k)).acceptModelChanged(A.value,m,s);this._onDidChangeNotebookDocument.fire(E)}$acceptDirtyStateChanged(k,A){this._notebooksAndEditors.getNotebookDocument(T.URI.revive(k)).acceptDirty(A)}$acceptModelSaved(k){const A=this._notebooksAndEditors.getNotebookDocument(T.URI.revive(k));this._onDidSaveNotebookDocument.fire(A.apiNotebook)}}e.ExtHostNotebookDocuments=D}),define(ke[16],Re([1,0,3]),function(Ee,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,S.createDecorator)("IExtHostRpcService");class T{constructor(O){this.getProxy=O.getProxy.bind(O),this.set=O.set.bind(O),this.dispose=O.dispose.bind(O),this.assertRegistered=O.assertRegistered.bind(O),this.drain=O.drain.bind(O)}}e.ExtHostRpcService=T}),define(ke[191],Re([1,0,18,6,4]),function(Ee,e,S,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class O{#e;constructor(A,m){this.disposables=new D.DisposableStore,this._id=S.ExtensionIdentifier.toKey(A.identifier),this.#e=m,this.onDidChange=T.Event.map(T.Event.filter(this.#e.onDidChangePassword,s=>s.extensionId===this._id),s=>({key:s.key}),this.disposables)}dispose(){this.disposables.dispose()}get(A){return this.#e.get(this._id,A)}store(A,m){return this.#e.store(this._id,A,m)}delete(A){return this.#e.delete(this._id,A)}}e.ExtensionSecrets=O}),define(ke[65],Re([1,0,3]),function(Ee,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,S.createDecorator)("IURITransformerService");class T{constructor(O){O?(this.transformIncoming=O.transformIncoming.bind(O),this.transformOutgoing=O.transformOutgoing.bind(O),this.transformOutgoingURI=O.transformOutgoingURI.bind(O),this.transformOutgoingScheme=O.transformOutgoingScheme.bind(O)):(this.transformIncoming=k=>k,this.transformOutgoing=k=>k,this.transformOutgoingURI=k=>k,this.transformOutgoingScheme=k=>k)}}e.URITransformerService=T});var oi=this&&this.__importDefault||function(Ee){return Ee&&Ee.__esModule?Ee:{default:Ee}};define(ke[116],Re([1,0,9,14,2,4,3,29,28,15,42,157,37]),function(Ee,e,S,T,D,O,k,A,m,s,I,E,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.CloseDirection=e.EditorResourceAccessor=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveSourceRegistry=e.SaveReason=e.Verbosity=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.isEditorPaneWithSelection=r,e.isEditorPaneWithScrolling=a,e.findViewStateForEditor=d,e.isResourceEditorInput=l,e.isResourceDiffEditorInput=i,e.isResourceMultiDiffEditorInput=n,e.isResourceSideBySideEditorInput=t,e.isUntitledResourceEditorInput=o,e.isResourceMergeEditorInput=c,e.isEditorInput=w,e.isSideBySideEditorInput=R,e.isDiffEditorInput=p,e.createTooLargeFileError=b,e.isEditorInputWithOptions=N,e.isEditorInputWithOptionsAndGroup=L,e.isEditorIdentifier=F,e.isEditorCommandsContext=K,e.preventEditorClose=ae,e.pathsToEditors=ie,e.isTextEditorViewState=Z,e.isEditorOpenError=ve,e.createEditorOpenError=Ie,u=oi(u),e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,S.localize)(4055,null),providerDisplayName:(0,S.localize)(4056,null)},e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";var C;(function(X){X[X.PROGRAMMATIC=1]="PROGRAMMATIC",X[X.USER=2]="USER",X[X.EDIT=3]="EDIT",X[X.NAVIGATION=4]="NAVIGATION",X[X.JUMP=5]="JUMP"})(C||(e.EditorPaneSelectionChangeReason=C={}));var v;(function(X){X[X.IDENTICAL=1]="IDENTICAL",X[X.SIMILAR=2]="SIMILAR",X[X.DIFFERENT=3]="DIFFERENT"})(v||(e.EditorPaneSelectionCompareResult=v={}));function r(X){const V=X;return!!V&&typeof V.getSelection=="function"&&!!V.onDidChangeSelection}function a(X){const V=X;return!!V&&typeof V.getScrollPosition=="function"&&typeof V.setScrollPosition=="function"&&!!V.onDidChangeScroll}function d(X,V,re){for(const be of re.visibleEditorPanes)if(be.group.id===V&&X.matches(be.input))return be.getViewState()}function l(X){if(w(X))return!1;const V=X;return D.URI.isUri(V?.resource)}function i(X){if(w(X))return!1;const V=X;return V?.original!==void 0&&V.modified!==void 0}function n(X){if(w(X))return!1;const V=X;return!V||V.resources&&!Array.isArray(V.resources)?!1:!!V.resources||!!V.multiDiffSource}function t(X){if(w(X)||i(X))return!1;const V=X;return V?.primary!==void 0&&V.secondary!==void 0}function o(X){if(w(X))return!1;const V=X;return V?V.resource===void 0||V.resource.scheme===s.Schemas.untitled||V.forceUntitled===!0:!1}function c(X){if(w(X))return!1;const V=X;return D.URI.isUri(V?.base?.resource)&&D.URI.isUri(V?.input1?.resource)&&D.URI.isUri(V?.input2?.resource)&&D.URI.isUri(V?.result?.resource)}var g;(function(X){X[X.SHORT=0]="SHORT",X[X.MEDIUM=1]="MEDIUM",X[X.LONG=2]="LONG"})(g||(e.Verbosity=g={}));var f;(function(X){X[X.EXPLICIT=1]="EXPLICIT",X[X.AUTO=2]="AUTO",X[X.FOCUS_CHANGE=3]="FOCUS_CHANGE",X[X.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(f||(e.SaveReason=f={}));class h{constructor(){this.mapIdToSaveSource=new Map}registerSource(V,re){let be=this.mapIdToSaveSource.get(V);return be||(be={source:V,label:re},this.mapIdToSaveSource.set(V,be)),be.source}getSourceLabel(V){return this.mapIdToSaveSource.get(V)?.label??V}}e.SaveSourceRegistry=new h;var _;(function(X){X[X.None=0]="None",X[X.Readonly=2]="Readonly",X[X.Untitled=4]="Untitled",X[X.Singleton=8]="Singleton",X[X.RequiresTrust=16]="RequiresTrust",X[X.CanSplitInGroup=32]="CanSplitInGroup",X[X.ForceDescription=64]="ForceDescription",X[X.CanDropIntoEditor=128]="CanDropIntoEditor",X[X.MultipleEditors=256]="MultipleEditors",X[X.Scratchpad=512]="Scratchpad"})(_||(e.EditorInputCapabilities=_={}));class y extends O.Disposable{}e.AbstractEditorInput=y;function w(X){return X instanceof y}function P(X){const V=X;return D.URI.isUri(V?.preferredResource)}function R(X){const V=X;return w(V?.primary)&&w(V?.secondary)}function p(X){const V=X;return w(V?.modified)&&w(V?.original)}function b(X,V,re,be,De){return Ie(be,[(0,E.toAction)({id:"workbench.action.openLargeFile",label:(0,S.localize)(4057,null),run:()=>{const Fe={...re,limits:{size:Number.MAX_VALUE}};X.openEditor(V,Fe)}}),(0,E.toAction)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,S.localize)(4058,null),run:()=>De.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:u.default.Warning})}function N(X){return w(X?.editor)}function L(X){const V=X;return N(X)&&V?.group!==void 0}function F(X){const V=X;return typeof V?.groupId=="number"&&w(V.editor)}function K(X){return typeof X?.groupId=="number"}var J;(function(X){X[X.UNKNOWN=0]="UNKNOWN",X[X.REPLACE=1]="REPLACE",X[X.MOVE=2]="MOVE",X[X.UNPIN=3]="UNPIN"})(J||(e.EditorCloseContext=J={}));var $;(function(X){X[X.GROUP_ACTIVE=0]="GROUP_ACTIVE",X[X.GROUP_INDEX=1]="GROUP_INDEX",X[X.GROUP_LABEL=2]="GROUP_LABEL",X[X.GROUP_LOCKED=3]="GROUP_LOCKED",X[X.EDITORS_SELECTION=4]="EDITORS_SELECTION",X[X.EDITOR_OPEN=5]="EDITOR_OPEN",X[X.EDITOR_CLOSE=6]="EDITOR_CLOSE",X[X.EDITOR_MOVE=7]="EDITOR_MOVE",X[X.EDITOR_ACTIVE=8]="EDITOR_ACTIVE",X[X.EDITOR_LABEL=9]="EDITOR_LABEL",X[X.EDITOR_CAPABILITIES=10]="EDITOR_CAPABILITIES",X[X.EDITOR_PIN=11]="EDITOR_PIN",X[X.EDITOR_TRANSIENT=12]="EDITOR_TRANSIENT",X[X.EDITOR_STICKY=13]="EDITOR_STICKY",X[X.EDITOR_DIRTY=14]="EDITOR_DIRTY",X[X.EDITOR_WILL_DISPOSE=15]="EDITOR_WILL_DISPOSE"})($||(e.GroupModelChangeKind=$={}));var x;(function(X){X[X.PRIMARY=1]="PRIMARY",X[X.SECONDARY=2]="SECONDARY",X[X.BOTH=3]="BOTH",X[X.ANY=4]="ANY"})(x||(e.SideBySideEditor=x={}));class G{getOriginalUri(V,re){if(!V)return;if(c(V))return e.EditorResourceAccessor.getOriginalUri(V.result,re);if(re?.supportSideBySide){const{primary:De,secondary:Fe}=this.getSideEditors(V);if(De&&Fe){if(re?.supportSideBySide===x.BOTH)return{primary:this.getOriginalUri(De,{filterByScheme:re.filterByScheme}),secondary:this.getOriginalUri(Fe,{filterByScheme:re.filterByScheme})};if(re?.supportSideBySide===x.ANY)return this.getOriginalUri(De,{filterByScheme:re.filterByScheme})??this.getOriginalUri(Fe,{filterByScheme:re.filterByScheme});V=re.supportSideBySide===x.PRIMARY?De:Fe}}if(i(V)||n(V)||t(V)||c(V))return;const be=P(V)?V.preferredResource:V.resource;return!be||!re||!re.filterByScheme?be:this.filterUri(be,re.filterByScheme)}getSideEditors(V){return R(V)||t(V)?{primary:V.primary,secondary:V.secondary}:p(V)||i(V)?{primary:V.modified,secondary:V.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(V,re){if(!V)return;if(c(V))return e.EditorResourceAccessor.getCanonicalUri(V.result,re);if(re?.supportSideBySide){const{primary:De,secondary:Fe}=this.getSideEditors(V);if(De&&Fe){if(re?.supportSideBySide===x.BOTH)return{primary:this.getCanonicalUri(De,{filterByScheme:re.filterByScheme}),secondary:this.getCanonicalUri(Fe,{filterByScheme:re.filterByScheme})};if(re?.supportSideBySide===x.ANY)return this.getCanonicalUri(De,{filterByScheme:re.filterByScheme})??this.getCanonicalUri(Fe,{filterByScheme:re.filterByScheme});V=re.supportSideBySide===x.PRIMARY?De:Fe}}if(i(V)||n(V)||t(V)||c(V))return;const be=V.resource;return!be||!re||!re.filterByScheme?be:this.filterUri(be,re.filterByScheme)}filterUri(V,re){if(Array.isArray(re)){if(re.some(be=>V.scheme===be))return V}else if(re===V.scheme)return V}}var Y;(function(X){X[X.UNKNOWN=0]="UNKNOWN",X[X.KEYBOARD=1]="KEYBOARD",X[X.MOUSE=2]="MOUSE"})(Y||(e.EditorCloseMethod=Y={}));function ae(X,V,re,be){if(!X.isSticky(V))return!1;switch(be.preventPinnedEditorClose){case"keyboardAndMouse":return re===Y.MOUSE||re===Y.KEYBOARD;case"mouse":return re===Y.MOUSE;case"keyboard":return re===Y.KEYBOARD}return!1}e.EditorResourceAccessor=new G;var ee;(function(X){X[X.LEFT=0]="LEFT",X[X.RIGHT=1]="RIGHT"})(ee||(e.CloseDirection=ee={}));class oe{constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start(V){const re=this.instantiationService=V.get(k.IInstantiationService);for(const[be,De]of this.editorSerializerConstructors)this.createEditorSerializer(be,De,re);this.editorSerializerConstructors.clear()}createEditorSerializer(V,re,be){const De=be.createInstance(re);this.editorSerializerInstances.set(V,De)}registerFileEditorFactory(V){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=V}getFileEditorFactory(){return(0,T.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer(V,re){if(this.editorSerializerConstructors.has(V)||this.editorSerializerInstances.has(V))throw new Error(`A editor serializer with type ID '${V}' was already registered.`);return this.instantiationService?this.createEditorSerializer(V,re,this.instantiationService):this.editorSerializerConstructors.set(V,re),(0,O.toDisposable)(()=>{this.editorSerializerConstructors.delete(V),this.editorSerializerInstances.delete(V)})}getEditorSerializer(V){return this.editorSerializerInstances.get(typeof V=="string"?V:V.typeId)}}A.Registry.add(e.EditorExtensions.EditorFactory,new oe);async function ie(X,V,re){return!X||!X.length?[]:await Promise.all(X.map(async be=>{const De=D.URI.revive(be.fileUri);if(!De){re.info("Cannot resolve the path because it is not valid.",be);return}if(!await V.canHandleResource(De)){re.info("Cannot resolve the path because it cannot be handled",be);return}let ze=be.exists,Je=be.type;if(typeof ze!="boolean"||typeof Je!="number")try{Je=(await V.stat(De)).isDirectory?m.FileType.Directory:m.FileType.Unknown,ze=!0}catch(dt){re.error(dt),ze=!1}if(!ze&&be.openOnlyIfExists){re.info("Cannot resolve the path because it does not exist",be);return}if(Je===m.FileType.Directory){re.info("Cannot resolve the path because it is a directory",be);return}const nt={...be.options,pinned:!0};return ze?{resource:De,options:nt}:{resource:De,options:nt,forceUntitled:!0}}))}var ue;(function(X){X[X.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",X[X.SEQUENTIAL=1]="SEQUENTIAL"})(ue||(e.EditorsOrder=ue={}));function Z(X){const V=X;if(!V)return!1;const re=V;if(re.modified)return Z(re.modified);const be=V;return!!(be.contributionsState&&be.viewState&&Array.isArray(be.cursorState))}function ve(X){return(0,I.isErrorWithActions)(X)}function Ie(X,V,re){const be=(0,I.createErrorWithActions)(X,V);return be.forceMessage=re?.forceMessage,be.forceSeverity=re?.forceSeverity,be.allowDialog=re?.allowDialog,be}}),define(ke[192],Re([1,0,6,9,3,4,27,29,25,98,183]),function(Ee,e,S,T,D,O,k,A,m,s,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoTreeViewError=e.ResolvableTreeItem=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.IViewDescriptorService=e.ViewContentGroups=e.ViewContainerLocations=e.ViewContainerLocation=e.Extensions=e.defaultViewIcon=e.VIEWS_LOG_NAME=e.VIEWS_LOG_ID=void 0,e.ViewContainerLocationToString=C,e.VIEWS_LOG_ID="views",e.VIEWS_LOG_NAME=(0,T.localize)(4218,null),e.defaultViewIcon=(0,I.registerIcon)("default-view-icon",s.Codicon.window,(0,T.localize)(4219,null));var E;(function(o){o.ViewContainersRegistry="workbench.registry.view.containers",o.ViewsRegistry="workbench.registry.view"})(E||(e.Extensions=E={}));var u;(function(o){o[o.Sidebar=0]="Sidebar",o[o.Panel=1]="Panel",o[o.AuxiliaryBar=2]="AuxiliaryBar"})(u||(e.ViewContainerLocation=u={})),e.ViewContainerLocations=[u.Sidebar,u.Panel,u.AuxiliaryBar];function C(o){switch(o){case u.Sidebar:return"sidebar";case u.Panel:return"panel";case u.AuxiliaryBar:return"auxiliarybar"}}class v extends O.Disposable{constructor(){super(...arguments),this._onDidRegister=this._register(new S.Emitter),this.onDidRegister=this._onDidRegister.event,this._onDidDeregister=this._register(new S.Emitter),this.onDidDeregister=this._onDidDeregister.event,this.viewContainers=new Map,this.defaultViewContainers=[]}get all(){return[...this.viewContainers.values()].flat()}registerViewContainer(c,g,f){const h=this.get(c.id);if(h)return h;const _=c;return _.openCommandActionDescriptor=f?.doNotRegisterOpenCommand?void 0:_.openCommandActionDescriptor??{id:_.id},(0,k.getOrSet)(this.viewContainers,g,[]).push(_),f?.isDefault&&this.defaultViewContainers.push(_),this._onDidRegister.fire({viewContainer:_,viewContainerLocation:g}),_}deregisterViewContainer(c){for(const g of this.viewContainers.keys()){const f=this.viewContainers.get(g),h=f?.indexOf(c);if(h!==-1){f?.splice(h,1),f.length===0&&this.viewContainers.delete(g),this._onDidDeregister.fire({viewContainer:c,viewContainerLocation:g});return}}}get(c){return this.all.filter(g=>g.id===c)[0]}getViewContainers(c){return[...this.viewContainers.get(c)||[]]}getViewContainerLocation(c){return[...this.viewContainers.keys()].filter(g=>this.getViewContainers(g).filter(f=>f?.id===c.id).length>0)[0]}getDefaultViewContainer(c){return this.defaultViewContainers.find(g=>this.getViewContainerLocation(g)===c)}}A.Registry.add(E.ViewContainersRegistry,new v);var r;(function(o){o.Open="2_open",o.Debug="4_debug",o.SCM="5_scm",o.More="9_more"})(r||(e.ViewContentGroups=r={}));function a(o,c){const g=o.group??r.More,f=c.group??r.More;return g!==f?g.localeCompare(f):(o.order??5)-(c.order??5)}class d extends O.Disposable{constructor(){super(...arguments),this._onViewsRegistered=this._register(new S.Emitter),this.onViewsRegistered=this._onViewsRegistered.event,this._onViewsDeregistered=this._register(new S.Emitter),this.onViewsDeregistered=this._onViewsDeregistered.event,this._onDidChangeContainer=this._register(new S.Emitter),this.onDidChangeContainer=this._onDidChangeContainer.event,this._onDidChangeViewWelcomeContent=this._register(new S.Emitter),this.onDidChangeViewWelcomeContent=this._onDidChangeViewWelcomeContent.event,this._viewContainers=[],this._views=new Map,this._viewWelcomeContents=new k.SetMap}registerViews(c,g){this.registerViews2([{views:c,viewContainer:g}])}registerViews2(c){c.forEach(({views:g,viewContainer:f})=>this.addViews(g,f)),this._onViewsRegistered.fire(c)}deregisterViews(c,g){const f=this.removeViews(c,g);f.length&&this._onViewsDeregistered.fire({views:f,viewContainer:g})}moveViews(c,g){for(const f of this._views.keys())if(f!==g){const h=this.removeViews(c,f);h.length&&(this.addViews(h,g),this._onDidChangeContainer.fire({views:h,from:f,to:g}))}}getViews(c){return this._views.get(c)||[]}getView(c){for(const g of this._viewContainers){const f=(this._views.get(g)||[]).filter(h=>h.id===c)[0];if(f)return f}return null}getViewContainer(c){for(const g of this._viewContainers)if((this._views.get(g)||[]).filter(h=>h.id===c)[0])return g;return null}registerViewWelcomeContent(c,g){return this._viewWelcomeContents.add(c,g),this._onDidChangeViewWelcomeContent.fire(c),(0,O.toDisposable)(()=>{this._viewWelcomeContents.delete(c,g),this._onDidChangeViewWelcomeContent.fire(c)})}registerViewWelcomeContent2(c,g){const f=new Map;for(const[h,_]of g)this._viewWelcomeContents.add(c,_),f.set(h,(0,O.toDisposable)(()=>{this._viewWelcomeContents.delete(c,_),this._onDidChangeViewWelcomeContent.fire(c)}));return this._onDidChangeViewWelcomeContent.fire(c),f}getViewWelcomeContent(c){const g=[];return this._viewWelcomeContents.forEach(c,f=>g.push(f)),g.sort(a)}addViews(c,g){let f=this._views.get(g);f||(f=[],this._views.set(g,f),this._viewContainers.push(g));for(const h of c){if(this.getView(h.id)!==null)throw new Error((0,T.localize)(4220,null,h.id));f.push(h)}}removeViews(c,g){const f=this._views.get(g);if(!f)return[];const h=[],_=[];for(const y of f)c.includes(y)?h.push(y):_.push(y);return h.length&&(_.length?this._views.set(g,_):(this._views.delete(g),this._viewContainers.splice(this._viewContainers.indexOf(g),1))),h}}A.Registry.add(E.ViewsRegistry,new d),e.IViewDescriptorService=(0,D.createDecorator)("viewDescriptorService");var l;(function(o){o[o.Default=0]="Default",o[o.Expand=1]="Expand"})(l||(e.ViewVisibilityState=l={}));var i;(function(o){o[o.None=0]="None",o[o.Collapsed=1]="Collapsed",o[o.Expanded=2]="Expanded"})(i||(e.TreeItemCollapsibleState=i={}));class n{constructor(c,g){this.resolved=!1,this._hasResolve=!1,(0,m.mixin)(this,c),this._hasResolve=!!g,this.resolve=async f=>{if(g&&!this.resolved){const h=await g(f);h&&(this.tooltip=this.tooltip??h.tooltip,this.command=this.command??h.command)}f.isCancellationRequested||(this.resolved=!0)}}get hasResolve(){return this._hasResolve}resetResolve(){this.resolved=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.ResolvableTreeItem=n;class t extends Error{constructor(c){super((0,T.localize)(4221,null,c)),this.name="NoTreeViewError"}static is(c){return!!c&&c.name==="NoTreeViewError"}}e.NoTreeViewError=t}),define(ke[193],Re([1,0,9,31]),function(Ee,e,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_IN_QUICK_CHAT=e.CONTEXT_CHAT_LOCATION=e.CONTEXT_CHAT_INPUT_HAS_AGENT=e.CONTEXT_CHAT_INPUT_CURSOR_AT_TOP=e.CONTEXT_CHAT_EXTENSION_INVALID=e.CONTEXT_CHAT_PANEL_PARTICIPANT_REGISTERED=e.CONTEXT_CHAT_ENABLED=e.CONTEXT_IN_CHAT_SESSION=e.CONTEXT_IN_CHAT_INPUT=e.CONTEXT_CHAT_INPUT_HAS_FOCUS=e.CONTEXT_CHAT_INPUT_HAS_TEXT=e.CONTEXT_CHAT_EDIT_APPLIED=e.CONTEXT_REQUEST=e.CONTEXT_RESPONSE=e.CONTEXT_CHAT_REQUEST_IN_PROGRESS=e.CONTEXT_RESPONSE_ERROR=e.CONTEXT_RESPONSE_FILTERED=e.CONTEXT_CHAT_RESPONSE_SUPPORT_ISSUE_REPORTING=e.CONTEXT_RESPONSE_DETECTED_AGENT_COMMAND=e.CONTEXT_VOTE_UP_ENABLED=e.CONTEXT_RESPONSE_VOTE=void 0,e.CONTEXT_RESPONSE_VOTE=new T.RawContextKey("chatSessionResponseVote","",{type:"string",description:(0,S.localize)(4716,null)}),e.CONTEXT_VOTE_UP_ENABLED=new T.RawContextKey("chatVoteUpEnabled",!1,{type:"boolean",description:(0,S.localize)(4717,null)}),e.CONTEXT_RESPONSE_DETECTED_AGENT_COMMAND=new T.RawContextKey("chatSessionResponseDetectedAgentOrCommand",!1,{type:"boolean",description:(0,S.localize)(4718,null)}),e.CONTEXT_CHAT_RESPONSE_SUPPORT_ISSUE_REPORTING=new T.RawContextKey("chatResponseSupportsIssueReporting",!1,{type:"boolean",description:(0,S.localize)(4719,null)}),e.CONTEXT_RESPONSE_FILTERED=new T.RawContextKey("chatSessionResponseFiltered",!1,{type:"boolean",description:(0,S.localize)(4720,null)}),e.CONTEXT_RESPONSE_ERROR=new T.RawContextKey("chatSessionResponseError",!1,{type:"boolean",description:(0,S.localize)(4721,null)}),e.CONTEXT_CHAT_REQUEST_IN_PROGRESS=new T.RawContextKey("chatSessionRequestInProgress",!1,{type:"boolean",description:(0,S.localize)(4722,null)}),e.CONTEXT_RESPONSE=new T.RawContextKey("chatResponse",!1,{type:"boolean",description:(0,S.localize)(4723,null)}),e.CONTEXT_REQUEST=new T.RawContextKey("chatRequest",!1,{type:"boolean",description:(0,S.localize)(4724,null)}),e.CONTEXT_CHAT_EDIT_APPLIED=new T.RawContextKey("chatEditApplied",!1,{type:"boolean",description:(0,S.localize)(4725,null)}),e.CONTEXT_CHAT_INPUT_HAS_TEXT=new T.RawContextKey("chatInputHasText",!1,{type:"boolean",description:(0,S.localize)(4726,null)}),e.CONTEXT_CHAT_INPUT_HAS_FOCUS=new T.RawContextKey("chatInputHasFocus",!1,{type:"boolean",description:(0,S.localize)(4727,null)}),e.CONTEXT_IN_CHAT_INPUT=new T.RawContextKey("inChatInput",!1,{type:"boolean",description:(0,S.localize)(4728,null)}),e.CONTEXT_IN_CHAT_SESSION=new T.RawContextKey("inChat",!1,{type:"boolean",description:(0,S.localize)(4729,null)}),e.CONTEXT_CHAT_ENABLED=new T.RawContextKey("chatIsEnabled",!1,{type:"boolean",description:(0,S.localize)(4730,null)}),e.CONTEXT_CHAT_PANEL_PARTICIPANT_REGISTERED=new T.RawContextKey("chatPanelParticipantRegistered",!1,{type:"boolean",description:(0,S.localize)(4731,null)}),e.CONTEXT_CHAT_EXTENSION_INVALID=new T.RawContextKey("chatExtensionInvalid",!1,{type:"boolean",description:(0,S.localize)(4732,null)}),e.CONTEXT_CHAT_INPUT_CURSOR_AT_TOP=new T.RawContextKey("chatCursorAtTop",!1),e.CONTEXT_CHAT_INPUT_HAS_AGENT=new T.RawContextKey("chatInputHasAgent",!1),e.CONTEXT_CHAT_LOCATION=new T.RawContextKey("chatLocation",void 0),e.CONTEXT_IN_QUICK_CHAT=new T.RawContextKey("quickChatHasFocus",!1,{type:"boolean",description:(0,S.localize)(4733,null)})}),define(ke[117],Re([1,0,283,10,19,6,41,4,34,145,13,31,18,3,11,109,177,187,193]),function(Ee,e,S,T,D,O,k,A,m,s,I,E,u,C,v,r,a,d,l){"use strict";var i;Object.defineProperty(e,"__esModule",{value:!0}),e.ChatAgentNameService=e.IChatAgentNameService=e.MergedChatAgent=e.ChatAgentService=e.IChatAgentService=e.ChatAgentLocation=void 0,e.getFullyQualifiedId=g,e.reviveSerializedAgent=f;var n;(function(h){h.Panel="panel",h.Terminal="terminal",h.Notebook="notebook",h.Editor="editor"})(n||(e.ChatAgentLocation=n={})),function(h){function _(y){switch(y){case"panel":return h.Panel;case"terminal":return h.Terminal;case"notebook":return h.Notebook;case"editor":return h.Editor}return h.Panel}h.fromRaw=_}(n||(e.ChatAgentLocation=n={})),e.IChatAgentService=(0,C.createDecorator)("chatAgentService");let t=class{static{this.AGENT_LEADER="@"}constructor(_){this.contextKeyService=_,this._agents=new Map,this._onDidChangeAgents=new O.Emitter,this.onDidChangeAgents=this._onDidChangeAgents.event,this._agentCompletionProviders=new Map,this._chatParticipantDetectionProviders=new Map,this._hasDefaultAgent=l.CONTEXT_CHAT_ENABLED.bindTo(this.contextKeyService),this._defaultAgentRegistered=l.CONTEXT_CHAT_PANEL_PARTICIPANT_REGISTERED.bindTo(this.contextKeyService)}registerAgent(_,y){if(this.getAgent(_))throw new Error(`Agent already registered: ${JSON.stringify(_)}`);y.isDefault&&this._defaultAgentRegistered.set(!0);const P=this,R=y.slashCommands;y={...y,get slashCommands(){return R.filter(b=>!b.when||P.contextKeyService.contextMatchesRules(E.ContextKeyExpr.deserialize(b.when)))}};const p={data:y};return this._agents.set(_,p),this._onDidChangeAgents.fire(void 0),(0,A.toDisposable)(()=>{this._agents.delete(_),y.isDefault&&this._defaultAgentRegistered.set(!1),this._onDidChangeAgents.fire(void 0)})}registerAgentImplementation(_,y){const w=this._agents.get(_);if(!w)throw new Error(`Unknown agent: ${JSON.stringify(_)}`);if(w.impl)throw new Error(`Agent already has implementation: ${JSON.stringify(_)}`);return w.data.isDefault&&this._hasDefaultAgent.set(!0),w.impl=y,this._onDidChangeAgents.fire(new o(w.data,y)),(0,A.toDisposable)(()=>{w.impl=void 0,this._onDidChangeAgents.fire(void 0),w.data.isDefault&&this._hasDefaultAgent.set(!1)})}registerDynamicAgent(_,y){_.isDynamic=!0;const w={data:_,impl:y};return this._agents.set(_.id,w),this._onDidChangeAgents.fire(new o(_,y)),(0,A.toDisposable)(()=>{this._agents.delete(_.id),this._onDidChangeAgents.fire(void 0)})}registerAgentCompletionProvider(_,y){return this._agentCompletionProviders.set(_,y),{dispose:()=>{this._agentCompletionProviders.delete(_)}}}async getAgentCompletionItems(_,y,w){return await this._agentCompletionProviders.get(_)?.(y,w)??[]}updateAgent(_,y){const w=this._agents.get(_);if(!w?.impl)throw new Error(`No activated agent with id ${JSON.stringify(_)} registered`);w.data.metadata={...w.data.metadata,...y},this._onDidChangeAgents.fire(new o(w.data,w.impl))}getDefaultAgent(_){return(0,S.findLast)(this.getActivatedAgents(),y=>!!y.isDefault&&y.locations.includes(_))}getContributedDefaultAgent(_){return this.getAgents().find(y=>!!y.isDefault&&y.locations.includes(_))}getSecondaryAgent(){return k.Iterable.find(this._agents.values(),_=>!!_.data.metadata.isSecondary)?.data}getAgent(_){if(this._agentIsEnabled(_))return this._agents.get(_)?.data}_agentIsEnabled(_){const y=this._agents.get(_);return!y?.data.when||this.contextKeyService.contextMatchesRules(E.ContextKeyExpr.deserialize(y.data.when))}getAgentByFullyQualifiedId(_){const y=k.Iterable.find(this._agents.values(),w=>g(w.data)===_)?.data;if(!(y&&!this._agentIsEnabled(y.id)))return y}getAgents(){return Array.from(this._agents.values()).map(_=>_.data).filter(_=>this._agentIsEnabled(_.id))}getActivatedAgents(){return Array.from(this._agents.values()).filter(_=>!!_.impl).filter(_=>this._agentIsEnabled(_.data.id)).map(_=>new o(_.data,_.impl))}getAgentsByName(_){return this.getAgents().filter(y=>y.name===_)}agentHasDupeName(_){const y=this.getAgent(_);return y?this.getAgentsByName(y.name).filter(w=>w.extensionId.value!==y.extensionId.value).length>0:!1}async invokeAgent(_,y,w,P,R){const p=this._agents.get(_);if(!p?.impl)throw new Error(`No activated agent with id "${_}"`);return await p.impl.invoke(y,w,P,R)}async getFollowups(_,y,w,P,R){const p=this._agents.get(_);if(!p?.impl)throw new Error(`No activated agent with id "${_}"`);return p.impl?.provideFollowups?p.impl.provideFollowups(y,w,P,R):[]}async getChatTitle(_,y,w){const P=this._agents.get(_);if(!P?.impl)throw new Error(`No activated agent with id "${_}"`);if(P.impl?.provideChatTitle)return P.impl.provideChatTitle(y,w)}registerChatParticipantDetectionProvider(_,y){return this._chatParticipantDetectionProviders.set(_,y),(0,A.toDisposable)(()=>{this._chatParticipantDetectionProviders.delete(_)})}hasChatParticipantDetectionProviders(){return this._chatParticipantDetectionProviders.size>0}async detectAgentOrCommand(_,y,w,P){const R=k.Iterable.first(this._chatParticipantDetectionProviders.values());if(!R)return;const p=this.getAgents().reduce((F,K)=>{F.push({participant:K.id,disambiguation:K.disambiguation??[]});for(const J of K.slashCommands)F.push({participant:K.id,command:J.name,disambiguation:J.disambiguation??[]});return F},[]),b=await R.provideParticipantDetection(_,y,{...w,participants:p},P);if(!b)return;const N=this.getAgent(b.participant);if(!N)return;if(!b.command)return{agent:N};const L=N?.slashCommands.find(F=>F.name===b.command);if(L)return{agent:N,command:L}}};e.ChatAgentService=t,e.ChatAgentService=t=qe([We(0,E.IContextKeyService)],t);class o{constructor(_,y){this.data=_,this.impl=y}get id(){return this.data.id}get name(){return this.data.name??""}get fullName(){return this.data.fullName??""}get description(){return this.data.description??""}get extensionId(){return this.data.extensionId}get extensionPublisherId(){return this.data.extensionPublisherId}get extensionPublisherDisplayName(){return this.data.publisherDisplayName}get extensionDisplayName(){return this.data.extensionDisplayName}get isDefault(){return this.data.isDefault}get metadata(){return this.data.metadata}get slashCommands(){return this.data.slashCommands}get locations(){return this.data.locations}get disambiguation(){return this.data.disambiguation}async invoke(_,y,w,P){return this.impl.invoke(_,y,w,P)}async provideFollowups(_,y,w,P){return this.impl.provideFollowups?this.impl.provideFollowups(_,y,w,P):[]}provideWelcomeMessage(_,y){if(this.impl.provideWelcomeMessage)return this.impl.provideWelcomeMessage(_,y)}provideSampleQuestions(_,y){if(this.impl.provideSampleQuestions)return this.impl.provideSampleQuestions(_,y)}toJSON(){return this.data}}e.MergedChatAgent=o,e.IChatAgentNameService=(0,C.createDecorator)("chatAgentNameService");let c=class{static{i=this}static{this.StorageKey="chat.participantNameRegistry"}constructor(_,y,w,P){if(this.requestService=y,this.logService=w,this.storageService=P,this.registry=(0,s.observableValue)(this,Object.create(null)),this.disposed=!1,!_.chatParticipantRegistry)return;this.url=_.chatParticipantRegistry;const R=P.get(i.StorageKey,d.StorageScope.APPLICATION);try{this.registry.set(JSON.parse(R??"{}"),void 0)}catch{P.remove(i.StorageKey,d.StorageScope.APPLICATION)}this.refresh()}refresh(){this.disposed||this.update().catch(_=>this.logService.warn("Failed to fetch chat participant registry",_)).then(()=>(0,T.timeout)(5*60*1e3)).then(()=>this.refresh())}async update(){const _=await this.requestService.request({type:"GET",url:this.url},D.CancellationToken.None);if(_.res.statusCode!==200)throw new Error("Could not get extensions report.");const y=await(0,a.asJson)(_);if(!y||y.version!==1)throw new Error("Unexpected chat participant registry response.");const w=y.restrictedChatParticipants;this.registry.set(w,void 0),this.storageService.store(i.StorageKey,JSON.stringify(w),d.StorageScope.APPLICATION,d.StorageTarget.MACHINE)}getAgentNameRestriction(_){const y=this.checkAgentNameRestriction(_.name,_).get(),w=!_.fullName||this.checkAgentNameRestriction(_.fullName.replace(/\s/g,""),_).get();return y&&w}checkAgentNameRestriction(_,y){return this.registry.map(P=>P[_.toLowerCase()]).map(P=>P?P.some(R=>(0,I.equalsIgnoreCase)(R,R.includes(".")?y.extensionId.value:y.extensionPublisherId)):!0)}dispose(){this.disposed=!0}};e.ChatAgentNameService=c,e.ChatAgentNameService=c=i=qe([We(0,r.IProductService),We(1,a.IRequestService),We(2,v.ILogService),We(3,d.IStorageService)],c);function g(h){return`${h.extensionId.value}.${h.id}`}function f(h){const _="name"in h?h:{...h,name:h.id};return"extensionPublisherId"in _||(_.extensionPublisherId=_.extensionPublisher??""),"extensionDisplayName"in _||(_.extensionDisplayName=""),"extensionId"in _||(_.extensionId=new u.ExtensionIdentifier("")),(0,m.revive)(_)}}),define(ke[194],Re([1,0,2,32,3]),function(Ee,e,S,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KEYWORD_ACTIVIATION_SETTING_ID=e.IChatService=e.ChatCopyKind=e.ChatAgentVoteDownReason=e.ChatAgentVoteDirection=e.ChatResponseReferencePartStatusKind=void 0,e.isIDocumentContext=O,e.isIUsedContext=k;function O(E){return!!E&&typeof E=="object"&&"uri"in E&&E.uri instanceof S.URI&&"version"in E&&typeof E.version=="number"&&"ranges"in E&&Array.isArray(E.ranges)&&E.ranges.every(T.Range.isIRange)}function k(E){return!!E&&typeof E=="object"&&"documents"in E&&Array.isArray(E.documents)&&E.documents.every(O)}var A;(function(E){E[E.Complete=1]="Complete",E[E.Partial=2]="Partial",E[E.Omitted=3]="Omitted"})(A||(e.ChatResponseReferencePartStatusKind=A={}));var m;(function(E){E[E.Down=0]="Down",E[E.Up=1]="Up"})(m||(e.ChatAgentVoteDirection=m={}));var s;(function(E){E.IncorrectCode="incorrectCode",E.DidNotFollowInstructions="didNotFollowInstructions",E.IncompleteCode="incompleteCode",E.MissingContext="missingContext",E.PoorlyWrittenOrFormatted="poorlyWrittenOrFormatted",E.RefusedAValidRequest="refusedAValidRequest",E.OffensiveOrUnsafe="offensiveOrUnsafe",E.Other="other",E.WillReportIssue="willReportIssue"})(s||(e.ChatAgentVoteDownReason=s={}));var I;(function(E){E[E.Action=1]="Action",E[E.Toolbar=2]="Toolbar"})(I||(e.ChatCopyKind=I={})),e.IChatService=(0,D.createDecorator)("IChatService"),e.KEYWORD_ACTIVIATION_SETTING_ID="accessibility.voice.keywordActivation"}),define(ke[195],Re([1,0,6,10,9]),function(Ee,e,S,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class O{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new S.Emitter,this._onExit=new S.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(A){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=A}onEvent(A){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=A}onRequest(A){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=A}sendResponse(A){A.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${A.command}`)):this.internalSend("response",A)}sendRequest(A,m,s,I){const E={command:A};if(m&&Object.keys(m).length>0&&(E.arguments=m),this.internalSend("request",E),typeof I=="number"){const u=setTimeout(()=>{clearTimeout(u);const C=this.pendingRequests.get(E.seq);if(C){this.pendingRequests.delete(E.seq);const v={type:"response",seq:0,request_seq:E.seq,success:!1,command:A,message:(0,D.localize)(5733,null,I,A)};C(v)}},I)}return s&&this.pendingRequests.set(E.seq,s),E.seq}acceptMessage(A){this.messageCallback?this.messageCallback(A):(this.queue.push(A),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(A,m){return A.type!=="event"||m.type!=="event"}async processQueue(){let A;for(;this.queue.length;){if((!A||this.needsTaskBoundaryBetween(this.queue[0],A))&&await(0,T.timeout)(0),A=this.queue.shift(),!A)return;switch(A.type){case"event":this.eventCallback?.(A);break;case"request":this.requestCallback?.(A);break;case"response":{const m=A,s=this.pendingRequests.get(m.request_seq);s&&(this.pendingRequests.delete(m.request_seq),s(m));break}}}}internalSend(A,m){m.type=A,m.seq=this.sequence++,this.sendMessage(m)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const A=new Map;this.pendingRequests.forEach((m,s)=>A.set(s,m)),await(0,T.timeout)(500),A.forEach((m,s)=>{m({type:"response",seq:0,request_seq:s,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(s)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=O}),define(ke[81],Re([1,0,2,9,31,3]),function(Ee,e,S,T,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDebugVisualization=e.IDebugVisualizationTreeItem=e.DebugTreeItemCollapsibleState=e.DebugVisualizationType=e.BreakpointWidgetContext=e.IDebugService=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DataBreakpointSetType=e.DEBUG_MEMORY_SCHEME=e.MemoryRangeType=e.State=e.INTERNAL_CONSOLE_OPTIONS_SCHEMA=e.DEBUG_SCHEME=e.BREAKPOINT_EDITOR_CONTRIBUTION_ID=e.EDITOR_CONTRIBUTION_ID=e.debuggerDisabledMessage=e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=e.CONTEXT_MULTI_SESSION_DEBUG=e.CONTEXT_MULTI_SESSION_REPL=e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=e.CONTEXT_VARIABLE_EXTENSIONID=e.CONTEXT_VARIABLE_LANGUAGE=e.CONTEXT_VARIABLE_NAME=e.CONTEXT_VARIABLE_INTERFACES=e.CONTEXT_VARIABLE_TYPE=e.CONTEXT_VARIABLE_VALUE=e.CONTEXT_VARIABLE_IS_READONLY=e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=e.CONTEXT_SET_EXPRESSION_SUPPORTED=e.CONTEXT_SET_DATA_BREAKPOINT_BYTES_SUPPORTED=e.CONTEXT_SET_VARIABLE_SUPPORTED=e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=e.CONTEXT_DEBUGGERS_AVAILABLE=e.CONTEXT_BREAKPOINTS_EXIST=e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=e.CONTEXT_RESTART_FRAME_SUPPORTED=e.CONTEXT_STEP_BACK_SUPPORTED=e.CONTEXT_FOCUSED_SESSION_IS_NO_DEBUG=e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=e.CONTEXT_BREAKPOINT_HAS_MODES=e.CONTEXT_BREAKPOINT_ITEM_IS_DATA_BYTES=e.CONTEXT_BREAKPOINT_ITEM_TYPE=e.CONTEXT_CAN_VIEW_MEMORY=e.CONTEXT_WATCH_ITEM_TYPE=e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=e.CONTEXT_CALLSTACK_ITEM_STOPPED=e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=e.CONTEXT_CALLSTACK_ITEM_TYPE=e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=e.CONTEXT_EXPRESSION_SELECTED=e.CONTEXT_VARIABLES_FOCUSED=e.CONTEXT_WATCH_EXPRESSIONS_EXIST=e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=e.CONTEXT_BREAKPOINTS_FOCUSED=e.CONTEXT_IN_BREAKPOINT_WIDGET=e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=e.CONTEXT_IN_DEBUG_REPL=e.CONTEXT_IN_DEBUG_MODE=e.CONTEXT_HAS_DEBUGGED=e.CONTEXT_DEBUG_UX=e.CONTEXT_DEBUG_UX_KEY=e.CONTEXT_DEBUG_STATE=e.CONTEXT_DEBUG_CONFIGURATION_TYPE=e.CONTEXT_DEBUG_TYPE=e.REPL_VIEW_ID=e.DEBUG_PANEL_ID=e.DISASSEMBLY_VIEW_ID=e.BREAKPOINTS_VIEW_ID=e.LOADED_SCRIPTS_VIEW_ID=e.CALLSTACK_VIEW_ID=e.WATCH_VIEW_ID=e.VARIABLES_VIEW_ID=e.VIEWLET_ID=void 0,e.getStateLabel=m,e.isFrameDeemphasized=I,T=Ve(T),e.VIEWLET_ID="workbench.view.debug",e.VARIABLES_VIEW_ID="workbench.debug.variablesView",e.WATCH_VIEW_ID="workbench.debug.watchExpressionsView",e.CALLSTACK_VIEW_ID="workbench.debug.callStackView",e.LOADED_SCRIPTS_VIEW_ID="workbench.debug.loadedScriptsView",e.BREAKPOINTS_VIEW_ID="workbench.debug.breakPointsView",e.DISASSEMBLY_VIEW_ID="workbench.debug.disassemblyView",e.DEBUG_PANEL_ID="workbench.panel.repl",e.REPL_VIEW_ID="workbench.panel.repl.view",e.CONTEXT_DEBUG_TYPE=new D.RawContextKey("debugType",void 0,{type:"string",description:T.localize(5734,null)}),e.CONTEXT_DEBUG_CONFIGURATION_TYPE=new D.RawContextKey("debugConfigurationType",void 0,{type:"string",description:T.localize(5735,null)}),e.CONTEXT_DEBUG_STATE=new D.RawContextKey("debugState","inactive",{type:"string",description:T.localize(5736,null)}),e.CONTEXT_DEBUG_UX_KEY="debugUx",e.CONTEXT_DEBUG_UX=new D.RawContextKey(e.CONTEXT_DEBUG_UX_KEY,"default",{type:"string",description:T.localize(5737,null)}),e.CONTEXT_HAS_DEBUGGED=new D.RawContextKey("hasDebugged",!1,{type:"boolean",description:T.localize(5738,null)}),e.CONTEXT_IN_DEBUG_MODE=new D.RawContextKey("inDebugMode",!1,{type:"boolean",description:T.localize(5739,null)}),e.CONTEXT_IN_DEBUG_REPL=new D.RawContextKey("inDebugRepl",!1,{type:"boolean",description:T.localize(5740,null)}),e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=new D.RawContextKey("breakpointWidgetVisible",!1,{type:"boolean",description:T.localize(5741,null)}),e.CONTEXT_IN_BREAKPOINT_WIDGET=new D.RawContextKey("inBreakpointWidget",!1,{type:"boolean",description:T.localize(5742,null)}),e.CONTEXT_BREAKPOINTS_FOCUSED=new D.RawContextKey("breakpointsFocused",!0,{type:"boolean",description:T.localize(5743,null)}),e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=new D.RawContextKey("watchExpressionsFocused",!0,{type:"boolean",description:T.localize(5744,null)}),e.CONTEXT_WATCH_EXPRESSIONS_EXIST=new D.RawContextKey("watchExpressionsExist",!1,{type:"boolean",description:T.localize(5745,null)}),e.CONTEXT_VARIABLES_FOCUSED=new D.RawContextKey("variablesFocused",!0,{type:"boolean",description:T.localize(5746,null)}),e.CONTEXT_EXPRESSION_SELECTED=new D.RawContextKey("expressionSelected",!1,{type:"boolean",description:T.localize(5747,null)}),e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=new D.RawContextKey("breakpointInputFocused",!1,{type:"boolean",description:T.localize(5748,null)}),e.CONTEXT_CALLSTACK_ITEM_TYPE=new D.RawContextKey("callStackItemType",void 0,{type:"string",description:T.localize(5749,null)}),e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=new D.RawContextKey("callStackSessionIsAttach",!1,{type:"boolean",description:T.localize(5750,null)}),e.CONTEXT_CALLSTACK_ITEM_STOPPED=new D.RawContextKey("callStackItemStopped",!1,{type:"boolean",description:T.localize(5751,null)}),e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=new D.RawContextKey("callStackSessionHasOneThread",!1,{type:"boolean",description:T.localize(5752,null)}),e.CONTEXT_WATCH_ITEM_TYPE=new D.RawContextKey("watchItemType",void 0,{type:"string",description:T.localize(5753,null)}),e.CONTEXT_CAN_VIEW_MEMORY=new D.RawContextKey("canViewMemory",void 0,{type:"boolean",description:T.localize(5754,null)}),e.CONTEXT_BREAKPOINT_ITEM_TYPE=new D.RawContextKey("breakpointItemType",void 0,{type:"string",description:T.localize(5755,null)}),e.CONTEXT_BREAKPOINT_ITEM_IS_DATA_BYTES=new D.RawContextKey("breakpointItemBytes",void 0,{type:"boolean",description:T.localize(5756,null)}),e.CONTEXT_BREAKPOINT_HAS_MODES=new D.RawContextKey("breakpointHasModes",!1,{type:"boolean",description:T.localize(5757,null)}),e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=new D.RawContextKey("breakpointSupportsCondition",!1,{type:"boolean",description:T.localize(5758,null)}),e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=new D.RawContextKey("loadedScriptsSupported",!1,{type:"boolean",description:T.localize(5759,null)}),e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=new D.RawContextKey("loadedScriptsItemType",void 0,{type:"string",description:T.localize(5760,null)}),e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=new D.RawContextKey("focusedSessionIsAttach",!1,{type:"boolean",description:T.localize(5761,null)}),e.CONTEXT_FOCUSED_SESSION_IS_NO_DEBUG=new D.RawContextKey("focusedSessionIsNoDebug",!1,{type:"boolean",description:T.localize(5762,null)}),e.CONTEXT_STEP_BACK_SUPPORTED=new D.RawContextKey("stepBackSupported",!1,{type:"boolean",description:T.localize(5763,null)}),e.CONTEXT_RESTART_FRAME_SUPPORTED=new D.RawContextKey("restartFrameSupported",!1,{type:"boolean",description:T.localize(5764,null)}),e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=new D.RawContextKey("stackFrameSupportsRestart",!1,{type:"boolean",description:T.localize(5765,null)}),e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=new D.RawContextKey("jumpToCursorSupported",!1,{type:"boolean",description:T.localize(5766,null)}),e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=new D.RawContextKey("stepIntoTargetsSupported",!1,{type:"boolean",description:T.localize(5767,null)}),e.CONTEXT_BREAKPOINTS_EXIST=new D.RawContextKey("breakpointsExist",!1,{type:"boolean",description:T.localize(5768,null)}),e.CONTEXT_DEBUGGERS_AVAILABLE=new D.RawContextKey("debuggersAvailable",!1,{type:"boolean",description:T.localize(5769,null)}),e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=new D.RawContextKey("debugExtensionAvailable",!0,{type:"boolean",description:T.localize(5770,null)}),e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=new D.RawContextKey("debugProtocolVariableMenuContext",void 0,{type:"string",description:T.localize(5771,null)}),e.CONTEXT_SET_VARIABLE_SUPPORTED=new D.RawContextKey("debugSetVariableSupported",!1,{type:"boolean",description:T.localize(5772,null)}),e.CONTEXT_SET_DATA_BREAKPOINT_BYTES_SUPPORTED=new D.RawContextKey("debugSetDataBreakpointAddressSupported",!1,{type:"boolean",description:T.localize(5773,null)}),e.CONTEXT_SET_EXPRESSION_SUPPORTED=new D.RawContextKey("debugSetExpressionSupported",!1,{type:"boolean",description:T.localize(5774,null)}),e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=new D.RawContextKey("breakWhenValueChangesSupported",!1,{type:"boolean",description:T.localize(5775,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=new D.RawContextKey("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:T.localize(5776,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=new D.RawContextKey("breakWhenValueIsReadSupported",!1,{type:"boolean",description:T.localize(5777,null)}),e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=new D.RawContextKey("terminateDebuggeeSupported",!1,{type:"boolean",description:T.localize(5778,null)}),e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=new D.RawContextKey("suspendDebuggeeSupported",!1,{type:"boolean",description:T.localize(5779,null)}),e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=new D.RawContextKey("variableEvaluateNamePresent",!1,{type:"boolean",description:T.localize(5780,null)}),e.CONTEXT_VARIABLE_IS_READONLY=new D.RawContextKey("variableIsReadonly",!1,{type:"boolean",description:T.localize(5781,null)}),e.CONTEXT_VARIABLE_VALUE=new D.RawContextKey("variableValue",!1,{type:"string",description:T.localize(5782,null)}),e.CONTEXT_VARIABLE_TYPE=new D.RawContextKey("variableType",!1,{type:"string",description:T.localize(5783,null)}),e.CONTEXT_VARIABLE_INTERFACES=new D.RawContextKey("variableInterfaces",!1,{type:"array",description:T.localize(5784,null)}),e.CONTEXT_VARIABLE_NAME=new D.RawContextKey("variableName",!1,{type:"string",description:T.localize(5785,null)}),e.CONTEXT_VARIABLE_LANGUAGE=new D.RawContextKey("variableLanguage",!1,{type:"string",description:T.localize(5786,null)}),e.CONTEXT_VARIABLE_EXTENSIONID=new D.RawContextKey("variableExtensionId",!1,{type:"string",description:T.localize(5787,null)}),e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=new D.RawContextKey("exceptionWidgetVisible",!1,{type:"boolean",description:T.localize(5788,null)}),e.CONTEXT_MULTI_SESSION_REPL=new D.RawContextKey("multiSessionRepl",!1,{type:"boolean",description:T.localize(5789,null)}),e.CONTEXT_MULTI_SESSION_DEBUG=new D.RawContextKey("multiSessionDebug",!1,{type:"boolean",description:T.localize(5790,null)}),e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=new D.RawContextKey("disassembleRequestSupported",!1,{type:"boolean",description:T.localize(5791,null)}),e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=new D.RawContextKey("disassemblyViewFocus",!1,{type:"boolean",description:T.localize(5792,null)}),e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=new D.RawContextKey("languageSupportsDisassembleRequest",!1,{type:"boolean",description:T.localize(5793,null)}),e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=new D.RawContextKey("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:T.localize(5794,null)});const k=i=>T.localize(5795,null,i);e.debuggerDisabledMessage=k,e.EDITOR_CONTRIBUTION_ID="editor.contrib.debug",e.BREAKPOINT_EDITOR_CONTRIBUTION_ID="editor.contrib.breakpoint",e.DEBUG_SCHEME="debug",e.INTERNAL_CONSOLE_OPTIONS_SCHEMA={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:T.localize(5796,null)};var A;(function(i){i[i.Inactive=0]="Inactive",i[i.Initializing=1]="Initializing",i[i.Stopped=2]="Stopped",i[i.Running=3]="Running"})(A||(e.State=A={}));function m(i){switch(i){case A.Initializing:return"initializing";case A.Stopped:return"stopped";case A.Running:return"running";default:return"inactive"}}var s;(function(i){i[i.Valid=0]="Valid",i[i.Unreadable=1]="Unreadable",i[i.Error=2]="Error"})(s||(e.MemoryRangeType=s={})),e.DEBUG_MEMORY_SCHEME="vscode-debug-memory";function I(i){const n=i.presentationHint??i.source.presentationHint;return n==="deemphasize"||n==="subtle"}var E;(function(i){i[i.Variable=0]="Variable",i[i.Address=1]="Address"})(E||(e.DataBreakpointSetType=E={}));var u;(function(i){i[i.Initial=1]="Initial",i[i.Dynamic=2]="Dynamic"})(u||(e.DebugConfigurationProviderTriggerKind=u={}));var C;(function(i){i.UnverifiedBreakpoints="unverifiedBreakpoints"})(C||(e.DebuggerString=C={})),e.IDebugService=(0,O.createDecorator)("debugService");var v;(function(i){i[i.CONDITION=0]="CONDITION",i[i.HIT_COUNT=1]="HIT_COUNT",i[i.LOG_MESSAGE=2]="LOG_MESSAGE",i[i.TRIGGER_POINT=3]="TRIGGER_POINT"})(v||(e.BreakpointWidgetContext=v={}));var r;(function(i){i[i.Command=0]="Command",i[i.Tree=1]="Tree"})(r||(e.DebugVisualizationType=r={}));var a;(function(i){i[i.None=0]="None",i[i.Collapsed=1]="Collapsed",i[i.Expanded=2]="Expanded"})(a||(e.DebugTreeItemCollapsibleState=a={}));var d;(function(i){i.deserialize=n=>n,i.serialize=n=>n})(d||(e.IDebugVisualizationTreeItem=d={}));var l;(function(i){i.deserialize=n=>({id:n.id,name:n.name,iconPath:n.iconPath&&{light:S.URI.revive(n.iconPath.light),dark:S.URI.revive(n.iconPath.dark)},iconClass:n.iconClass,visualization:n.visualization}),i.serialize=n=>n})(l||(e.IDebugVisualization=l={}))}),define(ke[196],Re([1,0,13,2,22,25,15,32,19,17]),function(Ee,e,S,T,D,O,k,A,m,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sourcesEqual=void 0,e.formatPII=E,e.filterExceptionsFromTelemetry=u,e.isSessionAttach=C,e.getExtensionHostDebugSession=v,e.isDebuggerMainContribution=r,e.getExactExpressionStartAndEnd=a,e.getEvaluatableExpressionAtPosition=d,e.isUri=i,e.convertToDAPaths=o,e.convertToVSCPaths=c,e.getVisibleAndSorted=f,e.saveAllBeforeDebugStart=_;const I=/{([^}]+)}/g;function E(w,P,R){return w.replace(I,function(p,b){return P&&b.length>0&&b[0]!=="_"?p:R&&R.hasOwnProperty(b)?R[b]:p})}function u(w){const P={};for(const R of Object.keys(w))R.startsWith("!")||(P[R]=w[R]);return P}function C(w){return w.configuration.request==="attach"&&!v(w)&&(!w.parentSession||C(w.parentSession))}function v(w){let P=w.configuration.type;if(P)return P==="vslsShare"&&(P=w.configuration.adapterProxy.configuration.type),(0,S.equalsIgnoreCase)(P,"extensionhost")||(0,S.equalsIgnoreCase)(P,"pwa-extensionhost")?w:w.parentSession?v(w.parentSession):void 0}function r(w){return w.type&&(w.label||w.program||w.runtime)}function a(w,P,R){let p,b=0;const N=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let L=null;for(;L=N.exec(w);){const F=L.index+1,K=F+L[0].length;if(F<=P&&K>=R){p=L[0],b=F;break}}if(p){const F=/(\w|\p{L})+/gu;let K=null;for(;(K=F.exec(p))&&!(K.index+1+b+K[0].length>=R););K&&(p=p.substring(0,F.lastIndex))}return p?{start:b,end:b+p.length-1}:{start:0,end:0}}async function d(w,P,R,p){if(w.evaluatableExpressionProvider.has(P)){const b=w.evaluatableExpressionProvider.ordered(P),N=(0,s.coalesce)(await Promise.all(b.map(async L=>{try{return await L.provideEvaluatableExpression(P,R,p??m.CancellationToken.None)}catch{return}})));if(N.length>0){let L=N[0].expression;const F=N[0].range;return L||(L=P.getLineContent(R.lineNumber).substring(F.startColumn-1,F.endColumn-1)),{range:F,matchingExpression:L}}}else{const b=P.getLineContent(R.lineNumber),{start:N,end:L}=a(b,R.column,R.column),F=b.substring(N-1,L);return{matchingExpression:F,range:new A.Range(R.lineNumber,N,R.lineNumber,N+F.length)}}return null}const l=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function i(w){return!!(w&&w.match(l))}function n(w){if(typeof w.path=="string"&&!(typeof w.sourceReference=="number"&&w.sourceReference>0)){if(i(w.path))return T.URI.parse(w.path);if((0,D.isAbsolute)(w.path))return T.URI.file(w.path)}return w.path}function t(w){if(typeof w.path=="object"){const P=T.URI.revive(w.path);if(P)return P.scheme===k.Schemas.file?P.fsPath:P.toString()}return w.path}function o(w,P){const R=P?n:t,p=(0,O.deepClone)(w);return g(p,(b,N)=>{b&&N&&(N.path=R(N))}),p}function c(w,P){const R=P?n:t,p=(0,O.deepClone)(w);return g(p,(b,N)=>{!b&&N&&(N.path=R(N))}),p}function g(w,P){switch(w.type){case"event":{const R=w;switch(R.event){case"output":P(!1,R.body.source);break;case"loadedSource":P(!1,R.body.source);break;case"breakpoint":P(!1,R.body.breakpoint.source);break;default:break}break}case"request":{const R=w;switch(R.command){case"setBreakpoints":P(!0,R.arguments.source);break;case"breakpointLocations":P(!0,R.arguments.source);break;case"source":P(!0,R.arguments.source);break;case"gotoTargets":P(!0,R.arguments.source);break;case"launchVSCode":R.arguments.args.forEach(p=>P(!1,p));break;default:break}break}case"response":{const R=w;if(R.success&&R.body)switch(R.command){case"stackTrace":R.body.stackFrames.forEach(p=>P(!1,p.source));break;case"loadedSources":R.body.sources.forEach(p=>P(!1,p));break;case"scopes":R.body.scopes.forEach(p=>P(!1,p.source));break;case"setFunctionBreakpoints":R.body.breakpoints.forEach(p=>P(!1,p.source));break;case"setBreakpoints":R.body.breakpoints.forEach(p=>P(!1,p.source));break;case"disassemble":R.body?.instructions.forEach(b=>P(!1,b.location));break;case"locations":P(!1,R.body?.source);break;default:break}break}}}function f(w){return w.filter(P=>!P.presentation?.hidden).sort((P,R)=>P.presentation?R.presentation?P.presentation.group?R.presentation.group?P.presentation.group!==R.presentation.group?P.presentation.group.localeCompare(R.presentation.group):h(P.presentation.order,R.presentation.order):-1:R.presentation.group?1:h(P.presentation.order,R.presentation.order):-1:R.presentation?1:0)}function h(w,P){return typeof w!="number"?typeof P!="number"?0:1:typeof P!="number"?-1:w-P}async function _(w,P){const R=w.getValue("debug.saveBeforeStart",{overrideIdentifier:P.activeTextEditorLanguageId});if(R!=="none"&&(await P.saveAll(),R==="allEditorsInActiveGroup")){const p=P.activeEditorPane;p&&p.input.resource?.scheme===k.Schemas.untitled&&await P.save({editor:p.input,groupId:p.group.id})}await w.reloadConfiguration()}const y=(w,P)=>!w||!P?w===P:w.name===P.name&&w.path===P.path&&w.sourceReference===P.sourceReference;e.sourcesEqual=y}),define(ke[197],Re([1,0,3]),function(Ee,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var T;(function(D){D[D.Output=1]="Output",D[D.OutputItems=2]="OutputItems",D[D.ExecutionState=3]="ExecutionState"})(T||(e.CellExecutionUpdateType=T={})),e.INotebookExecutionService=(0,S.createDecorator)("INotebookExecutionService")}),define(ke[198],Re([1,0,3]),function(Ee,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookKernelHistoryService=e.INotebookKernelService=e.ProxyKernelState=e.variablePageSize=void 0,e.variablePageSize=100;var T;(function(D){D[D.Disconnected=1]="Disconnected",D[D.Connected=2]="Connected",D[D.Initializing=3]="Initializing"})(T||(e.ProxyKernelState=T={})),e.INotebookKernelService=(0,S.createDecorator)("INotebookKernelService"),e.INotebookKernelHistoryService=(0,S.createDecorator)("INotebookKernelHistoryService")}),define(ke[199],Re([1,0,4,32,52,166,102]),function(Ee,e,S,T,D,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CellSearchModel=void 0;class A extends S.Disposable{constructor(s,I,E){super(),this._source=s,this._inputTextBuffer=I,this._outputs=E,this._outputTextBuffers=void 0}_getFullModelRange(s){const I=s.getLineCount();return new T.Range(1,1,I,this._getLineMaxColumn(s,I))}_getLineMaxColumn(s,I){if(I<1||I>s.getLineCount())throw new Error("Illegal value for lineNumber");return s.getLineLength(I)+1}get inputTextBuffer(){if(!this._inputTextBuffer){const s=new O.PieceTreeTextBufferBuilder;s.acceptChunk(this._source);const I=s.finish(!0),{textBuffer:E,disposable:u}=I.create(D.DefaultEndOfLine.LF);this._inputTextBuffer=E,this._register(u)}return this._inputTextBuffer}get outputTextBuffers(){return this._outputTextBuffers||(this._outputTextBuffers=this._outputs.map(s=>{const I=new O.PieceTreeTextBufferBuilder;I.acceptChunk(s);const E=I.finish(!0),{textBuffer:u,disposable:C}=E.create(D.DefaultEndOfLine.LF);return this._register(C),u})),this._outputTextBuffers}findInInputs(s){const E=new k.SearchParams(s,!1,!1,null).parseSearchRequest();if(!E)return[];const u=this._getFullModelRange(this.inputTextBuffer);return this.inputTextBuffer.findMatchesLineByLine(u,E,!0,5e3)}findInOutputs(s){const E=new k.SearchParams(s,!1,!1,null).parseSearchRequest();return E?this.outputTextBuffers.map(u=>{const C=u.findMatchesLineByLine(this._getFullModelRange(u),E,!0,5e3);if(C.length!==0)return{textBuffer:u,matches:C}}).filter(u=>!!u):[]}}e.CellSearchModel=A}),define(ke[54],Re([1,0]),function(Ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var S;(function(O){O.Delimiter="\0"})(S||(e.TestIdPathParts=S={}));var T;(function(O){O[O.IsSame=0]="IsSame",O[O.Disconnected=1]="Disconnected",O[O.IsChild=2]="IsChild",O[O.IsParent=3]="IsParent"})(T||(e.TestPosition=T={}));class D{static fromExtHostTestItem(k,A,m=k.parent){if(k._isRoot)return new D([A]);const s=[k.id];for(let I=m;I&&I.id!==A;I=I.parent)s.push(I.id);return s.push(A),new D(s.reverse())}static isRoot(k){return!k.includes(S.Delimiter)}static root(k){const A=k.indexOf(S.Delimiter);return A===-1?k:k.slice(0,A)}static fromString(k){return new D(k.split(S.Delimiter))}static join(k,A){return new D([...k.path,A])}static joinToString(k,A){return k.toString()+S.Delimiter+A}static parentId(k){const A=k.lastIndexOf(S.Delimiter);return A===-1?void 0:k.slice(0,A)}static localId(k){const A=k.lastIndexOf(S.Delimiter);return A===-1?k:k.slice(A+S.Delimiter.length)}static isChild(k,A){return A[k.length]===S.Delimiter&&A.startsWith(k)}static compare(k,A){return k===A?T.IsSame:D.isChild(k,A)?T.IsChild:D.isChild(A,k)?T.IsParent:T.Disconnected}static getLengthOfCommonPrefix(k,A){if(k===0)return 0;let m=0;for(;m<k-1;){for(let s=1;s<k;s++){const I=A(s-1),E=A(s);if(I.path[m]!==E.path[m])return m}m++}return m}constructor(k,A=k.length){if(this.path=k,this.viewEnd=A,k.length===0||A<1)throw new Error("cannot create test with empty path")}get rootId(){return new D(this.path,1)}get parentId(){return this.viewEnd>1?new D(this.path,this.viewEnd-1):void 0}get localId(){return this.path[this.viewEnd-1]}get controllerId(){return this.path[0]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){for(let k=1;k<=this.viewEnd;k++)yield new D(this.path,k)}*idsToRoot(){for(let k=this.viewEnd;k>0;k--)yield new D(this.path,k)}compare(k){if(typeof k=="string")return D.compare(this.toString(),k);for(let A=0;A<k.viewEnd&&A<this.viewEnd;A++)if(k.path[A]!==this.path[A])return T.Disconnected;return k.viewEnd>this.viewEnd?T.IsChild:k.viewEnd<this.viewEnd?T.IsParent:T.IsSame}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let k=1;k<this.viewEnd;k++)this.stringifed+=S.Delimiter,this.stringifed+=this.path[k]}return this.stringifed}}e.TestId=D}),define(ke[55],Re([1,0,2,101,32,54]),function(Ee,e,S,T,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.TestsDiffOp=e.TestDiffOpType=e.IStatementCoverage=e.IDeclarationCoverage=e.IBranchCoverage=e.CoverageDetails=e.DetailType=e.KEEP_N_LAST_COVERAGE_REPORTS=e.IFileCoverage=e.ICoverageCount=e.TestResultItem=e.applyTestItemUpdate=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.denamespaceTestTag=e.namespaceTestTag=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.getMarkId=e.ITestErrorMessage=e.ITestMessageStackFrame=e.TestMessageType=e.IRichLocation=e.isStartControllerTests=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestControllerCapability=e.ExtTestRunProfileKind=e.testResultStateToContextValues=e.TestResultState=void 0;var k;(function(x){x[x.Unset=0]="Unset",x[x.Queued=1]="Queued",x[x.Running=2]="Running",x[x.Passed=3]="Passed",x[x.Failed=4]="Failed",x[x.Skipped=5]="Skipped",x[x.Errored=6]="Errored"})(k||(e.TestResultState=k={})),e.testResultStateToContextValues={[k.Unset]:"unset",[k.Queued]:"queued",[k.Running]:"running",[k.Passed]:"passed",[k.Failed]:"failed",[k.Skipped]:"skipped",[k.Errored]:"errored"};var A;(function(x){x[x.Run=1]="Run",x[x.Debug=2]="Debug",x[x.Coverage=3]="Coverage"})(A||(e.ExtTestRunProfileKind=A={}));var m;(function(x){x[x.Refresh=2]="Refresh",x[x.CodeRelatedToTest=4]="CodeRelatedToTest",x[x.TestRelatedToCode=8]="TestRelatedToCode"})(m||(e.TestControllerCapability=m={}));var s;(function(x){x[x.Run=2]="Run",x[x.Debug=4]="Debug",x[x.Coverage=8]="Coverage",x[x.HasNonDefaultProfile=16]="HasNonDefaultProfile",x[x.HasConfigurable=32]="HasConfigurable",x[x.SupportsContinuousRun=64]="SupportsContinuousRun"})(s||(e.TestRunProfileBitset=s={})),e.testRunProfileBitsetList=[s.Run,s.Debug,s.Coverage,s.HasNonDefaultProfile,s.HasConfigurable,s.SupportsContinuousRun];const I=x=>"runId"in x;e.isStartControllerTests=I;var E;(function(x){x.serialize=G=>({range:G.range.toJSON(),uri:G.uri.toJSON()}),x.deserialize=(G,Y)=>({range:D.Range.lift(Y.range),uri:G.asCanonicalUri(S.URI.revive(Y.uri))})})(E||(e.IRichLocation=E={}));var u;(function(x){x[x.Error=0]="Error",x[x.Output=1]="Output"})(u||(e.TestMessageType=u={}));var C;(function(x){x.serialize=G=>({label:G.label,uri:G.uri?.toJSON(),position:G.position?.toJSON()}),x.deserialize=(G,Y)=>({label:Y.label,uri:Y.uri?G.asCanonicalUri(S.URI.revive(Y.uri)):void 0,position:Y.position?T.Position.lift(Y.position):void 0})})(C||(e.ITestMessageStackFrame=C={}));var v;(function(x){x.serialize=G=>({message:G.message,type:u.Error,expected:G.expected,actual:G.actual,contextValue:G.contextValue,location:G.location&&E.serialize(G.location),stackTrace:G.stackTrace?.map(C.serialize)}),x.deserialize=(G,Y)=>({message:Y.message,type:u.Error,expected:Y.expected,actual:Y.actual,contextValue:Y.contextValue,location:Y.location&&E.deserialize(G,Y.location),stackTrace:Y.stackTrace&&Y.stackTrace.map(ae=>C.deserialize(G,ae))})})(v||(e.ITestErrorMessage=v={}));const r=(x,G)=>`${G?"s":"e"}${x}`;e.getMarkId=r;var a;(function(x){x.serialize=G=>({message:G.message,type:u.Output,offset:G.offset,length:G.length,location:G.location&&E.serialize(G.location)}),x.deserialize=(G,Y)=>({message:Y.message,type:u.Output,offset:Y.offset,length:Y.length,location:Y.location&&E.deserialize(G,Y.location)})})(a||(e.ITestOutputMessage=a={}));var d;(function(x){x.serialize=G=>G.type===u.Error?v.serialize(G):a.serialize(G),x.deserialize=(G,Y)=>Y.type===u.Error?v.deserialize(G,Y):a.deserialize(G,Y),x.isDiffable=G=>G.type===u.Error&&G.actual!==void 0&&G.expected!==void 0})(d||(e.ITestMessage=d={}));var l;(function(x){x.serializeWithoutMessages=G=>({state:G.state,duration:G.duration,messages:[]}),x.serialize=G=>({state:G.state,duration:G.duration,messages:G.messages.map(d.serialize)}),x.deserialize=(G,Y)=>({state:Y.state,duration:Y.duration,messages:Y.messages.map(ae=>d.deserialize(G,ae))})})(l||(e.ITestTaskState=l={}));const i="\0",n=(x,G)=>x+i+G;e.namespaceTestTag=n;const t=x=>{const G=x.indexOf(i);return{ctrlId:x.slice(0,G),tagId:x.slice(G+1)}};e.denamespaceTestTag=t;var o;(function(x){x.serialize=G=>({extId:G.extId,label:G.label,tags:G.tags,busy:G.busy,children:void 0,uri:G.uri?.toJSON(),range:G.range?.toJSON()||null,description:G.description,error:G.error,sortText:G.sortText}),x.deserialize=(G,Y)=>({extId:Y.extId,label:Y.label,tags:Y.tags,busy:Y.busy,children:void 0,uri:Y.uri?G.asCanonicalUri(S.URI.revive(Y.uri)):void 0,range:Y.range?D.Range.lift(Y.range):null,description:Y.description,error:Y.error,sortText:Y.sortText})})(o||(e.ITestItem=o={}));var c;(function(x){x[x.NotExpandable=0]="NotExpandable",x[x.Expandable=1]="Expandable",x[x.BusyExpanding=2]="BusyExpanding",x[x.Expanded=3]="Expanded"})(c||(e.TestItemExpandState=c={}));var g;(function(x){x.serialize=G=>({expand:G.expand,item:o.serialize(G.item)}),x.deserialize=(G,Y)=>({controllerId:O.TestId.root(Y.item.extId),expand:Y.expand,item:o.deserialize(G,Y.item)})})(g||(e.InternalTestItem=g={}));var f;(function(x){x.serialize=G=>{let Y;return G.item&&(Y={},G.item.label!==void 0&&(Y.label=G.item.label),G.item.tags!==void 0&&(Y.tags=G.item.tags),G.item.busy!==void 0&&(Y.busy=G.item.busy),G.item.uri!==void 0&&(Y.uri=G.item.uri?.toJSON()),G.item.range!==void 0&&(Y.range=G.item.range?.toJSON()),G.item.description!==void 0&&(Y.description=G.item.description),G.item.error!==void 0&&(Y.error=G.item.error),G.item.sortText!==void 0&&(Y.sortText=G.item.sortText)),{extId:G.extId,expand:G.expand,item:Y}},x.deserialize=G=>{let Y;return G.item&&(Y={},G.item.label!==void 0&&(Y.label=G.item.label),G.item.tags!==void 0&&(Y.tags=G.item.tags),G.item.busy!==void 0&&(Y.busy=G.item.busy),G.item.range!==void 0&&(Y.range=G.item.range?D.Range.lift(G.item.range):null),G.item.description!==void 0&&(Y.description=G.item.description),G.item.error!==void 0&&(Y.error=G.item.error),G.item.sortText!==void 0&&(Y.sortText=G.item.sortText)),{extId:G.extId,expand:G.expand,item:Y}}})(f||(e.ITestItemUpdate=f={}));const h=(x,G)=>{G.expand!==void 0&&(x.expand=G.expand),G.item!==void 0&&(x.item=x.item?Object.assign(x.item,G.item):G.item)};e.applyTestItemUpdate=h;var _;(function(x){x.serializeWithoutMessages=G=>({...g.serialize(G),ownComputedState:G.ownComputedState,computedState:G.computedState,tasks:G.tasks.map(l.serializeWithoutMessages)}),x.serialize=G=>({...g.serialize(G),ownComputedState:G.ownComputedState,computedState:G.computedState,tasks:G.tasks.map(l.serialize)}),x.deserialize=(G,Y)=>({...g.deserialize(G,Y),ownComputedState:Y.ownComputedState,computedState:Y.computedState,tasks:Y.tasks.map(ae=>l.deserialize(G,ae)),retired:!0})})(_||(e.TestResultItem=_={}));var y;(function(x){x.empty=()=>({covered:0,total:0}),x.sum=(G,Y)=>{G.covered+=Y.covered,G.total+=Y.total}})(y||(e.ICoverageCount=y={}));var w;(function(x){x.serialize=G=>({id:G.id,statement:G.statement,branch:G.branch,declaration:G.declaration,testIds:G.testIds,uri:G.uri.toJSON()}),x.deserialize=(G,Y)=>({id:Y.id,statement:Y.statement,branch:Y.branch,declaration:Y.declaration,testIds:Y.testIds,uri:G.asCanonicalUri(S.URI.revive(Y.uri))}),x.empty=(G,Y)=>({id:G,uri:Y,statement:y.empty()})})(w||(e.IFileCoverage=w={}));function P(x){return{...x,location:x.location?.toJSON()}}function R(x){return x.location=x.location?T.Position.isIPosition(x.location)?T.Position.lift(x.location):D.Range.lift(x.location):void 0,x}e.KEEP_N_LAST_COVERAGE_REPORTS=3;var p;(function(x){x[x.Declaration=0]="Declaration",x[x.Statement=1]="Statement",x[x.Branch=2]="Branch"})(p||(e.DetailType=p={}));var b;(function(x){x.serialize=G=>G.type===p.Declaration?L.serialize(G):F.serialize(G),x.deserialize=G=>G.type===p.Declaration?L.deserialize(G):F.deserialize(G)})(b||(e.CoverageDetails=b={}));var N;(function(x){x.serialize=P,x.deserialize=R})(N||(e.IBranchCoverage=N={}));var L;(function(x){x.serialize=P,x.deserialize=R})(L||(e.IDeclarationCoverage=L={}));var F;(function(x){x.serialize=G=>({...P(G),branches:G.branches?.map(N.serialize)}),x.deserialize=G=>({...R(G),branches:G.branches?.map(N.deserialize)})})(F||(e.IStatementCoverage=F={}));var K;(function(x){x[x.Add=0]="Add",x[x.Update=1]="Update",x[x.DocumentSynced=2]="DocumentSynced",x[x.Remove=3]="Remove",x[x.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",x[x.Retire=5]="Retire",x[x.AddTag=6]="AddTag",x[x.RemoveTag=7]="RemoveTag"})(K||(e.TestDiffOpType=K={}));var J;(function(x){x.deserialize=(G,Y)=>Y.op===K.Add?{op:Y.op,item:g.deserialize(G,Y.item)}:Y.op===K.Update?{op:Y.op,item:f.deserialize(Y.item)}:Y.op===K.DocumentSynced?{op:Y.op,uri:G.asCanonicalUri(S.URI.revive(Y.uri)),docv:Y.docv}:Y,x.serialize=G=>G.op===K.Add?{op:G.op,item:g.serialize(G.item)}:G.op===K.Update?{op:G.op,item:f.serialize(G.item)}:G})(J||(e.TestsDiffOp=J={}));class ${constructor(G){this.uriIdentity=G,this._tags=new Map,this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0,this.tags=this._tags}apply(G){const Y=this.createChangeCollector();for(const ae of G)switch(ae.op){case K.Add:this.add(g.deserialize(this.uriIdentity,ae.item),Y);break;case K.Update:this.update(f.deserialize(ae.item),Y);break;case K.Remove:this.remove(ae.itemId,Y);break;case K.Retire:this.retireTest(ae.itemId);break;case K.IncrementPendingExtHosts:this.updatePendingRoots(ae.amount);break;case K.AddTag:this._tags.set(ae.tag.id,ae.tag);break;case K.RemoveTag:this._tags.delete(ae.id);break}Y.complete?.()}add(G,Y){const ae=O.TestId.parentId(G.item.extId)?.toString();let ee;if(!ae)ee=this.createItem(G),this.roots.add(ee),this.items.set(G.item.extId,ee);else if(this.items.has(ae)){const oe=this.items.get(ae);oe.children.add(G.item.extId),ee=this.createItem(G,oe),this.items.set(G.item.extId,ee)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(G)}`);return}return Y.add?.(ee),G.expand===c.BusyExpanding&&this.busyControllerCount++,ee}update(G,Y){const ae=this.items.get(G.extId);if(ae)return G.expand!==void 0&&(ae.expand===c.BusyExpanding&&this.busyControllerCount--,G.expand===c.BusyExpanding&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(ae,G),Y.update?.(ae),ae}remove(G,Y){const ae=this.items.get(G);if(!ae)return;const ee=O.TestId.parentId(ae.item.extId)?.toString();ee?this.items.get(ee).children.delete(ae.item.extId):this.roots.delete(ae);const oe=[[G]];for(;oe.length;)for(const ie of oe.pop()){const ue=this.items.get(ie);ue&&(oe.push(ue.children),this.items.delete(ie),Y.remove?.(ue,ue!==ae),ue.expand===c.BusyExpanding&&this.busyControllerCount--)}}retireTest(G){}updatePendingRoots(G){this.pendingRootCount+=G}createChangeCollector(){return{}}}e.AbstractIncrementalTestCollection=$}),define(ke[200],Re([1,0,99,9,55]),function(Ee,e,S,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestCommandId=e.testConfigurationGroupNames=e.labelForTestInState=e.TestExplorerViewSorting=e.TestExplorerViewMode=e.Testing=void 0;var O;(function(E){E.ViewletId="workbench.view.extension.test",E.ExplorerViewId="workbench.view.testing",E.OutputPeekContributionId="editor.contrib.testingOutputPeek",E.DecorationsContributionId="editor.contrib.testingDecorations",E.CoverageDecorationsContributionId="editor.contrib.coverageDecorations",E.CoverageViewId="workbench.view.testCoverage",E.ResultsPanelId="workbench.panel.testResults",E.ResultsViewId="workbench.panel.testResults.view",E.MessageLanguageId="vscodeInternalTestMessage"})(O||(e.Testing=O={}));var k;(function(E){E.List="list",E.Tree="true"})(k||(e.TestExplorerViewMode=k={}));var A;(function(E){E.ByLocation="location",E.ByStatus="status",E.ByDuration="duration"})(A||(e.TestExplorerViewSorting=A={}));const m={[D.TestResultState.Errored]:(0,T.localize)(10839,null),[D.TestResultState.Failed]:(0,T.localize)(10840,null),[D.TestResultState.Passed]:(0,T.localize)(10841,null),[D.TestResultState.Queued]:(0,T.localize)(10842,null),[D.TestResultState.Running]:(0,T.localize)(10843,null),[D.TestResultState.Skipped]:(0,T.localize)(10844,null),[D.TestResultState.Unset]:(0,T.localize)(10845,null)},s=(E,u)=>(0,T.localize)(10846,null,(0,S.stripIcons)(E),m[u]);e.labelForTestInState=s,e.testConfigurationGroupNames={[D.TestRunProfileBitset.Debug]:(0,T.localize)(10847,null),[D.TestRunProfileBitset.Run]:(0,T.localize)(10848,null),[D.TestRunProfileBitset.Coverage]:(0,T.localize)(10849,null)};var I;(function(E){E.CancelTestRefreshAction="testing.cancelTestRefresh",E.CancelTestRunAction="testing.cancelRun",E.ClearTestResultsAction="testing.clearTestResults",E.CollapseAllAction="testing.collapseAll",E.ConfigureTestProfilesAction="testing.configureProfile",E.ContinousRunUsingForTest="testing.continuousRunUsingForTest",E.CoverageAtCursor="testing.coverageAtCursor",E.CoverageByUri="testing.coverage.uri",E.CoverageClear="testing.coverage.close",E.CoverageCurrentFile="testing.coverageCurrentFile",E.CoverageFilterToTest="testing.coverageFilterToTest",E.CoverageFilterToTestInEditor="testing.coverageFilterToTestInEditor",E.CoverageLastRun="testing.coverageLastRun",E.CoverageSelectedAction="testing.coverageSelected",E.CoverageToggleToolbar="testing.coverageToggleToolbar",E.CoverageViewChangeSorting="testing.coverageViewChangeSorting",E.DebugAction="testing.debug",E.DebugAllAction="testing.debugAll",E.DebugAtCursor="testing.debugAtCursor",E.DebugByUri="testing.debug.uri",E.DebugCurrentFile="testing.debugCurrentFile",E.DebugFailedTests="testing.debugFailTests",E.DebugLastRun="testing.debugLastRun",E.DebugSelectedAction="testing.debugSelected",E.FilterAction="workbench.actions.treeView.testExplorer.filter",E.GetExplorerSelection="_testing.getExplorerSelection",E.GetSelectedProfiles="testing.getSelectedProfiles",E.GoToTest="testing.editFocusedTest",E.GoToRelatedTest="testing.goToRelatedTest",E.PeekRelatedTest="testing.peekRelatedTest",E.GoToRelatedCode="testing.goToRelatedCode",E.PeekRelatedCode="testing.peekRelatedCode",E.HideTestAction="testing.hideTest",E.OpenCoverage="testing.openCoverage",E.OpenOutputPeek="testing.openOutputPeek",E.RefreshTestsAction="testing.refreshTests",E.ReRunFailedTests="testing.reRunFailTests",E.ReRunLastRun="testing.reRunLastRun",E.RunAction="testing.run",E.RunAllAction="testing.runAll",E.RunAllWithCoverageAction="testing.coverageAll",E.RunAtCursor="testing.runAtCursor",E.RunByUri="testing.run.uri",E.RunCurrentFile="testing.runCurrentFile",E.RunSelectedAction="testing.runSelected",E.RunUsingProfileAction="testing.runUsing",E.RunWithCoverageAction="testing.coverage",E.SearchForTestExtension="testing.searchForTestExtension",E.SelectDefaultTestProfiles="testing.selectDefaultTestProfiles",E.ShowMostRecentOutputAction="testing.showMostRecentOutput",E.StartContinousRun="testing.startContinuousRun",E.StopContinousRun="testing.stopContinuousRun",E.TestingSortByDurationAction="testing.sortByDuration",E.TestingSortByLocationAction="testing.sortByLocation",E.TestingSortByStatusAction="testing.sortByStatus",E.TestingViewAsListAction="testing.viewAsList",E.TestingViewAsTreeAction="testing.viewAsTree",E.ToggleContinousRunForTest="testing.toggleContinuousRunForTest",E.ToggleInlineTestOutput="testing.toggleInlineTestOutput",E.UnhideAllTestsAction="testing.unhideAllTests",E.UnhideTestAction="testing.unhideTest"})(I||(e.TestCommandId=I={}))}),define(ke[82],Re([1,0,10,6,4,61,55,54]),function(Ee,e,S,T,D,O,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createTestItemChildren=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.TestItemCollection=e.TestItemEventOp=void 0;var m;(function(l){l[l.Upsert=0]="Upsert",l[l.SetTags=1]="SetTags",l[l.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",l[l.RemoveChild=3]="RemoveChild",l[l.SetProp=4]="SetProp",l[l.Bulk=5]="Bulk",l[l.DocumentSynced=6]="DocumentSynced"})(m||(e.TestItemEventOp=m={}));const s=(l,i)=>l===i,E=Object.entries({range:(l,i)=>l===i?!0:!l||!i?!1:l.equalsRange(i),busy:s,label:s,description:s,error:s,sortText:s,tags:(l,i)=>!(l.length!==i.length||l.some(n=>!i.includes(n)))}),u=(l,i)=>{let n;for(const[t,o]of E)o(l[t],i[t])||(n?n[t]=i[t]:n={[t]:i[t]});return n};class C extends D.Disposable{get root(){return this.options.root}constructor(i){super(),this.options=i,this.debounceSendDiff=this._register(new S.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new T.Emitter),this.tree=new Map,this.tags=new Map,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.root.canResolveChildren=!0,this.upsertItem(this.root,void 0)}set resolveHandler(i){this._resolveHandler=i;for(const n of this.tree.values())this.updateExpandability(n)}get resolveHandler(){return this._resolveHandler}collectDiff(){const i=this.diff;return this.diff=[],i}pushDiff(i){switch(i.op){case k.TestDiffOpType.DocumentSynced:{for(const n of this.diff)if(n.op===k.TestDiffOpType.DocumentSynced&&n.uri===i.uri){n.docv=i.docv;return}break}case k.TestDiffOpType.Update:{const n=this.diff[this.diff.length-1];if(n){if(n.op===k.TestDiffOpType.Update&&n.item.extId===i.item.extId){(0,k.applyTestItemUpdate)(n.item,i.item);return}if(n.op===k.TestDiffOpType.Add&&n.item.item.extId===i.item.extId){(0,k.applyTestItemUpdate)(n.item,i.item);return}}break}}this.diff.push(i),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(i,n){const t=this.tree.get(i);if(t){if((t.expandLevels===void 0||n>t.expandLevels)&&(t.expandLevels=n),t.expand===k.TestItemExpandState.Expandable){const o=this.resolveChildren(t);return o.isOpen()?this.expandChildren(t,n-1):o.wait().then(()=>this.expandChildren(t,n-1))}else if(t.expand===k.TestItemExpandState.Expanded)return t.resolveBarrier?.isOpen()===!1?t.resolveBarrier.wait().then(()=>this.expandChildren(t,n-1)):this.expandChildren(t,n-1)}}dispose(){for(const i of this.tree.values())this.options.getApiFor(i.actual).listener=void 0;this.tree.clear(),this.diff=[],super.dispose()}onTestItemEvent(i,n){switch(n.op){case m.RemoveChild:this.removeItem(A.TestId.joinToString(i.fullId,n.id));break;case m.Upsert:this.upsertItem(n.item,i);break;case m.Bulk:for(const t of n.ops)this.onTestItemEvent(i,t);break;case m.SetTags:this.diffTagRefs(n.new,n.old,i.fullId.toString());break;case m.UpdateCanResolveChildren:this.updateExpandability(i);break;case m.SetProp:this.pushDiff({op:k.TestDiffOpType.Update,item:{extId:i.fullId.toString(),item:n.update}});break;case m.DocumentSynced:this.documentSynced(i.actual.uri);break;default:(0,O.assertNever)(n)}}documentSynced(i){i&&this.pushDiff({op:k.TestDiffOpType.DocumentSynced,uri:i,docv:this.options.getDocumentVersion(i)})}upsertItem(i,n){const t=A.TestId.fromExtHostTestItem(i,this.root.id,n?.actual),o=this.options.getApiFor(i);o.parent&&o.parent!==n?.actual&&this.options.getChildren(o.parent).delete(i.id);let c=this.tree.get(t.toString());if(!c){c={fullId:t,actual:i,expandLevels:n?.expandLevels?n.expandLevels-1:void 0,expand:k.TestItemExpandState.NotExpandable},i.tags.forEach(this.incrementTagRefs,this),this.tree.set(c.fullId.toString(),c),this.setItemParent(i,n),this.pushDiff({op:k.TestDiffOpType.Add,item:{controllerId:this.options.controllerId,expand:c.expand,item:this.options.toITestItem(i)}}),this.connectItemAndChildren(i,c,n);return}if(c.actual===i){this.connectItem(i,c,n);return}if(c.actual.uri?.toString()!==i.uri?.toString())return this.removeItem(t.toString()),this.upsertItem(i,n);const g=this.options.getChildren(c.actual),f=c.actual,h=u(this.options.toITestItem(f),this.options.toITestItem(i));this.options.getApiFor(f).listener=void 0,c.actual=i,c.resolveBarrier=void 0,c.expand=k.TestItemExpandState.NotExpandable,h&&(h.hasOwnProperty("tags")&&(this.diffTagRefs(i.tags,f.tags,t.toString()),delete h.tags),this.onTestItemEvent(c,{op:m.SetProp,update:h})),this.connectItemAndChildren(i,c,n);for(const[y,w]of g)this.options.getChildren(i).get(w.id)||this.removeItem(A.TestId.joinToString(t,w.id));const _=c.expandLevels;_!==void 0&&queueMicrotask(()=>{c.expand===k.TestItemExpandState.Expandable&&(c.expandLevels=void 0,this.expand(t.toString(),_))}),this.documentSynced(c.actual.uri)}diffTagRefs(i,n,t){const o=new Set(n.map(c=>c.id));for(const c of i)o.delete(c.id)||this.incrementTagRefs(c);this.pushDiff({op:k.TestDiffOpType.Update,item:{extId:t,item:{tags:i.map(c=>(0,k.namespaceTestTag)(this.options.controllerId,c.id))}}}),o.forEach(this.decrementTagRefs,this)}incrementTagRefs(i){const n=this.tags.get(i.id);n?n.refCount++:(this.tags.set(i.id,{refCount:1}),this.pushDiff({op:k.TestDiffOpType.AddTag,tag:{id:(0,k.namespaceTestTag)(this.options.controllerId,i.id)}}))}decrementTagRefs(i){const n=this.tags.get(i);n&&!--n.refCount&&(this.tags.delete(i),this.pushDiff({op:k.TestDiffOpType.RemoveTag,id:(0,k.namespaceTestTag)(this.options.controllerId,i)}))}setItemParent(i,n){this.options.getApiFor(i).parent=n&&n.actual!==this.root?n.actual:void 0}connectItem(i,n,t){this.setItemParent(i,t);const o=this.options.getApiFor(i);o.parent=t?.actual,o.listener=c=>this.onTestItemEvent(n,c),this.updateExpandability(n)}connectItemAndChildren(i,n,t){this.connectItem(i,n,t);for(const[o,c]of this.options.getChildren(i))this.upsertItem(c,n)}updateExpandability(i){let n;this._resolveHandler?i.resolveBarrier?n=i.resolveBarrier.isOpen()?k.TestItemExpandState.Expanded:k.TestItemExpandState.BusyExpanding:n=i.actual.canResolveChildren?k.TestItemExpandState.Expandable:k.TestItemExpandState.NotExpandable:n=k.TestItemExpandState.NotExpandable,n!==i.expand&&(i.expand=n,this.pushDiff({op:k.TestDiffOpType.Update,item:{extId:i.fullId.toString(),expand:n}}),n===k.TestItemExpandState.Expandable&&i.expandLevels!==void 0&&this.resolveChildren(i))}expandChildren(i,n){if(n<0)return;const t=[];for(const[o,c]of this.options.getChildren(i.actual)){const g=this.expand(A.TestId.joinToString(i.fullId,c.id),n);(0,S.isThenable)(g)&&t.push(g)}if(t.length)return Promise.all(t).then(()=>{})}resolveChildren(i){if(i.resolveBarrier)return i.resolveBarrier;if(!this._resolveHandler){const c=new S.Barrier;return c.open(),c}i.expand=k.TestItemExpandState.BusyExpanding,this.pushExpandStateUpdate(i);const n=i.resolveBarrier=new S.Barrier,t=c=>{console.error(`Unhandled error in resolveHandler of test controller "${this.options.controllerId}"`,c)};let o;try{o=this._resolveHandler(i.actual===this.root?void 0:i.actual)}catch(c){t(c)}return(0,S.isThenable)(o)?o.catch(t).then(()=>{n.open(),this.updateExpandability(i)}):(n.open(),this.updateExpandability(i)),i.resolveBarrier}pushExpandStateUpdate(i){this.pushDiff({op:k.TestDiffOpType.Update,item:{extId:i.fullId.toString(),expand:i.expand}})}removeItem(i){const n=this.tree.get(i);if(!n)throw new Error("attempting to remove non-existent child");this.pushDiff({op:k.TestDiffOpType.Remove,itemId:i});const t=[n];for(;t.length;){const o=t.pop();if(o){this.options.getApiFor(o.actual).listener=void 0;for(const c of o.actual.tags)this.decrementTagRefs(c.id);this.tree.delete(o.fullId.toString());for(const[c,g]of this.options.getChildren(o.actual))t.push(this.tree.get(A.TestId.joinToString(o.fullId,g.id)))}}}flushDiff(){const i=this.collectDiff();i.length&&this.diffOpEmitter.fire(i)}}e.TestItemCollection=C;class v extends Error{constructor(i){super(`Attempted to insert a duplicate test item ID ${i}`)}}e.DuplicateTestItemError=v;class r extends Error{constructor(i){super(`TestItem with ID "${i}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=r;class a extends Error{constructor(i,n,t){super(`TestItem with ID "${i}" is from controller "${n}" and cannot be added as a child of an item from controller "${t}".`)}}e.MixedTestItemController=a;const d=(l,i,n)=>{let t=new Map;return{get size(){return t.size},forEach(o,c){for(const g of t.values())o.call(c,g,this)},[Symbol.iterator](){return t.entries()},replace(o){const c=new Map,g=new Set(t.keys()),f={op:m.Bulk,ops:[]};for(const h of o){if(!(h instanceof n))throw new r(h.id);const _=i(h).controllerId;if(_!==l.controllerId)throw new a(h.id,_,l.controllerId);if(c.has(h.id))throw new v(h.id);c.set(h.id,h),g.delete(h.id),f.ops.push({op:m.Upsert,item:h})}for(const h of g.keys())f.ops.push({op:m.RemoveChild,id:h});l.listener?.(f),t=c},add(o){if(!(o instanceof n))throw new r(o.id);t.set(o.id,o),l.listener?.({op:m.Upsert,item:o})},delete(o){t.delete(o)&&l.listener?.({op:m.RemoveChild,id:o})},get(o){return t.get(o)},toJSON(){return Array.from(t.values())}}};e.createTestItemChildren=d}),define(ke[118],Re([1,0,82]),function(Ee,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPrivateApiFor=e.createPrivateApiFor=void 0;const T=new WeakMap,D=(k,A)=>{const m={controllerId:A};return T.set(k,m),m};e.createPrivateApiFor=D;const O=k=>{const A=T.get(k);if(!A)throw new S.InvalidTestItemError(k?.id||"<unknown>");return A};e.getPrivateApiFor=O}),define(ke[83],Re([1,0,30,15,2]),function(Ee,e,S,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.asWebviewUri=O,e.decodeAuthority=A,e.webviewResourceBaseHost="vscode-cdn.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`'self' https://*.${e.webviewResourceBaseHost}`;function O(m,s){return m.scheme===T.Schemas.http||m.scheme===T.Schemas.https?m:(s&&s.authority&&s.isRemote&&m.scheme===T.Schemas.file&&(m=D.URI.from({scheme:T.Schemas.vscodeRemote,authority:s.authority,path:m.path})),D.URI.from({scheme:T.Schemas.https,authority:`${m.scheme}+${k(m.authority)}.${e.webviewRootResourceAuthority}`,path:m.path,fragment:m.fragment,query:m.query}))}function k(m){return m.replace(/./g,s=>{const I=s.charCodeAt(0);return I>=S.CharCode.a&&I<=S.CharCode.z||I>=S.CharCode.A&&I<=S.CharCode.Z||I>=S.CharCode.Digit0&&I<=S.CharCode.Digit9?s:"-"+I.toString(16).padStart(4,"0")})}function A(m){return m.replace(/-([0-9a-f]{4})/g,(s,I)=>String.fromCharCode(parseInt(I,16)))}}),define(ke[201],Re([1,0,6,4,83]),function(Ee,e,S,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class O{constructor(A,m,s){this._proxy=A,this._editors=m,this._remoteInfo=s,this._handlePool=0,this._disposables=new T.DisposableStore,this._insets=new Map,this._disposables.add(m.onDidChangeVisibleTextEditors(()=>{const I=m.getVisibleTextEditors();for(const E of this._insets.values())I.indexOf(E.editor)<0&&E.inset.dispose()}))}dispose(){this._insets.forEach(A=>A.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(A,m,s,I,E){let u;for(const i of this._editors.getVisibleTextEditors(!0))if(i.value===A){u=i;break}if(!u)throw new Error("not a visible editor");const C=this,v=this._handlePool++,r=new S.Emitter,a=new S.Emitter,d=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(i){return(0,D.asWebviewUri)(i,C._remoteInfo)}get cspSource(){return D.webviewGenericCspSource}set options(i){this._options=i,C._proxy.$setOptions(v,i)}get options(){return this._options}set html(i){this._html=i,C._proxy.$setHtml(v,i)}get html(){return this._html}get onDidReceiveMessage(){return r.event}postMessage(i){return C._proxy.$postMessage(v,i)}},l=new class{constructor(){this.editor=A,this.line=m,this.height=s,this.webview=d,this.onDidDispose=a.event}dispose(){C._insets.has(v)&&(C._insets.delete(v),C._proxy.$disposeEditorInset(v),a.fire(),a.dispose(),r.dispose())}};return this._proxy.$createEditorInset(v,u.id,u.value.document.uri,m+1,s,I||{},E.identifier,E.extensionLocation),this._insets.set(v,{editor:A,inset:l,onDidReceiveMessage:r}),l}$onDidDispose(A){const m=this._insets.get(A);m&&m.inset.dispose()}$onDidReceiveMessage(A,m){this._insets.get(A)?.onDidReceiveMessage.fire(m)}}e.ExtHostEditorInsets=O}),define(ke[119],Re([1,0,3]),function(Ee,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IAuthenticationExtensionsService=e.IAuthenticationService=e.INTERNAL_AUTH_PROVIDER_PREFIX=void 0,e.INTERNAL_AUTH_PROVIDER_PREFIX="__",e.IAuthenticationService=(0,S.createDecorator)("IAuthenticationService"),e.IAuthenticationExtensionsService=(0,S.createDecorator)("IAuthenticationExtensionsService")}),define(ke[202],Re([1,0,3,12]),function(Ee,e,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.VariableError=e.VariableKind=e.IConfigurationResolverService=void 0,e.IConfigurationResolverService=(0,S.createDecorator)("configurationResolverService");var D;(function(k){k.Unknown="unknown",k.Env="env",k.Config="config",k.Command="command",k.Input="input",k.ExtensionInstallFolder="extensionInstallFolder",k.WorkspaceFolder="workspaceFolder",k.Cwd="cwd",k.WorkspaceFolderBasename="workspaceFolderBasename",k.UserHome="userHome",k.LineNumber="lineNumber",k.SelectedText="selectedText",k.File="file",k.FileWorkspaceFolder="fileWorkspaceFolder",k.FileWorkspaceFolderBasename="fileWorkspaceFolderBasename",k.RelativeFile="relativeFile",k.RelativeFileDirname="relativeFileDirname",k.FileDirname="fileDirname",k.FileExtname="fileExtname",k.FileBasename="fileBasename",k.FileBasenameNoExtension="fileBasenameNoExtension",k.FileDirnameBasename="fileDirnameBasename",k.ExecPath="execPath",k.ExecInstallFolder="execInstallFolder",k.PathSeparator="pathSeparator",k.PathSeparatorAlias="/"})(D||(e.VariableKind=D={}));class O extends T.ErrorNoTelemetry{constructor(A,m){super(m),this.variable=A}}e.VariableError=O}),define(ke[203],Re([1,0,22,79,14,25,23,103,9,202,13]),function(Ee,e,S,T,D,O,k,A,m,s,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0,S=Ve(S),T=Ve(T),D=Ve(D),O=Ve(O);class E{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(C,v,r,a){this._contributedVariables=new Map,this._context=C,this._labelService=v,this._userHomePromise=r,a&&(this._envVariablesPromise=a.then(d=>this.prepareEnv(d)))}prepareEnv(C){if(k.isWindows){const v=Object.create(null);return Object.keys(C).forEach(r=>{v[r.toLowerCase()]=C[r]}),v}return C}resolveWithEnvironment(C,v,r){return this.recursiveResolve({env:this.prepareEnv(C),userHome:void 0},v?v.uri:void 0,r)}async resolveAsync(C,v){const r={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(r,C?C.uri:void 0,v)}async resolveAnyBase(C,v,r,a){const d=O.deepClone(v);k.isWindows&&d.windows?Object.keys(d.windows).forEach(i=>d[i]=d.windows[i]):k.isMacintosh&&d.osx?Object.keys(d.osx).forEach(i=>d[i]=d.osx[i]):k.isLinux&&d.linux&&Object.keys(d.linux).forEach(i=>d[i]=d.linux[i]),delete d.windows,delete d.osx,delete d.linux;const l={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(l,C?C.uri:void 0,d,r,a)}async resolveAnyAsync(C,v,r){return this.resolveAnyBase(C,v,r)}async resolveAnyMap(C,v,r){const a=new Map;return{newConfig:await this.resolveAnyBase(C,v,r,a),resolvedVariables:a}}resolveWithInteractionReplace(C,v,r,a){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(C,v,r,a){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(C,v){if(this._contributedVariables.has(C))throw new Error("Variable "+C+" is contributed twice.");this._contributedVariables.set(C,v)}async recursiveResolve(C,v,r,a,d){if(D.isString(r))return this.resolveString(C,v,r,a,d);if(Array.isArray(r))return Promise.all(r.map(l=>this.recursiveResolve(C,v,l,a,d)));if(D.isObject(r)){const l=Object.create(null),i=await Promise.all(Object.keys(r).map(async n=>[await this.resolveString(C,v,n,a,d),await this.recursiveResolve(C,v,r[n],a,d)]));for(const[n,t]of i)l[n]=t;return l}return r}resolveString(C,v,r,a,d){return(0,I.replaceAsync)(r,E.VARIABLE_REGEXP,async(l,i)=>{if(i.includes(E.VARIABLE_LHS))return l;let n=await this.evaluateSingleVariable(C,l,i,v,a);return d?.set(i,n),n!==l&&D.isString(n)&&n.match(E.VARIABLE_REGEXP)&&(n=await this.resolveString(C,v,n,a,d)),n})}fsPath(C){return this._labelService?this._labelService.getUriLabel(C,{noPrefix:!0}):C.fsPath}async evaluateSingleVariable(C,v,r,a,d){let l;const i=r.split(":");i.length>1&&(r=i[0],l=i[1]);const n=c=>{const g=this._context.getFilePath();if(g)return(0,A.normalizeDriveLetter)(g);throw new s.VariableError(c,(0,m.localize)(12109,null,v))},t=c=>{const g=n(c);if(this._context.getWorkspaceFolderPathForFile){const f=this._context.getWorkspaceFolderPathForFile();if(f)return(0,A.normalizeDriveLetter)(f)}throw new s.VariableError(c,(0,m.localize)(12110,null,v,S.basename(g)))},o=c=>{if(l){const g=this._context.getFolderUri(l);if(g)return g;throw new s.VariableError(c,(0,m.localize)(12111,null,v,l))}if(a)return a;throw this._context.getWorkspaceFolderCount()>1?new s.VariableError(c,(0,m.localize)(12112,null,v)):new s.VariableError(c,(0,m.localize)(12113,null,v))};switch(r){case"env":if(l){if(C.env){const c=C.env[k.isWindows?l.toLowerCase():l];if(D.isString(c))return c}return""}throw new s.VariableError(s.VariableKind.Env,(0,m.localize)(12114,null,v));case"config":if(l){const c=this._context.getConfigurationValue(a,l);if(D.isUndefinedOrNull(c))throw new s.VariableError(s.VariableKind.Config,(0,m.localize)(12115,null,v,l));if(D.isObject(c))throw new s.VariableError(s.VariableKind.Config,(0,m.localize)(12116,null,v,l));return c}throw new s.VariableError(s.VariableKind.Config,(0,m.localize)(12117,null,v));case"command":return this.resolveFromMap(s.VariableKind.Command,v,l,d,"command");case"input":return this.resolveFromMap(s.VariableKind.Input,v,l,d,"input");case"extensionInstallFolder":if(l){const c=await this._context.getExtension(l);if(!c)throw new s.VariableError(s.VariableKind.ExtensionInstallFolder,(0,m.localize)(12118,null,v,l));return this.fsPath(c.extensionLocation)}throw new s.VariableError(s.VariableKind.ExtensionInstallFolder,(0,m.localize)(12119,null,v));default:switch(r){case"workspaceRoot":case"workspaceFolder":return(0,A.normalizeDriveLetter)(this.fsPath(o(s.VariableKind.WorkspaceFolder)));case"cwd":return a||l?(0,A.normalizeDriveLetter)(this.fsPath(o(s.VariableKind.Cwd))):T.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,A.normalizeDriveLetter)(S.basename(this.fsPath(o(s.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(C.userHome)return C.userHome;throw new s.VariableError(s.VariableKind.UserHome,(0,m.localize)(12120,null,v))}case"lineNumber":{const c=this._context.getLineNumber();if(c)return c;throw new s.VariableError(s.VariableKind.LineNumber,(0,m.localize)(12121,null,v))}case"selectedText":{const c=this._context.getSelectedText();if(c)return c;throw new s.VariableError(s.VariableKind.SelectedText,(0,m.localize)(12122,null,v))}case"file":return n(s.VariableKind.File);case"fileWorkspaceFolder":return t(s.VariableKind.FileWorkspaceFolder);case"fileWorkspaceFolderBasename":return S.basename(t(s.VariableKind.FileWorkspaceFolderBasename));case"relativeFile":return a||l?S.relative(this.fsPath(o(s.VariableKind.RelativeFile)),n(s.VariableKind.RelativeFile)):n(s.VariableKind.RelativeFile);case"relativeFileDirname":{const c=S.dirname(n(s.VariableKind.RelativeFileDirname));if(a||l){const g=S.relative(this.fsPath(o(s.VariableKind.RelativeFileDirname)),c);return g.length===0?".":g}return c}case"fileDirname":return S.dirname(n(s.VariableKind.FileDirname));case"fileExtname":return S.extname(n(s.VariableKind.FileExtname));case"fileBasename":return S.basename(n(s.VariableKind.FileBasename));case"fileBasenameNoExtension":{const c=S.basename(n(s.VariableKind.FileBasenameNoExtension));return c.slice(0,c.length-S.extname(c).length)}case"fileDirnameBasename":return S.basename(S.dirname(n(s.VariableKind.FileDirnameBasename)));case"execPath":{const c=this._context.getExecPath();return c||v}case"execInstallFolder":{const c=this._context.getAppRoot();return c||v}case"pathSeparator":case"/":return S.sep;default:try{const c=l?`${r}:${l}`:r;return this.resolveFromMap(s.VariableKind.Unknown,v,c,d,void 0)}catch{return v}}}}resolveFromMap(C,v,r,a,d){if(r&&a){const l=d===void 0?a[r]:a[d+":"+r];if(typeof l=="string")return l;throw new s.VariableError(C,(0,m.localize)(12123,null,v))}return v}}e.AbstractVariableResolverService=E}),define(ke[120],Re([1,0,3,116]),function(Ee,e,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OpenEditorContext=e.GroupsOrder=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.isEditorReplacement=s,e.isEditorGroup=u,e.preferredSideBySideGroupDirection=C,e.IEditorGroupsService=(0,S.createDecorator)("editorGroupsService");var D;(function(v){v[v.UP=0]="UP",v[v.DOWN=1]="DOWN",v[v.LEFT=2]="LEFT",v[v.RIGHT=3]="RIGHT"})(D||(e.GroupDirection=D={}));var O;(function(v){v[v.HORIZONTAL=0]="HORIZONTAL",v[v.VERTICAL=1]="VERTICAL"})(O||(e.GroupOrientation=O={}));var k;(function(v){v[v.FIRST=0]="FIRST",v[v.LAST=1]="LAST",v[v.NEXT=2]="NEXT",v[v.PREVIOUS=3]="PREVIOUS"})(k||(e.GroupLocation=k={}));var A;(function(v){v[v.MAXIMIZE=0]="MAXIMIZE",v[v.EXPAND=1]="EXPAND",v[v.EVEN=2]="EVEN"})(A||(e.GroupsArrangement=A={}));var m;(function(v){v[v.COPY_EDITORS=0]="COPY_EDITORS",v[v.MOVE_EDITORS=1]="MOVE_EDITORS"})(m||(e.MergeGroupMode=m={}));function s(v){const r=v;return(0,T.isEditorInput)(r?.editor)&&(0,T.isEditorInput)(r?.replacement)}var I;(function(v){v[v.CREATION_TIME=0]="CREATION_TIME",v[v.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",v[v.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(I||(e.GroupsOrder=I={}));var E;(function(v){v[v.NEW_EDITOR=1]="NEW_EDITOR",v[v.MOVE_EDITOR=2]="MOVE_EDITOR",v[v.COPY_EDITOR=3]="COPY_EDITOR"})(E||(e.OpenEditorContext=E={}));function u(v){const r=v;return!!r&&typeof r.id=="number"&&Array.isArray(r.editors)}function C(v){return v.getValue("workbench.editor.openSideBySideDirection")==="down"?D.DOWN:D.RIGHT}}),define(ke[204],Re([1,0,3,120]),function(Ee,e,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AUX_WINDOW_GROUP=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.isPreferredGroup=D,e.IEditorService=(0,S.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2,e.AUX_WINDOW_GROUP=-3;function D(O){const k=O;return typeof O=="number"||(0,T.isEditorGroup)(k)}}),define(ke[205],Re([1,0,3,107]),function(Ee,e,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,S.refineServiceDecorator)(T.IEnvironmentService)}),define(ke[121],Re([1,0,18,6,22,4,10]),function(Ee,e,S,T,D,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistryLock=e.LockableExtensionDescriptionRegistry=e.ExtensionDescriptionRegistrySnapshot=e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0,D=Ve(D);class A{constructor(l,i){this.versionId=l,this.removedDueToLooping=i}}e.DeltaExtensionsResult=A;class m{static isHostExtension(l,i,n){if(i.getExtensionDescription(l))return!1;const t=n.getExtensionDescription(l);return t?!!((t.main||t.browser)&&t.api==="none"):!1}constructor(l,i){this._activationEventsReader=l,this._onDidChange=new T.Emitter,this.onDidChange=this._onDidChange.event,this._versionId=0,this._extensionDescriptions=i,this._initialize()}_initialize(){this._extensionDescriptions.sort(r),this._extensionsMap=new S.ExtensionIdentifierMap,this._extensionsArr=[],this._activationMap=new Map;for(const l of this._extensionDescriptions){if(this._extensionsMap.has(l.identifier)){console.error("Extension `"+l.identifier.value+"` is already registered");continue}this._extensionsMap.set(l.identifier,l),this._extensionsArr.push(l);const i=this._activationEventsReader.readActivationEvents(l);for(const n of i)this._activationMap.has(n)||this._activationMap.set(n,[]),this._activationMap.get(n).push(l)}}set(l){return this._extensionDescriptions=l,this._initialize(),this._versionId++,this._onDidChange.fire(void 0),{versionId:this._versionId}}deltaExtensions(l,i){this._extensionDescriptions=a(this._extensionDescriptions,i),this._extensionDescriptions=this._extensionDescriptions.concat(l);const n=m._findLoopingExtensions(this._extensionDescriptions);return this._extensionDescriptions=a(this._extensionDescriptions,n.map(t=>t.identifier)),this._initialize(),this._versionId++,this._onDidChange.fire(void 0),new A(this._versionId,n)}static _findLoopingExtensions(l){const i=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(g){this._nodesSet.has(g)||(this._nodesSet.add(g),this._nodesArr.push(g))}addArc(g,f){this.addNode(g),this.addNode(f),this._arcs.has(g)?this._arcs.get(g).push(f):this._arcs.set(g,[f])}getArcs(g){return this._arcs.has(g)?this._arcs.get(g):[]}hasOnlyGoodArcs(g,f){const h=i.getArcs(g);for(let _=0;_<h.length;_++)if(!f.has(h[_]))return!1;return!0}getNodes(){return this._nodesArr}},n=new S.ExtensionIdentifierMap;for(const g of l)if(n.set(g.identifier,g),g.extensionDependencies)for(const f of g.extensionDependencies)i.addArc(S.ExtensionIdentifier.toKey(g.identifier),S.ExtensionIdentifier.toKey(f));const t=new Set;i.getNodes().filter(g=>i.getArcs(g).length===0).forEach(g=>t.add(g));const o=i.getNodes().filter(g=>!t.has(g));let c;do{c=!1;for(let g=0;g<o.length;g++){const f=o[g];i.hasOnlyGoodArcs(f,t)&&(o.splice(g,1),g--,t.add(f),c=!0)}}while(c);return o.map(g=>n.get(g))}containsActivationEvent(l){return this._activationMap.has(l)}containsExtension(l){return this._extensionsMap.has(l)}getExtensionDescriptionsForActivationEvent(l){const i=this._activationMap.get(l);return i?i.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getSnapshot(){return new s(this._versionId,this.getAllExtensionDescriptions())}getExtensionDescription(l){const i=this._extensionsMap.get(l);return i||void 0}getExtensionDescriptionByUUID(l){for(const i of this._extensionsArr)if(i.uuid===l)return i}getExtensionDescriptionByIdOrUUID(l,i){return this.getExtensionDescription(l)??(i?this.getExtensionDescriptionByUUID(i):void 0)}}e.ExtensionDescriptionRegistry=m;class s{constructor(l,i){this.versionId=l,this.extensions=i}}e.ExtensionDescriptionRegistrySnapshot=s;class I{constructor(l){this._lock=new C,this._actual=new m(l,[])}async acquireLock(l){const i=await this._lock.acquire(l);return new E(this,i)}deltaExtensions(l,i,n){if(!l.isAcquiredFor(this))throw new Error("Lock is not held");return this._actual.deltaExtensions(i,n)}containsActivationEvent(l){return this._actual.containsActivationEvent(l)}containsExtension(l){return this._actual.containsExtension(l)}getExtensionDescriptionsForActivationEvent(l){return this._actual.getExtensionDescriptionsForActivationEvent(l)}getAllExtensionDescriptions(){return this._actual.getAllExtensionDescriptions()}getSnapshot(){return this._actual.getSnapshot()}getExtensionDescription(l){return this._actual.getExtensionDescription(l)}getExtensionDescriptionByUUID(l){return this._actual.getExtensionDescriptionByUUID(l)}getExtensionDescriptionByIdOrUUID(l,i){return this._actual.getExtensionDescriptionByIdOrUUID(l,i)}}e.LockableExtensionDescriptionRegistry=I;class E extends O.Disposable{constructor(l,i){super(),this._registry=l,this._isDisposed=!1,this._register(i)}isAcquiredFor(l){return!this._isDisposed&&this._registry===l}}e.ExtensionDescriptionRegistryLock=E;class u{constructor(l){this.name=l;const i=(0,k.promiseWithResolvers)();this.promise=i.promise,this._resolve=i.resolve}resolve(l){this._resolve(l)}}class C{constructor(){this._pendingCustomers=[],this._isLocked=!1}async acquire(l){const i=new u(l);return this._pendingCustomers.push(i),this._advance(),i.promise}_advance(){if(this._isLocked||this._pendingCustomers.length===0)return;const l=this._pendingCustomers.shift();this._isLocked=!0;let i=!0;const n=setTimeout(()=>{i&&console.warn(`The customer named ${l.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),t=()=>{i&&(clearTimeout(n),i=!1,this._isLocked=!1,this._advance())};l.resolve((0,O.toDisposable)(t))}}var v;(function(d){d[d.Builtin=0]="Builtin",d[d.User=1]="User",d[d.Dev=2]="Dev"})(v||(v={}));function r(d,l){const i=d.isBuiltin?v.Builtin:d.isUnderDevelopment?v.Dev:v.User,n=l.isBuiltin?v.Builtin:l.isUnderDevelopment?v.Dev:v.User;if(i!==n)return i-n;const t=D.posix.basename(d.extensionLocation.path),o=D.posix.basename(l.extensionLocation.path);return t<o?-1:t>o?1:0}function a(d,l){const i=new S.ExtensionIdentifierSet(l);return d.filter(n=>!i.has(n.identifier))}}),define(ke[84],Re([1,0,20]),function(Ee,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0,e.createMessageOfType=k,e.isMessageOfType=A;var T;(function(s){s[s.Desktop=1]="Desktop",s[s.Web=2]="Web"})(T||(e.UIKind=T={}));var D;(function(s){s[s.VersionMismatch=55]="VersionMismatch",s[s.UnexpectedError=81]="UnexpectedError"})(D||(e.ExtensionHostExitCode=D={}));var O;(function(s){s[s.Initialized=0]="Initialized",s[s.Ready=1]="Ready",s[s.Terminate=2]="Terminate"})(O||(e.MessageType=O={}));function k(s){const I=S.VSBuffer.alloc(1);switch(s){case O.Initialized:I.writeUInt8(1,0);break;case O.Ready:I.writeUInt8(2,0);break;case O.Terminate:I.writeUInt8(3,0);break}return I}function A(s,I){if(s.byteLength!==1)return!1;switch(s.readUInt8(0)){case 1:return I===O.Initialized;case 2:return I===O.Ready;case 3:return I===O.Terminate;default:return!1}}var m;(function(s){s.Start="START_NATIVE_LOG",s.End="END_NATIVE_LOG"})(m||(e.NativeLogMarkers=m={}))}),define(ke[66],Re([1,0,3,6,113,11,26,84,62,63,25,2,4,9]),function(Ee,e,S,T,D,O,k,A,m,s,I,E,u,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetryLogger=e.ExtHostTelemetry=void 0,e.isNewAppInstall=a;let v=class extends u.Disposable{constructor(l,i){super(),this.initData=l,this.loggerService=i,this._onDidChangeTelemetryEnabled=this._register(new T.Emitter),this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._onDidChangeTelemetryConfiguration=this._register(new T.Emitter),this.onDidChangeTelemetryConfiguration=this._onDidChangeTelemetryConfiguration.event,this._productConfig={usage:!0,error:!0},this._level=D.TelemetryLevel.NONE,this._telemetryIsSupported=!1,this._inLoggingOnlyMode=!1,this._telemetryLoggers=new Map,this.extHostTelemetryLogFile=E.URI.revive(this.initData.environment.extensionTelemetryLogResource),this._inLoggingOnlyMode=this.initData.environment.isExtensionTelemetryLoggingOnly,this._outputLogger=i.createLogger(this.extHostTelemetryLogFile,{id:s.extensionTelemetryLogChannelId,name:(0,C.localize)(2713,null,this._inLoggingOnlyMode?" (Not Sent)":""),hidden:!0}),this._register(this._outputLogger),this._register(i.onDidChangeLogLevel(n=>{(0,O.isLogLevel)(n)&&this.updateLoggerVisibility()})),this._outputLogger.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this._outputLogger.info("===========================================================")}updateLoggerVisibility(){this.loggerService.setVisibility(this.extHostTelemetryLogFile,this._telemetryIsSupported&&this.loggerService.getLogLevel()===O.LogLevel.Trace)}getTelemetryConfiguration(){return this._level===D.TelemetryLevel.USAGE}getTelemetryDetails(){return{isCrashEnabled:this._level>=D.TelemetryLevel.CRASH,isErrorsEnabled:this._productConfig.error?this._level>=D.TelemetryLevel.ERROR:!1,isUsageEnabled:this._productConfig.usage?this._level>=D.TelemetryLevel.USAGE:!1}}instantiateLogger(l,i,n){const t=this.getTelemetryDetails(),o=new r(i,n,l,this._outputLogger,this._inLoggingOnlyMode,this.getBuiltInCommonProperties(l),{isUsageEnabled:t.isUsageEnabled,isErrorsEnabled:t.isErrorsEnabled}),c=this._telemetryLoggers.get(l.identifier.value)??[];return this._telemetryLoggers.set(l.identifier.value,[...c,o]),o.apiTelemetryLogger}$initializeTelemetryLevel(l,i,n){this._level=l,this._telemetryIsSupported=i,this._productConfig=n??{usage:!0,error:!0},this.updateLoggerVisibility()}getBuiltInCommonProperties(l){const i=Object.create(null);switch(i["common.extname"]=`${l.publisher}.${l.name}`,i["common.extversion"]=l.version,i["common.vscodemachineid"]=this.initData.telemetryInfo.machineId,i["common.vscodesessionid"]=this.initData.telemetryInfo.sessionId,i["common.sqmid"]=this.initData.telemetryInfo.sqmId,i["common.devDeviceId"]=this.initData.telemetryInfo.devDeviceId,i["common.vscodeversion"]=this.initData.version,i["common.isnewappinstall"]=a(this.initData.telemetryInfo.firstSessionDate),i["common.product"]=this.initData.environment.appHost,this.initData.uiKind){case A.UIKind.Web:i["common.uikind"]="web";break;case A.UIKind.Desktop:i["common.uikind"]="desktop";break;default:i["common.uikind"]="unknown"}return i["common.remotename"]=(0,m.getRemoteName)((0,s.cleanRemoteAuthority)(this.initData.remote.authority)),i}$onDidChangeTelemetryLevel(l){this._oldTelemetryEnablement=this.getTelemetryConfiguration(),this._level=l;const i=this.getTelemetryDetails();this._telemetryLoggers.forEach((n,t)=>{const o=n.filter(c=>!c.isDisposed);o.length===0?this._telemetryLoggers.delete(t):this._telemetryLoggers.set(t,o)}),this._telemetryLoggers.forEach(n=>{for(const t of n)t.updateTelemetryEnablements(i.isUsageEnabled,i.isErrorsEnabled)}),this._oldTelemetryEnablement!==this.getTelemetryConfiguration()&&this._onDidChangeTelemetryEnabled.fire(this.getTelemetryConfiguration()),this._onDidChangeTelemetryConfiguration.fire(this.getTelemetryDetails()),this.updateLoggerVisibility()}onExtensionError(l,i){const t=this._telemetryLoggers.get(l.value)?.filter(c=>!c.isDisposed);if(!t)return this._telemetryLoggers.delete(l.value),!1;let o=!1;for(const c of t)c.ignoreUnhandledExtHostErrors||(c.logError(i),o=!0);return o}};e.ExtHostTelemetry=v,e.ExtHostTelemetry=v=qe([We(0,k.IExtHostInitDataService),We(1,O.ILoggerService)],v);class r{static validateSender(l){if(typeof l!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof l.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof l.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof l.flush<"u"&&typeof l.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(l,i,n,t,o,c,g){this._extension=n,this._logger=t,this._inLoggingOnlyMode=o,this._commonProperties=c,this._onDidChangeEnableStates=new T.Emitter,this.ignoreUnhandledExtHostErrors=i?.ignoreUnhandledErrors??!1,this._ignoreBuiltinCommonProperties=i?.ignoreBuiltInCommonProperties??!1,this._additionalCommonProperties=i?.additionalCommonProperties,this._sender=l,this._telemetryEnablements={isUsageEnabled:g.isUsageEnabled,isErrorsEnabled:g.isErrorsEnabled}}updateTelemetryEnablements(l,i){this._apiObject&&(this._telemetryEnablements={isUsageEnabled:l,isErrorsEnabled:i},this._onDidChangeEnableStates.fire(this._apiObject))}mixInCommonPropsAndCleanData(l){let i="properties"in l?l.properties??{}:l;return i=(0,s.cleanData)(i,[]),this._additionalCommonProperties&&(i=(0,I.mixin)(i,this._additionalCommonProperties)),this._ignoreBuiltinCommonProperties||(i=(0,I.mixin)(i,this._commonProperties)),"properties"in l?l.properties=i:l=i,l}logEvent(l,i){this._sender&&(this._extension.publisher==="vscode"?l=this._extension.name+"/"+l:l=this._extension.identifier.value+"/"+l,i=this.mixInCommonPropsAndCleanData(i||{}),this._inLoggingOnlyMode||this._sender?.sendEventData(l,i),this._logger.trace(l,i))}logUsage(l,i){this._telemetryEnablements.isUsageEnabled&&this.logEvent(l,i)}logError(l,i){if(!(!this._telemetryEnablements.isErrorsEnabled||!this._sender))if(typeof l=="string")this.logEvent(l,i);else{const n={name:l.name,message:l.message,stack:l.stack,cause:l.cause},t=(0,s.cleanData)(n,[]),o=new Error(t.message,{cause:t.cause});o.stack=t.stack,o.name=t.name,i=this.mixInCommonPropsAndCleanData(i||{}),this._inLoggingOnlyMode||this._sender.sendErrorData(o,i),this._logger.trace("exception",i)}}get apiTelemetryLogger(){if(!this._apiObject){const l=this,i={logUsage:l.logUsage.bind(l),get isUsageEnabled(){return l._telemetryEnablements.isUsageEnabled},get isErrorsEnabled(){return l._telemetryEnablements.isErrorsEnabled},logError:l.logError.bind(l),dispose:l.dispose.bind(l),onDidChangeEnableStates:l._onDidChangeEnableStates.event.bind(l)};this._apiObject=Object.freeze(i)}return this._apiObject}get isDisposed(){return!this._sender}dispose(){if(this._sender?.flush){let l=this._sender;this._sender=void 0,Promise.resolve(l.flush()).then(l=void 0),this._apiObject=void 0}else this._sender=void 0}}e.ExtHostTelemetryLogger=r;function a(d){const l=Date.now()-new Date(d).getTime();return isNaN(l)?!1:l<1e3*60*60*24}e.IExtHostTelemetry=(0,S.createDecorator)("IExtHostTelemetry")}),define(ke[21],Re([1,0,6,2,179,112,18,3]),function(Ee,e,S,T,D,O,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.ActivationKind=e.ExtensionPointContribution=e.ActivationTimes=e.ExtensionHostExtensions=e.ExtensionHostStartup=e.MissingExtensionDependency=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.isProposedApiEnabled=u,e.checkProposedApiEnabled=C,e.toExtension=d,e.toExtensionDescription=l,e.nullExtensionDescription=Object.freeze({identifier:new k.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:T.URI.parse("void:location"),isBuiltin:!1,targetPlatform:k.TargetPlatform.UNDEFINED,isUserBuiltin:!1,isUnderDevelopment:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,A.createDecorator)("extensionService");class m{constructor(t){this.dependency=t}}e.MissingExtensionDependency=m;var s;(function(n){n[n.EagerAutoStart=1]="EagerAutoStart",n[n.EagerManualStart=2]="EagerManualStart",n[n.Lazy=3]="Lazy"})(s||(e.ExtensionHostStartup=s={}));class I{get versionId(){return this._versionId}get allExtensions(){return this._allExtensions}get myExtensions(){return this._myExtensions}constructor(t,o,c){this._versionId=t,this._allExtensions=o.slice(0),this._myExtensions=c.slice(0),this._myActivationEvents=null}toSnapshot(){return{versionId:this._versionId,allExtensions:this._allExtensions,myExtensions:this._myExtensions,activationEvents:O.ImplicitActivationEvents.createActivationEventsMap(this._allExtensions)}}set(t,o,c){if(this._versionId>t)throw new Error(`ExtensionHostExtensions: invalid versionId ${t} (current: ${this._versionId})`);const g=[],f=[],h=[],_=[],y=E(this._allExtensions),w=E(o),P=(L,F)=>L.extensionLocation.toString()===F.extensionLocation.toString()||L.isBuiltin===F.isBuiltin||L.isUserBuiltin===F.isUserBuiltin||L.isUnderDevelopment===F.isUnderDevelopment;for(const L of this._allExtensions){const F=w.get(L.identifier);if(!F){g.push(L.identifier),y.delete(L.identifier);continue}if(!P(L,F)){g.push(L.identifier),y.delete(L.identifier);continue}}for(const L of o){const F=y.get(L.identifier);if(!F){f.push(L);continue}if(!P(F,L)){g.push(F.identifier),y.delete(F.identifier);continue}}const R=new k.ExtensionIdentifierSet(this._myExtensions),p=new k.ExtensionIdentifierSet(c);for(const L of this._myExtensions)p.has(L)||h.push(L);for(const L of c)R.has(L)||_.push(L);const b=O.ImplicitActivationEvents.createActivationEventsMap(f),N={versionId:t,toRemove:g,toAdd:f,addActivationEvents:b,myToRemove:h,myToAdd:_};return this.delta(N),N}delta(t){if(this._versionId>=t.versionId)return null;const{toRemove:o,toAdd:c,myToRemove:g,myToAdd:f}=t,h=new k.ExtensionIdentifierSet(o),_=new k.ExtensionIdentifierSet(g);for(let y=0;y<this._allExtensions.length;y++)h.has(this._allExtensions[y].identifier)&&(this._allExtensions.splice(y,1),y--);for(let y=0;y<this._myExtensions.length;y++)_.has(this._myExtensions[y])&&(this._myExtensions.splice(y,1),y--);for(const y of c)this._allExtensions.push(y);for(const y of f)this._myExtensions.push(y);return this._myActivationEvents=null,t}containsExtension(t){for(const o of this._myExtensions)if(k.ExtensionIdentifier.equals(o,t))return!0;return!1}containsActivationEvent(t){return this._myActivationEvents||(this._myActivationEvents=this._readMyActivationEvents()),this._myActivationEvents.has(t)}_readMyActivationEvents(){const t=new Set;for(const o of this._allExtensions){if(!this.containsExtension(o.identifier))continue;const c=O.ImplicitActivationEvents.readActivationEvents(o);for(const g of c)t.add(g)}return t}}e.ExtensionHostExtensions=I;function E(n){const t=new k.ExtensionIdentifierMap;for(const o of n)t.set(o.identifier,o);return t}function u(n,t){return n.enabledApiProposals?n.enabledApiProposals.includes(t):!1}function C(n,t){if(!u(n,t))throw new Error(`Extension '${n.identifier.value}' CANNOT use API proposal: ${t}.
Its package.json#enabledApiProposals-property declares: ${n.enabledApiProposals?.join(", ")??"[]"} but NOT ${t}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${n.identifier.value}`)}class v{constructor(t,o,c,g){this.codeLoadingTime=t,this.activateCallTime=o,this.activateResolvedTime=c,this.activationReason=g}}e.ActivationTimes=v;class r{constructor(t,o){this.description=t,this.value=o}}e.ExtensionPointContribution=r;var a;(function(n){n[n.Normal=0]="Normal",n[n.Immediate=1]="Immediate"})(a||(e.ActivationKind=a={}));function d(n){return{type:n.isBuiltin?k.ExtensionType.System:k.ExtensionType.User,isBuiltin:n.isBuiltin||n.isUserBuiltin,identifier:{id:(0,D.getGalleryExtensionId)(n.publisher,n.name),uuid:n.uuid},manifest:n,location:n.extensionLocation,targetPlatform:n.targetPlatform,validations:[],isValid:!0}}function l(n,t){const o=(0,D.getExtensionId)(n.manifest.publisher,n.manifest.name);return{id:o,identifier:new k.ExtensionIdentifier(o),isBuiltin:n.type===k.ExtensionType.System,isUserBuiltin:n.type===k.ExtensionType.User&&n.isBuiltin,isUnderDevelopment:!!t,extensionLocation:n.location,uuid:n.identifier.uuid,targetPlatform:n.targetPlatform,publisherDisplayName:n.publisherDisplayName,...n.manifest}}class i{constructor(){this.onDidRegisterExtensions=S.Event.None,this.onDidChangeExtensionsStatus=S.Event.None,this.onDidChangeExtensions=S.Event.None,this.onWillActivateByEvent=S.Event.None,this.onDidChangeResponsiveChange=S.Event.None,this.onWillStop=S.Event.None,this.extensions=[]}activateByEvent(t){return Promise.resolve(void 0)}activateById(t,o){return Promise.resolve(void 0)}activationEventIsDone(t){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(t){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(t,o){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(t){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.NullExtensionService=i}),define(ke[206],Re([1,0,12,4,121,18,21,11,10]),function(Ee,e,S,T,D,O,k,A,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0,S=Ve(S);class s{static{this.NONE=new s(!1,-1,-1,-1)}constructor(l,i,n,t){this.startup=l,this.codeLoadingTime=i,this.activateCallTime=n,this.activateResolvedTime=t}}e.ExtensionActivationTimes=s;class I{constructor(l){this._startup=l,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(l,i){return l===-1||i===-1?-1:i-l}build(){return new s(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=I;class E{constructor(l,i,n,t,o,c){this.activationFailed=l,this.activationFailedError=i,this.activationTimes=n,this.module=t,this.exports=o,this.disposable=c}}e.ActivatedExtension=E;class u extends E{constructor(l){super(!1,null,l,{activate:void 0,deactivate:void 0},void 0,T.Disposable.None)}}e.EmptyExtension=u;class C extends E{constructor(){super(!1,null,s.NONE,{activate:void 0,deactivate:void 0},void 0,T.Disposable.None)}}e.HostExtension=C;class v extends E{constructor(l){super(!0,l,s.NONE,{activate:void 0,deactivate:void 0},void 0,T.Disposable.None)}}let r=class{constructor(l,i,n,t){this._logService=t,this._registry=l,this._globalRegistry=i,this._host=n,this._operations=new O.ExtensionIdentifierMap,this._alreadyActivatedEvents=Object.create(null)}dispose(){for(const[l,i]of this._operations)i.dispose()}async waitForActivatingExtensions(){const l=[];for(const[i,n]of this._operations)l.push(n.wait());await Promise.all(l)}isActivated(l){const i=this._operations.get(l);return!!(i&&i.value)}getActivatedExtension(l){const i=this._operations.get(l);if(!i||!i.value)throw new Error(`Extension '${l.value}' is not known or not activated`);return i.value}async activateByEvent(l,i){if(this._alreadyActivatedEvents[l])return;const n=this._registry.getExtensionDescriptionsForActivationEvent(l);await this._activateExtensions(n.map(t=>({id:t.identifier,reason:{startup:i,extensionId:t.identifier,activationEvent:l}}))),this._alreadyActivatedEvents[l]=!0}activateById(l,i){const n=this._registry.getExtensionDescription(l);if(!n)throw new Error(`Extension '${l.value}' is not known`);return this._activateExtensions([{id:n.identifier,reason:i}])}async _activateExtensions(l){const i=l.filter(n=>!this.isActivated(n.id)).map(n=>this._handleActivationRequest(n));await Promise.all(i.map(n=>n.wait()))}_handleActivationRequest(l){if(this._operations.has(l.id))return this._operations.get(l.id);if(this._isHostExtension(l.id))return this._createAndSaveOperation(l,null,[],null);const i=this._registry.getExtensionDescription(l.id);if(!i){const o=new Error(`Cannot activate unknown extension '${l.id.value}'`),c=this._createAndSaveOperation(l,null,[],new v(o));return this._host.onExtensionActivationError(l.id,o,new k.MissingExtensionDependency(l.id.value)),c}const n=[],t=typeof i.extensionDependencies>"u"?[]:i.extensionDependencies;for(const o of t){if(this._isResolvedExtension(o))continue;const c=this._operations.get(o);if(c){n.push(c);continue}if(this._isHostExtension(o)){n.push(this._handleActivationRequest({id:this._globalRegistry.getExtensionDescription(o).identifier,reason:l.reason}));continue}const g=this._registry.getExtensionDescription(o);if(g){if(!g.main&&!g.browser)continue;n.push(this._handleActivationRequest({id:g.identifier,reason:l.reason}));continue}const f=i.displayName||i.identifier.value,h=new Error(`Cannot activate the '${f}' extension because it depends on unknown extension '${o}'`),_=this._createAndSaveOperation(l,i.displayName,[],new v(h));return this._host.onExtensionActivationError(i.identifier,h,new k.MissingExtensionDependency(o)),_}return this._createAndSaveOperation(l,i.displayName,n,null)}_createAndSaveOperation(l,i,n,t){const o=new a(l.id,i,l.reason,n,t,this._host,this._logService);return this._operations.set(l.id,o),o}_isHostExtension(l){return D.ExtensionDescriptionRegistry.isHostExtension(l,this._registry,this._globalRegistry)}_isResolvedExtension(l){const i=this._globalRegistry.getExtensionDescription(l);return i?!i.main&&!i.browser:!1}};e.ExtensionsActivator=r,e.ExtensionsActivator=r=qe([We(3,A.ILogService)],r);let a=class{get value(){return this._value}get friendlyName(){return this._displayName||this._id.value}constructor(l,i,n,t,o,c,g){this._id=l,this._displayName=i,this._reason=n,this._deps=t,this._value=o,this._host=c,this._logService=g,this._barrier=new m.Barrier,this._isDisposed=!1,this._initialize()}dispose(){this._isDisposed=!0}wait(){return this._barrier.wait()}async _initialize(){await this._waitForDepsThenActivate(),this._barrier.open()}async _waitForDepsThenActivate(){if(!this._value){for(;this._deps.length>0;){for(let l=0;l<this._deps.length;l++){const i=this._deps[l];if(i.value&&!i.value.activationFailed){this._deps.splice(l,1),l--;continue}if(i.value&&i.value.activationFailed){const n=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${i.friendlyName}' failed to activate`);n.detail=i.value.activationFailedError,this._value=new v(n),this._host.onExtensionActivationError(this._id,n,null);return}}this._deps.length>0&&await Promise.race(this._deps.map(l=>l.wait()))}await this._activate()}}async _activate(){try{this._value=await this._host.actualActivateExtension(this._id,this._reason)}catch(l){const i=new Error;if(l&&l.name&&(i.name=l.name),l&&l.message?i.message=`Activating extension '${this._id.value}' failed: ${l.message}.`:i.message=`Activating extension '${this._id.value}' failed: ${l}.`,l&&l.stack&&(i.stack=l.stack),this._value=new v(i),this._isDisposed&&S.isCancellationError(l))return;this._host.onExtensionActivationError(this._id,i,null),this._logService.error(`Activating extension ${this._id.value} failed due to an error:`),this._logService.error(l)}}};a=qe([We(6,A.ILogService)],a)});var oi=this&&this.__importDefault||function(Ee){return Ee&&Ee.__esModule?Ee:{default:Ee}};define(ke[122],Re([1,0,9,12,37,111,78,29,18,109,112,105]),function(Ee,e,S,T,D,O,k,A,m,s,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsRegistry=e.ExtensionsRegistryImpl=e.schema=e.ExtensionPoint=e.ExtensionPointUserDelta=e.ExtensionMessageCollector=void 0,S=Ve(S),D=oi(D);const u=A.Registry.as(k.Extensions.JSONContribution);class C{constructor(t,o,c){this._messageHandler=t,this._extension=o,this._extensionPointId=c}_msg(t,o){this._messageHandler({type:t,message:o,extensionId:this._extension.identifier,extensionPointId:this._extensionPointId})}error(t){this._msg(D.default.Error,t)}warn(t){this._msg(D.default.Warning,t)}info(t){this._msg(D.default.Info,t)}}e.ExtensionMessageCollector=C;class v{static _toSet(t){const o=new m.ExtensionIdentifierSet;for(let c=0,g=t.length;c<g;c++)o.add(t[c].description.identifier);return o}static compute(t,o){if(!t||!t.length)return new v(o,[]);if(!o||!o.length)return new v([],t);const c=this._toSet(t),g=this._toSet(o),f=o.filter(_=>!c.has(_.description.identifier)),h=t.filter(_=>!g.has(_.description.identifier));return new v(f,h)}constructor(t,o){this.added=t,this.removed=o}}e.ExtensionPointUserDelta=v;class r{constructor(t,o){this.name=t,this.defaultExtensionKind=o,this._handler=null,this._users=null,this._delta=null}setHandler(t){if(this._handler!==null)throw new Error("Handler already set!");return this._handler=t,this._handle(),{dispose:()=>{this._handler=null}}}acceptUsers(t){this._delta=v.compute(this._users,t),this._users=t,this._handle()}_handle(){if(!(this._handler===null||this._users===null||this._delta===null))try{this._handler(this._users,this._delta)}catch(t){(0,T.onUnexpectedError)(t)}}}e.ExtensionPoint=r;const a={type:"string",enum:["ui","workspace"],enumDescriptions:[S.localize(12278,null),S.localize(12279,null)]},d="vscode://schemas/vscode-extensions";e.schema={properties:{engines:{type:"object",description:S.localize(12280,null),properties:{vscode:{type:"string",description:S.localize(12281,null),default:"^1.22.0"}}},publisher:{description:S.localize(12282,null),type:"string"},displayName:{description:S.localize(12283,null),type:"string"},categories:{description:S.localize(12284,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:m.EXTENSION_CATEGORIES},{type:"string",const:"Languages",deprecationMessage:S.localize(12285,null)}]}},galleryBanner:{type:"object",description:S.localize(12286,null),properties:{color:{description:S.localize(12287,null),type:"string"},theme:{description:S.localize(12288,null),type:"string",enum:["dark","light"]}}},contributes:{description:S.localize(12289,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:S.localize(12290,null)},enableProposedApi:{type:"boolean",deprecationMessage:S.localize(12291,null)},enabledApiProposals:{markdownDescription:S.localize(12292,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(E.allApiProposals).map(n=>n),markdownEnumDescriptions:Object.values(E.allApiProposals).map(n=>n.proposal)}},api:{markdownDescription:S.localize(12293,null),type:"string",enum:["none"],enumDescriptions:[S.localize(12294,null)]},activationEvents:{description:S.localize(12295,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:S.localize(12296,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:S.localize(12297,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:S.localize(12298,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:S.localize(12299,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:S.localize(12300,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:S.localize(12301,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:S.localize(12302,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:S.localize(12303,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:S.localize(12304,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:S.localize(12305,null),body:"onStartupFinished"},{label:"onTaskType",description:S.localize(12306,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:S.localize(12307,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:S.localize(12308,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:S.localize(12309,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:S.localize(12310,null)},{label:"onUri",body:"onUri",description:S.localize(12311,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:S.localize(12312,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:S.localize(12313,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:S.localize(12314,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:S.localize(12315,null)},{label:"onRenderer",description:S.localize(12316,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:S.localize(12317,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:S.localize(12318,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:S.localize(12319,null)},{label:"onIssueReporterOpened",body:"onIssueReporterOpened",description:S.localize(12320,null)},{label:"onChatParticipant",body:"onChatParticipant:${1:participantId}",description:S.localize(12321,null)},{label:"onLanguageModelTool",body:"onLanguageModelTool:${1:toolId}",description:S.localize(12322,null)},{label:"*",description:S.localize(12323,null),body:"*"}]}},badges:{type:"array",description:S.localize(12324,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:S.localize(12325,null)},href:{type:"string",description:S.localize(12326,null)},description:{type:"string",description:S.localize(12327,null)}}}},markdown:{type:"string",description:S.localize(12328,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:S.localize(12329,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:S.localize(12330,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:O.EXTENSION_IDENTIFIER_PATTERN}},extensionPack:{description:S.localize(12331,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:O.EXTENSION_IDENTIFIER_PATTERN}},extensionKind:{description:S.localize(12332,null),type:"array",items:a,default:["workspace"],defaultSnippets:[{body:["ui"],description:S.localize(12333,null)},{body:["workspace"],description:S.localize(12334,null)},{body:["ui","workspace"],description:S.localize(12335,null)},{body:["workspace","ui"],description:S.localize(12336,null)},{body:[],description:S.localize(12337,null)}]},capabilities:{description:S.localize(12338,null),type:"object",properties:{virtualWorkspaces:{description:S.localize(12339,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:S.localize(12340,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[S.localize(12341,null),S.localize(12342,null),S.localize(12343,null)]},description:{type:"string",markdownDescription:S.localize(12344,null)}}},untrustedWorkspaces:{description:S.localize(12345,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:S.localize(12346,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[S.localize(12347,null),S.localize(12348,null),S.localize(12349,null)]},restrictedConfigurations:{description:S.localize(12350,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:S.localize(12351,null)}}}}},sponsor:{description:S.localize(12352,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:S.localize(12353,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:S.localize(12354,null),type:"string"},"vscode:uninstall":{description:S.localize(12355,null),type:"string"}}},icon:{type:"string",description:S.localize(12356,null)},l10n:{type:"string",description:S.localize(12357,null)},pricing:{type:"string",markdownDescription:S.localize(12358,null),enum:["Free","Trial"],default:"Free"}}};class l{constructor(){this._extensionPoints=new Map}registerExtensionPoint(t){if(this._extensionPoints.has(t.extensionPoint))throw new Error("Duplicate extension point: "+t.extensionPoint);const o=new r(t.extensionPoint,t.defaultExtensionKind);return this._extensionPoints.set(t.extensionPoint,o),t.activationEventsGenerator&&I.ImplicitActivationEvents.register(t.extensionPoint,t.activationEventsGenerator),e.schema.properties.contributes.properties[t.extensionPoint]=t.jsonSchema,u.registerSchema(d,e.schema),o}getExtensionPoints(){return Array.from(this._extensionPoints.values())}}e.ExtensionsRegistryImpl=l;const i={ExtensionsRegistry:"ExtensionsRegistry"};A.Registry.add(i.ExtensionsRegistry,new l),e.ExtensionsRegistry=A.Registry.as(i.ExtensionsRegistry),u.registerSchema(d,e.schema),u.registerSchema(s.productSchemaId,{properties:{extensionEnabledApiProposals:{description:S.localize(12359,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(E.allApiProposals),markdownEnumDescriptions:Object.values(E.allApiProposals).map(n=>n.proposal)}}]}}}})}),define(ke[207],Re([1,0,6,41,4,13,9,18,3,11,21,122]),function(Ee,e,S,T,D,O,k,A,m,s,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageModelsService=e.languageModelExtensionPoint=e.ILanguageModelsService=e.ChatMessageRole=void 0;var u;(function(r){r[r.System=0]="System",r[r.User=1]="User",r[r.Assistant=2]="Assistant"})(u||(e.ChatMessageRole=u={})),e.ILanguageModelsService=(0,m.createDecorator)("ILanguageModelsService");const C={type:"object",properties:{vendor:{type:"string",description:(0,k.localize)(4739,null)}}};e.languageModelExtensionPoint=E.ExtensionsRegistry.registerExtensionPoint({extensionPoint:"languageModels",jsonSchema:{description:(0,k.localize)(4740,null),oneOf:[C,{type:"array",items:C}]},activationEventsGenerator:(r,a)=>{for(const d of r)a.push(`onLanguageModelChat:${d.vendor}`)}});let v=class{constructor(a,d){this._extensionService=a,this._logService=d,this._store=new D.DisposableStore,this._providers=new Map,this._vendors=new Set,this._onDidChangeProviders=this._store.add(new S.Emitter),this.onDidChangeLanguageModels=this._onDidChangeProviders.event,this._store.add(e.languageModelExtensionPoint.setHandler(l=>{this._vendors.clear();for(const n of l){if(!(0,I.isProposedApiEnabled)(n.description,"chatProvider")){n.collector.error((0,k.localize)(4741,null));continue}for(const t of T.Iterable.wrap(n.value)){if(this._vendors.has(t.vendor)){n.collector.error((0,k.localize)(4742,null,t.vendor));continue}if((0,O.isFalsyOrWhitespace)(t.vendor)){n.collector.error((0,k.localize)(4743,null));continue}if(t.vendor.trim()!==t.vendor){n.collector.error((0,k.localize)(4744,null));continue}this._vendors.add(t.vendor)}}const i=[];for(const[n,t]of this._providers)this._vendors.has(t.metadata.vendor)||(this._providers.delete(n),i.push(n));i.length>0&&this._onDidChangeProviders.fire({removed:i})}))}dispose(){this._store.dispose(),this._providers.clear()}getLanguageModelIds(){return Array.from(this._providers.keys())}lookupLanguageModel(a){return this._providers.get(a)?.metadata}async selectLanguageModels(a){if(a.vendor)await this._extensionService.activateByEvent(`onLanguageModelChat:${a.vendor}}`);else{const l=Array.from(this._vendors).map(i=>this._extensionService.activateByEvent(`onLanguageModelChat:${i}`));await Promise.all(l)}const d=[];for(const[l,i]of this._providers)(a.vendor===void 0||i.metadata.vendor===a.vendor)&&(a.family===void 0||i.metadata.family===a.family)&&(a.version===void 0||i.metadata.version===a.version)&&(a.identifier===void 0||i.metadata.id===a.identifier)&&(!i.metadata.targetExtensions||i.metadata.targetExtensions.some(n=>A.ExtensionIdentifier.equals(n,a.extension)))&&d.push(l);return this._logService.trace("[LM] selected language models",a,d),d}registerLanguageModelChat(a,d){if(this._logService.trace("[LM] registering language model chat",a,d.metadata),!this._vendors.has(d.metadata.vendor))throw new Error(`Chat response provider uses UNKNOWN vendor ${d.metadata.vendor}.`);if(this._providers.has(a))throw new Error(`Chat response provider with identifier ${a} is already registered.`);return this._providers.set(a,d),this._onDidChangeProviders.fire({added:[{identifier:a,metadata:d.metadata}]}),(0,D.toDisposable)(()=>{this._providers.delete(a)&&(this._onDidChangeProviders.fire({removed:[a]}),this._logService.trace("[LM] UNregistered language model chat",a,d.metadata))})}async sendChatRequest(a,d,l,i,n){const t=this._providers.get(a);if(!t)throw new Error(`Chat response provider with identifier ${a} is not registered.`);return t.sendChatRequest(l,d,i,n)}computeTokenLength(a,d,l){const i=this._providers.get(a);if(!i)throw new Error(`Chat response provider with identifier ${a} is not registered.`);return i.provideTokenCount(d,l)}};e.LanguageModelsService=v,e.LanguageModelsService=v=qe([We(0,I.IExtensionService),We(1,s.ILogService)],v)}),define(ke[208],Re([1,0,9,14,25,122,31,6]),function(Ee,e,S,T,D,O,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinitionRegistry=void 0,S=Ve(S),T=Ve(T),D=Ve(D);const m={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:S.localize(9876,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:S.localize(9877,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:S.localize(9878,null),default:""}}};var s;(function(u){function C(v,r,a){if(!v)return;const d=T.isString(v.type)?v.type:void 0;if(!d||d.length===0){a.error(S.localize(9879,null));return}const l=[];if(Array.isArray(v.required))for(const i of v.required)T.isString(i)&&l.push(i);return{extensionId:r.value,taskType:d,required:l,properties:v.properties?D.deepClone(v.properties):{},when:v.when?k.ContextKeyExpr.deserialize(v.when):void 0}}u.from=C})(s||(s={}));const I=O.ExtensionsRegistry.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(u,C)=>{for(const v of u)v.type&&C.push(`onTaskType:${v.type}`)},jsonSchema:{description:S.localize(9880,null),type:"array",items:m}});class E{constructor(){this._onDefinitionsChanged=new A.Emitter,this.onDefinitionsChanged=this._onDefinitionsChanged.event,this.taskTypes=Object.create(null),this.readyPromise=new Promise((C,v)=>{I.setHandler((r,a)=>{this._schema=void 0;try{for(const d of a.removed){const l=d.value;for(const i of l)this.taskTypes&&i.type&&this.taskTypes[i.type]&&delete this.taskTypes[i.type]}for(const d of a.added){const l=d.value;for(const i of l){const n=s.from(i,d.description.identifier,d.collector);n&&(this.taskTypes[n.taskType]=n)}}(a.removed.length>0||a.added.length>0)&&this._onDefinitionsChanged.fire()}catch{}C(void 0)})})}onReady(){return this.readyPromise}get(C){return this.taskTypes[C]}all(){return Object.keys(this.taskTypes).map(C=>this.taskTypes[C])}getJsonSchema(){if(this._schema===void 0){const C=[];for(const v of this.all()){const r={type:"object",additionalProperties:!1};v.required.length>0&&(r.required=v.required.slice(0)),v.properties!==void 0?r.properties=D.deepClone(v.properties):r.properties=Object.create(null),r.properties.type={type:"string",enum:[v.taskType]},C.push(r)}this._schema={oneOf:C}}return this._schema}}e.TaskDefinitionRegistry=new E}),define(ke[209],Re([1,0,9,14,24,25,31,208,44]),function(Ee,e,S,T,D,O,k,A,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.TaskSorter=e.JsonSchemaVersion=e.ExecutionEngine=e.InMemoryTask=e.ContributedTask=e.ConfiguringTask=e.CustomTask=e.CommonTask=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.CUSTOMIZED_TASK_TYPE=e.ShellQuoting=e.TASKS_CATEGORY=e.TASK_RUNNING_STATE=e.USER_TASKS_GROUP_KEY=void 0,S=Ve(S),T=Ve(T),D=Ve(D),O=Ve(O),e.USER_TASKS_GROUP_KEY="settings",e.TASK_RUNNING_STATE=new k.RawContextKey("taskRunning",!1,S.localize(9881,null)),e.TASKS_CATEGORY=S.localize2(9883,"Tasks");var s;(function($){$[$.Escape=1]="Escape",$[$.Strong=2]="Strong",$[$.Weak=3]="Weak"})(s||(e.ShellQuoting=s={})),e.CUSTOMIZED_TASK_TYPE="$customized",function($){function x(G){if(!G)return $.Strong;switch(G.toLowerCase()){case"escape":return $.Escape;case"strong":return $.Strong;case"weak":return $.Weak;default:return $.Strong}}$.from=x}(s||(e.ShellQuoting=s={}));var I;(function($){$.defaults={cwd:"${workspaceFolder}"}})(I||(e.CommandOptions=I={}));var E;(function($){$[$.Always=1]="Always",$[$.Silent=2]="Silent",$[$.Never=3]="Never"})(E||(e.RevealKind=E={})),function($){function x(G){switch(G.toLowerCase()){case"always":return $.Always;case"silent":return $.Silent;case"never":return $.Never;default:return $.Always}}$.fromString=x}(E||(e.RevealKind=E={}));var u;(function($){$[$.Never=1]="Never",$[$.OnProblem=2]="OnProblem",$[$.Always=3]="Always"})(u||(e.RevealProblemKind=u={})),function($){function x(G){switch(G.toLowerCase()){case"always":return $.Always;case"never":return $.Never;case"onproblem":return $.OnProblem;default:return $.OnProblem}}$.fromString=x}(u||(e.RevealProblemKind=u={}));var C;(function($){$[$.Shared=1]="Shared",$[$.Dedicated=2]="Dedicated",$[$.New=3]="New"})(C||(e.PanelKind=C={})),function($){function x(G){switch(G.toLowerCase()){case"shared":return $.Shared;case"dedicated":return $.Dedicated;case"new":return $.New;default:return $.Shared}}$.fromString=x}(C||(e.PanelKind=C={}));var v;(function($){$.defaults={echo:!0,reveal:E.Always,revealProblems:u.Never,focus:!1,panel:C.Shared,showReuseMessage:!0,clear:!1}})(v||(e.PresentationOptions=v={}));var r;(function($){$[$.Shell=1]="Shell",$[$.Process=2]="Process",$[$.CustomExecution=3]="CustomExecution"})(r||(e.RuntimeType=r={})),function($){function x(Y){switch(Y.toLowerCase()){case"shell":return $.Shell;case"process":return $.Process;case"customExecution":return $.CustomExecution;default:return $.Process}}$.fromString=x;function G(Y){switch(Y){case $.Shell:return"shell";case $.Process:return"process";case $.CustomExecution:return"customExecution";default:return"process"}}$.toString=G}(r||(e.RuntimeType=r={}));var a;(function($){function x(G){return T.isString(G)?G:G.value}$.value=x})(a||(e.CommandString=a={}));var d;(function($){$.Clean={_id:"clean",isDefault:!1},$.Build={_id:"build",isDefault:!1},$.Rebuild={_id:"rebuild",isDefault:!1},$.Test={_id:"test",isDefault:!1};function x(Y){return Y===$.Clean._id||Y===$.Build._id||Y===$.Rebuild._id||Y===$.Test._id}$.is=x;function G(Y){if(Y!==void 0)return T.isString(Y)?x(Y)?{_id:Y,isDefault:!1}:void 0:Y}$.from=G})(d||(e.TaskGroup=d={}));var l;(function($){$[$.Global=1]="Global",$[$.Workspace=2]="Workspace",$[$.Folder=3]="Folder"})(l||(e.TaskScope=l={}));var i;(function($){$.Workspace="workspace",$.Extension="extension",$.InMemory="inMemory",$.WorkspaceFile="workspaceFile",$.User="user";function x(G){switch(G){case $.User:return m.ConfigurationTarget.USER;case $.WorkspaceFile:return m.ConfigurationTarget.WORKSPACE;default:return m.ConfigurationTarget.WORKSPACE_FOLDER}}$.toConfigurationTarget=x})(i||(e.TaskSourceKind=i={}));var n;(function($){$.parallel="parallel",$.sequence="sequence"})(n||(e.DependsOrder=n={}));var t;(function($){$[$.default=1]="default",$[$.folderOpen=2]="folderOpen"})(t||(e.RunOnOptions=t={}));var o;(function($){$.defaults={reevaluateOnRerun:!0,runOn:t.default,instanceLimit:1}})(o||(e.RunOptions=o={}));class c{constructor(x,G,Y,ae,ee,oe){this._label="",this._id=x,G&&(this._label=G),Y&&(this.type=Y),this.runOptions=ae,this.configurationProperties=ee,this._source=oe}getDefinition(x){}getMapKey(){return this._id}getKey(){}getCommonTaskId(){const x={folder:this.getFolderId(),id:this._id};return JSON.stringify(x)}clone(){return this.fromObject(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(x,G=!1){if(x===void 0)return!1;if(T.isString(x))return x===this._label||x===this.configurationProperties.identifier||G&&x===this._id;const Y=this.getDefinition(!0);return Y!==void 0&&Y._key===x._key}getQualifiedLabel(){const x=this.getWorkspaceFolder();return x?`${this._label} (${x.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(x){this._taskLoadMessages===void 0&&(this._taskLoadMessages=[]),x&&(this._taskLoadMessages=this._taskLoadMessages.concat(x))}get taskLoadMessages(){return this._taskLoadMessages}}e.CommonTask=c;class g extends c{constructor(x,G,Y,ae,ee,oe,ie,ue){super(x,Y,void 0,ie,ue,G),this.command={},this._source=G,this.hasDefinedMatchers=oe,ee&&(this.command=ee)}clone(){return new g(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(x=!1){if(x&&this._source.customizes!==void 0)return this._source.customizes;{let G;switch(this.command?this.command.runtime:void 0){case r.Shell:G="shell";break;case r.Process:G="process";break;case r.CustomExecution:G="customExecution";break;case void 0:G="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:G,_key:this._id,id:this._id}}}static is(x){return x instanceof g}getMapKey(){const x=this._source.config.workspaceFolder;return x?`${x.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}getFolderId(){return this._source.kind===i.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getKey()??super.getCommonTaskId()}getKey(){const x=this.getFolderId();if(!x)return;let G=this.configurationProperties.identifier;this._source.kind!==i.Workspace&&(G+=this._source.kind);const Y={type:e.CUSTOMIZED_TASK_TYPE,folder:x,id:G};return JSON.stringify(Y)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?D.basename(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}fromObject(x){return new g(x._id,x._source,x._label,x.type,x.command,x.hasDefinedMatchers,x.runOptions,x.configurationProperties)}}e.CustomTask=g;class f extends c{constructor(x,G,Y,ae,ee,oe,ie){super(x,Y,ae,oe,ie,G),this._source=G,this.configures=ee}static is(x){return x instanceof f}fromObject(x){return x}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?D.basename(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}getFolderId(){return this._source.kind===i.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getKey(){const x=this.getFolderId();if(!x)return;let G=this.configurationProperties.identifier;this._source.kind!==i.Workspace&&(G+=this._source.kind);const Y={type:e.CUSTOMIZED_TASK_TYPE,folder:x,id:G};return JSON.stringify(Y)}}e.ConfiguringTask=f;class h extends c{constructor(x,G,Y,ae,ee,oe,ie,ue,Z){super(x,Y,ae,ue,Z,G),this.defines=ee,this.hasDefinedMatchers=ie,this.command=oe,this.icon=Z.icon,this.hide=Z.hide}clone(){return new h(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(x){return x instanceof h}getMapKey(){const x=this._source.workspaceFolder;return x?`${this._source.scope.toString()}|${x.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}getFolderId(){if(this._source.scope===l.Folder&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getKey(){const x={type:"contributed",scope:this._source.scope,id:this._id};return x.folder=this.getFolderId(),JSON.stringify(x)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}fromObject(x){return new h(x._id,x._source,x._label,x.type,x.defines,x.command,x.hasDefinedMatchers,x.runOptions,x.configurationProperties)}}e.ContributedTask=h;class _ extends c{constructor(x,G,Y,ae,ee,oe){super(x,Y,ae,ee,oe,G),this._source=G}clone(){return new _(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(x){return x instanceof _}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}getFolderId(){}fromObject(x){return new _(x._id,x._source,x._label,x.type,x.runOptions,x.configurationProperties)}}e.InMemoryTask=_;var y;(function($){$[$.Process=1]="Process",$[$.Terminal=2]="Terminal"})(y||(e.ExecutionEngine=y={})),function($){$._default=$.Terminal}(y||(e.ExecutionEngine=y={}));var w;(function($){$[$.V0_1_0=1]="V0_1_0",$[$.V2_0_0=2]="V2_0_0"})(w||(e.JsonSchemaVersion=w={}));class P{constructor(x){this._order=new Map;for(let G=0;G<x.length;G++)this._order.set(x[G].uri.toString(),G)}compare(x,G){const Y=x.getWorkspaceFolder(),ae=G.getWorkspaceFolder();if(Y&&ae){let ee=this._order.get(Y.uri.toString());ee=ee===void 0?0:ee+1;let oe=this._order.get(ae.uri.toString());return oe=oe===void 0?0:oe+1,ee===oe?x._label.localeCompare(G._label):ee-oe}else return!Y&&ae?-1:Y&&!ae?1:0}}e.TaskSorter=P;var R;(function($){$.DependsOnStarted="dependsOnStarted",$.AcquiredInput="acquiredInput",$.Start="start",$.ProcessStarted="processStarted",$.Active="active",$.Inactive="inactive",$.Changed="changed",$.Terminated="terminated",$.ProcessEnded="processEnded",$.End="end"})(R||(e.TaskEventKind=R={}));var p;(function($){$.SingleRun="singleRun",$.Background="background"})(p||(e.TaskRunType=p={}));var b;(function($){$[$.System=0]="System",$[$.User=1]="User",$[$.FolderOpen=2]="FolderOpen",$[$.ConfigurationChange=3]="ConfigurationChange",$[$.Reconnect=4]="Reconnect"})(b||(e.TaskRunSource=b={}));var N;(function($){function x(ue){return{taskId:ue._id,taskName:ue.configurationProperties.name,runType:ue.configurationProperties.isBackground?p.Background:p.SingleRun,group:ue.configurationProperties.group,__task:ue}}function G(ue,Z,ve){return{...x(ue),kind:R.Start,terminalId:Z,resolvedVariables:ve}}$.start=G;function Y(ue,Z,ve){return{...x(ue),kind:R.ProcessStarted,terminalId:Z,processId:ve}}$.processStarted=Y;function ae(ue,Z,ve){return{...x(ue),kind:R.ProcessEnded,terminalId:Z,exitCode:ve}}$.processEnded=ae;function ee(ue,Z,ve){return{...x(ue),kind:R.Terminated,exitReason:ve,terminalId:Z}}$.terminated=ee;function oe(ue,Z,ve){return{...x(Z),kind:ue,terminalId:ve}}$.general=oe;function ie(){return{kind:R.Changed}}$.changed=ie})(N||(e.TaskEvent=N={}));var L;(function($){function x(Y){const ae=Object.keys(Y).sort();let ee="";for(const oe of ae){let ie=Y[oe];ie instanceof Object?ie=x(ie):typeof ie=="string"&&(ie=ie.replace(/,/g,",,")),ee+=oe+","+ie+","}return ee}function G(Y){const ee={_key:x(Y),type:Y.taskType};return Object.assign(ee,Y),ee}$.create=G})(L||(e.KeyedTaskIdentifier=L={}));var F;(function($){$.AutoDetect="task.autoDetect",$.SaveBeforeRun="task.saveBeforeRun",$.ShowDecorations="task.showDecorations",$.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",$.SlowProviderWarning="task.slowProviderWarning",$.QuickOpenHistory="task.quickOpen.history",$.QuickOpenDetail="task.quickOpen.detail",$.QuickOpenSkip="task.quickOpen.skip",$.QuickOpenShowAll="task.quickOpen.showAll",$.AllowAutomaticTasks="task.allowAutomaticTasks",$.Reconnection="task.reconnection",$.VerboseLogging="task.verboseLogging"})(F||(e.TaskSettingId=F={}));var K;(function($){$.Tasks="tasks",$.SuppressTaskName="tasks.suppressTaskName",$.Windows="tasks.windows",$.Osx="tasks.osx",$.Linux="tasks.linux",$.ShowOutput="tasks.showOutput",$.IsShellCommand="tasks.isShellCommand",$.ServiceTestSetting="tasks.service.testSetting"})(K||(e.TasksSchemaProperties=K={}));var J;(function($){function x(G,Y){const ae=A.TaskDefinitionRegistry.get(G.type);if(ae===void 0){const ue=O.deepClone(G);return delete ue._key,L.create(ue)}const ee=Object.create(null);ee.type=ae.taskType;const oe=new Set;ae.required.forEach(ue=>oe.add(ue));const ie=ae.properties;for(const ue of Object.keys(ie)){const Z=G[ue];if(Z!=null)ee[ue]=Z;else if(oe.has(ue)){const ve=ie[ue];if(ve.default!==void 0)ee[ue]=O.deepClone(ve.default);else switch(ve.type){case"boolean":ee[ue]=!1;break;case"number":case"integer":ee[ue]=0;break;case"string":ee[ue]="";break;default:Y.error(S.localize(9882,null,JSON.stringify(G,void 0,0),ue));return}}}return L.create(ee)}$.createTaskIdentifier=x})(J||(e.TaskDefinition=J={}))}),define(ke[210],Re([1,0,12]),function(Ee,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CanceledLazyPromise=e.LazyPromise=void 0;class T{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((k,A)=>{this._actualOk=k,this._actualErr=A,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(k){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=k,this._actual&&this._actualOk(k))}resolveErr(k){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=k,this._actual?this._actualErr(k):(0,S.onUnexpectedError)(k))}then(k,A){return this._ensureActual().then(k,A)}catch(k){return this._ensureActual().then(void 0,k)}finally(k){return this._ensureActual().finally(k)}}e.LazyPromise=T;class D extends T{constructor(){super(),this._hasErr=!0,this._err=new S.CancellationError}}e.CanceledLazyPromise=D}),define(ke[39],Re([1,0]),function(Ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.ProxyIdentifier=void 0,e.createProxyIdentifier=D,e.getStringIdentifierForProxy=O;class S{static{this.count=0}constructor(m){this._proxyIdentifierBrand=void 0,this.sid=m,this.nid=++S.count}}e.ProxyIdentifier=S;const T=[];function D(A){const m=new S(A);return T[m.nid]=m,m}function O(A){return T[A].sid}class k{constructor(m){this.value=m}}e.SerializableObjectWithBuffers=k}),define(ke[5],Re([1,0,39]),function(Ee,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var T;(function(r){r[r.Default=0]="Default",r[r.InCenter=1]="InCenter",r[r.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",r[r.AtTop=3]="AtTop"})(T||(e.TextEditorRevealType=T={}));var D;(function(r){r[r.UnknownInput=0]="UnknownInput",r[r.TextInput=1]="TextInput",r[r.TextDiffInput=2]="TextDiffInput",r[r.TextMergeInput=3]="TextMergeInput",r[r.NotebookInput=4]="NotebookInput",r[r.NotebookDiffInput=5]="NotebookDiffInput",r[r.CustomEditorInput=6]="CustomEditorInput",r[r.WebviewEditorInput=7]="WebviewEditorInput",r[r.TerminalEditorInput=8]="TerminalEditorInput",r[r.InteractiveEditorInput=9]="InteractiveEditorInput",r[r.ChatEditorInput=10]="ChatEditorInput",r[r.MultiDiffEditorInput=11]="MultiDiffEditorInput"})(D||(e.TabInputKind=D={}));var O;(function(r){r[r.TAB_OPEN=0]="TAB_OPEN",r[r.TAB_CLOSE=1]="TAB_CLOSE",r[r.TAB_UPDATE=2]="TAB_UPDATE",r[r.TAB_MOVE=3]="TAB_MOVE"})(O||(e.TabModelOperationKind=O={}));var k;(function(r){r[r.Editable=0]="Editable",r[r.SupportsHotExit=1]="SupportsHotExit"})(k||(e.WebviewEditorCapabilities=k={}));var A;(function(r){r[r.Int8Array=1]="Int8Array",r[r.Uint8Array=2]="Uint8Array",r[r.Uint8ClampedArray=3]="Uint8ClampedArray",r[r.Int16Array=4]="Int16Array",r[r.Uint16Array=5]="Uint16Array",r[r.Int32Array=6]="Int32Array",r[r.Uint32Array=7]="Uint32Array",r[r.Float32Array=8]="Float32Array",r[r.Float64Array=9]="Float64Array",r[r.BigInt64Array=10]="BigInt64Array",r[r.BigUint64Array=11]="BigUint64Array"})(A||(e.WebviewMessageArrayBufferViewType=A={}));var m;(function(r){r[r.Text=1]="Text",r[r.Error=2]="Error",r[r.Rich=3]="Rich"})(m||(e.CellOutputKind=m={}));var s;(function(r){r[r.Default=0]="Default",r[r.InCenter=1]="InCenter",r[r.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",r[r.AtTop=3]="AtTop"})(s||(e.NotebookEditorRevealType=s={}));var I;(function(r){r[r.None=0]="None",r[r.Process=1]="Process",r[r.Output=2]="Output",r[r.Hybrid=3]="Hybrid"})(I||(e.CandidatePortSource=I={}));class E{static{this._n=0}static mixin(a){return a._id=E._n++,a}}e.IdObject=E;var u;(function(r){r.label="a",r.kind="b",r.detail="c",r.documentation="d",r.sortText="e",r.filterText="f",r.preselect="g",r.insertText="h",r.insertTextRules="i",r.range="j",r.commitCharacters="k",r.additionalTextEdits="l",r.kindModifier="m",r.commandIdent="n",r.commandId="o",r.commandArguments="p"})(u||(e.ISuggestDataDtoField=u={}));var C;(function(r){r.defaultRanges="a",r.completions="b",r.isIncomplete="c",r.duration="d"})(C||(e.ISuggestResultDtoField=C={}));var v;(function(r){r[r.Workspace=0]="Workspace",r[r.TextDocument=1]="TextDocument"})(v||(e.ExtHostTestingResource=v={})),e.MainContext={MainThreadAuthentication:(0,S.createProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,S.createProxyIdentifier)("MainThreadBulkEdits"),MainThreadLanguageModels:(0,S.createProxyIdentifier)("MainThreadLanguageModels"),MainThreadEmbeddings:(0,S.createProxyIdentifier)("MainThreadEmbeddings"),MainThreadChatAgents2:(0,S.createProxyIdentifier)("MainThreadChatAgents2"),MainThreadChatVariables:(0,S.createProxyIdentifier)("MainThreadChatVariables"),MainThreadLanguageModelTools:(0,S.createProxyIdentifier)("MainThreadChatSkills"),MainThreadClipboard:(0,S.createProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,S.createProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,S.createProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,S.createProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,S.createProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,S.createProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,S.createProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,S.createProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,S.createProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,S.createProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,S.createProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,S.createProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,S.createProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,S.createProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,S.createProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,S.createProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,S.createProxyIdentifier)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,S.createProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,S.createProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,S.createProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,S.createProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,S.createProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,S.createProxyIdentifier)("MainThreadProgress"),MainThreadQuickDiff:(0,S.createProxyIdentifier)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,S.createProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,S.createProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,S.createProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,S.createProxyIdentifier)("MainThreadStorage"),MainThreadSpeech:(0,S.createProxyIdentifier)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,S.createProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,S.createProxyIdentifier)("MainThreadTerminalService"),MainThreadTerminalShellIntegration:(0,S.createProxyIdentifier)("MainThreadTerminalShellIntegration"),MainThreadWebviews:(0,S.createProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,S.createProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,S.createProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,S.createProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,S.createProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,S.createProxyIdentifier)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,S.createProxyIdentifier)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,S.createProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,S.createProxyIdentifier)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,S.createProxyIdentifier)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,S.createProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,S.createProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,S.createProxyIdentifier)("MainThreadSearch"),MainThreadShare:(0,S.createProxyIdentifier)("MainThreadShare"),MainThreadTask:(0,S.createProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,S.createProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,S.createProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,S.createProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,S.createProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,S.createProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,S.createProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,S.createProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,S.createProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,S.createProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,S.createProxyIdentifier)("MainThreadTunnelService"),MainThreadManagedSockets:(0,S.createProxyIdentifier)("MainThreadManagedSockets"),MainThreadTimeline:(0,S.createProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,S.createProxyIdentifier)("MainThreadTesting"),MainThreadLocalization:(0,S.createProxyIdentifier)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,S.createProxyIdentifier)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,S.createProxyIdentifier)("MainThreadAiEmbeddingVector")},e.ExtHostContext={ExtHostCommands:(0,S.createProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,S.createProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,S.createProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,S.createProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,S.createProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,S.createProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,S.createProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,S.createProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,S.createProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,S.createProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,S.createProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,S.createProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,S.createProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,S.createProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,S.createProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,S.createProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,S.createProxyIdentifier)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,S.createProxyIdentifier)("ExtHostQuickDiff"),ExtHostStatusBar:(0,S.createProxyIdentifier)("ExtHostStatusBar"),ExtHostShare:(0,S.createProxyIdentifier)("ExtHostShare"),ExtHostExtensionService:(0,S.createProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,S.createProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,S.createProxyIdentifier)("ExtHostTerminalService"),ExtHostTerminalShellIntegration:(0,S.createProxyIdentifier)("ExtHostTerminalShellIntegration"),ExtHostSCM:(0,S.createProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,S.createProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,S.createProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,S.createProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,S.createProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,S.createProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,S.createProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,S.createProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,S.createProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,S.createProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,S.createProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,S.createProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,S.createProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,S.createProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,S.createProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,S.createProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,S.createProxyIdentifier)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,S.createProxyIdentifier)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,S.createProxyIdentifier)("ExtHostOutputService"),ExtHostLabelService:(0,S.createProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,S.createProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,S.createProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,S.createProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,S.createProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,S.createProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,S.createProxyIdentifier)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,S.createProxyIdentifier)("ExtHostInteractive"),ExtHostChatAgents2:(0,S.createProxyIdentifier)("ExtHostChatAgents"),ExtHostChatVariables:(0,S.createProxyIdentifier)("ExtHostChatVariables"),ExtHostLanguageModelTools:(0,S.createProxyIdentifier)("ExtHostChatSkills"),ExtHostChatProvider:(0,S.createProxyIdentifier)("ExtHostChatProvider"),ExtHostSpeech:(0,S.createProxyIdentifier)("ExtHostSpeech"),ExtHostEmbeddings:(0,S.createProxyIdentifier)("ExtHostEmbeddings"),ExtHostAiRelatedInformation:(0,S.createProxyIdentifier)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,S.createProxyIdentifier)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,S.createProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,S.createProxyIdentifier)("ExtHostTunnelService"),ExtHostManagedSockets:(0,S.createProxyIdentifier)("ExtHostManagedSockets"),ExtHostAuthentication:(0,S.createProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,S.createProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,S.createProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,S.createProxyIdentifier)("ExtHostTelemetry"),ExtHostLocalization:(0,S.createProxyIdentifier)("ExtHostLocalization")}}),define(ke[85],Re([1,0,3,11,5,16]),function(Ee,e,S,T,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,D=Ve(D),e.IExtHostApiDeprecationService=(0,S.createDecorator)("IExtHostApiDeprecationService");let k=class{constructor(m,s){this._extHostLogService=s,this._reportedUsages=new Set,this._telemetryShape=m.getProxy(D.MainContext.MainThreadTelemetry)}report(m,s,I){const E=this.getUsageKey(m,s);this._reportedUsages.has(E)||(this._reportedUsages.add(E),s.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${m}' is deprecated. ${I}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:s.identifier.value,apiId:m}))}getUsageKey(m,s){return`${m}-${s.identifier.value}`}};e.ExtHostApiDeprecationService=k,e.ExtHostApiDeprecationService=k=qe([We(0,O.IExtHostRpcService),We(1,T.ILogService)],k),e.NullApiDeprecationService=Object.freeze(new class{report(A,m,s){}})}),define(ke[211],Re([1,0,5]),function(Ee,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class T{constructor(O){const k=O.getProxy(S.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return k.$readText()},writeText(A){return k.$writeText(A)}})}}e.ExtHostClipboard=T}),define(ke[212],Re([1,0,25,5,26,16]),function(Ee,e,S,T,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtHostConsoleForwarder=void 0;let k=class{constructor(I,E){this._mainThreadConsole=I.getProxy(T.MainContext.MainThreadConsole),this._includeStack=E.consoleForward.includeStack,this._logNative=E.consoleForward.logNative,this._wrapConsoleMethod("info","log"),this._wrapConsoleMethod("log","log"),this._wrapConsoleMethod("warn","warn"),this._wrapConsoleMethod("debug","debug"),this._wrapConsoleMethod("error","error")}_wrapConsoleMethod(I,E){const u=this,C=console[I];Object.defineProperty(console,I,{set:()=>{},get:()=>function(){u._handleConsoleCall(I,E,C,arguments)}})}_handleConsoleCall(I,E,u,C){this._mainThreadConsole.$logExtensionHostMessage({type:"__$console",severity:E,arguments:m(C,this._includeStack)}),this._logNative&&this._nativeConsoleLogMessage(I,u,C)}};e.AbstractExtHostConsoleForwarder=k,e.AbstractExtHostConsoleForwarder=k=qe([We(0,O.IExtHostRpcService),We(1,D.IExtHostInitDataService)],k);const A=1e5;function m(s,I){const E=[];if(s.length)for(let u=0;u<s.length;u++){let C=s[u];if(typeof C>"u")C="undefined";else if(C instanceof Error){const v=C;v.stack?C=v.stack:C=v.toString()}E.push(C)}if(I){const u=new Error().stack;u&&E.push({__$stack:u.split(`
`).slice(3).join(`
`)})}try{const u=(0,S.safeStringify)(E);return u.length>A?"Output omitted for a large object that exceeds the limits":u}catch(u){return`Output omitted for an object that cannot be inspected ('${u.toString()}')`}}}),define(ke[213],Re([1,0,2,5,21]),function(Ee,e,S,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class O{constructor(A){this._proxy=A.getProxy(T.MainContext.MainThreadDialogs)}showOpenDialog(A,m){return m?.allowUIResources&&(0,D.checkProposedApiEnabled)(A,"showLocal"),this._proxy.$showOpenDialog(m).then(s=>s?s.map(I=>S.URI.revive(I)):void 0)}showSaveDialog(A){return this._proxy.$showSaveDialog(A).then(m=>m?S.URI.revive(m):void 0)}}e.ExtHostDialogs=O}),define(ke[214],Re([1,0,19,6,4,5]),function(Ee,e,S,T,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEmbeddings=void 0;class k{constructor(m){this._provider=new Map,this._onDidChange=new T.Emitter,this.onDidChange=this._onDidChange.event,this._allKnownModels=new Set,this._handlePool=0,this._proxy=m.getProxy(O.MainContext.MainThreadEmbeddings)}registerEmbeddingsProvider(m,s,I){if(this._allKnownModels.has(s))throw new Error("An embeddings provider for this model is already registered");const E=this._handlePool++;return this._proxy.$registerEmbeddingProvider(E,s),this._provider.set(E,{id:s,provider:I}),(0,D.toDisposable)(()=>{this._allKnownModels.delete(s),this._proxy.$unregisterEmbeddingProvider(E),this._provider.delete(E)})}async computeEmbeddings(m,s,I){I??=S.CancellationToken.None;let E=!1;typeof s=="string"&&(s=[s],E=!0);const u=await this._proxy.$computeEmbeddings(m,s,I);if(u.length!==s.length)throw new Error;if(E){if(u.length!==1)throw new Error;return u[0]}return u}async $provideEmbeddings(m,s,I){const E=this._provider.get(m);if(!E)return[];const u=await E.provider.provideEmbeddings(s,I);return u||[]}get embeddingsModels(){return Array.from(this._allKnownModels)}$acceptEmbeddingModels(m){this._allKnownModels=new Set(m),this._onDidChange.fire()}}e.ExtHostEmbeddings=k}),define(ke[215],Re([1,0,4,5]),function(Ee,e,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class D{constructor(k){this._handlePool=0,this._proxy=k.getProxy(T.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(k){const A=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(A,k),(0,S.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(A)})}}e.ExtHostLabelService=D}),define(ke[86],Re([1,0,23,13,2,3,11,5,26,16]),function(Ee,e,S,T,D,O,k,A,m,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostLocalizationService=e.ExtHostLocalizationService=void 0;let I=class{constructor(u,C,v){this.logService=v,this.bundleCache=new Map,this._proxy=C.getProxy(A.MainContext.MainThreadLocalization),this.currentLanguage=u.environment.appLanguage,this.isDefaultLanguage=this.currentLanguage===S.LANGUAGE_DEFAULT}getMessage(u,C){const{message:v,args:r,comment:a}=C;if(this.isDefaultLanguage)return(0,T.format2)(v,r??{});let d=v;a&&a.length>0&&(d+=`/${Array.isArray(a)?a.join(""):a}`);const l=this.bundleCache.get(u)?.contents[d];return l||this.logService.warn(`Using default string since no string found in i18n bundle that has the key: ${d}`),(0,T.format2)(l??v,r??{})}getBundle(u){return this.bundleCache.get(u)?.contents}getBundleUri(u){return this.bundleCache.get(u)?.uri}async initializeLocalizedMessages(u){if(this.isDefaultLanguage||!u.l10n&&!u.isBuiltin||this.bundleCache.has(u.identifier.value))return;let C;const v=await this.getBundleLocation(u);if(!v){this.logService.error(`No bundle location found for extension ${u.identifier.value}`);return}try{const r=await this._proxy.$fetchBundleContents(v),a=JSON.parse(r);C=u.isBuiltin?a.contents?.bundle:a}catch(r){this.logService.error(`Failed to load translations for ${u.identifier.value} from ${v}: ${r.message}`);return}C&&this.bundleCache.set(u.identifier.value,{contents:C,uri:v})}async getBundleLocation(u){if(u.isBuiltin){const C=await this._proxy.$fetchBuiltInBundleUri(u.identifier.value,this.currentLanguage);return D.URI.revive(C)}return u.l10n?D.URI.joinPath(u.extensionLocation,u.l10n,`bundle.l10n.${this.currentLanguage}.json`):void 0}};e.ExtHostLocalizationService=I,e.ExtHostLocalizationService=I=qe([We(0,m.IExtHostInitDataService),We(1,s.IExtHostRpcService),We(2,k.ILogService)],I),e.IExtHostLocalizationService=(0,O.createDecorator)("IExtHostLocalizationService")}),define(ke[216],Re([1,0,11,5,26,16,2,34]),function(Ee,e,S,T,D,O,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;let m=class extends S.AbstractLoggerService{constructor(E,u){super(u.logLevel,u.logsLocation,u.loggers.map(C=>(0,A.revive)(C))),this._proxy=E.getProxy(T.MainContext.MainThreadLogger)}$setLogLevel(E,u){u?this.setLogLevel(k.URI.revive(u),E):this.setLogLevel(E)}setVisibility(E,u){super.setVisibility(E,u),this._proxy.$setVisibility(E,u)}doCreateLogger(E,u,C){return new s(this._proxy,E,u,C)}};e.ExtHostLoggerService=m,e.ExtHostLoggerService=m=qe([We(0,O.IExtHostRpcService),We(1,D.IExtHostInitDataService)],m);class s extends S.AbstractMessageLogger{constructor(E,u,C,v){super(v?.logLevel==="always"),this.proxy=E,this.file=u,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(C),this.proxy.$createLogger(u,v).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(E,u){const C=[[E,u]];this.isLoggerCreated?this.doLog(C):this.buffer.push(...C)}doLog(E){this.proxy.$log(this.file,E)}flush(){this.proxy.$flush(this.file)}}}),define(ke[87],Re([1,0,5,3,4,16,20]),function(Ee,e,S,T,D,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostManagedSockets=e.IExtHostManagedSockets=void 0,e.IExtHostManagedSockets=(0,T.createDecorator)("IExtHostManagedSockets");let A=class{constructor(E){this._remoteSocketIdCounter=0,this._factory=null,this._managedRemoteSockets=new Map,this._proxy=E.getProxy(S.MainContext.MainThreadManagedSockets)}setFactory(E,u){for(const C of this._managedRemoteSockets.values())C.dispose();this._factory&&this._proxy.$unregisterSocketFactory(this._factory.socketFactoryId),this._factory=new m(E,u),this._proxy.$registerSocketFactory(this._factory.socketFactoryId)}async $openRemoteSocket(E){if(!this._factory||this._factory.socketFactoryId!==E)throw new Error(`No socket factory with id ${E}`);const u=++this._remoteSocketIdCounter,C=await this._factory.makeConnection(),v=new D.DisposableStore;return this._managedRemoteSockets.set(u,new s(u,C,v)),v.add((0,D.toDisposable)(()=>this._managedRemoteSockets.delete(u))),v.add(C.onDidEnd(()=>{this._proxy.$onDidManagedSocketEnd(u),v.dispose()})),v.add(C.onDidClose(r=>{this._proxy.$onDidManagedSocketClose(u,r?.stack??r?.message),v.dispose()})),v.add(C.onDidReceiveMessage(r=>this._proxy.$onDidManagedSocketHaveData(u,k.VSBuffer.wrap(r)))),u}$remoteSocketWrite(E,u){this._managedRemoteSockets.get(E)?.actual.send(u.buffer)}$remoteSocketEnd(E){const u=this._managedRemoteSockets.get(E);u&&(u.actual.end(),u.dispose())}async $remoteSocketDrain(E){await this._managedRemoteSockets.get(E)?.actual.drain?.()}};e.ExtHostManagedSockets=A,e.ExtHostManagedSockets=A=qe([We(0,O.IExtHostRpcService)],A);class m{constructor(E,u){this.socketFactoryId=E,this.makeConnection=u}}class s extends D.Disposable{constructor(E,u,C){super(),this.socketId=E,this.actual=u,this._register(C)}}}),define(ke[217],Re([1,0,5,11,21]),function(Ee,e,S,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function O(A){return A&&A.title}let k=class{constructor(m,s){this._logService=s,this._proxy=m.getProxy(S.MainContext.MainThreadMessageService)}showMessage(m,s,I,E,u){const C={source:{identifier:m.identifier,label:m.displayName||m.name}};let v;typeof E=="string"||O(E)?v=[E,...u]:(C.modal=E?.modal,C.useCustom=E?.useCustom,C.detail=E?.detail,v=u),C.useCustom&&(0,D.checkProposedApiEnabled)(m,"resolvers");const r=[];let a=!1;for(let d=0;d<v.length;d++){const l=v[d];if(typeof l=="string")r.push({title:l,handle:d,isCloseAffordance:!1});else if(typeof l=="object"){const{title:i,isCloseAffordance:n}=l;r.push({title:i,isCloseAffordance:!!n,handle:d}),n&&(a?this._logService.warn(`[${m.identifier}] Only one message item can have 'isCloseAffordance':`,l):a=!0)}else this._logService.warn(`[${m.identifier}] Invalid message item:`,l)}return this._proxy.$showMessage(s,I,C,r).then(d=>{if(typeof d=="number")return v[d]})}};e.ExtHostMessageService=k,e.ExtHostMessageService=k=qe([We(1,T.ILogService)],k)}),define(ke[218],Re([1,0,4,14,2,21,5]),function(Ee,e,S,T,D,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProfileContentHandlers=void 0;class A{constructor(s){this.handlers=new Map,this.proxy=s.getProxy(k.MainContext.MainThreadProfileContentHandlers)}registerProfileContentHandler(s,I,E){if((0,O.checkProposedApiEnabled)(s,"profileContentHandlers"),this.handlers.has(I))throw new Error(`Handler with id '${I}' already registered`);return this.handlers.set(I,E),this.proxy.$registerProfileContentHandler(I,E.name,E.description,s.identifier.value),(0,S.toDisposable)(()=>{this.handlers.delete(I),this.proxy.$unregisterProfileContentHandler(I)})}async $saveProfile(s,I,E,u){const C=this.handlers.get(s);if(!C)throw new Error(`Unknown handler with id: ${s}`);return C.saveProfile(I,E,u)}async $readProfile(s,I,E){const u=this.handlers.get(s);if(!u)throw new Error(`Unknown handler with id: ${s}`);return u.readProfile((0,T.isString)(I)?I:D.URI.revive(I),E)}}e.ExtHostProfileContentHandlers=A}),define(ke[88],Re([1,0,5,6,3]),function(Ee,e,S,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class O{constructor(A){this._onDidChangePassword=new T.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=A.getProxy(S.MainContext.MainThreadSecretState)}async $onDidChangePassword(A){this._onDidChangePassword.fire(A)}get(A,m){return this._proxy.$getPassword(A,m)}store(A,m,s){return this._proxy.$setPassword(A,m,s)}delete(A,m){return this._proxy.$deletePassword(A,m)}}e.ExtHostSecretState=O,e.IExtHostSecretState=(0,D.createDecorator)("IExtHostSecretState")}),define(ke[219],Re([1,0,19,4,5]),function(Ee,e,S,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSpeech=void 0;class O{static{this.ID_POOL=1}constructor(A){this.providers=new Map,this.sessions=new Map,this.synthesizers=new Map,this.proxy=A.getProxy(D.MainContext.MainThreadSpeech)}async $createSpeechToTextSession(A,m,s){const I=this.providers.get(A);if(!I)return;const E=new T.DisposableStore,u=new S.CancellationTokenSource;this.sessions.set(m,u);const C=await I.provideSpeechToTextSession(u.token,s?{language:s}:void 0);C&&(E.add(C.onDidChange(v=>{u.token.isCancellationRequested||this.proxy.$emitSpeechToTextEvent(m,v)})),E.add(u.token.onCancellationRequested(()=>E.dispose())))}async $cancelSpeechToTextSession(A){this.sessions.get(A)?.dispose(!0),this.sessions.delete(A)}async $createTextToSpeechSession(A,m,s){const I=this.providers.get(A);if(!I)return;const E=new T.DisposableStore,u=new S.CancellationTokenSource;this.sessions.set(m,u);const C=await I.provideTextToSpeechSession(u.token,s?{language:s}:void 0);C&&(this.synthesizers.set(m,C),E.add(C.onDidChange(v=>{u.token.isCancellationRequested||this.proxy.$emitTextToSpeechEvent(m,v)})),E.add(u.token.onCancellationRequested(()=>E.dispose())))}async $synthesizeSpeech(A,m){this.synthesizers.get(A)?.synthesize(m)}async $cancelTextToSpeechSession(A){this.sessions.get(A)?.dispose(!0),this.sessions.delete(A),this.synthesizers.delete(A)}async $createKeywordRecognitionSession(A,m){const s=this.providers.get(A);if(!s)return;const I=new T.DisposableStore,E=new S.CancellationTokenSource;this.sessions.set(m,E);const u=await s.provideKeywordRecognitionSession(E.token);u&&(I.add(u.onDidChange(C=>{E.token.isCancellationRequested||this.proxy.$emitKeywordRecognitionEvent(m,C)})),I.add(E.token.onCancellationRequested(()=>I.dispose())))}async $cancelKeywordRecognitionSession(A){this.sessions.get(A)?.dispose(!0),this.sessions.delete(A)}registerProvider(A,m,s){const I=O.ID_POOL++;return this.providers.set(I,s),this.proxy.$registerProvider(I,m,{extension:A,displayName:A.value}),(0,T.toDisposable)(()=>{this.proxy.$unregisterProvider(I),this.providers.delete(I)})}}e.ExtHostSpeech=O}),define(ke[89],Re([1,0,5,6,3]),function(Ee,e,S,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class O{constructor(A,m){this._logService=m,this._onDidChangeStorage=new T.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=A.getProxy(S.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(A,m){this._proxy.$registerExtensionStorageKeysToSync(A,m)}async initializeExtensionStorage(A,m,s){const I=await this._proxy.$initializeExtensionStorage(A,m);let E;return I&&(E=this.safeParseValue(A,m,I)),E||s}setValue(A,m,s){return this._proxy.$setValue(A,m,s)}$acceptValue(A,m,s){const I=this.safeParseValue(A,m,s);I&&this._onDidChangeStorage.fire({shared:A,key:m,value:I})}safeParseValue(A,m,s){try{return JSON.parse(s)}catch(I){this._logService.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${m}, global: ${A}): ${I}`)}}}e.ExtHostStorage=O,e.IExtHostStorage=(0,D.createDecorator)("IExtHostStorage")}),define(ke[220],Re([1,0,4,15,2,5]),function(Ee,e,S,T,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class k{static{this.supportedSchemes=new Set([T.Schemas.http,T.Schemas.https])}constructor(m){this._openers=new Map,this._proxy=m.getProxy(O.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(m,s,I,E){if(this._openers.has(s))throw new Error(`Opener with id '${s}' already registered`);const u=E.schemes.find(C=>!k.supportedSchemes.has(C));if(u)throw new Error(`Scheme '${u}' is not supported. Only http and https are currently supported.`);return this._openers.set(s,I),this._proxy.$registerUriOpener(s,E.schemes,m,E.label),(0,S.toDisposable)(()=>{this._openers.delete(s),this._proxy.$unregisterUriOpener(s)})}async $canOpenUri(m,s,I){const E=this._openers.get(m);if(!E)throw new Error(`Unknown opener with id: ${m}`);const u=D.URI.revive(s);return E.canOpenExternalUri(u,I)}async $openUri(m,s,I){const E=this._openers.get(m);if(!E)throw new Error(`Unknown opener id: '${m}'`);return E.openExternalUri(D.URI.revive(s.resolvedUri),{sourceUri:D.URI.revive(s.sourceUri)},I)}}e.ExtHostUriOpeners=k}),define(ke[221],Re([1,0,5,2,4,12,18]),function(Ee,e,S,T,D,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class A{static{this.HandlePool=0}constructor(s){this.handles=new k.ExtensionIdentifierSet,this.handlers=new Map,this._proxy=s.getProxy(S.MainContext.MainThreadUrls)}registerUriHandler(s,I){const E=s.identifier;if(this.handles.has(E))throw new Error(`Protocol handler already registered for extension ${E}`);const u=A.HandlePool++;return this.handles.add(E),this.handlers.set(u,I),this._proxy.$registerUriHandler(u,E,s.displayName||s.name),(0,D.toDisposable)(()=>{this.handles.delete(E),this.handlers.delete(u),this._proxy.$unregisterUriHandler(u)})}$handleExternalUri(s,I){const E=this.handlers.get(s);if(!E)return Promise.resolve(void 0);try{E.handleUri(T.URI.revive(I))}catch(u){(0,O.onUnexpectedError)(u)}return Promise.resolve(void 0)}async createAppUri(s){return T.URI.revive(await this._proxy.$createAppUri(s))}}e.ExtHostUrls=A}),define(ke[222],Re([1,0,20,5]),function(Ee,e,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.serializeWebviewMessage=O,e.deserializeWebviewMessage=A,T=Ve(T);class D{constructor(){this.buffers=[]}add(s){let I=this.buffers.indexOf(s);return I<0&&(I=this.buffers.length,this.buffers.push(s)),I}}function O(m,s){if(s.serializeBuffersForPostMessage){const I=new D,u=JSON.stringify(m,(v,r)=>{if(r instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:I.add(r)};if(ArrayBuffer.isView(r)){const a=k(r);if(a)return{$$vscode_array_buffer_reference$$:!0,index:I.add(r.buffer),view:{type:a,byteLength:r.byteLength,byteOffset:r.byteOffset}}}return r}),C=I.buffers.map(v=>{const r=new Uint8Array(v);return S.VSBuffer.wrap(r)});return{message:u,buffers:C}}else return{message:JSON.stringify(m),buffers:[]}}function k(m){switch(m.constructor.name){case"Int8Array":return T.WebviewMessageArrayBufferViewType.Int8Array;case"Uint8Array":return T.WebviewMessageArrayBufferViewType.Uint8Array;case"Uint8ClampedArray":return T.WebviewMessageArrayBufferViewType.Uint8ClampedArray;case"Int16Array":return T.WebviewMessageArrayBufferViewType.Int16Array;case"Uint16Array":return T.WebviewMessageArrayBufferViewType.Uint16Array;case"Int32Array":return T.WebviewMessageArrayBufferViewType.Int32Array;case"Uint32Array":return T.WebviewMessageArrayBufferViewType.Uint32Array;case"Float32Array":return T.WebviewMessageArrayBufferViewType.Float32Array;case"Float64Array":return T.WebviewMessageArrayBufferViewType.Float64Array;case"BigInt64Array":return T.WebviewMessageArrayBufferViewType.BigInt64Array;case"BigUint64Array":return T.WebviewMessageArrayBufferViewType.BigUint64Array}}function A(m,s){const I=s.map(C=>{const v=new ArrayBuffer(C.byteLength);return new Uint8Array(v).set(C.buffer),v}),E=s.length?(C,v)=>{if(v&&typeof v=="object"&&v.$$vscode_array_buffer_reference$$){const r=v,{index:a}=r,d=I[a];if(r.view)switch(r.view.type){case T.WebviewMessageArrayBufferViewType.Int8Array:return new Int8Array(d,r.view.byteOffset,r.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case T.WebviewMessageArrayBufferViewType.Uint8Array:return new Uint8Array(d,r.view.byteOffset,r.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case T.WebviewMessageArrayBufferViewType.Uint8ClampedArray:return new Uint8ClampedArray(d,r.view.byteOffset,r.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case T.WebviewMessageArrayBufferViewType.Int16Array:return new Int16Array(d,r.view.byteOffset,r.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case T.WebviewMessageArrayBufferViewType.Uint16Array:return new Uint16Array(d,r.view.byteOffset,r.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case T.WebviewMessageArrayBufferViewType.Int32Array:return new Int32Array(d,r.view.byteOffset,r.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case T.WebviewMessageArrayBufferViewType.Uint32Array:return new Uint32Array(d,r.view.byteOffset,r.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case T.WebviewMessageArrayBufferViewType.Float32Array:return new Float32Array(d,r.view.byteOffset,r.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case T.WebviewMessageArrayBufferViewType.Float64Array:return new Float64Array(d,r.view.byteOffset,r.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case T.WebviewMessageArrayBufferViewType.BigInt64Array:return new BigInt64Array(d,r.view.byteOffset,r.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case T.WebviewMessageArrayBufferViewType.BigUint64Array:return new BigUint64Array(d,r.view.byteOffset,r.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return d}return v}:void 0;return{message:JSON.parse(m,E),arrayBuffers:I}}}),define(ke[67],Re([1,0,6,4,15,25,2,176,222,83,5]),function(Ee,e,S,T,D,O,k,A,m,s,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviews=e.ExtHostWebview=void 0,e.shouldSerializeBuffersForPostMessage=u,e.toExtensionData=r,e.serializeWebviewOptions=a,O=Ve(O),I=Ve(I);class E{#e;#t;#i;#n;#s;#r;#a;#o;#l;#c;#u;#h;constructor(n,t,o,c,g,f,h){this.#a="",this.#l=!1,this.#c=!1,this._onMessageEmitter=new S.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#d=new S.Emitter,this._onDidDispose=this.#d.event,this.#e=n,this.#t=t,this.#o=o,this.#n=c,this.#s=g,this.#r=f,this.#u=u(f),this.#h=C(f),this.#i=h}#d;dispose(){this.#l=!0,this.#d.fire(),this.#d.dispose(),this._onMessageEmitter.dispose()}asWebviewUri(n){return this.#c=!0,(0,s.asWebviewUri)(n,this.#n)}get cspSource(){const n=this.#r.extensionLocation;if(n.scheme===D.Schemas.https||n.scheme===D.Schemas.http){let t=n.toString();return t.endsWith("/")||(t+="/"),t+" "+s.webviewGenericCspSource}return s.webviewGenericCspSource}get html(){return this.assertNotDisposed(),this.#a}set html(n){this.assertNotDisposed(),this.#a!==n&&(this.#a=n,this.#h&&!this.#c&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(n)&&(this.#c=!0,this.#i.report("Webview vscode-resource: uris",this.#r,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.rewriteOldResourceUrlsIfNeeded(n)))}get options(){return this.assertNotDisposed(),this.#o}set options(n){this.assertNotDisposed(),O.equals(this.#o,n)||this.#t.$setOptions(this.#e,a(this.#r,this.#s,n)),this.#o=n}async postMessage(n){if(this.#l)return!1;const t=(0,m.serializeWebviewMessage)(n,{serializeBuffersForPostMessage:this.#u});return this.#t.$postMessage(this.#e,t.message,...t.buffers)}assertNotDisposed(){if(this.#l)throw new Error("Webview is disposed")}rewriteOldResourceUrlsIfNeeded(n){if(!this.#h)return n;const t=this.#r.extensionLocation?.scheme===D.Schemas.vscodeRemote,o=this.#r.extensionLocation.scheme===D.Schemas.vscodeRemote?this.#r.extensionLocation.authority:void 0;return n.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(c,g,f,h,_,y)=>{const w=k.URI.from({scheme:h||"file",path:decodeURIComponent(_)}),P=(0,s.asWebviewUri)(w,{isRemote:t,authority:o}).toString();return`${g}${P}${y}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(c,g,f,h,_,y)=>{const w=k.URI.from({scheme:h||"file",path:decodeURIComponent(_)}),P=(0,s.asWebviewUri)(w,{isRemote:t,authority:o}).toString();return`${g}${P}${y}`})}}e.ExtHostWebview=E;function u(i){try{const n=(0,A.normalizeVersion)((0,A.parseVersion)(i.engines.vscode));return!!n&&n.majorBase>=1&&n.minorBase>=57}catch{return!1}}function C(i){try{const n=(0,A.normalizeVersion)((0,A.parseVersion)(i.engines.vscode));return n?n.majorBase<1||n.majorBase===1&&n.minorBase<60:!1}catch{return!1}}class v extends T.Disposable{constructor(n,t,o,c,g){super(),this.remoteInfo=t,this.workspace=o,this._logService=c,this._deprecationService=g,this._webviews=new Map,this._webviewProxy=n.getProxy(I.MainContext.MainThreadWebviews)}dispose(){super.dispose();for(const n of this._webviews.values())n.dispose();this._webviews.clear()}$onMessage(n,t,o){const c=this.getWebview(n);if(c){const{message:g}=(0,m.deserializeWebviewMessage)(t,o.value);c._onMessageEmitter.fire(g)}}$onMissingCsp(n,t){this._logService.warn(`${t} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(n,t,o){const c=new E(n,this._webviewProxy,d(t),this.remoteInfo,this.workspace,o,this._deprecationService);this._webviews.set(n,c);const g=c._onDidDispose(()=>{g.dispose(),this.deleteWebview(n)});return c}deleteWebview(n){this._webviews.delete(n)}getWebview(n){return this._webviews.get(n)}}e.ExtHostWebviews=v;function r(i){return{id:i.identifier,location:i.extensionLocation}}function a(i,n,t){return{enableCommandUris:t.enableCommandUris,enableScripts:t.enableScripts,enableForms:t.enableForms,portMapping:t.portMapping,localResourceRoots:t.localResourceRoots||l(i,n)}}function d(i){return{enableCommandUris:i.enableCommandUris,enableScripts:i.enableScripts,enableForms:i.enableForms,portMapping:i.portMapping,localResourceRoots:i.localResourceRoots?.map(n=>k.URI.from(n))}}function l(i,n){return[...(n?.getWorkspaceFolders()||[]).map(t=>t.uri),i.extensionLocation]}}),define(ke[123],Re([1,0,6,15,13,2,3,16,5]),function(Ee,e,S,T,D,O,k,A,m){"use strict";var s;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let I=class{static{s=this}static{this.InitialState={focused:!0,active:!0}}getState(){const u=this._state;return{get focused(){return u.focused},get active(){return u.active}}}constructor(u){this._onDidChangeWindowState=new S.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=s.InitialState,this._proxy=u.getProxy(m.MainContext.MainThreadWindow),this._proxy.$getInitialState().then(({isFocused:C,isActive:v})=>{this.onDidChangeWindowProperty("focused",C),this.onDidChangeWindowProperty("active",v)})}$onDidChangeWindowFocus(u){this.onDidChangeWindowProperty("focused",u)}$onDidChangeWindowActive(u){this.onDidChangeWindowProperty("active",u)}onDidChangeWindowProperty(u,C){C!==this._state[u]&&(this._state={...this._state,[u]:C},this._onDidChangeWindowState.fire(this._state))}openUri(u,C){let v;if(typeof u=="string"){v=u;try{u=O.URI.parse(u)}catch{return Promise.reject(`Invalid uri - '${u}'`)}}return(0,D.isFalsyOrWhitespace)(u.scheme)?Promise.reject("Invalid scheme - cannot be empty"):u.scheme===T.Schemas.command?Promise.reject(`Invalid scheme '${u.scheme}'`):this._proxy.$openUri(u,v,C)}async asExternalUri(u,C){if((0,D.isFalsyOrWhitespace)(u.scheme))return Promise.reject("Invalid scheme - cannot be empty");const v=await this._proxy.$asExternalUri(u,C);return O.URI.from(v)}};e.ExtHostWindow=I,e.ExtHostWindow=I=s=qe([We(0,A.IExtHostRpcService)],I),e.IExtHostWindow=(0,k.createDecorator)("IExtHostWindow")}),define(ke[223],Re([1,0,212,26,16]),function(Ee,e,S,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostConsoleForwarder=void 0;let O=class extends S.AbstractExtHostConsoleForwarder{constructor(A,m){super(A,m)}_nativeConsoleLogMessage(A,m,s){m.apply(console,s)}};e.ExtHostConsoleForwarder=O,e.ExtHostConsoleForwarder=O=qe([We(0,D.IExtHostRpcService),We(1,T.IExtHostInitDataService)],O)}),define(ke[224],Re([1,0,10,20,19,30,12,6,4,38,160,210,39]),function(Ee,e,S,T,D,O,k,A,m,s,I,E,u){"use strict";var C;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=void 0,e.stringifyJsonWithBufferRefs=l,e.parseJsonAndRestoreBufferRefs=i,k=Ve(k);function v(N,L){try{return JSON.stringify(N,L)}catch{return"null"}}const r="$$ref$$",a={[r]:-1};class d{constructor(L,F){this.jsonString=L,this.referencedBuffers=F}}function l(N,L=null,F=!1){const K=[];return{jsonString:(F?v:JSON.stringify)(N,($,x)=>{if(typeof x>"u")return a;if(typeof x=="object"){if(x instanceof T.VSBuffer){const G=K.push(x)-1;return{[r]:G}}if(L)return L($,x)}return x}),referencedBuffers:K}}function i(N,L,F){return JSON.parse(N,(K,J)=>{if(J){const $=J[r];if(typeof $=="number")return L[$];if(F&&J.$mid===s.MarshalledId.Uri)return F.transformIncoming(J)}return J})}function n(N,L){return JSON.stringify(N,L)}function t(N){return N?(L,F)=>F&&F.$mid===s.MarshalledId.Uri?N.transformOutgoing(F):F:null}var o;(function(N){N[N.LocalSide=0]="LocalSide",N[N.OtherSide=1]="OtherSide"})(o||(e.RequestInitiator=o={}));var c;(function(N){N[N.Responsive=0]="Responsive",N[N.Unresponsive=1]="Unresponsive"})(c||(e.ResponsiveState=c={}));const g=()=>{},f=Symbol.for("rpcProtocol"),h=Symbol.for("rpcProxy");class _ extends m.Disposable{static{C=f}static{this.UNRESPONSIVE_TIME=3*1e3}constructor(L,F=null,K=null){super(),this[C]=!0,this._onDidChangeResponsiveState=this._register(new A.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=L,this._logger=F,this._uriTransformer=K,this._uriReplacer=t(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let J=0,$=u.ProxyIdentifier.count;J<$;J++)this._locals[J]=null,this._proxies[J]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=c.Responsive,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new S.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._register(this._protocol.onMessage(J=>this._receiveOneMessage(J)))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(L=>{const F=this._pendingRPCReplies[L];delete this._pendingRPCReplies[L],F.resolveErr(k.canceled())}),super.dispose()}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(L){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+_.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(L){this._unresponsiveTime=Date.now()+_.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(c.Responsive)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(c.Unresponsive):this._asyncCheckUresponsive.schedule())}_setResponsiveState(L){this._responsiveState!==L&&(this._responsiveState=L,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(L){return this._uriTransformer?(0,I.transformIncomingURIs)(L,this._uriTransformer):L}getProxy(L){const{nid:F,sid:K}=L;return this._proxies[F]||(this._proxies[F]=this._createProxy(F,K)),this._proxies[F]}_createProxy(L,F){const K={get:(J,$)=>(typeof $=="string"&&!J[$]&&$.charCodeAt(0)===O.CharCode.DollarSign&&(J[$]=(...x)=>this._remoteCall(L,$,x)),$===h?F:J[$])};return new Proxy(Object.create(null),K)}set(L,F){return this._locals[L.nid]=F,F}assertRegistered(L){for(let F=0,K=L.length;F<K;F++){const J=L[F];if(!this._locals[J.nid])throw new Error(`Missing proxy instance ${J.sid}`)}}_receiveOneMessage(L){if(this._isDisposed)return;const F=L.byteLength,K=w.read(L,0),J=K.readUInt8(),$=K.readUInt32();switch(J){case p.RequestJSONArgs:case p.RequestJSONArgsWithCancellation:{let{rpcId:x,method:G,args:Y}=R.deserializeRequestJSONArgs(K);this._uriTransformer&&(Y=(0,I.transformIncomingURIs)(Y,this._uriTransformer)),this._receiveRequest(F,$,x,G,Y,J===p.RequestJSONArgsWithCancellation);break}case p.RequestMixedArgs:case p.RequestMixedArgsWithCancellation:{let{rpcId:x,method:G,args:Y}=R.deserializeRequestMixedArgs(K);this._uriTransformer&&(Y=(0,I.transformIncomingURIs)(Y,this._uriTransformer)),this._receiveRequest(F,$,x,G,Y,J===p.RequestMixedArgsWithCancellation);break}case p.Acknowledged:{this._logger?.logIncoming(F,$,o.LocalSide,"ack"),this._onDidReceiveAcknowledge($);break}case p.Cancel:{this._receiveCancel(F,$);break}case p.ReplyOKEmpty:{this._receiveReply(F,$,void 0);break}case p.ReplyOKJSON:{let x=R.deserializeReplyOKJSON(K);this._uriTransformer&&(x=(0,I.transformIncomingURIs)(x,this._uriTransformer)),this._receiveReply(F,$,x);break}case p.ReplyOKJSONWithBuffers:{const x=R.deserializeReplyOKJSONWithBuffers(K,this._uriTransformer);this._receiveReply(F,$,x);break}case p.ReplyOKVSBuffer:{const x=R.deserializeReplyOKVSBuffer(K);this._receiveReply(F,$,x);break}case p.ReplyErrError:{let x=R.deserializeReplyErrError(K);this._uriTransformer&&(x=(0,I.transformIncomingURIs)(x,this._uriTransformer)),this._receiveReplyErr(F,$,x);break}case p.ReplyErrEmpty:{this._receiveReplyErr(F,$,void 0);break}default:console.error("received unexpected message"),console.error(L)}}_receiveRequest(L,F,K,J,$,x){this._logger?.logIncoming(L,F,o.OtherSide,`receiveRequest ${(0,u.getStringIdentifierForProxy)(K)}.${J}(`,$);const G=String(F);let Y,ae;if(x){const oe=new D.CancellationTokenSource;$.push(oe.token),Y=this._invokeHandler(K,J,$),ae=()=>oe.cancel()}else Y=this._invokeHandler(K,J,$),ae=g;this._cancelInvokedHandlers[G]=ae;const ee=R.serializeAcknowledged(F);this._logger?.logOutgoing(ee.byteLength,F,o.OtherSide,"ack"),this._protocol.send(ee),Y.then(oe=>{delete this._cancelInvokedHandlers[G];const ie=R.serializeReplyOK(F,oe,this._uriReplacer);this._logger?.logOutgoing(ie.byteLength,F,o.OtherSide,"reply:",oe),this._protocol.send(ie)},oe=>{delete this._cancelInvokedHandlers[G];const ie=R.serializeReplyErr(F,oe);this._logger?.logOutgoing(ie.byteLength,F,o.OtherSide,"replyErr:",oe),this._protocol.send(ie)})}_receiveCancel(L,F){this._logger?.logIncoming(L,F,o.OtherSide,"receiveCancel");const K=String(F);this._cancelInvokedHandlers[K]?.()}_receiveReply(L,F,K){this._logger?.logIncoming(L,F,o.LocalSide,"receiveReply:",K);const J=String(F);if(!this._pendingRPCReplies.hasOwnProperty(J))return;const $=this._pendingRPCReplies[J];delete this._pendingRPCReplies[J],$.resolveOk(K)}_receiveReplyErr(L,F,K){this._logger?.logIncoming(L,F,o.LocalSide,"receiveReplyErr:",K);const J=String(F);if(!this._pendingRPCReplies.hasOwnProperty(J))return;const $=this._pendingRPCReplies[J];delete this._pendingRPCReplies[J];let x;K&&(K.$isError?(x=new Error,x.name=K.name,x.message=K.message,x.stack=K.stack):x=K),$.resolveErr(x)}_invokeHandler(L,F,K){try{return Promise.resolve(this._doInvokeHandler(L,F,K))}catch(J){return Promise.reject(J)}}_doInvokeHandler(L,F,K){const J=this._locals[L];if(!J)throw new Error("Unknown actor "+(0,u.getStringIdentifierForProxy)(L));const $=J[F];if(typeof $!="function")throw new Error("Unknown method "+F+" on actor "+(0,u.getStringIdentifierForProxy)(L));return $.apply(J,K)}_remoteCall(L,F,K){if(this._isDisposed)return new E.CanceledLazyPromise;let J=null;if(K.length>0&&D.CancellationToken.isCancellationToken(K[K.length-1])&&(J=K.pop()),J&&J.isCancellationRequested)return Promise.reject(k.canceled());const $=R.serializeRequestArguments(K,this._uriReplacer),x=++this._lastMessageId,G=String(x),Y=new E.LazyPromise,ae=new m.DisposableStore;J&&ae.add(J.onCancellationRequested(()=>{const oe=R.serializeCancel(x);this._logger?.logOutgoing(oe.byteLength,x,o.LocalSide,"cancel"),this._protocol.send(R.serializeCancel(x))})),this._pendingRPCReplies[G]=new y(Y,ae),this._onWillSendRequest(x);const ee=R.serializeRequest(x,L,F,$,!!J);return this._logger?.logOutgoing(ee.byteLength,x,o.LocalSide,`request: ${(0,u.getStringIdentifierForProxy)(L)}.${F}(`,K),this._protocol.send(ee),Y}}e.RPCProtocol=_;class y{constructor(L,F){this._promise=L,this._disposable=F}resolveOk(L){this._promise.resolveOk(L),this._disposable.dispose()}resolveErr(L){this._promise.resolveErr(L),this._disposable.dispose()}}class w{static alloc(L,F,K){const J=new w(T.VSBuffer.alloc(K+1+4),0);return J.writeUInt8(L),J.writeUInt32(F),J}static read(L,F){return new w(L,F)}get buffer(){return this._buff}constructor(L,F){this._buff=L,this._offset=F}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(L){this._buff.writeUInt8(L,this._offset),this._offset+=1}readUInt8(){const L=this._buff.readUInt8(this._offset);return this._offset+=1,L}writeUInt32(L){this._buff.writeUInt32BE(L,this._offset),this._offset+=4}readUInt32(){const L=this._buff.readUInt32BE(this._offset);return this._offset+=4,L}static sizeShortString(L){return 1+L.byteLength}writeShortString(L){this._buff.writeUInt8(L.byteLength,this._offset),this._offset+=1,this._buff.set(L,this._offset),this._offset+=L.byteLength}readShortString(){const L=this._buff.readUInt8(this._offset);this._offset+=1;const K=this._buff.slice(this._offset,this._offset+L).toString();return this._offset+=L,K}static sizeLongString(L){return 4+L.byteLength}writeLongString(L){this._buff.writeUInt32BE(L.byteLength,this._offset),this._offset+=4,this._buff.set(L,this._offset),this._offset+=L.byteLength}readLongString(){const L=this._buff.readUInt32BE(this._offset);this._offset+=4;const K=this._buff.slice(this._offset,this._offset+L).toString();return this._offset+=L,K}writeBuffer(L){this._buff.writeUInt32BE(L.byteLength,this._offset),this._offset+=4,this._buff.set(L,this._offset),this._offset+=L.byteLength}static sizeVSBuffer(L){return 4+L.byteLength}writeVSBuffer(L){this._buff.writeUInt32BE(L.byteLength,this._offset),this._offset+=4,this._buff.set(L,this._offset),this._offset+=L.byteLength}readVSBuffer(){const L=this._buff.readUInt32BE(this._offset);this._offset+=4;const F=this._buff.slice(this._offset,this._offset+L);return this._offset+=L,F}static sizeMixedArray(L){let F=0;F+=1;for(let K=0,J=L.length;K<J;K++){const $=L[K];switch(F+=1,$.type){case b.String:F+=this.sizeLongString($.value);break;case b.VSBuffer:F+=this.sizeVSBuffer($.value);break;case b.SerializedObjectWithBuffers:F+=this.sizeUInt32,F+=this.sizeLongString($.value);for(let x=0;x<$.buffers.length;++x)F+=this.sizeVSBuffer($.buffers[x]);break;case b.Undefined:break}}return F}writeMixedArray(L){this._buff.writeUInt8(L.length,this._offset),this._offset+=1;for(let F=0,K=L.length;F<K;F++){const J=L[F];switch(J.type){case b.String:this.writeUInt8(b.String),this.writeLongString(J.value);break;case b.VSBuffer:this.writeUInt8(b.VSBuffer),this.writeVSBuffer(J.value);break;case b.SerializedObjectWithBuffers:this.writeUInt8(b.SerializedObjectWithBuffers),this.writeUInt32(J.buffers.length),this.writeLongString(J.value);for(let $=0;$<J.buffers.length;++$)this.writeBuffer(J.buffers[$]);break;case b.Undefined:this.writeUInt8(b.Undefined);break}}}readMixedArray(){const L=this._buff.readUInt8(this._offset);this._offset+=1;const F=new Array(L);for(let K=0;K<L;K++)switch(this.readUInt8()){case b.String:F[K]=this.readLongString();break;case b.VSBuffer:F[K]=this.readVSBuffer();break;case b.SerializedObjectWithBuffers:{const $=this.readUInt32(),x=this.readLongString(),G=[];for(let Y=0;Y<$;++Y)G.push(this.readVSBuffer());F[K]=new u.SerializableObjectWithBuffers(i(x,G,null));break}case b.Undefined:F[K]=void 0;break}return F}}var P;(function(N){N[N.Simple=0]="Simple",N[N.Mixed=1]="Mixed"})(P||(P={}));class R{static _useMixedArgSerialization(L){for(let F=0,K=L.length;F<K;F++)if(L[F]instanceof T.VSBuffer||L[F]instanceof u.SerializableObjectWithBuffers||typeof L[F]>"u")return!0;return!1}static serializeRequestArguments(L,F){if(this._useMixedArgSerialization(L)){const K=[];for(let J=0,$=L.length;J<$;J++){const x=L[J];if(x instanceof T.VSBuffer)K[J]={type:b.VSBuffer,value:x};else if(typeof x>"u")K[J]={type:b.Undefined};else if(x instanceof u.SerializableObjectWithBuffers){const{jsonString:G,referencedBuffers:Y}=l(x.value,F);K[J]={type:b.SerializedObjectWithBuffers,value:T.VSBuffer.fromString(G),buffers:Y}}else K[J]={type:b.String,value:T.VSBuffer.fromString(n(x,F))}}return{type:P.Mixed,args:K}}return{type:P.Simple,args:n(L,F)}}static serializeRequest(L,F,K,J,$){switch(J.type){case P.Simple:return this._requestJSONArgs(L,F,K,J.args,$);case P.Mixed:return this._requestMixedArgs(L,F,K,J.args,$)}}static _requestJSONArgs(L,F,K,J,$){const x=T.VSBuffer.fromString(K),G=T.VSBuffer.fromString(J);let Y=0;Y+=w.sizeUInt8(),Y+=w.sizeShortString(x),Y+=w.sizeLongString(G);const ae=w.alloc($?p.RequestJSONArgsWithCancellation:p.RequestJSONArgs,L,Y);return ae.writeUInt8(F),ae.writeShortString(x),ae.writeLongString(G),ae.buffer}static deserializeRequestJSONArgs(L){const F=L.readUInt8(),K=L.readShortString(),J=L.readLongString();return{rpcId:F,method:K,args:JSON.parse(J)}}static _requestMixedArgs(L,F,K,J,$){const x=T.VSBuffer.fromString(K);let G=0;G+=w.sizeUInt8(),G+=w.sizeShortString(x),G+=w.sizeMixedArray(J);const Y=w.alloc($?p.RequestMixedArgsWithCancellation:p.RequestMixedArgs,L,G);return Y.writeUInt8(F),Y.writeShortString(x),Y.writeMixedArray(J),Y.buffer}static deserializeRequestMixedArgs(L){const F=L.readUInt8(),K=L.readShortString(),J=L.readMixedArray(),$=new Array(J.length);for(let x=0,G=J.length;x<G;x++){const Y=J[x];typeof Y=="string"?$[x]=JSON.parse(Y):$[x]=Y}return{rpcId:F,method:K,args:$}}static serializeAcknowledged(L){return w.alloc(p.Acknowledged,L,0).buffer}static serializeCancel(L){return w.alloc(p.Cancel,L,0).buffer}static serializeReplyOK(L,F,K){if(typeof F>"u")return this._serializeReplyOKEmpty(L);if(F instanceof T.VSBuffer)return this._serializeReplyOKVSBuffer(L,F);if(F instanceof u.SerializableObjectWithBuffers){const{jsonString:J,referencedBuffers:$}=l(F.value,K,!0);return this._serializeReplyOKJSONWithBuffers(L,J,$)}else return this._serializeReplyOKJSON(L,v(F,K))}static _serializeReplyOKEmpty(L){return w.alloc(p.ReplyOKEmpty,L,0).buffer}static _serializeReplyOKVSBuffer(L,F){let K=0;K+=w.sizeVSBuffer(F);const J=w.alloc(p.ReplyOKVSBuffer,L,K);return J.writeVSBuffer(F),J.buffer}static deserializeReplyOKVSBuffer(L){return L.readVSBuffer()}static _serializeReplyOKJSON(L,F){const K=T.VSBuffer.fromString(F);let J=0;J+=w.sizeLongString(K);const $=w.alloc(p.ReplyOKJSON,L,J);return $.writeLongString(K),$.buffer}static _serializeReplyOKJSONWithBuffers(L,F,K){const J=T.VSBuffer.fromString(F);let $=0;$+=w.sizeUInt32,$+=w.sizeLongString(J);for(const G of K)$+=w.sizeVSBuffer(G);const x=w.alloc(p.ReplyOKJSONWithBuffers,L,$);x.writeUInt32(K.length),x.writeLongString(J);for(const G of K)x.writeBuffer(G);return x.buffer}static deserializeReplyOKJSON(L){const F=L.readLongString();return JSON.parse(F)}static deserializeReplyOKJSONWithBuffers(L,F){const K=L.readUInt32(),J=L.readLongString(),$=[];for(let x=0;x<K;++x)$.push(L.readVSBuffer());return new u.SerializableObjectWithBuffers(i(J,$,F))}static serializeReplyErr(L,F){const K=F?v(k.transformErrorForSerialization(F),null):void 0;if(typeof K!="string")return this._serializeReplyErrEmpty(L);const J=T.VSBuffer.fromString(K);let $=0;$+=w.sizeLongString(J);const x=w.alloc(p.ReplyErrError,L,$);return x.writeLongString(J),x.buffer}static deserializeReplyErrError(L){const F=L.readLongString();return JSON.parse(F)}static _serializeReplyErrEmpty(L){return w.alloc(p.ReplyErrEmpty,L,0).buffer}}var p;(function(N){N[N.RequestJSONArgs=1]="RequestJSONArgs",N[N.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",N[N.RequestMixedArgs=3]="RequestMixedArgs",N[N.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",N[N.Acknowledged=5]="Acknowledged",N[N.Cancel=6]="Cancel",N[N.ReplyOKEmpty=7]="ReplyOKEmpty",N[N.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",N[N.ReplyOKJSON=9]="ReplyOKJSON",N[N.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",N[N.ReplyErrError=11]="ReplyErrError",N[N.ReplyErrEmpty=12]="ReplyErrEmpty"})(p||(p={}));var b;(function(N){N[N.String=1]="String",N[N.VSBuffer=2]="VSBuffer",N[N.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",N[N.Undefined=4]="Undefined"})(b||(b={}))}),define(ke[225],Re([1,0]),function(Ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NestedWorker=void 0;const S=function(O){const k=A=>{globalThis.removeEventListener("message",k);const m=A.data;Object.defineProperties(globalThis,{postMessage:{value(s,I){m.postMessage(s,I)}},onmessage:{get(){return m.onmessage},set(s){m.onmessage=s}}}),m.addEventListener("message",s=>{globalThis.dispatchEvent(new MessageEvent("message",{data:s.data,ports:s.ports?[...s.ports]:void 0}))}),m.start(),globalThis.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(O)};globalThis.addEventListener("message",k)}.toString();class T extends EventTarget{constructor(O,k,A){super(),this.onmessage=null,this.onmessageerror=null,this.onerror=null;const m=`((${S})('${k}'))`,s=new Blob([m],{type:"application/javascript"}),I=URL.createObjectURL(s),E=new MessageChannel,u=I,C={type:"_newWorker",id:u,port:E.port2,url:I,options:A};O(C,[E.port2]),this.postMessage=E.port1.postMessage.bind(E.port1),this.terminate=()=>{O({type:"_terminateWorker",id:u}),URL.revokeObjectURL(I),E.port1.close(),E.port2.close()},Object.defineProperties(this,{onmessage:{get(){return E.port1.onmessage},set(v){E.port1.onmessage=v}},onmessageerror:{get(){return E.port1.onmessageerror},set(v){E.port1.onmessageerror=v}}}),E.port1.addEventListener("messageerror",v=>{const r=new MessageEvent("messageerror",{data:v.data});this.dispatchEvent(r)}),E.port1.addEventListener("message",v=>{const r=new MessageEvent("message",{data:v.data});this.dispatchEvent(r)}),E.port1.start()}}e.NestedWorker=T}),define(ke[226],Re([1,0,20,27,15,60,3]),function(Ee,e,S,T,D,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookDocumentWorkbenchService=e.INotebookDocumentService=void 0,e.parse=I,e.generate=E,e.parseMetadataUri=u,e.generateMetadataUri=C,e.INotebookDocumentService=(0,k.createDecorator)("notebookDocumentService");const A=["W","X","Y","Z","a","b","c","d","e","f"],m=new RegExp(`^[${A.join("")}]+`),s=7;function I(r){if(r.scheme!==D.Schemas.vscodeNotebookCell)return;const a=r.fragment.indexOf("s");if(a<0)return;const d=parseInt(r.fragment.substring(0,a).replace(m,""),s),l=(0,S.decodeBase64)(r.fragment.substring(a+1)).toString();if(!isNaN(d))return{handle:d,notebook:r.with({scheme:l,fragment:null})}}function E(r,a){const d=a.toString(s),i=`${d.length<A.length?A[d.length-1]:"z"}${d}s${(0,S.encodeBase64)(S.VSBuffer.fromString(r.scheme),!0,!0)}`;return r.with({scheme:D.Schemas.vscodeNotebookCell,fragment:i})}function u(r){if(r.scheme!==D.Schemas.vscodeNotebookMetadata)return;const a=(0,S.decodeBase64)(r.fragment).toString();return r.with({scheme:a,fragment:null})}function C(r){const a=`${(0,S.encodeBase64)(S.VSBuffer.fromString(r.scheme),!0,!0)}`;return r.with({scheme:D.Schemas.vscodeNotebookMetadata,fragment:a})}class v{constructor(){this._documents=new T.ResourceMap}getNotebook(a){if(a.scheme===D.Schemas.vscodeNotebookCell){const d=I(a);if(d){const l=this._documents.get(d.notebook);if(l)return l}}return this._documents.get(a)}addNotebookDocument(a){this._documents.set(a.uri,a)}removeNotebookDocument(a){this._documents.delete(a.uri)}}e.NotebookDocumentWorkbenchService=v,(0,O.registerSingleton)(e.INotebookDocumentService,v,O.InstantiationType.Delayed)}),define(ke[90],Re([1,0,20,43,41,72,15,22,23,31,226]),function(Ee,e,S,T,D,O,k,A,m,s,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MOVE_CURSOR_1_LINE_COMMAND=e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.NotebookFindScopeType=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_LINE_BOUNDARY=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.MimeTypeDisplayOrder=e.CellUri=e.NotebookUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=e.EXECUTE_REPL_COMMAND_ID=e.REPL_EDITOR_ID=e.INTERACTIVE_WINDOW_EDITOR_ID=e.NOTEBOOK_MULTI_DIFF_EDITOR_ID=e.NOTEBOOK_DIFF_EDITOR_ID=e.NOTEBOOK_EDITOR_ID=void 0,e.diff=g,e.isDocumentExcludePattern=_,e.notebookDocumentFilterMatch=y,e.isTextStreamMime=R,e.compressOutputItemStreams=b,T=Ve(T),e.NOTEBOOK_EDITOR_ID="workbench.editor.notebook",e.NOTEBOOK_DIFF_EDITOR_ID="workbench.editor.notebookTextDiffEditor",e.NOTEBOOK_MULTI_DIFF_EDITOR_ID="workbench.editor.notebookMultiTextDiffEditor",e.INTERACTIVE_WINDOW_EDITOR_ID="workbench.editor.interactive",e.REPL_EDITOR_ID="workbench.editor.repl",e.EXECUTE_REPL_COMMAND_ID="replNotebook.input.execute";var E;(function(Y){Y[Y.Markup=1]="Markup",Y[Y.Code=2]="Code"})(E||(e.CellKind=E={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",O.Mimes.latex,O.Mimes.markdown,"image/png","image/jpeg",O.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[O.Mimes.latex,O.Mimes.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",O.Mimes.text],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.RENDERER_NOT_AVAILABLE="_notAvailable";var u;(function(Y){Y[Y.Running=1]="Running",Y[Y.Idle=2]="Idle"})(u||(e.NotebookRunState=u={}));var C;(function(Y){Y[Y.Unconfirmed=1]="Unconfirmed",Y[Y.Pending=2]="Pending",Y[Y.Executing=3]="Executing"})(C||(e.NotebookCellExecutionState=C={}));var v;(function(Y){Y[Y.Unconfirmed=1]="Unconfirmed",Y[Y.Pending=2]="Pending",Y[Y.Executing=3]="Executing"})(v||(e.NotebookExecutionState=v={}));var r;(function(Y){Y[Y.WithHardKernelDependency=0]="WithHardKernelDependency",Y[Y.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",Y[Y.Pure=2]="Pure",Y[Y.Never=3]="Never"})(r||(e.NotebookRendererMatch=r={}));var a;(function(Y){Y.Always="always",Y.Never="never",Y.Optional="optional"})(a||(e.RendererMessagingSpec=a={}));var d;(function(Y){Y[Y.ModelChange=1]="ModelChange",Y[Y.Move=2]="Move",Y[Y.ChangeCellLanguage=5]="ChangeCellLanguage",Y[Y.Initialize=6]="Initialize",Y[Y.ChangeCellMetadata=7]="ChangeCellMetadata",Y[Y.Output=8]="Output",Y[Y.OutputItem=9]="OutputItem",Y[Y.ChangeCellContent=10]="ChangeCellContent",Y[Y.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",Y[Y.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",Y[Y.ChangeCellMime=13]="ChangeCellMime",Y[Y.Unknown=100]="Unknown"})(d||(e.NotebookCellsChangeType=d={}));var l;(function(Y){Y[Y.Handle=0]="Handle",Y[Y.Index=1]="Index"})(l||(e.SelectionStateType=l={}));var i;(function(Y){Y[Y.Replace=1]="Replace",Y[Y.Output=2]="Output",Y[Y.Metadata=3]="Metadata",Y[Y.CellLanguage=4]="CellLanguage",Y[Y.DocumentMetadata=5]="DocumentMetadata",Y[Y.Move=6]="Move",Y[Y.OutputItems=7]="OutputItems",Y[Y.PartialMetadata=8]="PartialMetadata",Y[Y.PartialInternalMetadata=9]="PartialInternalMetadata"})(i||(e.CellEditType=i={}));var n;(function(Y){Y.scheme=k.Schemas.vscodeNotebookMetadata;function ae(oe){return(0,I.generateMetadataUri)(oe)}Y.generate=ae;function ee(oe){return(0,I.parseMetadataUri)(oe)}Y.parse=ee})(n||(e.NotebookUri=n={}));var t;(function(Y){Y.scheme=k.Schemas.vscodeNotebookCell;function ae(ve,Ie){return(0,I.generate)(ve,Ie)}Y.generate=ae;function ee(ve){return(0,I.parse)(ve)}Y.parse=ee;function oe(ve,Ie){return ve.with({scheme:k.Schemas.vscodeNotebookCellOutput,fragment:`op${Ie??""},${ve.scheme!==k.Schemas.file?ve.scheme:""}`})}Y.generateCellOutputUri=oe;function ie(ve){if(ve.scheme!==k.Schemas.vscodeNotebookCellOutput)return;const Ie=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(ve.fragment);if(!Ie)return;const X=Ie[1]&&Ie[1]!==""?Ie[1]:void 0,V=Ie[2];return{outputId:X,notebook:ve.with({scheme:V||k.Schemas.file,fragment:null})}}Y.parseCellOutputUri=ie;function ue(ve,Ie,X){return Y.generate(ve,Ie).with({scheme:X})}Y.generateCellPropertyUri=ue;function Z(ve,Ie){if(ve.scheme===Ie)return Y.parse(ve.with({scheme:Y.scheme}))}Y.parseCellPropertyUri=Z})(t||(e.CellUri=t={}));const o=Y=>m.isWindows?Y.replace(/\//g,"\\"):Y;class c{constructor(ae=[],ee=e.NOTEBOOK_DISPLAY_ORDER){this.defaultOrder=ee,this.order=[...new Set(ae)].map(oe=>({pattern:oe,matches:T.parse(o(oe))}))}sort(ae){const ee=new Map(D.Iterable.map(ae,ie=>[ie,o(ie)]));let oe=[];for(const{matches:ie}of this.order)for(const[ue,Z]of ee)if(ie(Z)){oe.push(ue),ee.delete(ue);break}return ee.size&&(oe=oe.concat([...ee.keys()].sort((ie,ue)=>this.defaultOrder.indexOf(ie)-this.defaultOrder.indexOf(ue)))),oe}prioritize(ae,ee){const oe=this.findIndex(ae);if(oe===-1){this.order.unshift({pattern:ae,matches:T.parse(o(ae))});return}const ie=new Set(ee.map(Z=>this.findIndex(Z,oe)));ie.delete(-1);const ue=Array.from(ie).sort();this.order.splice(oe+1,0,...ue.map(Z=>this.order[Z]));for(let Z=ue.length-1;Z>=0;Z--)this.order.splice(ue[Z],1)}toArray(){return this.order.map(ae=>ae.pattern)}findIndex(ae,ee=this.order.length){const oe=o(ae);for(let ie=0;ie<ee;ie++)if(this.order[ie].matches(oe))return ie;return-1}}e.MimeTypeDisplayOrder=c;function g(Y,ae,ee,oe=(ie,ue)=>ie===ue){const ie=[];function ue(Ie,X,V){if(X===0&&V.length===0)return;const re=ie[ie.length-1];re&&re.start+re.deleteCount===Ie?(re.deleteCount+=X,re.toInsert.push(...V)):ie.push({start:Ie,deleteCount:X,toInsert:V})}let Z=0,ve=0;for(;;){if(Z===Y.length){ue(Z,0,ae.slice(ve));break}if(ve===ae.length){ue(Z,Y.length-Z,[]);break}const Ie=Y[Z],X=ae[ve];if(oe(Ie,X)){Z+=1,ve+=1;continue}ee(X)?(ue(Z,1,[]),Z+=1):(ue(Z,0,[X]),ve+=1)}return ie}e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new s.RawContextKey("notebookEditorCursorAtBoundary","none"),e.NOTEBOOK_EDITOR_CURSOR_LINE_BOUNDARY=new s.RawContextKey("notebookEditorCursorAtLineBoundary","none");var f;(function(Y){Y.default="default",Y.option="option"})(f||(e.NotebookEditorPriority=f={}));var h;(function(Y){Y.Cells="cells",Y.Text="text",Y.None="none"})(h||(e.NotebookFindScopeType=h={}));function _(Y){const ae=Y;return!!((typeof ae.include=="string"||T.isRelativePattern(ae.include))&&(typeof ae.exclude=="string"||T.isRelativePattern(ae.exclude)))}function y(Y,ae,ee){if(Array.isArray(Y.viewType)&&Y.viewType.indexOf(ae)>=0||Y.viewType===ae)return!0;if(Y.filenamePattern){const oe=_(Y.filenamePattern)?Y.filenamePattern.include:Y.filenamePattern,ie=_(Y.filenamePattern)?Y.filenamePattern.exclude:void 0;if(T.match(oe,(0,A.basename)(ee.fsPath).toLowerCase()))return!(ie&&T.match(ie,(0,A.basename)(ee.fsPath).toLowerCase()))}return!1}e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScrollEnabled:"notebook.stickyScroll.enabled",stickyScrollMode:"notebook.stickyScroll.mode",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",markdownLineHeight:"notebook.markdown.lineHeight",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",LinkifyOutputFilePaths:"notebook.output.linkifyFilePaths",minimalErrorRendering:"notebook.output.minimalErrorRendering",formatOnSave:"notebook.formatOnSave.enabled",insertFinalNewline:"notebook.insertFinalNewline",defaultFormatter:"notebook.defaultFormatter",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findFilters:"notebook.find.filters",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",outlineShowMarkdownHeadersOnly:"notebook.outline.showMarkdownHeadersOnly",outlineShowCodeCells:"notebook.outline.showCodeCells",outlineShowCodeCellSymbols:"notebook.outline.showCodeCellSymbols",breadcrumbsShowCodeCells:"notebook.breadcrumbs.showCodeCells",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",cellChat:"notebook.experimental.cellChat",cellGenerate:"notebook.experimental.generate",notebookVariablesView:"notebook.experimental.variablesView",InteractiveWindowPromptToSave:"interactiveWindow.promptToSaveOnClose",cellFailureDiagnostics:"notebook.cellFailureDiagnostics",outputBackupSizeLimit:"notebook.backup.sizeLimit"};var w;(function(Y){Y[Y.Left=1]="Left",Y[Y.Right=2]="Right"})(w||(e.CellStatusbarAlignment=w={}));class P{static{this._prefix="notebook/"}static create(ae){return`${P._prefix}${ae}`}static parse(ae){if(ae.startsWith(P._prefix))return ae.substring(P._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=P;function R(Y){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(Y)}const p=new TextDecoder;function b(Y){const ae=[];let ee=!1;for(const Z of Y)(ae.length===0||ee)&&(ae.push(Z),ee=!0);let oe=F(ae);const ie=S.VSBuffer.concat(ae.map(Z=>S.VSBuffer.wrap(Z))),ue=G(ie);return oe=oe||ue.byteLength!==ie.byteLength,{data:ue,didCompression:oe}}e.MOVE_CURSOR_1_LINE_COMMAND="\x1B[A";const N=e.MOVE_CURSOR_1_LINE_COMMAND.split("").map(Y=>Y.charCodeAt(0)),L=10;function F(Y){let ae=!1;return Y.forEach((ee,oe)=>{if(oe===0||ee.length<e.MOVE_CURSOR_1_LINE_COMMAND.length)return;const ie=Y[oe-1],ue=ee.subarray(0,e.MOVE_CURSOR_1_LINE_COMMAND.length);if(ue[0]===N[0]&&ue[1]===N[1]&&ue[2]===N[2]){const Z=ie.lastIndexOf(L);if(Z===-1)return;ae=!0,Y[oe-1]=ie.subarray(0,Z),Y[oe]=ee.subarray(e.MOVE_CURSOR_1_LINE_COMMAND.length)}}),ae}function K(Y){let ae=Y;do Y=ae,ae=Y.replace(/[^\n]\x08/gm,"");while(ae.length<Y.length);return Y}function J(Y){for(Y=Y.replace(/\r+\n/gm,`
`);Y.search(/\r[^$]/g)>-1;){const ae=Y.match(/^(.*)\r+/m)[1];let ee=Y.match(/\r+(.*)$/m)[1];ee=ee+ae.slice(ee.length,ae.length),Y=Y.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,ee)}return Y}const $=8,x=13;function G(Y){return!Y.buffer.includes($)&&!Y.buffer.includes(x)?Y:S.VSBuffer.fromString(J(K(p.decode(Y.buffer))))}}),define(ke[7],Re([1,0,17,12,59,27,72,13,14,2,33,18,28,110,90]),function(Ee,e,S,T,D,O,k,A,m,s,I,E,u,C,v){"use strict";var r,a,d,l,i,n,t,o,c,g,f,h,_,y,w,P,R;Object.defineProperty(e,"__esModule",{value:!0}),e.InlineEditTriggerKind=e.InlineEdit=e.KeywordRecognitionStatus=e.TextToSpeechStatus=e.SpeechToTextStatus=e.RelatedInformationType=e.LanguageModelError=e.LanguageModelChatAssistantMessage=e.LanguageModelChatUserMessage=e.LanguageModelChatSystemMessage=e.LanguageModelTextPart=e.LanguageModelToolCallPart=e.LanguageModelChatMessage=e.LanguageModelToolResultPart=e.LanguageModelChatMessageRole=e.ChatRequestNotebookData=e.ChatRequestEditorData=e.ChatResponseReferencePartStatusKind=e.ChatLocation=e.ChatResponseTurn=e.ChatRequestTurn=e.ChatResponseTextEditPart=e.ChatResponseMovePart=e.ChatResponseCodeCitationPart=e.ChatResponseReferencePart=e.ChatResponseCommandButtonPart=e.ChatResponseWarningPart=e.ChatResponseProgressPart2=e.ChatResponseProgressPart=e.ChatResponseAnchorPart=e.ChatResponseFileTreePart=e.ChatResponseConfirmationPart=e.ChatResponseDetectedParticipantPart=e.ChatResponseMarkdownWithVulnerabilitiesPart=e.ChatResponseMarkdownPart=e.ChatResultFeedbackKind=e.InteractiveEditorResponseFeedbackKind=e.ChatCompletionItem=e.ChatVariableLevel=e.ChatCopyKind=e.InteractiveSessionVoteDirection=e.TextMultiDiffTabInput=e.ChatEditorTabInput=e.InteractiveWindowInput=e.TerminalEditorTabInput=e.NotebookDiffEditorTabInput=e.NotebookEditorTabInput=e.WebviewEditorTabInput=e.CustomEditorTabInput=e.TextMergeTabInput=e.TextDiffTabInput=e.TextTabInput=e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.DeclarationCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.TestCoverageCount=e.TestMessageStackFrame=e.TestTag=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookVariablesRequestKind=e.NotebookKernelSourceAction=e.NotebookRendererScript=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.QuickInputButtons=e.QuickInputButtonLocation=e.DebugVisualization=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentThreadFocus=e.CommentThreadApplicability=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.NewSymbolName=e.NewSymbolNameTriggerKind=e.NewSymbolNameTag=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugThread=e.DebugStackFrame=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.DocumentPasteEdit=e.DocumentDropOrPasteEditKind=e.DocumentPasteTriggerKind=e.DocumentDropEdit=e.DataTransfer=e.DataTransferFile=e.InternalFileDataTransferItem=e.InternalDataTransferItem=e.DataTransferItem=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.TreeItem=e.ViewBadge=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalQuickFixCommand=e.TerminalQuickFixOpener=e.TerminalLink=e.TerminalShellExecutionCommandLineConfidence=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.PartialAcceptTriggerKind=e.InlineSuggestionList=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintLabelPart=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.MultiDocumentHighlight=e.DocumentHighlight=e.DocumentHighlightKind=e.HoverVerbosityAction=e.VerboseHover=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.SnippetTextEdit=e.NotebookEdit=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ManagedResolvedAuthority=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0,e.getDebugDescriptionOfRange=$,e.getDebugDescriptionOfSelection=x,e.asStatusBarItemIdentifier=ht,e.setBreakpointId=$i,e.validateTestCoverageCount=Pn;function p(U){return Object.assign(U,{apply:function(...ne){if(ne.length===0)return Reflect.construct(U,[]);{const _e=ne.length===1?[]:ne[1];return Reflect.construct(U,_e,ne[0].constructor)}},call:function(...ne){if(ne.length===0)return Reflect.construct(U,[]);{const[_e,...je]=ne;return Reflect.construct(U,je,_e.constructor)}}})}var b;(function(U){U[U.Top=0]="Top",U[U.Bottom=1]="Bottom"})(b||(e.TerminalOutputAnchor=b={}));var N;(function(U){U[U.TerminalCommand=0]="TerminalCommand",U[U.Opener=1]="Opener",U[U.Command=3]="Command"})(N||(e.TerminalQuickFixType=N={}));let L=r=class{static from(...M){let ne=M;return new r(function(){if(ne){for(const _e of ne)_e&&typeof _e.dispose=="function"&&_e.dispose();ne=void 0}})}#e;constructor(M){this.#e=M}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.Disposable=L,e.Disposable=L=r=qe([p],L);let F=a=class{static Min(...M){if(M.length===0)throw new TypeError;let ne=M[0];for(let _e=1;_e<M.length;_e++){const je=M[_e];je.isBefore(ne)&&(ne=je)}return ne}static Max(...M){if(M.length===0)throw new TypeError;let ne=M[0];for(let _e=1;_e<M.length;_e++){const je=M[_e];je.isAfter(ne)&&(ne=je)}return ne}static isPosition(M){if(!M)return!1;if(M instanceof a)return!0;const{line:ne,character:_e}=M;return typeof ne=="number"&&typeof _e=="number"}static of(M){if(M instanceof a)return M;if(this.isPosition(M))return new a(M.line,M.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this._line}get character(){return this._character}constructor(M,ne){if(M<0)throw(0,T.illegalArgument)("line must be non-negative");if(ne<0)throw(0,T.illegalArgument)("character must be non-negative");this._line=M,this._character=ne}isBefore(M){return this._line<M._line?!0:M._line<this._line?!1:this._character<M._character}isBeforeOrEqual(M){return this._line<M._line?!0:M._line<this._line?!1:this._character<=M._character}isAfter(M){return!this.isBeforeOrEqual(M)}isAfterOrEqual(M){return!this.isBefore(M)}isEqual(M){return this._line===M._line&&this._character===M._character}compareTo(M){return this._line<M._line?-1:this._line>M.line?1:this._character<M._character?-1:this._character>M._character?1:0}translate(M,ne=0){if(M===null||ne===null)throw(0,T.illegalArgument)();let _e;return typeof M>"u"?_e=0:typeof M=="number"?_e=M:(_e=typeof M.lineDelta=="number"?M.lineDelta:0,ne=typeof M.characterDelta=="number"?M.characterDelta:0),_e===0&&ne===0?this:new a(this.line+_e,this.character+ne)}with(M,ne=this.character){if(M===null||ne===null)throw(0,T.illegalArgument)();let _e;return typeof M>"u"?_e=this.line:typeof M=="number"?_e=M:(_e=typeof M.line=="number"?M.line:this.line,ne=typeof M.character=="number"?M.character:this.character),_e===this.line&&ne===this.character?this:new a(_e,ne)}toJSON(){return{line:this.line,character:this.character}}[Symbol.for("debug.description")](){return`(${this.line}:${this.character})`}};e.Position=F,e.Position=F=a=qe([p],F);let K=d=class{static isRange(M){return M instanceof d?!0:M?F.isPosition(M.start)&&F.isPosition(M.end):!1}static of(M){if(M instanceof d)return M;if(this.isRange(M))return new d(M.start,M.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this._start}get end(){return this._end}constructor(M,ne,_e,je){let rt,pt;if(typeof M=="number"&&typeof ne=="number"&&typeof _e=="number"&&typeof je=="number"?(rt=new F(M,ne),pt=new F(_e,je)):F.isPosition(M)&&F.isPosition(ne)&&(rt=F.of(M),pt=F.of(ne)),!rt||!pt)throw new Error("Invalid arguments");rt.isBefore(pt)?(this._start=rt,this._end=pt):(this._start=pt,this._end=rt)}contains(M){return d.isRange(M)?this.contains(M.start)&&this.contains(M.end):F.isPosition(M)?!(F.of(M).isBefore(this._start)||this._end.isBefore(M)):!1}isEqual(M){return this._start.isEqual(M._start)&&this._end.isEqual(M._end)}intersection(M){const ne=F.Max(M.start,this._start),_e=F.Min(M.end,this._end);if(!ne.isAfter(_e))return new d(ne,_e)}union(M){if(this.contains(M))return this;if(M.contains(this))return M;const ne=F.Min(M.start,this._start),_e=F.Max(M.end,this.end);return new d(ne,_e)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(M,ne=this.end){if(M===null||ne===null)throw(0,T.illegalArgument)();let _e;return M?F.isPosition(M)?_e=M:(_e=M.start||this.start,ne=M.end||this.end):_e=this.start,_e.isEqual(this._start)&&ne.isEqual(this.end)?this:new d(_e,ne)}toJSON(){return[this.start,this.end]}[Symbol.for("debug.description")](){return $(this)}};e.Range=K,e.Range=K=d=qe([p],K);let J=l=class extends K{static isSelection(M){return M instanceof l?!0:M?K.isRange(M)&&F.isPosition(M.anchor)&&F.isPosition(M.active)&&typeof M.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}constructor(M,ne,_e,je){let rt,pt;if(typeof M=="number"&&typeof ne=="number"&&typeof _e=="number"&&typeof je=="number"?(rt=new F(M,ne),pt=new F(_e,je)):F.isPosition(M)&&F.isPosition(ne)&&(rt=F.of(M),pt=F.of(ne)),!rt||!pt)throw new Error("Invalid arguments");super(rt,pt),this._anchor=rt,this._active=pt}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}[Symbol.for("debug.description")](){return x(this)}};e.Selection=J,e.Selection=J=l=qe([p],J);function $(U){return U.isEmpty?`[${U.start.line}:${U.start.character})`:`[${U.start.line}:${U.start.character} -> ${U.end.line}:${U.end.character})`}function x(U){let M=$(U);return U.isEmpty||(U.active.isEqual(U.start)?M=`|${M}`:M=`${M}|`),M}const G=U=>{if(typeof U!="string"||U.length===0||!/^[0-9A-Za-z_\-]+$/.test(U))throw(0,T.illegalArgument)("connectionToken")};class Y{static isResolvedAuthority(M){return M&&typeof M=="object"&&typeof M.host=="string"&&typeof M.port=="number"&&(M.connectionToken===void 0||typeof M.connectionToken=="string")}constructor(M,ne,_e){if(typeof M!="string"||M.length===0)throw(0,T.illegalArgument)("host");if(typeof ne!="number"||ne===0||Math.round(ne)!==ne)throw(0,T.illegalArgument)("port");typeof _e<"u"&&G(_e),this.host=M,this.port=Math.round(ne),this.connectionToken=_e}}e.ResolvedAuthority=Y;class ae{static isManagedResolvedAuthority(M){return M&&typeof M=="object"&&typeof M.makeConnection=="function"&&(M.connectionToken===void 0||typeof M.connectionToken=="string")}constructor(M,ne){this.makeConnection=M,this.connectionToken=ne,typeof ne<"u"&&G(ne)}}e.ManagedResolvedAuthority=ae;class ee extends Error{static NotAvailable(M,ne){return new ee(M,C.RemoteAuthorityResolverErrorCode.NotAvailable,ne)}static TemporarilyNotAvailable(M){return new ee(M,C.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(M,ne=C.RemoteAuthorityResolverErrorCode.Unknown,_e){super(M),this._message=M,this._code=ne,this._detail=_e,Object.setPrototypeOf(this,ee.prototype)}}e.RemoteAuthorityResolverError=ee;var oe;(function(U){U[U.LF=1]="LF",U[U.CRLF=2]="CRLF"})(oe||(e.EndOfLine=oe={}));var ie;(function(U){U[U.Replace=1]="Replace",U[U.Append=2]="Append",U[U.Prepend=3]="Prepend"})(ie||(e.EnvironmentVariableMutatorType=ie={}));let ue=i=class{static isTextEdit(M){return M instanceof i?!0:M?K.isRange(M)&&typeof M.newText=="string":!1}static replace(M,ne){return new i(M,ne)}static insert(M,ne){return i.replace(new K(M,M),ne)}static delete(M){return i.replace(M,"")}static setEndOfLine(M){const ne=new i(new K(new F(0,0),new F(0,0)),"");return ne.newEol=M,ne}get range(){return this._range}set range(M){if(M&&!K.isRange(M))throw(0,T.illegalArgument)("range");this._range=M}get newText(){return this._newText||""}set newText(M){if(M&&typeof M!="string")throw(0,T.illegalArgument)("newText");this._newText=M}get newEol(){return this._newEol}set newEol(M){if(M&&typeof M!="number")throw(0,T.illegalArgument)("newEol");this._newEol=M}constructor(M,ne){this._range=M,this._newText=ne}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};e.TextEdit=ue,e.TextEdit=ue=i=qe([p],ue);let Z=n=class{static isNotebookCellEdit(M){return M instanceof n?!0:M?Ci.isNotebookRange(M)&&Array.isArray(M.newCells):!1}static replaceCells(M,ne){return new n(M,ne)}static insertCells(M,ne){return new n(new Ci(M,M),ne)}static deleteCells(M){return new n(M,[])}static updateCellMetadata(M,ne){const _e=new n(new Ci(M,M),[]);return _e.newCellMetadata=ne,_e}static updateNotebookMetadata(M){const ne=new n(new Ci(0,0),[]);return ne.newNotebookMetadata=M,ne}constructor(M,ne){this.range=M,this.newCells=ne}};e.NotebookEdit=Z,e.NotebookEdit=Z=n=qe([p],Z);class ve{static isSnippetTextEdit(M){return M instanceof ve?!0:M?K.isRange(M.range)&&V.isSnippetString(M.snippet):!1}static replace(M,ne){return new ve(M,ne)}static insert(M,ne){return ve.replace(new K(M,M),ne)}constructor(M,ne){this.range=M,this.snippet=ne}}e.SnippetTextEdit=ve;var Ie;(function(U){U[U.File=1]="File",U[U.Text=2]="Text",U[U.Cell=3]="Cell",U[U.CellReplace=5]="CellReplace",U[U.Snippet=6]="Snippet"})(Ie||(e.FileEditType=Ie={}));let X=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(M,ne,_e,je){this._edits.push({_type:Ie.File,from:M,to:ne,options:_e,metadata:je})}createFile(M,ne,_e){this._edits.push({_type:Ie.File,from:void 0,to:M,options:ne,metadata:_e})}deleteFile(M,ne,_e){this._edits.push({_type:Ie.File,from:M,to:void 0,options:ne,metadata:_e})}replaceNotebookMetadata(M,ne,_e){this._edits.push({_type:Ie.Cell,metadata:_e,uri:M,edit:{editType:v.CellEditType.DocumentMetadata,metadata:ne},notebookMetadata:ne})}replaceNotebookCells(M,ne,_e,je){const rt=ne.start,pt=ne.end;(rt!==pt||_e.length>0)&&this._edits.push({_type:Ie.CellReplace,uri:M,index:rt,count:pt-rt,cells:_e,metadata:je})}replaceNotebookCellMetadata(M,ne,_e,je){this._edits.push({_type:Ie.Cell,metadata:je,uri:M,edit:{editType:v.CellEditType.Metadata,index:ne,metadata:_e}})}replace(M,ne,_e,je){this._edits.push({_type:Ie.Text,uri:M,edit:new ue(ne,_e),metadata:je})}insert(M,ne,_e,je){this.replace(M,new K(ne,ne),_e,je)}delete(M,ne,_e){this.replace(M,ne,"",_e)}has(M){return this._edits.some(ne=>ne._type===Ie.Text&&ne.uri.toString()===M.toString())}set(M,ne){if(ne)for(const _e of ne){if(!_e)continue;let je,rt;Array.isArray(_e)?(je=_e[0],rt=_e[1]):je=_e,Z.isNotebookCellEdit(je)?je.newCellMetadata?this.replaceNotebookCellMetadata(M,je.range.start,je.newCellMetadata,rt):je.newNotebookMetadata?this.replaceNotebookMetadata(M,je.newNotebookMetadata,rt):this.replaceNotebookCells(M,je.range,je.newCells,rt):ve.isSnippetTextEdit(je)?this._edits.push({_type:Ie.Snippet,uri:M,range:je.range,edit:je.snippet,metadata:rt}):this._edits.push({_type:Ie.Text,uri:M,edit:je,metadata:rt})}else{for(let _e=0;_e<this._edits.length;_e++){const je=this._edits[_e];switch(je._type){case Ie.Text:case Ie.Snippet:case Ie.Cell:case Ie.CellReplace:je.uri.toString()===M.toString()&&(this._edits[_e]=void 0);break}}(0,S.coalesceInPlace)(this._edits)}}get(M){const ne=[];for(const _e of this._edits)_e._type===Ie.Text&&_e.uri.toString()===M.toString()&&ne.push(_e.edit);return ne}entries(){const M=new O.ResourceMap;for(const ne of this._edits)if(ne._type===Ie.Text){let _e=M.get(ne.uri);_e||(_e=[ne.uri,[]],M.set(ne.uri,_e)),_e[1].push(ne.edit)}return[...M.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.WorkspaceEdit=X,e.WorkspaceEdit=X=qe([p],X);let V=t=class{static isSnippetString(M){return M instanceof t?!0:M?typeof M.value=="string":!1}static _escape(M){return M.replace(/\$|}|\\/g,"\\$&")}constructor(M){this._tabstop=1,this.value=M||""}appendText(M){return this.value+=t._escape(M),this}appendTabstop(M=this._tabstop++){return this.value+="$",this.value+=M,this}appendPlaceholder(M,ne=this._tabstop++){if(typeof M=="function"){const _e=new t;_e._tabstop=this._tabstop,M(_e),this._tabstop=_e._tabstop,M=_e.value}else M=t._escape(M);return this.value+="${",this.value+=ne,this.value+=":",this.value+=M,this.value+="}",this}appendChoice(M,ne=this._tabstop++){const _e=M.map(je=>je.replaceAll(/[|\\,]/g,"\\$&")).join(",");return this.value+="${",this.value+=ne,this.value+="|",this.value+=_e,this.value+="|}",this}appendVariable(M,ne){if(typeof ne=="function"){const _e=new t;_e._tabstop=this._tabstop,ne(_e),this._tabstop=_e._tabstop,ne=_e.value}else typeof ne=="string"&&(ne=ne.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=M,ne&&(this.value+=":",this.value+=ne),this.value+="}",this}};e.SnippetString=V,e.SnippetString=V=t=qe([p],V);var re;(function(U){U[U.Unnecessary=1]="Unnecessary",U[U.Deprecated=2]="Deprecated"})(re||(e.DiagnosticTag=re={}));var be;(function(U){U[U.Hint=3]="Hint",U[U.Information=2]="Information",U[U.Warning=1]="Warning",U[U.Error=0]="Error"})(be||(e.DiagnosticSeverity=be={}));let De=o=class{static isLocation(M){return M instanceof o?!0:M?K.isRange(M.range)&&s.URI.isUri(M.uri):!1}constructor(M,ne){if(this.uri=M,ne)if(K.isRange(ne))this.range=K.of(ne);else if(F.isPosition(ne))this.range=new K(ne,ne);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.Location=De,e.Location=De=o=qe([p],De);let Fe=class{static is(M){return M?typeof M.message=="string"&&M.location&&K.isRange(M.location.range)&&s.URI.isUri(M.location.uri):!1}constructor(M,ne){this.location=M,this.message=ne}static isEqual(M,ne){return M===ne?!0:!M||!ne?!1:M.message===ne.message&&M.location.range.isEqual(ne.location.range)&&M.location.uri.toString()===ne.location.uri.toString()}};e.DiagnosticRelatedInformation=Fe,e.DiagnosticRelatedInformation=Fe=qe([p],Fe);let ze=class{constructor(M,ne,_e=be.Error){if(!K.isRange(M))throw new TypeError("range must be set");if(!ne)throw new TypeError("message must be set");this.range=M,this.message=ne,this.severity=_e}toJSON(){return{severity:be[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(M,ne){return M===ne?!0:!M||!ne?!1:M.message===ne.message&&M.severity===ne.severity&&M.code===ne.code&&M.severity===ne.severity&&M.source===ne.source&&M.range.isEqual(ne.range)&&(0,S.equals)(M.tags,ne.tags)&&(0,S.equals)(M.relatedInformation,ne.relatedInformation,Fe.isEqual)}};e.Diagnostic=ze,e.Diagnostic=ze=qe([p],ze);let Je=class{constructor(M,ne){if(!M)throw new Error("Illegal argument, contents must be defined");Array.isArray(M)?this.contents=M:this.contents=[M],this.range=ne}};e.Hover=Je,e.Hover=Je=qe([p],Je);let nt=class extends Je{constructor(M,ne,_e,je){super(M,ne),this.canIncreaseVerbosity=_e,this.canDecreaseVerbosity=je}};e.VerboseHover=nt,e.VerboseHover=nt=qe([p],nt);var dt;(function(U){U[U.Increase=0]="Increase",U[U.Decrease=1]="Decrease"})(dt||(e.HoverVerbosityAction=dt={}));var vt;(function(U){U[U.Text=0]="Text",U[U.Read=1]="Read",U[U.Write=2]="Write"})(vt||(e.DocumentHighlightKind=vt={}));let ut=class{constructor(M,ne=vt.Text){this.range=M,this.kind=ne}toJSON(){return{range:this.range,kind:vt[this.kind]}}};e.DocumentHighlight=ut,e.DocumentHighlight=ut=qe([p],ut);let et=class{constructor(M,ne){this.uri=M,this.highlights=ne}toJSON(){return{uri:this.uri,highlights:this.highlights.map(M=>M.toJSON())}}};e.MultiDocumentHighlight=et,e.MultiDocumentHighlight=et=qe([p],et);var Oe;(function(U){U[U.File=0]="File",U[U.Module=1]="Module",U[U.Namespace=2]="Namespace",U[U.Package=3]="Package",U[U.Class=4]="Class",U[U.Method=5]="Method",U[U.Property=6]="Property",U[U.Field=7]="Field",U[U.Constructor=8]="Constructor",U[U.Enum=9]="Enum",U[U.Interface=10]="Interface",U[U.Function=11]="Function",U[U.Variable=12]="Variable",U[U.Constant=13]="Constant",U[U.String=14]="String",U[U.Number=15]="Number",U[U.Boolean=16]="Boolean",U[U.Array=17]="Array",U[U.Object=18]="Object",U[U.Key=19]="Key",U[U.Null=20]="Null",U[U.EnumMember=21]="EnumMember",U[U.Struct=22]="Struct",U[U.Event=23]="Event",U[U.Operator=24]="Operator",U[U.TypeParameter=25]="TypeParameter"})(Oe||(e.SymbolKind=Oe={}));var Me;(function(U){U[U.Deprecated=1]="Deprecated"})(Me||(e.SymbolTag=Me={}));let Ne=c=class{static validate(M){if(!M.name)throw new Error("name must not be falsy")}constructor(M,ne,_e,je,rt){this.name=M,this.kind=ne,this.containerName=rt,typeof _e=="string"&&(this.containerName=_e),je instanceof De?this.location=je:_e instanceof K&&(this.location=new De(je,_e)),c.validate(this)}toJSON(){return{name:this.name,kind:Oe[this.kind],location:this.location,containerName:this.containerName}}};e.SymbolInformation=Ne,e.SymbolInformation=Ne=c=qe([p],Ne);let B=g=class{static validate(M){if(!M.name)throw new Error("name must not be falsy");if(!M.range.contains(M.selectionRange))throw new Error("selectionRange must be contained in fullRange");M.children?.forEach(g.validate)}constructor(M,ne,_e,je,rt){this.name=M,this.detail=ne,this.kind=_e,this.range=je,this.selectionRange=rt,this.children=[],g.validate(this)}};e.DocumentSymbol=B,e.DocumentSymbol=B=g=qe([p],B);var z;(function(U){U[U.Invoke=1]="Invoke",U[U.Automatic=2]="Automatic"})(z||(e.CodeActionTriggerKind=z={}));let H=class{constructor(M,ne){this.title=M,this.kind=ne}};e.CodeAction=H,e.CodeAction=H=qe([p],H);let q=class{static{f=this}static{this.sep="."}constructor(M){this.value=M}append(M){return new f(this.value?this.value+f.sep+M:M)}intersects(M){return this.contains(M)||M.contains(this)}contains(M){return this.value===M.value||M.value.startsWith(this.value+f.sep)}};e.CodeActionKind=q,e.CodeActionKind=q=f=qe([p],q),q.Empty=new q(""),q.QuickFix=q.Empty.append("quickfix"),q.Refactor=q.Empty.append("refactor"),q.RefactorExtract=q.Refactor.append("extract"),q.RefactorInline=q.Refactor.append("inline"),q.RefactorMove=q.Refactor.append("move"),q.RefactorRewrite=q.Refactor.append("rewrite"),q.Source=q.Empty.append("source"),q.SourceOrganizeImports=q.Source.append("organizeImports"),q.SourceFixAll=q.Source.append("fixAll"),q.Notebook=q.Empty.append("notebook");let se=class{constructor(M,ne){if(this.range=M,this.parent=ne,ne&&!ne.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.SelectionRange=se,e.SelectionRange=se=qe([p],se);class ge{constructor(M,ne,_e,je,rt,pt){this.kind=M,this.name=ne,this.detail=_e,this.uri=je,this.range=rt,this.selectionRange=pt}}e.CallHierarchyItem=ge;class ye{constructor(M,ne){this.fromRanges=ne,this.from=M}}e.CallHierarchyIncomingCall=ye;class Ue{constructor(M,ne){this.fromRanges=ne,this.to=M}}e.CallHierarchyOutgoingCall=Ue;var Ge;(function(U){U[U.Information=0]="Information",U[U.Warning=1]="Warning",U[U.Error=2]="Error"})(Ge||(e.LanguageStatusSeverity=Ge={}));let Ze=class{constructor(M,ne){this.range=M,this.command=ne}get isResolved(){return!!this.command}};e.CodeLens=Ze,e.CodeLens=Ze=qe([p],Ze);let tt=h=class{#e;static isMarkdownString(M){return M instanceof h?!0:M&&M.appendCodeblock&&M.appendMarkdown&&M.appendText&&M.value!==void 0}constructor(M,ne=!1){this.#e=new D.MarkdownString(M,{supportThemeIcons:ne})}get value(){return this.#e.value}set value(M){this.#e.value=M}get isTrusted(){return this.#e.isTrusted}set isTrusted(M){this.#e.isTrusted=M}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(M){this.#e.supportThemeIcons=M}get supportHtml(){return this.#e.supportHtml}set supportHtml(M){this.#e.supportHtml=M}get baseUri(){return this.#e.baseUri}set baseUri(M){this.#e.baseUri=M}appendText(M){return this.#e.appendText(M),this}appendMarkdown(M){return this.#e.appendMarkdown(M),this}appendCodeblock(M,ne){return this.#e.appendCodeblock(ne??"",M),this}};e.MarkdownString=tt,e.MarkdownString=tt=h=qe([p],tt);let lt=class{constructor(M,ne){this.label=M,this.documentation=ne}};e.ParameterInformation=lt,e.ParameterInformation=lt=qe([p],lt);let it=class{constructor(M,ne){this.label=M,this.documentation=ne,this.parameters=[]}};e.SignatureInformation=it,e.SignatureInformation=it=qe([p],it);let at=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.SignatureHelp=at,e.SignatureHelp=at=qe([p],at);var wt;(function(U){U[U.Invoke=1]="Invoke",U[U.TriggerCharacter=2]="TriggerCharacter",U[U.ContentChange=3]="ContentChange"})(wt||(e.SignatureHelpTriggerKind=wt={}));var Qe;(function(U){U[U.Type=1]="Type",U[U.Parameter=2]="Parameter"})(Qe||(e.InlayHintKind=Qe={}));let de=class{constructor(M){this.value=M}};e.InlayHintLabelPart=de,e.InlayHintLabelPart=de=qe([p],de);let pe=class{constructor(M,ne,_e){this.position=M,this.label=ne,this.kind=_e}};e.InlayHint=pe,e.InlayHint=pe=qe([p],pe);var we;(function(U){U[U.Invoke=0]="Invoke",U[U.TriggerCharacter=1]="TriggerCharacter",U[U.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(we||(e.CompletionTriggerKind=we={}));var Pe;(function(U){U[U.Text=0]="Text",U[U.Method=1]="Method",U[U.Function=2]="Function",U[U.Constructor=3]="Constructor",U[U.Field=4]="Field",U[U.Variable=5]="Variable",U[U.Class=6]="Class",U[U.Interface=7]="Interface",U[U.Module=8]="Module",U[U.Property=9]="Property",U[U.Unit=10]="Unit",U[U.Value=11]="Value",U[U.Enum=12]="Enum",U[U.Keyword=13]="Keyword",U[U.Snippet=14]="Snippet",U[U.Color=15]="Color",U[U.File=16]="File",U[U.Reference=17]="Reference",U[U.Folder=18]="Folder",U[U.EnumMember=19]="EnumMember",U[U.Constant=20]="Constant",U[U.Struct=21]="Struct",U[U.Event=22]="Event",U[U.Operator=23]="Operator",U[U.TypeParameter=24]="TypeParameter",U[U.User=25]="User",U[U.Issue=26]="Issue"})(Pe||(e.CompletionItemKind=Pe={}));var fe;(function(U){U[U.Deprecated=1]="Deprecated"})(fe||(e.CompletionItemTag=fe={}));let Se=class{constructor(M,ne){this.label=M,this.kind=ne}toJSON(){return{label:this.label,kind:this.kind&&Pe[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.CompletionItem=Se,e.CompletionItem=Se=qe([p],Se);let Q=class{constructor(M=[],ne=!1){this.items=M,this.isIncomplete=ne}};e.CompletionList=Q,e.CompletionList=Q=qe([p],Q);let W=class{constructor(M,ne,_e){this.insertText=M,this.range=ne,this.command=_e}};e.InlineSuggestion=W,e.InlineSuggestion=W=qe([p],W);let he=class{constructor(M){this.commands=void 0,this.suppressSuggestions=void 0,this.items=M}};e.InlineSuggestionList=he,e.InlineSuggestionList=he=qe([p],he);var $e;(function(U){U[U.Unknown=0]="Unknown",U[U.Word=1]="Word",U[U.Line=2]="Line",U[U.Suggest=3]="Suggest"})($e||(e.PartialAcceptTriggerKind=$e={}));var He;(function(U){U[U.Active=-1]="Active",U[U.Beside=-2]="Beside",U[U.One=1]="One",U[U.Two=2]="Two",U[U.Three=3]="Three",U[U.Four=4]="Four",U[U.Five=5]="Five",U[U.Six=6]="Six",U[U.Seven=7]="Seven",U[U.Eight=8]="Eight",U[U.Nine=9]="Nine"})(He||(e.ViewColumn=He={}));var st;(function(U){U[U.Left=1]="Left",U[U.Right=2]="Right"})(st||(e.StatusBarAlignment=st={}));function ht(U,M){return`${E.ExtensionIdentifier.toKey(U)}.${M}`}var mt;(function(U){U[U.Off=0]="Off",U[U.On=1]="On",U[U.Relative=2]="Relative",U[U.Interval=3]="Interval"})(mt||(e.TextEditorLineNumbersStyle=mt={}));var Rt;(function(U){U[U.Manual=1]="Manual",U[U.AfterDelay=2]="AfterDelay",U[U.FocusOut=3]="FocusOut"})(Rt||(e.TextDocumentSaveReason=Rt={}));var At;(function(U){U[U.Default=0]="Default",U[U.InCenter=1]="InCenter",U[U.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",U[U.AtTop=3]="AtTop"})(At||(e.TextEditorRevealType=At={}));var Ht;(function(U){U[U.Keyboard=1]="Keyboard",U[U.Mouse=2]="Mouse",U[U.Command=3]="Command"})(Ht||(e.TextEditorSelectionChangeKind=Ht={}));var Zt;(function(U){U[U.Undo=1]="Undo",U[U.Redo=2]="Redo"})(Zt||(e.TextDocumentChangeReason=Zt={}));var Xe;(function(U){U[U.OpenOpen=0]="OpenOpen",U[U.ClosedClosed=1]="ClosedClosed",U[U.OpenClosed=2]="OpenClosed",U[U.ClosedOpen=3]="ClosedOpen"})(Xe||(e.DecorationRangeBehavior=Xe={})),function(U){function M(ne){switch(ne){case"keyboard":return U.Keyboard;case"mouse":return U.Mouse;case"api":return U.Command}}U.fromValue=M}(Ht||(e.TextEditorSelectionChangeKind=Ht={}));var Lt;(function(U){U[U.Other=0]="Other",U[U.Comment=1]="Comment",U[U.String=2]="String",U[U.RegEx=3]="RegEx"})(Lt||(e.SyntaxTokenType=Lt={})),function(U){function M(ne){switch(ne){case U.Other:return"other";case U.Comment:return"comment";case U.String:return"string";case U.RegEx:return"regex"}return"other"}U.toString=M}(Lt||(e.SyntaxTokenType=Lt={}));let xt=class{constructor(M,ne){if(ne&&!s.URI.isUri(ne))throw(0,T.illegalArgument)("target");if(!K.isRange(M)||M.isEmpty)throw(0,T.illegalArgument)("range");this.range=M,this.target=ne}};e.DocumentLink=xt,e.DocumentLink=xt=qe([p],xt);let Et=class{constructor(M,ne,_e,je){this.red=M,this.green=ne,this.blue=_e,this.alpha=je}};e.Color=Et,e.Color=Et=qe([p],Et);let Tt=class{constructor(M,ne){if(ne&&!(ne instanceof Et))throw(0,T.illegalArgument)("color");if(!K.isRange(M)||M.isEmpty)throw(0,T.illegalArgument)("range");this.range=M,this.color=ne}};e.ColorInformation=Tt,e.ColorInformation=Tt=qe([p],Tt);let ei=class{constructor(M){if(!M||typeof M!="string")throw(0,T.illegalArgument)("label");this.label=M}};e.ColorPresentation=ei,e.ColorPresentation=ei=qe([p],ei);var ti;(function(U){U[U.RGB=0]="RGB",U[U.HEX=1]="HEX",U[U.HSL=2]="HSL"})(ti||(e.ColorFormat=ti={}));var qt;(function(U){U[U.Error=0]="Error",U[U.Warning=1]="Warning",U[U.Information=2]="Information"})(qt||(e.SourceControlInputBoxValidationType=qt={}));var bt;(function(U){U[U.Unknown=0]="Unknown",U[U.Shutdown=1]="Shutdown",U[U.Process=2]="Process",U[U.User=3]="User",U[U.Extension=4]="Extension"})(bt||(e.TerminalExitReason=bt={}));var Ot;(function(U){U[U.Low=0]="Low",U[U.Medium=1]="Medium",U[U.High=2]="High"})(Ot||(e.TerminalShellExecutionCommandLineConfidence=Ot={}));class li{constructor(M,ne,_e){if(this.startIndex=M,this.length=ne,this.tooltip=_e,typeof M!="number"||M<0)throw(0,T.illegalArgument)("startIndex");if(typeof ne!="number"||ne<1)throw(0,T.illegalArgument)("length");if(_e!==void 0&&typeof _e!="string")throw(0,T.illegalArgument)("tooltip")}}e.TerminalLink=li;class Qt{constructor(M){this.uri=M}}e.TerminalQuickFixOpener=Qt;class Ke{constructor(M){this.terminalCommand=M}}e.TerminalQuickFixCommand=Ke;var ii;(function(U){U[U.Panel=1]="Panel",U[U.Editor=2]="Editor"})(ii||(e.TerminalLocation=ii={}));class ci{constructor(M){if(this.options=M,typeof M!="object")throw(0,T.illegalArgument)("options")}}e.TerminalProfile=ci;var di;(function(U){U[U.Always=1]="Always",U[U.Silent=2]="Silent",U[U.Never=3]="Never"})(di||(e.TaskRevealKind=di={}));var Ct;(function(U){U[U.Shared=1]="Shared",U[U.Dedicated=2]="Dedicated",U[U.New=3]="New"})(Ct||(e.TaskPanelKind=Ct={}));let $t=class{static{_=this}static{this.Clean=new _("clean","Clean")}static{this.Build=new _("build","Build")}static{this.Rebuild=new _("rebuild","Rebuild")}static{this.Test=new _("test","Test")}static from(M){switch(M){case"clean":return _.Clean;case"build":return _.Build;case"rebuild":return _.Rebuild;case"test":return _.Test;default:return}}constructor(M,ne){if(this.label=ne,typeof M!="string"||typeof ne!="string")throw(0,T.illegalArgument)("name");this._id=M}get id(){return this._id}};e.TaskGroup=$t,e.TaskGroup=$t=_=qe([p],$t);function Nt(U){let M="";for(let ne=0;ne<U.length;ne++)M+=U[ne].replace(/,/g,",,")+",";return M}let zt=class{constructor(M,ne,_e){if(typeof M!="string")throw(0,T.illegalArgument)("process");this._args=[],this._process=M,ne!==void 0&&(Array.isArray(ne)?(this._args=ne,this._options=_e):this._options=ne)}get process(){return this._process}set process(M){if(typeof M!="string")throw(0,T.illegalArgument)("process");this._process=M}get args(){return this._args}set args(M){Array.isArray(M)||(M=[]),this._args=M}get options(){return this._options}set options(M){this._options=M}computeId(){const M=[];if(M.push("process"),this._process!==void 0&&M.push(this._process),this._args&&this._args.length>0)for(const ne of this._args)M.push(ne);return Nt(M)}};e.ProcessExecution=zt,e.ProcessExecution=zt=qe([p],zt);let ai=class{constructor(M,ne,_e){if(this._args=[],Array.isArray(ne)){if(!M)throw(0,T.illegalArgument)("command can't be undefined or null");if(typeof M!="string"&&typeof M.value!="string")throw(0,T.illegalArgument)("command");this._command=M,this._args=ne,this._options=_e}else{if(typeof M!="string")throw(0,T.illegalArgument)("commandLine");this._commandLine=M,this._options=ne}}get commandLine(){return this._commandLine}set commandLine(M){if(typeof M!="string")throw(0,T.illegalArgument)("commandLine");this._commandLine=M}get command(){return this._command?this._command:""}set command(M){if(typeof M!="string"&&typeof M.value!="string")throw(0,T.illegalArgument)("command");this._command=M}get args(){return this._args}set args(M){this._args=M||[]}get options(){return this._options}set options(M){this._options=M}computeId(){const M=[];if(M.push("shell"),this._commandLine!==void 0&&M.push(this._commandLine),this._command!==void 0&&M.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(const ne of this._args)M.push(typeof ne=="string"?ne:ne.value);return Nt(M)}};e.ShellExecution=ai,e.ShellExecution=ai=qe([p],ai);var ni;(function(U){U[U.Escape=1]="Escape",U[U.Strong=2]="Strong",U[U.Weak=3]="Weak"})(ni||(e.ShellQuoting=ni={}));var ri;(function(U){U[U.Global=1]="Global",U[U.Workspace=2]="Workspace"})(ri||(e.TaskScope=ri={}));class Kt{constructor(M){this._callback=M}computeId(){return"customExecution"+(0,I.generateUuid)()}set callback(M){this._callback=M}get callback(){return this._callback}}e.CustomExecution=Kt;let Gt=class{static{y=this}static{this.ExtensionCallbackType="customExecution"}static{this.ProcessType="process"}static{this.ShellType="shell"}static{this.EmptyType="$empty"}constructor(M,ne,_e,je,rt,pt){this.__deprecated=!1,this._definition=this.definition=M;let _t;typeof ne=="string"?(this._name=this.name=ne,this._source=this.source=_e,this.execution=je,_t=rt,this.__deprecated=!0):ne===ri.Global||ne===ri.Workspace?(this.target=ne,this._name=this.name=_e,this._source=this.source=je,this.execution=rt,_t=pt):(this.target=ne,this._name=this.name=_e,this._source=this.source=je,this.execution=rt,_t=pt),typeof _t=="string"?(this._problemMatchers=[_t],this._hasDefinedMatchers=!0):Array.isArray(_t)?(this._problemMatchers=_t,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(M){this.__id=M}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof zt?this._definition={type:y.ProcessType,id:this._execution.computeId()}:this._execution instanceof ai?this._definition={type:y.ShellType,id:this._execution.computeId()}:this._execution instanceof Kt?this._definition={type:y.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:y.EmptyType,id:(0,I.generateUuid)()}}get definition(){return this._definition}set definition(M){if(M==null)throw(0,T.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=M}get scope(){return this._scope}set target(M){this.clear(),this._scope=M}get name(){return this._name}set name(M){if(typeof M!="string")throw(0,T.illegalArgument)("name");this.clear(),this._name=M}get execution(){return this._execution}set execution(M){M===null&&(M=void 0),this.clear(),this._execution=M;const ne=this._definition.type;(y.EmptyType===ne||y.ProcessType===ne||y.ShellType===ne||y.ExtensionCallbackType===ne)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(M){if(Array.isArray(M))this.clear(),this._problemMatchers=M,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(M){M!==!0&&M!==!1&&(M=!1),this.clear(),this._isBackground=M}get source(){return this._source}set source(M){if(typeof M!="string"||M.length===0)throw(0,T.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=M}get group(){return this._group}set group(M){M===null&&(M=void 0),this.clear(),this._group=M}get detail(){return this._detail}set detail(M){M===null&&(M=void 0),this._detail=M}get presentationOptions(){return this._presentationOptions}set presentationOptions(M){M==null&&(M=Object.create(null)),this.clear(),this._presentationOptions=M}get runOptions(){return this._runOptions}set runOptions(M){M==null&&(M=Object.create(null)),this.clear(),this._runOptions=M}};e.Task=Gt,e.Task=Gt=y=qe([p],Gt);var ui;(function(U){U[U.SourceControl=1]="SourceControl",U[U.Window=10]="Window",U[U.Notification=15]="Notification"})(ui||(e.ProgressLocation=ui={}));var Mt;(function(U){function M(ne){const _e=ne;return(0,m.isNumber)(_e.value)?_e.tooltip&&!(0,m.isString)(_e.tooltip)?(console.log("INVALID view badge, invalid tooltip",_e.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",_e.value),!1)}U.isViewBadge=M})(Mt||(e.ViewBadge=Mt={}));let Pt=w=class{static isTreeItem(M,ne){const _e=M;if(_e.checkboxState!==void 0){const je=(0,m.isNumber)(_e.checkboxState)?_e.checkboxState:(0,m.isObject)(_e.checkboxState)&&(0,m.isNumber)(_e.checkboxState.state)?_e.checkboxState.state:void 0,rt=!(0,m.isNumber)(_e.checkboxState)&&(0,m.isObject)(_e.checkboxState)?_e.checkboxState.tooltip:void 0;if(je===void 0||je!==Xt.Checked&&je!==Xt.Unchecked||rt!==void 0&&!(0,m.isString)(rt))return console.log("INVALID tree item, invalid checkboxState",_e.checkboxState),!1}if(M instanceof w)return!0;if(_e.label!==void 0&&!(0,m.isString)(_e.label)&&!_e.label?.label)return console.log("INVALID tree item, invalid label",_e.label),!1;if(_e.id!==void 0&&!(0,m.isString)(_e.id))return console.log("INVALID tree item, invalid id",_e.id),!1;if(_e.iconPath!==void 0&&!(0,m.isString)(_e.iconPath)&&!s.URI.isUri(_e.iconPath)&&(!_e.iconPath||!(0,m.isString)(_e.iconPath.id))){const je=_e.iconPath;if(!je||!(0,m.isString)(je.light)&&!s.URI.isUri(je.light)&&!(0,m.isString)(je.dark)&&!s.URI.isUri(je.dark))return console.log("INVALID tree item, invalid iconPath",_e.iconPath),!1}return _e.description!==void 0&&!(0,m.isString)(_e.description)&&typeof _e.description!="boolean"?(console.log("INVALID tree item, invalid description",_e.description),!1):_e.resourceUri!==void 0&&!s.URI.isUri(_e.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",_e.resourceUri),!1):_e.tooltip!==void 0&&!(0,m.isString)(_e.tooltip)&&!(_e.tooltip instanceof tt)?(console.log("INVALID tree item, invalid tooltip",_e.tooltip),!1):_e.command!==void 0&&!_e.command.command?(console.log("INVALID tree item, invalid command",_e.command),!1):_e.collapsibleState!==void 0&&_e.collapsibleState<St.None&&_e.collapsibleState>St.Expanded?(console.log("INVALID tree item, invalid collapsibleState",_e.collapsibleState),!1):_e.contextValue!==void 0&&!(0,m.isString)(_e.contextValue)?(console.log("INVALID tree item, invalid contextValue",_e.contextValue),!1):_e.accessibilityInformation!==void 0&&!_e.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",_e.accessibilityInformation),!1):!0}constructor(M,ne=St.None){this.collapsibleState=ne,s.URI.isUri(M)?this.resourceUri=M:this.label=M}};e.TreeItem=Pt,e.TreeItem=Pt=w=qe([p],Pt);var St;(function(U){U[U.None=0]="None",U[U.Collapsed=1]="Collapsed",U[U.Expanded=2]="Expanded"})(St||(e.TreeItemCollapsibleState=St={}));var Xt;(function(U){U[U.Unchecked=0]="Unchecked",U[U.Checked=1]="Checked"})(Xt||(e.TreeItemCheckboxState=Xt={}));let yt=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(M){this.value=M}};e.DataTransferItem=yt,e.DataTransferItem=yt=qe([p],yt);class si extends yt{}e.InternalDataTransferItem=si;class Yt extends si{#e;constructor(M){super(""),this.#e=M}asFile(){return this.#e}}e.InternalFileDataTransferItem=Yt;class Mi{constructor(M,ne,_e,je){this.name=M,this.uri=ne,this._itemId=_e,this._getData=je}data(){return this._getData()}}e.DataTransferFile=Mi;let hi=class{#e=new Map;constructor(M){for(const[ne,_e]of M??[]){const je=this.#e.get(this.#t(ne));je?je.push(_e):this.#e.set(this.#t(ne),[_e])}}get(M){return this.#e.get(this.#t(M))?.[0]}set(M,ne){this.#e.set(this.#t(M),[ne])}forEach(M,ne){for(const[_e,je]of this.#e)for(const rt of je)M.call(ne,rt,_e,this)}*[Symbol.iterator](){for(const[M,ne]of this.#e)for(const _e of ne)yield[M,_e]}#t(M){return M.toLowerCase()}};e.DataTransfer=hi,e.DataTransfer=hi=qe([p],hi);let wi=class{constructor(M,ne,_e){this.insertText=M,this.title=ne,this.kind=_e}};e.DocumentDropEdit=wi,e.DocumentDropEdit=wi=qe([p],wi);var Wt;(function(U){U[U.Automatic=0]="Automatic",U[U.PasteAs=1]="PasteAs"})(Wt||(e.DocumentPasteTriggerKind=Wt={}));class fi{static{this.sep="."}constructor(M){this.value=M}append(...M){return new fi((this.value?[this.value,...M]:M).join(fi.sep))}intersects(M){return this.contains(M)||M.contains(this)}contains(M){return this.value===M.value||M.value.startsWith(this.value+fi.sep)}}e.DocumentDropOrPasteEditKind=fi,fi.Empty=new fi("");class Fi{constructor(M,ne,_e){this.title=ne,this.insertText=M,this.kind=_e}}e.DocumentPasteEdit=Fi;let kt=class{constructor(M,ne){this.id=M,this.color=ne}static isThemeIcon(M){return typeof M.id!="string"?(console.log("INVALID ThemeIcon, invalid id",M.id),!1):!0}};e.ThemeIcon=kt,e.ThemeIcon=kt=qe([p],kt),kt.File=new kt("file"),kt.Folder=new kt("folder");let _i=class{constructor(M){this.id=M}};e.ThemeColor=_i,e.ThemeColor=_i=qe([p],_i);var Li;(function(U){U[U.Global=1]="Global",U[U.Workspace=2]="Workspace",U[U.WorkspaceFolder=3]="WorkspaceFolder"})(Li||(e.ConfigurationTarget=Li={}));let gi=class{get base(){return this._base}set base(M){this._base=M,this._baseUri=s.URI.file(M)}get baseUri(){return this._baseUri}set baseUri(M){this._baseUri=M,this._base=M.fsPath}constructor(M,ne){if(typeof M!="string"&&(!M||!s.URI.isUri(M)&&!s.URI.isUri(M.uri)))throw(0,T.illegalArgument)("base");if(typeof ne!="string")throw(0,T.illegalArgument)("pattern");typeof M=="string"?this.baseUri=s.URI.file(M):s.URI.isUri(M)?this.baseUri=M:this.baseUri=M.uri,this.pattern=ne}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.RelativePattern=gi,e.RelativePattern=gi=qe([p],gi);const Ui=new WeakMap;function $i(U,M){Ui.set(U,M)}let Ut=class{constructor(M,ne,_e,je,rt){this.enabled=typeof M=="boolean"?M:!0,typeof ne=="string"&&(this.condition=ne),typeof _e=="string"&&(this.hitCondition=_e),typeof je=="string"&&(this.logMessage=je),typeof rt=="string"&&(this.mode=rt)}get id(){return this._id||(this._id=Ui.get(this)??(0,I.generateUuid)()),this._id}};e.Breakpoint=Ut,e.Breakpoint=Ut=qe([p],Ut);let Di=class extends Ut{constructor(M,ne,_e,je,rt,pt){if(super(ne,_e,je,rt,pt),M===null)throw(0,T.illegalArgument)("location");this.location=M}};e.SourceBreakpoint=Di,e.SourceBreakpoint=Di=qe([p],Di);let Ti=class extends Ut{constructor(M,ne,_e,je,rt,pt){super(ne,_e,je,rt,pt),this.functionName=M}};e.FunctionBreakpoint=Ti,e.FunctionBreakpoint=Ti=qe([p],Ti);let Ei=class extends Ut{constructor(M,ne,_e,je,rt,pt,_t,Jt){if(super(je,rt,pt,_t,Jt),!ne)throw(0,T.illegalArgument)("dataId");this.label=M,this.dataId=ne,this.canPersist=_e}};e.DataBreakpoint=Ei,e.DataBreakpoint=Ei=qe([p],Ei);let bi=class{constructor(M,ne,_e){this.command=M,this.args=ne||[],this.options=_e}};e.DebugAdapterExecutable=bi,e.DebugAdapterExecutable=bi=qe([p],bi);let me=class{constructor(M,ne){this.port=M,this.host=ne}};e.DebugAdapterServer=me,e.DebugAdapterServer=me=qe([p],me);let Te=class{constructor(M){this.path=M}};e.DebugAdapterNamedPipeServer=Te,e.DebugAdapterNamedPipeServer=Te=qe([p],Te);let le=class{constructor(M){this.implementation=M}};e.DebugAdapterInlineImplementation=le,e.DebugAdapterInlineImplementation=le=qe([p],le);class j{constructor(M,ne,_e){this.session=M,this.threadId=ne,this.frameId=_e}}e.DebugStackFrame=j;class Ce{constructor(M,ne){this.session=M,this.threadId=ne}}e.DebugThread=Ce;let Be=class{constructor(M,ne){this.range=M,this.expression=ne}};e.EvaluatableExpression=Be,e.EvaluatableExpression=Be=qe([p],Be);var Ye;(function(U){U[U.Invoke=0]="Invoke",U[U.Automatic=1]="Automatic"})(Ye||(e.InlineCompletionTriggerKind=Ye={}));let xe=class{constructor(M,ne){this.range=M,this.text=ne}};e.InlineValueText=xe,e.InlineValueText=xe=qe([p],xe);let ot=class{constructor(M,ne,_e=!0){this.range=M,this.variableName=ne,this.caseSensitiveLookup=_e}};e.InlineValueVariableLookup=ot,e.InlineValueVariableLookup=ot=qe([p],ot);let gt=class{constructor(M,ne){this.range=M,this.expression=ne}};e.InlineValueEvaluatableExpression=gt,e.InlineValueEvaluatableExpression=gt=qe([p],gt);let jt=class{constructor(M,ne){this.frameId=M,this.stoppedLocation=ne}};e.InlineValueContext=jt,e.InlineValueContext=jt=qe([p],jt);var Vt;(function(U){U[U.AIGenerated=1]="AIGenerated"})(Vt||(e.NewSymbolNameTag=Vt={}));var Bt;(function(U){U[U.Invoke=0]="Invoke",U[U.Automatic=1]="Automatic"})(Bt||(e.NewSymbolNameTriggerKind=Bt={}));class Oi{constructor(M,ne){this.newSymbolName=M,this.tags=ne}}e.NewSymbolName=Oi;var en;(function(U){U[U.Changed=1]="Changed",U[U.Created=2]="Created",U[U.Deleted=3]="Deleted"})(en||(e.FileChangeType=en={}));let Vi=P=class extends Error{static FileExists(M){return new P(M,u.FileSystemProviderErrorCode.FileExists,P.FileExists)}static FileNotFound(M){return new P(M,u.FileSystemProviderErrorCode.FileNotFound,P.FileNotFound)}static FileNotADirectory(M){return new P(M,u.FileSystemProviderErrorCode.FileNotADirectory,P.FileNotADirectory)}static FileIsADirectory(M){return new P(M,u.FileSystemProviderErrorCode.FileIsADirectory,P.FileIsADirectory)}static NoPermissions(M){return new P(M,u.FileSystemProviderErrorCode.NoPermissions,P.NoPermissions)}static Unavailable(M){return new P(M,u.FileSystemProviderErrorCode.Unavailable,P.Unavailable)}constructor(M,ne=u.FileSystemProviderErrorCode.Unknown,_e){super(s.URI.isUri(M)?M.toString(!0):M),this.code=_e?.name??"Unknown",(0,u.markAsFileSystemProviderError)(this,ne),Object.setPrototypeOf(this,P.prototype),typeof Error.captureStackTrace=="function"&&typeof _e=="function"&&Error.captureStackTrace(this,_e)}};e.FileSystemError=Vi,e.FileSystemError=Vi=P=qe([p],Vi);let yi=class{constructor(M,ne,_e){this.start=M,this.end=ne,this.kind=_e}};e.FoldingRange=yi,e.FoldingRange=yi=qe([p],yi);var tn;(function(U){U[U.Comment=1]="Comment",U[U.Imports=2]="Imports",U[U.Region=3]="Region"})(tn||(e.FoldingRangeKind=tn={}));var nn;(function(U){U[U.Collapsed=0]="Collapsed",U[U.Expanded=1]="Expanded"})(nn||(e.CommentThreadCollapsibleState=nn={}));var xi;(function(U){U[U.Editing=0]="Editing",U[U.Preview=1]="Preview"})(xi||(e.CommentMode=xi={}));var rn;(function(U){U[U.Published=0]="Published",U[U.Draft=1]="Draft"})(rn||(e.CommentState=rn={}));var zi;(function(U){U[U.Unresolved=0]="Unresolved",U[U.Resolved=1]="Resolved"})(zi||(e.CommentThreadState=zi={}));var Hi;(function(U){U[U.Current=0]="Current",U[U.Outdated=1]="Outdated"})(Hi||(e.CommentThreadApplicability=Hi={}));var sn;(function(U){U[U.Reply=1]="Reply",U[U.Comment=2]="Comment"})(sn||(e.CommentThreadFocus=sn={}));class on{constructor(M,ne=[]){this.tokenTypes=M,this.tokenModifiers=ne}}e.SemanticTokensLegend=on;function En(U){return typeof U>"u"||(0,m.isStringArray)(U)}class Pi{constructor(M){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,M){this._hasLegend=!0;for(let ne=0,_e=M.tokenTypes.length;ne<_e;ne++)this._tokenTypeStrToInt.set(M.tokenTypes[ne],ne);for(let ne=0,_e=M.tokenModifiers.length;ne<_e;ne++)this._tokenModifierStrToInt.set(M.tokenModifiers[ne],ne)}}push(M,ne,_e,je,rt){if(typeof M=="number"&&typeof ne=="number"&&typeof _e=="number"&&typeof je=="number"&&(typeof rt=="number"||typeof rt>"u"))return typeof rt>"u"&&(rt=0),this._pushEncoded(M,ne,_e,je,rt);if(K.isRange(M)&&typeof ne=="string"&&En(_e))return this._push(M,ne,_e);throw(0,T.illegalArgument)()}_push(M,ne,_e){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(M.start.line!==M.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(ne))throw new Error("`tokenType` is not in the provided legend");const je=M.start.line,rt=M.start.character,pt=M.end.character-M.start.character,_t=this._tokenTypeStrToInt.get(ne);let Jt=0;if(_e)for(const vi of _e){if(!this._tokenModifierStrToInt.has(vi))throw new Error("`tokenModifier` is not in the provided legend");const Si=this._tokenModifierStrToInt.get(vi);Jt|=1<<Si>>>0}this._pushEncoded(je,rt,pt,_t,Jt)}_pushEncoded(M,ne,_e,je,rt){if(this._dataIsSortedAndDeltaEncoded&&(M<this._prevLine||M===this._prevLine&&ne<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const Jt=this._data.length/5|0;let vi=0,Si=0;for(let Ii=0;Ii<Jt;Ii++){let Ai=this._data[5*Ii],Ji=this._data[5*Ii+1];Ai===0?(Ai=vi,Ji+=Si):Ai+=vi,this._data[5*Ii]=Ai,this._data[5*Ii+1]=Ji,vi=Ai,Si=Ji}}let pt=M,_t=ne;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(pt-=this._prevLine,pt===0&&(_t-=this._prevChar)),this._data[this._dataLen++]=pt,this._data[this._dataLen++]=_t,this._data[this._dataLen++]=_e,this._data[this._dataLen++]=je,this._data[this._dataLen++]=rt,this._prevLine=M,this._prevChar=ne}static _sortAndDeltaEncode(M){const ne=[],_e=M.length/5|0;for(let _t=0;_t<_e;_t++)ne[_t]=_t;ne.sort((_t,Jt)=>{const vi=M[5*_t],Si=M[5*Jt];if(vi===Si){const Ii=M[5*_t+1],Ai=M[5*Jt+1];return Ii-Ai}return vi-Si});const je=new Uint32Array(M.length);let rt=0,pt=0;for(let _t=0;_t<_e;_t++){const Jt=5*ne[_t],vi=M[Jt+0],Si=M[Jt+1],Ii=M[Jt+2],Ai=M[Jt+3],Ji=M[Jt+4],Hn=vi-rt,Mr=Hn===0?Si-pt:Si,Zi=5*_t;je[Zi+0]=Hn,je[Zi+1]=Mr,je[Zi+2]=Ii,je[Zi+3]=Ai,je[Zi+4]=Ji,rt=vi,pt=Si}return je}build(M){return this._dataIsSortedAndDeltaEncoded?new ji(new Uint32Array(this._data),M):new ji(Pi._sortAndDeltaEncode(this._data),M)}}e.SemanticTokensBuilder=Pi;class ji{constructor(M,ne){this.resultId=ne,this.data=M}}e.SemanticTokens=ji;class bn{constructor(M,ne,_e){this.start=M,this.deleteCount=ne,this.data=_e}}e.SemanticTokensEdit=bn;class Sn{constructor(M,ne){this.resultId=ne,this.edits=M}}e.SemanticTokensEdits=Sn;var Bi;(function(U){U[U.Separate=0]="Separate",U[U.MergeWithParent=1]="MergeWithParent"})(Bi||(e.DebugConsoleMode=Bi={}));class an{constructor(M){this.name=M}}e.DebugVisualization=an;var Le;(function(U){U[U.Title=1]="Title",U[U.Inline=2]="Inline"})(Le||(e.QuickInputButtonLocation=Le={}));let mi=class{static{this.Back={iconPath:new kt("arrow-left")}}constructor(){}};e.QuickInputButtons=mi,e.QuickInputButtons=mi=qe([p],mi);var qi;(function(U){U[U.Separator=-1]="Separator",U[U.Default=0]="Default"})(qi||(e.QuickPickItemKind=qi={}));var ct;(function(U){U[U.Info=1]="Info",U[U.Warning=2]="Warning",U[U.Error=3]="Error"})(ct||(e.InputBoxValidationSeverity=ct={}));var It;(function(U){U[U.UI=1]="UI",U[U.Workspace=2]="Workspace"})(It||(e.ExtensionKind=It={}));class wn{static validate(M){if(typeof M.badge=="string"){let ne=(0,A.nextCharLength)(M.badge,0);if(ne<M.badge.length&&(ne+=(0,A.nextCharLength)(M.badge,ne)),M.badge.length>ne)throw new Error("The 'badge'-property must be undefined or a short character")}else if(M.badge&&!kt.isThemeIcon(M.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!M.color&&!M.badge&&!M.tooltip)throw new Error("The decoration is empty");return!0}constructor(M,ne,_e){this.badge=M,this.tooltip=ne,this.color=_e}}e.FileDecoration=wn;let Ki=class{constructor(M){this.kind=M}};e.ColorTheme=Ki,e.ColorTheme=Ki=qe([p],Ki);var Gi;(function(U){U[U.Light=1]="Light",U[U.Dark=2]="Dark",U[U.HighContrast=3]="HighContrast",U[U.HighContrastLight=4]="HighContrastLight"})(Gi||(e.ColorThemeKind=Gi={}));class Ci{static isNotebookRange(M){return M instanceof Ci?!0:M?typeof M.start=="number"&&typeof M.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}constructor(M,ne){if(M<0)throw(0,T.illegalArgument)("start must be positive");if(ne<0)throw(0,T.illegalArgument)("end must be positive");M<=ne?(this._start=M,this._end=ne):(this._start=ne,this._end=M)}with(M){let ne=this._start,_e=this._end;return M.start!==void 0&&(ne=M.start),M.end!==void 0&&(_e=M.end),ne===this._start&&_e===this._end?this:new Ci(ne,_e)}}e.NotebookRange=Ci;class ki{static validate(M){if(typeof M.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof M.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof M.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(M){return Array.isArray(M)&&M.every(ne=>ki.isNotebookCellData(ne))}static isNotebookCellData(M){return!0}constructor(M,ne,_e,je,rt,pt,_t){this.kind=M,this.value=ne,this.languageId=_e,this.mime=je,this.outputs=rt??[],this.metadata=pt,this.executionSummary=_t,ki.validate(this)}}e.NotebookCellData=ki;class _n{constructor(M){this.cells=M}}e.NotebookData=_n;class pi{static isNotebookCellOutputItem(M){return M instanceof pi?!0:M?typeof M.mime=="string"&&M.data instanceof Uint8Array:!1}static error(M){const ne={name:M.name,message:M.message,stack:M.stack};return pi.json(ne,"application/vnd.code.notebook.error")}static stdout(M){return pi.text(M,"application/vnd.code.notebook.stdout")}static stderr(M){return pi.text(M,"application/vnd.code.notebook.stderr")}static bytes(M,ne="application/octet-stream"){return new pi(M,ne)}static#e=new TextEncoder;static text(M,ne=k.Mimes.text){const _e=pi.#e.encode(String(M));return new pi(_e,ne)}static json(M,ne="text/x-json"){const _e=JSON.stringify(M,void 0,"	");return pi.text(_e,ne)}constructor(M,ne){this.data=M,this.mime=ne;const _e=(0,k.normalizeMimeType)(ne,!0);if(!_e)throw new Error(`INVALID mime type: ${ne}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=_e}}e.NotebookCellOutputItem=pi;class Wi{static isNotebookCellOutput(M){return M instanceof Wi?!0:!M||typeof M!="object"?!1:typeof M.id=="string"&&Array.isArray(M.items)}static ensureUniqueMimeTypes(M,ne=!1){const _e=new Set,je=new Set;for(let rt=0;rt<M.length;rt++){const pt=M[rt],_t=(0,k.normalizeMimeType)(pt.mime);if(!_e.has(_t)||(0,v.isTextStreamMime)(_t)){_e.add(_t);continue}je.add(rt),ne&&console.warn(`DUPLICATED mime type '${pt.mime}' will be dropped`)}return je.size===0?M:M.filter((rt,pt)=>!je.has(pt))}constructor(M,ne,_e){this.items=Wi.ensureUniqueMimeTypes(M,!0),typeof ne=="string"?(this.id=ne,this.metadata=_e):(this.id=(0,I.generateUuid)(),this.metadata=ne??_e)}}e.NotebookCellOutput=Wi;var Xi;(function(U){U[U.Markup=1]="Markup",U[U.Code=2]="Code"})(Xi||(e.NotebookCellKind=Xi={}));var ln;(function(U){U[U.Idle=1]="Idle",U[U.Pending=2]="Pending",U[U.Executing=3]="Executing"})(ln||(e.NotebookCellExecutionState=ln={}));var cn;(function(U){U[U.Left=1]="Left",U[U.Right=2]="Right"})(cn||(e.NotebookCellStatusBarAlignment=cn={}));var un;(function(U){U[U.Default=0]="Default",U[U.InCenter=1]="InCenter",U[U.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",U[U.AtTop=3]="AtTop"})(un||(e.NotebookEditorRevealType=un={}));class yn{constructor(M,ne){this.text=M,this.alignment=ne}}e.NotebookCellStatusBarItem=yn;var dn;(function(U){U[U.Default=1]="Default",U[U.Preferred=2]="Preferred"})(dn||(e.NotebookControllerAffinity=dn={}));var hn;(function(U){U[U.Default=1]="Default",U[U.Preferred=2]="Preferred",U[U.Hidden=-1]="Hidden"})(hn||(e.NotebookControllerAffinity2=hn={}));class Cn{constructor(M,ne=[]){this.uri=M,this.provides=(0,S.asArray)(ne)}}e.NotebookRendererScript=Cn;class In{constructor(M){this.label=M}}e.NotebookKernelSourceAction=In;var fn;(function(U){U[U.Named=1]="Named",U[U.Indexed=2]="Indexed"})(fn||(e.NotebookVariablesRequestKind=fn={}));let Qi=class{constructor(M,ne){this.label=M,this.timestamp=ne}};e.TimelineItem=Qi,e.TimelineItem=Qi=qe([p],Qi);var gn;(function(U){U[U.Production=1]="Production",U[U.Development=2]="Development",U[U.Test=3]="Test"})(gn||(e.ExtensionMode=gn={}));var te;(function(U){U[U.Node=1]="Node",U[U.Webworker=2]="Webworker"})(te||(e.ExtensionRuntime=te={}));var ce;(function(U){U[U.Other=0]="Other",U[U.Comment=1]="Comment",U[U.String=2]="String",U[U.RegEx=3]="RegEx"})(ce||(e.StandardTokenType=ce={}));class Ae{constructor(M,ne){this.ranges=M,this.wordPattern=ne}}e.LinkedEditingRanges=Ae;class ft{constructor(M){this._autoForwardAction=M}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=ft;var Dt;(function(U){U[U.Queued=1]="Queued",U[U.Running=2]="Running",U[U.Passed=3]="Passed",U[U.Failed=4]="Failed",U[U.Skipped=5]="Skipped",U[U.Errored=6]="Errored"})(Dt||(e.TestResultState=Dt={}));var Ft;(function(U){U[U.Run=1]="Run",U[U.Debug=2]="Debug",U[U.Coverage=3]="Coverage"})(Ft||(e.TestRunProfileKind=Ft={}));let Ri=class{constructor(M=void 0,ne=void 0,_e=void 0,je=!1,rt=!0){this.include=M,this.exclude=ne,this.profile=_e,this.continuous=je,this.preserveFocus=rt}};e.TestRunRequest=Ri,e.TestRunRequest=Ri=qe([p],Ri);let Yi=R=class{static diff(M,ne,_e){const je=new R(M);return je.expectedOutput=ne,je.actualOutput=_e,je}constructor(M){this.message=M}};e.TestMessage=Yi,e.TestMessage=Yi=R=qe([p],Yi);let Dn=class{constructor(M){this.id=M}};e.TestTag=Dn,e.TestTag=Dn=qe([p],Dn);class Kn{constructor(M,ne,_e){this.label=M,this.uri=ne,this.position=_e}}e.TestMessageStackFrame=Kn;class mn{constructor(M,ne){this.covered=M,this.total=ne,Pn(this)}}e.TestCoverageCount=mn;function Pn(U){if(U){if(U.covered>U.total)throw new Error(`The total number of covered items (${U.covered}) cannot be greater than the total (${U.total})`);if(U.total<0)throw new Error(`The number of covered items (${U.total}) cannot be negative`)}}class Tn{static fromDetails(M,ne){const _e=new mn(0,0),je=new mn(0,0),rt=new mn(0,0);for(const _t of ne)if("branches"in _t){_e.total+=1,_e.covered+=_t.executed?1:0;for(const Jt of _t.branches)je.total+=1,je.covered+=Jt.executed?1:0}else rt.total+=1,rt.covered+=_t.executed?1:0;const pt=new Tn(M,_e,je.total>0?je:void 0,rt.total>0?rt:void 0);return pt.detailedCoverage=ne,pt}constructor(M,ne,_e,je,rt=[]){this.uri=M,this.statementCoverage=ne,this.branchCoverage=_e,this.declarationCoverage=je,this.fromTests=rt}}e.FileCoverage=Tn;class Gn{get executionCount(){return+this.executed}set executionCount(M){this.executed=M}constructor(M,ne,_e=[]){this.executed=M,this.location=ne,this.branches=_e}}e.StatementCoverage=Gn;class Xn{get executionCount(){return+this.executed}set executionCount(M){this.executed=M}constructor(M,ne,_e){this.executed=M,this.location=ne,this.label=_e}}e.BranchCoverage=Xn;class Qn{get executionCount(){return+this.executed}set executionCount(M){this.executed=M}constructor(M,ne,_e){this.name=M,this.executed=ne,this.location=_e}}e.DeclarationCoverage=Qn;var kn;(function(U){U[U.None=0]="None",U[U.Option=1]="Option",U[U.Default=2]="Default",U[U.Preferred=3]="Preferred"})(kn||(e.ExternalUriOpenerPriority=kn={}));var Rn;(function(U){U[U.Untrusted=0]="Untrusted",U[U.Trusted=1]="Trusted",U[U.Unspecified=2]="Unspecified"})(Rn||(e.WorkspaceTrustState=Rn={}));var An;(function(U){U[U.Notify=1]="Notify",U[U.OpenBrowser=2]="OpenBrowser",U[U.OpenPreview=3]="OpenPreview",U[U.Silent=4]="Silent",U[U.Ignore=5]="Ignore",U[U.OpenBrowserOnce=6]="OpenBrowserOnce"})(An||(e.PortAutoForwardAction=An={}));class Yn{constructor(M,ne,_e,je,rt,pt){this.kind=M,this.name=ne,this.detail=_e,this.uri=je,this.range=rt,this.selectionRange=pt}}e.TypeHierarchyItem=Yn;class Jn{constructor(M){this.uri=M}}e.TextTabInput=Jn;class Zn{constructor(M,ne){this.original=M,this.modified=ne}}e.TextDiffTabInput=Zn;class er{constructor(M,ne,_e,je){this.base=M,this.input1=ne,this.input2=_e,this.result=je}}e.TextMergeTabInput=er;class tr{constructor(M,ne){this.uri=M,this.viewType=ne}}e.CustomEditorTabInput=tr;class ir{constructor(M){this.viewType=M}}e.WebviewEditorTabInput=ir;class nr{constructor(M,ne){this.uri=M,this.notebookType=ne}}e.NotebookEditorTabInput=nr;class rr{constructor(M,ne,_e){this.original=M,this.modified=ne,this.notebookType=_e}}e.NotebookDiffEditorTabInput=rr;class sr{constructor(){}}e.TerminalEditorTabInput=sr;class or{constructor(M,ne){this.uri=M,this.inputBoxUri=ne}}e.InteractiveWindowInput=or;class ar{constructor(){}}e.ChatEditorTabInput=ar;class lr{constructor(M){this.textDiffs=M}}e.TextMultiDiffTabInput=lr;var Ln;(function(U){U[U.Down=0]="Down",U[U.Up=1]="Up"})(Ln||(e.InteractiveSessionVoteDirection=Ln={}));var On;(function(U){U[U.Action=1]="Action",U[U.Toolbar=2]="Toolbar"})(On||(e.ChatCopyKind=On={}));var Nn;(function(U){U[U.Short=1]="Short",U[U.Medium=2]="Medium",U[U.Full=3]="Full"})(Nn||(e.ChatVariableLevel=Nn={}));class cr{constructor(M,ne,_e){this.id=M,this.label=ne,this.values=_e}}e.ChatCompletionItem=cr;var Mn;(function(U){U[U.Unhelpful=0]="Unhelpful",U[U.Helpful=1]="Helpful",U[U.Undone=2]="Undone",U[U.Accepted=3]="Accepted",U[U.Bug=4]="Bug"})(Mn||(e.InteractiveEditorResponseFeedbackKind=Mn={}));var Fn;(function(U){U[U.Unhelpful=0]="Unhelpful",U[U.Helpful=1]="Helpful"})(Fn||(e.ChatResultFeedbackKind=Fn={}));class ur{constructor(M){if(typeof M!="string"&&M.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof M=="string"?new tt(M):M}}e.ChatResponseMarkdownPart=ur;class dr{constructor(M,ne){if(typeof M!="string"&&M.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof M=="string"?new tt(M):M,this.vulnerabilities=ne}}e.ChatResponseMarkdownWithVulnerabilitiesPart=dr;class hr{constructor(M,ne){this.participant=M,this.command=ne}}e.ChatResponseDetectedParticipantPart=hr;class fr{constructor(M,ne,_e,je){this.title=M,this.message=ne,this.data=_e,this.buttons=je}}e.ChatResponseConfirmationPart=fr;class gr{constructor(M,ne){this.value=M,this.baseUri=ne}}e.ChatResponseFileTreePart=gr;class mr{constructor(M,ne){this.value=M,this.title=ne}}e.ChatResponseAnchorPart=mr;class pr{constructor(M){this.value=M}}e.ChatResponseProgressPart=pr;class vr{constructor(M,ne){this.value=M,this.task=ne}}e.ChatResponseProgressPart2=vr;class Er{constructor(M){if(typeof M!="string"&&M.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof M=="string"?new tt(M):M}}e.ChatResponseWarningPart=Er;class br{constructor(M){this.value=M}}e.ChatResponseCommandButtonPart=br;class Sr{constructor(M,ne,_e){this.value=M,this.iconPath=ne,this.options=_e}}e.ChatResponseReferencePart=Sr;class wr{constructor(M,ne,_e){this.value=M,this.license=ne,this.snippet=_e}}e.ChatResponseCodeCitationPart=wr;class _r{constructor(M,ne){this.uri=M,this.range=ne}}e.ChatResponseMovePart=_r;class yr{constructor(M,ne){this.uri=M,this.edits=Array.isArray(ne)?ne:[ne]}}e.ChatResponseTextEditPart=yr;class Cr{constructor(M,ne,_e,je){this.prompt=M,this.command=ne,this.references=_e,this.participant=je}}e.ChatRequestTurn=Cr;class Ir{constructor(M,ne,_e,je){this.response=M,this.result=ne,this.participant=_e,this.command=je}}e.ChatResponseTurn=Ir;var Un;(function(U){U[U.Panel=1]="Panel",U[U.Terminal=2]="Terminal",U[U.Notebook=3]="Notebook",U[U.Editor=4]="Editor"})(Un||(e.ChatLocation=Un={}));var xn;(function(U){U[U.Complete=1]="Complete",U[U.Partial=2]="Partial",U[U.Omitted=3]="Omitted"})(xn||(e.ChatResponseReferencePartStatusKind=xn={}));class Dr{constructor(M,ne,_e){this.document=M,this.selection=ne,this.wholeRange=_e}}e.ChatRequestEditorData=Dr;class Tr{constructor(M){this.cell=M}}e.ChatRequestNotebookData=Tr;var pn;(function(U){U[U.User=1]="User",U[U.Assistant=2]="Assistant",U[U.System=3]="System"})(pn||(e.LanguageModelChatMessageRole=pn={}));class Pr{constructor(M,ne,_e){this.toolCallId=M,this.content=ne,this.isError=_e??!1}}e.LanguageModelToolResultPart=Pr;class vn{static User(M,ne){const _e=new vn(pn.User,typeof M=="string"?M:"",ne);return _e.content2=[M],_e}static Assistant(M,ne){return new vn(pn.Assistant,M,ne)}constructor(M,ne,_e){this.role=M,this.content=ne,this.content2=[ne],this.name=_e}}e.LanguageModelChatMessage=vn;class kr{constructor(M,ne,_e){this.name=M,this.toolCallId=ne,this.parameters=_e}}e.LanguageModelToolCallPart=kr;class Rr{constructor(M){this.value=M}}e.LanguageModelTextPart=Rr;class Ar{constructor(M){this.content=M}}e.LanguageModelChatSystemMessage=Ar;class Lr{constructor(M,ne){this.content=M,this.name=ne}}e.LanguageModelChatUserMessage=Lr;class Or{constructor(M,ne){this.content=M,this.name=ne}}e.LanguageModelChatAssistantMessage=Or;class Ni extends Error{static NotFound(M){return new Ni(M,Ni.NotFound.name)}static NoPermissions(M){return new Ni(M,Ni.NoPermissions.name)}static Blocked(M){return new Ni(M,Ni.Blocked.name)}constructor(M,ne,_e){super(M,{cause:_e}),this.name="LanguageModelError",this.code=ne??""}}e.LanguageModelError=Ni;var $n;(function(U){U[U.SymbolInformation=1]="SymbolInformation",U[U.CommandInformation=2]="CommandInformation",U[U.SearchInformation=3]="SearchInformation",U[U.SettingInformation=4]="SettingInformation"})($n||(e.RelatedInformationType=$n={}));var zn;(function(U){U[U.Started=1]="Started",U[U.Recognizing=2]="Recognizing",U[U.Recognized=3]="Recognized",U[U.Stopped=4]="Stopped",U[U.Error=5]="Error"})(zn||(e.SpeechToTextStatus=zn={}));var Bn;(function(U){U[U.Started=1]="Started",U[U.Stopped=2]="Stopped",U[U.Error=3]="Error"})(Bn||(e.TextToSpeechStatus=Bn={}));var Wn;(function(U){U[U.Recognized=1]="Recognized",U[U.Stopped=2]="Stopped"})(Wn||(e.KeywordRecognitionStatus=Wn={}));class Nr{constructor(M,ne){this.text=M,this.range=ne}}e.InlineEdit=Nr;var Vn;(function(U){U[U.Invoke=0]="Invoke",U[U.Automatic=1]="Automatic"})(Vn||(e.InlineEditTriggerKind=Vn={}))}),define(ke[227],Re([1,0,5,7]),function(Ee,e,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRelatedInformation=void 0;class D{constructor(k){this._relatedInformationProviders=new Map,this._nextHandle=0,this._proxy=k.getProxy(S.MainContext.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(k,A,m){if(this._relatedInformationProviders.size===0)throw new Error("No related information providers registered");const s=this._relatedInformationProviders.get(k);if(!s)throw new Error("related information provider not found");return await s.provideRelatedInformation(A,m)??[]}getRelatedInformation(k,A,m){return this._proxy.$getAiRelatedInformation(A,m)}registerRelatedInformationProvider(k,A,m){const s=this._nextHandle;return this._nextHandle++,this._relatedInformationProviders.set(s,m),this._proxy.$registerAiRelatedInformationProvider(s,A),new T.Disposable(()=>{this._proxy.$unregisterAiRelatedInformationProvider(s),this._relatedInformationProviders.delete(s)})}}e.ExtHostRelatedInformation=D}),define(ke[91],Re([1,0,6,5,7,18,119,3,16]),function(Ee,e,S,T,D,O,k,A,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=e.IExtHostAuthentication=void 0,e.IExtHostAuthentication=(0,A.createDecorator)("IExtHostAuthentication");let s=class{constructor(u){this._authenticationProviders=new Map,this._onDidChangeSessions=new S.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._getSessionTaskSingler=new I,this._proxy=u.getProxy(T.MainContext.MainThreadAuthentication)}async getSession(u,C,v,r={}){const a=O.ExtensionIdentifier.toKey(u.identifier),d=[...v].sort().join(" ");return await this._getSessionTaskSingler.getOrCreate(`${a} ${C} ${d}`,async()=>{await this._proxy.$ensureProvider(C);const l=u.displayName||u.name;return this._proxy.$getSession(C,v,a,l,r)})}async getAccounts(u){return await this._proxy.$ensureProvider(u),await this._proxy.$getAccounts(u)}async removeSession(u,C){const v=this._authenticationProviders.get(u);return v?v.provider.removeSession(C):this._proxy.$removeSession(u,C)}registerAuthenticationProvider(u,C,v,r){if(this._authenticationProviders.get(u))throw new Error(`An authentication provider with id '${u}' is already registered.`);this._authenticationProviders.set(u,{label:C,provider:v,options:r??{supportsMultipleAccounts:!1}});const a=v.onDidChangeSessions(d=>this._proxy.$sendDidChangeSessions(u,d));return this._proxy.$registerAuthenticationProvider(u,C,r?.supportsMultipleAccounts??!1),new D.Disposable(()=>{a.dispose(),this._authenticationProviders.delete(u),this._proxy.$unregisterAuthenticationProvider(u)})}async $createSession(u,C,v){const r=this._authenticationProviders.get(u);if(r)return await r.provider.createSession(C,v);throw new Error(`Unable to find authentication provider with handle: ${u}`)}async $removeSession(u,C){const v=this._authenticationProviders.get(u);if(v)return await v.provider.removeSession(C);throw new Error(`Unable to find authentication provider with handle: ${u}`)}async $getSessions(u,C,v){const r=this._authenticationProviders.get(u);if(r)return await r.provider.getSessions(C,v);throw new Error(`Unable to find authentication provider with handle: ${u}`)}$onDidChangeAuthenticationSessions(u,C){return u.startsWith(k.INTERNAL_AUTH_PROVIDER_PREFIX)||this._onDidChangeSessions.fire({provider:{id:u,label:C}}),Promise.resolve()}};e.ExtHostAuthentication=s,e.ExtHostAuthentication=s=qe([We(0,m.IExtHostRpcService)],s);class I{constructor(){this._inFlightPromises=new Map}getOrCreate(u,C){const v=this._inFlightPromises.get(u);if(v)return v;const r=C().finally(()=>this._inFlightPromises.delete(u));return this._inFlightPromises.set(u,r),r}}}),define(ke[124],Re([1,0,2,5,7,3,16,11,17,13,22,21]),function(Ee,e,S,T,D,O,k,A,m,s,I,E){"use strict";var u;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let C=class{static{u=this}static{this._handlePool=0}static{this._maxEventSize=250}constructor(r,a){this._logService=a,this._provider=new Map,this._proxy=r.getProxy(T.MainContext.MainThreadDecorations)}registerFileDecorationProvider(r,a){const d=u._handlePool++;this._provider.set(d,{provider:r,extensionDescription:a}),this._proxy.$registerDecorationProvider(d,a.identifier.value);const l=r.onDidChangeFileDecorations&&r.onDidChangeFileDecorations(i=>{if(!i){this._proxy.$onDidChange(d,null);return}const n=(0,m.asArray)(i);if(n.length<=u._maxEventSize){this._proxy.$onDidChange(d,n);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",a.identifier.value,n.length);const t=n.map(g=>({uri:g,rank:(0,s.count)(g.path,"/")})),o=(0,m.groupBy)(t,(g,f)=>g.rank-f.rank||(0,s.compare)(g.uri.path,f.uri.path)),c=[];e:for(const g of o){let f;for(const h of g){const _=(0,I.dirname)(h.uri.path);if(f!==_&&(f=_,c.push(h.uri)>=u._maxEventSize))break e}}this._proxy.$onDidChange(d,c)});return new D.Disposable(()=>{l?.dispose(),this._proxy.$unregisterDecorationProvider(d),this._provider.delete(d)})}async $provideDecorations(r,a,d){if(!this._provider.has(r))return Object.create(null);const l=Object.create(null),{provider:i,extensionDescription:n}=this._provider.get(r);return await Promise.all(a.map(async t=>{try{const{uri:o,id:c}=t,g=await Promise.resolve(i.provideFileDecoration(S.URI.revive(o),d));if(!g)return;try{D.FileDecoration.validate(g),g.badge&&typeof g.badge!="string"&&(0,E.checkProposedApiEnabled)(n,"codiconDecoration"),l[c]=[g.propagate,g.tooltip,g.badge,g.color]}catch(f){this._logService.warn(`INVALID decoration from extension '${n.identifier.value}': ${f}`)}}catch(o){this._logService.error(o)}})),l}};e.ExtHostDecorations=C,e.ExtHostDecorations=C=u=qe([We(0,k.IExtHostRpcService),We(1,A.ILogService)],C),e.IExtHostDecorations=(0,O.createDecorator)("IExtHostDecorations")}),define(ke[228],Re([1,0,12,2,7,5,15,19,13]),function(Ee,e,S,T,D,O,k,A,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class s{static{this._handlePool=0}constructor(E,u,C){this._documentsAndEditors=u,this._logService=C,this._documentContentProviders=new Map,this._proxy=E.getProxy(O.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(E,u){if(Object.keys(k.Schemas).indexOf(E)>=0)throw new Error(`scheme '${E}' already registered`);const C=s._handlePool++;this._documentContentProviders.set(C,u),this._proxy.$registerTextContentProvider(C,E);let v;if(typeof u.onDidChange=="function"){let r;v=u.onDidChange(async a=>{if(a.scheme!==E){this._logService.warn(`Provider for scheme '${E}' is firing event for schema '${a.scheme}' which will be IGNORED`);return}if(!this._documentsAndEditors.getDocument(a))return;r&&await r;const d=this.$provideTextDocumentContent(C,a).then(async l=>{if(!l&&typeof l!="string")return;const i=this._documentsAndEditors.getDocument(a);if(!i)return;const n=(0,m.splitLines)(l);if(!i.equalLines(n))return this._proxy.$onVirtualDocumentChange(a,l)}).catch(S.onUnexpectedError).finally(()=>{r===d&&(r=void 0)});r=d})}return new D.Disposable(()=>{this._documentContentProviders.delete(C)&&this._proxy.$unregisterTextContentProvider(C),v&&(v.dispose(),v=void 0)})}$provideTextDocumentContent(E,u){const C=this._documentContentProviders.get(E);return C?Promise.resolve(C.provideTextDocumentContent(T.URI.revive(u),A.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${u.scheme}`))}}e.ExtHostDocumentContentProvider=s}),define(ke[125],Re([1,0,61,15,13,284,170,7,17]),function(Ee,e,S,T,D,O,k,A,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=void 0,e.setWordDefinitionFor=I;const s=new Map;function I(v,r){r?s.set(v,r):s.delete(v)}function E(v){return s.get(v)}class u extends O.MirrorTextModel{constructor(r,a,d,l,i,n,t){super(a,d,l,i),this._proxy=r,this._languageId=n,this._isDirty=t,this._isDisposed=!1}dispose(){(0,S.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(r){return(0,m.equals)(this._lines,r)}get document(){if(!this._document){const r=this;this._document={get uri(){return r._uri},get fileName(){return r._uri.fsPath},get isUntitled(){return r._uri.scheme===T.Schemas.untitled},get languageId(){return r._languageId},get version(){return r._versionId},get isClosed(){return r._isDisposed},get isDirty(){return r._isDirty},save(){return r._save()},getText(a){return a?r._getTextInRange(a):r.getText()},get eol(){return r._eol===`
`?A.EndOfLine.LF:A.EndOfLine.CRLF},get lineCount(){return r._lines.length},lineAt(a){return r._lineAt(a)},offsetAt(a){return r._offsetAt(a)},positionAt(a){return r._positionAt(a)},validateRange(a){return r._validateRange(a)},validatePosition(a){return r._validatePosition(a)},getWordRangeAtPosition(a,d){return r._getWordRangeAtPosition(a,d)},[Symbol.for("debug.description")](){return`TextDocument(${r._uri.toString()})`}}}return Object.freeze(this._document)}_acceptLanguageId(r){(0,S.ok)(!this._isDisposed),this._languageId=r}_acceptIsDirty(r){(0,S.ok)(!this._isDisposed),this._isDirty=r}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(r){const a=this._validateRange(r);if(a.isEmpty)return"";if(a.isSingleLine)return this._lines[a.start.line].substring(a.start.character,a.end.character);const d=this._eol,l=a.start.line,i=a.end.line,n=[];n.push(this._lines[l].substring(a.start.character));for(let t=l+1;t<i;t++)n.push(this._lines[t]);return n.push(this._lines[i].substring(0,a.end.character)),n.join(d)}_lineAt(r){let a;if(r instanceof A.Position?a=r.line:typeof r=="number"&&(a=r),typeof a!="number"||a<0||a>=this._lines.length||Math.floor(a)!==a)throw new Error("Illegal value for `line`");return new C(a,this._lines[a],a===this._lines.length-1)}_offsetAt(r){return r=this._validatePosition(r),this._ensureLineStarts(),this._lineStarts.getPrefixSum(r.line-1)+r.character}_positionAt(r){r=Math.floor(r),r=Math.max(0,r),this._ensureLineStarts();const a=this._lineStarts.getIndexOf(r),d=this._lines[a.index].length;return new A.Position(a.index,Math.min(a.remainder,d))}_validateRange(r){if(!(r instanceof A.Range))throw new Error("Invalid argument");const a=this._validatePosition(r.start),d=this._validatePosition(r.end);return a===r.start&&d===r.end?r:new A.Range(a.line,a.character,d.line,d.character)}_validatePosition(r){if(!(r instanceof A.Position))throw new Error("Invalid argument");if(this._lines.length===0)return r.with(0,0);let{line:a,character:d}=r,l=!1;if(a<0)a=0,d=0,l=!0;else if(a>=this._lines.length)a=this._lines.length-1,d=this._lines[a].length,l=!0;else{const i=this._lines[a].length;d<0?(d=0,l=!0):d>i&&(d=i,l=!0)}return l?new A.Position(a,d):r}_getWordRangeAtPosition(r,a){const d=this._validatePosition(r);if(!a)a=E(this._languageId);else if((0,D.regExpLeadsToEndlessLoop)(a))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${a.source}' because it matches the empty string.`);const l=(0,k.getWordAtText)(d.character+1,(0,k.ensureValidWordDefinition)(a),this._lines[d.line],0);if(l)return new A.Range(d.line,l.startColumn-1,d.line,l.endColumn-1)}}e.ExtHostDocumentData=u;class C{constructor(r,a,d){this._line=r,this._text=a,this._isLastLine=d}get lineNumber(){return this._line}get text(){return this._text}get range(){return new A.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new A.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=C}),define(ke[229],Re([1,0,5,7]),function(Ee,e,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAiEmbeddingVector=void 0;class D{constructor(k){this._AiEmbeddingVectorProviders=new Map,this._nextHandle=0,this._proxy=k.getProxy(S.MainContext.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(k,A,m){if(this._AiEmbeddingVectorProviders.size===0)throw new Error("No embedding vector providers registered");const s=this._AiEmbeddingVectorProviders.get(k);if(!s)throw new Error("Embedding vector provider not found");const I=await s.provideEmbeddingVector(A,m);if(!I)throw new Error("Embedding vector provider returned undefined");return I}registerEmbeddingVectorProvider(k,A,m){const s=this._nextHandle;return this._nextHandle++,this._AiEmbeddingVectorProviders.set(s,m),this._proxy.$registerAiEmbeddingVectorProvider(A,s),new T.Disposable(()=>{this._proxy.$unregisterAiEmbeddingVectorProvider(s),this._AiEmbeddingVectorProviders.delete(s)})}}e.ExtHostAiEmbeddingVector=D}),define(ke[68],Re([1,0,5,28,7,20,3,16,50,4,10,24,15]),function(Ee,e,S,T,D,O,k,A,m,s,I,E,u){"use strict";var C;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0,T=Ve(T);let v=C=class{constructor(a,d){this._fileSystemProvider=new Map,this._writeQueue=new I.ResourceQueue,this._proxy=a.getProxy(S.MainContext.MainThreadFileSystem);const l=this;this.value=Object.freeze({async stat(i){try{let n;const t=l._fileSystemProvider.get(i.scheme);return t?(await l._proxy.$ensureActivation(i.scheme),n=await t.impl.stat(i)):n=await l._proxy.$stat(i),{type:n.type,ctime:n.ctime,mtime:n.mtime,size:n.size,permissions:n.permissions===T.FilePermission.Readonly?1:void 0}}catch(n){C._handleError(n)}},async readDirectory(i){try{const n=l._fileSystemProvider.get(i.scheme);return n?(await l._proxy.$ensureActivation(i.scheme),(await n.impl.readDirectory(i)).slice()):await l._proxy.$readdir(i)}catch(n){return C._handleError(n)}},async createDirectory(i){try{const n=l._fileSystemProvider.get(i.scheme);return n&&!n.isReadonly?(await l._proxy.$ensureActivation(i.scheme),await l.mkdirp(n.impl,n.extUri,i)):await l._proxy.$mkdir(i)}catch(n){return C._handleError(n)}},async readFile(i){try{const n=l._fileSystemProvider.get(i.scheme);return n?(await l._proxy.$ensureActivation(i.scheme),(await n.impl.readFile(i)).slice()):(await l._proxy.$readFile(i)).buffer}catch(n){return C._handleError(n)}},async writeFile(i,n){try{const t=l._fileSystemProvider.get(i.scheme);return t&&!t.isReadonly?(await l._proxy.$ensureActivation(i.scheme),await l.mkdirp(t.impl,t.extUri,t.extUri.dirname(i)),await l._writeQueue.queueFor(i,()=>Promise.resolve(t.impl.writeFile(i,n,{create:!0,overwrite:!0})))):await l._proxy.$writeFile(i,O.VSBuffer.wrap(n))}catch(t){return C._handleError(t)}},async delete(i,n){try{const t=l._fileSystemProvider.get(i.scheme);return t&&!t.isReadonly&&!n?.useTrash?(await l._proxy.$ensureActivation(i.scheme),await t.impl.delete(i,{recursive:!1,...n})):await l._proxy.$delete(i,{recursive:!1,useTrash:!1,atomic:!1,...n})}catch(t){return C._handleError(t)}},async rename(i,n,t){try{return await l._proxy.$rename(i,n,{overwrite:!1,...t})}catch(o){return C._handleError(o)}},async copy(i,n,t){try{return await l._proxy.$copy(i,n,{overwrite:!1,...t})}catch(o){return C._handleError(o)}},isWritableFileSystem(i){const n=d.getCapabilities(i);if(typeof n=="number")return!(n&T.FileSystemProviderCapabilities.Readonly)}})}async mkdirp(a,d,l){const i=[];for(;!d.isEqual(l,d.dirname(l));)try{if(!((await a.stat(l)).type&T.FileType.Directory))throw D.FileSystemError.FileExists(`Unable to create folder '${l.scheme===u.Schemas.file?l.fsPath:l.toString(!0)}' that already exists but is not a directory`);break}catch(n){if(T.toFileSystemProviderErrorCode(n)!==T.FileSystemProviderErrorCode.FileNotFound)throw n;i.push(d.basename(l)),l=d.dirname(l)}for(let n=i.length-1;n>=0;n--){l=d.joinPath(l,i[n]);try{await a.createDirectory(l)}catch(t){if(T.toFileSystemProviderErrorCode(t)!==T.FileSystemProviderErrorCode.FileExists)throw t}}}static _handleError(a){if(a instanceof D.FileSystemError)throw a;if(a instanceof T.FileSystemProviderError)switch(a.code){case T.FileSystemProviderErrorCode.FileExists:throw D.FileSystemError.FileExists(a.message);case T.FileSystemProviderErrorCode.FileNotFound:throw D.FileSystemError.FileNotFound(a.message);case T.FileSystemProviderErrorCode.FileNotADirectory:throw D.FileSystemError.FileNotADirectory(a.message);case T.FileSystemProviderErrorCode.FileIsADirectory:throw D.FileSystemError.FileIsADirectory(a.message);case T.FileSystemProviderErrorCode.NoPermissions:throw D.FileSystemError.NoPermissions(a.message);case T.FileSystemProviderErrorCode.Unavailable:throw D.FileSystemError.Unavailable(a.message);default:throw new D.FileSystemError(a.message,a.name)}if(!(a instanceof Error))throw new D.FileSystemError(String(a));if(a.name==="ENOPRO"||a.message.includes("ENOPRO"))throw D.FileSystemError.Unavailable(a.message);switch(a.name){case T.FileSystemProviderErrorCode.FileExists:throw D.FileSystemError.FileExists(a.message);case T.FileSystemProviderErrorCode.FileNotFound:throw D.FileSystemError.FileNotFound(a.message);case T.FileSystemProviderErrorCode.FileNotADirectory:throw D.FileSystemError.FileNotADirectory(a.message);case T.FileSystemProviderErrorCode.FileIsADirectory:throw D.FileSystemError.FileIsADirectory(a.message);case T.FileSystemProviderErrorCode.NoPermissions:throw D.FileSystemError.NoPermissions(a.message);case T.FileSystemProviderErrorCode.Unavailable:throw D.FileSystemError.Unavailable(a.message);default:throw new D.FileSystemError(a.message,a.name)}}addFileSystemProvider(a,d,l){return this._fileSystemProvider.set(a,{impl:d,extUri:l?.isCaseSensitive?E.extUri:E.extUriIgnorePathCase,isReadonly:!!l?.isReadonly}),(0,s.toDisposable)(()=>this._fileSystemProvider.delete(a))}getFileSystemProviderExtUri(a){return this._fileSystemProvider.get(a)?.extUri??E.extUri}};e.ExtHostConsumerFileSystem=v,e.ExtHostConsumerFileSystem=v=C=qe([We(0,A.IExtHostRpcService),We(1,m.IExtHostFileSystemInfo)],v),e.IExtHostConsumerFileSystem=(0,k.createDecorator)("IExtHostConsumerFileSystem")}),define(ke[92],Re([1,0,3,26,11,68,2]),function(Ee,e,S,T,D,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,S.createDecorator)("IExtensionStoragePaths");let A=class{constructor(s,I,E){this._logService=I,this._extHostFileSystem=E,this._workspace=s.workspace??void 0,this._environment=s.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(u=>this._value=u)}async _getWorkspaceStorageURI(s){return k.URI.joinPath(this._environment.workspaceStorageHome,s)}async _getOrCreateWorkspaceStoragePath(){if(!this._workspace)return Promise.resolve(void 0);const s=this._workspace.id,I=await this._getWorkspaceStorageURI(s);try{return await this._extHostFileSystem.value.stat(I),this._logService.trace("[ExtHostStorage] storage dir already exists",I),I}catch{}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",I),await this._extHostFileSystem.value.createDirectory(I),await this._extHostFileSystem.value.writeFile(k.URI.joinPath(I,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:k.URI.revive(this._workspace.configuration)?.toString(),name:this._workspace.name},void 0,2))),I}catch(E){this._logService.error("[ExtHostStorage]",E);return}}workspaceValue(s){if(this._value)return k.URI.joinPath(this._value,s.identifier.value)}globalValue(s){return k.URI.joinPath(this._environment.globalStorageHome,s.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.ExtensionStoragePaths=A,e.ExtensionStoragePaths=A=qe([We(0,T.IExtHostInitDataService),We(1,D.ILogService),We(2,O.IExtHostConsumerFileSystem)],A)}),define(ke[230],Re([1,0,7,16,6]),function(Ee,e,S,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let O=class{constructor(A){this._actual=new S.ColorTheme(S.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new D.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(A){let m;switch(A){case"light":m=S.ColorThemeKind.Light;break;case"hcDark":m=S.ColorThemeKind.HighContrast;break;case"hcLight":m=S.ColorThemeKind.HighContrastLight;break;default:m=S.ColorThemeKind.Dark}this._actual=new S.ColorTheme(m),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};e.ExtHostTheming=O,e.ExtHostTheming=O=qe([We(0,T.IExtHostRpcService)],O)}),define(ke[93],Re([1,0,19,6,4,9,3,11,184,5,26,16,7]),function(Ee,e,S,T,D,O,k,A,m,s,I,E,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDtoConverter=void 0,O=Ve(O),u=Ve(u);class C extends m.DisposableTunnel{}var v;(function(a){function d(i){return{remoteAddress:i.remoteAddress,localAddress:i.localAddress,public:!!i.public,privacy:i.privacy??(i.public?m.TunnelPrivacyId.Public:m.TunnelPrivacyId.Private),protocol:i.protocol}}a.fromApiTunnel=d;function l(i){return{remoteAddress:{host:i.tunnelRemoteHost,port:i.tunnelRemotePort},localAddress:i.localAddress,public:i.privacy!==m.TunnelPrivacyId.ConstantPrivate&&i.privacy!==m.TunnelPrivacyId.ConstantPrivate,privacy:i.privacy,protocol:i.protocol}}a.fromServiceTunnel=l})(v||(e.TunnelDtoConverter=v={})),e.IExtHostTunnelService=(0,k.createDecorator)("IExtHostTunnelService");let r=class extends D.Disposable{constructor(d,l,i){super(),this.logService=i,this._showCandidatePort=()=>Promise.resolve(!0),this._extensionTunnels=new Map,this._onDidChangeTunnels=new T.Emitter,this.onDidChangeTunnels=this._onDidChangeTunnels.event,this._providerHandleCounter=0,this._portAttributesProviders=new Map,this._proxy=d.getProxy(s.MainContext.MainThreadTunnelService)}async openTunnel(d,l){this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) ${d.identifier.value} called openTunnel API for ${l.remoteAddress.host}:${l.remoteAddress.port}.`);const i=await this._proxy.$openTunnel(l,d.displayName);if(i){const n=new C(i.remoteAddress,i.localAddress,()=>this._proxy.$closeTunnel(i.remoteAddress));return this._register(n),n}}async getTunnels(){return this._proxy.$getTunnels()}nextPortAttributesProviderHandle(){return this._providerHandleCounter++}registerPortsAttributesProvider(d,l){d.portRange===void 0&&d.commandPattern===void 0&&this.logService.error("PortAttributesProvider must specify either a portRange or a commandPattern");const i=this.nextPortAttributesProviderHandle();return this._portAttributesProviders.set(i,{selector:d,provider:l}),this._proxy.$registerPortsAttributesProvider(d,i),new u.Disposable(()=>{this._portAttributesProviders.delete(i),this._proxy.$unregisterPortsAttributesProvider(i)})}async $providePortAttributes(d,l,i,n,t){const o=[];for(const g of d){const f=this._portAttributesProviders.get(g);if(!f)return[];o.push(...await Promise.all(l.map(async h=>{let _;try{_=await f.provider.providePortAttributes({port:h,pid:i,commandLine:n},t)}catch{_=await f.provider.providePortAttributes(h,i,n,t)}return{providedAttributes:_,port:h}})))}const c=o.filter(g=>!!g.providedAttributes);return c.length>0?c.map(g=>({autoForwardAction:g.providedAttributes.autoForwardAction,port:g.port})):[]}async $registerCandidateFinder(d){}registerTunnelProvider(d,l){if(this._forwardPortProvider)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this._forwardPortProvider=async(n,t)=>await d.provideTunnel(n,t,S.CancellationToken.None)??void 0;const i=l.tunnelFeatures?{elevation:!!l.tunnelFeatures?.elevation,privacyOptions:l.tunnelFeatures?.privacyOptions,protocol:l.tunnelFeatures.protocol===void 0?!0:l.tunnelFeatures.protocol}:void 0;return this._proxy.$setTunnelProvider(i),Promise.resolve((0,D.toDisposable)(()=>{this._forwardPortProvider=void 0,this._proxy.$setTunnelProvider(void 0)}))}async setTunnelFactory(d,l){if(d){d.candidatePortSource!==void 0&&this._proxy.$setCandidatePortSource(d.candidatePortSource),d.showCandidatePort&&(this._showCandidatePort=d.showCandidatePort,this._proxy.$setCandidateFilter());const i=d.tunnelFactory??(l?this.makeManagedTunnelFactory(l):void 0);if(i){this._forwardPortProvider=i;let n=d.tunnelFeatures?.privacyOptions??[];d.tunnelFeatures?.public&&n.length===0&&(n=[{id:"private",label:O.localize(2716,null),themeIcon:"lock"},{id:"public",label:O.localize(2717,null),themeIcon:"eye"}]);const t=d.tunnelFeatures?{elevation:!!d.tunnelFeatures?.elevation,public:!!d.tunnelFeatures?.public,privacyOptions:n,protocol:!0}:void 0;this._proxy.$setTunnelProvider(t)}}else this._forwardPortProvider=void 0;return(0,D.toDisposable)(()=>{this._forwardPortProvider=void 0})}makeManagedTunnelFactory(d){}async $closeTunnel(d,l){if(this._extensionTunnels.has(d.host)){const i=this._extensionTunnels.get(d.host);i.has(d.port)&&(l&&i.get(d.port).disposeListener.dispose(),await i.get(d.port).tunnel.dispose(),i.delete(d.port))}}async $onDidTunnelsChange(){this._onDidChangeTunnels.fire()}async $forwardPort(d,l){if(this._forwardPortProvider)try{this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const i=this._forwardPortProvider(d,l);if(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),i!==void 0){const n=await i;if(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),n===void 0){this.logService.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this._extensionTunnels.has(d.remoteAddress.host)||this._extensionTunnels.set(d.remoteAddress.host,new Map);const t=this._register(n.onDidDispose(()=>(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this._proxy.$closeTunnel(n.remoteAddress))));return this._extensionTunnels.get(d.remoteAddress.host).set(d.remoteAddress.port,{tunnel:n,disposeListener:t}),v.fromApiTunnel(n)}else this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(i){if(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),i instanceof Error)return i.message}}async $applyCandidateFilter(d){const l=await Promise.all(d.map(n=>this._showCandidatePort(n.host,n.port,n.detail??""))),i=d.filter((n,t)=>l[t]);return this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${d.map(n=>n.port).join(", ")} to ${i.map(n=>n.port).join(", ")}`),i}};e.ExtHostTunnelService=r,e.ExtHostTunnelService=r=qe([We(0,E.IExtHostRpcService),We(1,I.IExtHostInitDataService),We(2,A.ILogService)],r)}),define(ke[8],Re([1,0,17,20,150,231,59,27,140,34,72,25,146,24,36,14,2,106,32,154,94,52,108,77,118,116,117,207,81,90,54,55,204,7]),function(Ee,e,S,T,D,O,k,A,m,s,I,E,u,C,v,r,a,d,l,i,n,t,o,c,g,f,h,_,y,w,P,R,p,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageModelToolDescription=e.DebugTreeItem=e.PartialAcceptTriggerKind=e.PartialAcceptInfo=e.TerminalQuickFix=e.LanguageModelToolResult=e.ChatAgentUserActionEvent=e.ChatAgentResult=e.ChatAgentCompletionItem=e.ChatLanguageModelToolReference=e.ChatPromptReference=e.ChatLocation=e.ChatAgentRequest=e.ChatResponsePart=e.ChatResponseCodeCitationPart=e.ChatResponseReferencePart=e.ChatResponseTextEditPart=e.ChatResponseCommandButtonPart=e.ChatTaskResult=e.ChatTask=e.ChatResponseMovePart=e.ChatResponseWarningPart=e.ChatResponseProgressPart=e.ChatResponseAnchorPart=e.ChatResponseFilesPart=e.ChatResponseConfirmationPart=e.ChatResponseDetectedParticipantPart=e.ChatResponseMarkdownWithVulnerabilitiesPart=e.ChatResponseMarkdownPart=e.LanguageModelChatMessage=e.LanguageModelChatMessageRole=e.ChatFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.MultiDocumentHighlight=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.MarkdownString=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Location=e.Range=e.Selection=void 0,e.isDecorationOptionsArr=ie,e.fromRangeOrRangeWithMessage=Z,e.pathOrURIToURI=ve,k=Ve(k),m=Ve(m),l=Ve(l),i=Ve(i),n=Ve(n),_=Ve(_),w=Ve(w),b=Ve(b);var N;(function(me){function Te(j){const{selectionStartLineNumber:Ce,selectionStartColumn:Be,positionLineNumber:Ye,positionColumn:xe}=j,ot=new b.Position(Ce-1,Be-1),gt=new b.Position(Ye-1,xe-1);return new b.Selection(ot,gt)}me.to=Te;function le(j){const{anchor:Ce,active:Be}=j;return{selectionStartLineNumber:Ce.line+1,selectionStartColumn:Ce.character+1,positionLineNumber:Be.line+1,positionColumn:Be.character+1}}me.from=le})(N||(e.Selection=N={}));var L;(function(me){function Te(j){if(!j)return;const{start:Ce,end:Be}=j;return{startLineNumber:Ce.line+1,startColumn:Ce.character+1,endLineNumber:Be.line+1,endColumn:Be.character+1}}me.from=Te;function le(j){if(!j)return;const{startLineNumber:Ce,startColumn:Be,endLineNumber:Ye,endColumn:xe}=j;return new b.Range(Ce-1,Be-1,Ye-1,xe-1)}me.to=le})(L||(e.Range=L={}));var F;(function(me){function Te(j){return{uri:j.uri,range:L.from(j.range)}}me.from=Te;function le(j){return new b.Location(a.URI.revive(j.uri),L.to(j.range))}me.to=le})(F||(e.Location=F={}));var K;(function(me){function Te(le){switch(le){case i.StandardTokenType.Comment:return b.StandardTokenType.Comment;case i.StandardTokenType.Other:return b.StandardTokenType.Other;case i.StandardTokenType.RegEx:return b.StandardTokenType.RegEx;case i.StandardTokenType.String:return b.StandardTokenType.String}}me.to=Te})(K||(e.TokenType=K={}));var J;(function(me){function Te(j){return new b.Position(j.lineNumber-1,j.column-1)}me.to=Te;function le(j){return{lineNumber:j.line+1,column:j.character+1}}me.from=le})(J||(e.Position=J={}));var $;(function(me){function Te(Ce,Be,Ye){return(0,S.coalesce)((0,S.asArray)(Ce).map(xe=>le(xe,Be,Ye)))}me.from=Te;function le(Ce,Be,Ye){if(typeof Ce=="string")return{$serialized:!0,language:Ce,isBuiltin:Ye?.isBuiltin};if(Ce)return{$serialized:!0,language:Ce.language,scheme:j(Ce.scheme,Be),pattern:He.from(Ce.pattern)??void 0,exclusive:Ce.exclusive,notebookType:Ce.notebookType,isBuiltin:Ye?.isBuiltin}}function j(Ce,Be){return Be&&typeof Ce=="string"?Be.transformOutgoingScheme(Ce):Ce}})($||(e.DocumentSelector=$={}));var x;(function(me){function Te(j){switch(j){case b.DiagnosticTag.Unnecessary:return o.MarkerTag.Unnecessary;case b.DiagnosticTag.Deprecated:return o.MarkerTag.Deprecated}}me.from=Te;function le(j){switch(j){case o.MarkerTag.Unnecessary:return b.DiagnosticTag.Unnecessary;case o.MarkerTag.Deprecated:return b.DiagnosticTag.Deprecated;default:return}}me.to=le})(x||(e.DiagnosticTag=x={}));var G;(function(me){function Te(j){let Ce;return j.code&&((0,r.isString)(j.code)||(0,r.isNumber)(j.code)?Ce=String(j.code):Ce={value:String(j.code.value),target:j.code.target}),{...L.from(j.range),message:j.message,source:j.source,code:Ce,severity:ae.from(j.severity),relatedInformation:j.relatedInformation&&j.relatedInformation.map(Y.from),tags:Array.isArray(j.tags)?(0,S.coalesce)(j.tags.map(x.from)):void 0}}me.from=Te;function le(j){const Ce=new b.Diagnostic(L.to(j),j.message,ae.to(j.severity));return Ce.source=j.source,Ce.code=(0,r.isString)(j.code)?j.code:j.code?.value,Ce.relatedInformation=j.relatedInformation&&j.relatedInformation.map(Y.to),Ce.tags=j.tags&&(0,S.coalesce)(j.tags.map(x.to)),Ce}me.to=le})(G||(e.Diagnostic=G={}));var Y;(function(me){function Te(j){return{...L.from(j.location.range),message:j.message,resource:j.location.uri}}me.from=Te;function le(j){return new b.DiagnosticRelatedInformation(new b.Location(j.resource,L.to(j)),j.message)}me.to=le})(Y||(e.DiagnosticRelatedInformation=Y={}));var ae;(function(me){function Te(j){switch(j){case b.DiagnosticSeverity.Error:return o.MarkerSeverity.Error;case b.DiagnosticSeverity.Warning:return o.MarkerSeverity.Warning;case b.DiagnosticSeverity.Information:return o.MarkerSeverity.Info;case b.DiagnosticSeverity.Hint:return o.MarkerSeverity.Hint}return o.MarkerSeverity.Error}me.from=Te;function le(j){switch(j){case o.MarkerSeverity.Info:return b.DiagnosticSeverity.Information;case o.MarkerSeverity.Warning:return b.DiagnosticSeverity.Warning;case o.MarkerSeverity.Error:return b.DiagnosticSeverity.Error;case o.MarkerSeverity.Hint:return b.DiagnosticSeverity.Hint;default:return b.DiagnosticSeverity.Error}}me.to=le})(ae||(e.DiagnosticSeverity=ae={}));var ee;(function(me){function Te(j){return typeof j=="number"&&j>=b.ViewColumn.One?j-1:j===b.ViewColumn.Beside?p.SIDE_GROUP:p.ACTIVE_GROUP}me.from=Te;function le(j){if(typeof j=="number"&&j>=0)return j+1;throw new Error("invalid 'EditorGroupColumn'")}me.to=le})(ee||(e.ViewColumn=ee={}));function oe(me){return typeof me.range<"u"}function ie(me){return me.length===0?!0:!!oe(me[0])}var ue;(function(me){function Te(xe){return xe.map(me.from)}me.fromMany=Te;function le(xe){return xe&&typeof xe=="object"&&typeof xe.language=="string"&&typeof xe.value=="string"}function j(xe){let ot;if(le(xe)){const{language:Vt,value:Bt}=xe;ot={value:"```"+Vt+`
`+Bt+"\n```\n"}}else b.MarkdownString.isMarkdownString(xe)?ot={value:xe.value,isTrusted:xe.isTrusted,supportThemeIcons:xe.supportThemeIcons,supportHtml:xe.supportHtml,baseUri:xe.baseUri}:typeof xe=="string"?ot={value:xe}:ot={value:""};const gt=Object.create(null);ot.uris=gt;const jt=({href:Vt})=>{try{let Bt=a.URI.parse(Vt,!0);Bt=Bt.with({query:Ce(Bt.query,gt)}),gt[Vt]=Bt}catch{}return""};return m.marked.walkTokens(m.marked.lexer(ot.value),Vt=>{Vt.type==="link"?jt({href:Vt.href}):Vt.type==="image"&&typeof Vt.href=="string"&&jt(k.parseHrefAndDimensions(Vt.href))}),ot}me.from=j;function Ce(xe,ot){if(!xe)return xe;let gt;try{gt=(0,s.parse)(xe)}catch{}if(!gt)return xe;let jt=!1;return gt=(0,E.cloneAndChange)(gt,Vt=>{if(a.URI.isUri(Vt)){const Bt=`__uri_${Math.random().toString(16).slice(2,8)}`;return ot[Bt]=Vt,jt=!0,Bt}else return}),jt?JSON.stringify(gt):xe}function Be(xe){const ot=new b.MarkdownString(xe.value,xe.supportThemeIcons);return ot.isTrusted=xe.isTrusted,ot.supportHtml=xe.supportHtml,ot.baseUri=xe.baseUri?a.URI.from(xe.baseUri):void 0,ot}me.to=Be;function Ye(xe){if(xe)return typeof xe=="string"?xe:me.from(xe)}me.fromStrict=Ye})(ue||(e.MarkdownString=ue={}));function Z(me){return ie(me)?me.map(Te=>({range:L.from(Te.range),hoverMessage:Array.isArray(Te.hoverMessage)?ue.fromMany(Te.hoverMessage):Te.hoverMessage?ue.from(Te.hoverMessage):void 0,renderOptions:Te.renderOptions})):me.map(Te=>({range:L.from(Te)}))}function ve(me){return typeof me>"u"?me:typeof me=="string"?a.URI.file(me):me}var Ie;(function(me){function Te(le){return typeof le>"u"?le:{contentText:le.contentText,contentIconPath:le.contentIconPath?ve(le.contentIconPath):void 0,border:le.border,borderColor:le.borderColor,fontStyle:le.fontStyle,fontWeight:le.fontWeight,textDecoration:le.textDecoration,color:le.color,backgroundColor:le.backgroundColor,margin:le.margin,width:le.width,height:le.height}}me.from=Te})(Ie||(e.ThemableDecorationAttachmentRenderOptions=Ie={}));var X;(function(me){function Te(le){return typeof le>"u"?le:{backgroundColor:le.backgroundColor,outline:le.outline,outlineColor:le.outlineColor,outlineStyle:le.outlineStyle,outlineWidth:le.outlineWidth,border:le.border,borderColor:le.borderColor,borderRadius:le.borderRadius,borderSpacing:le.borderSpacing,borderStyle:le.borderStyle,borderWidth:le.borderWidth,fontStyle:le.fontStyle,fontWeight:le.fontWeight,textDecoration:le.textDecoration,cursor:le.cursor,color:le.color,opacity:le.opacity,letterSpacing:le.letterSpacing,gutterIconPath:le.gutterIconPath?ve(le.gutterIconPath):void 0,gutterIconSize:le.gutterIconSize,overviewRulerColor:le.overviewRulerColor,before:le.before?Ie.from(le.before):void 0,after:le.after?Ie.from(le.after):void 0}}me.from=Te})(X||(e.ThemableDecorationRenderOptions=X={}));var V;(function(me){function Te(le){if(typeof le>"u")return le;switch(le){case b.DecorationRangeBehavior.OpenOpen:return t.TrackedRangeStickiness.AlwaysGrowsWhenTypingAtEdges;case b.DecorationRangeBehavior.ClosedClosed:return t.TrackedRangeStickiness.NeverGrowsWhenTypingAtEdges;case b.DecorationRangeBehavior.OpenClosed:return t.TrackedRangeStickiness.GrowsOnlyWhenTypingBefore;case b.DecorationRangeBehavior.ClosedOpen:return t.TrackedRangeStickiness.GrowsOnlyWhenTypingAfter}}me.from=Te})(V||(e.DecorationRangeBehavior=V={}));var re;(function(me){function Te(le){return{isWholeLine:le.isWholeLine,rangeBehavior:le.rangeBehavior?V.from(le.rangeBehavior):void 0,overviewRulerLane:le.overviewRulerLane,light:le.light?X.from(le.light):void 0,dark:le.dark?X.from(le.dark):void 0,backgroundColor:le.backgroundColor,outline:le.outline,outlineColor:le.outlineColor,outlineStyle:le.outlineStyle,outlineWidth:le.outlineWidth,border:le.border,borderColor:le.borderColor,borderRadius:le.borderRadius,borderSpacing:le.borderSpacing,borderStyle:le.borderStyle,borderWidth:le.borderWidth,fontStyle:le.fontStyle,fontWeight:le.fontWeight,textDecoration:le.textDecoration,cursor:le.cursor,color:le.color,opacity:le.opacity,letterSpacing:le.letterSpacing,gutterIconPath:le.gutterIconPath?ve(le.gutterIconPath):void 0,gutterIconSize:le.gutterIconSize,overviewRulerColor:le.overviewRulerColor,before:le.before?Ie.from(le.before):void 0,after:le.after?Ie.from(le.after):void 0}}me.from=Te})(re||(e.DecorationRenderOptions=re={}));var be;(function(me){function Te(j){return{text:j.newText,eol:j.newEol&&Se.from(j.newEol),range:L.from(j.range)}}me.from=Te;function le(j){const Ce=new b.TextEdit(L.to(j.range),j.text);return Ce.newEol=typeof j.eol>"u"?void 0:Se.to(j.eol),Ce}me.to=le})(be||(e.TextEdit=be={}));var De;(function(me){function Te(j,Ce){const Be={edits:[]};if(j instanceof b.WorkspaceEdit){const Ye=new A.ResourceSet;for(const xe of j._allEntries())xe._type===b.FileEditType.File&&a.URI.isUri(xe.to)&&xe.from===void 0&&Ye.add(xe.to);for(const xe of j._allEntries())if(xe._type===b.FileEditType.File){let ot;xe.options?.contents&&(ArrayBuffer.isView(xe.options.contents)?ot={type:"base64",value:(0,T.encodeBase64)(T.VSBuffer.wrap(xe.options.contents))}:ot={type:"dataTransferItem",id:xe.options.contents._itemId}),Be.edits.push({oldResource:xe.from,newResource:xe.to,options:{...xe.options,contents:ot},metadata:xe.metadata})}else xe._type===b.FileEditType.Text?Be.edits.push({resource:xe.uri,textEdit:be.from(xe.edit),versionId:Ye.has(xe.uri)?void 0:Ce?.getTextDocumentVersion(xe.uri),metadata:xe.metadata}):xe._type===b.FileEditType.Snippet?Be.edits.push({resource:xe.uri,textEdit:{range:L.from(xe.range),text:xe.edit.value,insertAsSnippet:!0},versionId:Ye.has(xe.uri)?void 0:Ce?.getTextDocumentVersion(xe.uri),metadata:xe.metadata}):xe._type===b.FileEditType.Cell?Be.edits.push({metadata:xe.metadata,resource:xe.uri,cellEdit:xe.edit,notebookMetadata:xe.notebookMetadata,notebookVersionId:Ce?.getNotebookDocumentVersion(xe.uri)}):xe._type===b.FileEditType.CellReplace&&Be.edits.push({metadata:xe.metadata,resource:xe.uri,notebookVersionId:Ce?.getNotebookDocumentVersion(xe.uri),cellEdit:{editType:w.CellEditType.Replace,index:xe.index,count:xe.count,cells:xe.cells.map(Xe.from)}})}return Be}me.from=Te;function le(j){const Ce=new b.WorkspaceEdit,Be=new A.ResourceMap;for(const Ye of j.edits)if(Ye.textEdit){const xe=Ye,ot=a.URI.revive(xe.resource),gt=L.to(xe.textEdit.range),jt=xe.textEdit.text,Vt=xe.textEdit.insertAsSnippet;let Bt;Vt?Bt=b.SnippetTextEdit.replace(gt,new b.SnippetString(jt)):Bt=b.TextEdit.replace(gt,jt);const Oi=Be.get(ot);Oi?Oi.push(Bt):Be.set(ot,[Bt])}else Ce.renameFile(a.URI.revive(Ye.oldResource),a.URI.revive(Ye.newResource),Ye.options);for(const[Ye,xe]of Be)Ce.set(Ye,xe);return Ce}me.to=le})(De||(e.WorkspaceEdit=De={}));var Fe;(function(me){const Te=Object.create(null);Te[b.SymbolKind.File]=n.SymbolKind.File,Te[b.SymbolKind.Module]=n.SymbolKind.Module,Te[b.SymbolKind.Namespace]=n.SymbolKind.Namespace,Te[b.SymbolKind.Package]=n.SymbolKind.Package,Te[b.SymbolKind.Class]=n.SymbolKind.Class,Te[b.SymbolKind.Method]=n.SymbolKind.Method,Te[b.SymbolKind.Property]=n.SymbolKind.Property,Te[b.SymbolKind.Field]=n.SymbolKind.Field,Te[b.SymbolKind.Constructor]=n.SymbolKind.Constructor,Te[b.SymbolKind.Enum]=n.SymbolKind.Enum,Te[b.SymbolKind.Interface]=n.SymbolKind.Interface,Te[b.SymbolKind.Function]=n.SymbolKind.Function,Te[b.SymbolKind.Variable]=n.SymbolKind.Variable,Te[b.SymbolKind.Constant]=n.SymbolKind.Constant,Te[b.SymbolKind.String]=n.SymbolKind.String,Te[b.SymbolKind.Number]=n.SymbolKind.Number,Te[b.SymbolKind.Boolean]=n.SymbolKind.Boolean,Te[b.SymbolKind.Array]=n.SymbolKind.Array,Te[b.SymbolKind.Object]=n.SymbolKind.Object,Te[b.SymbolKind.Key]=n.SymbolKind.Key,Te[b.SymbolKind.Null]=n.SymbolKind.Null,Te[b.SymbolKind.EnumMember]=n.SymbolKind.EnumMember,Te[b.SymbolKind.Struct]=n.SymbolKind.Struct,Te[b.SymbolKind.Event]=n.SymbolKind.Event,Te[b.SymbolKind.Operator]=n.SymbolKind.Operator,Te[b.SymbolKind.TypeParameter]=n.SymbolKind.TypeParameter;function le(Ce){return typeof Te[Ce]=="number"?Te[Ce]:n.SymbolKind.Property}me.from=le;function j(Ce){for(const Be in Te)if(Te[Be]===Ce)return Number(Be);return b.SymbolKind.Property}me.to=j})(Fe||(e.SymbolKind=Fe={}));var ze;(function(me){function Te(j){switch(j){case b.SymbolTag.Deprecated:return n.SymbolTag.Deprecated}}me.from=Te;function le(j){switch(j){case n.SymbolTag.Deprecated:return b.SymbolTag.Deprecated}}me.to=le})(ze||(e.SymbolTag=ze={}));var Je;(function(me){function Te(j){return{name:j.name,kind:Fe.from(j.kind),tags:j.tags&&j.tags.map(ze.from),containerName:j.containerName,location:et.from(j.location)}}me.from=Te;function le(j){const Ce=new b.SymbolInformation(j.name,Fe.to(j.kind),j.containerName,et.to(j.location));return Ce.tags=j.tags&&j.tags.map(ze.to),Ce}me.to=le})(Je||(e.WorkspaceSymbol=Je={}));var nt;(function(me){function Te(j){const Ce={name:j.name||"!!MISSING: name!!",detail:j.detail,range:L.from(j.range),selectionRange:L.from(j.selectionRange),kind:Fe.from(j.kind),tags:j.tags?.map(ze.from)??[]};return j.children&&(Ce.children=j.children.map(Te)),Ce}me.from=Te;function le(j){const Ce=new b.DocumentSymbol(j.name,j.detail,Fe.to(j.kind),L.to(j.range),L.to(j.selectionRange));return(0,S.isNonEmptyArray)(j.tags)&&(Ce.tags=j.tags.map(ze.to)),j.children&&(Ce.children=j.children.map(le)),Ce}me.to=le})(nt||(e.DocumentSymbol=nt={}));var dt;(function(me){function Te(j){const Ce=new b.CallHierarchyItem(Fe.to(j.kind),j.name,j.detail||"",a.URI.revive(j.uri),L.to(j.range),L.to(j.selectionRange));return Ce._sessionId=j._sessionId,Ce._itemId=j._itemId,Ce}me.to=Te;function le(j,Ce,Be){if(Ce=Ce??j._sessionId,Be=Be??j._itemId,Ce===void 0||Be===void 0)throw new Error("invalid item");return{_sessionId:Ce,_itemId:Be,name:j.name,detail:j.detail,kind:Fe.from(j.kind),uri:j.uri,range:L.from(j.range),selectionRange:L.from(j.selectionRange),tags:j.tags?.map(ze.from)}}me.from=le})(dt||(e.CallHierarchyItem=dt={}));var vt;(function(me){function Te(le){return new b.CallHierarchyIncomingCall(dt.to(le.from),le.fromRanges.map(j=>L.to(j)))}me.to=Te})(vt||(e.CallHierarchyIncomingCall=vt={}));var ut;(function(me){function Te(le){return new b.CallHierarchyOutgoingCall(dt.to(le.to),le.fromRanges.map(j=>L.to(j)))}me.to=Te})(ut||(e.CallHierarchyOutgoingCall=ut={}));var et;(function(me){function Te(j){return{range:j.range&&L.from(j.range),uri:j.uri}}me.from=Te;function le(j){return new b.Location(a.URI.revive(j.uri),L.to(j.range))}me.to=le})(et||(e.location=et={}));var Oe;(function(me){function Te(j){const Ce=j,Be=j;return{originSelectionRange:Ce.originSelectionRange?L.from(Ce.originSelectionRange):void 0,uri:Ce.targetUri?Ce.targetUri:Be.uri,range:L.from(Ce.targetRange?Ce.targetRange:Be.range),targetSelectionRange:Ce.targetSelectionRange?L.from(Ce.targetSelectionRange):void 0}}me.from=Te;function le(j){return{targetUri:a.URI.revive(j.uri),targetRange:L.to(j.range),targetSelectionRange:j.targetSelectionRange?L.to(j.targetSelectionRange):void 0,originSelectionRange:j.originSelectionRange?L.to(j.originSelectionRange):void 0}}me.to=le})(Oe||(e.DefinitionLink=Oe={}));var Me;(function(me){function Te(j){return{range:L.from(j.range),contents:ue.fromMany(j.contents),canIncreaseVerbosity:j.canIncreaseVerbosity,canDecreaseVerbosity:j.canDecreaseVerbosity}}me.from=Te;function le(j){const Ce=j.contents.map(ue.to),Be=L.to(j.range),Ye=j.canIncreaseVerbosity,xe=j.canDecreaseVerbosity;return new b.VerboseHover(Ce,Be,Ye,xe)}me.to=le})(Me||(e.Hover=Me={}));var Ne;(function(me){function Te(j){return{range:L.from(j.range),expression:j.expression}}me.from=Te;function le(j){return new b.EvaluatableExpression(L.to(j.range),j.expression)}me.to=le})(Ne||(e.EvaluatableExpression=Ne={}));var B;(function(me){function Te(j){if(j instanceof b.InlineValueText)return{type:"text",range:L.from(j.range),text:j.text};if(j instanceof b.InlineValueVariableLookup)return{type:"variable",range:L.from(j.range),variableName:j.variableName,caseSensitiveLookup:j.caseSensitiveLookup};if(j instanceof b.InlineValueEvaluatableExpression)return{type:"expression",range:L.from(j.range),expression:j.expression};throw new Error("Unknown 'InlineValue' type")}me.from=Te;function le(j){switch(j.type){case"text":return{range:L.to(j.range),text:j.text};case"variable":return{range:L.to(j.range),variableName:j.variableName,caseSensitiveLookup:j.caseSensitiveLookup};case"expression":return{range:L.to(j.range),expression:j.expression}}}me.to=le})(B||(e.InlineValue=B={}));var z;(function(me){function Te(j){return{frameId:j.frameId,stoppedLocation:L.from(j.stoppedLocation)}}me.from=Te;function le(j){return new b.InlineValueContext(j.frameId,L.to(j.stoppedLocation))}me.to=le})(z||(e.InlineValueContext=z={}));var H;(function(me){function Te(j){return{range:L.from(j.range),kind:j.kind}}me.from=Te;function le(j){return new b.DocumentHighlight(L.to(j.range),j.kind)}me.to=le})(H||(e.DocumentHighlight=H={}));var q;(function(me){function Te(j){return{uri:j.uri,highlights:j.highlights.map(H.from)}}me.from=Te;function le(j){return new b.MultiDocumentHighlight(a.URI.revive(j.uri),j.highlights.map(H.to))}me.to=le})(q||(e.MultiDocumentHighlight=q={}));var se;(function(me){function Te(le){switch(le){case n.CompletionTriggerKind.TriggerCharacter:return b.CompletionTriggerKind.TriggerCharacter;case n.CompletionTriggerKind.TriggerForIncompleteCompletions:return b.CompletionTriggerKind.TriggerForIncompleteCompletions;case n.CompletionTriggerKind.Invoke:default:return b.CompletionTriggerKind.Invoke}}me.to=Te})(se||(e.CompletionTriggerKind=se={}));var ge;(function(me){function Te(le){return{triggerKind:se.to(le.triggerKind),triggerCharacter:le.triggerCharacter}}me.to=Te})(ge||(e.CompletionContext=ge={}));var ye;(function(me){function Te(j){switch(j){case b.CompletionItemTag.Deprecated:return n.CompletionItemTag.Deprecated}}me.from=Te;function le(j){switch(j){case n.CompletionItemTag.Deprecated:return b.CompletionItemTag.Deprecated}}me.to=le})(ye||(e.CompletionItemTag=ye={}));var Ue;(function(me){const Te=new Map([[b.CompletionItemKind.Method,n.CompletionItemKind.Method],[b.CompletionItemKind.Function,n.CompletionItemKind.Function],[b.CompletionItemKind.Constructor,n.CompletionItemKind.Constructor],[b.CompletionItemKind.Field,n.CompletionItemKind.Field],[b.CompletionItemKind.Variable,n.CompletionItemKind.Variable],[b.CompletionItemKind.Class,n.CompletionItemKind.Class],[b.CompletionItemKind.Interface,n.CompletionItemKind.Interface],[b.CompletionItemKind.Struct,n.CompletionItemKind.Struct],[b.CompletionItemKind.Module,n.CompletionItemKind.Module],[b.CompletionItemKind.Property,n.CompletionItemKind.Property],[b.CompletionItemKind.Unit,n.CompletionItemKind.Unit],[b.CompletionItemKind.Value,n.CompletionItemKind.Value],[b.CompletionItemKind.Constant,n.CompletionItemKind.Constant],[b.CompletionItemKind.Enum,n.CompletionItemKind.Enum],[b.CompletionItemKind.EnumMember,n.CompletionItemKind.EnumMember],[b.CompletionItemKind.Keyword,n.CompletionItemKind.Keyword],[b.CompletionItemKind.Snippet,n.CompletionItemKind.Snippet],[b.CompletionItemKind.Text,n.CompletionItemKind.Text],[b.CompletionItemKind.Color,n.CompletionItemKind.Color],[b.CompletionItemKind.File,n.CompletionItemKind.File],[b.CompletionItemKind.Reference,n.CompletionItemKind.Reference],[b.CompletionItemKind.Folder,n.CompletionItemKind.Folder],[b.CompletionItemKind.Event,n.CompletionItemKind.Event],[b.CompletionItemKind.Operator,n.CompletionItemKind.Operator],[b.CompletionItemKind.TypeParameter,n.CompletionItemKind.TypeParameter],[b.CompletionItemKind.Issue,n.CompletionItemKind.Issue],[b.CompletionItemKind.User,n.CompletionItemKind.User]]);function le(Be){return Te.get(Be)??n.CompletionItemKind.Property}me.from=le;const j=new Map([[n.CompletionItemKind.Method,b.CompletionItemKind.Method],[n.CompletionItemKind.Function,b.CompletionItemKind.Function],[n.CompletionItemKind.Constructor,b.CompletionItemKind.Constructor],[n.CompletionItemKind.Field,b.CompletionItemKind.Field],[n.CompletionItemKind.Variable,b.CompletionItemKind.Variable],[n.CompletionItemKind.Class,b.CompletionItemKind.Class],[n.CompletionItemKind.Interface,b.CompletionItemKind.Interface],[n.CompletionItemKind.Struct,b.CompletionItemKind.Struct],[n.CompletionItemKind.Module,b.CompletionItemKind.Module],[n.CompletionItemKind.Property,b.CompletionItemKind.Property],[n.CompletionItemKind.Unit,b.CompletionItemKind.Unit],[n.CompletionItemKind.Value,b.CompletionItemKind.Value],[n.CompletionItemKind.Constant,b.CompletionItemKind.Constant],[n.CompletionItemKind.Enum,b.CompletionItemKind.Enum],[n.CompletionItemKind.EnumMember,b.CompletionItemKind.EnumMember],[n.CompletionItemKind.Keyword,b.CompletionItemKind.Keyword],[n.CompletionItemKind.Snippet,b.CompletionItemKind.Snippet],[n.CompletionItemKind.Text,b.CompletionItemKind.Text],[n.CompletionItemKind.Color,b.CompletionItemKind.Color],[n.CompletionItemKind.File,b.CompletionItemKind.File],[n.CompletionItemKind.Reference,b.CompletionItemKind.Reference],[n.CompletionItemKind.Folder,b.CompletionItemKind.Folder],[n.CompletionItemKind.Event,b.CompletionItemKind.Event],[n.CompletionItemKind.Operator,b.CompletionItemKind.Operator],[n.CompletionItemKind.TypeParameter,b.CompletionItemKind.TypeParameter],[n.CompletionItemKind.User,b.CompletionItemKind.User],[n.CompletionItemKind.Issue,b.CompletionItemKind.Issue]]);function Ce(Be){return j.get(Be)??b.CompletionItemKind.Property}me.to=Ce})(Ue||(e.CompletionItemKind=Ue={}));var Ge;(function(me){function Te(le,j){const Ce=new b.CompletionItem(le.label);return Ce.insertText=le.insertText,Ce.kind=Ue.to(le.kind),Ce.tags=le.tags?.map(ye.to),Ce.detail=le.detail,Ce.documentation=k.isMarkdownString(le.documentation)?ue.to(le.documentation):le.documentation,Ce.sortText=le.sortText,Ce.filterText=le.filterText,Ce.preselect=le.preselect,Ce.commitCharacters=le.commitCharacters,l.Range.isIRange(le.range)?Ce.range=L.to(le.range):typeof le.range=="object"&&(Ce.range={inserting:L.to(le.range.insert),replacing:L.to(le.range.replace)}),Ce.keepWhitespace=typeof le.insertTextRules>"u"?!1:!!(le.insertTextRules&n.CompletionItemInsertTextRule.KeepWhitespace),typeof le.insertTextRules<"u"&&le.insertTextRules&n.CompletionItemInsertTextRule.InsertAsSnippet?Ce.insertText=new b.SnippetString(le.insertText):(Ce.insertText=le.insertText,Ce.textEdit=Ce.range instanceof b.Range?new b.TextEdit(Ce.range,Ce.insertText):void 0),le.additionalTextEdits&&le.additionalTextEdits.length>0&&(Ce.additionalTextEdits=le.additionalTextEdits.map(Be=>be.to(Be))),Ce.command=j&&le.command?j.fromInternal(le.command):void 0,Ce}me.to=Te})(Ge||(e.CompletionItem=Ge={}));var Ze;(function(me){function Te(j){if(typeof j.label!="string"&&!Array.isArray(j.label))throw new TypeError("Invalid label");return{label:j.label,documentation:ue.fromStrict(j.documentation)}}me.from=Te;function le(j){return{label:j.label,documentation:k.isMarkdownString(j.documentation)?ue.to(j.documentation):j.documentation}}me.to=le})(Ze||(e.ParameterInformation=Ze={}));var tt;(function(me){function Te(j){return{label:j.label,documentation:ue.fromStrict(j.documentation),parameters:Array.isArray(j.parameters)?j.parameters.map(Ze.from):[],activeParameter:j.activeParameter}}me.from=Te;function le(j){return{label:j.label,documentation:k.isMarkdownString(j.documentation)?ue.to(j.documentation):j.documentation,parameters:Array.isArray(j.parameters)?j.parameters.map(Ze.to):[],activeParameter:j.activeParameter}}me.to=le})(tt||(e.SignatureInformation=tt={}));var lt;(function(me){function Te(j){return{activeSignature:j.activeSignature,activeParameter:j.activeParameter,signatures:Array.isArray(j.signatures)?j.signatures.map(tt.from):[]}}me.from=Te;function le(j){return{activeSignature:j.activeSignature,activeParameter:j.activeParameter,signatures:Array.isArray(j.signatures)?j.signatures.map(tt.to):[]}}me.to=le})(lt||(e.SignatureHelp=lt={}));var it;(function(me){function Te(le,j){const Ce=new b.InlayHint(J.to(j.position),typeof j.label=="string"?j.label:j.label.map(at.to.bind(void 0,le)),j.kind&&wt.to(j.kind));return Ce.textEdits=j.textEdits&&j.textEdits.map(be.to),Ce.tooltip=k.isMarkdownString(j.tooltip)?ue.to(j.tooltip):j.tooltip,Ce.paddingLeft=j.paddingLeft,Ce.paddingRight=j.paddingRight,Ce}me.to=Te})(it||(e.InlayHint=it={}));var at;(function(me){function Te(le,j){const Ce=new b.InlayHintLabelPart(j.label);return Ce.tooltip=k.isMarkdownString(j.tooltip)?ue.to(j.tooltip):j.tooltip,n.Command.is(j.command)&&(Ce.command=le.fromInternal(j.command)),j.location&&(Ce.location=et.to(j.location)),Ce}me.to=Te})(at||(e.InlayHintLabelPart=at={}));var wt;(function(me){function Te(j){return j}me.from=Te;function le(j){return j}me.to=le})(wt||(e.InlayHintKind=wt={}));var Qe;(function(me){function Te(j){return{range:L.from(j.range),url:j.target,tooltip:j.tooltip}}me.from=Te;function le(j){let Ce;if(j.url)try{Ce=typeof j.url=="string"?a.URI.parse(j.url,!0):a.URI.revive(j.url)}catch{}const Be=new b.DocumentLink(L.to(j.range),Ce);return Be.tooltip=j.tooltip,Be}me.to=le})(Qe||(e.DocumentLink=Qe={}));var de;(function(me){function Te(j){const Ce=new b.ColorPresentation(j.label);return j.textEdit&&(Ce.textEdit=be.to(j.textEdit)),j.additionalTextEdits&&(Ce.additionalTextEdits=j.additionalTextEdits.map(Be=>be.to(Be))),Ce}me.to=Te;function le(j){return{label:j.label,textEdit:j.textEdit?be.from(j.textEdit):void 0,additionalTextEdits:j.additionalTextEdits?j.additionalTextEdits.map(Ce=>be.from(Ce)):void 0}}me.from=le})(de||(e.ColorPresentation=de={}));var pe;(function(me){function Te(j){return new b.Color(j[0],j[1],j[2],j[3])}me.to=Te;function le(j){return[j.red,j.green,j.blue,j.alpha]}me.from=le})(pe||(e.Color=pe={}));var we;(function(me){function Te(j){return{range:L.from(j.range)}}me.from=Te;function le(j){return new b.SelectionRange(L.to(j.range))}me.to=le})(we||(e.SelectionRange=we={}));var Pe;(function(me){function Te(le){switch(le){case f.SaveReason.AUTO:return b.TextDocumentSaveReason.AfterDelay;case f.SaveReason.EXPLICIT:return b.TextDocumentSaveReason.Manual;case f.SaveReason.FOCUS_CHANGE:case f.SaveReason.WINDOW_CHANGE:return b.TextDocumentSaveReason.FocusOut}}me.to=Te})(Pe||(e.TextDocumentSaveReason=Pe={}));var fe;(function(me){function Te(j){switch(j){case b.TextEditorLineNumbersStyle.Off:return d.RenderLineNumbersType.Off;case b.TextEditorLineNumbersStyle.Relative:return d.RenderLineNumbersType.Relative;case b.TextEditorLineNumbersStyle.Interval:return d.RenderLineNumbersType.Interval;case b.TextEditorLineNumbersStyle.On:default:return d.RenderLineNumbersType.On}}me.from=Te;function le(j){switch(j){case d.RenderLineNumbersType.Off:return b.TextEditorLineNumbersStyle.Off;case d.RenderLineNumbersType.Relative:return b.TextEditorLineNumbersStyle.Relative;case d.RenderLineNumbersType.Interval:return b.TextEditorLineNumbersStyle.Interval;case d.RenderLineNumbersType.On:default:return b.TextEditorLineNumbersStyle.On}}me.to=le})(fe||(e.TextEditorLineNumbersStyle=fe={}));var Se;(function(me){function Te(j){if(j===b.EndOfLine.CRLF)return t.EndOfLineSequence.CRLF;if(j===b.EndOfLine.LF)return t.EndOfLineSequence.LF}me.from=Te;function le(j){if(j===t.EndOfLineSequence.CRLF)return b.EndOfLine.CRLF;if(j===t.EndOfLineSequence.LF)return b.EndOfLine.LF}me.to=le})(Se||(e.EndOfLine=Se={}));var Q;(function(me){function Te(le){if(typeof le=="object")return le.viewId;switch(le){case b.ProgressLocation.SourceControl:return c.ProgressLocation.Scm;case b.ProgressLocation.Window:return c.ProgressLocation.Window;case b.ProgressLocation.Notification:return c.ProgressLocation.Notification}throw new Error("Unknown 'ProgressLocation'")}me.from=Te})(Q||(e.ProgressLocation=Q={}));var W;(function(me){function Te(j){const Ce={start:j.start+1,end:j.end+1};return j.kind&&(Ce.kind=he.from(j.kind)),Ce}me.from=Te;function le(j){const Ce={start:j.start-1,end:j.end-1};return j.kind&&(Ce.kind=he.to(j.kind)),Ce}me.to=le})(W||(e.FoldingRange=W={}));var he;(function(me){function Te(j){if(j)switch(j){case b.FoldingRangeKind.Comment:return n.FoldingRangeKind.Comment;case b.FoldingRangeKind.Imports:return n.FoldingRangeKind.Imports;case b.FoldingRangeKind.Region:return n.FoldingRangeKind.Region}}me.from=Te;function le(j){if(j)switch(j.value){case n.FoldingRangeKind.Comment.value:return b.FoldingRangeKind.Comment;case n.FoldingRangeKind.Imports.value:return b.FoldingRangeKind.Imports;case n.FoldingRangeKind.Region.value:return b.FoldingRangeKind.Region}}me.to=le})(he||(e.FoldingRangeKind=he={}));var $e;(function(me){function Te(le){if(le)return{pinned:typeof le.preview=="boolean"?!le.preview:void 0,inactive:le.background,preserveFocus:le.preserveFocus,selection:typeof le.selection=="object"?L.from(le.selection):void 0,override:typeof le.override=="boolean"?f.DEFAULT_EDITOR_ASSOCIATION.id:void 0}}me.from=Te})($e||(e.TextEditorOpenOptions=$e={}));var He;(function(me){function Te(Be){return Be instanceof b.RelativePattern?Be.toJSON():typeof Be=="string"?Be:le(Be)||j(Be)?new b.RelativePattern(Be.baseUri??Be.base,Be.pattern).toJSON():Be}me.from=Te;function le(Be){const Ye=Be;return Ye?a.URI.isUri(Ye.baseUri)&&typeof Ye.pattern=="string":!1}function j(Be){const Ye=Be;return Ye?typeof Ye.base=="string"&&typeof Ye.pattern=="string":!1}function Ce(Be){return typeof Be=="string"?Be:new b.RelativePattern(a.URI.revive(Be.baseUri),Be.pattern)}me.to=Ce})(He||(e.GlobPattern=He={}));var st;(function(me){function Te(le){if(le){if(Array.isArray(le))return le.map(Te);if(typeof le=="string")return le;{const j=le;return{language:j.language,scheme:j.scheme,pattern:He.from(j.pattern),exclusive:j.exclusive,notebookType:j.notebookType}}}else return}me.from=Te})(st||(e.LanguageSelector=st={}));var ht;(function(me){function Te(j){return!!j&&typeof j=="object"&&"documents"in j&&Array.isArray(j.documents)&&j.documents.every(Ce=>Array.isArray(Ce)&&Ce.every(Be=>Be&&typeof Be=="object"&&"uri"in Be&&a.URI.isUri(Be.uri)&&"version"in Be&&typeof Be.version=="number"&&"ranges"in Be&&Array.isArray(Be.ranges)&&Be.ranges.every(Ye=>Ye instanceof b.Range)))}me.is=Te;function le(j){return{documents:j.documents.map(Ce=>Ce.map(Be=>({uri:a.URI.from(Be.uri),version:Be.version,ranges:Be.ranges.map(Ye=>L.from(Ye))})))}}me.from=le})(ht||(e.MappedEditsContext=ht={}));var mt;(function(me){function Te(j){return{start:j.start,end:j.end}}me.from=Te;function le(j){return new b.NotebookRange(j.start,j.end)}me.to=le})(mt||(e.NotebookRange=mt={}));var Rt;(function(me){function Te(j){return{timing:typeof j.runStartTime=="number"&&typeof j.runEndTime=="number"?{startTime:j.runStartTime,endTime:j.runEndTime}:void 0,executionOrder:j.executionOrder,success:j.lastRunSuccess}}me.to=Te;function le(j){return{lastRunSuccess:j.success,runStartTime:j.timing?.startTime,runEndTime:j.timing?.endTime,executionOrder:j.executionOrder}}me.from=le})(Rt||(e.NotebookCellExecutionSummary=Rt={}));var At;(function(me){function Te(le){if(le===w.NotebookCellExecutionState.Unconfirmed)return b.NotebookCellExecutionState.Pending;if(le===w.NotebookCellExecutionState.Pending)return;if(le===w.NotebookCellExecutionState.Executing)return b.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${le}`)}me.to=Te})(At||(e.NotebookCellExecutionState=At={}));var Ht;(function(me){function Te(j){switch(j){case b.NotebookCellKind.Markup:return w.CellKind.Markup;case b.NotebookCellKind.Code:default:return w.CellKind.Code}}me.from=Te;function le(j){switch(j){case w.CellKind.Markup:return b.NotebookCellKind.Markup;case w.CellKind.Code:default:return b.NotebookCellKind.Code}}me.to=le})(Ht||(e.NotebookCellKind=Ht={}));var Zt;(function(me){function Te(j){const Ce={metadata:j.metadata??Object.create(null),cells:[]};for(const Be of j.cells)b.NotebookCellData.validate(Be),Ce.cells.push(Xe.from(Be));return Ce}me.from=Te;function le(j){const Ce=new b.NotebookData(j.cells.map(Xe.to));return(0,r.isEmptyObject)(j.metadata)||(Ce.metadata=j.metadata),Ce}me.to=le})(Zt||(e.NotebookData=Zt={}));var Xe;(function(me){function Te(j){return{cellKind:Ht.from(j.kind),language:j.languageId,mime:j.mime,source:j.value,metadata:j.metadata,internalMetadata:Rt.from(j.executionSummary??{}),outputs:j.outputs?j.outputs.map(xt.from):[]}}me.from=Te;function le(j){return new b.NotebookCellData(Ht.to(j.cellKind),j.source,j.language,j.mime,j.outputs?j.outputs.map(xt.to):void 0,j.metadata,j.internalMetadata?Rt.to(j.internalMetadata):void 0)}me.to=le})(Xe||(e.NotebookCellData=Xe={}));var Lt;(function(me){function Te(j){return{mime:j.mime,valueBytes:T.VSBuffer.wrap(j.data)}}me.from=Te;function le(j){return new b.NotebookCellOutputItem(j.valueBytes.buffer,j.mime)}me.to=le})(Lt||(e.NotebookCellOutputItem=Lt={}));var xt;(function(me){function Te(j){return{outputId:j.id,items:j.items.map(Lt.from),metadata:j.metadata}}me.from=Te;function le(j){const Ce=j.items.map(Lt.to);return new b.NotebookCellOutput(Ce,j.outputId,j.metadata)}me.to=le})(xt||(e.NotebookCellOutput=xt={}));var Et;(function(me){function Te(Ce){return j(Ce)?{include:He.from(Ce.include)??void 0,exclude:He.from(Ce.exclude)??void 0}:He.from(Ce)??void 0}me.from=Te;function le(Ce){return j(Ce)?{include:He.to(Ce.include),exclude:He.to(Ce.exclude)}:He.to(Ce)}me.to=le;function j(Ce){const Be=Ce;return Be?!(0,r.isUndefinedOrNull)(Be.include)&&!(0,r.isUndefinedOrNull)(Be.exclude):!1}})(Et||(e.NotebookExclusiveDocumentPattern=Et={}));var Tt;(function(me){function Te(le,j,Ce){const Be=typeof le.command=="string"?{title:"",command:le.command}:le.command;return{alignment:le.alignment===b.NotebookCellStatusBarAlignment.Left?w.CellStatusbarAlignment.Left:w.CellStatusbarAlignment.Right,command:j.toInternal(Be,Ce),text:le.text,tooltip:le.tooltip,accessibilityInformation:le.accessibilityInformation,priority:le.priority}}me.from=Te})(Tt||(e.NotebookStatusBarItem=Tt={}));var ei;(function(me){function Te(le,j,Ce){const Be=typeof le.command=="string"?{title:"",command:le.command}:le.command;return{command:j.toInternal(Be,Ce),label:le.label,description:le.description,detail:le.detail,documentation:le.documentation}}me.from=Te})(ei||(e.NotebookKernelSourceAction=ei={}));var ti;(function(me){function Te(le){return{transientOutputs:le?.transientOutputs??!1,transientCellMetadata:le?.transientCellMetadata??{},transientDocumentMetadata:le?.transientDocumentMetadata??{},cellContentMetadata:le?.cellContentMetadata??{}}}me.from=Te})(ti||(e.NotebookDocumentContentOptions=ti={}));var qt;(function(me){function Te(j){return{uri:j.uri,provides:j.provides}}me.from=Te;function le(j){return new b.NotebookRendererScript(a.URI.revive(j.uri),j.provides)}me.to=le})(qt||(e.NotebookRendererScript=qt={}));var bt;(function(me){function Te(j){return{message:ue.fromStrict(j.message)||"",type:R.TestMessageType.Error,expected:j.expectedOutput,actual:j.actualOutput,contextValue:j.contextValue,location:j.location&&{range:L.from(j.location.range),uri:j.location.uri},stackTrace:j.stackTrace?.map(Ce=>({label:Ce.label,position:Ce.position&&J.from(Ce.position),uri:Ce.uri&&a.URI.revive(Ce.uri).toJSON()}))}}me.from=Te;function le(j){const Ce=new b.TestMessage(typeof j.message=="string"?j.message:ue.to(j.message));return Ce.actualOutput=j.actual,Ce.expectedOutput=j.expected,Ce.contextValue=j.contextValue,Ce.location=j.location?et.to(j.location):void 0,Ce}me.to=le})(bt||(e.TestMessage=bt={}));var Ot;(function(me){me.namespace=R.namespaceTestTag,me.denamespace=R.denamespaceTestTag})(Ot||(e.TestTag=Ot={}));var li;(function(me){function Te(j){const Ce=(0,g.getPrivateApiFor)(j).controllerId;return{extId:P.TestId.fromExtHostTestItem(j,Ce).toString(),label:j.label,uri:a.URI.revive(j.uri),busy:j.busy,tags:j.tags.map(Be=>Ot.namespace(Ce,Be.id)),range:l.Range.lift(L.from(j.range)),description:j.description||null,sortText:j.sortText||null,error:j.error&&ue.fromStrict(j.error)||null}}me.from=Te;function le(j){return{parent:void 0,error:void 0,id:P.TestId.fromString(j.extId).localId,label:j.label,uri:a.URI.revive(j.uri),tags:(j.tags||[]).map(Ce=>{const{tagId:Be}=Ot.denamespace(Ce);return new b.TestTag(Be)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:L.to(j.range||void 0),canResolveChildren:!1,busy:j.busy,description:j.description||void 0,sortText:j.sortText||void 0}}me.toPlain=le})(li||(e.TestItem=li={})),function(me){function Te(j){return{id:j.id}}me.from=Te;function le(j){return new b.TestTag(j.id)}me.to=le}(Ot||(e.TestTag=Ot={}));var Qt;(function(me){const Te=(j,Ce)=>{const Be=j.value;if(!Be)return;const Ye={...li.toPlain(Be.item),parent:Ce,taskStates:Be.tasks.map(xe=>({state:xe.state,duration:xe.duration,messages:xe.messages.filter(ot=>ot.type===R.TestMessageType.Error).map(bt.to)})),children:[]};if(j.children)for(const xe of j.children.values()){const ot=Te(xe,Ye);ot&&Ye.children.push(ot)}return Ye};function le(j){const Ce=new u.WellDefinedPrefixTree;for(const xe of j.items)Ce.insert(P.TestId.fromString(xe.item.extId).path,xe);const Be=[Ce.nodes],Ye=[];for(;Be.length;)for(const xe of Be.pop())xe.value?Ye.push(xe):xe.children&&Be.push(xe.children.values());return{completedAt:j.completedAt,results:Ye.map(xe=>Te(xe)).filter(r.isDefined)}}me.to=le})(Qt||(e.TestResults=Qt={}));var Ke;(function(me){function Te(xe){return{covered:xe.covered,total:xe.total}}function le(xe){return"line"in xe?J.from(xe):L.from(xe)}function j(xe){if(xe)return"endLineNumber"in xe?L.to(xe):J.to(xe)}function Ce(xe){if(xe.type===R.DetailType.Statement){const ot=[];if(xe.branches)for(const gt of xe.branches)ot.push({executed:gt.count,location:j(gt.location),label:gt.label});return new b.StatementCoverage(xe.count,j(xe.location),xe.branches?.map(gt=>new b.BranchCoverage(gt.count,j(gt.location),gt.label)))}else return new b.DeclarationCoverage(xe.name,xe.count,j(xe.location))}me.to=Ce;function Be(xe){if(typeof xe.executed=="number"&&xe.executed<0)throw new Error(`Invalid coverage count ${xe.executed}`);return"branches"in xe?{count:xe.executed,location:le(xe.location),type:R.DetailType.Statement,branches:xe.branches.length?xe.branches.map(ot=>({count:ot.executed,location:ot.location&&le(ot.location),label:ot.label})):void 0}:{type:R.DetailType.Declaration,name:xe.name,count:xe.executed,location:le(xe.location)}}me.fromDetails=Be;function Ye(xe,ot,gt){return b.validateTestCoverageCount(gt.statementCoverage),b.validateTestCoverageCount(gt.branchCoverage),b.validateTestCoverageCount(gt.declarationCoverage),{id:ot,uri:gt.uri,statement:Te(gt.statementCoverage),branch:gt.branchCoverage&&Te(gt.branchCoverage),declaration:gt.declarationCoverage&&Te(gt.declarationCoverage),testIds:gt instanceof b.FileCoverage&&gt.fromTests.length?gt.fromTests.map(jt=>P.TestId.fromExtHostTestItem(jt,xe).toString()):void 0}}me.fromFile=Ye})(Ke||(e.TestCoverage=Ke={}));var ii;(function(me){function Te(le){switch(le){case n.CodeActionTriggerType.Invoke:return b.CodeActionTriggerKind.Invoke;case n.CodeActionTriggerType.Auto:return b.CodeActionTriggerKind.Automatic}}me.to=Te})(ii||(e.CodeActionTriggerKind=ii={}));var ci;(function(me){function Te(j){const Ce=new b.TypeHierarchyItem(Fe.to(j.kind),j.name,j.detail||"",a.URI.revive(j.uri),L.to(j.range),L.to(j.selectionRange));return Ce._sessionId=j._sessionId,Ce._itemId=j._itemId,Ce}me.to=Te;function le(j,Ce,Be){if(Ce=Ce??j._sessionId,Be=Be??j._itemId,Ce===void 0||Be===void 0)throw new Error("invalid item");return{_sessionId:Ce,_itemId:Be,kind:Fe.from(j.kind),name:j.name,detail:j.detail??"",uri:j.uri,range:L.from(j.range),selectionRange:L.from(j.selectionRange),tags:j.tags?.map(ze.from)}}me.from=le})(ci||(e.TypeHierarchyItem=ci={}));var di;(function(me){function Te(le){if(le)return{value:le.value,tooltip:le.tooltip}}me.from=Te})(di||(e.ViewBadge=di={}));var Ct;(function(me){function Te(Be,Ye,xe){const ot=Ye.fileData;return ot?new b.InternalFileDataTransferItem(new b.DataTransferFile(ot.name,a.URI.revive(ot.uri),ot.id,(0,O.createSingleCallFunction)(()=>xe(ot.id)))):Be===I.Mimes.uriList&&Ye.uriListData?new b.InternalDataTransferItem(Ce(Ye.uriListData)):new b.InternalDataTransferItem(Ye.asString)}me.to=Te;async function le(Be,Ye){const xe=await Ye.asString();if(Be===I.Mimes.uriList)return{asString:xe,fileData:void 0,uriListData:j(xe)};const ot=Ye.asFile();return{asString:xe,fileData:ot?{name:ot.name,uri:ot.uri,id:ot._itemId??ot.id}:void 0}}me.from=le;function j(Be){return D.UriList.split(Be).map(Ye=>{if(Ye.startsWith("#"))return Ye;try{return a.URI.parse(Ye)}catch{}return Ye})}function Ce(Be){return D.UriList.create(Be.map(Ye=>typeof Ye=="string"?Ye:a.URI.revive(Ye)))}})(Ct||(e.DataTransferItem=Ct={}));var $t;(function(me){function Te(j,Ce){const Be=j.items.map(([Ye,xe])=>[Ye,Ct.to(Ye,xe,Ce)]);return new b.DataTransfer(Be)}me.toDataTransfer=Te;async function le(j){const Ce={items:[]},Be=[];for(const[Ye,xe]of j)Be.push((async()=>{Ce.items.push([Ye,await Ct.from(Ye,xe)])})());return await Promise.all(Be),Ce}me.from=le})($t||(e.DataTransfer=$t={}));var Nt;(function(me){function Te(j,Ce){return{kind:"reply",agentId:j.participant??Ce?.agentId??"",subCommand:j.command??Ce?.command,message:j.prompt,title:j.label}}me.from=Te;function le(j){return{prompt:j.message,label:j.title,participant:j.agentId,command:j.subCommand}}me.to=le})(Nt||(e.ChatFollowup=Nt={}));var zt;(function(me){function Te(j){switch(j){case _.ChatMessageRole.System:return b.LanguageModelChatMessageRole.System;case _.ChatMessageRole.User:return b.LanguageModelChatMessageRole.User;case _.ChatMessageRole.Assistant:return b.LanguageModelChatMessageRole.Assistant}}me.to=Te;function le(j){switch(j){case b.LanguageModelChatMessageRole.System:return _.ChatMessageRole.System;case b.LanguageModelChatMessageRole.User:return _.ChatMessageRole.User;case b.LanguageModelChatMessageRole.Assistant:return _.ChatMessageRole.Assistant}return _.ChatMessageRole.User}me.from=le})(zt||(e.LanguageModelChatMessageRole=zt={}));var ai;(function(me){function Te(j){const Ce=j.content.map(ot=>ot.type==="text"?ot.value:ot.type==="tool_result"?new b.LanguageModelToolResultPart(ot.toolCallId,ot.value,ot.isError):new b.LanguageModelToolCallPart(ot.name,ot.toolCallId,ot.parameters)),Be=Ce.find(ot=>typeof ot=="string")??"",Ye=zt.to(j.role),xe=new b.LanguageModelChatMessage(Ye,Be,j.name);return xe.content2=Ce,xe}me.to=Te;function le(j){const Ce=zt.from(j.role),Be=j.name,Ye=j.content2.map(xe=>{if(xe instanceof b.LanguageModelToolResultPart)return{type:"tool_result",toolCallId:xe.toolCallId,value:xe.content,isError:xe.isError};if(xe instanceof b.LanguageModelToolCallPart)return{type:"tool_use",toolCallId:xe.toolCallId,name:xe.name,parameters:xe.parameters};if(typeof xe!="string")throw new Error("Unexpected chat message content type");return{type:"text",value:xe}});return{role:Ce,name:Be,content:Ye}}me.from=le})(ai||(e.LanguageModelChatMessage=ai={}));var ni;(function(me){function Te(j){return{kind:"markdownContent",content:ue.from(j.value)}}me.from=Te;function le(j){return new b.ChatResponseMarkdownPart(ue.to(j.content))}me.to=le})(ni||(e.ChatResponseMarkdownPart=ni={}));var ri;(function(me){function Te(j){return{kind:"markdownVuln",content:ue.from(j.value),vulnerabilities:j.vulnerabilities}}me.from=Te;function le(j){return new b.ChatResponseMarkdownWithVulnerabilitiesPart(ue.to(j.content),j.vulnerabilities)}me.to=le})(ri||(e.ChatResponseMarkdownWithVulnerabilitiesPart=ri={}));var Kt;(function(me){function Te(j){return{kind:"agentDetection",agentId:j.participant,command:j.command}}me.from=Te;function le(j){return new b.ChatResponseDetectedParticipantPart(j.agentId,j.command)}me.to=le})(Kt||(e.ChatResponseDetectedParticipantPart=Kt={}));var Gt;(function(me){function Te(le){return{kind:"confirmation",title:le.title,message:le.message,data:le.data,buttons:le.buttons}}me.from=Te})(Gt||(e.ChatResponseConfirmationPart=Gt={}));var ui;(function(me){function Te(j){const{value:Ce,baseUri:Be}=j;function Ye(xe,ot){return xe.map(gt=>{const jt=a.URI.joinPath(ot,gt.name);return{label:gt.name,uri:jt,children:gt.children&&Ye(gt.children,jt)}})}return{kind:"treeData",treeData:{label:(0,C.basename)(Be),uri:Be,children:Ye(Ce,Be)}}}me.from=Te;function le(j){const Ce=(0,s.revive)(j.treeData);function Be(ot){return ot.map(gt=>({name:gt.label,children:gt.children&&Be(gt.children)}))}const Ye=Ce.uri,xe=Ce.children?Be(Ce.children):[];return new b.ChatResponseFileTreePart(xe,Ye)}me.to=le})(ui||(e.ChatResponseFilesPart=ui={}));var Mt;(function(me){function Te(j){const Ce=Be=>a.URI.isUri(Be);return{kind:"inlineReference",name:j.title,inlineReference:Ce(j.value)?j.value:F.from(j.value)}}me.from=Te;function le(j){const Ce=(0,s.revive)(j);return new b.ChatResponseAnchorPart(a.URI.isUri(Ce.inlineReference)?Ce.inlineReference:F.to(Ce.inlineReference),j.name)}me.to=le})(Mt||(e.ChatResponseAnchorPart=Mt={}));var Pt;(function(me){function Te(j){return{kind:"progressMessage",content:ue.from(j.value)}}me.from=Te;function le(j){return new b.ChatResponseProgressPart(j.content.value)}me.to=le})(Pt||(e.ChatResponseProgressPart=Pt={}));var St;(function(me){function Te(j){return{kind:"warning",content:ue.from(j.value)}}me.from=Te;function le(j){return new b.ChatResponseWarningPart(j.content.value)}me.to=le})(St||(e.ChatResponseWarningPart=St={}));var Xt;(function(me){function Te(j){return{kind:"move",uri:j.uri,range:L.from(j.range)}}me.from=Te;function le(j){return new b.ChatResponseMovePart(a.URI.revive(j.uri),L.to(j.range))}me.to=le})(Xt||(e.ChatResponseMovePart=Xt={}));var yt;(function(me){function Te(le){return{kind:"progressTask",content:ue.from(le.value)}}me.from=Te})(yt||(e.ChatTask=yt={}));var si;(function(me){function Te(le){return{kind:"progressTaskResult",content:typeof le=="string"?ue.from(le):void 0}}me.from=Te})(si||(e.ChatTaskResult=si={}));var Yt;(function(me){function Te(j,Ce,Be){return{kind:"command",command:Ce.toInternal(j.value,Be)??{command:j.value.command,title:j.value.title}}}me.from=Te;function le(j,Ce){return new b.ChatResponseCommandButtonPart(Ce.fromInternal(j.command)??{command:j.command.id,title:j.command.title})}me.to=le})(Yt||(e.ChatResponseCommandButtonPart=Yt={}));var Mi;(function(me){function Te(j){return{kind:"textEdit",uri:j.uri,edits:j.edits.map(Ce=>be.from(Ce))}}me.from=Te;function le(j){return new b.ChatResponseTextEditPart(a.URI.revive(j.uri),j.edits.map(Ce=>be.to(Ce)))}me.to=le})(Mi||(e.ChatResponseTextEditPart=Mi={}));var hi;(function(me){function Te(j){const Ce=v.ThemeIcon.isThemeIcon(j.iconPath)?j.iconPath:a.URI.isUri(j.iconPath)?{light:a.URI.revive(j.iconPath)}:j.iconPath&&"light"in j.iconPath&&"dark"in j.iconPath&&a.URI.isUri(j.iconPath.light)&&a.URI.isUri(j.iconPath.dark)?{light:a.URI.revive(j.iconPath.light),dark:a.URI.revive(j.iconPath.dark)}:void 0;return typeof j.value=="object"&&"variableName"in j.value?{kind:"reference",reference:{variableName:j.value.variableName,value:a.URI.isUri(j.value.value)||!j.value.value?j.value.value:F.from(j.value.value)},iconPath:Ce,options:j.options}:{kind:"reference",reference:a.URI.isUri(j.value)||typeof j.value=="string"?j.value:F.from(j.value),iconPath:Ce,options:j.options}}me.from=Te;function le(j){const Ce=(0,s.revive)(j),Be=Ye=>a.URI.isUri(Ye)?Ye:F.to(Ye);return new b.ChatResponseReferencePart(typeof Ce.reference=="string"?Ce.reference:"variableName"in Ce.reference?{variableName:Ce.reference.variableName,value:Ce.reference.value&&Be(Ce.reference.value)}:Be(Ce.reference))}me.to=le})(hi||(e.ChatResponseReferencePart=hi={}));var wi;(function(me){function Te(le){return{kind:"codeCitation",value:le.value,license:le.license,snippet:le.snippet}}me.from=Te})(wi||(e.ChatResponseCodeCitationPart=wi={}));var Wt;(function(me){function Te(Ce,Be,Ye){return Ce instanceof b.ChatResponseMarkdownPart?ni.from(Ce):Ce instanceof b.ChatResponseAnchorPart?Mt.from(Ce):Ce instanceof b.ChatResponseReferencePart?hi.from(Ce):Ce instanceof b.ChatResponseProgressPart?Pt.from(Ce):Ce instanceof b.ChatResponseFileTreePart?ui.from(Ce):Ce instanceof b.ChatResponseCommandButtonPart?Yt.from(Ce,Be,Ye):Ce instanceof b.ChatResponseTextEditPart?Mi.from(Ce):Ce instanceof b.ChatResponseMarkdownWithVulnerabilitiesPart?ri.from(Ce):Ce instanceof b.ChatResponseDetectedParticipantPart?Kt.from(Ce):Ce instanceof b.ChatResponseWarningPart?St.from(Ce):Ce instanceof b.ChatResponseConfirmationPart?Gt.from(Ce):Ce instanceof b.ChatResponseCodeCitationPart?wi.from(Ce):Ce instanceof b.ChatResponseMovePart?Xt.from(Ce):{kind:"markdownContent",content:ue.from("")}}me.from=Te;function le(Ce,Be){switch(Ce.kind){case"reference":return hi.to(Ce);case"markdownContent":case"inlineReference":case"progressMessage":case"treeData":case"command":return j(Ce,Be)}}me.to=le;function j(Ce,Be){switch(Ce.kind){case"markdownContent":return ni.to(Ce);case"inlineReference":return Mt.to(Ce);case"progressMessage":return;case"treeData":return ui.to(Ce);case"command":return Yt.to(Ce,Be)}}me.toContent=j})(Wt||(e.ChatResponsePart=Wt={}));var fi;(function(me){function Te(le,j){const Ce=le.variables.variables.filter(Ye=>Ye.isTool),Be=le.variables.variables.filter(Ye=>!Ye.isTool);return{prompt:le.message,command:le.command,attempt:le.attempt??0,enableCommandDetection:le.enableCommandDetection??!0,isParticipantDetected:le.isParticipantDetected??!1,references:Be.map(kt.to),toolReferences:Ce.map(_i.to),location:Fi.to(le.location),acceptedConfirmationData:le.acceptedConfirmationData,rejectedConfirmationData:le.rejectedConfirmationData,location2:j}}me.to=Te})(fi||(e.ChatAgentRequest=fi={}));var Fi;(function(me){function Te(j){switch(j){case h.ChatAgentLocation.Notebook:return b.ChatLocation.Notebook;case h.ChatAgentLocation.Terminal:return b.ChatLocation.Terminal;case h.ChatAgentLocation.Panel:return b.ChatLocation.Panel;case h.ChatAgentLocation.Editor:return b.ChatLocation.Editor}}me.to=Te;function le(j){switch(j){case b.ChatLocation.Notebook:return h.ChatAgentLocation.Notebook;case b.ChatLocation.Terminal:return h.ChatAgentLocation.Terminal;case b.ChatLocation.Panel:return h.ChatAgentLocation.Panel;case b.ChatLocation.Editor:return h.ChatAgentLocation.Editor}}me.from=le})(Fi||(e.ChatLocation=Fi={}));var kt;(function(me){function Te(le){const j=le.value;if(!j)throw new Error("Invalid value reference");return{id:le.id,name:le.name,range:le.range&&[le.range.start,le.range.endExclusive],value:(0,a.isUriComponents)(j)?a.URI.revive(j):j&&typeof j=="object"&&"uri"in j&&"range"in j&&(0,a.isUriComponents)(j.uri)?F.to((0,s.revive)(j)):j,modelDescription:le.modelDescription}}me.to=Te})(kt||(e.ChatPromptReference=kt={}));var _i;(function(me){function Te(le){if(le.value)throw new Error("Invalid tool reference");return{id:le.id,range:le.range&&[le.range.start,le.range.endExclusive]}}me.to=Te})(_i||(e.ChatLanguageModelToolReference=_i={}));var Li;(function(me){function Te(le,j,Ce){return{id:le.id,label:le.label,fullName:le.fullName,icon:le.icon?.id,value:le.values[0].value,insertText:le.insertText,detail:le.detail,documentation:le.documentation,command:j.toInternal(le.command,Ce)}}me.from=Te})(Li||(e.ChatAgentCompletionItem=Li={}));var gi;(function(me){function Te(le){return{errorDetails:le.errorDetails,metadata:le.metadata,nextQuestion:le.nextQuestion}}me.to=Te})(gi||(e.ChatAgentResult=gi={}));var Ui;(function(me){function Te(le,j,Ce){if(j.action.kind==="vote")return;const Be=gi.to(le);if(j.action.kind==="command"){const Ye=j.action.commandButton.command;return{action:{kind:"command",commandButton:{command:Ce.fromInternal(Ye)??{command:Ye.id,title:Ye.title}}},result:Be}}else return j.action.kind==="followUp"?{action:{kind:"followUp",followup:Nt.to(j.action.followup)},result:Be}:j.action.kind==="inlineChat"?{action:{kind:"editor",accepted:j.action.action==="accepted"},result:Be}:{action:j.action,result:Be}}me.to=Te})(Ui||(e.ChatAgentUserActionEvent=Ui={}));var $i;(function(me){function Te(j){return{...j,string:j.toString()}}me.from=Te;function le(j){const Ce={...j,toString:()=>j.string};return delete Ce.string,Ce}me.to=le})($i||(e.LanguageModelToolResult=$i={}));var Ut;(function(me){function Te(le,j,Ce){return"terminalCommand"in le?{terminalCommand:le.terminalCommand,shouldExecute:le.shouldExecute}:"uri"in le?{uri:le.uri}:j.toInternal(le,Ce)}me.from=Te})(Ut||(e.TerminalQuickFix=Ut={}));var Di;(function(me){function Te(le){return{kind:Ti.to(le.kind)}}me.to=Te})(Di||(e.PartialAcceptInfo=Di={}));var Ti;(function(me){function Te(le){switch(le){case n.PartialAcceptTriggerKind.Word:return b.PartialAcceptTriggerKind.Word;case n.PartialAcceptTriggerKind.Line:return b.PartialAcceptTriggerKind.Line;case n.PartialAcceptTriggerKind.Suggest:return b.PartialAcceptTriggerKind.Suggest;default:return b.PartialAcceptTriggerKind.Unknown}}me.to=Te})(Ti||(e.PartialAcceptTriggerKind=Ti={}));var Ei;(function(me){function Te(le,j){return{id:j,label:le.label,description:le.description,canEdit:le.canEdit,collapsibleState:le.collapsibleState||y.DebugTreeItemCollapsibleState.None,contextValue:le.contextValue}}me.from=Te})(Ei||(e.DebugTreeItem=Ei={}));var bi;(function(me){function Te(le){return{id:le.id,modelDescription:le.modelDescription,parametersSchema:le.parametersSchema,displayName:le.displayName}}me.to=Te})(bi||(e.LanguageModelToolDescription=bi={}))}),define(ke[232],Re([1,0,5,16,8,39]),function(Ee,e,S,T,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let k=class{constructor(m,s){this._proxy=m.getProxy(S.MainContext.MainThreadBulkEdits),this._versionInformationProvider={getTextDocumentVersion:I=>s.getDocument(I)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(m,s,I){const E=new O.SerializableObjectWithBuffers(D.WorkspaceEdit.from(m,this._versionInformationProvider));return this._proxy.$tryApplyWorkspaceEdit(E,void 0,I?.isRefactoring??!1)}};e.ExtHostBulkEdits=k,e.ExtHostBulkEdits=k=qe([We(0,T.IExtHostRpcService)],k)}),define(ke[233],Re([1,0,17,10,42,6,41,4,34,69,14,2,18,5,8,7,117,194,21]),function(Ee,e,S,T,D,O,k,A,m,s,I,E,u,C,v,r,a,d,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostChatAgents2=void 0,v=Ve(v),r=Ve(r);class i{constructor(c,g,f,h,_){this._extension=c,this._request=g,this._proxy=f,this._commandsConverter=h,this._sessionDisposables=_,this._stopWatch=s.StopWatch.create(!1),this._isClosed=!1}close(){this._isClosed=!0}get timings(){return{firstProgress:this._firstProgress,totalElapsed:this._stopWatch.elapsed()}}get apiObject(){if(!this._apiObject){let g=function(h){if(c._isClosed){const _=new Error("Response stream has been closed");throw Error.captureStackTrace(_,h),_}};const c=this;this._stopWatch.reset();const f=(h,_)=>{if(typeof this._firstProgress>"u"&&(h.kind==="markdownContent"||h.kind==="markdownVuln")&&(this._firstProgress=this._stopWatch.elapsed()),_){const y=this._proxy.$handleProgressChunk(this._request.requestId,h),w={report:P=>{y?.then(R=>{R&&(r.MarkdownString.isMarkdownString(P.value)?this._proxy.$handleProgressChunk(this._request.requestId,v.ChatResponseWarningPart.from(P),R):this._proxy.$handleProgressChunk(this._request.requestId,v.ChatResponseReferencePart.from(P),R))})}};Promise.all([y,_?.(w)]).then(([P,R])=>{P!==void 0&&this._proxy.$handleProgressChunk(this._request.requestId,v.ChatTaskResult.from(R),P)})}else this._proxy.$handleProgressChunk(this._request.requestId,h)};this._apiObject={markdown(h){g(this.markdown);const _=new r.ChatResponseMarkdownPart(h),y=v.ChatResponseMarkdownPart.from(_);return f(y),this},markdownWithVulnerabilities(h,_){g(this.markdown),_&&(0,l.checkProposedApiEnabled)(c._extension,"chatParticipantAdditions");const y=new r.ChatResponseMarkdownWithVulnerabilitiesPart(h,_),w=v.ChatResponseMarkdownWithVulnerabilitiesPart.from(y);return f(w),this},filetree(h,_){g(this.filetree);const y=new r.ChatResponseFileTreePart(h,_),w=v.ChatResponseFilesPart.from(y);return f(w),this},anchor(h,_){g(this.anchor);const y=new r.ChatResponseAnchorPart(h,_),w=v.ChatResponseAnchorPart.from(y);return f(w),this},button(h){g(this.anchor);const _=new r.ChatResponseCommandButtonPart(h),y=v.ChatResponseCommandButtonPart.from(_,c._commandsConverter,c._sessionDisposables);return f(y),this},progress(h,_){g(this.progress);const y=new r.ChatResponseProgressPart2(h,_),w=_?v.ChatTask.from(y):v.ChatResponseProgressPart.from(y);return f(w,_),this},warning(h){g(this.progress),(0,l.checkProposedApiEnabled)(c._extension,"chatParticipantAdditions");const _=new r.ChatResponseWarningPart(h),y=v.ChatResponseWarningPart.from(_);return f(y),this},reference(h,_){return this.reference2(h,_)},reference2(h,_,y){if(g(this.reference),typeof h=="object"&&"variableName"in h&&(0,l.checkProposedApiEnabled)(c._extension,"chatParticipantAdditions"),typeof h=="object"&&"variableName"in h&&!h.value){const w=c._request.variables.variables.find(P=>P.name===h.variableName);if(w){let P;if(w.references?.length)P=w.references.map(R=>({kind:"reference",reference:{variableName:h.variableName,value:R.reference}}));else{const R=new r.ChatResponseReferencePart(h,_,y);P=[v.ChatResponseReferencePart.from(R)]}return P.forEach(R=>f(R)),this}}else{const w=new r.ChatResponseReferencePart(h,_,y),P=v.ChatResponseReferencePart.from(w);f(P)}return this},codeCitation(h,_,y){g(this.codeCitation),(0,l.checkProposedApiEnabled)(c._extension,"chatParticipantAdditions");const w=new r.ChatResponseCodeCitationPart(h,_,y),P=v.ChatResponseCodeCitationPart.from(w);f(P)},textEdit(h,_){g(this.textEdit),(0,l.checkProposedApiEnabled)(c._extension,"chatParticipantAdditions");const y=new r.ChatResponseTextEditPart(h,_),w=v.ChatResponseTextEditPart.from(y);return f(w),this},detectedParticipant(h,_){g(this.detectedParticipant),(0,l.checkProposedApiEnabled)(c._extension,"chatParticipantAdditions");const y=new r.ChatResponseDetectedParticipantPart(h,_),w=v.ChatResponseDetectedParticipantPart.from(y);return f(w),this},confirmation(h,_,y,w){g(this.confirmation),(0,l.checkProposedApiEnabled)(c._extension,"chatParticipantAdditions");const P=new r.ChatResponseConfirmationPart(h,_,y,w),R=v.ChatResponseConfirmationPart.from(P);return f(R),this},push(h){if(g(this.push),(h instanceof r.ChatResponseTextEditPart||h instanceof r.ChatResponseMarkdownWithVulnerabilitiesPart||h instanceof r.ChatResponseDetectedParticipantPart||h instanceof r.ChatResponseWarningPart||h instanceof r.ChatResponseConfirmationPart||h instanceof r.ChatResponseCodeCitationPart||h instanceof r.ChatResponseMovePart)&&(0,l.checkProposedApiEnabled)(c._extension,"chatParticipantAdditions"),h instanceof r.ChatResponseReferencePart)this.reference2(h.value,h.iconPath,h.options);else{const _=v.ChatResponsePart.from(h,c._commandsConverter,c._sessionDisposables);f(_)}return this}}}return this._apiObject}}class n extends A.Disposable{static{this._idPool=0}static{this._participantDetectionProviderIdPool=0}constructor(c,g,f,h){super(),this._logService=g,this._commands=f,this._documents=h,this._agents=new Map,this._participantDetectionProviders=new Map,this._sessionDisposables=this._register(new A.DisposableMap),this._completionDisposables=this._register(new A.DisposableMap),this._proxy=c.getProxy(C.MainContext.MainThreadChatAgents2)}transferActiveChat(c){this._proxy.$transferActiveChatSession(c)}createChatAgent(c,g,f){const h=n._idPool++,_=new t(c,g,this._proxy,h,f);return this._agents.set(h,_),this._proxy.$registerAgent(h,c.identifier,g,{},void 0),_.apiAgent}createDynamicChatAgent(c,g,f,h){const _=n._idPool++,y=new t(c,g,this._proxy,_,h);return this._agents.set(_,y),this._proxy.$registerAgent(_,c.identifier,g,{isSticky:!0},f),y.apiAgent}registerChatParticipantDetectionProvider(c){const g=n._participantDetectionProviderIdPool++;return this._participantDetectionProviders.set(g,c),this._proxy.$registerChatParticipantDetectionProvider(g),(0,A.toDisposable)(()=>{this._participantDetectionProviders.delete(g),this._proxy.$unregisterChatParticipantDetectionProvider(g)})}async $detectChatParticipant(c,g,f,h,_){const{request:y,location:w,history:P}=await this._createRequest(g,f),R=this._participantDetectionProviders.get(c);if(R)return R.provideParticipantDetection(v.ChatAgentRequest.to(y,w),{history:P},{participants:h.participants,location:v.ChatLocation.to(h.location)},_)}async _createRequest(c,g){const f=(0,m.revive)(c),h=await this.prepareHistoryTurns(f.agentId,g);let _;if(f.locationData?.type===a.ChatAgentLocation.Editor){const y=this._documents.getDocument(f.locationData.document);_=new r.ChatRequestEditorData(y,v.Selection.to(f.locationData.selection),v.Range.to(f.locationData.wholeRange))}else if(f.locationData?.type===a.ChatAgentLocation.Notebook){const y=this._documents.getDocument(f.locationData.sessionInputUri);_=new r.ChatRequestNotebookData(y)}else f.locationData?.type,a.ChatAgentLocation.Terminal;return{request:f,location:_,history:h}}async $invokeAgent(c,g,f,h){const _=this._agents.get(c);if(!_)throw new Error(`[CHAT](${c}) CANNOT invoke agent because the agent is not registered`);let y;try{const{request:w,location:P,history:R}=await this._createRequest(g,f);let p=this._sessionDisposables.get(w.sessionId);p||(p=new A.DisposableStore,this._sessionDisposables.set(w.sessionId,p)),y=new i(_.extension,w,this._proxy,this._commands.converter,p);const b=_.invoke(v.ChatAgentRequest.to(w,P),{history:R},y.apiObject,h);return await(0,T.raceCancellation)(Promise.resolve(b).then(N=>{if(N?.metadata)try{JSON.stringify(N.metadata)}catch(F){const K=`result.metadata MUST be JSON.stringify-able. Got error: ${F.message}`;return this._logService.error(`[${_.extension.identifier.value}] [@${_.id}] ${K}`,_.extension),{errorDetails:{message:K},timings:y?.timings,nextQuestion:N.nextQuestion}}let L;return N?.errorDetails&&(L={...N.errorDetails,responseIsIncomplete:!0}),L?.responseIsRedacted&&(0,l.checkProposedApiEnabled)(_.extension,"chatParticipantPrivate"),{errorDetails:L,timings:y?.timings,metadata:N?.metadata,nextQuestion:N?.nextQuestion}}),h)}catch(w){return this._logService.error(w,_.extension),w instanceof r.LanguageModelError&&w.cause&&(w=w.cause),{errorDetails:{message:(0,D.toErrorMessage)(w),responseIsIncomplete:!0}}}finally{y?.close()}}async prepareHistoryTurns(c,g){const f=[];for(const h of g.history){const _=v.ChatAgentResult.to(h.result),y=c===h.request.agentId?_:{..._,metadata:void 0},w=h.request.variables.variables.filter(b=>!b.isTool).map(v.ChatPromptReference.to),P=h.request.variables.variables.filter(b=>b.isTool).map(v.ChatLanguageModelToolReference.to),R=new r.ChatRequestTurn(h.request.message,h.request.command,w,h.request.agentId);R.toolReferences=P,f.push(R);const p=(0,S.coalesce)(h.response.map(b=>v.ChatResponsePart.toContent(b,this._commands.converter)));f.push(new r.ChatResponseTurn(p,y,h.request.agentId,h.request.command))}return f}$releaseSession(c){this._sessionDisposables.deleteAndDispose(c)}async $provideFollowups(c,g,f,h,_){const y=this._agents.get(g);if(!y)return Promise.resolve([]);const w=(0,m.revive)(c),P=await this.prepareHistoryTurns(y.id,h),R=v.ChatAgentResult.to(f);return(await y.provideFollowups(R,{history:P},_)).filter(p=>{const b=!p.participant||k.Iterable.some(this._agents.values(),N=>N.id===p.participant&&u.ExtensionIdentifier.equals(N.extension.identifier,y.extension.identifier));return b||this._logService.warn(`[@${y.id}] ChatFollowup refers to an unknown participant: ${p.participant}`),b}).map(p=>v.ChatFollowup.from(p,w))}$acceptFeedback(c,g,f){const h=this._agents.get(c);if(!h)return;const _=v.ChatAgentResult.to(g);let y;switch(f.direction){case d.ChatAgentVoteDirection.Down:y=r.ChatResultFeedbackKind.Unhelpful;break;case d.ChatAgentVoteDirection.Up:y=r.ChatResultFeedbackKind.Helpful;break}const w={result:_,kind:y,unhelpfulReason:(0,l.isProposedApiEnabled)(h.extension,"chatParticipantAdditions")?f.reason:void 0};h.acceptFeedback(Object.freeze(w))}$acceptAction(c,g,f){const h=this._agents.get(c);if(!h||f.action.kind==="vote")return;const _=v.ChatAgentUserActionEvent.to(g,f,this._commands.converter);_&&h.acceptAction(Object.freeze(_))}async $invokeCompletionProvider(c,g,f){const h=this._agents.get(c);if(!h)return[];let _=this._completionDisposables.get(c);return _?_.clear():(_=new A.DisposableStore,this._completionDisposables.set(c,_)),(await h.invokeCompletionProvider(g,f)).map(w=>v.ChatAgentCompletionItem.from(w,this._commands.converter,_))}async $provideWelcomeMessage(c,g,f){const h=this._agents.get(c);if(h)return await h.provideWelcomeMessage(v.ChatLocation.to(g),f)}async $provideChatTitle(c,g,f){const h=this._agents.get(c);if(!h)return;const _=await this.prepareHistoryTurns(h.id,{history:g});return await h.provideTitle({history:_},f)}async $provideSampleQuestions(c,g,f){const h=this._agents.get(c);if(h)return(await h.provideSampleQuestions(v.ChatLocation.to(g),f)).map(_=>v.ChatFollowup.from(_,void 0))}}e.ExtHostChatAgents2=n;class t{constructor(c,g,f,h,_){this.extension=c,this.id=g,this._proxy=f,this._handle=h,this._requestHandler=_,this._onDidReceiveFeedback=new O.Emitter,this._onDidPerformAction=new O.Emitter}acceptFeedback(c){this._onDidReceiveFeedback.fire(c)}acceptAction(c){this._onDidPerformAction.fire(c)}async invokeCompletionProvider(c,g){return this._agentVariableProvider?await this._agentVariableProvider.provider.provideCompletionItems(c,g)??[]:[]}async provideFollowups(c,g,f){if(!this._followupProvider)return[];const h=await this._followupProvider.provideFollowups(c,g,f);return h?h.filter(_=>!(_&&"commandId"in _)).filter(_=>!(_&&"message"in _)):[]}async provideWelcomeMessage(c,g){if(!this._welcomeMessageProvider)return[];const f=await this._welcomeMessageProvider.provideWelcomeMessage(c,g);return f?f.map(h=>typeof h=="string"?h:v.MarkdownString.from(h)):[]}async provideTitle(c,g){if(this._titleProvider)return await this._titleProvider.provideChatTitle(c,g)??void 0}async provideSampleQuestions(c,g){if(!this._welcomeMessageProvider||!this._welcomeMessageProvider.provideSampleQuestions)return[];const f=await this._welcomeMessageProvider.provideSampleQuestions(c,g);return f||[]}get apiAgent(){let c=!1,g=!1;const f=()=>{c||g||(g=!0,queueMicrotask(()=>{this._proxy.$updateAgent(this._handle,{icon:this._iconPath?this._iconPath instanceof E.URI?this._iconPath:"light"in this._iconPath?this._iconPath.light:void 0:void 0,iconDark:this._iconPath&&"dark"in this._iconPath?this._iconPath.dark:void 0,themeIcon:this._iconPath instanceof r.ThemeIcon?this._iconPath:void 0,hasFollowups:this._followupProvider!==void 0,isSecondary:this._isSecondary,helpTextPrefix:!this._helpTextPrefix||typeof this._helpTextPrefix=="string"?this._helpTextPrefix:v.MarkdownString.from(this._helpTextPrefix),helpTextVariablesPrefix:!this._helpTextVariablesPrefix||typeof this._helpTextVariablesPrefix=="string"?this._helpTextVariablesPrefix:v.MarkdownString.from(this._helpTextVariablesPrefix),helpTextPostfix:!this._helpTextPostfix||typeof this._helpTextPostfix=="string"?this._helpTextPostfix:v.MarkdownString.from(this._helpTextPostfix),supportIssueReporting:this._supportIssueReporting,requester:this._requester,supportsSlowVariables:this._supportsSlowReferences}),g=!1}))},h=this;return{get id(){return h.id},get iconPath(){return h._iconPath},set iconPath(_){h._iconPath=_,f()},get requestHandler(){return h._requestHandler},set requestHandler(_){(0,I.assertType)(typeof _=="function","Invalid request handler"),h._requestHandler=_},get followupProvider(){return h._followupProvider},set followupProvider(_){h._followupProvider=_,f()},get helpTextPrefix(){return(0,l.checkProposedApiEnabled)(h.extension,"defaultChatParticipant"),h._helpTextPrefix},set helpTextPrefix(_){(0,l.checkProposedApiEnabled)(h.extension,"defaultChatParticipant"),h._helpTextPrefix=_,f()},get helpTextVariablesPrefix(){return(0,l.checkProposedApiEnabled)(h.extension,"defaultChatParticipant"),h._helpTextVariablesPrefix},set helpTextVariablesPrefix(_){(0,l.checkProposedApiEnabled)(h.extension,"defaultChatParticipant"),h._helpTextVariablesPrefix=_,f()},get helpTextPostfix(){return(0,l.checkProposedApiEnabled)(h.extension,"defaultChatParticipant"),h._helpTextPostfix},set helpTextPostfix(_){(0,l.checkProposedApiEnabled)(h.extension,"defaultChatParticipant"),h._helpTextPostfix=_,f()},get isSecondary(){return(0,l.checkProposedApiEnabled)(h.extension,"defaultChatParticipant"),h._isSecondary},set isSecondary(_){(0,l.checkProposedApiEnabled)(h.extension,"defaultChatParticipant"),h._isSecondary=_,f()},get supportIssueReporting(){return(0,l.checkProposedApiEnabled)(h.extension,"chatParticipantPrivate"),h._supportIssueReporting},set supportIssueReporting(_){(0,l.checkProposedApiEnabled)(h.extension,"chatParticipantPrivate"),h._supportIssueReporting=_,f()},get onDidReceiveFeedback(){return h._onDidReceiveFeedback.event},set participantVariableProvider(_){if((0,l.checkProposedApiEnabled)(h.extension,"chatParticipantAdditions"),h._agentVariableProvider=_,_){if(!_.triggerCharacters.length)throw new Error("triggerCharacters are required");h._proxy.$registerAgentCompletionsProvider(h._handle,h.id,_.triggerCharacters)}else h._proxy.$unregisterAgentCompletionsProvider(h._handle,h.id)},get participantVariableProvider(){return(0,l.checkProposedApiEnabled)(h.extension,"chatParticipantAdditions"),h._agentVariableProvider},set welcomeMessageProvider(_){(0,l.checkProposedApiEnabled)(h.extension,"defaultChatParticipant"),h._welcomeMessageProvider=_,f()},get welcomeMessageProvider(){return(0,l.checkProposedApiEnabled)(h.extension,"defaultChatParticipant"),h._welcomeMessageProvider},set titleProvider(_){(0,l.checkProposedApiEnabled)(h.extension,"defaultChatParticipant"),h._titleProvider=_,f()},get titleProvider(){return(0,l.checkProposedApiEnabled)(h.extension,"defaultChatParticipant"),h._titleProvider},onDidPerformAction:(0,l.isProposedApiEnabled)(this.extension,"chatParticipantAdditions")?this._onDidPerformAction.event:void 0,set requester(_){h._requester=_,f()},get requester(){return h._requester},set supportsSlowReferences(_){(0,l.checkProposedApiEnabled)(h.extension,"chatParticipantPrivate"),h._supportsSlowReferences=_,f()},get supportsSlowReferences(){return(0,l.checkProposedApiEnabled)(h.extension,"chatParticipantPrivate"),h._supportsSlowReferences},dispose(){c=!0,h._followupProvider=void 0,h._onDidReceiveFeedback.dispose(),h._proxy.$unregisterAgent(h._handle)}}}invoke(c,g,f,h){return this._requestHandler(c,g,f,h)}}}),define(ke[234],Re([1,0,12,4,36,5,8,7,21]),function(Ee,e,S,T,D,O,k,A,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostChatVariables=void 0,k=Ve(k),A=Ve(A);class s{static{this._idPool=0}constructor(u){this._resolver=new Map,this._proxy=u.getProxy(O.MainContext.MainThreadChatVariables)}async $resolveVariable(u,C,v,r){const a=this._resolver.get(u);if(a)try{if(a.resolver.resolve2){(0,m.checkProposedApiEnabled)(a.extension,"chatParticipantAdditions");const d=new I(C,this._proxy),l=await a.resolver.resolve2(a.data.name,{prompt:v},d.apiObject,r);if(l&&l[0])return l[0].value}else{const d=await a.resolver.resolve(a.data.name,{prompt:v},r);if(d&&d[0])return d[0].value}}catch(d){(0,S.onUnexpectedExternalError)(d)}}registerVariableResolver(u,C,v,r,a,d,l,i,n){const t=s._idPool++,o=n?D.ThemeIcon.fromId(n):void 0;return this._resolver.set(t,{extension:u,data:{id:C,name:v,description:r,modelDescription:a,icon:o},resolver:l}),this._proxy.$registerVariable(t,{id:C,name:v,description:r,modelDescription:a,isSlow:d,fullName:i,icon:o}),(0,T.toDisposable)(()=>{this._resolver.delete(t),this._proxy.$unregisterVariable(t)})}}e.ExtHostChatVariables=s;class I{constructor(u,C){this._requestId=u,this._proxy=C,this._isClosed=!1}close(){this._isClosed=!0}get apiObject(){if(!this._apiObject){let C=function(r){if(u._isClosed){const a=new Error("Response stream has been closed");throw Error.captureStackTrace(a,r),a}};const u=this,v=r=>{this._proxy.$handleProgressChunk(this._requestId,r)};this._apiObject={progress(r){C(this.progress);const a=new A.ChatResponseProgressPart(r),d=k.ChatResponseProgressPart.from(a);return v(d),this},reference(r){C(this.reference);const a=new A.ChatResponseReferencePart(r),d=k.ChatResponseReferencePart.from(a);return v(d),this},push(r){return C(this.push),r instanceof A.ChatResponseReferencePart?v(k.ChatResponseReferencePart.from(r)):r instanceof A.ChatResponseProgressPart&&v(k.ChatResponseProgressPart.from(r)),this}}}return this._apiObject}}}),define(ke[235],Re([1,0,10,71,6,4,38,2,94,18,8,7,5,21]),function(Ee,e,S,T,D,O,k,A,m,s,I,E,u,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=v,m=Ve(m),I=Ve(I),E=Ve(E);function v(r,a,d){const l=r.getProxy(u.MainContext.MainThreadComments);class i{static{this.handlePool=0}constructor(){this._commentControllers=new Map,this._commentControllersByExtension=new s.ExtensionIdentifierMap,a.registerArgumentProcessor({processArgument:w=>{if(w&&w.$mid===k.MarshalledId.CommentController){const P=this._commentControllers.get(w.handle);return P?P.value:w}else if(w&&w.$mid===k.MarshalledId.CommentThread){const P=w,R=this._commentControllers.get(P.commentControlHandle);if(!R)return P;const p=R.getCommentThread(P.commentThreadHandle);return p?p.value:P}else if(w&&(w.$mid===k.MarshalledId.CommentThreadReply||w.$mid===k.MarshalledId.CommentThreadInstance)){const P=this._commentControllers.get(w.thread.commentControlHandle);if(!P)return w;const R=P.getCommentThread(w.thread.commentThreadHandle);return R?w.$mid===k.MarshalledId.CommentThreadInstance?R.value:{thread:R.value,text:w.text}:w}else if(w&&w.$mid===k.MarshalledId.CommentNode){const P=this._commentControllers.get(w.thread.commentControlHandle);if(!P)return w;const R=P.getCommentThread(w.thread.commentThreadHandle);if(!R)return w;const p=w.commentUniqueId,b=R.getCommentByUniqueId(p);return b||w}else if(w&&w.$mid===k.MarshalledId.CommentThreadNode){const P=this._commentControllers.get(w.thread.commentControlHandle);if(!P)return w;const R=P.getCommentThread(w.thread.commentThreadHandle);if(!R)return w;const p=w.text,b=w.commentUniqueId,N=R.getCommentByUniqueId(b);return N?(typeof N.body=="string"?N.body=p:N.body=new E.MarkdownString(p),N):w}return w}})}createCommentController(w,P,R){const p=i.handlePool++,b=new t(w,p,P,R);this._commentControllers.set(b.handle,b);const N=this._commentControllersByExtension.get(w.identifier)||[];return N.push(b),this._commentControllersByExtension.set(w.identifier,N),b.value}async $createCommentThreadTemplate(w,P,R,p){const b=this._commentControllers.get(w);b&&b.$createCommentThreadTemplate(P,R,p)}async $setActiveComment(w,P){const R=this._commentControllers.get(w);R&&R.$setActiveComment(P??void 0)}async $updateCommentThreadTemplate(w,P,R){const p=this._commentControllers.get(w);p&&p.$updateCommentThreadTemplate(P,R)}$deleteCommentThread(w,P){this._commentControllers.get(w)?.$deleteCommentThread(P)}async $provideCommentingRanges(w,P,R){const p=this._commentControllers.get(w);if(!p||!p.commentingRangeProvider)return Promise.resolve(void 0);const b=await d.ensureDocumentData(A.URI.revive(P));return(0,S.asPromise)(async()=>{const N=await p.commentingRangeProvider.provideCommentingRanges(b.document,R);let L;return Array.isArray(N)?L={ranges:N,fileComments:!1}:N?L={ranges:N.ranges||[],fileComments:N.enableFileComments||!1}:L=N??void 0,L}).then(N=>{let L;return N&&(L={ranges:N.ranges.map(F=>I.Range.from(F)),fileComments:N.fileComments}),L})}$toggleReaction(w,P,R,p,b){const N=this._commentControllers.get(w);return!N||!N.reactionHandler?Promise.resolve(void 0):(0,S.asPromise)(()=>{const L=N.getCommentThread(P);if(L){const F=L.getCommentByUniqueId(p.uniqueIdInThread);if(N!==void 0&&F&&N.reactionHandler)return N.reactionHandler(F,g(b))}return Promise.resolve(void 0)})}}class n{static{this._handlePool=0}set threadId(w){this._id=w}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(w){(w===void 0!=(this._range===void 0)||!w||!this._range||!w.isEqual(this._range))&&(this._range=w,this.modifications.range=w,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(w){this._canReply!==w&&(this._canReply=w,this.modifications.canReply=w,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(w){this._label=w,this.modifications.label=w,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(w){this._contextValue=w,this.modifications.contextValue=w,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(w){this._comments=w,this.modifications.comments=w,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(w){this._collapseState=w,this.modifications.collapsibleState=w,this._onDidUpdateCommentThread.fire()}get state(){return this._state}set state(w){this._state=w,typeof w=="object"?((0,C.checkProposedApiEnabled)(this.extensionDescription,"commentThreadApplicability"),this.modifications.state=w.resolved,this.modifications.applicability=w.applicability):this.modifications.state=w,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}constructor(w,P,R,p,b,N,L,F,K){this._commentControllerHandle=P,this._id=R,this._uri=p,this._range=b,this._comments=N,this.extensionDescription=L,this._isTemplate=F,this.handle=n._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new D.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new O.MutableDisposable,this._acceptInputDisposables.value=new O.DisposableStore,this._id===void 0&&(this._id=`${w}.${this.handle}`),l.$createCommentThread(P,this.handle,this._id,this._uri,I.Range.from(this._range),this._comments.map($=>o(this,$,this._commentsMap,this.extensionDescription)),L.identifier,this._isTemplate,K),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this._localDisposables.push({dispose:()=>{l.$deleteCommentThread(P,this.handle)}});const J=this;this.value={get uri(){return J.uri},get range(){return J.range},set range($){J.range=$},get comments(){return J.comments},set comments($){J.comments=$},get collapsibleState(){return J.collapsibleState},set collapsibleState($){J.collapsibleState=$},get canReply(){return J.canReply},set canReply($){J.canReply=$},get contextValue(){return J.contextValue},set contextValue($){J.contextValue=$},get label(){return J.label},set label($){J.label=$},get state(){return J.state},set state($){J.state=$},reveal:($,x)=>J.reveal($,x),hide:()=>J.hide(),dispose:()=>{J.dispose()}}}updateIsTemplate(){this._isTemplate&&(this._isTemplate=!1,this.modifications.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this.updateIsTemplate(),this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new O.DisposableStore);const w=R=>Object.prototype.hasOwnProperty.call(this.modifications,R),P={};w("range")&&(P.range=I.Range.from(this._range)),w("label")&&(P.label=this.label),w("contextValue")&&(P.contextValue=this.contextValue??null),w("comments")&&(P.comments=this._comments.map(R=>o(this,R,this._commentsMap,this.extensionDescription))),w("collapsibleState")&&(P.collapseState=f(this._collapseState)),w("canReply")&&(P.canReply=this.canReply),w("state")&&(P.state=h(this._state)),w("applicability")&&(P.applicability=_(this._state)),w("isTemplate")&&(P.isTemplate=this._isTemplate),this.modifications={},l.$updateCommentThread(this._commentControllerHandle,this.handle,this._id,this._uri,P)}getCommentByUniqueId(w){for(const P of this._commentsMap){const R=P[0],p=P[1];if(w===p)return R}}async reveal(w,P){(0,C.checkProposedApiEnabled)(this.extensionDescription,"commentReveal");let R;w&&w.body!==void 0?R=w:P=P??w;let p=R?this._commentsMap.get(R):void 0;p??=this._commentsMap.get(this._comments[0]);let b=!0,N=!1;return P?.focus===E.CommentThreadFocus.Reply?(N=!0,b=!1):P?.focus===E.CommentThreadFocus.Comment&&(b=!1),l.$revealCommentThread(this._commentControllerHandle,this.handle,p,{preserveFocus:b,focusReply:N})}async hide(){return l.$hideCommentThread(this._commentControllerHandle,this.handle)}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(w=>w.dispose())}}qe([(0,T.debounce)(100)],n.prototype,"eventuallyUpdateCommentThread",null);class t{get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get commentingRangeProvider(){return this._commentingRangeProvider}set commentingRangeProvider(w){this._commentingRangeProvider=w,w?.resourceHints&&(0,C.checkProposedApiEnabled)(this._extension,"commentingRangeHint"),l.$updateCommentingRanges(this.handle,w?.resourceHints)}get reactionHandler(){return this._reactionHandler}set reactionHandler(w){this._reactionHandler=w,l.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!w})}get options(){return this._options}set options(w){this._options=w,l.$updateCommentControllerFeatures(this.handle,{options:this._options})}get activeComment(){return(0,C.checkProposedApiEnabled)(this._extension,"activeComment"),this._activeComment}get activeCommentThread(){return(0,C.checkProposedApiEnabled)(this._extension,"activeComment"),this._activeThread?.value}constructor(w,P,R,p){this._extension=w,this._handle=P,this._id=R,this._label=p,this._threads=new Map,l.$registerCommentController(this.handle,R,p,this._extension.identifier.value);const b=this;this.value=Object.freeze({id:b.id,label:b.label,get options(){return b.options},set options(N){b.options=N},get commentingRangeProvider(){return b.commentingRangeProvider},set commentingRangeProvider(N){b.commentingRangeProvider=N},get reactionHandler(){return b.reactionHandler},set reactionHandler(N){b.reactionHandler=N},get activeCommentThread(){return b.activeCommentThread},createCommentThread(N,L,F){return b.createCommentThread(N,L,F).value},dispose:()=>{b.dispose()}}),this._localDisposables=[],this._localDisposables.push({dispose:()=>{l.$unregisterCommentController(this.handle)}})}createCommentThread(w,P,R){P===void 0&&(0,C.checkProposedApiEnabled)(this._extension,"fileComments");const p=new n(this.id,this.handle,void 0,w,P,R,this._extension,!1);return this._threads.set(p.handle,p),p}$setActiveComment(w){if(!w){this._activeComment=void 0,this._activeThread=void 0;return}const P=this._threads.get(w.commentThreadHandle);P&&(this._activeComment=w.uniqueIdInThread?P.getCommentByUniqueId(w.uniqueIdInThread):void 0,this._activeThread=P)}$createCommentThreadTemplate(w,P,R){const p=new n(this.id,this.handle,void 0,A.URI.revive(w),I.Range.to(P),[],this._extension,!0,R);return p.collapsibleState=m.CommentThreadCollapsibleState.Expanded,this._threads.set(p.handle,p),p}$updateCommentThreadTemplate(w,P){const R=this._threads.get(w);R&&(R.range=I.Range.to(P))}$deleteCommentThread(w){this._threads.get(w)?.dispose(),this._threads.delete(w)}getCommentThread(w){return this._threads.get(w)}dispose(){this._threads.forEach(w=>{w.dispose()}),this._localDisposables.forEach(w=>w.dispose())}}function o(y,w,P,R){let p=P.get(w);return p||(p=++y.commentHandle,P.set(w,p)),w.state!==void 0&&(0,C.checkProposedApiEnabled)(R,"commentsDraftState"),w.reactions?.some(b=>b.reactors!==void 0)&&(0,C.checkProposedApiEnabled)(R,"commentReactor"),{mode:w.mode,contextValue:w.contextValue,uniqueIdInThread:p,body:typeof w.body=="string"?w.body:I.MarkdownString.from(w.body),userName:w.author.name,userIconPath:w.author.iconPath,label:w.label,commentReactions:w.reactions?w.reactions.map(b=>c(b)):void 0,state:w.state,timestamp:w.timestamp?.toJSON()}}function c(y){return{label:y.label,iconPath:y.iconPath?I.pathOrURIToURI(y.iconPath):void 0,count:y.count,hasReacted:y.authorHasReacted,reactors:y.reactors&&y.reactors.length>0&&typeof y.reactors[0]!="string"?y.reactors.map(w=>w.name):y.reactors}}function g(y){return{label:y.label||"",count:y.count||0,iconPath:y.iconPath?A.URI.revive(y.iconPath):"",authorHasReacted:y.hasReacted||!1,reactors:y.reactors?.map(w=>({name:w}))}}function f(y){if(y!==void 0)switch(y){case E.CommentThreadCollapsibleState.Expanded:return m.CommentThreadCollapsibleState.Expanded;case E.CommentThreadCollapsibleState.Collapsed:return m.CommentThreadCollapsibleState.Collapsed}return m.CommentThreadCollapsibleState.Collapsed}function h(y){let w;if(typeof y=="object"?w=y.resolved:w=y,w!==void 0)switch(w){case E.CommentThreadState.Unresolved:return m.CommentThreadState.Unresolved;case E.CommentThreadState.Resolved:return m.CommentThreadState.Resolved}return m.CommentThreadState.Unresolved}function _(y){let w;if(typeof y=="object"&&(w=y.applicability),w!==void 0)switch(w){case E.CommentThreadApplicability.Current:return m.CommentThreadApplicability.Current;case E.CommentThreadApplicability.Outdated:return m.CommentThreadApplicability.Outdated}return m.CommentThreadApplicability.Current}return new i}}),define(ke[236],Re([1,0,19,76,4,15,24,2,8,67,80,5,7]),function(Ee,e,S,T,D,O,k,A,m,s,I,E,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0,m=Ve(m),E=Ve(E),u=Ve(u);class C{constructor(c,g){this.document=c,this._storagePath=g,this._backupCounter=1,this._edits=new I.Cache("custom documents")}addEdit(c){return this._edits.add([c])}async undo(c,g){await this.getEdit(c).undo(),g||this.disposeBackup()}async redo(c,g){await this.getEdit(c).redo(),g||this.disposeBackup()}disposeEdits(c){for(const g of c)this._edits.delete(g)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const c=t(this.document.uri)+this._backupCounter++;return(0,k.joinPath)(this._storagePath,c)}updateBackup(c){this._backup?.delete(),this._backup=c}disposeBackup(){this._backup?.delete(),this._backup=void 0}getEdit(c){const g=this._edits.get(c,0);if(!g)throw new Error("No edit found");return g}}class v{constructor(){this._documents=new Map}get(c,g){return this._documents.get(this.key(c,g))}add(c,g,f){const h=this.key(c,g.uri);if(this._documents.has(h))throw new Error(`Document already exists for viewType:${c} resource:${g.uri}`);const _=new C(g,f);return this._documents.set(h,_),_}delete(c,g){const f=this.key(c,g.uri);this._documents.delete(f)}key(c,g){return`${c}@@@${g}`}}var r;(function(o){o[o.Text=0]="Text",o[o.Custom=1]="Custom"})(r||(r={}));class a{constructor(){this._providers=new Map}addTextProvider(c,g,f){return this.add(c,{type:r.Text,extension:g,provider:f})}addCustomProvider(c,g,f){return this.add(c,{type:r.Custom,extension:g,provider:f})}get(c){return this._providers.get(c)}add(c,g){if(this._providers.has(c))throw new Error(`Provider for viewType:${c} already registered`);return this._providers.set(c,g),new u.Disposable(()=>this._providers.delete(c))}}class d{constructor(c,g,f,h,_){this._extHostDocuments=g,this._extensionStoragePaths=f,this._extHostWebview=h,this._extHostWebviewPanels=_,this._editorProviders=new a,this._documents=new v,this._proxy=c.getProxy(E.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(c,g,f,h){const _=new D.DisposableStore;return i(f)?(_.add(this._editorProviders.addTextProvider(g,c,f)),this._proxy.$registerTextEditorProvider((0,s.toExtensionData)(c),g,h.webviewOptions||{},{supportsMove:!!f.moveCustomTextEditor},(0,s.shouldSerializeBuffersForPostMessage)(c))):(_.add(this._editorProviders.addCustomProvider(g,c,f)),l(f)&&_.add(f.onDidChangeCustomDocument(y=>{const w=this.getCustomDocumentEntry(g,y.document.uri);if(n(y)){const P=w.addEdit(y);this._proxy.$onDidEdit(y.document.uri,g,P,y.label)}else this._proxy.$onContentChange(y.document.uri,g)})),this._proxy.$registerCustomEditorProvider((0,s.toExtensionData)(c),g,h.webviewOptions||{},!!h.supportsMultipleEditorsPerDocument,(0,s.shouldSerializeBuffersForPostMessage)(c))),u.Disposable.from(_,new u.Disposable(()=>{this._proxy.$unregisterEditorProvider(g)}))}async $createCustomDocument(c,g,f,h,_){const y=this._editorProviders.get(g);if(!y)throw new Error(`No provider found for '${g}'`);if(y.type!==r.Custom)throw new Error(`Invalid provide type for '${g}'`);const w=A.URI.revive(c),P=await y.provider.openCustomDocument(w,{backupId:f,untitledDocumentData:h?.buffer},_);let R;return l(y.provider)&&this._extensionStoragePaths&&(R=this._extensionStoragePaths.workspaceValue(y.extension)??this._extensionStoragePaths.globalValue(y.extension)),this._documents.add(g,P,R),{editable:l(y.provider)}}async $disposeCustomDocument(c,g){const f=this._editorProviders.get(g);if(!f)throw new Error(`No provider found for '${g}'`);if(f.type!==r.Custom)throw new Error(`Invalid provider type for '${g}'`);const h=A.URI.revive(c),{document:_}=this.getCustomDocumentEntry(g,h);this._documents.delete(g,_),_.dispose()}async $resolveCustomEditor(c,g,f,h,_,y){const w=this._editorProviders.get(f);if(!w)throw new Error(`No provider found for '${f}'`);const P=m.ViewColumn.to(_),R=this._extHostWebview.createNewWebview(g,h.contentOptions,w.extension),p=this._extHostWebviewPanels.createNewWebviewPanel(g,f,h.title,P,h.options,R,h.active),b=A.URI.revive(c);switch(w.type){case r.Custom:{const{document:N}=this.getCustomDocumentEntry(f,b);return w.provider.resolveCustomEditor(N,p,y)}case r.Text:{const N=this._extHostDocuments.getDocument(b);return w.provider.resolveCustomTextEditor(N,p,y)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(c,g,f){this.getCustomDocumentEntry(g,c).disposeEdits(f)}async $onMoveCustomEditor(c,g,f){const h=this._editorProviders.get(f);if(!h)throw new Error(`No provider found for '${f}'`);if(!h.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${f}'`);const _=this._extHostWebviewPanels.getWebviewPanel(c);if(!_)throw new Error("No webview found");const y=A.URI.revive(g),w=this._extHostDocuments.getDocument(y);await h.provider.moveCustomTextEditor(w,_,S.CancellationToken.None)}async $undo(c,g,f,h){return this.getCustomDocumentEntry(g,c).undo(f,h)}async $redo(c,g,f,h){return this.getCustomDocumentEntry(g,c).redo(f,h)}async $revert(c,g,f){const h=this.getCustomDocumentEntry(g,c);await this.getCustomEditorProvider(g).revertCustomDocument(h.document,f),h.disposeBackup()}async $onSave(c,g,f){const h=this.getCustomDocumentEntry(g,c);await this.getCustomEditorProvider(g).saveCustomDocument(h.document,f),h.disposeBackup()}async $onSaveAs(c,g,f,h){const _=this.getCustomDocumentEntry(g,c);return this.getCustomEditorProvider(g).saveCustomDocumentAs(_.document,A.URI.revive(f),h)}async $backup(c,g,f){const h=this.getCustomDocumentEntry(g,c),y=await this.getCustomEditorProvider(g).backupCustomDocument(h.document,{destination:h.getNewBackupUri()},f);return h.updateBackup(y),y.id}getCustomDocumentEntry(c,g){const f=this._documents.get(c,A.URI.revive(g));if(!f)throw new Error("No custom document found");return f}getCustomEditorProvider(c){const f=this._editorProviders.get(c)?.provider;if(!f||!l(f))throw new Error("Custom document is not editable");return f}}e.ExtHostCustomEditors=d;function l(o){return!!o.onDidChangeCustomDocument}function i(o){return typeof o.resolveCustomTextEditor=="function"}function n(o){return typeof o.undo=="function"&&typeof o.redo=="function"}function t(o){const c=o.scheme===O.Schemas.file||o.scheme===O.Schemas.untitled?o.fsPath:o.toString();return(0,T.hash)(c)+""}}),define(ke[237],Re([1,0,9,108,2,5,7,8,6,11,27,50]),function(Ee,e,S,T,D,O,k,A,m,s,I,E){"use strict";var u;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0,A=Ve(A);class C{#e;#t;#i;constructor(a,d,l,i,n,t,o,c){this._name=a,this._owner=d,this._maxDiagnosticsTotal=l,this._maxDiagnosticsPerFile=i,this._modelVersionIdProvider=n,this._isDisposed=!1,this._maxDiagnosticsTotal=Math.max(i,l),this.#i=new I.ResourceMap(g=>t.getComparisonKey(g)),this.#e=o,this.#t=c}dispose(){this._isDisposed||(this.#t.fire([...this.#i.keys()]),this.#e?.$clear(this._owner),this.#i.clear(),this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(a,d){if(!a){this.clear();return}this._checkDisposed();let l=[];if(D.URI.isUri(a)){if(!d){this.delete(a);return}this.#i.set(a,d.slice()),l=[a]}else if(Array.isArray(a)){l=[];let t;a=[...a].sort(C._compareIndexedTuplesByUri);for(const o of a){const[c,g]=o;if((!t||c.toString()!==t.toString())&&(t&&this.#i.get(t).length===0&&this.#i.delete(t),t=c,l.push(c),this.#i.set(c,[])),g)this.#i.get(c)?.push(...g);else{const f=this.#i.get(c);f&&(f.length=0)}}}if(this.#t.fire(l),!this.#e)return;const i=[];let n=0;for(const t of l){let o=[];const c=this.#i.get(t);if(c)if(c.length>this._maxDiagnosticsPerFile){o=[];const g=[k.DiagnosticSeverity.Error,k.DiagnosticSeverity.Warning,k.DiagnosticSeverity.Information,k.DiagnosticSeverity.Hint];e:for(let f=0;f<4;f++)for(const h of c)if(h.severity===g[f]&&o.push({...A.Diagnostic.from(h),modelVersionId:this._modelVersionIdProvider(t)})===this._maxDiagnosticsPerFile)break e;o.push({severity:T.MarkerSeverity.Info,message:(0,S.localize)(2700,null,c.length-this._maxDiagnosticsPerFile),startLineNumber:o[o.length-1].startLineNumber,startColumn:o[o.length-1].startColumn,endLineNumber:o[o.length-1].endLineNumber,endColumn:o[o.length-1].endColumn})}else o=c.map(g=>({...A.Diagnostic.from(g),modelVersionId:this._modelVersionIdProvider(t)}));if(i.push([t,o]),n+=o.length,n>this._maxDiagnosticsTotal)break}this.#e.$changeMany(this._owner,i)}delete(a){this._checkDisposed(),this.#t.fire([a]),this.#i.delete(a),this.#e?.$changeMany(this._owner,[[a,void 0]])}clear(){this._checkDisposed(),this.#t.fire([...this.#i.keys()]),this.#i.clear(),this.#e?.$clear(this._owner)}forEach(a,d){this._checkDisposed();for(const[l,i]of this)a.call(d,l,i,this)}*[Symbol.iterator](){this._checkDisposed();for(const a of this.#i.keys())yield[a,this.get(a)]}get(a){this._checkDisposed();const d=this.#i.get(a);return Array.isArray(d)?Object.freeze(d.slice(0)):[]}has(a){return this._checkDisposed(),Array.isArray(this.#i.get(a))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(a,d){return a[0].toString()<d[0].toString()?-1:a[0].toString()>d[0].toString()?1:0}}e.DiagnosticCollection=C;let v=class{static{u=this}static{this._idPool=0}static{this._maxDiagnosticsPerFile=1e3}static{this._maxDiagnosticsTotal=1.1*this._maxDiagnosticsPerFile}static _mapper(a){const d=new I.ResourceMap;for(const l of a)d.set(l,l);return{uris:Object.freeze(Array.from(d.values()))}}constructor(a,d,l,i){this._logService=d,this._fileSystemInfoService=l,this._extHostDocumentsAndEditors=i,this._collections=new Map,this._onDidChangeDiagnostics=new m.DebounceEmitter({merge:n=>n.flat(),delay:50}),this.onDidChangeDiagnostics=m.Event.map(this._onDidChangeDiagnostics.event,u._mapper),this._proxy=a.getProxy(O.MainContext.MainThreadDiagnostics)}createDiagnosticCollection(a,d){const{_collections:l,_proxy:i,_onDidChangeDiagnostics:n,_logService:t,_fileSystemInfoService:o,_extHostDocumentsAndEditors:c}=this,g=new class{$changeMany(_,y){i.$changeMany(_,y),t.trace("[DiagnosticCollection] change many (extension, owner, uris)",a.value,_,y.length===0?"CLEARING":y)}$clear(_){i.$clear(_),t.trace("[DiagnosticCollection] remove all (extension, owner)",a.value,_)}dispose(){i.dispose()}};let f;if(!d)d="_generated_diagnostic_collection_name_#"+u._idPool++,f=d;else if(!l.has(d))f=d;else{this._logService.warn(`DiagnosticCollection with name '${d}' does already exist.`);do f=d+u._idPool++;while(l.has(f))}return new class extends C{constructor(){super(d,f,u._maxDiagnosticsTotal,u._maxDiagnosticsPerFile,_=>c.getDocument(_)?.version,o.extUri,g,n),l.set(f,this)}dispose(){super.dispose(),l.delete(f)}}}getDiagnostics(a){if(a)return this._getDiagnostics(a);{const d=new Map,l=[];for(const i of this._collections.values())i.forEach((n,t)=>{let o=d.get(n.toString());typeof o>"u"&&(o=l.length,d.set(n.toString(),o),l.push([n,[]])),l[o][1]=l[o][1].concat(...t)});return l}}_getDiagnostics(a){let d=[];for(const l of this._collections.values())l.has(a)&&(d=d.concat(l.get(a)));return d}$acceptMarkersChange(a){if(!this._mirrorCollection){const d="_generated_mirror",l=new C(d,d,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,i=>{},this._fileSystemInfoService.extUri,void 0,this._onDidChangeDiagnostics);this._collections.set(d,l),this._mirrorCollection=l}for(const[d,l]of a)this._mirrorCollection.set(D.URI.revive(d),l.map(A.Diagnostic.to))}};e.ExtHostDiagnostics=v,e.ExtHostDiagnostics=v=u=qe([We(1,s.ILogService),We(2,E.IExtHostFileSystemInfo)],v)}),define(ke[238],Re([1,0,2,12,7,8,172,39]),function(Ee,e,S,T,D,O,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class m{constructor(I,E,u,C={timeout:1500,errors:3}){this._logService=I,this._documents=E,this._mainThreadBulkEdits=u,this._thresholds=C,this._callbacks=new k.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(I){return(E,u,C)=>{const r={dispose:this._callbacks.push([E,u,I])};return Array.isArray(C)&&C.push(r),r}}async $participateInSave(I,E){const u=S.URI.revive(I);let C=!1;const v=setTimeout(()=>C=!0,this._thresholds.timeout),r=[];try{for(const a of[...this._callbacks]){if(C)break;const d=this._documents.getDocument(u),l=await this._deliverEventAsyncAndBlameBadListeners(a,{document:d,reason:O.TextDocumentSaveReason.to(E)});r.push(l)}}finally{clearTimeout(v)}return r}_deliverEventAsyncAndBlameBadListeners([I,E,u],C){const v=this._badListeners.get(I);return typeof v=="number"&&v>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(u,I,E,C).then(()=>!0,r=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${u.identifier.value}' threw ERROR`),this._logService.error(r),!(r instanceof Error)||r.message!=="concurrent_edits"){const a=this._badListeners.get(I);this._badListeners.set(I,a?a+1:1),typeof a=="number"&&a>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${u.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(I,E,u,C){const v=[],r=Date.now(),{document:a,reason:d}=C,{version:l}=a,i=Object.freeze({document:a,reason:d,waitUntil(n){if(Object.isFrozen(v))throw(0,T.illegalState)("waitUntil can not be called async");v.push(Promise.resolve(n))}});try{E.apply(u,[i])}catch(n){return Promise.reject(n)}return Object.freeze(v),new Promise((n,t)=>{const o=setTimeout(()=>t(new Error("timeout")),this._thresholds.timeout);return Promise.all(v).then(c=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' finished after ${Date.now()-r}ms`),clearTimeout(o),n(c)}).catch(c=>{clearTimeout(o),t(c)})}).then(n=>{const t={edits:[]};for(const o of n)if(Array.isArray(o)&&o.every(c=>c instanceof D.TextEdit))for(const{newText:c,newEol:g,range:f}of o)t.edits.push({resource:a.uri,versionId:void 0,textEdit:{range:f&&O.Range.from(f),text:c,eol:g&&O.EndOfLine.from(g)}});if(t.edits.length!==0)return l===a.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(new A.SerializableObjectWithBuffers(t)):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=m}),define(ke[239],Re([1,0,6,4,2,5,125,8,14,25,7]),function(Ee,e,S,T,D,O,k,A,m,s,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0,A=Ve(A);class E{constructor(C,v){this._onDidAddDocument=new S.Emitter,this._onDidRemoveDocument=new S.Emitter,this._onDidChangeDocument=new S.Emitter,this._onDidSaveDocument=new S.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new T.DisposableStore,this._documentLoader=new Map,this._proxy=C.getProxy(O.MainContext.MainThreadDocuments),this._documentsAndEditors=v,this._documentsAndEditors.onDidRemoveDocuments(r=>{for(const a of r)this._onDidRemoveDocument.fire(a.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(r=>{for(const a of r)this._onDidAddDocument.fire(a.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(C){if(!C)return;const v=this._documentsAndEditors.getDocument(C);if(v)return v}getDocument(C){const v=this.getDocumentData(C);if(!v?.document)throw new Error(`Unable to retrieve document from URI '${C}'`);return v.document}ensureDocumentData(C){const v=this._documentsAndEditors.getDocument(C);if(v)return Promise.resolve(v);let r=this._documentLoader.get(C.toString());return r||(r=this._proxy.$tryOpenDocument(C).then(a=>{this._documentLoader.delete(C.toString());const d=D.URI.revive(a);return(0,m.assertIsDefined)(this._documentsAndEditors.getDocument(d))},a=>(this._documentLoader.delete(C.toString()),Promise.reject(a))),this._documentLoader.set(C.toString(),r)),r}createDocumentData(C){return this._proxy.$tryCreateDocument(C).then(v=>D.URI.revive(v))}$acceptModelLanguageChanged(C,v){const r=D.URI.revive(C),a=this._documentsAndEditors.getDocument(r);if(!a)throw new Error("unknown document");this._onDidRemoveDocument.fire(a.document),a._acceptLanguageId(v),this._onDidAddDocument.fire(a.document)}$acceptModelSaved(C){const v=D.URI.revive(C),r=this._documentsAndEditors.getDocument(v);if(!r)throw new Error("unknown document");this.$acceptDirtyStateChanged(C,!1),this._onDidSaveDocument.fire(r.document)}$acceptDirtyStateChanged(C,v){const r=D.URI.revive(C),a=this._documentsAndEditors.getDocument(r);if(!a)throw new Error("unknown document");a._acceptIsDirty(v),this._onDidChangeDocument.fire({document:a.document,contentChanges:[],reason:void 0})}$acceptModelChanged(C,v,r){const a=D.URI.revive(C),d=this._documentsAndEditors.getDocument(a);if(!d)throw new Error("unknown document");d._acceptIsDirty(r),d.onEvents(v);let l;v.isUndoing?l=I.TextDocumentChangeReason.Undo:v.isRedoing&&(l=I.TextDocumentChangeReason.Redo),this._onDidChangeDocument.fire((0,s.deepFreeze)({document:d.document,contentChanges:v.changes.map(i=>({range:A.Range.to(i.range),rangeOffset:i.rangeOffset,rangeLength:i.rangeLength,text:i.text})),reason:l}))}setWordDefinitionFor(C,v){(0,k.setWordDefinitionFor)(C,v)}}e.ExtHostDocuments=E}),define(ke[70],Re([1,0,240,6,14,2,3,5,16,8,7]),function(Ee,e,S,T,D,O,k,A,m,s,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,s=Ve(s),e.IExtHostEditorTabs=(0,k.createDecorator)("IExtHostEditorTabs");class E{constructor(a,d,l){this._activeTabIdGetter=l,this._parentGroup=d,this.acceptDtoUpdate(a)}get apiObject(){if(!this._apiObject){const a=this,d={get isActive(){return a._dto.id===a._activeTabIdGetter()},get label(){return a._dto.label},get input(){return a._input},get isDirty(){return a._dto.isDirty},get isPinned(){return a._dto.isPinned},get isPreview(){return a._dto.isPreview},get group(){return a._parentGroup.apiObject}};this._apiObject=Object.freeze(d)}return this._apiObject}get tabId(){return this._dto.id}acceptDtoUpdate(a){this._dto=a,this._input=this._initInput()}_initInput(){switch(this._dto.input.kind){case A.TabInputKind.TextInput:return new I.TextTabInput(O.URI.revive(this._dto.input.uri));case A.TabInputKind.TextDiffInput:return new I.TextDiffTabInput(O.URI.revive(this._dto.input.original),O.URI.revive(this._dto.input.modified));case A.TabInputKind.TextMergeInput:return new I.TextMergeTabInput(O.URI.revive(this._dto.input.base),O.URI.revive(this._dto.input.input1),O.URI.revive(this._dto.input.input2),O.URI.revive(this._dto.input.result));case A.TabInputKind.CustomEditorInput:return new I.CustomEditorTabInput(O.URI.revive(this._dto.input.uri),this._dto.input.viewType);case A.TabInputKind.WebviewEditorInput:return new I.WebviewEditorTabInput(this._dto.input.viewType);case A.TabInputKind.NotebookInput:return new I.NotebookEditorTabInput(O.URI.revive(this._dto.input.uri),this._dto.input.notebookType);case A.TabInputKind.NotebookDiffInput:return new I.NotebookDiffEditorTabInput(O.URI.revive(this._dto.input.original),O.URI.revive(this._dto.input.modified),this._dto.input.notebookType);case A.TabInputKind.TerminalEditorInput:return new I.TerminalEditorTabInput;case A.TabInputKind.InteractiveEditorInput:return new I.InteractiveWindowInput(O.URI.revive(this._dto.input.uri),O.URI.revive(this._dto.input.inputBoxUri));case A.TabInputKind.ChatEditorInput:return new I.ChatEditorTabInput;case A.TabInputKind.MultiDiffEditorInput:return new I.TextMultiDiffTabInput(this._dto.input.diffEditors.map(a=>new I.TextDiffTabInput(O.URI.revive(a.original),O.URI.revive(a.modified))));default:return}}}class u{constructor(a,d){this._tabs=[],this._activeTabId="",this._dto=a,this._activeGroupIdGetter=d;for(const l of a.tabs)l.isActive&&(this._activeTabId=l.id),this._tabs.push(new E(l,this,()=>this.activeTabId()))}get apiObject(){if(!this._apiObject){const a=this,d={get isActive(){return a._dto.groupId===a._activeGroupIdGetter()},get viewColumn(){return s.ViewColumn.to(a._dto.viewColumn)},get activeTab(){return a._tabs.find(l=>l.tabId===a._activeTabId)?.apiObject},get tabs(){return Object.freeze(a._tabs.map(l=>l.apiObject))}};this._apiObject=Object.freeze(d)}return this._apiObject}get groupId(){return this._dto.groupId}get tabs(){return this._tabs}acceptGroupDtoUpdate(a){this._dto=a}acceptTabOperation(a){if(a.kind===A.TabModelOperationKind.TAB_OPEN){const l=new E(a.tabDto,this,()=>this.activeTabId());return this._tabs.splice(a.index,0,l),a.tabDto.isActive&&(this._activeTabId=l.tabId),l}else if(a.kind===A.TabModelOperationKind.TAB_CLOSE){const l=this._tabs.splice(a.index,1)[0];if(!l)throw new Error(`Tab close updated received for index ${a.index} which does not exist`);return l.tabId===this._activeTabId&&(this._activeTabId=""),l}else if(a.kind===A.TabModelOperationKind.TAB_MOVE){if(a.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const l=this._tabs.splice(a.oldIndex,1)[0];if(!l)throw new Error(`Tab move updated received for index ${a.oldIndex} which does not exist`);return this._tabs.splice(a.index,0,l),l}const d=this._tabs.find(l=>l.tabId===a.tabDto.id);if(!d)throw new Error("INVALID tab");return a.tabDto.isActive?this._activeTabId=a.tabDto.id:this._activeTabId===a.tabDto.id&&!a.tabDto.isActive&&(this._activeTabId=""),d.acceptDtoUpdate(a.tabDto),d}activeTabId(){return this._activeTabId}}let C=class{constructor(a){this._onDidChangeTabs=new T.Emitter,this._onDidChangeTabGroups=new T.Emitter,this._extHostTabGroups=[],this._proxy=a.getProxy(A.MainContext.MainThreadEditorTabs)}get tabGroups(){if(!this._apiObject){const a=this,d={onDidChangeTabGroups:a._onDidChangeTabGroups.event,onDidChangeTabs:a._onDidChangeTabs.event,get all(){return Object.freeze(a._extHostTabGroups.map(l=>l.apiObject))},get activeTabGroup(){const l=a._activeGroupId;return(0,D.assertIsDefined)(a._extHostTabGroups.find(n=>n.groupId===l)?.apiObject)},close:async(l,i)=>{const n=Array.isArray(l)?l:[l];return n.length?v(n[0])?this._closeGroups(n,i):this._closeTabs(n,i):!0}};this._apiObject=Object.freeze(d)}return this._apiObject}$acceptEditorTabModel(a){const d=new Set(this._extHostTabGroups.map(g=>g.groupId)),l=new Set(a.map(g=>g.groupId)),i=(0,S.diffSets)(d,l),n=this._extHostTabGroups.filter(g=>i.removed.includes(g.groupId)).map(g=>g.apiObject),t=[],o=[];this._extHostTabGroups=a.map(g=>{const f=new u(g,()=>this._activeGroupId);return i.added.includes(f.groupId)?t.push(f.apiObject):o.push(f.apiObject),f});const c=(0,D.assertIsDefined)(a.find(g=>g.isActive===!0)?.groupId);c!==void 0&&this._activeGroupId!==c&&(this._activeGroupId=c),this._onDidChangeTabGroups.fire(Object.freeze({opened:t,closed:n,changed:o}))}$acceptTabGroupUpdate(a){const d=this._extHostTabGroups.find(l=>l.groupId===a.groupId);if(!d)throw new Error("Update Group IPC call received before group creation.");d.acceptGroupDtoUpdate(a),a.isActive&&(this._activeGroupId=a.groupId),this._onDidChangeTabGroups.fire(Object.freeze({changed:[d.apiObject],opened:[],closed:[]}))}$acceptTabOperation(a){const d=this._extHostTabGroups.find(i=>i.groupId===a.groupId);if(!d)throw new Error("Update Tabs IPC call received before group creation.");const l=d.acceptTabOperation(a);switch(a.kind){case A.TabModelOperationKind.TAB_OPEN:this._onDidChangeTabs.fire(Object.freeze({opened:[l.apiObject],closed:[],changed:[]}));return;case A.TabModelOperationKind.TAB_CLOSE:this._onDidChangeTabs.fire(Object.freeze({opened:[],closed:[l.apiObject],changed:[]}));return;case A.TabModelOperationKind.TAB_MOVE:case A.TabModelOperationKind.TAB_UPDATE:this._onDidChangeTabs.fire(Object.freeze({opened:[],closed:[],changed:[l.apiObject]}));return}}_findExtHostTabFromApi(a){for(const d of this._extHostTabGroups)for(const l of d.tabs)if(l.apiObject===a)return l}_findExtHostTabGroupFromApi(a){return this._extHostTabGroups.find(d=>d.apiObject===a)}async _closeTabs(a,d){const l=[];for(const i of a){const n=this._findExtHostTabFromApi(i);if(!n)throw new Error("Tab close: Invalid tab not found!");l.push(n.tabId)}return this._proxy.$closeTab(l,d)}async _closeGroups(a,d){const l=[];for(const i of a){const n=this._findExtHostTabGroupFromApi(i);if(!n)throw new Error("Group close: Invalid group not found!");l.push(n.groupId)}return this._proxy.$closeGroup(l,d)}};e.ExtHostEditorTabs=C,e.ExtHostEditorTabs=C=qe([We(0,m.IExtHostRpcService)],C);function v(r){return r.tabs!==void 0}}),define(ke[241],Re([1,0,2,5,28,4,7,8,285,13,30,20,21,59]),function(Ee,e,S,T,D,O,k,A,m,s,I,E,u,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0,D=Ve(D),A=Ve(A);class v{constructor(){this._schemes=[]}add(d){this._stateMachine=void 0,this._schemes.push(d)}delete(d){const l=this._schemes.indexOf(d);l>=0&&(this._schemes.splice(l,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const d=this._schemes.sort(),l=[];let i,n,t=m.State.LastKnownState,o=m.State.LastKnownState;for(const c of d){let g=i?(0,s.commonPrefixLength)(i,c):0;for(g===0?n=m.State.Start:n=o;g<c.length;g++)g+1===c.length?(t=o,o=m.State.BeforeColon):o+=1,l.push([n,c.toUpperCase().charCodeAt(g),o]),l.push([n,c.toLowerCase().charCodeAt(g),o]),n=o;i=c,o=t}l.push([m.State.BeforeColon,I.CharCode.Colon,m.State.AfterColon]),l.push([m.State.AfterColon,I.CharCode.Slash,m.State.End]),this._stateMachine=new m.StateMachine(l)}}provideDocumentLinks(d){this._initStateMachine();const l=[],i=m.LinkComputer.computeLinks({getLineContent(n){return d.lineAt(n-1).text},getLineCount(){return d.lineCount}},this._stateMachine);for(const n of i){const t=A.DocumentLink.to(n);t.target&&l.push(t)}return l}}class r{constructor(d,l){this._extHostLanguageFeatures=l,this._linkProvider=new v,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=d.getProxy(T.MainContext.MainThreadFileSystem)}dispose(){this._linkProviderRegistration?.dispose()}registerFileSystemProvider(d,l,i,n={}){if(r._validateFileSystemProvider(i),this._registeredSchemes.has(l))throw new Error(`a provider for the scheme '${l}' is already registered`);this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(d,"*",this._linkProvider));const t=this._handlePool++;this._linkProvider.add(l),this._registeredSchemes.add(l),this._fsProvider.set(t,i);let o=D.FileSystemProviderCapabilities.FileReadWrite;n.isCaseSensitive&&(o+=D.FileSystemProviderCapabilities.PathCaseSensitive),n.isReadonly&&(o+=D.FileSystemProviderCapabilities.Readonly),typeof i.copy=="function"&&(o+=D.FileSystemProviderCapabilities.FileFolderCopy),typeof i.open=="function"&&typeof i.close=="function"&&typeof i.read=="function"&&typeof i.write=="function"&&((0,u.checkProposedApiEnabled)(d,"fsChunks"),o+=D.FileSystemProviderCapabilities.FileOpenReadWriteClose);let c;n.isReadonly&&(0,C.isMarkdownString)(n.isReadonly)&&n.isReadonly.value!==""&&(c={value:n.isReadonly.value,isTrusted:n.isReadonly.isTrusted,supportThemeIcons:n.isReadonly.supportThemeIcons,supportHtml:n.isReadonly.supportHtml,baseUri:n.isReadonly.baseUri,uris:n.isReadonly.uris}),this._proxy.$registerFileSystemProvider(t,l,o,c).catch(f=>{console.error(`FAILED to register filesystem provider of ${d.identifier.value}-extension for the scheme ${l}`),console.error(f)});const g=i.onDidChangeFile(f=>{const h=[];for(const _ of f){const{uri:y,type:w}=_;if(y.scheme!==l)continue;let P;switch(w){case k.FileChangeType.Changed:P=D.FileChangeType.UPDATED;break;case k.FileChangeType.Created:P=D.FileChangeType.ADDED;break;case k.FileChangeType.Deleted:P=D.FileChangeType.DELETED;break;default:throw new Error("Unknown FileChangeType")}h.push({resource:y,type:P})}this._proxy.$onFileSystemChange(t,h)});return(0,O.toDisposable)(()=>{g.dispose(),this._linkProvider.delete(l),this._registeredSchemes.delete(l),this._fsProvider.delete(t),this._proxy.$unregisterProvider(t)})}static _validateFileSystemProvider(d){if(!d)throw new Error("MISSING provider");if(typeof d.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof d.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof d.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof d.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof d.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof d.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof d.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof d.rename!="function")throw new Error("Provider does NOT implement rename")}static _asIStat(d){const{type:l,ctime:i,mtime:n,size:t,permissions:o}=d;return{type:l,ctime:i,mtime:n,size:t,permissions:o}}$stat(d,l){return Promise.resolve(this._getFsProvider(d).stat(S.URI.revive(l))).then(i=>r._asIStat(i))}$readdir(d,l){return Promise.resolve(this._getFsProvider(d).readDirectory(S.URI.revive(l)))}$readFile(d,l){return Promise.resolve(this._getFsProvider(d).readFile(S.URI.revive(l))).then(i=>E.VSBuffer.wrap(i))}$writeFile(d,l,i,n){return Promise.resolve(this._getFsProvider(d).writeFile(S.URI.revive(l),i.buffer,n))}$delete(d,l,i){return Promise.resolve(this._getFsProvider(d).delete(S.URI.revive(l),i))}$rename(d,l,i,n){return Promise.resolve(this._getFsProvider(d).rename(S.URI.revive(l),S.URI.revive(i),n))}$copy(d,l,i,n){const t=this._getFsProvider(d);if(!t.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(t.copy(S.URI.revive(l),S.URI.revive(i),n))}$mkdir(d,l){return Promise.resolve(this._getFsProvider(d).createDirectory(S.URI.revive(l)))}$watch(d,l,i,n){const t=this._getFsProvider(d).watch(S.URI.revive(i),n);this._watches.set(l,t)}$unwatch(d,l){const i=this._watches.get(l);i&&(i.dispose(),this._watches.delete(l))}$open(d,l,i){const n=this._getFsProvider(d);if(!n.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(n.open(S.URI.revive(l),i))}$close(d,l){const i=this._getFsProvider(d);if(!i.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(i.close(l))}$read(d,l,i,n){const t=this._getFsProvider(d);if(!t.read)throw new Error('FileSystemProvider does not implement "read"');const o=E.VSBuffer.alloc(n);return Promise.resolve(t.read(l,i,o.buffer,0,n)).then(c=>o.slice(0,c))}$write(d,l,i,n){const t=this._getFsProvider(d);if(!t.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(t.write(l,i,n.buffer,0,n.byteLength))}_getFsProvider(d){const l=this._fsProvider.get(d);if(!l){const i=new Error;throw i.name="ENOPRO",i.message="no provider",i}return l}}e.ExtHostFileSystem=r}),define(ke[242],Re([1,0,6,43,2,5,8,7,28,51]),function(Ee,e,S,T,D,O,k,A,m,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0,k=Ve(k);class I{get ignoreCreateEvents(){return!!(this._config&1)}get ignoreChangeEvents(){return!!(this._config&2)}get ignoreDeleteEvents(){return!!(this._config&4)}constructor(v,r,a,d,l,i){this.session=Math.random(),this._onDidCreate=new S.Emitter,this._onDidChange=new S.Emitter,this._onDidDelete=new S.Emitter,this._config=0,i?.ignoreCreateEvents&&(this._config+=1),i?.ignoreChangeEvents&&(this._config+=2),i?.ignoreDeleteEvents&&(this._config+=4);const n=(0,T.parse)(l),t=typeof l=="string",o=i?.correlate,c=d(g=>{if(!(typeof g.session=="number"&&g.session!==this.session)&&!(o&&typeof g.session>"u")){if(!i?.ignoreCreateEvents)for(const f of g.created){const h=D.URI.revive(f);n(h.fsPath)&&(!t||r.getWorkspaceFolder(h))&&this._onDidCreate.fire(h)}if(!i?.ignoreChangeEvents)for(const f of g.changed){const h=D.URI.revive(f);n(h.fsPath)&&(!t||r.getWorkspaceFolder(h))&&this._onDidChange.fire(h)}if(!i?.ignoreDeleteEvents)for(const f of g.deleted){const h=D.URI.revive(f);n(h.fsPath)&&(!t||r.getWorkspaceFolder(h))&&this._onDidDelete.fire(h)}}});this._disposable=A.Disposable.from(this.ensureWatching(v,a,l,i,i?.correlate),this._onDidCreate,this._onDidChange,this._onDidDelete,c)}ensureWatching(v,r,a,d,l){const i=A.Disposable.from();if(typeof a=="string"||d?.ignoreChangeEvents&&d?.ignoreCreateEvents&&d?.ignoreDeleteEvents)return i;const n=v.getProxy(O.MainContext.MainThreadFileSystemEventService);let t=!1;(a.pattern.includes(T.GLOBSTAR)||a.pattern.includes(T.GLOB_SPLIT))&&(t=!0);let o;return l&&(d?.ignoreChangeEvents||d?.ignoreCreateEvents||d?.ignoreDeleteEvents)&&(o=m.FileChangeFilter.UPDATED|m.FileChangeFilter.ADDED|m.FileChangeFilter.DELETED,d?.ignoreChangeEvents&&(o&=~m.FileChangeFilter.UPDATED),d?.ignoreCreateEvents&&(o&=~m.FileChangeFilter.ADDED),d?.ignoreDeleteEvents&&(o&=~m.FileChangeFilter.DELETED)),n.$watch(r.identifier.value,this.session,a.baseUri,{recursive:t,excludes:d?.excludes??[],filter:o},!!l),A.Disposable.from({dispose:()=>n.$unwatch(this.session)})}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class E{constructor(v){this._events=v,this.session=this._events.session,this._created=new s.Lazy(()=>this._events.created.map(D.URI.revive)),this._changed=new s.Lazy(()=>this._events.changed.map(D.URI.revive)),this._deleted=new s.Lazy(()=>this._events.deleted.map(D.URI.revive))}get created(){return this._created.value}get changed(){return this._changed.value}get deleted(){return this._deleted.value}}class u{constructor(v,r,a){this._mainContext=v,this._logService=r,this._extHostDocumentsAndEditors=a,this._onFileSystemEvent=new S.Emitter,this._onDidRenameFile=new S.Emitter,this._onDidCreateFile=new S.Emitter,this._onDidDeleteFile=new S.Emitter,this._onWillRenameFile=new S.AsyncEmitter,this._onWillCreateFile=new S.AsyncEmitter,this._onWillDeleteFile=new S.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(v,r,a,d){return new I(this._mainContext,v,r,this._onFileSystemEvent.event,k.GlobPattern.from(a),d)}$onFileEvent(v){this._onFileSystemEvent.fire(new E(v))}$onDidRunFileOperation(v,r){switch(v){case m.FileOperation.MOVE:this._onDidRenameFile.fire(Object.freeze({files:r.map(a=>({oldUri:D.URI.revive(a.source),newUri:D.URI.revive(a.target)}))}));break;case m.FileOperation.DELETE:this._onDidDeleteFile.fire(Object.freeze({files:r.map(a=>D.URI.revive(a.target))}));break;case m.FileOperation.CREATE:case m.FileOperation.COPY:this._onDidCreateFile.fire(Object.freeze({files:r.map(a=>D.URI.revive(a.target))}));break;default:}}getOnWillRenameFileEvent(v){return this._createWillExecuteEvent(v,this._onWillRenameFile)}getOnWillCreateFileEvent(v){return this._createWillExecuteEvent(v,this._onWillCreateFile)}getOnWillDeleteFileEvent(v){return this._createWillExecuteEvent(v,this._onWillDeleteFile)}_createWillExecuteEvent(v,r){return(a,d,l)=>{const i=function(t){a.call(d,t)};return i.extension=v,r.event(i,void 0,l)}}async $onWillRunFileOperation(v,r,a,d){switch(v){case m.FileOperation.MOVE:return await this._fireWillEvent(this._onWillRenameFile,{files:r.map(l=>({oldUri:D.URI.revive(l.source),newUri:D.URI.revive(l.target)}))},a,d);case m.FileOperation.DELETE:return await this._fireWillEvent(this._onWillDeleteFile,{files:r.map(l=>D.URI.revive(l.target))},a,d);case m.FileOperation.CREATE:case m.FileOperation.COPY:return await this._fireWillEvent(this._onWillCreateFile,{files:r.map(l=>D.URI.revive(l.target))},a,d)}}async _fireWillEvent(v,r,a,d){const l=new Set,i=[];if(await v.fireAsync(r,d,async(t,o)=>{const c=Date.now(),g=await Promise.resolve(t);g instanceof A.WorkspaceEdit&&(i.push([o.extension,g]),l.add(o.extension.displayName??o.extension.identifier.value)),Date.now()-c>a&&this._logService.warn("SLOW file-participant",o.extension.identifier)}),d.isCancellationRequested||i.length===0)return;const n={edits:[]};for(const[,t]of i){const{edits:o}=k.WorkspaceEdit.from(t,{getTextDocumentVersion:c=>this._extHostDocumentsAndEditors.getDocument(c)?.version,getNotebookDocumentVersion:()=>{}});n.edits=n.edits.concat(o)}return{edit:n,extensionNames:Array.from(l)}}}e.ExtHostFileSystemEventService=u}),define(ke[243],Re([1,0,17,10,19,12,97,4,25,69,13,14,2,32,286,94,104,9,18,8,7,21,80,5]),function(Ee,e,S,T,D,O,k,A,m,s,I,E,u,C,v,r,a,d,l,i,n,t,o,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=void 0,r=Ve(r),i=Ve(i),c=Ve(c);class g{constructor(B,z){this._documents=B,this._provider=z}async provideDocumentSymbols(B,z){const H=this._documents.getDocument(B),q=await this._provider.provideDocumentSymbols(H,z);if(!(0,S.isFalsyOrEmpty)(q))return q[0]instanceof n.DocumentSymbol?q.map(i.DocumentSymbol.from):g._asDocumentSymbolTree(q)}static _asDocumentSymbolTree(B){B=B.slice(0).sort((q,se)=>{let ge=q.location.range.start.compareTo(se.location.range.start);return ge===0&&(ge=se.location.range.end.compareTo(q.location.range.end)),ge});const z=[],H=[];for(const q of B){const se={name:q.name||"!!MISSING: name!!",kind:i.SymbolKind.from(q.kind),tags:q.tags?.map(i.SymbolTag.from)||[],detail:"",containerName:q.containerName,range:i.Range.from(q.location.range),selectionRange:i.Range.from(q.location.range),children:[]};for(;;){if(H.length===0){H.push(se),z.push(se);break}const ge=H[H.length-1];if(C.Range.containsRange(ge.range,se.range)&&!C.Range.equalsRange(ge.range,se.range)){ge.children?.push(se),H.push(se);break}H.pop()}}return z}}class f{constructor(B,z,H,q,se,ge){this._documents=B,this._commands=z,this._provider=H,this._extension=q,this._extTelemetry=se,this._logService=ge,this._cache=new o.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(B,z){const H=this._documents.getDocument(B),q=await this._provider.provideCodeLenses(H,z);if(!q||z.isCancellationRequested)return;const se=this._cache.add(q),ge=new A.DisposableStore;this._disposables.set(se,ge);const ye={cacheId:se,lenses:[]};for(let Ue=0;Ue<q.length;Ue++)ye.lenses.push({cacheId:[se,Ue],range:i.Range.from(q[Ue].range),command:this._commands.toInternal(q[Ue].command,ge)});return ye}async resolveCodeLens(B,z){const H=B.cacheId&&this._cache.get(...B.cacheId);if(!H)return;let q;if(typeof this._provider.resolveCodeLens!="function"||H.isResolved?q=H:q=await this._provider.resolveCodeLens(H,z),q||(q=H),z.isCancellationRequested)return;const se=B.cacheId&&this._disposables.get(B.cacheId[0]);if(se){if(!q.command){const ge=new Error("INVALID code lens resolved, lacks command: "+this._extension.identifier.value);this._extTelemetry.onExtensionError(this._extension.identifier,ge),this._logService.error(ge);return}return B.command=this._commands.toInternal(q.command,se),B}}releaseCodeLenses(B){this._disposables.get(B)?.dispose(),this._disposables.delete(B),this._cache.delete(B)}}function h(Ne){return Array.isArray(Ne)?Ne.map(i.DefinitionLink.from):Ne?[i.DefinitionLink.from(Ne)]:[]}class _{constructor(B,z){this._documents=B,this._provider=z}async provideDefinition(B,z,H){const q=this._documents.getDocument(B),se=i.Position.to(z),ge=await this._provider.provideDefinition(q,se,H);return h(ge)}}class y{constructor(B,z){this._documents=B,this._provider=z}async provideDeclaration(B,z,H){const q=this._documents.getDocument(B),se=i.Position.to(z),ge=await this._provider.provideDeclaration(q,se,H);return h(ge)}}class w{constructor(B,z){this._documents=B,this._provider=z}async provideImplementation(B,z,H){const q=this._documents.getDocument(B),se=i.Position.to(z),ge=await this._provider.provideImplementation(q,se,H);return h(ge)}}class P{constructor(B,z){this._documents=B,this._provider=z}async provideTypeDefinition(B,z,H){const q=this._documents.getDocument(B),se=i.Position.to(z),ge=await this._provider.provideTypeDefinition(q,se,H);return h(ge)}}class R{static{this.HOVER_MAP_MAX_SIZE=10}constructor(B,z){this._documents=B,this._provider=z,this._hoverCounter=0,this._hoverMap=new Map}async provideHover(B,z,H,q){const se=this._documents.getDocument(B),ge=i.Position.to(z);let ye;if(H&&H.verbosityRequest){const tt=H.verbosityRequest.previousHover.id,lt=this._hoverMap.get(tt);if(!lt)throw new Error(`Hover with id ${tt} not found`);const it={verbosityDelta:H.verbosityRequest.verbosityDelta,previousHover:lt};ye=await this._provider.provideHover(se,ge,q,it)}else ye=await this._provider.provideHover(se,ge,q);if(!ye||(0,S.isFalsyOrEmpty)(ye.contents))return;ye.range||(ye.range=se.getWordRangeAtPosition(ge)),ye.range||(ye.range=new n.Range(ge,ge));const Ue=i.Hover.from(ye),Ge=this._hoverCounter;if(this._hoverMap.size===R.HOVER_MAP_MAX_SIZE){const tt=Math.min(...this._hoverMap.keys());this._hoverMap.delete(tt)}return this._hoverMap.set(Ge,ye),this._hoverCounter+=1,{...Ue,id:Ge}}releaseHover(B){this._hoverMap.delete(B)}}class p{constructor(B,z){this._documents=B,this._provider=z}async provideEvaluatableExpression(B,z,H){const q=this._documents.getDocument(B),se=i.Position.to(z),ge=await this._provider.provideEvaluatableExpression(q,se,H);if(ge)return i.EvaluatableExpression.from(ge)}}class b{constructor(B,z){this._documents=B,this._provider=z}async provideInlineValues(B,z,H,q){const se=this._documents.getDocument(B),ge=await this._provider.provideInlineValues(se,i.Range.to(z),i.InlineValueContext.to(H),q);if(Array.isArray(ge))return ge.map(ye=>i.InlineValue.from(ye))}}class N{constructor(B,z){this._documents=B,this._provider=z}async provideDocumentHighlights(B,z,H){const q=this._documents.getDocument(B),se=i.Position.to(z),ge=await this._provider.provideDocumentHighlights(q,se,H);if(Array.isArray(ge))return ge.map(i.DocumentHighlight.from)}}class L{constructor(B,z){this._documents=B,this._provider=z}async provideMultiDocumentHighlights(B,z,H,q){const se=this._documents.getDocument(B),ge=H.map(Ge=>this._documents.getDocument(Ge)),ye=i.Position.to(z),Ue=await this._provider.provideMultiDocumentHighlights(se,ye,ge,q);if(Array.isArray(Ue))return Ue.map(i.MultiDocumentHighlight.from)}}class F{constructor(B,z){this._documents=B,this._provider=z}async provideLinkedEditingRanges(B,z,H){const q=this._documents.getDocument(B),se=i.Position.to(z),ge=await this._provider.provideLinkedEditingRanges(q,se,H);if(ge&&Array.isArray(ge.ranges))return{ranges:(0,S.coalesce)(ge.ranges.map(i.Range.from)),wordPattern:ge.wordPattern}}}class K{constructor(B,z){this._documents=B,this._provider=z}async provideReferences(B,z,H,q){const se=this._documents.getDocument(B),ge=i.Position.to(z),ye=await this._provider.provideReferences(se,ge,H,q);if(Array.isArray(ye))return ye.map(i.location.from)}}class J{static{this._maxCodeActionsPerFile=1e3}constructor(B,z,H,q,se,ge,ye){this._documents=B,this._commands=z,this._diagnostics=H,this._provider=q,this._logService=se,this._extension=ge,this._apiDeprecation=ye,this._cache=new o.Cache("CodeAction"),this._disposables=new Map}async provideCodeActions(B,z,H,q){const se=this._documents.getDocument(B),ge=v.Selection.isISelection(z)?i.Selection.to(z):i.Range.to(z),ye=[];for(const it of this._diagnostics.getDiagnostics(B))if(ge.intersection(it.range)&&ye.push(it)>J._maxCodeActionsPerFile)break;const Ue={diagnostics:ye,only:H.only?new n.CodeActionKind(H.only):void 0,triggerKind:i.CodeActionTriggerKind.to(H.trigger)},Ge=await this._provider.provideCodeActions(se,ge,Ue,q);if(!(0,S.isNonEmptyArray)(Ge)||q.isCancellationRequested)return;const Ze=this._cache.add(Ge),tt=new A.DisposableStore;this._disposables.set(Ze,tt);const lt=[];for(let it=0;it<Ge.length;it++){const at=Ge[it];if(at)if(J._isCommand(at))this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),lt.push({_isSynthetic:!0,title:at.title,command:this._commands.toInternal(at,tt)});else{Ue.only&&(at.kind?Ue.only.contains(at.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Ue.only.value}' requested but returned code action is of kind '${at.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Ue.only.value}' requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`));const wt=at.ranges??[];lt.push({cacheId:[Ze,it],title:at.title,command:at.command&&this._commands.toInternal(at.command,tt),diagnostics:at.diagnostics&&at.diagnostics.map(i.Diagnostic.from),edit:at.edit&&i.WorkspaceEdit.from(at.edit,void 0),kind:at.kind&&at.kind.value,isPreferred:at.isPreferred,isAI:(0,t.isProposedApiEnabled)(this._extension,"codeActionAI")?at.isAI:!1,ranges:(0,t.isProposedApiEnabled)(this._extension,"codeActionRanges")?(0,S.coalesce)(wt.map(i.Range.from)):void 0,disabled:at.disabled?.reason})}}return{cacheId:Ze,actions:lt}}async resolveCodeAction(B,z){const[H,q]=B,se=this._cache.get(H,q);if(!se||J._isCommand(se))return{};if(!this._provider.resolveCodeAction)return{};const ge=await this._provider.resolveCodeAction(se,z)??se;let ye;ge.edit&&(ye=i.WorkspaceEdit.from(ge.edit,void 0));let Ue;if(ge.command){const Ge=this._disposables.get(H);Ge&&(Ue=this._commands.toInternal(ge.command,Ge))}return{edit:ye,command:Ue}}releaseCodeActions(B){this._disposables.get(B)?.dispose(),this._disposables.delete(B),this._cache.delete(B)}static _isCommand(B){return typeof B.command=="string"&&typeof B.title=="string"}}class ${constructor(B,z,H,q,se){this._proxy=B,this._documents=z,this._provider=H,this._handle=q,this._extension=se,this._cache=new o.Cache("DocumentPasteEdit")}async prepareDocumentPaste(B,z,H,q){if(!this._provider.prepareDocumentPaste)return;const se=this._documents.getDocument(B),ge=z.map(Ge=>i.Range.to(Ge)),ye=i.DataTransfer.toDataTransfer(H,()=>{throw new O.NotImplementedError});if(await this._provider.prepareDocumentPaste(se,ge,ye,q),q.isCancellationRequested)return;const Ue=Array.from(ye).filter(([,Ge])=>!(Ge instanceof n.InternalDataTransferItem));return i.DataTransfer.from(Ue)}async providePasteEdits(B,z,H,q,se,ge){if(!this._provider.provideDocumentPasteEdits)return[];const ye=this._documents.getDocument(z),Ue=H.map(lt=>i.Range.to(lt)),Ge=i.DataTransfer.toDataTransfer(q,async lt=>(await this._proxy.$resolvePasteFileData(this._handle,B,lt)).buffer),Ze=await this._provider.provideDocumentPasteEdits(ye,Ue,Ge,{only:se.only?new n.DocumentDropOrPasteEditKind(se.only):void 0,triggerKind:se.triggerKind},ge);if(!Ze||ge.isCancellationRequested)return[];const tt=this._cache.add(Ze);return Ze.map((lt,it)=>({_cacheId:[tt,it],title:lt.title??(0,d.localize)(2703,null,this._extension.displayName||this._extension.name),kind:lt.kind,yieldTo:lt.yieldTo?.map(at=>at.value),insertText:typeof lt.insertText=="string"?lt.insertText:{snippet:lt.insertText.value},additionalEdit:lt.additionalEdit?i.WorkspaceEdit.from(lt.additionalEdit,void 0):void 0}))}async resolvePasteEdit(B,z){const[H,q]=B,se=this._cache.get(H,q);if(!se||!this._provider.resolveDocumentPasteEdit)return{};const ge=await this._provider.resolveDocumentPasteEdit(se,z)??se;return{additionalEdit:ge.additionalEdit?i.WorkspaceEdit.from(ge.additionalEdit,void 0):void 0}}releasePasteEdits(B){this._cache.delete(B)}}class x{constructor(B,z){this._documents=B,this._provider=z}async provideDocumentFormattingEdits(B,z,H){const q=this._documents.getDocument(B),se=await this._provider.provideDocumentFormattingEdits(q,z,H);if(Array.isArray(se))return se.map(i.TextEdit.from)}}class G{constructor(B,z){this._documents=B,this._provider=z}async provideDocumentRangeFormattingEdits(B,z,H,q){const se=this._documents.getDocument(B),ge=i.Range.to(z),ye=await this._provider.provideDocumentRangeFormattingEdits(se,ge,H,q);if(Array.isArray(ye))return ye.map(i.TextEdit.from)}async provideDocumentRangesFormattingEdits(B,z,H,q){(0,E.assertType)(typeof this._provider.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const se=this._documents.getDocument(B),ge=z.map(i.Range.to),ye=await this._provider.provideDocumentRangesFormattingEdits(se,ge,H,q);if(Array.isArray(ye))return ye.map(i.TextEdit.from)}}class Y{constructor(B,z){this._documents=B,this._provider=z,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(B,z,H,q,se){const ge=this._documents.getDocument(B),ye=i.Position.to(z),Ue=await this._provider.provideOnTypeFormattingEdits(ge,ye,H,q,se);if(Array.isArray(Ue))return Ue.map(i.TextEdit.from)}}class ae{constructor(B,z){this._provider=B,this._logService=z,this._cache=new o.Cache("WorkspaceSymbols")}async provideWorkspaceSymbols(B,z){const H=await this._provider.provideWorkspaceSymbols(B,z);if(!(0,S.isNonEmptyArray)(H))return{symbols:[]};const q=this._cache.add(H),se={cacheId:q,symbols:[]};for(let ge=0;ge<H.length;ge++){const ye=H[ge];if(!ye||!ye.name){this._logService.warn("INVALID SymbolInformation",ye);continue}se.symbols.push({...i.WorkspaceSymbol.from(ye),cacheId:[q,ge]})}return se}async resolveWorkspaceSymbol(B,z){if(typeof this._provider.resolveWorkspaceSymbol!="function"||!B.cacheId)return B;const H=this._cache.get(...B.cacheId);if(H){const q=await this._provider.resolveWorkspaceSymbol(H,z);return q&&(0,m.mixin)(B,i.WorkspaceSymbol.from(q),!0)}}releaseWorkspaceSymbols(B){this._cache.delete(B)}}class ee{static supportsResolving(B){return typeof B.prepareRename=="function"}constructor(B,z,H){this._documents=B,this._provider=z,this._logService=H}async provideRenameEdits(B,z,H,q){const se=this._documents.getDocument(B),ge=i.Position.to(z);try{const ye=await this._provider.provideRenameEdits(se,ge,H,q);return ye?i.WorkspaceEdit.from(ye):void 0}catch(ye){const Ue=ee._asMessage(ye);return Ue?{rejectReason:Ue,edits:void 0}:Promise.reject(ye)}}async resolveRenameLocation(B,z,H){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const q=this._documents.getDocument(B),se=i.Position.to(z);try{const ge=await this._provider.prepareRename(q,se,H);let ye,Ue;if(n.Range.isRange(ge)?(ye=ge,Ue=q.getText(ge)):(0,E.isObject)(ge)&&(ye=ge.range,Ue=ge.placeholder),!ye||!Ue)return;if(ye.start.line>se.line||ye.end.line<se.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:i.Range.from(ye),text:Ue}}catch(ge){const ye=ee._asMessage(ge);return ye?{rejectReason:ye,range:void 0,text:void 0}:Promise.reject(ge)}}static _asMessage(B){return typeof B=="string"?B:B instanceof Error&&typeof B.message=="string"?B.message:void 0}}class oe{static{this.languageTriggerKindToVSCodeTriggerKind={[r.NewSymbolNameTriggerKind.Invoke]:n.NewSymbolNameTriggerKind.Invoke,[r.NewSymbolNameTriggerKind.Automatic]:n.NewSymbolNameTriggerKind.Automatic}}constructor(B,z,H){this._documents=B,this._provider=z,this._logService=H}async supportsAutomaticNewSymbolNamesTriggerKind(){return this._provider.supportsAutomaticTriggerKind}async provideNewSymbolNames(B,z,H,q){const se=this._documents.getDocument(B),ge=i.Range.to(z);try{const ye=oe.languageTriggerKindToVSCodeTriggerKind[H],Ue=await this._provider.provideNewSymbolNames(se,ge,ye,q);return Ue?Ue.map(Ge=>typeof Ge=="string"?{newSymbolName:Ge}:{newSymbolName:Ge.newSymbolName,tags:Ge.tags}):void 0}catch(ye){this._logService.error(oe._asMessage(ye)??JSON.stringify(ye,null,"	"));return}}static _asMessage(B){return typeof B=="string"?B:B instanceof Error&&typeof B.message=="string"?B.message:void 0}}class ie{constructor(B,z){this.resultId=B,this.tokens=z}}class ue{constructor(B,z){this._documents=B,this._provider=z,this._nextResultId=1,this._previousResults=new Map}async provideDocumentSemanticTokens(B,z,H){const q=this._documents.getDocument(B),se=z!==0?this._previousResults.get(z):null;let ge=typeof se?.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?await this._provider.provideDocumentSemanticTokensEdits(q,se.resultId,H):await this._provider.provideDocumentSemanticTokens(q,H);return se&&this._previousResults.delete(z),ge?(ge=ue._fixProvidedSemanticTokens(ge),this._send(ue._convertToEdits(se,ge),ge)):null}async releaseDocumentSemanticColoring(B){this._previousResults.delete(B)}static _fixProvidedSemanticTokens(B){return ue._isSemanticTokens(B)?ue._isCorrectSemanticTokens(B)?B:new n.SemanticTokens(new Uint32Array(B.data),B.resultId):ue._isSemanticTokensEdits(B)?ue._isCorrectSemanticTokensEdits(B)?B:new n.SemanticTokensEdits(B.edits.map(z=>new n.SemanticTokensEdit(z.start,z.deleteCount,z.data?new Uint32Array(z.data):z.data)),B.resultId):B}static _isSemanticTokens(B){return B&&!!B.data}static _isCorrectSemanticTokens(B){return B.data instanceof Uint32Array}static _isSemanticTokensEdits(B){return B&&Array.isArray(B.edits)}static _isCorrectSemanticTokensEdits(B){for(const z of B.edits)if(!(z.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(B,z){if(!ue._isSemanticTokens(z)||!B||!B.tokens)return z;const H=B.tokens,q=H.length,se=z.data,ge=se.length;let ye=0;const Ue=Math.min(q,ge);for(;ye<Ue&&H[ye]===se[ye];)ye++;if(ye===q&&ye===ge)return new n.SemanticTokensEdits([],z.resultId);let Ge=0;const Ze=Ue-ye;for(;Ge<Ze&&H[q-Ge-1]===se[ge-Ge-1];)Ge++;return new n.SemanticTokensEdits([{start:ye,deleteCount:q-ye-Ge,data:se.subarray(ye,ge-Ge)}],z.resultId)}_send(B,z){if(ue._isSemanticTokens(B)){const H=this._nextResultId++;return this._previousResults.set(H,new ie(B.resultId,B.data)),(0,a.encodeSemanticTokensDto)({id:H,type:"full",data:B.data})}if(ue._isSemanticTokensEdits(B)){const H=this._nextResultId++;return ue._isSemanticTokens(z)?this._previousResults.set(H,new ie(z.resultId,z.data)):this._previousResults.set(H,new ie(B.resultId)),(0,a.encodeSemanticTokensDto)({id:H,type:"delta",deltas:(B.edits||[]).map(q=>({start:q.start,deleteCount:q.deleteCount,data:q.data}))})}return null}}class Z{constructor(B,z){this._documents=B,this._provider=z}async provideDocumentRangeSemanticTokens(B,z,H){const q=this._documents.getDocument(B),se=await this._provider.provideDocumentRangeSemanticTokens(q,i.Range.to(z),H);return se?this._send(se):null}_send(B){return(0,a.encodeSemanticTokensDto)({id:0,type:"full",data:B.data})}}class ve{static supportsResolving(B){return typeof B.resolveCompletionItem=="function"}constructor(B,z,H,q,se){this._documents=B,this._commands=z,this._provider=H,this._apiDeprecation=q,this._extension=se,this._cache=new o.Cache("CompletionItem"),this._disposables=new Map}async provideCompletionItems(B,z,H,q){const se=this._documents.getDocument(B),ge=i.Position.to(z),ye=se.getWordRangeAtPosition(ge)||new n.Range(ge,ge),Ue=ye.with({end:ge}),Ge=new s.StopWatch,Ze=await this._provider.provideCompletionItems(se,ge,q,i.CompletionContext.to(H));if(!Ze||q.isCancellationRequested)return;const tt=Array.isArray(Ze)?new n.CompletionList(Ze):Ze,lt=ve.supportsResolving(this._provider)?this._cache.add(tt.items):this._cache.add([]),it=new A.DisposableStore;this._disposables.set(lt,it);const at=[],wt={x:lt,[c.ISuggestResultDtoField.completions]:at,[c.ISuggestResultDtoField.defaultRanges]:{replace:i.Range.from(ye),insert:i.Range.from(Ue)},[c.ISuggestResultDtoField.isIncomplete]:tt.isIncomplete||void 0,[c.ISuggestResultDtoField.duration]:Ge.elapsed()};for(let Qe=0;Qe<tt.items.length;Qe++){const de=tt.items[Qe],pe=this._convertCompletionItem(de,[lt,Qe],Ue,ye);at.push(pe)}return wt}async resolveCompletionItem(B,z){if(typeof this._provider.resolveCompletionItem!="function")return;const H=this._cache.get(...B);if(!H)return;const q=this._convertCompletionItem(H,B),se=await this._provider.resolveCompletionItem(H,z);if(!se)return;const ge=this._convertCompletionItem(se,B);return(q[c.ISuggestDataDtoField.insertText]!==ge[c.ISuggestDataDtoField.insertText]||q[c.ISuggestDataDtoField.insertTextRules]!==ge[c.ISuggestDataDtoField.insertTextRules])&&this._apiDeprecation.report("CompletionItem.insertText",this._extension,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(q[c.ISuggestDataDtoField.commandIdent]!==ge[c.ISuggestDataDtoField.commandIdent]||q[c.ISuggestDataDtoField.commandId]!==ge[c.ISuggestDataDtoField.commandId]||!(0,m.equals)(q[c.ISuggestDataDtoField.commandArguments],ge[c.ISuggestDataDtoField.commandArguments]))&&this._apiDeprecation.report("CompletionItem.command",this._extension,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...q,[c.ISuggestDataDtoField.documentation]:ge[c.ISuggestDataDtoField.documentation],[c.ISuggestDataDtoField.detail]:ge[c.ISuggestDataDtoField.detail],[c.ISuggestDataDtoField.additionalTextEdits]:ge[c.ISuggestDataDtoField.additionalTextEdits],[c.ISuggestDataDtoField.insertText]:ge[c.ISuggestDataDtoField.insertText],[c.ISuggestDataDtoField.insertTextRules]:ge[c.ISuggestDataDtoField.insertTextRules],[c.ISuggestDataDtoField.commandIdent]:ge[c.ISuggestDataDtoField.commandIdent],[c.ISuggestDataDtoField.commandId]:ge[c.ISuggestDataDtoField.commandId],[c.ISuggestDataDtoField.commandArguments]:ge[c.ISuggestDataDtoField.commandArguments]}}releaseCompletionItems(B){this._disposables.get(B)?.dispose(),this._disposables.delete(B),this._cache.delete(B)}_convertCompletionItem(B,z,H,q){const se=this._disposables.get(z[0]);if(!se)throw Error("DisposableStore is missing...");const ge=this._commands.toInternal(B.command,se),ye={x:z,[c.ISuggestDataDtoField.label]:B.label,[c.ISuggestDataDtoField.kind]:B.kind!==void 0?i.CompletionItemKind.from(B.kind):void 0,[c.ISuggestDataDtoField.kindModifier]:B.tags&&B.tags.map(i.CompletionItemTag.from),[c.ISuggestDataDtoField.detail]:B.detail,[c.ISuggestDataDtoField.documentation]:typeof B.documentation>"u"?void 0:i.MarkdownString.fromStrict(B.documentation),[c.ISuggestDataDtoField.sortText]:B.sortText!==B.label?B.sortText:void 0,[c.ISuggestDataDtoField.filterText]:B.filterText!==B.label?B.filterText:void 0,[c.ISuggestDataDtoField.preselect]:B.preselect||void 0,[c.ISuggestDataDtoField.insertTextRules]:B.keepWhitespace?r.CompletionItemInsertTextRule.KeepWhitespace:r.CompletionItemInsertTextRule.None,[c.ISuggestDataDtoField.commitCharacters]:B.commitCharacters?.join(""),[c.ISuggestDataDtoField.additionalTextEdits]:B.additionalTextEdits&&B.additionalTextEdits.map(i.TextEdit.from),[c.ISuggestDataDtoField.commandIdent]:ge?.$ident,[c.ISuggestDataDtoField.commandId]:ge?.id,[c.ISuggestDataDtoField.commandArguments]:ge?.$ident?void 0:ge?.arguments};B.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),ye[c.ISuggestDataDtoField.insertText]=B.textEdit.newText):typeof B.insertText=="string"?ye[c.ISuggestDataDtoField.insertText]=B.insertText:B.insertText instanceof n.SnippetString&&(ye[c.ISuggestDataDtoField.insertText]=B.insertText.value,ye[c.ISuggestDataDtoField.insertTextRules]|=r.CompletionItemInsertTextRule.InsertAsSnippet);let Ue;return B.textEdit?Ue=B.textEdit.range:B.range&&(Ue=B.range),n.Range.isRange(Ue)?ye[c.ISuggestDataDtoField.range]=i.Range.from(Ue):Ue&&(!H?.isEqual(Ue.inserting)||!q?.isEqual(Ue.replacing))&&(ye[c.ISuggestDataDtoField.range]={insert:i.Range.from(Ue.inserting),replace:i.Range.from(Ue.replacing)}),ye}}class Ie{async provideInlineCompletions(B,z,H,q){}async provideInlineEdits(B,z,H,q){}disposeCompletions(B){}handleDidShowCompletionItem(B,z,H){}handlePartialAccept(B,z,H,q){}}class X extends Ie{constructor(B,z,H,q){super(),this._extension=B,this._documents=z,this._provider=H,this._commands=q,this._references=new re,this._isAdditionsProposedApiEnabled=(0,t.isProposedApiEnabled)(this._extension,"inlineCompletionsAdditions"),this.languageTriggerKindToVSCodeTriggerKind={[r.InlineCompletionTriggerKind.Automatic]:n.InlineCompletionTriggerKind.Automatic,[r.InlineCompletionTriggerKind.Explicit]:n.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,t.isProposedApiEnabled)(this._extension,"inlineCompletionsAdditions")&&(typeof this._provider.handleDidShowCompletionItem=="function"||typeof this._provider.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(B,z,H,q){const se=this._documents.getDocument(B),ge=i.Position.to(z),ye=await this._provider.provideInlineCompletionItems(se,ge,{selectedCompletionInfo:H.selectedSuggestionInfo?{range:i.Range.to(H.selectedSuggestionInfo.range),text:H.selectedSuggestionInfo.text}:void 0,triggerKind:this.languageTriggerKindToVSCodeTriggerKind[H.triggerKind]},q);if(!ye||q.isCancellationRequested)return;const Ue=Array.isArray(ye)?ye:ye.items,Ge=this._isAdditionsProposedApiEnabled?Array.isArray(ye)?[]:ye.commands||[]:[],Ze=this._isAdditionsProposedApiEnabled&&!Array.isArray(ye)?ye.enableForwardStability:void 0;let tt;return{pid:this._references.createReferenceId({dispose(){tt?.dispose()},items:Ue}),items:Ue.map((it,at)=>{let wt;it.command&&(tt||(tt=new A.DisposableStore),wt=this._commands.toInternal(it.command,tt));const Qe=it.insertText;return{insertText:typeof Qe=="string"?Qe:{snippet:Qe.value},filterText:it.filterText,range:it.range?i.Range.from(it.range):void 0,command:wt,idx:at,completeBracketPairs:this._isAdditionsProposedApiEnabled?it.completeBracketPairs:!1}}),commands:Ge.map(it=>(tt||(tt=new A.DisposableStore),this._commands.toInternal(it,tt))),suppressSuggestions:!1,enableForwardStability:Ze}}async provideInlineEdits(B,z,H,q){if(!this._provider.provideInlineEdits)return;(0,t.checkProposedApiEnabled)(this._extension,"inlineCompletionsAdditions");const se=this._documents.getDocument(B),ge=i.Range.to(z),ye=await this._provider.provideInlineEdits(se,ge,{selectedCompletionInfo:H.selectedSuggestionInfo?{range:i.Range.to(H.selectedSuggestionInfo.range),text:H.selectedSuggestionInfo.text}:void 0,triggerKind:this.languageTriggerKindToVSCodeTriggerKind[H.triggerKind],userPrompt:H.userPrompt},q);if(!ye||q.isCancellationRequested)return;const Ue=Array.isArray(ye)?ye:ye.items,Ge=this._isAdditionsProposedApiEnabled?Array.isArray(ye)?[]:ye.commands||[]:[],Ze=this._isAdditionsProposedApiEnabled&&!Array.isArray(ye)?ye.enableForwardStability:void 0;let tt;return{pid:this._references.createReferenceId({dispose(){tt?.dispose()},items:Ue}),items:Ue.map((it,at)=>{let wt;it.command&&(tt||(tt=new A.DisposableStore),wt=this._commands.toInternal(it.command,tt));const Qe=it.insertText;return{insertText:typeof Qe=="string"?Qe:{snippet:Qe.value},filterText:it.filterText,range:it.range?i.Range.from(it.range):void 0,command:wt,idx:at,completeBracketPairs:this._isAdditionsProposedApiEnabled?it.completeBracketPairs:!1}}),commands:Ge.map(it=>(tt||(tt=new A.DisposableStore),this._commands.toInternal(it,tt))),suppressSuggestions:!1,enableForwardStability:Ze}}disposeCompletions(B){this._references.disposeReferenceId(B)?.dispose()}handleDidShowCompletionItem(B,z,H){const q=this._references.get(B)?.items[z];q&&this._provider.handleDidShowCompletionItem&&this._isAdditionsProposedApiEnabled&&this._provider.handleDidShowCompletionItem(q,H)}handlePartialAccept(B,z,H,q){const se=this._references.get(B)?.items[z];se&&this._provider.handleDidPartiallyAcceptCompletionItem&&this._isAdditionsProposedApiEnabled&&(this._provider.handleDidPartiallyAcceptCompletionItem(se,H),this._provider.handleDidPartiallyAcceptCompletionItem(se,i.PartialAcceptInfo.to(q)))}}class V{async provideInlineEdits(B,z,H){const q=this._documents.getDocument(B),se=await this._provider.provideInlineEdit(q,{triggerKind:this.languageTriggerKindToVSCodeTriggerKind[z.triggerKind]},H);if(!se||H.isCancellationRequested)return;let ge;const ye=this._references.createReferenceId({dispose(){ge?.dispose()},item:se});let Ue;se.accepted&&(ge||(ge=new A.DisposableStore),Ue=this._commands.toInternal(se.accepted,ge));let Ge;return se.rejected&&(ge||(ge=new A.DisposableStore),Ge=this._commands.toInternal(se.rejected,ge)),{pid:ye,text:se.text,range:i.Range.from(se.range),accepted:Ue,rejected:Ge}}disposeEdit(B){this._references.disposeReferenceId(B)?.dispose()}constructor(B,z,H,q){this._documents=z,this._provider=H,this._commands=q,this._references=new re,this.languageTriggerKindToVSCodeTriggerKind={[r.InlineEditTriggerKind.Automatic]:n.InlineEditTriggerKind.Automatic,[r.InlineEditTriggerKind.Invoke]:n.InlineEditTriggerKind.Invoke}}}class re{constructor(){this._references=new Map,this._idPool=1}createReferenceId(B){const z=this._idPool++;return this._references.set(z,B),z}disposeReferenceId(B){const z=this._references.get(B);return this._references.delete(B),z}get(B){return this._references.get(B)}}class be{constructor(B,z){this._documents=B,this._provider=z,this._cache=new o.Cache("SignatureHelp")}async provideSignatureHelp(B,z,H,q){const se=this._documents.getDocument(B),ge=i.Position.to(z),ye=this.reviveContext(H),Ue=await this._provider.provideSignatureHelp(se,ge,q,ye);if(Ue){const Ge=this._cache.add([Ue]);return{...i.SignatureHelp.from(Ue),id:Ge}}}reviveContext(B){let z;if(B.activeSignatureHelp){const H=i.SignatureHelp.to(B.activeSignatureHelp),q=this._cache.get(B.activeSignatureHelp.id,0);q?(z=q,z.activeSignature=H.activeSignature,z.activeParameter=H.activeParameter):z=H}return{...B,activeSignatureHelp:z}}releaseSignatureHelp(B){this._cache.delete(B)}}class De{constructor(B,z,H,q,se){this._documents=B,this._commands=z,this._provider=H,this._logService=q,this._extension=se,this._cache=new o.Cache("InlayHints"),this._disposables=new Map}async provideInlayHints(B,z,H){const q=this._documents.getDocument(B),se=i.Range.to(z),ge=await this._provider.provideInlayHints(q,se,H);if(!Array.isArray(ge)||ge.length===0){this._logService.trace(`[InlayHints] NO inlay hints from '${this._extension.identifier.value}' for range ${JSON.stringify(z)}`);return}if(H.isCancellationRequested)return;const ye=this._cache.add(ge);this._disposables.set(ye,new A.DisposableStore);const Ue={hints:[],cacheId:ye};for(let Ge=0;Ge<ge.length;Ge++)this._isValidInlayHint(ge[Ge],se)&&Ue.hints.push(this._convertInlayHint(ge[Ge],[ye,Ge]));return this._logService.trace(`[InlayHints] ${Ue.hints.length} inlay hints from '${this._extension.identifier.value}' for range ${JSON.stringify(z)}`),Ue}async resolveInlayHint(B,z){if(typeof this._provider.resolveInlayHint!="function")return;const H=this._cache.get(...B);if(!H)return;const q=await this._provider.resolveInlayHint(H,z);if(q&&this._isValidInlayHint(q))return this._convertInlayHint(q,B)}releaseHints(B){this._disposables.get(B)?.dispose(),this._disposables.delete(B),this._cache.delete(B)}_isValidInlayHint(B,z){return B.label.length===0||Array.isArray(B.label)&&B.label.every(H=>H.value.length===0)?(console.log("INVALID inlay hint, empty label",B),!1):!(z&&!z.contains(B.position))}_convertInlayHint(B,z){const H=this._disposables.get(z[0]);if(!H)throw Error("DisposableStore is missing...");const q={label:"",cacheId:z,tooltip:i.MarkdownString.fromStrict(B.tooltip),position:i.Position.from(B.position),textEdits:B.textEdits&&B.textEdits.map(i.TextEdit.from),kind:B.kind&&i.InlayHintKind.from(B.kind),paddingLeft:B.paddingLeft,paddingRight:B.paddingRight};if(typeof B.label=="string")q.label=B.label;else{const se=[];q.label=se;for(const ge of B.label){if(!ge.value){console.warn("INVALID inlay hint, empty label part",this._extension.identifier.value);continue}const ye={label:ge.value,tooltip:i.MarkdownString.fromStrict(ge.tooltip)};n.Location.isLocation(ge.location)&&(ye.location=i.location.from(ge.location)),ge.command&&(ye.command=this._commands.toInternal(ge.command,H)),se.push(ye)}}return q}}class Fe{constructor(B,z){this._documents=B,this._provider=z,this._cache=new o.Cache("DocumentLink")}async provideLinks(B,z){const H=this._documents.getDocument(B),q=await this._provider.provideDocumentLinks(H,z);if(!(!Array.isArray(q)||q.length===0)&&!z.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:q.filter(Fe._validateLink).map(i.DocumentLink.from)};{const se=this._cache.add(q),ge={links:[],cacheId:se};for(let ye=0;ye<q.length;ye++){if(!Fe._validateLink(q[ye]))continue;const Ue=i.DocumentLink.from(q[ye]);Ue.cacheId=[se,ye],ge.links.push(Ue)}return ge}}}static _validateLink(B){return B.target&&B.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(B,z){if(typeof this._provider.resolveDocumentLink!="function")return;const H=this._cache.get(...B);if(!H)return;const q=await this._provider.resolveDocumentLink(H,z);if(!(!q||!Fe._validateLink(q)))return i.DocumentLink.from(q)}releaseLinks(B){this._cache.delete(B)}}class ze{constructor(B,z){this._documents=B,this._provider=z}async provideColors(B,z){const H=this._documents.getDocument(B),q=await this._provider.provideDocumentColors(H,z);return Array.isArray(q)?q.map(ge=>({color:i.Color.from(ge.color),range:i.Range.from(ge.range)})):[]}async provideColorPresentations(B,z,H){const q=this._documents.getDocument(B),se=i.Range.to(z.range),ge=i.Color.to(z.color),ye=await this._provider.provideColorPresentations(ge,{document:q,range:se},H);if(Array.isArray(ye))return ye.map(i.ColorPresentation.from)}}class Je{constructor(B,z){this._documents=B,this._provider=z}async provideFoldingRanges(B,z,H){const q=this._documents.getDocument(B),se=await this._provider.provideFoldingRanges(q,z,H);if(Array.isArray(se))return se.map(i.FoldingRange.from)}}class nt{constructor(B,z,H){this._documents=B,this._provider=z,this._logService=H}async provideSelectionRanges(B,z,H){const q=this._documents.getDocument(B),se=z.map(i.Position.to),ge=await this._provider.provideSelectionRanges(q,se,H);if(!(0,S.isNonEmptyArray)(ge))return[];if(ge.length!==se.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const ye=[];for(let Ue=0;Ue<se.length;Ue++){const Ge=[];ye.push(Ge);let Ze=se[Ue],tt=ge[Ue];for(;;){if(!tt.range.contains(Ze))throw new Error("INVALID selection range, must contain the previous range");if(Ge.push(i.SelectionRange.from(tt)),!tt.parent)break;Ze=tt.range,tt=tt.parent}}return ye}}class dt{constructor(B,z){this._documents=B,this._provider=z,this._idPool=new k.IdGenerator(""),this._cache=new Map}async prepareSession(B,z,H){const q=this._documents.getDocument(B),se=i.Position.to(z),ge=await this._provider.prepareCallHierarchy(q,se,H);if(!ge)return;const ye=this._idPool.nextId();return this._cache.set(ye,new Map),Array.isArray(ge)?ge.map(Ue=>this._cacheAndConvertItem(ye,Ue)):[this._cacheAndConvertItem(ye,ge)]}async provideCallsTo(B,z,H){const q=this._itemFromCache(B,z);if(!q)throw new Error("missing call hierarchy item");const se=await this._provider.provideCallHierarchyIncomingCalls(q,H);if(se)return se.map(ge=>({from:this._cacheAndConvertItem(B,ge.from),fromRanges:ge.fromRanges.map(ye=>i.Range.from(ye))}))}async provideCallsFrom(B,z,H){const q=this._itemFromCache(B,z);if(!q)throw new Error("missing call hierarchy item");const se=await this._provider.provideCallHierarchyOutgoingCalls(q,H);if(se)return se.map(ge=>({to:this._cacheAndConvertItem(B,ge.to),fromRanges:ge.fromRanges.map(ye=>i.Range.from(ye))}))}releaseSession(B){this._cache.delete(B)}_cacheAndConvertItem(B,z){const H=this._cache.get(B),q=i.CallHierarchyItem.from(z,B,H.size.toString(36));return H.set(q._itemId,z),q}_itemFromCache(B,z){return this._cache.get(B)?.get(z)}}class vt{constructor(B,z){this._documents=B,this._provider=z,this._idPool=new k.IdGenerator(""),this._cache=new Map}async prepareSession(B,z,H){const q=this._documents.getDocument(B),se=i.Position.to(z),ge=await this._provider.prepareTypeHierarchy(q,se,H);if(!ge)return;const ye=this._idPool.nextId();return this._cache.set(ye,new Map),Array.isArray(ge)?ge.map(Ue=>this._cacheAndConvertItem(ye,Ue)):[this._cacheAndConvertItem(ye,ge)]}async provideSupertypes(B,z,H){const q=this._itemFromCache(B,z);if(!q)throw new Error("missing type hierarchy item");const se=await this._provider.provideTypeHierarchySupertypes(q,H);if(se)return se.map(ge=>this._cacheAndConvertItem(B,ge))}async provideSubtypes(B,z,H){const q=this._itemFromCache(B,z);if(!q)throw new Error("missing type hierarchy item");const se=await this._provider.provideTypeHierarchySubtypes(q,H);if(se)return se.map(ge=>this._cacheAndConvertItem(B,ge))}releaseSession(B){this._cache.delete(B)}_cacheAndConvertItem(B,z){const H=this._cache.get(B),q=i.TypeHierarchyItem.from(z,B,H.size.toString(36));return H.set(q._itemId,z),q}_itemFromCache(B,z){return this._cache.get(B)?.get(z)}}class ut{constructor(B,z,H,q,se){this._proxy=B,this._documents=z,this._provider=H,this._handle=q,this._extension=se,this._cache=new o.Cache("DocumentDropEdit")}async provideDocumentOnDropEdits(B,z,H,q,se){const ge=this._documents.getDocument(z),ye=i.Position.to(H),Ue=i.DataTransfer.toDataTransfer(q,async lt=>(await this._proxy.$resolveDocumentOnDropFileData(this._handle,B,lt)).buffer),Ge=await this._provider.provideDocumentDropEdits(ge,ye,Ue,se);if(!Ge)return;const Ze=(0,S.asArray)(Ge),tt=this._cache.add(Ze);return Ze.map((lt,it)=>({_cacheId:[tt,it],title:lt.title??(0,d.localize)(2704,null,this._extension.displayName||this._extension.name),kind:lt.kind?.value,yieldTo:lt.yieldTo?.map(at=>at.value),insertText:typeof lt.insertText=="string"?lt.insertText:{snippet:lt.insertText.value},additionalEdit:lt.additionalEdit?i.WorkspaceEdit.from(lt.additionalEdit,void 0):void 0}))}async resolveDropEdit(B,z){const[H,q]=B,se=this._cache.get(H,q);if(!se||!this._provider.resolveDocumentDropEdit)return{};const ge=await this._provider.resolveDocumentDropEdit(se,z)??se;return{additionalEdit:ge.additionalEdit?i.WorkspaceEdit.from(ge.additionalEdit,void 0):void 0}}releaseDropEdits(B){this._cache.delete(B)}}class et{constructor(B,z){this._documents=B,this._provider=z}async provideMappedEdits(B,z,H,q){const se=u.URI.revive(B),ge=this._documents.getDocument(se),ye=H.documents.map(Ze=>Ze.map(tt=>({uri:u.URI.revive(tt.uri),version:tt.version,ranges:tt.ranges.map(lt=>i.Range.to(lt))}))),Ue={documents:ye,selections:ye[0]?.[0]?.ranges??[]},Ge=await this._provider.provideMappedEdits(ge,z,Ue,q);return Ge?i.WorkspaceEdit.from(Ge):null}}class Oe{constructor(B,z){this.adapter=B,this.extension=z}}class Me{static{this._handlePool=0}constructor(B,z,H,q,se,ge,ye,Ue){this._uriTransformer=z,this._documents=H,this._commands=q,this._diagnostics=se,this._logService=ge,this._apiDeprecation=ye,this._extensionTelemetry=Ue,this._adapter=new Map,this._proxy=B.getProxy(c.MainContext.MainThreadLanguageFeatures)}_transformDocumentSelector(B,z){return i.DocumentSelector.from(B,this._uriTransformer,z)}_createDisposable(B){return new n.Disposable(()=>{this._adapter.delete(B),this._proxy.$unregister(B)})}_nextHandle(){return Me._handlePool++}async _withAdapter(B,z,H,q,se,ge=!1){const ye=this._adapter.get(B);if(!ye||!(ye.adapter instanceof z))return q;const Ue=Date.now();ge||this._logService.trace(`[${ye.extension.identifier.value}] INVOKE provider '${H.toString().replace(/[\r\n]/g,"")}'`);const Ge=H(ye.adapter,ye.extension);return Promise.resolve(Ge).catch(Ze=>{(0,O.isCancellationError)(Ze)||(this._logService.error(`[${ye.extension.identifier.value}] provider FAILED`),this._logService.error(Ze),this._extensionTelemetry.onExtensionError(ye.extension.identifier,Ze))}).finally(()=>{ge||this._logService.trace(`[${ye.extension.identifier.value}] provider DONE after ${Date.now()-Ue}ms`)}),D.CancellationToken.isCancellationToken(se)?(0,T.raceCancellationError)(Ge,se):Ge}_addNewAdapter(B,z){const H=this._nextHandle();return this._adapter.set(H,new Oe(B,z)),H}static _extLabel(B){return B.displayName||B.name}static _extId(B){return B.identifier.value}registerDocumentSymbolProvider(B,z,H,q){const se=this._addNewAdapter(new g(this._documents,H),B),ge=q&&q.label||Me._extLabel(B);return this._proxy.$registerDocumentSymbolProvider(se,this._transformDocumentSelector(z,B),ge),this._createDisposable(se)}$provideDocumentSymbols(B,z,H){return this._withAdapter(B,g,q=>q.provideDocumentSymbols(u.URI.revive(z),H),void 0,H)}registerCodeLensProvider(B,z,H){const q=this._nextHandle(),se=typeof H.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(q,new Oe(new f(this._documents,this._commands.converter,H,B,this._extensionTelemetry,this._logService),B)),this._proxy.$registerCodeLensSupport(q,this._transformDocumentSelector(z,B),se);let ge=this._createDisposable(q);if(se!==void 0){const ye=H.onDidChangeCodeLenses(Ue=>this._proxy.$emitCodeLensEvent(se));ge=n.Disposable.from(ge,ye)}return ge}$provideCodeLenses(B,z,H){return this._withAdapter(B,f,q=>q.provideCodeLenses(u.URI.revive(z),H),void 0,H,z.scheme==="output")}$resolveCodeLens(B,z,H){return this._withAdapter(B,f,q=>q.resolveCodeLens(z,H),void 0,void 0,!0)}$releaseCodeLenses(B,z){this._withAdapter(B,f,H=>Promise.resolve(H.releaseCodeLenses(z)),void 0,void 0,!0)}registerDefinitionProvider(B,z,H){const q=this._addNewAdapter(new _(this._documents,H),B);return this._proxy.$registerDefinitionSupport(q,this._transformDocumentSelector(z,B)),this._createDisposable(q)}$provideDefinition(B,z,H,q){return this._withAdapter(B,_,se=>se.provideDefinition(u.URI.revive(z),H,q),[],q)}registerDeclarationProvider(B,z,H){const q=this._addNewAdapter(new y(this._documents,H),B);return this._proxy.$registerDeclarationSupport(q,this._transformDocumentSelector(z,B)),this._createDisposable(q)}$provideDeclaration(B,z,H,q){return this._withAdapter(B,y,se=>se.provideDeclaration(u.URI.revive(z),H,q),[],q)}registerImplementationProvider(B,z,H){const q=this._addNewAdapter(new w(this._documents,H),B);return this._proxy.$registerImplementationSupport(q,this._transformDocumentSelector(z,B)),this._createDisposable(q)}$provideImplementation(B,z,H,q){return this._withAdapter(B,w,se=>se.provideImplementation(u.URI.revive(z),H,q),[],q)}registerTypeDefinitionProvider(B,z,H){const q=this._addNewAdapter(new P(this._documents,H),B);return this._proxy.$registerTypeDefinitionSupport(q,this._transformDocumentSelector(z,B)),this._createDisposable(q)}$provideTypeDefinition(B,z,H,q){return this._withAdapter(B,P,se=>se.provideTypeDefinition(u.URI.revive(z),H,q),[],q)}registerHoverProvider(B,z,H,q){const se=this._addNewAdapter(new R(this._documents,H),B);return this._proxy.$registerHoverProvider(se,this._transformDocumentSelector(z,B)),this._createDisposable(se)}$provideHover(B,z,H,q,se){return this._withAdapter(B,R,ge=>ge.provideHover(u.URI.revive(z),H,q,se),void 0,se)}$releaseHover(B,z){this._withAdapter(B,R,H=>Promise.resolve(H.releaseHover(z)),void 0,void 0)}registerEvaluatableExpressionProvider(B,z,H,q){const se=this._addNewAdapter(new p(this._documents,H),B);return this._proxy.$registerEvaluatableExpressionProvider(se,this._transformDocumentSelector(z,B)),this._createDisposable(se)}$provideEvaluatableExpression(B,z,H,q){return this._withAdapter(B,p,se=>se.provideEvaluatableExpression(u.URI.revive(z),H,q),void 0,q)}registerInlineValuesProvider(B,z,H,q){const se=typeof H.onDidChangeInlineValues=="function"?this._nextHandle():void 0,ge=this._addNewAdapter(new b(this._documents,H),B);this._proxy.$registerInlineValuesProvider(ge,this._transformDocumentSelector(z,B),se);let ye=this._createDisposable(ge);if(se!==void 0){const Ue=H.onDidChangeInlineValues(Ge=>this._proxy.$emitInlineValuesEvent(se));ye=n.Disposable.from(ye,Ue)}return ye}$provideInlineValues(B,z,H,q,se){return this._withAdapter(B,b,ge=>ge.provideInlineValues(u.URI.revive(z),H,q,se),void 0,se)}registerDocumentHighlightProvider(B,z,H){const q=this._addNewAdapter(new N(this._documents,H),B);return this._proxy.$registerDocumentHighlightProvider(q,this._transformDocumentSelector(z,B)),this._createDisposable(q)}registerMultiDocumentHighlightProvider(B,z,H){const q=this._addNewAdapter(new L(this._documents,H),B);return this._proxy.$registerMultiDocumentHighlightProvider(q,this._transformDocumentSelector(z,B)),this._createDisposable(q)}$provideDocumentHighlights(B,z,H,q){return this._withAdapter(B,N,se=>se.provideDocumentHighlights(u.URI.revive(z),H,q),void 0,q)}$provideMultiDocumentHighlights(B,z,H,q,se){return this._withAdapter(B,L,ge=>ge.provideMultiDocumentHighlights(u.URI.revive(z),H,q.map(ye=>u.URI.revive(ye)),se),void 0,se)}registerLinkedEditingRangeProvider(B,z,H){const q=this._addNewAdapter(new F(this._documents,H),B);return this._proxy.$registerLinkedEditingRangeProvider(q,this._transformDocumentSelector(z,B)),this._createDisposable(q)}$provideLinkedEditingRanges(B,z,H,q){return this._withAdapter(B,F,async se=>{const ge=await se.provideLinkedEditingRanges(u.URI.revive(z),H,q);if(ge)return{ranges:ge.ranges,wordPattern:ge.wordPattern?Me._serializeRegExp(ge.wordPattern):void 0}},void 0,q)}registerReferenceProvider(B,z,H){const q=this._addNewAdapter(new K(this._documents,H),B);return this._proxy.$registerReferenceSupport(q,this._transformDocumentSelector(z,B)),this._createDisposable(q)}$provideReferences(B,z,H,q,se){return this._withAdapter(B,K,ge=>ge.provideReferences(u.URI.revive(z),H,q,se),void 0,se)}registerCodeActionProvider(B,z,H,q){const se=new A.DisposableStore,ge=this._addNewAdapter(new J(this._documents,this._commands.converter,this._diagnostics,H,this._logService,B,this._apiDeprecation),B);return this._proxy.$registerCodeActionSupport(ge,this._transformDocumentSelector(z,B),{providedKinds:q?.providedCodeActionKinds?.map(ye=>ye.value),documentation:q?.documentation?.map(ye=>({kind:ye.kind.value,command:this._commands.converter.toInternal(ye.command,se)}))},Me._extLabel(B),Me._extId(B),!!H.resolveCodeAction),se.add(this._createDisposable(ge)),se}$provideCodeActions(B,z,H,q,se){return this._withAdapter(B,J,ge=>ge.provideCodeActions(u.URI.revive(z),H,q,se),void 0,se)}$resolveCodeAction(B,z,H){return this._withAdapter(B,J,q=>q.resolveCodeAction(z,H),{},void 0)}$releaseCodeActions(B,z){this._withAdapter(B,J,H=>Promise.resolve(H.releaseCodeActions(z)),void 0,void 0)}registerDocumentFormattingEditProvider(B,z,H){const q=this._addNewAdapter(new x(this._documents,H),B);return this._proxy.$registerDocumentFormattingSupport(q,this._transformDocumentSelector(z,B),B.identifier,B.displayName||B.name),this._createDisposable(q)}$provideDocumentFormattingEdits(B,z,H,q){return this._withAdapter(B,x,se=>se.provideDocumentFormattingEdits(u.URI.revive(z),H,q),void 0,q)}registerDocumentRangeFormattingEditProvider(B,z,H){const q=typeof H.provideDocumentRangesFormattingEdits=="function",se=this._addNewAdapter(new G(this._documents,H),B);return this._proxy.$registerRangeFormattingSupport(se,this._transformDocumentSelector(z,B),B.identifier,B.displayName||B.name,q),this._createDisposable(se)}$provideDocumentRangeFormattingEdits(B,z,H,q,se){return this._withAdapter(B,G,ge=>ge.provideDocumentRangeFormattingEdits(u.URI.revive(z),H,q,se),void 0,se)}$provideDocumentRangesFormattingEdits(B,z,H,q,se){return this._withAdapter(B,G,ge=>ge.provideDocumentRangesFormattingEdits(u.URI.revive(z),H,q,se),void 0,se)}registerOnTypeFormattingEditProvider(B,z,H,q){const se=this._addNewAdapter(new Y(this._documents,H),B);return this._proxy.$registerOnTypeFormattingSupport(se,this._transformDocumentSelector(z,B),q,B.identifier),this._createDisposable(se)}$provideOnTypeFormattingEdits(B,z,H,q,se,ge){return this._withAdapter(B,Y,ye=>ye.provideOnTypeFormattingEdits(u.URI.revive(z),H,q,se,ge),void 0,ge)}registerWorkspaceSymbolProvider(B,z){const H=this._addNewAdapter(new ae(z,this._logService),B);return this._proxy.$registerNavigateTypeSupport(H,typeof z.resolveWorkspaceSymbol=="function"),this._createDisposable(H)}$provideWorkspaceSymbols(B,z,H){return this._withAdapter(B,ae,q=>q.provideWorkspaceSymbols(z,H),{symbols:[]},H)}$resolveWorkspaceSymbol(B,z,H){return this._withAdapter(B,ae,q=>q.resolveWorkspaceSymbol(z,H),void 0,void 0)}$releaseWorkspaceSymbols(B,z){this._withAdapter(B,ae,H=>H.releaseWorkspaceSymbols(z),void 0,void 0)}registerRenameProvider(B,z,H){const q=this._addNewAdapter(new ee(this._documents,H,this._logService),B);return this._proxy.$registerRenameSupport(q,this._transformDocumentSelector(z,B),ee.supportsResolving(H)),this._createDisposable(q)}$provideRenameEdits(B,z,H,q,se){return this._withAdapter(B,ee,ge=>ge.provideRenameEdits(u.URI.revive(z),H,q,se),void 0,se)}$resolveRenameLocation(B,z,H,q){return this._withAdapter(B,ee,se=>se.resolveRenameLocation(u.URI.revive(z),H,q),void 0,q)}registerNewSymbolNamesProvider(B,z,H){const q=this._addNewAdapter(new oe(this._documents,H,this._logService),B);return this._proxy.$registerNewSymbolNamesProvider(q,this._transformDocumentSelector(z,B)),this._createDisposable(q)}$supportsAutomaticNewSymbolNamesTriggerKind(B){return this._withAdapter(B,oe,z=>z.supportsAutomaticNewSymbolNamesTriggerKind(),!1,void 0)}$provideNewSymbolNames(B,z,H,q,se){return this._withAdapter(B,oe,ge=>ge.provideNewSymbolNames(u.URI.revive(z),H,q,se),void 0,se)}registerDocumentSemanticTokensProvider(B,z,H,q){const se=this._addNewAdapter(new ue(this._documents,H),B),ge=typeof H.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._proxy.$registerDocumentSemanticTokensProvider(se,this._transformDocumentSelector(z,B),q,ge);let ye=this._createDisposable(se);if(ge){const Ue=H.onDidChangeSemanticTokens(Ge=>this._proxy.$emitDocumentSemanticTokensEvent(ge));ye=n.Disposable.from(ye,Ue)}return ye}$provideDocumentSemanticTokens(B,z,H,q){return this._withAdapter(B,ue,se=>se.provideDocumentSemanticTokens(u.URI.revive(z),H,q),null,q)}$releaseDocumentSemanticTokens(B,z){this._withAdapter(B,ue,H=>H.releaseDocumentSemanticColoring(z),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(B,z,H,q){const se=this._addNewAdapter(new Z(this._documents,H),B);return this._proxy.$registerDocumentRangeSemanticTokensProvider(se,this._transformDocumentSelector(z,B),q),this._createDisposable(se)}$provideDocumentRangeSemanticTokens(B,z,H,q){return this._withAdapter(B,Z,se=>se.provideDocumentRangeSemanticTokens(u.URI.revive(z),H,q),null,q)}registerCompletionItemProvider(B,z,H,q){const se=this._addNewAdapter(new ve(this._documents,this._commands.converter,H,this._apiDeprecation,B),B);return this._proxy.$registerCompletionsProvider(se,this._transformDocumentSelector(z,B),q,ve.supportsResolving(H),B.identifier),this._createDisposable(se)}$provideCompletionItems(B,z,H,q,se){return this._withAdapter(B,ve,ge=>ge.provideCompletionItems(u.URI.revive(z),H,q,se),void 0,se)}$resolveCompletionItem(B,z,H){return this._withAdapter(B,ve,q=>q.resolveCompletionItem(z,H),void 0,H)}$releaseCompletionItems(B,z){this._withAdapter(B,ve,H=>H.releaseCompletionItems(z),void 0,void 0)}registerInlineCompletionsProvider(B,z,H,q){const se=new X(B,this._documents,H,this._commands.converter),ge=this._addNewAdapter(se,B);return this._proxy.$registerInlineCompletionsSupport(ge,this._transformDocumentSelector(z,B),se.supportsHandleEvents,l.ExtensionIdentifier.toKey(B.identifier.value),q?.yieldTo?.map(ye=>l.ExtensionIdentifier.toKey(ye))||[]),this._createDisposable(ge)}$provideInlineCompletions(B,z,H,q,se){return this._withAdapter(B,Ie,ge=>ge.provideInlineCompletions(u.URI.revive(z),H,q,se),void 0,se)}$provideInlineEdits(B,z,H,q,se){return this._withAdapter(B,Ie,ge=>ge.provideInlineEdits(u.URI.revive(z),H,q,se),void 0,se)}$handleInlineCompletionDidShow(B,z,H,q){this._withAdapter(B,Ie,async se=>{se.handleDidShowCompletionItem(z,H,q)},void 0,void 0)}$handleInlineCompletionPartialAccept(B,z,H,q,se){this._withAdapter(B,Ie,async ge=>{ge.handlePartialAccept(z,H,q,se)},void 0,void 0)}$freeInlineCompletionsList(B,z){this._withAdapter(B,Ie,async H=>{H.disposeCompletions(z)},void 0,void 0)}registerInlineEditProvider(B,z,H){const q=new V(B,this._documents,H,this._commands.converter),se=this._addNewAdapter(q,B);return this._proxy.$registerInlineEditProvider(se,this._transformDocumentSelector(z,B),B.identifier),this._createDisposable(se)}$provideInlineEdit(B,z,H,q){return this._withAdapter(B,V,se=>se.provideInlineEdits(u.URI.revive(z),H,q),void 0,q)}$freeInlineEdit(B,z){this._withAdapter(B,V,async H=>{H.disposeEdit(z)},void 0,void 0)}registerSignatureHelpProvider(B,z,H,q){const se=Array.isArray(q)?{triggerCharacters:q,retriggerCharacters:[]}:q,ge=this._addNewAdapter(new be(this._documents,H),B);return this._proxy.$registerSignatureHelpProvider(ge,this._transformDocumentSelector(z,B),se),this._createDisposable(ge)}$provideSignatureHelp(B,z,H,q,se){return this._withAdapter(B,be,ge=>ge.provideSignatureHelp(u.URI.revive(z),H,q,se),void 0,se)}$releaseSignatureHelp(B,z){this._withAdapter(B,be,H=>H.releaseSignatureHelp(z),void 0,void 0)}registerInlayHintsProvider(B,z,H){const q=typeof H.onDidChangeInlayHints=="function"?this._nextHandle():void 0,se=this._addNewAdapter(new De(this._documents,this._commands.converter,H,this._logService,B),B);this._proxy.$registerInlayHintsProvider(se,this._transformDocumentSelector(z,B),typeof H.resolveInlayHint=="function",q,Me._extLabel(B));let ge=this._createDisposable(se);if(q!==void 0){const ye=H.onDidChangeInlayHints(Ue=>this._proxy.$emitInlayHintsEvent(q));ge=n.Disposable.from(ge,ye)}return ge}$provideInlayHints(B,z,H,q){return this._withAdapter(B,De,se=>se.provideInlayHints(u.URI.revive(z),H,q),void 0,q)}$resolveInlayHint(B,z,H){return this._withAdapter(B,De,q=>q.resolveInlayHint(z,H),void 0,H)}$releaseInlayHints(B,z){this._withAdapter(B,De,H=>H.releaseHints(z),void 0,void 0)}registerDocumentLinkProvider(B,z,H){const q=this._addNewAdapter(new Fe(this._documents,H),B);return this._proxy.$registerDocumentLinkProvider(q,this._transformDocumentSelector(z,B),typeof H.resolveDocumentLink=="function"),this._createDisposable(q)}$provideDocumentLinks(B,z,H){return this._withAdapter(B,Fe,q=>q.provideLinks(u.URI.revive(z),H),void 0,H,z.scheme==="output")}$resolveDocumentLink(B,z,H){return this._withAdapter(B,Fe,q=>q.resolveLink(z,H),void 0,void 0,!0)}$releaseDocumentLinks(B,z){this._withAdapter(B,Fe,H=>H.releaseLinks(z),void 0,void 0,!0)}registerColorProvider(B,z,H){const q=this._addNewAdapter(new ze(this._documents,H),B);return this._proxy.$registerDocumentColorProvider(q,this._transformDocumentSelector(z,B)),this._createDisposable(q)}$provideDocumentColors(B,z,H){return this._withAdapter(B,ze,q=>q.provideColors(u.URI.revive(z),H),[],H)}$provideColorPresentations(B,z,H,q){return this._withAdapter(B,ze,se=>se.provideColorPresentations(u.URI.revive(z),H,q),void 0,q)}registerFoldingRangeProvider(B,z,H){const q=this._nextHandle(),se=typeof H.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(q,new Oe(new Je(this._documents,H),B)),this._proxy.$registerFoldingRangeProvider(q,this._transformDocumentSelector(z,B),B.identifier,se);let ge=this._createDisposable(q);if(se!==void 0){const ye=H.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(se));ge=n.Disposable.from(ge,ye)}return ge}$provideFoldingRanges(B,z,H,q){return this._withAdapter(B,Je,se=>se.provideFoldingRanges(u.URI.revive(z),H,q),void 0,q)}registerSelectionRangeProvider(B,z,H){const q=this._addNewAdapter(new nt(this._documents,H,this._logService),B);return this._proxy.$registerSelectionRangeProvider(q,this._transformDocumentSelector(z,B)),this._createDisposable(q)}$provideSelectionRanges(B,z,H,q){return this._withAdapter(B,nt,se=>se.provideSelectionRanges(u.URI.revive(z),H,q),[],q)}registerCallHierarchyProvider(B,z,H){const q=this._addNewAdapter(new dt(this._documents,H),B);return this._proxy.$registerCallHierarchyProvider(q,this._transformDocumentSelector(z,B)),this._createDisposable(q)}$prepareCallHierarchy(B,z,H,q){return this._withAdapter(B,dt,se=>Promise.resolve(se.prepareSession(u.URI.revive(z),H,q)),void 0,q)}$provideCallHierarchyIncomingCalls(B,z,H,q){return this._withAdapter(B,dt,se=>se.provideCallsTo(z,H,q),void 0,q)}$provideCallHierarchyOutgoingCalls(B,z,H,q){return this._withAdapter(B,dt,se=>se.provideCallsFrom(z,H,q),void 0,q)}$releaseCallHierarchy(B,z){this._withAdapter(B,dt,H=>Promise.resolve(H.releaseSession(z)),void 0,void 0)}registerTypeHierarchyProvider(B,z,H){const q=this._addNewAdapter(new vt(this._documents,H),B);return this._proxy.$registerTypeHierarchyProvider(q,this._transformDocumentSelector(z,B)),this._createDisposable(q)}$prepareTypeHierarchy(B,z,H,q){return this._withAdapter(B,vt,se=>Promise.resolve(se.prepareSession(u.URI.revive(z),H,q)),void 0,q)}$provideTypeHierarchySupertypes(B,z,H,q){return this._withAdapter(B,vt,se=>se.provideSupertypes(z,H,q),void 0,q)}$provideTypeHierarchySubtypes(B,z,H,q){return this._withAdapter(B,vt,se=>se.provideSubtypes(z,H,q),void 0,q)}$releaseTypeHierarchy(B,z){this._withAdapter(B,vt,H=>Promise.resolve(H.releaseSession(z)),void 0,void 0)}registerDocumentOnDropEditProvider(B,z,H,q){const se=this._nextHandle();return this._adapter.set(se,new Oe(new ut(this._proxy,this._documents,H,se,B),B)),this._proxy.$registerDocumentOnDropEditProvider(se,this._transformDocumentSelector(z,B),(0,t.isProposedApiEnabled)(B,"documentPaste")&&q?{supportsResolve:!!H.resolveDocumentDropEdit,dropMimeTypes:q.dropMimeTypes}:void 0),this._createDisposable(se)}$provideDocumentOnDropEdits(B,z,H,q,se,ge){return this._withAdapter(B,ut,ye=>Promise.resolve(ye.provideDocumentOnDropEdits(z,u.URI.revive(H),q,se,ge)),void 0,void 0)}$resolveDropEdit(B,z,H){return this._withAdapter(B,ut,q=>q.resolveDropEdit(z,H),{},void 0)}$releaseDocumentOnDropEdits(B,z){this._withAdapter(B,ut,H=>Promise.resolve(H.releaseDropEdits(z)),void 0,void 0)}registerMappedEditsProvider(B,z,H){const q=this._addNewAdapter(new et(this._documents,H),B);return this._proxy.$registerMappedEditsProvider(q,this._transformDocumentSelector(z,B),B.displayName??B.name),this._createDisposable(q)}$provideMappedEdits(B,z,H,q,se){return this._withAdapter(B,et,ge=>Promise.resolve(ge.provideMappedEdits(z,H,q,se)),null,se)}registerDocumentPasteEditProvider(B,z,H,q){const se=this._nextHandle();return this._adapter.set(se,new Oe(new $(this._proxy,this._documents,H,se,B),B)),this._proxy.$registerPasteEditProvider(se,this._transformDocumentSelector(z,B),{supportsCopy:!!H.prepareDocumentPaste,supportsPaste:!!H.provideDocumentPasteEdits,supportsResolve:!!H.resolveDocumentPasteEdit,providedPasteEditKinds:q.providedPasteEditKinds?.map(ge=>ge.value),copyMimeTypes:q.copyMimeTypes,pasteMimeTypes:q.pasteMimeTypes}),this._createDisposable(se)}$prepareDocumentPaste(B,z,H,q,se){return this._withAdapter(B,$,ge=>ge.prepareDocumentPaste(u.URI.revive(z),H,q,se),void 0,se)}$providePasteEdits(B,z,H,q,se,ge,ye){return this._withAdapter(B,$,Ue=>Ue.providePasteEdits(z,u.URI.revive(H),q,se,ge,ye),void 0,ye)}$resolvePasteEdit(B,z,H){return this._withAdapter(B,$,q=>q.resolvePasteEdit(z,H),{},void 0)}$releasePasteEdits(B,z){this._withAdapter(B,$,H=>Promise.resolve(H.releasePasteEdits(z)),void 0,void 0)}static _serializeRegExp(B){return{pattern:B.source,flags:B.flags}}static _serializeIndentationRule(B){return{decreaseIndentPattern:Me._serializeRegExp(B.decreaseIndentPattern),increaseIndentPattern:Me._serializeRegExp(B.increaseIndentPattern),indentNextLinePattern:B.indentNextLinePattern?Me._serializeRegExp(B.indentNextLinePattern):void 0,unIndentedLinePattern:B.unIndentedLinePattern?Me._serializeRegExp(B.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(B){return{beforeText:Me._serializeRegExp(B.beforeText),afterText:B.afterText?Me._serializeRegExp(B.afterText):void 0,previousLineText:B.previousLineText?Me._serializeRegExp(B.previousLineText):void 0,action:B.action}}static _serializeOnEnterRules(B){return B.map(Me._serializeOnEnterRule)}static _serializeAutoClosingPair(B){return{open:B.open,close:B.close,notIn:B.notIn?B.notIn.map(z=>n.SyntaxTokenType.toString(z)):void 0}}static _serializeAutoClosingPairs(B){return B.map(Me._serializeAutoClosingPair)}setLanguageConfiguration(B,z,H){const{wordPattern:q}=H;if(q&&(0,I.regExpLeadsToEndlessLoop)(q))throw new Error(`Invalid language configuration: wordPattern '${q}' is not allowed to match the empty string.`);q?this._documents.setWordDefinitionFor(z,q):this._documents.setWordDefinitionFor(z,void 0),H.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",B,"Do not use."),H.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",B,"Do not use.");const se=this._nextHandle(),ge={comments:H.comments,brackets:H.brackets,wordPattern:H.wordPattern?Me._serializeRegExp(H.wordPattern):void 0,indentationRules:H.indentationRules?Me._serializeIndentationRule(H.indentationRules):void 0,onEnterRules:H.onEnterRules?Me._serializeOnEnterRules(H.onEnterRules):void 0,__electricCharacterSupport:H.__electricCharacterSupport,__characterPairSupport:H.__characterPairSupport,autoClosingPairs:H.autoClosingPairs?Me._serializeAutoClosingPairs(H.autoClosingPairs):void 0};return this._proxy.$setLanguageConfiguration(se,z,ge),this._createDisposable(se)}$setWordDefinitions(B){for(const z of B)this._documents.setWordDefinitionFor(z.languageId,new RegExp(z.regexSource,z.regexFlags))}}e.ExtHostLanguageFeatures=Me}),define(ke[244],Re([1,0,10,19,12,4,34,33,5,8]),function(Ee,e,S,T,D,O,k,A,m,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageModelTools=void 0,s=Ve(s);class I{constructor(u){this._registeredTools=new Map,this._tokenCountFuncs=new Map,this._allTools=new Map,this._proxy=u.getProxy(m.MainContext.MainThreadLanguageModelTools),this._proxy.$getTools().then(C=>{for(const v of C)this._allTools.set(v.id,(0,k.revive)(v))})}async $countTokensForInvocation(u,C,v){const r=this._tokenCountFuncs.get(u);if(!r)throw new Error(`Tool invocation call ${u} not found`);return await r(C,v)}async invokeTool(u,C,v){const r=(0,A.generateUuid)();C.tokenOptions&&this._tokenCountFuncs.set(r,C.tokenOptions.countTokens);try{const a=await this._proxy.$invokeTool({toolId:u,callId:r,parameters:C.parameters,tokenBudget:C.tokenOptions?.tokenBudget},v);return s.LanguageModelToolResult.to(a)}finally{this._tokenCountFuncs.delete(r)}}$onDidChangeTools(u){this._allTools.clear();for(const C of u)this._allTools.set(C.id,C)}get tools(){return Array.from(this._allTools.values()).map(u=>s.LanguageModelToolDescription.to(u))}async $invokeTool(u,C){const v=this._registeredTools.get(u.toolId);if(!v)throw new Error(`Unknown tool ${u.toolId}`);const r={parameters:u.parameters};u.tokenBudget!==void 0&&(r.tokenOptions={tokenBudget:u.tokenBudget,countTokens:this._tokenCountFuncs.get(u.callId)||((d,l=T.CancellationToken.None)=>this._proxy.$countTokensForInvocation(u.callId,d,l))});const a=await(0,S.raceCancellation)(Promise.resolve(v.tool.invoke(r,C)),C);if(!a)throw new D.CancellationError;for(const d of Object.keys(a))if(a[d]instanceof Promise)throw new Error(`Tool result for '${d}' cannot be a Promise`);return s.LanguageModelToolResult.from(a)}registerTool(u,C,v){return this._registeredTools.set(C,{extension:u,tool:v}),this._proxy.$registerTool(C),(0,O.toDisposable)(()=>{this._registeredTools.delete(C),this._proxy.$unregisterTool(C)})}}e.ExtHostLanguageModelTools=I}),define(ke[95],Re([1,0,10,19,42,12,6,41,4,9,18,3,11,77,5,91,16,8,7,119,21]),function(Ee,e,S,T,D,O,k,A,m,s,I,E,u,C,v,r,a,d,l,i,n){"use strict";var t;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageModels=e.IExtHostLanguageModels=void 0,d=Ve(d),l=Ve(l),e.IExtHostLanguageModels=(0,E.createDecorator)("IExtHostLanguageModels");class o{constructor(h,_){this.option=h,this.stream=new S.AsyncIterableSource,this.stream=_??new S.AsyncIterableSource}}class c{constructor(){this._responseStreams=new Map,this._defaultStream=new S.AsyncIterableSource,this._isDone=!1;const h=this;this.apiObject={get stream(){return h._defaultStream.asyncIterable},get text(){return S.AsyncIterableObject.map(h._defaultStream.asyncIterable,_=>{if(_ instanceof l.LanguageModelTextPart)return _.value}).coalesce()}}}*_streams(){if(this._responseStreams.size>0)for(const[,h]of this._responseStreams)yield h.stream;else yield this._defaultStream}handleFragment(h){if(this._isDone)return;let _=this._responseStreams.get(h.index);_||(this._responseStreams.size===0?_=new o(h.index,this._defaultStream):_=new o(h.index),this._responseStreams.set(h.index,_));let y;h.part.type==="text"?y=new l.LanguageModelTextPart(h.part.value):y=new l.LanguageModelToolCallPart(h.part.name,h.part.toolCallId,h.part.parameters),_.stream.emitOne(y)}reject(h){this._isDone=!0;for(const _ of this._streams())_.reject(h)}resolve(){this._isDone=!0;for(const h of this._streams())h.resolve()}}let g=class{static{t=this}static{this._idPool=1}constructor(h,_,y){this._logService=_,this._extHostAuthentication=y,this._onDidChangeModelAccess=new k.Emitter,this._onDidChangeProviders=new k.Emitter,this.onDidChangeProviders=this._onDidChangeProviders.event,this._languageModels=new Map,this._allLanguageModelData=new Map,this._modelAccessList=new I.ExtensionIdentifierMap,this._pendingRequest=new Map,this._languageAccessInformationExtensions=new Set,this._proxy=h.getProxy(v.MainContext.MainThreadLanguageModels)}dispose(){this._onDidChangeModelAccess.dispose(),this._onDidChangeProviders.dispose()}registerLanguageModel(h,_,y,w){const P=t._idPool++;this._languageModels.set(P,{extension:h.identifier,provider:y,languageModelId:_});let R;w.auth&&(R={providerLabel:h.displayName||h.name,accountLabel:typeof w.auth=="object"?w.auth.label:void 0}),this._proxy.$registerLanguageModelProvider(P,`${I.ExtensionIdentifier.toKey(h.identifier)}/${P}/${_}`,{extension:h.identifier,id:_,vendor:w.vendor??I.ExtensionIdentifier.toKey(h.identifier),name:w.name??"",family:w.family??"",version:w.version,maxInputTokens:w.maxInputTokens,maxOutputTokens:w.maxOutputTokens,auth:R,targetExtensions:w.extensions});const p=y.onDidReceiveLanguageModelResponse2?.(({extensionId:b,participant:N,tokenCount:L})=>{this._proxy.$whenLanguageModelChatRequestMade(_,new I.ExtensionIdentifier(b),N,L)});return(0,m.toDisposable)(()=>{this._languageModels.delete(P),this._proxy.$unregisterProvider(P),p?.dispose()})}async $startChatRequest(h,_,y,w,P,R){const p=this._languageModels.get(h);if(!p)throw new Error("Provider not found");const b=new C.Progress(async L=>{if(R.isCancellationRequested){this._logService.warn(`[CHAT](${p.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}let F;if(L.part instanceof l.LanguageModelToolCallPart?F={type:"tool_use",name:L.part.name,parameters:L.part.parameters,toolCallId:L.part.toolCallId}:L.part instanceof l.LanguageModelTextPart&&(F={type:"text",value:L.part.value}),!F){this._logService.warn(`[CHAT](${p.extension.value}) UNKNOWN part ${JSON.stringify(L)}`);return}this._proxy.$reportResponsePart(_,{index:L.index,part:F})});let N;if(p.provider.provideLanguageModelResponse2)N=Promise.resolve(p.provider.provideLanguageModelResponse2(w.map(d.LanguageModelChatMessage.to),P,I.ExtensionIdentifier.toKey(y),b,R));else{const L=new C.Progress(async F=>{b.report({index:F.index,part:new l.LanguageModelTextPart(F.part)})});N=Promise.resolve(p.provider.provideLanguageModelResponse(w.map(d.LanguageModelChatMessage.to),P?.modelOptions??{},I.ExtensionIdentifier.toKey(y),L,R))}N.then(()=>{this._proxy.$reportResponseDone(_,void 0)},L=>{this._proxy.$reportResponseDone(_,(0,O.transformErrorForSerialization)(L))})}$provideTokenLength(h,_,y){const w=this._languageModels.get(h);return w?Promise.resolve(w.provider.provideTokenCount(_,y)):Promise.resolve(0)}$acceptChatModelMetadata(h){if(h.added)for(const{identifier:_,metadata:y}of h.added)this._allLanguageModelData.set(_,{metadata:y,apiObjects:new I.ExtensionIdentifierMap});if(h.removed)for(const _ of h.removed){this._allLanguageModelData.delete(_);for(const[y,w]of this._pendingRequest)w.languageModelId===_&&(w.res.reject(new O.CancellationError),this._pendingRequest.delete(y))}h.added?.forEach(_=>this._fakeAuthPopulate(_.metadata)),this._onDidChangeProviders.fire(void 0)}async selectLanguageModels(h,_){const y=await this._proxy.$selectChatModels({..._,extension:h.identifier}),w=[],P=this;for(const R of y){const p=this._allLanguageModelData.get(R);if(!p)continue;this._isUsingAuth(h.identifier,p.metadata)&&await this._fakeAuthPopulate(p.metadata);let b=p.apiObjects.get(h.identifier);b||(b={id:R,vendor:p.metadata.vendor,family:p.metadata.family,version:p.metadata.version,name:p.metadata.name,maxInputTokens:p.metadata.maxInputTokens,countTokens(N,L){if(!P._allLanguageModelData.has(R))throw l.LanguageModelError.NotFound(R);return P._computeTokenLength(R,N,L??T.CancellationToken.None)},sendRequest(N,L,F){if(!P._allLanguageModelData.has(R))throw l.LanguageModelError.NotFound(R);return P._sendChatRequest(h,R,N,L??{},F??T.CancellationToken.None)}},Object.freeze(b),p.apiObjects.set(h.identifier,b)),w.push(b)}return w}async _sendChatRequest(h,_,y,w,P){const R=this._convertMessages(h,y),p=h.identifier,b=this._allLanguageModelData.get(_)?.metadata;if(!b||!this._allLanguageModelData.has(_))throw l.LanguageModelError.NotFound(`Language model '${_}' is unknown.`);if(this._isUsingAuth(p,b)&&(!await this._getAuthAccess(h,{identifier:b.extension,displayName:b.auth.providerLabel},w.justification,!1)||!this._modelAccessList.get(p)?.has(b.extension)))throw l.LanguageModelError.NoPermissions(`Language model '${_}' cannot be used by '${p.value}'.`);try{const N=Math.random()*1e6|0,L=new c;this._pendingRequest.set(N,{languageModelId:_,res:L});try{await this._proxy.$tryStartChatRequest(p,_,N,R,w,P)}catch(F){throw this._pendingRequest.delete(N),F}return L.apiObject}catch(N){throw N.name===l.LanguageModelError.name?N:new l.LanguageModelError(`Language model '${_}' errored: ${(0,D.toErrorMessage)(N)}`,"Unknown",N)}}_convertMessages(h,_){const y=[];for(const w of _)w.role===l.LanguageModelChatMessageRole.System&&(0,n.checkProposedApiEnabled)(h,"languageModelSystem"),w.content2.some(P=>P instanceof l.LanguageModelToolResultPart)&&(0,n.checkProposedApiEnabled)(h,"lmTools"),y.push(d.LanguageModelChatMessage.from(w));return y}async $acceptResponsePart(h,_){const y=this._pendingRequest.get(h);y&&y.res.handleFragment(_)}async $acceptResponseDone(h,_){const y=this._pendingRequest.get(h);y&&(this._pendingRequest.delete(h),_?y.res.reject((0,O.transformErrorFromSerialization)(_)):y.res.resolve())}async _getAuthAccess(h,_,y,w){const P=i.INTERNAL_AUTH_PROVIDER_PREFIX+_.identifier.value;if(await this._extHostAuthentication.getSession(h,P,[],{silent:!0}))return this.$updateModelAccesslist([{from:h.identifier,to:_.identifier,enabled:!0}]),!0;if(w)return!1;try{const p=y?(0,s.localize)(2705,null,_.displayName,y):void 0;return await this._extHostAuthentication.getSession(h,P,[],{forceNewSession:{detail:p}}),this.$updateModelAccesslist([{from:h.identifier,to:_.identifier,enabled:!0}]),!0}catch{return!1}}_isUsingAuth(h,_){return!!_.auth&&!I.ExtensionIdentifier.equals(_.extension,h)}async _fakeAuthPopulate(h){if(h.auth)for(const _ of this._languageAccessInformationExtensions)try{await this._getAuthAccess(_,{identifier:h.extension,displayName:""},void 0,!0)}catch(y){this._logService.error("Fake Auth request failed"),this._logService.error(y)}}async _computeTokenLength(h,_,y){if(!this._allLanguageModelData.get(h))throw l.LanguageModelError.NotFound(`Language model '${h}' is unknown.`);const P=A.Iterable.find(this._languageModels.values(),R=>R.languageModelId===h);return P?P.provider.provideTokenCount(_,y):this._proxy.$countTokens(h,typeof _=="string"?_:d.LanguageModelChatMessage.from(_),y)}$updateModelAccesslist(h){const _=new Array;for(const{from:y,to:w,enabled:P}of h){const R=this._modelAccessList.get(y)??new I.ExtensionIdentifierSet;if(R.has(w)!==P){P?R.add(w):R.delete(w),this._modelAccessList.set(y,R);const b={from:y,to:w};_.push(b),this._onDidChangeModelAccess.fire(b)}}}createLanguageModelAccessInformation(h){this._languageAccessInformationExtensions.add(h);const _=this,y=k.Event.signal(k.Event.filter(this._onDidChangeModelAccess.event,P=>I.ExtensionIdentifier.equals(P.from,h.identifier))),w=k.Event.signal(this._onDidChangeProviders.event);return{get onDidChange(){return k.Event.any(y,w)},canSendRequest(P){let R;e:for(const[b,N]of _._allLanguageModelData)for(const L of N.apiObjects.values())if(L===P){R=N.metadata;break e}if(!R)return;if(!_._isUsingAuth(h.identifier,R))return!0;const p=_._modelAccessList.get(h.identifier);if(p)return p.has(R.extension)}}}};e.ExtHostLanguageModels=g,e.ExtHostLanguageModels=g=t=qe([We(0,a.IExtHostRpcService),We(1,u.ILogService),We(2,r.IExtHostAuthentication)],g)});var oi=this&&this.__importDefault||function(Ee){return Ee&&Ee.__esModule?Ee:{default:Ee}};define(ke[245],Re([1,0,5,8,7,37,10,4,21]),function(Ee,e,S,T,D,O,k,A,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0,T=Ve(T),O=oi(O);class s{constructor(E,u,C,v){this._documents=u,this._commands=C,this._uriTransformer=v,this._languageIds=[],this._handlePool=0,this._ids=new Set,this._proxy=E.getProxy(S.MainContext.MainThreadLanguages)}$acceptLanguageIds(E){this._languageIds=E}async getLanguages(){return this._languageIds.slice(0)}async changeLanguage(E,u){await this._proxy.$changeLanguage(E,u);const C=this._documents.getDocumentData(E);if(!C)throw new Error(`document '${E.toString()}' NOT found`);return C.document}async tokenAtPosition(E,u){const C=E.version,v=T.Position.from(u),r=await this._proxy.$tokensAtPosition(E.uri,v),a={type:D.StandardTokenType.Other,range:E.getWordRangeAtPosition(u)??new D.Range(u.line,u.character,u.line,u.character)};if(!r)return a;const d={range:T.Range.to(r.range),type:T.TokenType.to(r.type)};return!d.range.contains(u)||C!==E.version?a:d}createLanguageStatusItem(E,u,C){const v=this._handlePool++,r=this._proxy,a=this._ids,d=`${E.identifier.value}/${u}`;if(a.has(d))throw new Error(`LanguageStatusItem with id '${u}' ALREADY exists`);a.add(d);const l={selector:C,id:u,name:E.displayName??E.name,severity:D.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let i;const n=new A.DisposableStore,t=()=>{if(i?.dispose(),!a.has(d)){console.warn(`LanguageStatusItem (${u}) from ${E.identifier.value} has been disposed and CANNOT be updated anymore`);return}i=(0,k.disposableTimeout)(()=>{n.clear(),this._proxy.$setLanguageStatus(v,{id:d,name:l.name??E.displayName??E.name,source:E.displayName??E.name,selector:T.DocumentSelector.from(l.selector,this._uriTransformer),label:l.text,detail:l.detail??"",severity:l.severity===D.LanguageStatusSeverity.Error?O.default.Error:l.severity===D.LanguageStatusSeverity.Warning?O.default.Warning:O.default.Info,command:l.command&&this._commands.toInternal(l.command,n),accessibilityInfo:l.accessibilityInformation,busy:l.busy})},0)},o={dispose(){n.dispose(),i?.dispose(),r.$removeLanguageStatus(v),a.delete(d)},get id(){return l.id},get name(){return l.name},set name(c){l.name=c,t()},get selector(){return l.selector},set selector(c){l.selector=c,t()},get text(){return l.text},set text(c){l.text=c,t()},set text2(c){(0,m.checkProposedApiEnabled)(E,"languageStatusText"),l.text=c,t()},get text2(){return(0,m.checkProposedApiEnabled)(E,"languageStatusText"),l.text},get detail(){return l.detail},set detail(c){l.detail=c,t()},get severity(){return l.severity},set severity(c){l.severity=c,t()},get accessibilityInformation(){return l.accessibilityInformation},set accessibilityInformation(c){l.accessibilityInformation=c,t()},get command(){return l.command},set command(c){l.command=c,t()},get busy(){return l.busy},set busy(c){l.busy=c,t()}};return t(),o}}e.ExtHostLanguages=s}),define(ke[246],Re([1,0,15,2,8,7,90]),function(Ee,e,S,T,D,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0,D=Ve(D),k=Ve(k);class A{constructor(E,u,C,v){this.start=E,this.deletedCount=u,this.deletedItems=C,this.items=v}asApiEvent(){return{range:new O.NotebookRange(this.start,this.start+this.deletedCount),addedCells:this.items.map(E=>E.apiCell),removedCells:this.deletedItems}}}class m{static asModelAddData(E){return{EOL:E.eol,lines:E.source,languageId:E.language,uri:E.uri,isDirty:!1,versionId:1}}constructor(E,u,C){this.notebook=E,this._extHostDocument=u,this._cellData=C,this.handle=C.handle,this.uri=T.URI.revive(C.uri),this.cellKind=C.cellKind,this._outputs=C.outputs.map(D.NotebookCellOutput.to),this._internalMetadata=C.internalMetadata??{},this._metadata=Object.freeze(C.metadata??{}),this._previousResult=Object.freeze(D.NotebookCellExecutionSummary.to(C.internalMetadata??{}))}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const E=this,u=this._extHostDocument.getDocument(this.uri);if(!u)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const C={get index(){return E.notebook.getCellIndex(E)},notebook:E.notebook.apiNotebook,kind:D.NotebookCellKind.to(this._cellData.cellKind),document:u.document,get mime(){return E._mime},set mime(v){E._mime=v},get outputs(){return E._outputs.slice(0)},get metadata(){return E._metadata},get executionSummary(){return E._previousResult}};this._apiCell=Object.freeze(C)}return this._apiCell}setOutputs(E){this._outputs=E.map(D.NotebookCellOutput.to)}setOutputItems(E,u,C){const v=C.map(D.NotebookCellOutputItem.to),r=this._outputs.find(a=>a.id===E);if(r&&(u||(r.items.length=0),r.items.push(...v),r.items.length>1&&r.items.every(a=>k.isTextStreamMime(a.mime)))){const a=new Map,d=[];r.items.forEach(l=>{let i;a.has(l.mime)?i=a.get(l.mime):(i=[],a.set(l.mime,i),d.push(l.mime)),i.push(l.data)}),r.items.length=0,d.forEach(l=>{const i=k.compressOutputItemStreams(a.get(l));r.items.push({mime:l,data:i.data.buffer})})}}setMetadata(E){this._metadata=Object.freeze(E)}setInternalMetadata(E){this._internalMetadata=E,this._previousResult=Object.freeze(D.NotebookCellExecutionSummary.to(E))}setMime(E){}}e.ExtHostCell=m;class s{static{this._handlePool=0}constructor(E,u,C,v,r){this._proxy=E,this._textDocumentsAndEditors=u,this._textDocuments=C,this.uri=v,this.handle=s._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1,this._notebookType=r.viewType,this._metadata=Object.freeze(r.metadata??Object.create(null)),this._spliceNotebookCells([[0,0,r.cells]],!0,void 0),this._versionId=r.versionId}dispose(){this._disposed=!0}get versionId(){return this._versionId}get apiNotebook(){if(!this._notebook){const E=this,u={get uri(){return E.uri},get version(){return E._versionId},get notebookType(){return E._notebookType},get isDirty(){return E._isDirty},get isUntitled(){return E.uri.scheme===S.Schemas.untitled},get isClosed(){return E._disposed},get metadata(){return E._metadata},get cellCount(){return E._cells.length},cellAt(C){return C=E._validateIndex(C),E._cells[C].apiCell},getCells(C){return(C?E._getCells(C):E._cells).map(r=>r.apiCell)},save(){return E._save()},[Symbol.for("debug.description")](){return`NotebookDocument(${this.uri.toString()})`}};this._notebook=Object.freeze(u)}return this._notebook}acceptDocumentPropertiesChanged(E){E.metadata&&(this._metadata=Object.freeze({...this._metadata,...E.metadata}))}acceptDirty(E){this._isDirty=E}acceptModelChanged(E,u,C){this._versionId=E.versionId,this._isDirty=u,this.acceptDocumentPropertiesChanged({metadata:C});const v={notebook:this.apiNotebook,metadata:C,cellChanges:[],contentChanges:[]},r=[];for(const d of E.rawEvents)d.kind===k.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(d.changes,!1,v.contentChanges):d.kind===k.NotebookCellsChangeType.Move?this._moveCells(d.index,d.length,d.newIdx,v.contentChanges):d.kind===k.NotebookCellsChangeType.Output?(this._setCellOutputs(d.index,d.outputs),r.push({cell:this._cells[d.index].apiCell,outputs:this._cells[d.index].apiCell.outputs})):d.kind===k.NotebookCellsChangeType.OutputItem?(this._setCellOutputItems(d.index,d.outputId,d.append,d.outputItems),r.push({cell:this._cells[d.index].apiCell,outputs:this._cells[d.index].apiCell.outputs})):d.kind===k.NotebookCellsChangeType.ChangeCellLanguage?(this._changeCellLanguage(d.index,d.language),r.push({cell:this._cells[d.index].apiCell,document:this._cells[d.index].apiCell.document})):d.kind===k.NotebookCellsChangeType.ChangeCellContent?r.push({cell:this._cells[d.index].apiCell,document:this._cells[d.index].apiCell.document}):d.kind===k.NotebookCellsChangeType.ChangeCellMime?this._changeCellMime(d.index,d.mime):d.kind===k.NotebookCellsChangeType.ChangeCellMetadata?(this._changeCellMetadata(d.index,d.metadata),r.push({cell:this._cells[d.index].apiCell,metadata:this._cells[d.index].apiCell.metadata})):d.kind===k.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this._changeCellInternalMetadata(d.index,d.internalMetadata),r.push({cell:this._cells[d.index].apiCell,executionSummary:this._cells[d.index].apiCell.executionSummary}));const a=new Map;for(let d=0;d<r.length;d++){const l=r[d],i=a.get(l.cell);if(i===void 0){const n=v.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...l});a.set(l.cell,n-1)}else v.cellChanges[i]={...v.cellChanges[i],...l}}return Object.freeze(v),Object.freeze(v.cellChanges),Object.freeze(v.contentChanges),v}_validateIndex(E){return E=E|0,E<0?0:E>=this._cells.length?this._cells.length-1:E}_validateRange(E){let u=E.start|0,C=E.end|0;return u<0&&(u=0),C>this._cells.length&&(C=this._cells.length),E.with({start:u,end:C})}_getCells(E){E=this._validateRange(E);const u=[];for(let C=E.start;C<E.end;C++)u.push(this._cells[C]);return u}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(E,u,C){if(this._disposed)return;const v=[],r=[],a=[];if(E.reverse().forEach(d=>{const i=d[2].map(o=>{const c=new m(this,this._textDocumentsAndEditors,o);return u||r.push(m.asModelAddData(o)),c}),n=new A(d[0],d[1],[],i),t=this._cells.splice(d[0],d[1],...i);for(const o of t)a.push(o.uri),n.deletedItems.push(o.apiCell);v.push(n)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:r,removedDocuments:a}),C)for(const d of v)C.push(d.asApiEvent())}_moveCells(E,u,C,v){const r=this._cells.splice(E,u);this._cells.splice(C,0,...r);const a=[new A(E,u,r.map(d=>d.apiCell),[]),new A(C,0,[],r)];for(const d of a)v.push(d.asApiEvent())}_setCellOutputs(E,u){this._cells[E].setOutputs(u)}_setCellOutputItems(E,u,C,v){this._cells[E].setOutputItems(u,C,v)}_changeCellLanguage(E,u){const C=this._cells[E];C.apiCell.document.languageId!==u&&this._textDocuments.$acceptModelLanguageChanged(C.uri,u)}_changeCellMime(E,u){const C=this._cells[E];C.apiCell.mime=u}_changeCellMetadata(E,u){this._cells[E].setMetadata(u)}_changeCellInternalMetadata(E,u){this._cells[E].setInternalMetadata(u)}getCellFromApiCell(E){return this._cells.find(u=>u.apiCell===E)}getCellFromIndex(E){return this._cells[E]}getCell(E){return this._cells.find(u=>u.handle===E)}getCellIndex(E){return this._cells.indexOf(E)}}e.ExtHostNotebookDocument=s}),define(ke[247],Re([1,0,6,2,8,7,39]),function(Ee,e,S,T,D,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocumentSaveParticipant=void 0;class A{constructor(s,I,E,u={timeout:1500,errors:3}){this._logService=s,this._notebooksAndEditors=I,this._mainThreadBulkEdits=E,this._thresholds=u,this._onWillSaveNotebookDocumentEvent=new S.AsyncEmitter}dispose(){}getOnWillSaveNotebookDocumentEvent(s){return(I,E,u)=>{const C=function(r){I.call(E,r)};return C.extension=s,this._onWillSaveNotebookDocumentEvent.event(C,void 0,u)}}async $participateInSave(s,I,E){const u=T.URI.revive(s),C=this._notebooksAndEditors.getNotebookDocument(u);if(!C)throw new Error("Unable to resolve notebook document");const v=[];if(await this._onWillSaveNotebookDocumentEvent.fireAsync({notebook:C.apiNotebook,reason:D.TextDocumentSaveReason.to(I)},E,async(a,d)=>{const l=Date.now(),i=await await Promise.resolve(a);Date.now()-l>this._thresholds.timeout&&this._logService.warn("onWillSaveNotebookDocument-listener from extension",d.extension.identifier),!E.isCancellationRequested&&i&&(i instanceof O.WorkspaceEdit?v.push(i):this._logService.warn("onWillSaveNotebookDocument-listener from extension",d.extension.identifier,"ignored due to invalid data"))}),E.isCancellationRequested)return!1;if(v.length===0)return!0;const r={edits:[]};for(const a of v){const{edits:d}=D.WorkspaceEdit.from(a);r.edits=r.edits.concat(d)}return this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(new k.SerializableObjectWithBuffers(r))}}e.ExtHostNotebookDocumentSaveParticipant=A}),define(ke[126],Re([1,0,12,8,7]),function(Ee,e,S,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0,T=Ve(T),D=Ve(D);class O{static{this.apiEditorsToExtHost=new WeakMap}constructor(A,m,s,I,E,u){this.id=A,this._proxy=m,this.notebookData=s,this._selections=[],this._visibleRanges=[],this._visible=!1,this._selections=E,this._visibleRanges=I,this._viewColumn=u}get apiEditor(){if(!this._editor){const A=this;this._editor={get notebook(){return A.notebookData.apiNotebook},get selection(){return A._selections[0]},set selection(m){this.selections=[m]},get selections(){return A._selections},set selections(m){if(!Array.isArray(m)||!m.every(D.NotebookRange.isNotebookRange))throw(0,S.illegalArgument)("selections");A._selections=m,A._trySetSelections(m)},get visibleRanges(){return A._visibleRanges},revealRange(m,s){A._proxy.$tryRevealRange(A.id,T.NotebookRange.from(m),s??D.NotebookEditorRevealType.Default)},get viewColumn(){return A._viewColumn},[Symbol.for("debug.description")](){return`NotebookEditor(${this.notebook.uri.toString()})`}},O.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(A){this._visible=A}_acceptVisibleRanges(A){this._visibleRanges=A}_acceptSelections(A){this._selections=A}_trySetSelections(A){this._proxy.$trySetSelections(this.id,A.map(T.NotebookRange.from))}_acceptViewColumn(A){this._viewColumn=A}}e.ExtHostNotebookEditor=O}),define(ke[248],Re([1,0,6,11,8]),function(Ee,e,S,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0,D=Ve(D);let O=class{constructor(A,m){this._logService=A,this._notebooksAndEditors=m,this._onDidChangeNotebookEditorSelection=new S.Emitter,this._onDidChangeNotebookEditorVisibleRanges=new S.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event}$acceptEditorPropertiesChanged(A,m){this._logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",A,m);const s=this._notebooksAndEditors.getEditorById(A);m.visibleRanges&&s._acceptVisibleRanges(m.visibleRanges.ranges.map(D.NotebookRange.to)),m.selections&&s._acceptSelections(m.selections.selections.map(D.NotebookRange.to)),m.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:s.apiEditor,visibleRanges:s.apiEditor.visibleRanges}),m.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:s.apiEditor,selections:s.apiEditor.selections}))}$acceptEditorViewColumns(A){for(const m in A)this._notebooksAndEditors.getEditorById(m)._acceptViewColumn(D.ViewColumn.to(A[m]))}};e.ExtHostNotebookEditors=O,e.ExtHostNotebookEditors=O=qe([We(0,T.ILogService)],O)}),define(ke[249],Re([1,0,6,5,126]),function(Ee,e,S,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class O{constructor(A,m){this._extHostNotebook=m,this._rendererMessageEmitters=new Map,this.proxy=A.getProxy(T.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(A,m,s){const I=this._extHostNotebook.getEditorById(A);this._rendererMessageEmitters.get(m)?.fire({editor:I.apiEditor,message:s})}createRendererMessaging(A,m){if(!A.contributes?.notebookRenderer?.some(I=>I.id===m))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${m})`);return{onDidReceiveMessage:(I,E,u)=>this.getOrCreateEmitterFor(m).event(I,E,u),postMessage:(I,E)=>{D.ExtHostNotebookEditor.apiEditorsToExtHost.has(I)&&([I,E]=[E,I]);const u=E&&D.ExtHostNotebookEditor.apiEditorsToExtHost.get(E);return this.proxy.$postMessage(u?.id,m,I)}}}getOrCreateEmitterFor(A){let m=this._rendererMessageEmitters.get(A);return m||(m=new S.Emitter({onDidRemoveLastListener:()=>{m?.dispose(),this._rendererMessageEmitters.delete(A)}}),this._rendererMessageEmitters.set(A,m),m)}}e.ExtHostNotebookRenderers=O}),define(ke[250],Re([1,0,8,77,19,71,12]),function(Ee,e,S,T,D,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class A{constructor(E){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=E}async withProgress(E,u,C){const v=this._handles++,{title:r,location:a,cancellable:d}=u,l={label:E.displayName||E.name,id:E.identifier.value};return this._proxy.$startProgress(v,{location:S.ProgressLocation.from(a),title:r,source:l,cancellable:d},E.isUnderDevelopment?void 0:E.identifier.value).catch(k.onUnexpectedExternalError),this._withProgress(v,C,!!d)}_withProgress(E,u,C){let v;C&&(v=new D.CancellationTokenSource,this._mapHandleToCancellationSource.set(E,v));const r=d=>{this._proxy.$progressEnd(d),this._mapHandleToCancellationSource.delete(d),v?.dispose()};let a;try{a=u(new s(this._proxy,E),C&&v?v.token:D.CancellationToken.None)}catch(d){throw r(E),d}return a.then(d=>r(E),d=>r(E)),a}$acceptProgressCanceled(E){const u=this._mapHandleToCancellationSource.get(E);u&&(u.cancel(),this._mapHandleToCancellationSource.delete(E))}}e.ExtHostProgress=A;function m(I,E){return I.message=E.message,typeof E.increment=="number"&&(typeof I.increment=="number"?I.increment+=E.increment:I.increment=E.increment),I}class s extends T.Progress{constructor(E,u){super(C=>this.throttledReport(C)),this._proxy=E,this._handle=u}throttledReport(E){this._proxy.$progressReport(this._handle,E)}}qe([(0,O.throttle)(100,(I,E)=>m(I,E),()=>Object.create(null))],s.prototype,"throttledReport",null)}),define(ke[251],Re([1,0,2,5,10,8]),function(Ee,e,S,T,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostQuickDiff=void 0;class k{static{this.handlePool=0}constructor(m,s){this.uriTransformer=s,this.providers=new Map,this.proxy=m.getProxy(T.MainContext.MainThreadQuickDiff)}$provideOriginalResource(m,s,I){const E=S.URI.revive(s),u=this.providers.get(m);return u?(0,D.asPromise)(()=>u.provideOriginalResource(E,I)).then(C=>C||null):Promise.resolve(null)}registerQuickDiffProvider(m,s,I,E){const u=k.handlePool++;return this.providers.set(u,s),this.proxy.$registerQuickDiffProvider(u,O.DocumentSelector.from(m,this.uriTransformer),I,E),{dispose:()=>{this.proxy.$unregisterQuickDiffProvider(u),this.providers.delete(u)}}}}e.ExtHostQuickDiff=k});var oi=this&&this.__importDefault||function(Ee){return Ee&&Ee.__esModule?Ee:{default:Ee}};define(ke[252],Re([1,0,19,6,4,5,2,7,12,17,37,36,21,8]),function(Ee,e,S,T,D,O,k,A,m,s,I,E,u,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=v,I=oi(I);function v(r,a,d){const l=r.getProxy(O.MainContext.MainThreadQuickOpen);class i{constructor(y,w){this._sessions=new Map,this._instances=0,this._workspace=y,this._commands=w}showQuickPick(y,w,P,R=S.CancellationToken.None){this._onDidSelectItem=void 0;const p=Promise.resolve(w),b=++this._instances,N=l.$show(b,{title:P?.title,placeHolder:P?.placeHolder,matchOnDescription:P?.matchOnDescription,matchOnDetail:P?.matchOnDetail,ignoreFocusLost:P?.ignoreFocusOut,canPickMany:P?.canPickMany},R),L={},F=N.then(()=>L);return Promise.race([F,p]).then(K=>{if(K===L)return;const J=(0,u.isProposedApiEnabled)(y,"quickPickItemTooltip");return p.then($=>{const x=[];for(let G=0;G<$.length;G++){const Y=$[G];if(typeof Y=="string")x.push({label:Y,handle:G});else if(Y.kind===A.QuickPickItemKind.Separator)x.push({type:"separator",label:Y.label});else{Y.tooltip&&!J&&console.warn(`Extension '${y.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${y.identifier.value}`);const ae=Y.iconPath?g(Y.iconPath):void 0;x.push({label:Y.label,iconPath:ae?.iconPath,iconClass:ae?.iconClass,description:Y.description,detail:Y.detail,picked:Y.picked,alwaysShow:Y.alwaysShow,tooltip:J?C.MarkdownString.fromStrict(Y.tooltip):void 0,handle:G})}}return P&&typeof P.onDidSelectItem=="function"&&(this._onDidSelectItem=G=>{P.onDidSelectItem($[G])}),l.$setItems(b,x),N.then(G=>{if(typeof G=="number")return $[G];if(Array.isArray(G))return G.map(Y=>$[Y])})})}).then(void 0,K=>{if(!(0,m.isCancellationError)(K))return l.$setError(b,K),Promise.reject(K)})}$onItemSelected(y){this._onDidSelectItem?.(y)}showInput(y,w=S.CancellationToken.None){return this._validateInput=y?.validateInput,l.$input(y,typeof this._validateInput=="function",w).then(void 0,P=>{if(!(0,m.isCancellationError)(P))return Promise.reject(P)})}async $validateInput(y){if(!this._validateInput)return;const w=await this._validateInput(y);if(!w||typeof w=="string")return w;let P;switch(w.severity){case A.InputBoxValidationSeverity.Info:P=I.default.Info;break;case A.InputBoxValidationSeverity.Warning:P=I.default.Warning;break;case A.InputBoxValidationSeverity.Error:P=I.default.Error;break;default:P=w.message?I.default.Error:I.default.Ignore;break}return{content:w.message,severity:P}}async showWorkspaceFolderPick(y,w=S.CancellationToken.None){const P=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[y]);if(!P)return;const R=await this._workspace.getWorkspaceFolders2();if(R)return R.find(p=>p.uri.toString()===P.uri.toString())}createQuickPick(y){const w=new f(y,()=>this._sessions.delete(w._id));return this._sessions.set(w._id,w),w}createInputBox(y){const w=new h(y,()=>this._sessions.delete(w._id));return this._sessions.set(w._id,w),w}$onDidChangeValue(y,w){this._sessions.get(y)?._fireDidChangeValue(w)}$onDidAccept(y){this._sessions.get(y)?._fireDidAccept()}$onDidChangeActive(y,w){const P=this._sessions.get(y);P instanceof f&&P._fireDidChangeActive(w)}$onDidChangeSelection(y,w){const P=this._sessions.get(y);P instanceof f&&P._fireDidChangeSelection(w)}$onDidTriggerButton(y,w){this._sessions.get(y)?._fireDidTriggerButton(w)}$onDidTriggerItemButton(y,w,P){const R=this._sessions.get(y);R instanceof f&&R._fireDidTriggerItemButton(w,P)}$onDidHide(y){this._sessions.get(y)?._fireDidHide()}}class n{static{this._nextId=1}constructor(y,w){this._extension=y,this._onDidDispose=w,this._id=f._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new T.Emitter,this._onDidChangeValueEmitter=new T.Emitter,this._onDidTriggerButtonEmitter=new T.Emitter,this._onDidHideEmitter=new T.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(y){this._title=y,this.update({title:y})}get step(){return this._steps}set step(y){this._steps=y,this.update({step:y})}get totalSteps(){return this._totalSteps}set totalSteps(y){this._totalSteps=y,this.update({totalSteps:y})}get enabled(){return this._enabled}set enabled(y){this._enabled=y,this.update({enabled:y})}get busy(){return this._busy}set busy(y){this._busy=y,this.update({busy:y})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(y){this._ignoreFocusOut=y,this.update({ignoreFocusOut:y})}get value(){return this._value}set value(y){this._value=y,this.update({value:y})}get placeholder(){return this._placeholder}set placeholder(y){this._placeholder=y,this.update({placeholder:y})}get buttons(){return this._buttons}set buttons(y){const w=(0,u.isProposedApiEnabled)(this._extension,"quickInputButtonLocation");!w&&y.some(P=>P.location)&&console.warn(`Extension '${this._extension.identifier.value}' uses a button location which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this._extension.identifier.value}`),this._buttons=y.slice(),this._handlesToButtons.clear(),y.forEach((P,R)=>{const p=P===A.QuickInputButtons.Back?-1:R;this._handlesToButtons.set(p,P)}),this.update({buttons:y.map((P,R)=>({...g(P.iconPath),tooltip:P.tooltip,handle:P===A.QuickInputButtons.Back?-1:R,location:w?P.location:void 0}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(y){this._value=y,this._onDidChangeValueEmitter.fire(y)}_fireDidTriggerButton(y){const w=this._handlesToButtons.get(y);w&&this._onDidTriggerButtonEmitter.fire(w)}_fireDidHide(){this._expectingHide&&(this._expectingHide=this._visible,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,D.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),l.$dispose(this._id))}update(y){if(!this._disposed){for(const w of Object.keys(y)){const P=y[w];this._pendingUpdate[w]=P===void 0?null:P}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){l.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}function t(_){if(_ instanceof A.ThemeIcon)return{id:_.id};const y=c(_),w=o(_);return{dark:typeof y=="string"?k.URI.file(y):y,light:typeof w=="string"?k.URI.file(w):w}}function o(_){return typeof _=="object"&&"light"in _?_.light:_}function c(_){return typeof _=="object"&&"dark"in _?_.dark:_}function g(_){const y=t(_);let w,P;return"id"in y?P=E.ThemeIcon.asClassName(y):w=y,{iconPath:w,iconClass:P}}class f extends n{constructor(y,w){super(y,w),this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._keepScrollPosition=!1,this._activeItems=[],this._onDidChangeActiveEmitter=new T.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new T.Emitter,this._onDidTriggerItemButtonEmitter=new T.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this.onDidTriggerItemButton=this._onDidTriggerItemButtonEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter,this._onDidTriggerItemButtonEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(y){this._items=y.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),y.forEach((R,p)=>{this._handlesToItems.set(p,R),this._itemsToHandles.set(R,p)});const w=(0,u.isProposedApiEnabled)(this._extension,"quickPickItemTooltip"),P=[];for(let R=0;R<y.length;R++){const p=y[R];if(p.kind===A.QuickPickItemKind.Separator)P.push({type:"separator",label:p.label});else{p.tooltip&&!w&&console.warn(`Extension '${this._extension.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this._extension.identifier.value}`);const b=p.iconPath?g(p.iconPath):void 0;P.push({handle:R,label:p.label,iconPath:b?.iconPath,iconClass:b?.iconClass,description:p.description,detail:p.detail,picked:p.picked,alwaysShow:p.alwaysShow,tooltip:w?C.MarkdownString.fromStrict(p.tooltip):void 0,buttons:p.buttons?.map((N,L)=>({...g(N.iconPath),tooltip:N.tooltip,handle:L}))})}}this.update({items:P})}get canSelectMany(){return this._canSelectMany}set canSelectMany(y){this._canSelectMany=y,this.update({canSelectMany:y})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(y){this._matchOnDescription=y,this.update({matchOnDescription:y})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(y){this._matchOnDetail=y,this.update({matchOnDetail:y})}get sortByLabel(){return this._sortByLabel}set sortByLabel(y){this._sortByLabel=y,this.update({sortByLabel:y})}get keepScrollPosition(){return this._keepScrollPosition}set keepScrollPosition(y){this._keepScrollPosition=y,this.update({keepScrollPosition:y})}get activeItems(){return this._activeItems}set activeItems(y){this._activeItems=y.filter(w=>this._itemsToHandles.has(w)),this.update({activeItems:this._activeItems.map(w=>this._itemsToHandles.get(w))})}get selectedItems(){return this._selectedItems}set selectedItems(y){this._selectedItems=y.filter(w=>this._itemsToHandles.has(w)),this.update({selectedItems:this._selectedItems.map(w=>this._itemsToHandles.get(w))})}_fireDidChangeActive(y){const w=(0,s.coalesce)(y.map(P=>this._handlesToItems.get(P)));this._activeItems=w,this._onDidChangeActiveEmitter.fire(w)}_fireDidChangeSelection(y){const w=(0,s.coalesce)(y.map(P=>this._handlesToItems.get(P)));this._selectedItems=w,this._onDidChangeSelectionEmitter.fire(w)}_fireDidTriggerItemButton(y,w){const P=this._handlesToItems.get(y);if(!P||!P.buttons||!P.buttons.length)return;const R=P.buttons[w];R&&this._onDidTriggerItemButtonEmitter.fire({button:R,item:P})}}class h extends n{constructor(y,w){super(y,w),this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(y){this._password=y,this.update({password:y})}get prompt(){return this._prompt}set prompt(y){this._prompt=y,this.update({prompt:y})}get valueSelection(){return this._valueSelection}set valueSelection(y){this._valueSelection=y,this.update({valueSelection:y})}get validationMessage(){return this._validationMessage}set validationMessage(y){this._validationMessage=y,y?typeof y=="string"?this.update({validationMessage:y,severity:I.default.Error}):this.update({validationMessage:y.message,severity:y.severity??I.default.Error}):this.update({validationMessage:void 0,severity:I.default.Ignore})}}return new i(a,d)}}),define(ke[253],Re([1,0,2,6,71,4,10,5,17,159,11,18,38,36,8,21,15,23]),function(Ee,e,S,T,D,O,k,A,m,s,I,E,u,C,v,r,a,d){"use strict";var l;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function i(L){return L instanceof S.URI}function n(L,F){return L.scheme===a.Schemas.file&&F.scheme===a.Schemas.file&&d.isLinux?L.toString()===F.toString():L.toString().toLowerCase()===F.toString().toLowerCase()}function t(L){if(L)return typeof L.iconPath=="string"?S.URI.file(L.iconPath):S.URI.isUri(L.iconPath)||C.ThemeIcon.isThemeIcon(L.iconPath)?L.iconPath:void 0}function o(L){if(L){if(S.URI.isUri(L))return L;if(C.ThemeIcon.isThemeIcon(L))return L;{const F=L;return{light:F.light,dark:F.dark}}}else return}function c(L){const F=o(L.icon),K=L.labels?.map(J=>({title:J.title,icon:o(J.icon)}));return{...L,icon:F,labels:K}}function g(L,F){if(!L.iconPath&&!F.iconPath)return 0;if(L.iconPath){if(!F.iconPath)return 1}else return-1;const K=typeof L.iconPath=="string"?L.iconPath:S.URI.isUri(L.iconPath)?L.iconPath.fsPath:L.iconPath.id,J=typeof F.iconPath=="string"?F.iconPath:S.URI.isUri(F.iconPath)?F.iconPath.fsPath:F.iconPath.id;return(0,s.comparePaths)(K,J)}function f(L,F){let K=0;if(L.strikeThrough!==F.strikeThrough)return L.strikeThrough?1:-1;if(L.faded!==F.faded)return L.faded?1:-1;if(L.tooltip!==F.tooltip)return(L.tooltip||"").localeCompare(F.tooltip||"");if(K=g(L,F),K!==0)return K;if(L.light&&F.light)K=g(L.light,F.light);else{if(L.light)return 1;if(F.light)return-1}if(K!==0)return K;if(L.dark&&F.dark)K=g(L.dark,F.dark);else{if(L.dark)return 1;if(F.dark)return-1}return K}function h(L,F){if(L.command!==F.command)return L.command<F.command?-1:1;if(L.title!==F.title)return L.title<F.title?-1:1;if(L.tooltip!==F.tooltip){if(L.tooltip!==void 0&&F.tooltip!==void 0)return L.tooltip<F.tooltip?-1:1;if(L.tooltip!==void 0)return 1;if(F.tooltip!==void 0)return-1}if(L.arguments===F.arguments)return 0;if(L.arguments)if(F.arguments){if(L.arguments.length!==F.arguments.length)return L.arguments.length-F.arguments.length}else return 1;else return-1;for(let K=0;K<L.arguments.length;K++){const J=L.arguments[K],$=F.arguments[K];if(J!==$&&!(i(J)&&i($)&&n(J,$)))return J<$?-1:1}return 0}function _(L,F){let K=(0,s.comparePaths)(L.resourceUri.fsPath,F.resourceUri.fsPath,!0);if(K!==0)return K;if(L.command&&F.command)K=h(L.command,F.command);else{if(L.command)return 1;if(F.command)return-1}if(K!==0)return K;if(L.decorations&&F.decorations)K=f(L.decorations,F.decorations);else{if(L.decorations)return 1;if(F.decorations)return-1}if(L.multiFileDiffEditorModifiedUri&&F.multiFileDiffEditorModifiedUri)K=(0,s.comparePaths)(L.multiFileDiffEditorModifiedUri.fsPath,F.multiFileDiffEditorModifiedUri.fsPath,!0);else{if(L.multiFileDiffEditorModifiedUri)return 1;if(F.multiFileDiffEditorModifiedUri)return-1}if(L.multiDiffEditorOriginalUri&&F.multiDiffEditorOriginalUri)K=(0,s.comparePaths)(L.multiDiffEditorOriginalUri.fsPath,F.multiDiffEditorOriginalUri.fsPath,!0);else{if(L.multiDiffEditorOriginalUri)return 1;if(F.multiDiffEditorOriginalUri)return-1}return K}function y(L,F){for(let K=0;K<L.length;K++)if(L[K]!==F[K])return!1;return!0}function w(L,F){return L.command===F.command&&L.title===F.title&&L.tooltip===F.tooltip&&(L.arguments&&F.arguments?y(L.arguments,F.arguments):L.arguments===F.arguments)}function P(L,F){return(0,m.equals)(L,F,w)}class R{#e;#t;get value(){return this._value}set value(F){F=F??"",this.#e.$setInputBoxValue(this._sourceControlHandle,F),this.updateValue(F)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(F){this.#e.$setInputBoxPlaceholder(this._sourceControlHandle,F),this._placeholder=F}get validateInput(){return(0,r.checkProposedApiEnabled)(this._extension,"scmValidation"),this._validateInput}set validateInput(F){if((0,r.checkProposedApiEnabled)(this._extension,"scmValidation"),F&&typeof F!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=F,this.#e.$setValidationProviderIsEnabled(this._sourceControlHandle,!!F)}get enabled(){return this._enabled}set enabled(F){F=!!F,this._enabled!==F&&(this._enabled=F,this.#e.$setInputBoxEnablement(this._sourceControlHandle,F))}get visible(){return this._visible}set visible(F){F=!!F,this._visible!==F&&(this._visible=F,this.#e.$setInputBoxVisibility(this._sourceControlHandle,F))}get document(){return(0,r.checkProposedApiEnabled)(this._extension,"scmTextDocument"),this.#t.getDocument(this._documentUri)}constructor(F,K,J,$,x){this._extension=F,this._sourceControlHandle=$,this._documentUri=x,this._value="",this._onDidChange=new T.Emitter,this._placeholder="",this._enabled=!0,this._visible=!0,this.#t=K,this.#e=J}showValidationMessage(F,K){(0,r.checkProposedApiEnabled)(this._extension,"scmValidation"),this.#e.$showValidationMessage(this._sourceControlHandle,F,K)}$onInputBoxValueChange(F){this.updateValue(F)}updateValue(F){this._value=F,this._onDidChange.fire(F)}}e.ExtHostSCMInputBox=R;class p{static{this._handlePool=0}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(F){this._label=F,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,F)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(F){this._hideWhenEmpty=F,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(F){this._resourceStates=[...F],this._onDidUpdateResourceStates.fire()}constructor(F,K,J,$,x,G,Y){this._proxy=F,this._commands=K,this._sourceControlHandle=J,this._id=$,this._label=x,this.multiDiffEditorEnableViewChanges=G,this._extension=Y,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new T.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new T.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=p._handlePool++}getResourceState(F){return this._resourceStatesMap.get(F)}$executeResourceCommand(F,K){const J=this._resourceStatesCommandsMap.get(F);return J?(0,k.asPromise)(()=>this._commands.executeCommand(J.command,...J.arguments||[],K)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const F=[...this._resourceStates].sort(_),J=(0,m.sortedDiff)(this._resourceSnapshot,F,_).map(G=>{const Y=G.toInsert.map(ae=>{const ee=this._resourceHandlePool++;this._resourceStatesMap.set(ee,ae);const oe=ae.resourceUri;let ie;if(ae.command)if(ae.command.command==="vscode.open"||ae.command.command==="vscode.diff"||ae.command.command==="vscode.changes"){const nt=new O.DisposableStore;ie=this._commands.converter.toInternal(ae.command,nt),this._resourceStatesDisposablesMap.set(ee,nt)}else this._resourceStatesCommandsMap.set(ee,ae.command);const ue=(0,r.isProposedApiEnabled)(this._extension,"scmMultiDiffEditor"),Z=ue?ae.multiDiffEditorOriginalUri:void 0,ve=ue?ae.multiFileDiffEditorModifiedUri:void 0,Ie=t(ae.decorations),X=ae.decorations&&t(ae.decorations.light)||Ie,V=ae.decorations&&t(ae.decorations.dark)||Ie,re=[X,V],be=ae.decorations&&ae.decorations.tooltip||"",De=ae.decorations&&!!ae.decorations.strikeThrough,Fe=ae.decorations&&!!ae.decorations.faded,ze=ae.contextValue||"";return{rawResource:[ee,oe,re,be,De,Fe,ze,ie,Z,ve],handle:ee}});return{start:G.start,deleteCount:G.deleteCount,toInsert:Y}}),$=J.map(({start:G,deleteCount:Y,toInsert:ae})=>[G,Y,ae.map(ee=>ee.rawResource)]),x=J.reverse();for(const{start:G,deleteCount:Y,toInsert:ae}of x){const ee=ae.map(ie=>ie.handle),oe=this._handlesSnapshot.splice(G,Y,...ee);for(const ie of oe)this._resourceStatesMap.delete(ie),this._resourceStatesCommandsMap.delete(ie),this._resourceStatesDisposablesMap.get(ie)?.dispose(),this._resourceStatesDisposablesMap.delete(ie)}return this._resourceSnapshot=F,$}dispose(){this._disposed=!0,this._onDidDispose.fire()}}class b{static{this._handlePool=0}#e;get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(F){this._count!==F&&(this._count=F,this.#e.$updateSourceControl(this.handle,{count:F}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(F){this._quickDiffProvider=F;let K;(0,r.isProposedApiEnabled)(this._extension,"quickDiffProvider")&&(K=F?.label),this.#e.$updateSourceControl(this.handle,{hasQuickDiffProvider:!!F,quickDiffLabel:K})}get historyProvider(){return(0,r.checkProposedApiEnabled)(this._extension,"scmHistoryProvider"),this._historyProvider}set historyProvider(F){(0,r.checkProposedApiEnabled)(this._extension,"scmHistoryProvider"),this._historyProvider=F,this._historyProviderDisposable.value=new O.DisposableStore,this.#e.$updateSourceControl(this.handle,{hasHistoryProvider:!!F}),F&&this._historyProviderDisposable.value.add(F.onDidChangeCurrentHistoryItemGroup(()=>{this._historyProviderCurrentHistoryItemGroup=F?.currentHistoryItemGroup,this.#e.$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.handle,this._historyProviderCurrentHistoryItemGroup)}))}get commitTemplate(){return this._commitTemplate}set commitTemplate(F){F!==this._commitTemplate&&(this._commitTemplate=F,this.#e.$updateSourceControl(this.handle,{commitTemplate:F}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(F){this._acceptInputDisposables.value=new O.DisposableStore,this._acceptInputCommand=F;const K=this._commands.converter.toInternal(F,this._acceptInputDisposables.value);this.#e.$updateSourceControl(this.handle,{acceptInputCommand:K})}get actionButton(){return(0,r.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButton}set actionButton(F){(0,r.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButtonDisposables.value=new O.DisposableStore,this._actionButton=F;const K=F!==void 0?{command:this._commands.converter.toInternal(F.command,this._actionButtonDisposables.value),secondaryCommands:F.secondaryCommands?.map(J=>J.map($=>this._commands.converter.toInternal($,this._actionButtonDisposables.value))),description:F.description,enabled:F.enabled}:void 0;this.#e.$updateSourceControl(this.handle,{actionButton:K??null})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(F){if(this._statusBarCommands&&F&&P(this._statusBarCommands,F))return;this._statusBarDisposables.value=new O.DisposableStore,this._statusBarCommands=F;const K=(F||[]).map(J=>this._commands.converter.toInternal(J,this._statusBarDisposables.value));this.#e.$updateSourceControl(this.handle,{statusBarCommands:K})}get selected(){return this._selected}constructor(F,K,J,$,x,G,Y){this._extension=F,this._commands=$,this._id=x,this._label=G,this._rootUri=Y,this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._historyProviderDisposable=new O.MutableDisposable,this._commitTemplate=void 0,this._acceptInputDisposables=new O.MutableDisposable,this._acceptInputCommand=void 0,this._actionButtonDisposables=new O.MutableDisposable,this._statusBarDisposables=new O.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new T.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=b._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,this.#e=J;const ae=S.URI.from({scheme:a.Schemas.vscodeSourceControl,path:`${x}/scm${this.handle}/input`,query:Y?`rootUri=${encodeURIComponent(Y.toString())}`:void 0});this._inputBox=new R(F,K,this.#e,this.handle,ae),this.#e.$registerSourceControl(this.handle,x,G,Y,ae)}createResourceGroup(F,K,J){const $=(0,r.isProposedApiEnabled)(this._extension,"scmMultiDiffEditor")&&J?.multiDiffEditorEnableViewChanges===!0,x=new p(this.#e,this._commands,this.handle,F,K,$,this._extension),G=T.Event.once(x.onDidDispose)(()=>this.createdResourceGroups.delete(x));return this.createdResourceGroups.set(x,G),this.eventuallyAddResourceGroups(),x}eventuallyAddResourceGroups(){const F=[],K=[];for(const[J,$]of this.createdResourceGroups){$.dispose();const x=J.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(J),this.eventuallyUpdateResourceStates()});T.Event.once(J.onDidDispose)(()=>{this.updatedResourceGroups.delete(J),x.dispose(),this._groups.delete(J.handle),this.#e.$unregisterGroup(this.handle,J.handle)}),F.push([J.handle,J.id,J.label,J.features,J.multiDiffEditorEnableViewChanges]);const G=J._takeResourceStateSnapshot();G.length>0&&K.push([J.handle,G]),this._groups.set(J.handle,J)}this.#e.$registerGroups(this.handle,F,K),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const F=[];this.updatedResourceGroups.forEach(K=>{const J=K._takeResourceStateSnapshot();J.length!==0&&F.push([K.handle,J])}),F.length>0&&this.#e.$spliceResourceStates(this.handle,F),this.updatedResourceGroups.clear()}getResourceGroup(F){return this._groups.get(F)}setSelectionState(F){this._selected=F,this._onDidChangeSelection.fire(F)}dispose(){this._acceptInputDisposables.dispose(),this._actionButtonDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(F=>F.dispose()),this.#e.$unregisterSourceControl(this.handle)}}qe([(0,D.debounce)(100)],b.prototype,"eventuallyAddResourceGroups",null),qe([(0,D.debounce)(100)],b.prototype,"eventuallyUpdateResourceStates",null);let N=class{static{l=this}static{this._handlePool=0}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}constructor(F,K,J,$){this._commands=K,this._extHostDocuments=J,this.logService=$,this._sourceControls=new Map,this._sourceControlsByExtension=new E.ExtensionIdentifierMap,this._onDidChangeActiveProvider=new T.Emitter,this._proxy=F.getProxy(A.MainContext.MainThreadSCM),this._telemetry=F.getProxy(A.MainContext.MainThreadTelemetry),K.registerArgumentProcessor({processArgument:x=>{if(x&&x.$mid===u.MarshalledId.ScmResource){const G=this._sourceControls.get(x.sourceControlHandle);if(!G)return x;const Y=G.getResourceGroup(x.groupHandle);return Y?Y.getResourceState(x.handle):x}else if(x&&x.$mid===u.MarshalledId.ScmResourceGroup){const G=this._sourceControls.get(x.sourceControlHandle);return G?G.getResourceGroup(x.groupHandle):x}else if(x&&x.$mid===u.MarshalledId.ScmProvider){const G=this._sourceControls.get(x.handle);return G||x}return x}})}createSourceControl(F,K,J,$){this.logService.trace("ExtHostSCM#createSourceControl",F.identifier.value,K,J,$),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:F.identifier.value});const x=l._handlePool++,G=new b(F,this._extHostDocuments,this._proxy,this._commands,K,J,$);this._sourceControls.set(x,G);const Y=this._sourceControlsByExtension.get(F.identifier)||[];return Y.push(G),this._sourceControlsByExtension.set(F.identifier,Y),G}getLastInputBox(F){this.logService.trace("ExtHostSCM#getLastInputBox",F.identifier.value);const K=this._sourceControlsByExtension.get(F.identifier),J=K&&K[K.length-1];return J&&J.inputBox}$provideOriginalResource(F,K,J){const $=S.URI.revive(K);this.logService.trace("ExtHostSCM#$provideOriginalResource",F,$.toString());const x=this._sourceControls.get(F);return!x||!x.quickDiffProvider||!x.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,k.asPromise)(()=>x.quickDiffProvider.provideOriginalResource($,J)).then(G=>G||null)}$onInputBoxValueChange(F,K){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",F);const J=this._sourceControls.get(F);return J&&J.inputBox.$onInputBoxValueChange(K),Promise.resolve(void 0)}$executeResourceCommand(F,K,J,$){this.logService.trace("ExtHostSCM#$executeResourceCommand",F,K,J);const x=this._sourceControls.get(F);if(!x)return Promise.resolve(void 0);const G=x.getResourceGroup(K);return G?G.$executeResourceCommand(J,$):Promise.resolve(void 0)}$validateInput(F,K,J){this.logService.trace("ExtHostSCM#$validateInput",F);const $=this._sourceControls.get(F);return!$||!$.inputBox.validateInput?Promise.resolve(void 0):(0,k.asPromise)(()=>$.inputBox.validateInput(K,J)).then(x=>{if(!x)return Promise.resolve(void 0);const G=v.MarkdownString.fromStrict(x.message);return G?Promise.resolve([G,x.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(F){return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",F),F!==void 0&&this._sourceControls.get(F)?.setSelectionState(!0),this._selectedSourceControlHandle!==void 0&&this._sourceControls.get(this._selectedSourceControlHandle)?.setSelectionState(!1),this._selectedSourceControlHandle=F,Promise.resolve(void 0)}async $resolveHistoryItemGroupCommonAncestor(F,K,J,$){return await this._sourceControls.get(F)?.historyProvider?.resolveHistoryItemGroupCommonAncestor(K,J,$)??void 0}async $resolveHistoryItemGroupCommonAncestor2(F,K,J){return await this._sourceControls.get(F)?.historyProvider?.resolveHistoryItemGroupCommonAncestor2(K,J)??void 0}async $provideHistoryItems(F,K,J,$){return(await this._sourceControls.get(F)?.historyProvider?.provideHistoryItems(K,J,$))?.map(Y=>c(Y))??void 0}async $provideHistoryItems2(F,K,J){return(await this._sourceControls.get(F)?.historyProvider?.provideHistoryItems2(K,J))?.map(G=>c(G))??void 0}async $provideHistoryItemSummary(F,K,J,$){const x=this._sourceControls.get(F)?.historyProvider;if(typeof x?.provideHistoryItemSummary!="function")return;const G=await x.provideHistoryItemSummary(K,J,$);return G?c(G):void 0}async $provideHistoryItemChanges(F,K,J,$){return await this._sourceControls.get(F)?.historyProvider?.provideHistoryItemChanges(K,J,$)??void 0}};e.ExtHostSCM=N,e.ExtHostSCM=N=l=qe([We(3,I.ILogService)],N)}),define(ke[254],Re([1,0,5,8,2]),function(Ee,e,S,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostShare=void 0;class O{static{this.handlePool=0}constructor(A,m){this.uriTransformer=m,this.providers=new Map,this.proxy=A.getProxy(S.MainContext.MainThreadShare)}async $provideShare(A,m,s){return await this.providers.get(A)?.provideShare({selection:T.Range.to(m.selection),resourceUri:D.URI.revive(m.resourceUri)},s)??void 0}registerShareProvider(A,m){const s=O.handlePool++;return this.providers.set(s,m),this.proxy.$registerShareProvider(s,T.DocumentSelector.from(A,this.uriTransformer),m.id,m.label,m.priority),{dispose:()=>{this.proxy.$unregisterShareProvider(s),this.providers.delete(s)}}}}e.ExtHostShare=O}),define(ke[255],Re([1,0,7,5,9,4,8,14]),function(Ee,e,S,T,D,O,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class m{static{this.ID_GEN=0}static{this.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new S.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new S.ThemeColor("statusBarItem.warningForeground")]])}#e;#t;constructor(u,C,v,r,a,d=S.StatusBarAlignment.Left,l){if(this._disposed=!1,this._text="",this._staleCommandRegistrations=new O.DisposableStore,this.#e=u,this.#t=C,a&&r){this._entryId=(0,S.asStatusBarItemIdentifier)(r.identifier,a);const i=v.get(this._entryId);i&&(d=i.alignLeft?S.StatusBarAlignment.Left:S.StatusBarAlignment.Right,l=i.priority,this._visible=!0,this.name=i.name,this.text=i.text,this.tooltip=i.tooltip,this.command=i.command,this.accessibilityInformation=i.accessibilityInformation)}else this._entryId=String(m.ID_GEN++);this._extension=r,this._id=a,this._alignment=d,this._priority=this.validatePriority(l)}validatePriority(u){if((0,A.isNumber)(u))return u===Number.POSITIVE_INFINITY?Number.MAX_VALUE:u===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:u}get id(){return this._id??this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){return this._command?.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(u){this._text=u,this.update()}set name(u){this._name=u,this.update()}set tooltip(u){this._tooltip=u,this.update()}set color(u){this._color=u,this.update()}set backgroundColor(u){u&&!m.ALLOWED_BACKGROUND_COLORS.has(u.id)&&(u=void 0),this._backgroundColor=u,this.update()}set command(u){this._command?.fromApi!==u&&(this._latestCommandRegistration&&this._staleCommandRegistrations.add(this._latestCommandRegistration),this._latestCommandRegistration=new O.DisposableStore,typeof u=="string"?this._command={fromApi:u,internal:this.#t.toInternal({title:"",command:u},this._latestCommandRegistration)}:u?this._command={fromApi:u,internal:this.#t.toInternal(u,this._latestCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(u){this._accessibilityInformation=u,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,this.#e.$disposeEntry(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{this._timeoutHandle=void 0;let u;this._extension?this._id?u=`${this._extension.identifier.value}.${this._id}`:u=this._extension.identifier.value:u=this._id;let C;this._name?C=this._name:C=(0,D.localize)(2711,null,this._extension.displayName||this._extension.name);let v=this._color;this._backgroundColor&&(v=m.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id));const r=k.MarkdownString.fromStrict(this._tooltip);this.#e.$setEntry(this._entryId,u,this._extension?.identifier.value,C,this._text,r,this._command?.internal,v,this._backgroundColor,this._alignment===S.StatusBarAlignment.Left,this._priority,this._accessibilityInformation),this._staleCommandRegistrations.clear()},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=m;class s{constructor(u){this._messages=[],this._item=u.createStatusBarEntry(void 0,"status.extensionMessage",S.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=(0,D.localize)(2712,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(u){const C={message:u};return this._messages.unshift(C),this._update(),new S.Disposable(()=>{const v=this._messages.indexOf(C);v>=0&&(this._messages.splice(v,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class I{constructor(u,C){this._existingItems=new Map,this._proxy=u.getProxy(T.MainContext.MainThreadStatusBar),this._commands=C,this._statusMessage=new s(this)}$acceptStaticEntries(u){for(const C of u)this._existingItems.set(C.entryId,C)}createStatusBarEntry(u,C,v,r){return new m(this._proxy,this._commands,this._existingItems,u,C,v,r)}setStatusBarMessage(u,C){const v=this._statusMessage.setMessage(u);let r;return typeof C=="number"?r=setTimeout(()=>v.dispose(),C):typeof C<"u"&&C.then(()=>v.dispose(),()=>v.dispose()),new S.Disposable(()=>{v.dispose(),clearTimeout(r)})}}e.ExtHostStatusBar=I}),define(ke[127],Re([1,0,32,118,54,82,55,8,2]),function(Ee,e,S,T,D,O,k,A,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTestItemCollection=e.TestItemRootImpl=e.TestItemImpl=e.toItemFromContext=void 0,S=Ve(S),A=Ve(A);const s=(i,n,t,o)=>{let c=n;return{enumerable:!0,configurable:!1,get(){return c},set(g){if(!t(c,g)){const f=c;c=g,i.listener?.(o(g,f))}}}},I=(i,n)=>i===n,E={range:(i,n)=>i===n?!0:!i||!n?!1:i.isEqual(n),label:I,description:I,sortText:I,busy:I,error:I,canResolveChildren:I,tags:(i,n)=>!(i.length!==n.length||i.some(t=>!n.find(o=>t.id===o.id)))},u=i=>n=>({op:O.TestItemEventOp.SetProp,update:i(n)}),C=(i,n)=>({range:(()=>{let t;const o=u(c=>({range:S.Range.lift(A.Range.from(c))}));return{enumerable:!0,configurable:!1,get(){return t},set(c){i.listener?.({op:O.TestItemEventOp.DocumentSynced}),E.range(t,c)||(t=c,i.listener?.(o(c)))}}})(),label:s(i,n,E.label,u(t=>({label:t}))),description:s(i,void 0,E.description,u(t=>({description:t}))),sortText:s(i,void 0,E.sortText,u(t=>({sortText:t}))),canResolveChildren:s(i,!1,E.canResolveChildren,t=>({op:O.TestItemEventOp.UpdateCanResolveChildren,state:t})),busy:s(i,!1,E.busy,u(t=>({busy:t}))),error:s(i,void 0,E.error,u(t=>({error:A.MarkdownString.fromStrict(t)||null}))),tags:s(i,[],E.tags,(t,o)=>({op:O.TestItemEventOp.SetTags,new:t.map(A.TestTag.from),old:o.map(A.TestTag.from)}))}),v=i=>{const n=D.TestId.fromString(i.extId),t=new a(n.controllerId,n.localId,i.label,m.URI.revive(i.uri)||void 0);return t.range=A.Range.to(i.range||void 0),t.description=i.description||void 0,t.sortText=i.sortText||void 0,t.tags=i.tags.map(o=>A.TestTag.to({id:(0,k.denamespaceTestTag)(o).tagId})),t},r=i=>{let n;for(const t of i.tests){const o=v(t.item);(0,T.getPrivateApiFor)(o).parent=n,n=o}return n};e.toItemFromContext=r;class a{constructor(n,t,o,c){if(t.includes(D.TestIdPathParts.Delimiter))throw new Error(`Test IDs may not include the ${JSON.stringify(t)} symbol`);const g=(0,T.createPrivateApiFor)(this,n);Object.defineProperties(this,{id:{value:t,enumerable:!0,writable:!1},uri:{value:c,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return g.parent instanceof d?void 0:g.parent}},children:{value:(0,O.createTestItemChildren)(g,T.getPrivateApiFor,a),enumerable:!0,writable:!1},...C(g,o)})}}e.TestItemImpl=a;class d extends a{constructor(n,t){super(n,n,t,void 0),this._isRoot=!0}}e.TestItemRootImpl=d;class l extends O.TestItemCollection{constructor(n,t,o){super({controllerId:n,getDocumentVersion:c=>c&&o.getDocument(c)?.version,getApiFor:T.getPrivateApiFor,getChildren:c=>c.children,root:new d(n,t),toITestItem:A.TestItem.from})}}e.ExtHostTestItemCollection=l}),define(ke[35],Re([1,0,14,7,8,25,5,17,11,34,32,101,2,4,3,16,127,20,39,42,69,63,66,33]),function(Ee,e,S,T,D,O,k,A,m,s,I,E,u,C,v,r,a,d,l,i,n,t,o,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0,T=Ve(T),D=Ve(D);let g=class{#e;#t;#i;constructor(P,R,p){this._commands=new Map,this._apiCommands=new Map,this.#e=P.getProxy(k.MainContext.MainThreadCommands),this._logService=R,this.#i=p,this.#t=P.getProxy(k.MainContext.MainThreadTelemetry),this.converter=new f(this,b=>{const N=this._apiCommands.get(b);return N?.result===_.Void?N:void 0},R),this._argumentProcessors=[{processArgument(b){return(0,s.revive)(b)}},{processArgument(b){return(0,O.cloneAndChange)(b,function(N){if(I.Range.isIRange(N))return D.Range.to(N);if(E.Position.isIPosition(N))return D.Position.to(N);if(I.Range.isIRange(N.range)&&u.URI.isUri(N.uri))return D.location.to(N);if(N instanceof d.VSBuffer)return N.buffer.buffer;if(!Array.isArray(N))return N})}}]}registerArgumentProcessor(P){this._argumentProcessors.push(P)}registerApiCommand(P){const R=this.registerCommand(!1,P.id,async(...p)=>{const b=P.args.map((L,F)=>{if(!L.validate(p[F]))throw new Error(`Invalid argument '${L.name}' when running '${P.id}', received: ${typeof p[F]=="object"?JSON.stringify(p[F],null,"	"):p[F]} `);return L.convert(p[F])}),N=await this.executeCommand(P.internalId,...b);return P.result.convert(N,p,this.converter)},void 0,{description:P.description,args:P.args,returns:P.result.description});return this._apiCommands.set(P.id,P),new T.Disposable(()=>{R.dispose(),this._apiCommands.delete(P.id)})}registerCommand(P,R,p,b,N,L){if(this._logService.trace("ExtHostCommands#registerCommand",R),!R.trim().length)throw new Error("invalid id");if(this._commands.has(R))throw new Error(`command '${R}' already exists`);return this._commands.set(R,{callback:p,thisArg:b,metadata:N,extension:L}),P&&this.#e.$registerCommand(R),new T.Disposable(()=>{this._commands.delete(R)&&P&&this.#e.$unregisterCommand(R)})}executeCommand(P,...R){return this._logService.trace("ExtHostCommands#executeCommand",P),this._doExecuteCommand(P,R,!0)}async _doExecuteCommand(P,R,p){if(this._commands.has(P))return this.#e.$fireCommandActivationEvent(P),this._executeContributedCommand(P,R,!1);{let b=!1;const N=(0,O.cloneAndChange)(R,function(L){if(L instanceof T.Position)return D.Position.from(L);if(L instanceof T.Range)return D.Range.from(L);if(L instanceof T.Location)return D.location.from(L);if(T.NotebookRange.isNotebookRange(L))return D.NotebookRange.from(L);if(L instanceof ArrayBuffer)return b=!0,d.VSBuffer.wrap(new Uint8Array(L));if(L instanceof Uint8Array)return b=!0,d.VSBuffer.wrap(L);if(L instanceof d.VSBuffer)return b=!0,L;if(!Array.isArray(L))return L});try{const L=await this.#e.$executeCommand(P,b?new l.SerializableObjectWithBuffers(N):N,p);return(0,s.revive)(L)}catch(L){if(L instanceof Error&&L.message==="$executeCommand:retry")return this._doExecuteCommand(P,R,!1);throw L}}}async _executeContributedCommand(P,R,p){const b=this._commands.get(P);if(!b)throw new Error("Unknown command");const{callback:N,thisArg:L,metadata:F}=b;if(F?.args)for(let J=0;J<F.args.length;J++)try{(0,S.validateConstraint)(R[J],F.args[J].constraint)}catch{throw new Error(`Running the contributed command: '${P}' failed. Illegal argument '${F.args[J].name}' - ${F.args[J].description}`)}const K=n.StopWatch.create();try{return await N.apply(L,R)}catch(J){if(P===this.converter.delegatingCommandId){const $=this.converter.getActualCommand(...R);$&&(P=$.command)}if(this._logService.error(J,P,b.extension?.identifier),!p)throw J;if(b.extension?.identifier){const $=this.#i.onExtensionError(b.extension.identifier,J);this._logService.trace("forwarded error to extension?",$,b.extension?.identifier)}throw new class extends Error{constructor(){super((0,i.toErrorMessage)(J)),this.id=P,this.source=b.extension?.displayName??b.extension?.name}}}finally{this._reportTelemetry(b,P,K.elapsed())}}_reportTelemetry(P,R,p){P.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:P.extension.identifier.value,id:new t.TelemetryTrustedValue(R),duration:p})}$executeContributedCommand(P,...R){this._logService.trace("ExtHostCommands#$executeContributedCommand",P);const p=this._commands.get(P);return p?(R=R.map(b=>this._argumentProcessors.reduce((N,L)=>L.processArgument(N,p.extension?.identifier),b)),this._executeContributedCommand(P,R,!0)):Promise.reject(new Error(`Contributed command '${P}' does not exist.`))}getCommands(P=!1){return this._logService.trace("ExtHostCommands#getCommands",P),this.#e.$getCommands().then(R=>(P&&(R=R.filter(p=>p[0]!=="_")),R))}$getContributedCommandMetadata(){const P=Object.create(null);for(const[R,p]of this._commands){const{metadata:b}=p;b&&(P[R]=b)}return Promise.resolve(P)}};e.ExtHostCommands=g,e.ExtHostCommands=g=qe([We(0,r.IExtHostRpcService),We(1,m.ILogService),We(2,o.IExtHostTelemetry)],g),e.IExtHostCommands=(0,v.createDecorator)("IExtHostCommands");class f{constructor(P,R,p){this._commands=P,this._lookupApiCommand=R,this._logService=p,this.delegatingCommandId=`__vsc${(0,c.generateUuid)()}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(P,R){if(!P)return;const p={$ident:void 0,id:P.command,title:P.title,tooltip:P.tooltip};if(!P.command)return p;const b=this._lookupApiCommand(P.command);if(b)p.id=b.internalId,p.arguments=b.args.map((N,L)=>N.convert(P.arguments&&P.arguments[L]));else if((0,A.isNonEmptyArray)(P.arguments)){const N=`${P.command} /${++this._cachIdPool}`;this._cache.set(N,P),R.add((0,C.toDisposable)(()=>{this._cache.delete(N),this._logService.trace("CommandsConverter#DISPOSE",N)})),p.$ident=N,p.id=this.delegatingCommandId,p.arguments=[N],this._logService.trace("CommandsConverter#CREATE",P.command,N)}return p}fromInternal(P){return typeof P.$ident=="string"?this._cache.get(P.$ident):{command:P.id,title:P.title,arguments:P.arguments}}getActualCommand(...P){return this._cache.get(P[0])}_executeConvertedCommand(...P){const R=this.getActualCommand(...P);return this._logService.trace("CommandsConverter#EXECUTE",P[0],R?R.command:"MISSING"),R?this._commands.executeCommand(R.command,...R.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${P[0]}`)}}e.CommandsConverter=f;class h{static{this.Uri=new h("uri","Uri of a text document",P=>u.URI.isUri(P),P=>P)}static{this.Position=new h("position","A position in a text document",P=>T.Position.isPosition(P),D.Position.from)}static{this.Range=new h("range","A range in a text document",P=>T.Range.isRange(P),D.Range.from)}static{this.Selection=new h("selection","A selection in a text document",P=>T.Selection.isSelection(P),D.Selection.from)}static{this.Number=new h("number","",P=>typeof P=="number",P=>P)}static{this.String=new h("string","",P=>typeof P=="string",P=>P)}static{this.StringArray=h.Arr(h.String)}static Arr(P){return new h(`${P.name}_array`,`Array of ${P.name}, ${P.description}`,R=>Array.isArray(R)&&R.every(p=>P.validate(p)),R=>R.map(p=>P.convert(p)))}static{this.CallHierarchyItem=new h("item","A call hierarchy item",P=>P instanceof T.CallHierarchyItem,D.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new h("item","A type hierarchy item",P=>P instanceof T.TypeHierarchyItem,D.TypeHierarchyItem.from)}static{this.TestItem=new h("testItem","A VSCodium TestItem",P=>P instanceof a.TestItemImpl,D.TestItem.from)}constructor(P,R,p,b){this.name=P,this.description=R,this.validate=p,this.convert=b}optional(){return new h(this.name,`(optional) ${this.description}`,P=>P==null||this.validate(P),P=>P===void 0?void 0:P===null?null:this.convert(P))}with(P,R){return new h(P??this.name,R??this.description,this.validate,this.convert)}}e.ApiCommandArgument=h;class _{static{this.Void=new _("no result",P=>P)}constructor(P,R){this.description=P,this.convert=R}}e.ApiCommandResult=_;class y{constructor(P,R,p,b,N){this.id=P,this.internalId=R,this.description=p,this.args=b,this.result=N}}e.ApiCommand=y}),define(ke[256],Re([1,0,17,15,2,94,104,31,35,8,7]),function(Ee,e,S,T,D,O,k,A,m,s,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0,O=Ve(O),s=Ve(s),I=Ve(I);const E=[new m.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Position],new m.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",C(s.DocumentHighlight.to))),new m.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[m.ApiCommandArgument.Uri],new m.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(r,a)=>{if((0,S.isFalsyOrEmpty)(r))return;class d extends I.SymbolInformation{static to(i){const n=new d(i.name,s.SymbolKind.to(i.kind),i.containerName||"",new I.Location(a[0],s.Range.to(i.range)));return n.detail=i.detail,n.range=n.location.range,n.selectionRange=s.Range.to(i.selectionRange),n.children=i.children?i.children.map(d.to):[],n}}return r.map(d.to)})),new m.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[m.ApiCommandArgument.Uri,new m.ApiCommandArgument("options","Formatting options",r=>!0,r=>r)],new m.ApiCommandResult("A promise that resolves to an array of TextEdits.",C(s.TextEdit.to))),new m.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Range,new m.ApiCommandArgument("options","Formatting options",r=>!0,r=>r)],new m.ApiCommandResult("A promise that resolves to an array of TextEdits.",C(s.TextEdit.to))),new m.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Position,new m.ApiCommandArgument("ch","Trigger character",r=>typeof r=="string",r=>r),new m.ApiCommandArgument("options","Formatting options",r=>!0,r=>r)],new m.ApiCommandResult("A promise that resolves to an array of TextEdits.",C(s.TextEdit.to))),new m.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Position],new m.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",v)),new m.ApiCommand("vscode.experimental.executeDefinitionProvider_recursive","_executeDefinitionProvider_recursive","Execute all definition providers.",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Position],new m.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",v)),new m.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Position],new m.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",v)),new m.ApiCommand("vscode.experimental.executeTypeDefinitionProvider_recursive","_executeTypeDefinitionProvider_recursive","Execute all type definition providers.",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Position],new m.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",v)),new m.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Position],new m.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",v)),new m.ApiCommand("vscode.experimental.executeDeclarationProvider_recursive","_executeDeclarationProvider_recursive","Execute all declaration providers.",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Position],new m.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",v)),new m.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Position],new m.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",v)),new m.ApiCommand("vscode.experimental.executeImplementationProvider_recursive","_executeImplementationProvider_recursive","Execute all implementation providers.",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Position],new m.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",v)),new m.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Position],new m.ApiCommandResult("A promise that resolves to an array of Location-instances.",C(s.location.to))),new m.ApiCommand("vscode.experimental.executeReferenceProvider","_executeReferenceProvider_recursive","Execute all reference providers.",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Position],new m.ApiCommandResult("A promise that resolves to an array of Location-instances.",C(s.location.to))),new m.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Position],new m.ApiCommandResult("A promise that resolves to an array of Hover-instances.",C(s.Hover.to))),new m.ApiCommand("vscode.experimental.executeHoverProvider_recursive","_executeHoverProvider_recursive","Execute all hover providers.",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Position],new m.ApiCommandResult("A promise that resolves to an array of Hover-instances.",C(s.Hover.to))),new m.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[m.ApiCommandArgument.Uri,new m.ApiCommandArgument("position","A position in a text document",r=>Array.isArray(r)&&r.every(a=>I.Position.isPosition(a)),r=>r.map(s.Position.from))],new m.ApiCommandResult("A promise that resolves to an array of ranges.",r=>r.map(a=>{let d;for(const l of a.reverse())d=new I.SelectionRange(s.Range.to(l),d);return d}))),new m.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[m.ApiCommandArgument.String.with("query","Search string")],new m.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",r=>r.map(s.WorkspaceSymbol.to))),new m.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Position],new m.ApiCommandResult("A promise that resolves to an array of CallHierarchyItem-instances",r=>r.map(s.CallHierarchyItem.to))),new m.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[m.ApiCommandArgument.CallHierarchyItem],new m.ApiCommandResult("A promise that resolves to an array of CallHierarchyIncomingCall-instances",r=>r.map(s.CallHierarchyIncomingCall.to))),new m.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[m.ApiCommandArgument.CallHierarchyItem],new m.ApiCommandResult("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",r=>r.map(s.CallHierarchyOutgoingCall.to))),new m.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Position],new m.ApiCommandResult("A promise that resolves to a range and placeholder text.",r=>{if(r)return{range:s.Range.to(r.range),placeholder:r.text}})),new m.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Position,m.ApiCommandArgument.String.with("newName","The new symbol name")],new m.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",r=>{if(r){if(r.rejectReason)throw new Error(r.rejectReason);return s.WorkspaceEdit.to(r)}})),new m.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new m.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",r=>r.map(s.DocumentLink.to))),new m.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[m.ApiCommandArgument.Uri],new m.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",r=>{if(r)return new I.SemanticTokensLegend(r.tokenTypes,r.tokenModifiers)})),new m.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[m.ApiCommandArgument.Uri],new m.ApiCommandResult("A promise that resolves to SemanticTokens.",r=>{if(!r)return;const a=(0,k.decodeSemanticTokensDto)(r);if(a.type==="full")return new I.SemanticTokens(a.data,void 0)})),new m.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Range.optional()],new m.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",r=>{if(r)return new I.SemanticTokensLegend(r.tokenTypes,r.tokenModifiers)})),new m.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Range],new m.ApiCommandResult("A promise that resolves to SemanticTokens.",r=>{if(!r)return;const a=(0,k.decodeSemanticTokensDto)(r);if(a.type==="full")return new I.SemanticTokens(a.data,void 0)})),new m.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Position,m.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),m.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new m.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(r,a,d)=>{if(!r)return new I.CompletionList([]);const l=r.suggestions.map(i=>s.CompletionItem.to(i,d));return new I.CompletionList(l,r.incomplete)})),new m.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Position,m.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new m.ApiCommandResult("A promise that resolves to SignatureHelp.",r=>{if(r)return s.SignatureHelp.to(r)})),new m.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new m.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(r,a,d)=>C(l=>new I.CodeLens(s.Range.to(l.range),l.command&&d.fromInternal(l.command)))(r))),new m.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[m.ApiCommandArgument.Uri,new m.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",r=>I.Range.isRange(r),r=>I.Selection.isSelection(r)?s.Selection.from(r):s.Range.from(r)),m.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),m.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new m.ApiCommandResult("A promise that resolves to an array of Command-instances.",(r,a,d)=>C(l=>{if(l._isSynthetic){if(!l.command)throw new Error("Synthetic code actions must have a command");return d.fromInternal(l.command)}else{const i=new I.CodeAction(l.title,l.kind?new I.CodeActionKind(l.kind):void 0);return l.edit&&(i.edit=s.WorkspaceEdit.to(l.edit)),l.command&&(i.command=d.fromInternal(l.command)),i.isPreferred=l.isPreferred,i}})(r))),new m.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[m.ApiCommandArgument.Uri],new m.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",r=>r?r.map(a=>new I.ColorInformation(s.Range.to(a.range),s.Color.to(a.color))):[])),new m.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new m.ApiCommandArgument("color","The color to show and insert",r=>r instanceof I.Color,s.Color.from),new m.ApiCommandArgument("context","Context object with uri and range",r=>!0,r=>({uri:r.uri,range:s.Range.from(r.range)}))],new m.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",r=>r?r.map(s.ColorPresentation.to):[])),new m.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Range],new m.ApiCommandResult("A promise that resolves to an array of Inlay objects",(r,a,d)=>r.map(s.InlayHint.to.bind(void 0,d)))),new m.ApiCommand("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[m.ApiCommandArgument.Uri],new m.ApiCommandResult("A promise that resolves to an array of FoldingRange objects",(r,a)=>{if(r)return r.map(s.FoldingRange.to)})),new m.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new m.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",C(r=>({viewType:r.viewType,displayName:r.displayName,options:{transientOutputs:r.options.transientOutputs,transientCellMetadata:r.options.transientCellMetadata,transientDocumentMetadata:r.options.transientDocumentMetadata},filenamePattern:r.filenamePattern.map(a=>s.NotebookExclusiveDocumentPattern.to(a))})))),new m.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Range,new m.ApiCommandArgument("context","An InlineValueContext",r=>r&&typeof r.frameId=="number"&&r.stoppedLocation instanceof I.Range,r=>s.InlineValueContext.from(r))],new m.ApiCommandResult("A promise that resolves to an array of InlineValue objects",r=>r.map(s.InlineValue.to))),new m.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new m.ApiCommandArgument("uriOrString","Uri-instance or string (only http/https)",r=>D.URI.isUri(r)||typeof r=="string"&&(0,T.matchesSomeScheme)(r,T.Schemas.http,T.Schemas.https),r=>r),new m.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="number"||typeof r=="object",r=>r&&(typeof r=="number"?[s.ViewColumn.from(r),void 0]:[s.ViewColumn.from(r.viewColumn),s.TextEditorOpenOptions.from(r)])).optional(),m.ApiCommandArgument.String.with("label","").optional()],m.ApiCommandResult.Void),new m.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[m.ApiCommandArgument.Uri.with("resource","Resource to open"),m.ApiCommandArgument.String.with("viewId","Custom editor view id. This should be the viewType string for custom editors or the notebookType string for notebooks. Use 'default' to use VSCodium's default text editor"),new m.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="number"||typeof r=="object",r=>r&&(typeof r=="number"?[s.ViewColumn.from(r),void 0]:[s.ViewColumn.from(r.viewColumn),s.TextEditorOpenOptions.from(r)])).optional()],m.ApiCommandResult.Void),new m.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[m.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),m.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),m.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new m.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="object",r=>r&&[s.ViewColumn.from(r.viewColumn),s.TextEditorOpenOptions.from(r)]).optional()],m.ApiCommandResult.Void),new m.ApiCommand("vscode.changes","_workbench.changes","Opens a list of resources in the changes editor to compare their contents.",[m.ApiCommandArgument.String.with("title","Human readable title for the changes editor"),new m.ApiCommandArgument("resourceList","List of resources to compare",r=>{for(const a of r){if(a.length!==3)return!1;const[d,l,i]=a;if(!D.URI.isUri(d)||!D.URI.isUri(l)&&l!==void 0&&l!==null||!D.URI.isUri(i)&&i!==void 0&&i!==null)return!1}return!0},r=>r)],m.ApiCommandResult.Void),new m.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Position],new m.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",r=>r.map(s.TypeHierarchyItem.to))),new m.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[m.ApiCommandArgument.TypeHierarchyItem],new m.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",r=>r.map(s.TypeHierarchyItem.to))),new m.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[m.ApiCommandArgument.TypeHierarchyItem],new m.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",r=>r.map(s.TypeHierarchyItem.to))),new m.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[m.ApiCommandArgument.TestItem],m.ApiCommandResult.Void),new m.ApiCommand("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[m.ApiCommandArgument.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],m.ApiCommandResult.Void),new m.ApiCommand("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[m.ApiCommandArgument.String.with("name","The context key name"),new m.ApiCommandArgument("value","The context key value",()=>!0,r=>r)],m.ApiCommandResult.Void),new m.ApiCommand("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.StringArray,new m.ApiCommandArgument("MappedEditsContext","Mapped Edits Context",r=>s.MappedEditsContext.is(r),r=>s.MappedEditsContext.from(r))],new m.ApiCommandResult("A promise that resolves to a workspace edit or null",r=>r?s.WorkspaceEdit.to(r):null)),new m.ApiCommand("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new m.ApiCommandArgument("Run arguments","",r=>!0,r=>{if(r)return{initialRange:r.initialRange?s.Range.from(r.initialRange):void 0,initialSelection:I.Selection.isSelection(r.initialSelection)?s.Selection.from(r.initialSelection):void 0,message:r.message,autoSend:r.autoSend,position:r.position?s.Position.from(r.position):void 0}})],m.ApiCommandResult.Void)];class u{static register(a){E.forEach(a.registerApiCommand,a),this._registerValidateWhenClausesCommand(a)}static _registerValidateWhenClausesCommand(a){a.registerCommand(!1,"_validateWhenClauses",A.validateWhenClauses)}}e.ExtHostApiCommands=u;function C(r){return a=>{if(Array.isArray(a))return a.map(r)}}function v(r){if(!Array.isArray(r))return;const a=[];for(const d of r)O.isLocationLink(d)?a.push(s.DefinitionLink.to(d)):a.push(s.location.to(d));return a}}),define(ke[257],Re([1,0,2,35]),function(Ee,e,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class D{constructor(k,A,m,s,I){this._extHostNotebooks=A,this._textDocumentsAndEditors=m,this._commands=s;const E=new T.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new T.ApiCommandArgument("showOptions","Show Options",u=>!0,u=>u),new T.ApiCommandArgument("resource","Interactive resource Uri",u=>!0,u=>u),new T.ApiCommandArgument("controllerId","Notebook controller Id",u=>!0,u=>u),new T.ApiCommandArgument("title","Interactive editor title",u=>!0,u=>u)],new T.ApiCommandResult("Notebook and input URI",u=>{if(I.debug("[ExtHostInteractive] open iw with notebook editor id",u.notebookEditorId),u.notebookEditorId!==void 0){const C=this._extHostNotebooks.getEditorById(u.notebookEditorId);return I.debug("[ExtHostInteractive] notebook editor found",C.id),{notebookUri:S.URI.revive(u.notebookUri),inputUri:S.URI.revive(u.inputUri),notebookEditor:C.apiEditor}}return I.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",u.notebookUri,u.inputUri),{notebookUri:S.URI.revive(u.notebookUri),inputUri:S.URI.revive(u.inputUri)}}));this._commands.registerApiCommand(E)}$willAddInteractiveDocument(k,A,m,s){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:A,lines:[""],languageId:m,uri:k,isDirty:!1,versionId:1}]})}$willRemoveInteractiveDocument(k,A){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({removedDocuments:[k]})}}e.ExtHostInteractive=D}),define(ke[258],Re([1,0,17,10,19,6,4,27,2,18,11,5,35,8,7,83,197,21,39,198]),function(Ee,e,S,T,D,O,k,A,m,s,I,E,u,C,v,r,a,d,l,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookKernels=void 0,e.createKernelId=h,C=Ve(C);let n=class{constructor(y,w,P,R,p){this._initData=w,this._extHostNotebook=P,this._commands=R,this._logService=p,this._activeExecutions=new A.ResourceMap,this._activeNotebookExecutions=new A.ResourceMap,this._kernelDetectionTask=new Map,this._kernelDetectionTaskHandlePool=0,this._kernelSourceActionProviders=new Map,this._kernelSourceActionProviderHandlePool=0,this._kernelData=new Map,this._handlePool=0,this._onDidChangeCellExecutionState=new O.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this.id=0,this.variableStore={},this._proxy=y.getProxy(E.MainContext.MainThreadNotebookKernels);const b=new u.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new u.ApiCommandArgument("options","Select kernel options",L=>!0,L=>{if(L&&"notebookEditor"in L&&"id"in L){const F=this._extHostNotebook.getIdByEditor(L.notebookEditor);return{id:L.id,extension:L.extension,notebookEditorId:F}}else if(L&&"notebookEditor"in L){const F=this._extHostNotebook.getIdByEditor(L.notebookEditor);if(F===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${L.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:F}}return L})],u.ApiCommandResult.Void),N=new u.ApiCommand("vscode.executeNotebookVariableProvider","_executeNotebookVariableProvider","Execute notebook variable provider",[u.ApiCommandArgument.Uri],new u.ApiCommandResult("A promise that resolves to an array of variables",(L,F)=>L.map(K=>({variable:{name:K.name,value:K.value,expression:K.expression,type:K.type,language:K.language},hasNamedChildren:K.hasNamedChildren,indexedChildrenCount:K.indexedChildrenCount}))));this._commands.registerApiCommand(b),this._commands.registerApiCommand(N)}createNotebookController(y,w,P,R,p,b){for(const Z of this._kernelData.values())if(Z.controller.id===w&&s.ExtensionIdentifier.equals(y.identifier,Z.extensionId))throw new Error(`notebook controller with id '${w}' ALREADY exist`);const N=this._handlePool++,L=this;this._logService.trace(`NotebookController[${N}], CREATED by ${y.identifier.value}, ${w}`);const F=()=>console.warn(`NO execute handler from notebook controller '${x.id}' of extension: '${y.identifier}'`);let K=!1;const J=new O.Emitter,$=new O.Emitter,x={id:h(y.identifier,w),notebookType:P,extensionId:y.identifier,extensionLocation:y.extensionLocation,label:R||y.identifier.value,preloads:b?b.map(C.NotebookRendererScript.from):[]};let G=p??F,Y,ae;this._proxy.$addKernel(N,x).catch(Z=>{console.log(Z),K=!0});let ee=0;const oe=()=>{if(K)return;const Z=++ee;Promise.resolve().then(()=>{Z===ee&&this._proxy.$updateKernel(N,x)})},ie=new A.ResourceMap,ue={get id(){return w},get notebookType(){return x.notebookType},onDidChangeSelectedNotebooks:J.event,get label(){return x.label},set label(Z){x.label=Z??y.displayName??y.name,oe()},get detail(){return x.detail??""},set detail(Z){x.detail=Z,oe()},get description(){return x.description??""},set description(Z){x.description=Z,oe()},get supportedLanguages(){return x.supportedLanguages},set supportedLanguages(Z){x.supportedLanguages=Z,oe()},get supportsExecutionOrder(){return x.supportsExecutionOrder??!1},set supportsExecutionOrder(Z){x.supportsExecutionOrder=Z,oe()},get rendererScripts(){return x.preloads?x.preloads.map(C.NotebookRendererScript.to):[]},get executeHandler(){return G},set executeHandler(Z){G=Z??F},get interruptHandler(){return Y},set interruptHandler(Z){Y=Z,x.supportsInterrupt=!!Z,oe()},set variableProvider(Z){(0,d.checkProposedApiEnabled)(y,"notebookVariableProvider"),ae=Z,x.hasVariableProvider=!!Z,Z?.onDidChangeVariables(ve=>L._proxy.$variablesUpdated(ve.uri)),oe()},get variableProvider(){return ae},createNotebookCellExecution(Z){if(K)throw new Error("notebook controller is DISPOSED");if(!ie.has(Z.notebook.uri))throw L._logService.trace(`NotebookController[${N}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(ie.keys()).map(ve=>ve.toString())),new Error(`notebook controller is NOT associated to notebook: ${Z.notebook.uri.toString()}`);return L._createNotebookCellExecution(Z,h(y.identifier,this.id))},createNotebookExecution(Z){if((0,d.checkProposedApiEnabled)(y,"notebookExecution"),K)throw new Error("notebook controller is DISPOSED");if(!ie.has(Z.uri))throw L._logService.trace(`NotebookController[${N}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(ie.keys()).map(ve=>ve.toString())),new Error(`notebook controller is NOT associated to notebook: ${Z.uri.toString()}`);return L._createNotebookExecution(Z,h(y.identifier,this.id))},dispose:()=>{K||(this._logService.trace(`NotebookController[${N}], DISPOSED`),K=!0,this._kernelData.delete(N),J.dispose(),$.dispose(),this._proxy.$removeKernel(N))},updateNotebookAffinity(Z,ve){ve===v.NotebookControllerAffinity2.Hidden&&(0,d.checkProposedApiEnabled)(y,"notebookControllerAffinityHidden"),L._proxy.$updateNotebookPriority(N,Z.uri,ve)},onDidReceiveMessage:$.event,postMessage(Z,ve){return(0,d.checkProposedApiEnabled)(y,"notebookMessaging"),L._proxy.$postMessage(N,ve&&L._extHostNotebook.getIdByEditor(ve),Z)},asWebviewUri(Z){return(0,d.checkProposedApiEnabled)(y,"notebookMessaging"),(0,r.asWebviewUri)(Z,L._initData.remote)}};return this._kernelData.set(N,{extensionId:y.identifier,controller:ue,onDidReceiveMessage:$,onDidChangeSelection:J,associatedNotebooks:ie}),ue}getIdByController(y){for(const[w,P]of this._kernelData)if(P.controller===y)return h(P.extensionId,y.id);return null}createNotebookControllerDetectionTask(y,w){const P=this._kernelDetectionTaskHandlePool++,R=this;this._logService.trace(`NotebookControllerDetectionTask[${P}], CREATED by ${y.identifier.value}`),this._proxy.$addKernelDetectionTask(P,w);const p={dispose:()=>{this._kernelDetectionTask.delete(P),R._proxy.$removeKernelDetectionTask(P)}};return this._kernelDetectionTask.set(P,p),p}registerKernelSourceActionProvider(y,w,P){const R=this._kernelSourceActionProviderHandlePool++,p=typeof P.onDidChangeNotebookKernelSourceActions=="function"?R:void 0,b=this;this._kernelSourceActionProviders.set(R,P),this._logService.trace(`NotebookKernelSourceActionProvider[${R}], CREATED by ${y.identifier.value}`),this._proxy.$addKernelSourceActionProvider(R,R,w);let N;return p!==void 0&&(N=P.onDidChangeNotebookKernelSourceActions(L=>this._proxy.$emitNotebookKernelSourceActionsChangeEvent(p))),{dispose:()=>{this._kernelSourceActionProviders.delete(R),b._proxy.$removeKernelSourceActionProvider(R,R),N?.dispose()}}}async $provideKernelSourceActions(y,w){const P=this._kernelSourceActionProviders.get(y);if(P){const R=new k.DisposableStore;return(await P.provideNotebookKernelSourceActions(w)??[]).map(b=>C.NotebookKernelSourceAction.from(b,this._commands.converter,R))}return[]}$acceptNotebookAssociation(y,w,P){const R=this._kernelData.get(y);if(R){const p=this._extHostNotebook.getNotebookDocument(m.URI.revive(w));P?R.associatedNotebooks.set(p.uri,!0):R.associatedNotebooks.delete(p.uri),this._logService.trace(`NotebookController[${y}] ASSOCIATE notebook`,p.uri.toString(),P),R.onDidChangeSelection.fire({selected:P,notebook:p.apiNotebook})}}async $executeCells(y,w,P){const R=this._kernelData.get(y);if(!R)return;const p=this._extHostNotebook.getNotebookDocument(m.URI.revive(w)),b=[];for(const N of P){const L=p.getCell(N);L&&b.push(L.apiCell)}try{this._logService.trace(`NotebookController[${y}] EXECUTE cells`,p.uri.toString(),b.length),await R.controller.executeHandler.call(R.controller,b,p.apiNotebook,R.controller)}catch(N){this._logService.error(`NotebookController[${y}] execute cells FAILED`,N),console.error(N)}}async $cancelCells(y,w,P){const R=this._kernelData.get(y);if(!R)return;const p=this._extHostNotebook.getNotebookDocument(m.URI.revive(w));if(R.controller.interruptHandler)await R.controller.interruptHandler.call(R.controller,p.apiNotebook);else for(const b of P){const N=p.getCell(b);N&&this._activeExecutions.get(N.uri)?.cancel()}if(R.controller.interruptHandler){const b=this._activeNotebookExecutions.get(p.uri);this._activeNotebookExecutions.delete(p.uri),P.length&&Array.isArray(b)&&b.length&&b.forEach(N=>N.dispose())}}async $provideVariables(y,w,P,R,p,b,N){const L=this._kernelData.get(y);if(!L)return;const F=this._extHostNotebook.getNotebookDocument(m.URI.revive(P)),K=L.controller.variableProvider;if(!K)return;let J;if(R!==void 0){if(J=this.variableStore[R],!J)return}else this.variableStore={};const $=p==="named"?v.NotebookVariablesRequestKind.Named:v.NotebookVariablesRequestKind.Indexed,x=K.provideVariables(F.apiNotebook,J,$,b,N);let G=0;for await(const Y of x){if(N.isCancellationRequested)return;const ae={id:this.id++,name:Y.variable.name,value:Y.variable.value,type:Y.variable.type,interfaces:Y.variable.interfaces,language:Y.variable.language,expression:Y.variable.expression,hasNamedChildren:Y.hasNamedChildren,indexedChildrenCount:Y.indexedChildrenCount,extensionId:L.extensionId.value};if(this.variableStore[ae.id]=Y.variable,this._proxy.$receiveVariable(w,ae),G++>=i.variablePageSize)return}}$acceptKernelMessageFromRenderer(y,w,P){const R=this._kernelData.get(y);if(!R)return;const p=this._extHostNotebook.getEditorById(w);R.onDidReceiveMessage.fire(Object.freeze({editor:p.apiEditor,message:P}))}$cellExecutionChanged(y,w,P){const p=this._extHostNotebook.getNotebookDocument(m.URI.revive(y)).getCell(w);if(p){const b=P?C.NotebookCellExecutionState.to(P):v.NotebookCellExecutionState.Idle;b!==void 0&&this._onDidChangeCellExecutionState.fire({cell:p.apiCell,state:b})}}_createNotebookCellExecution(y,w){if(y.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const R=this._extHostNotebook.getNotebookDocument(y.notebook.uri).getCellFromApiCell(y);if(!R)throw new Error("invalid cell");if(this._activeExecutions.has(R.uri))throw new Error(`duplicate execution for ${R.uri}`);const p=new o(w,R,this._proxy);this._activeExecutions.set(R.uri,p);const b=p.onDidChangeState(()=>{p.state===t.Resolved&&(p.dispose(),b.dispose(),this._activeExecutions.delete(R.uri))});return p.asApiObject()}_createNotebookExecution(y,w){const P=this._extHostNotebook.getNotebookDocument(y.uri),R=y.getCells().find(N=>{const L=P.getCellFromApiCell(N);return L&&this._activeExecutions.has(L.uri)});if(R)throw new Error(`duplicate cell execution for ${R.document.uri}`);if(this._activeNotebookExecutions.has(P.uri))throw new Error(`duplicate notebook execution for ${P.uri}`);const p=new g(w,P,this._proxy),b=p.onDidChangeState(()=>{p.state===c.Resolved&&(p.dispose(),b.dispose(),this._activeNotebookExecutions.delete(P.uri))});return this._activeNotebookExecutions.set(P.uri,[p,b]),p.asApiObject()}};e.ExtHostNotebookKernels=n,e.ExtHostNotebookKernels=n=qe([We(4,I.ILogService)],n);var t;(function(_){_[_.Init=0]="Init",_[_.Started=1]="Started",_[_.Resolved=2]="Resolved"})(t||(t={}));class o extends k.Disposable{static{this.HANDLE=0}get state(){return this._state}constructor(y,w,P){super(),this._cell=w,this._proxy=P,this._handle=o.HANDLE++,this._onDidChangeState=new O.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=t.Init,this._tokenSource=this._register(new D.CancellationTokenSource),this._collector=new f(10,R=>this.update(R)),this._executionOrder=w.internalMetadata.executionOrder,this._proxy.$createExecution(this._handle,y,this._cell.notebook.uri,this._cell.handle)}cancel(){this._tokenSource.cancel()}async updateSoon(y){await this._collector.addItem(y)}async update(y){const w=Array.isArray(y)?y:[y];return this._proxy.$updateExecution(this._handle,new l.SerializableObjectWithBuffers(w))}verifyStateForOutput(){if(this._state===t.Init)throw new Error("Must call start before modifying cell output");if(this._state===t.Resolved)throw new Error("Cannot modify cell output after calling resolve")}cellIndexToHandle(y){let w=this._cell;if(y&&(w=this._cell.notebook.getCellFromApiCell(y)),!w)throw new Error("INVALID cell");return w.handle}validateAndConvertOutputs(y){return y.map(w=>{const P=v.NotebookCellOutput.ensureUniqueMimeTypes(w.items,!0);return P===w.items?C.NotebookCellOutput.from(w):C.NotebookCellOutput.from({items:P,id:w.id,metadata:w.metadata})})}async updateOutputs(y,w,P){const R=this.cellIndexToHandle(w),p=this.validateAndConvertOutputs((0,S.asArray)(y));return this.updateSoon({editType:a.CellExecutionUpdateType.Output,cellHandle:R,append:P,outputs:p})}async updateOutputItems(y,w,P){return y=v.NotebookCellOutput.ensureUniqueMimeTypes((0,S.asArray)(y),!0),this.updateSoon({editType:a.CellExecutionUpdateType.OutputItems,items:y.map(C.NotebookCellOutputItem.from),outputId:w.id,append:P})}asApiObject(){const y=this;return Object.freeze({get token(){return y._tokenSource.token},get cell(){return y._cell.apiCell},get executionOrder(){return y._executionOrder},set executionOrder(P){y._executionOrder=P,y.update([{editType:a.CellExecutionUpdateType.ExecutionState,executionOrder:y._executionOrder}])},start(P){if(y._state===t.Resolved||y._state===t.Started)throw new Error("Cannot call start again");y._state=t.Started,y._onDidChangeState.fire(),y.update({editType:a.CellExecutionUpdateType.ExecutionState,runStartTime:P})},end(P,R,p){if(y._state===t.Resolved)throw new Error("Cannot call resolve twice");y._state=t.Resolved,y._onDidChangeState.fire(),y._collector.flush();const b=p?{message:p.message,stack:p.stack,location:p?.location?{startLineNumber:p.location.start.line,startColumn:p.location.start.character,endLineNumber:p.location.end.line,endColumn:p.location.end.character}:void 0,uri:p.uri}:void 0;y._proxy.$completeExecution(y._handle,new l.SerializableObjectWithBuffers({runEndTime:R,lastRunSuccess:P,error:b}))},clearOutput(P){return y.verifyStateForOutput(),y.updateOutputs([],P,!1)},appendOutput(P,R){return y.verifyStateForOutput(),y.updateOutputs(P,R,!0)},replaceOutput(P,R){return y.verifyStateForOutput(),y.updateOutputs(P,R,!1)},appendOutputItems(P,R){return y.verifyStateForOutput(),y.updateOutputItems(P,R,!0)},replaceOutputItems(P,R){return y.verifyStateForOutput(),y.updateOutputItems(P,R,!1)}})}}var c;(function(_){_[_.Init=0]="Init",_[_.Started=1]="Started",_[_.Resolved=2]="Resolved"})(c||(c={}));class g extends k.Disposable{static{this.HANDLE=0}get state(){return this._state}constructor(y,w,P){super(),this._notebook=w,this._proxy=P,this._handle=g.HANDLE++,this._onDidChangeState=new O.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=c.Init,this._tokenSource=this._register(new D.CancellationTokenSource),this._proxy.$createNotebookExecution(this._handle,y,this._notebook.uri)}cancel(){this._tokenSource.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this._state===c.Resolved||this._state===c.Started)throw new Error("Cannot call start again");this._state=c.Started,this._onDidChangeState.fire(),this._proxy.$beginNotebookExecution(this._handle)},end:()=>{if(this._state===c.Resolved)throw new Error("Cannot call resolve twice");this._state=c.Resolved,this._onDidChangeState.fire(),this._proxy.$completeNotebookExecution(this._handle)}})}}class f{constructor(y,w){this.delay=y,this.callback=w,this.batch=[],this.startedTimer=Date.now()}addItem(y){return this.batch.push(y),this.currentDeferred||(this.currentDeferred=new T.DeferredPromise,this.startedTimer=Date.now(),(0,T.timeout)(this.delay).then(()=>this.flush())),Date.now()-this.startedTimer>this.delay?this.flush():this.currentDeferred.p}flush(){if(this.batch.length===0||!this.currentDeferred)return Promise.resolve();const y=this.currentDeferred;this.currentDeferred=void 0;const w=this.batch;return this.batch=[],this.callback(w).finally(()=>y.complete())}}function h(_,y){return`${_.value}/${y}`}}),define(ke[56],Re([1,0,6,5,3,2,16,4,7,9,12,180,19,33,181,182,36,10,8,35,38]),function(Ee,e,S,T,D,O,k,A,m,s,I,E,u,C,v,r,a,d,l,i,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.BaseExtHostTerminalService=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,D.createDecorator)("IExtHostTerminalService");class t extends A.Disposable{constructor(p,b,N,L){super(),this._proxy=p,this._id=b,this._creationOptions=N,this._name=L,this._disposed=!1,this._state={isInteractedWith:!1},this.isOpen=!1,this._onWillDispose=this._register(new S.Emitter),this.onWillDispose=this._onWillDispose.event,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(K=>this._pidPromiseComplete=K);const F=this;this.value={get name(){return F._name||""},get processId(){return F._pidPromise},get creationOptions(){return F._creationOptions},get exitStatus(){return F._exitStatus},get state(){return F._state},get selection(){return F._selection},get shellIntegration(){return F.shellIntegration},sendText(K,J=!0){F._checkDisposed(),F._proxy.$sendText(F._id,K,J)},show(K){F._checkDisposed(),F._proxy.$show(F._id,K)},hide(){F._checkDisposed(),F._proxy.$hide(F._id)},dispose(){F._disposed||(F._disposed=!0,F._proxy.$dispose(F._id))},get dimensions(){if(!(F._cols===void 0||F._rows===void 0))return{columns:F._cols,rows:F._rows}}}}dispose(){this._onWillDispose.fire(),super.dispose()}async create(p,b){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:p.name,shellPath:p.shellPath??void 0,shellArgs:p.shellArgs??void 0,cwd:p.cwd??b?.cwd??void 0,env:p.env??void 0,icon:y(p.iconPath)??void 0,color:a.ThemeColor.isThemeColor(p.color)?p.color.id:void 0,initialText:p.message??void 0,strictEnv:p.strictEnv??void 0,hideFromUser:p.hideFromUser??void 0,forceShellIntegration:b?.forceShellIntegration??void 0,isFeatureTerminal:b?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:b?.useShellEnvironment??void 0,location:b?.location||this._serializeParentTerminal(p.location,b?.resolvedExtHostIdentifier),isTransient:p.isTransient??void 0})}async createExtensionTerminal(p,b,N,L,F){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:L,color:a.ThemeColor.isThemeColor(F)?F.id:void 0,location:b?.location||this._serializeParentTerminal(p,N),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_serializeParentTerminal(p,b){return typeof p=="object"?"parentTerminal"in p&&p.parentTerminal&&b?{parentTerminal:b}:"viewColumn"in p?{viewColumn:l.ViewColumn.from(p.viewColumn),preserveFocus:p.preserveFocus}:void 0:p}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(p){this._name=p}setExitStatus(p,b){this._exitStatus=Object.freeze({code:p,reason:b})}setDimensions(p,b){return p===this._cols&&b===this._rows||p===0||b===0?!1:(this._cols=p,this._rows=b,!0)}setInteractedWith(){return this._state.isInteractedWith?!1:(this._state={isInteractedWith:!0},!0)}setSelection(p){this._selection=p}_setProcessId(p){this._pidPromiseComplete?(this._pidPromiseComplete(p),this._pidPromiseComplete=void 0):this._pidPromise.then(b=>{b!==p&&(this._pidPromise=Promise.resolve(p))})}}e.ExtHostTerminal=t;class o{get onProcessReady(){return this._onProcessReady.event}constructor(p){this._pty=p,this.id=0,this.shouldPersist=!1,this._onProcessData=new S.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessReady=new S.Emitter,this._onDidChangeProperty=new S.Emitter,this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=new S.Emitter,this.onProcessExit=this._onProcessExit.event}refreshProperty(p){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${p}`)}updateProperty(p,b){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${p}, value: ${b}`)}async start(){}shutdown(){this._pty.close()}input(p){this._pty.handleInput?.(p)}resize(p,b){this._pty.setDimensions?.({columns:p,rows:b})}clearBuffer(){}async processBinary(p){}acknowledgeDataEvent(p){}async setUnicodeVersion(p){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(p){this._pty.onDidWrite(b=>this._onProcessData.fire(b)),this._pty.onDidClose?.((b=void 0)=>{this._onProcessExit.fire(b===void 0?void 0:b)}),this._pty.onDidOverrideDimensions?.(b=>{b&&this._onDidChangeProperty.fire({type:v.ProcessPropertyType.OverrideDimensions,value:{cols:b.columns,rows:b.rows}})}),this._pty.onDidChangeName?.(b=>{this._onDidChangeProperty.fire({type:v.ProcessPropertyType.Title,value:b})}),this._pty.open(p||void 0),p&&this._pty.setDimensions?.(p),this._onProcessReady.fire({pid:-1,cwd:"",windowsPty:void 0})}}let c=1,g=class extends A.Disposable{get activeTerminal(){return this._activeTerminal?.value}get terminals(){return this._terminals.map(p=>p.value)}constructor(p,b,N){super(),this._extHostCommands=b,this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._lastQuickFixCommands=this._register(new A.MutableDisposable),this._linkProviders=new Set,this._profileProviders=new Map,this._quickFixProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new S.Emitter,this.onDidCloseTerminal=this._onDidCloseTerminal.event,this._onDidOpenTerminal=new S.Emitter,this.onDidOpenTerminal=this._onDidOpenTerminal.event,this._onDidChangeActiveTerminal=new S.Emitter,this.onDidChangeActiveTerminal=this._onDidChangeActiveTerminal.event,this._onDidChangeTerminalDimensions=new S.Emitter,this.onDidChangeTerminalDimensions=this._onDidChangeTerminalDimensions.event,this._onDidChangeTerminalState=new S.Emitter,this.onDidChangeTerminalState=this._onDidChangeTerminalState.event,this._onDidChangeShell=new S.Emitter,this.onDidChangeShell=this._onDidChangeShell.event,this._onDidWriteTerminalData=new S.Emitter({onWillAddFirstListener:()=>this._proxy.$startSendingDataEvents(),onDidRemoveLastListener:()=>this._proxy.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this._onDidWriteTerminalData.event,this._onDidExecuteCommand=new S.Emitter({onWillAddFirstListener:()=>this._proxy.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this._proxy.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this._onDidExecuteCommand.event,this._proxy=N.getProxy(T.MainContext.MainThreadTerminalService),this._bufferer=new r.TerminalDataBufferer(this._proxy.$sendProcessData),this._proxy.$registerProcessSupport(p),this._extHostCommands.registerArgumentProcessor({processArgument:L=>{const F=K=>{const J=K;return this.getTerminalById(J.instanceId)?.value};switch(L?.$mid){case n.MarshalledId.TerminalContext:return F(L);default:{if(Array.isArray(L))for(let K=0;K<L.length&&L[K].$mid===n.MarshalledId.TerminalContext;K++)L[K]=F(L[K]);return L}}}}),this._register({dispose:()=>{for(const[L,F]of this._terminalProcesses)F.shutdown(!0)}})}getDefaultShell(p){return(p?this._defaultAutomationProfile:this._defaultProfile)?.path||""}getDefaultShellArgs(p){return(p?this._defaultAutomationProfile:this._defaultProfile)?.args||[]}createExtensionTerminal(p,b){const N=new t(this._proxy,(0,C.generateUuid)(),p,p.name),L=new o(p.pty);return N.createExtensionTerminal(p.location,b,this._serializeParentTerminal(p,b).resolvedExtHostIdentifier,y(p.iconPath),w(p.color)).then(F=>{const K=this._setupExtHostProcessListeners(F,L);this._terminalProcessDisposables[F]=K}),this._terminals.push(N),N.value}_serializeParentTerminal(p,b){if(b=b||{},p.location&&typeof p.location=="object"&&"parentTerminal"in p.location){const N=p.location.parentTerminal;if(N){const L=this._terminals.find(F=>F.value===N);L&&(b.resolvedExtHostIdentifier=L._id)}}else p.location&&typeof p.location!="object"?b.location=p.location:b.location&&typeof b.location=="object"&&"splitActiveTerminal"in b.location&&(b.location={splitActiveTerminal:!0});return b}attachPtyToTerminal(p,b){if(!this.getTerminalById(p))throw new Error(`Cannot resolve terminal with id ${p} for virtual process`);const L=new o(b),F=this._setupExtHostProcessListeners(p,L);this._terminalProcessDisposables[p]=F}async $acceptActiveTerminalChanged(p){const b=this._activeTerminal;if(p===null){this._activeTerminal=void 0,b!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const N=this.getTerminalById(p);N&&(this._activeTerminal=N,b!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(p,b){const N=this.getTerminalById(p);N&&this._onDidWriteTerminalData.fire({terminal:N.value,data:b})}async $acceptTerminalDimensions(p,b,N){const L=this.getTerminalById(p);L&&L.setDimensions(b,N)&&this._onDidChangeTerminalDimensions.fire({terminal:L.value,dimensions:L.value.dimensions})}async $acceptDidExecuteCommand(p,b){const N=this.getTerminalById(p);N&&this._onDidExecuteCommand.fire({terminal:N.value,...b})}async $acceptTerminalMaximumDimensions(p,b,N){this._terminalProcesses.get(p)?.resize(b,N)}async $acceptTerminalTitleChange(p,b){const N=this.getTerminalById(p);N&&(N.name=b)}async $acceptTerminalClosed(p,b,N){const L=this._getTerminalObjectIndexById(this._terminals,p);if(L!==null){const F=this._terminals.splice(L,1)[0];F.setExitStatus(b,N),this._onDidCloseTerminal.fire(F.value)}}$acceptTerminalOpened(p,b,N,L){if(b){const J=this._getTerminalObjectIndexById(this._terminals,b);if(J!==null){this._terminals[J]._id=p,this._onDidOpenTerminal.fire(this.terminals[J]),this._terminals[J].isOpen=!0;return}}const F={name:L.name,shellPath:L.executable,shellArgs:L.args,cwd:typeof L.cwd=="string"?L.cwd:O.URI.revive(L.cwd),env:L.env,hideFromUser:L.hideFromUser},K=new t(this._proxy,p,F,N);this._terminals.push(K),this._onDidOpenTerminal.fire(K.value),K.isOpen=!0}async $acceptTerminalProcessId(p,b){this.getTerminalById(p)?._setProcessId(b)}async $startExtensionTerminal(p,b){const N=this.getTerminalById(p);if(!N)return{message:(0,s.localize)(2714,null,p)};N.isOpen||await new Promise(F=>{const K=this.onDidOpenTerminal(async J=>{J===N.value&&(K.dispose(),F())})});const L=this._terminalProcesses.get(p);L?L.startSendingEvents(b):this._extensionTerminalAwaitingStart[p]={initialDimensions:b}}_setupExtHostProcessListeners(p,b){const N=new A.DisposableStore;N.add(b.onProcessReady(F=>this._proxy.$sendProcessReady(p,F.pid,F.cwd,F.windowsPty))),N.add(b.onDidChangeProperty(F=>this._proxy.$sendProcessProperty(p,F))),this._bufferer.startBuffering(p,b.onProcessData),N.add(b.onProcessExit(F=>this._onProcessExit(p,F))),this._terminalProcesses.set(p,b);const L=this._extensionTerminalAwaitingStart[p];return L&&b instanceof o&&(b.startSendingEvents(L.initialDimensions),delete this._extensionTerminalAwaitingStart[p]),N}$acceptProcessAckDataEvent(p,b){this._terminalProcesses.get(p)?.acknowledgeDataEvent(b)}$acceptProcessInput(p,b){this._terminalProcesses.get(p)?.input(b)}$acceptTerminalInteraction(p){const b=this.getTerminalById(p);b?.setInteractedWith()&&this._onDidChangeTerminalState.fire(b.value)}$acceptTerminalSelection(p,b){this.getTerminalById(p)?.setSelection(b)}$acceptProcessResize(p,b,N){try{this._terminalProcesses.get(p)?.resize(b,N)}catch(L){if(L.code!=="EPIPE"&&L.code!=="ERR_IPC_CHANNEL_CLOSED")throw L}}$acceptProcessShutdown(p,b){this._terminalProcesses.get(p)?.shutdown(b)}$acceptProcessRequestInitialCwd(p){this._terminalProcesses.get(p)?.getInitialCwd().then(b=>this._proxy.$sendProcessProperty(p,{type:v.ProcessPropertyType.InitialCwd,value:b}))}$acceptProcessRequestCwd(p){this._terminalProcesses.get(p)?.getCwd().then(b=>this._proxy.$sendProcessProperty(p,{type:v.ProcessPropertyType.Cwd,value:b}))}$acceptProcessRequestLatency(p){return Promise.resolve(p)}registerLinkProvider(p){return this._linkProviders.add(p),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new m.Disposable(()=>{this._linkProviders.delete(p),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(p,b,N){if(this._profileProviders.has(b))throw new Error(`Terminal profile provider "${b}" already registered`);return this._profileProviders.set(b,N),this._proxy.$registerProfileProvider(b,p.identifier.value),new m.Disposable(()=>{this._profileProviders.delete(b),this._proxy.$unregisterProfileProvider(b)})}registerTerminalQuickFixProvider(p,b,N){if(this._quickFixProviders.has(p))throw new Error(`Terminal quick fix provider "${p}" is already registered`);return this._quickFixProviders.set(p,N),this._proxy.$registerQuickFixProvider(p,b),new m.Disposable(()=>{this._quickFixProviders.delete(p),this._proxy.$unregisterQuickFixProvider(p)})}async $provideTerminalQuickFixes(p,b){const N=new u.CancellationTokenSource().token;if(N.isCancellationRequested)return;const L=this._quickFixProviders.get(p);if(!L)return;const F=await L.provideTerminalQuickFixes(b,N);if(F===null||Array.isArray(F)&&F.length===0)return;const K=new A.DisposableStore;if(this._lastQuickFixCommands.value=K,!Array.isArray(F))return F?l.TerminalQuickFix.from(F,this._extHostCommands.converter,K):void 0;const J=[];for(const $ of F){const x=l.TerminalQuickFix.from($,this._extHostCommands.converter,K);x&&J.push(x)}return J}async $createContributedProfileTerminal(p,b){const N=new u.CancellationTokenSource().token;let L=await this._profileProviders.get(p)?.provideTerminalProfile(N);if(!N.isCancellationRequested){if(L&&!("options"in L)&&(L={options:L}),!L||!("options"in L))throw new Error(`No terminal profile options provided for id "${p}"`);if("pty"in L.options){this.createExtensionTerminal(L.options,b);return}this.createTerminalFromOptions(L.options,b)}}async $provideLinks(p,b){const N=this.getTerminalById(p);if(!N)return[];this._terminalLinkCache.delete(p),this._terminalLinkCancellationSource.get(p)?.dispose(!0);const F=new u.CancellationTokenSource;this._terminalLinkCancellationSource.set(p,F);const K=[],J={terminal:N.value,line:b},$=[];for(const Y of this._linkProviders)$.push(d.Promises.withAsyncBody(async ae=>{F.token.onCancellationRequested(()=>ae({provider:Y,links:[]}));const ee=await Y.provideTerminalLinks(J,F.token)||[];F.token.isCancellationRequested||ae({provider:Y,links:ee})}));const x=await Promise.all($);if(F.token.isCancellationRequested)return[];const G=new Map;for(const Y of x)Y&&Y.links.length>0&&K.push(...Y.links.map(ae=>{const ee={id:c++,startIndex:ae.startIndex,length:ae.length,label:ae.tooltip};return G.set(ee.id,{provider:Y.provider,link:ae}),ee}));return this._terminalLinkCache.set(p,G),K}$activateLink(p,b){const N=this._terminalLinkCache.get(p)?.get(b);N&&N.provider.handleTerminalLink(N.link)}_onProcessExit(p,b){this._bufferer.stopBuffering(p),this._terminalProcesses.delete(p),delete this._extensionTerminalAwaitingStart[p];const N=this._terminalProcessDisposables[p];N&&(N.dispose(),delete this._terminalProcessDisposables[p]),this._proxy.$sendProcessExit(p,b)}getTerminalById(p){return this._getTerminalObjectById(this._terminals,p)}getTerminalIdByApiObject(p){const b=this._terminals.findIndex(N=>N.value===p);return b>=0?b:null}_getTerminalObjectById(p,b){const N=this._getTerminalObjectIndexById(p,b);return N!==null?p[N]:null}_getTerminalObjectIndexById(p,b){const N=p.findIndex(L=>L._id===b);return N>=0?N:null}getEnvironmentVariableCollection(p){let b=this._environmentVariableCollections.get(p.identifier.value);return b||(b=this._register(new f),this._setEnvironmentVariableCollection(p.identifier.value,b)),b.getScopedEnvironmentVariableCollection(void 0)}_syncEnvironmentVariableCollection(p,b){const N=(0,E.serializeEnvironmentVariableCollection)(b.map),L=(0,E.serializeEnvironmentDescriptionMap)(b.descriptionMap);this._proxy.$setEnvironmentVariableCollection(p,b.persistent,N.length===0?void 0:N,L)}$initEnvironmentVariableCollections(p){p.forEach(b=>{const N=b[0],L=this._register(new f(b[1]));this._setEnvironmentVariableCollection(N,L)})}$acceptDefaultProfile(p,b){const N=this._defaultProfile;this._defaultProfile=p,this._defaultAutomationProfile=b,N?.path!==p.path&&this._onDidChangeShell.fire(p.path)}_setEnvironmentVariableCollection(p,b){this._environmentVariableCollections.set(p,b),this._register(b.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(p,b)}))}};e.BaseExtHostTerminalService=g,e.BaseExtHostTerminalService=g=qe([We(1,i.IExtHostCommands),We(2,k.IExtHostRpcService)],g);class f extends A.Disposable{get persistent(){return this._persistent}set persistent(p){this._persistent=p,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}constructor(p){super(),this.map=new Map,this.scopedCollections=new Map,this.descriptionMap=new Map,this._persistent=!0,this._onDidChangeCollection=new S.Emitter,this.map=new Map(p)}getScopedEnvironmentVariableCollection(p){const b=this.getScopeKey(p);let N=this.scopedCollections.get(b);return N||(N=new h(this,p),this.scopedCollections.set(b,N),this._register(N.onDidChangeCollection(()=>this._onDidChangeCollection.fire()))),N}replace(p,b,N,L){this._setIfDiffers(p,{value:b,type:m.EnvironmentVariableMutatorType.Replace,options:N??{applyAtProcessCreation:!0},scope:L})}append(p,b,N,L){this._setIfDiffers(p,{value:b,type:m.EnvironmentVariableMutatorType.Append,options:N??{applyAtProcessCreation:!0},scope:L})}prepend(p,b,N,L){this._setIfDiffers(p,{value:b,type:m.EnvironmentVariableMutatorType.Prepend,options:N??{applyAtProcessCreation:!0},scope:L})}_setIfDiffers(p,b){if(b.options&&b.options.applyAtProcessCreation===!1&&!b.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const N=this.getKey(p,b.scope),L=this.map.get(N),F=b.options?{applyAtProcessCreation:b.options.applyAtProcessCreation??!1,applyAtShellIntegration:b.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!L||L.value!==b.value||L.type!==b.type||L.options?.applyAtProcessCreation!==F.applyAtProcessCreation||L.options?.applyAtShellIntegration!==F.applyAtShellIntegration||L.scope?.workspaceFolder?.index!==b.scope?.workspaceFolder?.index){const K=this.getKey(p,b.scope),J={variable:p,...b,options:F};this.map.set(K,J),this._onDidChangeCollection.fire()}}get(p,b){const N=this.getKey(p,b),L=this.map.get(N);return L?P(L):void 0}getKey(p,b){const N=this.getScopeKey(b);return N.length?`${p}:::${N}`:p}getScopeKey(p){return this.getWorkspaceKey(p?.workspaceFolder)??""}getWorkspaceKey(p){return p?p.uri.toString():void 0}getVariableMap(p){const b=new Map;for(const[N,L]of this.map)this.getScopeKey(L.scope)===this.getScopeKey(p)&&b.set(L.variable,P(L));return b}delete(p,b){const N=this.getKey(p,b);this.map.delete(N),this._onDidChangeCollection.fire()}clear(p){if(p?.workspaceFolder){for(const[b,N]of this.map)N.scope?.workspaceFolder?.index===p.workspaceFolder.index&&this.map.delete(b);this.clearDescription(p)}else this.map.clear(),this.descriptionMap.clear();this._onDidChangeCollection.fire()}setDescription(p,b){const N=this.getScopeKey(b),L=this.descriptionMap.get(N);if(!L||L.description!==p){let F;typeof p=="string"?F=p:F=p?.value.split(`

`)[0];const K={description:F,scope:b};this.descriptionMap.set(N,K),this._onDidChangeCollection.fire()}}getDescription(p){const b=this.getScopeKey(p);return this.descriptionMap.get(b)?.description}clearDescription(p){const b=this.getScopeKey(p);this.descriptionMap.delete(b)}}class h{get persistent(){return this.collection.persistent}set persistent(p){this.collection.persistent=p}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}constructor(p,b){this.collection=p,this.scope=b,this._onDidChangeCollection=new S.Emitter}getScoped(p){return this.collection.getScopedEnvironmentVariableCollection(p)}replace(p,b,N){this.collection.replace(p,b,N,this.scope)}append(p,b,N){this.collection.append(p,b,N,this.scope)}prepend(p,b,N){this.collection.prepend(p,b,N,this.scope)}get(p){return this.collection.get(p,this.scope)}forEach(p,b){this.collection.getVariableMap(this.scope).forEach((N,L)=>p.call(b,L,N,this),this.scope)}[Symbol.iterator](){return this.collection.getVariableMap(this.scope).entries()}delete(p){this.collection.delete(p,this.scope),this._onDidChangeCollection.fire(void 0)}clear(){this.collection.clear(this.scope)}set description(p){this.collection.setDescription(p,this.scope)}get description(){return this.collection.getDescription(this.scope)}}let _=class extends g{constructor(p,b){super(!1,p,b)}createTerminal(p,b,N){throw new I.NotSupportedError}createTerminalFromOptions(p,b){throw new I.NotSupportedError}};e.WorkerExtHostTerminalService=_,e.WorkerExtHostTerminalService=_=qe([We(0,i.IExtHostCommands),We(1,k.IExtHostRpcService)],_);function y(R){if(!(!R||typeof R=="string"))return"id"in R?{id:R.id,color:R.color}:R}function w(R){return a.ThemeColor.isThemeColor(R)?R:void 0}function P(R){const p={...R};return delete p.scope,p.options=p.options??void 0,delete p.variable,p}}),define(ke[128],Re([1,0,7,4,3,5,16,56,6,2,10]),function(Ee,e,S,T,D,O,k,A,m,s,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTerminalShellIntegration=e.IExtHostTerminalShellIntegration=void 0,e.IExtHostTerminalShellIntegration=(0,D.createDecorator)("IExtHostTerminalShellIntegration");let E=class extends T.Disposable{constructor(a,d){super(),this._extHostTerminalService=d,this._activeShellIntegrations=new Map,this._onDidChangeTerminalShellIntegration=new m.Emitter,this.onDidChangeTerminalShellIntegration=this._onDidChangeTerminalShellIntegration.event,this._onDidStartTerminalShellExecution=new m.Emitter,this.onDidStartTerminalShellExecution=this._onDidStartTerminalShellExecution.event,this._onDidEndTerminalShellExecution=new m.Emitter,this.onDidEndTerminalShellExecution=this._onDidEndTerminalShellExecution.event,this._proxy=a.getProxy(O.MainContext.MainThreadTerminalShellIntegration),this._register((0,T.toDisposable)(()=>{for(const[l,i]of this._activeShellIntegrations)i.dispose();this._activeShellIntegrations.clear()}))}$shellIntegrationChange(a){const d=this._extHostTerminalService.getTerminalById(a);if(!d)return;const l=d.value;let i=this._activeShellIntegrations.get(a);i||(i=new u(d.value,this._onDidStartTerminalShellExecution),this._activeShellIntegrations.set(a,i),i.store.add(d.onWillDispose(()=>this._activeShellIntegrations.get(a)?.dispose())),i.store.add(i.onDidRequestShellExecution(n=>this._proxy.$executeCommand(a,n))),i.store.add(i.onDidRequestEndExecution(n=>this._onDidEndTerminalShellExecution.fire(n))),i.store.add(i.onDidRequestChangeShellIntegration(n=>this._onDidChangeTerminalShellIntegration.fire(n))),d.shellIntegration=i.value),this._onDidChangeTerminalShellIntegration.fire({terminal:l,shellIntegration:i.value})}$shellExecutionStart(a,d,l,i,n){this._activeShellIntegrations.has(a)||this.$shellIntegrationChange(a);const t={value:d,confidence:l,isTrusted:i};this._activeShellIntegrations.get(a)?.startShellExecution(t,s.URI.revive(n))}$shellExecutionEnd(a,d,l,i,n){const t={value:d,confidence:l,isTrusted:i};this._activeShellIntegrations.get(a)?.endShellExecution(t,n)}$shellExecutionData(a,d){this._activeShellIntegrations.get(a)?.emitData(d)}$cwdChange(a,d){this._activeShellIntegrations.get(a)?.setCwd(s.URI.revive(d))}$closeTerminal(a){this._activeShellIntegrations.get(a)?.dispose(),this._activeShellIntegrations.delete(a)}};e.ExtHostTerminalShellIntegration=E,e.ExtHostTerminalShellIntegration=E=qe([We(0,k.IExtHostRpcService),We(1,A.IExtHostTerminalService)],E);class u extends T.Disposable{get currentExecution(){return this._currentExecution}constructor(a,d){super(),this._terminal=a,this._onDidStartTerminalShellExecution=d,this._ignoreNextExecution=!1,this.store=this._register(new T.DisposableStore),this._onDidRequestChangeShellIntegration=this._register(new m.Emitter),this.onDidRequestChangeShellIntegration=this._onDidRequestChangeShellIntegration.event,this._onDidRequestShellExecution=this._register(new m.Emitter),this.onDidRequestShellExecution=this._onDidRequestShellExecution.event,this._onDidRequestEndExecution=this._register(new m.Emitter),this.onDidRequestEndExecution=this._onDidRequestEndExecution.event;const l=this;this.value={get cwd(){return l._cwd},executeCommand(i,n){let t=i;n&&(t+=` "${n.map(g=>`${g.replaceAll('"','\\"')}`).join('" "')}"`),l._onDidRequestShellExecution.fire(t);const o={value:t,confidence:S.TerminalShellExecutionCommandLineConfidence.High,isTrusted:!0},c=l.startShellExecution(o,l._cwd,!0).value;return l._ignoreNextExecution=!0,c}}}startShellExecution(a,d,l){if(this._ignoreNextExecution&&this._currentExecution)this._ignoreNextExecution=!1;else{this._currentExecution&&(this._currentExecution.endExecution(void 0),this._onDidRequestEndExecution.fire({terminal:this._terminal,shellIntegration:this.value,execution:this._currentExecution.value,exitCode:void 0}));const i=this._currentExecution=new C(a,d??this._cwd);l?queueMicrotask(()=>this._onDidStartTerminalShellExecution.fire({terminal:this._terminal,shellIntegration:this.value,execution:i.value})):this._onDidStartTerminalShellExecution.fire({terminal:this._terminal,shellIntegration:this.value,execution:this._currentExecution.value})}return this._currentExecution}emitData(a){this.currentExecution?.emitData(a)}endShellExecution(a,d){this._currentExecution&&(this._currentExecution.endExecution(a),this._onDidRequestEndExecution.fire({terminal:this._terminal,shellIntegration:this.value,execution:this._currentExecution.value,exitCode:d}),this._currentExecution=void 0)}setCwd(a){let d=!1;s.URI.isUri(this._cwd)?d=!s.URI.isUri(a)||this._cwd.toString()!==a.toString():this._cwd!==a&&(d=!0),d&&(this._cwd=a,this._onDidRequestChangeShellIntegration.fire({terminal:this._terminal,shellIntegration:this.value}))}}class C{constructor(a,d){this._commandLine=a,this.cwd=d,this._ended=!1;const l=this;this.value={get commandLine(){return l._commandLine},get cwd(){return l.cwd},read(){return l._createDataStream()}}}_createDataStream(){if(!this._dataStream){if(this._ended)return I.AsyncIterableObject.EMPTY;this._dataStream=new v}return this._dataStream.createIterable()}emitData(a){this._dataStream?.emitData(a)}endExecution(a){a&&(this._commandLine=a),this._dataStream?.endExecution(),this._dataStream=void 0,this._ended=!0}}class v extends T.Disposable{constructor(){super(...arguments),this._emitters=[]}createIterable(){this._barrier||(this._barrier=new I.Barrier);const a=this._barrier;return new I.AsyncIterableObject(async l=>{this._emitters.push(l),await a.wait()})}emitData(a){for(const d of this._emitters)d.emitOne(a)}endExecution(){this._barrier?.open(),this._barrier=void 0}}}),define(ke[129],Re([1,0,61,12,97,8,7]),function(Ee,e,S,T,D,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorDecorationType=void 0,O=Ve(O);class A{static{this._Keys=new D.IdGenerator("TextEditorDecorationType")}constructor(u,C,v){const r=A._Keys.nextId();u.$registerTextEditorDecorationType(C.identifier,r,O.DecorationRenderOptions.from(v)),this.value=Object.freeze({key:r,dispose(){u.$removeTextEditorDecorationType(r)}})}}e.TextEditorDecorationType=A;class m{constructor(u,C){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=u,this._documentVersionId=u.version,this._undoStopBefore=C.undoStopBefore,this._undoStopAfter=C.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(u,C){this._throwIfFinalized();let v=null;if(u instanceof k.Position)v=new k.Range(u,u);else if(u instanceof k.Range)v=u;else throw new Error("Unrecognized location");this._pushEdit(v,C,!1)}insert(u,C){this._throwIfFinalized(),this._pushEdit(new k.Range(u,u),C,!0)}delete(u){this._throwIfFinalized();let C=null;if(u instanceof k.Range)C=u;else throw new Error("Unrecognized location");this._pushEdit(C,null,!0)}_pushEdit(u,C,v){const r=this._document.validateRange(u);this._collectedEdits.push({range:r,text:C,forceMoveMarkers:v})}setEndOfLine(u){if(this._throwIfFinalized(),u!==k.EndOfLine.LF&&u!==k.EndOfLine.CRLF)throw(0,T.illegalArgument)("endOfLine");this._setEndOfLine=u}}class s{constructor(u,C,v,r){this._proxy=u,this._id=C,this._accept(v),this._logService=r;const a=this;this.value={get tabSize(){return a._tabSize},set tabSize(d){a._setTabSize(d)},get indentSize(){return a._indentSize},set indentSize(d){a._setIndentSize(d)},get insertSpaces(){return a._insertSpaces},set insertSpaces(d){a._setInsertSpaces(d)},get cursorStyle(){return a._cursorStyle},set cursorStyle(d){a._setCursorStyle(d)},get lineNumbers(){return a._lineNumbers},set lineNumbers(d){a._setLineNumbers(d)}}}_accept(u){this._tabSize=u.tabSize,this._indentSize=u.indentSize,this._originalIndentSize=u.originalIndentSize,this._insertSpaces=u.insertSpaces,this._cursorStyle=u.cursorStyle,this._lineNumbers=O.TextEditorLineNumbersStyle.to(u.lineNumbers)}_validateTabSize(u){if(u==="auto")return"auto";if(typeof u=="number"){const C=Math.floor(u);return C>0?C:null}if(typeof u=="string"){const C=parseInt(u,10);return isNaN(C)?null:C>0?C:null}return null}_setTabSize(u){const C=this._validateTabSize(u);if(C!==null){if(typeof C=="number"){if(this._tabSize===C)return;this._tabSize=C}this._warnOnError("setTabSize",this._proxy.$trySetOptions(this._id,{tabSize:C}))}}_validateIndentSize(u){if(u==="tabSize")return"tabSize";if(typeof u=="number"){const C=Math.floor(u);return C>0?C:null}if(typeof u=="string"){const C=parseInt(u,10);return isNaN(C)?null:C>0?C:null}return null}_setIndentSize(u){const C=this._validateIndentSize(u);if(C!==null){if(typeof C=="number"){if(this._originalIndentSize===C)return;this._indentSize=C,this._originalIndentSize=C}this._warnOnError("setIndentSize",this._proxy.$trySetOptions(this._id,{indentSize:C}))}}_validateInsertSpaces(u){return u==="auto"?"auto":u==="false"?!1:!!u}_setInsertSpaces(u){const C=this._validateInsertSpaces(u);if(typeof C=="boolean"){if(this._insertSpaces===C)return;this._insertSpaces=C}this._warnOnError("setInsertSpaces",this._proxy.$trySetOptions(this._id,{insertSpaces:C}))}_setCursorStyle(u){this._cursorStyle!==u&&(this._cursorStyle=u,this._warnOnError("setCursorStyle",this._proxy.$trySetOptions(this._id,{cursorStyle:u})))}_setLineNumbers(u){this._lineNumbers!==u&&(this._lineNumbers=u,this._warnOnError("setLineNumbers",this._proxy.$trySetOptions(this._id,{lineNumbers:O.TextEditorLineNumbersStyle.from(u)})))}assign(u){const C={};let v=!1;if(typeof u.tabSize<"u"){const r=this._validateTabSize(u.tabSize);r==="auto"?(v=!0,C.tabSize=r):typeof r=="number"&&this._tabSize!==r&&(this._tabSize=r,v=!0,C.tabSize=r)}if(typeof u.indentSize<"u"){const r=this._validateIndentSize(u.indentSize);r==="tabSize"?(v=!0,C.indentSize=r):typeof r=="number"&&this._originalIndentSize!==r&&(this._indentSize=r,this._originalIndentSize=r,v=!0,C.indentSize=r)}if(typeof u.insertSpaces<"u"){const r=this._validateInsertSpaces(u.insertSpaces);r==="auto"?(v=!0,C.insertSpaces=r):this._insertSpaces!==r&&(this._insertSpaces=r,v=!0,C.insertSpaces=r)}typeof u.cursorStyle<"u"&&this._cursorStyle!==u.cursorStyle&&(this._cursorStyle=u.cursorStyle,v=!0,C.cursorStyle=u.cursorStyle),typeof u.lineNumbers<"u"&&this._lineNumbers!==u.lineNumbers&&(this._lineNumbers=u.lineNumbers,v=!0,C.lineNumbers=O.TextEditorLineNumbersStyle.from(u.lineNumbers)),v&&this._warnOnError("setOptions",this._proxy.$trySetOptions(this._id,C))}_warnOnError(u,C){C.catch(v=>{this._logService.warn(`ExtHostTextEditorOptions '${u}' failed:'`),this._logService.warn(v)})}}e.ExtHostTextEditorOptions=s;class I{constructor(u,C,v,r,a,d,l,i){this.id=u,this._proxy=C,this._logService=v,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=a,this._options=new s(this._proxy,this.id,d,v),this._visibleRanges=l,this._viewColumn=i;const n=this;this.value=Object.freeze({get document(){return r.value},set document(t){throw new T.ReadonlyError("document")},get selection(){return n._selections&&n._selections[0]},set selection(t){if(!(t instanceof k.Selection))throw(0,T.illegalArgument)("selection");n._selections=[t],n._trySetSelection()},get selections(){return n._selections},set selections(t){if(!Array.isArray(t)||t.some(o=>!(o instanceof k.Selection)))throw(0,T.illegalArgument)("selections");n._selections=t,n._trySetSelection()},get visibleRanges(){return n._visibleRanges},set visibleRanges(t){throw new T.ReadonlyError("visibleRanges")},get options(){return n._options.value},set options(t){n._disposed||n._options.assign(t)},get viewColumn(){return n._viewColumn},set viewColumn(t){throw new T.ReadonlyError("viewColumn")},edit(t,o={undoStopBefore:!0,undoStopAfter:!0}){if(n._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const c=new m(r.value,o);return t(c),n._applyEdit(c)},insertSnippet(t,o,c={undoStopBefore:!0,undoStopAfter:!0}){if(n._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let g;if(!o||Array.isArray(o)&&o.length===0)g=n._selections.map(f=>O.Range.from(f));else if(o instanceof k.Position){const{lineNumber:f,column:h}=O.Position.from(o);g=[{startLineNumber:f,startColumn:h,endLineNumber:f,endColumn:h}]}else if(o instanceof k.Range)g=[O.Range.from(o)];else{g=[];for(const f of o)if(f instanceof k.Range)g.push(O.Range.from(f));else{const{lineNumber:h,column:_}=O.Position.from(f);g.push({startLineNumber:h,startColumn:_,endLineNumber:h,endColumn:_})}}return C.$tryInsertSnippet(u,r.value.version,t.value,g,c)},setDecorations(t,o){const c=o.length===0;c&&!n._hasDecorationsForKey.has(t.key)||(c?n._hasDecorationsForKey.delete(t.key):n._hasDecorationsForKey.add(t.key),n._runOnProxy(()=>{if(O.isDecorationOptionsArr(o))return C.$trySetDecorations(u,t.key,O.fromRangeOrRangeWithMessage(o));{const g=new Array(4*o.length);for(let f=0,h=o.length;f<h;f++){const _=o[f];g[4*f]=_.start.line+1,g[4*f+1]=_.start.character+1,g[4*f+2]=_.end.line+1,g[4*f+3]=_.end.character+1}return C.$trySetDecorationsFast(u,t.key,g)}}))},revealRange(t,o){n._runOnProxy(()=>C.$tryRevealRange(u,O.Range.from(t),o||k.TextEditorRevealType.Default))},show(t){C.$tryShowEditor(u,O.ViewColumn.from(t))},hide(){C.$tryHideEditor(u)},[Symbol.for("debug.description")](){return`TextEditor(${this.document.uri.toString()})`}})}dispose(){(0,S.ok)(!this._disposed),this._disposed=!0}_acceptOptions(u){(0,S.ok)(!this._disposed),this._options._accept(u)}_acceptVisibleRanges(u){(0,S.ok)(!this._disposed),this._visibleRanges=u}_acceptViewColumn(u){(0,S.ok)(!this._disposed),this._viewColumn=u}_acceptSelections(u){(0,S.ok)(!this._disposed),this._selections=u}async _trySetSelection(){const u=this._selections.map(O.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,u)),this.value}_applyEdit(u){const C=u.finalize();if(C.edits.length===0&&!C.setEndOfLine)return Promise.resolve(!0);const v=C.edits.map(a=>a.range);v.sort((a,d)=>a.end.line===d.end.line?a.end.character===d.end.character?a.start.line===d.start.line?a.start.character-d.start.character:a.start.line-d.start.line:a.end.character-d.end.character:a.end.line-d.end.line);for(let a=0,d=v.length-1;a<d;a++){const l=v[a].end;if(v[a+1].start.isBefore(l))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const r=C.edits.map(a=>({range:O.Range.from(a.range),text:a.text,forceMoveMarkers:a.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,C.documentVersionId,r,{setEndOfLine:typeof C.setEndOfLine=="number"?O.EndOfLine.from(C.setEndOfLine):void 0,undoStopBefore:C.undoStopBefore,undoStopAfter:C.undoStopAfter})}_runOnProxy(u){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):u().then(()=>this,C=>(C instanceof Error&&C.name==="DISPOSED"||this._logService.warn(C),null))}}e.ExtHostTextEditor=I}),define(ke[57],Re([1,0,61,6,4,2,3,5,125,16,129,8,11,27,15,41,51]),function(Ee,e,S,T,D,O,k,A,m,s,I,E,u,C,v,r,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0,S=Ve(S),E=Ve(E);class d{constructor(n){this.value=n,this._count=0}ref(){this._count++}unref(){return--this._count===0}}let l=class{constructor(n,t){this._extHostRpc=n,this._logService=t,this._activeEditorId=null,this._editors=new Map,this._documents=new C.ResourceMap,this._onDidAddDocuments=new T.Emitter,this._onDidRemoveDocuments=new T.Emitter,this._onDidChangeVisibleTextEditors=new T.Emitter,this._onDidChangeActiveTextEditor=new T.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(n){this.acceptDocumentsAndEditorsDelta(n)}acceptDocumentsAndEditorsDelta(n){const t=[],o=[],c=[];if(n.removedDocuments)for(const g of n.removedDocuments){const f=O.URI.revive(g),h=this._documents.get(f);h?.unref()&&(this._documents.delete(f),t.push(h.value))}if(n.addedDocuments)for(const g of n.addedDocuments){const f=O.URI.revive(g.uri);let h=this._documents.get(f);if(h&&f.scheme!==v.Schemas.vscodeNotebookCell&&f.scheme!==v.Schemas.vscodeInteractiveInput)throw new Error(`document '${f} already exists!'`);h||(h=new d(new m.ExtHostDocumentData(this._extHostRpc.getProxy(A.MainContext.MainThreadDocuments),f,g.lines,g.EOL,g.versionId,g.languageId,g.isDirty)),this._documents.set(f,h),o.push(h.value)),h.ref()}if(n.removedEditors)for(const g of n.removedEditors){const f=this._editors.get(g);this._editors.delete(g),f&&c.push(f)}if(n.addedEditors)for(const g of n.addedEditors){const f=O.URI.revive(g.documentUri);S.ok(this._documents.has(f),`document '${f}' does not exist`),S.ok(!this._editors.has(g.id),`editor '${g.id}' already exists!`);const h=this._documents.get(f).value,_=new I.ExtHostTextEditor(g.id,this._extHostRpc.getProxy(A.MainContext.MainThreadTextEditors),this._logService,new a.Lazy(()=>h.document),g.selections.map(E.Selection.to),g.options,g.visibleRanges.map(y=>E.Range.to(y)),typeof g.editorPosition=="number"?E.ViewColumn.to(g.editorPosition):void 0);this._editors.set(g.id,_)}n.newActiveEditor!==void 0&&(S.ok(n.newActiveEditor===null||this._editors.has(n.newActiveEditor),`active editor '${n.newActiveEditor}' does not exist`),this._activeEditorId=n.newActiveEditor),(0,D.dispose)(t),(0,D.dispose)(c),n.removedDocuments&&this._onDidRemoveDocuments.fire(t),n.addedDocuments&&this._onDidAddDocuments.fire(o),(n.removedEditors||n.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(g=>g.value)),n.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(n){return this._documents.get(n)?.value}allDocuments(){return r.Iterable.map(this._documents.values(),n=>n.value)}getEditor(n){return this._editors.get(n)}activeEditor(n){if(!this._activeEditorId)return;const t=this._editors.get(this._activeEditorId);return n?t:t?.value}allEditors(){return[...this._editors.values()]}};e.ExtHostDocumentsAndEditors=l,e.ExtHostDocumentsAndEditors=l=qe([We(0,s.IExtHostRpcService),We(1,u.ILogService)],l),e.IExtHostDocumentsAndEditors=(0,k.createDecorator)("IExtHostDocumentsAndEditors")}),define(ke[96],Re([1,0,10,20,19,6,231,76,4,38,14,2,33,3,11,5,35,57,16,127,8,7,200,54,82,55,21]),function(Ee,e,S,T,D,O,k,A,m,s,I,E,u,C,v,r,a,d,l,i,n,t,o,c,g,f,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=e.IExtHostTesting=void 0,n=Ve(n);let _=0;const y=new WeakMap;e.IExtHostTesting=(0,C.createDecorator)("IExtHostTesting");let w=class extends m.Disposable{constructor(ee,oe,ie,ue){super(),this.logService=oe,this.commands=ie,this.editors=ue,this.resultsChangedEmitter=this._register(new O.Emitter),this.controllers=new Map,this.defaultProfilesChangedEmitter=this._register(new O.Emitter),this.followupProviders=new Set,this.testFollowups=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=ee.getProxy(r.MainContext.MainThreadTesting),this.observer=new J(this.proxy),this.runTracker=new b(this.proxy,oe),ie.registerArgumentProcessor({processArgument:Z=>{switch(Z?.$mid){case s.MarshalledId.TestItemContext:{const ve=Z,Ie=ve.tests[ve.tests.length-1].item.extId;return this.controllers.get(c.TestId.root(Ie))?.collection.tree.get(Ie)?.actual??(0,i.toItemFromContext)(Z)}case s.MarshalledId.TestMessageMenuArgs:{const{test:ve,message:Ie}=Z,X=ve.item.extId;return{test:this.controllers.get(c.TestId.root(X))?.collection.tree.get(X)?.actual??(0,i.toItemFromContext)({$mid:s.MarshalledId.TestItemContext,tests:[ve]}),message:n.TestMessage.to(Ie)}}default:return Z}}}),ie.registerCommand(!1,"testing.getExplorerSelection",async()=>{const Z=await ie.executeCommand(o.TestCommandId.GetExplorerSelection),ve=Ie=>{const X=this.controllers.get(c.TestId.root(Ie));if(X)return c.TestId.isRoot(Ie)?X.controller:X.collection.tree.get(Ie)?.actual};return{include:Z?.include.map(ve).filter(I.isDefined)||[],exclude:Z?.exclude.map(ve).filter(I.isDefined)||[]}})}createTestController(ee,oe,ie,ue){if(this.controllers.has(oe))throw new Error(`Attempt to insert a duplicate controller with ID "${oe}"`);const Z=new m.DisposableStore,ve=Z.add(new i.ExtHostTestItemCollection(oe,ie,this.editors));ve.root.label=ie;const Ie=new Map,X=new Set,V=this.proxy,re=()=>{let Fe=0;ue&&(Fe|=f.TestControllerCapability.Refresh);const ze=De.relatedCodeProvider;return ze&&(ze?.provideRelatedTests&&(Fe|=f.TestControllerCapability.TestRelatedToCode),ze?.provideRelatedCode&&(Fe|=f.TestControllerCapability.CodeRelatedToTest)),Fe},be={items:ve.root.children,get label(){return ie},set label(Fe){ie=Fe,ve.root.label=Fe,V.$updateController(oe,{label:ie})},get refreshHandler(){return ue},set refreshHandler(Fe){ue=Fe,V.$updateController(oe,{capabilities:re()})},get id(){return oe},get relatedCodeProvider(){return De.relatedCodeProvider},set relatedCodeProvider(Fe){(0,h.checkProposedApiEnabled)(ee,"testRelatedCode"),De.relatedCodeProvider=Fe,V.$updateController(oe,{capabilities:re()})},createRunProfile:(Fe,ze,Je,nt,dt,vt)=>{let ut=(0,A.hash)(Fe);for(;Ie.has(ut);)ut++;return new x(this.proxy,Ie,X,this.defaultProfilesChangedEmitter.event,oe,ut,Fe,ze,Je,nt,dt,vt)},createTestItem(Fe,ze,Je){return new i.TestItemImpl(oe,Fe,ze,Je)},createTestRun:(Fe,ze,Je=!0)=>this.runTracker.createTestRun(ee,oe,ve,Fe,ze,Je),invalidateTestResults:Fe=>{if(Fe===void 0)this.proxy.$markTestRetired(void 0);else{const ze=Fe instanceof Array?Fe:[Fe];this.proxy.$markTestRetired(ze.map(Je=>c.TestId.fromExtHostTestItem(Je,oe).toString()))}},set resolveHandler(Fe){ve.resolveHandler=Fe},get resolveHandler(){return ve.resolveHandler},dispose:()=>{Z.dispose()}},De={controller:be,collection:ve,profiles:Ie,extension:ee,activeProfiles:X};return V.$registerTestController(oe,ie,re()),Z.add((0,m.toDisposable)(()=>V.$unregisterTestController(oe))),this.controllers.set(oe,De),Z.add((0,m.toDisposable)(()=>this.controllers.delete(oe))),Z.add(ve.onDidGenerateDiff(Fe=>V.$publishDiff(oe,Fe.map(f.TestsDiffOp.serialize)))),be}createTestObserver(){return this.observer.checkout()}async runTests(ee,oe=D.CancellationToken.None){const ie=N(ee);if(!ie)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const ue=this.controllers.get(ie.controllerId);if(!ue)throw new Error("Controller not found");await this.proxy.$runTests({preserveFocus:ee.preserveFocus??!0,group:G[ie.kind],targets:[{testIds:ee.include?.map(Z=>c.TestId.fromExtHostTestItem(Z,ue.collection.root.id).toString())??[ue.collection.root.id],profileId:ie.profileId,controllerId:ie.controllerId}],exclude:ee.exclude?.map(Z=>Z.id)},oe)}registerTestFollowupProvider(ee){return this.followupProviders.add(ee),{dispose:()=>{this.followupProviders.delete(ee)}}}async $getTestsRelatedToCode(ee,oe,ie){const ue=this.editors.getDocument(E.URI.revive(ee));if(!ue)return[];const Z=n.Position.to(oe),ve=[];return await Promise.all([...this.controllers.values()].map(async Ie=>{let X;try{X=await Ie.relatedCodeProvider?.provideRelatedTests?.(ue.document,Z,ie)}catch(V){ie.isCancellationRequested||this.logService.warn(`Error thrown while providing related tests for ${Ie.controller.label}`,V)}if(X){for(const V of X)ve.push(c.TestId.fromExtHostTestItem(V,Ie.controller.id).toString());Ie.collection.flushDiff()}})),ve}async $getCodeRelatedToTest(ee,oe){const ie=this.controllers.get(c.TestId.root(ee));if(!ie)return[];const ue=ie.collection.tree.get(ee);return ue?(await ie.relatedCodeProvider?.provideRelatedCode?.(ue.actual,oe))?.map(n.location.from)??[]:[]}$syncTests(){for(const{collection:ee}of this.controllers.values())ee.flushDiff();return Promise.resolve()}async $getCoverageDetails(ee,oe,ie){return(await this.runTracker.getCoverageDetails(ee,oe,ie))?.map(n.TestCoverage.fromDetails)}async $disposeRun(ee){this.runTracker.disposeTestRun(ee)}$configureRunProfile(ee,oe){this.controllers.get(ee)?.profiles.get(oe)?.configureHandler?.()}$setDefaultRunProfiles(ee){const oe=new Map;for(const[ie,ue]of Object.entries(ee)){const Z=this.controllers.get(ie);if(!Z)continue;const ve=new Map,Ie=ue.filter(V=>!Z.activeProfiles.has(V)),X=[...Z.activeProfiles].filter(V=>!ue.includes(V));for(const V of Ie)ve.set(V,!0),Z.activeProfiles.add(V);for(const V of X)ve.set(V,!1),Z.activeProfiles.delete(V);ve.size&&oe.set(ie,ve)}this.defaultProfilesChangedEmitter.fire(oe)}async $refreshTests(ee,oe){await this.controllers.get(ee)?.controller.refreshHandler?.(oe)}$publishTestResults(ee){this.results=Object.freeze(ee.map(oe=>{const ie=n.TestResults.to(oe),ue=oe.tasks.findIndex(Z=>Z.hasCoverage);return ue!==-1&&(ie.getDetailedCoverage=(Z,ve=D.CancellationToken.None)=>this.proxy.$getCoverageDetails(oe.id,ue,Z,ve).then(Ie=>Ie.map(n.TestCoverage.to))),y.set(ie,oe.id),ie}).concat(this.results).sort((oe,ie)=>ie.completedAt-oe.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $expandTest(ee,oe){const ie=this.controllers.get(c.TestId.fromString(ee).controllerId)?.collection;ie&&(await ie.expand(ee,oe<0?1/0:oe),ie.flushDiff())}$acceptDiff(ee){this.observer.applyDiff(ee.map(oe=>f.TestsDiffOp.deserialize({asCanonicalUri:ie=>ie},oe)))}async $runControllerTests(ee,oe){return Promise.all(ee.map(ie=>this.runControllerTestRequest(ie,!1,oe)))}async $startContinuousRun(ee,oe){const ie=new D.CancellationTokenSource(oe),ue=await Promise.all(ee.map(Z=>this.runControllerTestRequest(Z,!0,ie.token)));return!oe.isCancellationRequested&&!ue.some(Z=>Z.error)&&await new Promise(Z=>oe.onCancellationRequested(Z)),ie.dispose(!0),ue}async $provideTestFollowups(ee,oe){const ie=this.results.find(ve=>y.get(ve)===ee.resultId),ue=ie&&Y(c.TestId.fromString(ee.extId),ie?.results);if(!ue)return[];let Z=[];return await Promise.all([...this.followupProviders].map(async ve=>{try{const Ie=await ve.provideFollowup(ie,ue,ee.taskIndex,ee.messageIndex,oe);Ie&&(Z=Z.concat(Ie))}catch(Ie){this.logService.error("Error thrown while providing followup for test message",Ie)}})),oe.isCancellationRequested?[]:Z.map(ve=>{const Ie=_++;return this.testFollowups.set(Ie,ve),{title:ve.title,id:Ie}})}$disposeTestFollowups(ee){for(const oe of ee)this.testFollowups.delete(oe)}$executeTestFollowup(ee){const oe=this.testFollowups.get(ee);return oe?this.commands.executeCommand(oe.command,...oe.arguments||[]):Promise.resolve()}$cancelExtensionTestRun(ee,oe){ee===void 0?this.runTracker.cancelAllRuns():this.runTracker.cancelRunById(ee,oe)}getMetadataForRun(ee){for(const oe of this.runTracker.trackers){const ie=oe.getTaskIdForRun(ee);if(ie)return{taskId:ie,runId:oe.id}}}async runControllerTestRequest(ee,oe,ie){const ue=this.controllers.get(ee.controllerId);if(!ue)return{};const{collection:Z,profiles:ve,extension:Ie}=ue,X=ve.get(ee.profileId);if(!X)return{};const V=ee.testIds.map(Fe=>Z.tree.get(Fe)).filter(I.isDefined),re=ee.excludeExtIds.map(Fe=>ue.collection.tree.get(Fe)).filter(I.isDefined).filter(Fe=>V.some(ze=>ze.fullId.compare(Fe.fullId)===c.TestPosition.IsChild));if(!V.length)return{};const be=new t.TestRunRequest(V.some(Fe=>Fe.actual instanceof i.TestItemRootImpl)?void 0:V.map(Fe=>Fe.actual),re.map(Fe=>Fe.actual),X,oe),De=(0,f.isStartControllerTests)(ee)&&this.runTracker.prepareForMainThreadTestRun(Ie,be,L.fromInternal(ee,ue.collection),X,ie);try{return await X.runHandler(be,ie),{}}catch(Fe){return{error:String(Fe)}}finally{De&&De.hasRunningTasks&&!ie.isCancellationRequested&&await O.Event.toPromise(De.onEnd)}}};e.ExtHostTesting=w,e.ExtHostTesting=w=qe([We(0,l.IExtHostRpcService),We(1,v.ILogService),We(2,a.IExtHostCommands),We(3,d.IExtHostDocumentsAndEditors)],w);const P=1e4;var R;(function(ae){ae[ae.Running=0]="Running",ae[ae.Cancelling=1]="Cancelling",ae[ae.Ended=2]="Ended"})(R||(R={}));class p extends m.Disposable{get hasRunningTasks(){return this.running>0}get id(){return this.dto.id}constructor(ee,oe,ie,ue,Z,ve){super(),this.dto=ee,this.proxy=oe,this.logService=ie,this.profile=ue,this.extension=Z,this.state=R.Running,this.running=0,this.tasks=new Map,this.sharedTestIds=new Set,this.endEmitter=this._register(new O.Emitter),this.publishedCoverage=new Map,this.onEnd=this.endEmitter.event,this.cts=this._register(new D.CancellationTokenSource(ve));const Ie=this._register(new S.RunOnceScheduler(()=>this.forciblyEndTasks(),P));this._register(this.cts.token.onCancellationRequested(()=>Ie.schedule()));const X=new O.Emitter;this.onDidDispose=X.event,this._register((0,m.toDisposable)(()=>{X.fire(),X.dispose()}))}getTaskIdForRun(ee){for(const[oe,{run:ie}]of this.tasks)if(ie===ee)return oe}cancel(ee){ee?this.tasks.get(ee)?.cts.cancel():this.state===R.Running?(this.cts.cancel(),this.state=R.Cancelling):this.state===R.Cancelling&&this.forciblyEndTasks()}async getCoverageDetails(ee,oe,ie){const[,ue]=c.TestId.fromString(ee).path,Z=this.publishedCoverage.get(ee);if(!Z)return[];const{report:ve,extIds:Ie}=Z,X=this.tasks.get(ue);if(!X)throw new Error("unreachable: run task was not found");let V;if(oe&&ve instanceof t.FileCoverage){const be=Ie.indexOf(oe);if(be===-1)return[];V=ve.fromTests[be]}return await(V?this.profile?.loadDetailedCoverageForTest?.(X.run,ve,V,ie):this.profile?.loadDetailedCoverage?.(X.run,ve,ie))??[]}createRun(ee){const oe=this.dto.id,ie=this.dto.controllerId,ue=(0,u.generateUuid)(),Z=re=>(be,...De)=>{if(Ie){this.logService.warn(`Setting the state of test "${be.id}" is a no-op after the run ends.`);return}this.ensureTestIsKnown(be),re(be,...De)},ve=(re,be)=>{const De=be instanceof Array?be.map(n.TestMessage.from):[n.TestMessage.from(be)];if(re.uri&&re.range){const Fe={range:n.Range.from(re.range),uri:re.uri};for(const ze of De)ze.location=ze.location||Fe}this.proxy.$appendTestMessagesInRun(oe,ue,c.TestId.fromExtHostTestItem(re,ie).toString(),De)};let Ie=!1;const X=this._register(new D.CancellationTokenSource(this.cts.token)),V={isPersisted:this.dto.isPersisted,token:X.token,name:ee,onDidDispose:this.onDidDispose,addCoverage:re=>{if(Ie)return;const be=re instanceof t.FileCoverage?re.fromTests:[];if(be.length){(0,h.checkProposedApiEnabled)(this.extension,"attributableCoverage");for(const ze of be)this.ensureTestIsKnown(ze)}const De=re.uri.toString(),Fe=new c.TestId([oe,ue,De]).toString();this.publishedCoverage.set(Fe,{report:re,extIds:be.map(ze=>c.TestId.fromExtHostTestItem(ze,ie).toString())}),this.proxy.$appendCoverage(oe,ue,n.TestCoverage.fromFile(ie,Fe,re))},enqueued:Z(re=>{this.proxy.$updateTestStateInRun(oe,ue,c.TestId.fromExtHostTestItem(re,ie).toString(),f.TestResultState.Queued)}),skipped:Z(re=>{this.proxy.$updateTestStateInRun(oe,ue,c.TestId.fromExtHostTestItem(re,ie).toString(),f.TestResultState.Skipped)}),started:Z(re=>{this.proxy.$updateTestStateInRun(oe,ue,c.TestId.fromExtHostTestItem(re,ie).toString(),f.TestResultState.Running)}),errored:Z((re,be,De)=>{ve(re,be),this.proxy.$updateTestStateInRun(oe,ue,c.TestId.fromExtHostTestItem(re,ie).toString(),f.TestResultState.Errored,De)}),failed:Z((re,be,De)=>{ve(re,be),this.proxy.$updateTestStateInRun(oe,ue,c.TestId.fromExtHostTestItem(re,ie).toString(),f.TestResultState.Failed,De)}),passed:Z((re,be)=>{this.proxy.$updateTestStateInRun(oe,ue,c.TestId.fromExtHostTestItem(re,this.dto.controllerId).toString(),f.TestResultState.Passed,be)}),appendOutput:(re,be,De)=>{Ie||(De&&this.ensureTestIsKnown(De),this.proxy.$appendOutputToRun(oe,ue,T.VSBuffer.fromString(re),be&&n.location.from(be),De&&c.TestId.fromExtHostTestItem(De,ie).toString()))},end:()=>{Ie||(Ie=!0,this.proxy.$finishedTestRunTask(oe,ue),--this.running||this.markEnded())}};return this.running++,this.tasks.set(ue,{run:V,cts:X}),this.proxy.$startedTestRunTask(oe,{id:ue,ctrlId:this.dto.controllerId,name:ee||this.extension.displayName||this.extension.identifier.value,running:!0}),V}forciblyEndTasks(){for(const{run:ee}of this.tasks.values())ee.end()}markEnded(){this.state!==R.Ended&&(this.state=R.Ended,this.endEmitter.fire())}ensureTestIsKnown(ee){if(!(ee instanceof i.TestItemImpl))throw new g.InvalidTestItemError(ee.id);if(this.sharedTestIds.has(c.TestId.fromExtHostTestItem(ee,this.dto.controllerId).toString()))return;const oe=[],ie=this.dto.colllection.root;for(;;){const ue=n.TestItem.from(ee);if(oe.unshift(ue),this.sharedTestIds.has(ue.extId)||(this.sharedTestIds.add(ue.extId),ee===ie))break;ee=ee.parent||ie}this.proxy.$addTestsToRun(this.dto.controllerId,this.dto.id,oe)}dispose(){this.markEnded(),super.dispose()}}class b{get trackers(){return this.tracked.values()}constructor(ee,oe){this.proxy=ee,this.logService=oe,this.tracked=new Map,this.trackedById=new Map}getCoverageDetails(ee,oe,ie){const ue=c.TestId.root(ee);return this.trackedById.get(ue)?.getCoverageDetails(ee,oe,ie)||[]}disposeTestRun(ee){this.trackedById.get(ee)?.dispose(),this.trackedById.delete(ee);for(const[oe,{id:ie}]of this.tracked)ie===ee&&this.tracked.delete(oe)}prepareForMainThreadTestRun(ee,oe,ie,ue,Z){return this.getTracker(oe,ie,ue,ee,Z)}cancelRunById(ee,oe){this.trackedById.get(ee)?.cancel(oe)}cancelAllRuns(){for(const ee of this.tracked.values())ee.cancel()}createTestRun(ee,oe,ie,ue,Z,ve){const Ie=this.tracked.get(ue);if(Ie)return Ie.createRun(Z);const X=L.fromPublic(oe,ie,ue,ve),V=N(ue);this.proxy.$startedExtensionTestRun({controllerId:oe,continuous:!!ue.continuous,profile:V&&{group:G[V.kind],id:V.profileId},exclude:ue.exclude?.map(be=>c.TestId.fromExtHostTestItem(be,ie.root.id).toString())??[],id:X.id,include:ue.include?.map(be=>c.TestId.fromExtHostTestItem(be,ie.root.id).toString())??[ie.root.id],preserveFocus:ue.preserveFocus??!0,persist:ve});const re=this.getTracker(ue,X,ue.profile,ee);return O.Event.once(re.onEnd)(()=>{this.proxy.$finishedExtensionTestRun(X.id)}),re.createRun(Z)}getTracker(ee,oe,ie,ue,Z){const ve=new p(oe,this.proxy,this.logService,ie,ue,Z);return this.tracked.set(ee,ve),this.trackedById.set(ve.id,ve),ve}}e.TestRunCoordinator=b;const N=ae=>{if(ae.profile){if(!(ae.profile instanceof x))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return ae.profile}};class L{static fromPublic(ee,oe,ie,ue){return new L(ee,(0,u.generateUuid)(),ue,oe)}static fromInternal(ee,oe){return new L(ee.controllerId,ee.runId,!0,oe)}constructor(ee,oe,ie,ue){this.controllerId=ee,this.id=oe,this.isPersisted=ie,this.colllection=ue}}e.TestRunDto=L;class F{get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}constructor(ee){this.emitter=ee,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}add(ee){this.added.add(ee)}update(ee){Object.assign(ee.revived,n.TestItem.toPlain(ee.item)),this.added.has(ee)||this.updated.add(ee)}remove(ee){if(this.added.has(ee)){this.added.delete(ee);return}this.updated.delete(ee);const oe=c.TestId.parentId(ee.item.extId);if(oe&&this.alreadyRemoved.has(oe.toString())){this.alreadyRemoved.add(ee.item.extId);return}this.removed.add(ee)}getChangeEvent(){const{added:ee,updated:oe,removed:ie}=this;return{get added(){return[...ee].map(ue=>ue.revived)},get updated(){return[...oe].map(ue=>ue.revived)},get removed(){return[...ie].map(ue=>ue.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class K extends f.AbstractIncrementalTestCollection{constructor(){super(...arguments),this.changeEmitter=new O.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTests(){return this.roots}getMirroredTestDataById(ee){return this.items.get(ee)}getMirroredTestDataByReference(ee){return this.items.get(ee.id)}createItem(ee,oe){return{...ee,revived:n.TestItem.toPlain(ee.item),depth:oe?oe.depth+1:0,children:new Set}}createChangeCollector(){return new F(this.changeEmitter)}}class J{constructor(ee){this.proxy=ee}checkout(){this.current||(this.current=this.createObserverData());const ee=this.current;return ee.observers++,{onDidChangeTest:ee.tests.onDidChangeTests,get tests(){return[...ee.tests.rootTests].map(oe=>oe.revived)},dispose:(0,k.createSingleCallFunction)(()=>{--ee.observers===0&&(this.proxy.$unsubscribeFromDiffs(),this.current=void 0)})}}getMirroredTestDataByReference(ee){return this.current?.tests.getMirroredTestDataByReference(ee)}applyDiff(ee){this.current?.tests.apply(ee)}createObserverData(){const ee=new K({asCanonicalUri:oe=>oe});return this.proxy.$subscribeToDiffs(),{observers:0,tests:ee}}}const $=(ae,ee,oe,ie)=>{oe?Object.assign(oe,ie):ee.$updateTestRunConfig(ae.controllerId,ae.profileId,ie)};class x{#e;#t;#i;#n;#s;get label(){return this._label}set label(ee){ee!==this._label&&(this._label=ee,$(this,this.#e,this.#n,{label:ee}))}get supportsContinuousRun(){return this._supportsContinuousRun}set supportsContinuousRun(ee){ee!==this._supportsContinuousRun&&(this._supportsContinuousRun=ee,$(this,this.#e,this.#n,{supportsContinuousRun:ee}))}get isDefault(){return this.#t.has(this.profileId)}set isDefault(ee){ee!==this.isDefault&&(ee?this.#t.add(this.profileId):this.#t.delete(this.profileId),$(this,this.#e,this.#n,{isDefault:ee}))}get tag(){return this._tag}set tag(ee){ee?.id!==this._tag?.id&&(this._tag=ee,$(this,this.#e,this.#n,{tag:ee?n.TestTag.namespace(this.controllerId,ee.id):null}))}get configureHandler(){return this._configureHandler}set configureHandler(ee){ee!==this._configureHandler&&(this._configureHandler=ee,$(this,this.#e,this.#n,{hasConfigurationHandler:!!ee}))}get onDidChangeDefault(){return O.Event.chain(this.#i,ee=>ee.map(oe=>oe.get(this.controllerId)?.get(this.profileId)).filter(I.isDefined))}constructor(ee,oe,ie,ue,Z,ve,Ie,X,V,re=!1,be=void 0,De=!1){this.controllerId=Z,this.profileId=ve,this._label=Ie,this.kind=X,this.runHandler=V,this._tag=be,this._supportsContinuousRun=De,this.#e=ee,this.#s=oe,this.#t=ie,this.#i=ue,oe.set(ve,this);const Fe=G[X];if(typeof Fe!="number")throw new Error(`Unknown TestRunProfile.group ${X}`);re&&ie.add(ve),this.#n={profileId:ve,controllerId:Z,tag:be?n.TestTag.namespace(this.controllerId,be.id):null,label:Ie,group:Fe,isDefault:re,hasConfigurationHandler:!1,supportsContinuousRun:De},queueMicrotask(()=>{this.#n&&(this.#e.$publishTestRunProfile(this.#n),this.#n=void 0)})}dispose(){this.#s?.delete(this.profileId)&&(this.#s=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId)),this.#n=void 0}}e.TestRunProfileImpl=x;const G={[t.TestRunProfileKind.Coverage]:f.TestRunProfileBitset.Coverage,[t.TestRunProfileKind.Debug]:f.TestRunProfileBitset.Debug,[t.TestRunProfileKind.Run]:f.TestRunProfileBitset.Run};function Y(ae,ee){for(let oe=0;oe<ae.path.length;oe++){const ie=ee.find(ue=>ue.id===ae.path[oe]);if(!ie)return;if(oe===ae.path.length-1)return ie;ee=ie.children}}}),define(ke[259],Re([1,0,17,6,4,5,129,8,7]),function(Ee,e,S,T,D,O,k,A,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0,S=Ve(S),A=Ve(A);class s extends D.Disposable{constructor(E,u){super(),this._extHostDocumentsAndEditors=u,this._onDidChangeTextEditorSelection=new T.Emitter,this._onDidChangeTextEditorOptions=new T.Emitter,this._onDidChangeTextEditorVisibleRanges=new T.Emitter,this._onDidChangeTextEditorViewColumn=new T.Emitter,this._onDidChangeActiveTextEditor=new T.Emitter,this._onDidChangeVisibleTextEditors=new T.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=E.getProxy(O.MainContext.MainThreadTextEditors),this._register(this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(C=>this._onDidChangeVisibleTextEditors.fire(C))),this._register(this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(C=>this._onDidChangeActiveTextEditor.fire(C)))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(E){const u=this._extHostDocumentsAndEditors.allEditors();return E?u:u.map(C=>C.value)}async showTextDocument(E,u,C){let v;typeof u=="number"?v={position:A.ViewColumn.from(u),preserveFocus:C}:typeof u=="object"?v={position:A.ViewColumn.from(u.viewColumn),preserveFocus:u.preserveFocus,selection:typeof u.selection=="object"?A.Range.from(u.selection):void 0,pinned:typeof u.preview=="boolean"?!u.preview:void 0}:v={preserveFocus:!1};const r=await this._proxy.$tryShowTextDocument(E.uri,v),a=r&&this._extHostDocumentsAndEditors.getEditor(r);if(a)return a.value;throw r?new Error(`Could NOT open editor for "${E.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${E.uri.toString()}".`)}createTextEditorDecorationType(E,u){return new k.TextEditorDecorationType(this._proxy,E,u).value}$acceptEditorPropertiesChanged(E,u){const C=this._extHostDocumentsAndEditors.getEditor(E);if(!C)throw new Error("unknown text editor");if(u.options&&C._acceptOptions(u.options),u.selections){const v=u.selections.selections.map(A.Selection.to);C._acceptSelections(v)}if(u.visibleRanges){const v=S.coalesce(u.visibleRanges.map(A.Range.to));C._acceptVisibleRanges(v)}if(u.options&&this._onDidChangeTextEditorOptions.fire({textEditor:C.value,options:{...u.options,lineNumbers:A.TextEditorLineNumbersStyle.to(u.options.lineNumbers)}}),u.selections){const v=m.TextEditorSelectionChangeKind.fromValue(u.selections.source),r=u.selections.selections.map(A.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:C.value,selections:r,kind:v})}if(u.visibleRanges){const v=S.coalesce(u.visibleRanges.map(A.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:C.value,visibleRanges:v})}}$acceptEditorPositionData(E){for(const u in E){const C=this._extHostDocumentsAndEditors.getEditor(u);if(!C)throw new Error("Unknown text editor");const v=A.ViewColumn.to(E[u]);C.value.viewColumn!==v&&(C._acceptViewColumn(v),this._onDidChangeTextEditorViewColumn.fire({textEditor:C.value,viewColumn:v}))}}getDiffInformation(E){return Promise.resolve(this._proxy.$getDiffInformation(E))}}e.ExtHostEditors=s}),define(ke[260],Re([1,0,2,3,5,4,7,8,18,38,14]),function(Ee,e,S,T,D,O,k,A,m,s,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,T.createDecorator)("IExtHostTimeline");class E{constructor(v,r){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=v.getProxy(D.MainContext.MainThreadTimeline),r.registerArgumentProcessor({processArgument:(a,d)=>{if(a&&a.$mid===s.MarshalledId.TimelineActionContext)if(this._providers.get(a.source)&&m.ExtensionIdentifier.equals(d,this._providers.get(a.source)?.extension)){const l=a.uri===void 0?void 0:S.URI.revive(a.uri);return this._itemsBySourceAndUriMap.get(a.source)?.get(u(l))?.get(a.handle)}else return;return a}})}async $getTimeline(v,r,a,d){return this._providers.get(v)?.provider.provideTimeline(S.URI.revive(r),a,d)}registerTimelineProvider(v,r,a,d){const l=new O.DisposableStore,i=this.convertTimelineItem(r.id,d,l).bind(this);let n;r.onDidChange&&(n=r.onDidChange(o=>this._proxy.$emitTimelineChangeEvent({uri:void 0,reset:!0,...o,id:r.id}),this));const t=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore({...r,scheme:v,onDidChange:void 0,async provideTimeline(o,c,g){c?.resetCache&&(l.clear(),t.get(r.id)?.clear());const f=await r.provideTimeline(o,c,g);if(f==null)return;const h=i(o,c);return{...f,source:r.id,items:f.items.map(h)}},dispose(){for(const o of t.values())o.get(r.id)?.clear();n?.dispose(),l.dispose()}},a)}convertTimelineItem(v,r,a){return(d,l)=>{let i;if(l?.cacheResults){let n=this._itemsBySourceAndUriMap.get(v);n===void 0&&(n=new Map,this._itemsBySourceAndUriMap.set(v,n));const t=u(d);i=n.get(t),i===void 0&&(i=new Map,n.set(t,i))}return n=>{const{iconPath:t,...o}=n,c=`${v}|${n.id??n.timestamp}`;i?.set(c,n);let g,f,h;n.iconPath&&(t instanceof k.ThemeIcon?h={id:t.id,color:t.color}:S.URI.isUri(t)?(g=t,f=t):{light:g,dark:f}=t);let _;return k.MarkdownString.isMarkdownString(o.tooltip)?_=A.MarkdownString.from(o.tooltip):(0,I.isString)(o.tooltip)?_=o.tooltip:k.MarkdownString.isMarkdownString(o.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),_=A.MarkdownString.from(o.detail)):(0,I.isString)(o.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),_=o.detail),{...o,id:o.id??void 0,handle:c,source:v,command:n.command?r.toInternal(n.command,a):void 0,icon:g,iconDark:f,themeIcon:h,tooltip:_,accessibilityInformation:n.accessibilityInformation}}}}registerTimelineProviderCore(v,r){if(this._providers.get(v.id))throw new Error(`Timeline Provider ${v.id} already exists.`);return this._proxy.$registerTimelineProvider({id:v.id,label:v.label,scheme:v.scheme}),this._providers.set(v.id,{provider:v,extension:r}),(0,O.toDisposable)(()=>{for(const d of this._itemsBySourceAndUriMap.values())d.get(v.id)?.clear();this._providers.delete(v.id),this._proxy.$unregisterTimelineProvider(v.id),v.dispose()})}}e.ExtHostTimeline=E;function u(C){return C?.toString()}}),define(ke[261],Re([1,0,9,24,2,6,4,192,10,7,14,17,8,59,19,156,21]),function(Ee,e,S,T,D,O,k,A,m,s,I,E,u,C,v,r,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0,s=Ve(s);function d(n,t){if((0,I.isString)(n))return{label:n};if(n&&typeof n=="object"&&typeof n.label=="string"){let o;return Array.isArray(n.highlights)&&(o=n.highlights.filter(c=>c.length===2&&typeof c[0]=="number"&&typeof c[1]=="number"),o=o.length?o:void 0),{label:n.label,highlights:o}}}class l extends k.Disposable{constructor(t,o,c){super(),this._proxy=t,this.commands=o,this.logService=c,this.treeViews=new Map,this.treeDragAndDropService=new r.TreeViewsDnDService;function g(f){return f&&f.$treeViewId&&(f.$treeItemHandle||f.$selectedTreeItems||f.$focusedTreeItem)}o.registerArgumentProcessor({processArgument:f=>g(f)?this.convertArgument(f):Array.isArray(f)&&f.length>0?f.map(h=>g(h)?this.convertArgument(h):h):f})}registerTreeDataProvider(t,o,c){const g=this.createTreeView(t,{treeDataProvider:o},c);return{dispose:()=>g.dispose()}}createTreeView(t,o,c){if(!o||!o.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const g=o.dragAndDropController?.dropMimeTypes??[],f=o.dragAndDropController?.dragMimeTypes??[],h=!!o.dragAndDropController?.handleDrag,_=!!o.dragAndDropController?.handleDrop,y=this.createExtHostTreeView(t,o,c),w={showCollapseAll:!!o.showCollapseAll,canSelectMany:!!o.canSelectMany,dropMimeTypes:g,dragMimeTypes:f,hasHandleDrag:h,hasHandleDrop:_,manuallyManageCheckboxes:!!o.manageCheckboxStateManually},P=this._proxy.$registerTreeViewDataProvider(t,w),R={get onDidCollapseElement(){return y.onDidCollapseElement},get onDidExpandElement(){return y.onDidExpandElement},get selection(){return y.selectedElements},get onDidChangeSelection(){return y.onDidChangeSelection},get activeItem(){return(0,a.checkProposedApiEnabled)(c,"treeViewActiveItem"),y.focusedElement},get onDidChangeActiveItem(){return(0,a.checkProposedApiEnabled)(c,"treeViewActiveItem"),y.onDidChangeActiveItem},get visible(){return y.visible},get onDidChangeVisibility(){return y.onDidChangeVisibility},get onDidChangeCheckboxState(){return y.onDidChangeCheckboxState},get message(){return y.message},set message(p){(0,C.isMarkdownString)(p)&&(0,a.checkProposedApiEnabled)(c,"treeViewMarkdownMessage"),y.message=p},get title(){return y.title},set title(p){y.title=p},get description(){return y.description},set description(p){y.description=p},get badge(){return y.badge},set badge(p){p!==void 0&&s.ViewBadge.isViewBadge(p)?y.badge={value:Math.floor(Math.abs(p.value)),tooltip:p.tooltip}:p===void 0&&(y.badge=void 0)},reveal:(p,b)=>y.reveal(p,b),dispose:async()=>{await P,this.treeViews.delete(t),y.dispose()}};return this._register(R),R}$getChildren(t,o){const c=this.treeViews.get(t);return c?c.getChildren(o):Promise.reject(new A.NoTreeViewError(t))}async $handleDrop(t,o,c,g,f,h,_,y){const w=this.treeViews.get(t);if(!w)return Promise.reject(new A.NoTreeViewError(t));const P=u.DataTransfer.toDataTransfer(c,async R=>(await this._proxy.$resolveDropFileData(t,o,R)).buffer);return _===t&&y&&await this.addAdditionalTransferItems(P,w,y,f,h),w.onDrop(P,g,f)}async addAdditionalTransferItems(t,o,c,g,f){const h=this.treeDragAndDropService.removeDragOperationTransfer(f);if(h)(await h)?.forEach((_,y)=>{_&&t.set(y,_)});else if(f&&o.handleDrag){const _=o.handleDrag(c,t,g);this.treeDragAndDropService.addDragOperationTransfer(f,_),await _}return t}async $handleDrag(t,o,c,g){const f=this.treeViews.get(t);if(!f)return Promise.reject(new A.NoTreeViewError(t));const h=await this.addAdditionalTransferItems(new s.DataTransfer,f,o,g,c);if(!(!h||g.isCancellationRequested))return u.DataTransfer.from(h)}async $hasResolve(t){const o=this.treeViews.get(t);if(!o)throw new A.NoTreeViewError(t);return o.hasResolve}$resolve(t,o,c){const g=this.treeViews.get(t);if(!g)throw new A.NoTreeViewError(t);return g.resolveTreeItem(o,c)}$setExpanded(t,o,c){const g=this.treeViews.get(t);if(!g)throw new A.NoTreeViewError(t);g.setExpanded(o,c)}$setSelectionAndFocus(t,o,c){const g=this.treeViews.get(t);if(!g)throw new A.NoTreeViewError(t);g.setSelectionAndFocus(o,c)}$setVisible(t,o){const c=this.treeViews.get(t);if(!c){if(!o)return;throw new A.NoTreeViewError(t)}c.setVisible(o)}$changeCheckboxState(t,o){const c=this.treeViews.get(t);if(!c)throw new A.NoTreeViewError(t);c.setCheckboxState(o)}createExtHostTreeView(t,o,c){const g=this._register(new i(t,o,this._proxy,this.commands.converter,this.logService,c));return this.treeViews.set(t,g),g}convertArgument(t){const o=this.treeViews.get(t.$treeViewId);return o&&"$treeItemHandle"in t?o.getExtensionElement(t.$treeItemHandle):o&&"$focusedTreeItem"in t&&t.$focusedTreeItem?o.focusedElement:null}}e.ExtHostTreeViews=l;class i extends k.Disposable{static{this.LABEL_HANDLE_PREFIX="0"}static{this.ID_HANDLE_PREFIX="1"}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(t=>this.getExtensionElement(t)).filter(t=>!(0,I.isUndefinedOrNull)(t))}get focusedElement(){return this._focusedHandle?this.getExtensionElement(this._focusedHandle):void 0}constructor(t,o,c,g,f,h){if(super(),this.viewId=t,this.proxy=c,this.commands=g,this.logService=f,this.extension=h,this.roots=void 0,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._focusedHandle=void 0,this._onDidExpandElement=this._register(new O.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new O.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new O.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeActiveItem=this._register(new O.Emitter),this.onDidChangeActiveItem=this._onDidChangeActiveItem.event,this._onDidChangeVisibility=this._register(new O.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeCheckboxState=this._register(new O.Emitter),this.onDidChangeCheckboxState=this._onDidChangeCheckboxState.event,this._onDidChangeData=this._register(new O.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new v.CancellationTokenSource,h.contributes&&h.contributes.views)for(const P in h.contributes.views)for(const R of h.contributes.views[P])R.id===t&&(this._title=R.name);this.dataProvider=o.treeDataProvider,this.dndController=o.dragAndDropController,this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(P=>{Array.isArray(P)&&P.length===0||this._onDidChangeData.fire({message:!1,element:P})}));let _,y;const w=O.Event.debounce(this._onDidChangeData.event,(P,R)=>(P||(P={message:!1,elements:[]}),R.element!==!1&&(_||(_=new Promise(p=>y=p),this.refreshPromise=this.refreshPromise.then(()=>_)),Array.isArray(R.element)?P.elements.push(...R.element):P.elements.push(R.element)),R.message&&(P.message=!0),P),200,!0);this._register(w(({message:P,elements:R})=>{R.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const p=y;return _=null,this.refresh(R).then(()=>p())})),P&&this.proxy.$setMessage(this.viewId,u.MarkdownString.fromStrict(this._message)??"")}))}async getChildren(t){const o=t?this.getExtensionElement(t):void 0;if(t&&!o)return this.logService.error(`No tree item with id '${t}' found.`),Promise.resolve([]);let c=this.getChildrenNodes(t);return c||(c=await this.fetchChildrenNodes(o)),c?c.map(g=>g.item):void 0}getExtensionElement(t){return this.elements.get(t)}reveal(t,o){o=o||{select:!0,focus:!1};const c=(0,I.isUndefinedOrNull)(o.select)?!0:o.select,g=(0,I.isUndefinedOrNull)(o.focus)?!1:o.focus,f=(0,I.isUndefinedOrNull)(o.expand)?!1:o.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):t?this.refreshPromise.then(()=>this.resolveUnknownParentChain(t)).then(h=>this.resolveTreeNode(t,h[h.length-1]).then(_=>this.proxy.$reveal(this.viewId,{item:_.item,parentChain:h.map(y=>y.item)},{select:c,focus:g,expand:f})),h=>this.logService.error(h)):this.proxy.$reveal(this.viewId,void 0,{select:c,focus:g,expand:f})}get message(){return this._message}set message(t){this._message=t,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(t){this._title=t,this.proxy.$setTitle(this.viewId,t,this._description)}get description(){return this._description}set description(t){this._description=t,this.proxy.$setTitle(this.viewId,this._title,t)}get badge(){return this._badge}set badge(t){this._badge?.value===t?.value&&this._badge?.tooltip===t?.tooltip||(this._badge=u.ViewBadge.from(t),this.proxy.$setBadge(this.viewId,t))}setExpanded(t,o){const c=this.getExtensionElement(t);c&&(o?this._onDidExpandElement.fire(Object.freeze({element:c})):this._onDidCollapseElement.fire(Object.freeze({element:c})))}setSelectionAndFocus(t,o){const c=!(0,E.equals)(this._selectedHandles,t);this._selectedHandles=t;const g=this._focusedHandle!==o;this._focusedHandle=o,c&&this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})),g&&this._onDidChangeActiveItem.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(t){t!==this._visible&&(this._visible=t,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}async setCheckboxState(t){const o=(await Promise.all(t.map(async c=>{const g=this.getExtensionElement(c.treeItemHandle);return g?{extensionItem:g,treeItem:await this.dataProvider.getTreeItem(g),newState:c.newState?s.TreeItemCheckboxState.Checked:s.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(c=>c!==void 0);o.forEach(c=>{c.treeItem.checkboxState=c.newState?s.TreeItemCheckboxState.Checked:s.TreeItemCheckboxState.Unchecked}),this._onDidChangeCheckboxState.fire({items:o.map(c=>[c.extensionItem,c.newState])})}async handleDrag(t,o,c){const g=[];for(const f of t){const h=this.getExtensionElement(f);h&&g.push(h)}if(!(!this.dndController?.handleDrag||g.length===0))return await this.dndController.handleDrag(g,o,c),o}get hasHandleDrag(){return!!this.dndController?.handleDrag}async onDrop(t,o,c){const g=o?this.getExtensionElement(o):void 0;if(!(!g&&o||!this.dndController?.handleDrop))return(0,m.asPromise)(()=>this.dndController?.handleDrop?this.dndController.handleDrop(g,t,c):void 0)}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(t,o){if(!this.dataProvider.resolveTreeItem)return;const c=this.elements.get(t);if(c){const g=this.nodes.get(c);if(g){const f=await this.dataProvider.resolveTreeItem(g.extensionItem,c,o)??g.extensionItem;return this.validateTreeItem(f),g.item.tooltip=this.getTooltip(f.tooltip),g.item.command=this.getCommand(g.disposableStore,f.command),g.item}}}resolveUnknownParentChain(t){return this.resolveParent(t).then(o=>o?this.resolveUnknownParentChain(o).then(c=>this.resolveTreeNode(o,c[c.length-1]).then(g=>(c.push(g),c))):Promise.resolve([]))}resolveParent(t){const o=this.nodes.get(t);return o?Promise.resolve(o.parent?this.elements.get(o.parent.item.handle):void 0):(0,m.asPromise)(()=>this.dataProvider.getParent(t))}resolveTreeNode(t,o){const c=this.nodes.get(t);return c?Promise.resolve(c):(0,m.asPromise)(()=>this.dataProvider.getTreeItem(t)).then(g=>this.createHandle(t,g,o,!0)).then(g=>this.getChildren(o?o.item.handle:void 0).then(()=>{const f=this.getExtensionElement(g);if(f){const h=this.nodes.get(f);if(h)return Promise.resolve(h)}throw new Error(`Cannot resolve tree item for element ${g} from extension ${this.extension.identifier.value}`)}))}getChildrenNodes(t){if(t){let o;if(typeof t=="string"){const c=this.getExtensionElement(t);o=c?this.nodes.get(c):void 0}else o=t;return o&&o.children||void 0}return this.roots}async fetchChildrenNodes(t){this.clearChildren(t);const o=new v.CancellationTokenSource(this._refreshCancellationSource.token);try{const c=t?this.nodes.get(t):void 0,g=await this.dataProvider.getChildren(t);if(o.token.isCancellationRequested)return;const f=(0,E.coalesce)(g||[]),h=await Promise.all((0,E.coalesce)(f).map(y=>this.dataProvider.getTreeItem(y)));if(o.token.isCancellationRequested)return;const _=h.map((y,w)=>y?this.createAndRegisterTreeNode(f[w],y,c):null);return(0,E.coalesce)(_)}finally{o.dispose()}}refresh(t){if(t.some(c=>!c))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new v.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const c=this.getHandlesToRefresh(t);if(c.length)return this.refreshHandles(c)}return Promise.resolve(void 0)}getHandlesToRefresh(t){const o=new Set,c=t.map(f=>this.nodes.get(f));for(const f of c)if(f&&!o.has(f.item.handle)){let h=f;for(;h&&h.parent&&c.findIndex(_=>h&&h.parent&&_&&_.item.handle===h.parent.item.handle)===-1;){const _=this.elements.get(h.parent.item.handle);h=_?this.nodes.get(_):void 0}h&&!h.parent&&o.add(f.item.handle)}const g=[];return o.forEach(f=>{const h=this.elements.get(f);if(h){const _=this.nodes.get(h);_&&(!_.parent||!o.has(_.parent.item.handle))&&g.push(f)}}),g}refreshHandles(t){const o={};return Promise.all(t.map(c=>this.refreshNode(c).then(g=>{g&&(o[c]=g.item)}))).then(()=>Object.keys(o).length?this.proxy.$refresh(this.viewId,o):void 0)}refreshNode(t){const o=this.getExtensionElement(t);if(o){const c=this.nodes.get(o);if(c)return this.clearChildren(o),(0,m.asPromise)(()=>this.dataProvider.getTreeItem(o)).then(g=>{if(g){const f=this.createTreeNode(o,g,c.parent);return this.updateNodeCache(o,f,c,c.parent),c.dispose(),f}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(t,o,c){const g=this.createTreeNode(t,o,c);if(o.id&&this.elements.has(g.item.handle))throw new Error((0,S.localize)(2715,null,o.id));return this.addNodeToCache(t,g),this.addNodeToParentCache(g,c),g}getTooltip(t){return s.MarkdownString.isMarkdownString(t)?u.MarkdownString.from(t):t}getCommand(t,o){return o?{...this.commands.toInternal(o,t),originalId:o.command}:void 0}getCheckbox(t){if(t.checkboxState===void 0)return;let o,c,g;return typeof t.checkboxState=="number"?o=t.checkboxState:(o=t.checkboxState.state,c=t.checkboxState.tooltip,g=t.checkboxState.accessibilityInformation),{isChecked:o===s.TreeItemCheckboxState.Checked,tooltip:c,accessibilityInformation:g}}validateTreeItem(t){if(!s.TreeItem.isTreeItem(t,this.extension))throw new Error(`Extension ${this.extension.identifier.value} has provided an invalid tree item.`)}createTreeNode(t,o,c){this.validateTreeItem(o);const g=this._register(new k.DisposableStore),f=this.createHandle(t,o,c),h=this.getLightIconPath(o);return{item:{handle:f,parentHandle:c?c.item.handle:void 0,label:d(o.label,this.extension),description:o.description,resourceUri:o.resourceUri,tooltip:this.getTooltip(o.tooltip),command:this.getCommand(g,o.command),contextValue:o.contextValue,icon:h,iconDark:this.getDarkIconPath(o)||h,themeIcon:this.getThemeIcon(o),collapsibleState:(0,I.isUndefinedOrNull)(o.collapsibleState)?s.TreeItemCollapsibleState.None:o.collapsibleState,accessibilityInformation:o.accessibilityInformation,checkbox:this.getCheckbox(o)},extensionItem:o,parent:c,children:void 0,disposableStore:g,dispose(){g.dispose()}}}getThemeIcon(t){return t.iconPath instanceof s.ThemeIcon?t.iconPath:void 0}createHandle(t,{id:o,label:c,resourceUri:g},f,h){if(o)return`${i.ID_HANDLE_PREFIX}/${o}`;const _=d(c,this.extension),y=f?f.item.handle:i.LABEL_HANDLE_PREFIX;let w=_?_.label:g?(0,T.basename)(g):"";w=w.indexOf("/")!==-1?w.replace("/","//"):w;const P=this.nodes.has(t)?this.nodes.get(t).item.handle:void 0,R=this.getChildrenNodes(f)||[];let p,b=0;do{if(p=`${y}/${b}:${w}`,h||!this.elements.has(p)||P===p)break;b++}while(b<=R.length);return p}getLightIconPath(t){if(t.iconPath&&!(t.iconPath instanceof s.ThemeIcon))return typeof t.iconPath=="string"||D.URI.isUri(t.iconPath)?this.getIconPath(t.iconPath):this.getIconPath(t.iconPath.light)}getDarkIconPath(t){if(t.iconPath&&!(t.iconPath instanceof s.ThemeIcon)&&t.iconPath.dark)return this.getIconPath(t.iconPath.dark)}getIconPath(t){return D.URI.isUri(t)?t:D.URI.file(t)}addNodeToCache(t,o){this.elements.set(o.item.handle,t),this.nodes.set(t,o)}updateNodeCache(t,o,c,g){this.elements.delete(o.item.handle),this.nodes.delete(t),o.item.handle!==c.item.handle&&this.elements.delete(c.item.handle),this.addNodeToCache(t,o);const f=this.getChildrenNodes(g)||[],h=f.filter(_=>_.item.handle===c.item.handle)[0];h&&f.splice(f.indexOf(h),1,o)}addNodeToParentCache(t,o){o?(o.children||(o.children=[]),o.children.push(t)):(this.roots||(this.roots=[]),this.roots.push(t))}clearChildren(t){if(t){const o=this.nodes.get(t);if(o){if(o.children)for(const c of o.children){const g=this.elements.get(c.item.handle);g&&this.clear(g)}o.children=void 0}}else this.clearAll()}clear(t){const o=this.nodes.get(t);if(o){if(o.children)for(const c of o.children){const g=this.elements.get(c.item.handle);g&&this.clear(g)}this.nodes.delete(t),this.elements.delete(o.item.handle),o.dispose()}}clearAll(){this.roots=void 0,this.elements.clear(),this.nodes.forEach(t=>t.dispose()),this.nodes.clear()}dispose(){super.dispose(),this._refreshCancellationSource.dispose(),this.clearAll(),this.proxy.$disposeTree(this.viewId)}}}),define(ke[262],Re([1,0,6,4,2,33,8,67,5,7]),function(Ee,e,S,T,D,O,k,A,m,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0,k=Ve(k),m=Ve(m),s=Ve(s);class I extends T.Disposable{#e;#t;#i;#n;#s;#r;#a;#o;#l;#c;#u;#h;#d;constructor(v,r,a,d){super(),this.#o=void 0,this.#l=!0,this.#u=!1,this.#h=this._register(new S.Emitter),this.onDidDispose=this.#h.event,this.#d=this._register(new S.Emitter),this.onDidChangeViewState=this.#d.event,this.#e=v,this.#t=r,this.#n=a,this.#i=d.viewType,this.#s=d.panelOptions,this.#o=d.viewColumn,this.#r=d.title,this.#c=d.active}dispose(){this.#u||(this.#u=!0,this.#h.fire(),this.#t.$disposeWebview(this.#e),this.#n.dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),this.#n}get viewType(){return this.assertNotDisposed(),this.#i}get title(){return this.assertNotDisposed(),this.#r}set title(v){this.assertNotDisposed(),this.#r!==v&&(this.#r=v,this.#t.$setTitle(this.#e,v))}get iconPath(){return this.assertNotDisposed(),this.#a}set iconPath(v){this.assertNotDisposed(),this.#a!==v&&(this.#a=v,this.#t.$setIconPath(this.#e,D.URI.isUri(v)?{light:v,dark:v}:v))}get options(){return this.#s}get viewColumn(){if(this.assertNotDisposed(),!(typeof this.#o=="number"&&this.#o<0))return this.#o}get active(){return this.assertNotDisposed(),this.#c}get visible(){return this.assertNotDisposed(),this.#l}_updateViewState(v){this.#u||(this.active!==v.active||this.visible!==v.visible||this.viewColumn!==v.viewColumn)&&(this.#c=v.active,this.#l=v.visible,this.#o=v.viewColumn,this.#d.fire({webviewPanel:this}))}reveal(v,r){this.assertNotDisposed(),this.#t.$reveal(this.#e,{viewColumn:typeof v>"u"?void 0:k.ViewColumn.from(v),preserveFocus:!!r})}assertNotDisposed(){if(this.#u)throw new Error("Webview is disposed")}}class E extends T.Disposable{static newHandle(){return(0,O.generateUuid)()}constructor(v,r,a){super(),this.webviews=r,this.workspace=a,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=v.getProxy(m.MainContext.MainThreadWebviewPanels)}dispose(){super.dispose(),this._webviewPanels.forEach(v=>v.dispose()),this._webviewPanels.clear()}createWebviewPanel(v,r,a,d,l={}){const i=typeof d=="object"?d.viewColumn:d,n={viewColumn:k.ViewColumn.from(i),preserveFocus:typeof d=="object"&&!!d.preserveFocus},t=(0,A.shouldSerializeBuffersForPostMessage)(v),o=E.newHandle();this._proxy.$createWebviewPanel((0,A.toExtensionData)(v),o,r,{title:a,panelOptions:u(l),webviewOptions:(0,A.serializeWebviewOptions)(v,this.workspace,l),serializeBuffersForPostMessage:t},n);const c=this.webviews.createNewWebview(o,l,v);return this.createNewWebviewPanel(o,r,a,i,l,c,!0)}$onDidChangeWebviewPanelViewStates(v){const r=Object.keys(v);r.sort((a,d)=>{const l=v[a],i=v[d];return l.active?1:i.active?-1:+l.visible-+i.visible});for(const a of r){const d=this.getWebviewPanel(a);if(!d)continue;const l=v[a];d._updateViewState({active:l.active,visible:l.visible,viewColumn:k.ViewColumn.to(l.position)})}}async $onDidDisposeWebviewPanel(v){this.getWebviewPanel(v)?.dispose(),this._webviewPanels.delete(v),this.webviews.deleteWebview(v)}registerWebviewPanelSerializer(v,r,a){if(this._serializers.has(r))throw new Error(`Serializer for '${r}' already registered`);return this._serializers.set(r,{serializer:a,extension:v}),this._proxy.$registerSerializer(r,{serializeBuffersForPostMessage:(0,A.shouldSerializeBuffersForPostMessage)(v)}),new s.Disposable(()=>{this._serializers.delete(r),this._proxy.$unregisterSerializer(r)})}async $deserializeWebviewPanel(v,r,a,d){const l=this._serializers.get(r);if(!l)throw new Error(`No serializer found for '${r}'`);const{serializer:i,extension:n}=l,t=this.webviews.createNewWebview(v,a.webviewOptions,n),o=this.createNewWebviewPanel(v,r,a.title,d,a.panelOptions,t,a.active);await i.deserializeWebviewPanel(o,a.state)}createNewWebviewPanel(v,r,a,d,l,i,n){const t=new I(v,this._proxy,i,{viewType:r,title:a,viewColumn:d,panelOptions:l,active:n});return this._webviewPanels.set(v,t),t}getWebviewPanel(v){return this._webviewPanels.get(v)}}e.ExtHostWebviewPanels=E;function u(C){return{enableFindWidget:C.enableFindWidget,retainContextWhenHidden:C.retainContextWhenHidden}}}),define(ke[263],Re([1,0,6,4,67,8,5,7]),function(Ee,e,S,T,D,O,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0,k=Ve(k),A=Ve(A);class m extends T.Disposable{#e;#t;#i;#n;#s;#r;#a;#o;#l;constructor(E,u,C,v,r,a){super(),this.#s=!1,this.#c=this._register(new S.Emitter),this.onDidChangeVisibility=this.#c.event,this.#u=this._register(new S.Emitter),this.onDidDispose=this.#u.event,this.#i=C,this.#a=v,this.#e=E,this.#t=u,this.#n=r,this.#r=a}dispose(){this.#s||(this.#s=!0,this.#u.fire(),this.#n.dispose(),super.dispose())}#c;#u;get title(){return this.assertNotDisposed(),this.#a}set title(E){this.assertNotDisposed(),this.#a!==E&&(this.#a=E,this.#t.$setWebviewViewTitle(this.#e,E))}get description(){return this.assertNotDisposed(),this.#o}set description(E){this.assertNotDisposed(),this.#o!==E&&(this.#o=E,this.#t.$setWebviewViewDescription(this.#e,E))}get visible(){return this.#r}get webview(){return this.#n}get viewType(){return this.#i}_setVisible(E){E===this.#r||this.#s||(this.#r=E,this.#c.fire())}get badge(){return this.assertNotDisposed(),this.#l}set badge(E){this.assertNotDisposed(),!(E?.value===this.#l?.value&&E?.tooltip===this.#l?.tooltip)&&(this.#l=O.ViewBadge.from(E),this.#t.$setWebviewViewBadge(this.#e,E))}show(E){this.assertNotDisposed(),this.#t.$show(this.#e,!!E)}assertNotDisposed(){if(this.#s)throw new Error("Webview is disposed")}}class s{constructor(E,u){this._extHostWebview=u,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=E.getProxy(k.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(E,u,C,v){if(this._viewProviders.has(u))throw new Error(`View provider for '${u}' already registered`);return this._viewProviders.set(u,{provider:C,extension:E}),this._proxy.$registerWebviewViewProvider((0,D.toExtensionData)(E),u,{retainContextWhenHidden:v?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,D.shouldSerializeBuffersForPostMessage)(E)}),new A.Disposable(()=>{this._viewProviders.delete(u),this._proxy.$unregisterWebviewViewProvider(u)})}async $resolveWebviewView(E,u,C,v,r){const a=this._viewProviders.get(u);if(!a)throw new Error(`No view provider found for '${u}'`);const{provider:d,extension:l}=a,i=this._extHostWebview.createNewWebview(E,{},l),n=new m(E,this._proxy,u,C,i,!0);this._webviewViews.set(E,n),await d.resolveWebviewView(n,{state:v},r)}async $onDidChangeWebviewViewVisibility(E,u){this.getWebviewView(E)._setVisible(u)}async $disposeWebviewView(E){const u=this.getWebviewView(E);this._webviewViews.delete(E),u.dispose(),this._extHostWebview.deleteWebview(E)}getWebviewView(E){const u=this._webviewViews.get(E);if(!u)throw new Error("No webview found");return u}}e.ExtHostWebviewViews=s}),define(ke[264],Re([1,0,6,29,31,3]),function(Ee,e,S,T,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=e.Extensions=e.OutputChannelUpdateMode=e.IOutputService=e.CONTEXT_OUTPUT_SCROLL_LOCK=e.CONTEXT_ACTIVE_OUTPUT_LEVEL_IS_DEFAULT=e.CONTEXT_ACTIVE_OUTPUT_LEVEL=e.CONTEXT_ACTIVE_OUTPUT_LEVEL_SETTABLE=e.CONTEXT_ACTIVE_FILE_OUTPUT=e.CONTEXT_IN_OUTPUT=e.OUTPUT_VIEW_ID=e.LOG_MODE_ID=e.LOG_MIME=e.OUTPUT_MODE_ID=e.OUTPUT_MIME=void 0,e.OUTPUT_MIME="text/x-code-output",e.OUTPUT_MODE_ID="Log",e.LOG_MIME="text/x-code-log-output",e.LOG_MODE_ID="log",e.OUTPUT_VIEW_ID="workbench.panel.output",e.CONTEXT_IN_OUTPUT=new D.RawContextKey("inOutput",!1),e.CONTEXT_ACTIVE_FILE_OUTPUT=new D.RawContextKey("activeLogOutput",!1),e.CONTEXT_ACTIVE_OUTPUT_LEVEL_SETTABLE=new D.RawContextKey("activeLogOutput.levelSettable",!1),e.CONTEXT_ACTIVE_OUTPUT_LEVEL=new D.RawContextKey("activeLogOutput.level",""),e.CONTEXT_ACTIVE_OUTPUT_LEVEL_IS_DEFAULT=new D.RawContextKey("activeLogOutput.levelIsDefault",!1),e.CONTEXT_OUTPUT_SCROLL_LOCK=new D.RawContextKey("outputView.scrollLock",!1),e.IOutputService=(0,O.createDecorator)("outputService");var k;(function(m){m[m.Append=1]="Append",m[m.Replace=2]="Replace",m[m.Clear=3]="Clear"})(k||(e.OutputChannelUpdateMode=k={})),e.Extensions={OutputChannels:"workbench.contributions.outputChannels"};class A{constructor(){this.channels=new Map,this._onDidRegisterChannel=new S.Emitter,this.onDidRegisterChannel=this._onDidRegisterChannel.event,this._onDidRemoveChannel=new S.Emitter,this.onDidRemoveChannel=this._onDidRemoveChannel.event}registerChannel(s){this.channels.has(s.id)||(this.channels.set(s.id,s),this._onDidRegisterChannel.fire(s.id))}getChannels(){const s=[];return this.channels.forEach(I=>s.push(I)),s}getChannel(s){return this.channels.get(s)}removeChannel(s){this.channels.delete(s),this._onDidRemoveChannel.fire(s)}}T.Registry.add(e.Extensions.OutputChannels,new A),e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=new D.RawContextKey("activeOutputChannel","")}),define(ke[130],Re([1,0,5,3,16,18,11,264,68,26,50,158,20,14,28,6,4]),function(Ee,e,S,T,D,O,k,A,m,s,I,E,u,C,v,r,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=void 0;class d extends k.AbstractMessageLogger{get disposed(){return this._disposed}constructor(t,o,c,g,f){super(),this.id=t,this.name=o,this.logger=c,this.proxy=g,this.extension=f,this.offset=0,this._disposed=!1,this.visible=!1,this.setLevel(c.getLevel()),this._register(c.onDidChangeLogLevel(h=>this.setLevel(h)))}get logLevel(){return this.getLevel()}appendLine(t){this.append(t+`
`)}append(t){this.info(t)}clear(){const t=this.offset;this.logger.flush(),this.proxy.$update(this.id,A.OutputChannelUpdateMode.Clear,t)}replace(t){const o=this.offset;this.info(t),this.proxy.$update(this.id,A.OutputChannelUpdateMode.Replace,o),this.visible&&this.logger.flush()}show(t,o){this.logger.flush(),this.proxy.$reveal(this.id,!!(typeof t=="boolean"?t:o))}hide(){this.proxy.$close(this.id)}log(t,o){this.offset+=u.VSBuffer.fromString(o).byteLength,(0,k.log)(this.logger,t,o),this.visible&&(this.logger.flush(),this.proxy.$update(this.id,A.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this._disposed||(this.proxy.$dispose(this.id),this._disposed=!0)}}class l extends d{appendLine(t){this.append(t)}}let i=class{constructor(t,o,c,g,f,h){this.initData=o,this.extHostFileSystem=c,this.extHostFileSystemInfo=g,this.loggerService=f,this.logService=h,this.extensionLogDirectoryPromise=new Map,this.namePool=1,this.channels=new Map,this.visibleChannelId=null,this.proxy=t.getProxy(S.MainContext.MainThreadOutputService),this.outputsLocation=this.extHostFileSystemInfo.extUri.joinPath(o.logsLocation,`output_logging_${(0,E.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(t){this.visibleChannelId=t;for(const[o,c]of this.channels)c.visible=o===this.visibleChannelId}createOutputChannel(t,o,c){if(t=t.trim(),!t)throw new Error("illegal argument `name`. must not be falsy");const g=typeof o=="object"&&o.log,f=(0,C.isString)(o)?o:void 0;if((0,C.isString)(f)&&!f.trim())throw new Error("illegal argument `languageId`. must not be empty");let h;const _=this.initData.environment.extensionLogLevel?.find(([w])=>O.ExtensionIdentifier.equals(c.identifier,w))?.[1];_&&(h=(0,k.parseLogLevel)(_));const y=g?this.doCreateLogOutputChannel(t,h,c):this.doCreateOutputChannel(t,f,c);return y.then(w=>{this.channels.set(w.id,w),w.visible=w.id===this.visibleChannelId}),g?this.createExtHostLogOutputChannel(t,h??this.logService.getLevel(),y):this.createExtHostOutputChannel(t,y)}async doCreateOutputChannel(t,o,c){this.outputDirectoryPromise||(this.outputDirectoryPromise=this.extHostFileSystem.value.createDirectory(this.outputsLocation).then(()=>this.outputsLocation));const g=await this.outputDirectoryPromise,f=this.extHostFileSystemInfo.extUri.joinPath(g,`${this.namePool++}-${t.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),h=this.loggerService.createLogger(f,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),_=await this.proxy.$register(t,f,o,c.identifier.value);return new d(_,t,h,this.proxy,c)}async doCreateLogOutputChannel(t,o,c){const g=await this.createExtensionLogDirectory(c),f=t.replace(/[\\/:\*\?"<>\|]/g,""),h=this.extHostFileSystemInfo.extUri.joinPath(g,`${f}.log`),_=`${c.identifier.value}.${f}`,y=this.loggerService.createLogger(h,{id:_,name:t,logLevel:o,extensionId:c.identifier.value});return new l(_,t,y,this.proxy,c)}createExtensionLogDirectory(t){let o=this.extensionLogDirectoryPromise.get(t.identifier.value);if(!o){const c=this.extHostFileSystemInfo.extUri.joinPath(this.initData.logsLocation,t.identifier.value);this.extensionLogDirectoryPromise.set(t.identifier.value,o=(async()=>{try{await this.extHostFileSystem.value.createDirectory(c)}catch(g){if((0,v.toFileSystemProviderErrorCode)(g)!==v.FileSystemProviderErrorCode.FileExists)throw g}return c})())}return o}createExtHostOutputChannel(t,o){let c=!1;const g=()=>{if(c)throw new Error("Channel has been closed")};return{get name(){return t},append(f){g(),o.then(h=>h.append(f))},appendLine(f){g(),o.then(h=>h.appendLine(f))},clear(){g(),o.then(f=>f.clear())},replace(f){g(),o.then(h=>h.replace(f))},show(f,h){g(),o.then(_=>_.show(f,h))},hide(){g(),o.then(f=>f.hide())},dispose(){c=!0,o.then(f=>f.dispose())}}}createExtHostLogOutputChannel(t,o,c){const g=new a.DisposableStore,f=()=>{if(g.isDisposed)throw new Error("Channel has been closed")},h=g.add(new r.Emitter);function _(y){o=y,h.fire(y)}return c.then(y=>{g.add(y),y.logLevel!==o&&_(y.logLevel),g.add(y.onDidChangeLogLevel(w=>_(w)))}),{...this.createExtHostOutputChannel(t,c),get logLevel(){return o},onDidChangeLogLevel:h.event,trace(y,...w){f(),c.then(P=>P.trace(y,...w))},debug(y,...w){f(),c.then(P=>P.debug(y,...w))},info(y,...w){f(),c.then(P=>P.info(y,...w))},warn(y,...w){f(),c.then(P=>P.warn(y,...w))},error(y,...w){f(),c.then(P=>P.error(y,...w))},dispose(){g.dispose()}}}};e.ExtHostOutputService=i,e.ExtHostOutputService=i=qe([We(0,D.IExtHostRpcService),We(1,s.IExtHostInitDataService),We(2,m.IExtHostConsumerFileSystem),We(3,I.IExtHostFileSystemInfo),We(4,k.ILoggerService),We(5,k.ILogService)],i),e.IExtHostOutputService=(0,T.createDecorator)("IExtHostOutputService")}),define(ke[131],Re([1,0,3,10]),function(Ee,e,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.remoteConnectionLatencyMeasurer=e.IRemoteAgentService=void 0,e.IRemoteAgentService=(0,S.createDecorator)("remoteAgentService"),e.remoteConnectionLatencyMeasurer=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(D){let O=1/0;for(let A=0;A<this.maxSampleCount;A++){const m=await D.getRoundTripTime();if(m===void 0)return;O=Math.min(O,m/2),await(0,T.timeout)(this.sampleDelay)}this.average.push(O),this.average.length>this.maxAverageCount&&this.average.shift();let k;return this.initial.length<this.maxInitialCount?this.initial.push(O):k=this.initial.reduce((A,m)=>A+m,0)/this.initial.length,this.lastMeasurement={initial:k,current:O,average:this.average.reduce((A,m)=>A+m,0)/this.average.length,high:typeof k>"u"?!1:O>this.highLatencyMaxThreshold||O>this.highLatencyMinThreshold&&O>k*this.highLatencyMultiple},this.lastMeasurement}}}),define(ke[265],Re([1,0,9,53,29,49,44,4,6,131,23,25,10,115]),function(Ee,e,S,T,D,O,k,A,m,s,I,E,u,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DynamicWindowConfiguration=e.CONFIG_NEW_WINDOW_PROFILE=e.DynamicWorkbenchSecurityConfiguration=e.ConfigurationMigrationWorkbenchContribution=e.Extensions=e.windowConfigurationNodeBase=e.problemsConfigurationNodeBase=e.securityConfigurationNodeBase=e.workbenchConfigurationNodeBase=e.applicationConfigurationNodeBase=void 0,e.applicationConfigurationNodeBase=Object.freeze({id:"application",order:100,title:(0,S.localize)(3975,null),type:"object"}),e.workbenchConfigurationNodeBase=Object.freeze({id:"workbench",order:7,title:(0,S.localize)(3976,null),type:"object"}),e.securityConfigurationNodeBase=Object.freeze({id:"security",scope:T.ConfigurationScope.APPLICATION,title:(0,S.localize)(3977,null),type:"object",order:7}),e.problemsConfigurationNodeBase=Object.freeze({id:"problems",title:(0,S.localize)(3978,null),type:"object",order:101}),e.windowConfigurationNodeBase=Object.freeze({id:"window",order:8,title:(0,S.localize)(3979,null),type:"object"}),e.Extensions={ConfigurationMigration:"base.contributions.configuration.migration"};class v{constructor(){this.migrations=[],this._onDidRegisterConfigurationMigrations=new m.Emitter,this.onDidRegisterConfigurationMigration=this._onDidRegisterConfigurationMigrations.event}registerConfigurationMigrations(n){this.migrations.push(...n)}}const r=new v;D.Registry.add(e.Extensions.ConfigurationMigration,r);let a=class extends A.Disposable{static{this.ID="workbench.contrib.configurationMigration"}constructor(n,t){super(),this.configurationService=n,this.workspaceService=t,this._register(this.workspaceService.onDidChangeWorkspaceFolders(async o=>{for(const c of o.added)await this.migrateConfigurationsForFolder(c,r.migrations)})),this.migrateConfigurations(r.migrations),this._register(r.onDidRegisterConfigurationMigration(o=>this.migrateConfigurations(o)))}async migrateConfigurations(n){await this.migrateConfigurationsForFolder(void 0,n);for(const t of this.workspaceService.getWorkspace().folders)await this.migrateConfigurationsForFolder(t,n)}async migrateConfigurationsForFolder(n,t){await Promise.all([t.map(o=>this.migrateConfigurationsForFolderAndOverride(o,n?.uri))])}async migrateConfigurationsForFolderAndOverride(n,t){const o=this.configurationService.inspect(n.key,{resource:t}),c=this.workspaceService.getWorkbenchState()===O.WorkbenchState.WORKSPACE?[["user",k.ConfigurationTarget.USER],["userLocal",k.ConfigurationTarget.USER_LOCAL],["userRemote",k.ConfigurationTarget.USER_REMOTE],["workspace",k.ConfigurationTarget.WORKSPACE],["workspaceFolder",k.ConfigurationTarget.WORKSPACE_FOLDER]]:[["user",k.ConfigurationTarget.USER],["userLocal",k.ConfigurationTarget.USER_LOCAL],["userRemote",k.ConfigurationTarget.USER_REMOTE],["workspace",k.ConfigurationTarget.WORKSPACE]];for(const[g,f]of c){const h=o[g];if(!h)continue;const _=[];if(h.value!==void 0){const y=await this.runMigration(n,g,h.value,t,void 0);for(const w of y??[])_.push([w,[]])}for(const{identifiers:y,value:w}of h.overrides??[])if(w!==void 0){const P=await this.runMigration(n,g,w,t,y);for(const R of P??[])_.push([R,y])}_.length&&await Promise.allSettled(_.map(async([[y,w],P])=>this.configurationService.updateValue(y,w.value,{resource:t,overrideIdentifiers:P},f)))}}async runMigration(n,t,o,c,g){const f=_=>{const w=this.configurationService.inspect(_,{resource:c})[t];if(w)return g?w.overrides?.find(({identifiers:P})=>(0,E.equals)(P,g))?.value:w.value},h=await n.migrateFn(o,f);return Array.isArray(h)?h:[[n.key,h]]}};e.ConfigurationMigrationWorkbenchContribution=a,e.ConfigurationMigrationWorkbenchContribution=a=qe([We(0,k.IConfigurationService),We(1,O.IWorkspaceContextService)],a);let d=class extends A.Disposable{static{this.ID="workbench.contrib.dynamicWorkbenchSecurityConfiguration"}constructor(n){super(),this.remoteAgentService=n,this._ready=new u.DeferredPromise,this.ready=this._ready.p,this.create()}async create(){try{await this.doCreate()}finally{this._ready.complete()}}async doCreate(){if(!I.isWindows&&(await this.remoteAgentService.getEnvironment())?.os!==I.OperatingSystem.Windows)return;D.Registry.as(T.Extensions.Configuration).registerConfiguration({...e.securityConfigurationNodeBase,properties:{"security.allowedUNCHosts":{type:"array",items:{type:"string",pattern:"^[^\\\\]+$",patternErrorMessage:(0,S.localize)(3980,null)},default:[],markdownDescription:(0,S.localize)(3981,null),scope:T.ConfigurationScope.MACHINE},"security.restrictUNCAccess":{type:"boolean",default:!0,markdownDescription:(0,S.localize)(3982,null),scope:T.ConfigurationScope.MACHINE}}})}};e.DynamicWorkbenchSecurityConfiguration=d,e.DynamicWorkbenchSecurityConfiguration=d=qe([We(0,s.IRemoteAgentService)],d),e.CONFIG_NEW_WINDOW_PROFILE="window.newWindowProfile";let l=class extends A.Disposable{static{this.ID="workbench.contrib.dynamicWindowConfiguration"}constructor(n,t){super(),this.userDataProfilesService=n,this.configurationService=t,this.registerNewWindowProfileConfiguration(),this._register(this.userDataProfilesService.onDidChangeProfiles(o=>this.registerNewWindowProfileConfiguration())),this.setNewWindowProfile(),this.checkAndResetNewWindowProfileConfig(),this._register(t.onDidChangeConfiguration(o=>{o.source!==k.ConfigurationTarget.DEFAULT&&o.affectsConfiguration(e.CONFIG_NEW_WINDOW_PROFILE)&&this.setNewWindowProfile()})),this._register(this.userDataProfilesService.onDidChangeProfiles(()=>this.checkAndResetNewWindowProfileConfig()))}registerNewWindowProfileConfiguration(){const n=D.Registry.as(T.Extensions.Configuration),t={...e.windowConfigurationNodeBase,properties:{[e.CONFIG_NEW_WINDOW_PROFILE]:{type:["string","null"],default:null,enum:[...this.userDataProfilesService.profiles.map(o=>o.name),null],enumItemLabels:[...this.userDataProfilesService.profiles.map(o=>""),(0,S.localize)(3983,null)],description:(0,S.localize)(3984,null),scope:T.ConfigurationScope.APPLICATION}}};this.configurationNode?n.updateConfigurations({add:[t],remove:[this.configurationNode]}):n.registerConfiguration(t),this.configurationNode=t}setNewWindowProfile(){const n=this.configurationService.getValue(e.CONFIG_NEW_WINDOW_PROFILE);this.newWindowProfile=n?this.userDataProfilesService.profiles.find(t=>t.name===n):void 0}checkAndResetNewWindowProfileConfig(){const n=this.configurationService.getValue(e.CONFIG_NEW_WINDOW_PROFILE);if(!n)return;const t=this.newWindowProfile?this.userDataProfilesService.profiles.find(o=>o.id===this.newWindowProfile.id):void 0;n!==t?.name&&this.configurationService.updateValue(e.CONFIG_NEW_WINDOW_PROFILE,t?.name)}};e.DynamicWindowConfiguration=l,e.DynamicWindowConfiguration=l=qe([We(0,C.IUserDataProfilesService),We(1,k.IConfigurationService)],l)}),define(ke[266],Re([1,0,43,15,22,24,9,265,53,3,29]),function(Ee,e,S,T,D,O,k,A,m,s,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvedStatus=e.RegisteredEditorPriority=e.editorsAssociationsSettingId=e.IEditorResolverService=void 0,e.priorityToRank=r,e.globMatchesResource=a,S=Ve(S),e.IEditorResolverService=(0,s.createDecorator)("editorResolverService"),e.editorsAssociationsSettingId="workbench.editorAssociations";const E=I.Registry.as(m.Extensions.Configuration),u={...A.workbenchConfigurationNodeBase,properties:{"workbench.editorAssociations":{type:"object",markdownDescription:(0,k.localize)(12176,null),additionalProperties:{type:"string"}}}};E.registerConfiguration(u);var C;(function(d){d.builtin="builtin",d.option="option",d.exclusive="exclusive",d.default="default"})(C||(e.RegisteredEditorPriority=C={}));var v;(function(d){d[d.ABORT=1]="ABORT",d[d.NONE=2]="NONE"})(v||(e.ResolvedStatus=v={}));function r(d){switch(d){case C.exclusive:return 5;case C.default:return 4;case C.builtin:return 3;case C.option:default:return 1}}function a(d,l){if(new Set([T.Schemas.extension,T.Schemas.webviewPanel,T.Schemas.vscodeWorkspaceTrust,T.Schemas.vscodeSettings]).has(l.scheme))return!1;const t=typeof d=="string"&&d.indexOf(D.posix.sep)>=0?`${l.scheme}:${l.path}`:(0,O.basename)(l);return S.match(typeof d=="string"?d.toLowerCase():d,t.toLowerCase())}}),define(ke[267],Re([1,0,73,15,22,23,24,2,3,186,49,205,131]),function(Ee,e,S,T,D,O,k,A,m,s,I,E,u){"use strict";var C;Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,m.createDecorator)("pathService");let v=C=class{constructor(a,d,l,i){this.localUserHome=a,this.remoteAgentService=d,this.environmentService=l,this.contextService=i,this.resolveOS=(async()=>(await this.remoteAgentService.getEnvironment())?.os||O.OS)(),this.resolveUserHome=(async()=>{const n=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=n?.userHome??a})()}hasValidBasename(a,d,l){return typeof d=="string"||typeof d>"u"?this.resolveOS.then(i=>this.doHasValidBasename(a,i,d)):this.doHasValidBasename(a,d,l)}doHasValidBasename(a,d,l){return a.scheme===T.Schemas.file||a.scheme===T.Schemas.vscodeRemote?(0,S.isValidBasename)(l??(0,k.basename)(a),d===O.OperatingSystem.Windows):!0}get defaultUriScheme(){return C.findDefaultUriScheme(this.environmentService,this.contextService)}static findDefaultUriScheme(a,d){if(a.remoteAuthority)return T.Schemas.vscodeRemote;const l=(0,s.getVirtualWorkspaceScheme)(d.getWorkspace());if(l)return l;const i=d.getWorkspace().folders[0];if(i)return i.uri.scheme;const n=d.getWorkspace().configuration;return n?n.scheme:T.Schemas.file}userHome(a){return a?.preferLocal?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(a=>a===O.OperatingSystem.Windows?D.win32:D.posix)}async fileURI(a){let d="";if(await this.resolveOS===O.OperatingSystem.Windows&&(a=a.replace(/\\/g,"/")),a[0]==="/"&&a[1]==="/"){const i=a.indexOf("/",2);i===-1?(d=a.substring(2),a="/"):(d=a.substring(2,i),a=a.substring(i)||"/")}return A.URI.from({scheme:T.Schemas.file,authority:d,path:a,query:"",fragment:""})}};e.AbstractPathService=v,e.AbstractPathService=v=C=qe([We(1,u.IRemoteAgentService),We(2,E.IWorkbenchEnvironmentService),We(3,I.IWorkspaceContextService)],v)}),define(ke[58],Re([1,0]),function(Ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.ExcludeSettingOptions=e.TextSearchContextNew=e.TextSearchMatchNew=e.Range=e.Position=void 0;class S{constructor(s,I){this.line=s,this.character=I}isBefore(s){return!1}isBeforeOrEqual(s){return!1}isAfter(s){return!1}isAfterOrEqual(s){return!1}isEqual(s){return!1}compareTo(s){return 0}translate(s,I){return new S(0,0)}with(s){return new S(0,0)}}e.Position=S;class T{constructor(s,I,E,u){this.isEmpty=!1,this.isSingleLine=!1,this.start=new S(s,I),this.end=new S(E,u)}contains(s){return!1}isEqual(s){return!1}intersection(s){}union(s){return new T(0,0,0,0)}with(s){return new T(0,0,0,0)}}e.Range=T;class D{constructor(s,I,E){this.uri=s,this.ranges=I,this.previewText=E}}e.TextSearchMatchNew=D;class O{constructor(s,I,E){this.uri=s,this.text=I,this.lineNumber=E}}e.TextSearchContextNew=O;var k;(function(m){m[m.None=1]="None",m[m.FilesExclude=2]="FilesExclude",m[m.SearchAndFilesExclude=3]="SearchAndFilesExclude"})(k||(e.ExcludeSettingOptions=k={}));var A;(function(m){m[m.Information=1]="Information",m[m.Warning=2]="Warning"})(A||(e.TextSearchCompleteMessageType=A={}))}),define(ke[40],Re([1,0,17,43,25,73,13,3,22,12,58,10]),function(Ee,e,S,T,D,O,k,A,m,s,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DEFAULT_TEXT_SEARCH_PREVIEW_OPTIONS=e.QueryGlobTester=e.SerializableFileMatch=e.SearchError=e.SearchErrorCode=e.SearchSortOrder=e.ViewMode=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.QueryType=e.SearchProviderType=e.ISearchService=e.DEFAULT_MAX_SEARCH_RESULTS=e.SEARCH_EXCLUDE_CONFIG=e.SEARCH_RESULT_LANGUAGE_ID=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,e.resultIsMatch=d,e.isFileMatch=l,e.isProgressMessage=i,e.getExcludes=y,e.pathIncludedInQuery=w,e.deserializeSearchError=p,e.serializeSearchError=b,e.isSerializedSearchComplete=N,e.isSerializedSearchSuccess=L,e.isSerializedFileMatch=F,e.isFilePatternMatch=K,e.resolvePatternsForProvider=$,e.hasSiblingPromiseFn=Y,e.hasSiblingFn=ae,e.excludeToGlobPattern=oe,T=Ve(T),D=Ve(D),O=Ve(O),m=Ve(m),Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return I.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_RESULT_LANGUAGE_ID="search-result",e.SEARCH_EXCLUDE_CONFIG="search.exclude",e.DEFAULT_MAX_SEARCH_RESULTS=2e4;const u="\u27EA ",C=" characters skipped \u27EB",v=(u.length+C.length+5)*2;e.ISearchService=(0,A.createDecorator)("searchService");var r;(function(ie){ie[ie.file=0]="file",ie[ie.text=1]="text",ie[ie.aiText=2]="aiText"})(r||(e.SearchProviderType=r={}));var a;(function(ie){ie[ie.File=1]="File",ie[ie.Text=2]="Text",ie[ie.aiText=3]="aiText"})(a||(e.QueryType=a={}));function d(ie){return!!ie.rangeLocations&&!!ie.previewText}function l(ie){return!!ie.resource}function i(ie){return!!ie.message}var n;(function(ie){ie[ie.Normal=0]="Normal",ie[ie.NewSearchStarted=1]="NewSearchStarted"})(n||(e.SearchCompletionExitCode=n={}));class t{constructor(ue){this.resource=ue,this.results=[]}}e.FileMatch=t;class o{constructor(ue,Z,ve,Ie){this.rangeLocations=[],this.webviewIndex=Ie;const X=Array.isArray(Z)?Z:[Z];if(ve&&ve.matchLines===1&&c(X)){ue=(0,k.getNLines)(ue,ve.matchLines);let V="",re=0,be=0;const De=Math.floor(ve.charsPerLine/5);for(const Fe of X){const ze=Math.max(Fe.startColumn-De,0),Je=Fe.startColumn+ve.charsPerLine;if(ze>be+De+v){const nt=u+(ze-be)+C;V+=nt+ue.slice(ze,Je),re+=ze-(be+nt.length)}else V+=ue.slice(be,Je);be=Je,this.rangeLocations.push({source:Fe,preview:new f(0,Fe.startColumn-re,Fe.endColumn-re)})}this.previewText=V}else{const V=Array.isArray(Z)?Z[0].startLineNumber:Z.startLineNumber,re=(0,S.mapArrayOrNot)(Z,be=>({preview:new g(be.startLineNumber-V,be.startColumn,be.endLineNumber-V,be.endColumn),source:be}));this.rangeLocations=Array.isArray(re)?re:[re],this.previewText=ue}}}e.TextSearchMatch=o;function c(ie){const ue=ie[0].startLineNumber;for(const Z of ie)if(Z.startLineNumber!==ue||Z.endLineNumber!==ue)return!1;return!0}class g{constructor(ue,Z,ve,Ie){this.startLineNumber=ue,this.startColumn=Z,this.endLineNumber=ve,this.endColumn=Ie}}e.SearchRange=g;class f extends g{constructor(ue,Z,ve){super(ue,Z,ue,ve)}}e.OneLineRange=f;var h;(function(ie){ie.List="list",ie.Tree="tree"})(h||(e.ViewMode=h={}));var _;(function(ie){ie.Default="default",ie.FileNames="fileNames",ie.Type="type",ie.Modified="modified",ie.CountDescending="countDescending",ie.CountAscending="countAscending"})(_||(e.SearchSortOrder=_={}));function y(ie,ue=!0){const Z=ie&&ie.files&&ie.files.exclude,ve=ue&&ie&&ie.search&&ie.search.exclude;if(!Z&&!ve)return;if(!Z||!ve)return Z||ve||void 0;let Ie=Object.create(null);return Ie=D.mixin(Ie,D.deepClone(Z)),Ie=D.mixin(Ie,D.deepClone(ve),!0),Ie}function w(ie,ue){return ie.excludePattern&&T.match(ie.excludePattern,ue)?!1:ie.includePattern||ie.usingSearchPaths?ie.includePattern&&T.match(ie.includePattern,ue)?!0:ie.usingSearchPaths?!!ie.folderQueries&&ie.folderQueries.some(Z=>{const ve=Z.folder.fsPath;if(O.isEqualOrParent(ue,ve)){const Ie=m.relative(ve,ue);return!Z.includePattern||!!T.match(Z.includePattern,Ie)}else return!1}):!1:!0}var P;(function(ie){ie[ie.unknownEncoding=1]="unknownEncoding",ie[ie.regexParseError=2]="regexParseError",ie[ie.globParseError=3]="globParseError",ie[ie.invalidLiteral=4]="invalidLiteral",ie[ie.rgProcessError=5]="rgProcessError",ie[ie.other=6]="other",ie[ie.canceled=7]="canceled"})(P||(e.SearchErrorCode=P={}));class R extends Error{constructor(ue,Z){super(ue),this.code=Z}}e.SearchError=R;function p(ie){const ue=ie.message;if((0,s.isCancellationError)(ie))return new R(ue,P.canceled);try{const Z=JSON.parse(ue);return new R(Z.message,Z.code)}catch{return new R(ue,P.other)}}function b(ie){const ue={message:ie.message,code:ie.code};return new Error(JSON.stringify(ue))}function N(ie){return ie.type==="error"?!0:ie.type==="success"}function L(ie){return ie.type==="success"}function F(ie){return!!ie.path}function K(ie,ue,Z=!0){const ve=ie.searchPath?ie.searchPath:ie.relativePath;return Z?(0,k.fuzzyContains)(ve,ue):T.match(ue,ve)}class J{constructor(ue){this.path=ue,this.results=[]}addMatch(ue){this.results.push(ue)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=J;function $(ie,ue){const Z={...ie||{},...ue||{}};return Object.keys(Z).filter(ve=>{const Ie=Z[ve];return typeof Ie=="boolean"&&Ie})}class x{constructor(ue,Z){this._parsedIncludeExpression=null,this._excludeExpression=Z.excludePattern?.map(Ie=>({...ue.excludePattern||{},...Ie.pattern||{}}))??[],this._excludeExpression.length===0&&(this._excludeExpression=[ue.excludePattern||{}]),this._parsedExcludeExpression=this._excludeExpression.map(Ie=>T.parse(Ie));let ve=ue.includePattern;Z.includePattern&&(ve?ve={...ve,...Z.includePattern}:ve=Z.includePattern),ve&&(this._parsedIncludeExpression=T.parse(ve))}_evalParsedExcludeExpression(ue,Z,ve){let Ie=null;for(const X of this._parsedExcludeExpression){const V=X(ue,Z,ve);if(typeof V=="string"){Ie=V;break}}return Ie}matchesExcludesSync(ue,Z,ve){return!!(this._parsedExcludeExpression&&this._evalParsedExcludeExpression(ue,Z,ve))}includedInQuerySync(ue,Z,ve){return!(this._parsedExcludeExpression&&this._evalParsedExcludeExpression(ue,Z,ve)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(ue,Z,ve))}includedInQuery(ue,Z,ve){const Ie=()=>this._parsedIncludeExpression?!!this._parsedIncludeExpression(ue,Z,ve):!0;return Promise.all(this._parsedExcludeExpression.map(X=>{const V=X(ue,Z,ve);return(0,E.isThenable)(V)?V.then(re=>re?!1:Ie()):Ie()})).then(X=>X.some(V=>!!V))}hasSiblingExcludeClauses(){return this._excludeExpression.reduce((ue,Z)=>G(Z)||ue,!1)}}e.QueryGlobTester=x;function G(ie){for(const ue in ie)if(typeof ie[ue]!="boolean")return!0;return!1}function Y(ie){if(!ie)return;let ue;return Z=>(ue||(ue=(ie()||Promise.resolve([])).then(ve=>ve?ee(ve):{})),ue.then(ve=>!!ve[Z]))}function ae(ie){if(!ie)return;let ue;return Z=>{if(!ue){const ve=ie();ue=ve?ee(ve):{}}return!!ue[Z]}}function ee(ie){const ue={};for(const Z of ie)ue[Z]=!0;return ue}function oe(ie){return ie.flatMap(ue=>ue.patterns.map(Z=>ue.baseUri?{baseUri:ue.baseUri,pattern:Z}:Z))}e.DEFAULT_TEXT_SEARCH_PREVIEW_OPTIONS={matchLines:100,charsPerLine:1e4}}),define(ke[45],Re([1,0,17,10,19,6,4,48,15,142,24,13,2,9,28,3,11,174,49,50,26,16,8,7,65,40,5,34,58]),function(Ee,e,S,T,D,O,k,A,m,s,I,E,u,C,v,r,a,d,l,i,n,t,o,c,g,f,h,_,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function w(J,$,x){return new I.ExtUri(G=>b(G,x)).isEqual(J,$)}function P(J,$,x){return w(J.uri,$.uri,x)?0:(0,E.compare)(J.uri.toString(),$.uri.toString())}function R(J,$,x){return J.index!==$.index?J.index<$.index?-1:1:w(J.uri,$.uri,x)?(0,E.compare)(J.name,$.name):(0,E.compare)(J.uri.toString(),$.uri.toString())}function p(J,$,x,G){const Y=J.slice(0).sort((ee,oe)=>x(ee,oe,G)),ae=$.slice(0).sort((ee,oe)=>x(ee,oe,G));return(0,S.delta)(Y,ae,(ee,oe)=>x(ee,oe,G))}function b(J,$){const x=$.getCapabilities(J.scheme);return!(x&&x&v.FileSystemProviderCapabilities.PathCaseSensitive)}class N extends l.Workspace{static toExtHostWorkspace($,x,G,Y){if(!$)return{workspace:null,added:[],removed:[]};const{id:ae,name:ee,folders:oe,configuration:ie,transient:ue,isUntitled:Z}=$,ve=[],Ie=x;x?oe.forEach((be,De)=>{const Fe=u.URI.revive(be.uri),ze=N._findFolder(G||x,Fe,Y);ze?(ze.name=be.name,ze.index=be.index,ve.push(ze)):ve.push({uri:Fe,name:be.name,index:De})}):ve.push(...oe.map(({uri:be,name:De,index:Fe})=>({uri:u.URI.revive(be),name:De,index:Fe}))),ve.sort((be,De)=>be.index<De.index?-1:1);const X=new N(ae,ee,ve,!!ue,ie?u.URI.revive(ie):null,!!Z,be=>b(be,Y)),{added:V,removed:re}=p(Ie?Ie.workspaceFolders:[],X.workspaceFolders,P,Y);return{workspace:X,added:V,removed:re}}static _findFolder($,x,G){for(let Y=0;Y<$.folders.length;Y++){const ae=$.workspaceFolders[Y];if(w(ae.uri,x,G))return ae}}constructor($,x,G,Y,ae,ee,oe){super($,G.map(ie=>new l.WorkspaceFolder(ie)),Y,ae,oe),this._name=x,this._isUntitled=ee,this._workspaceFolders=[],this._structure=A.TernarySearchTree.forUris(oe,()=>!0),G.forEach(ie=>{this._workspaceFolders.push(ie),this._structure.set(ie.uri,ie)})}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder($,x){return x&&this._structure.get($)&&($=(0,I.dirname)($)),this._structure.findSubstr($)}resolveWorkspaceFolder($){return this._structure.get($)}}let L=class{constructor($,x,G,Y,ae){this._onDidChangeWorkspace=new O.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new O.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._editSessionIdentityProviders=new Map,this._providerHandlePool=0,this._onWillCreateEditSessionIdentityEvent=new O.AsyncEmitter,this._canonicalUriProviders=new Map,this._logService=Y,this._extHostFileSystemInfo=G,this._uriTransformerService=ae,this._requestIdProvider=new s.Counter,this._barrier=new T.Barrier,this._proxy=$.getProxy(h.MainContext.MainThreadWorkspace),this._messageService=$.getProxy(h.MainContext.MainThreadMessageService);const ee=x.workspace;this._confirmedWorkspace=ee?new N(ee.id,ee.name,[],!!ee.transient,ee.configuration?u.URI.revive(ee.configuration):null,!!ee.isUntitled,oe=>b(oe,G)):void 0}$initializeWorkspace($,x){this._trusted=x,this.$acceptWorkspaceData($),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?u.URI.from({scheme:m.Schemas.untitled,path:(0,I.basename)((0,I.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders($,x,G,...Y){const ae=[];if(Array.isArray(Y)&&Y.forEach(Z=>{u.URI.isUri(Z.uri)&&!ae.some(ve=>w(ve.uri,Z.uri,this._extHostFileSystemInfo))&&ae.push({uri:Z.uri,name:Z.name||(0,I.basenameOrAuthority)(Z.uri)})}),this._unconfirmedWorkspace||[x,G].some(Z=>typeof Z!="number"||Z<0)||G===0&&ae.length===0)return!1;const ee=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(x+G>ee.length)return!1;const oe=ee.slice(0);oe.splice(x,G,...ae.map(Z=>({uri:Z.uri,name:Z.name||(0,I.basenameOrAuthority)(Z.uri),index:void 0})));for(let Z=0;Z<oe.length;Z++){const ve=oe[Z];if(oe.some((Ie,X)=>X!==Z&&w(ve.uri,Ie.uri,this._extHostFileSystemInfo)))return!1}oe.forEach((Z,ve)=>Z.index=ve);const{added:ie,removed:ue}=p(ee,oe,R,this._extHostFileSystemInfo);if(ie.length===0&&ue.length===0)return!1;if(this._proxy){const Z=$.displayName||$.name;this._proxy.$updateWorkspaceFolders(Z,x,G,ae).then(void 0,ve=>{this._unconfirmedWorkspace=void 0;const Ie={source:{identifier:$.identifier,label:$.displayName||$.name}};this._messageService.$showMessage(d.Severity.Error,(0,C.localize)(2718,null,Z,ve.toString()),Ie,[])})}return this.trySetWorkspaceFolders(oe),!0}getWorkspaceFolder($,x){if(this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder($,x)}async getWorkspaceFolder2($,x){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder($,x)}async resolveWorkspaceFolder($){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder($)}getPath(){if(!this._actualWorkspace)return;const{folders:$}=this._actualWorkspace;if($.length!==0)return $[0].uri.fsPath}getRelativePath($,x){let G,Y="";if(typeof $=="string"?(G=u.URI.file($),Y=$):typeof $<"u"&&(G=$,Y=$.fsPath),!G)return Y;const ae=this.getWorkspaceFolder(G,!0);if(!ae)return Y;typeof x>"u"&&this._actualWorkspace&&(x=this._actualWorkspace.folders.length>1);let ee=(0,I.relativePath)(ae.uri,G);return x&&ae.name&&(ee=`${ae.name}/${ee}`),ee}trySetWorkspaceFolders($){this._actualWorkspace&&(this._unconfirmedWorkspace=N.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:$,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData($){const{workspace:x,added:G,removed:Y}=N.toExtHostWorkspace($,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=x||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:G,removed:Y}))}findFiles($,x,G,Y,ae=D.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${Y.value}, entryPoint: findFiles`);let ee="",oe=!0;return x===null?oe=!1:x!==void 0&&(typeof x=="string"?ee=x:ee=x.pattern),this._findFilesImpl($,void 0,{exclude:[ee],maxResults:G,useExcludeSettings:oe?y.ExcludeSettingOptions.FilesExclude:y.ExcludeSettingOptions.None,useIgnoreFiles:{local:!1}},ae)}findFiles2($,x={},G,Y=D.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles2: fileSearch, extension: ${G.value}, entryPoint: findFiles2`);const ae=x.useDefaultExcludes??!0,ee=x.useDefaultSearchExcludes??!0,oe=ae?ee?y.ExcludeSettingOptions.SearchAndFilesExclude:y.ExcludeSettingOptions.FilesExclude:y.ExcludeSettingOptions.None,ie={exclude:x.exclude?[x.exclude]:void 0,useIgnoreFiles:{local:x.useIgnoreFiles,global:x.useGlobalIgnoreFiles,parent:x.useParentIgnoreFiles},useExcludeSettings:oe,followSymlinks:x.followSymlinks,maxResults:x.maxResults};return this._findFilesImpl(void 0,$!==void 0?[$]:[],ie,Y)}findFiles2New($,x={},G,Y=D.CancellationToken.None){return this._logService.trace(`extHostWorkspace#findFiles2New: fileSearch, extension: ${G.value}, entryPoint: findFiles2New`),this._findFilesImpl(void 0,$,x,Y)}async _findFilesImpl($,x,G,Y=D.CancellationToken.None){if(Y&&Y.isCancellationRequested)return Promise.resolve([]);const ee=($!==void 0?[$]:x)?.map(oe=>{const ie=K(G.exclude),ue={ignoreSymlinks:typeof G.followSymlinks=="boolean"?!G.followSymlinks:void 0,disregardIgnoreFiles:typeof G.useIgnoreFiles?.local=="boolean"?!G.useIgnoreFiles.local:void 0,disregardGlobalIgnoreFiles:typeof G.useIgnoreFiles?.global=="boolean"?!G.useIgnoreFiles.global:void 0,disregardParentIgnoreFiles:typeof G.useIgnoreFiles?.parent=="boolean"?!G.useIgnoreFiles.parent:void 0,disregardExcludeSettings:G.useExcludeSettings!==void 0&&G.useExcludeSettings===y.ExcludeSettingOptions.None,disregardSearchExcludeSettings:G.useExcludeSettings!==void 0&&G.useExcludeSettings!==y.ExcludeSettingOptions.SearchAndFilesExclude,maxResults:G.maxResults,excludePattern:ie.length>0?ie:void 0,_reason:"startFileSearch",shouldGlobSearch:$?void 0:!0},Z=F(o.GlobPattern.from(oe)),ve=Z?.folder;return $?ue.includePattern=Z?.pattern:ue.filePattern=Z?.pattern,{folder:ve,options:ue}})??[];return this._findFilesBase(ee,Y)}async _findFilesBase($,x){return(await Promise.all($?.map(Y=>this._proxy.$startFileSearch(Y.folder??null,Y.options,x).then(ae=>Array.isArray(ae)?ae.map(ee=>u.URI.revive(ee)):[]))??[])).flat()}findTextInFilesNew($,x,G,Y){this._logService.trace(`extHostWorkspace#findTextInFilesNew: textSearch, extension: ${x.value}, entryPoint: findTextInFilesNew`);const ae=Z=>{if(!G)return{folder:void 0,options:{}};const ve=Z?F(o.GlobPattern.from(Z)):void 0,Ie=K(G.exclude);return{options:{ignoreSymlinks:typeof G.followSymlinks=="boolean"?!G.followSymlinks:void 0,disregardIgnoreFiles:typeof G.useIgnoreFiles=="boolean"?!G.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof G.useIgnoreFiles?.global=="boolean"?!G.useIgnoreFiles?.global:void 0,disregardParentIgnoreFiles:typeof G.useIgnoreFiles?.parent=="boolean"?!G.useIgnoreFiles?.parent:void 0,disregardExcludeSettings:G.useExcludeSettings!==void 0&&G.useExcludeSettings===y.ExcludeSettingOptions.None,disregardSearchExcludeSettings:G.useExcludeSettings!==void 0&&G.useExcludeSettings!==y.ExcludeSettingOptions.SearchAndFilesExclude,fileEncoding:G.encoding,maxResults:G.maxResults,previewOptions:G.previewOptions?{matchLines:G.previewOptions?.numMatchLines??100,charsPerLine:G.previewOptions?.charsPerLine??1e4}:void 0,surroundingContext:G.surroundingContext,includePattern:ve?.pattern,excludePattern:Ie},folder:ve?.folder}},oe=(G?.include?.map(Z=>ae(Z))??[ae(void 0)]).filter(Z=>!!Z),ie=Promise.resolve(void 0);return{results:new T.AsyncIterableObject(async Z=>{const ve=(Ie,X)=>((0,f.resultIsMatch)(Ie)?Z.emitOne(new y.TextSearchMatchNew(X,Ie.rangeLocations.map(V=>({previewRange:new c.Range(V.preview.startLineNumber,V.preview.startColumn,V.preview.endLineNumber,V.preview.endColumn),sourceRange:new c.Range(V.source.startLineNumber,V.source.startColumn,V.source.endLineNumber,V.source.endColumn)})),Ie.previewText)):Z.emitOne(new y.TextSearchContextNew(X,Ie.text,Ie.lineNumber)),Ie);await ie.then(Ie=>this.findTextInFilesBase($,oe,ve,Y))}),complete:ie.then(Z=>({limitHit:Z?.limitHit??!1}))}}async findTextInFilesBase($,x,G,Y=D.CancellationToken.None){const ae=this._requestIdProvider.getNext();let ee=!1;if(Y.onCancellationRequested(oe=>{ee=!0}),this._activeSearchCallbacks[ae]=oe=>{if(ee)return;const ie=u.URI.revive(oe.resource);oe.results.forEach(ue=>{const Z=(0,_.revive)(ue);G(Z,ie)})},Y.isCancellationRequested)return{};try{const oe=await Promise.all(x?.map(ie=>this._proxy.$startTextSearch($,ie.folder??null,ie.options,ae,Y)||{})??[]);return delete this._activeSearchCallbacks[ae],oe.reduce((ie,ue)=>({limitHit:ie?.limitHit||(ue?.limitHit??!1),message:[ie?.message??[],ue?.message??[]].flat()}),{})??{limitHit:!1}}catch(oe){throw delete this._activeSearchCallbacks[ae],oe}}async findTextInFiles($,x,G,Y,ae=D.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${Y.value}, entryPoint: findTextInFiles`);const ee=typeof x.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:x.previewOptions,oe=F(o.GlobPattern.from(x.include)),ie=typeof x.exclude=="string"?x.exclude:x.exclude?x.exclude.pattern:void 0,ue={ignoreSymlinks:typeof x.followSymlinks=="boolean"?!x.followSymlinks:void 0,disregardIgnoreFiles:typeof x.useIgnoreFiles=="boolean"?!x.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof x.useGlobalIgnoreFiles=="boolean"?!x.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof x.useParentIgnoreFiles=="boolean"?!x.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof x.useDefaultExcludes=="boolean"?!x.useDefaultExcludes:!0,disregardSearchExcludeSettings:typeof x.useSearchExclude=="boolean"?!x.useSearchExclude:!0,fileEncoding:x.encoding,maxResults:x.maxResults,previewOptions:ee,surroundingContext:x.afterContext,includePattern:oe?.pattern,excludePattern:ie?[{pattern:ie}]:void 0},Z=(ve,Ie)=>{(0,f.resultIsMatch)(ve)?G({uri:Ie,preview:{text:ve.previewText,matches:(0,S.mapArrayOrNot)(ve.rangeLocations,X=>new c.Range(X.preview.startLineNumber,X.preview.startColumn,X.preview.endLineNumber,X.preview.endColumn))},ranges:(0,S.mapArrayOrNot)(ve.rangeLocations,X=>new c.Range(X.source.startLineNumber,X.source.startColumn,X.source.endLineNumber,X.source.endColumn))}):G({uri:Ie,text:ve.text,lineNumber:ve.lineNumber})};return this.findTextInFilesBase($,[{options:ue,folder:oe?.folder}],Z,ae)}$handleTextSearchResult($,x){this._activeSearchCallbacks[x]?.($)}async save($){const x=await this._proxy.$save($,{saveAs:!1});return u.URI.revive(x)}async saveAs($){const x=await this._proxy.$save($,{saveAs:!0});return u.URI.revive(x)}saveAll($){return this._proxy.$saveAll($)}resolveProxy($){return this._proxy.$resolveProxy($)}lookupAuthorization($){return this._proxy.$lookupAuthorization($)}lookupKerberosAuthorization($){return this._proxy.$lookupKerberosAuthorization($)}loadCertificates(){return this._proxy.$loadCertificates()}get trusted(){return this._trusted}requestWorkspaceTrust($){return this._proxy.$requestWorkspaceTrust($)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}registerEditSessionIdentityProvider($,x){if(this._editSessionIdentityProviders.has($))throw new Error(`A provider has already been registered for scheme ${$}`);this._editSessionIdentityProviders.set($,x);const G=this._uriTransformerService.transformOutgoingScheme($),Y=this._providerHandlePool++;return this._proxy.$registerEditSessionIdentityProvider(Y,G),(0,k.toDisposable)(()=>{this._editSessionIdentityProviders.delete($),this._proxy.$unregisterEditSessionIdentityProvider(Y)})}async $getEditSessionIdentifier($,x){this._logService.info("Getting edit session identifier for workspaceFolder",$);const G=await this.resolveWorkspaceFolder(u.URI.revive($));if(!G){this._logService.warn("Unable to resolve workspace folder");return}this._logService.info("Invoking #provideEditSessionIdentity for workspaceFolder",G);const Y=this._editSessionIdentityProviders.get(G.uri.scheme);if(this._logService.info(`Provider for scheme ${G.uri.scheme} is defined: `,!!Y),!Y)return;const ae=await Y.provideEditSessionIdentity(G,x);if(this._logService.info("Provider returned edit session identifier: ",ae),!!ae)return ae}async $provideEditSessionIdentityMatch($,x,G,Y){this._logService.info("Getting edit session identifier for workspaceFolder",$);const ae=await this.resolveWorkspaceFolder(u.URI.revive($));if(!ae){this._logService.warn("Unable to resolve workspace folder");return}this._logService.info("Invoking #provideEditSessionIdentity for workspaceFolder",ae);const ee=this._editSessionIdentityProviders.get(ae.uri.scheme);if(this._logService.info(`Provider for scheme ${ae.uri.scheme} is defined: `,!!ee),!ee)return;const oe=await ee.provideEditSessionIdentityMatch?.(x,G,Y);if(this._logService.info("Provider returned edit session identifier match result: ",oe),!!oe)return oe}getOnWillCreateEditSessionIdentityEvent($){return(x,G,Y)=>{const ae=function(oe){x.call(G,oe)};return ae.extension=$,this._onWillCreateEditSessionIdentityEvent.event(ae,void 0,Y)}}async $onWillCreateEditSessionIdentity($,x,G){const Y=await this.resolveWorkspaceFolder(u.URI.revive($));if(Y===void 0)throw new Error("Unable to resolve workspace folder");await this._onWillCreateEditSessionIdentityEvent.fireAsync({workspaceFolder:Y},x,async(ae,ee)=>{const oe=Date.now();await Promise.resolve(ae),Date.now()-oe>G&&this._logService.warn("SLOW edit session create-participant",ee.extension.identifier)}),x.isCancellationRequested}registerCanonicalUriProvider($,x){if(this._canonicalUriProviders.has($))throw new Error(`A provider has already been registered for scheme ${$}`);this._canonicalUriProviders.set($,x);const G=this._uriTransformerService.transformOutgoingScheme($),Y=this._providerHandlePool++;return this._proxy.$registerCanonicalUriProvider(Y,G),(0,k.toDisposable)(()=>{this._canonicalUriProviders.delete($),this._proxy.$unregisterCanonicalUriProvider(Y)})}async provideCanonicalUri($,x,G){const Y=this._canonicalUriProviders.get($.scheme);if(!Y)return;const ae=await Y.provideCanonicalUri?.(u.URI.revive($),x,G);if(ae)return ae}async $provideCanonicalUri($,x,G){return this.provideCanonicalUri(u.URI.revive($),{targetScheme:x},G)}};e.ExtHostWorkspace=L,e.ExtHostWorkspace=L=qe([We(0,t.IExtHostRpcService),We(1,n.IExtHostInitDataService),We(2,i.IExtHostFileSystemInfo),We(3,a.ILogService),We(4,g.IURITransformerService)],L),e.IExtHostWorkspace=(0,r.createDecorator)("IExtHostWorkspace");function F(J){let $,x;if(J)return typeof J=="string"?$=J:($=J.pattern,x=u.URI.revive(J.baseUri)),{pattern:$,folder:x}}function K(J){return(J?.map($=>{if(typeof $=="string")return $===""?void 0:{pattern:$,uri:void 0};{const x=F($);return x?{pattern:x.pattern,uri:x.folder}:void 0}})??[]).filter($=>!!$)}}),define(ke[46],Re([1,0,25,6,45,5,7,44,175,53,14,10,3,16,11,2]),function(Ee,e,S,T,D,O,k,A,m,s,I,E,u,C,v,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function a(g,f){if(f){const h=f.split(".");let _=g;for(let y=0;_&&y<h.length;y++)_=_[h[y]];return _}}function d(g){return g instanceof r.URI}function l(g){return g&&g.uri instanceof r.URI&&g.languageId&&typeof g.languageId=="string"}function i(g){return g&&!g.uri&&g.languageId&&typeof g.languageId=="string"}function n(g){return g&&g.uri instanceof r.URI&&(!g.name||typeof g.name=="string")&&(!g.index||typeof g.index=="number")}function t(g){if(d(g))return{resource:g};if(l(g))return{resource:g.uri,overrideIdentifier:g.languageId};if(i(g))return{overrideIdentifier:g.languageId};if(n(g))return{resource:g.uri};if(g===null)return{resource:null}}let o=class{constructor(f,h,_){this._proxy=f.getProxy(O.MainContext.MainThreadConfiguration),this._extHostWorkspace=h,this._logService=_,this._barrier=new E.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(f=>this._actual)}$initializeConfiguration(f){this._actual=new c(this._proxy,this._extHostWorkspace,f,this._logService),this._barrier.open()}$acceptConfigurationChanged(f,h){this.getConfigProvider().then(_=>_.$acceptConfigurationChanged(f,h))}};e.ExtHostConfiguration=o,e.ExtHostConfiguration=o=qe([We(0,C.IExtHostRpcService),We(1,D.IExtHostWorkspace),We(2,v.ILogService)],o);class c{constructor(f,h,_,y){this._onDidChangeConfiguration=new T.Emitter,this._proxy=f,this._logService=y,this._extHostWorkspace=h,this._configuration=m.Configuration.parse(_,y),this._configurationScopes=this._toMap(_.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(f,h){const _={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=m.Configuration.parse(f,this._logService),this._configurationScopes=this._toMap(f.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(h,_))}getConfiguration(f,h,_){const y=t(h)||{},w=this._toReadonlyValue(f?a(this._configuration.getValue(void 0,y,this._extHostWorkspace.workspace),f):this._configuration.getValue(void 0,y,this._extHostWorkspace.workspace));f&&this._validateConfigurationAccess(f,y,_?.identifier);function P(p){if(p==null)return null;if(typeof p=="boolean")return p?A.ConfigurationTarget.USER:A.ConfigurationTarget.WORKSPACE;switch(p){case k.ConfigurationTarget.Global:return A.ConfigurationTarget.USER;case k.ConfigurationTarget.Workspace:return A.ConfigurationTarget.WORKSPACE;case k.ConfigurationTarget.WorkspaceFolder:return A.ConfigurationTarget.WORKSPACE_FOLDER}}const R={has(p){return typeof a(w,p)<"u"},get:(p,b)=>{this._validateConfigurationAccess(f?`${f}.${p}`:p,y,_?.identifier);let N=a(w,p);if(typeof N>"u")N=b;else{let L;const F=(K,J)=>{if((0,I.isObject)(K)){let $;const x=()=>{L=L||(0,S.deepClone)(w),$=$||a(L,J)};return new Proxy(K,{get:(G,Y)=>{if(typeof Y=="string"&&Y.toLowerCase()==="tojson")return x(),()=>$;if(L)return $=$||a(L,J),$[Y];const ae=G[Y];return typeof Y=="string"?F(ae,`${J}.${Y}`):ae},set:(G,Y,ae)=>(x(),$&&($[Y]=ae),!0),deleteProperty:(G,Y)=>(x(),$&&delete $[Y],!0),defineProperty:(G,Y,ae)=>(x(),$&&Object.defineProperty($,Y,ae),!0)})}return Array.isArray(K)?(0,S.deepClone)(K):K};N=F(N,p)}return N},update:(p,b,N,L)=>{p=f?`${f}.${p}`:p;const F=P(N);return b!==void 0?this._proxy.$updateConfigurationOption(F,p,b,y,L):this._proxy.$removeConfigurationOption(F,p,y,L)},inspect:p=>{p=f?`${f}.${p}`:p;const b=this._configuration.inspect(p,y,this._extHostWorkspace.workspace);if(b)return{key:p,defaultValue:(0,S.deepClone)(b.policy?.value??b.default?.value),globalValue:(0,S.deepClone)(b.user?.value??b.application?.value),workspaceValue:(0,S.deepClone)(b.workspace?.value),workspaceFolderValue:(0,S.deepClone)(b.workspaceFolder?.value),defaultLanguageValue:(0,S.deepClone)(b.default?.override),globalLanguageValue:(0,S.deepClone)(b.user?.override??b.application?.override),workspaceLanguageValue:(0,S.deepClone)(b.workspace?.override),workspaceFolderLanguageValue:(0,S.deepClone)(b.workspaceFolder?.override),languageIds:(0,S.deepClone)(b.overrideIdentifiers)}}};return typeof w=="object"&&(0,S.mixin)(R,w,!1),Object.freeze(R)}_toReadonlyValue(f){const h=_=>(0,I.isObject)(_)?new Proxy(_,{get:(y,w)=>h(y[w]),set:(y,w,P)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(w)}' of object`)},deleteProperty:(y,w)=>{throw new Error(`TypeError: Cannot delete read only property '${String(w)}' of object`)},defineProperty:(y,w)=>{throw new Error(`TypeError: Cannot define property '${String(w)}' for a readonly object`)},setPrototypeOf:y=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):_;return h(f)}_validateConfigurationAccess(f,h,_){const y=s.OVERRIDE_PROPERTY_REGEX.test(f)?s.ConfigurationScope.RESOURCE:this._configurationScopes.get(f),w=_?`[${_.value}] `:"";if(s.ConfigurationScope.RESOURCE===y){typeof h?.resource>"u"&&this._logService.warn(`${w}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${f}', provide the URI of a resource or 'null' for any resource.`);return}if(s.ConfigurationScope.WINDOW===y){h?.resource&&this._logService.warn(`${w}Accessing a window scoped configuration for a resource is not expected. To associate '${f}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(f,h){const _=new m.ConfigurationChangeEvent(f,h,this._configuration,this._extHostWorkspace.workspace,this._logService);return Object.freeze({affectsConfiguration:(y,w)=>_.affectsConfiguration(y,t(w))})}_toMap(f){return f.reduce((h,_)=>(h.set(_[0],_[1]),h),new Map)}}e.ExtHostConfigProvider=c,e.IExtHostConfiguration=(0,u.createDecorator)("IExtHostConfiguration")}),define(ke[132],Re([1,0,2,10,6,5,7,45,57,46,19,56,16,26,3,15,23,11,85,209,12,17]),function(Ee,e,S,T,D,O,k,A,m,s,I,E,u,C,v,r,a,d,l,i,n,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0,k=Ve(k),a=Ve(a);var o;(function(F){function K($){if($!=null)return $}F.from=K;function J($){if($!=null)return $}F.to=J})(o||(o={}));var c;(function(F){function K($){if($!=null)return $}F.from=K;function J($){if($!=null)return $}F.to=J})(c||(c={}));var g;(function(F){function K($){if($!=null)return $}F.from=K;function J($){if($!=null)return $}F.to=J})(g||(g={}));var f;(function(F){function K(x){if(x){const G=x;return G&&!!G.process}else return!1}F.is=K;function J(x){if(x==null)return;const G={process:x.process,args:x.args};return x.options&&(G.options=g.from(x.options)),G}F.from=J;function $(x){if(x!=null)return new k.ProcessExecution(x.process,x.args,x.options)}F.to=$})(f||(f={}));var h;(function(F){function K($){if($!=null)return $}F.from=K;function J($){if($!=null)return $}F.to=J})(h||(h={}));var _;(function(F){function K(x){if(x){const G=x;return G&&(!!G.commandLine||!!G.command)}else return!1}F.is=K;function J(x){if(x==null)return;const G={};return x.commandLine!==void 0?G.commandLine=x.commandLine:(G.command=x.command,G.args=x.args),x.options&&(G.options=h.from(x.options)),G}F.from=J;function $(x){if(!(x==null||x.command===void 0&&x.commandLine===void 0))return x.commandLine?new k.ShellExecution(x.commandLine,x.options):new k.ShellExecution(x.command,x.args?x.args:[],x.options)}F.to=$})(_||(_={}));var y;(function(F){function K(x){if(x){const G=x;return G&&G.customExecution==="customExecution"}else return!1}F.is=K;function J(x){return{customExecution:"customExecution"}}F.from=J;function $(x,G){return G.get(x)}F.to=$})(y||(e.CustomExecutionDTO=y={}));var w;(function(F){function K(J,$){let x;return J.scope!==void 0&&typeof J.scope!="number"?x=J.scope.uri:J.scope!==void 0&&typeof J.scope=="number"&&(J.scope===k.TaskScope.Workspace&&$&&$.workspaceFile?x=$.workspaceFile:x=i.USER_TASKS_GROUP_KEY),{id:J._id,workspaceFolder:x}}F.from=K})(w||(e.TaskHandleDTO=w={}));var P;(function(F){function K(J){if(J!=null)return{_id:J.id,isDefault:J.isDefault}}F.from=K})(P||(P={}));var R;(function(F){function K(x,G){if(x==null)return[];const Y=[];for(const ae of x){const ee=J(ae,G);ee&&Y.push(ee)}return Y}F.fromMany=K;function J(x,G){if(x==null)return;let Y;x.execution instanceof k.ProcessExecution?Y=f.from(x.execution):x.execution instanceof k.ShellExecution?Y=_.from(x.execution):x.execution&&x.execution instanceof k.CustomExecution&&(Y=y.from(x.execution));const ae=o.from(x.definition);let ee;return x.scope?typeof x.scope=="number"?ee=x.scope:ee=x.scope.uri:ee=k.TaskScope.Workspace,!ae||!ee?void 0:{_id:x._id,definition:ae,name:x.name,source:{extensionId:G.identifier.value,label:x.source,scope:ee},execution:Y,isBackground:x.isBackground,group:P.from(x.group),presentationOptions:c.from(x.presentationOptions),problemMatchers:(0,t.asArray)(x.problemMatchers),hasDefinedMatchers:x.hasDefinedMatchers,runOptions:x.runOptions?x.runOptions:{reevaluateOnRerun:!0},detail:x.detail}}F.from=J;async function $(x,G,Y){if(x==null)return;let ae;f.is(x.execution)?ae=f.to(x.execution):_.is(x.execution)?ae=_.to(x.execution):y.is(x.execution)&&(ae=y.to(x._id,Y));const ee=o.to(x.definition);let oe;if(x.source&&(x.source.scope!==void 0?typeof x.source.scope=="number"?oe=x.source.scope:oe=await G.resolveWorkspaceFolder(S.URI.revive(x.source.scope)):oe=k.TaskScope.Workspace),!ee||!oe)return;const ie=new k.Task(ee,oe,x.name,x.source.label,ae,x.problemMatchers);return x.isBackground!==void 0&&(ie.isBackground=x.isBackground),x.group!==void 0&&(ie.group=k.TaskGroup.from(x.group._id),ie.group&&x.group.isDefault&&(ie.group=new k.TaskGroup(ie.group.id,ie.group.label),x.group.isDefault===!0&&(ie.group.isDefault=x.group.isDefault))),x.presentationOptions&&(ie.presentationOptions=c.to(x.presentationOptions)),x._id&&(ie._id=x._id),x.detail&&(ie.detail=x.detail),ie}F.to=$})(R||(e.TaskDTO=R={}));var p;(function(F){function K($){return $}F.from=K;function J($){if($)return Object.assign(Object.create(null),$)}F.to=J})(p||(p={}));class b{#e;constructor(K,J,$){this._id=J,this._task=$,this.#e=K}get task(){return this._task}terminate(){this.#e.terminateTask(this)}fireDidStartProcess(K){}fireDidEndProcess(K){}}let N=class{constructor(K,J,$,x,G,Y,ae,ee){this._onDidExecuteTask=new D.Emitter,this._onDidTerminateTask=new D.Emitter,this._onDidTaskProcessStarted=new D.Emitter,this._onDidTaskProcessEnded=new D.Emitter,this._proxy=K.getProxy(O.MainContext.MainThreadTask),this._workspaceProvider=$,this._editorService=x,this._configurationService=G,this._terminalService=Y,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=ae,this._deprecationService=ee,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(K,J,$){if(!$)return new k.Disposable(()=>{});const x=this.nextHandle();return this._handlers.set(x,{type:J,provider:$,extension:K}),this._proxy.$registerTaskProvider(x,J),new k.Disposable(()=>{this._handlers.delete(x),this._proxy.$unregisterTaskProvider(x)})}registerTaskSystem(K,J){this._proxy.$registerTaskSystem(K,J)}fetchTasks(K){return this._proxy.$fetchTasks(p.from(K)).then(async J=>{const $=[];for(const x of J){const G=await R.to(x,this._workspaceProvider,this._providedCustomExecutions2);G&&$.push(G)}return $})}get taskExecutions(){const K=[];return this._taskExecutions.forEach(J=>K.push(J)),K}terminateTask(K){if(!(K instanceof b))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(K._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(K,J,$){const x=this._providedCustomExecutions2.get(K.id);x&&(this._activeCustomExecutions2.set(K.id,x),this._terminalService.attachPtyToTerminal(J,await x.callback($))),this._lastStartedTask=K.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(K)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(K){if(!this._taskExecutionPromises.has(K.id))return;const J=await this.getTaskExecution(K);this._taskExecutionPromises.delete(K.id),this._taskExecutions.delete(K.id),this.customExecutionComplete(K),this._onDidTerminateTask.fire({execution:J})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(K){const J=await this.getTaskExecution(K.id);this._onDidTaskProcessStarted.fire({execution:J,processId:K.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(K){const J=await this.getTaskExecution(K.id);this._onDidTaskProcessEnded.fire({execution:J,exitCode:K.exitCode})}$provideTasks(K,J){const $=this._handlers.get(K);if(!$)return Promise.reject(new Error("no handler found"));const x=[],G=(0,T.asPromise)(()=>$.provider.provideTasks(I.CancellationToken.None)).then(Y=>this.provideTasksInternal(J,x,$,Y));return new Promise(Y=>{G.then(ae=>{Promise.all(x).then(()=>{Y(ae)})})})}async $resolveTask(K,J){const $=this._handlers.get(K);if(!$)return Promise.reject(new Error("no handler found"));if(J.definition.type!==$.type)throw new Error(`Unexpected: Task of type [${J.definition.type}] cannot be resolved by provider of type [${$.type}].`);const x=await R.to(J,this._workspaceProvider,this._providedCustomExecutions2);if(!x)throw new Error("Unexpected: Task cannot be resolved.");const G=await $.provider.resolveTask(x,I.CancellationToken.None);if(!G)return;this.checkDeprecation(G,$);const Y=R.from(G,$.extension);if(!Y)throw new Error("Unexpected: Task cannot be resolved.");if(G.definition!==x.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return y.is(Y.execution)&&await this.addCustomExecution(Y,G,!0),await this.resolveTaskInternal(Y)}nextHandle(){return this._handleCounter++}async addCustomExecution(K,J,$){const x=await this._proxy.$createTaskId(K);!$&&!this._providedCustomExecutions2.has(x)&&(this._notProvidedCustomExecutions.add(x),this._activeCustomExecutions2.set(x,J.execution)),this._providedCustomExecutions2.set(x,J.execution)}async getTaskExecution(K,J){if(typeof K=="string"){const G=this._taskExecutionPromises.get(K);if(!G)throw new n.ErrorNoTelemetry("Unexpected: The specified task is missing an execution");return G}const $=this._taskExecutionPromises.get(K.id);if($)return $;let x;return J?x=Promise.resolve(new b(this,K.id,J)):x=R.to(K.task,this._workspaceProvider,this._providedCustomExecutions2).then(G=>{if(!G)throw new n.ErrorNoTelemetry("Unexpected: Task does not exist.");return new b(this,K.id,G)}),this._taskExecutionPromises.set(K.id,x),x.then(G=>(this._taskExecutions.set(K.id,G),G))}checkDeprecation(K,J){K._deprecated&&this._deprecationService.report("Task.constructor",J.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(K){this._activeCustomExecutions2.get(K.id)&&this._activeCustomExecutions2.delete(K.id),this._notProvidedCustomExecutions.has(K.id)&&this._lastStartedTask!==K.id&&(this._providedCustomExecutions2.delete(K.id),this._notProvidedCustomExecutions.delete(K.id));const $=this._notProvidedCustomExecutions.values();let x=$.next();for(;!x.done;)!this._activeCustomExecutions2.has(x.value)&&this._lastStartedTask!==x.value&&(this._providedCustomExecutions2.delete(x.value),this._notProvidedCustomExecutions.delete(x.value)),x=$.next()}};e.ExtHostTaskBase=N,e.ExtHostTaskBase=N=qe([We(0,u.IExtHostRpcService),We(1,C.IExtHostInitDataService),We(2,A.IExtHostWorkspace),We(3,m.IExtHostDocumentsAndEditors),We(4,s.IExtHostConfiguration),We(5,E.IExtHostTerminalService),We(6,d.ILogService),We(7,l.IExtHostApiDeprecationService)],N);let L=class extends N{constructor(K,J,$,x,G,Y,ae,ee){super(K,J,$,x,G,Y,ae,ee),this.registerTaskSystem(r.Schemas.vscodeRemote,{scheme:r.Schemas.vscodeRemote,authority:"",platform:a.PlatformToString(a.Platform.Web)})}async executeTask(K,J){if(!J.execution)throw new Error("Tasks to execute must include an execution");const $=R.from(J,K);if($===void 0)throw new Error("Task is not valid");if(y.is($.execution))await this.addCustomExecution($,J,!1);else throw new n.NotSupportedError;const x=await this.getTaskExecution(await this._proxy.$getTaskExecution($),J);return this._proxy.$executeTask($).catch(G=>{throw new Error(G)}),x}provideTasksInternal(K,J,$,x){const G=[];if(x)for(const Y of x){if(this.checkDeprecation(Y,$),!Y.definition||!K[Y.definition.type]){const ee=Y.source?Y.source:"No task source";this._logService.warn(`The task [${ee}, ${Y.name}] uses an undefined task type. The task will be ignored in the future.`)}const ae=R.from(Y,$.extension);ae&&y.is(ae.execution)?(G.push(ae),J.push(this.addCustomExecution(ae,Y,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:G,extension:$.extension}}async resolveTaskInternal(K){if(y.is(K.execution))return K;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(K,J){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(K,J,$){}};e.WorkerExtHostTask=L,e.WorkerExtHostTask=L=qe([We(0,u.IExtHostRpcService),We(1,C.IExtHostInitDataService),We(2,A.IExtHostWorkspace),We(3,m.IExtHostDocumentsAndEditors),We(4,s.IExtHostConfiguration),We(5,E.IExtHostTerminalService),We(6,d.ILogService),We(7,l.IExtHostApiDeprecationService)],L),e.IExtHostTask=(0,v.createDecorator)("IExtHostTask")}),define(ke[268],Re([1,0,40,32]),function(Ee,e,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.rawCellPrefix=void 0,e.isINotebookFileMatchNoModel=D,e.genericCellMatchesToTextSearchMatches=O;function D(k){return"cellResults"in k}e.rawCellPrefix="rawCell#";function O(k,A){let m=-1;const s=[];let I=[];return k.forEach(u=>{u.range.startLineNumber!==m&&I.length>0&&(s.push([...I]),I=[]),I.push(u),m=u.range.endLineNumber}),I.length>0&&s.push([...I]),s.map(u=>{const C=[],v=u[0].range.startLineNumber,r=u[u.length-1].range.endLineNumber;for(let a=v;a<=r;a++)C.push(A.getLineContent(a));return new S.TextSearchMatch(C.join(`
`)+`
`,u.map(a=>new T.Range(a.range.startLineNumber-1,a.range.startColumn-1,a.range.endLineNumber-1,a.range.endColumn-1)))})}}),define(ke[269],Re([1,0,9,20,6,4,27,38,13,14,2,28,80,5,35,8,7,39,246,126,25,15,40,199,268,266]),function(Ee,e,S,T,D,O,k,A,m,s,I,E,u,C,v,r,a,d,l,i,n,t,o,c,g,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0,E=Ve(E),r=Ve(r),a=Ve(a);class h{static{this._notebookStatusBarItemProviderHandlePool=0}get activeNotebookEditor(){return this._activeNotebookEditor?.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(y=>y.apiEditor)}constructor(y,w,P,R,p,b,N){this._textDocumentsAndEditors=P,this._textDocuments=R,this._extHostFileSystem=p,this._extHostSearch=b,this._logService=N,this._notebookStatusBarItemProviders=new Map,this._documents=new k.ResourceMap,this._editors=new Map,this._onDidChangeActiveNotebookEditor=new D.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new D.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new D.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new D.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new u.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._notebookProxy=y.getProxy(C.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=y.getProxy(C.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=y.getProxy(C.MainContext.MainThreadNotebookEditors),this._commandsConverter=w.converter,w.registerArgumentProcessor({processArgument:L=>{if(L&&L.$mid===A.MarshalledId.NotebookCellActionContext){const F=L.notebookEditor?.notebookUri,K=L.cell.handle,$=this._documents.get(F)?.getCell(K);if($)return $.apiCell}if(L&&L.$mid===A.MarshalledId.NotebookActionContext){const F=L.uri,K=this._documents.get(F);if(K)return K.apiNotebook}return L}}),h._registerApiCommands(w)}getEditorById(y){const w=this._editors.get(y);if(!w)throw new Error(`unknown text editor: ${y}. known editors: ${[...this._editors.keys()]} `);return w}getIdByEditor(y){for(const[w,P]of this._editors)if(P.apiEditor===y)return w}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(y,w){const P=this._documents.get(y);if(!P&&!w)throw new Error(`NO notebook document for '${y}'`);return P}static _convertNotebookRegistrationData(y,w){if(!w)return;const P=w.filenamePattern.map(R=>r.NotebookExclusiveDocumentPattern.from(R)).filter(R=>R!==void 0);if(w.filenamePattern&&!P){console.warn(`Notebook content provider view options file name pattern is invalid ${w.filenamePattern}`);return}return{extension:y.identifier,providerDisplayName:y.displayName||y.name,displayName:w.displayName,filenamePattern:P,priority:w.exclusive?f.RegisteredEditorPriority.exclusive:void 0}}registerNotebookCellStatusBarItemProvider(y,w,P){const R=h._notebookStatusBarItemProviderHandlePool++,p=typeof P.onDidChangeCellStatusBarItems=="function"?h._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(R,P),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(R,p,w);let b;return p!==void 0&&(b=P.onDidChangeCellStatusBarItems(N=>this._notebookProxy.$emitCellStatusBarEvent(p))),new a.Disposable(()=>{this._notebookStatusBarItemProviders.delete(R),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(R,p),b?.dispose()})}async createNotebookDocument(y){const w=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:y.viewType,content:y.content&&r.NotebookData.from(y.content)});return I.URI.revive(w)}async openNotebookDocument(y){const w=this._documents.get(y);if(w)return w.apiNotebook;const P=await this._notebookDocumentsProxy.$tryOpenNotebook(y),R=this._documents.get(I.URI.revive(P));return(0,s.assertIsDefined)(R?.apiNotebook)}async showNotebookDocument(y,w){let P;typeof w=="object"?P={position:r.ViewColumn.from(w.viewColumn),preserveFocus:w.preserveFocus,selections:w.selections&&w.selections.map(r.NotebookRange.from),pinned:typeof w.preview=="boolean"?!w.preview:void 0,label:w?.label}:P={preserveFocus:!1,pinned:!0};const R=w?.asRepl?"repl":y.notebookType,p=await this._notebookEditorsProxy.$tryShowNotebookDocument(y.uri,R,P),b=p&&this._editors.get(p)?.apiEditor;if(b)return b;throw p?new Error(`Could NOT open editor for "${y.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${y.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(y,w,P,R){const p=this._notebookStatusBarItemProviders.get(y),b=I.URI.revive(w),N=this._documents.get(b);if(!N||!p)return;const L=N.getCellFromIndex(P);if(!L)return;const F=await p.provideCellStatusBarItems(L.apiCell,R);if(!F)return;const K=new O.DisposableStore,J=this._statusBarCache.add([K]),x=(Array.isArray(F)?F:[F]).map(G=>r.NotebookStatusBarItem.from(G,this._commandsConverter,K));return{cacheId:J,items:x}}$releaseNotebookCellStatusBarItems(y){this._statusBarCache.delete(y)}registerNotebookSerializer(y,w,P,R,p){if((0,m.isFalsyOrWhitespace)(w))throw new Error("viewType cannot be empty or just whitespace");const b=this._handlePool++;return this._notebookSerializer.set(b,{viewType:w,serializer:P,options:R}),this._notebookProxy.$registerNotebookSerializer(b,{id:y.identifier,location:y.extensionLocation},w,r.NotebookDocumentContentOptions.from(R),h._convertNotebookRegistrationData(y,p)),(0,O.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(b)})}async $dataToNotebook(y,w,P){const R=this._notebookSerializer.get(y);if(!R)throw new Error("NO serializer found");const p=await R.serializer.deserializeNotebook(w.buffer,P);return new d.SerializableObjectWithBuffers(r.NotebookData.from(p))}async $notebookToData(y,w,P){const R=this._notebookSerializer.get(y);if(!R)throw new Error("NO serializer found");const p=await R.serializer.serializeNotebook(r.NotebookData.to(w.value),P);return T.VSBuffer.wrap(p)}async $saveNotebook(y,w,P,R,p){const b=I.URI.revive(w),N=this._notebookSerializer.get(y);if(this.trace(`enter saveNotebook(versionId: ${P}, ${b.toString()})`),!N)throw new Error("NO serializer found");const L=this._documents.get(b);if(!L)throw new Error("Document NOT found");if(L.versionId!==P)throw new Error("Document version mismatch");if(!this._extHostFileSystem.value.isWritableFileSystem(b.scheme))throw new E.FileOperationError((0,S.localize)(2709,null,this._resourceForError(b)),E.FileOperationResult.FILE_PERMISSION_DENIED);const F={metadata:(0,n.filter)(L.apiNotebook.metadata,G=>!(N.options?.transientDocumentMetadata??{})[G]),cells:[]};for(const G of L.apiNotebook.getCells()){const Y=new a.NotebookCellData(G.kind,G.document.getText(),G.document.languageId,G.mime,N.options?.transientOutputs?[]:[...G.outputs],G.metadata,G.executionSummary);Y.metadata=(0,n.filter)(G.metadata,ae=>!(N.options?.transientCellMetadata??{})[ae]),F.cells.push(Y)}if(await this._validateWriteFile(b,R),p.isCancellationRequested)throw new Error("canceled");const K=await N.serializer.serializeNotebook(F,p);if(p.isCancellationRequested)throw new Error("canceled");this.trace(`serialized versionId: ${P} ${b.toString()}`),await this._extHostFileSystem.value.writeFile(b,K),this.trace(`Finished write versionId: ${P} ${b.toString()}`);const J=this._extHostFileSystem.getFileSystemProviderExtUri(b.scheme),$=await this._extHostFileSystem.value.stat(b),x={name:J.basename(b),isFile:($.type&E.FileType.File)!==0,isDirectory:($.type&E.FileType.Directory)!==0,isSymbolicLink:($.type&E.FileType.SymbolicLink)!==0,mtime:$.mtime,ctime:$.ctime,size:$.size,readonly:!!(($.permissions??0)&E.FilePermission.Readonly)||!this._extHostFileSystem.value.isWritableFileSystem(b.scheme),locked:!!(($.permissions??0)&E.FilePermission.Locked),etag:E.etag({mtime:$.mtime,size:$.size}),children:void 0};return this.trace(`exit saveNotebook(versionId: ${P}, ${b.toString()})`),x}async $searchInNotebooks(y,w,P,R,p){const b=this._notebookSerializer.get(y)?.serializer;if(!b)return{limitHit:!1,results:[]};const N=new k.ResourceSet;await(async($,x,G)=>{await Promise.all($.map(async Y=>await Promise.all(Y.filenamePatterns.map(ae=>{const ee={_reason:G._reason,folderQueries:G.folderQueries,includePattern:G.includePattern,excludePattern:G.excludePattern,maxResults:G.maxResults,type:o.QueryType.File,filePattern:ae};return this._extHostSearch.doInternalFileSearchWithCustomCallback(ee,x,oe=>{oe.forEach(ie=>{N.has(ie)||R.some(Z=>Y.isFromSettings&&!Z.isFromSettings?!1:Z.filenamePatterns.some(ve=>(0,f.globMatchesResource)(ve,ie)))||N.add(ie)})}).catch(oe=>{if(oe.code==="ENOENT")return console.warn("Could not find notebook search results, ignoring notebook results."),{limitHit:!1,messages:[]};throw oe})}))))})(P,p,w);const F=new k.ResourceMap;let K=!1;const J=Array.from(N).map(async $=>{const x=[];try{if(p.isCancellationRequested)return;if(w.maxResults&&[...F.values()].reduce((ee,oe)=>ee+oe.cellResults.length,0)>w.maxResults){K=!0;return}const G=[],Y=this._documents.get($);if(Y)Y.apiNotebook.getCells().forEach(oe=>G.push({input:oe.document.getText(),outputs:oe.outputs.flatMap(ie=>ie.items.map(ue=>ue.data.toString()))}));else{const ee=await this._extHostFileSystem.value.readFile($),oe=T.VSBuffer.fromString(ee.toString()),ie=await b.deserializeNotebook(oe.buffer,p);if(p.isCancellationRequested)return;r.NotebookData.from(ie).cells.forEach(Z=>G.push({input:Z.source,outputs:Z.outputs.flatMap(ve=>ve.items.map(Ie=>Ie.valueBytes.toString()))}))}if(p.isCancellationRequested)return;G.forEach((ee,oe)=>{const ie=w.contentPattern.pattern,ue=new c.CellSearchModel(ee.input,void 0,ee.outputs),Z=ue.findInInputs(ie),ve=ue.findInOutputs(ie),Ie=ve.flatMap(X=>(0,g.genericCellMatchesToTextSearchMatches)(X.matches,X.textBuffer)).map((X,V)=>(X.webviewIndex=V,X));if(Z.length>0||ve.length>0){const X={index:oe,contentResults:(0,g.genericCellMatchesToTextSearchMatches)(Z,ue.inputTextBuffer),webviewResults:Ie};x.push(X)}});const ae={resource:$,cellResults:x};F.set($,ae);return}catch{return}});return await Promise.all(J),{limitHit:K,results:[...F.values()]}}async _validateWriteFile(y,w){const P=await this._extHostFileSystem.value.stat(y);if(typeof w?.mtime=="number"&&typeof w.etag=="string"&&w.etag!==E.ETAG_DISABLED&&typeof P.mtime=="number"&&typeof P.size=="number"&&w.mtime<P.mtime&&w.etag!==E.etag({mtime:w.mtime,size:P.size}))throw new E.FileOperationError((0,S.localize)(2710,null),E.FileOperationResult.FILE_MODIFIED_SINCE,w)}_resourceForError(y){return y.scheme===t.Schemas.file?y.fsPath:y.toString()}_createExtHostEditor(y,w,P){if(this._editors.has(w))throw new Error(`editor with id ALREADY EXSIST: ${w}`);const R=new i.ExtHostNotebookEditor(w,this._notebookEditorsProxy,y,P.visibleRanges.map(r.NotebookRange.to),P.selections.map(r.NotebookRange.to),typeof P.viewColumn=="number"?r.ViewColumn.to(P.viewColumn):void 0);this._editors.set(w,R)}$acceptDocumentAndEditorsDelta(y){if(y.value.removedDocuments)for(const P of y.value.removedDocuments){const R=I.URI.revive(P),p=this._documents.get(R);p&&(p.dispose(),this._documents.delete(R),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:p.apiNotebook.getCells().map(b=>b.document.uri)}),this._onDidCloseNotebookDocument.fire(p.apiNotebook));for(const b of this._editors.values())b.notebookData.uri.toString()===R.toString()&&this._editors.delete(b.id)}if(y.value.addedDocuments){const P=[];for(const R of y.value.addedDocuments){const p=I.URI.revive(R.uri);if(this._documents.has(p))throw new Error(`adding EXISTING notebook ${p} `);const b=new l.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,p,R);P.push(...R.cells.map(N=>l.ExtHostCell.asModelAddData(N))),this._documents.get(p)?.dispose(),this._documents.set(p,b),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:P}),this._onDidOpenNotebookDocument.fire(b.apiNotebook)}}if(y.value.addedEditors)for(const P of y.value.addedEditors){if(this._editors.has(P.id))return;const R=I.URI.revive(P.documentUri),p=this._documents.get(R);p&&this._createExtHostEditor(p,P.id,P)}const w=[];if(y.value.removedEditors)for(const P of y.value.removedEditors){const R=this._editors.get(P);R&&(this._editors.delete(P),this._activeNotebookEditor?.id===R.id&&(this._activeNotebookEditor=void 0),w.push(R))}if(y.value.visibleEditors){this._visibleNotebookEditors=y.value.visibleEditors.map(R=>this._editors.get(R)).filter(R=>!!R);const P=new Set;this._visibleNotebookEditors.forEach(R=>P.add(R.id));for(const R of this._editors.values()){const p=P.has(R.id);R._acceptVisibility(p)}this._visibleNotebookEditors=[...this._editors.values()].map(R=>R).filter(R=>R.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}y.value.newActiveEditor===null?this._activeNotebookEditor=void 0:y.value.newActiveEditor&&(this._editors.get(y.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${y.value.newActiveEditor}`),this._activeNotebookEditor=this._editors.get(y.value.newActiveEditor)),y.value.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire(this._activeNotebookEditor?.apiEditor)}static _registerApiCommands(y){const w=v.ApiCommandArgument.String.with("notebookType","A notebook type"),P=new v.ApiCommand("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[w,new v.ApiCommandArgument("data","Bytes to convert to data",p=>p instanceof Uint8Array,p=>T.VSBuffer.wrap(p))],new v.ApiCommandResult("Notebook Data",p=>r.NotebookData.to(p.value))),R=new v.ApiCommand("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[w,new v.ApiCommandArgument("NotebookData","Notebook data to convert to bytes",p=>!0,p=>new d.SerializableObjectWithBuffers(r.NotebookData.from(p)))],new v.ApiCommandResult("Bytes",p=>p.buffer));y.registerApiCommand(P),y.registerApiCommand(R)}trace(y){this._logService.trace(`[Extension Host Notebook] ${y}`)}}e.ExtHostNotebookController=h}),define(ke[270],Re([1,0,17,240,43,103,27,15,22,24,13,14,2,102,9,44,11,114,49,120,267,40]),function(Ee,e,S,T,D,O,k,A,m,s,I,E,u,C,v,r,a,d,l,i,n,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.QueryBuilder=void 0,e.isISearchPatternBuilder=o,e.globPatternToISearchPatternBuilder=c,e.resolveResourcesForSearchIncludes=p,S=Ve(S),T=Ve(T),D=Ve(D),m=Ve(m),I=Ve(I),v=Ve(v);function o(b){return typeof b=="object"&&"uri"in b&&"pattern"in b}function c(b){return typeof b=="string"?{pattern:b}:{pattern:b.pattern,uri:b.baseUri}}let g=class{constructor(N,L,F,K,J,$){this.configurationService=N,this.workspaceContextService=L,this.editorGroupsService=F,this.logService=K,this.pathService=J,this.uriIdentityService=$}text(N,L,F={}){N=this.getContentPattern(N,F);const K=this.configurationService.getValue(),J=L&&L.some(x=>!this.configurationService.getValue({resource:x}).search.useRipgrep);return{...this.commonQuery(L?.map(l.toWorkspaceFolder),F),type:t.QueryType.Text,contentPattern:N,previewOptions:F.previewOptions,maxFileSize:F.maxFileSize,usePCRE2:K.search.usePCRE2||J||!1,surroundingContext:F.surroundingContext,userDisabledExcludesAndIgnoreFiles:F.disregardExcludeSettings&&F.disregardIgnoreFiles}}getContentPattern(N,L){const F=this.configurationService.getValue();N.isRegExp&&(N.pattern=N.pattern.replace(/\r?\n/g,"\\n"));const K={...N,wordSeparators:F.editor.wordSeparators};return this.isCaseSensitive(N,L)&&(K.isCaseSensitive=!0),this.isMultiline(N)&&(K.isMultiline=!0),L.notebookSearchConfig?.includeMarkupInput&&(K.notebookInfo||(K.notebookInfo={}),K.notebookInfo.isInNotebookMarkdownInput=L.notebookSearchConfig.includeMarkupInput),L.notebookSearchConfig?.includeMarkupPreview&&(K.notebookInfo||(K.notebookInfo={}),K.notebookInfo.isInNotebookMarkdownPreview=L.notebookSearchConfig.includeMarkupPreview),L.notebookSearchConfig?.includeCodeInput&&(K.notebookInfo||(K.notebookInfo={}),K.notebookInfo.isInNotebookCellInput=L.notebookSearchConfig.includeCodeInput),L.notebookSearchConfig?.includeOutput&&(K.notebookInfo||(K.notebookInfo={}),K.notebookInfo.isInNotebookCellOutput=L.notebookSearchConfig.includeOutput),K}file(N,L={}){return{...this.commonQuery(N,L),type:t.QueryType.File,filePattern:L.filePattern?L.filePattern.trim():L.filePattern,exists:L.exists,sortByScore:L.sortByScore,cacheKey:L.cacheKey,shouldGlobMatchFilePattern:L.shouldGlobSearch}}handleIncludeExclude(N,L){if(!N)return{};if(Array.isArray(N)){if(N=N.filter(F=>F.length>0).map(w),!N.length)return{}}else N=w(N);return L?this.parseSearchPaths(N):{pattern:h(...Array.isArray(N)?N:[N])}}commonQuery(N=[],L={}){let F=Array.isArray(L.excludePattern)?L.excludePattern.map(ae=>ae.pattern).flat():L.excludePattern;F=F?.length===1?F[0]:F;const K=this.handleIncludeExclude(L.includePattern,L.expandPatterns),J=this.handleIncludeExclude(F,L.expandPatterns),$=N.length>1,x=(K.searchPaths&&K.searchPaths.length?K.searchPaths.map(ae=>this.getFolderQueryForSearchPath(ae,L,J)):N.map(ae=>this.getFolderQueryForRoot(ae,L,J,$))).filter(ae=>!!ae),G={_reason:L._reason,folderQueries:x,usingSearchPaths:!!(K.searchPaths&&K.searchPaths.length),extraFileResources:L.extraFileResources,excludePattern:J.pattern,includePattern:K.pattern,onlyOpenEditors:L.onlyOpenEditors,maxResults:L.maxResults,onlyFileScheme:L.onlyFileScheme};if(L.onlyOpenEditors){const ae=S.coalesce(this.editorGroupsService.groups.flatMap(ie=>ie.editors.map(ue=>ue.resource)));this.logService.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(ae));const ee=ae.filter(ie=>(0,t.pathIncludedInQuery)(G,ie.fsPath)),oe=this.commonQueryFromFileList(ee);return this.logService.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(oe)),{...G,...oe}}const Y=L.extraFileResources&&L.extraFileResources.filter(ae=>(0,t.pathIncludedInQuery)(G,ae.fsPath));return G.extraFileResources=Y&&Y.length?Y:void 0,G}commonQueryFromFileList(N){const L=[],F=new k.ResourceMap,K={};let J=!1;return N.forEach($=>{if($.scheme===A.Schemas.walkThrough)return;if((0,s.isAbsolutePath)($)){const G=this.workspaceContextService.getWorkspaceFolder($)?.uri??this.uriIdentityService.extUri.dirname($);let Y=F.get(G);Y||(J=!0,Y={folder:G,includePattern:{}},L.push(Y),F.set(G,Y));const ae=m.relative(G.fsPath,$.fsPath);(0,E.assertIsDefined)(Y.includePattern)[ae.replace(/\\/g,"/")]=!0}else $.fsPath&&(J=!0,K[$.fsPath]=!0)}),{folderQueries:L,includePattern:K,usingSearchPaths:!0,excludePattern:J?void 0:{"**/*":!0}}}isCaseSensitive(N,L){if(L.isSmartCase){if(N.isRegExp){if(I.containsUppercaseCharacter(N.pattern,!0))return!0}else if(I.containsUppercaseCharacter(N.pattern))return!0}return!!N.isCaseSensitive}isMultiline(N){return N.isMultiline||N.isRegExp&&(0,C.isMultilineRegexSource)(N.pattern)||N.pattern.indexOf(`
`)>=0?!0:!!N.isMultiline}parseSearchPaths(N){const L=ee=>m.isAbsolute(ee)||/^\.\.?([\/\\]|$)/.test(ee),K=(Array.isArray(N)?N:_(N)).map(ee=>{const oe=this.pathService.resolvedUserHome;return oe?(0,O.untildify)(ee,oe.scheme===A.Schemas.file?oe.fsPath:oe.path):ee}),J=T.groupBy(K,ee=>L(ee)?"searchPaths":"exprSegments"),$=(J.exprSegments||[]).map(ee=>I.rtrim(ee,"/")).map(ee=>I.rtrim(ee,"\\")).map(ee=>(ee[0]==="."&&(ee="*"+ee),y(ee))),x={},G=this.expandSearchPathPatterns(J.searchPaths||[]);G&&G.length&&(x.searchPaths=G);const Y=$.flat(),ae=h(...Y);return ae&&(x.pattern=ae),x}getExcludesForFolder(N,L){return L.disregardExcludeSettings?void 0:(0,t.getExcludes)(N,!L.disregardSearchExcludeSettings)}expandSearchPathPatterns(N){if(!N||!N.length)return[];const L=N.flatMap(K=>{let{pathPortion:J,globPortion:$}=f(K);return $&&($=P($)),this.expandOneSearchPath(J).flatMap(G=>this.resolveOneSearchPathPattern(G,$))}),F=new Map;return L.forEach(K=>{const J=K.searchPath.toString(),$=F.get(J);$?K.pattern&&($.pattern=$.pattern||{},$.pattern[K.pattern]=!0):F.set(J,{searchPath:K.searchPath,pattern:K.pattern?h(K.pattern):void 0})}),Array.from(F.values())}expandOneSearchPath(N){if(m.isAbsolute(N)){const L=this.workspaceContextService.getWorkspace().folders;return L[0]&&L[0].uri.scheme!==A.Schemas.file?[{searchPath:L[0].uri.with({path:N})}]:[{searchPath:u.URI.file(m.normalize(N))}]}if(this.workspaceContextService.getWorkbenchState()===l.WorkbenchState.FOLDER){const L=this.workspaceContextService.getWorkspace().folders[0].uri;if(N=w(N),N.startsWith("../")||N===".."){const K=m.posix.resolve(L.path,N);return[{searchPath:L.with({path:K})}]}const F=P(N);return[{searchPath:L,pattern:F}]}else{if(N==="./"||N===".\\")return[];{const L=N.replace(/^\.[\/\\]/,""),K=this.workspaceContextService.getWorkspace().folders.map(J=>{const $=L.match(new RegExp(`^${I.escapeRegExpCharacters(J.name)}(?:/(.*)|$)`));return $?{match:$,folder:J}:null}).filter(E.isDefined);if(K.length)return K.map(J=>{const $=J.match[1];return{searchPath:J.folder.uri,pattern:$&&P($)}});{const J=N.match(/\.[\/\\](.+)[\/\\]?/),$=J?J[1]:N,x=v.localize(12569,null,$);throw new Error(x)}}}}resolveOneSearchPathPattern(N,L){const F=N.pattern&&L?`${N.pattern}/${L}`:N.pattern||L,K=[{searchPath:N.searchPath,pattern:F}];return F&&!F.endsWith("**")&&K.push({searchPath:N.searchPath,pattern:F+"/**"}),K}getFolderQueryForSearchPath(N,L,F){const K=this.getFolderQueryForRoot((0,l.toWorkspaceFolder)(N.searchPath),L,F,!1);return K?{...K,includePattern:N.pattern}:null}getFolderQueryForRoot(N,L,F,K){let J;const $=u.URI.isUri(N)?N:N.uri;let x=L.excludePattern?.map(ie=>{const ue=L.excludePattern&&o(ie)?ie.uri:void 0;return!ue||!(u.URI.isUri(N)&&this.uriIdentityService.extUri.isEqual(N,ue))?ue:void 0});if(x?.length||(x=[void 0]),F.searchPaths){const ie=F.searchPaths.filter(ue=>(0,s.isEqual)(ue.searchPath,$))[0];if(ie&&!ie.pattern)return null;ie&&(J=ie.pattern)}const G=this.configurationService.getValue({resource:$}),ae={...this.getExcludesForFolder(G,L)||{},...J||{}},ee=u.URI.isUri(N)?(0,s.basename)(N):N.name,oe=x.map(ie=>Object.keys(ae).length>0?{folder:ie,pattern:ae}:void 0).filter(ie=>ie);return{folder:$,folderName:K?ee:void 0,excludePattern:oe,fileEncoding:G.files&&G.files.encoding,disregardIgnoreFiles:typeof L.disregardIgnoreFiles=="boolean"?L.disregardIgnoreFiles:!G.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof L.disregardGlobalIgnoreFiles=="boolean"?L.disregardGlobalIgnoreFiles:!G.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof L.disregardParentIgnoreFiles=="boolean"?L.disregardParentIgnoreFiles:!G.search.useParentIgnoreFiles,ignoreSymlinks:typeof L.ignoreSymlinks=="boolean"?L.ignoreSymlinks:!G.search.followSymlinks}}};e.QueryBuilder=g,e.QueryBuilder=g=qe([We(0,r.IConfigurationService),We(1,l.IWorkspaceContextService),We(2,i.IEditorGroupsService),We(3,a.ILogService),We(4,n.IPathService),We(5,d.IUriIdentityService)],g);function f(b){const N=b.match(/[\*\{\}\(\)\[\]\?]/);if(N){const L=N.index,F=b.substr(0,L).match(/[/|\\][^/\\]*$/);if(F){let K=b.substr(0,F.index);return K.match(/[/\\]/)||(K+="/"),{pathPortion:K,globPortion:b.substr((F.index||0)+1)}}}return{pathPortion:b}}function h(...b){return b.length?b.reduce((N,L)=>(N[L]=!0,N),Object.create(null)):void 0}function _(b){return D.splitGlobAware(b,",").map(N=>N.trim()).filter(N=>!!N.length)}function y(b){return[`**/${b}/**`,`**/${b}`].map(L=>L.replace(/\*\*\/\*\*/g,"**"))}function w(b){return b.replace(/\\/g,"/")}function P(b){return w(b).replace(/^\.\//,"").replace(/\/+$/g,"")}function R(b){return b.replace(/([?*[\]])/g,"[$1]")}function p(b,N){b=S.distinct(b,K=>K.toString());const L=[],F=N.getWorkspace();return b&&b.forEach(K=>{let J;if(N.getWorkbenchState()===l.WorkbenchState.FOLDER)J=(0,s.relativePath)(F.folders[0].uri,K),J&&J!=="."&&(J="./"+J);else{const $=N.getWorkspaceFolder(K);if($){const x=$.name;if(F.folders.filter(Y=>Y.name===x).length===1){const Y=(0,s.relativePath)($.uri,K);Y===""?J=`./${$.name}`:J=`./${$.name}/${Y}`}else J=K.fsPath}}J&&L.push(R(J))}),L}}),define(ke[271],Re([1,0,24,2,19,12,3,270,40,49,10]),function(Ee,e,S,T,D,O,k,A,m,s,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkActivateWorkspaceContainsExtension=u,e.checkGlobFileExists=r,S=Ve(S),O=Ve(O);const E=7e3;function u(a,d){const l=d.activationEvents;if(!l)return Promise.resolve(void 0);const i=[],n=[];for(const h of l)if(/^workspaceContains:/.test(h)){const _=h.substr(18);_.indexOf("*")>=0||_.indexOf("?")>=0||a.forceUsingSearch?n.push(_):i.push(_)}if(i.length===0&&n.length===0)return Promise.resolve(void 0);const{promise:t,resolve:o}=(0,I.promiseWithResolvers)(),c=h=>o({activationEvent:h}),g=Promise.all(i.map(h=>C(a,h,c))).then(()=>{}),f=v(a,d.identifier,n,c);return Promise.all([g,f]).then(()=>{o(void 0)}),t}async function C(a,d,l){for(const i of a.folders)if(await a.exists(S.joinPath(T.URI.revive(i),d))){l(`workspaceContains:${d}`);return}}async function v(a,d,l,i){if(l.length===0)return Promise.resolve(void 0);const n=new D.CancellationTokenSource,t=a.checkExists(a.folders,l,n.token),o=setTimeout(async()=>{n.cancel(),a.logService.info(`Not activating extension '${d.value}': Timed out while searching for 'workspaceContains' pattern ${l.join(",")}`)},E);let c=!1;try{c=await t}catch(g){O.isCancellationError(g)||O.onUnexpectedError(g)}n.dispose(),clearTimeout(o),c&&i(`workspaceContains:${l.join(",")}`)}function r(a,d,l,i){const n=a.get(k.IInstantiationService),t=a.get(m.ISearchService),c=n.createInstance(A.QueryBuilder).file(d.map(g=>(0,s.toWorkspaceFolder)(T.URI.revive(g))),{_reason:"checkExists",includePattern:l,exists:!0});return t.fileSearch(c,i).then(g=>!!g.limitHit,g=>O.isCancellationError(g)?!1:Promise.reject(g))}}),define(ke[47],Re([1,0,9,22,64,24,10,4,48,2,11,5,46,206,89,45,21,121,12,18,20,189,7,110,3,26,92,16,75,93,56,95,6,271,88,191,15,86,69,23,87]),function(Ee,e,S,T,D,O,k,A,m,s,I,E,u,C,v,r,a,d,l,i,n,t,o,c,g,f,h,_,y,w,P,R,p,b,N,L,F,K,J,$,x){"use strict";var G;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionPaths=e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,S=Ve(S),T=Ve(T),D=Ve(D),l=Ve(l),e.IHostUtils=(0,g.createDecorator)("IHostUtils");let Y=G=class extends A.Disposable{constructor(X,V,re,be,De,Fe,ze,Je,nt,dt,vt,ut,et){super(),this._extHostManagedSockets=ut,this._extHostLanguageModels=et,this._onDidChangeRemoteConnectionData=this._register(new p.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._realPathCache=new Map,this._isTerminating=!1,this._hostUtils=V,this._extHostContext=re,this._initData=ze,this._extHostWorkspace=be,this._extHostConfiguration=De,this._logService=Fe,this._extHostTunnelService=nt,this._extHostTerminalService=dt,this._extHostLocalizationService=vt,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(E.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(E.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(E.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new k.Barrier,this._readyToStartExtensionHost=new k.Barrier,this._readyToRunExtensions=new k.Barrier,this._eagerExtensionsActivated=new k.Barrier,this._activationEventsReader=new ve(this._initData.extensions.activationEvents),this._globalRegistry=new d.ExtensionDescriptionRegistry(this._activationEventsReader,this._initData.extensions.allExtensions);const Oe=new i.ExtensionIdentifierSet(this._initData.extensions.myExtensions);this._myRegistry=new d.ExtensionDescriptionRegistry(this._activationEventsReader,ue(this._globalRegistry,Oe)),$.isCI&&(this._logService.info(`Creating extension host with the following global extensions: ${oe(this._globalRegistry)}`),this._logService.info(`Creating extension host with the following local extensions: ${oe(this._myRegistry)}`)),this._storage=new v.ExtHostStorage(this._extHostContext,this._logService),this._secretState=new N.ExtHostSecretState(this._extHostContext),this._storagePath=Je,this._instaService=this._store.add(X.createChild(new y.ServiceCollection([v.IExtHostStorage,this._storage],[N.IExtHostSecretState,this._secretState]))),this._activator=this._register(new C.ExtensionsActivator(this._myRegistry,this._globalRegistry,{onExtensionActivationError:(Me,Ne,B)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(Me,l.transformErrorForSerialization(Ne),B)},actualActivateExtension:async(Me,Ne)=>{if(d.ExtensionDescriptionRegistry.isHostExtension(Me,this._myRegistry,this._globalRegistry))return await this._mainThreadExtensionsProxy.$activateExtension(Me,Ne),new C.HostExtension;const B=this._myRegistry.getExtensionDescription(Me);return this._activateExtension(B,Ne)}},this._logService)),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),D.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(X){l.onUnexpectedError(X)}}async _deactivateAll(){this._storagePath.onWillDeactivateAll();let X=[];try{X=this._myRegistry.getAllExtensionDescriptions().map(De=>De.identifier).filter(De=>this.isActivated(De)).map(De=>this._deactivate(De))}catch{}await Promise.all(X)}terminate(X,V=0){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`Extension host terminating: ${X}`),this._logService.flush(),this._extHostTerminalService.dispose(),this._activator.dispose(),l.setUnexpectedErrorHandler(be=>{this._logService.error(be)}),this._extHostContext.dispose();const re=this._deactivateAll();Promise.race([(0,k.timeout)(5e3),re]).finally(()=>{this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code ${V}`):this._logService.info(`Extension host exiting with code ${V}`),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(V)})}isActivated(X){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(X):!1}async getExtension(X){const V=await this._mainThreadExtensionsProxy.$getExtension(X);return V&&{...V,identifier:new i.ExtensionIdentifier(V.identifier.value),extensionLocation:s.URI.revive(V.extensionLocation)}}_activateByEvent(X,V){return this._activator.activateByEvent(X,V)}_activateById(X,V){return this._activator.activateById(X,V)}activateByIdWithErrors(X,V){return this._activateById(X,V).then(()=>{const re=this._activator.getActivatedExtension(X);if(re.activationFailed)return Promise.reject(re.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(X=>this._myRegistry)}getExtensionExports(X){if(this._readyToRunExtensions.isOpen())return this._activator.getActivatedExtension(X).exports;try{return this._activator.getActivatedExtension(X).exports}catch{return null}}async _realPathExtensionUri(X){if(X.scheme===F.Schemas.file&&this._hostUtils.fsRealpath){const V=X.fsPath;this._realPathCache.has(V)||this._realPathCache.set(V,this._hostUtils.fsRealpath(V));const re=await this._realPathCache.get(V);return s.URI.file(re)}return X}async getExtensionPathIndex(){return this._extensionPathIndex||(this._extensionPathIndex=this._createExtensionPathIndex(this._myRegistry.getAllExtensionDescriptions()).then(X=>new Z(X))),this._extensionPathIndex}async _createExtensionPathIndex(X){const V=m.TernarySearchTree.forUris(re=>O.extUriBiasedIgnorePathCase.ignorePathCasing(re));return await Promise.all(X.map(async re=>{if(this._getEntryPoint(re)){const be=await this._realPathExtensionUri(re.extensionLocation);V.set(be,re)}})),V}_deactivate(X){let V=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(X))return V;const re=this._activator.getActivatedExtension(X);if(!re)return V;try{typeof re.module.deactivate=="function"&&(V=Promise.resolve(re.module.deactivate()).then(void 0,be=>(this._logService.error(be),Promise.resolve(void 0))))}catch(be){this._logService.error(`An error occurred when deactivating the extension '${X.value}':`),this._logService.error(be)}try{re.disposable.dispose()}catch(be){this._logService.error(`An error occurred when disposing the subscriptions for extension '${X.value}':`),this._logService.error(be)}return V}async _activateExtension(X,V){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(X.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(X.identifier),this._doActivateExtension(X,V).then(re=>{const be=re.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(X.identifier,be.codeLoadingTime,be.activateCallTime,be.activateResolvedTime,V),this._logExtensionActivationTimes(X,V,"success",be),re},re=>{throw this._logExtensionActivationTimes(X,V,"failure"),re})}_logExtensionActivationTimes(X,V,re,be){const De=ee(X,V);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",{...De,...be||{},outcome:re})}_doActivateExtension(X,V){const re=ee(X,V);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",re);const be=this._getEntryPoint(X);if(!be)return Promise.resolve(new C.EmptyExtension(C.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${X.identifier.value}, startup: ${V.startup}, activationEvent: '${V.activationEvent}'${X.identifier.value!==V.extensionId.value?`, root cause: ${V.extensionId.value}`:""}`),this._logService.flush();const De=new A.DisposableStore,Fe=new C.ExtensionActivationTimesBuilder(V.startup);return Promise.all([this._loadCommonJSModule(X,(0,O.joinPath)(X.extensionLocation,be),Fe),this._loadExtensionContext(X,De)]).then(ze=>(D.mark(`code/extHost/willActivateExtension/${X.identifier.value}`),G._callActivate(this._logService,X.identifier,ze[0],ze[1],De,Fe))).then(ze=>(D.mark(`code/extHost/didActivateExtension/${X.identifier.value}`),ze))}_loadExtensionContext(X,V){const re=this._extHostLanguageModels.createLanguageModelAccessInformation(X),be=V.add(new t.ExtensionGlobalMemento(X,this._storage)),De=V.add(new t.ExtensionMemento(X.identifier.value,!1,this._storage)),Fe=V.add(new L.ExtensionSecrets(X,this._secretState)),ze=X.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?o.ExtensionMode.Test:o.ExtensionMode.Development:o.ExtensionMode.Production,Je=this._initData.remote.isRemote?o.ExtensionKind.Workspace:o.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${X.identifier.value}`),Promise.all([be.whenReady,De.whenReady,this._storagePath.whenReady]).then(()=>{const nt=this;let dt,vt;const ut=(0,a.isProposedApiEnabled)(X,"ipc")?this._initData.messagePorts?.get(i.ExtensionIdentifier.toKey(X.identifier)):void 0;return Object.freeze({globalState:be,workspaceState:De,secrets:Fe,subscriptions:[],get languageModelAccessInformation(){return re},get extensionUri(){return X.extensionLocation},get extensionPath(){return X.extensionLocation.fsPath},asAbsolutePath(et){return T.join(X.extensionLocation.fsPath,et)},get storagePath(){return nt._storagePath.workspaceValue(X)?.fsPath},get globalStoragePath(){return nt._storagePath.globalValue(X).fsPath},get logPath(){return T.join(nt._initData.logsLocation.fsPath,X.identifier.value)},get logUri(){return s.URI.joinPath(nt._initData.logsLocation,X.identifier.value)},get storageUri(){return nt._storagePath.workspaceValue(X)},get globalStorageUri(){return nt._storagePath.globalValue(X)},get extensionMode(){return ze},get extension(){return dt===void 0&&(dt=new ie(nt,X.identifier,X,Je,!1)),dt},get extensionRuntime(){return(0,a.checkProposedApiEnabled)(X,"extensionRuntime"),nt.extensionRuntime},get environmentVariableCollection(){return nt._extHostTerminalService.getEnvironmentVariableCollection(X)},get messagePassingProtocol(){if(!vt){if(!ut)return;const et=p.Event.buffer(p.Event.fromDOMEventEmitter(ut,"message",Oe=>Oe.data));ut.start(),vt={onDidReceiveMessage:et,postMessage:ut.postMessage.bind(ut)}}return vt}})})}static _callActivate(X,V,re,be,De,Fe){return re=re||{activate:void 0,deactivate:void 0},this._callActivateOptional(X,V,re,be,Fe).then(ze=>new C.ActivatedExtension(!1,null,Fe.build(),re,ze,(0,A.toDisposable)(()=>{De.dispose(),(0,A.dispose)(be.subscriptions)})))}static _callActivateOptional(X,V,re,be,De){if(typeof re.activate=="function")try{De.activateCallStart(),X.trace(`ExtensionService#_callActivateOptional ${V.value}`);const Fe=typeof global=="object"?global:self,ze=re.activate.apply(Fe,[be]);return De.activateCallStop(),De.activateResolveStart(),Promise.resolve(ze).then(Je=>(De.activateResolveStop(),Je))}catch(Fe){return Promise.reject(Fe)}else return Promise.resolve(re)}_activateOneStartupFinished(X,V){this._activateById(X.identifier,{startup:!1,extensionId:X.identifier,activationEvent:V}).then(void 0,re=>{this._logService.error(re)})}_activateAllStartupFinishedDeferred(X,V=0){const be=Date.now();(0,$.setTimeout0)(()=>{for(let De=V;De<X.length;De+=1){const Fe=X[De];for(const ze of Fe.activationEvents??[])if(ze==="onStartupFinished")if(Date.now()-be>50){this._activateAllStartupFinishedDeferred(X,De);break}else this._activateOneStartupFinished(Fe,ze)}})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(D.getMarks()),this._extHostConfiguration.getConfigProvider().then(X=>{const V=X.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),re=this._myRegistry.getAllExtensionDescriptions();if(V)this._activateAllStartupFinishedDeferred(re);else for(const be of re)if(be.activationEvents)for(const De of be.activationEvents)De==="onStartupFinished"&&this._activateOneStartupFinished(be,De)})}_handleEagerExtensions(){const X=this._activateByEvent("*",!0).then(void 0,Fe=>{this._logService.error(Fe)});this._register(this._extHostWorkspace.onDidChangeWorkspace(Fe=>this._handleWorkspaceContainsEagerExtensions(Fe.added)));const V=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],re=this._handleWorkspaceContainsEagerExtensions(V),be=this._handleRemoteResolverEagerExtensions(),De=Promise.all([be,X,re]).then(()=>{});return Promise.race([De,(0,k.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),De}_handleWorkspaceContainsEagerExtensions(X){return X.length===0?Promise.resolve(void 0):Promise.all(this._myRegistry.getAllExtensionDescriptions().map(V=>this._handleWorkspaceContainsEagerExtension(X,V))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(X,V){if(this.isActivated(V.identifier))return;const re=!this._initData.remote.isRemote&&!!this._initData.remote.authority,be={logService:this._logService,folders:X.map(Fe=>Fe.uri),forceUsingSearch:re||!this._hostUtils.fsExists,exists:Fe=>this._hostUtils.fsExists(Fe.fsPath),checkExists:(Fe,ze,Je)=>this._mainThreadWorkspaceProxy.$checkExists(Fe,ze,Je)},De=await(0,b.checkActivateWorkspaceContainsExtension)(be,V);if(De)return this._activateById(V.identifier,{startup:!0,extensionId:V.identifier,activationEvent:De.activationEvent}).then(void 0,Fe=>this._logService.error(Fe))}async _handleRemoteResolverEagerExtensions(){if(this._initData.remote.authority)return this._activateByEvent(`onResolveRemoteAuthority:${this._initData.remote.authority}`,!1)}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return await this._doHandleExtensionTests()}catch(X){throw console.error(X),X}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:X,extensionTestsLocationURI:V}=this._initData.environment;if(!X||!V)throw new Error(S.localize(2701,null));const re=await this._loadCommonJSModule(null,V,new C.ExtensionActivationTimesBuilder(!1));if(!re||typeof re.run!="function")throw new Error(S.localize(2702,null,V.toString()));return new Promise((be,De)=>{const Fe=(nt,dt)=>{nt?($.isCI&&this._logService.error("Test runner called back with error",nt),De(nt)):($.isCI&&(dt?this._logService.info(`Test runner called back with ${dt} failures.`):this._logService.info("Test runner called back with successful outcome.")),be(typeof dt=="number"&&dt>0?1:0))},ze=(0,O.originalFSPath)(V),Je=re.run(ze,Fe);Je&&Je.then&&Je.then(()=>{$.isCI&&this._logService.info("Test runner finished successfully."),be(0)}).catch(nt=>{$.isCI&&this._logService.error("Test runner finished with error",nt),De(nt instanceof Error&&nt.stack?nt.stack:String(nt))})})}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>Promise.race([this._activator.waitForActivatingExtensions(),(0,k.timeout)(1e3)])).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("Eager extensions activated")})}registerRemoteAuthorityResolver(X,V){return this._resolvers[X]=V,(0,A.toDisposable)(()=>{delete this._resolvers[X]})}async getRemoteExecServer(X){const{resolver:V}=await this._activateAndGetResolver(X);return V?.resolveExecServer?.(X,{resolveAttempt:0})}async _activateAndGetResolver(X){const V=X.indexOf("+");if(V===-1)throw new o.RemoteAuthorityResolverError("Not an authority that can be resolved!",c.RemoteAuthorityResolverErrorCode.InvalidAuthority);const re=X.substr(0,V);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${re}`,!1),{authorityPrefix:re,resolver:this._resolvers[re]}}async $resolveAuthority(X,V){const re=J.StopWatch.create(!1),be=()=>`[resolveAuthority(${(0,c.getRemoteAuthorityPrefix)(X)},${V})][${re.elapsed()}ms] `,De=z=>this._logService.info(`${be()}${z}`),Fe=z=>this._logService.warn(`${be()}${z}`),ze=(z,H=void 0)=>this._logService.error(`${be()}${z}`,H),Je=z=>{if(z instanceof o.RemoteAuthorityResolverError)return{type:"error",error:{code:z._code,message:z._message,detail:z._detail}};throw z},nt=async z=>{De(`activating resolver for ${z}...`);const{resolver:H,authorityPrefix:q}=await this._activateAndGetResolver(z);if(!H)throw ze(`no resolver for ${q}`),new o.RemoteAuthorityResolverError(`No remote extension installed to resolve ${q}.`,c.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:H,authorityPrefix:q,remoteAuthority:z}},dt=X.split(/@|%40/g).reverse();De(`activating remote resolvers ${dt.join(" -> ")}`);let vt;try{vt=await Promise.all(dt.map(nt)).catch(async z=>{if(!(z instanceof o.RemoteAuthorityResolverError)||z._code!==c.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw z;return Fe(`resolving nested authorities failed: ${z.message}`),[await nt(X)]})}catch(z){return Je(z)}const ut=new k.IntervalTimer;ut.cancelAndSet(()=>De("waiting..."),1e3);let et,Oe;for(const[z,{authorityPrefix:H,resolver:q,remoteAuthority:se}]of vt.entries())try{if(z===vt.length-1)De("invoking final resolve()..."),D.mark(`code/extHost/willResolveAuthority/${H}`),et=await q.resolve(se,{resolveAttempt:V,execServer:Oe}),D.mark(`code/extHost/didResolveAuthorityOK/${H}`),De("setting tunnel factory..."),this._register(await this._extHostTunnelService.setTunnelFactory(q,o.ManagedResolvedAuthority.isManagedResolvedAuthority(et)?et:void 0));else{if(De(`invoking resolveExecServer() for ${se}`),D.mark(`code/extHost/willResolveExecServer/${H}`),Oe=await q.resolveExecServer?.(se,{resolveAttempt:V,execServer:Oe}),!Oe)throw new o.RemoteAuthorityResolverError(`Exec server was not available for ${se}`,c.RemoteAuthorityResolverErrorCode.NoResolverFound);D.mark(`code/extHost/didResolveExecServerOK/${H}`)}}catch(ge){return D.mark(`code/extHost/didResolveAuthorityError/${H}`),ze("returned an error",ge),ut.dispose(),Je(ge)}ut.dispose();const Me={environmentTunnels:et.environmentTunnels,features:et.tunnelFeatures?{elevation:et.tunnelFeatures.elevation,privacyOptions:et.tunnelFeatures.privacyOptions,protocol:et.tunnelFeatures.protocol===void 0?!0:et.tunnelFeatures.protocol}:void 0},Ne={extensionHostEnv:et.extensionHostEnv,isTrusted:et.isTrusted,authenticationSession:et.authenticationSessionForInitializingExtensions?{id:et.authenticationSessionForInitializingExtensions.id,providerId:et.authenticationSessionForInitializingExtensions.providerId}:void 0};De(`returned ${o.ManagedResolvedAuthority.isManagedResolvedAuthority(et)?"managed authority":`${et.host}:${et.port}`}`);let B;if(o.ManagedResolvedAuthority.isManagedResolvedAuthority(et)){const z=V;this._extHostManagedSockets.setFactory(z,et.makeConnection),B={authority:X,connectTo:new c.ManagedRemoteConnection(z),connectionToken:et.connectionToken}}else B={authority:X,connectTo:new c.WebSocketRemoteConnection(et.host,et.port),connectionToken:et.connectionToken};return{type:"ok",value:{authority:B,options:Ne,tunnelInformation:Me}}}async $getCanonicalURI(X,V){this._logService.info(`$getCanonicalURI invoked for authority (${(0,c.getRemoteAuthorityPrefix)(X)})`);const{resolver:re}=await this._activateAndGetResolver(X);if(!re)return null;const be=s.URI.revive(V);if(typeof re.getCanonicalURI>"u")return be;const De=await(0,k.asPromise)(()=>re.getCanonicalURI(be));return De||be}async $startExtensionHost(X){X.toAdd.forEach(Fe=>Fe.extensionLocation=s.URI.revive(Fe.extensionLocation));const{globalRegistry:V,myExtensions:re}=ae(this._activationEventsReader,this._globalRegistry,this._myRegistry,X),be=await this._createExtensionPathIndex(re);return(await this.getExtensionPathIndex()).setSearchTree(be),this._globalRegistry.set(V.getAllExtensionDescriptions()),this._myRegistry.set(re),$.isCI&&(this._logService.info(`$startExtensionHost: global extensions: ${oe(this._globalRegistry)}`),this._logService.info(`$startExtensionHost: local extensions: ${oe(this._myRegistry)}`)),this._startExtensionHost()}$activateByEvent(X,V){return V===a.ActivationKind.Immediate?this._almostReadyToRunExtensions.wait().then(re=>this._activateByEvent(X,!1)):this._readyToRunExtensions.wait().then(re=>this._activateByEvent(X,!1))}async $activate(X,V){return await this._readyToRunExtensions.wait(),this._myRegistry.getExtensionDescription(X)?(await this._activateById(X,V),!0):!1}async $deltaExtensions(X){X.toAdd.forEach(Fe=>Fe.extensionLocation=s.URI.revive(Fe.extensionLocation));const{globalRegistry:V,myExtensions:re}=ae(this._activationEventsReader,this._globalRegistry,this._myRegistry,X),be=await this._createExtensionPathIndex(re);return(await this.getExtensionPathIndex()).setSearchTree(be),this._globalRegistry.set(V.getAllExtensionDescriptions()),this._myRegistry.set(re),$.isCI&&(this._logService.info(`$deltaExtensions: global extensions: ${oe(this._globalRegistry)}`),this._logService.info(`$deltaExtensions: local extensions: ${oe(this._myRegistry)}`)),Promise.resolve(void 0)}async $test_latency(X){return X}async $test_up(X){return X.byteLength}async $test_down(X){const V=n.VSBuffer.alloc(X),re=Math.random()%256;for(let be=0;be<X;be++)V.writeUInt8(re,be);return V}async $updateRemoteConnectionData(X){this._remoteConnectionData=X,this._onDidChangeRemoteConnectionData.fire()}};e.AbstractExtHostExtensionService=Y,e.AbstractExtHostExtensionService=Y=G=qe([We(0,g.IInstantiationService),We(1,e.IHostUtils),We(2,_.IExtHostRpcService),We(3,r.IExtHostWorkspace),We(4,u.IExtHostConfiguration),We(5,I.ILogService),We(6,f.IExtHostInitDataService),We(7,h.IExtensionStoragePaths),We(8,w.IExtHostTunnelService),We(9,P.IExtHostTerminalService),We(10,K.IExtHostLocalizationService),We(11,x.IExtHostManagedSockets),We(12,R.IExtHostLanguageModels)],Y);function ae(Ie,X,V,re){Ie.addActivationEvents(re.addActivationEvents);const be=new d.ExtensionDescriptionRegistry(Ie,X.getAllExtensionDescriptions());be.deltaExtensions(re.toAdd,re.toRemove);const De=new i.ExtensionIdentifierSet(V.getAllExtensionDescriptions().map(ze=>ze.identifier));for(const ze of re.myToRemove)De.delete(ze);for(const ze of re.myToAdd)De.add(ze);const Fe=ue(be,De);return{globalRegistry:be,myExtensions:Fe}}function ee(Ie,X){return{id:Ie.identifier.value,name:Ie.name,extensionVersion:Ie.version,publisherDisplayName:Ie.publisher,activationEvents:Ie.activationEvents?Ie.activationEvents.join(","):null,isBuiltin:Ie.isBuiltin,reason:X.activationEvent,reasonId:X.extensionId.value}}function oe(Ie){return Ie.getAllExtensionDescriptions().map(X=>X.identifier.value).join(",")}e.IExtHostExtensionService=(0,g.createDecorator)("IExtHostExtensionService");class ie{#e;#t;#i;constructor(X,V,re,be,De){this.#e=X,this.#t=V,this.#i=re.identifier,this.id=re.identifier.value,this.extensionUri=re.extensionLocation,this.extensionPath=T.normalize((0,O.originalFSPath)(re.extensionLocation)),this.packageJSON=re,this.extensionKind=be,this.isFromDifferentExtensionHost=De}get isActive(){return this.#e.isActivated(this.#i)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#i)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#i,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.Extension=ie;function ue(Ie,X){return Ie.getAllExtensionDescriptions().filter(V=>X.has(V.identifier))}class Z{constructor(X){this._searchTree=X}setSearchTree(X){this._searchTree=X}findSubstr(X){return this._searchTree.findSubstr(X)}forEach(X){return this._searchTree.forEach(X)}}e.ExtensionPaths=Z;class ve{constructor(X){this._map=new i.ExtensionIdentifierMap,this.addActivationEvents(X)}readActivationEvents(X){return this._map.get(X.identifier)??[]}addActivationEvents(X){for(const V of Object.keys(X))this._map.set(V,X[V])}}}),define(ke[272],Re([1,0,64,2,5,46,21,18,16,26,3,47,11,13]),function(Ee,e,S,T,D,O,k,A,m,s,I,E,u,C){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0,S=Ve(S);let r=class{constructor(n,t,o,c,g,f,h){this._apiFactory=n,this._extensionRegistry=t,this._instaService=o,this._extHostConfiguration=c,this._extHostExtensionService=g,this._initData=f,this._logService=h,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),S.mark("code/extHost/willWaitForConfig");const n=await this._extHostConfiguration.getConfigProvider();S.mark("code/extHost/didWaitForConfig");const t=await this._extHostExtensionService.getExtensionPathIndex();this.register(new d(this._apiFactory,t,this._extensionRegistry,n,this._logService)),this.register(this._instaService.createInstance(a)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(l,t,this._initData.environment.appUriScheme))}register(n){if("nodeModuleName"in n)if(Array.isArray(n.nodeModuleName))for(const t of n.nodeModuleName)this._factories.set(t,n);else this._factories.set(n.nodeModuleName,n);typeof n.alternativeModuleName=="function"&&this._alternatives.push(t=>n.alternativeModuleName(t))}};e.RequireInterceptor=r,e.RequireInterceptor=r=qe([We(2,I.IInstantiationService),We(3,O.IExtHostConfiguration),We(4,E.IExtHostExtensionService),We(5,s.IExtHostInitDataService),We(6,u.ILogService)],r);let a=class{static{v=this}static{this.aliased=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor(n){if(n.environment.appRoot&&v.aliased.size){const t=(0,C.escapeRegExpCharacters)(this.forceForwardSlashes(n.environment.appRoot.fsPath)),o="[a-z0-9_.-]",c=`@${o}+\\/${o}+|${o}+`,g="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.re=new RegExp(`^(${t}/${g}\\/)(${c})(.*)$`,"i")}}alternativeModuleName(n){if(!this.re)return;const t=this.re.exec(this.forceForwardSlashes(n));if(!t)return;const[,o,c,g]=t,f=v.aliased.get(c);if(f!==void 0)return console.warn(`${c} as been renamed to ${f}, please update your imports`),o+f+g}forceForwardSlashes(n){return n.replace(/\\/g,"/")}};a=v=qe([We(0,s.IExtHostInitDataService)],a);class d{constructor(n,t,o,c,g){this._apiFactory=n,this._extensionPaths=t,this._extensionRegistry=o,this._configProvider=c,this._logService=g,this.nodeModuleName="vscode",this._extApiImpl=new A.ExtensionIdentifierMap}load(n,t){const o=this._extensionPaths.findSubstr(t);if(o){let c=this._extApiImpl.get(o.identifier);return c||(c=this._apiFactory(o,this._extensionRegistry,this._configProvider),this._extApiImpl.set(o.identifier,c)),c}if(!this._defaultApiImpl){let c="";this._extensionPaths.forEach((g,f)=>c+=`	${f} -> ${g.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${t}. These are the extension path mappings: 
${c}`),this._defaultApiImpl=this._apiFactory(k.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let l=class{constructor(n,t,o){this._extensionPaths=n,this._appUriScheme=t,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=o.getProxy(D.MainContext.MainThreadTelemetry);const c=o.getProxy(D.MainContext.MainThreadWindow);this._impl=(g,f)=>{const h=T.URI.parse(g);return f?this.callOriginal(g,f):h.scheme==="http"||h.scheme==="https"?c.$openUri(h,g,{allowTunneling:!0}):h.scheme==="mailto"||h.scheme===this._appUriScheme?c.$openUri(h,g,{}):this.callOriginal(g,f)}}load(n,t,o){const c=this._extensionPaths.findSubstr(t);return c&&(this._extensionId=c.identifier.value,this.sendShimmingTelemetry()),this._original=o(n),this._impl}callOriginal(n,t){return this.sendNoForwardTelemetry(),this._original(n,t)}sendShimmingTelemetry(){this._extensionId&&this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){this._extensionId&&this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};l=qe([We(2,m.IExtHostRpcService)],l)}),define(ke[133],Re([1,0,51,4,22,79,3,57,70,47,7,45,203,46]),function(Ee,e,S,T,D,O,k,A,m,s,I,E,u,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostVariableResolverProviderService=e.IExtHostVariableResolverProvider=void 0,D=Ve(D),O=Ve(O),e.IExtHostVariableResolverProvider=(0,k.createDecorator)("IExtHostVariableResolverProvider");class v extends u.AbstractVariableResolverService{constructor(d,l,i,n,t,o,c){function g(){if(i){const f=i.activeEditor();if(f)return f.document.uri;const h=n.tabGroups.all.find(_=>_.isActive)?.activeTab;if(h!==void 0){if(h.input instanceof I.TextDiffTabInput||h.input instanceof I.NotebookDiffEditorTabInput)return h.input.modified;if(h.input instanceof I.TextTabInput||h.input instanceof I.NotebookEditorTabInput||h.input instanceof I.CustomEditorTabInput)return h.input.uri}}}super({getFolderUri:f=>{const h=o.folders.filter(_=>_.name===f);if(h&&h.length>0)return h[0].uri},getWorkspaceFolderCount:()=>o.folders.length,getConfigurationValue:(f,h)=>t.getConfiguration(void 0,f).get(h),getAppRoot:()=>O.cwd(),getExecPath:()=>O.env.VSCODE_EXEC_PATH,getFilePath:()=>{const f=g();if(f)return D.normalize(f.fsPath)},getWorkspaceFolderPathForFile:()=>{if(l){const f=g();if(f){const h=l.getWorkspaceFolder(f);if(h)return D.normalize(h.uri.fsPath)}}},getSelectedText:()=>{if(i){const f=i.activeEditor();if(f&&!f.selection.isEmpty)return f.document.getText(f.selection)}},getLineNumber:()=>{if(i){const f=i.activeEditor();if(f)return String(f.selection.end.line+1)}},getExtension:f=>d.getExtension(f)},void 0,c?Promise.resolve(c):void 0,Promise.resolve(O.env))}}let r=class extends T.Disposable{constructor(d,l,i,n,t){super(),this.extensionService=d,this.workspaceService=l,this.editorService=i,this.configurationService=n,this.editorTabs=t,this._resolver=new S.Lazy(async()=>{const o=await this.configurationService.getConfigProvider(),g={folders:await this.workspaceService.getWorkspaceFolders2()||[]};return this._register(this.workspaceService.onDidChangeWorkspace(async f=>{g.folders=await this.workspaceService.getWorkspaceFolders2()||[]})),new v(this.extensionService,this.workspaceService,this.editorService,this.editorTabs,o,g,this.homeDir())})}getResolver(){return this._resolver.value}homeDir(){}};e.ExtHostVariableResolverProviderService=r,e.ExtHostVariableResolverProviderService=r=qe([We(0,s.IExtHostExtensionService),We(1,E.IExtHostWorkspace),We(2,A.IExtHostDocumentsAndEditors),We(3,C.IExtHostConfiguration),We(4,m.IExtHostEditorTabs)],r)}),define(ke[134],Re([1,0,10,6,2,4,18,3,5,70,47,16,7,45,195,81,196,46,133,36,35,8,17,96]),function(Ee,e,S,T,D,O,k,A,m,s,I,E,u,C,v,r,a,d,l,i,n,t,o,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,t=Ve(t),e.IExtHostDebugService=(0,A.createDecorator)("IExtHostDebugService");let g=class extends O.Disposable{get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession?.api}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}constructor(R,p,b,N,L,F,K,J){super(),this._workspaceService=p,this._extensionService=b,this._configurationService=N,this._editorTabs=L,this._variableResolver=F,this._commands=K,this._testing=J,this._debugSessions=new Map,this._debugVisualizationTreeItemIdsCounter=0,this._debugVisualizationProviders=new Map,this._debugVisualizationTrees=new Map,this._debugVisualizationTreeItemIds=new WeakMap,this._debugVisualizationElements=new Map,this._visualizers=new Map,this._visualizerIdCounter=0,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=this._register(new T.Emitter),this._onDidTerminateDebugSession=this._register(new T.Emitter),this._onDidChangeActiveDebugSession=this._register(new T.Emitter),this._onDidReceiveDebugSessionCustomEvent=this._register(new T.Emitter),this._debugServiceProxy=R.getProxy(m.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=this._register(new T.Emitter),this._onDidChangeActiveStackItem=this._register(new T.Emitter),this._activeDebugConsole=new h(this._debugServiceProxy),this._breakpoints=new Map,this._extensionService.getExtensionRegistry().then($=>{this._register($.onDidChange(x=>{this.registerAllDebugTypes($)})),this.registerAllDebugTypes($)})}async $getVisualizerTreeItem(R,p){const b=this.hydrateVisualizationContext(p);if(!b)return;const N=await this._debugVisualizationTrees.get(R)?.getTreeItem?.(b);return N?this.convertVisualizerTreeItem(R,N):void 0}registerDebugVisualizationTree(R,p,b){const N=k.ExtensionIdentifier.toKey(R.identifier),L=this.extensionVisKey(N,p);if(this._debugVisualizationProviders.has(L))throw new Error(`A debug visualization provider with id '${p}' is already registered`);return this._debugVisualizationTrees.set(L,b),this._debugServiceProxy.$registerDebugVisualizerTree(L,!!b.editItem),(0,O.toDisposable)(()=>{this._debugServiceProxy.$unregisterDebugVisualizerTree(L),this._debugVisualizationTrees.delete(p)})}async $getVisualizerTreeItemChildren(R,p){const b=this._debugVisualizationElements.get(p)?.item;return b?(await this._debugVisualizationTrees.get(R)?.getChildren?.(b))?.map(L=>this.convertVisualizerTreeItem(R,L))||[]:[]}async $editVisualizerTreeItem(R,p){const b=this._debugVisualizationElements.get(R);if(!b)return;const N=await this._debugVisualizationTrees.get(b.provider)?.editItem?.(b.item,p);return this.convertVisualizerTreeItem(b.provider,N||b.item)}$disposeVisualizedTree(R){const p=this._debugVisualizationElements.get(R);if(!p)return;const b=[p.children];for(const N of b)if(N)for(const L of N)b.push(this._debugVisualizationElements.get(L)?.children),this._debugVisualizationElements.delete(L)}convertVisualizerTreeItem(R,p){let b=this._debugVisualizationTreeItemIds.get(p);return b||(b=this._debugVisualizationTreeItemIdsCounter++,this._debugVisualizationTreeItemIds.set(p,b),this._debugVisualizationElements.set(b,{provider:R,item:p})),t.DebugTreeItem.from(p,b)}asDebugSourceUri(R,p){const b=R;if(typeof b.sourceReference=="number"&&b.sourceReference>0){let N=`debug:${encodeURIComponent(b.path||"")}`,L="?";return p&&(N+=`${L}session=${encodeURIComponent(p.id)}`,L="&"),N+=`${L}ref=${b.sourceReference}`,D.URI.parse(N)}else{if(b.path)return D.URI.file(b.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(R){const p=[];for(const b of R.getAllExtensionDescriptions())if(b.contributes){const N=b.contributes.debuggers;if(N&&N.length>0)for(const L of N)(0,a.isDebuggerMainContribution)(L)&&p.push(L.type)}this._debugServiceProxy.$registerDebugTypes(p)}get activeStackItem(){return this._activeStackItem}get onDidChangeActiveStackItem(){return this._onDidChangeActiveStackItem.event}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){const R=[];return this._breakpoints.forEach(p=>R.push(p)),R}async $resolveDebugVisualizer(R,p){const b=this._visualizers.get(R);if(!b)throw new Error(`No debug visualizer found with id '${R}'`);let{v:N,provider:L,extensionId:F}=b;if(N.visualization||(N=await L.resolveDebugVisualization?.(N,p)||N,b.v=N),!N.visualization)throw new Error(`No visualization returned from resolveDebugVisualization in '${L}'`);return this.serializeVisualization(F,N.visualization)}async $executeDebugVisualizerCommand(R){const p=this._visualizers.get(R);if(!p)throw new Error(`No debug visualizer found with id '${R}'`);const b=p.v.visualization;b&&"command"in b&&this._commands.executeCommand(b.command,...b.arguments||[])}hydrateVisualizationContext(R){const p=this._debugSessions.get(R.sessionId);return p&&{session:p.api,variable:R.variable,containerId:R.containerId,frameId:R.frameId,threadId:R.threadId}}async $provideDebugVisualizers(R,p,b,N){const L=this.hydrateVisualizationContext(b),F=this.extensionVisKey(R,p),K=this._debugVisualizationProviders.get(F);if(!L||!K)return[];const J=await K.provideDebugVisualization(L,N);return J?J.map($=>{const x=++this._visualizerIdCounter;this._visualizers.set(x,{v:$,provider:K,extensionId:R});const G=$.iconPath?this.getIconPathOrClass($.iconPath):void 0;return{id:x,name:$.name,iconClass:G?.iconClass,iconPath:G?.iconPath,visualization:this.serializeVisualization(R,$.visualization)}}):[]}$disposeDebugVisualizers(R){for(const p of R)this._visualizers.delete(p)}registerDebugVisualizationProvider(R,p,b){if(!R.contributes?.debugVisualizers?.some(F=>F.id===p))throw new Error(`Extensions may only call registerDebugVisualizationProvider() for renderers they contribute (got ${p})`);const N=k.ExtensionIdentifier.toKey(R.identifier),L=this.extensionVisKey(N,p);if(this._debugVisualizationProviders.has(L))throw new Error(`A debug visualization provider with id '${p}' is already registered`);return this._debugVisualizationProviders.set(L,b),this._debugServiceProxy.$registerDebugVisualizer(N,p),(0,O.toDisposable)(()=>{this._debugServiceProxy.$unregisterDebugVisualizer(N,p),this._debugVisualizationProviders.delete(p)})}addBreakpoints(R){const p=R.filter(L=>{const F=L.id;return this._breakpoints.has(F)?!1:(this._breakpoints.set(F,L),!0)});this.fireBreakpointChanges(p,[],[]);const b=[],N=new Map;for(const L of p)if(L instanceof u.SourceBreakpoint){let F=N.get(L.location.uri.toString());F||(F={type:"sourceMulti",uri:L.location.uri,lines:[]},N.set(L.location.uri.toString(),F),b.push(F)),F.lines.push({id:L.id,enabled:L.enabled,condition:L.condition,hitCondition:L.hitCondition,logMessage:L.logMessage,line:L.location.range.start.line,character:L.location.range.start.character,mode:L.mode})}else L instanceof u.FunctionBreakpoint&&b.push({type:"function",id:L.id,enabled:L.enabled,hitCondition:L.hitCondition,logMessage:L.logMessage,condition:L.condition,functionName:L.functionName,mode:L.mode});return this._debugServiceProxy.$registerBreakpoints(b)}removeBreakpoints(R){const p=R.filter(F=>this._breakpoints.delete(F.id));this.fireBreakpointChanges([],p,[]);const b=p.filter(F=>F instanceof u.SourceBreakpoint).map(F=>F.id),N=p.filter(F=>F instanceof u.FunctionBreakpoint).map(F=>F.id),L=p.filter(F=>F instanceof u.DataBreakpoint).map(F=>F.id);return this._debugServiceProxy.$unregisterBreakpoints(b,N,L)}startDebugging(R,p,b){const N=b.testRun&&this._testing.getMetadataForRun(b.testRun);return this._debugServiceProxy.$startDebugging(R?R.uri:void 0,p,{parentSessionID:b.parentSession?b.parentSession.id:void 0,lifecycleManagedByParent:b.lifecycleManagedByParent,repl:b.consoleMode===u.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:b.noDebug,compact:b.compact,suppressSaveBeforeStart:b.suppressSaveBeforeStart,testRun:N&&{runId:N.runId,taskId:N.taskId},suppressDebugStatusbar:b.suppressDebugStatusbar??b.debugUI?.simple,suppressDebugToolbar:b.suppressDebugToolbar??b.debugUI?.simple,suppressDebugView:b.suppressDebugView??b.debugUI?.simple})}stopDebugging(R){return this._debugServiceProxy.$stopDebugging(R?R.id:void 0)}registerDebugConfigurationProvider(R,p,b){if(!p)return new u.Disposable(()=>{});const N=this._configProviderHandleCounter++;return this._configProviders.push({type:R,handle:N,provider:p}),this._debugServiceProxy.$registerDebugConfigurationProvider(R,b,!!p.provideDebugConfigurations,!!p.resolveDebugConfiguration,!!p.resolveDebugConfigurationWithSubstitutedVariables,N),new u.Disposable(()=>{this._configProviders=this._configProviders.filter(L=>L.provider!==p),this._debugServiceProxy.$unregisterDebugConfigurationProvider(N)})}registerDebugAdapterDescriptorFactory(R,p,b){if(!b)return new u.Disposable(()=>{});if(!this.definesDebugType(R,p))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${p}' debugger.`);if(this.getAdapterDescriptorFactoryByType(p))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const N=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:p,handle:N,factory:b}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(p,N),new u.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(L=>L.factory!==b),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(N)})}registerDebugAdapterTrackerFactory(R,p){if(!p)return new u.Disposable(()=>{});const b=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:R,handle:b,factory:p}),new u.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(N=>N.factory!==p)})}async $runInTerminal(R,p){return Promise.resolve(void 0)}async $substituteVariables(R,p){let b;const N=await this.getFolder(R);return N&&(b={uri:N.uri,name:N.name,index:N.index,toResource:()=>{throw new Error("Not implemented")}}),(await this._variableResolver.getResolver()).resolveAnyAsync(b,p)}createDebugAdapter(R,p){if(R.type==="implementation")return new y(R.implementation)}createSignService(){}async $startDASession(R,p){const b=this,N=await this.getSession(p);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(N.type),N).then(L=>{if(!L)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${N.type}' (extension might have failed to activate)`);const F=this.convertToDto(L),K=this.createDebugAdapter(F,N);if(!K)throw new Error(`Couldn't create a debug adapter for type '${N.type}'.`);const J=K;return this._debugAdapters.set(R,J),this.getDebugAdapterTrackers(N).then($=>($&&this._debugAdaptersTrackers.set(R,$),J.onMessage(async x=>{if(x.type==="request"&&x.command==="handshake"){const G=x,Y={type:"response",seq:0,command:G.command,request_seq:G.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const ae=await this._signService.sign(G.arguments.value);Y.body={signature:ae},J.sendResponse(Y)}else throw new Error("no signer")}catch(ae){Y.success=!1,Y.message=ae.message,J.sendResponse(Y)}}else $&&$.onDidSendMessage&&$.onDidSendMessage(x),x=(0,a.convertToVSCPaths)(x,!0),b._debugServiceProxy.$acceptDAMessage(R,x)}),J.onError(x=>{$&&$.onError&&$.onError(x),this._debugServiceProxy.$acceptDAError(R,x.name,x.message,x.stack)}),J.onExit(x=>{$&&$.onExit&&$.onExit(x??void 0,void 0),this._debugServiceProxy.$acceptDAExit(R,x??void 0,void 0)}),$&&$.onWillStartSession&&$.onWillStartSession(),J.startSession()))})}$sendDAMessage(R,p){p=(0,a.convertToDAPaths)(p,!1);const b=this._debugAdaptersTrackers.get(R);b&&b.onWillReceiveMessage&&b.onWillReceiveMessage(p),this._debugAdapters.get(R)?.sendMessage(p)}$stopDASession(R){const p=this._debugAdaptersTrackers.get(R);this._debugAdaptersTrackers.delete(R),p&&p.onWillStopSession&&p.onWillStopSession();const b=this._debugAdapters.get(R);return this._debugAdapters.delete(R),b?b.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(R){const p=[],b=[],N=[];if(R.added)for(const L of R.added){const F=L.id;if(F&&!this._breakpoints.has(F)){let K;if(L.type==="function")K=new u.FunctionBreakpoint(L.functionName,L.enabled,L.condition,L.hitCondition,L.logMessage,L.mode);else if(L.type==="data")K=new u.DataBreakpoint(L.label,L.dataId,L.canPersist,L.enabled,L.hitCondition,L.condition,L.logMessage,L.mode);else{const J=D.URI.revive(L.uri);K=new u.SourceBreakpoint(new u.Location(J,new u.Position(L.line,L.character)),L.enabled,L.condition,L.hitCondition,L.logMessage,L.mode)}(0,u.setBreakpointId)(K,F),this._breakpoints.set(F,K),p.push(K)}}if(R.removed)for(const L of R.removed){const F=this._breakpoints.get(L);F&&(this._breakpoints.delete(L),b.push(F))}if(R.changed){for(const L of R.changed)if(L.id){const F=this._breakpoints.get(L.id);if(F){if(F instanceof u.FunctionBreakpoint&&L.type==="function"){const K=F;K.enabled=L.enabled,K.condition=L.condition,K.hitCondition=L.hitCondition,K.logMessage=L.logMessage,K.functionName=L.functionName}else if(F instanceof u.SourceBreakpoint&&L.type==="source"){const K=F;K.enabled=L.enabled,K.condition=L.condition,K.hitCondition=L.hitCondition,K.logMessage=L.logMessage,K.location=new u.Location(D.URI.revive(L.uri),new u.Position(L.line,L.character))}N.push(F)}}}this.fireBreakpointChanges(p,b,N)}async $acceptStackFrameFocus(R){let p;if(R){const b=await this.getSession(R.sessionId);R.kind==="thread"?p=new u.DebugThread(b.api,R.threadId):p=new u.DebugStackFrame(b.api,R.threadId,R.frameId)}this._activeStackItem=p,this._onDidChangeActiveStackItem.fire(this._activeStackItem)}$provideDebugConfigurations(R,p,b){return(0,S.asPromise)(async()=>{const N=this.getConfigProviderByHandle(R);if(!N)throw new Error("no DebugConfigurationProvider found");if(!N.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const L=await this.getFolder(p);return N.provideDebugConfigurations(L,b)}).then(N=>{if(!N)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return N})}$resolveDebugConfiguration(R,p,b,N){return(0,S.asPromise)(async()=>{const L=this.getConfigProviderByHandle(R);if(!L)throw new Error("no DebugConfigurationProvider found");if(!L.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const F=await this.getFolder(p);return L.resolveDebugConfiguration(F,b,N)})}$resolveDebugConfigurationWithSubstitutedVariables(R,p,b,N){return(0,S.asPromise)(async()=>{const L=this.getConfigProviderByHandle(R);if(!L)throw new Error("no DebugConfigurationProvider found");if(!L.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const F=await this.getFolder(p);return L.resolveDebugConfigurationWithSubstitutedVariables(F,b,N)})}async $provideDebugAdapter(R,p){const b=this.getAdapterDescriptorFactoryByHandle(R);if(!b)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const N=await this.getSession(p);return this.getAdapterDescriptor(b,N).then(L=>{if(!L)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${N.type}'`);return this.convertToDto(L)})}async $acceptDebugSessionStarted(R){const p=await this.getSession(R);this._onDidStartDebugSession.fire(p.api)}async $acceptDebugSessionTerminated(R){const p=await this.getSession(R);p&&(this._onDidTerminateDebugSession.fire(p.api),this._debugSessions.delete(p.id))}async $acceptDebugSessionActiveChanged(R){this._activeDebugSession=R?await this.getSession(R):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession?.api)}async $acceptDebugSessionNameChanged(R,p){(await this.getSession(R))?._acceptNameChanged(p)}async $acceptDebugSessionCustomEvent(R,p){const N={session:(await this.getSession(R)).api,event:p.event,body:p.body};this._onDidReceiveDebugSessionCustomEvent.fire(N)}convertToDto(R){if(R instanceof u.DebugAdapterExecutable)return{type:"executable",command:R.command,args:R.args,options:R.options};if(R instanceof u.DebugAdapterServer)return{type:"server",port:R.port,host:R.host};if(R instanceof u.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:R.path};if(R instanceof u.DebugAdapterInlineImplementation)return{type:"implementation",implementation:R.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(R){const p=this._adapterFactories.filter(b=>b.type===R);if(p.length>0)return p[0].factory}getAdapterDescriptorFactoryByHandle(R){const p=this._adapterFactories.filter(b=>b.handle===R);if(p.length>0)return p[0].factory}getConfigProviderByHandle(R){const p=this._configProviders.filter(b=>b.handle===R);if(p.length>0)return p[0].provider}definesDebugType(R,p){if(R.contributes){const b=R.contributes.debuggers;if(b&&b.length>0){for(const N of b)if(N.label&&N.type&&N.type===p)return!0}}return!1}getDebugAdapterTrackers(R){const b=R.configuration.type,N=this._trackerFactories.filter(L=>L.type===b||L.type==="*").map(L=>(0,S.asPromise)(()=>L.factory.createDebugAdapterTracker(R.api)).then(F=>F,F=>null));return Promise.race([Promise.all(N).then(L=>{const F=(0,o.coalesce)(L);if(F.length>0)return new _(F)}),new Promise(L=>setTimeout(()=>L(void 0),1e3))]).catch(L=>{})}async getAdapterDescriptor(R,p){const b=p.configuration.debugServer;if(typeof b=="number")return Promise.resolve(new u.DebugAdapterServer(b));if(R){const L=await this._extensionService.getExtensionRegistry();return(0,S.asPromise)(()=>R.createDebugAdapterDescriptor(p.api,this.daExecutableFromPackage(p,L))).then(F=>{if(F)return F})}const N=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(p,N))}daExecutableFromPackage(R,p){}fireBreakpointChanges(R,p,b){(R.length>0||p.length>0||b.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:R,removed:p,changed:b}))}async getSession(R){if(R)if(typeof R=="string"){const p=this._debugSessions.get(R);if(p)return p}else{let p=this._debugSessions.get(R.id);if(!p){const b=await this.getFolder(R.folderUri),N=R.parent?this._debugSessions.get(R.parent):void 0;p=new f(this._debugServiceProxy,R.id,R.type,R.name,b,R.configuration,N?.api),this._debugSessions.set(p.id,p),this._debugServiceProxy.$sessionCached(p.id)}return p}throw new Error("cannot find session")}getFolder(R){if(R){const p=D.URI.revive(R);return this._workspaceService.resolveWorkspaceFolder(p)}return Promise.resolve(void 0)}extensionVisKey(R,p){return`${R}\0${p}`}serializeVisualization(R,p){if(p){if("title"in p&&"command"in p)return{type:r.DebugVisualizationType.Command};if("treeId"in p)return{type:r.DebugVisualizationType.Tree,id:`${R}\0${p.treeId}`};throw new Error("Unsupported debug visualization type")}}getIconPathOrClass(R){const p=this.getIconUris(R);let b,N;return"id"in p?N=i.ThemeIcon.asClassName(p):b=p,{iconPath:b,iconClass:N}}getIconUris(R){if(R instanceof u.ThemeIcon)return{id:R.id};const p=typeof R=="object"&&"dark"in R?R.dark:R,b=typeof R=="object"&&"light"in R?R.light:R;return{dark:typeof p=="string"?D.URI.file(p):p,light:typeof b=="string"?D.URI.file(b):b}}};e.ExtHostDebugServiceBase=g,e.ExtHostDebugServiceBase=g=qe([We(0,E.IExtHostRpcService),We(1,C.IExtHostWorkspace),We(2,I.IExtHostExtensionService),We(3,d.IExtHostConfiguration),We(4,s.IExtHostEditorTabs),We(5,l.IExtHostVariableResolverProvider),We(6,n.IExtHostCommands),We(7,c.IExtHostTesting)],g);class f{constructor(R,p,b,N,L,F,K){this._debugServiceProxy=R,this._id=p,this._type=b,this._name=N,this._workspaceFolder=L,this._configuration=F,this._parentSession=K}get api(){const R=this;return this.apiSession??=Object.freeze({id:R._id,type:R._type,get name(){return R._name},set name(p){R._name=p,R._debugServiceProxy.$setDebugSessionName(R._id,p)},parentSession:R._parentSession,workspaceFolder:R._workspaceFolder,configuration:R._configuration,customRequest(p,b){return R._debugServiceProxy.$customDebugAdapterRequest(R._id,p,b)},getDebugProtocolBreakpoint(p){return R._debugServiceProxy.$getDebugProtocolBreakpoint(R._id,p.id)}})}get id(){return this._id}get type(){return this._type}_acceptNameChanged(R){this._name=R}get configuration(){return this._configuration}}e.ExtHostDebugSession=f;class h{constructor(R){this.value=Object.freeze({append(p){R.$appendDebugConsole(p)},appendLine(p){this.append(p+`
`)}})}}e.ExtHostDebugConsole=h;class _{constructor(R){this.trackers=R}onWillStartSession(){this.trackers.forEach(R=>R.onWillStartSession?R.onWillStartSession():void 0)}onWillReceiveMessage(R){this.trackers.forEach(p=>p.onWillReceiveMessage?p.onWillReceiveMessage(R):void 0)}onDidSendMessage(R){this.trackers.forEach(p=>p.onDidSendMessage?p.onDidSendMessage(R):void 0)}onWillStopSession(){this.trackers.forEach(R=>R.onWillStopSession?R.onWillStopSession():void 0)}onError(R){this.trackers.forEach(p=>p.onError?p.onError(R):void 0)}onExit(R,p){this.trackers.forEach(b=>b.onExit?b.onExit(R,p):void 0)}}class y extends v.AbstractDebugAdapter{constructor(R){super(),this.implementation=R,R.onDidSendMessage(p=>{this.acceptMessage(p)})}startSession(){return Promise.resolve(void 0)}sendMessage(R){this.implementation.handleMessage(R)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let w=class extends g{constructor(R,p,b,N,L,F,K,J){super(R,p,b,N,L,F,K,J)}};e.WorkerExtHostDebugService=w,e.WorkerExtHostDebugService=w=qe([We(0,E.IExtHostRpcService),We(1,C.IExtHostWorkspace),We(2,I.IExtHostExtensionService),We(3,d.IExtHostConfiguration),We(4,s.IExtHostEditorTabs),We(5,l.IExtHostVariableResolverProvider),We(6,n.IExtHostCommands),We(7,c.IExtHostTesting)],w)}),define(ke[273],Re([1,0,12,64,2,5,224,11,60,75,26,171,16,65,47,66]),function(Ee,e,S,T,D,O,k,A,m,s,I,E,u,C,v,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=e.ErrorHandler=void 0,S=Ve(S),T=Ve(T);class a{static async installEarlyHandler(i){Error.stackTraceLimit=100;const n=i.get(A.ILogService),o=i.get(u.IExtHostRpcService).getProxy(O.MainContext.MainThreadErrors);S.setUnexpectedErrorHandler(c=>{n.error(c);const g=S.transformErrorForSerialization(c);o.$onUnexpectedError(g)})}static async installFullHandler(i){const n=i.get(A.ILogService),t=i.get(u.IExtHostRpcService),o=i.get(v.IExtHostExtensionService),c=i.get(r.IExtHostTelemetry),g=t.getProxy(O.MainContext.MainThreadExtensionService),f=t.getProxy(O.MainContext.MainThreadErrors),h=await o.getExtensionPathIndex(),_=new WeakMap;function y(R,p){if(_.has(R))return _.get(R).stack;let b="",N,L;for(const K of p)b+=`
	at ${K.toString()}`,L=K.getFileName(),!N&&L&&(N=h.findSubstr(D.URI.file(L)));const F=`${R.name||"Error"}: ${R.message||""}${b}`;return _.set(R,{extensionIdentifier:N?.identifier,stack:F}),F}const w=Symbol("prepareStackTrace wrapped");let P=y;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return P},set(R){if(R===y||!R||R[w]){P=R||y;return}P=function(p,b){return y(p,b),R.call(Error,p,b)},Object.assign(P,{[w]:!0})}}),S.setUnexpectedErrorHandler(R=>{n.error(R);const p=S.transformErrorForSerialization(R),b=_.get(R);if(!b?.extensionIdentifier){f.$onUnexpectedError(p);return}g.$onExtensionRuntimeError(b.extensionIdentifier,p);const N=c.onExtensionError(b.extensionIdentifier,R);n.trace("forwarded error to extension?",N,b)})}}e.ErrorHandler=a;class d{constructor(i,n,t,o,c){this._hostUtils=t,this._rpcProtocol=new k.RPCProtocol(i,null,o),n=d._transform(n,this._rpcProtocol);const g=new s.ServiceCollection(...(0,m.getSingletonServiceDescriptors)());g.set(I.IExtHostInitDataService,{_serviceBrand:void 0,...n,messagePorts:c}),g.set(u.IExtHostRpcService,new u.ExtHostRpcService(this._rpcProtocol)),g.set(C.IURITransformerService,new C.URITransformerService(o)),g.set(v.IHostUtils,t);const f=new E.InstantiationService(g,!0);f.invokeFunction(a.installEarlyHandler),this._logService=f.invokeFunction(h=>h.get(A.ILogService)),T.mark("code/extHost/didCreateServices"),this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} started`):this._logService.info("Extension host started"),this._logService.trace("initData",n),this._extensionService=f.invokeFunction(h=>h.get(v.IExtHostExtensionService)),this._extensionService.initialize(),f.invokeFunction(a.installFullHandler)}async asBrowserUri(i){const n=this._rpcProtocol.getProxy(O.MainContext.MainThreadExtensionService);return D.URI.revive(await n.$asBrowserUri(i))}terminate(i){this._extensionService.terminate(i)}static _transform(i,n){i.extensions.allExtensions.forEach(o=>{o.extensionLocation=D.URI.revive(n.transformIncomingURIs(o.extensionLocation))}),i.environment.appRoot=D.URI.revive(n.transformIncomingURIs(i.environment.appRoot));const t=i.environment.extensionDevelopmentLocationURI;return t&&(i.environment.extensionDevelopmentLocationURI=t.map(o=>D.URI.revive(n.transformIncomingURIs(o)))),i.environment.extensionTestsLocationURI=D.URI.revive(n.transformIncomingURIs(i.environment.extensionTestsLocationURI)),i.environment.globalStorageHome=D.URI.revive(n.transformIncomingURIs(i.environment.globalStorageHome)),i.environment.workspaceStorageHome=D.URI.revive(n.transformIncomingURIs(i.environment.workspaceStorageHome)),i.environment.extensionTelemetryLogResource=D.URI.revive(n.transformIncomingURIs(i.environment.extensionTelemetryLogResource)),i.nlsBaseUrl=D.URI.revive(n.transformIncomingURIs(i.nlsBaseUrl)),i.logsLocation=D.URI.revive(n.transformIncomingURIs(i.logsLocation)),i.workspace=n.transformIncomingURIs(i.workspace),i}}e.ExtensionHostMain=d}),define(ke[135],Re([1,0,17,40,58]),function(Ee,e,S,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OldAITextSearchProviderConverter=e.OldTextSearchProviderConverter=e.OldFileSearchProviderConverter=void 0,e.newToOldPreviewOptions=s,e.oldToNewTextSearchResult=I,e.extensionResultIsMatch=v;function O(r){return"uri"in r&&"ranges"in r&&"preview"in r}function k(r){return r.folderOptions.map(a=>({folder:a.folder,excludes:a.excludes.map(d=>typeof d=="string"?d:d.pattern),includes:a.includes,useGlobalIgnoreFiles:a.useIgnoreFiles.global,useIgnoreFiles:a.useIgnoreFiles.local,useParentIgnoreFiles:a.useIgnoreFiles.parent,followSymlinks:a.followSymlinks,maxResults:r.maxResults,session:r.session}))}class A{constructor(a){this.provider=a}provideFileSearchResults(a,d,l){return(async()=>{const n=k(d);return Promise.all(n.map(t=>this.provider.provideFileSearchResults({pattern:a},t,l)))})().then(n=>(0,S.coalesce)(n).flat())}}e.OldFileSearchProviderConverter=A;function m(r){return r.folderOptions.map(a=>({folder:a.folder,excludes:a.excludes.map(d=>typeof d=="string"?d:d.pattern),includes:a.includes,useGlobalIgnoreFiles:a.useIgnoreFiles.global,useIgnoreFiles:a.useIgnoreFiles.local,useParentIgnoreFiles:a.useIgnoreFiles.parent,followSymlinks:a.followSymlinks,maxResults:r.maxResults,previewOptions:s(r.previewOptions),maxFileSize:r.maxFileSize,encoding:a.encoding,afterContext:r.surroundingContext,beforeContext:r.surroundingContext}))}function s(r){return{matchLines:r?.matchLines??T.DEFAULT_TEXT_SEARCH_PREVIEW_OPTIONS.matchLines,charsPerLine:r?.charsPerLine??T.DEFAULT_TEXT_SEARCH_PREVIEW_OPTIONS.charsPerLine}}function I(r){if(O(r)){const a=(0,S.asArray)(r.ranges).map((d,l)=>{const n=(0,S.asArray)(r.preview.matches)[l];return{sourceRange:d,previewRange:n}});return new D.TextSearchMatchNew(r.uri,a,r.preview.text)}else return new D.TextSearchContextNew(r.uri,r.text,r.lineNumber)}class E{constructor(a){this.provider=a}provideTextSearchResults(a,d,l,i){const n=c=>{C(c)&&l.report(I(c))};return(async()=>(0,S.coalesce)(await Promise.all(m(d).map(c=>this.provider.provideTextSearchResults(a,c,{report:g=>n(g)},i)))).reduce((c,g)=>({limitHit:c.limitHit||g.limitHit}),{limitHit:!1}))().then(c=>({limitHit:c.limitHit,message:(0,S.coalesce)((0,S.asArray)(c.message))}))}}e.OldTextSearchProviderConverter=E;class u{constructor(a){this.provider=a}provideAITextSearchResults(a,d,l,i){const n=c=>{C(c)&&l.report(I(c))};return(async()=>(0,S.coalesce)(await Promise.all(m(d).map(c=>this.provider.provideAITextSearchResults(a,c,{report:g=>n(g)},i)))).reduce((c,g)=>({limitHit:c.limitHit||g.limitHit}),{limitHit:!1}))().then(c=>({limitHit:c.limitHit,message:(0,S.coalesce)((0,S.asArray)(c.message))}))}}e.OldAITextSearchProviderConverter=u;function C(r){if(v(r)){if(Array.isArray(r.ranges)){if(!Array.isArray(r.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(r.preview.matches.length!==r.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(r.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}function v(r){return!!r.preview}}),define(ke[274],Re([1,0,22,19,42,43,24,69,40,48,4,135]),function(Ee,e,S,T,D,O,k,A,m,s,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0,S=Ve(S),O=Ve(O),k=Ve(k);class u{constructor(a,d,l){this.config=a,this.provider=d,this.sessionLifecycle=l,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=a.filePattern,this.includePattern=a.includePattern&&O.parse(a.includePattern),this.maxResults=a.maxResults||void 0,this.exists=a.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=a.excludePattern&&O.parse(a.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(a=>a.cancel()),this.activeCancellationTokens=new Set}search(a){const d=this.config.folderQueries||[];return new Promise((l,i)=>{const n=t=>{this.resultCount++,a(t)};if(this.isCanceled)return l({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(t=>{const o=t.toString(),c=S.basename(o);this.globalExcludePattern&&this.globalExcludePattern(o,c)||this.matchFile(n,{base:t,basename:c})}),this.doSearch(d,n).then(t=>{l({limitHit:this.isLimitHit,stats:t||void 0})},t=>{i(new Error((0,D.toErrorMessage)(t)))})})}async doSearch(a,d){const l=new T.CancellationTokenSource,i=a.map(g=>this.getSearchOptionsForFolder(g)),n=this.provider instanceof E.OldFileSearchProviderConverter?this.sessionLifecycle?.tokenSource.token:this.sessionLifecycle?.obj,t={folderOptions:i,maxResults:this.config.maxResults??m.DEFAULT_MAX_SEARCH_RESULTS,session:n},o=s.TernarySearchTree.forUris();a.forEach(g=>{const f=new m.QueryGlobTester(this.config,g),h=!f.hasSiblingExcludeClauses();o.set(g.folder,{queryTester:f,noSiblingsClauses:h,folder:g.folder,tree:this.initDirectoryTree()})});let c;try{this.activeCancellationTokens.add(l),c=A.StopWatch.create();const g=await this.provider.provideFileSearchResults(this.config.filePattern||"",t,l.token),f=c.elapsed(),h=A.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(g&&g.forEach(_=>{const y=o.findSubstr(_),w=S.posix.relative(y.folder.path,_.path);if(y.noSiblingsClauses){const P=S.basename(_.path);this.matchFile(d,{base:y.folder,relativePath:w,basename:P});return}this.addDirectoryEntries(y.tree,y.folder,w,d)}),this.isCanceled&&!this.isLimitHit)?null:(o.forEach(_=>{this.matchDirectoryTree(_.tree,_.queryTester,d)}),{providerTime:f,postProcessTime:h.elapsed()})}finally{l.dispose(),this.activeCancellationTokens.delete(l)}}getSearchOptionsForFolder(a){const d=(0,m.resolvePatternsForProvider)(this.config.includePattern,a.includePattern);let l=a.excludePattern?.map(n=>({folder:n.folder,patterns:(0,m.resolvePatternsForProvider)(this.config.excludePattern,n.pattern)}));l?.length||(l=[{folder:void 0,patterns:(0,m.resolvePatternsForProvider)(this.config.excludePattern,void 0)}]);const i=(0,m.excludeToGlobPattern)(l);return{folder:a.folder,excludes:i,includes:d,useIgnoreFiles:{local:!a.disregardIgnoreFiles,parent:!a.disregardParentIgnoreFiles,global:!a.disregardGlobalIgnoreFiles},followSymlinks:!a.ignoreSymlinks}}initDirectoryTree(){const a={rootEntries:[],pathToEntries:Object.create(null)};return a.pathToEntries["."]=a.rootEntries,a}addDirectoryEntries({pathToEntries:a},d,l,i){if(l===this.filePattern){const t=S.basename(this.filePattern);this.matchFile(i,{base:d,relativePath:this.filePattern,basename:t})}function n(t){const o=S.basename(t),c=S.dirname(t);let g=a[c];g||(g=a[c]=[],n(c)),g.push({base:d,relativePath:t,basename:o})}n(l)}matchDirectoryTree({rootEntries:a,pathToEntries:d},l,i){const n=this,t=this.filePattern;function o(c){const g=(0,m.hasSiblingFn)(()=>c.map(f=>f.basename));for(let f=0,h=c.length;f<h;f++){const _=c[f],{relativePath:y,basename:w}=_;if(l.matchesExcludesSync(y,w,t!==w?g:void 0))continue;const P=d[y];if(P)o(P);else{if(y===t)continue;n.matchFile(i,_)}if(n.isLimitHit)break}}o(a)}matchFile(a,d){(!this.includePattern||d.relativePath&&this.includePattern(d.relativePath,d.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||a(d))}}class C extends I.Disposable{constructor(){super(),this.obj=new Object,this.tokenSource=new T.CancellationTokenSource}dispose(){this.tokenSource.cancel(),super.dispose()}}class v{constructor(){this.sessions=new Map}static{this.BATCH_SIZE=512}fileSearch(a,d,l,i){const n=this.getSessionTokenSource(a.cacheKey),t=new u(a,d,n);let o=0;const c=g=>{o+=g.length,l(g.map(f=>this.rawMatchToSearchItem(f)))};return this.doSearch(t,v.BATCH_SIZE,c,i).then(g=>({limitHit:g.limitHit,stats:g.stats?{fromCache:!1,type:"fileSearchProvider",resultCount:o,detailStats:g.stats}:void 0,messages:[]}))}clearCache(a){this.sessions.get(a)?.dispose(),this.sessions.delete(a)}getSessionTokenSource(a){if(a)return this.sessions.has(a)||this.sessions.set(a,new C),this.sessions.get(a)}rawMatchToSearchItem(a){return a.relativePath?{resource:k.joinPath(a.base,a.relativePath)}:{resource:a.base}}doSearch(a,d,l,i){const n=i.onCancellationRequested(()=>{a.cancel()}),t=c=>{c&&(o.push(c),d>0&&o.length>=d&&(l(o),o=[]))};let o=[];return a.search(t).then(c=>(o.length&&l(o),n.dispose(),c),c=>(o.length&&l(o),n.dispose(),Promise.reject(c)))}}e.FileSearchManager=v}),define(ke[275],Re([1,0,10,19,42,15,22,24,48,2,40,58]),function(Ee,e,S,T,D,O,k,A,m,s,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.TextSearchResultsCollector=e.TextSearchManager=void 0,k=Ve(k),A=Ve(A);class u{constructor(l,i,n){this.queryProviderPair=l,this.fileUtils=i,this.processType=n,this.collector=null,this.isLimitHit=!1,this.resultCount=0}get query(){return this.queryProviderPair.query}search(l,i){const n=this.query.folderQueries||[],t=new T.CancellationTokenSource(i);return new Promise((o,c)=>{this.collector=new v(l);let g=!1;const f=(h,_)=>{if(!g&&!this.isLimitHit){const y=this.resultSize(h);h instanceof E.TextSearchMatchNew&&typeof this.query.maxResults=="number"&&this.resultCount+y>this.query.maxResults&&(this.isLimitHit=!0,g=!0,t.cancel(),h=this.trimResultToSize(h,this.query.maxResults-this.resultCount));const w=this.resultSize(h);this.resultCount+=w;const P=h instanceof E.TextSearchMatchNew;(w>0||!P)&&this.collector.add(h,_)}};this.doSearch(n,f,t.token).then(h=>{t.dispose(),this.collector.flush(),o({limitHit:this.isLimitHit||h?.limitHit,messages:this.getMessagesFromResults(h),stats:{type:this.processType}})},h=>{t.dispose();const _=(0,D.toErrorMessage)(h);c(new Error(_))})})}getMessagesFromResults(l){return l?.message?Array.isArray(l.message)?l.message:[l.message]:[]}resultSize(l){return l instanceof E.TextSearchMatchNew?Array.isArray(l.ranges)?l.ranges.length:1:0}trimResultToSize(l,i){return new E.TextSearchMatchNew(l.uri,l.ranges.slice(0,i),l.previewText)}async doSearch(l,i,n){const t=m.TernarySearchTree.forUris();l.forEach((_,y)=>{const w=new I.QueryGlobTester(this.query,_);t.set(_.folder,{queryTester:w,folder:_.folder,folderIdx:y})});const o=[],c={report:_=>{if(_.uri===void 0)throw Error("Text search result URI is undefined. Please check provider implementation.");const y=t.findSubstr(_.uri),w=y.folder.scheme===O.Schemas.file?(0,I.hasSiblingPromiseFn)(()=>this.fileUtils.readdir(A.dirname(_.uri))):void 0,P=A.relativePath(y.folder,_.uri);if(P){const R=y.queryTester.includedInQuery(P,k.basename(P),w);(0,S.isThenable)(R)?o.push(R.then(p=>{p&&i(_,y.folderIdx)})):R&&i(_,y.folderIdx)}}},f={folderOptions:l.map(_=>this.getSearchOptionsForFolder(_)),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults??I.DEFAULT_MAX_SEARCH_RESULTS,previewOptions:this.query.previewOptions??I.DEFAULT_TEXT_SEARCH_PREVIEW_OPTIONS,surroundingContext:this.query.surroundingContext??0};"usePCRE2"in this.query&&(f.usePCRE2=this.query.usePCRE2);let h;return this.queryProviderPair.query.type===I.QueryType.aiText?h=await this.queryProviderPair.provider.provideAITextSearchResults(this.queryProviderPair.query.contentPattern,f,c,n):h=await this.queryProviderPair.provider.provideTextSearchResults(C(this.queryProviderPair.query.contentPattern),f,c,n),o.length&&await Promise.all(o),h}getSearchOptionsForFolder(l){const i=(0,I.resolvePatternsForProvider)(this.query.includePattern,l.includePattern);let n=l.excludePattern?.map(c=>({folder:c.folder,patterns:(0,I.resolvePatternsForProvider)(this.query.excludePattern,c.pattern)}));(!n||n.length===0)&&(n=[{folder:void 0,patterns:(0,I.resolvePatternsForProvider)(this.query.excludePattern,void 0)}]);const t=(0,I.excludeToGlobPattern)(n);return{folder:s.URI.from(l.folder),excludes:t,includes:i,useIgnoreFiles:{local:!l.disregardIgnoreFiles,parent:!l.disregardParentIgnoreFiles,global:!l.disregardGlobalIgnoreFiles},followSymlinks:!l.ignoreSymlinks,encoding:(l.fileEncoding&&this.fileUtils.toCanonicalName(l.fileEncoding))??""}}}e.TextSearchManager=u;function C(d){return{isCaseSensitive:d.isCaseSensitive||!1,isRegExp:d.isRegExp||!1,isWordMatch:d.isWordMatch||!1,isMultiline:d.isMultiline||!1,pattern:d.pattern}}class v{constructor(l){this._onResult=l,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new a(512,i=>this.sendItems(i))}add(l,i){this._currentFileMatch&&(this._currentFolderIdx!==i||!A.isEqual(this._currentUri,l.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=i,this._currentFileMatch={resource:l.uri,results:[]}),this._currentFileMatch.results.push(r(l))}pushToCollector(){const l=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,l)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(l){this._onResult(l)}}e.TextSearchResultsCollector=v;function r(d){return d instanceof E.TextSearchMatchNew?{previewText:d.previewText,rangeLocations:d.ranges.map(l=>({preview:{startLineNumber:l.previewRange.start.line,startColumn:l.previewRange.start.character,endLineNumber:l.previewRange.end.line,endColumn:l.previewRange.end.character},source:{startLineNumber:l.sourceRange.start.line,startColumn:l.sourceRange.start.character,endLineNumber:l.sourceRange.end.line,endColumn:l.sourceRange.end.character}}))}:{text:d.text,lineNumber:d.lineNumber}}class a{static{this.TIMEOUT=4e3}static{this.START_BATCH_AFTER_COUNT=50}constructor(l,i){this.maxBatchSize=l,this.cb=i,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(l,i){l&&this.addItemToBatch(l,i)}addItems(l,i){l&&this.addItemsToBatch(l,i)}addItemToBatch(l,i){this.batch.push(l),this.batchSize+=i,this.onUpdate()}addItemsToBatch(l,i){this.batch=this.batch.concat(l),this.batchSize+=i,this.onUpdate()}onUpdate(){this.totalNumberCompleted<a.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},a.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=a}),define(ke[136],Re([1,0,4,5,3,274,16,65,11,2,275,34,135]),function(Ee,e,S,T,D,O,k,A,m,s,I,E,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSearch=e.IExtHostSearch=void 0,e.reviveQuery=v,e.IExtHostSearch=(0,D.createDecorator)("IExtHostSearch");let C=class{constructor(d,l,i){this.extHostRpc=d,this._uriTransformer=l,this._logService=i,this._proxy=this.extHostRpc.getProxy(T.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._aiTextSearchProvider=new Map,this._aiTextSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new O.FileSearchManager}_transformScheme(d){return this._uriTransformer.transformOutgoingScheme(d)}registerTextSearchProviderOld(d,l){if(this._textSearchUsedSchemes.has(d))throw new Error(`a text search provider for the scheme '${d}' is already registered`);this._textSearchUsedSchemes.add(d);const i=this._handlePool++;return this._textSearchProvider.set(i,new u.OldTextSearchProviderConverter(l)),this._proxy.$registerTextSearchProvider(i,this._transformScheme(d)),(0,S.toDisposable)(()=>{this._textSearchUsedSchemes.delete(d),this._textSearchProvider.delete(i),this._proxy.$unregisterProvider(i)})}registerTextSearchProvider(d,l){if(this._textSearchUsedSchemes.has(d))throw new Error(`a text search provider for the scheme '${d}' is already registered`);this._textSearchUsedSchemes.add(d);const i=this._handlePool++;return this._textSearchProvider.set(i,l),this._proxy.$registerTextSearchProvider(i,this._transformScheme(d)),(0,S.toDisposable)(()=>{this._textSearchUsedSchemes.delete(d),this._textSearchProvider.delete(i),this._proxy.$unregisterProvider(i)})}registerAITextSearchProviderOld(d,l){if(this._aiTextSearchUsedSchemes.has(d))throw new Error(`an AI text search provider for the scheme '${d}'is already registered`);this._aiTextSearchUsedSchemes.add(d);const i=this._handlePool++;return this._aiTextSearchProvider.set(i,new u.OldAITextSearchProviderConverter(l)),this._proxy.$registerAITextSearchProvider(i,this._transformScheme(d)),(0,S.toDisposable)(()=>{this._aiTextSearchUsedSchemes.delete(d),this._aiTextSearchProvider.delete(i),this._proxy.$unregisterProvider(i)})}registerAITextSearchProvider(d,l){if(this._aiTextSearchUsedSchemes.has(d))throw new Error(`an AI text search provider for the scheme '${d}'is already registered`);this._aiTextSearchUsedSchemes.add(d);const i=this._handlePool++;return this._aiTextSearchProvider.set(i,l),this._proxy.$registerAITextSearchProvider(i,this._transformScheme(d)),(0,S.toDisposable)(()=>{this._aiTextSearchUsedSchemes.delete(d),this._aiTextSearchProvider.delete(i),this._proxy.$unregisterProvider(i)})}registerFileSearchProviderOld(d,l){if(this._fileSearchUsedSchemes.has(d))throw new Error(`a file search provider for the scheme '${d}' is already registered`);this._fileSearchUsedSchemes.add(d);const i=this._handlePool++;return this._fileSearchProvider.set(i,new u.OldFileSearchProviderConverter(l)),this._proxy.$registerFileSearchProvider(i,this._transformScheme(d)),(0,S.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(d),this._fileSearchProvider.delete(i),this._proxy.$unregisterProvider(i)})}registerFileSearchProvider(d,l){if(this._fileSearchUsedSchemes.has(d))throw new Error(`a file search provider for the scheme '${d}' is already registered`);this._fileSearchUsedSchemes.add(d);const i=this._handlePool++;return this._fileSearchProvider.set(i,l),this._proxy.$registerFileSearchProvider(i,this._transformScheme(d)),(0,S.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(d),this._fileSearchProvider.delete(i),this._proxy.$unregisterProvider(i)})}$provideFileSearchResults(d,l,i,n){const t=v(i),o=this._fileSearchProvider.get(d);if(o)return this._fileSearchManager.fileSearch(t,o,c=>{this._proxy.$handleFileMatch(d,l,c.map(g=>g.resource))},n);throw new Error("unknown provider: "+d)}async doInternalFileSearchWithCustomCallback(d,l,i){return{messages:[]}}$clearCache(d){return this._fileSearchManager.clearCache(d),Promise.resolve(void 0)}$provideTextSearchResults(d,l,i,n){const t=this._textSearchProvider.get(d);if(!t||!t.provideTextSearchResults)throw new Error(`Unknown Text Search Provider ${d}`);const o=v(i);return this.createTextSearchManager(o,t).search(g=>this._proxy.$handleTextMatch(d,l,g),n)}$provideAITextSearchResults(d,l,i,n){const t=this._aiTextSearchProvider.get(d);if(!t||!t.provideAITextSearchResults)throw new Error(`Unknown AI Text Search Provider ${d}`);const o=v(i);return this.createAITextSearchManager(o,t).search(g=>this._proxy.$handleTextMatch(d,l,g),n)}$enableExtensionHostSearch(){}createTextSearchManager(d,l){return new I.TextSearchManager({query:d,provider:l},{readdir:i=>Promise.resolve([]),toCanonicalName:i=>i},"textSearchProvider")}createAITextSearchManager(d,l){return new I.TextSearchManager({query:d,provider:l},{readdir:i=>Promise.resolve([]),toCanonicalName:i=>i},"aiTextSearchProvider")}};e.ExtHostSearch=C,e.ExtHostSearch=C=qe([We(0,k.IExtHostRpcService),We(1,A.IURITransformerService),We(2,m.ILogService)],C);function v(a){return{...a,folderQueries:a.folderQueries&&a.folderQueries.map(r),extraFileResources:a.extraFileResources&&a.extraFileResources.map(d=>s.URI.revive(d))}}function r(a){return(0,E.revive)(a)}});var oi=this&&this.__importDefault||function(Ee){return Ee&&Ee.__esModule?Ee:{default:Ee}};define(ke[276],Re([1,0,19,12,6,4,15,37,2,106,164,153,52,18,28,11,62,63,185,5,227,256,85,91,232,233,234,211,201,35,235,46,236,134,124,237,213,228,238,239,57,70,214,229,47,241,68,242,50,26,257,215,243,244,95,245,86,87,217,269,247,190,248,258,249,130,218,250,251,252,16,253,136,88,254,219,255,89,92,132,66,56,128,96,259,230,260,261,93,8,7,220,65,221,67,262,263,123,45,81,84,21,58]),function(Ee,e,S,T,D,O,k,A,m,s,I,E,u,C,v,r,a,d,l,i,n,t,o,c,g,f,h,_,y,w,P,R,p,b,N,L,F,K,J,$,x,G,Y,ae,ee,oe,ie,ue,Z,ve,Ie,X,V,re,be,De,Fe,ze,Je,nt,dt,vt,ut,et,Oe,Me,Ne,B,z,H,q,se,ge,ye,Ue,Ge,Ze,tt,lt,it,at,wt,Qe,de,pe,we,Pe,fe,Se,Q,W,he,$e,He,st,ht,mt,Rt,At,Ht,Zt,Xe,Lt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=xt,T=Ve(T),A=oi(A),E=Ve(E),v=Ve(v),Q=Ve(Q),W=Ve(W);function xt(Et){const Tt=Et.get(ve.IExtHostInitDataService),ei=Et.get(Z.IExtHostFileSystemInfo),ti=Et.get(ie.IExtHostConsumerFileSystem),qt=Et.get(ee.IExtHostExtensionService),bt=Et.get(At.IExtHostWorkspace),Ot=Et.get(at.IExtHostTelemetry),li=Et.get(R.IExtHostConfiguration),Qt=Et.get($e.IURITransformerService),Ke=Et.get(q.IExtHostRpcService),ii=Et.get(tt.IExtHostStorage),ci=Et.get(lt.IExtensionStoragePaths),di=Et.get(r.ILoggerService),Ct=Et.get(r.ILogService),$t=Et.get(Se.IExtHostTunnelService),Nt=Et.get(o.IExtHostApiDeprecationService),zt=Et.get(Rt.IExtHostWindow),ai=Et.get(ye.IExtHostSecretState),ni=Et.get(G.IExtHostEditorTabs),ri=Et.get(ze.IExtHostManagedSockets),Kt=Et.get(c.IExtHostAuthentication),Gt=Et.get(be.IExtHostLanguageModels);Ke.set(i.ExtHostContext.ExtHostFileSystemInfo,ei),Ke.set(i.ExtHostContext.ExtHostLogLevelServiceShape,di),Ke.set(i.ExtHostContext.ExtHostWorkspace,bt),Ke.set(i.ExtHostContext.ExtHostConfiguration,li),Ke.set(i.ExtHostContext.ExtHostExtensionService,qt),Ke.set(i.ExtHostContext.ExtHostStorage,ii),Ke.set(i.ExtHostContext.ExtHostTunnelService,$t),Ke.set(i.ExtHostContext.ExtHostWindow,zt),Ke.set(i.ExtHostContext.ExtHostSecretState,ai),Ke.set(i.ExtHostContext.ExtHostTelemetry,Ot),Ke.set(i.ExtHostContext.ExtHostEditorTabs,ni),Ke.set(i.ExtHostContext.ExtHostManagedSockets,ri),Ke.set(i.ExtHostContext.ExtHostAuthentication,Kt),Ke.set(i.ExtHostContext.ExtHostChatProvider,Gt);const ui=Ke.set(i.ExtHostContext.ExtHostDecorations,Et.get(N.IExtHostDecorations)),Mt=Ke.set(i.ExtHostContext.ExtHostDocumentsAndEditors,Et.get(x.IExtHostDocumentsAndEditors)),Pt=Ke.set(i.ExtHostContext.ExtHostCommands,Et.get(w.IExtHostCommands)),St=Ke.set(i.ExtHostContext.ExtHostTerminalService,Et.get(wt.IExtHostTerminalService)),Xt=Ke.set(i.ExtHostContext.ExtHostTerminalShellIntegration,Et.get(Qe.IExtHostTerminalShellIntegration)),yt=Ke.set(i.ExtHostContext.ExtHostDebugService,Et.get(b.IExtHostDebugService)),si=Ke.set(i.ExtHostContext.ExtHostSearch,Et.get(ge.IExtHostSearch)),Yt=Ke.set(i.ExtHostContext.ExtHostTask,Et.get(it.IExtHostTask)),Mi=Ke.set(i.ExtHostContext.ExtHostOutputService,Et.get(Me.IExtHostOutputService)),hi=Ke.set(i.ExtHostContext.ExtHostLocalization,Et.get(Fe.IExtHostLocalizationService)),wi=Ke.set(i.ExtHostContext.ExtHostUrls,new He.ExtHostUrls(Ke)),Wt=Ke.set(i.ExtHostContext.ExtHostDocuments,new $.ExtHostDocuments(Ke,Mt)),fi=Ke.set(i.ExtHostContext.ExtHostDocumentContentProviders,new K.ExtHostDocumentContentProvider(Ke,Mt,Ct)),Fi=Ke.set(i.ExtHostContext.ExtHostDocumentSaveParticipant,new J.ExtHostDocumentSaveParticipant(Ct,Wt,Ke.getProxy(i.MainContext.MainThreadBulkEdits))),kt=Ke.set(i.ExtHostContext.ExtHostNotebook,new nt.ExtHostNotebookController(Ke,Pt,Mt,Wt,ti,si,Ct)),_i=Ke.set(i.ExtHostContext.ExtHostNotebookDocuments,new vt.ExtHostNotebookDocuments(kt)),Li=Ke.set(i.ExtHostContext.ExtHostNotebookEditors,new ut.ExtHostNotebookEditors(Ct,kt)),gi=Ke.set(i.ExtHostContext.ExtHostNotebookKernels,new et.ExtHostNotebookKernels(Ke,Tt,kt,Pt,Ct)),Ui=Ke.set(i.ExtHostContext.ExtHostNotebookRenderers,new Oe.ExtHostNotebookRenderers(Ke,kt)),$i=Ke.set(i.ExtHostContext.ExtHostNotebookDocumentSaveParticipant,new dt.ExtHostNotebookDocumentSaveParticipant(Ct,kt,Ke.getProxy(i.MainContext.MainThreadBulkEdits))),Ut=Ke.set(i.ExtHostContext.ExtHostEditors,new pe.ExtHostEditors(Ke,Mt)),Di=Ke.set(i.ExtHostContext.ExtHostTreeViews,new fe.ExtHostTreeViews(Ke.getProxy(i.MainContext.MainThreadTreeViews),Pt,Ct)),Ti=Ke.set(i.ExtHostContext.ExtHostEditorInsets,new y.ExtHostEditorInsets(Ke.getProxy(i.MainContext.MainThreadEditorInsets),Ut,Tt.remote)),Ei=Ke.set(i.ExtHostContext.ExtHostDiagnostics,new L.ExtHostDiagnostics(Ke,Ct,ei,Mt)),bi=Ke.set(i.ExtHostContext.ExtHostLanguages,new De.ExtHostLanguages(Ke,Wt,Pt.converter,Qt)),me=Ke.set(i.ExtHostContext.ExtHostLanguageFeatures,new V.ExtHostLanguageFeatures(Ke,Qt,Wt,Pt,Ei,Ct,Nt,Ot)),Te=Ke.set(i.ExtHostContext.ExtHostFileSystem,new oe.ExtHostFileSystem(Ke,me)),le=Ke.set(i.ExtHostContext.ExtHostFileSystemEventService,new ue.ExtHostFileSystemEventService(Ke,Ct,Mt)),j=Ke.set(i.ExtHostContext.ExtHostQuickOpen,(0,H.createExtHostQuickOpen)(Ke,bt,Pt)),Ce=Ke.set(i.ExtHostContext.ExtHostSCM,new se.ExtHostSCM(Ke,Pt,Wt,Ct)),Be=Ke.set(i.ExtHostContext.ExtHostQuickDiff,new z.ExtHostQuickDiff(Ke,Qt)),Ye=Ke.set(i.ExtHostContext.ExtHostShare,new Ue.ExtHostShare(Ke,Qt)),xe=Ke.set(i.ExtHostContext.ExtHostComments,(0,P.createExtHostComments)(Ke,Pt,Wt)),ot=Ke.set(i.ExtHostContext.ExtHostProgress,new B.ExtHostProgress(Ke.getProxy(i.MainContext.MainThreadProgress))),gt=Ke.set(i.ExtHostContext.ExtHostLabelService,new X.ExtHostLabelService(Ke)),jt=Ke.set(i.ExtHostContext.ExtHostTheming,new we.ExtHostTheming(Ke)),Vt=Ke.set(i.ExtHostContext.ExtHostTimeline,new Pe.ExtHostTimeline(Ke,Pt)),Bt=Ke.set(i.ExtHostContext.ExtHostWebviews,new st.ExtHostWebviews(Ke,Tt.remote,bt,Ct,Nt)),Oi=Ke.set(i.ExtHostContext.ExtHostWebviewPanels,new ht.ExtHostWebviewPanels(Ke,Bt,bt)),en=Ke.set(i.ExtHostContext.ExtHostCustomEditors,new p.ExtHostCustomEditors(Ke,Wt,ci,Bt,Oi)),Vi=Ke.set(i.ExtHostContext.ExtHostWebviewViews,new mt.ExtHostWebviewViews(Ke,Bt)),yi=Ke.set(i.ExtHostContext.ExtHostTesting,Et.get(de.IExtHostTesting)),tn=Ke.set(i.ExtHostContext.ExtHostUriOpeners,new he.ExtHostUriOpeners(Ke)),nn=Ke.set(i.ExtHostContext.ExtHostProfileContentHandlers,new Ne.ExtHostProfileContentHandlers(Ke));Ke.set(i.ExtHostContext.ExtHostInteractive,new Ie.ExtHostInteractive(Ke,kt,Mt,Pt,Ct));const xi=Ke.set(i.ExtHostContext.ExtHostChatAgents2,new f.ExtHostChatAgents2(Ke,Ct,Pt,Wt)),rn=Ke.set(i.ExtHostContext.ExtHostChatVariables,new h.ExtHostChatVariables(Ke)),zi=Ke.set(i.ExtHostContext.ExtHostLanguageModelTools,new re.ExtHostLanguageModelTools(Ke)),Hi=Ke.set(i.ExtHostContext.ExtHostAiRelatedInformation,new n.ExtHostRelatedInformation(Ke)),sn=Ke.set(i.ExtHostContext.ExtHostAiEmbeddingVector,new ae.ExtHostAiEmbeddingVector(Ke)),on=Ke.set(i.ExtHostContext.ExtHostStatusBar,new Ze.ExtHostStatusBar(Ke,Pt.converter)),En=Ke.set(i.ExtHostContext.ExtHostSpeech,new Ge.ExtHostSpeech(Ke)),Pi=Ke.set(i.ExtHostContext.ExtHostEmbeddings,new Y.ExtHostEmbeddings(Ke)),ji=Object.values(i.ExtHostContext);Ke.assertRegistered(ji);const bn=new g.ExtHostBulkEdits(Ke,Mt),Sn=new _.ExtHostClipboard(Ke),Bi=new Je.ExtHostMessageService(Ke,Ct),an=new F.ExtHostDialogs(Ke);return t.ExtHostApiCommands.register(Pt),function(Le,mi,qi){function ct(te){return(ce,Ae,ft)=>{const Dt=te(Ft=>{try{ce.call(Ae,Ft)}catch(Ri){T.onUnexpectedExternalError(new Error(`[ExtensionListenerError] Extension '${Le.identifier.value}' FAILED to handle event: ${Ri.toString()}`,{cause:Ri})),Ot.onExtensionError(Le.identifier,Ri)}});return ft?.push(Dt),Dt}}const It=function(){let te=!Le.isUnderDevelopment;function ce(){te||(Ct.info(`Extension '${Le.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),te=!0)}return function Ae(ft){if(Array.isArray(ft))ft.forEach(Ae);else if(typeof ft=="string")ce();else{const Dt=ft;typeof Dt.scheme>"u"&&ce(),typeof Dt.exclusive=="boolean"&&(0,Xe.checkProposedApiEnabled)(Le,"documentFiltersExclusive")}return ft}}(),wn={getSession(te,ce,Ae){return typeof Ae?.forceNewSession=="object"&&Ae.forceNewSession.learnMore&&(0,Xe.checkProposedApiEnabled)(Le,"authLearnMore"),Kt.getSession(Le,te,ce,Ae)},getAccounts(te){return Kt.getAccounts(te)},async hasSession(te,ce){return(0,Xe.checkProposedApiEnabled)(Le,"authSession"),!!await Kt.getSession(Le,te,ce,{silent:!0})},get onDidChangeSessions(){return ct(Kt.onDidChangeSessions)},registerAuthenticationProvider(te,ce,Ae,ft){return Kt.registerAuthenticationProvider(te,ce,Ae,ft)}},Ki={registerCommand(te,ce,Ae){return Pt.registerCommand(!0,te,ce,Ae,void 0,Le)},registerTextEditorCommand(te,ce,Ae){return Pt.registerCommand(!0,te,(...ft)=>{const Dt=Ut.getActiveTextEditor();if(!Dt){Ct.warn("Cannot execute "+te+" because there is no active text editor.");return}return Dt.edit(Ft=>{ce.apply(Ae,[Dt,Ft,...ft])}).then(Ft=>{Ft||Ct.warn("Edits from command "+te+" were not applied.")},Ft=>{Ct.warn("An error occurred while running command "+te,Ft)})},void 0,void 0,Le)},registerDiffInformationCommand:(te,ce,Ae)=>((0,Xe.checkProposedApiEnabled)(Le,"diffCommand"),Pt.registerCommand(!0,te,async(...ft)=>{const Dt=Mt.activeEditor(!0);if(!Dt){Ct.warn("Cannot execute "+te+" because there is no active text editor.");return}const Ft=await Ut.getDiffInformation(Dt.id);ce.apply(Ae,[Ft,...ft])},void 0,void 0,Le)),executeCommand(te,...ce){return Pt.executeCommand(te,...ce)},getCommands(te=!1){return Pt.getCommands(te)}},Gi={get machineId(){return Tt.telemetryInfo.machineId},get sessionId(){return Tt.telemetryInfo.sessionId},get language(){return Tt.environment.appLanguage},get appName(){return Tt.environment.appName},get appRoot(){return Tt.environment.appRoot?.fsPath??""},get appHost(){return Tt.environment.appHost},get uriScheme(){return Tt.environment.appUriScheme},get clipboard(){return Sn.value},get shell(){return St.getDefaultShell(!1)},get onDidChangeShell(){return ct(St.onDidChangeShell)},get isTelemetryEnabled(){return Ot.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return ct(Ot.onDidChangeTelemetryEnabled)},get telemetryConfiguration(){return(0,Xe.checkProposedApiEnabled)(Le,"telemetry"),Ot.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,Xe.checkProposedApiEnabled)(Le,"telemetry"),ct(Ot.onDidChangeTelemetryConfiguration)},get isNewAppInstall(){return(0,at.isNewAppInstall)(Tt.telemetryInfo.firstSessionDate)},createTelemetryLogger(te,ce){return at.ExtHostTelemetryLogger.validateSender(te),Ot.instantiateLogger(Le,te,ce)},openExternal(te,ce){return zt.openUri(te,{allowTunneling:!!Tt.remote.authority,allowContributedOpeners:ce?.allowContributedOpeners})},async asExternalUri(te){if(te.scheme===Tt.environment.appUriScheme)return wi.createAppUri(te);try{return await zt.asExternalUri(te,{allowTunneling:!!Tt.remote.authority})}catch(ce){if((0,k.matchesScheme)(te,k.Schemas.http)||(0,k.matchesScheme)(te,k.Schemas.https))return te;throw ce}},get remoteName(){return(0,a.getRemoteName)(Tt.remote.authority)},get remoteAuthority(){return(0,Xe.checkProposedApiEnabled)(Le,"resolvers"),Tt.remote.authority},get uiKind(){return Tt.uiKind},get logLevel(){return Ct.getLevel()},get onDidChangeLogLevel(){return ct(Ct.onDidChangeLogLevel)},get appQuality(){return(0,Xe.checkProposedApiEnabled)(Le,"resolvers"),Tt.quality},get appCommit(){return(0,Xe.checkProposedApiEnabled)(Le,"resolvers"),Tt.commit}};Tt.environment.extensionTestsLocationURI||Object.freeze(Gi);const Ci={createTestController(te,ce,Ae){return yi.createTestController(Le,te,ce,Ae)},createTestObserver(){return(0,Xe.checkProposedApiEnabled)(Le,"testObserver"),yi.createTestObserver()},runTests(te){return(0,Xe.checkProposedApiEnabled)(Le,"testObserver"),yi.runTests(te)},registerTestFollowupProvider(te){return(0,Xe.checkProposedApiEnabled)(Le,"testObserver"),yi.registerTestFollowupProvider(te)},get onDidChangeTestResults(){return(0,Xe.checkProposedApiEnabled)(Le,"testObserver"),ct(yi.onResultsChanged)},get testResults(){return(0,Xe.checkProposedApiEnabled)(Le,"testObserver"),yi.results}},ki=Tt.remote.isRemote?W.ExtensionKind.Workspace:W.ExtensionKind.UI,_n={getExtension(te,ce){(0,Xe.isProposedApiEnabled)(Le,"extensionsAny")||(ce=!1);const Ae=mi.mine.getExtensionDescription(te);if(Ae)return new ee.Extension(qt,Le.identifier,Ae,ki,!1);if(ce){const ft=mi.all.getExtensionDescription(te);if(ft)return new ee.Extension(qt,Le.identifier,ft,ki,!0)}},get all(){const te=[];for(const ce of mi.mine.getAllExtensionDescriptions())te.push(new ee.Extension(qt,Le.identifier,ce,ki,!1));return te},get allAcrossExtensionHosts(){(0,Xe.checkProposedApiEnabled)(Le,"extensionsAny");const te=new C.ExtensionIdentifierSet(mi.mine.getAllExtensionDescriptions().map(Ae=>Ae.identifier)),ce=[];for(const Ae of mi.all.getAllExtensionDescriptions()){const ft=!te.has(Ae.identifier);ce.push(new ee.Extension(qt,Le.identifier,Ae,ki,ft))}return ce},get onDidChange(){return(0,Xe.isProposedApiEnabled)(Le,"extensionsAny")?ct(D.Event.any(mi.mine.onDidChange,mi.all.onDidChange)):ct(mi.mine.onDidChange)}},pi={createDiagnosticCollection(te){return Ei.createDiagnosticCollection(Le.identifier,te)},get onDidChangeDiagnostics(){return ct(Ei.onDidChangeDiagnostics)},getDiagnostics:te=>Ei.getDiagnostics(te),getLanguages(){return bi.getLanguages()},setTextDocumentLanguage(te,ce){return bi.changeLanguage(te.uri,ce)},match(te,ce){const Ae=Q.LanguageSelector.from(te);let ft;return(0,I.targetsNotebooks)(Ae)&&(ft=kt.notebookDocuments.find(Dt=>Dt.apiNotebook.getCells().find(Ft=>Ft.document===ce))?.apiNotebook),(0,I.score)(Ae,ce.uri,ce.languageId,!0,ft?.uri,ft?.notebookType)},registerCodeActionsProvider(te,ce,Ae){return me.registerCodeActionProvider(Le,It(te),ce,Ae)},registerDocumentPasteEditProvider(te,ce,Ae){return(0,Xe.checkProposedApiEnabled)(Le,"documentPaste"),me.registerDocumentPasteEditProvider(Le,It(te),ce,Ae)},registerCodeLensProvider(te,ce){return me.registerCodeLensProvider(Le,It(te),ce)},registerDefinitionProvider(te,ce){return me.registerDefinitionProvider(Le,It(te),ce)},registerDeclarationProvider(te,ce){return me.registerDeclarationProvider(Le,It(te),ce)},registerImplementationProvider(te,ce){return me.registerImplementationProvider(Le,It(te),ce)},registerTypeDefinitionProvider(te,ce){return me.registerTypeDefinitionProvider(Le,It(te),ce)},registerHoverProvider(te,ce){return me.registerHoverProvider(Le,It(te),ce,Le.identifier)},registerEvaluatableExpressionProvider(te,ce){return me.registerEvaluatableExpressionProvider(Le,It(te),ce,Le.identifier)},registerInlineValuesProvider(te,ce){return me.registerInlineValuesProvider(Le,It(te),ce,Le.identifier)},registerDocumentHighlightProvider(te,ce){return me.registerDocumentHighlightProvider(Le,It(te),ce)},registerMultiDocumentHighlightProvider(te,ce){return me.registerMultiDocumentHighlightProvider(Le,It(te),ce)},registerLinkedEditingRangeProvider(te,ce){return me.registerLinkedEditingRangeProvider(Le,It(te),ce)},registerReferenceProvider(te,ce){return me.registerReferenceProvider(Le,It(te),ce)},registerRenameProvider(te,ce){return me.registerRenameProvider(Le,It(te),ce)},registerNewSymbolNamesProvider(te,ce){return(0,Xe.checkProposedApiEnabled)(Le,"newSymbolNamesProvider"),me.registerNewSymbolNamesProvider(Le,It(te),ce)},registerDocumentSymbolProvider(te,ce,Ae){return me.registerDocumentSymbolProvider(Le,It(te),ce,Ae)},registerWorkspaceSymbolProvider(te){return me.registerWorkspaceSymbolProvider(Le,te)},registerDocumentFormattingEditProvider(te,ce){return me.registerDocumentFormattingEditProvider(Le,It(te),ce)},registerDocumentRangeFormattingEditProvider(te,ce){return me.registerDocumentRangeFormattingEditProvider(Le,It(te),ce)},registerOnTypeFormattingEditProvider(te,ce,Ae,...ft){return me.registerOnTypeFormattingEditProvider(Le,It(te),ce,[Ae].concat(ft))},registerDocumentSemanticTokensProvider(te,ce,Ae){return me.registerDocumentSemanticTokensProvider(Le,It(te),ce,Ae)},registerDocumentRangeSemanticTokensProvider(te,ce,Ae){return me.registerDocumentRangeSemanticTokensProvider(Le,It(te),ce,Ae)},registerSignatureHelpProvider(te,ce,Ae,...ft){return typeof Ae=="object"?me.registerSignatureHelpProvider(Le,It(te),ce,Ae):me.registerSignatureHelpProvider(Le,It(te),ce,typeof Ae>"u"?[]:[Ae,...ft])},registerCompletionItemProvider(te,ce,...Ae){return me.registerCompletionItemProvider(Le,It(te),ce,Ae)},registerInlineCompletionItemProvider(te,ce,Ae){return ce.handleDidShowCompletionItem&&(0,Xe.checkProposedApiEnabled)(Le,"inlineCompletionsAdditions"),ce.handleDidPartiallyAcceptCompletionItem&&(0,Xe.checkProposedApiEnabled)(Le,"inlineCompletionsAdditions"),Ae&&(0,Xe.checkProposedApiEnabled)(Le,"inlineCompletionsAdditions"),me.registerInlineCompletionsProvider(Le,It(te),ce,Ae)},registerInlineEditProvider(te,ce){return(0,Xe.checkProposedApiEnabled)(Le,"inlineEdit"),me.registerInlineEditProvider(Le,It(te),ce)},registerDocumentLinkProvider(te,ce){return me.registerDocumentLinkProvider(Le,It(te),ce)},registerColorProvider(te,ce){return me.registerColorProvider(Le,It(te),ce)},registerFoldingRangeProvider(te,ce){return me.registerFoldingRangeProvider(Le,It(te),ce)},registerSelectionRangeProvider(te,ce){return me.registerSelectionRangeProvider(Le,te,ce)},registerCallHierarchyProvider(te,ce){return me.registerCallHierarchyProvider(Le,te,ce)},registerTypeHierarchyProvider(te,ce){return me.registerTypeHierarchyProvider(Le,te,ce)},setLanguageConfiguration:(te,ce)=>me.setLanguageConfiguration(Le,te,ce),getTokenInformationAtPosition(te,ce){return(0,Xe.checkProposedApiEnabled)(Le,"tokenInformation"),bi.tokenAtPosition(te,ce)},registerInlayHintsProvider(te,ce){return me.registerInlayHintsProvider(Le,te,ce)},createLanguageStatusItem(te,ce){return bi.createLanguageStatusItem(Le,te,ce)},registerDocumentDropEditProvider(te,ce,Ae){return me.registerDocumentOnDropEditProvider(Le,te,ce,(0,Xe.isProposedApiEnabled)(Le,"documentPaste")?Ae:void 0)}},Wi={get activeTextEditor(){return Ut.getActiveTextEditor()},get visibleTextEditors(){return Ut.getVisibleTextEditors()},get activeTerminal(){return St.activeTerminal},get terminals(){return St.terminals},async showTextDocument(te,ce,Ae){m.URI.isUri(te)&&te.scheme===k.Schemas.vscodeRemote&&!te.authority&&Nt.report("workspace.showTextDocument",Le,"A URI of 'vscode-remote' scheme requires an authority.");const ft=await(m.URI.isUri(te)?Promise.resolve(Xi.openTextDocument(te)):Promise.resolve(te));return Ut.showTextDocument(ft,ce,Ae)},createTextEditorDecorationType(te){return Ut.createTextEditorDecorationType(Le,te)},onDidChangeActiveTextEditor(te,ce,Ae){return ct(Ut.onDidChangeActiveTextEditor)(te,ce,Ae)},onDidChangeVisibleTextEditors(te,ce,Ae){return ct(Ut.onDidChangeVisibleTextEditors)(te,ce,Ae)},onDidChangeTextEditorSelection(te,ce,Ae){return ct(Ut.onDidChangeTextEditorSelection)(te,ce,Ae)},onDidChangeTextEditorOptions(te,ce,Ae){return ct(Ut.onDidChangeTextEditorOptions)(te,ce,Ae)},onDidChangeTextEditorVisibleRanges(te,ce,Ae){return ct(Ut.onDidChangeTextEditorVisibleRanges)(te,ce,Ae)},onDidChangeTextEditorViewColumn(te,ce,Ae){return ct(Ut.onDidChangeTextEditorViewColumn)(te,ce,Ae)},onDidCloseTerminal(te,ce,Ae){return ct(St.onDidCloseTerminal)(te,ce,Ae)},onDidOpenTerminal(te,ce,Ae){return ct(St.onDidOpenTerminal)(te,ce,Ae)},onDidChangeActiveTerminal(te,ce,Ae){return ct(St.onDidChangeActiveTerminal)(te,ce,Ae)},onDidChangeTerminalDimensions(te,ce,Ae){return(0,Xe.checkProposedApiEnabled)(Le,"terminalDimensions"),ct(St.onDidChangeTerminalDimensions)(te,ce,Ae)},onDidChangeTerminalState(te,ce,Ae){return ct(St.onDidChangeTerminalState)(te,ce,Ae)},onDidWriteTerminalData(te,ce,Ae){return(0,Xe.checkProposedApiEnabled)(Le,"terminalDataWriteEvent"),ct(St.onDidWriteTerminalData)(te,ce,Ae)},onDidExecuteTerminalCommand(te,ce,Ae){return(0,Xe.checkProposedApiEnabled)(Le,"terminalExecuteCommandEvent"),ct(St.onDidExecuteTerminalCommand)(te,ce,Ae)},onDidChangeTerminalShellIntegration(te,ce,Ae){return ct(Xt.onDidChangeTerminalShellIntegration)(te,ce,Ae)},onDidStartTerminalShellExecution(te,ce,Ae){return ct(Xt.onDidStartTerminalShellExecution)(te,ce,Ae)},onDidEndTerminalShellExecution(te,ce,Ae){return ct(Xt.onDidEndTerminalShellExecution)(te,ce,Ae)},get state(){return zt.getState()},onDidChangeWindowState(te,ce,Ae){return ct(zt.onDidChangeWindowState)(te,ce,Ae)},showInformationMessage(te,...ce){return Bi.showMessage(Le,A.default.Info,te,ce[0],ce.slice(1))},showWarningMessage(te,...ce){return Bi.showMessage(Le,A.default.Warning,te,ce[0],ce.slice(1))},showErrorMessage(te,...ce){return Bi.showMessage(Le,A.default.Error,te,ce[0],ce.slice(1))},showQuickPick(te,ce,Ae){return j.showQuickPick(Le,te,ce,Ae)},showWorkspaceFolderPick(te){return j.showWorkspaceFolderPick(te)},showInputBox(te,ce){return j.showInput(te,ce)},showOpenDialog(te){return an.showOpenDialog(Le,te)},showSaveDialog(te){return an.showSaveDialog(te)},createStatusBarItem(te,ce,Ae){let ft,Dt,Ft;return typeof te=="string"?(ft=te,Dt=ce,Ft=Ae):(Dt=te,Ft=ce),on.createStatusBarEntry(Le,ft,Dt,Ft)},setStatusBarMessage(te,ce){return on.setStatusBarMessage(te,ce)},withScmProgress(te){return Nt.report("window.withScmProgress",Le,"Use 'withProgress' instead."),ot.withProgress(Le,{location:W.ProgressLocation.SourceControl},(ce,Ae)=>te({report(ft){}}))},withProgress(te,ce){return ot.withProgress(Le,te,ce)},createOutputChannel(te,ce){return Mi.createOutputChannel(te,ce,Le)},createWebviewPanel(te,ce,Ae,ft){return Oi.createWebviewPanel(Le,te,ce,Ae,ft)},createWebviewTextEditorInset(te,ce,Ae,ft){return(0,Xe.checkProposedApiEnabled)(Le,"editorInsets"),Ti.createWebviewEditorInset(te,ce,Ae,ft,Le)},createTerminal(te,ce,Ae){return typeof te=="object"?"pty"in te?St.createExtensionTerminal(te):St.createTerminalFromOptions(te):St.createTerminal(te,ce,Ae)},registerTerminalLinkProvider(te){return St.registerLinkProvider(te)},registerTerminalProfileProvider(te,ce){return St.registerProfileProvider(Le,te,ce)},registerTerminalQuickFixProvider(te,ce){return(0,Xe.checkProposedApiEnabled)(Le,"terminalQuickFixProvider"),St.registerTerminalQuickFixProvider(te,Le.identifier.value,ce)},registerTreeDataProvider(te,ce){return Di.registerTreeDataProvider(te,ce,Le)},createTreeView(te,ce){return Di.createTreeView(te,ce,Le)},registerWebviewPanelSerializer:(te,ce)=>Oi.registerWebviewPanelSerializer(Le,te,ce),registerCustomEditorProvider:(te,ce,Ae={})=>en.registerCustomEditorProvider(Le,te,ce,Ae),registerFileDecorationProvider(te){return ui.registerFileDecorationProvider(te,Le)},registerUriHandler(te){return wi.registerUriHandler(Le,te)},createQuickPick(){return j.createQuickPick(Le)},createInputBox(){return j.createInputBox(Le)},get activeColorTheme(){return jt.activeColorTheme},onDidChangeActiveColorTheme(te,ce,Ae){return ct(jt.onDidChangeActiveColorTheme)(te,ce,Ae)},registerWebviewViewProvider(te,ce,Ae){return Vi.registerWebviewViewProvider(Le,te,ce,Ae?.webviewOptions)},get activeNotebookEditor(){return kt.activeNotebookEditor},onDidChangeActiveNotebookEditor(te,ce,Ae){return ct(kt.onDidChangeActiveNotebookEditor)(te,ce,Ae)},get visibleNotebookEditors(){return kt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return ct(kt.onDidChangeVisibleNotebookEditors)},onDidChangeNotebookEditorSelection(te,ce,Ae){return ct(Li.onDidChangeNotebookEditorSelection)(te,ce,Ae)},onDidChangeNotebookEditorVisibleRanges(te,ce,Ae){return ct(Li.onDidChangeNotebookEditorVisibleRanges)(te,ce,Ae)},showNotebookDocument(te,ce){return kt.showNotebookDocument(te,ce)},registerExternalUriOpener(te,ce,Ae){return(0,Xe.checkProposedApiEnabled)(Le,"externalUriOpener"),tn.registerExternalUriOpener(Le.identifier,te,ce,Ae)},registerProfileContentHandler(te,ce){return(0,Xe.checkProposedApiEnabled)(Le,"profileContentHandlers"),nn.registerProfileContentHandler(Le,te,ce)},registerQuickDiffProvider(te,ce,Ae,ft){return(0,Xe.checkProposedApiEnabled)(Le,"quickDiffProvider"),Be.registerQuickDiffProvider(It(te),ce,Ae,ft)},get tabGroups(){return ni.tabGroups},registerShareProvider(te,ce){return(0,Xe.checkProposedApiEnabled)(Le,"shareProvider"),Ye.registerShareProvider(It(te),ce)}},Xi={get rootPath(){return Nt.report("workspace.rootPath",Le,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),bt.getPath()},set rootPath(te){throw new T.ReadonlyError("rootPath")},getWorkspaceFolder(te){return bt.getWorkspaceFolder(te)},get workspaceFolders(){return bt.getWorkspaceFolders()},get name(){return bt.name},set name(te){throw new T.ReadonlyError("name")},get workspaceFile(){return bt.workspaceFile},set workspaceFile(te){throw new T.ReadonlyError("workspaceFile")},updateWorkspaceFolders:(te,ce,...Ae)=>bt.updateWorkspaceFolders(Le,te,ce||0,...Ae),onDidChangeWorkspaceFolders:function(te,ce,Ae){return ct(bt.onDidChangeWorkspace)(te,ce,Ae)},asRelativePath:(te,ce)=>bt.getRelativePath(te,ce),findFiles:(te,ce,Ae,ft)=>bt.findFiles(te,ce,Ae,Le.identifier,ft),findFiles2:(te,ce,Ae)=>((0,Xe.checkProposedApiEnabled)(Le,"findFiles2"),bt.findFiles2(te,ce,Le.identifier,Ae)),findFiles2New:(te,ce,Ae)=>((0,Xe.checkProposedApiEnabled)(Le,"findFiles2New"),bt.findFiles2New(te,ce,Le.identifier,Ae)),findTextInFiles:(te,ce,Ae,ft)=>{(0,Xe.checkProposedApiEnabled)(Le,"findTextInFiles");let Dt,Ft;return typeof ce=="object"?(Dt=ce,Ft=Ae):(Dt={},Ft=ce,ft=Ae),bt.findTextInFiles(te,Dt||{},Ft,Le.identifier,ft)},findTextInFilesNew:(te,ce,Ae)=>((0,Xe.checkProposedApiEnabled)(Le,"findTextInFilesNew"),(0,Xe.checkProposedApiEnabled)(Le,"textSearchProviderNew"),bt.findTextInFilesNew(te,Le.identifier,ce||{},Ae)),save:te=>bt.save(te),saveAs:te=>bt.saveAs(te),saveAll:te=>bt.saveAll(te),applyEdit(te,ce){return bn.applyWorkspaceEdit(te,Le,ce)},createFileSystemWatcher:(te,ce,Ae,ft)=>{let Dt;return typeof ce=="boolean"?Dt={ignoreCreateEvents:!!ce,ignoreChangeEvents:!!Ae,ignoreDeleteEvents:!!ft,correlate:!1}:ce&&((0,Xe.checkProposedApiEnabled)(Le,"createFileSystemWatcher"),Dt={...ce,correlate:!0}),le.createFileSystemWatcher(bt,Le,te,Dt)},get textDocuments(){return Wt.getAllDocumentData().map(te=>te.document)},set textDocuments(te){throw new T.ReadonlyError("textDocuments")},openTextDocument(te){let ce;const Ae=te;if(typeof te=="string")ce=Promise.resolve(m.URI.file(te));else if(m.URI.isUri(te))ce=Promise.resolve(te);else if(!Ae||typeof Ae=="object")ce=Wt.createDocumentData(Ae);else throw new Error("illegal argument - uriOrFileNameOrOptions");return ce.then(ft=>(Ct.trace(`openTextDocument from ${Le.identifier}`),ft.scheme===k.Schemas.vscodeRemote&&!ft.authority&&Nt.report("workspace.openTextDocument",Le,"A URI of 'vscode-remote' scheme requires an authority."),Wt.ensureDocumentData(ft).then(Dt=>Dt.document)))},onDidOpenTextDocument:(te,ce,Ae)=>ct(Wt.onDidAddDocument)(te,ce,Ae),onDidCloseTextDocument:(te,ce,Ae)=>ct(Wt.onDidRemoveDocument)(te,ce,Ae),onDidChangeTextDocument:(te,ce,Ae)=>ct(Wt.onDidChangeDocument)(te,ce,Ae),onDidSaveTextDocument:(te,ce,Ae)=>ct(Wt.onDidSaveDocument)(te,ce,Ae),onWillSaveTextDocument:(te,ce,Ae)=>ct(Fi.getOnWillSaveTextDocumentEvent(Le))(te,ce,Ae),get notebookDocuments(){return kt.notebookDocuments.map(te=>te.apiNotebook)},async openNotebookDocument(te,ce){let Ae;if(m.URI.isUri(te))Ae=te,await kt.openNotebookDocument(te);else if(typeof te=="string")Ae=m.URI.revive(await kt.createNotebookDocument({viewType:te,content:ce}));else throw new Error("Invalid arguments");return kt.getNotebookDocument(Ae).apiNotebook},onDidSaveNotebookDocument(te,ce,Ae){return ct(_i.onDidSaveNotebookDocument)(te,ce,Ae)},onDidChangeNotebookDocument(te,ce,Ae){return ct(_i.onDidChangeNotebookDocument)(te,ce,Ae)},onWillSaveNotebookDocument(te,ce,Ae){return ct($i.getOnWillSaveNotebookDocumentEvent(Le))(te,ce,Ae)},get onDidOpenNotebookDocument(){return ct(kt.onDidOpenNotebookDocument)},get onDidCloseNotebookDocument(){return ct(kt.onDidCloseNotebookDocument)},registerNotebookSerializer(te,ce,Ae,ft){return kt.registerNotebookSerializer(Le,te,ce,Ae,(0,Xe.isProposedApiEnabled)(Le,"notebookLiveShare")?ft:void 0)},onDidChangeConfiguration:(te,ce,Ae)=>ct(qi.onDidChangeConfiguration)(te,ce,Ae),getConfiguration(te,ce){return ce=arguments.length===1?void 0:ce,qi.getConfiguration(te,ce,Le)},registerTextDocumentContentProvider(te,ce){return fi.registerTextDocumentContentProvider(te,ce)},registerTaskProvider:(te,ce)=>(Nt.report("window.registerTaskProvider",Le,"Use the corresponding function on the 'tasks' namespace instead"),Yt.registerTaskProvider(Le,te,ce)),registerFileSystemProvider(te,ce,Ae){return(0,O.combinedDisposable)(Te.registerFileSystemProvider(Le,te,ce,Ae),ti.addFileSystemProvider(te,ce,Ae))},get fs(){return ti.value},registerFileSearchProvider:(te,ce)=>((0,Xe.checkProposedApiEnabled)(Le,"fileSearchProvider"),si.registerFileSearchProviderOld(te,ce)),registerTextSearchProvider:(te,ce)=>((0,Xe.checkProposedApiEnabled)(Le,"textSearchProvider"),si.registerTextSearchProviderOld(te,ce)),registerAITextSearchProvider:(te,ce)=>((0,Xe.checkProposedApiEnabled)(Le,"aiTextSearchProvider"),(0,Xe.checkProposedApiEnabled)(Le,"textSearchProvider"),si.registerAITextSearchProviderOld(te,ce)),registerFileSearchProviderNew:(te,ce)=>((0,Xe.checkProposedApiEnabled)(Le,"fileSearchProviderNew"),si.registerFileSearchProvider(te,ce)),registerTextSearchProviderNew:(te,ce)=>((0,Xe.checkProposedApiEnabled)(Le,"textSearchProviderNew"),si.registerTextSearchProvider(te,ce)),registerAITextSearchProviderNew:(te,ce)=>((0,Xe.checkProposedApiEnabled)(Le,"aiTextSearchProviderNew"),(0,Xe.checkProposedApiEnabled)(Le,"textSearchProviderNew"),si.registerAITextSearchProvider(te,ce)),registerRemoteAuthorityResolver:(te,ce)=>((0,Xe.checkProposedApiEnabled)(Le,"resolvers"),qt.registerRemoteAuthorityResolver(te,ce)),registerResourceLabelFormatter:te=>((0,Xe.checkProposedApiEnabled)(Le,"resolvers"),gt.$registerResourceLabelFormatter(te)),getRemoteExecServer:te=>((0,Xe.checkProposedApiEnabled)(Le,"resolvers"),qt.getRemoteExecServer(te)),onDidCreateFiles:(te,ce,Ae)=>ct(le.onDidCreateFile)(te,ce,Ae),onDidDeleteFiles:(te,ce,Ae)=>ct(le.onDidDeleteFile)(te,ce,Ae),onDidRenameFiles:(te,ce,Ae)=>ct(le.onDidRenameFile)(te,ce,Ae),onWillCreateFiles:(te,ce,Ae)=>ct(le.getOnWillCreateFileEvent(Le))(te,ce,Ae),onWillDeleteFiles:(te,ce,Ae)=>ct(le.getOnWillDeleteFileEvent(Le))(te,ce,Ae),onWillRenameFiles:(te,ce,Ae)=>ct(le.getOnWillRenameFileEvent(Le))(te,ce,Ae),openTunnel:te=>((0,Xe.checkProposedApiEnabled)(Le,"tunnels"),$t.openTunnel(Le,te).then(ce=>{if(!ce)throw new Error("cannot open tunnel");return ce})),get tunnels(){return(0,Xe.checkProposedApiEnabled)(Le,"tunnels"),$t.getTunnels()},onDidChangeTunnels:(te,ce,Ae)=>((0,Xe.checkProposedApiEnabled)(Le,"tunnels"),ct($t.onDidChangeTunnels)(te,ce,Ae)),registerPortAttributesProvider:(te,ce)=>((0,Xe.checkProposedApiEnabled)(Le,"portsAttributes"),$t.registerPortsAttributesProvider(te,ce)),registerTunnelProvider:(te,ce)=>((0,Xe.checkProposedApiEnabled)(Le,"tunnelFactory"),$t.registerTunnelProvider(te,ce)),registerTimelineProvider:(te,ce)=>((0,Xe.checkProposedApiEnabled)(Le,"timeline"),Vt.registerTimelineProvider(te,ce,Le.identifier,Pt.converter)),get isTrusted(){return bt.trusted},requestWorkspaceTrust:te=>((0,Xe.checkProposedApiEnabled)(Le,"workspaceTrust"),bt.requestWorkspaceTrust(te)),onDidGrantWorkspaceTrust:(te,ce,Ae)=>ct(bt.onDidGrantWorkspaceTrust)(te,ce,Ae),registerEditSessionIdentityProvider:(te,ce)=>((0,Xe.checkProposedApiEnabled)(Le,"editSessionIdentityProvider"),bt.registerEditSessionIdentityProvider(te,ce)),onWillCreateEditSessionIdentity:(te,ce,Ae)=>((0,Xe.checkProposedApiEnabled)(Le,"editSessionIdentityProvider"),ct(bt.getOnWillCreateEditSessionIdentityEvent(Le))(te,ce,Ae)),registerCanonicalUriProvider:(te,ce)=>((0,Xe.checkProposedApiEnabled)(Le,"canonicalUriProvider"),bt.registerCanonicalUriProvider(te,ce)),getCanonicalUri:(te,ce,Ae)=>((0,Xe.checkProposedApiEnabled)(Le,"canonicalUriProvider"),bt.provideCanonicalUri(te,ce,Ae))},ln={get inputBox(){return Nt.report("scm.inputBox",Le,"Use 'SourceControl.inputBox' instead"),Ce.getLastInputBox(Le)},createSourceControl(te,ce,Ae){return Ce.createSourceControl(Le,te,ce,Ae)}},cn={createCommentController(te,ce){return xe.createCommentController(Le,te,ce)}},un={get activeDebugSession(){return yt.activeDebugSession},get activeDebugConsole(){return yt.activeDebugConsole},get breakpoints(){return yt.breakpoints},get activeStackItem(){return yt.activeStackItem},registerDebugVisualizationProvider(te,ce){return(0,Xe.checkProposedApiEnabled)(Le,"debugVisualization"),yt.registerDebugVisualizationProvider(Le,te,ce)},registerDebugVisualizationTreeProvider(te,ce){return(0,Xe.checkProposedApiEnabled)(Le,"debugVisualization"),yt.registerDebugVisualizationTree(Le,te,ce)},onDidStartDebugSession(te,ce,Ae){return ct(yt.onDidStartDebugSession)(te,ce,Ae)},onDidTerminateDebugSession(te,ce,Ae){return ct(yt.onDidTerminateDebugSession)(te,ce,Ae)},onDidChangeActiveDebugSession(te,ce,Ae){return ct(yt.onDidChangeActiveDebugSession)(te,ce,Ae)},onDidReceiveDebugSessionCustomEvent(te,ce,Ae){return ct(yt.onDidReceiveDebugSessionCustomEvent)(te,ce,Ae)},onDidChangeBreakpoints(te,ce,Ae){return ct(yt.onDidChangeBreakpoints)(te,ce,Ae)},onDidChangeActiveStackItem(te,ce,Ae){return ct(yt.onDidChangeActiveStackItem)(te,ce,Ae)},registerDebugConfigurationProvider(te,ce,Ae){return yt.registerDebugConfigurationProvider(te,ce,Ae||Ht.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(te,ce){return yt.registerDebugAdapterDescriptorFactory(Le,te,ce)},registerDebugAdapterTrackerFactory(te,ce){return yt.registerDebugAdapterTrackerFactory(te,ce)},startDebugging(te,ce,Ae){return!Ae||typeof Ae=="object"&&"configuration"in Ae?yt.startDebugging(te,ce,{parentSession:Ae}):yt.startDebugging(te,ce,Ae||{})},stopDebugging(te){return yt.stopDebugging(te)},addBreakpoints(te){return yt.addBreakpoints(te)},removeBreakpoints(te){return yt.removeBreakpoints(te)},asDebugSourceUri(te,ce){return yt.asDebugSourceUri(te,ce)}},yn={registerTaskProvider:(te,ce)=>Yt.registerTaskProvider(Le,te,ce),fetchTasks:te=>Yt.fetchTasks(te),executeTask:te=>Yt.executeTask(Le,te),get taskExecutions(){return Yt.taskExecutions},onDidStartTask:(te,ce,Ae)=>ct(Yt.onDidStartTask)(te,ce,Ae),onDidEndTask:(te,ce,Ae)=>ct(Yt.onDidEndTask)(te,ce,Ae),onDidStartTaskProcess:(te,ce,Ae)=>ct(Yt.onDidStartTaskProcess)(te,ce,Ae),onDidEndTaskProcess:(te,ce,Ae)=>ct(Yt.onDidEndTaskProcess)(te,ce,Ae)},dn={createNotebookController(te,ce,Ae,ft,Dt){return gi.createNotebookController(Le,te,ce,Ae,ft,(0,Xe.isProposedApiEnabled)(Le,"notebookMessaging")?Dt:void 0)},registerNotebookCellStatusBarItemProvider:(te,ce)=>kt.registerNotebookCellStatusBarItemProvider(Le,te,ce),createRendererMessaging(te){return Ui.createRendererMessaging(Le,te)},createNotebookControllerDetectionTask(te){return(0,Xe.checkProposedApiEnabled)(Le,"notebookKernelSource"),gi.createNotebookControllerDetectionTask(Le,te)},registerKernelSourceActionProvider(te,ce){return(0,Xe.checkProposedApiEnabled)(Le,"notebookKernelSource"),gi.registerKernelSourceActionProvider(Le,te,ce)},onDidChangeNotebookCellExecutionState(te,ce,Ae){return(0,Xe.checkProposedApiEnabled)(Le,"notebookCellExecutionState"),ct(gi.onDidChangeNotebookCellExecutionState)(te,ce,Ae)}},hn={t(...te){if(typeof te[0]=="string"){const ce=te.shift(),Ae=!te||typeof te[0]!="object"?te:te[0];return hi.getMessage(Le.identifier.value,{message:ce,args:Ae})}return hi.getMessage(Le.identifier.value,te[0])},get bundle(){return hi.getBundle(Le.identifier.value)},get uri(){return hi.getBundleUri(Le.identifier.value)}},Cn={transferActiveChat(te){return(0,Xe.checkProposedApiEnabled)(Le,"interactive"),xi.transferActiveChat(te)}},In={getRelatedInformation(te,ce){return(0,Xe.checkProposedApiEnabled)(Le,"aiRelatedInformation"),Hi.getRelatedInformation(Le,te,ce)},registerRelatedInformationProvider(te,ce){return(0,Xe.checkProposedApiEnabled)(Le,"aiRelatedInformation"),Hi.registerRelatedInformationProvider(Le,te,ce)},registerEmbeddingVectorProvider(te,ce){return(0,Xe.checkProposedApiEnabled)(Le,"aiRelatedInformation"),sn.registerEmbeddingVectorProvider(Le,te,ce)}},fn={registerChatResponseProvider(te,ce,Ae){return(0,Xe.checkProposedApiEnabled)(Le,"chatProvider"),Gt.registerLanguageModel(Le,te,ce,Ae)},registerChatVariableResolver(te,ce,Ae,ft,Dt,Ft,Ri,Yi){return(0,Xe.checkProposedApiEnabled)(Le,"chatVariableResolver"),rn.registerVariableResolver(Le,te,ce,Ae,ft,Dt,Ft,Ri,Yi?.id)},registerMappedEditsProvider(te,ce){return(0,Xe.checkProposedApiEnabled)(Le,"mappedEditsProvider"),me.registerMappedEditsProvider(Le,te,ce)},createChatParticipant(te,ce){return xi.createChatAgent(Le,te,ce)},createDynamicChatParticipant(te,ce,Ae){return(0,Xe.checkProposedApiEnabled)(Le,"chatParticipantPrivate"),xi.createDynamicChatAgent(Le,te,ce,Ae)},registerChatParticipantDetectionProvider(te){return(0,Xe.checkProposedApiEnabled)(Le,"chatParticipantAdditions"),xi.registerChatParticipantDetectionProvider(te)}},Qi={selectChatModels:te=>Gt.selectLanguageModels(Le,te??{}),onDidChangeChatModels:(te,ce,Ae)=>Gt.onDidChangeProviders(te,ce,Ae),registerChatModelProvider:(te,ce,Ae)=>((0,Xe.checkProposedApiEnabled)(Le,"chatProvider"),Gt.registerLanguageModel(Le,te,ce,Ae)),get embeddingModels(){return(0,Xe.checkProposedApiEnabled)(Le,"embeddings"),Pi.embeddingsModels},onDidChangeEmbeddingModels:(te,ce,Ae)=>((0,Xe.checkProposedApiEnabled)(Le,"embeddings"),Pi.onDidChange(te,ce,Ae)),registerEmbeddingsProvider(te,ce){return(0,Xe.checkProposedApiEnabled)(Le,"embeddings"),Pi.registerEmbeddingsProvider(Le,te,ce)},async computeEmbeddings(te,ce,Ae){return(0,Xe.checkProposedApiEnabled)(Le,"embeddings"),Pi.computeEmbeddings(te,ce,Ae)},registerTool(te,ce){return(0,Xe.checkProposedApiEnabled)(Le,"lmTools"),zi.registerTool(Le,te,ce)},invokeTool(te,ce,Ae){return(0,Xe.checkProposedApiEnabled)(Le,"lmTools"),zi.invokeTool(te,ce,Ae)},get tools(){return(0,Xe.checkProposedApiEnabled)(Le,"lmTools"),zi.tools}},gn={registerSpeechProvider(te,ce){return(0,Xe.checkProposedApiEnabled)(Le,"speech"),En.registerProvider(Le.identifier,te,ce)}};return{version:Tt.version,ai:In,authentication:wn,commands:Ki,comments:cn,chat:fn,debug:un,env:Gi,extensions:_n,interactive:Cn,l10n:hn,languages:pi,lm:Qi,notebooks:dn,scm:ln,speech:gn,tasks:yn,tests:Ci,window:Wi,workspace:Xi,Breakpoint:W.Breakpoint,TerminalOutputAnchor:W.TerminalOutputAnchor,ChatResultFeedbackKind:W.ChatResultFeedbackKind,ChatVariableLevel:W.ChatVariableLevel,ChatCompletionItem:W.ChatCompletionItem,CallHierarchyIncomingCall:W.CallHierarchyIncomingCall,CallHierarchyItem:W.CallHierarchyItem,CallHierarchyOutgoingCall:W.CallHierarchyOutgoingCall,CancellationError:T.CancellationError,CancellationTokenSource:S.CancellationTokenSource,CandidatePortSource:i.CandidatePortSource,CodeAction:W.CodeAction,CodeActionKind:W.CodeActionKind,CodeActionTriggerKind:W.CodeActionTriggerKind,CodeLens:W.CodeLens,Color:W.Color,ColorInformation:W.ColorInformation,ColorPresentation:W.ColorPresentation,ColorThemeKind:W.ColorThemeKind,CommentMode:W.CommentMode,CommentState:W.CommentState,CommentThreadCollapsibleState:W.CommentThreadCollapsibleState,CommentThreadState:W.CommentThreadState,CommentThreadApplicability:W.CommentThreadApplicability,CommentThreadFocus:W.CommentThreadFocus,CompletionItem:W.CompletionItem,CompletionItemKind:W.CompletionItemKind,CompletionItemTag:W.CompletionItemTag,CompletionList:W.CompletionList,CompletionTriggerKind:W.CompletionTriggerKind,ConfigurationTarget:W.ConfigurationTarget,CustomExecution:W.CustomExecution,DebugAdapterExecutable:W.DebugAdapterExecutable,DebugAdapterInlineImplementation:W.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:W.DebugAdapterNamedPipeServer,DebugAdapterServer:W.DebugAdapterServer,DebugConfigurationProviderTriggerKind:Ht.DebugConfigurationProviderTriggerKind,DebugConsoleMode:W.DebugConsoleMode,DebugVisualization:W.DebugVisualization,DecorationRangeBehavior:W.DecorationRangeBehavior,Diagnostic:W.Diagnostic,DiagnosticRelatedInformation:W.DiagnosticRelatedInformation,DiagnosticSeverity:W.DiagnosticSeverity,DiagnosticTag:W.DiagnosticTag,Disposable:W.Disposable,DocumentHighlight:W.DocumentHighlight,DocumentHighlightKind:W.DocumentHighlightKind,MultiDocumentHighlight:W.MultiDocumentHighlight,DocumentLink:W.DocumentLink,DocumentSymbol:W.DocumentSymbol,EndOfLine:W.EndOfLine,EnvironmentVariableMutatorType:W.EnvironmentVariableMutatorType,EvaluatableExpression:W.EvaluatableExpression,InlineValueText:W.InlineValueText,InlineValueVariableLookup:W.InlineValueVariableLookup,InlineValueEvaluatableExpression:W.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:W.InlineCompletionTriggerKind,EventEmitter:D.Emitter,ExtensionKind:W.ExtensionKind,ExtensionMode:W.ExtensionMode,ExternalUriOpenerPriority:W.ExternalUriOpenerPriority,FileChangeType:W.FileChangeType,FileDecoration:W.FileDecoration,FileDecoration2:W.FileDecoration,FileSystemError:W.FileSystemError,FileType:v.FileType,FilePermission:v.FilePermission,FoldingRange:W.FoldingRange,FoldingRangeKind:W.FoldingRangeKind,FunctionBreakpoint:W.FunctionBreakpoint,InlineCompletionItem:W.InlineSuggestion,InlineCompletionList:W.InlineSuggestionList,Hover:W.Hover,VerboseHover:W.VerboseHover,HoverVerbosityAction:W.HoverVerbosityAction,IndentAction:E.IndentAction,Location:W.Location,MarkdownString:W.MarkdownString,OverviewRulerLane:u.OverviewRulerLane,ParameterInformation:W.ParameterInformation,PortAutoForwardAction:W.PortAutoForwardAction,Position:W.Position,ProcessExecution:W.ProcessExecution,ProgressLocation:W.ProgressLocation,QuickInputButtonLocation:W.QuickInputButtonLocation,QuickInputButtons:W.QuickInputButtons,Range:W.Range,RelativePattern:W.RelativePattern,Selection:W.Selection,SelectionRange:W.SelectionRange,SemanticTokens:W.SemanticTokens,SemanticTokensBuilder:W.SemanticTokensBuilder,SemanticTokensEdit:W.SemanticTokensEdit,SemanticTokensEdits:W.SemanticTokensEdits,SemanticTokensLegend:W.SemanticTokensLegend,ShellExecution:W.ShellExecution,ShellQuoting:W.ShellQuoting,SignatureHelp:W.SignatureHelp,SignatureHelpTriggerKind:W.SignatureHelpTriggerKind,SignatureInformation:W.SignatureInformation,SnippetString:W.SnippetString,SourceBreakpoint:W.SourceBreakpoint,StandardTokenType:W.StandardTokenType,StatusBarAlignment:W.StatusBarAlignment,SymbolInformation:W.SymbolInformation,SymbolKind:W.SymbolKind,SymbolTag:W.SymbolTag,Task:W.Task,TaskGroup:W.TaskGroup,TaskPanelKind:W.TaskPanelKind,TaskRevealKind:W.TaskRevealKind,TaskScope:W.TaskScope,TerminalLink:W.TerminalLink,TerminalQuickFixTerminalCommand:W.TerminalQuickFixCommand,TerminalQuickFixOpener:W.TerminalQuickFixOpener,TerminalLocation:W.TerminalLocation,TerminalProfile:W.TerminalProfile,TerminalExitReason:W.TerminalExitReason,TerminalShellExecutionCommandLineConfidence:W.TerminalShellExecutionCommandLineConfidence,TextDocumentSaveReason:W.TextDocumentSaveReason,TextEdit:W.TextEdit,SnippetTextEdit:W.SnippetTextEdit,TextEditorCursorStyle:s.TextEditorCursorStyle,TextEditorLineNumbersStyle:W.TextEditorLineNumbersStyle,TextEditorRevealType:W.TextEditorRevealType,TextEditorSelectionChangeKind:W.TextEditorSelectionChangeKind,SyntaxTokenType:W.SyntaxTokenType,TextDocumentChangeReason:W.TextDocumentChangeReason,ThemeColor:W.ThemeColor,ThemeIcon:W.ThemeIcon,TreeItem:W.TreeItem,TreeItemCheckboxState:W.TreeItemCheckboxState,TreeItemCollapsibleState:W.TreeItemCollapsibleState,TypeHierarchyItem:W.TypeHierarchyItem,UIKind:Zt.UIKind,Uri:m.URI,ViewColumn:W.ViewColumn,WorkspaceEdit:W.WorkspaceEdit,DocumentPasteTriggerKind:W.DocumentPasteTriggerKind,DocumentDropEdit:W.DocumentDropEdit,DocumentDropOrPasteEditKind:W.DocumentDropOrPasteEditKind,DocumentPasteEdit:W.DocumentPasteEdit,InlayHint:W.InlayHint,InlayHintLabelPart:W.InlayHintLabelPart,InlayHintKind:W.InlayHintKind,RemoteAuthorityResolverError:W.RemoteAuthorityResolverError,ResolvedAuthority:W.ResolvedAuthority,ManagedResolvedAuthority:W.ManagedResolvedAuthority,SourceControlInputBoxValidationType:W.SourceControlInputBoxValidationType,ExtensionRuntime:W.ExtensionRuntime,TimelineItem:W.TimelineItem,NotebookRange:W.NotebookRange,NotebookCellKind:W.NotebookCellKind,NotebookCellExecutionState:W.NotebookCellExecutionState,NotebookCellData:W.NotebookCellData,NotebookData:W.NotebookData,NotebookRendererScript:W.NotebookRendererScript,NotebookCellStatusBarAlignment:W.NotebookCellStatusBarAlignment,NotebookEditorRevealType:W.NotebookEditorRevealType,NotebookCellOutput:W.NotebookCellOutput,NotebookCellOutputItem:W.NotebookCellOutputItem,NotebookCellStatusBarItem:W.NotebookCellStatusBarItem,NotebookControllerAffinity:W.NotebookControllerAffinity,NotebookControllerAffinity2:W.NotebookControllerAffinity2,NotebookEdit:W.NotebookEdit,NotebookKernelSourceAction:W.NotebookKernelSourceAction,NotebookVariablesRequestKind:W.NotebookVariablesRequestKind,PortAttributes:W.PortAttributes,LinkedEditingRanges:W.LinkedEditingRanges,TestResultState:W.TestResultState,TestRunRequest:W.TestRunRequest,TestMessage:W.TestMessage,TestMessageStackFrame:W.TestMessageStackFrame,TestTag:W.TestTag,TestRunProfileKind:W.TestRunProfileKind,TextSearchCompleteMessageType:Lt.TextSearchCompleteMessageType,DataTransfer:W.DataTransfer,DataTransferItem:W.DataTransferItem,TestCoverageCount:W.TestCoverageCount,FileCoverage:W.FileCoverage,FileCoverage2:W.FileCoverage,StatementCoverage:W.StatementCoverage,BranchCoverage:W.BranchCoverage,DeclarationCoverage:W.DeclarationCoverage,WorkspaceTrustState:W.WorkspaceTrustState,LanguageStatusSeverity:W.LanguageStatusSeverity,QuickPickItemKind:W.QuickPickItemKind,InputBoxValidationSeverity:W.InputBoxValidationSeverity,TabInputText:W.TextTabInput,TabInputTextDiff:W.TextDiffTabInput,TabInputTextMerge:W.TextMergeTabInput,TabInputCustom:W.CustomEditorTabInput,TabInputNotebook:W.NotebookEditorTabInput,TabInputNotebookDiff:W.NotebookDiffEditorTabInput,TabInputWebview:W.WebviewEditorTabInput,TabInputTerminal:W.TerminalEditorTabInput,TabInputInteractiveWindow:W.InteractiveWindowInput,TabInputChat:W.ChatEditorTabInput,TabInputTextMultiDiff:W.TextMultiDiffTabInput,TelemetryTrustedValue:d.TelemetryTrustedValue,LogLevel:r.LogLevel,EditSessionIdentityMatch:l.EditSessionIdentityMatch,InteractiveSessionVoteDirection:W.InteractiveSessionVoteDirection,ChatCopyKind:W.ChatCopyKind,InteractiveEditorResponseFeedbackKind:W.InteractiveEditorResponseFeedbackKind,DebugStackFrame:W.DebugStackFrame,DebugThread:W.DebugThread,RelatedInformationType:W.RelatedInformationType,SpeechToTextStatus:W.SpeechToTextStatus,TextToSpeechStatus:W.TextToSpeechStatus,PartialAcceptTriggerKind:W.PartialAcceptTriggerKind,KeywordRecognitionStatus:W.KeywordRecognitionStatus,ChatResponseMarkdownPart:W.ChatResponseMarkdownPart,ChatResponseFileTreePart:W.ChatResponseFileTreePart,ChatResponseAnchorPart:W.ChatResponseAnchorPart,ChatResponseProgressPart:W.ChatResponseProgressPart,ChatResponseProgressPart2:W.ChatResponseProgressPart2,ChatResponseReferencePart:W.ChatResponseReferencePart,ChatResponseReferencePart2:W.ChatResponseReferencePart,ChatResponseCodeCitationPart:W.ChatResponseCodeCitationPart,ChatResponseWarningPart:W.ChatResponseWarningPart,ChatResponseTextEditPart:W.ChatResponseTextEditPart,ChatResponseMarkdownWithVulnerabilitiesPart:W.ChatResponseMarkdownWithVulnerabilitiesPart,ChatResponseCommandButtonPart:W.ChatResponseCommandButtonPart,ChatResponseDetectedParticipantPart:W.ChatResponseDetectedParticipantPart,ChatResponseConfirmationPart:W.ChatResponseConfirmationPart,ChatResponseMovePart:W.ChatResponseMovePart,ChatResponseReferencePartStatusKind:W.ChatResponseReferencePartStatusKind,ChatRequestTurn:W.ChatRequestTurn,ChatResponseTurn:W.ChatResponseTurn,ChatLocation:W.ChatLocation,ChatRequestEditorData:W.ChatRequestEditorData,ChatRequestNotebookData:W.ChatRequestNotebookData,LanguageModelChatMessageRole:W.LanguageModelChatMessageRole,LanguageModelChatMessage:W.LanguageModelChatMessage,LanguageModelChatMessageToolResultPart:W.LanguageModelToolResultPart,LanguageModelChatResponseTextPart:W.LanguageModelTextPart,LanguageModelChatResponseToolCallPart:W.LanguageModelToolCallPart,LanguageModelError:W.LanguageModelError,NewSymbolName:W.NewSymbolName,NewSymbolNameTag:W.NewSymbolNameTag,NewSymbolNameTriggerKind:W.NewSymbolNameTriggerKind,InlineEdit:W.InlineEdit,InlineEditTriggerKind:W.InlineEditTriggerKind,ExcludeSettingOptions:Lt.ExcludeSettingOptions,TextSearchContextNew:Lt.TextSearchContextNew,TextSearchMatchNew:Lt.TextSearchMatchNew,TextSearchCompleteMessageTypeNew:Lt.TextSearchCompleteMessageType}}}}),define(ke[277],Re([1,0,60,130,45,124,46,35,57,56,132,134,136,89,93,85,123,68,50,88,66,70,216,11,133,86,87,91,95,128,96]),function(Ee,e,S,T,D,O,k,A,m,s,I,E,u,C,v,r,a,d,l,i,n,t,o,c,g,f,h,_,y,w,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,S.registerSingleton)(f.IExtHostLocalizationService,f.ExtHostLocalizationService,S.InstantiationType.Delayed),(0,S.registerSingleton)(c.ILoggerService,o.ExtHostLoggerService,S.InstantiationType.Delayed),(0,S.registerSingleton)(r.IExtHostApiDeprecationService,r.ExtHostApiDeprecationService,S.InstantiationType.Delayed),(0,S.registerSingleton)(A.IExtHostCommands,A.ExtHostCommands,S.InstantiationType.Eager),(0,S.registerSingleton)(_.IExtHostAuthentication,_.ExtHostAuthentication,S.InstantiationType.Eager),(0,S.registerSingleton)(y.IExtHostLanguageModels,y.ExtHostLanguageModels,S.InstantiationType.Eager),(0,S.registerSingleton)(k.IExtHostConfiguration,k.ExtHostConfiguration,S.InstantiationType.Eager),(0,S.registerSingleton)(d.IExtHostConsumerFileSystem,d.ExtHostConsumerFileSystem,S.InstantiationType.Eager),(0,S.registerSingleton)(P.IExtHostTesting,P.ExtHostTesting,S.InstantiationType.Eager),(0,S.registerSingleton)(E.IExtHostDebugService,E.WorkerExtHostDebugService,S.InstantiationType.Eager),(0,S.registerSingleton)(O.IExtHostDecorations,O.ExtHostDecorations,S.InstantiationType.Eager),(0,S.registerSingleton)(m.IExtHostDocumentsAndEditors,m.ExtHostDocumentsAndEditors,S.InstantiationType.Eager),(0,S.registerSingleton)(h.IExtHostManagedSockets,h.ExtHostManagedSockets,S.InstantiationType.Eager),(0,S.registerSingleton)(l.IExtHostFileSystemInfo,l.ExtHostFileSystemInfo,S.InstantiationType.Eager),(0,S.registerSingleton)(T.IExtHostOutputService,T.ExtHostOutputService,S.InstantiationType.Delayed),(0,S.registerSingleton)(u.IExtHostSearch,u.ExtHostSearch,S.InstantiationType.Eager),(0,S.registerSingleton)(C.IExtHostStorage,C.ExtHostStorage,S.InstantiationType.Eager),(0,S.registerSingleton)(I.IExtHostTask,I.WorkerExtHostTask,S.InstantiationType.Eager),(0,S.registerSingleton)(s.IExtHostTerminalService,s.WorkerExtHostTerminalService,S.InstantiationType.Eager),(0,S.registerSingleton)(w.IExtHostTerminalShellIntegration,w.ExtHostTerminalShellIntegration,S.InstantiationType.Eager),(0,S.registerSingleton)(v.IExtHostTunnelService,v.ExtHostTunnelService,S.InstantiationType.Eager),(0,S.registerSingleton)(a.IExtHostWindow,a.ExtHostWindow,S.InstantiationType.Eager),(0,S.registerSingleton)(D.IExtHostWorkspace,D.ExtHostWorkspace,S.InstantiationType.Eager),(0,S.registerSingleton)(i.IExtHostSecretState,i.ExtHostSecretState,S.InstantiationType.Eager),(0,S.registerSingleton)(n.IExtHostTelemetry,n.ExtHostTelemetry,S.InstantiationType.Eager),(0,S.registerSingleton)(t.IExtHostEditorTabs,t.ExtHostEditorTabs,S.InstantiationType.Eager),(0,S.registerSingleton)(g.IExtHostVariableResolverProvider,g.ExtHostVariableResolverProviderService,S.InstantiationType.Eager)}),define(ke[278],Re([1,0,276,47,2,272,7,10,223]),function(Ee,e,S,T,D,O,k,A,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class s extends O.RequireInterceptor{_installInterceptor(){}getModule(C,v){for(const r of this._alternatives){const a=r(C);if(a){C=a;break}}if(this._factories.has(C))return this._factories.get(C).load(C,v,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class I extends T.AbstractExtHostExtensionService{constructor(){super(...arguments),this.extensionRuntime=k.ExtensionRuntime.Webworker}async _beforeAlmostReadyToRunExtensions(){this._instaService.createInstance(m.ExtHostConsoleForwarder);const C=this._instaService.invokeFunction(S.createApiFactoryAndRegisterActors);this._fakeModules=this._instaService.createInstance(s,C,{mine:this._myRegistry,all:this._globalRegistry}),await this._fakeModules.install(),performance.mark("code/extHost/didInitAPI"),await this._waitForDebuggerAttachment()}_getEntryPoint(C){return C.browser}async _loadCommonJSModule(C,v,r){v=v.with({path:E(v.path,".js")});const a=C?.identifier.value;a&&performance.mark(`code/extHost/willFetchExtensionCode/${a}`);const d=D.URI.revive(await this._mainThreadExtensionsProxy.$asBrowserUri(v)),l=await fetch(d.toString(!0));if(a&&performance.mark(`code/extHost/didFetchExtensionCode/${a}`),l.status!==200)throw new Error(l.statusText);const i=await l.text(),n=`${v.toString(!0)}#vscode-extension`,t=`${i}
//# sourceURL=${n}`;let o;try{o=new Function("module","exports","require",t)}catch(h){throw console.error(a?`Loading code for extension ${a} failed: ${h.message}`:`Loading code failed: ${h.message}`),console.error(`${v.toString(!0)}${typeof h.line=="number"?` line ${h.line}`:""}${typeof h.column=="number"?` column ${h.column}`:""}`),console.error(h),h}C&&await this._extHostLocalizationService.initializeLocalizedMessages(C);const c={},g={exports:c},f=h=>{const _=this._fakeModules.getModule(h,v);if(_===void 0)throw new Error(`Cannot load module '${h}'`);return _};try{return r.codeLoadingStart(),a&&performance.mark(`code/extHost/willLoadExtensionCode/${a}`),o(g,c,f),g.exports!==c?g.exports:c}finally{a&&performance.mark(`code/extHost/didLoadExtensionCode/${a}`),r.codeLoadingStop()}}async $setRemoteEnvironment(C){}async _waitForDebuggerAttachment(C=5e3){if(!this._initData.environment.isExtensionDevelopmentDebug)return;const v=Date.now()+C;for(;Date.now()<v&&!("__jsDebugIsReady"in globalThis);)await(0,A.timeout)(10)}}e.ExtHostExtensionService=I;function E(u,C){return u.endsWith(C)?u:u+C}}),define(ke[279],Re([1,0,74,60,11,47,188,92,278]),function(Ee,e,S,T,D,O,k,A,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,T.registerSingleton)(D.ILogService,new S.SyncDescriptor(k.ExtHostLogService,[!0],!0)),(0,T.registerSingleton)(O.IExtHostExtensionService,m.ExtHostExtensionService,T.InstantiationType.Eager),(0,T.registerSingleton)(A.IExtensionStoragePaths,A.ExtensionStoragePaths,T.InstantiationType.Eager)}),define(ke[287],Re([1,0,20,6,84,273,225,22,64,15,2,277,279]),function(Ee,e,S,T,D,O,k,A,m,s,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=t,A=Ve(A),m=Ve(m);const E=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const u=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");function C(o){return/^(file|vscode-remote):/i.test(o)}const v=fetch.bind(self);function r(o){self.fetch=async function(c,g){return c instanceof Request||C(String(c))&&(c=(await o(I.URI.parse(String(c)))).toString(!0)),v(c,g)},self.XMLHttpRequest=class extends XMLHttpRequest{open(c,g,f,h,_){(async()=>(C(g.toString())&&(g=(await o(I.URI.parse(g.toString()))).toString(!0)),super.open(c,g,f??!0,h,_)))()}}}if(self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const o=self.Worker;Worker=function(c,g){if(/^file:/i.test(c.toString()))c=s.FileAccess.uriToBrowserUri(I.URI.parse(c.toString())).toString(!0);else if(/^vscode-remote:/i.test(c.toString()))throw new Error("Creating workers from remote extensions is currently not supported.");const h=`(${function(P){function R(N){return typeof N=="string"||N instanceof URL?String(N).replace(/^file:\/\//i,"vscode-file://vscode-app"):N}const p=fetch.bind(self);self.fetch=function(N,L){return N instanceof Request?p(N,L):p(R(N),L)},self.XMLHttpRequest=class extends XMLHttpRequest{open(N,L,F,K,J){return super.open(N,R(L),F??!0,K,J)}};const b=importScripts.bind(self);self.importScripts=(...N)=>{b(...N.map(R))},b(P)}.toString()}('${c}'))`;g=g||{},g.name=`${name} -> ${g.name||A.basename(c.toString())}`;const _=new Blob([h],{type:"application/javascript"}),y=URL.createObjectURL(_);return new o(y,g)}}else self.Worker=class extends k.NestedWorker{constructor(o,c){super(u,o,{name:A.basename(o.toString()),...c})}};const a=new class{constructor(){this.pid=void 0}exit(o){E()}};class d{constructor(){const c=new MessageChannel,g=new T.Emitter;let f=!1;u(c.port2,[c.port2]),c.port1.onmessage=h=>{const{data:_}=h;if(!(_ instanceof ArrayBuffer)){console.warn("UNKNOWN data received",_);return}const y=S.VSBuffer.wrap(new Uint8Array(_,0,_.byteLength));if((0,D.isMessageOfType)(y,D.MessageType.Terminate)){f=!0,i("received terminate message from renderer");return}g.fire(y)},this.protocol={onMessage:g.event,send:h=>{if(!f){const _=h.buffer.buffer.slice(h.buffer.byteOffset,h.buffer.byteOffset+h.buffer.byteLength);c.port1.postMessage(_,[_])}}}}}function l(o){return new Promise(c=>{const g=o.onMessage(f=>{g.dispose();const h=JSON.parse(f.toString());o.send((0,D.createMessageOfType)(D.MessageType.Initialized)),c({protocol:o,initData:h})});o.send((0,D.createMessageOfType)(D.MessageType.Ready))})}let i=o=>E();function n(o){return!!o&&typeof o=="object"&&o.type==="vscode.init"&&o.data instanceof Map}function t(){m.mark("code/extHost/willConnectToRenderer");const o=new d;return{onmessage(c){n(c)&&l(o.protocol).then(g=>{m.mark("code/extHost/didWaitForInitData");const f=new O.ExtensionHostMain(g.protocol,g.initData,a,null,c.data);r(h=>f.asBrowserUri(h)),i=h=>f.terminate(h)})}}}})}).call(this);

//# sourceMappingURL=https://main.vscode-cdn.net/sourcemaps/532bdf24071d0a26ceea0844dcdf5ee8cfabd562/core/vs/workbench/api/worker/extensionHostWorker.js.map
